"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __esm = (fn, res) => function __init() {
  return fn && (res = (0, fn[__getOwnPropNames(fn)[0]])(fn = 0)), res;
};
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// node_modules/axios/lib/helpers/bind.js
var require_bind = __commonJS({
  "node_modules/axios/lib/helpers/bind.js"(exports2, module2) {
    "use strict";
    module2.exports = function bind(fn, thisArg) {
      return function wrap() {
        var args = new Array(arguments.length);
        for (var i = 0; i < args.length; i++) {
          args[i] = arguments[i];
        }
        return fn.apply(thisArg, args);
      };
    };
  }
});

// node_modules/axios/lib/utils.js
var require_utils = __commonJS({
  "node_modules/axios/lib/utils.js"(exports2, module2) {
    "use strict";
    var bind = require_bind();
    var toString = Object.prototype.toString;
    function isArray(val) {
      return Array.isArray(val);
    }
    function isUndefined(val) {
      return typeof val === "undefined";
    }
    function isBuffer(val) {
      return val !== null && !isUndefined(val) && val.constructor !== null && !isUndefined(val.constructor) && typeof val.constructor.isBuffer === "function" && val.constructor.isBuffer(val);
    }
    function isArrayBuffer(val) {
      return toString.call(val) === "[object ArrayBuffer]";
    }
    function isFormData(val) {
      return toString.call(val) === "[object FormData]";
    }
    function isArrayBufferView(val) {
      var result2;
      if (typeof ArrayBuffer !== "undefined" && ArrayBuffer.isView) {
        result2 = ArrayBuffer.isView(val);
      } else {
        result2 = val && val.buffer && isArrayBuffer(val.buffer);
      }
      return result2;
    }
    function isString(val) {
      return typeof val === "string";
    }
    function isNumber(val) {
      return typeof val === "number";
    }
    function isObject(val) {
      return val !== null && typeof val === "object";
    }
    function isPlainObject(val) {
      if (toString.call(val) !== "[object Object]") {
        return false;
      }
      var prototype = Object.getPrototypeOf(val);
      return prototype === null || prototype === Object.prototype;
    }
    function isDate(val) {
      return toString.call(val) === "[object Date]";
    }
    function isFile(val) {
      return toString.call(val) === "[object File]";
    }
    function isBlob(val) {
      return toString.call(val) === "[object Blob]";
    }
    function isFunction(val) {
      return toString.call(val) === "[object Function]";
    }
    function isStream(val) {
      return isObject(val) && isFunction(val.pipe);
    }
    function isURLSearchParams(val) {
      return toString.call(val) === "[object URLSearchParams]";
    }
    function trim(str) {
      return str.trim ? str.trim() : str.replace(/^\s+|\s+$/g, "");
    }
    function isStandardBrowserEnv() {
      if (typeof navigator !== "undefined" && (navigator.product === "ReactNative" || navigator.product === "NativeScript" || navigator.product === "NS")) {
        return false;
      }
      return typeof window !== "undefined" && typeof document !== "undefined";
    }
    function forEach(obj, fn) {
      if (obj === null || typeof obj === "undefined") {
        return;
      }
      if (typeof obj !== "object") {
        obj = [obj];
      }
      if (isArray(obj)) {
        for (var i = 0, l2 = obj.length; i < l2; i++) {
          fn.call(null, obj[i], i, obj);
        }
      } else {
        for (var key in obj) {
          if (Object.prototype.hasOwnProperty.call(obj, key)) {
            fn.call(null, obj[key], key, obj);
          }
        }
      }
    }
    function merge() {
      var result2 = {};
      function assignValue(val, key) {
        if (isPlainObject(result2[key]) && isPlainObject(val)) {
          result2[key] = merge(result2[key], val);
        } else if (isPlainObject(val)) {
          result2[key] = merge({}, val);
        } else if (isArray(val)) {
          result2[key] = val.slice();
        } else {
          result2[key] = val;
        }
      }
      for (var i = 0, l2 = arguments.length; i < l2; i++) {
        forEach(arguments[i], assignValue);
      }
      return result2;
    }
    function extend(a, b, thisArg) {
      forEach(b, function assignValue(val, key) {
        if (thisArg && typeof val === "function") {
          a[key] = bind(val, thisArg);
        } else {
          a[key] = val;
        }
      });
      return a;
    }
    function stripBOM(content) {
      if (content.charCodeAt(0) === 65279) {
        content = content.slice(1);
      }
      return content;
    }
    module2.exports = {
      isArray,
      isArrayBuffer,
      isBuffer,
      isFormData,
      isArrayBufferView,
      isString,
      isNumber,
      isObject,
      isPlainObject,
      isUndefined,
      isDate,
      isFile,
      isBlob,
      isFunction,
      isStream,
      isURLSearchParams,
      isStandardBrowserEnv,
      forEach,
      merge,
      extend,
      trim,
      stripBOM
    };
  }
});

// node_modules/axios/lib/helpers/buildURL.js
var require_buildURL = __commonJS({
  "node_modules/axios/lib/helpers/buildURL.js"(exports2, module2) {
    "use strict";
    var utils = require_utils();
    function encode(val) {
      return encodeURIComponent(val).replace(/%3A/gi, ":").replace(/%24/g, "$").replace(/%2C/gi, ",").replace(/%20/g, "+").replace(/%5B/gi, "[").replace(/%5D/gi, "]");
    }
    module2.exports = function buildURL(url, params, paramsSerializer) {
      if (!params) {
        return url;
      }
      var serializedParams;
      if (paramsSerializer) {
        serializedParams = paramsSerializer(params);
      } else if (utils.isURLSearchParams(params)) {
        serializedParams = params.toString();
      } else {
        var parts = [];
        utils.forEach(params, function serialize2(val, key) {
          if (val === null || typeof val === "undefined") {
            return;
          }
          if (utils.isArray(val)) {
            key = key + "[]";
          } else {
            val = [val];
          }
          utils.forEach(val, function parseValue(v) {
            if (utils.isDate(v)) {
              v = v.toISOString();
            } else if (utils.isObject(v)) {
              v = JSON.stringify(v);
            }
            parts.push(encode(key) + "=" + encode(v));
          });
        });
        serializedParams = parts.join("&");
      }
      if (serializedParams) {
        var hashmarkIndex = url.indexOf("#");
        if (hashmarkIndex !== -1) {
          url = url.slice(0, hashmarkIndex);
        }
        url += (url.indexOf("?") === -1 ? "?" : "&") + serializedParams;
      }
      return url;
    };
  }
});

// node_modules/axios/lib/core/InterceptorManager.js
var require_InterceptorManager = __commonJS({
  "node_modules/axios/lib/core/InterceptorManager.js"(exports2, module2) {
    "use strict";
    var utils = require_utils();
    function InterceptorManager() {
      this.handlers = [];
    }
    InterceptorManager.prototype.use = function use(fulfilled, rejected, options) {
      this.handlers.push({
        fulfilled,
        rejected,
        synchronous: options ? options.synchronous : false,
        runWhen: options ? options.runWhen : null
      });
      return this.handlers.length - 1;
    };
    InterceptorManager.prototype.eject = function eject(id) {
      if (this.handlers[id]) {
        this.handlers[id] = null;
      }
    };
    InterceptorManager.prototype.forEach = function forEach(fn) {
      utils.forEach(this.handlers, function forEachHandler(h) {
        if (h !== null) {
          fn(h);
        }
      });
    };
    module2.exports = InterceptorManager;
  }
});

// node_modules/axios/lib/helpers/normalizeHeaderName.js
var require_normalizeHeaderName = __commonJS({
  "node_modules/axios/lib/helpers/normalizeHeaderName.js"(exports2, module2) {
    "use strict";
    var utils = require_utils();
    module2.exports = function normalizeHeaderName(headers, normalizedName) {
      utils.forEach(headers, function processHeader(value, name) {
        if (name !== normalizedName && name.toUpperCase() === normalizedName.toUpperCase()) {
          headers[normalizedName] = value;
          delete headers[name];
        }
      });
    };
  }
});

// node_modules/axios/lib/core/enhanceError.js
var require_enhanceError = __commonJS({
  "node_modules/axios/lib/core/enhanceError.js"(exports2, module2) {
    "use strict";
    module2.exports = function enhanceError(error, config, code, request, response) {
      error.config = config;
      if (code) {
        error.code = code;
      }
      error.request = request;
      error.response = response;
      error.isAxiosError = true;
      error.toJSON = function toJSON() {
        return {
          // Standard
          message: this.message,
          name: this.name,
          // Microsoft
          description: this.description,
          number: this.number,
          // Mozilla
          fileName: this.fileName,
          lineNumber: this.lineNumber,
          columnNumber: this.columnNumber,
          stack: this.stack,
          // Axios
          config: this.config,
          code: this.code,
          status: this.response && this.response.status ? this.response.status : null
        };
      };
      return error;
    };
  }
});

// node_modules/axios/lib/defaults/transitional.js
var require_transitional = __commonJS({
  "node_modules/axios/lib/defaults/transitional.js"(exports2, module2) {
    "use strict";
    module2.exports = {
      silentJSONParsing: true,
      forcedJSONParsing: true,
      clarifyTimeoutError: false
    };
  }
});

// node_modules/axios/lib/core/createError.js
var require_createError = __commonJS({
  "node_modules/axios/lib/core/createError.js"(exports2, module2) {
    "use strict";
    var enhanceError = require_enhanceError();
    module2.exports = function createError(message, config, code, request, response) {
      var error = new Error(message);
      return enhanceError(error, config, code, request, response);
    };
  }
});

// node_modules/axios/lib/core/settle.js
var require_settle = __commonJS({
  "node_modules/axios/lib/core/settle.js"(exports2, module2) {
    "use strict";
    var createError = require_createError();
    module2.exports = function settle(resolve2, reject, response) {
      var validateStatus = response.config.validateStatus;
      if (!response.status || !validateStatus || validateStatus(response.status)) {
        resolve2(response);
      } else {
        reject(createError(
          "Request failed with status code " + response.status,
          response.config,
          null,
          response.request,
          response
        ));
      }
    };
  }
});

// node_modules/axios/lib/helpers/cookies.js
var require_cookies = __commonJS({
  "node_modules/axios/lib/helpers/cookies.js"(exports2, module2) {
    "use strict";
    var utils = require_utils();
    module2.exports = utils.isStandardBrowserEnv() ? (
      // Standard browser envs support document.cookie
      /* @__PURE__ */ function standardBrowserEnv() {
        return {
          write: function write(name, value, expires, path3, domain, secure) {
            var cookie = [];
            cookie.push(name + "=" + encodeURIComponent(value));
            if (utils.isNumber(expires)) {
              cookie.push("expires=" + new Date(expires).toGMTString());
            }
            if (utils.isString(path3)) {
              cookie.push("path=" + path3);
            }
            if (utils.isString(domain)) {
              cookie.push("domain=" + domain);
            }
            if (secure === true) {
              cookie.push("secure");
            }
            document.cookie = cookie.join("; ");
          },
          read: function read(name) {
            var match = document.cookie.match(new RegExp("(^|;\\s*)(" + name + ")=([^;]*)"));
            return match ? decodeURIComponent(match[3]) : null;
          },
          remove: function remove(name) {
            this.write(name, "", Date.now() - 864e5);
          }
        };
      }()
    ) : (
      // Non standard browser env (web workers, react-native) lack needed support.
      /* @__PURE__ */ function nonStandardBrowserEnv() {
        return {
          write: function write() {
          },
          read: function read() {
            return null;
          },
          remove: function remove() {
          }
        };
      }()
    );
  }
});

// node_modules/axios/lib/helpers/isAbsoluteURL.js
var require_isAbsoluteURL = __commonJS({
  "node_modules/axios/lib/helpers/isAbsoluteURL.js"(exports2, module2) {
    "use strict";
    module2.exports = function isAbsoluteURL(url) {
      return /^([a-z][a-z\d+\-.]*:)?\/\//i.test(url);
    };
  }
});

// node_modules/axios/lib/helpers/combineURLs.js
var require_combineURLs = __commonJS({
  "node_modules/axios/lib/helpers/combineURLs.js"(exports2, module2) {
    "use strict";
    module2.exports = function combineURLs(baseURL, relativeURL) {
      return relativeURL ? baseURL.replace(/\/+$/, "") + "/" + relativeURL.replace(/^\/+/, "") : baseURL;
    };
  }
});

// node_modules/axios/lib/core/buildFullPath.js
var require_buildFullPath = __commonJS({
  "node_modules/axios/lib/core/buildFullPath.js"(exports2, module2) {
    "use strict";
    var isAbsoluteURL = require_isAbsoluteURL();
    var combineURLs = require_combineURLs();
    module2.exports = function buildFullPath(baseURL, requestedURL) {
      if (baseURL && !isAbsoluteURL(requestedURL)) {
        return combineURLs(baseURL, requestedURL);
      }
      return requestedURL;
    };
  }
});

// node_modules/axios/lib/helpers/parseHeaders.js
var require_parseHeaders = __commonJS({
  "node_modules/axios/lib/helpers/parseHeaders.js"(exports2, module2) {
    "use strict";
    var utils = require_utils();
    var ignoreDuplicateOf = [
      "age",
      "authorization",
      "content-length",
      "content-type",
      "etag",
      "expires",
      "from",
      "host",
      "if-modified-since",
      "if-unmodified-since",
      "last-modified",
      "location",
      "max-forwards",
      "proxy-authorization",
      "referer",
      "retry-after",
      "user-agent"
    ];
    module2.exports = function parseHeaders(headers) {
      var parsed = {};
      var key;
      var val;
      var i;
      if (!headers) {
        return parsed;
      }
      utils.forEach(headers.split("\n"), function parser(line) {
        i = line.indexOf(":");
        key = utils.trim(line.substr(0, i)).toLowerCase();
        val = utils.trim(line.substr(i + 1));
        if (key) {
          if (parsed[key] && ignoreDuplicateOf.indexOf(key) >= 0) {
            return;
          }
          if (key === "set-cookie") {
            parsed[key] = (parsed[key] ? parsed[key] : []).concat([val]);
          } else {
            parsed[key] = parsed[key] ? parsed[key] + ", " + val : val;
          }
        }
      });
      return parsed;
    };
  }
});

// node_modules/axios/lib/helpers/isURLSameOrigin.js
var require_isURLSameOrigin = __commonJS({
  "node_modules/axios/lib/helpers/isURLSameOrigin.js"(exports2, module2) {
    "use strict";
    var utils = require_utils();
    module2.exports = utils.isStandardBrowserEnv() ? (
      // Standard browser envs have full support of the APIs needed to test
      // whether the request URL is of the same origin as current location.
      function standardBrowserEnv() {
        var msie = /(msie|trident)/i.test(navigator.userAgent);
        var urlParsingNode = document.createElement("a");
        var originURL;
        function resolveURL(url) {
          var href = url;
          if (msie) {
            urlParsingNode.setAttribute("href", href);
            href = urlParsingNode.href;
          }
          urlParsingNode.setAttribute("href", href);
          return {
            href: urlParsingNode.href,
            protocol: urlParsingNode.protocol ? urlParsingNode.protocol.replace(/:$/, "") : "",
            host: urlParsingNode.host,
            search: urlParsingNode.search ? urlParsingNode.search.replace(/^\?/, "") : "",
            hash: urlParsingNode.hash ? urlParsingNode.hash.replace(/^#/, "") : "",
            hostname: urlParsingNode.hostname,
            port: urlParsingNode.port,
            pathname: urlParsingNode.pathname.charAt(0) === "/" ? urlParsingNode.pathname : "/" + urlParsingNode.pathname
          };
        }
        originURL = resolveURL(window.location.href);
        return function isURLSameOrigin(requestURL) {
          var parsed = utils.isString(requestURL) ? resolveURL(requestURL) : requestURL;
          return parsed.protocol === originURL.protocol && parsed.host === originURL.host;
        };
      }()
    ) : (
      // Non standard browser envs (web workers, react-native) lack needed support.
      /* @__PURE__ */ function nonStandardBrowserEnv() {
        return function isURLSameOrigin() {
          return true;
        };
      }()
    );
  }
});

// node_modules/axios/lib/cancel/Cancel.js
var require_Cancel = __commonJS({
  "node_modules/axios/lib/cancel/Cancel.js"(exports2, module2) {
    "use strict";
    function Cancel(message) {
      this.message = message;
    }
    Cancel.prototype.toString = function toString() {
      return "Cancel" + (this.message ? ": " + this.message : "");
    };
    Cancel.prototype.__CANCEL__ = true;
    module2.exports = Cancel;
  }
});

// node_modules/axios/lib/adapters/xhr.js
var require_xhr = __commonJS({
  "node_modules/axios/lib/adapters/xhr.js"(exports2, module2) {
    "use strict";
    var utils = require_utils();
    var settle = require_settle();
    var cookies = require_cookies();
    var buildURL = require_buildURL();
    var buildFullPath = require_buildFullPath();
    var parseHeaders = require_parseHeaders();
    var isURLSameOrigin = require_isURLSameOrigin();
    var createError = require_createError();
    var transitionalDefaults = require_transitional();
    var Cancel = require_Cancel();
    module2.exports = function xhrAdapter(config) {
      return new Promise(function dispatchXhrRequest(resolve2, reject) {
        var requestData = config.data;
        var requestHeaders = config.headers;
        var responseType = config.responseType;
        var onCanceled;
        function done() {
          if (config.cancelToken) {
            config.cancelToken.unsubscribe(onCanceled);
          }
          if (config.signal) {
            config.signal.removeEventListener("abort", onCanceled);
          }
        }
        if (utils.isFormData(requestData)) {
          delete requestHeaders["Content-Type"];
        }
        var request = new XMLHttpRequest();
        if (config.auth) {
          var username = config.auth.username || "";
          var password = config.auth.password ? unescape(encodeURIComponent(config.auth.password)) : "";
          requestHeaders.Authorization = "Basic " + btoa(username + ":" + password);
        }
        var fullPath = buildFullPath(config.baseURL, config.url);
        request.open(config.method.toUpperCase(), buildURL(fullPath, config.params, config.paramsSerializer), true);
        request.timeout = config.timeout;
        function onloadend() {
          if (!request) {
            return;
          }
          var responseHeaders = "getAllResponseHeaders" in request ? parseHeaders(request.getAllResponseHeaders()) : null;
          var responseData = !responseType || responseType === "text" || responseType === "json" ? request.responseText : request.response;
          var response = {
            data: responseData,
            status: request.status,
            statusText: request.statusText,
            headers: responseHeaders,
            config,
            request
          };
          settle(function _resolve(value) {
            resolve2(value);
            done();
          }, function _reject(err) {
            reject(err);
            done();
          }, response);
          request = null;
        }
        if ("onloadend" in request) {
          request.onloadend = onloadend;
        } else {
          request.onreadystatechange = function handleLoad() {
            if (!request || request.readyState !== 4) {
              return;
            }
            if (request.status === 0 && !(request.responseURL && request.responseURL.indexOf("file:") === 0)) {
              return;
            }
            setTimeout(onloadend);
          };
        }
        request.onabort = function handleAbort() {
          if (!request) {
            return;
          }
          reject(createError("Request aborted", config, "ECONNABORTED", request));
          request = null;
        };
        request.onerror = function handleError() {
          reject(createError("Network Error", config, null, request));
          request = null;
        };
        request.ontimeout = function handleTimeout() {
          var timeoutErrorMessage = config.timeout ? "timeout of " + config.timeout + "ms exceeded" : "timeout exceeded";
          var transitional = config.transitional || transitionalDefaults;
          if (config.timeoutErrorMessage) {
            timeoutErrorMessage = config.timeoutErrorMessage;
          }
          reject(createError(
            timeoutErrorMessage,
            config,
            transitional.clarifyTimeoutError ? "ETIMEDOUT" : "ECONNABORTED",
            request
          ));
          request = null;
        };
        if (utils.isStandardBrowserEnv()) {
          var xsrfValue = (config.withCredentials || isURLSameOrigin(fullPath)) && config.xsrfCookieName ? cookies.read(config.xsrfCookieName) : void 0;
          if (xsrfValue) {
            requestHeaders[config.xsrfHeaderName] = xsrfValue;
          }
        }
        if ("setRequestHeader" in request) {
          utils.forEach(requestHeaders, function setRequestHeader(val, key) {
            if (typeof requestData === "undefined" && key.toLowerCase() === "content-type") {
              delete requestHeaders[key];
            } else {
              request.setRequestHeader(key, val);
            }
          });
        }
        if (!utils.isUndefined(config.withCredentials)) {
          request.withCredentials = !!config.withCredentials;
        }
        if (responseType && responseType !== "json") {
          request.responseType = config.responseType;
        }
        if (typeof config.onDownloadProgress === "function") {
          request.addEventListener("progress", config.onDownloadProgress);
        }
        if (typeof config.onUploadProgress === "function" && request.upload) {
          request.upload.addEventListener("progress", config.onUploadProgress);
        }
        if (config.cancelToken || config.signal) {
          onCanceled = function(cancel) {
            if (!request) {
              return;
            }
            reject(!cancel || cancel && cancel.type ? new Cancel("canceled") : cancel);
            request.abort();
            request = null;
          };
          config.cancelToken && config.cancelToken.subscribe(onCanceled);
          if (config.signal) {
            config.signal.aborted ? onCanceled() : config.signal.addEventListener("abort", onCanceled);
          }
        }
        if (!requestData) {
          requestData = null;
        }
        request.send(requestData);
      });
    };
  }
});

// node_modules/ms/index.js
var require_ms = __commonJS({
  "node_modules/ms/index.js"(exports2, module2) {
    var s = 1e3;
    var m2 = s * 60;
    var h = m2 * 60;
    var d2 = h * 24;
    var w = d2 * 7;
    var y = d2 * 365.25;
    module2.exports = function(val, options) {
      options = options || {};
      var type = typeof val;
      if (type === "string" && val.length > 0) {
        return parse6(val);
      } else if (type === "number" && isFinite(val)) {
        return options.long ? fmtLong(val) : fmtShort(val);
      }
      throw new Error(
        "val is not a non-empty string or a valid number. val=" + JSON.stringify(val)
      );
    };
    function parse6(str) {
      str = String(str);
      if (str.length > 100) {
        return;
      }
      var match = /^(-?(?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(
        str
      );
      if (!match) {
        return;
      }
      var n = parseFloat(match[1]);
      var type = (match[2] || "ms").toLowerCase();
      switch (type) {
        case "years":
        case "year":
        case "yrs":
        case "yr":
        case "y":
          return n * y;
        case "weeks":
        case "week":
        case "w":
          return n * w;
        case "days":
        case "day":
        case "d":
          return n * d2;
        case "hours":
        case "hour":
        case "hrs":
        case "hr":
        case "h":
          return n * h;
        case "minutes":
        case "minute":
        case "mins":
        case "min":
        case "m":
          return n * m2;
        case "seconds":
        case "second":
        case "secs":
        case "sec":
        case "s":
          return n * s;
        case "milliseconds":
        case "millisecond":
        case "msecs":
        case "msec":
        case "ms":
          return n;
        default:
          return void 0;
      }
    }
    function fmtShort(ms) {
      var msAbs = Math.abs(ms);
      if (msAbs >= d2) {
        return Math.round(ms / d2) + "d";
      }
      if (msAbs >= h) {
        return Math.round(ms / h) + "h";
      }
      if (msAbs >= m2) {
        return Math.round(ms / m2) + "m";
      }
      if (msAbs >= s) {
        return Math.round(ms / s) + "s";
      }
      return ms + "ms";
    }
    function fmtLong(ms) {
      var msAbs = Math.abs(ms);
      if (msAbs >= d2) {
        return plural(ms, msAbs, d2, "day");
      }
      if (msAbs >= h) {
        return plural(ms, msAbs, h, "hour");
      }
      if (msAbs >= m2) {
        return plural(ms, msAbs, m2, "minute");
      }
      if (msAbs >= s) {
        return plural(ms, msAbs, s, "second");
      }
      return ms + " ms";
    }
    function plural(ms, msAbs, n, name) {
      var isPlural = msAbs >= n * 1.5;
      return Math.round(ms / n) + " " + name + (isPlural ? "s" : "");
    }
  }
});

// node_modules/debug/src/common.js
var require_common = __commonJS({
  "node_modules/debug/src/common.js"(exports2, module2) {
    function setup(env) {
      createDebug.debug = createDebug;
      createDebug.default = createDebug;
      createDebug.coerce = coerce;
      createDebug.disable = disable;
      createDebug.enable = enable;
      createDebug.enabled = enabled;
      createDebug.humanize = require_ms();
      createDebug.destroy = destroy;
      Object.keys(env).forEach((key) => {
        createDebug[key] = env[key];
      });
      createDebug.names = [];
      createDebug.skips = [];
      createDebug.formatters = {};
      function selectColor(namespace) {
        let hash = 0;
        for (let i = 0; i < namespace.length; i++) {
          hash = (hash << 5) - hash + namespace.charCodeAt(i);
          hash |= 0;
        }
        return createDebug.colors[Math.abs(hash) % createDebug.colors.length];
      }
      createDebug.selectColor = selectColor;
      function createDebug(namespace) {
        let prevTime;
        let enableOverride = null;
        let namespacesCache;
        let enabledCache;
        function debug(...args) {
          if (!debug.enabled) {
            return;
          }
          const self2 = debug;
          const curr = Number(/* @__PURE__ */ new Date());
          const ms = curr - (prevTime || curr);
          self2.diff = ms;
          self2.prev = prevTime;
          self2.curr = curr;
          prevTime = curr;
          args[0] = createDebug.coerce(args[0]);
          if (typeof args[0] !== "string") {
            args.unshift("%O");
          }
          let index = 0;
          args[0] = args[0].replace(/%([a-zA-Z%])/g, (match, format3) => {
            if (match === "%%") {
              return "%";
            }
            index++;
            const formatter = createDebug.formatters[format3];
            if (typeof formatter === "function") {
              const val = args[index];
              match = formatter.call(self2, val);
              args.splice(index, 1);
              index--;
            }
            return match;
          });
          createDebug.formatArgs.call(self2, args);
          const logFn = self2.log || createDebug.log;
          logFn.apply(self2, args);
        }
        debug.namespace = namespace;
        debug.useColors = createDebug.useColors();
        debug.color = createDebug.selectColor(namespace);
        debug.extend = extend;
        debug.destroy = createDebug.destroy;
        Object.defineProperty(debug, "enabled", {
          enumerable: true,
          configurable: false,
          get: () => {
            if (enableOverride !== null) {
              return enableOverride;
            }
            if (namespacesCache !== createDebug.namespaces) {
              namespacesCache = createDebug.namespaces;
              enabledCache = createDebug.enabled(namespace);
            }
            return enabledCache;
          },
          set: (v) => {
            enableOverride = v;
          }
        });
        if (typeof createDebug.init === "function") {
          createDebug.init(debug);
        }
        return debug;
      }
      function extend(namespace, delimiter) {
        const newDebug = createDebug(this.namespace + (typeof delimiter === "undefined" ? ":" : delimiter) + namespace);
        newDebug.log = this.log;
        return newDebug;
      }
      function enable(namespaces) {
        createDebug.save(namespaces);
        createDebug.namespaces = namespaces;
        createDebug.names = [];
        createDebug.skips = [];
        let i;
        const split = (typeof namespaces === "string" ? namespaces : "").split(/[\s,]+/);
        const len = split.length;
        for (i = 0; i < len; i++) {
          if (!split[i]) {
            continue;
          }
          namespaces = split[i].replace(/\*/g, ".*?");
          if (namespaces[0] === "-") {
            createDebug.skips.push(new RegExp("^" + namespaces.slice(1) + "$"));
          } else {
            createDebug.names.push(new RegExp("^" + namespaces + "$"));
          }
        }
      }
      function disable() {
        const namespaces = [
          ...createDebug.names.map(toNamespace),
          ...createDebug.skips.map(toNamespace).map((namespace) => "-" + namespace)
        ].join(",");
        createDebug.enable("");
        return namespaces;
      }
      function enabled(name) {
        if (name[name.length - 1] === "*") {
          return true;
        }
        let i;
        let len;
        for (i = 0, len = createDebug.skips.length; i < len; i++) {
          if (createDebug.skips[i].test(name)) {
            return false;
          }
        }
        for (i = 0, len = createDebug.names.length; i < len; i++) {
          if (createDebug.names[i].test(name)) {
            return true;
          }
        }
        return false;
      }
      function toNamespace(regexp) {
        return regexp.toString().substring(2, regexp.toString().length - 2).replace(/\.\*\?$/, "*");
      }
      function coerce(val) {
        if (val instanceof Error) {
          return val.stack || val.message;
        }
        return val;
      }
      function destroy() {
        console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.");
      }
      createDebug.enable(createDebug.load());
      return createDebug;
    }
    module2.exports = setup;
  }
});

// node_modules/debug/src/browser.js
var require_browser = __commonJS({
  "node_modules/debug/src/browser.js"(exports2, module2) {
    exports2.formatArgs = formatArgs;
    exports2.save = save;
    exports2.load = load;
    exports2.useColors = useColors;
    exports2.storage = localstorage();
    exports2.destroy = /* @__PURE__ */ (() => {
      let warned = false;
      return () => {
        if (!warned) {
          warned = true;
          console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.");
        }
      };
    })();
    exports2.colors = [
      "#0000CC",
      "#0000FF",
      "#0033CC",
      "#0033FF",
      "#0066CC",
      "#0066FF",
      "#0099CC",
      "#0099FF",
      "#00CC00",
      "#00CC33",
      "#00CC66",
      "#00CC99",
      "#00CCCC",
      "#00CCFF",
      "#3300CC",
      "#3300FF",
      "#3333CC",
      "#3333FF",
      "#3366CC",
      "#3366FF",
      "#3399CC",
      "#3399FF",
      "#33CC00",
      "#33CC33",
      "#33CC66",
      "#33CC99",
      "#33CCCC",
      "#33CCFF",
      "#6600CC",
      "#6600FF",
      "#6633CC",
      "#6633FF",
      "#66CC00",
      "#66CC33",
      "#9900CC",
      "#9900FF",
      "#9933CC",
      "#9933FF",
      "#99CC00",
      "#99CC33",
      "#CC0000",
      "#CC0033",
      "#CC0066",
      "#CC0099",
      "#CC00CC",
      "#CC00FF",
      "#CC3300",
      "#CC3333",
      "#CC3366",
      "#CC3399",
      "#CC33CC",
      "#CC33FF",
      "#CC6600",
      "#CC6633",
      "#CC9900",
      "#CC9933",
      "#CCCC00",
      "#CCCC33",
      "#FF0000",
      "#FF0033",
      "#FF0066",
      "#FF0099",
      "#FF00CC",
      "#FF00FF",
      "#FF3300",
      "#FF3333",
      "#FF3366",
      "#FF3399",
      "#FF33CC",
      "#FF33FF",
      "#FF6600",
      "#FF6633",
      "#FF9900",
      "#FF9933",
      "#FFCC00",
      "#FFCC33"
    ];
    function useColors() {
      if (typeof window !== "undefined" && window.process && (window.process.type === "renderer" || window.process.__nwjs)) {
        return true;
      }
      if (typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) {
        return false;
      }
      return typeof document !== "undefined" && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance || // Is firebug? http://stackoverflow.com/a/398120/376773
      typeof window !== "undefined" && window.console && (window.console.firebug || window.console.exception && window.console.table) || // Is firefox >= v31?
      // https://developer.mozilla.org/en-US/docs/Tools/Web_Console#Styling_messages
      typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31 || // Double check webkit in userAgent just in case we are in a worker
      typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/);
    }
    function formatArgs(args) {
      args[0] = (this.useColors ? "%c" : "") + this.namespace + (this.useColors ? " %c" : " ") + args[0] + (this.useColors ? "%c " : " ") + "+" + module2.exports.humanize(this.diff);
      if (!this.useColors) {
        return;
      }
      const c2 = "color: " + this.color;
      args.splice(1, 0, c2, "color: inherit");
      let index = 0;
      let lastC = 0;
      args[0].replace(/%[a-zA-Z%]/g, (match) => {
        if (match === "%%") {
          return;
        }
        index++;
        if (match === "%c") {
          lastC = index;
        }
      });
      args.splice(lastC, 0, c2);
    }
    exports2.log = console.debug || console.log || (() => {
    });
    function save(namespaces) {
      try {
        if (namespaces) {
          exports2.storage.setItem("debug", namespaces);
        } else {
          exports2.storage.removeItem("debug");
        }
      } catch (error) {
      }
    }
    function load() {
      let r;
      try {
        r = exports2.storage.getItem("debug");
      } catch (error) {
      }
      if (!r && typeof process !== "undefined" && "env" in process) {
        r = process.env.DEBUG;
      }
      return r;
    }
    function localstorage() {
      try {
        return localStorage;
      } catch (error) {
      }
    }
    module2.exports = require_common()(exports2);
    var { formatters } = module2.exports;
    formatters.j = function(v) {
      try {
        return JSON.stringify(v);
      } catch (error) {
        return "[UnexpectedJSONParseError]: " + error.message;
      }
    };
  }
});

// node_modules/has-flag/index.js
var require_has_flag = __commonJS({
  "node_modules/has-flag/index.js"(exports2, module2) {
    "use strict";
    module2.exports = (flag, argv = process.argv) => {
      const prefix = flag.startsWith("-") ? "" : flag.length === 1 ? "-" : "--";
      const position = argv.indexOf(prefix + flag);
      const terminatorPosition = argv.indexOf("--");
      return position !== -1 && (terminatorPosition === -1 || position < terminatorPosition);
    };
  }
});

// node_modules/supports-color/index.js
var require_supports_color = __commonJS({
  "node_modules/supports-color/index.js"(exports2, module2) {
    "use strict";
    var os2 = require("os");
    var tty = require("tty");
    var hasFlag = require_has_flag();
    var { env } = process;
    var forceColor;
    if (hasFlag("no-color") || hasFlag("no-colors") || hasFlag("color=false") || hasFlag("color=never")) {
      forceColor = 0;
    } else if (hasFlag("color") || hasFlag("colors") || hasFlag("color=true") || hasFlag("color=always")) {
      forceColor = 1;
    }
    if ("FORCE_COLOR" in env) {
      if (env.FORCE_COLOR === "true") {
        forceColor = 1;
      } else if (env.FORCE_COLOR === "false") {
        forceColor = 0;
      } else {
        forceColor = env.FORCE_COLOR.length === 0 ? 1 : Math.min(parseInt(env.FORCE_COLOR, 10), 3);
      }
    }
    function translateLevel(level) {
      if (level === 0) {
        return false;
      }
      return {
        level,
        hasBasic: true,
        has256: level >= 2,
        has16m: level >= 3
      };
    }
    function supportsColor(haveStream, streamIsTTY) {
      if (forceColor === 0) {
        return 0;
      }
      if (hasFlag("color=16m") || hasFlag("color=full") || hasFlag("color=truecolor")) {
        return 3;
      }
      if (hasFlag("color=256")) {
        return 2;
      }
      if (haveStream && !streamIsTTY && forceColor === void 0) {
        return 0;
      }
      const min = forceColor || 0;
      if (env.TERM === "dumb") {
        return min;
      }
      if (process.platform === "win32") {
        const osRelease = os2.release().split(".");
        if (Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
          return Number(osRelease[2]) >= 14931 ? 3 : 2;
        }
        return 1;
      }
      if ("CI" in env) {
        if (["TRAVIS", "CIRCLECI", "APPVEYOR", "GITLAB_CI", "GITHUB_ACTIONS", "BUILDKITE"].some((sign2) => sign2 in env) || env.CI_NAME === "codeship") {
          return 1;
        }
        return min;
      }
      if ("TEAMCITY_VERSION" in env) {
        return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0;
      }
      if (env.COLORTERM === "truecolor") {
        return 3;
      }
      if ("TERM_PROGRAM" in env) {
        const version = parseInt((env.TERM_PROGRAM_VERSION || "").split(".")[0], 10);
        switch (env.TERM_PROGRAM) {
          case "iTerm.app":
            return version >= 3 ? 3 : 2;
          case "Apple_Terminal":
            return 2;
        }
      }
      if (/-256(color)?$/i.test(env.TERM)) {
        return 2;
      }
      if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env.TERM)) {
        return 1;
      }
      if ("COLORTERM" in env) {
        return 1;
      }
      return min;
    }
    function getSupportLevel(stream) {
      const level = supportsColor(stream, stream && stream.isTTY);
      return translateLevel(level);
    }
    module2.exports = {
      supportsColor: getSupportLevel,
      stdout: translateLevel(supportsColor(true, tty.isatty(1))),
      stderr: translateLevel(supportsColor(true, tty.isatty(2)))
    };
  }
});

// node_modules/debug/src/node.js
var require_node = __commonJS({
  "node_modules/debug/src/node.js"(exports2, module2) {
    var tty = require("tty");
    var util = require("util");
    exports2.init = init2;
    exports2.log = log;
    exports2.formatArgs = formatArgs;
    exports2.save = save;
    exports2.load = load;
    exports2.useColors = useColors;
    exports2.destroy = util.deprecate(
      () => {
      },
      "Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`."
    );
    exports2.colors = [6, 2, 3, 4, 5, 1];
    try {
      const supportsColor = require_supports_color();
      if (supportsColor && (supportsColor.stderr || supportsColor).level >= 2) {
        exports2.colors = [
          20,
          21,
          26,
          27,
          32,
          33,
          38,
          39,
          40,
          41,
          42,
          43,
          44,
          45,
          56,
          57,
          62,
          63,
          68,
          69,
          74,
          75,
          76,
          77,
          78,
          79,
          80,
          81,
          92,
          93,
          98,
          99,
          112,
          113,
          128,
          129,
          134,
          135,
          148,
          149,
          160,
          161,
          162,
          163,
          164,
          165,
          166,
          167,
          168,
          169,
          170,
          171,
          172,
          173,
          178,
          179,
          184,
          185,
          196,
          197,
          198,
          199,
          200,
          201,
          202,
          203,
          204,
          205,
          206,
          207,
          208,
          209,
          214,
          215,
          220,
          221
        ];
      }
    } catch (error) {
    }
    exports2.inspectOpts = Object.keys(process.env).filter((key) => {
      return /^debug_/i.test(key);
    }).reduce((obj, key) => {
      const prop = key.substring(6).toLowerCase().replace(/_([a-z])/g, (_, k) => {
        return k.toUpperCase();
      });
      let val = process.env[key];
      if (/^(yes|on|true|enabled)$/i.test(val)) {
        val = true;
      } else if (/^(no|off|false|disabled)$/i.test(val)) {
        val = false;
      } else if (val === "null") {
        val = null;
      } else {
        val = Number(val);
      }
      obj[prop] = val;
      return obj;
    }, {});
    function useColors() {
      return "colors" in exports2.inspectOpts ? Boolean(exports2.inspectOpts.colors) : tty.isatty(process.stderr.fd);
    }
    function formatArgs(args) {
      const { namespace: name, useColors: useColors2 } = this;
      if (useColors2) {
        const c2 = this.color;
        const colorCode = "\x1B[3" + (c2 < 8 ? c2 : "8;5;" + c2);
        const prefix = `  ${colorCode};1m${name} \x1B[0m`;
        args[0] = prefix + args[0].split("\n").join("\n" + prefix);
        args.push(colorCode + "m+" + module2.exports.humanize(this.diff) + "\x1B[0m");
      } else {
        args[0] = getDate() + name + " " + args[0];
      }
    }
    function getDate() {
      if (exports2.inspectOpts.hideDate) {
        return "";
      }
      return (/* @__PURE__ */ new Date()).toISOString() + " ";
    }
    function log(...args) {
      return process.stderr.write(util.format(...args) + "\n");
    }
    function save(namespaces) {
      if (namespaces) {
        process.env.DEBUG = namespaces;
      } else {
        delete process.env.DEBUG;
      }
    }
    function load() {
      return process.env.DEBUG;
    }
    function init2(debug) {
      debug.inspectOpts = {};
      const keys = Object.keys(exports2.inspectOpts);
      for (let i = 0; i < keys.length; i++) {
        debug.inspectOpts[keys[i]] = exports2.inspectOpts[keys[i]];
      }
    }
    module2.exports = require_common()(exports2);
    var { formatters } = module2.exports;
    formatters.o = function(v) {
      this.inspectOpts.colors = this.useColors;
      return util.inspect(v, this.inspectOpts).split("\n").map((str) => str.trim()).join(" ");
    };
    formatters.O = function(v) {
      this.inspectOpts.colors = this.useColors;
      return util.inspect(v, this.inspectOpts);
    };
  }
});

// node_modules/debug/src/index.js
var require_src = __commonJS({
  "node_modules/debug/src/index.js"(exports2, module2) {
    if (typeof process === "undefined" || process.type === "renderer" || process.browser === true || process.__nwjs) {
      module2.exports = require_browser();
    } else {
      module2.exports = require_node();
    }
  }
});

// node_modules/follow-redirects/debug.js
var require_debug = __commonJS({
  "node_modules/follow-redirects/debug.js"(exports2, module2) {
    var debug;
    module2.exports = function() {
      if (!debug) {
        try {
          debug = require_src()("follow-redirects");
        } catch (error) {
        }
        if (typeof debug !== "function") {
          debug = function() {
          };
        }
      }
      debug.apply(null, arguments);
    };
  }
});

// node_modules/follow-redirects/index.js
var require_follow_redirects = __commonJS({
  "node_modules/follow-redirects/index.js"(exports2, module2) {
    var url = require("url");
    var URL2 = url.URL;
    var http2 = require("http");
    var https = require("https");
    var Writable = require("stream").Writable;
    var assert = require("assert");
    var debug = require_debug();
    var useNativeURL = false;
    try {
      assert(new URL2());
    } catch (error) {
      useNativeURL = error.code === "ERR_INVALID_URL";
    }
    var preservedUrlFields = [
      "auth",
      "host",
      "hostname",
      "href",
      "path",
      "pathname",
      "port",
      "protocol",
      "query",
      "search",
      "hash"
    ];
    var events = ["abort", "aborted", "connect", "error", "socket", "timeout"];
    var eventHandlers = /* @__PURE__ */ Object.create(null);
    events.forEach(function(event) {
      eventHandlers[event] = function(arg1, arg2, arg3) {
        this._redirectable.emit(event, arg1, arg2, arg3);
      };
    });
    var InvalidUrlError = createErrorType(
      "ERR_INVALID_URL",
      "Invalid URL",
      TypeError
    );
    var RedirectionError = createErrorType(
      "ERR_FR_REDIRECTION_FAILURE",
      "Redirected request failed"
    );
    var TooManyRedirectsError = createErrorType(
      "ERR_FR_TOO_MANY_REDIRECTS",
      "Maximum number of redirects exceeded",
      RedirectionError
    );
    var MaxBodyLengthExceededError = createErrorType(
      "ERR_FR_MAX_BODY_LENGTH_EXCEEDED",
      "Request body larger than maxBodyLength limit"
    );
    var WriteAfterEndError = createErrorType(
      "ERR_STREAM_WRITE_AFTER_END",
      "write after end"
    );
    var destroy = Writable.prototype.destroy || noop;
    function RedirectableRequest(options, responseCallback) {
      Writable.call(this);
      this._sanitizeOptions(options);
      this._options = options;
      this._ended = false;
      this._ending = false;
      this._redirectCount = 0;
      this._redirects = [];
      this._requestBodyLength = 0;
      this._requestBodyBuffers = [];
      if (responseCallback) {
        this.on("response", responseCallback);
      }
      var self2 = this;
      this._onNativeResponse = function(response) {
        try {
          self2._processResponse(response);
        } catch (cause) {
          self2.emit("error", cause instanceof RedirectionError ? cause : new RedirectionError({ cause }));
        }
      };
      this._performRequest();
    }
    RedirectableRequest.prototype = Object.create(Writable.prototype);
    RedirectableRequest.prototype.abort = function() {
      destroyRequest(this._currentRequest);
      this._currentRequest.abort();
      this.emit("abort");
    };
    RedirectableRequest.prototype.destroy = function(error) {
      destroyRequest(this._currentRequest, error);
      destroy.call(this, error);
      return this;
    };
    RedirectableRequest.prototype.write = function(data, encoding, callback) {
      if (this._ending) {
        throw new WriteAfterEndError();
      }
      if (!isString(data) && !isBuffer(data)) {
        throw new TypeError("data should be a string, Buffer or Uint8Array");
      }
      if (isFunction(encoding)) {
        callback = encoding;
        encoding = null;
      }
      if (data.length === 0) {
        if (callback) {
          callback();
        }
        return;
      }
      if (this._requestBodyLength + data.length <= this._options.maxBodyLength) {
        this._requestBodyLength += data.length;
        this._requestBodyBuffers.push({ data, encoding });
        this._currentRequest.write(data, encoding, callback);
      } else {
        this.emit("error", new MaxBodyLengthExceededError());
        this.abort();
      }
    };
    RedirectableRequest.prototype.end = function(data, encoding, callback) {
      if (isFunction(data)) {
        callback = data;
        data = encoding = null;
      } else if (isFunction(encoding)) {
        callback = encoding;
        encoding = null;
      }
      if (!data) {
        this._ended = this._ending = true;
        this._currentRequest.end(null, null, callback);
      } else {
        var self2 = this;
        var currentRequest = this._currentRequest;
        this.write(data, encoding, function() {
          self2._ended = true;
          currentRequest.end(null, null, callback);
        });
        this._ending = true;
      }
    };
    RedirectableRequest.prototype.setHeader = function(name, value) {
      this._options.headers[name] = value;
      this._currentRequest.setHeader(name, value);
    };
    RedirectableRequest.prototype.removeHeader = function(name) {
      delete this._options.headers[name];
      this._currentRequest.removeHeader(name);
    };
    RedirectableRequest.prototype.setTimeout = function(msecs, callback) {
      var self2 = this;
      function destroyOnTimeout(socket) {
        socket.setTimeout(msecs);
        socket.removeListener("timeout", socket.destroy);
        socket.addListener("timeout", socket.destroy);
      }
      function startTimer(socket) {
        if (self2._timeout) {
          clearTimeout(self2._timeout);
        }
        self2._timeout = setTimeout(function() {
          self2.emit("timeout");
          clearTimer();
        }, msecs);
        destroyOnTimeout(socket);
      }
      function clearTimer() {
        if (self2._timeout) {
          clearTimeout(self2._timeout);
          self2._timeout = null;
        }
        self2.removeListener("abort", clearTimer);
        self2.removeListener("error", clearTimer);
        self2.removeListener("response", clearTimer);
        self2.removeListener("close", clearTimer);
        if (callback) {
          self2.removeListener("timeout", callback);
        }
        if (!self2.socket) {
          self2._currentRequest.removeListener("socket", startTimer);
        }
      }
      if (callback) {
        this.on("timeout", callback);
      }
      if (this.socket) {
        startTimer(this.socket);
      } else {
        this._currentRequest.once("socket", startTimer);
      }
      this.on("socket", destroyOnTimeout);
      this.on("abort", clearTimer);
      this.on("error", clearTimer);
      this.on("response", clearTimer);
      this.on("close", clearTimer);
      return this;
    };
    [
      "flushHeaders",
      "getHeader",
      "setNoDelay",
      "setSocketKeepAlive"
    ].forEach(function(method) {
      RedirectableRequest.prototype[method] = function(a, b) {
        return this._currentRequest[method](a, b);
      };
    });
    ["aborted", "connection", "socket"].forEach(function(property) {
      Object.defineProperty(RedirectableRequest.prototype, property, {
        get: function() {
          return this._currentRequest[property];
        }
      });
    });
    RedirectableRequest.prototype._sanitizeOptions = function(options) {
      if (!options.headers) {
        options.headers = {};
      }
      if (options.host) {
        if (!options.hostname) {
          options.hostname = options.host;
        }
        delete options.host;
      }
      if (!options.pathname && options.path) {
        var searchPos = options.path.indexOf("?");
        if (searchPos < 0) {
          options.pathname = options.path;
        } else {
          options.pathname = options.path.substring(0, searchPos);
          options.search = options.path.substring(searchPos);
        }
      }
    };
    RedirectableRequest.prototype._performRequest = function() {
      var protocol = this._options.protocol;
      var nativeProtocol = this._options.nativeProtocols[protocol];
      if (!nativeProtocol) {
        throw new TypeError("Unsupported protocol " + protocol);
      }
      if (this._options.agents) {
        var scheme = protocol.slice(0, -1);
        this._options.agent = this._options.agents[scheme];
      }
      var request = this._currentRequest = nativeProtocol.request(this._options, this._onNativeResponse);
      request._redirectable = this;
      for (var event of events) {
        request.on(event, eventHandlers[event]);
      }
      this._currentUrl = /^\//.test(this._options.path) ? url.format(this._options) : (
        // When making a request to a proxy, […]
        // a client MUST send the target URI in absolute-form […].
        this._options.path
      );
      if (this._isRedirect) {
        var i = 0;
        var self2 = this;
        var buffers = this._requestBodyBuffers;
        (function writeNext(error) {
          if (request === self2._currentRequest) {
            if (error) {
              self2.emit("error", error);
            } else if (i < buffers.length) {
              var buffer = buffers[i++];
              if (!request.finished) {
                request.write(buffer.data, buffer.encoding, writeNext);
              }
            } else if (self2._ended) {
              request.end();
            }
          }
        })();
      }
    };
    RedirectableRequest.prototype._processResponse = function(response) {
      var statusCode = response.statusCode;
      if (this._options.trackRedirects) {
        this._redirects.push({
          url: this._currentUrl,
          headers: response.headers,
          statusCode
        });
      }
      var location = response.headers.location;
      if (!location || this._options.followRedirects === false || statusCode < 300 || statusCode >= 400) {
        response.responseUrl = this._currentUrl;
        response.redirects = this._redirects;
        this.emit("response", response);
        this._requestBodyBuffers = [];
        return;
      }
      destroyRequest(this._currentRequest);
      response.destroy();
      if (++this._redirectCount > this._options.maxRedirects) {
        throw new TooManyRedirectsError();
      }
      var requestHeaders;
      var beforeRedirect = this._options.beforeRedirect;
      if (beforeRedirect) {
        requestHeaders = Object.assign({
          // The Host header was set by nativeProtocol.request
          Host: response.req.getHeader("host")
        }, this._options.headers);
      }
      var method = this._options.method;
      if ((statusCode === 301 || statusCode === 302) && this._options.method === "POST" || // RFC7231§6.4.4: The 303 (See Other) status code indicates that
      // the server is redirecting the user agent to a different resource […]
      // A user agent can perform a retrieval request targeting that URI
      // (a GET or HEAD request if using HTTP) […]
      statusCode === 303 && !/^(?:GET|HEAD)$/.test(this._options.method)) {
        this._options.method = "GET";
        this._requestBodyBuffers = [];
        removeMatchingHeaders(/^content-/i, this._options.headers);
      }
      var currentHostHeader = removeMatchingHeaders(/^host$/i, this._options.headers);
      var currentUrlParts = parseUrl(this._currentUrl);
      var currentHost = currentHostHeader || currentUrlParts.host;
      var currentUrl = /^\w+:/.test(location) ? this._currentUrl : url.format(Object.assign(currentUrlParts, { host: currentHost }));
      var redirectUrl = resolveUrl(location, currentUrl);
      debug("redirecting to", redirectUrl.href);
      this._isRedirect = true;
      spreadUrlObject(redirectUrl, this._options);
      if (redirectUrl.protocol !== currentUrlParts.protocol && redirectUrl.protocol !== "https:" || redirectUrl.host !== currentHost && !isSubdomain(redirectUrl.host, currentHost)) {
        removeMatchingHeaders(/^(?:authorization|cookie)$/i, this._options.headers);
      }
      if (isFunction(beforeRedirect)) {
        var responseDetails = {
          headers: response.headers,
          statusCode
        };
        var requestDetails = {
          url: currentUrl,
          method,
          headers: requestHeaders
        };
        beforeRedirect(this._options, responseDetails, requestDetails);
        this._sanitizeOptions(this._options);
      }
      this._performRequest();
    };
    function wrap(protocols) {
      var exports3 = {
        maxRedirects: 21,
        maxBodyLength: 10 * 1024 * 1024
      };
      var nativeProtocols = {};
      Object.keys(protocols).forEach(function(scheme) {
        var protocol = scheme + ":";
        var nativeProtocol = nativeProtocols[protocol] = protocols[scheme];
        var wrappedProtocol = exports3[scheme] = Object.create(nativeProtocol);
        function request(input, options, callback) {
          if (isURL(input)) {
            input = spreadUrlObject(input);
          } else if (isString(input)) {
            input = spreadUrlObject(parseUrl(input));
          } else {
            callback = options;
            options = validateUrl(input);
            input = { protocol };
          }
          if (isFunction(options)) {
            callback = options;
            options = null;
          }
          options = Object.assign({
            maxRedirects: exports3.maxRedirects,
            maxBodyLength: exports3.maxBodyLength
          }, input, options);
          options.nativeProtocols = nativeProtocols;
          if (!isString(options.host) && !isString(options.hostname)) {
            options.hostname = "::1";
          }
          assert.equal(options.protocol, protocol, "protocol mismatch");
          debug("options", options);
          return new RedirectableRequest(options, callback);
        }
        function get(input, options, callback) {
          var wrappedRequest = wrappedProtocol.request(input, options, callback);
          wrappedRequest.end();
          return wrappedRequest;
        }
        Object.defineProperties(wrappedProtocol, {
          request: { value: request, configurable: true, enumerable: true, writable: true },
          get: { value: get, configurable: true, enumerable: true, writable: true }
        });
      });
      return exports3;
    }
    function noop() {
    }
    function parseUrl(input) {
      var parsed;
      if (useNativeURL) {
        parsed = new URL2(input);
      } else {
        parsed = validateUrl(url.parse(input));
        if (!isString(parsed.protocol)) {
          throw new InvalidUrlError({ input });
        }
      }
      return parsed;
    }
    function resolveUrl(relative, base) {
      return useNativeURL ? new URL2(relative, base) : parseUrl(url.resolve(base, relative));
    }
    function validateUrl(input) {
      if (/^\[/.test(input.hostname) && !/^\[[:0-9a-f]+\]$/i.test(input.hostname)) {
        throw new InvalidUrlError({ input: input.href || input });
      }
      if (/^\[/.test(input.host) && !/^\[[:0-9a-f]+\](:\d+)?$/i.test(input.host)) {
        throw new InvalidUrlError({ input: input.href || input });
      }
      return input;
    }
    function spreadUrlObject(urlObject, target) {
      var spread = target || {};
      for (var key of preservedUrlFields) {
        spread[key] = urlObject[key];
      }
      if (spread.hostname.startsWith("[")) {
        spread.hostname = spread.hostname.slice(1, -1);
      }
      if (spread.port !== "") {
        spread.port = Number(spread.port);
      }
      spread.path = spread.search ? spread.pathname + spread.search : spread.pathname;
      return spread;
    }
    function removeMatchingHeaders(regex, headers) {
      var lastValue;
      for (var header in headers) {
        if (regex.test(header)) {
          lastValue = headers[header];
          delete headers[header];
        }
      }
      return lastValue === null || typeof lastValue === "undefined" ? void 0 : String(lastValue).trim();
    }
    function createErrorType(code, message, baseClass) {
      function CustomError(properties) {
        Error.captureStackTrace(this, this.constructor);
        Object.assign(this, properties || {});
        this.code = code;
        this.message = this.cause ? message + ": " + this.cause.message : message;
      }
      CustomError.prototype = new (baseClass || Error)();
      Object.defineProperties(CustomError.prototype, {
        constructor: {
          value: CustomError,
          enumerable: false
        },
        name: {
          value: "Error [" + code + "]",
          enumerable: false
        }
      });
      return CustomError;
    }
    function destroyRequest(request, error) {
      for (var event of events) {
        request.removeListener(event, eventHandlers[event]);
      }
      request.on("error", noop);
      request.destroy(error);
    }
    function isSubdomain(subdomain, domain) {
      assert(isString(subdomain) && isString(domain));
      var dot = subdomain.length - domain.length - 1;
      return dot > 0 && subdomain[dot] === "." && subdomain.endsWith(domain);
    }
    function isString(value) {
      return typeof value === "string" || value instanceof String;
    }
    function isFunction(value) {
      return typeof value === "function";
    }
    function isBuffer(value) {
      return typeof value === "object" && "length" in value;
    }
    function isURL(value) {
      return URL2 && value instanceof URL2;
    }
    module2.exports = wrap({ http: http2, https });
    module2.exports.wrap = wrap;
  }
});

// node_modules/axios/lib/env/data.js
var require_data = __commonJS({
  "node_modules/axios/lib/env/data.js"(exports2, module2) {
    module2.exports = {
      "version": "0.26.1"
    };
  }
});

// node_modules/axios/lib/adapters/http.js
var require_http = __commonJS({
  "node_modules/axios/lib/adapters/http.js"(exports2, module2) {
    "use strict";
    var utils = require_utils();
    var settle = require_settle();
    var buildFullPath = require_buildFullPath();
    var buildURL = require_buildURL();
    var http2 = require("http");
    var https = require("https");
    var httpFollow = require_follow_redirects().http;
    var httpsFollow = require_follow_redirects().https;
    var url = require("url");
    var zlib = require("zlib");
    var VERSION2 = require_data().version;
    var createError = require_createError();
    var enhanceError = require_enhanceError();
    var transitionalDefaults = require_transitional();
    var Cancel = require_Cancel();
    var isHttps = /https:?/;
    function setProxy(options, proxy, location) {
      options.hostname = proxy.host;
      options.host = proxy.host;
      options.port = proxy.port;
      options.path = location;
      if (proxy.auth) {
        var base64 = Buffer.from(proxy.auth.username + ":" + proxy.auth.password, "utf8").toString("base64");
        options.headers["Proxy-Authorization"] = "Basic " + base64;
      }
      options.beforeRedirect = function beforeRedirect(redirection) {
        redirection.headers.host = redirection.host;
        setProxy(redirection, proxy, redirection.href);
      };
    }
    module2.exports = function httpAdapter(config) {
      return new Promise(function dispatchHttpRequest(resolvePromise, rejectPromise) {
        var onCanceled;
        function done() {
          if (config.cancelToken) {
            config.cancelToken.unsubscribe(onCanceled);
          }
          if (config.signal) {
            config.signal.removeEventListener("abort", onCanceled);
          }
        }
        var resolve2 = function resolve3(value) {
          done();
          resolvePromise(value);
        };
        var rejected = false;
        var reject = function reject2(value) {
          done();
          rejected = true;
          rejectPromise(value);
        };
        var data = config.data;
        var headers = config.headers;
        var headerNames = {};
        Object.keys(headers).forEach(function storeLowerName(name) {
          headerNames[name.toLowerCase()] = name;
        });
        if ("user-agent" in headerNames) {
          if (!headers[headerNames["user-agent"]]) {
            delete headers[headerNames["user-agent"]];
          }
        } else {
          headers["User-Agent"] = "axios/" + VERSION2;
        }
        if (data && !utils.isStream(data)) {
          if (Buffer.isBuffer(data)) {
          } else if (utils.isArrayBuffer(data)) {
            data = Buffer.from(new Uint8Array(data));
          } else if (utils.isString(data)) {
            data = Buffer.from(data, "utf-8");
          } else {
            return reject(createError(
              "Data after transformation must be a string, an ArrayBuffer, a Buffer, or a Stream",
              config
            ));
          }
          if (config.maxBodyLength > -1 && data.length > config.maxBodyLength) {
            return reject(createError("Request body larger than maxBodyLength limit", config));
          }
          if (!headerNames["content-length"]) {
            headers["Content-Length"] = data.length;
          }
        }
        var auth = void 0;
        if (config.auth) {
          var username = config.auth.username || "";
          var password = config.auth.password || "";
          auth = username + ":" + password;
        }
        var fullPath = buildFullPath(config.baseURL, config.url);
        var parsed = url.parse(fullPath);
        var protocol = parsed.protocol || "http:";
        if (!auth && parsed.auth) {
          var urlAuth = parsed.auth.split(":");
          var urlUsername = urlAuth[0] || "";
          var urlPassword = urlAuth[1] || "";
          auth = urlUsername + ":" + urlPassword;
        }
        if (auth && headerNames.authorization) {
          delete headers[headerNames.authorization];
        }
        var isHttpsRequest = isHttps.test(protocol);
        var agent = isHttpsRequest ? config.httpsAgent : config.httpAgent;
        try {
          buildURL(parsed.path, config.params, config.paramsSerializer).replace(/^\?/, "");
        } catch (err) {
          var customErr = new Error(err.message);
          customErr.config = config;
          customErr.url = config.url;
          customErr.exists = true;
          reject(customErr);
        }
        var options = {
          path: buildURL(parsed.path, config.params, config.paramsSerializer).replace(/^\?/, ""),
          method: config.method.toUpperCase(),
          headers,
          agent,
          agents: { http: config.httpAgent, https: config.httpsAgent },
          auth
        };
        if (config.socketPath) {
          options.socketPath = config.socketPath;
        } else {
          options.hostname = parsed.hostname;
          options.port = parsed.port;
        }
        var proxy = config.proxy;
        if (!proxy && proxy !== false) {
          var proxyEnv = protocol.slice(0, -1) + "_proxy";
          var proxyUrl = process.env[proxyEnv] || process.env[proxyEnv.toUpperCase()];
          if (proxyUrl) {
            var parsedProxyUrl = url.parse(proxyUrl);
            var noProxyEnv = process.env.no_proxy || process.env.NO_PROXY;
            var shouldProxy = true;
            if (noProxyEnv) {
              var noProxy = noProxyEnv.split(",").map(function trim(s) {
                return s.trim();
              });
              shouldProxy = !noProxy.some(function proxyMatch(proxyElement) {
                if (!proxyElement) {
                  return false;
                }
                if (proxyElement === "*") {
                  return true;
                }
                if (proxyElement[0] === "." && parsed.hostname.substr(parsed.hostname.length - proxyElement.length) === proxyElement) {
                  return true;
                }
                return parsed.hostname === proxyElement;
              });
            }
            if (shouldProxy) {
              proxy = {
                host: parsedProxyUrl.hostname,
                port: parsedProxyUrl.port,
                protocol: parsedProxyUrl.protocol
              };
              if (parsedProxyUrl.auth) {
                var proxyUrlAuth = parsedProxyUrl.auth.split(":");
                proxy.auth = {
                  username: proxyUrlAuth[0],
                  password: proxyUrlAuth[1]
                };
              }
            }
          }
        }
        if (proxy) {
          options.headers.host = parsed.hostname + (parsed.port ? ":" + parsed.port : "");
          setProxy(options, proxy, protocol + "//" + parsed.hostname + (parsed.port ? ":" + parsed.port : "") + options.path);
        }
        var transport;
        var isHttpsProxy = isHttpsRequest && (proxy ? isHttps.test(proxy.protocol) : true);
        if (config.transport) {
          transport = config.transport;
        } else if (config.maxRedirects === 0) {
          transport = isHttpsProxy ? https : http2;
        } else {
          if (config.maxRedirects) {
            options.maxRedirects = config.maxRedirects;
          }
          transport = isHttpsProxy ? httpsFollow : httpFollow;
        }
        if (config.maxBodyLength > -1) {
          options.maxBodyLength = config.maxBodyLength;
        }
        if (config.insecureHTTPParser) {
          options.insecureHTTPParser = config.insecureHTTPParser;
        }
        var req = transport.request(options, function handleResponse(res) {
          if (req.aborted)
            return;
          var stream = res;
          var lastRequest = res.req || req;
          if (res.statusCode !== 204 && lastRequest.method !== "HEAD" && config.decompress !== false) {
            switch (res.headers["content-encoding"]) {
              case "gzip":
              case "compress":
              case "deflate":
                stream = stream.pipe(zlib.createUnzip());
                delete res.headers["content-encoding"];
                break;
            }
          }
          var response = {
            status: res.statusCode,
            statusText: res.statusMessage,
            headers: res.headers,
            config,
            request: lastRequest
          };
          if (config.responseType === "stream") {
            response.data = stream;
            settle(resolve2, reject, response);
          } else {
            var responseBuffer = [];
            var totalResponseBytes = 0;
            stream.on("data", function handleStreamData(chunk) {
              responseBuffer.push(chunk);
              totalResponseBytes += chunk.length;
              if (config.maxContentLength > -1 && totalResponseBytes > config.maxContentLength) {
                rejected = true;
                stream.destroy();
                reject(createError(
                  "maxContentLength size of " + config.maxContentLength + " exceeded",
                  config,
                  null,
                  lastRequest
                ));
              }
            });
            stream.on("aborted", function handlerStreamAborted() {
              if (rejected) {
                return;
              }
              stream.destroy();
              reject(createError("error request aborted", config, "ERR_REQUEST_ABORTED", lastRequest));
            });
            stream.on("error", function handleStreamError(err) {
              if (req.aborted)
                return;
              reject(enhanceError(err, config, null, lastRequest));
            });
            stream.on("end", function handleStreamEnd() {
              try {
                var responseData = responseBuffer.length === 1 ? responseBuffer[0] : Buffer.concat(responseBuffer);
                if (config.responseType !== "arraybuffer") {
                  responseData = responseData.toString(config.responseEncoding);
                  if (!config.responseEncoding || config.responseEncoding === "utf8") {
                    responseData = utils.stripBOM(responseData);
                  }
                }
                response.data = responseData;
              } catch (err) {
                reject(enhanceError(err, config, err.code, response.request, response));
              }
              settle(resolve2, reject, response);
            });
          }
        });
        req.on("error", function handleRequestError(err) {
          if (req.aborted && err.code !== "ERR_FR_TOO_MANY_REDIRECTS")
            return;
          reject(enhanceError(err, config, null, req));
        });
        req.on("socket", function handleRequestSocket(socket) {
          socket.setKeepAlive(true, 1e3 * 60);
        });
        if (config.timeout) {
          var timeout = parseInt(config.timeout, 10);
          if (isNaN(timeout)) {
            reject(createError(
              "error trying to parse `config.timeout` to int",
              config,
              "ERR_PARSE_TIMEOUT",
              req
            ));
            return;
          }
          req.setTimeout(timeout, function handleRequestTimeout() {
            req.abort();
            var timeoutErrorMessage = "";
            if (config.timeoutErrorMessage) {
              timeoutErrorMessage = config.timeoutErrorMessage;
            } else {
              timeoutErrorMessage = "timeout of " + config.timeout + "ms exceeded";
            }
            var transitional = config.transitional || transitionalDefaults;
            reject(createError(
              timeoutErrorMessage,
              config,
              transitional.clarifyTimeoutError ? "ETIMEDOUT" : "ECONNABORTED",
              req
            ));
          });
        }
        if (config.cancelToken || config.signal) {
          onCanceled = function(cancel) {
            if (req.aborted)
              return;
            req.abort();
            reject(!cancel || cancel && cancel.type ? new Cancel("canceled") : cancel);
          };
          config.cancelToken && config.cancelToken.subscribe(onCanceled);
          if (config.signal) {
            config.signal.aborted ? onCanceled() : config.signal.addEventListener("abort", onCanceled);
          }
        }
        if (utils.isStream(data)) {
          data.on("error", function handleStreamError(err) {
            reject(enhanceError(err, config, null, req));
          }).pipe(req);
        } else {
          req.end(data);
        }
      });
    };
  }
});

// node_modules/axios/lib/defaults/index.js
var require_defaults = __commonJS({
  "node_modules/axios/lib/defaults/index.js"(exports2, module2) {
    "use strict";
    var utils = require_utils();
    var normalizeHeaderName = require_normalizeHeaderName();
    var enhanceError = require_enhanceError();
    var transitionalDefaults = require_transitional();
    var DEFAULT_CONTENT_TYPE = {
      "Content-Type": "application/x-www-form-urlencoded"
    };
    function setContentTypeIfUnset(headers, value) {
      if (!utils.isUndefined(headers) && utils.isUndefined(headers["Content-Type"])) {
        headers["Content-Type"] = value;
      }
    }
    function getDefaultAdapter() {
      var adapter;
      if (typeof XMLHttpRequest !== "undefined") {
        adapter = require_xhr();
      } else if (typeof process !== "undefined" && Object.prototype.toString.call(process) === "[object process]") {
        adapter = require_http();
      }
      return adapter;
    }
    function stringifySafely(rawValue, parser, encoder) {
      if (utils.isString(rawValue)) {
        try {
          (parser || JSON.parse)(rawValue);
          return utils.trim(rawValue);
        } catch (e) {
          if (e.name !== "SyntaxError") {
            throw e;
          }
        }
      }
      return (encoder || JSON.stringify)(rawValue);
    }
    var defaults = {
      transitional: transitionalDefaults,
      adapter: getDefaultAdapter(),
      transformRequest: [function transformRequest(data, headers) {
        normalizeHeaderName(headers, "Accept");
        normalizeHeaderName(headers, "Content-Type");
        if (utils.isFormData(data) || utils.isArrayBuffer(data) || utils.isBuffer(data) || utils.isStream(data) || utils.isFile(data) || utils.isBlob(data)) {
          return data;
        }
        if (utils.isArrayBufferView(data)) {
          return data.buffer;
        }
        if (utils.isURLSearchParams(data)) {
          setContentTypeIfUnset(headers, "application/x-www-form-urlencoded;charset=utf-8");
          return data.toString();
        }
        if (utils.isObject(data) || headers && headers["Content-Type"] === "application/json") {
          setContentTypeIfUnset(headers, "application/json");
          return stringifySafely(data);
        }
        return data;
      }],
      transformResponse: [function transformResponse(data) {
        var transitional = this.transitional || defaults.transitional;
        var silentJSONParsing = transitional && transitional.silentJSONParsing;
        var forcedJSONParsing = transitional && transitional.forcedJSONParsing;
        var strictJSONParsing = !silentJSONParsing && this.responseType === "json";
        if (strictJSONParsing || forcedJSONParsing && utils.isString(data) && data.length) {
          try {
            return JSON.parse(data);
          } catch (e) {
            if (strictJSONParsing) {
              if (e.name === "SyntaxError") {
                throw enhanceError(e, this, "E_JSON_PARSE");
              }
              throw e;
            }
          }
        }
        return data;
      }],
      /**
       * A timeout in milliseconds to abort a request. If set to 0 (default) a
       * timeout is not created.
       */
      timeout: 0,
      xsrfCookieName: "XSRF-TOKEN",
      xsrfHeaderName: "X-XSRF-TOKEN",
      maxContentLength: -1,
      maxBodyLength: -1,
      validateStatus: function validateStatus(status2) {
        return status2 >= 200 && status2 < 300;
      },
      headers: {
        common: {
          "Accept": "application/json, text/plain, */*"
        }
      }
    };
    utils.forEach(["delete", "get", "head"], function forEachMethodNoData(method) {
      defaults.headers[method] = {};
    });
    utils.forEach(["post", "put", "patch"], function forEachMethodWithData(method) {
      defaults.headers[method] = utils.merge(DEFAULT_CONTENT_TYPE);
    });
    module2.exports = defaults;
  }
});

// node_modules/axios/lib/core/transformData.js
var require_transformData = __commonJS({
  "node_modules/axios/lib/core/transformData.js"(exports2, module2) {
    "use strict";
    var utils = require_utils();
    var defaults = require_defaults();
    module2.exports = function transformData(data, headers, fns) {
      var context = this || defaults;
      utils.forEach(fns, function transform(fn) {
        data = fn.call(context, data, headers);
      });
      return data;
    };
  }
});

// node_modules/axios/lib/cancel/isCancel.js
var require_isCancel = __commonJS({
  "node_modules/axios/lib/cancel/isCancel.js"(exports2, module2) {
    "use strict";
    module2.exports = function isCancel(value) {
      return !!(value && value.__CANCEL__);
    };
  }
});

// node_modules/axios/lib/core/dispatchRequest.js
var require_dispatchRequest = __commonJS({
  "node_modules/axios/lib/core/dispatchRequest.js"(exports2, module2) {
    "use strict";
    var utils = require_utils();
    var transformData = require_transformData();
    var isCancel = require_isCancel();
    var defaults = require_defaults();
    var Cancel = require_Cancel();
    function throwIfCancellationRequested(config) {
      if (config.cancelToken) {
        config.cancelToken.throwIfRequested();
      }
      if (config.signal && config.signal.aborted) {
        throw new Cancel("canceled");
      }
    }
    module2.exports = function dispatchRequest(config) {
      throwIfCancellationRequested(config);
      config.headers = config.headers || {};
      config.data = transformData.call(
        config,
        config.data,
        config.headers,
        config.transformRequest
      );
      config.headers = utils.merge(
        config.headers.common || {},
        config.headers[config.method] || {},
        config.headers
      );
      utils.forEach(
        ["delete", "get", "head", "post", "put", "patch", "common"],
        function cleanHeaderConfig(method) {
          delete config.headers[method];
        }
      );
      var adapter = config.adapter || defaults.adapter;
      return adapter(config).then(function onAdapterResolution(response) {
        throwIfCancellationRequested(config);
        response.data = transformData.call(
          config,
          response.data,
          response.headers,
          config.transformResponse
        );
        return response;
      }, function onAdapterRejection(reason) {
        if (!isCancel(reason)) {
          throwIfCancellationRequested(config);
          if (reason && reason.response) {
            reason.response.data = transformData.call(
              config,
              reason.response.data,
              reason.response.headers,
              config.transformResponse
            );
          }
        }
        return Promise.reject(reason);
      });
    };
  }
});

// node_modules/axios/lib/core/mergeConfig.js
var require_mergeConfig = __commonJS({
  "node_modules/axios/lib/core/mergeConfig.js"(exports2, module2) {
    "use strict";
    var utils = require_utils();
    module2.exports = function mergeConfig(config1, config2) {
      config2 = config2 || {};
      var config = {};
      function getMergedValue(target, source) {
        if (utils.isPlainObject(target) && utils.isPlainObject(source)) {
          return utils.merge(target, source);
        } else if (utils.isPlainObject(source)) {
          return utils.merge({}, source);
        } else if (utils.isArray(source)) {
          return source.slice();
        }
        return source;
      }
      function mergeDeepProperties(prop) {
        if (!utils.isUndefined(config2[prop])) {
          return getMergedValue(config1[prop], config2[prop]);
        } else if (!utils.isUndefined(config1[prop])) {
          return getMergedValue(void 0, config1[prop]);
        }
      }
      function valueFromConfig2(prop) {
        if (!utils.isUndefined(config2[prop])) {
          return getMergedValue(void 0, config2[prop]);
        }
      }
      function defaultToConfig2(prop) {
        if (!utils.isUndefined(config2[prop])) {
          return getMergedValue(void 0, config2[prop]);
        } else if (!utils.isUndefined(config1[prop])) {
          return getMergedValue(void 0, config1[prop]);
        }
      }
      function mergeDirectKeys(prop) {
        if (prop in config2) {
          return getMergedValue(config1[prop], config2[prop]);
        } else if (prop in config1) {
          return getMergedValue(void 0, config1[prop]);
        }
      }
      var mergeMap = {
        "url": valueFromConfig2,
        "method": valueFromConfig2,
        "data": valueFromConfig2,
        "baseURL": defaultToConfig2,
        "transformRequest": defaultToConfig2,
        "transformResponse": defaultToConfig2,
        "paramsSerializer": defaultToConfig2,
        "timeout": defaultToConfig2,
        "timeoutMessage": defaultToConfig2,
        "withCredentials": defaultToConfig2,
        "adapter": defaultToConfig2,
        "responseType": defaultToConfig2,
        "xsrfCookieName": defaultToConfig2,
        "xsrfHeaderName": defaultToConfig2,
        "onUploadProgress": defaultToConfig2,
        "onDownloadProgress": defaultToConfig2,
        "decompress": defaultToConfig2,
        "maxContentLength": defaultToConfig2,
        "maxBodyLength": defaultToConfig2,
        "transport": defaultToConfig2,
        "httpAgent": defaultToConfig2,
        "httpsAgent": defaultToConfig2,
        "cancelToken": defaultToConfig2,
        "socketPath": defaultToConfig2,
        "responseEncoding": defaultToConfig2,
        "validateStatus": mergeDirectKeys
      };
      utils.forEach(Object.keys(config1).concat(Object.keys(config2)), function computeConfigValue(prop) {
        var merge = mergeMap[prop] || mergeDeepProperties;
        var configValue = merge(prop);
        utils.isUndefined(configValue) && merge !== mergeDirectKeys || (config[prop] = configValue);
      });
      return config;
    };
  }
});

// node_modules/axios/lib/helpers/validator.js
var require_validator = __commonJS({
  "node_modules/axios/lib/helpers/validator.js"(exports2, module2) {
    "use strict";
    var VERSION2 = require_data().version;
    var validators = {};
    ["object", "boolean", "number", "function", "string", "symbol"].forEach(function(type, i) {
      validators[type] = function validator(thing) {
        return typeof thing === type || "a" + (i < 1 ? "n " : " ") + type;
      };
    });
    var deprecatedWarnings = {};
    validators.transitional = function transitional(validator, version, message) {
      function formatMessage(opt, desc) {
        return "[Axios v" + VERSION2 + "] Transitional option '" + opt + "'" + desc + (message ? ". " + message : "");
      }
      return function(value, opt, opts) {
        if (validator === false) {
          throw new Error(formatMessage(opt, " has been removed" + (version ? " in " + version : "")));
        }
        if (version && !deprecatedWarnings[opt]) {
          deprecatedWarnings[opt] = true;
          console.warn(
            formatMessage(
              opt,
              " has been deprecated since v" + version + " and will be removed in the near future"
            )
          );
        }
        return validator ? validator(value, opt, opts) : true;
      };
    };
    function assertOptions(options, schema, allowUnknown) {
      if (typeof options !== "object") {
        throw new TypeError("options must be an object");
      }
      var keys = Object.keys(options);
      var i = keys.length;
      while (i-- > 0) {
        var opt = keys[i];
        var validator = schema[opt];
        if (validator) {
          var value = options[opt];
          var result2 = value === void 0 || validator(value, opt, options);
          if (result2 !== true) {
            throw new TypeError("option " + opt + " must be " + result2);
          }
          continue;
        }
        if (allowUnknown !== true) {
          throw Error("Unknown option " + opt);
        }
      }
    }
    module2.exports = {
      assertOptions,
      validators
    };
  }
});

// node_modules/axios/lib/core/Axios.js
var require_Axios = __commonJS({
  "node_modules/axios/lib/core/Axios.js"(exports2, module2) {
    "use strict";
    var utils = require_utils();
    var buildURL = require_buildURL();
    var InterceptorManager = require_InterceptorManager();
    var dispatchRequest = require_dispatchRequest();
    var mergeConfig = require_mergeConfig();
    var validator = require_validator();
    var validators = validator.validators;
    function Axios(instanceConfig) {
      this.defaults = instanceConfig;
      this.interceptors = {
        request: new InterceptorManager(),
        response: new InterceptorManager()
      };
    }
    Axios.prototype.request = function request(configOrUrl, config) {
      if (typeof configOrUrl === "string") {
        config = config || {};
        config.url = configOrUrl;
      } else {
        config = configOrUrl || {};
      }
      config = mergeConfig(this.defaults, config);
      if (config.method) {
        config.method = config.method.toLowerCase();
      } else if (this.defaults.method) {
        config.method = this.defaults.method.toLowerCase();
      } else {
        config.method = "get";
      }
      var transitional = config.transitional;
      if (transitional !== void 0) {
        validator.assertOptions(transitional, {
          silentJSONParsing: validators.transitional(validators.boolean),
          forcedJSONParsing: validators.transitional(validators.boolean),
          clarifyTimeoutError: validators.transitional(validators.boolean)
        }, false);
      }
      var requestInterceptorChain = [];
      var synchronousRequestInterceptors = true;
      this.interceptors.request.forEach(function unshiftRequestInterceptors(interceptor) {
        if (typeof interceptor.runWhen === "function" && interceptor.runWhen(config) === false) {
          return;
        }
        synchronousRequestInterceptors = synchronousRequestInterceptors && interceptor.synchronous;
        requestInterceptorChain.unshift(interceptor.fulfilled, interceptor.rejected);
      });
      var responseInterceptorChain = [];
      this.interceptors.response.forEach(function pushResponseInterceptors(interceptor) {
        responseInterceptorChain.push(interceptor.fulfilled, interceptor.rejected);
      });
      var promise;
      if (!synchronousRequestInterceptors) {
        var chain = [dispatchRequest, void 0];
        Array.prototype.unshift.apply(chain, requestInterceptorChain);
        chain = chain.concat(responseInterceptorChain);
        promise = Promise.resolve(config);
        while (chain.length) {
          promise = promise.then(chain.shift(), chain.shift());
        }
        return promise;
      }
      var newConfig = config;
      while (requestInterceptorChain.length) {
        var onFulfilled = requestInterceptorChain.shift();
        var onRejected = requestInterceptorChain.shift();
        try {
          newConfig = onFulfilled(newConfig);
        } catch (error) {
          onRejected(error);
          break;
        }
      }
      try {
        promise = dispatchRequest(newConfig);
      } catch (error) {
        return Promise.reject(error);
      }
      while (responseInterceptorChain.length) {
        promise = promise.then(responseInterceptorChain.shift(), responseInterceptorChain.shift());
      }
      return promise;
    };
    Axios.prototype.getUri = function getUri(config) {
      config = mergeConfig(this.defaults, config);
      return buildURL(config.url, config.params, config.paramsSerializer).replace(/^\?/, "");
    };
    utils.forEach(["delete", "get", "head", "options"], function forEachMethodNoData(method) {
      Axios.prototype[method] = function(url, config) {
        return this.request(mergeConfig(config || {}, {
          method,
          url,
          data: (config || {}).data
        }));
      };
    });
    utils.forEach(["post", "put", "patch"], function forEachMethodWithData(method) {
      Axios.prototype[method] = function(url, data, config) {
        return this.request(mergeConfig(config || {}, {
          method,
          url,
          data
        }));
      };
    });
    module2.exports = Axios;
  }
});

// node_modules/axios/lib/cancel/CancelToken.js
var require_CancelToken = __commonJS({
  "node_modules/axios/lib/cancel/CancelToken.js"(exports2, module2) {
    "use strict";
    var Cancel = require_Cancel();
    function CancelToken(executor) {
      if (typeof executor !== "function") {
        throw new TypeError("executor must be a function.");
      }
      var resolvePromise;
      this.promise = new Promise(function promiseExecutor(resolve2) {
        resolvePromise = resolve2;
      });
      var token = this;
      this.promise.then(function(cancel) {
        if (!token._listeners)
          return;
        var i;
        var l2 = token._listeners.length;
        for (i = 0; i < l2; i++) {
          token._listeners[i](cancel);
        }
        token._listeners = null;
      });
      this.promise.then = function(onfulfilled) {
        var _resolve;
        var promise = new Promise(function(resolve2) {
          token.subscribe(resolve2);
          _resolve = resolve2;
        }).then(onfulfilled);
        promise.cancel = function reject() {
          token.unsubscribe(_resolve);
        };
        return promise;
      };
      executor(function cancel(message) {
        if (token.reason) {
          return;
        }
        token.reason = new Cancel(message);
        resolvePromise(token.reason);
      });
    }
    CancelToken.prototype.throwIfRequested = function throwIfRequested() {
      if (this.reason) {
        throw this.reason;
      }
    };
    CancelToken.prototype.subscribe = function subscribe(listener) {
      if (this.reason) {
        listener(this.reason);
        return;
      }
      if (this._listeners) {
        this._listeners.push(listener);
      } else {
        this._listeners = [listener];
      }
    };
    CancelToken.prototype.unsubscribe = function unsubscribe(listener) {
      if (!this._listeners) {
        return;
      }
      var index = this._listeners.indexOf(listener);
      if (index !== -1) {
        this._listeners.splice(index, 1);
      }
    };
    CancelToken.source = function source() {
      var cancel;
      var token = new CancelToken(function executor(c2) {
        cancel = c2;
      });
      return {
        token,
        cancel
      };
    };
    module2.exports = CancelToken;
  }
});

// node_modules/axios/lib/helpers/spread.js
var require_spread = __commonJS({
  "node_modules/axios/lib/helpers/spread.js"(exports2, module2) {
    "use strict";
    module2.exports = function spread(callback) {
      return function wrap(arr) {
        return callback.apply(null, arr);
      };
    };
  }
});

// node_modules/axios/lib/helpers/isAxiosError.js
var require_isAxiosError = __commonJS({
  "node_modules/axios/lib/helpers/isAxiosError.js"(exports2, module2) {
    "use strict";
    var utils = require_utils();
    module2.exports = function isAxiosError(payload) {
      return utils.isObject(payload) && payload.isAxiosError === true;
    };
  }
});

// node_modules/axios/lib/axios.js
var require_axios = __commonJS({
  "node_modules/axios/lib/axios.js"(exports2, module2) {
    "use strict";
    var utils = require_utils();
    var bind = require_bind();
    var Axios = require_Axios();
    var mergeConfig = require_mergeConfig();
    var defaults = require_defaults();
    function createInstance(defaultConfig) {
      var context = new Axios(defaultConfig);
      var instance = bind(Axios.prototype.request, context);
      utils.extend(instance, Axios.prototype, context);
      utils.extend(instance, context);
      instance.create = function create(instanceConfig) {
        return createInstance(mergeConfig(defaultConfig, instanceConfig));
      };
      return instance;
    }
    var axios = createInstance(defaults);
    axios.Axios = Axios;
    axios.Cancel = require_Cancel();
    axios.CancelToken = require_CancelToken();
    axios.isCancel = require_isCancel();
    axios.VERSION = require_data().version;
    axios.all = function all(promises) {
      return Promise.all(promises);
    };
    axios.spread = require_spread();
    axios.isAxiosError = require_isAxiosError();
    module2.exports = axios;
    module2.exports.default = axios;
  }
});

// node_modules/axios/index.js
var require_axios2 = __commonJS({
  "node_modules/axios/index.js"(exports2, module2) {
    module2.exports = require_axios();
  }
});

// node_modules/jsonpatcherproxy/src/jsonpatcherproxy.js
var jsonpatcherproxy_exports = {};
__export(jsonpatcherproxy_exports, {
  JSONPatcherProxy: () => JSONPatcherProxy
});
var JSONPatcherProxy;
var init_jsonpatcherproxy = __esm({
  "node_modules/jsonpatcherproxy/src/jsonpatcherproxy.js"() {
    "use strict";
    JSONPatcherProxy = function() {
      function deepClone(obj) {
        switch (typeof obj) {
          case "object":
            return JSON.parse(JSON.stringify(obj));
          case "undefined":
            return null;
          default:
            return obj;
        }
      }
      JSONPatcherProxy2.deepClone = deepClone;
      function escapePathComponent(str) {
        if (str.indexOf("/") == -1 && str.indexOf("~") == -1)
          return str;
        return str.replace(/~/g, "~0").replace(/\//g, "~1");
      }
      JSONPatcherProxy2.escapePathComponent = escapePathComponent;
      function getPathToTree(instance, tree) {
        const pathComponents = [];
        let parenthood = instance._parenthoodMap.get(tree);
        while (parenthood && parenthood.key) {
          pathComponents.unshift(parenthood.key);
          parenthood = instance._parenthoodMap.get(parenthood.parent);
        }
        if (pathComponents.length) {
          const path3 = pathComponents.join("/");
          return "/" + path3;
        }
        return "";
      }
      function trapForSet(instance, tree, key, newValue) {
        const pathToKey = getPathToTree(instance, tree) + "/" + escapePathComponent(key);
        const subtreeMetadata = instance._treeMetadataMap.get(newValue);
        if (instance._treeMetadataMap.has(newValue)) {
          instance._parenthoodMap.set(subtreeMetadata.originalObject, { parent: tree, key });
        }
        if (subtreeMetadata && !instance._isProxifyingTreeNow) {
          subtreeMetadata.inherited = true;
        }
        let warnedAboutNonIntegrerArrayProp = false;
        const isTreeAnArray = Array.isArray(tree);
        const isNonSerializableArrayProperty = isTreeAnArray && !Number.isInteger(+key.toString());
        if (newValue && typeof newValue == "object" && !instance._treeMetadataMap.has(newValue)) {
          if (isNonSerializableArrayProperty) {
            console.warn(`JSONPatcherProxy noticed a non-integer property ('${key}') was set for an array. This interception will not emit a patch. The value is an object, but it was not proxified, because it would not be addressable in JSON-Pointer`);
            warnedAboutNonIntegrerArrayProp = true;
          } else {
            instance._parenthoodMap.set(newValue, { parent: tree, key });
            newValue = instance._proxifyTreeRecursively(tree, newValue, key);
          }
        }
        const valueBeforeReflection = tree[key];
        const wasKeyInTreeBeforeReflection = tree.hasOwnProperty(key);
        if (isTreeAnArray && !isNonSerializableArrayProperty) {
          const index = parseInt(key, 10);
          if (index > tree.length) {
            trapForSet(instance, tree, index - 1 + "", void 0);
          }
        }
        const reflectionResult = Reflect.set(tree, key, newValue);
        const operation = {
          op: "remove",
          path: pathToKey
        };
        if (typeof newValue == "undefined") {
          if (!isTreeAnArray && !wasKeyInTreeBeforeReflection) {
            return reflectionResult;
          } else {
            if (wasKeyInTreeBeforeReflection && !isSignificantChange(valueBeforeReflection, newValue, isTreeAnArray)) {
              return reflectionResult;
            }
            if (isTreeAnArray) {
              operation.value = null;
              if (wasKeyInTreeBeforeReflection) {
                operation.op = "replace";
              } else {
                operation.op = "add";
              }
            }
            const oldSubtreeMetadata = instance._treeMetadataMap.get(valueBeforeReflection);
            if (oldSubtreeMetadata) {
              instance._parenthoodMap.delete(valueBeforeReflection);
              instance._disableTrapsForTreeMetadata(oldSubtreeMetadata);
              instance._treeMetadataMap.delete(oldSubtreeMetadata);
            }
          }
        } else {
          if (isNonSerializableArrayProperty) {
            if (key != "length" && !warnedAboutNonIntegrerArrayProp) {
              console.warn(`JSONPatcherProxy noticed a non-integer property ('${key}') was set for an array. This interception will not emit a patch`);
            }
            return reflectionResult;
          }
          operation.op = "add";
          if (wasKeyInTreeBeforeReflection) {
            if (typeof valueBeforeReflection !== "undefined" || isTreeAnArray) {
              if (!isSignificantChange(valueBeforeReflection, newValue, isTreeAnArray)) {
                return reflectionResult;
              }
              operation.op = "replace";
            }
          }
          operation.value = newValue;
        }
        instance._defaultCallback(operation);
        return reflectionResult;
      }
      function isSignificantChange(oldValue, newValue, isTreeAnArray) {
        if (isTreeAnArray) {
          return isSignificantChangeInArray(oldValue, newValue);
        } else {
          return isSignificantChangeInObject(oldValue, newValue);
        }
      }
      function isSignificantChangeInObject(oldValue, newValue) {
        return oldValue !== newValue;
      }
      function isSignificantChangeInArray(oldValue, newValue) {
        if (typeof oldValue === "undefined") {
          oldValue = null;
        }
        if (typeof newValue === "undefined") {
          newValue = null;
        }
        return oldValue !== newValue;
      }
      function trapForDeleteProperty(instance, tree, key) {
        const oldValue = tree[key];
        const reflectionResult = Reflect.deleteProperty(tree, key);
        if (typeof oldValue !== "undefined") {
          const pathToKey = getPathToTree(instance, tree) + "/" + escapePathComponent(key);
          const subtreeMetadata = instance._treeMetadataMap.get(oldValue);
          if (subtreeMetadata) {
            if (subtreeMetadata.inherited) {
              subtreeMetadata.inherited = false;
            } else {
              instance._parenthoodMap.delete(subtreeMetadata.originalObject);
              instance._disableTrapsForTreeMetadata(subtreeMetadata);
              instance._treeMetadataMap.delete(oldValue);
            }
          }
          instance._defaultCallback({
            op: "remove",
            path: pathToKey
          });
        }
        return reflectionResult;
      }
      function JSONPatcherProxy2(root, showDetachedWarning) {
        this._isProxifyingTreeNow = false;
        this._isObserving = false;
        this._treeMetadataMap = /* @__PURE__ */ new Map();
        this._parenthoodMap = /* @__PURE__ */ new Map();
        if (typeof showDetachedWarning !== "boolean") {
          showDetachedWarning = true;
        }
        this._showDetachedWarning = showDetachedWarning;
        this._originalRoot = root;
        this._cachedProxy = null;
        this._isRecording = false;
        this._userCallback;
        this._defaultCallback;
        this._patches;
      }
      JSONPatcherProxy2.prototype._generateProxyAtKey = function(parent, tree, key) {
        if (!tree) {
          return tree;
        }
        const handler = {
          set: (...args) => trapForSet(this, ...args),
          deleteProperty: (...args) => trapForDeleteProperty(this, ...args)
        };
        const treeMetadata = Proxy.revocable(tree, handler);
        treeMetadata.handler = handler;
        treeMetadata.originalObject = tree;
        this._parenthoodMap.set(tree, { parent, key });
        this._treeMetadataMap.set(treeMetadata.proxy, treeMetadata);
        return treeMetadata.proxy;
      };
      JSONPatcherProxy2.prototype._proxifyTreeRecursively = function(parent, tree, key) {
        for (let key2 in tree) {
          if (tree.hasOwnProperty(key2)) {
            if (tree[key2] instanceof Object) {
              tree[key2] = this._proxifyTreeRecursively(
                tree,
                tree[key2],
                escapePathComponent(key2)
              );
            }
          }
        }
        return this._generateProxyAtKey(parent, tree, key);
      };
      JSONPatcherProxy2.prototype._proxifyRoot = function(root) {
        this.pause();
        this._isProxifyingTreeNow = true;
        const proxifiedRoot = this._proxifyTreeRecursively(
          void 0,
          root,
          ""
        );
        this._isProxifyingTreeNow = false;
        this.resume();
        return proxifiedRoot;
      };
      JSONPatcherProxy2.prototype._disableTrapsForTreeMetadata = function(treeMetadata) {
        if (this._showDetachedWarning) {
          const message = "You're accessing an object that is detached from the observedObject tree, see https://github.com/Palindrom/JSONPatcherProxy#detached-objects";
          treeMetadata.handler.set = (parent, key, newValue) => {
            console.warn(message);
            return Reflect.set(parent, key, newValue);
          };
          treeMetadata.handler.set = (parent, key, newValue) => {
            console.warn(message);
            return Reflect.set(parent, key, newValue);
          };
          treeMetadata.handler.deleteProperty = (parent, key) => {
            return Reflect.deleteProperty(parent, key);
          };
        } else {
          delete treeMetadata.handler.set;
          delete treeMetadata.handler.get;
          delete treeMetadata.handler.deleteProperty;
        }
      };
      JSONPatcherProxy2.prototype.observe = function(record, callback) {
        if (!record && !callback) {
          throw new Error("You need to either record changes or pass a callback");
        }
        this._isRecording = record;
        this._userCallback = callback;
        if (record)
          this._patches = [];
        this._cachedProxy = this._proxifyRoot(this._originalRoot);
        return this._cachedProxy;
      };
      JSONPatcherProxy2.prototype.generate = function() {
        if (!this._isRecording) {
          throw new Error("You should set record to true to get patches later");
        }
        return this._patches.splice(0, this._patches.length);
      };
      JSONPatcherProxy2.prototype.revoke = function() {
        this._treeMetadataMap.forEach((el) => {
          el.revoke();
        });
      };
      JSONPatcherProxy2.prototype.disableTraps = function() {
        this._treeMetadataMap.forEach(this._disableTrapsForTreeMetadata, this);
      };
      JSONPatcherProxy2.prototype.resume = function() {
        this._defaultCallback = (operation) => {
          this._isRecording && this._patches.push(operation);
          this._userCallback && this._userCallback(operation);
        };
        this._isObserving = true;
      };
      JSONPatcherProxy2.prototype.pause = function() {
        this._defaultCallback = () => {
        };
        this._isObserving = false;
      };
      return JSONPatcherProxy2;
    }();
  }
});

// src/gwutils.js
var require_gwutils = __commonJS({
  "src/gwutils.js"(exports2, module2) {
    "use strict";
    var fssync = require("fs");
    var path3 = require("path");
    var { stdout } = require("process");
    var fs2 = require("fs").promises;
    var exec = require("child_process").exec;
    var { promisify } = require("util");
    var execAsync = promisify(require("child_process").exec);
    var axios = require_axios2();
    var g_eventHandlers = {};
    var gwGlobalState = null;
    var updateStateTimeout = null;
    var g_securityConfig = null;
    var jsonPatcherProxy = null;
    var g_originalGlobalState = null;
    var g_fileSaverRunning = false;
    var subordinateConnected = false;
    module2.exports = {
      sleep(ms) {
        return new Promise((resolve2) => setTimeout(resolve2, ms));
      },
      sleepOrPromise(ms, retObject) {
        return new Promise((resolve2) => {
          retObject.resolve = resolve2;
          retObject.timeout = setTimeout(() => {
            if (retObject.resolve) {
              retObject.resolve("timeout");
              retObject.resolve = null;
            }
            retObject.timeout = null;
          }, ms);
        });
      },
      setGlobalState(state) {
        gwGlobalState = state;
      },
      async loadStateFile() {
        const JSONPatcherProxy2 = (await Promise.resolve().then(() => (init_jsonpatcherproxy(), jsonpatcherproxy_exports))).JSONPatcherProxy;
        let gS = null;
        let nodeSettings = null;
        try {
          let fileContents = await fs2.readFile(stateFile, "utf8");
          gS = JSON.parse(fileContents);
        } catch (e) {
        }
        try {
          let fileContents = await fs2.readFile(nodeConfigFile, "utf8");
          nodeSettings = JSON.parse(fileContents);
        } catch (e) {
        }
        if (!gS) {
          gS = { nodes: {}, sensorData: {} };
        }
        if (gS.basicconfig)
          delete gS.basicconfig;
        if (!gS.nodes)
          gS.nodes = {};
        gS.sensorData = {};
        for (const code in gS.nodes) {
          let node = gS.nodes[code];
          delete node.action;
          delete node.settings;
        }
        if (nodeSettings) {
          for (const code in nodeSettings) {
            let currentNodeSettings = nodeSettings[code];
            if (code == "phantomSync") {
              gS.phantomSync = currentNodeSettings;
            } else if (code == "gateways") {
              gS.gateways = currentNodeSettings;
            } else {
              if (!gS.nodes[code])
                gS.nodes[code] = {};
              gS.nodes[code].settings = currentNodeSettings;
            }
          }
        }
        g_originalGlobalState = gS;
        jsonPatcherProxy = new JSONPatcherProxy2(gS);
        return jsonPatcherProxy.observe(true);
      },
      getPatches() {
        return jsonPatcherProxy.generate();
      },
      // getGlobalObjectByPath(path) {
      //   if (path[0] != "/") {
      //     throw new Error('Bad path!')
      //   }
      //   let parts = path.substring(1).split("/")
      //   let baseobject = g_originalGlobalState;
      //   for (let i = 0; i < parts.length - 1; i++){
      //     baseobject = baseobject[path[i]]
      //   }
      //   let last = parts[parts.length - 1]
      //   return { 
      //     baseobject,
      //     last
      //   }
      // },
      // globalStateSet(path, value) {
      //   let { baseobject, last } = this.getGlobalObjectByPath(path)
      //   if (baseobject[last] == undefined) {
      //   } else {
      //   }
      //   baseobject[last] = value
      // },
      // globalStateDelete(path, value) {
      //   let { baseobject, last } = this.getGlobalObjectByPath(path)
      //   delete baseobject[last]
      // },
      async stateFileSaver() {
        let promiseObject = {
          resolve: null,
          timeout: null
        };
        g_fileSaverRunning = true;
        let saveNowFunc = async (e) => {
          if (promiseObject.timeout)
            clearTimeout(promiseObject.timeout);
          if (promiseObject.resolve) {
            console.log("Restarting promise");
            promiseObject.resolve("signal");
          }
        };
        let donotsave = false;
        let halt = false;
        this.subscribeToEvent("factoryReset", (options) => {
          donotsave = true;
          saveNowFunc();
          if (options && options.halt)
            halt = true;
        });
        this.subscribeToEvent("restarting", saveNowFunc);
        this.subscribeToEvent("dogmightbite", saveNowFunc);
        this.subscribeToEvent("forcestatesave", saveNowFunc);
        while (true) {
          let reason = await this.sleepOrPromise(10 * 60 * 1e3, promiseObject);
          if (donotsave) {
            break;
          }
          this.writeFileReliabily(stateFile, JSON.stringify(gwGlobalState));
          if (gwGlobalState.deviceInfo?.state?.action == "restarting") {
            break;
          }
        }
        this.reallyReboot(halt);
      },
      async nodeConfigFileSaver() {
        let promiseObject = {
          resolve: null
        };
        this.subscribeToEvent("nodeconfigchanged", async (e) => {
          if (promiseObject.resolve) {
            promiseObject.resolve("signal");
          }
        });
        while (true) {
          await new Promise((resolve2) => promiseObject.resolve = resolve2);
          let nodesConfig = {};
          for (const code in gwGlobalState.nodes) {
            let node = gwGlobalState.nodes[code];
            if (node.settings) {
              nodesConfig[code] = node.settings;
            }
          }
          if (gwGlobalState.phantomSync)
            nodesConfig["phantomSync"] = gwGlobalState.phantomSync;
          if (gwGlobalState.gateways)
            nodesConfig["gateways"] = gwGlobalState.gateways;
          this.writeFileReliabily(nodeConfigFile, JSON.stringify(nodesConfig));
          nodesConfig = {};
        }
      },
      async writeFileReliabily(filename, contents) {
        let intermediateFilename = filename + "-intermediate";
        let ret = false;
        try {
          let fileHandle = await fs2.open(filename + "-intermediate", "w");
          await fileHandle.writeFile(contents);
          await fileHandle.sync();
          fileHandle.close();
          await fs2.rename(intermediateFilename, filename);
          ret = true;
        } catch (e) {
          console.log("Error writing file", filename, e.message);
        }
        return ret;
      },
      getDataDirectory(subdir) {
        let basedir = "/data/";
        if (process.argv[2]) {
          basedir = process.argv[2];
          if (!fssync.existsSync(basedir))
            fssync.mkdirSync(basedir);
        } else if (process.platform == "win32") {
          basedir = "data/";
          if (!fssync.existsSync(basedir))
            fssync.mkdirSync(basedir);
        }
        if (subdir) {
          basedir = path3.join(basedir, subdir);
          if (!fssync.existsSync(basedir))
            fssync.mkdirSync(basedir);
        }
        return basedir;
      },
      stringFormat(format3) {
        var args = Array.prototype.slice.call(arguments, 1);
        return format3.replace(/{(\d+)}/g, function(match, number) {
          return typeof args[number] != "undefined" ? args[number] : match;
        });
      },
      subscribeToEvent(e, handler) {
        if (!g_eventHandlers[e])
          g_eventHandlers[e] = [];
        g_eventHandlers[e].push(handler);
      },
      broadcastEvent(e, data) {
        if (!g_eventHandlers[e])
          return;
        for (let i = 0; i < g_eventHandlers[e].length; i++) {
          let handler = g_eventHandlers[e][i];
          setTimeout(() => {
            handler(data);
          }, 0);
        }
      },
      gwUpdateGlobalState() {
        if (!updateStateTimeout) {
          updateStateTimeout = setTimeout(() => {
            updateStateTimeout = null;
            this.broadcastEvent("globalstateupdated", null);
          }, 100);
        }
      },
      getSettingsPath() {
        return basicconfigpath;
      },
      gwMergeBasicConfig(newconfig) {
        if (!gwGlobalState.basicconfig) {
          gwGlobalState.basicconfig = newconfig;
        } else {
          for (const setting in newconfig) {
            gwGlobalState.basicconfig[setting] = newconfig[setting];
          }
        }
      },
      async gwSaveBasicConfig() {
        return this.writeFileReliabily(basicconfigpath, JSON.stringify(gwGlobalState.basicconfig));
      },
      async gwLoadBasicConfig() {
        let settings = {};
        try {
          settings = JSON.parse(await fs2.readFile(basicconfigpath, "utf8"));
        } catch (e) {
        }
        if (!settings.collectionInterval)
          settings.collectionInterval = 720;
        if (!settings.collectionIntervalUnits)
          settings.collectionIntervalUnits = 60;
        if (!settings.vibrationWaveFormSettings) {
          settings.vibrationWaveFormSettings = {};
          settings.vibrationWaveFormSettings.mode = "triaxial";
          settings.vibrationWaveFormSettings.axis = "x";
          settings.vibrationWaveFormSettings.sampleRate = 25600;
          settings.vibrationWaveFormSettings.highRange = 8;
          settings.vibrationWaveFormSettings.lowRange = 8;
        }
        return settings;
      },
      isSubordinate() {
        return gwGlobalState.basicconfig.subordinate || gwGlobalState.basicconfig.meshmode == 2;
      },
      setSubordinateConnected(connected) {
        subordinateConnected = connected;
      },
      getSubordinateConnected() {
        return subordinateConnected;
      },
      async gwResetBasicConfig() {
        try {
          await fs2.unlink(basicconfigpath);
        } catch (e) {
        }
        try {
          await fs2.unlink(securityconfigpath);
        } catch (e) {
        }
      },
      async gwFactoryReset(halt) {
        this.broadcastEvent("factoryReset", {
          halt
        });
        try {
          await fs2.unlink(basicconfigpath);
        } catch (e) {
        }
        try {
          await fs2.unlink(securityconfigpath);
        } catch (e) {
        }
        try {
          await fs2.unlink(stateFile);
        } catch (e) {
        }
        try {
          await fs2.unlink(nodeConfigFile);
        } catch (e) {
        }
        try {
          await fs2.unlink(keychain);
        } catch (e) {
        }
        try {
          await fs2.unlink(timeZonePath);
        } catch (e) {
        }
        try {
          await fs2.unlink(ntpPath);
        } catch (e) {
        }
        try {
          await fs2.unlink(ranInitPath);
        } catch (e) {
        }
        try {
          await fs2.rm(opcConfig, { recursive: true });
        } catch (e) {
        }
        try {
          await fs2.rm(offlineStoragePath, { recursive: true });
        } catch (e) {
        }
      },
      reboot() {
        gwGlobalState.deviceInfo.state = {
          action: "restarting"
        };
        this.broadcastEvent("restarting", null);
        this.broadcastEvent("globalstateupdated", null);
        if (!g_fileSaverRunning)
          this.reallyReboot();
      },
      reallyReboot(halt) {
        setTimeout(() => {
          if (process.platform == "linux" && false) {
            if (halt)
              exec("halt");
            else
              exec("reboot");
          }
          process.exit(0);
        }, 1e3);
      },
      enablessh() {
        exec("mount / -o rw,remount", null, (error, stdout2, stderr) => {
          exec("passwd -u eigw");
          exec("/etc/init.d/S50sshd start");
        });
      },
      async getWifiNetworksadv() {
        let wifiScan = "";
        try {
          await execAsync("ifconfig wlan0 up");
          wifiScan = (await execAsync("iwlist scan")).stdout;
        } catch (e) {
        }
        return wifiScan;
      },
      async getWifiNetworks() {
        let networklist = {};
        try {
          let networks = (await execAsync('iwlist scan|grep "ESSID:"')).stdout;
          let lines = networks.split("\n");
          for (let i = 0; i < lines.length; i++) {
            try {
              let network = lines[i].trim().replace('ESSID:"', "").slice(0, -1);
              if (network.length > 0)
                networklist[network] = 1;
            } catch (e) {
            }
          }
        } catch (e) {
        }
        return networklist;
      },
      async getCurrentTZ() {
        let timezone = null;
        try {
          timezone = (await fs2.readFile(path3.join(configpath, "timezone"), "utf8")).trim();
        } catch (e) {
        }
        return timezone;
      },
      async setCurrentTZ(currentTimezone) {
        try {
          this.writeFileReliabily(path3.join(configpath, "timezone"), currentTimezone.trim() + "\n");
        } catch (e) {
        }
      },
      async getNTPServer() {
        let ntpserver = null;
        try {
          ntpserver = (await fs2.readFile(path3.join(configpath, "ntpserver"), "utf8")).trim();
        } catch (e) {
        }
        return ntpserver;
      },
      async setNTPServer(ntpServer) {
        try {
          this.writeFileReliabily(path3.join(configpath, "ntpserver"), ntpServer.trim() + "\n");
        } catch (e) {
        }
      },
      async setSystemTime(timestamp) {
        try {
          console.log("set system time to", timestamp);
          await execAsync("/bin/date --set=@" + timestamp);
          await execAsync("hwclock -f /dev/rtc1 -w -u");
        } catch (e) {
        }
      },
      async setSecurity(securityConfig) {
        if (securityConfig.passwordenable) {
          if (!securityConfig.password) {
            securityConfig.password = g_securityConfig.password;
          }
        } else {
          securityConfig.password = null;
        }
        if (securityConfig.enableWPAPassword) {
          if (!securityConfig.wpaPassword) {
            securityConfig.wpaPassword = g_securityConfig.wpaPassword;
          }
        } else {
          securityConfig.wpaPassword = null;
        }
        g_securityConfig = securityConfig;
        gwGlobalState.deviceInfo.passwordenable = securityConfig.passwordenable;
        gwGlobalState.deviceInfo.enableWPAPassword = securityConfig.enableWPAPassword;
        try {
          await this.writeFileReliabily(securityconfigpath, JSON.stringify(securityConfig));
        } catch (e) {
        }
        let newSettings = {
          enablesensorsecurity: securityConfig.enablesensorsecurity,
          forcesensorsecurity: securityConfig.forcesensorsecurity
        };
        if (!securityConfig.passwordenable) {
          newSettings.enablesensorsecurity = false;
          newSettings.forcesensorsecurity = false;
        }
        this.gwMergeBasicConfig(newSettings);
        this.gwSaveBasicConfig();
        this.gwUpdateGlobalState();
      },
      async loadSecurity() {
        if (!g_securityConfig) {
          g_securityConfig = {};
          try {
            g_securityConfig = JSON.parse(await fs2.readFile(securityconfigpath, "utf8"));
          } catch (e) {
          }
        }
        if (!gwGlobalState.deviceInfo)
          gwGlobalState.deviceInfo = {};
        if (g_securityConfig.password)
          gwGlobalState.deviceInfo.passwordenable = true;
        if (g_securityConfig.wpaPassword)
          gwGlobalState.deviceInfo.enableWPAPassword = true;
        return g_securityConfig;
      },
      offsetTimestampLocalTime(timestamp) {
        return timestamp - (/* @__PURE__ */ new Date()).getTimezoneOffset() * 60;
      },
      async readSystemLog() {
        let log = "";
        try {
          log = (await execAsync("logread")).stdout;
        } catch (e) {
        }
        return log;
      },
      async setupMeshRoute(ipaddr2) {
        let routeCmd = "iptables -t nat -A PREROUTING -p tcp --dport 81 -j DNAT --to-destination " + ipaddr2 + ":80"(await execAsync("iptables -t nat -F PREROUTING"))(await execAsync(routeCmd));
      },
      async downloadFirmware(firmwareCode) {
        let haveCode = true;
        try {
          await fs2.access(path3.join(customFwPath, firmwareCode + ".dat"));
        } catch (e) {
          haveCode = false;
        }
        if (!haveCode) {
          try {
            const baseFirmwareCodes = "https://pfw.erbessd-instruments.com/test/firmware-files.php";
            let response = await axios.get(baseFirmwareCodes + "?type=dat&id=" + firmwareCode, { responseType: "arraybuffer" });
            let firmwareIni = response.data;
            response = await axios.get(baseFirmwareCodes + "?type=bin&id=" + firmwareCode, { responseType: "arraybuffer" });
            let firmwareBin = response.data;
            await fs2.writeFile(path3.join(customFwPath, firmwareCode + ".dat"), firmwareIni);
            await fs2.writeFile(path3.join(customFwPath, firmwareCode + ".bin"), firmwareBin);
            haveCode = true;
            try {
              let response2 = await axios.get(baseFirmwareCodes + "?type=datsdbl&id=" + firmwareCode, { responseType: "arraybuffer" });
              firmwareIni = response2.data;
              response2 = await axios.get(baseFirmwareCodes + "?type=binsdbl&id=" + firmwareCode, { responseType: "arraybuffer" });
              firmwareBin = response2.data;
              await fs2.writeFile(path3.join(customFwPath, firmwareCode + "sdbl.dat"), firmwareIni);
              await fs2.writeFile(path3.join(customFwPath, firmwareCode + "sdbl.bin"), firmwareBin);
            } catch (e) {
            }
          } catch (e) {
            console.log(e);
            haveCode = false;
          }
        }
        return haveCode;
      },
      setupssshtunnel(host, remoteport, user, password) {
        exec(`sshpass -p ${password} ssh -o "StrictHostKeyChecking no"  -f -N -T -R${remoteport}:localhost:22 ${user}@${host} &`);
      },
      gzipAsync(payload) {
      }
    };
    var configpath = module2.exports.getDataDirectory("config");
    var basicconfigpath = path3.join(configpath, "basicconfig");
    var securityconfigpath = path3.join(configpath, "security");
    var stateFile = path3.join(module2.exports.getDataDirectory(), "state.json");
    var nodeConfigFile = path3.join(module2.exports.getDataDirectory(), "nodeconfig.json");
    var opcConfig = module2.exports.getDataDirectory("opc");
    var keychainpath = path3.join(configpath, "keychain");
    var offlineStoragePath = module2.exports.getDataDirectory("offlineStorage");
    var timeZonePath = path3.join(configpath, "timezone");
    var ntpPath = path3.join(configpath, "ntpserver");
    var ranInitPath = path3.join(configpath, "raninit");
    var customFwPath = module2.exports.getDataDirectory("customFw");
  }
});

// src/dogpet.js
var require_dogpet = __commonJS({
  "src/dogpet.js"(exports2, module2) {
    "use strict";
    var { promisify } = require("util");
    var execAsync = promisify(require("child_process").exec);
    var fs2 = require("fs").promises;
    var gwutils2 = require_gwutils();
    var WDT_CHANNEL_SEENNODE = 1;
    var WDT_CHANNEL_SUBCONNECTED = 2;
    var firstTimeNotFeeding = false;
    var watchdogChannels = [
      {
        // WDT_CHANNEL_SIGNAL
        max: 43200,
        // max 60 seconds without seeing this
        enabled: false
      },
      {
        // WDT_CHANNEL_SEENNODE
        max: 40 * 60,
        enabled: true
      },
      {
        // WDT_CHANNEL_SUBCONNECTED
        max: 30 * 60,
        enabled: false
      }
    ];
    async function handleWatchdog() {
      if (process.platform == "linux" && false) {
        try {
          await execAsync("pkill -f dogfeeder.sh");
        } catch (e) {
        }
      }
      let uno = Buffer.from([1]);
      if (process.platform == "linux" && false) {
        try {
          let watchdog = await fs2.open("/dev/watchdog", "a");
          watchdog.write(uno);
          watchdog.close();
        } catch (e) {
        }
      }
      for (let i = 0; i < watchdogChannels.length; i++)
        watchdogChannels[i].last = process.hrtime();
      setInterval(async function() {
        let feed = true;
        for (let i = 0; i < watchdogChannels.length; i++) {
          if (!watchdogChannels[i].enabled)
            continue;
          let ellapsed = process.hrtime(watchdogChannels[i].last);
          if (ellapsed[0] > watchdogChannels[i].max) {
            feed = false;
            break;
          }
        }
        if (feed) {
          if (process.platform == "linux" && false) {
            try {
              let watchdog = await fs2.open("/dev/watchdog", "a");
              watchdog.write(uno);
              watchdog.close();
            } catch (e) {
            }
          }
          firstTimeNotFeeding = false;
        } else {
          if (!firstTimeNotFeeding) {
            gwutils2.broadcastEvent("dogmightbite", null);
            firstTimeNotFeeding = true;
          }
          console.log("Not feeding dog!");
        }
      }, 1e3);
      gwutils2.subscribeToEvent("seensensor", (eventdata) => {
        watchdogChannels[WDT_CHANNEL_SEENNODE].last = process.hrtime();
      });
    }
    function enableSubordinateWatchDog() {
      watchdogChannels[WDT_CHANNEL_SUBCONNECTED].enabled = true;
      setInterval(() => {
        if (gwutils2.getSubordinateConnected())
          watchdogChannels[WDT_CHANNEL_SUBCONNECTED].last = process.hrtime();
      }, 1e4);
    }
    module2.exports = {
      handleWatchdog,
      enableSubordinateWatchDog
    };
  }
});

// node_modules/@serialport/parser-byte-length/dist/index.js
var require_dist = __commonJS({
  "node_modules/@serialport/parser-byte-length/dist/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ByteLengthParser = void 0;
    var stream_1 = require("stream");
    var ByteLengthParser = class extends stream_1.Transform {
      length;
      position;
      buffer;
      constructor(options) {
        super(options);
        if (typeof options.length !== "number") {
          throw new TypeError('"length" is not a number');
        }
        if (options.length < 1) {
          throw new TypeError('"length" is not greater than 0');
        }
        this.length = options.length;
        this.position = 0;
        this.buffer = Buffer.alloc(this.length);
      }
      _transform(chunk, _encoding, cb) {
        let cursor = 0;
        while (cursor < chunk.length) {
          this.buffer[this.position] = chunk[cursor];
          cursor++;
          this.position++;
          if (this.position === this.length) {
            this.push(this.buffer);
            this.buffer = Buffer.alloc(this.length);
            this.position = 0;
          }
        }
        cb();
      }
      _flush(cb) {
        this.push(this.buffer.slice(0, this.position));
        this.buffer = Buffer.alloc(this.length);
        cb();
      }
    };
    exports2.ByteLengthParser = ByteLengthParser;
  }
});

// node_modules/@serialport/parser-cctalk/dist/index.js
var require_dist2 = __commonJS({
  "node_modules/@serialport/parser-cctalk/dist/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.CCTalkParser = void 0;
    var stream_1 = require("stream");
    var CCTalkParser = class extends stream_1.Transform {
      array;
      cursor;
      lastByteFetchTime;
      maxDelayBetweenBytesMs;
      constructor(maxDelayBetweenBytesMs = 50) {
        super();
        this.array = [];
        this.cursor = 0;
        this.lastByteFetchTime = 0;
        this.maxDelayBetweenBytesMs = maxDelayBetweenBytesMs;
      }
      _transform(buffer, encoding, cb) {
        if (this.maxDelayBetweenBytesMs > 0) {
          const now = Date.now();
          if (now - this.lastByteFetchTime > this.maxDelayBetweenBytesMs) {
            this.array = [];
            this.cursor = 0;
          }
          this.lastByteFetchTime = now;
        }
        this.cursor += buffer.length;
        Array.from(buffer).map((byte) => this.array.push(byte));
        while (this.cursor > 1 && this.cursor >= this.array[1] + 5) {
          const FullMsgLength = this.array[1] + 5;
          const frame = Buffer.from(this.array.slice(0, FullMsgLength));
          this.array = this.array.slice(frame.length, this.array.length);
          this.cursor -= FullMsgLength;
          this.push(frame);
        }
        cb();
      }
    };
    exports2.CCTalkParser = CCTalkParser;
  }
});

// node_modules/@serialport/parser-delimiter/dist/index.js
var require_dist3 = __commonJS({
  "node_modules/@serialport/parser-delimiter/dist/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.DelimiterParser = void 0;
    var stream_1 = require("stream");
    var DelimiterParser = class extends stream_1.Transform {
      includeDelimiter;
      delimiter;
      buffer;
      constructor({ delimiter, includeDelimiter = false, ...options }) {
        super(options);
        if (delimiter === void 0) {
          throw new TypeError('"delimiter" is not a bufferable object');
        }
        if (delimiter.length === 0) {
          throw new TypeError('"delimiter" has a 0 or undefined length');
        }
        this.includeDelimiter = includeDelimiter;
        this.delimiter = Buffer.from(delimiter);
        this.buffer = Buffer.alloc(0);
      }
      _transform(chunk, encoding, cb) {
        let data = Buffer.concat([this.buffer, chunk]);
        let position;
        while ((position = data.indexOf(this.delimiter)) !== -1) {
          this.push(data.slice(0, position + (this.includeDelimiter ? this.delimiter.length : 0)));
          data = data.slice(position + this.delimiter.length);
        }
        this.buffer = data;
        cb();
      }
      _flush(cb) {
        this.push(this.buffer);
        this.buffer = Buffer.alloc(0);
        cb();
      }
    };
    exports2.DelimiterParser = DelimiterParser;
  }
});

// node_modules/@serialport/parser-inter-byte-timeout/dist/index.js
var require_dist4 = __commonJS({
  "node_modules/@serialport/parser-inter-byte-timeout/dist/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.InterByteTimeoutParser = void 0;
    var stream_1 = require("stream");
    var InterByteTimeoutParser = class extends stream_1.Transform {
      maxBufferSize;
      currentPacket;
      interval;
      intervalID;
      constructor({ maxBufferSize = 65536, interval, ...transformOptions }) {
        super(transformOptions);
        if (!interval) {
          throw new TypeError('"interval" is required');
        }
        if (typeof interval !== "number" || Number.isNaN(interval)) {
          throw new TypeError('"interval" is not a number');
        }
        if (interval < 1) {
          throw new TypeError('"interval" is not greater than 0');
        }
        if (typeof maxBufferSize !== "number" || Number.isNaN(maxBufferSize)) {
          throw new TypeError('"maxBufferSize" is not a number');
        }
        if (maxBufferSize < 1) {
          throw new TypeError('"maxBufferSize" is not greater than 0');
        }
        this.maxBufferSize = maxBufferSize;
        this.currentPacket = [];
        this.interval = interval;
      }
      _transform(chunk, encoding, cb) {
        if (this.intervalID) {
          clearTimeout(this.intervalID);
        }
        for (let offset = 0; offset < chunk.length; offset++) {
          this.currentPacket.push(chunk[offset]);
          if (this.currentPacket.length >= this.maxBufferSize) {
            this.emitPacket();
          }
        }
        this.intervalID = setTimeout(this.emitPacket.bind(this), this.interval);
        cb();
      }
      emitPacket() {
        if (this.intervalID) {
          clearTimeout(this.intervalID);
        }
        if (this.currentPacket.length > 0) {
          this.push(Buffer.from(this.currentPacket));
        }
        this.currentPacket = [];
      }
      _flush(cb) {
        this.emitPacket();
        cb();
      }
    };
    exports2.InterByteTimeoutParser = InterByteTimeoutParser;
  }
});

// node_modules/@serialport/parser-packet-length/dist/index.js
var require_dist5 = __commonJS({
  "node_modules/@serialport/parser-packet-length/dist/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PacketLengthParser = void 0;
    var stream_1 = require("stream");
    var PacketLengthParser = class extends stream_1.Transform {
      buffer;
      start;
      opts;
      constructor(options = {}) {
        super(options);
        const { delimiter = 170, packetOverhead = 2, lengthBytes = 1, lengthOffset = 1, maxLen = 255 } = options;
        this.opts = {
          delimiter,
          packetOverhead,
          lengthBytes,
          lengthOffset,
          maxLen
        };
        this.buffer = Buffer.alloc(0);
        this.start = false;
      }
      _transform(chunk, encoding, cb) {
        for (let ndx = 0; ndx < chunk.length; ndx++) {
          const byte = chunk[ndx];
          if (byte === this.opts.delimiter) {
            this.start = true;
          }
          if (true === this.start) {
            this.buffer = Buffer.concat([this.buffer, Buffer.from([byte])]);
            if (this.buffer.length >= this.opts.lengthOffset + this.opts.lengthBytes) {
              const len = this.buffer.readUIntLE(this.opts.lengthOffset, this.opts.lengthBytes);
              if (this.buffer.length == len + this.opts.packetOverhead || len > this.opts.maxLen) {
                this.push(this.buffer);
                this.buffer = Buffer.alloc(0);
                this.start = false;
              }
            }
          }
        }
        cb();
      }
      _flush(cb) {
        this.push(this.buffer);
        this.buffer = Buffer.alloc(0);
        cb();
      }
    };
    exports2.PacketLengthParser = PacketLengthParser;
  }
});

// node_modules/@serialport/parser-readline/dist/index.js
var require_dist6 = __commonJS({
  "node_modules/@serialport/parser-readline/dist/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ReadlineParser = void 0;
    var parser_delimiter_1 = require_dist3();
    var ReadlineParser = class extends parser_delimiter_1.DelimiterParser {
      constructor(options) {
        const opts = {
          delimiter: Buffer.from("\n", "utf8"),
          encoding: "utf8",
          ...options
        };
        if (typeof opts.delimiter === "string") {
          opts.delimiter = Buffer.from(opts.delimiter, opts.encoding);
        }
        super(opts);
      }
    };
    exports2.ReadlineParser = ReadlineParser;
  }
});

// node_modules/@serialport/parser-ready/dist/index.js
var require_dist7 = __commonJS({
  "node_modules/@serialport/parser-ready/dist/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ReadyParser = void 0;
    var stream_1 = require("stream");
    var ReadyParser = class extends stream_1.Transform {
      delimiter;
      readOffset;
      ready;
      constructor({ delimiter, ...options }) {
        if (delimiter === void 0) {
          throw new TypeError('"delimiter" is not a bufferable object');
        }
        if (delimiter.length === 0) {
          throw new TypeError('"delimiter" has a 0 or undefined length');
        }
        super(options);
        this.delimiter = Buffer.from(delimiter);
        this.readOffset = 0;
        this.ready = false;
      }
      _transform(chunk, encoding, cb) {
        if (this.ready) {
          this.push(chunk);
          return cb();
        }
        const delimiter = this.delimiter;
        let chunkOffset = 0;
        while (this.readOffset < delimiter.length && chunkOffset < chunk.length) {
          if (delimiter[this.readOffset] === chunk[chunkOffset]) {
            this.readOffset++;
          } else {
            this.readOffset = 0;
          }
          chunkOffset++;
        }
        if (this.readOffset === delimiter.length) {
          this.ready = true;
          this.emit("ready");
          const chunkRest = chunk.slice(chunkOffset);
          if (chunkRest.length > 0) {
            this.push(chunkRest);
          }
        }
        cb();
      }
    };
    exports2.ReadyParser = ReadyParser;
  }
});

// node_modules/@serialport/parser-regex/dist/index.js
var require_dist8 = __commonJS({
  "node_modules/@serialport/parser-regex/dist/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RegexParser = void 0;
    var stream_1 = require("stream");
    var RegexParser = class extends stream_1.Transform {
      regex;
      data;
      constructor({ regex, ...options }) {
        const opts = {
          encoding: "utf8",
          ...options
        };
        if (regex === void 0) {
          throw new TypeError('"options.regex" must be a regular expression pattern or object');
        }
        if (!(regex instanceof RegExp)) {
          regex = new RegExp(regex.toString());
        }
        super(opts);
        this.regex = regex;
        this.data = "";
      }
      _transform(chunk, encoding, cb) {
        const data = this.data + chunk;
        const parts = data.split(this.regex);
        this.data = parts.pop() || "";
        parts.forEach((part) => {
          this.push(part);
        });
        cb();
      }
      _flush(cb) {
        this.push(this.data);
        this.data = "";
        cb();
      }
    };
    exports2.RegexParser = RegexParser;
  }
});

// node_modules/@serialport/parser-slip-encoder/dist/decoder.js
var require_decoder = __commonJS({
  "node_modules/@serialport/parser-slip-encoder/dist/decoder.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SlipDecoder = void 0;
    var stream_1 = require("stream");
    var SlipDecoder = class extends stream_1.Transform {
      opts;
      buffer;
      escape;
      start;
      constructor(options = {}) {
        super(options);
        const { START, ESC = 219, END = 192, ESC_START, ESC_END = 220, ESC_ESC = 221 } = options;
        this.opts = {
          START,
          ESC,
          END,
          ESC_START,
          ESC_END,
          ESC_ESC
        };
        this.buffer = Buffer.alloc(0);
        this.escape = false;
        this.start = false;
      }
      _transform(chunk, encoding, cb) {
        for (let ndx = 0; ndx < chunk.length; ndx++) {
          let byte = chunk[ndx];
          if (byte === this.opts.START) {
            this.start = true;
            continue;
          } else if (void 0 == this.opts.START) {
            this.start = true;
          }
          if (this.escape) {
            if (byte === this.opts.ESC_START && this.opts.START) {
              byte = this.opts.START;
            } else if (byte === this.opts.ESC_ESC) {
              byte = this.opts.ESC;
            } else if (byte === this.opts.ESC_END) {
              byte = this.opts.END;
            } else {
              this.escape = false;
              this.push(this.buffer);
              this.buffer = Buffer.alloc(0);
            }
          } else {
            if (byte === this.opts.ESC) {
              this.escape = true;
              continue;
            }
            if (byte === this.opts.END) {
              this.push(this.buffer);
              this.buffer = Buffer.alloc(0);
              this.escape = false;
              this.start = false;
              continue;
            }
          }
          this.escape = false;
          if (this.start) {
            this.buffer = Buffer.concat([this.buffer, Buffer.from([byte])]);
          }
        }
        cb();
      }
      _flush(cb) {
        this.push(this.buffer);
        this.buffer = Buffer.alloc(0);
        cb();
      }
    };
    exports2.SlipDecoder = SlipDecoder;
  }
});

// node_modules/@serialport/parser-slip-encoder/dist/encoder.js
var require_encoder = __commonJS({
  "node_modules/@serialport/parser-slip-encoder/dist/encoder.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SlipEncoder = void 0;
    var stream_1 = require("stream");
    var SlipEncoder = class extends stream_1.Transform {
      opts;
      constructor(options = {}) {
        super(options);
        const { START, ESC = 219, END = 192, ESC_START, ESC_END = 220, ESC_ESC = 221, bluetoothQuirk = false } = options;
        this.opts = {
          START,
          ESC,
          END,
          ESC_START,
          ESC_END,
          ESC_ESC,
          bluetoothQuirk
        };
      }
      _transform(chunk, encoding, cb) {
        const chunkLength = chunk.length;
        if (this.opts.bluetoothQuirk && chunkLength === 0) {
          return cb();
        }
        const encoded = Buffer.alloc(chunkLength * 2 + 2);
        let j = 0;
        if (this.opts.bluetoothQuirk == true) {
          encoded[j++] = this.opts.END;
        }
        if (this.opts.START !== void 0) {
          encoded[j++] = this.opts.START;
        }
        for (let i = 0; i < chunkLength; i++) {
          let byte = chunk[i];
          if (byte === this.opts.START && this.opts.ESC_START) {
            encoded[j++] = this.opts.ESC;
            byte = this.opts.ESC_START;
          } else if (byte === this.opts.END) {
            encoded[j++] = this.opts.ESC;
            byte = this.opts.ESC_END;
          } else if (byte === this.opts.ESC) {
            encoded[j++] = this.opts.ESC;
            byte = this.opts.ESC_ESC;
          }
          encoded[j++] = byte;
        }
        encoded[j++] = this.opts.END;
        cb(null, encoded.slice(0, j));
      }
    };
    exports2.SlipEncoder = SlipEncoder;
  }
});

// node_modules/@serialport/parser-slip-encoder/dist/index.js
var require_dist9 = __commonJS({
  "node_modules/@serialport/parser-slip-encoder/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_decoder(), exports2);
    __exportStar3(require_encoder(), exports2);
  }
});

// node_modules/@serialport/parser-spacepacket/dist/utils.js
var require_utils2 = __commonJS({
  "node_modules/@serialport/parser-spacepacket/dist/utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.convertHeaderBufferToObj = exports2.HEADER_LENGTH = void 0;
    exports2.HEADER_LENGTH = 6;
    var toOctetStr = (num) => {
      let str = Number(num).toString(2);
      while (str.length < 8) {
        str = `0${str}`;
      }
      return str;
    };
    var convertHeaderBufferToObj = (buf) => {
      const headerStr = Array.from(buf.slice(0, exports2.HEADER_LENGTH)).reduce((accum, curr) => `${accum}${toOctetStr(curr)}`, "");
      const isVersion1 = headerStr.slice(0, 3) === "000";
      const versionNumber = isVersion1 ? 1 : "UNKNOWN_VERSION";
      const type = Number(headerStr[3]);
      const secondaryHeader = Number(headerStr[4]);
      const apid = parseInt(headerStr.slice(5, 16), 2);
      const sequenceFlags = parseInt(headerStr.slice(16, 18), 2);
      const packetName = parseInt(headerStr.slice(18, 32), 2);
      const dataLength = parseInt(headerStr.slice(-16), 2) + 1;
      return {
        versionNumber,
        identification: {
          apid,
          secondaryHeader,
          type
        },
        sequenceControl: {
          packetName,
          sequenceFlags
        },
        dataLength
      };
    };
    exports2.convertHeaderBufferToObj = convertHeaderBufferToObj;
  }
});

// node_modules/@serialport/parser-spacepacket/dist/index.js
var require_dist10 = __commonJS({
  "node_modules/@serialport/parser-spacepacket/dist/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SpacePacketParser = void 0;
    var stream_1 = require("stream");
    var utils_1 = require_utils2();
    var SpacePacketParser = class extends stream_1.Transform {
      timeCodeFieldLength;
      ancillaryDataFieldLength;
      dataBuffer;
      headerBuffer;
      dataLength;
      expectingHeader;
      dataSlice;
      header;
      /**
       * A Transform stream that accepts a stream of octet data and emits object representations of
       * CCSDS Space Packets once a packet has been completely received.
       * @param {Object} [options] Configuration options for the stream
       * @param {Number} options.timeCodeFieldLength The length of the time code field within the data
       * @param {Number} options.ancillaryDataFieldLength The length of the ancillary data field within the data
       */
      constructor(options = {}) {
        super({ ...options, objectMode: true });
        this.timeCodeFieldLength = options.timeCodeFieldLength || 0;
        this.ancillaryDataFieldLength = options.ancillaryDataFieldLength || 0;
        this.dataSlice = this.timeCodeFieldLength + this.ancillaryDataFieldLength;
        this.dataBuffer = Buffer.alloc(0);
        this.headerBuffer = Buffer.alloc(0);
        this.dataLength = 0;
        this.expectingHeader = true;
      }
      /**
       * Bundle the header, secondary header if present, and the data into a JavaScript object to emit.
       * If more data has been received past the current packet, begin the process of parsing the next
       * packet(s).
       */
      pushCompletedPacket() {
        if (!this.header) {
          throw new Error("Missing header");
        }
        const timeCode = Buffer.from(this.dataBuffer.slice(0, this.timeCodeFieldLength));
        const ancillaryData = Buffer.from(this.dataBuffer.slice(this.timeCodeFieldLength, this.timeCodeFieldLength + this.ancillaryDataFieldLength));
        const data = Buffer.from(this.dataBuffer.slice(this.dataSlice, this.dataLength));
        const completedPacket = {
          header: { ...this.header },
          data: data.toString()
        };
        if (timeCode.length > 0 || ancillaryData.length > 0) {
          completedPacket.secondaryHeader = {};
          if (timeCode.length) {
            completedPacket.secondaryHeader.timeCode = timeCode.toString();
          }
          if (ancillaryData.length) {
            completedPacket.secondaryHeader.ancillaryData = ancillaryData.toString();
          }
        }
        this.push(completedPacket);
        const nextChunk = Buffer.from(this.dataBuffer.slice(this.dataLength));
        if (nextChunk.length >= utils_1.HEADER_LENGTH) {
          this.extractHeader(nextChunk);
        } else {
          this.headerBuffer = nextChunk;
          this.dataBuffer = Buffer.alloc(0);
          this.expectingHeader = true;
          this.dataLength = 0;
          this.header = void 0;
        }
      }
      /**
       * Build the Stream's headerBuffer property from the received Buffer chunk; extract data from it
       * if it's complete. If there's more to the chunk than just the header, initiate handling the
       * packet data.
       * @param chunk -  Build the Stream's headerBuffer property from
       */
      extractHeader(chunk) {
        const headerAsBuffer = Buffer.concat([this.headerBuffer, chunk]);
        const startOfDataBuffer = headerAsBuffer.slice(utils_1.HEADER_LENGTH);
        if (headerAsBuffer.length >= utils_1.HEADER_LENGTH) {
          this.header = (0, utils_1.convertHeaderBufferToObj)(headerAsBuffer);
          this.dataLength = this.header.dataLength;
          this.headerBuffer = Buffer.alloc(0);
          this.expectingHeader = false;
        } else {
          this.headerBuffer = headerAsBuffer;
        }
        if (startOfDataBuffer.length > 0) {
          this.dataBuffer = Buffer.from(startOfDataBuffer);
          if (this.dataBuffer.length >= this.dataLength) {
            this.pushCompletedPacket();
          }
        }
      }
      _transform(chunk, encoding, cb) {
        if (this.expectingHeader) {
          this.extractHeader(chunk);
        } else {
          this.dataBuffer = Buffer.concat([this.dataBuffer, chunk]);
          if (this.dataBuffer.length >= this.dataLength) {
            this.pushCompletedPacket();
          }
        }
        cb();
      }
      _flush(cb) {
        const remaining = Buffer.concat([this.headerBuffer, this.dataBuffer]);
        const remainingArray = Array.from(remaining);
        this.push(remainingArray);
        cb();
      }
    };
    exports2.SpacePacketParser = SpacePacketParser;
  }
});

// node_modules/@serialport/stream/dist/index.js
var require_dist11 = __commonJS({
  "node_modules/@serialport/stream/dist/index.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SerialPortStream = exports2.DisconnectedError = void 0;
    var stream_1 = require("stream");
    var debug_1 = __importDefault3(require_src());
    var debug = (0, debug_1.default)("serialport/stream");
    var DisconnectedError = class extends Error {
      disconnected;
      constructor(message) {
        super(message);
        this.disconnected = true;
      }
    };
    exports2.DisconnectedError = DisconnectedError;
    var defaultSetFlags = {
      brk: false,
      cts: false,
      dtr: true,
      rts: true
    };
    function allocNewReadPool(poolSize) {
      const pool = Buffer.allocUnsafe(poolSize);
      pool.used = 0;
      return pool;
    }
    var SerialPortStream = class extends stream_1.Duplex {
      port;
      _pool;
      _kMinPoolSpace;
      opening;
      closing;
      settings;
      /**
       * Create a new serial port object for the `path`. In the case of invalid arguments or invalid options, when constructing a new SerialPort it will throw an error. The port will open automatically by default, which is the equivalent of calling `port.open(openCallback)` in the next tick. You can disable this by setting the option `autoOpen` to `false`.
       * @emits open
       * @emits data
       * @emits close
       * @emits error
       */
      constructor(options, openCallback) {
        const settings = {
          autoOpen: true,
          endOnClose: false,
          highWaterMark: 64 * 1024,
          ...options
        };
        super({
          highWaterMark: settings.highWaterMark
        });
        if (!settings.binding) {
          throw new TypeError('"Bindings" is invalid pass it as `options.binding`');
        }
        if (!settings.path) {
          throw new TypeError(`"path" is not defined: ${settings.path}`);
        }
        if (typeof settings.baudRate !== "number") {
          throw new TypeError(`"baudRate" must be a number: ${settings.baudRate}`);
        }
        this.settings = settings;
        this.opening = false;
        this.closing = false;
        this._pool = allocNewReadPool(this.settings.highWaterMark);
        this._kMinPoolSpace = 128;
        if (this.settings.autoOpen) {
          this.open(openCallback);
        }
      }
      get path() {
        return this.settings.path;
      }
      get baudRate() {
        return this.settings.baudRate;
      }
      get isOpen() {
        return (this.port?.isOpen ?? false) && !this.closing;
      }
      _error(error, callback) {
        if (callback) {
          callback.call(this, error);
        } else {
          this.emit("error", error);
        }
      }
      _asyncError(error, callback) {
        process.nextTick(() => this._error(error, callback));
      }
      /**
       * Opens a connection to the given serial port.
       * @param {ErrorCallback=} openCallback - Called after a connection is opened. If this is not provided and an error occurs, it will be emitted on the port's `error` event.
       * @emits open
       */
      open(openCallback) {
        if (this.isOpen) {
          return this._asyncError(new Error("Port is already open"), openCallback);
        }
        if (this.opening) {
          return this._asyncError(new Error("Port is opening"), openCallback);
        }
        const { highWaterMark, binding, autoOpen, endOnClose, ...openOptions } = this.settings;
        this.opening = true;
        debug("opening", `path: ${this.path}`);
        this.settings.binding.open(openOptions).then((port2) => {
          debug("opened", `path: ${this.path}`);
          this.port = port2;
          this.opening = false;
          this.emit("open");
          if (openCallback) {
            openCallback.call(this, null);
          }
        }, (err) => {
          this.opening = false;
          debug("Binding #open had an error", err);
          this._error(err, openCallback);
        });
      }
      /**
       * Changes the baud rate for an open port. Emits an error or calls the callback if the baud rate isn't supported.
       * @param {object=} options Only supports `baudRate`.
       * @param {number=} [options.baudRate] The baud rate of the port to be opened. This should match one of the commonly available baud rates, such as 110, 300, 1200, 2400, 4800, 9600, 14400, 19200, 38400, 57600, or 115200. Custom rates are supported best effort per platform. The device connected to the serial port is not guaranteed to support the requested baud rate, even if the port itself supports that baud rate.
       * @param {ErrorCallback=} [callback] Called once the port's baud rate changes. If `.update` is called without a callback, and there is an error, an error event is emitted.
       * @returns {undefined}
       */
      update(options, callback) {
        if (!this.isOpen || !this.port) {
          debug("update attempted, but port is not open");
          return this._asyncError(new Error("Port is not open"), callback);
        }
        debug("update", `baudRate: ${options.baudRate}`);
        this.port.update(options).then(() => {
          debug("binding.update", "finished");
          this.settings.baudRate = options.baudRate;
          if (callback) {
            callback.call(this, null);
          }
        }, (err) => {
          debug("binding.update", "error", err);
          return this._error(err, callback);
        });
      }
      write(data, encoding, callback) {
        if (Array.isArray(data)) {
          data = Buffer.from(data);
        }
        if (typeof encoding === "function") {
          return super.write(data, encoding);
        }
        return super.write(data, encoding, callback);
      }
      _write(data, encoding, callback) {
        if (!this.isOpen || !this.port) {
          this.once("open", () => {
            this._write(data, encoding, callback);
          });
          return;
        }
        debug("_write", `${data.length} bytes of data`);
        this.port.write(data).then(() => {
          debug("binding.write", "write finished");
          callback(null);
        }, (err) => {
          debug("binding.write", "error", err);
          if (!err.canceled) {
            this._disconnected(err);
          }
          callback(err);
        });
      }
      _writev(data, callback) {
        debug("_writev", `${data.length} chunks of data`);
        const dataV = data.map((write) => write.chunk);
        this._write(Buffer.concat(dataV), void 0, callback);
      }
      _read(bytesToRead) {
        if (!this.isOpen || !this.port) {
          debug("_read", "queueing _read for after open");
          this.once("open", () => {
            this._read(bytesToRead);
          });
          return;
        }
        if (!this._pool || this._pool.length - this._pool.used < this._kMinPoolSpace) {
          debug("_read", "discarding the read buffer pool because it is below kMinPoolSpace");
          this._pool = allocNewReadPool(this.settings.highWaterMark);
        }
        const pool = this._pool;
        const toRead = Math.min(pool.length - pool.used, bytesToRead);
        const start = pool.used;
        debug("_read", `reading`, { start, toRead });
        this.port.read(pool, start, toRead).then(({ bytesRead }) => {
          debug("binding.read", `finished`, { bytesRead });
          if (bytesRead === 0) {
            debug("binding.read", "Zero bytes read closing readable stream");
            this.push(null);
            return;
          }
          pool.used += bytesRead;
          this.push(pool.slice(start, start + bytesRead));
        }, (err) => {
          debug("binding.read", `error`, err);
          if (!err.canceled) {
            this._disconnected(err);
          }
          this._read(bytesToRead);
        });
      }
      _disconnected(err) {
        if (!this.isOpen) {
          debug("disconnected aborted because already closed", err);
          return;
        }
        debug("disconnected", err);
        this.close(void 0, new DisconnectedError(err.message));
      }
      /**
       * Closes an open connection.
       *
       * If there are in progress writes when the port is closed the writes will error.
       * @param {ErrorCallback} callback Called once a connection is closed.
       * @param {Error} disconnectError used internally to propagate a disconnect error
       */
      close(callback, disconnectError = null) {
        if (!this.isOpen || !this.port) {
          debug("close attempted, but port is not open");
          return this._asyncError(new Error("Port is not open"), callback);
        }
        this.closing = true;
        debug("#close");
        this.port.close().then(() => {
          this.closing = false;
          debug("binding.close", "finished");
          this.emit("close", disconnectError);
          if (this.settings.endOnClose) {
            this.emit("end");
          }
          if (callback) {
            callback.call(this, disconnectError);
          }
        }, (err) => {
          this.closing = false;
          debug("binding.close", "had an error", err);
          return this._error(err, callback);
        });
      }
      /**
       * Set control flags on an open port. Uses [`SetCommMask`](https://msdn.microsoft.com/en-us/library/windows/desktop/aa363257(v=vs.85).aspx) for Windows and [`ioctl`](http://linux.die.net/man/4/tty_ioctl) for OS X and Linux.
       *
       * All options are operating system default when the port is opened. Every flag is set on each call to the provided or default values. If options isn't provided default options is used.
       */
      set(options, callback) {
        if (!this.isOpen || !this.port) {
          debug("set attempted, but port is not open");
          return this._asyncError(new Error("Port is not open"), callback);
        }
        const settings = { ...defaultSetFlags, ...options };
        debug("#set", settings);
        this.port.set(settings).then(() => {
          debug("binding.set", "finished");
          if (callback) {
            callback.call(this, null);
          }
        }, (err) => {
          debug("binding.set", "had an error", err);
          return this._error(err, callback);
        });
      }
      /**
       * Returns the control flags (CTS, DSR, DCD) on the open port.
       * Uses [`GetCommModemStatus`](https://msdn.microsoft.com/en-us/library/windows/desktop/aa363258(v=vs.85).aspx) for Windows and [`ioctl`](http://linux.die.net/man/4/tty_ioctl) for mac and linux.
       */
      get(callback) {
        if (!this.isOpen || !this.port) {
          debug("get attempted, but port is not open");
          return this._asyncError(new Error("Port is not open"), callback);
        }
        debug("#get");
        this.port.get().then((status2) => {
          debug("binding.get", "finished");
          callback.call(this, null, status2);
        }, (err) => {
          debug("binding.get", "had an error", err);
          return this._error(err, callback);
        });
      }
      /**
       * Flush discards data received but not read, and written but not transmitted by the operating system. For more technical details, see [`tcflush(fd, TCIOFLUSH)`](http://linux.die.net/man/3/tcflush) for Mac/Linux and [`FlushFileBuffers`](http://msdn.microsoft.com/en-us/library/windows/desktop/aa364439) for Windows.
       */
      flush(callback) {
        if (!this.isOpen || !this.port) {
          debug("flush attempted, but port is not open");
          return this._asyncError(new Error("Port is not open"), callback);
        }
        debug("#flush");
        this.port.flush().then(() => {
          debug("binding.flush", "finished");
          if (callback) {
            callback.call(this, null);
          }
        }, (err) => {
          debug("binding.flush", "had an error", err);
          return this._error(err, callback);
        });
      }
      /**
         * Waits until all output data is transmitted to the serial port. After any pending write has completed it calls [`tcdrain()`](http://linux.die.net/man/3/tcdrain) or [FlushFileBuffers()](https://msdn.microsoft.com/en-us/library/windows/desktop/aa364439(v=vs.85).aspx) to ensure it has been written to the device.
        * @example
        Write the `data` and wait until it has finished transmitting to the target serial port before calling the callback. This will queue until the port is open and writes are finished.
      
        ```js
        function writeAndDrain (data, callback) {
          port.write(data);
          port.drain(callback);
        }
        ```
        */
      drain(callback) {
        debug("drain");
        if (!this.isOpen || !this.port) {
          debug("drain queuing on port open");
          this.once("open", () => {
            this.drain(callback);
          });
          return;
        }
        this.port.drain().then(() => {
          debug("binding.drain", "finished");
          if (callback) {
            callback.call(this, null);
          }
        }, (err) => {
          debug("binding.drain", "had an error", err);
          return this._error(err, callback);
        });
      }
    };
    exports2.SerialPortStream = SerialPortStream;
  }
});

// node_modules/@serialport/binding-mock/dist/index.js
var require_dist12 = __commonJS({
  "node_modules/@serialport/binding-mock/dist/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var debugFactory = require_src();
    function _interopDefaultLegacy(e) {
      return e && typeof e === "object" && "default" in e ? e : { "default": e };
    }
    var debugFactory__default = /* @__PURE__ */ _interopDefaultLegacy(debugFactory);
    var debug = debugFactory__default["default"]("serialport/binding-mock");
    var ports = {};
    var serialNumber = 0;
    function resolveNextTick() {
      return new Promise((resolve2) => process.nextTick(() => resolve2()));
    }
    var CanceledError = class extends Error {
      constructor(message) {
        super(message);
        this.canceled = true;
      }
    };
    var MockBinding = {
      reset() {
        ports = {};
        serialNumber = 0;
      },
      // Create a mock port
      createPort(path3, options = {}) {
        serialNumber++;
        const optWithDefaults = Object.assign({ echo: false, record: false, manufacturer: "The J5 Robotics Company", vendorId: void 0, productId: void 0, maxReadSize: 1024 }, options);
        ports[path3] = {
          data: Buffer.alloc(0),
          echo: optWithDefaults.echo,
          record: optWithDefaults.record,
          readyData: optWithDefaults.readyData,
          maxReadSize: optWithDefaults.maxReadSize,
          info: {
            path: path3,
            manufacturer: optWithDefaults.manufacturer,
            serialNumber: `${serialNumber}`,
            pnpId: void 0,
            locationId: void 0,
            vendorId: optWithDefaults.vendorId,
            productId: optWithDefaults.productId
          }
        };
        debug(serialNumber, "created port", JSON.stringify({ path: path3, opt: options }));
      },
      async list() {
        debug(null, "list");
        return Object.values(ports).map((port2) => port2.info);
      },
      async open(options) {
        var _a;
        if (!options || typeof options !== "object" || Array.isArray(options)) {
          throw new TypeError('"options" is not an object');
        }
        if (!options.path) {
          throw new TypeError('"path" is not a valid port');
        }
        if (!options.baudRate) {
          throw new TypeError('"baudRate" is not a valid baudRate');
        }
        const openOptions = Object.assign({ dataBits: 8, lock: true, stopBits: 1, parity: "none", rtscts: false, xon: false, xoff: false, xany: false, hupcl: true }, options);
        const { path: path3 } = openOptions;
        debug(null, `open: opening path ${path3}`);
        const port2 = ports[path3];
        await resolveNextTick();
        if (!port2) {
          throw new Error(`Port does not exist - please call MockBinding.createPort('${path3}') first`);
        }
        const serialNumber2 = port2.info.serialNumber;
        if ((_a = port2.openOpt) === null || _a === void 0 ? void 0 : _a.lock) {
          debug(serialNumber2, "open: Port is locked cannot open");
          throw new Error("Port is locked cannot open");
        }
        debug(serialNumber2, `open: opened path ${path3}`);
        port2.openOpt = Object.assign({}, openOptions);
        return new MockPortBinding(port2, openOptions);
      }
    };
    var MockPortBinding = class {
      constructor(port2, openOptions) {
        this.port = port2;
        this.openOptions = openOptions;
        this.pendingRead = null;
        this.isOpen = true;
        this.lastWrite = null;
        this.recording = Buffer.alloc(0);
        this.writeOperation = null;
        this.serialNumber = port2.info.serialNumber;
        if (port2.readyData) {
          const data = port2.readyData;
          process.nextTick(() => {
            if (this.isOpen) {
              debug(this.serialNumber, "emitting ready data");
              this.emitData(data);
            }
          });
        }
      }
      // Emit data on a mock port
      emitData(data) {
        if (!this.isOpen || !this.port) {
          throw new Error("Port must be open to pretend to receive data");
        }
        const bufferData = Buffer.isBuffer(data) ? data : Buffer.from(data);
        debug(this.serialNumber, "emitting data - pending read:", Boolean(this.pendingRead));
        this.port.data = Buffer.concat([this.port.data, bufferData]);
        if (this.pendingRead) {
          process.nextTick(this.pendingRead);
          this.pendingRead = null;
        }
      }
      async close() {
        debug(this.serialNumber, "close");
        if (!this.isOpen) {
          throw new Error("Port is not open");
        }
        const port2 = this.port;
        if (!port2) {
          throw new Error("already closed");
        }
        port2.openOpt = void 0;
        port2.data = Buffer.alloc(0);
        debug(this.serialNumber, "port is closed");
        this.serialNumber = void 0;
        this.isOpen = false;
        if (this.pendingRead) {
          this.pendingRead(new CanceledError("port is closed"));
        }
      }
      async read(buffer, offset, length) {
        if (!Buffer.isBuffer(buffer)) {
          throw new TypeError('"buffer" is not a Buffer');
        }
        if (typeof offset !== "number" || isNaN(offset)) {
          throw new TypeError(`"offset" is not an integer got "${isNaN(offset) ? "NaN" : typeof offset}"`);
        }
        if (typeof length !== "number" || isNaN(length)) {
          throw new TypeError(`"length" is not an integer got "${isNaN(length) ? "NaN" : typeof length}"`);
        }
        if (buffer.length < offset + length) {
          throw new Error("buffer is too small");
        }
        if (!this.isOpen) {
          throw new Error("Port is not open");
        }
        debug(this.serialNumber, "read", length, "bytes");
        await resolveNextTick();
        if (!this.isOpen || !this.port) {
          throw new CanceledError("Read canceled");
        }
        if (this.port.data.length <= 0) {
          return new Promise((resolve2, reject) => {
            this.pendingRead = (err) => {
              if (err) {
                return reject(err);
              }
              this.read(buffer, offset, length).then(resolve2, reject);
            };
          });
        }
        const lengthToRead = this.port.maxReadSize > length ? length : this.port.maxReadSize;
        const data = this.port.data.slice(0, lengthToRead);
        const bytesRead = data.copy(buffer, offset);
        this.port.data = this.port.data.slice(lengthToRead);
        debug(this.serialNumber, "read", bytesRead, "bytes");
        return { bytesRead, buffer };
      }
      async write(buffer) {
        if (!Buffer.isBuffer(buffer)) {
          throw new TypeError('"buffer" is not a Buffer');
        }
        if (!this.isOpen || !this.port) {
          debug("write", "error port is not open");
          throw new Error("Port is not open");
        }
        debug(this.serialNumber, "write", buffer.length, "bytes");
        if (this.writeOperation) {
          throw new Error("Overlapping writes are not supported and should be queued by the serialport object");
        }
        this.writeOperation = (async () => {
          await resolveNextTick();
          if (!this.isOpen || !this.port) {
            throw new Error("Write canceled");
          }
          const data = this.lastWrite = Buffer.from(buffer);
          if (this.port.record) {
            this.recording = Buffer.concat([this.recording, data]);
          }
          if (this.port.echo) {
            process.nextTick(() => {
              if (this.isOpen) {
                this.emitData(data);
              }
            });
          }
          this.writeOperation = null;
          debug(this.serialNumber, "writing finished");
        })();
        return this.writeOperation;
      }
      async update(options) {
        if (typeof options !== "object") {
          throw TypeError('"options" is not an object');
        }
        if (typeof options.baudRate !== "number") {
          throw new TypeError('"options.baudRate" is not a number');
        }
        debug(this.serialNumber, "update");
        if (!this.isOpen || !this.port) {
          throw new Error("Port is not open");
        }
        await resolveNextTick();
        if (this.port.openOpt) {
          this.port.openOpt.baudRate = options.baudRate;
        }
      }
      async set(options) {
        if (typeof options !== "object") {
          throw new TypeError('"options" is not an object');
        }
        debug(this.serialNumber, "set");
        if (!this.isOpen) {
          throw new Error("Port is not open");
        }
        await resolveNextTick();
      }
      async get() {
        debug(this.serialNumber, "get");
        if (!this.isOpen) {
          throw new Error("Port is not open");
        }
        await resolveNextTick();
        return {
          cts: true,
          dsr: false,
          dcd: false
        };
      }
      async getBaudRate() {
        var _a;
        debug(this.serialNumber, "getBaudRate");
        if (!this.isOpen || !this.port) {
          throw new Error("Port is not open");
        }
        await resolveNextTick();
        if (!((_a = this.port.openOpt) === null || _a === void 0 ? void 0 : _a.baudRate)) {
          throw new Error("Internal Error");
        }
        return {
          baudRate: this.port.openOpt.baudRate
        };
      }
      async flush() {
        debug(this.serialNumber, "flush");
        if (!this.isOpen || !this.port) {
          throw new Error("Port is not open");
        }
        await resolveNextTick();
        this.port.data = Buffer.alloc(0);
      }
      async drain() {
        debug(this.serialNumber, "drain");
        if (!this.isOpen) {
          throw new Error("Port is not open");
        }
        await this.writeOperation;
        await resolveNextTick();
      }
    };
    exports2.CanceledError = CanceledError;
    exports2.MockBinding = MockBinding;
    exports2.MockPortBinding = MockPortBinding;
  }
});

// node_modules/serialport/dist/serialport-mock.js
var require_serialport_mock = __commonJS({
  "node_modules/serialport/dist/serialport-mock.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SerialPortMock = void 0;
    var stream_1 = require_dist11();
    var binding_mock_1 = require_dist12();
    var SerialPortMock = class extends stream_1.SerialPortStream {
      static list = binding_mock_1.MockBinding.list;
      static binding = binding_mock_1.MockBinding;
      constructor(options, openCallback) {
        const opts = {
          binding: binding_mock_1.MockBinding,
          ...options
        };
        super(opts, openCallback);
      }
    };
    exports2.SerialPortMock = SerialPortMock;
  }
});

// node_modules/serialport/dist/serialport.js
var require_serialport = __commonJS({
  "node_modules/serialport/dist/serialport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SerialPort = void 0;
    var stream_1 = require_dist11();
    var bindings_cpp_1 = require("@serialport/bindings-cpp");
    var DetectedBinding = (0, bindings_cpp_1.autoDetect)();
    var SerialPort = class extends stream_1.SerialPortStream {
      static list = DetectedBinding.list;
      static binding = DetectedBinding;
      constructor(options, openCallback) {
        const opts = {
          binding: DetectedBinding,
          ...options
        };
        super(opts, openCallback);
      }
    };
    exports2.SerialPort = SerialPort;
  }
});

// node_modules/serialport/dist/index.js
var require_dist13 = __commonJS({
  "node_modules/serialport/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_dist(), exports2);
    __exportStar3(require_dist2(), exports2);
    __exportStar3(require_dist3(), exports2);
    __exportStar3(require_dist4(), exports2);
    __exportStar3(require_dist5(), exports2);
    __exportStar3(require_dist6(), exports2);
    __exportStar3(require_dist7(), exports2);
    __exportStar3(require_dist8(), exports2);
    __exportStar3(require_dist9(), exports2);
    __exportStar3(require_dist10(), exports2);
    __exportStar3(require_serialport_mock(), exports2);
    __exportStar3(require_serialport(), exports2);
  }
});

// src/crc32.js
var require_crc32 = __commonJS({
  "src/crc32.js"(exports2, module2) {
    var Buffer2 = require("buffer").Buffer;
    var CRC_TABLE = [
      0,
      1996959894,
      3993919788,
      2567524794,
      124634137,
      1886057615,
      3915621685,
      2657392035,
      249268274,
      2044508324,
      3772115230,
      2547177864,
      162941995,
      2125561021,
      3887607047,
      2428444049,
      498536548,
      1789927666,
      4089016648,
      2227061214,
      450548861,
      1843258603,
      4107580753,
      2211677639,
      325883990,
      1684777152,
      4251122042,
      2321926636,
      335633487,
      1661365465,
      4195302755,
      2366115317,
      997073096,
      1281953886,
      3579855332,
      2724688242,
      1006888145,
      1258607687,
      3524101629,
      2768942443,
      901097722,
      1119000684,
      3686517206,
      2898065728,
      853044451,
      1172266101,
      3705015759,
      2882616665,
      651767980,
      1373503546,
      3369554304,
      3218104598,
      565507253,
      1454621731,
      3485111705,
      3099436303,
      671266974,
      1594198024,
      3322730930,
      2970347812,
      795835527,
      1483230225,
      3244367275,
      3060149565,
      1994146192,
      31158534,
      2563907772,
      4023717930,
      1907459465,
      112637215,
      2680153253,
      3904427059,
      2013776290,
      251722036,
      2517215374,
      3775830040,
      2137656763,
      141376813,
      2439277719,
      3865271297,
      1802195444,
      476864866,
      2238001368,
      4066508878,
      1812370925,
      453092731,
      2181625025,
      4111451223,
      1706088902,
      314042704,
      2344532202,
      4240017532,
      1658658271,
      366619977,
      2362670323,
      4224994405,
      1303535960,
      984961486,
      2747007092,
      3569037538,
      1256170817,
      1037604311,
      2765210733,
      3554079995,
      1131014506,
      879679996,
      2909243462,
      3663771856,
      1141124467,
      855842277,
      2852801631,
      3708648649,
      1342533948,
      654459306,
      3188396048,
      3373015174,
      1466479909,
      544179635,
      3110523913,
      3462522015,
      1591671054,
      702138776,
      2966460450,
      3352799412,
      1504918807,
      783551873,
      3082640443,
      3233442989,
      3988292384,
      2596254646,
      62317068,
      1957810842,
      3939845945,
      2647816111,
      81470997,
      1943803523,
      3814918930,
      2489596804,
      225274430,
      2053790376,
      3826175755,
      2466906013,
      167816743,
      2097651377,
      4027552580,
      2265490386,
      503444072,
      1762050814,
      4150417245,
      2154129355,
      426522225,
      1852507879,
      4275313526,
      2312317920,
      282753626,
      1742555852,
      4189708143,
      2394877945,
      397917763,
      1622183637,
      3604390888,
      2714866558,
      953729732,
      1340076626,
      3518719985,
      2797360999,
      1068828381,
      1219638859,
      3624741850,
      2936675148,
      906185462,
      1090812512,
      3747672003,
      2825379669,
      829329135,
      1181335161,
      3412177804,
      3160834842,
      628085408,
      1382605366,
      3423369109,
      3138078467,
      570562233,
      1426400815,
      3317316542,
      2998733608,
      733239954,
      1555261956,
      3268935591,
      3050360625,
      752459403,
      1541320221,
      2607071920,
      3965973030,
      1969922972,
      40735498,
      2617837225,
      3943577151,
      1913087877,
      83908371,
      2512341634,
      3803740692,
      2075208622,
      213261112,
      2463272603,
      3855990285,
      2094854071,
      198958881,
      2262029012,
      4057260610,
      1759359992,
      534414190,
      2176718541,
      4139329115,
      1873836001,
      414664567,
      2282248934,
      4279200368,
      1711684554,
      285281116,
      2405801727,
      4167216745,
      1634467795,
      376229701,
      2685067896,
      3608007406,
      1308918612,
      956543938,
      2808555105,
      3495958263,
      1231636301,
      1047427035,
      2932959818,
      3654703836,
      1088359270,
      936918e3,
      2847714899,
      3736837829,
      1202900863,
      817233897,
      3183342108,
      3401237130,
      1404277552,
      615818150,
      3134207493,
      3453421203,
      1423857449,
      601450431,
      3009837614,
      3294710456,
      1567103746,
      711928724,
      3020668471,
      3272380065,
      1510334235,
      755167117
    ];
    if (typeof Int32Array !== "undefined") {
      CRC_TABLE = new Int32Array(CRC_TABLE);
    }
    function newEmptyBuffer(length) {
      var buffer = new Buffer2(length);
      buffer.fill(0);
      return buffer;
    }
    function ensureBuffer(input) {
      if (Buffer2.isBuffer(input)) {
        return input;
      }
      var hasNewBufferAPI = typeof Buffer2.alloc === "function" && typeof Buffer2.from === "function";
      if (typeof input === "number") {
        return hasNewBufferAPI ? Buffer2.alloc(input) : newEmptyBuffer(input);
      } else if (typeof input === "string") {
        return hasNewBufferAPI ? Buffer2.from(input) : new Buffer2(input);
      } else {
        throw new Error("input must be buffer, number, or string, received " + typeof input);
      }
    }
    function bufferizeInt(num) {
      var tmp = ensureBuffer(4);
      tmp.writeInt32BE(num, 0);
      return tmp;
    }
    function _crc32(buf, previous) {
      buf = ensureBuffer(buf);
      if (Buffer2.isBuffer(previous)) {
        previous = previous.readUInt32BE(0);
      }
      var crc = ~~previous ^ -1;
      for (var n = 0; n < buf.length; n++) {
        crc = CRC_TABLE[(crc ^ buf[n]) & 255] ^ crc >>> 8;
      }
      return crc ^ -1;
    }
    function crc32() {
      return bufferizeInt(_crc32.apply(null, arguments));
    }
    crc32.signed = function() {
      return _crc32.apply(null, arguments);
    };
    crc32.unsigned = function() {
      return _crc32.apply(null, arguments) >>> 0;
    };
    module2.exports = crc32;
  }
});

// src/nrfusbdfu.js
var require_nrfusbdfu = __commonJS({
  "src/nrfusbdfu.js"(exports2, module2) {
    "use strict";
    var axios = require_axios2();
    var gwutils2 = require_gwutils();
    var Buffer2 = require("buffer").Buffer;
    var crc32 = require_crc32();
    var path3 = require("path");
    var { SerialPort } = require_dist13();
    var { SlipEncoder, SlipDecoder } = require_dist9();
    var fs2 = require("fs").promises;
    var DFU_REQUEST_CREATE = 1;
    var DFU_REQUEST_SET_RECEIPT_NOTIFICATION = 2;
    var DFU_REQUEST_CALCULATE_CRC = 3;
    var DFU_REQUEST_EXECUTE = 4;
    var DFU_REQUEST_SELECT = 6;
    var DFU_REQUEST_GET_MTU = 7;
    var DFU_REQUEST_WRITE = 8;
    var TRANSFER_TYPE_INIT_PACKET = 1;
    var TRANSFER_TYPE_FIRMWARE = 2;
    var nrfUSBDFU = class _nrfUSBDFU {
      static sendCommand(data, donotwait) {
        if (!donotwait) {
          let connectionPromise = new Promise((resolve2, reject) => {
            this.commandResolve = resolve2;
          });
          this.encoder.write(data);
          return connectionPromise;
        } else {
          this.encoder.write(data);
          return true;
        }
      }
      static async update(gwGlobalState, port2) {
        this.gwGlobalState = gwGlobalState;
        this.gwGlobalState.deviceInfo.state = {
          action: "flashingble",
          state: "opening",
          progress: 0
        };
        return new Promise((resolve2, reject) => {
          this.port = new SerialPort({
            path: port2,
            baudRate: 57600
          });
          this.encoder = new SlipEncoder();
          this.encoder.pipe(this.port);
          const parser = this.port.pipe(new SlipDecoder());
          let updateTimeout = setTimeout(() => reject(), 5e3);
          parser.on("data", (data) => {
            if (this.commandResolve)
              this.commandResolve(data);
          });
          this.port.on("open", async () => {
            console.log("port open");
            clearTimeout(updateTimeout);
            await _nrfUSBDFU.startUpdate();
            delete gwGlobalState.deviceInfo.state;
            resolve2();
          });
        });
      }
      static async startUpdate() {
        let response = null;
        this.gwGlobalState.deviceInfo.state.state = "transfering";
        response = await _nrfUSBDFU.sendCommand(Buffer2.from([DFU_REQUEST_SET_RECEIPT_NOTIFICATION, 0, 0]));
        response = await _nrfUSBDFU.sendCommand(Buffer2.from([DFU_REQUEST_GET_MTU]));
        let mtu = response.readUInt16LE(3);
        const firmware = await fs2.readFile(path3.join("fw", "gwfw.bin"));
        const ini = await fs2.readFile(path3.join("fw", "gwfw.dat"));
        if (response) {
          response = await this.#transfer(ini, TRANSFER_TYPE_INIT_PACKET);
        }
        if (response) {
          response = await this.#transfer(firmware, TRANSFER_TYPE_FIRMWARE);
        }
      }
      static async #CreateObject(size, type) {
        let createCommand = Buffer2.from([DFU_REQUEST_CREATE, type, 0, 0, 0, 0]);
        createCommand.writeUInt32LE(size, 2);
        return await this.sendCommand(createCommand);
      }
      static async #transfer_object(obj_size, offset, mtu, file_bytes, transferType) {
        let transfer_pos = 0;
        while (transfer_pos < obj_size && !this.m_abort) {
          let packet_size = mtu;
          if (obj_size - transfer_pos < mtu) {
            packet_size = obj_size - transfer_pos;
          }
          let subbuffer = Buffer2.alloc(packet_size + 1);
          subbuffer[0] = DFU_REQUEST_WRITE;
          file_bytes.copy(subbuffer, 1, transfer_pos + offset, transfer_pos + offset + packet_size);
          let status2 = false;
          try {
            status2 = await this.sendCommand(subbuffer, true);
          } catch (e) {
            console.log("Error!!!!!!!!!!!!!!!!!!!!!", e);
            this.m_abort = true;
          }
          if (!status2 || this.m_abort) {
            console.log("WriteValueAsync Failed ", status2);
            break;
          }
          transfer_pos += packet_size;
          if (transferType == TRANSFER_TYPE_FIRMWARE) {
            let progress = 0;
            if (transfer_pos + offset != 0)
              progress = (transfer_pos + offset) / file_bytes.length;
            this.gwGlobalState.deviceInfo.progress = progress;
          }
        }
      }
      static async #transfer(file_bytes, type) {
        let response = false;
        let mtu = 244;
        let max_object_size = 0;
        let offset = 0;
        let crc = 0;
        let success = false;
        try {
          response = await this.sendCommand(Buffer2.from([DFU_REQUEST_SELECT, type]));
          if (response == null || response[2] != 1) {
            console.log("-----------------> Error when selecting firmware  ", response);
            return false;
          }
          max_object_size = response.readUInt32LE(3);
          offset = response.readUInt32LE(7);
          crc = response.readUInt32LE(11);
          let transfered = 0;
          let retries = 0;
          do {
            let obj_size = file_bytes.length - transfered;
            if (obj_size > max_object_size)
              obj_size = max_object_size;
            response = await this.#CreateObject(obj_size, type);
            if (response == null || response[2] != 1) {
              console.log("-----------------> Error when creating object ", response);
              return false;
            }
            await this.#transfer_object(obj_size, transfered, mtu, file_bytes, type);
            response = await this.sendCommand(Buffer2.from([DFU_REQUEST_CALCULATE_CRC]));
            if (response == null || response[2] != 1) {
              console.log("-----------------> Error when calculating crc", response);
              return false;
            }
            offset = response.readUInt32LE(3);
            crc = response.readUInt32LE(7);
            let segment = file_bytes.subarray(0, offset);
            let expected_crc = crc32.unsigned(segment);
            if (expected_crc != crc) {
              console.log("---------------------------------------> CRC32 unexpected", crc, "!=", expected_crc, "retries", retries);
              retries++;
              if (retries > 5)
                return false;
              else
                continue;
            } else {
              retries = 0;
            }
            transfered = offset;
            response = await this.sendCommand(Buffer2.from([DFU_REQUEST_EXECUTE]));
            if (response == null || response[2] != 1) {
              console.log("--------------------------------------> Error when executing ", response);
              return false;
            }
          } while (transfered < file_bytes.length && !this.m_abort);
          success = true;
        } catch (e) {
          success = false;
          console.log("-----------------> EI Error ", e);
        }
        return success;
      }
    };
    module2.exports = {
      nrfUSBDFU
    };
  }
});

// node_modules/lodash.debounce/index.js
var require_lodash = __commonJS({
  "node_modules/lodash.debounce/index.js"(exports2, module2) {
    var FUNC_ERROR_TEXT = "Expected a function";
    var NAN = 0 / 0;
    var symbolTag = "[object Symbol]";
    var reTrim = /^\s+|\s+$/g;
    var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
    var reIsBinary = /^0b[01]+$/i;
    var reIsOctal = /^0o[0-7]+$/i;
    var freeParseInt = parseInt;
    var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
    var freeSelf = typeof self == "object" && self && self.Object === Object && self;
    var root = freeGlobal || freeSelf || Function("return this")();
    var objectProto = Object.prototype;
    var objectToString = objectProto.toString;
    var nativeMax = Math.max;
    var nativeMin = Math.min;
    var now = function() {
      return root.Date.now();
    };
    function debounce(func, wait, options) {
      var lastArgs, lastThis, maxWait, result2, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
      if (typeof func != "function") {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      wait = toNumber(wait) || 0;
      if (isObject(options)) {
        leading = !!options.leading;
        maxing = "maxWait" in options;
        maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
        trailing = "trailing" in options ? !!options.trailing : trailing;
      }
      function invokeFunc(time) {
        var args = lastArgs, thisArg = lastThis;
        lastArgs = lastThis = void 0;
        lastInvokeTime = time;
        result2 = func.apply(thisArg, args);
        return result2;
      }
      function leadingEdge(time) {
        lastInvokeTime = time;
        timerId = setTimeout(timerExpired, wait);
        return leading ? invokeFunc(time) : result2;
      }
      function remainingWait(time) {
        var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, result3 = wait - timeSinceLastCall;
        return maxing ? nativeMin(result3, maxWait - timeSinceLastInvoke) : result3;
      }
      function shouldInvoke(time) {
        var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
        return lastCallTime === void 0 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
      }
      function timerExpired() {
        var time = now();
        if (shouldInvoke(time)) {
          return trailingEdge(time);
        }
        timerId = setTimeout(timerExpired, remainingWait(time));
      }
      function trailingEdge(time) {
        timerId = void 0;
        if (trailing && lastArgs) {
          return invokeFunc(time);
        }
        lastArgs = lastThis = void 0;
        return result2;
      }
      function cancel() {
        if (timerId !== void 0) {
          clearTimeout(timerId);
        }
        lastInvokeTime = 0;
        lastArgs = lastCallTime = lastThis = timerId = void 0;
      }
      function flush() {
        return timerId === void 0 ? result2 : trailingEdge(now());
      }
      function debounced() {
        var time = now(), isInvoking = shouldInvoke(time);
        lastArgs = arguments;
        lastThis = this;
        lastCallTime = time;
        if (isInvoking) {
          if (timerId === void 0) {
            return leadingEdge(lastCallTime);
          }
          if (maxing) {
            timerId = setTimeout(timerExpired, wait);
            return invokeFunc(lastCallTime);
          }
        }
        if (timerId === void 0) {
          timerId = setTimeout(timerExpired, wait);
        }
        return result2;
      }
      debounced.cancel = cancel;
      debounced.flush = flush;
      return debounced;
    }
    function isObject(value) {
      var type = typeof value;
      return !!value && (type == "object" || type == "function");
    }
    function isObjectLike(value) {
      return !!value && typeof value == "object";
    }
    function isSymbol(value) {
      return typeof value == "symbol" || isObjectLike(value) && objectToString.call(value) == symbolTag;
    }
    function toNumber(value) {
      if (typeof value == "number") {
        return value;
      }
      if (isSymbol(value)) {
        return NAN;
      }
      if (isObject(value)) {
        var other = typeof value.valueOf == "function" ? value.valueOf() : value;
        value = isObject(other) ? other + "" : other;
      }
      if (typeof value != "string") {
        return value === 0 ? value : +value;
      }
      value = value.replace(reTrim, "");
      var isBinary = reIsBinary.test(value);
      return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
    }
    module2.exports = debounce;
  }
});

// node_modules/file-uri-to-path/index.js
var require_file_uri_to_path = __commonJS({
  "node_modules/file-uri-to-path/index.js"(exports2, module2) {
    var sep = require("path").sep || "/";
    module2.exports = fileUriToPath;
    function fileUriToPath(uri) {
      if ("string" != typeof uri || uri.length <= 7 || "file://" != uri.substring(0, 7)) {
        throw new TypeError("must pass in a file:// URI to convert to a file path");
      }
      var rest = decodeURI(uri.substring(7));
      var firstSlash = rest.indexOf("/");
      var host = rest.substring(0, firstSlash);
      var path3 = rest.substring(firstSlash + 1);
      if ("localhost" == host)
        host = "";
      if (host) {
        host = sep + sep + host;
      }
      path3 = path3.replace(/^(.+)\|/, "$1:");
      if (sep == "\\") {
        path3 = path3.replace(/\//g, "\\");
      }
      if (/^.+\:/.test(path3)) {
      } else {
        path3 = sep + path3;
      }
      return host + path3;
    }
  }
});

// node_modules/bindings/bindings.js
var require_bindings = __commonJS({
  "node_modules/bindings/bindings.js"(exports2, module2) {
    var fs2 = require("fs");
    var path3 = require("path");
    var fileURLToPath = require_file_uri_to_path();
    var join2 = path3.join;
    var dirname = path3.dirname;
    var exists = fs2.accessSync && function(path4) {
      try {
        fs2.accessSync(path4);
      } catch (e) {
        return false;
      }
      return true;
    } || fs2.existsSync || path3.existsSync;
    var defaults = {
      arrow: process.env.NODE_BINDINGS_ARROW || " \u2192 ",
      compiled: process.env.NODE_BINDINGS_COMPILED_DIR || "compiled",
      platform: process.platform,
      arch: process.arch,
      nodePreGyp: "node-v" + process.versions.modules + "-" + process.platform + "-" + process.arch,
      version: process.versions.node,
      bindings: "bindings.node",
      try: [
        // node-gyp's linked version in the "build" dir
        ["module_root", "build", "bindings"],
        // node-waf and gyp_addon (a.k.a node-gyp)
        ["module_root", "build", "Debug", "bindings"],
        ["module_root", "build", "Release", "bindings"],
        // Debug files, for development (legacy behavior, remove for node v0.9)
        ["module_root", "out", "Debug", "bindings"],
        ["module_root", "Debug", "bindings"],
        // Release files, but manually compiled (legacy behavior, remove for node v0.9)
        ["module_root", "out", "Release", "bindings"],
        ["module_root", "Release", "bindings"],
        // Legacy from node-waf, node <= 0.4.x
        ["module_root", "build", "default", "bindings"],
        // Production "Release" buildtype binary (meh...)
        ["module_root", "compiled", "version", "platform", "arch", "bindings"],
        // node-qbs builds
        ["module_root", "addon-build", "release", "install-root", "bindings"],
        ["module_root", "addon-build", "debug", "install-root", "bindings"],
        ["module_root", "addon-build", "default", "install-root", "bindings"],
        // node-pre-gyp path ./lib/binding/{node_abi}-{platform}-{arch}
        ["module_root", "lib", "binding", "nodePreGyp", "bindings"]
      ]
    };
    function bindings(opts) {
      if (typeof opts == "string") {
        opts = { bindings: opts };
      } else if (!opts) {
        opts = {};
      }
      Object.keys(defaults).map(function(i2) {
        if (!(i2 in opts))
          opts[i2] = defaults[i2];
      });
      if (!opts.module_root) {
        opts.module_root = exports2.getRoot(exports2.getFileName());
      }
      if (path3.extname(opts.bindings) != ".node") {
        opts.bindings += ".node";
      }
      var requireFunc = typeof __webpack_require__ === "function" ? __non_webpack_require__ : require;
      var tries = [], i = 0, l2 = opts.try.length, n, b, err;
      for (; i < l2; i++) {
        n = join2.apply(
          null,
          opts.try[i].map(function(p3) {
            return opts[p3] || p3;
          })
        );
        tries.push(n);
        try {
          b = opts.path ? requireFunc.resolve(n) : requireFunc(n);
          if (!opts.path) {
            b.path = n;
          }
          return b;
        } catch (e) {
          if (e.code !== "MODULE_NOT_FOUND" && e.code !== "QUALIFIED_PATH_RESOLUTION_FAILED" && !/not find/i.test(e.message)) {
            throw e;
          }
        }
      }
      err = new Error(
        "Could not locate the bindings file. Tried:\n" + tries.map(function(a) {
          return opts.arrow + a;
        }).join("\n")
      );
      err.tries = tries;
      throw err;
    }
    module2.exports = exports2 = bindings;
    exports2.getFileName = function getFileName(calling_file) {
      var origPST = Error.prepareStackTrace, origSTL = Error.stackTraceLimit, dummy = {}, fileName;
      Error.stackTraceLimit = 10;
      Error.prepareStackTrace = function(e, st) {
        for (var i = 0, l2 = st.length; i < l2; i++) {
          fileName = st[i].getFileName();
          if (fileName !== __filename) {
            if (calling_file) {
              if (fileName !== calling_file) {
                return;
              }
            } else {
              return;
            }
          }
        }
      };
      Error.captureStackTrace(dummy);
      dummy.stack;
      Error.prepareStackTrace = origPST;
      Error.stackTraceLimit = origSTL;
      var fileSchema = "file://";
      if (fileName.indexOf(fileSchema) === 0) {
        fileName = fileURLToPath(fileName);
      }
      return fileName;
    };
    exports2.getRoot = function getRoot(file) {
      var dir = dirname(file), prev;
      while (true) {
        if (dir === ".") {
          dir = process.cwd();
        }
        if (exists(join2(dir, "package.json")) || exists(join2(dir, "node_modules"))) {
          return dir;
        }
        if (prev === dir) {
          throw new Error(
            'Could not find module root given file: "' + file + '". Do you have a `package.json` file? '
          );
        }
        prev = dir;
        dir = join2(dir, "..");
      }
    };
  }
});

// node_modules/epoll/epoll.js
var require_epoll = __commonJS({
  "node_modules/epoll/epoll.js"(exports2, module2) {
    "use strict";
    module2.exports = ((_) => {
      const osType = require("os").type();
      if (osType === "Linux") {
        return require_bindings()("epoll.node");
      }
      console.warn(`Warning: epoll is built for Linux and not intended for usage on ${osType}.`);
      return {
        Epoll: {}
      };
    })();
  }
});

// node_modules/onoff/onoff.js
var require_onoff = __commonJS({
  "node_modules/onoff/onoff.js"(exports2, module2) {
    "use strict";
    var fs2 = require("fs");
    var debounce = require_lodash();
    var Epoll = require_epoll().Epoll;
    var GPIO_ROOT_PATH = "/sys/class/gpio/";
    var HIGH_BUF = Buffer.from("1");
    var LOW_BUF = Buffer.from("0");
    var HIGH = 1;
    var LOW = 0;
    var exportGpio = (gpio2) => {
      if (!fs2.existsSync(gpio2._gpioPath)) {
        fs2.writeFileSync(GPIO_ROOT_PATH + "export", "" + gpio2._gpio);
        return false;
      }
      return true;
    };
    var waitForGpioAccessPermission = (gpio2, direction, edge, gpioPreviouslyExported) => {
      let permissionRequiredPaths = [
        gpio2._gpioPath + "value"
      ];
      if (gpioPreviouslyExported === false) {
        permissionRequiredPaths.push(gpio2._gpioPath + "direction");
        permissionRequiredPaths.push(gpio2._gpioPath + "active_low");
        if (edge && direction === "in") {
          permissionRequiredPaths.push(gpio2._gpioPath + "edge");
        }
      }
      permissionRequiredPaths.forEach((path3) => {
        let tries = 0;
        while (true) {
          try {
            tries += 1;
            const fd = fs2.openSync(path3, "r+");
            fs2.closeSync(fd);
            break;
          } catch (e) {
            if (tries === 1e4) {
              throw e;
            }
          }
        }
      });
    };
    var configureGpio = (gpio2, direction, edge, options, gpioPreviouslyExported) => {
      const throwIfNeeded = (err) => {
        if (gpioPreviouslyExported === false) {
          throw err;
        }
      };
      try {
        if (typeof options.activeLow === "boolean") {
          gpio2.setActiveLow(options.activeLow);
        }
      } catch (err) {
        throwIfNeeded(err);
      }
      try {
        const reconfigureDirection = typeof options.reconfigureDirection === "boolean" ? options.reconfigureDirection : true;
        const requestedDirection = direction === "high" || direction === "low" ? "out" : direction;
        if (reconfigureDirection || gpio2.direction() !== requestedDirection) {
          gpio2.setDirection(direction);
        }
      } catch (err) {
        throwIfNeeded(err);
      }
      try {
        if (edge && direction === "in") {
          gpio2.setEdge(edge);
        }
      } catch (err) {
        throwIfNeeded(err);
      }
    };
    var configureInterruptHandler = (gpio2) => {
      const pollerEventHandler = (err, fd, events) => {
        const value = gpio2.readSync();
        if (value === LOW && gpio2._fallingEnabled || value === HIGH && gpio2._risingEnabled) {
          gpio2._listeners.slice(0).forEach((callback) => {
            callback(err, value);
          });
        }
      };
      gpio2.readSync();
      if (gpio2._debounceTimeout > 0) {
        const db2 = debounce(pollerEventHandler, gpio2._debounceTimeout);
        gpio2._poller = new Epoll((err, fd, events) => {
          gpio2.readSync();
          db2(err, fd, events);
        });
      } else {
        gpio2._poller = new Epoll(pollerEventHandler);
      }
    };
    var Gpio = class {
      constructor(gpio2, direction, edge, options) {
        if (typeof edge === "object" && !options) {
          options = edge;
          edge = void 0;
        }
        options = options || {};
        this._gpio = gpio2;
        this._gpioPath = GPIO_ROOT_PATH + "gpio" + this._gpio + "/";
        this._debounceTimeout = options.debounceTimeout || 0;
        this._readBuffer = Buffer.alloc(16);
        this._readSyncBuffer = Buffer.alloc(16);
        this._listeners = [];
        const gpioPreviouslyExported = exportGpio(this);
        waitForGpioAccessPermission(
          this,
          direction,
          edge,
          gpioPreviouslyExported
        );
        configureGpio(this, direction, edge, options, gpioPreviouslyExported);
        this._valueFd = fs2.openSync(this._gpioPath + "value", "r+");
        configureInterruptHandler(this);
      }
      read(callback) {
        const readValue = (callback2) => {
          fs2.read(this._valueFd, this._readBuffer, 0, 1, 0, (err, bytes, buf) => {
            if (typeof callback2 === "function") {
              if (err) {
                return callback2(err);
              }
              callback2(null, convertBufferToBit(buf));
            }
          });
        };
        if (callback) {
          readValue(callback);
        } else {
          return new Promise((resolve2, reject) => {
            readValue((err, value) => {
              if (err) {
                reject(err);
              } else {
                resolve2(value);
              }
            });
          });
        }
      }
      readSync() {
        fs2.readSync(this._valueFd, this._readSyncBuffer, 0, 1, 0);
        return convertBufferToBit(this._readSyncBuffer);
      }
      write(value, callback) {
        const writeValue = (value2, callback2) => {
          const writeBuffer = convertBitToBuffer(value2);
          fs2.write(
            this._valueFd,
            writeBuffer,
            0,
            writeBuffer.length,
            0,
            callback2
          );
        };
        if (callback) {
          writeValue(value, callback);
        } else {
          return new Promise((resolve2, reject) => {
            writeValue(value, (err) => {
              if (err) {
                reject(err);
              } else {
                resolve2();
              }
            });
          });
        }
      }
      writeSync(value) {
        const writeBuffer = convertBitToBuffer(value);
        fs2.writeSync(this._valueFd, writeBuffer, 0, writeBuffer.length, 0);
      }
      watch(callback) {
        this._listeners.push(callback);
        if (this._listeners.length === 1) {
          this._poller.add(this._valueFd, Epoll.EPOLLPRI);
        }
      }
      unwatch(callback) {
        if (this._listeners.length > 0) {
          if (typeof callback !== "function") {
            this._listeners = [];
          } else {
            this._listeners = this._listeners.filter((listener) => {
              return callback !== listener;
            });
          }
          if (this._listeners.length === 0) {
            this._poller.remove(this._valueFd);
          }
        }
      }
      unwatchAll() {
        this.unwatch();
      }
      direction() {
        return fs2.readFileSync(this._gpioPath + "direction").toString().trim();
      }
      setDirection(direction) {
        fs2.writeFileSync(this._gpioPath + "direction", direction);
      }
      edge() {
        return fs2.readFileSync(this._gpioPath + "edge").toString().trim();
      }
      setEdge(edge) {
        fs2.writeFileSync(this._gpioPath + "edge", edge);
        this._risingEnabled = edge === "both" || edge === "rising";
        this._fallingEnabled = edge === "both" || edge === "falling";
      }
      activeLow() {
        return convertBufferToBoolean(
          fs2.readFileSync(this._gpioPath + "active_low")
        );
      }
      setActiveLow(invert) {
        fs2.writeFileSync(
          this._gpioPath + "active_low",
          convertBooleanToBuffer(!!invert)
        );
      }
      unexport() {
        this.unwatchAll();
        fs2.closeSync(this._valueFd);
        try {
          fs2.writeFileSync(GPIO_ROOT_PATH + "unexport", "" + this._gpio);
        } catch (ignore) {
        }
      }
      static get accessible() {
        let fd;
        try {
          fd = fs2.openSync(GPIO_ROOT_PATH + "export", fs2.constants.O_WRONLY);
        } catch (e) {
          return false;
        } finally {
          if (fd) {
            fs2.closeSync(fd);
          }
        }
        return true;
      }
    };
    var convertBitToBuffer = (bit) => convertBooleanToBuffer(bit === HIGH);
    var convertBufferToBit = (buffer) => convertBufferToBoolean(buffer) ? HIGH : LOW;
    var convertBooleanToBuffer = (boolean) => boolean ? HIGH_BUF : LOW_BUF;
    var convertBufferToBoolean = (buffer) => buffer[0] === HIGH_BUF[0];
    Gpio.HIGH = HIGH;
    Gpio.LOW = LOW;
    module2.exports.Gpio = Gpio;
  }
});

// src/gpio.js
var require_gpio = __commonJS({
  "src/gpio.js"(exports2, module2) {
    "use strict";
    var gwutils2 = require_gwutils();
    var Gpio = require_onoff().Gpio;
    var led1_pin = 0;
    var button2_pin = 199;
    var nrf_reset_pin = 15;
    var blinking = false;
    var nrfReset = null;
    async function init2(gwGlobalState) {
      let led1 = new Gpio(led1_pin, "out");
      nrfReset = new Gpio(nrf_reset_pin, "out");
      const button = new Gpio(button2_pin, "in", "both", { debounceTimeout: 100 });
      let longPressTimeout = null;
      let longerPressTimeout = null;
      let basicResetDone = false;
      button.watch(async (err, value) => {
        if (value == 0) {
          longPressTimeout = setTimeout(async () => {
            longPressTimeout = null;
            await gwutils2.gwResetBasicConfig();
            gwutils2.broadcastEvent("showscreen", {
              lines: [
                "Basic config reset",
                "Keep pressing to",
                "restore to factory"
              ]
            });
            basicResetDone = true;
            longerPressTimeout = setTimeout(async () => {
              longerPressTimeout = null;
              console.log("Factory reset!!");
              gwutils2.broadcastEvent("showscreen", {
                lines: [
                  "Factory reseting"
                ]
              });
              await gwutils2.gwFactoryReset();
              gwutils2.broadcastEvent("showscreen", {
                lines: [
                  "Factory reset"
                ]
              });
              basicResetDone = false;
            }, 1e4);
          }, 5e3);
        } else {
          if (longPressTimeout)
            clearTimeout(longPressTimeout);
          if (longerPressTimeout)
            clearTimeout(longerPressTimeout);
          if (basicResetDone) {
            gwutils2.broadcastEvent("showscreen", {
              lines: null
            });
            setTimeout(async () => {
              await gwutils2.reboot();
            }, 2e3);
          }
        }
      });
      gwutils2.subscribeToEvent("seensensor", async (e) => {
        if (!blinking) {
          blinking = true;
          await led1.write(1);
          setTimeout(async () => {
            await led1.write(0);
            blinking = false;
          }, 10);
        }
      });
    }
    async function resetNRF() {
      if (process.platform == "linux" && false) {
        await nrfReset.write(0);
        await gwutils2.sleep(200);
        await nrfReset.write(1);
      }
    }
    module2.exports = {
      init: init2,
      resetNRF
    };
  }
});

// src/nrf_ble.js
var require_nrf_ble = __commonJS({
  "src/nrf_ble.js"(exports2, module2) {
    "use strict";
    var workers = require("node:worker_threads");
    if (!workers.isMainThread)
      return;
    var Buffer2 = require("buffer").Buffer;
    var { SerialPort } = require_dist13();
    var nrfusbdfu = require_nrfusbdfu().nrfUSBDFU;
    var gpio2 = require_gpio();
    if (process.versions.node.split(".")[0] >= 16)
      var { ByteLengthParser } = require_dist();
    else
      var ByteLengthParser = require_dist();
    var gwutils2 = require_gwutils();
    var COMPATIBLE_BLE_VERSION = 27;
    var ENANO_SPI_TEMPERATURE = 5;
    var ENANO_SPI_YOUR_ID = 7;
    var ENANO_SPI_ADV_REPORT = 14;
    var ENANO_SPI_BLE_CONNECTED = 15;
    var ENANO_SPI_BLE_DISCONNECTED = 16;
    var ENANO_SPI_BLE_CONNECT_ERR = 17;
    var ENANO_SPI_BLE_CONNECT_TIMEOUT = 18;
    var ENANO_SPI_BLE_RX_DATA = 19;
    var ENANO_SPI_BLE_WRITE_ERR = 20;
    var ENANO_SPI_BLE_ENABLE_NOTIF_ERR = 21;
    var ENANO_SPI_BLEWRITE_RESPONSE = 22;
    var ENANO_SPI_WRITE_COMPLETED = 23;
    var ENANO_SPI_CONN_SEC_UPDATE = 24;
    var ENANO_SPI_BLE_MTU_RSP = 25;
    var ENANO_SPI_QOS_SURVEY_REPORT = 32;
    var ENANO_SPI_WHATS_MY_ID = 129;
    var ENANO_SPI_RESTART = 133;
    var ENANO_SPI_ENTER_DFU = 136;
    var ENANO_SPI_BLE_CONNECT_TO = 137;
    var ENANO_SPI_BLE_WRITE = 138;
    var ENANO_SPI_BLE_ENABLE_NOTIF = 139;
    var ENANO_SPI_BLE_DISCONNECT = 140;
    var ENANO_SPI_BLE_WRITE_WITHOURSP = 141;
    var ENANO_SPI_BLE_START_SCANNING = 142;
    var ENANO_SPI_BLE_ENCRYPT = 143;
    var ENANO_SPI_BLE_AUTHENTICATE = 144;
    var ENANO_SPI_GET_TEMPERATURE = 145;
    var ENANO_SPI_TEST_ADVERTISE = 146;
    var ENANO_SPI_SYNC_BROADCAST = 147;
    var ENANO_SPI_START_CHANNEL_SURVEY = 149;
    var BLE_GAP_AD_TYPE_FLAGS = 1;
    var BLE_GAP_AD_TYPE_TX_POWER_LEVEL = 10;
    var BLE_GAP_AD_TYPE_COMPLETE_LOCAL_NAME = 9;
    var BLE_GAP_AD_TYPE_MANUFACTURER_SPECIFIC_DATA = 255;
    var NRF_ERRORS = {
      NRF_ERROR_SUCCESS: 0,
      NRF_ERROR_DATA_SIZE: 12,
      NRF_ERROR_BUSY: 17,
      NRF_ERROR_RESOURCES: 19
    };
    var nrfPacketSize = 255;
    var MAX_CONNECTIONS = 5;
    var m_connection_state = Array(MAX_CONNECTIONS);
    var connectionStartResolve = null;
    var connectionStateResolve = [];
    var disconnectstateResolve = [];
    var connectionState = [];
    var exchangedMtuResolve = [];
    var initNRFResolve = null;
    var alreadyEstablishErrors = 0;
    var nrf_ble_parse_adv_payload = function(adv_payload) {
      let index = 0;
      let retdata = {};
      while (index < adv_payload.length) {
        let length = adv_payload[index];
        if (length == 0)
          break;
        let type = adv_payload[index + 1];
        let payload = adv_payload.slice(index + 2, index + 1 + length);
        if (type == BLE_GAP_AD_TYPE_COMPLETE_LOCAL_NAME) {
          retdata.name = payload.toString("ascii");
        } else if (type == BLE_GAP_AD_TYPE_MANUFACTURER_SPECIFIC_DATA) {
          retdata.manufacturer = payload;
        } else if (type == BLE_GAP_AD_TYPE_FLAGS) {
        } else if (type == BLE_GAP_AD_TYPE_TX_POWER_LEVEL) {
        } else {
        }
        index += length + 1;
      }
      return retdata;
    };
    module2.exports = {
      async init(gwGlobalState) {
        let SERIALPORT = "";
        while (SERIALPORT == "") {
          let portlist = await SerialPort.list();
          let flashingnrf = false;
          for (let i = 0; i < portlist.length; i++) {
            if (portlist[i].productId && portlist[i].vendorId && portlist[i].productId.toLowerCase() == "521a" && portlist[i].vendorId.toLowerCase() == "1915") {
              SERIALPORT = portlist[i].path;
              console.log("Opened Phantom Gateway USB on", SERIALPORT);
              break;
            } else if (portlist[i].productId && portlist[i].vendorId && portlist[i].productId.toLowerCase() == "521f" && portlist[i].vendorId.toLowerCase() == "1915") {
              SERIALPORT = portlist[i].path;
              console.log("Running DFU on", SERIALPORT);
              try {
                await nrfusbdfu.update(gwGlobalState, SERIALPORT);
              } catch (e) {
              }
            }
          }
          await gwutils2.sleep(1e3);
        }
        this.port = new SerialPort({
          path: SERIALPORT,
          baudRate: 57600
        });
        const parser = this.port.pipe(new ByteLengthParser({ length: nrfPacketSize }));
        this.port.on("open", () => {
          let message = Buffer2.alloc(nrfPacketSize);
          message[0] = ENANO_SPI_WHATS_MY_ID;
          this.writeCommand(message);
        }), this.port.on("close", () => {
          console.log("On close");
          this.failAllBLEConnections();
          this.init(gwGlobalState);
        }), // Open errors will be emitted as an error event
        this.port.on("error", (err) => {
          console.log("Error: ", err.message);
          this.init(gwGlobalState);
        });
        parser.on("data", (data) => this.serialPortOnData(gwGlobalState, data));
        return new Promise(function(resolve2, reject) {
          initNRFResolve = resolve2;
        });
      },
      start(advertising_report) {
        this.advertising_report = advertising_report;
      },
      async serialPortOnData(gwGlobalState, data) {
        if (nrfPacketSize != data.length)
          console.log("!!!!!!!!!!!!!!! WRONG SIZE \xA1\xA1\xA1\xA1\xA1\xA1\xA1\xA1\xA1\xA1\xA1\xA1\xA1\xA1\xA1\xA1\xA1\xA1\xA1\xA1\xA1:", data.length);
        switch (data[0]) {
          case ENANO_SPI_YOUR_ID:
            let serial = data.readUInt32LE(1);
            let magic1 = data[5];
            let magic2 = data[6];
            let btVersion = data.readUInt32LE(7);
            let btTemperature = data.readInt32LE(11);
            let vendorId = data[15];
            let board = data[16];
            if (magic1 != 66 || magic2 != 67)
              console.log("--------------------------> Wrong magic!!", magic1, magic2);
            console.log("GW version", serial, btVersion);
            if (btVersion != COMPATIBLE_BLE_VERSION) {
              console.log("We need to update BLE chip version...");
              let message = Buffer2.alloc(nrfPacketSize);
              message[0] = ENANO_SPI_ENTER_DFU;
              this.writeCommand(message);
              this.port.drain((error) => this.port.close());
            } else {
              let message = Buffer2.alloc(nrfPacketSize);
              message[0] = ENANO_SPI_BLE_START_SCANNING;
              message[1] = gwGlobalState.basicconfig.btscanningtype;
              message[2] = gwGlobalState.basicconfig.btamplifier ? 1 : 0;
              console.log("Starting scanning");
              this.writeCommand(message);
            }
            gwGlobalState.deviceInfo.serialNumber = serial;
            gwGlobalState.deviceInfo.btVersion = btVersion;
            gwGlobalState.deviceInfo.btTemperature = btTemperature / 100;
            gwGlobalState.deviceInfo.vendorId = vendorId;
            gwGlobalState.deviceInfo.hasBLEAmplifier = false;
            if (board == 1) {
              gwGlobalState.deviceInfo.hasBuildInChannels = true;
            } else if (board == 2 || board == 4) {
              gwGlobalState.deviceInfo.hasBLEAmplifier = true;
            }
            if (initNRFResolve) {
              initNRFResolve();
              initNRFResolve = null;
            }
            break;
          case ENANO_SPI_ADV_REPORT:
            let ble_addr = [...data.slice(1, 7)];
            let rssi = data.readInt8(7);
            let ch_index = data[8];
            let primaryPhy = data[9];
            let secondaryPhy = data[10];
            let adv_payload_len = data.readUInt16LE(11);
            let adv_payload = data.slice(13, 13 + adv_payload_len);
            let adv_data = nrf_ble_parse_adv_payload(adv_payload);
            let bledevice = {
              ble_addr,
              rssi,
              ch_index,
              primaryPhy,
              secondaryPhy
            };
            if (this.advertising_report)
              this.advertising_report(bledevice, adv_data);
            break;
          case ENANO_SPI_BLE_CONNECTED:
            console.log("ENANO_SPI_BLE_CONNECTED");
            if (connectionStartResolve) {
              let conn_handle2 = data.readUInt16LE(1);
              let addr = Buffer2.alloc(6);
              data.copy(addr, 0, 3, 9);
              connectionState[conn_handle2] = {
                conn_handle: conn_handle2,
                btaddr: addr
              };
              exchangedMtuResolve[conn_handle2] = null;
              connectionStartResolve.resolve(connectionState[conn_handle2]);
              connectionStartResolve = null;
            } else {
              console.log("Wasn't expecting a conncetion??");
            }
            break;
          case ENANO_SPI_BLE_DISCONNECTED: {
            let conn_handle2 = data.readUInt16LE(1);
            let reason = data[3];
            let connection2 = connectionState[conn_handle2];
            console.log("ENANO_SPI_BLE_DISCONNECTED", conn_handle2, reason);
            if (connection2.disconnecting) {
              connection2.disconnecting = false;
            } else if (connectionStateResolve[conn_handle2]) {
              connectionStateResolve[conn_handle2].reject({ error: "disconnected", reason });
              connectionStateResolve[conn_handle2] = void 0;
            }
            if (disconnectstateResolve[conn_handle2]) {
              disconnectstateResolve[conn_handle2].resolve();
              disconnectstateResolve[conn_handle2] = void 0;
            }
            if (exchangedMtuResolve[conn_handle2]) {
              exchangedMtuResolve[conn_handle2].reject("disconnected");
              exchangedMtuResolve[conn_handle2] = null;
            }
            connectionState[conn_handle2] = void 0;
            break;
          }
          case ENANO_SPI_BLE_CONNECT_ERR: {
            console.log("ENANO_SPI_BLE_CONNECT_ERR");
            if (connectionStartResolve)
              connectionStartResolve.reject("Disconnected");
            connectionStartResolve = null;
            break;
          }
          case ENANO_SPI_BLE_CONNECT_TIMEOUT:
            console.log("ENANO_SPI_BLE_CONNECT_TIMEOUT");
            if (connectionStartResolve) {
              connectionStartResolve.reject("Connection timeout");
              connectionStartResolve = null;
            }
            break;
          case ENANO_SPI_BLE_RX_DATA: {
            let conn_handle2 = data.readUInt16LE(1);
            let char_handle = data.readUInt16LE(3);
            let len = data[5];
            let connection2 = connectionState[conn_handle2];
            let messageStart = 6;
            if (connection2.longdata) {
              if (!connection2.longdata_header) {
                connection2.longdata_header = data.subarray(messageStart + 1, messageStart + 1 + len);
                connection2.longdata_size = data.readUInt32LE(messageStart + 5);
                connection2.longdata_payload = Buffer2.alloc(connection2.longdata_size);
                connection2.longdata_pos = 0;
                console.log("Got long data header ", connection2.longdata_size);
              } else {
                data.copy(connection2.longdata_payload, connection2.longdata_pos, messageStart + 1, messageStart + 1 + len);
                connection2.longdata_pos += len - 1;
                if (connection2.longProgress) {
                  let newProgress = connection2.longdata_pos / connection2.longdata_size;
                  if (newProgress == 1 || newProgress - connection2.currentProgress >= 0.01) {
                    connection2.longProgress(connection2.longdata_pos / connection2.longdata_size);
                  }
                }
                if (connection2.longdata_pos == connection2.longdata_size) {
                  if (connectionStateResolve[conn_handle2]) {
                    connectionStateResolve[conn_handle2].resolve(true);
                    connectionStateResolve[conn_handle2] = void 0;
                  }
                }
              }
            } else {
              let message = Buffer2.alloc(len);
              data.copy(message, 0, messageStart, messageStart + len);
              if (connectionStateResolve[conn_handle2]) {
                connectionStateResolve[conn_handle2].resolve(message);
                connectionStateResolve[conn_handle2] = void 0;
              }
            }
            break;
          }
          case ENANO_SPI_BLE_WRITE_ERR:
            let conn_handle = data.readUInt16LE(1);
            let err = data.readUInt32LE(3);
            let connection = connectionState[conn_handle];
            let resolve2 = false;
            if (connection) {
              if (err == NRF_ERRORS.NRF_ERROR_RESOURCES) {
                connection.retryWrite = true;
              } else if (err == NRF_ERRORS.NRF_ERROR_SUCCESS) {
                if (connection.withoutresponse) {
                  connection.withoutresponse = false;
                  if (connectionStateResolve[conn_handle]) {
                    connectionStateResolve[conn_handle].resolve(true);
                    connectionStateResolve[conn_handle] = void 0;
                  }
                }
              } else {
                if (connectionStateResolve[conn_handle]) {
                  connectionStateResolve[conn_handle].reject("Write error");
                  connectionStateResolve[conn_handle] = void 0;
                }
              }
              if (resolve2) {
              }
            }
            break;
          case ENANO_SPI_BLE_ENABLE_NOTIF_ERR: {
            let conn_handle2 = data.readUInt16LE(1);
            let err2 = data.readUInt32LE(3);
            let connection2 = connectionState[conn_handle2];
            if (!connection2)
              return;
            if (err2 == NRF_ERRORS.NRF_ERROR_BUSY) {
              this.writeCommand(connection2.lastEnableNotifMessage);
            } else if (connectionStateResolve[conn_handle2]) {
              connectionStateResolve[conn_handle2].resolve(err2);
              connectionStateResolve[conn_handle2] = void 0;
            }
            break;
          }
          case ENANO_SPI_BLEWRITE_RESPONSE: {
            let conn_handle2 = data.readUInt16LE(1);
            let connection2 = connectionState[conn_handle2];
            if (connection2.waitingfornotifenable) {
              connection2.waitingfornotifenable = false;
              if (connectionStateResolve[conn_handle2]) {
                connectionStateResolve[conn_handle2].resolve(true);
                connectionStateResolve[conn_handle2] = void 0;
              }
            }
            if (connection2.resolveOnResponse) {
              if (connectionStateResolve[conn_handle2]) {
                connectionStateResolve[conn_handle2].resolve();
                connectionStateResolve[conn_handle2] = void 0;
              }
              connection2.resolveOnResponse = false;
            }
            break;
          }
          case ENANO_SPI_WRITE_COMPLETED: {
            let conn_handle2 = data.readUInt16LE(1);
            let count = data[3];
            let connection2 = connectionState[conn_handle2];
            if (connection2 && connection2.retryWrite) {
              connection2.retryWrite = false;
              this.writeCommand(connection2.lastWriteMessage);
            } else {
            }
            break;
          }
          case ENANO_SPI_CONN_SEC_UPDATE: {
            let conn_handle2 = data.readUInt16LE(1);
            let sm = data[3];
            let lv = data[4];
            let connection2 = connectionState[conn_handle2];
            console.log("ENANO_SPI_CONN_SEC_UPDATE conn_handle", conn_handle2, "sm: ", sm, "lv: ", lv);
            if (lv >= 2) {
              connection2.encrypted = true;
            }
            if (connection2 && connection2.waitingforsecurity) {
              connection2.waitingforsecurity = false;
              if (connectionStateResolve[conn_handle2]) {
                connectionStateResolve[conn_handle2].resolve({ connectionLevel: lv });
                connectionStateResolve[conn_handle2] = void 0;
              }
            }
            break;
          }
          case ENANO_SPI_TEMPERATURE: {
            let btTemperature2 = data.readInt32LE(1);
            gwGlobalState.deviceInfo.btTemperature = btTemperature2 / 100;
            gwutils2.gwUpdateGlobalState();
            break;
          }
          case ENANO_SPI_BLE_MTU_RSP: {
            let conn_handle2 = data.readUInt16LE(1);
            let mtu = data.readUInt16LE(3);
            if (exchangedMtuResolve[conn_handle2])
              exchangedMtuResolve[conn_handle2].resolve();
            exchangedMtuResolve[conn_handle2] = null;
            break;
          }
          case ENANO_SPI_QOS_SURVEY_REPORT: {
            console.log("ENANO_SPI_QOS_SURVEY_REPORT");
            let channelSurvey = [];
            for (let i = 0; i < 40; i++) {
              channelSurvey.push(data.readInt8(i + 1));
            }
            {
              gwGlobalState.deviceInfo.bleChannelSurvey = channelSurvey;
            }
            gwutils2.gwUpdateGlobalState();
            break;
          }
          default:
            console.log("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!UNKNOW COMMAND!!!!!!!!!!!!!!!!!!!!!!!");
            process.exit(0);
        }
      },
      restartNRF() {
        let message = Buffer2.alloc(nrfPacketSize);
        message[0] = ENANO_SPI_RESTART;
        this.writeCommand(message);
      },
      failAllBLEConnections() {
        if (connectionStartResolve) {
          connectionStartResolve.reject();
          connectionStartResolve = null;
        }
        for (let i = 0; i < MAX_CONNECTIONS; i++) {
          if (connectionStateResolve[i]) {
            connectionStateResolve[i].reject();
            connectionStateResolve[i] = null;
          }
        }
        for (let i = 0; i < MAX_CONNECTIONS; i++) {
          if (disconnectstateResolve[i]) {
            disconnectstateResolve[i].reject();
            disconnectstateResolve[i] = null;
          }
        }
      },
      writeCommand(sendbuf) {
        this.port.write(sendbuf, (err) => {
          if (err) {
            return console.log("Error on write: ", err.message);
          }
        });
      },
      connect(bledevice, conn_interval, sup_timeout, slaveLatency, connTimeout) {
        if (connectionStartResolve) {
          alreadyEstablishErrors++;
          if (alreadyEstablishErrors > 50) {
            gwutils2.reboot();
          }
          console.log("Already establishing connection");
          return new Promise((resolve2, reject) => reject("Already establishing connection"));
        }
        alreadyEstablishErrors = 0;
        console.log("Connecting....", bledevice);
        let connectionPromise = new Promise(function(resolve2, reject) {
          connectionStartResolve = {
            resolve: resolve2,
            reject
          };
        });
        let isMultiple = false;
        if (Array.isArray(bledevice))
          isMultiple = true;
        let message = Buffer2.alloc(nrfPacketSize);
        message[0] = ENANO_SPI_BLE_CONNECT_TO;
        if (isMultiple)
          Buffer2.from([0, 0, 0, 0, 0, 0]).copy(message, 1, 0, 6);
        else {
          let buffaddr = Buffer2.from(bledevice.ble_addr);
          buffaddr.copy(message, 1, 0, 6);
        }
        message[7] = conn_interval / 1.25;
        message.writeUIntLE(sup_timeout, 8, 4);
        message.writeUIntLE(slaveLatency, 12, 4);
        if (connTimeout == void 0)
          connTimeout = 20 * 100;
        message.writeUIntLE(connTimeout, 16, 2);
        message[18] = 247;
        if (isMultiple) {
          message[19] = bledevice.length;
          for (let i = 0; i < bledevice.length; i++) {
            let buffaddr = Buffer2.from(bledevice[i].ble_addr);
            buffaddr.copy(message, 20 + i * 6, 0, 6);
          }
        }
        this.writeCommand(message);
        return connectionPromise;
      },
      async disconnect(connection) {
        if (!connectionState[connection.conn_handle])
          return;
        let disconnectionPromise = new Promise(function(resolve2, reject) {
          disconnectstateResolve[connection.conn_handle] = {
            resolve: resolve2,
            reject
          };
        });
        connection.disconnecting = true;
        let message = Buffer2.alloc(nrfPacketSize);
        message[0] = ENANO_SPI_BLE_DISCONNECT;
        message.writeUIntLE(connection.conn_handle, 1, 2);
        this.writeCommand(message);
        return disconnectionPromise;
      },
      async enableEncryption(connection, key) {
        if (!connectionState[connection.conn_handle])
          return false;
        connection.waitingforsecurity = true;
        let connectionPromise = new Promise(function(resolve2, reject) {
          connectionStateResolve[connection.conn_handle] = {
            resolve: resolve2,
            reject
          };
        });
        let message = Buffer2.alloc(nrfPacketSize);
        message[0] = ENANO_SPI_BLE_ENCRYPT;
        message.writeUIntLE(connection.conn_handle, 1, 2);
        message[3] = 1;
        message[4] = 1;
        message[5] = 16;
        key.copy(message, 6);
        this.writeCommand(message);
        return connectionPromise;
      },
      async pairConnection(connection) {
        if (!connectionState[connection.conn_handle])
          return;
        connection.waitingforsecurity = true;
        let connectionPromise = new Promise(function(resolve2, reject) {
          connectionStateResolve[connection.conn_handle] = {
            resolve: resolve2,
            reject
          };
        });
        let message = Buffer2.alloc(nrfPacketSize);
        message[0] = ENANO_SPI_BLE_AUTHENTICATE;
        console.log("Connection pairing ", connection.conn_handle);
        message.writeUIntLE(connection.conn_handle, 1, 2);
        this.writeCommand(message);
        return connectionPromise;
      },
      enableNotif(connection, charhandle, enable) {
        let conn_handle = connection.conn_handle;
        if (!connectionState[conn_handle])
          return new Promise((resolve2, reject) => reject());
        let connectionPromise = new Promise(function(resolve2, reject) {
          connectionStateResolve[conn_handle] = {
            resolve: resolve2,
            reject
          };
        });
        connection.waitingfornotifenable = true;
        let message = Buffer2.alloc(nrfPacketSize);
        message[0] = ENANO_SPI_BLE_ENABLE_NOTIF;
        message.writeUIntLE(connection.conn_handle, 1, 2);
        message.writeUIntLE(charhandle, 3, 2);
        message[5] = enable ? 1 : 0;
        connection.lastEnableNotifMessage = message;
        this.writeCommand(message);
        return connectionPromise;
      },
      writeChar(connection, charhandle, data, withoutresponse, resolveOnResponse) {
        let conn_handle = connection.conn_handle;
        if (!connectionState[conn_handle])
          return new Promise((resolve2, reject) => reject());
        let connectionPromise = new Promise(function(resolve2, reject) {
          connectionStateResolve[conn_handle] = {
            resolve: resolve2,
            reject
          };
        });
        let message = Buffer2.alloc(nrfPacketSize);
        if (withoutresponse)
          message[0] = ENANO_SPI_BLE_WRITE_WITHOURSP;
        else
          message[0] = ENANO_SPI_BLE_WRITE;
        message.writeUIntLE(connection.conn_handle, 1, 2);
        message.writeUIntLE(charhandle, 3, 2);
        message[5] = data.length;
        data.copy(message, 6);
        connection.lastWriteMessage = message;
        connection.withoutresponse = withoutresponse;
        connection.resolveOnResponse = resolveOnResponse;
        this.writeCommand(message);
        return connectionPromise;
      },
      requestTemperature() {
        let message = Buffer2.alloc(nrfPacketSize);
        message[0] = ENANO_SPI_GET_TEMPERATURE;
        this.writeCommand(message);
      },
      testAdvertise() {
        let message = Buffer2.alloc(nrfPacketSize);
        message[0] = ENANO_SPI_TEST_ADVERTISE;
        this.writeCommand(message);
      },
      waitForMTUExchange(connection) {
        if (!connectionState[connection.conn_handle])
          return new Promise((resolve2, reject) => reject());
        let mtuPromise = new Promise(function(resolve2, reject) {
          exchangedMtuResolve[connection.conn_handle] = {
            resolve: resolve2,
            reject
          };
        });
        return mtuPromise;
      },
      startSyncBroadcast(channel, timeout, longrange) {
        let hz = 5e4;
        let prefix = 144;
        let message = Buffer2.alloc(nrfPacketSize);
        message[0] = ENANO_SPI_SYNC_BROADCAST;
        message[1] = channel;
        message[2] = timeout;
        message.writeUIntLE(hz, 3, 2);
        message[5] = prefix;
        message[6] = longrange;
        this.writeCommand(message);
      },
      startQoSChannelSurvey() {
        let message = Buffer2.alloc(nrfPacketSize);
        message[0] = ENANO_SPI_START_CHANNEL_SURVEY;
        let surveyInterval = 0;
        let runtime = 8e3;
        message.writeUIntLE(surveyInterval, 1, 4);
        message.writeUIntLE(runtime, 5, 4);
        this.writeCommand(message);
      }
    };
  }
});

// src/nrfbledfu.js
var require_nrfbledfu = __commonJS({
  "src/nrfbledfu.js"(exports2, module2) {
    "use strict";
    var Buffer2 = require("buffer").Buffer;
    var ble2 = require_nrf_ble();
    var crc32 = require_crc32();
    var gwutils2 = require_gwutils();
    var path3 = require("path");
    var fs2 = require("fs").promises;
    var DFU_REQUEST_CREATE = 1;
    var DFU_REQUEST_CALCULATE_CRC = 3;
    var DFU_REQUEST_EXECUTE = 4;
    var DFU_REQUEST_SELECT = 6;
    var TRANSFER_TYPE_INIT_PACKET = 1;
    var TRANSFER_TYPE_FIRMWARE = 2;
    var sd_ini = null;
    var sd_firmware = null;
    var nordicDFU = class {
      constructor(bledevice, ini, firmware) {
        this.bledevice = bledevice;
        this.ini = ini;
        this.firmware = firmware;
        this.abort = false;
      }
      async update(progressCB) {
        let response = false;
        this.progressCB = progressCB;
        try {
          if (!sd_ini || sd_firmware) {
            sd_firmware = await fs2.readFile(path3.join("fw", "sd611.bin"));
            sd_ini = await fs2.readFile(path3.join("fw", "sd611.dat"));
          }
          this.connection = await ble2.connect(this.bledevice, 10, 8e3, 0);
          if (this.connection) {
            while (!response) {
              await gwutils2.sleep(500);
              response = await ble2.enableNotif(this.connection, 16, true);
            }
            if (response) {
              console.log("TRANSFERING SD INIT PACKET");
              response = await this.#transfer(sd_ini, TRANSFER_TYPE_INIT_PACKET);
              console.log("TRANSFERED SD INIT PACKET", response);
            }
            if (response) {
              console.log("TRANSFERING SD FIRMWARE PACKET");
              response = await this.#transfer(sd_firmware, TRANSFER_TYPE_FIRMWARE);
              console.log("TRANSFERED SD FIRMWARE PACKET");
            } else {
              response = true;
            }
            if (response) {
              console.log("TRANSFERING INIT PACKET");
              response = await this.#transfer(this.ini, TRANSFER_TYPE_INIT_PACKET);
              console.log("TRANSFERED INIT PACKET");
            }
            if (response) {
              console.log("TRANSFERING FIRMWARE PACKET");
              response = await this.#transfer(this.firmware, TRANSFER_TYPE_FIRMWARE);
              console.log("TRANSFERED FIRMWARE PACKET");
            }
          }
        } catch (e) {
          console.log("error in update", e);
        }
        try {
          if (this.connection) {
            await ble2.disconnect(this.connection);
          }
        } catch (e) {
        }
        return response;
      }
      #writexferchar(data) {
        return ble2.writeChar(this.connection, 13, data, true);
      }
      #writeToControl(payload) {
        return ble2.writeChar(this.connection, 15, payload);
      }
      async #CreateObject(size, type) {
        let createCommand = Buffer2.from([DFU_REQUEST_CREATE, type, 0, 0, 0, 0]);
        createCommand.writeUInt32LE(size, 2);
        return await this.#writeToControl(createCommand);
      }
      async #transfer_object(obj_size, offset, mtu, file_bytes, transferType) {
        let transfer_pos = 0;
        while (transfer_pos < obj_size && !this.m_abort) {
          let packet_size = mtu;
          if (obj_size - transfer_pos < mtu) {
            packet_size = obj_size - transfer_pos;
          }
          let subbuffer = file_bytes.subarray(transfer_pos + offset, transfer_pos + offset + packet_size);
          let status2 = false;
          try {
            status2 = await this.#writexferchar(subbuffer);
          } catch (e) {
            console.log("Error!!!!!!!!!!!!!!!!!!!!!", e);
            this.m_abort = true;
          }
          if (!status2 || this.m_abort) {
            console.log("WriteValueAsync Failed ", status2);
            break;
          }
          transfer_pos += packet_size;
          if (transferType == TRANSFER_TYPE_FIRMWARE) {
            let progress = 0;
            if (transfer_pos + offset != 0)
              progress = (transfer_pos + offset) / file_bytes.length;
            this.progressCB(progress);
          }
        }
      }
      async #transfer(file_bytes, type) {
        let response = false;
        let mtu = 244;
        let max_object_size = 0;
        let offset = 0;
        let crc = 0;
        let success = false;
        try {
          response = await this.#writeToControl(Buffer2.from([DFU_REQUEST_SELECT, type]));
          if (response == null || response[2] != 1) {
            console.log("-----------------> Error when selecting firmware  ", response);
            return false;
          }
          max_object_size = response.readUInt32LE(3);
          offset = response.readUInt32LE(7);
          crc = response.readUInt32LE(11);
          let transfered = 0;
          let retries = 0;
          do {
            let obj_size = file_bytes.length - transfered;
            if (obj_size > max_object_size)
              obj_size = max_object_size;
            response = await this.#CreateObject(obj_size, type);
            if (response == null || response[2] != 1) {
              console.log("-----------------> Error when creating object ", response);
              return false;
            }
            await gwutils2.sleep(200);
            await this.#transfer_object(obj_size, transfered, mtu, file_bytes, type);
            response = await this.#writeToControl(Buffer2.from([DFU_REQUEST_CALCULATE_CRC]));
            if (response == null || response[2] != 1) {
              console.log("-----------------> Error when calculating crc", response);
              return false;
            }
            offset = response.readUInt32LE(3);
            crc = response.readUInt32LE(7);
            let segment = file_bytes.subarray(0, offset);
            let expected_crc = crc32.unsigned(segment);
            if (expected_crc != crc) {
              console.log("---------------------------------------> CRC32 unexpected", crc, "!=", expected_crc, "retries", retries);
              retries++;
              if (retries > 5)
                return false;
              else
                continue;
            } else {
              retries = 0;
            }
            transfered = offset;
            response = await this.#writeToControl(Buffer2.from([DFU_REQUEST_EXECUTE]));
            if (response == null || response[2] != 1) {
              console.log("--------------------------------------> Error when executing ", response);
              return false;
            }
          } while (transfered < file_bytes.length && !this.m_abort);
          success = true;
        } catch (e) {
          success = false;
          console.log("-----------------> EI Error ", e);
        }
        return success;
      }
      static parse_phantom_bootloader_adv_data(manu_payload) {
        let retdata = {};
        retdata.company_id = manu_payload.readUInt16LE(0);
        retdata.version = manu_payload.readUInt16LE(2);
        retdata.type = manu_payload.readUInt16LE(4);
        return retdata;
      }
    };
    module2.exports = {
      nordicDFU
    };
  }
});

// src/sensorDefinition.js
var require_sensorDefinition = __commonJS({
  "src/sensorDefinition.js"(exports2, module2) {
    "use strict";
    var sensorDefinition2 = require_sensorDefinition();
    var DataType = {
      Null: 0,
      Boolean: 1,
      SByte: 2,
      Byte: 3,
      Int16: 4,
      UInt16: 5,
      Int32: 6,
      UInt32: 7,
      Int64: 8,
      UInt64: 9,
      Float: 10,
      Double: 11,
      String: 12,
      DateTime: 13,
      Guid: 14,
      ByteString: 15,
      XmlElement: 16,
      NodeId: 17,
      ExpandedNodeId: 18,
      StatusCode: 19,
      QualifiedName: 20,
      LocalizedText: 21,
      ExtensionObject: 22,
      DataValue: 23,
      Variant: 24,
      DiagnosticInfo: 25
    };
    var phantomTypes = {
      TRIAXIAL_KX222: 3,
      TRIAXIAL_KX122: 5,
      TRIAXIAL_KX134: 6,
      TRIAXIAL_UNIVERSAL: 7,
      THERMALCAMERA: 10,
      CURRENT_V1: 30,
      CURRENT_V2: 32,
      RPM: 40,
      THERMOCOUPLE: 20,
      // 12??
      THERMOCOUPLE_V2: 21,
      THERMOCOUPLE_V3: 22,
      INFRARED: 25,
      SENSOR420MA: 26,
      VOLTIMETER: 27,
      DIGITALINPUTS: 31,
      DISPLAY: 202,
      GP: 60,
      DISTANCE: 50
    };
    var lookupSensorDefinition = null;
    function getDefaultUpdateFilename(type) {
      switch (type) {
        case phantomTypes.TRIAXIAL_KX222:
        case phantomTypes.TRIAXIAL_KX122:
        case phantomTypes.TRIAXIAL_KX134:
        case phantomTypes.TRIAXIAL_UNIVERSAL:
          return {
            name: "triaxial",
            mingw2version: 178,
            version: 188
          };
        case phantomTypes.THERMALCAMERA:
          return {
            name: "thermalcamera",
            mingw2version: 106,
            version: 109
          };
        case phantomTypes.CURRENT_V1:
        case phantomTypes.CURRENT_V2:
          return {
            name: "current",
            mingw2version: 132,
            version: 135
          };
        case phantomTypes.RPM:
          return {
            name: "rpm",
            mingw2version: 141,
            version: 143
          };
        case phantomTypes.THERMOCOUPLE:
        case phantomTypes.THERMOCOUPLE_V2:
        case phantomTypes.THERMOCOUPLE_V3:
          return {
            name: "thermocouple",
            mingw2version: 116,
            version: 117
          };
        case phantomTypes.INFRARED:
          return {
            name: "infrared",
            mingw2version: 106,
            version: 108
          };
        case phantomTypes.SENSOR420MA:
        case phantomTypes.VOLTIMETER:
          return {
            name: "20ma",
            mingw2version: 116,
            version: 117
          };
        case phantomTypes.DIGITALINPUTS:
          return {
            name: "digitalinputs",
            mingw2version: 106,
            version: 108
          };
        case phantomTypes.GP:
          return {
            name: "pg",
            mingw2version: 140,
            version: 143
          };
        case phantomTypes.DISPLAY:
          return;
        case phantomTypes.DISTANCE:
          return {
            name: "distance",
            mingw2version: 101,
            version: 101
          };
      }
      return null;
    }
    function getCanForceUpdateAdv(type) {
      switch (type) {
        case phantomTypes.TRIAXIAL_KX222:
        case phantomTypes.TRIAXIAL_KX122:
        case phantomTypes.TRIAXIAL_KX134:
        case phantomTypes.TRIAXIAL_UNIVERSAL:
          return 182;
        case phantomTypes.THERMALCAMERA:
          return 107;
        case phantomTypes.CURRENT_V1:
        case phantomTypes.CURRENT_V2:
          return 134;
        case phantomTypes.RPM:
          return 142;
        case phantomTypes.THERMOCOUPLE:
        case phantomTypes.THERMOCOUPLE_V2:
        case phantomTypes.THERMOCOUPLE_V3:
          return 117;
        case phantomTypes.INFRARED:
          return 107;
        case phantomTypes.SENSOR420MA:
        case phantomTypes.VOLTIMETER:
          return 117;
        case phantomTypes.DIGITALINPUTS:
          return 107;
        case phantomTypes.GP:
          return 141;
        case phantomTypes.DISTANCE:
          return 101;
        case phantomTypes.DISPLAY:
          return 5e3;
      }
      return 5e3;
    }
    function getCanDoCodedAdv(type) {
      switch (type) {
        case phantomTypes.TRIAXIAL_KX222:
        case phantomTypes.TRIAXIAL_KX122:
        case phantomTypes.TRIAXIAL_KX134:
        case phantomTypes.TRIAXIAL_UNIVERSAL:
          return 185;
        case phantomTypes.THERMALCAMERA:
          return 5e3;
        case phantomTypes.CURRENT_V1:
        case phantomTypes.CURRENT_V2:
          return 5e3;
        case phantomTypes.RPM:
          return 5e3;
        case phantomTypes.THERMOCOUPLE:
        case phantomTypes.THERMOCOUPLE_V2:
        case phantomTypes.THERMOCOUPLE_V3:
          return 5e3;
        case phantomTypes.INFRARED:
          return 5e3;
        case phantomTypes.SENSOR420MA:
        case phantomTypes.VOLTIMETER:
          return 5e3;
        case phantomTypes.DIGITALINPUTS:
          return 5e3;
        case phantomTypes.GP:
          return 5e3;
        case phantomTypes.DISTANCE:
          return 5e3;
        case phantomTypes.DISPLAY:
          return 5e3;
      }
      return 5e3;
    }
    function getCanDoFastAdv(type) {
      switch (type) {
        case phantomTypes.TRIAXIAL_KX222:
        case phantomTypes.TRIAXIAL_KX122:
        case phantomTypes.TRIAXIAL_KX134:
        case phantomTypes.TRIAXIAL_UNIVERSAL:
          return 187;
        case phantomTypes.THERMALCAMERA:
          return 5e3;
        case phantomTypes.CURRENT_V1:
        case phantomTypes.CURRENT_V2:
          return 5e3;
        case phantomTypes.RPM:
          return 5e3;
        case phantomTypes.THERMOCOUPLE:
        case phantomTypes.THERMOCOUPLE_V2:
        case phantomTypes.THERMOCOUPLE_V3:
          return 5e3;
        case phantomTypes.INFRARED:
          return 5e3;
        case phantomTypes.SENSOR420MA:
        case phantomTypes.VOLTIMETER:
          return 5e3;
        case phantomTypes.DIGITALINPUTS:
          return 5e3;
        case phantomTypes.GP:
          return 5e3;
        case phantomTypes.DISTANCE:
          return 5e3;
        case phantomTypes.DISPLAY:
          return 5e3;
      }
      return 5e3;
    }
    function getLookupSensorDefinition() {
      if (!lookupSensorDefinition) {
        lookupSensorDefinition = {};
        for (let sensorType in phantomTypes) {
          let typeNumber = phantomTypes[sensorType];
          let sensorDef = getSensorDefinition(typeNumber);
          let lookupTable = {};
          if (!sensorDef)
            continue;
          for (let i = 0; i < sensorDef.length; i++) {
            let variable = sensorDef[i];
            lookupTable[variable.stateVariableName] = variable;
          }
          lookupSensorDefinition[typeNumber] = lookupTable;
        }
      }
      return lookupSensorDefinition;
    }
    function getSensorDefinition(type) {
      switch (type) {
        case phantomTypes.TRIAXIAL_KX222:
        case phantomTypes.TRIAXIAL_KX122:
        case phantomTypes.TRIAXIAL_KX134:
          return [
            {
              stateVariableName: "type",
              description: "Sensor type",
              modbus: {
                gw1offset: 2,
                dataType: "uint32"
              },
              opc: {
                browseName: "type",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "version",
              description: "Sensor firmware version",
              modbus: {
                gw1offset: 13,
                dataType: "uint32"
              },
              opc: {
                browseName: "version",
                dataType: DataType.UInt16
              },
              mtconnect: {
                id: "version",
                category: "EVENT",
                type: "FIRMWARE"
              }
            },
            {
              stateVariableName: "seq",
              description: "Sensor data update sequence",
              /*modbus: {
                  autoOffset: 2,
                  dataType: "uint32"
              },*/
              advv2: {
                type: "uint8",
                offset: 11,
                scale: 1
              }
            },
            {
              stateVariableName: "advFlags",
              advv2: {
                type: "uint16",
                offset: 12
              }
            },
            {
              stateVariableName: "batteryType",
              description: "Battery type",
              advv2: {
                type: "uint8",
                offset: 14,
                scale: 1
              },
              modbus: {
                gw1offset: 9,
                dataType: "uint32"
              },
              opc: {
                browseName: "batteryType",
                dataType: DataType.UInt32
              }
            },
            {
              stateVariableName: "battery",
              description: "Battery voltage",
              advv2: {
                type: "uint16",
                offset: 15,
                scale: 100
              },
              modbus: {
                gw1offset: 10,
                rawDataType: "uint16",
                dataType: "float"
              },
              opc: {
                browseName: "battery",
                dataType: DataType.Double
              },
              mtconnect: {
                id: "battery",
                category: "SAMPLE",
                type: "BATTERY_CHARGE"
              }
            },
            {
              stateVariableName: "temperature",
              description: "Sensor internal temperature",
              advv2: {
                type: "int16",
                offset: 17,
                scale: 100
              },
              modbus: {
                gw1offset: 11,
                rawDataType: "uint32",
                dataType: "float"
              },
              opc: {
                browseName: "temperature",
                dataType: DataType.Double
              },
              mtconnect: {
                id: "temperature",
                category: "SAMPLE",
                type: "TEMPERATURE",
                units: "CELSIUS"
              }
            },
            {
              stateVariableName: "updateInterval",
              description: "Sensor internal update interval",
              advv2: {
                type: "uint16",
                offset: 19,
                scale: 1
              }
            },
            {
              stateVariableName: "txPower",
              description: "Sensor radio transfer powers",
              advv2: {
                type: "uint8",
                offset: 21,
                scale: 1
              }
            },
            {
              stateVariableName: "minRMSFreq",
              advv2: {
                type: "uint16",
                offset: 22,
                scale: 1
              }
            },
            {
              stateVariableName: "maxRMSFreq",
              advv2: {
                type: "uint16",
                offset: 24,
                scale: 1
              }
            },
            {
              stateVariableName: "rms",
              description: "Vibration velocity RMS",
              advv2: {
                type: "uint16array",
                offset: 26,
                arraySize: 3,
                scale: 100
              },
              modbus: {
                gw1offset: 3,
                rawDataType: "uint32",
                dataType: "float",
                arraySize: 3
              },
              opc: {
                browseName: "rms",
                dataType: DataType.Double,
                isArray: true
              },
              mtconnect: {
                id: "rms",
                category: "SAMPLE",
                type: "VELOCITY",
                units: "MILLIMETER/SECOND"
              }
            },
            {
              stateVariableName: "range",
              advv2: {
                type: "uint8",
                offset: 32,
                scale: 1
              }
            },
            {
              stateVariableName: "recordingSettings",
              advv2: {
                type: "uint8",
                offset: 33,
                scale: 1
              }
            },
            {
              stateVariableName: "triggerCollection",
              description: "Trigger waveform collection (write only)",
              modbus: {
                dataType: "float"
              }
            },
            {
              stateVariableName: "triggerStateUpdate",
              description: "Trigger state update collection (write only)",
              modbus: {
                dataType: "float"
              }
            }
          ];
          break;
        case phantomTypes.TRIAXIAL_UNIVERSAL:
          return [
            {
              stateVariableName: "type",
              description: "Sensor type",
              modbus: {
                gw1offset: 2,
                dataType: "uint32"
              },
              opc: {
                browseName: "type",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "version",
              description: "Sensor firmware version",
              modbus: {
                gw1offset: 13,
                dataType: "uint32"
              },
              opc: {
                browseName: "version",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "seq",
              description: "Sensor data update sequence",
              /*modbus: {
                  autoOffset: 2,
                  dataType: "uint32"
              },*/
              advv2: {
                type: "uint8",
                offset: 11,
                scale: 1
              }
            },
            {
              stateVariableName: "advFlags",
              advv2: {
                type: "uint16",
                offset: 12
              }
            },
            {
              stateVariableName: "batteryType",
              description: "Battery type",
              advv2: {
                type: "uint8",
                offset: 14,
                scale: 1
              },
              modbus: {
                gw1offset: 9,
                dataType: "uint32"
              },
              opc: {
                browseName: "batteryType",
                dataType: DataType.UInt32
              }
            },
            {
              stateVariableName: "battery",
              description: "Battery voltage",
              advv2: {
                type: "uint16",
                offset: 15,
                scale: 100
              },
              modbus: {
                gw1offset: 10,
                rawDataType: "uint16",
                dataType: "float"
              },
              opc: {
                browseName: "battery",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "temperature",
              description: "Sensor internal temperature",
              advv2: {
                type: "int16",
                offset: 17,
                scale: 100
              },
              modbus: {
                gw1offset: 11,
                rawDataType: "uint32",
                dataType: "float"
              },
              opc: {
                browseName: "temperature",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "updateInterval",
              description: "Sensor internal update interval",
              advv2: {
                type: "uint16",
                offset: 19,
                scale: 1
              }
            },
            {
              stateVariableName: "txPower",
              description: "Sensor radio transfer powers",
              advv2: {
                type: "uint8",
                offset: 21,
                scale: 1
              }
            },
            {
              stateVariableName: "minRMSFreq",
              advv2: {
                type: "uint16",
                offset: 22,
                scale: 1
              }
            },
            {
              stateVariableName: "maxRMSFreq",
              advv2: {
                type: "uint16",
                offset: 24,
                scale: 1
              }
            },
            {
              stateVariableName: "rms",
              description: "Vibration velocity RMS",
              advv2: {
                type: "uint16array",
                offset: 26,
                arraySize: 3,
                scale: 100
              },
              modbus: {
                gw1offset: 3,
                rawDataType: "uint32",
                dataType: "float",
                arraySize: 3
              },
              opc: {
                browseName: "rms",
                dataType: DataType.Double,
                isArray: true
              }
            },
            {
              stateVariableName: "tcTemperature",
              description: "Thermocouple temperature",
              advv2: {
                type: "int16array",
                offset: 32,
                arraySize: 2,
                scale: 100
              },
              modbus: {
                gw1offset: [
                  3,
                  13,
                  15
                ],
                rawDataType: "uint32",
                dataType: "float",
                arraySize: 2
              },
              opc: {
                browseName: "tcTemperature",
                dataType: DataType.Double,
                isArray: true
              }
            },
            {
              stateVariableName: "accumulatedCurrent",
              advv2: {
                type: "uint32array",
                offset: 36,
                arraySize: 3,
                scale: 100
              },
              modbus: {
                rawDataType: "uint32",
                dataType: "float",
                arraySize: 3
              },
              opc: {
                browseName: "accumulatedCurrent",
                dataType: DataType.Double,
                isArray: true
              }
            },
            {
              stateVariableName: "accumulatedStart",
              advv2: {
                type: "uint32",
                offset: 48,
                scale: 1
              },
              opc: {
                browseName: "accumulatedStart",
                dataType: DataType.UInt32
              }
            },
            {
              stateVariableName: "accumulatedEnd",
              advv2: {
                type: "uint32",
                offset: 52,
                scale: 1
              },
              opc: {
                browseName: "accumulatedEnd",
                dataType: DataType.UInt32
              }
            },
            {
              stateVariableName: "averageCurrent",
              description: "Average current in update period",
              advv2: {
                type: "uint16array",
                offset: 56,
                arraySize: 3,
                scale: 100
              },
              modbus: {
                gw1offset: 11,
                rawDataType: "uint32",
                dataType: "float",
                arraySize: 3
              },
              opc: {
                browseName: "averageCurrent",
                dataType: DataType.Double,
                isArray: true
              }
            },
            {
              stateVariableName: "minCurrent",
              description: "Lowest current in update period",
              advv2: {
                type: "uint16array",
                offset: 62,
                arraySize: 3,
                scale: 100
              },
              modbus: {
                gw1offset: 15,
                rawDataType: "uint32",
                dataType: "float",
                arraySize: 3
              },
              opc: {
                browseName: "minCurrent",
                dataType: DataType.Double,
                isArray: true
              }
            },
            {
              stateVariableName: "maxCurrent",
              description: "Highest current in update period",
              advv2: {
                type: "uint16array",
                offset: 68,
                arraySize: 3,
                scale: 100
              },
              modbus: {
                gw1offset: 19,
                rawDataType: "uint32",
                dataType: "float",
                arraySize: 3
              },
              opc: {
                browseName: "maxCurrent",
                dataType: DataType.Double,
                isArray: true
              }
            },
            {
              stateVariableName: "instCurrent",
              description: "Instantaneous current",
              advv2: {
                type: "uint16array",
                offset: 74,
                arraySize: 3,
                scale: 100
              },
              modbus: {
                gw1offset: 23,
                rawDataType: "uint32",
                dataType: "float",
                arraySize: 3
              },
              opc: {
                browseName: "instCurrent",
                dataType: DataType.Double,
                isArray: true
              }
            },
            {
              stateVariableName: "range",
              advv2: {
                type: "uint8",
                offset: 80,
                scale: 1
              }
            },
            {
              stateVariableName: "recordingSettings",
              advv2: {
                type: "uint8",
                offset: 81,
                scale: 1
              }
            },
            {
              stateVariableName: "triggerCollection",
              description: "Trigger waveform collection (write only)",
              modbus: {
                dataType: "float"
              }
            },
            {
              stateVariableName: "triggerStateUpdate",
              description: "Trigger state update collection (write only)",
              modbus: {
                dataType: "float"
              }
            }
          ];
          break;
        case phantomTypes.GP:
          return [
            {
              stateVariableName: "type",
              description: "Sensor type",
              modbus: {
                gw1offset: 2,
                dataType: "uint32"
              },
              opc: {
                browseName: "type",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "version",
              description: "Sensor firmware version",
              modbus: {
                gw1offset: 13,
                dataType: "uint32"
              },
              opc: {
                browseName: "version",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "seq",
              description: "Sensor data update sequence",
              /*modbus: {
                  autoOffset: 2,
                  dataType: "uint32"
              },*/
              advv2: {
                type: "uint8",
                offset: 11,
                scale: 1
              }
            },
            {
              stateVariableName: "advFlags",
              advv2: {
                type: "uint16",
                offset: 12
              }
            },
            {
              stateVariableName: "batteryType",
              description: "Battery type",
              advv2: {
                type: "uint8",
                offset: 14,
                scale: 1
              },
              modbus: {
                gw1offset: 9,
                dataType: "uint32"
              },
              opc: {
                browseName: "batteryType",
                dataType: DataType.UInt32
              }
            },
            {
              stateVariableName: "battery",
              description: "Battery voltage",
              advv2: {
                type: "uint16",
                offset: 15,
                scale: 100
              },
              modbus: {
                gw1offset: 10,
                rawDataType: "uint16",
                dataType: "float"
              },
              opc: {
                browseName: "battery",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "temperature",
              description: "Sensor internal temperature",
              advv2: {
                type: "int16",
                offset: 17,
                scale: 100
              },
              modbus: {
                gw1offset: 11,
                rawDataType: "uint32",
                dataType: "float"
              },
              opc: {
                browseName: "temperature",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "updateInterval",
              description: "Sensor internal update interval",
              advv2: {
                type: "uint16",
                offset: 19,
                scale: 1
              }
            },
            {
              stateVariableName: "txPower",
              description: "Sensor radio transfer powers",
              advv2: {
                type: "uint8",
                offset: 21,
                scale: 1
              }
            },
            {
              stateVariableName: "minRMSFreq",
              advv2: {
                type: "uint16",
                offset: 22,
                scale: 1
              }
            },
            {
              stateVariableName: "maxRMSFreq",
              advv2: {
                type: "uint16",
                offset: 24,
                scale: 1
              }
            },
            {
              stateVariableName: "sensitivity",
              advv2: {
                type: "uint32array",
                offset: 26,
                arraySize: 2,
                scale: 100
              }
            },
            {
              stateVariableName: "gpFlags",
              advv2: {
                type: "uint8",
                offset: 34
              }
            },
            {
              stateVariableName: "rms",
              description: "Vibration velocity RMS",
              advv2: {
                type: "uint16array",
                offset: 35,
                arraySize: 2,
                scale: 100
              },
              modbus: {
                gw1offset: 3,
                rawDataType: "uint32",
                dataType: "float",
                arraySize: 2
              },
              opc: {
                browseName: "rms",
                dataType: DataType.Double,
                isArray: true
              }
            },
            {
              stateVariableName: "triggerCollection",
              description: "Trigger waveform collection (write only)",
              modbus: {
                dataType: "float"
              }
            },
            {
              stateVariableName: "triggerStateUpdate",
              description: "Trigger state update collection (write only)",
              modbus: {
                dataType: "float"
              }
            }
          ];
          break;
        case phantomTypes.INFRARED:
          return [
            {
              stateVariableName: "type",
              description: "Sensor type",
              modbus: {
                gw1offset: 2,
                dataType: "uint32"
              },
              opc: {
                browseName: "type",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "version",
              description: "Sensor firmware version",
              modbus: {
                gw1offset: 13,
                dataType: "uint32"
              },
              opc: {
                browseName: "version",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "seq",
              description: "Sensor data update sequence",
              /*modbus: {
                  autoOffset: 2,
                  dataType: "uint32"
              },*/
              advv2: {
                type: "uint8",
                offset: 11,
                scale: 1
              }
            },
            {
              stateVariableName: "advFlags",
              advv2: {
                type: "uint16",
                offset: 12
              }
            },
            {
              stateVariableName: "batteryType",
              description: "Battery type",
              advv2: {
                type: "uint8",
                offset: 14,
                scale: 1
              },
              modbus: {
                gw1offset: 9,
                dataType: "uint32"
              },
              opc: {
                browseName: "batteryType",
                dataType: DataType.UInt32
              }
            },
            {
              stateVariableName: "battery",
              description: "Battery voltage",
              advv2: {
                type: "uint16",
                offset: 15,
                scale: 100
              },
              modbus: {
                gw1offset: 10,
                rawDataType: "uint16",
                dataType: "float"
              },
              opc: {
                browseName: "battery",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "temperature",
              description: "Sensor internal temperature",
              advv2: {
                type: "int16",
                offset: 17,
                scale: 100
              },
              modbus: {
                gw1offset: 7,
                rawDataType: "uint32",
                dataType: "float"
              },
              opc: {
                browseName: "temperature",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "updateInterval",
              description: "Sensor internal update interval",
              advv2: {
                type: "uint16",
                offset: 19,
                scale: 1
              }
            },
            {
              stateVariableName: "txPower",
              description: "Sensor radio transfer powers",
              advv2: {
                type: "uint8",
                offset: 21,
                scale: 1
              }
            },
            {
              stateVariableName: "ambientTemperature",
              description: "Ambient temperature",
              advv2: {
                type: "int16",
                offset: 22,
                scale: 100
              },
              modbus: {
                gw1offset: 9,
                rawDataType: "int32",
                dataType: "float"
              },
              opc: {
                browseName: "ambientTemperature",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "objectTemperature",
              description: "Infrarred object temperature",
              advv2: {
                type: "int16",
                offset: 24,
                scale: 100
              },
              modbus: {
                gw1offset: 3,
                rawDataType: "int32",
                dataType: "float"
              },
              opc: {
                browseName: "objectTemperature",
                dataType: DataType.Double
              }
            }
          ];
          break;
        case phantomTypes.DISTANCE:
          return [
            {
              stateVariableName: "type",
              description: "Sensor type",
              modbus: {
                gw1offset: 2,
                dataType: "uint32"
              },
              opc: {
                browseName: "type",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "version",
              description: "Sensor firmware version",
              modbus: {
                gw1offset: 13,
                dataType: "uint32"
              },
              opc: {
                browseName: "version",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "seq",
              description: "Sensor data update sequence",
              /*modbus: {
                  autoOffset: 2,
                  dataType: "uint32"
              },*/
              advv2: {
                type: "uint8",
                offset: 11,
                scale: 1
              }
            },
            {
              stateVariableName: "advFlags",
              advv2: {
                type: "uint16",
                offset: 12
              }
            },
            {
              stateVariableName: "batteryType",
              description: "Battery type",
              advv2: {
                type: "uint8",
                offset: 14,
                scale: 1
              },
              modbus: {
                gw1offset: 9,
                dataType: "uint32"
              },
              opc: {
                browseName: "batteryType",
                dataType: DataType.UInt32
              }
            },
            {
              stateVariableName: "battery",
              description: "Battery voltage",
              advv2: {
                type: "uint16",
                offset: 15,
                scale: 100
              },
              modbus: {
                gw1offset: 10,
                rawDataType: "uint16",
                dataType: "float"
              },
              opc: {
                browseName: "battery",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "temperature",
              description: "Sensor internal temperature",
              advv2: {
                type: "int16",
                offset: 17,
                scale: 100
              },
              modbus: {
                gw1offset: 7,
                rawDataType: "uint32",
                dataType: "float"
              },
              opc: {
                browseName: "temperature",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "updateInterval",
              description: "Sensor internal update interval",
              advv2: {
                type: "uint16",
                offset: 19,
                scale: 1
              }
            },
            {
              stateVariableName: "txPower",
              description: "Sensor radio transfer powers",
              advv2: {
                type: "uint8",
                offset: 21,
                scale: 1
              }
            },
            {
              stateVariableName: "distance",
              description: "Distance",
              advv2: {
                type: "int16",
                offset: 22,
                scale: 1
              },
              modbus: {
                gw1offset: 9,
                rawDataType: "uint16",
                dataType: "uint16"
              },
              opc: {
                browseName: "distance",
                dataType: DataType.UInt16
              }
            }
          ];
          break;
        case phantomTypes.THERMALCAMERA:
          return [
            {
              stateVariableName: "type",
              description: "Sensor type",
              modbus: {
                gw1offset: 2,
                dataType: "uint32"
              },
              opc: {
                browseName: "type",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "version",
              description: "Sensor firmware version",
              modbus: {
                gw1offset: 13,
                dataType: "uint32"
              },
              opc: {
                browseName: "version",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "seq",
              description: "Sensor data update sequence",
              /*modbus: {
                  autoOffset: 2,
                  dataType: "uint32"
              },*/
              advv2: {
                type: "uint8",
                offset: 11,
                scale: 1
              }
            },
            {
              stateVariableName: "advFlags",
              advv2: {
                type: "uint16",
                offset: 12
              }
            },
            {
              stateVariableName: "batteryType",
              description: "Battery type",
              advv2: {
                type: "uint8",
                offset: 14,
                scale: 1
              },
              modbus: {
                gw1offset: 9,
                dataType: "uint32"
              },
              opc: {
                browseName: "batteryType",
                dataType: DataType.UInt32
              }
            },
            {
              stateVariableName: "battery",
              description: "Battery voltage",
              advv2: {
                type: "uint16",
                offset: 15,
                scale: 100
              },
              modbus: {
                gw1offset: 10,
                rawDataType: "uint16",
                dataType: "float"
              },
              opc: {
                browseName: "battery",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "temperature",
              description: "Sensor internal temperature",
              advv2: {
                type: "int16",
                offset: 17,
                scale: 100
              },
              modbus: {
                gw1offset: 7,
                rawDataType: "uint32",
                dataType: "float"
              },
              opc: {
                browseName: "temperature",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "updateInterval",
              description: "Sensor internal update interval",
              advv2: {
                type: "uint16",
                offset: 19,
                scale: 1
              }
            },
            {
              stateVariableName: "txPower",
              description: "Sensor radio transfer powers",
              advv2: {
                type: "uint8",
                offset: 21,
                scale: 1
              }
            },
            {
              stateVariableName: "avgImageTemperature",
              description: "Average image temperature",
              advv2: {
                type: "int16",
                offset: 22,
                scale: 100
              },
              modbus: {
                gw1offset: 7,
                rawDataType: "int32",
                dataType: "float"
              },
              opc: {
                browseName: "avgImageTemperature",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "triggerCollection",
              description: "Trigger waveform collection (write only)",
              modbus: {
                dataType: "float"
              }
            },
            {
              stateVariableName: "triggerStateUpdate",
              description: "Trigger state update collection  (write only)",
              modbus: {
                dataType: "float"
              }
            }
          ];
          break;
        case phantomTypes.DIGITALINPUTS:
          return [
            {
              stateVariableName: "type",
              description: "Sensor type",
              modbus: {
                gw1offset: 2,
                dataType: "uint32"
              },
              opc: {
                browseName: "type",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "version",
              description: "Sensor firmware version",
              modbus: {
                gw1offset: 13,
                dataType: "uint32"
              },
              opc: {
                browseName: "version",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "seq",
              description: "Sensor data update sequence",
              /*modbus: {
                  autoOffset: 2,
                  dataType: "uint32"
              },*/
              advv2: {
                type: "uint8",
                offset: 11,
                scale: 1
              }
            },
            {
              stateVariableName: "advFlags",
              advv2: {
                type: "uint16",
                offset: 12
              }
            },
            {
              stateVariableName: "batteryType",
              description: "Battery type",
              advv2: {
                type: "uint8",
                offset: 14,
                scale: 1
              },
              modbus: {
                gw1offset: 9,
                dataType: "uint32"
              },
              opc: {
                browseName: "batteryType",
                dataType: DataType.UInt32
              }
            },
            {
              stateVariableName: "battery",
              description: "Battery voltage",
              advv2: {
                type: "uint16",
                offset: 15,
                scale: 100
              },
              modbus: {
                gw1offset: 10,
                rawDataType: "uint16",
                dataType: "float"
              },
              opc: {
                browseName: "battery",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "temperature",
              description: "Sensor internal temperature",
              advv2: {
                type: "int16",
                offset: 17,
                scale: 100
              },
              modbus: {
                gw1offset: 7,
                rawDataType: "uint32",
                dataType: "float"
              },
              opc: {
                browseName: "temperature",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "updateInterval",
              description: "Sensor internal update interval",
              advv2: {
                type: "uint16",
                offset: 19,
                scale: 1
              }
            },
            {
              stateVariableName: "txPower",
              description: "Sensor radio transfer powers",
              advv2: {
                type: "uint8",
                offset: 21,
                scale: 1
              }
            },
            {
              stateVariableName: "dryContactsState",
              advv2: {
                type: "uint8bitarray",
                offset: 22,
                arraySize: 4,
                scale: 1
              },
              modbus: {
                gw1offset: 11,
                rawDataType: "uint16",
                dataType: "uint32",
                arraySize: 4
              },
              opc: {
                browseName: "dryContactsState",
                dataType: DataType.Boolean,
                isArray: true
              }
            },
            {
              stateVariableName: "debounce",
              description: "Debounce setting",
              advv2: {
                type: "uint16",
                offset: 23,
                scale: 1
              }
            }
          ];
          break;
        case phantomTypes.THERMOCOUPLE:
        case phantomTypes.THERMOCOUPLE_V2:
          return [
            {
              stateVariableName: "type",
              description: "Sensor type",
              modbus: {
                gw1offset: 2,
                dataType: "uint32"
              },
              opc: {
                browseName: "type",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "version",
              description: "Sensor firmware version",
              modbus: {
                gw1offset: 9,
                dataType: "uint32"
              },
              opc: {
                browseName: "version",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "seq",
              description: "Sensor data update sequence",
              /*modbus: {
                  autoOffset: 2,
                  dataType: "uint16"
              },*/
              advv2: {
                type: "uint8",
                offset: 11,
                scale: 1
              }
            },
            {
              stateVariableName: "advFlags",
              advv2: {
                type: "uint16",
                offset: 12
              }
            },
            {
              stateVariableName: "batteryType",
              description: "Battery type",
              advv2: {
                type: "uint8",
                offset: 14,
                scale: 1
              },
              modbus: {
                gw1offset: 5,
                dataType: "uint32"
              },
              opc: {
                browseName: "batteryType",
                dataType: DataType.UInt32
              }
            },
            {
              stateVariableName: "battery",
              description: "Battery voltage",
              advv2: {
                type: "uint16",
                offset: 15,
                scale: 100
              },
              modbus: {
                gw1offset: 6,
                rawDataType: "uint16",
                dataType: "float"
              },
              opc: {
                browseName: "battery",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "temperature",
              description: "Sensor internal temperature",
              advv2: {
                type: "int16",
                offset: 17,
                scale: 100
              },
              modbus: {
                gw1offset: 7,
                rawDataType: "uint32",
                dataType: "float"
              },
              opc: {
                browseName: "temperature",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "updateInterval",
              description: "Sensor internal update interval",
              advv2: {
                type: "uint16",
                offset: 19,
                scale: 1
              }
            },
            {
              stateVariableName: "txPower",
              description: "Sensor radio transfer powers",
              advv2: {
                type: "uint8",
                offset: 21,
                scale: 1
              }
            },
            {
              stateVariableName: "tcTemperature",
              description: "Thermocouple temperature",
              advv2: {
                type: "int16array",
                offset: 22,
                arraySize: 3,
                scale: 100
              },
              modbus: {
                gw1offset: [
                  3,
                  13,
                  15
                ],
                rawDataType: "uint32",
                dataType: "float",
                arraySize: 3
              },
              opc: {
                browseName: "tcTemperature",
                dataType: DataType.Double,
                isArray: true
              }
            }
          ];
          break;
        case phantomTypes.THERMOCOUPLE_V3:
          return [
            {
              stateVariableName: "type",
              description: "Sensor type",
              modbus: {
                gw1offset: 2,
                dataType: "uint32"
              },
              opc: {
                browseName: "type",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "version",
              description: "Sensor firmware version",
              modbus: {
                gw1offset: 9,
                dataType: "uint32"
              },
              opc: {
                browseName: "version",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "seq",
              description: "Sensor data update sequence",
              /*modbus: {
                  autoOffset: 2,
                  dataType: "uint16"
              },*/
              advv2: {
                type: "uint8",
                offset: 11,
                scale: 1
              }
            },
            {
              stateVariableName: "advFlags",
              advv2: {
                type: "uint16",
                offset: 12
              }
            },
            {
              stateVariableName: "batteryType",
              description: "Battery type",
              advv2: {
                type: "uint8",
                offset: 14,
                scale: 1
              },
              modbus: {
                gw1offset: 5,
                dataType: "uint32"
              },
              opc: {
                browseName: "batteryType",
                dataType: DataType.UInt32
              }
            },
            {
              stateVariableName: "battery",
              description: "Battery voltage",
              advv2: {
                type: "uint16",
                offset: 15,
                scale: 100
              },
              modbus: {
                gw1offset: 6,
                rawDataType: "uint16",
                dataType: "float"
              },
              opc: {
                browseName: "battery",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "temperature",
              description: "Sensor internal temperature",
              advv2: {
                type: "int16",
                offset: 17,
                scale: 100
              },
              modbus: {
                gw1offset: 7,
                rawDataType: "uint32",
                dataType: "float"
              },
              opc: {
                browseName: "temperature",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "updateInterval",
              description: "Sensor internal update interval",
              advv2: {
                type: "uint16",
                offset: 19,
                scale: 1
              }
            },
            {
              stateVariableName: "txPower",
              description: "Sensor radio transfer powers",
              advv2: {
                type: "uint8",
                offset: 21,
                scale: 1
              }
            },
            {
              stateVariableName: "tcTemperature",
              description: "Thermocouple temperature",
              advv2: {
                type: "int16array",
                offset: 22,
                arraySize: 2,
                scale: 100
              },
              modbus: {
                gw1offset: [
                  3,
                  13
                ],
                rawDataType: "uint32",
                dataType: "float",
                arraySize: 2
              },
              opc: {
                browseName: "tcTemperature",
                dataType: DataType.Double,
                isArray: true
              }
            }
          ];
          break;
        case phantomTypes.CURRENT_V1:
        case phantomTypes.CURRENT_V2:
          return [
            {
              stateVariableName: "type",
              description: "Sensor type",
              modbus: {
                gw1offset: 2,
                dataType: "uint32"
              },
              opc: {
                browseName: "type",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "version",
              description: "Sensor firmware version",
              modbus: {
                gw1offset: 9,
                dataType: "uint32"
              },
              opc: {
                browseName: "version",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "seq",
              description: "Sensor data update sequence",
              advv2: {
                type: "uint8",
                offset: 11,
                scale: 1
              }
            },
            {
              stateVariableName: "advFlags",
              advv2: {
                type: "uint16",
                offset: 12
              }
            },
            {
              stateVariableName: "batteryType",
              description: "Battery type",
              advv2: {
                type: "uint8",
                offset: 14,
                scale: 1
              },
              modbus: {
                gw1offset: 3,
                dataType: "uint32"
              },
              opc: {
                browseName: "batteryType",
                dataType: DataType.UInt32
              }
            },
            {
              stateVariableName: "battery",
              description: "Battery voltage",
              advv2: {
                type: "uint16",
                offset: 15,
                scale: 100
              },
              modbus: {
                gw1offset: 4,
                rawDataType: "uint16",
                dataType: "float"
              },
              opc: {
                browseName: "battery",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "temperature",
              description: "Sensor internal temperature",
              advv2: {
                type: "int16",
                offset: 17,
                scale: 100
              },
              modbus: {
                gw1offset: 5,
                rawDataType: "uint32",
                dataType: "float"
              },
              opc: {
                browseName: "temperature",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "updateInterval",
              description: "Sensor internal update interval",
              advv2: {
                type: "uint16",
                offset: 19,
                scale: 1
              }
            },
            {
              stateVariableName: "txPower",
              description: "Sensor radio transfer powers",
              advv2: {
                type: "uint8",
                offset: 21,
                scale: 1
              }
            },
            {
              stateVariableName: "currentProbeType",
              advv2: {
                type: "uint8array",
                offset: 22,
                arraySize: 4,
                scale: 1
              },
              opc: {
                browseName: "currentProbeType",
                dataType: DataType.UInt16,
                isArray: true
              }
            },
            {
              stateVariableName: "currentOffsets",
              advv2: {
                type: "uint32array",
                offset: 26,
                arraySize: 4,
                scale: 1e6
              },
              opc: {
                browseName: "currentOffsets",
                dataType: DataType.Double,
                isArray: true
              }
            },
            {
              stateVariableName: "currentMultiplier",
              advv2: {
                type: "uint32array",
                offset: 42,
                arraySize: 4,
                scale: 1e6
              },
              opc: {
                browseName: "currentMultiplier",
                dataType: DataType.Double,
                isArray: true
              }
            },
            {
              stateVariableName: "instCurrent",
              description: "Instantaneous current",
              advv2: {
                type: "uint16array",
                offset: 58,
                arraySize: 4,
                scale: 100
              },
              modbus: {
                gw1offset: 23,
                rawDataType: "uint32",
                dataType: "float",
                arraySize: 4
              },
              opc: {
                browseName: "instCurrent",
                dataType: DataType.Double,
                isArray: true
              }
            },
            {
              stateVariableName: "averageCurrent",
              description: "Average current in update period",
              advv2: {
                type: "uint16array",
                offset: 66,
                arraySize: 4,
                scale: 100
              },
              modbus: {
                gw1offset: 11,
                rawDataType: "uint32",
                dataType: "float",
                arraySize: 4
              },
              opc: {
                browseName: "averageCurrent",
                dataType: DataType.Double,
                isArray: true
              }
            },
            {
              stateVariableName: "minCurrent",
              description: "Lowest current in update period",
              advv2: {
                type: "uint16array",
                offset: 74,
                arraySize: 4,
                scale: 100
              },
              modbus: {
                gw1offset: 15,
                rawDataType: "uint32",
                dataType: "float",
                arraySize: 4
              },
              opc: {
                browseName: "minCurrent",
                dataType: DataType.Double,
                isArray: true
              }
            },
            {
              stateVariableName: "maxCurrent",
              description: "Highest current in update period",
              advv2: {
                type: "uint16array",
                offset: 82,
                arraySize: 4,
                scale: 100
              },
              modbus: {
                gw1offset: 19,
                rawDataType: "uint32",
                dataType: "float",
                arraySize: 4
              },
              opc: {
                browseName: "maxCurrent",
                dataType: DataType.Double,
                isArray: true
              }
            },
            {
              stateVariableName: "accumulatedCurrent",
              description: "Accumulated current since reset",
              advv2: {
                type: "uint32array",
                offset: 90,
                arraySize: 4,
                scale: 100
              },
              modbus: {
                rawDataType: "uint32",
                dataType: "float",
                arraySize: 4
              },
              opc: {
                browseName: "accumulatedCurrent",
                dataType: DataType.Double,
                isArray: true
              }
            },
            {
              stateVariableName: "accumulatedStart",
              advv2: {
                type: "uint32",
                offset: 106,
                scale: 1
              },
              opc: {
                browseName: "accumulatedStart",
                dataType: DataType.UInt32
              }
            },
            {
              stateVariableName: "accumulatedEnd",
              advv2: {
                type: "uint32",
                offset: 110,
                scale: 1
              },
              opc: {
                browseName: "accumulatedEnd",
                dataType: DataType.UInt32
              }
            }
          ];
          break;
        case phantomTypes.RPM:
          return [
            {
              stateVariableName: "type",
              description: "Sensor type",
              modbus: {
                gw1offset: 2,
                dataType: "uint32"
              },
              opc: {
                browseName: "type",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "version",
              description: "Sensor firmware version",
              modbus: {
                gw1offset: 9,
                dataType: "uint32"
              },
              opc: {
                browseName: "version",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "seq",
              description: "Sensor data update sequence",
              /*modbus: {
                  autoOffset: 2,
                  dataType: "uint32"
              },*/
              advv2: {
                type: "uint8",
                offset: 11,
                scale: 1
              }
            },
            {
              stateVariableName: "advFlags",
              advv2: {
                type: "uint16",
                offset: 12
              }
            },
            {
              stateVariableName: "batteryType",
              description: "Battery type",
              advv2: {
                type: "uint8",
                offset: 14,
                scale: 1
              },
              modbus: {
                gw1offset: 5,
                dataType: "uint32"
              },
              opc: {
                browseName: "batteryType",
                dataType: DataType.UInt32
              }
            },
            {
              stateVariableName: "battery",
              description: "Battery voltage",
              advv2: {
                type: "uint16",
                offset: 15,
                scale: 100
              },
              modbus: {
                gw1offset: 6,
                rawDataType: "uint16",
                dataType: "float"
              },
              opc: {
                browseName: "battery",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "temperature",
              description: "Sensor internal temperature",
              advv2: {
                type: "int16",
                offset: 17,
                scale: 100
              },
              modbus: {
                gw1offset: 7,
                rawDataType: "uint32",
                dataType: "float"
              },
              opc: {
                browseName: "temperature",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "updateInterval",
              description: "Sensor internal update interval",
              advv2: {
                type: "uint16",
                offset: 19,
                scale: 1
              }
            },
            {
              stateVariableName: "txPower",
              description: "Sensor radio transfer powers",
              advv2: {
                type: "uint8",
                offset: 21,
                scale: 1
              }
            },
            {
              stateVariableName: "rpm",
              description: "Revolutions per minute (RPM)",
              advv2: {
                type: "uint32",
                offset: 22,
                scale: 100
              },
              modbus: {
                gw1offset: 3,
                rawDataType: "uint32",
                dataType: "float"
              },
              opc: {
                browseName: "rpm",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "rpmTimeout",
              description: "rpm sensor timeout",
              advv2: {
                type: "uint16",
                offset: 26,
                scale: 10
              }
            }
          ];
          break;
        case phantomTypes.SENSOR420MA:
          return [
            {
              stateVariableName: "type",
              description: "Sensor type",
              modbus: {
                gw1offset: 2,
                dataType: "uint32"
              },
              opc: {
                browseName: "type",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "version",
              description: "Sensor firmware version",
              modbus: {
                gw1offset: 17,
                dataType: "uint32"
              },
              opc: {
                browseName: "version",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "seq",
              description: "Sensor data update sequence",
              /*modbus: {
                  autoOffset: 2,
                  dataType: "uint32"
              },*/
              advv2: {
                type: "uint8",
                offset: 11,
                scale: 1
              }
            },
            {
              stateVariableName: "advFlags",
              advv2: {
                type: "uint16",
                offset: 12
              }
            },
            {
              stateVariableName: "batteryType",
              description: "Battery type",
              advv2: {
                type: "uint8",
                offset: 14,
                scale: 1
              },
              modbus: {
                gw1offset: 5,
                dataType: "uint32"
              },
              opc: {
                browseName: "batteryType",
                dataType: DataType.UInt32
              }
            },
            {
              stateVariableName: "battery",
              description: "Battery voltage",
              advv2: {
                type: "uint16",
                offset: 15,
                scale: 100
              },
              modbus: {
                gw1offset: 6,
                rawDataType: "uint16",
                dataType: "float"
              },
              opc: {
                browseName: "battery",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "temperature",
              description: "Sensor internal temperature",
              advv2: {
                type: "int16",
                offset: 17,
                scale: 100
              },
              modbus: {
                gw1offset: 7,
                rawDataType: "uint32",
                dataType: "float"
              },
              opc: {
                browseName: "temperature",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "updateInterval",
              description: "Sensor internal update interval",
              advv2: {
                type: "uint16",
                offset: 19,
                scale: 1
              }
            },
            {
              stateVariableName: "txPower",
              description: "Sensor radio transfer powers",
              advv2: {
                type: "uint8",
                offset: 21,
                scale: 1
              }
            },
            {
              stateVariableName: "voltage",
              description: "Sensor measured voltage",
              advv2: {
                type: "uint16array",
                offset: 22,
                arraySize: 4,
                scale: 1e3
              },
              modbus: {
                gw1offset: [
                  3,
                  9,
                  13,
                  15
                ],
                rawDataType: "uint32",
                dataType: "float",
                arraySize: 4
              },
              opc: {
                browseName: "voltage",
                dataType: DataType.Double,
                isArray: true
              }
            }
          ];
          break;
        case phantomTypes.VOLTIMETER:
          return [
            {
              stateVariableName: "type",
              description: "Sensor type",
              modbus: {
                gw1offset: 2,
                dataType: "uint32"
              },
              opc: {
                browseName: "type",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "version",
              description: "Sensor firmware version",
              modbus: {
                gw1offset: 17,
                dataType: "uint32"
              },
              opc: {
                browseName: "version",
                dataType: DataType.UInt16
              }
            },
            {
              stateVariableName: "seq",
              description: "Sensor data update sequence",
              advv2: {
                type: "uint8",
                offset: 11,
                scale: 1
              }
            },
            {
              stateVariableName: "advFlags",
              advv2: {
                type: "uint16",
                offset: 12
              }
            },
            {
              stateVariableName: "batteryType",
              description: "Battery type",
              advv2: {
                type: "uint8",
                offset: 14,
                scale: 1
              },
              modbus: {
                gw1offset: 5,
                dataType: "uint32"
              },
              opc: {
                browseName: "batteryType",
                dataType: DataType.UInt32
              }
            },
            {
              stateVariableName: "battery",
              description: "Battery voltage",
              advv2: {
                type: "uint16",
                offset: 15,
                scale: 100
              },
              modbus: {
                gw1offset: 6,
                rawDataType: "uint16",
                dataType: "float"
              },
              opc: {
                browseName: "battery",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "temperature",
              description: "Sensor internal temperature",
              advv2: {
                type: "int16",
                offset: 17,
                scale: 100
              },
              modbus: {
                gw1offset: 7,
                rawDataType: "uint32",
                dataType: "float"
              },
              opc: {
                browseName: "temperature",
                dataType: DataType.Double
              }
            },
            {
              stateVariableName: "updateInterval",
              description: "Sensor internal update interval",
              advv2: {
                type: "uint16",
                offset: 19,
                scale: 1
              }
            },
            {
              stateVariableName: "txPower",
              description: "Sensor radio transfer powers",
              advv2: {
                type: "uint8",
                offset: 21,
                scale: 1
              }
            },
            {
              stateVariableName: "voltage",
              description: "Sensor measured voltage",
              advv2: {
                type: "uint16array",
                offset: 22,
                arraySize: 4,
                scale: 1e3
              },
              modbus: {
                gw1offset: [
                  3,
                  9,
                  13,
                  15
                ],
                rawDataType: "uint32",
                dataType: "float",
                arraySize: 4
              },
              opc: {
                browseName: "voltage",
                dataType: DataType.Double,
                isArray: true
              }
            }
          ];
          break;
      }
    }
    module2.exports = {
      getSensorDefinition,
      phantomTypes,
      getLookupSensorDefinition,
      getDefaultUpdateFilename,
      getCanForceUpdateAdv,
      getCanDoCodedAdv,
      getCanDoFastAdv
    };
  }
});

// src/crypto.js
var require_crypto = __commonJS({
  "src/crypto.js"(exports2, module2) {
    "use strict";
    var Buffer2 = require("buffer").Buffer;
    var gwutils2 = require_gwutils();
    var crypto2 = require("crypto");
    var fs2 = require("fs").promises;
    var path3 = require("path");
    var configpath = gwutils2.getDataDirectory("config");
    var keychainpath = path3.join(configpath, "keychain");
    var g_GlobalKeyList = {};
    var gwCrypto2 = class {
      static async init() {
        try {
          let keylist = JSON.parse(await fs2.readFile(keychainpath, "utf8"));
          for (let key in keylist) {
            g_GlobalKeyList[key] = {
              connKey: Buffer2.from(keylist[key].connKey, "hex"),
              advKey: Buffer2.from(keylist[key].advKey, "hex")
            };
          }
        } catch (e) {
        }
      }
      static async generateAESKeyAsync() {
        let promise = new Promise(function(resolve2, reject) {
          crypto2.generateKey("aes", {
            length: 128
          }, (err, key) => {
            resolve2(key.export({ format: "buffer" }));
          });
        });
        return promise;
      }
      static getAllKeys() {
        let keyList = {};
        for (let key in g_GlobalKeyList) {
          keyList[key] = {
            connKey: g_GlobalKeyList[key].connKey.toString("hex"),
            advKey: g_GlobalKeyList[key].advKey.toString("hex")
          };
        }
        return keyList;
      }
      static mergeSensorKeys(keyList) {
        try {
          for (let key in keyList) {
            g_GlobalKeyList[key] = {
              connKey: Buffer2.from(keyList[key].connKey, "hex"),
              advKey: Buffer2.from(keyList[key].advKey, "hex")
            };
          }
          this.saveKeysToDisk();
        } catch (e) {
        }
      }
      static saveKey(phantomCode, connKey, advKey) {
        g_GlobalKeyList[phantomCode] = {
          connKey,
          advKey
        };
        this.saveKeysToDisk();
      }
      static saveKeysToDisk() {
        try {
          let keyList = this.getAllKeys();
          gwutils2.writeFileReliabily(keychainpath, JSON.stringify(keyList));
        } catch (e) {
        }
      }
      static getKey(phantomCode, type) {
        try {
          return g_GlobalKeyList[phantomCode][type];
        } catch (e) {
        }
        return null;
      }
    };
    module2.exports = {
      gwCrypto: gwCrypto2
    };
  }
});

// src/phantomService.js
var require_phantomService = __commonJS({
  "src/phantomService.js"(exports2, module2) {
    "use strict";
    var Buffer2 = require("buffer").Buffer;
    var ble2 = require_nrf_ble();
    var gwutils2 = require_gwutils();
    var sensorDefinition2 = require_sensorDefinition();
    var crypto2 = require("crypto");
    var gwCrypto2 = require_crypto().gwCrypto;
    var phantomServiceCmds = {
      VERSION: 1,
      TYPE: 2,
      CONFIG: 3,
      APPLYCONFIG: 4,
      ACCELGETDATA: 5,
      ACCEL_SENDTOGW: 7,
      JUMP_TO_BOOTLOADER: 8,
      SLEEP_DEEPLY: 9,
      THERMAL_GETDATA: 10,
      GET_SMALLDATA: 11,
      GET_SMALLDATASTREAM: 12,
      ACCEL_SYNC_SENDTOGW: 14,
      PHANTOM_CFG_CMD_ACCEL_GETDATA_STORED: 15,
      PHANTOM_CFG_CMD_GET_BATTERY: 16,
      PHANTOM_CFG_CMD_GET_SYNC_MASTERS: 17,
      PHANTOM_CFG_CMD_GET_TEMPERATURE: 18,
      PHANTOM_CFG_CMD_BLINK: 19,
      PHANTOM_CFG_CMD_CHANGE_ADV_INTERVAL: 20,
      PHANTOM_CFG_CMD_UPDATE_SMALL_DATA: 21,
      PHANTOM_CFG_CMD_CURRENT_ACCUMULATION: 22,
      WRITEFLAG: 128
    };
    var phantomService2 = class _phantomService {
      static phantomV1AdvFlags = {
        GW1_ADV_FLAGS_NEEDS_SD_UPDATE: 1,
        GW1_ADV_FLAGS_GW1_DISABLED: 2,
        GW1_ADV_FLAGS_INITIAL_ADV: 4,
        GW1_ADV_FLAGS_IGNORE_ADV2: 8,
        GW1_ADV_FLAGS_PERMANENT_ADVERTISING: 16
      };
      static phantomV2AdvFlags = {
        GW2_ADV_FLAGS_COLLECT_NOW: 1,
        GW2_ADV_FLAGS_GW1_DISABLED: 2,
        GW2_ADV_FLAGS_PERMANENT_ADVERTISING: 4,
        GW2_ADV_FLAGS_HIPERF_ADVERTISING: 8,
        GW2_ADV_FLAGS_HAVE_BIG_DATA: 16,
        GW2_ADV_FLAGS_WAITING_FOR_SYNC: 32,
        GW2_ADV_FLAGS_CODED_PHY_ADV: 64,
        GW2_ADV_FLAGS_HAVE_AMP: 128,
        GW2_ADV_FLAGS_AMP_ENABLED: 256,
        GW2_ADV_FLAGS_HAVE_MEMORY: 512,
        // Triaxial 
        GW2_ADV_FLAGS_FAST_ADV1: 4096,
        GW2_ADV_FLAGS_FAST_ADV2: 8192,
        GW2_ADV_FLAGS_IS_ATEX: 16384,
        GW2_ADV_FLAGS_EXTENDED_RMS_POINTS: 32768,
        // RPM
        GW2_ADV_FLAGS_RPM_HIGHPERFORMACE: 32768
      };
      constructor(bledevice, connKey, phantomCode) {
        this.bledevice = bledevice;
        this.connection = null;
        this.connKey = connKey;
        this.phantomCode = phantomCode;
      }
      static parsePhantomAdvDataVariables(type, manuPayload, retdata) {
        try {
          const sensorDef = sensorDefinition2.getSensorDefinition(type);
          for (let i = 0; i < sensorDef.length; i++) {
            const variable = sensorDef[i];
            if (!variable.advv2)
              continue;
            let value = 0;
            switch (variable.advv2.type) {
              case "uint8":
                value = manuPayload[variable.advv2.offset] / (variable.advv2.scale ? variable.advv2.scale : 1);
                break;
              case "int16":
                value = manuPayload.readInt16LE(variable.advv2.offset) / (variable.advv2.scale ? variable.advv2.scale : 1);
                break;
              case "uint16":
                value = manuPayload.readUInt16LE(variable.advv2.offset) / (variable.advv2.scale ? variable.advv2.scale : 1);
                break;
              case "uint32":
                value = manuPayload.readUInt32LE(variable.advv2.offset) / (variable.advv2.scale ? variable.advv2.scale : 1);
                break;
              case "uint8array":
                value = [];
                for (let iArray = 0; iArray < variable.advv2.arraySize; iArray++) {
                  value[iArray] = manuPayload[variable.advv2.offset + iArray] / (variable.advv2.scale ? variable.advv2.scale : 1);
                }
                break;
              case "uint16array":
                value = [];
                for (let iArray = 0; iArray < variable.advv2.arraySize; iArray++) {
                  value[iArray] = manuPayload.readUInt16LE(variable.advv2.offset + iArray * 2) / (variable.advv2.scale ? variable.advv2.scale : 1);
                }
                break;
              case "int16array":
                value = [];
                for (let iArray = 0; iArray < variable.advv2.arraySize; iArray++) {
                  value[iArray] = manuPayload.readInt16LE(variable.advv2.offset + iArray * 2) / (variable.advv2.scale ? variable.advv2.scale : 1);
                }
                break;
              case "uint32array":
                value = [];
                for (let iArray = 0; iArray < variable.advv2.arraySize; iArray++) {
                  value[iArray] = manuPayload.readUInt32LE(variable.advv2.offset + iArray * 4) / (variable.advv2.scale ? variable.advv2.scale : 1);
                }
                break;
              case "uint8bitarray":
                value = [];
                for (let iArray = 0; iArray < variable.advv2.arraySize; iArray++) {
                  let mask = 1 << iArray;
                  value[iArray] = manuPayload[variable.advv2.offset] & mask ? true : false;
                }
                break;
            }
            retdata[variable.stateVariableName] = value;
          }
        } catch (e) {
        }
        return retdata;
      }
      static parsePhantomV1HeaderGetType(header) {
        return header[26];
      }
      static parsePhantomV1ThermalImageHeader(header) {
        let retdata = {};
        retdata.type = header[26];
        retdata.phantomCode = header.readUInt32LE(0);
        retdata.dataSize = header.readUInt32LE(4);
        retdata.eimu_version = header[8];
        retdata.columns = header[9];
        retdata.rows = header[10];
        retdata.bytesperPixel = header[11];
        retdata.frames = header[12];
        retdata.frameRate = header[13];
        if (!retdata.frames)
          retdata.frames = 1;
        if (!retdata.frameRate)
          retdata.frameRate = 1;
        return retdata;
      }
      static parsePhantomV1SignalHeader(header) {
        let retdata = {};
        retdata.type = header[26];
        retdata.phantomCode = header.readUInt32LE(0);
        retdata.dataLen = header.readUInt32LE(4);
        retdata.eimu_version = header[8];
        retdata.axisCount = header[9] & 3;
        retdata.selectedAxis = header[9] >> 2;
        retdata.sampleRate = header.readUInt16LE(10);
        if (retdata.type == 60) {
          retdata.calibration = header.readFloatLE(12);
        } else {
          retdata.range = header[12];
        }
        retdata.timestamp = header.readUInt32LE(13);
        return retdata;
      }
      static smallDataToJSON(node, captureTime, gwGlobalState) {
        let mqttData = {};
        mqttData.rssi = node.rssi;
        mqttData.type = node.type;
        mqttData.version = node.version;
        mqttData.phantomCode = node.phantomCode;
        mqttData.gwSerial = gwGlobalState.deviceInfo.serialNumber;
        mqttData.timestamp = captureTime;
        mqttData.dataType = "stateupdate";
        if (node.settings?.friendlyName) {
          mqttData.friendlyName = node.settings.friendlyName;
        }
        const sensorDef = sensorDefinition2.getSensorDefinition(node.type);
        for (let i = 0; i < sensorDef.length; i++) {
          const variable = sensorDef[i];
          mqttData[variable.stateVariableName] = node.advdatav2[variable.stateVariableName];
        }
        return mqttData;
      }
      static bigDataToJSON(eventdata, gwGlobalState) {
        try {
          let data = [];
          let metadata = this.parsePhantomV1SignalHeader(eventdata.header);
          if (metadata.timestamp == 0)
            metadata.timestamp = eventdata.signalData.captureTime;
          data.push([]);
          data.push([]);
          data.push([]);
          if (metadata) {
            let calibration = metadata.range / 32768;
            if (metadata.axisCount == 3) {
              for (let i = 0; i * 6 < metadata.dataLen; i++) {
                data[0].push(eventdata.data.readInt16LE(i * 6 + 0) * calibration);
                data[1].push(eventdata.data.readInt16LE(i * 6 + 2) * calibration);
                data[2].push(eventdata.data.readInt16LE(i * 6 + 4) * calibration);
              }
            } else if (metadata.axisCount == 1) {
              for (let i = 0; i * 2 < metadata.dataLen; i++) {
                data[metadata.selectedAxis].push(eventdata.data.readInt16LE(i * 2 + 0) * calibration);
              }
            }
          }
          let mqttData = {
            serialNumber: metadata.phantomCode,
            sampleRate: metadata.sampleRate,
            gwSerial: gwGlobalState.deviceInfo.serialNumber,
            timestamp: metadata.timestamp,
            type: metadata.type,
            dataType: "collection",
            data
          };
          let node = gwGlobalState.nodes[metadata.phantomCode];
          if (node && node.settings?.friendlyName) {
            mqttData.friendlyName = node.settings.friendlyName;
          }
          return mqttData;
        } catch (e) {
          console.log("Error when trying to generate json mensage: ", e.message);
        }
        return null;
      }
      static isTriaxial(type) {
        return type == sensorDefinition2.phantomTypes.TRIAXIAL_KX222 || type == sensorDefinition2.phantomTypes.TRIAXIAL_KX122 || type == sensorDefinition2.phantomTypes.TRIAXIAL_KX134 || type == sensorDefinition2.phantomTypes.TRIAXIAL_UNIVERSAL;
      }
      static isTriaxialHighRange(type) {
        return type == sensorDefinition2.phantomTypes.TRIAXIAL_KX222 || type == sensorDefinition2.phantomTypes.TRIAXIAL_KX134;
      }
      static isTriaxialLowRange(type) {
        return type == sensorDefinition2.phantomTypes.TRIAXIAL_KX122;
      }
      static isTriaxialUniversal(type) {
        return type == sensorDefinition2.phantomTypes.TRIAXIAL_UNIVERSAL;
      }
      static isGP(type) {
        return type == sensorDefinition2.phantomTypes.GP;
      }
      static isThermalImage(type) {
        return type == sensorDefinition2.phantomTypes.THERMALCAMERA;
      }
      static isCurrentSensor(type) {
        return type == sensorDefinition2.phantomTypes.CURRENT_V1 || type == sensorDefinition2.phantomTypes.CURRENT_V2;
      }
      static isRPMSensor(type) {
        return type == sensorDefinition2.phantomTypes.RPM;
      }
      static is420maSensor(type) {
        return type == sensorDefinition2.phantomTypes.SENSOR420MA;
      }
      static isVoltimeterSensor(type) {
        return type == sensorDefinition2.phantomTypes.VOLTIMETER;
      }
      static isInfrared(type) {
        return type == sensorDefinition2.phantomTypes.INFRARED;
      }
      static isDistance(type) {
        return type == sensorDefinition2.phantomTypes.DISTANCE;
      }
      static isDryContacts(type) {
        return type == sensorDefinition2.phantomTypes.DIGITALINPUTS;
      }
      static isThermoCouple(type) {
        return type == sensorDefinition2.phantomTypes.THERMOCOUPLE_V2 || type == sensorDefinition2.phantomTypes.THERMOCOUPLE || type == sensorDefinition2.phantomTypes.THERMOCOUPLE_V3;
      }
      static parsePhantomV1AdvData(advdata, gwGlobalState) {
        let retdata = {};
        let manu_payload = advdata.manufacturer;
        retdata.company_id = manu_payload.readUInt16LE(0);
        retdata.phantomCode = manu_payload.readUInt32LE(2);
        retdata.version = 0;
        if (advdata.name == "PE" || advdata.name.startsWith("E")) {
          retdata.gw2adv = true;
          retdata.encrypted = true;
          let key = gwCrypto2.getKey(retdata.phantomCode, "advKey");
          if (key) {
            try {
              retdata.missingkey = false;
              let nonce = manu_payload.subarray(6, 19);
              let mac = manu_payload.subarray(19, 27);
              const decipher = crypto2.createDecipheriv("aes-128-ccm", key, nonce, {
                authTagLength: 8
              });
              decipher.setAuthTag(mac);
              let decrypted = decipher.update(manu_payload.subarray(27));
              decipher.final();
              decrypted.copy(manu_payload, 6);
              retdata.decrypted = true;
            } catch (err) {
              console.log("error decrypting", err.message);
              manu_payload = manu_payload.subarray(0, 6);
              retdata.decrypted = false;
              retdata.decryptFail = true;
            }
          } else {
            manu_payload = manu_payload.subarray(0, 6);
            advdata.missingkey = true;
            retdata.decrypted = false;
            retdata.decryptFail = true;
          }
        }
        if (manu_payload.length >= 9) {
          retdata.version = manu_payload.readUInt16LE(6);
          retdata.type = manu_payload[8];
          if (retdata.version >= sensorDefinition2.getCanForceUpdateAdv(retdata.type))
            retdata.canForceUpdate = true;
          else
            retdata.canForceUpdate = false;
          if (retdata.version >= sensorDefinition2.getCanDoCodedAdv(retdata.type))
            retdata.canDoCodedAdv = true;
          else
            retdata.canDoCodedAdv = false;
          if (retdata.version >= sensorDefinition2.getCanDoFastAdv(retdata.type))
            retdata.canDoFastAdv = true;
          else
            retdata.canDoFastAdv = false;
        }
        if (manu_payload.length == 9) {
          retdata.needsupdate = true;
        }
        if (manu_payload.length == 10) {
          retdata.gw2adv = true;
          retdata.v1AdvFlags = manu_payload[9];
          if (retdata.v1AdvFlags & _phantomService.phantomV1AdvFlags.GW1_ADV_FLAGS_NEEDS_SD_UPDATE) {
            retdata.needsupdate = true;
          }
          retdata.initialAdvertising = retdata.v1AdvFlags & _phantomService.phantomV1AdvFlags.GW1_ADV_FLAGS_INITIAL_ADV ? true : false;
          retdata.ignoreAdv1 = retdata.v1AdvFlags & _phantomService.phantomV1AdvFlags.GW1_ADV_FLAGS_IGNORE_ADV2 ? true : false;
          retdata.gw1Disabled = retdata.v1AdvFlags & _phantomService.phantomV1AdvFlags.GW1_ADV_FLAGS_GW1_DISABLED ? true : false;
          retdata.advertisingEnabled = retdata.v1AdvFlags & _phantomService.phantomV1AdvFlags.GW1_ADV_FLAGS_PERMANENT_ADVERTISING ? true : false;
        }
        if (retdata.type) {
          if (_phantomService.isTriaxial(retdata.type)) {
            if (manu_payload.length == 14) {
              if (retdata.version == 0 || retdata.version < 178)
                retdata.needsupdate = true;
            } else if (manu_payload.length > 14) {
              retdata.cmd = manu_payload[10];
              if (retdata.cmd == 1) {
                retdata.gw2adv = true;
                retdata.canupdateSettings = true;
                retdata.candownloaddata = true;
                _phantomService.parsePhantomAdvDataVariables(retdata.type, manu_payload, retdata);
                if (retdata.gw2adv && retdata.advFlags) {
                  if (retdata.advFlags & _phantomService.phantomV2AdvFlags.GW2_ADV_FLAGS_IS_ATEX) {
                    retdata.isAtex = true;
                  }
                  if (retdata.advFlags) {
                    let bit0 = retdata.advFlags & _phantomService.phantomV2AdvFlags.GW2_ADV_FLAGS_FAST_ADV1 ? 1 : 0;
                    let bit1 = retdata.advFlags & _phantomService.phantomV2AdvFlags.GW2_ADV_FLAGS_FAST_ADV2 ? 1 : 0;
                    retdata.advInterval = bit1 << 1 | bit0;
                  }
                }
              } else if (retdata.cmd == 2) {
                let gwSerialCollection = manu_payload.readUInt32LE(11);
                if (gwSerialCollection == gwGlobalState.deviceInfo.serialNumber)
                  retdata.haveDataToCollect = true;
                retdata.gw2merge = true;
                retdata.canupdateSettings = true;
                retdata.candownloaddata = true;
              }
            }
          } else if (_phantomService.isGP(retdata.type)) {
            if (manu_payload.length > 14) {
              retdata.cmd = manu_payload[10];
              if (retdata.cmd == 1) {
                retdata.gw2adv = true;
                retdata.canupdateSettings = true;
                retdata.candownloaddata = true;
                _phantomService.parsePhantomAdvDataVariables(retdata.type, manu_payload, retdata);
              }
            }
          } else if (_phantomService.isThermalImage(retdata.type)) {
            if (manu_payload.length == 14) {
            } else if (manu_payload.length > 14) {
              retdata.cmd = manu_payload[10];
              if (retdata.cmd == 1) {
                retdata.gw2adv = true;
                retdata.canupdateSettings = 1;
                retdata.candownloaddata = true;
                _phantomService.parsePhantomAdvDataVariables(retdata.type, manu_payload, retdata);
              }
            }
          } else if (_phantomService.isInfrared(retdata.type)) {
            if (manu_payload.length == 14) {
            } else if (manu_payload.length > 14) {
              retdata.cmd = manu_payload[10];
              if (retdata.cmd == 1) {
                retdata.gw2adv = true;
                retdata.canupdateSettings = 1;
                _phantomService.parsePhantomAdvDataVariables(retdata.type, manu_payload, retdata);
              }
            }
          } else if (_phantomService.isDistance(retdata.type)) {
            if (manu_payload.length == 14) {
            } else if (manu_payload.length > 14) {
              retdata.cmd = manu_payload[10];
              if (retdata.cmd == 1) {
                retdata.gw2adv = true;
                retdata.canupdateSettings = 1;
                _phantomService.parsePhantomAdvDataVariables(retdata.type, manu_payload, retdata);
              }
            }
          } else if (_phantomService.isDryContacts(retdata.type)) {
            if (manu_payload.length == 14) {
            } else if (manu_payload.length > 14) {
              retdata.cmd = manu_payload[10];
              if (retdata.cmd == 1) {
                retdata.gw2adv = true;
                retdata.canupdateSettings = 1;
                _phantomService.parsePhantomAdvDataVariables(retdata.type, manu_payload, retdata);
              }
            }
          } else if (_phantomService.isThermoCouple(retdata.type)) {
            if (manu_payload.length == 14) {
            } else if (manu_payload.length > 14) {
              retdata.cmd = manu_payload[10];
              if (retdata.cmd == 1) {
                retdata.gw2adv = true;
                retdata.canupdateSettings = 1;
                _phantomService.parsePhantomAdvDataVariables(retdata.type, manu_payload, retdata);
              }
            }
          } else if (_phantomService.isCurrentSensor(retdata.type)) {
            retdata.cmd = manu_payload[10];
            if (retdata.cmd == 1) {
              retdata.gw2adv = true;
              retdata.canupdateSettings = 1;
              _phantomService.parsePhantomAdvDataVariables(retdata.type, manu_payload, retdata);
            }
          } else if (_phantomService.isRPMSensor(retdata.type)) {
            retdata.cmd = manu_payload[10];
            if (retdata.cmd == 1) {
              retdata.gw2adv = true;
              retdata.canupdateSettings = 1;
              _phantomService.parsePhantomAdvDataVariables(retdata.type, manu_payload, retdata);
              if (retdata.gw2adv && retdata.advFlags) {
                if (retdata.advFlags & _phantomService.phantomV2AdvFlags.GW2_ADV_FLAGS_RPM_HIGHPERFORMACE) {
                  retdata.highPerformace = true;
                }
              }
            }
          } else if (_phantomService.is420maSensor(retdata.type)) {
            retdata.cmd = manu_payload[10];
            if (retdata.cmd == 1) {
              retdata.gw2adv = true;
              retdata.canupdateSettings = 1;
              _phantomService.parsePhantomAdvDataVariables(retdata.type, manu_payload, retdata);
            }
          } else if (_phantomService.isVoltimeterSensor(retdata.type)) {
            retdata.cmd = manu_payload[10];
            if (retdata.cmd == 1) {
              retdata.gw2adv = true;
              retdata.canupdateSettings = 1;
              _phantomService.parsePhantomAdvDataVariables(retdata.type, manu_payload, retdata);
            }
          }
        }
        if (retdata.gw2adv && retdata.advFlags) {
          if (retdata.advFlags & _phantomService.phantomV2AdvFlags.GW2_ADV_FLAGS_GW1_DISABLED) {
            retdata.gw1Disabled = true;
          }
          if (retdata.advFlags & _phantomService.phantomV2AdvFlags.GW2_ADV_FLAGS_PERMANENT_ADVERTISING) {
            retdata.advertisingEnabled = true;
          }
          if (retdata.advFlags & _phantomService.phantomV2AdvFlags.GW2_ADV_FLAGS_HIPERF_ADVERTISING) {
            retdata.highPerformaceAdv = true;
          }
          if (retdata.advFlags & _phantomService.phantomV2AdvFlags.GW2_ADV_FLAGS_HAVE_BIG_DATA) {
            retdata.haveDataToCollect = true;
          }
          if (retdata.advFlags & _phantomService.phantomV2AdvFlags.GW2_ADV_FLAGS_WAITING_FOR_SYNC) {
            retdata.waitingForPhantomSync = true;
          }
          if (retdata.advFlags & _phantomService.phantomV2AdvFlags.GW2_ADV_FLAGS_CODED_PHY_ADV) {
            retdata.longRange = true;
          }
          if (retdata.advFlags & _phantomService.phantomV2AdvFlags.GW2_ADV_FLAGS_HAVE_AMP) {
            retdata.hasAmplifier = true;
          }
          if (retdata.advFlags & _phantomService.phantomV2AdvFlags.GW2_ADV_FLAGS_AMP_ENABLED) {
            retdata.amplifierEnabled = true;
          }
          if (retdata.advFlags & _phantomService.phantomV2AdvFlags.GW2_ADV_FLAGS_HAVE_MEMORY) {
            retdata.hasExtendedMemory = true;
          }
        }
        return retdata;
      }
      static convertToUint32(value) {
        let data = Buffer2.alloc(4);
        data.writeInt32LE(value);
        return data.readUint32LE(0);
      }
      static packBatteryAndType(batteryVoltage, batteryType) {
        let data = Buffer2.alloc(4);
        data.writeInt16LE(batteryVoltage, 0);
        data.writeInt16LE(batteryType, 2);
        return data.readUint32LE(0);
      }
      static createPhantomv1CompatibleRMSUniversalMessage(advertisingData) {
        let message = "6;";
        if (!advertisingData.rms)
          return null;
        message += advertisingData.phantomCode + ";";
        message += advertisingData.type + ";";
        message += "1;";
        message += (advertisingData.rms[0] * 100).toFixed() + ";";
        message += (advertisingData.rms[1] * 100).toFixed() + ";";
        message += (advertisingData.rms[2] * 100).toFixed() + ";";
        message += _phantomService.packBatteryAndType((advertisingData.battery * 100).toFixed(), advertisingData.batteryType) + ";";
        message += _phantomService.convertToUint32((advertisingData.temperature * 100).toFixed()) + ";";
        message += advertisingData.version + ";";
        let message2 = "6;";
        message2 += advertisingData.phantomCode + ";";
        message2 += advertisingData.type + ";";
        message2 += "2;";
        message2 += _phantomService.packBatteryAndType((advertisingData.battery * 100).toFixed(), advertisingData.batteryType) + ";";
        message2 += _phantomService.convertToUint32((advertisingData.temperature * 100).toFixed()) + ";";
        message2 += advertisingData.version + ";";
        message2 += advertisingData.seq + ";";
        function packTwoInt16(v1, v2) {
          let a = (v1 * 100).toFixed();
          let b = (v2 * 100).toFixed();
          return a << 16 | b;
        }
        message2 += packTwoInt16(advertisingData.averageCurrent[0], advertisingData.averageCurrent[1]) + ";";
        message2 += packTwoInt16(advertisingData.averageCurrent[2], advertisingData.averageCurrent[3]) + ";";
        message2 += packTwoInt16(advertisingData.minCurrent[0], advertisingData.minCurrent[1]) + ";";
        message2 += packTwoInt16(advertisingData.minCurrent[2], advertisingData.minCurrent[3]) + ";";
        message2 += packTwoInt16(advertisingData.maxCurrent[0], advertisingData.maxCurrent[1]) + ";";
        message2 += packTwoInt16(advertisingData.maxCurrent[2], advertisingData.maxCurrent[3]) + ";";
        let message3 = "6;";
        message3 += advertisingData.phantomCode + ";";
        message3 += advertisingData.type + ";";
        message3 += "3;";
        message3 += (advertisingData.accumulatedCurrent[0] * 100).toFixed() + ";";
        message3 += (advertisingData.accumulatedCurrent[1] * 100).toFixed() + ";";
        message3 += (advertisingData.accumulatedCurrent[2] * 100).toFixed() + ";";
        message3 += "0;";
        message3 += (advertisingData.accumulatedStart * 100).toFixed() + ";";
        message3 += (advertisingData.accumulatedEnd * 100).toFixed() + ";";
        let message4 = "6;";
        message4 += advertisingData.phantomCode + ";";
        message4 += advertisingData.type + ";";
        message4 += "4;";
        message4 += _phantomService.convertToUint32((advertisingData.tcTemperature[0] * 100).toFixed()) + ";";
        message4 += _phantomService.packBatteryAndType((advertisingData.battery * 100).toFixed(), advertisingData.batteryType) + ";";
        message4 += _phantomService.convertToUint32((advertisingData.temperature * 100).toFixed()) + ";";
        message4 += advertisingData.version + ";";
        message4 += advertisingData.seq + ";";
        message4 += _phantomService.convertToUint32((advertisingData.tcTemperature[1] * 100).toFixed()) + ";";
        message4 += "0;";
        return [message, message2, message3, message4];
      }
      static createPhantomv1CompatibleRMSMessage(advertisingData, node) {
        let message = "6;";
        if (!advertisingData.rms)
          return null;
        let batteryType = advertisingData.batteryType;
        if (node.settings?.misc?.usingBatteryKit)
          batteryType = 4;
        message += advertisingData.phantomCode + ";";
        message += advertisingData.type + ";";
        message += "1;";
        message += (advertisingData.rms[0] * 100).toFixed() + ";";
        message += (advertisingData.rms[1] * 100).toFixed() + ";";
        message += (advertisingData.rms[2] * 100).toFixed() + ";";
        message += _phantomService.packBatteryAndType((advertisingData.battery * 100).toFixed(), batteryType) + ";";
        message += _phantomService.convertToUint32((advertisingData.temperature * 100).toFixed()) + ";";
        message += advertisingData.version + ";";
        return [message];
      }
      static createPhantomv1ThermoCoupleMessage(advertisingData) {
        let message = "6;";
        message += advertisingData.phantomCode + ";";
        if (advertisingData.type == 22)
          message += "22;";
        else
          message += "21;";
        message += "0;";
        message += _phantomService.convertToUint32((advertisingData.tcTemperature[0] * 100).toFixed()) + ";";
        message += _phantomService.packBatteryAndType((advertisingData.battery * 100).toFixed(), advertisingData.batteryType) + ";";
        message += _phantomService.convertToUint32((advertisingData.temperature * 100).toFixed()) + ";";
        message += advertisingData.version + ";";
        message += advertisingData.seq + ";";
        message += _phantomService.convertToUint32((advertisingData.tcTemperature[1] * 100).toFixed()) + ";";
        let temp3 = 0;
        if (advertisingData.tcTemperature[2])
          temp3 = advertisingData.tcTemperature[2];
        message += _phantomService.convertToUint32((temp3 * 100).toFixed()) + ";";
        return [message];
      }
      static createPhantomv1CompatibleGPRMSMessage(advertisingData) {
        let message = "6;";
        if (!advertisingData.rms)
          return null;
        message += advertisingData.phantomCode + ";";
        message += advertisingData.type + ";";
        message += "1;";
        message += (advertisingData.rms[0] * 100).toFixed() + ";";
        message += (advertisingData.rms[1] * 100).toFixed() + ";";
        message += "0;";
        message += (advertisingData.battery * 100).toFixed() + ";";
        message += _phantomService.convertToUint32((advertisingData.temperature * 100).toFixed()) + ";";
        message += "0;";
        message += "0;";
        message += "0;";
        message += "0;";
        message += "0;";
        return [message];
      }
      static createPhantomv1CompatibleThermalMessage(advertisingData) {
        let message = "6;";
        message += advertisingData.phantomCode + ";";
        message += advertisingData.type + ";";
        message += "0;";
        message += (advertisingData.avgImageTemperature * 100).toFixed() + ";";
        message += "0;";
        message += _phantomService.packBatteryAndType((advertisingData.battery * 100).toFixed(), advertisingData.batteryType) + ";";
        message += _phantomService.convertToUint32((advertisingData.temperature * 100).toFixed()) + ";";
        message += advertisingData.version + ";";
        return [message];
      }
      static createPhantomv1CompatibleCurrentMessages(advertisingData) {
        let message = "6;";
        message += advertisingData.phantomCode + ";";
        message += "32;";
        message += "0;";
        message += _phantomService.packBatteryAndType((advertisingData.battery * 100).toFixed(), advertisingData.batteryType) + ";";
        message += _phantomService.convertToUint32((advertisingData.temperature * 100).toFixed()) + ";";
        message += advertisingData.version + ";";
        message += advertisingData.seq + ";";
        function packTwoInt16(v1, v2) {
          let a = (v1 * 100).toFixed();
          let b = (v2 * 100).toFixed();
          return a << 16 | b;
        }
        message += packTwoInt16(advertisingData.averageCurrent[0], advertisingData.averageCurrent[1]) + ";";
        message += packTwoInt16(advertisingData.averageCurrent[2], advertisingData.averageCurrent[3]) + ";";
        message += packTwoInt16(advertisingData.minCurrent[0], advertisingData.minCurrent[1]) + ";";
        message += packTwoInt16(advertisingData.minCurrent[2], advertisingData.minCurrent[3]) + ";";
        message += packTwoInt16(advertisingData.maxCurrent[0], advertisingData.maxCurrent[1]) + ";";
        message += packTwoInt16(advertisingData.maxCurrent[2], advertisingData.maxCurrent[3]) + ";";
        let message2 = "6;";
        message2 += advertisingData.phantomCode + ";";
        message2 += "32;";
        message2 += "1;";
        message2 += (advertisingData.accumulatedCurrent[0] * 100).toFixed() + ";";
        message2 += (advertisingData.accumulatedCurrent[1] * 100).toFixed() + ";";
        message2 += (advertisingData.accumulatedCurrent[2] * 100).toFixed() + ";";
        message2 += (advertisingData.accumulatedCurrent[3] * 100).toFixed() + ";";
        message2 += advertisingData.accumulatedStart.toFixed() + ";";
        message2 += advertisingData.accumulatedEnd.toFixed() + ";";
        return [message, message2];
      }
      static createPhantomv1CompatibleInfraredMessage(advertisingData) {
        let message = "6;";
        message += advertisingData.phantomCode + ";";
        message += advertisingData.type + ";";
        message += "0;";
        message += (advertisingData.objectTemperature * 100).toFixed() + ";";
        message += _phantomService.packBatteryAndType((advertisingData.battery * 100).toFixed(), advertisingData.batteryType) + ";";
        message += _phantomService.convertToUint32((advertisingData.temperature * 100).toFixed()) + ";";
        message += (advertisingData.ambientTemperature * 100).toFixed() + ";";
        message += advertisingData.version + ";";
        message += advertisingData.seq + ";";
        return [message];
      }
      static createPhantomv1CompatibleRPMMessage(advertisingData) {
        let message = "6;";
        message += advertisingData.phantomCode + ";";
        message += advertisingData.type + ";";
        message += "0;";
        message += (advertisingData.rpm * 100).toFixed() + ";";
        message += _phantomService.packBatteryAndType((advertisingData.battery * 100).toFixed(), advertisingData.batteryType) + ";";
        message += _phantomService.convertToUint32((advertisingData.temperature * 100).toFixed()) + ";";
        message += advertisingData.version + ";";
        message += advertisingData.seq + ";";
        return [message];
      }
      static createPhantomv1Compatible420Message(advertisingData) {
        let message = "6;";
        message += advertisingData.phantomCode + ";";
        message += advertisingData.type + ";";
        message += "0;";
        message += (advertisingData.voltage[0] * 1e3).toFixed() + ";";
        message += _phantomService.packBatteryAndType((advertisingData.battery * 100).toFixed(), advertisingData.batteryType) + ";";
        message += _phantomService.convertToUint32((advertisingData.temperature * 100).toFixed()) + ";";
        message += (advertisingData.voltage[1] * 1e3).toFixed() + ";";
        message += (advertisingData.voltage[2] * 1e3).toFixed() + ";";
        message += (advertisingData.voltage[3] * 1e3).toFixed() + ";";
        message += advertisingData.version + ";";
        message += advertisingData.seq + ";";
        return [message];
      }
      static createPhantomv1CompatibleVoltimeterMessage(advertisingData) {
        let message = "6;";
        message += advertisingData.phantomCode + ";";
        message += advertisingData.type + ";";
        message += "0;";
        message += (advertisingData.voltage[0] * 1e3).toFixed() + ";";
        message += _phantomService.packBatteryAndType((advertisingData.battery * 100).toFixed(), advertisingData.batteryType) + ";";
        message += _phantomService.convertToUint32((advertisingData.temperature * 100).toFixed()) + ";";
        message += (advertisingData.voltage[1] * 1e3).toFixed() + ";";
        message += (advertisingData.voltage[2] * 1e3).toFixed() + ";";
        message += (advertisingData.voltage[3] * 1e3).toFixed() + ";";
        message += advertisingData.version + ";";
        message += advertisingData.seq + ";";
        return [message];
      }
      static createPhantomv1CompatibleDryContactsMessage(advertisingData) {
        let message = "6;";
        message += advertisingData.phantomCode + ";";
        message += advertisingData.type + ";";
        message += "0;";
        message += _phantomService.packBatteryAndType((advertisingData.battery * 100).toFixed(), advertisingData.batteryType) + ";";
        message += _phantomService.convertToUint32((advertisingData.temperature * 100).toFixed()) + ";";
        let pins = 0;
        if (advertisingData.dryContactsState?.[0])
          pins |= 1;
        if (advertisingData.dryContactsState?.[1])
          pins |= 2;
        if (advertisingData.dryContactsState?.[2])
          pins |= 4;
        if (advertisingData.dryContactsState?.[3])
          pins |= 8;
        message += pins.toFixed() + ";";
        message += advertisingData.version + ";";
        message += advertisingData.seq + ";";
        return [message];
      }
      static createPhantomv1CompatibleRSSIMessage(advertisingData, node) {
        let message = "6;";
        message += advertisingData.phantomCode + ";";
        message += "253;";
        message += "1;";
        let data = Buffer2.alloc(4);
        data[0] = node.ch_index;
        data[1] = node.ch_index;
        data.writeInt8(node.rssi, 2);
        data.writeInt8(node.rssi, 3);
        message += data.readUint32LE(0).toString() + ";";
        return message;
      }
      static createPhantomV1SmallMessages(node, advertisingData) {
        let messages = null;
        if (!advertisingData || !advertisingData.gw2adv)
          return null;
        if (_phantomService.isTriaxialUniversal(advertisingData.type)) {
          messages = _phantomService.createPhantomv1CompatibleRMSUniversalMessage(advertisingData);
        } else if (_phantomService.isTriaxial(advertisingData.type)) {
          messages = _phantomService.createPhantomv1CompatibleRMSMessage(advertisingData, node);
        } else if (_phantomService.isGP(advertisingData.type)) {
          messages = _phantomService.createPhantomv1CompatibleGPRMSMessage(advertisingData);
        } else if (_phantomService.isThermalImage(advertisingData.type)) {
          messages = _phantomService.createPhantomv1CompatibleThermalMessage(advertisingData);
        } else if (_phantomService.isInfrared(advertisingData.type)) {
          messages = _phantomService.createPhantomv1CompatibleInfraredMessage(advertisingData);
        } else if (_phantomService.isCurrentSensor(advertisingData.type)) {
          messages = _phantomService.createPhantomv1CompatibleCurrentMessages(advertisingData);
        } else if (_phantomService.isRPMSensor(advertisingData.type)) {
          messages = _phantomService.createPhantomv1CompatibleRPMMessage(advertisingData);
        } else if (_phantomService.is420maSensor(advertisingData.type)) {
          messages = _phantomService.createPhantomv1Compatible420Message(advertisingData);
        } else if (_phantomService.isVoltimeterSensor(advertisingData.type)) {
          messages = _phantomService.createPhantomv1CompatibleVoltimeterMessage(advertisingData);
        } else if (_phantomService.isThermoCouple(advertisingData.type)) {
          messages = _phantomService.createPhantomv1ThermoCoupleMessage(advertisingData);
        } else if (_phantomService.isDryContacts(advertisingData.type)) {
          messages = _phantomService.createPhantomv1CompatibleDryContactsMessage(advertisingData);
        }
        if (messages) {
          messages.push(_phantomService.createPhantomv1CompatibleRSSIMessage(advertisingData, node));
        }
        return messages;
      }
      static createPhantomv1CompatibleSignalHeader(metaData) {
        let header = Buffer2.alloc(32);
        header[0] = 50;
        header[1] = 1;
        header[2] = metaData.phantomCode & 255;
        header[3] = (metaData.phantomCode & 65280) >> 8;
        header[4] = (metaData.phantomCode & 16711680) >> 16;
        header[5] = (metaData.phantomCode & 4278190080) >> 24;
        header[6] = 0;
        header[7] = 0;
        header[8] = metaData.dataLen & 255;
        header[9] = (metaData.dataLen & 65280) >> 8;
        header[10] = (metaData.dataLen & 16711680) >> 16;
        header[11] = (metaData.dataLen & 4278190080) >> 24;
        header[12] = 2;
        header[13] = metaData.axisCount & 3 | (metaData.selectedAxis & 3) << 2;
        header[14] = metaData.sampleRate & 255;
        header[15] = (metaData.sampleRate & 65280) >> 8;
        if (_phantomService.isGP(metaData.type)) {
          header.writeFloatLE(metaData.calibration, 16);
        } else {
          header[16] = metaData.range;
          header[17] = metaData.triggered ? 255 : 42;
          header[18] = 42;
          header[19] = 42;
        }
        header[20] = metaData.alarm ? 1 : 0;
        header[21] = _phantomService.isGP(metaData.type) ? 60 : 0;
        header[22] = metaData.start ? 1 : 0;
        header[23] = 0;
        header[24] = 0;
        header[25] = 0;
        header[26] = 0;
        header[27] = 0;
        let localTimestamp = gwutils2.offsetTimestampLocalTime(metaData.timestamp);
        header[28] = localTimestamp & 255;
        header[29] = (localTimestamp & 65280) >> 8;
        header[30] = (localTimestamp & 16711680) >> 16;
        header[31] = (localTimestamp & 4278190080) >> 24;
        return header;
      }
      static createPhantomv1CompatibleThermalImageHeader(phantomCode, columns, rows, dataLen, frames, frameRate, timestamp) {
        let header = Buffer2.alloc(32);
        header[0] = 52;
        header[1] = 1;
        header[2] = phantomCode & 255;
        header[3] = (phantomCode & 65280) >> 8;
        header[4] = (phantomCode & 16711680) >> 16;
        header[5] = (phantomCode & 4278190080) >> 24;
        header[6] = columns;
        header[7] = rows;
        header[8] = dataLen & 255;
        header[9] = (dataLen & 65280) >> 8;
        header[10] = (dataLen & 16711680) >> 16;
        header[11] = (dataLen & 4278190080) >> 24;
        header[12] = 1;
        header[13] = frames;
        header[14] = frameRate;
        header[15] = 0;
        header[16] = 0;
        header[17] = 42;
        header[18] = 42;
        header[19] = 42;
        header[20] = 0;
        header[21] = 0;
        header[22] = 0;
        header[23] = 0;
        header[24] = 0;
        header[25] = 0;
        header[26] = 0;
        header[27] = 0;
        let localTimestamp = gwutils2.offsetTimestampLocalTime(timestamp);
        header[28] = localTimestamp & 255;
        header[29] = (localTimestamp & 65280) >> 8;
        header[30] = (localTimestamp & 16711680) >> 16;
        header[31] = (localTimestamp & 4278190080) >> 24;
        return header;
      }
      async connect(recordtime) {
        if (!recordtime)
          this.connection = await ble2.connect(this.bledevice, 10, 8e3, 0);
        else if (recordtime <= 3)
          this.connection = await ble2.connect(this.bledevice, 60, 1e4, 60);
        else
          this.connection = await ble2.connect(this.bledevice, 60, 32e3, 260);
        if (this.connection) {
          console.log("Enabling notifications");
          await gwutils2.sleep(500);
          let response = await ble2.enableNotif(this.connection, 14, true);
          if (response && this.connKey) {
            if (this.connKey) {
              console.log("encrypting...");
              response = await ble2.enableEncryption(this.connection, this.connKey);
              this.encrypted = this.connection.encrypted;
            }
          }
        }
        return this.connection;
      }
      async pairConnection() {
        let ret = await ble2.pairConnection(this.connection);
        this.encrypted = this.connection.encrypted;
        return ret;
      }
      async disconnect() {
        return ble2.disconnect(this.connection);
      }
      writeToPhantomControl(cmd, payload, waitresponse, longdata, progresscb) {
        let message = Buffer2.alloc((payload ? payload.length : 0) + 1);
        message[0] = cmd;
        if (payload)
          payload.copy(message, 1);
        this.connection.longdata = longdata;
        this.connection.longdata_header = null;
        this.connection.longdata_size = 0;
        this.connection.longdata_pos = 0;
        this.connection.currentProgress = 0;
        this.connection.longProgress = progresscb;
        return ble2.writeChar(this.connection, 13, message);
      }
      async getBatteryLevel() {
        let response = await this.writeToPhantomControl(phantomServiceCmds.PHANTOM_CFG_CMD_GET_BATTERY, null, true, false, null);
        let centivolts = 0;
        if (response)
          centivolts = response.readUInt32LE(1);
        return centivolts / 100;
      }
      async getInternalTemperature() {
        let response = await this.writeToPhantomControl(phantomServiceCmds.PHANTOM_CFG_CMD_GET_TEMPERATURE, null, true, false, null);
        let centivolts = 0;
        if (response)
          centivolts = response.readUInt32LE(1);
        return centivolts / 100;
      }
      async getConfigBlock(block) {
        let response = await this.writeToPhantomControl(phantomServiceCmds.CONFIG, Buffer2.from([block]), true, false, null);
        return response;
      }
      async setConfigBlock(block, blockData) {
        let payload = Buffer2.alloc(blockData.length + 1);
        payload[0] = block;
        blockData.copy(payload, 1, 0);
        return await this.writeToPhantomControl(phantomServiceCmds.CONFIG | phantomServiceCmds.WRITEFLAG, payload, true, false, null);
      }
      async applyConfig() {
        return await this.writeToPhantomControl(phantomServiceCmds.APPLYCONFIG, null, true, false, null);
      }
      async putToSleep() {
        return this.writeToPhantomControl(phantomServiceCmds.SLEEP_DEEPLY, null, true, false, null);
      }
      async blink() {
        return await this.writeToPhantomControl(phantomServiceCmds.PHANTOM_CFG_CMD_BLINK, null, true, false, null);
      }
      async updateState() {
        return await this.writeToPhantomControl(phantomServiceCmds.PHANTOM_CFG_CMD_UPDATE_SMALL_DATA, null, true, false, null);
      }
      async resetCurrentAccumulation(timestamp) {
        let payload = Buffer2.alloc(4);
        payload.writeUInt32LE(timestamp, 0);
        return this.writeToPhantomControl(phantomServiceCmds.PHANTOM_CFG_CMD_CURRENT_ACCUMULATION, payload, true, false, null);
      }
      async setHighPerformaceAdv(enable, interval) {
        let payload = Buffer2.alloc(3);
        payload[0] = enable ? 1 : 0;
        if (!interval)
          interval = 0;
        payload.writeUInt16LE(interval / 0.625, 1);
        return this.writeToPhantomControl(phantomServiceCmds.PHANTOM_CFG_CMD_CHANGE_ADV_INTERVAL, payload, true, false, null);
      }
      generateGW2BasicConfig1(txPower, updateInterval, gw1, advertising, onlygw1valid, longRange, amplifierEnabled, advInterval) {
        let blockData = Buffer2.alloc(4);
        blockData.writeUInt16LE(updateInterval, 0);
        blockData[2] = txPower;
        blockData[3] = 0;
        if (advertising)
          blockData[3] |= 1;
        if (!gw1)
          blockData[3] |= 2;
        if (onlygw1valid)
          blockData[3] |= 4;
        if (longRange)
          blockData[3] |= 8;
        if (amplifierEnabled) {
          blockData[3] |= 64;
        }
        switch (advInterval) {
          case 0:
            break;
          case 1:
            blockData[3] |= 16;
            break;
          case 2:
            blockData[3] |= 32;
            break;
          case 3:
            blockData[3] |= 16;
            blockData[3] |= 32;
            break;
        }
        return blockData;
      }
      generateGW2KeyConfig1(enable, connKey, advKey) {
        let blockData = Buffer2.alloc(33);
        blockData[0] = enable ? 1 : 0;
        advKey.copy(blockData, 1);
        connKey.copy(blockData, 17);
        return blockData;
      }
      generateGW2CurrentConfig1(probeTypes, multipliers, offsets) {
        let blockData = Buffer2.alloc(36);
        blockData[0] = probeTypes[0];
        blockData[1] = probeTypes[1];
        blockData[2] = probeTypes[2];
        blockData[3] = probeTypes[3];
        blockData.writeUInt32LE((offsets[0] * 1e6).toFixed(), 4);
        blockData.writeUInt32LE((multipliers[0] * 1e6).toFixed(), 8);
        blockData.writeUInt32LE((offsets[1] * 1e6).toFixed(), 12);
        blockData.writeUInt32LE((multipliers[1] * 1e6).toFixed(), 16);
        blockData.writeUInt32LE((offsets[2] * 1e6).toFixed(), 20);
        blockData.writeUInt32LE((multipliers[2] * 1e6).toFixed(), 24);
        blockData.writeUInt32LE((offsets[3] * 1e6).toFixed(), 28);
        blockData.writeUInt32LE((multipliers[3] * 1e6).toFixed(), 32);
        return blockData;
      }
      generateGW2TriaxialConfig1(minRMS, maxRMS, range, recordingSettings, extRMS) {
        let blockData = Buffer2.alloc(7);
        blockData.writeUInt16LE(minRMS, 0);
        blockData.writeUInt16LE(maxRMS, 2);
        blockData[4] = range;
        blockData[5] = recordingSettings;
        blockData[6] = 0;
        if (extRMS)
          blockData[6] |= 1;
        return blockData;
      }
      generateGW2GPConfig1(minRMS, maxRMS, sensitivity, calculateVelocity) {
        let blockData = Buffer2.alloc(13);
        blockData.writeUInt16LE(minRMS, 0);
        blockData.writeUInt16LE(maxRMS, 2);
        blockData.writeUInt32LE(Math.floor(sensitivity[0] * 100), 4);
        blockData.writeUInt32LE(Math.floor(sensitivity[1] * 100), 8);
        blockData[12] = calculateVelocity ? 1 : 0;
        return blockData;
      }
      generateGW2RPMConfig1(highPerformace, rpmTimeout) {
        let blockData = Buffer2.alloc(3);
        blockData[0] = highPerformace;
        blockData.writeUInt16LE(rpmTimeout * 10, 1);
        return blockData;
      }
      generateGW2DryContactsConfig1(debounce) {
        let blockData = Buffer2.alloc(2);
        blockData.writeUInt16LE(debounce, 0);
        return blockData;
      }
      generateGWDisplayConfig(phantomCode, displayName, flags) {
        let blockData = Buffer2.alloc(28);
        let nameBuffer = Buffer2.from(displayName, "ascii");
        blockData.writeUInt32LE(phantomCode, 0);
        nameBuffer.copy(blockData, 4, 0, 20);
        blockData.writeUInt32LE(flags, 24);
        return blockData;
      }
      async downloadPhantomThermalImage(frames, rate, emissivity, progresscb) {
        let settingArray = Buffer2.alloc(3);
        settingArray[0] = frames;
        settingArray[1] = rate;
        settingArray[2] = (emissivity * 100).toFixed();
        let captureTime = Math.floor(Date.now() / 1e3);
        await this.writeToPhantomControl(phantomServiceCmds.THERMAL_GETDATA, settingArray, true, true, progresscb);
        return {
          data: this.connection.longdata_payload,
          header: this.connection.longdata_header,
          captureTime
        };
      }
      async downloadPhantomSignalGP(progresscb) {
        let settingArray = Buffer2.alloc(4);
        let captureTime = Math.floor(Date.now() / 1e3);
        await this.writeToPhantomControl(phantomServiceCmds.ACCELGETDATA, settingArray, true, true, progresscb);
        return {
          data: this.connection.longdata_payload,
          header: this.connection.longdata_header,
          captureTime
        };
      }
      async downloadPhantomSignal(options, progresscb) {
        let settingArray = Buffer2.alloc(25);
        settingArray[0] = options.range;
        if (options.axisCount == 3) {
          switch (options.sampleRate) {
            case 25600:
              settingArray[1] = 0;
              break;
            case 12800:
              settingArray[1] = 1;
              break;
            case 6400:
              settingArray[1] = 2;
              break;
            case 3200:
              settingArray[1] = 3;
              break;
            case 1600:
              settingArray[1] = 4;
              break;
            case 800:
              settingArray[1] = 10;
              break;
            case 400:
              settingArray[1] = 11;
              break;
            case 200:
              settingArray[1] = 12;
              break;
          }
        } else if (options.axisCount == 1) {
          switch (parseInt(options.sampleRate)) {
            case 25600:
              settingArray[1] = 5;
              break;
            case 12800:
              settingArray[1] = 6;
              break;
            case 6400:
              settingArray[1] = 7;
              break;
            case 3200:
              settingArray[1] = 8;
              break;
            case 1600:
              settingArray[1] = 9;
              break;
            case 800:
              settingArray[1] = 13;
              break;
            case 400:
              settingArray[1] = 14;
              break;
            case 200:
              settingArray[1] = 15;
              break;
          }
        }
        settingArray[2] = options.axis;
        settingArray[3] = options.samples;
        settingArray[4] = 0;
        if (options.existing)
          settingArray[4] = 1;
        else if (options.collectafterdisconnect)
          settingArray[4] = 2;
        else if (options.clear)
          settingArray[4] = 3;
        else if (options.collectafterdisconnectsync)
          settingArray[4] = 4;
        let captureTime = Math.floor(Date.now() / 1e3);
        settingArray.writeUInt32LE(captureTime, 5);
        settingArray.writeUInt16LE(options.syncTimeout, 9);
        settingArray[11] = options.channel;
        if (options.syncAddr)
          options.syncAddr.copy(settingArray, 12);
        settingArray[17] = options.syncSeconds;
        settingArray.writeUInt16LE(options.syncScanDistance, 18);
        settingArray[20] = options.syncLongRange ? 1 : 0;
        settingArray.writeUInt32LE(options.gwSerial, 21);
        let waitforlongdata = !options.collectafterdisconnect && !options.clear && !options.collectafterdisconnectsync;
        let ret = await this.writeToPhantomControl(phantomServiceCmds.ACCELGETDATA, settingArray, true, waitforlongdata, progresscb);
        if (options.collectafterdisconnect && ret && ret[0] == phantomServiceCmds.ACCELGETDATA) {
          return {
            scheduledDownload: true
          };
        }
        return {
          data: this.connection.longdata_payload,
          header: this.connection.longdata_header,
          captureTime
        };
      }
      jumpToBootloader() {
        return this.writeToPhantomControl(phantomServiceCmds.JUMP_TO_BOOTLOADER, null, false, false, null);
      }
    };
    module2.exports = {
      phantomService: phantomService2
    };
  }
});

// src/neteimonitoring.js
var require_neteimonitoring = __commonJS({
  "src/neteimonitoring.js"(exports2, module2) {
    "use strict";
    var dgram = require("dgram");
    var net = require("net");
    var gwutils2 = require_gwutils();
    var os2 = require("os");
    var phantomService2 = require_phantomService().phantomService;
    var udpClient = null;
    var udpBroadcastClient = null;
    var NETEIMonitoring = class _NETEIMonitoring {
      static digivibeIPAddr = null;
      static broadcastAddr = "255.255.255.255";
      static addresses = null;
      static IPStringToInt(dot) {
        let d2 = dot.split(".");
        return ((+d2[0] * 256 + +d2[1]) * 256 + +d2[2]) * 256 + +d2[3];
      }
      static IntToIPString(num) {
        let d2 = num % 256;
        for (let i = 3; i > 0; i--) {
          num = Math.floor(num / 256);
          d2 = num % 256 + "." + d2;
        }
        return d2;
      }
      static connectAsync(client2, ip, port2) {
        let connectionPromise = new Promise(function(resolve2, reject) {
          client2.on("error", function(e) {
            reject(e);
          });
          client2.connect(port2, ip, function() {
            resolve2();
          });
        });
        return connectionPromise;
      }
      static writeAsync(data) {
        let connectionPromise = new Promise(function(resolve2, reject) {
          client.write(port, void 0, function() {
            resolve2();
          });
        });
        return connectionPromise;
      }
      static initAddresses() {
        let addresses = [];
        const netifaces = os2.networkInterfaces();
        for (const ifacename in netifaces) {
          const iface = netifaces[ifacename];
          for (const addressnumber in iface) {
            const address = iface[addressnumber];
            if (address.family == "IPv4" && !address.internal) {
              let a = new Uint32Array(3);
              a[0] = _NETEIMonitoring.IPStringToInt(address.address);
              a[1] = _NETEIMonitoring.IPStringToInt(address.netmask);
              a[2] = a[0] | ~a[1];
              let bcastip = _NETEIMonitoring.IntToIPString(a[2]);
              addresses.push({
                address: address.address,
                broadcast: bcastip
              });
            }
          }
        }
        _NETEIMonitoring.addresses = addresses;
      }
      static async onNewMessageToBroadcast(eventdata) {
        if (!eventdata || !eventdata.messages)
          return;
        for (let i = 0; i < eventdata.messages.length; i++) {
          _NETEIMonitoring.broadCastUDPMessage(eventdata.messages[i]);
        }
      }
      static async onNewSignal(eventdata) {
        if (!_NETEIMonitoring.digivibeIPAddr)
          return;
        if (eventdata.signalData.services.eimonitor?.state == "sent")
          return;
        let newheader = null;
        if (phantomService2.isTriaxial(eventdata.node.type) || phantomService2.isGP(eventdata.node.type)) {
          let metadata = phantomService2.parsePhantomV1SignalHeader(eventdata.header);
          if (metadata.timestamp == 0)
            metadata.timestamp = eventdata.signalData.captureTime;
          metadata.alarm = eventdata.signalData.alarm;
          metadata.start = eventdata.signalData.start;
          metadata.triggered = eventdata.signalData.triggered;
          newheader = phantomService2.createPhantomv1CompatibleSignalHeader(metadata);
          if (metadata.dataLen != eventdata.data.length) {
            console.log("Unexpected data size!");
            return;
          }
        } else if (phantomService2.isThermalImage(eventdata.node.type)) {
          let metadata = phantomService2.parsePhantomV1ThermalImageHeader(eventdata.header);
          newheader = phantomService2.createPhantomv1CompatibleThermalImageHeader(
            metadata.phantomCode,
            metadata.columns,
            metadata.rows,
            metadata.dataSize,
            1,
            // frames
            1,
            // frameRate
            eventdata.signalData.captureTime,
            metadata.frames,
            metadata.frameRate
          );
          if (metadata.dataSize != eventdata.data.length) {
            console.log("Unexpected data size!");
            return;
          }
        }
        let client2 = new net.Socket();
        console.log("Connecting to EI Monitor");
        try {
          eventdata.signalData.services.eimonitor = {};
          eventdata.signalData.services.eimonitor.state = "connecting";
          await _NETEIMonitoring.connectAsync(client2, _NETEIMonitoring.digivibeIPAddr, 11050);
          eventdata.signalData.services.eimonitor.state = "sending";
          client2.write(newheader);
          client2.write(eventdata.data);
          client2.end();
          eventdata.signalData.services.eimonitor.state = "sent";
          gwutils2.broadcastEvent("signalsent", eventdata);
        } catch (e) {
          eventdata.signalData.services.eimonitor.state = "error";
          eventdata.signalData.services.eimonitor.error = e.message;
          gwutils2.broadcastEvent("signalfailsend", eventdata);
          console.log("Error when connecting", e.message);
        }
      }
      static async broadCastUDPMessage(msg) {
        if (!udpClient)
          return;
        udpClient.send(msg, 0, msg.length, 11050, _NETEIMonitoring.broadcastAddr);
      }
      static async startUDPServer(gwGlobalState) {
        _NETEIMonitoring.initAddresses();
        gwutils2.subscribeToEvent("newsignal", async (eventdata) => {
          try {
            await _NETEIMonitoring.onNewSignal(eventdata);
          } catch (e) {
            eventdata.signalData.services.eimonitor = {};
            eventdata.signalData.services.eimonitor.state = "sent";
            gwutils2.broadcastEvent("signalsent", eventdata);
          }
        });
        gwutils2.subscribeToEvent("newphantomv1broadcast", _NETEIMonitoring.onNewMessageToBroadcast);
        const server = dgram.createSocket({ type: "udp4", reuseAddr: true });
        server.on("error", (err) => {
          console.log(`server error:
${err.stack}`);
          server.close();
        });
        server.on("message", (msg, rinfo) => {
          switch (msg[0]) {
            case "o".charCodeAt(0):
              lastDigivibeTime = /* @__PURE__ */ new Date();
              if (!gwGlobalState.basicconfig.staticmonitor) {
                if (rinfo.address != gwGlobalState.deviceInfo.digivibeIPAddr) {
                  gwGlobalState.deviceInfo.digivibeIPAddr = rinfo.address;
                  _NETEIMonitoring.digivibeIPAddr = rinfo.address;
                }
              }
              gwutils2.broadcastEvent("monitorstatechanged", {});
              break;
            case "3".charCodeAt(0):
              break;
          }
        });
        let lastDigivibeTime = /* @__PURE__ */ new Date();
        if (gwGlobalState.basicconfig.staticmonitor) {
          gwGlobalState.deviceInfo.digivibeIPAddr = gwGlobalState.basicconfig.staticmonitorip;
          _NETEIMonitoring.digivibeIPAddr = gwGlobalState.basicconfig.staticmonitorip;
          _NETEIMonitoring.broadcastAddr = gwGlobalState.basicconfig.staticmonitorip;
          gwutils2.gwUpdateGlobalState();
        } else {
          setInterval(() => {
            if (/* @__PURE__ */ new Date() - lastDigivibeTime > 4e4) {
              gwGlobalState.deviceInfo.digivibeIPAddr = null;
              _NETEIMonitoring.digivibeIPAddr = null;
              gwutils2.broadcastEvent("monitorstatechanged", {});
              gwutils2.gwUpdateGlobalState();
            }
          }, 1e4);
        }
        server.bind(11050);
        udpClient = dgram.createSocket("udp4");
        udpClient.bind(() => {
          if (!gwGlobalState.basicconfig.staticmonitor)
            udpClient.setBroadcast(true);
        });
        udpBroadcastClient = dgram.createSocket("udp4");
        udpBroadcastClient.bind(() => {
          udpBroadcastClient.setBroadcast(true);
        });
        while (true) {
          _NETEIMonitoring.initAddresses();
          for (let addressindex in _NETEIMonitoring.addresses) {
            let address = _NETEIMonitoring.addresses[addressindex];
            let msg = gwutils2.stringFormat("3;{0};{1};EINANOGW;{2};{3}", address.address, gwGlobalState.deviceInfo.serialNumber, 0, 0);
            udpClient.send(msg, 0, msg.length, 11050, _NETEIMonitoring.broadcastAddr);
            for (let node in gwGlobalState.nodes) {
              let nodeinfo = gwGlobalState.nodes[node];
              if (nodeinfo && nodeinfo.type && nodeinfo.settings?.isPaired) {
                msg = gwutils2.stringFormat("3;{0};{1};EIMONANO;{2}", address.address, node, nodeinfo.type);
                udpClient.send(msg, 0, msg.length, 11050, _NETEIMonitoring.broadcastAddr);
              }
            }
          }
          await gwutils2.sleep(3e3);
        }
        udpClient.close();
      }
    };
    module2.exports = {
      NETEIMonitoring
    };
  }
});

// src/phantommesh.js
var require_phantommesh = __commonJS({
  "src/phantommesh.js"(exports2, module2) {
    var dgram = require("dgram");
    var gwutils2 = require_gwutils();
    var exec = require("child_process").exec;
    var { promisify } = require("util");
    var execAsync = promisify(require("child_process").exec);
    var os2 = require("os");
    var fs2 = require("fs").promises;
    var gwjsnapi = null;
    if (process.platform == "linux" && false)
      gwjsnapi = null;
    var PORT = 11059;
    var broadcastAddr = "255.255.255.255";
    var isMeshRoot = false;
    var isMeshClient = false;
    var PhantoMesh = class _PhantoMesh {
      static async getLinkQuality() {
        let linkQuality = 0;
        try {
          let netwireless = "/proc/net/wireless";
          let nw = await fs2.readFile(netwireless, "utf8");
          let lines = nw.split("\n");
          for (let i = 0; i < lines.length; i++) {
            let line = lines[i].trim();
            if (line.startsWith("wlan0")) {
              let parts = line.split(/\s+/);
              linkQuality = Number(parts[2]);
              linkQuality /= 70;
            }
          }
        } catch (e) {
        }
        return linkQuality;
      }
      static countRecentNodes(gwGlobalState) {
        let now = Date.now();
        let paired = 0;
        let seen = 0;
        for (let phantomCode in gwGlobalState.nodes) {
          let node = gwGlobalState.nodes[phantomCode];
          if (node.settings?.isPaired) {
            paired++;
            if (now - node.lastseen < 6e4) {
              seen++;
            }
          }
        }
        return {
          paired,
          seen
        };
      }
      static deleteOldGateways(gwGlobalState) {
        if (!gwGlobalState.deviceInfo.meshinfo)
          return;
        let now = Date.now();
        for (const mac in gwGlobalState.deviceInfo.meshinfo) {
          let gw = gwGlobalState.deviceInfo.meshinfo[mac];
          if (now - gw.updated > 3e4) {
            delete gwGlobalState.deviceInfo.meshinfo[mac];
          }
        }
      }
      static async initMesh(gwGlobalState) {
        isMeshRoot = gwGlobalState.basicconfig.meshmode == 1;
        isMeshClient = gwGlobalState.basicconfig.meshmode == 2;
        if (gwGlobalState.basicconfig.meshmode == 2)
          broadcastAddr = "fd66:66:66::1";
        let udpClient = dgram.createSocket("udp6");
        udpClient.bind(() => {
          if (gwGlobalState.basicconfig.meshmode != 2 && gwGlobalState.basicconfig.meshmode != 1) {
            udpClient.setBroadcast(true);
          }
          if (gwjsnapi)
            gwjsnapi.bindToInterface(udpClient._handle.fd, "wlan0");
        });
        if (isMeshRoot) {
          const server = dgram.createSocket({ type: "udp6", reuseAddr: true });
          server.on("message", (msg, rinfo) => {
            try {
              let parsed = JSON.parse(msg);
              if (parsed.type == "meshinfo") {
                if (!gwGlobalState.deviceInfo.meshinfo)
                  gwGlobalState.deviceInfo.meshinfo = {};
                if (parsed.apmac) {
                  parsed.updated = Date.now();
                  parsed.ipaddr = rinfo.address;
                  gwGlobalState.deviceInfo.meshinfo[parsed.apmac] = parsed;
                  gwutils2.gwUpdateGlobalState();
                }
              }
            } catch (e) {
              console.log(e);
            }
          });
          server.bind(PORT);
        }
        while (true) {
          try {
            let ap = "";
            let linkQuality = 0;
            try {
              ap = (await execAsync(`iwconfig wlan0 |grep "Access Point" | grep -o -E '([[:xdigit:]]{1,2}:){5}[[:xdigit:]]{1,2}'`)).stdout.trim().toLowerCase();
              linkQuality = await _PhantoMesh.getLinkQuality(gwGlobalState);
            } catch (e) {
            }
            let nodeInfo = _PhantoMesh.countRecentNodes(gwGlobalState);
            _PhantoMesh.deleteOldGateways(gwGlobalState);
            let msg = {
              type: "meshinfo",
              mac: gwGlobalState.deviceInfo.wifimac,
              apmac: gwGlobalState.deviceInfo.apmac,
              connectedmac: ap,
              sn: gwGlobalState.deviceInfo.serialNumber,
              root: isMeshRoot,
              linkQuality,
              nodeInfo
            };
            let msgJSON = JSON.stringify(msg);
            udpClient.send(msgJSON, 0, msgJSON.length, PORT, broadcastAddr);
            msg.updated = Date.now();
            gwGlobalState.deviceInfo.meshinfo[msg.apmac] = msg;
          } catch (e) {
          }
          await gwutils2.sleep(1e4);
        }
      }
      static async init(gwGlobalState) {
        if (gwGlobalState.basicconfig.meshmode == 1 || gwGlobalState.basicconfig.meshmode == 2) {
          this.initMesh(gwGlobalState);
        }
        const discoverServer = dgram.createSocket({ type: "udp4", reuseAddr: true });
        discoverServer.on("message", (msg, rinfo) => {
          try {
            let parsed = JSON.parse(msg);
            if (parsed.type == "discover") {
              let msgJSON = JSON.stringify({
                type: "discoverreply",
                serialNumber: gwGlobalState.deviceInfo.serialNumber
              });
              discoverServer.send(msgJSON, 0, msgJSON.length, rinfo.port, rinfo.address);
            }
          } catch (e) {
            console.log(e);
          }
        });
        discoverServer.bind(11060);
      }
    };
    module2.exports = {
      PhantoMesh
    };
  }
});

// node_modules/i2c-bus/i2c-bus.js
var require_i2c_bus = __commonJS({
  "node_modules/i2c-bus/i2c-bus.js"(exports2, module2) {
    "use strict";
    var fs2 = require("fs");
    var i2c = require_bindings()("i2c.node");
    var BUS_FILE_PREFIX = "/dev/i2c-";
    var FIRST_SCAN_ADDR = 3;
    var LAST_SCAN_ADDR = 119;
    var knownManufacturers = [
      { value: 0, name: "NXP Semiconductors" },
      { value: 1, name: "NXP Semiconductors (reserved)" },
      { value: 2, name: "NXP Semiconductors (reserved)" },
      { value: 3, name: "NXP Semiconductors (reserved)" },
      { value: 4, name: "Ramtron International" },
      { value: 5, name: "Analog Devices" },
      { value: 6, name: "STMicroelectronics" },
      { value: 7, name: "ON Semiconductor" },
      { value: 8, name: "Sprintek Corporation" },
      { value: 9, name: "ESPROS Photonics AG" },
      { value: 10, name: "Fujitsu Semiconductor" },
      { value: 11, name: "Flir" },
      { value: 12, name: "O\u2082Micro" },
      { value: 13, name: "Atmel" }
    ];
    var open = (busNumber, options, cb) => {
      if (typeof options === "function") {
        cb = options;
        options = void 0;
      }
      checkBusNumber(busNumber);
      checkCallback(cb);
      const bus = new Bus(busNumber, options);
      setImmediate(cb, null);
      return bus;
    };
    var openSync = (busNumber, options) => {
      checkBusNumber(busNumber);
      return new Bus(busNumber, options);
    };
    var openPromisified = (busNumber, options) => new Promise(
      (resolve2, reject) => {
        const bus = open(
          busNumber,
          options,
          (err) => err ? reject(err) : resolve2(bus.promisifiedBus())
        );
      }
    );
    var checkBusNumber = (busNumber) => {
      if (!Number.isInteger(busNumber) || busNumber < 0) {
        throw new Error("Invalid I2C bus number " + busNumber);
      }
    };
    var checkAddress = (addr) => {
      if (!Number.isInteger(addr) || addr < 0 || addr > 127) {
        throw new Error("Invalid I2C address " + addr);
      }
    };
    var checkCommand = (cmd) => {
      if (!Number.isInteger(cmd) || cmd < 0 || cmd > 255) {
        throw new Error("Invalid I2C command " + cmd);
      }
    };
    var checkCallback = (cb) => {
      if (typeof cb !== "function") {
        throw new Error("Invalid callback " + cb);
      }
    };
    var checkBuffer = (buffer) => {
      if (!Buffer.isBuffer(buffer)) {
        throw new Error("Invalid buffer " + buffer);
      }
    };
    var checkBufferAndLength = (length, buffer, maxLength) => {
      if (!Number.isInteger(length) || length < 0 || maxLength !== void 0 && length > maxLength) {
        throw new Error("Invalid buffer length " + length);
      }
      checkBuffer(buffer);
      if (buffer.length < length) {
        throw new Error("Buffer must contain at least " + length + " bytes");
      }
    };
    var checkByte = (byte) => {
      if (!Number.isInteger(byte) || byte < 0 || byte > 255) {
        throw new Error("Invalid byte " + byte);
      }
    };
    var checkWord = (word) => {
      if (!Number.isInteger(word) || word < 0 || word > 65535) {
        throw new Error("Invalid word " + word);
      }
    };
    var checkBit = (bit) => {
      if (!Number.isInteger(bit) || bit < 0 || bit > 1) {
        throw new Error("Invalid bit " + bit);
      }
    };
    var parseId = (id) => {
      const manufacturer = id >> 12 & 4095;
      const product = id & 4095;
      const known = knownManufacturers.find((man) => man.value === manufacturer);
      const name = known !== void 0 ? known.name : "<0x" + manufacturer.toString(16) + ">";
      return {
        manufacturer,
        product,
        name
      };
    };
    var peripheral = (bus, addr, cb) => {
      const device = bus._peripherals[addr];
      if (device === void 0) {
        fs2.open(BUS_FILE_PREFIX + bus._busNumber, "r+", (err, device2) => {
          if (err) {
            return cb(err);
          }
          bus._peripherals[addr] = device2;
          i2c.setAddrAsync(device2, addr, bus._forceAccess, (err2) => {
            if (err2) {
              return cb(err2);
            }
            cb(null, device2);
          });
        });
      } else {
        setImmediate(cb, null, device);
      }
    };
    var peripheralSync = (bus, addr) => {
      let peripheral2 = bus._peripherals[addr];
      if (peripheral2 === void 0) {
        peripheral2 = fs2.openSync(BUS_FILE_PREFIX + bus._busNumber, "r+");
        bus._peripherals[addr] = peripheral2;
        i2c.setAddrSync(peripheral2, addr, bus._forceAccess);
      }
      return peripheral2;
    };
    var I2cFuncs = class {
      constructor(i2cFuncBits) {
        this.i2c = !!(i2cFuncBits & i2c.I2C_FUNC_I2C);
        this.tenBitAddr = !!(i2cFuncBits & i2c.I2C_FUNC_10BIT_ADDR);
        this.protocolMangling = !!(i2cFuncBits & i2c.I2C_FUNC_PROTOCOL_MANGLING);
        this.smbusPec = !!(i2cFuncBits & i2c.I2C_FUNC_SMBUS_PEC);
        this.smbusBlockProcCall = !!(i2cFuncBits & i2c.I2C_FUNC_SMBUS_BLOCK_PROC_CALL);
        this.smbusQuick = !!(i2cFuncBits & i2c.I2C_FUNC_SMBUS_QUICK);
        this.smbusReceiveByte = !!(i2cFuncBits & i2c.I2C_FUNC_SMBUS_READ_BYTE);
        this.smbusSendByte = !!(i2cFuncBits & i2c.I2C_FUNC_SMBUS_WRITE_BYTE);
        this.smbusReadByte = !!(i2cFuncBits & i2c.I2C_FUNC_SMBUS_READ_BYTE_DATA);
        this.smbusWriteByte = !!(i2cFuncBits & i2c.I2C_FUNC_SMBUS_WRITE_BYTE_DATA);
        this.smbusReadWord = !!(i2cFuncBits & i2c.I2C_FUNC_SMBUS_READ_WORD_DATA);
        this.smbusWriteWord = !!(i2cFuncBits & i2c.I2C_FUNC_SMBUS_WRITE_WORD_DATA);
        this.smbusProcCall = !!(i2cFuncBits & i2c.I2C_FUNC_SMBUS_PROC_CALL);
        this.smbusReadBlock = !!(i2cFuncBits & i2c.I2C_FUNC_SMBUS_READ_BLOCK_DATA);
        this.smbusWriteBlock = !!(i2cFuncBits & i2c.I2C_FUNC_SMBUS_WRITE_BLOCK_DATA);
        this.smbusReadI2cBlock = !!(i2cFuncBits & i2c.I2C_FUNC_SMBUS_READ_I2C_BLOCK);
        this.smbusWriteI2cBlock = !!(i2cFuncBits & i2c.I2C_FUNC_SMBUS_WRITE_I2C_BLOCK);
      }
    };
    var Bus = class {
      constructor(busNumber, options) {
        options = options || {};
        this._busNumber = busNumber;
        this._forceAccess = !!options.forceAccess || false;
        this._peripherals = [];
        this._promisifiedBus = new PromisifiedBus(this);
      }
      promisifiedBus() {
        return this._promisifiedBus;
      }
      close(cb) {
        checkCallback(cb);
        const peripherals = this._peripherals.filter((peripheral2) => {
          return peripheral2 !== void 0;
        });
        const closePeripheral = (_) => {
          if (peripherals.length === 0) {
            return setImmediate(cb, null);
          }
          fs2.close(peripherals.pop(), (err) => {
            if (err) {
              return cb(err);
            }
            closePeripheral();
          });
        };
        closePeripheral();
      }
      closeSync() {
        this._peripherals.forEach((peripheral2) => {
          if (peripheral2 !== void 0) {
            fs2.closeSync(peripheral2);
          }
        });
        this._peripherals = [];
      }
      i2cFuncs(cb) {
        checkCallback(cb);
        if (!this.funcs) {
          peripheral(this, 0, (err, device) => {
            if (err) {
              return cb(err);
            }
            i2c.i2cFuncsAsync(device, (err2, i2cFuncBits) => {
              if (err2) {
                return cb(err2);
              }
              this.funcs = Object.freeze(new I2cFuncs(i2cFuncBits));
              cb(null, this.funcs);
            });
          });
        } else {
          setImmediate(cb, null, this.funcs);
        }
      }
      i2cFuncsSync() {
        if (!this.funcs) {
          this.funcs = Object.freeze(new I2cFuncs(i2c.i2cFuncsSync(peripheralSync(this, 0))));
        }
        return this.funcs;
      }
      readByte(addr, cmd, cb) {
        checkAddress(addr);
        checkCommand(cmd);
        checkCallback(cb);
        peripheral(this, addr, (err, device) => {
          if (err) {
            return cb(err);
          }
          i2c.readByteAsync(device, cmd, cb);
        });
      }
      readByteSync(addr, cmd) {
        checkAddress(addr);
        checkCommand(cmd);
        return i2c.readByteSync(peripheralSync(this, addr), cmd);
      }
      readWord(addr, cmd, cb) {
        checkAddress(addr);
        checkCommand(cmd);
        checkCallback(cb);
        peripheral(this, addr, (err, device) => {
          if (err) {
            return cb(err);
          }
          i2c.readWordAsync(device, cmd, cb);
        });
      }
      readWordSync(addr, cmd) {
        checkAddress(addr);
        checkCommand(cmd);
        return i2c.readWordSync(peripheralSync(this, addr), cmd);
      }
      // UNTESTED and undocumented due to lack of supporting hardware
      readBlock(addr, cmd, buffer, cb) {
        checkAddress(addr);
        checkCommand(cmd);
        checkBuffer(buffer);
        checkCallback(cb);
        peripheral(this, addr, (err, device) => {
          if (err) {
            return cb(err);
          }
          i2c.readBlockAsync(device, cmd, buffer, cb);
        });
      }
      // UNTESTED and undocumented due to lack of supporting hardware
      readBlockSync(addr, cmd, buffer) {
        checkAddress(addr);
        checkCommand(cmd);
        checkBuffer(buffer);
        return i2c.readBlockSync(peripheralSync(this, addr), cmd, buffer);
      }
      readI2cBlock(addr, cmd, length, buffer, cb) {
        checkAddress(addr);
        checkCommand(cmd);
        checkBufferAndLength(length, buffer, 32);
        checkCallback(cb);
        peripheral(this, addr, (err, device) => {
          if (err) {
            return cb(err);
          }
          i2c.readI2cBlockAsync(device, cmd, length, buffer, cb);
        });
      }
      readI2cBlockSync(addr, cmd, length, buffer) {
        checkAddress(addr);
        checkCommand(cmd);
        checkBufferAndLength(length, buffer, 32);
        return i2c.readI2cBlockSync(peripheralSync(this, addr), cmd, length, buffer);
      }
      receiveByte(addr, cb) {
        checkAddress(addr);
        checkCallback(cb);
        peripheral(this, addr, (err, device) => {
          if (err) {
            return cb(err);
          }
          i2c.receiveByteAsync(device, cb);
        });
      }
      receiveByteSync(addr) {
        checkAddress(addr);
        return i2c.receiveByteSync(peripheralSync(this, addr));
      }
      sendByte(addr, byte, cb) {
        checkAddress(addr);
        checkByte(byte);
        checkCallback(cb);
        peripheral(this, addr, (err, device) => {
          if (err) {
            return cb(err);
          }
          i2c.sendByteAsync(device, byte, cb);
        });
      }
      sendByteSync(addr, byte) {
        checkAddress(addr);
        checkByte(byte);
        i2c.sendByteSync(peripheralSync(this, addr), byte);
        return this;
      }
      writeByte(addr, cmd, byte, cb) {
        checkAddress(addr);
        checkCommand(cmd);
        checkByte(byte);
        checkCallback(cb);
        peripheral(this, addr, (err, device) => {
          if (err) {
            return cb(err);
          }
          i2c.writeByteAsync(device, cmd, byte, cb);
        });
      }
      writeByteSync(addr, cmd, byte) {
        checkAddress(addr);
        checkCommand(cmd);
        checkByte(byte);
        i2c.writeByteSync(peripheralSync(this, addr), cmd, byte);
        return this;
      }
      writeWord(addr, cmd, word, cb) {
        checkAddress(addr);
        checkCommand(cmd);
        checkWord(word);
        checkCallback(cb);
        peripheral(this, addr, (err, device) => {
          if (err) {
            return cb(err);
          }
          i2c.writeWordAsync(device, cmd, word, cb);
        });
      }
      writeWordSync(addr, cmd, word) {
        checkAddress(addr);
        checkCommand(cmd);
        checkWord(word);
        i2c.writeWordSync(peripheralSync(this, addr), cmd, word);
        return this;
      }
      writeQuick(addr, bit, cb) {
        checkAddress(addr);
        checkBit(bit);
        checkCallback(cb);
        peripheral(this, addr, (err, device) => {
          if (err) {
            return cb(err);
          }
          i2c.writeQuickAsync(device, bit, cb);
        });
      }
      writeQuickSync(addr, bit) {
        checkAddress(addr);
        checkBit(bit);
        i2c.writeQuickSync(peripheralSync(this, addr), bit);
        return this;
      }
      // UNTESTED and undocumented due to lack of supporting hardware
      writeBlock(addr, cmd, length, buffer, cb) {
        checkAddress(addr);
        checkCommand(cmd);
        checkBufferAndLength(length, buffer);
        checkCallback(cb);
        peripheral(this, addr, (err, device) => {
          if (err) {
            return cb(err);
          }
          i2c.writeBlockAsync(device, cmd, length, buffer, cb);
        });
      }
      // UNTESTED and undocumented due to lack of supporting hardware
      writeBlockSync(addr, cmd, length, buffer) {
        checkAddress(addr);
        checkCommand(cmd);
        checkBufferAndLength(length, buffer);
        i2c.writeBlockSync(peripheralSync(this, addr), cmd, length, buffer);
        return this;
      }
      writeI2cBlock(addr, cmd, length, buffer, cb) {
        checkAddress(addr);
        checkCommand(cmd);
        checkBufferAndLength(length, buffer, 32);
        checkCallback(cb);
        peripheral(this, addr, (err, device) => {
          if (err) {
            return cb(err);
          }
          i2c.writeI2cBlockAsync(device, cmd, length, buffer, cb);
        });
      }
      writeI2cBlockSync(addr, cmd, length, buffer) {
        checkAddress(addr);
        checkCommand(cmd);
        checkBufferAndLength(length, buffer, 32);
        i2c.writeI2cBlockSync(peripheralSync(this, addr), cmd, length, buffer);
        return this;
      }
      i2cRead(addr, length, buffer, cb) {
        checkAddress(addr);
        checkBufferAndLength(length, buffer);
        checkCallback(cb);
        peripheral(this, addr, (err, device) => {
          if (err) {
            return cb(err);
          }
          fs2.read(device, buffer, 0, length, 0, cb);
        });
      }
      i2cReadSync(addr, length, buffer) {
        checkAddress(addr);
        checkBufferAndLength(length, buffer);
        return fs2.readSync(peripheralSync(this, addr), buffer, 0, length, 0);
      }
      i2cWrite(addr, length, buffer, cb) {
        checkAddress(addr);
        checkBufferAndLength(length, buffer);
        checkCallback(cb);
        peripheral(this, addr, (err, device) => {
          if (err) {
            return cb(err);
          }
          fs2.write(device, buffer, 0, length, 0, cb);
        });
      }
      i2cWriteSync(addr, length, buffer) {
        checkAddress(addr);
        checkBufferAndLength(length, buffer);
        return fs2.writeSync(peripheralSync(this, addr), buffer, 0, length, 0);
      }
      scan(startAddr, endAddr, cb) {
        if (typeof startAddr === "function") {
          cb = startAddr;
          startAddr = FIRST_SCAN_ADDR;
          endAddr = LAST_SCAN_ADDR;
        } else if (typeof endAddr === "function") {
          cb = endAddr;
          endAddr = startAddr;
        }
        checkCallback(cb);
        checkAddress(startAddr);
        checkAddress(endAddr);
        const scanBus = open(this._busNumber, { forceAccess: this._forceAccess }, (err) => {
          const addresses = [];
          if (err) {
            return cb(err);
          }
          const next = (addr) => {
            if (addr > endAddr) {
              return scanBus.close((err2) => {
                if (err2) {
                  return cb(err2);
                }
                cb(null, addresses);
              });
            }
            scanBus.receiveByte(addr, (err2) => {
              if (!err2) {
                addresses.push(addr);
              }
              next(addr + 1);
            });
          };
          next(startAddr);
        });
      }
      scanSync(startAddr, endAddr) {
        if (typeof startAddr === "undefined") {
          startAddr = FIRST_SCAN_ADDR;
          endAddr = LAST_SCAN_ADDR;
        } else if (typeof endAddr === "undefined") {
          endAddr = startAddr;
        }
        checkAddress(startAddr);
        checkAddress(endAddr);
        const scanBus = openSync(this._busNumber, { forceAccess: this._forceAccess });
        const addresses = [];
        for (let addr = startAddr; addr <= endAddr; addr += 1) {
          try {
            scanBus.receiveByteSync(addr);
            addresses.push(addr);
          } catch (ignore) {
          }
        }
        scanBus.closeSync();
        return addresses;
      }
      deviceId(addr, cb) {
        checkAddress(addr);
        checkCallback(cb);
        peripheral(this, addr, (err, device) => {
          if (err) {
            return cb(err);
          }
          i2c.deviceIdAsync(device, addr, (err2, id) => {
            if (err2) {
              return cb(err2);
            }
            cb(null, parseId(id));
          });
        });
      }
      deviceIdSync(addr) {
        checkAddress(addr);
        const mp = i2c.deviceIdSync(peripheralSync(this, addr), addr);
        return parseId(mp);
      }
    };
    var PromisifiedBus = class {
      constructor(bus) {
        this._bus = bus;
      }
      bus() {
        return this._bus;
      }
      close() {
        return new Promise(
          (resolve2, reject) => this._bus.close((err) => err ? reject(err) : resolve2())
        );
      }
      i2cFuncs() {
        return new Promise(
          (resolve2, reject) => this._bus.i2cFuncs((err, funcs) => err ? reject(err) : resolve2(funcs))
        );
      }
      readByte(addr, cmd) {
        return new Promise(
          (resolve2, reject) => this._bus.readByte(
            addr,
            cmd,
            (err, byte) => err ? reject(err) : resolve2(byte)
          )
        );
      }
      readWord(addr, cmd) {
        return new Promise(
          (resolve2, reject) => this._bus.readWord(
            addr,
            cmd,
            (err, word) => err ? reject(err) : resolve2(word)
          )
        );
      }
      // UNTESTED and undocumented due to lack of supporting hardware
      readBlock(addr, cmd, buffer) {
        return new Promise(
          (resolve2, reject) => this._bus.readBlock(
            addr,
            cmd,
            buffer,
            (err, bytesRead, buffer2) => err ? reject(err) : resolve2({ bytesRead, buffer: buffer2 })
          )
        );
      }
      readI2cBlock(addr, cmd, length, buffer) {
        return new Promise(
          (resolve2, reject) => this._bus.readI2cBlock(
            addr,
            cmd,
            length,
            buffer,
            (err, bytesRead, buffer2) => err ? reject(err) : resolve2({ bytesRead, buffer: buffer2 })
          )
        );
      }
      receiveByte(addr) {
        return new Promise(
          (resolve2, reject) => this._bus.receiveByte(
            addr,
            (err, byte) => err ? reject(err) : resolve2(byte)
          )
        );
      }
      sendByte(addr, byte) {
        return new Promise(
          (resolve2, reject) => this._bus.sendByte(
            addr,
            byte,
            (err) => err ? reject(err) : resolve2()
          )
        );
      }
      writeByte(addr, cmd, byte) {
        return new Promise(
          (resolve2, reject) => this._bus.writeByte(
            addr,
            cmd,
            byte,
            (err) => err ? reject(err) : resolve2()
          )
        );
      }
      writeWord(addr, cmd, word) {
        return new Promise(
          (resolve2, reject) => this._bus.writeWord(
            addr,
            cmd,
            word,
            (err) => err ? reject(err) : resolve2()
          )
        );
      }
      writeQuick(addr, bit) {
        return new Promise(
          (resolve2, reject) => this._bus.writeQuick(
            addr,
            bit,
            (err) => err ? reject(err) : resolve2()
          )
        );
      }
      // UNTESTED and undocumented due to lack of supporting hardware
      writeBlock(addr, cmd, length, buffer) {
        return new Promise(
          (resolve2, reject) => this._bus.writeBlock(
            addr,
            cmd,
            length,
            buffer,
            (err, bytesWritten, buffer2) => err ? reject(err) : resolve2({ bytesWritten, buffer: buffer2 })
          )
        );
      }
      writeI2cBlock(addr, cmd, length, buffer) {
        return new Promise(
          (resolve2, reject) => this._bus.writeI2cBlock(
            addr,
            cmd,
            length,
            buffer,
            (err, bytesWritten, buffer2) => err ? reject(err) : resolve2({ bytesWritten, buffer: buffer2 })
          )
        );
      }
      i2cRead(addr, length, buffer) {
        return new Promise(
          (resolve2, reject) => this._bus.i2cRead(
            addr,
            length,
            buffer,
            (err, bytesRead, buffer2) => err ? reject(err) : resolve2({ bytesRead, buffer: buffer2 })
          )
        );
      }
      i2cWrite(addr, length, buffer) {
        return new Promise(
          (resolve2, reject) => this._bus.i2cWrite(
            addr,
            length,
            buffer,
            (err, bytesWritten, buffer2) => err ? reject(err) : resolve2({ bytesWritten, buffer: buffer2 })
          )
        );
      }
      scan(...args) {
        return new Promise(
          (resolve2, reject) => this._bus.scan(
            ...args,
            (err, devices) => err ? reject(err) : resolve2(devices)
          )
        );
      }
      deviceId(addr) {
        return new Promise(
          (resolve2, reject) => this._bus.deviceId(addr, (err, id) => err ? reject(err) : resolve2(id))
        );
      }
    };
    module2.exports = {
      open,
      openSync,
      openPromisified
    };
  }
});

// node_modules/oled-i2c-bus/oled.js
var require_oled = __commonJS({
  "node_modules/oled-i2c-bus/oled.js"(exports2, module2) {
    var Oled = function(i2c, opts) {
      this.HEIGHT = opts.height || 32;
      this.WIDTH = opts.width || 128;
      this.ADDRESS = opts.address || 60;
      this.PROTOCOL = "I2C";
      this.LINESPACING = typeof opts.linespacing !== "undefined" ? opts.linespacing : 1;
      this.LETTERSPACING = typeof opts.letterspacing !== "undefined" ? opts.letterspacing : 1;
      this.DISPLAY_OFF = 174;
      this.DISPLAY_ON = 175;
      this.SET_DISPLAY_CLOCK_DIV = 213;
      this.SET_MULTIPLEX = 168;
      this.SET_DISPLAY_OFFSET = 211;
      this.SET_START_LINE = 0;
      this.CHARGE_PUMP = 141;
      this.EXTERNAL_VCC = false;
      this.MEMORY_MODE = 32;
      this.SEG_REMAP = 161;
      this.COM_SCAN_DEC = 200;
      this.COM_SCAN_INC = 192;
      this.SET_COM_PINS = 218;
      this.SET_CONTRAST = 129;
      this.SET_PRECHARGE = 217;
      this.SET_VCOM_DETECT = 219;
      this.DISPLAY_ALL_ON_RESUME = 164;
      this.NORMAL_DISPLAY = 166;
      this.COLUMN_ADDR = 33;
      this.PAGE_ADDR = 34;
      this.INVERT_DISPLAY = 167;
      this.ACTIVATE_SCROLL = 47;
      this.DEACTIVATE_SCROLL = 46;
      this.SET_VERTICAL_SCROLL_AREA = 163;
      this.RIGHT_HORIZONTAL_SCROLL = 38;
      this.LEFT_HORIZONTAL_SCROLL = 39;
      this.VERTICAL_AND_RIGHT_HORIZONTAL_SCROLL = 41;
      this.VERTICAL_AND_LEFT_HORIZONTAL_SCROLL = 42;
      this.cursor_x = 0;
      this.cursor_y = 0;
      if (typeof Buffer.alloc == "undefined") {
        this.buffer = new Buffer(this.WIDTH * this.HEIGHT / 8);
      } else {
        this.buffer = Buffer.alloc(this.WIDTH * this.HEIGHT / 8);
      }
      this.buffer.fill(0);
      this.dirtyBytes = [];
      var config = {
        "128x32": {
          "multiplex": 31,
          "compins": 2,
          "coloffset": 0
        },
        "128x64": {
          "multiplex": 63,
          "compins": 18,
          "coloffset": 0
        },
        "96x16": {
          "multiplex": 15,
          "compins": 2,
          "coloffset": 0
        }
      };
      this.wire = i2c;
      var screenSize = this.WIDTH + "x" + this.HEIGHT;
      this.screenConfig = config[screenSize];
      this._initialise();
    };
    Oled.prototype._initialise = function() {
      var initSeq = [
        this.DISPLAY_OFF,
        this.SET_DISPLAY_CLOCK_DIV,
        128,
        this.SET_MULTIPLEX,
        this.screenConfig.multiplex,
        // set the last value dynamically based on screen size requirement
        this.SET_DISPLAY_OFFSET,
        0,
        // sets offset pro to 0
        this.SET_START_LINE,
        this.CHARGE_PUMP,
        20,
        // charge pump val
        this.MEMORY_MODE,
        0,
        // 0x0 act like ks0108
        this.SEG_REMAP,
        // screen orientation
        this.COM_SCAN_DEC,
        // screen orientation change to INC to flip
        this.SET_COM_PINS,
        this.screenConfig.compins,
        // com pins val sets dynamically to match each screen size requirement
        this.SET_CONTRAST,
        143,
        // contrast val
        this.SET_PRECHARGE,
        241,
        // precharge val
        this.SET_VCOM_DETECT,
        64,
        // vcom detect
        this.DISPLAY_ALL_ON_RESUME,
        this.NORMAL_DISPLAY,
        this.DISPLAY_ON
      ];
      var i, initSeqLen = initSeq.length;
      for (i = 0; i < initSeqLen; i++) {
        this._transfer("cmd", initSeq[i]);
      }
    };
    Oled.prototype._transfer = function(type, val, fn) {
      var control;
      if (type === "data") {
        control = 64;
      } else if (type === "cmd") {
        control = 0;
      } else {
        return;
      }
      var bufferForSend, sentCount;
      if (typeof Buffer.from == "undefined") {
        bufferForSend = new Buffer([control, val]);
      } else {
        bufferForSend = Buffer.from([control, val]);
      }
      sentCount = this.wire.i2cWriteSync(this.ADDRESS, 2, bufferForSend);
      if (fn) {
        fn();
      }
    };
    Oled.prototype._readI2C = function(fn) {
      if (typeof Buffer.from == "undefined") {
        this.wire.i2cRead(this.ADDRESS, 0, new Buffer([0]), function(err, bytesRead, data2) {
          if (typeof data2 === "object") {
            fn(data2[0]);
          } else {
            fn(0);
          }
        });
      } else {
        var data = [0];
        this.wire.i2cReadSync(this.ADDRESS, 1, Buffer.from(data));
        fn(data[0]);
      }
    };
    Oled.prototype._waitUntilReady = function(callback) {
      var done, oled = this;
      function tick(callback2) {
        oled._readI2C(function(byte) {
          busy = byte >> 7 & 1;
          if (!busy) {
            callback2();
          } else {
            setTimeout(function() {
              tick(callback2);
            }, 0);
          }
        });
      }
      ;
      setTimeout(function() {
        tick(callback);
      }, 0);
    };
    Oled.prototype.setCursor = function(x2, y) {
      this.cursor_x = x2;
      this.cursor_y = y;
    };
    Oled.prototype.writeString = function(font, size, string, color, wrap, sync) {
      var immed = typeof sync === "undefined" ? true : sync;
      var wordArr = string.split(" "), len = wordArr.length, offset = this.cursor_x, padding = 0;
      for (var w = 0; w < len; w += 1) {
        if (w < len - 1 || !wordArr[w].length) {
          wordArr[w] += " ";
        }
        var stringArr = wordArr[w].split(""), slen = stringArr.length, compare = font.width * size * slen + size * (len - 1);
        if (wrap && len > 1 && w > 0 && offset >= this.WIDTH - compare) {
          offset = 0;
          this.cursor_y += font.height * size + this.LINESPACING;
          this.setCursor(offset, this.cursor_y);
        }
        for (var i = 0; i < slen; i += 1) {
          if (stringArr[i] === "\n") {
            offset = 0;
            this.cursor_y += font.height * size + this.LINESPACING;
            this.setCursor(offset, this.cursor_y);
          } else {
            var charBuf = this._findCharBuf(font, stringArr[i]);
            var charBytes = this._readCharBytes(charBuf, font.height);
            this._drawChar(charBytes, font.height, size, false);
            offset += font.width * size + this.LETTERSPACING;
            if (wrap && offset >= this.WIDTH - font.width - this.LETTERSPACING) {
              offset = 0;
              this.cursor_y += font.height * size + this.LINESPACING;
            }
            this.setCursor(offset, this.cursor_y);
          }
        }
      }
      if (immed) {
        this._updateDirtyBytes(this.dirtyBytes);
      }
    };
    Oled.prototype._drawChar = function(byteArray, charHeight, size, sync) {
      var x2 = this.cursor_x, y = this.cursor_y;
      for (var i = 0; i < byteArray.length; i += 1) {
        for (var j = 0; j < charHeight; j += 1) {
          var color = byteArray[i][j], xpos, ypos;
          if (size === 1) {
            xpos = x2 + i;
            ypos = y + j;
            this.drawPixel([xpos, ypos, color], false);
          } else {
            xpos = x2 + i * size;
            ypos = y + j * size;
            this.fillRect(xpos, ypos, size, size, color, false);
          }
        }
      }
    };
    Oled.prototype._readCharBytes = function(byteArray, charHeight) {
      var bitArr = [], bitCharArr = [];
      for (var i = 0; i < byteArray.length; i += 1) {
        var byte = byteArray[i];
        for (var j = 0; j < charHeight; j += 1) {
          var bit = byte >> j & 1;
          bitArr.push(bit);
        }
        bitCharArr.push(bitArr);
        bitArr = [];
      }
      return bitCharArr;
    };
    Oled.prototype._findCharBuf = function(font, c2) {
      var cBufPos = font.lookup.indexOf(c2) * font.width;
      var cBuf = font.fontData.slice(cBufPos, cBufPos + font.width);
      return cBuf;
    };
    Oled.prototype.update = function() {
      this._waitUntilReady(function() {
        var displaySeq = [
          this.COLUMN_ADDR,
          this.screenConfig.coloffset,
          this.screenConfig.coloffset + this.WIDTH - 1,
          // column start and end address
          this.PAGE_ADDR,
          0,
          this.HEIGHT / 8 - 1
          // page start and end address
        ];
        var displaySeqLen = displaySeq.length, bufferLen = this.buffer.length, i, v;
        for (i = 0; i < displaySeqLen; i += 1) {
          this._transfer("cmd", displaySeq[i]);
        }
        var bufferToSend = Buffer.concat([Buffer.from([64]), this.buffer]);
        var sentCount = this.wire.i2cWriteSync(this.ADDRESS, bufferToSend.length, bufferToSend);
      }.bind(this));
    };
    Oled.prototype.dimDisplay = function(bool) {
      var contrast;
      if (bool) {
        contrast = 0;
      } else {
        contrast = 207;
      }
      this._transfer("cmd", this.SET_CONTRAST);
      this._transfer("cmd", contrast);
    };
    Oled.prototype.turnOffDisplay = function() {
      this._transfer("cmd", this.DISPLAY_OFF);
    };
    Oled.prototype.turnOnDisplay = function() {
      this._transfer("cmd", this.DISPLAY_ON);
    };
    Oled.prototype.clearDisplay = function(sync) {
      var immed = typeof sync === "undefined" ? true : sync;
      this.buffer.fill(0);
      if (immed) {
        this.update();
      }
    };
    Oled.prototype.invertDisplay = function(bool) {
      if (bool) {
        this._transfer("cmd", this.INVERT_DISPLAY);
      } else {
        this._transfer("cmd", this.NORMAL_DISPLAY);
      }
    };
    Oled.prototype.drawRGBAImage = function(image, dx, dy, sync) {
      var immed = typeof sync === "undefined" ? true : sync;
      var x2, y, dataIndex, buffIndex, buffByte, bit, pixelByte;
      var dyp = this.WIDTH * Math.floor(dy / 8);
      var dxyp = dyp + dx;
      for (x2 = 0; x2 < image.width; x2++) {
        var dxx = dx + x2;
        if (dxx < 0 || dxx >= this.WIDTH) {
          continue;
        }
        buffIndex = x2 + dxyp;
        buffByte = this.buffer[buffIndex];
        for (y = 0; y < image.height; y++) {
          var dyy = dy + y;
          if (dyy < 0 || dyy >= this.HEIGHT) {
            continue;
          }
          var dyyp = Math.floor(dyy / 8);
          if (!(dyy % 8)) {
            if ((x2 || y) && buffByte !== this.buffer[buffIndex]) {
              this.buffer[buffIndex] = buffByte;
              this.dirtyBytes.push(buffIndex);
            }
            buffIndex = dx + x2 + this.WIDTH * dyyp;
            buffByte = this.buffer[buffIndex];
          }
          dataIndex = image.width * y + x2 << 2;
          if (!image.data[dataIndex + 3]) {
            continue;
          }
          pixelByte = 1 << dyy - 8 * dyyp;
          bit = image.data[dataIndex] || image.data[dataIndex + 1] || image.data[dataIndex + 2];
          if (bit) {
            buffByte |= pixelByte;
          } else {
            buffByte &= ~pixelByte;
          }
        }
        if ((x2 || y) && buffByte !== this.buffer[buffIndex]) {
          this.buffer[buffIndex] = buffByte;
          this.dirtyBytes.push(buffIndex);
        }
      }
      if (immed) {
        this._updateDirtyBytes(this.dirtyBytes);
      }
    };
    Oled.prototype.drawBitmap = function(pixels, sync) {
      var immed = typeof sync === "undefined" ? true : sync;
      var x2, y, pixelArray = [];
      for (var i = 0; i < pixels.length; i++) {
        x2 = Math.floor(i % this.WIDTH);
        y = Math.floor(i / this.WIDTH);
        this.drawPixel([x2, y, pixels[i]], false);
      }
      if (immed) {
        this._updateDirtyBytes(this.dirtyBytes);
      }
    };
    Oled.prototype.drawPixel = function(pixels, sync) {
      var immed = typeof sync === "undefined" ? true : sync;
      if (typeof pixels[0] !== "object")
        pixels = [pixels];
      pixels.forEach(function(el) {
        var x2 = el[0], y = el[1], color = el[2];
        if (x2 >= this.WIDTH || y >= this.HEIGHT)
          return;
        var byte = 0, page = Math.floor(y / 8), pageShift = 1 << y - 8 * page;
        page == 0 ? byte = x2 : byte = x2 + this.WIDTH * page;
        if (color === "BLACK" || color === 0) {
          this.buffer[byte] &= ~pageShift;
        }
        if (color === "WHITE" || color > 0) {
          this.buffer[byte] |= pageShift;
        }
        if (this.dirtyBytes.indexOf(byte) === -1) {
          this.dirtyBytes.push(byte);
        }
      }, this);
      if (immed) {
        this._updateDirtyBytes(this.dirtyBytes);
      }
    };
    Oled.prototype._updateDirtyBytes = function(byteArray) {
      var blen = byteArray.length, i, displaySeq = [];
      if (blen > this.buffer.length / 7) {
        this.update();
        this.dirtyBytes = [];
      } else {
        this._waitUntilReady(function() {
          for (var i2 = 0; i2 < blen; i2 += 1) {
            var byte = byteArray[i2];
            var page = Math.floor(byte / this.WIDTH);
            var col = Math.floor(byte % this.WIDTH);
            var displaySeq2 = [
              this.COLUMN_ADDR,
              col,
              col,
              // column start and end address
              this.PAGE_ADDR,
              page,
              page
              // page start and end address
            ];
            var displaySeqLen = displaySeq2.length, v;
            for (v = 0; v < displaySeqLen; v += 1) {
              this._transfer("cmd", displaySeq2[v]);
            }
            this._transfer("data", this.buffer[byte]);
            this.buffer[byte];
          }
        }.bind(this));
      }
      this.dirtyBytes = [];
    };
    Oled.prototype.drawLine = function(x0, y0, x1, y1, color, sync) {
      var immed = typeof sync === "undefined" ? true : sync;
      var dx = Math.abs(x1 - x0), sx = x0 < x1 ? 1 : -1, dy = Math.abs(y1 - y0), sy = y0 < y1 ? 1 : -1, err = (dx > dy ? dx : -dy) / 2;
      while (true) {
        this.drawPixel([x0, y0, color], false);
        if (x0 === x1 && y0 === y1)
          break;
        var e2 = err;
        if (e2 > -dx) {
          err -= dy;
          x0 += sx;
        }
        if (e2 < dy) {
          err += dx;
          y0 += sy;
        }
      }
      if (immed) {
        this._updateDirtyBytes(this.dirtyBytes);
      }
    };
    Oled.prototype.fillRect = function(x2, y, w, h, color, sync) {
      var immed = typeof sync === "undefined" ? true : sync;
      for (var i = x2; i < x2 + w; i += 1) {
        this.drawLine(i, y, i, y + h - 1, color, false);
      }
      if (immed) {
        this._updateDirtyBytes(this.dirtyBytes);
      }
    };
    Oled.prototype.startScroll = function(dir, start, stop) {
      var scrollHeader, cmdSeq = [];
      switch (dir) {
        case "right":
          cmdSeq.push(this.RIGHT_HORIZONTAL_SCROLL);
          break;
        case "left":
          cmdSeq.push(this.LEFT_HORIZONTAL_SCROLL);
          break;
        case "left diagonal":
          cmdSeq.push(
            this.SET_VERTICAL_SCROLL_AREA,
            0,
            this.VERTICAL_AND_LEFT_HORIZONTAL_SCROLL,
            this.HEIGHT
          );
          break;
        case "right diagonal":
          cmdSeq.push(
            this.SET_VERTICAL_SCROLL_AREA,
            0,
            this.VERTICAL_AND_RIGHT_HORIZONTAL_SCROLL,
            this.HEIGHT
          );
          break;
      }
      this._waitUntilReady(function() {
        cmdSeq.push(
          0,
          start,
          0,
          stop,
          // TODO: these need to change when diagonal
          0,
          255,
          this.ACTIVATE_SCROLL
        );
        var i, cmdSeqLen = cmdSeq.length;
        for (i = 0; i < cmdSeqLen; i += 1) {
          this._transfer("cmd", cmdSeq[i]);
        }
      }.bind(this));
    };
    Oled.prototype.stopScroll = function() {
      this._transfer("cmd", this.DEACTIVATE_SCROLL);
    };
    module2.exports = Oled;
  }
});

// node_modules/oled-font-5x7/oled-font-5x7.js
var require_oled_font_5x7 = __commonJS({
  "node_modules/oled-font-5x7/oled-font-5x7.js"(exports2, module2) {
    module2.exports = {
      monospace: true,
      width: 5,
      height: 7,
      fontData: [
        0,
        0,
        0,
        0,
        0,
        // (space)
        0,
        0,
        95,
        0,
        0,
        // !
        0,
        7,
        0,
        7,
        0,
        // "
        20,
        127,
        20,
        127,
        20,
        // #
        36,
        42,
        127,
        42,
        18,
        // $
        35,
        19,
        8,
        100,
        98,
        // %
        54,
        73,
        85,
        34,
        80,
        // &
        0,
        5,
        3,
        0,
        0,
        // '
        0,
        28,
        34,
        65,
        0,
        // (
        0,
        65,
        34,
        28,
        0,
        // )
        8,
        42,
        28,
        42,
        8,
        // *
        8,
        8,
        62,
        8,
        8,
        // +
        0,
        80,
        48,
        0,
        0,
        // ,
        8,
        8,
        8,
        8,
        8,
        // -
        0,
        96,
        96,
        0,
        0,
        // .
        32,
        16,
        8,
        4,
        2,
        // /
        62,
        81,
        73,
        69,
        62,
        // 0
        0,
        66,
        127,
        64,
        0,
        // 1
        66,
        97,
        81,
        73,
        70,
        // 2
        33,
        65,
        69,
        75,
        49,
        // 3
        24,
        20,
        18,
        127,
        16,
        // 4
        39,
        69,
        69,
        69,
        57,
        // 5
        60,
        74,
        73,
        73,
        48,
        // 6
        1,
        113,
        9,
        5,
        3,
        // 7
        54,
        73,
        73,
        73,
        54,
        // 8
        6,
        73,
        73,
        41,
        30,
        // 9
        0,
        54,
        54,
        0,
        0,
        // :
        0,
        86,
        54,
        0,
        0,
        // ;
        0,
        8,
        20,
        34,
        65,
        // <
        20,
        20,
        20,
        20,
        20,
        // =
        65,
        34,
        20,
        8,
        0,
        // >
        2,
        1,
        81,
        9,
        6,
        // ?
        50,
        73,
        121,
        65,
        62,
        // @
        126,
        17,
        17,
        17,
        126,
        // A
        127,
        73,
        73,
        73,
        54,
        // B
        62,
        65,
        65,
        65,
        34,
        // C
        127,
        65,
        65,
        34,
        28,
        // D
        127,
        73,
        73,
        73,
        65,
        // E
        127,
        9,
        9,
        1,
        1,
        // F
        62,
        65,
        65,
        81,
        50,
        // G
        127,
        8,
        8,
        8,
        127,
        // H
        0,
        65,
        127,
        65,
        0,
        // I
        32,
        64,
        65,
        63,
        1,
        // J
        127,
        8,
        20,
        34,
        65,
        // K
        127,
        64,
        64,
        64,
        64,
        // L
        127,
        2,
        4,
        2,
        127,
        // M
        127,
        4,
        8,
        16,
        127,
        // N
        62,
        65,
        65,
        65,
        62,
        // O
        127,
        9,
        9,
        9,
        6,
        // P
        62,
        65,
        81,
        33,
        94,
        // Q
        127,
        9,
        25,
        41,
        70,
        // R
        70,
        73,
        73,
        73,
        49,
        // S
        1,
        1,
        127,
        1,
        1,
        // T
        63,
        64,
        64,
        64,
        63,
        // U
        31,
        32,
        64,
        32,
        31,
        // V
        127,
        32,
        24,
        32,
        127,
        // W
        99,
        20,
        8,
        20,
        99,
        // X
        3,
        4,
        120,
        4,
        3,
        // Y
        97,
        81,
        73,
        69,
        67,
        // Z
        125,
        18,
        18,
        125,
        0,
        // Ä
        61,
        66,
        66,
        66,
        61,
        // Ö
        61,
        64,
        64,
        64,
        61,
        // Ü
        0,
        0,
        127,
        65,
        65,
        // [
        2,
        4,
        8,
        16,
        32,
        // "\"
        65,
        65,
        127,
        0,
        0,
        // ]
        4,
        2,
        1,
        2,
        4,
        // ^
        64,
        64,
        64,
        64,
        64,
        // _
        0,
        1,
        2,
        4,
        0,
        // `
        32,
        84,
        84,
        84,
        120,
        // a
        127,
        72,
        68,
        68,
        56,
        // b
        56,
        68,
        68,
        68,
        32,
        // c
        56,
        68,
        68,
        72,
        127,
        // d
        56,
        84,
        84,
        84,
        24,
        // e
        8,
        126,
        9,
        1,
        2,
        // f
        8,
        20,
        84,
        84,
        60,
        // g
        127,
        8,
        4,
        4,
        120,
        // h
        0,
        68,
        125,
        64,
        0,
        // i
        32,
        64,
        68,
        61,
        0,
        // j
        0,
        127,
        16,
        40,
        68,
        // k
        0,
        65,
        127,
        64,
        0,
        // l
        124,
        4,
        24,
        4,
        120,
        // m
        124,
        8,
        4,
        4,
        120,
        // n
        56,
        68,
        68,
        68,
        56,
        // o
        124,
        20,
        20,
        20,
        8,
        // p
        8,
        20,
        20,
        24,
        124,
        // q
        124,
        8,
        4,
        4,
        8,
        // r
        72,
        84,
        84,
        84,
        32,
        // s
        4,
        63,
        68,
        64,
        32,
        // t
        60,
        64,
        64,
        32,
        124,
        // u
        28,
        32,
        64,
        32,
        28,
        // v
        60,
        64,
        48,
        64,
        60,
        // w
        68,
        40,
        16,
        40,
        68,
        // x
        12,
        80,
        80,
        80,
        60,
        // y
        68,
        100,
        84,
        76,
        68,
        // z
        32,
        85,
        84,
        85,
        120,
        // ä
        58,
        68,
        68,
        58,
        0,
        // ö
        58,
        64,
        64,
        58,
        0,
        // ü
        0,
        8,
        54,
        65,
        0,
        // {
        0,
        0,
        127,
        0,
        0,
        // |
        0,
        65,
        54,
        8,
        0,
        // }
        20,
        62,
        85,
        65,
        34,
        // €
        8,
        8,
        42,
        28,
        8,
        // -> (ALT + 0134) † 
        8,
        28,
        42,
        8,
        8,
        // <- (ALT + 0135) ‡
        0,
        0,
        7,
        5,
        7
        // °
      ],
      lookup: [
        " ",
        "!",
        '"',
        "#",
        "$",
        "%",
        "&",
        "'",
        "(",
        ")",
        "*",
        "+",
        ",",
        "-",
        ".",
        "/",
        "0",
        "1",
        "2",
        "3",
        "4",
        "5",
        "6",
        "7",
        "8",
        "9",
        ":",
        ";",
        "<",
        "=",
        ">",
        "?",
        "@",
        "A",
        "B",
        "C",
        "D",
        "E",
        "F",
        "G",
        "H",
        "I",
        "J",
        "K",
        "L",
        "M",
        "N",
        "O",
        "P",
        "Q",
        "R",
        "S",
        "T",
        "U",
        "V",
        "W",
        "X",
        "Y",
        "Z",
        "\xC4",
        "\xD6",
        "\xDC",
        "[",
        "\\",
        "]",
        "^",
        "_",
        "`",
        "a",
        "b",
        "c",
        "d",
        "e",
        "f",
        "g",
        "h",
        "i",
        "j",
        "k",
        "l",
        "m",
        "n",
        "o",
        "p",
        "q",
        "r",
        "s",
        "t",
        "u",
        "v",
        "w",
        "x",
        "y",
        "z",
        "\xE4",
        "\xF6",
        "\xFC",
        "{",
        "|",
        "}",
        "\u20AC",
        "\u2020",
        "\u2021",
        "\xB0"
      ]
    };
  }
});

// src/oledscreen.js
var require_oledscreen = __commonJS({
  "src/oledscreen.js"(exports2, module2) {
    "use strict";
    async function oledScreenInit(gwGlobalState) {
      if (process.platform != "linux")
        return;
      const i2c = require_i2c_bus();
      const i2cBus = await i2c.openPromisified(0);
      const oled = require_oled();
      const font = require_oled_font_5x7();
      const gwutils2 = require_gwutils();
      const os2 = require("os");
      const { promisify } = require("util");
      const exec = promisify(require("child_process").exec);
      function countRecentNodes() {
        let now = Date.now();
        let total = 0;
        for (let phantomCode in gwGlobalState.nodes) {
          let node = gwGlobalState.nodes[phantomCode];
          if (now - node.lastseen < 12e4) {
            total++;
          }
        }
        return total;
      }
      const opts = {
        width: 128,
        height: 32,
        address: 60,
        bus: 0,
        driver: "SSD1306"
      };
      if (gwGlobalState.deviceInfo.hasBuildInChannels) {
        opts.driver = "SH1106";
        opts.height = 64;
      }
      let display = null;
      let cpuserial = await exec('cat /proc/cpuinfo |grep Serial| cut -d ":" -f 2');
      console.log(cpuserial.stdout);
      cpuserial = cpuserial.stdout.trim();
      gwGlobalState.deviceInfo.cpuSerialNumber = cpuserial;
      let netifaces = os2.networkInterfaces();
      display = new oled(i2cBus, opts);
      await display.api._initialise();
      await display.clearDisplay();
      await display.turnOnDisplay();
      let serviceStates = [];
      let currentService = 0;
      if (gwGlobalState.basicconfig.sendtoeimonitor && !gwutils2.isSubordinate()) {
        serviceStates.push(() => {
          if (gwGlobalState.deviceInfo.digivibeIPAddr)
            return "Mon: " + gwGlobalState.deviceInfo.digivibeIPAddr;
          else
            return "Mon: NO MONITOR    ";
        });
      }
      if (gwGlobalState.basicconfig.sendtoeianalytics && !gwutils2.isSubordinate()) {
        serviceStates.push(() => {
          if (gwGlobalState.deviceInfo.eiAnalyticsStatus == "ok")
            return "EI Analytic: OK";
          else if (gwGlobalState.deviceInfo.eiAnalyticsStatus == "unknow")
            return "EI Analytic: Connecting";
          else
            return "EI Analytic: FAIL";
        });
      }
      if (gwGlobalState.basicconfig.isalternateurl && !gwutils2.isSubordinate()) {
        serviceStates.push(() => {
          if (gwGlobalState.deviceInfo.alternateCloudState == "ok")
            return "Cloud: OK";
          else if (gwGlobalState.deviceInfo.alternateCloudState == "unknow")
            return "Cloud: Connecting";
          else
            return "Cloud: FAIL";
        });
      }
      if (!gwutils2.isSubordinate()) {
        serviceStates.push(() => {
          let dateTime = "";
          let now = /* @__PURE__ */ new Date();
          dateTime += now.getFullYear() + "-" + (now.getMonth() + 1).toString().padStart(2, "0") + "-" + now.getDate().toString().padStart(2, "0") + " ";
          dateTime += now.getHours().toString().padStart(2, "0") + ":" + now.getMinutes().toString().padStart(2, "0") + ":" + now.getSeconds().toString().padStart(2, "0");
          return dateTime;
        });
      }
      let promiseObject = {
        resolve: null,
        timeout: null
      };
      let customMessage = null;
      gwutils2.subscribeToEvent("showscreen", (eventdata) => {
        customMessage = eventdata.lines;
        if (promiseObject.timeout)
          clearTimeout(promiseObject.timeout);
        if (promiseObject.resolve) {
          promiseObject.resolve("signal");
        }
      });
      gwutils2.subscribeToEvent("restarting", (eventdata) => {
        if (promiseObject.timeout)
          clearTimeout(promiseObject.timeout);
        if (promiseObject.resolve) {
          promiseObject.resolve("signal");
        }
      });
      while (true) {
        let sleepTime = 6e3;
        display.clearDisplay(false);
        if (customMessage) {
          if (customMessage[0]) {
            display.setCursor(0, 0);
            display.writeString(font, 1, customMessage[0], 1, false, false);
          }
          if (customMessage[1]) {
            display.setCursor(0, 9);
            display.writeString(font, 1, customMessage[1], 1, false, false);
          }
          if (customMessage[2]) {
            display.setCursor(0, 18);
            display.writeString(font, 1, customMessage[2], 1, false, false);
          }
          sleepTime = 3e4;
        } else if (gwGlobalState.deviceInfo?.state?.action == "restarting") {
          display.setCursor(0, 0);
          display.writeString(font, 1, "Restarting...", 1, false, false);
          sleepTime = 1e4;
        } else if (gwGlobalState.deviceInfo?.state?.action == "updating") {
          display.clearDisplay(false);
          display.setCursor(0, 0);
          display.writeString(font, 1, "Updating " + (gwGlobalState.deviceInfo.state?.progress * 100).toFixed() + "%", 1, false, false);
          sleepTime = 300;
        } else {
          netifaces = os2.networkInterfaces();
          gwGlobalState.deviceInfo.netifaces = netifaces;
          let ipaddress = "";
          display.setCursor(0, 0);
          if (gwutils2.getSubordinateConnected() && netifaces.eth0 && netifaces.eth0[0] && netifaces.eth0[0].family == "IPv6" && netifaces.eth0[0].includes("fd66:66:66")) {
            display.writeString(font, 1, "Connected to mesh", 1, false, false);
          } else if (netifaces.eth0 && netifaces.eth0[0] && netifaces.eth0[0].family != "IPv6") {
            ipaddress = netifaces.eth0[0].address;
            display.writeString(font, 1, "IP: " + ipaddress, 1, false, false);
          } else if (netifaces.wlan0 && netifaces.wlan0[0] && netifaces.wlan0[0].address == "192.168.4.1") {
            ipaddress = netifaces.wlan0[0].address;
            display.writeString(font, 1, "IP: " + ipaddress + "(AP)", 1, false, false);
          } else if (netifaces.wlan0 && netifaces.wlan0[0]) {
            ipaddress = netifaces.wlan0[0].address;
            if (ipaddress.includes("fd66:66:66")) {
              display.writeString(font, 1, "Connected to mesh", 1, false, false);
            } else {
              ipaddress = netifaces.wlan0[0].address;
              display.writeString(font, 1, "IP: " + ipaddress, 1, false, false);
            }
          } else if (netifaces["eth0:avahi"] && netifaces["eth0:avahi"][0]) {
            ipaddress = netifaces["eth0:avahi"][0].address;
            display.writeString(font, 1, "IP: " + ipaddress, 1, false, false);
          } else {
            display.writeString(font, 1, "Not connected", 1, false, false);
          }
          display.setCursor(0, 9);
          if (!gwutils2.isSubordinate())
            display.writeString(font, 1, "Recent sensors: " + countRecentNodes(), 1, false, false);
          display.setCursor(0, 18);
          if (serviceStates.length > 0) {
            let serviceString = serviceStates[currentService]();
            currentService++;
            if (currentService == serviceStates.length)
              currentService = 0;
            display.writeString(font, 1, serviceString, 1, false, false);
          }
        }
        await display.update();
        await gwutils2.sleepOrPromise(sleepTime, promiseObject);
      }
    }
    module2.exports = {
      oledScreenInit
    };
  }
});

// node_modules/totalist/sync/index.js
var require_sync = __commonJS({
  "node_modules/totalist/sync/index.js"(exports2) {
    var { join: join2, resolve: resolve2 } = require("path");
    var { readdirSync, statSync: statSync2 } = require("fs");
    function totalist(dir, callback, pre = "") {
      dir = resolve2(".", dir);
      let arr = readdirSync(dir);
      let i = 0, abs, stats;
      for (; i < arr.length; i++) {
        abs = join2(dir, arr[i]);
        stats = statSync2(abs);
        stats.isDirectory() ? totalist(abs, callback, join2(pre, arr[i])) : callback(join2(pre, arr[i]), abs, stats);
      }
    }
    exports2.totalist = totalist;
  }
});

// node_modules/@polka/url/build.js
var require_build = __commonJS({
  "node_modules/@polka/url/build.js"(exports2) {
    var qs = require("querystring");
    function parse6(req) {
      let raw2 = req.url;
      if (raw2 == null)
        return;
      let prev = req._parsedUrl;
      if (prev && prev.raw === raw2)
        return prev;
      let pathname = raw2, search = "", query;
      if (raw2.length > 1) {
        let idx = raw2.indexOf("?", 1);
        if (idx !== -1) {
          search = raw2.substring(idx);
          pathname = raw2.substring(0, idx);
          if (search.length > 1) {
            query = qs.parse(search.substring(1));
          }
        }
      }
      return req._parsedUrl = { pathname, search, query, raw: raw2 };
    }
    exports2.parse = parse6;
  }
});

// node_modules/mrmime/index.js
var require_mrmime = __commonJS({
  "node_modules/mrmime/index.js"(exports2) {
    var mimes = {
      "ez": "application/andrew-inset",
      "aw": "application/applixware",
      "atom": "application/atom+xml",
      "atomcat": "application/atomcat+xml",
      "atomdeleted": "application/atomdeleted+xml",
      "atomsvc": "application/atomsvc+xml",
      "dwd": "application/atsc-dwd+xml",
      "held": "application/atsc-held+xml",
      "rsat": "application/atsc-rsat+xml",
      "bdoc": "application/bdoc",
      "xcs": "application/calendar+xml",
      "ccxml": "application/ccxml+xml",
      "cdfx": "application/cdfx+xml",
      "cdmia": "application/cdmi-capability",
      "cdmic": "application/cdmi-container",
      "cdmid": "application/cdmi-domain",
      "cdmio": "application/cdmi-object",
      "cdmiq": "application/cdmi-queue",
      "cu": "application/cu-seeme",
      "mpd": "application/dash+xml",
      "davmount": "application/davmount+xml",
      "dbk": "application/docbook+xml",
      "dssc": "application/dssc+der",
      "xdssc": "application/dssc+xml",
      "es": "application/ecmascript",
      "ecma": "application/ecmascript",
      "emma": "application/emma+xml",
      "emotionml": "application/emotionml+xml",
      "epub": "application/epub+zip",
      "exi": "application/exi",
      "fdt": "application/fdt+xml",
      "pfr": "application/font-tdpfr",
      "geojson": "application/geo+json",
      "gml": "application/gml+xml",
      "gpx": "application/gpx+xml",
      "gxf": "application/gxf",
      "gz": "application/gzip",
      "hjson": "application/hjson",
      "stk": "application/hyperstudio",
      "ink": "application/inkml+xml",
      "inkml": "application/inkml+xml",
      "ipfix": "application/ipfix",
      "its": "application/its+xml",
      "jar": "application/java-archive",
      "war": "application/java-archive",
      "ear": "application/java-archive",
      "ser": "application/java-serialized-object",
      "class": "application/java-vm",
      "js": "application/javascript",
      "mjs": "application/javascript",
      "json": "application/json",
      "map": "application/json",
      "json5": "application/json5",
      "jsonml": "application/jsonml+json",
      "jsonld": "application/ld+json",
      "lgr": "application/lgr+xml",
      "lostxml": "application/lost+xml",
      "hqx": "application/mac-binhex40",
      "cpt": "application/mac-compactpro",
      "mads": "application/mads+xml",
      "webmanifest": "application/manifest+json",
      "mrc": "application/marc",
      "mrcx": "application/marcxml+xml",
      "ma": "application/mathematica",
      "nb": "application/mathematica",
      "mb": "application/mathematica",
      "mathml": "application/mathml+xml",
      "mbox": "application/mbox",
      "mscml": "application/mediaservercontrol+xml",
      "metalink": "application/metalink+xml",
      "meta4": "application/metalink4+xml",
      "mets": "application/mets+xml",
      "maei": "application/mmt-aei+xml",
      "musd": "application/mmt-usd+xml",
      "mods": "application/mods+xml",
      "m21": "application/mp21",
      "mp21": "application/mp21",
      "mp4s": "application/mp4",
      "m4p": "application/mp4",
      "doc": "application/msword",
      "dot": "application/msword",
      "mxf": "application/mxf",
      "nq": "application/n-quads",
      "nt": "application/n-triples",
      "cjs": "application/node",
      "bin": "application/octet-stream",
      "dms": "application/octet-stream",
      "lrf": "application/octet-stream",
      "mar": "application/octet-stream",
      "so": "application/octet-stream",
      "dist": "application/octet-stream",
      "distz": "application/octet-stream",
      "pkg": "application/octet-stream",
      "bpk": "application/octet-stream",
      "dump": "application/octet-stream",
      "elc": "application/octet-stream",
      "deploy": "application/octet-stream",
      "exe": "application/octet-stream",
      "dll": "application/octet-stream",
      "deb": "application/octet-stream",
      "dmg": "application/octet-stream",
      "iso": "application/octet-stream",
      "img": "application/octet-stream",
      "msi": "application/octet-stream",
      "msp": "application/octet-stream",
      "msm": "application/octet-stream",
      "buffer": "application/octet-stream",
      "oda": "application/oda",
      "opf": "application/oebps-package+xml",
      "ogx": "application/ogg",
      "omdoc": "application/omdoc+xml",
      "onetoc": "application/onenote",
      "onetoc2": "application/onenote",
      "onetmp": "application/onenote",
      "onepkg": "application/onenote",
      "oxps": "application/oxps",
      "relo": "application/p2p-overlay+xml",
      "xer": "application/patch-ops-error+xml",
      "pdf": "application/pdf",
      "pgp": "application/pgp-encrypted",
      "asc": "application/pgp-signature",
      "sig": "application/pgp-signature",
      "prf": "application/pics-rules",
      "p10": "application/pkcs10",
      "p7m": "application/pkcs7-mime",
      "p7c": "application/pkcs7-mime",
      "p7s": "application/pkcs7-signature",
      "p8": "application/pkcs8",
      "ac": "application/pkix-attr-cert",
      "cer": "application/pkix-cert",
      "crl": "application/pkix-crl",
      "pkipath": "application/pkix-pkipath",
      "pki": "application/pkixcmp",
      "pls": "application/pls+xml",
      "ai": "application/postscript",
      "eps": "application/postscript",
      "ps": "application/postscript",
      "provx": "application/provenance+xml",
      "cww": "application/prs.cww",
      "pskcxml": "application/pskc+xml",
      "raml": "application/raml+yaml",
      "rdf": "application/rdf+xml",
      "owl": "application/rdf+xml",
      "rif": "application/reginfo+xml",
      "rnc": "application/relax-ng-compact-syntax",
      "rl": "application/resource-lists+xml",
      "rld": "application/resource-lists-diff+xml",
      "rs": "application/rls-services+xml",
      "rapd": "application/route-apd+xml",
      "sls": "application/route-s-tsid+xml",
      "rusd": "application/route-usd+xml",
      "gbr": "application/rpki-ghostbusters",
      "mft": "application/rpki-manifest",
      "roa": "application/rpki-roa",
      "rsd": "application/rsd+xml",
      "rss": "application/rss+xml",
      "rtf": "application/rtf",
      "sbml": "application/sbml+xml",
      "scq": "application/scvp-cv-request",
      "scs": "application/scvp-cv-response",
      "spq": "application/scvp-vp-request",
      "spp": "application/scvp-vp-response",
      "sdp": "application/sdp",
      "senmlx": "application/senml+xml",
      "sensmlx": "application/sensml+xml",
      "setpay": "application/set-payment-initiation",
      "setreg": "application/set-registration-initiation",
      "shf": "application/shf+xml",
      "siv": "application/sieve",
      "sieve": "application/sieve",
      "smi": "application/smil+xml",
      "smil": "application/smil+xml",
      "rq": "application/sparql-query",
      "srx": "application/sparql-results+xml",
      "gram": "application/srgs",
      "grxml": "application/srgs+xml",
      "sru": "application/sru+xml",
      "ssdl": "application/ssdl+xml",
      "ssml": "application/ssml+xml",
      "swidtag": "application/swid+xml",
      "tei": "application/tei+xml",
      "teicorpus": "application/tei+xml",
      "tfi": "application/thraud+xml",
      "tsd": "application/timestamped-data",
      "toml": "application/toml",
      "trig": "application/trig",
      "ttml": "application/ttml+xml",
      "ubj": "application/ubjson",
      "rsheet": "application/urc-ressheet+xml",
      "td": "application/urc-targetdesc+xml",
      "vxml": "application/voicexml+xml",
      "wasm": "application/wasm",
      "wgt": "application/widget",
      "hlp": "application/winhlp",
      "wsdl": "application/wsdl+xml",
      "wspolicy": "application/wspolicy+xml",
      "xaml": "application/xaml+xml",
      "xav": "application/xcap-att+xml",
      "xca": "application/xcap-caps+xml",
      "xdf": "application/xcap-diff+xml",
      "xel": "application/xcap-el+xml",
      "xns": "application/xcap-ns+xml",
      "xenc": "application/xenc+xml",
      "xhtml": "application/xhtml+xml",
      "xht": "application/xhtml+xml",
      "xlf": "application/xliff+xml",
      "xml": "application/xml",
      "xsl": "application/xml",
      "xsd": "application/xml",
      "rng": "application/xml",
      "dtd": "application/xml-dtd",
      "xop": "application/xop+xml",
      "xpl": "application/xproc+xml",
      "xslt": "application/xml",
      "xspf": "application/xspf+xml",
      "mxml": "application/xv+xml",
      "xhvml": "application/xv+xml",
      "xvml": "application/xv+xml",
      "xvm": "application/xv+xml",
      "yang": "application/yang",
      "yin": "application/yin+xml",
      "zip": "application/zip",
      "3gpp": "video/3gpp",
      "adp": "audio/adpcm",
      "amr": "audio/amr",
      "au": "audio/basic",
      "snd": "audio/basic",
      "mid": "audio/midi",
      "midi": "audio/midi",
      "kar": "audio/midi",
      "rmi": "audio/midi",
      "mxmf": "audio/mobile-xmf",
      "mp3": "audio/mpeg",
      "m4a": "audio/mp4",
      "mp4a": "audio/mp4",
      "mpga": "audio/mpeg",
      "mp2": "audio/mpeg",
      "mp2a": "audio/mpeg",
      "m2a": "audio/mpeg",
      "m3a": "audio/mpeg",
      "oga": "audio/ogg",
      "ogg": "audio/ogg",
      "spx": "audio/ogg",
      "opus": "audio/ogg",
      "s3m": "audio/s3m",
      "sil": "audio/silk",
      "wav": "audio/wav",
      "weba": "audio/webm",
      "xm": "audio/xm",
      "ttc": "font/collection",
      "otf": "font/otf",
      "ttf": "font/ttf",
      "woff": "font/woff",
      "woff2": "font/woff2",
      "exr": "image/aces",
      "apng": "image/apng",
      "avif": "image/avif",
      "bmp": "image/bmp",
      "cgm": "image/cgm",
      "drle": "image/dicom-rle",
      "emf": "image/emf",
      "fits": "image/fits",
      "g3": "image/g3fax",
      "gif": "image/gif",
      "heic": "image/heic",
      "heics": "image/heic-sequence",
      "heif": "image/heif",
      "heifs": "image/heif-sequence",
      "hej2": "image/hej2k",
      "hsj2": "image/hsj2",
      "ief": "image/ief",
      "jls": "image/jls",
      "jp2": "image/jp2",
      "jpg2": "image/jp2",
      "jpeg": "image/jpeg",
      "jpg": "image/jpeg",
      "jpe": "image/jpeg",
      "jph": "image/jph",
      "jhc": "image/jphc",
      "jpm": "image/jpm",
      "jpx": "image/jpx",
      "jpf": "image/jpx",
      "jxr": "image/jxr",
      "jxra": "image/jxra",
      "jxrs": "image/jxrs",
      "jxs": "image/jxs",
      "jxsc": "image/jxsc",
      "jxsi": "image/jxsi",
      "jxss": "image/jxss",
      "ktx": "image/ktx",
      "ktx2": "image/ktx2",
      "png": "image/png",
      "btif": "image/prs.btif",
      "pti": "image/prs.pti",
      "sgi": "image/sgi",
      "svg": "image/svg+xml",
      "svgz": "image/svg+xml",
      "t38": "image/t38",
      "tif": "image/tiff",
      "tiff": "image/tiff",
      "tfx": "image/tiff-fx",
      "webp": "image/webp",
      "wmf": "image/wmf",
      "disposition-notification": "message/disposition-notification",
      "u8msg": "message/global",
      "u8dsn": "message/global-delivery-status",
      "u8mdn": "message/global-disposition-notification",
      "u8hdr": "message/global-headers",
      "eml": "message/rfc822",
      "mime": "message/rfc822",
      "3mf": "model/3mf",
      "gltf": "model/gltf+json",
      "glb": "model/gltf-binary",
      "igs": "model/iges",
      "iges": "model/iges",
      "msh": "model/mesh",
      "mesh": "model/mesh",
      "silo": "model/mesh",
      "mtl": "model/mtl",
      "obj": "model/obj",
      "stpz": "model/step+zip",
      "stpxz": "model/step-xml+zip",
      "stl": "model/stl",
      "wrl": "model/vrml",
      "vrml": "model/vrml",
      "x3db": "model/x3d+fastinfoset",
      "x3dbz": "model/x3d+binary",
      "x3dv": "model/x3d-vrml",
      "x3dvz": "model/x3d+vrml",
      "x3d": "model/x3d+xml",
      "x3dz": "model/x3d+xml",
      "appcache": "text/cache-manifest",
      "manifest": "text/cache-manifest",
      "ics": "text/calendar",
      "ifb": "text/calendar",
      "coffee": "text/coffeescript",
      "litcoffee": "text/coffeescript",
      "css": "text/css",
      "csv": "text/csv",
      "html": "text/html",
      "htm": "text/html",
      "shtml": "text/html",
      "jade": "text/jade",
      "jsx": "text/jsx",
      "less": "text/less",
      "markdown": "text/markdown",
      "md": "text/markdown",
      "mml": "text/mathml",
      "mdx": "text/mdx",
      "n3": "text/n3",
      "txt": "text/plain",
      "text": "text/plain",
      "conf": "text/plain",
      "def": "text/plain",
      "list": "text/plain",
      "log": "text/plain",
      "in": "text/plain",
      "ini": "text/plain",
      "dsc": "text/prs.lines.tag",
      "rtx": "text/richtext",
      "sgml": "text/sgml",
      "sgm": "text/sgml",
      "shex": "text/shex",
      "slim": "text/slim",
      "slm": "text/slim",
      "spdx": "text/spdx",
      "stylus": "text/stylus",
      "styl": "text/stylus",
      "tsv": "text/tab-separated-values",
      "t": "text/troff",
      "tr": "text/troff",
      "roff": "text/troff",
      "man": "text/troff",
      "me": "text/troff",
      "ms": "text/troff",
      "ttl": "text/turtle",
      "uri": "text/uri-list",
      "uris": "text/uri-list",
      "urls": "text/uri-list",
      "vcard": "text/vcard",
      "vtt": "text/vtt",
      "yaml": "text/yaml",
      "yml": "text/yaml",
      "3gp": "video/3gpp",
      "3g2": "video/3gpp2",
      "h261": "video/h261",
      "h263": "video/h263",
      "h264": "video/h264",
      "m4s": "video/iso.segment",
      "jpgv": "video/jpeg",
      "jpgm": "image/jpm",
      "mj2": "video/mj2",
      "mjp2": "video/mj2",
      "ts": "video/mp2t",
      "mp4": "video/mp4",
      "mp4v": "video/mp4",
      "mpg4": "video/mp4",
      "mpeg": "video/mpeg",
      "mpg": "video/mpeg",
      "mpe": "video/mpeg",
      "m1v": "video/mpeg",
      "m2v": "video/mpeg",
      "ogv": "video/ogg",
      "qt": "video/quicktime",
      "mov": "video/quicktime",
      "webm": "video/webm"
    };
    function lookup2(extn) {
      let tmp = ("" + extn).trim().toLowerCase();
      let idx = tmp.lastIndexOf(".");
      return mimes[!~idx ? tmp : tmp.substring(++idx)];
    }
    exports2.lookup = lookup2;
    exports2.mimes = mimes;
  }
});

// node_modules/sirv/build.js
var require_build2 = __commonJS({
  "node_modules/sirv/build.js"(exports2, module2) {
    var fs2 = require("fs");
    var { join: join2, normalize, resolve: resolve2 } = require("path");
    var { totalist } = require_sync();
    var { parse: parse6 } = require_build();
    var { lookup: lookup2 } = require_mrmime();
    var noop = () => {
    };
    function isMatch(uri, arr) {
      for (let i = 0; i < arr.length; i++) {
        if (arr[i].test(uri))
          return true;
      }
    }
    function toAssume(uri, extns) {
      let i = 0, x2, len = uri.length - 1;
      if (uri.charCodeAt(len) === 47) {
        uri = uri.substring(0, len);
      }
      let arr = [], tmp = `${uri}/index`;
      for (; i < extns.length; i++) {
        x2 = extns[i] ? `.${extns[i]}` : "";
        if (uri)
          arr.push(uri + x2);
        arr.push(tmp + x2);
      }
      return arr;
    }
    function viaCache(cache, uri, extns) {
      let i = 0, data, arr = toAssume(uri, extns);
      for (; i < arr.length; i++) {
        if (data = cache[arr[i]])
          return data;
      }
    }
    function viaLocal(dir, isEtag, uri, extns) {
      let i = 0, arr = toAssume(uri, extns);
      let abs, stats, name, headers;
      for (; i < arr.length; i++) {
        abs = normalize(join2(dir, name = arr[i]));
        if (abs.startsWith(dir) && fs2.existsSync(abs)) {
          stats = fs2.statSync(abs);
          if (stats.isDirectory())
            continue;
          headers = toHeaders(name, stats, isEtag);
          headers["Cache-Control"] = isEtag ? "no-cache" : "no-store";
          return { abs, stats, headers };
        }
      }
    }
    function is404(req, res) {
      return res.statusCode = 404, res.end();
    }
    function send2(req, res, file, stats, headers) {
      let code = 200, tmp, opts = {};
      headers = { ...headers };
      for (let key in headers) {
        tmp = res.getHeader(key);
        if (tmp)
          headers[key] = tmp;
      }
      if (tmp = res.getHeader("content-type")) {
        headers["Content-Type"] = tmp;
      }
      if (req.headers.range) {
        code = 206;
        let [x2, y] = req.headers.range.replace("bytes=", "").split("-");
        let end = opts.end = parseInt(y, 10) || stats.size - 1;
        let start = opts.start = parseInt(x2, 10) || 0;
        if (start >= stats.size || end >= stats.size) {
          res.setHeader("Content-Range", `bytes */${stats.size}`);
          res.statusCode = 416;
          return res.end();
        }
        headers["Content-Range"] = `bytes ${start}-${end}/${stats.size}`;
        headers["Content-Length"] = end - start + 1;
        headers["Accept-Ranges"] = "bytes";
      }
      res.writeHead(code, headers);
      fs2.createReadStream(file, opts).pipe(res);
    }
    var ENCODING = {
      ".br": "br",
      ".gz": "gzip"
    };
    function toHeaders(name, stats, isEtag) {
      let enc = ENCODING[name.slice(-3)];
      let ctype = lookup2(name.slice(0, enc && -3)) || "";
      if (ctype === "text/html")
        ctype += ";charset=utf-8";
      let headers = {
        "Content-Length": stats.size,
        "Content-Type": ctype,
        "Last-Modified": stats.mtime.toUTCString()
      };
      if (enc)
        headers["Content-Encoding"] = enc;
      if (isEtag)
        headers["ETag"] = `W/"${stats.size}-${stats.mtime.getTime()}"`;
      return headers;
    }
    module2.exports = function(dir, opts = {}) {
      dir = resolve2(dir || ".");
      let isNotFound = opts.onNoMatch || is404;
      let setHeaders = opts.setHeaders || noop;
      let extensions2 = opts.extensions || ["html", "htm"];
      let gzips = opts.gzip && extensions2.map((x2) => `${x2}.gz`).concat("gz");
      let brots = opts.brotli && extensions2.map((x2) => `${x2}.br`).concat("br");
      const FILES = {};
      let fallback = "/";
      let isEtag = !!opts.etag;
      let isSPA = !!opts.single;
      if (typeof opts.single === "string") {
        let idx = opts.single.lastIndexOf(".");
        fallback += !!~idx ? opts.single.substring(0, idx) : opts.single;
      }
      let ignores = [];
      if (opts.ignores !== false) {
        ignores.push(/[/]([A-Za-z\s\d~$._-]+\.\w+){1,}$/);
        if (opts.dotfiles)
          ignores.push(/\/\.\w/);
        else
          ignores.push(/\/\.well-known/);
        [].concat(opts.ignores || []).forEach((x2) => {
          ignores.push(new RegExp(x2, "i"));
        });
      }
      let cc = opts.maxAge != null && `public,max-age=${opts.maxAge}`;
      if (cc && opts.immutable)
        cc += ",immutable";
      else if (cc && opts.maxAge === 0)
        cc += ",must-revalidate";
      if (!opts.dev) {
        totalist(dir, (name, abs, stats) => {
          if (/\.well-known[\\+\/]/.test(name)) {
          } else if (!opts.dotfiles && /(^\.|[\\+|\/+]\.)/.test(name))
            return;
          let headers = toHeaders(name, stats, isEtag);
          if (cc)
            headers["Cache-Control"] = cc;
          FILES["/" + name.normalize().replace(/\\+/g, "/")] = { abs, stats, headers };
        });
      }
      let lookup3 = opts.dev ? viaLocal.bind(0, dir, isEtag) : viaCache.bind(0, FILES);
      return function(req, res, next) {
        let extns = [""];
        let pathname = parse6(req).pathname;
        let val = req.headers["accept-encoding"] || "";
        if (gzips && val.includes("gzip"))
          extns.unshift(...gzips);
        if (brots && /(br|brotli)/i.test(val))
          extns.unshift(...brots);
        extns.push(...extensions2);
        if (pathname.indexOf("%") !== -1) {
          try {
            pathname = decodeURIComponent(pathname);
          } catch (err) {
          }
        }
        let data = lookup3(pathname, extns) || isSPA && !isMatch(pathname, ignores) && lookup3(fallback, extns);
        if (!data)
          return next ? next() : isNotFound(req, res);
        if (isEtag && req.headers["if-none-match"] === data.headers["ETag"]) {
          res.writeHead(304);
          return res.end();
        }
        if (gzips || brots) {
          res.setHeader("Vary", "Accept-Encoding");
        }
        setHeaders(res, pathname, data.stats);
        send2(req, res, data.abs, data.stats, data.headers);
      };
    };
  }
});

// node_modules/ws/lib/constants.js
var require_constants = __commonJS({
  "node_modules/ws/lib/constants.js"(exports2, module2) {
    "use strict";
    module2.exports = {
      BINARY_TYPES: ["nodebuffer", "arraybuffer", "fragments"],
      EMPTY_BUFFER: Buffer.alloc(0),
      GUID: "258EAFA5-E914-47DA-95CA-C5AB0DC85B11",
      kForOnEventAttribute: Symbol("kIsForOnEventAttribute"),
      kListener: Symbol("kListener"),
      kStatusCode: Symbol("status-code"),
      kWebSocket: Symbol("websocket"),
      NOOP: () => {
      }
    };
  }
});

// node_modules/ws/lib/buffer-util.js
var require_buffer_util = __commonJS({
  "node_modules/ws/lib/buffer-util.js"(exports2, module2) {
    "use strict";
    var { EMPTY_BUFFER } = require_constants();
    function concat(list, totalLength) {
      if (list.length === 0)
        return EMPTY_BUFFER;
      if (list.length === 1)
        return list[0];
      const target = Buffer.allocUnsafe(totalLength);
      let offset = 0;
      for (let i = 0; i < list.length; i++) {
        const buf = list[i];
        target.set(buf, offset);
        offset += buf.length;
      }
      if (offset < totalLength)
        return target.slice(0, offset);
      return target;
    }
    function _mask(source, mask, output, offset, length) {
      for (let i = 0; i < length; i++) {
        output[offset + i] = source[i] ^ mask[i & 3];
      }
    }
    function _unmask(buffer, mask) {
      for (let i = 0; i < buffer.length; i++) {
        buffer[i] ^= mask[i & 3];
      }
    }
    function toArrayBuffer(buf) {
      if (buf.byteLength === buf.buffer.byteLength) {
        return buf.buffer;
      }
      return buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.byteLength);
    }
    function toBuffer(data) {
      toBuffer.readOnly = true;
      if (Buffer.isBuffer(data))
        return data;
      let buf;
      if (data instanceof ArrayBuffer) {
        buf = Buffer.from(data);
      } else if (ArrayBuffer.isView(data)) {
        buf = Buffer.from(data.buffer, data.byteOffset, data.byteLength);
      } else {
        buf = Buffer.from(data);
        toBuffer.readOnly = false;
      }
      return buf;
    }
    try {
      const bufferUtil = require("bufferutil");
      module2.exports = {
        concat,
        mask(source, mask, output, offset, length) {
          if (length < 48)
            _mask(source, mask, output, offset, length);
          else
            bufferUtil.mask(source, mask, output, offset, length);
        },
        toArrayBuffer,
        toBuffer,
        unmask(buffer, mask) {
          if (buffer.length < 32)
            _unmask(buffer, mask);
          else
            bufferUtil.unmask(buffer, mask);
        }
      };
    } catch (e) {
      module2.exports = {
        concat,
        mask: _mask,
        toArrayBuffer,
        toBuffer,
        unmask: _unmask
      };
    }
  }
});

// node_modules/ws/lib/limiter.js
var require_limiter = __commonJS({
  "node_modules/ws/lib/limiter.js"(exports2, module2) {
    "use strict";
    var kDone = Symbol("kDone");
    var kRun = Symbol("kRun");
    var Limiter = class {
      /**
       * Creates a new `Limiter`.
       *
       * @param {Number} [concurrency=Infinity] The maximum number of jobs allowed
       *     to run concurrently
       */
      constructor(concurrency) {
        this[kDone] = () => {
          this.pending--;
          this[kRun]();
        };
        this.concurrency = concurrency || Infinity;
        this.jobs = [];
        this.pending = 0;
      }
      /**
       * Adds a job to the queue.
       *
       * @param {Function} job The job to run
       * @public
       */
      add(job) {
        this.jobs.push(job);
        this[kRun]();
      }
      /**
       * Removes a job from the queue and runs it if possible.
       *
       * @private
       */
      [kRun]() {
        if (this.pending === this.concurrency)
          return;
        if (this.jobs.length) {
          const job = this.jobs.shift();
          this.pending++;
          job(this[kDone]);
        }
      }
    };
    module2.exports = Limiter;
  }
});

// node_modules/ws/lib/permessage-deflate.js
var require_permessage_deflate = __commonJS({
  "node_modules/ws/lib/permessage-deflate.js"(exports2, module2) {
    "use strict";
    var zlib = require("zlib");
    var bufferUtil = require_buffer_util();
    var Limiter = require_limiter();
    var { kStatusCode } = require_constants();
    var TRAILER = Buffer.from([0, 0, 255, 255]);
    var kPerMessageDeflate = Symbol("permessage-deflate");
    var kTotalLength = Symbol("total-length");
    var kCallback = Symbol("callback");
    var kBuffers = Symbol("buffers");
    var kError = Symbol("error");
    var zlibLimiter;
    var PerMessageDeflate = class {
      /**
       * Creates a PerMessageDeflate instance.
       *
       * @param {Object} [options] Configuration options
       * @param {(Boolean|Number)} [options.clientMaxWindowBits] Advertise support
       *     for, or request, a custom client window size
       * @param {Boolean} [options.clientNoContextTakeover=false] Advertise/
       *     acknowledge disabling of client context takeover
       * @param {Number} [options.concurrencyLimit=10] The number of concurrent
       *     calls to zlib
       * @param {(Boolean|Number)} [options.serverMaxWindowBits] Request/confirm the
       *     use of a custom server window size
       * @param {Boolean} [options.serverNoContextTakeover=false] Request/accept
       *     disabling of server context takeover
       * @param {Number} [options.threshold=1024] Size (in bytes) below which
       *     messages should not be compressed if context takeover is disabled
       * @param {Object} [options.zlibDeflateOptions] Options to pass to zlib on
       *     deflate
       * @param {Object} [options.zlibInflateOptions] Options to pass to zlib on
       *     inflate
       * @param {Boolean} [isServer=false] Create the instance in either server or
       *     client mode
       * @param {Number} [maxPayload=0] The maximum allowed message length
       */
      constructor(options, isServer, maxPayload) {
        this._maxPayload = maxPayload | 0;
        this._options = options || {};
        this._threshold = this._options.threshold !== void 0 ? this._options.threshold : 1024;
        this._isServer = !!isServer;
        this._deflate = null;
        this._inflate = null;
        this.params = null;
        if (!zlibLimiter) {
          const concurrency = this._options.concurrencyLimit !== void 0 ? this._options.concurrencyLimit : 10;
          zlibLimiter = new Limiter(concurrency);
        }
      }
      /**
       * @type {String}
       */
      static get extensionName() {
        return "permessage-deflate";
      }
      /**
       * Create an extension negotiation offer.
       *
       * @return {Object} Extension parameters
       * @public
       */
      offer() {
        const params = {};
        if (this._options.serverNoContextTakeover) {
          params.server_no_context_takeover = true;
        }
        if (this._options.clientNoContextTakeover) {
          params.client_no_context_takeover = true;
        }
        if (this._options.serverMaxWindowBits) {
          params.server_max_window_bits = this._options.serverMaxWindowBits;
        }
        if (this._options.clientMaxWindowBits) {
          params.client_max_window_bits = this._options.clientMaxWindowBits;
        } else if (this._options.clientMaxWindowBits == null) {
          params.client_max_window_bits = true;
        }
        return params;
      }
      /**
       * Accept an extension negotiation offer/response.
       *
       * @param {Array} configurations The extension negotiation offers/reponse
       * @return {Object} Accepted configuration
       * @public
       */
      accept(configurations) {
        configurations = this.normalizeParams(configurations);
        this.params = this._isServer ? this.acceptAsServer(configurations) : this.acceptAsClient(configurations);
        return this.params;
      }
      /**
       * Releases all resources used by the extension.
       *
       * @public
       */
      cleanup() {
        if (this._inflate) {
          this._inflate.close();
          this._inflate = null;
        }
        if (this._deflate) {
          const callback = this._deflate[kCallback];
          this._deflate.close();
          this._deflate = null;
          if (callback) {
            callback(
              new Error(
                "The deflate stream was closed while data was being processed"
              )
            );
          }
        }
      }
      /**
       *  Accept an extension negotiation offer.
       *
       * @param {Array} offers The extension negotiation offers
       * @return {Object} Accepted configuration
       * @private
       */
      acceptAsServer(offers) {
        const opts = this._options;
        const accepted = offers.find((params) => {
          if (opts.serverNoContextTakeover === false && params.server_no_context_takeover || params.server_max_window_bits && (opts.serverMaxWindowBits === false || typeof opts.serverMaxWindowBits === "number" && opts.serverMaxWindowBits > params.server_max_window_bits) || typeof opts.clientMaxWindowBits === "number" && !params.client_max_window_bits) {
            return false;
          }
          return true;
        });
        if (!accepted) {
          throw new Error("None of the extension offers can be accepted");
        }
        if (opts.serverNoContextTakeover) {
          accepted.server_no_context_takeover = true;
        }
        if (opts.clientNoContextTakeover) {
          accepted.client_no_context_takeover = true;
        }
        if (typeof opts.serverMaxWindowBits === "number") {
          accepted.server_max_window_bits = opts.serverMaxWindowBits;
        }
        if (typeof opts.clientMaxWindowBits === "number") {
          accepted.client_max_window_bits = opts.clientMaxWindowBits;
        } else if (accepted.client_max_window_bits === true || opts.clientMaxWindowBits === false) {
          delete accepted.client_max_window_bits;
        }
        return accepted;
      }
      /**
       * Accept the extension negotiation response.
       *
       * @param {Array} response The extension negotiation response
       * @return {Object} Accepted configuration
       * @private
       */
      acceptAsClient(response) {
        const params = response[0];
        if (this._options.clientNoContextTakeover === false && params.client_no_context_takeover) {
          throw new Error('Unexpected parameter "client_no_context_takeover"');
        }
        if (!params.client_max_window_bits) {
          if (typeof this._options.clientMaxWindowBits === "number") {
            params.client_max_window_bits = this._options.clientMaxWindowBits;
          }
        } else if (this._options.clientMaxWindowBits === false || typeof this._options.clientMaxWindowBits === "number" && params.client_max_window_bits > this._options.clientMaxWindowBits) {
          throw new Error(
            'Unexpected or invalid parameter "client_max_window_bits"'
          );
        }
        return params;
      }
      /**
       * Normalize parameters.
       *
       * @param {Array} configurations The extension negotiation offers/reponse
       * @return {Array} The offers/response with normalized parameters
       * @private
       */
      normalizeParams(configurations) {
        configurations.forEach((params) => {
          Object.keys(params).forEach((key) => {
            let value = params[key];
            if (value.length > 1) {
              throw new Error(`Parameter "${key}" must have only a single value`);
            }
            value = value[0];
            if (key === "client_max_window_bits") {
              if (value !== true) {
                const num = +value;
                if (!Number.isInteger(num) || num < 8 || num > 15) {
                  throw new TypeError(
                    `Invalid value for parameter "${key}": ${value}`
                  );
                }
                value = num;
              } else if (!this._isServer) {
                throw new TypeError(
                  `Invalid value for parameter "${key}": ${value}`
                );
              }
            } else if (key === "server_max_window_bits") {
              const num = +value;
              if (!Number.isInteger(num) || num < 8 || num > 15) {
                throw new TypeError(
                  `Invalid value for parameter "${key}": ${value}`
                );
              }
              value = num;
            } else if (key === "client_no_context_takeover" || key === "server_no_context_takeover") {
              if (value !== true) {
                throw new TypeError(
                  `Invalid value for parameter "${key}": ${value}`
                );
              }
            } else {
              throw new Error(`Unknown parameter "${key}"`);
            }
            params[key] = value;
          });
        });
        return configurations;
      }
      /**
       * Decompress data. Concurrency limited.
       *
       * @param {Buffer} data Compressed data
       * @param {Boolean} fin Specifies whether or not this is the last fragment
       * @param {Function} callback Callback
       * @public
       */
      decompress(data, fin, callback) {
        zlibLimiter.add((done) => {
          this._decompress(data, fin, (err, result2) => {
            done();
            callback(err, result2);
          });
        });
      }
      /**
       * Compress data. Concurrency limited.
       *
       * @param {(Buffer|String)} data Data to compress
       * @param {Boolean} fin Specifies whether or not this is the last fragment
       * @param {Function} callback Callback
       * @public
       */
      compress(data, fin, callback) {
        zlibLimiter.add((done) => {
          this._compress(data, fin, (err, result2) => {
            done();
            callback(err, result2);
          });
        });
      }
      /**
       * Decompress data.
       *
       * @param {Buffer} data Compressed data
       * @param {Boolean} fin Specifies whether or not this is the last fragment
       * @param {Function} callback Callback
       * @private
       */
      _decompress(data, fin, callback) {
        const endpoint = this._isServer ? "client" : "server";
        if (!this._inflate) {
          const key = `${endpoint}_max_window_bits`;
          const windowBits = typeof this.params[key] !== "number" ? zlib.Z_DEFAULT_WINDOWBITS : this.params[key];
          this._inflate = zlib.createInflateRaw({
            ...this._options.zlibInflateOptions,
            windowBits
          });
          this._inflate[kPerMessageDeflate] = this;
          this._inflate[kTotalLength] = 0;
          this._inflate[kBuffers] = [];
          this._inflate.on("error", inflateOnError);
          this._inflate.on("data", inflateOnData);
        }
        this._inflate[kCallback] = callback;
        this._inflate.write(data);
        if (fin)
          this._inflate.write(TRAILER);
        this._inflate.flush(() => {
          const err = this._inflate[kError];
          if (err) {
            this._inflate.close();
            this._inflate = null;
            callback(err);
            return;
          }
          const data2 = bufferUtil.concat(
            this._inflate[kBuffers],
            this._inflate[kTotalLength]
          );
          if (this._inflate._readableState.endEmitted) {
            this._inflate.close();
            this._inflate = null;
          } else {
            this._inflate[kTotalLength] = 0;
            this._inflate[kBuffers] = [];
            if (fin && this.params[`${endpoint}_no_context_takeover`]) {
              this._inflate.reset();
            }
          }
          callback(null, data2);
        });
      }
      /**
       * Compress data.
       *
       * @param {(Buffer|String)} data Data to compress
       * @param {Boolean} fin Specifies whether or not this is the last fragment
       * @param {Function} callback Callback
       * @private
       */
      _compress(data, fin, callback) {
        const endpoint = this._isServer ? "server" : "client";
        if (!this._deflate) {
          const key = `${endpoint}_max_window_bits`;
          const windowBits = typeof this.params[key] !== "number" ? zlib.Z_DEFAULT_WINDOWBITS : this.params[key];
          this._deflate = zlib.createDeflateRaw({
            ...this._options.zlibDeflateOptions,
            windowBits
          });
          this._deflate[kTotalLength] = 0;
          this._deflate[kBuffers] = [];
          this._deflate.on("data", deflateOnData);
        }
        this._deflate[kCallback] = callback;
        this._deflate.write(data);
        this._deflate.flush(zlib.Z_SYNC_FLUSH, () => {
          if (!this._deflate) {
            return;
          }
          let data2 = bufferUtil.concat(
            this._deflate[kBuffers],
            this._deflate[kTotalLength]
          );
          if (fin)
            data2 = data2.slice(0, data2.length - 4);
          this._deflate[kCallback] = null;
          this._deflate[kTotalLength] = 0;
          this._deflate[kBuffers] = [];
          if (fin && this.params[`${endpoint}_no_context_takeover`]) {
            this._deflate.reset();
          }
          callback(null, data2);
        });
      }
    };
    module2.exports = PerMessageDeflate;
    function deflateOnData(chunk) {
      this[kBuffers].push(chunk);
      this[kTotalLength] += chunk.length;
    }
    function inflateOnData(chunk) {
      this[kTotalLength] += chunk.length;
      if (this[kPerMessageDeflate]._maxPayload < 1 || this[kTotalLength] <= this[kPerMessageDeflate]._maxPayload) {
        this[kBuffers].push(chunk);
        return;
      }
      this[kError] = new RangeError("Max payload size exceeded");
      this[kError].code = "WS_ERR_UNSUPPORTED_MESSAGE_LENGTH";
      this[kError][kStatusCode] = 1009;
      this.removeListener("data", inflateOnData);
      this.reset();
    }
    function inflateOnError(err) {
      this[kPerMessageDeflate]._inflate = null;
      err[kStatusCode] = 1007;
      this[kCallback](err);
    }
  }
});

// node_modules/ws/lib/validation.js
var require_validation = __commonJS({
  "node_modules/ws/lib/validation.js"(exports2, module2) {
    "use strict";
    var tokenChars = [
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      // 0 - 15
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      // 16 - 31
      0,
      1,
      0,
      1,
      1,
      1,
      1,
      1,
      0,
      0,
      1,
      1,
      0,
      1,
      1,
      0,
      // 32 - 47
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      0,
      0,
      0,
      0,
      0,
      0,
      // 48 - 63
      0,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      // 64 - 79
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      0,
      0,
      0,
      1,
      1,
      // 80 - 95
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      // 96 - 111
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      0,
      1,
      0,
      1,
      0
      // 112 - 127
    ];
    function isValidStatusCode(code) {
      return code >= 1e3 && code <= 1014 && code !== 1004 && code !== 1005 && code !== 1006 || code >= 3e3 && code <= 4999;
    }
    function _isValidUTF8(buf) {
      const len = buf.length;
      let i = 0;
      while (i < len) {
        if ((buf[i] & 128) === 0) {
          i++;
        } else if ((buf[i] & 224) === 192) {
          if (i + 1 === len || (buf[i + 1] & 192) !== 128 || (buf[i] & 254) === 192) {
            return false;
          }
          i += 2;
        } else if ((buf[i] & 240) === 224) {
          if (i + 2 >= len || (buf[i + 1] & 192) !== 128 || (buf[i + 2] & 192) !== 128 || buf[i] === 224 && (buf[i + 1] & 224) === 128 || // Overlong
          buf[i] === 237 && (buf[i + 1] & 224) === 160) {
            return false;
          }
          i += 3;
        } else if ((buf[i] & 248) === 240) {
          if (i + 3 >= len || (buf[i + 1] & 192) !== 128 || (buf[i + 2] & 192) !== 128 || (buf[i + 3] & 192) !== 128 || buf[i] === 240 && (buf[i + 1] & 240) === 128 || // Overlong
          buf[i] === 244 && buf[i + 1] > 143 || buf[i] > 244) {
            return false;
          }
          i += 4;
        } else {
          return false;
        }
      }
      return true;
    }
    try {
      const isValidUTF8 = require("utf-8-validate");
      module2.exports = {
        isValidStatusCode,
        isValidUTF8(buf) {
          return buf.length < 150 ? _isValidUTF8(buf) : isValidUTF8(buf);
        },
        tokenChars
      };
    } catch (e) {
      module2.exports = {
        isValidStatusCode,
        isValidUTF8: _isValidUTF8,
        tokenChars
      };
    }
  }
});

// node_modules/ws/lib/receiver.js
var require_receiver = __commonJS({
  "node_modules/ws/lib/receiver.js"(exports2, module2) {
    "use strict";
    var { Writable } = require("stream");
    var PerMessageDeflate = require_permessage_deflate();
    var {
      BINARY_TYPES,
      EMPTY_BUFFER,
      kStatusCode,
      kWebSocket
    } = require_constants();
    var { concat, toArrayBuffer, unmask } = require_buffer_util();
    var { isValidStatusCode, isValidUTF8 } = require_validation();
    var GET_INFO = 0;
    var GET_PAYLOAD_LENGTH_16 = 1;
    var GET_PAYLOAD_LENGTH_64 = 2;
    var GET_MASK = 3;
    var GET_DATA = 4;
    var INFLATING = 5;
    var Receiver2 = class extends Writable {
      /**
       * Creates a Receiver instance.
       *
       * @param {Object} [options] Options object
       * @param {String} [options.binaryType=nodebuffer] The type for binary data
       * @param {Object} [options.extensions] An object containing the negotiated
       *     extensions
       * @param {Boolean} [options.isServer=false] Specifies whether to operate in
       *     client or server mode
       * @param {Number} [options.maxPayload=0] The maximum allowed message length
       * @param {Boolean} [options.skipUTF8Validation=false] Specifies whether or
       *     not to skip UTF-8 validation for text and close messages
       */
      constructor(options = {}) {
        super();
        this._binaryType = options.binaryType || BINARY_TYPES[0];
        this._extensions = options.extensions || {};
        this._isServer = !!options.isServer;
        this._maxPayload = options.maxPayload | 0;
        this._skipUTF8Validation = !!options.skipUTF8Validation;
        this[kWebSocket] = void 0;
        this._bufferedBytes = 0;
        this._buffers = [];
        this._compressed = false;
        this._payloadLength = 0;
        this._mask = void 0;
        this._fragmented = 0;
        this._masked = false;
        this._fin = false;
        this._opcode = 0;
        this._totalPayloadLength = 0;
        this._messageLength = 0;
        this._fragments = [];
        this._state = GET_INFO;
        this._loop = false;
      }
      /**
       * Implements `Writable.prototype._write()`.
       *
       * @param {Buffer} chunk The chunk of data to write
       * @param {String} encoding The character encoding of `chunk`
       * @param {Function} cb Callback
       * @private
       */
      _write(chunk, encoding, cb) {
        if (this._opcode === 8 && this._state == GET_INFO)
          return cb();
        this._bufferedBytes += chunk.length;
        this._buffers.push(chunk);
        this.startLoop(cb);
      }
      /**
       * Consumes `n` bytes from the buffered data.
       *
       * @param {Number} n The number of bytes to consume
       * @return {Buffer} The consumed bytes
       * @private
       */
      consume(n) {
        this._bufferedBytes -= n;
        if (n === this._buffers[0].length)
          return this._buffers.shift();
        if (n < this._buffers[0].length) {
          const buf = this._buffers[0];
          this._buffers[0] = buf.slice(n);
          return buf.slice(0, n);
        }
        const dst = Buffer.allocUnsafe(n);
        do {
          const buf = this._buffers[0];
          const offset = dst.length - n;
          if (n >= buf.length) {
            dst.set(this._buffers.shift(), offset);
          } else {
            dst.set(new Uint8Array(buf.buffer, buf.byteOffset, n), offset);
            this._buffers[0] = buf.slice(n);
          }
          n -= buf.length;
        } while (n > 0);
        return dst;
      }
      /**
       * Starts the parsing loop.
       *
       * @param {Function} cb Callback
       * @private
       */
      startLoop(cb) {
        let err;
        this._loop = true;
        do {
          switch (this._state) {
            case GET_INFO:
              err = this.getInfo();
              break;
            case GET_PAYLOAD_LENGTH_16:
              err = this.getPayloadLength16();
              break;
            case GET_PAYLOAD_LENGTH_64:
              err = this.getPayloadLength64();
              break;
            case GET_MASK:
              this.getMask();
              break;
            case GET_DATA:
              err = this.getData(cb);
              break;
            default:
              this._loop = false;
              return;
          }
        } while (this._loop);
        cb(err);
      }
      /**
       * Reads the first two bytes of a frame.
       *
       * @return {(RangeError|undefined)} A possible error
       * @private
       */
      getInfo() {
        if (this._bufferedBytes < 2) {
          this._loop = false;
          return;
        }
        const buf = this.consume(2);
        if ((buf[0] & 48) !== 0) {
          this._loop = false;
          return error(
            RangeError,
            "RSV2 and RSV3 must be clear",
            true,
            1002,
            "WS_ERR_UNEXPECTED_RSV_2_3"
          );
        }
        const compressed = (buf[0] & 64) === 64;
        if (compressed && !this._extensions[PerMessageDeflate.extensionName]) {
          this._loop = false;
          return error(
            RangeError,
            "RSV1 must be clear",
            true,
            1002,
            "WS_ERR_UNEXPECTED_RSV_1"
          );
        }
        this._fin = (buf[0] & 128) === 128;
        this._opcode = buf[0] & 15;
        this._payloadLength = buf[1] & 127;
        if (this._opcode === 0) {
          if (compressed) {
            this._loop = false;
            return error(
              RangeError,
              "RSV1 must be clear",
              true,
              1002,
              "WS_ERR_UNEXPECTED_RSV_1"
            );
          }
          if (!this._fragmented) {
            this._loop = false;
            return error(
              RangeError,
              "invalid opcode 0",
              true,
              1002,
              "WS_ERR_INVALID_OPCODE"
            );
          }
          this._opcode = this._fragmented;
        } else if (this._opcode === 1 || this._opcode === 2) {
          if (this._fragmented) {
            this._loop = false;
            return error(
              RangeError,
              `invalid opcode ${this._opcode}`,
              true,
              1002,
              "WS_ERR_INVALID_OPCODE"
            );
          }
          this._compressed = compressed;
        } else if (this._opcode > 7 && this._opcode < 11) {
          if (!this._fin) {
            this._loop = false;
            return error(
              RangeError,
              "FIN must be set",
              true,
              1002,
              "WS_ERR_EXPECTED_FIN"
            );
          }
          if (compressed) {
            this._loop = false;
            return error(
              RangeError,
              "RSV1 must be clear",
              true,
              1002,
              "WS_ERR_UNEXPECTED_RSV_1"
            );
          }
          if (this._payloadLength > 125) {
            this._loop = false;
            return error(
              RangeError,
              `invalid payload length ${this._payloadLength}`,
              true,
              1002,
              "WS_ERR_INVALID_CONTROL_PAYLOAD_LENGTH"
            );
          }
        } else {
          this._loop = false;
          return error(
            RangeError,
            `invalid opcode ${this._opcode}`,
            true,
            1002,
            "WS_ERR_INVALID_OPCODE"
          );
        }
        if (!this._fin && !this._fragmented)
          this._fragmented = this._opcode;
        this._masked = (buf[1] & 128) === 128;
        if (this._isServer) {
          if (!this._masked) {
            this._loop = false;
            return error(
              RangeError,
              "MASK must be set",
              true,
              1002,
              "WS_ERR_EXPECTED_MASK"
            );
          }
        } else if (this._masked) {
          this._loop = false;
          return error(
            RangeError,
            "MASK must be clear",
            true,
            1002,
            "WS_ERR_UNEXPECTED_MASK"
          );
        }
        if (this._payloadLength === 126)
          this._state = GET_PAYLOAD_LENGTH_16;
        else if (this._payloadLength === 127)
          this._state = GET_PAYLOAD_LENGTH_64;
        else
          return this.haveLength();
      }
      /**
       * Gets extended payload length (7+16).
       *
       * @return {(RangeError|undefined)} A possible error
       * @private
       */
      getPayloadLength16() {
        if (this._bufferedBytes < 2) {
          this._loop = false;
          return;
        }
        this._payloadLength = this.consume(2).readUInt16BE(0);
        return this.haveLength();
      }
      /**
       * Gets extended payload length (7+64).
       *
       * @return {(RangeError|undefined)} A possible error
       * @private
       */
      getPayloadLength64() {
        if (this._bufferedBytes < 8) {
          this._loop = false;
          return;
        }
        const buf = this.consume(8);
        const num = buf.readUInt32BE(0);
        if (num > Math.pow(2, 53 - 32) - 1) {
          this._loop = false;
          return error(
            RangeError,
            "Unsupported WebSocket frame: payload length > 2^53 - 1",
            false,
            1009,
            "WS_ERR_UNSUPPORTED_DATA_PAYLOAD_LENGTH"
          );
        }
        this._payloadLength = num * Math.pow(2, 32) + buf.readUInt32BE(4);
        return this.haveLength();
      }
      /**
       * Payload length has been read.
       *
       * @return {(RangeError|undefined)} A possible error
       * @private
       */
      haveLength() {
        if (this._payloadLength && this._opcode < 8) {
          this._totalPayloadLength += this._payloadLength;
          if (this._totalPayloadLength > this._maxPayload && this._maxPayload > 0) {
            this._loop = false;
            return error(
              RangeError,
              "Max payload size exceeded",
              false,
              1009,
              "WS_ERR_UNSUPPORTED_MESSAGE_LENGTH"
            );
          }
        }
        if (this._masked)
          this._state = GET_MASK;
        else
          this._state = GET_DATA;
      }
      /**
       * Reads mask bytes.
       *
       * @private
       */
      getMask() {
        if (this._bufferedBytes < 4) {
          this._loop = false;
          return;
        }
        this._mask = this.consume(4);
        this._state = GET_DATA;
      }
      /**
       * Reads data bytes.
       *
       * @param {Function} cb Callback
       * @return {(Error|RangeError|undefined)} A possible error
       * @private
       */
      getData(cb) {
        let data = EMPTY_BUFFER;
        if (this._payloadLength) {
          if (this._bufferedBytes < this._payloadLength) {
            this._loop = false;
            return;
          }
          data = this.consume(this._payloadLength);
          if (this._masked && (this._mask[0] | this._mask[1] | this._mask[2] | this._mask[3]) !== 0) {
            unmask(data, this._mask);
          }
        }
        if (this._opcode > 7)
          return this.controlMessage(data);
        if (this._compressed) {
          this._state = INFLATING;
          this.decompress(data, cb);
          return;
        }
        if (data.length) {
          this._messageLength = this._totalPayloadLength;
          this._fragments.push(data);
        }
        return this.dataMessage();
      }
      /**
       * Decompresses data.
       *
       * @param {Buffer} data Compressed data
       * @param {Function} cb Callback
       * @private
       */
      decompress(data, cb) {
        const perMessageDeflate = this._extensions[PerMessageDeflate.extensionName];
        perMessageDeflate.decompress(data, this._fin, (err, buf) => {
          if (err)
            return cb(err);
          if (buf.length) {
            this._messageLength += buf.length;
            if (this._messageLength > this._maxPayload && this._maxPayload > 0) {
              return cb(
                error(
                  RangeError,
                  "Max payload size exceeded",
                  false,
                  1009,
                  "WS_ERR_UNSUPPORTED_MESSAGE_LENGTH"
                )
              );
            }
            this._fragments.push(buf);
          }
          const er = this.dataMessage();
          if (er)
            return cb(er);
          this.startLoop(cb);
        });
      }
      /**
       * Handles a data message.
       *
       * @return {(Error|undefined)} A possible error
       * @private
       */
      dataMessage() {
        if (this._fin) {
          const messageLength = this._messageLength;
          const fragments = this._fragments;
          this._totalPayloadLength = 0;
          this._messageLength = 0;
          this._fragmented = 0;
          this._fragments = [];
          if (this._opcode === 2) {
            let data;
            if (this._binaryType === "nodebuffer") {
              data = concat(fragments, messageLength);
            } else if (this._binaryType === "arraybuffer") {
              data = toArrayBuffer(concat(fragments, messageLength));
            } else {
              data = fragments;
            }
            this.emit("message", data, true);
          } else {
            const buf = concat(fragments, messageLength);
            if (!this._skipUTF8Validation && !isValidUTF8(buf)) {
              this._loop = false;
              return error(
                Error,
                "invalid UTF-8 sequence",
                true,
                1007,
                "WS_ERR_INVALID_UTF8"
              );
            }
            this.emit("message", buf, false);
          }
        }
        this._state = GET_INFO;
      }
      /**
       * Handles a control message.
       *
       * @param {Buffer} data Data to handle
       * @return {(Error|RangeError|undefined)} A possible error
       * @private
       */
      controlMessage(data) {
        if (this._opcode === 8) {
          this._loop = false;
          if (data.length === 0) {
            this.emit("conclude", 1005, EMPTY_BUFFER);
            this.end();
          } else if (data.length === 1) {
            return error(
              RangeError,
              "invalid payload length 1",
              true,
              1002,
              "WS_ERR_INVALID_CONTROL_PAYLOAD_LENGTH"
            );
          } else {
            const code = data.readUInt16BE(0);
            if (!isValidStatusCode(code)) {
              return error(
                RangeError,
                `invalid status code ${code}`,
                true,
                1002,
                "WS_ERR_INVALID_CLOSE_CODE"
              );
            }
            const buf = data.slice(2);
            if (!this._skipUTF8Validation && !isValidUTF8(buf)) {
              return error(
                Error,
                "invalid UTF-8 sequence",
                true,
                1007,
                "WS_ERR_INVALID_UTF8"
              );
            }
            this.emit("conclude", code, buf);
            this.end();
          }
        } else if (this._opcode === 9) {
          this.emit("ping", data);
        } else {
          this.emit("pong", data);
        }
        this._state = GET_INFO;
      }
    };
    module2.exports = Receiver2;
    function error(ErrorCtor, message, prefix, statusCode, errorCode) {
      const err = new ErrorCtor(
        prefix ? `Invalid WebSocket frame: ${message}` : message
      );
      Error.captureStackTrace(err, error);
      err.code = errorCode;
      err[kStatusCode] = statusCode;
      return err;
    }
  }
});

// node_modules/ws/lib/sender.js
var require_sender = __commonJS({
  "node_modules/ws/lib/sender.js"(exports2, module2) {
    "use strict";
    var net = require("net");
    var tls = require("tls");
    var { randomFillSync } = require("crypto");
    var PerMessageDeflate = require_permessage_deflate();
    var { EMPTY_BUFFER } = require_constants();
    var { isValidStatusCode } = require_validation();
    var { mask: applyMask, toBuffer } = require_buffer_util();
    var kByteLength = Symbol("kByteLength");
    var maskBuffer = Buffer.alloc(4);
    var Sender2 = class _Sender {
      /**
       * Creates a Sender instance.
       *
       * @param {(net.Socket|tls.Socket)} socket The connection socket
       * @param {Object} [extensions] An object containing the negotiated extensions
       * @param {Function} [generateMask] The function used to generate the masking
       *     key
       */
      constructor(socket, extensions2, generateMask) {
        this._extensions = extensions2 || {};
        if (generateMask) {
          this._generateMask = generateMask;
          this._maskBuffer = Buffer.alloc(4);
        }
        this._socket = socket;
        this._firstFragment = true;
        this._compress = false;
        this._bufferedBytes = 0;
        this._deflating = false;
        this._queue = [];
      }
      /**
       * Frames a piece of data according to the HyBi WebSocket protocol.
       *
       * @param {(Buffer|String)} data The data to frame
       * @param {Object} options Options object
       * @param {Boolean} [options.fin=false] Specifies whether or not to set the
       *     FIN bit
       * @param {Function} [options.generateMask] The function used to generate the
       *     masking key
       * @param {Boolean} [options.mask=false] Specifies whether or not to mask
       *     `data`
       * @param {Buffer} [options.maskBuffer] The buffer used to store the masking
       *     key
       * @param {Number} options.opcode The opcode
       * @param {Boolean} [options.readOnly=false] Specifies whether `data` can be
       *     modified
       * @param {Boolean} [options.rsv1=false] Specifies whether or not to set the
       *     RSV1 bit
       * @return {(Buffer|String)[]} The framed data
       * @public
       */
      static frame(data, options) {
        let mask;
        let merge = false;
        let offset = 2;
        let skipMasking = false;
        if (options.mask) {
          mask = options.maskBuffer || maskBuffer;
          if (options.generateMask) {
            options.generateMask(mask);
          } else {
            randomFillSync(mask, 0, 4);
          }
          skipMasking = (mask[0] | mask[1] | mask[2] | mask[3]) === 0;
          offset = 6;
        }
        let dataLength;
        if (typeof data === "string") {
          if ((!options.mask || skipMasking) && options[kByteLength] !== void 0) {
            dataLength = options[kByteLength];
          } else {
            data = Buffer.from(data);
            dataLength = data.length;
          }
        } else {
          dataLength = data.length;
          merge = options.mask && options.readOnly && !skipMasking;
        }
        let payloadLength = dataLength;
        if (dataLength >= 65536) {
          offset += 8;
          payloadLength = 127;
        } else if (dataLength > 125) {
          offset += 2;
          payloadLength = 126;
        }
        const target = Buffer.allocUnsafe(merge ? dataLength + offset : offset);
        target[0] = options.fin ? options.opcode | 128 : options.opcode;
        if (options.rsv1)
          target[0] |= 64;
        target[1] = payloadLength;
        if (payloadLength === 126) {
          target.writeUInt16BE(dataLength, 2);
        } else if (payloadLength === 127) {
          target[2] = target[3] = 0;
          target.writeUIntBE(dataLength, 4, 6);
        }
        if (!options.mask)
          return [target, data];
        target[1] |= 128;
        target[offset - 4] = mask[0];
        target[offset - 3] = mask[1];
        target[offset - 2] = mask[2];
        target[offset - 1] = mask[3];
        if (skipMasking)
          return [target, data];
        if (merge) {
          applyMask(data, mask, target, offset, dataLength);
          return [target];
        }
        applyMask(data, mask, data, 0, dataLength);
        return [target, data];
      }
      /**
       * Sends a close message to the other peer.
       *
       * @param {Number} [code] The status code component of the body
       * @param {(String|Buffer)} [data] The message component of the body
       * @param {Boolean} [mask=false] Specifies whether or not to mask the message
       * @param {Function} [cb] Callback
       * @public
       */
      close(code, data, mask, cb) {
        let buf;
        if (code === void 0) {
          buf = EMPTY_BUFFER;
        } else if (typeof code !== "number" || !isValidStatusCode(code)) {
          throw new TypeError("First argument must be a valid error code number");
        } else if (data === void 0 || !data.length) {
          buf = Buffer.allocUnsafe(2);
          buf.writeUInt16BE(code, 0);
        } else {
          const length = Buffer.byteLength(data);
          if (length > 123) {
            throw new RangeError("The message must not be greater than 123 bytes");
          }
          buf = Buffer.allocUnsafe(2 + length);
          buf.writeUInt16BE(code, 0);
          if (typeof data === "string") {
            buf.write(data, 2);
          } else {
            buf.set(data, 2);
          }
        }
        const options = {
          [kByteLength]: buf.length,
          fin: true,
          generateMask: this._generateMask,
          mask,
          maskBuffer: this._maskBuffer,
          opcode: 8,
          readOnly: false,
          rsv1: false
        };
        if (this._deflating) {
          this.enqueue([this.dispatch, buf, false, options, cb]);
        } else {
          this.sendFrame(_Sender.frame(buf, options), cb);
        }
      }
      /**
       * Sends a ping message to the other peer.
       *
       * @param {*} data The message to send
       * @param {Boolean} [mask=false] Specifies whether or not to mask `data`
       * @param {Function} [cb] Callback
       * @public
       */
      ping(data, mask, cb) {
        let byteLength;
        let readOnly;
        if (typeof data === "string") {
          byteLength = Buffer.byteLength(data);
          readOnly = false;
        } else {
          data = toBuffer(data);
          byteLength = data.length;
          readOnly = toBuffer.readOnly;
        }
        if (byteLength > 125) {
          throw new RangeError("The data size must not be greater than 125 bytes");
        }
        const options = {
          [kByteLength]: byteLength,
          fin: true,
          generateMask: this._generateMask,
          mask,
          maskBuffer: this._maskBuffer,
          opcode: 9,
          readOnly,
          rsv1: false
        };
        if (this._deflating) {
          this.enqueue([this.dispatch, data, false, options, cb]);
        } else {
          this.sendFrame(_Sender.frame(data, options), cb);
        }
      }
      /**
       * Sends a pong message to the other peer.
       *
       * @param {*} data The message to send
       * @param {Boolean} [mask=false] Specifies whether or not to mask `data`
       * @param {Function} [cb] Callback
       * @public
       */
      pong(data, mask, cb) {
        let byteLength;
        let readOnly;
        if (typeof data === "string") {
          byteLength = Buffer.byteLength(data);
          readOnly = false;
        } else {
          data = toBuffer(data);
          byteLength = data.length;
          readOnly = toBuffer.readOnly;
        }
        if (byteLength > 125) {
          throw new RangeError("The data size must not be greater than 125 bytes");
        }
        const options = {
          [kByteLength]: byteLength,
          fin: true,
          generateMask: this._generateMask,
          mask,
          maskBuffer: this._maskBuffer,
          opcode: 10,
          readOnly,
          rsv1: false
        };
        if (this._deflating) {
          this.enqueue([this.dispatch, data, false, options, cb]);
        } else {
          this.sendFrame(_Sender.frame(data, options), cb);
        }
      }
      /**
       * Sends a data message to the other peer.
       *
       * @param {*} data The message to send
       * @param {Object} options Options object
       * @param {Boolean} [options.binary=false] Specifies whether `data` is binary
       *     or text
       * @param {Boolean} [options.compress=false] Specifies whether or not to
       *     compress `data`
       * @param {Boolean} [options.fin=false] Specifies whether the fragment is the
       *     last one
       * @param {Boolean} [options.mask=false] Specifies whether or not to mask
       *     `data`
       * @param {Function} [cb] Callback
       * @public
       */
      send(data, options, cb) {
        const perMessageDeflate = this._extensions[PerMessageDeflate.extensionName];
        let opcode = options.binary ? 2 : 1;
        let rsv1 = options.compress;
        let byteLength;
        let readOnly;
        if (typeof data === "string") {
          byteLength = Buffer.byteLength(data);
          readOnly = false;
        } else {
          data = toBuffer(data);
          byteLength = data.length;
          readOnly = toBuffer.readOnly;
        }
        if (this._firstFragment) {
          this._firstFragment = false;
          if (rsv1 && perMessageDeflate && perMessageDeflate.params[perMessageDeflate._isServer ? "server_no_context_takeover" : "client_no_context_takeover"]) {
            rsv1 = byteLength >= perMessageDeflate._threshold;
          }
          this._compress = rsv1;
        } else {
          rsv1 = false;
          opcode = 0;
        }
        if (options.fin)
          this._firstFragment = true;
        if (perMessageDeflate) {
          const opts = {
            [kByteLength]: byteLength,
            fin: options.fin,
            generateMask: this._generateMask,
            mask: options.mask,
            maskBuffer: this._maskBuffer,
            opcode,
            readOnly,
            rsv1
          };
          if (this._deflating) {
            this.enqueue([this.dispatch, data, this._compress, opts, cb]);
          } else {
            this.dispatch(data, this._compress, opts, cb);
          }
        } else {
          this.sendFrame(
            _Sender.frame(data, {
              [kByteLength]: byteLength,
              fin: options.fin,
              generateMask: this._generateMask,
              mask: options.mask,
              maskBuffer: this._maskBuffer,
              opcode,
              readOnly,
              rsv1: false
            }),
            cb
          );
        }
      }
      /**
       * Dispatches a message.
       *
       * @param {(Buffer|String)} data The message to send
       * @param {Boolean} [compress=false] Specifies whether or not to compress
       *     `data`
       * @param {Object} options Options object
       * @param {Boolean} [options.fin=false] Specifies whether or not to set the
       *     FIN bit
       * @param {Function} [options.generateMask] The function used to generate the
       *     masking key
       * @param {Boolean} [options.mask=false] Specifies whether or not to mask
       *     `data`
       * @param {Buffer} [options.maskBuffer] The buffer used to store the masking
       *     key
       * @param {Number} options.opcode The opcode
       * @param {Boolean} [options.readOnly=false] Specifies whether `data` can be
       *     modified
       * @param {Boolean} [options.rsv1=false] Specifies whether or not to set the
       *     RSV1 bit
       * @param {Function} [cb] Callback
       * @private
       */
      dispatch(data, compress, options, cb) {
        if (!compress) {
          this.sendFrame(_Sender.frame(data, options), cb);
          return;
        }
        const perMessageDeflate = this._extensions[PerMessageDeflate.extensionName];
        this._bufferedBytes += options[kByteLength];
        this._deflating = true;
        perMessageDeflate.compress(data, options.fin, (_, buf) => {
          if (this._socket.destroyed) {
            const err = new Error(
              "The socket was closed while data was being compressed"
            );
            if (typeof cb === "function")
              cb(err);
            for (let i = 0; i < this._queue.length; i++) {
              const params = this._queue[i];
              const callback = params[params.length - 1];
              if (typeof callback === "function")
                callback(err);
            }
            return;
          }
          this._bufferedBytes -= options[kByteLength];
          this._deflating = false;
          options.readOnly = false;
          this.sendFrame(_Sender.frame(buf, options), cb);
          this.dequeue();
        });
      }
      /**
       * Executes queued send operations.
       *
       * @private
       */
      dequeue() {
        while (!this._deflating && this._queue.length) {
          const params = this._queue.shift();
          this._bufferedBytes -= params[3][kByteLength];
          Reflect.apply(params[0], this, params.slice(1));
        }
      }
      /**
       * Enqueues a send operation.
       *
       * @param {Array} params Send operation parameters.
       * @private
       */
      enqueue(params) {
        this._bufferedBytes += params[3][kByteLength];
        this._queue.push(params);
      }
      /**
       * Sends a frame.
       *
       * @param {Buffer[]} list The frame to send
       * @param {Function} [cb] Callback
       * @private
       */
      sendFrame(list, cb) {
        if (list.length === 2) {
          this._socket.cork();
          this._socket.write(list[0]);
          this._socket.write(list[1], cb);
          this._socket.uncork();
        } else {
          this._socket.write(list[0], cb);
        }
      }
    };
    module2.exports = Sender2;
  }
});

// node_modules/ws/lib/event-target.js
var require_event_target = __commonJS({
  "node_modules/ws/lib/event-target.js"(exports2, module2) {
    "use strict";
    var { kForOnEventAttribute, kListener } = require_constants();
    var kCode = Symbol("kCode");
    var kData = Symbol("kData");
    var kError = Symbol("kError");
    var kMessage = Symbol("kMessage");
    var kReason = Symbol("kReason");
    var kTarget = Symbol("kTarget");
    var kType = Symbol("kType");
    var kWasClean = Symbol("kWasClean");
    var Event = class {
      /**
       * Create a new `Event`.
       *
       * @param {String} type The name of the event
       * @throws {TypeError} If the `type` argument is not specified
       */
      constructor(type) {
        this[kTarget] = null;
        this[kType] = type;
      }
      /**
       * @type {*}
       */
      get target() {
        return this[kTarget];
      }
      /**
       * @type {String}
       */
      get type() {
        return this[kType];
      }
    };
    Object.defineProperty(Event.prototype, "target", { enumerable: true });
    Object.defineProperty(Event.prototype, "type", { enumerable: true });
    var CloseEvent = class extends Event {
      /**
       * Create a new `CloseEvent`.
       *
       * @param {String} type The name of the event
       * @param {Object} [options] A dictionary object that allows for setting
       *     attributes via object members of the same name
       * @param {Number} [options.code=0] The status code explaining why the
       *     connection was closed
       * @param {String} [options.reason=''] A human-readable string explaining why
       *     the connection was closed
       * @param {Boolean} [options.wasClean=false] Indicates whether or not the
       *     connection was cleanly closed
       */
      constructor(type, options = {}) {
        super(type);
        this[kCode] = options.code === void 0 ? 0 : options.code;
        this[kReason] = options.reason === void 0 ? "" : options.reason;
        this[kWasClean] = options.wasClean === void 0 ? false : options.wasClean;
      }
      /**
       * @type {Number}
       */
      get code() {
        return this[kCode];
      }
      /**
       * @type {String}
       */
      get reason() {
        return this[kReason];
      }
      /**
       * @type {Boolean}
       */
      get wasClean() {
        return this[kWasClean];
      }
    };
    Object.defineProperty(CloseEvent.prototype, "code", { enumerable: true });
    Object.defineProperty(CloseEvent.prototype, "reason", { enumerable: true });
    Object.defineProperty(CloseEvent.prototype, "wasClean", { enumerable: true });
    var ErrorEvent = class extends Event {
      /**
       * Create a new `ErrorEvent`.
       *
       * @param {String} type The name of the event
       * @param {Object} [options] A dictionary object that allows for setting
       *     attributes via object members of the same name
       * @param {*} [options.error=null] The error that generated this event
       * @param {String} [options.message=''] The error message
       */
      constructor(type, options = {}) {
        super(type);
        this[kError] = options.error === void 0 ? null : options.error;
        this[kMessage] = options.message === void 0 ? "" : options.message;
      }
      /**
       * @type {*}
       */
      get error() {
        return this[kError];
      }
      /**
       * @type {String}
       */
      get message() {
        return this[kMessage];
      }
    };
    Object.defineProperty(ErrorEvent.prototype, "error", { enumerable: true });
    Object.defineProperty(ErrorEvent.prototype, "message", { enumerable: true });
    var MessageEvent = class extends Event {
      /**
       * Create a new `MessageEvent`.
       *
       * @param {String} type The name of the event
       * @param {Object} [options] A dictionary object that allows for setting
       *     attributes via object members of the same name
       * @param {*} [options.data=null] The message content
       */
      constructor(type, options = {}) {
        super(type);
        this[kData] = options.data === void 0 ? null : options.data;
      }
      /**
       * @type {*}
       */
      get data() {
        return this[kData];
      }
    };
    Object.defineProperty(MessageEvent.prototype, "data", { enumerable: true });
    var EventTarget = {
      /**
       * Register an event listener.
       *
       * @param {String} type A string representing the event type to listen for
       * @param {Function} listener The listener to add
       * @param {Object} [options] An options object specifies characteristics about
       *     the event listener
       * @param {Boolean} [options.once=false] A `Boolean` indicating that the
       *     listener should be invoked at most once after being added. If `true`,
       *     the listener would be automatically removed when invoked.
       * @public
       */
      addEventListener(type, listener, options = {}) {
        let wrapper;
        if (type === "message") {
          wrapper = function onMessage(data, isBinary) {
            const event = new MessageEvent("message", {
              data: isBinary ? data : data.toString()
            });
            event[kTarget] = this;
            listener.call(this, event);
          };
        } else if (type === "close") {
          wrapper = function onClose(code, message) {
            const event = new CloseEvent("close", {
              code,
              reason: message.toString(),
              wasClean: this._closeFrameReceived && this._closeFrameSent
            });
            event[kTarget] = this;
            listener.call(this, event);
          };
        } else if (type === "error") {
          wrapper = function onError(error) {
            const event = new ErrorEvent("error", {
              error,
              message: error.message
            });
            event[kTarget] = this;
            listener.call(this, event);
          };
        } else if (type === "open") {
          wrapper = function onOpen() {
            const event = new Event("open");
            event[kTarget] = this;
            listener.call(this, event);
          };
        } else {
          return;
        }
        wrapper[kForOnEventAttribute] = !!options[kForOnEventAttribute];
        wrapper[kListener] = listener;
        if (options.once) {
          this.once(type, wrapper);
        } else {
          this.on(type, wrapper);
        }
      },
      /**
       * Remove an event listener.
       *
       * @param {String} type A string representing the event type to remove
       * @param {Function} handler The listener to remove
       * @public
       */
      removeEventListener(type, handler) {
        for (const listener of this.listeners(type)) {
          if (listener[kListener] === handler && !listener[kForOnEventAttribute]) {
            this.removeListener(type, listener);
            break;
          }
        }
      }
    };
    module2.exports = {
      CloseEvent,
      ErrorEvent,
      Event,
      EventTarget,
      MessageEvent
    };
  }
});

// node_modules/ws/lib/extension.js
var require_extension = __commonJS({
  "node_modules/ws/lib/extension.js"(exports2, module2) {
    "use strict";
    var { tokenChars } = require_validation();
    function push(dest, name, elem) {
      if (dest[name] === void 0)
        dest[name] = [elem];
      else
        dest[name].push(elem);
    }
    function parse6(header) {
      const offers = /* @__PURE__ */ Object.create(null);
      let params = /* @__PURE__ */ Object.create(null);
      let mustUnescape = false;
      let isEscaping = false;
      let inQuotes = false;
      let extensionName;
      let paramName;
      let start = -1;
      let code = -1;
      let end = -1;
      let i = 0;
      for (; i < header.length; i++) {
        code = header.charCodeAt(i);
        if (extensionName === void 0) {
          if (end === -1 && tokenChars[code] === 1) {
            if (start === -1)
              start = i;
          } else if (i !== 0 && (code === 32 || code === 9)) {
            if (end === -1 && start !== -1)
              end = i;
          } else if (code === 59 || code === 44) {
            if (start === -1) {
              throw new SyntaxError(`Unexpected character at index ${i}`);
            }
            if (end === -1)
              end = i;
            const name = header.slice(start, end);
            if (code === 44) {
              push(offers, name, params);
              params = /* @__PURE__ */ Object.create(null);
            } else {
              extensionName = name;
            }
            start = end = -1;
          } else {
            throw new SyntaxError(`Unexpected character at index ${i}`);
          }
        } else if (paramName === void 0) {
          if (end === -1 && tokenChars[code] === 1) {
            if (start === -1)
              start = i;
          } else if (code === 32 || code === 9) {
            if (end === -1 && start !== -1)
              end = i;
          } else if (code === 59 || code === 44) {
            if (start === -1) {
              throw new SyntaxError(`Unexpected character at index ${i}`);
            }
            if (end === -1)
              end = i;
            push(params, header.slice(start, end), true);
            if (code === 44) {
              push(offers, extensionName, params);
              params = /* @__PURE__ */ Object.create(null);
              extensionName = void 0;
            }
            start = end = -1;
          } else if (code === 61 && start !== -1 && end === -1) {
            paramName = header.slice(start, i);
            start = end = -1;
          } else {
            throw new SyntaxError(`Unexpected character at index ${i}`);
          }
        } else {
          if (isEscaping) {
            if (tokenChars[code] !== 1) {
              throw new SyntaxError(`Unexpected character at index ${i}`);
            }
            if (start === -1)
              start = i;
            else if (!mustUnescape)
              mustUnescape = true;
            isEscaping = false;
          } else if (inQuotes) {
            if (tokenChars[code] === 1) {
              if (start === -1)
                start = i;
            } else if (code === 34 && start !== -1) {
              inQuotes = false;
              end = i;
            } else if (code === 92) {
              isEscaping = true;
            } else {
              throw new SyntaxError(`Unexpected character at index ${i}`);
            }
          } else if (code === 34 && header.charCodeAt(i - 1) === 61) {
            inQuotes = true;
          } else if (end === -1 && tokenChars[code] === 1) {
            if (start === -1)
              start = i;
          } else if (start !== -1 && (code === 32 || code === 9)) {
            if (end === -1)
              end = i;
          } else if (code === 59 || code === 44) {
            if (start === -1) {
              throw new SyntaxError(`Unexpected character at index ${i}`);
            }
            if (end === -1)
              end = i;
            let value = header.slice(start, end);
            if (mustUnescape) {
              value = value.replace(/\\/g, "");
              mustUnescape = false;
            }
            push(params, paramName, value);
            if (code === 44) {
              push(offers, extensionName, params);
              params = /* @__PURE__ */ Object.create(null);
              extensionName = void 0;
            }
            paramName = void 0;
            start = end = -1;
          } else {
            throw new SyntaxError(`Unexpected character at index ${i}`);
          }
        }
      }
      if (start === -1 || inQuotes || code === 32 || code === 9) {
        throw new SyntaxError("Unexpected end of input");
      }
      if (end === -1)
        end = i;
      const token = header.slice(start, end);
      if (extensionName === void 0) {
        push(offers, token, params);
      } else {
        if (paramName === void 0) {
          push(params, token, true);
        } else if (mustUnescape) {
          push(params, paramName, token.replace(/\\/g, ""));
        } else {
          push(params, paramName, token);
        }
        push(offers, extensionName, params);
      }
      return offers;
    }
    function format3(extensions2) {
      return Object.keys(extensions2).map((extension) => {
        let configurations = extensions2[extension];
        if (!Array.isArray(configurations))
          configurations = [configurations];
        return configurations.map((params) => {
          return [extension].concat(
            Object.keys(params).map((k) => {
              let values = params[k];
              if (!Array.isArray(values))
                values = [values];
              return values.map((v) => v === true ? k : `${k}=${v}`).join("; ");
            })
          ).join("; ");
        }).join(", ");
      }).join(", ");
    }
    module2.exports = { format: format3, parse: parse6 };
  }
});

// node_modules/ws/lib/websocket.js
var require_websocket = __commonJS({
  "node_modules/ws/lib/websocket.js"(exports2, module2) {
    "use strict";
    var EventEmitter = require("events");
    var https = require("https");
    var http2 = require("http");
    var net = require("net");
    var tls = require("tls");
    var { randomBytes, createHash: createHash2 } = require("crypto");
    var { Readable } = require("stream");
    var { URL: URL2 } = require("url");
    var PerMessageDeflate = require_permessage_deflate();
    var Receiver2 = require_receiver();
    var Sender2 = require_sender();
    var {
      BINARY_TYPES,
      EMPTY_BUFFER,
      GUID,
      kForOnEventAttribute,
      kListener,
      kStatusCode,
      kWebSocket,
      NOOP
    } = require_constants();
    var {
      EventTarget: { addEventListener, removeEventListener }
    } = require_event_target();
    var { format: format3, parse: parse6 } = require_extension();
    var { toBuffer } = require_buffer_util();
    var readyStates = ["CONNECTING", "OPEN", "CLOSING", "CLOSED"];
    var subprotocolRegex = /^[!#$%&'*+\-.0-9A-Z^_`|a-z~]+$/;
    var protocolVersions = [8, 13];
    var closeTimeout = 30 * 1e3;
    var WebSocket3 = class _WebSocket extends EventEmitter {
      /**
       * Create a new `WebSocket`.
       *
       * @param {(String|URL)} address The URL to which to connect
       * @param {(String|String[])} [protocols] The subprotocols
       * @param {Object} [options] Connection options
       */
      constructor(address, protocols, options) {
        super();
        this._binaryType = BINARY_TYPES[0];
        this._closeCode = 1006;
        this._closeFrameReceived = false;
        this._closeFrameSent = false;
        this._closeMessage = EMPTY_BUFFER;
        this._closeTimer = null;
        this._extensions = {};
        this._paused = false;
        this._protocol = "";
        this._readyState = _WebSocket.CONNECTING;
        this._receiver = null;
        this._sender = null;
        this._socket = null;
        if (address !== null) {
          this._bufferedAmount = 0;
          this._isServer = false;
          this._redirects = 0;
          if (protocols === void 0) {
            protocols = [];
          } else if (!Array.isArray(protocols)) {
            if (typeof protocols === "object" && protocols !== null) {
              options = protocols;
              protocols = [];
            } else {
              protocols = [protocols];
            }
          }
          initAsClient(this, address, protocols, options);
        } else {
          this._isServer = true;
        }
      }
      /**
       * This deviates from the WHATWG interface since ws doesn't support the
       * required default "blob" type (instead we define a custom "nodebuffer"
       * type).
       *
       * @type {String}
       */
      get binaryType() {
        return this._binaryType;
      }
      set binaryType(type) {
        if (!BINARY_TYPES.includes(type))
          return;
        this._binaryType = type;
        if (this._receiver)
          this._receiver._binaryType = type;
      }
      /**
       * @type {Number}
       */
      get bufferedAmount() {
        if (!this._socket)
          return this._bufferedAmount;
        return this._socket._writableState.length + this._sender._bufferedBytes;
      }
      /**
       * @type {String}
       */
      get extensions() {
        return Object.keys(this._extensions).join();
      }
      /**
       * @type {Boolean}
       */
      get isPaused() {
        return this._paused;
      }
      /**
       * @type {Function}
       */
      /* istanbul ignore next */
      get onclose() {
        return null;
      }
      /**
       * @type {Function}
       */
      /* istanbul ignore next */
      get onerror() {
        return null;
      }
      /**
       * @type {Function}
       */
      /* istanbul ignore next */
      get onopen() {
        return null;
      }
      /**
       * @type {Function}
       */
      /* istanbul ignore next */
      get onmessage() {
        return null;
      }
      /**
       * @type {String}
       */
      get protocol() {
        return this._protocol;
      }
      /**
       * @type {Number}
       */
      get readyState() {
        return this._readyState;
      }
      /**
       * @type {String}
       */
      get url() {
        return this._url;
      }
      /**
       * Set up the socket and the internal resources.
       *
       * @param {(net.Socket|tls.Socket)} socket The network socket between the
       *     server and client
       * @param {Buffer} head The first packet of the upgraded stream
       * @param {Object} options Options object
       * @param {Function} [options.generateMask] The function used to generate the
       *     masking key
       * @param {Number} [options.maxPayload=0] The maximum allowed message size
       * @param {Boolean} [options.skipUTF8Validation=false] Specifies whether or
       *     not to skip UTF-8 validation for text and close messages
       * @private
       */
      setSocket(socket, head, options) {
        const receiver = new Receiver2({
          binaryType: this.binaryType,
          extensions: this._extensions,
          isServer: this._isServer,
          maxPayload: options.maxPayload,
          skipUTF8Validation: options.skipUTF8Validation
        });
        this._sender = new Sender2(socket, this._extensions, options.generateMask);
        this._receiver = receiver;
        this._socket = socket;
        receiver[kWebSocket] = this;
        socket[kWebSocket] = this;
        receiver.on("conclude", receiverOnConclude);
        receiver.on("drain", receiverOnDrain);
        receiver.on("error", receiverOnError);
        receiver.on("message", receiverOnMessage);
        receiver.on("ping", receiverOnPing);
        receiver.on("pong", receiverOnPong);
        socket.setTimeout(0);
        socket.setNoDelay();
        if (head.length > 0)
          socket.unshift(head);
        socket.on("close", socketOnClose);
        socket.on("data", socketOnData);
        socket.on("end", socketOnEnd);
        socket.on("error", socketOnError);
        this._readyState = _WebSocket.OPEN;
        this.emit("open");
      }
      /**
       * Emit the `'close'` event.
       *
       * @private
       */
      emitClose() {
        if (!this._socket) {
          this._readyState = _WebSocket.CLOSED;
          this.emit("close", this._closeCode, this._closeMessage);
          return;
        }
        if (this._extensions[PerMessageDeflate.extensionName]) {
          this._extensions[PerMessageDeflate.extensionName].cleanup();
        }
        this._receiver.removeAllListeners();
        this._readyState = _WebSocket.CLOSED;
        this.emit("close", this._closeCode, this._closeMessage);
      }
      /**
       * Start a closing handshake.
       *
       *          +----------+   +-----------+   +----------+
       *     - - -|ws.close()|-->|close frame|-->|ws.close()|- - -
       *    |     +----------+   +-----------+   +----------+     |
       *          +----------+   +-----------+         |
       * CLOSING  |ws.close()|<--|close frame|<--+-----+       CLOSING
       *          +----------+   +-----------+   |
       *    |           |                        |   +---+        |
       *                +------------------------+-->|fin| - - - -
       *    |         +---+                      |   +---+
       *     - - - - -|fin|<---------------------+
       *              +---+
       *
       * @param {Number} [code] Status code explaining why the connection is closing
       * @param {(String|Buffer)} [data] The reason why the connection is
       *     closing
       * @public
       */
      close(code, data) {
        if (this.readyState === _WebSocket.CLOSED)
          return;
        if (this.readyState === _WebSocket.CONNECTING) {
          const msg = "WebSocket was closed before the connection was established";
          return abortHandshake(this, this._req, msg);
        }
        if (this.readyState === _WebSocket.CLOSING) {
          if (this._closeFrameSent && (this._closeFrameReceived || this._receiver._writableState.errorEmitted)) {
            this._socket.end();
          }
          return;
        }
        this._readyState = _WebSocket.CLOSING;
        this._sender.close(code, data, !this._isServer, (err) => {
          if (err)
            return;
          this._closeFrameSent = true;
          if (this._closeFrameReceived || this._receiver._writableState.errorEmitted) {
            this._socket.end();
          }
        });
        this._closeTimer = setTimeout(
          this._socket.destroy.bind(this._socket),
          closeTimeout
        );
      }
      /**
       * Pause the socket.
       *
       * @public
       */
      pause() {
        if (this.readyState === _WebSocket.CONNECTING || this.readyState === _WebSocket.CLOSED) {
          return;
        }
        this._paused = true;
        this._socket.pause();
      }
      /**
       * Send a ping.
       *
       * @param {*} [data] The data to send
       * @param {Boolean} [mask] Indicates whether or not to mask `data`
       * @param {Function} [cb] Callback which is executed when the ping is sent
       * @public
       */
      ping(data, mask, cb) {
        if (this.readyState === _WebSocket.CONNECTING) {
          throw new Error("WebSocket is not open: readyState 0 (CONNECTING)");
        }
        if (typeof data === "function") {
          cb = data;
          data = mask = void 0;
        } else if (typeof mask === "function") {
          cb = mask;
          mask = void 0;
        }
        if (typeof data === "number")
          data = data.toString();
        if (this.readyState !== _WebSocket.OPEN) {
          sendAfterClose(this, data, cb);
          return;
        }
        if (mask === void 0)
          mask = !this._isServer;
        this._sender.ping(data || EMPTY_BUFFER, mask, cb);
      }
      /**
       * Send a pong.
       *
       * @param {*} [data] The data to send
       * @param {Boolean} [mask] Indicates whether or not to mask `data`
       * @param {Function} [cb] Callback which is executed when the pong is sent
       * @public
       */
      pong(data, mask, cb) {
        if (this.readyState === _WebSocket.CONNECTING) {
          throw new Error("WebSocket is not open: readyState 0 (CONNECTING)");
        }
        if (typeof data === "function") {
          cb = data;
          data = mask = void 0;
        } else if (typeof mask === "function") {
          cb = mask;
          mask = void 0;
        }
        if (typeof data === "number")
          data = data.toString();
        if (this.readyState !== _WebSocket.OPEN) {
          sendAfterClose(this, data, cb);
          return;
        }
        if (mask === void 0)
          mask = !this._isServer;
        this._sender.pong(data || EMPTY_BUFFER, mask, cb);
      }
      /**
       * Resume the socket.
       *
       * @public
       */
      resume() {
        if (this.readyState === _WebSocket.CONNECTING || this.readyState === _WebSocket.CLOSED) {
          return;
        }
        this._paused = false;
        if (!this._receiver._writableState.needDrain)
          this._socket.resume();
      }
      /**
       * Send a data message.
       *
       * @param {*} data The message to send
       * @param {Object} [options] Options object
       * @param {Boolean} [options.binary] Specifies whether `data` is binary or
       *     text
       * @param {Boolean} [options.compress] Specifies whether or not to compress
       *     `data`
       * @param {Boolean} [options.fin=true] Specifies whether the fragment is the
       *     last one
       * @param {Boolean} [options.mask] Specifies whether or not to mask `data`
       * @param {Function} [cb] Callback which is executed when data is written out
       * @public
       */
      send(data, options, cb) {
        if (this.readyState === _WebSocket.CONNECTING) {
          throw new Error("WebSocket is not open: readyState 0 (CONNECTING)");
        }
        if (typeof options === "function") {
          cb = options;
          options = {};
        }
        if (typeof data === "number")
          data = data.toString();
        if (this.readyState !== _WebSocket.OPEN) {
          sendAfterClose(this, data, cb);
          return;
        }
        const opts = {
          binary: typeof data !== "string",
          mask: !this._isServer,
          compress: true,
          fin: true,
          ...options
        };
        if (!this._extensions[PerMessageDeflate.extensionName]) {
          opts.compress = false;
        }
        this._sender.send(data || EMPTY_BUFFER, opts, cb);
      }
      /**
       * Forcibly close the connection.
       *
       * @public
       */
      terminate() {
        if (this.readyState === _WebSocket.CLOSED)
          return;
        if (this.readyState === _WebSocket.CONNECTING) {
          const msg = "WebSocket was closed before the connection was established";
          return abortHandshake(this, this._req, msg);
        }
        if (this._socket) {
          this._readyState = _WebSocket.CLOSING;
          this._socket.destroy();
        }
      }
    };
    Object.defineProperty(WebSocket3, "CONNECTING", {
      enumerable: true,
      value: readyStates.indexOf("CONNECTING")
    });
    Object.defineProperty(WebSocket3.prototype, "CONNECTING", {
      enumerable: true,
      value: readyStates.indexOf("CONNECTING")
    });
    Object.defineProperty(WebSocket3, "OPEN", {
      enumerable: true,
      value: readyStates.indexOf("OPEN")
    });
    Object.defineProperty(WebSocket3.prototype, "OPEN", {
      enumerable: true,
      value: readyStates.indexOf("OPEN")
    });
    Object.defineProperty(WebSocket3, "CLOSING", {
      enumerable: true,
      value: readyStates.indexOf("CLOSING")
    });
    Object.defineProperty(WebSocket3.prototype, "CLOSING", {
      enumerable: true,
      value: readyStates.indexOf("CLOSING")
    });
    Object.defineProperty(WebSocket3, "CLOSED", {
      enumerable: true,
      value: readyStates.indexOf("CLOSED")
    });
    Object.defineProperty(WebSocket3.prototype, "CLOSED", {
      enumerable: true,
      value: readyStates.indexOf("CLOSED")
    });
    [
      "binaryType",
      "bufferedAmount",
      "extensions",
      "isPaused",
      "protocol",
      "readyState",
      "url"
    ].forEach((property) => {
      Object.defineProperty(WebSocket3.prototype, property, { enumerable: true });
    });
    ["open", "error", "close", "message"].forEach((method) => {
      Object.defineProperty(WebSocket3.prototype, `on${method}`, {
        enumerable: true,
        get() {
          for (const listener of this.listeners(method)) {
            if (listener[kForOnEventAttribute])
              return listener[kListener];
          }
          return null;
        },
        set(handler) {
          for (const listener of this.listeners(method)) {
            if (listener[kForOnEventAttribute]) {
              this.removeListener(method, listener);
              break;
            }
          }
          if (typeof handler !== "function")
            return;
          this.addEventListener(method, handler, {
            [kForOnEventAttribute]: true
          });
        }
      });
    });
    WebSocket3.prototype.addEventListener = addEventListener;
    WebSocket3.prototype.removeEventListener = removeEventListener;
    module2.exports = WebSocket3;
    function initAsClient(websocket, address, protocols, options) {
      const opts = {
        protocolVersion: protocolVersions[1],
        maxPayload: 100 * 1024 * 1024,
        skipUTF8Validation: false,
        perMessageDeflate: true,
        followRedirects: false,
        maxRedirects: 10,
        ...options,
        createConnection: void 0,
        socketPath: void 0,
        hostname: void 0,
        protocol: void 0,
        timeout: void 0,
        method: void 0,
        host: void 0,
        path: void 0,
        port: void 0
      };
      if (!protocolVersions.includes(opts.protocolVersion)) {
        throw new RangeError(
          `Unsupported protocol version: ${opts.protocolVersion} (supported versions: ${protocolVersions.join(", ")})`
        );
      }
      let parsedUrl;
      if (address instanceof URL2) {
        parsedUrl = address;
        websocket._url = address.href;
      } else {
        try {
          parsedUrl = new URL2(address);
        } catch (e) {
          throw new SyntaxError(`Invalid URL: ${address}`);
        }
        websocket._url = address;
      }
      const isSecure = parsedUrl.protocol === "wss:";
      const isUnixSocket = parsedUrl.protocol === "ws+unix:";
      let invalidURLMessage;
      if (parsedUrl.protocol !== "ws:" && !isSecure && !isUnixSocket) {
        invalidURLMessage = `The URL's protocol must be one of "ws:", "wss:", or "ws+unix:"`;
      } else if (isUnixSocket && !parsedUrl.pathname) {
        invalidURLMessage = "The URL's pathname is empty";
      } else if (parsedUrl.hash) {
        invalidURLMessage = "The URL contains a fragment identifier";
      }
      if (invalidURLMessage) {
        const err = new SyntaxError(invalidURLMessage);
        if (websocket._redirects === 0) {
          throw err;
        } else {
          emitErrorAndClose(websocket, err);
          return;
        }
      }
      const defaultPort = isSecure ? 443 : 80;
      const key = randomBytes(16).toString("base64");
      const get = isSecure ? https.get : http2.get;
      const protocolSet = /* @__PURE__ */ new Set();
      let perMessageDeflate;
      opts.createConnection = isSecure ? tlsConnect : netConnect;
      opts.defaultPort = opts.defaultPort || defaultPort;
      opts.port = parsedUrl.port || defaultPort;
      opts.host = parsedUrl.hostname.startsWith("[") ? parsedUrl.hostname.slice(1, -1) : parsedUrl.hostname;
      opts.headers = {
        "Sec-WebSocket-Version": opts.protocolVersion,
        "Sec-WebSocket-Key": key,
        Connection: "Upgrade",
        Upgrade: "websocket",
        ...opts.headers
      };
      opts.path = parsedUrl.pathname + parsedUrl.search;
      opts.timeout = opts.handshakeTimeout;
      if (opts.perMessageDeflate) {
        perMessageDeflate = new PerMessageDeflate(
          opts.perMessageDeflate !== true ? opts.perMessageDeflate : {},
          false,
          opts.maxPayload
        );
        opts.headers["Sec-WebSocket-Extensions"] = format3({
          [PerMessageDeflate.extensionName]: perMessageDeflate.offer()
        });
      }
      if (protocols.length) {
        for (const protocol of protocols) {
          if (typeof protocol !== "string" || !subprotocolRegex.test(protocol) || protocolSet.has(protocol)) {
            throw new SyntaxError(
              "An invalid or duplicated subprotocol was specified"
            );
          }
          protocolSet.add(protocol);
        }
        opts.headers["Sec-WebSocket-Protocol"] = protocols.join(",");
      }
      if (opts.origin) {
        if (opts.protocolVersion < 13) {
          opts.headers["Sec-WebSocket-Origin"] = opts.origin;
        } else {
          opts.headers.Origin = opts.origin;
        }
      }
      if (parsedUrl.username || parsedUrl.password) {
        opts.auth = `${parsedUrl.username}:${parsedUrl.password}`;
      }
      if (isUnixSocket) {
        const parts = opts.path.split(":");
        opts.socketPath = parts[0];
        opts.path = parts[1];
      }
      if (opts.followRedirects) {
        if (websocket._redirects === 0) {
          websocket._originalHost = parsedUrl.host;
          const headers = options && options.headers;
          options = { ...options, headers: {} };
          if (headers) {
            for (const [key2, value] of Object.entries(headers)) {
              options.headers[key2.toLowerCase()] = value;
            }
          }
        } else if (parsedUrl.host !== websocket._originalHost) {
          delete opts.headers.authorization;
          delete opts.headers.cookie;
          delete opts.headers.host;
          opts.auth = void 0;
        }
        if (opts.auth && !options.headers.authorization) {
          options.headers.authorization = "Basic " + Buffer.from(opts.auth).toString("base64");
        }
      }
      let req = websocket._req = get(opts);
      if (opts.timeout) {
        req.on("timeout", () => {
          abortHandshake(websocket, req, "Opening handshake has timed out");
        });
      }
      req.on("error", (err) => {
        if (req === null || req.aborted)
          return;
        req = websocket._req = null;
        emitErrorAndClose(websocket, err);
      });
      req.on("response", (res) => {
        const location = res.headers.location;
        const statusCode = res.statusCode;
        if (location && opts.followRedirects && statusCode >= 300 && statusCode < 400) {
          if (++websocket._redirects > opts.maxRedirects) {
            abortHandshake(websocket, req, "Maximum redirects exceeded");
            return;
          }
          req.abort();
          let addr;
          try {
            addr = new URL2(location, address);
          } catch (e) {
            const err = new SyntaxError(`Invalid URL: ${location}`);
            emitErrorAndClose(websocket, err);
            return;
          }
          initAsClient(websocket, addr, protocols, options);
        } else if (!websocket.emit("unexpected-response", req, res)) {
          abortHandshake(
            websocket,
            req,
            `Unexpected server response: ${res.statusCode}`
          );
        }
      });
      req.on("upgrade", (res, socket, head) => {
        websocket.emit("upgrade", res);
        if (websocket.readyState !== WebSocket3.CONNECTING)
          return;
        req = websocket._req = null;
        const digest = createHash2("sha1").update(key + GUID).digest("base64");
        if (res.headers["sec-websocket-accept"] !== digest) {
          abortHandshake(websocket, socket, "Invalid Sec-WebSocket-Accept header");
          return;
        }
        const serverProt = res.headers["sec-websocket-protocol"];
        let protError;
        if (serverProt !== void 0) {
          if (!protocolSet.size) {
            protError = "Server sent a subprotocol but none was requested";
          } else if (!protocolSet.has(serverProt)) {
            protError = "Server sent an invalid subprotocol";
          }
        } else if (protocolSet.size) {
          protError = "Server sent no subprotocol";
        }
        if (protError) {
          abortHandshake(websocket, socket, protError);
          return;
        }
        if (serverProt)
          websocket._protocol = serverProt;
        const secWebSocketExtensions = res.headers["sec-websocket-extensions"];
        if (secWebSocketExtensions !== void 0) {
          if (!perMessageDeflate) {
            const message = "Server sent a Sec-WebSocket-Extensions header but no extension was requested";
            abortHandshake(websocket, socket, message);
            return;
          }
          let extensions2;
          try {
            extensions2 = parse6(secWebSocketExtensions);
          } catch (err) {
            const message = "Invalid Sec-WebSocket-Extensions header";
            abortHandshake(websocket, socket, message);
            return;
          }
          const extensionNames = Object.keys(extensions2);
          if (extensionNames.length !== 1 || extensionNames[0] !== PerMessageDeflate.extensionName) {
            const message = "Server indicated an extension that was not requested";
            abortHandshake(websocket, socket, message);
            return;
          }
          try {
            perMessageDeflate.accept(extensions2[PerMessageDeflate.extensionName]);
          } catch (err) {
            const message = "Invalid Sec-WebSocket-Extensions header";
            abortHandshake(websocket, socket, message);
            return;
          }
          websocket._extensions[PerMessageDeflate.extensionName] = perMessageDeflate;
        }
        websocket.setSocket(socket, head, {
          generateMask: opts.generateMask,
          maxPayload: opts.maxPayload,
          skipUTF8Validation: opts.skipUTF8Validation
        });
      });
    }
    function emitErrorAndClose(websocket, err) {
      websocket._readyState = WebSocket3.CLOSING;
      websocket.emit("error", err);
      websocket.emitClose();
    }
    function netConnect(options) {
      options.path = options.socketPath;
      return net.connect(options);
    }
    function tlsConnect(options) {
      options.path = void 0;
      if (!options.servername && options.servername !== "") {
        options.servername = net.isIP(options.host) ? "" : options.host;
      }
      return tls.connect(options);
    }
    function abortHandshake(websocket, stream, message) {
      websocket._readyState = WebSocket3.CLOSING;
      const err = new Error(message);
      Error.captureStackTrace(err, abortHandshake);
      if (stream.setHeader) {
        stream.abort();
        if (stream.socket && !stream.socket.destroyed) {
          stream.socket.destroy();
        }
        stream.once("abort", websocket.emitClose.bind(websocket));
        websocket.emit("error", err);
      } else {
        stream.destroy(err);
        stream.once("error", websocket.emit.bind(websocket, "error"));
        stream.once("close", websocket.emitClose.bind(websocket));
      }
    }
    function sendAfterClose(websocket, data, cb) {
      if (data) {
        const length = toBuffer(data).length;
        if (websocket._socket)
          websocket._sender._bufferedBytes += length;
        else
          websocket._bufferedAmount += length;
      }
      if (cb) {
        const err = new Error(
          `WebSocket is not open: readyState ${websocket.readyState} (${readyStates[websocket.readyState]})`
        );
        cb(err);
      }
    }
    function receiverOnConclude(code, reason) {
      const websocket = this[kWebSocket];
      websocket._closeFrameReceived = true;
      websocket._closeMessage = reason;
      websocket._closeCode = code;
      if (websocket._socket[kWebSocket] === void 0)
        return;
      websocket._socket.removeListener("data", socketOnData);
      process.nextTick(resume, websocket._socket);
      if (code === 1005)
        websocket.close();
      else
        websocket.close(code, reason);
    }
    function receiverOnDrain() {
      const websocket = this[kWebSocket];
      if (!websocket.isPaused)
        websocket._socket.resume();
    }
    function receiverOnError(err) {
      const websocket = this[kWebSocket];
      if (websocket._socket[kWebSocket] !== void 0) {
        websocket._socket.removeListener("data", socketOnData);
        process.nextTick(resume, websocket._socket);
        websocket.close(err[kStatusCode]);
      }
      websocket.emit("error", err);
    }
    function receiverOnFinish() {
      this[kWebSocket].emitClose();
    }
    function receiverOnMessage(data, isBinary) {
      this[kWebSocket].emit("message", data, isBinary);
    }
    function receiverOnPing(data) {
      const websocket = this[kWebSocket];
      websocket.pong(data, !websocket._isServer, NOOP);
      websocket.emit("ping", data);
    }
    function receiverOnPong(data) {
      this[kWebSocket].emit("pong", data);
    }
    function resume(stream) {
      stream.resume();
    }
    function socketOnClose() {
      const websocket = this[kWebSocket];
      this.removeListener("close", socketOnClose);
      this.removeListener("data", socketOnData);
      this.removeListener("end", socketOnEnd);
      websocket._readyState = WebSocket3.CLOSING;
      let chunk;
      if (!this._readableState.endEmitted && !websocket._closeFrameReceived && !websocket._receiver._writableState.errorEmitted && (chunk = websocket._socket.read()) !== null) {
        websocket._receiver.write(chunk);
      }
      websocket._receiver.end();
      this[kWebSocket] = void 0;
      clearTimeout(websocket._closeTimer);
      if (websocket._receiver._writableState.finished || websocket._receiver._writableState.errorEmitted) {
        websocket.emitClose();
      } else {
        websocket._receiver.on("error", receiverOnFinish);
        websocket._receiver.on("finish", receiverOnFinish);
      }
    }
    function socketOnData(chunk) {
      if (!this[kWebSocket]._receiver.write(chunk)) {
        this.pause();
      }
    }
    function socketOnEnd() {
      const websocket = this[kWebSocket];
      websocket._readyState = WebSocket3.CLOSING;
      websocket._receiver.end();
      this.end();
    }
    function socketOnError() {
      const websocket = this[kWebSocket];
      this.removeListener("error", socketOnError);
      this.on("error", NOOP);
      if (websocket) {
        websocket._readyState = WebSocket3.CLOSING;
        this.destroy();
      }
    }
  }
});

// node_modules/ws/lib/stream.js
var require_stream = __commonJS({
  "node_modules/ws/lib/stream.js"(exports2, module2) {
    "use strict";
    var { Duplex } = require("stream");
    function emitClose(stream) {
      stream.emit("close");
    }
    function duplexOnEnd() {
      if (!this.destroyed && this._writableState.finished) {
        this.destroy();
      }
    }
    function duplexOnError(err) {
      this.removeListener("error", duplexOnError);
      this.destroy();
      if (this.listenerCount("error") === 0) {
        this.emit("error", err);
      }
    }
    function createWebSocketStream2(ws, options) {
      let terminateOnDestroy = true;
      const duplex = new Duplex({
        ...options,
        autoDestroy: false,
        emitClose: false,
        objectMode: false,
        writableObjectMode: false
      });
      ws.on("message", function message(msg, isBinary) {
        const data = !isBinary && duplex._readableState.objectMode ? msg.toString() : msg;
        if (!duplex.push(data))
          ws.pause();
      });
      ws.once("error", function error(err) {
        if (duplex.destroyed)
          return;
        terminateOnDestroy = false;
        duplex.destroy(err);
      });
      ws.once("close", function close() {
        if (duplex.destroyed)
          return;
        duplex.push(null);
      });
      duplex._destroy = function(err, callback) {
        if (ws.readyState === ws.CLOSED) {
          callback(err);
          process.nextTick(emitClose, duplex);
          return;
        }
        let called = false;
        ws.once("error", function error(err2) {
          called = true;
          callback(err2);
        });
        ws.once("close", function close() {
          if (!called)
            callback(err);
          process.nextTick(emitClose, duplex);
        });
        if (terminateOnDestroy)
          ws.terminate();
      };
      duplex._final = function(callback) {
        if (ws.readyState === ws.CONNECTING) {
          ws.once("open", function open() {
            duplex._final(callback);
          });
          return;
        }
        if (ws._socket === null)
          return;
        if (ws._socket._writableState.finished) {
          callback();
          if (duplex._readableState.endEmitted)
            duplex.destroy();
        } else {
          ws._socket.once("finish", function finish() {
            callback();
          });
          ws.close();
        }
      };
      duplex._read = function() {
        if (ws.isPaused)
          ws.resume();
      };
      duplex._write = function(chunk, encoding, callback) {
        if (ws.readyState === ws.CONNECTING) {
          ws.once("open", function open() {
            duplex._write(chunk, encoding, callback);
          });
          return;
        }
        ws.send(chunk, callback);
      };
      duplex.on("end", duplexOnEnd);
      duplex.on("error", duplexOnError);
      return duplex;
    }
    module2.exports = createWebSocketStream2;
  }
});

// node_modules/ws/lib/subprotocol.js
var require_subprotocol = __commonJS({
  "node_modules/ws/lib/subprotocol.js"(exports2, module2) {
    "use strict";
    var { tokenChars } = require_validation();
    function parse6(header) {
      const protocols = /* @__PURE__ */ new Set();
      let start = -1;
      let end = -1;
      let i = 0;
      for (i; i < header.length; i++) {
        const code = header.charCodeAt(i);
        if (end === -1 && tokenChars[code] === 1) {
          if (start === -1)
            start = i;
        } else if (i !== 0 && (code === 32 || code === 9)) {
          if (end === -1 && start !== -1)
            end = i;
        } else if (code === 44) {
          if (start === -1) {
            throw new SyntaxError(`Unexpected character at index ${i}`);
          }
          if (end === -1)
            end = i;
          const protocol2 = header.slice(start, end);
          if (protocols.has(protocol2)) {
            throw new SyntaxError(`The "${protocol2}" subprotocol is duplicated`);
          }
          protocols.add(protocol2);
          start = end = -1;
        } else {
          throw new SyntaxError(`Unexpected character at index ${i}`);
        }
      }
      if (start === -1 || end !== -1) {
        throw new SyntaxError("Unexpected end of input");
      }
      const protocol = header.slice(start, i);
      if (protocols.has(protocol)) {
        throw new SyntaxError(`The "${protocol}" subprotocol is duplicated`);
      }
      protocols.add(protocol);
      return protocols;
    }
    module2.exports = { parse: parse6 };
  }
});

// node_modules/ws/lib/websocket-server.js
var require_websocket_server = __commonJS({
  "node_modules/ws/lib/websocket-server.js"(exports2, module2) {
    "use strict";
    var EventEmitter = require("events");
    var http2 = require("http");
    var https = require("https");
    var net = require("net");
    var tls = require("tls");
    var { createHash: createHash2 } = require("crypto");
    var extension = require_extension();
    var PerMessageDeflate = require_permessage_deflate();
    var subprotocol = require_subprotocol();
    var WebSocket3 = require_websocket();
    var { GUID, kWebSocket } = require_constants();
    var keyRegex = /^[+/0-9A-Za-z]{22}==$/;
    var RUNNING = 0;
    var CLOSING = 1;
    var CLOSED = 2;
    var WebSocketServer2 = class extends EventEmitter {
      /**
       * Create a `WebSocketServer` instance.
       *
       * @param {Object} options Configuration options
       * @param {Number} [options.backlog=511] The maximum length of the queue of
       *     pending connections
       * @param {Boolean} [options.clientTracking=true] Specifies whether or not to
       *     track clients
       * @param {Function} [options.handleProtocols] A hook to handle protocols
       * @param {String} [options.host] The hostname where to bind the server
       * @param {Number} [options.maxPayload=104857600] The maximum allowed message
       *     size
       * @param {Boolean} [options.noServer=false] Enable no server mode
       * @param {String} [options.path] Accept only connections matching this path
       * @param {(Boolean|Object)} [options.perMessageDeflate=false] Enable/disable
       *     permessage-deflate
       * @param {Number} [options.port] The port where to bind the server
       * @param {(http.Server|https.Server)} [options.server] A pre-created HTTP/S
       *     server to use
       * @param {Boolean} [options.skipUTF8Validation=false] Specifies whether or
       *     not to skip UTF-8 validation for text and close messages
       * @param {Function} [options.verifyClient] A hook to reject connections
       * @param {Function} [options.WebSocket=WebSocket] Specifies the `WebSocket`
       *     class to use. It must be the `WebSocket` class or class that extends it
       * @param {Function} [callback] A listener for the `listening` event
       */
      constructor(options, callback) {
        super();
        options = {
          maxPayload: 100 * 1024 * 1024,
          skipUTF8Validation: false,
          perMessageDeflate: false,
          handleProtocols: null,
          clientTracking: true,
          verifyClient: null,
          noServer: false,
          backlog: null,
          // use default (511 as implemented in net.js)
          server: null,
          host: null,
          path: null,
          port: null,
          WebSocket: WebSocket3,
          ...options
        };
        if (options.port == null && !options.server && !options.noServer || options.port != null && (options.server || options.noServer) || options.server && options.noServer) {
          throw new TypeError(
            'One and only one of the "port", "server", or "noServer" options must be specified'
          );
        }
        if (options.port != null) {
          this._server = http2.createServer((req, res) => {
            const body = http2.STATUS_CODES[426];
            res.writeHead(426, {
              "Content-Length": body.length,
              "Content-Type": "text/plain"
            });
            res.end(body);
          });
          this._server.listen(
            options.port,
            options.host,
            options.backlog,
            callback
          );
        } else if (options.server) {
          this._server = options.server;
        }
        if (this._server) {
          const emitConnection = this.emit.bind(this, "connection");
          this._removeListeners = addListeners(this._server, {
            listening: this.emit.bind(this, "listening"),
            error: this.emit.bind(this, "error"),
            upgrade: (req, socket, head) => {
              this.handleUpgrade(req, socket, head, emitConnection);
            }
          });
        }
        if (options.perMessageDeflate === true)
          options.perMessageDeflate = {};
        if (options.clientTracking) {
          this.clients = /* @__PURE__ */ new Set();
          this._shouldEmitClose = false;
        }
        this.options = options;
        this._state = RUNNING;
      }
      /**
       * Returns the bound address, the address family name, and port of the server
       * as reported by the operating system if listening on an IP socket.
       * If the server is listening on a pipe or UNIX domain socket, the name is
       * returned as a string.
       *
       * @return {(Object|String|null)} The address of the server
       * @public
       */
      address() {
        if (this.options.noServer) {
          throw new Error('The server is operating in "noServer" mode');
        }
        if (!this._server)
          return null;
        return this._server.address();
      }
      /**
       * Stop the server from accepting new connections and emit the `'close'` event
       * when all existing connections are closed.
       *
       * @param {Function} [cb] A one-time listener for the `'close'` event
       * @public
       */
      close(cb) {
        if (this._state === CLOSED) {
          if (cb) {
            this.once("close", () => {
              cb(new Error("The server is not running"));
            });
          }
          process.nextTick(emitClose, this);
          return;
        }
        if (cb)
          this.once("close", cb);
        if (this._state === CLOSING)
          return;
        this._state = CLOSING;
        if (this.options.noServer || this.options.server) {
          if (this._server) {
            this._removeListeners();
            this._removeListeners = this._server = null;
          }
          if (this.clients) {
            if (!this.clients.size) {
              process.nextTick(emitClose, this);
            } else {
              this._shouldEmitClose = true;
            }
          } else {
            process.nextTick(emitClose, this);
          }
        } else {
          const server = this._server;
          this._removeListeners();
          this._removeListeners = this._server = null;
          server.close(() => {
            emitClose(this);
          });
        }
      }
      /**
       * See if a given request should be handled by this server instance.
       *
       * @param {http.IncomingMessage} req Request object to inspect
       * @return {Boolean} `true` if the request is valid, else `false`
       * @public
       */
      shouldHandle(req) {
        if (this.options.path) {
          const index = req.url.indexOf("?");
          const pathname = index !== -1 ? req.url.slice(0, index) : req.url;
          if (pathname !== this.options.path)
            return false;
        }
        return true;
      }
      /**
       * Handle a HTTP Upgrade request.
       *
       * @param {http.IncomingMessage} req The request object
       * @param {(net.Socket|tls.Socket)} socket The network socket between the
       *     server and client
       * @param {Buffer} head The first packet of the upgraded stream
       * @param {Function} cb Callback
       * @public
       */
      handleUpgrade(req, socket, head, cb) {
        socket.on("error", socketOnError);
        const key = req.headers["sec-websocket-key"] !== void 0 ? req.headers["sec-websocket-key"] : false;
        const version = +req.headers["sec-websocket-version"];
        if (req.method !== "GET" || req.headers.upgrade.toLowerCase() !== "websocket" || !key || !keyRegex.test(key) || version !== 8 && version !== 13 || !this.shouldHandle(req)) {
          return abortHandshake(socket, 400);
        }
        const secWebSocketProtocol = req.headers["sec-websocket-protocol"];
        let protocols = /* @__PURE__ */ new Set();
        if (secWebSocketProtocol !== void 0) {
          try {
            protocols = subprotocol.parse(secWebSocketProtocol);
          } catch (err) {
            return abortHandshake(socket, 400);
          }
        }
        const secWebSocketExtensions = req.headers["sec-websocket-extensions"];
        const extensions2 = {};
        if (this.options.perMessageDeflate && secWebSocketExtensions !== void 0) {
          const perMessageDeflate = new PerMessageDeflate(
            this.options.perMessageDeflate,
            true,
            this.options.maxPayload
          );
          try {
            const offers = extension.parse(secWebSocketExtensions);
            if (offers[PerMessageDeflate.extensionName]) {
              perMessageDeflate.accept(offers[PerMessageDeflate.extensionName]);
              extensions2[PerMessageDeflate.extensionName] = perMessageDeflate;
            }
          } catch (err) {
            return abortHandshake(socket, 400);
          }
        }
        if (this.options.verifyClient) {
          const info = {
            origin: req.headers[`${version === 8 ? "sec-websocket-origin" : "origin"}`],
            secure: !!(req.socket.authorized || req.socket.encrypted),
            req
          };
          if (this.options.verifyClient.length === 2) {
            this.options.verifyClient(info, (verified, code, message, headers) => {
              if (!verified) {
                return abortHandshake(socket, code || 401, message, headers);
              }
              this.completeUpgrade(
                extensions2,
                key,
                protocols,
                req,
                socket,
                head,
                cb
              );
            });
            return;
          }
          if (!this.options.verifyClient(info))
            return abortHandshake(socket, 401);
        }
        this.completeUpgrade(extensions2, key, protocols, req, socket, head, cb);
      }
      /**
       * Upgrade the connection to WebSocket.
       *
       * @param {Object} extensions The accepted extensions
       * @param {String} key The value of the `Sec-WebSocket-Key` header
       * @param {Set} protocols The subprotocols
       * @param {http.IncomingMessage} req The request object
       * @param {(net.Socket|tls.Socket)} socket The network socket between the
       *     server and client
       * @param {Buffer} head The first packet of the upgraded stream
       * @param {Function} cb Callback
       * @throws {Error} If called more than once with the same socket
       * @private
       */
      completeUpgrade(extensions2, key, protocols, req, socket, head, cb) {
        if (!socket.readable || !socket.writable)
          return socket.destroy();
        if (socket[kWebSocket]) {
          throw new Error(
            "server.handleUpgrade() was called more than once with the same socket, possibly due to a misconfiguration"
          );
        }
        if (this._state > RUNNING)
          return abortHandshake(socket, 503);
        const digest = createHash2("sha1").update(key + GUID).digest("base64");
        const headers = [
          "HTTP/1.1 101 Switching Protocols",
          "Upgrade: websocket",
          "Connection: Upgrade",
          `Sec-WebSocket-Accept: ${digest}`
        ];
        const ws = new this.options.WebSocket(null);
        if (protocols.size) {
          const protocol = this.options.handleProtocols ? this.options.handleProtocols(protocols, req) : protocols.values().next().value;
          if (protocol) {
            headers.push(`Sec-WebSocket-Protocol: ${protocol}`);
            ws._protocol = protocol;
          }
        }
        if (extensions2[PerMessageDeflate.extensionName]) {
          const params = extensions2[PerMessageDeflate.extensionName].params;
          const value = extension.format({
            [PerMessageDeflate.extensionName]: [params]
          });
          headers.push(`Sec-WebSocket-Extensions: ${value}`);
          ws._extensions = extensions2;
        }
        this.emit("headers", headers, req);
        socket.write(headers.concat("\r\n").join("\r\n"));
        socket.removeListener("error", socketOnError);
        ws.setSocket(socket, head, {
          maxPayload: this.options.maxPayload,
          skipUTF8Validation: this.options.skipUTF8Validation
        });
        if (this.clients) {
          this.clients.add(ws);
          ws.on("close", () => {
            this.clients.delete(ws);
            if (this._shouldEmitClose && !this.clients.size) {
              process.nextTick(emitClose, this);
            }
          });
        }
        cb(ws, req);
      }
    };
    module2.exports = WebSocketServer2;
    function addListeners(server, map) {
      for (const event of Object.keys(map))
        server.on(event, map[event]);
      return function removeListeners() {
        for (const event of Object.keys(map)) {
          server.removeListener(event, map[event]);
        }
      };
    }
    function emitClose(server) {
      server._state = CLOSED;
      server.emit("close");
    }
    function socketOnError() {
      this.destroy();
    }
    function abortHandshake(socket, code, message, headers) {
      if (socket.writable) {
        message = message || http2.STATUS_CODES[code];
        headers = {
          Connection: "close",
          "Content-Type": "text/html",
          "Content-Length": Buffer.byteLength(message),
          ...headers
        };
        socket.write(
          `HTTP/1.1 ${code} ${http2.STATUS_CODES[code]}\r
` + Object.keys(headers).map((h) => `${h}: ${headers[h]}`).join("\r\n") + "\r\n\r\n" + message
        );
      }
      socket.removeListener("error", socketOnError);
      socket.destroy();
    }
  }
});

// node_modules/ws/index.js
var require_ws = __commonJS({
  "node_modules/ws/index.js"(exports2, module2) {
    "use strict";
    var WebSocket3 = require_websocket();
    WebSocket3.createWebSocketStream = require_stream();
    WebSocket3.Server = require_websocket_server();
    WebSocket3.Receiver = require_receiver();
    WebSocket3.Sender = require_sender();
    WebSocket3.WebSocket = WebSocket3;
    WebSocket3.WebSocketServer = WebSocket3.Server;
    module2.exports = WebSocket3;
  }
});

// src/linuxdfu.js
var require_linuxdfu = __commonJS({
  "src/linuxdfu.js"(exports2, module2) {
    "use strict";
    var fs2 = require("fs").promises;
    var fsnp = require("fs");
    var gwutils2 = require_gwutils();
    var path3 = require("path");
    var zlib = require("zlib");
    var crypto2 = require("crypto");
    var allowedPartitions = [5, 6];
    var allowedOSPartitions = [3, 4];
    var exec = require("child_process").exec;
    var UPDATE_GW_APP = 1;
    var UPDATE_GW_OS = 2;
    var publicKey = `-----BEGIN PUBLIC KEY-----
MIICIjANBgkqhkiG9w0BAQEFAAOCAg8AMIICCgKCAgEAqlG+So5P23yZRZZmb7Yz
iMiv7qs6pu1tOcGs6tcaTY4UmteEAOBPUwlkOBk9oju5cBRBHC+ccM0Zq6AXkzBS
XIr91Al4vhtjBZ2kGkifSDYNAwyy8Sb6KC012DWRfOgbz1Mg0WyfWD4CeibXilN2
xKZ+7Rg28W5zQi+ogbXmsEKnfFzjLAHiHclZf4w4+iMumAT3X0OYntbSTkPA2soG
yFdZOoWu9qxiF99DLQxSBfARN8ipDzq//8BIQBAIS6b9lBeYcggY6PrCPjHodSYO
iMnJ6NwcNAcTdGf9XWzk/dTyAcMGyFlBYQy2DqfKbjA1/rvZgLcLbceQsWj5pTGW
b7w2g5jy7cjmtCqfmLSywvdsP/Qu7sAACzsqc3E3RYz3Ffl8dHYUjTKj5tRiEvdL
UbS6B2Teje7mH+/g8vv3Qt9V6ZPRVFvXpD5qIfob3CqHGILW2TMfN0ffMNK164J2
f2+ba0N8/CYjd3Amp9p4vGElBVLz+2gtc8+JkoLbyn8rP17qqI0sblras1d5q/Bu
G13uu19lBJCbhDMTGlyFiL8h2J2mbF5pt3kvUak36AMXYJ7bJP6ggeo+HRkLMNt4
w2+INUwGdPWopaUtvQxueE6ysnymKnDqtpjY/g+CsXOa1s+sJmnt4Pu5vVHwKhm0
m+5Zivq2gYGmhxzQv7cJN/ECAwEAAQ==
-----END PUBLIC KEY-----`;
    async function getRootPartition() {
      let cmdline = await fs2.readFile("/proc/cmdline", "utf8");
      let params = cmdline.split(/\s+/);
      for (let i = 0; i < params.length; i++) {
        let param = params[i];
        let parts = param.split("=");
        if (parts.length == 2 && parts[0] == "root") {
          let xxx = parts[1].split("mmcblk0p");
          if (xxx.length == 2)
            return parseInt(xxx[1]);
        }
      }
      return null;
    }
    async function readAppPartition() {
      let mtab = await fs2.readFile("/etc/mtab", "utf8");
      let lines = mtab.split(/\r?\n/);
      for (let i = 0; i < lines.length; i++) {
        let line = lines[i];
        let parts = line.split(/\s+/);
        if (parts.length >= 2 && parts[1].startsWith("/app")) {
          let x2 = parts[0].split("/dev/mmcblk0p");
          if (x2.length == 2)
            return parseInt(x2[1]);
        }
      }
      return 0;
    }
    async function getUpdatePartition(updateType) {
      if (updateType == UPDATE_GW_APP) {
        let updatePartition = allowedPartitions[1];
        let currentPartitionNum = await readAppPartition();
        if (currentPartitionNum == allowedPartitions[1])
          updatePartition = allowedPartitions[0];
        return "/dev/mmcblk0p" + updatePartition;
      } else if (updateType == UPDATE_GW_OS) {
        let updatePartition = allowedOSPartitions[1];
        let currentPartitionNum = await getRootPartition();
        if (currentPartitionNum == allowedOSPartitions[1])
          updatePartition = allowedOSPartitions[0];
        return "/dev/mmcblk0p" + updatePartition;
      }
    }
    async function readUpdateHeader(filename, offset) {
      let firmwareblob = await fs2.open(filename, "r");
      if (!firmwareblob) {
        console.log("can't open update file");
        return false;
      }
      const preheadersize = 4;
      let data = Buffer.alloc(preheadersize);
      let retvalread = await firmwareblob.read(data, 0, preheadersize, offset);
      console.log(retvalread);
      if (retvalread.bytesRead != preheadersize) {
        console.log("Can't read update file");
        return false;
      }
      if (data[0] != 66 || data[1] != 67) {
        console.log("Bad magic header");
      }
      let headersize = data[2];
      let extheadersize = headersize - preheadersize;
      let updatetype = data[3];
      if (headersize > 8192) {
        console.log("Header too big");
        return false;
      }
      data = Buffer.alloc(extheadersize);
      retvalread = await firmwareblob.read(data, 0, extheadersize, offset + preheadersize);
      if (extheadersize != retvalread.bytesRead) {
        console.log("Can't read ext header");
        return false;
      }
      let updatefssize = data.readUInt32LE(0);
      let signaturesize = data.readUInt32LE(4);
      let originalfssize = data.readUInt32LE(8);
      console.log("Update type", updatetype, "FS size", updatefssize, "Sig size", signaturesize);
      firmwareblob.close();
      return {
        headersize,
        updatetype,
        signaturesize,
        updatefssize,
        originalfssize
      };
    }
    async function verify_signature(filename, updateInfo, gwGlobalState, offset) {
      let verifier = crypto2.createVerify("sha256");
      let firmwareblob = await fs2.open(filename, "r");
      const buffersize = 65536;
      let data = Buffer.alloc(buffersize);
      if (!firmwareblob) {
        console.log("can't open update file");
        return false;
      }
      const signatureBuffer = Buffer.alloc(updateInfo.signaturesize);
      offset += updateInfo.headersize;
      let retvalread = await firmwareblob.read(signatureBuffer, 0, updateInfo.signaturesize, offset);
      if (updateInfo.signaturesize != retvalread.bytesRead) {
        console.log("Can't read signature");
        return false;
      }
      offset += updateInfo.signaturesize;
      let firmwareRead = 0;
      while (firmwareRead < updateInfo.updatefssize) {
        let readSize = updateInfo.updatefssize - firmwareRead;
        if (updateInfo.updatefssize - firmwareRead > buffersize)
          readSize = buffersize;
        retvalread = await firmwareblob.read(data, 0, readSize, offset);
        offset += readSize;
        if (readSize != retvalread.bytesRead) {
          console.log("Can't main fw");
          return false;
        }
        verifier.update(data.subarray(0, readSize));
        firmwareRead += readSize;
      }
      let valid = verifier.verify(publicKey, signatureBuffer);
      console.log("signature is valid", valid);
      firmwareblob.close();
      return valid;
    }
    async function really_update(filename, updateInfo, updatePartition, gwGlobalState, offset) {
      let success = true;
      if (process.platform != "linux")
        return;
      let partition = await fs2.open(updatePartition, "r+");
      let firmwareReadable = fsnp.createReadStream(filename, {
        start: offset + updateInfo.headersize + updateInfo.signaturesize,
        end: offset + updateInfo.headersize + updateInfo.signaturesize + updateInfo.updatefssize
      }).pipe(zlib.createGunzip());
      firmwareReadable.pause();
      let bytesWritten = 0;
      for await (const chunk of firmwareReadable) {
        let retvalwrite = await partition.write(chunk, 0, chunk.length);
        if (retvalwrite.bytesWritten != chunk.length) {
          success = false;
          break;
        }
        bytesWritten += chunk.length;
        if (updateInfo.originalfssize != 0) {
          let newProgress = bytesWritten / updateInfo.originalfssize;
          if (gwGlobalState.deviceInfo?.state) {
            if (newProgress - 0.02 > gwGlobalState.deviceInfo.state.progress || newProgress == 1) {
              gwGlobalState.deviceInfo.state.progress = newProgress;
              console.log(gwGlobalState.deviceInfo.state.progress);
              gwutils2.gwUpdateGlobalState();
            }
          }
        }
        if (bytesWritten == updateInfo.originalfssize)
          break;
      }
      console.log("Done with this partition");
      partition.close();
      return success;
    }
    async function updatePartitionPointer(updatetype, updatePartition) {
      if (updatetype == UPDATE_GW_APP) {
        let configpath = gwutils2.getDataDirectory("config");
        const apppointerpath = path3.join(configpath, "apppartition");
        await fs2.writeFile(apppointerpath, updatePartition + "\n");
      } else if (updatetype == UPDATE_GW_OS) {
        let boot_order = "A B";
        let tries = "BOOT_A_LEFT";
        if (updatePartition == "/dev/mmcblk0p4") {
          boot_order = "B A";
          tries = "BOOT_B_LEFT";
        }
        let alternateFwEnv = false;
        try {
          if (await fs2.stat("/tmp/fw_env.config"))
            alternateFwEnv = true;
        } catch (e) {
          console.log(e);
        }
        if (alternateFwEnv) {
          exec("fw_setenv -c /tmp/fw_env.config BOOT_ORDER " + boot_order);
          exec("fw_setenv -c /tmp/fw_env.config " + tries + " 3");
        } else {
          exec("fw_setenv BOOT_ORDER " + boot_order);
          exec("fw_setenv " + tries + " 3");
        }
      }
    }
    async function update(filename, gwGlobalState) {
      let success = false;
      try {
        let offset = 0;
        let updates = [];
        gwGlobalState.deviceInfo.state = {
          action: "updating",
          state: "verifying",
          progress: 0
        };
        gwutils2.gwUpdateGlobalState();
        let stats = await fs2.stat(filename);
        let remainingSize = stats.size;
        while (remainingSize > 32) {
          success = false;
          let updatePartition = null;
          let validsign = false;
          let updateInfo = await readUpdateHeader(filename, offset);
          if (updateInfo) {
            validsign = await verify_signature(filename, updateInfo, gwGlobalState, offset);
          }
          if (validsign) {
            updatePartition = await getUpdatePartition(updateInfo.updatetype);
          }
          if (updatePartition) {
            gwGlobalState.deviceInfo.state.state = "writing";
            gwGlobalState.deviceInfo.state.progress = 0;
            gwutils2.gwUpdateGlobalState();
            success = await really_update(filename, updateInfo, updatePartition, gwGlobalState, offset);
          }
          if (success) {
            updates.push({
              updatetype: updateInfo.updatetype,
              updatePartition
            });
          } else {
            break;
          }
          remainingSize -= updateInfo.headersize + updateInfo.signaturesize + updateInfo.updatefssize;
          offset += updateInfo.headersize + updateInfo.signaturesize + updateInfo.updatefssize;
        }
        if (success) {
          for (let i = 0; i < updates.length; i++) {
            await updatePartitionPointer(updates[i].updatetype, updates[i].updatePartition);
          }
          gwutils2.reboot();
        }
      } catch (e) {
        console.log(e);
      }
      if (!success) {
        delete gwGlobalState.deviceInfo.state;
        gwutils2.gwUpdateGlobalState();
      }
    }
    async function updateBootloader(gwGlobalState) {
      let retVal = false;
      try {
        let bootloaderOffset = 8192;
        let bootloader = await fs2.readFile(path3.join("fw", "u-boot-sunxi-with-spl.bin"));
        let sdcard = await fs2.open("/dev/mmcblk0", "r+");
        await sdcard.write(bootloader, 0, bootloader.length, bootloaderOffset);
        sdcard.close();
        retVal = true;
      } catch (e) {
      }
      return retVal;
    }
    module2.exports = {
      update,
      updateBootloader
    };
  }
});

// src/offlineStorage.js
var require_offlineStorage = __commonJS({
  "src/offlineStorage.js"(exports2, module2) {
    "use strict";
    var path3 = require("path");
    var fs2 = require("fs").promises;
    var gwutils2 = require_gwutils();
    var phantomService2 = require_phantomService().phantomService;
    var offlineStoragePath = null;
    var todayDirectoryPath = null;
    var RETRYTIMEOUT = 30;
    var KEEPLOG = 60;
    var offlineStoreData = {};
    var tryingUpload = false;
    var OfflineStorage = class {
      static async init(gwGlobalState) {
        this.gwGlobalState = gwGlobalState;
        offlineStoragePath = gwutils2.getDataDirectory("offlineStorage");
        this.globalFileList = await this.loadOfflineFiles();
        gwGlobalState.deviceInfo.offlineFilesCount = this.globalFileList.length;
        gwutils2.gwUpdateGlobalState();
        gwutils2.subscribeToEvent("signalsent", async (eventdata) => {
          if (this.allMethodsSucceeded(eventdata.signalData) && !gwGlobalState.basicconfig.enableoffline) {
            console.log("Done sending this signal!!");
            setTimeout(() => {
              delete gwGlobalState.sensorData[eventdata.signalData.uniqueName];
              delete offlineStoreData[eventdata.signalData.uniqueName];
              gwutils2.gwUpdateGlobalState();
            }, KEEPLOG * 1e3);
            if (eventdata.fileInfo)
              await this.deleteSignal(eventdata);
            eventdata.data = null;
            eventdata.header = null;
            this.retryNextInQueue(true);
          } else {
            if (eventdata.fileInfo)
              this.updateMetadata(eventdata.fileInfo);
          }
        });
        gwutils2.subscribeToEvent("signalfailsend", async (eventdata) => {
          if (!eventdata.fileInfo) {
            await this.saveSignal(eventdata);
          }
          await this.updateMetadata(eventdata.fileInfo);
        });
        gwutils2.subscribeToEvent("newsignal", (eventdata) => {
          offlineStoreData[eventdata.signalData.uniqueName] = eventdata;
          if (gwGlobalState.basicconfig.enableoffline)
            gwutils2.broadcastEvent("signalfailsend", eventdata);
        });
        gwutils2.subscribeToEvent("newphantomv1broadcast", (eventdata) => {
        });
        setInterval(async () => {
          await this.retryNextInQueue(false);
        }, RETRYTIMEOUT * 1e3);
      }
      static async retryNextInQueue(force) {
        if (tryingUpload)
          return;
        tryingUpload = true;
        let allDone = true;
        try {
          for (let uniqueName in offlineStoreData) {
            let eventdata = offlineStoreData[uniqueName];
            console.log("Retrying queue...");
            if (this.allMethodsSucceeded(eventdata.signalData)) {
              continue;
            }
            if (this.allMethodsTried(eventdata.signalData)) {
              if (!eventdata.signalData.retries)
                eventdata.signalData.retries = 1;
              if (eventdata.signalData.retries >= 3) {
                if (!eventdata.signalData.gaveUp) {
                  eventdata.signalData.gaveUp = true;
                  setTimeout(() => {
                    if (eventdata.fileInfo)
                      eventdata.fileInfo.eventdata = null;
                    delete this.gwGlobalState.sensorData[eventdata.signalData.uniqueName];
                    delete offlineStoreData[eventdata.signalData.uniqueName];
                    gwutils2.gwUpdateGlobalState();
                  }, KEEPLOG * 1e3);
                }
              } else {
                eventdata.signalData.retries++;
                console.log("Retry signal", eventdata.signalData.uniqueName);
                gwutils2.broadcastEvent("newsignal", eventdata);
                allDone = false;
              }
              break;
            }
          }
          if (allDone && this.globalFileList.length > 0 && Object.keys(offlineStoreData).length < 5 || force) {
            console.log("All done, check if we have any file pending");
            let fileInfo = null;
            for (let i = 0; i < this.globalFileList.length; i++) {
              if (!this.globalFileList[i].eventdata)
                fileInfo = this.globalFileList[i];
            }
            if (fileInfo) {
              let eventdata = await this.loadSignal(fileInfo);
              gwutils2.broadcastEvent("signalsent", eventdata);
              gwutils2.broadcastEvent("newsignal", eventdata);
            }
          }
        } catch (e) {
        }
        tryingUpload = false;
      }
      static allMethodsSucceeded(signalData) {
        let eimonitor = this.gwGlobalState.basicconfig.sendtoeimonitor;
        let eianlytics = this.gwGlobalState.basicconfig.sendtoeianalytics;
        let alternatecloud = this.gwGlobalState.basicconfig.isalternateurl && this.gwGlobalState.basicconfig.endpointurl;
        let mqtt = this.gwGlobalState.basicconfig.enablemqtt && this.gwGlobalState.basicconfig.mqttConfig && this.gwGlobalState.basicconfig.mqttConfig.sendwaveform;
        if ((!eimonitor || signalData.services.eimonitor?.state == "sent") && (!eianlytics || signalData.services.eianalytics?.state == "sent") && (!alternatecloud || signalData.services.alternatecloud?.state == "sent") && (!mqtt || signalData.services.mqtt?.state == "sent")) {
          return true;
        }
        return false;
      }
      static allMethodsTried(signalData) {
        let eimonitor = this.gwGlobalState.basicconfig.sendtoeimonitor;
        let eianalytics = this.gwGlobalState.basicconfig.sendtoeianalytics;
        let alternatecloud = this.gwGlobalState.basicconfig.isalternateurl && this.gwGlobalState.basicconfig.endpointurl;
        let mqtt = this.gwGlobalState.basicconfig.enablemqtt && this.gwGlobalState.basicconfig.mqttConfig && this.gwGlobalState.basicconfig.mqttConfig.sendwaveform;
        if ((!eimonitor || signalData.services.eimonitor?.state == "error" || signalData.services.eimonitor?.state == "sent") && (!eianalytics || signalData.services.eianalytics?.state == "error" || signalData.services.eianalytics?.state == "sent") && (!alternatecloud || signalData.services.alternatecloud?.state == "error" || signalData.services.alternatecloud?.state == "sent") && (!mqtt || signalData.services.mqtt?.state == "error" || signalData.services.mqtt?.state == "sent")) {
          return true;
        }
        return false;
      }
      static async deleteOfflineFiles() {
        let fileList = [];
        let offlinefilesDir = await fs2.opendir(offlineStoragePath);
        let currentDir = null;
        while (currentDir = await offlinefilesDir.read()) {
          if (currentDir.isDirectory()) {
            let innerDir = await fs2.opendir(path3.join(offlineStoragePath, currentDir.name));
            let dirPath = currentDir.name;
            let currentFile = null;
            while (currentFile = await innerDir.read()) {
              await fs2.unlink(path3.join(offlineStoragePath, currentDir.name, currentFile.name));
            }
            innerDir.close();
            await fs2.rmdir(path3.join(offlineStoragePath, dirPath), { recursive: true, force: true });
          }
        }
        offlinefilesDir.close();
        gwutils2.reboot();
      }
      static async loadOfflineFiles() {
        let fileList = [];
        let offlinefilesDir = await fs2.opendir(offlineStoragePath);
        let currentDir = null;
        while (currentDir = await offlinefilesDir.read()) {
          if (currentDir.isDirectory()) {
            let dirPath = path3.join(offlineStoragePath, currentDir.name);
            let innerDir = await fs2.opendir(dirPath);
            let currentFile = null;
            let isEmpty = true;
            while (currentFile = await innerDir.read()) {
              if (currentFile.name.endsWith(".bin")) {
                fileList.push({
                  dirname: currentDir.name,
                  filename: currentFile.name
                });
                isEmpty = false;
              }
            }
            innerDir.close();
            if (isEmpty)
              try {
                await fs2.rmdir(dirPath);
              } catch (e) {
                console.log("Error deleting dir", e);
              }
          }
        }
        offlinefilesDir.close();
        return fileList;
      }
      static sanitize(input) {
        var illegalRe = /[\/\?<>\\:\*\|"]/g;
        var controlRe = /[\x00-\x1f\x80-\x9f]/g;
        var reservedRe = /^\.+$/;
        var windowsReservedRe = /^(con|prn|aux|nul|com[0-9]|lpt[0-9])(\..*)?$/i;
        var windowsTrailingRe = /[\. ]+$/;
        var replacement = "";
        var sanitized = input.replace(illegalRe, replacement).replace(controlRe, replacement).replace(reservedRe, replacement).replace(windowsReservedRe, replacement).replace(windowsTrailingRe, replacement);
        return sanitized;
      }
      static async deleteOfflineFile(dirname, filename) {
        let fileInfo = null;
        for (let i = 0; i < this.globalFileList.length; i++) {
          if (this.globalFileList[i].dirname == dirname && this.globalFileList[i].filename == filename) {
            fileInfo = this.globalFileList[i];
            break;
          }
        }
        if (fileInfo) {
          await this.deleteSignal({
            fileInfo
          });
        }
      }
      static async getOffLineFile(dirname, filename) {
        let fileInfo = null;
        for (let i = 0; i < this.globalFileList.length; i++) {
          if (this.globalFileList[i].dirname == dirname && this.globalFileList[i].filename == filename) {
            fileInfo = this.globalFileList[i];
            break;
          }
        }
        if (!fileInfo)
          return null;
        let eventdata = await this.loadSignal(fileInfo);
        if (phantomService2.isTriaxial(phantomService2.parsePhantomV1HeaderGetType(eventdata.header))) {
          let metadata = phantomService2.parsePhantomV1SignalHeader(eventdata.header);
          if (metadata.timestamp == 0)
            metadata.timestamp = eventdata.signalData.captureTime;
          let data = [];
          data.push([]);
          data.push([]);
          data.push([]);
          if (metadata) {
            let calibration = metadata.range / 32768;
            if (metadata.axisCount == 3) {
              for (let i = 0; i * 6 < metadata.dataLen; i++) {
                data[0].push(eventdata.data.readInt16LE(i * 6 + 0) * calibration);
                data[1].push(eventdata.data.readInt16LE(i * 6 + 2) * calibration);
                data[2].push(eventdata.data.readInt16LE(i * 6 + 4) * calibration);
              }
            } else if (metadata.axisCount == 1) {
              data.push([]);
              for (let i = 0; i * 2 < metadata.dataLen; i++) {
                data[metadata.selectedAxis].push(eventdata.data.readInt16LE(i * 2 + 0) * calibration);
              }
            }
            return {
              dirname,
              filename,
              type: metadata.type,
              serialNumber: metadata.phantomCode,
              sampleRate: metadata.sampleRate,
              timestamp: metadata.timestamp,
              data
            };
          }
        } else if (phantomService2.isThermalImage(phantomService2.parsePhantomV1HeaderGetType(eventdata.header))) {
          let metadata = phantomService2.parsePhantomV1ThermalImageHeader(eventdata.header);
          let imageArray = [];
          let lineArray = [];
          let line = 0;
          let pixel = 0;
          for (let i = 0; i < eventdata.data.length; i += 2) {
            lineArray.push(eventdata.data.readInt16LE(i) / 100);
            pixel++;
            if (pixel == metadata.columns) {
              pixel = 0;
              imageArray.push(lineArray);
              lineArray = [];
            }
          }
          return {
            dirname,
            filename,
            type: metadata.type,
            serialNumber: metadata.phantomCode,
            rows: metadata.rows,
            columns: metadata.columns,
            timestamp: metadata.timestamp ? metadata.timestamp : eventdata.signalData.captureTime,
            data: [imageArray]
          };
        }
        return null;
      }
      static async getOfflineFiles() {
        let offlinefiles = [];
        for (let i = 0; i < this.globalFileList.length; i++) {
          offlinefiles.push({
            dirname: this.globalFileList[i].dirname,
            filename: this.globalFileList[i].filename
          });
        }
        return offlinefiles;
        let fileTree = [];
        let fileList = await this.loadOfflineFiles();
        let currentDir = "";
        let currentDirList = [];
        for (let i = 0; i < fileList.length; i++) {
          let currentFile = fileList[i];
          if (currentFile.dirname != currentDir) {
            currentDir = currentFile.dirname;
            currentDirList = [];
            fileTree.push({
              name: currentDir,
              children: currentDirList
            });
          }
          currentDirList.push({ name: currentFile.dirname });
        }
        return fileTree;
      }
      static formatSignalDir(now) {
        let todayDir = gwutils2.stringFormat(
          "{0}-{1}-{2}",
          now.getFullYear(),
          String(now.getMonth() + 1).padStart(2, "0"),
          String(now.getDate()).padStart(2, "0")
        );
        return todayDir;
      }
      static async getTodayDirectory(signalDir) {
        let todayPath = path3.join(offlineStoragePath, signalDir);
        if (todayPath != todayDirectoryPath) {
          try {
            await fs2.mkdir(todayPath);
          } catch (e) {
          }
          todayDirectoryPath = path3.join(offlineStoragePath, signalDir);
        }
        return todayDirectoryPath;
      }
      static async deleteSignal(eventdata) {
        let fullPath = path3.join(offlineStoragePath, eventdata.fileInfo.dirname, eventdata.fileInfo.filename);
        try {
          let index = this.globalFileList.indexOf(eventdata.fileInfo);
          if (index != -1) {
            this.globalFileList.splice(index, 1);
            this.gwGlobalState.deviceInfo.offlineFilesCount = this.globalFileList.length;
            gwutils2.gwUpdateGlobalState();
          }
          try {
            await fs2.unlink(fullPath);
          } catch (e) {
          }
          try {
            await fs2.unlink(fullPath.replace(".bin", ".json"));
          } catch (e) {
          }
        } catch (e) {
        }
      }
      static async saveSignal(eventdata) {
        let signalDate = new Date(eventdata.signalData.captureTime * 1e3);
        let fileName = eventdata.signalData.uniqueName + ".bin";
        const signalDir = this.formatSignalDir(signalDate);
        const signalFilePath = path3.join(await this.getTodayDirectory(signalDir), fileName);
        try {
          let fileInfo = {
            dirname: signalDir,
            filename: fileName,
            eventdata
          };
          this.globalFileList.push(fileInfo);
          this.gwGlobalState.deviceInfo.offlineFilesCount = this.globalFileList.length;
          gwutils2.gwUpdateGlobalState();
          eventdata.fileInfo = fileInfo;
          let signalFile = await fs2.open(signalFilePath, "w");
          await signalFile.write(eventdata.header);
          await signalFile.write(eventdata.data);
          await signalFile.close();
        } catch (e) {
        }
      }
      static async loadSignal(fileInfo) {
        let filePath = path3.join(offlineStoragePath, fileInfo.dirname, fileInfo.filename);
        let fileData = await fs2.readFile(filePath);
        let header = fileData.subarray(0, 28);
        let data = fileData.subarray(28);
        let uniqueName = fileInfo.filename.replace(".bin", "");
        let fileParts = uniqueName.split("-");
        let fPhantomCode = fileParts[0];
        let year = parseInt(fileParts[1]);
        let month = parseInt(fileParts[2]);
        let day = parseInt(fileParts[3]);
        let hour = parseInt(fileParts[4]);
        let minutes = parseInt(fileParts[5]);
        let seconds = parseInt(fileParts[6]);
        let captureTime = Math.floor(new Date(year, month - 1, day, hour, minutes, seconds, 0) / 1e3);
        let signalData = {
          phantomCode: fPhantomCode,
          captureTime,
          uniqueName,
          services: {}
        };
        let eventData = {
          header,
          data,
          node: this.gwGlobalState.nodes[fPhantomCode],
          signalData,
          fileInfo
        };
        fileInfo.eventdata = eventData;
        await this.loadMetaData(fileInfo);
        this.gwGlobalState.sensorData[uniqueName] = signalData;
        gwutils2.gwUpdateGlobalState();
        return eventData;
      }
      static async loadMetaData(fileInfo) {
        try {
          let filePath = path3.join(offlineStoragePath, fileInfo.dirname, fileInfo.filename);
          let signalData = fileInfo.eventdata.signalData;
          fileInfo.lastMetaData = await fs2.readFile(filePath.replace(".bin", ".json"), "utf8");
          let metaData = JSON.parse(fileInfo.lastMetaData);
          if (!signalData.services)
            signalData.services = {};
          if (metaData.eimonitor) {
            if (!signalData.services.eimonitor)
              signalData.services.eimonitor = {};
            signalData.services.eimonitor.state = "sent";
          }
          if (metaData.eianalytic) {
            if (!signalData.services.eianalytics)
              signalData.services.eianalytics = {};
            signalData.services.eianalytics.state = "sent";
          }
          if (metaData.alternatecloud) {
            if (!signalData.services.alternatecloud)
              signalData.services.alternatecloud = {};
            signalData.services.alternatecloud.state = "sent";
          }
          if (metaData.mqtt) {
            if (!signalData.services.mqtt)
              signalData.services.mqtt = {};
            signalData.services.mqtt.state = "sent";
          }
        } catch (e) {
        }
      }
      static async updateMetadata(fileInfo) {
        let filePath = path3.join(offlineStoragePath, fileInfo.dirname, fileInfo.filename);
        let signalData = fileInfo.eventdata.signalData;
        let metaDataJson = {
          eimonitor: signalData.services.eimonitor?.state == "sent",
          eianalytic: signalData.services.eianalytics?.state == "sent",
          alternatecloud: signalData.services.alternatecloud?.state == "sent",
          mqtt: signalData.services.mqtt?.state == "sent"
        };
        try {
          let metaData = JSON.stringify(metaDataJson);
          if (metaData != fileInfo.lastMetaData) {
            await fs2.writeFile(filePath.replace(".bin", ".json"), metaData);
            fileInfo.lastMetaData = metaData;
          }
        } catch (e) {
        }
      }
    };
    module2.exports = {
      OfflineStorage
    };
  }
});

// node_modules/modbus-serial/utils/buffer_bit.js
var require_buffer_bit = __commonJS({
  "node_modules/modbus-serial/utils/buffer_bit.js"(exports2, module2) {
    "use strict";
    var addBufferBitOp = function() {
      Buffer.prototype.writeBit = function(value, bit, offset) {
        var byteOffset = parseInt(bit / 8 + offset);
        var bitOffset = bit % 8;
        var bitMask = 1 << bitOffset;
        var byte = this.readUInt8(byteOffset);
        if (value) {
          byte |= bitMask;
        } else {
          byte &= ~bitMask;
        }
        this.writeUInt8(byte, byteOffset);
      };
      Buffer.prototype.readBit = function(bit, offset) {
        var byteOffset = parseInt(bit / 8 + offset);
        var bitOffset = bit % 8;
        var bitMask = 1 << bitOffset;
        var byte = this.readUInt8(byteOffset);
        return (byte & bitMask) === bitMask;
      };
    };
    module2.exports = addBufferBitOp;
  }
});

// node_modules/modbus-serial/utils/crc16.js
var require_crc16 = __commonJS({
  "node_modules/modbus-serial/utils/crc16.js"(exports2, module2) {
    "use strict";
    module2.exports = function crc16(buffer) {
      var crc = 65535;
      var odd;
      for (var i = 0; i < buffer.length; i++) {
        crc = crc ^ buffer[i];
        for (var j = 0; j < 8; j++) {
          odd = crc & 1;
          crc = crc >> 1;
          if (odd) {
            crc = crc ^ 40961;
          }
        }
      }
      return crc;
    };
  }
});

// node_modules/modbus-serial/node_modules/@serialport/stream/lib/index.js
var require_lib = __commonJS({
  "node_modules/modbus-serial/node_modules/@serialport/stream/lib/index.js"(exports2, module2) {
    var stream = require("stream");
    var util = require("util");
    var debug = require_src()("serialport/stream");
    var DATABITS = Object.freeze([5, 6, 7, 8]);
    var STOPBITS = Object.freeze([1, 1.5, 2]);
    var PARITY = Object.freeze(["none", "even", "mark", "odd", "space"]);
    var FLOWCONTROLS = Object.freeze(["xon", "xoff", "xany", "rtscts"]);
    var defaultSettings = Object.freeze({
      autoOpen: true,
      endOnClose: false,
      baudRate: 9600,
      dataBits: 8,
      hupcl: true,
      lock: true,
      parity: "none",
      rtscts: false,
      stopBits: 1,
      xany: false,
      xoff: false,
      xon: false,
      highWaterMark: 64 * 1024
    });
    var defaultSetFlags = Object.freeze({
      brk: false,
      cts: false,
      dtr: true,
      dts: false,
      rts: true
    });
    function allocNewReadPool(poolSize) {
      const pool = Buffer.allocUnsafe(poolSize);
      pool.used = 0;
      return pool;
    }
    function SerialPort(path3, options, openCallback) {
      if (!(this instanceof SerialPort)) {
        return new SerialPort(path3, options, openCallback);
      }
      if (options instanceof Function) {
        openCallback = options;
        options = {};
      }
      const settings = { ...defaultSettings, ...options };
      stream.Duplex.call(this, {
        highWaterMark: settings.highWaterMark
      });
      const Binding = settings.binding || SerialPort.Binding;
      if (!Binding) {
        throw new TypeError('"Bindings" is invalid pass it as `options.binding` or set it on `SerialPort.Binding`');
      }
      if (!path3) {
        throw new TypeError(`"path" is not defined: ${path3}`);
      }
      if (settings.baudrate) {
        throw new TypeError(`"baudrate" is an unknown option, did you mean "baudRate"?`);
      }
      if (typeof settings.baudRate !== "number") {
        throw new TypeError(`"baudRate" must be a number: ${settings.baudRate}`);
      }
      if (DATABITS.indexOf(settings.dataBits) === -1) {
        throw new TypeError(`"databits" is invalid: ${settings.dataBits}`);
      }
      if (STOPBITS.indexOf(settings.stopBits) === -1) {
        throw new TypeError(`"stopbits" is invalid: ${settings.stopbits}`);
      }
      if (PARITY.indexOf(settings.parity) === -1) {
        throw new TypeError(`"parity" is invalid: ${settings.parity}`);
      }
      FLOWCONTROLS.forEach((control) => {
        if (typeof settings[control] !== "boolean") {
          throw new TypeError(`"${control}" is not boolean: ${settings[control]}`);
        }
      });
      const binding = new Binding({
        bindingOptions: settings.bindingOptions
      });
      Object.defineProperties(this, {
        binding: {
          enumerable: true,
          value: binding
        },
        path: {
          enumerable: true,
          value: path3
        },
        settings: {
          enumerable: true,
          value: settings
        }
      });
      this.opening = false;
      this.closing = false;
      this._pool = allocNewReadPool(this.settings.highWaterMark);
      this._kMinPoolSpace = 128;
      if (this.settings.autoOpen) {
        this.open(openCallback);
      }
    }
    util.inherits(SerialPort, stream.Duplex);
    Object.defineProperties(SerialPort.prototype, {
      isOpen: {
        enumerable: true,
        get() {
          return this.binding.isOpen && !this.closing;
        }
      },
      baudRate: {
        enumerable: true,
        get() {
          return this.settings.baudRate;
        }
      }
    });
    SerialPort.prototype._error = function(error, callback) {
      if (callback) {
        callback.call(this, error);
      } else {
        this.emit("error", error);
      }
    };
    SerialPort.prototype._asyncError = function(error, callback) {
      process.nextTick(() => this._error(error, callback));
    };
    SerialPort.prototype.open = function(openCallback) {
      if (this.isOpen) {
        return this._asyncError(new Error("Port is already open"), openCallback);
      }
      if (this.opening) {
        return this._asyncError(new Error("Port is opening"), openCallback);
      }
      this.opening = true;
      debug("opening", `path: ${this.path}`);
      this.binding.open(this.path, this.settings).then(
        () => {
          debug("opened", `path: ${this.path}`);
          this.opening = false;
          this.emit("open");
          if (openCallback) {
            openCallback.call(this, null);
          }
        },
        (err) => {
          this.opening = false;
          debug("Binding #open had an error", err);
          this._error(err, openCallback);
        }
      );
    };
    SerialPort.prototype.update = function(options, callback) {
      if (typeof options !== "object") {
        throw TypeError('"options" is not an object');
      }
      if (!this.isOpen) {
        debug("update attempted, but port is not open");
        return this._asyncError(new Error("Port is not open"), callback);
      }
      const settings = { ...defaultSettings, ...options };
      this.settings.baudRate = settings.baudRate;
      debug("update", `baudRate: ${settings.baudRate}`);
      this.binding.update(this.settings).then(
        () => {
          debug("binding.update", "finished");
          if (callback) {
            callback.call(this, null);
          }
        },
        (err) => {
          debug("binding.update", "error", err);
          return this._error(err, callback);
        }
      );
    };
    var superWrite = SerialPort.prototype.write;
    SerialPort.prototype.write = function(data, encoding, callback) {
      if (Array.isArray(data)) {
        data = Buffer.from(data);
      }
      return superWrite.call(this, data, encoding, callback);
    };
    SerialPort.prototype._write = function(data, encoding, callback) {
      if (!this.isOpen) {
        return this.once("open", function afterOpenWrite() {
          this._write(data, encoding, callback);
        });
      }
      debug("_write", `${data.length} bytes of data`);
      this.binding.write(data).then(
        () => {
          debug("binding.write", "write finished");
          callback(null);
        },
        (err) => {
          debug("binding.write", "error", err);
          if (!err.canceled) {
            this._disconnected(err);
          }
          callback(err);
        }
      );
    };
    SerialPort.prototype._writev = function(data, callback) {
      debug("_writev", `${data.length} chunks of data`);
      const dataV = data.map((write) => write.chunk);
      this._write(Buffer.concat(dataV), null, callback);
    };
    SerialPort.prototype._read = function(bytesToRead) {
      if (!this.isOpen) {
        debug("_read", "queueing _read for after open");
        this.once("open", () => {
          this._read(bytesToRead);
        });
        return;
      }
      if (!this._pool || this._pool.length - this._pool.used < this._kMinPoolSpace) {
        debug("_read", "discarding the read buffer pool because it is below kMinPoolSpace");
        this._pool = allocNewReadPool(this.settings.highWaterMark);
      }
      const pool = this._pool;
      const toRead = Math.min(pool.length - pool.used, bytesToRead);
      const start = pool.used;
      debug("_read", `reading`, { start, toRead });
      this.binding.read(pool, start, toRead).then(
        ({ bytesRead }) => {
          debug("binding.read", `finished`, { bytesRead });
          if (bytesRead === 0) {
            debug("binding.read", "Zero bytes read closing readable stream");
            this.push(null);
            return;
          }
          pool.used += bytesRead;
          this.push(pool.slice(start, start + bytesRead));
        },
        (err) => {
          debug("binding.read", `error`, err);
          if (!err.canceled) {
            this._disconnected(err);
          }
          this._read(bytesToRead);
        }
      );
    };
    SerialPort.prototype._disconnected = function(err) {
      if (!this.isOpen) {
        debug("disconnected aborted because already closed", err);
        return;
      }
      debug("disconnected", err);
      err.disconnected = true;
      this.close(null, err);
    };
    SerialPort.prototype.close = function(callback, disconnectError) {
      disconnectError = disconnectError || null;
      if (!this.isOpen) {
        debug("close attempted, but port is not open");
        return this._asyncError(new Error("Port is not open"), callback);
      }
      this.closing = true;
      debug("#close");
      this.binding.close().then(
        () => {
          this.closing = false;
          debug("binding.close", "finished");
          this.emit("close", disconnectError);
          if (this.settings.endOnClose) {
            this.emit("end");
          }
          if (callback) {
            callback.call(this, disconnectError);
          }
        },
        (err) => {
          this.closing = false;
          debug("binding.close", "had an error", err);
          return this._error(err, callback);
        }
      );
    };
    SerialPort.prototype.set = function(options, callback) {
      if (typeof options !== "object") {
        throw TypeError('"options" is not an object');
      }
      if (!this.isOpen) {
        debug("set attempted, but port is not open");
        return this._asyncError(new Error("Port is not open"), callback);
      }
      const settings = { ...defaultSetFlags, ...options };
      debug("#set", settings);
      this.binding.set(settings).then(
        () => {
          debug("binding.set", "finished");
          if (callback) {
            callback.call(this, null);
          }
        },
        (err) => {
          debug("binding.set", "had an error", err);
          return this._error(err, callback);
        }
      );
    };
    SerialPort.prototype.get = function(callback) {
      if (!this.isOpen) {
        debug("get attempted, but port is not open");
        return this._asyncError(new Error("Port is not open"), callback);
      }
      debug("#get");
      this.binding.get().then(
        (status2) => {
          debug("binding.get", "finished");
          if (callback) {
            callback.call(this, null, status2);
          }
        },
        (err) => {
          debug("binding.get", "had an error", err);
          return this._error(err, callback);
        }
      );
    };
    SerialPort.prototype.flush = function(callback) {
      if (!this.isOpen) {
        debug("flush attempted, but port is not open");
        return this._asyncError(new Error("Port is not open"), callback);
      }
      debug("#flush");
      this.binding.flush().then(
        () => {
          debug("binding.flush", "finished");
          if (callback) {
            callback.call(this, null);
          }
        },
        (err) => {
          debug("binding.flush", "had an error", err);
          return this._error(err, callback);
        }
      );
    };
    SerialPort.prototype.drain = function(callback) {
      debug("drain");
      if (!this.isOpen) {
        debug("drain queuing on port open");
        return this.once("open", () => {
          this.drain(callback);
        });
      }
      this.binding.drain().then(
        () => {
          debug("binding.drain", "finished");
          if (callback) {
            callback.call(this, null);
          }
        },
        (err) => {
          debug("binding.drain", "had an error", err);
          return this._error(err, callback);
        }
      );
    };
    SerialPort.list = async function(callback) {
      debug(".list");
      if (!SerialPort.Binding) {
        throw new TypeError("No Binding set on `SerialPort.Binding`");
      }
      if (callback) {
        throw new TypeError("SerialPort.list no longer takes a callback and only returns a promise");
      }
      return SerialPort.Binding.list();
    };
    module2.exports = SerialPort;
  }
});

// node_modules/@serialport/binding-abstract/lib/index.js
var require_lib2 = __commonJS({
  "node_modules/@serialport/binding-abstract/lib/index.js"(exports2, module2) {
    var debug = require_src()("serialport/binding-abstract");
    var AbstractBinding = class {
      /**
       * Retrieves a list of available serial ports with metadata. The `path` must be guaranteed, and all other fields should be undefined if unavailable. The `path` is either the path or an identifier (eg `COM1`) used to open the serialport.
       * @returns {Promise} resolves to an array of port [info objects](#module_serialport--SerialPort.list).
       */
      static async list() {
        debug("list");
      }
      constructor(opt = {}) {
        if (typeof opt !== "object") {
          throw new TypeError('"options" is not an object');
        }
      }
      /**
       * Opens a connection to the serial port referenced by the path.
       * @param {string} path the path or com port to open
       * @param {openOptions} options openOptions for the serialport
       * @returns {Promise} Resolves after the port is opened and configured.
       * @rejects {TypeError} When given invalid arguments, a `TypeError` is rejected.
       */
      async open(path3, options) {
        if (!path3) {
          throw new TypeError('"path" is not a valid port');
        }
        if (typeof options !== "object") {
          throw new TypeError('"options" is not an object');
        }
        debug("open");
        if (this.isOpen) {
          throw new Error("Already open");
        }
      }
      /**
       * Closes an open connection
       * @returns {Promise} Resolves once the connection is closed.
       * @rejects {TypeError} When given invalid arguments, a `TypeError` is rejected.
       */
      async close() {
        debug("close");
        if (!this.isOpen) {
          throw new Error("Port is not open");
        }
      }
      /**
         * Request a number of bytes from the SerialPort. This function is similar to Node's [`fs.read`](http://nodejs.org/api/fs.html#fs_fs_read_fd_buffer_offset_length_position_callback) except it will always return at least one byte.
      
      The in progress reads must error when the port is closed with an error object that has the property `canceled` equal to `true`. Any other error will cause a disconnection.
      
         * @param {buffer} buffer Accepts a [`Buffer`](http://nodejs.org/api/buffer.html) object.
         * @param {integer} offset The offset in the buffer to start writing at.
         * @param {integer} length Specifies the maximum number of bytes to read.
         * @returns {Promise} Resolves with the number of bytes read after a read operation.
         * @rejects {TypeError} When given invalid arguments, a `TypeError` is rejected.
         */
      async read(buffer, offset, length) {
        if (!Buffer.isBuffer(buffer)) {
          throw new TypeError('"buffer" is not a Buffer');
        }
        if (typeof offset !== "number" || isNaN(offset)) {
          throw new TypeError(`"offset" is not an integer got "${isNaN(offset) ? "NaN" : typeof offset}"`);
        }
        if (typeof length !== "number" || isNaN(length)) {
          throw new TypeError(`"length" is not an integer got "${isNaN(length) ? "NaN" : typeof length}"`);
        }
        debug("read");
        if (buffer.length < offset + length) {
          throw new Error("buffer is too small");
        }
        if (!this.isOpen) {
          throw new Error("Port is not open");
        }
      }
      /**
         * Write bytes to the SerialPort. Only called when there is no pending write operation.
      
      The in progress writes must error when the port is closed with an error object that has the property `canceled` equal to `true`. Any other error will cause a disconnection.
      
         * @param {buffer} buffer - Accepts a [`Buffer`](http://nodejs.org/api/buffer.html) object.
         * @returns {Promise} Resolves after the data is passed to the operating system for writing.
         * @rejects {TypeError} When given invalid arguments, a `TypeError` is rejected.
         */
      async write(buffer) {
        if (!Buffer.isBuffer(buffer)) {
          throw new TypeError('"buffer" is not a Buffer');
        }
        debug("write", buffer.length, "bytes");
        if (!this.isOpen) {
          debug("write", "error port is not open");
          throw new Error("Port is not open");
        }
      }
      /**
       * Changes connection settings on an open port. Only `baudRate` is supported.
       * @param {object=} options Only supports `baudRate`.
       * @param {number=} [options.baudRate] If provided a baud rate that the bindings do not support, it should reject.
       * @returns {Promise} Resolves once the port's baud rate changes.
       * @rejects {TypeError} When given invalid arguments, a `TypeError` is rejected.
       */
      async update(options) {
        if (typeof options !== "object") {
          throw TypeError('"options" is not an object');
        }
        if (typeof options.baudRate !== "number") {
          throw new TypeError('"options.baudRate" is not a number');
        }
        debug("update");
        if (!this.isOpen) {
          throw new Error("Port is not open");
        }
      }
      /**
       * Set control flags on an open port.
       * @param {object=} options All options are operating system default when the port is opened. Every flag is set on each call to the provided or default values. All options are always provided.
       * @param {Boolean} [options.brk=false] flag for brk
       * @param {Boolean} [options.cts=false] flag for cts
       * @param {Boolean} [options.dsr=false] flag for dsr
       * @param {Boolean} [options.dtr=true] flag for dtr
       * @param {Boolean} [options.rts=true] flag for rts
       * @param {Boolean} [options.lowLatency=false] flag for lowLatency mode on Linux
       * @returns {Promise} Resolves once the port's flags are set.
       * @rejects {TypeError} When given invalid arguments, a `TypeError` is rejected.
       */
      async set(options) {
        if (typeof options !== "object") {
          throw new TypeError('"options" is not an object');
        }
        debug("set");
        if (!this.isOpen) {
          throw new Error("Port is not open");
        }
      }
      /**
       * Get the control flags (CTS, DSR, DCD) on the open port.
       * @returns {Promise} Resolves with the retrieved flags.
       * @rejects {TypeError} When given invalid arguments, a `TypeError` is rejected.
       */
      async get() {
        debug("get");
        if (!this.isOpen) {
          throw new Error("Port is not open");
        }
      }
      /**
       * Get the OS reported baud rate for the open port.
       * Used mostly for debugging custom baud rates.
       * @returns {Promise} Resolves with the current baud rate.
       * @rejects {TypeError} When given invalid arguments, a `TypeError` is rejected.
       */
      async getBaudRate() {
        debug("getbaudRate");
        if (!this.isOpen) {
          throw new Error("Port is not open");
        }
      }
      /**
       * Flush (discard) data received but not read, and written but not transmitted.
       * @returns {Promise} Resolves once the flush operation finishes.
       * @rejects {TypeError} When given invalid arguments, a `TypeError` is rejected.
       */
      async flush() {
        debug("flush");
        if (!this.isOpen) {
          throw new Error("Port is not open");
        }
      }
      /**
       * Drain waits until all output data is transmitted to the serial port. An in progress write should be completed before this returns.
       * @returns {Promise} Resolves once the drain operation finishes.
       * @rejects {TypeError} When given invalid arguments, a `TypeError` is rejected.
       */
      async drain() {
        debug("drain");
        if (!this.isOpen) {
          throw new Error("Port is not open");
        }
      }
    };
    module2.exports = AbstractBinding;
  }
});

// node_modules/@serialport/bindings/lib/win32-sn-parser.js
var require_win32_sn_parser = __commonJS({
  "node_modules/@serialport/bindings/lib/win32-sn-parser.js"(exports2, module2) {
    var PARSERS = [/USB\\(?:.+)\\(.+)/, /FTDIBUS\\(?:.+)\+(.+?)A?\\.+/];
    module2.exports = (pnpId) => {
      if (!pnpId) {
        return null;
      }
      for (const parser of PARSERS) {
        const sn = pnpId.match(parser);
        if (sn) {
          return sn[1];
        }
      }
      return null;
    };
  }
});

// node_modules/@serialport/bindings/lib/legacy.js
var require_legacy = __commonJS({
  "node_modules/@serialport/bindings/lib/legacy.js"(exports2, module2) {
    var warningSent = false;
    var wrapWithHiddenComName = async (portsPromise) => {
      const ports = await portsPromise;
      return ports.map((port2) => {
        const newPort = { ...port2 };
        return Object.defineProperties(newPort, {
          comName: {
            get() {
              if (!warningSent) {
                warningSent = true;
                console.warn(
                  `"PortInfo.comName" has been deprecated. You should now use "PortInfo.path". The property will be removed in the next major release.`
                );
              }
              return newPort.path;
            },
            enumerable: false
          }
        });
      });
    };
    module2.exports = {
      wrapWithHiddenComName
    };
  }
});

// node_modules/@serialport/bindings/lib/win32.js
var require_win32 = __commonJS({
  "node_modules/@serialport/bindings/lib/win32.js"(exports2, module2) {
    var binding = require_bindings()("bindings.node");
    var AbstractBinding = require_lib2();
    var { promisify } = require("util");
    var serialNumParser = require_win32_sn_parser();
    var asyncList = promisify(binding.list);
    var asyncOpen = promisify(binding.open);
    var asyncClose = promisify(binding.close);
    var asyncRead = promisify(binding.read);
    var asyncWrite = promisify(binding.write);
    var asyncUpdate = promisify(binding.update);
    var asyncSet = promisify(binding.set);
    var asyncGet = promisify(binding.get);
    var asyncGetBaudRate = promisify(binding.getBaudRate);
    var asyncDrain = promisify(binding.drain);
    var asyncFlush = promisify(binding.flush);
    var { wrapWithHiddenComName } = require_legacy();
    var WindowsBinding = class extends AbstractBinding {
      static async list() {
        const ports = await asyncList();
        return wrapWithHiddenComName(
          ports.map((port2) => {
            if (port2.pnpId && !port2.serialNumber) {
              const serialNumber = serialNumParser(port2.pnpId);
              if (serialNumber) {
                return {
                  ...port2,
                  serialNumber
                };
              }
            }
            return port2;
          })
        );
      }
      constructor(opt = {}) {
        super(opt);
        this.bindingOptions = { ...opt.bindingOptions };
        this.fd = null;
        this.writeOperation = null;
      }
      get isOpen() {
        return this.fd !== null;
      }
      async open(path3, options) {
        await super.open(path3, options);
        this.openOptions = { ...this.bindingOptions, ...options };
        const fd = await asyncOpen(path3, this.openOptions);
        this.fd = fd;
      }
      async close() {
        await super.close();
        const fd = this.fd;
        this.fd = null;
        return asyncClose(fd);
      }
      async read(buffer, offset, length) {
        await super.read(buffer, offset, length);
        try {
          const bytesRead = await asyncRead(this.fd, buffer, offset, length);
          return { bytesRead, buffer };
        } catch (err) {
          if (!this.isOpen) {
            err.canceled = true;
          }
          throw err;
        }
      }
      async write(buffer) {
        this.writeOperation = super.write(buffer).then(async () => {
          if (buffer.length === 0) {
            return;
          }
          await asyncWrite(this.fd, buffer);
          this.writeOperation = null;
        });
        return this.writeOperation;
      }
      async update(options) {
        await super.update(options);
        return asyncUpdate(this.fd, options);
      }
      async set(options) {
        await super.set(options);
        return asyncSet(this.fd, options);
      }
      async get() {
        await super.get();
        return asyncGet(this.fd);
      }
      async getBaudRate() {
        await super.get();
        return asyncGetBaudRate(this.fd);
      }
      async drain() {
        await super.drain();
        await this.writeOperation;
        return asyncDrain(this.fd);
      }
      async flush() {
        await super.flush();
        return asyncFlush(this.fd);
      }
    };
    module2.exports = WindowsBinding;
  }
});

// node_modules/@serialport/bindings/lib/poller.js
var require_poller = __commonJS({
  "node_modules/@serialport/bindings/lib/poller.js"(exports2, module2) {
    var debug = require_src();
    var logger = debug("serialport/bindings/poller");
    var EventEmitter = require("events");
    var PollerBindings = require_bindings()("bindings.node").Poller;
    var EVENTS = {
      UV_READABLE: 1,
      UV_WRITABLE: 2,
      UV_DISCONNECT: 4
    };
    function handleEvent(error, eventFlag) {
      if (error) {
        logger("error", error);
        this.emit("readable", error);
        this.emit("writable", error);
        this.emit("disconnect", error);
        return;
      }
      if (eventFlag & EVENTS.UV_READABLE) {
        logger('received "readable"');
        this.emit("readable", null);
      }
      if (eventFlag & EVENTS.UV_WRITABLE) {
        logger('received "writable"');
        this.emit("writable", null);
      }
      if (eventFlag & EVENTS.UV_DISCONNECT) {
        logger('received "disconnect"');
        this.emit("disconnect", null);
      }
    }
    var Poller = class extends EventEmitter {
      constructor(fd, FDPoller = PollerBindings) {
        logger("Creating poller");
        super();
        this.poller = new FDPoller(fd, handleEvent.bind(this));
      }
      /**
       * Wait for the next event to occur
       * @param {string} event ('readable'|'writable'|'disconnect')
       * @returns {Poller} returns itself
       */
      once(event, callback) {
        switch (event) {
          case "readable":
            this.poll(EVENTS.UV_READABLE);
            break;
          case "writable":
            this.poll(EVENTS.UV_WRITABLE);
            break;
          case "disconnect":
            this.poll(EVENTS.UV_DISCONNECT);
            break;
        }
        return super.once(event, callback);
      }
      /**
       * Ask the bindings to listen for an event, it is recommend to use `.once()` for easy use
       * @param {EVENTS} eventFlag polls for an event or group of events based upon a flag.
       * @returns {undefined}
       */
      poll(eventFlag) {
        eventFlag = eventFlag || 0;
        if (eventFlag & EVENTS.UV_READABLE) {
          logger('Polling for "readable"');
        }
        if (eventFlag & EVENTS.UV_WRITABLE) {
          logger('Polling for "writable"');
        }
        if (eventFlag & EVENTS.UV_DISCONNECT) {
          logger('Polling for "disconnect"');
        }
        this.poller.poll(eventFlag);
      }
      /**
       * Stop listening for events and cancel all outstanding listening with an error
       * @returns {undefined}
       */
      stop() {
        logger("Stopping poller");
        this.poller.stop();
        this.emitCanceled();
      }
      destroy() {
        logger("Destroying poller");
        this.poller.destroy();
        this.emitCanceled();
      }
      emitCanceled() {
        const err = new Error("Canceled");
        err.canceled = true;
        this.emit("readable", err);
        this.emit("writable", err);
        this.emit("disconnect", err);
      }
    };
    Poller.EVENTS = EVENTS;
    module2.exports = Poller;
  }
});

// node_modules/@serialport/bindings/lib/unix-read.js
var require_unix_read = __commonJS({
  "node_modules/@serialport/bindings/lib/unix-read.js"(exports2, module2) {
    var fs2 = require("fs");
    var debug = require_src();
    var logger = debug("serialport/bindings/unixRead");
    var { promisify } = require("util");
    var readAsync = promisify(fs2.read);
    var readable = (binding) => {
      return new Promise((resolve2, reject) => {
        binding.poller.once("readable", (err) => err ? reject(err) : resolve2());
      });
    };
    var unixRead = async ({ binding, buffer, offset, length, fsReadAsync = readAsync }) => {
      logger("Starting read");
      if (!binding.isOpen) {
        const err = new Error("Port is not open");
        err.canceled = true;
        throw err;
      }
      try {
        const { bytesRead } = await fsReadAsync(binding.fd, buffer, offset, length, null);
        if (bytesRead === 0) {
          return unixRead({ binding, buffer, offset, length, fsReadAsync });
        }
        logger("Finished read", bytesRead, "bytes");
        return { bytesRead, buffer };
      } catch (err) {
        logger("read error", err);
        if (err.code === "EAGAIN" || err.code === "EWOULDBLOCK" || err.code === "EINTR") {
          if (!binding.isOpen) {
            const err2 = new Error("Port is not open");
            err2.canceled = true;
            throw err2;
          }
          logger("waiting for readable because of code:", err.code);
          await readable(binding);
          return unixRead({ binding, buffer, offset, length, fsReadAsync });
        }
        const disconnectError = err.code === "EBADF" || // Bad file number means we got closed
        err.code === "ENXIO" || // No such device or address probably usb disconnect
        err.code === "UNKNOWN" || err.errno === -1;
        if (disconnectError) {
          err.disconnect = true;
          logger("disconnecting", err);
        }
        throw err;
      }
    };
    module2.exports = unixRead;
  }
});

// node_modules/@serialport/bindings/lib/unix-write.js
var require_unix_write = __commonJS({
  "node_modules/@serialport/bindings/lib/unix-write.js"(exports2, module2) {
    var fs2 = require("fs");
    var debug = require_src();
    var logger = debug("serialport/bindings/unixWrite");
    var { promisify } = require("util");
    var writeAsync = promisify(fs2.write);
    var writable = (binding) => {
      return new Promise((resolve2, reject) => {
        binding.poller.once("writable", (err) => err ? reject(err) : resolve2());
      });
    };
    var unixWrite = async ({ binding, buffer, offset = 0, fsWriteAsync = writeAsync }) => {
      const bytesToWrite = buffer.length - offset;
      logger("Starting write", buffer.length, "bytes offset", offset, "bytesToWrite", bytesToWrite);
      if (!binding.isOpen) {
        throw new Error("Port is not open");
      }
      try {
        const { bytesWritten } = await fsWriteAsync(binding.fd, buffer, offset, bytesToWrite);
        logger("write returned: wrote", bytesWritten, "bytes");
        if (bytesWritten + offset < buffer.length) {
          if (!binding.isOpen) {
            throw new Error("Port is not open");
          }
          return unixWrite({ binding, buffer, offset: bytesWritten + offset, fsWriteAsync });
        }
        logger("Finished writing", bytesWritten + offset, "bytes");
      } catch (err) {
        logger("write errored", err);
        if (err.code === "EAGAIN" || err.code === "EWOULDBLOCK" || err.code === "EINTR") {
          if (!binding.isOpen) {
            throw new Error("Port is not open");
          }
          logger("waiting for writable because of code:", err.code);
          await writable(binding);
          return unixWrite({ binding, buffer, offset, fsWriteAsync });
        }
        const disconnectError = err.code === "EBADF" || // Bad file number means we got closed
        err.code === "ENXIO" || // No such device or address probably usb disconnect
        err.code === "UNKNOWN" || err.errno === -1;
        if (disconnectError) {
          err.disconnect = true;
          logger("disconnecting", err);
        }
        logger("error", err);
        throw err;
      }
    };
    module2.exports = unixWrite;
  }
});

// node_modules/@serialport/bindings/lib/darwin.js
var require_darwin = __commonJS({
  "node_modules/@serialport/bindings/lib/darwin.js"(exports2, module2) {
    var { promisify } = require("util");
    var binding = require_bindings()("bindings.node");
    var AbstractBinding = require_lib2();
    var Poller = require_poller();
    var unixRead = require_unix_read();
    var unixWrite = require_unix_write();
    var { wrapWithHiddenComName } = require_legacy();
    var defaultBindingOptions = Object.freeze({
      vmin: 1,
      vtime: 0
    });
    var asyncList = promisify(binding.list);
    var asyncOpen = promisify(binding.open);
    var asyncClose = promisify(binding.close);
    var asyncUpdate = promisify(binding.update);
    var asyncSet = promisify(binding.set);
    var asyncGet = promisify(binding.get);
    var asyncGetBaudRate = promisify(binding.getBaudRate);
    var asyncDrain = promisify(binding.drain);
    var asyncFlush = promisify(binding.flush);
    var DarwinBinding = class extends AbstractBinding {
      static list() {
        return wrapWithHiddenComName(asyncList());
      }
      constructor(opt = {}) {
        super(opt);
        this.bindingOptions = { ...defaultBindingOptions, ...opt.bindingOptions };
        this.fd = null;
        this.writeOperation = null;
      }
      get isOpen() {
        return this.fd !== null;
      }
      async open(path3, options) {
        await super.open(path3, options);
        this.openOptions = { ...this.bindingOptions, ...options };
        const fd = await asyncOpen(path3, this.openOptions);
        this.fd = fd;
        this.poller = new Poller(fd);
      }
      async close() {
        await super.close();
        const fd = this.fd;
        this.poller.stop();
        this.poller.destroy();
        this.poller = null;
        this.openOptions = null;
        this.fd = null;
        return asyncClose(fd);
      }
      async read(buffer, offset, length) {
        await super.read(buffer, offset, length);
        return unixRead({ binding: this, buffer, offset, length });
      }
      async write(buffer) {
        this.writeOperation = super.write(buffer).then(async () => {
          if (buffer.length === 0) {
            return;
          }
          await unixWrite({ binding: this, buffer });
          this.writeOperation = null;
        });
        return this.writeOperation;
      }
      async update(options) {
        await super.update(options);
        return asyncUpdate(this.fd, options);
      }
      async set(options) {
        await super.set(options);
        return asyncSet(this.fd, options);
      }
      async get() {
        await super.get();
        return asyncGet(this.fd);
      }
      async getBaudRate() {
        await super.get();
        return asyncGetBaudRate(this.fd);
      }
      async drain() {
        await super.drain();
        await this.writeOperation;
        return asyncDrain(this.fd);
      }
      async flush() {
        await super.flush();
        return asyncFlush(this.fd);
      }
    };
    module2.exports = DarwinBinding;
  }
});

// node_modules/@serialport/bindings/node_modules/@serialport/parser-delimiter/lib/index.js
var require_lib3 = __commonJS({
  "node_modules/@serialport/bindings/node_modules/@serialport/parser-delimiter/lib/index.js"(exports2, module2) {
    var { Transform } = require("stream");
    var DelimiterParser = class extends Transform {
      constructor(options = {}) {
        super(options);
        if (options.delimiter === void 0) {
          throw new TypeError('"delimiter" is not a bufferable object');
        }
        if (options.delimiter.length === 0) {
          throw new TypeError('"delimiter" has a 0 or undefined length');
        }
        this.includeDelimiter = options.includeDelimiter !== void 0 ? options.includeDelimiter : false;
        this.delimiter = Buffer.from(options.delimiter);
        this.buffer = Buffer.alloc(0);
      }
      _transform(chunk, encoding, cb) {
        let data = Buffer.concat([this.buffer, chunk]);
        let position;
        while ((position = data.indexOf(this.delimiter)) !== -1) {
          this.push(data.slice(0, position + (this.includeDelimiter ? this.delimiter.length : 0)));
          data = data.slice(position + this.delimiter.length);
        }
        this.buffer = data;
        cb();
      }
      _flush(cb) {
        this.push(this.buffer);
        this.buffer = Buffer.alloc(0);
        cb();
      }
    };
    module2.exports = DelimiterParser;
  }
});

// node_modules/@serialport/bindings/node_modules/@serialport/parser-readline/lib/index.js
var require_lib4 = __commonJS({
  "node_modules/@serialport/bindings/node_modules/@serialport/parser-readline/lib/index.js"(exports2, module2) {
    var DelimiterParser = require_lib3();
    var ReadLineParser = class extends DelimiterParser {
      constructor(options) {
        const opts = {
          delimiter: Buffer.from("\n", "utf8"),
          encoding: "utf8",
          ...options
        };
        if (typeof opts.delimiter === "string") {
          opts.delimiter = Buffer.from(opts.delimiter, opts.encoding);
        }
        super(opts);
      }
    };
    module2.exports = ReadLineParser;
  }
});

// node_modules/@serialport/bindings/lib/linux-list.js
var require_linux_list = __commonJS({
  "node_modules/@serialport/bindings/lib/linux-list.js"(exports2, module2) {
    var childProcess = require("child_process");
    var Readline = require_lib4();
    function checkPathOfDevice(path3) {
      return /(tty(S|WCH|ACM|USB|AMA|MFD|O|XRUSB)|rfcomm)/.test(path3) && path3;
    }
    function propName(name) {
      return {
        DEVNAME: "path",
        ID_VENDOR_ENC: "manufacturer",
        ID_SERIAL_SHORT: "serialNumber",
        ID_VENDOR_ID: "vendorId",
        ID_MODEL_ID: "productId",
        DEVLINKS: "pnpId"
      }[name.toUpperCase()];
    }
    function decodeHexEscape(str) {
      return str.replace(/\\x([a-fA-F0-9]{2})/g, (a, b) => {
        return String.fromCharCode(parseInt(b, 16));
      });
    }
    function propVal(name, val) {
      if (name === "pnpId") {
        const match = val.match(/\/by-id\/([^\s]+)/);
        return match && match[1] || void 0;
      }
      if (name === "manufacturer") {
        return decodeHexEscape(val);
      }
      if (/^0x/.test(val)) {
        return val.substr(2);
      }
      return val;
    }
    function listLinux() {
      return new Promise((resolve2, reject) => {
        const ports = [];
        const ude = childProcess.spawn("udevadm", ["info", "-e"]);
        const lines = ude.stdout.pipe(new Readline());
        ude.on("close", (code) => code && reject(new Error(`Error listing ports udevadm exited with error code: ${code}`)));
        ude.on("error", reject);
        lines.on("error", reject);
        let port2 = {};
        let skipPort = false;
        lines.on("data", (line) => {
          const lineType = line.slice(0, 1);
          const data = line.slice(3);
          if (lineType === "P") {
            port2 = {
              manufacturer: void 0,
              serialNumber: void 0,
              pnpId: void 0,
              locationId: void 0,
              vendorId: void 0,
              productId: void 0
            };
            skipPort = false;
            return;
          }
          if (skipPort) {
            return;
          }
          if (lineType === "N") {
            if (checkPathOfDevice(data)) {
              ports.push(port2);
            } else {
              skipPort = true;
            }
            return;
          }
          if (lineType === "E") {
            const keyValue = data.match(/^(.+)=(.*)/);
            if (!keyValue) {
              return;
            }
            const key = propName(keyValue[1]);
            if (!key) {
              return;
            }
            port2[key] = propVal(key, keyValue[2]);
          }
        });
        lines.on("finish", () => resolve2(ports));
      });
    }
    module2.exports = listLinux;
  }
});

// node_modules/@serialport/bindings/lib/linux.js
var require_linux = __commonJS({
  "node_modules/@serialport/bindings/lib/linux.js"(exports2, module2) {
    var { promisify } = require("util");
    var binding = require_bindings()("bindings.node");
    var AbstractBinding = require_lib2();
    var linuxList = require_linux_list();
    var Poller = require_poller();
    var unixRead = require_unix_read();
    var unixWrite = require_unix_write();
    var { wrapWithHiddenComName } = require_legacy();
    var defaultBindingOptions = Object.freeze({
      vmin: 1,
      vtime: 0
    });
    var asyncOpen = promisify(binding.open);
    var asyncClose = promisify(binding.close);
    var asyncUpdate = promisify(binding.update);
    var asyncSet = promisify(binding.set);
    var asyncGet = promisify(binding.get);
    var asyncGetBaudRate = promisify(binding.getBaudRate);
    var asyncDrain = promisify(binding.drain);
    var asyncFlush = promisify(binding.flush);
    var LinuxBinding = class extends AbstractBinding {
      static list() {
        return wrapWithHiddenComName(linuxList());
      }
      constructor(opt = {}) {
        super(opt);
        this.bindingOptions = { ...defaultBindingOptions, ...opt.bindingOptions };
        this.fd = null;
        this.writeOperation = null;
      }
      get isOpen() {
        return this.fd !== null;
      }
      async open(path3, options) {
        await super.open(path3, options);
        this.openOptions = { ...this.bindingOptions, ...options };
        const fd = await asyncOpen(path3, this.openOptions);
        this.fd = fd;
        this.poller = new Poller(fd);
      }
      async close() {
        await super.close();
        const fd = this.fd;
        this.poller.stop();
        this.poller.destroy();
        this.poller = null;
        this.openOptions = null;
        this.fd = null;
        return asyncClose(fd);
      }
      async read(buffer, offset, length) {
        await super.read(buffer, offset, length);
        return unixRead({ binding: this, buffer, offset, length });
      }
      async write(buffer) {
        this.writeOperation = super.write(buffer).then(async () => {
          if (buffer.length === 0) {
            return;
          }
          await unixWrite({ binding: this, buffer });
          this.writeOperation = null;
        });
        return this.writeOperation;
      }
      async update(options) {
        await super.update(options);
        return asyncUpdate(this.fd, options);
      }
      async set(options) {
        await super.set(options);
        return asyncSet(this.fd, options);
      }
      async get() {
        await super.get();
        return asyncGet(this.fd);
      }
      async getBaudRate() {
        await super.get();
        return asyncGetBaudRate(this.fd);
      }
      async drain() {
        await super.drain();
        await this.writeOperation;
        return asyncDrain(this.fd);
      }
      async flush() {
        await super.flush();
        return asyncFlush(this.fd);
      }
    };
    module2.exports = LinuxBinding;
  }
});

// node_modules/@serialport/bindings/lib/index.js
var require_lib5 = __commonJS({
  "node_modules/@serialport/bindings/lib/index.js"(exports2, module2) {
    var debug = require_src()("serialport/bindings");
    switch (process.platform) {
      case "win32":
        debug("loading WindowsBinding");
        module2.exports = require_win32();
        break;
      case "darwin":
        debug("loading DarwinBinding");
        module2.exports = require_darwin();
        break;
      default:
        debug("loading LinuxBinding");
        module2.exports = require_linux();
    }
  }
});

// node_modules/modbus-serial/node_modules/@serialport/parser-byte-length/lib/index.js
var require_lib6 = __commonJS({
  "node_modules/modbus-serial/node_modules/@serialport/parser-byte-length/lib/index.js"(exports2, module2) {
    var { Transform } = require("stream");
    var ByteLengthParser = class extends Transform {
      constructor(options = {}) {
        super(options);
        if (typeof options.length !== "number") {
          throw new TypeError('"length" is not a number');
        }
        if (options.length < 1) {
          throw new TypeError('"length" is not greater than 0');
        }
        this.length = options.length;
        this.position = 0;
        this.buffer = Buffer.alloc(this.length);
      }
      _transform(chunk, encoding, cb) {
        let cursor = 0;
        while (cursor < chunk.length) {
          this.buffer[this.position] = chunk[cursor];
          cursor++;
          this.position++;
          if (this.position === this.length) {
            this.push(this.buffer);
            this.buffer = Buffer.alloc(this.length);
            this.position = 0;
          }
        }
        cb();
      }
      _flush(cb) {
        this.push(this.buffer.slice(0, this.position));
        this.buffer = Buffer.alloc(this.length);
        cb();
      }
    };
    module2.exports = ByteLengthParser;
  }
});

// node_modules/modbus-serial/node_modules/@serialport/parser-cctalk/lib/index.js
var require_lib7 = __commonJS({
  "node_modules/modbus-serial/node_modules/@serialport/parser-cctalk/lib/index.js"(exports2, module2) {
    var { Transform } = require("stream");
    var CCTalkParser = class extends Transform {
      constructor(maxDelayBetweenBytesMs = 50) {
        super();
        this.array = [];
        this.cursor = 0;
        this.lastByteFetchTime = 0;
        this.maxDelayBetweenBytesMs = maxDelayBetweenBytesMs;
      }
      _transform(buffer, _, cb) {
        if (this.maxDelayBetweenBytesMs > 0) {
          const now = Date.now();
          if (now - this.lastByteFetchTime > this.maxDelayBetweenBytesMs) {
            this.array = [];
            this.cursor = 0;
          }
          this.lastByteFetchTime = now;
        }
        this.cursor += buffer.length;
        Array.from(buffer).map((byte) => this.array.push(byte));
        while (this.cursor > 1 && this.cursor >= this.array[1] + 5) {
          const FullMsgLength = this.array[1] + 5;
          const frame = Buffer.from(this.array.slice(0, FullMsgLength));
          this.array = this.array.slice(frame.length, this.array.length);
          this.cursor -= FullMsgLength;
          this.push(frame);
        }
        cb();
      }
    };
    module2.exports = CCTalkParser;
  }
});

// node_modules/modbus-serial/node_modules/@serialport/parser-delimiter/lib/index.js
var require_lib8 = __commonJS({
  "node_modules/modbus-serial/node_modules/@serialport/parser-delimiter/lib/index.js"(exports2, module2) {
    var { Transform } = require("stream");
    var DelimiterParser = class extends Transform {
      constructor(options = {}) {
        super(options);
        if (options.delimiter === void 0) {
          throw new TypeError('"delimiter" is not a bufferable object');
        }
        if (options.delimiter.length === 0) {
          throw new TypeError('"delimiter" has a 0 or undefined length');
        }
        this.includeDelimiter = options.includeDelimiter !== void 0 ? options.includeDelimiter : false;
        this.delimiter = Buffer.from(options.delimiter);
        this.buffer = Buffer.alloc(0);
      }
      _transform(chunk, encoding, cb) {
        let data = Buffer.concat([this.buffer, chunk]);
        let position;
        while ((position = data.indexOf(this.delimiter)) !== -1) {
          this.push(data.slice(0, position + (this.includeDelimiter ? this.delimiter.length : 0)));
          data = data.slice(position + this.delimiter.length);
        }
        this.buffer = data;
        cb();
      }
      _flush(cb) {
        this.push(this.buffer);
        this.buffer = Buffer.alloc(0);
        cb();
      }
    };
    module2.exports = DelimiterParser;
  }
});

// node_modules/modbus-serial/node_modules/@serialport/parser-inter-byte-timeout/lib/index.js
var require_lib9 = __commonJS({
  "node_modules/modbus-serial/node_modules/@serialport/parser-inter-byte-timeout/lib/index.js"(exports2, module2) {
    var { Transform } = require("stream");
    var InterByteTimeoutParser = class extends Transform {
      constructor(options) {
        super();
        options = { maxBufferSize: 65536, ...options };
        if (!options.interval) {
          throw new TypeError('"interval" is required');
        }
        if (typeof options.interval !== "number" || Number.isNaN(options.interval)) {
          throw new TypeError('"interval" is not a number');
        }
        if (options.interval < 1) {
          throw new TypeError('"interval" is not greater than 0');
        }
        if (typeof options.maxBufferSize !== "number" || Number.isNaN(options.maxBufferSize)) {
          throw new TypeError('"maxBufferSize" is not a number');
        }
        if (options.maxBufferSize < 1) {
          throw new TypeError('"maxBufferSize" is not greater than 0');
        }
        this.maxBufferSize = options.maxBufferSize;
        this.currentPacket = [];
        this.interval = options.interval;
        this.intervalID = -1;
      }
      _transform(chunk, encoding, cb) {
        clearTimeout(this.intervalID);
        for (let offset = 0; offset < chunk.length; offset++) {
          this.currentPacket.push(chunk[offset]);
          if (this.currentPacket.length >= this.maxBufferSize) {
            this.emitPacket();
          }
        }
        this.intervalID = setTimeout(this.emitPacket.bind(this), this.interval);
        cb();
      }
      emitPacket() {
        clearTimeout(this.intervalID);
        if (this.currentPacket.length > 0) {
          this.push(Buffer.from(this.currentPacket));
        }
        this.currentPacket = [];
      }
      _flush(cb) {
        this.emitPacket();
        cb();
      }
    };
    module2.exports = InterByteTimeoutParser;
  }
});

// node_modules/modbus-serial/node_modules/@serialport/parser-readline/lib/index.js
var require_lib10 = __commonJS({
  "node_modules/modbus-serial/node_modules/@serialport/parser-readline/lib/index.js"(exports2, module2) {
    var DelimiterParser = require_lib8();
    var ReadLineParser = class extends DelimiterParser {
      constructor(options) {
        const opts = {
          delimiter: Buffer.from("\n", "utf8"),
          encoding: "utf8",
          ...options
        };
        if (typeof opts.delimiter === "string") {
          opts.delimiter = Buffer.from(opts.delimiter, opts.encoding);
        }
        super(opts);
      }
    };
    module2.exports = ReadLineParser;
  }
});

// node_modules/modbus-serial/node_modules/@serialport/parser-ready/lib/index.js
var require_lib11 = __commonJS({
  "node_modules/modbus-serial/node_modules/@serialport/parser-ready/lib/index.js"(exports2, module2) {
    var { Transform } = require("stream");
    var ReadyParser = class extends Transform {
      /**
       *
       * @param {object} options options for the parser
       * @param {string|Buffer|array} options.delimiter data to look for before emitted "ready"
       */
      constructor(options = {}) {
        if (options.delimiter === void 0) {
          throw new TypeError('"delimiter" is not a bufferable object');
        }
        if (options.delimiter.length === 0) {
          throw new TypeError('"delimiter" has a 0 or undefined length');
        }
        super(options);
        this.delimiter = Buffer.from(options.delimiter);
        this.readOffset = 0;
        this.ready = false;
      }
      _transform(chunk, encoding, cb) {
        if (this.ready) {
          this.push(chunk);
          return cb();
        }
        const delimiter = this.delimiter;
        let chunkOffset = 0;
        while (this.readOffset < delimiter.length && chunkOffset < chunk.length) {
          if (delimiter[this.readOffset] === chunk[chunkOffset]) {
            this.readOffset++;
          } else {
            this.readOffset = 0;
          }
          chunkOffset++;
        }
        if (this.readOffset === delimiter.length) {
          this.ready = true;
          this.emit("ready");
          const chunkRest = chunk.slice(chunkOffset);
          if (chunkRest.length > 0) {
            this.push(chunkRest);
          }
        }
        cb();
      }
    };
    module2.exports = ReadyParser;
  }
});

// node_modules/modbus-serial/node_modules/@serialport/parser-regex/lib/index.js
var require_lib12 = __commonJS({
  "node_modules/modbus-serial/node_modules/@serialport/parser-regex/lib/index.js"(exports2, module2) {
    var { Transform } = require("stream");
    var RegexParser = class extends Transform {
      constructor(options) {
        const opts = {
          encoding: "utf8",
          ...options
        };
        if (opts.regex === void 0) {
          throw new TypeError('"options.regex" must be a regular expression pattern or object');
        }
        if (!(opts.regex instanceof RegExp)) {
          opts.regex = new RegExp(opts.regex);
        }
        super(opts);
        this.regex = opts.regex;
        this.data = "";
      }
      _transform(chunk, encoding, cb) {
        const data = this.data + chunk;
        const parts = data.split(this.regex);
        this.data = parts.pop();
        parts.forEach((part) => {
          this.push(part);
        });
        cb();
      }
      _flush(cb) {
        this.push(this.data);
        this.data = "";
        cb();
      }
    };
    module2.exports = RegexParser;
  }
});

// node_modules/modbus-serial/node_modules/serialport/lib/parsers.js
var require_parsers = __commonJS({
  "node_modules/modbus-serial/node_modules/serialport/lib/parsers.js"(exports2, module2) {
    module2.exports = {
      ByteLength: require_lib6(),
      CCTalk: require_lib7(),
      Delimiter: require_lib8(),
      InterByteTimeout: require_lib9(),
      Readline: require_lib10(),
      Ready: require_lib11(),
      Regex: require_lib12()
    };
  }
});

// node_modules/modbus-serial/node_modules/serialport/lib/index.js
var require_lib13 = __commonJS({
  "node_modules/modbus-serial/node_modules/serialport/lib/index.js"(exports2, module2) {
    var SerialPort = require_lib();
    var Binding = require_lib5();
    var parsers = require_parsers();
    SerialPort.Binding = Binding;
    SerialPort.parsers = parsers;
    module2.exports = SerialPort;
  }
});

// node_modules/modbus-serial/ports/tcpport.js
var require_tcpport = __commonJS({
  "node_modules/modbus-serial/ports/tcpport.js"(exports2, module2) {
    "use strict";
    var util = require("util");
    var events = require("events");
    var EventEmitter = events.EventEmitter || events;
    var net = require("net");
    var modbusSerialDebug = require_src()("modbus-serial");
    var crc16 = require_crc16();
    var MODBUS_PORT = 502;
    var MAX_TRANSACTIONS = 256;
    var MIN_DATA_LENGTH = 6;
    var MIN_MBAP_LENGTH = 6;
    var CRC_LENGTH = 2;
    var TcpPort = function(ip, options) {
      var modbus = this;
      this.openFlag = false;
      this.callback = null;
      this._transactionIdWrite = 1;
      this._externalSocket = null;
      if (typeof ip === "object") {
        options = ip;
      }
      if (typeof options === "undefined")
        options = {};
      this.connectOptions = {
        host: ip || options.ip,
        port: options.port || MODBUS_PORT,
        localAddress: options.localAddress,
        family: options.family
      };
      if (options.socket) {
        if (options.socket instanceof net.Socket) {
          this._externalSocket = options.socket;
          this.openFlag = this._externalSocket.readyState === "opening" || this._externalSocket.readyState === "open";
        } else {
          throw new Error("invalid socket provided");
        }
      }
      var handleCallback = function(had_error) {
        if (modbus.callback) {
          modbus.callback(had_error);
          modbus.callback = null;
        }
      };
      this._client = this._externalSocket || new net.Socket();
      if (options.timeout)
        this._client.setTimeout(options.timeout);
      this._client.on("data", function(data) {
        var buffer;
        var crc;
        var length;
        modbusSerialDebug({ action: "receive tcp port strings", data });
        while (data.length > MIN_MBAP_LENGTH) {
          length = data.readUInt16BE(4);
          buffer = Buffer.alloc(length + CRC_LENGTH);
          data.copy(buffer, 0, MIN_MBAP_LENGTH);
          crc = crc16(buffer.slice(0, -CRC_LENGTH));
          buffer.writeUInt16LE(crc, buffer.length - CRC_LENGTH);
          modbus._transactionIdRead = data.readUInt16BE(0);
          modbus.emit("data", buffer);
          modbusSerialDebug({ action: "parsed tcp port", buffer, transactionId: modbus._transactionIdRead });
          data = data.slice(length + MIN_MBAP_LENGTH);
        }
      });
      this._client.on("connect", function() {
        modbus.openFlag = true;
        modbusSerialDebug("TCP port: signal connect");
        handleCallback();
      });
      this._client.on("close", function(had_error) {
        modbus.openFlag = false;
        modbusSerialDebug("TCP port: signal close: " + had_error);
        handleCallback(had_error);
        modbus.emit("close");
        modbus.removeAllListeners();
      });
      this._client.on("error", function(had_error) {
        modbus.openFlag = false;
        modbusSerialDebug("TCP port: signal error: " + had_error);
        handleCallback(had_error);
      });
      this._client.on("timeout", function() {
        modbusSerialDebug("TCP port: TimedOut");
        handleCallback(new Error("TCP Connection Timed Out"));
      });
      Object.defineProperty(this, "isOpen", {
        enumerable: true,
        get: function() {
          return this.openFlag;
        }
      });
      EventEmitter.call(this);
    };
    util.inherits(TcpPort, EventEmitter);
    TcpPort.prototype.open = function(callback) {
      if (this._externalSocket === null) {
        this.callback = callback;
        this._client.connect(this.connectOptions);
      } else if (this.openFlag) {
        modbusSerialDebug("TCP port: external socket is opened");
        callback();
      } else {
        callback(new Error("TCP port: external socket is not opened"));
      }
    };
    TcpPort.prototype.close = function(callback) {
      this.callback = callback;
      this._client.end();
      this.removeAllListeners();
    };
    TcpPort.prototype.destroy = function(callback) {
      this.callback = callback;
      if (!this._client.destroyed) {
        this._client.destroy();
      }
    };
    TcpPort.prototype.write = function(data) {
      if (data.length < MIN_DATA_LENGTH) {
        modbusSerialDebug("expected length of data is to small - minimum is " + MIN_DATA_LENGTH);
        return;
      }
      this._id = data[0];
      this._cmd = data[1];
      var buffer = Buffer.alloc(data.length + MIN_MBAP_LENGTH - CRC_LENGTH);
      buffer.writeUInt16BE(this._transactionIdWrite, 0);
      buffer.writeUInt16BE(0, 2);
      buffer.writeUInt16BE(data.length - CRC_LENGTH, 4);
      data.copy(buffer, MIN_MBAP_LENGTH);
      modbusSerialDebug({
        action: "send tcp port",
        data,
        buffer,
        unitid: this._id,
        functionCode: this._cmd,
        transactionsId: this._transactionIdWrite
      });
      this._client.write(buffer);
      this._transactionIdWrite = (this._transactionIdWrite + 1) % MAX_TRANSACTIONS;
    };
    module2.exports = TcpPort;
  }
});

// node_modules/modbus-serial/ports/tcprtubufferedport.js
var require_tcprtubufferedport = __commonJS({
  "node_modules/modbus-serial/ports/tcprtubufferedport.js"(exports2, module2) {
    "use strict";
    var util = require("util");
    var events = require("events");
    var EventEmitter = events.EventEmitter || events;
    var net = require("net");
    var modbusSerialDebug = require_src()("modbus-serial");
    var crc16 = require_crc16();
    var EXCEPTION_LENGTH = 3;
    var MIN_DATA_LENGTH = 6;
    var MIN_MBAP_LENGTH = 6;
    var MAX_TRANSACTIONS = 64;
    var MAX_BUFFER_LENGTH = 256;
    var CRC_LENGTH = 2;
    var MODBUS_PORT = 502;
    var TcpRTUBufferedPort = function(ip, options) {
      var modbus = this;
      modbus.openFlag = false;
      modbus.callback = null;
      modbus._transactionIdWrite = 1;
      this._externalSocket = null;
      if (typeof ip === "object") {
        options = ip;
      }
      if (typeof options === "undefined")
        options = {};
      modbus.connectOptions = {
        host: ip || options.ip,
        port: options.port || MODBUS_PORT,
        localAddress: options.localAddress,
        family: options.family || 0
      };
      if (options.socket) {
        if (options.socket instanceof net.Socket) {
          this._externalSocket = options.socket;
          this.openFlag = this._externalSocket.readyState === "opening" || this._externalSocket.readyState === "open";
        } else {
          throw new Error("invalid socket provided");
        }
      }
      modbus._buffer = Buffer.alloc(0);
      var handleCallback = function(had_error) {
        if (modbus.callback) {
          modbus.callback(had_error);
          modbus.callback = null;
        }
      };
      modbus._client = this._externalSocket || new net.Socket();
      if (options.timeout)
        this._client.setTimeout(options.timeout);
      modbus._client.on("data", function onData(data) {
        modbus._buffer = Buffer.concat([modbus._buffer, data]);
        modbusSerialDebug({
          action: "receive tcp rtu buffered port",
          data,
          buffer: modbus._buffer
        });
        var bufferLength = modbus._buffer.length;
        if (bufferLength < MIN_MBAP_LENGTH)
          return;
        if (bufferLength > MAX_BUFFER_LENGTH) {
          modbus._buffer = modbus._buffer.slice(-MAX_BUFFER_LENGTH);
          bufferLength = MAX_BUFFER_LENGTH;
        }
        if (bufferLength < MIN_MBAP_LENGTH + EXCEPTION_LENGTH)
          return;
        var maxOffset = bufferLength - MIN_MBAP_LENGTH;
        for (var i = 0; i <= maxOffset; i++) {
          modbus._transactionIdRead = modbus._buffer.readUInt16BE(i);
          var protocolID = modbus._buffer.readUInt16BE(i + 2);
          var msgLength = modbus._buffer.readUInt16BE(i + 4);
          var cmd = modbus._buffer[i + 7];
          modbusSerialDebug({
            protocolID,
            msgLength,
            bufferLength,
            cmd
          });
          if (protocolID === 0 && cmd !== 0 && msgLength >= EXCEPTION_LENGTH && i + MIN_MBAP_LENGTH + msgLength <= bufferLength) {
            modbus._emitData(i + MIN_MBAP_LENGTH, msgLength);
            return;
          }
        }
      });
      this._client.on("connect", function() {
        modbus.openFlag = true;
        handleCallback();
      });
      this._client.on("close", function(had_error) {
        modbus.openFlag = false;
        handleCallback(had_error);
        modbus.emit("close");
      });
      this._client.on("error", function(had_error) {
        modbus.openFlag = false;
        handleCallback(had_error);
      });
      this._client.on("timeout", function() {
        modbusSerialDebug("TcpRTUBufferedPort port: TimedOut");
        handleCallback(new Error("TcpRTUBufferedPort Connection Timed Out"));
      });
      Object.defineProperty(this, "isOpen", {
        enumerable: true,
        get: function() {
          return this.openFlag;
        }
      });
      EventEmitter.call(this);
    };
    util.inherits(TcpRTUBufferedPort, EventEmitter);
    TcpRTUBufferedPort.prototype._emitData = function(start, length) {
      var modbus = this;
      var data = modbus._buffer.slice(start, start + length);
      modbus._buffer = modbus._buffer.slice(start + length);
      if (data.length > 0) {
        var buffer = Buffer.alloc(data.length + CRC_LENGTH);
        data.copy(buffer, 0);
        var crc = crc16(buffer.slice(0, -CRC_LENGTH));
        buffer.writeUInt16LE(crc, buffer.length - CRC_LENGTH);
        modbus.emit("data", buffer);
        modbusSerialDebug({
          action: "parsed tcp buffered port",
          buffer,
          transactionId: modbus._transactionIdRead
        });
      } else {
        modbusSerialDebug({ action: "emit data to short", data });
      }
    };
    TcpRTUBufferedPort.prototype.open = function(callback) {
      if (this._externalSocket === null) {
        this.callback = callback;
        this._client.connect(this.connectOptions);
      } else if (this.openFlag) {
        modbusSerialDebug("TcpRTUBuffered port: external socket is opened");
        callback();
      } else {
        callback(new Error("TcpRTUBuffered port: external socket is not opened"));
      }
    };
    TcpRTUBufferedPort.prototype.close = function(callback) {
      this.callback = callback;
      this._client.end(callback);
      this.removeAllListeners();
    };
    TcpRTUBufferedPort.prototype.destroy = function(callback) {
      this.callback = callback;
      if (!this._client.destroyed) {
        this._client.destroy();
      }
    };
    TcpRTUBufferedPort.prototype.write = function(data) {
      if (data.length < MIN_DATA_LENGTH) {
        modbusSerialDebug(
          "expected length of data is to small - minimum is " + MIN_DATA_LENGTH
        );
        return;
      }
      var buffer = Buffer.alloc(data.length + MIN_MBAP_LENGTH - CRC_LENGTH);
      buffer.writeUInt16BE(this._transactionIdWrite, 0);
      buffer.writeUInt16BE(0, 2);
      buffer.writeUInt16BE(data.length - CRC_LENGTH, 4);
      data.copy(buffer, MIN_MBAP_LENGTH);
      modbusSerialDebug({
        action: "send tcp rtu buffered port",
        data,
        buffer,
        transactionsId: this._transactionIdWrite
      });
      this._transactionIdWrite = (this._transactionIdWrite + 1) % MAX_TRANSACTIONS;
      this._client.write(buffer);
    };
    module2.exports = TcpRTUBufferedPort;
  }
});

// node_modules/modbus-serial/ports/telnetport.js
var require_telnetport = __commonJS({
  "node_modules/modbus-serial/ports/telnetport.js"(exports2, module2) {
    "use strict";
    var util = require("util");
    var events = require("events");
    var EventEmitter = events.EventEmitter || events;
    var net = require("net");
    var modbusSerialDebug = require_src()("modbus-serial");
    var EXCEPTION_LENGTH = 5;
    var MIN_DATA_LENGTH = 6;
    var TELNET_PORT = 2217;
    var TelnetPort = function(ip, options) {
      var self2 = this;
      this.ip = ip;
      this.openFlag = false;
      this.callback = null;
      this._externalSocket = null;
      if (typeof ip === "object") {
        options = ip;
        this.ip = options.ip;
      }
      if (typeof options === "undefined")
        options = {};
      this.port = options.port || TELNET_PORT;
      this._buffer = Buffer.alloc(0);
      this._id = 0;
      this._cmd = 0;
      this._length = 0;
      var handleCallback = function(had_error) {
        if (self2.callback) {
          self2.callback(had_error);
          self2.callback = null;
        }
      };
      if (options.socket) {
        if (options.socket instanceof net.Socket) {
          this._externalSocket = options.socket;
          this.openFlag = this._externalSocket.readyState === "opening" || this._externalSocket.readyState === "open";
        } else {
          throw new Error("invalid socket provided");
        }
      }
      this._client = this._externalSocket || new net.Socket();
      if (options.timeout)
        this._client.setTimeout(options.timeout);
      this._client.on("data", function onData(data) {
        self2._buffer = Buffer.concat([self2._buffer, data]);
        var expectedLength = self2._length;
        var bufferLength = self2._buffer.length;
        modbusSerialDebug(
          "on data expected length:" + expectedLength + " buffer length:" + bufferLength
        );
        modbusSerialDebug({
          action: "receive tcp telnet port",
          data,
          buffer: self2._buffer
        });
        modbusSerialDebug(
          JSON.stringify({
            action: "receive tcp telnet port strings",
            data,
            buffer: self2._buffer
          })
        );
        if (expectedLength < 6 || bufferLength < EXCEPTION_LENGTH)
          return;
        var maxOffset = bufferLength - EXCEPTION_LENGTH;
        for (var i = 0; i <= maxOffset; i++) {
          var unitId = self2._buffer[i];
          var functionCode = self2._buffer[i + 1];
          if (unitId !== self2._id)
            continue;
          if (functionCode === self2._cmd && i + expectedLength <= bufferLength) {
            self2._emitData(i, expectedLength);
            return;
          }
          if (functionCode === (128 | self2._cmd) && i + EXCEPTION_LENGTH <= bufferLength) {
            self2._emitData(i, EXCEPTION_LENGTH);
            return;
          }
          if (functionCode === (127 & self2._cmd))
            break;
        }
      });
      this._client.on("connect", function() {
        self2.openFlag = true;
        handleCallback();
      });
      this._client.on("close", function(had_error) {
        self2.openFlag = false;
        handleCallback(had_error);
        self2.emit("close");
      });
      this._client.on("error", function(had_error) {
        self2.openFlag = false;
        handleCallback(had_error);
      });
      this._client.on("timeout", function() {
        modbusSerialDebug("TelnetPort port: TimedOut");
        handleCallback(new Error("TelnetPort Connection Timed Out."));
      });
      Object.defineProperty(this, "isOpen", {
        enumerable: true,
        get: function() {
          return this.openFlag;
        }
      });
      EventEmitter.call(this);
    };
    util.inherits(TelnetPort, EventEmitter);
    TelnetPort.prototype._emitData = function(start, length) {
      this.emit("data", this._buffer.slice(start, start + length));
      this._buffer = this._buffer.slice(start + length);
      this._id = 0;
      this._cmd = 0;
      this._length = 0;
    };
    TelnetPort.prototype.open = function(callback) {
      if (this._externalSocket === null) {
        this.callback = callback;
        this._client.connect(this.port, this.ip);
      } else if (this.openFlag) {
        modbusSerialDebug("telnet port: external socket is opened");
        callback();
      } else {
        callback(new Error("telnet port: external socket is not opened"));
      }
    };
    TelnetPort.prototype.close = function(callback) {
      this.callback = callback;
      this._client.end();
      this.removeAllListeners();
    };
    TelnetPort.prototype.destroy = function(callback) {
      this.callback = callback;
      if (!this._client.destroyed) {
        this._client.destroy();
      }
    };
    TelnetPort.prototype.write = function(data) {
      if (data.length < MIN_DATA_LENGTH) {
        modbusSerialDebug(
          "expected length of data is to small - minimum is " + MIN_DATA_LENGTH
        );
        return;
      }
      var length = null;
      this._id = data[0];
      this._cmd = data[1];
      switch (this._cmd) {
        case 1:
        case 2:
          length = data.readUInt16BE(4);
          this._length = 3 + parseInt((length - 1) / 8 + 1) + 2;
          break;
        case 3:
        case 4:
          length = data.readUInt16BE(4);
          this._length = 3 + 2 * length + 2;
          break;
        case 5:
        case 6:
        case 15:
        case 16:
          this._length = 6 + 2;
          break;
        default:
          this._length = 0;
          break;
      }
      this._client.write(data);
      modbusSerialDebug({
        action: "send tcp telnet port",
        data,
        unitid: this._id,
        functionCode: this._cmd
      });
      modbusSerialDebug(
        JSON.stringify({
          action: "send tcp telnet port strings",
          data,
          unitid: this._id,
          functionCode: this._cmd
        })
      );
    };
    module2.exports = TelnetPort;
  }
});

// node_modules/modbus-serial/ports/c701port.js
var require_c701port = __commonJS({
  "node_modules/modbus-serial/ports/c701port.js"(exports2, module2) {
    "use strict";
    var util = require("util");
    var events = require("events");
    var EventEmitter = events.EventEmitter || events;
    var dgram = require("dgram");
    var modbusSerialDebug = require_src()("modbus-serial");
    var crc16 = require_crc16();
    var MIN_DATA_LENGTH = 6;
    var C701_PORT = 28674;
    function _checkData(modbus, buf) {
      if (buf.length !== modbus._length && buf.length !== 5)
        return false;
      var crcIn = buf.readUInt16LE(buf.length - 2);
      return buf[0] === modbus._id && (127 & buf[1]) === modbus._cmd && crcIn === crc16(buf.slice(0, -2));
    }
    var UdpPort = function(ip, options) {
      var modbus = this;
      this.ip = ip;
      this.openFlag = false;
      if (typeof options === "undefined")
        options = {};
      this.port = options.port || C701_PORT;
      this._client = dgram.createSocket("udp4");
      this._client.on("message", function(data) {
        var buffer = null;
        if (modbus.length < 6)
          return;
        if (data.length < 116 + 5)
          return;
        if (data.readUInt16LE(2) !== 602)
          return;
        buffer = data.slice(data.length - modbus._length);
        modbusSerialDebug({ action: "receive c701 upd port", data, buffer });
        modbusSerialDebug(JSON.stringify({ action: "receive c701 upd port strings", data, buffer }));
        if (_checkData(modbus, buffer)) {
          modbusSerialDebug({ action: "emit data serial rtu buffered port", buffer });
          modbusSerialDebug(JSON.stringify({ action: "emit data serial rtu buffered port strings", buffer }));
          modbus.emit("data", buffer);
        } else {
          buffer = data.slice(data.length - 5);
          if (_checkData(modbus, buffer)) {
            modbusSerialDebug({ action: "emit data serial rtu buffered port", buffer });
            modbusSerialDebug(JSON.stringify({
              action: "emit data serial rtu buffered port strings",
              buffer
            }));
            modbus.emit("data", buffer);
          }
        }
      });
      this._client.on("listening", function() {
        modbus.openFlag = true;
      });
      this._client.on("close", function() {
        modbus.openFlag = false;
      });
      Object.defineProperty(this, "isOpen", {
        enumerable: true,
        get: function() {
          return this.openFlag;
        }
      });
      EventEmitter.call(this);
    };
    util.inherits(UdpPort, EventEmitter);
    UdpPort.prototype.open = function(callback) {
      if (callback)
        callback(null);
    };
    UdpPort.prototype.close = function(callback) {
      this._client.close();
      if (callback)
        callback(null);
    };
    UdpPort.prototype.write = function(data) {
      if (data.length < MIN_DATA_LENGTH) {
        modbusSerialDebug("expected length of data is to small - minimum is " + MIN_DATA_LENGTH);
        return;
      }
      var length = null;
      this._id = data[0];
      this._cmd = data[1];
      switch (this._cmd) {
        case 1:
        case 2:
          length = data.readUInt16BE(4);
          this._length = 3 + parseInt((length - 1) / 8 + 1) + 2;
          break;
        case 3:
        case 4:
          length = data.readUInt16BE(4);
          this._length = 3 + 2 * length + 2;
          break;
        case 5:
        case 6:
        case 15:
        case 16:
          this._length = 6 + 2;
          break;
        default:
          this._length = 0;
          break;
      }
      var buffer = Buffer.alloc(data.length + 116);
      buffer.fill(0);
      buffer.writeUInt16LE(600, 2);
      buffer.writeUInt16LE(0, 36);
      buffer.writeUInt16LE(this._length, 38);
      buffer.writeUInt16LE(1, 102);
      buffer.writeUInt16LE(data.length, 104);
      data.copy(buffer, 116);
      this._client.send(buffer, 0, buffer.length, this.port, this.ip);
      modbusSerialDebug({
        action: "send c701 upd port",
        data,
        buffer,
        unitid: this._id,
        functionCode: this._cmd
      });
      modbusSerialDebug(JSON.stringify({
        action: "send c701 upd port strings",
        data,
        buffer,
        unitid: this._id,
        functionCode: this._cmd
      }));
    };
    module2.exports = UdpPort;
  }
});

// node_modules/modbus-serial/ports/udpport.js
var require_udpport = __commonJS({
  "node_modules/modbus-serial/ports/udpport.js"(exports2, module2) {
    "use strict";
    var util = require("util");
    var events = require("events");
    var EventEmitter = events.EventEmitter || events;
    var dgram = require("dgram");
    var modbusSerialDebug = require_src()("modbus-serial");
    var crc16 = require_crc16();
    var MODBUS_PORT = 502;
    var MAX_TRANSACTIONS = 256;
    var MIN_DATA_LENGTH = 6;
    var MIN_MBAP_LENGTH = 6;
    var CRC_LENGTH = 2;
    var ModbusUdpPort = function(ip, options) {
      var modbus = this;
      this.ip = ip;
      this.openFlag = false;
      this._transactionIdWrite = 1;
      this.port = options.port || MODBUS_PORT;
      if (typeof options === "undefined")
        options = {};
      this._client = dgram.createSocket("udp4");
      this._client.bind();
      const self2 = this;
      this._client.on("message", function(data, rinfo) {
        var buffer;
        var crc;
        var length;
        if (rinfo.address !== self2.ip || rinfo.port !== self2.port) {
          return;
        }
        modbusSerialDebug({ action: "receive udp port strings", data });
        while (data.length > MIN_MBAP_LENGTH) {
          length = data.readUInt16BE(4);
          buffer = Buffer.alloc(length + CRC_LENGTH);
          data.copy(buffer, 0, MIN_MBAP_LENGTH);
          crc = crc16(buffer.slice(0, -CRC_LENGTH));
          buffer.writeUInt16LE(crc, buffer.length - CRC_LENGTH);
          modbus._transactionIdRead = data.readUInt16BE(0);
          modbus.emit("data", buffer);
          modbusSerialDebug({ action: "parsed udp port", buffer, transactionId: modbus._transactionIdRead });
          data = data.slice(length + MIN_MBAP_LENGTH);
        }
      });
      this._client.on("listening", function() {
        modbus.openFlag = true;
      });
      this._client.on("close", function() {
        modbus.openFlag = false;
      });
      Object.defineProperty(this, "isOpen", {
        enumerable: true,
        get: function() {
          return this.openFlag;
        }
      });
      EventEmitter.call(this);
    };
    util.inherits(ModbusUdpPort, EventEmitter);
    ModbusUdpPort.prototype.open = function(callback) {
      if (callback)
        callback(null);
    };
    ModbusUdpPort.prototype.close = function(callback) {
      this._client.close();
      if (callback)
        callback(null);
    };
    ModbusUdpPort.prototype.write = function(data) {
      if (data.length < MIN_DATA_LENGTH) {
        modbusSerialDebug("expected length of data is too small - minimum is " + MIN_DATA_LENGTH);
        return;
      }
      this._id = data[0];
      this._cmd = data[1];
      var buffer = Buffer.alloc(data.length + MIN_MBAP_LENGTH - CRC_LENGTH);
      buffer.writeUInt16BE(this._transactionIdWrite, 0);
      buffer.writeUInt16BE(0, 2);
      buffer.writeUInt16BE(data.length - CRC_LENGTH, 4);
      data.copy(buffer, MIN_MBAP_LENGTH);
      modbusSerialDebug({
        action: "send modbus udp port",
        data,
        buffer,
        unitid: this._id,
        functionCode: this._cmd
      });
      this._client.send(buffer, 0, buffer.length, this.port, this.ip);
      this._transactionIdWrite = (this._transactionIdWrite + 1) % MAX_TRANSACTIONS;
    };
    module2.exports = ModbusUdpPort;
  }
});

// node_modules/modbus-serial/ports/rtubufferedport.js
var require_rtubufferedport = __commonJS({
  "node_modules/modbus-serial/ports/rtubufferedport.js"(exports2, module2) {
    "use strict";
    var util = require("util");
    var events = require("events");
    var EventEmitter = events.EventEmitter || events;
    var SerialPort = require_lib13();
    var modbusSerialDebug = require_src()("modbus-serial");
    var EXCEPTION_LENGTH = 5;
    var MIN_DATA_LENGTH = 6;
    var MAX_BUFFER_LENGTH = 256;
    var CRC_LENGTH = 2;
    var READ_DEVICE_IDENTIFICATION_FUNCTION_CODE = 43;
    var LENGTH_UNKNOWN = "unknown";
    var BITS_TO_NUM_OF_OBJECTS = 7;
    var calculateFC43Length = function(buffer, numObjects, i, bufferLength) {
      var result2 = { hasAllData: true };
      var currentByte = 8 + i;
      if (numObjects > 0) {
        for (var j = 0; j < numObjects; j++) {
          if (bufferLength < currentByte) {
            result2.hasAllData = false;
            break;
          }
          var objLength = buffer[currentByte + 1];
          if (!objLength) {
            result2.hasAllData = false;
            break;
          }
          currentByte += 2 + objLength;
        }
      }
      if (currentByte + CRC_LENGTH > bufferLength) {
        result2.hasAllData = false;
      }
      if (result2.hasAllData) {
        result2.bufLength = currentByte + CRC_LENGTH;
      }
      return result2;
    };
    var RTUBufferedPort = function(path3, options) {
      var self2 = this;
      if (typeof options === "undefined")
        options = {};
      options.autoOpen = false;
      this._buffer = Buffer.alloc(0);
      this._id = 0;
      this._cmd = 0;
      this._length = 0;
      this._client = new SerialPort(path3, options);
      this._client.on("error", function(error) {
        self2.emit("error", error);
      });
      this._client.on("data", function onData(data) {
        self2._buffer = Buffer.concat([self2._buffer, data]);
        modbusSerialDebug({ action: "receive serial rtu buffered port", data, buffer: self2._buffer });
        var expectedLength = self2._length;
        var bufferLength = self2._buffer.length;
        if (expectedLength !== LENGTH_UNKNOWN && expectedLength < MIN_DATA_LENGTH || bufferLength < EXCEPTION_LENGTH) {
          return;
        }
        if (bufferLength > MAX_BUFFER_LENGTH) {
          self2._buffer = self2._buffer.slice(-MAX_BUFFER_LENGTH);
          bufferLength = MAX_BUFFER_LENGTH;
        }
        var maxOffset = bufferLength - EXCEPTION_LENGTH;
        for (var i = 0; i <= maxOffset; i++) {
          var unitId = self2._buffer[i];
          var functionCode = self2._buffer[i + 1];
          if (unitId !== self2._id)
            continue;
          if (functionCode === self2._cmd && functionCode === READ_DEVICE_IDENTIFICATION_FUNCTION_CODE) {
            if (bufferLength <= BITS_TO_NUM_OF_OBJECTS + i) {
              return;
            }
            var numObjects = self2._buffer[7 + i];
            var result2 = calculateFC43Length(self2._buffer, numObjects, i, bufferLength);
            if (result2.hasAllData) {
              self2._emitData(i, result2.bufLength);
              return;
            }
          } else {
            if (functionCode === self2._cmd && i + expectedLength <= bufferLength) {
              self2._emitData(i, expectedLength);
              return;
            }
            if (functionCode === (128 | self2._cmd) && i + EXCEPTION_LENGTH <= bufferLength) {
              self2._emitData(i, EXCEPTION_LENGTH);
              return;
            }
          }
          if (functionCode === (127 & self2._cmd))
            break;
        }
      });
      Object.defineProperty(this, "isOpen", {
        enumerable: true,
        get: function() {
          return this._client.isOpen;
        }
      });
      EventEmitter.call(this);
    };
    util.inherits(RTUBufferedPort, EventEmitter);
    RTUBufferedPort.prototype._emitData = function(start, length) {
      var buffer = this._buffer.slice(start, start + length);
      modbusSerialDebug({ action: "emit data serial rtu buffered port", buffer });
      this.emit("data", buffer);
      this._buffer = this._buffer.slice(start + length);
    };
    RTUBufferedPort.prototype.open = function(callback) {
      this._client.open(callback);
    };
    RTUBufferedPort.prototype.close = function(callback) {
      this._client.close(callback);
      this.removeAllListeners("data");
    };
    RTUBufferedPort.prototype.write = function(data) {
      if (data.length < MIN_DATA_LENGTH) {
        modbusSerialDebug("expected length of data is to small - minimum is " + MIN_DATA_LENGTH);
        return;
      }
      var length = null;
      this._id = data[0];
      this._cmd = data[1];
      switch (this._cmd) {
        case 1:
        case 2:
          length = data.readUInt16BE(4);
          this._length = 3 + parseInt((length - 1) / 8 + 1) + 2;
          break;
        case 3:
        case 4:
          length = data.readUInt16BE(4);
          this._length = 3 + 2 * length + 2;
          break;
        case 5:
        case 6:
        case 15:
        case 16:
          this._length = 6 + 2;
          break;
        case 43:
          this._length = LENGTH_UNKNOWN;
          break;
        default:
          this._length = 0;
          break;
      }
      this._client.write(data);
      modbusSerialDebug({
        action: "send serial rtu buffered",
        data,
        unitid: this._id,
        functionCode: this._cmd,
        length: this._length
      });
    };
    module2.exports = RTUBufferedPort;
  }
});

// node_modules/modbus-serial/utils/lrc.js
var require_lrc = __commonJS({
  "node_modules/modbus-serial/utils/lrc.js"(exports2, module2) {
    "use strict";
    module2.exports = function lrc(buffer) {
      var lrc2 = 0;
      for (var i = 0; i < buffer.length; i++) {
        lrc2 += buffer[i] & 255;
      }
      return (lrc2 ^ 255) + 1 & 255;
    };
  }
});

// node_modules/modbus-serial/ports/asciiport.js
var require_asciiport = __commonJS({
  "node_modules/modbus-serial/ports/asciiport.js"(exports2, module2) {
    "use strict";
    var util = require("util");
    var events = require("events");
    var EventEmitter = events.EventEmitter || events;
    var SerialPort = require_lib13();
    var modbusSerialDebug = require_src()("modbus-serial");
    var crc16 = require_crc16();
    var calculateLrc = require_lrc();
    var MIN_DATA_LENGTH = 6;
    function _asciiEncodeRequestBuffer(buf) {
      buf.writeUInt8(calculateLrc(buf.slice(0, -2)), buf.length - 2);
      var bufAscii = Buffer.alloc(buf.length * 2 + 1);
      bufAscii.write(":", 0);
      bufAscii.write(buf.toString("hex", 0, buf.length - 1).toUpperCase(), 1);
      bufAscii.write("\r", bufAscii.length - 2);
      bufAscii.write("\n", bufAscii.length - 1);
      return bufAscii;
    }
    function _asciiDecodeResponseBuffer(bufAscii) {
      var bufDecoded = Buffer.alloc((bufAscii.length - 1) / 2);
      for (var i = 0; i < (bufAscii.length - 3) / 2; i++) {
        bufDecoded.write(String.fromCharCode(bufAscii.readUInt8(i * 2 + 1), bufAscii.readUInt8(i * 2 + 2)), i, 1, "hex");
      }
      var lrcIn = bufDecoded.readUInt8(bufDecoded.length - 2);
      if (calculateLrc(bufDecoded.slice(0, -2)) !== lrcIn) {
        var calcLrc = calculateLrc(bufDecoded.slice(0, -2));
        modbusSerialDebug({ action: "LRC error", LRC: lrcIn.toString(16), calcLRC: calcLrc.toString(16) });
        return null;
      }
      bufDecoded.writeUInt16LE(crc16(bufDecoded.slice(0, -2)), bufDecoded.length - 2);
      return bufDecoded;
    }
    function _checkData(modbus, buf) {
      if (buf.length !== modbus._length && buf.length !== 5) {
        modbusSerialDebug({ action: "length error", recive: buf.length, expected: modbus._length });
        return false;
      }
      return buf[0] === modbus._id && (127 & buf[1]) === modbus._cmd;
    }
    var AsciiPort = function(path3, options) {
      var modbus = this;
      options = options || {};
      this._startOfSlaveFrameChar = options.startOfSlaveFrameChar === void 0 ? 58 : options.startOfSlaveFrameChar;
      options.autoOpen = false;
      this._buffer = Buffer.from("");
      this._id = 0;
      this._cmd = 0;
      this._length = 0;
      this._client = new SerialPort(path3, options);
      this._client.on("data", function(data) {
        modbus._buffer = Buffer.concat([modbus._buffer, data]);
        modbusSerialDebug({ action: "receive serial ascii port", data, buffer: modbus._buffer });
        modbusSerialDebug(JSON.stringify({ action: "receive serial ascii port strings", data, buffer: modbus._buffer }));
        var sdIndex = modbus._buffer.indexOf(modbus._startOfSlaveFrameChar);
        if (sdIndex === -1) {
          modbus._buffer = Buffer.from("");
          return;
        }
        if (sdIndex > 0) {
          modbus._buffer = modbus._buffer.slice(sdIndex);
        }
        if (modbus._buffer.includes("\r\n", 1, "ascii") === true) {
          var edIndex = modbus._buffer.indexOf(10);
          if (edIndex !== modbus._buffer.length - 1) {
            modbus._buffer = modbus._buffer.slice(0, edIndex + 1);
          }
          var _data = _asciiDecodeResponseBuffer(modbus._buffer);
          modbusSerialDebug({ action: "got EOM", data: _data, buffer: modbus._buffer });
          if (_data !== null) {
            if (_checkData(modbus, _data)) {
              modbusSerialDebug({ action: "emit data serial ascii port", data, buffer: modbus._buffer });
              modbusSerialDebug(JSON.stringify({ action: "emit data serial ascii port strings", data, buffer: modbus._buffer }));
              modbus.emit("data", _data);
            }
          }
          modbus._buffer = Buffer.from("");
        } else {
        }
      });
      Object.defineProperty(this, "isOpen", {
        enumerable: true,
        get: function() {
          return this._client.isOpen;
        }
      });
      EventEmitter.call(this);
    };
    util.inherits(AsciiPort, EventEmitter);
    AsciiPort.prototype.open = function(callback) {
      this._client.open(callback);
    };
    AsciiPort.prototype.close = function(callback) {
      this._client.close(callback);
      this.removeAllListeners();
    };
    AsciiPort.prototype.write = function(data) {
      if (data.length < MIN_DATA_LENGTH) {
        modbusSerialDebug("expected length of data is to small - minimum is " + MIN_DATA_LENGTH);
        return;
      }
      var length = null;
      this._id = data[0];
      this._cmd = data[1];
      switch (this._cmd) {
        case 1:
        case 2:
          length = data.readUInt16BE(4);
          this._length = 3 + parseInt((length - 1) / 8 + 1) + 2;
          break;
        case 3:
        case 4:
          length = data.readUInt16BE(4);
          this._length = 3 + 2 * length + 2;
          break;
        case 5:
        case 6:
        case 15:
        case 16:
          this._length = 6 + 2;
          break;
        default:
          modbusSerialDebug({ action: "unknown command", id: this._id.toString(16), command: this._cmd.toString(16) });
          this._length = 0;
          break;
      }
      var _encodedData = _asciiEncodeRequestBuffer(data);
      this._client.write(_encodedData);
      modbusSerialDebug({
        action: "send serial ascii port",
        data: _encodedData,
        unitid: this._id,
        functionCode: this._cmd
      });
      modbusSerialDebug(JSON.stringify({
        action: "send serial ascii port",
        data: _encodedData,
        unitid: this._id,
        functionCode: this._cmd
      }));
    };
    module2.exports = AsciiPort;
  }
});

// node_modules/modbus-serial/apis/connection.js
var require_connection = __commonJS({
  "node_modules/modbus-serial/apis/connection.js"(exports2, module2) {
    "use strict";
    var MIN_MODBUSRTU_FRAMESZ = 5;
    var addConnctionAPI = function(Modbus) {
      var cl = Modbus.prototype;
      var open = function(obj, next) {
        if (next) {
          obj.open(next);
        } else {
          return new Promise(function(resolve2, reject) {
            function cb(err) {
              if (err) {
                reject(err);
              } else {
                resolve2();
              }
            }
            obj.open(cb);
          });
        }
      };
      cl.connectRTU = function(path3, options, next) {
        if (typeof next === "undefined" && typeof options === "function") {
          next = options;
          options = {};
        }
        if (typeof options === "undefined") {
          options = {};
        }
        options.autoOpen = false;
        options.platformOptions = { vmin: MIN_MODBUSRTU_FRAMESZ, vtime: 0 };
        var SerialPort = require_lib13();
        this._port = new SerialPort(path3, options);
        return open(this, next);
      };
      cl.connectTCP = function(ip, options, next) {
        if (typeof next === "undefined" && typeof options === "function") {
          next = options;
          options = {};
        }
        if (typeof options === "undefined") {
          options = {};
        }
        var TcpPort = require_tcpport();
        if (this._timeout) {
          options.timeout = this._timeout;
        }
        this._port = new TcpPort(ip, options);
        return open(this, next);
      };
      cl.linkTCP = function(socket, options, next) {
        if (typeof next === "undefined" && typeof options === "function") {
          next = options;
          options = {};
        }
        if (typeof options === "undefined") {
          options = {};
        }
        options.socket = socket;
        const TcpPort = require_tcpport();
        if (this._timeout) {
          options.timeout = this._timeout;
        }
        this._port = new TcpPort(options);
        return open(this, next);
      };
      cl.connectTcpRTUBuffered = function(ip, options, next) {
        if (typeof next === "undefined" && typeof options === "function") {
          next = options;
          options = {};
        }
        if (typeof options === "undefined") {
          options = {};
        }
        var TcpRTUBufferedPort = require_tcprtubufferedport();
        if (this._timeout) {
          options.timeout = this._timeout;
        }
        this._port = new TcpRTUBufferedPort(ip, options);
        return open(this, next);
      };
      cl.linkTcpRTUBuffered = function(socket, options, next) {
        if (typeof next === "undefined" && typeof options === "function") {
          next = options;
          options = {};
        }
        if (typeof options === "undefined") {
          options = {};
        }
        options.socket = socket;
        const TcpRTUBufferedPort = require_tcprtubufferedport();
        if (this._timeout) {
          options.timeout = this._timeout;
        }
        this._port = new TcpRTUBufferedPort(options);
        return open(this, next);
      };
      cl.connectTelnet = function(ip, options, next) {
        if (typeof next === "undefined" && typeof options === "function") {
          next = options;
          options = {};
        }
        if (typeof options === "undefined") {
          options = {};
        }
        var TelnetPort = require_telnetport();
        if (this._timeout) {
          options.timeout = this._timeout;
        }
        this._port = new TelnetPort(ip, options);
        return open(this, next);
      };
      cl.linkTelnet = function(socket, options, next) {
        if (typeof next === "undefined" && typeof options === "function") {
          next = options;
          options = {};
        }
        if (typeof options === "undefined") {
          options = {};
        }
        options.socket = socket;
        const TelnetPort = require_telnetport();
        if (this._timeout) {
          options.timeout = this._timeout;
        }
        this._port = new TelnetPort(options);
        return open(this, next);
      };
      cl.connectC701 = function(ip, options, next) {
        if (typeof next === "undefined" && typeof options === "function") {
          next = options;
          options = {};
        }
        if (typeof options === "undefined") {
          options = {};
        }
        var C701Port = require_c701port();
        this._port = new C701Port(ip, options);
        return open(this, next);
      };
      cl.connectUDP = function(ip, options, next) {
        if (typeof next === "undefined" && typeof options === "function") {
          next = options;
          options = {};
        }
        if (typeof options === "undefined") {
          options = {};
        }
        var UdpPort = require_udpport();
        this._port = new UdpPort(ip, options);
        return open(this, next);
      };
      cl.connectRTUBuffered = function(path3, options, next) {
        if (typeof next === "undefined" && typeof options === "function") {
          next = options;
          options = {};
        }
        if (typeof options === "undefined") {
          options = {};
        }
        var SerialPort = require_rtubufferedport();
        this._port = new SerialPort(path3, options);
        options.platformOptions = { vmin: MIN_MODBUSRTU_FRAMESZ, vtime: 0 };
        return open(this, next);
      };
      cl.connectAsciiSerial = function(path3, options, next) {
        if (typeof next === "undefined" && typeof options === "function") {
          next = options;
          options = {};
        }
        if (typeof options === "undefined") {
          options = {};
        }
        var SerialPortAscii = require_asciiport();
        this._port = new SerialPortAscii(path3, options);
        return open(this, next);
      };
      cl.connectRTUSocket = function(socket, next) {
        const thisModbus = this;
        this._port = socket;
        this._port.open = function(callback) {
          thisModbus._port.isOpen = true;
          callback();
        };
        return open(this, next);
      };
    };
    module2.exports = addConnctionAPI;
  }
});

// node_modules/modbus-serial/apis/promise.js
var require_promise = __commonJS({
  "node_modules/modbus-serial/apis/promise.js"(exports2, module2) {
    "use strict";
    var _convert = function(f2) {
      var converted = function(address, arg, next) {
        var client2 = this;
        var id = this._unitID;
        if (next) {
          f2.bind(client2)(id, address, arg, next);
        } else {
          var promise = new Promise(function(resolve2, reject) {
            function cb(err, data) {
              if (err) {
                reject(err);
              } else {
                resolve2(data);
              }
            }
            f2.bind(client2)(id, address, arg, cb);
          });
          return promise;
        }
      };
      return converted;
    };
    var addPromiseAPI = function(Modbus) {
      var cl = Modbus.prototype;
      cl.setID = function(id) {
        this._unitID = Number(id);
      };
      cl.getID = function() {
        return this._unitID;
      };
      cl.setTimeout = function(timeout) {
        this._timeout = timeout;
      };
      cl.getTimeout = function() {
        return this._timeout;
      };
      cl.readCoils = _convert(cl.writeFC1);
      cl.readDiscreteInputs = _convert(cl.writeFC2);
      cl.readHoldingRegisters = _convert(cl.writeFC3);
      cl.readInputRegisters = _convert(cl.writeFC4);
      cl.writeCoil = _convert(cl.writeFC5);
      cl.writeRegister = _convert(cl.writeFC6);
      cl.writeCoils = _convert(cl.writeFC15);
      cl.writeRegisters = _convert(cl.writeFC16);
      cl.readFileRecords = _convert(cl.writeFC20);
      cl.readDeviceIdentification = _convert(cl.writeFC43);
    };
    module2.exports = addPromiseAPI;
  }
});

// node_modules/modbus-serial/worker/index.js
var require_worker = __commonJS({
  "node_modules/modbus-serial/worker/index.js"(exports2, module2) {
    "use strict";
    function getByteLength(type) {
      switch (String(type).toLowerCase()) {
        case "int16":
        case "uint16":
          return 2;
        case "int32":
        case "uint32":
        case "float":
          return 4;
        default:
          throw new Error("Unsupported type");
      }
    }
    function send2({ fc, unit, address, arg }) {
      this._port.setID(unit);
      switch (fc) {
        case 1:
          return this._port.readCoils(address, arg);
        case 2:
          return this._port.readDiscreteInputs(address, arg);
        case 3:
          return this._port.readHoldingRegisters(address, arg);
        case 4:
          return this._port.readInputRegisters(address, arg);
        case 5:
          return this._port.writeCoil(address, arg);
        case 6:
          return this._port.writeRegister(address, arg);
        case 15:
          return this._port.writeCoils(address, arg);
        case 16:
          return this._port.writeRegisters(address, arg);
      }
      return Promise.reject(new Error("Unknown fc code"));
    }
    var Worker = function(port2, options) {
      if (typeof options === "undefined")
        options = {};
      this.maxConcurrentRequests = 1;
      this.debug = false;
      this._port = port2;
      this._queue = [];
      this._scheduled = [];
      this._running = /* @__PURE__ */ new Map();
      this._nextId = 0;
      this.setOptions(options);
    };
    Worker.prototype.setOptions = function({ maxConcurrentRequests, debug }) {
      if (maxConcurrentRequests > 0) {
        this.maxConcurrentRequests = maxConcurrentRequests;
      }
      if (debug !== void 0) {
        this.debug = Boolean(debug);
      }
    };
    Worker.prototype.log = function(...args) {
      if (this.debug === true) {
        args.unshift(/* @__PURE__ */ new Date());
        console.log(...args);
      }
    };
    Worker.prototype.emit = function(name, data) {
      this._port.emit(name, data);
    };
    Worker.prototype.bufferize = function(data, type) {
      if (Array.isArray(data) === false) {
        data = [data];
      }
      const quantity = data.length;
      const byteLength = getByteLength(type);
      const size = quantity * byteLength;
      const buffer = Buffer.alloc(size);
      for (let i = 0; i < quantity; i++) {
        if (type === "int16") {
          buffer.writeInt16BE(data[i], i * byteLength);
        } else if (type === "uint16") {
          buffer.writeUInt16BE(data[i], i * byteLength);
        } else if (type === "int32") {
          buffer.writeInt32BE(data[i], i * byteLength);
        } else if (type === "uint32") {
          buffer.writeUInt32BE(data[i], i * byteLength);
        } else if (type === "float") {
          buffer.writeFloatBE(data[i], i * byteLength);
        }
      }
      return buffer;
    };
    Worker.prototype.unbufferize = function(buffer, type) {
      const byteLength = getByteLength(type);
      const quantity = buffer.length / byteLength;
      const data = [];
      for (let i = 0; i < quantity; i++) {
        if (type === "int16") {
          data.push(buffer.readInt16BE(i * byteLength));
        } else if (type === "uint16") {
          data.push(buffer.readUInt16BE(i * byteLength));
        } else if (type === "int32") {
          data.push(buffer.readInt32BE(i * byteLength));
        } else if (type === "uint32") {
          data.push(buffer.readUInt32BE(i * byteLength));
        } else if (type === "float") {
          data.push(buffer.readFloatBE(i * byteLength));
        }
      }
      return data;
    };
    Worker.prototype.nextId = function() {
      this._nextId = this._nextId + 1;
      if (this._nextId > 9999) {
        this._nextId = 1;
      }
      return this._nextId;
    };
    Worker.prototype.send = function({ fc, unit, address, value, quantity, arg, type }) {
      const promise = new Promise((resolve2, reject) => {
        arg = arg || quantity || value;
        if (fc === 1 || fc === 2) {
          arg = arg || 1;
        }
        if (fc === 3 || fc === 4) {
          type = type || "int16";
          arg = (arg || 1) * getByteLength(type) / 2;
        }
        if (fc === 6 || fc === 16) {
          type = type || "int16";
          arg = this.bufferize(arg, type);
          if (fc === 6 && arg.length > 2) {
            fc = 16;
          }
        }
        if (fc === 5 && arg instanceof Array && arg.length > 1) {
          fc = 15;
        }
        const id = this.nextId();
        this.log("queue push", `#${id}`, fc, unit, address, arg, type);
        this._queue.push({ id, fc, unit, address, arg, type, resolve: resolve2, reject });
      });
      this.process();
      return promise;
    };
    Worker.prototype.process = function() {
      if (this._port.isOpen === false) {
        this._queue = [];
        this._scheduled = [];
        this._running = /* @__PURE__ */ new Map();
        this._nextId = 0;
        return;
      }
      setTimeout(() => this.run(), 1);
    };
    Worker.prototype.run = function() {
      if (this._running.size >= this.maxConcurrentRequests) {
        return;
      }
      let request = this._queue.shift();
      if (!request) {
        request = this._scheduled.shift();
      }
      if (!request) {
        return;
      }
      if (typeof request.checkBeforeQueuing === "function") {
        if (request.checkBeforeQueuing() === false) {
          return this.process();
        }
      }
      this._running.set(request.id, request);
      this.log("send", JSON.stringify(request));
      this.emit("request", { request });
      send2.apply(this, [request]).then((response) => {
        let data = [];
        if (request.fc === 1 || request.fc === 2) {
          for (let i = 0; i < request.arg; i++) {
            data.push(Boolean(response.data[i]));
          }
        } else if (request.fc === 3 || request.fc === 4) {
          data = this.unbufferize(response.buffer, request.type);
        } else if (request.arg instanceof Array) {
          data = request.arg;
        } else if (request.arg instanceof Buffer && request.type) {
          data = this.unbufferize(request.arg, request.type);
        } else {
          data.push(request.arg);
        }
        this._running.delete(request.id);
        this.emit("response", { request, response: data });
        request.resolve(data);
        this.process();
      }).catch((error) => {
        this._running.delete(request.id);
        error.request = request;
        this.emit("failed", error);
        request.reject(error);
        this.process();
      });
      this.process();
    };
    Worker.prototype._poll_send = function(result2, { i, fc, unit, address, arg, items, length, type }, { skipErrors }) {
      const promise = new Promise((res, rej) => {
        const id = this.nextId();
        this.log("scheduled push", "poll #" + result2.id, "req #" + i, "#" + id, fc, length, type);
        const resolve2 = function(response) {
          const data = items.map((address2, index) => ({ address: address2, value: response[index] }));
          result2._req += 1;
          result2.done += 1;
          result2.data = [...result2.data, ...data];
          res(data);
        };
        const reject = function(error) {
          result2._req += 1;
          result2.error = error;
          rej(error);
        };
        const checkBeforeQueuing = function() {
          return result2.error === null || skipErrors === true;
        };
        this._scheduled.push({ id, i, fc, unit, address, arg, items, length, type, result: result2, checkBeforeQueuing, resolve: resolve2, reject });
      });
      this.process();
      return promise;
    };
    Worker.prototype.poll = function({ unit, map, onProgress, maxChunkSize, skipErrors, defaultType }) {
      maxChunkSize = maxChunkSize || 32;
      skipErrors = Boolean(skipErrors);
      defaultType = defaultType || "int16";
      if (unit < 1 || unit > 250 || isNaN(unit) || unit === void 0) {
        throw new Error("invalid unit");
      }
      this.log("poll", `unit=${unit}`, "map size=" + Object.keys(map).length, `maxChunkSize=${maxChunkSize}`, `skipErrors=${skipErrors}`);
      const result2 = {
        id: this.nextId(),
        unit,
        total: 0,
        done: 0,
        data: [],
        error: null,
        dt: Date.now(),
        _req: 0
      };
      const registers = [];
      map.forEach(({ fc, address, type }) => {
        fc = parseInt(fc);
        if (fc === 3 || fc === 4) {
          type = type || defaultType;
        } else if (fc === 1 || fc === 2) {
          type = "bool";
        } else {
          throw new Error("unsupported fc");
        }
        if (address instanceof Array) {
          address.forEach((item) => {
            registers.push({ fc, address: parseInt(item), type: type || null });
          });
        } else {
          address = parseInt(address);
          registers.push({ fc, address, type: type || null });
        }
      });
      registers.sort((a, b) => {
        if (a.fc === b.fc) {
          return a.address - b.address;
        }
        return a.fc - b.fc;
      });
      const requests = registers.reduce(function(chunks, register, i, arr) {
        let chunk = 0;
        if (chunks.length) {
          chunk = chunks.length - 1;
        }
        if (i > 0) {
          const lastRegister = arr[i - 1];
          if (lastRegister.fc !== register.fc) {
            chunk += 1;
          } else if (lastRegister.type !== register.type) {
            chunk += 1;
          } else if ([3, 4].indexOf(register.fc) >= 0 && register.address - lastRegister.address !== getByteLength(register.type) / 2) {
            chunk += 1;
          } else if (chunks[chunk].items.length >= maxChunkSize) {
            chunk += 1;
          }
        }
        if (chunks[chunk] === void 0) {
          chunks[chunk] = {
            fc: register.fc,
            items: [],
            length: 0,
            type: register.type
          };
        }
        chunks[chunk].items.push(register.address);
        if ([3, 4].indexOf(register.fc) >= 0) {
          chunks[chunk].length += getByteLength(register.type) / 2;
        } else {
          chunks[chunk].length += 1;
        }
        return chunks;
      }, []);
      result2.total = requests.length;
      return new Promise((resolve2) => {
        const check = function() {
          if (result2._req === result2.total) {
            result2.dt = Date.now() - result2.dt;
            resolve2(result2);
          } else if (result2.error && skipErrors !== true) {
            result2.dt = Date.now() - result2.dt;
            resolve2(result2);
          }
        };
        for (let i = 0; i < requests.length; i++) {
          const { fc, items, length, type } = requests[i];
          this._poll_send(result2, { i, unit, fc, address: parseInt(items[0]), items, arg: length, length, type }, {
            skipErrors
          }).then((data) => {
            if (typeof onProgress === "function") {
              onProgress(result2.done / result2.total, data);
            }
            check();
          }).catch(() => check());
        }
      });
    };
    module2.exports = Worker;
  }
});

// node_modules/modbus-serial/apis/worker.js
var require_worker2 = __commonJS({
  "node_modules/modbus-serial/apis/worker.js"(exports2, module2) {
    var Worker = require_worker();
    module2.exports = function(Modbus) {
      const cl = Modbus.prototype;
      cl.setWorkerOptions = function(options) {
        if (this._worker) {
          this._worker.setOptions(options);
        } else {
          this._worker = new Worker(this, options);
        }
      };
      cl.send = function(request) {
        if (!this._worker) {
          this._worker = new Worker(this);
        }
        return this._worker.send(request);
      };
      cl.poll = function(options) {
        if (!this._worker) {
          this._worker = new Worker(this);
        }
        return this._worker.poll(options);
      };
    };
  }
});

// node_modules/modbus-serial/ports/testport.js
var require_testport = __commonJS({
  "node_modules/modbus-serial/ports/testport.js"(exports2, module2) {
    "use strict";
    var util = require("util");
    var events = require("events");
    var EventEmitter = events.EventEmitter || events;
    var modbusSerialDebug = require_src()("modbus-serial");
    require_buffer_bit()();
    var crc16 = require_crc16();
    var MIN_DATA_LENGTH = 7;
    var TestPort = function() {
      this._registers = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
      this._holding_registers = [0, 0, 0, 0, 0, 0, 0, 0, 41259, 65535, 45594];
      this._coils = 0;
      Object.defineProperty(this, "isOpen", {
        enumerable: true,
        get: function() {
          return true;
        }
      });
      EventEmitter.call(this);
    };
    util.inherits(TestPort, EventEmitter);
    TestPort.prototype.open = function(callback) {
      if (callback)
        callback(null);
    };
    TestPort.prototype.close = function(callback) {
      if (callback)
        callback(null);
    };
    TestPort.prototype.write = function(data) {
      var buffer = null;
      var length = null;
      var address = null;
      var value = null;
      var state = null;
      var i = null;
      if (data.length < MIN_DATA_LENGTH) {
        modbusSerialDebug("expected length of data is to small - minimum is " + MIN_DATA_LENGTH);
        return;
      }
      var unitNumber = data[0];
      var functionCode = data[1];
      var crc = data[data.length - 2] + data[data.length - 1] * 256;
      if (crc !== crc16(data.slice(0, -2))) {
        return;
      }
      if (functionCode === 1 || functionCode === 2) {
        address = data.readUInt16BE(2);
        length = data.readUInt16BE(4);
        if (data.length !== 8) {
          return;
        }
        buffer = Buffer.alloc(3 + parseInt((length - 1) / 8 + 1) + 2);
        buffer.writeUInt8(parseInt((length - 1) / 8 + 1), 2);
        buffer.writeUInt16LE(this._coils >> address, 3);
      }
      if (functionCode === 3) {
        address = data.readUInt16BE(2);
        length = data.readUInt16BE(4);
        if (data.length !== 8) {
          return;
        }
        buffer = Buffer.alloc(3 + length * 2 + 2);
        buffer.writeUInt8(length * 2, 2);
        for (i = 0; i < length; i++) {
          buffer.writeUInt16BE(this._holding_registers[address + i], 3 + i * 2);
        }
      }
      if (functionCode === 4) {
        address = data.readUInt16BE(2);
        length = data.readUInt16BE(4);
        if (data.length !== 8) {
          return;
        }
        buffer = Buffer.alloc(3 + length * 2 + 2);
        buffer.writeUInt8(length * 2, 2);
        for (i = 0; i < length; i++) {
          buffer.writeUInt16BE(this._registers[address + i], 3 + i * 2);
        }
      }
      if (functionCode === 5) {
        address = data.readUInt16BE(2);
        state = data.readUInt16BE(4);
        if (data.length !== 8) {
          return;
        }
        buffer = Buffer.alloc(8);
        buffer.writeUInt16BE(address, 2);
        buffer.writeUInt16BE(state, 4);
        if (state === 65280) {
          this._coils |= 1 << address;
        } else {
          this._coils &= ~(1 << address);
        }
      }
      if (functionCode === 6) {
        address = data.readUInt16BE(2);
        value = data.readUInt16BE(4);
        if (data.length !== 6 + 2) {
          return;
        }
        buffer = Buffer.alloc(8);
        buffer.writeUInt16BE(address, 2);
        buffer.writeUInt16BE(value, 4);
        this._holding_registers[address] = value;
      }
      if (functionCode === 15) {
        address = data.readUInt16BE(2);
        length = data.readUInt16BE(4);
        if (data.length !== 7 + Math.ceil(length / 8) + 2) {
          return;
        }
        buffer = Buffer.alloc(8);
        buffer.writeUInt16BE(address, 2);
        buffer.writeUInt16BE(length, 4);
        for (i = 0; i < length; i++) {
          state = data.readBit(i, 7);
          if (state) {
            this._coils |= 1 << address + i;
          } else {
            this._coils &= ~(1 << address + i);
          }
        }
      }
      if (functionCode === 16) {
        address = data.readUInt16BE(2);
        length = data.readUInt16BE(4);
        if (data.length !== 7 + length * 2 + 2) {
          return;
        }
        buffer = Buffer.alloc(8);
        buffer.writeUInt16BE(address, 2);
        buffer.writeUInt16BE(length, 4);
        for (i = 0; i < length; i++) {
          this._holding_registers[address + i] = data.readUInt16BE(7 + i * 2);
        }
      }
      if (functionCode === 43) {
        const productCode = "MyProductCode1234";
        buffer = Buffer.alloc(12 + productCode.length);
        buffer.writeUInt8(16, 2);
        buffer.writeUInt8(data.readInt8(3), 3);
        buffer.writeUInt8(1, 4);
        buffer.writeUInt8(0, 5);
        buffer.writeUInt8(0, 6);
        buffer.writeUInt8(1, 7);
        buffer.writeUInt8(data.readInt8(4), 8);
        buffer.writeUInt8(productCode.length, 9);
        buffer.write(productCode, 10, productCode.length, "ascii");
      }
      if (buffer) {
        buffer.writeUInt8(unitNumber, 0);
        buffer.writeUInt8(functionCode, 1);
        switch (unitNumber) {
          case 1:
            break;
          case 2:
            buffer = buffer.slice(0, buffer.length - 5);
            break;
          case 4:
            buffer[0] = unitNumber + 2;
            break;
          case 5:
            buffer.writeUInt8(functionCode + 128, 1);
            buffer.writeUInt8(4, 2);
            buffer = buffer.slice(0, 5);
            break;
          case 6:
            return;
        }
        crc = crc16(buffer.slice(0, -2));
        buffer.writeUInt16LE(crc, buffer.length - 2);
        if (unitNumber === 3) {
          buffer.writeUInt16LE(crc + 1, buffer.length - 2);
        }
        this.emit("data", buffer);
        modbusSerialDebug({
          action: "send test port",
          data,
          buffer,
          unitid: unitNumber,
          functionCode
        });
        modbusSerialDebug(JSON.stringify({
          action: "send test port strings",
          data,
          buffer,
          unitid: unitNumber,
          functionCode
        }));
      }
    };
    module2.exports = TestPort;
  }
});

// node_modules/modbus-serial/package.json
var require_package = __commonJS({
  "node_modules/modbus-serial/package.json"(exports2, module2) {
    module2.exports = {
      name: "modbus-serial",
      version: "8.0.5",
      description: "A pure JavaScript implemetation of MODBUS-RTU (Serial and TCP) for NodeJS.",
      main: "index.js",
      scripts: {
        test: "mocha --recursive"
      },
      repository: {
        type: "git",
        url: "git+https://github.com/yaacov/node-modbus-serial.git"
      },
      keywords: [
        "modbus",
        "rtu",
        "serial",
        "port",
        "com",
        "arduino"
      ],
      author: "Yaacov Zamir <kobi.zamir@gmail.com>",
      license: "ISC",
      bugs: {
        url: "https://github.com/yaacov/node-modbus-serial/issues"
      },
      homepage: "https://github.com/yaacov/node-modbus-serial#readme",
      devDependencies: {
        chai: "^4.2.0",
        eslint: "^6.5.1",
        gulp: "^4.0.2",
        "gulp-clean": "^0.4.0",
        "gulp-jsdoc3": "^2.0.0",
        mocha: "^6.2.1",
        "mocha-eslint": "^5.0.0",
        mockery: "^2.1.0",
        pump: "^3.0.0",
        sinon: "^7.5.0"
      },
      dependencies: {
        debug: "^4.1.1",
        serialport: "^9.0.0"
      }
    };
  }
});

// node_modules/modbus-serial/servers/servertcp_handler.js
var require_servertcp_handler = __commonJS({
  "node_modules/modbus-serial/servers/servertcp_handler.js"(exports2, module2) {
    "use strict";
    var modbusSerialDebug = require_src()("modbus-serial");
    function _errorRequestBufferLength(requestBuffer) {
      if (requestBuffer.length !== 8) {
        modbusSerialDebug("request Buffer length " + requestBuffer.length + " is wrong - has to be >= 8");
        return true;
      }
      return false;
    }
    function _handlePromiseOrValue(promiseOrValue, cb) {
      if (promiseOrValue && promiseOrValue.then && typeof promiseOrValue.then === "function") {
        promiseOrValue.then(function(value) {
          cb(null, value);
        }).catch(function(err) {
          cb(err);
        });
      } else {
        cb(null, promiseOrValue);
      }
    }
    function _handleReadCoilsOrInputDiscretes(requestBuffer, vector, unitID, callback, fc) {
      var address = requestBuffer.readUInt16BE(2);
      var length = requestBuffer.readUInt16BE(4);
      if (_errorRequestBufferLength(requestBuffer)) {
        return;
      }
      var dataBytes = parseInt((length - 1) / 8 + 1);
      var responseBuffer = Buffer.alloc(3 + dataBytes + 2);
      try {
        responseBuffer.writeUInt8(dataBytes, 2);
      } catch (err) {
        callback(err);
        return;
      }
      var isGetCoil = fc === 1 && vector.getCoil;
      var isGetDiscreteInpupt = fc === 2 && vector.getDiscreteInput;
      if (isGetCoil || isGetDiscreteInpupt) {
        var callbackInvoked = false;
        var cbCount = 0;
        var buildCb = function(i2) {
          return function(err, value) {
            if (err) {
              if (!callbackInvoked) {
                callbackInvoked = true;
                callback(err);
              }
              return;
            }
            cbCount = cbCount + 1;
            responseBuffer.writeBit(value, i2 % 8, 3 + parseInt(i2 / 8));
            if (cbCount === length && !callbackInvoked) {
              modbusSerialDebug({ action: "FC" + fc + " response", responseBuffer });
              callbackInvoked = true;
              callback(null, responseBuffer);
            }
          };
        };
        if (length === 0)
          callback({
            modbusErrorCode: 2,
            // Illegal address
            msg: "Invalid length"
          });
        var i = 0;
        var cb = null;
        var promiseOrValue = null;
        if (isGetCoil && vector.getCoil.length === 3) {
          for (i = 0; i < length; i++) {
            cb = buildCb(i);
            try {
              vector.getCoil(address + i, unitID, cb);
            } catch (err) {
              cb(err);
            }
          }
        } else if (isGetDiscreteInpupt && vector.getDiscreteInput.length === 3) {
          for (i = 0; i < length; i++) {
            cb = buildCb(i);
            try {
              vector.getDiscreteInput(address + i, unitID, cb);
            } catch (err) {
              cb(err);
            }
          }
        } else if (isGetCoil) {
          for (i = 0; i < length; i++) {
            cb = buildCb(i);
            try {
              promiseOrValue = vector.getCoil(address + i, unitID);
              _handlePromiseOrValue(promiseOrValue, cb);
            } catch (err) {
              cb(err);
            }
          }
        } else if (isGetDiscreteInpupt) {
          for (i = 0; i < length; i++) {
            cb = buildCb(i);
            try {
              promiseOrValue = vector.getDiscreteInput(address + i, unitID);
              _handlePromiseOrValue(promiseOrValue, cb);
            } catch (err) {
              cb(err);
            }
          }
        }
      }
    }
    function _handleReadMultipleRegisters(requestBuffer, vector, unitID, callback) {
      var address = requestBuffer.readUInt16BE(2);
      var length = requestBuffer.readUInt16BE(4);
      if (_errorRequestBufferLength(requestBuffer)) {
        return;
      }
      var responseBuffer = Buffer.alloc(3 + length * 2 + 2);
      try {
        responseBuffer.writeUInt8(length * 2, 2);
      } catch (err) {
        callback(err);
        return;
      }
      var callbackInvoked = false;
      var cbCount = 0;
      var buildCb = function(i2) {
        return function(err, value) {
          if (err) {
            if (!callbackInvoked) {
              callbackInvoked = true;
              callback(err);
            }
            return;
          }
          cbCount = cbCount + 1;
          responseBuffer.writeUInt16BE(value, 3 + i2 * 2);
          if (cbCount === length && !callbackInvoked) {
            modbusSerialDebug({ action: "FC3 response", responseBuffer });
            callbackInvoked = true;
            callback(null, responseBuffer);
          }
        };
      };
      if (length === 0)
        callback({
          modbusErrorCode: 2,
          // Illegal address
          msg: "Invalid length"
        });
      function tryAndHandlePromiseOrValue(i2, values2) {
        var cb2 = buildCb(i2);
        try {
          var promiseOrValue2 = values2[i2];
          _handlePromiseOrValue(promiseOrValue2, cb2);
        } catch (err) {
          cb2(err);
        }
      }
      if (vector.getMultipleHoldingRegisters && length > 1) {
        if (vector.getMultipleHoldingRegisters.length === 4) {
          vector.getMultipleHoldingRegisters(address, length, unitID, function(err, values2) {
            if (!err && values2.length !== length) {
              var error2 = new Error("Requested address length and response length do not match");
              callback(error2);
            } else if (err) {
              const cb2 = buildCb(i2);
              try {
                cb2(err);
              } catch (ex) {
                cb2(ex);
              }
            } else {
              for (var i2 = 0; i2 < length; i2++) {
                const cb2 = buildCb(i2);
                try {
                  cb2(err, values2[i2]);
                } catch (ex) {
                  cb2(ex);
                }
              }
            }
          });
        } else {
          var values = vector.getMultipleHoldingRegisters(address, length, unitID);
          if (values.length === length) {
            for (i = 0; i < length; i++) {
              tryAndHandlePromiseOrValue(i, values);
            }
          } else {
            var error = new Error("Requested address length and response length do not match");
            callback(error);
          }
        }
      } else if (vector.getHoldingRegister) {
        for (var i = 0; i < length; i++) {
          var cb = buildCb(i);
          try {
            if (vector.getHoldingRegister.length === 3) {
              vector.getHoldingRegister(address + i, unitID, cb);
            } else {
              var promiseOrValue = vector.getHoldingRegister(address + i, unitID);
              _handlePromiseOrValue(promiseOrValue, cb);
            }
          } catch (err) {
            cb(err);
          }
        }
      }
    }
    function _handleReadInputRegisters(requestBuffer, vector, unitID, callback) {
      var address = requestBuffer.readUInt16BE(2);
      var length = requestBuffer.readUInt16BE(4);
      if (_errorRequestBufferLength(requestBuffer)) {
        return;
      }
      var responseBuffer = Buffer.alloc(3 + length * 2 + 2);
      try {
        responseBuffer.writeUInt8(length * 2, 2);
      } catch (err) {
        callback(err);
        return;
      }
      var callbackInvoked = false;
      var cbCount = 0;
      var buildCb = function(i2) {
        return function(err, value) {
          if (err) {
            if (!callbackInvoked) {
              callbackInvoked = true;
              callback(err);
            }
            return;
          }
          cbCount = cbCount + 1;
          responseBuffer.writeUInt16BE(value, 3 + i2 * 2);
          if (cbCount === length && !callbackInvoked) {
            modbusSerialDebug({ action: "FC4 response", responseBuffer });
            callbackInvoked = true;
            callback(null, responseBuffer);
          }
        };
      };
      if (length === 0)
        callback({
          modbusErrorCode: 2,
          // Illegal address
          msg: "Invalid length"
        });
      function tryAndHandlePromiseOrValues(i2, values2) {
        var cb2 = buildCb(i2);
        try {
          var promiseOrValue2 = values2[i2];
          _handlePromiseOrValue(promiseOrValue2, cb2);
        } catch (err) {
          cb2(err);
        }
      }
      if (vector.getMultipleInputRegisters && length > 1) {
        if (vector.getMultipleInputRegisters.length === 4) {
          vector.getMultipleInputRegisters(address, length, unitID, function(err, values2) {
            if (!err && values2.length !== length) {
              var error2 = new Error("Requested address length and response length do not match");
              callback(error2);
            } else {
              for (var i2 = 0; i2 < length; i2++) {
                var cb2 = buildCb(i2);
                try {
                  cb2(err, values2[i2]);
                } catch (ex) {
                  cb2(ex);
                }
              }
            }
          });
        } else {
          var values = vector.getMultipleInputRegisters(address, length, unitID);
          if (values.length === length) {
            for (var i = 0; i < length; i++) {
              tryAndHandlePromiseOrValues(i, values);
            }
          } else {
            var error = new Error("Requested address length and response length do not match");
            callback(error);
          }
        }
      } else if (vector.getInputRegister) {
        for (i = 0; i < length; i++) {
          var cb = buildCb(i);
          try {
            if (vector.getInputRegister.length === 3) {
              vector.getInputRegister(address + i, unitID, cb);
            } else {
              var promiseOrValue = vector.getInputRegister(address + i, unitID);
              _handlePromiseOrValue(promiseOrValue, cb);
            }
          } catch (ex) {
            cb(ex);
          }
        }
      }
    }
    function _handleWriteCoil(requestBuffer, vector, unitID, callback) {
      var address = requestBuffer.readUInt16BE(2);
      var state = requestBuffer.readUInt16BE(4);
      if (_errorRequestBufferLength(requestBuffer)) {
        return;
      }
      var responseBuffer = Buffer.alloc(8);
      responseBuffer.writeUInt16BE(address, 2);
      responseBuffer.writeUInt16BE(state, 4);
      if (vector.setCoil) {
        var callbackInvoked = false;
        var cb = function(err) {
          if (err) {
            if (!callbackInvoked) {
              callbackInvoked = true;
              callback(err);
            }
            return;
          }
          if (!callbackInvoked) {
            modbusSerialDebug({ action: "FC5 response", responseBuffer });
            callbackInvoked = true;
            callback(null, responseBuffer);
          }
        };
        try {
          if (vector.setCoil.length === 4) {
            vector.setCoil(address, state === 65280, unitID, cb);
          } else {
            var promiseOrValue = vector.setCoil(address, state === 65280, unitID);
            _handlePromiseOrValue(promiseOrValue, cb);
          }
        } catch (err) {
          cb(err);
        }
      }
    }
    function _handleWriteSingleRegister(requestBuffer, vector, unitID, callback) {
      var address = requestBuffer.readUInt16BE(2);
      var value = requestBuffer.readUInt16BE(4);
      if (_errorRequestBufferLength(requestBuffer)) {
        return;
      }
      var responseBuffer = Buffer.alloc(8);
      responseBuffer.writeUInt16BE(address, 2);
      responseBuffer.writeUInt16BE(value, 4);
      if (vector.setRegister) {
        var callbackInvoked = false;
        var cb = function(err) {
          if (err) {
            if (!callbackInvoked) {
              callbackInvoked = true;
              callback(err);
            }
            return;
          }
          if (!callbackInvoked) {
            modbusSerialDebug({ action: "FC6 response", responseBuffer });
            callbackInvoked = true;
            callback(null, responseBuffer);
          }
        };
        try {
          if (vector.setRegister.length === 4) {
            vector.setRegister(address, value, unitID, cb);
          } else {
            var promiseOrValue = vector.setRegister(address, value, unitID);
            _handlePromiseOrValue(promiseOrValue, cb);
          }
        } catch (err) {
          cb(err);
        }
      }
    }
    function _handleForceMultipleCoils(requestBuffer, vector, unitID, callback) {
      var address = requestBuffer.readUInt16BE(2);
      var length = requestBuffer.readUInt16BE(4);
      if (requestBuffer.length !== 7 + Math.ceil(length / 8) + 2) {
        return;
      }
      var responseBuffer = Buffer.alloc(8);
      responseBuffer.writeUInt16BE(address, 2);
      responseBuffer.writeUInt16BE(length, 4);
      var callbackInvoked = false;
      var cbCount = 0;
      var buildCb = function() {
        return function(err) {
          if (err) {
            if (!callbackInvoked) {
              callbackInvoked = true;
              callback(err);
            }
            return;
          }
          cbCount = cbCount + 1;
          if (cbCount === length && !callbackInvoked) {
            modbusSerialDebug({ action: "FC15 response", responseBuffer });
            callbackInvoked = true;
            callback(null, responseBuffer);
          }
        };
      };
      if (length === 0)
        callback({
          modbusErrorCode: 2,
          // Illegal address
          msg: "Invalid length"
        });
      if (vector.setCoilArray) {
        var state = [];
        for (i = 0; i < length; i++) {
          cb = buildCb(i);
          state.push(requestBuffer.readBit(i, 7));
          _handlePromiseOrValue(promiseOrValue, cb);
        }
        try {
          if (vector.setCoilArray.length === 4) {
            vector.setCoilArray(address, state, unitID, cb);
          } else {
            vector.setCoilArray(address, state, unitID);
          }
        } catch (err) {
          cb(err);
        }
      } else if (vector.setCoil) {
        let state2;
        for (var i = 0; i < length; i++) {
          var cb = buildCb(i);
          state2 = requestBuffer.readBit(i, 7);
          try {
            if (vector.setCoil.length === 4) {
              vector.setCoil(address + i, state2 !== false, unitID, cb);
            } else {
              var promiseOrValue = vector.setCoil(address + i, state2 !== false, unitID);
              _handlePromiseOrValue(promiseOrValue, cb);
            }
          } catch (err) {
            cb(err);
          }
        }
      }
    }
    function _handleWriteMultipleRegisters(requestBuffer, vector, unitID, callback) {
      var address = requestBuffer.readUInt16BE(2);
      var length = requestBuffer.readUInt16BE(4);
      if (requestBuffer.length !== 7 + length * 2 + 2) {
        return;
      }
      var responseBuffer = Buffer.alloc(8);
      responseBuffer.writeUInt16BE(address, 2);
      responseBuffer.writeUInt16BE(length, 4);
      var callbackInvoked = false;
      var cbCount = 0;
      var buildCb = function() {
        return function(err) {
          if (err) {
            if (!callbackInvoked) {
              callbackInvoked = true;
              callback(err);
            }
            return;
          }
          cbCount = cbCount + 1;
          if (cbCount === length && !callbackInvoked) {
            modbusSerialDebug({ action: "FC16 response", responseBuffer });
            callbackInvoked = true;
            callback(null, responseBuffer);
          }
        };
      };
      if (length === 0)
        callback({
          modbusErrorCode: 2,
          // Illegal address
          msg: "Invalid length"
        });
      if (vector.setRegisterArray) {
        value = [];
        for (i = 0; i < length; i++) {
          cb = buildCb(i);
          value.push(requestBuffer.readUInt16BE(7 + i * 2));
          _handlePromiseOrValue(value, cb);
        }
        try {
          if (vector.setRegisterArray.length === 4) {
            vector.setRegisterArray(address, value, unitID, cb);
          } else {
            vector.setRegisterArray(address, value, unitID);
          }
        } catch (err) {
          cb(err);
        }
      } else if (vector.setRegister) {
        var value;
        for (var i = 0; i < length; i++) {
          var cb = buildCb(i);
          value = requestBuffer.readUInt16BE(7 + i * 2);
          try {
            if (vector.setRegister.length === 4) {
              vector.setRegister(address + i, value, unitID, cb);
            } else {
              var promiseOrValue = vector.setRegister(address + i, value, unitID);
              _handlePromiseOrValue(promiseOrValue, cb);
            }
          } catch (err) {
            cb(err);
          }
        }
      }
    }
    function _handleMEI(requestBuffer, vector, unitID, callback) {
      var MEIType = requestBuffer[2];
      switch (parseInt(MEIType)) {
        case 14:
          _handleReadDeviceIdentification(requestBuffer, vector, unitID, callback);
          break;
        default:
          callback({ modbusErrorCode: 1 });
      }
    }
    function _handleReadDeviceIdentification(requestBuffer, vector, unitID, callback) {
      const PDULenMax = 253;
      const MEI14HeaderLen = 6;
      const stringLengthMax = PDULenMax - MEI14HeaderLen - 2;
      if (!vector.readDeviceIdentification) {
        callback({ modbusErrorCode: 1 });
        return;
      }
      var readDeviceIDCode = requestBuffer.readUInt8(3);
      var objectID = requestBuffer.readUInt8(4);
      switch (readDeviceIDCode) {
        case 1:
          if (objectID > 2 || objectID > 6 && objectID < 128)
            objectID = 0;
          break;
        case 2:
          if (objectID >= 128 || objectID > 6 && objectID < 128)
            objectID = 0;
          break;
        case 3:
          if (objectID > 6 && objectID < 128)
            objectID = 0;
          break;
        case 4:
          if (objectID > 6 && objectID < 128) {
            callback({ modbusErrorCode: 2 });
            return;
          }
          break;
        default:
          callback({ modbusErrorCode: 3 });
          return;
      }
      var objects = {
        0: "undefined",
        1: "undefined",
        2: "undefined"
      };
      const pkg = require_package();
      if (pkg) {
        if (pkg.author)
          objects[0] = pkg.author;
        if (pkg.name)
          objects[1] = pkg.name;
        if (pkg.version)
          objects[2] = pkg.version;
      }
      var promiseOrValue = vector.readDeviceIdentification(unitID);
      _handlePromiseOrValue(promiseOrValue, function(err, value) {
        if (err) {
          callback(err);
          return;
        }
        var userObjects = value;
        for (var o2 of Object.keys(userObjects)) {
          const i2 = parseInt(o2);
          if (!isNaN(i2) && i2 >= 0 && i2 <= 255)
            objects[i2] = userObjects[o2];
        }
        if (!objects[objectID]) {
          if (readDeviceIDCode === 4) {
            callback({ modbusErrorCode: 2 });
            return;
          }
          objectID = 0;
        }
        var ids = [];
        var totalLength = 2 + MEI14HeaderLen + 2;
        var lastID = 0;
        var conformityLevel = 129;
        var supportedIDs = Object.keys(objects);
        for (var id of supportedIDs) {
          id = parseInt(id);
          if (isNaN(id))
            continue;
          if (id < 0 || id > 6 && id < 128 || id > 255) {
            callback({ modbusErrorCode: 4, msg: "Invalid Object ID provided for Read Device Identification: " + id });
          }
          if (id > 2)
            conformityLevel = 130;
          if (id > 128)
            conformityLevel = 131;
          if (objectID > id)
            continue;
          if (objects[id].length > stringLengthMax) {
            callback({
              modbusErrorCode: 4,
              msg: "Read Device Identification string size can be maximum " + stringLengthMax
            });
          }
          if (lastID !== 0)
            continue;
          if (objects[id].length + 2 > PDULenMax - totalLength) {
            if (lastID === 0)
              lastID = id;
          } else {
            totalLength += objects[id].length + 2;
            ids.push(id);
            if (readDeviceIDCode === 4)
              break;
          }
        }
        ids.sort((a, b) => parseInt(a) - parseInt(b));
        var responseBuffer = Buffer.alloc(totalLength);
        var i = 2;
        i = responseBuffer.writeUInt8(14, i);
        i = responseBuffer.writeUInt8(readDeviceIDCode, i);
        i = responseBuffer.writeUInt8(conformityLevel, i);
        if (lastID === 0)
          i = responseBuffer.writeUInt8(0, i);
        else
          i = responseBuffer.writeUInt8(255, i);
        i = responseBuffer.writeUInt8(lastID, i);
        i = responseBuffer.writeUInt8(ids.length, i);
        for (id of ids) {
          i = responseBuffer.writeUInt8(id, i);
          i = responseBuffer.writeUInt8(objects[id].length, i);
          i += responseBuffer.write(objects[id], i, objects[id].length);
        }
        callback(null, responseBuffer);
      });
    }
    module2.exports = {
      readCoilsOrInputDiscretes: _handleReadCoilsOrInputDiscretes,
      readMultipleRegisters: _handleReadMultipleRegisters,
      readInputRegisters: _handleReadInputRegisters,
      writeCoil: _handleWriteCoil,
      writeSingleRegister: _handleWriteSingleRegister,
      forceMultipleCoils: _handleForceMultipleCoils,
      writeMultipleRegisters: _handleWriteMultipleRegisters,
      handleMEI: _handleMEI
    };
  }
});

// node_modules/modbus-serial/servers/servertcp.js
var require_servertcp = __commonJS({
  "node_modules/modbus-serial/servers/servertcp.js"(exports2, module2) {
    "use strict";
    var util = require("util");
    var events = require("events");
    var EventEmitter = events.EventEmitter || events;
    var net = require("net");
    var modbusSerialDebug = require_src()("modbus-serial");
    var HOST = "127.0.0.1";
    var UNIT_ID = 255;
    var MODBUS_PORT = 502;
    var MBAP_LEN = 6;
    var handlers = require_servertcp_handler();
    require_buffer_bit()();
    var crc16 = require_crc16();
    function _serverDebug(text2, unitID, functionCode, responseBuffer) {
      if (typeof responseBuffer === "undefined") {
        modbusSerialDebug({
          error: text2,
          unitID,
          functionCode
        });
      } else {
        modbusSerialDebug({
          action: text2,
          unitID,
          functionCode,
          responseBuffer: responseBuffer.toString("hex")
        });
      }
    }
    function _callbackFactory(unitID, functionCode, sockWriter) {
      return function cb(err, responseBuffer) {
        var crc;
        if (err) {
          var errorCode = 4;
          if (!isNaN(err.modbusErrorCode)) {
            errorCode = err.modbusErrorCode;
          }
          functionCode = parseInt(functionCode) | 128;
          responseBuffer = Buffer.alloc(3 + 2);
          responseBuffer.writeUInt8(errorCode, 2);
          _serverDebug("error processing response", unitID, functionCode);
        }
        if (!responseBuffer) {
          _serverDebug("no response buffer", unitID, functionCode);
          return sockWriter(null, responseBuffer);
        }
        responseBuffer.writeUInt8(unitID, 0);
        responseBuffer.writeUInt8(functionCode, 1);
        crc = crc16(responseBuffer.slice(0, -2));
        responseBuffer.writeUInt16LE(crc, responseBuffer.length - 2);
        _serverDebug("server response", unitID, functionCode, responseBuffer);
        return sockWriter(null, responseBuffer);
      };
    }
    function _parseModbusBuffer(requestBuffer, vector, serverUnitID, sockWriter) {
      var cb;
      if (!requestBuffer || requestBuffer.length < MBAP_LEN) {
        modbusSerialDebug("wrong size of request Buffer " + requestBuffer.length);
        return;
      }
      var unitID = requestBuffer[0];
      var functionCode = requestBuffer[1];
      var crc = requestBuffer[requestBuffer.length - 2] + requestBuffer[requestBuffer.length - 1] * 256;
      if (crc !== crc16(requestBuffer.slice(0, -2))) {
        modbusSerialDebug("wrong CRC of request Buffer");
        return;
      }
      if (serverUnitID !== 255 && serverUnitID !== unitID) {
        modbusSerialDebug("wrong unitID");
        return;
      }
      modbusSerialDebug("request for function code " + functionCode);
      cb = _callbackFactory(unitID, functionCode, sockWriter);
      switch (parseInt(functionCode)) {
        case 1:
        case 2:
          handlers.readCoilsOrInputDiscretes(requestBuffer, vector, unitID, cb, functionCode);
          break;
        case 3:
          handlers.readMultipleRegisters(requestBuffer, vector, unitID, cb);
          break;
        case 4:
          handlers.readInputRegisters(requestBuffer, vector, unitID, cb);
          break;
        case 5:
          handlers.writeCoil(requestBuffer, vector, unitID, cb);
          break;
        case 6:
          handlers.writeSingleRegister(requestBuffer, vector, unitID, cb);
          break;
        case 15:
          handlers.forceMultipleCoils(requestBuffer, vector, unitID, cb);
          break;
        case 16:
          handlers.writeMultipleRegisters(requestBuffer, vector, unitID, cb);
          break;
        case 43:
          handlers.handleMEI(requestBuffer, vector, unitID, cb);
          break;
        default:
          var errorCode = 1;
          functionCode = parseInt(functionCode) | 128;
          var responseBuffer = Buffer.alloc(3 + 2);
          responseBuffer.writeUInt8(errorCode, 2);
          modbusSerialDebug({
            error: "Illegal function",
            functionCode
          });
          cb({ modbusErrorCode: errorCode }, responseBuffer);
      }
    }
    var ServerTCP = function(vector, options) {
      var modbus = this;
      options = options || {};
      modbus._server = net.createServer();
      modbus._server.listen({
        port: options.port || MODBUS_PORT,
        host: options.host || HOST
      }, function() {
        modbus.emit("initialized");
      });
      var serverUnitID = options.unitID || UNIT_ID;
      modbus.socks = /* @__PURE__ */ new Map();
      modbus._server.on("connection", function(sock) {
        var recvBuffer = Buffer.from([]);
        modbus.socks.set(sock, 0);
        modbusSerialDebug({
          action: "connected",
          address: sock.address(),
          remoteAddress: sock.remoteAddress,
          localPort: sock.localPort
        });
        sock.once("close", function() {
          modbusSerialDebug({
            action: "closed"
          });
          modbus.socks.delete(sock);
        });
        sock.on("data", function(data) {
          modbusSerialDebug({ action: "socket data", data });
          recvBuffer = Buffer.concat([recvBuffer, data], recvBuffer.length + data.length);
          while (recvBuffer.length > MBAP_LEN) {
            const transactionsId = recvBuffer.readUInt16BE(0);
            var pduLen = recvBuffer.readUInt16BE(4);
            if (recvBuffer.length - MBAP_LEN < pduLen)
              break;
            var requestBuffer = Buffer.alloc(pduLen + 2);
            recvBuffer.copy(requestBuffer, 0, MBAP_LEN, MBAP_LEN + pduLen);
            recvBuffer = recvBuffer.slice(MBAP_LEN + pduLen);
            var crc = crc16(requestBuffer.slice(0, -2));
            requestBuffer.writeUInt16LE(crc, requestBuffer.length - 2);
            modbusSerialDebug({ action: "receive", data: requestBuffer, requestBufferLength: requestBuffer.length });
            modbusSerialDebug(JSON.stringify({ action: "receive", data: requestBuffer }));
            var sockWriter = function(err, responseBuffer) {
              if (err) {
                modbus.emit("error", err);
                return;
              }
              if (responseBuffer) {
                var outTcp = Buffer.alloc(responseBuffer.length + 6 - 2);
                outTcp.writeUInt16BE(transactionsId, 0);
                outTcp.writeUInt16BE(0, 2);
                outTcp.writeUInt16BE(responseBuffer.length - 2, 4);
                responseBuffer.copy(outTcp, 6);
                modbusSerialDebug({ action: "send", data: responseBuffer });
                modbusSerialDebug(JSON.stringify({ action: "send string", data: responseBuffer }));
                sock.write(outTcp);
              }
            };
            setTimeout(
              _parseModbusBuffer.bind(
                this,
                requestBuffer,
                vector,
                serverUnitID,
                sockWriter
              ),
              0
            );
          }
        });
        sock.on("error", function(err) {
          modbusSerialDebug(JSON.stringify({ action: "socket error", data: err }));
          modbus.emit("socketError", err);
        });
      });
      EventEmitter.call(this);
    };
    util.inherits(ServerTCP, EventEmitter);
    ServerTCP.prototype.close = function(callback) {
      const modbus = this;
      if (modbus._server) {
        modbus._server.removeAllListeners("data");
        modbus._server.close(callback);
        modbus.socks.forEach(function(e, sock) {
          sock.destroy();
        });
        modbusSerialDebug({ action: "close server" });
      } else {
        modbusSerialDebug({ action: "close server", warning: "server already closed" });
      }
    };
    module2.exports = ServerTCP;
  }
});

// node_modules/modbus-serial/index.js
var require_modbus_serial = __commonJS({
  "node_modules/modbus-serial/index.js"(exports2, module2) {
    "use strict";
    require_buffer_bit()();
    var crc16 = require_crc16();
    var modbusSerialDebug = require_src()("modbus-serial");
    var util = require("util");
    var events = require("events");
    var EventEmitter = events.EventEmitter || events;
    var PORT_NOT_OPEN_MESSAGE = "Port Not Open";
    var PORT_NOT_OPEN_ERRNO = "ECONNREFUSED";
    var BAD_ADDRESS_MESSAGE = "Bad Client Address";
    var BAD_ADDRESS_ERRNO = "ECONNREFUSED";
    var TRANSACTION_TIMED_OUT_MESSAGE = "Timed out";
    var TRANSACTION_TIMED_OUT_ERRNO = "ETIMEDOUT";
    var modbusErrorMessages = [
      "Unknown error",
      "Illegal function (device does not support this read/write function)",
      "Illegal data address (register not supported by device)",
      "Illegal data value (value cannot be written to this register)",
      "Slave device failure (device reports internal error)",
      "Acknowledge (requested data will be available later)",
      "Slave device busy (retry request again later)"
    ];
    var PortNotOpenError = function() {
      Error.captureStackTrace(this, this.constructor);
      this.name = this.constructor.name;
      this.message = PORT_NOT_OPEN_MESSAGE;
      this.errno = PORT_NOT_OPEN_ERRNO;
    };
    var BadAddressError = function() {
      Error.captureStackTrace(this, this.constructor);
      this.name = this.constructor.name;
      this.message = BAD_ADDRESS_MESSAGE;
      this.errno = BAD_ADDRESS_ERRNO;
    };
    var TransactionTimedOutError = function() {
      this.name = this.constructor.name;
      this.message = TRANSACTION_TIMED_OUT_MESSAGE;
      this.errno = TRANSACTION_TIMED_OUT_ERRNO;
    };
    var SerialPortError = function() {
      this.name = this.constructor.name;
      this.message = null;
      this.errno = "ECONNREFUSED";
    };
    function _readFC2(data, next) {
      var length = data.readUInt8(2);
      var contents = [];
      for (var i = 0; i < length; i++) {
        var reg = data[i + 3];
        for (var j = 0; j < 8; j++) {
          contents.push((reg & 1) === 1);
          reg = reg >> 1;
        }
      }
      if (next)
        next(null, { "data": contents, "buffer": data.slice(3, 3 + length) });
    }
    function _readFC4(data, next) {
      var length = data.readUInt8(2);
      var contents = [];
      for (var i = 0; i < length; i += 2) {
        var reg = data.readUInt16BE(i + 3);
        contents.push(reg);
      }
      if (next)
        next(null, { "data": contents, "buffer": data.slice(3, 3 + length) });
    }
    function _readFC5(data, next) {
      var dataAddress = data.readUInt16BE(2);
      var state = data.readUInt16BE(4);
      if (next)
        next(null, { "address": dataAddress, "state": state === 65280 });
    }
    function _readFC6(data, next) {
      var dataAddress = data.readUInt16BE(2);
      var value = data.readUInt16BE(4);
      if (next)
        next(null, { "address": dataAddress, "value": value });
    }
    function _readFC16(data, next) {
      var dataAddress = data.readUInt16BE(2);
      var length = data.readUInt16BE(4);
      if (next)
        next(null, { "address": dataAddress, "length": length });
    }
    function _readFC20(data, next) {
      var fileRespLength = parseInt(data.readUInt8(2));
      var result2 = [];
      for (var i = 5; i < fileRespLength + 5; i++) {
        var reg = data.readUInt8(i);
        result2.push(reg);
      }
      if (next)
        next(null, { "data": result2, "length": fileRespLength });
    }
    function _readFC43(data, modbus, next) {
      var address = parseInt(data.readUInt8(0));
      var readDeviceIdCode = parseInt(data.readUInt8(3));
      var conformityLevel = parseInt(data.readUInt8(4));
      var moreFollows = parseInt(data.readUInt8(5));
      var nextObjectId = parseInt(data.readUInt8(6));
      var numOfObjects = parseInt(data.readUInt8(7));
      var startAt = 8;
      var result2 = {};
      for (var i = 0; i < numOfObjects; i++) {
        var objectId = parseInt(data.readUInt8(startAt));
        var objectLength = parseInt(data.readUInt8(startAt + 1));
        const startOfData = startAt + 2;
        result2[objectId] = data.toString("ascii", startOfData, startOfData + objectLength);
        startAt = startOfData + objectLength;
      }
      if (moreFollows && numOfObjects) {
        const cb = function(err, data2) {
          data2.data = Object.assign(data2.data, result2);
          return next(err, data2);
        };
        modbus.writeFC43(address, readDeviceIdCode, nextObjectId, cb);
      } else if (next) {
        next(null, { data: result2, conformityLevel });
      }
    }
    function _writeBufferToPort(buffer, transactionId) {
      var transaction = this._transactions[transactionId];
      if (transaction) {
        transaction._timeoutFired = false;
        transaction._timeoutHandle = _startTimeout(this._timeout, transaction);
        if (this._debugEnabled) {
          transaction.request = Uint8Array.prototype.slice.call(buffer);
          transaction.responses = [];
        }
      }
      this._port.write(buffer);
    }
    function _startTimeout(duration, transaction) {
      if (!duration) {
        return void 0;
      }
      return setTimeout(function() {
        transaction._timeoutFired = true;
        if (transaction.next) {
          var err = new TransactionTimedOutError();
          if (transaction.request && transaction.responses) {
            err.modbusRequest = transaction.request;
            err.modbusResponses = transaction.responses;
          }
          transaction.next(err);
        }
      }, duration);
    }
    function _cancelTimeout(timeoutHandle) {
      clearTimeout(timeoutHandle);
    }
    function _onReceive(data) {
      var modbus = this;
      var error;
      var transaction = modbus._transactions[modbus._port._transactionIdRead];
      if (!transaction) {
        return;
      }
      if (transaction.responses) {
        transaction.responses.push(Uint8Array.prototype.slice.call(data));
      }
      var next = function(err, res) {
        if (transaction.next) {
          if (transaction.request && transaction.responses) {
            if (err) {
              err.modbusRequest = transaction.request;
              err.modbusResponses = transaction.responses;
            }
            if (res) {
              res.request = transaction.request;
              res.responses = transaction.responses;
            }
          }
          return transaction.next(err, res);
        }
      };
      _cancelTimeout(transaction._timeoutHandle);
      transaction._timeoutHandle = void 0;
      if (transaction._timeoutFired === true) {
        return;
      }
      if (!transaction.lengthUnknown && data.length < 5) {
        error = "Data length error, expected " + transaction.nextLength + " got " + data.length;
        next(new Error(error));
        return;
      }
      var crcIn = data.readUInt16LE(data.length - 2);
      if (crcIn !== crc16(data.slice(0, -2))) {
        error = "CRC error";
        next(new Error(error));
        return;
      }
      var address = data.readUInt8(0);
      var code = data.readUInt8(1);
      if (data.length >= 5 && code === (128 | transaction.nextCode)) {
        var errorCode = data.readUInt8(2);
        if (transaction.next) {
          error = new Error("Modbus exception " + errorCode + ": " + (modbusErrorMessages[errorCode] || "Unknown error"));
          error.modbusCode = errorCode;
          next(error);
        }
        return;
      }
      if (!transaction.lengthUnknown && data.length !== transaction.nextLength) {
        error = "Data length error, expected " + transaction.nextLength + " got " + data.length;
        next(new Error(error));
        return;
      }
      if (address !== transaction.nextAddress) {
        error = "Unexpected data error, expected address " + transaction.nextAddress + " got " + address;
        if (transaction.next)
          next(new Error(error));
        return;
      }
      if (code !== transaction.nextCode) {
        error = "Unexpected data error, expected code " + transaction.nextCode + " got " + code;
        if (transaction.next)
          next(new Error(error));
        return;
      }
      switch (code) {
        case 1:
        case 2:
          _readFC2(data, next);
          break;
        case 3:
        case 4:
          _readFC4(data, next);
          break;
        case 5:
          _readFC5(data, next);
          break;
        case 6:
          _readFC6(data, next);
          break;
        case 15:
        case 16:
          _readFC16(data, next);
          break;
        case 20:
          _readFC20(data, transaction.next);
          break;
        case 43:
          _readFC43(data, modbus, next);
      }
    }
    function _onError(e) {
      var err = new SerialPortError();
      err.message = e.message;
      err.stack = e.stack;
      this.emit("error", err);
    }
    var ModbusRTU = function(port2) {
      this._port = port2;
      this._transactions = {};
      this._timeout = null;
      this._unitID = 1;
      this._debugEnabled = false;
      this._onReceive = _onReceive.bind(this);
      this._onError = _onError.bind(this);
      EventEmitter.call(this);
    };
    util.inherits(ModbusRTU, EventEmitter);
    ModbusRTU.prototype.open = function(callback) {
      var modbus = this;
      modbus._port.open(function(error) {
        if (error) {
          modbusSerialDebug({ action: "port open error", error });
          if (callback)
            callback(error);
        } else {
          modbus._port._transactionIdRead = 1;
          modbus._port._transactionIdWrite = 1;
          modbus._port.removeListener("data", modbus._onReceive);
          modbus._port.on("data", modbus._onReceive);
          modbus._port.removeListener("error", modbus._onError);
          modbus._port.on("error", modbus._onError);
          modbus._port.once("close", modbus.emit.bind(modbus, "close"));
          if (callback)
            callback(error);
        }
      });
    };
    Object.defineProperty(ModbusRTU.prototype, "isDebugEnabled", {
      enumerable: true,
      get: function() {
        return this._debugEnabled;
      },
      set: function(enable) {
        enable = Boolean(enable);
        this._debugEnabled = enable;
      }
    });
    Object.defineProperty(ModbusRTU.prototype, "isOpen", {
      enumerable: true,
      get: function() {
        if (this._port) {
          return this._port.isOpen;
        }
        return false;
      }
    });
    ModbusRTU.prototype.close = function(callback) {
      if (this._port) {
        this._port.removeAllListeners("data");
        this._port.close(callback);
      } else {
        callback();
      }
    };
    ModbusRTU.prototype.destroy = function(callback) {
      if (this._port && this._port.destroy) {
        this._port.removeAllListeners("data");
        this._port.destroy(callback);
      } else {
        callback();
      }
    };
    ModbusRTU.prototype.writeFC1 = function(address, dataAddress, length, next) {
      this.writeFC2(address, dataAddress, length, next, 1);
    };
    ModbusRTU.prototype.writeFC2 = function(address, dataAddress, length, next, code) {
      if (this.isOpen !== true) {
        if (next)
          next(new PortNotOpenError());
        return;
      }
      if (typeof address === "undefined" || typeof dataAddress === "undefined") {
        if (next)
          next(new BadAddressError());
        return;
      }
      code = code || 2;
      this._transactions[this._port._transactionIdWrite] = {
        nextAddress: address,
        nextCode: code,
        nextLength: 3 + parseInt((length - 1) / 8 + 1) + 2,
        next
      };
      var codeLength = 6;
      var buf = Buffer.alloc(codeLength + 2);
      buf.writeUInt8(address, 0);
      buf.writeUInt8(code, 1);
      buf.writeUInt16BE(dataAddress, 2);
      buf.writeUInt16BE(length, 4);
      buf.writeUInt16LE(crc16(buf.slice(0, -2)), codeLength);
      _writeBufferToPort.call(this, buf, this._port._transactionIdWrite);
    };
    ModbusRTU.prototype.writeFC3 = function(address, dataAddress, length, next) {
      this.writeFC4(address, dataAddress, length, next, 3);
    };
    ModbusRTU.prototype.writeFC4 = function(address, dataAddress, length, next, code) {
      if (this.isOpen !== true) {
        if (next)
          next(new PortNotOpenError());
        return;
      }
      if (typeof address === "undefined" || typeof dataAddress === "undefined") {
        if (next)
          next(new BadAddressError());
        return;
      }
      code = code || 4;
      this._transactions[this._port._transactionIdWrite] = {
        nextAddress: address,
        nextCode: code,
        nextLength: 3 + 2 * length + 2,
        next
      };
      var codeLength = 6;
      var buf = Buffer.alloc(codeLength + 2);
      buf.writeUInt8(address, 0);
      buf.writeUInt8(code, 1);
      buf.writeUInt16BE(dataAddress, 2);
      buf.writeUInt16BE(length, 4);
      buf.writeUInt16LE(crc16(buf.slice(0, -2)), codeLength);
      _writeBufferToPort.call(this, buf, this._port._transactionIdWrite);
    };
    ModbusRTU.prototype.writeFC5 = function(address, dataAddress, state, next) {
      if (this.isOpen !== true) {
        if (next)
          next(new PortNotOpenError());
        return;
      }
      if (typeof address === "undefined" || typeof dataAddress === "undefined") {
        if (next)
          next(new BadAddressError());
        return;
      }
      var code = 5;
      this._transactions[this._port._transactionIdWrite] = {
        nextAddress: address,
        nextCode: code,
        nextLength: 8,
        next
      };
      var codeLength = 6;
      var buf = Buffer.alloc(codeLength + 2);
      buf.writeUInt8(address, 0);
      buf.writeUInt8(code, 1);
      buf.writeUInt16BE(dataAddress, 2);
      if (state) {
        buf.writeUInt16BE(65280, 4);
      } else {
        buf.writeUInt16BE(0, 4);
      }
      buf.writeUInt16LE(crc16(buf.slice(0, -2)), codeLength);
      _writeBufferToPort.call(this, buf, this._port._transactionIdWrite);
    };
    ModbusRTU.prototype.writeFC6 = function(address, dataAddress, value, next) {
      if (this.isOpen !== true) {
        if (next)
          next(new PortNotOpenError());
        return;
      }
      if (typeof address === "undefined" || typeof dataAddress === "undefined") {
        if (next)
          next(new BadAddressError());
        return;
      }
      var code = 6;
      this._transactions[this._port._transactionIdWrite] = {
        nextAddress: address,
        nextCode: code,
        nextLength: 8,
        next
      };
      var codeLength = 6;
      var buf = Buffer.alloc(codeLength + 2);
      buf.writeUInt8(address, 0);
      buf.writeUInt8(code, 1);
      buf.writeUInt16BE(dataAddress, 2);
      if (Buffer.isBuffer(value)) {
        value.copy(buf, 4);
      } else {
        buf.writeUInt16BE(value, 4);
      }
      buf.writeUInt16LE(crc16(buf.slice(0, -2)), codeLength);
      _writeBufferToPort.call(this, buf, this._port._transactionIdWrite);
    };
    ModbusRTU.prototype.writeFC15 = function(address, dataAddress, array, next) {
      if (this.isOpen !== true) {
        if (next)
          next(new PortNotOpenError());
        return;
      }
      if (typeof address === "undefined" || typeof dataAddress === "undefined") {
        if (next)
          next(new BadAddressError());
        return;
      }
      var code = 15;
      var i = 0;
      this._transactions[this._port._transactionIdWrite] = {
        nextAddress: address,
        nextCode: code,
        nextLength: 8,
        next
      };
      var dataBytes = Math.ceil(array.length / 8);
      var codeLength = 7 + dataBytes;
      var buf = Buffer.alloc(codeLength + 2);
      buf.writeUInt8(address, 0);
      buf.writeUInt8(code, 1);
      buf.writeUInt16BE(dataAddress, 2);
      buf.writeUInt16BE(array.length, 4);
      buf.writeUInt8(dataBytes, 6);
      for (i = 0; i < dataBytes; i++) {
        buf.writeUInt8(0, 7 + i);
      }
      for (i = 0; i < array.length; i++) {
        if (array[i]) {
          buf.writeBit(1, i, 7);
        }
      }
      buf.writeUInt16LE(crc16(buf.slice(0, -2)), codeLength);
      _writeBufferToPort.call(this, buf, this._port._transactionIdWrite);
    };
    ModbusRTU.prototype.writeFC16 = function(address, dataAddress, array, next) {
      if (this.isOpen !== true) {
        if (next)
          next(new PortNotOpenError());
        return;
      }
      if (typeof address === "undefined" || typeof dataAddress === "undefined") {
        if (next)
          next(new BadAddressError());
        return;
      }
      var code = 16;
      this._transactions[this._port._transactionIdWrite] = {
        nextAddress: address,
        nextCode: code,
        nextLength: 8,
        next
      };
      var dataLength = array.length;
      if (Buffer.isBuffer(array)) {
        dataLength = array.length / 2;
      }
      var codeLength = 7 + 2 * dataLength;
      var buf = Buffer.alloc(codeLength + 2);
      buf.writeUInt8(address, 0);
      buf.writeUInt8(code, 1);
      buf.writeUInt16BE(dataAddress, 2);
      buf.writeUInt16BE(dataLength, 4);
      buf.writeUInt8(dataLength * 2, 6);
      if (Buffer.isBuffer(array)) {
        array.copy(buf, 7);
      } else {
        for (var i = 0; i < dataLength; i++) {
          buf.writeUInt16BE(array[i], 7 + 2 * i);
        }
      }
      buf.writeUInt16LE(crc16(buf.slice(0, -2)), codeLength);
      _writeBufferToPort.call(this, buf, this._port._transactionIdWrite);
    };
    ModbusRTU.prototype.writeFC20 = function(address, fileNumber, recordNumber, next) {
      if (this.isOpen !== true) {
        if (next)
          next(new PortNotOpenError());
        return;
      }
      if (typeof address === "undefined") {
        if (next)
          next(new BadAddressError());
        return;
      }
      var code = 20;
      var codeLength = 10;
      var byteCount = 7;
      var chunck = 100;
      this._transactions[this._port._transactionIdWrite] = {
        nextAddress: address,
        nextCode: code,
        lengthUnknown: true,
        next
      };
      var buf = Buffer.alloc(codeLength + 2);
      buf.writeUInt8(address, 0);
      buf.writeUInt8(code, 1);
      buf.writeUInt8(byteCount, 2);
      buf.writeUInt8(6, 3);
      buf.writeUInt16BE(fileNumber, 4);
      buf.writeUInt16BE(recordNumber, 6);
      buf.writeUInt8(chunck, 9);
      buf.writeUInt16LE(crc16(buf.slice(0, -2)), codeLength);
      _writeBufferToPort.call(this, buf, this._port._transactionIdWrite);
    };
    ModbusRTU.prototype.writeFC43 = function(address, deviceIdCode, objectId, next) {
      if (this.isOpen !== true) {
        if (next)
          next(new PortNotOpenError());
        return;
      }
      var code = 43;
      this._transactions[this._port._transactionIdWrite] = {
        nextAddress: address,
        nextCode: code,
        lengthUnknown: true,
        next
      };
      var codeLength = 5;
      var buf = Buffer.alloc(codeLength + 2);
      buf.writeUInt8(address, 0);
      buf.writeUInt8(code, 1);
      buf.writeUInt8(14, 2);
      buf.writeUInt8(deviceIdCode, 3);
      buf.writeUInt8(objectId, 4);
      buf.writeUInt16LE(crc16(buf.slice(0, -2)), codeLength);
      _writeBufferToPort.call(this, buf, this._port._transactionIdWrite);
    };
    require_connection()(ModbusRTU);
    require_promise()(ModbusRTU);
    require_worker2()(ModbusRTU);
    module2.exports = ModbusRTU;
    module2.exports.TestPort = require_testport();
    try {
      module2.exports.RTUBufferedPort = require_rtubufferedport();
    } catch (err) {
    }
    module2.exports.TcpPort = require_tcpport();
    module2.exports.TcpRTUBufferedPort = require_tcprtubufferedport();
    module2.exports.TelnetPort = require_telnetport();
    module2.exports.C701Port = require_c701port();
    module2.exports.ServerTCP = require_servertcp();
    module2.exports.default = module2.exports;
  }
});

// src/modbus.js
var require_modbus = __commonJS({
  "src/modbus.js"(exports2, module2) {
    "use strict";
    var ModbusRTU = require_modbus_serial();
    var sensorDefinition2 = require_sensorDefinition();
    var gwutils2 = require_gwutils();
    var ModbusServer = class {
      static init(gwGlobalState) {
        let modbusRegisterTable = [];
        if (gwGlobalState.basicconfig.modbusRegisterTable)
          modbusRegisterTable = gwGlobalState.basicconfig.modbusRegisterTable;
        console.log(JSON.stringify(modbusRegisterTable));
        let modbusRegisterTableByOffset = {};
        for (let i = 0; i < modbusRegisterTable.length; i++) {
          let entry = modbusRegisterTable[i];
          modbusRegisterTableByOffset[entry.offset] = entry;
        }
        this.modbusSensorDefinition = null;
        this.getModbusSensorDefinitions();
        var vector = {
          setRegister: (addr, value, unitID) => {
            try {
              let tableMatch = modbusRegisterTableByOffset[addr];
              let tableMatchPrev = void 0;
              if (addr > 0)
                tableMatchPrev = modbusRegisterTableByOffset[addr - 1];
              let secondhalf = false;
              let propertyInfo = null;
              if (tableMatch) {
                propertyInfo = this.modbusSensorDefinition[tableMatch.nodeType].lookupTable[tableMatch.property][0];
              } else if (tableMatchPrev) {
                propertyInfo = this.modbusSensorDefinition[tableMatchPrev.nodeType].lookupTable[tableMatchPrev.property][0];
                tableMatch = tableMatchPrev;
                secondhalf = true;
              }
              if (tableMatch) {
                if (propertyInfo.stateVariableName == "triggerCollection") {
                  if (gwGlobalState.nodes[tableMatch.phantomCode].actions === void 0)
                    gwGlobalState.nodes[tableMatch.phantomCode].actions = {};
                  gwGlobalState.nodes[tableMatch.phantomCode].actions["signal"] = {};
                  gwGlobalState.nodes[tableMatch.phantomCode].actions["signal"].requestTime = Date.now();
                  gwutils2.gwUpdateGlobalState();
                } else if (propertyInfo.stateVariableName == "triggerStateUpdate") {
                  if (gwGlobalState.nodes[tableMatch.phantomCode].actions === void 0)
                    gwGlobalState.nodes[tableMatch.phantomCode].actions = {};
                  gwGlobalState.nodes[tableMatch.phantomCode].actions["updatestate"] = {};
                  gwGlobalState.nodes[tableMatch.phantomCode].actions["updatestate"].requestTime = Date.now();
                  gwutils2.gwUpdateGlobalState();
                }
              }
            } catch (e) {
              console.log(e);
            }
          },
          getHoldingRegister: (addr, unitID) => {
            let retval = 0;
            try {
              let tableMatch = modbusRegisterTableByOffset[addr];
              let tableMatchPrev = void 0;
              if (addr > 0)
                tableMatchPrev = modbusRegisterTableByOffset[addr - 1];
              let secondhalf = false;
              let propertyInfo = null;
              if (tableMatch) {
                propertyInfo = this.modbusSensorDefinition[tableMatch.nodeType].lookupTable[tableMatch.property][0];
              } else if (tableMatchPrev) {
                propertyInfo = this.modbusSensorDefinition[tableMatchPrev.nodeType].lookupTable[tableMatchPrev.property][0];
                tableMatch = tableMatchPrev;
                secondhalf = true;
              }
              if (tableMatch) {
                let value = gwGlobalState.nodes[tableMatch.phantomCode]?.advdatav2[propertyInfo.stateVariableName];
                if (value == void 0)
                  value = 0;
                if (Array.isArray(value)) {
                  value = value[tableMatch.arrayIndex];
                }
                switch (propertyInfo.dataType) {
                  case "float":
                    {
                      const rbuf = Buffer.alloc(4);
                      rbuf.writeFloatBE(value);
                      if (secondhalf)
                        retval = rbuf.readUInt16BE(2);
                      else
                        retval = rbuf.readUInt16BE(0);
                    }
                    break;
                  case "uint16": {
                    const rbuf = Buffer.alloc(2);
                    rbuf.writeUInt16BE(value);
                    retval = rbuf.readUInt16BE(0);
                    break;
                  }
                  case "uint32": {
                    const rbuf = Buffer.alloc(4);
                    rbuf.writeUInt32BE(value);
                    if (secondhalf)
                      retval = rbuf.readUInt16BE(2);
                    else
                      retval = rbuf.readUInt16BE(0);
                    break;
                  }
                }
              }
            } catch (e) {
              console.log("modbus errror", e);
            }
            return retval;
          },
          readDeviceIdentification: function(addr) {
            return {
              0: "Erbessd Instruments",
              1: "Phantom GW 2.0",
              2: "",
              5: "",
              151: "",
              171: ""
            };
          }
        };
        var serverTCP = new ModbusRTU.ServerTCP(vector, { host: "0.0.0.0", port: 502, debug: true, unitID: 1 });
        serverTCP.on("socketError", function(err) {
          console.error(err);
        });
      }
      static getModbusSensorDefinitions() {
        let alldatatypes = {};
        if (!this.modbusSensorDefinition) {
          this.modbusSensorDefinition = {};
          for (let sensorType in sensorDefinition2.phantomTypes) {
            let typeNumber = sensorDefinition2.phantomTypes[sensorType];
            let sensorDef = sensorDefinition2.getSensorDefinition(typeNumber);
            let lookupTable = {};
            let arrayTable = [];
            if (!sensorDef)
              continue;
            for (let i = 0; i < sensorDef.length; i++) {
              let variable = sensorDef[i];
              if (variable.modbus) {
                if (variable.modbus.arraySize) {
                  lookupTable[variable.stateVariableName] = [];
                  for (let iArray = 0; iArray < variable.modbus.arraySize; iArray++) {
                    let modbusVar = {
                      stateVariableName: variable.stateVariableName,
                      description: variable.description + " (" + iArray + ")",
                      dataType: variable.modbus.dataType,
                      arrayIndex: iArray
                    };
                    arrayTable.push(modbusVar);
                    lookupTable[variable.stateVariableName][iArray] = modbusVar;
                  }
                } else {
                  let modbusVar = {
                    stateVariableName: variable.stateVariableName,
                    description: variable.description,
                    dataType: variable.modbus.dataType,
                    arrayIndex: 0
                  };
                  arrayTable.push(modbusVar);
                  lookupTable[variable.stateVariableName] = [];
                  lookupTable[variable.stateVariableName][0] = modbusVar;
                }
              }
            }
            this.modbusSensorDefinition[typeNumber] = {
              arrayTable,
              lookupTable
            };
          }
        }
        console.log(alldatatypes);
        return this.modbusSensorDefinition;
      }
    };
    module2.exports = {
      ModbusServer
    };
  }
});

// node_modules/fast-json-patch/commonjs/helpers.js
var require_helpers = __commonJS({
  "node_modules/fast-json-patch/commonjs/helpers.js"(exports2) {
    var __extends3 = exports2 && exports2.__extends || /* @__PURE__ */ function() {
      var extendStatics3 = function(d2, b) {
        extendStatics3 = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d3, b2) {
          d3.__proto__ = b2;
        } || function(d3, b2) {
          for (var p3 in b2)
            if (b2.hasOwnProperty(p3))
              d3[p3] = b2[p3];
        };
        return extendStatics3(d2, b);
      };
      return function(d2, b) {
        extendStatics3(d2, b);
        function __() {
          this.constructor = d2;
        }
        d2.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
      };
    }();
    Object.defineProperty(exports2, "__esModule", { value: true });
    var _hasOwnProperty = Object.prototype.hasOwnProperty;
    function hasOwnProperty(obj, key) {
      return _hasOwnProperty.call(obj, key);
    }
    exports2.hasOwnProperty = hasOwnProperty;
    function _objectKeys(obj) {
      if (Array.isArray(obj)) {
        var keys_1 = new Array(obj.length);
        for (var k = 0; k < keys_1.length; k++) {
          keys_1[k] = "" + k;
        }
        return keys_1;
      }
      if (Object.keys) {
        return Object.keys(obj);
      }
      var keys = [];
      for (var i in obj) {
        if (hasOwnProperty(obj, i)) {
          keys.push(i);
        }
      }
      return keys;
    }
    exports2._objectKeys = _objectKeys;
    function _deepClone(obj) {
      switch (typeof obj) {
        case "object":
          return JSON.parse(JSON.stringify(obj));
        case "undefined":
          return null;
        default:
          return obj;
      }
    }
    exports2._deepClone = _deepClone;
    function isInteger(str) {
      var i = 0;
      var len = str.length;
      var charCode;
      while (i < len) {
        charCode = str.charCodeAt(i);
        if (charCode >= 48 && charCode <= 57) {
          i++;
          continue;
        }
        return false;
      }
      return true;
    }
    exports2.isInteger = isInteger;
    function escapePathComponent(path3) {
      if (path3.indexOf("/") === -1 && path3.indexOf("~") === -1)
        return path3;
      return path3.replace(/~/g, "~0").replace(/\//g, "~1");
    }
    exports2.escapePathComponent = escapePathComponent;
    function unescapePathComponent(path3) {
      return path3.replace(/~1/g, "/").replace(/~0/g, "~");
    }
    exports2.unescapePathComponent = unescapePathComponent;
    function _getPathRecursive(root, obj) {
      var found;
      for (var key in root) {
        if (hasOwnProperty(root, key)) {
          if (root[key] === obj) {
            return escapePathComponent(key) + "/";
          } else if (typeof root[key] === "object") {
            found = _getPathRecursive(root[key], obj);
            if (found != "") {
              return escapePathComponent(key) + "/" + found;
            }
          }
        }
      }
      return "";
    }
    exports2._getPathRecursive = _getPathRecursive;
    function getPath(root, obj) {
      if (root === obj) {
        return "/";
      }
      var path3 = _getPathRecursive(root, obj);
      if (path3 === "") {
        throw new Error("Object not found in root");
      }
      return "/" + path3;
    }
    exports2.getPath = getPath;
    function hasUndefined(obj) {
      if (obj === void 0) {
        return true;
      }
      if (obj) {
        if (Array.isArray(obj)) {
          for (var i_1 = 0, len = obj.length; i_1 < len; i_1++) {
            if (hasUndefined(obj[i_1])) {
              return true;
            }
          }
        } else if (typeof obj === "object") {
          var objKeys = _objectKeys(obj);
          var objKeysLength = objKeys.length;
          for (var i = 0; i < objKeysLength; i++) {
            if (hasUndefined(obj[objKeys[i]])) {
              return true;
            }
          }
        }
      }
      return false;
    }
    exports2.hasUndefined = hasUndefined;
    function patchErrorMessageFormatter(message, args) {
      var messageParts = [message];
      for (var key in args) {
        var value = typeof args[key] === "object" ? JSON.stringify(args[key], null, 2) : args[key];
        if (typeof value !== "undefined") {
          messageParts.push(key + ": " + value);
        }
      }
      return messageParts.join("\n");
    }
    var PatchError = (
      /** @class */
      function(_super) {
        __extends3(PatchError2, _super);
        function PatchError2(message, name, index, operation, tree) {
          var _newTarget = this.constructor;
          var _this = _super.call(this, patchErrorMessageFormatter(message, { name, index, operation, tree })) || this;
          _this.name = name;
          _this.index = index;
          _this.operation = operation;
          _this.tree = tree;
          Object.setPrototypeOf(_this, _newTarget.prototype);
          _this.message = patchErrorMessageFormatter(message, { name, index, operation, tree });
          return _this;
        }
        return PatchError2;
      }(Error)
    );
    exports2.PatchError = PatchError;
  }
});

// node_modules/fast-json-patch/commonjs/core.js
var require_core = __commonJS({
  "node_modules/fast-json-patch/commonjs/core.js"(exports2) {
    Object.defineProperty(exports2, "__esModule", { value: true });
    var helpers_js_1 = require_helpers();
    exports2.JsonPatchError = helpers_js_1.PatchError;
    exports2.deepClone = helpers_js_1._deepClone;
    var objOps = {
      add: function(obj, key, document2) {
        obj[key] = this.value;
        return { newDocument: document2 };
      },
      remove: function(obj, key, document2) {
        var removed = obj[key];
        delete obj[key];
        return { newDocument: document2, removed };
      },
      replace: function(obj, key, document2) {
        var removed = obj[key];
        obj[key] = this.value;
        return { newDocument: document2, removed };
      },
      move: function(obj, key, document2) {
        var removed = getValueByPointer(document2, this.path);
        if (removed) {
          removed = helpers_js_1._deepClone(removed);
        }
        var originalValue = applyOperation(document2, { op: "remove", path: this.from }).removed;
        applyOperation(document2, { op: "add", path: this.path, value: originalValue });
        return { newDocument: document2, removed };
      },
      copy: function(obj, key, document2) {
        var valueToCopy = getValueByPointer(document2, this.from);
        applyOperation(document2, { op: "add", path: this.path, value: helpers_js_1._deepClone(valueToCopy) });
        return { newDocument: document2 };
      },
      test: function(obj, key, document2) {
        return { newDocument: document2, test: _areEquals(obj[key], this.value) };
      },
      _get: function(obj, key, document2) {
        this.value = obj[key];
        return { newDocument: document2 };
      }
    };
    var arrOps = {
      add: function(arr, i, document2) {
        if (helpers_js_1.isInteger(i)) {
          arr.splice(i, 0, this.value);
        } else {
          arr[i] = this.value;
        }
        return { newDocument: document2, index: i };
      },
      remove: function(arr, i, document2) {
        var removedList = arr.splice(i, 1);
        return { newDocument: document2, removed: removedList[0] };
      },
      replace: function(arr, i, document2) {
        var removed = arr[i];
        arr[i] = this.value;
        return { newDocument: document2, removed };
      },
      move: objOps.move,
      copy: objOps.copy,
      test: objOps.test,
      _get: objOps._get
    };
    function getValueByPointer(document2, pointer) {
      if (pointer == "") {
        return document2;
      }
      var getOriginalDestination = { op: "_get", path: pointer };
      applyOperation(document2, getOriginalDestination);
      return getOriginalDestination.value;
    }
    exports2.getValueByPointer = getValueByPointer;
    function applyOperation(document2, operation, validateOperation, mutateDocument, banPrototypeModifications, index) {
      if (validateOperation === void 0) {
        validateOperation = false;
      }
      if (mutateDocument === void 0) {
        mutateDocument = true;
      }
      if (banPrototypeModifications === void 0) {
        banPrototypeModifications = true;
      }
      if (index === void 0) {
        index = 0;
      }
      if (validateOperation) {
        if (typeof validateOperation == "function") {
          validateOperation(operation, 0, document2, operation.path);
        } else {
          validator(operation, 0);
        }
      }
      if (operation.path === "") {
        var returnValue = { newDocument: document2 };
        if (operation.op === "add") {
          returnValue.newDocument = operation.value;
          return returnValue;
        } else if (operation.op === "replace") {
          returnValue.newDocument = operation.value;
          returnValue.removed = document2;
          return returnValue;
        } else if (operation.op === "move" || operation.op === "copy") {
          returnValue.newDocument = getValueByPointer(document2, operation.from);
          if (operation.op === "move") {
            returnValue.removed = document2;
          }
          return returnValue;
        } else if (operation.op === "test") {
          returnValue.test = _areEquals(document2, operation.value);
          if (returnValue.test === false) {
            throw new exports2.JsonPatchError("Test operation failed", "TEST_OPERATION_FAILED", index, operation, document2);
          }
          returnValue.newDocument = document2;
          return returnValue;
        } else if (operation.op === "remove") {
          returnValue.removed = document2;
          returnValue.newDocument = null;
          return returnValue;
        } else if (operation.op === "_get") {
          operation.value = document2;
          return returnValue;
        } else {
          if (validateOperation) {
            throw new exports2.JsonPatchError("Operation `op` property is not one of operations defined in RFC-6902", "OPERATION_OP_INVALID", index, operation, document2);
          } else {
            return returnValue;
          }
        }
      } else {
        if (!mutateDocument) {
          document2 = helpers_js_1._deepClone(document2);
        }
        var path3 = operation.path || "";
        var keys = path3.split("/");
        var obj = document2;
        var t = 1;
        var len = keys.length;
        var existingPathFragment = void 0;
        var key = void 0;
        var validateFunction = void 0;
        if (typeof validateOperation == "function") {
          validateFunction = validateOperation;
        } else {
          validateFunction = validator;
        }
        while (true) {
          key = keys[t];
          if (key && key.indexOf("~") != -1) {
            key = helpers_js_1.unescapePathComponent(key);
          }
          if (banPrototypeModifications && (key == "__proto__" || key == "prototype" && t > 0 && keys[t - 1] == "constructor")) {
            throw new TypeError("JSON-Patch: modifying `__proto__` or `constructor/prototype` prop is banned for security reasons, if this was on purpose, please set `banPrototypeModifications` flag false and pass it to this function. More info in fast-json-patch README");
          }
          if (validateOperation) {
            if (existingPathFragment === void 0) {
              if (obj[key] === void 0) {
                existingPathFragment = keys.slice(0, t).join("/");
              } else if (t == len - 1) {
                existingPathFragment = operation.path;
              }
              if (existingPathFragment !== void 0) {
                validateFunction(operation, 0, document2, existingPathFragment);
              }
            }
          }
          t++;
          if (Array.isArray(obj)) {
            if (key === "-") {
              key = obj.length;
            } else {
              if (validateOperation && !helpers_js_1.isInteger(key)) {
                throw new exports2.JsonPatchError("Expected an unsigned base-10 integer value, making the new referenced value the array element with the zero-based index", "OPERATION_PATH_ILLEGAL_ARRAY_INDEX", index, operation, document2);
              } else if (helpers_js_1.isInteger(key)) {
                key = ~~key;
              }
            }
            if (t >= len) {
              if (validateOperation && operation.op === "add" && key > obj.length) {
                throw new exports2.JsonPatchError("The specified index MUST NOT be greater than the number of elements in the array", "OPERATION_VALUE_OUT_OF_BOUNDS", index, operation, document2);
              }
              var returnValue = arrOps[operation.op].call(operation, obj, key, document2);
              if (returnValue.test === false) {
                throw new exports2.JsonPatchError("Test operation failed", "TEST_OPERATION_FAILED", index, operation, document2);
              }
              return returnValue;
            }
          } else {
            if (t >= len) {
              var returnValue = objOps[operation.op].call(operation, obj, key, document2);
              if (returnValue.test === false) {
                throw new exports2.JsonPatchError("Test operation failed", "TEST_OPERATION_FAILED", index, operation, document2);
              }
              return returnValue;
            }
          }
          obj = obj[key];
          if (validateOperation && t < len && (!obj || typeof obj !== "object")) {
            throw new exports2.JsonPatchError("Cannot perform operation at the desired path", "OPERATION_PATH_UNRESOLVABLE", index, operation, document2);
          }
        }
      }
    }
    exports2.applyOperation = applyOperation;
    function applyPatch(document2, patch, validateOperation, mutateDocument, banPrototypeModifications) {
      if (mutateDocument === void 0) {
        mutateDocument = true;
      }
      if (banPrototypeModifications === void 0) {
        banPrototypeModifications = true;
      }
      if (validateOperation) {
        if (!Array.isArray(patch)) {
          throw new exports2.JsonPatchError("Patch sequence must be an array", "SEQUENCE_NOT_AN_ARRAY");
        }
      }
      if (!mutateDocument) {
        document2 = helpers_js_1._deepClone(document2);
      }
      var results = new Array(patch.length);
      for (var i = 0, length_1 = patch.length; i < length_1; i++) {
        results[i] = applyOperation(document2, patch[i], validateOperation, true, banPrototypeModifications, i);
        document2 = results[i].newDocument;
      }
      results.newDocument = document2;
      return results;
    }
    exports2.applyPatch = applyPatch;
    function applyReducer(document2, operation, index) {
      var operationResult = applyOperation(document2, operation);
      if (operationResult.test === false) {
        throw new exports2.JsonPatchError("Test operation failed", "TEST_OPERATION_FAILED", index, operation, document2);
      }
      return operationResult.newDocument;
    }
    exports2.applyReducer = applyReducer;
    function validator(operation, index, document2, existingPathFragment) {
      if (typeof operation !== "object" || operation === null || Array.isArray(operation)) {
        throw new exports2.JsonPatchError("Operation is not an object", "OPERATION_NOT_AN_OBJECT", index, operation, document2);
      } else if (!objOps[operation.op]) {
        throw new exports2.JsonPatchError("Operation `op` property is not one of operations defined in RFC-6902", "OPERATION_OP_INVALID", index, operation, document2);
      } else if (typeof operation.path !== "string") {
        throw new exports2.JsonPatchError("Operation `path` property is not a string", "OPERATION_PATH_INVALID", index, operation, document2);
      } else if (operation.path.indexOf("/") !== 0 && operation.path.length > 0) {
        throw new exports2.JsonPatchError('Operation `path` property must start with "/"', "OPERATION_PATH_INVALID", index, operation, document2);
      } else if ((operation.op === "move" || operation.op === "copy") && typeof operation.from !== "string") {
        throw new exports2.JsonPatchError("Operation `from` property is not present (applicable in `move` and `copy` operations)", "OPERATION_FROM_REQUIRED", index, operation, document2);
      } else if ((operation.op === "add" || operation.op === "replace" || operation.op === "test") && operation.value === void 0) {
        throw new exports2.JsonPatchError("Operation `value` property is not present (applicable in `add`, `replace` and `test` operations)", "OPERATION_VALUE_REQUIRED", index, operation, document2);
      } else if ((operation.op === "add" || operation.op === "replace" || operation.op === "test") && helpers_js_1.hasUndefined(operation.value)) {
        throw new exports2.JsonPatchError("Operation `value` property is not present (applicable in `add`, `replace` and `test` operations)", "OPERATION_VALUE_CANNOT_CONTAIN_UNDEFINED", index, operation, document2);
      } else if (document2) {
        if (operation.op == "add") {
          var pathLen = operation.path.split("/").length;
          var existingPathLen = existingPathFragment.split("/").length;
          if (pathLen !== existingPathLen + 1 && pathLen !== existingPathLen) {
            throw new exports2.JsonPatchError("Cannot perform an `add` operation at the desired path", "OPERATION_PATH_CANNOT_ADD", index, operation, document2);
          }
        } else if (operation.op === "replace" || operation.op === "remove" || operation.op === "_get") {
          if (operation.path !== existingPathFragment) {
            throw new exports2.JsonPatchError("Cannot perform the operation at a path that does not exist", "OPERATION_PATH_UNRESOLVABLE", index, operation, document2);
          }
        } else if (operation.op === "move" || operation.op === "copy") {
          var existingValue = { op: "_get", path: operation.from, value: void 0 };
          var error = validate([existingValue], document2);
          if (error && error.name === "OPERATION_PATH_UNRESOLVABLE") {
            throw new exports2.JsonPatchError("Cannot perform the operation from a path that does not exist", "OPERATION_FROM_UNRESOLVABLE", index, operation, document2);
          }
        }
      }
    }
    exports2.validator = validator;
    function validate(sequence, document2, externalValidator) {
      try {
        if (!Array.isArray(sequence)) {
          throw new exports2.JsonPatchError("Patch sequence must be an array", "SEQUENCE_NOT_AN_ARRAY");
        }
        if (document2) {
          applyPatch(helpers_js_1._deepClone(document2), helpers_js_1._deepClone(sequence), externalValidator || true);
        } else {
          externalValidator = externalValidator || validator;
          for (var i = 0; i < sequence.length; i++) {
            externalValidator(sequence[i], i, document2, void 0);
          }
        }
      } catch (e) {
        if (e instanceof exports2.JsonPatchError) {
          return e;
        } else {
          throw e;
        }
      }
    }
    exports2.validate = validate;
    function _areEquals(a, b) {
      if (a === b)
        return true;
      if (a && b && typeof a == "object" && typeof b == "object") {
        var arrA = Array.isArray(a), arrB = Array.isArray(b), i, length, key;
        if (arrA && arrB) {
          length = a.length;
          if (length != b.length)
            return false;
          for (i = length; i-- !== 0; )
            if (!_areEquals(a[i], b[i]))
              return false;
          return true;
        }
        if (arrA != arrB)
          return false;
        var keys = Object.keys(a);
        length = keys.length;
        if (length !== Object.keys(b).length)
          return false;
        for (i = length; i-- !== 0; )
          if (!b.hasOwnProperty(keys[i]))
            return false;
        for (i = length; i-- !== 0; ) {
          key = keys[i];
          if (!_areEquals(a[key], b[key]))
            return false;
        }
        return true;
      }
      return a !== a && b !== b;
    }
    exports2._areEquals = _areEquals;
  }
});

// node_modules/fast-json-patch/commonjs/duplex.js
var require_duplex = __commonJS({
  "node_modules/fast-json-patch/commonjs/duplex.js"(exports2) {
    Object.defineProperty(exports2, "__esModule", { value: true });
    var helpers_js_1 = require_helpers();
    var core_js_1 = require_core();
    var beforeDict = /* @__PURE__ */ new WeakMap();
    var Mirror = (
      /** @class */
      /* @__PURE__ */ function() {
        function Mirror2(obj) {
          this.observers = /* @__PURE__ */ new Map();
          this.obj = obj;
        }
        return Mirror2;
      }()
    );
    var ObserverInfo = (
      /** @class */
      /* @__PURE__ */ function() {
        function ObserverInfo2(callback, observer) {
          this.callback = callback;
          this.observer = observer;
        }
        return ObserverInfo2;
      }()
    );
    function getMirror(obj) {
      return beforeDict.get(obj);
    }
    function getObserverFromMirror(mirror, callback) {
      return mirror.observers.get(callback);
    }
    function removeObserverFromMirror(mirror, observer) {
      mirror.observers.delete(observer.callback);
    }
    function unobserve(root, observer) {
      observer.unobserve();
    }
    exports2.unobserve = unobserve;
    function observe(obj, callback) {
      var patches = [];
      var observer;
      var mirror = getMirror(obj);
      if (!mirror) {
        mirror = new Mirror(obj);
        beforeDict.set(obj, mirror);
      } else {
        var observerInfo = getObserverFromMirror(mirror, callback);
        observer = observerInfo && observerInfo.observer;
      }
      if (observer) {
        return observer;
      }
      observer = {};
      mirror.value = helpers_js_1._deepClone(obj);
      if (callback) {
        observer.callback = callback;
        observer.next = null;
        var dirtyCheck = function() {
          generate(observer);
        };
        var fastCheck = function() {
          clearTimeout(observer.next);
          observer.next = setTimeout(dirtyCheck);
        };
        if (typeof window !== "undefined") {
          window.addEventListener("mouseup", fastCheck);
          window.addEventListener("keyup", fastCheck);
          window.addEventListener("mousedown", fastCheck);
          window.addEventListener("keydown", fastCheck);
          window.addEventListener("change", fastCheck);
        }
      }
      observer.patches = patches;
      observer.object = obj;
      observer.unobserve = function() {
        generate(observer);
        clearTimeout(observer.next);
        removeObserverFromMirror(mirror, observer);
        if (typeof window !== "undefined") {
          window.removeEventListener("mouseup", fastCheck);
          window.removeEventListener("keyup", fastCheck);
          window.removeEventListener("mousedown", fastCheck);
          window.removeEventListener("keydown", fastCheck);
          window.removeEventListener("change", fastCheck);
        }
      };
      mirror.observers.set(callback, new ObserverInfo(callback, observer));
      return observer;
    }
    exports2.observe = observe;
    function generate(observer, invertible) {
      if (invertible === void 0) {
        invertible = false;
      }
      var mirror = beforeDict.get(observer.object);
      _generate(mirror.value, observer.object, observer.patches, "", invertible);
      if (observer.patches.length) {
        core_js_1.applyPatch(mirror.value, observer.patches);
      }
      var temp = observer.patches;
      if (temp.length > 0) {
        observer.patches = [];
        if (observer.callback) {
          observer.callback(temp);
        }
      }
      return temp;
    }
    exports2.generate = generate;
    function _generate(mirror, obj, patches, path3, invertible) {
      if (obj === mirror) {
        return;
      }
      if (typeof obj.toJSON === "function") {
        obj = obj.toJSON();
      }
      var newKeys = helpers_js_1._objectKeys(obj);
      var oldKeys = helpers_js_1._objectKeys(mirror);
      var changed = false;
      var deleted = false;
      for (var t = oldKeys.length - 1; t >= 0; t--) {
        var key = oldKeys[t];
        var oldVal = mirror[key];
        if (helpers_js_1.hasOwnProperty(obj, key) && !(obj[key] === void 0 && oldVal !== void 0 && Array.isArray(obj) === false)) {
          var newVal = obj[key];
          if (typeof oldVal == "object" && oldVal != null && typeof newVal == "object" && newVal != null && Array.isArray(oldVal) === Array.isArray(newVal)) {
            _generate(oldVal, newVal, patches, path3 + "/" + helpers_js_1.escapePathComponent(key), invertible);
          } else {
            if (oldVal !== newVal) {
              changed = true;
              if (invertible) {
                patches.push({ op: "test", path: path3 + "/" + helpers_js_1.escapePathComponent(key), value: helpers_js_1._deepClone(oldVal) });
              }
              patches.push({ op: "replace", path: path3 + "/" + helpers_js_1.escapePathComponent(key), value: helpers_js_1._deepClone(newVal) });
            }
          }
        } else if (Array.isArray(mirror) === Array.isArray(obj)) {
          if (invertible) {
            patches.push({ op: "test", path: path3 + "/" + helpers_js_1.escapePathComponent(key), value: helpers_js_1._deepClone(oldVal) });
          }
          patches.push({ op: "remove", path: path3 + "/" + helpers_js_1.escapePathComponent(key) });
          deleted = true;
        } else {
          if (invertible) {
            patches.push({ op: "test", path: path3, value: mirror });
          }
          patches.push({ op: "replace", path: path3, value: obj });
          changed = true;
        }
      }
      if (!deleted && newKeys.length == oldKeys.length) {
        return;
      }
      for (var t = 0; t < newKeys.length; t++) {
        var key = newKeys[t];
        if (!helpers_js_1.hasOwnProperty(mirror, key) && obj[key] !== void 0) {
          patches.push({ op: "add", path: path3 + "/" + helpers_js_1.escapePathComponent(key), value: helpers_js_1._deepClone(obj[key]) });
        }
      }
    }
    function compare(tree1, tree2, invertible) {
      if (invertible === void 0) {
        invertible = false;
      }
      var patches = [];
      _generate(tree1, tree2, patches, "", invertible);
      return patches;
    }
    exports2.compare = compare;
  }
});

// node_modules/fast-json-patch/index.js
var require_fast_json_patch = __commonJS({
  "node_modules/fast-json-patch/index.js"(exports2) {
    var core = require_core();
    Object.assign(exports2, core);
    var duplex = require_duplex();
    Object.assign(exports2, duplex);
    var helpers = require_helpers();
    exports2.JsonPatchError = helpers.PatchError;
    exports2.deepClone = helpers._deepClone;
    exports2.escapePathComponent = helpers.escapePathComponent;
    exports2.unescapePathComponent = helpers.unescapePathComponent;
  }
});

// src/sensorActions.js
var require_sensorActions = __commonJS({
  "src/sensorActions.js"(exports2, module2) {
    var dfu2 = require_nrfbledfu().nordicDFU;
    var gwutils2 = require_gwutils();
    var phantomService2 = require_phantomService().phantomService;
    var sensorDefinition2 = require_sensorDefinition();
    var gwCrypto2 = require_crypto().gwCrypto;
    var gwapi2 = require_gwapi();
    var g_GWState = null;
    var seq = 0;
    var remotePromises = {};
    var sensorActions2 = class {
      static init(_gwGlobalState) {
        g_GWState = _gwGlobalState;
        gwutils2.subscribeToEvent("sensorActionProgress", ((eventdata) => {
          try {
            if (eventdata.state == "done") {
              clearTimeout(remotePromises?.[eventdata.gwSerial]?.[eventdata.seq].timeout);
              remotePromises?.[eventdata.gwSerial]?.[eventdata.seq].resolve(eventdata.result);
              delete remotePromises?.[eventdata.gwSerial]?.[eventdata.seq];
            } else if (eventdata.state == "progress") {
              if (remotePromises?.[eventdata.gwSerial]?.[eventdata.seq].timeout) {
                clearTimeout(remotePromises?.[eventdata.gwSerial]?.[eventdata.seq].timeout);
                remotePromises[eventdata.gwSerial][eventdata.seq].timeout = setTimeout(() => {
                  remotePromises?.[eventdata.gwSerial]?.[eventdata.seq].resolve(eventdata.result);
                  delete remotePromises?.[eventdata.gwSerial]?.[eventdata.seq];
                }, 3e4);
              }
              this.setSensorProgress(eventdata, eventdata.actionState, eventdata.actionProgress);
            }
          } catch (e) {
          }
        }).bind(this));
        gwutils2.subscribeToEvent("sensorActionDispatch", async (eventdata) => {
          let retval = await this.sensorActionDispatch(eventdata.action, eventdata.actionParams);
          gwapi2.sendToMainGW("sensorActionProgress", {
            state: "done",
            seq: eventdata.actionParams.seq,
            gwSerial: eventdata.actionParams.gwSerial,
            result: retval
          });
        });
      }
      static async sensorActionDownload(actionDownloadParams) {
        let retval = null;
        let ps2 = new phantomService2(
          actionDownloadParams.bledevice,
          actionDownloadParams.connKey,
          actionDownloadParams.phantomCode
        );
        try {
          let result2 = await ps2.connect(actionDownloadParams.recordTime);
          console.log("Connection result", result2 ? true : false);
          if (result2) {
            this.setSensorProgress(actionDownloadParams, "downloading", 0);
            let downloadret = null;
            if (phantomService2.isTriaxial(actionDownloadParams.type)) {
              let axis = 0;
              let isSequantially = false;
              if (actionDownloadParams.recordinSettings.axisCount == 1) {
                switch (actionDownloadParams.recordinSettings.axis) {
                  case "x":
                    axis = 0;
                    break;
                  case "y":
                    axis = 1;
                    break;
                  case "z":
                    axis = 2;
                    break;
                  case "sequentially":
                    if (!g_GWState.nodes[actionDownloadParams.phantomCode].nextSeqAxis)
                      g_GWState.nodes[actionDownloadParams.phantomCode].nextSeqAxis = 0;
                    axis = 0;
                    console.log("recording sequally axis", axis);
                    isSequantially = true;
                    break;
                }
              }
              if (actionDownloadParams.collectafterdisconnect) {
                downloadret = await ps2.downloadPhantomSignal({
                  range: actionDownloadParams.recordinSettings.range,
                  sampleRate: actionDownloadParams.recordinSettings.sampleRate,
                  axisCount: actionDownloadParams.recordinSettings.axisCount,
                  axis,
                  samples: actionDownloadParams.recordinSettings.samples,
                  existing: false,
                  collectafterdisconnect: true,
                  gwSerial: actionDownloadParams.gwSerial
                }, function(progress) {
                  this.setSensorProgress(actionDownloadParams, "downloading", progress);
                }.bind(this));
                if (downloadret && downloadret.scheduledDownload) {
                  retval = {
                    phatomCode: actionDownloadParams.phantomCode,
                    scheduledDownload: true
                  };
                }
              } else if (!actionDownloadParams.justCollect) {
                for (let i = 0; i < 3; i++) {
                  downloadret = await ps2.downloadPhantomSignal({
                    range: actionDownloadParams.recordinSettings.range,
                    sampleRate: actionDownloadParams.recordinSettings.sampleRate,
                    axisCount: actionDownloadParams.recordinSettings.axisCount,
                    axis,
                    samples: actionDownloadParams.recordinSettings.samples,
                    existing: false,
                    collectafterdisconnect: false
                  }, function(progress) {
                    if (isSequantially) {
                      progress = i * (1 / 3) + progress / 3;
                    }
                    this.setSensorProgress(actionDownloadParams, "downloading", progress);
                  }.bind(this));
                  if (downloadret && downloadret.data && downloadret.header) {
                    downloadret.alarm = actionDownloadParams.alarmedLevel2;
                    downloadret.start = actionDownloadParams.restart || actionDownloadParams.manual;
                    downloadret.triggered = actionDownloadParams.triggered;
                    if (!retval) {
                      retval = {
                        phatomCode: actionDownloadParams.phantomCode,
                        downloadret,
                        downloadretArray: [downloadret]
                      };
                    } else {
                      retval.downloadretArray.push(downloadret);
                    }
                  } else {
                    break;
                  }
                  if (!isSequantially)
                    break;
                  axis++;
                }
              } else {
                downloadret = await ps2.downloadPhantomSignal({
                  range: actionDownloadParams.recordinSettings.range,
                  sampleRate: actionDownloadParams.recordinSettings.sampleRate,
                  axisCount: actionDownloadParams.recordinSettings.axisCount,
                  axis,
                  samples: actionDownloadParams.recordinSettings.samples,
                  existing: true
                }, function(progress) {
                  this.setSensorProgress(actionDownloadParams, "downloading", progress);
                }.bind(this));
                if (downloadret && downloadret.data && downloadret.header) {
                  await ps2.downloadPhantomSignal({
                    clear: true
                  });
                  downloadret.alarm = actionDownloadParams.alarmedLevel2;
                  downloadret.start = actionDownloadParams.restart || actionDownloadParams.manual;
                  retval = {
                    phatomCode: actionDownloadParams.phantomCode,
                    downloadret
                  };
                }
              }
            } else if (phantomService2.isGP(actionDownloadParams.type)) {
              console.log("Downloading data from GP sensor");
              downloadret = await ps2.downloadPhantomSignalGP(function(progress) {
                console.log("progress", progress);
                this.setSensorProgress(actionDownloadParams, "downloading", progress);
              }.bind(this));
              if (downloadret && downloadret.data && downloadret.header) {
                downloadret.alarm = actionDownloadParams.alarmedLevel2;
                downloadret.start = actionDownloadParams.restart || actionDownloadParams.manual;
                retval = {
                  phatomCode: actionDownloadParams.phantomCode,
                  downloadret
                };
              }
            } else if (phantomService2.isThermalImage(actionDownloadParams.type)) {
              downloadret = await ps2.downloadPhantomThermalImage(1, 1, 1, function(progress) {
                this.setSensorProgress(actionDownloadParams, "downloading", progress);
              }.bind(this));
              if (downloadret && downloadret.data && downloadret.header) {
                downloadret.alarm = actionDownloadParams.alarmedLevel2;
                downloadret.start = actionDownloadParams.manual;
                retval = {
                  phatomCode: actionDownloadParams.phantomCode,
                  downloadret
                };
              }
            }
            console.log("Disconnecting");
            try {
              await ps2.disconnect();
            } catch (e) {
            }
          }
        } catch (e) {
          console.log("Exception when downloading data", e);
        }
        return retval;
      }
      static async sensorActionEncrypt(actionParams) {
        let retval = false;
        let ps2 = new phantomService2(
          actionParams.bledevice,
          actionParams.connKey,
          actionParams.phantomCode
        );
        try {
          let result2 = await ps2.connect();
          console.log("Connection result", result2 ? true : false);
          if (result2) {
            let enable = actionParams.enableEncryption;
            this.setSensorProgress(actionParams, "encrypting", 0);
            console.log("Paring...");
            if (!ps2.encrypted)
              await ps2.pairConnection();
            this.setSensorProgress(actionParams, "updating", 0);
            if (ps2.encrypted) {
              let connKey = null;
              let advKey = null;
              if (enable) {
                connKey = actionParams.newConnKey;
                advKey = actionParams.newAdvKey;
              } else {
                connKey = advKey = Buffer.alloc(16);
              }
              console.log("Set Key");
              let keyConfigBlock = ps2.generateGW2KeyConfig1(enable, connKey, advKey);
              let response = await ps2.setConfigBlock(119, keyConfigBlock);
              retval = true;
              response = await ps2.applyConfig();
              console.log("applyConfig", response);
            }
          }
        } catch (e) {
          console.log("Error when exchanging keys?", e);
        }
        try {
          await ps2.disconnect();
        } catch (e) {
        }
        return retval;
      }
      static async sensorActionSleep(actionParams) {
        let retval = false;
        let ps2 = new phantomService2(
          actionParams.bledevice,
          actionParams.connKey,
          actionParams.phantomCode
        );
        try {
          let result2 = await ps2.connect();
          console.log("Connection result", result2 ? true : false);
          if (result2) {
            this.setSensorProgress(actionParams, "puttingtosleep", 0);
            try {
              ps2.putToSleep();
              retval = true;
              ps2.disconnect();
            } catch (e) {
            }
          }
        } catch (e) {
          console.log("Error when putting to sleep", e);
        }
        return retval;
      }
      static async sensorActionUpdateState(actionParams) {
        let success = false;
        let ps2 = new phantomService2(
          actionParams.bledevice,
          actionParams.connKey,
          actionParams.phantomCode
        );
        try {
          let result2 = await ps2.connect();
          console.log("Connection result", result2 ? true : false);
          if (result2) {
            this.setSensorProgress(actionParams, "requesting", 0);
            await ps2.updateState();
            success = true;
          }
        } catch (e) {
          console.log("Error when updating state settings?", e);
        }
        try {
          await ps2.disconnect();
        } catch (e) {
        }
        return success;
      }
      static async sensorActionChangeSettings(actionParams) {
        let success = false;
        let ps2 = new phantomService2(
          actionParams.bledevice,
          actionParams.connKey,
          actionParams.phantomCode
        );
        try {
          let result2 = await ps2.connect();
          console.log("Connection result", result2 ? true : false);
          if (result2) {
            this.setSensorProgress(actionParams, "changing", 0);
            let txPower = actionParams.changeSettingsParams.general.txPower;
            let updateInterval = actionParams.changeSettingsParams.general.updateInterval;
            let advertising = actionParams.changeSettingsParams.general.advertising;
            let gw1 = actionParams.changeSettingsParams.general.gw1;
            let onlygw1valid = actionParams.changeSettingsParams.general.onlygw1valid;
            let longRange = actionParams.changeSettingsParams.general.longRange ? true : false;
            let amplifierEnabled = actionParams.changeSettingsParams.general.amplifierEnabled;
            let advInterval = actionParams.changeSettingsParams.general.advInterval;
            let basicGw2Block = ps2.generateGW2BasicConfig1(txPower, updateInterval, gw1, advertising, onlygw1valid, longRange, amplifierEnabled, advInterval);
            console.log("Generate config block", basicGw2Block);
            let response = await ps2.setConfigBlock(6, basicGw2Block);
            console.log("set config response", response);
            if (phantomService2.isTriaxial(actionParams.type) && actionParams.changeSettingsParams.triaxial) {
              let triaxial1Block = ps2.generateGW2TriaxialConfig1(
                actionParams.changeSettingsParams.triaxial.minRMSFreq,
                actionParams.changeSettingsParams.triaxial.maxRMSFreq,
                actionParams.changeSettingsParams.triaxial.range,
                actionParams.changeSettingsParams.triaxial.recordingSettings,
                actionParams.changeSettingsParams.triaxial.extRMS
              );
              let response2 = await ps2.setConfigBlock(16, triaxial1Block);
            } else if (phantomService2.isCurrentSensor(actionParams.type) && actionParams.changeSettingsParams.current) {
              let current1Block = ps2.generateGW2CurrentConfig1(
                actionParams.changeSettingsParams.current.currentProbeType,
                actionParams.changeSettingsParams.current.multiplier,
                actionParams.changeSettingsParams.current.offset
              );
              let response2 = await ps2.setConfigBlock(1, current1Block);
            } else if (phantomService2.isGP(actionParams.type) && actionParams.changeSettingsParams.gp) {
              let gp1Block = ps2.generateGW2GPConfig1(
                actionParams.changeSettingsParams.gp.minRMSFreq,
                actionParams.changeSettingsParams.gp.maxRMSFreq,
                actionParams.changeSettingsParams.gp.sensitivity,
                actionParams.changeSettingsParams.gp.velocity
              );
              let response2 = await ps2.setConfigBlock(16, gp1Block);
            } else if (phantomService2.isRPMSensor(actionParams.type) && actionParams.changeSettingsParams.rpm && actionParams.version >= 142) {
              let rpm1Block = ps2.generateGW2RPMConfig1(
                actionParams.changeSettingsParams.rpm.highPerformace,
                actionParams.changeSettingsParams.rpm.rpmTimeout
              );
              let response2 = await ps2.setConfigBlock(16, rpm1Block);
            } else if (phantomService2.isDryContacts(actionParams.type) && actionParams.changeSettingsParams.drycontacts && actionParams.version >= 108) {
              let dryContacts1Block = ps2.generateGW2DryContactsConfig1(actionParams.changeSettingsParams.drycontacts.debounce);
              let response2 = await ps2.setConfigBlock(16, dryContacts1Block);
            }
            success = true;
            response = await ps2.applyConfig();
            console.log("applyConfig", response);
          }
        } catch (e) {
          console.log("Error when changing settings?", e);
        }
        try {
          await ps2.disconnect();
        } catch (e) {
        }
        return success;
      }
      static async sensorActionJumpBootloader(actionParams) {
        let success = false;
        let ps2 = new phantomService2(
          actionParams.bledevice,
          actionParams.connKey,
          actionParams.phantomCode
        );
        try {
          let result2 = await ps2.connect();
          if (result2) {
            console.log("Jumping to bootloader...");
            await ps2.jumpToBootloader();
            await ps2.disconnect();
          }
        } catch (e) {
        }
      }
      static async sensorActionDFU(actionParams) {
        let result2 = false;
        try {
          this.setSensorProgress(actionParams, "connecting", 0);
          let dfuConn = new dfu2(actionParams.bledevice, actionParams.firmware.ini, actionParams.firmware.bin);
          result2 = await dfuConn.update(function(progress) {
            this.setSensorProgress(actionParams, "updating", progress);
          }.bind(this));
        } catch (e) {
          console.log("Error during update", e);
        }
        return result2;
      }
      static setSensorProgress(actionParams, actionState, actionProgress) {
        if (gwutils2.isSubordinate()) {
          gwapi2.sendToMainGW("sensorActionProgress", {
            state: "progress",
            phantomCode: actionParams.phantomCode,
            seq: actionParams.seq,
            gwSerial: actionParams.gwSerial,
            actionState,
            actionProgress
          });
        } else {
          if (g_GWState.nodes[actionParams.phantomCode]) {
            if (g_GWState.nodes[actionParams.phantomCode].actionstate != actionState)
              g_GWState.nodes[actionParams.phantomCode].actionstate = actionState;
            g_GWState.nodes[actionParams.phantomCode].actionprogress = actionProgress;
            gwutils2.gwUpdateGlobalState();
          }
        }
      }
      static async sensorActionDispatch(action, actionParams, isLocal) {
        if (actionParams.encrypted && !actionParams.connKey)
          actionParams.connKey = gwCrypto2.getKey(actionParams.phantomCode, "connKey");
        if (isLocal)
          g_GWState.nodes[actionParams.phantomCode].actionsubordinate = actionParams.gwSerial;
        if (actionParams.gwSerial != g_GWState.deviceInfo.serialNumber) {
          seq++;
          actionParams.seq = seq;
          let result2 = gwapi2.sendToSubordinate(actionParams.gwSerial, "sensorActionDispatch", {
            sensorAction: action,
            actionParams
          });
          if (!result2)
            return false;
          if (!remotePromises[actionParams.gwSerial])
            remotePromises[actionParams.gwSerial] = {};
          let connectionPromise = new Promise(function(resolve2, reject) {
            remotePromises[actionParams.gwSerial][seq] = {
              resolve: resolve2,
              reject,
              timeout: setTimeout(() => {
                resolve2(false);
                delete remotePromises[actionParams.gwSerial][seq];
              }, 3e4)
            };
          });
          return connectionPromise;
        } else {
          if (action == "downloadSignal") {
            return this.sensorActionDownload(actionParams);
          } else if (action == "encrypt") {
            return this.sensorActionEncrypt(actionParams);
          } else if (action == "sleep") {
            return this.sensorActionSleep(actionParams);
          } else if (action == "updatestate") {
            return this.sensorActionUpdateState(actionParams);
          } else if (action == "changesettings") {
            return this.sensorActionChangeSettings(actionParams);
          } else if (action == "jumptobootloader") {
            return this.sensorActionJumpBootloader(actionParams);
          } else if (action == "dfu") {
            return this.sensorActionDFU(actionParams);
          }
        }
        return void 0;
      }
    };
    module2.exports.sensorActions = sensorActions2;
  }
});

// node_modules/@tinyhttp/forwarded/dist/index.js
function forwarded(req) {
  const proxyAddrs = parse(req.headers["x-forwarded-for"] || "");
  const socketAddr = req.connection.remoteAddress;
  return [socketAddr].concat(proxyAddrs);
}
function parse(header) {
  let end = header.length;
  const list = [];
  let start = header.length;
  for (let i = header.length - 1; i >= 0; i--) {
    switch (header.charCodeAt(i)) {
      case 32:
        if (start === end) {
          start = end = i;
        }
        break;
      case 44:
        if (start !== end) {
          list.push(header.substring(start, end));
        }
        start = end = i;
        break;
      default:
        start = i;
        break;
    }
  }
  if (start !== end)
    list.push(header.substring(start, end));
  return list;
}
var init_dist = __esm({
  "node_modules/@tinyhttp/forwarded/dist/index.js"() {
  }
});

// node_modules/ipaddr.js/lib/ipaddr.js
var require_ipaddr = __commonJS({
  "node_modules/ipaddr.js/lib/ipaddr.js"(exports2, module2) {
    (function(root) {
      "use strict";
      const ipv4Part = "(0?\\d+|0x[a-f0-9]+)";
      const ipv4Regexes = {
        fourOctet: new RegExp(`^${ipv4Part}\\.${ipv4Part}\\.${ipv4Part}\\.${ipv4Part}$`, "i"),
        threeOctet: new RegExp(`^${ipv4Part}\\.${ipv4Part}\\.${ipv4Part}$`, "i"),
        twoOctet: new RegExp(`^${ipv4Part}\\.${ipv4Part}$`, "i"),
        longValue: new RegExp(`^${ipv4Part}$`, "i")
      };
      const octalRegex = new RegExp(`^0[0-7]+$`, "i");
      const hexRegex = new RegExp(`^0x[a-f0-9]+$`, "i");
      const zoneIndex = "%[0-9a-z]{1,}";
      const ipv6Part = "(?:[0-9a-f]+::?)+";
      const ipv6Regexes = {
        zoneIndex: new RegExp(zoneIndex, "i"),
        "native": new RegExp(`^(::)?(${ipv6Part})?([0-9a-f]+)?(::)?(${zoneIndex})?$`, "i"),
        deprecatedTransitional: new RegExp(`^(?:::)(${ipv4Part}\\.${ipv4Part}\\.${ipv4Part}\\.${ipv4Part}(${zoneIndex})?)$`, "i"),
        transitional: new RegExp(`^((?:${ipv6Part})|(?:::)(?:${ipv6Part})?)${ipv4Part}\\.${ipv4Part}\\.${ipv4Part}\\.${ipv4Part}(${zoneIndex})?$`, "i")
      };
      function expandIPv6(string, parts) {
        if (string.indexOf("::") !== string.lastIndexOf("::")) {
          return null;
        }
        let colonCount = 0;
        let lastColon = -1;
        let zoneId = (string.match(ipv6Regexes.zoneIndex) || [])[0];
        let replacement, replacementCount;
        if (zoneId) {
          zoneId = zoneId.substring(1);
          string = string.replace(/%.+$/, "");
        }
        while ((lastColon = string.indexOf(":", lastColon + 1)) >= 0) {
          colonCount++;
        }
        if (string.substr(0, 2) === "::") {
          colonCount--;
        }
        if (string.substr(-2, 2) === "::") {
          colonCount--;
        }
        if (colonCount > parts) {
          return null;
        }
        replacementCount = parts - colonCount;
        replacement = ":";
        while (replacementCount--) {
          replacement += "0:";
        }
        string = string.replace("::", replacement);
        if (string[0] === ":") {
          string = string.slice(1);
        }
        if (string[string.length - 1] === ":") {
          string = string.slice(0, -1);
        }
        parts = function() {
          const ref = string.split(":");
          const results = [];
          for (let i = 0; i < ref.length; i++) {
            results.push(parseInt(ref[i], 16));
          }
          return results;
        }();
        return {
          parts,
          zoneId
        };
      }
      function matchCIDR(first, second, partSize, cidrBits) {
        if (first.length !== second.length) {
          throw new Error("ipaddr: cannot match CIDR for objects with different lengths");
        }
        let part = 0;
        let shift;
        while (cidrBits > 0) {
          shift = partSize - cidrBits;
          if (shift < 0) {
            shift = 0;
          }
          if (first[part] >> shift !== second[part] >> shift) {
            return false;
          }
          cidrBits -= partSize;
          part += 1;
        }
        return true;
      }
      function parseIntAuto(string) {
        if (hexRegex.test(string)) {
          return parseInt(string, 16);
        }
        if (string[0] === "0" && !isNaN(parseInt(string[1], 10))) {
          if (octalRegex.test(string)) {
            return parseInt(string, 8);
          }
          throw new Error(`ipaddr: cannot parse ${string} as octal`);
        }
        return parseInt(string, 10);
      }
      function padPart(part, length) {
        while (part.length < length) {
          part = `0${part}`;
        }
        return part;
      }
      const ipaddr2 = {};
      ipaddr2.IPv4 = function() {
        function IPv4(octets) {
          if (octets.length !== 4) {
            throw new Error("ipaddr: ipv4 octet count should be 4");
          }
          let i, octet;
          for (i = 0; i < octets.length; i++) {
            octet = octets[i];
            if (!(0 <= octet && octet <= 255)) {
              throw new Error("ipaddr: ipv4 octet should fit in 8 bits");
            }
          }
          this.octets = octets;
        }
        IPv4.prototype.SpecialRanges = {
          unspecified: [[new IPv4([0, 0, 0, 0]), 8]],
          broadcast: [[new IPv4([255, 255, 255, 255]), 32]],
          // RFC3171
          multicast: [[new IPv4([224, 0, 0, 0]), 4]],
          // RFC3927
          linkLocal: [[new IPv4([169, 254, 0, 0]), 16]],
          // RFC5735
          loopback: [[new IPv4([127, 0, 0, 0]), 8]],
          // RFC6598
          carrierGradeNat: [[new IPv4([100, 64, 0, 0]), 10]],
          // RFC1918
          "private": [
            [new IPv4([10, 0, 0, 0]), 8],
            [new IPv4([172, 16, 0, 0]), 12],
            [new IPv4([192, 168, 0, 0]), 16]
          ],
          // Reserved and testing-only ranges; RFCs 5735, 5737, 2544, 1700
          reserved: [
            [new IPv4([192, 0, 0, 0]), 24],
            [new IPv4([192, 0, 2, 0]), 24],
            [new IPv4([192, 88, 99, 0]), 24],
            [new IPv4([198, 18, 0, 0]), 15],
            [new IPv4([198, 51, 100, 0]), 24],
            [new IPv4([203, 0, 113, 0]), 24],
            [new IPv4([240, 0, 0, 0]), 4]
          ]
        };
        IPv4.prototype.kind = function() {
          return "ipv4";
        };
        IPv4.prototype.match = function(other, cidrRange) {
          let ref;
          if (cidrRange === void 0) {
            ref = other;
            other = ref[0];
            cidrRange = ref[1];
          }
          if (other.kind() !== "ipv4") {
            throw new Error("ipaddr: cannot match ipv4 address with non-ipv4 one");
          }
          return matchCIDR(this.octets, other.octets, 8, cidrRange);
        };
        IPv4.prototype.prefixLengthFromSubnetMask = function() {
          let cidr = 0;
          let stop = false;
          const zerotable = {
            0: 8,
            128: 7,
            192: 6,
            224: 5,
            240: 4,
            248: 3,
            252: 2,
            254: 1,
            255: 0
          };
          let i, octet, zeros;
          for (i = 3; i >= 0; i -= 1) {
            octet = this.octets[i];
            if (octet in zerotable) {
              zeros = zerotable[octet];
              if (stop && zeros !== 0) {
                return null;
              }
              if (zeros !== 8) {
                stop = true;
              }
              cidr += zeros;
            } else {
              return null;
            }
          }
          return 32 - cidr;
        };
        IPv4.prototype.range = function() {
          return ipaddr2.subnetMatch(this, this.SpecialRanges);
        };
        IPv4.prototype.toByteArray = function() {
          return this.octets.slice(0);
        };
        IPv4.prototype.toIPv4MappedAddress = function() {
          return ipaddr2.IPv6.parse(`::ffff:${this.toString()}`);
        };
        IPv4.prototype.toNormalizedString = function() {
          return this.toString();
        };
        IPv4.prototype.toString = function() {
          return this.octets.join(".");
        };
        return IPv4;
      }();
      ipaddr2.IPv4.broadcastAddressFromCIDR = function(string) {
        try {
          const cidr = this.parseCIDR(string);
          const ipInterfaceOctets = cidr[0].toByteArray();
          const subnetMaskOctets = this.subnetMaskFromPrefixLength(cidr[1]).toByteArray();
          const octets = [];
          let i = 0;
          while (i < 4) {
            octets.push(parseInt(ipInterfaceOctets[i], 10) | parseInt(subnetMaskOctets[i], 10) ^ 255);
            i++;
          }
          return new this(octets);
        } catch (e) {
          throw new Error("ipaddr: the address does not have IPv4 CIDR format");
        }
      };
      ipaddr2.IPv4.isIPv4 = function(string) {
        return this.parser(string) !== null;
      };
      ipaddr2.IPv4.isValid = function(string) {
        try {
          new this(this.parser(string));
          return true;
        } catch (e) {
          return false;
        }
      };
      ipaddr2.IPv4.isValidFourPartDecimal = function(string) {
        if (ipaddr2.IPv4.isValid(string) && string.match(/^(0|[1-9]\d*)(\.(0|[1-9]\d*)){3}$/)) {
          return true;
        } else {
          return false;
        }
      };
      ipaddr2.IPv4.networkAddressFromCIDR = function(string) {
        let cidr, i, ipInterfaceOctets, octets, subnetMaskOctets;
        try {
          cidr = this.parseCIDR(string);
          ipInterfaceOctets = cidr[0].toByteArray();
          subnetMaskOctets = this.subnetMaskFromPrefixLength(cidr[1]).toByteArray();
          octets = [];
          i = 0;
          while (i < 4) {
            octets.push(parseInt(ipInterfaceOctets[i], 10) & parseInt(subnetMaskOctets[i], 10));
            i++;
          }
          return new this(octets);
        } catch (e) {
          throw new Error("ipaddr: the address does not have IPv4 CIDR format");
        }
      };
      ipaddr2.IPv4.parse = function(string) {
        const parts = this.parser(string);
        if (parts === null) {
          throw new Error("ipaddr: string is not formatted like an IPv4 Address");
        }
        return new this(parts);
      };
      ipaddr2.IPv4.parseCIDR = function(string) {
        let match;
        if (match = string.match(/^(.+)\/(\d+)$/)) {
          const maskLength = parseInt(match[2]);
          if (maskLength >= 0 && maskLength <= 32) {
            const parsed = [this.parse(match[1]), maskLength];
            Object.defineProperty(parsed, "toString", {
              value: function() {
                return this.join("/");
              }
            });
            return parsed;
          }
        }
        throw new Error("ipaddr: string is not formatted like an IPv4 CIDR range");
      };
      ipaddr2.IPv4.parser = function(string) {
        let match, part, value;
        if (match = string.match(ipv4Regexes.fourOctet)) {
          return function() {
            const ref = match.slice(1, 6);
            const results = [];
            for (let i = 0; i < ref.length; i++) {
              part = ref[i];
              results.push(parseIntAuto(part));
            }
            return results;
          }();
        } else if (match = string.match(ipv4Regexes.longValue)) {
          value = parseIntAuto(match[1]);
          if (value > 4294967295 || value < 0) {
            throw new Error("ipaddr: address outside defined range");
          }
          return function() {
            const results = [];
            let shift;
            for (shift = 0; shift <= 24; shift += 8) {
              results.push(value >> shift & 255);
            }
            return results;
          }().reverse();
        } else if (match = string.match(ipv4Regexes.twoOctet)) {
          return function() {
            const ref = match.slice(1, 4);
            const results = [];
            value = parseIntAuto(ref[1]);
            if (value > 16777215 || value < 0) {
              throw new Error("ipaddr: address outside defined range");
            }
            results.push(parseIntAuto(ref[0]));
            results.push(value >> 16 & 255);
            results.push(value >> 8 & 255);
            results.push(value & 255);
            return results;
          }();
        } else if (match = string.match(ipv4Regexes.threeOctet)) {
          return function() {
            const ref = match.slice(1, 5);
            const results = [];
            value = parseIntAuto(ref[2]);
            if (value > 65535 || value < 0) {
              throw new Error("ipaddr: address outside defined range");
            }
            results.push(parseIntAuto(ref[0]));
            results.push(parseIntAuto(ref[1]));
            results.push(value >> 8 & 255);
            results.push(value & 255);
            return results;
          }();
        } else {
          return null;
        }
      };
      ipaddr2.IPv4.subnetMaskFromPrefixLength = function(prefix) {
        prefix = parseInt(prefix);
        if (prefix < 0 || prefix > 32) {
          throw new Error("ipaddr: invalid IPv4 prefix length");
        }
        const octets = [0, 0, 0, 0];
        let j = 0;
        const filledOctetCount = Math.floor(prefix / 8);
        while (j < filledOctetCount) {
          octets[j] = 255;
          j++;
        }
        if (filledOctetCount < 4) {
          octets[filledOctetCount] = Math.pow(2, prefix % 8) - 1 << 8 - prefix % 8;
        }
        return new this(octets);
      };
      ipaddr2.IPv6 = function() {
        function IPv6(parts, zoneId) {
          let i, part;
          if (parts.length === 16) {
            this.parts = [];
            for (i = 0; i <= 14; i += 2) {
              this.parts.push(parts[i] << 8 | parts[i + 1]);
            }
          } else if (parts.length === 8) {
            this.parts = parts;
          } else {
            throw new Error("ipaddr: ipv6 part count should be 8 or 16");
          }
          for (i = 0; i < this.parts.length; i++) {
            part = this.parts[i];
            if (!(0 <= part && part <= 65535)) {
              throw new Error("ipaddr: ipv6 part should fit in 16 bits");
            }
          }
          if (zoneId) {
            this.zoneId = zoneId;
          }
        }
        IPv6.prototype.SpecialRanges = {
          // RFC4291, here and after
          unspecified: [new IPv6([0, 0, 0, 0, 0, 0, 0, 0]), 128],
          linkLocal: [new IPv6([65152, 0, 0, 0, 0, 0, 0, 0]), 10],
          multicast: [new IPv6([65280, 0, 0, 0, 0, 0, 0, 0]), 8],
          loopback: [new IPv6([0, 0, 0, 0, 0, 0, 0, 1]), 128],
          uniqueLocal: [new IPv6([64512, 0, 0, 0, 0, 0, 0, 0]), 7],
          ipv4Mapped: [new IPv6([0, 0, 0, 0, 0, 65535, 0, 0]), 96],
          // RFC6145
          rfc6145: [new IPv6([0, 0, 0, 0, 65535, 0, 0, 0]), 96],
          // RFC6052
          rfc6052: [new IPv6([100, 65435, 0, 0, 0, 0, 0, 0]), 96],
          // RFC3056
          "6to4": [new IPv6([8194, 0, 0, 0, 0, 0, 0, 0]), 16],
          // RFC6052, RFC6146
          teredo: [new IPv6([8193, 0, 0, 0, 0, 0, 0, 0]), 32],
          // RFC4291
          reserved: [[new IPv6([8193, 3512, 0, 0, 0, 0, 0, 0]), 32]],
          benchmarking: [new IPv6([8193, 2, 0, 0, 0, 0, 0, 0]), 48],
          amt: [new IPv6([8193, 3, 0, 0, 0, 0, 0, 0]), 32],
          as112v6: [new IPv6([8193, 4, 274, 0, 0, 0, 0, 0]), 48],
          deprecated: [new IPv6([8193, 16, 0, 0, 0, 0, 0, 0]), 28],
          orchid2: [new IPv6([8193, 32, 0, 0, 0, 0, 0, 0]), 28]
        };
        IPv6.prototype.isIPv4MappedAddress = function() {
          return this.range() === "ipv4Mapped";
        };
        IPv6.prototype.kind = function() {
          return "ipv6";
        };
        IPv6.prototype.match = function(other, cidrRange) {
          let ref;
          if (cidrRange === void 0) {
            ref = other;
            other = ref[0];
            cidrRange = ref[1];
          }
          if (other.kind() !== "ipv6") {
            throw new Error("ipaddr: cannot match ipv6 address with non-ipv6 one");
          }
          return matchCIDR(this.parts, other.parts, 16, cidrRange);
        };
        IPv6.prototype.prefixLengthFromSubnetMask = function() {
          let cidr = 0;
          let stop = false;
          const zerotable = {
            0: 16,
            32768: 15,
            49152: 14,
            57344: 13,
            61440: 12,
            63488: 11,
            64512: 10,
            65024: 9,
            65280: 8,
            65408: 7,
            65472: 6,
            65504: 5,
            65520: 4,
            65528: 3,
            65532: 2,
            65534: 1,
            65535: 0
          };
          let part, zeros;
          for (let i = 7; i >= 0; i -= 1) {
            part = this.parts[i];
            if (part in zerotable) {
              zeros = zerotable[part];
              if (stop && zeros !== 0) {
                return null;
              }
              if (zeros !== 16) {
                stop = true;
              }
              cidr += zeros;
            } else {
              return null;
            }
          }
          return 128 - cidr;
        };
        IPv6.prototype.range = function() {
          return ipaddr2.subnetMatch(this, this.SpecialRanges);
        };
        IPv6.prototype.toByteArray = function() {
          let part;
          const bytes = [];
          const ref = this.parts;
          for (let i = 0; i < ref.length; i++) {
            part = ref[i];
            bytes.push(part >> 8);
            bytes.push(part & 255);
          }
          return bytes;
        };
        IPv6.prototype.toFixedLengthString = function() {
          const addr = function() {
            const results = [];
            for (let i = 0; i < this.parts.length; i++) {
              results.push(padPart(this.parts[i].toString(16), 4));
            }
            return results;
          }.call(this).join(":");
          let suffix = "";
          if (this.zoneId) {
            suffix = `%${this.zoneId}`;
          }
          return addr + suffix;
        };
        IPv6.prototype.toIPv4Address = function() {
          if (!this.isIPv4MappedAddress()) {
            throw new Error("ipaddr: trying to convert a generic ipv6 address to ipv4");
          }
          const ref = this.parts.slice(-2);
          const high = ref[0];
          const low = ref[1];
          return new ipaddr2.IPv4([high >> 8, high & 255, low >> 8, low & 255]);
        };
        IPv6.prototype.toNormalizedString = function() {
          const addr = function() {
            const results = [];
            for (let i = 0; i < this.parts.length; i++) {
              results.push(this.parts[i].toString(16));
            }
            return results;
          }.call(this).join(":");
          let suffix = "";
          if (this.zoneId) {
            suffix = `%${this.zoneId}`;
          }
          return addr + suffix;
        };
        IPv6.prototype.toRFC5952String = function() {
          const regex = /((^|:)(0(:|$)){2,})/g;
          const string = this.toNormalizedString();
          let bestMatchIndex = 0;
          let bestMatchLength = -1;
          let match;
          while (match = regex.exec(string)) {
            if (match[0].length > bestMatchLength) {
              bestMatchIndex = match.index;
              bestMatchLength = match[0].length;
            }
          }
          if (bestMatchLength < 0) {
            return string;
          }
          return `${string.substring(0, bestMatchIndex)}::${string.substring(bestMatchIndex + bestMatchLength)}`;
        };
        IPv6.prototype.toString = function() {
          return this.toRFC5952String();
        };
        return IPv6;
      }();
      ipaddr2.IPv6.broadcastAddressFromCIDR = function(string) {
        try {
          const cidr = this.parseCIDR(string);
          const ipInterfaceOctets = cidr[0].toByteArray();
          const subnetMaskOctets = this.subnetMaskFromPrefixLength(cidr[1]).toByteArray();
          const octets = [];
          let i = 0;
          while (i < 16) {
            octets.push(parseInt(ipInterfaceOctets[i], 10) | parseInt(subnetMaskOctets[i], 10) ^ 255);
            i++;
          }
          return new this(octets);
        } catch (e) {
          throw new Error(`ipaddr: the address does not have IPv6 CIDR format (${e})`);
        }
      };
      ipaddr2.IPv6.isIPv6 = function(string) {
        return this.parser(string) !== null;
      };
      ipaddr2.IPv6.isValid = function(string) {
        if (typeof string === "string" && string.indexOf(":") === -1) {
          return false;
        }
        try {
          const addr = this.parser(string);
          new this(addr.parts, addr.zoneId);
          return true;
        } catch (e) {
          return false;
        }
      };
      ipaddr2.IPv6.networkAddressFromCIDR = function(string) {
        let cidr, i, ipInterfaceOctets, octets, subnetMaskOctets;
        try {
          cidr = this.parseCIDR(string);
          ipInterfaceOctets = cidr[0].toByteArray();
          subnetMaskOctets = this.subnetMaskFromPrefixLength(cidr[1]).toByteArray();
          octets = [];
          i = 0;
          while (i < 16) {
            octets.push(parseInt(ipInterfaceOctets[i], 10) & parseInt(subnetMaskOctets[i], 10));
            i++;
          }
          return new this(octets);
        } catch (e) {
          throw new Error(`ipaddr: the address does not have IPv6 CIDR format (${e})`);
        }
      };
      ipaddr2.IPv6.parse = function(string) {
        const addr = this.parser(string);
        if (addr.parts === null) {
          throw new Error("ipaddr: string is not formatted like an IPv6 Address");
        }
        return new this(addr.parts, addr.zoneId);
      };
      ipaddr2.IPv6.parseCIDR = function(string) {
        let maskLength, match, parsed;
        if (match = string.match(/^(.+)\/(\d+)$/)) {
          maskLength = parseInt(match[2]);
          if (maskLength >= 0 && maskLength <= 128) {
            parsed = [this.parse(match[1]), maskLength];
            Object.defineProperty(parsed, "toString", {
              value: function() {
                return this.join("/");
              }
            });
            return parsed;
          }
        }
        throw new Error("ipaddr: string is not formatted like an IPv6 CIDR range");
      };
      ipaddr2.IPv6.parser = function(string) {
        let addr, i, match, octet, octets, zoneId;
        if (match = string.match(ipv6Regexes.deprecatedTransitional)) {
          return this.parser(`::ffff:${match[1]}`);
        }
        if (ipv6Regexes.native.test(string)) {
          return expandIPv6(string, 8);
        }
        if (match = string.match(ipv6Regexes.transitional)) {
          zoneId = match[6] || "";
          addr = expandIPv6(match[1].slice(0, -1) + zoneId, 6);
          if (addr.parts) {
            octets = [
              parseInt(match[2]),
              parseInt(match[3]),
              parseInt(match[4]),
              parseInt(match[5])
            ];
            for (i = 0; i < octets.length; i++) {
              octet = octets[i];
              if (!(0 <= octet && octet <= 255)) {
                return null;
              }
            }
            addr.parts.push(octets[0] << 8 | octets[1]);
            addr.parts.push(octets[2] << 8 | octets[3]);
            return {
              parts: addr.parts,
              zoneId: addr.zoneId
            };
          }
        }
        return null;
      };
      ipaddr2.IPv6.subnetMaskFromPrefixLength = function(prefix) {
        prefix = parseInt(prefix);
        if (prefix < 0 || prefix > 128) {
          throw new Error("ipaddr: invalid IPv6 prefix length");
        }
        const octets = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
        let j = 0;
        const filledOctetCount = Math.floor(prefix / 8);
        while (j < filledOctetCount) {
          octets[j] = 255;
          j++;
        }
        if (filledOctetCount < 16) {
          octets[filledOctetCount] = Math.pow(2, prefix % 8) - 1 << 8 - prefix % 8;
        }
        return new this(octets);
      };
      ipaddr2.fromByteArray = function(bytes) {
        const length = bytes.length;
        if (length === 4) {
          return new ipaddr2.IPv4(bytes);
        } else if (length === 16) {
          return new ipaddr2.IPv6(bytes);
        } else {
          throw new Error("ipaddr: the binary input is neither an IPv6 nor IPv4 address");
        }
      };
      ipaddr2.isValid = function(string) {
        return ipaddr2.IPv6.isValid(string) || ipaddr2.IPv4.isValid(string);
      };
      ipaddr2.parse = function(string) {
        if (ipaddr2.IPv6.isValid(string)) {
          return ipaddr2.IPv6.parse(string);
        } else if (ipaddr2.IPv4.isValid(string)) {
          return ipaddr2.IPv4.parse(string);
        } else {
          throw new Error("ipaddr: the address has neither IPv6 nor IPv4 format");
        }
      };
      ipaddr2.parseCIDR = function(string) {
        try {
          return ipaddr2.IPv6.parseCIDR(string);
        } catch (e) {
          try {
            return ipaddr2.IPv4.parseCIDR(string);
          } catch (e2) {
            throw new Error("ipaddr: the address has neither IPv6 nor IPv4 CIDR format");
          }
        }
      };
      ipaddr2.process = function(string) {
        const addr = this.parse(string);
        if (addr.kind() === "ipv6" && addr.isIPv4MappedAddress()) {
          return addr.toIPv4Address();
        } else {
          return addr;
        }
      };
      ipaddr2.subnetMatch = function(address, rangeList, defaultName) {
        let i, rangeName, rangeSubnets, subnet;
        if (defaultName === void 0 || defaultName === null) {
          defaultName = "unicast";
        }
        for (rangeName in rangeList) {
          if (Object.prototype.hasOwnProperty.call(rangeList, rangeName)) {
            rangeSubnets = rangeList[rangeName];
            if (rangeSubnets[0] && !(rangeSubnets[0] instanceof Array)) {
              rangeSubnets = [rangeSubnets];
            }
            for (i = 0; i < rangeSubnets.length; i++) {
              subnet = rangeSubnets[i];
              if (address.kind() === subnet[0].kind() && address.match.apply(address, subnet)) {
                return rangeName;
              }
            }
          }
        }
        return defaultName;
      };
      if (typeof module2 !== "undefined" && module2.exports) {
        module2.exports = ipaddr2;
      } else {
        root.ipaddr = ipaddr2;
      }
    })(exports2);
  }
});

// node_modules/@tinyhttp/proxy-addr/dist/index.js
function alladdrs(req, trust) {
  const addrs = forwarded(req);
  if (!trust)
    return addrs;
  if (typeof trust !== "function")
    trust = compile(trust);
  for (let i = 0; i < addrs.length - 1; i++) {
    if (trust(addrs[i], i))
      continue;
    addrs.length = i + 1;
  }
  return addrs;
}
function compile(val) {
  let trust;
  if (typeof val === "string")
    trust = [val];
  else if (Array.isArray(val))
    trust = val.slice();
  else
    throw new TypeError("unsupported trust argument");
  for (let i = 0; i < trust.length; i++) {
    val = trust[i];
    if (!Object.prototype.hasOwnProperty.call(IP_RANGES, val))
      continue;
    val = IP_RANGES[val];
    trust.splice.apply(trust, [i, 1].concat(val));
    i += val.length - 1;
  }
  return compileTrust(compileRangeSubnets(trust));
}
function compileRangeSubnets(arr) {
  const rangeSubnets = new Array(arr.length);
  for (let i = 0; i < arr.length; i++)
    rangeSubnets[i] = parseIPNotation(arr[i]);
  return rangeSubnets;
}
function compileTrust(rangeSubnets) {
  const len = rangeSubnets.length;
  return len === 0 ? trustNone : len === 1 ? trustSingle(rangeSubnets[0]) : trustMulti(rangeSubnets);
}
function parseIPNotation(note) {
  const pos = note.lastIndexOf("/");
  const str = pos !== -1 ? note.substring(0, pos) : note;
  if (!isip(str))
    throw new TypeError("invalid IP address: " + str);
  let ip = parseip(str);
  if (pos === -1 && ip.kind() === "ipv6") {
    ip = ip;
    if (ip.isIPv4MappedAddress())
      ip = ip.toIPv4Address();
  }
  const max = ip.kind() === "ipv6" ? 128 : 32;
  let range = pos !== -1 ? note.substring(pos + 1, note.length) : null;
  if (range === null)
    range = max;
  else if (DIGIT_REGEXP.test(range))
    range = parseInt(range, 10);
  else if (ip.kind() === "ipv4" && isip(range))
    range = parseNetmask(range);
  else
    range = null;
  if (range <= 0 || range > max)
    throw new TypeError("invalid range on address: " + note);
  return [ip, range];
}
function parseNetmask(netmask) {
  const ip = parseip(netmask);
  return ip.kind() === "ipv4" ? ip.prefixLengthFromSubnetMask() : null;
}
function proxyaddr(req, trust) {
  const addrs = alladdrs(req, trust);
  return addrs[addrs.length - 1];
}
function trustMulti(subnets) {
  return function trust(addr) {
    if (!isip(addr))
      return false;
    const ip = parseip(addr);
    let ipconv;
    const kind = ip.kind();
    for (let i = 0; i < subnets.length; i++) {
      const subnet = subnets[i];
      const subnetip = subnet[0];
      const subnetkind = subnetip.kind();
      const subnetrange = subnet[1];
      let trusted = ip;
      if (kind !== subnetkind) {
        if (subnetkind === "ipv4" && !ip.isIPv4MappedAddress())
          continue;
        if (!ipconv)
          ipconv = subnetkind === "ipv4" ? ip.toIPv4Address() : ip.toIPv4MappedAddress();
        trusted = ipconv;
      }
      if (trusted.match(subnetip, subnetrange))
        return true;
    }
    return false;
  };
}
function trustSingle(subnet) {
  const subnetip = subnet[0];
  const subnetkind = subnetip.kind();
  const subnetisipv4 = subnetkind === "ipv4";
  const subnetrange = subnet[1];
  return function trust(addr) {
    if (!isip(addr))
      return false;
    let ip = parseip(addr);
    const kind = ip.kind();
    if (kind !== subnetkind) {
      if (subnetisipv4 && !ip.isIPv4MappedAddress())
        return false;
      ip = subnetisipv4 ? ip.toIPv4Address() : ip.toIPv4MappedAddress();
    }
    return ip.match(subnetip, subnetrange);
  };
}
var import_ipaddr, DIGIT_REGEXP, isip, parseip, IP_RANGES, trustNone;
var init_dist2 = __esm({
  "node_modules/@tinyhttp/proxy-addr/dist/index.js"() {
    init_dist();
    import_ipaddr = __toESM(require_ipaddr(), 1);
    DIGIT_REGEXP = /^[0-9]+$/;
    isip = import_ipaddr.default.isValid;
    parseip = import_ipaddr.default.parse;
    IP_RANGES = {
      linklocal: ["169.254.0.0/16", "fe80::/10"],
      loopback: ["127.0.0.1/8", "::1/128"],
      uniquelocal: ["10.0.0.0/8", "172.16.0.0/12", "192.168.0.0/16", "fc00::/7"]
    };
    trustNone = () => false;
  }
});

// node_modules/header-range-parser/dist/index.js
function l(t) {
  let e = t.map(c).sort(m), s = 0;
  for (let a = 1; a < e.length; a++) {
    let r = e[a], n = e[s];
    r.start > n.end + 1 ? e[++s] = r : r.end > n.end && (n.end = r.end, n.index = Math.min(n.index, r.index));
  }
  e.length = s + 1;
  let i = [...e].sort(f).map(d);
  return i.type = t.type, i;
}
function c(t, e) {
  return { end: t.end, index: e, start: t.start };
}
function d(t) {
  return { end: t.end, start: t.start };
}
function f(t, e) {
  return t.index - e.index;
}
function m(t, e) {
  return t.start - e.start;
}
function p(t, e) {
  let s = new u();
  for (let i of t) {
    let a = i.split("-"), r = Number.parseInt(a[0], 10), n = Number.parseInt(a[1], 10);
    Number.isNaN(r) ? (r = e - n, n = e - 1) : Number.isNaN(n) && (n = e - 1), n > e - 1 && (n = e - 1), !(Number.isNaN(r) || Number.isNaN(n) || r > n || r < 0) && s.push({ end: n, start: r });
  }
  return s;
}
function x(t, e, s) {
  let i = true;
  if (s && "throwError" in s && s.throwError === false && (i = false), !Number.isInteger(t)) {
    if (i)
      throw new TypeError("Argument 'size' must be an integer.");
    return o;
  }
  if (typeof e != "string") {
    if (i)
      throw new TypeError("Argument 'header' must be a string.");
    return o;
  }
  let a = e.indexOf("=");
  if (a === -1)
    return R;
  let r = e.slice(a + 1).split(","), n = p(r, t);
  return n.length < 1 ? g : (n.type = e.slice(0, a), s && s.combine ? l(n) : n);
}
var o, R, g, u;
var init_dist3 = __esm({
  "node_modules/header-range-parser/dist/index.js"() {
    o = -3;
    R = -2;
    g = -1;
    u = class extends Array {
      constructor() {
        super(...arguments);
        this.type = "";
      }
      toArray() {
        let e = Array.from(this);
        return e.type = this.type, e;
      }
    };
  }
});

// node_modules/es-fresh/dist/index.js
function isStale(etag, noneMatch) {
  let start = 0;
  let end = 0;
  for (let i = 0, len = noneMatch.length; i < len; i++) {
    switch (noneMatch.charCodeAt(i)) {
      case 32:
        if (start === end)
          start = end = i + 1;
        break;
      case 44:
        if (compareETags(etag, noneMatch.substring(start, end)))
          return false;
        start = end = i + 1;
        break;
      default:
        end = i + 1;
        break;
    }
  }
  if (compareETags(etag, noneMatch.substring(start, end)))
    return false;
  return true;
}
function fresh(reqHeaders, resHeaders) {
  const modifiedSince = reqHeaders["if-modified-since"];
  const noneMatch = reqHeaders["if-none-match"];
  if (!modifiedSince && !noneMatch)
    return false;
  const cacheControl = reqHeaders["cache-control"];
  if (cacheControl && CACHE_CONTROL_NO_CACHE_REGEXP.test(cacheControl)) {
    return false;
  }
  if (noneMatch && noneMatch !== "*") {
    const etag = resHeaders.etag;
    if (!etag || isStale(etag, noneMatch))
      return false;
  }
  if (modifiedSince) {
    const lastModified = resHeaders["last-modified"];
    if (!lastModified || !(parseHttpDate(lastModified) <= parseHttpDate(modifiedSince))) {
      return false;
    }
  }
  return true;
}
var CACHE_CONTROL_NO_CACHE_REGEXP, parseHttpDate, compareETags;
var init_dist4 = __esm({
  "node_modules/es-fresh/dist/index.js"() {
    CACHE_CONTROL_NO_CACHE_REGEXP = /(?:^|,)\s*?no-cache\s*?(?:,|$)/;
    parseHttpDate = Date.parse;
    compareETags = (etag, str) => str === etag || str === `W/${etag}` || `W/${str}` === etag;
  }
});

// node_modules/mime-db/db.json
var require_db = __commonJS({
  "node_modules/mime-db/db.json"(exports2, module2) {
    module2.exports = {
      "application/1d-interleaved-parityfec": {
        source: "iana"
      },
      "application/3gpdash-qoe-report+xml": {
        source: "iana",
        charset: "UTF-8",
        compressible: true
      },
      "application/3gpp-ims+xml": {
        source: "iana",
        compressible: true
      },
      "application/3gpphal+json": {
        source: "iana",
        compressible: true
      },
      "application/3gpphalforms+json": {
        source: "iana",
        compressible: true
      },
      "application/a2l": {
        source: "iana"
      },
      "application/ace+cbor": {
        source: "iana"
      },
      "application/activemessage": {
        source: "iana"
      },
      "application/activity+json": {
        source: "iana",
        compressible: true
      },
      "application/alto-costmap+json": {
        source: "iana",
        compressible: true
      },
      "application/alto-costmapfilter+json": {
        source: "iana",
        compressible: true
      },
      "application/alto-directory+json": {
        source: "iana",
        compressible: true
      },
      "application/alto-endpointcost+json": {
        source: "iana",
        compressible: true
      },
      "application/alto-endpointcostparams+json": {
        source: "iana",
        compressible: true
      },
      "application/alto-endpointprop+json": {
        source: "iana",
        compressible: true
      },
      "application/alto-endpointpropparams+json": {
        source: "iana",
        compressible: true
      },
      "application/alto-error+json": {
        source: "iana",
        compressible: true
      },
      "application/alto-networkmap+json": {
        source: "iana",
        compressible: true
      },
      "application/alto-networkmapfilter+json": {
        source: "iana",
        compressible: true
      },
      "application/alto-updatestreamcontrol+json": {
        source: "iana",
        compressible: true
      },
      "application/alto-updatestreamparams+json": {
        source: "iana",
        compressible: true
      },
      "application/aml": {
        source: "iana"
      },
      "application/andrew-inset": {
        source: "iana",
        extensions: ["ez"]
      },
      "application/applefile": {
        source: "iana"
      },
      "application/applixware": {
        source: "apache",
        extensions: ["aw"]
      },
      "application/at+jwt": {
        source: "iana"
      },
      "application/atf": {
        source: "iana"
      },
      "application/atfx": {
        source: "iana"
      },
      "application/atom+xml": {
        source: "iana",
        compressible: true,
        extensions: ["atom"]
      },
      "application/atomcat+xml": {
        source: "iana",
        compressible: true,
        extensions: ["atomcat"]
      },
      "application/atomdeleted+xml": {
        source: "iana",
        compressible: true,
        extensions: ["atomdeleted"]
      },
      "application/atomicmail": {
        source: "iana"
      },
      "application/atomsvc+xml": {
        source: "iana",
        compressible: true,
        extensions: ["atomsvc"]
      },
      "application/atsc-dwd+xml": {
        source: "iana",
        compressible: true,
        extensions: ["dwd"]
      },
      "application/atsc-dynamic-event-message": {
        source: "iana"
      },
      "application/atsc-held+xml": {
        source: "iana",
        compressible: true,
        extensions: ["held"]
      },
      "application/atsc-rdt+json": {
        source: "iana",
        compressible: true
      },
      "application/atsc-rsat+xml": {
        source: "iana",
        compressible: true,
        extensions: ["rsat"]
      },
      "application/atxml": {
        source: "iana"
      },
      "application/auth-policy+xml": {
        source: "iana",
        compressible: true
      },
      "application/bacnet-xdd+zip": {
        source: "iana",
        compressible: false
      },
      "application/batch-smtp": {
        source: "iana"
      },
      "application/bdoc": {
        compressible: false,
        extensions: ["bdoc"]
      },
      "application/beep+xml": {
        source: "iana",
        charset: "UTF-8",
        compressible: true
      },
      "application/calendar+json": {
        source: "iana",
        compressible: true
      },
      "application/calendar+xml": {
        source: "iana",
        compressible: true,
        extensions: ["xcs"]
      },
      "application/call-completion": {
        source: "iana"
      },
      "application/cals-1840": {
        source: "iana"
      },
      "application/captive+json": {
        source: "iana",
        compressible: true
      },
      "application/cbor": {
        source: "iana"
      },
      "application/cbor-seq": {
        source: "iana"
      },
      "application/cccex": {
        source: "iana"
      },
      "application/ccmp+xml": {
        source: "iana",
        compressible: true
      },
      "application/ccxml+xml": {
        source: "iana",
        compressible: true,
        extensions: ["ccxml"]
      },
      "application/cdfx+xml": {
        source: "iana",
        compressible: true,
        extensions: ["cdfx"]
      },
      "application/cdmi-capability": {
        source: "iana",
        extensions: ["cdmia"]
      },
      "application/cdmi-container": {
        source: "iana",
        extensions: ["cdmic"]
      },
      "application/cdmi-domain": {
        source: "iana",
        extensions: ["cdmid"]
      },
      "application/cdmi-object": {
        source: "iana",
        extensions: ["cdmio"]
      },
      "application/cdmi-queue": {
        source: "iana",
        extensions: ["cdmiq"]
      },
      "application/cdni": {
        source: "iana"
      },
      "application/cea": {
        source: "iana"
      },
      "application/cea-2018+xml": {
        source: "iana",
        compressible: true
      },
      "application/cellml+xml": {
        source: "iana",
        compressible: true
      },
      "application/cfw": {
        source: "iana"
      },
      "application/city+json": {
        source: "iana",
        compressible: true
      },
      "application/clr": {
        source: "iana"
      },
      "application/clue+xml": {
        source: "iana",
        compressible: true
      },
      "application/clue_info+xml": {
        source: "iana",
        compressible: true
      },
      "application/cms": {
        source: "iana"
      },
      "application/cnrp+xml": {
        source: "iana",
        compressible: true
      },
      "application/coap-group+json": {
        source: "iana",
        compressible: true
      },
      "application/coap-payload": {
        source: "iana"
      },
      "application/commonground": {
        source: "iana"
      },
      "application/conference-info+xml": {
        source: "iana",
        compressible: true
      },
      "application/cose": {
        source: "iana"
      },
      "application/cose-key": {
        source: "iana"
      },
      "application/cose-key-set": {
        source: "iana"
      },
      "application/cpl+xml": {
        source: "iana",
        compressible: true,
        extensions: ["cpl"]
      },
      "application/csrattrs": {
        source: "iana"
      },
      "application/csta+xml": {
        source: "iana",
        compressible: true
      },
      "application/cstadata+xml": {
        source: "iana",
        compressible: true
      },
      "application/csvm+json": {
        source: "iana",
        compressible: true
      },
      "application/cu-seeme": {
        source: "apache",
        extensions: ["cu"]
      },
      "application/cwt": {
        source: "iana"
      },
      "application/cybercash": {
        source: "iana"
      },
      "application/dart": {
        compressible: true
      },
      "application/dash+xml": {
        source: "iana",
        compressible: true,
        extensions: ["mpd"]
      },
      "application/dash-patch+xml": {
        source: "iana",
        compressible: true,
        extensions: ["mpp"]
      },
      "application/dashdelta": {
        source: "iana"
      },
      "application/davmount+xml": {
        source: "iana",
        compressible: true,
        extensions: ["davmount"]
      },
      "application/dca-rft": {
        source: "iana"
      },
      "application/dcd": {
        source: "iana"
      },
      "application/dec-dx": {
        source: "iana"
      },
      "application/dialog-info+xml": {
        source: "iana",
        compressible: true
      },
      "application/dicom": {
        source: "iana"
      },
      "application/dicom+json": {
        source: "iana",
        compressible: true
      },
      "application/dicom+xml": {
        source: "iana",
        compressible: true
      },
      "application/dii": {
        source: "iana"
      },
      "application/dit": {
        source: "iana"
      },
      "application/dns": {
        source: "iana"
      },
      "application/dns+json": {
        source: "iana",
        compressible: true
      },
      "application/dns-message": {
        source: "iana"
      },
      "application/docbook+xml": {
        source: "apache",
        compressible: true,
        extensions: ["dbk"]
      },
      "application/dots+cbor": {
        source: "iana"
      },
      "application/dskpp+xml": {
        source: "iana",
        compressible: true
      },
      "application/dssc+der": {
        source: "iana",
        extensions: ["dssc"]
      },
      "application/dssc+xml": {
        source: "iana",
        compressible: true,
        extensions: ["xdssc"]
      },
      "application/dvcs": {
        source: "iana"
      },
      "application/ecmascript": {
        source: "iana",
        compressible: true,
        extensions: ["es", "ecma"]
      },
      "application/edi-consent": {
        source: "iana"
      },
      "application/edi-x12": {
        source: "iana",
        compressible: false
      },
      "application/edifact": {
        source: "iana",
        compressible: false
      },
      "application/efi": {
        source: "iana"
      },
      "application/elm+json": {
        source: "iana",
        charset: "UTF-8",
        compressible: true
      },
      "application/elm+xml": {
        source: "iana",
        compressible: true
      },
      "application/emergencycalldata.cap+xml": {
        source: "iana",
        charset: "UTF-8",
        compressible: true
      },
      "application/emergencycalldata.comment+xml": {
        source: "iana",
        compressible: true
      },
      "application/emergencycalldata.control+xml": {
        source: "iana",
        compressible: true
      },
      "application/emergencycalldata.deviceinfo+xml": {
        source: "iana",
        compressible: true
      },
      "application/emergencycalldata.ecall.msd": {
        source: "iana"
      },
      "application/emergencycalldata.providerinfo+xml": {
        source: "iana",
        compressible: true
      },
      "application/emergencycalldata.serviceinfo+xml": {
        source: "iana",
        compressible: true
      },
      "application/emergencycalldata.subscriberinfo+xml": {
        source: "iana",
        compressible: true
      },
      "application/emergencycalldata.veds+xml": {
        source: "iana",
        compressible: true
      },
      "application/emma+xml": {
        source: "iana",
        compressible: true,
        extensions: ["emma"]
      },
      "application/emotionml+xml": {
        source: "iana",
        compressible: true,
        extensions: ["emotionml"]
      },
      "application/encaprtp": {
        source: "iana"
      },
      "application/epp+xml": {
        source: "iana",
        compressible: true
      },
      "application/epub+zip": {
        source: "iana",
        compressible: false,
        extensions: ["epub"]
      },
      "application/eshop": {
        source: "iana"
      },
      "application/exi": {
        source: "iana",
        extensions: ["exi"]
      },
      "application/expect-ct-report+json": {
        source: "iana",
        compressible: true
      },
      "application/express": {
        source: "iana",
        extensions: ["exp"]
      },
      "application/fastinfoset": {
        source: "iana"
      },
      "application/fastsoap": {
        source: "iana"
      },
      "application/fdt+xml": {
        source: "iana",
        compressible: true,
        extensions: ["fdt"]
      },
      "application/fhir+json": {
        source: "iana",
        charset: "UTF-8",
        compressible: true
      },
      "application/fhir+xml": {
        source: "iana",
        charset: "UTF-8",
        compressible: true
      },
      "application/fido.trusted-apps+json": {
        compressible: true
      },
      "application/fits": {
        source: "iana"
      },
      "application/flexfec": {
        source: "iana"
      },
      "application/font-sfnt": {
        source: "iana"
      },
      "application/font-tdpfr": {
        source: "iana",
        extensions: ["pfr"]
      },
      "application/font-woff": {
        source: "iana",
        compressible: false
      },
      "application/framework-attributes+xml": {
        source: "iana",
        compressible: true
      },
      "application/geo+json": {
        source: "iana",
        compressible: true,
        extensions: ["geojson"]
      },
      "application/geo+json-seq": {
        source: "iana"
      },
      "application/geopackage+sqlite3": {
        source: "iana"
      },
      "application/geoxacml+xml": {
        source: "iana",
        compressible: true
      },
      "application/gltf-buffer": {
        source: "iana"
      },
      "application/gml+xml": {
        source: "iana",
        compressible: true,
        extensions: ["gml"]
      },
      "application/gpx+xml": {
        source: "apache",
        compressible: true,
        extensions: ["gpx"]
      },
      "application/gxf": {
        source: "apache",
        extensions: ["gxf"]
      },
      "application/gzip": {
        source: "iana",
        compressible: false,
        extensions: ["gz"]
      },
      "application/h224": {
        source: "iana"
      },
      "application/held+xml": {
        source: "iana",
        compressible: true
      },
      "application/hjson": {
        extensions: ["hjson"]
      },
      "application/http": {
        source: "iana"
      },
      "application/hyperstudio": {
        source: "iana",
        extensions: ["stk"]
      },
      "application/ibe-key-request+xml": {
        source: "iana",
        compressible: true
      },
      "application/ibe-pkg-reply+xml": {
        source: "iana",
        compressible: true
      },
      "application/ibe-pp-data": {
        source: "iana"
      },
      "application/iges": {
        source: "iana"
      },
      "application/im-iscomposing+xml": {
        source: "iana",
        charset: "UTF-8",
        compressible: true
      },
      "application/index": {
        source: "iana"
      },
      "application/index.cmd": {
        source: "iana"
      },
      "application/index.obj": {
        source: "iana"
      },
      "application/index.response": {
        source: "iana"
      },
      "application/index.vnd": {
        source: "iana"
      },
      "application/inkml+xml": {
        source: "iana",
        compressible: true,
        extensions: ["ink", "inkml"]
      },
      "application/iotp": {
        source: "iana"
      },
      "application/ipfix": {
        source: "iana",
        extensions: ["ipfix"]
      },
      "application/ipp": {
        source: "iana"
      },
      "application/isup": {
        source: "iana"
      },
      "application/its+xml": {
        source: "iana",
        compressible: true,
        extensions: ["its"]
      },
      "application/java-archive": {
        source: "apache",
        compressible: false,
        extensions: ["jar", "war", "ear"]
      },
      "application/java-serialized-object": {
        source: "apache",
        compressible: false,
        extensions: ["ser"]
      },
      "application/java-vm": {
        source: "apache",
        compressible: false,
        extensions: ["class"]
      },
      "application/javascript": {
        source: "iana",
        charset: "UTF-8",
        compressible: true,
        extensions: ["js", "mjs"]
      },
      "application/jf2feed+json": {
        source: "iana",
        compressible: true
      },
      "application/jose": {
        source: "iana"
      },
      "application/jose+json": {
        source: "iana",
        compressible: true
      },
      "application/jrd+json": {
        source: "iana",
        compressible: true
      },
      "application/jscalendar+json": {
        source: "iana",
        compressible: true
      },
      "application/json": {
        source: "iana",
        charset: "UTF-8",
        compressible: true,
        extensions: ["json", "map"]
      },
      "application/json-patch+json": {
        source: "iana",
        compressible: true
      },
      "application/json-seq": {
        source: "iana"
      },
      "application/json5": {
        extensions: ["json5"]
      },
      "application/jsonml+json": {
        source: "apache",
        compressible: true,
        extensions: ["jsonml"]
      },
      "application/jwk+json": {
        source: "iana",
        compressible: true
      },
      "application/jwk-set+json": {
        source: "iana",
        compressible: true
      },
      "application/jwt": {
        source: "iana"
      },
      "application/kpml-request+xml": {
        source: "iana",
        compressible: true
      },
      "application/kpml-response+xml": {
        source: "iana",
        compressible: true
      },
      "application/ld+json": {
        source: "iana",
        compressible: true,
        extensions: ["jsonld"]
      },
      "application/lgr+xml": {
        source: "iana",
        compressible: true,
        extensions: ["lgr"]
      },
      "application/link-format": {
        source: "iana"
      },
      "application/load-control+xml": {
        source: "iana",
        compressible: true
      },
      "application/lost+xml": {
        source: "iana",
        compressible: true,
        extensions: ["lostxml"]
      },
      "application/lostsync+xml": {
        source: "iana",
        compressible: true
      },
      "application/lpf+zip": {
        source: "iana",
        compressible: false
      },
      "application/lxf": {
        source: "iana"
      },
      "application/mac-binhex40": {
        source: "iana",
        extensions: ["hqx"]
      },
      "application/mac-compactpro": {
        source: "apache",
        extensions: ["cpt"]
      },
      "application/macwriteii": {
        source: "iana"
      },
      "application/mads+xml": {
        source: "iana",
        compressible: true,
        extensions: ["mads"]
      },
      "application/manifest+json": {
        source: "iana",
        charset: "UTF-8",
        compressible: true,
        extensions: ["webmanifest"]
      },
      "application/marc": {
        source: "iana",
        extensions: ["mrc"]
      },
      "application/marcxml+xml": {
        source: "iana",
        compressible: true,
        extensions: ["mrcx"]
      },
      "application/mathematica": {
        source: "iana",
        extensions: ["ma", "nb", "mb"]
      },
      "application/mathml+xml": {
        source: "iana",
        compressible: true,
        extensions: ["mathml"]
      },
      "application/mathml-content+xml": {
        source: "iana",
        compressible: true
      },
      "application/mathml-presentation+xml": {
        source: "iana",
        compressible: true
      },
      "application/mbms-associated-procedure-description+xml": {
        source: "iana",
        compressible: true
      },
      "application/mbms-deregister+xml": {
        source: "iana",
        compressible: true
      },
      "application/mbms-envelope+xml": {
        source: "iana",
        compressible: true
      },
      "application/mbms-msk+xml": {
        source: "iana",
        compressible: true
      },
      "application/mbms-msk-response+xml": {
        source: "iana",
        compressible: true
      },
      "application/mbms-protection-description+xml": {
        source: "iana",
        compressible: true
      },
      "application/mbms-reception-report+xml": {
        source: "iana",
        compressible: true
      },
      "application/mbms-register+xml": {
        source: "iana",
        compressible: true
      },
      "application/mbms-register-response+xml": {
        source: "iana",
        compressible: true
      },
      "application/mbms-schedule+xml": {
        source: "iana",
        compressible: true
      },
      "application/mbms-user-service-description+xml": {
        source: "iana",
        compressible: true
      },
      "application/mbox": {
        source: "iana",
        extensions: ["mbox"]
      },
      "application/media-policy-dataset+xml": {
        source: "iana",
        compressible: true,
        extensions: ["mpf"]
      },
      "application/media_control+xml": {
        source: "iana",
        compressible: true
      },
      "application/mediaservercontrol+xml": {
        source: "iana",
        compressible: true,
        extensions: ["mscml"]
      },
      "application/merge-patch+json": {
        source: "iana",
        compressible: true
      },
      "application/metalink+xml": {
        source: "apache",
        compressible: true,
        extensions: ["metalink"]
      },
      "application/metalink4+xml": {
        source: "iana",
        compressible: true,
        extensions: ["meta4"]
      },
      "application/mets+xml": {
        source: "iana",
        compressible: true,
        extensions: ["mets"]
      },
      "application/mf4": {
        source: "iana"
      },
      "application/mikey": {
        source: "iana"
      },
      "application/mipc": {
        source: "iana"
      },
      "application/missing-blocks+cbor-seq": {
        source: "iana"
      },
      "application/mmt-aei+xml": {
        source: "iana",
        compressible: true,
        extensions: ["maei"]
      },
      "application/mmt-usd+xml": {
        source: "iana",
        compressible: true,
        extensions: ["musd"]
      },
      "application/mods+xml": {
        source: "iana",
        compressible: true,
        extensions: ["mods"]
      },
      "application/moss-keys": {
        source: "iana"
      },
      "application/moss-signature": {
        source: "iana"
      },
      "application/mosskey-data": {
        source: "iana"
      },
      "application/mosskey-request": {
        source: "iana"
      },
      "application/mp21": {
        source: "iana",
        extensions: ["m21", "mp21"]
      },
      "application/mp4": {
        source: "iana",
        extensions: ["mp4s", "m4p"]
      },
      "application/mpeg4-generic": {
        source: "iana"
      },
      "application/mpeg4-iod": {
        source: "iana"
      },
      "application/mpeg4-iod-xmt": {
        source: "iana"
      },
      "application/mrb-consumer+xml": {
        source: "iana",
        compressible: true
      },
      "application/mrb-publish+xml": {
        source: "iana",
        compressible: true
      },
      "application/msc-ivr+xml": {
        source: "iana",
        charset: "UTF-8",
        compressible: true
      },
      "application/msc-mixer+xml": {
        source: "iana",
        charset: "UTF-8",
        compressible: true
      },
      "application/msword": {
        source: "iana",
        compressible: false,
        extensions: ["doc", "dot"]
      },
      "application/mud+json": {
        source: "iana",
        compressible: true
      },
      "application/multipart-core": {
        source: "iana"
      },
      "application/mxf": {
        source: "iana",
        extensions: ["mxf"]
      },
      "application/n-quads": {
        source: "iana",
        extensions: ["nq"]
      },
      "application/n-triples": {
        source: "iana",
        extensions: ["nt"]
      },
      "application/nasdata": {
        source: "iana"
      },
      "application/news-checkgroups": {
        source: "iana",
        charset: "US-ASCII"
      },
      "application/news-groupinfo": {
        source: "iana",
        charset: "US-ASCII"
      },
      "application/news-transmission": {
        source: "iana"
      },
      "application/nlsml+xml": {
        source: "iana",
        compressible: true
      },
      "application/node": {
        source: "iana",
        extensions: ["cjs"]
      },
      "application/nss": {
        source: "iana"
      },
      "application/oauth-authz-req+jwt": {
        source: "iana"
      },
      "application/oblivious-dns-message": {
        source: "iana"
      },
      "application/ocsp-request": {
        source: "iana"
      },
      "application/ocsp-response": {
        source: "iana"
      },
      "application/octet-stream": {
        source: "iana",
        compressible: false,
        extensions: ["bin", "dms", "lrf", "mar", "so", "dist", "distz", "pkg", "bpk", "dump", "elc", "deploy", "exe", "dll", "deb", "dmg", "iso", "img", "msi", "msp", "msm", "buffer"]
      },
      "application/oda": {
        source: "iana",
        extensions: ["oda"]
      },
      "application/odm+xml": {
        source: "iana",
        compressible: true
      },
      "application/odx": {
        source: "iana"
      },
      "application/oebps-package+xml": {
        source: "iana",
        compressible: true,
        extensions: ["opf"]
      },
      "application/ogg": {
        source: "iana",
        compressible: false,
        extensions: ["ogx"]
      },
      "application/omdoc+xml": {
        source: "apache",
        compressible: true,
        extensions: ["omdoc"]
      },
      "application/onenote": {
        source: "apache",
        extensions: ["onetoc", "onetoc2", "onetmp", "onepkg"]
      },
      "application/opc-nodeset+xml": {
        source: "iana",
        compressible: true
      },
      "application/oscore": {
        source: "iana"
      },
      "application/oxps": {
        source: "iana",
        extensions: ["oxps"]
      },
      "application/p21": {
        source: "iana"
      },
      "application/p21+zip": {
        source: "iana",
        compressible: false
      },
      "application/p2p-overlay+xml": {
        source: "iana",
        compressible: true,
        extensions: ["relo"]
      },
      "application/parityfec": {
        source: "iana"
      },
      "application/passport": {
        source: "iana"
      },
      "application/patch-ops-error+xml": {
        source: "iana",
        compressible: true,
        extensions: ["xer"]
      },
      "application/pdf": {
        source: "iana",
        compressible: false,
        extensions: ["pdf"]
      },
      "application/pdx": {
        source: "iana"
      },
      "application/pem-certificate-chain": {
        source: "iana"
      },
      "application/pgp-encrypted": {
        source: "iana",
        compressible: false,
        extensions: ["pgp"]
      },
      "application/pgp-keys": {
        source: "iana",
        extensions: ["asc"]
      },
      "application/pgp-signature": {
        source: "iana",
        extensions: ["asc", "sig"]
      },
      "application/pics-rules": {
        source: "apache",
        extensions: ["prf"]
      },
      "application/pidf+xml": {
        source: "iana",
        charset: "UTF-8",
        compressible: true
      },
      "application/pidf-diff+xml": {
        source: "iana",
        charset: "UTF-8",
        compressible: true
      },
      "application/pkcs10": {
        source: "iana",
        extensions: ["p10"]
      },
      "application/pkcs12": {
        source: "iana"
      },
      "application/pkcs7-mime": {
        source: "iana",
        extensions: ["p7m", "p7c"]
      },
      "application/pkcs7-signature": {
        source: "iana",
        extensions: ["p7s"]
      },
      "application/pkcs8": {
        source: "iana",
        extensions: ["p8"]
      },
      "application/pkcs8-encrypted": {
        source: "iana"
      },
      "application/pkix-attr-cert": {
        source: "iana",
        extensions: ["ac"]
      },
      "application/pkix-cert": {
        source: "iana",
        extensions: ["cer"]
      },
      "application/pkix-crl": {
        source: "iana",
        extensions: ["crl"]
      },
      "application/pkix-pkipath": {
        source: "iana",
        extensions: ["pkipath"]
      },
      "application/pkixcmp": {
        source: "iana",
        extensions: ["pki"]
      },
      "application/pls+xml": {
        source: "iana",
        compressible: true,
        extensions: ["pls"]
      },
      "application/poc-settings+xml": {
        source: "iana",
        charset: "UTF-8",
        compressible: true
      },
      "application/postscript": {
        source: "iana",
        compressible: true,
        extensions: ["ai", "eps", "ps"]
      },
      "application/ppsp-tracker+json": {
        source: "iana",
        compressible: true
      },
      "application/problem+json": {
        source: "iana",
        compressible: true
      },
      "application/problem+xml": {
        source: "iana",
        compressible: true
      },
      "application/provenance+xml": {
        source: "iana",
        compressible: true,
        extensions: ["provx"]
      },
      "application/prs.alvestrand.titrax-sheet": {
        source: "iana"
      },
      "application/prs.cww": {
        source: "iana",
        extensions: ["cww"]
      },
      "application/prs.cyn": {
        source: "iana",
        charset: "7-BIT"
      },
      "application/prs.hpub+zip": {
        source: "iana",
        compressible: false
      },
      "application/prs.nprend": {
        source: "iana"
      },
      "application/prs.plucker": {
        source: "iana"
      },
      "application/prs.rdf-xml-crypt": {
        source: "iana"
      },
      "application/prs.xsf+xml": {
        source: "iana",
        compressible: true
      },
      "application/pskc+xml": {
        source: "iana",
        compressible: true,
        extensions: ["pskcxml"]
      },
      "application/pvd+json": {
        source: "iana",
        compressible: true
      },
      "application/qsig": {
        source: "iana"
      },
      "application/raml+yaml": {
        compressible: true,
        extensions: ["raml"]
      },
      "application/raptorfec": {
        source: "iana"
      },
      "application/rdap+json": {
        source: "iana",
        compressible: true
      },
      "application/rdf+xml": {
        source: "iana",
        compressible: true,
        extensions: ["rdf", "owl"]
      },
      "application/reginfo+xml": {
        source: "iana",
        compressible: true,
        extensions: ["rif"]
      },
      "application/relax-ng-compact-syntax": {
        source: "iana",
        extensions: ["rnc"]
      },
      "application/remote-printing": {
        source: "iana"
      },
      "application/reputon+json": {
        source: "iana",
        compressible: true
      },
      "application/resource-lists+xml": {
        source: "iana",
        compressible: true,
        extensions: ["rl"]
      },
      "application/resource-lists-diff+xml": {
        source: "iana",
        compressible: true,
        extensions: ["rld"]
      },
      "application/rfc+xml": {
        source: "iana",
        compressible: true
      },
      "application/riscos": {
        source: "iana"
      },
      "application/rlmi+xml": {
        source: "iana",
        compressible: true
      },
      "application/rls-services+xml": {
        source: "iana",
        compressible: true,
        extensions: ["rs"]
      },
      "application/route-apd+xml": {
        source: "iana",
        compressible: true,
        extensions: ["rapd"]
      },
      "application/route-s-tsid+xml": {
        source: "iana",
        compressible: true,
        extensions: ["sls"]
      },
      "application/route-usd+xml": {
        source: "iana",
        compressible: true,
        extensions: ["rusd"]
      },
      "application/rpki-ghostbusters": {
        source: "iana",
        extensions: ["gbr"]
      },
      "application/rpki-manifest": {
        source: "iana",
        extensions: ["mft"]
      },
      "application/rpki-publication": {
        source: "iana"
      },
      "application/rpki-roa": {
        source: "iana",
        extensions: ["roa"]
      },
      "application/rpki-updown": {
        source: "iana"
      },
      "application/rsd+xml": {
        source: "apache",
        compressible: true,
        extensions: ["rsd"]
      },
      "application/rss+xml": {
        source: "apache",
        compressible: true,
        extensions: ["rss"]
      },
      "application/rtf": {
        source: "iana",
        compressible: true,
        extensions: ["rtf"]
      },
      "application/rtploopback": {
        source: "iana"
      },
      "application/rtx": {
        source: "iana"
      },
      "application/samlassertion+xml": {
        source: "iana",
        compressible: true
      },
      "application/samlmetadata+xml": {
        source: "iana",
        compressible: true
      },
      "application/sarif+json": {
        source: "iana",
        compressible: true
      },
      "application/sarif-external-properties+json": {
        source: "iana",
        compressible: true
      },
      "application/sbe": {
        source: "iana"
      },
      "application/sbml+xml": {
        source: "iana",
        compressible: true,
        extensions: ["sbml"]
      },
      "application/scaip+xml": {
        source: "iana",
        compressible: true
      },
      "application/scim+json": {
        source: "iana",
        compressible: true
      },
      "application/scvp-cv-request": {
        source: "iana",
        extensions: ["scq"]
      },
      "application/scvp-cv-response": {
        source: "iana",
        extensions: ["scs"]
      },
      "application/scvp-vp-request": {
        source: "iana",
        extensions: ["spq"]
      },
      "application/scvp-vp-response": {
        source: "iana",
        extensions: ["spp"]
      },
      "application/sdp": {
        source: "iana",
        extensions: ["sdp"]
      },
      "application/secevent+jwt": {
        source: "iana"
      },
      "application/senml+cbor": {
        source: "iana"
      },
      "application/senml+json": {
        source: "iana",
        compressible: true
      },
      "application/senml+xml": {
        source: "iana",
        compressible: true,
        extensions: ["senmlx"]
      },
      "application/senml-etch+cbor": {
        source: "iana"
      },
      "application/senml-etch+json": {
        source: "iana",
        compressible: true
      },
      "application/senml-exi": {
        source: "iana"
      },
      "application/sensml+cbor": {
        source: "iana"
      },
      "application/sensml+json": {
        source: "iana",
        compressible: true
      },
      "application/sensml+xml": {
        source: "iana",
        compressible: true,
        extensions: ["sensmlx"]
      },
      "application/sensml-exi": {
        source: "iana"
      },
      "application/sep+xml": {
        source: "iana",
        compressible: true
      },
      "application/sep-exi": {
        source: "iana"
      },
      "application/session-info": {
        source: "iana"
      },
      "application/set-payment": {
        source: "iana"
      },
      "application/set-payment-initiation": {
        source: "iana",
        extensions: ["setpay"]
      },
      "application/set-registration": {
        source: "iana"
      },
      "application/set-registration-initiation": {
        source: "iana",
        extensions: ["setreg"]
      },
      "application/sgml": {
        source: "iana"
      },
      "application/sgml-open-catalog": {
        source: "iana"
      },
      "application/shf+xml": {
        source: "iana",
        compressible: true,
        extensions: ["shf"]
      },
      "application/sieve": {
        source: "iana",
        extensions: ["siv", "sieve"]
      },
      "application/simple-filter+xml": {
        source: "iana",
        compressible: true
      },
      "application/simple-message-summary": {
        source: "iana"
      },
      "application/simplesymbolcontainer": {
        source: "iana"
      },
      "application/sipc": {
        source: "iana"
      },
      "application/slate": {
        source: "iana"
      },
      "application/smil": {
        source: "iana"
      },
      "application/smil+xml": {
        source: "iana",
        compressible: true,
        extensions: ["smi", "smil"]
      },
      "application/smpte336m": {
        source: "iana"
      },
      "application/soap+fastinfoset": {
        source: "iana"
      },
      "application/soap+xml": {
        source: "iana",
        compressible: true
      },
      "application/sparql-query": {
        source: "iana",
        extensions: ["rq"]
      },
      "application/sparql-results+xml": {
        source: "iana",
        compressible: true,
        extensions: ["srx"]
      },
      "application/spdx+json": {
        source: "iana",
        compressible: true
      },
      "application/spirits-event+xml": {
        source: "iana",
        compressible: true
      },
      "application/sql": {
        source: "iana"
      },
      "application/srgs": {
        source: "iana",
        extensions: ["gram"]
      },
      "application/srgs+xml": {
        source: "iana",
        compressible: true,
        extensions: ["grxml"]
      },
      "application/sru+xml": {
        source: "iana",
        compressible: true,
        extensions: ["sru"]
      },
      "application/ssdl+xml": {
        source: "apache",
        compressible: true,
        extensions: ["ssdl"]
      },
      "application/ssml+xml": {
        source: "iana",
        compressible: true,
        extensions: ["ssml"]
      },
      "application/stix+json": {
        source: "iana",
        compressible: true
      },
      "application/swid+xml": {
        source: "iana",
        compressible: true,
        extensions: ["swidtag"]
      },
      "application/tamp-apex-update": {
        source: "iana"
      },
      "application/tamp-apex-update-confirm": {
        source: "iana"
      },
      "application/tamp-community-update": {
        source: "iana"
      },
      "application/tamp-community-update-confirm": {
        source: "iana"
      },
      "application/tamp-error": {
        source: "iana"
      },
      "application/tamp-sequence-adjust": {
        source: "iana"
      },
      "application/tamp-sequence-adjust-confirm": {
        source: "iana"
      },
      "application/tamp-status-query": {
        source: "iana"
      },
      "application/tamp-status-response": {
        source: "iana"
      },
      "application/tamp-update": {
        source: "iana"
      },
      "application/tamp-update-confirm": {
        source: "iana"
      },
      "application/tar": {
        compressible: true
      },
      "application/taxii+json": {
        source: "iana",
        compressible: true
      },
      "application/td+json": {
        source: "iana",
        compressible: true
      },
      "application/tei+xml": {
        source: "iana",
        compressible: true,
        extensions: ["tei", "teicorpus"]
      },
      "application/tetra_isi": {
        source: "iana"
      },
      "application/thraud+xml": {
        source: "iana",
        compressible: true,
        extensions: ["tfi"]
      },
      "application/timestamp-query": {
        source: "iana"
      },
      "application/timestamp-reply": {
        source: "iana"
      },
      "application/timestamped-data": {
        source: "iana",
        extensions: ["tsd"]
      },
      "application/tlsrpt+gzip": {
        source: "iana"
      },
      "application/tlsrpt+json": {
        source: "iana",
        compressible: true
      },
      "application/tnauthlist": {
        source: "iana"
      },
      "application/token-introspection+jwt": {
        source: "iana"
      },
      "application/toml": {
        compressible: true,
        extensions: ["toml"]
      },
      "application/trickle-ice-sdpfrag": {
        source: "iana"
      },
      "application/trig": {
        source: "iana",
        extensions: ["trig"]
      },
      "application/ttml+xml": {
        source: "iana",
        compressible: true,
        extensions: ["ttml"]
      },
      "application/tve-trigger": {
        source: "iana"
      },
      "application/tzif": {
        source: "iana"
      },
      "application/tzif-leap": {
        source: "iana"
      },
      "application/ubjson": {
        compressible: false,
        extensions: ["ubj"]
      },
      "application/ulpfec": {
        source: "iana"
      },
      "application/urc-grpsheet+xml": {
        source: "iana",
        compressible: true
      },
      "application/urc-ressheet+xml": {
        source: "iana",
        compressible: true,
        extensions: ["rsheet"]
      },
      "application/urc-targetdesc+xml": {
        source: "iana",
        compressible: true,
        extensions: ["td"]
      },
      "application/urc-uisocketdesc+xml": {
        source: "iana",
        compressible: true
      },
      "application/vcard+json": {
        source: "iana",
        compressible: true
      },
      "application/vcard+xml": {
        source: "iana",
        compressible: true
      },
      "application/vemmi": {
        source: "iana"
      },
      "application/vividence.scriptfile": {
        source: "apache"
      },
      "application/vnd.1000minds.decision-model+xml": {
        source: "iana",
        compressible: true,
        extensions: ["1km"]
      },
      "application/vnd.3gpp-prose+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp-prose-pc3ch+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp-v2x-local-service-information": {
        source: "iana"
      },
      "application/vnd.3gpp.5gnas": {
        source: "iana"
      },
      "application/vnd.3gpp.access-transfer-events+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.bsf+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.gmop+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.gtpc": {
        source: "iana"
      },
      "application/vnd.3gpp.interworking-data": {
        source: "iana"
      },
      "application/vnd.3gpp.lpp": {
        source: "iana"
      },
      "application/vnd.3gpp.mc-signalling-ear": {
        source: "iana"
      },
      "application/vnd.3gpp.mcdata-affiliation-command+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcdata-info+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcdata-payload": {
        source: "iana"
      },
      "application/vnd.3gpp.mcdata-service-config+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcdata-signalling": {
        source: "iana"
      },
      "application/vnd.3gpp.mcdata-ue-config+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcdata-user-profile+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcptt-affiliation-command+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcptt-floor-request+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcptt-info+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcptt-location-info+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcptt-mbms-usage-info+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcptt-service-config+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcptt-signed+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcptt-ue-config+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcptt-ue-init-config+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcptt-user-profile+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcvideo-affiliation-command+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcvideo-affiliation-info+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcvideo-info+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcvideo-location-info+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcvideo-mbms-usage-info+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcvideo-service-config+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcvideo-transmission-request+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcvideo-ue-config+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mcvideo-user-profile+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.mid-call+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.ngap": {
        source: "iana"
      },
      "application/vnd.3gpp.pfcp": {
        source: "iana"
      },
      "application/vnd.3gpp.pic-bw-large": {
        source: "iana",
        extensions: ["plb"]
      },
      "application/vnd.3gpp.pic-bw-small": {
        source: "iana",
        extensions: ["psb"]
      },
      "application/vnd.3gpp.pic-bw-var": {
        source: "iana",
        extensions: ["pvb"]
      },
      "application/vnd.3gpp.s1ap": {
        source: "iana"
      },
      "application/vnd.3gpp.sms": {
        source: "iana"
      },
      "application/vnd.3gpp.sms+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.srvcc-ext+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.srvcc-info+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.state-and-event-info+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp.ussd+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp2.bcmcsinfo+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.3gpp2.sms": {
        source: "iana"
      },
      "application/vnd.3gpp2.tcap": {
        source: "iana",
        extensions: ["tcap"]
      },
      "application/vnd.3lightssoftware.imagescal": {
        source: "iana"
      },
      "application/vnd.3m.post-it-notes": {
        source: "iana",
        extensions: ["pwn"]
      },
      "application/vnd.accpac.simply.aso": {
        source: "iana",
        extensions: ["aso"]
      },
      "application/vnd.accpac.simply.imp": {
        source: "iana",
        extensions: ["imp"]
      },
      "application/vnd.acucobol": {
        source: "iana",
        extensions: ["acu"]
      },
      "application/vnd.acucorp": {
        source: "iana",
        extensions: ["atc", "acutc"]
      },
      "application/vnd.adobe.air-application-installer-package+zip": {
        source: "apache",
        compressible: false,
        extensions: ["air"]
      },
      "application/vnd.adobe.flash.movie": {
        source: "iana"
      },
      "application/vnd.adobe.formscentral.fcdt": {
        source: "iana",
        extensions: ["fcdt"]
      },
      "application/vnd.adobe.fxp": {
        source: "iana",
        extensions: ["fxp", "fxpl"]
      },
      "application/vnd.adobe.partial-upload": {
        source: "iana"
      },
      "application/vnd.adobe.xdp+xml": {
        source: "iana",
        compressible: true,
        extensions: ["xdp"]
      },
      "application/vnd.adobe.xfdf": {
        source: "iana",
        extensions: ["xfdf"]
      },
      "application/vnd.aether.imp": {
        source: "iana"
      },
      "application/vnd.afpc.afplinedata": {
        source: "iana"
      },
      "application/vnd.afpc.afplinedata-pagedef": {
        source: "iana"
      },
      "application/vnd.afpc.cmoca-cmresource": {
        source: "iana"
      },
      "application/vnd.afpc.foca-charset": {
        source: "iana"
      },
      "application/vnd.afpc.foca-codedfont": {
        source: "iana"
      },
      "application/vnd.afpc.foca-codepage": {
        source: "iana"
      },
      "application/vnd.afpc.modca": {
        source: "iana"
      },
      "application/vnd.afpc.modca-cmtable": {
        source: "iana"
      },
      "application/vnd.afpc.modca-formdef": {
        source: "iana"
      },
      "application/vnd.afpc.modca-mediummap": {
        source: "iana"
      },
      "application/vnd.afpc.modca-objectcontainer": {
        source: "iana"
      },
      "application/vnd.afpc.modca-overlay": {
        source: "iana"
      },
      "application/vnd.afpc.modca-pagesegment": {
        source: "iana"
      },
      "application/vnd.age": {
        source: "iana",
        extensions: ["age"]
      },
      "application/vnd.ah-barcode": {
        source: "iana"
      },
      "application/vnd.ahead.space": {
        source: "iana",
        extensions: ["ahead"]
      },
      "application/vnd.airzip.filesecure.azf": {
        source: "iana",
        extensions: ["azf"]
      },
      "application/vnd.airzip.filesecure.azs": {
        source: "iana",
        extensions: ["azs"]
      },
      "application/vnd.amadeus+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.amazon.ebook": {
        source: "apache",
        extensions: ["azw"]
      },
      "application/vnd.amazon.mobi8-ebook": {
        source: "iana"
      },
      "application/vnd.americandynamics.acc": {
        source: "iana",
        extensions: ["acc"]
      },
      "application/vnd.amiga.ami": {
        source: "iana",
        extensions: ["ami"]
      },
      "application/vnd.amundsen.maze+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.android.ota": {
        source: "iana"
      },
      "application/vnd.android.package-archive": {
        source: "apache",
        compressible: false,
        extensions: ["apk"]
      },
      "application/vnd.anki": {
        source: "iana"
      },
      "application/vnd.anser-web-certificate-issue-initiation": {
        source: "iana",
        extensions: ["cii"]
      },
      "application/vnd.anser-web-funds-transfer-initiation": {
        source: "apache",
        extensions: ["fti"]
      },
      "application/vnd.antix.game-component": {
        source: "iana",
        extensions: ["atx"]
      },
      "application/vnd.apache.arrow.file": {
        source: "iana"
      },
      "application/vnd.apache.arrow.stream": {
        source: "iana"
      },
      "application/vnd.apache.thrift.binary": {
        source: "iana"
      },
      "application/vnd.apache.thrift.compact": {
        source: "iana"
      },
      "application/vnd.apache.thrift.json": {
        source: "iana"
      },
      "application/vnd.api+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.aplextor.warrp+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.apothekende.reservation+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.apple.installer+xml": {
        source: "iana",
        compressible: true,
        extensions: ["mpkg"]
      },
      "application/vnd.apple.keynote": {
        source: "iana",
        extensions: ["key"]
      },
      "application/vnd.apple.mpegurl": {
        source: "iana",
        extensions: ["m3u8"]
      },
      "application/vnd.apple.numbers": {
        source: "iana",
        extensions: ["numbers"]
      },
      "application/vnd.apple.pages": {
        source: "iana",
        extensions: ["pages"]
      },
      "application/vnd.apple.pkpass": {
        compressible: false,
        extensions: ["pkpass"]
      },
      "application/vnd.arastra.swi": {
        source: "iana"
      },
      "application/vnd.aristanetworks.swi": {
        source: "iana",
        extensions: ["swi"]
      },
      "application/vnd.artisan+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.artsquare": {
        source: "iana"
      },
      "application/vnd.astraea-software.iota": {
        source: "iana",
        extensions: ["iota"]
      },
      "application/vnd.audiograph": {
        source: "iana",
        extensions: ["aep"]
      },
      "application/vnd.autopackage": {
        source: "iana"
      },
      "application/vnd.avalon+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.avistar+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.balsamiq.bmml+xml": {
        source: "iana",
        compressible: true,
        extensions: ["bmml"]
      },
      "application/vnd.balsamiq.bmpr": {
        source: "iana"
      },
      "application/vnd.banana-accounting": {
        source: "iana"
      },
      "application/vnd.bbf.usp.error": {
        source: "iana"
      },
      "application/vnd.bbf.usp.msg": {
        source: "iana"
      },
      "application/vnd.bbf.usp.msg+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.bekitzur-stech+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.bint.med-content": {
        source: "iana"
      },
      "application/vnd.biopax.rdf+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.blink-idb-value-wrapper": {
        source: "iana"
      },
      "application/vnd.blueice.multipass": {
        source: "iana",
        extensions: ["mpm"]
      },
      "application/vnd.bluetooth.ep.oob": {
        source: "iana"
      },
      "application/vnd.bluetooth.le.oob": {
        source: "iana"
      },
      "application/vnd.bmi": {
        source: "iana",
        extensions: ["bmi"]
      },
      "application/vnd.bpf": {
        source: "iana"
      },
      "application/vnd.bpf3": {
        source: "iana"
      },
      "application/vnd.businessobjects": {
        source: "iana",
        extensions: ["rep"]
      },
      "application/vnd.byu.uapi+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.cab-jscript": {
        source: "iana"
      },
      "application/vnd.canon-cpdl": {
        source: "iana"
      },
      "application/vnd.canon-lips": {
        source: "iana"
      },
      "application/vnd.capasystems-pg+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.cendio.thinlinc.clientconf": {
        source: "iana"
      },
      "application/vnd.century-systems.tcp_stream": {
        source: "iana"
      },
      "application/vnd.chemdraw+xml": {
        source: "iana",
        compressible: true,
        extensions: ["cdxml"]
      },
      "application/vnd.chess-pgn": {
        source: "iana"
      },
      "application/vnd.chipnuts.karaoke-mmd": {
        source: "iana",
        extensions: ["mmd"]
      },
      "application/vnd.ciedi": {
        source: "iana"
      },
      "application/vnd.cinderella": {
        source: "iana",
        extensions: ["cdy"]
      },
      "application/vnd.cirpack.isdn-ext": {
        source: "iana"
      },
      "application/vnd.citationstyles.style+xml": {
        source: "iana",
        compressible: true,
        extensions: ["csl"]
      },
      "application/vnd.claymore": {
        source: "iana",
        extensions: ["cla"]
      },
      "application/vnd.cloanto.rp9": {
        source: "iana",
        extensions: ["rp9"]
      },
      "application/vnd.clonk.c4group": {
        source: "iana",
        extensions: ["c4g", "c4d", "c4f", "c4p", "c4u"]
      },
      "application/vnd.cluetrust.cartomobile-config": {
        source: "iana",
        extensions: ["c11amc"]
      },
      "application/vnd.cluetrust.cartomobile-config-pkg": {
        source: "iana",
        extensions: ["c11amz"]
      },
      "application/vnd.coffeescript": {
        source: "iana"
      },
      "application/vnd.collabio.xodocuments.document": {
        source: "iana"
      },
      "application/vnd.collabio.xodocuments.document-template": {
        source: "iana"
      },
      "application/vnd.collabio.xodocuments.presentation": {
        source: "iana"
      },
      "application/vnd.collabio.xodocuments.presentation-template": {
        source: "iana"
      },
      "application/vnd.collabio.xodocuments.spreadsheet": {
        source: "iana"
      },
      "application/vnd.collabio.xodocuments.spreadsheet-template": {
        source: "iana"
      },
      "application/vnd.collection+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.collection.doc+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.collection.next+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.comicbook+zip": {
        source: "iana",
        compressible: false
      },
      "application/vnd.comicbook-rar": {
        source: "iana"
      },
      "application/vnd.commerce-battelle": {
        source: "iana"
      },
      "application/vnd.commonspace": {
        source: "iana",
        extensions: ["csp"]
      },
      "application/vnd.contact.cmsg": {
        source: "iana",
        extensions: ["cdbcmsg"]
      },
      "application/vnd.coreos.ignition+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.cosmocaller": {
        source: "iana",
        extensions: ["cmc"]
      },
      "application/vnd.crick.clicker": {
        source: "iana",
        extensions: ["clkx"]
      },
      "application/vnd.crick.clicker.keyboard": {
        source: "iana",
        extensions: ["clkk"]
      },
      "application/vnd.crick.clicker.palette": {
        source: "iana",
        extensions: ["clkp"]
      },
      "application/vnd.crick.clicker.template": {
        source: "iana",
        extensions: ["clkt"]
      },
      "application/vnd.crick.clicker.wordbank": {
        source: "iana",
        extensions: ["clkw"]
      },
      "application/vnd.criticaltools.wbs+xml": {
        source: "iana",
        compressible: true,
        extensions: ["wbs"]
      },
      "application/vnd.cryptii.pipe+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.crypto-shade-file": {
        source: "iana"
      },
      "application/vnd.cryptomator.encrypted": {
        source: "iana"
      },
      "application/vnd.cryptomator.vault": {
        source: "iana"
      },
      "application/vnd.ctc-posml": {
        source: "iana",
        extensions: ["pml"]
      },
      "application/vnd.ctct.ws+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.cups-pdf": {
        source: "iana"
      },
      "application/vnd.cups-postscript": {
        source: "iana"
      },
      "application/vnd.cups-ppd": {
        source: "iana",
        extensions: ["ppd"]
      },
      "application/vnd.cups-raster": {
        source: "iana"
      },
      "application/vnd.cups-raw": {
        source: "iana"
      },
      "application/vnd.curl": {
        source: "iana"
      },
      "application/vnd.curl.car": {
        source: "apache",
        extensions: ["car"]
      },
      "application/vnd.curl.pcurl": {
        source: "apache",
        extensions: ["pcurl"]
      },
      "application/vnd.cyan.dean.root+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.cybank": {
        source: "iana"
      },
      "application/vnd.cyclonedx+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.cyclonedx+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.d2l.coursepackage1p0+zip": {
        source: "iana",
        compressible: false
      },
      "application/vnd.d3m-dataset": {
        source: "iana"
      },
      "application/vnd.d3m-problem": {
        source: "iana"
      },
      "application/vnd.dart": {
        source: "iana",
        compressible: true,
        extensions: ["dart"]
      },
      "application/vnd.data-vision.rdz": {
        source: "iana",
        extensions: ["rdz"]
      },
      "application/vnd.datapackage+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.dataresource+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.dbf": {
        source: "iana",
        extensions: ["dbf"]
      },
      "application/vnd.debian.binary-package": {
        source: "iana"
      },
      "application/vnd.dece.data": {
        source: "iana",
        extensions: ["uvf", "uvvf", "uvd", "uvvd"]
      },
      "application/vnd.dece.ttml+xml": {
        source: "iana",
        compressible: true,
        extensions: ["uvt", "uvvt"]
      },
      "application/vnd.dece.unspecified": {
        source: "iana",
        extensions: ["uvx", "uvvx"]
      },
      "application/vnd.dece.zip": {
        source: "iana",
        extensions: ["uvz", "uvvz"]
      },
      "application/vnd.denovo.fcselayout-link": {
        source: "iana",
        extensions: ["fe_launch"]
      },
      "application/vnd.desmume.movie": {
        source: "iana"
      },
      "application/vnd.dir-bi.plate-dl-nosuffix": {
        source: "iana"
      },
      "application/vnd.dm.delegation+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.dna": {
        source: "iana",
        extensions: ["dna"]
      },
      "application/vnd.document+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.dolby.mlp": {
        source: "apache",
        extensions: ["mlp"]
      },
      "application/vnd.dolby.mobile.1": {
        source: "iana"
      },
      "application/vnd.dolby.mobile.2": {
        source: "iana"
      },
      "application/vnd.doremir.scorecloud-binary-document": {
        source: "iana"
      },
      "application/vnd.dpgraph": {
        source: "iana",
        extensions: ["dpg"]
      },
      "application/vnd.dreamfactory": {
        source: "iana",
        extensions: ["dfac"]
      },
      "application/vnd.drive+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.ds-keypoint": {
        source: "apache",
        extensions: ["kpxx"]
      },
      "application/vnd.dtg.local": {
        source: "iana"
      },
      "application/vnd.dtg.local.flash": {
        source: "iana"
      },
      "application/vnd.dtg.local.html": {
        source: "iana"
      },
      "application/vnd.dvb.ait": {
        source: "iana",
        extensions: ["ait"]
      },
      "application/vnd.dvb.dvbisl+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.dvb.dvbj": {
        source: "iana"
      },
      "application/vnd.dvb.esgcontainer": {
        source: "iana"
      },
      "application/vnd.dvb.ipdcdftnotifaccess": {
        source: "iana"
      },
      "application/vnd.dvb.ipdcesgaccess": {
        source: "iana"
      },
      "application/vnd.dvb.ipdcesgaccess2": {
        source: "iana"
      },
      "application/vnd.dvb.ipdcesgpdd": {
        source: "iana"
      },
      "application/vnd.dvb.ipdcroaming": {
        source: "iana"
      },
      "application/vnd.dvb.iptv.alfec-base": {
        source: "iana"
      },
      "application/vnd.dvb.iptv.alfec-enhancement": {
        source: "iana"
      },
      "application/vnd.dvb.notif-aggregate-root+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.dvb.notif-container+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.dvb.notif-generic+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.dvb.notif-ia-msglist+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.dvb.notif-ia-registration-request+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.dvb.notif-ia-registration-response+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.dvb.notif-init+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.dvb.pfr": {
        source: "iana"
      },
      "application/vnd.dvb.service": {
        source: "iana",
        extensions: ["svc"]
      },
      "application/vnd.dxr": {
        source: "iana"
      },
      "application/vnd.dynageo": {
        source: "iana",
        extensions: ["geo"]
      },
      "application/vnd.dzr": {
        source: "iana"
      },
      "application/vnd.easykaraoke.cdgdownload": {
        source: "iana"
      },
      "application/vnd.ecdis-update": {
        source: "iana"
      },
      "application/vnd.ecip.rlp": {
        source: "iana"
      },
      "application/vnd.eclipse.ditto+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.ecowin.chart": {
        source: "iana",
        extensions: ["mag"]
      },
      "application/vnd.ecowin.filerequest": {
        source: "iana"
      },
      "application/vnd.ecowin.fileupdate": {
        source: "iana"
      },
      "application/vnd.ecowin.series": {
        source: "iana"
      },
      "application/vnd.ecowin.seriesrequest": {
        source: "iana"
      },
      "application/vnd.ecowin.seriesupdate": {
        source: "iana"
      },
      "application/vnd.efi.img": {
        source: "iana"
      },
      "application/vnd.efi.iso": {
        source: "iana"
      },
      "application/vnd.emclient.accessrequest+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.enliven": {
        source: "iana",
        extensions: ["nml"]
      },
      "application/vnd.enphase.envoy": {
        source: "iana"
      },
      "application/vnd.eprints.data+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.epson.esf": {
        source: "iana",
        extensions: ["esf"]
      },
      "application/vnd.epson.msf": {
        source: "iana",
        extensions: ["msf"]
      },
      "application/vnd.epson.quickanime": {
        source: "iana",
        extensions: ["qam"]
      },
      "application/vnd.epson.salt": {
        source: "iana",
        extensions: ["slt"]
      },
      "application/vnd.epson.ssf": {
        source: "iana",
        extensions: ["ssf"]
      },
      "application/vnd.ericsson.quickcall": {
        source: "iana"
      },
      "application/vnd.espass-espass+zip": {
        source: "iana",
        compressible: false
      },
      "application/vnd.eszigno3+xml": {
        source: "iana",
        compressible: true,
        extensions: ["es3", "et3"]
      },
      "application/vnd.etsi.aoc+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.etsi.asic-e+zip": {
        source: "iana",
        compressible: false
      },
      "application/vnd.etsi.asic-s+zip": {
        source: "iana",
        compressible: false
      },
      "application/vnd.etsi.cug+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.etsi.iptvcommand+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.etsi.iptvdiscovery+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.etsi.iptvprofile+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.etsi.iptvsad-bc+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.etsi.iptvsad-cod+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.etsi.iptvsad-npvr+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.etsi.iptvservice+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.etsi.iptvsync+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.etsi.iptvueprofile+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.etsi.mcid+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.etsi.mheg5": {
        source: "iana"
      },
      "application/vnd.etsi.overload-control-policy-dataset+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.etsi.pstn+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.etsi.sci+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.etsi.simservs+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.etsi.timestamp-token": {
        source: "iana"
      },
      "application/vnd.etsi.tsl+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.etsi.tsl.der": {
        source: "iana"
      },
      "application/vnd.eu.kasparian.car+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.eudora.data": {
        source: "iana"
      },
      "application/vnd.evolv.ecig.profile": {
        source: "iana"
      },
      "application/vnd.evolv.ecig.settings": {
        source: "iana"
      },
      "application/vnd.evolv.ecig.theme": {
        source: "iana"
      },
      "application/vnd.exstream-empower+zip": {
        source: "iana",
        compressible: false
      },
      "application/vnd.exstream-package": {
        source: "iana"
      },
      "application/vnd.ezpix-album": {
        source: "iana",
        extensions: ["ez2"]
      },
      "application/vnd.ezpix-package": {
        source: "iana",
        extensions: ["ez3"]
      },
      "application/vnd.f-secure.mobile": {
        source: "iana"
      },
      "application/vnd.familysearch.gedcom+zip": {
        source: "iana",
        compressible: false
      },
      "application/vnd.fastcopy-disk-image": {
        source: "iana"
      },
      "application/vnd.fdf": {
        source: "iana",
        extensions: ["fdf"]
      },
      "application/vnd.fdsn.mseed": {
        source: "iana",
        extensions: ["mseed"]
      },
      "application/vnd.fdsn.seed": {
        source: "iana",
        extensions: ["seed", "dataless"]
      },
      "application/vnd.ffsns": {
        source: "iana"
      },
      "application/vnd.ficlab.flb+zip": {
        source: "iana",
        compressible: false
      },
      "application/vnd.filmit.zfc": {
        source: "iana"
      },
      "application/vnd.fints": {
        source: "iana"
      },
      "application/vnd.firemonkeys.cloudcell": {
        source: "iana"
      },
      "application/vnd.flographit": {
        source: "iana",
        extensions: ["gph"]
      },
      "application/vnd.fluxtime.clip": {
        source: "iana",
        extensions: ["ftc"]
      },
      "application/vnd.font-fontforge-sfd": {
        source: "iana"
      },
      "application/vnd.framemaker": {
        source: "iana",
        extensions: ["fm", "frame", "maker", "book"]
      },
      "application/vnd.frogans.fnc": {
        source: "iana",
        extensions: ["fnc"]
      },
      "application/vnd.frogans.ltf": {
        source: "iana",
        extensions: ["ltf"]
      },
      "application/vnd.fsc.weblaunch": {
        source: "iana",
        extensions: ["fsc"]
      },
      "application/vnd.fujifilm.fb.docuworks": {
        source: "iana"
      },
      "application/vnd.fujifilm.fb.docuworks.binder": {
        source: "iana"
      },
      "application/vnd.fujifilm.fb.docuworks.container": {
        source: "iana"
      },
      "application/vnd.fujifilm.fb.jfi+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.fujitsu.oasys": {
        source: "iana",
        extensions: ["oas"]
      },
      "application/vnd.fujitsu.oasys2": {
        source: "iana",
        extensions: ["oa2"]
      },
      "application/vnd.fujitsu.oasys3": {
        source: "iana",
        extensions: ["oa3"]
      },
      "application/vnd.fujitsu.oasysgp": {
        source: "iana",
        extensions: ["fg5"]
      },
      "application/vnd.fujitsu.oasysprs": {
        source: "iana",
        extensions: ["bh2"]
      },
      "application/vnd.fujixerox.art-ex": {
        source: "iana"
      },
      "application/vnd.fujixerox.art4": {
        source: "iana"
      },
      "application/vnd.fujixerox.ddd": {
        source: "iana",
        extensions: ["ddd"]
      },
      "application/vnd.fujixerox.docuworks": {
        source: "iana",
        extensions: ["xdw"]
      },
      "application/vnd.fujixerox.docuworks.binder": {
        source: "iana",
        extensions: ["xbd"]
      },
      "application/vnd.fujixerox.docuworks.container": {
        source: "iana"
      },
      "application/vnd.fujixerox.hbpl": {
        source: "iana"
      },
      "application/vnd.fut-misnet": {
        source: "iana"
      },
      "application/vnd.futoin+cbor": {
        source: "iana"
      },
      "application/vnd.futoin+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.fuzzysheet": {
        source: "iana",
        extensions: ["fzs"]
      },
      "application/vnd.genomatix.tuxedo": {
        source: "iana",
        extensions: ["txd"]
      },
      "application/vnd.gentics.grd+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.geo+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.geocube+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.geogebra.file": {
        source: "iana",
        extensions: ["ggb"]
      },
      "application/vnd.geogebra.slides": {
        source: "iana"
      },
      "application/vnd.geogebra.tool": {
        source: "iana",
        extensions: ["ggt"]
      },
      "application/vnd.geometry-explorer": {
        source: "iana",
        extensions: ["gex", "gre"]
      },
      "application/vnd.geonext": {
        source: "iana",
        extensions: ["gxt"]
      },
      "application/vnd.geoplan": {
        source: "iana",
        extensions: ["g2w"]
      },
      "application/vnd.geospace": {
        source: "iana",
        extensions: ["g3w"]
      },
      "application/vnd.gerber": {
        source: "iana"
      },
      "application/vnd.globalplatform.card-content-mgt": {
        source: "iana"
      },
      "application/vnd.globalplatform.card-content-mgt-response": {
        source: "iana"
      },
      "application/vnd.gmx": {
        source: "iana",
        extensions: ["gmx"]
      },
      "application/vnd.google-apps.document": {
        compressible: false,
        extensions: ["gdoc"]
      },
      "application/vnd.google-apps.presentation": {
        compressible: false,
        extensions: ["gslides"]
      },
      "application/vnd.google-apps.spreadsheet": {
        compressible: false,
        extensions: ["gsheet"]
      },
      "application/vnd.google-earth.kml+xml": {
        source: "iana",
        compressible: true,
        extensions: ["kml"]
      },
      "application/vnd.google-earth.kmz": {
        source: "iana",
        compressible: false,
        extensions: ["kmz"]
      },
      "application/vnd.gov.sk.e-form+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.gov.sk.e-form+zip": {
        source: "iana",
        compressible: false
      },
      "application/vnd.gov.sk.xmldatacontainer+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.grafeq": {
        source: "iana",
        extensions: ["gqf", "gqs"]
      },
      "application/vnd.gridmp": {
        source: "iana"
      },
      "application/vnd.groove-account": {
        source: "iana",
        extensions: ["gac"]
      },
      "application/vnd.groove-help": {
        source: "iana",
        extensions: ["ghf"]
      },
      "application/vnd.groove-identity-message": {
        source: "iana",
        extensions: ["gim"]
      },
      "application/vnd.groove-injector": {
        source: "iana",
        extensions: ["grv"]
      },
      "application/vnd.groove-tool-message": {
        source: "iana",
        extensions: ["gtm"]
      },
      "application/vnd.groove-tool-template": {
        source: "iana",
        extensions: ["tpl"]
      },
      "application/vnd.groove-vcard": {
        source: "iana",
        extensions: ["vcg"]
      },
      "application/vnd.hal+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.hal+xml": {
        source: "iana",
        compressible: true,
        extensions: ["hal"]
      },
      "application/vnd.handheld-entertainment+xml": {
        source: "iana",
        compressible: true,
        extensions: ["zmm"]
      },
      "application/vnd.hbci": {
        source: "iana",
        extensions: ["hbci"]
      },
      "application/vnd.hc+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.hcl-bireports": {
        source: "iana"
      },
      "application/vnd.hdt": {
        source: "iana"
      },
      "application/vnd.heroku+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.hhe.lesson-player": {
        source: "iana",
        extensions: ["les"]
      },
      "application/vnd.hl7cda+xml": {
        source: "iana",
        charset: "UTF-8",
        compressible: true
      },
      "application/vnd.hl7v2+xml": {
        source: "iana",
        charset: "UTF-8",
        compressible: true
      },
      "application/vnd.hp-hpgl": {
        source: "iana",
        extensions: ["hpgl"]
      },
      "application/vnd.hp-hpid": {
        source: "iana",
        extensions: ["hpid"]
      },
      "application/vnd.hp-hps": {
        source: "iana",
        extensions: ["hps"]
      },
      "application/vnd.hp-jlyt": {
        source: "iana",
        extensions: ["jlt"]
      },
      "application/vnd.hp-pcl": {
        source: "iana",
        extensions: ["pcl"]
      },
      "application/vnd.hp-pclxl": {
        source: "iana",
        extensions: ["pclxl"]
      },
      "application/vnd.httphone": {
        source: "iana"
      },
      "application/vnd.hydrostatix.sof-data": {
        source: "iana",
        extensions: ["sfd-hdstx"]
      },
      "application/vnd.hyper+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.hyper-item+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.hyperdrive+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.hzn-3d-crossword": {
        source: "iana"
      },
      "application/vnd.ibm.afplinedata": {
        source: "iana"
      },
      "application/vnd.ibm.electronic-media": {
        source: "iana"
      },
      "application/vnd.ibm.minipay": {
        source: "iana",
        extensions: ["mpy"]
      },
      "application/vnd.ibm.modcap": {
        source: "iana",
        extensions: ["afp", "listafp", "list3820"]
      },
      "application/vnd.ibm.rights-management": {
        source: "iana",
        extensions: ["irm"]
      },
      "application/vnd.ibm.secure-container": {
        source: "iana",
        extensions: ["sc"]
      },
      "application/vnd.iccprofile": {
        source: "iana",
        extensions: ["icc", "icm"]
      },
      "application/vnd.ieee.1905": {
        source: "iana"
      },
      "application/vnd.igloader": {
        source: "iana",
        extensions: ["igl"]
      },
      "application/vnd.imagemeter.folder+zip": {
        source: "iana",
        compressible: false
      },
      "application/vnd.imagemeter.image+zip": {
        source: "iana",
        compressible: false
      },
      "application/vnd.immervision-ivp": {
        source: "iana",
        extensions: ["ivp"]
      },
      "application/vnd.immervision-ivu": {
        source: "iana",
        extensions: ["ivu"]
      },
      "application/vnd.ims.imsccv1p1": {
        source: "iana"
      },
      "application/vnd.ims.imsccv1p2": {
        source: "iana"
      },
      "application/vnd.ims.imsccv1p3": {
        source: "iana"
      },
      "application/vnd.ims.lis.v2.result+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.ims.lti.v2.toolconsumerprofile+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.ims.lti.v2.toolproxy+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.ims.lti.v2.toolproxy.id+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.ims.lti.v2.toolsettings+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.ims.lti.v2.toolsettings.simple+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.informedcontrol.rms+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.informix-visionary": {
        source: "iana"
      },
      "application/vnd.infotech.project": {
        source: "iana"
      },
      "application/vnd.infotech.project+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.innopath.wamp.notification": {
        source: "iana"
      },
      "application/vnd.insors.igm": {
        source: "iana",
        extensions: ["igm"]
      },
      "application/vnd.intercon.formnet": {
        source: "iana",
        extensions: ["xpw", "xpx"]
      },
      "application/vnd.intergeo": {
        source: "iana",
        extensions: ["i2g"]
      },
      "application/vnd.intertrust.digibox": {
        source: "iana"
      },
      "application/vnd.intertrust.nncp": {
        source: "iana"
      },
      "application/vnd.intu.qbo": {
        source: "iana",
        extensions: ["qbo"]
      },
      "application/vnd.intu.qfx": {
        source: "iana",
        extensions: ["qfx"]
      },
      "application/vnd.iptc.g2.catalogitem+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.iptc.g2.conceptitem+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.iptc.g2.knowledgeitem+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.iptc.g2.newsitem+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.iptc.g2.newsmessage+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.iptc.g2.packageitem+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.iptc.g2.planningitem+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.ipunplugged.rcprofile": {
        source: "iana",
        extensions: ["rcprofile"]
      },
      "application/vnd.irepository.package+xml": {
        source: "iana",
        compressible: true,
        extensions: ["irp"]
      },
      "application/vnd.is-xpr": {
        source: "iana",
        extensions: ["xpr"]
      },
      "application/vnd.isac.fcs": {
        source: "iana",
        extensions: ["fcs"]
      },
      "application/vnd.iso11783-10+zip": {
        source: "iana",
        compressible: false
      },
      "application/vnd.jam": {
        source: "iana",
        extensions: ["jam"]
      },
      "application/vnd.japannet-directory-service": {
        source: "iana"
      },
      "application/vnd.japannet-jpnstore-wakeup": {
        source: "iana"
      },
      "application/vnd.japannet-payment-wakeup": {
        source: "iana"
      },
      "application/vnd.japannet-registration": {
        source: "iana"
      },
      "application/vnd.japannet-registration-wakeup": {
        source: "iana"
      },
      "application/vnd.japannet-setstore-wakeup": {
        source: "iana"
      },
      "application/vnd.japannet-verification": {
        source: "iana"
      },
      "application/vnd.japannet-verification-wakeup": {
        source: "iana"
      },
      "application/vnd.jcp.javame.midlet-rms": {
        source: "iana",
        extensions: ["rms"]
      },
      "application/vnd.jisp": {
        source: "iana",
        extensions: ["jisp"]
      },
      "application/vnd.joost.joda-archive": {
        source: "iana",
        extensions: ["joda"]
      },
      "application/vnd.jsk.isdn-ngn": {
        source: "iana"
      },
      "application/vnd.kahootz": {
        source: "iana",
        extensions: ["ktz", "ktr"]
      },
      "application/vnd.kde.karbon": {
        source: "iana",
        extensions: ["karbon"]
      },
      "application/vnd.kde.kchart": {
        source: "iana",
        extensions: ["chrt"]
      },
      "application/vnd.kde.kformula": {
        source: "iana",
        extensions: ["kfo"]
      },
      "application/vnd.kde.kivio": {
        source: "iana",
        extensions: ["flw"]
      },
      "application/vnd.kde.kontour": {
        source: "iana",
        extensions: ["kon"]
      },
      "application/vnd.kde.kpresenter": {
        source: "iana",
        extensions: ["kpr", "kpt"]
      },
      "application/vnd.kde.kspread": {
        source: "iana",
        extensions: ["ksp"]
      },
      "application/vnd.kde.kword": {
        source: "iana",
        extensions: ["kwd", "kwt"]
      },
      "application/vnd.kenameaapp": {
        source: "iana",
        extensions: ["htke"]
      },
      "application/vnd.kidspiration": {
        source: "iana",
        extensions: ["kia"]
      },
      "application/vnd.kinar": {
        source: "iana",
        extensions: ["kne", "knp"]
      },
      "application/vnd.koan": {
        source: "iana",
        extensions: ["skp", "skd", "skt", "skm"]
      },
      "application/vnd.kodak-descriptor": {
        source: "iana",
        extensions: ["sse"]
      },
      "application/vnd.las": {
        source: "iana"
      },
      "application/vnd.las.las+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.las.las+xml": {
        source: "iana",
        compressible: true,
        extensions: ["lasxml"]
      },
      "application/vnd.laszip": {
        source: "iana"
      },
      "application/vnd.leap+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.liberty-request+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.llamagraphics.life-balance.desktop": {
        source: "iana",
        extensions: ["lbd"]
      },
      "application/vnd.llamagraphics.life-balance.exchange+xml": {
        source: "iana",
        compressible: true,
        extensions: ["lbe"]
      },
      "application/vnd.logipipe.circuit+zip": {
        source: "iana",
        compressible: false
      },
      "application/vnd.loom": {
        source: "iana"
      },
      "application/vnd.lotus-1-2-3": {
        source: "iana",
        extensions: ["123"]
      },
      "application/vnd.lotus-approach": {
        source: "iana",
        extensions: ["apr"]
      },
      "application/vnd.lotus-freelance": {
        source: "iana",
        extensions: ["pre"]
      },
      "application/vnd.lotus-notes": {
        source: "iana",
        extensions: ["nsf"]
      },
      "application/vnd.lotus-organizer": {
        source: "iana",
        extensions: ["org"]
      },
      "application/vnd.lotus-screencam": {
        source: "iana",
        extensions: ["scm"]
      },
      "application/vnd.lotus-wordpro": {
        source: "iana",
        extensions: ["lwp"]
      },
      "application/vnd.macports.portpkg": {
        source: "iana",
        extensions: ["portpkg"]
      },
      "application/vnd.mapbox-vector-tile": {
        source: "iana",
        extensions: ["mvt"]
      },
      "application/vnd.marlin.drm.actiontoken+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.marlin.drm.conftoken+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.marlin.drm.license+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.marlin.drm.mdcf": {
        source: "iana"
      },
      "application/vnd.mason+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.maxar.archive.3tz+zip": {
        source: "iana",
        compressible: false
      },
      "application/vnd.maxmind.maxmind-db": {
        source: "iana"
      },
      "application/vnd.mcd": {
        source: "iana",
        extensions: ["mcd"]
      },
      "application/vnd.medcalcdata": {
        source: "iana",
        extensions: ["mc1"]
      },
      "application/vnd.mediastation.cdkey": {
        source: "iana",
        extensions: ["cdkey"]
      },
      "application/vnd.meridian-slingshot": {
        source: "iana"
      },
      "application/vnd.mfer": {
        source: "iana",
        extensions: ["mwf"]
      },
      "application/vnd.mfmp": {
        source: "iana",
        extensions: ["mfm"]
      },
      "application/vnd.micro+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.micrografx.flo": {
        source: "iana",
        extensions: ["flo"]
      },
      "application/vnd.micrografx.igx": {
        source: "iana",
        extensions: ["igx"]
      },
      "application/vnd.microsoft.portable-executable": {
        source: "iana"
      },
      "application/vnd.microsoft.windows.thumbnail-cache": {
        source: "iana"
      },
      "application/vnd.miele+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.mif": {
        source: "iana",
        extensions: ["mif"]
      },
      "application/vnd.minisoft-hp3000-save": {
        source: "iana"
      },
      "application/vnd.mitsubishi.misty-guard.trustweb": {
        source: "iana"
      },
      "application/vnd.mobius.daf": {
        source: "iana",
        extensions: ["daf"]
      },
      "application/vnd.mobius.dis": {
        source: "iana",
        extensions: ["dis"]
      },
      "application/vnd.mobius.mbk": {
        source: "iana",
        extensions: ["mbk"]
      },
      "application/vnd.mobius.mqy": {
        source: "iana",
        extensions: ["mqy"]
      },
      "application/vnd.mobius.msl": {
        source: "iana",
        extensions: ["msl"]
      },
      "application/vnd.mobius.plc": {
        source: "iana",
        extensions: ["plc"]
      },
      "application/vnd.mobius.txf": {
        source: "iana",
        extensions: ["txf"]
      },
      "application/vnd.mophun.application": {
        source: "iana",
        extensions: ["mpn"]
      },
      "application/vnd.mophun.certificate": {
        source: "iana",
        extensions: ["mpc"]
      },
      "application/vnd.motorola.flexsuite": {
        source: "iana"
      },
      "application/vnd.motorola.flexsuite.adsi": {
        source: "iana"
      },
      "application/vnd.motorola.flexsuite.fis": {
        source: "iana"
      },
      "application/vnd.motorola.flexsuite.gotap": {
        source: "iana"
      },
      "application/vnd.motorola.flexsuite.kmr": {
        source: "iana"
      },
      "application/vnd.motorola.flexsuite.ttc": {
        source: "iana"
      },
      "application/vnd.motorola.flexsuite.wem": {
        source: "iana"
      },
      "application/vnd.motorola.iprm": {
        source: "iana"
      },
      "application/vnd.mozilla.xul+xml": {
        source: "iana",
        compressible: true,
        extensions: ["xul"]
      },
      "application/vnd.ms-3mfdocument": {
        source: "iana"
      },
      "application/vnd.ms-artgalry": {
        source: "iana",
        extensions: ["cil"]
      },
      "application/vnd.ms-asf": {
        source: "iana"
      },
      "application/vnd.ms-cab-compressed": {
        source: "iana",
        extensions: ["cab"]
      },
      "application/vnd.ms-color.iccprofile": {
        source: "apache"
      },
      "application/vnd.ms-excel": {
        source: "iana",
        compressible: false,
        extensions: ["xls", "xlm", "xla", "xlc", "xlt", "xlw"]
      },
      "application/vnd.ms-excel.addin.macroenabled.12": {
        source: "iana",
        extensions: ["xlam"]
      },
      "application/vnd.ms-excel.sheet.binary.macroenabled.12": {
        source: "iana",
        extensions: ["xlsb"]
      },
      "application/vnd.ms-excel.sheet.macroenabled.12": {
        source: "iana",
        extensions: ["xlsm"]
      },
      "application/vnd.ms-excel.template.macroenabled.12": {
        source: "iana",
        extensions: ["xltm"]
      },
      "application/vnd.ms-fontobject": {
        source: "iana",
        compressible: true,
        extensions: ["eot"]
      },
      "application/vnd.ms-htmlhelp": {
        source: "iana",
        extensions: ["chm"]
      },
      "application/vnd.ms-ims": {
        source: "iana",
        extensions: ["ims"]
      },
      "application/vnd.ms-lrm": {
        source: "iana",
        extensions: ["lrm"]
      },
      "application/vnd.ms-office.activex+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.ms-officetheme": {
        source: "iana",
        extensions: ["thmx"]
      },
      "application/vnd.ms-opentype": {
        source: "apache",
        compressible: true
      },
      "application/vnd.ms-outlook": {
        compressible: false,
        extensions: ["msg"]
      },
      "application/vnd.ms-package.obfuscated-opentype": {
        source: "apache"
      },
      "application/vnd.ms-pki.seccat": {
        source: "apache",
        extensions: ["cat"]
      },
      "application/vnd.ms-pki.stl": {
        source: "apache",
        extensions: ["stl"]
      },
      "application/vnd.ms-playready.initiator+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.ms-powerpoint": {
        source: "iana",
        compressible: false,
        extensions: ["ppt", "pps", "pot"]
      },
      "application/vnd.ms-powerpoint.addin.macroenabled.12": {
        source: "iana",
        extensions: ["ppam"]
      },
      "application/vnd.ms-powerpoint.presentation.macroenabled.12": {
        source: "iana",
        extensions: ["pptm"]
      },
      "application/vnd.ms-powerpoint.slide.macroenabled.12": {
        source: "iana",
        extensions: ["sldm"]
      },
      "application/vnd.ms-powerpoint.slideshow.macroenabled.12": {
        source: "iana",
        extensions: ["ppsm"]
      },
      "application/vnd.ms-powerpoint.template.macroenabled.12": {
        source: "iana",
        extensions: ["potm"]
      },
      "application/vnd.ms-printdevicecapabilities+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.ms-printing.printticket+xml": {
        source: "apache",
        compressible: true
      },
      "application/vnd.ms-printschematicket+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.ms-project": {
        source: "iana",
        extensions: ["mpp", "mpt"]
      },
      "application/vnd.ms-tnef": {
        source: "iana"
      },
      "application/vnd.ms-windows.devicepairing": {
        source: "iana"
      },
      "application/vnd.ms-windows.nwprinting.oob": {
        source: "iana"
      },
      "application/vnd.ms-windows.printerpairing": {
        source: "iana"
      },
      "application/vnd.ms-windows.wsd.oob": {
        source: "iana"
      },
      "application/vnd.ms-wmdrm.lic-chlg-req": {
        source: "iana"
      },
      "application/vnd.ms-wmdrm.lic-resp": {
        source: "iana"
      },
      "application/vnd.ms-wmdrm.meter-chlg-req": {
        source: "iana"
      },
      "application/vnd.ms-wmdrm.meter-resp": {
        source: "iana"
      },
      "application/vnd.ms-word.document.macroenabled.12": {
        source: "iana",
        extensions: ["docm"]
      },
      "application/vnd.ms-word.template.macroenabled.12": {
        source: "iana",
        extensions: ["dotm"]
      },
      "application/vnd.ms-works": {
        source: "iana",
        extensions: ["wps", "wks", "wcm", "wdb"]
      },
      "application/vnd.ms-wpl": {
        source: "iana",
        extensions: ["wpl"]
      },
      "application/vnd.ms-xpsdocument": {
        source: "iana",
        compressible: false,
        extensions: ["xps"]
      },
      "application/vnd.msa-disk-image": {
        source: "iana"
      },
      "application/vnd.mseq": {
        source: "iana",
        extensions: ["mseq"]
      },
      "application/vnd.msign": {
        source: "iana"
      },
      "application/vnd.multiad.creator": {
        source: "iana"
      },
      "application/vnd.multiad.creator.cif": {
        source: "iana"
      },
      "application/vnd.music-niff": {
        source: "iana"
      },
      "application/vnd.musician": {
        source: "iana",
        extensions: ["mus"]
      },
      "application/vnd.muvee.style": {
        source: "iana",
        extensions: ["msty"]
      },
      "application/vnd.mynfc": {
        source: "iana",
        extensions: ["taglet"]
      },
      "application/vnd.nacamar.ybrid+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.ncd.control": {
        source: "iana"
      },
      "application/vnd.ncd.reference": {
        source: "iana"
      },
      "application/vnd.nearst.inv+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.nebumind.line": {
        source: "iana"
      },
      "application/vnd.nervana": {
        source: "iana"
      },
      "application/vnd.netfpx": {
        source: "iana"
      },
      "application/vnd.neurolanguage.nlu": {
        source: "iana",
        extensions: ["nlu"]
      },
      "application/vnd.nimn": {
        source: "iana"
      },
      "application/vnd.nintendo.nitro.rom": {
        source: "iana"
      },
      "application/vnd.nintendo.snes.rom": {
        source: "iana"
      },
      "application/vnd.nitf": {
        source: "iana",
        extensions: ["ntf", "nitf"]
      },
      "application/vnd.noblenet-directory": {
        source: "iana",
        extensions: ["nnd"]
      },
      "application/vnd.noblenet-sealer": {
        source: "iana",
        extensions: ["nns"]
      },
      "application/vnd.noblenet-web": {
        source: "iana",
        extensions: ["nnw"]
      },
      "application/vnd.nokia.catalogs": {
        source: "iana"
      },
      "application/vnd.nokia.conml+wbxml": {
        source: "iana"
      },
      "application/vnd.nokia.conml+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.nokia.iptv.config+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.nokia.isds-radio-presets": {
        source: "iana"
      },
      "application/vnd.nokia.landmark+wbxml": {
        source: "iana"
      },
      "application/vnd.nokia.landmark+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.nokia.landmarkcollection+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.nokia.n-gage.ac+xml": {
        source: "iana",
        compressible: true,
        extensions: ["ac"]
      },
      "application/vnd.nokia.n-gage.data": {
        source: "iana",
        extensions: ["ngdat"]
      },
      "application/vnd.nokia.n-gage.symbian.install": {
        source: "iana",
        extensions: ["n-gage"]
      },
      "application/vnd.nokia.ncd": {
        source: "iana"
      },
      "application/vnd.nokia.pcd+wbxml": {
        source: "iana"
      },
      "application/vnd.nokia.pcd+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.nokia.radio-preset": {
        source: "iana",
        extensions: ["rpst"]
      },
      "application/vnd.nokia.radio-presets": {
        source: "iana",
        extensions: ["rpss"]
      },
      "application/vnd.novadigm.edm": {
        source: "iana",
        extensions: ["edm"]
      },
      "application/vnd.novadigm.edx": {
        source: "iana",
        extensions: ["edx"]
      },
      "application/vnd.novadigm.ext": {
        source: "iana",
        extensions: ["ext"]
      },
      "application/vnd.ntt-local.content-share": {
        source: "iana"
      },
      "application/vnd.ntt-local.file-transfer": {
        source: "iana"
      },
      "application/vnd.ntt-local.ogw_remote-access": {
        source: "iana"
      },
      "application/vnd.ntt-local.sip-ta_remote": {
        source: "iana"
      },
      "application/vnd.ntt-local.sip-ta_tcp_stream": {
        source: "iana"
      },
      "application/vnd.oasis.opendocument.chart": {
        source: "iana",
        extensions: ["odc"]
      },
      "application/vnd.oasis.opendocument.chart-template": {
        source: "iana",
        extensions: ["otc"]
      },
      "application/vnd.oasis.opendocument.database": {
        source: "iana",
        extensions: ["odb"]
      },
      "application/vnd.oasis.opendocument.formula": {
        source: "iana",
        extensions: ["odf"]
      },
      "application/vnd.oasis.opendocument.formula-template": {
        source: "iana",
        extensions: ["odft"]
      },
      "application/vnd.oasis.opendocument.graphics": {
        source: "iana",
        compressible: false,
        extensions: ["odg"]
      },
      "application/vnd.oasis.opendocument.graphics-template": {
        source: "iana",
        extensions: ["otg"]
      },
      "application/vnd.oasis.opendocument.image": {
        source: "iana",
        extensions: ["odi"]
      },
      "application/vnd.oasis.opendocument.image-template": {
        source: "iana",
        extensions: ["oti"]
      },
      "application/vnd.oasis.opendocument.presentation": {
        source: "iana",
        compressible: false,
        extensions: ["odp"]
      },
      "application/vnd.oasis.opendocument.presentation-template": {
        source: "iana",
        extensions: ["otp"]
      },
      "application/vnd.oasis.opendocument.spreadsheet": {
        source: "iana",
        compressible: false,
        extensions: ["ods"]
      },
      "application/vnd.oasis.opendocument.spreadsheet-template": {
        source: "iana",
        extensions: ["ots"]
      },
      "application/vnd.oasis.opendocument.text": {
        source: "iana",
        compressible: false,
        extensions: ["odt"]
      },
      "application/vnd.oasis.opendocument.text-master": {
        source: "iana",
        extensions: ["odm"]
      },
      "application/vnd.oasis.opendocument.text-template": {
        source: "iana",
        extensions: ["ott"]
      },
      "application/vnd.oasis.opendocument.text-web": {
        source: "iana",
        extensions: ["oth"]
      },
      "application/vnd.obn": {
        source: "iana"
      },
      "application/vnd.ocf+cbor": {
        source: "iana"
      },
      "application/vnd.oci.image.manifest.v1+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oftn.l10n+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oipf.contentaccessdownload+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oipf.contentaccessstreaming+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oipf.cspg-hexbinary": {
        source: "iana"
      },
      "application/vnd.oipf.dae.svg+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oipf.dae.xhtml+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oipf.mippvcontrolmessage+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oipf.pae.gem": {
        source: "iana"
      },
      "application/vnd.oipf.spdiscovery+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oipf.spdlist+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oipf.ueprofile+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oipf.userprofile+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.olpc-sugar": {
        source: "iana",
        extensions: ["xo"]
      },
      "application/vnd.oma-scws-config": {
        source: "iana"
      },
      "application/vnd.oma-scws-http-request": {
        source: "iana"
      },
      "application/vnd.oma-scws-http-response": {
        source: "iana"
      },
      "application/vnd.oma.bcast.associated-procedure-parameter+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.bcast.drm-trigger+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.bcast.imd+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.bcast.ltkm": {
        source: "iana"
      },
      "application/vnd.oma.bcast.notification+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.bcast.provisioningtrigger": {
        source: "iana"
      },
      "application/vnd.oma.bcast.sgboot": {
        source: "iana"
      },
      "application/vnd.oma.bcast.sgdd+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.bcast.sgdu": {
        source: "iana"
      },
      "application/vnd.oma.bcast.simple-symbol-container": {
        source: "iana"
      },
      "application/vnd.oma.bcast.smartcard-trigger+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.bcast.sprov+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.bcast.stkm": {
        source: "iana"
      },
      "application/vnd.oma.cab-address-book+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.cab-feature-handler+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.cab-pcc+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.cab-subs-invite+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.cab-user-prefs+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.dcd": {
        source: "iana"
      },
      "application/vnd.oma.dcdc": {
        source: "iana"
      },
      "application/vnd.oma.dd2+xml": {
        source: "iana",
        compressible: true,
        extensions: ["dd2"]
      },
      "application/vnd.oma.drm.risd+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.group-usage-list+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.lwm2m+cbor": {
        source: "iana"
      },
      "application/vnd.oma.lwm2m+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.lwm2m+tlv": {
        source: "iana"
      },
      "application/vnd.oma.pal+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.poc.detailed-progress-report+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.poc.final-report+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.poc.groups+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.poc.invocation-descriptor+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.poc.optimized-progress-report+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.push": {
        source: "iana"
      },
      "application/vnd.oma.scidm.messages+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oma.xcap-directory+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.omads-email+xml": {
        source: "iana",
        charset: "UTF-8",
        compressible: true
      },
      "application/vnd.omads-file+xml": {
        source: "iana",
        charset: "UTF-8",
        compressible: true
      },
      "application/vnd.omads-folder+xml": {
        source: "iana",
        charset: "UTF-8",
        compressible: true
      },
      "application/vnd.omaloc-supl-init": {
        source: "iana"
      },
      "application/vnd.onepager": {
        source: "iana"
      },
      "application/vnd.onepagertamp": {
        source: "iana"
      },
      "application/vnd.onepagertamx": {
        source: "iana"
      },
      "application/vnd.onepagertat": {
        source: "iana"
      },
      "application/vnd.onepagertatp": {
        source: "iana"
      },
      "application/vnd.onepagertatx": {
        source: "iana"
      },
      "application/vnd.openblox.game+xml": {
        source: "iana",
        compressible: true,
        extensions: ["obgx"]
      },
      "application/vnd.openblox.game-binary": {
        source: "iana"
      },
      "application/vnd.openeye.oeb": {
        source: "iana"
      },
      "application/vnd.openofficeorg.extension": {
        source: "apache",
        extensions: ["oxt"]
      },
      "application/vnd.openstreetmap.data+xml": {
        source: "iana",
        compressible: true,
        extensions: ["osm"]
      },
      "application/vnd.opentimestamps.ots": {
        source: "iana"
      },
      "application/vnd.openxmlformats-officedocument.custom-properties+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.customxmlproperties+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.drawing+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.drawingml.chart+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.drawingml.chartshapes+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.drawingml.diagramcolors+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.drawingml.diagramdata+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.drawingml.diagramlayout+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.drawingml.diagramstyle+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.extended-properties+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.presentationml.commentauthors+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.presentationml.comments+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.presentationml.handoutmaster+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.presentationml.notesmaster+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.presentationml.notesslide+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.presentationml.presentation": {
        source: "iana",
        compressible: false,
        extensions: ["pptx"]
      },
      "application/vnd.openxmlformats-officedocument.presentationml.presentation.main+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.presentationml.presprops+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.presentationml.slide": {
        source: "iana",
        extensions: ["sldx"]
      },
      "application/vnd.openxmlformats-officedocument.presentationml.slide+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.presentationml.slidelayout+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.presentationml.slidemaster+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.presentationml.slideshow": {
        source: "iana",
        extensions: ["ppsx"]
      },
      "application/vnd.openxmlformats-officedocument.presentationml.slideshow.main+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.presentationml.slideupdateinfo+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.presentationml.tablestyles+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.presentationml.tags+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.presentationml.template": {
        source: "iana",
        extensions: ["potx"]
      },
      "application/vnd.openxmlformats-officedocument.presentationml.template.main+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.presentationml.viewprops+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.calcchain+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.chartsheet+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.comments+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.connections+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.dialogsheet+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.externallink+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.pivotcachedefinition+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.pivotcacherecords+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.pivottable+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.querytable+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.revisionheaders+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.revisionlog+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.sharedstrings+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet": {
        source: "iana",
        compressible: false,
        extensions: ["xlsx"]
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet.main+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.sheetmetadata+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.styles+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.table+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.tablesinglecells+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.template": {
        source: "iana",
        extensions: ["xltx"]
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.template.main+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.usernames+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.volatiledependencies+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.spreadsheetml.worksheet+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.theme+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.themeoverride+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.vmldrawing": {
        source: "iana"
      },
      "application/vnd.openxmlformats-officedocument.wordprocessingml.comments+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.wordprocessingml.document": {
        source: "iana",
        compressible: false,
        extensions: ["docx"]
      },
      "application/vnd.openxmlformats-officedocument.wordprocessingml.document.glossary+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.wordprocessingml.document.main+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.wordprocessingml.endnotes+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.wordprocessingml.fonttable+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.wordprocessingml.footer+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.wordprocessingml.footnotes+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.wordprocessingml.numbering+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.wordprocessingml.settings+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.wordprocessingml.styles+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.wordprocessingml.template": {
        source: "iana",
        extensions: ["dotx"]
      },
      "application/vnd.openxmlformats-officedocument.wordprocessingml.template.main+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-officedocument.wordprocessingml.websettings+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-package.core-properties+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-package.digital-signature-xmlsignature+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.openxmlformats-package.relationships+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oracle.resource+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.orange.indata": {
        source: "iana"
      },
      "application/vnd.osa.netdeploy": {
        source: "iana"
      },
      "application/vnd.osgeo.mapguide.package": {
        source: "iana",
        extensions: ["mgp"]
      },
      "application/vnd.osgi.bundle": {
        source: "iana"
      },
      "application/vnd.osgi.dp": {
        source: "iana",
        extensions: ["dp"]
      },
      "application/vnd.osgi.subsystem": {
        source: "iana",
        extensions: ["esa"]
      },
      "application/vnd.otps.ct-kip+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.oxli.countgraph": {
        source: "iana"
      },
      "application/vnd.pagerduty+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.palm": {
        source: "iana",
        extensions: ["pdb", "pqa", "oprc"]
      },
      "application/vnd.panoply": {
        source: "iana"
      },
      "application/vnd.paos.xml": {
        source: "iana"
      },
      "application/vnd.patentdive": {
        source: "iana"
      },
      "application/vnd.patientecommsdoc": {
        source: "iana"
      },
      "application/vnd.pawaafile": {
        source: "iana",
        extensions: ["paw"]
      },
      "application/vnd.pcos": {
        source: "iana"
      },
      "application/vnd.pg.format": {
        source: "iana",
        extensions: ["str"]
      },
      "application/vnd.pg.osasli": {
        source: "iana",
        extensions: ["ei6"]
      },
      "application/vnd.piaccess.application-licence": {
        source: "iana"
      },
      "application/vnd.picsel": {
        source: "iana",
        extensions: ["efif"]
      },
      "application/vnd.pmi.widget": {
        source: "iana",
        extensions: ["wg"]
      },
      "application/vnd.poc.group-advertisement+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.pocketlearn": {
        source: "iana",
        extensions: ["plf"]
      },
      "application/vnd.powerbuilder6": {
        source: "iana",
        extensions: ["pbd"]
      },
      "application/vnd.powerbuilder6-s": {
        source: "iana"
      },
      "application/vnd.powerbuilder7": {
        source: "iana"
      },
      "application/vnd.powerbuilder7-s": {
        source: "iana"
      },
      "application/vnd.powerbuilder75": {
        source: "iana"
      },
      "application/vnd.powerbuilder75-s": {
        source: "iana"
      },
      "application/vnd.preminet": {
        source: "iana"
      },
      "application/vnd.previewsystems.box": {
        source: "iana",
        extensions: ["box"]
      },
      "application/vnd.proteus.magazine": {
        source: "iana",
        extensions: ["mgz"]
      },
      "application/vnd.psfs": {
        source: "iana"
      },
      "application/vnd.publishare-delta-tree": {
        source: "iana",
        extensions: ["qps"]
      },
      "application/vnd.pvi.ptid1": {
        source: "iana",
        extensions: ["ptid"]
      },
      "application/vnd.pwg-multiplexed": {
        source: "iana"
      },
      "application/vnd.pwg-xhtml-print+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.qualcomm.brew-app-res": {
        source: "iana"
      },
      "application/vnd.quarantainenet": {
        source: "iana"
      },
      "application/vnd.quark.quarkxpress": {
        source: "iana",
        extensions: ["qxd", "qxt", "qwd", "qwt", "qxl", "qxb"]
      },
      "application/vnd.quobject-quoxdocument": {
        source: "iana"
      },
      "application/vnd.radisys.moml+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.radisys.msml+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.radisys.msml-audit+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.radisys.msml-audit-conf+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.radisys.msml-audit-conn+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.radisys.msml-audit-dialog+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.radisys.msml-audit-stream+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.radisys.msml-conf+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.radisys.msml-dialog+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.radisys.msml-dialog-base+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.radisys.msml-dialog-fax-detect+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.radisys.msml-dialog-fax-sendrecv+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.radisys.msml-dialog-group+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.radisys.msml-dialog-speech+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.radisys.msml-dialog-transform+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.rainstor.data": {
        source: "iana"
      },
      "application/vnd.rapid": {
        source: "iana"
      },
      "application/vnd.rar": {
        source: "iana",
        extensions: ["rar"]
      },
      "application/vnd.realvnc.bed": {
        source: "iana",
        extensions: ["bed"]
      },
      "application/vnd.recordare.musicxml": {
        source: "iana",
        extensions: ["mxl"]
      },
      "application/vnd.recordare.musicxml+xml": {
        source: "iana",
        compressible: true,
        extensions: ["musicxml"]
      },
      "application/vnd.renlearn.rlprint": {
        source: "iana"
      },
      "application/vnd.resilient.logic": {
        source: "iana"
      },
      "application/vnd.restful+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.rig.cryptonote": {
        source: "iana",
        extensions: ["cryptonote"]
      },
      "application/vnd.rim.cod": {
        source: "apache",
        extensions: ["cod"]
      },
      "application/vnd.rn-realmedia": {
        source: "apache",
        extensions: ["rm"]
      },
      "application/vnd.rn-realmedia-vbr": {
        source: "apache",
        extensions: ["rmvb"]
      },
      "application/vnd.route66.link66+xml": {
        source: "iana",
        compressible: true,
        extensions: ["link66"]
      },
      "application/vnd.rs-274x": {
        source: "iana"
      },
      "application/vnd.ruckus.download": {
        source: "iana"
      },
      "application/vnd.s3sms": {
        source: "iana"
      },
      "application/vnd.sailingtracker.track": {
        source: "iana",
        extensions: ["st"]
      },
      "application/vnd.sar": {
        source: "iana"
      },
      "application/vnd.sbm.cid": {
        source: "iana"
      },
      "application/vnd.sbm.mid2": {
        source: "iana"
      },
      "application/vnd.scribus": {
        source: "iana"
      },
      "application/vnd.sealed.3df": {
        source: "iana"
      },
      "application/vnd.sealed.csf": {
        source: "iana"
      },
      "application/vnd.sealed.doc": {
        source: "iana"
      },
      "application/vnd.sealed.eml": {
        source: "iana"
      },
      "application/vnd.sealed.mht": {
        source: "iana"
      },
      "application/vnd.sealed.net": {
        source: "iana"
      },
      "application/vnd.sealed.ppt": {
        source: "iana"
      },
      "application/vnd.sealed.tiff": {
        source: "iana"
      },
      "application/vnd.sealed.xls": {
        source: "iana"
      },
      "application/vnd.sealedmedia.softseal.html": {
        source: "iana"
      },
      "application/vnd.sealedmedia.softseal.pdf": {
        source: "iana"
      },
      "application/vnd.seemail": {
        source: "iana",
        extensions: ["see"]
      },
      "application/vnd.seis+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.sema": {
        source: "iana",
        extensions: ["sema"]
      },
      "application/vnd.semd": {
        source: "iana",
        extensions: ["semd"]
      },
      "application/vnd.semf": {
        source: "iana",
        extensions: ["semf"]
      },
      "application/vnd.shade-save-file": {
        source: "iana"
      },
      "application/vnd.shana.informed.formdata": {
        source: "iana",
        extensions: ["ifm"]
      },
      "application/vnd.shana.informed.formtemplate": {
        source: "iana",
        extensions: ["itp"]
      },
      "application/vnd.shana.informed.interchange": {
        source: "iana",
        extensions: ["iif"]
      },
      "application/vnd.shana.informed.package": {
        source: "iana",
        extensions: ["ipk"]
      },
      "application/vnd.shootproof+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.shopkick+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.shp": {
        source: "iana"
      },
      "application/vnd.shx": {
        source: "iana"
      },
      "application/vnd.sigrok.session": {
        source: "iana"
      },
      "application/vnd.simtech-mindmapper": {
        source: "iana",
        extensions: ["twd", "twds"]
      },
      "application/vnd.siren+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.smaf": {
        source: "iana",
        extensions: ["mmf"]
      },
      "application/vnd.smart.notebook": {
        source: "iana"
      },
      "application/vnd.smart.teacher": {
        source: "iana",
        extensions: ["teacher"]
      },
      "application/vnd.snesdev-page-table": {
        source: "iana"
      },
      "application/vnd.software602.filler.form+xml": {
        source: "iana",
        compressible: true,
        extensions: ["fo"]
      },
      "application/vnd.software602.filler.form-xml-zip": {
        source: "iana"
      },
      "application/vnd.solent.sdkm+xml": {
        source: "iana",
        compressible: true,
        extensions: ["sdkm", "sdkd"]
      },
      "application/vnd.spotfire.dxp": {
        source: "iana",
        extensions: ["dxp"]
      },
      "application/vnd.spotfire.sfs": {
        source: "iana",
        extensions: ["sfs"]
      },
      "application/vnd.sqlite3": {
        source: "iana"
      },
      "application/vnd.sss-cod": {
        source: "iana"
      },
      "application/vnd.sss-dtf": {
        source: "iana"
      },
      "application/vnd.sss-ntf": {
        source: "iana"
      },
      "application/vnd.stardivision.calc": {
        source: "apache",
        extensions: ["sdc"]
      },
      "application/vnd.stardivision.draw": {
        source: "apache",
        extensions: ["sda"]
      },
      "application/vnd.stardivision.impress": {
        source: "apache",
        extensions: ["sdd"]
      },
      "application/vnd.stardivision.math": {
        source: "apache",
        extensions: ["smf"]
      },
      "application/vnd.stardivision.writer": {
        source: "apache",
        extensions: ["sdw", "vor"]
      },
      "application/vnd.stardivision.writer-global": {
        source: "apache",
        extensions: ["sgl"]
      },
      "application/vnd.stepmania.package": {
        source: "iana",
        extensions: ["smzip"]
      },
      "application/vnd.stepmania.stepchart": {
        source: "iana",
        extensions: ["sm"]
      },
      "application/vnd.street-stream": {
        source: "iana"
      },
      "application/vnd.sun.wadl+xml": {
        source: "iana",
        compressible: true,
        extensions: ["wadl"]
      },
      "application/vnd.sun.xml.calc": {
        source: "apache",
        extensions: ["sxc"]
      },
      "application/vnd.sun.xml.calc.template": {
        source: "apache",
        extensions: ["stc"]
      },
      "application/vnd.sun.xml.draw": {
        source: "apache",
        extensions: ["sxd"]
      },
      "application/vnd.sun.xml.draw.template": {
        source: "apache",
        extensions: ["std"]
      },
      "application/vnd.sun.xml.impress": {
        source: "apache",
        extensions: ["sxi"]
      },
      "application/vnd.sun.xml.impress.template": {
        source: "apache",
        extensions: ["sti"]
      },
      "application/vnd.sun.xml.math": {
        source: "apache",
        extensions: ["sxm"]
      },
      "application/vnd.sun.xml.writer": {
        source: "apache",
        extensions: ["sxw"]
      },
      "application/vnd.sun.xml.writer.global": {
        source: "apache",
        extensions: ["sxg"]
      },
      "application/vnd.sun.xml.writer.template": {
        source: "apache",
        extensions: ["stw"]
      },
      "application/vnd.sus-calendar": {
        source: "iana",
        extensions: ["sus", "susp"]
      },
      "application/vnd.svd": {
        source: "iana",
        extensions: ["svd"]
      },
      "application/vnd.swiftview-ics": {
        source: "iana"
      },
      "application/vnd.sycle+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.syft+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.symbian.install": {
        source: "apache",
        extensions: ["sis", "sisx"]
      },
      "application/vnd.syncml+xml": {
        source: "iana",
        charset: "UTF-8",
        compressible: true,
        extensions: ["xsm"]
      },
      "application/vnd.syncml.dm+wbxml": {
        source: "iana",
        charset: "UTF-8",
        extensions: ["bdm"]
      },
      "application/vnd.syncml.dm+xml": {
        source: "iana",
        charset: "UTF-8",
        compressible: true,
        extensions: ["xdm"]
      },
      "application/vnd.syncml.dm.notification": {
        source: "iana"
      },
      "application/vnd.syncml.dmddf+wbxml": {
        source: "iana"
      },
      "application/vnd.syncml.dmddf+xml": {
        source: "iana",
        charset: "UTF-8",
        compressible: true,
        extensions: ["ddf"]
      },
      "application/vnd.syncml.dmtnds+wbxml": {
        source: "iana"
      },
      "application/vnd.syncml.dmtnds+xml": {
        source: "iana",
        charset: "UTF-8",
        compressible: true
      },
      "application/vnd.syncml.ds.notification": {
        source: "iana"
      },
      "application/vnd.tableschema+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.tao.intent-module-archive": {
        source: "iana",
        extensions: ["tao"]
      },
      "application/vnd.tcpdump.pcap": {
        source: "iana",
        extensions: ["pcap", "cap", "dmp"]
      },
      "application/vnd.think-cell.ppttc+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.tmd.mediaflex.api+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.tml": {
        source: "iana"
      },
      "application/vnd.tmobile-livetv": {
        source: "iana",
        extensions: ["tmo"]
      },
      "application/vnd.tri.onesource": {
        source: "iana"
      },
      "application/vnd.trid.tpt": {
        source: "iana",
        extensions: ["tpt"]
      },
      "application/vnd.triscape.mxs": {
        source: "iana",
        extensions: ["mxs"]
      },
      "application/vnd.trueapp": {
        source: "iana",
        extensions: ["tra"]
      },
      "application/vnd.truedoc": {
        source: "iana"
      },
      "application/vnd.ubisoft.webplayer": {
        source: "iana"
      },
      "application/vnd.ufdl": {
        source: "iana",
        extensions: ["ufd", "ufdl"]
      },
      "application/vnd.uiq.theme": {
        source: "iana",
        extensions: ["utz"]
      },
      "application/vnd.umajin": {
        source: "iana",
        extensions: ["umj"]
      },
      "application/vnd.unity": {
        source: "iana",
        extensions: ["unityweb"]
      },
      "application/vnd.uoml+xml": {
        source: "iana",
        compressible: true,
        extensions: ["uoml"]
      },
      "application/vnd.uplanet.alert": {
        source: "iana"
      },
      "application/vnd.uplanet.alert-wbxml": {
        source: "iana"
      },
      "application/vnd.uplanet.bearer-choice": {
        source: "iana"
      },
      "application/vnd.uplanet.bearer-choice-wbxml": {
        source: "iana"
      },
      "application/vnd.uplanet.cacheop": {
        source: "iana"
      },
      "application/vnd.uplanet.cacheop-wbxml": {
        source: "iana"
      },
      "application/vnd.uplanet.channel": {
        source: "iana"
      },
      "application/vnd.uplanet.channel-wbxml": {
        source: "iana"
      },
      "application/vnd.uplanet.list": {
        source: "iana"
      },
      "application/vnd.uplanet.list-wbxml": {
        source: "iana"
      },
      "application/vnd.uplanet.listcmd": {
        source: "iana"
      },
      "application/vnd.uplanet.listcmd-wbxml": {
        source: "iana"
      },
      "application/vnd.uplanet.signal": {
        source: "iana"
      },
      "application/vnd.uri-map": {
        source: "iana"
      },
      "application/vnd.valve.source.material": {
        source: "iana"
      },
      "application/vnd.vcx": {
        source: "iana",
        extensions: ["vcx"]
      },
      "application/vnd.vd-study": {
        source: "iana"
      },
      "application/vnd.vectorworks": {
        source: "iana"
      },
      "application/vnd.vel+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.verimatrix.vcas": {
        source: "iana"
      },
      "application/vnd.veritone.aion+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.veryant.thin": {
        source: "iana"
      },
      "application/vnd.ves.encrypted": {
        source: "iana"
      },
      "application/vnd.vidsoft.vidconference": {
        source: "iana"
      },
      "application/vnd.visio": {
        source: "iana",
        extensions: ["vsd", "vst", "vss", "vsw"]
      },
      "application/vnd.visionary": {
        source: "iana",
        extensions: ["vis"]
      },
      "application/vnd.vividence.scriptfile": {
        source: "iana"
      },
      "application/vnd.vsf": {
        source: "iana",
        extensions: ["vsf"]
      },
      "application/vnd.wap.sic": {
        source: "iana"
      },
      "application/vnd.wap.slc": {
        source: "iana"
      },
      "application/vnd.wap.wbxml": {
        source: "iana",
        charset: "UTF-8",
        extensions: ["wbxml"]
      },
      "application/vnd.wap.wmlc": {
        source: "iana",
        extensions: ["wmlc"]
      },
      "application/vnd.wap.wmlscriptc": {
        source: "iana",
        extensions: ["wmlsc"]
      },
      "application/vnd.webturbo": {
        source: "iana",
        extensions: ["wtb"]
      },
      "application/vnd.wfa.dpp": {
        source: "iana"
      },
      "application/vnd.wfa.p2p": {
        source: "iana"
      },
      "application/vnd.wfa.wsc": {
        source: "iana"
      },
      "application/vnd.windows.devicepairing": {
        source: "iana"
      },
      "application/vnd.wmc": {
        source: "iana"
      },
      "application/vnd.wmf.bootstrap": {
        source: "iana"
      },
      "application/vnd.wolfram.mathematica": {
        source: "iana"
      },
      "application/vnd.wolfram.mathematica.package": {
        source: "iana"
      },
      "application/vnd.wolfram.player": {
        source: "iana",
        extensions: ["nbp"]
      },
      "application/vnd.wordperfect": {
        source: "iana",
        extensions: ["wpd"]
      },
      "application/vnd.wqd": {
        source: "iana",
        extensions: ["wqd"]
      },
      "application/vnd.wrq-hp3000-labelled": {
        source: "iana"
      },
      "application/vnd.wt.stf": {
        source: "iana",
        extensions: ["stf"]
      },
      "application/vnd.wv.csp+wbxml": {
        source: "iana"
      },
      "application/vnd.wv.csp+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.wv.ssp+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.xacml+json": {
        source: "iana",
        compressible: true
      },
      "application/vnd.xara": {
        source: "iana",
        extensions: ["xar"]
      },
      "application/vnd.xfdl": {
        source: "iana",
        extensions: ["xfdl"]
      },
      "application/vnd.xfdl.webform": {
        source: "iana"
      },
      "application/vnd.xmi+xml": {
        source: "iana",
        compressible: true
      },
      "application/vnd.xmpie.cpkg": {
        source: "iana"
      },
      "application/vnd.xmpie.dpkg": {
        source: "iana"
      },
      "application/vnd.xmpie.plan": {
        source: "iana"
      },
      "application/vnd.xmpie.ppkg": {
        source: "iana"
      },
      "application/vnd.xmpie.xlim": {
        source: "iana"
      },
      "application/vnd.yamaha.hv-dic": {
        source: "iana",
        extensions: ["hvd"]
      },
      "application/vnd.yamaha.hv-script": {
        source: "iana",
        extensions: ["hvs"]
      },
      "application/vnd.yamaha.hv-voice": {
        source: "iana",
        extensions: ["hvp"]
      },
      "application/vnd.yamaha.openscoreformat": {
        source: "iana",
        extensions: ["osf"]
      },
      "application/vnd.yamaha.openscoreformat.osfpvg+xml": {
        source: "iana",
        compressible: true,
        extensions: ["osfpvg"]
      },
      "application/vnd.yamaha.remote-setup": {
        source: "iana"
      },
      "application/vnd.yamaha.smaf-audio": {
        source: "iana",
        extensions: ["saf"]
      },
      "application/vnd.yamaha.smaf-phrase": {
        source: "iana",
        extensions: ["spf"]
      },
      "application/vnd.yamaha.through-ngn": {
        source: "iana"
      },
      "application/vnd.yamaha.tunnel-udpencap": {
        source: "iana"
      },
      "application/vnd.yaoweme": {
        source: "iana"
      },
      "application/vnd.yellowriver-custom-menu": {
        source: "iana",
        extensions: ["cmp"]
      },
      "application/vnd.youtube.yt": {
        source: "iana"
      },
      "application/vnd.zul": {
        source: "iana",
        extensions: ["zir", "zirz"]
      },
      "application/vnd.zzazz.deck+xml": {
        source: "iana",
        compressible: true,
        extensions: ["zaz"]
      },
      "application/voicexml+xml": {
        source: "iana",
        compressible: true,
        extensions: ["vxml"]
      },
      "application/voucher-cms+json": {
        source: "iana",
        compressible: true
      },
      "application/vq-rtcpxr": {
        source: "iana"
      },
      "application/wasm": {
        source: "iana",
        compressible: true,
        extensions: ["wasm"]
      },
      "application/watcherinfo+xml": {
        source: "iana",
        compressible: true,
        extensions: ["wif"]
      },
      "application/webpush-options+json": {
        source: "iana",
        compressible: true
      },
      "application/whoispp-query": {
        source: "iana"
      },
      "application/whoispp-response": {
        source: "iana"
      },
      "application/widget": {
        source: "iana",
        extensions: ["wgt"]
      },
      "application/winhlp": {
        source: "apache",
        extensions: ["hlp"]
      },
      "application/wita": {
        source: "iana"
      },
      "application/wordperfect5.1": {
        source: "iana"
      },
      "application/wsdl+xml": {
        source: "iana",
        compressible: true,
        extensions: ["wsdl"]
      },
      "application/wspolicy+xml": {
        source: "iana",
        compressible: true,
        extensions: ["wspolicy"]
      },
      "application/x-7z-compressed": {
        source: "apache",
        compressible: false,
        extensions: ["7z"]
      },
      "application/x-abiword": {
        source: "apache",
        extensions: ["abw"]
      },
      "application/x-ace-compressed": {
        source: "apache",
        extensions: ["ace"]
      },
      "application/x-amf": {
        source: "apache"
      },
      "application/x-apple-diskimage": {
        source: "apache",
        extensions: ["dmg"]
      },
      "application/x-arj": {
        compressible: false,
        extensions: ["arj"]
      },
      "application/x-authorware-bin": {
        source: "apache",
        extensions: ["aab", "x32", "u32", "vox"]
      },
      "application/x-authorware-map": {
        source: "apache",
        extensions: ["aam"]
      },
      "application/x-authorware-seg": {
        source: "apache",
        extensions: ["aas"]
      },
      "application/x-bcpio": {
        source: "apache",
        extensions: ["bcpio"]
      },
      "application/x-bdoc": {
        compressible: false,
        extensions: ["bdoc"]
      },
      "application/x-bittorrent": {
        source: "apache",
        extensions: ["torrent"]
      },
      "application/x-blorb": {
        source: "apache",
        extensions: ["blb", "blorb"]
      },
      "application/x-bzip": {
        source: "apache",
        compressible: false,
        extensions: ["bz"]
      },
      "application/x-bzip2": {
        source: "apache",
        compressible: false,
        extensions: ["bz2", "boz"]
      },
      "application/x-cbr": {
        source: "apache",
        extensions: ["cbr", "cba", "cbt", "cbz", "cb7"]
      },
      "application/x-cdlink": {
        source: "apache",
        extensions: ["vcd"]
      },
      "application/x-cfs-compressed": {
        source: "apache",
        extensions: ["cfs"]
      },
      "application/x-chat": {
        source: "apache",
        extensions: ["chat"]
      },
      "application/x-chess-pgn": {
        source: "apache",
        extensions: ["pgn"]
      },
      "application/x-chrome-extension": {
        extensions: ["crx"]
      },
      "application/x-cocoa": {
        source: "nginx",
        extensions: ["cco"]
      },
      "application/x-compress": {
        source: "apache"
      },
      "application/x-conference": {
        source: "apache",
        extensions: ["nsc"]
      },
      "application/x-cpio": {
        source: "apache",
        extensions: ["cpio"]
      },
      "application/x-csh": {
        source: "apache",
        extensions: ["csh"]
      },
      "application/x-deb": {
        compressible: false
      },
      "application/x-debian-package": {
        source: "apache",
        extensions: ["deb", "udeb"]
      },
      "application/x-dgc-compressed": {
        source: "apache",
        extensions: ["dgc"]
      },
      "application/x-director": {
        source: "apache",
        extensions: ["dir", "dcr", "dxr", "cst", "cct", "cxt", "w3d", "fgd", "swa"]
      },
      "application/x-doom": {
        source: "apache",
        extensions: ["wad"]
      },
      "application/x-dtbncx+xml": {
        source: "apache",
        compressible: true,
        extensions: ["ncx"]
      },
      "application/x-dtbook+xml": {
        source: "apache",
        compressible: true,
        extensions: ["dtb"]
      },
      "application/x-dtbresource+xml": {
        source: "apache",
        compressible: true,
        extensions: ["res"]
      },
      "application/x-dvi": {
        source: "apache",
        compressible: false,
        extensions: ["dvi"]
      },
      "application/x-envoy": {
        source: "apache",
        extensions: ["evy"]
      },
      "application/x-eva": {
        source: "apache",
        extensions: ["eva"]
      },
      "application/x-font-bdf": {
        source: "apache",
        extensions: ["bdf"]
      },
      "application/x-font-dos": {
        source: "apache"
      },
      "application/x-font-framemaker": {
        source: "apache"
      },
      "application/x-font-ghostscript": {
        source: "apache",
        extensions: ["gsf"]
      },
      "application/x-font-libgrx": {
        source: "apache"
      },
      "application/x-font-linux-psf": {
        source: "apache",
        extensions: ["psf"]
      },
      "application/x-font-pcf": {
        source: "apache",
        extensions: ["pcf"]
      },
      "application/x-font-snf": {
        source: "apache",
        extensions: ["snf"]
      },
      "application/x-font-speedo": {
        source: "apache"
      },
      "application/x-font-sunos-news": {
        source: "apache"
      },
      "application/x-font-type1": {
        source: "apache",
        extensions: ["pfa", "pfb", "pfm", "afm"]
      },
      "application/x-font-vfont": {
        source: "apache"
      },
      "application/x-freearc": {
        source: "apache",
        extensions: ["arc"]
      },
      "application/x-futuresplash": {
        source: "apache",
        extensions: ["spl"]
      },
      "application/x-gca-compressed": {
        source: "apache",
        extensions: ["gca"]
      },
      "application/x-glulx": {
        source: "apache",
        extensions: ["ulx"]
      },
      "application/x-gnumeric": {
        source: "apache",
        extensions: ["gnumeric"]
      },
      "application/x-gramps-xml": {
        source: "apache",
        extensions: ["gramps"]
      },
      "application/x-gtar": {
        source: "apache",
        extensions: ["gtar"]
      },
      "application/x-gzip": {
        source: "apache"
      },
      "application/x-hdf": {
        source: "apache",
        extensions: ["hdf"]
      },
      "application/x-httpd-php": {
        compressible: true,
        extensions: ["php"]
      },
      "application/x-install-instructions": {
        source: "apache",
        extensions: ["install"]
      },
      "application/x-iso9660-image": {
        source: "apache",
        extensions: ["iso"]
      },
      "application/x-iwork-keynote-sffkey": {
        extensions: ["key"]
      },
      "application/x-iwork-numbers-sffnumbers": {
        extensions: ["numbers"]
      },
      "application/x-iwork-pages-sffpages": {
        extensions: ["pages"]
      },
      "application/x-java-archive-diff": {
        source: "nginx",
        extensions: ["jardiff"]
      },
      "application/x-java-jnlp-file": {
        source: "apache",
        compressible: false,
        extensions: ["jnlp"]
      },
      "application/x-javascript": {
        compressible: true
      },
      "application/x-keepass2": {
        extensions: ["kdbx"]
      },
      "application/x-latex": {
        source: "apache",
        compressible: false,
        extensions: ["latex"]
      },
      "application/x-lua-bytecode": {
        extensions: ["luac"]
      },
      "application/x-lzh-compressed": {
        source: "apache",
        extensions: ["lzh", "lha"]
      },
      "application/x-makeself": {
        source: "nginx",
        extensions: ["run"]
      },
      "application/x-mie": {
        source: "apache",
        extensions: ["mie"]
      },
      "application/x-mobipocket-ebook": {
        source: "apache",
        extensions: ["prc", "mobi"]
      },
      "application/x-mpegurl": {
        compressible: false
      },
      "application/x-ms-application": {
        source: "apache",
        extensions: ["application"]
      },
      "application/x-ms-shortcut": {
        source: "apache",
        extensions: ["lnk"]
      },
      "application/x-ms-wmd": {
        source: "apache",
        extensions: ["wmd"]
      },
      "application/x-ms-wmz": {
        source: "apache",
        extensions: ["wmz"]
      },
      "application/x-ms-xbap": {
        source: "apache",
        extensions: ["xbap"]
      },
      "application/x-msaccess": {
        source: "apache",
        extensions: ["mdb"]
      },
      "application/x-msbinder": {
        source: "apache",
        extensions: ["obd"]
      },
      "application/x-mscardfile": {
        source: "apache",
        extensions: ["crd"]
      },
      "application/x-msclip": {
        source: "apache",
        extensions: ["clp"]
      },
      "application/x-msdos-program": {
        extensions: ["exe"]
      },
      "application/x-msdownload": {
        source: "apache",
        extensions: ["exe", "dll", "com", "bat", "msi"]
      },
      "application/x-msmediaview": {
        source: "apache",
        extensions: ["mvb", "m13", "m14"]
      },
      "application/x-msmetafile": {
        source: "apache",
        extensions: ["wmf", "wmz", "emf", "emz"]
      },
      "application/x-msmoney": {
        source: "apache",
        extensions: ["mny"]
      },
      "application/x-mspublisher": {
        source: "apache",
        extensions: ["pub"]
      },
      "application/x-msschedule": {
        source: "apache",
        extensions: ["scd"]
      },
      "application/x-msterminal": {
        source: "apache",
        extensions: ["trm"]
      },
      "application/x-mswrite": {
        source: "apache",
        extensions: ["wri"]
      },
      "application/x-netcdf": {
        source: "apache",
        extensions: ["nc", "cdf"]
      },
      "application/x-ns-proxy-autoconfig": {
        compressible: true,
        extensions: ["pac"]
      },
      "application/x-nzb": {
        source: "apache",
        extensions: ["nzb"]
      },
      "application/x-perl": {
        source: "nginx",
        extensions: ["pl", "pm"]
      },
      "application/x-pilot": {
        source: "nginx",
        extensions: ["prc", "pdb"]
      },
      "application/x-pkcs12": {
        source: "apache",
        compressible: false,
        extensions: ["p12", "pfx"]
      },
      "application/x-pkcs7-certificates": {
        source: "apache",
        extensions: ["p7b", "spc"]
      },
      "application/x-pkcs7-certreqresp": {
        source: "apache",
        extensions: ["p7r"]
      },
      "application/x-pki-message": {
        source: "iana"
      },
      "application/x-rar-compressed": {
        source: "apache",
        compressible: false,
        extensions: ["rar"]
      },
      "application/x-redhat-package-manager": {
        source: "nginx",
        extensions: ["rpm"]
      },
      "application/x-research-info-systems": {
        source: "apache",
        extensions: ["ris"]
      },
      "application/x-sea": {
        source: "nginx",
        extensions: ["sea"]
      },
      "application/x-sh": {
        source: "apache",
        compressible: true,
        extensions: ["sh"]
      },
      "application/x-shar": {
        source: "apache",
        extensions: ["shar"]
      },
      "application/x-shockwave-flash": {
        source: "apache",
        compressible: false,
        extensions: ["swf"]
      },
      "application/x-silverlight-app": {
        source: "apache",
        extensions: ["xap"]
      },
      "application/x-sql": {
        source: "apache",
        extensions: ["sql"]
      },
      "application/x-stuffit": {
        source: "apache",
        compressible: false,
        extensions: ["sit"]
      },
      "application/x-stuffitx": {
        source: "apache",
        extensions: ["sitx"]
      },
      "application/x-subrip": {
        source: "apache",
        extensions: ["srt"]
      },
      "application/x-sv4cpio": {
        source: "apache",
        extensions: ["sv4cpio"]
      },
      "application/x-sv4crc": {
        source: "apache",
        extensions: ["sv4crc"]
      },
      "application/x-t3vm-image": {
        source: "apache",
        extensions: ["t3"]
      },
      "application/x-tads": {
        source: "apache",
        extensions: ["gam"]
      },
      "application/x-tar": {
        source: "apache",
        compressible: true,
        extensions: ["tar"]
      },
      "application/x-tcl": {
        source: "apache",
        extensions: ["tcl", "tk"]
      },
      "application/x-tex": {
        source: "apache",
        extensions: ["tex"]
      },
      "application/x-tex-tfm": {
        source: "apache",
        extensions: ["tfm"]
      },
      "application/x-texinfo": {
        source: "apache",
        extensions: ["texinfo", "texi"]
      },
      "application/x-tgif": {
        source: "apache",
        extensions: ["obj"]
      },
      "application/x-ustar": {
        source: "apache",
        extensions: ["ustar"]
      },
      "application/x-virtualbox-hdd": {
        compressible: true,
        extensions: ["hdd"]
      },
      "application/x-virtualbox-ova": {
        compressible: true,
        extensions: ["ova"]
      },
      "application/x-virtualbox-ovf": {
        compressible: true,
        extensions: ["ovf"]
      },
      "application/x-virtualbox-vbox": {
        compressible: true,
        extensions: ["vbox"]
      },
      "application/x-virtualbox-vbox-extpack": {
        compressible: false,
        extensions: ["vbox-extpack"]
      },
      "application/x-virtualbox-vdi": {
        compressible: true,
        extensions: ["vdi"]
      },
      "application/x-virtualbox-vhd": {
        compressible: true,
        extensions: ["vhd"]
      },
      "application/x-virtualbox-vmdk": {
        compressible: true,
        extensions: ["vmdk"]
      },
      "application/x-wais-source": {
        source: "apache",
        extensions: ["src"]
      },
      "application/x-web-app-manifest+json": {
        compressible: true,
        extensions: ["webapp"]
      },
      "application/x-www-form-urlencoded": {
        source: "iana",
        compressible: true
      },
      "application/x-x509-ca-cert": {
        source: "iana",
        extensions: ["der", "crt", "pem"]
      },
      "application/x-x509-ca-ra-cert": {
        source: "iana"
      },
      "application/x-x509-next-ca-cert": {
        source: "iana"
      },
      "application/x-xfig": {
        source: "apache",
        extensions: ["fig"]
      },
      "application/x-xliff+xml": {
        source: "apache",
        compressible: true,
        extensions: ["xlf"]
      },
      "application/x-xpinstall": {
        source: "apache",
        compressible: false,
        extensions: ["xpi"]
      },
      "application/x-xz": {
        source: "apache",
        extensions: ["xz"]
      },
      "application/x-zmachine": {
        source: "apache",
        extensions: ["z1", "z2", "z3", "z4", "z5", "z6", "z7", "z8"]
      },
      "application/x400-bp": {
        source: "iana"
      },
      "application/xacml+xml": {
        source: "iana",
        compressible: true
      },
      "application/xaml+xml": {
        source: "apache",
        compressible: true,
        extensions: ["xaml"]
      },
      "application/xcap-att+xml": {
        source: "iana",
        compressible: true,
        extensions: ["xav"]
      },
      "application/xcap-caps+xml": {
        source: "iana",
        compressible: true,
        extensions: ["xca"]
      },
      "application/xcap-diff+xml": {
        source: "iana",
        compressible: true,
        extensions: ["xdf"]
      },
      "application/xcap-el+xml": {
        source: "iana",
        compressible: true,
        extensions: ["xel"]
      },
      "application/xcap-error+xml": {
        source: "iana",
        compressible: true
      },
      "application/xcap-ns+xml": {
        source: "iana",
        compressible: true,
        extensions: ["xns"]
      },
      "application/xcon-conference-info+xml": {
        source: "iana",
        compressible: true
      },
      "application/xcon-conference-info-diff+xml": {
        source: "iana",
        compressible: true
      },
      "application/xenc+xml": {
        source: "iana",
        compressible: true,
        extensions: ["xenc"]
      },
      "application/xhtml+xml": {
        source: "iana",
        compressible: true,
        extensions: ["xhtml", "xht"]
      },
      "application/xhtml-voice+xml": {
        source: "apache",
        compressible: true
      },
      "application/xliff+xml": {
        source: "iana",
        compressible: true,
        extensions: ["xlf"]
      },
      "application/xml": {
        source: "iana",
        compressible: true,
        extensions: ["xml", "xsl", "xsd", "rng"]
      },
      "application/xml-dtd": {
        source: "iana",
        compressible: true,
        extensions: ["dtd"]
      },
      "application/xml-external-parsed-entity": {
        source: "iana"
      },
      "application/xml-patch+xml": {
        source: "iana",
        compressible: true
      },
      "application/xmpp+xml": {
        source: "iana",
        compressible: true
      },
      "application/xop+xml": {
        source: "iana",
        compressible: true,
        extensions: ["xop"]
      },
      "application/xproc+xml": {
        source: "apache",
        compressible: true,
        extensions: ["xpl"]
      },
      "application/xslt+xml": {
        source: "iana",
        compressible: true,
        extensions: ["xsl", "xslt"]
      },
      "application/xspf+xml": {
        source: "apache",
        compressible: true,
        extensions: ["xspf"]
      },
      "application/xv+xml": {
        source: "iana",
        compressible: true,
        extensions: ["mxml", "xhvml", "xvml", "xvm"]
      },
      "application/yang": {
        source: "iana",
        extensions: ["yang"]
      },
      "application/yang-data+json": {
        source: "iana",
        compressible: true
      },
      "application/yang-data+xml": {
        source: "iana",
        compressible: true
      },
      "application/yang-patch+json": {
        source: "iana",
        compressible: true
      },
      "application/yang-patch+xml": {
        source: "iana",
        compressible: true
      },
      "application/yin+xml": {
        source: "iana",
        compressible: true,
        extensions: ["yin"]
      },
      "application/zip": {
        source: "iana",
        compressible: false,
        extensions: ["zip"]
      },
      "application/zlib": {
        source: "iana"
      },
      "application/zstd": {
        source: "iana"
      },
      "audio/1d-interleaved-parityfec": {
        source: "iana"
      },
      "audio/32kadpcm": {
        source: "iana"
      },
      "audio/3gpp": {
        source: "iana",
        compressible: false,
        extensions: ["3gpp"]
      },
      "audio/3gpp2": {
        source: "iana"
      },
      "audio/aac": {
        source: "iana"
      },
      "audio/ac3": {
        source: "iana"
      },
      "audio/adpcm": {
        source: "apache",
        extensions: ["adp"]
      },
      "audio/amr": {
        source: "iana",
        extensions: ["amr"]
      },
      "audio/amr-wb": {
        source: "iana"
      },
      "audio/amr-wb+": {
        source: "iana"
      },
      "audio/aptx": {
        source: "iana"
      },
      "audio/asc": {
        source: "iana"
      },
      "audio/atrac-advanced-lossless": {
        source: "iana"
      },
      "audio/atrac-x": {
        source: "iana"
      },
      "audio/atrac3": {
        source: "iana"
      },
      "audio/basic": {
        source: "iana",
        compressible: false,
        extensions: ["au", "snd"]
      },
      "audio/bv16": {
        source: "iana"
      },
      "audio/bv32": {
        source: "iana"
      },
      "audio/clearmode": {
        source: "iana"
      },
      "audio/cn": {
        source: "iana"
      },
      "audio/dat12": {
        source: "iana"
      },
      "audio/dls": {
        source: "iana"
      },
      "audio/dsr-es201108": {
        source: "iana"
      },
      "audio/dsr-es202050": {
        source: "iana"
      },
      "audio/dsr-es202211": {
        source: "iana"
      },
      "audio/dsr-es202212": {
        source: "iana"
      },
      "audio/dv": {
        source: "iana"
      },
      "audio/dvi4": {
        source: "iana"
      },
      "audio/eac3": {
        source: "iana"
      },
      "audio/encaprtp": {
        source: "iana"
      },
      "audio/evrc": {
        source: "iana"
      },
      "audio/evrc-qcp": {
        source: "iana"
      },
      "audio/evrc0": {
        source: "iana"
      },
      "audio/evrc1": {
        source: "iana"
      },
      "audio/evrcb": {
        source: "iana"
      },
      "audio/evrcb0": {
        source: "iana"
      },
      "audio/evrcb1": {
        source: "iana"
      },
      "audio/evrcnw": {
        source: "iana"
      },
      "audio/evrcnw0": {
        source: "iana"
      },
      "audio/evrcnw1": {
        source: "iana"
      },
      "audio/evrcwb": {
        source: "iana"
      },
      "audio/evrcwb0": {
        source: "iana"
      },
      "audio/evrcwb1": {
        source: "iana"
      },
      "audio/evs": {
        source: "iana"
      },
      "audio/flexfec": {
        source: "iana"
      },
      "audio/fwdred": {
        source: "iana"
      },
      "audio/g711-0": {
        source: "iana"
      },
      "audio/g719": {
        source: "iana"
      },
      "audio/g722": {
        source: "iana"
      },
      "audio/g7221": {
        source: "iana"
      },
      "audio/g723": {
        source: "iana"
      },
      "audio/g726-16": {
        source: "iana"
      },
      "audio/g726-24": {
        source: "iana"
      },
      "audio/g726-32": {
        source: "iana"
      },
      "audio/g726-40": {
        source: "iana"
      },
      "audio/g728": {
        source: "iana"
      },
      "audio/g729": {
        source: "iana"
      },
      "audio/g7291": {
        source: "iana"
      },
      "audio/g729d": {
        source: "iana"
      },
      "audio/g729e": {
        source: "iana"
      },
      "audio/gsm": {
        source: "iana"
      },
      "audio/gsm-efr": {
        source: "iana"
      },
      "audio/gsm-hr-08": {
        source: "iana"
      },
      "audio/ilbc": {
        source: "iana"
      },
      "audio/ip-mr_v2.5": {
        source: "iana"
      },
      "audio/isac": {
        source: "apache"
      },
      "audio/l16": {
        source: "iana"
      },
      "audio/l20": {
        source: "iana"
      },
      "audio/l24": {
        source: "iana",
        compressible: false
      },
      "audio/l8": {
        source: "iana"
      },
      "audio/lpc": {
        source: "iana"
      },
      "audio/melp": {
        source: "iana"
      },
      "audio/melp1200": {
        source: "iana"
      },
      "audio/melp2400": {
        source: "iana"
      },
      "audio/melp600": {
        source: "iana"
      },
      "audio/mhas": {
        source: "iana"
      },
      "audio/midi": {
        source: "apache",
        extensions: ["mid", "midi", "kar", "rmi"]
      },
      "audio/mobile-xmf": {
        source: "iana",
        extensions: ["mxmf"]
      },
      "audio/mp3": {
        compressible: false,
        extensions: ["mp3"]
      },
      "audio/mp4": {
        source: "iana",
        compressible: false,
        extensions: ["m4a", "mp4a"]
      },
      "audio/mp4a-latm": {
        source: "iana"
      },
      "audio/mpa": {
        source: "iana"
      },
      "audio/mpa-robust": {
        source: "iana"
      },
      "audio/mpeg": {
        source: "iana",
        compressible: false,
        extensions: ["mpga", "mp2", "mp2a", "mp3", "m2a", "m3a"]
      },
      "audio/mpeg4-generic": {
        source: "iana"
      },
      "audio/musepack": {
        source: "apache"
      },
      "audio/ogg": {
        source: "iana",
        compressible: false,
        extensions: ["oga", "ogg", "spx", "opus"]
      },
      "audio/opus": {
        source: "iana"
      },
      "audio/parityfec": {
        source: "iana"
      },
      "audio/pcma": {
        source: "iana"
      },
      "audio/pcma-wb": {
        source: "iana"
      },
      "audio/pcmu": {
        source: "iana"
      },
      "audio/pcmu-wb": {
        source: "iana"
      },
      "audio/prs.sid": {
        source: "iana"
      },
      "audio/qcelp": {
        source: "iana"
      },
      "audio/raptorfec": {
        source: "iana"
      },
      "audio/red": {
        source: "iana"
      },
      "audio/rtp-enc-aescm128": {
        source: "iana"
      },
      "audio/rtp-midi": {
        source: "iana"
      },
      "audio/rtploopback": {
        source: "iana"
      },
      "audio/rtx": {
        source: "iana"
      },
      "audio/s3m": {
        source: "apache",
        extensions: ["s3m"]
      },
      "audio/scip": {
        source: "iana"
      },
      "audio/silk": {
        source: "apache",
        extensions: ["sil"]
      },
      "audio/smv": {
        source: "iana"
      },
      "audio/smv-qcp": {
        source: "iana"
      },
      "audio/smv0": {
        source: "iana"
      },
      "audio/sofa": {
        source: "iana"
      },
      "audio/sp-midi": {
        source: "iana"
      },
      "audio/speex": {
        source: "iana"
      },
      "audio/t140c": {
        source: "iana"
      },
      "audio/t38": {
        source: "iana"
      },
      "audio/telephone-event": {
        source: "iana"
      },
      "audio/tetra_acelp": {
        source: "iana"
      },
      "audio/tetra_acelp_bb": {
        source: "iana"
      },
      "audio/tone": {
        source: "iana"
      },
      "audio/tsvcis": {
        source: "iana"
      },
      "audio/uemclip": {
        source: "iana"
      },
      "audio/ulpfec": {
        source: "iana"
      },
      "audio/usac": {
        source: "iana"
      },
      "audio/vdvi": {
        source: "iana"
      },
      "audio/vmr-wb": {
        source: "iana"
      },
      "audio/vnd.3gpp.iufp": {
        source: "iana"
      },
      "audio/vnd.4sb": {
        source: "iana"
      },
      "audio/vnd.audiokoz": {
        source: "iana"
      },
      "audio/vnd.celp": {
        source: "iana"
      },
      "audio/vnd.cisco.nse": {
        source: "iana"
      },
      "audio/vnd.cmles.radio-events": {
        source: "iana"
      },
      "audio/vnd.cns.anp1": {
        source: "iana"
      },
      "audio/vnd.cns.inf1": {
        source: "iana"
      },
      "audio/vnd.dece.audio": {
        source: "iana",
        extensions: ["uva", "uvva"]
      },
      "audio/vnd.digital-winds": {
        source: "iana",
        extensions: ["eol"]
      },
      "audio/vnd.dlna.adts": {
        source: "iana"
      },
      "audio/vnd.dolby.heaac.1": {
        source: "iana"
      },
      "audio/vnd.dolby.heaac.2": {
        source: "iana"
      },
      "audio/vnd.dolby.mlp": {
        source: "iana"
      },
      "audio/vnd.dolby.mps": {
        source: "iana"
      },
      "audio/vnd.dolby.pl2": {
        source: "iana"
      },
      "audio/vnd.dolby.pl2x": {
        source: "iana"
      },
      "audio/vnd.dolby.pl2z": {
        source: "iana"
      },
      "audio/vnd.dolby.pulse.1": {
        source: "iana"
      },
      "audio/vnd.dra": {
        source: "iana",
        extensions: ["dra"]
      },
      "audio/vnd.dts": {
        source: "iana",
        extensions: ["dts"]
      },
      "audio/vnd.dts.hd": {
        source: "iana",
        extensions: ["dtshd"]
      },
      "audio/vnd.dts.uhd": {
        source: "iana"
      },
      "audio/vnd.dvb.file": {
        source: "iana"
      },
      "audio/vnd.everad.plj": {
        source: "iana"
      },
      "audio/vnd.hns.audio": {
        source: "iana"
      },
      "audio/vnd.lucent.voice": {
        source: "iana",
        extensions: ["lvp"]
      },
      "audio/vnd.ms-playready.media.pya": {
        source: "iana",
        extensions: ["pya"]
      },
      "audio/vnd.nokia.mobile-xmf": {
        source: "iana"
      },
      "audio/vnd.nortel.vbk": {
        source: "iana"
      },
      "audio/vnd.nuera.ecelp4800": {
        source: "iana",
        extensions: ["ecelp4800"]
      },
      "audio/vnd.nuera.ecelp7470": {
        source: "iana",
        extensions: ["ecelp7470"]
      },
      "audio/vnd.nuera.ecelp9600": {
        source: "iana",
        extensions: ["ecelp9600"]
      },
      "audio/vnd.octel.sbc": {
        source: "iana"
      },
      "audio/vnd.presonus.multitrack": {
        source: "iana"
      },
      "audio/vnd.qcelp": {
        source: "iana"
      },
      "audio/vnd.rhetorex.32kadpcm": {
        source: "iana"
      },
      "audio/vnd.rip": {
        source: "iana",
        extensions: ["rip"]
      },
      "audio/vnd.rn-realaudio": {
        compressible: false
      },
      "audio/vnd.sealedmedia.softseal.mpeg": {
        source: "iana"
      },
      "audio/vnd.vmx.cvsd": {
        source: "iana"
      },
      "audio/vnd.wave": {
        compressible: false
      },
      "audio/vorbis": {
        source: "iana",
        compressible: false
      },
      "audio/vorbis-config": {
        source: "iana"
      },
      "audio/wav": {
        compressible: false,
        extensions: ["wav"]
      },
      "audio/wave": {
        compressible: false,
        extensions: ["wav"]
      },
      "audio/webm": {
        source: "apache",
        compressible: false,
        extensions: ["weba"]
      },
      "audio/x-aac": {
        source: "apache",
        compressible: false,
        extensions: ["aac"]
      },
      "audio/x-aiff": {
        source: "apache",
        extensions: ["aif", "aiff", "aifc"]
      },
      "audio/x-caf": {
        source: "apache",
        compressible: false,
        extensions: ["caf"]
      },
      "audio/x-flac": {
        source: "apache",
        extensions: ["flac"]
      },
      "audio/x-m4a": {
        source: "nginx",
        extensions: ["m4a"]
      },
      "audio/x-matroska": {
        source: "apache",
        extensions: ["mka"]
      },
      "audio/x-mpegurl": {
        source: "apache",
        extensions: ["m3u"]
      },
      "audio/x-ms-wax": {
        source: "apache",
        extensions: ["wax"]
      },
      "audio/x-ms-wma": {
        source: "apache",
        extensions: ["wma"]
      },
      "audio/x-pn-realaudio": {
        source: "apache",
        extensions: ["ram", "ra"]
      },
      "audio/x-pn-realaudio-plugin": {
        source: "apache",
        extensions: ["rmp"]
      },
      "audio/x-realaudio": {
        source: "nginx",
        extensions: ["ra"]
      },
      "audio/x-tta": {
        source: "apache"
      },
      "audio/x-wav": {
        source: "apache",
        extensions: ["wav"]
      },
      "audio/xm": {
        source: "apache",
        extensions: ["xm"]
      },
      "chemical/x-cdx": {
        source: "apache",
        extensions: ["cdx"]
      },
      "chemical/x-cif": {
        source: "apache",
        extensions: ["cif"]
      },
      "chemical/x-cmdf": {
        source: "apache",
        extensions: ["cmdf"]
      },
      "chemical/x-cml": {
        source: "apache",
        extensions: ["cml"]
      },
      "chemical/x-csml": {
        source: "apache",
        extensions: ["csml"]
      },
      "chemical/x-pdb": {
        source: "apache"
      },
      "chemical/x-xyz": {
        source: "apache",
        extensions: ["xyz"]
      },
      "font/collection": {
        source: "iana",
        extensions: ["ttc"]
      },
      "font/otf": {
        source: "iana",
        compressible: true,
        extensions: ["otf"]
      },
      "font/sfnt": {
        source: "iana"
      },
      "font/ttf": {
        source: "iana",
        compressible: true,
        extensions: ["ttf"]
      },
      "font/woff": {
        source: "iana",
        extensions: ["woff"]
      },
      "font/woff2": {
        source: "iana",
        extensions: ["woff2"]
      },
      "image/aces": {
        source: "iana",
        extensions: ["exr"]
      },
      "image/apng": {
        compressible: false,
        extensions: ["apng"]
      },
      "image/avci": {
        source: "iana",
        extensions: ["avci"]
      },
      "image/avcs": {
        source: "iana",
        extensions: ["avcs"]
      },
      "image/avif": {
        source: "iana",
        compressible: false,
        extensions: ["avif"]
      },
      "image/bmp": {
        source: "iana",
        compressible: true,
        extensions: ["bmp"]
      },
      "image/cgm": {
        source: "iana",
        extensions: ["cgm"]
      },
      "image/dicom-rle": {
        source: "iana",
        extensions: ["drle"]
      },
      "image/emf": {
        source: "iana",
        extensions: ["emf"]
      },
      "image/fits": {
        source: "iana",
        extensions: ["fits"]
      },
      "image/g3fax": {
        source: "iana",
        extensions: ["g3"]
      },
      "image/gif": {
        source: "iana",
        compressible: false,
        extensions: ["gif"]
      },
      "image/heic": {
        source: "iana",
        extensions: ["heic"]
      },
      "image/heic-sequence": {
        source: "iana",
        extensions: ["heics"]
      },
      "image/heif": {
        source: "iana",
        extensions: ["heif"]
      },
      "image/heif-sequence": {
        source: "iana",
        extensions: ["heifs"]
      },
      "image/hej2k": {
        source: "iana",
        extensions: ["hej2"]
      },
      "image/hsj2": {
        source: "iana",
        extensions: ["hsj2"]
      },
      "image/ief": {
        source: "iana",
        extensions: ["ief"]
      },
      "image/jls": {
        source: "iana",
        extensions: ["jls"]
      },
      "image/jp2": {
        source: "iana",
        compressible: false,
        extensions: ["jp2", "jpg2"]
      },
      "image/jpeg": {
        source: "iana",
        compressible: false,
        extensions: ["jpeg", "jpg", "jpe"]
      },
      "image/jph": {
        source: "iana",
        extensions: ["jph"]
      },
      "image/jphc": {
        source: "iana",
        extensions: ["jhc"]
      },
      "image/jpm": {
        source: "iana",
        compressible: false,
        extensions: ["jpm"]
      },
      "image/jpx": {
        source: "iana",
        compressible: false,
        extensions: ["jpx", "jpf"]
      },
      "image/jxr": {
        source: "iana",
        extensions: ["jxr"]
      },
      "image/jxra": {
        source: "iana",
        extensions: ["jxra"]
      },
      "image/jxrs": {
        source: "iana",
        extensions: ["jxrs"]
      },
      "image/jxs": {
        source: "iana",
        extensions: ["jxs"]
      },
      "image/jxsc": {
        source: "iana",
        extensions: ["jxsc"]
      },
      "image/jxsi": {
        source: "iana",
        extensions: ["jxsi"]
      },
      "image/jxss": {
        source: "iana",
        extensions: ["jxss"]
      },
      "image/ktx": {
        source: "iana",
        extensions: ["ktx"]
      },
      "image/ktx2": {
        source: "iana",
        extensions: ["ktx2"]
      },
      "image/naplps": {
        source: "iana"
      },
      "image/pjpeg": {
        compressible: false
      },
      "image/png": {
        source: "iana",
        compressible: false,
        extensions: ["png"]
      },
      "image/prs.btif": {
        source: "iana",
        extensions: ["btif"]
      },
      "image/prs.pti": {
        source: "iana",
        extensions: ["pti"]
      },
      "image/pwg-raster": {
        source: "iana"
      },
      "image/sgi": {
        source: "apache",
        extensions: ["sgi"]
      },
      "image/svg+xml": {
        source: "iana",
        compressible: true,
        extensions: ["svg", "svgz"]
      },
      "image/t38": {
        source: "iana",
        extensions: ["t38"]
      },
      "image/tiff": {
        source: "iana",
        compressible: false,
        extensions: ["tif", "tiff"]
      },
      "image/tiff-fx": {
        source: "iana",
        extensions: ["tfx"]
      },
      "image/vnd.adobe.photoshop": {
        source: "iana",
        compressible: true,
        extensions: ["psd"]
      },
      "image/vnd.airzip.accelerator.azv": {
        source: "iana",
        extensions: ["azv"]
      },
      "image/vnd.cns.inf2": {
        source: "iana"
      },
      "image/vnd.dece.graphic": {
        source: "iana",
        extensions: ["uvi", "uvvi", "uvg", "uvvg"]
      },
      "image/vnd.djvu": {
        source: "iana",
        extensions: ["djvu", "djv"]
      },
      "image/vnd.dvb.subtitle": {
        source: "iana",
        extensions: ["sub"]
      },
      "image/vnd.dwg": {
        source: "iana",
        extensions: ["dwg"]
      },
      "image/vnd.dxf": {
        source: "iana",
        extensions: ["dxf"]
      },
      "image/vnd.fastbidsheet": {
        source: "iana",
        extensions: ["fbs"]
      },
      "image/vnd.fpx": {
        source: "iana",
        extensions: ["fpx"]
      },
      "image/vnd.fst": {
        source: "iana",
        extensions: ["fst"]
      },
      "image/vnd.fujixerox.edmics-mmr": {
        source: "iana",
        extensions: ["mmr"]
      },
      "image/vnd.fujixerox.edmics-rlc": {
        source: "iana",
        extensions: ["rlc"]
      },
      "image/vnd.globalgraphics.pgb": {
        source: "iana"
      },
      "image/vnd.microsoft.icon": {
        source: "iana",
        compressible: true,
        extensions: ["ico"]
      },
      "image/vnd.mix": {
        source: "iana"
      },
      "image/vnd.mozilla.apng": {
        source: "iana"
      },
      "image/vnd.ms-dds": {
        compressible: true,
        extensions: ["dds"]
      },
      "image/vnd.ms-modi": {
        source: "iana",
        extensions: ["mdi"]
      },
      "image/vnd.ms-photo": {
        source: "apache",
        extensions: ["wdp"]
      },
      "image/vnd.net-fpx": {
        source: "iana",
        extensions: ["npx"]
      },
      "image/vnd.pco.b16": {
        source: "iana",
        extensions: ["b16"]
      },
      "image/vnd.radiance": {
        source: "iana"
      },
      "image/vnd.sealed.png": {
        source: "iana"
      },
      "image/vnd.sealedmedia.softseal.gif": {
        source: "iana"
      },
      "image/vnd.sealedmedia.softseal.jpg": {
        source: "iana"
      },
      "image/vnd.svf": {
        source: "iana"
      },
      "image/vnd.tencent.tap": {
        source: "iana",
        extensions: ["tap"]
      },
      "image/vnd.valve.source.texture": {
        source: "iana",
        extensions: ["vtf"]
      },
      "image/vnd.wap.wbmp": {
        source: "iana",
        extensions: ["wbmp"]
      },
      "image/vnd.xiff": {
        source: "iana",
        extensions: ["xif"]
      },
      "image/vnd.zbrush.pcx": {
        source: "iana",
        extensions: ["pcx"]
      },
      "image/webp": {
        source: "apache",
        extensions: ["webp"]
      },
      "image/wmf": {
        source: "iana",
        extensions: ["wmf"]
      },
      "image/x-3ds": {
        source: "apache",
        extensions: ["3ds"]
      },
      "image/x-cmu-raster": {
        source: "apache",
        extensions: ["ras"]
      },
      "image/x-cmx": {
        source: "apache",
        extensions: ["cmx"]
      },
      "image/x-freehand": {
        source: "apache",
        extensions: ["fh", "fhc", "fh4", "fh5", "fh7"]
      },
      "image/x-icon": {
        source: "apache",
        compressible: true,
        extensions: ["ico"]
      },
      "image/x-jng": {
        source: "nginx",
        extensions: ["jng"]
      },
      "image/x-mrsid-image": {
        source: "apache",
        extensions: ["sid"]
      },
      "image/x-ms-bmp": {
        source: "nginx",
        compressible: true,
        extensions: ["bmp"]
      },
      "image/x-pcx": {
        source: "apache",
        extensions: ["pcx"]
      },
      "image/x-pict": {
        source: "apache",
        extensions: ["pic", "pct"]
      },
      "image/x-portable-anymap": {
        source: "apache",
        extensions: ["pnm"]
      },
      "image/x-portable-bitmap": {
        source: "apache",
        extensions: ["pbm"]
      },
      "image/x-portable-graymap": {
        source: "apache",
        extensions: ["pgm"]
      },
      "image/x-portable-pixmap": {
        source: "apache",
        extensions: ["ppm"]
      },
      "image/x-rgb": {
        source: "apache",
        extensions: ["rgb"]
      },
      "image/x-tga": {
        source: "apache",
        extensions: ["tga"]
      },
      "image/x-xbitmap": {
        source: "apache",
        extensions: ["xbm"]
      },
      "image/x-xcf": {
        compressible: false
      },
      "image/x-xpixmap": {
        source: "apache",
        extensions: ["xpm"]
      },
      "image/x-xwindowdump": {
        source: "apache",
        extensions: ["xwd"]
      },
      "message/cpim": {
        source: "iana"
      },
      "message/delivery-status": {
        source: "iana"
      },
      "message/disposition-notification": {
        source: "iana",
        extensions: [
          "disposition-notification"
        ]
      },
      "message/external-body": {
        source: "iana"
      },
      "message/feedback-report": {
        source: "iana"
      },
      "message/global": {
        source: "iana",
        extensions: ["u8msg"]
      },
      "message/global-delivery-status": {
        source: "iana",
        extensions: ["u8dsn"]
      },
      "message/global-disposition-notification": {
        source: "iana",
        extensions: ["u8mdn"]
      },
      "message/global-headers": {
        source: "iana",
        extensions: ["u8hdr"]
      },
      "message/http": {
        source: "iana",
        compressible: false
      },
      "message/imdn+xml": {
        source: "iana",
        compressible: true
      },
      "message/news": {
        source: "iana"
      },
      "message/partial": {
        source: "iana",
        compressible: false
      },
      "message/rfc822": {
        source: "iana",
        compressible: true,
        extensions: ["eml", "mime"]
      },
      "message/s-http": {
        source: "iana"
      },
      "message/sip": {
        source: "iana"
      },
      "message/sipfrag": {
        source: "iana"
      },
      "message/tracking-status": {
        source: "iana"
      },
      "message/vnd.si.simp": {
        source: "iana"
      },
      "message/vnd.wfa.wsc": {
        source: "iana",
        extensions: ["wsc"]
      },
      "model/3mf": {
        source: "iana",
        extensions: ["3mf"]
      },
      "model/e57": {
        source: "iana"
      },
      "model/gltf+json": {
        source: "iana",
        compressible: true,
        extensions: ["gltf"]
      },
      "model/gltf-binary": {
        source: "iana",
        compressible: true,
        extensions: ["glb"]
      },
      "model/iges": {
        source: "iana",
        compressible: false,
        extensions: ["igs", "iges"]
      },
      "model/mesh": {
        source: "iana",
        compressible: false,
        extensions: ["msh", "mesh", "silo"]
      },
      "model/mtl": {
        source: "iana",
        extensions: ["mtl"]
      },
      "model/obj": {
        source: "iana",
        extensions: ["obj"]
      },
      "model/step": {
        source: "iana"
      },
      "model/step+xml": {
        source: "iana",
        compressible: true,
        extensions: ["stpx"]
      },
      "model/step+zip": {
        source: "iana",
        compressible: false,
        extensions: ["stpz"]
      },
      "model/step-xml+zip": {
        source: "iana",
        compressible: false,
        extensions: ["stpxz"]
      },
      "model/stl": {
        source: "iana",
        extensions: ["stl"]
      },
      "model/vnd.collada+xml": {
        source: "iana",
        compressible: true,
        extensions: ["dae"]
      },
      "model/vnd.dwf": {
        source: "iana",
        extensions: ["dwf"]
      },
      "model/vnd.flatland.3dml": {
        source: "iana"
      },
      "model/vnd.gdl": {
        source: "iana",
        extensions: ["gdl"]
      },
      "model/vnd.gs-gdl": {
        source: "apache"
      },
      "model/vnd.gs.gdl": {
        source: "iana"
      },
      "model/vnd.gtw": {
        source: "iana",
        extensions: ["gtw"]
      },
      "model/vnd.moml+xml": {
        source: "iana",
        compressible: true
      },
      "model/vnd.mts": {
        source: "iana",
        extensions: ["mts"]
      },
      "model/vnd.opengex": {
        source: "iana",
        extensions: ["ogex"]
      },
      "model/vnd.parasolid.transmit.binary": {
        source: "iana",
        extensions: ["x_b"]
      },
      "model/vnd.parasolid.transmit.text": {
        source: "iana",
        extensions: ["x_t"]
      },
      "model/vnd.pytha.pyox": {
        source: "iana"
      },
      "model/vnd.rosette.annotated-data-model": {
        source: "iana"
      },
      "model/vnd.sap.vds": {
        source: "iana",
        extensions: ["vds"]
      },
      "model/vnd.usdz+zip": {
        source: "iana",
        compressible: false,
        extensions: ["usdz"]
      },
      "model/vnd.valve.source.compiled-map": {
        source: "iana",
        extensions: ["bsp"]
      },
      "model/vnd.vtu": {
        source: "iana",
        extensions: ["vtu"]
      },
      "model/vrml": {
        source: "iana",
        compressible: false,
        extensions: ["wrl", "vrml"]
      },
      "model/x3d+binary": {
        source: "apache",
        compressible: false,
        extensions: ["x3db", "x3dbz"]
      },
      "model/x3d+fastinfoset": {
        source: "iana",
        extensions: ["x3db"]
      },
      "model/x3d+vrml": {
        source: "apache",
        compressible: false,
        extensions: ["x3dv", "x3dvz"]
      },
      "model/x3d+xml": {
        source: "iana",
        compressible: true,
        extensions: ["x3d", "x3dz"]
      },
      "model/x3d-vrml": {
        source: "iana",
        extensions: ["x3dv"]
      },
      "multipart/alternative": {
        source: "iana",
        compressible: false
      },
      "multipart/appledouble": {
        source: "iana"
      },
      "multipart/byteranges": {
        source: "iana"
      },
      "multipart/digest": {
        source: "iana"
      },
      "multipart/encrypted": {
        source: "iana",
        compressible: false
      },
      "multipart/form-data": {
        source: "iana",
        compressible: false
      },
      "multipart/header-set": {
        source: "iana"
      },
      "multipart/mixed": {
        source: "iana"
      },
      "multipart/multilingual": {
        source: "iana"
      },
      "multipart/parallel": {
        source: "iana"
      },
      "multipart/related": {
        source: "iana",
        compressible: false
      },
      "multipart/report": {
        source: "iana"
      },
      "multipart/signed": {
        source: "iana",
        compressible: false
      },
      "multipart/vnd.bint.med-plus": {
        source: "iana"
      },
      "multipart/voice-message": {
        source: "iana"
      },
      "multipart/x-mixed-replace": {
        source: "iana"
      },
      "text/1d-interleaved-parityfec": {
        source: "iana"
      },
      "text/cache-manifest": {
        source: "iana",
        compressible: true,
        extensions: ["appcache", "manifest"]
      },
      "text/calendar": {
        source: "iana",
        extensions: ["ics", "ifb"]
      },
      "text/calender": {
        compressible: true
      },
      "text/cmd": {
        compressible: true
      },
      "text/coffeescript": {
        extensions: ["coffee", "litcoffee"]
      },
      "text/cql": {
        source: "iana"
      },
      "text/cql-expression": {
        source: "iana"
      },
      "text/cql-identifier": {
        source: "iana"
      },
      "text/css": {
        source: "iana",
        charset: "UTF-8",
        compressible: true,
        extensions: ["css"]
      },
      "text/csv": {
        source: "iana",
        compressible: true,
        extensions: ["csv"]
      },
      "text/csv-schema": {
        source: "iana"
      },
      "text/directory": {
        source: "iana"
      },
      "text/dns": {
        source: "iana"
      },
      "text/ecmascript": {
        source: "iana"
      },
      "text/encaprtp": {
        source: "iana"
      },
      "text/enriched": {
        source: "iana"
      },
      "text/fhirpath": {
        source: "iana"
      },
      "text/flexfec": {
        source: "iana"
      },
      "text/fwdred": {
        source: "iana"
      },
      "text/gff3": {
        source: "iana"
      },
      "text/grammar-ref-list": {
        source: "iana"
      },
      "text/html": {
        source: "iana",
        compressible: true,
        extensions: ["html", "htm", "shtml"]
      },
      "text/jade": {
        extensions: ["jade"]
      },
      "text/javascript": {
        source: "iana",
        compressible: true
      },
      "text/jcr-cnd": {
        source: "iana"
      },
      "text/jsx": {
        compressible: true,
        extensions: ["jsx"]
      },
      "text/less": {
        compressible: true,
        extensions: ["less"]
      },
      "text/markdown": {
        source: "iana",
        compressible: true,
        extensions: ["markdown", "md"]
      },
      "text/mathml": {
        source: "nginx",
        extensions: ["mml"]
      },
      "text/mdx": {
        compressible: true,
        extensions: ["mdx"]
      },
      "text/mizar": {
        source: "iana"
      },
      "text/n3": {
        source: "iana",
        charset: "UTF-8",
        compressible: true,
        extensions: ["n3"]
      },
      "text/parameters": {
        source: "iana",
        charset: "UTF-8"
      },
      "text/parityfec": {
        source: "iana"
      },
      "text/plain": {
        source: "iana",
        compressible: true,
        extensions: ["txt", "text", "conf", "def", "list", "log", "in", "ini"]
      },
      "text/provenance-notation": {
        source: "iana",
        charset: "UTF-8"
      },
      "text/prs.fallenstein.rst": {
        source: "iana"
      },
      "text/prs.lines.tag": {
        source: "iana",
        extensions: ["dsc"]
      },
      "text/prs.prop.logic": {
        source: "iana"
      },
      "text/raptorfec": {
        source: "iana"
      },
      "text/red": {
        source: "iana"
      },
      "text/rfc822-headers": {
        source: "iana"
      },
      "text/richtext": {
        source: "iana",
        compressible: true,
        extensions: ["rtx"]
      },
      "text/rtf": {
        source: "iana",
        compressible: true,
        extensions: ["rtf"]
      },
      "text/rtp-enc-aescm128": {
        source: "iana"
      },
      "text/rtploopback": {
        source: "iana"
      },
      "text/rtx": {
        source: "iana"
      },
      "text/sgml": {
        source: "iana",
        extensions: ["sgml", "sgm"]
      },
      "text/shaclc": {
        source: "iana"
      },
      "text/shex": {
        source: "iana",
        extensions: ["shex"]
      },
      "text/slim": {
        extensions: ["slim", "slm"]
      },
      "text/spdx": {
        source: "iana",
        extensions: ["spdx"]
      },
      "text/strings": {
        source: "iana"
      },
      "text/stylus": {
        extensions: ["stylus", "styl"]
      },
      "text/t140": {
        source: "iana"
      },
      "text/tab-separated-values": {
        source: "iana",
        compressible: true,
        extensions: ["tsv"]
      },
      "text/troff": {
        source: "iana",
        extensions: ["t", "tr", "roff", "man", "me", "ms"]
      },
      "text/turtle": {
        source: "iana",
        charset: "UTF-8",
        extensions: ["ttl"]
      },
      "text/ulpfec": {
        source: "iana"
      },
      "text/uri-list": {
        source: "iana",
        compressible: true,
        extensions: ["uri", "uris", "urls"]
      },
      "text/vcard": {
        source: "iana",
        compressible: true,
        extensions: ["vcard"]
      },
      "text/vnd.a": {
        source: "iana"
      },
      "text/vnd.abc": {
        source: "iana"
      },
      "text/vnd.ascii-art": {
        source: "iana"
      },
      "text/vnd.curl": {
        source: "iana",
        extensions: ["curl"]
      },
      "text/vnd.curl.dcurl": {
        source: "apache",
        extensions: ["dcurl"]
      },
      "text/vnd.curl.mcurl": {
        source: "apache",
        extensions: ["mcurl"]
      },
      "text/vnd.curl.scurl": {
        source: "apache",
        extensions: ["scurl"]
      },
      "text/vnd.debian.copyright": {
        source: "iana",
        charset: "UTF-8"
      },
      "text/vnd.dmclientscript": {
        source: "iana"
      },
      "text/vnd.dvb.subtitle": {
        source: "iana",
        extensions: ["sub"]
      },
      "text/vnd.esmertec.theme-descriptor": {
        source: "iana",
        charset: "UTF-8"
      },
      "text/vnd.familysearch.gedcom": {
        source: "iana",
        extensions: ["ged"]
      },
      "text/vnd.ficlab.flt": {
        source: "iana"
      },
      "text/vnd.fly": {
        source: "iana",
        extensions: ["fly"]
      },
      "text/vnd.fmi.flexstor": {
        source: "iana",
        extensions: ["flx"]
      },
      "text/vnd.gml": {
        source: "iana"
      },
      "text/vnd.graphviz": {
        source: "iana",
        extensions: ["gv"]
      },
      "text/vnd.hans": {
        source: "iana"
      },
      "text/vnd.hgl": {
        source: "iana"
      },
      "text/vnd.in3d.3dml": {
        source: "iana",
        extensions: ["3dml"]
      },
      "text/vnd.in3d.spot": {
        source: "iana",
        extensions: ["spot"]
      },
      "text/vnd.iptc.newsml": {
        source: "iana"
      },
      "text/vnd.iptc.nitf": {
        source: "iana"
      },
      "text/vnd.latex-z": {
        source: "iana"
      },
      "text/vnd.motorola.reflex": {
        source: "iana"
      },
      "text/vnd.ms-mediapackage": {
        source: "iana"
      },
      "text/vnd.net2phone.commcenter.command": {
        source: "iana"
      },
      "text/vnd.radisys.msml-basic-layout": {
        source: "iana"
      },
      "text/vnd.senx.warpscript": {
        source: "iana"
      },
      "text/vnd.si.uricatalogue": {
        source: "iana"
      },
      "text/vnd.sosi": {
        source: "iana"
      },
      "text/vnd.sun.j2me.app-descriptor": {
        source: "iana",
        charset: "UTF-8",
        extensions: ["jad"]
      },
      "text/vnd.trolltech.linguist": {
        source: "iana",
        charset: "UTF-8"
      },
      "text/vnd.wap.si": {
        source: "iana"
      },
      "text/vnd.wap.sl": {
        source: "iana"
      },
      "text/vnd.wap.wml": {
        source: "iana",
        extensions: ["wml"]
      },
      "text/vnd.wap.wmlscript": {
        source: "iana",
        extensions: ["wmls"]
      },
      "text/vtt": {
        source: "iana",
        charset: "UTF-8",
        compressible: true,
        extensions: ["vtt"]
      },
      "text/x-asm": {
        source: "apache",
        extensions: ["s", "asm"]
      },
      "text/x-c": {
        source: "apache",
        extensions: ["c", "cc", "cxx", "cpp", "h", "hh", "dic"]
      },
      "text/x-component": {
        source: "nginx",
        extensions: ["htc"]
      },
      "text/x-fortran": {
        source: "apache",
        extensions: ["f", "for", "f77", "f90"]
      },
      "text/x-gwt-rpc": {
        compressible: true
      },
      "text/x-handlebars-template": {
        extensions: ["hbs"]
      },
      "text/x-java-source": {
        source: "apache",
        extensions: ["java"]
      },
      "text/x-jquery-tmpl": {
        compressible: true
      },
      "text/x-lua": {
        extensions: ["lua"]
      },
      "text/x-markdown": {
        compressible: true,
        extensions: ["mkd"]
      },
      "text/x-nfo": {
        source: "apache",
        extensions: ["nfo"]
      },
      "text/x-opml": {
        source: "apache",
        extensions: ["opml"]
      },
      "text/x-org": {
        compressible: true,
        extensions: ["org"]
      },
      "text/x-pascal": {
        source: "apache",
        extensions: ["p", "pas"]
      },
      "text/x-processing": {
        compressible: true,
        extensions: ["pde"]
      },
      "text/x-sass": {
        extensions: ["sass"]
      },
      "text/x-scss": {
        extensions: ["scss"]
      },
      "text/x-setext": {
        source: "apache",
        extensions: ["etx"]
      },
      "text/x-sfv": {
        source: "apache",
        extensions: ["sfv"]
      },
      "text/x-suse-ymp": {
        compressible: true,
        extensions: ["ymp"]
      },
      "text/x-uuencode": {
        source: "apache",
        extensions: ["uu"]
      },
      "text/x-vcalendar": {
        source: "apache",
        extensions: ["vcs"]
      },
      "text/x-vcard": {
        source: "apache",
        extensions: ["vcf"]
      },
      "text/xml": {
        source: "iana",
        compressible: true,
        extensions: ["xml"]
      },
      "text/xml-external-parsed-entity": {
        source: "iana"
      },
      "text/yaml": {
        compressible: true,
        extensions: ["yaml", "yml"]
      },
      "video/1d-interleaved-parityfec": {
        source: "iana"
      },
      "video/3gpp": {
        source: "iana",
        extensions: ["3gp", "3gpp"]
      },
      "video/3gpp-tt": {
        source: "iana"
      },
      "video/3gpp2": {
        source: "iana",
        extensions: ["3g2"]
      },
      "video/av1": {
        source: "iana"
      },
      "video/bmpeg": {
        source: "iana"
      },
      "video/bt656": {
        source: "iana"
      },
      "video/celb": {
        source: "iana"
      },
      "video/dv": {
        source: "iana"
      },
      "video/encaprtp": {
        source: "iana"
      },
      "video/ffv1": {
        source: "iana"
      },
      "video/flexfec": {
        source: "iana"
      },
      "video/h261": {
        source: "iana",
        extensions: ["h261"]
      },
      "video/h263": {
        source: "iana",
        extensions: ["h263"]
      },
      "video/h263-1998": {
        source: "iana"
      },
      "video/h263-2000": {
        source: "iana"
      },
      "video/h264": {
        source: "iana",
        extensions: ["h264"]
      },
      "video/h264-rcdo": {
        source: "iana"
      },
      "video/h264-svc": {
        source: "iana"
      },
      "video/h265": {
        source: "iana"
      },
      "video/iso.segment": {
        source: "iana",
        extensions: ["m4s"]
      },
      "video/jpeg": {
        source: "iana",
        extensions: ["jpgv"]
      },
      "video/jpeg2000": {
        source: "iana"
      },
      "video/jpm": {
        source: "apache",
        extensions: ["jpm", "jpgm"]
      },
      "video/jxsv": {
        source: "iana"
      },
      "video/mj2": {
        source: "iana",
        extensions: ["mj2", "mjp2"]
      },
      "video/mp1s": {
        source: "iana"
      },
      "video/mp2p": {
        source: "iana"
      },
      "video/mp2t": {
        source: "iana",
        extensions: ["ts"]
      },
      "video/mp4": {
        source: "iana",
        compressible: false,
        extensions: ["mp4", "mp4v", "mpg4"]
      },
      "video/mp4v-es": {
        source: "iana"
      },
      "video/mpeg": {
        source: "iana",
        compressible: false,
        extensions: ["mpeg", "mpg", "mpe", "m1v", "m2v"]
      },
      "video/mpeg4-generic": {
        source: "iana"
      },
      "video/mpv": {
        source: "iana"
      },
      "video/nv": {
        source: "iana"
      },
      "video/ogg": {
        source: "iana",
        compressible: false,
        extensions: ["ogv"]
      },
      "video/parityfec": {
        source: "iana"
      },
      "video/pointer": {
        source: "iana"
      },
      "video/quicktime": {
        source: "iana",
        compressible: false,
        extensions: ["qt", "mov"]
      },
      "video/raptorfec": {
        source: "iana"
      },
      "video/raw": {
        source: "iana"
      },
      "video/rtp-enc-aescm128": {
        source: "iana"
      },
      "video/rtploopback": {
        source: "iana"
      },
      "video/rtx": {
        source: "iana"
      },
      "video/scip": {
        source: "iana"
      },
      "video/smpte291": {
        source: "iana"
      },
      "video/smpte292m": {
        source: "iana"
      },
      "video/ulpfec": {
        source: "iana"
      },
      "video/vc1": {
        source: "iana"
      },
      "video/vc2": {
        source: "iana"
      },
      "video/vnd.cctv": {
        source: "iana"
      },
      "video/vnd.dece.hd": {
        source: "iana",
        extensions: ["uvh", "uvvh"]
      },
      "video/vnd.dece.mobile": {
        source: "iana",
        extensions: ["uvm", "uvvm"]
      },
      "video/vnd.dece.mp4": {
        source: "iana"
      },
      "video/vnd.dece.pd": {
        source: "iana",
        extensions: ["uvp", "uvvp"]
      },
      "video/vnd.dece.sd": {
        source: "iana",
        extensions: ["uvs", "uvvs"]
      },
      "video/vnd.dece.video": {
        source: "iana",
        extensions: ["uvv", "uvvv"]
      },
      "video/vnd.directv.mpeg": {
        source: "iana"
      },
      "video/vnd.directv.mpeg-tts": {
        source: "iana"
      },
      "video/vnd.dlna.mpeg-tts": {
        source: "iana"
      },
      "video/vnd.dvb.file": {
        source: "iana",
        extensions: ["dvb"]
      },
      "video/vnd.fvt": {
        source: "iana",
        extensions: ["fvt"]
      },
      "video/vnd.hns.video": {
        source: "iana"
      },
      "video/vnd.iptvforum.1dparityfec-1010": {
        source: "iana"
      },
      "video/vnd.iptvforum.1dparityfec-2005": {
        source: "iana"
      },
      "video/vnd.iptvforum.2dparityfec-1010": {
        source: "iana"
      },
      "video/vnd.iptvforum.2dparityfec-2005": {
        source: "iana"
      },
      "video/vnd.iptvforum.ttsavc": {
        source: "iana"
      },
      "video/vnd.iptvforum.ttsmpeg2": {
        source: "iana"
      },
      "video/vnd.motorola.video": {
        source: "iana"
      },
      "video/vnd.motorola.videop": {
        source: "iana"
      },
      "video/vnd.mpegurl": {
        source: "iana",
        extensions: ["mxu", "m4u"]
      },
      "video/vnd.ms-playready.media.pyv": {
        source: "iana",
        extensions: ["pyv"]
      },
      "video/vnd.nokia.interleaved-multimedia": {
        source: "iana"
      },
      "video/vnd.nokia.mp4vr": {
        source: "iana"
      },
      "video/vnd.nokia.videovoip": {
        source: "iana"
      },
      "video/vnd.objectvideo": {
        source: "iana"
      },
      "video/vnd.radgamettools.bink": {
        source: "iana"
      },
      "video/vnd.radgamettools.smacker": {
        source: "iana"
      },
      "video/vnd.sealed.mpeg1": {
        source: "iana"
      },
      "video/vnd.sealed.mpeg4": {
        source: "iana"
      },
      "video/vnd.sealed.swf": {
        source: "iana"
      },
      "video/vnd.sealedmedia.softseal.mov": {
        source: "iana"
      },
      "video/vnd.uvvu.mp4": {
        source: "iana",
        extensions: ["uvu", "uvvu"]
      },
      "video/vnd.vivo": {
        source: "iana",
        extensions: ["viv"]
      },
      "video/vnd.youtube.yt": {
        source: "iana"
      },
      "video/vp8": {
        source: "iana"
      },
      "video/vp9": {
        source: "iana"
      },
      "video/webm": {
        source: "apache",
        compressible: false,
        extensions: ["webm"]
      },
      "video/x-f4v": {
        source: "apache",
        extensions: ["f4v"]
      },
      "video/x-fli": {
        source: "apache",
        extensions: ["fli"]
      },
      "video/x-flv": {
        source: "apache",
        compressible: false,
        extensions: ["flv"]
      },
      "video/x-m4v": {
        source: "apache",
        extensions: ["m4v"]
      },
      "video/x-matroska": {
        source: "apache",
        compressible: false,
        extensions: ["mkv", "mk3d", "mks"]
      },
      "video/x-mng": {
        source: "apache",
        extensions: ["mng"]
      },
      "video/x-ms-asf": {
        source: "apache",
        extensions: ["asf", "asx"]
      },
      "video/x-ms-vob": {
        source: "apache",
        extensions: ["vob"]
      },
      "video/x-ms-wm": {
        source: "apache",
        extensions: ["wm"]
      },
      "video/x-ms-wmv": {
        source: "apache",
        compressible: false,
        extensions: ["wmv"]
      },
      "video/x-ms-wmx": {
        source: "apache",
        extensions: ["wmx"]
      },
      "video/x-ms-wvx": {
        source: "apache",
        extensions: ["wvx"]
      },
      "video/x-msvideo": {
        source: "apache",
        extensions: ["avi"]
      },
      "video/x-sgi-movie": {
        source: "apache",
        extensions: ["movie"]
      },
      "video/x-smv": {
        source: "apache",
        extensions: ["smv"]
      },
      "x-conference/x-cooltalk": {
        source: "apache",
        extensions: ["ice"]
      },
      "x-shader/x-fragment": {
        compressible: true
      },
      "x-shader/x-vertex": {
        compressible: true
      }
    };
  }
});

// node_modules/mime-db/index.js
var require_mime_db = __commonJS({
  "node_modules/mime-db/index.js"(exports2, module2) {
    module2.exports = require_db();
  }
});

// node_modules/es-mime-types/dist/index.js
function populateMaps(extensions2, types2) {
  const preference = ["nginx", "apache", void 0, "iana"];
  Object.keys(import_mime_db.default).forEach((type) => {
    const mime = import_mime_db.default[type];
    const exts = mime.extensions;
    if (!exts || !exts.length) {
      return;
    }
    extensions2[type] = exts;
    for (const extension of exts) {
      if (types2[extension]) {
        const from = preference.indexOf(import_mime_db.default[types2[extension]].source);
        const to = preference.indexOf(mime.source);
        if (types2[extension] !== "application/octet-stream" && (from > to || from === to && types2[extension].substr(0, 12) === "application/")) {
          continue;
        }
      }
      types2[extension] = type;
    }
  });
}
function charset(type) {
  if (!type || typeof type !== "string") {
    return false;
  }
  const match = EXTRACT_TYPE_REGEXP.exec(type);
  const mime = match && import_mime_db.default[match[1].toLowerCase()];
  if (mime && mime.charset) {
    return mime.charset;
  }
  if (match && TEXT_TYPE_REGEXP.test(match[1])) {
    return "UTF-8";
  }
  return false;
}
function contentType(str) {
  if (!str || typeof str !== "string") {
    return false;
  }
  let mime = str.indexOf("/") === -1 ? lookup(str) : str;
  if (!mime) {
    return false;
  }
  if (mime.indexOf("charset") === -1) {
    const ch = charset(mime);
    if (ch)
      mime += "; charset=" + ch.toLowerCase();
  }
  return mime;
}
function lookup(path3) {
  if (!path3 || typeof path3 !== "string") {
    return false;
  }
  const extension = (0, import_path.extname)("x." + path3).toLowerCase().substr(1);
  if (!extension) {
    return false;
  }
  return types[extension] || false;
}
var import_mime_db, import_path, EXTRACT_TYPE_REGEXP, TEXT_TYPE_REGEXP, extensions, types;
var init_dist5 = __esm({
  "node_modules/es-mime-types/dist/index.js"() {
    import_mime_db = __toESM(require_mime_db(), 1);
    import_path = require("path");
    EXTRACT_TYPE_REGEXP = /^\s*([^;\s]*)(?:;|\s|$)/;
    TEXT_TYPE_REGEXP = /^text\//i;
    extensions = /* @__PURE__ */ Object.create(null);
    types = /* @__PURE__ */ Object.create(null);
    populateMaps(extensions, types);
  }
});

// node_modules/es-content-type/dist/index.js
function qstring(val) {
  const str = String(val);
  if (TOKEN_REGEXP.test(str))
    return str;
  if (str.length > 0 && !TEXT_REGEXP.test(str))
    throw new TypeError("invalid parameter value");
  return '"' + str.replace(QUOTE_REGEXP, "\\$1") + '"';
}
function getcontenttype(obj) {
  let header;
  if (obj instanceof import_http.ServerResponse && typeof obj.getHeader === "function") {
    header = obj.getHeader("content-type");
  } else if (obj instanceof import_http.IncomingMessage && typeof obj.headers === "object") {
    const h = obj.headers;
    header = h && h["content-type"];
  }
  if (typeof header !== "string") {
    throw new TypeError("content-type header is missing from object");
  }
  return header;
}
function format(obj) {
  if (!obj || typeof obj !== "object")
    throw new TypeError("argument obj is required");
  const { parameters, type } = obj;
  if (!type || !TYPE_REGEXP.test(type))
    throw new TypeError("invalid type");
  let string = type;
  if (parameters && typeof parameters == "object") {
    const params = Object.keys(parameters).sort();
    for (const param of params) {
      if (!TOKEN_REGEXP.test(param))
        throw new TypeError("invalid parameter name");
      string += "; " + param + "=" + qstring(parameters[param]);
    }
  }
  return string;
}
function parse2(string) {
  if (!string)
    throw new TypeError("argument string is required");
  const header = typeof string == "object" ? getcontenttype(string) : string;
  if (typeof header !== "string")
    throw new TypeError("argument string is required to be a string");
  let index = header.indexOf(";");
  const type = index != -1 ? header.substr(0, index).trim() : header.trim();
  if (!TYPE_REGEXP.test(type))
    throw new TypeError("invalid media type");
  const obj = new ContentType(type.toLowerCase());
  if (index != -1) {
    let key;
    let match;
    let value;
    PARAM_REGEXP.lastIndex = index;
    while (match = PARAM_REGEXP.exec(header)) {
      if (match.index !== index)
        throw new TypeError("invalid parameter format");
      index += match[0].length;
      key = match[1].toLowerCase();
      value = match[2];
      if (value[0] == '"') {
        value = value.substr(1, value.length - 2).replace(QESC_REGEXP, "$1");
      }
      obj.parameters[key] = value;
    }
    if (index != header.length)
      throw new TypeError("invalid parameter format");
  }
  return obj;
}
var import_http, PARAM_REGEXP, TEXT_REGEXP, TOKEN_REGEXP, QESC_REGEXP, QUOTE_REGEXP, TYPE_REGEXP, ContentType;
var init_dist6 = __esm({
  "node_modules/es-content-type/dist/index.js"() {
    import_http = require("http");
    PARAM_REGEXP = /; *([!#$%&'*+.^_`|~0-9A-Za-z-]+) *= *("(?:[\u000b\u0020\u0021\u0023-\u005b\u005d-\u007e\u0080-\u00ff]|\\[\u000b\u0020-\u00ff])*"|[!#$%&'*+.^_`|~0-9A-Za-z-]+) */g;
    TEXT_REGEXP = /^[\u000b\u0020-\u007e\u0080-\u00ff]+$/;
    TOKEN_REGEXP = /^[!#$%&'*+.^_`|~0-9A-Za-z-]+$/;
    QESC_REGEXP = /\\([\u000b\u0020-\u00ff])/g;
    QUOTE_REGEXP = /([\\"])/g;
    TYPE_REGEXP = /^[!#$%&'*+.^_`|~0-9A-Za-z-]+\/[!#$%&'*+.^_`|~0-9A-Za-z-]+$/;
    ContentType = class {
      constructor(type) {
        this.parameters = {};
        this.type = type;
      }
    };
  }
});

// node_modules/@tinyhttp/type-is/dist/index.js
var init_dist7 = __esm({
  "node_modules/@tinyhttp/type-is/dist/index.js"() {
    init_dist5();
    init_dist6();
  }
});

// node_modules/negotiator/lib/charset.js
var require_charset = __commonJS({
  "node_modules/negotiator/lib/charset.js"(exports2, module2) {
    "use strict";
    module2.exports = preferredCharsets;
    module2.exports.preferredCharsets = preferredCharsets;
    var simpleCharsetRegExp = /^\s*([^\s;]+)\s*(?:;(.*))?$/;
    function parseAcceptCharset(accept) {
      var accepts = accept.split(",");
      for (var i = 0, j = 0; i < accepts.length; i++) {
        var charset2 = parseCharset(accepts[i].trim(), i);
        if (charset2) {
          accepts[j++] = charset2;
        }
      }
      accepts.length = j;
      return accepts;
    }
    function parseCharset(str, i) {
      var match = simpleCharsetRegExp.exec(str);
      if (!match)
        return null;
      var charset2 = match[1];
      var q2 = 1;
      if (match[2]) {
        var params = match[2].split(";");
        for (var j = 0; j < params.length; j++) {
          var p3 = params[j].trim().split("=");
          if (p3[0] === "q") {
            q2 = parseFloat(p3[1]);
            break;
          }
        }
      }
      return {
        charset: charset2,
        q: q2,
        i
      };
    }
    function getCharsetPriority(charset2, accepted, index) {
      var priority = { o: -1, q: 0, s: 0 };
      for (var i = 0; i < accepted.length; i++) {
        var spec = specify(charset2, accepted[i], index);
        if (spec && (priority.s - spec.s || priority.q - spec.q || priority.o - spec.o) < 0) {
          priority = spec;
        }
      }
      return priority;
    }
    function specify(charset2, spec, index) {
      var s = 0;
      if (spec.charset.toLowerCase() === charset2.toLowerCase()) {
        s |= 1;
      } else if (spec.charset !== "*") {
        return null;
      }
      return {
        i: index,
        o: spec.i,
        q: spec.q,
        s
      };
    }
    function preferredCharsets(accept, provided) {
      var accepts = parseAcceptCharset(accept === void 0 ? "*" : accept || "");
      if (!provided) {
        return accepts.filter(isQuality).sort(compareSpecs).map(getFullCharset);
      }
      var priorities = provided.map(function getPriority(type, index) {
        return getCharsetPriority(type, accepts, index);
      });
      return priorities.filter(isQuality).sort(compareSpecs).map(function getCharset(priority) {
        return provided[priorities.indexOf(priority)];
      });
    }
    function compareSpecs(a, b) {
      return b.q - a.q || b.s - a.s || a.o - b.o || a.i - b.i || 0;
    }
    function getFullCharset(spec) {
      return spec.charset;
    }
    function isQuality(spec) {
      return spec.q > 0;
    }
  }
});

// node_modules/negotiator/lib/encoding.js
var require_encoding = __commonJS({
  "node_modules/negotiator/lib/encoding.js"(exports2, module2) {
    "use strict";
    module2.exports = preferredEncodings;
    module2.exports.preferredEncodings = preferredEncodings;
    var simpleEncodingRegExp = /^\s*([^\s;]+)\s*(?:;(.*))?$/;
    function parseAcceptEncoding(accept) {
      var accepts = accept.split(",");
      var hasIdentity = false;
      var minQuality = 1;
      for (var i = 0, j = 0; i < accepts.length; i++) {
        var encoding = parseEncoding(accepts[i].trim(), i);
        if (encoding) {
          accepts[j++] = encoding;
          hasIdentity = hasIdentity || specify("identity", encoding);
          minQuality = Math.min(minQuality, encoding.q || 1);
        }
      }
      if (!hasIdentity) {
        accepts[j++] = {
          encoding: "identity",
          q: minQuality,
          i
        };
      }
      accepts.length = j;
      return accepts;
    }
    function parseEncoding(str, i) {
      var match = simpleEncodingRegExp.exec(str);
      if (!match)
        return null;
      var encoding = match[1];
      var q2 = 1;
      if (match[2]) {
        var params = match[2].split(";");
        for (var j = 0; j < params.length; j++) {
          var p3 = params[j].trim().split("=");
          if (p3[0] === "q") {
            q2 = parseFloat(p3[1]);
            break;
          }
        }
      }
      return {
        encoding,
        q: q2,
        i
      };
    }
    function getEncodingPriority(encoding, accepted, index) {
      var priority = { o: -1, q: 0, s: 0 };
      for (var i = 0; i < accepted.length; i++) {
        var spec = specify(encoding, accepted[i], index);
        if (spec && (priority.s - spec.s || priority.q - spec.q || priority.o - spec.o) < 0) {
          priority = spec;
        }
      }
      return priority;
    }
    function specify(encoding, spec, index) {
      var s = 0;
      if (spec.encoding.toLowerCase() === encoding.toLowerCase()) {
        s |= 1;
      } else if (spec.encoding !== "*") {
        return null;
      }
      return {
        i: index,
        o: spec.i,
        q: spec.q,
        s
      };
    }
    function preferredEncodings(accept, provided) {
      var accepts = parseAcceptEncoding(accept || "");
      if (!provided) {
        return accepts.filter(isQuality).sort(compareSpecs).map(getFullEncoding);
      }
      var priorities = provided.map(function getPriority(type, index) {
        return getEncodingPriority(type, accepts, index);
      });
      return priorities.filter(isQuality).sort(compareSpecs).map(function getEncoding(priority) {
        return provided[priorities.indexOf(priority)];
      });
    }
    function compareSpecs(a, b) {
      return b.q - a.q || b.s - a.s || a.o - b.o || a.i - b.i || 0;
    }
    function getFullEncoding(spec) {
      return spec.encoding;
    }
    function isQuality(spec) {
      return spec.q > 0;
    }
  }
});

// node_modules/negotiator/lib/language.js
var require_language = __commonJS({
  "node_modules/negotiator/lib/language.js"(exports2, module2) {
    "use strict";
    module2.exports = preferredLanguages;
    module2.exports.preferredLanguages = preferredLanguages;
    var simpleLanguageRegExp = /^\s*([^\s\-;]+)(?:-([^\s;]+))?\s*(?:;(.*))?$/;
    function parseAcceptLanguage(accept) {
      var accepts = accept.split(",");
      for (var i = 0, j = 0; i < accepts.length; i++) {
        var language = parseLanguage(accepts[i].trim(), i);
        if (language) {
          accepts[j++] = language;
        }
      }
      accepts.length = j;
      return accepts;
    }
    function parseLanguage(str, i) {
      var match = simpleLanguageRegExp.exec(str);
      if (!match)
        return null;
      var prefix = match[1];
      var suffix = match[2];
      var full = prefix;
      if (suffix)
        full += "-" + suffix;
      var q2 = 1;
      if (match[3]) {
        var params = match[3].split(";");
        for (var j = 0; j < params.length; j++) {
          var p3 = params[j].split("=");
          if (p3[0] === "q")
            q2 = parseFloat(p3[1]);
        }
      }
      return {
        prefix,
        suffix,
        q: q2,
        i,
        full
      };
    }
    function getLanguagePriority(language, accepted, index) {
      var priority = { o: -1, q: 0, s: 0 };
      for (var i = 0; i < accepted.length; i++) {
        var spec = specify(language, accepted[i], index);
        if (spec && (priority.s - spec.s || priority.q - spec.q || priority.o - spec.o) < 0) {
          priority = spec;
        }
      }
      return priority;
    }
    function specify(language, spec, index) {
      var p3 = parseLanguage(language);
      if (!p3)
        return null;
      var s = 0;
      if (spec.full.toLowerCase() === p3.full.toLowerCase()) {
        s |= 4;
      } else if (spec.prefix.toLowerCase() === p3.full.toLowerCase()) {
        s |= 2;
      } else if (spec.full.toLowerCase() === p3.prefix.toLowerCase()) {
        s |= 1;
      } else if (spec.full !== "*") {
        return null;
      }
      return {
        i: index,
        o: spec.i,
        q: spec.q,
        s
      };
    }
    function preferredLanguages(accept, provided) {
      var accepts = parseAcceptLanguage(accept === void 0 ? "*" : accept || "");
      if (!provided) {
        return accepts.filter(isQuality).sort(compareSpecs).map(getFullLanguage);
      }
      var priorities = provided.map(function getPriority(type, index) {
        return getLanguagePriority(type, accepts, index);
      });
      return priorities.filter(isQuality).sort(compareSpecs).map(function getLanguage(priority) {
        return provided[priorities.indexOf(priority)];
      });
    }
    function compareSpecs(a, b) {
      return b.q - a.q || b.s - a.s || a.o - b.o || a.i - b.i || 0;
    }
    function getFullLanguage(spec) {
      return spec.full;
    }
    function isQuality(spec) {
      return spec.q > 0;
    }
  }
});

// node_modules/negotiator/lib/mediaType.js
var require_mediaType = __commonJS({
  "node_modules/negotiator/lib/mediaType.js"(exports2, module2) {
    "use strict";
    module2.exports = preferredMediaTypes;
    module2.exports.preferredMediaTypes = preferredMediaTypes;
    var simpleMediaTypeRegExp = /^\s*([^\s\/;]+)\/([^;\s]+)\s*(?:;(.*))?$/;
    function parseAccept(accept) {
      var accepts = splitMediaTypes(accept);
      for (var i = 0, j = 0; i < accepts.length; i++) {
        var mediaType = parseMediaType(accepts[i].trim(), i);
        if (mediaType) {
          accepts[j++] = mediaType;
        }
      }
      accepts.length = j;
      return accepts;
    }
    function parseMediaType(str, i) {
      var match = simpleMediaTypeRegExp.exec(str);
      if (!match)
        return null;
      var params = /* @__PURE__ */ Object.create(null);
      var q2 = 1;
      var subtype = match[2];
      var type = match[1];
      if (match[3]) {
        var kvps = splitParameters(match[3]).map(splitKeyValuePair);
        for (var j = 0; j < kvps.length; j++) {
          var pair = kvps[j];
          var key = pair[0].toLowerCase();
          var val = pair[1];
          var value = val && val[0] === '"' && val[val.length - 1] === '"' ? val.substr(1, val.length - 2) : val;
          if (key === "q") {
            q2 = parseFloat(value);
            break;
          }
          params[key] = value;
        }
      }
      return {
        type,
        subtype,
        params,
        q: q2,
        i
      };
    }
    function getMediaTypePriority(type, accepted, index) {
      var priority = { o: -1, q: 0, s: 0 };
      for (var i = 0; i < accepted.length; i++) {
        var spec = specify(type, accepted[i], index);
        if (spec && (priority.s - spec.s || priority.q - spec.q || priority.o - spec.o) < 0) {
          priority = spec;
        }
      }
      return priority;
    }
    function specify(type, spec, index) {
      var p3 = parseMediaType(type);
      var s = 0;
      if (!p3) {
        return null;
      }
      if (spec.type.toLowerCase() == p3.type.toLowerCase()) {
        s |= 4;
      } else if (spec.type != "*") {
        return null;
      }
      if (spec.subtype.toLowerCase() == p3.subtype.toLowerCase()) {
        s |= 2;
      } else if (spec.subtype != "*") {
        return null;
      }
      var keys = Object.keys(spec.params);
      if (keys.length > 0) {
        if (keys.every(function(k) {
          return spec.params[k] == "*" || (spec.params[k] || "").toLowerCase() == (p3.params[k] || "").toLowerCase();
        })) {
          s |= 1;
        } else {
          return null;
        }
      }
      return {
        i: index,
        o: spec.i,
        q: spec.q,
        s
      };
    }
    function preferredMediaTypes(accept, provided) {
      var accepts = parseAccept(accept === void 0 ? "*/*" : accept || "");
      if (!provided) {
        return accepts.filter(isQuality).sort(compareSpecs).map(getFullType);
      }
      var priorities = provided.map(function getPriority(type, index) {
        return getMediaTypePriority(type, accepts, index);
      });
      return priorities.filter(isQuality).sort(compareSpecs).map(function getType(priority) {
        return provided[priorities.indexOf(priority)];
      });
    }
    function compareSpecs(a, b) {
      return b.q - a.q || b.s - a.s || a.o - b.o || a.i - b.i || 0;
    }
    function getFullType(spec) {
      return spec.type + "/" + spec.subtype;
    }
    function isQuality(spec) {
      return spec.q > 0;
    }
    function quoteCount(string) {
      var count = 0;
      var index = 0;
      while ((index = string.indexOf('"', index)) !== -1) {
        count++;
        index++;
      }
      return count;
    }
    function splitKeyValuePair(str) {
      var index = str.indexOf("=");
      var key;
      var val;
      if (index === -1) {
        key = str;
      } else {
        key = str.substr(0, index);
        val = str.substr(index + 1);
      }
      return [key, val];
    }
    function splitMediaTypes(accept) {
      var accepts = accept.split(",");
      for (var i = 1, j = 0; i < accepts.length; i++) {
        if (quoteCount(accepts[j]) % 2 == 0) {
          accepts[++j] = accepts[i];
        } else {
          accepts[j] += "," + accepts[i];
        }
      }
      accepts.length = j + 1;
      return accepts;
    }
    function splitParameters(str) {
      var parameters = str.split(";");
      for (var i = 1, j = 0; i < parameters.length; i++) {
        if (quoteCount(parameters[j]) % 2 == 0) {
          parameters[++j] = parameters[i];
        } else {
          parameters[j] += ";" + parameters[i];
        }
      }
      parameters.length = j + 1;
      for (var i = 0; i < parameters.length; i++) {
        parameters[i] = parameters[i].trim();
      }
      return parameters;
    }
  }
});

// node_modules/negotiator/index.js
var require_negotiator = __commonJS({
  "node_modules/negotiator/index.js"(exports2, module2) {
    "use strict";
    var preferredCharsets = require_charset();
    var preferredEncodings = require_encoding();
    var preferredLanguages = require_language();
    var preferredMediaTypes = require_mediaType();
    module2.exports = Negotiator2;
    module2.exports.Negotiator = Negotiator2;
    function Negotiator2(request) {
      if (!(this instanceof Negotiator2)) {
        return new Negotiator2(request);
      }
      this.request = request;
    }
    Negotiator2.prototype.charset = function charset2(available) {
      var set = this.charsets(available);
      return set && set[0];
    };
    Negotiator2.prototype.charsets = function charsets(available) {
      return preferredCharsets(this.request.headers["accept-charset"], available);
    };
    Negotiator2.prototype.encoding = function encoding(available) {
      var set = this.encodings(available);
      return set && set[0];
    };
    Negotiator2.prototype.encodings = function encodings(available) {
      return preferredEncodings(this.request.headers["accept-encoding"], available);
    };
    Negotiator2.prototype.language = function language(available) {
      var set = this.languages(available);
      return set && set[0];
    };
    Negotiator2.prototype.languages = function languages(available) {
      return preferredLanguages(this.request.headers["accept-language"], available);
    };
    Negotiator2.prototype.mediaType = function mediaType(available) {
      var set = this.mediaTypes(available);
      return set && set[0];
    };
    Negotiator2.prototype.mediaTypes = function mediaTypes(available) {
      return preferredMediaTypes(this.request.headers.accept, available);
    };
    Negotiator2.prototype.preferredCharset = Negotiator2.prototype.charset;
    Negotiator2.prototype.preferredCharsets = Negotiator2.prototype.charsets;
    Negotiator2.prototype.preferredEncoding = Negotiator2.prototype.encoding;
    Negotiator2.prototype.preferredEncodings = Negotiator2.prototype.encodings;
    Negotiator2.prototype.preferredLanguage = Negotiator2.prototype.language;
    Negotiator2.prototype.preferredLanguages = Negotiator2.prototype.languages;
    Negotiator2.prototype.preferredMediaType = Negotiator2.prototype.mediaType;
    Negotiator2.prototype.preferredMediaTypes = Negotiator2.prototype.mediaTypes;
  }
});

// node_modules/@tinyhttp/accepts/dist/index.js
var import_negotiator, extToMime, validMime, Accepts;
var init_dist8 = __esm({
  "node_modules/@tinyhttp/accepts/dist/index.js"() {
    import_negotiator = __toESM(require_negotiator(), 1);
    init_dist5();
    extToMime = (type) => type.indexOf("/") == -1 ? lookup(type) : type;
    validMime = (type) => typeof type == "string";
    Accepts = class {
      constructor(req) {
        this.headers = req.headers;
        this.negotiator = new import_negotiator.default(req);
      }
      /**
       * Check if the given `type(s)` is acceptable, returning the best match when true, otherwise `false`, in which case you should respond with 406 "Not Acceptable".
       *
       * The `type` value may be a single mime type string such as "application/json", the extension name such as "json" or an array `["json", "html", "text/plain"]`. When a list or array is given the _best_ match, if any is returned. When no types are given as arguments, returns all types accepted by the client in the preference order.
       */
      types(types2, ...args) {
        let mimeTypes = [];
        if (types2 && !Array.isArray(types2)) {
          mimeTypes = [types2, ...args];
        } else if (types2) {
          mimeTypes = [...types2, ...args];
        }
        if (!mimeTypes || mimeTypes.length == 0) {
          return this.negotiator.mediaTypes();
        }
        if (!this.headers["accept"]) {
          return mimeTypes[0];
        }
        const mimes = mimeTypes.map(extToMime);
        const accepts = this.negotiator.mediaTypes(mimes.filter(validMime));
        const [first] = accepts;
        return first ? mimeTypes[mimes.indexOf(first)] : false;
      }
      get type() {
        return this.types;
      }
      /**
       * Return accepted encodings or best fit based on `encodings`.
       *
       * Given `Accept-Encoding: gzip, deflate`
       * an array sorted by quality is returned:
       *
       *     ['gzip', 'deflate']
       */
      encodings(encodings, ...args) {
        let _encodings = encodings;
        if (_encodings && !Array.isArray(_encodings)) {
          _encodings = [_encodings, ...args];
        }
        if (!_encodings || _encodings.length == 0) {
          return this.negotiator.encodings();
        }
        return this.negotiator.encodings(_encodings)[0] || false;
      }
      get encoding() {
        return this.encodings;
      }
      /**
       * Return accepted charsets or best fit based on `charsets`.
       *
       * Given `Accept-Charset: utf-8, iso-8859-1;q=0.2, utf-7;q=0.5`
       * an array sorted by quality is returned:
       *
       *     ['utf-8', 'utf-7', 'iso-8859-1']
       */
      charsets(charsets, ...args) {
        let _charsets = charsets;
        if (_charsets && !Array.isArray(_charsets)) {
          _charsets = [_charsets, ...args];
        }
        if (!_charsets || _charsets.length == 0) {
          return this.negotiator.charsets();
        }
        return this.negotiator.charsets(_charsets)[0] || false;
      }
      get charset() {
        return this.charsets;
      }
      /**
       * Return accepted languages or best fit based on `langs`.
       *
       * Given `Accept-Language: en;q=0.8, es, pt`
       * an array sorted by quality is returned:
       *
       *     ['es', 'pt', 'en']
       *
       */
      languages(languages, ...args) {
        let _languages = languages;
        if (_languages && !Array.isArray(_languages)) {
          _languages = [_languages, ...args];
        }
        if (!_languages || _languages.length == 0) {
          return this.negotiator.languages();
        }
        return this.negotiator.languages(_languages)[0] || false;
      }
      get lang() {
        return this.languages;
      }
      get langs() {
        return this.languages;
      }
      get language() {
        return this.languages;
      }
    };
  }
});

// node_modules/@tinyhttp/url/dist/index.js
var import_querystring, getURLParams, getQueryIndex, getPathname, getQueryParams;
var init_dist9 = __esm({
  "node_modules/@tinyhttp/url/dist/index.js"() {
    import_querystring = require("querystring");
    getURLParams = ({ pattern, keys }, reqUrl = "/") => {
      const matches = pattern.exec(reqUrl);
      const params = {};
      if (matches && typeof keys !== "boolean")
        for (let i = 0; i < keys.length; i++) {
          if (matches[i + 1]) {
            params[keys[i]] = decodeURIComponent(matches[i + 1]);
          }
        }
      return params;
    };
    getQueryIndex = (url) => {
      const index = url.indexOf("?");
      return index === -1 ? url.length : index;
    };
    getPathname = (url) => url.slice(0, getQueryIndex(url));
    getQueryParams = (url = "/") => (0, import_querystring.parse)(url.slice(getQueryIndex(url) + 1));
  }
});

// node_modules/@tinyhttp/req/dist/index.js
var getAccepts, getAcceptsEncodings, getAcceptsCharsets, getAcceptsLanguages, getRequestHeader, getRangeFromHeader, getFreshOrStale, checkIfXMLHttpRequest;
var init_dist10 = __esm({
  "node_modules/@tinyhttp/req/dist/index.js"() {
    init_dist3();
    init_dist4();
    init_dist7();
    init_dist8();
    init_dist9();
    getAccepts = (req) => (...types2) => new Accepts(req).types(types2);
    getAcceptsEncodings = (req) => (...encodings) => new Accepts(req).encodings(encodings);
    getAcceptsCharsets = (req) => (...charsets) => new Accepts(req).charsets(charsets);
    getAcceptsLanguages = (req) => (...languages) => new Accepts(req).languages(languages);
    getRequestHeader = (req) => (header) => {
      const lc = header.toLowerCase();
      switch (lc) {
        case "referer":
        case "referrer":
          return req.headers.referrer || req.headers.referer;
        default:
          return req.headers[lc];
      }
    };
    getRangeFromHeader = (req) => (size, options) => {
      const range = getRequestHeader(req)("Range");
      if (!range)
        return;
      return x(size, range, options);
    };
    getFreshOrStale = (req, res) => {
      const method = req.method;
      const status2 = res.statusCode;
      if (method !== "GET" && method !== "HEAD")
        return false;
      if (status2 >= 200 && status2 < 300 || status2 === 304) {
        return fresh(req.headers, {
          etag: res.getHeader("ETag"),
          "last-modified": res.getHeader("Last-Modified")
        });
      }
      return false;
    };
    checkIfXMLHttpRequest = (req) => req.headers["X-Requested-With"] === "XMLHttpRequest";
  }
});

// node_modules/@tinyhttp/router/dist/index.js
var METHODS, createMiddlewareFromRoute, pushMiddleware, Router;
var init_dist11 = __esm({
  "node_modules/@tinyhttp/router/dist/index.js"() {
    METHODS = [
      "ACL",
      "BIND",
      "CHECKOUT",
      "CONNECT",
      "COPY",
      "DELETE",
      "GET",
      "HEAD",
      "LINK",
      "LOCK",
      "M-SEARCH",
      "MERGE",
      "MKACTIVITY",
      "MKCALENDAR",
      "MKCOL",
      "MOVE",
      "NOTIFY",
      "OPTIONS",
      "PATCH",
      "POST",
      "PRI",
      "PROPFIND",
      "PROPPATCH",
      "PURGE",
      "PUT",
      "REBIND",
      "REPORT",
      "SEARCH",
      "SOURCE",
      "SUBSCRIBE",
      "TRACE",
      "UNBIND",
      "UNLINK",
      "UNLOCK",
      "UNSUBSCRIBE"
    ];
    createMiddlewareFromRoute = ({ path: path3, handler, fullPath, method }) => ({
      method,
      handler: handler || path3,
      path: typeof path3 === "string" ? path3 : "/",
      fullPath: typeof path3 === "string" ? fullPath : path3
    });
    pushMiddleware = (mw) => ({ path: path3, handler, method, handlers, type, fullPaths }) => {
      const m2 = createMiddlewareFromRoute({ path: path3, handler, method, type, fullPath: fullPaths === null || fullPaths === void 0 ? void 0 : fullPaths[0] });
      let waresFromHandlers = [];
      let idx = 1;
      if (handlers) {
        waresFromHandlers = handlers.flat().map((handler2) => createMiddlewareFromRoute({
          path: path3,
          handler: handler2,
          method,
          type,
          fullPath: fullPaths == null ? null : fullPaths[idx++]
        }));
      }
      for (const mdw of [m2, ...waresFromHandlers])
        mw.push({ ...mdw, type });
    };
    Router = class {
      constructor() {
        this.middleware = [];
        this.mountpath = "/";
        this.apps = {};
        for (const m2 of METHODS) {
          this[m2.toLowerCase()] = this.add(m2);
        }
      }
      add(method) {
        return (...args) => {
          const handlers = args.slice(1).flat();
          pushMiddleware(this.middleware)({
            path: args[0],
            handler: handlers[0],
            handlers: handlers.slice(1),
            method,
            type: "route"
          });
          return this;
        };
      }
      msearch(...args) {
        const handlers = args.slice(1).flat();
        pushMiddleware(this.middleware)({
          path: args[0],
          handler: handlers[0],
          handlers: handlers.slice(1),
          method: "M-SEARCH",
          type: "route"
        });
        return this;
      }
      all(...args) {
        const handlers = args.slice(1).flat();
        pushMiddleware(this.middleware)({
          path: args[0],
          handler: handlers[0],
          handlers: handlers.slice(1),
          type: "route"
        });
        return this;
      }
      /**
       * Return the app's absolute pathname
       * based on the parent(s) that have
       * mounted it.
       *
       * For example if the application was
       * mounted as `"/admin"`, which itself
       * was mounted as `"/blog"` then the
       * return value would be `"/blog/admin"`.
       *
       */
      path() {
        return this.parent ? this.parent.path() + this.mountpath : "";
      }
      /**
       * Push middleware to the stack
       */
      use(...args) {
        const base = args[0];
        const handlers = args.slice(1).flat();
        if (typeof base === "string") {
          pushMiddleware(this.middleware)({
            path: base,
            handler: handlers[0],
            handlers: handlers.slice(1),
            type: "mw"
          });
        } else {
          pushMiddleware(this.middleware)({
            path: "/",
            handler: Array.isArray(base) ? base[0] : base,
            handlers: Array.isArray(base) ? [...base.slice(1), ...handlers] : handlers,
            type: "mw"
          });
        }
        return this;
      }
    };
  }
});

// node_modules/@tinyhttp/etag/dist/index.js
var import_crypto, import_fs, entityTag, statTag, eTag;
var init_dist12 = __esm({
  "node_modules/@tinyhttp/etag/dist/index.js"() {
    import_crypto = require("crypto");
    import_fs = require("fs");
    entityTag = (entity) => {
      if (entity.length === 0) {
        return '"0-2jmj7l5rSw0yVb/vlWAYkK/YBwk"';
      } else {
        const hash = (0, import_crypto.createHash)("sha1").update(entity, "utf8").digest("base64").substring(0, 27);
        const len = typeof entity === "string" ? Buffer.byteLength(entity, "utf8") : entity.length;
        return '"' + len.toString(16) + "-" + hash + '"';
      }
    };
    statTag = ({ mtime, size }) => {
      return '"' + mtime.getTime().toString(16) + "-" + size.toString(16) + '"';
    };
    eTag = (entity, options) => {
      if (entity == null)
        throw new TypeError("argument entity is required");
      const weak = (options === null || options === void 0 ? void 0 : options.weak) || entity instanceof import_fs.Stats;
      const tag = entity instanceof import_fs.Stats ? statTag(entity) : entityTag(entity);
      return weak ? "W/" + tag : tag;
    };
  }
});

// node_modules/@tinyhttp/send/dist/index.js
function setCharset(type, charset2) {
  const parsed = parse2(type);
  parsed.parameters.charset = charset2;
  return format(parsed);
}
var import_fs2, import_http2, import_path2, json, createETag, send, sendStatus, status, enableCaching, sendFile;
var init_dist13 = __esm({
  "node_modules/@tinyhttp/send/dist/index.js"() {
    init_dist6();
    init_dist12();
    import_fs2 = require("fs");
    import_http2 = require("http");
    import_path2 = require("path");
    init_dist5();
    json = (res) => (body, ...args) => {
      res.setHeader("Content-Type", "application/json");
      if (typeof body === "object" && body != null)
        res.end(JSON.stringify(body, null, 2), ...args);
      else if (typeof body === "string")
        res.end(body, ...args);
      else if (body == null) {
        res.removeHeader("Content-Length");
        res.removeHeader("Transfer-Encoding");
        res.end(null, ...args);
      }
      return res;
    };
    createETag = (body, encoding) => {
      if (body instanceof import_fs2.Stats) {
        return eTag(body, { weak: true });
      } else {
        return eTag(!Buffer.isBuffer(body) ? Buffer.from(body, encoding) : body, { weak: true });
      }
    };
    send = (req, res) => (body) => {
      let bodyToSend = body;
      if (Buffer.isBuffer(body)) {
        bodyToSend = body;
      } else if (typeof body === "object" && body !== null) {
        bodyToSend = JSON.stringify(body, null, 2);
      } else if (typeof body === "string") {
        const type = res.getHeader("Content-Type");
        if (type && typeof type === "string") {
          res.setHeader("Content-Type", setCharset(type, "utf-8"));
        } else
          res.setHeader("Content-Type", setCharset("text/html", "utf-8"));
      }
      const encoding = "utf8";
      let etag;
      if (body && !res.getHeader("etag") && (etag = createETag(bodyToSend, encoding))) {
        res.setHeader("etag", etag);
      }
      if (req.fresh)
        res.statusCode = 304;
      if (res.statusCode === 204 || res.statusCode === 304) {
        res.removeHeader("Content-Type");
        res.removeHeader("Content-Length");
        res.removeHeader("Transfer-Encoding");
        bodyToSend = "";
      }
      if (req.method === "HEAD") {
        res.end("");
        return res;
      }
      if (typeof body === "object") {
        if (body == null) {
          res.end("");
          return res;
        } else if (Buffer.isBuffer(body)) {
          if (!res.getHeader("Content-Type"))
            res.setHeader("content-type", "application/octet-stream");
          res.end(bodyToSend);
        } else
          json(res)(bodyToSend, encoding);
      } else {
        if (typeof bodyToSend !== "string")
          bodyToSend = bodyToSend.toString();
        res.end(bodyToSend, encoding);
      }
      return res;
    };
    sendStatus = (req, res) => (statusCode) => {
      const body = import_http2.STATUS_CODES[statusCode] || String(statusCode);
      res.statusCode = statusCode;
      res.setHeader("Content-Type", "text/plain");
      return send(req, res)(body);
    };
    status = (res) => (status2) => {
      res.statusCode = status2;
      return res;
    };
    enableCaching = (res, caching) => {
      let cc = caching.maxAge != null && `public,max-age=${caching.maxAge}`;
      if (cc && caching.immutable)
        cc += ",immutable";
      else if (cc && caching.maxAge === 0)
        cc += ",must-revalidate";
      if (cc)
        res.setHeader("Cache-Control", cc);
    };
    sendFile = (req, res) => (path3, opts = {}, cb) => {
      const { root, headers = {}, encoding = "utf-8", caching, ...options } = opts;
      if (!(0, import_path2.isAbsolute)(path3) && !root)
        throw new TypeError("path must be absolute");
      if (caching)
        enableCaching(res, caching);
      const filePath = root ? (0, import_path2.join)(root, path3) : path3;
      const stats = (0, import_fs2.statSync)(filePath);
      headers["Content-Encoding"] = encoding;
      headers["Last-Modified"] = stats.mtime.toUTCString();
      headers["Content-Type"] = contentType((0, import_path2.extname)(path3));
      headers["ETag"] = createETag(stats, encoding);
      let status2 = res.statusCode || 200;
      if (req.headers["range"]) {
        status2 = 206;
        const [x2, y] = req.headers.range.replace("bytes=", "").split("-");
        const end = options.end = parseInt(y, 10) || stats.size - 1;
        const start = options.start = parseInt(x2, 10) || 0;
        if (start >= stats.size || end >= stats.size) {
          res.writeHead(416, {
            "Content-Range": `bytes */${stats.size}`
          }).end();
          return res;
        }
        headers["Content-Range"] = `bytes ${start}-${end}/${stats.size}`;
        headers["Content-Length"] = end - start + 1;
        headers["Accept-Ranges"] = "bytes";
      } else {
        headers["Content-Length"] = stats.size;
      }
      for (const [k, v] of Object.entries(headers))
        res.setHeader(k, v);
      res.writeHead(status2, headers);
      const stream = (0, import_fs2.createReadStream)(filePath, options);
      if (cb)
        stream.on("error", (err) => cb(err)).on("end", () => cb());
      stream.pipe(res);
      return res;
    };
  }
});

// node_modules/@tinyhttp/cookie/dist/index.js
function serialize(name, val, opt = {}) {
  if (!opt.encode)
    opt.encode = encodeURIComponent;
  if (!fieldContentRegExp.test(name))
    throw new TypeError("argument name is invalid");
  const value = opt.encode(val);
  if (value && !fieldContentRegExp.test(value))
    throw new TypeError("argument val is invalid");
  let str = name + "=" + value;
  if (null != opt.maxAge) {
    const maxAge = opt.maxAge - 0;
    if (isNaN(maxAge) || !isFinite(maxAge))
      throw new TypeError("option maxAge is invalid");
    str += "; Max-Age=" + Math.floor(maxAge);
  }
  if (opt.domain) {
    if (!fieldContentRegExp.test(opt.domain))
      throw new TypeError("option domain is invalid");
    str += "; Domain=" + opt.domain;
  }
  if (opt.path) {
    if (!fieldContentRegExp.test(opt.path))
      throw new TypeError("option path is invalid");
    str += "; Path=" + opt.path;
  }
  if (opt.expires)
    str += "; Expires=" + opt.expires.toUTCString();
  if (opt.httpOnly)
    str += "; HttpOnly";
  if (opt.secure)
    str += "; Secure";
  if (opt.sameSite) {
    const sameSite = typeof opt.sameSite === "string" ? opt.sameSite.toLowerCase() : opt.sameSite;
    switch (sameSite) {
      case true:
      case "strict":
        str += "; SameSite=Strict";
        break;
      case "lax":
        str += "; SameSite=Lax";
        break;
      case "none":
        str += "; SameSite=None";
        break;
      default:
        throw new TypeError("option sameSite is invalid");
    }
  }
  return str;
}
var fieldContentRegExp;
var init_dist14 = __esm({
  "node_modules/@tinyhttp/cookie/dist/index.js"() {
    fieldContentRegExp = /^[\u0009\u0020-\u007e\u0080-\u00ff]+$/;
  }
});

// node_modules/@tinyhttp/cookie-signature/dist/index.js
var import_crypto2, sign;
var init_dist15 = __esm({
  "node_modules/@tinyhttp/cookie-signature/dist/index.js"() {
    import_crypto2 = require("crypto");
    sign = (val, secret) => `${val}.${(0, import_crypto2.createHmac)("sha256", secret).update(val).digest("base64").replace(/=+$/, "")}`;
  }
});

// node_modules/es-vary/dist/index.js
function parse4(header) {
  let end = 0;
  let list = [];
  let start = 0;
  for (var i = 0, len = header.length; i < len; i++) {
    switch (header.charCodeAt(i)) {
      case 32:
        if (start === end) {
          start = end = i + 1;
        }
        break;
      case 44:
        list.push(header.substring(start, end));
        start = end = i + 1;
        break;
      default:
        end = i + 1;
        break;
    }
  }
  list.push(header.substring(start, end));
  return list;
}
function append(header, field) {
  const fields = !Array.isArray(field) ? parse4(String(field)) : field;
  for (const field2 of fields) {
    if (!FIELD_NAME_REGEXP.test(field2))
      throw new TypeError("field argument contains an invalid header name");
  }
  if (header === "*") {
    return header;
  }
  let val = header;
  const vals = parse4(header.toLowerCase());
  if (fields.indexOf("*") !== -1 || vals.indexOf("*") !== -1) {
    return "*";
  }
  for (const field2 of fields) {
    const fld = field2.toLowerCase();
    if (vals.indexOf(fld) === -1) {
      vals.push(fld);
      val = val ? val + ", " + field2 : field2;
    }
  }
  return val;
}
function vary(res, field) {
  let val = res.getHeader("Vary") || "";
  const header = Array.isArray(val) ? val.join(", ") : String(val);
  if (val = append(header, field)) {
    res.setHeader("Vary", val);
  }
}
var FIELD_NAME_REGEXP;
var init_dist16 = __esm({
  "node_modules/es-vary/dist/index.js"() {
    FIELD_NAME_REGEXP = /^[!#$%&'*+\-.^_`|~0-9A-Za-z]+$/;
  }
});

// node_modules/@tinyhttp/encode-url/dist/index.js
var ENCODE_CHARS_REGEXP, UNMATCHED_SURROGATE_PAIR_REGEXP, UNMATCHED_SURROGATE_PAIR_REPLACE, encodeUrl;
var init_dist17 = __esm({
  "node_modules/@tinyhttp/encode-url/dist/index.js"() {
    ENCODE_CHARS_REGEXP = /(?:[^\x21\x25\x26-\x3B\x3D\x3F-\x5B\x5D\x5F\x61-\x7A\x7E]|%(?:[^0-9A-Fa-f]|[0-9A-Fa-f][^0-9A-Fa-f]|$))+/g;
    UNMATCHED_SURROGATE_PAIR_REGEXP = /(^|[^\uD800-\uDBFF])[\uDC00-\uDFFF]|[\uD800-\uDBFF]([^\uDC00-\uDFFF]|$)/g;
    UNMATCHED_SURROGATE_PAIR_REPLACE = "$1\uFFFD$2";
    encodeUrl = (url) => {
      return String(url).replace(UNMATCHED_SURROGATE_PAIR_REGEXP, UNMATCHED_SURROGATE_PAIR_REPLACE).replace(ENCODE_CHARS_REGEXP, encodeURI);
    };
  }
});

// node_modules/es-escape-html/src/index.js
function escapeHTML(str) {
  const match = matchHtmlRegExp.exec(str);
  if (!match) {
    return str;
  }
  let escape2;
  let html = "";
  let index = 0;
  let lastIndex = 0;
  for (index = match.index; index < str.length; index++) {
    switch (str.charCodeAt(index)) {
      case 34:
        escape2 = "&quot;";
        break;
      case 38:
        escape2 = "&amp;";
        break;
      case 39:
        escape2 = "&#39;";
        break;
      case 60:
        escape2 = "&lt;";
        break;
      case 62:
        escape2 = "&gt;";
        break;
      default:
        continue;
    }
    if (lastIndex !== index) {
      html += str.substring(lastIndex, index);
    }
    lastIndex = index + 1;
    html += escape2;
  }
  return lastIndex !== index ? html + str.substring(lastIndex, index) : html;
}
var matchHtmlRegExp;
var init_src = __esm({
  "node_modules/es-escape-html/src/index.js"() {
    matchHtmlRegExp = /["'&<>]/;
  }
});

// node_modules/@tinyhttp/content-disposition/dist/index.js
function ustring(val) {
  const str = String(val);
  const encoded = encodeURIComponent(str).replace(ENCODE_URL_ATTR_CHAR_REGEXP, pencode);
  return "UTF-8''" + encoded;
}
function format2({ parameters, type }) {
  if (!type || typeof type !== "string" || !TOKEN_REGEXP2.test(type))
    throw new TypeError("invalid type");
  let string = String(type).toLowerCase();
  if (parameters && typeof parameters === "object") {
    const params = Object.keys(parameters).sort();
    for (const param of params) {
      const val = param.substr(-1) === "*" ? ustring(parameters[param]) : qstring2(parameters[param]);
      string += "; " + param + "=" + val;
    }
  }
  return string;
}
function createParams(filename, fallback) {
  if (filename === void 0)
    return;
  const params = {};
  if (fallback === void 0)
    fallback = true;
  if (typeof fallback === "string" && NON_LATIN1_REGEXP.test(fallback))
    throw new TypeError("fallback must be ISO-8859-1 string");
  const name = basename(filename);
  const isQuotedString = TEXT_REGEXP2.test(name);
  const fallbackName = typeof fallback !== "string" ? fallback && getlatin1(name) : basename(fallback);
  const hasFallback = typeof fallbackName === "string" && fallbackName !== name;
  if (hasFallback || !isQuotedString || HEX_ESCAPE_REGEXP.test(name))
    params["filename*"] = name;
  if (isQuotedString || hasFallback)
    params.filename = hasFallback ? fallbackName : name;
  return params;
}
function contentDisposition(filename, options = {}) {
  return format2(new ContentDisposition(options.type || "attachment", createParams(filename, options.fallback)));
}
var ENCODE_URL_ATTR_CHAR_REGEXP, HEX_ESCAPE_REGEXP, NON_LATIN1_REGEXP, QUOTE_REGEXP2, TEXT_REGEXP2, TOKEN_REGEXP2, getlatin1, ContentDisposition, qstring2, pencode, basename;
var init_dist18 = __esm({
  "node_modules/@tinyhttp/content-disposition/dist/index.js"() {
    ENCODE_URL_ATTR_CHAR_REGEXP = /[\x00-\x20"'()*,/:;<=>?@[\\\]{}\x7f]/g;
    HEX_ESCAPE_REGEXP = /%[0-9A-Fa-f]{2}/;
    NON_LATIN1_REGEXP = /[^\x20-\x7e\xa0-\xff]/g;
    QUOTE_REGEXP2 = /([\\"])/g;
    TEXT_REGEXP2 = /^[\x20-\x7e\x80-\xff]+$/;
    TOKEN_REGEXP2 = /^[!#$%&'*+.0-9A-Z^_`a-z|~-]+$/;
    getlatin1 = (val) => {
      return String(val).replace(NON_LATIN1_REGEXP, "?");
    };
    ContentDisposition = class {
      constructor(type, parameters) {
        this.type = type;
        this.parameters = parameters;
      }
    };
    qstring2 = (val) => '"' + String(val).replace(QUOTE_REGEXP2, "\\$1") + '"';
    pencode = (char) => "%" + String(char).charCodeAt(0).toString(16).toUpperCase();
    basename = (str) => str.slice(str.lastIndexOf("/") + 1);
  }
});

// node_modules/@tinyhttp/res/dist/index.js
function acceptParams(str, index) {
  const parts = str.split(/ *; */);
  const ret = { value: parts[0], quality: 1, params: {}, originalIndex: index };
  for (const part of parts) {
    const pms = part.split(/ *= */);
    if ("q" === pms[0])
      ret.quality = parseFloat(pms[1]);
    else
      ret.params[pms[0]] = pms[1];
  }
  return ret;
}
function normalizeTypes(types2) {
  const ret = [];
  for (const type of types2) {
    ret.push(normalizeType(type));
  }
  return ret;
}
var import_http3, import_path3, charsetRegExp, setHeader, setLocationHeader, getResponseHeader, setLinksHeader, setVaryHeader, setContentType, append2, setCookie, clearCookie, normalizeType, formatResponse, redirect, download, attachment;
var init_dist19 = __esm({
  "node_modules/@tinyhttp/res/dist/index.js"() {
    init_dist13();
    init_dist13();
    init_dist14();
    init_dist15();
    init_dist5();
    init_dist10();
    init_dist16();
    init_dist17();
    import_http3 = require("http");
    init_src();
    init_dist18();
    import_path3 = require("path");
    charsetRegExp = /;\s*charset\s*=/;
    setHeader = (res) => (field, val) => {
      if (typeof field === "string") {
        let value = Array.isArray(val) ? val.map(String) : String(val);
        if (field.toLowerCase() === "content-type") {
          if (Array.isArray(value)) {
            throw new TypeError("Content-Type cannot be set to an Array");
          }
          if (!charsetRegExp.test(value)) {
            const charset2 = charset(value.split(";")[0]);
            if (typeof charset2 === "string")
              value += "; charset=" + charset2.toLowerCase();
          }
        }
        res.setHeader(field, value);
      } else {
        for (const key in field) {
          setHeader(res)(key, field[key]);
        }
      }
      return res;
    };
    setLocationHeader = (req, res) => (url) => {
      let loc = url;
      if (url === "back")
        loc = getRequestHeader(req)("Referrer") || "/";
      res.setHeader("Location", encodeUrl(loc));
      return res;
    };
    getResponseHeader = (res) => (field) => {
      return res.getHeader(field);
    };
    setLinksHeader = (res) => (links) => {
      let link = res.getHeader("Link") || "";
      if (link)
        link += ", ";
      res.setHeader("Link", link + Object.keys(links).map((rel) => "<" + links[rel] + '>; rel="' + rel + '"').join(", "));
      return res;
    };
    setVaryHeader = (res) => (field) => {
      vary(res, field);
      return res;
    };
    setContentType = (res) => (type) => {
      const ct = type.indexOf("/") === -1 ? lookup(type) : type;
      setHeader(res)("Content-Type", ct);
      return res;
    };
    append2 = (res) => (field, value) => {
      const prevVal = getResponseHeader(res)(field);
      let newVal = value;
      if (prevVal && typeof newVal !== "number" && typeof prevVal !== "number") {
        newVal = Array.isArray(prevVal) ? prevVal.concat(newVal) : Array.isArray(newVal) ? [prevVal].concat(newVal) : [prevVal, newVal];
      }
      setHeader(res)(field, newVal);
      return res;
    };
    setCookie = (req, res) => (name, value, options = {}) => {
      const secret = req.secret;
      const signed = options.signed || false;
      if (signed && !secret)
        throw new Error('cookieParser("secret") required for signed cookies');
      let val = typeof value === "object" ? "j:" + JSON.stringify(value) : String(value);
      if (signed)
        val = "s:" + sign(val, secret);
      if (options.maxAge) {
        options.expires = new Date(Date.now() + options.maxAge);
        options.maxAge /= 1e3;
      }
      if (options.path == null)
        options.path = "/";
      append2(res)("Set-Cookie", `${serialize(name, String(val), options)}`);
      return res;
    };
    clearCookie = (req, res) => (name, options) => {
      return setCookie(req, res)(name, "", Object.assign({}, { expires: /* @__PURE__ */ new Date(1), path: "/" }, options));
    };
    normalizeType = (type) => ~type.indexOf("/") ? acceptParams(type) : { value: lookup(type), params: {} };
    formatResponse = (req, res, next) => (obj) => {
      const fn = obj.default;
      if (fn)
        delete obj.default;
      const keys = Object.keys(obj);
      const key = keys.length > 0 ? getAccepts(req)(...keys) : false;
      setVaryHeader(res)("Accept");
      if (key) {
        res.setHeader("Content-Type", normalizeType(key).value);
        obj[key](req, res, next);
      } else if (fn) {
        fn();
      } else {
        const err = new Error("Not Acceptable");
        err.status = err.statusCode = 406;
        err.types = normalizeTypes(keys).map((o2) => o2.value);
        next(err);
      }
      return res;
    };
    redirect = (req, res, next) => (url, status2) => {
      let address = url;
      status2 = status2 || 302;
      let body = "";
      address = setLocationHeader(req, res)(address).getHeader("Location");
      formatResponse(req, res, next)({
        text: () => {
          body = import_http3.STATUS_CODES[status2] + ". Redirecting to " + address;
        },
        html: () => {
          const u2 = escapeHTML(address);
          body = `<p>${import_http3.STATUS_CODES[status2]}. Redirecting to <a href="${u2}">${u2}</a></p>`;
        }
      });
      res.setHeader("Content-Length", Buffer.byteLength(body));
      res.statusCode = status2;
      if (req.method === "HEAD")
        res.end();
      else
        res.end(body);
      return res;
    };
    download = (req, res) => (path3, filename, options, cb) => {
      let done = cb;
      let name = filename;
      let opts = options || null;
      if (typeof filename === "function") {
        done = filename;
        name = null;
      } else if (typeof options === "function") {
        done = options;
        opts = null;
      }
      const headers = {
        "Content-Disposition": contentDisposition(name || path3)
      };
      if (opts && opts.headers) {
        for (const key of Object.keys(opts.headers)) {
          if (key.toLowerCase() !== "content-disposition")
            headers[key] = opts.headers[key];
        }
      }
      opts = { ...opts, headers };
      return sendFile(req, res)(opts.root ? path3 : (0, import_path3.resolve)(path3), opts, done || (() => void 0));
    };
    attachment = (res) => (filename) => {
      if (filename)
        setContentType(res)((0, import_path3.extname)(filename));
      setHeader(res)("Content-Disposition", contentDisposition(filename));
      return res;
    };
  }
});

// node_modules/regexparam/dist/index.mjs
function parse5(str, loose) {
  if (str instanceof RegExp)
    return { keys: false, pattern: str };
  var c2, o2, tmp, ext, keys = [], pattern = "", arr = str.split("/");
  arr[0] || arr.shift();
  while (tmp = arr.shift()) {
    c2 = tmp[0];
    if (c2 === "*") {
      keys.push("wild");
      pattern += "/(.*)";
    } else if (c2 === ":") {
      o2 = tmp.indexOf("?", 1);
      ext = tmp.indexOf(".", 1);
      keys.push(tmp.substring(1, !!~o2 ? o2 : !!~ext ? ext : tmp.length));
      pattern += !!~o2 && !~ext ? "(?:/([^/]+?))?" : "/([^/]+?)";
      if (!!~ext)
        pattern += (!!~o2 ? "?" : "") + "\\" + tmp.substring(ext);
    } else {
      pattern += "/" + tmp;
    }
  }
  return {
    keys,
    pattern: new RegExp("^" + pattern + (loose ? "(?=$|/)" : "/?$"), "i")
  };
}
var init_dist20 = __esm({
  "node_modules/regexparam/dist/index.mjs"() {
  }
});

// node_modules/@tinyhttp/app/dist/index.js
var dist_exports4 = {};
__export(dist_exports4, {
  App: () => App,
  extendMiddleware: () => extendMiddleware,
  getHostname: () => getHostname,
  getIP: () => getIP,
  getIPs: () => getIPs,
  getProtocol: () => getProtocol,
  getRouteFromApp: () => getRouteFromApp,
  getSubdomains: () => getSubdomains,
  getURLParams: () => getURLParams,
  onErrorHandler: () => onErrorHandler,
  renderTemplate: () => renderTemplate
});
var import_http4, import_path4, import_net, trustRemoteAddress, getRouteFromApp, getProtocol, getHostname, getIP, getIPs, getSubdomains, onErrorHandler, renderTemplate, extendMiddleware, lead, mount, applyHandler, App;
var init_dist21 = __esm({
  "node_modules/@tinyhttp/app/dist/index.js"() {
    import_http4 = require("http");
    import_path4 = __toESM(require("path"), 1);
    init_dist2();
    import_net = require("net");
    init_dist10();
    init_dist10();
    init_dist11();
    init_dist19();
    init_dist20();
    trustRemoteAddress = ({ connection }) => {
      const val = connection.remoteAddress;
      if (typeof val === "function")
        return val;
      if (typeof val === "boolean" && val === true)
        return () => true;
      if (typeof val === "number")
        return (_, i) => val ? i < val : void 0;
      if (typeof val === "string")
        return compile(val.split(",").map((x2) => x2.trim()));
      return compile(val || []);
    };
    getRouteFromApp = ({ middleware }, h) => middleware.find(({ handler }) => typeof handler === "function" && handler.name === h.name);
    getProtocol = (req) => {
      const proto = req.connection.encrypted ? "https" : "http";
      if (!trustRemoteAddress(req))
        return proto;
      const header = req.headers["X-Forwarded-Proto"] || proto;
      const index = header.indexOf(",");
      return index !== -1 ? header.substring(0, index).trim() : header.trim();
    };
    getHostname = (req) => {
      let host = req.get("X-Forwarded-Host");
      if (!host || !trustRemoteAddress(req))
        host = req.get("Host");
      if (!host)
        return;
      const index = host.indexOf(":", host[0] === "[" ? host.indexOf("]") + 1 : 0);
      return index !== -1 ? host.substring(0, index) : host;
    };
    getIP = (req) => proxyaddr(req, trustRemoteAddress(req)).replace(/^.*:/, "");
    getIPs = (req) => alladdrs(req, trustRemoteAddress(req));
    getSubdomains = (req, subdomainOffset = 2) => {
      const hostname2 = getHostname(req);
      if (!hostname2)
        return [];
      const subdomains = (0, import_net.isIP)(hostname2) ? [hostname2] : hostname2.split(".").reverse();
      return subdomains.slice(subdomainOffset);
    };
    onErrorHandler = (err, _req, res) => {
      if (!process.env.TESTING && err instanceof Error)
        console.error(err);
      const code = err.code in import_http4.STATUS_CODES ? err.code : err.status;
      if (typeof err === "string" || Buffer.isBuffer(err))
        res.writeHead(500).end(err);
      else if (code in import_http4.STATUS_CODES)
        res.writeHead(code).end(import_http4.STATUS_CODES[code]);
      else
        res.writeHead(500).end(err.message);
    };
    renderTemplate = (_req, res, app) => (file, data, options) => {
      app.render(file, data, (err, html) => {
        if (err)
          throw err;
        res.send(html);
      }, options);
      return res;
    };
    extendMiddleware = (app) => (req, res, next) => {
      const { settings } = app;
      res.get = getResponseHeader(res);
      req.get = getRequestHeader(req);
      if (settings === null || settings === void 0 ? void 0 : settings.bindAppToReqRes) {
        req.app = app;
        res.app = app;
      }
      if (settings === null || settings === void 0 ? void 0 : settings.networkExtensions) {
        req.protocol = getProtocol(req);
        req.secure = req.protocol === "https";
        req.connection = Object.assign(req.socket, { encrypted: req.secure });
        req.hostname = getHostname(req);
        req.subdomains = getSubdomains(req, settings.subdomainOffset);
        req.ip = getIP(req);
        req.ips = getIPs(req);
      }
      req.query = getQueryParams(req.url);
      req.range = getRangeFromHeader(req);
      req.accepts = getAccepts(req);
      req.acceptsCharsets = getAcceptsCharsets(req);
      req.acceptsEncodings = getAcceptsEncodings(req);
      req.acceptsLanguages = getAcceptsLanguages(req);
      req.xhr = checkIfXMLHttpRequest(req);
      res.header = res.set = setHeader(res);
      res.send = send(req, res);
      res.json = json(res);
      res.status = status(res);
      res.sendStatus = sendStatus(req, res);
      res.sendFile = sendFile(req, res);
      res.type = setContentType(res);
      res.location = setLocationHeader(req, res);
      res.links = setLinksHeader(res);
      res.vary = setVaryHeader(res);
      res.cookie = setCookie(req, res);
      res.clearCookie = clearCookie(req, res);
      res.render = renderTemplate(req, res, app);
      res.format = formatResponse(req, res, next);
      res.redirect = redirect(req, res, next);
      res.attachment = attachment(res);
      res.download = download(req, res);
      res.append = append2(res);
      res.locals = res.locals || /* @__PURE__ */ Object.create(null);
      Object.defineProperty(req, "fresh", { get: getFreshOrStale.bind(null, req, res), configurable: true });
      req.stale = !req.fresh;
      next();
    };
    lead = (x2) => x2.charCodeAt(0) === 47 ? x2 : "/" + x2;
    mount = (fn) => fn instanceof App ? fn.attach : fn;
    applyHandler = (h) => async (req, res, next) => {
      try {
        if (h[Symbol.toStringTag] === "AsyncFunction") {
          await h(req, res, next);
        } else
          h(req, res, next);
      } catch (e) {
        next(e);
      }
    };
    App = class _App extends Router {
      constructor(options = {}) {
        super();
        this.middleware = [];
        this.locals = {};
        this.engines = {};
        this.onError = (options === null || options === void 0 ? void 0 : options.onError) || onErrorHandler;
        this.noMatchHandler = (options === null || options === void 0 ? void 0 : options.noMatchHandler) || this.onError.bind(null, { code: 404 });
        this.settings = options.settings || { xPoweredBy: true };
        this.applyExtensions = options === null || options === void 0 ? void 0 : options.applyExtensions;
        this.attach = (req, res) => setImmediate(this.handler.bind(this, req, res, void 0), req, res);
      }
      /**
       * Set app setting
       * @param setting setting name
       * @param value setting value
       */
      set(setting, value) {
        this.settings[setting] = value;
        return this;
      }
      /**
       * Enable app setting
       * @param setting Setting name
       */
      enable(setting) {
        this.settings[setting] = true;
        return this;
      }
      /**
       * Disable app setting
       * @param setting
       */
      disable(setting) {
        this.settings[setting] = false;
        return this;
      }
      /**
       * Render a template
       * @param file What to render
       * @param data data that is passed to a template
       * @param options Template engine options
       * @param cb Callback that consumes error and html
       */
      render(file, data = {}, cb, options = {}) {
        options.viewsFolder = options.viewsFolder || `${process.cwd()}/views`;
        options.ext = options.ext || file.slice(file.lastIndexOf(".") + 1) || "ejs";
        options._locals = options._locals || {};
        options.cache = options.cache || process.env.NODE_ENV === "production";
        let locals = { ...data, ...this.locals };
        if (options._locals)
          locals = { ...locals, ...options._locals };
        if (!file.endsWith(`.${options.ext}`))
          file = `${file}.${options.ext}`;
        const dest = options.viewsFolder ? import_path4.default.join(options.viewsFolder, file) : file;
        this.engines[options.ext](dest, locals, options.renderOptions, cb);
        return this;
      }
      use(...args) {
        var _a;
        const base = args[0];
        const fns = args.slice(1).flat();
        if (typeof base === "function" || base instanceof _App) {
          fns.unshift(base);
        } else if (Array.isArray(base)) {
          fns.unshift(...base);
        }
        const path3 = typeof base === "string" ? base : "/";
        let regex;
        for (const fn of fns) {
          if (fn instanceof _App) {
            regex = parse5(path3, true);
            fn.mountpath = path3;
            this.apps[path3] = fn;
            fn.parent = this;
          }
        }
        const handlerPaths = [];
        const handlerFunctions = [];
        const handlerPathBase = path3 === "/" ? "" : lead(path3);
        for (const fn of fns) {
          if (fn instanceof _App && ((_a = fn.middleware) === null || _a === void 0 ? void 0 : _a.length)) {
            for (const mw of fn.middleware) {
              handlerPaths.push(handlerPathBase + lead(mw.path));
              handlerFunctions.push(fn);
            }
          } else {
            handlerPaths.push("");
            handlerFunctions.push(fn);
          }
        }
        pushMiddleware(this.middleware)({
          path: path3,
          regex,
          type: "mw",
          handler: mount(handlerFunctions[0]),
          handlers: handlerFunctions.slice(1).map(mount),
          fullPaths: handlerPaths
        });
        return this;
      }
      /**
       * Register a template engine with extension
       */
      engine(ext, fn) {
        this.engines[ext] = fn;
        return this;
      }
      route(path3) {
        const app = new _App();
        this.use(path3, app);
        return app;
      }
      find(url) {
        return this.middleware.filter((m2) => {
          m2.regex = m2.regex || parse5(m2.path, m2.type === "mw");
          let fullPathRegex;
          m2.fullPath && typeof m2.fullPath === "string" ? fullPathRegex = parse5(m2.fullPath, m2.type === "mw") : fullPathRegex = null;
          return m2.regex.pattern.test(url) && (m2.type === "mw" && fullPathRegex ? fullPathRegex.pattern.test(url) : true);
        });
      }
      /**
       * Extends Req / Res objects, pushes 404 and 500 handlers, dispatches middleware
       * @param req Req object
       * @param res Res object
       */
      handler(req, res, next) {
        const { xPoweredBy } = this.settings;
        if (xPoweredBy)
          res.setHeader("X-Powered-By", typeof xPoweredBy === "string" ? xPoweredBy : "tinyhttp");
        const exts = this.applyExtensions || extendMiddleware(this);
        req.originalUrl = req.url || req.originalUrl;
        const pathname = getPathname(req.originalUrl);
        const matched = this.find(pathname);
        const mw = [
          {
            handler: exts,
            type: "mw",
            path: "/"
          },
          ...matched.filter((x2) => req.method === "HEAD" || (x2.method ? x2.method === req.method : true))
        ];
        if (matched[0] != null) {
          mw.push({
            type: "mw",
            handler: (req2, res2, next2) => {
              if (req2.method === "HEAD") {
                res2.statusCode = 204;
                return res2.end("");
              }
              next2();
            },
            path: "/"
          });
        }
        mw.push({
          handler: this.noMatchHandler,
          type: "mw",
          path: "/"
        });
        const handle = (mw2) => async (req2, res2, next2) => {
          var _a;
          const { path: path3, handler, regex } = mw2;
          const params = regex ? getURLParams(regex, pathname) : {};
          req2.params = { ...req2.params, ...params };
          if (path3.includes(":")) {
            const first = Object.values(params)[0];
            const url = req2.url.slice(req2.url.indexOf(first) + (first === null || first === void 0 ? void 0 : first.length));
            req2.url = lead(url);
          } else {
            req2.url = lead(req2.url.substring(path3.length));
          }
          if (!req2.path)
            req2.path = getPathname(req2.url);
          if ((_a = this.settings) === null || _a === void 0 ? void 0 : _a.enableReqRoute)
            req2.route = getRouteFromApp(this, handler);
          await applyHandler(handler)(req2, res2, next2);
        };
        let idx = 0;
        const loop = () => res.writableEnded || idx < mw.length && handle(mw[idx++])(req, res, next);
        next = next || ((err) => err ? this.onError(err, req, res) : loop());
        loop();
      }
      /**
       * Creates HTTP server and dispatches middleware
       * @param port server listening port
       * @param Server callback after server starts listening
       * @param host server listening host
       */
      listen(port2, cb, host = "0.0.0.0") {
        return (0, import_http4.createServer)().on("request", this.attach).listen(port2, host, cb);
      }
    };
  }
});

// node_modules/milliparsec/dist/index.js
var dist_exports5 = {};
__export(dist_exports5, {
  custom: () => custom,
  hasBody: () => hasBody,
  json: () => json2,
  p: () => p2,
  raw: () => raw,
  text: () => text,
  urlencoded: () => urlencoded
});
var hasBody, p2, custom, json2, raw, text, urlencoded;
var init_dist22 = __esm({
  "node_modules/milliparsec/dist/index.js"() {
    hasBody = (method) => ["POST", "PUT", "PATCH", "DELETE"].includes(method);
    p2 = (fn) => async (req, _res, next) => {
      try {
        let body = "";
        for await (const chunk of req)
          body += chunk;
        return fn(body);
      } catch (e) {
        next(e);
      }
    };
    custom = (fn) => async (req, _res, next) => {
      req.body = await p2(fn)(req, void 0, next);
      next();
    };
    json2 = () => async (req, res, next) => {
      if (hasBody(req.method)) {
        req.body = await p2((x2) => JSON.parse(x2.toString()))(req, res, next);
        next();
      } else
        next();
    };
    raw = () => async (req, _res, next) => {
      if (hasBody(req.method))
        req.body = await p2((x2) => x2)(req, _res, next);
      else
        next();
    };
    text = () => async (req, _res, next) => {
      if (hasBody(req.method))
        req.body = await p2((x2) => x2.toString())(req, _res, next);
      else
        next();
    };
    urlencoded = () => async (req, res, next) => {
      if (hasBody(req.method)) {
        req.body = await p2((x2) => {
          const urlSearchParam = new URLSearchParams(x2.toString());
          return Object.fromEntries(urlSearchParam.entries());
        })(req, res, next);
        next();
      } else
        next();
    };
  }
});

// node_modules/ws/wrapper.mjs
var import_stream, import_receiver, import_sender, import_websocket, import_websocket_server;
var init_wrapper = __esm({
  "node_modules/ws/wrapper.mjs"() {
    import_stream = __toESM(require_stream(), 1);
    import_receiver = __toESM(require_receiver(), 1);
    import_sender = __toESM(require_sender(), 1);
    import_websocket = __toESM(require_websocket(), 1);
    import_websocket_server = __toESM(require_websocket_server(), 1);
  }
});

// node_modules/tinyws/dist/index.js
var dist_exports6 = {};
__export(dist_exports6, {
  tinyws: () => tinyws
});
var tinyws;
var init_dist23 = __esm({
  "node_modules/tinyws/dist/index.js"() {
    init_wrapper();
    tinyws = (wsOptions, wss = new import_websocket_server.default({ ...wsOptions, noServer: true })) => async (req, _, next) => {
      0 === (req.headers.upgrade || "").split(",").map((s) => s.trim()).indexOf("websocket") && (req.ws = () => new Promise((resolve2) => {
        wss.handleUpgrade(req, req.socket, Buffer.alloc(0), (ws) => {
          wss.emit("connection", ws, req), resolve2(ws);
        });
      })), await next();
    };
  }
});

// src/gwapi.js
var require_gwapi = __commonJS({
  "src/gwapi.js"(exports2, module2) {
    "use strict";
    var sirv = require_build2();
    var ble2 = require_nrf_ble();
    var gwutils2 = require_gwutils();
    var WebSocket3 = require_ws();
    var linuxdfu = require_linuxdfu();
    var fs2 = require("fs").promises;
    var fsNonPromises = require("fs");
    var path3 = require("path");
    var OfflineStorage = require_offlineStorage().OfflineStorage;
    var sensorDefinition2 = require_sensorDefinition();
    var ModbusServer = require_modbus().ModbusServer;
    var smm = require_systemmon();
    var gwCrypto2 = require_crypto().gwCrypto;
    var axios = require_axios2();
    var jsonpatch = require_fast_json_patch();
    var sensorActions2 = require_sensorActions().sensorActions;
    var phantomService2 = require_phantomService().phantomService;
    var spawn = require("child_process").spawn;
    var g_fwFileOffset = 0;
    var localWSConnections = [];
    var remoteEIRealtimeSocket = null;
    var remoteEIRealtimeSocketPingInterval = null;
    var remoteEIRealtimeSocketObserved = false;
    var remoteEIRealtimeSocketObservedSubordinates = {};
    var remoteEIRealtimeGotPong = true;
    var subordinateRealtimeSocket = null;
    var subordinatePingInterval = null;
    var subordinateGotPong = true;
    var gwGlobalState = null;
    var subordinateRedirectIP = null;
    var subordinateRedirectPassword = null;
    var subordinateStartedRedirect = false;
    var invalidateRedirectNext = false;
    var firmwareUploadPath = gwutils2.getDataDirectory("firmwareUpload");
    var firmwareFilePath = path3.join(firmwareUploadPath, "fw.bin");
    function findSubordinateGW(gwSerial) {
      for (let i = 0; i < localWSConnections.length; i++) {
        let ws = localWSConnections[i];
        if (!ws.subordinate)
          continue;
        if (ws.deviceId == gwSerial)
          return ws;
      }
      return void 0;
    }
    async function parseGWRequest(actionrequest, ws) {
      if (actionrequest?.action == "restartnrf") {
        ble2.restartNRF();
      } else if (actionrequest?.action == "restart") {
        gwutils2.reboot();
      } else if (actionrequest?.action == "setbasicconfig") {
        gwutils2.gwMergeBasicConfig(actionrequest.settings);
        gwutils2.gwSaveBasicConfig();
        gwutils2.gwUpdateGlobalState();
        gwutils2.reboot();
      } else if (actionrequest?.action == "enablessh") {
        gwutils2.enablessh();
      } else if (actionrequest?.action == "disablestateupdates") {
        ws.disablestateupdates = true;
      } else if (actionrequest?.action == "checkonlineupdate") {
        let canUpdate = false;
        let version = 0;
        try {
          let response = await axios.get("https://pfw.erbessd-instruments.com/test/phantom/gwupdate.json", { responseType: "json" });
          version = response.data.currentVersion;
          canUpdate = version > gwGlobalState.deviceInfo.version || gwGlobalState.deviceInfo.osversion != gwGlobalState.deviceInfo.expectedos;
        } catch (e) {
        }
        ws.send(JSON.stringify({
          type: "checkonlineupdate",
          payload: {
            version,
            canUpdate
          }
        }));
      } else if (actionrequest?.action == "applyonlineupdate") {
        try {
          gwGlobalState.deviceInfo.state = {
            action: "updating",
            state: "downloading",
            progress: 0
          };
          gwutils2.gwUpdateGlobalState();
          let response = await axios.get(
            "https://pfw.erbessd-instruments.com/test/phantom/files/gw2/gwupdate-" + actionrequest.version + ".bin",
            { responseType: "stream" }
          );
          const contentLength = response.headers["content-length"];
          let total = 0;
          response.data.on("data", (chunk) => {
            total += chunk.length;
            gwGlobalState.deviceInfo.state.progress = total / contentLength;
            gwutils2.gwUpdateGlobalState();
          });
          response.data.on("end", async () => {
            let success = await linuxdfu.update(firmwareFilePath, gwGlobalState);
          });
          response.data.pipe(fsNonPromises.createWriteStream(firmwareFilePath));
        } catch (e) {
          delete gwGlobalState.deviceInfo.state;
          gwutils2.gwUpdateGlobalState();
          console.log(e.message);
        }
      } else if (actionrequest?.action == "startfwupdate") {
        g_fwFileOffset = 0;
      } else if (actionrequest?.action == "applyfwupdate") {
        let success = false;
        try {
          success = await linuxdfu.update(firmwareFilePath, gwGlobalState);
        } catch (e) {
          console.log(e.message);
        }
        await fs2.unlink(firmwareFilePath);
      } else if (actionrequest?.action == "fwupdatedata") {
        try {
          let binary = Buffer.from(actionrequest?.blob, "base64");
          if (g_fwFileOffset == 0) {
            g_fwFileOffset += binary.length;
            await fs2.writeFile(firmwareFilePath, binary);
          } else {
            g_fwFileOffset += binary.length;
            await fs2.appendFile(firmwareFilePath, binary);
          }
          ws.send(JSON.stringify({
            type: "fwupdateoffset",
            payload: {
              offset: g_fwFileOffset
            }
          }));
        } catch (e) {
          console.log(e.message);
        }
      } else if (actionrequest?.action == "update") {
        if (actionrequest.params && actionrequest.params.updatecode) {
          await gwutils2.downloadFirmware(actionrequest.params.updatecode);
        }
        if (gwGlobalState.nodes[actionrequest.phantomcode] === void 0)
          gwGlobalState.nodes[actionrequest.phantomcode] = {};
        if (gwGlobalState.nodes[actionrequest.phantomcode].actions === void 0)
          gwGlobalState.nodes[actionrequest.phantomcode].actions = {};
        if (gwGlobalState.nodes[actionrequest.phantomcode].actions[actionrequest.action] == void 0)
          gwGlobalState.nodes[actionrequest.phantomcode].actions[actionrequest.action] = {};
        gwGlobalState.nodes[actionrequest.phantomcode].actions[actionrequest.action].requestTime = Date.now();
        gwGlobalState.nodes[actionrequest.phantomcode].actions[actionrequest.action].params = actionrequest.params;
        gwutils2.gwUpdateGlobalState();
      } else if (actionrequest?.action == "updatebootloader") {
        let success = await linuxdfu.updateBootloader(gwGlobalState);
        ws.send(JSON.stringify({
          type: "updatebootloader",
          payload: {
            state: success
          }
        }));
      } else if (actionrequest?.action == "cancelupdate") {
        try {
          delete gwGlobalState.nodes[actionrequest.phantomcode].actions.update;
          gwutils2.gwUpdateGlobalState();
        } catch (e) {
        }
      } else if (actionrequest?.action == "cancelsignal") {
        try {
          delete gwGlobalState.nodes[actionrequest.phantomcode].actions.signal;
          gwutils2.gwUpdateGlobalState();
        } catch (e) {
        }
      } else if (actionrequest?.action == "cancelupdatestate") {
        try {
          delete gwGlobalState.nodes[actionrequest.phantomcode].actions.updatestate;
          gwutils2.gwUpdateGlobalState();
        } catch (e) {
        }
      } else if (actionrequest?.action == "cancelsleep") {
        try {
          delete gwGlobalState.nodes[actionrequest.phantomcode].actions.sleep;
          gwutils2.gwUpdateGlobalState();
        } catch (e) {
        }
      } else if (actionrequest?.action == "stopbatterytest") {
        try {
          delete gwGlobalState.nodes[actionrequest.phantomcode].actions.batterytest;
          gwutils2.gwUpdateGlobalState();
        } catch (e) {
        }
      } else if (actionrequest?.action == "forget") {
        try {
          gwutils2.broadcastEvent("noderemoved", actionrequest.phantomcode);
          delete gwGlobalState.nodes[actionrequest.phantomcode];
          gwutils2.gwUpdateGlobalState();
        } catch (e) {
        }
      } else if (actionrequest?.action == "pair") {
        try {
          if (!gwGlobalState.nodes[actionrequest.phantomcode].settings)
            gwGlobalState.nodes[actionrequest.phantomcode].settings = {};
          gwGlobalState.nodes[actionrequest.phantomcode].settings.isPaired = true;
          gwutils2.broadcastEvent("nodeconfigchanged", actionrequest.phantomcode);
          gwutils2.gwUpdateGlobalState();
        } catch (e) {
        }
      } else if (actionrequest?.action == "unpair") {
        try {
          if (!gwGlobalState.nodes[actionrequest.phantomcode].settings)
            gwGlobalState.nodes[actionrequest.phantomcode].settings = {};
          gwGlobalState.nodes[actionrequest.phantomcode].settings.isPaired = false;
          gwutils2.broadcastEvent("nodeconfigchanged", actionrequest.phantomcode);
          gwutils2.gwUpdateGlobalState();
        } catch (e) {
        }
      } else if (actionrequest?.action == "blink") {
        try {
          gwGlobalState.nodes[actionrequest.phantomcode].doBlink = true;
          gwGlobalState.nodes[actionrequest.phantomcode].blinkStart = Date.now();
        } catch (e) {
        }
      } else if (actionrequest?.action == "favorite") {
        try {
          if (!gwGlobalState.nodes[actionrequest.phantomcode].settings)
            gwGlobalState.nodes[actionrequest.phantomcode].settings = {};
          gwGlobalState.nodes[actionrequest.phantomcode].settings.isFavorite = actionrequest.params.favorite;
          gwutils2.broadcastEvent("nodeconfigchanged", actionrequest.phantomcode);
          gwutils2.gwUpdateGlobalState();
        } catch (e) {
        }
      } else if (actionrequest?.action == "setfriendlyname") {
        try {
          if (!gwGlobalState.nodes[actionrequest.phantomcode].settings)
            gwGlobalState.nodes[actionrequest.phantomcode].settings = {};
          gwGlobalState.nodes[actionrequest.phantomcode].settings.friendlyName = actionrequest.params.friendlyName;
          gwutils2.broadcastEvent("nodeconfigchanged", actionrequest.phantomcode);
          gwutils2.gwUpdateGlobalState();
        } catch (e) {
        }
      } else if (actionrequest?.action == "setgwfriendlyname") {
        try {
          if (!gwGlobalState.gateways)
            gwGlobalState.gateways = {};
          if (!gwGlobalState.gateways[actionrequest.gwSerial])
            gwGlobalState.gateways[actionrequest.gwSerial] = {};
          gwGlobalState.gateways[actionrequest.gwSerial].friendlyName = actionrequest.params.friendlyName;
          gwutils2.broadcastEvent("nodeconfigchanged");
          gwutils2.gwUpdateGlobalState();
        } catch (e) {
        }
      } else if (actionrequest?.action == "adddisplaysensor") {
        try {
          if (!gwGlobalState.nodes[actionrequest.phantomcode].displaySensors)
            gwGlobalState.nodes[actionrequest.phantomcode].displaySensors = [];
          gwGlobalState.nodes[actionrequest.phantomcode].displaySensors.push(actionrequest.params);
          gwutils2.gwUpdateGlobalState();
        } catch (e) {
        }
      } else if (actionrequest?.action == "removedisplaysensor") {
        try {
          if (!gwGlobalState.nodes[actionrequest.phantomcode].displaySensors)
            gwGlobalState.nodes[actionrequest.phantomcode].displaySensors = [];
          gwGlobalState.nodes[actionrequest.phantomcode].displaySensors = gwGlobalState.nodes[actionrequest.phantomcode].displaySensors.filter((displaysensor) => displaysensor.sensorCode != actionrequest.params.sensorCode);
          gwutils2.gwUpdateGlobalState();
        } catch (e) {
        }
      } else if (actionrequest?.action == "scanwifinetworks") {
        let wifinetworks = await gwutils2.getWifiNetworks();
        ws.send(JSON.stringify({
          type: "wifinetworks",
          payload: wifinetworks
        }));
      } else if (actionrequest?.action == "scanwifinetworksadv") {
        let wifinetworks = await gwutils2.getWifiNetworksadv();
        ws.send(JSON.stringify({
          type: "wifinetworksadv",
          payload: wifinetworks
        }));
      } else if (actionrequest?.action == "getmodbussensordef") {
        let modbusDefinition = ModbusServer.getModbusSensorDefinitions();
        ws.send(JSON.stringify({
          type: "modbussensordef",
          payload: modbusDefinition
        }));
      } else if (actionrequest?.action == "getofflinefiles") {
        let offlineFiles = await OfflineStorage.getOfflineFiles();
        ws.send(JSON.stringify({
          type: "offlinefiles",
          payload: offlineFiles
        }));
      } else if (actionrequest?.action == "resetofflinefiles") {
        await OfflineStorage.deleteOfflineFiles();
      } else if (actionrequest?.action == "getofflinefile") {
        let data = await OfflineStorage.getOffLineFile(actionrequest.dirname, actionrequest.filename);
        ws.send(JSON.stringify({
          type: "offlinefile",
          payload: data
        }));
      } else if (actionrequest?.action == "deleteofflinefile") {
        await OfflineStorage.deleteOfflineFile(actionrequest.dirname, actionrequest.filename);
      } else if (actionrequest?.action == "gettimeinfo") {
        let timezones = await smm.getTimeZones();
        let ntpserver = await gwutils2.getNTPServer();
        let timezone = await gwutils2.getCurrentTZ();
        ws.send(JSON.stringify({
          type: "timeinfo",
          payload: {
            timezones,
            ntpserver,
            timezone,
            currentDateTime: Math.floor(Date.now() / 1e3),
            currentTZGWOffset: (/* @__PURE__ */ new Date()).getTimezoneOffset() * 60
          }
        }));
      } else if (actionrequest?.action == "settimeinfo") {
        console.log("settimeinfo", actionrequest?.timeinfo);
        if (actionrequest?.timeinfo?.settime) {
          console.log("Set time");
          await gwutils2.setSystemTime(actionrequest?.timeinfo.settime);
        }
        if (actionrequest?.timeinfo?.timezone) {
          console.log("Set current TZ");
          await gwutils2.setCurrentTZ(actionrequest?.timeinfo.timezone);
        }
        if (actionrequest?.timeinfo?.ntpserver) {
          console.log("Set ntp server");
          await gwutils2.setNTPServer(actionrequest?.timeinfo.ntpserver);
        } else {
          await gwutils2.setNTPServer("");
        }
        gwutils2.reboot();
      } else if (actionrequest?.action == "setsecurity") {
        await gwutils2.setSecurity(actionrequest?.security);
      } else if (actionrequest?.action == "setsensorgwsettings") {
        let node = gwGlobalState.nodes[actionrequest.phantomcode];
        if (!node)
          return;
        if (!node.settings)
          node.settings = {};
        for (const setting in actionrequest.settings) {
          node.settings[setting] = actionrequest.settings[setting];
        }
        gwutils2.broadcastEvent("nodeconfigchanged", actionrequest.phantomcode);
        gwutils2.gwUpdateGlobalState();
      } else if (actionrequest?.action == "getsensorkeys") {
        let sensorKeys = gwCrypto2.getAllKeys();
        ws.send(JSON.stringify({
          type: "sensorkeys",
          payload: {
            sensorKeys
          }
        }));
      } else if (actionrequest?.action == "setsensorkeys") {
        gwCrypto2.mergeSensorKeys(actionrequest?.sensorKeys);
      } else if (actionrequest?.action == "cancelencrypt") {
        try {
          delete gwGlobalState.nodes[actionrequest.phantomcode].actions.encrypt;
          gwutils2.gwUpdateGlobalState();
        } catch (e) {
        }
      } else if (actionrequest?.action == "cancelchangesettings") {
        try {
          delete gwGlobalState.nodes[actionrequest.phantomcode].actions.changesettings;
          gwutils2.gwUpdateGlobalState();
        } catch (e) {
        }
      } else if (actionrequest?.action == "readlog") {
        try {
          let log = await gwutils2.readSystemLog();
          ws.send(JSON.stringify({
            type: "readlog",
            payload: {
              log
            }
          }));
        } catch (e) {
        }
      } else if (actionrequest?.action == "routemesh") {
        try {
          await gwutils2.setupMeshRoute(actionrequest.ipaddr);
        } catch (e) {
        }
      } else if (actionrequest?.action == "testadvertising") {
        ble2.testAdvertise();
      } else if (actionrequest?.action == "startqoschannelsurvey") {
        ble2.startQoSChannelSurvey();
      } else if (actionrequest?.action == "setPhantomSync") {
        if (!gwGlobalState.phantomSync)
          gwGlobalState.phantomSync = [];
        if (actionrequest.params.new)
          gwGlobalState.phantomSync.push(actionrequest.params.settings);
        else if (actionrequest.params.edit)
          gwGlobalState.phantomSync[actionrequest.params.index] = actionrequest.params.settings;
        gwutils2.gwUpdateGlobalState();
        gwutils2.broadcastEvent("nodeconfigchanged");
      } else if (actionrequest?.action == "deletePhantomSync") {
        if (!gwGlobalState.phantomSync)
          return;
        gwGlobalState.phantomSync.splice(actionrequest.params.index, 1);
        gwutils2.gwUpdateGlobalState();
        gwutils2.broadcastEvent("nodeconfigchanged");
      } else if (actionrequest?.action == "doPhantomSync") {
        if (!gwGlobalState.phantomSync)
          return;
        gwutils2.broadcastEvent("dophantomsync", {
          index: actionrequest.params.index,
          action: actionrequest.params.action,
          manual: true,
          timeout: actionrequest.params.timeout
        });
      } else if (actionrequest?.action == "cancelPhantomSync") {
        delete gwGlobalState.deviceInfo.runningPhantomSync;
        gwutils2.gwUpdateGlobalState();
      } else if (actionrequest?.action == "getstate") {
        ws.send(JSON.stringify({
          type: "state",
          payload: gwGlobalState
        }));
      } else if (actionrequest?.action == "factoryreset") {
        await gwutils2.gwFactoryReset(actionrequest.halt);
      } else if (actionrequest?.action == "getwiredstream") {
        ws.getWiredStream = true;
      } else if (actionrequest?.action == "resetcurrent") {
        if (gwGlobalState.nodes[actionrequest.phantomcode] === void 0)
          gwGlobalState.nodes[actionrequest.phantomcode] = {};
        if (gwGlobalState.nodes[actionrequest.phantomcode].actions === void 0)
          gwGlobalState.nodes[actionrequest.phantomcode].actions = {};
        gwGlobalState.nodes[actionrequest.phantomcode].actions.resetcurrent = {};
        gwutils2.gwUpdateGlobalState();
      } else if (actionrequest?.action == "cancelresetcurrent") {
        try {
          delete gwGlobalState.nodes[actionrequest.phantomcode].actions.resetcurrent;
          gwutils2.gwUpdateGlobalState();
        } catch (e) {
        }
      } else if (actionrequest?.action == "enabletunnel") {
        try {
          await gwutils2.setupssshtunnel(actionrequest.host, actionrequest.remoteport, actionrequest.user, actionrequest.password);
        } catch (e) {
        }
      } else if (actionrequest?.action == "senddata") {
        try {
          ws.wantdata = true;
        } catch (e) {
        }
      } else if (actionrequest?.action == "subordinatehello") {
        try {
          if (gwGlobalState.basicconfig.subordinate) {
            if (!subordinateStartedRedirect) {
              subordinateStartedRedirect = true;
              spawn("socat", ["TCP6-LISTEN:81,fork", "TCP4:" + gwGlobalState.basicconfig.subordinateip + ":80"], { detached: true });
            }
            ws.send(JSON.stringify({
              type: "observeerequest",
              action: "subordinateredirect",
              payload: {
                subordinateip: "[fd66:66:66::1]:81",
                subordinatepassword: gwGlobalState.basicconfig.subordinatepassword
              }
            }));
            setTimeout(() => {
              ws.close();
            }, 1500);
          }
          ws.subordinate = true;
          ws.deviceId = actionrequest?.deviceId;
          if (!gwGlobalState.deviceInfo.subordinatesConnection)
            gwGlobalState.deviceInfo.subordinatesConnection = {};
          gwGlobalState.deviceInfo.subordinatesConnection[ws.deviceId] = true;
          gwutils2.gwUpdateGlobalState();
        } catch (e) {
        }
      } else if (actionrequest?.action == "subordinateredirect") {
        subordinateRedirectIP = actionrequest.payload.subordinateip;
        subordinateRedirectPassword = actionrequest.payload.subordinatepassword;
      } else if (actionrequest?.action == "sensorAdvertising") {
        try {
          gwutils2.broadcastEvent("subordinateSensorAdvertising", {
            sourcegw: ws.deviceId,
            payload: actionrequest?.payload
          });
        } catch (e) {
        }
      } else if (actionrequest?.action == "deviceinfo") {
        try {
          if (!gwGlobalState.deviceInfo.subordinates)
            gwGlobalState.deviceInfo.subordinates = {};
          gwGlobalState.deviceInfo.subordinates[ws.deviceId] = actionrequest?.payload;
          gwutils2.gwUpdateGlobalState();
          console.log(gwGlobalState.nodes[actionrequest?.payload.phantomCode].actionprogress);
        } catch (e) {
        }
      } else if (actionrequest?.action == "blecommand") {
        try {
          ble2.writeCommand(actionrequest?.payload.command);
        } catch (e) {
        }
      } else if (actionrequest?.action == "bleresponse") {
        try {
          ble2.serialPortOnData(actionrequest?.payload.command, ws.deviceId);
        } catch (e) {
        }
      } else if (actionrequest?.action == "sensorActionDispatch") {
        try {
          gwutils2.broadcastEvent("sensorActionDispatch", {
            action: actionrequest?.payload.sensorAction,
            actionParams: actionrequest?.payload.actionParams
          });
        } catch (e) {
        }
      } else if (actionrequest?.action == "sensorActionProgress") {
        try {
          gwutils2.broadcastEvent("sensorActionProgress", actionrequest?.payload);
        } catch (e) {
        }
      } else if (actionrequest.action && actionrequest.phantomcode) {
        if (gwGlobalState.nodes[actionrequest.phantomcode] === void 0)
          gwGlobalState.nodes[actionrequest.phantomcode] = {};
        if (gwGlobalState.nodes[actionrequest.phantomcode].actions === void 0)
          gwGlobalState.nodes[actionrequest.phantomcode].actions = {};
        if (gwGlobalState.nodes[actionrequest.phantomcode].actions[actionrequest.action] == void 0)
          gwGlobalState.nodes[actionrequest.phantomcode].actions[actionrequest.action] = {};
        gwGlobalState.nodes[actionrequest.phantomcode].actions[actionrequest.action].requestTime = Date.now();
        gwGlobalState.nodes[actionrequest.phantomcode].actions[actionrequest.action].params = actionrequest.params;
        gwutils2.gwUpdateGlobalState();
      }
    }
    async function handleGWBinaryRequest(actionrequest, ws) {
      if (g_fwFileOffset == 0) {
        g_fwFileOffset += actionrequest.length - 2;
        await fs2.writeFile(firmwareFilePath, actionrequest.subarray(2));
      } else {
        g_fwFileOffset += actionrequest.length - 2;
        await fs2.appendFile(firmwareFilePath, actionrequest.subarray(2));
      }
      ws.send(JSON.stringify({
        type: "fwupdateoffset",
        payload: {
          offset: g_fwFileOffset
        }
      }));
    }
    function connectRealTimeCloudServer() {
      console.log("Reconnect EI RT Server ....");
      gwGlobalState.deviceInfo.eianalytics.state = "connecting";
      gwutils2.gwUpdateGlobalState();
      let realtimeurl = "wss://rt.app.eianalytic.com/eirealtime/";
      if (gwGlobalState.deviceInfo.vendorId != 0) {
        realtimeurl = gwGlobalState.basicconfig.realtimeURL;
        if (!realtimeurl)
          return;
      }
      remoteEIRealtimeSocket = new WebSocket3(realtimeurl, {
        rejectUnauthorized: false,
        handshakeTimeout: 3e4
      });
      remoteEIRealtimeGotPong = true;
      if (!remoteEIRealtimeSocketPingInterval) {
        remoteEIRealtimeSocketPingInterval = setInterval(() => {
          try {
            if (remoteEIRealtimeSocket.readyState === WebSocket3.OPEN) {
              if (remoteEIRealtimeGotPong) {
                remoteEIRealtimeGotPong = false;
                remoteEIRealtimeSocket.ping();
              } else {
                remoteEIRealtimeSocket.terminate();
              }
            }
          } catch (e) {
          }
        }, 120 * 1e3);
      }
      remoteEIRealtimeSocket.on("open", function open(e) {
        remoteEIRealtimeGotPong = true;
        console.log("EI RT Server Connected");
        gwGlobalState.deviceInfo.eianalytics.state = "connected";
        gwGlobalState.deviceInfo.eianalytics.error = void 0;
        gwutils2.gwUpdateGlobalState();
        remoteEIRealtimeSocketObserved = false;
        remoteEIRealtimeSocketObservedSubordinates = {};
        remoteEIRealtimeSocket.send(JSON.stringify({
          type: "hello",
          deviceId: gwGlobalState.deviceInfo.serialNumber,
          authtoken: gwGlobalState.basicconfig.eiaauthtoken
        }));
      });
      remoteEIRealtimeSocket.on("close", function message(code, reason) {
        remoteEIRealtimeGotPong = true;
        console.log("Disconnected from EI Realtime server", code);
        gwGlobalState.deviceInfo.eianalytics.state = "disconnected";
        gwutils2.gwUpdateGlobalState();
        if (code != 1e3) {
          remoteEIRealtimeSocket.removeAllListeners();
          remoteEIRealtimeSocket = null;
          setTimeout(connectRealTimeCloudServer, Math.floor(Math.random() * (1e4 - 2e3) + 2e3));
        }
      });
      remoteEIRealtimeSocket.on("pong", () => {
        remoteEIRealtimeGotPong = true;
      });
      remoteEIRealtimeSocket.on("error", function message(e) {
        gwGlobalState.deviceInfo.eianalytics.error = e.message;
        gwutils2.gwUpdateGlobalState();
        console.log("EI Realtime server error", e);
        remoteEIRealtimeSocket.close();
      });
      remoteEIRealtimeSocket.on("message", async function message(actionrequest) {
        try {
          if (actionrequest[0] == 17 && actionrequest[1] == 18) {
            handleGWBinaryRequest(actionrequest, remoteEIRealtimeSocket);
          } else {
            let jsonMessage = JSON.parse(actionrequest);
            if (jsonMessage.type == "observed") {
              if (jsonMessage.subordinate) {
                remoteEIRealtimeSocketObservedSubordinates[jsonMessage.subordinate] = jsonMessage.observed;
                if (remoteEIRealtimeSocketObservedSubordinates[jsonMessage.subordinate]) {
                  let ws = findSubordinateGW(jsonMessage.subordinate);
                  if (ws && ws.gwState) {
                    remoteEIRealtimeSocket.send(JSON.stringify({
                      type: "stateupdate",
                      subordinate: jsonMessage.subordinate,
                      payload: ws.gwState,
                      sendTime: Date.now()
                    }));
                  }
                }
              } else {
                remoteEIRealtimeSocketObserved = jsonMessage.observed;
                if (remoteEIRealtimeSocketObserved) {
                  updateAllClients(remoteEIRealtimeSocket);
                  remoteEIRealtimeSocket.send(JSON.stringify({
                    type: "stateupdate",
                    payload: gwGlobalState,
                    sendTime: Date.now()
                  }));
                }
                console.log("Observed status changed!: ", remoteEIRealtimeSocketObserved);
              }
            }
            if (jsonMessage.type == "autherror") {
              if (gwGlobalState.basicconfig.connectotoeianalytics) {
                gwGlobalState.deviceInfo.eianalytics.state = "autherror";
                gwutils2.gwUpdateGlobalState();
                setTimeout(() => {
                  try {
                    remoteEIRealtimeSocket.close();
                  } catch (e) {
                  }
                }, Math.floor(Math.random() * (24e4 - 12e4) + 12e4));
              }
            } else {
              if (jsonMessage.subordinate) {
                let subws = findSubordinateGW(jsonMessage.subordinate);
                if (subws) {
                  jsonMessage.subordinate = void 0;
                  subws.send(JSON.stringify(jsonMessage));
                }
              } else {
                parseGWRequest(jsonMessage, remoteEIRealtimeSocket);
              }
            }
          }
        } catch (e) {
        }
      });
    }
    function connectToMainGWAsSubordinate() {
      console.log("Reconnect to main GW ....");
      gwutils2.setSubordinateConnected(false);
      gwGlobalState.deviceInfo.maingw.state = "connecting";
      gwutils2.gwUpdateGlobalState();
      let realtimeurl = gwGlobalState.basicconfig.subordinateip;
      if (gwGlobalState.basicconfig.meshmode == 2) {
        realtimeurl = "[fd66:66:66::1]";
      }
      if (subordinateRedirectIP) {
        realtimeurl = subordinateRedirectIP;
      }
      if (!realtimeurl)
        return;
      realtimeurl = "ws://" + realtimeurl + "/realtime/";
      subordinateRealtimeSocket = new WebSocket3(realtimeurl, {
        rejectUnauthorized: false,
        handshakeTimeout: 3e4
      });
      subordinateGotPong = true;
      if (!subordinatePingInterval) {
        subordinatePingInterval = setInterval(() => {
          try {
            if (subordinateRealtimeSocket.readyState === WebSocket3.OPEN) {
              if (subordinateGotPong) {
                subordinateGotPong = false;
                subordinateRealtimeSocket.ping();
              } else {
                subordinateRealtimeSocket.terminate();
              }
            }
          } catch (e) {
          }
        }, 5 * 1e3);
      }
      subordinateRealtimeSocket.on("open", function open(e) {
        if (gwGlobalState.basicconfig.subordinatepassword || subordinateRedirectPassword) {
          subordinateRealtimeSocket.send(JSON.stringify({
            type: "observeerequest",
            action: "auth",
            security: {
              user: "admin",
              password: subordinateRedirectPassword ? subordinateRedirectPassword : gwGlobalState.basicconfig.subordinatepassword
            }
          }));
        }
        console.log("main gw Server Connected");
        gwutils2.setSubordinateConnected(true);
        subordinateGotPong = true;
        gwGlobalState.deviceInfo.maingw.state = "connected";
        gwGlobalState.deviceInfo.maingw.error = void 0;
        gwutils2.gwUpdateGlobalState();
        subordinateRealtimeSocket.send(JSON.stringify({
          type: "observeerequest",
          action: "subordinatehello",
          deviceId: gwGlobalState.deviceInfo.serialNumber
        }));
        updateAllClients(subordinateRealtimeSocket);
        subordinateRealtimeSocket.send(JSON.stringify({
          type: "stateupdate",
          payload: gwGlobalState,
          sendTime: Date.now()
        }));
      });
      subordinateRealtimeSocket.on("close", function message(code, reason) {
        subordinateGotPong = true;
        gwutils2.setSubordinateConnected(false);
        console.log("Disconnected from main gw", reason);
        gwGlobalState.deviceInfo.maingw.state = "disconnected";
        gwutils2.gwUpdateGlobalState();
        if (invalidateRedirectNext) {
          subordinateRedirectIP = null;
          subordinateRedirectPassword = null;
          invalidateRedirectNext = false;
        } else {
          invalidateRedirectNext = true;
        }
        if (code != 1e3) {
          subordinateRealtimeSocket.removeAllListeners();
          subordinateRealtimeSocket = null;
          setTimeout(connectToMainGWAsSubordinate, 1e3);
        }
      });
      subordinateRealtimeSocket.on("error", function message(e) {
        gwutils2.setSubordinateConnected(false);
        gwGlobalState.deviceInfo.maingw.error = e.message;
        gwutils2.gwUpdateGlobalState();
        console.log("Main gw server error", e);
        subordinateRealtimeSocket.close();
      });
      subordinateRealtimeSocket.on("pong", () => {
        subordinateGotPong = true;
      });
      subordinateRealtimeSocket.on("message", async function message(actionrequest) {
        try {
          if (actionrequest[0] == 17 && actionrequest[1] == 18) {
            handleGWBinaryRequest(actionrequest, subordinateRealtimeSocket);
          } else {
            let jsonMessage = JSON.parse(actionrequest, (key, value) => {
              return value && value.type === "Buffer" ? Buffer.from(value) : value;
            });
            if (jsonMessage.type == "autherror") {
              gwGlobalState.deviceInfo.maingw.state = "autherror";
              gwutils2.gwUpdateGlobalState();
              setTimeout(() => {
                try {
                  subordinateRealtimeSocket.close();
                } catch (e) {
                }
              }, Math.floor(Math.random() * (24e4 - 12e4) + 12e4));
            } else {
              parseGWRequest(jsonMessage, subordinateRealtimeSocket);
            }
          }
        } catch (e) {
        }
      });
    }
    function updateAllClients(ignoreConn) {
      let patch = gwutils2.getPatches();
      localWSConnections.forEach((socket) => {
        if (socket.needsauth || ignoreConn == socket || socket.subordinate || socket.observingSubordinate || socket.disablestateupdates)
          return;
        socket.send(JSON.stringify({
          type: "statepatch",
          payload: patch,
          sendTime: Date.now()
        }));
      });
      if (remoteEIRealtimeSocket) {
        try {
          if (remoteEIRealtimeSocketObserved && remoteEIRealtimeSocket != ignoreConn) {
            remoteEIRealtimeSocket.send(JSON.stringify({
              type: "statepatch",
              payload: patch,
              sendTime: Date.now()
            }));
          }
        } catch (e) {
        }
      }
      if (subordinateRealtimeSocket) {
        try {
          if (subordinateRealtimeSocket != ignoreConn) {
            subordinateRealtimeSocket.send(JSON.stringify({
              type: "statepatch",
              payload: patch,
              sendTime: Date.now()
            }));
          }
        } catch (e) {
        }
      }
    }
    async function gwAPIStartExternalConnections() {
      if (gwutils2.isSubordinate()) {
        connectToMainGWAsSubordinate();
      }
      if ((gwGlobalState.basicconfig.connectotoeianalytics || !gwGlobalState.basicconfig.disableeianalyticsconnection) && !gwutils2.isSubordinate()) {
        connectRealTimeCloudServer();
      }
    }
    async function gwAPIStart(_gwGlobalState) {
      gwGlobalState = _gwGlobalState;
      const App2 = (await Promise.resolve().then(() => (init_dist21(), dist_exports4))).App;
      const json3 = (await Promise.resolve().then(() => (init_dist22(), dist_exports5))).json;
      const tinyws2 = (await Promise.resolve().then(() => (init_dist23(), dist_exports6))).tinyws;
      gwGlobalState.deviceInfo.eianalytics = {
        state: "disabled"
      };
      gwGlobalState.deviceInfo.maingw = {
        state: "disabled"
      };
      gwutils2.gwUpdateGlobalState();
      const tinyhttpapp = new App2({
        settings: {
          xPoweredBy: false
        }
      });
      tinyhttpapp.use(tinyws2());
      tinyhttpapp.use("/", sirv("testfront/dist", {
        maxAge: 0,
        setHeaders: (res, pathname, stats) => {
          res.setHeader("X-Frame-Options", "DENY");
          res.setHeader(
            "Content-Security-Policy",
            "default-src 'self'; font-src 'self' data: https://fonts.gstatic.com; img-src 'self' data:; script-src 'self' 'nonce-xQr1i9WgXjp' https://fonts.googleapis.com; style-src 'self' 'nonce-xQr1i9WgXjp' https://fonts.googleapis.com; frame-src 'self'; frame-ancestors 'self'; form-action 'self'"
          );
          res.setHeader("X-Content-Type-Options", "nosniff");
        }
      }));
      setInterval(() => {
        updateAllClients();
      }, 1e3);
      gwutils2.subscribeToEvent("globalstateupdated", async (e) => {
        updateAllClients();
      });
      gwutils2.subscribeToEvent("sensorAdvertising", async (e) => {
        try {
          sendToMainGW("sensorAdvertising", e);
        } catch (e2) {
        }
      });
      gwutils2.subscribeToEvent("newsignal", async (eventdata) => {
        localWSConnections.forEach((socket) => {
          if (!socket.wantdata)
            return;
          let metadata = null;
          let data = [];
          try {
            metadata = phantomService2.parsePhantomV1SignalHeader(eventdata.header);
            if (metadata.timestamp == 0)
              metadata.timestamp = eventdata.signalData.captureTime;
            data.push([]);
            data.push([]);
            data.push([]);
            if (metadata) {
              let calibration = metadata.range / 32768;
              if (metadata.axisCount == 3) {
                for (let i = 0; i * 6 < metadata.dataLen; i++) {
                  data[0].push(eventdata.data.readInt16LE(i * 6 + 0) * calibration);
                  data[1].push(eventdata.data.readInt16LE(i * 6 + 2) * calibration);
                  data[2].push(eventdata.data.readInt16LE(i * 6 + 4) * calibration);
                }
              } else if (metadata.axisCount == 1) {
                for (let i = 0; i * 2 < metadata.dataLen; i++) {
                  data[metadata.selectedAxis].push(eventdata.data.readInt16LE(i * 2 + 0) * calibration);
                }
              }
            }
          } catch (e) {
            console.log("Error when trying to generate mqtt mensage: ", e.message);
          }
          try {
            let mqttData = {
              serialNumber: metadata.phantomCode,
              sampleRate: metadata.sampleRate,
              gwSerial: gwGlobalState.deviceInfo.serialNumber,
              timestamp: metadata.timestamp,
              type: metadata.type,
              dataType: "collection",
              data
            };
            socket.send(JSON.stringify({
              type: "sensordata",
              payload: mqttData,
              sendTime: Date.now()
            }));
          } catch (e) {
          }
        });
      });
      gwutils2.subscribeToEvent("wiredstream", async (e) => {
        let json4 = null;
        localWSConnections.forEach((socket) => {
          if (socket.needsauth || !socket.getWiredStream)
            return;
          socket.send(Buffer.from([17, 19]), { fin: false, binary: true });
          socket.send(e.payload, { fin: true, binary: true });
        });
      });
      tinyhttpapp.use("/realtime", async (req, res) => {
        if (req.ws) {
          const ws = await req.ws();
          ws.observingSubordinate = req.query.subordinate;
          ws.gotPong = true;
          ws.pingInterval = setInterval(() => {
            try {
              if (ws.gotPong) {
                ws.gotPong = false;
                ws.ping();
              } else {
                console.log("Didn't got pong from client");
                ws.terminate();
              }
            } catch (e) {
            }
          }, 5 * 1e3);
          ws.remoteAddress = req.connection.remoteAddress;
          let security = await gwutils2.loadSecurity();
          let isMesh = ws.remoteAddress.startsWith("169.254") || ws.remoteAddress.includes("fd66:66:66");
          if (security.password && !isMesh) {
            ws.needsauth = true;
            ws.send(JSON.stringify({
              type: "auth",
              payload: {
                needsauth: true
              }
            }));
          } else {
            ws.needsauth = false;
            ws.send(JSON.stringify({
              type: "auth",
              payload: {
                needsauth: false
              }
            }));
            if (ws.observingSubordinate) {
              let subWS = findSubordinateGW(ws.observingSubordinate);
              if (subWS && subWS.gwState) {
                ws.send(JSON.stringify({
                  type: "stateupdate",
                  subordinate: ws.observingSubordinate,
                  payload: subWS.gwState,
                  sendTime: Date.now()
                }));
              }
            } else {
              updateAllClients(ws);
              ws.send(JSON.stringify({
                type: "stateupdate",
                payload: gwGlobalState,
                sendTime: Date.now()
              }));
            }
          }
          localWSConnections.push(ws);
          ws.on("message", async (message) => {
            if (ws.needsauth) {
              let actionrequest = JSON.parse(message);
              if (actionrequest.action != "auth" || !actionrequest.security.user || !actionrequest.security.password)
                return;
              let security2 = await gwutils2.loadSecurity();
              if (actionrequest.security.user == "admin" && actionrequest.security.password == security2.password) {
                ws.needsauth = false;
                ws.send(JSON.stringify({
                  type: "auth",
                  payload: {
                    needsauth: false
                  }
                }));
                updateAllClients(ws);
                ws.send(JSON.stringify({
                  type: "stateupdate",
                  payload: gwGlobalState,
                  sendTime: Date.now()
                }));
              } else {
                ws.send(JSON.stringify({
                  type: "auth",
                  payload: {
                    needsauth: true,
                    wrongtry: true
                  }
                }));
              }
            }
            if (message[0] == 17 && message[1] == 18) {
              handleGWBinaryRequest(message, ws);
            } else {
              try {
                let actionrequest = JSON.parse(message, (key, value) => {
                  return value && value.type === "Buffer" ? Buffer.from(value) : value;
                });
                if (ws.subordinate && actionrequest.type != "subordinaterequest") {
                  if (actionrequest?.type == "stateupdate") {
                    try {
                      ws.gwState = actionrequest?.payload;
                      localWSConnections.forEach((socket) => {
                        if (socket.observingSubordinate == ws.deviceId) {
                          socket.send(JSON.stringify({
                            type: "stateupdate",
                            subordinate: ws.deviceId,
                            payload: actionrequest?.payload,
                            sendTime: Date.now()
                          }));
                        }
                      });
                      if (remoteEIRealtimeSocketObservedSubordinates[ws.deviceId]) {
                        remoteEIRealtimeSocket.send(JSON.stringify({
                          type: "stateupdate",
                          subordinate: ws.deviceId,
                          payload: actionrequest?.payload,
                          sendTime: Date.now()
                        }));
                      }
                    } catch (e) {
                    }
                  } else if (actionrequest?.type == "statepatch") {
                    try {
                      jsonpatch.applyPatch(ws.gwState, actionrequest?.payload, true, true);
                      localWSConnections.forEach((socket) => {
                        if (socket.observingSubordinate == ws.deviceId) {
                          socket.send(JSON.stringify({
                            type: "statepatch",
                            subordinate: ws.deviceId,
                            payload: actionrequest?.payload,
                            sendTime: Date.now()
                          }));
                        }
                      });
                      if (remoteEIRealtimeSocketObservedSubordinates[ws.deviceId]) {
                        remoteEIRealtimeSocket.send(JSON.stringify({
                          type: "statepatch",
                          subordinate: ws.deviceId,
                          payload: actionrequest?.payload,
                          sendTime: Date.now()
                        }));
                      }
                    } catch (e) {
                      console.log(e);
                    }
                  } else {
                    if (remoteEIRealtimeSocketObservedSubordinates[ws.deviceId]) {
                      console.log(actionrequest);
                      actionrequest.subordinate = ws.deviceId;
                      actionrequest.sendTime = Date.now();
                      remoteEIRealtimeSocket.send(JSON.stringify(actionrequest));
                    }
                    localWSConnections.forEach((socket) => {
                      if (socket.observingSubordinate == ws.deviceId) {
                        actionrequest.subordinate = ws.deviceId;
                        actionrequest.sendTime = Date.now();
                        socket.send(JSON.stringify(actionrequest));
                      }
                    });
                  }
                } else if (ws.observingSubordinate) {
                  let subws = findSubordinateGW(ws.observingSubordinate);
                  if (subws) {
                    actionrequest.subordinate = void 0;
                    subws.send(JSON.stringify(actionrequest));
                  }
                } else {
                  parseGWRequest(actionrequest, ws);
                }
              } catch (e) {
              }
            }
          });
          ws.on("close", () => {
            clearInterval(ws.pingInterval);
            localWSConnections = localWSConnections.filter((conn) => conn === ws ? false : true);
            if (ws.subordinate && !findSubordinateGW(ws.deviceId)) {
              gwGlobalState.deviceInfo.subordinatesConnection[ws.deviceId] = false;
              gwutils2.gwUpdateGlobalState();
            }
          });
          ws.on("pong", () => {
            ws.gotPong = true;
          });
        } else {
          res.send("Error");
        }
      });
      let port2 = 80;
      if (process.platform == "win32") {
        try {
          let configFile = "gwconfig.json";
          let filecontents = await fs2.readFile(configFile);
          port2 = JSON.parse(await fs2.readFile(configFile)).port;
        } catch (e) {
        }
      }
      if (!port2)
        port2 = 80;
      tinyhttpapp.listen(port2, void 0, "::");
    }
    function sendToSubordinate(gwSerial, type, payload) {
      for (let i = 0; i < localWSConnections.length; i++) {
        let ws = localWSConnections[i];
        if (!ws.subordinate)
          continue;
        if (ws.deviceId == gwSerial) {
          console.log("Sending message to subordinate", gwSerial, type);
          ws.send(JSON.stringify({
            type: "observeerequest",
            action: type,
            payload
          }));
          return true;
        }
      }
      console.log("sendToSubordinate failed");
      return false;
    }
    function sendToMainGW(type, payload) {
      if (subordinateRealtimeSocket) {
        try {
          subordinateRealtimeSocket.send(JSON.stringify({
            type: "subordinaterequest",
            action: type,
            payload
          }));
        } catch (e) {
        }
        return true;
      }
      return false;
    }
    module2.exports.gwAPIStart = gwAPIStart;
    module2.exports.parseGWRequest = parseGWRequest;
    module2.exports.sendToSubordinate = sendToSubordinate;
    module2.exports.sendToMainGW = sendToMainGW;
    module2.exports.gwAPIStartExternalConnections = gwAPIStartExternalConnections;
  }
});

// src/systemmon.js
var require_systemmon = __commonJS({
  "src/systemmon.js"(exports2, module2) {
    "use strict";
    var fs2 = require("fs").promises;
    var gwutils2 = require_gwutils();
    var os2 = require("os");
    var path3 = require("path");
    var ble2 = require_nrf_ble();
    var gwapi2 = require_gwapi();
    var disk = null;
    if (process.platform == "linux" && false) {
      disk = null;
    }
    var cputempFile = "/sys/devices/virtual/thermal/thermal_zone0/temp";
    var timeZonePath = "/usr/share/zoneinfo/uclibc/";
    var wifimacaddressPath = "/sys/class/net/wlan0/address";
    var wifiAPmacaddressPath = "/sys/class/net/wlan1/address";
    var ethmacaddressPath = "/sys/class/net/eth0/address";
    async function getLinkQuality() {
      let linkQuality = 0;
      try {
        let netwireless = "/proc/net/wireless";
        let nw = await fs2.readFile(netwireless, "utf8");
        let lines = nw.split("\n");
        for (let i = 0; i < lines.length; i++) {
          let line = lines[i].trim();
          if (line.startsWith("wlan0")) {
            let parts = line.split(/\s+/);
            linkQuality = Number(parts[2]);
            linkQuality /= 70;
          }
        }
      } catch (e) {
      }
      return linkQuality;
    }
    async function run(gwGlobalState) {
      try {
        let wifimac = (await fs2.readFile(wifimacaddressPath, "utf8")).trim().toLowerCase();
        gwGlobalState.deviceInfo.wifimac = wifimac;
      } catch (e) {
      }
      try {
        let wifimac = (await fs2.readFile(wifiAPmacaddressPath, "utf8")).trim().toLowerCase();
        gwGlobalState.deviceInfo.apmac = wifimac;
      } catch (e) {
      }
      try {
        let eth0mac = (await fs2.readFile(ethmacaddressPath, "utf8")).trim().toLowerCase();
        gwGlobalState.deviceInfo.ethmac = eth0mac;
      } catch (e) {
      }
      while (true) {
        try {
          gwGlobalState.deviceInfo.uptime = os2.uptime();
          gwGlobalState.deviceInfo.totalmem = os2.totalmem();
          gwGlobalState.deviceInfo.freemem = os2.freemem();
          gwGlobalState.deviceInfo.loadavg = os2.loadavg();
          gwGlobalState.deviceInfo.wifiLinkQuality = await getLinkQuality();
          if (disk) {
            let diskinfo = await disk.check("/data");
            gwGlobalState.deviceInfo.disk = {
              available: diskinfo.available,
              free: diskinfo.free,
              total: diskinfo.total
            };
          }
          let cpuTemp = parseFloat(await fs2.readFile(cputempFile, "utf8")) / 1e3;
          let fanstelDiff = gwGlobalState.deviceInfo.btTemperature - cpuTemp;
          if (fanstelDiff > 20) {
            cpuTemp += 30;
            gwGlobalState.deviceInfo.cpuTemperatureCorrected = true;
          } else {
            gwGlobalState.deviceInfo.cpuTemperatureCorrected = false;
          }
          gwGlobalState.deviceInfo.cpuTemperature = cpuTemp;
          ble2.requestTemperature();
          gwutils2.gwUpdateGlobalState();
          if (gwutils2.isSubordinate())
            gwapi2.sendToMainGW("deviceinfo", gwGlobalState.deviceInfo);
        } catch (e) {
        }
        await gwutils2.sleep(1e4);
      }
    }
    async function getTimeZones() {
      let fileTree = [];
      try {
        let offlinefilesDir = await fs2.opendir(timeZonePath);
        let currentDir = null;
        while (currentDir = await offlinefilesDir.read()) {
          if (currentDir.isDirectory()) {
            let innerDir = await fs2.opendir(path3.join(timeZonePath, currentDir.name));
            let currentFile;
            while (currentFile = await innerDir.read()) {
              fileTree.push(currentDir.name + "/" + currentFile.name);
            }
            innerDir.close();
          } else {
            fileTree.push(currentDir.name);
          }
        }
        offlinefilesDir.close();
      } catch (e) {
      }
      return fileTree;
    }
    module2.exports.run = run;
    module2.exports.getTimeZones = getTimeZones;
  }
});

// src/cloudupload.js
var require_cloudupload = __commonJS({
  "src/cloudupload.js"(exports2, module2) {
    var axios = require_axios2();
    var https = require("https");
    var gwutils2 = require_gwutils();
    var phantomService2 = require_phantomService().phantomService;
    var WEBSERVICE_BASE_URL = "https://eiaws.eianalytic.com/PhantomService.svc/";
    var CloudUpload = class _CloudUpload {
      static async init(gwGlobalState) {
        gwGlobalState.deviceInfo.eiAnalyticsStatus = "unknow";
        gwGlobalState.deviceInfo.alternateCloudState == "unknow";
        if (gwGlobalState.basicconfig.sendtoeianalytics) {
          try {
            let response = await axios.get(WEBSERVICE_BASE_URL + "ServiceOk", {
              httpsAgent: new https.Agent({
                rejectUnauthorized: !gwGlobalState.basicconfig.disablecertificatevalidation
              }),
              responseType: "json"
            });
            if (gwGlobalState.deviceInfo.eiAnalyticsStatus == "unknow")
              gwGlobalState.deviceInfo.eiAnalyticsStatus = "ok";
          } catch (e) {
            if (gwGlobalState.deviceInfo.eiAnalyticsStatus == "unknow") {
              gwGlobalState.deviceInfo.eiAnalyticsStatus = "error";
              gwGlobalState.deviceInfo.eiAnalyticsStatusError = e.message;
            }
          }
        }
        gwutils2.subscribeToEvent("newsignal", async (eventdata) => {
          try {
            await _CloudUpload.queueBigDataUpload(gwGlobalState, eventdata);
          } catch (e) {
            eventdata.signalData.services.eianalytics = {};
            eventdata.signalData.services.eianalytics.state = "sent";
            gwutils2.broadcastEvent("signalsent", eventdata);
          }
        });
        gwutils2.subscribeToEvent("newphantomv1broadcast", async (eventdata) => {
          try {
            await _CloudUpload.queueSmallDataUpload(gwGlobalState, eventdata);
          } catch (e) {
          }
        });
      }
      static async queueBigDataUpload(gwGlobalState, eventdata) {
        var now = new Date(eventdata.signalData.captureTime * 1e3);
        let datestr = gwutils2.stringFormat(
          "{0}-{1}-{2} {3}:{4}:{5}",
          now.getFullYear(),
          now.getMonth() + 1,
          now.getDate(),
          now.getHours(),
          now.getMinutes(),
          now.getSeconds()
        );
        let newheader = null;
        if (phantomService2.isTriaxial(eventdata.node.type) || phantomService2.isGP(eventdata.node.type)) {
          let metadata = phantomService2.parsePhantomV1SignalHeader(eventdata.header);
          if (metadata.timestamp == 0)
            metadata.timestamp = eventdata.signalData.captureTime;
          metadata.alarm = eventdata.signalData.alarm;
          metadata.start = eventdata.signalData.start;
          metadata.triggered = eventdata.signalData.triggered;
          newheader = phantomService2.createPhantomv1CompatibleSignalHeader(metadata);
          if (metadata.dataLen != eventdata.data.length) {
            console.log("Unexpected data size!");
            return;
          }
        } else if (phantomService2.isThermalImage(eventdata.node.type)) {
          let metadata = phantomService2.parsePhantomV1ThermalImageHeader(eventdata.header);
          newheader = phantomService2.createPhantomv1CompatibleThermalImageHeader(
            metadata.phantomCode,
            metadata.columns,
            metadata.rows,
            metadata.dataSize,
            1,
            // frames
            1,
            // frameRate
            eventdata.signalData.captureTime,
            metadata.frames,
            metadata.frameRate
          );
          if (metadata.dataSize != eventdata.data.length) {
            console.log("Unexpected data size!");
            return;
          }
        }
        let fulldata = Buffer.alloc(eventdata.data.length + newheader.length);
        newheader.copy(fulldata);
        eventdata.data.copy(fulldata, 32);
        if (gwGlobalState.basicconfig.sendtoeianalytics) {
          if (eventdata.signalData.services.eianalytics?.state != "sent") {
            eventdata.signalData.services.eianalytics = {};
            eventdata.signalData.services.eianalytics.state = "connecting";
            try {
              let response = await axios.post(WEBSERVICE_BASE_URL + "PhantomBigDataBlock", fulldata, {
                httpsAgent: new https.Agent({
                  rejectUnauthorized: !gwGlobalState.basicconfig.disablecertificatevalidation
                }),
                headers: {
                  "EI-Auth2": gwGlobalState.basicconfig.eiaauthtoken,
                  "EI-GW": gwGlobalState.deviceInfo.serialNumber,
                  "Content-Type": "application/octet-stream",
                  "Date-request": datestr,
                  "User-Agent": "Erbessd Instruments Phantom Gateway 2.0/" + gwGlobalState.deviceInfo.version
                }
              });
              eventdata.signalData.services.eianalytics.state = "sent";
              gwGlobalState.deviceInfo.eiAnalyticsStatus = "ok";
              gwutils2.broadcastEvent("signalsent", eventdata);
              try {
                if (response.data.StatusNumber != 0 && response.data.StatusNumber != 591) {
                  gwGlobalState.nodes[eventdata.signalData.phantomCode].EIAnalyticsFail = true;
                  gwGlobalState.nodes[eventdata.signalData.phantomCode].EIAnalyticsFailNumber = response.data.StatusNumber;
                } else {
                  gwGlobalState.nodes[eventdata.signalData.phantomCode].EIAnalyticsFail = false;
                }
              } catch (e) {
              }
              console.log("EI Analytic Big data sent", JSON.stringify(response.data));
            } catch (e) {
              eventdata.signalData.services.eianalytics.state = "error";
              eventdata.signalData.services.eianalytics.error = e.message;
              gwGlobalState.deviceInfo.eiAnalyticsStatus = "error";
              gwGlobalState.deviceInfo.eiAnalyticsStatusError = e.message;
              gwutils2.broadcastEvent("signalfailsend", eventdata);
              console.log("EI analytic send error", e.message);
            }
          }
        }
        if (gwGlobalState.basicconfig.isalternateurl) {
          if (eventdata.signalData.services.alternatecloud?.state != "sent") {
            try {
              eventdata.signalData.services.alternatecloud = {};
              eventdata.signalData.services.alternatecloud.state = "connecting";
              let authtoken = gwGlobalState.basicconfig.alternateauthtoken ? gwGlobalState.basicconfig.alternateauthtoken : "";
              let isJSON = gwGlobalState.basicconfig.alternateurlformat == 1;
              let endpoint = gwGlobalState.basicconfig.endpointurl + "PhantomBigDataBlock";
              if (isJSON) {
                fulldata = phantomService2.bigDataToJSON(eventdata, gwGlobalState);
                endpoint = gwGlobalState.basicconfig.endpointurl;
              }
              let response = await axios.post(endpoint, fulldata, {
                httpsAgent: new https.Agent({
                  rejectUnauthorized: !gwGlobalState.basicconfig.disablecertificatevalidation
                }),
                headers: {
                  "Content-Type": isJSON ? "application/json" : "application/octet-stream",
                  "Date-request": datestr,
                  "EI-Auth2": authtoken,
                  "EI-GW": gwGlobalState.deviceInfo.serialNumber,
                  "User-Agent": "Erbessd Instruments Phantom Gateway 2.0/" + gwGlobalState.deviceInfo.version
                }
              });
              eventdata.signalData.services.alternatecloud.state = "sent";
              gwGlobalState.deviceInfo.alternateCloudState = "ok";
              gwutils2.broadcastEvent("signalsent", eventdata);
            } catch (e) {
              eventdata.signalData.services.alternatecloud.state = "error";
              eventdata.signalData.services.alternatecloud.error = e.message;
              gwGlobalState.deviceInfo.alternateCloudState = "error";
              gwutils2.broadcastEvent("signalfailsend", eventdata);
            }
          }
        }
      }
      static async queueSmallDataUpload(gwGlobalState, eventdata) {
        if (!eventdata || !eventdata.messages)
          return;
        let didalternatejson = false;
        let now = /* @__PURE__ */ new Date();
        if (eventdata.captureTime)
          now = new Date(eventdata.captureTime * 1e3);
        let datestr = gwutils2.stringFormat(
          "{0}-{1}-{2} {3}:{4}:{5}",
          now.getFullYear(),
          now.getMonth() + 1,
          now.getDate(),
          now.getHours(),
          now.getMinutes(),
          now.getSeconds()
        );
        for (let i = 0; i < eventdata.messages.length; i++) {
          let message = eventdata.messages[i];
          if (gwGlobalState.basicconfig.sendtoeianalytics) {
            try {
              let response = await axios.post(WEBSERVICE_BASE_URL + "PhantomSmallDataBlock", message, {
                httpsAgent: new https.Agent({
                  rejectUnauthorized: !gwGlobalState.basicconfig.disablecertificatevalidation
                }),
                headers: {
                  "EI-Auth2": gwGlobalState.basicconfig.eiaauthtoken,
                  "EI-GW": gwGlobalState.deviceInfo.serialNumber,
                  "Content-Type": "application/octet-stream",
                  "Date-request": datestr,
                  "User-Agent": "Erbessd Instruments Phantom Gateway 2.0/" + gwGlobalState.deviceInfo.version
                }
              });
              gwGlobalState.deviceInfo.eiAnalyticsStatus = "ok";
              try {
                if (response.data.StatusNumber != 0) {
                  gwGlobalState.nodes[eventdata.phantomCode].EIAnalyticsFail = true;
                  gwGlobalState.nodes[eventdata.phantomCode].EIAnalyticsFailNumber = response.data.StatusNumber;
                } else {
                  gwGlobalState.nodes[eventdata.phantomCode].EIAnalyticsFail = false;
                }
              } catch (e) {
              }
              console.log("Small data sent", JSON.stringify(response.data));
            } catch (e) {
              gwGlobalState.deviceInfo.eiAnalyticsStatus = "error";
              gwGlobalState.deviceInfo.eiAnalyticsStatusError = e.message;
            }
          }
          if (gwGlobalState.basicconfig.isalternateurl) {
            try {
              if (didalternatejson)
                return;
              let authtoken = gwGlobalState.basicconfig.alternateauthtoken ? gwGlobalState.basicconfig.alternateauthtoken : "";
              let isJSON = gwGlobalState.basicconfig.alternateurlformat == 1;
              let endpoint = gwGlobalState.basicconfig.endpointurl + "PhantomSmallDataBlock";
              if (isJSON) {
                let node = gwGlobalState.nodes[eventdata.phantomCode];
                message = phantomService2.smallDataToJSON(node, Math.floor(now / 1e3), gwGlobalState);
                endpoint = gwGlobalState.basicconfig.endpointurl;
                didalternatejson = true;
              }
              let response = await axios.post(endpoint, message, {
                httpsAgent: new https.Agent({
                  rejectUnauthorized: !gwGlobalState.basicconfig.disablecertificatevalidation
                }),
                headers: {
                  "Content-Type": isJSON ? "application/json" : "application/octet-stream",
                  "Date-request": datestr,
                  "EI-Auth2": authtoken,
                  "EI-GW": gwGlobalState.deviceInfo.serialNumber,
                  "User-Agent": "Erbessd Instruments Phantom Gateway 2.0/" + gwGlobalState.deviceInfo.version
                }
              });
              gwGlobalState.deviceInfo.alternateCloudState = "ok";
              console.log("Alternate Small data response", JSON.stringify(response.data));
            } catch (e) {
              gwGlobalState.deviceInfo.alternateCloudState = "error";
            }
          }
        }
      }
    };
    module2.exports = {
      CloudUpload
    };
  }
});

// node_modules/xtend/immutable.js
var require_immutable = __commonJS({
  "node_modules/xtend/immutable.js"(exports2, module2) {
    module2.exports = extend;
    var hasOwnProperty = Object.prototype.hasOwnProperty;
    function extend() {
      var target = {};
      for (var i = 0; i < arguments.length; i++) {
        var source = arguments[i];
        for (var key in source) {
          if (hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }
      return target;
    }
  }
});

// node_modules/readable-stream/lib/internal/streams/stream.js
var require_stream2 = __commonJS({
  "node_modules/readable-stream/lib/internal/streams/stream.js"(exports2, module2) {
    module2.exports = require("stream");
  }
});

// node_modules/readable-stream/lib/internal/streams/buffer_list.js
var require_buffer_list = __commonJS({
  "node_modules/readable-stream/lib/internal/streams/buffer_list.js"(exports2, module2) {
    "use strict";
    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);
      if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        enumerableOnly && (symbols = symbols.filter(function(sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        })), keys.push.apply(keys, symbols);
      }
      return keys;
    }
    function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = null != arguments[i] ? arguments[i] : {};
        i % 2 ? ownKeys(Object(source), true).forEach(function(key) {
          _defineProperty(target, key, source[key]);
        }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function(key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
      return target;
    }
    function _defineProperty(obj, key, value) {
      key = _toPropertyKey(key);
      if (key in obj) {
        Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }
      return obj;
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      Object.defineProperty(Constructor, "prototype", { writable: false });
      return Constructor;
    }
    function _toPropertyKey(arg) {
      var key = _toPrimitive(arg, "string");
      return typeof key === "symbol" ? key : String(key);
    }
    function _toPrimitive(input, hint) {
      if (typeof input !== "object" || input === null)
        return input;
      var prim = input[Symbol.toPrimitive];
      if (prim !== void 0) {
        var res = prim.call(input, hint || "default");
        if (typeof res !== "object")
          return res;
        throw new TypeError("@@toPrimitive must return a primitive value.");
      }
      return (hint === "string" ? String : Number)(input);
    }
    var _require = require("buffer");
    var Buffer2 = _require.Buffer;
    var _require2 = require("util");
    var inspect = _require2.inspect;
    var custom2 = inspect && inspect.custom || "inspect";
    function copyBuffer(src, target, offset) {
      Buffer2.prototype.copy.call(src, target, offset);
    }
    module2.exports = /* @__PURE__ */ function() {
      function BufferList() {
        _classCallCheck(this, BufferList);
        this.head = null;
        this.tail = null;
        this.length = 0;
      }
      _createClass(BufferList, [{
        key: "push",
        value: function push(v) {
          var entry = {
            data: v,
            next: null
          };
          if (this.length > 0)
            this.tail.next = entry;
          else
            this.head = entry;
          this.tail = entry;
          ++this.length;
        }
      }, {
        key: "unshift",
        value: function unshift(v) {
          var entry = {
            data: v,
            next: this.head
          };
          if (this.length === 0)
            this.tail = entry;
          this.head = entry;
          ++this.length;
        }
      }, {
        key: "shift",
        value: function shift() {
          if (this.length === 0)
            return;
          var ret = this.head.data;
          if (this.length === 1)
            this.head = this.tail = null;
          else
            this.head = this.head.next;
          --this.length;
          return ret;
        }
      }, {
        key: "clear",
        value: function clear() {
          this.head = this.tail = null;
          this.length = 0;
        }
      }, {
        key: "join",
        value: function join2(s) {
          if (this.length === 0)
            return "";
          var p3 = this.head;
          var ret = "" + p3.data;
          while (p3 = p3.next)
            ret += s + p3.data;
          return ret;
        }
      }, {
        key: "concat",
        value: function concat(n) {
          if (this.length === 0)
            return Buffer2.alloc(0);
          var ret = Buffer2.allocUnsafe(n >>> 0);
          var p3 = this.head;
          var i = 0;
          while (p3) {
            copyBuffer(p3.data, ret, i);
            i += p3.data.length;
            p3 = p3.next;
          }
          return ret;
        }
        // Consumes a specified amount of bytes or characters from the buffered data.
      }, {
        key: "consume",
        value: function consume(n, hasStrings) {
          var ret;
          if (n < this.head.data.length) {
            ret = this.head.data.slice(0, n);
            this.head.data = this.head.data.slice(n);
          } else if (n === this.head.data.length) {
            ret = this.shift();
          } else {
            ret = hasStrings ? this._getString(n) : this._getBuffer(n);
          }
          return ret;
        }
      }, {
        key: "first",
        value: function first() {
          return this.head.data;
        }
        // Consumes a specified amount of characters from the buffered data.
      }, {
        key: "_getString",
        value: function _getString(n) {
          var p3 = this.head;
          var c2 = 1;
          var ret = p3.data;
          n -= ret.length;
          while (p3 = p3.next) {
            var str = p3.data;
            var nb = n > str.length ? str.length : n;
            if (nb === str.length)
              ret += str;
            else
              ret += str.slice(0, n);
            n -= nb;
            if (n === 0) {
              if (nb === str.length) {
                ++c2;
                if (p3.next)
                  this.head = p3.next;
                else
                  this.head = this.tail = null;
              } else {
                this.head = p3;
                p3.data = str.slice(nb);
              }
              break;
            }
            ++c2;
          }
          this.length -= c2;
          return ret;
        }
        // Consumes a specified amount of bytes from the buffered data.
      }, {
        key: "_getBuffer",
        value: function _getBuffer(n) {
          var ret = Buffer2.allocUnsafe(n);
          var p3 = this.head;
          var c2 = 1;
          p3.data.copy(ret);
          n -= p3.data.length;
          while (p3 = p3.next) {
            var buf = p3.data;
            var nb = n > buf.length ? buf.length : n;
            buf.copy(ret, ret.length - n, 0, nb);
            n -= nb;
            if (n === 0) {
              if (nb === buf.length) {
                ++c2;
                if (p3.next)
                  this.head = p3.next;
                else
                  this.head = this.tail = null;
              } else {
                this.head = p3;
                p3.data = buf.slice(nb);
              }
              break;
            }
            ++c2;
          }
          this.length -= c2;
          return ret;
        }
        // Make sure the linked list only shows the minimal necessary information.
      }, {
        key: custom2,
        value: function value(_, options) {
          return inspect(this, _objectSpread(_objectSpread({}, options), {}, {
            // Only inspect one level.
            depth: 0,
            // It should not recurse.
            customInspect: false
          }));
        }
      }]);
      return BufferList;
    }();
  }
});

// node_modules/readable-stream/lib/internal/streams/destroy.js
var require_destroy = __commonJS({
  "node_modules/readable-stream/lib/internal/streams/destroy.js"(exports2, module2) {
    "use strict";
    function destroy(err, cb) {
      var _this = this;
      var readableDestroyed = this._readableState && this._readableState.destroyed;
      var writableDestroyed = this._writableState && this._writableState.destroyed;
      if (readableDestroyed || writableDestroyed) {
        if (cb) {
          cb(err);
        } else if (err) {
          if (!this._writableState) {
            process.nextTick(emitErrorNT, this, err);
          } else if (!this._writableState.errorEmitted) {
            this._writableState.errorEmitted = true;
            process.nextTick(emitErrorNT, this, err);
          }
        }
        return this;
      }
      if (this._readableState) {
        this._readableState.destroyed = true;
      }
      if (this._writableState) {
        this._writableState.destroyed = true;
      }
      this._destroy(err || null, function(err2) {
        if (!cb && err2) {
          if (!_this._writableState) {
            process.nextTick(emitErrorAndCloseNT, _this, err2);
          } else if (!_this._writableState.errorEmitted) {
            _this._writableState.errorEmitted = true;
            process.nextTick(emitErrorAndCloseNT, _this, err2);
          } else {
            process.nextTick(emitCloseNT, _this);
          }
        } else if (cb) {
          process.nextTick(emitCloseNT, _this);
          cb(err2);
        } else {
          process.nextTick(emitCloseNT, _this);
        }
      });
      return this;
    }
    function emitErrorAndCloseNT(self2, err) {
      emitErrorNT(self2, err);
      emitCloseNT(self2);
    }
    function emitCloseNT(self2) {
      if (self2._writableState && !self2._writableState.emitClose)
        return;
      if (self2._readableState && !self2._readableState.emitClose)
        return;
      self2.emit("close");
    }
    function undestroy() {
      if (this._readableState) {
        this._readableState.destroyed = false;
        this._readableState.reading = false;
        this._readableState.ended = false;
        this._readableState.endEmitted = false;
      }
      if (this._writableState) {
        this._writableState.destroyed = false;
        this._writableState.ended = false;
        this._writableState.ending = false;
        this._writableState.finalCalled = false;
        this._writableState.prefinished = false;
        this._writableState.finished = false;
        this._writableState.errorEmitted = false;
      }
    }
    function emitErrorNT(self2, err) {
      self2.emit("error", err);
    }
    function errorOrDestroy(stream, err) {
      var rState = stream._readableState;
      var wState = stream._writableState;
      if (rState && rState.autoDestroy || wState && wState.autoDestroy)
        stream.destroy(err);
      else
        stream.emit("error", err);
    }
    module2.exports = {
      destroy,
      undestroy,
      errorOrDestroy
    };
  }
});

// node_modules/readable-stream/errors.js
var require_errors = __commonJS({
  "node_modules/readable-stream/errors.js"(exports2, module2) {
    "use strict";
    var codes = {};
    function createErrorType(code, message, Base) {
      if (!Base) {
        Base = Error;
      }
      function getMessage(arg1, arg2, arg3) {
        if (typeof message === "string") {
          return message;
        } else {
          return message(arg1, arg2, arg3);
        }
      }
      class NodeError extends Base {
        constructor(arg1, arg2, arg3) {
          super(getMessage(arg1, arg2, arg3));
        }
      }
      NodeError.prototype.name = Base.name;
      NodeError.prototype.code = code;
      codes[code] = NodeError;
    }
    function oneOf(expected, thing) {
      if (Array.isArray(expected)) {
        const len = expected.length;
        expected = expected.map((i) => String(i));
        if (len > 2) {
          return `one of ${thing} ${expected.slice(0, len - 1).join(", ")}, or ` + expected[len - 1];
        } else if (len === 2) {
          return `one of ${thing} ${expected[0]} or ${expected[1]}`;
        } else {
          return `of ${thing} ${expected[0]}`;
        }
      } else {
        return `of ${thing} ${String(expected)}`;
      }
    }
    function startsWith(str, search, pos) {
      return str.substr(!pos || pos < 0 ? 0 : +pos, search.length) === search;
    }
    function endsWith(str, search, this_len) {
      if (this_len === void 0 || this_len > str.length) {
        this_len = str.length;
      }
      return str.substring(this_len - search.length, this_len) === search;
    }
    function includes(str, search, start) {
      if (typeof start !== "number") {
        start = 0;
      }
      if (start + search.length > str.length) {
        return false;
      } else {
        return str.indexOf(search, start) !== -1;
      }
    }
    createErrorType("ERR_INVALID_OPT_VALUE", function(name, value) {
      return 'The value "' + value + '" is invalid for option "' + name + '"';
    }, TypeError);
    createErrorType("ERR_INVALID_ARG_TYPE", function(name, expected, actual) {
      let determiner;
      if (typeof expected === "string" && startsWith(expected, "not ")) {
        determiner = "must not be";
        expected = expected.replace(/^not /, "");
      } else {
        determiner = "must be";
      }
      let msg;
      if (endsWith(name, " argument")) {
        msg = `The ${name} ${determiner} ${oneOf(expected, "type")}`;
      } else {
        const type = includes(name, ".") ? "property" : "argument";
        msg = `The "${name}" ${type} ${determiner} ${oneOf(expected, "type")}`;
      }
      msg += `. Received type ${typeof actual}`;
      return msg;
    }, TypeError);
    createErrorType("ERR_STREAM_PUSH_AFTER_EOF", "stream.push() after EOF");
    createErrorType("ERR_METHOD_NOT_IMPLEMENTED", function(name) {
      return "The " + name + " method is not implemented";
    });
    createErrorType("ERR_STREAM_PREMATURE_CLOSE", "Premature close");
    createErrorType("ERR_STREAM_DESTROYED", function(name) {
      return "Cannot call " + name + " after a stream was destroyed";
    });
    createErrorType("ERR_MULTIPLE_CALLBACK", "Callback called multiple times");
    createErrorType("ERR_STREAM_CANNOT_PIPE", "Cannot pipe, not readable");
    createErrorType("ERR_STREAM_WRITE_AFTER_END", "write after end");
    createErrorType("ERR_STREAM_NULL_VALUES", "May not write null values to stream", TypeError);
    createErrorType("ERR_UNKNOWN_ENCODING", function(arg) {
      return "Unknown encoding: " + arg;
    }, TypeError);
    createErrorType("ERR_STREAM_UNSHIFT_AFTER_END_EVENT", "stream.unshift() after end event");
    module2.exports.codes = codes;
  }
});

// node_modules/readable-stream/lib/internal/streams/state.js
var require_state = __commonJS({
  "node_modules/readable-stream/lib/internal/streams/state.js"(exports2, module2) {
    "use strict";
    var ERR_INVALID_OPT_VALUE = require_errors().codes.ERR_INVALID_OPT_VALUE;
    function highWaterMarkFrom(options, isDuplex, duplexKey) {
      return options.highWaterMark != null ? options.highWaterMark : isDuplex ? options[duplexKey] : null;
    }
    function getHighWaterMark(state, options, duplexKey, isDuplex) {
      var hwm = highWaterMarkFrom(options, isDuplex, duplexKey);
      if (hwm != null) {
        if (!(isFinite(hwm) && Math.floor(hwm) === hwm) || hwm < 0) {
          var name = isDuplex ? duplexKey : "highWaterMark";
          throw new ERR_INVALID_OPT_VALUE(name, hwm);
        }
        return Math.floor(hwm);
      }
      return state.objectMode ? 16 : 16 * 1024;
    }
    module2.exports = {
      getHighWaterMark
    };
  }
});

// node_modules/inherits/inherits_browser.js
var require_inherits_browser = __commonJS({
  "node_modules/inherits/inherits_browser.js"(exports2, module2) {
    if (typeof Object.create === "function") {
      module2.exports = function inherits(ctor, superCtor) {
        if (superCtor) {
          ctor.super_ = superCtor;
          ctor.prototype = Object.create(superCtor.prototype, {
            constructor: {
              value: ctor,
              enumerable: false,
              writable: true,
              configurable: true
            }
          });
        }
      };
    } else {
      module2.exports = function inherits(ctor, superCtor) {
        if (superCtor) {
          ctor.super_ = superCtor;
          var TempCtor = function() {
          };
          TempCtor.prototype = superCtor.prototype;
          ctor.prototype = new TempCtor();
          ctor.prototype.constructor = ctor;
        }
      };
    }
  }
});

// node_modules/inherits/inherits.js
var require_inherits = __commonJS({
  "node_modules/inherits/inherits.js"(exports2, module2) {
    try {
      util = require("util");
      if (typeof util.inherits !== "function")
        throw "";
      module2.exports = util.inherits;
    } catch (e) {
      module2.exports = require_inherits_browser();
    }
    var util;
  }
});

// node_modules/util-deprecate/node.js
var require_node2 = __commonJS({
  "node_modules/util-deprecate/node.js"(exports2, module2) {
    module2.exports = require("util").deprecate;
  }
});

// node_modules/readable-stream/lib/_stream_writable.js
var require_stream_writable = __commonJS({
  "node_modules/readable-stream/lib/_stream_writable.js"(exports2, module2) {
    "use strict";
    module2.exports = Writable;
    function CorkedRequest(state) {
      var _this = this;
      this.next = null;
      this.entry = null;
      this.finish = function() {
        onCorkedFinish(_this, state);
      };
    }
    var Duplex;
    Writable.WritableState = WritableState;
    var internalUtil = {
      deprecate: require_node2()
    };
    var Stream = require_stream2();
    var Buffer2 = require("buffer").Buffer;
    var OurUint8Array = (typeof global !== "undefined" ? global : typeof window !== "undefined" ? window : typeof self !== "undefined" ? self : {}).Uint8Array || function() {
    };
    function _uint8ArrayToBuffer(chunk) {
      return Buffer2.from(chunk);
    }
    function _isUint8Array(obj) {
      return Buffer2.isBuffer(obj) || obj instanceof OurUint8Array;
    }
    var destroyImpl = require_destroy();
    var _require = require_state();
    var getHighWaterMark = _require.getHighWaterMark;
    var _require$codes = require_errors().codes;
    var ERR_INVALID_ARG_TYPE = _require$codes.ERR_INVALID_ARG_TYPE;
    var ERR_METHOD_NOT_IMPLEMENTED = _require$codes.ERR_METHOD_NOT_IMPLEMENTED;
    var ERR_MULTIPLE_CALLBACK = _require$codes.ERR_MULTIPLE_CALLBACK;
    var ERR_STREAM_CANNOT_PIPE = _require$codes.ERR_STREAM_CANNOT_PIPE;
    var ERR_STREAM_DESTROYED = _require$codes.ERR_STREAM_DESTROYED;
    var ERR_STREAM_NULL_VALUES = _require$codes.ERR_STREAM_NULL_VALUES;
    var ERR_STREAM_WRITE_AFTER_END = _require$codes.ERR_STREAM_WRITE_AFTER_END;
    var ERR_UNKNOWN_ENCODING = _require$codes.ERR_UNKNOWN_ENCODING;
    var errorOrDestroy = destroyImpl.errorOrDestroy;
    require_inherits()(Writable, Stream);
    function nop() {
    }
    function WritableState(options, stream, isDuplex) {
      Duplex = Duplex || require_stream_duplex();
      options = options || {};
      if (typeof isDuplex !== "boolean")
        isDuplex = stream instanceof Duplex;
      this.objectMode = !!options.objectMode;
      if (isDuplex)
        this.objectMode = this.objectMode || !!options.writableObjectMode;
      this.highWaterMark = getHighWaterMark(this, options, "writableHighWaterMark", isDuplex);
      this.finalCalled = false;
      this.needDrain = false;
      this.ending = false;
      this.ended = false;
      this.finished = false;
      this.destroyed = false;
      var noDecode = options.decodeStrings === false;
      this.decodeStrings = !noDecode;
      this.defaultEncoding = options.defaultEncoding || "utf8";
      this.length = 0;
      this.writing = false;
      this.corked = 0;
      this.sync = true;
      this.bufferProcessing = false;
      this.onwrite = function(er) {
        onwrite(stream, er);
      };
      this.writecb = null;
      this.writelen = 0;
      this.bufferedRequest = null;
      this.lastBufferedRequest = null;
      this.pendingcb = 0;
      this.prefinished = false;
      this.errorEmitted = false;
      this.emitClose = options.emitClose !== false;
      this.autoDestroy = !!options.autoDestroy;
      this.bufferedRequestCount = 0;
      this.corkedRequestsFree = new CorkedRequest(this);
    }
    WritableState.prototype.getBuffer = function getBuffer() {
      var current = this.bufferedRequest;
      var out = [];
      while (current) {
        out.push(current);
        current = current.next;
      }
      return out;
    };
    (function() {
      try {
        Object.defineProperty(WritableState.prototype, "buffer", {
          get: internalUtil.deprecate(function writableStateBufferGetter() {
            return this.getBuffer();
          }, "_writableState.buffer is deprecated. Use _writableState.getBuffer instead.", "DEP0003")
        });
      } catch (_) {
      }
    })();
    var realHasInstance;
    if (typeof Symbol === "function" && Symbol.hasInstance && typeof Function.prototype[Symbol.hasInstance] === "function") {
      realHasInstance = Function.prototype[Symbol.hasInstance];
      Object.defineProperty(Writable, Symbol.hasInstance, {
        value: function value(object) {
          if (realHasInstance.call(this, object))
            return true;
          if (this !== Writable)
            return false;
          return object && object._writableState instanceof WritableState;
        }
      });
    } else {
      realHasInstance = function realHasInstance2(object) {
        return object instanceof this;
      };
    }
    function Writable(options) {
      Duplex = Duplex || require_stream_duplex();
      var isDuplex = this instanceof Duplex;
      if (!isDuplex && !realHasInstance.call(Writable, this))
        return new Writable(options);
      this._writableState = new WritableState(options, this, isDuplex);
      this.writable = true;
      if (options) {
        if (typeof options.write === "function")
          this._write = options.write;
        if (typeof options.writev === "function")
          this._writev = options.writev;
        if (typeof options.destroy === "function")
          this._destroy = options.destroy;
        if (typeof options.final === "function")
          this._final = options.final;
      }
      Stream.call(this);
    }
    Writable.prototype.pipe = function() {
      errorOrDestroy(this, new ERR_STREAM_CANNOT_PIPE());
    };
    function writeAfterEnd(stream, cb) {
      var er = new ERR_STREAM_WRITE_AFTER_END();
      errorOrDestroy(stream, er);
      process.nextTick(cb, er);
    }
    function validChunk(stream, state, chunk, cb) {
      var er;
      if (chunk === null) {
        er = new ERR_STREAM_NULL_VALUES();
      } else if (typeof chunk !== "string" && !state.objectMode) {
        er = new ERR_INVALID_ARG_TYPE("chunk", ["string", "Buffer"], chunk);
      }
      if (er) {
        errorOrDestroy(stream, er);
        process.nextTick(cb, er);
        return false;
      }
      return true;
    }
    Writable.prototype.write = function(chunk, encoding, cb) {
      var state = this._writableState;
      var ret = false;
      var isBuf = !state.objectMode && _isUint8Array(chunk);
      if (isBuf && !Buffer2.isBuffer(chunk)) {
        chunk = _uint8ArrayToBuffer(chunk);
      }
      if (typeof encoding === "function") {
        cb = encoding;
        encoding = null;
      }
      if (isBuf)
        encoding = "buffer";
      else if (!encoding)
        encoding = state.defaultEncoding;
      if (typeof cb !== "function")
        cb = nop;
      if (state.ending)
        writeAfterEnd(this, cb);
      else if (isBuf || validChunk(this, state, chunk, cb)) {
        state.pendingcb++;
        ret = writeOrBuffer(this, state, isBuf, chunk, encoding, cb);
      }
      return ret;
    };
    Writable.prototype.cork = function() {
      this._writableState.corked++;
    };
    Writable.prototype.uncork = function() {
      var state = this._writableState;
      if (state.corked) {
        state.corked--;
        if (!state.writing && !state.corked && !state.bufferProcessing && state.bufferedRequest)
          clearBuffer(this, state);
      }
    };
    Writable.prototype.setDefaultEncoding = function setDefaultEncoding(encoding) {
      if (typeof encoding === "string")
        encoding = encoding.toLowerCase();
      if (!(["hex", "utf8", "utf-8", "ascii", "binary", "base64", "ucs2", "ucs-2", "utf16le", "utf-16le", "raw"].indexOf((encoding + "").toLowerCase()) > -1))
        throw new ERR_UNKNOWN_ENCODING(encoding);
      this._writableState.defaultEncoding = encoding;
      return this;
    };
    Object.defineProperty(Writable.prototype, "writableBuffer", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: false,
      get: function get() {
        return this._writableState && this._writableState.getBuffer();
      }
    });
    function decodeChunk(state, chunk, encoding) {
      if (!state.objectMode && state.decodeStrings !== false && typeof chunk === "string") {
        chunk = Buffer2.from(chunk, encoding);
      }
      return chunk;
    }
    Object.defineProperty(Writable.prototype, "writableHighWaterMark", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: false,
      get: function get() {
        return this._writableState.highWaterMark;
      }
    });
    function writeOrBuffer(stream, state, isBuf, chunk, encoding, cb) {
      if (!isBuf) {
        var newChunk = decodeChunk(state, chunk, encoding);
        if (chunk !== newChunk) {
          isBuf = true;
          encoding = "buffer";
          chunk = newChunk;
        }
      }
      var len = state.objectMode ? 1 : chunk.length;
      state.length += len;
      var ret = state.length < state.highWaterMark;
      if (!ret)
        state.needDrain = true;
      if (state.writing || state.corked) {
        var last = state.lastBufferedRequest;
        state.lastBufferedRequest = {
          chunk,
          encoding,
          isBuf,
          callback: cb,
          next: null
        };
        if (last) {
          last.next = state.lastBufferedRequest;
        } else {
          state.bufferedRequest = state.lastBufferedRequest;
        }
        state.bufferedRequestCount += 1;
      } else {
        doWrite(stream, state, false, len, chunk, encoding, cb);
      }
      return ret;
    }
    function doWrite(stream, state, writev, len, chunk, encoding, cb) {
      state.writelen = len;
      state.writecb = cb;
      state.writing = true;
      state.sync = true;
      if (state.destroyed)
        state.onwrite(new ERR_STREAM_DESTROYED("write"));
      else if (writev)
        stream._writev(chunk, state.onwrite);
      else
        stream._write(chunk, encoding, state.onwrite);
      state.sync = false;
    }
    function onwriteError(stream, state, sync, er, cb) {
      --state.pendingcb;
      if (sync) {
        process.nextTick(cb, er);
        process.nextTick(finishMaybe, stream, state);
        stream._writableState.errorEmitted = true;
        errorOrDestroy(stream, er);
      } else {
        cb(er);
        stream._writableState.errorEmitted = true;
        errorOrDestroy(stream, er);
        finishMaybe(stream, state);
      }
    }
    function onwriteStateUpdate(state) {
      state.writing = false;
      state.writecb = null;
      state.length -= state.writelen;
      state.writelen = 0;
    }
    function onwrite(stream, er) {
      var state = stream._writableState;
      var sync = state.sync;
      var cb = state.writecb;
      if (typeof cb !== "function")
        throw new ERR_MULTIPLE_CALLBACK();
      onwriteStateUpdate(state);
      if (er)
        onwriteError(stream, state, sync, er, cb);
      else {
        var finished = needFinish(state) || stream.destroyed;
        if (!finished && !state.corked && !state.bufferProcessing && state.bufferedRequest) {
          clearBuffer(stream, state);
        }
        if (sync) {
          process.nextTick(afterWrite, stream, state, finished, cb);
        } else {
          afterWrite(stream, state, finished, cb);
        }
      }
    }
    function afterWrite(stream, state, finished, cb) {
      if (!finished)
        onwriteDrain(stream, state);
      state.pendingcb--;
      cb();
      finishMaybe(stream, state);
    }
    function onwriteDrain(stream, state) {
      if (state.length === 0 && state.needDrain) {
        state.needDrain = false;
        stream.emit("drain");
      }
    }
    function clearBuffer(stream, state) {
      state.bufferProcessing = true;
      var entry = state.bufferedRequest;
      if (stream._writev && entry && entry.next) {
        var l2 = state.bufferedRequestCount;
        var buffer = new Array(l2);
        var holder = state.corkedRequestsFree;
        holder.entry = entry;
        var count = 0;
        var allBuffers = true;
        while (entry) {
          buffer[count] = entry;
          if (!entry.isBuf)
            allBuffers = false;
          entry = entry.next;
          count += 1;
        }
        buffer.allBuffers = allBuffers;
        doWrite(stream, state, true, state.length, buffer, "", holder.finish);
        state.pendingcb++;
        state.lastBufferedRequest = null;
        if (holder.next) {
          state.corkedRequestsFree = holder.next;
          holder.next = null;
        } else {
          state.corkedRequestsFree = new CorkedRequest(state);
        }
        state.bufferedRequestCount = 0;
      } else {
        while (entry) {
          var chunk = entry.chunk;
          var encoding = entry.encoding;
          var cb = entry.callback;
          var len = state.objectMode ? 1 : chunk.length;
          doWrite(stream, state, false, len, chunk, encoding, cb);
          entry = entry.next;
          state.bufferedRequestCount--;
          if (state.writing) {
            break;
          }
        }
        if (entry === null)
          state.lastBufferedRequest = null;
      }
      state.bufferedRequest = entry;
      state.bufferProcessing = false;
    }
    Writable.prototype._write = function(chunk, encoding, cb) {
      cb(new ERR_METHOD_NOT_IMPLEMENTED("_write()"));
    };
    Writable.prototype._writev = null;
    Writable.prototype.end = function(chunk, encoding, cb) {
      var state = this._writableState;
      if (typeof chunk === "function") {
        cb = chunk;
        chunk = null;
        encoding = null;
      } else if (typeof encoding === "function") {
        cb = encoding;
        encoding = null;
      }
      if (chunk !== null && chunk !== void 0)
        this.write(chunk, encoding);
      if (state.corked) {
        state.corked = 1;
        this.uncork();
      }
      if (!state.ending)
        endWritable(this, state, cb);
      return this;
    };
    Object.defineProperty(Writable.prototype, "writableLength", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: false,
      get: function get() {
        return this._writableState.length;
      }
    });
    function needFinish(state) {
      return state.ending && state.length === 0 && state.bufferedRequest === null && !state.finished && !state.writing;
    }
    function callFinal(stream, state) {
      stream._final(function(err) {
        state.pendingcb--;
        if (err) {
          errorOrDestroy(stream, err);
        }
        state.prefinished = true;
        stream.emit("prefinish");
        finishMaybe(stream, state);
      });
    }
    function prefinish(stream, state) {
      if (!state.prefinished && !state.finalCalled) {
        if (typeof stream._final === "function" && !state.destroyed) {
          state.pendingcb++;
          state.finalCalled = true;
          process.nextTick(callFinal, stream, state);
        } else {
          state.prefinished = true;
          stream.emit("prefinish");
        }
      }
    }
    function finishMaybe(stream, state) {
      var need = needFinish(state);
      if (need) {
        prefinish(stream, state);
        if (state.pendingcb === 0) {
          state.finished = true;
          stream.emit("finish");
          if (state.autoDestroy) {
            var rState = stream._readableState;
            if (!rState || rState.autoDestroy && rState.endEmitted) {
              stream.destroy();
            }
          }
        }
      }
      return need;
    }
    function endWritable(stream, state, cb) {
      state.ending = true;
      finishMaybe(stream, state);
      if (cb) {
        if (state.finished)
          process.nextTick(cb);
        else
          stream.once("finish", cb);
      }
      state.ended = true;
      stream.writable = false;
    }
    function onCorkedFinish(corkReq, state, err) {
      var entry = corkReq.entry;
      corkReq.entry = null;
      while (entry) {
        var cb = entry.callback;
        state.pendingcb--;
        cb(err);
        entry = entry.next;
      }
      state.corkedRequestsFree.next = corkReq;
    }
    Object.defineProperty(Writable.prototype, "destroyed", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: false,
      get: function get() {
        if (this._writableState === void 0) {
          return false;
        }
        return this._writableState.destroyed;
      },
      set: function set(value) {
        if (!this._writableState) {
          return;
        }
        this._writableState.destroyed = value;
      }
    });
    Writable.prototype.destroy = destroyImpl.destroy;
    Writable.prototype._undestroy = destroyImpl.undestroy;
    Writable.prototype._destroy = function(err, cb) {
      cb(err);
    };
  }
});

// node_modules/readable-stream/lib/_stream_duplex.js
var require_stream_duplex = __commonJS({
  "node_modules/readable-stream/lib/_stream_duplex.js"(exports2, module2) {
    "use strict";
    var objectKeys = Object.keys || function(obj) {
      var keys2 = [];
      for (var key in obj)
        keys2.push(key);
      return keys2;
    };
    module2.exports = Duplex;
    var Readable = require_stream_readable();
    var Writable = require_stream_writable();
    require_inherits()(Duplex, Readable);
    {
      keys = objectKeys(Writable.prototype);
      for (v = 0; v < keys.length; v++) {
        method = keys[v];
        if (!Duplex.prototype[method])
          Duplex.prototype[method] = Writable.prototype[method];
      }
    }
    var keys;
    var method;
    var v;
    function Duplex(options) {
      if (!(this instanceof Duplex))
        return new Duplex(options);
      Readable.call(this, options);
      Writable.call(this, options);
      this.allowHalfOpen = true;
      if (options) {
        if (options.readable === false)
          this.readable = false;
        if (options.writable === false)
          this.writable = false;
        if (options.allowHalfOpen === false) {
          this.allowHalfOpen = false;
          this.once("end", onend);
        }
      }
    }
    Object.defineProperty(Duplex.prototype, "writableHighWaterMark", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: false,
      get: function get() {
        return this._writableState.highWaterMark;
      }
    });
    Object.defineProperty(Duplex.prototype, "writableBuffer", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: false,
      get: function get() {
        return this._writableState && this._writableState.getBuffer();
      }
    });
    Object.defineProperty(Duplex.prototype, "writableLength", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: false,
      get: function get() {
        return this._writableState.length;
      }
    });
    function onend() {
      if (this._writableState.ended)
        return;
      process.nextTick(onEndNT, this);
    }
    function onEndNT(self2) {
      self2.end();
    }
    Object.defineProperty(Duplex.prototype, "destroyed", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: false,
      get: function get() {
        if (this._readableState === void 0 || this._writableState === void 0) {
          return false;
        }
        return this._readableState.destroyed && this._writableState.destroyed;
      },
      set: function set(value) {
        if (this._readableState === void 0 || this._writableState === void 0) {
          return;
        }
        this._readableState.destroyed = value;
        this._writableState.destroyed = value;
      }
    });
  }
});

// node_modules/safe-buffer/index.js
var require_safe_buffer = __commonJS({
  "node_modules/safe-buffer/index.js"(exports2, module2) {
    var buffer = require("buffer");
    var Buffer2 = buffer.Buffer;
    function copyProps(src, dst) {
      for (var key in src) {
        dst[key] = src[key];
      }
    }
    if (Buffer2.from && Buffer2.alloc && Buffer2.allocUnsafe && Buffer2.allocUnsafeSlow) {
      module2.exports = buffer;
    } else {
      copyProps(buffer, exports2);
      exports2.Buffer = SafeBuffer;
    }
    function SafeBuffer(arg, encodingOrOffset, length) {
      return Buffer2(arg, encodingOrOffset, length);
    }
    SafeBuffer.prototype = Object.create(Buffer2.prototype);
    copyProps(Buffer2, SafeBuffer);
    SafeBuffer.from = function(arg, encodingOrOffset, length) {
      if (typeof arg === "number") {
        throw new TypeError("Argument must not be a number");
      }
      return Buffer2(arg, encodingOrOffset, length);
    };
    SafeBuffer.alloc = function(size, fill, encoding) {
      if (typeof size !== "number") {
        throw new TypeError("Argument must be a number");
      }
      var buf = Buffer2(size);
      if (fill !== void 0) {
        if (typeof encoding === "string") {
          buf.fill(fill, encoding);
        } else {
          buf.fill(fill);
        }
      } else {
        buf.fill(0);
      }
      return buf;
    };
    SafeBuffer.allocUnsafe = function(size) {
      if (typeof size !== "number") {
        throw new TypeError("Argument must be a number");
      }
      return Buffer2(size);
    };
    SafeBuffer.allocUnsafeSlow = function(size) {
      if (typeof size !== "number") {
        throw new TypeError("Argument must be a number");
      }
      return buffer.SlowBuffer(size);
    };
  }
});

// node_modules/string_decoder/lib/string_decoder.js
var require_string_decoder = __commonJS({
  "node_modules/string_decoder/lib/string_decoder.js"(exports2) {
    "use strict";
    var Buffer2 = require_safe_buffer().Buffer;
    var isEncoding = Buffer2.isEncoding || function(encoding) {
      encoding = "" + encoding;
      switch (encoding && encoding.toLowerCase()) {
        case "hex":
        case "utf8":
        case "utf-8":
        case "ascii":
        case "binary":
        case "base64":
        case "ucs2":
        case "ucs-2":
        case "utf16le":
        case "utf-16le":
        case "raw":
          return true;
        default:
          return false;
      }
    };
    function _normalizeEncoding(enc) {
      if (!enc)
        return "utf8";
      var retried;
      while (true) {
        switch (enc) {
          case "utf8":
          case "utf-8":
            return "utf8";
          case "ucs2":
          case "ucs-2":
          case "utf16le":
          case "utf-16le":
            return "utf16le";
          case "latin1":
          case "binary":
            return "latin1";
          case "base64":
          case "ascii":
          case "hex":
            return enc;
          default:
            if (retried)
              return;
            enc = ("" + enc).toLowerCase();
            retried = true;
        }
      }
    }
    function normalizeEncoding(enc) {
      var nenc = _normalizeEncoding(enc);
      if (typeof nenc !== "string" && (Buffer2.isEncoding === isEncoding || !isEncoding(enc)))
        throw new Error("Unknown encoding: " + enc);
      return nenc || enc;
    }
    exports2.StringDecoder = StringDecoder;
    function StringDecoder(encoding) {
      this.encoding = normalizeEncoding(encoding);
      var nb;
      switch (this.encoding) {
        case "utf16le":
          this.text = utf16Text;
          this.end = utf16End;
          nb = 4;
          break;
        case "utf8":
          this.fillLast = utf8FillLast;
          nb = 4;
          break;
        case "base64":
          this.text = base64Text;
          this.end = base64End;
          nb = 3;
          break;
        default:
          this.write = simpleWrite;
          this.end = simpleEnd;
          return;
      }
      this.lastNeed = 0;
      this.lastTotal = 0;
      this.lastChar = Buffer2.allocUnsafe(nb);
    }
    StringDecoder.prototype.write = function(buf) {
      if (buf.length === 0)
        return "";
      var r;
      var i;
      if (this.lastNeed) {
        r = this.fillLast(buf);
        if (r === void 0)
          return "";
        i = this.lastNeed;
        this.lastNeed = 0;
      } else {
        i = 0;
      }
      if (i < buf.length)
        return r ? r + this.text(buf, i) : this.text(buf, i);
      return r || "";
    };
    StringDecoder.prototype.end = utf8End;
    StringDecoder.prototype.text = utf8Text;
    StringDecoder.prototype.fillLast = function(buf) {
      if (this.lastNeed <= buf.length) {
        buf.copy(this.lastChar, this.lastTotal - this.lastNeed, 0, this.lastNeed);
        return this.lastChar.toString(this.encoding, 0, this.lastTotal);
      }
      buf.copy(this.lastChar, this.lastTotal - this.lastNeed, 0, buf.length);
      this.lastNeed -= buf.length;
    };
    function utf8CheckByte(byte) {
      if (byte <= 127)
        return 0;
      else if (byte >> 5 === 6)
        return 2;
      else if (byte >> 4 === 14)
        return 3;
      else if (byte >> 3 === 30)
        return 4;
      return byte >> 6 === 2 ? -1 : -2;
    }
    function utf8CheckIncomplete(self2, buf, i) {
      var j = buf.length - 1;
      if (j < i)
        return 0;
      var nb = utf8CheckByte(buf[j]);
      if (nb >= 0) {
        if (nb > 0)
          self2.lastNeed = nb - 1;
        return nb;
      }
      if (--j < i || nb === -2)
        return 0;
      nb = utf8CheckByte(buf[j]);
      if (nb >= 0) {
        if (nb > 0)
          self2.lastNeed = nb - 2;
        return nb;
      }
      if (--j < i || nb === -2)
        return 0;
      nb = utf8CheckByte(buf[j]);
      if (nb >= 0) {
        if (nb > 0) {
          if (nb === 2)
            nb = 0;
          else
            self2.lastNeed = nb - 3;
        }
        return nb;
      }
      return 0;
    }
    function utf8CheckExtraBytes(self2, buf, p3) {
      if ((buf[0] & 192) !== 128) {
        self2.lastNeed = 0;
        return "\uFFFD";
      }
      if (self2.lastNeed > 1 && buf.length > 1) {
        if ((buf[1] & 192) !== 128) {
          self2.lastNeed = 1;
          return "\uFFFD";
        }
        if (self2.lastNeed > 2 && buf.length > 2) {
          if ((buf[2] & 192) !== 128) {
            self2.lastNeed = 2;
            return "\uFFFD";
          }
        }
      }
    }
    function utf8FillLast(buf) {
      var p3 = this.lastTotal - this.lastNeed;
      var r = utf8CheckExtraBytes(this, buf, p3);
      if (r !== void 0)
        return r;
      if (this.lastNeed <= buf.length) {
        buf.copy(this.lastChar, p3, 0, this.lastNeed);
        return this.lastChar.toString(this.encoding, 0, this.lastTotal);
      }
      buf.copy(this.lastChar, p3, 0, buf.length);
      this.lastNeed -= buf.length;
    }
    function utf8Text(buf, i) {
      var total = utf8CheckIncomplete(this, buf, i);
      if (!this.lastNeed)
        return buf.toString("utf8", i);
      this.lastTotal = total;
      var end = buf.length - (total - this.lastNeed);
      buf.copy(this.lastChar, 0, end);
      return buf.toString("utf8", i, end);
    }
    function utf8End(buf) {
      var r = buf && buf.length ? this.write(buf) : "";
      if (this.lastNeed)
        return r + "\uFFFD";
      return r;
    }
    function utf16Text(buf, i) {
      if ((buf.length - i) % 2 === 0) {
        var r = buf.toString("utf16le", i);
        if (r) {
          var c2 = r.charCodeAt(r.length - 1);
          if (c2 >= 55296 && c2 <= 56319) {
            this.lastNeed = 2;
            this.lastTotal = 4;
            this.lastChar[0] = buf[buf.length - 2];
            this.lastChar[1] = buf[buf.length - 1];
            return r.slice(0, -1);
          }
        }
        return r;
      }
      this.lastNeed = 1;
      this.lastTotal = 2;
      this.lastChar[0] = buf[buf.length - 1];
      return buf.toString("utf16le", i, buf.length - 1);
    }
    function utf16End(buf) {
      var r = buf && buf.length ? this.write(buf) : "";
      if (this.lastNeed) {
        var end = this.lastTotal - this.lastNeed;
        return r + this.lastChar.toString("utf16le", 0, end);
      }
      return r;
    }
    function base64Text(buf, i) {
      var n = (buf.length - i) % 3;
      if (n === 0)
        return buf.toString("base64", i);
      this.lastNeed = 3 - n;
      this.lastTotal = 3;
      if (n === 1) {
        this.lastChar[0] = buf[buf.length - 1];
      } else {
        this.lastChar[0] = buf[buf.length - 2];
        this.lastChar[1] = buf[buf.length - 1];
      }
      return buf.toString("base64", i, buf.length - n);
    }
    function base64End(buf) {
      var r = buf && buf.length ? this.write(buf) : "";
      if (this.lastNeed)
        return r + this.lastChar.toString("base64", 0, 3 - this.lastNeed);
      return r;
    }
    function simpleWrite(buf) {
      return buf.toString(this.encoding);
    }
    function simpleEnd(buf) {
      return buf && buf.length ? this.write(buf) : "";
    }
  }
});

// node_modules/readable-stream/lib/internal/streams/end-of-stream.js
var require_end_of_stream = __commonJS({
  "node_modules/readable-stream/lib/internal/streams/end-of-stream.js"(exports2, module2) {
    "use strict";
    var ERR_STREAM_PREMATURE_CLOSE = require_errors().codes.ERR_STREAM_PREMATURE_CLOSE;
    function once(callback) {
      var called = false;
      return function() {
        if (called)
          return;
        called = true;
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }
        callback.apply(this, args);
      };
    }
    function noop() {
    }
    function isRequest(stream) {
      return stream.setHeader && typeof stream.abort === "function";
    }
    function eos(stream, opts, callback) {
      if (typeof opts === "function")
        return eos(stream, null, opts);
      if (!opts)
        opts = {};
      callback = once(callback || noop);
      var readable = opts.readable || opts.readable !== false && stream.readable;
      var writable = opts.writable || opts.writable !== false && stream.writable;
      var onlegacyfinish = function onlegacyfinish2() {
        if (!stream.writable)
          onfinish();
      };
      var writableEnded = stream._writableState && stream._writableState.finished;
      var onfinish = function onfinish2() {
        writable = false;
        writableEnded = true;
        if (!readable)
          callback.call(stream);
      };
      var readableEnded = stream._readableState && stream._readableState.endEmitted;
      var onend = function onend2() {
        readable = false;
        readableEnded = true;
        if (!writable)
          callback.call(stream);
      };
      var onerror = function onerror2(err) {
        callback.call(stream, err);
      };
      var onclose = function onclose2() {
        var err;
        if (readable && !readableEnded) {
          if (!stream._readableState || !stream._readableState.ended)
            err = new ERR_STREAM_PREMATURE_CLOSE();
          return callback.call(stream, err);
        }
        if (writable && !writableEnded) {
          if (!stream._writableState || !stream._writableState.ended)
            err = new ERR_STREAM_PREMATURE_CLOSE();
          return callback.call(stream, err);
        }
      };
      var onrequest = function onrequest2() {
        stream.req.on("finish", onfinish);
      };
      if (isRequest(stream)) {
        stream.on("complete", onfinish);
        stream.on("abort", onclose);
        if (stream.req)
          onrequest();
        else
          stream.on("request", onrequest);
      } else if (writable && !stream._writableState) {
        stream.on("end", onlegacyfinish);
        stream.on("close", onlegacyfinish);
      }
      stream.on("end", onend);
      stream.on("finish", onfinish);
      if (opts.error !== false)
        stream.on("error", onerror);
      stream.on("close", onclose);
      return function() {
        stream.removeListener("complete", onfinish);
        stream.removeListener("abort", onclose);
        stream.removeListener("request", onrequest);
        if (stream.req)
          stream.req.removeListener("finish", onfinish);
        stream.removeListener("end", onlegacyfinish);
        stream.removeListener("close", onlegacyfinish);
        stream.removeListener("finish", onfinish);
        stream.removeListener("end", onend);
        stream.removeListener("error", onerror);
        stream.removeListener("close", onclose);
      };
    }
    module2.exports = eos;
  }
});

// node_modules/readable-stream/lib/internal/streams/async_iterator.js
var require_async_iterator = __commonJS({
  "node_modules/readable-stream/lib/internal/streams/async_iterator.js"(exports2, module2) {
    "use strict";
    var _Object$setPrototypeO;
    function _defineProperty(obj, key, value) {
      key = _toPropertyKey(key);
      if (key in obj) {
        Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }
      return obj;
    }
    function _toPropertyKey(arg) {
      var key = _toPrimitive(arg, "string");
      return typeof key === "symbol" ? key : String(key);
    }
    function _toPrimitive(input, hint) {
      if (typeof input !== "object" || input === null)
        return input;
      var prim = input[Symbol.toPrimitive];
      if (prim !== void 0) {
        var res = prim.call(input, hint || "default");
        if (typeof res !== "object")
          return res;
        throw new TypeError("@@toPrimitive must return a primitive value.");
      }
      return (hint === "string" ? String : Number)(input);
    }
    var finished = require_end_of_stream();
    var kLastResolve = Symbol("lastResolve");
    var kLastReject = Symbol("lastReject");
    var kError = Symbol("error");
    var kEnded = Symbol("ended");
    var kLastPromise = Symbol("lastPromise");
    var kHandlePromise = Symbol("handlePromise");
    var kStream = Symbol("stream");
    function createIterResult(value, done) {
      return {
        value,
        done
      };
    }
    function readAndResolve(iter) {
      var resolve2 = iter[kLastResolve];
      if (resolve2 !== null) {
        var data = iter[kStream].read();
        if (data !== null) {
          iter[kLastPromise] = null;
          iter[kLastResolve] = null;
          iter[kLastReject] = null;
          resolve2(createIterResult(data, false));
        }
      }
    }
    function onReadable(iter) {
      process.nextTick(readAndResolve, iter);
    }
    function wrapForNext(lastPromise, iter) {
      return function(resolve2, reject) {
        lastPromise.then(function() {
          if (iter[kEnded]) {
            resolve2(createIterResult(void 0, true));
            return;
          }
          iter[kHandlePromise](resolve2, reject);
        }, reject);
      };
    }
    var AsyncIteratorPrototype = Object.getPrototypeOf(function() {
    });
    var ReadableStreamAsyncIteratorPrototype = Object.setPrototypeOf((_Object$setPrototypeO = {
      get stream() {
        return this[kStream];
      },
      next: function next() {
        var _this = this;
        var error = this[kError];
        if (error !== null) {
          return Promise.reject(error);
        }
        if (this[kEnded]) {
          return Promise.resolve(createIterResult(void 0, true));
        }
        if (this[kStream].destroyed) {
          return new Promise(function(resolve2, reject) {
            process.nextTick(function() {
              if (_this[kError]) {
                reject(_this[kError]);
              } else {
                resolve2(createIterResult(void 0, true));
              }
            });
          });
        }
        var lastPromise = this[kLastPromise];
        var promise;
        if (lastPromise) {
          promise = new Promise(wrapForNext(lastPromise, this));
        } else {
          var data = this[kStream].read();
          if (data !== null) {
            return Promise.resolve(createIterResult(data, false));
          }
          promise = new Promise(this[kHandlePromise]);
        }
        this[kLastPromise] = promise;
        return promise;
      }
    }, _defineProperty(_Object$setPrototypeO, Symbol.asyncIterator, function() {
      return this;
    }), _defineProperty(_Object$setPrototypeO, "return", function _return() {
      var _this2 = this;
      return new Promise(function(resolve2, reject) {
        _this2[kStream].destroy(null, function(err) {
          if (err) {
            reject(err);
            return;
          }
          resolve2(createIterResult(void 0, true));
        });
      });
    }), _Object$setPrototypeO), AsyncIteratorPrototype);
    var createReadableStreamAsyncIterator = function createReadableStreamAsyncIterator2(stream) {
      var _Object$create;
      var iterator = Object.create(ReadableStreamAsyncIteratorPrototype, (_Object$create = {}, _defineProperty(_Object$create, kStream, {
        value: stream,
        writable: true
      }), _defineProperty(_Object$create, kLastResolve, {
        value: null,
        writable: true
      }), _defineProperty(_Object$create, kLastReject, {
        value: null,
        writable: true
      }), _defineProperty(_Object$create, kError, {
        value: null,
        writable: true
      }), _defineProperty(_Object$create, kEnded, {
        value: stream._readableState.endEmitted,
        writable: true
      }), _defineProperty(_Object$create, kHandlePromise, {
        value: function value(resolve2, reject) {
          var data = iterator[kStream].read();
          if (data) {
            iterator[kLastPromise] = null;
            iterator[kLastResolve] = null;
            iterator[kLastReject] = null;
            resolve2(createIterResult(data, false));
          } else {
            iterator[kLastResolve] = resolve2;
            iterator[kLastReject] = reject;
          }
        },
        writable: true
      }), _Object$create));
      iterator[kLastPromise] = null;
      finished(stream, function(err) {
        if (err && err.code !== "ERR_STREAM_PREMATURE_CLOSE") {
          var reject = iterator[kLastReject];
          if (reject !== null) {
            iterator[kLastPromise] = null;
            iterator[kLastResolve] = null;
            iterator[kLastReject] = null;
            reject(err);
          }
          iterator[kError] = err;
          return;
        }
        var resolve2 = iterator[kLastResolve];
        if (resolve2 !== null) {
          iterator[kLastPromise] = null;
          iterator[kLastResolve] = null;
          iterator[kLastReject] = null;
          resolve2(createIterResult(void 0, true));
        }
        iterator[kEnded] = true;
      });
      stream.on("readable", onReadable.bind(null, iterator));
      return iterator;
    };
    module2.exports = createReadableStreamAsyncIterator;
  }
});

// node_modules/readable-stream/lib/internal/streams/from.js
var require_from = __commonJS({
  "node_modules/readable-stream/lib/internal/streams/from.js"(exports2, module2) {
    "use strict";
    function asyncGeneratorStep(gen, resolve2, reject, _next, _throw, key, arg) {
      try {
        var info = gen[key](arg);
        var value = info.value;
      } catch (error) {
        reject(error);
        return;
      }
      if (info.done) {
        resolve2(value);
      } else {
        Promise.resolve(value).then(_next, _throw);
      }
    }
    function _asyncToGenerator(fn) {
      return function() {
        var self2 = this, args = arguments;
        return new Promise(function(resolve2, reject) {
          var gen = fn.apply(self2, args);
          function _next(value) {
            asyncGeneratorStep(gen, resolve2, reject, _next, _throw, "next", value);
          }
          function _throw(err) {
            asyncGeneratorStep(gen, resolve2, reject, _next, _throw, "throw", err);
          }
          _next(void 0);
        });
      };
    }
    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);
      if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        enumerableOnly && (symbols = symbols.filter(function(sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        })), keys.push.apply(keys, symbols);
      }
      return keys;
    }
    function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = null != arguments[i] ? arguments[i] : {};
        i % 2 ? ownKeys(Object(source), true).forEach(function(key) {
          _defineProperty(target, key, source[key]);
        }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function(key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
      return target;
    }
    function _defineProperty(obj, key, value) {
      key = _toPropertyKey(key);
      if (key in obj) {
        Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }
      return obj;
    }
    function _toPropertyKey(arg) {
      var key = _toPrimitive(arg, "string");
      return typeof key === "symbol" ? key : String(key);
    }
    function _toPrimitive(input, hint) {
      if (typeof input !== "object" || input === null)
        return input;
      var prim = input[Symbol.toPrimitive];
      if (prim !== void 0) {
        var res = prim.call(input, hint || "default");
        if (typeof res !== "object")
          return res;
        throw new TypeError("@@toPrimitive must return a primitive value.");
      }
      return (hint === "string" ? String : Number)(input);
    }
    var ERR_INVALID_ARG_TYPE = require_errors().codes.ERR_INVALID_ARG_TYPE;
    function from(Readable, iterable, opts) {
      var iterator;
      if (iterable && typeof iterable.next === "function") {
        iterator = iterable;
      } else if (iterable && iterable[Symbol.asyncIterator])
        iterator = iterable[Symbol.asyncIterator]();
      else if (iterable && iterable[Symbol.iterator])
        iterator = iterable[Symbol.iterator]();
      else
        throw new ERR_INVALID_ARG_TYPE("iterable", ["Iterable"], iterable);
      var readable = new Readable(_objectSpread({
        objectMode: true
      }, opts));
      var reading = false;
      readable._read = function() {
        if (!reading) {
          reading = true;
          next();
        }
      };
      function next() {
        return _next2.apply(this, arguments);
      }
      function _next2() {
        _next2 = _asyncToGenerator(function* () {
          try {
            var _yield$iterator$next = yield iterator.next(), value = _yield$iterator$next.value, done = _yield$iterator$next.done;
            if (done) {
              readable.push(null);
            } else if (readable.push(yield value)) {
              next();
            } else {
              reading = false;
            }
          } catch (err) {
            readable.destroy(err);
          }
        });
        return _next2.apply(this, arguments);
      }
      return readable;
    }
    module2.exports = from;
  }
});

// node_modules/readable-stream/lib/_stream_readable.js
var require_stream_readable = __commonJS({
  "node_modules/readable-stream/lib/_stream_readable.js"(exports2, module2) {
    "use strict";
    module2.exports = Readable;
    var Duplex;
    Readable.ReadableState = ReadableState;
    var EE = require("events").EventEmitter;
    var EElistenerCount = function EElistenerCount2(emitter, type) {
      return emitter.listeners(type).length;
    };
    var Stream = require_stream2();
    var Buffer2 = require("buffer").Buffer;
    var OurUint8Array = (typeof global !== "undefined" ? global : typeof window !== "undefined" ? window : typeof self !== "undefined" ? self : {}).Uint8Array || function() {
    };
    function _uint8ArrayToBuffer(chunk) {
      return Buffer2.from(chunk);
    }
    function _isUint8Array(obj) {
      return Buffer2.isBuffer(obj) || obj instanceof OurUint8Array;
    }
    var debugUtil = require("util");
    var debug;
    if (debugUtil && debugUtil.debuglog) {
      debug = debugUtil.debuglog("stream");
    } else {
      debug = function debug2() {
      };
    }
    var BufferList = require_buffer_list();
    var destroyImpl = require_destroy();
    var _require = require_state();
    var getHighWaterMark = _require.getHighWaterMark;
    var _require$codes = require_errors().codes;
    var ERR_INVALID_ARG_TYPE = _require$codes.ERR_INVALID_ARG_TYPE;
    var ERR_STREAM_PUSH_AFTER_EOF = _require$codes.ERR_STREAM_PUSH_AFTER_EOF;
    var ERR_METHOD_NOT_IMPLEMENTED = _require$codes.ERR_METHOD_NOT_IMPLEMENTED;
    var ERR_STREAM_UNSHIFT_AFTER_END_EVENT = _require$codes.ERR_STREAM_UNSHIFT_AFTER_END_EVENT;
    var StringDecoder;
    var createReadableStreamAsyncIterator;
    var from;
    require_inherits()(Readable, Stream);
    var errorOrDestroy = destroyImpl.errorOrDestroy;
    var kProxyEvents = ["error", "close", "destroy", "pause", "resume"];
    function prependListener(emitter, event, fn) {
      if (typeof emitter.prependListener === "function")
        return emitter.prependListener(event, fn);
      if (!emitter._events || !emitter._events[event])
        emitter.on(event, fn);
      else if (Array.isArray(emitter._events[event]))
        emitter._events[event].unshift(fn);
      else
        emitter._events[event] = [fn, emitter._events[event]];
    }
    function ReadableState(options, stream, isDuplex) {
      Duplex = Duplex || require_stream_duplex();
      options = options || {};
      if (typeof isDuplex !== "boolean")
        isDuplex = stream instanceof Duplex;
      this.objectMode = !!options.objectMode;
      if (isDuplex)
        this.objectMode = this.objectMode || !!options.readableObjectMode;
      this.highWaterMark = getHighWaterMark(this, options, "readableHighWaterMark", isDuplex);
      this.buffer = new BufferList();
      this.length = 0;
      this.pipes = null;
      this.pipesCount = 0;
      this.flowing = null;
      this.ended = false;
      this.endEmitted = false;
      this.reading = false;
      this.sync = true;
      this.needReadable = false;
      this.emittedReadable = false;
      this.readableListening = false;
      this.resumeScheduled = false;
      this.paused = true;
      this.emitClose = options.emitClose !== false;
      this.autoDestroy = !!options.autoDestroy;
      this.destroyed = false;
      this.defaultEncoding = options.defaultEncoding || "utf8";
      this.awaitDrain = 0;
      this.readingMore = false;
      this.decoder = null;
      this.encoding = null;
      if (options.encoding) {
        if (!StringDecoder)
          StringDecoder = require_string_decoder().StringDecoder;
        this.decoder = new StringDecoder(options.encoding);
        this.encoding = options.encoding;
      }
    }
    function Readable(options) {
      Duplex = Duplex || require_stream_duplex();
      if (!(this instanceof Readable))
        return new Readable(options);
      var isDuplex = this instanceof Duplex;
      this._readableState = new ReadableState(options, this, isDuplex);
      this.readable = true;
      if (options) {
        if (typeof options.read === "function")
          this._read = options.read;
        if (typeof options.destroy === "function")
          this._destroy = options.destroy;
      }
      Stream.call(this);
    }
    Object.defineProperty(Readable.prototype, "destroyed", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: false,
      get: function get() {
        if (this._readableState === void 0) {
          return false;
        }
        return this._readableState.destroyed;
      },
      set: function set(value) {
        if (!this._readableState) {
          return;
        }
        this._readableState.destroyed = value;
      }
    });
    Readable.prototype.destroy = destroyImpl.destroy;
    Readable.prototype._undestroy = destroyImpl.undestroy;
    Readable.prototype._destroy = function(err, cb) {
      cb(err);
    };
    Readable.prototype.push = function(chunk, encoding) {
      var state = this._readableState;
      var skipChunkCheck;
      if (!state.objectMode) {
        if (typeof chunk === "string") {
          encoding = encoding || state.defaultEncoding;
          if (encoding !== state.encoding) {
            chunk = Buffer2.from(chunk, encoding);
            encoding = "";
          }
          skipChunkCheck = true;
        }
      } else {
        skipChunkCheck = true;
      }
      return readableAddChunk(this, chunk, encoding, false, skipChunkCheck);
    };
    Readable.prototype.unshift = function(chunk) {
      return readableAddChunk(this, chunk, null, true, false);
    };
    function readableAddChunk(stream, chunk, encoding, addToFront, skipChunkCheck) {
      debug("readableAddChunk", chunk);
      var state = stream._readableState;
      if (chunk === null) {
        state.reading = false;
        onEofChunk(stream, state);
      } else {
        var er;
        if (!skipChunkCheck)
          er = chunkInvalid(state, chunk);
        if (er) {
          errorOrDestroy(stream, er);
        } else if (state.objectMode || chunk && chunk.length > 0) {
          if (typeof chunk !== "string" && !state.objectMode && Object.getPrototypeOf(chunk) !== Buffer2.prototype) {
            chunk = _uint8ArrayToBuffer(chunk);
          }
          if (addToFront) {
            if (state.endEmitted)
              errorOrDestroy(stream, new ERR_STREAM_UNSHIFT_AFTER_END_EVENT());
            else
              addChunk(stream, state, chunk, true);
          } else if (state.ended) {
            errorOrDestroy(stream, new ERR_STREAM_PUSH_AFTER_EOF());
          } else if (state.destroyed) {
            return false;
          } else {
            state.reading = false;
            if (state.decoder && !encoding) {
              chunk = state.decoder.write(chunk);
              if (state.objectMode || chunk.length !== 0)
                addChunk(stream, state, chunk, false);
              else
                maybeReadMore(stream, state);
            } else {
              addChunk(stream, state, chunk, false);
            }
          }
        } else if (!addToFront) {
          state.reading = false;
          maybeReadMore(stream, state);
        }
      }
      return !state.ended && (state.length < state.highWaterMark || state.length === 0);
    }
    function addChunk(stream, state, chunk, addToFront) {
      if (state.flowing && state.length === 0 && !state.sync) {
        state.awaitDrain = 0;
        stream.emit("data", chunk);
      } else {
        state.length += state.objectMode ? 1 : chunk.length;
        if (addToFront)
          state.buffer.unshift(chunk);
        else
          state.buffer.push(chunk);
        if (state.needReadable)
          emitReadable(stream);
      }
      maybeReadMore(stream, state);
    }
    function chunkInvalid(state, chunk) {
      var er;
      if (!_isUint8Array(chunk) && typeof chunk !== "string" && chunk !== void 0 && !state.objectMode) {
        er = new ERR_INVALID_ARG_TYPE("chunk", ["string", "Buffer", "Uint8Array"], chunk);
      }
      return er;
    }
    Readable.prototype.isPaused = function() {
      return this._readableState.flowing === false;
    };
    Readable.prototype.setEncoding = function(enc) {
      if (!StringDecoder)
        StringDecoder = require_string_decoder().StringDecoder;
      var decoder = new StringDecoder(enc);
      this._readableState.decoder = decoder;
      this._readableState.encoding = this._readableState.decoder.encoding;
      var p3 = this._readableState.buffer.head;
      var content = "";
      while (p3 !== null) {
        content += decoder.write(p3.data);
        p3 = p3.next;
      }
      this._readableState.buffer.clear();
      if (content !== "")
        this._readableState.buffer.push(content);
      this._readableState.length = content.length;
      return this;
    };
    var MAX_HWM = 1073741824;
    function computeNewHighWaterMark(n) {
      if (n >= MAX_HWM) {
        n = MAX_HWM;
      } else {
        n--;
        n |= n >>> 1;
        n |= n >>> 2;
        n |= n >>> 4;
        n |= n >>> 8;
        n |= n >>> 16;
        n++;
      }
      return n;
    }
    function howMuchToRead(n, state) {
      if (n <= 0 || state.length === 0 && state.ended)
        return 0;
      if (state.objectMode)
        return 1;
      if (n !== n) {
        if (state.flowing && state.length)
          return state.buffer.head.data.length;
        else
          return state.length;
      }
      if (n > state.highWaterMark)
        state.highWaterMark = computeNewHighWaterMark(n);
      if (n <= state.length)
        return n;
      if (!state.ended) {
        state.needReadable = true;
        return 0;
      }
      return state.length;
    }
    Readable.prototype.read = function(n) {
      debug("read", n);
      n = parseInt(n, 10);
      var state = this._readableState;
      var nOrig = n;
      if (n !== 0)
        state.emittedReadable = false;
      if (n === 0 && state.needReadable && ((state.highWaterMark !== 0 ? state.length >= state.highWaterMark : state.length > 0) || state.ended)) {
        debug("read: emitReadable", state.length, state.ended);
        if (state.length === 0 && state.ended)
          endReadable(this);
        else
          emitReadable(this);
        return null;
      }
      n = howMuchToRead(n, state);
      if (n === 0 && state.ended) {
        if (state.length === 0)
          endReadable(this);
        return null;
      }
      var doRead = state.needReadable;
      debug("need readable", doRead);
      if (state.length === 0 || state.length - n < state.highWaterMark) {
        doRead = true;
        debug("length less than watermark", doRead);
      }
      if (state.ended || state.reading) {
        doRead = false;
        debug("reading or ended", doRead);
      } else if (doRead) {
        debug("do read");
        state.reading = true;
        state.sync = true;
        if (state.length === 0)
          state.needReadable = true;
        this._read(state.highWaterMark);
        state.sync = false;
        if (!state.reading)
          n = howMuchToRead(nOrig, state);
      }
      var ret;
      if (n > 0)
        ret = fromList(n, state);
      else
        ret = null;
      if (ret === null) {
        state.needReadable = state.length <= state.highWaterMark;
        n = 0;
      } else {
        state.length -= n;
        state.awaitDrain = 0;
      }
      if (state.length === 0) {
        if (!state.ended)
          state.needReadable = true;
        if (nOrig !== n && state.ended)
          endReadable(this);
      }
      if (ret !== null)
        this.emit("data", ret);
      return ret;
    };
    function onEofChunk(stream, state) {
      debug("onEofChunk");
      if (state.ended)
        return;
      if (state.decoder) {
        var chunk = state.decoder.end();
        if (chunk && chunk.length) {
          state.buffer.push(chunk);
          state.length += state.objectMode ? 1 : chunk.length;
        }
      }
      state.ended = true;
      if (state.sync) {
        emitReadable(stream);
      } else {
        state.needReadable = false;
        if (!state.emittedReadable) {
          state.emittedReadable = true;
          emitReadable_(stream);
        }
      }
    }
    function emitReadable(stream) {
      var state = stream._readableState;
      debug("emitReadable", state.needReadable, state.emittedReadable);
      state.needReadable = false;
      if (!state.emittedReadable) {
        debug("emitReadable", state.flowing);
        state.emittedReadable = true;
        process.nextTick(emitReadable_, stream);
      }
    }
    function emitReadable_(stream) {
      var state = stream._readableState;
      debug("emitReadable_", state.destroyed, state.length, state.ended);
      if (!state.destroyed && (state.length || state.ended)) {
        stream.emit("readable");
        state.emittedReadable = false;
      }
      state.needReadable = !state.flowing && !state.ended && state.length <= state.highWaterMark;
      flow(stream);
    }
    function maybeReadMore(stream, state) {
      if (!state.readingMore) {
        state.readingMore = true;
        process.nextTick(maybeReadMore_, stream, state);
      }
    }
    function maybeReadMore_(stream, state) {
      while (!state.reading && !state.ended && (state.length < state.highWaterMark || state.flowing && state.length === 0)) {
        var len = state.length;
        debug("maybeReadMore read 0");
        stream.read(0);
        if (len === state.length)
          break;
      }
      state.readingMore = false;
    }
    Readable.prototype._read = function(n) {
      errorOrDestroy(this, new ERR_METHOD_NOT_IMPLEMENTED("_read()"));
    };
    Readable.prototype.pipe = function(dest, pipeOpts) {
      var src = this;
      var state = this._readableState;
      switch (state.pipesCount) {
        case 0:
          state.pipes = dest;
          break;
        case 1:
          state.pipes = [state.pipes, dest];
          break;
        default:
          state.pipes.push(dest);
          break;
      }
      state.pipesCount += 1;
      debug("pipe count=%d opts=%j", state.pipesCount, pipeOpts);
      var doEnd = (!pipeOpts || pipeOpts.end !== false) && dest !== process.stdout && dest !== process.stderr;
      var endFn = doEnd ? onend : unpipe;
      if (state.endEmitted)
        process.nextTick(endFn);
      else
        src.once("end", endFn);
      dest.on("unpipe", onunpipe);
      function onunpipe(readable, unpipeInfo) {
        debug("onunpipe");
        if (readable === src) {
          if (unpipeInfo && unpipeInfo.hasUnpiped === false) {
            unpipeInfo.hasUnpiped = true;
            cleanup();
          }
        }
      }
      function onend() {
        debug("onend");
        dest.end();
      }
      var ondrain = pipeOnDrain(src);
      dest.on("drain", ondrain);
      var cleanedUp = false;
      function cleanup() {
        debug("cleanup");
        dest.removeListener("close", onclose);
        dest.removeListener("finish", onfinish);
        dest.removeListener("drain", ondrain);
        dest.removeListener("error", onerror);
        dest.removeListener("unpipe", onunpipe);
        src.removeListener("end", onend);
        src.removeListener("end", unpipe);
        src.removeListener("data", ondata);
        cleanedUp = true;
        if (state.awaitDrain && (!dest._writableState || dest._writableState.needDrain))
          ondrain();
      }
      src.on("data", ondata);
      function ondata(chunk) {
        debug("ondata");
        var ret = dest.write(chunk);
        debug("dest.write", ret);
        if (ret === false) {
          if ((state.pipesCount === 1 && state.pipes === dest || state.pipesCount > 1 && indexOf(state.pipes, dest) !== -1) && !cleanedUp) {
            debug("false write response, pause", state.awaitDrain);
            state.awaitDrain++;
          }
          src.pause();
        }
      }
      function onerror(er) {
        debug("onerror", er);
        unpipe();
        dest.removeListener("error", onerror);
        if (EElistenerCount(dest, "error") === 0)
          errorOrDestroy(dest, er);
      }
      prependListener(dest, "error", onerror);
      function onclose() {
        dest.removeListener("finish", onfinish);
        unpipe();
      }
      dest.once("close", onclose);
      function onfinish() {
        debug("onfinish");
        dest.removeListener("close", onclose);
        unpipe();
      }
      dest.once("finish", onfinish);
      function unpipe() {
        debug("unpipe");
        src.unpipe(dest);
      }
      dest.emit("pipe", src);
      if (!state.flowing) {
        debug("pipe resume");
        src.resume();
      }
      return dest;
    };
    function pipeOnDrain(src) {
      return function pipeOnDrainFunctionResult() {
        var state = src._readableState;
        debug("pipeOnDrain", state.awaitDrain);
        if (state.awaitDrain)
          state.awaitDrain--;
        if (state.awaitDrain === 0 && EElistenerCount(src, "data")) {
          state.flowing = true;
          flow(src);
        }
      };
    }
    Readable.prototype.unpipe = function(dest) {
      var state = this._readableState;
      var unpipeInfo = {
        hasUnpiped: false
      };
      if (state.pipesCount === 0)
        return this;
      if (state.pipesCount === 1) {
        if (dest && dest !== state.pipes)
          return this;
        if (!dest)
          dest = state.pipes;
        state.pipes = null;
        state.pipesCount = 0;
        state.flowing = false;
        if (dest)
          dest.emit("unpipe", this, unpipeInfo);
        return this;
      }
      if (!dest) {
        var dests = state.pipes;
        var len = state.pipesCount;
        state.pipes = null;
        state.pipesCount = 0;
        state.flowing = false;
        for (var i = 0; i < len; i++)
          dests[i].emit("unpipe", this, {
            hasUnpiped: false
          });
        return this;
      }
      var index = indexOf(state.pipes, dest);
      if (index === -1)
        return this;
      state.pipes.splice(index, 1);
      state.pipesCount -= 1;
      if (state.pipesCount === 1)
        state.pipes = state.pipes[0];
      dest.emit("unpipe", this, unpipeInfo);
      return this;
    };
    Readable.prototype.on = function(ev, fn) {
      var res = Stream.prototype.on.call(this, ev, fn);
      var state = this._readableState;
      if (ev === "data") {
        state.readableListening = this.listenerCount("readable") > 0;
        if (state.flowing !== false)
          this.resume();
      } else if (ev === "readable") {
        if (!state.endEmitted && !state.readableListening) {
          state.readableListening = state.needReadable = true;
          state.flowing = false;
          state.emittedReadable = false;
          debug("on readable", state.length, state.reading);
          if (state.length) {
            emitReadable(this);
          } else if (!state.reading) {
            process.nextTick(nReadingNextTick, this);
          }
        }
      }
      return res;
    };
    Readable.prototype.addListener = Readable.prototype.on;
    Readable.prototype.removeListener = function(ev, fn) {
      var res = Stream.prototype.removeListener.call(this, ev, fn);
      if (ev === "readable") {
        process.nextTick(updateReadableListening, this);
      }
      return res;
    };
    Readable.prototype.removeAllListeners = function(ev) {
      var res = Stream.prototype.removeAllListeners.apply(this, arguments);
      if (ev === "readable" || ev === void 0) {
        process.nextTick(updateReadableListening, this);
      }
      return res;
    };
    function updateReadableListening(self2) {
      var state = self2._readableState;
      state.readableListening = self2.listenerCount("readable") > 0;
      if (state.resumeScheduled && !state.paused) {
        state.flowing = true;
      } else if (self2.listenerCount("data") > 0) {
        self2.resume();
      }
    }
    function nReadingNextTick(self2) {
      debug("readable nexttick read 0");
      self2.read(0);
    }
    Readable.prototype.resume = function() {
      var state = this._readableState;
      if (!state.flowing) {
        debug("resume");
        state.flowing = !state.readableListening;
        resume(this, state);
      }
      state.paused = false;
      return this;
    };
    function resume(stream, state) {
      if (!state.resumeScheduled) {
        state.resumeScheduled = true;
        process.nextTick(resume_, stream, state);
      }
    }
    function resume_(stream, state) {
      debug("resume", state.reading);
      if (!state.reading) {
        stream.read(0);
      }
      state.resumeScheduled = false;
      stream.emit("resume");
      flow(stream);
      if (state.flowing && !state.reading)
        stream.read(0);
    }
    Readable.prototype.pause = function() {
      debug("call pause flowing=%j", this._readableState.flowing);
      if (this._readableState.flowing !== false) {
        debug("pause");
        this._readableState.flowing = false;
        this.emit("pause");
      }
      this._readableState.paused = true;
      return this;
    };
    function flow(stream) {
      var state = stream._readableState;
      debug("flow", state.flowing);
      while (state.flowing && stream.read() !== null)
        ;
    }
    Readable.prototype.wrap = function(stream) {
      var _this = this;
      var state = this._readableState;
      var paused = false;
      stream.on("end", function() {
        debug("wrapped end");
        if (state.decoder && !state.ended) {
          var chunk = state.decoder.end();
          if (chunk && chunk.length)
            _this.push(chunk);
        }
        _this.push(null);
      });
      stream.on("data", function(chunk) {
        debug("wrapped data");
        if (state.decoder)
          chunk = state.decoder.write(chunk);
        if (state.objectMode && (chunk === null || chunk === void 0))
          return;
        else if (!state.objectMode && (!chunk || !chunk.length))
          return;
        var ret = _this.push(chunk);
        if (!ret) {
          paused = true;
          stream.pause();
        }
      });
      for (var i in stream) {
        if (this[i] === void 0 && typeof stream[i] === "function") {
          this[i] = /* @__PURE__ */ function methodWrap(method) {
            return function methodWrapReturnFunction() {
              return stream[method].apply(stream, arguments);
            };
          }(i);
        }
      }
      for (var n = 0; n < kProxyEvents.length; n++) {
        stream.on(kProxyEvents[n], this.emit.bind(this, kProxyEvents[n]));
      }
      this._read = function(n2) {
        debug("wrapped _read", n2);
        if (paused) {
          paused = false;
          stream.resume();
        }
      };
      return this;
    };
    if (typeof Symbol === "function") {
      Readable.prototype[Symbol.asyncIterator] = function() {
        if (createReadableStreamAsyncIterator === void 0) {
          createReadableStreamAsyncIterator = require_async_iterator();
        }
        return createReadableStreamAsyncIterator(this);
      };
    }
    Object.defineProperty(Readable.prototype, "readableHighWaterMark", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: false,
      get: function get() {
        return this._readableState.highWaterMark;
      }
    });
    Object.defineProperty(Readable.prototype, "readableBuffer", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: false,
      get: function get() {
        return this._readableState && this._readableState.buffer;
      }
    });
    Object.defineProperty(Readable.prototype, "readableFlowing", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: false,
      get: function get() {
        return this._readableState.flowing;
      },
      set: function set(state) {
        if (this._readableState) {
          this._readableState.flowing = state;
        }
      }
    });
    Readable._fromList = fromList;
    Object.defineProperty(Readable.prototype, "readableLength", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: false,
      get: function get() {
        return this._readableState.length;
      }
    });
    function fromList(n, state) {
      if (state.length === 0)
        return null;
      var ret;
      if (state.objectMode)
        ret = state.buffer.shift();
      else if (!n || n >= state.length) {
        if (state.decoder)
          ret = state.buffer.join("");
        else if (state.buffer.length === 1)
          ret = state.buffer.first();
        else
          ret = state.buffer.concat(state.length);
        state.buffer.clear();
      } else {
        ret = state.buffer.consume(n, state.decoder);
      }
      return ret;
    }
    function endReadable(stream) {
      var state = stream._readableState;
      debug("endReadable", state.endEmitted);
      if (!state.endEmitted) {
        state.ended = true;
        process.nextTick(endReadableNT, state, stream);
      }
    }
    function endReadableNT(state, stream) {
      debug("endReadableNT", state.endEmitted, state.length);
      if (!state.endEmitted && state.length === 0) {
        state.endEmitted = true;
        stream.readable = false;
        stream.emit("end");
        if (state.autoDestroy) {
          var wState = stream._writableState;
          if (!wState || wState.autoDestroy && wState.finished) {
            stream.destroy();
          }
        }
      }
    }
    if (typeof Symbol === "function") {
      Readable.from = function(iterable, opts) {
        if (from === void 0) {
          from = require_from();
        }
        return from(Readable, iterable, opts);
      };
    }
    function indexOf(xs, x2) {
      for (var i = 0, l2 = xs.length; i < l2; i++) {
        if (xs[i] === x2)
          return i;
      }
      return -1;
    }
  }
});

// node_modules/readable-stream/lib/_stream_transform.js
var require_stream_transform = __commonJS({
  "node_modules/readable-stream/lib/_stream_transform.js"(exports2, module2) {
    "use strict";
    module2.exports = Transform;
    var _require$codes = require_errors().codes;
    var ERR_METHOD_NOT_IMPLEMENTED = _require$codes.ERR_METHOD_NOT_IMPLEMENTED;
    var ERR_MULTIPLE_CALLBACK = _require$codes.ERR_MULTIPLE_CALLBACK;
    var ERR_TRANSFORM_ALREADY_TRANSFORMING = _require$codes.ERR_TRANSFORM_ALREADY_TRANSFORMING;
    var ERR_TRANSFORM_WITH_LENGTH_0 = _require$codes.ERR_TRANSFORM_WITH_LENGTH_0;
    var Duplex = require_stream_duplex();
    require_inherits()(Transform, Duplex);
    function afterTransform(er, data) {
      var ts = this._transformState;
      ts.transforming = false;
      var cb = ts.writecb;
      if (cb === null) {
        return this.emit("error", new ERR_MULTIPLE_CALLBACK());
      }
      ts.writechunk = null;
      ts.writecb = null;
      if (data != null)
        this.push(data);
      cb(er);
      var rs = this._readableState;
      rs.reading = false;
      if (rs.needReadable || rs.length < rs.highWaterMark) {
        this._read(rs.highWaterMark);
      }
    }
    function Transform(options) {
      if (!(this instanceof Transform))
        return new Transform(options);
      Duplex.call(this, options);
      this._transformState = {
        afterTransform: afterTransform.bind(this),
        needTransform: false,
        transforming: false,
        writecb: null,
        writechunk: null,
        writeencoding: null
      };
      this._readableState.needReadable = true;
      this._readableState.sync = false;
      if (options) {
        if (typeof options.transform === "function")
          this._transform = options.transform;
        if (typeof options.flush === "function")
          this._flush = options.flush;
      }
      this.on("prefinish", prefinish);
    }
    function prefinish() {
      var _this = this;
      if (typeof this._flush === "function" && !this._readableState.destroyed) {
        this._flush(function(er, data) {
          done(_this, er, data);
        });
      } else {
        done(this, null, null);
      }
    }
    Transform.prototype.push = function(chunk, encoding) {
      this._transformState.needTransform = false;
      return Duplex.prototype.push.call(this, chunk, encoding);
    };
    Transform.prototype._transform = function(chunk, encoding, cb) {
      cb(new ERR_METHOD_NOT_IMPLEMENTED("_transform()"));
    };
    Transform.prototype._write = function(chunk, encoding, cb) {
      var ts = this._transformState;
      ts.writecb = cb;
      ts.writechunk = chunk;
      ts.writeencoding = encoding;
      if (!ts.transforming) {
        var rs = this._readableState;
        if (ts.needTransform || rs.needReadable || rs.length < rs.highWaterMark)
          this._read(rs.highWaterMark);
      }
    };
    Transform.prototype._read = function(n) {
      var ts = this._transformState;
      if (ts.writechunk !== null && !ts.transforming) {
        ts.transforming = true;
        this._transform(ts.writechunk, ts.writeencoding, ts.afterTransform);
      } else {
        ts.needTransform = true;
      }
    };
    Transform.prototype._destroy = function(err, cb) {
      Duplex.prototype._destroy.call(this, err, function(err2) {
        cb(err2);
      });
    };
    function done(stream, er, data) {
      if (er)
        return stream.emit("error", er);
      if (data != null)
        stream.push(data);
      if (stream._writableState.length)
        throw new ERR_TRANSFORM_WITH_LENGTH_0();
      if (stream._transformState.transforming)
        throw new ERR_TRANSFORM_ALREADY_TRANSFORMING();
      return stream.push(null);
    }
  }
});

// node_modules/readable-stream/lib/_stream_passthrough.js
var require_stream_passthrough = __commonJS({
  "node_modules/readable-stream/lib/_stream_passthrough.js"(exports2, module2) {
    "use strict";
    module2.exports = PassThrough;
    var Transform = require_stream_transform();
    require_inherits()(PassThrough, Transform);
    function PassThrough(options) {
      if (!(this instanceof PassThrough))
        return new PassThrough(options);
      Transform.call(this, options);
    }
    PassThrough.prototype._transform = function(chunk, encoding, cb) {
      cb(null, chunk);
    };
  }
});

// node_modules/readable-stream/lib/internal/streams/pipeline.js
var require_pipeline = __commonJS({
  "node_modules/readable-stream/lib/internal/streams/pipeline.js"(exports2, module2) {
    "use strict";
    var eos;
    function once(callback) {
      var called = false;
      return function() {
        if (called)
          return;
        called = true;
        callback.apply(void 0, arguments);
      };
    }
    var _require$codes = require_errors().codes;
    var ERR_MISSING_ARGS = _require$codes.ERR_MISSING_ARGS;
    var ERR_STREAM_DESTROYED = _require$codes.ERR_STREAM_DESTROYED;
    function noop(err) {
      if (err)
        throw err;
    }
    function isRequest(stream) {
      return stream.setHeader && typeof stream.abort === "function";
    }
    function destroyer(stream, reading, writing, callback) {
      callback = once(callback);
      var closed = false;
      stream.on("close", function() {
        closed = true;
      });
      if (eos === void 0)
        eos = require_end_of_stream();
      eos(stream, {
        readable: reading,
        writable: writing
      }, function(err) {
        if (err)
          return callback(err);
        closed = true;
        callback();
      });
      var destroyed = false;
      return function(err) {
        if (closed)
          return;
        if (destroyed)
          return;
        destroyed = true;
        if (isRequest(stream))
          return stream.abort();
        if (typeof stream.destroy === "function")
          return stream.destroy();
        callback(err || new ERR_STREAM_DESTROYED("pipe"));
      };
    }
    function call(fn) {
      fn();
    }
    function pipe(from, to) {
      return from.pipe(to);
    }
    function popCallback(streams) {
      if (!streams.length)
        return noop;
      if (typeof streams[streams.length - 1] !== "function")
        return noop;
      return streams.pop();
    }
    function pipeline() {
      for (var _len = arguments.length, streams = new Array(_len), _key = 0; _key < _len; _key++) {
        streams[_key] = arguments[_key];
      }
      var callback = popCallback(streams);
      if (Array.isArray(streams[0]))
        streams = streams[0];
      if (streams.length < 2) {
        throw new ERR_MISSING_ARGS("streams");
      }
      var error;
      var destroys = streams.map(function(stream, i) {
        var reading = i < streams.length - 1;
        var writing = i > 0;
        return destroyer(stream, reading, writing, function(err) {
          if (!error)
            error = err;
          if (err)
            destroys.forEach(call);
          if (reading)
            return;
          destroys.forEach(call);
          callback(error);
        });
      });
      return streams.reduce(pipe);
    }
    module2.exports = pipeline;
  }
});

// node_modules/readable-stream/readable.js
var require_readable = __commonJS({
  "node_modules/readable-stream/readable.js"(exports2, module2) {
    var Stream = require("stream");
    if (process.env.READABLE_STREAM === "disable" && Stream) {
      module2.exports = Stream.Readable;
      Object.assign(module2.exports, Stream);
      module2.exports.Stream = Stream;
    } else {
      exports2 = module2.exports = require_stream_readable();
      exports2.Stream = Stream || exports2;
      exports2.Readable = exports2;
      exports2.Writable = require_stream_writable();
      exports2.Duplex = require_stream_duplex();
      exports2.Transform = require_stream_transform();
      exports2.PassThrough = require_stream_passthrough();
      exports2.finished = require_end_of_stream();
      exports2.pipeline = require_pipeline();
    }
  }
});

// node_modules/mqtt/lib/store.js
var require_store = __commonJS({
  "node_modules/mqtt/lib/store.js"(exports2, module2) {
    "use strict";
    var xtend = require_immutable();
    var Readable = require_readable().Readable;
    var streamsOpts = { objectMode: true };
    var defaultStoreOptions = {
      clean: true
    };
    function Store(options) {
      if (!(this instanceof Store)) {
        return new Store(options);
      }
      this.options = options || {};
      this.options = xtend(defaultStoreOptions, options);
      this._inflights = /* @__PURE__ */ new Map();
    }
    Store.prototype.put = function(packet, cb) {
      this._inflights.set(packet.messageId, packet);
      if (cb) {
        cb();
      }
      return this;
    };
    Store.prototype.createStream = function() {
      const stream = new Readable(streamsOpts);
      const values = [];
      let destroyed = false;
      let i = 0;
      this._inflights.forEach(function(value, key) {
        values.push(value);
      });
      stream._read = function() {
        if (!destroyed && i < values.length) {
          this.push(values[i++]);
        } else {
          this.push(null);
        }
      };
      stream.destroy = function() {
        if (destroyed) {
          return;
        }
        const self2 = this;
        destroyed = true;
        setTimeout(function() {
          self2.emit("close");
        }, 0);
      };
      return stream;
    };
    Store.prototype.del = function(packet, cb) {
      packet = this._inflights.get(packet.messageId);
      if (packet) {
        this._inflights.delete(packet.messageId);
        cb(null, packet);
      } else if (cb) {
        cb(new Error("missing packet"));
      }
      return this;
    };
    Store.prototype.get = function(packet, cb) {
      packet = this._inflights.get(packet.messageId);
      if (packet) {
        cb(null, packet);
      } else if (cb) {
        cb(new Error("missing packet"));
      }
      return this;
    };
    Store.prototype.close = function(cb) {
      if (this.options.clean) {
        this._inflights = null;
      }
      if (cb) {
        cb();
      }
    };
    module2.exports = Store;
  }
});

// node_modules/mqtt/lib/topic-alias-recv.js
var require_topic_alias_recv = __commonJS({
  "node_modules/mqtt/lib/topic-alias-recv.js"(exports2, module2) {
    "use strict";
    function TopicAliasRecv(max) {
      if (!(this instanceof TopicAliasRecv)) {
        return new TopicAliasRecv(max);
      }
      this.aliasToTopic = {};
      this.max = max;
    }
    TopicAliasRecv.prototype.put = function(topic, alias) {
      if (alias === 0 || alias > this.max) {
        return false;
      }
      this.aliasToTopic[alias] = topic;
      this.length = Object.keys(this.aliasToTopic).length;
      return true;
    };
    TopicAliasRecv.prototype.getTopicByAlias = function(alias) {
      return this.aliasToTopic[alias];
    };
    TopicAliasRecv.prototype.clear = function() {
      this.aliasToTopic = {};
    };
    module2.exports = TopicAliasRecv;
  }
});

// node_modules/yallist/iterator.js
var require_iterator = __commonJS({
  "node_modules/yallist/iterator.js"(exports2, module2) {
    "use strict";
    module2.exports = function(Yallist) {
      Yallist.prototype[Symbol.iterator] = function* () {
        for (let walker = this.head; walker; walker = walker.next) {
          yield walker.value;
        }
      };
    };
  }
});

// node_modules/yallist/yallist.js
var require_yallist = __commonJS({
  "node_modules/yallist/yallist.js"(exports2, module2) {
    "use strict";
    module2.exports = Yallist;
    Yallist.Node = Node;
    Yallist.create = Yallist;
    function Yallist(list) {
      var self2 = this;
      if (!(self2 instanceof Yallist)) {
        self2 = new Yallist();
      }
      self2.tail = null;
      self2.head = null;
      self2.length = 0;
      if (list && typeof list.forEach === "function") {
        list.forEach(function(item) {
          self2.push(item);
        });
      } else if (arguments.length > 0) {
        for (var i = 0, l2 = arguments.length; i < l2; i++) {
          self2.push(arguments[i]);
        }
      }
      return self2;
    }
    Yallist.prototype.removeNode = function(node) {
      if (node.list !== this) {
        throw new Error("removing node which does not belong to this list");
      }
      var next = node.next;
      var prev = node.prev;
      if (next) {
        next.prev = prev;
      }
      if (prev) {
        prev.next = next;
      }
      if (node === this.head) {
        this.head = next;
      }
      if (node === this.tail) {
        this.tail = prev;
      }
      node.list.length--;
      node.next = null;
      node.prev = null;
      node.list = null;
      return next;
    };
    Yallist.prototype.unshiftNode = function(node) {
      if (node === this.head) {
        return;
      }
      if (node.list) {
        node.list.removeNode(node);
      }
      var head = this.head;
      node.list = this;
      node.next = head;
      if (head) {
        head.prev = node;
      }
      this.head = node;
      if (!this.tail) {
        this.tail = node;
      }
      this.length++;
    };
    Yallist.prototype.pushNode = function(node) {
      if (node === this.tail) {
        return;
      }
      if (node.list) {
        node.list.removeNode(node);
      }
      var tail = this.tail;
      node.list = this;
      node.prev = tail;
      if (tail) {
        tail.next = node;
      }
      this.tail = node;
      if (!this.head) {
        this.head = node;
      }
      this.length++;
    };
    Yallist.prototype.push = function() {
      for (var i = 0, l2 = arguments.length; i < l2; i++) {
        push(this, arguments[i]);
      }
      return this.length;
    };
    Yallist.prototype.unshift = function() {
      for (var i = 0, l2 = arguments.length; i < l2; i++) {
        unshift(this, arguments[i]);
      }
      return this.length;
    };
    Yallist.prototype.pop = function() {
      if (!this.tail) {
        return void 0;
      }
      var res = this.tail.value;
      this.tail = this.tail.prev;
      if (this.tail) {
        this.tail.next = null;
      } else {
        this.head = null;
      }
      this.length--;
      return res;
    };
    Yallist.prototype.shift = function() {
      if (!this.head) {
        return void 0;
      }
      var res = this.head.value;
      this.head = this.head.next;
      if (this.head) {
        this.head.prev = null;
      } else {
        this.tail = null;
      }
      this.length--;
      return res;
    };
    Yallist.prototype.forEach = function(fn, thisp) {
      thisp = thisp || this;
      for (var walker = this.head, i = 0; walker !== null; i++) {
        fn.call(thisp, walker.value, i, this);
        walker = walker.next;
      }
    };
    Yallist.prototype.forEachReverse = function(fn, thisp) {
      thisp = thisp || this;
      for (var walker = this.tail, i = this.length - 1; walker !== null; i--) {
        fn.call(thisp, walker.value, i, this);
        walker = walker.prev;
      }
    };
    Yallist.prototype.get = function(n) {
      for (var i = 0, walker = this.head; walker !== null && i < n; i++) {
        walker = walker.next;
      }
      if (i === n && walker !== null) {
        return walker.value;
      }
    };
    Yallist.prototype.getReverse = function(n) {
      for (var i = 0, walker = this.tail; walker !== null && i < n; i++) {
        walker = walker.prev;
      }
      if (i === n && walker !== null) {
        return walker.value;
      }
    };
    Yallist.prototype.map = function(fn, thisp) {
      thisp = thisp || this;
      var res = new Yallist();
      for (var walker = this.head; walker !== null; ) {
        res.push(fn.call(thisp, walker.value, this));
        walker = walker.next;
      }
      return res;
    };
    Yallist.prototype.mapReverse = function(fn, thisp) {
      thisp = thisp || this;
      var res = new Yallist();
      for (var walker = this.tail; walker !== null; ) {
        res.push(fn.call(thisp, walker.value, this));
        walker = walker.prev;
      }
      return res;
    };
    Yallist.prototype.reduce = function(fn, initial) {
      var acc;
      var walker = this.head;
      if (arguments.length > 1) {
        acc = initial;
      } else if (this.head) {
        walker = this.head.next;
        acc = this.head.value;
      } else {
        throw new TypeError("Reduce of empty list with no initial value");
      }
      for (var i = 0; walker !== null; i++) {
        acc = fn(acc, walker.value, i);
        walker = walker.next;
      }
      return acc;
    };
    Yallist.prototype.reduceReverse = function(fn, initial) {
      var acc;
      var walker = this.tail;
      if (arguments.length > 1) {
        acc = initial;
      } else if (this.tail) {
        walker = this.tail.prev;
        acc = this.tail.value;
      } else {
        throw new TypeError("Reduce of empty list with no initial value");
      }
      for (var i = this.length - 1; walker !== null; i--) {
        acc = fn(acc, walker.value, i);
        walker = walker.prev;
      }
      return acc;
    };
    Yallist.prototype.toArray = function() {
      var arr = new Array(this.length);
      for (var i = 0, walker = this.head; walker !== null; i++) {
        arr[i] = walker.value;
        walker = walker.next;
      }
      return arr;
    };
    Yallist.prototype.toArrayReverse = function() {
      var arr = new Array(this.length);
      for (var i = 0, walker = this.tail; walker !== null; i++) {
        arr[i] = walker.value;
        walker = walker.prev;
      }
      return arr;
    };
    Yallist.prototype.slice = function(from, to) {
      to = to || this.length;
      if (to < 0) {
        to += this.length;
      }
      from = from || 0;
      if (from < 0) {
        from += this.length;
      }
      var ret = new Yallist();
      if (to < from || to < 0) {
        return ret;
      }
      if (from < 0) {
        from = 0;
      }
      if (to > this.length) {
        to = this.length;
      }
      for (var i = 0, walker = this.head; walker !== null && i < from; i++) {
        walker = walker.next;
      }
      for (; walker !== null && i < to; i++, walker = walker.next) {
        ret.push(walker.value);
      }
      return ret;
    };
    Yallist.prototype.sliceReverse = function(from, to) {
      to = to || this.length;
      if (to < 0) {
        to += this.length;
      }
      from = from || 0;
      if (from < 0) {
        from += this.length;
      }
      var ret = new Yallist();
      if (to < from || to < 0) {
        return ret;
      }
      if (from < 0) {
        from = 0;
      }
      if (to > this.length) {
        to = this.length;
      }
      for (var i = this.length, walker = this.tail; walker !== null && i > to; i--) {
        walker = walker.prev;
      }
      for (; walker !== null && i > from; i--, walker = walker.prev) {
        ret.push(walker.value);
      }
      return ret;
    };
    Yallist.prototype.splice = function(start, deleteCount, ...nodes) {
      if (start > this.length) {
        start = this.length - 1;
      }
      if (start < 0) {
        start = this.length + start;
      }
      for (var i = 0, walker = this.head; walker !== null && i < start; i++) {
        walker = walker.next;
      }
      var ret = [];
      for (var i = 0; walker && i < deleteCount; i++) {
        ret.push(walker.value);
        walker = this.removeNode(walker);
      }
      if (walker === null) {
        walker = this.tail;
      }
      if (walker !== this.head && walker !== this.tail) {
        walker = walker.prev;
      }
      for (var i = 0; i < nodes.length; i++) {
        walker = insert(this, walker, nodes[i]);
      }
      return ret;
    };
    Yallist.prototype.reverse = function() {
      var head = this.head;
      var tail = this.tail;
      for (var walker = head; walker !== null; walker = walker.prev) {
        var p3 = walker.prev;
        walker.prev = walker.next;
        walker.next = p3;
      }
      this.head = tail;
      this.tail = head;
      return this;
    };
    function insert(self2, node, value) {
      var inserted = node === self2.head ? new Node(value, null, node, self2) : new Node(value, node, node.next, self2);
      if (inserted.next === null) {
        self2.tail = inserted;
      }
      if (inserted.prev === null) {
        self2.head = inserted;
      }
      self2.length++;
      return inserted;
    }
    function push(self2, item) {
      self2.tail = new Node(item, self2.tail, null, self2);
      if (!self2.head) {
        self2.head = self2.tail;
      }
      self2.length++;
    }
    function unshift(self2, item) {
      self2.head = new Node(item, null, self2.head, self2);
      if (!self2.tail) {
        self2.tail = self2.head;
      }
      self2.length++;
    }
    function Node(value, prev, next, list) {
      if (!(this instanceof Node)) {
        return new Node(value, prev, next, list);
      }
      this.list = list;
      this.value = value;
      if (prev) {
        prev.next = this;
        this.prev = prev;
      } else {
        this.prev = null;
      }
      if (next) {
        next.prev = this;
        this.next = next;
      } else {
        this.next = null;
      }
    }
    try {
      require_iterator()(Yallist);
    } catch (er) {
    }
  }
});

// node_modules/lru-cache/index.js
var require_lru_cache = __commonJS({
  "node_modules/lru-cache/index.js"(exports2, module2) {
    "use strict";
    var Yallist = require_yallist();
    var MAX = Symbol("max");
    var LENGTH = Symbol("length");
    var LENGTH_CALCULATOR = Symbol("lengthCalculator");
    var ALLOW_STALE = Symbol("allowStale");
    var MAX_AGE = Symbol("maxAge");
    var DISPOSE = Symbol("dispose");
    var NO_DISPOSE_ON_SET = Symbol("noDisposeOnSet");
    var LRU_LIST = Symbol("lruList");
    var CACHE = Symbol("cache");
    var UPDATE_AGE_ON_GET = Symbol("updateAgeOnGet");
    var naiveLength = () => 1;
    var LRUCache = class {
      constructor(options) {
        if (typeof options === "number")
          options = { max: options };
        if (!options)
          options = {};
        if (options.max && (typeof options.max !== "number" || options.max < 0))
          throw new TypeError("max must be a non-negative number");
        const max = this[MAX] = options.max || Infinity;
        const lc = options.length || naiveLength;
        this[LENGTH_CALCULATOR] = typeof lc !== "function" ? naiveLength : lc;
        this[ALLOW_STALE] = options.stale || false;
        if (options.maxAge && typeof options.maxAge !== "number")
          throw new TypeError("maxAge must be a number");
        this[MAX_AGE] = options.maxAge || 0;
        this[DISPOSE] = options.dispose;
        this[NO_DISPOSE_ON_SET] = options.noDisposeOnSet || false;
        this[UPDATE_AGE_ON_GET] = options.updateAgeOnGet || false;
        this.reset();
      }
      // resize the cache when the max changes.
      set max(mL) {
        if (typeof mL !== "number" || mL < 0)
          throw new TypeError("max must be a non-negative number");
        this[MAX] = mL || Infinity;
        trim(this);
      }
      get max() {
        return this[MAX];
      }
      set allowStale(allowStale) {
        this[ALLOW_STALE] = !!allowStale;
      }
      get allowStale() {
        return this[ALLOW_STALE];
      }
      set maxAge(mA) {
        if (typeof mA !== "number")
          throw new TypeError("maxAge must be a non-negative number");
        this[MAX_AGE] = mA;
        trim(this);
      }
      get maxAge() {
        return this[MAX_AGE];
      }
      // resize the cache when the lengthCalculator changes.
      set lengthCalculator(lC) {
        if (typeof lC !== "function")
          lC = naiveLength;
        if (lC !== this[LENGTH_CALCULATOR]) {
          this[LENGTH_CALCULATOR] = lC;
          this[LENGTH] = 0;
          this[LRU_LIST].forEach((hit) => {
            hit.length = this[LENGTH_CALCULATOR](hit.value, hit.key);
            this[LENGTH] += hit.length;
          });
        }
        trim(this);
      }
      get lengthCalculator() {
        return this[LENGTH_CALCULATOR];
      }
      get length() {
        return this[LENGTH];
      }
      get itemCount() {
        return this[LRU_LIST].length;
      }
      rforEach(fn, thisp) {
        thisp = thisp || this;
        for (let walker = this[LRU_LIST].tail; walker !== null; ) {
          const prev = walker.prev;
          forEachStep(this, fn, walker, thisp);
          walker = prev;
        }
      }
      forEach(fn, thisp) {
        thisp = thisp || this;
        for (let walker = this[LRU_LIST].head; walker !== null; ) {
          const next = walker.next;
          forEachStep(this, fn, walker, thisp);
          walker = next;
        }
      }
      keys() {
        return this[LRU_LIST].toArray().map((k) => k.key);
      }
      values() {
        return this[LRU_LIST].toArray().map((k) => k.value);
      }
      reset() {
        if (this[DISPOSE] && this[LRU_LIST] && this[LRU_LIST].length) {
          this[LRU_LIST].forEach((hit) => this[DISPOSE](hit.key, hit.value));
        }
        this[CACHE] = /* @__PURE__ */ new Map();
        this[LRU_LIST] = new Yallist();
        this[LENGTH] = 0;
      }
      dump() {
        return this[LRU_LIST].map((hit) => isStale2(this, hit) ? false : {
          k: hit.key,
          v: hit.value,
          e: hit.now + (hit.maxAge || 0)
        }).toArray().filter((h) => h);
      }
      dumpLru() {
        return this[LRU_LIST];
      }
      set(key, value, maxAge) {
        maxAge = maxAge || this[MAX_AGE];
        if (maxAge && typeof maxAge !== "number")
          throw new TypeError("maxAge must be a number");
        const now = maxAge ? Date.now() : 0;
        const len = this[LENGTH_CALCULATOR](value, key);
        if (this[CACHE].has(key)) {
          if (len > this[MAX]) {
            del(this, this[CACHE].get(key));
            return false;
          }
          const node = this[CACHE].get(key);
          const item = node.value;
          if (this[DISPOSE]) {
            if (!this[NO_DISPOSE_ON_SET])
              this[DISPOSE](key, item.value);
          }
          item.now = now;
          item.maxAge = maxAge;
          item.value = value;
          this[LENGTH] += len - item.length;
          item.length = len;
          this.get(key);
          trim(this);
          return true;
        }
        const hit = new Entry(key, value, len, now, maxAge);
        if (hit.length > this[MAX]) {
          if (this[DISPOSE])
            this[DISPOSE](key, value);
          return false;
        }
        this[LENGTH] += hit.length;
        this[LRU_LIST].unshift(hit);
        this[CACHE].set(key, this[LRU_LIST].head);
        trim(this);
        return true;
      }
      has(key) {
        if (!this[CACHE].has(key))
          return false;
        const hit = this[CACHE].get(key).value;
        return !isStale2(this, hit);
      }
      get(key) {
        return get(this, key, true);
      }
      peek(key) {
        return get(this, key, false);
      }
      pop() {
        const node = this[LRU_LIST].tail;
        if (!node)
          return null;
        del(this, node);
        return node.value;
      }
      del(key) {
        del(this, this[CACHE].get(key));
      }
      load(arr) {
        this.reset();
        const now = Date.now();
        for (let l2 = arr.length - 1; l2 >= 0; l2--) {
          const hit = arr[l2];
          const expiresAt = hit.e || 0;
          if (expiresAt === 0)
            this.set(hit.k, hit.v);
          else {
            const maxAge = expiresAt - now;
            if (maxAge > 0) {
              this.set(hit.k, hit.v, maxAge);
            }
          }
        }
      }
      prune() {
        this[CACHE].forEach((value, key) => get(this, key, false));
      }
    };
    var get = (self2, key, doUse) => {
      const node = self2[CACHE].get(key);
      if (node) {
        const hit = node.value;
        if (isStale2(self2, hit)) {
          del(self2, node);
          if (!self2[ALLOW_STALE])
            return void 0;
        } else {
          if (doUse) {
            if (self2[UPDATE_AGE_ON_GET])
              node.value.now = Date.now();
            self2[LRU_LIST].unshiftNode(node);
          }
        }
        return hit.value;
      }
    };
    var isStale2 = (self2, hit) => {
      if (!hit || !hit.maxAge && !self2[MAX_AGE])
        return false;
      const diff = Date.now() - hit.now;
      return hit.maxAge ? diff > hit.maxAge : self2[MAX_AGE] && diff > self2[MAX_AGE];
    };
    var trim = (self2) => {
      if (self2[LENGTH] > self2[MAX]) {
        for (let walker = self2[LRU_LIST].tail; self2[LENGTH] > self2[MAX] && walker !== null; ) {
          const prev = walker.prev;
          del(self2, walker);
          walker = prev;
        }
      }
    };
    var del = (self2, node) => {
      if (node) {
        const hit = node.value;
        if (self2[DISPOSE])
          self2[DISPOSE](hit.key, hit.value);
        self2[LENGTH] -= hit.length;
        self2[CACHE].delete(hit.key);
        self2[LRU_LIST].removeNode(node);
      }
    };
    var Entry = class {
      constructor(key, value, length, now, maxAge) {
        this.key = key;
        this.value = value;
        this.length = length;
        this.now = now;
        this.maxAge = maxAge || 0;
      }
    };
    var forEachStep = (self2, fn, node, thisp) => {
      let hit = node.value;
      if (isStale2(self2, hit)) {
        del(self2, node);
        if (!self2[ALLOW_STALE])
          hit = void 0;
      }
      if (hit)
        fn.call(thisp, hit.value, hit.key, self2);
    };
    module2.exports = LRUCache;
  }
});

// node_modules/js-sdsl/dist/cjs/container/ContainerBase/index.js
var require_ContainerBase = __commonJS({
  "node_modules/js-sdsl/dist/cjs/container/ContainerBase/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "t", {
      value: true
    });
    exports2.ContainerIterator = exports2.Container = exports2.Base = void 0;
    var ContainerIterator = class {
      constructor(t = 0) {
        this.iteratorType = t;
      }
      equals(t) {
        return this.o === t.o;
      }
    };
    exports2.ContainerIterator = ContainerIterator;
    var Base = class {
      constructor() {
        this.i = 0;
      }
      get length() {
        return this.i;
      }
      size() {
        return this.i;
      }
      empty() {
        return this.i === 0;
      }
    };
    exports2.Base = Base;
    var Container = class extends Base {
    };
    exports2.Container = Container;
  }
});

// node_modules/js-sdsl/dist/cjs/container/OtherContainer/Stack.js
var require_Stack = __commonJS({
  "node_modules/js-sdsl/dist/cjs/container/OtherContainer/Stack.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "t", {
      value: true
    });
    exports2.default = void 0;
    var _ContainerBase = require_ContainerBase();
    var Stack = class extends _ContainerBase.Base {
      constructor(t = []) {
        super();
        this.S = [];
        const s = this;
        t.forEach(function(t2) {
          s.push(t2);
        });
      }
      clear() {
        this.i = 0;
        this.S = [];
      }
      push(t) {
        this.S.push(t);
        this.i += 1;
        return this.i;
      }
      pop() {
        if (this.i === 0)
          return;
        this.i -= 1;
        return this.S.pop();
      }
      top() {
        return this.S[this.i - 1];
      }
    };
    var _default = Stack;
    exports2.default = _default;
  }
});

// node_modules/js-sdsl/dist/cjs/container/OtherContainer/Queue.js
var require_Queue = __commonJS({
  "node_modules/js-sdsl/dist/cjs/container/OtherContainer/Queue.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "t", {
      value: true
    });
    exports2.default = void 0;
    var _ContainerBase = require_ContainerBase();
    var Queue = class extends _ContainerBase.Base {
      constructor(t = []) {
        super();
        this.j = 0;
        this.q = [];
        const s = this;
        t.forEach(function(t2) {
          s.push(t2);
        });
      }
      clear() {
        this.q = [];
        this.i = this.j = 0;
      }
      push(t) {
        const s = this.q.length;
        if (this.j / s > 0.5 && this.j + this.i >= s && s > 4096) {
          const s2 = this.i;
          for (let t2 = 0; t2 < s2; ++t2) {
            this.q[t2] = this.q[this.j + t2];
          }
          this.j = 0;
          this.q[this.i] = t;
        } else
          this.q[this.j + this.i] = t;
        return ++this.i;
      }
      pop() {
        if (this.i === 0)
          return;
        const t = this.q[this.j++];
        this.i -= 1;
        return t;
      }
      front() {
        if (this.i === 0)
          return;
        return this.q[this.j];
      }
    };
    var _default = Queue;
    exports2.default = _default;
  }
});

// node_modules/js-sdsl/dist/cjs/container/OtherContainer/PriorityQueue.js
var require_PriorityQueue = __commonJS({
  "node_modules/js-sdsl/dist/cjs/container/OtherContainer/PriorityQueue.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "t", {
      value: true
    });
    exports2.default = void 0;
    var _ContainerBase = require_ContainerBase();
    var PriorityQueue = class extends _ContainerBase.Base {
      constructor(t = [], s = function(t2, s2) {
        if (t2 > s2)
          return -1;
        if (t2 < s2)
          return 1;
        return 0;
      }, i = true) {
        super();
        this.v = s;
        if (Array.isArray(t)) {
          this.C = i ? [...t] : t;
        } else {
          this.C = [];
          const s2 = this;
          t.forEach(function(t2) {
            s2.C.push(t2);
          });
        }
        this.i = this.C.length;
        const e = this.i >> 1;
        for (let t2 = this.i - 1 >> 1; t2 >= 0; --t2) {
          this.k(t2, e);
        }
      }
      m(t) {
        const s = this.C[t];
        while (t > 0) {
          const i = t - 1 >> 1;
          const e = this.C[i];
          if (this.v(e, s) <= 0)
            break;
          this.C[t] = e;
          t = i;
        }
        this.C[t] = s;
      }
      k(t, s) {
        const i = this.C[t];
        while (t < s) {
          let s2 = t << 1 | 1;
          const e = s2 + 1;
          let h = this.C[s2];
          if (e < this.i && this.v(h, this.C[e]) > 0) {
            s2 = e;
            h = this.C[e];
          }
          if (this.v(h, i) >= 0)
            break;
          this.C[t] = h;
          t = s2;
        }
        this.C[t] = i;
      }
      clear() {
        this.i = 0;
        this.C.length = 0;
      }
      push(t) {
        this.C.push(t);
        this.m(this.i);
        this.i += 1;
      }
      pop() {
        if (this.i === 0)
          return;
        const t = this.C[0];
        const s = this.C.pop();
        this.i -= 1;
        if (this.i) {
          this.C[0] = s;
          this.k(0, this.i >> 1);
        }
        return t;
      }
      top() {
        return this.C[0];
      }
      find(t) {
        return this.C.indexOf(t) >= 0;
      }
      remove(t) {
        const s = this.C.indexOf(t);
        if (s < 0)
          return false;
        if (s === 0) {
          this.pop();
        } else if (s === this.i - 1) {
          this.C.pop();
          this.i -= 1;
        } else {
          this.C.splice(s, 1, this.C.pop());
          this.i -= 1;
          this.m(s);
          this.k(s, this.i >> 1);
        }
        return true;
      }
      updateItem(t) {
        const s = this.C.indexOf(t);
        if (s < 0)
          return false;
        this.m(s);
        this.k(s, this.i >> 1);
        return true;
      }
      toArray() {
        return [...this.C];
      }
    };
    var _default = PriorityQueue;
    exports2.default = _default;
  }
});

// node_modules/js-sdsl/dist/cjs/container/SequentialContainer/Base/index.js
var require_Base = __commonJS({
  "node_modules/js-sdsl/dist/cjs/container/SequentialContainer/Base/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "t", {
      value: true
    });
    exports2.default = void 0;
    var _ContainerBase = require_ContainerBase();
    var SequentialContainer = class extends _ContainerBase.Container {
    };
    var _default = SequentialContainer;
    exports2.default = _default;
  }
});

// node_modules/js-sdsl/dist/cjs/utils/throwError.js
var require_throwError = __commonJS({
  "node_modules/js-sdsl/dist/cjs/utils/throwError.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "t", {
      value: true
    });
    exports2.throwIteratorAccessError = throwIteratorAccessError;
    function throwIteratorAccessError() {
      throw new RangeError("Iterator access denied!");
    }
  }
});

// node_modules/js-sdsl/dist/cjs/container/SequentialContainer/Base/RandomIterator.js
var require_RandomIterator = __commonJS({
  "node_modules/js-sdsl/dist/cjs/container/SequentialContainer/Base/RandomIterator.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "t", {
      value: true
    });
    exports2.RandomIterator = void 0;
    var _ContainerBase = require_ContainerBase();
    var _throwError = require_throwError();
    var RandomIterator = class extends _ContainerBase.ContainerIterator {
      constructor(t, r) {
        super(r);
        this.o = t;
        if (this.iteratorType === 0) {
          this.pre = function() {
            if (this.o === 0) {
              (0, _throwError.throwIteratorAccessError)();
            }
            this.o -= 1;
            return this;
          };
          this.next = function() {
            if (this.o === this.container.size()) {
              (0, _throwError.throwIteratorAccessError)();
            }
            this.o += 1;
            return this;
          };
        } else {
          this.pre = function() {
            if (this.o === this.container.size() - 1) {
              (0, _throwError.throwIteratorAccessError)();
            }
            this.o += 1;
            return this;
          };
          this.next = function() {
            if (this.o === -1) {
              (0, _throwError.throwIteratorAccessError)();
            }
            this.o -= 1;
            return this;
          };
        }
      }
      get pointer() {
        return this.container.getElementByPos(this.o);
      }
      set pointer(t) {
        this.container.setElementByPos(this.o, t);
      }
    };
    exports2.RandomIterator = RandomIterator;
  }
});

// node_modules/js-sdsl/dist/cjs/container/SequentialContainer/Vector.js
var require_Vector = __commonJS({
  "node_modules/js-sdsl/dist/cjs/container/SequentialContainer/Vector.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "t", {
      value: true
    });
    exports2.default = void 0;
    var _Base = _interopRequireDefault(require_Base());
    var _RandomIterator = require_RandomIterator();
    function _interopRequireDefault(t) {
      return t && t.t ? t : {
        default: t
      };
    }
    var VectorIterator = class _VectorIterator extends _RandomIterator.RandomIterator {
      constructor(t, r, e) {
        super(t, e);
        this.container = r;
      }
      copy() {
        return new _VectorIterator(this.o, this.container, this.iteratorType);
      }
    };
    var Vector = class extends _Base.default {
      constructor(t = [], r = true) {
        super();
        if (Array.isArray(t)) {
          this.J = r ? [...t] : t;
          this.i = t.length;
        } else {
          this.J = [];
          const r2 = this;
          t.forEach(function(t2) {
            r2.pushBack(t2);
          });
        }
      }
      clear() {
        this.i = 0;
        this.J.length = 0;
      }
      begin() {
        return new VectorIterator(0, this);
      }
      end() {
        return new VectorIterator(this.i, this);
      }
      rBegin() {
        return new VectorIterator(this.i - 1, this, 1);
      }
      rEnd() {
        return new VectorIterator(-1, this, 1);
      }
      front() {
        return this.J[0];
      }
      back() {
        return this.J[this.i - 1];
      }
      getElementByPos(t) {
        if (t < 0 || t > this.i - 1) {
          throw new RangeError();
        }
        return this.J[t];
      }
      eraseElementByPos(t) {
        if (t < 0 || t > this.i - 1) {
          throw new RangeError();
        }
        this.J.splice(t, 1);
        this.i -= 1;
        return this.i;
      }
      eraseElementByValue(t) {
        let r = 0;
        for (let e = 0; e < this.i; ++e) {
          if (this.J[e] !== t) {
            this.J[r++] = this.J[e];
          }
        }
        this.i = this.J.length = r;
        return this.i;
      }
      eraseElementByIterator(t) {
        const r = t.o;
        t = t.next();
        this.eraseElementByPos(r);
        return t;
      }
      pushBack(t) {
        this.J.push(t);
        this.i += 1;
        return this.i;
      }
      popBack() {
        if (this.i === 0)
          return;
        this.i -= 1;
        return this.J.pop();
      }
      setElementByPos(t, r) {
        if (t < 0 || t > this.i - 1) {
          throw new RangeError();
        }
        this.J[t] = r;
      }
      insert(t, r, e = 1) {
        if (t < 0 || t > this.i) {
          throw new RangeError();
        }
        this.J.splice(t, 0, ...new Array(e).fill(r));
        this.i += e;
        return this.i;
      }
      find(t) {
        for (let r = 0; r < this.i; ++r) {
          if (this.J[r] === t) {
            return new VectorIterator(r, this);
          }
        }
        return this.end();
      }
      reverse() {
        this.J.reverse();
      }
      unique() {
        let t = 1;
        for (let r = 1; r < this.i; ++r) {
          if (this.J[r] !== this.J[r - 1]) {
            this.J[t++] = this.J[r];
          }
        }
        this.i = this.J.length = t;
        return this.i;
      }
      sort(t) {
        this.J.sort(t);
      }
      forEach(t) {
        for (let r = 0; r < this.i; ++r) {
          t(this.J[r], r, this);
        }
      }
      [Symbol.iterator]() {
        return function* () {
          yield* this.J;
        }.bind(this)();
      }
    };
    var _default = Vector;
    exports2.default = _default;
  }
});

// node_modules/js-sdsl/dist/cjs/container/SequentialContainer/LinkList.js
var require_LinkList = __commonJS({
  "node_modules/js-sdsl/dist/cjs/container/SequentialContainer/LinkList.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "t", {
      value: true
    });
    exports2.default = void 0;
    var _Base = _interopRequireDefault(require_Base());
    var _ContainerBase = require_ContainerBase();
    var _throwError = require_throwError();
    function _interopRequireDefault(t) {
      return t && t.t ? t : {
        default: t
      };
    }
    var LinkListIterator = class _LinkListIterator extends _ContainerBase.ContainerIterator {
      constructor(t, i, s, r) {
        super(r);
        this.o = t;
        this.h = i;
        this.container = s;
        if (this.iteratorType === 0) {
          this.pre = function() {
            if (this.o.L === this.h) {
              (0, _throwError.throwIteratorAccessError)();
            }
            this.o = this.o.L;
            return this;
          };
          this.next = function() {
            if (this.o === this.h) {
              (0, _throwError.throwIteratorAccessError)();
            }
            this.o = this.o.B;
            return this;
          };
        } else {
          this.pre = function() {
            if (this.o.B === this.h) {
              (0, _throwError.throwIteratorAccessError)();
            }
            this.o = this.o.B;
            return this;
          };
          this.next = function() {
            if (this.o === this.h) {
              (0, _throwError.throwIteratorAccessError)();
            }
            this.o = this.o.L;
            return this;
          };
        }
      }
      get pointer() {
        if (this.o === this.h) {
          (0, _throwError.throwIteratorAccessError)();
        }
        return this.o.l;
      }
      set pointer(t) {
        if (this.o === this.h) {
          (0, _throwError.throwIteratorAccessError)();
        }
        this.o.l = t;
      }
      copy() {
        return new _LinkListIterator(this.o, this.h, this.container, this.iteratorType);
      }
    };
    var LinkList = class extends _Base.default {
      constructor(t = []) {
        super();
        this.h = {};
        this.p = this._ = this.h.L = this.h.B = this.h;
        const i = this;
        t.forEach(function(t2) {
          i.pushBack(t2);
        });
      }
      V(t) {
        const { L: i, B: s } = t;
        i.B = s;
        s.L = i;
        if (t === this.p) {
          this.p = s;
        }
        if (t === this._) {
          this._ = i;
        }
        this.i -= 1;
      }
      G(t, i) {
        const s = i.B;
        const r = {
          l: t,
          L: i,
          B: s
        };
        i.B = r;
        s.L = r;
        if (i === this.h) {
          this.p = r;
        }
        if (s === this.h) {
          this._ = r;
        }
        this.i += 1;
      }
      clear() {
        this.i = 0;
        this.p = this._ = this.h.L = this.h.B = this.h;
      }
      begin() {
        return new LinkListIterator(this.p, this.h, this);
      }
      end() {
        return new LinkListIterator(this.h, this.h, this);
      }
      rBegin() {
        return new LinkListIterator(this._, this.h, this, 1);
      }
      rEnd() {
        return new LinkListIterator(this.h, this.h, this, 1);
      }
      front() {
        return this.p.l;
      }
      back() {
        return this._.l;
      }
      getElementByPos(t) {
        if (t < 0 || t > this.i - 1) {
          throw new RangeError();
        }
        let i = this.p;
        while (t--) {
          i = i.B;
        }
        return i.l;
      }
      eraseElementByPos(t) {
        if (t < 0 || t > this.i - 1) {
          throw new RangeError();
        }
        let i = this.p;
        while (t--) {
          i = i.B;
        }
        this.V(i);
        return this.i;
      }
      eraseElementByValue(t) {
        let i = this.p;
        while (i !== this.h) {
          if (i.l === t) {
            this.V(i);
          }
          i = i.B;
        }
        return this.i;
      }
      eraseElementByIterator(t) {
        const i = t.o;
        if (i === this.h) {
          (0, _throwError.throwIteratorAccessError)();
        }
        t = t.next();
        this.V(i);
        return t;
      }
      pushBack(t) {
        this.G(t, this._);
        return this.i;
      }
      popBack() {
        if (this.i === 0)
          return;
        const t = this._.l;
        this.V(this._);
        return t;
      }
      pushFront(t) {
        this.G(t, this.h);
        return this.i;
      }
      popFront() {
        if (this.i === 0)
          return;
        const t = this.p.l;
        this.V(this.p);
        return t;
      }
      setElementByPos(t, i) {
        if (t < 0 || t > this.i - 1) {
          throw new RangeError();
        }
        let s = this.p;
        while (t--) {
          s = s.B;
        }
        s.l = i;
      }
      insert(t, i, s = 1) {
        if (t < 0 || t > this.i) {
          throw new RangeError();
        }
        if (s <= 0)
          return this.i;
        if (t === 0) {
          while (s--)
            this.pushFront(i);
        } else if (t === this.i) {
          while (s--)
            this.pushBack(i);
        } else {
          let r = this.p;
          for (let i2 = 1; i2 < t; ++i2) {
            r = r.B;
          }
          const e = r.B;
          this.i += s;
          while (s--) {
            r.B = {
              l: i,
              L: r
            };
            r.B.L = r;
            r = r.B;
          }
          r.B = e;
          e.L = r;
        }
        return this.i;
      }
      find(t) {
        let i = this.p;
        while (i !== this.h) {
          if (i.l === t) {
            return new LinkListIterator(i, this.h, this);
          }
          i = i.B;
        }
        return this.end();
      }
      reverse() {
        if (this.i <= 1)
          return;
        let t = this.p;
        let i = this._;
        let s = 0;
        while (s << 1 < this.i) {
          const r = t.l;
          t.l = i.l;
          i.l = r;
          t = t.B;
          i = i.L;
          s += 1;
        }
      }
      unique() {
        if (this.i <= 1) {
          return this.i;
        }
        let t = this.p;
        while (t !== this.h) {
          let i = t;
          while (i.B !== this.h && i.l === i.B.l) {
            i = i.B;
            this.i -= 1;
          }
          t.B = i.B;
          t.B.L = t;
          t = t.B;
        }
        return this.i;
      }
      sort(t) {
        if (this.i <= 1)
          return;
        const i = [];
        this.forEach(function(t2) {
          i.push(t2);
        });
        i.sort(t);
        let s = this.p;
        i.forEach(function(t2) {
          s.l = t2;
          s = s.B;
        });
      }
      merge(t) {
        const i = this;
        if (this.i === 0) {
          t.forEach(function(t2) {
            i.pushBack(t2);
          });
        } else {
          let s = this.p;
          t.forEach(function(t2) {
            while (s !== i.h && s.l <= t2) {
              s = s.B;
            }
            i.G(t2, s.L);
          });
        }
        return this.i;
      }
      forEach(t) {
        let i = this.p;
        let s = 0;
        while (i !== this.h) {
          t(i.l, s++, this);
          i = i.B;
        }
      }
      [Symbol.iterator]() {
        return function* () {
          if (this.i === 0)
            return;
          let t = this.p;
          while (t !== this.h) {
            yield t.l;
            t = t.B;
          }
        }.bind(this)();
      }
    };
    var _default = LinkList;
    exports2.default = _default;
  }
});

// node_modules/js-sdsl/dist/cjs/container/SequentialContainer/Deque.js
var require_Deque = __commonJS({
  "node_modules/js-sdsl/dist/cjs/container/SequentialContainer/Deque.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "t", {
      value: true
    });
    exports2.default = void 0;
    var _Base = _interopRequireDefault(require_Base());
    var _RandomIterator = require_RandomIterator();
    function _interopRequireDefault(t) {
      return t && t.t ? t : {
        default: t
      };
    }
    var DequeIterator = class _DequeIterator extends _RandomIterator.RandomIterator {
      constructor(t, i, s) {
        super(t, s);
        this.container = i;
      }
      copy() {
        return new _DequeIterator(this.o, this.container, this.iteratorType);
      }
    };
    var Deque = class extends _Base.default {
      constructor(t = [], i = 1 << 12) {
        super();
        this.j = 0;
        this.D = 0;
        this.R = 0;
        this.N = 0;
        this.P = 0;
        this.A = [];
        const s = (() => {
          if (typeof t.length === "number")
            return t.length;
          if (typeof t.size === "number")
            return t.size;
          if (typeof t.size === "function")
            return t.size();
          throw new TypeError("Cannot get the length or size of the container");
        })();
        this.F = i;
        this.P = Math.max(Math.ceil(s / this.F), 1);
        for (let t2 = 0; t2 < this.P; ++t2) {
          this.A.push(new Array(this.F));
        }
        const h = Math.ceil(s / this.F);
        this.j = this.R = (this.P >> 1) - (h >> 1);
        this.D = this.N = this.F - s % this.F >> 1;
        const e = this;
        t.forEach(function(t2) {
          e.pushBack(t2);
        });
      }
      T() {
        const t = [];
        const i = Math.max(this.P >> 1, 1);
        for (let s = 0; s < i; ++s) {
          t[s] = new Array(this.F);
        }
        for (let i2 = this.j; i2 < this.P; ++i2) {
          t[t.length] = this.A[i2];
        }
        for (let i2 = 0; i2 < this.R; ++i2) {
          t[t.length] = this.A[i2];
        }
        t[t.length] = [...this.A[this.R]];
        this.j = i;
        this.R = t.length - 1;
        for (let s = 0; s < i; ++s) {
          t[t.length] = new Array(this.F);
        }
        this.A = t;
        this.P = t.length;
      }
      O(t) {
        const i = this.D + t + 1;
        const s = i % this.F;
        let h = s - 1;
        let e = this.j + (i - s) / this.F;
        if (s === 0)
          e -= 1;
        e %= this.P;
        if (h < 0)
          h += this.F;
        return {
          curNodeBucketIndex: e,
          curNodePointerIndex: h
        };
      }
      clear() {
        this.A = [new Array(this.F)];
        this.P = 1;
        this.j = this.R = this.i = 0;
        this.D = this.N = this.F >> 1;
      }
      begin() {
        return new DequeIterator(0, this);
      }
      end() {
        return new DequeIterator(this.i, this);
      }
      rBegin() {
        return new DequeIterator(this.i - 1, this, 1);
      }
      rEnd() {
        return new DequeIterator(-1, this, 1);
      }
      front() {
        if (this.i === 0)
          return;
        return this.A[this.j][this.D];
      }
      back() {
        if (this.i === 0)
          return;
        return this.A[this.R][this.N];
      }
      pushBack(t) {
        if (this.i) {
          if (this.N < this.F - 1) {
            this.N += 1;
          } else if (this.R < this.P - 1) {
            this.R += 1;
            this.N = 0;
          } else {
            this.R = 0;
            this.N = 0;
          }
          if (this.R === this.j && this.N === this.D)
            this.T();
        }
        this.i += 1;
        this.A[this.R][this.N] = t;
        return this.i;
      }
      popBack() {
        if (this.i === 0)
          return;
        const t = this.A[this.R][this.N];
        if (this.i !== 1) {
          if (this.N > 0) {
            this.N -= 1;
          } else if (this.R > 0) {
            this.R -= 1;
            this.N = this.F - 1;
          } else {
            this.R = this.P - 1;
            this.N = this.F - 1;
          }
        }
        this.i -= 1;
        return t;
      }
      pushFront(t) {
        if (this.i) {
          if (this.D > 0) {
            this.D -= 1;
          } else if (this.j > 0) {
            this.j -= 1;
            this.D = this.F - 1;
          } else {
            this.j = this.P - 1;
            this.D = this.F - 1;
          }
          if (this.j === this.R && this.D === this.N)
            this.T();
        }
        this.i += 1;
        this.A[this.j][this.D] = t;
        return this.i;
      }
      popFront() {
        if (this.i === 0)
          return;
        const t = this.A[this.j][this.D];
        if (this.i !== 1) {
          if (this.D < this.F - 1) {
            this.D += 1;
          } else if (this.j < this.P - 1) {
            this.j += 1;
            this.D = 0;
          } else {
            this.j = 0;
            this.D = 0;
          }
        }
        this.i -= 1;
        return t;
      }
      getElementByPos(t) {
        if (t < 0 || t > this.i - 1) {
          throw new RangeError();
        }
        const { curNodeBucketIndex: i, curNodePointerIndex: s } = this.O(t);
        return this.A[i][s];
      }
      setElementByPos(t, i) {
        if (t < 0 || t > this.i - 1) {
          throw new RangeError();
        }
        const { curNodeBucketIndex: s, curNodePointerIndex: h } = this.O(t);
        this.A[s][h] = i;
      }
      insert(t, i, s = 1) {
        if (t < 0 || t > this.i) {
          throw new RangeError();
        }
        if (t === 0) {
          while (s--)
            this.pushFront(i);
        } else if (t === this.i) {
          while (s--)
            this.pushBack(i);
        } else {
          const h = [];
          for (let i2 = t; i2 < this.i; ++i2) {
            h.push(this.getElementByPos(i2));
          }
          this.cut(t - 1);
          for (let t2 = 0; t2 < s; ++t2)
            this.pushBack(i);
          for (let t2 = 0; t2 < h.length; ++t2)
            this.pushBack(h[t2]);
        }
        return this.i;
      }
      cut(t) {
        if (t < 0) {
          this.clear();
          return 0;
        }
        const { curNodeBucketIndex: i, curNodePointerIndex: s } = this.O(t);
        this.R = i;
        this.N = s;
        this.i = t + 1;
        return this.i;
      }
      eraseElementByPos(t) {
        if (t < 0 || t > this.i - 1) {
          throw new RangeError();
        }
        if (t === 0)
          this.popFront();
        else if (t === this.i - 1)
          this.popBack();
        else {
          const i = [];
          for (let s2 = t + 1; s2 < this.i; ++s2) {
            i.push(this.getElementByPos(s2));
          }
          this.cut(t);
          this.popBack();
          const s = this;
          i.forEach(function(t2) {
            s.pushBack(t2);
          });
        }
        return this.i;
      }
      eraseElementByValue(t) {
        if (this.i === 0)
          return 0;
        const i = [];
        for (let s2 = 0; s2 < this.i; ++s2) {
          const h = this.getElementByPos(s2);
          if (h !== t)
            i.push(h);
        }
        const s = i.length;
        for (let t2 = 0; t2 < s; ++t2)
          this.setElementByPos(t2, i[t2]);
        return this.cut(s - 1);
      }
      eraseElementByIterator(t) {
        const i = t.o;
        this.eraseElementByPos(i);
        t = t.next();
        return t;
      }
      find(t) {
        for (let i = 0; i < this.i; ++i) {
          if (this.getElementByPos(i) === t) {
            return new DequeIterator(i, this);
          }
        }
        return this.end();
      }
      reverse() {
        let t = 0;
        let i = this.i - 1;
        while (t < i) {
          const s = this.getElementByPos(t);
          this.setElementByPos(t, this.getElementByPos(i));
          this.setElementByPos(i, s);
          t += 1;
          i -= 1;
        }
      }
      unique() {
        if (this.i <= 1) {
          return this.i;
        }
        let t = 1;
        let i = this.getElementByPos(0);
        for (let s = 1; s < this.i; ++s) {
          const h = this.getElementByPos(s);
          if (h !== i) {
            i = h;
            this.setElementByPos(t++, h);
          }
        }
        while (this.i > t)
          this.popBack();
        return this.i;
      }
      sort(t) {
        const i = [];
        for (let t2 = 0; t2 < this.i; ++t2) {
          i.push(this.getElementByPos(t2));
        }
        i.sort(t);
        for (let t2 = 0; t2 < this.i; ++t2)
          this.setElementByPos(t2, i[t2]);
      }
      shrinkToFit() {
        if (this.i === 0)
          return;
        const t = [];
        this.forEach(function(i) {
          t.push(i);
        });
        this.P = Math.max(Math.ceil(this.i / this.F), 1);
        this.i = this.j = this.R = this.D = this.N = 0;
        this.A = [];
        for (let t2 = 0; t2 < this.P; ++t2) {
          this.A.push(new Array(this.F));
        }
        for (let i = 0; i < t.length; ++i)
          this.pushBack(t[i]);
      }
      forEach(t) {
        for (let i = 0; i < this.i; ++i) {
          t(this.getElementByPos(i), i, this);
        }
      }
      [Symbol.iterator]() {
        return function* () {
          for (let t = 0; t < this.i; ++t) {
            yield this.getElementByPos(t);
          }
        }.bind(this)();
      }
    };
    var _default = Deque;
    exports2.default = _default;
  }
});

// node_modules/js-sdsl/dist/cjs/container/TreeContainer/Base/TreeNode.js
var require_TreeNode = __commonJS({
  "node_modules/js-sdsl/dist/cjs/container/TreeContainer/Base/TreeNode.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "t", {
      value: true
    });
    exports2.TreeNodeEnableIndex = exports2.TreeNode = void 0;
    var TreeNode = class {
      constructor(e, t) {
        this.ee = 1;
        this.u = void 0;
        this.l = void 0;
        this.U = void 0;
        this.W = void 0;
        this.tt = void 0;
        this.u = e;
        this.l = t;
      }
      L() {
        let e = this;
        if (e.ee === 1 && e.tt.tt === e) {
          e = e.W;
        } else if (e.U) {
          e = e.U;
          while (e.W) {
            e = e.W;
          }
        } else {
          let t = e.tt;
          while (t.U === e) {
            e = t;
            t = e.tt;
          }
          e = t;
        }
        return e;
      }
      B() {
        let e = this;
        if (e.W) {
          e = e.W;
          while (e.U) {
            e = e.U;
          }
          return e;
        } else {
          let t = e.tt;
          while (t.W === e) {
            e = t;
            t = e.tt;
          }
          if (e.W !== t) {
            return t;
          } else
            return e;
        }
      }
      te() {
        const e = this.tt;
        const t = this.W;
        const s = t.U;
        if (e.tt === this)
          e.tt = t;
        else if (e.U === this)
          e.U = t;
        else
          e.W = t;
        t.tt = e;
        t.U = this;
        this.tt = t;
        this.W = s;
        if (s)
          s.tt = this;
        return t;
      }
      se() {
        const e = this.tt;
        const t = this.U;
        const s = t.W;
        if (e.tt === this)
          e.tt = t;
        else if (e.U === this)
          e.U = t;
        else
          e.W = t;
        t.tt = e;
        t.W = this;
        this.tt = t;
        this.U = s;
        if (s)
          s.tt = this;
        return t;
      }
    };
    exports2.TreeNode = TreeNode;
    var TreeNodeEnableIndex = class extends TreeNode {
      constructor() {
        super(...arguments);
        this.rt = 1;
      }
      te() {
        const e = super.te();
        this.ie();
        e.ie();
        return e;
      }
      se() {
        const e = super.se();
        this.ie();
        e.ie();
        return e;
      }
      ie() {
        this.rt = 1;
        if (this.U) {
          this.rt += this.U.rt;
        }
        if (this.W) {
          this.rt += this.W.rt;
        }
      }
    };
    exports2.TreeNodeEnableIndex = TreeNodeEnableIndex;
  }
});

// node_modules/js-sdsl/dist/cjs/container/TreeContainer/Base/index.js
var require_Base2 = __commonJS({
  "node_modules/js-sdsl/dist/cjs/container/TreeContainer/Base/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "t", {
      value: true
    });
    exports2.default = void 0;
    var _TreeNode = require_TreeNode();
    var _ContainerBase = require_ContainerBase();
    var _throwError = require_throwError();
    var TreeContainer = class extends _ContainerBase.Container {
      constructor(e = function(e2, t2) {
        if (e2 < t2)
          return -1;
        if (e2 > t2)
          return 1;
        return 0;
      }, t = false) {
        super();
        this.Y = void 0;
        this.v = e;
        if (t) {
          this.re = _TreeNode.TreeNodeEnableIndex;
          this.M = function(e2, t2, i) {
            const s = this.ne(e2, t2, i);
            if (s) {
              let e3 = s.tt;
              while (e3 !== this.h) {
                e3.rt += 1;
                e3 = e3.tt;
              }
              const t3 = this.he(s);
              if (t3) {
                const { parentNode: e4, grandParent: i2, curNode: s2 } = t3;
                e4.ie();
                i2.ie();
                s2.ie();
              }
            }
            return this.i;
          };
          this.V = function(e2) {
            let t2 = this.fe(e2);
            while (t2 !== this.h) {
              t2.rt -= 1;
              t2 = t2.tt;
            }
          };
        } else {
          this.re = _TreeNode.TreeNode;
          this.M = function(e2, t2, i) {
            const s = this.ne(e2, t2, i);
            if (s)
              this.he(s);
            return this.i;
          };
          this.V = this.fe;
        }
        this.h = new this.re();
      }
      X(e, t) {
        let i = this.h;
        while (e) {
          const s = this.v(e.u, t);
          if (s < 0) {
            e = e.W;
          } else if (s > 0) {
            i = e;
            e = e.U;
          } else
            return e;
        }
        return i;
      }
      Z(e, t) {
        let i = this.h;
        while (e) {
          const s = this.v(e.u, t);
          if (s <= 0) {
            e = e.W;
          } else {
            i = e;
            e = e.U;
          }
        }
        return i;
      }
      $(e, t) {
        let i = this.h;
        while (e) {
          const s = this.v(e.u, t);
          if (s < 0) {
            i = e;
            e = e.W;
          } else if (s > 0) {
            e = e.U;
          } else
            return e;
        }
        return i;
      }
      rr(e, t) {
        let i = this.h;
        while (e) {
          const s = this.v(e.u, t);
          if (s < 0) {
            i = e;
            e = e.W;
          } else {
            e = e.U;
          }
        }
        return i;
      }
      ue(e) {
        while (true) {
          const t = e.tt;
          if (t === this.h)
            return;
          if (e.ee === 1) {
            e.ee = 0;
            return;
          }
          if (e === t.U) {
            const i = t.W;
            if (i.ee === 1) {
              i.ee = 0;
              t.ee = 1;
              if (t === this.Y) {
                this.Y = t.te();
              } else
                t.te();
            } else {
              if (i.W && i.W.ee === 1) {
                i.ee = t.ee;
                t.ee = 0;
                i.W.ee = 0;
                if (t === this.Y) {
                  this.Y = t.te();
                } else
                  t.te();
                return;
              } else if (i.U && i.U.ee === 1) {
                i.ee = 1;
                i.U.ee = 0;
                i.se();
              } else {
                i.ee = 1;
                e = t;
              }
            }
          } else {
            const i = t.U;
            if (i.ee === 1) {
              i.ee = 0;
              t.ee = 1;
              if (t === this.Y) {
                this.Y = t.se();
              } else
                t.se();
            } else {
              if (i.U && i.U.ee === 1) {
                i.ee = t.ee;
                t.ee = 0;
                i.U.ee = 0;
                if (t === this.Y) {
                  this.Y = t.se();
                } else
                  t.se();
                return;
              } else if (i.W && i.W.ee === 1) {
                i.ee = 1;
                i.W.ee = 0;
                i.te();
              } else {
                i.ee = 1;
                e = t;
              }
            }
          }
        }
      }
      fe(e) {
        if (this.i === 1) {
          this.clear();
          return this.h;
        }
        let t = e;
        while (t.U || t.W) {
          if (t.W) {
            t = t.W;
            while (t.U)
              t = t.U;
          } else {
            t = t.U;
          }
          [e.u, t.u] = [t.u, e.u];
          [e.l, t.l] = [t.l, e.l];
          e = t;
        }
        if (this.h.U === t) {
          this.h.U = t.tt;
        } else if (this.h.W === t) {
          this.h.W = t.tt;
        }
        this.ue(t);
        const i = t.tt;
        if (t === i.U) {
          i.U = void 0;
        } else
          i.W = void 0;
        this.i -= 1;
        this.Y.ee = 0;
        return i;
      }
      oe(e, t) {
        if (e === void 0)
          return false;
        const i = this.oe(e.U, t);
        if (i)
          return true;
        if (t(e))
          return true;
        return this.oe(e.W, t);
      }
      he(e) {
        while (true) {
          const t = e.tt;
          if (t.ee === 0)
            return;
          const i = t.tt;
          if (t === i.U) {
            const s = i.W;
            if (s && s.ee === 1) {
              s.ee = t.ee = 0;
              if (i === this.Y)
                return;
              i.ee = 1;
              e = i;
              continue;
            } else if (e === t.W) {
              e.ee = 0;
              if (e.U)
                e.U.tt = t;
              if (e.W)
                e.W.tt = i;
              t.W = e.U;
              i.U = e.W;
              e.U = t;
              e.W = i;
              if (i === this.Y) {
                this.Y = e;
                this.h.tt = e;
              } else {
                const t2 = i.tt;
                if (t2.U === i) {
                  t2.U = e;
                } else
                  t2.W = e;
              }
              e.tt = i.tt;
              t.tt = e;
              i.tt = e;
              i.ee = 1;
              return {
                parentNode: t,
                grandParent: i,
                curNode: e
              };
            } else {
              t.ee = 0;
              if (i === this.Y) {
                this.Y = i.se();
              } else
                i.se();
              i.ee = 1;
            }
          } else {
            const s = i.U;
            if (s && s.ee === 1) {
              s.ee = t.ee = 0;
              if (i === this.Y)
                return;
              i.ee = 1;
              e = i;
              continue;
            } else if (e === t.U) {
              e.ee = 0;
              if (e.U)
                e.U.tt = i;
              if (e.W)
                e.W.tt = t;
              i.W = e.U;
              t.U = e.W;
              e.U = i;
              e.W = t;
              if (i === this.Y) {
                this.Y = e;
                this.h.tt = e;
              } else {
                const t2 = i.tt;
                if (t2.U === i) {
                  t2.U = e;
                } else
                  t2.W = e;
              }
              e.tt = i.tt;
              t.tt = e;
              i.tt = e;
              i.ee = 1;
              return {
                parentNode: t,
                grandParent: i,
                curNode: e
              };
            } else {
              t.ee = 0;
              if (i === this.Y) {
                this.Y = i.te();
              } else
                i.te();
              i.ee = 1;
            }
          }
          return;
        }
      }
      ne(e, t, i) {
        if (this.Y === void 0) {
          this.i += 1;
          this.Y = new this.re(e, t);
          this.Y.ee = 0;
          this.Y.tt = this.h;
          this.h.tt = this.Y;
          this.h.U = this.Y;
          this.h.W = this.Y;
          return;
        }
        let s;
        const r = this.h.U;
        const n = this.v(r.u, e);
        if (n === 0) {
          r.l = t;
          return;
        } else if (n > 0) {
          r.U = new this.re(e, t);
          r.U.tt = r;
          s = r.U;
          this.h.U = s;
        } else {
          const r2 = this.h.W;
          const n2 = this.v(r2.u, e);
          if (n2 === 0) {
            r2.l = t;
            return;
          } else if (n2 < 0) {
            r2.W = new this.re(e, t);
            r2.W.tt = r2;
            s = r2.W;
            this.h.W = s;
          } else {
            if (i !== void 0) {
              const r3 = i.o;
              if (r3 !== this.h) {
                const i2 = this.v(r3.u, e);
                if (i2 === 0) {
                  r3.l = t;
                  return;
                } else if (i2 > 0) {
                  const i3 = r3.L();
                  const n3 = this.v(i3.u, e);
                  if (n3 === 0) {
                    i3.l = t;
                    return;
                  } else if (n3 < 0) {
                    s = new this.re(e, t);
                    if (i3.W === void 0) {
                      i3.W = s;
                      s.tt = i3;
                    } else {
                      r3.U = s;
                      s.tt = r3;
                    }
                  }
                }
              }
            }
            if (s === void 0) {
              s = this.Y;
              while (true) {
                const i2 = this.v(s.u, e);
                if (i2 > 0) {
                  if (s.U === void 0) {
                    s.U = new this.re(e, t);
                    s.U.tt = s;
                    s = s.U;
                    break;
                  }
                  s = s.U;
                } else if (i2 < 0) {
                  if (s.W === void 0) {
                    s.W = new this.re(e, t);
                    s.W.tt = s;
                    s = s.W;
                    break;
                  }
                  s = s.W;
                } else {
                  s.l = t;
                  return;
                }
              }
            }
          }
        }
        this.i += 1;
        return s;
      }
      I(e, t) {
        while (e) {
          const i = this.v(e.u, t);
          if (i < 0) {
            e = e.W;
          } else if (i > 0) {
            e = e.U;
          } else
            return e;
        }
        return e || this.h;
      }
      clear() {
        this.i = 0;
        this.Y = void 0;
        this.h.tt = void 0;
        this.h.U = this.h.W = void 0;
      }
      updateKeyByIterator(e, t) {
        const i = e.o;
        if (i === this.h) {
          (0, _throwError.throwIteratorAccessError)();
        }
        if (this.i === 1) {
          i.u = t;
          return true;
        }
        if (i === this.h.U) {
          if (this.v(i.B().u, t) > 0) {
            i.u = t;
            return true;
          }
          return false;
        }
        if (i === this.h.W) {
          if (this.v(i.L().u, t) < 0) {
            i.u = t;
            return true;
          }
          return false;
        }
        const s = i.L().u;
        if (this.v(s, t) >= 0)
          return false;
        const r = i.B().u;
        if (this.v(r, t) <= 0)
          return false;
        i.u = t;
        return true;
      }
      eraseElementByPos(e) {
        if (e < 0 || e > this.i - 1) {
          throw new RangeError();
        }
        let t = 0;
        const i = this;
        this.oe(this.Y, function(s) {
          if (e === t) {
            i.V(s);
            return true;
          }
          t += 1;
          return false;
        });
        return this.i;
      }
      eraseElementByKey(e) {
        if (this.i === 0)
          return false;
        const t = this.I(this.Y, e);
        if (t === this.h)
          return false;
        this.V(t);
        return true;
      }
      eraseElementByIterator(e) {
        const t = e.o;
        if (t === this.h) {
          (0, _throwError.throwIteratorAccessError)();
        }
        const i = t.W === void 0;
        const s = e.iteratorType === 0;
        if (s) {
          if (i)
            e.next();
        } else {
          if (!i || t.U === void 0)
            e.next();
        }
        this.V(t);
        return e;
      }
      forEach(e) {
        let t = 0;
        for (const i of this)
          e(i, t++, this);
      }
      getElementByPos(e) {
        if (e < 0 || e > this.i - 1) {
          throw new RangeError();
        }
        let t;
        let i = 0;
        for (const s of this) {
          if (i === e) {
            t = s;
            break;
          }
          i += 1;
        }
        return t;
      }
      getHeight() {
        if (this.i === 0)
          return 0;
        const traversal = function(e) {
          if (!e)
            return 0;
          return Math.max(traversal(e.U), traversal(e.W)) + 1;
        };
        return traversal(this.Y);
      }
    };
    var _default = TreeContainer;
    exports2.default = _default;
  }
});

// node_modules/js-sdsl/dist/cjs/container/TreeContainer/Base/TreeIterator.js
var require_TreeIterator = __commonJS({
  "node_modules/js-sdsl/dist/cjs/container/TreeContainer/Base/TreeIterator.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "t", {
      value: true
    });
    exports2.default = void 0;
    var _ContainerBase = require_ContainerBase();
    var _throwError = require_throwError();
    var TreeIterator = class extends _ContainerBase.ContainerIterator {
      constructor(t, r, i) {
        super(i);
        this.o = t;
        this.h = r;
        if (this.iteratorType === 0) {
          this.pre = function() {
            if (this.o === this.h.U) {
              (0, _throwError.throwIteratorAccessError)();
            }
            this.o = this.o.L();
            return this;
          };
          this.next = function() {
            if (this.o === this.h) {
              (0, _throwError.throwIteratorAccessError)();
            }
            this.o = this.o.B();
            return this;
          };
        } else {
          this.pre = function() {
            if (this.o === this.h.W) {
              (0, _throwError.throwIteratorAccessError)();
            }
            this.o = this.o.B();
            return this;
          };
          this.next = function() {
            if (this.o === this.h) {
              (0, _throwError.throwIteratorAccessError)();
            }
            this.o = this.o.L();
            return this;
          };
        }
      }
      get index() {
        let t = this.o;
        const r = this.h.tt;
        if (t === this.h) {
          if (r) {
            return r.rt - 1;
          }
          return 0;
        }
        let i = 0;
        if (t.U) {
          i += t.U.rt;
        }
        while (t !== r) {
          const r2 = t.tt;
          if (t === r2.W) {
            i += 1;
            if (r2.U) {
              i += r2.U.rt;
            }
          }
          t = r2;
        }
        return i;
      }
    };
    var _default = TreeIterator;
    exports2.default = _default;
  }
});

// node_modules/js-sdsl/dist/cjs/container/TreeContainer/OrderedSet.js
var require_OrderedSet = __commonJS({
  "node_modules/js-sdsl/dist/cjs/container/TreeContainer/OrderedSet.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "t", {
      value: true
    });
    exports2.default = void 0;
    var _Base = _interopRequireDefault(require_Base2());
    var _TreeIterator = _interopRequireDefault(require_TreeIterator());
    var _throwError = require_throwError();
    function _interopRequireDefault(e) {
      return e && e.t ? e : {
        default: e
      };
    }
    var OrderedSetIterator = class _OrderedSetIterator extends _TreeIterator.default {
      constructor(e, t, r, i) {
        super(e, t, i);
        this.container = r;
      }
      get pointer() {
        if (this.o === this.h) {
          (0, _throwError.throwIteratorAccessError)();
        }
        return this.o.u;
      }
      copy() {
        return new _OrderedSetIterator(this.o, this.h, this.container, this.iteratorType);
      }
    };
    var OrderedSet = class extends _Base.default {
      constructor(e = [], t, r) {
        super(t, r);
        const i = this;
        e.forEach(function(e2) {
          i.insert(e2);
        });
      }
      *K(e) {
        if (e === void 0)
          return;
        yield* this.K(e.U);
        yield e.u;
        yield* this.K(e.W);
      }
      begin() {
        return new OrderedSetIterator(this.h.U || this.h, this.h, this);
      }
      end() {
        return new OrderedSetIterator(this.h, this.h, this);
      }
      rBegin() {
        return new OrderedSetIterator(this.h.W || this.h, this.h, this, 1);
      }
      rEnd() {
        return new OrderedSetIterator(this.h, this.h, this, 1);
      }
      front() {
        return this.h.U ? this.h.U.u : void 0;
      }
      back() {
        return this.h.W ? this.h.W.u : void 0;
      }
      insert(e, t) {
        return this.M(e, void 0, t);
      }
      find(e) {
        const t = this.I(this.Y, e);
        return new OrderedSetIterator(t, this.h, this);
      }
      lowerBound(e) {
        const t = this.X(this.Y, e);
        return new OrderedSetIterator(t, this.h, this);
      }
      upperBound(e) {
        const t = this.Z(this.Y, e);
        return new OrderedSetIterator(t, this.h, this);
      }
      reverseLowerBound(e) {
        const t = this.$(this.Y, e);
        return new OrderedSetIterator(t, this.h, this);
      }
      reverseUpperBound(e) {
        const t = this.rr(this.Y, e);
        return new OrderedSetIterator(t, this.h, this);
      }
      union(e) {
        const t = this;
        e.forEach(function(e2) {
          t.insert(e2);
        });
        return this.i;
      }
      [Symbol.iterator]() {
        return this.K(this.Y);
      }
    };
    var _default = OrderedSet;
    exports2.default = _default;
  }
});

// node_modules/js-sdsl/dist/cjs/container/TreeContainer/OrderedMap.js
var require_OrderedMap = __commonJS({
  "node_modules/js-sdsl/dist/cjs/container/TreeContainer/OrderedMap.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "t", {
      value: true
    });
    exports2.default = void 0;
    var _Base = _interopRequireDefault(require_Base2());
    var _TreeIterator = _interopRequireDefault(require_TreeIterator());
    var _throwError = require_throwError();
    function _interopRequireDefault(r) {
      return r && r.t ? r : {
        default: r
      };
    }
    var OrderedMapIterator = class _OrderedMapIterator extends _TreeIterator.default {
      constructor(r, t, e, s) {
        super(r, t, s);
        this.container = e;
      }
      get pointer() {
        if (this.o === this.h) {
          (0, _throwError.throwIteratorAccessError)();
        }
        const r = this;
        return new Proxy([], {
          get(t, e) {
            if (e === "0")
              return r.o.u;
            else if (e === "1")
              return r.o.l;
          },
          set(t, e, s) {
            if (e !== "1") {
              throw new TypeError("props must be 1");
            }
            r.o.l = s;
            return true;
          }
        });
      }
      copy() {
        return new _OrderedMapIterator(this.o, this.h, this.container, this.iteratorType);
      }
    };
    var OrderedMap = class extends _Base.default {
      constructor(r = [], t, e) {
        super(t, e);
        const s = this;
        r.forEach(function(r2) {
          s.setElement(r2[0], r2[1]);
        });
      }
      *K(r) {
        if (r === void 0)
          return;
        yield* this.K(r.U);
        yield [r.u, r.l];
        yield* this.K(r.W);
      }
      begin() {
        return new OrderedMapIterator(this.h.U || this.h, this.h, this);
      }
      end() {
        return new OrderedMapIterator(this.h, this.h, this);
      }
      rBegin() {
        return new OrderedMapIterator(this.h.W || this.h, this.h, this, 1);
      }
      rEnd() {
        return new OrderedMapIterator(this.h, this.h, this, 1);
      }
      front() {
        if (this.i === 0)
          return;
        const r = this.h.U;
        return [r.u, r.l];
      }
      back() {
        if (this.i === 0)
          return;
        const r = this.h.W;
        return [r.u, r.l];
      }
      lowerBound(r) {
        const t = this.X(this.Y, r);
        return new OrderedMapIterator(t, this.h, this);
      }
      upperBound(r) {
        const t = this.Z(this.Y, r);
        return new OrderedMapIterator(t, this.h, this);
      }
      reverseLowerBound(r) {
        const t = this.$(this.Y, r);
        return new OrderedMapIterator(t, this.h, this);
      }
      reverseUpperBound(r) {
        const t = this.rr(this.Y, r);
        return new OrderedMapIterator(t, this.h, this);
      }
      setElement(r, t, e) {
        return this.M(r, t, e);
      }
      find(r) {
        const t = this.I(this.Y, r);
        return new OrderedMapIterator(t, this.h, this);
      }
      getElementByKey(r) {
        const t = this.I(this.Y, r);
        return t.l;
      }
      union(r) {
        const t = this;
        r.forEach(function(r2) {
          t.setElement(r2[0], r2[1]);
        });
        return this.i;
      }
      [Symbol.iterator]() {
        return this.K(this.Y);
      }
    };
    var _default = OrderedMap;
    exports2.default = _default;
  }
});

// node_modules/js-sdsl/dist/cjs/utils/checkObject.js
var require_checkObject = __commonJS({
  "node_modules/js-sdsl/dist/cjs/utils/checkObject.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "t", {
      value: true
    });
    exports2.default = checkObject;
    function checkObject(e) {
      const t = typeof e;
      return t === "object" && e !== null || t === "function";
    }
  }
});

// node_modules/js-sdsl/dist/cjs/container/HashContainer/Base/index.js
var require_Base3 = __commonJS({
  "node_modules/js-sdsl/dist/cjs/container/HashContainer/Base/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "t", {
      value: true
    });
    exports2.HashContainerIterator = exports2.HashContainer = void 0;
    var _ContainerBase = require_ContainerBase();
    var _checkObject = _interopRequireDefault(require_checkObject());
    var _throwError = require_throwError();
    function _interopRequireDefault(t) {
      return t && t.t ? t : {
        default: t
      };
    }
    var HashContainerIterator = class extends _ContainerBase.ContainerIterator {
      constructor(t, e, i) {
        super(i);
        this.o = t;
        this.h = e;
        if (this.iteratorType === 0) {
          this.pre = function() {
            if (this.o.L === this.h) {
              (0, _throwError.throwIteratorAccessError)();
            }
            this.o = this.o.L;
            return this;
          };
          this.next = function() {
            if (this.o === this.h) {
              (0, _throwError.throwIteratorAccessError)();
            }
            this.o = this.o.B;
            return this;
          };
        } else {
          this.pre = function() {
            if (this.o.B === this.h) {
              (0, _throwError.throwIteratorAccessError)();
            }
            this.o = this.o.B;
            return this;
          };
          this.next = function() {
            if (this.o === this.h) {
              (0, _throwError.throwIteratorAccessError)();
            }
            this.o = this.o.L;
            return this;
          };
        }
      }
    };
    exports2.HashContainerIterator = HashContainerIterator;
    var HashContainer = class extends _ContainerBase.Container {
      constructor() {
        super();
        this.H = [];
        this.g = {};
        this.HASH_TAG = Symbol("@@HASH_TAG");
        Object.setPrototypeOf(this.g, null);
        this.h = {};
        this.h.L = this.h.B = this.p = this._ = this.h;
      }
      V(t) {
        const { L: e, B: i } = t;
        e.B = i;
        i.L = e;
        if (t === this.p) {
          this.p = i;
        }
        if (t === this._) {
          this._ = e;
        }
        this.i -= 1;
      }
      M(t, e, i) {
        if (i === void 0)
          i = (0, _checkObject.default)(t);
        let s;
        if (i) {
          const i2 = t[this.HASH_TAG];
          if (i2 !== void 0) {
            this.H[i2].l = e;
            return this.i;
          }
          Object.defineProperty(t, this.HASH_TAG, {
            value: this.H.length,
            configurable: true
          });
          s = {
            u: t,
            l: e,
            L: this._,
            B: this.h
          };
          this.H.push(s);
        } else {
          const i2 = this.g[t];
          if (i2) {
            i2.l = e;
            return this.i;
          }
          s = {
            u: t,
            l: e,
            L: this._,
            B: this.h
          };
          this.g[t] = s;
        }
        if (this.i === 0) {
          this.p = s;
          this.h.B = s;
        } else {
          this._.B = s;
        }
        this._ = s;
        this.h.L = s;
        return ++this.i;
      }
      I(t, e) {
        if (e === void 0)
          e = (0, _checkObject.default)(t);
        if (e) {
          const e2 = t[this.HASH_TAG];
          if (e2 === void 0)
            return this.h;
          return this.H[e2];
        } else {
          return this.g[t] || this.h;
        }
      }
      clear() {
        const t = this.HASH_TAG;
        this.H.forEach(function(e) {
          delete e.u[t];
        });
        this.H = [];
        this.g = {};
        Object.setPrototypeOf(this.g, null);
        this.i = 0;
        this.p = this._ = this.h.L = this.h.B = this.h;
      }
      eraseElementByKey(t, e) {
        let i;
        if (e === void 0)
          e = (0, _checkObject.default)(t);
        if (e) {
          const e2 = t[this.HASH_TAG];
          if (e2 === void 0)
            return false;
          delete t[this.HASH_TAG];
          i = this.H[e2];
          delete this.H[e2];
        } else {
          i = this.g[t];
          if (i === void 0)
            return false;
          delete this.g[t];
        }
        this.V(i);
        return true;
      }
      eraseElementByIterator(t) {
        const e = t.o;
        if (e === this.h) {
          (0, _throwError.throwIteratorAccessError)();
        }
        this.V(e);
        return t.next();
      }
      eraseElementByPos(t) {
        if (t < 0 || t > this.i - 1) {
          throw new RangeError();
        }
        let e = this.p;
        while (t--) {
          e = e.B;
        }
        this.V(e);
        return this.i;
      }
    };
    exports2.HashContainer = HashContainer;
  }
});

// node_modules/js-sdsl/dist/cjs/container/HashContainer/HashSet.js
var require_HashSet = __commonJS({
  "node_modules/js-sdsl/dist/cjs/container/HashContainer/HashSet.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "t", {
      value: true
    });
    exports2.default = void 0;
    var _Base = require_Base3();
    var _throwError = require_throwError();
    var HashSetIterator = class _HashSetIterator extends _Base.HashContainerIterator {
      constructor(t, e, r, s) {
        super(t, e, s);
        this.container = r;
      }
      get pointer() {
        if (this.o === this.h) {
          (0, _throwError.throwIteratorAccessError)();
        }
        return this.o.u;
      }
      copy() {
        return new _HashSetIterator(this.o, this.h, this.container, this.iteratorType);
      }
    };
    var HashSet = class extends _Base.HashContainer {
      constructor(t = []) {
        super();
        const e = this;
        t.forEach(function(t2) {
          e.insert(t2);
        });
      }
      begin() {
        return new HashSetIterator(this.p, this.h, this);
      }
      end() {
        return new HashSetIterator(this.h, this.h, this);
      }
      rBegin() {
        return new HashSetIterator(this._, this.h, this, 1);
      }
      rEnd() {
        return new HashSetIterator(this.h, this.h, this, 1);
      }
      front() {
        return this.p.u;
      }
      back() {
        return this._.u;
      }
      insert(t, e) {
        return this.M(t, void 0, e);
      }
      getElementByPos(t) {
        if (t < 0 || t > this.i - 1) {
          throw new RangeError();
        }
        let e = this.p;
        while (t--) {
          e = e.B;
        }
        return e.u;
      }
      find(t, e) {
        const r = this.I(t, e);
        return new HashSetIterator(r, this.h, this);
      }
      forEach(t) {
        let e = 0;
        let r = this.p;
        while (r !== this.h) {
          t(r.u, e++, this);
          r = r.B;
        }
      }
      [Symbol.iterator]() {
        return function* () {
          let t = this.p;
          while (t !== this.h) {
            yield t.u;
            t = t.B;
          }
        }.bind(this)();
      }
    };
    var _default = HashSet;
    exports2.default = _default;
  }
});

// node_modules/js-sdsl/dist/cjs/container/HashContainer/HashMap.js
var require_HashMap = __commonJS({
  "node_modules/js-sdsl/dist/cjs/container/HashContainer/HashMap.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "t", {
      value: true
    });
    exports2.default = void 0;
    var _Base = require_Base3();
    var _checkObject = _interopRequireDefault(require_checkObject());
    var _throwError = require_throwError();
    function _interopRequireDefault(t) {
      return t && t.t ? t : {
        default: t
      };
    }
    var HashMapIterator = class _HashMapIterator extends _Base.HashContainerIterator {
      constructor(t, e, r, s) {
        super(t, e, s);
        this.container = r;
      }
      get pointer() {
        if (this.o === this.h) {
          (0, _throwError.throwIteratorAccessError)();
        }
        const t = this;
        return new Proxy([], {
          get(e, r) {
            if (r === "0")
              return t.o.u;
            else if (r === "1")
              return t.o.l;
          },
          set(e, r, s) {
            if (r !== "1") {
              throw new TypeError("props must be 1");
            }
            t.o.l = s;
            return true;
          }
        });
      }
      copy() {
        return new _HashMapIterator(this.o, this.h, this.container, this.iteratorType);
      }
    };
    var HashMap = class extends _Base.HashContainer {
      constructor(t = []) {
        super();
        const e = this;
        t.forEach(function(t2) {
          e.setElement(t2[0], t2[1]);
        });
      }
      begin() {
        return new HashMapIterator(this.p, this.h, this);
      }
      end() {
        return new HashMapIterator(this.h, this.h, this);
      }
      rBegin() {
        return new HashMapIterator(this._, this.h, this, 1);
      }
      rEnd() {
        return new HashMapIterator(this.h, this.h, this, 1);
      }
      front() {
        if (this.i === 0)
          return;
        return [this.p.u, this.p.l];
      }
      back() {
        if (this.i === 0)
          return;
        return [this._.u, this._.l];
      }
      setElement(t, e, r) {
        return this.M(t, e, r);
      }
      getElementByKey(t, e) {
        if (e === void 0)
          e = (0, _checkObject.default)(t);
        if (e) {
          const e2 = t[this.HASH_TAG];
          return e2 !== void 0 ? this.H[e2].l : void 0;
        }
        const r = this.g[t];
        return r ? r.l : void 0;
      }
      getElementByPos(t) {
        if (t < 0 || t > this.i - 1) {
          throw new RangeError();
        }
        let e = this.p;
        while (t--) {
          e = e.B;
        }
        return [e.u, e.l];
      }
      find(t, e) {
        const r = this.I(t, e);
        return new HashMapIterator(r, this.h, this);
      }
      forEach(t) {
        let e = 0;
        let r = this.p;
        while (r !== this.h) {
          t([r.u, r.l], e++, this);
          r = r.B;
        }
      }
      [Symbol.iterator]() {
        return function* () {
          let t = this.p;
          while (t !== this.h) {
            yield [t.u, t.l];
            t = t.B;
          }
        }.bind(this)();
      }
    };
    var _default = HashMap;
    exports2.default = _default;
  }
});

// node_modules/js-sdsl/dist/cjs/index.js
var require_cjs = __commonJS({
  "node_modules/js-sdsl/dist/cjs/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "t", {
      value: true
    });
    Object.defineProperty(exports2, "Deque", {
      enumerable: true,
      get: function() {
        return _Deque.default;
      }
    });
    Object.defineProperty(exports2, "HashMap", {
      enumerable: true,
      get: function() {
        return _HashMap.default;
      }
    });
    Object.defineProperty(exports2, "HashSet", {
      enumerable: true,
      get: function() {
        return _HashSet.default;
      }
    });
    Object.defineProperty(exports2, "LinkList", {
      enumerable: true,
      get: function() {
        return _LinkList.default;
      }
    });
    Object.defineProperty(exports2, "OrderedMap", {
      enumerable: true,
      get: function() {
        return _OrderedMap.default;
      }
    });
    Object.defineProperty(exports2, "OrderedSet", {
      enumerable: true,
      get: function() {
        return _OrderedSet.default;
      }
    });
    Object.defineProperty(exports2, "PriorityQueue", {
      enumerable: true,
      get: function() {
        return _PriorityQueue.default;
      }
    });
    Object.defineProperty(exports2, "Queue", {
      enumerable: true,
      get: function() {
        return _Queue.default;
      }
    });
    Object.defineProperty(exports2, "Stack", {
      enumerable: true,
      get: function() {
        return _Stack.default;
      }
    });
    Object.defineProperty(exports2, "Vector", {
      enumerable: true,
      get: function() {
        return _Vector.default;
      }
    });
    var _Stack = _interopRequireDefault(require_Stack());
    var _Queue = _interopRequireDefault(require_Queue());
    var _PriorityQueue = _interopRequireDefault(require_PriorityQueue());
    var _Vector = _interopRequireDefault(require_Vector());
    var _LinkList = _interopRequireDefault(require_LinkList());
    var _Deque = _interopRequireDefault(require_Deque());
    var _OrderedSet = _interopRequireDefault(require_OrderedSet());
    var _OrderedMap = _interopRequireDefault(require_OrderedMap());
    var _HashSet = _interopRequireDefault(require_HashSet());
    var _HashMap = _interopRequireDefault(require_HashMap());
    function _interopRequireDefault(e) {
      return e && e.t ? e : {
        default: e
      };
    }
  }
});

// node_modules/number-allocator/lib/number-allocator.js
var require_number_allocator = __commonJS({
  "node_modules/number-allocator/lib/number-allocator.js"(exports2, module2) {
    "use strict";
    var SortedSet = require_cjs().OrderedSet;
    var debugTrace = require_src()("number-allocator:trace");
    var debugError = require_src()("number-allocator:error");
    function Interval(low, high) {
      this.low = low;
      this.high = high;
    }
    Interval.prototype.equals = function(other) {
      return this.low === other.low && this.high === other.high;
    };
    Interval.prototype.compare = function(other) {
      if (this.low < other.low && this.high < other.low)
        return -1;
      if (other.low < this.low && other.high < this.low)
        return 1;
      return 0;
    };
    function NumberAllocator(min, max) {
      if (!(this instanceof NumberAllocator)) {
        return new NumberAllocator(min, max);
      }
      this.min = min;
      this.max = max;
      this.ss = new SortedSet(
        [],
        (lhs, rhs) => {
          return lhs.compare(rhs);
        }
      );
      debugTrace("Create");
      this.clear();
    }
    NumberAllocator.prototype.firstVacant = function() {
      if (this.ss.size() === 0)
        return null;
      return this.ss.front().low;
    };
    NumberAllocator.prototype.alloc = function() {
      if (this.ss.size() === 0) {
        debugTrace("alloc():empty");
        return null;
      }
      const it = this.ss.begin();
      const low = it.pointer.low;
      const high = it.pointer.high;
      const num = low;
      if (num + 1 <= high) {
        this.ss.updateKeyByIterator(it, new Interval(low + 1, high));
      } else {
        this.ss.eraseElementByPos(0);
      }
      debugTrace("alloc():" + num);
      return num;
    };
    NumberAllocator.prototype.use = function(num) {
      const key = new Interval(num, num);
      const it = this.ss.lowerBound(key);
      if (!it.equals(this.ss.end())) {
        const low = it.pointer.low;
        const high = it.pointer.high;
        if (it.pointer.equals(key)) {
          this.ss.eraseElementByIterator(it);
          debugTrace("use():" + num);
          return true;
        }
        if (low > num)
          return false;
        if (low === num) {
          this.ss.updateKeyByIterator(it, new Interval(low + 1, high));
          debugTrace("use():" + num);
          return true;
        }
        if (high === num) {
          this.ss.updateKeyByIterator(it, new Interval(low, high - 1));
          debugTrace("use():" + num);
          return true;
        }
        this.ss.updateKeyByIterator(it, new Interval(num + 1, high));
        this.ss.insert(new Interval(low, num - 1));
        debugTrace("use():" + num);
        return true;
      }
      debugTrace("use():failed");
      return false;
    };
    NumberAllocator.prototype.free = function(num) {
      if (num < this.min || num > this.max) {
        debugError("free():" + num + " is out of range");
        return;
      }
      const key = new Interval(num, num);
      const it = this.ss.upperBound(key);
      if (it.equals(this.ss.end())) {
        if (it.equals(this.ss.begin())) {
          this.ss.insert(key);
          return;
        }
        it.pre();
        const low = it.pointer.high;
        const high = it.pointer.high;
        if (high + 1 === num) {
          this.ss.updateKeyByIterator(it, new Interval(low, num));
        } else {
          this.ss.insert(key);
        }
      } else {
        if (it.equals(this.ss.begin())) {
          if (num + 1 === it.pointer.low) {
            const high = it.pointer.high;
            this.ss.updateKeyByIterator(it, new Interval(num, high));
          } else {
            this.ss.insert(key);
          }
        } else {
          const rLow = it.pointer.low;
          const rHigh = it.pointer.high;
          it.pre();
          const lLow = it.pointer.low;
          const lHigh = it.pointer.high;
          if (lHigh + 1 === num) {
            if (num + 1 === rLow) {
              this.ss.eraseElementByIterator(it);
              this.ss.updateKeyByIterator(it, new Interval(lLow, rHigh));
            } else {
              this.ss.updateKeyByIterator(it, new Interval(lLow, num));
            }
          } else {
            if (num + 1 === rLow) {
              this.ss.eraseElementByIterator(it.next());
              this.ss.insert(new Interval(num, rHigh));
            } else {
              this.ss.insert(key);
            }
          }
        }
      }
      debugTrace("free():" + num);
    };
    NumberAllocator.prototype.clear = function() {
      debugTrace("clear()");
      this.ss.clear();
      this.ss.insert(new Interval(this.min, this.max));
    };
    NumberAllocator.prototype.intervalCount = function() {
      return this.ss.size();
    };
    NumberAllocator.prototype.dump = function() {
      console.log("length:" + this.ss.size());
      for (const element of this.ss) {
        console.log(element);
      }
    };
    module2.exports = NumberAllocator;
  }
});

// node_modules/number-allocator/index.js
var require_number_allocator2 = __commonJS({
  "node_modules/number-allocator/index.js"(exports2, module2) {
    var NumberAllocator = require_number_allocator();
    module2.exports.NumberAllocator = NumberAllocator;
  }
});

// node_modules/mqtt/lib/topic-alias-send.js
var require_topic_alias_send = __commonJS({
  "node_modules/mqtt/lib/topic-alias-send.js"(exports2, module2) {
    "use strict";
    var LruMap = require_lru_cache();
    var NumberAllocator = require_number_allocator2().NumberAllocator;
    function TopicAliasSend(max) {
      if (!(this instanceof TopicAliasSend)) {
        return new TopicAliasSend(max);
      }
      if (max > 0) {
        this.aliasToTopic = new LruMap({ max });
        this.topicToAlias = {};
        this.numberAllocator = new NumberAllocator(1, max);
        this.max = max;
        this.length = 0;
      }
    }
    TopicAliasSend.prototype.put = function(topic, alias) {
      if (alias === 0 || alias > this.max) {
        return false;
      }
      const entry = this.aliasToTopic.get(alias);
      if (entry) {
        delete this.topicToAlias[entry];
      }
      this.aliasToTopic.set(alias, topic);
      this.topicToAlias[topic] = alias;
      this.numberAllocator.use(alias);
      this.length = this.aliasToTopic.length;
      return true;
    };
    TopicAliasSend.prototype.getTopicByAlias = function(alias) {
      return this.aliasToTopic.get(alias);
    };
    TopicAliasSend.prototype.getAliasByTopic = function(topic) {
      const alias = this.topicToAlias[topic];
      if (typeof alias !== "undefined") {
        this.aliasToTopic.get(alias);
      }
      return alias;
    };
    TopicAliasSend.prototype.clear = function() {
      this.aliasToTopic.reset();
      this.topicToAlias = {};
      this.numberAllocator.clear();
      this.length = 0;
    };
    TopicAliasSend.prototype.getLruAlias = function() {
      const alias = this.numberAllocator.firstVacant();
      if (alias)
        return alias;
      return this.aliasToTopic.keys()[this.aliasToTopic.length - 1];
    };
    module2.exports = TopicAliasSend;
  }
});

// node_modules/bl/BufferList.js
var require_BufferList = __commonJS({
  "node_modules/bl/BufferList.js"(exports2, module2) {
    "use strict";
    var { Buffer: Buffer2 } = require("buffer");
    var symbol = Symbol.for("BufferList");
    function BufferList(buf) {
      if (!(this instanceof BufferList)) {
        return new BufferList(buf);
      }
      BufferList._init.call(this, buf);
    }
    BufferList._init = function _init(buf) {
      Object.defineProperty(this, symbol, { value: true });
      this._bufs = [];
      this.length = 0;
      if (buf) {
        this.append(buf);
      }
    };
    BufferList.prototype._new = function _new(buf) {
      return new BufferList(buf);
    };
    BufferList.prototype._offset = function _offset(offset) {
      if (offset === 0) {
        return [0, 0];
      }
      let tot = 0;
      for (let i = 0; i < this._bufs.length; i++) {
        const _t = tot + this._bufs[i].length;
        if (offset < _t || i === this._bufs.length - 1) {
          return [i, offset - tot];
        }
        tot = _t;
      }
    };
    BufferList.prototype._reverseOffset = function(blOffset) {
      const bufferId = blOffset[0];
      let offset = blOffset[1];
      for (let i = 0; i < bufferId; i++) {
        offset += this._bufs[i].length;
      }
      return offset;
    };
    BufferList.prototype.get = function get(index) {
      if (index > this.length || index < 0) {
        return void 0;
      }
      const offset = this._offset(index);
      return this._bufs[offset[0]][offset[1]];
    };
    BufferList.prototype.slice = function slice(start, end) {
      if (typeof start === "number" && start < 0) {
        start += this.length;
      }
      if (typeof end === "number" && end < 0) {
        end += this.length;
      }
      return this.copy(null, 0, start, end);
    };
    BufferList.prototype.copy = function copy(dst, dstStart, srcStart, srcEnd) {
      if (typeof srcStart !== "number" || srcStart < 0) {
        srcStart = 0;
      }
      if (typeof srcEnd !== "number" || srcEnd > this.length) {
        srcEnd = this.length;
      }
      if (srcStart >= this.length) {
        return dst || Buffer2.alloc(0);
      }
      if (srcEnd <= 0) {
        return dst || Buffer2.alloc(0);
      }
      const copy2 = !!dst;
      const off = this._offset(srcStart);
      const len = srcEnd - srcStart;
      let bytes = len;
      let bufoff = copy2 && dstStart || 0;
      let start = off[1];
      if (srcStart === 0 && srcEnd === this.length) {
        if (!copy2) {
          return this._bufs.length === 1 ? this._bufs[0] : Buffer2.concat(this._bufs, this.length);
        }
        for (let i = 0; i < this._bufs.length; i++) {
          this._bufs[i].copy(dst, bufoff);
          bufoff += this._bufs[i].length;
        }
        return dst;
      }
      if (bytes <= this._bufs[off[0]].length - start) {
        return copy2 ? this._bufs[off[0]].copy(dst, dstStart, start, start + bytes) : this._bufs[off[0]].slice(start, start + bytes);
      }
      if (!copy2) {
        dst = Buffer2.allocUnsafe(len);
      }
      for (let i = off[0]; i < this._bufs.length; i++) {
        const l2 = this._bufs[i].length - start;
        if (bytes > l2) {
          this._bufs[i].copy(dst, bufoff, start);
          bufoff += l2;
        } else {
          this._bufs[i].copy(dst, bufoff, start, start + bytes);
          bufoff += l2;
          break;
        }
        bytes -= l2;
        if (start) {
          start = 0;
        }
      }
      if (dst.length > bufoff)
        return dst.slice(0, bufoff);
      return dst;
    };
    BufferList.prototype.shallowSlice = function shallowSlice(start, end) {
      start = start || 0;
      end = typeof end !== "number" ? this.length : end;
      if (start < 0) {
        start += this.length;
      }
      if (end < 0) {
        end += this.length;
      }
      if (start === end) {
        return this._new();
      }
      const startOffset = this._offset(start);
      const endOffset = this._offset(end);
      const buffers = this._bufs.slice(startOffset[0], endOffset[0] + 1);
      if (endOffset[1] === 0) {
        buffers.pop();
      } else {
        buffers[buffers.length - 1] = buffers[buffers.length - 1].slice(0, endOffset[1]);
      }
      if (startOffset[1] !== 0) {
        buffers[0] = buffers[0].slice(startOffset[1]);
      }
      return this._new(buffers);
    };
    BufferList.prototype.toString = function toString(encoding, start, end) {
      return this.slice(start, end).toString(encoding);
    };
    BufferList.prototype.consume = function consume(bytes) {
      bytes = Math.trunc(bytes);
      if (Number.isNaN(bytes) || bytes <= 0)
        return this;
      while (this._bufs.length) {
        if (bytes >= this._bufs[0].length) {
          bytes -= this._bufs[0].length;
          this.length -= this._bufs[0].length;
          this._bufs.shift();
        } else {
          this._bufs[0] = this._bufs[0].slice(bytes);
          this.length -= bytes;
          break;
        }
      }
      return this;
    };
    BufferList.prototype.duplicate = function duplicate() {
      const copy = this._new();
      for (let i = 0; i < this._bufs.length; i++) {
        copy.append(this._bufs[i]);
      }
      return copy;
    };
    BufferList.prototype.append = function append3(buf) {
      if (buf == null) {
        return this;
      }
      if (buf.buffer) {
        this._appendBuffer(Buffer2.from(buf.buffer, buf.byteOffset, buf.byteLength));
      } else if (Array.isArray(buf)) {
        for (let i = 0; i < buf.length; i++) {
          this.append(buf[i]);
        }
      } else if (this._isBufferList(buf)) {
        for (let i = 0; i < buf._bufs.length; i++) {
          this.append(buf._bufs[i]);
        }
      } else {
        if (typeof buf === "number") {
          buf = buf.toString();
        }
        this._appendBuffer(Buffer2.from(buf));
      }
      return this;
    };
    BufferList.prototype._appendBuffer = function appendBuffer(buf) {
      this._bufs.push(buf);
      this.length += buf.length;
    };
    BufferList.prototype.indexOf = function(search, offset, encoding) {
      if (encoding === void 0 && typeof offset === "string") {
        encoding = offset;
        offset = void 0;
      }
      if (typeof search === "function" || Array.isArray(search)) {
        throw new TypeError('The "value" argument must be one of type string, Buffer, BufferList, or Uint8Array.');
      } else if (typeof search === "number") {
        search = Buffer2.from([search]);
      } else if (typeof search === "string") {
        search = Buffer2.from(search, encoding);
      } else if (this._isBufferList(search)) {
        search = search.slice();
      } else if (Array.isArray(search.buffer)) {
        search = Buffer2.from(search.buffer, search.byteOffset, search.byteLength);
      } else if (!Buffer2.isBuffer(search)) {
        search = Buffer2.from(search);
      }
      offset = Number(offset || 0);
      if (isNaN(offset)) {
        offset = 0;
      }
      if (offset < 0) {
        offset = this.length + offset;
      }
      if (offset < 0) {
        offset = 0;
      }
      if (search.length === 0) {
        return offset > this.length ? this.length : offset;
      }
      const blOffset = this._offset(offset);
      let blIndex = blOffset[0];
      let buffOffset = blOffset[1];
      for (; blIndex < this._bufs.length; blIndex++) {
        const buff = this._bufs[blIndex];
        while (buffOffset < buff.length) {
          const availableWindow = buff.length - buffOffset;
          if (availableWindow >= search.length) {
            const nativeSearchResult = buff.indexOf(search, buffOffset);
            if (nativeSearchResult !== -1) {
              return this._reverseOffset([blIndex, nativeSearchResult]);
            }
            buffOffset = buff.length - search.length + 1;
          } else {
            const revOffset = this._reverseOffset([blIndex, buffOffset]);
            if (this._match(revOffset, search)) {
              return revOffset;
            }
            buffOffset++;
          }
        }
        buffOffset = 0;
      }
      return -1;
    };
    BufferList.prototype._match = function(offset, search) {
      if (this.length - offset < search.length) {
        return false;
      }
      for (let searchOffset = 0; searchOffset < search.length; searchOffset++) {
        if (this.get(offset + searchOffset) !== search[searchOffset]) {
          return false;
        }
      }
      return true;
    };
    (function() {
      const methods = {
        readDoubleBE: 8,
        readDoubleLE: 8,
        readFloatBE: 4,
        readFloatLE: 4,
        readInt32BE: 4,
        readInt32LE: 4,
        readUInt32BE: 4,
        readUInt32LE: 4,
        readInt16BE: 2,
        readInt16LE: 2,
        readUInt16BE: 2,
        readUInt16LE: 2,
        readInt8: 1,
        readUInt8: 1,
        readIntBE: null,
        readIntLE: null,
        readUIntBE: null,
        readUIntLE: null
      };
      for (const m2 in methods) {
        (function(m3) {
          if (methods[m3] === null) {
            BufferList.prototype[m3] = function(offset, byteLength) {
              return this.slice(offset, offset + byteLength)[m3](0, byteLength);
            };
          } else {
            BufferList.prototype[m3] = function(offset = 0) {
              return this.slice(offset, offset + methods[m3])[m3](0);
            };
          }
        })(m2);
      }
    })();
    BufferList.prototype._isBufferList = function _isBufferList(b) {
      return b instanceof BufferList || BufferList.isBufferList(b);
    };
    BufferList.isBufferList = function isBufferList(b) {
      return b != null && b[symbol];
    };
    module2.exports = BufferList;
  }
});

// node_modules/bl/bl.js
var require_bl = __commonJS({
  "node_modules/bl/bl.js"(exports2, module2) {
    "use strict";
    var DuplexStream = require_readable().Duplex;
    var inherits = require_inherits();
    var BufferList = require_BufferList();
    function BufferListStream(callback) {
      if (!(this instanceof BufferListStream)) {
        return new BufferListStream(callback);
      }
      if (typeof callback === "function") {
        this._callback = callback;
        const piper = function piper2(err) {
          if (this._callback) {
            this._callback(err);
            this._callback = null;
          }
        }.bind(this);
        this.on("pipe", function onPipe(src) {
          src.on("error", piper);
        });
        this.on("unpipe", function onUnpipe(src) {
          src.removeListener("error", piper);
        });
        callback = null;
      }
      BufferList._init.call(this, callback);
      DuplexStream.call(this);
    }
    inherits(BufferListStream, DuplexStream);
    Object.assign(BufferListStream.prototype, BufferList.prototype);
    BufferListStream.prototype._new = function _new(callback) {
      return new BufferListStream(callback);
    };
    BufferListStream.prototype._write = function _write(buf, encoding, callback) {
      this._appendBuffer(buf);
      if (typeof callback === "function") {
        callback();
      }
    };
    BufferListStream.prototype._read = function _read(size) {
      if (!this.length) {
        return this.push(null);
      }
      size = Math.min(size, this.length);
      this.push(this.slice(0, size));
      this.consume(size);
    };
    BufferListStream.prototype.end = function end(chunk) {
      DuplexStream.prototype.end.call(this, chunk);
      if (this._callback) {
        this._callback(null, this.slice());
        this._callback = null;
      }
    };
    BufferListStream.prototype._destroy = function _destroy(err, cb) {
      this._bufs.length = 0;
      this.length = 0;
      cb(err);
    };
    BufferListStream.prototype._isBufferList = function _isBufferList(b) {
      return b instanceof BufferListStream || b instanceof BufferList || BufferListStream.isBufferList(b);
    };
    BufferListStream.isBufferList = BufferList.isBufferList;
    module2.exports = BufferListStream;
    module2.exports.BufferListStream = BufferListStream;
    module2.exports.BufferList = BufferList;
  }
});

// node_modules/mqtt-packet/packet.js
var require_packet = __commonJS({
  "node_modules/mqtt-packet/packet.js"(exports2, module2) {
    var Packet = class {
      constructor() {
        this.cmd = null;
        this.retain = false;
        this.qos = 0;
        this.dup = false;
        this.length = -1;
        this.topic = null;
        this.payload = null;
      }
    };
    module2.exports = Packet;
  }
});

// node_modules/mqtt-packet/constants.js
var require_constants2 = __commonJS({
  "node_modules/mqtt-packet/constants.js"(exports2, module2) {
    var protocol = module2.exports;
    protocol.types = {
      0: "reserved",
      1: "connect",
      2: "connack",
      3: "publish",
      4: "puback",
      5: "pubrec",
      6: "pubrel",
      7: "pubcomp",
      8: "subscribe",
      9: "suback",
      10: "unsubscribe",
      11: "unsuback",
      12: "pingreq",
      13: "pingresp",
      14: "disconnect",
      15: "auth"
    };
    protocol.codes = {};
    for (const k in protocol.types) {
      const v = protocol.types[k];
      protocol.codes[v] = k;
    }
    protocol.CMD_SHIFT = 4;
    protocol.CMD_MASK = 240;
    protocol.DUP_MASK = 8;
    protocol.QOS_MASK = 3;
    protocol.QOS_SHIFT = 1;
    protocol.RETAIN_MASK = 1;
    protocol.VARBYTEINT_MASK = 127;
    protocol.VARBYTEINT_FIN_MASK = 128;
    protocol.VARBYTEINT_MAX = 268435455;
    protocol.SESSIONPRESENT_MASK = 1;
    protocol.SESSIONPRESENT_HEADER = Buffer.from([protocol.SESSIONPRESENT_MASK]);
    protocol.CONNACK_HEADER = Buffer.from([protocol.codes.connack << protocol.CMD_SHIFT]);
    protocol.USERNAME_MASK = 128;
    protocol.PASSWORD_MASK = 64;
    protocol.WILL_RETAIN_MASK = 32;
    protocol.WILL_QOS_MASK = 24;
    protocol.WILL_QOS_SHIFT = 3;
    protocol.WILL_FLAG_MASK = 4;
    protocol.CLEAN_SESSION_MASK = 2;
    protocol.CONNECT_HEADER = Buffer.from([protocol.codes.connect << protocol.CMD_SHIFT]);
    protocol.properties = {
      sessionExpiryInterval: 17,
      willDelayInterval: 24,
      receiveMaximum: 33,
      maximumPacketSize: 39,
      topicAliasMaximum: 34,
      requestResponseInformation: 25,
      requestProblemInformation: 23,
      userProperties: 38,
      authenticationMethod: 21,
      authenticationData: 22,
      payloadFormatIndicator: 1,
      messageExpiryInterval: 2,
      contentType: 3,
      responseTopic: 8,
      correlationData: 9,
      maximumQoS: 36,
      retainAvailable: 37,
      assignedClientIdentifier: 18,
      reasonString: 31,
      wildcardSubscriptionAvailable: 40,
      subscriptionIdentifiersAvailable: 41,
      sharedSubscriptionAvailable: 42,
      serverKeepAlive: 19,
      responseInformation: 26,
      serverReference: 28,
      topicAlias: 35,
      subscriptionIdentifier: 11
    };
    protocol.propertiesCodes = {};
    for (const prop in protocol.properties) {
      const id = protocol.properties[prop];
      protocol.propertiesCodes[id] = prop;
    }
    protocol.propertiesTypes = {
      sessionExpiryInterval: "int32",
      willDelayInterval: "int32",
      receiveMaximum: "int16",
      maximumPacketSize: "int32",
      topicAliasMaximum: "int16",
      requestResponseInformation: "byte",
      requestProblemInformation: "byte",
      userProperties: "pair",
      authenticationMethod: "string",
      authenticationData: "binary",
      payloadFormatIndicator: "byte",
      messageExpiryInterval: "int32",
      contentType: "string",
      responseTopic: "string",
      correlationData: "binary",
      maximumQoS: "int8",
      retainAvailable: "byte",
      assignedClientIdentifier: "string",
      reasonString: "string",
      wildcardSubscriptionAvailable: "byte",
      subscriptionIdentifiersAvailable: "byte",
      sharedSubscriptionAvailable: "byte",
      serverKeepAlive: "int16",
      responseInformation: "string",
      serverReference: "string",
      topicAlias: "int16",
      subscriptionIdentifier: "var"
    };
    function genHeader(type) {
      return [0, 1, 2].map((qos) => {
        return [0, 1].map((dup) => {
          return [0, 1].map((retain) => {
            const buf = Buffer.alloc(1);
            buf.writeUInt8(
              protocol.codes[type] << protocol.CMD_SHIFT | (dup ? protocol.DUP_MASK : 0) | qos << protocol.QOS_SHIFT | retain,
              0,
              true
            );
            return buf;
          });
        });
      });
    }
    protocol.PUBLISH_HEADER = genHeader("publish");
    protocol.SUBSCRIBE_HEADER = genHeader("subscribe");
    protocol.SUBSCRIBE_OPTIONS_QOS_MASK = 3;
    protocol.SUBSCRIBE_OPTIONS_NL_MASK = 1;
    protocol.SUBSCRIBE_OPTIONS_NL_SHIFT = 2;
    protocol.SUBSCRIBE_OPTIONS_RAP_MASK = 1;
    protocol.SUBSCRIBE_OPTIONS_RAP_SHIFT = 3;
    protocol.SUBSCRIBE_OPTIONS_RH_MASK = 3;
    protocol.SUBSCRIBE_OPTIONS_RH_SHIFT = 4;
    protocol.SUBSCRIBE_OPTIONS_RH = [0, 16, 32];
    protocol.SUBSCRIBE_OPTIONS_NL = 4;
    protocol.SUBSCRIBE_OPTIONS_RAP = 8;
    protocol.SUBSCRIBE_OPTIONS_QOS = [0, 1, 2];
    protocol.UNSUBSCRIBE_HEADER = genHeader("unsubscribe");
    protocol.ACKS = {
      unsuback: genHeader("unsuback"),
      puback: genHeader("puback"),
      pubcomp: genHeader("pubcomp"),
      pubrel: genHeader("pubrel"),
      pubrec: genHeader("pubrec")
    };
    protocol.SUBACK_HEADER = Buffer.from([protocol.codes.suback << protocol.CMD_SHIFT]);
    protocol.VERSION3 = Buffer.from([3]);
    protocol.VERSION4 = Buffer.from([4]);
    protocol.VERSION5 = Buffer.from([5]);
    protocol.VERSION131 = Buffer.from([131]);
    protocol.VERSION132 = Buffer.from([132]);
    protocol.QOS = [0, 1, 2].map((qos) => {
      return Buffer.from([qos]);
    });
    protocol.EMPTY = {
      pingreq: Buffer.from([protocol.codes.pingreq << 4, 0]),
      pingresp: Buffer.from([protocol.codes.pingresp << 4, 0]),
      disconnect: Buffer.from([protocol.codes.disconnect << 4, 0])
    };
  }
});

// node_modules/mqtt-packet/parser.js
var require_parser = __commonJS({
  "node_modules/mqtt-packet/parser.js"(exports2, module2) {
    var bl = require_bl();
    var EventEmitter = require("events");
    var Packet = require_packet();
    var constants = require_constants2();
    var debug = require_src()("mqtt-packet:parser");
    var Parser = class _Parser extends EventEmitter {
      constructor() {
        super();
        this.parser = this.constructor.parser;
      }
      static parser(opt) {
        if (!(this instanceof _Parser))
          return new _Parser().parser(opt);
        this.settings = opt || {};
        this._states = [
          "_parseHeader",
          "_parseLength",
          "_parsePayload",
          "_newPacket"
        ];
        this._resetState();
        return this;
      }
      _resetState() {
        debug("_resetState: resetting packet, error, _list, and _stateCounter");
        this.packet = new Packet();
        this.error = null;
        this._list = bl();
        this._stateCounter = 0;
      }
      parse(buf) {
        if (this.error)
          this._resetState();
        this._list.append(buf);
        debug("parse: current state: %s", this._states[this._stateCounter]);
        while ((this.packet.length !== -1 || this._list.length > 0) && this[this._states[this._stateCounter]]() && !this.error) {
          this._stateCounter++;
          debug("parse: state complete. _stateCounter is now: %d", this._stateCounter);
          debug("parse: packet.length: %d, buffer list length: %d", this.packet.length, this._list.length);
          if (this._stateCounter >= this._states.length)
            this._stateCounter = 0;
        }
        debug("parse: exited while loop. packet: %d, buffer list length: %d", this.packet.length, this._list.length);
        return this._list.length;
      }
      _parseHeader() {
        const zero = this._list.readUInt8(0);
        this.packet.cmd = constants.types[zero >> constants.CMD_SHIFT];
        this.packet.retain = (zero & constants.RETAIN_MASK) !== 0;
        this.packet.qos = zero >> constants.QOS_SHIFT & constants.QOS_MASK;
        this.packet.dup = (zero & constants.DUP_MASK) !== 0;
        debug("_parseHeader: packet: %o", this.packet);
        this._list.consume(1);
        return true;
      }
      _parseLength() {
        const result2 = this._parseVarByteNum(true);
        if (result2) {
          this.packet.length = result2.value;
          this._list.consume(result2.bytes);
        }
        debug("_parseLength %d", result2.value);
        return !!result2;
      }
      _parsePayload() {
        debug("_parsePayload: payload %O", this._list);
        let result2 = false;
        if (this.packet.length === 0 || this._list.length >= this.packet.length) {
          this._pos = 0;
          switch (this.packet.cmd) {
            case "connect":
              this._parseConnect();
              break;
            case "connack":
              this._parseConnack();
              break;
            case "publish":
              this._parsePublish();
              break;
            case "puback":
            case "pubrec":
            case "pubrel":
            case "pubcomp":
              this._parseConfirmation();
              break;
            case "subscribe":
              this._parseSubscribe();
              break;
            case "suback":
              this._parseSuback();
              break;
            case "unsubscribe":
              this._parseUnsubscribe();
              break;
            case "unsuback":
              this._parseUnsuback();
              break;
            case "pingreq":
            case "pingresp":
              break;
            case "disconnect":
              this._parseDisconnect();
              break;
            case "auth":
              this._parseAuth();
              break;
            default:
              this._emitError(new Error("Not supported"));
          }
          result2 = true;
        }
        debug("_parsePayload complete result: %s", result2);
        return result2;
      }
      _parseConnect() {
        debug("_parseConnect");
        let topic;
        let payload;
        let password;
        let username;
        const flags = {};
        const packet = this.packet;
        const protocolId = this._parseString();
        if (protocolId === null)
          return this._emitError(new Error("Cannot parse protocolId"));
        if (protocolId !== "MQTT" && protocolId !== "MQIsdp") {
          return this._emitError(new Error("Invalid protocolId"));
        }
        packet.protocolId = protocolId;
        if (this._pos >= this._list.length)
          return this._emitError(new Error("Packet too short"));
        packet.protocolVersion = this._list.readUInt8(this._pos);
        if (packet.protocolVersion >= 128) {
          packet.bridgeMode = true;
          packet.protocolVersion = packet.protocolVersion - 128;
        }
        if (packet.protocolVersion !== 3 && packet.protocolVersion !== 4 && packet.protocolVersion !== 5) {
          return this._emitError(new Error("Invalid protocol version"));
        }
        this._pos++;
        if (this._pos >= this._list.length) {
          return this._emitError(new Error("Packet too short"));
        }
        flags.username = this._list.readUInt8(this._pos) & constants.USERNAME_MASK;
        flags.password = this._list.readUInt8(this._pos) & constants.PASSWORD_MASK;
        flags.will = this._list.readUInt8(this._pos) & constants.WILL_FLAG_MASK;
        if (flags.will) {
          packet.will = {};
          packet.will.retain = (this._list.readUInt8(this._pos) & constants.WILL_RETAIN_MASK) !== 0;
          packet.will.qos = (this._list.readUInt8(this._pos) & constants.WILL_QOS_MASK) >> constants.WILL_QOS_SHIFT;
        }
        packet.clean = (this._list.readUInt8(this._pos) & constants.CLEAN_SESSION_MASK) !== 0;
        this._pos++;
        packet.keepalive = this._parseNum();
        if (packet.keepalive === -1)
          return this._emitError(new Error("Packet too short"));
        if (packet.protocolVersion === 5) {
          const properties = this._parseProperties();
          if (Object.getOwnPropertyNames(properties).length) {
            packet.properties = properties;
          }
        }
        const clientId = this._parseString();
        if (clientId === null)
          return this._emitError(new Error("Packet too short"));
        packet.clientId = clientId;
        debug("_parseConnect: packet.clientId: %s", packet.clientId);
        if (flags.will) {
          if (packet.protocolVersion === 5) {
            const willProperties = this._parseProperties();
            if (Object.getOwnPropertyNames(willProperties).length) {
              packet.will.properties = willProperties;
            }
          }
          topic = this._parseString();
          if (topic === null)
            return this._emitError(new Error("Cannot parse will topic"));
          packet.will.topic = topic;
          debug("_parseConnect: packet.will.topic: %s", packet.will.topic);
          payload = this._parseBuffer();
          if (payload === null)
            return this._emitError(new Error("Cannot parse will payload"));
          packet.will.payload = payload;
          debug("_parseConnect: packet.will.paylaod: %s", packet.will.payload);
        }
        if (flags.username) {
          username = this._parseString();
          if (username === null)
            return this._emitError(new Error("Cannot parse username"));
          packet.username = username;
          debug("_parseConnect: packet.username: %s", packet.username);
        }
        if (flags.password) {
          password = this._parseBuffer();
          if (password === null)
            return this._emitError(new Error("Cannot parse password"));
          packet.password = password;
        }
        this.settings = packet;
        debug("_parseConnect: complete");
        return packet;
      }
      _parseConnack() {
        debug("_parseConnack");
        const packet = this.packet;
        if (this._list.length < 1)
          return null;
        packet.sessionPresent = !!(this._list.readUInt8(this._pos++) & constants.SESSIONPRESENT_MASK);
        if (this.settings.protocolVersion === 5) {
          if (this._list.length >= 2) {
            packet.reasonCode = this._list.readUInt8(this._pos++);
          } else {
            packet.reasonCode = 0;
          }
        } else {
          if (this._list.length < 2)
            return null;
          packet.returnCode = this._list.readUInt8(this._pos++);
        }
        if (packet.returnCode === -1 || packet.reasonCode === -1)
          return this._emitError(new Error("Cannot parse return code"));
        if (this.settings.protocolVersion === 5) {
          const properties = this._parseProperties();
          if (Object.getOwnPropertyNames(properties).length) {
            packet.properties = properties;
          }
        }
        debug("_parseConnack: complete");
      }
      _parsePublish() {
        debug("_parsePublish");
        const packet = this.packet;
        packet.topic = this._parseString();
        if (packet.topic === null)
          return this._emitError(new Error("Cannot parse topic"));
        if (packet.qos > 0) {
          if (!this._parseMessageId()) {
            return;
          }
        }
        if (this.settings.protocolVersion === 5) {
          const properties = this._parseProperties();
          if (Object.getOwnPropertyNames(properties).length) {
            packet.properties = properties;
          }
        }
        packet.payload = this._list.slice(this._pos, packet.length);
        debug("_parsePublish: payload from buffer list: %o", packet.payload);
      }
      _parseSubscribe() {
        debug("_parseSubscribe");
        const packet = this.packet;
        let topic;
        let options;
        let qos;
        let rh;
        let rap;
        let nl;
        let subscription;
        if (packet.qos !== 1) {
          return this._emitError(new Error("Wrong subscribe header"));
        }
        packet.subscriptions = [];
        if (!this._parseMessageId()) {
          return;
        }
        if (this.settings.protocolVersion === 5) {
          const properties = this._parseProperties();
          if (Object.getOwnPropertyNames(properties).length) {
            packet.properties = properties;
          }
        }
        while (this._pos < packet.length) {
          topic = this._parseString();
          if (topic === null)
            return this._emitError(new Error("Cannot parse topic"));
          if (this._pos >= packet.length)
            return this._emitError(new Error("Malformed Subscribe Payload"));
          options = this._parseByte();
          qos = options & constants.SUBSCRIBE_OPTIONS_QOS_MASK;
          nl = (options >> constants.SUBSCRIBE_OPTIONS_NL_SHIFT & constants.SUBSCRIBE_OPTIONS_NL_MASK) !== 0;
          rap = (options >> constants.SUBSCRIBE_OPTIONS_RAP_SHIFT & constants.SUBSCRIBE_OPTIONS_RAP_MASK) !== 0;
          rh = options >> constants.SUBSCRIBE_OPTIONS_RH_SHIFT & constants.SUBSCRIBE_OPTIONS_RH_MASK;
          subscription = { topic, qos };
          if (this.settings.protocolVersion === 5) {
            subscription.nl = nl;
            subscription.rap = rap;
            subscription.rh = rh;
          } else if (this.settings.bridgeMode) {
            subscription.rh = 0;
            subscription.rap = true;
            subscription.nl = true;
          }
          debug("_parseSubscribe: push subscription `%s` to subscription", subscription);
          packet.subscriptions.push(subscription);
        }
      }
      _parseSuback() {
        debug("_parseSuback");
        const packet = this.packet;
        this.packet.granted = [];
        if (!this._parseMessageId()) {
          return;
        }
        if (this.settings.protocolVersion === 5) {
          const properties = this._parseProperties();
          if (Object.getOwnPropertyNames(properties).length) {
            packet.properties = properties;
          }
        }
        while (this._pos < this.packet.length) {
          this.packet.granted.push(this._list.readUInt8(this._pos++));
        }
      }
      _parseUnsubscribe() {
        debug("_parseUnsubscribe");
        const packet = this.packet;
        packet.unsubscriptions = [];
        if (!this._parseMessageId()) {
          return;
        }
        if (this.settings.protocolVersion === 5) {
          const properties = this._parseProperties();
          if (Object.getOwnPropertyNames(properties).length) {
            packet.properties = properties;
          }
        }
        while (this._pos < packet.length) {
          const topic = this._parseString();
          if (topic === null)
            return this._emitError(new Error("Cannot parse topic"));
          debug("_parseUnsubscribe: push topic `%s` to unsubscriptions", topic);
          packet.unsubscriptions.push(topic);
        }
      }
      _parseUnsuback() {
        debug("_parseUnsuback");
        const packet = this.packet;
        if (!this._parseMessageId())
          return this._emitError(new Error("Cannot parse messageId"));
        if (this.settings.protocolVersion === 5) {
          const properties = this._parseProperties();
          if (Object.getOwnPropertyNames(properties).length) {
            packet.properties = properties;
          }
          packet.granted = [];
          while (this._pos < this.packet.length) {
            this.packet.granted.push(this._list.readUInt8(this._pos++));
          }
        }
      }
      // parse packets like puback, pubrec, pubrel, pubcomp
      _parseConfirmation() {
        debug("_parseConfirmation: packet.cmd: `%s`", this.packet.cmd);
        const packet = this.packet;
        this._parseMessageId();
        if (this.settings.protocolVersion === 5) {
          if (packet.length > 2) {
            packet.reasonCode = this._parseByte();
            debug("_parseConfirmation: packet.reasonCode `%d`", packet.reasonCode);
          } else {
            packet.reasonCode = 0;
          }
          if (packet.length > 3) {
            const properties = this._parseProperties();
            if (Object.getOwnPropertyNames(properties).length) {
              packet.properties = properties;
            }
          }
        }
        return true;
      }
      // parse disconnect packet
      _parseDisconnect() {
        const packet = this.packet;
        debug("_parseDisconnect");
        if (this.settings.protocolVersion === 5) {
          if (this._list.length > 0) {
            packet.reasonCode = this._parseByte();
          } else {
            packet.reasonCode = 0;
          }
          const properties = this._parseProperties();
          if (Object.getOwnPropertyNames(properties).length) {
            packet.properties = properties;
          }
        }
        debug("_parseDisconnect result: true");
        return true;
      }
      // parse auth packet
      _parseAuth() {
        debug("_parseAuth");
        const packet = this.packet;
        if (this.settings.protocolVersion !== 5) {
          return this._emitError(new Error("Not supported auth packet for this version MQTT"));
        }
        packet.reasonCode = this._parseByte();
        const properties = this._parseProperties();
        if (Object.getOwnPropertyNames(properties).length) {
          packet.properties = properties;
        }
        debug("_parseAuth: result: true");
        return true;
      }
      _parseMessageId() {
        const packet = this.packet;
        packet.messageId = this._parseNum();
        if (packet.messageId === null) {
          this._emitError(new Error("Cannot parse messageId"));
          return false;
        }
        debug("_parseMessageId: packet.messageId %d", packet.messageId);
        return true;
      }
      _parseString(maybeBuffer) {
        const length = this._parseNum();
        const end = length + this._pos;
        if (length === -1 || end > this._list.length || end > this.packet.length)
          return null;
        const result2 = this._list.toString("utf8", this._pos, end);
        this._pos += length;
        debug("_parseString: result: %s", result2);
        return result2;
      }
      _parseStringPair() {
        debug("_parseStringPair");
        return {
          name: this._parseString(),
          value: this._parseString()
        };
      }
      _parseBuffer() {
        const length = this._parseNum();
        const end = length + this._pos;
        if (length === -1 || end > this._list.length || end > this.packet.length)
          return null;
        const result2 = this._list.slice(this._pos, end);
        this._pos += length;
        debug("_parseBuffer: result: %o", result2);
        return result2;
      }
      _parseNum() {
        if (this._list.length - this._pos < 2)
          return -1;
        const result2 = this._list.readUInt16BE(this._pos);
        this._pos += 2;
        debug("_parseNum: result: %s", result2);
        return result2;
      }
      _parse4ByteNum() {
        if (this._list.length - this._pos < 4)
          return -1;
        const result2 = this._list.readUInt32BE(this._pos);
        this._pos += 4;
        debug("_parse4ByteNum: result: %s", result2);
        return result2;
      }
      _parseVarByteNum(fullInfoFlag) {
        debug("_parseVarByteNum");
        const maxBytes = 4;
        let bytes = 0;
        let mul = 1;
        let value = 0;
        let result2 = false;
        let current;
        const padding = this._pos ? this._pos : 0;
        while (bytes < maxBytes && padding + bytes < this._list.length) {
          current = this._list.readUInt8(padding + bytes++);
          value += mul * (current & constants.VARBYTEINT_MASK);
          mul *= 128;
          if ((current & constants.VARBYTEINT_FIN_MASK) === 0) {
            result2 = true;
            break;
          }
          if (this._list.length <= bytes) {
            break;
          }
        }
        if (!result2 && bytes === maxBytes && this._list.length >= bytes) {
          this._emitError(new Error("Invalid variable byte integer"));
        }
        if (padding) {
          this._pos += bytes;
        }
        result2 = result2 ? fullInfoFlag ? {
          bytes,
          value
        } : value : false;
        debug("_parseVarByteNum: result: %o", result2);
        return result2;
      }
      _parseByte() {
        let result2;
        if (this._pos < this._list.length) {
          result2 = this._list.readUInt8(this._pos);
          this._pos++;
        }
        debug("_parseByte: result: %o", result2);
        return result2;
      }
      _parseByType(type) {
        debug("_parseByType: type: %s", type);
        switch (type) {
          case "byte": {
            return this._parseByte() !== 0;
          }
          case "int8": {
            return this._parseByte();
          }
          case "int16": {
            return this._parseNum();
          }
          case "int32": {
            return this._parse4ByteNum();
          }
          case "var": {
            return this._parseVarByteNum();
          }
          case "string": {
            return this._parseString();
          }
          case "pair": {
            return this._parseStringPair();
          }
          case "binary": {
            return this._parseBuffer();
          }
        }
      }
      _parseProperties() {
        debug("_parseProperties");
        const length = this._parseVarByteNum();
        const start = this._pos;
        const end = start + length;
        const result2 = {};
        while (this._pos < end) {
          const type = this._parseByte();
          if (!type) {
            this._emitError(new Error("Cannot parse property code type"));
            return false;
          }
          const name = constants.propertiesCodes[type];
          if (!name) {
            this._emitError(new Error("Unknown property"));
            return false;
          }
          if (name === "userProperties") {
            if (!result2[name]) {
              result2[name] = /* @__PURE__ */ Object.create(null);
            }
            const currentUserProperty = this._parseByType(constants.propertiesTypes[name]);
            if (result2[name][currentUserProperty.name]) {
              if (Array.isArray(result2[name][currentUserProperty.name])) {
                result2[name][currentUserProperty.name].push(currentUserProperty.value);
              } else {
                const currentValue = result2[name][currentUserProperty.name];
                result2[name][currentUserProperty.name] = [currentValue];
                result2[name][currentUserProperty.name].push(currentUserProperty.value);
              }
            } else {
              result2[name][currentUserProperty.name] = currentUserProperty.value;
            }
            continue;
          }
          if (result2[name]) {
            if (Array.isArray(result2[name])) {
              result2[name].push(this._parseByType(constants.propertiesTypes[name]));
            } else {
              result2[name] = [result2[name]];
              result2[name].push(this._parseByType(constants.propertiesTypes[name]));
            }
          } else {
            result2[name] = this._parseByType(constants.propertiesTypes[name]);
          }
        }
        return result2;
      }
      _newPacket() {
        debug("_newPacket");
        if (this.packet) {
          this._list.consume(this.packet.length);
          debug("_newPacket: parser emit packet: packet.cmd: %s, packet.payload: %s, packet.length: %d", this.packet.cmd, this.packet.payload, this.packet.length);
          this.emit("packet", this.packet);
        }
        debug("_newPacket: new packet");
        this.packet = new Packet();
        this._pos = 0;
        return true;
      }
      _emitError(err) {
        debug("_emitError");
        this.error = err;
        this.emit("error", err);
      }
    };
    module2.exports = Parser;
  }
});

// node_modules/mqtt-packet/numbers.js
var require_numbers = __commonJS({
  "node_modules/mqtt-packet/numbers.js"(exports2, module2) {
    var max = 65536;
    var cache = {};
    var SubOk = Buffer.isBuffer(Buffer.from([1, 2]).subarray(0, 1));
    function generateBuffer(i) {
      const buffer = Buffer.allocUnsafe(2);
      buffer.writeUInt8(i >> 8, 0);
      buffer.writeUInt8(i & 255, 0 + 1);
      return buffer;
    }
    function generateCache() {
      for (let i = 0; i < max; i++) {
        cache[i] = generateBuffer(i);
      }
    }
    function genBufVariableByteInt(num) {
      const maxLength = 4;
      let digit = 0;
      let pos = 0;
      const buffer = Buffer.allocUnsafe(maxLength);
      do {
        digit = num % 128 | 0;
        num = num / 128 | 0;
        if (num > 0)
          digit = digit | 128;
        buffer.writeUInt8(digit, pos++);
      } while (num > 0 && pos < maxLength);
      if (num > 0) {
        pos = 0;
      }
      return SubOk ? buffer.subarray(0, pos) : buffer.slice(0, pos);
    }
    function generate4ByteBuffer(num) {
      const buffer = Buffer.allocUnsafe(4);
      buffer.writeUInt32BE(num, 0);
      return buffer;
    }
    module2.exports = {
      cache,
      generateCache,
      generateNumber: generateBuffer,
      genBufVariableByteInt,
      generate4ByteBuffer
    };
  }
});

// node_modules/process-nextick-args/index.js
var require_process_nextick_args = __commonJS({
  "node_modules/process-nextick-args/index.js"(exports2, module2) {
    "use strict";
    if (typeof process === "undefined" || !process.version || process.version.indexOf("v0.") === 0 || process.version.indexOf("v1.") === 0 && process.version.indexOf("v1.8.") !== 0) {
      module2.exports = { nextTick };
    } else {
      module2.exports = process;
    }
    function nextTick(fn, arg1, arg2, arg3) {
      if (typeof fn !== "function") {
        throw new TypeError('"callback" argument must be a function');
      }
      var len = arguments.length;
      var args, i;
      switch (len) {
        case 0:
        case 1:
          return process.nextTick(fn);
        case 2:
          return process.nextTick(function afterTickOne() {
            fn.call(null, arg1);
          });
        case 3:
          return process.nextTick(function afterTickTwo() {
            fn.call(null, arg1, arg2);
          });
        case 4:
          return process.nextTick(function afterTickThree() {
            fn.call(null, arg1, arg2, arg3);
          });
        default:
          args = new Array(len - 1);
          i = 0;
          while (i < args.length) {
            args[i++] = arguments[i];
          }
          return process.nextTick(function afterTick() {
            fn.apply(null, args);
          });
      }
    }
  }
});

// node_modules/mqtt-packet/writeToStream.js
var require_writeToStream = __commonJS({
  "node_modules/mqtt-packet/writeToStream.js"(exports2, module2) {
    var protocol = require_constants2();
    var empty = Buffer.allocUnsafe(0);
    var zeroBuf = Buffer.from([0]);
    var numbers = require_numbers();
    var nextTick = require_process_nextick_args().nextTick;
    var debug = require_src()("mqtt-packet:writeToStream");
    var numCache = numbers.cache;
    var generateNumber = numbers.generateNumber;
    var generateCache = numbers.generateCache;
    var genBufVariableByteInt = numbers.genBufVariableByteInt;
    var generate4ByteBuffer = numbers.generate4ByteBuffer;
    var writeNumber = writeNumberCached;
    var toGenerate = true;
    function generate(packet, stream, opts) {
      debug("generate called");
      if (stream.cork) {
        stream.cork();
        nextTick(uncork, stream);
      }
      if (toGenerate) {
        toGenerate = false;
        generateCache();
      }
      debug("generate: packet.cmd: %s", packet.cmd);
      switch (packet.cmd) {
        case "connect":
          return connect(packet, stream, opts);
        case "connack":
          return connack(packet, stream, opts);
        case "publish":
          return publish(packet, stream, opts);
        case "puback":
        case "pubrec":
        case "pubrel":
        case "pubcomp":
          return confirmation(packet, stream, opts);
        case "subscribe":
          return subscribe(packet, stream, opts);
        case "suback":
          return suback(packet, stream, opts);
        case "unsubscribe":
          return unsubscribe(packet, stream, opts);
        case "unsuback":
          return unsuback(packet, stream, opts);
        case "pingreq":
        case "pingresp":
          return emptyPacket(packet, stream, opts);
        case "disconnect":
          return disconnect(packet, stream, opts);
        case "auth":
          return auth(packet, stream, opts);
        default:
          stream.emit("error", new Error("Unknown command"));
          return false;
      }
    }
    Object.defineProperty(generate, "cacheNumbers", {
      get() {
        return writeNumber === writeNumberCached;
      },
      set(value) {
        if (value) {
          if (!numCache || Object.keys(numCache).length === 0)
            toGenerate = true;
          writeNumber = writeNumberCached;
        } else {
          toGenerate = false;
          writeNumber = writeNumberGenerated;
        }
      }
    });
    function uncork(stream) {
      stream.uncork();
    }
    function connect(packet, stream, opts) {
      const settings = packet || {};
      const protocolId = settings.protocolId || "MQTT";
      let protocolVersion = settings.protocolVersion || 4;
      const will = settings.will;
      let clean = settings.clean;
      const keepalive = settings.keepalive || 0;
      const clientId = settings.clientId || "";
      const username = settings.username;
      const password = settings.password;
      const properties = settings.properties;
      if (clean === void 0)
        clean = true;
      let length = 0;
      if (!protocolId || typeof protocolId !== "string" && !Buffer.isBuffer(protocolId)) {
        stream.emit("error", new Error("Invalid protocolId"));
        return false;
      } else
        length += protocolId.length + 2;
      if (protocolVersion !== 3 && protocolVersion !== 4 && protocolVersion !== 5) {
        stream.emit("error", new Error("Invalid protocol version"));
        return false;
      } else
        length += 1;
      if ((typeof clientId === "string" || Buffer.isBuffer(clientId)) && (clientId || protocolVersion >= 4) && (clientId || clean)) {
        length += Buffer.byteLength(clientId) + 2;
      } else {
        if (protocolVersion < 4) {
          stream.emit("error", new Error("clientId must be supplied before 3.1.1"));
          return false;
        }
        if (clean * 1 === 0) {
          stream.emit("error", new Error("clientId must be given if cleanSession set to 0"));
          return false;
        }
      }
      if (typeof keepalive !== "number" || keepalive < 0 || keepalive > 65535 || keepalive % 1 !== 0) {
        stream.emit("error", new Error("Invalid keepalive"));
        return false;
      } else
        length += 2;
      length += 1;
      if (protocolVersion === 5) {
        var propertiesData = getProperties(stream, properties);
        if (!propertiesData) {
          return false;
        }
        length += propertiesData.length;
      }
      if (will) {
        if (typeof will !== "object") {
          stream.emit("error", new Error("Invalid will"));
          return false;
        }
        if (!will.topic || typeof will.topic !== "string") {
          stream.emit("error", new Error("Invalid will topic"));
          return false;
        } else {
          length += Buffer.byteLength(will.topic) + 2;
        }
        length += 2;
        if (will.payload) {
          if (will.payload.length >= 0) {
            if (typeof will.payload === "string") {
              length += Buffer.byteLength(will.payload);
            } else {
              length += will.payload.length;
            }
          } else {
            stream.emit("error", new Error("Invalid will payload"));
            return false;
          }
        }
        var willProperties = {};
        if (protocolVersion === 5) {
          willProperties = getProperties(stream, will.properties);
          if (!willProperties) {
            return false;
          }
          length += willProperties.length;
        }
      }
      let providedUsername = false;
      if (username != null) {
        if (isStringOrBuffer(username)) {
          providedUsername = true;
          length += Buffer.byteLength(username) + 2;
        } else {
          stream.emit("error", new Error("Invalid username"));
          return false;
        }
      }
      if (password != null) {
        if (!providedUsername) {
          stream.emit("error", new Error("Username is required to use password"));
          return false;
        }
        if (isStringOrBuffer(password)) {
          length += byteLength(password) + 2;
        } else {
          stream.emit("error", new Error("Invalid password"));
          return false;
        }
      }
      stream.write(protocol.CONNECT_HEADER);
      writeVarByteInt(stream, length);
      writeStringOrBuffer(stream, protocolId);
      if (settings.bridgeMode) {
        protocolVersion += 128;
      }
      stream.write(
        protocolVersion === 131 ? protocol.VERSION131 : protocolVersion === 132 ? protocol.VERSION132 : protocolVersion === 4 ? protocol.VERSION4 : protocolVersion === 5 ? protocol.VERSION5 : protocol.VERSION3
      );
      let flags = 0;
      flags |= username != null ? protocol.USERNAME_MASK : 0;
      flags |= password != null ? protocol.PASSWORD_MASK : 0;
      flags |= will && will.retain ? protocol.WILL_RETAIN_MASK : 0;
      flags |= will && will.qos ? will.qos << protocol.WILL_QOS_SHIFT : 0;
      flags |= will ? protocol.WILL_FLAG_MASK : 0;
      flags |= clean ? protocol.CLEAN_SESSION_MASK : 0;
      stream.write(Buffer.from([flags]));
      writeNumber(stream, keepalive);
      if (protocolVersion === 5) {
        propertiesData.write();
      }
      writeStringOrBuffer(stream, clientId);
      if (will) {
        if (protocolVersion === 5) {
          willProperties.write();
        }
        writeString(stream, will.topic);
        writeStringOrBuffer(stream, will.payload);
      }
      if (username != null) {
        writeStringOrBuffer(stream, username);
      }
      if (password != null) {
        writeStringOrBuffer(stream, password);
      }
      return true;
    }
    function connack(packet, stream, opts) {
      const version = opts ? opts.protocolVersion : 4;
      const settings = packet || {};
      const rc = version === 5 ? settings.reasonCode : settings.returnCode;
      const properties = settings.properties;
      let length = 2;
      if (typeof rc !== "number") {
        stream.emit("error", new Error("Invalid return code"));
        return false;
      }
      let propertiesData = null;
      if (version === 5) {
        propertiesData = getProperties(stream, properties);
        if (!propertiesData) {
          return false;
        }
        length += propertiesData.length;
      }
      stream.write(protocol.CONNACK_HEADER);
      writeVarByteInt(stream, length);
      stream.write(settings.sessionPresent ? protocol.SESSIONPRESENT_HEADER : zeroBuf);
      stream.write(Buffer.from([rc]));
      if (propertiesData != null) {
        propertiesData.write();
      }
      return true;
    }
    function publish(packet, stream, opts) {
      debug("publish: packet: %o", packet);
      const version = opts ? opts.protocolVersion : 4;
      const settings = packet || {};
      const qos = settings.qos || 0;
      const retain = settings.retain ? protocol.RETAIN_MASK : 0;
      const topic = settings.topic;
      const payload = settings.payload || empty;
      const id = settings.messageId;
      const properties = settings.properties;
      let length = 0;
      if (typeof topic === "string")
        length += Buffer.byteLength(topic) + 2;
      else if (Buffer.isBuffer(topic))
        length += topic.length + 2;
      else {
        stream.emit("error", new Error("Invalid topic"));
        return false;
      }
      if (!Buffer.isBuffer(payload))
        length += Buffer.byteLength(payload);
      else
        length += payload.length;
      if (qos && typeof id !== "number") {
        stream.emit("error", new Error("Invalid messageId"));
        return false;
      } else if (qos)
        length += 2;
      let propertiesData = null;
      if (version === 5) {
        propertiesData = getProperties(stream, properties);
        if (!propertiesData) {
          return false;
        }
        length += propertiesData.length;
      }
      stream.write(protocol.PUBLISH_HEADER[qos][settings.dup ? 1 : 0][retain ? 1 : 0]);
      writeVarByteInt(stream, length);
      writeNumber(stream, byteLength(topic));
      stream.write(topic);
      if (qos > 0)
        writeNumber(stream, id);
      if (propertiesData != null) {
        propertiesData.write();
      }
      debug("publish: payload: %o", payload);
      return stream.write(payload);
    }
    function confirmation(packet, stream, opts) {
      const version = opts ? opts.protocolVersion : 4;
      const settings = packet || {};
      const type = settings.cmd || "puback";
      const id = settings.messageId;
      const dup = settings.dup && type === "pubrel" ? protocol.DUP_MASK : 0;
      let qos = 0;
      const reasonCode = settings.reasonCode;
      const properties = settings.properties;
      let length = version === 5 ? 3 : 2;
      if (type === "pubrel")
        qos = 1;
      if (typeof id !== "number") {
        stream.emit("error", new Error("Invalid messageId"));
        return false;
      }
      let propertiesData = null;
      if (version === 5) {
        if (typeof properties === "object") {
          propertiesData = getPropertiesByMaximumPacketSize(stream, properties, opts, length);
          if (!propertiesData) {
            return false;
          }
          length += propertiesData.length;
        }
      }
      stream.write(protocol.ACKS[type][qos][dup][0]);
      writeVarByteInt(stream, length);
      writeNumber(stream, id);
      if (version === 5) {
        stream.write(Buffer.from([reasonCode]));
      }
      if (propertiesData !== null) {
        propertiesData.write();
      }
      return true;
    }
    function subscribe(packet, stream, opts) {
      debug("subscribe: packet: ");
      const version = opts ? opts.protocolVersion : 4;
      const settings = packet || {};
      const dup = settings.dup ? protocol.DUP_MASK : 0;
      const id = settings.messageId;
      const subs = settings.subscriptions;
      const properties = settings.properties;
      let length = 0;
      if (typeof id !== "number") {
        stream.emit("error", new Error("Invalid messageId"));
        return false;
      } else
        length += 2;
      let propertiesData = null;
      if (version === 5) {
        propertiesData = getProperties(stream, properties);
        if (!propertiesData) {
          return false;
        }
        length += propertiesData.length;
      }
      if (typeof subs === "object" && subs.length) {
        for (let i = 0; i < subs.length; i += 1) {
          const itopic = subs[i].topic;
          const iqos = subs[i].qos;
          if (typeof itopic !== "string") {
            stream.emit("error", new Error("Invalid subscriptions - invalid topic"));
            return false;
          }
          if (typeof iqos !== "number") {
            stream.emit("error", new Error("Invalid subscriptions - invalid qos"));
            return false;
          }
          if (version === 5) {
            const nl = subs[i].nl || false;
            if (typeof nl !== "boolean") {
              stream.emit("error", new Error("Invalid subscriptions - invalid No Local"));
              return false;
            }
            const rap = subs[i].rap || false;
            if (typeof rap !== "boolean") {
              stream.emit("error", new Error("Invalid subscriptions - invalid Retain as Published"));
              return false;
            }
            const rh = subs[i].rh || 0;
            if (typeof rh !== "number" || rh > 2) {
              stream.emit("error", new Error("Invalid subscriptions - invalid Retain Handling"));
              return false;
            }
          }
          length += Buffer.byteLength(itopic) + 2 + 1;
        }
      } else {
        stream.emit("error", new Error("Invalid subscriptions"));
        return false;
      }
      debug("subscribe: writing to stream: %o", protocol.SUBSCRIBE_HEADER);
      stream.write(protocol.SUBSCRIBE_HEADER[1][dup ? 1 : 0][0]);
      writeVarByteInt(stream, length);
      writeNumber(stream, id);
      if (propertiesData !== null) {
        propertiesData.write();
      }
      let result2 = true;
      for (const sub of subs) {
        const jtopic = sub.topic;
        const jqos = sub.qos;
        const jnl = +sub.nl;
        const jrap = +sub.rap;
        const jrh = sub.rh;
        let joptions;
        writeString(stream, jtopic);
        joptions = protocol.SUBSCRIBE_OPTIONS_QOS[jqos];
        if (version === 5) {
          joptions |= jnl ? protocol.SUBSCRIBE_OPTIONS_NL : 0;
          joptions |= jrap ? protocol.SUBSCRIBE_OPTIONS_RAP : 0;
          joptions |= jrh ? protocol.SUBSCRIBE_OPTIONS_RH[jrh] : 0;
        }
        result2 = stream.write(Buffer.from([joptions]));
      }
      return result2;
    }
    function suback(packet, stream, opts) {
      const version = opts ? opts.protocolVersion : 4;
      const settings = packet || {};
      const id = settings.messageId;
      const granted = settings.granted;
      const properties = settings.properties;
      let length = 0;
      if (typeof id !== "number") {
        stream.emit("error", new Error("Invalid messageId"));
        return false;
      } else
        length += 2;
      if (typeof granted === "object" && granted.length) {
        for (let i = 0; i < granted.length; i += 1) {
          if (typeof granted[i] !== "number") {
            stream.emit("error", new Error("Invalid qos vector"));
            return false;
          }
          length += 1;
        }
      } else {
        stream.emit("error", new Error("Invalid qos vector"));
        return false;
      }
      let propertiesData = null;
      if (version === 5) {
        propertiesData = getPropertiesByMaximumPacketSize(stream, properties, opts, length);
        if (!propertiesData) {
          return false;
        }
        length += propertiesData.length;
      }
      stream.write(protocol.SUBACK_HEADER);
      writeVarByteInt(stream, length);
      writeNumber(stream, id);
      if (propertiesData !== null) {
        propertiesData.write();
      }
      return stream.write(Buffer.from(granted));
    }
    function unsubscribe(packet, stream, opts) {
      const version = opts ? opts.protocolVersion : 4;
      const settings = packet || {};
      const id = settings.messageId;
      const dup = settings.dup ? protocol.DUP_MASK : 0;
      const unsubs = settings.unsubscriptions;
      const properties = settings.properties;
      let length = 0;
      if (typeof id !== "number") {
        stream.emit("error", new Error("Invalid messageId"));
        return false;
      } else {
        length += 2;
      }
      if (typeof unsubs === "object" && unsubs.length) {
        for (let i = 0; i < unsubs.length; i += 1) {
          if (typeof unsubs[i] !== "string") {
            stream.emit("error", new Error("Invalid unsubscriptions"));
            return false;
          }
          length += Buffer.byteLength(unsubs[i]) + 2;
        }
      } else {
        stream.emit("error", new Error("Invalid unsubscriptions"));
        return false;
      }
      let propertiesData = null;
      if (version === 5) {
        propertiesData = getProperties(stream, properties);
        if (!propertiesData) {
          return false;
        }
        length += propertiesData.length;
      }
      stream.write(protocol.UNSUBSCRIBE_HEADER[1][dup ? 1 : 0][0]);
      writeVarByteInt(stream, length);
      writeNumber(stream, id);
      if (propertiesData !== null) {
        propertiesData.write();
      }
      let result2 = true;
      for (let j = 0; j < unsubs.length; j++) {
        result2 = writeString(stream, unsubs[j]);
      }
      return result2;
    }
    function unsuback(packet, stream, opts) {
      const version = opts ? opts.protocolVersion : 4;
      const settings = packet || {};
      const id = settings.messageId;
      const dup = settings.dup ? protocol.DUP_MASK : 0;
      const granted = settings.granted;
      const properties = settings.properties;
      const type = settings.cmd;
      const qos = 0;
      let length = 2;
      if (typeof id !== "number") {
        stream.emit("error", new Error("Invalid messageId"));
        return false;
      }
      if (version === 5) {
        if (typeof granted === "object" && granted.length) {
          for (let i = 0; i < granted.length; i += 1) {
            if (typeof granted[i] !== "number") {
              stream.emit("error", new Error("Invalid qos vector"));
              return false;
            }
            length += 1;
          }
        } else {
          stream.emit("error", new Error("Invalid qos vector"));
          return false;
        }
      }
      let propertiesData = null;
      if (version === 5) {
        propertiesData = getPropertiesByMaximumPacketSize(stream, properties, opts, length);
        if (!propertiesData) {
          return false;
        }
        length += propertiesData.length;
      }
      stream.write(protocol.ACKS[type][qos][dup][0]);
      writeVarByteInt(stream, length);
      writeNumber(stream, id);
      if (propertiesData !== null) {
        propertiesData.write();
      }
      if (version === 5) {
        stream.write(Buffer.from(granted));
      }
      return true;
    }
    function emptyPacket(packet, stream, opts) {
      return stream.write(protocol.EMPTY[packet.cmd]);
    }
    function disconnect(packet, stream, opts) {
      const version = opts ? opts.protocolVersion : 4;
      const settings = packet || {};
      const reasonCode = settings.reasonCode;
      const properties = settings.properties;
      let length = version === 5 ? 1 : 0;
      let propertiesData = null;
      if (version === 5) {
        propertiesData = getPropertiesByMaximumPacketSize(stream, properties, opts, length);
        if (!propertiesData) {
          return false;
        }
        length += propertiesData.length;
      }
      stream.write(Buffer.from([protocol.codes.disconnect << 4]));
      writeVarByteInt(stream, length);
      if (version === 5) {
        stream.write(Buffer.from([reasonCode]));
      }
      if (propertiesData !== null) {
        propertiesData.write();
      }
      return true;
    }
    function auth(packet, stream, opts) {
      const version = opts ? opts.protocolVersion : 4;
      const settings = packet || {};
      const reasonCode = settings.reasonCode;
      const properties = settings.properties;
      let length = version === 5 ? 1 : 0;
      if (version !== 5)
        stream.emit("error", new Error("Invalid mqtt version for auth packet"));
      const propertiesData = getPropertiesByMaximumPacketSize(stream, properties, opts, length);
      if (!propertiesData) {
        return false;
      }
      length += propertiesData.length;
      stream.write(Buffer.from([protocol.codes.auth << 4]));
      writeVarByteInt(stream, length);
      stream.write(Buffer.from([reasonCode]));
      if (propertiesData !== null) {
        propertiesData.write();
      }
      return true;
    }
    var varByteIntCache = {};
    function writeVarByteInt(stream, num) {
      if (num > protocol.VARBYTEINT_MAX) {
        stream.emit("error", new Error(`Invalid variable byte integer: ${num}`));
        return false;
      }
      let buffer = varByteIntCache[num];
      if (!buffer) {
        buffer = genBufVariableByteInt(num);
        if (num < 16384)
          varByteIntCache[num] = buffer;
      }
      debug("writeVarByteInt: writing to stream: %o", buffer);
      return stream.write(buffer);
    }
    function writeString(stream, string) {
      const strlen = Buffer.byteLength(string);
      writeNumber(stream, strlen);
      debug("writeString: %s", string);
      return stream.write(string, "utf8");
    }
    function writeStringPair(stream, name, value) {
      writeString(stream, name);
      writeString(stream, value);
    }
    function writeNumberCached(stream, number) {
      debug("writeNumberCached: number: %d", number);
      debug("writeNumberCached: %o", numCache[number]);
      return stream.write(numCache[number]);
    }
    function writeNumberGenerated(stream, number) {
      const generatedNumber = generateNumber(number);
      debug("writeNumberGenerated: %o", generatedNumber);
      return stream.write(generatedNumber);
    }
    function write4ByteNumber(stream, number) {
      const generated4ByteBuffer = generate4ByteBuffer(number);
      debug("write4ByteNumber: %o", generated4ByteBuffer);
      return stream.write(generated4ByteBuffer);
    }
    function writeStringOrBuffer(stream, toWrite) {
      if (typeof toWrite === "string") {
        writeString(stream, toWrite);
      } else if (toWrite) {
        writeNumber(stream, toWrite.length);
        stream.write(toWrite);
      } else
        writeNumber(stream, 0);
    }
    function getProperties(stream, properties) {
      if (typeof properties !== "object" || properties.length != null) {
        return {
          length: 1,
          write() {
            writeProperties(stream, {}, 0);
          }
        };
      }
      let propertiesLength = 0;
      function getLengthProperty(name, value) {
        const type = protocol.propertiesTypes[name];
        let length = 0;
        switch (type) {
          case "byte": {
            if (typeof value !== "boolean") {
              stream.emit("error", new Error(`Invalid ${name}: ${value}`));
              return false;
            }
            length += 1 + 1;
            break;
          }
          case "int8": {
            if (typeof value !== "number" || value < 0 || value > 255) {
              stream.emit("error", new Error(`Invalid ${name}: ${value}`));
              return false;
            }
            length += 1 + 1;
            break;
          }
          case "binary": {
            if (value && value === null) {
              stream.emit("error", new Error(`Invalid ${name}: ${value}`));
              return false;
            }
            length += 1 + Buffer.byteLength(value) + 2;
            break;
          }
          case "int16": {
            if (typeof value !== "number" || value < 0 || value > 65535) {
              stream.emit("error", new Error(`Invalid ${name}: ${value}`));
              return false;
            }
            length += 1 + 2;
            break;
          }
          case "int32": {
            if (typeof value !== "number" || value < 0 || value > 4294967295) {
              stream.emit("error", new Error(`Invalid ${name}: ${value}`));
              return false;
            }
            length += 1 + 4;
            break;
          }
          case "var": {
            if (typeof value !== "number" || value < 0 || value > 268435455) {
              stream.emit("error", new Error(`Invalid ${name}: ${value}`));
              return false;
            }
            length += 1 + Buffer.byteLength(genBufVariableByteInt(value));
            break;
          }
          case "string": {
            if (typeof value !== "string") {
              stream.emit("error", new Error(`Invalid ${name}: ${value}`));
              return false;
            }
            length += 1 + 2 + Buffer.byteLength(value.toString());
            break;
          }
          case "pair": {
            if (typeof value !== "object") {
              stream.emit("error", new Error(`Invalid ${name}: ${value}`));
              return false;
            }
            length += Object.getOwnPropertyNames(value).reduce((result2, name2) => {
              const currentValue = value[name2];
              if (Array.isArray(currentValue)) {
                result2 += currentValue.reduce((currentLength, value2) => {
                  currentLength += 1 + 2 + Buffer.byteLength(name2.toString()) + 2 + Buffer.byteLength(value2.toString());
                  return currentLength;
                }, 0);
              } else {
                result2 += 1 + 2 + Buffer.byteLength(name2.toString()) + 2 + Buffer.byteLength(value[name2].toString());
              }
              return result2;
            }, 0);
            break;
          }
          default: {
            stream.emit("error", new Error(`Invalid property ${name}: ${value}`));
            return false;
          }
        }
        return length;
      }
      if (properties) {
        for (const propName in properties) {
          let propLength = 0;
          let propValueLength = 0;
          const propValue = properties[propName];
          if (Array.isArray(propValue)) {
            for (let valueIndex = 0; valueIndex < propValue.length; valueIndex++) {
              propValueLength = getLengthProperty(propName, propValue[valueIndex]);
              if (!propValueLength) {
                return false;
              }
              propLength += propValueLength;
            }
          } else {
            propValueLength = getLengthProperty(propName, propValue);
            if (!propValueLength) {
              return false;
            }
            propLength = propValueLength;
          }
          if (!propLength)
            return false;
          propertiesLength += propLength;
        }
      }
      const propertiesLengthLength = Buffer.byteLength(genBufVariableByteInt(propertiesLength));
      return {
        length: propertiesLengthLength + propertiesLength,
        write() {
          writeProperties(stream, properties, propertiesLength);
        }
      };
    }
    function getPropertiesByMaximumPacketSize(stream, properties, opts, length) {
      const mayEmptyProps = ["reasonString", "userProperties"];
      const maximumPacketSize = opts && opts.properties && opts.properties.maximumPacketSize ? opts.properties.maximumPacketSize : 0;
      let propertiesData = getProperties(stream, properties);
      if (maximumPacketSize) {
        while (length + propertiesData.length > maximumPacketSize) {
          const currentMayEmptyProp = mayEmptyProps.shift();
          if (currentMayEmptyProp && properties[currentMayEmptyProp]) {
            delete properties[currentMayEmptyProp];
            propertiesData = getProperties(stream, properties);
          } else {
            return false;
          }
        }
      }
      return propertiesData;
    }
    function writeProperty(stream, propName, value) {
      const type = protocol.propertiesTypes[propName];
      switch (type) {
        case "byte": {
          stream.write(Buffer.from([protocol.properties[propName]]));
          stream.write(Buffer.from([+value]));
          break;
        }
        case "int8": {
          stream.write(Buffer.from([protocol.properties[propName]]));
          stream.write(Buffer.from([value]));
          break;
        }
        case "binary": {
          stream.write(Buffer.from([protocol.properties[propName]]));
          writeStringOrBuffer(stream, value);
          break;
        }
        case "int16": {
          stream.write(Buffer.from([protocol.properties[propName]]));
          writeNumber(stream, value);
          break;
        }
        case "int32": {
          stream.write(Buffer.from([protocol.properties[propName]]));
          write4ByteNumber(stream, value);
          break;
        }
        case "var": {
          stream.write(Buffer.from([protocol.properties[propName]]));
          writeVarByteInt(stream, value);
          break;
        }
        case "string": {
          stream.write(Buffer.from([protocol.properties[propName]]));
          writeString(stream, value);
          break;
        }
        case "pair": {
          Object.getOwnPropertyNames(value).forEach((name) => {
            const currentValue = value[name];
            if (Array.isArray(currentValue)) {
              currentValue.forEach((value2) => {
                stream.write(Buffer.from([protocol.properties[propName]]));
                writeStringPair(stream, name.toString(), value2.toString());
              });
            } else {
              stream.write(Buffer.from([protocol.properties[propName]]));
              writeStringPair(stream, name.toString(), currentValue.toString());
            }
          });
          break;
        }
        default: {
          stream.emit("error", new Error(`Invalid property ${propName} value: ${value}`));
          return false;
        }
      }
    }
    function writeProperties(stream, properties, propertiesLength) {
      writeVarByteInt(stream, propertiesLength);
      for (const propName in properties) {
        if (Object.prototype.hasOwnProperty.call(properties, propName) && properties[propName] !== null) {
          const value = properties[propName];
          if (Array.isArray(value)) {
            for (let valueIndex = 0; valueIndex < value.length; valueIndex++) {
              writeProperty(stream, propName, value[valueIndex]);
            }
          } else {
            writeProperty(stream, propName, value);
          }
        }
      }
    }
    function byteLength(bufOrString) {
      if (!bufOrString)
        return 0;
      else if (bufOrString instanceof Buffer)
        return bufOrString.length;
      else
        return Buffer.byteLength(bufOrString);
    }
    function isStringOrBuffer(field) {
      return typeof field === "string" || field instanceof Buffer;
    }
    module2.exports = generate;
  }
});

// node_modules/mqtt-packet/generate.js
var require_generate = __commonJS({
  "node_modules/mqtt-packet/generate.js"(exports2, module2) {
    var writeToStream = require_writeToStream();
    var EventEmitter = require("events");
    function generate(packet, opts) {
      const stream = new Accumulator();
      writeToStream(packet, stream, opts);
      return stream.concat();
    }
    var Accumulator = class extends EventEmitter {
      constructor() {
        super();
        this._array = new Array(20);
        this._i = 0;
      }
      write(chunk) {
        this._array[this._i++] = chunk;
        return true;
      }
      concat() {
        let length = 0;
        const lengths = new Array(this._array.length);
        const list = this._array;
        let pos = 0;
        let i;
        for (i = 0; i < list.length && list[i] !== void 0; i++) {
          if (typeof list[i] !== "string")
            lengths[i] = list[i].length;
          else
            lengths[i] = Buffer.byteLength(list[i]);
          length += lengths[i];
        }
        const result2 = Buffer.allocUnsafe(length);
        for (i = 0; i < list.length && list[i] !== void 0; i++) {
          if (typeof list[i] !== "string") {
            list[i].copy(result2, pos);
            pos += lengths[i];
          } else {
            result2.write(list[i], pos);
            pos += lengths[i];
          }
        }
        return result2;
      }
    };
    module2.exports = generate;
  }
});

// node_modules/mqtt-packet/mqtt.js
var require_mqtt = __commonJS({
  "node_modules/mqtt-packet/mqtt.js"(exports2) {
    exports2.parser = require_parser().parser;
    exports2.generate = require_generate();
    exports2.writeToStream = require_writeToStream();
  }
});

// node_modules/mqtt/lib/default-message-id-provider.js
var require_default_message_id_provider = __commonJS({
  "node_modules/mqtt/lib/default-message-id-provider.js"(exports2, module2) {
    "use strict";
    function DefaultMessageIdProvider() {
      if (!(this instanceof DefaultMessageIdProvider)) {
        return new DefaultMessageIdProvider();
      }
      this.nextId = Math.max(1, Math.floor(Math.random() * 65535));
    }
    DefaultMessageIdProvider.prototype.allocate = function() {
      const id = this.nextId++;
      if (this.nextId === 65536) {
        this.nextId = 1;
      }
      return id;
    };
    DefaultMessageIdProvider.prototype.getLastAllocated = function() {
      return this.nextId === 1 ? 65535 : this.nextId - 1;
    };
    DefaultMessageIdProvider.prototype.register = function(messageId) {
      return true;
    };
    DefaultMessageIdProvider.prototype.deallocate = function(messageId) {
    };
    DefaultMessageIdProvider.prototype.clear = function() {
    };
    module2.exports = DefaultMessageIdProvider;
  }
});

// node_modules/reinterval/index.js
var require_reinterval = __commonJS({
  "node_modules/reinterval/index.js"(exports2, module2) {
    "use strict";
    function ReInterval(callback, interval, args) {
      var self2 = this;
      this._callback = callback;
      this._args = args;
      this._interval = setInterval(callback, interval, this._args);
      this.reschedule = function(interval2) {
        if (!interval2)
          interval2 = self2._interval;
        if (self2._interval)
          clearInterval(self2._interval);
        self2._interval = setInterval(self2._callback, interval2, self2._args);
      };
      this.clear = function() {
        if (self2._interval) {
          clearInterval(self2._interval);
          self2._interval = void 0;
        }
      };
      this.destroy = function() {
        if (self2._interval) {
          clearInterval(self2._interval);
        }
        self2._callback = void 0;
        self2._interval = void 0;
        self2._args = void 0;
      };
    }
    function reInterval() {
      if (typeof arguments[0] !== "function")
        throw new Error("callback needed");
      if (typeof arguments[1] !== "number")
        throw new Error("interval needed");
      var args;
      if (arguments.length > 0) {
        args = new Array(arguments.length - 2);
        for (var i = 0; i < args.length; i++) {
          args[i] = arguments[i + 2];
        }
      }
      return new ReInterval(arguments[0], arguments[1], args);
    }
    module2.exports = reInterval;
  }
});

// node_modules/rfdc/index.js
var require_rfdc = __commonJS({
  "node_modules/rfdc/index.js"(exports2, module2) {
    "use strict";
    module2.exports = rfdc;
    function copyBuffer(cur) {
      if (cur instanceof Buffer) {
        return Buffer.from(cur);
      }
      return new cur.constructor(cur.buffer.slice(), cur.byteOffset, cur.length);
    }
    function rfdc(opts) {
      opts = opts || {};
      if (opts.circles)
        return rfdcCircles(opts);
      return opts.proto ? cloneProto : clone;
      function cloneArray(a, fn) {
        var keys = Object.keys(a);
        var a2 = new Array(keys.length);
        for (var i = 0; i < keys.length; i++) {
          var k = keys[i];
          var cur = a[k];
          if (typeof cur !== "object" || cur === null) {
            a2[k] = cur;
          } else if (cur instanceof Date) {
            a2[k] = new Date(cur);
          } else if (ArrayBuffer.isView(cur)) {
            a2[k] = copyBuffer(cur);
          } else {
            a2[k] = fn(cur);
          }
        }
        return a2;
      }
      function clone(o2) {
        if (typeof o2 !== "object" || o2 === null)
          return o2;
        if (o2 instanceof Date)
          return new Date(o2);
        if (Array.isArray(o2))
          return cloneArray(o2, clone);
        if (o2 instanceof Map)
          return new Map(cloneArray(Array.from(o2), clone));
        if (o2 instanceof Set)
          return new Set(cloneArray(Array.from(o2), clone));
        var o22 = {};
        for (var k in o2) {
          if (Object.hasOwnProperty.call(o2, k) === false)
            continue;
          var cur = o2[k];
          if (typeof cur !== "object" || cur === null) {
            o22[k] = cur;
          } else if (cur instanceof Date) {
            o22[k] = new Date(cur);
          } else if (cur instanceof Map) {
            o22[k] = new Map(cloneArray(Array.from(cur), clone));
          } else if (cur instanceof Set) {
            o22[k] = new Set(cloneArray(Array.from(cur), clone));
          } else if (ArrayBuffer.isView(cur)) {
            o22[k] = copyBuffer(cur);
          } else {
            o22[k] = clone(cur);
          }
        }
        return o22;
      }
      function cloneProto(o2) {
        if (typeof o2 !== "object" || o2 === null)
          return o2;
        if (o2 instanceof Date)
          return new Date(o2);
        if (Array.isArray(o2))
          return cloneArray(o2, cloneProto);
        if (o2 instanceof Map)
          return new Map(cloneArray(Array.from(o2), cloneProto));
        if (o2 instanceof Set)
          return new Set(cloneArray(Array.from(o2), cloneProto));
        var o22 = {};
        for (var k in o2) {
          var cur = o2[k];
          if (typeof cur !== "object" || cur === null) {
            o22[k] = cur;
          } else if (cur instanceof Date) {
            o22[k] = new Date(cur);
          } else if (cur instanceof Map) {
            o22[k] = new Map(cloneArray(Array.from(cur), cloneProto));
          } else if (cur instanceof Set) {
            o22[k] = new Set(cloneArray(Array.from(cur), cloneProto));
          } else if (ArrayBuffer.isView(cur)) {
            o22[k] = copyBuffer(cur);
          } else {
            o22[k] = cloneProto(cur);
          }
        }
        return o22;
      }
    }
    function rfdcCircles(opts) {
      var refs = [];
      var refsNew = [];
      return opts.proto ? cloneProto : clone;
      function cloneArray(a, fn) {
        var keys = Object.keys(a);
        var a2 = new Array(keys.length);
        for (var i = 0; i < keys.length; i++) {
          var k = keys[i];
          var cur = a[k];
          if (typeof cur !== "object" || cur === null) {
            a2[k] = cur;
          } else if (cur instanceof Date) {
            a2[k] = new Date(cur);
          } else if (ArrayBuffer.isView(cur)) {
            a2[k] = copyBuffer(cur);
          } else {
            var index = refs.indexOf(cur);
            if (index !== -1) {
              a2[k] = refsNew[index];
            } else {
              a2[k] = fn(cur);
            }
          }
        }
        return a2;
      }
      function clone(o2) {
        if (typeof o2 !== "object" || o2 === null)
          return o2;
        if (o2 instanceof Date)
          return new Date(o2);
        if (Array.isArray(o2))
          return cloneArray(o2, clone);
        if (o2 instanceof Map)
          return new Map(cloneArray(Array.from(o2), clone));
        if (o2 instanceof Set)
          return new Set(cloneArray(Array.from(o2), clone));
        var o22 = {};
        refs.push(o2);
        refsNew.push(o22);
        for (var k in o2) {
          if (Object.hasOwnProperty.call(o2, k) === false)
            continue;
          var cur = o2[k];
          if (typeof cur !== "object" || cur === null) {
            o22[k] = cur;
          } else if (cur instanceof Date) {
            o22[k] = new Date(cur);
          } else if (cur instanceof Map) {
            o22[k] = new Map(cloneArray(Array.from(cur), clone));
          } else if (cur instanceof Set) {
            o22[k] = new Set(cloneArray(Array.from(cur), clone));
          } else if (ArrayBuffer.isView(cur)) {
            o22[k] = copyBuffer(cur);
          } else {
            var i = refs.indexOf(cur);
            if (i !== -1) {
              o22[k] = refsNew[i];
            } else {
              o22[k] = clone(cur);
            }
          }
        }
        refs.pop();
        refsNew.pop();
        return o22;
      }
      function cloneProto(o2) {
        if (typeof o2 !== "object" || o2 === null)
          return o2;
        if (o2 instanceof Date)
          return new Date(o2);
        if (Array.isArray(o2))
          return cloneArray(o2, cloneProto);
        if (o2 instanceof Map)
          return new Map(cloneArray(Array.from(o2), cloneProto));
        if (o2 instanceof Set)
          return new Set(cloneArray(Array.from(o2), cloneProto));
        var o22 = {};
        refs.push(o2);
        refsNew.push(o22);
        for (var k in o2) {
          var cur = o2[k];
          if (typeof cur !== "object" || cur === null) {
            o22[k] = cur;
          } else if (cur instanceof Date) {
            o22[k] = new Date(cur);
          } else if (cur instanceof Map) {
            o22[k] = new Map(cloneArray(Array.from(cur), cloneProto));
          } else if (cur instanceof Set) {
            o22[k] = new Set(cloneArray(Array.from(cur), cloneProto));
          } else if (ArrayBuffer.isView(cur)) {
            o22[k] = copyBuffer(cur);
          } else {
            var i = refs.indexOf(cur);
            if (i !== -1) {
              o22[k] = refsNew[i];
            } else {
              o22[k] = cloneProto(cur);
            }
          }
        }
        refs.pop();
        refsNew.pop();
        return o22;
      }
    }
  }
});

// node_modules/rfdc/default.js
var require_default = __commonJS({
  "node_modules/rfdc/default.js"(exports2, module2) {
    "use strict";
    module2.exports = require_rfdc()();
  }
});

// node_modules/mqtt/lib/validations.js
var require_validations = __commonJS({
  "node_modules/mqtt/lib/validations.js"(exports2, module2) {
    "use strict";
    function validateTopic(topic) {
      const parts = topic.split("/");
      for (let i = 0; i < parts.length; i++) {
        if (parts[i] === "+") {
          continue;
        }
        if (parts[i] === "#") {
          return i === parts.length - 1;
        }
        if (parts[i].indexOf("+") !== -1 || parts[i].indexOf("#") !== -1) {
          return false;
        }
      }
      return true;
    }
    function validateTopics(topics) {
      if (topics.length === 0) {
        return "empty_topic_list";
      }
      for (let i = 0; i < topics.length; i++) {
        if (!validateTopic(topics[i])) {
          return topics[i];
        }
      }
      return null;
    }
    module2.exports = {
      validateTopics
    };
  }
});

// node_modules/mqtt/lib/client.js
var require_client = __commonJS({
  "node_modules/mqtt/lib/client.js"(exports2, module2) {
    "use strict";
    var EventEmitter = require("events").EventEmitter;
    var Store = require_store();
    var TopicAliasRecv = require_topic_alias_recv();
    var TopicAliasSend = require_topic_alias_send();
    var mqttPacket = require_mqtt();
    var DefaultMessageIdProvider = require_default_message_id_provider();
    var Writable = require_readable().Writable;
    var inherits = require_inherits();
    var reInterval = require_reinterval();
    var clone = require_default();
    var validations = require_validations();
    var xtend = require_immutable();
    var debug = require_src()("mqttjs:client");
    var nextTick = process ? process.nextTick : function(callback) {
      setTimeout(callback, 0);
    };
    var setImmediate2 = global.setImmediate || function(callback) {
      nextTick(callback);
    };
    var defaultConnectOptions = {
      keepalive: 60,
      reschedulePings: true,
      protocolId: "MQTT",
      protocolVersion: 4,
      reconnectPeriod: 1e3,
      connectTimeout: 30 * 1e3,
      clean: true,
      resubscribe: true
    };
    var socketErrors = [
      "ECONNREFUSED",
      "EADDRINUSE",
      "ECONNRESET",
      "ENOTFOUND"
    ];
    var errors = {
      0: "",
      1: "Unacceptable protocol version",
      2: "Identifier rejected",
      3: "Server unavailable",
      4: "Bad username or password",
      5: "Not authorized",
      16: "No matching subscribers",
      17: "No subscription existed",
      128: "Unspecified error",
      129: "Malformed Packet",
      130: "Protocol Error",
      131: "Implementation specific error",
      132: "Unsupported Protocol Version",
      133: "Client Identifier not valid",
      134: "Bad User Name or Password",
      135: "Not authorized",
      136: "Server unavailable",
      137: "Server busy",
      138: "Banned",
      139: "Server shutting down",
      140: "Bad authentication method",
      141: "Keep Alive timeout",
      142: "Session taken over",
      143: "Topic Filter invalid",
      144: "Topic Name invalid",
      145: "Packet identifier in use",
      146: "Packet Identifier not found",
      147: "Receive Maximum exceeded",
      148: "Topic Alias invalid",
      149: "Packet too large",
      150: "Message rate too high",
      151: "Quota exceeded",
      152: "Administrative action",
      153: "Payload format invalid",
      154: "Retain not supported",
      155: "QoS not supported",
      156: "Use another server",
      157: "Server moved",
      158: "Shared Subscriptions not supported",
      159: "Connection rate exceeded",
      160: "Maximum connect time",
      161: "Subscription Identifiers not supported",
      162: "Wildcard Subscriptions not supported"
    };
    function defaultId() {
      return "mqttjs_" + Math.random().toString(16).substr(2, 8);
    }
    function applyTopicAlias(client2, packet) {
      if (client2.options.protocolVersion === 5) {
        if (packet.cmd === "publish") {
          let alias;
          if (packet.properties) {
            alias = packet.properties.topicAlias;
          }
          const topic = packet.topic.toString();
          if (client2.topicAliasSend) {
            if (alias) {
              if (topic.length !== 0) {
                debug("applyTopicAlias :: register topic: %s - alias: %d", topic, alias);
                if (!client2.topicAliasSend.put(topic, alias)) {
                  debug("applyTopicAlias :: error out of range. topic: %s - alias: %d", topic, alias);
                  return new Error("Sending Topic Alias out of range");
                }
              }
            } else {
              if (topic.length !== 0) {
                if (client2.options.autoAssignTopicAlias) {
                  alias = client2.topicAliasSend.getAliasByTopic(topic);
                  if (alias) {
                    packet.topic = "";
                    packet.properties = { ...packet.properties, topicAlias: alias };
                    debug("applyTopicAlias :: auto assign(use) topic: %s - alias: %d", topic, alias);
                  } else {
                    alias = client2.topicAliasSend.getLruAlias();
                    client2.topicAliasSend.put(topic, alias);
                    packet.properties = { ...packet.properties, topicAlias: alias };
                    debug("applyTopicAlias :: auto assign topic: %s - alias: %d", topic, alias);
                  }
                } else if (client2.options.autoUseTopicAlias) {
                  alias = client2.topicAliasSend.getAliasByTopic(topic);
                  if (alias) {
                    packet.topic = "";
                    packet.properties = { ...packet.properties, topicAlias: alias };
                    debug("applyTopicAlias :: auto use topic: %s - alias: %d", topic, alias);
                  }
                }
              }
            }
          } else if (alias) {
            debug("applyTopicAlias :: error out of range. topic: %s - alias: %d", topic, alias);
            return new Error("Sending Topic Alias out of range");
          }
        }
      }
    }
    function removeTopicAliasAndRecoverTopicName(client2, packet) {
      let alias;
      if (packet.properties) {
        alias = packet.properties.topicAlias;
      }
      let topic = packet.topic.toString();
      if (topic.length === 0) {
        if (typeof alias === "undefined") {
          return new Error("Unregistered Topic Alias");
        } else {
          topic = client2.topicAliasSend.getTopicByAlias(alias);
          if (typeof topic === "undefined") {
            return new Error("Unregistered Topic Alias");
          } else {
            packet.topic = topic;
          }
        }
      }
      if (alias) {
        delete packet.properties.topicAlias;
      }
    }
    function sendPacket(client2, packet, cb) {
      debug("sendPacket :: packet: %O", packet);
      debug("sendPacket :: emitting `packetsend`");
      client2.emit("packetsend", packet);
      debug("sendPacket :: writing to stream");
      const result2 = mqttPacket.writeToStream(packet, client2.stream, client2.options);
      debug("sendPacket :: writeToStream result %s", result2);
      if (!result2 && cb && cb !== nop) {
        debug("sendPacket :: handle events on `drain` once through callback.");
        client2.stream.once("drain", cb);
      } else if (cb) {
        debug("sendPacket :: invoking cb");
        cb();
      }
    }
    function flush(queue) {
      if (queue) {
        debug("flush: queue exists? %b", !!queue);
        Object.keys(queue).forEach(function(messageId) {
          if (typeof queue[messageId].cb === "function") {
            queue[messageId].cb(new Error("Connection closed"));
            delete queue[messageId];
          }
        });
      }
    }
    function flushVolatile(queue) {
      if (queue) {
        debug("flushVolatile :: deleting volatile messages from the queue and setting their callbacks as error function");
        Object.keys(queue).forEach(function(messageId) {
          if (queue[messageId].volatile && typeof queue[messageId].cb === "function") {
            queue[messageId].cb(new Error("Connection closed"));
            delete queue[messageId];
          }
        });
      }
    }
    function storeAndSend(client2, packet, cb, cbStorePut) {
      debug("storeAndSend :: store packet with cmd %s to outgoingStore", packet.cmd);
      let storePacket = packet;
      let err;
      if (storePacket.cmd === "publish") {
        storePacket = clone(packet);
        err = removeTopicAliasAndRecoverTopicName(client2, storePacket);
        if (err) {
          return cb && cb(err);
        }
      }
      client2.outgoingStore.put(storePacket, function storedPacket(err2) {
        if (err2) {
          return cb && cb(err2);
        }
        cbStorePut();
        sendPacket(client2, packet, cb);
      });
    }
    function nop(error) {
      debug("nop ::", error);
    }
    function MqttClient(streamBuilder, options) {
      let k;
      const that = this;
      if (!(this instanceof MqttClient)) {
        return new MqttClient(streamBuilder, options);
      }
      this.options = options || {};
      for (k in defaultConnectOptions) {
        if (typeof this.options[k] === "undefined") {
          this.options[k] = defaultConnectOptions[k];
        } else {
          this.options[k] = options[k];
        }
      }
      debug("MqttClient :: options.protocol", options.protocol);
      debug("MqttClient :: options.protocolVersion", options.protocolVersion);
      debug("MqttClient :: options.username", options.username);
      debug("MqttClient :: options.keepalive", options.keepalive);
      debug("MqttClient :: options.reconnectPeriod", options.reconnectPeriod);
      debug("MqttClient :: options.rejectUnauthorized", options.rejectUnauthorized);
      debug("MqttClient :: options.topicAliasMaximum", options.topicAliasMaximum);
      this.options.clientId = typeof options.clientId === "string" ? options.clientId : defaultId();
      debug("MqttClient :: clientId", this.options.clientId);
      this.options.customHandleAcks = options.protocolVersion === 5 && options.customHandleAcks ? options.customHandleAcks : function() {
        arguments[3](0);
      };
      this.streamBuilder = streamBuilder;
      this.messageIdProvider = typeof this.options.messageIdProvider === "undefined" ? new DefaultMessageIdProvider() : this.options.messageIdProvider;
      this.outgoingStore = options.outgoingStore || new Store();
      this.incomingStore = options.incomingStore || new Store();
      this.queueQoSZero = options.queueQoSZero === void 0 ? true : options.queueQoSZero;
      this._resubscribeTopics = {};
      this.messageIdToTopic = {};
      this.pingTimer = null;
      this.connected = false;
      this.disconnecting = false;
      this.queue = [];
      this.connackTimer = null;
      this.reconnectTimer = null;
      this._storeProcessing = false;
      this._packetIdsDuringStoreProcessing = {};
      this._storeProcessingQueue = [];
      this.outgoing = {};
      this._firstConnection = true;
      if (options.topicAliasMaximum > 0) {
        if (options.topicAliasMaximum > 65535) {
          debug("MqttClient :: options.topicAliasMaximum is out of range");
        } else {
          this.topicAliasRecv = new TopicAliasRecv(options.topicAliasMaximum);
        }
      }
      this.on("connect", function() {
        const queue = this.queue;
        function deliver() {
          const entry = queue.shift();
          debug("deliver :: entry %o", entry);
          let packet = null;
          if (!entry) {
            that._resubscribe();
            return;
          }
          packet = entry.packet;
          debug("deliver :: call _sendPacket for %o", packet);
          let send2 = true;
          if (packet.messageId && packet.messageId !== 0) {
            if (!that.messageIdProvider.register(packet.messageId)) {
              send2 = false;
            }
          }
          if (send2) {
            that._sendPacket(
              packet,
              function(err) {
                if (entry.cb) {
                  entry.cb(err);
                }
                deliver();
              }
            );
          } else {
            debug("messageId: %d has already used. The message is skipped and removed.", packet.messageId);
            deliver();
          }
        }
        debug("connect :: sending queued packets");
        deliver();
      });
      this.on("close", function() {
        debug("close :: connected set to `false`");
        this.connected = false;
        debug("close :: clearing connackTimer");
        clearTimeout(this.connackTimer);
        debug("close :: clearing ping timer");
        if (that.pingTimer !== null) {
          that.pingTimer.clear();
          that.pingTimer = null;
        }
        if (this.topicAliasRecv) {
          this.topicAliasRecv.clear();
        }
        debug("close :: calling _setupReconnect");
        this._setupReconnect();
      });
      EventEmitter.call(this);
      debug("MqttClient :: setting up stream");
      this._setupStream();
    }
    inherits(MqttClient, EventEmitter);
    MqttClient.prototype._setupStream = function() {
      const that = this;
      const writable = new Writable();
      const parser = mqttPacket.parser(this.options);
      let completeParse = null;
      const packets = [];
      debug("_setupStream :: calling method to clear reconnect");
      this._clearReconnect();
      debug("_setupStream :: using streamBuilder provided to client to create stream");
      this.stream = this.streamBuilder(this);
      parser.on("packet", function(packet) {
        debug("parser :: on packet push to packets array.");
        packets.push(packet);
      });
      function nextTickWork() {
        if (packets.length) {
          nextTick(work);
        } else {
          const done = completeParse;
          completeParse = null;
          done();
        }
      }
      function work() {
        debug("work :: getting next packet in queue");
        const packet = packets.shift();
        if (packet) {
          debug("work :: packet pulled from queue");
          that._handlePacket(packet, nextTickWork);
        } else {
          debug("work :: no packets in queue");
          const done = completeParse;
          completeParse = null;
          debug("work :: done flag is %s", !!done);
          if (done)
            done();
        }
      }
      writable._write = function(buf, enc, done) {
        completeParse = done;
        debug("writable stream :: parsing buffer");
        parser.parse(buf);
        work();
      };
      function streamErrorHandler(error) {
        debug("streamErrorHandler :: error", error.message);
        if (socketErrors.includes(error.code)) {
          debug("streamErrorHandler :: emitting error");
          that.emit("error", error);
        } else {
          nop(error);
        }
      }
      debug("_setupStream :: pipe stream to writable stream");
      this.stream.pipe(writable);
      this.stream.on("error", streamErrorHandler);
      this.stream.on("close", function() {
        debug("(%s)stream :: on close", that.options.clientId);
        flushVolatile(that.outgoing);
        debug("stream: emit close to MqttClient");
        that.emit("close");
      });
      debug("_setupStream: sending packet `connect`");
      const connectPacket = Object.create(this.options);
      connectPacket.cmd = "connect";
      if (this.topicAliasRecv) {
        if (!connectPacket.properties) {
          connectPacket.properties = {};
        }
        if (this.topicAliasRecv) {
          connectPacket.properties.topicAliasMaximum = this.topicAliasRecv.max;
        }
      }
      sendPacket(this, connectPacket);
      parser.on("error", this.emit.bind(this, "error"));
      if (this.options.properties) {
        if (!this.options.properties.authenticationMethod && this.options.properties.authenticationData) {
          that.end(() => this.emit(
            "error",
            new Error("Packet has no Authentication Method")
          ));
          return this;
        }
        if (this.options.properties.authenticationMethod && this.options.authPacket && typeof this.options.authPacket === "object") {
          const authPacket = xtend({ cmd: "auth", reasonCode: 0 }, this.options.authPacket);
          sendPacket(this, authPacket);
        }
      }
      this.stream.setMaxListeners(1e3);
      clearTimeout(this.connackTimer);
      this.connackTimer = setTimeout(function() {
        debug("!!connectTimeout hit!! Calling _cleanUp with force `true`");
        that._cleanUp(true);
      }, this.options.connectTimeout);
    };
    MqttClient.prototype._handlePacket = function(packet, done) {
      const options = this.options;
      if (options.protocolVersion === 5 && options.properties && options.properties.maximumPacketSize && options.properties.maximumPacketSize < packet.length) {
        this.emit("error", new Error("exceeding packets size " + packet.cmd));
        this.end({ reasonCode: 149, properties: { reasonString: "Maximum packet size was exceeded" } });
        return this;
      }
      debug("_handlePacket :: emitting packetreceive");
      this.emit("packetreceive", packet);
      switch (packet.cmd) {
        case "publish":
          this._handlePublish(packet, done);
          break;
        case "puback":
        case "pubrec":
        case "pubcomp":
        case "suback":
        case "unsuback":
          this._handleAck(packet);
          done();
          break;
        case "pubrel":
          this._handlePubrel(packet, done);
          break;
        case "connack":
          this._handleConnack(packet);
          done();
          break;
        case "auth":
          this._handleAuth(packet);
          done();
          break;
        case "pingresp":
          this._handlePingresp(packet);
          done();
          break;
        case "disconnect":
          this._handleDisconnect(packet);
          done();
          break;
        default:
          break;
      }
    };
    MqttClient.prototype._checkDisconnecting = function(callback) {
      if (this.disconnecting) {
        if (callback && callback !== nop) {
          callback(new Error("client disconnecting"));
        } else {
          this.emit("error", new Error("client disconnecting"));
        }
      }
      return this.disconnecting;
    };
    MqttClient.prototype.publish = function(topic, message, opts, callback) {
      debug("publish :: message `%s` to topic `%s`", message, topic);
      const options = this.options;
      if (typeof opts === "function") {
        callback = opts;
        opts = null;
      }
      const defaultOpts = { qos: 0, retain: false, dup: false };
      opts = xtend(defaultOpts, opts);
      if (this._checkDisconnecting(callback)) {
        return this;
      }
      const that = this;
      const publishProc = function() {
        let messageId = 0;
        if (opts.qos === 1 || opts.qos === 2) {
          messageId = that._nextId();
          if (messageId === null) {
            debug("No messageId left");
            return false;
          }
        }
        const packet = {
          cmd: "publish",
          topic,
          payload: message,
          qos: opts.qos,
          retain: opts.retain,
          messageId,
          dup: opts.dup
        };
        if (options.protocolVersion === 5) {
          packet.properties = opts.properties;
        }
        debug("publish :: qos", opts.qos);
        switch (opts.qos) {
          case 1:
          case 2:
            that.outgoing[packet.messageId] = {
              volatile: false,
              cb: callback || nop
            };
            debug("MqttClient:publish: packet cmd: %s", packet.cmd);
            that._sendPacket(packet, void 0, opts.cbStorePut);
            break;
          default:
            debug("MqttClient:publish: packet cmd: %s", packet.cmd);
            that._sendPacket(packet, callback, opts.cbStorePut);
            break;
        }
        return true;
      };
      if (this._storeProcessing || this._storeProcessingQueue.length > 0 || !publishProc()) {
        this._storeProcessingQueue.push(
          {
            invoke: publishProc,
            cbStorePut: opts.cbStorePut,
            callback
          }
        );
      }
      return this;
    };
    MqttClient.prototype.subscribe = function() {
      const that = this;
      const args = new Array(arguments.length);
      for (let i = 0; i < arguments.length; i++) {
        args[i] = arguments[i];
      }
      const subs = [];
      let obj = args.shift();
      const resubscribe = obj.resubscribe;
      let callback = args.pop() || nop;
      let opts = args.pop();
      const version = this.options.protocolVersion;
      delete obj.resubscribe;
      if (typeof obj === "string") {
        obj = [obj];
      }
      if (typeof callback !== "function") {
        opts = callback;
        callback = nop;
      }
      const invalidTopic = validations.validateTopics(obj);
      if (invalidTopic !== null) {
        setImmediate2(callback, new Error("Invalid topic " + invalidTopic));
        return this;
      }
      if (this._checkDisconnecting(callback)) {
        debug("subscribe: discconecting true");
        return this;
      }
      const defaultOpts = {
        qos: 0
      };
      if (version === 5) {
        defaultOpts.nl = false;
        defaultOpts.rap = false;
        defaultOpts.rh = 0;
      }
      opts = xtend(defaultOpts, opts);
      if (Array.isArray(obj)) {
        obj.forEach(function(topic) {
          debug("subscribe: array topic %s", topic);
          if (!Object.prototype.hasOwnProperty.call(that._resubscribeTopics, topic) || that._resubscribeTopics[topic].qos < opts.qos || resubscribe) {
            const currentOpts = {
              topic,
              qos: opts.qos
            };
            if (version === 5) {
              currentOpts.nl = opts.nl;
              currentOpts.rap = opts.rap;
              currentOpts.rh = opts.rh;
              currentOpts.properties = opts.properties;
            }
            debug("subscribe: pushing topic `%s` and qos `%s` to subs list", currentOpts.topic, currentOpts.qos);
            subs.push(currentOpts);
          }
        });
      } else {
        Object.keys(obj).forEach(function(k) {
          debug("subscribe: object topic %s", k);
          if (!Object.prototype.hasOwnProperty.call(that._resubscribeTopics, k) || that._resubscribeTopics[k].qos < obj[k].qos || resubscribe) {
            const currentOpts = {
              topic: k,
              qos: obj[k].qos
            };
            if (version === 5) {
              currentOpts.nl = obj[k].nl;
              currentOpts.rap = obj[k].rap;
              currentOpts.rh = obj[k].rh;
              currentOpts.properties = opts.properties;
            }
            debug("subscribe: pushing `%s` to subs list", currentOpts);
            subs.push(currentOpts);
          }
        });
      }
      if (!subs.length) {
        callback(null, []);
        return this;
      }
      const subscribeProc = function() {
        const messageId = that._nextId();
        if (messageId === null) {
          debug("No messageId left");
          return false;
        }
        const packet = {
          cmd: "subscribe",
          subscriptions: subs,
          qos: 1,
          retain: false,
          dup: false,
          messageId
        };
        if (opts.properties) {
          packet.properties = opts.properties;
        }
        if (that.options.resubscribe) {
          debug("subscribe :: resubscribe true");
          const topics = [];
          subs.forEach(function(sub) {
            if (that.options.reconnectPeriod > 0) {
              const topic = { qos: sub.qos };
              if (version === 5) {
                topic.nl = sub.nl || false;
                topic.rap = sub.rap || false;
                topic.rh = sub.rh || 0;
                topic.properties = sub.properties;
              }
              that._resubscribeTopics[sub.topic] = topic;
              topics.push(sub.topic);
            }
          });
          that.messageIdToTopic[packet.messageId] = topics;
        }
        that.outgoing[packet.messageId] = {
          volatile: true,
          cb: function(err, packet2) {
            if (!err) {
              const granted = packet2.granted;
              for (let i = 0; i < granted.length; i += 1) {
                subs[i].qos = granted[i];
              }
            }
            callback(err, subs);
          }
        };
        debug("subscribe :: call _sendPacket");
        that._sendPacket(packet);
        return true;
      };
      if (this._storeProcessing || this._storeProcessingQueue.length > 0 || !subscribeProc()) {
        this._storeProcessingQueue.push(
          {
            invoke: subscribeProc,
            callback
          }
        );
      }
      return this;
    };
    MqttClient.prototype.unsubscribe = function() {
      const that = this;
      const args = new Array(arguments.length);
      for (let i = 0; i < arguments.length; i++) {
        args[i] = arguments[i];
      }
      let topic = args.shift();
      let callback = args.pop() || nop;
      let opts = args.pop();
      if (typeof topic === "string") {
        topic = [topic];
      }
      if (typeof callback !== "function") {
        opts = callback;
        callback = nop;
      }
      const invalidTopic = validations.validateTopics(topic);
      if (invalidTopic !== null) {
        setImmediate2(callback, new Error("Invalid topic " + invalidTopic));
        return this;
      }
      if (that._checkDisconnecting(callback)) {
        return this;
      }
      const unsubscribeProc = function() {
        const messageId = that._nextId();
        if (messageId === null) {
          debug("No messageId left");
          return false;
        }
        const packet = {
          cmd: "unsubscribe",
          qos: 1,
          messageId
        };
        if (typeof topic === "string") {
          packet.unsubscriptions = [topic];
        } else if (Array.isArray(topic)) {
          packet.unsubscriptions = topic;
        }
        if (that.options.resubscribe) {
          packet.unsubscriptions.forEach(function(topic2) {
            delete that._resubscribeTopics[topic2];
          });
        }
        if (typeof opts === "object" && opts.properties) {
          packet.properties = opts.properties;
        }
        that.outgoing[packet.messageId] = {
          volatile: true,
          cb: callback
        };
        debug("unsubscribe: call _sendPacket");
        that._sendPacket(packet);
        return true;
      };
      if (this._storeProcessing || this._storeProcessingQueue.length > 0 || !unsubscribeProc()) {
        this._storeProcessingQueue.push(
          {
            invoke: unsubscribeProc,
            callback
          }
        );
      }
      return this;
    };
    MqttClient.prototype.end = function(force, opts, cb) {
      const that = this;
      debug("end :: (%s)", this.options.clientId);
      if (force == null || typeof force !== "boolean") {
        cb = opts || nop;
        opts = force;
        force = false;
        if (typeof opts !== "object") {
          cb = opts;
          opts = null;
          if (typeof cb !== "function") {
            cb = nop;
          }
        }
      }
      if (typeof opts !== "object") {
        cb = opts;
        opts = null;
      }
      debug("end :: cb? %s", !!cb);
      cb = cb || nop;
      function closeStores() {
        debug("end :: closeStores: closing incoming and outgoing stores");
        that.disconnected = true;
        that.incomingStore.close(function(e1) {
          that.outgoingStore.close(function(e2) {
            debug("end :: closeStores: emitting end");
            that.emit("end");
            if (cb) {
              const err = e1 || e2;
              debug("end :: closeStores: invoking callback with args");
              cb(err);
            }
          });
        });
        if (that._deferredReconnect) {
          that._deferredReconnect();
        }
      }
      function finish() {
        debug("end :: (%s) :: finish :: calling _cleanUp with force %s", that.options.clientId, force);
        that._cleanUp(force, () => {
          debug("end :: finish :: calling process.nextTick on closeStores");
          nextTick(closeStores.bind(that));
        }, opts);
      }
      if (this.disconnecting) {
        cb();
        return this;
      }
      this._clearReconnect();
      this.disconnecting = true;
      if (!force && Object.keys(this.outgoing).length > 0) {
        debug("end :: (%s) :: calling finish in 10ms once outgoing is empty", that.options.clientId);
        this.once("outgoingEmpty", setTimeout.bind(null, finish, 10));
      } else {
        debug("end :: (%s) :: immediately calling finish", that.options.clientId);
        finish();
      }
      return this;
    };
    MqttClient.prototype.removeOutgoingMessage = function(messageId) {
      const cb = this.outgoing[messageId] ? this.outgoing[messageId].cb : null;
      delete this.outgoing[messageId];
      this.outgoingStore.del({ messageId }, function() {
        cb(new Error("Message removed"));
      });
      return this;
    };
    MqttClient.prototype.reconnect = function(opts) {
      debug("client reconnect");
      const that = this;
      const f2 = function() {
        if (opts) {
          that.options.incomingStore = opts.incomingStore;
          that.options.outgoingStore = opts.outgoingStore;
        } else {
          that.options.incomingStore = null;
          that.options.outgoingStore = null;
        }
        that.incomingStore = that.options.incomingStore || new Store();
        that.outgoingStore = that.options.outgoingStore || new Store();
        that.disconnecting = false;
        that.disconnected = false;
        that._deferredReconnect = null;
        that._reconnect();
      };
      if (this.disconnecting && !this.disconnected) {
        this._deferredReconnect = f2;
      } else {
        f2();
      }
      return this;
    };
    MqttClient.prototype._reconnect = function() {
      debug("_reconnect: emitting reconnect to client");
      this.emit("reconnect");
      if (this.connected) {
        this.end(() => {
          this._setupStream();
        });
        debug("client already connected. disconnecting first.");
      } else {
        debug("_reconnect: calling _setupStream");
        this._setupStream();
      }
    };
    MqttClient.prototype._setupReconnect = function() {
      const that = this;
      if (!that.disconnecting && !that.reconnectTimer && that.options.reconnectPeriod > 0) {
        if (!this.reconnecting) {
          debug("_setupReconnect :: emit `offline` state");
          this.emit("offline");
          debug("_setupReconnect :: set `reconnecting` to `true`");
          this.reconnecting = true;
        }
        debug("_setupReconnect :: setting reconnectTimer for %d ms", that.options.reconnectPeriod);
        that.reconnectTimer = setInterval(function() {
          debug("reconnectTimer :: reconnect triggered!");
          that._reconnect();
        }, that.options.reconnectPeriod);
      } else {
        debug("_setupReconnect :: doing nothing...");
      }
    };
    MqttClient.prototype._clearReconnect = function() {
      debug("_clearReconnect : clearing reconnect timer");
      if (this.reconnectTimer) {
        clearInterval(this.reconnectTimer);
        this.reconnectTimer = null;
      }
    };
    MqttClient.prototype._cleanUp = function(forced, done) {
      const opts = arguments[2];
      if (done) {
        debug("_cleanUp :: done callback provided for on stream close");
        this.stream.on("close", done);
      }
      debug("_cleanUp :: forced? %s", forced);
      if (forced) {
        if (this.options.reconnectPeriod === 0 && this.options.clean) {
          flush(this.outgoing);
        }
        debug("_cleanUp :: (%s) :: destroying stream", this.options.clientId);
        this.stream.destroy();
      } else {
        const packet = xtend({ cmd: "disconnect" }, opts);
        debug("_cleanUp :: (%s) :: call _sendPacket with disconnect packet", this.options.clientId);
        this._sendPacket(
          packet,
          setImmediate2.bind(
            null,
            this.stream.end.bind(this.stream)
          )
        );
      }
      if (!this.disconnecting) {
        debug("_cleanUp :: client not disconnecting. Clearing and resetting reconnect.");
        this._clearReconnect();
        this._setupReconnect();
      }
      if (this.pingTimer !== null) {
        debug("_cleanUp :: clearing pingTimer");
        this.pingTimer.clear();
        this.pingTimer = null;
      }
      if (done && !this.connected) {
        debug("_cleanUp :: (%s) :: removing stream `done` callback `close` listener", this.options.clientId);
        this.stream.removeListener("close", done);
        done();
      }
    };
    MqttClient.prototype._sendPacket = function(packet, cb, cbStorePut) {
      debug("_sendPacket :: (%s) ::  start", this.options.clientId);
      cbStorePut = cbStorePut || nop;
      cb = cb || nop;
      const err = applyTopicAlias(this, packet);
      if (err) {
        cb(err);
        return;
      }
      if (!this.connected) {
        if (packet.cmd === "auth") {
          this._shiftPingInterval();
          sendPacket(this, packet, cb);
          return;
        }
        debug("_sendPacket :: client not connected. Storing packet offline.");
        this._storePacket(packet, cb, cbStorePut);
        return;
      }
      this._shiftPingInterval();
      switch (packet.cmd) {
        case "publish":
          break;
        case "pubrel":
          storeAndSend(this, packet, cb, cbStorePut);
          return;
        default:
          sendPacket(this, packet, cb);
          return;
      }
      switch (packet.qos) {
        case 2:
        case 1:
          storeAndSend(this, packet, cb, cbStorePut);
          break;
        case 0:
        default:
          sendPacket(this, packet, cb);
          break;
      }
      debug("_sendPacket :: (%s) ::  end", this.options.clientId);
    };
    MqttClient.prototype._storePacket = function(packet, cb, cbStorePut) {
      debug("_storePacket :: packet: %o", packet);
      debug("_storePacket :: cb? %s", !!cb);
      cbStorePut = cbStorePut || nop;
      let storePacket = packet;
      if (storePacket.cmd === "publish") {
        storePacket = clone(packet);
        const err = removeTopicAliasAndRecoverTopicName(this, storePacket);
        if (err) {
          return cb && cb(err);
        }
      }
      if ((storePacket.qos || 0) === 0 && this.queueQoSZero || storePacket.cmd !== "publish") {
        this.queue.push({ packet: storePacket, cb });
      } else if (storePacket.qos > 0) {
        cb = this.outgoing[storePacket.messageId] ? this.outgoing[storePacket.messageId].cb : null;
        this.outgoingStore.put(storePacket, function(err) {
          if (err) {
            return cb && cb(err);
          }
          cbStorePut();
        });
      } else if (cb) {
        cb(new Error("No connection to broker"));
      }
    };
    MqttClient.prototype._setupPingTimer = function() {
      debug("_setupPingTimer :: keepalive %d (seconds)", this.options.keepalive);
      const that = this;
      if (!this.pingTimer && this.options.keepalive) {
        this.pingResp = true;
        this.pingTimer = reInterval(function() {
          that._checkPing();
        }, this.options.keepalive * 1e3);
      }
    };
    MqttClient.prototype._shiftPingInterval = function() {
      if (this.pingTimer && this.options.keepalive && this.options.reschedulePings) {
        this.pingTimer.reschedule(this.options.keepalive * 1e3);
      }
    };
    MqttClient.prototype._checkPing = function() {
      debug("_checkPing :: checking ping...");
      if (this.pingResp) {
        debug("_checkPing :: ping response received. Clearing flag and sending `pingreq`");
        this.pingResp = false;
        this._sendPacket({ cmd: "pingreq" });
      } else {
        debug("_checkPing :: calling _cleanUp with force true");
        this._cleanUp(true);
      }
    };
    MqttClient.prototype._handlePingresp = function() {
      this.pingResp = true;
    };
    MqttClient.prototype._handleConnack = function(packet) {
      debug("_handleConnack");
      const options = this.options;
      const version = options.protocolVersion;
      const rc = version === 5 ? packet.reasonCode : packet.returnCode;
      clearTimeout(this.connackTimer);
      delete this.topicAliasSend;
      if (packet.properties) {
        if (packet.properties.topicAliasMaximum) {
          if (packet.properties.topicAliasMaximum > 65535) {
            this.emit("error", new Error("topicAliasMaximum from broker is out of range"));
            return;
          }
          if (packet.properties.topicAliasMaximum > 0) {
            this.topicAliasSend = new TopicAliasSend(packet.properties.topicAliasMaximum);
          }
        }
        if (packet.properties.serverKeepAlive && options.keepalive) {
          options.keepalive = packet.properties.serverKeepAlive;
          this._shiftPingInterval();
        }
        if (packet.properties.maximumPacketSize) {
          if (!options.properties) {
            options.properties = {};
          }
          options.properties.maximumPacketSize = packet.properties.maximumPacketSize;
        }
      }
      if (rc === 0) {
        this.reconnecting = false;
        this._onConnect(packet);
      } else if (rc > 0) {
        const err = new Error("Connection refused: " + errors[rc]);
        err.code = rc;
        this.emit("error", err);
      }
    };
    MqttClient.prototype._handleAuth = function(packet) {
      const options = this.options;
      const version = options.protocolVersion;
      const rc = version === 5 ? packet.reasonCode : packet.returnCode;
      if (version !== 5) {
        const err = new Error("Protocol error: Auth packets are only supported in MQTT 5. Your version:" + version);
        err.code = rc;
        this.emit("error", err);
        return;
      }
      const that = this;
      this.handleAuth(packet, function(err, packet2) {
        if (err) {
          that.emit("error", err);
          return;
        }
        if (rc === 24) {
          that.reconnecting = false;
          that._sendPacket(packet2);
        } else {
          const error = new Error("Connection refused: " + errors[rc]);
          err.code = rc;
          that.emit("error", error);
        }
      });
    };
    MqttClient.prototype.handleAuth = function(packet, callback) {
      callback();
    };
    MqttClient.prototype._handlePublish = function(packet, done) {
      debug("_handlePublish: packet %o", packet);
      done = typeof done !== "undefined" ? done : nop;
      let topic = packet.topic.toString();
      const message = packet.payload;
      const qos = packet.qos;
      const messageId = packet.messageId;
      const that = this;
      const options = this.options;
      const validReasonCodes = [0, 16, 128, 131, 135, 144, 145, 151, 153];
      if (this.options.protocolVersion === 5) {
        let alias;
        if (packet.properties) {
          alias = packet.properties.topicAlias;
        }
        if (typeof alias !== "undefined") {
          if (topic.length === 0) {
            if (alias > 0 && alias <= 65535) {
              const gotTopic = this.topicAliasRecv.getTopicByAlias(alias);
              if (gotTopic) {
                topic = gotTopic;
                debug("_handlePublish :: topic complemented by alias. topic: %s - alias: %d", topic, alias);
              } else {
                debug("_handlePublish :: unregistered topic alias. alias: %d", alias);
                this.emit("error", new Error("Received unregistered Topic Alias"));
                return;
              }
            } else {
              debug("_handlePublish :: topic alias out of range. alias: %d", alias);
              this.emit("error", new Error("Received Topic Alias is out of range"));
              return;
            }
          } else {
            if (this.topicAliasRecv.put(topic, alias)) {
              debug("_handlePublish :: registered topic: %s - alias: %d", topic, alias);
            } else {
              debug("_handlePublish :: topic alias out of range. alias: %d", alias);
              this.emit("error", new Error("Received Topic Alias is out of range"));
              return;
            }
          }
        }
      }
      debug("_handlePublish: qos %d", qos);
      switch (qos) {
        case 2: {
          options.customHandleAcks(topic, message, packet, function(error, code) {
            if (!(error instanceof Error)) {
              code = error;
              error = null;
            }
            if (error) {
              return that.emit("error", error);
            }
            if (validReasonCodes.indexOf(code) === -1) {
              return that.emit("error", new Error("Wrong reason code for pubrec"));
            }
            if (code) {
              that._sendPacket({ cmd: "pubrec", messageId, reasonCode: code }, done);
            } else {
              that.incomingStore.put(packet, function() {
                that._sendPacket({ cmd: "pubrec", messageId }, done);
              });
            }
          });
          break;
        }
        case 1: {
          options.customHandleAcks(topic, message, packet, function(error, code) {
            if (!(error instanceof Error)) {
              code = error;
              error = null;
            }
            if (error) {
              return that.emit("error", error);
            }
            if (validReasonCodes.indexOf(code) === -1) {
              return that.emit("error", new Error("Wrong reason code for puback"));
            }
            if (!code) {
              that.emit("message", topic, message, packet);
            }
            that.handleMessage(packet, function(err) {
              if (err) {
                return done && done(err);
              }
              that._sendPacket({ cmd: "puback", messageId, reasonCode: code }, done);
            });
          });
          break;
        }
        case 0:
          this.emit("message", topic, message, packet);
          this.handleMessage(packet, done);
          break;
        default:
          debug("_handlePublish: unknown QoS. Doing nothing.");
          break;
      }
    };
    MqttClient.prototype.handleMessage = function(packet, callback) {
      callback();
    };
    MqttClient.prototype._handleAck = function(packet) {
      const messageId = packet.messageId;
      const type = packet.cmd;
      let response = null;
      const cb = this.outgoing[messageId] ? this.outgoing[messageId].cb : null;
      const that = this;
      let err;
      if (!cb) {
        debug("_handleAck :: Server sent an ack in error. Ignoring.");
        return;
      }
      debug("_handleAck :: packet type", type);
      switch (type) {
        case "pubcomp":
        case "puback": {
          const pubackRC = packet.reasonCode;
          if (pubackRC && pubackRC > 0 && pubackRC !== 16) {
            err = new Error("Publish error: " + errors[pubackRC]);
            err.code = pubackRC;
            cb(err, packet);
          }
          delete this.outgoing[messageId];
          this.outgoingStore.del(packet, cb);
          this.messageIdProvider.deallocate(messageId);
          this._invokeStoreProcessingQueue();
          break;
        }
        case "pubrec": {
          response = {
            cmd: "pubrel",
            qos: 2,
            messageId
          };
          const pubrecRC = packet.reasonCode;
          if (pubrecRC && pubrecRC > 0 && pubrecRC !== 16) {
            err = new Error("Publish error: " + errors[pubrecRC]);
            err.code = pubrecRC;
            cb(err, packet);
          } else {
            this._sendPacket(response);
          }
          break;
        }
        case "suback": {
          delete this.outgoing[messageId];
          this.messageIdProvider.deallocate(messageId);
          for (let grantedI = 0; grantedI < packet.granted.length; grantedI++) {
            if ((packet.granted[grantedI] & 128) !== 0) {
              const topics = this.messageIdToTopic[messageId];
              if (topics) {
                topics.forEach(function(topic) {
                  delete that._resubscribeTopics[topic];
                });
              }
            }
          }
          this._invokeStoreProcessingQueue();
          cb(null, packet);
          break;
        }
        case "unsuback": {
          delete this.outgoing[messageId];
          this.messageIdProvider.deallocate(messageId);
          this._invokeStoreProcessingQueue();
          cb(null);
          break;
        }
        default:
          that.emit("error", new Error("unrecognized packet type"));
      }
      if (this.disconnecting && Object.keys(this.outgoing).length === 0) {
        this.emit("outgoingEmpty");
      }
    };
    MqttClient.prototype._handlePubrel = function(packet, callback) {
      debug("handling pubrel packet");
      callback = typeof callback !== "undefined" ? callback : nop;
      const messageId = packet.messageId;
      const that = this;
      const comp = { cmd: "pubcomp", messageId };
      that.incomingStore.get(packet, function(err, pub) {
        if (!err) {
          that.emit("message", pub.topic, pub.payload, pub);
          that.handleMessage(pub, function(err2) {
            if (err2) {
              return callback(err2);
            }
            that.incomingStore.del(pub, nop);
            that._sendPacket(comp, callback);
          });
        } else {
          that._sendPacket(comp, callback);
        }
      });
    };
    MqttClient.prototype._handleDisconnect = function(packet) {
      this.emit("disconnect", packet);
    };
    MqttClient.prototype._nextId = function() {
      return this.messageIdProvider.allocate();
    };
    MqttClient.prototype.getLastMessageId = function() {
      return this.messageIdProvider.getLastAllocated();
    };
    MqttClient.prototype._resubscribe = function() {
      debug("_resubscribe");
      const _resubscribeTopicsKeys = Object.keys(this._resubscribeTopics);
      if (!this._firstConnection && (this.options.clean || this.options.protocolVersion === 5 && !this.connackPacket.sessionPresent) && _resubscribeTopicsKeys.length > 0) {
        if (this.options.resubscribe) {
          if (this.options.protocolVersion === 5) {
            debug("_resubscribe: protocolVersion 5");
            for (let topicI = 0; topicI < _resubscribeTopicsKeys.length; topicI++) {
              const resubscribeTopic = {};
              resubscribeTopic[_resubscribeTopicsKeys[topicI]] = this._resubscribeTopics[_resubscribeTopicsKeys[topicI]];
              resubscribeTopic.resubscribe = true;
              this.subscribe(resubscribeTopic, { properties: resubscribeTopic[_resubscribeTopicsKeys[topicI]].properties });
            }
          } else {
            this._resubscribeTopics.resubscribe = true;
            this.subscribe(this._resubscribeTopics);
          }
        } else {
          this._resubscribeTopics = {};
        }
      }
      this._firstConnection = false;
    };
    MqttClient.prototype._onConnect = function(packet) {
      if (this.disconnected) {
        this.emit("connect", packet);
        return;
      }
      const that = this;
      this.connackPacket = packet;
      this.messageIdProvider.clear();
      this._setupPingTimer();
      this.connected = true;
      function startStreamProcess() {
        let outStore = that.outgoingStore.createStream();
        function clearStoreProcessing() {
          that._storeProcessing = false;
          that._packetIdsDuringStoreProcessing = {};
        }
        that.once("close", remove);
        outStore.on("error", function(err) {
          clearStoreProcessing();
          that._flushStoreProcessingQueue();
          that.removeListener("close", remove);
          that.emit("error", err);
        });
        function remove() {
          outStore.destroy();
          outStore = null;
          that._flushStoreProcessingQueue();
          clearStoreProcessing();
        }
        function storeDeliver() {
          if (!outStore) {
            return;
          }
          that._storeProcessing = true;
          const packet2 = outStore.read(1);
          let cb;
          if (!packet2) {
            outStore.once("readable", storeDeliver);
            return;
          }
          if (that._packetIdsDuringStoreProcessing[packet2.messageId]) {
            storeDeliver();
            return;
          }
          if (!that.disconnecting && !that.reconnectTimer) {
            cb = that.outgoing[packet2.messageId] ? that.outgoing[packet2.messageId].cb : null;
            that.outgoing[packet2.messageId] = {
              volatile: false,
              cb: function(err, status2) {
                if (cb) {
                  cb(err, status2);
                }
                storeDeliver();
              }
            };
            that._packetIdsDuringStoreProcessing[packet2.messageId] = true;
            if (that.messageIdProvider.register(packet2.messageId)) {
              that._sendPacket(packet2);
            } else {
              debug("messageId: %d has already used.", packet2.messageId);
            }
          } else if (outStore.destroy) {
            outStore.destroy();
          }
        }
        outStore.on("end", function() {
          let allProcessed = true;
          for (const id in that._packetIdsDuringStoreProcessing) {
            if (!that._packetIdsDuringStoreProcessing[id]) {
              allProcessed = false;
              break;
            }
          }
          if (allProcessed) {
            clearStoreProcessing();
            that.removeListener("close", remove);
            that._invokeAllStoreProcessingQueue();
            that.emit("connect", packet);
          } else {
            startStreamProcess();
          }
        });
        storeDeliver();
      }
      startStreamProcess();
    };
    MqttClient.prototype._invokeStoreProcessingQueue = function() {
      if (this._storeProcessingQueue.length > 0) {
        const f2 = this._storeProcessingQueue[0];
        if (f2 && f2.invoke()) {
          this._storeProcessingQueue.shift();
          return true;
        }
      }
      return false;
    };
    MqttClient.prototype._invokeAllStoreProcessingQueue = function() {
      while (this._invokeStoreProcessingQueue()) {
      }
    };
    MqttClient.prototype._flushStoreProcessingQueue = function() {
      for (const f2 of this._storeProcessingQueue) {
        if (f2.cbStorePut)
          f2.cbStorePut(new Error("Connection closed"));
        if (f2.callback)
          f2.callback(new Error("Connection closed"));
      }
      this._storeProcessingQueue.splice(0);
    };
    module2.exports = MqttClient;
  }
});

// node_modules/mqtt/lib/connect/tcp.js
var require_tcp = __commonJS({
  "node_modules/mqtt/lib/connect/tcp.js"(exports2, module2) {
    "use strict";
    var net = require("net");
    var debug = require_src()("mqttjs:tcp");
    function streamBuilder(client2, opts) {
      opts.port = opts.port || 1883;
      opts.hostname = opts.hostname || opts.host || "localhost";
      const port2 = opts.port;
      const host = opts.hostname;
      debug("port %d and host %s", port2, host);
      return net.createConnection(port2, host);
    }
    module2.exports = streamBuilder;
  }
});

// node_modules/mqtt/lib/connect/tls.js
var require_tls = __commonJS({
  "node_modules/mqtt/lib/connect/tls.js"(exports2, module2) {
    "use strict";
    var tls = require("tls");
    var net = require("net");
    var debug = require_src()("mqttjs:tls");
    function buildBuilder(mqttClient2, opts) {
      opts.port = opts.port || 8883;
      opts.host = opts.hostname || opts.host || "localhost";
      if (net.isIP(opts.host) === 0) {
        opts.servername = opts.host;
      }
      opts.rejectUnauthorized = opts.rejectUnauthorized !== false;
      delete opts.path;
      debug("port %d host %s rejectUnauthorized %b", opts.port, opts.host, opts.rejectUnauthorized);
      const connection = tls.connect(opts);
      connection.on("secureConnect", function() {
        if (opts.rejectUnauthorized && !connection.authorized) {
          connection.emit("error", new Error("TLS not authorized"));
        } else {
          connection.removeListener("error", handleTLSerrors);
        }
      });
      function handleTLSerrors(err) {
        if (opts.rejectUnauthorized) {
          mqttClient2.emit("error", err);
        }
        connection.end();
      }
      connection.on("error", handleTLSerrors);
      return connection;
    }
    module2.exports = buildBuilder;
  }
});

// node_modules/wrappy/wrappy.js
var require_wrappy = __commonJS({
  "node_modules/wrappy/wrappy.js"(exports2, module2) {
    module2.exports = wrappy;
    function wrappy(fn, cb) {
      if (fn && cb)
        return wrappy(fn)(cb);
      if (typeof fn !== "function")
        throw new TypeError("need wrapper function");
      Object.keys(fn).forEach(function(k) {
        wrapper[k] = fn[k];
      });
      return wrapper;
      function wrapper() {
        var args = new Array(arguments.length);
        for (var i = 0; i < args.length; i++) {
          args[i] = arguments[i];
        }
        var ret = fn.apply(this, args);
        var cb2 = args[args.length - 1];
        if (typeof ret === "function" && ret !== cb2) {
          Object.keys(cb2).forEach(function(k) {
            ret[k] = cb2[k];
          });
        }
        return ret;
      }
    }
  }
});

// node_modules/once/once.js
var require_once = __commonJS({
  "node_modules/once/once.js"(exports2, module2) {
    var wrappy = require_wrappy();
    module2.exports = wrappy(once);
    module2.exports.strict = wrappy(onceStrict);
    once.proto = once(function() {
      Object.defineProperty(Function.prototype, "once", {
        value: function() {
          return once(this);
        },
        configurable: true
      });
      Object.defineProperty(Function.prototype, "onceStrict", {
        value: function() {
          return onceStrict(this);
        },
        configurable: true
      });
    });
    function once(fn) {
      var f2 = function() {
        if (f2.called)
          return f2.value;
        f2.called = true;
        return f2.value = fn.apply(this, arguments);
      };
      f2.called = false;
      return f2;
    }
    function onceStrict(fn) {
      var f2 = function() {
        if (f2.called)
          throw new Error(f2.onceError);
        f2.called = true;
        return f2.value = fn.apply(this, arguments);
      };
      var name = fn.name || "Function wrapped with `once`";
      f2.onceError = name + " shouldn't be called more than once";
      f2.called = false;
      return f2;
    }
  }
});

// node_modules/end-of-stream/index.js
var require_end_of_stream2 = __commonJS({
  "node_modules/end-of-stream/index.js"(exports2, module2) {
    var once = require_once();
    var noop = function() {
    };
    var isRequest = function(stream) {
      return stream.setHeader && typeof stream.abort === "function";
    };
    var isChildProcess = function(stream) {
      return stream.stdio && Array.isArray(stream.stdio) && stream.stdio.length === 3;
    };
    var eos = function(stream, opts, callback) {
      if (typeof opts === "function")
        return eos(stream, null, opts);
      if (!opts)
        opts = {};
      callback = once(callback || noop);
      var ws = stream._writableState;
      var rs = stream._readableState;
      var readable = opts.readable || opts.readable !== false && stream.readable;
      var writable = opts.writable || opts.writable !== false && stream.writable;
      var cancelled = false;
      var onlegacyfinish = function() {
        if (!stream.writable)
          onfinish();
      };
      var onfinish = function() {
        writable = false;
        if (!readable)
          callback.call(stream);
      };
      var onend = function() {
        readable = false;
        if (!writable)
          callback.call(stream);
      };
      var onexit = function(exitCode) {
        callback.call(stream, exitCode ? new Error("exited with error code: " + exitCode) : null);
      };
      var onerror = function(err) {
        callback.call(stream, err);
      };
      var onclose = function() {
        process.nextTick(onclosenexttick);
      };
      var onclosenexttick = function() {
        if (cancelled)
          return;
        if (readable && !(rs && (rs.ended && !rs.destroyed)))
          return callback.call(stream, new Error("premature close"));
        if (writable && !(ws && (ws.ended && !ws.destroyed)))
          return callback.call(stream, new Error("premature close"));
      };
      var onrequest = function() {
        stream.req.on("finish", onfinish);
      };
      if (isRequest(stream)) {
        stream.on("complete", onfinish);
        stream.on("abort", onclose);
        if (stream.req)
          onrequest();
        else
          stream.on("request", onrequest);
      } else if (writable && !ws) {
        stream.on("end", onlegacyfinish);
        stream.on("close", onlegacyfinish);
      }
      if (isChildProcess(stream))
        stream.on("exit", onexit);
      stream.on("end", onend);
      stream.on("finish", onfinish);
      if (opts.error !== false)
        stream.on("error", onerror);
      stream.on("close", onclose);
      return function() {
        cancelled = true;
        stream.removeListener("complete", onfinish);
        stream.removeListener("abort", onclose);
        stream.removeListener("request", onrequest);
        if (stream.req)
          stream.req.removeListener("finish", onfinish);
        stream.removeListener("end", onlegacyfinish);
        stream.removeListener("close", onlegacyfinish);
        stream.removeListener("finish", onfinish);
        stream.removeListener("exit", onexit);
        stream.removeListener("end", onend);
        stream.removeListener("error", onerror);
        stream.removeListener("close", onclose);
      };
    };
    module2.exports = eos;
  }
});

// node_modules/stream-shift/index.js
var require_stream_shift = __commonJS({
  "node_modules/stream-shift/index.js"(exports2, module2) {
    module2.exports = shift;
    function shift(stream) {
      var rs = stream._readableState;
      if (!rs)
        return null;
      return rs.objectMode || typeof stream._duplexState === "number" ? stream.read() : stream.read(getStateLength(rs));
    }
    function getStateLength(state) {
      if (state.buffer.length) {
        var idx = state.bufferIndex || 0;
        if (state.buffer.head) {
          return state.buffer.head.data.length;
        } else if (state.buffer.length - idx > 0 && state.buffer[idx]) {
          return state.buffer[idx].length;
        }
      }
      return state.length;
    }
  }
});

// node_modules/duplexify/index.js
var require_duplexify = __commonJS({
  "node_modules/duplexify/index.js"(exports2, module2) {
    var stream = require_readable();
    var eos = require_end_of_stream2();
    var inherits = require_inherits();
    var shift = require_stream_shift();
    var SIGNAL_FLUSH = Buffer.from && Buffer.from !== Uint8Array.from ? Buffer.from([0]) : new Buffer([0]);
    var onuncork = function(self2, fn) {
      if (self2._corked)
        self2.once("uncork", fn);
      else
        fn();
    };
    var autoDestroy = function(self2, err) {
      if (self2._autoDestroy)
        self2.destroy(err);
    };
    var destroyer = function(self2, end2) {
      return function(err) {
        if (err)
          autoDestroy(self2, err.message === "premature close" ? null : err);
        else if (end2 && !self2._ended)
          self2.end();
      };
    };
    var end = function(ws, fn) {
      if (!ws)
        return fn();
      if (ws._writableState && ws._writableState.finished)
        return fn();
      if (ws._writableState)
        return ws.end(fn);
      ws.end();
      fn();
    };
    var noop = function() {
    };
    var toStreams2 = function(rs) {
      return new stream.Readable({ objectMode: true, highWaterMark: 16 }).wrap(rs);
    };
    var Duplexify = function(writable, readable, opts) {
      if (!(this instanceof Duplexify))
        return new Duplexify(writable, readable, opts);
      stream.Duplex.call(this, opts);
      this._writable = null;
      this._readable = null;
      this._readable2 = null;
      this._autoDestroy = !opts || opts.autoDestroy !== false;
      this._forwardDestroy = !opts || opts.destroy !== false;
      this._forwardEnd = !opts || opts.end !== false;
      this._corked = 1;
      this._ondrain = null;
      this._drained = false;
      this._forwarding = false;
      this._unwrite = null;
      this._unread = null;
      this._ended = false;
      this.destroyed = false;
      if (writable)
        this.setWritable(writable);
      if (readable)
        this.setReadable(readable);
    };
    inherits(Duplexify, stream.Duplex);
    Duplexify.obj = function(writable, readable, opts) {
      if (!opts)
        opts = {};
      opts.objectMode = true;
      opts.highWaterMark = 16;
      return new Duplexify(writable, readable, opts);
    };
    Duplexify.prototype.cork = function() {
      if (++this._corked === 1)
        this.emit("cork");
    };
    Duplexify.prototype.uncork = function() {
      if (this._corked && --this._corked === 0)
        this.emit("uncork");
    };
    Duplexify.prototype.setWritable = function(writable) {
      if (this._unwrite)
        this._unwrite();
      if (this.destroyed) {
        if (writable && writable.destroy)
          writable.destroy();
        return;
      }
      if (writable === null || writable === false) {
        this.end();
        return;
      }
      var self2 = this;
      var unend = eos(writable, { writable: true, readable: false }, destroyer(this, this._forwardEnd));
      var ondrain = function() {
        var ondrain2 = self2._ondrain;
        self2._ondrain = null;
        if (ondrain2)
          ondrain2();
      };
      var clear = function() {
        self2._writable.removeListener("drain", ondrain);
        unend();
      };
      if (this._unwrite)
        process.nextTick(ondrain);
      this._writable = writable;
      this._writable.on("drain", ondrain);
      this._unwrite = clear;
      this.uncork();
    };
    Duplexify.prototype.setReadable = function(readable) {
      if (this._unread)
        this._unread();
      if (this.destroyed) {
        if (readable && readable.destroy)
          readable.destroy();
        return;
      }
      if (readable === null || readable === false) {
        this.push(null);
        this.resume();
        return;
      }
      var self2 = this;
      var unend = eos(readable, { writable: false, readable: true }, destroyer(this));
      var onreadable = function() {
        self2._forward();
      };
      var onend = function() {
        self2.push(null);
      };
      var clear = function() {
        self2._readable2.removeListener("readable", onreadable);
        self2._readable2.removeListener("end", onend);
        unend();
      };
      this._drained = true;
      this._readable = readable;
      this._readable2 = readable._readableState ? readable : toStreams2(readable);
      this._readable2.on("readable", onreadable);
      this._readable2.on("end", onend);
      this._unread = clear;
      this._forward();
    };
    Duplexify.prototype._read = function() {
      this._drained = true;
      this._forward();
    };
    Duplexify.prototype._forward = function() {
      if (this._forwarding || !this._readable2 || !this._drained)
        return;
      this._forwarding = true;
      var data;
      while (this._drained && (data = shift(this._readable2)) !== null) {
        if (this.destroyed)
          continue;
        this._drained = this.push(data);
      }
      this._forwarding = false;
    };
    Duplexify.prototype.destroy = function(err, cb) {
      if (!cb)
        cb = noop;
      if (this.destroyed)
        return cb(null);
      this.destroyed = true;
      var self2 = this;
      process.nextTick(function() {
        self2._destroy(err);
        cb(null);
      });
    };
    Duplexify.prototype._destroy = function(err) {
      if (err) {
        var ondrain = this._ondrain;
        this._ondrain = null;
        if (ondrain)
          ondrain(err);
        else
          this.emit("error", err);
      }
      if (this._forwardDestroy) {
        if (this._readable && this._readable.destroy)
          this._readable.destroy();
        if (this._writable && this._writable.destroy)
          this._writable.destroy();
      }
      this.emit("close");
    };
    Duplexify.prototype._write = function(data, enc, cb) {
      if (this.destroyed)
        return;
      if (this._corked)
        return onuncork(this, this._write.bind(this, data, enc, cb));
      if (data === SIGNAL_FLUSH)
        return this._finish(cb);
      if (!this._writable)
        return cb();
      if (this._writable.write(data) === false)
        this._ondrain = cb;
      else if (!this.destroyed)
        cb();
    };
    Duplexify.prototype._finish = function(cb) {
      var self2 = this;
      this.emit("preend");
      onuncork(this, function() {
        end(self2._forwardEnd && self2._writable, function() {
          if (self2._writableState.prefinished === false)
            self2._writableState.prefinished = true;
          self2.emit("prefinish");
          onuncork(self2, cb);
        });
      });
    };
    Duplexify.prototype.end = function(data, enc, cb) {
      if (typeof data === "function")
        return this.end(null, null, data);
      if (typeof enc === "function")
        return this.end(data, null, enc);
      this._ended = true;
      if (data)
        this.write(data);
      if (!this._writableState.ending && !this._writableState.destroyed)
        this.write(SIGNAL_FLUSH);
      return stream.Writable.prototype.end.call(this, cb);
    };
    module2.exports = Duplexify;
  }
});

// node_modules/mqtt/lib/connect/wx.js
var require_wx = __commonJS({
  "node_modules/mqtt/lib/connect/wx.js"(exports2, module2) {
    "use strict";
    var { Buffer: Buffer2 } = require("buffer");
    var Transform = require_readable().Transform;
    var duplexify = require_duplexify();
    var socketTask;
    var proxy;
    var stream;
    function buildProxy() {
      const proxy2 = new Transform();
      proxy2._write = function(chunk, encoding, next) {
        socketTask.send({
          data: chunk.buffer,
          success: function() {
            next();
          },
          fail: function(errMsg) {
            next(new Error(errMsg));
          }
        });
      };
      proxy2._flush = function socketEnd(done) {
        socketTask.close({
          success: function() {
            done();
          }
        });
      };
      return proxy2;
    }
    function setDefaultOpts(opts) {
      if (!opts.hostname) {
        opts.hostname = "localhost";
      }
      if (!opts.path) {
        opts.path = "/";
      }
      if (!opts.wsOptions) {
        opts.wsOptions = {};
      }
    }
    function buildUrl(opts, client2) {
      const protocol = opts.protocol === "wxs" ? "wss" : "ws";
      let url = protocol + "://" + opts.hostname + opts.path;
      if (opts.port && opts.port !== 80 && opts.port !== 443) {
        url = protocol + "://" + opts.hostname + ":" + opts.port + opts.path;
      }
      if (typeof opts.transformWsUrl === "function") {
        url = opts.transformWsUrl(url, opts, client2);
      }
      return url;
    }
    function bindEventHandler() {
      socketTask.onOpen(function() {
        stream.setReadable(proxy);
        stream.setWritable(proxy);
        stream.emit("connect");
      });
      socketTask.onMessage(function(res) {
        let data = res.data;
        if (data instanceof ArrayBuffer)
          data = Buffer2.from(data);
        else
          data = Buffer2.from(data, "utf8");
        proxy.push(data);
      });
      socketTask.onClose(function() {
        stream.end();
        stream.destroy();
      });
      socketTask.onError(function(res) {
        stream.destroy(new Error(res.errMsg));
      });
    }
    function buildStream(client2, opts) {
      opts.hostname = opts.hostname || opts.host;
      if (!opts.hostname) {
        throw new Error("Could not determine host. Specify host manually.");
      }
      const websocketSubProtocol = opts.protocolId === "MQIsdp" && opts.protocolVersion === 3 ? "mqttv3.1" : "mqtt";
      setDefaultOpts(opts);
      const url = buildUrl(opts, client2);
      socketTask = wx.connectSocket({
        url,
        protocols: [websocketSubProtocol]
      });
      proxy = buildProxy();
      stream = duplexify.obj();
      stream._destroy = function(err, cb) {
        socketTask.close({
          success: function() {
            cb && cb(err);
          }
        });
      };
      const destroyRef = stream.destroy;
      stream.destroy = function() {
        stream.destroy = destroyRef;
        const self2 = this;
        setTimeout(function() {
          socketTask.close({
            fail: function() {
              self2._destroy(new Error());
            }
          });
        }, 0);
      }.bind(stream);
      bindEventHandler();
      return stream;
    }
    module2.exports = buildStream;
  }
});

// node_modules/mqtt/lib/connect/ali.js
var require_ali = __commonJS({
  "node_modules/mqtt/lib/connect/ali.js"(exports2, module2) {
    "use strict";
    var { Buffer: Buffer2 } = require("buffer");
    var Transform = require_readable().Transform;
    var duplexify = require_duplexify();
    var my;
    var proxy;
    var stream;
    var isInitialized = false;
    function buildProxy() {
      const proxy2 = new Transform();
      proxy2._write = function(chunk, encoding, next) {
        my.sendSocketMessage({
          data: chunk.buffer,
          success: function() {
            next();
          },
          fail: function() {
            next(new Error());
          }
        });
      };
      proxy2._flush = function socketEnd(done) {
        my.closeSocket({
          success: function() {
            done();
          }
        });
      };
      return proxy2;
    }
    function setDefaultOpts(opts) {
      if (!opts.hostname) {
        opts.hostname = "localhost";
      }
      if (!opts.path) {
        opts.path = "/";
      }
      if (!opts.wsOptions) {
        opts.wsOptions = {};
      }
    }
    function buildUrl(opts, client2) {
      const protocol = opts.protocol === "alis" ? "wss" : "ws";
      let url = protocol + "://" + opts.hostname + opts.path;
      if (opts.port && opts.port !== 80 && opts.port !== 443) {
        url = protocol + "://" + opts.hostname + ":" + opts.port + opts.path;
      }
      if (typeof opts.transformWsUrl === "function") {
        url = opts.transformWsUrl(url, opts, client2);
      }
      return url;
    }
    function bindEventHandler() {
      if (isInitialized)
        return;
      isInitialized = true;
      my.onSocketOpen(function() {
        stream.setReadable(proxy);
        stream.setWritable(proxy);
        stream.emit("connect");
      });
      my.onSocketMessage(function(res) {
        if (typeof res.data === "string") {
          const buffer = Buffer2.from(res.data, "base64");
          proxy.push(buffer);
        } else {
          const reader = new FileReader();
          reader.addEventListener("load", function() {
            let data = reader.result;
            if (data instanceof ArrayBuffer)
              data = Buffer2.from(data);
            else
              data = Buffer2.from(data, "utf8");
            proxy.push(data);
          });
          reader.readAsArrayBuffer(res.data);
        }
      });
      my.onSocketClose(function() {
        stream.end();
        stream.destroy();
      });
      my.onSocketError(function(res) {
        stream.destroy(res);
      });
    }
    function buildStream(client2, opts) {
      opts.hostname = opts.hostname || opts.host;
      if (!opts.hostname) {
        throw new Error("Could not determine host. Specify host manually.");
      }
      const websocketSubProtocol = opts.protocolId === "MQIsdp" && opts.protocolVersion === 3 ? "mqttv3.1" : "mqtt";
      setDefaultOpts(opts);
      const url = buildUrl(opts, client2);
      my = opts.my;
      my.connectSocket({
        url,
        protocols: websocketSubProtocol
      });
      proxy = buildProxy();
      stream = duplexify.obj();
      bindEventHandler();
      return stream;
    }
    module2.exports = buildStream;
  }
});

// node_modules/mqtt/node_modules/ws/lib/constants.js
var require_constants3 = __commonJS({
  "node_modules/mqtt/node_modules/ws/lib/constants.js"(exports2, module2) {
    "use strict";
    module2.exports = {
      BINARY_TYPES: ["nodebuffer", "arraybuffer", "fragments"],
      GUID: "258EAFA5-E914-47DA-95CA-C5AB0DC85B11",
      kStatusCode: Symbol("status-code"),
      kWebSocket: Symbol("websocket"),
      EMPTY_BUFFER: Buffer.alloc(0),
      NOOP: () => {
      }
    };
  }
});

// node_modules/mqtt/node_modules/ws/lib/buffer-util.js
var require_buffer_util2 = __commonJS({
  "node_modules/mqtt/node_modules/ws/lib/buffer-util.js"(exports2, module2) {
    "use strict";
    var { EMPTY_BUFFER } = require_constants3();
    function concat(list, totalLength) {
      if (list.length === 0)
        return EMPTY_BUFFER;
      if (list.length === 1)
        return list[0];
      const target = Buffer.allocUnsafe(totalLength);
      let offset = 0;
      for (let i = 0; i < list.length; i++) {
        const buf = list[i];
        target.set(buf, offset);
        offset += buf.length;
      }
      if (offset < totalLength)
        return target.slice(0, offset);
      return target;
    }
    function _mask(source, mask, output, offset, length) {
      for (let i = 0; i < length; i++) {
        output[offset + i] = source[i] ^ mask[i & 3];
      }
    }
    function _unmask(buffer, mask) {
      const length = buffer.length;
      for (let i = 0; i < length; i++) {
        buffer[i] ^= mask[i & 3];
      }
    }
    function toArrayBuffer(buf) {
      if (buf.byteLength === buf.buffer.byteLength) {
        return buf.buffer;
      }
      return buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.byteLength);
    }
    function toBuffer(data) {
      toBuffer.readOnly = true;
      if (Buffer.isBuffer(data))
        return data;
      let buf;
      if (data instanceof ArrayBuffer) {
        buf = Buffer.from(data);
      } else if (ArrayBuffer.isView(data)) {
        buf = Buffer.from(data.buffer, data.byteOffset, data.byteLength);
      } else {
        buf = Buffer.from(data);
        toBuffer.readOnly = false;
      }
      return buf;
    }
    try {
      const bufferUtil = require("bufferutil");
      const bu = bufferUtil.BufferUtil || bufferUtil;
      module2.exports = {
        concat,
        mask(source, mask, output, offset, length) {
          if (length < 48)
            _mask(source, mask, output, offset, length);
          else
            bu.mask(source, mask, output, offset, length);
        },
        toArrayBuffer,
        toBuffer,
        unmask(buffer, mask) {
          if (buffer.length < 32)
            _unmask(buffer, mask);
          else
            bu.unmask(buffer, mask);
        }
      };
    } catch (e) {
      module2.exports = {
        concat,
        mask: _mask,
        toArrayBuffer,
        toBuffer,
        unmask: _unmask
      };
    }
  }
});

// node_modules/mqtt/node_modules/ws/lib/limiter.js
var require_limiter2 = __commonJS({
  "node_modules/mqtt/node_modules/ws/lib/limiter.js"(exports2, module2) {
    "use strict";
    var kDone = Symbol("kDone");
    var kRun = Symbol("kRun");
    var Limiter = class {
      /**
       * Creates a new `Limiter`.
       *
       * @param {Number} [concurrency=Infinity] The maximum number of jobs allowed
       *     to run concurrently
       */
      constructor(concurrency) {
        this[kDone] = () => {
          this.pending--;
          this[kRun]();
        };
        this.concurrency = concurrency || Infinity;
        this.jobs = [];
        this.pending = 0;
      }
      /**
       * Adds a job to the queue.
       *
       * @param {Function} job The job to run
       * @public
       */
      add(job) {
        this.jobs.push(job);
        this[kRun]();
      }
      /**
       * Removes a job from the queue and runs it if possible.
       *
       * @private
       */
      [kRun]() {
        if (this.pending === this.concurrency)
          return;
        if (this.jobs.length) {
          const job = this.jobs.shift();
          this.pending++;
          job(this[kDone]);
        }
      }
    };
    module2.exports = Limiter;
  }
});

// node_modules/mqtt/node_modules/ws/lib/permessage-deflate.js
var require_permessage_deflate2 = __commonJS({
  "node_modules/mqtt/node_modules/ws/lib/permessage-deflate.js"(exports2, module2) {
    "use strict";
    var zlib = require("zlib");
    var bufferUtil = require_buffer_util2();
    var Limiter = require_limiter2();
    var { kStatusCode, NOOP } = require_constants3();
    var TRAILER = Buffer.from([0, 0, 255, 255]);
    var kPerMessageDeflate = Symbol("permessage-deflate");
    var kTotalLength = Symbol("total-length");
    var kCallback = Symbol("callback");
    var kBuffers = Symbol("buffers");
    var kError = Symbol("error");
    var zlibLimiter;
    var PerMessageDeflate = class {
      /**
       * Creates a PerMessageDeflate instance.
       *
       * @param {Object} [options] Configuration options
       * @param {Boolean} [options.serverNoContextTakeover=false] Request/accept
       *     disabling of server context takeover
       * @param {Boolean} [options.clientNoContextTakeover=false] Advertise/
       *     acknowledge disabling of client context takeover
       * @param {(Boolean|Number)} [options.serverMaxWindowBits] Request/confirm the
       *     use of a custom server window size
       * @param {(Boolean|Number)} [options.clientMaxWindowBits] Advertise support
       *     for, or request, a custom client window size
       * @param {Object} [options.zlibDeflateOptions] Options to pass to zlib on
       *     deflate
       * @param {Object} [options.zlibInflateOptions] Options to pass to zlib on
       *     inflate
       * @param {Number} [options.threshold=1024] Size (in bytes) below which
       *     messages should not be compressed
       * @param {Number} [options.concurrencyLimit=10] The number of concurrent
       *     calls to zlib
       * @param {Boolean} [isServer=false] Create the instance in either server or
       *     client mode
       * @param {Number} [maxPayload=0] The maximum allowed message length
       */
      constructor(options, isServer, maxPayload) {
        this._maxPayload = maxPayload | 0;
        this._options = options || {};
        this._threshold = this._options.threshold !== void 0 ? this._options.threshold : 1024;
        this._isServer = !!isServer;
        this._deflate = null;
        this._inflate = null;
        this.params = null;
        if (!zlibLimiter) {
          const concurrency = this._options.concurrencyLimit !== void 0 ? this._options.concurrencyLimit : 10;
          zlibLimiter = new Limiter(concurrency);
        }
      }
      /**
       * @type {String}
       */
      static get extensionName() {
        return "permessage-deflate";
      }
      /**
       * Create an extension negotiation offer.
       *
       * @return {Object} Extension parameters
       * @public
       */
      offer() {
        const params = {};
        if (this._options.serverNoContextTakeover) {
          params.server_no_context_takeover = true;
        }
        if (this._options.clientNoContextTakeover) {
          params.client_no_context_takeover = true;
        }
        if (this._options.serverMaxWindowBits) {
          params.server_max_window_bits = this._options.serverMaxWindowBits;
        }
        if (this._options.clientMaxWindowBits) {
          params.client_max_window_bits = this._options.clientMaxWindowBits;
        } else if (this._options.clientMaxWindowBits == null) {
          params.client_max_window_bits = true;
        }
        return params;
      }
      /**
       * Accept an extension negotiation offer/response.
       *
       * @param {Array} configurations The extension negotiation offers/reponse
       * @return {Object} Accepted configuration
       * @public
       */
      accept(configurations) {
        configurations = this.normalizeParams(configurations);
        this.params = this._isServer ? this.acceptAsServer(configurations) : this.acceptAsClient(configurations);
        return this.params;
      }
      /**
       * Releases all resources used by the extension.
       *
       * @public
       */
      cleanup() {
        if (this._inflate) {
          this._inflate.close();
          this._inflate = null;
        }
        if (this._deflate) {
          const callback = this._deflate[kCallback];
          this._deflate.close();
          this._deflate = null;
          if (callback) {
            callback(
              new Error(
                "The deflate stream was closed while data was being processed"
              )
            );
          }
        }
      }
      /**
       *  Accept an extension negotiation offer.
       *
       * @param {Array} offers The extension negotiation offers
       * @return {Object} Accepted configuration
       * @private
       */
      acceptAsServer(offers) {
        const opts = this._options;
        const accepted = offers.find((params) => {
          if (opts.serverNoContextTakeover === false && params.server_no_context_takeover || params.server_max_window_bits && (opts.serverMaxWindowBits === false || typeof opts.serverMaxWindowBits === "number" && opts.serverMaxWindowBits > params.server_max_window_bits) || typeof opts.clientMaxWindowBits === "number" && !params.client_max_window_bits) {
            return false;
          }
          return true;
        });
        if (!accepted) {
          throw new Error("None of the extension offers can be accepted");
        }
        if (opts.serverNoContextTakeover) {
          accepted.server_no_context_takeover = true;
        }
        if (opts.clientNoContextTakeover) {
          accepted.client_no_context_takeover = true;
        }
        if (typeof opts.serverMaxWindowBits === "number") {
          accepted.server_max_window_bits = opts.serverMaxWindowBits;
        }
        if (typeof opts.clientMaxWindowBits === "number") {
          accepted.client_max_window_bits = opts.clientMaxWindowBits;
        } else if (accepted.client_max_window_bits === true || opts.clientMaxWindowBits === false) {
          delete accepted.client_max_window_bits;
        }
        return accepted;
      }
      /**
       * Accept the extension negotiation response.
       *
       * @param {Array} response The extension negotiation response
       * @return {Object} Accepted configuration
       * @private
       */
      acceptAsClient(response) {
        const params = response[0];
        if (this._options.clientNoContextTakeover === false && params.client_no_context_takeover) {
          throw new Error('Unexpected parameter "client_no_context_takeover"');
        }
        if (!params.client_max_window_bits) {
          if (typeof this._options.clientMaxWindowBits === "number") {
            params.client_max_window_bits = this._options.clientMaxWindowBits;
          }
        } else if (this._options.clientMaxWindowBits === false || typeof this._options.clientMaxWindowBits === "number" && params.client_max_window_bits > this._options.clientMaxWindowBits) {
          throw new Error(
            'Unexpected or invalid parameter "client_max_window_bits"'
          );
        }
        return params;
      }
      /**
       * Normalize parameters.
       *
       * @param {Array} configurations The extension negotiation offers/reponse
       * @return {Array} The offers/response with normalized parameters
       * @private
       */
      normalizeParams(configurations) {
        configurations.forEach((params) => {
          Object.keys(params).forEach((key) => {
            let value = params[key];
            if (value.length > 1) {
              throw new Error(`Parameter "${key}" must have only a single value`);
            }
            value = value[0];
            if (key === "client_max_window_bits") {
              if (value !== true) {
                const num = +value;
                if (!Number.isInteger(num) || num < 8 || num > 15) {
                  throw new TypeError(
                    `Invalid value for parameter "${key}": ${value}`
                  );
                }
                value = num;
              } else if (!this._isServer) {
                throw new TypeError(
                  `Invalid value for parameter "${key}": ${value}`
                );
              }
            } else if (key === "server_max_window_bits") {
              const num = +value;
              if (!Number.isInteger(num) || num < 8 || num > 15) {
                throw new TypeError(
                  `Invalid value for parameter "${key}": ${value}`
                );
              }
              value = num;
            } else if (key === "client_no_context_takeover" || key === "server_no_context_takeover") {
              if (value !== true) {
                throw new TypeError(
                  `Invalid value for parameter "${key}": ${value}`
                );
              }
            } else {
              throw new Error(`Unknown parameter "${key}"`);
            }
            params[key] = value;
          });
        });
        return configurations;
      }
      /**
       * Decompress data. Concurrency limited.
       *
       * @param {Buffer} data Compressed data
       * @param {Boolean} fin Specifies whether or not this is the last fragment
       * @param {Function} callback Callback
       * @public
       */
      decompress(data, fin, callback) {
        zlibLimiter.add((done) => {
          this._decompress(data, fin, (err, result2) => {
            done();
            callback(err, result2);
          });
        });
      }
      /**
       * Compress data. Concurrency limited.
       *
       * @param {Buffer} data Data to compress
       * @param {Boolean} fin Specifies whether or not this is the last fragment
       * @param {Function} callback Callback
       * @public
       */
      compress(data, fin, callback) {
        zlibLimiter.add((done) => {
          this._compress(data, fin, (err, result2) => {
            done();
            callback(err, result2);
          });
        });
      }
      /**
       * Decompress data.
       *
       * @param {Buffer} data Compressed data
       * @param {Boolean} fin Specifies whether or not this is the last fragment
       * @param {Function} callback Callback
       * @private
       */
      _decompress(data, fin, callback) {
        const endpoint = this._isServer ? "client" : "server";
        if (!this._inflate) {
          const key = `${endpoint}_max_window_bits`;
          const windowBits = typeof this.params[key] !== "number" ? zlib.Z_DEFAULT_WINDOWBITS : this.params[key];
          this._inflate = zlib.createInflateRaw({
            ...this._options.zlibInflateOptions,
            windowBits
          });
          this._inflate[kPerMessageDeflate] = this;
          this._inflate[kTotalLength] = 0;
          this._inflate[kBuffers] = [];
          this._inflate.on("error", inflateOnError);
          this._inflate.on("data", inflateOnData);
        }
        this._inflate[kCallback] = callback;
        this._inflate.write(data);
        if (fin)
          this._inflate.write(TRAILER);
        this._inflate.flush(() => {
          const err = this._inflate[kError];
          if (err) {
            this._inflate.close();
            this._inflate = null;
            callback(err);
            return;
          }
          const data2 = bufferUtil.concat(
            this._inflate[kBuffers],
            this._inflate[kTotalLength]
          );
          if (this._inflate._readableState.endEmitted) {
            this._inflate.close();
            this._inflate = null;
          } else {
            this._inflate[kTotalLength] = 0;
            this._inflate[kBuffers] = [];
            if (fin && this.params[`${endpoint}_no_context_takeover`]) {
              this._inflate.reset();
            }
          }
          callback(null, data2);
        });
      }
      /**
       * Compress data.
       *
       * @param {Buffer} data Data to compress
       * @param {Boolean} fin Specifies whether or not this is the last fragment
       * @param {Function} callback Callback
       * @private
       */
      _compress(data, fin, callback) {
        const endpoint = this._isServer ? "server" : "client";
        if (!this._deflate) {
          const key = `${endpoint}_max_window_bits`;
          const windowBits = typeof this.params[key] !== "number" ? zlib.Z_DEFAULT_WINDOWBITS : this.params[key];
          this._deflate = zlib.createDeflateRaw({
            ...this._options.zlibDeflateOptions,
            windowBits
          });
          this._deflate[kTotalLength] = 0;
          this._deflate[kBuffers] = [];
          this._deflate.on("error", NOOP);
          this._deflate.on("data", deflateOnData);
        }
        this._deflate[kCallback] = callback;
        this._deflate.write(data);
        this._deflate.flush(zlib.Z_SYNC_FLUSH, () => {
          if (!this._deflate) {
            return;
          }
          let data2 = bufferUtil.concat(
            this._deflate[kBuffers],
            this._deflate[kTotalLength]
          );
          if (fin)
            data2 = data2.slice(0, data2.length - 4);
          this._deflate[kCallback] = null;
          this._deflate[kTotalLength] = 0;
          this._deflate[kBuffers] = [];
          if (fin && this.params[`${endpoint}_no_context_takeover`]) {
            this._deflate.reset();
          }
          callback(null, data2);
        });
      }
    };
    module2.exports = PerMessageDeflate;
    function deflateOnData(chunk) {
      this[kBuffers].push(chunk);
      this[kTotalLength] += chunk.length;
    }
    function inflateOnData(chunk) {
      this[kTotalLength] += chunk.length;
      if (this[kPerMessageDeflate]._maxPayload < 1 || this[kTotalLength] <= this[kPerMessageDeflate]._maxPayload) {
        this[kBuffers].push(chunk);
        return;
      }
      this[kError] = new RangeError("Max payload size exceeded");
      this[kError].code = "WS_ERR_UNSUPPORTED_MESSAGE_LENGTH";
      this[kError][kStatusCode] = 1009;
      this.removeListener("data", inflateOnData);
      this.reset();
    }
    function inflateOnError(err) {
      this[kPerMessageDeflate]._inflate = null;
      err[kStatusCode] = 1007;
      this[kCallback](err);
    }
  }
});

// node_modules/mqtt/node_modules/ws/lib/validation.js
var require_validation2 = __commonJS({
  "node_modules/mqtt/node_modules/ws/lib/validation.js"(exports2, module2) {
    "use strict";
    function isValidStatusCode(code) {
      return code >= 1e3 && code <= 1014 && code !== 1004 && code !== 1005 && code !== 1006 || code >= 3e3 && code <= 4999;
    }
    function _isValidUTF8(buf) {
      const len = buf.length;
      let i = 0;
      while (i < len) {
        if ((buf[i] & 128) === 0) {
          i++;
        } else if ((buf[i] & 224) === 192) {
          if (i + 1 === len || (buf[i + 1] & 192) !== 128 || (buf[i] & 254) === 192) {
            return false;
          }
          i += 2;
        } else if ((buf[i] & 240) === 224) {
          if (i + 2 >= len || (buf[i + 1] & 192) !== 128 || (buf[i + 2] & 192) !== 128 || buf[i] === 224 && (buf[i + 1] & 224) === 128 || // Overlong
          buf[i] === 237 && (buf[i + 1] & 224) === 160) {
            return false;
          }
          i += 3;
        } else if ((buf[i] & 248) === 240) {
          if (i + 3 >= len || (buf[i + 1] & 192) !== 128 || (buf[i + 2] & 192) !== 128 || (buf[i + 3] & 192) !== 128 || buf[i] === 240 && (buf[i + 1] & 240) === 128 || // Overlong
          buf[i] === 244 && buf[i + 1] > 143 || buf[i] > 244) {
            return false;
          }
          i += 4;
        } else {
          return false;
        }
      }
      return true;
    }
    try {
      let isValidUTF8 = require("utf-8-validate");
      if (typeof isValidUTF8 === "object") {
        isValidUTF8 = isValidUTF8.Validation.isValidUTF8;
      }
      module2.exports = {
        isValidStatusCode,
        isValidUTF8(buf) {
          return buf.length < 150 ? _isValidUTF8(buf) : isValidUTF8(buf);
        }
      };
    } catch (e) {
      module2.exports = {
        isValidStatusCode,
        isValidUTF8: _isValidUTF8
      };
    }
  }
});

// node_modules/mqtt/node_modules/ws/lib/receiver.js
var require_receiver2 = __commonJS({
  "node_modules/mqtt/node_modules/ws/lib/receiver.js"(exports2, module2) {
    "use strict";
    var { Writable } = require("stream");
    var PerMessageDeflate = require_permessage_deflate2();
    var {
      BINARY_TYPES,
      EMPTY_BUFFER,
      kStatusCode,
      kWebSocket
    } = require_constants3();
    var { concat, toArrayBuffer, unmask } = require_buffer_util2();
    var { isValidStatusCode, isValidUTF8 } = require_validation2();
    var GET_INFO = 0;
    var GET_PAYLOAD_LENGTH_16 = 1;
    var GET_PAYLOAD_LENGTH_64 = 2;
    var GET_MASK = 3;
    var GET_DATA = 4;
    var INFLATING = 5;
    var Receiver2 = class extends Writable {
      /**
       * Creates a Receiver instance.
       *
       * @param {String} [binaryType=nodebuffer] The type for binary data
       * @param {Object} [extensions] An object containing the negotiated extensions
       * @param {Boolean} [isServer=false] Specifies whether to operate in client or
       *     server mode
       * @param {Number} [maxPayload=0] The maximum allowed message length
       */
      constructor(binaryType, extensions2, isServer, maxPayload) {
        super();
        this._binaryType = binaryType || BINARY_TYPES[0];
        this[kWebSocket] = void 0;
        this._extensions = extensions2 || {};
        this._isServer = !!isServer;
        this._maxPayload = maxPayload | 0;
        this._bufferedBytes = 0;
        this._buffers = [];
        this._compressed = false;
        this._payloadLength = 0;
        this._mask = void 0;
        this._fragmented = 0;
        this._masked = false;
        this._fin = false;
        this._opcode = 0;
        this._totalPayloadLength = 0;
        this._messageLength = 0;
        this._fragments = [];
        this._state = GET_INFO;
        this._loop = false;
      }
      /**
       * Implements `Writable.prototype._write()`.
       *
       * @param {Buffer} chunk The chunk of data to write
       * @param {String} encoding The character encoding of `chunk`
       * @param {Function} cb Callback
       * @private
       */
      _write(chunk, encoding, cb) {
        if (this._opcode === 8 && this._state == GET_INFO)
          return cb();
        this._bufferedBytes += chunk.length;
        this._buffers.push(chunk);
        this.startLoop(cb);
      }
      /**
       * Consumes `n` bytes from the buffered data.
       *
       * @param {Number} n The number of bytes to consume
       * @return {Buffer} The consumed bytes
       * @private
       */
      consume(n) {
        this._bufferedBytes -= n;
        if (n === this._buffers[0].length)
          return this._buffers.shift();
        if (n < this._buffers[0].length) {
          const buf = this._buffers[0];
          this._buffers[0] = buf.slice(n);
          return buf.slice(0, n);
        }
        const dst = Buffer.allocUnsafe(n);
        do {
          const buf = this._buffers[0];
          const offset = dst.length - n;
          if (n >= buf.length) {
            dst.set(this._buffers.shift(), offset);
          } else {
            dst.set(new Uint8Array(buf.buffer, buf.byteOffset, n), offset);
            this._buffers[0] = buf.slice(n);
          }
          n -= buf.length;
        } while (n > 0);
        return dst;
      }
      /**
       * Starts the parsing loop.
       *
       * @param {Function} cb Callback
       * @private
       */
      startLoop(cb) {
        let err;
        this._loop = true;
        do {
          switch (this._state) {
            case GET_INFO:
              err = this.getInfo();
              break;
            case GET_PAYLOAD_LENGTH_16:
              err = this.getPayloadLength16();
              break;
            case GET_PAYLOAD_LENGTH_64:
              err = this.getPayloadLength64();
              break;
            case GET_MASK:
              this.getMask();
              break;
            case GET_DATA:
              err = this.getData(cb);
              break;
            default:
              this._loop = false;
              return;
          }
        } while (this._loop);
        cb(err);
      }
      /**
       * Reads the first two bytes of a frame.
       *
       * @return {(RangeError|undefined)} A possible error
       * @private
       */
      getInfo() {
        if (this._bufferedBytes < 2) {
          this._loop = false;
          return;
        }
        const buf = this.consume(2);
        if ((buf[0] & 48) !== 0) {
          this._loop = false;
          return error(
            RangeError,
            "RSV2 and RSV3 must be clear",
            true,
            1002,
            "WS_ERR_UNEXPECTED_RSV_2_3"
          );
        }
        const compressed = (buf[0] & 64) === 64;
        if (compressed && !this._extensions[PerMessageDeflate.extensionName]) {
          this._loop = false;
          return error(
            RangeError,
            "RSV1 must be clear",
            true,
            1002,
            "WS_ERR_UNEXPECTED_RSV_1"
          );
        }
        this._fin = (buf[0] & 128) === 128;
        this._opcode = buf[0] & 15;
        this._payloadLength = buf[1] & 127;
        if (this._opcode === 0) {
          if (compressed) {
            this._loop = false;
            return error(
              RangeError,
              "RSV1 must be clear",
              true,
              1002,
              "WS_ERR_UNEXPECTED_RSV_1"
            );
          }
          if (!this._fragmented) {
            this._loop = false;
            return error(
              RangeError,
              "invalid opcode 0",
              true,
              1002,
              "WS_ERR_INVALID_OPCODE"
            );
          }
          this._opcode = this._fragmented;
        } else if (this._opcode === 1 || this._opcode === 2) {
          if (this._fragmented) {
            this._loop = false;
            return error(
              RangeError,
              `invalid opcode ${this._opcode}`,
              true,
              1002,
              "WS_ERR_INVALID_OPCODE"
            );
          }
          this._compressed = compressed;
        } else if (this._opcode > 7 && this._opcode < 11) {
          if (!this._fin) {
            this._loop = false;
            return error(
              RangeError,
              "FIN must be set",
              true,
              1002,
              "WS_ERR_EXPECTED_FIN"
            );
          }
          if (compressed) {
            this._loop = false;
            return error(
              RangeError,
              "RSV1 must be clear",
              true,
              1002,
              "WS_ERR_UNEXPECTED_RSV_1"
            );
          }
          if (this._payloadLength > 125) {
            this._loop = false;
            return error(
              RangeError,
              `invalid payload length ${this._payloadLength}`,
              true,
              1002,
              "WS_ERR_INVALID_CONTROL_PAYLOAD_LENGTH"
            );
          }
        } else {
          this._loop = false;
          return error(
            RangeError,
            `invalid opcode ${this._opcode}`,
            true,
            1002,
            "WS_ERR_INVALID_OPCODE"
          );
        }
        if (!this._fin && !this._fragmented)
          this._fragmented = this._opcode;
        this._masked = (buf[1] & 128) === 128;
        if (this._isServer) {
          if (!this._masked) {
            this._loop = false;
            return error(
              RangeError,
              "MASK must be set",
              true,
              1002,
              "WS_ERR_EXPECTED_MASK"
            );
          }
        } else if (this._masked) {
          this._loop = false;
          return error(
            RangeError,
            "MASK must be clear",
            true,
            1002,
            "WS_ERR_UNEXPECTED_MASK"
          );
        }
        if (this._payloadLength === 126)
          this._state = GET_PAYLOAD_LENGTH_16;
        else if (this._payloadLength === 127)
          this._state = GET_PAYLOAD_LENGTH_64;
        else
          return this.haveLength();
      }
      /**
       * Gets extended payload length (7+16).
       *
       * @return {(RangeError|undefined)} A possible error
       * @private
       */
      getPayloadLength16() {
        if (this._bufferedBytes < 2) {
          this._loop = false;
          return;
        }
        this._payloadLength = this.consume(2).readUInt16BE(0);
        return this.haveLength();
      }
      /**
       * Gets extended payload length (7+64).
       *
       * @return {(RangeError|undefined)} A possible error
       * @private
       */
      getPayloadLength64() {
        if (this._bufferedBytes < 8) {
          this._loop = false;
          return;
        }
        const buf = this.consume(8);
        const num = buf.readUInt32BE(0);
        if (num > Math.pow(2, 53 - 32) - 1) {
          this._loop = false;
          return error(
            RangeError,
            "Unsupported WebSocket frame: payload length > 2^53 - 1",
            false,
            1009,
            "WS_ERR_UNSUPPORTED_DATA_PAYLOAD_LENGTH"
          );
        }
        this._payloadLength = num * Math.pow(2, 32) + buf.readUInt32BE(4);
        return this.haveLength();
      }
      /**
       * Payload length has been read.
       *
       * @return {(RangeError|undefined)} A possible error
       * @private
       */
      haveLength() {
        if (this._payloadLength && this._opcode < 8) {
          this._totalPayloadLength += this._payloadLength;
          if (this._totalPayloadLength > this._maxPayload && this._maxPayload > 0) {
            this._loop = false;
            return error(
              RangeError,
              "Max payload size exceeded",
              false,
              1009,
              "WS_ERR_UNSUPPORTED_MESSAGE_LENGTH"
            );
          }
        }
        if (this._masked)
          this._state = GET_MASK;
        else
          this._state = GET_DATA;
      }
      /**
       * Reads mask bytes.
       *
       * @private
       */
      getMask() {
        if (this._bufferedBytes < 4) {
          this._loop = false;
          return;
        }
        this._mask = this.consume(4);
        this._state = GET_DATA;
      }
      /**
       * Reads data bytes.
       *
       * @param {Function} cb Callback
       * @return {(Error|RangeError|undefined)} A possible error
       * @private
       */
      getData(cb) {
        let data = EMPTY_BUFFER;
        if (this._payloadLength) {
          if (this._bufferedBytes < this._payloadLength) {
            this._loop = false;
            return;
          }
          data = this.consume(this._payloadLength);
          if (this._masked)
            unmask(data, this._mask);
        }
        if (this._opcode > 7)
          return this.controlMessage(data);
        if (this._compressed) {
          this._state = INFLATING;
          this.decompress(data, cb);
          return;
        }
        if (data.length) {
          this._messageLength = this._totalPayloadLength;
          this._fragments.push(data);
        }
        return this.dataMessage();
      }
      /**
       * Decompresses data.
       *
       * @param {Buffer} data Compressed data
       * @param {Function} cb Callback
       * @private
       */
      decompress(data, cb) {
        const perMessageDeflate = this._extensions[PerMessageDeflate.extensionName];
        perMessageDeflate.decompress(data, this._fin, (err, buf) => {
          if (err)
            return cb(err);
          if (buf.length) {
            this._messageLength += buf.length;
            if (this._messageLength > this._maxPayload && this._maxPayload > 0) {
              return cb(
                error(
                  RangeError,
                  "Max payload size exceeded",
                  false,
                  1009,
                  "WS_ERR_UNSUPPORTED_MESSAGE_LENGTH"
                )
              );
            }
            this._fragments.push(buf);
          }
          const er = this.dataMessage();
          if (er)
            return cb(er);
          this.startLoop(cb);
        });
      }
      /**
       * Handles a data message.
       *
       * @return {(Error|undefined)} A possible error
       * @private
       */
      dataMessage() {
        if (this._fin) {
          const messageLength = this._messageLength;
          const fragments = this._fragments;
          this._totalPayloadLength = 0;
          this._messageLength = 0;
          this._fragmented = 0;
          this._fragments = [];
          if (this._opcode === 2) {
            let data;
            if (this._binaryType === "nodebuffer") {
              data = concat(fragments, messageLength);
            } else if (this._binaryType === "arraybuffer") {
              data = toArrayBuffer(concat(fragments, messageLength));
            } else {
              data = fragments;
            }
            this.emit("message", data);
          } else {
            const buf = concat(fragments, messageLength);
            if (!isValidUTF8(buf)) {
              this._loop = false;
              return error(
                Error,
                "invalid UTF-8 sequence",
                true,
                1007,
                "WS_ERR_INVALID_UTF8"
              );
            }
            this.emit("message", buf.toString());
          }
        }
        this._state = GET_INFO;
      }
      /**
       * Handles a control message.
       *
       * @param {Buffer} data Data to handle
       * @return {(Error|RangeError|undefined)} A possible error
       * @private
       */
      controlMessage(data) {
        if (this._opcode === 8) {
          this._loop = false;
          if (data.length === 0) {
            this.emit("conclude", 1005, "");
            this.end();
          } else if (data.length === 1) {
            return error(
              RangeError,
              "invalid payload length 1",
              true,
              1002,
              "WS_ERR_INVALID_CONTROL_PAYLOAD_LENGTH"
            );
          } else {
            const code = data.readUInt16BE(0);
            if (!isValidStatusCode(code)) {
              return error(
                RangeError,
                `invalid status code ${code}`,
                true,
                1002,
                "WS_ERR_INVALID_CLOSE_CODE"
              );
            }
            const buf = data.slice(2);
            if (!isValidUTF8(buf)) {
              return error(
                Error,
                "invalid UTF-8 sequence",
                true,
                1007,
                "WS_ERR_INVALID_UTF8"
              );
            }
            this.emit("conclude", code, buf.toString());
            this.end();
          }
        } else if (this._opcode === 9) {
          this.emit("ping", data);
        } else {
          this.emit("pong", data);
        }
        this._state = GET_INFO;
      }
    };
    module2.exports = Receiver2;
    function error(ErrorCtor, message, prefix, statusCode, errorCode) {
      const err = new ErrorCtor(
        prefix ? `Invalid WebSocket frame: ${message}` : message
      );
      Error.captureStackTrace(err, error);
      err.code = errorCode;
      err[kStatusCode] = statusCode;
      return err;
    }
  }
});

// node_modules/mqtt/node_modules/ws/lib/sender.js
var require_sender2 = __commonJS({
  "node_modules/mqtt/node_modules/ws/lib/sender.js"(exports2, module2) {
    "use strict";
    var net = require("net");
    var tls = require("tls");
    var { randomFillSync } = require("crypto");
    var PerMessageDeflate = require_permessage_deflate2();
    var { EMPTY_BUFFER } = require_constants3();
    var { isValidStatusCode } = require_validation2();
    var { mask: applyMask, toBuffer } = require_buffer_util2();
    var mask = Buffer.alloc(4);
    var Sender2 = class _Sender {
      /**
       * Creates a Sender instance.
       *
       * @param {(net.Socket|tls.Socket)} socket The connection socket
       * @param {Object} [extensions] An object containing the negotiated extensions
       */
      constructor(socket, extensions2) {
        this._extensions = extensions2 || {};
        this._socket = socket;
        this._firstFragment = true;
        this._compress = false;
        this._bufferedBytes = 0;
        this._deflating = false;
        this._queue = [];
      }
      /**
       * Frames a piece of data according to the HyBi WebSocket protocol.
       *
       * @param {Buffer} data The data to frame
       * @param {Object} options Options object
       * @param {Number} options.opcode The opcode
       * @param {Boolean} [options.readOnly=false] Specifies whether `data` can be
       *     modified
       * @param {Boolean} [options.fin=false] Specifies whether or not to set the
       *     FIN bit
       * @param {Boolean} [options.mask=false] Specifies whether or not to mask
       *     `data`
       * @param {Boolean} [options.rsv1=false] Specifies whether or not to set the
       *     RSV1 bit
       * @return {Buffer[]} The framed data as a list of `Buffer` instances
       * @public
       */
      static frame(data, options) {
        const merge = options.mask && options.readOnly;
        let offset = options.mask ? 6 : 2;
        let payloadLength = data.length;
        if (data.length >= 65536) {
          offset += 8;
          payloadLength = 127;
        } else if (data.length > 125) {
          offset += 2;
          payloadLength = 126;
        }
        const target = Buffer.allocUnsafe(merge ? data.length + offset : offset);
        target[0] = options.fin ? options.opcode | 128 : options.opcode;
        if (options.rsv1)
          target[0] |= 64;
        target[1] = payloadLength;
        if (payloadLength === 126) {
          target.writeUInt16BE(data.length, 2);
        } else if (payloadLength === 127) {
          target.writeUInt32BE(0, 2);
          target.writeUInt32BE(data.length, 6);
        }
        if (!options.mask)
          return [target, data];
        randomFillSync(mask, 0, 4);
        target[1] |= 128;
        target[offset - 4] = mask[0];
        target[offset - 3] = mask[1];
        target[offset - 2] = mask[2];
        target[offset - 1] = mask[3];
        if (merge) {
          applyMask(data, mask, target, offset, data.length);
          return [target];
        }
        applyMask(data, mask, data, 0, data.length);
        return [target, data];
      }
      /**
       * Sends a close message to the other peer.
       *
       * @param {Number} [code] The status code component of the body
       * @param {String} [data] The message component of the body
       * @param {Boolean} [mask=false] Specifies whether or not to mask the message
       * @param {Function} [cb] Callback
       * @public
       */
      close(code, data, mask2, cb) {
        let buf;
        if (code === void 0) {
          buf = EMPTY_BUFFER;
        } else if (typeof code !== "number" || !isValidStatusCode(code)) {
          throw new TypeError("First argument must be a valid error code number");
        } else if (data === void 0 || data === "") {
          buf = Buffer.allocUnsafe(2);
          buf.writeUInt16BE(code, 0);
        } else {
          const length = Buffer.byteLength(data);
          if (length > 123) {
            throw new RangeError("The message must not be greater than 123 bytes");
          }
          buf = Buffer.allocUnsafe(2 + length);
          buf.writeUInt16BE(code, 0);
          buf.write(data, 2);
        }
        if (this._deflating) {
          this.enqueue([this.doClose, buf, mask2, cb]);
        } else {
          this.doClose(buf, mask2, cb);
        }
      }
      /**
       * Frames and sends a close message.
       *
       * @param {Buffer} data The message to send
       * @param {Boolean} [mask=false] Specifies whether or not to mask `data`
       * @param {Function} [cb] Callback
       * @private
       */
      doClose(data, mask2, cb) {
        this.sendFrame(
          _Sender.frame(data, {
            fin: true,
            rsv1: false,
            opcode: 8,
            mask: mask2,
            readOnly: false
          }),
          cb
        );
      }
      /**
       * Sends a ping message to the other peer.
       *
       * @param {*} data The message to send
       * @param {Boolean} [mask=false] Specifies whether or not to mask `data`
       * @param {Function} [cb] Callback
       * @public
       */
      ping(data, mask2, cb) {
        const buf = toBuffer(data);
        if (buf.length > 125) {
          throw new RangeError("The data size must not be greater than 125 bytes");
        }
        if (this._deflating) {
          this.enqueue([this.doPing, buf, mask2, toBuffer.readOnly, cb]);
        } else {
          this.doPing(buf, mask2, toBuffer.readOnly, cb);
        }
      }
      /**
       * Frames and sends a ping message.
       *
       * @param {Buffer} data The message to send
       * @param {Boolean} [mask=false] Specifies whether or not to mask `data`
       * @param {Boolean} [readOnly=false] Specifies whether `data` can be modified
       * @param {Function} [cb] Callback
       * @private
       */
      doPing(data, mask2, readOnly, cb) {
        this.sendFrame(
          _Sender.frame(data, {
            fin: true,
            rsv1: false,
            opcode: 9,
            mask: mask2,
            readOnly
          }),
          cb
        );
      }
      /**
       * Sends a pong message to the other peer.
       *
       * @param {*} data The message to send
       * @param {Boolean} [mask=false] Specifies whether or not to mask `data`
       * @param {Function} [cb] Callback
       * @public
       */
      pong(data, mask2, cb) {
        const buf = toBuffer(data);
        if (buf.length > 125) {
          throw new RangeError("The data size must not be greater than 125 bytes");
        }
        if (this._deflating) {
          this.enqueue([this.doPong, buf, mask2, toBuffer.readOnly, cb]);
        } else {
          this.doPong(buf, mask2, toBuffer.readOnly, cb);
        }
      }
      /**
       * Frames and sends a pong message.
       *
       * @param {Buffer} data The message to send
       * @param {Boolean} [mask=false] Specifies whether or not to mask `data`
       * @param {Boolean} [readOnly=false] Specifies whether `data` can be modified
       * @param {Function} [cb] Callback
       * @private
       */
      doPong(data, mask2, readOnly, cb) {
        this.sendFrame(
          _Sender.frame(data, {
            fin: true,
            rsv1: false,
            opcode: 10,
            mask: mask2,
            readOnly
          }),
          cb
        );
      }
      /**
       * Sends a data message to the other peer.
       *
       * @param {*} data The message to send
       * @param {Object} options Options object
       * @param {Boolean} [options.compress=false] Specifies whether or not to
       *     compress `data`
       * @param {Boolean} [options.binary=false] Specifies whether `data` is binary
       *     or text
       * @param {Boolean} [options.fin=false] Specifies whether the fragment is the
       *     last one
       * @param {Boolean} [options.mask=false] Specifies whether or not to mask
       *     `data`
       * @param {Function} [cb] Callback
       * @public
       */
      send(data, options, cb) {
        const buf = toBuffer(data);
        const perMessageDeflate = this._extensions[PerMessageDeflate.extensionName];
        let opcode = options.binary ? 2 : 1;
        let rsv1 = options.compress;
        if (this._firstFragment) {
          this._firstFragment = false;
          if (rsv1 && perMessageDeflate) {
            rsv1 = buf.length >= perMessageDeflate._threshold;
          }
          this._compress = rsv1;
        } else {
          rsv1 = false;
          opcode = 0;
        }
        if (options.fin)
          this._firstFragment = true;
        if (perMessageDeflate) {
          const opts = {
            fin: options.fin,
            rsv1,
            opcode,
            mask: options.mask,
            readOnly: toBuffer.readOnly
          };
          if (this._deflating) {
            this.enqueue([this.dispatch, buf, this._compress, opts, cb]);
          } else {
            this.dispatch(buf, this._compress, opts, cb);
          }
        } else {
          this.sendFrame(
            _Sender.frame(buf, {
              fin: options.fin,
              rsv1: false,
              opcode,
              mask: options.mask,
              readOnly: toBuffer.readOnly
            }),
            cb
          );
        }
      }
      /**
       * Dispatches a data message.
       *
       * @param {Buffer} data The message to send
       * @param {Boolean} [compress=false] Specifies whether or not to compress
       *     `data`
       * @param {Object} options Options object
       * @param {Number} options.opcode The opcode
       * @param {Boolean} [options.readOnly=false] Specifies whether `data` can be
       *     modified
       * @param {Boolean} [options.fin=false] Specifies whether or not to set the
       *     FIN bit
       * @param {Boolean} [options.mask=false] Specifies whether or not to mask
       *     `data`
       * @param {Boolean} [options.rsv1=false] Specifies whether or not to set the
       *     RSV1 bit
       * @param {Function} [cb] Callback
       * @private
       */
      dispatch(data, compress, options, cb) {
        if (!compress) {
          this.sendFrame(_Sender.frame(data, options), cb);
          return;
        }
        const perMessageDeflate = this._extensions[PerMessageDeflate.extensionName];
        this._bufferedBytes += data.length;
        this._deflating = true;
        perMessageDeflate.compress(data, options.fin, (_, buf) => {
          if (this._socket.destroyed) {
            const err = new Error(
              "The socket was closed while data was being compressed"
            );
            if (typeof cb === "function")
              cb(err);
            for (let i = 0; i < this._queue.length; i++) {
              const callback = this._queue[i][4];
              if (typeof callback === "function")
                callback(err);
            }
            return;
          }
          this._bufferedBytes -= data.length;
          this._deflating = false;
          options.readOnly = false;
          this.sendFrame(_Sender.frame(buf, options), cb);
          this.dequeue();
        });
      }
      /**
       * Executes queued send operations.
       *
       * @private
       */
      dequeue() {
        while (!this._deflating && this._queue.length) {
          const params = this._queue.shift();
          this._bufferedBytes -= params[1].length;
          Reflect.apply(params[0], this, params.slice(1));
        }
      }
      /**
       * Enqueues a send operation.
       *
       * @param {Array} params Send operation parameters.
       * @private
       */
      enqueue(params) {
        this._bufferedBytes += params[1].length;
        this._queue.push(params);
      }
      /**
       * Sends a frame.
       *
       * @param {Buffer[]} list The frame to send
       * @param {Function} [cb] Callback
       * @private
       */
      sendFrame(list, cb) {
        if (list.length === 2) {
          this._socket.cork();
          this._socket.write(list[0]);
          this._socket.write(list[1], cb);
          this._socket.uncork();
        } else {
          this._socket.write(list[0], cb);
        }
      }
    };
    module2.exports = Sender2;
  }
});

// node_modules/mqtt/node_modules/ws/lib/event-target.js
var require_event_target2 = __commonJS({
  "node_modules/mqtt/node_modules/ws/lib/event-target.js"(exports2, module2) {
    "use strict";
    var Event = class {
      /**
       * Create a new `Event`.
       *
       * @param {String} type The name of the event
       * @param {Object} target A reference to the target to which the event was
       *     dispatched
       */
      constructor(type, target) {
        this.target = target;
        this.type = type;
      }
    };
    var MessageEvent = class extends Event {
      /**
       * Create a new `MessageEvent`.
       *
       * @param {(String|Buffer|ArrayBuffer|Buffer[])} data The received data
       * @param {WebSocket} target A reference to the target to which the event was
       *     dispatched
       */
      constructor(data, target) {
        super("message", target);
        this.data = data;
      }
    };
    var CloseEvent = class extends Event {
      /**
       * Create a new `CloseEvent`.
       *
       * @param {Number} code The status code explaining why the connection is being
       *     closed
       * @param {String} reason A human-readable string explaining why the
       *     connection is closing
       * @param {WebSocket} target A reference to the target to which the event was
       *     dispatched
       */
      constructor(code, reason, target) {
        super("close", target);
        this.wasClean = target._closeFrameReceived && target._closeFrameSent;
        this.reason = reason;
        this.code = code;
      }
    };
    var OpenEvent = class extends Event {
      /**
       * Create a new `OpenEvent`.
       *
       * @param {WebSocket} target A reference to the target to which the event was
       *     dispatched
       */
      constructor(target) {
        super("open", target);
      }
    };
    var ErrorEvent = class extends Event {
      /**
       * Create a new `ErrorEvent`.
       *
       * @param {Object} error The error that generated this event
       * @param {WebSocket} target A reference to the target to which the event was
       *     dispatched
       */
      constructor(error, target) {
        super("error", target);
        this.message = error.message;
        this.error = error;
      }
    };
    var EventTarget = {
      /**
       * Register an event listener.
       *
       * @param {String} type A string representing the event type to listen for
       * @param {Function} listener The listener to add
       * @param {Object} [options] An options object specifies characteristics about
       *     the event listener
       * @param {Boolean} [options.once=false] A `Boolean`` indicating that the
       *     listener should be invoked at most once after being added. If `true`,
       *     the listener would be automatically removed when invoked.
       * @public
       */
      addEventListener(type, listener, options) {
        if (typeof listener !== "function")
          return;
        function onMessage(data) {
          listener.call(this, new MessageEvent(data, this));
        }
        function onClose(code, message) {
          listener.call(this, new CloseEvent(code, message, this));
        }
        function onError(error) {
          listener.call(this, new ErrorEvent(error, this));
        }
        function onOpen() {
          listener.call(this, new OpenEvent(this));
        }
        const method = options && options.once ? "once" : "on";
        if (type === "message") {
          onMessage._listener = listener;
          this[method](type, onMessage);
        } else if (type === "close") {
          onClose._listener = listener;
          this[method](type, onClose);
        } else if (type === "error") {
          onError._listener = listener;
          this[method](type, onError);
        } else if (type === "open") {
          onOpen._listener = listener;
          this[method](type, onOpen);
        } else {
          this[method](type, listener);
        }
      },
      /**
       * Remove an event listener.
       *
       * @param {String} type A string representing the event type to remove
       * @param {Function} listener The listener to remove
       * @public
       */
      removeEventListener(type, listener) {
        const listeners = this.listeners(type);
        for (let i = 0; i < listeners.length; i++) {
          if (listeners[i] === listener || listeners[i]._listener === listener) {
            this.removeListener(type, listeners[i]);
          }
        }
      }
    };
    module2.exports = EventTarget;
  }
});

// node_modules/mqtt/node_modules/ws/lib/extension.js
var require_extension2 = __commonJS({
  "node_modules/mqtt/node_modules/ws/lib/extension.js"(exports2, module2) {
    "use strict";
    var tokenChars = [
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      // 0 - 15
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      // 16 - 31
      0,
      1,
      0,
      1,
      1,
      1,
      1,
      1,
      0,
      0,
      1,
      1,
      0,
      1,
      1,
      0,
      // 32 - 47
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      0,
      0,
      0,
      0,
      0,
      0,
      // 48 - 63
      0,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      // 64 - 79
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      0,
      0,
      0,
      1,
      1,
      // 80 - 95
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      // 96 - 111
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      0,
      1,
      0,
      1,
      0
      // 112 - 127
    ];
    function push(dest, name, elem) {
      if (dest[name] === void 0)
        dest[name] = [elem];
      else
        dest[name].push(elem);
    }
    function parse6(header) {
      const offers = /* @__PURE__ */ Object.create(null);
      if (header === void 0 || header === "")
        return offers;
      let params = /* @__PURE__ */ Object.create(null);
      let mustUnescape = false;
      let isEscaping = false;
      let inQuotes = false;
      let extensionName;
      let paramName;
      let start = -1;
      let end = -1;
      let i = 0;
      for (; i < header.length; i++) {
        const code = header.charCodeAt(i);
        if (extensionName === void 0) {
          if (end === -1 && tokenChars[code] === 1) {
            if (start === -1)
              start = i;
          } else if (code === 32 || code === 9) {
            if (end === -1 && start !== -1)
              end = i;
          } else if (code === 59 || code === 44) {
            if (start === -1) {
              throw new SyntaxError(`Unexpected character at index ${i}`);
            }
            if (end === -1)
              end = i;
            const name = header.slice(start, end);
            if (code === 44) {
              push(offers, name, params);
              params = /* @__PURE__ */ Object.create(null);
            } else {
              extensionName = name;
            }
            start = end = -1;
          } else {
            throw new SyntaxError(`Unexpected character at index ${i}`);
          }
        } else if (paramName === void 0) {
          if (end === -1 && tokenChars[code] === 1) {
            if (start === -1)
              start = i;
          } else if (code === 32 || code === 9) {
            if (end === -1 && start !== -1)
              end = i;
          } else if (code === 59 || code === 44) {
            if (start === -1) {
              throw new SyntaxError(`Unexpected character at index ${i}`);
            }
            if (end === -1)
              end = i;
            push(params, header.slice(start, end), true);
            if (code === 44) {
              push(offers, extensionName, params);
              params = /* @__PURE__ */ Object.create(null);
              extensionName = void 0;
            }
            start = end = -1;
          } else if (code === 61 && start !== -1 && end === -1) {
            paramName = header.slice(start, i);
            start = end = -1;
          } else {
            throw new SyntaxError(`Unexpected character at index ${i}`);
          }
        } else {
          if (isEscaping) {
            if (tokenChars[code] !== 1) {
              throw new SyntaxError(`Unexpected character at index ${i}`);
            }
            if (start === -1)
              start = i;
            else if (!mustUnescape)
              mustUnescape = true;
            isEscaping = false;
          } else if (inQuotes) {
            if (tokenChars[code] === 1) {
              if (start === -1)
                start = i;
            } else if (code === 34 && start !== -1) {
              inQuotes = false;
              end = i;
            } else if (code === 92) {
              isEscaping = true;
            } else {
              throw new SyntaxError(`Unexpected character at index ${i}`);
            }
          } else if (code === 34 && header.charCodeAt(i - 1) === 61) {
            inQuotes = true;
          } else if (end === -1 && tokenChars[code] === 1) {
            if (start === -1)
              start = i;
          } else if (start !== -1 && (code === 32 || code === 9)) {
            if (end === -1)
              end = i;
          } else if (code === 59 || code === 44) {
            if (start === -1) {
              throw new SyntaxError(`Unexpected character at index ${i}`);
            }
            if (end === -1)
              end = i;
            let value = header.slice(start, end);
            if (mustUnescape) {
              value = value.replace(/\\/g, "");
              mustUnescape = false;
            }
            push(params, paramName, value);
            if (code === 44) {
              push(offers, extensionName, params);
              params = /* @__PURE__ */ Object.create(null);
              extensionName = void 0;
            }
            paramName = void 0;
            start = end = -1;
          } else {
            throw new SyntaxError(`Unexpected character at index ${i}`);
          }
        }
      }
      if (start === -1 || inQuotes) {
        throw new SyntaxError("Unexpected end of input");
      }
      if (end === -1)
        end = i;
      const token = header.slice(start, end);
      if (extensionName === void 0) {
        push(offers, token, params);
      } else {
        if (paramName === void 0) {
          push(params, token, true);
        } else if (mustUnescape) {
          push(params, paramName, token.replace(/\\/g, ""));
        } else {
          push(params, paramName, token);
        }
        push(offers, extensionName, params);
      }
      return offers;
    }
    function format3(extensions2) {
      return Object.keys(extensions2).map((extension) => {
        let configurations = extensions2[extension];
        if (!Array.isArray(configurations))
          configurations = [configurations];
        return configurations.map((params) => {
          return [extension].concat(
            Object.keys(params).map((k) => {
              let values = params[k];
              if (!Array.isArray(values))
                values = [values];
              return values.map((v) => v === true ? k : `${k}=${v}`).join("; ");
            })
          ).join("; ");
        }).join(", ");
      }).join(", ");
    }
    module2.exports = { format: format3, parse: parse6 };
  }
});

// node_modules/mqtt/node_modules/ws/lib/websocket.js
var require_websocket2 = __commonJS({
  "node_modules/mqtt/node_modules/ws/lib/websocket.js"(exports2, module2) {
    "use strict";
    var EventEmitter = require("events");
    var https = require("https");
    var http2 = require("http");
    var net = require("net");
    var tls = require("tls");
    var { randomBytes, createHash: createHash2 } = require("crypto");
    var { Readable } = require("stream");
    var { URL: URL2 } = require("url");
    var PerMessageDeflate = require_permessage_deflate2();
    var Receiver2 = require_receiver2();
    var Sender2 = require_sender2();
    var {
      BINARY_TYPES,
      EMPTY_BUFFER,
      GUID,
      kStatusCode,
      kWebSocket,
      NOOP
    } = require_constants3();
    var { addEventListener, removeEventListener } = require_event_target2();
    var { format: format3, parse: parse6 } = require_extension2();
    var { toBuffer } = require_buffer_util2();
    var readyStates = ["CONNECTING", "OPEN", "CLOSING", "CLOSED"];
    var protocolVersions = [8, 13];
    var closeTimeout = 30 * 1e3;
    var WebSocket3 = class _WebSocket extends EventEmitter {
      /**
       * Create a new `WebSocket`.
       *
       * @param {(String|URL)} address The URL to which to connect
       * @param {(String|String[])} [protocols] The subprotocols
       * @param {Object} [options] Connection options
       */
      constructor(address, protocols, options) {
        super();
        this._binaryType = BINARY_TYPES[0];
        this._closeCode = 1006;
        this._closeFrameReceived = false;
        this._closeFrameSent = false;
        this._closeMessage = "";
        this._closeTimer = null;
        this._extensions = {};
        this._protocol = "";
        this._readyState = _WebSocket.CONNECTING;
        this._receiver = null;
        this._sender = null;
        this._socket = null;
        if (address !== null) {
          this._bufferedAmount = 0;
          this._isServer = false;
          this._redirects = 0;
          if (Array.isArray(protocols)) {
            protocols = protocols.join(", ");
          } else if (typeof protocols === "object" && protocols !== null) {
            options = protocols;
            protocols = void 0;
          }
          initAsClient(this, address, protocols, options);
        } else {
          this._isServer = true;
        }
      }
      /**
       * This deviates from the WHATWG interface since ws doesn't support the
       * required default "blob" type (instead we define a custom "nodebuffer"
       * type).
       *
       * @type {String}
       */
      get binaryType() {
        return this._binaryType;
      }
      set binaryType(type) {
        if (!BINARY_TYPES.includes(type))
          return;
        this._binaryType = type;
        if (this._receiver)
          this._receiver._binaryType = type;
      }
      /**
       * @type {Number}
       */
      get bufferedAmount() {
        if (!this._socket)
          return this._bufferedAmount;
        return this._socket._writableState.length + this._sender._bufferedBytes;
      }
      /**
       * @type {String}
       */
      get extensions() {
        return Object.keys(this._extensions).join();
      }
      /**
       * @type {Function}
       */
      /* istanbul ignore next */
      get onclose() {
        return void 0;
      }
      /* istanbul ignore next */
      set onclose(listener) {
      }
      /**
       * @type {Function}
       */
      /* istanbul ignore next */
      get onerror() {
        return void 0;
      }
      /* istanbul ignore next */
      set onerror(listener) {
      }
      /**
       * @type {Function}
       */
      /* istanbul ignore next */
      get onopen() {
        return void 0;
      }
      /* istanbul ignore next */
      set onopen(listener) {
      }
      /**
       * @type {Function}
       */
      /* istanbul ignore next */
      get onmessage() {
        return void 0;
      }
      /* istanbul ignore next */
      set onmessage(listener) {
      }
      /**
       * @type {String}
       */
      get protocol() {
        return this._protocol;
      }
      /**
       * @type {Number}
       */
      get readyState() {
        return this._readyState;
      }
      /**
       * @type {String}
       */
      get url() {
        return this._url;
      }
      /**
       * Set up the socket and the internal resources.
       *
       * @param {(net.Socket|tls.Socket)} socket The network socket between the
       *     server and client
       * @param {Buffer} head The first packet of the upgraded stream
       * @param {Number} [maxPayload=0] The maximum allowed message size
       * @private
       */
      setSocket(socket, head, maxPayload) {
        const receiver = new Receiver2(
          this.binaryType,
          this._extensions,
          this._isServer,
          maxPayload
        );
        this._sender = new Sender2(socket, this._extensions);
        this._receiver = receiver;
        this._socket = socket;
        receiver[kWebSocket] = this;
        socket[kWebSocket] = this;
        receiver.on("conclude", receiverOnConclude);
        receiver.on("drain", receiverOnDrain);
        receiver.on("error", receiverOnError);
        receiver.on("message", receiverOnMessage);
        receiver.on("ping", receiverOnPing);
        receiver.on("pong", receiverOnPong);
        socket.setTimeout(0);
        socket.setNoDelay();
        if (head.length > 0)
          socket.unshift(head);
        socket.on("close", socketOnClose);
        socket.on("data", socketOnData);
        socket.on("end", socketOnEnd);
        socket.on("error", socketOnError);
        this._readyState = _WebSocket.OPEN;
        this.emit("open");
      }
      /**
       * Emit the `'close'` event.
       *
       * @private
       */
      emitClose() {
        if (!this._socket) {
          this._readyState = _WebSocket.CLOSED;
          this.emit("close", this._closeCode, this._closeMessage);
          return;
        }
        if (this._extensions[PerMessageDeflate.extensionName]) {
          this._extensions[PerMessageDeflate.extensionName].cleanup();
        }
        this._receiver.removeAllListeners();
        this._readyState = _WebSocket.CLOSED;
        this.emit("close", this._closeCode, this._closeMessage);
      }
      /**
       * Start a closing handshake.
       *
       *          +----------+   +-----------+   +----------+
       *     - - -|ws.close()|-->|close frame|-->|ws.close()|- - -
       *    |     +----------+   +-----------+   +----------+     |
       *          +----------+   +-----------+         |
       * CLOSING  |ws.close()|<--|close frame|<--+-----+       CLOSING
       *          +----------+   +-----------+   |
       *    |           |                        |   +---+        |
       *                +------------------------+-->|fin| - - - -
       *    |         +---+                      |   +---+
       *     - - - - -|fin|<---------------------+
       *              +---+
       *
       * @param {Number} [code] Status code explaining why the connection is closing
       * @param {String} [data] A string explaining why the connection is closing
       * @public
       */
      close(code, data) {
        if (this.readyState === _WebSocket.CLOSED)
          return;
        if (this.readyState === _WebSocket.CONNECTING) {
          const msg = "WebSocket was closed before the connection was established";
          return abortHandshake(this, this._req, msg);
        }
        if (this.readyState === _WebSocket.CLOSING) {
          if (this._closeFrameSent && (this._closeFrameReceived || this._receiver._writableState.errorEmitted)) {
            this._socket.end();
          }
          return;
        }
        this._readyState = _WebSocket.CLOSING;
        this._sender.close(code, data, !this._isServer, (err) => {
          if (err)
            return;
          this._closeFrameSent = true;
          if (this._closeFrameReceived || this._receiver._writableState.errorEmitted) {
            this._socket.end();
          }
        });
        this._closeTimer = setTimeout(
          this._socket.destroy.bind(this._socket),
          closeTimeout
        );
      }
      /**
       * Send a ping.
       *
       * @param {*} [data] The data to send
       * @param {Boolean} [mask] Indicates whether or not to mask `data`
       * @param {Function} [cb] Callback which is executed when the ping is sent
       * @public
       */
      ping(data, mask, cb) {
        if (this.readyState === _WebSocket.CONNECTING) {
          throw new Error("WebSocket is not open: readyState 0 (CONNECTING)");
        }
        if (typeof data === "function") {
          cb = data;
          data = mask = void 0;
        } else if (typeof mask === "function") {
          cb = mask;
          mask = void 0;
        }
        if (typeof data === "number")
          data = data.toString();
        if (this.readyState !== _WebSocket.OPEN) {
          sendAfterClose(this, data, cb);
          return;
        }
        if (mask === void 0)
          mask = !this._isServer;
        this._sender.ping(data || EMPTY_BUFFER, mask, cb);
      }
      /**
       * Send a pong.
       *
       * @param {*} [data] The data to send
       * @param {Boolean} [mask] Indicates whether or not to mask `data`
       * @param {Function} [cb] Callback which is executed when the pong is sent
       * @public
       */
      pong(data, mask, cb) {
        if (this.readyState === _WebSocket.CONNECTING) {
          throw new Error("WebSocket is not open: readyState 0 (CONNECTING)");
        }
        if (typeof data === "function") {
          cb = data;
          data = mask = void 0;
        } else if (typeof mask === "function") {
          cb = mask;
          mask = void 0;
        }
        if (typeof data === "number")
          data = data.toString();
        if (this.readyState !== _WebSocket.OPEN) {
          sendAfterClose(this, data, cb);
          return;
        }
        if (mask === void 0)
          mask = !this._isServer;
        this._sender.pong(data || EMPTY_BUFFER, mask, cb);
      }
      /**
       * Send a data message.
       *
       * @param {*} data The message to send
       * @param {Object} [options] Options object
       * @param {Boolean} [options.compress] Specifies whether or not to compress
       *     `data`
       * @param {Boolean} [options.binary] Specifies whether `data` is binary or
       *     text
       * @param {Boolean} [options.fin=true] Specifies whether the fragment is the
       *     last one
       * @param {Boolean} [options.mask] Specifies whether or not to mask `data`
       * @param {Function} [cb] Callback which is executed when data is written out
       * @public
       */
      send(data, options, cb) {
        if (this.readyState === _WebSocket.CONNECTING) {
          throw new Error("WebSocket is not open: readyState 0 (CONNECTING)");
        }
        if (typeof options === "function") {
          cb = options;
          options = {};
        }
        if (typeof data === "number")
          data = data.toString();
        if (this.readyState !== _WebSocket.OPEN) {
          sendAfterClose(this, data, cb);
          return;
        }
        const opts = {
          binary: typeof data !== "string",
          mask: !this._isServer,
          compress: true,
          fin: true,
          ...options
        };
        if (!this._extensions[PerMessageDeflate.extensionName]) {
          opts.compress = false;
        }
        this._sender.send(data || EMPTY_BUFFER, opts, cb);
      }
      /**
       * Forcibly close the connection.
       *
       * @public
       */
      terminate() {
        if (this.readyState === _WebSocket.CLOSED)
          return;
        if (this.readyState === _WebSocket.CONNECTING) {
          const msg = "WebSocket was closed before the connection was established";
          return abortHandshake(this, this._req, msg);
        }
        if (this._socket) {
          this._readyState = _WebSocket.CLOSING;
          this._socket.destroy();
        }
      }
    };
    Object.defineProperty(WebSocket3, "CONNECTING", {
      enumerable: true,
      value: readyStates.indexOf("CONNECTING")
    });
    Object.defineProperty(WebSocket3.prototype, "CONNECTING", {
      enumerable: true,
      value: readyStates.indexOf("CONNECTING")
    });
    Object.defineProperty(WebSocket3, "OPEN", {
      enumerable: true,
      value: readyStates.indexOf("OPEN")
    });
    Object.defineProperty(WebSocket3.prototype, "OPEN", {
      enumerable: true,
      value: readyStates.indexOf("OPEN")
    });
    Object.defineProperty(WebSocket3, "CLOSING", {
      enumerable: true,
      value: readyStates.indexOf("CLOSING")
    });
    Object.defineProperty(WebSocket3.prototype, "CLOSING", {
      enumerable: true,
      value: readyStates.indexOf("CLOSING")
    });
    Object.defineProperty(WebSocket3, "CLOSED", {
      enumerable: true,
      value: readyStates.indexOf("CLOSED")
    });
    Object.defineProperty(WebSocket3.prototype, "CLOSED", {
      enumerable: true,
      value: readyStates.indexOf("CLOSED")
    });
    [
      "binaryType",
      "bufferedAmount",
      "extensions",
      "protocol",
      "readyState",
      "url"
    ].forEach((property) => {
      Object.defineProperty(WebSocket3.prototype, property, { enumerable: true });
    });
    ["open", "error", "close", "message"].forEach((method) => {
      Object.defineProperty(WebSocket3.prototype, `on${method}`, {
        enumerable: true,
        get() {
          const listeners = this.listeners(method);
          for (let i = 0; i < listeners.length; i++) {
            if (listeners[i]._listener)
              return listeners[i]._listener;
          }
          return void 0;
        },
        set(listener) {
          const listeners = this.listeners(method);
          for (let i = 0; i < listeners.length; i++) {
            if (listeners[i]._listener)
              this.removeListener(method, listeners[i]);
          }
          this.addEventListener(method, listener);
        }
      });
    });
    WebSocket3.prototype.addEventListener = addEventListener;
    WebSocket3.prototype.removeEventListener = removeEventListener;
    module2.exports = WebSocket3;
    function initAsClient(websocket, address, protocols, options) {
      const opts = {
        protocolVersion: protocolVersions[1],
        maxPayload: 100 * 1024 * 1024,
        perMessageDeflate: true,
        followRedirects: false,
        maxRedirects: 10,
        ...options,
        createConnection: void 0,
        socketPath: void 0,
        hostname: void 0,
        protocol: void 0,
        timeout: void 0,
        method: void 0,
        host: void 0,
        path: void 0,
        port: void 0
      };
      if (!protocolVersions.includes(opts.protocolVersion)) {
        throw new RangeError(
          `Unsupported protocol version: ${opts.protocolVersion} (supported versions: ${protocolVersions.join(", ")})`
        );
      }
      let parsedUrl;
      if (address instanceof URL2) {
        parsedUrl = address;
        websocket._url = address.href;
      } else {
        parsedUrl = new URL2(address);
        websocket._url = address;
      }
      const isUnixSocket = parsedUrl.protocol === "ws+unix:";
      if (!parsedUrl.host && (!isUnixSocket || !parsedUrl.pathname)) {
        const err = new Error(`Invalid URL: ${websocket.url}`);
        if (websocket._redirects === 0) {
          throw err;
        } else {
          emitErrorAndClose(websocket, err);
          return;
        }
      }
      const isSecure = parsedUrl.protocol === "wss:" || parsedUrl.protocol === "https:";
      const defaultPort = isSecure ? 443 : 80;
      const key = randomBytes(16).toString("base64");
      const get = isSecure ? https.get : http2.get;
      let perMessageDeflate;
      opts.createConnection = isSecure ? tlsConnect : netConnect;
      opts.defaultPort = opts.defaultPort || defaultPort;
      opts.port = parsedUrl.port || defaultPort;
      opts.host = parsedUrl.hostname.startsWith("[") ? parsedUrl.hostname.slice(1, -1) : parsedUrl.hostname;
      opts.headers = {
        "Sec-WebSocket-Version": opts.protocolVersion,
        "Sec-WebSocket-Key": key,
        Connection: "Upgrade",
        Upgrade: "websocket",
        ...opts.headers
      };
      opts.path = parsedUrl.pathname + parsedUrl.search;
      opts.timeout = opts.handshakeTimeout;
      if (opts.perMessageDeflate) {
        perMessageDeflate = new PerMessageDeflate(
          opts.perMessageDeflate !== true ? opts.perMessageDeflate : {},
          false,
          opts.maxPayload
        );
        opts.headers["Sec-WebSocket-Extensions"] = format3({
          [PerMessageDeflate.extensionName]: perMessageDeflate.offer()
        });
      }
      if (protocols) {
        opts.headers["Sec-WebSocket-Protocol"] = protocols;
      }
      if (opts.origin) {
        if (opts.protocolVersion < 13) {
          opts.headers["Sec-WebSocket-Origin"] = opts.origin;
        } else {
          opts.headers.Origin = opts.origin;
        }
      }
      if (parsedUrl.username || parsedUrl.password) {
        opts.auth = `${parsedUrl.username}:${parsedUrl.password}`;
      }
      if (isUnixSocket) {
        const parts = opts.path.split(":");
        opts.socketPath = parts[0];
        opts.path = parts[1];
      }
      if (opts.followRedirects) {
        if (websocket._redirects === 0) {
          websocket._originalUnixSocket = isUnixSocket;
          websocket._originalSecure = isSecure;
          websocket._originalHostOrSocketPath = isUnixSocket ? opts.socketPath : parsedUrl.host;
          const headers = options && options.headers;
          options = { ...options, headers: {} };
          if (headers) {
            for (const [key2, value] of Object.entries(headers)) {
              options.headers[key2.toLowerCase()] = value;
            }
          }
        } else {
          const isSameHost = isUnixSocket ? websocket._originalUnixSocket ? opts.socketPath === websocket._originalHostOrSocketPath : false : websocket._originalUnixSocket ? false : parsedUrl.host === websocket._originalHostOrSocketPath;
          if (!isSameHost || websocket._originalSecure && !isSecure) {
            delete opts.headers.authorization;
            delete opts.headers.cookie;
            if (!isSameHost)
              delete opts.headers.host;
            opts.auth = void 0;
          }
        }
        if (opts.auth && !options.headers.authorization) {
          options.headers.authorization = "Basic " + Buffer.from(opts.auth).toString("base64");
        }
      }
      let req = websocket._req = get(opts);
      if (opts.timeout) {
        req.on("timeout", () => {
          abortHandshake(websocket, req, "Opening handshake has timed out");
        });
      }
      req.on("error", (err) => {
        if (req === null || req.aborted)
          return;
        req = websocket._req = null;
        emitErrorAndClose(websocket, err);
      });
      req.on("response", (res) => {
        const location = res.headers.location;
        const statusCode = res.statusCode;
        if (location && opts.followRedirects && statusCode >= 300 && statusCode < 400) {
          if (++websocket._redirects > opts.maxRedirects) {
            abortHandshake(websocket, req, "Maximum redirects exceeded");
            return;
          }
          req.abort();
          let addr;
          try {
            addr = new URL2(location, address);
          } catch (err) {
            emitErrorAndClose(websocket, err);
            return;
          }
          initAsClient(websocket, addr, protocols, options);
        } else if (!websocket.emit("unexpected-response", req, res)) {
          abortHandshake(
            websocket,
            req,
            `Unexpected server response: ${res.statusCode}`
          );
        }
      });
      req.on("upgrade", (res, socket, head) => {
        websocket.emit("upgrade", res);
        if (websocket.readyState !== WebSocket3.CONNECTING)
          return;
        req = websocket._req = null;
        if (res.headers.upgrade.toLowerCase() !== "websocket") {
          abortHandshake(websocket, socket, "Invalid Upgrade header");
          return;
        }
        const digest = createHash2("sha1").update(key + GUID).digest("base64");
        if (res.headers["sec-websocket-accept"] !== digest) {
          abortHandshake(websocket, socket, "Invalid Sec-WebSocket-Accept header");
          return;
        }
        const serverProt = res.headers["sec-websocket-protocol"];
        const protList = (protocols || "").split(/, */);
        let protError;
        if (!protocols && serverProt) {
          protError = "Server sent a subprotocol but none was requested";
        } else if (protocols && !serverProt) {
          protError = "Server sent no subprotocol";
        } else if (serverProt && !protList.includes(serverProt)) {
          protError = "Server sent an invalid subprotocol";
        }
        if (protError) {
          abortHandshake(websocket, socket, protError);
          return;
        }
        if (serverProt)
          websocket._protocol = serverProt;
        const secWebSocketExtensions = res.headers["sec-websocket-extensions"];
        if (secWebSocketExtensions !== void 0) {
          if (!perMessageDeflate) {
            const message = "Server sent a Sec-WebSocket-Extensions header but no extension was requested";
            abortHandshake(websocket, socket, message);
            return;
          }
          let extensions2;
          try {
            extensions2 = parse6(secWebSocketExtensions);
          } catch (err) {
            const message = "Invalid Sec-WebSocket-Extensions header";
            abortHandshake(websocket, socket, message);
            return;
          }
          const extensionNames = Object.keys(extensions2);
          if (extensionNames.length) {
            if (extensionNames.length !== 1 || extensionNames[0] !== PerMessageDeflate.extensionName) {
              const message = "Server indicated an extension that was not requested";
              abortHandshake(websocket, socket, message);
              return;
            }
            try {
              perMessageDeflate.accept(extensions2[PerMessageDeflate.extensionName]);
            } catch (err) {
              const message = "Invalid Sec-WebSocket-Extensions header";
              abortHandshake(websocket, socket, message);
              return;
            }
            websocket._extensions[PerMessageDeflate.extensionName] = perMessageDeflate;
          }
        }
        websocket.setSocket(socket, head, opts.maxPayload);
      });
    }
    function emitErrorAndClose(websocket, err) {
      websocket._readyState = WebSocket3.CLOSING;
      websocket.emit("error", err);
      websocket.emitClose();
    }
    function netConnect(options) {
      options.path = options.socketPath;
      return net.connect(options);
    }
    function tlsConnect(options) {
      options.path = void 0;
      if (!options.servername && options.servername !== "") {
        options.servername = net.isIP(options.host) ? "" : options.host;
      }
      return tls.connect(options);
    }
    function abortHandshake(websocket, stream, message) {
      websocket._readyState = WebSocket3.CLOSING;
      const err = new Error(message);
      Error.captureStackTrace(err, abortHandshake);
      if (stream.setHeader) {
        stream.abort();
        if (stream.socket && !stream.socket.destroyed) {
          stream.socket.destroy();
        }
        stream.once("abort", websocket.emitClose.bind(websocket));
        websocket.emit("error", err);
      } else {
        stream.destroy(err);
        stream.once("error", websocket.emit.bind(websocket, "error"));
        stream.once("close", websocket.emitClose.bind(websocket));
      }
    }
    function sendAfterClose(websocket, data, cb) {
      if (data) {
        const length = toBuffer(data).length;
        if (websocket._socket)
          websocket._sender._bufferedBytes += length;
        else
          websocket._bufferedAmount += length;
      }
      if (cb) {
        const err = new Error(
          `WebSocket is not open: readyState ${websocket.readyState} (${readyStates[websocket.readyState]})`
        );
        cb(err);
      }
    }
    function receiverOnConclude(code, reason) {
      const websocket = this[kWebSocket];
      websocket._closeFrameReceived = true;
      websocket._closeMessage = reason;
      websocket._closeCode = code;
      if (websocket._socket[kWebSocket] === void 0)
        return;
      websocket._socket.removeListener("data", socketOnData);
      process.nextTick(resume, websocket._socket);
      if (code === 1005)
        websocket.close();
      else
        websocket.close(code, reason);
    }
    function receiverOnDrain() {
      this[kWebSocket]._socket.resume();
    }
    function receiverOnError(err) {
      const websocket = this[kWebSocket];
      if (websocket._socket[kWebSocket] !== void 0) {
        websocket._socket.removeListener("data", socketOnData);
        process.nextTick(resume, websocket._socket);
        websocket.close(err[kStatusCode]);
      }
      websocket.emit("error", err);
    }
    function receiverOnFinish() {
      this[kWebSocket].emitClose();
    }
    function receiverOnMessage(data) {
      this[kWebSocket].emit("message", data);
    }
    function receiverOnPing(data) {
      const websocket = this[kWebSocket];
      websocket.pong(data, !websocket._isServer, NOOP);
      websocket.emit("ping", data);
    }
    function receiverOnPong(data) {
      this[kWebSocket].emit("pong", data);
    }
    function resume(stream) {
      stream.resume();
    }
    function socketOnClose() {
      const websocket = this[kWebSocket];
      this.removeListener("close", socketOnClose);
      this.removeListener("data", socketOnData);
      this.removeListener("end", socketOnEnd);
      websocket._readyState = WebSocket3.CLOSING;
      let chunk;
      if (!this._readableState.endEmitted && !websocket._closeFrameReceived && !websocket._receiver._writableState.errorEmitted && (chunk = websocket._socket.read()) !== null) {
        websocket._receiver.write(chunk);
      }
      websocket._receiver.end();
      this[kWebSocket] = void 0;
      clearTimeout(websocket._closeTimer);
      if (websocket._receiver._writableState.finished || websocket._receiver._writableState.errorEmitted) {
        websocket.emitClose();
      } else {
        websocket._receiver.on("error", receiverOnFinish);
        websocket._receiver.on("finish", receiverOnFinish);
      }
    }
    function socketOnData(chunk) {
      if (!this[kWebSocket]._receiver.write(chunk)) {
        this.pause();
      }
    }
    function socketOnEnd() {
      const websocket = this[kWebSocket];
      websocket._readyState = WebSocket3.CLOSING;
      websocket._receiver.end();
      this.end();
    }
    function socketOnError() {
      const websocket = this[kWebSocket];
      this.removeListener("error", socketOnError);
      this.on("error", NOOP);
      if (websocket) {
        websocket._readyState = WebSocket3.CLOSING;
        this.destroy();
      }
    }
  }
});

// node_modules/mqtt/node_modules/ws/lib/stream.js
var require_stream3 = __commonJS({
  "node_modules/mqtt/node_modules/ws/lib/stream.js"(exports2, module2) {
    "use strict";
    var { Duplex } = require("stream");
    function emitClose(stream) {
      stream.emit("close");
    }
    function duplexOnEnd() {
      if (!this.destroyed && this._writableState.finished) {
        this.destroy();
      }
    }
    function duplexOnError(err) {
      this.removeListener("error", duplexOnError);
      this.destroy();
      if (this.listenerCount("error") === 0) {
        this.emit("error", err);
      }
    }
    function createWebSocketStream2(ws, options) {
      let resumeOnReceiverDrain = true;
      let terminateOnDestroy = true;
      function receiverOnDrain() {
        if (resumeOnReceiverDrain)
          ws._socket.resume();
      }
      if (ws.readyState === ws.CONNECTING) {
        ws.once("open", function open() {
          ws._receiver.removeAllListeners("drain");
          ws._receiver.on("drain", receiverOnDrain);
        });
      } else {
        ws._receiver.removeAllListeners("drain");
        ws._receiver.on("drain", receiverOnDrain);
      }
      const duplex = new Duplex({
        ...options,
        autoDestroy: false,
        emitClose: false,
        objectMode: false,
        writableObjectMode: false
      });
      ws.on("message", function message(msg) {
        if (!duplex.push(msg)) {
          resumeOnReceiverDrain = false;
          ws._socket.pause();
        }
      });
      ws.once("error", function error(err) {
        if (duplex.destroyed)
          return;
        terminateOnDestroy = false;
        duplex.destroy(err);
      });
      ws.once("close", function close() {
        if (duplex.destroyed)
          return;
        duplex.push(null);
      });
      duplex._destroy = function(err, callback) {
        if (ws.readyState === ws.CLOSED) {
          callback(err);
          process.nextTick(emitClose, duplex);
          return;
        }
        let called = false;
        ws.once("error", function error(err2) {
          called = true;
          callback(err2);
        });
        ws.once("close", function close() {
          if (!called)
            callback(err);
          process.nextTick(emitClose, duplex);
        });
        if (terminateOnDestroy)
          ws.terminate();
      };
      duplex._final = function(callback) {
        if (ws.readyState === ws.CONNECTING) {
          ws.once("open", function open() {
            duplex._final(callback);
          });
          return;
        }
        if (ws._socket === null)
          return;
        if (ws._socket._writableState.finished) {
          callback();
          if (duplex._readableState.endEmitted)
            duplex.destroy();
        } else {
          ws._socket.once("finish", function finish() {
            callback();
          });
          ws.close();
        }
      };
      duplex._read = function() {
        if ((ws.readyState === ws.OPEN || ws.readyState === ws.CLOSING) && !resumeOnReceiverDrain) {
          resumeOnReceiverDrain = true;
          if (!ws._receiver._writableState.needDrain)
            ws._socket.resume();
        }
      };
      duplex._write = function(chunk, encoding, callback) {
        if (ws.readyState === ws.CONNECTING) {
          ws.once("open", function open() {
            duplex._write(chunk, encoding, callback);
          });
          return;
        }
        ws.send(chunk, callback);
      };
      duplex.on("end", duplexOnEnd);
      duplex.on("error", duplexOnError);
      return duplex;
    }
    module2.exports = createWebSocketStream2;
  }
});

// node_modules/mqtt/node_modules/ws/lib/websocket-server.js
var require_websocket_server2 = __commonJS({
  "node_modules/mqtt/node_modules/ws/lib/websocket-server.js"(exports2, module2) {
    "use strict";
    var EventEmitter = require("events");
    var http2 = require("http");
    var https = require("https");
    var net = require("net");
    var tls = require("tls");
    var { createHash: createHash2 } = require("crypto");
    var PerMessageDeflate = require_permessage_deflate2();
    var WebSocket3 = require_websocket2();
    var { format: format3, parse: parse6 } = require_extension2();
    var { GUID, kWebSocket } = require_constants3();
    var keyRegex = /^[+/0-9A-Za-z]{22}==$/;
    var RUNNING = 0;
    var CLOSING = 1;
    var CLOSED = 2;
    var WebSocketServer2 = class extends EventEmitter {
      /**
       * Create a `WebSocketServer` instance.
       *
       * @param {Object} options Configuration options
       * @param {Number} [options.backlog=511] The maximum length of the queue of
       *     pending connections
       * @param {Boolean} [options.clientTracking=true] Specifies whether or not to
       *     track clients
       * @param {Function} [options.handleProtocols] A hook to handle protocols
       * @param {String} [options.host] The hostname where to bind the server
       * @param {Number} [options.maxPayload=104857600] The maximum allowed message
       *     size
       * @param {Boolean} [options.noServer=false] Enable no server mode
       * @param {String} [options.path] Accept only connections matching this path
       * @param {(Boolean|Object)} [options.perMessageDeflate=false] Enable/disable
       *     permessage-deflate
       * @param {Number} [options.port] The port where to bind the server
       * @param {(http.Server|https.Server)} [options.server] A pre-created HTTP/S
       *     server to use
       * @param {Function} [options.verifyClient] A hook to reject connections
       * @param {Function} [callback] A listener for the `listening` event
       */
      constructor(options, callback) {
        super();
        options = {
          maxPayload: 100 * 1024 * 1024,
          perMessageDeflate: false,
          handleProtocols: null,
          clientTracking: true,
          verifyClient: null,
          noServer: false,
          backlog: null,
          // use default (511 as implemented in net.js)
          server: null,
          host: null,
          path: null,
          port: null,
          ...options
        };
        if (options.port == null && !options.server && !options.noServer || options.port != null && (options.server || options.noServer) || options.server && options.noServer) {
          throw new TypeError(
            'One and only one of the "port", "server", or "noServer" options must be specified'
          );
        }
        if (options.port != null) {
          this._server = http2.createServer((req, res) => {
            const body = http2.STATUS_CODES[426];
            res.writeHead(426, {
              "Content-Length": body.length,
              "Content-Type": "text/plain"
            });
            res.end(body);
          });
          this._server.listen(
            options.port,
            options.host,
            options.backlog,
            callback
          );
        } else if (options.server) {
          this._server = options.server;
        }
        if (this._server) {
          const emitConnection = this.emit.bind(this, "connection");
          this._removeListeners = addListeners(this._server, {
            listening: this.emit.bind(this, "listening"),
            error: this.emit.bind(this, "error"),
            upgrade: (req, socket, head) => {
              this.handleUpgrade(req, socket, head, emitConnection);
            }
          });
        }
        if (options.perMessageDeflate === true)
          options.perMessageDeflate = {};
        if (options.clientTracking)
          this.clients = /* @__PURE__ */ new Set();
        this.options = options;
        this._state = RUNNING;
      }
      /**
       * Returns the bound address, the address family name, and port of the server
       * as reported by the operating system if listening on an IP socket.
       * If the server is listening on a pipe or UNIX domain socket, the name is
       * returned as a string.
       *
       * @return {(Object|String|null)} The address of the server
       * @public
       */
      address() {
        if (this.options.noServer) {
          throw new Error('The server is operating in "noServer" mode');
        }
        if (!this._server)
          return null;
        return this._server.address();
      }
      /**
       * Close the server.
       *
       * @param {Function} [cb] Callback
       * @public
       */
      close(cb) {
        if (cb)
          this.once("close", cb);
        if (this._state === CLOSED) {
          process.nextTick(emitClose, this);
          return;
        }
        if (this._state === CLOSING)
          return;
        this._state = CLOSING;
        if (this.clients) {
          for (const client2 of this.clients)
            client2.terminate();
        }
        const server = this._server;
        if (server) {
          this._removeListeners();
          this._removeListeners = this._server = null;
          if (this.options.port != null) {
            server.close(emitClose.bind(void 0, this));
            return;
          }
        }
        process.nextTick(emitClose, this);
      }
      /**
       * See if a given request should be handled by this server instance.
       *
       * @param {http.IncomingMessage} req Request object to inspect
       * @return {Boolean} `true` if the request is valid, else `false`
       * @public
       */
      shouldHandle(req) {
        if (this.options.path) {
          const index = req.url.indexOf("?");
          const pathname = index !== -1 ? req.url.slice(0, index) : req.url;
          if (pathname !== this.options.path)
            return false;
        }
        return true;
      }
      /**
       * Handle a HTTP Upgrade request.
       *
       * @param {http.IncomingMessage} req The request object
       * @param {(net.Socket|tls.Socket)} socket The network socket between the
       *     server and client
       * @param {Buffer} head The first packet of the upgraded stream
       * @param {Function} cb Callback
       * @public
       */
      handleUpgrade(req, socket, head, cb) {
        socket.on("error", socketOnError);
        const key = req.headers["sec-websocket-key"] !== void 0 ? req.headers["sec-websocket-key"].trim() : false;
        const version = +req.headers["sec-websocket-version"];
        const extensions2 = {};
        if (req.method !== "GET" || req.headers.upgrade.toLowerCase() !== "websocket" || !key || !keyRegex.test(key) || version !== 8 && version !== 13 || !this.shouldHandle(req)) {
          return abortHandshake(socket, 400);
        }
        if (this.options.perMessageDeflate) {
          const perMessageDeflate = new PerMessageDeflate(
            this.options.perMessageDeflate,
            true,
            this.options.maxPayload
          );
          try {
            const offers = parse6(req.headers["sec-websocket-extensions"]);
            if (offers[PerMessageDeflate.extensionName]) {
              perMessageDeflate.accept(offers[PerMessageDeflate.extensionName]);
              extensions2[PerMessageDeflate.extensionName] = perMessageDeflate;
            }
          } catch (err) {
            return abortHandshake(socket, 400);
          }
        }
        if (this.options.verifyClient) {
          const info = {
            origin: req.headers[`${version === 8 ? "sec-websocket-origin" : "origin"}`],
            secure: !!(req.socket.authorized || req.socket.encrypted),
            req
          };
          if (this.options.verifyClient.length === 2) {
            this.options.verifyClient(info, (verified, code, message, headers) => {
              if (!verified) {
                return abortHandshake(socket, code || 401, message, headers);
              }
              this.completeUpgrade(key, extensions2, req, socket, head, cb);
            });
            return;
          }
          if (!this.options.verifyClient(info))
            return abortHandshake(socket, 401);
        }
        this.completeUpgrade(key, extensions2, req, socket, head, cb);
      }
      /**
       * Upgrade the connection to WebSocket.
       *
       * @param {String} key The value of the `Sec-WebSocket-Key` header
       * @param {Object} extensions The accepted extensions
       * @param {http.IncomingMessage} req The request object
       * @param {(net.Socket|tls.Socket)} socket The network socket between the
       *     server and client
       * @param {Buffer} head The first packet of the upgraded stream
       * @param {Function} cb Callback
       * @throws {Error} If called more than once with the same socket
       * @private
       */
      completeUpgrade(key, extensions2, req, socket, head, cb) {
        if (!socket.readable || !socket.writable)
          return socket.destroy();
        if (socket[kWebSocket]) {
          throw new Error(
            "server.handleUpgrade() was called more than once with the same socket, possibly due to a misconfiguration"
          );
        }
        if (this._state > RUNNING)
          return abortHandshake(socket, 503);
        const digest = createHash2("sha1").update(key + GUID).digest("base64");
        const headers = [
          "HTTP/1.1 101 Switching Protocols",
          "Upgrade: websocket",
          "Connection: Upgrade",
          `Sec-WebSocket-Accept: ${digest}`
        ];
        const ws = new WebSocket3(null);
        let protocol = req.headers["sec-websocket-protocol"];
        if (protocol) {
          protocol = protocol.split(",").map(trim);
          if (this.options.handleProtocols) {
            protocol = this.options.handleProtocols(protocol, req);
          } else {
            protocol = protocol[0];
          }
          if (protocol) {
            headers.push(`Sec-WebSocket-Protocol: ${protocol}`);
            ws._protocol = protocol;
          }
        }
        if (extensions2[PerMessageDeflate.extensionName]) {
          const params = extensions2[PerMessageDeflate.extensionName].params;
          const value = format3({
            [PerMessageDeflate.extensionName]: [params]
          });
          headers.push(`Sec-WebSocket-Extensions: ${value}`);
          ws._extensions = extensions2;
        }
        this.emit("headers", headers, req);
        socket.write(headers.concat("\r\n").join("\r\n"));
        socket.removeListener("error", socketOnError);
        ws.setSocket(socket, head, this.options.maxPayload);
        if (this.clients) {
          this.clients.add(ws);
          ws.on("close", () => this.clients.delete(ws));
        }
        cb(ws, req);
      }
    };
    module2.exports = WebSocketServer2;
    function addListeners(server, map) {
      for (const event of Object.keys(map))
        server.on(event, map[event]);
      return function removeListeners() {
        for (const event of Object.keys(map)) {
          server.removeListener(event, map[event]);
        }
      };
    }
    function emitClose(server) {
      server._state = CLOSED;
      server.emit("close");
    }
    function socketOnError() {
      this.destroy();
    }
    function abortHandshake(socket, code, message, headers) {
      if (socket.writable) {
        message = message || http2.STATUS_CODES[code];
        headers = {
          Connection: "close",
          "Content-Type": "text/html",
          "Content-Length": Buffer.byteLength(message),
          ...headers
        };
        socket.write(
          `HTTP/1.1 ${code} ${http2.STATUS_CODES[code]}\r
` + Object.keys(headers).map((h) => `${h}: ${headers[h]}`).join("\r\n") + "\r\n\r\n" + message
        );
      }
      socket.removeListener("error", socketOnError);
      socket.destroy();
    }
    function trim(str) {
      return str.trim();
    }
  }
});

// node_modules/mqtt/node_modules/ws/index.js
var require_ws2 = __commonJS({
  "node_modules/mqtt/node_modules/ws/index.js"(exports2, module2) {
    "use strict";
    var WebSocket3 = require_websocket2();
    WebSocket3.createWebSocketStream = require_stream3();
    WebSocket3.Server = require_websocket_server2();
    WebSocket3.Receiver = require_receiver2();
    WebSocket3.Sender = require_sender2();
    module2.exports = WebSocket3;
  }
});

// node_modules/mqtt/lib/connect/ws.js
var require_ws3 = __commonJS({
  "node_modules/mqtt/lib/connect/ws.js"(exports2, module2) {
    "use strict";
    var { Buffer: Buffer2 } = require("buffer");
    var WS = require_ws2();
    var debug = require_src()("mqttjs:ws");
    var duplexify = require_duplexify();
    var Transform = require_readable().Transform;
    var WSS_OPTIONS = [
      "rejectUnauthorized",
      "ca",
      "cert",
      "key",
      "pfx",
      "passphrase"
    ];
    var IS_BROWSER = typeof process !== "undefined" && process.title === "browser" || typeof __webpack_require__ === "function";
    function buildUrl(opts, client2) {
      let url = opts.protocol + "://" + opts.hostname + ":" + opts.port + opts.path;
      if (typeof opts.transformWsUrl === "function") {
        url = opts.transformWsUrl(url, opts, client2);
      }
      return url;
    }
    function setDefaultOpts(opts) {
      const options = opts;
      if (!opts.hostname) {
        options.hostname = "localhost";
      }
      if (!opts.port) {
        if (opts.protocol === "wss") {
          options.port = 443;
        } else {
          options.port = 80;
        }
      }
      if (!opts.path) {
        options.path = "/";
      }
      if (!opts.wsOptions) {
        options.wsOptions = {};
      }
      if (!IS_BROWSER && opts.protocol === "wss") {
        WSS_OPTIONS.forEach(function(prop) {
          if (Object.prototype.hasOwnProperty.call(opts, prop) && !Object.prototype.hasOwnProperty.call(opts.wsOptions, prop)) {
            options.wsOptions[prop] = opts[prop];
          }
        });
      }
      return options;
    }
    function setDefaultBrowserOpts(opts) {
      const options = setDefaultOpts(opts);
      if (!options.hostname) {
        options.hostname = options.host;
      }
      if (!options.hostname) {
        if (typeof document === "undefined") {
          throw new Error("Could not determine host. Specify host manually.");
        }
        const parsed = new URL(document.URL);
        options.hostname = parsed.hostname;
        if (!options.port) {
          options.port = parsed.port;
        }
      }
      if (options.objectMode === void 0) {
        options.objectMode = !(options.binary === true || options.binary === void 0);
      }
      return options;
    }
    function createWebSocket(client2, url, opts) {
      debug("createWebSocket");
      debug("protocol: " + opts.protocolId + " " + opts.protocolVersion);
      const websocketSubProtocol = opts.protocolId === "MQIsdp" && opts.protocolVersion === 3 ? "mqttv3.1" : "mqtt";
      debug("creating new Websocket for url: " + url + " and protocol: " + websocketSubProtocol);
      const socket = new WS(url, [websocketSubProtocol], opts.wsOptions);
      return socket;
    }
    function createBrowserWebSocket(client2, opts) {
      const websocketSubProtocol = opts.protocolId === "MQIsdp" && opts.protocolVersion === 3 ? "mqttv3.1" : "mqtt";
      const url = buildUrl(opts, client2);
      const socket = new WebSocket(url, [websocketSubProtocol]);
      socket.binaryType = "arraybuffer";
      return socket;
    }
    function streamBuilder(client2, opts) {
      debug("streamBuilder");
      const options = setDefaultOpts(opts);
      const url = buildUrl(options, client2);
      const socket = createWebSocket(client2, url, options);
      const webSocketStream = WS.createWebSocketStream(socket, options.wsOptions);
      webSocketStream.url = url;
      socket.on("close", () => {
        webSocketStream.destroy();
      });
      return webSocketStream;
    }
    function browserStreamBuilder(client2, opts) {
      debug("browserStreamBuilder");
      let stream;
      const options = setDefaultBrowserOpts(opts);
      const bufferSize = options.browserBufferSize || 1024 * 512;
      const bufferTimeout = opts.browserBufferTimeout || 1e3;
      const coerceToBuffer = !opts.objectMode;
      const socket = createBrowserWebSocket(client2, opts);
      const proxy = buildProxy(opts, socketWriteBrowser, socketEndBrowser);
      if (!opts.objectMode) {
        proxy._writev = writev;
      }
      proxy.on("close", () => {
        socket.close();
      });
      const eventListenerSupport = typeof socket.addEventListener !== "undefined";
      if (socket.readyState === socket.OPEN) {
        stream = proxy;
      } else {
        stream = stream = duplexify(void 0, void 0, opts);
        if (!opts.objectMode) {
          stream._writev = writev;
        }
        if (eventListenerSupport) {
          socket.addEventListener("open", onopen);
        } else {
          socket.onopen = onopen;
        }
      }
      stream.socket = socket;
      if (eventListenerSupport) {
        socket.addEventListener("close", onclose);
        socket.addEventListener("error", onerror);
        socket.addEventListener("message", onmessage);
      } else {
        socket.onclose = onclose;
        socket.onerror = onerror;
        socket.onmessage = onmessage;
      }
      function buildProxy(options2, socketWrite, socketEnd) {
        const proxy2 = new Transform({
          objectModeMode: options2.objectMode
        });
        proxy2._write = socketWrite;
        proxy2._flush = socketEnd;
        return proxy2;
      }
      function onopen() {
        stream.setReadable(proxy);
        stream.setWritable(proxy);
        stream.emit("connect");
      }
      function onclose() {
        stream.end();
        stream.destroy();
      }
      function onerror(err) {
        stream.destroy(err);
      }
      function onmessage(event) {
        let data = event.data;
        if (data instanceof ArrayBuffer)
          data = Buffer2.from(data);
        else
          data = Buffer2.from(data, "utf8");
        proxy.push(data);
      }
      function writev(chunks, cb) {
        const buffers = new Array(chunks.length);
        for (let i = 0; i < chunks.length; i++) {
          if (typeof chunks[i].chunk === "string") {
            buffers[i] = Buffer2.from(chunks[i], "utf8");
          } else {
            buffers[i] = chunks[i].chunk;
          }
        }
        this._write(Buffer2.concat(buffers), "binary", cb);
      }
      function socketWriteBrowser(chunk, enc, next) {
        if (socket.bufferedAmount > bufferSize) {
          setTimeout(socketWriteBrowser, bufferTimeout, chunk, enc, next);
        }
        if (coerceToBuffer && typeof chunk === "string") {
          chunk = Buffer2.from(chunk, "utf8");
        }
        try {
          socket.send(chunk);
        } catch (err) {
          return next(err);
        }
        next();
      }
      function socketEndBrowser(done) {
        socket.close();
        done();
      }
      return stream;
    }
    if (IS_BROWSER) {
      module2.exports = browserStreamBuilder;
    } else {
      module2.exports = streamBuilder;
    }
  }
});

// node_modules/mqtt/lib/connect/index.js
var require_connect = __commonJS({
  "node_modules/mqtt/lib/connect/index.js"(exports2, module2) {
    "use strict";
    var MqttClient = require_client();
    var Store = require_store();
    var url = require("url");
    var xtend = require_immutable();
    var debug = require_src()("mqttjs");
    var protocols = {};
    if (typeof process !== "undefined" && process.title !== "browser" || typeof __webpack_require__ !== "function") {
      protocols.mqtt = require_tcp();
      protocols.tcp = require_tcp();
      protocols.ssl = require_tls();
      protocols.tls = require_tls();
      protocols.mqtts = require_tls();
    } else {
      protocols.wx = require_wx();
      protocols.wxs = require_wx();
      protocols.ali = require_ali();
      protocols.alis = require_ali();
    }
    protocols.ws = require_ws3();
    protocols.wss = require_ws3();
    function parseAuthOptions(opts) {
      let matches;
      if (opts.auth) {
        matches = opts.auth.match(/^(.+):(.+)$/);
        if (matches) {
          opts.username = matches[1];
          opts.password = matches[2];
        } else {
          opts.username = opts.auth;
        }
      }
    }
    function connect(brokerUrl, opts) {
      debug("connecting to an MQTT broker...");
      if (typeof brokerUrl === "object" && !opts) {
        opts = brokerUrl;
        brokerUrl = null;
      }
      opts = opts || {};
      if (brokerUrl) {
        const parsed = url.parse(brokerUrl, true);
        if (parsed.port != null) {
          parsed.port = Number(parsed.port);
        }
        opts = xtend(parsed, opts);
        if (opts.protocol === null) {
          throw new Error("Missing protocol");
        }
        opts.protocol = opts.protocol.replace(/:$/, "");
      }
      parseAuthOptions(opts);
      if (opts.query && typeof opts.query.clientId === "string") {
        opts.clientId = opts.query.clientId;
      }
      if (opts.cert && opts.key) {
        if (opts.protocol) {
          if (["mqtts", "wss", "wxs", "alis"].indexOf(opts.protocol) === -1) {
            switch (opts.protocol) {
              case "mqtt":
                opts.protocol = "mqtts";
                break;
              case "ws":
                opts.protocol = "wss";
                break;
              case "wx":
                opts.protocol = "wxs";
                break;
              case "ali":
                opts.protocol = "alis";
                break;
              default:
                throw new Error('Unknown protocol for secure connection: "' + opts.protocol + '"!');
            }
          }
        } else {
          throw new Error("Missing secure protocol key");
        }
      }
      if (!protocols[opts.protocol]) {
        const isSecure = ["mqtts", "wss"].indexOf(opts.protocol) !== -1;
        opts.protocol = [
          "mqtt",
          "mqtts",
          "ws",
          "wss",
          "wx",
          "wxs",
          "ali",
          "alis"
        ].filter(function(key, index) {
          if (isSecure && index % 2 === 0) {
            return false;
          }
          return typeof protocols[key] === "function";
        })[0];
      }
      if (opts.clean === false && !opts.clientId) {
        throw new Error("Missing clientId for unclean clients");
      }
      if (opts.protocol) {
        opts.defaultProtocol = opts.protocol;
      }
      function wrapper(client3) {
        if (opts.servers) {
          if (!client3._reconnectCount || client3._reconnectCount === opts.servers.length) {
            client3._reconnectCount = 0;
          }
          opts.host = opts.servers[client3._reconnectCount].host;
          opts.port = opts.servers[client3._reconnectCount].port;
          opts.protocol = !opts.servers[client3._reconnectCount].protocol ? opts.defaultProtocol : opts.servers[client3._reconnectCount].protocol;
          opts.hostname = opts.host;
          client3._reconnectCount++;
        }
        debug("calling streambuilder for", opts.protocol);
        return protocols[opts.protocol](client3, opts);
      }
      const client2 = new MqttClient(wrapper, opts);
      client2.on("error", function() {
      });
      return client2;
    }
    module2.exports = connect;
    module2.exports.connect = connect;
    module2.exports.MqttClient = MqttClient;
    module2.exports.Store = Store;
  }
});

// node_modules/mqtt/lib/unique-message-id-provider.js
var require_unique_message_id_provider = __commonJS({
  "node_modules/mqtt/lib/unique-message-id-provider.js"(exports2, module2) {
    "use strict";
    var NumberAllocator = require_number_allocator2().NumberAllocator;
    function UniqueMessageIdProvider() {
      if (!(this instanceof UniqueMessageIdProvider)) {
        return new UniqueMessageIdProvider();
      }
      this.numberAllocator = new NumberAllocator(1, 65535);
    }
    UniqueMessageIdProvider.prototype.allocate = function() {
      this.lastId = this.numberAllocator.alloc();
      return this.lastId;
    };
    UniqueMessageIdProvider.prototype.getLastAllocated = function() {
      return this.lastId;
    };
    UniqueMessageIdProvider.prototype.register = function(messageId) {
      return this.numberAllocator.use(messageId);
    };
    UniqueMessageIdProvider.prototype.deallocate = function(messageId) {
      this.numberAllocator.free(messageId);
    };
    UniqueMessageIdProvider.prototype.clear = function() {
      this.numberAllocator.clear();
    };
    module2.exports = UniqueMessageIdProvider;
  }
});

// node_modules/mqtt/mqtt.js
var require_mqtt2 = __commonJS({
  "node_modules/mqtt/mqtt.js"(exports2, module2) {
    var MqttClient = require_client();
    var connect = require_connect();
    var Store = require_store();
    var DefaultMessageIdProvider = require_default_message_id_provider();
    var UniqueMessageIdProvider = require_unique_message_id_provider();
    module2.exports.connect = connect;
    module2.exports.MqttClient = MqttClient;
    module2.exports.Client = MqttClient;
    module2.exports.Store = Store;
    module2.exports.DefaultMessageIdProvider = DefaultMessageIdProvider;
    module2.exports.UniqueMessageIdProvider = UniqueMessageIdProvider;
  }
});

// src/mqtt.js
var require_mqtt3 = __commonJS({
  "src/mqtt.js"(exports2, module2) {
    "use strict";
    var mqtt = require_mqtt2();
    var gwutils2 = require_gwutils();
    var getSensorDefinition = require_sensorDefinition().getSensorDefinition;
    var phantomService2 = require_phantomService().phantomService;
    var Buffer2 = require("buffer").Buffer;
    var gwapi2 = require_gwapi();
    var { gzip } = require("zlib");
    var { promisify } = require("node:util");
    var gzipAsync = promisify(gzip);
    var connected = false;
    var mqttClient2 = class {
      static async init(gwGlobalState) {
        if (!gwGlobalState.basicconfig.mqttConfig)
          return;
        let connectionStr = gwGlobalState.basicconfig.mqttConfig.protocol + gwGlobalState.basicconfig.mqttConfig.host + ":" + gwGlobalState.basicconfig.mqttConfig.port;
        let connectOptions = {
          clientId: "PhantomGW-" + gwGlobalState.deviceInfo.serialNumber,
          username: gwGlobalState.basicconfig.mqttConfig.username,
          password: gwGlobalState.basicconfig.mqttConfig.password,
          queueQoSZero: false,
          reconnectPeriod: 1e4
        };
        if (gwGlobalState.basicconfig.mqttConfig.tlsValidation == "calist") {
        } else if (gwGlobalState.basicconfig.mqttConfig.tlsValidation == "selfsigned") {
          connectOptions.ca = gwGlobalState.basicconfig.mqttConfig.ca;
        } else {
          connectOptions.rejectUnauthorized = false;
        }
        if (gwGlobalState.basicconfig.mqttConfig.clientcert && gwGlobalState.basicconfig.mqttConfig.clientcertkey && (gwGlobalState.basicconfig.mqttConfig.protocol == "mqtts://" || gwGlobalState.basicconfig.mqttConfig.protocol == "wss://")) {
          connectOptions.cert = gwGlobalState.basicconfig.mqttConfig.clientcert;
          connectOptions.key = gwGlobalState.basicconfig.mqttConfig.clientcertkey;
        }
        const client2 = mqtt.connect(connectionStr, connectOptions);
        gwGlobalState.deviceInfo.mqtt = {
          state: "connecting"
        };
        gwutils2.gwUpdateGlobalState();
        client2.on("connect", () => {
          console.log("connect");
          connected = true;
          gwGlobalState.deviceInfo.mqtt.state = "connected";
          gwGlobalState.deviceInfo.mqtt.error = void 0;
          gwutils2.gwUpdateGlobalState();
          let subscribetopic = gwGlobalState.basicconfig.mqttConfig.managementtopic;
          if (subscribetopic == void 0)
            subscribetopic = gwGlobalState.basicconfig.mqttConfig.topic;
          let qos = gwGlobalState.basicconfig.mqttConfig.subscribeQoS;
          if (qos == void 0)
            qos = 0;
          if (gwGlobalState.basicconfig.mqttConfig.allowmanagement) {
            client2.subscribe(subscribetopic, {
              qos
            }, function(err, granted) {
              if (!err) {
              } else {
                console.log("MQTT subscribe to", subscribetopic, "failed: ", err);
              }
            });
          }
        });
        client2.on("reconnect", () => {
          console.log("MQTT trying to reconnect");
          gwGlobalState.deviceInfo.mqtt.state = "reconnecting";
          gwutils2.gwUpdateGlobalState();
        });
        client2.on("close", () => {
          console.log("MQTT connection closed");
          connected = false;
          gwGlobalState.deviceInfo.mqtt.state = "closed";
          gwutils2.gwUpdateGlobalState();
        });
        client2.on("error", (error) => {
          console.log("MQT connection error:", error.message);
          connected = false;
          gwGlobalState.deviceInfo.mqtt.state = "error";
          gwGlobalState.deviceInfo.mqtt.error = error.message;
          gwutils2.gwUpdateGlobalState();
        });
        client2.on("message", (topic, payload) => {
          try {
            let jsonMessage = JSON.parse(payload);
            if (jsonMessage.type == "requestWaveform") {
              let phantomCode = jsonMessage.phantomCode;
              let gwSerial = jsonMessage.gwSerial;
              if (gwSerial == gwGlobalState.deviceInfo.serialNumber) {
                if (gwGlobalState.nodes[phantomCode] === void 0)
                  gwGlobalState.nodes[phantomCode] = {};
                if (gwGlobalState.nodes[phantomCode].actions === void 0)
                  gwGlobalState.nodes[phantomCode].actions = {};
                if (gwGlobalState.nodes[phantomCode].actions["signal"] == void 0)
                  gwGlobalState.nodes[phantomCode].actions["signal"] = {};
                gwGlobalState.nodes[phantomCode].actions["signal"].requestTime = Date.now();
                gwutils2.gwUpdateGlobalState();
              }
            } else if (jsonMessage.type == "observeerequest" && jsonMessage.gwSerial == gwGlobalState.deviceInfo.serialNumber && gwGlobalState.basicconfig.mqttConfig.allowmanagement) {
              gwapi2.parseGWRequest(jsonMessage, {
                send: async (j) => {
                  let o2 = JSON.parse(j);
                  o2.gwSerial = gwGlobalState.deviceInfo.serialNumber;
                  let qos = gwGlobalState.basicconfig.mqttConfig.publishQoS;
                  if (qos == void 0)
                    qos = 0;
                  let topic2 = gwGlobalState.basicconfig.mqttConfig.topic;
                  if (gwGlobalState.basicconfig.mqttConfig.appendSerial) {
                    topic2 += "/" + gwGlobalState.deviceInfo.serialNumber;
                  }
                  let payload2 = JSON.stringify(o2);
                  let contentType2 = "application/json";
                  if (gwGlobalState.basicconfig.mqttConfig.compress) {
                    payload2 = await gzipAsync(payload2);
                    contentType2 = "application/gzip";
                  }
                  client2.publish(topic2, payload2, {
                    qos,
                    properties: {
                      payloadFormatIndicator: !gwGlobalState.basicconfig.mqttConfig.compress,
                      contentType: contentType2
                    }
                  });
                }
              });
            }
          } catch (e) {
            console.log("MQTT error: ", e);
          }
        });
        gwutils2.subscribeToEvent("newsignal", async (eventdata) => {
          if (!gwGlobalState.basicconfig.mqttConfig.sendwaveform)
            return;
          if (eventdata.signalData.services.mqtt?.state == "sent")
            return;
          eventdata.signalData.services.mqtt = {};
          eventdata.signalData.services.mqtt.state = "connecting";
          try {
            let mqttData = phantomService2.bigDataToJSON(eventdata, gwGlobalState);
            let qos = gwGlobalState.basicconfig.mqttConfig.publishQoS;
            if (qos == void 0)
              qos = 0;
            let topic = gwGlobalState.basicconfig.mqttConfig.topic;
            if (gwGlobalState.basicconfig.mqttConfig.appendSerial) {
              topic += "/" + gwGlobalState.deviceInfo.serialNumber + "/" + mqttData.serialNumber + "/collection";
            }
            try {
              let node = eventdata.node;
              if (node && node.settings?.friendlyName) {
                mqttData.friendlyName = node.settings.friendlyName;
              }
            } catch (e) {
            }
            let payload = JSON.stringify(mqttData);
            let contentType2 = "application/json";
            if (gwGlobalState.basicconfig.mqttConfig.compress) {
              payload = await gzipAsync(payload);
              contentType2 = "application/gzip";
            }
            client2.publish(
              topic,
              payload,
              {
                qos,
                retain: false,
                properties: {
                  payloadFormatIndicator: !gwGlobalState.basicconfig.mqttConfig.compress,
                  contentType: contentType2
                }
              },
              (err) => {
                if (err) {
                  console.log(err);
                  eventdata.signalData.services.mqtt.state = "error";
                  eventdata.signalData.services.mqtt.error = err.message;
                  gwutils2.broadcastEvent("signalfailsend", eventdata);
                } else {
                  eventdata.signalData.services.mqtt.state = "sent";
                  gwutils2.broadcastEvent("signalsent", eventdata);
                }
              }
            );
          } catch (e) {
            eventdata.signalData.services.mqtt.state = "error";
            eventdata.signalData.services.mqtt.error = e.message;
            gwutils2.broadcastEvent("signalfailsend", eventdata);
          }
        });
        gwutils2.subscribeToEvent("newphantomv1broadcast", async (eventdata) => {
          let node = gwGlobalState.nodes[eventdata.phantomCode];
          let sensorData = eventdata.nodeData;
          if (!node.settings?.isPaired)
            return;
          try {
            let mqttData = phantomService2.smallDataToJSON(sensorData, eventdata.captureTime, gwGlobalState);
            let qos = gwGlobalState.basicconfig.mqttConfig.publishQoS;
            if (qos == void 0)
              qos = 0;
            let topic = gwGlobalState.basicconfig.mqttConfig.topic;
            if (gwGlobalState.basicconfig.mqttConfig.appendSerial) {
              topic += "/" + gwGlobalState.deviceInfo.serialNumber + "/" + node.phantomCode + "/stateupdate";
            }
            let payload = JSON.stringify(mqttData);
            let contentType2 = "application/json";
            if (gwGlobalState.basicconfig.mqttConfig.compress) {
              payload = await gzipAsync(payload);
              contentType2 = "application/gzip";
            }
            client2.publish(topic, payload, {
              qos,
              properties: {
                payloadFormatIndicator: !gwGlobalState.basicconfig.mqttConfig.compress,
                contentType: contentType2
              }
            });
          } catch (e) {
          }
        });
      }
    };
    module2.exports = {
      mqttClient: mqttClient2
    };
  }
});

// src/signalGenerator.js
var require_signalGenerator = __commonJS({
  "src/signalGenerator.js"(exports2, module2) {
    function isGP(type) {
      return type == 60;
    }
    function createPhantomv1CompatibleSignalHeader(metaData, header) {
      header[0] = metaData.phantomCode & 255;
      header[1] = (metaData.phantomCode & 65280) >> 8;
      header[2] = (metaData.phantomCode & 16711680) >> 16;
      header[3] = (metaData.phantomCode & 4278190080) >> 24;
      header[4] = metaData.dataLen & 255;
      header[5] = (metaData.dataLen & 65280) >> 8;
      header[6] = (metaData.dataLen & 16711680) >> 16;
      header[7] = (metaData.dataLen & 4278190080) >> 24;
      header[8] = 1;
      header[9] = metaData.axisCount & 3 | (metaData.selectedAxis & 3) << 2;
      header[10] = metaData.sampleRate & 255;
      header[11] = (metaData.sampleRate & 65280) >> 8;
      if (isGP(metaData.type)) {
        header.writeFloatLE(metaData.calibration, 12);
      } else {
        header[12] = metaData.range;
        header[13] = 42;
        header[14] = 42;
        header[15] = 42;
      }
      let localTimestamp = Math.round(Date.now() / 1e3);
      header[16] = localTimestamp & 255;
      header[17] = (localTimestamp & 65280) >> 8;
      header[18] = (localTimestamp & 16711680) >> 16;
      header[19] = (localTimestamp & 4278190080) >> 24;
    }
    function createPhantomv1CompatibleSignal(metaData, signal) {
      const headerSize = 28;
      metaData.axisCount = signal.length;
      metaData.dataLen = metaData.axisCount * signal[0].length * 2;
      let signalBlob = Buffer.alloc(metaData.dataLen + headerSize);
      let calibration = 32768 / metaData.range;
      function convertValue(value) {
        let out = Math.round(value * calibration);
        if (out > 32767)
          out = 32767;
        else if (out < -32768)
          out = -32768;
        return out;
      }
      for (let i = 0; i < signal[0].length; i++) {
        if (metaData.axisCount == 3) {
          signalBlob.writeInt16LE(convertValue(signal[0][i]), headerSize + i * metaData.axisCount * 2 + 0);
          signalBlob.writeInt16LE(convertValue(signal[1][i]), headerSize + i * metaData.axisCount * 2 + 2);
          signalBlob.writeInt16LE(convertValue(signal[2][i]), headerSize + i * metaData.axisCount * 2 + 4);
        } else if (metaData.axisCount == 1) {
          signalBlob.writeInt16LE(convertValue(signal[0][i]), headerSize + i * metaData.axisCount * 2 + 0);
        } else {
          console.log("Error, wrong axis count");
        }
      }
      createPhantomv1CompatibleSignalHeader(metaData, signalBlob);
      return signalBlob;
    }
    function generateTriaxialSignal(metaData) {
      let signal = [];
      signal.push([]);
      signal.push([]);
      signal.push([]);
      for (let i = 0; i < metaData.samples; i++) {
        signal[0].push(Math.sin(i * 2 * Math.PI / metaData.sampleRate * metaData.frequency) * metaData.amplitude);
        signal[1].push(Math.sin(i * 2 * Math.PI / metaData.sampleRate * metaData.frequency) * metaData.amplitude);
        signal[2].push(Math.sin(i * 2 * Math.PI / metaData.sampleRate * metaData.frequency) * metaData.amplitude);
      }
      return signal;
    }
    function generateTestSignal() {
      let request = {
        phantomCode: 189302894,
        sampleRate: 25600,
        samples: 25600,
        frequency: 600,
        amplitude: 1,
        axisCount: 3,
        range: 8,
        selectedAxis: 0,
        type: 3,
        alarm: false,
        start: false
      };
      let signal = generateTriaxialSignal(request);
      let data = createPhantomv1CompatibleSignal(request, signal);
      return data;
    }
    module2.exports = {
      generateTestSignal
    };
  }
});

// node_modules/color-name/index.js
var require_color_name = __commonJS({
  "node_modules/color-name/index.js"(exports2, module2) {
    "use strict";
    module2.exports = {
      "aliceblue": [240, 248, 255],
      "antiquewhite": [250, 235, 215],
      "aqua": [0, 255, 255],
      "aquamarine": [127, 255, 212],
      "azure": [240, 255, 255],
      "beige": [245, 245, 220],
      "bisque": [255, 228, 196],
      "black": [0, 0, 0],
      "blanchedalmond": [255, 235, 205],
      "blue": [0, 0, 255],
      "blueviolet": [138, 43, 226],
      "brown": [165, 42, 42],
      "burlywood": [222, 184, 135],
      "cadetblue": [95, 158, 160],
      "chartreuse": [127, 255, 0],
      "chocolate": [210, 105, 30],
      "coral": [255, 127, 80],
      "cornflowerblue": [100, 149, 237],
      "cornsilk": [255, 248, 220],
      "crimson": [220, 20, 60],
      "cyan": [0, 255, 255],
      "darkblue": [0, 0, 139],
      "darkcyan": [0, 139, 139],
      "darkgoldenrod": [184, 134, 11],
      "darkgray": [169, 169, 169],
      "darkgreen": [0, 100, 0],
      "darkgrey": [169, 169, 169],
      "darkkhaki": [189, 183, 107],
      "darkmagenta": [139, 0, 139],
      "darkolivegreen": [85, 107, 47],
      "darkorange": [255, 140, 0],
      "darkorchid": [153, 50, 204],
      "darkred": [139, 0, 0],
      "darksalmon": [233, 150, 122],
      "darkseagreen": [143, 188, 143],
      "darkslateblue": [72, 61, 139],
      "darkslategray": [47, 79, 79],
      "darkslategrey": [47, 79, 79],
      "darkturquoise": [0, 206, 209],
      "darkviolet": [148, 0, 211],
      "deeppink": [255, 20, 147],
      "deepskyblue": [0, 191, 255],
      "dimgray": [105, 105, 105],
      "dimgrey": [105, 105, 105],
      "dodgerblue": [30, 144, 255],
      "firebrick": [178, 34, 34],
      "floralwhite": [255, 250, 240],
      "forestgreen": [34, 139, 34],
      "fuchsia": [255, 0, 255],
      "gainsboro": [220, 220, 220],
      "ghostwhite": [248, 248, 255],
      "gold": [255, 215, 0],
      "goldenrod": [218, 165, 32],
      "gray": [128, 128, 128],
      "green": [0, 128, 0],
      "greenyellow": [173, 255, 47],
      "grey": [128, 128, 128],
      "honeydew": [240, 255, 240],
      "hotpink": [255, 105, 180],
      "indianred": [205, 92, 92],
      "indigo": [75, 0, 130],
      "ivory": [255, 255, 240],
      "khaki": [240, 230, 140],
      "lavender": [230, 230, 250],
      "lavenderblush": [255, 240, 245],
      "lawngreen": [124, 252, 0],
      "lemonchiffon": [255, 250, 205],
      "lightblue": [173, 216, 230],
      "lightcoral": [240, 128, 128],
      "lightcyan": [224, 255, 255],
      "lightgoldenrodyellow": [250, 250, 210],
      "lightgray": [211, 211, 211],
      "lightgreen": [144, 238, 144],
      "lightgrey": [211, 211, 211],
      "lightpink": [255, 182, 193],
      "lightsalmon": [255, 160, 122],
      "lightseagreen": [32, 178, 170],
      "lightskyblue": [135, 206, 250],
      "lightslategray": [119, 136, 153],
      "lightslategrey": [119, 136, 153],
      "lightsteelblue": [176, 196, 222],
      "lightyellow": [255, 255, 224],
      "lime": [0, 255, 0],
      "limegreen": [50, 205, 50],
      "linen": [250, 240, 230],
      "magenta": [255, 0, 255],
      "maroon": [128, 0, 0],
      "mediumaquamarine": [102, 205, 170],
      "mediumblue": [0, 0, 205],
      "mediumorchid": [186, 85, 211],
      "mediumpurple": [147, 112, 219],
      "mediumseagreen": [60, 179, 113],
      "mediumslateblue": [123, 104, 238],
      "mediumspringgreen": [0, 250, 154],
      "mediumturquoise": [72, 209, 204],
      "mediumvioletred": [199, 21, 133],
      "midnightblue": [25, 25, 112],
      "mintcream": [245, 255, 250],
      "mistyrose": [255, 228, 225],
      "moccasin": [255, 228, 181],
      "navajowhite": [255, 222, 173],
      "navy": [0, 0, 128],
      "oldlace": [253, 245, 230],
      "olive": [128, 128, 0],
      "olivedrab": [107, 142, 35],
      "orange": [255, 165, 0],
      "orangered": [255, 69, 0],
      "orchid": [218, 112, 214],
      "palegoldenrod": [238, 232, 170],
      "palegreen": [152, 251, 152],
      "paleturquoise": [175, 238, 238],
      "palevioletred": [219, 112, 147],
      "papayawhip": [255, 239, 213],
      "peachpuff": [255, 218, 185],
      "peru": [205, 133, 63],
      "pink": [255, 192, 203],
      "plum": [221, 160, 221],
      "powderblue": [176, 224, 230],
      "purple": [128, 0, 128],
      "rebeccapurple": [102, 51, 153],
      "red": [255, 0, 0],
      "rosybrown": [188, 143, 143],
      "royalblue": [65, 105, 225],
      "saddlebrown": [139, 69, 19],
      "salmon": [250, 128, 114],
      "sandybrown": [244, 164, 96],
      "seagreen": [46, 139, 87],
      "seashell": [255, 245, 238],
      "sienna": [160, 82, 45],
      "silver": [192, 192, 192],
      "skyblue": [135, 206, 235],
      "slateblue": [106, 90, 205],
      "slategray": [112, 128, 144],
      "slategrey": [112, 128, 144],
      "snow": [255, 250, 250],
      "springgreen": [0, 255, 127],
      "steelblue": [70, 130, 180],
      "tan": [210, 180, 140],
      "teal": [0, 128, 128],
      "thistle": [216, 191, 216],
      "tomato": [255, 99, 71],
      "turquoise": [64, 224, 208],
      "violet": [238, 130, 238],
      "wheat": [245, 222, 179],
      "white": [255, 255, 255],
      "whitesmoke": [245, 245, 245],
      "yellow": [255, 255, 0],
      "yellowgreen": [154, 205, 50]
    };
  }
});

// node_modules/color-convert/conversions.js
var require_conversions = __commonJS({
  "node_modules/color-convert/conversions.js"(exports2, module2) {
    var cssKeywords = require_color_name();
    var reverseKeywords = {};
    for (const key of Object.keys(cssKeywords)) {
      reverseKeywords[cssKeywords[key]] = key;
    }
    var convert = {
      rgb: { channels: 3, labels: "rgb" },
      hsl: { channels: 3, labels: "hsl" },
      hsv: { channels: 3, labels: "hsv" },
      hwb: { channels: 3, labels: "hwb" },
      cmyk: { channels: 4, labels: "cmyk" },
      xyz: { channels: 3, labels: "xyz" },
      lab: { channels: 3, labels: "lab" },
      lch: { channels: 3, labels: "lch" },
      hex: { channels: 1, labels: ["hex"] },
      keyword: { channels: 1, labels: ["keyword"] },
      ansi16: { channels: 1, labels: ["ansi16"] },
      ansi256: { channels: 1, labels: ["ansi256"] },
      hcg: { channels: 3, labels: ["h", "c", "g"] },
      apple: { channels: 3, labels: ["r16", "g16", "b16"] },
      gray: { channels: 1, labels: ["gray"] }
    };
    module2.exports = convert;
    for (const model of Object.keys(convert)) {
      if (!("channels" in convert[model])) {
        throw new Error("missing channels property: " + model);
      }
      if (!("labels" in convert[model])) {
        throw new Error("missing channel labels property: " + model);
      }
      if (convert[model].labels.length !== convert[model].channels) {
        throw new Error("channel and label counts mismatch: " + model);
      }
      const { channels, labels } = convert[model];
      delete convert[model].channels;
      delete convert[model].labels;
      Object.defineProperty(convert[model], "channels", { value: channels });
      Object.defineProperty(convert[model], "labels", { value: labels });
    }
    convert.rgb.hsl = function(rgb) {
      const r = rgb[0] / 255;
      const g2 = rgb[1] / 255;
      const b = rgb[2] / 255;
      const min = Math.min(r, g2, b);
      const max = Math.max(r, g2, b);
      const delta = max - min;
      let h;
      let s;
      if (max === min) {
        h = 0;
      } else if (r === max) {
        h = (g2 - b) / delta;
      } else if (g2 === max) {
        h = 2 + (b - r) / delta;
      } else if (b === max) {
        h = 4 + (r - g2) / delta;
      }
      h = Math.min(h * 60, 360);
      if (h < 0) {
        h += 360;
      }
      const l2 = (min + max) / 2;
      if (max === min) {
        s = 0;
      } else if (l2 <= 0.5) {
        s = delta / (max + min);
      } else {
        s = delta / (2 - max - min);
      }
      return [h, s * 100, l2 * 100];
    };
    convert.rgb.hsv = function(rgb) {
      let rdif;
      let gdif;
      let bdif;
      let h;
      let s;
      const r = rgb[0] / 255;
      const g2 = rgb[1] / 255;
      const b = rgb[2] / 255;
      const v = Math.max(r, g2, b);
      const diff = v - Math.min(r, g2, b);
      const diffc = function(c2) {
        return (v - c2) / 6 / diff + 1 / 2;
      };
      if (diff === 0) {
        h = 0;
        s = 0;
      } else {
        s = diff / v;
        rdif = diffc(r);
        gdif = diffc(g2);
        bdif = diffc(b);
        if (r === v) {
          h = bdif - gdif;
        } else if (g2 === v) {
          h = 1 / 3 + rdif - bdif;
        } else if (b === v) {
          h = 2 / 3 + gdif - rdif;
        }
        if (h < 0) {
          h += 1;
        } else if (h > 1) {
          h -= 1;
        }
      }
      return [
        h * 360,
        s * 100,
        v * 100
      ];
    };
    convert.rgb.hwb = function(rgb) {
      const r = rgb[0];
      const g2 = rgb[1];
      let b = rgb[2];
      const h = convert.rgb.hsl(rgb)[0];
      const w = 1 / 255 * Math.min(r, Math.min(g2, b));
      b = 1 - 1 / 255 * Math.max(r, Math.max(g2, b));
      return [h, w * 100, b * 100];
    };
    convert.rgb.cmyk = function(rgb) {
      const r = rgb[0] / 255;
      const g2 = rgb[1] / 255;
      const b = rgb[2] / 255;
      const k = Math.min(1 - r, 1 - g2, 1 - b);
      const c2 = (1 - r - k) / (1 - k) || 0;
      const m2 = (1 - g2 - k) / (1 - k) || 0;
      const y = (1 - b - k) / (1 - k) || 0;
      return [c2 * 100, m2 * 100, y * 100, k * 100];
    };
    function comparativeDistance(x2, y) {
      return (x2[0] - y[0]) ** 2 + (x2[1] - y[1]) ** 2 + (x2[2] - y[2]) ** 2;
    }
    convert.rgb.keyword = function(rgb) {
      const reversed = reverseKeywords[rgb];
      if (reversed) {
        return reversed;
      }
      let currentClosestDistance = Infinity;
      let currentClosestKeyword;
      for (const keyword of Object.keys(cssKeywords)) {
        const value = cssKeywords[keyword];
        const distance = comparativeDistance(rgb, value);
        if (distance < currentClosestDistance) {
          currentClosestDistance = distance;
          currentClosestKeyword = keyword;
        }
      }
      return currentClosestKeyword;
    };
    convert.keyword.rgb = function(keyword) {
      return cssKeywords[keyword];
    };
    convert.rgb.xyz = function(rgb) {
      let r = rgb[0] / 255;
      let g2 = rgb[1] / 255;
      let b = rgb[2] / 255;
      r = r > 0.04045 ? ((r + 0.055) / 1.055) ** 2.4 : r / 12.92;
      g2 = g2 > 0.04045 ? ((g2 + 0.055) / 1.055) ** 2.4 : g2 / 12.92;
      b = b > 0.04045 ? ((b + 0.055) / 1.055) ** 2.4 : b / 12.92;
      const x2 = r * 0.4124 + g2 * 0.3576 + b * 0.1805;
      const y = r * 0.2126 + g2 * 0.7152 + b * 0.0722;
      const z = r * 0.0193 + g2 * 0.1192 + b * 0.9505;
      return [x2 * 100, y * 100, z * 100];
    };
    convert.rgb.lab = function(rgb) {
      const xyz = convert.rgb.xyz(rgb);
      let x2 = xyz[0];
      let y = xyz[1];
      let z = xyz[2];
      x2 /= 95.047;
      y /= 100;
      z /= 108.883;
      x2 = x2 > 8856e-6 ? x2 ** (1 / 3) : 7.787 * x2 + 16 / 116;
      y = y > 8856e-6 ? y ** (1 / 3) : 7.787 * y + 16 / 116;
      z = z > 8856e-6 ? z ** (1 / 3) : 7.787 * z + 16 / 116;
      const l2 = 116 * y - 16;
      const a = 500 * (x2 - y);
      const b = 200 * (y - z);
      return [l2, a, b];
    };
    convert.hsl.rgb = function(hsl) {
      const h = hsl[0] / 360;
      const s = hsl[1] / 100;
      const l2 = hsl[2] / 100;
      let t2;
      let t3;
      let val;
      if (s === 0) {
        val = l2 * 255;
        return [val, val, val];
      }
      if (l2 < 0.5) {
        t2 = l2 * (1 + s);
      } else {
        t2 = l2 + s - l2 * s;
      }
      const t1 = 2 * l2 - t2;
      const rgb = [0, 0, 0];
      for (let i = 0; i < 3; i++) {
        t3 = h + 1 / 3 * -(i - 1);
        if (t3 < 0) {
          t3++;
        }
        if (t3 > 1) {
          t3--;
        }
        if (6 * t3 < 1) {
          val = t1 + (t2 - t1) * 6 * t3;
        } else if (2 * t3 < 1) {
          val = t2;
        } else if (3 * t3 < 2) {
          val = t1 + (t2 - t1) * (2 / 3 - t3) * 6;
        } else {
          val = t1;
        }
        rgb[i] = val * 255;
      }
      return rgb;
    };
    convert.hsl.hsv = function(hsl) {
      const h = hsl[0];
      let s = hsl[1] / 100;
      let l2 = hsl[2] / 100;
      let smin = s;
      const lmin = Math.max(l2, 0.01);
      l2 *= 2;
      s *= l2 <= 1 ? l2 : 2 - l2;
      smin *= lmin <= 1 ? lmin : 2 - lmin;
      const v = (l2 + s) / 2;
      const sv = l2 === 0 ? 2 * smin / (lmin + smin) : 2 * s / (l2 + s);
      return [h, sv * 100, v * 100];
    };
    convert.hsv.rgb = function(hsv) {
      const h = hsv[0] / 60;
      const s = hsv[1] / 100;
      let v = hsv[2] / 100;
      const hi = Math.floor(h) % 6;
      const f2 = h - Math.floor(h);
      const p3 = 255 * v * (1 - s);
      const q2 = 255 * v * (1 - s * f2);
      const t = 255 * v * (1 - s * (1 - f2));
      v *= 255;
      switch (hi) {
        case 0:
          return [v, t, p3];
        case 1:
          return [q2, v, p3];
        case 2:
          return [p3, v, t];
        case 3:
          return [p3, q2, v];
        case 4:
          return [t, p3, v];
        case 5:
          return [v, p3, q2];
      }
    };
    convert.hsv.hsl = function(hsv) {
      const h = hsv[0];
      const s = hsv[1] / 100;
      const v = hsv[2] / 100;
      const vmin = Math.max(v, 0.01);
      let sl;
      let l2;
      l2 = (2 - s) * v;
      const lmin = (2 - s) * vmin;
      sl = s * vmin;
      sl /= lmin <= 1 ? lmin : 2 - lmin;
      sl = sl || 0;
      l2 /= 2;
      return [h, sl * 100, l2 * 100];
    };
    convert.hwb.rgb = function(hwb) {
      const h = hwb[0] / 360;
      let wh = hwb[1] / 100;
      let bl = hwb[2] / 100;
      const ratio = wh + bl;
      let f2;
      if (ratio > 1) {
        wh /= ratio;
        bl /= ratio;
      }
      const i = Math.floor(6 * h);
      const v = 1 - bl;
      f2 = 6 * h - i;
      if ((i & 1) !== 0) {
        f2 = 1 - f2;
      }
      const n = wh + f2 * (v - wh);
      let r;
      let g2;
      let b;
      switch (i) {
        default:
        case 6:
        case 0:
          r = v;
          g2 = n;
          b = wh;
          break;
        case 1:
          r = n;
          g2 = v;
          b = wh;
          break;
        case 2:
          r = wh;
          g2 = v;
          b = n;
          break;
        case 3:
          r = wh;
          g2 = n;
          b = v;
          break;
        case 4:
          r = n;
          g2 = wh;
          b = v;
          break;
        case 5:
          r = v;
          g2 = wh;
          b = n;
          break;
      }
      return [r * 255, g2 * 255, b * 255];
    };
    convert.cmyk.rgb = function(cmyk) {
      const c2 = cmyk[0] / 100;
      const m2 = cmyk[1] / 100;
      const y = cmyk[2] / 100;
      const k = cmyk[3] / 100;
      const r = 1 - Math.min(1, c2 * (1 - k) + k);
      const g2 = 1 - Math.min(1, m2 * (1 - k) + k);
      const b = 1 - Math.min(1, y * (1 - k) + k);
      return [r * 255, g2 * 255, b * 255];
    };
    convert.xyz.rgb = function(xyz) {
      const x2 = xyz[0] / 100;
      const y = xyz[1] / 100;
      const z = xyz[2] / 100;
      let r;
      let g2;
      let b;
      r = x2 * 3.2406 + y * -1.5372 + z * -0.4986;
      g2 = x2 * -0.9689 + y * 1.8758 + z * 0.0415;
      b = x2 * 0.0557 + y * -0.204 + z * 1.057;
      r = r > 31308e-7 ? 1.055 * r ** (1 / 2.4) - 0.055 : r * 12.92;
      g2 = g2 > 31308e-7 ? 1.055 * g2 ** (1 / 2.4) - 0.055 : g2 * 12.92;
      b = b > 31308e-7 ? 1.055 * b ** (1 / 2.4) - 0.055 : b * 12.92;
      r = Math.min(Math.max(0, r), 1);
      g2 = Math.min(Math.max(0, g2), 1);
      b = Math.min(Math.max(0, b), 1);
      return [r * 255, g2 * 255, b * 255];
    };
    convert.xyz.lab = function(xyz) {
      let x2 = xyz[0];
      let y = xyz[1];
      let z = xyz[2];
      x2 /= 95.047;
      y /= 100;
      z /= 108.883;
      x2 = x2 > 8856e-6 ? x2 ** (1 / 3) : 7.787 * x2 + 16 / 116;
      y = y > 8856e-6 ? y ** (1 / 3) : 7.787 * y + 16 / 116;
      z = z > 8856e-6 ? z ** (1 / 3) : 7.787 * z + 16 / 116;
      const l2 = 116 * y - 16;
      const a = 500 * (x2 - y);
      const b = 200 * (y - z);
      return [l2, a, b];
    };
    convert.lab.xyz = function(lab) {
      const l2 = lab[0];
      const a = lab[1];
      const b = lab[2];
      let x2;
      let y;
      let z;
      y = (l2 + 16) / 116;
      x2 = a / 500 + y;
      z = y - b / 200;
      const y2 = y ** 3;
      const x22 = x2 ** 3;
      const z2 = z ** 3;
      y = y2 > 8856e-6 ? y2 : (y - 16 / 116) / 7.787;
      x2 = x22 > 8856e-6 ? x22 : (x2 - 16 / 116) / 7.787;
      z = z2 > 8856e-6 ? z2 : (z - 16 / 116) / 7.787;
      x2 *= 95.047;
      y *= 100;
      z *= 108.883;
      return [x2, y, z];
    };
    convert.lab.lch = function(lab) {
      const l2 = lab[0];
      const a = lab[1];
      const b = lab[2];
      let h;
      const hr = Math.atan2(b, a);
      h = hr * 360 / 2 / Math.PI;
      if (h < 0) {
        h += 360;
      }
      const c2 = Math.sqrt(a * a + b * b);
      return [l2, c2, h];
    };
    convert.lch.lab = function(lch) {
      const l2 = lch[0];
      const c2 = lch[1];
      const h = lch[2];
      const hr = h / 360 * 2 * Math.PI;
      const a = c2 * Math.cos(hr);
      const b = c2 * Math.sin(hr);
      return [l2, a, b];
    };
    convert.rgb.ansi16 = function(args, saturation = null) {
      const [r, g2, b] = args;
      let value = saturation === null ? convert.rgb.hsv(args)[2] : saturation;
      value = Math.round(value / 50);
      if (value === 0) {
        return 30;
      }
      let ansi = 30 + (Math.round(b / 255) << 2 | Math.round(g2 / 255) << 1 | Math.round(r / 255));
      if (value === 2) {
        ansi += 60;
      }
      return ansi;
    };
    convert.hsv.ansi16 = function(args) {
      return convert.rgb.ansi16(convert.hsv.rgb(args), args[2]);
    };
    convert.rgb.ansi256 = function(args) {
      const r = args[0];
      const g2 = args[1];
      const b = args[2];
      if (r === g2 && g2 === b) {
        if (r < 8) {
          return 16;
        }
        if (r > 248) {
          return 231;
        }
        return Math.round((r - 8) / 247 * 24) + 232;
      }
      const ansi = 16 + 36 * Math.round(r / 255 * 5) + 6 * Math.round(g2 / 255 * 5) + Math.round(b / 255 * 5);
      return ansi;
    };
    convert.ansi16.rgb = function(args) {
      let color = args % 10;
      if (color === 0 || color === 7) {
        if (args > 50) {
          color += 3.5;
        }
        color = color / 10.5 * 255;
        return [color, color, color];
      }
      const mult = (~~(args > 50) + 1) * 0.5;
      const r = (color & 1) * mult * 255;
      const g2 = (color >> 1 & 1) * mult * 255;
      const b = (color >> 2 & 1) * mult * 255;
      return [r, g2, b];
    };
    convert.ansi256.rgb = function(args) {
      if (args >= 232) {
        const c2 = (args - 232) * 10 + 8;
        return [c2, c2, c2];
      }
      args -= 16;
      let rem;
      const r = Math.floor(args / 36) / 5 * 255;
      const g2 = Math.floor((rem = args % 36) / 6) / 5 * 255;
      const b = rem % 6 / 5 * 255;
      return [r, g2, b];
    };
    convert.rgb.hex = function(args) {
      const integer = ((Math.round(args[0]) & 255) << 16) + ((Math.round(args[1]) & 255) << 8) + (Math.round(args[2]) & 255);
      const string = integer.toString(16).toUpperCase();
      return "000000".substring(string.length) + string;
    };
    convert.hex.rgb = function(args) {
      const match = args.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);
      if (!match) {
        return [0, 0, 0];
      }
      let colorString = match[0];
      if (match[0].length === 3) {
        colorString = colorString.split("").map((char) => {
          return char + char;
        }).join("");
      }
      const integer = parseInt(colorString, 16);
      const r = integer >> 16 & 255;
      const g2 = integer >> 8 & 255;
      const b = integer & 255;
      return [r, g2, b];
    };
    convert.rgb.hcg = function(rgb) {
      const r = rgb[0] / 255;
      const g2 = rgb[1] / 255;
      const b = rgb[2] / 255;
      const max = Math.max(Math.max(r, g2), b);
      const min = Math.min(Math.min(r, g2), b);
      const chroma = max - min;
      let grayscale;
      let hue;
      if (chroma < 1) {
        grayscale = min / (1 - chroma);
      } else {
        grayscale = 0;
      }
      if (chroma <= 0) {
        hue = 0;
      } else if (max === r) {
        hue = (g2 - b) / chroma % 6;
      } else if (max === g2) {
        hue = 2 + (b - r) / chroma;
      } else {
        hue = 4 + (r - g2) / chroma;
      }
      hue /= 6;
      hue %= 1;
      return [hue * 360, chroma * 100, grayscale * 100];
    };
    convert.hsl.hcg = function(hsl) {
      const s = hsl[1] / 100;
      const l2 = hsl[2] / 100;
      const c2 = l2 < 0.5 ? 2 * s * l2 : 2 * s * (1 - l2);
      let f2 = 0;
      if (c2 < 1) {
        f2 = (l2 - 0.5 * c2) / (1 - c2);
      }
      return [hsl[0], c2 * 100, f2 * 100];
    };
    convert.hsv.hcg = function(hsv) {
      const s = hsv[1] / 100;
      const v = hsv[2] / 100;
      const c2 = s * v;
      let f2 = 0;
      if (c2 < 1) {
        f2 = (v - c2) / (1 - c2);
      }
      return [hsv[0], c2 * 100, f2 * 100];
    };
    convert.hcg.rgb = function(hcg) {
      const h = hcg[0] / 360;
      const c2 = hcg[1] / 100;
      const g2 = hcg[2] / 100;
      if (c2 === 0) {
        return [g2 * 255, g2 * 255, g2 * 255];
      }
      const pure = [0, 0, 0];
      const hi = h % 1 * 6;
      const v = hi % 1;
      const w = 1 - v;
      let mg = 0;
      switch (Math.floor(hi)) {
        case 0:
          pure[0] = 1;
          pure[1] = v;
          pure[2] = 0;
          break;
        case 1:
          pure[0] = w;
          pure[1] = 1;
          pure[2] = 0;
          break;
        case 2:
          pure[0] = 0;
          pure[1] = 1;
          pure[2] = v;
          break;
        case 3:
          pure[0] = 0;
          pure[1] = w;
          pure[2] = 1;
          break;
        case 4:
          pure[0] = v;
          pure[1] = 0;
          pure[2] = 1;
          break;
        default:
          pure[0] = 1;
          pure[1] = 0;
          pure[2] = w;
      }
      mg = (1 - c2) * g2;
      return [
        (c2 * pure[0] + mg) * 255,
        (c2 * pure[1] + mg) * 255,
        (c2 * pure[2] + mg) * 255
      ];
    };
    convert.hcg.hsv = function(hcg) {
      const c2 = hcg[1] / 100;
      const g2 = hcg[2] / 100;
      const v = c2 + g2 * (1 - c2);
      let f2 = 0;
      if (v > 0) {
        f2 = c2 / v;
      }
      return [hcg[0], f2 * 100, v * 100];
    };
    convert.hcg.hsl = function(hcg) {
      const c2 = hcg[1] / 100;
      const g2 = hcg[2] / 100;
      const l2 = g2 * (1 - c2) + 0.5 * c2;
      let s = 0;
      if (l2 > 0 && l2 < 0.5) {
        s = c2 / (2 * l2);
      } else if (l2 >= 0.5 && l2 < 1) {
        s = c2 / (2 * (1 - l2));
      }
      return [hcg[0], s * 100, l2 * 100];
    };
    convert.hcg.hwb = function(hcg) {
      const c2 = hcg[1] / 100;
      const g2 = hcg[2] / 100;
      const v = c2 + g2 * (1 - c2);
      return [hcg[0], (v - c2) * 100, (1 - v) * 100];
    };
    convert.hwb.hcg = function(hwb) {
      const w = hwb[1] / 100;
      const b = hwb[2] / 100;
      const v = 1 - b;
      const c2 = v - w;
      let g2 = 0;
      if (c2 < 1) {
        g2 = (v - c2) / (1 - c2);
      }
      return [hwb[0], c2 * 100, g2 * 100];
    };
    convert.apple.rgb = function(apple) {
      return [apple[0] / 65535 * 255, apple[1] / 65535 * 255, apple[2] / 65535 * 255];
    };
    convert.rgb.apple = function(rgb) {
      return [rgb[0] / 255 * 65535, rgb[1] / 255 * 65535, rgb[2] / 255 * 65535];
    };
    convert.gray.rgb = function(args) {
      return [args[0] / 100 * 255, args[0] / 100 * 255, args[0] / 100 * 255];
    };
    convert.gray.hsl = function(args) {
      return [0, 0, args[0]];
    };
    convert.gray.hsv = convert.gray.hsl;
    convert.gray.hwb = function(gray) {
      return [0, 100, gray[0]];
    };
    convert.gray.cmyk = function(gray) {
      return [0, 0, 0, gray[0]];
    };
    convert.gray.lab = function(gray) {
      return [gray[0], 0, 0];
    };
    convert.gray.hex = function(gray) {
      const val = Math.round(gray[0] / 100 * 255) & 255;
      const integer = (val << 16) + (val << 8) + val;
      const string = integer.toString(16).toUpperCase();
      return "000000".substring(string.length) + string;
    };
    convert.rgb.gray = function(rgb) {
      const val = (rgb[0] + rgb[1] + rgb[2]) / 3;
      return [val / 255 * 100];
    };
  }
});

// node_modules/color-convert/route.js
var require_route = __commonJS({
  "node_modules/color-convert/route.js"(exports2, module2) {
    var conversions = require_conversions();
    function buildGraph() {
      const graph = {};
      const models = Object.keys(conversions);
      for (let len = models.length, i = 0; i < len; i++) {
        graph[models[i]] = {
          // http://jsperf.com/1-vs-infinity
          // micro-opt, but this is simple.
          distance: -1,
          parent: null
        };
      }
      return graph;
    }
    function deriveBFS(fromModel) {
      const graph = buildGraph();
      const queue = [fromModel];
      graph[fromModel].distance = 0;
      while (queue.length) {
        const current = queue.pop();
        const adjacents = Object.keys(conversions[current]);
        for (let len = adjacents.length, i = 0; i < len; i++) {
          const adjacent = adjacents[i];
          const node = graph[adjacent];
          if (node.distance === -1) {
            node.distance = graph[current].distance + 1;
            node.parent = current;
            queue.unshift(adjacent);
          }
        }
      }
      return graph;
    }
    function link(from, to) {
      return function(args) {
        return to(from(args));
      };
    }
    function wrapConversion(toModel, graph) {
      const path3 = [graph[toModel].parent, toModel];
      let fn = conversions[graph[toModel].parent][toModel];
      let cur = graph[toModel].parent;
      while (graph[cur].parent) {
        path3.unshift(graph[cur].parent);
        fn = link(conversions[graph[cur].parent][cur], fn);
        cur = graph[cur].parent;
      }
      fn.conversion = path3;
      return fn;
    }
    module2.exports = function(fromModel) {
      const graph = deriveBFS(fromModel);
      const conversion = {};
      const models = Object.keys(graph);
      for (let len = models.length, i = 0; i < len; i++) {
        const toModel = models[i];
        const node = graph[toModel];
        if (node.parent === null) {
          continue;
        }
        conversion[toModel] = wrapConversion(toModel, graph);
      }
      return conversion;
    };
  }
});

// node_modules/color-convert/index.js
var require_color_convert = __commonJS({
  "node_modules/color-convert/index.js"(exports2, module2) {
    var conversions = require_conversions();
    var route = require_route();
    var convert = {};
    var models = Object.keys(conversions);
    function wrapRaw(fn) {
      const wrappedFn = function(...args) {
        const arg0 = args[0];
        if (arg0 === void 0 || arg0 === null) {
          return arg0;
        }
        if (arg0.length > 1) {
          args = arg0;
        }
        return fn(args);
      };
      if ("conversion" in fn) {
        wrappedFn.conversion = fn.conversion;
      }
      return wrappedFn;
    }
    function wrapRounded(fn) {
      const wrappedFn = function(...args) {
        const arg0 = args[0];
        if (arg0 === void 0 || arg0 === null) {
          return arg0;
        }
        if (arg0.length > 1) {
          args = arg0;
        }
        const result2 = fn(args);
        if (typeof result2 === "object") {
          for (let len = result2.length, i = 0; i < len; i++) {
            result2[i] = Math.round(result2[i]);
          }
        }
        return result2;
      };
      if ("conversion" in fn) {
        wrappedFn.conversion = fn.conversion;
      }
      return wrappedFn;
    }
    models.forEach((fromModel) => {
      convert[fromModel] = {};
      Object.defineProperty(convert[fromModel], "channels", { value: conversions[fromModel].channels });
      Object.defineProperty(convert[fromModel], "labels", { value: conversions[fromModel].labels });
      const routes = route(fromModel);
      const routeModels = Object.keys(routes);
      routeModels.forEach((toModel) => {
        const fn = routes[toModel];
        convert[fromModel][toModel] = wrapRounded(fn);
        convert[fromModel][toModel].raw = wrapRaw(fn);
      });
    });
    module2.exports = convert;
  }
});

// node_modules/ansi-styles/index.js
var require_ansi_styles = __commonJS({
  "node_modules/ansi-styles/index.js"(exports2, module2) {
    "use strict";
    var wrapAnsi16 = (fn, offset) => (...args) => {
      const code = fn(...args);
      return `\x1B[${code + offset}m`;
    };
    var wrapAnsi256 = (fn, offset) => (...args) => {
      const code = fn(...args);
      return `\x1B[${38 + offset};5;${code}m`;
    };
    var wrapAnsi16m = (fn, offset) => (...args) => {
      const rgb = fn(...args);
      return `\x1B[${38 + offset};2;${rgb[0]};${rgb[1]};${rgb[2]}m`;
    };
    var ansi2ansi = (n) => n;
    var rgb2rgb = (r, g2, b) => [r, g2, b];
    var setLazyProperty = (object, property, get) => {
      Object.defineProperty(object, property, {
        get: () => {
          const value = get();
          Object.defineProperty(object, property, {
            value,
            enumerable: true,
            configurable: true
          });
          return value;
        },
        enumerable: true,
        configurable: true
      });
    };
    var colorConvert;
    var makeDynamicStyles = (wrap, targetSpace, identity, isBackground) => {
      if (colorConvert === void 0) {
        colorConvert = require_color_convert();
      }
      const offset = isBackground ? 10 : 0;
      const styles = {};
      for (const [sourceSpace, suite] of Object.entries(colorConvert)) {
        const name = sourceSpace === "ansi16" ? "ansi" : sourceSpace;
        if (sourceSpace === targetSpace) {
          styles[name] = wrap(identity, offset);
        } else if (typeof suite === "object") {
          styles[name] = wrap(suite[targetSpace], offset);
        }
      }
      return styles;
    };
    function assembleStyles() {
      const codes = /* @__PURE__ */ new Map();
      const styles = {
        modifier: {
          reset: [0, 0],
          // 21 isn't widely supported and 22 does the same thing
          bold: [1, 22],
          dim: [2, 22],
          italic: [3, 23],
          underline: [4, 24],
          inverse: [7, 27],
          hidden: [8, 28],
          strikethrough: [9, 29]
        },
        color: {
          black: [30, 39],
          red: [31, 39],
          green: [32, 39],
          yellow: [33, 39],
          blue: [34, 39],
          magenta: [35, 39],
          cyan: [36, 39],
          white: [37, 39],
          // Bright color
          blackBright: [90, 39],
          redBright: [91, 39],
          greenBright: [92, 39],
          yellowBright: [93, 39],
          blueBright: [94, 39],
          magentaBright: [95, 39],
          cyanBright: [96, 39],
          whiteBright: [97, 39]
        },
        bgColor: {
          bgBlack: [40, 49],
          bgRed: [41, 49],
          bgGreen: [42, 49],
          bgYellow: [43, 49],
          bgBlue: [44, 49],
          bgMagenta: [45, 49],
          bgCyan: [46, 49],
          bgWhite: [47, 49],
          // Bright color
          bgBlackBright: [100, 49],
          bgRedBright: [101, 49],
          bgGreenBright: [102, 49],
          bgYellowBright: [103, 49],
          bgBlueBright: [104, 49],
          bgMagentaBright: [105, 49],
          bgCyanBright: [106, 49],
          bgWhiteBright: [107, 49]
        }
      };
      styles.color.gray = styles.color.blackBright;
      styles.bgColor.bgGray = styles.bgColor.bgBlackBright;
      styles.color.grey = styles.color.blackBright;
      styles.bgColor.bgGrey = styles.bgColor.bgBlackBright;
      for (const [groupName, group] of Object.entries(styles)) {
        for (const [styleName, style] of Object.entries(group)) {
          styles[styleName] = {
            open: `\x1B[${style[0]}m`,
            close: `\x1B[${style[1]}m`
          };
          group[styleName] = styles[styleName];
          codes.set(style[0], style[1]);
        }
        Object.defineProperty(styles, groupName, {
          value: group,
          enumerable: false
        });
      }
      Object.defineProperty(styles, "codes", {
        value: codes,
        enumerable: false
      });
      styles.color.close = "\x1B[39m";
      styles.bgColor.close = "\x1B[49m";
      setLazyProperty(styles.color, "ansi", () => makeDynamicStyles(wrapAnsi16, "ansi16", ansi2ansi, false));
      setLazyProperty(styles.color, "ansi256", () => makeDynamicStyles(wrapAnsi256, "ansi256", ansi2ansi, false));
      setLazyProperty(styles.color, "ansi16m", () => makeDynamicStyles(wrapAnsi16m, "rgb", rgb2rgb, false));
      setLazyProperty(styles.bgColor, "ansi", () => makeDynamicStyles(wrapAnsi16, "ansi16", ansi2ansi, true));
      setLazyProperty(styles.bgColor, "ansi256", () => makeDynamicStyles(wrapAnsi256, "ansi256", ansi2ansi, true));
      setLazyProperty(styles.bgColor, "ansi16m", () => makeDynamicStyles(wrapAnsi16m, "rgb", rgb2rgb, true));
      return styles;
    }
    Object.defineProperty(module2, "exports", {
      enumerable: true,
      get: assembleStyles
    });
  }
});

// node_modules/chalk/source/util.js
var require_util = __commonJS({
  "node_modules/chalk/source/util.js"(exports2, module2) {
    "use strict";
    var stringReplaceAll = (string, substring, replacer) => {
      let index = string.indexOf(substring);
      if (index === -1) {
        return string;
      }
      const substringLength = substring.length;
      let endIndex = 0;
      let returnValue = "";
      do {
        returnValue += string.substr(endIndex, index - endIndex) + substring + replacer;
        endIndex = index + substringLength;
        index = string.indexOf(substring, endIndex);
      } while (index !== -1);
      returnValue += string.substr(endIndex);
      return returnValue;
    };
    var stringEncaseCRLFWithFirstIndex = (string, prefix, postfix, index) => {
      let endIndex = 0;
      let returnValue = "";
      do {
        const gotCR = string[index - 1] === "\r";
        returnValue += string.substr(endIndex, (gotCR ? index - 1 : index) - endIndex) + prefix + (gotCR ? "\r\n" : "\n") + postfix;
        endIndex = index + 1;
        index = string.indexOf("\n", endIndex);
      } while (index !== -1);
      returnValue += string.substr(endIndex);
      return returnValue;
    };
    module2.exports = {
      stringReplaceAll,
      stringEncaseCRLFWithFirstIndex
    };
  }
});

// node_modules/chalk/source/templates.js
var require_templates = __commonJS({
  "node_modules/chalk/source/templates.js"(exports2, module2) {
    "use strict";
    var TEMPLATE_REGEX = /(?:\\(u(?:[a-f\d]{4}|\{[a-f\d]{1,6}\})|x[a-f\d]{2}|.))|(?:\{(~)?(\w+(?:\([^)]*\))?(?:\.\w+(?:\([^)]*\))?)*)(?:[ \t]|(?=\r?\n)))|(\})|((?:.|[\r\n\f])+?)/gi;
    var STYLE_REGEX = /(?:^|\.)(\w+)(?:\(([^)]*)\))?/g;
    var STRING_REGEX = /^(['"])((?:\\.|(?!\1)[^\\])*)\1$/;
    var ESCAPE_REGEX = /\\(u(?:[a-f\d]{4}|{[a-f\d]{1,6}})|x[a-f\d]{2}|.)|([^\\])/gi;
    var ESCAPES = /* @__PURE__ */ new Map([
      ["n", "\n"],
      ["r", "\r"],
      ["t", "	"],
      ["b", "\b"],
      ["f", "\f"],
      ["v", "\v"],
      ["0", "\0"],
      ["\\", "\\"],
      ["e", "\x1B"],
      ["a", "\x07"]
    ]);
    function unescape2(c2) {
      const u2 = c2[0] === "u";
      const bracket = c2[1] === "{";
      if (u2 && !bracket && c2.length === 5 || c2[0] === "x" && c2.length === 3) {
        return String.fromCharCode(parseInt(c2.slice(1), 16));
      }
      if (u2 && bracket) {
        return String.fromCodePoint(parseInt(c2.slice(2, -1), 16));
      }
      return ESCAPES.get(c2) || c2;
    }
    function parseArguments(name, arguments_) {
      const results = [];
      const chunks = arguments_.trim().split(/\s*,\s*/g);
      let matches;
      for (const chunk of chunks) {
        const number = Number(chunk);
        if (!Number.isNaN(number)) {
          results.push(number);
        } else if (matches = chunk.match(STRING_REGEX)) {
          results.push(matches[2].replace(ESCAPE_REGEX, (m2, escape2, character) => escape2 ? unescape2(escape2) : character));
        } else {
          throw new Error(`Invalid Chalk template style argument: ${chunk} (in style '${name}')`);
        }
      }
      return results;
    }
    function parseStyle(style) {
      STYLE_REGEX.lastIndex = 0;
      const results = [];
      let matches;
      while ((matches = STYLE_REGEX.exec(style)) !== null) {
        const name = matches[1];
        if (matches[2]) {
          const args = parseArguments(name, matches[2]);
          results.push([name].concat(args));
        } else {
          results.push([name]);
        }
      }
      return results;
    }
    function buildStyle(chalk, styles) {
      const enabled = {};
      for (const layer of styles) {
        for (const style of layer.styles) {
          enabled[style[0]] = layer.inverse ? null : style.slice(1);
        }
      }
      let current = chalk;
      for (const [styleName, styles2] of Object.entries(enabled)) {
        if (!Array.isArray(styles2)) {
          continue;
        }
        if (!(styleName in current)) {
          throw new Error(`Unknown Chalk style: ${styleName}`);
        }
        current = styles2.length > 0 ? current[styleName](...styles2) : current[styleName];
      }
      return current;
    }
    module2.exports = (chalk, temporary) => {
      const styles = [];
      const chunks = [];
      let chunk = [];
      temporary.replace(TEMPLATE_REGEX, (m2, escapeCharacter, inverse, style, close, character) => {
        if (escapeCharacter) {
          chunk.push(unescape2(escapeCharacter));
        } else if (style) {
          const string = chunk.join("");
          chunk = [];
          chunks.push(styles.length === 0 ? string : buildStyle(chalk, styles)(string));
          styles.push({ inverse, styles: parseStyle(style) });
        } else if (close) {
          if (styles.length === 0) {
            throw new Error("Found extraneous } in Chalk template literal");
          }
          chunks.push(buildStyle(chalk, styles)(chunk.join("")));
          chunk = [];
          styles.pop();
        } else {
          chunk.push(character);
        }
      });
      chunks.push(chunk.join(""));
      if (styles.length > 0) {
        const errMessage = `Chalk template literal is missing ${styles.length} closing bracket${styles.length === 1 ? "" : "s"} (\`}\`)`;
        throw new Error(errMessage);
      }
      return chunks.join("");
    };
  }
});

// node_modules/chalk/source/index.js
var require_source = __commonJS({
  "node_modules/chalk/source/index.js"(exports2, module2) {
    "use strict";
    var ansiStyles = require_ansi_styles();
    var { stdout: stdoutColor, stderr: stderrColor } = require_supports_color();
    var {
      stringReplaceAll,
      stringEncaseCRLFWithFirstIndex
    } = require_util();
    var { isArray } = Array;
    var levelMapping = [
      "ansi",
      "ansi",
      "ansi256",
      "ansi16m"
    ];
    var styles = /* @__PURE__ */ Object.create(null);
    var applyOptions = (object, options = {}) => {
      if (options.level && !(Number.isInteger(options.level) && options.level >= 0 && options.level <= 3)) {
        throw new Error("The `level` option should be an integer from 0 to 3");
      }
      const colorLevel = stdoutColor ? stdoutColor.level : 0;
      object.level = options.level === void 0 ? colorLevel : options.level;
    };
    var ChalkClass = class {
      constructor(options) {
        return chalkFactory(options);
      }
    };
    var chalkFactory = (options) => {
      const chalk2 = {};
      applyOptions(chalk2, options);
      chalk2.template = (...arguments_) => chalkTag(chalk2.template, ...arguments_);
      Object.setPrototypeOf(chalk2, Chalk.prototype);
      Object.setPrototypeOf(chalk2.template, chalk2);
      chalk2.template.constructor = () => {
        throw new Error("`chalk.constructor()` is deprecated. Use `new chalk.Instance()` instead.");
      };
      chalk2.template.Instance = ChalkClass;
      return chalk2.template;
    };
    function Chalk(options) {
      return chalkFactory(options);
    }
    for (const [styleName, style] of Object.entries(ansiStyles)) {
      styles[styleName] = {
        get() {
          const builder = createBuilder(this, createStyler(style.open, style.close, this._styler), this._isEmpty);
          Object.defineProperty(this, styleName, { value: builder });
          return builder;
        }
      };
    }
    styles.visible = {
      get() {
        const builder = createBuilder(this, this._styler, true);
        Object.defineProperty(this, "visible", { value: builder });
        return builder;
      }
    };
    var usedModels = ["rgb", "hex", "keyword", "hsl", "hsv", "hwb", "ansi", "ansi256"];
    for (const model of usedModels) {
      styles[model] = {
        get() {
          const { level } = this;
          return function(...arguments_) {
            const styler = createStyler(ansiStyles.color[levelMapping[level]][model](...arguments_), ansiStyles.color.close, this._styler);
            return createBuilder(this, styler, this._isEmpty);
          };
        }
      };
    }
    for (const model of usedModels) {
      const bgModel = "bg" + model[0].toUpperCase() + model.slice(1);
      styles[bgModel] = {
        get() {
          const { level } = this;
          return function(...arguments_) {
            const styler = createStyler(ansiStyles.bgColor[levelMapping[level]][model](...arguments_), ansiStyles.bgColor.close, this._styler);
            return createBuilder(this, styler, this._isEmpty);
          };
        }
      };
    }
    var proto = Object.defineProperties(() => {
    }, {
      ...styles,
      level: {
        enumerable: true,
        get() {
          return this._generator.level;
        },
        set(level) {
          this._generator.level = level;
        }
      }
    });
    var createStyler = (open, close, parent) => {
      let openAll;
      let closeAll;
      if (parent === void 0) {
        openAll = open;
        closeAll = close;
      } else {
        openAll = parent.openAll + open;
        closeAll = close + parent.closeAll;
      }
      return {
        open,
        close,
        openAll,
        closeAll,
        parent
      };
    };
    var createBuilder = (self2, _styler, _isEmpty) => {
      const builder = (...arguments_) => {
        if (isArray(arguments_[0]) && isArray(arguments_[0].raw)) {
          return applyStyle(builder, chalkTag(builder, ...arguments_));
        }
        return applyStyle(builder, arguments_.length === 1 ? "" + arguments_[0] : arguments_.join(" "));
      };
      Object.setPrototypeOf(builder, proto);
      builder._generator = self2;
      builder._styler = _styler;
      builder._isEmpty = _isEmpty;
      return builder;
    };
    var applyStyle = (self2, string) => {
      if (self2.level <= 0 || !string) {
        return self2._isEmpty ? "" : string;
      }
      let styler = self2._styler;
      if (styler === void 0) {
        return string;
      }
      const { openAll, closeAll } = styler;
      if (string.indexOf("\x1B") !== -1) {
        while (styler !== void 0) {
          string = stringReplaceAll(string, styler.close, styler.open);
          styler = styler.parent;
        }
      }
      const lfIndex = string.indexOf("\n");
      if (lfIndex !== -1) {
        string = stringEncaseCRLFWithFirstIndex(string, closeAll, openAll, lfIndex);
      }
      return openAll + string + closeAll;
    };
    var template;
    var chalkTag = (chalk2, ...strings) => {
      const [firstString] = strings;
      if (!isArray(firstString) || !isArray(firstString.raw)) {
        return strings.join(" ");
      }
      const arguments_ = strings.slice(1);
      const parts = [firstString.raw[0]];
      for (let i = 1; i < firstString.length; i++) {
        parts.push(
          String(arguments_[i - 1]).replace(/[{}\\]/g, "\\$&"),
          String(firstString.raw[i])
        );
      }
      if (template === void 0) {
        template = require_templates();
      }
      return template(chalk2, parts.join(""));
    };
    Object.defineProperties(Chalk.prototype, styles);
    var chalk = Chalk();
    chalk.supportsColor = stdoutColor;
    chalk.stderr = Chalk({ level: stderrColor ? stderrColor.level : 0 });
    chalk.stderr.supportsColor = stderrColor;
    module2.exports = chalk;
  }
});

// node_modules/semver/internal/constants.js
var require_constants4 = __commonJS({
  "node_modules/semver/internal/constants.js"(exports2, module2) {
    var SEMVER_SPEC_VERSION = "2.0.0";
    var MAX_LENGTH = 256;
    var MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER || /* istanbul ignore next */
    9007199254740991;
    var MAX_SAFE_COMPONENT_LENGTH = 16;
    var MAX_SAFE_BUILD_LENGTH = MAX_LENGTH - 6;
    var RELEASE_TYPES = [
      "major",
      "premajor",
      "minor",
      "preminor",
      "patch",
      "prepatch",
      "prerelease"
    ];
    module2.exports = {
      MAX_LENGTH,
      MAX_SAFE_COMPONENT_LENGTH,
      MAX_SAFE_BUILD_LENGTH,
      MAX_SAFE_INTEGER,
      RELEASE_TYPES,
      SEMVER_SPEC_VERSION,
      FLAG_INCLUDE_PRERELEASE: 1,
      FLAG_LOOSE: 2
    };
  }
});

// node_modules/semver/internal/debug.js
var require_debug2 = __commonJS({
  "node_modules/semver/internal/debug.js"(exports2, module2) {
    var debug = typeof process === "object" && process.env && process.env.NODE_DEBUG && /\bsemver\b/i.test(process.env.NODE_DEBUG) ? (...args) => console.error("SEMVER", ...args) : () => {
    };
    module2.exports = debug;
  }
});

// node_modules/semver/internal/re.js
var require_re = __commonJS({
  "node_modules/semver/internal/re.js"(exports2, module2) {
    var {
      MAX_SAFE_COMPONENT_LENGTH,
      MAX_SAFE_BUILD_LENGTH,
      MAX_LENGTH
    } = require_constants4();
    var debug = require_debug2();
    exports2 = module2.exports = {};
    var re = exports2.re = [];
    var safeRe = exports2.safeRe = [];
    var src = exports2.src = [];
    var t = exports2.t = {};
    var R2 = 0;
    var LETTERDASHNUMBER = "[a-zA-Z0-9-]";
    var safeRegexReplacements = [
      ["\\s", 1],
      ["\\d", MAX_LENGTH],
      [LETTERDASHNUMBER, MAX_SAFE_BUILD_LENGTH]
    ];
    var makeSafeRegex = (value) => {
      for (const [token, max] of safeRegexReplacements) {
        value = value.split(`${token}*`).join(`${token}{0,${max}}`).split(`${token}+`).join(`${token}{1,${max}}`);
      }
      return value;
    };
    var createToken = (name, value, isGlobal) => {
      const safe = makeSafeRegex(value);
      const index = R2++;
      debug(name, index, value);
      t[name] = index;
      src[index] = value;
      re[index] = new RegExp(value, isGlobal ? "g" : void 0);
      safeRe[index] = new RegExp(safe, isGlobal ? "g" : void 0);
    };
    createToken("NUMERICIDENTIFIER", "0|[1-9]\\d*");
    createToken("NUMERICIDENTIFIERLOOSE", "\\d+");
    createToken("NONNUMERICIDENTIFIER", `\\d*[a-zA-Z-]${LETTERDASHNUMBER}*`);
    createToken("MAINVERSION", `(${src[t.NUMERICIDENTIFIER]})\\.(${src[t.NUMERICIDENTIFIER]})\\.(${src[t.NUMERICIDENTIFIER]})`);
    createToken("MAINVERSIONLOOSE", `(${src[t.NUMERICIDENTIFIERLOOSE]})\\.(${src[t.NUMERICIDENTIFIERLOOSE]})\\.(${src[t.NUMERICIDENTIFIERLOOSE]})`);
    createToken("PRERELEASEIDENTIFIER", `(?:${src[t.NUMERICIDENTIFIER]}|${src[t.NONNUMERICIDENTIFIER]})`);
    createToken("PRERELEASEIDENTIFIERLOOSE", `(?:${src[t.NUMERICIDENTIFIERLOOSE]}|${src[t.NONNUMERICIDENTIFIER]})`);
    createToken("PRERELEASE", `(?:-(${src[t.PRERELEASEIDENTIFIER]}(?:\\.${src[t.PRERELEASEIDENTIFIER]})*))`);
    createToken("PRERELEASELOOSE", `(?:-?(${src[t.PRERELEASEIDENTIFIERLOOSE]}(?:\\.${src[t.PRERELEASEIDENTIFIERLOOSE]})*))`);
    createToken("BUILDIDENTIFIER", `${LETTERDASHNUMBER}+`);
    createToken("BUILD", `(?:\\+(${src[t.BUILDIDENTIFIER]}(?:\\.${src[t.BUILDIDENTIFIER]})*))`);
    createToken("FULLPLAIN", `v?${src[t.MAINVERSION]}${src[t.PRERELEASE]}?${src[t.BUILD]}?`);
    createToken("FULL", `^${src[t.FULLPLAIN]}$`);
    createToken("LOOSEPLAIN", `[v=\\s]*${src[t.MAINVERSIONLOOSE]}${src[t.PRERELEASELOOSE]}?${src[t.BUILD]}?`);
    createToken("LOOSE", `^${src[t.LOOSEPLAIN]}$`);
    createToken("GTLT", "((?:<|>)?=?)");
    createToken("XRANGEIDENTIFIERLOOSE", `${src[t.NUMERICIDENTIFIERLOOSE]}|x|X|\\*`);
    createToken("XRANGEIDENTIFIER", `${src[t.NUMERICIDENTIFIER]}|x|X|\\*`);
    createToken("XRANGEPLAIN", `[v=\\s]*(${src[t.XRANGEIDENTIFIER]})(?:\\.(${src[t.XRANGEIDENTIFIER]})(?:\\.(${src[t.XRANGEIDENTIFIER]})(?:${src[t.PRERELEASE]})?${src[t.BUILD]}?)?)?`);
    createToken("XRANGEPLAINLOOSE", `[v=\\s]*(${src[t.XRANGEIDENTIFIERLOOSE]})(?:\\.(${src[t.XRANGEIDENTIFIERLOOSE]})(?:\\.(${src[t.XRANGEIDENTIFIERLOOSE]})(?:${src[t.PRERELEASELOOSE]})?${src[t.BUILD]}?)?)?`);
    createToken("XRANGE", `^${src[t.GTLT]}\\s*${src[t.XRANGEPLAIN]}$`);
    createToken("XRANGELOOSE", `^${src[t.GTLT]}\\s*${src[t.XRANGEPLAINLOOSE]}$`);
    createToken("COERCEPLAIN", `${"(^|[^\\d])(\\d{1,"}${MAX_SAFE_COMPONENT_LENGTH}})(?:\\.(\\d{1,${MAX_SAFE_COMPONENT_LENGTH}}))?(?:\\.(\\d{1,${MAX_SAFE_COMPONENT_LENGTH}}))?`);
    createToken("COERCE", `${src[t.COERCEPLAIN]}(?:$|[^\\d])`);
    createToken("COERCEFULL", src[t.COERCEPLAIN] + `(?:${src[t.PRERELEASE]})?(?:${src[t.BUILD]})?(?:$|[^\\d])`);
    createToken("COERCERTL", src[t.COERCE], true);
    createToken("COERCERTLFULL", src[t.COERCEFULL], true);
    createToken("LONETILDE", "(?:~>?)");
    createToken("TILDETRIM", `(\\s*)${src[t.LONETILDE]}\\s+`, true);
    exports2.tildeTrimReplace = "$1~";
    createToken("TILDE", `^${src[t.LONETILDE]}${src[t.XRANGEPLAIN]}$`);
    createToken("TILDELOOSE", `^${src[t.LONETILDE]}${src[t.XRANGEPLAINLOOSE]}$`);
    createToken("LONECARET", "(?:\\^)");
    createToken("CARETTRIM", `(\\s*)${src[t.LONECARET]}\\s+`, true);
    exports2.caretTrimReplace = "$1^";
    createToken("CARET", `^${src[t.LONECARET]}${src[t.XRANGEPLAIN]}$`);
    createToken("CARETLOOSE", `^${src[t.LONECARET]}${src[t.XRANGEPLAINLOOSE]}$`);
    createToken("COMPARATORLOOSE", `^${src[t.GTLT]}\\s*(${src[t.LOOSEPLAIN]})$|^$`);
    createToken("COMPARATOR", `^${src[t.GTLT]}\\s*(${src[t.FULLPLAIN]})$|^$`);
    createToken("COMPARATORTRIM", `(\\s*)${src[t.GTLT]}\\s*(${src[t.LOOSEPLAIN]}|${src[t.XRANGEPLAIN]})`, true);
    exports2.comparatorTrimReplace = "$1$2$3";
    createToken("HYPHENRANGE", `^\\s*(${src[t.XRANGEPLAIN]})\\s+-\\s+(${src[t.XRANGEPLAIN]})\\s*$`);
    createToken("HYPHENRANGELOOSE", `^\\s*(${src[t.XRANGEPLAINLOOSE]})\\s+-\\s+(${src[t.XRANGEPLAINLOOSE]})\\s*$`);
    createToken("STAR", "(<|>)?=?\\s*\\*");
    createToken("GTE0", "^\\s*>=\\s*0\\.0\\.0\\s*$");
    createToken("GTE0PRE", "^\\s*>=\\s*0\\.0\\.0-0\\s*$");
  }
});

// node_modules/semver/internal/parse-options.js
var require_parse_options = __commonJS({
  "node_modules/semver/internal/parse-options.js"(exports2, module2) {
    var looseOption = Object.freeze({ loose: true });
    var emptyOpts = Object.freeze({});
    var parseOptions = (options) => {
      if (!options) {
        return emptyOpts;
      }
      if (typeof options !== "object") {
        return looseOption;
      }
      return options;
    };
    module2.exports = parseOptions;
  }
});

// node_modules/semver/internal/identifiers.js
var require_identifiers = __commonJS({
  "node_modules/semver/internal/identifiers.js"(exports2, module2) {
    var numeric = /^[0-9]+$/;
    var compareIdentifiers = (a, b) => {
      const anum = numeric.test(a);
      const bnum = numeric.test(b);
      if (anum && bnum) {
        a = +a;
        b = +b;
      }
      return a === b ? 0 : anum && !bnum ? -1 : bnum && !anum ? 1 : a < b ? -1 : 1;
    };
    var rcompareIdentifiers = (a, b) => compareIdentifiers(b, a);
    module2.exports = {
      compareIdentifiers,
      rcompareIdentifiers
    };
  }
});

// node_modules/semver/classes/semver.js
var require_semver = __commonJS({
  "node_modules/semver/classes/semver.js"(exports2, module2) {
    var debug = require_debug2();
    var { MAX_LENGTH, MAX_SAFE_INTEGER } = require_constants4();
    var { safeRe: re, t } = require_re();
    var parseOptions = require_parse_options();
    var { compareIdentifiers } = require_identifiers();
    var SemVer = class _SemVer {
      constructor(version, options) {
        options = parseOptions(options);
        if (version instanceof _SemVer) {
          if (version.loose === !!options.loose && version.includePrerelease === !!options.includePrerelease) {
            return version;
          } else {
            version = version.version;
          }
        } else if (typeof version !== "string") {
          throw new TypeError(`Invalid version. Must be a string. Got type "${typeof version}".`);
        }
        if (version.length > MAX_LENGTH) {
          throw new TypeError(
            `version is longer than ${MAX_LENGTH} characters`
          );
        }
        debug("SemVer", version, options);
        this.options = options;
        this.loose = !!options.loose;
        this.includePrerelease = !!options.includePrerelease;
        const m2 = version.trim().match(options.loose ? re[t.LOOSE] : re[t.FULL]);
        if (!m2) {
          throw new TypeError(`Invalid Version: ${version}`);
        }
        this.raw = version;
        this.major = +m2[1];
        this.minor = +m2[2];
        this.patch = +m2[3];
        if (this.major > MAX_SAFE_INTEGER || this.major < 0) {
          throw new TypeError("Invalid major version");
        }
        if (this.minor > MAX_SAFE_INTEGER || this.minor < 0) {
          throw new TypeError("Invalid minor version");
        }
        if (this.patch > MAX_SAFE_INTEGER || this.patch < 0) {
          throw new TypeError("Invalid patch version");
        }
        if (!m2[4]) {
          this.prerelease = [];
        } else {
          this.prerelease = m2[4].split(".").map((id) => {
            if (/^[0-9]+$/.test(id)) {
              const num = +id;
              if (num >= 0 && num < MAX_SAFE_INTEGER) {
                return num;
              }
            }
            return id;
          });
        }
        this.build = m2[5] ? m2[5].split(".") : [];
        this.format();
      }
      format() {
        this.version = `${this.major}.${this.minor}.${this.patch}`;
        if (this.prerelease.length) {
          this.version += `-${this.prerelease.join(".")}`;
        }
        return this.version;
      }
      toString() {
        return this.version;
      }
      compare(other) {
        debug("SemVer.compare", this.version, this.options, other);
        if (!(other instanceof _SemVer)) {
          if (typeof other === "string" && other === this.version) {
            return 0;
          }
          other = new _SemVer(other, this.options);
        }
        if (other.version === this.version) {
          return 0;
        }
        return this.compareMain(other) || this.comparePre(other);
      }
      compareMain(other) {
        if (!(other instanceof _SemVer)) {
          other = new _SemVer(other, this.options);
        }
        return compareIdentifiers(this.major, other.major) || compareIdentifiers(this.minor, other.minor) || compareIdentifiers(this.patch, other.patch);
      }
      comparePre(other) {
        if (!(other instanceof _SemVer)) {
          other = new _SemVer(other, this.options);
        }
        if (this.prerelease.length && !other.prerelease.length) {
          return -1;
        } else if (!this.prerelease.length && other.prerelease.length) {
          return 1;
        } else if (!this.prerelease.length && !other.prerelease.length) {
          return 0;
        }
        let i = 0;
        do {
          const a = this.prerelease[i];
          const b = other.prerelease[i];
          debug("prerelease compare", i, a, b);
          if (a === void 0 && b === void 0) {
            return 0;
          } else if (b === void 0) {
            return 1;
          } else if (a === void 0) {
            return -1;
          } else if (a === b) {
            continue;
          } else {
            return compareIdentifiers(a, b);
          }
        } while (++i);
      }
      compareBuild(other) {
        if (!(other instanceof _SemVer)) {
          other = new _SemVer(other, this.options);
        }
        let i = 0;
        do {
          const a = this.build[i];
          const b = other.build[i];
          debug("prerelease compare", i, a, b);
          if (a === void 0 && b === void 0) {
            return 0;
          } else if (b === void 0) {
            return 1;
          } else if (a === void 0) {
            return -1;
          } else if (a === b) {
            continue;
          } else {
            return compareIdentifiers(a, b);
          }
        } while (++i);
      }
      // preminor will bump the version up to the next minor release, and immediately
      // down to pre-release. premajor and prepatch work the same way.
      inc(release, identifier, identifierBase) {
        switch (release) {
          case "premajor":
            this.prerelease.length = 0;
            this.patch = 0;
            this.minor = 0;
            this.major++;
            this.inc("pre", identifier, identifierBase);
            break;
          case "preminor":
            this.prerelease.length = 0;
            this.patch = 0;
            this.minor++;
            this.inc("pre", identifier, identifierBase);
            break;
          case "prepatch":
            this.prerelease.length = 0;
            this.inc("patch", identifier, identifierBase);
            this.inc("pre", identifier, identifierBase);
            break;
          case "prerelease":
            if (this.prerelease.length === 0) {
              this.inc("patch", identifier, identifierBase);
            }
            this.inc("pre", identifier, identifierBase);
            break;
          case "major":
            if (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) {
              this.major++;
            }
            this.minor = 0;
            this.patch = 0;
            this.prerelease = [];
            break;
          case "minor":
            if (this.patch !== 0 || this.prerelease.length === 0) {
              this.minor++;
            }
            this.patch = 0;
            this.prerelease = [];
            break;
          case "patch":
            if (this.prerelease.length === 0) {
              this.patch++;
            }
            this.prerelease = [];
            break;
          case "pre": {
            const base = Number(identifierBase) ? 1 : 0;
            if (!identifier && identifierBase === false) {
              throw new Error("invalid increment argument: identifier is empty");
            }
            if (this.prerelease.length === 0) {
              this.prerelease = [base];
            } else {
              let i = this.prerelease.length;
              while (--i >= 0) {
                if (typeof this.prerelease[i] === "number") {
                  this.prerelease[i]++;
                  i = -2;
                }
              }
              if (i === -1) {
                if (identifier === this.prerelease.join(".") && identifierBase === false) {
                  throw new Error("invalid increment argument: identifier already exists");
                }
                this.prerelease.push(base);
              }
            }
            if (identifier) {
              let prerelease = [identifier, base];
              if (identifierBase === false) {
                prerelease = [identifier];
              }
              if (compareIdentifiers(this.prerelease[0], identifier) === 0) {
                if (isNaN(this.prerelease[1])) {
                  this.prerelease = prerelease;
                }
              } else {
                this.prerelease = prerelease;
              }
            }
            break;
          }
          default:
            throw new Error(`invalid increment argument: ${release}`);
        }
        this.raw = this.format();
        if (this.build.length) {
          this.raw += `+${this.build.join(".")}`;
        }
        return this;
      }
    };
    module2.exports = SemVer;
  }
});

// node_modules/semver/functions/parse.js
var require_parse = __commonJS({
  "node_modules/semver/functions/parse.js"(exports2, module2) {
    var SemVer = require_semver();
    var parse6 = (version, options, throwErrors = false) => {
      if (version instanceof SemVer) {
        return version;
      }
      try {
        return new SemVer(version, options);
      } catch (er) {
        if (!throwErrors) {
          return null;
        }
        throw er;
      }
    };
    module2.exports = parse6;
  }
});

// node_modules/semver/functions/valid.js
var require_valid = __commonJS({
  "node_modules/semver/functions/valid.js"(exports2, module2) {
    var parse6 = require_parse();
    var valid = (version, options) => {
      const v = parse6(version, options);
      return v ? v.version : null;
    };
    module2.exports = valid;
  }
});

// node_modules/semver/functions/clean.js
var require_clean = __commonJS({
  "node_modules/semver/functions/clean.js"(exports2, module2) {
    var parse6 = require_parse();
    var clean = (version, options) => {
      const s = parse6(version.trim().replace(/^[=v]+/, ""), options);
      return s ? s.version : null;
    };
    module2.exports = clean;
  }
});

// node_modules/semver/functions/inc.js
var require_inc = __commonJS({
  "node_modules/semver/functions/inc.js"(exports2, module2) {
    var SemVer = require_semver();
    var inc = (version, release, options, identifier, identifierBase) => {
      if (typeof options === "string") {
        identifierBase = identifier;
        identifier = options;
        options = void 0;
      }
      try {
        return new SemVer(
          version instanceof SemVer ? version.version : version,
          options
        ).inc(release, identifier, identifierBase).version;
      } catch (er) {
        return null;
      }
    };
    module2.exports = inc;
  }
});

// node_modules/semver/functions/diff.js
var require_diff = __commonJS({
  "node_modules/semver/functions/diff.js"(exports2, module2) {
    var parse6 = require_parse();
    var diff = (version1, version2) => {
      const v1 = parse6(version1, null, true);
      const v2 = parse6(version2, null, true);
      const comparison = v1.compare(v2);
      if (comparison === 0) {
        return null;
      }
      const v1Higher = comparison > 0;
      const highVersion = v1Higher ? v1 : v2;
      const lowVersion = v1Higher ? v2 : v1;
      const highHasPre = !!highVersion.prerelease.length;
      const lowHasPre = !!lowVersion.prerelease.length;
      if (lowHasPre && !highHasPre) {
        if (!lowVersion.patch && !lowVersion.minor) {
          return "major";
        }
        if (highVersion.patch) {
          return "patch";
        }
        if (highVersion.minor) {
          return "minor";
        }
        return "major";
      }
      const prefix = highHasPre ? "pre" : "";
      if (v1.major !== v2.major) {
        return prefix + "major";
      }
      if (v1.minor !== v2.minor) {
        return prefix + "minor";
      }
      if (v1.patch !== v2.patch) {
        return prefix + "patch";
      }
      return "prerelease";
    };
    module2.exports = diff;
  }
});

// node_modules/semver/functions/major.js
var require_major = __commonJS({
  "node_modules/semver/functions/major.js"(exports2, module2) {
    var SemVer = require_semver();
    var major = (a, loose) => new SemVer(a, loose).major;
    module2.exports = major;
  }
});

// node_modules/semver/functions/minor.js
var require_minor = __commonJS({
  "node_modules/semver/functions/minor.js"(exports2, module2) {
    var SemVer = require_semver();
    var minor = (a, loose) => new SemVer(a, loose).minor;
    module2.exports = minor;
  }
});

// node_modules/semver/functions/patch.js
var require_patch = __commonJS({
  "node_modules/semver/functions/patch.js"(exports2, module2) {
    var SemVer = require_semver();
    var patch = (a, loose) => new SemVer(a, loose).patch;
    module2.exports = patch;
  }
});

// node_modules/semver/functions/prerelease.js
var require_prerelease = __commonJS({
  "node_modules/semver/functions/prerelease.js"(exports2, module2) {
    var parse6 = require_parse();
    var prerelease = (version, options) => {
      const parsed = parse6(version, options);
      return parsed && parsed.prerelease.length ? parsed.prerelease : null;
    };
    module2.exports = prerelease;
  }
});

// node_modules/semver/functions/compare.js
var require_compare = __commonJS({
  "node_modules/semver/functions/compare.js"(exports2, module2) {
    var SemVer = require_semver();
    var compare = (a, b, loose) => new SemVer(a, loose).compare(new SemVer(b, loose));
    module2.exports = compare;
  }
});

// node_modules/semver/functions/rcompare.js
var require_rcompare = __commonJS({
  "node_modules/semver/functions/rcompare.js"(exports2, module2) {
    var compare = require_compare();
    var rcompare = (a, b, loose) => compare(b, a, loose);
    module2.exports = rcompare;
  }
});

// node_modules/semver/functions/compare-loose.js
var require_compare_loose = __commonJS({
  "node_modules/semver/functions/compare-loose.js"(exports2, module2) {
    var compare = require_compare();
    var compareLoose = (a, b) => compare(a, b, true);
    module2.exports = compareLoose;
  }
});

// node_modules/semver/functions/compare-build.js
var require_compare_build = __commonJS({
  "node_modules/semver/functions/compare-build.js"(exports2, module2) {
    var SemVer = require_semver();
    var compareBuild = (a, b, loose) => {
      const versionA = new SemVer(a, loose);
      const versionB = new SemVer(b, loose);
      return versionA.compare(versionB) || versionA.compareBuild(versionB);
    };
    module2.exports = compareBuild;
  }
});

// node_modules/semver/functions/sort.js
var require_sort = __commonJS({
  "node_modules/semver/functions/sort.js"(exports2, module2) {
    var compareBuild = require_compare_build();
    var sort = (list, loose) => list.sort((a, b) => compareBuild(a, b, loose));
    module2.exports = sort;
  }
});

// node_modules/semver/functions/rsort.js
var require_rsort = __commonJS({
  "node_modules/semver/functions/rsort.js"(exports2, module2) {
    var compareBuild = require_compare_build();
    var rsort = (list, loose) => list.sort((a, b) => compareBuild(b, a, loose));
    module2.exports = rsort;
  }
});

// node_modules/semver/functions/gt.js
var require_gt = __commonJS({
  "node_modules/semver/functions/gt.js"(exports2, module2) {
    var compare = require_compare();
    var gt = (a, b, loose) => compare(a, b, loose) > 0;
    module2.exports = gt;
  }
});

// node_modules/semver/functions/lt.js
var require_lt = __commonJS({
  "node_modules/semver/functions/lt.js"(exports2, module2) {
    var compare = require_compare();
    var lt = (a, b, loose) => compare(a, b, loose) < 0;
    module2.exports = lt;
  }
});

// node_modules/semver/functions/eq.js
var require_eq = __commonJS({
  "node_modules/semver/functions/eq.js"(exports2, module2) {
    var compare = require_compare();
    var eq = (a, b, loose) => compare(a, b, loose) === 0;
    module2.exports = eq;
  }
});

// node_modules/semver/functions/neq.js
var require_neq = __commonJS({
  "node_modules/semver/functions/neq.js"(exports2, module2) {
    var compare = require_compare();
    var neq = (a, b, loose) => compare(a, b, loose) !== 0;
    module2.exports = neq;
  }
});

// node_modules/semver/functions/gte.js
var require_gte = __commonJS({
  "node_modules/semver/functions/gte.js"(exports2, module2) {
    var compare = require_compare();
    var gte = (a, b, loose) => compare(a, b, loose) >= 0;
    module2.exports = gte;
  }
});

// node_modules/semver/functions/lte.js
var require_lte = __commonJS({
  "node_modules/semver/functions/lte.js"(exports2, module2) {
    var compare = require_compare();
    var lte = (a, b, loose) => compare(a, b, loose) <= 0;
    module2.exports = lte;
  }
});

// node_modules/semver/functions/cmp.js
var require_cmp = __commonJS({
  "node_modules/semver/functions/cmp.js"(exports2, module2) {
    var eq = require_eq();
    var neq = require_neq();
    var gt = require_gt();
    var gte = require_gte();
    var lt = require_lt();
    var lte = require_lte();
    var cmp = (a, op, b, loose) => {
      switch (op) {
        case "===":
          if (typeof a === "object") {
            a = a.version;
          }
          if (typeof b === "object") {
            b = b.version;
          }
          return a === b;
        case "!==":
          if (typeof a === "object") {
            a = a.version;
          }
          if (typeof b === "object") {
            b = b.version;
          }
          return a !== b;
        case "":
        case "=":
        case "==":
          return eq(a, b, loose);
        case "!=":
          return neq(a, b, loose);
        case ">":
          return gt(a, b, loose);
        case ">=":
          return gte(a, b, loose);
        case "<":
          return lt(a, b, loose);
        case "<=":
          return lte(a, b, loose);
        default:
          throw new TypeError(`Invalid operator: ${op}`);
      }
    };
    module2.exports = cmp;
  }
});

// node_modules/semver/functions/coerce.js
var require_coerce = __commonJS({
  "node_modules/semver/functions/coerce.js"(exports2, module2) {
    var SemVer = require_semver();
    var parse6 = require_parse();
    var { safeRe: re, t } = require_re();
    var coerce = (version, options) => {
      if (version instanceof SemVer) {
        return version;
      }
      if (typeof version === "number") {
        version = String(version);
      }
      if (typeof version !== "string") {
        return null;
      }
      options = options || {};
      let match = null;
      if (!options.rtl) {
        match = version.match(options.includePrerelease ? re[t.COERCEFULL] : re[t.COERCE]);
      } else {
        const coerceRtlRegex = options.includePrerelease ? re[t.COERCERTLFULL] : re[t.COERCERTL];
        let next;
        while ((next = coerceRtlRegex.exec(version)) && (!match || match.index + match[0].length !== version.length)) {
          if (!match || next.index + next[0].length !== match.index + match[0].length) {
            match = next;
          }
          coerceRtlRegex.lastIndex = next.index + next[1].length + next[2].length;
        }
        coerceRtlRegex.lastIndex = -1;
      }
      if (match === null) {
        return null;
      }
      const major = match[2];
      const minor = match[3] || "0";
      const patch = match[4] || "0";
      const prerelease = options.includePrerelease && match[5] ? `-${match[5]}` : "";
      const build = options.includePrerelease && match[6] ? `+${match[6]}` : "";
      return parse6(`${major}.${minor}.${patch}${prerelease}${build}`, options);
    };
    module2.exports = coerce;
  }
});

// node_modules/semver/classes/range.js
var require_range = __commonJS({
  "node_modules/semver/classes/range.js"(exports2, module2) {
    var Range = class _Range {
      constructor(range, options) {
        options = parseOptions(options);
        if (range instanceof _Range) {
          if (range.loose === !!options.loose && range.includePrerelease === !!options.includePrerelease) {
            return range;
          } else {
            return new _Range(range.raw, options);
          }
        }
        if (range instanceof Comparator) {
          this.raw = range.value;
          this.set = [[range]];
          this.format();
          return this;
        }
        this.options = options;
        this.loose = !!options.loose;
        this.includePrerelease = !!options.includePrerelease;
        this.raw = range.trim().split(/\s+/).join(" ");
        this.set = this.raw.split("||").map((r) => this.parseRange(r.trim())).filter((c2) => c2.length);
        if (!this.set.length) {
          throw new TypeError(`Invalid SemVer Range: ${this.raw}`);
        }
        if (this.set.length > 1) {
          const first = this.set[0];
          this.set = this.set.filter((c2) => !isNullSet(c2[0]));
          if (this.set.length === 0) {
            this.set = [first];
          } else if (this.set.length > 1) {
            for (const c2 of this.set) {
              if (c2.length === 1 && isAny(c2[0])) {
                this.set = [c2];
                break;
              }
            }
          }
        }
        this.format();
      }
      format() {
        this.range = this.set.map((comps) => comps.join(" ").trim()).join("||").trim();
        return this.range;
      }
      toString() {
        return this.range;
      }
      parseRange(range) {
        const memoOpts = (this.options.includePrerelease && FLAG_INCLUDE_PRERELEASE) | (this.options.loose && FLAG_LOOSE);
        const memoKey = memoOpts + ":" + range;
        const cached = cache.get(memoKey);
        if (cached) {
          return cached;
        }
        const loose = this.options.loose;
        const hr = loose ? re[t.HYPHENRANGELOOSE] : re[t.HYPHENRANGE];
        range = range.replace(hr, hyphenReplace(this.options.includePrerelease));
        debug("hyphen replace", range);
        range = range.replace(re[t.COMPARATORTRIM], comparatorTrimReplace);
        debug("comparator trim", range);
        range = range.replace(re[t.TILDETRIM], tildeTrimReplace);
        debug("tilde trim", range);
        range = range.replace(re[t.CARETTRIM], caretTrimReplace);
        debug("caret trim", range);
        let rangeList = range.split(" ").map((comp) => parseComparator(comp, this.options)).join(" ").split(/\s+/).map((comp) => replaceGTE0(comp, this.options));
        if (loose) {
          rangeList = rangeList.filter((comp) => {
            debug("loose invalid filter", comp, this.options);
            return !!comp.match(re[t.COMPARATORLOOSE]);
          });
        }
        debug("range list", rangeList);
        const rangeMap = /* @__PURE__ */ new Map();
        const comparators = rangeList.map((comp) => new Comparator(comp, this.options));
        for (const comp of comparators) {
          if (isNullSet(comp)) {
            return [comp];
          }
          rangeMap.set(comp.value, comp);
        }
        if (rangeMap.size > 1 && rangeMap.has("")) {
          rangeMap.delete("");
        }
        const result2 = [...rangeMap.values()];
        cache.set(memoKey, result2);
        return result2;
      }
      intersects(range, options) {
        if (!(range instanceof _Range)) {
          throw new TypeError("a Range is required");
        }
        return this.set.some((thisComparators) => {
          return isSatisfiable(thisComparators, options) && range.set.some((rangeComparators) => {
            return isSatisfiable(rangeComparators, options) && thisComparators.every((thisComparator) => {
              return rangeComparators.every((rangeComparator) => {
                return thisComparator.intersects(rangeComparator, options);
              });
            });
          });
        });
      }
      // if ANY of the sets match ALL of its comparators, then pass
      test(version) {
        if (!version) {
          return false;
        }
        if (typeof version === "string") {
          try {
            version = new SemVer(version, this.options);
          } catch (er) {
            return false;
          }
        }
        for (let i = 0; i < this.set.length; i++) {
          if (testSet(this.set[i], version, this.options)) {
            return true;
          }
        }
        return false;
      }
    };
    module2.exports = Range;
    var LRU = require_lru_cache();
    var cache = new LRU({ max: 1e3 });
    var parseOptions = require_parse_options();
    var Comparator = require_comparator();
    var debug = require_debug2();
    var SemVer = require_semver();
    var {
      safeRe: re,
      t,
      comparatorTrimReplace,
      tildeTrimReplace,
      caretTrimReplace
    } = require_re();
    var { FLAG_INCLUDE_PRERELEASE, FLAG_LOOSE } = require_constants4();
    var isNullSet = (c2) => c2.value === "<0.0.0-0";
    var isAny = (c2) => c2.value === "";
    var isSatisfiable = (comparators, options) => {
      let result2 = true;
      const remainingComparators = comparators.slice();
      let testComparator = remainingComparators.pop();
      while (result2 && remainingComparators.length) {
        result2 = remainingComparators.every((otherComparator) => {
          return testComparator.intersects(otherComparator, options);
        });
        testComparator = remainingComparators.pop();
      }
      return result2;
    };
    var parseComparator = (comp, options) => {
      debug("comp", comp, options);
      comp = replaceCarets(comp, options);
      debug("caret", comp);
      comp = replaceTildes(comp, options);
      debug("tildes", comp);
      comp = replaceXRanges(comp, options);
      debug("xrange", comp);
      comp = replaceStars(comp, options);
      debug("stars", comp);
      return comp;
    };
    var isX = (id) => !id || id.toLowerCase() === "x" || id === "*";
    var replaceTildes = (comp, options) => {
      return comp.trim().split(/\s+/).map((c2) => replaceTilde(c2, options)).join(" ");
    };
    var replaceTilde = (comp, options) => {
      const r = options.loose ? re[t.TILDELOOSE] : re[t.TILDE];
      return comp.replace(r, (_, M, m2, p3, pr) => {
        debug("tilde", comp, _, M, m2, p3, pr);
        let ret;
        if (isX(M)) {
          ret = "";
        } else if (isX(m2)) {
          ret = `>=${M}.0.0 <${+M + 1}.0.0-0`;
        } else if (isX(p3)) {
          ret = `>=${M}.${m2}.0 <${M}.${+m2 + 1}.0-0`;
        } else if (pr) {
          debug("replaceTilde pr", pr);
          ret = `>=${M}.${m2}.${p3}-${pr} <${M}.${+m2 + 1}.0-0`;
        } else {
          ret = `>=${M}.${m2}.${p3} <${M}.${+m2 + 1}.0-0`;
        }
        debug("tilde return", ret);
        return ret;
      });
    };
    var replaceCarets = (comp, options) => {
      return comp.trim().split(/\s+/).map((c2) => replaceCaret(c2, options)).join(" ");
    };
    var replaceCaret = (comp, options) => {
      debug("caret", comp, options);
      const r = options.loose ? re[t.CARETLOOSE] : re[t.CARET];
      const z = options.includePrerelease ? "-0" : "";
      return comp.replace(r, (_, M, m2, p3, pr) => {
        debug("caret", comp, _, M, m2, p3, pr);
        let ret;
        if (isX(M)) {
          ret = "";
        } else if (isX(m2)) {
          ret = `>=${M}.0.0${z} <${+M + 1}.0.0-0`;
        } else if (isX(p3)) {
          if (M === "0") {
            ret = `>=${M}.${m2}.0${z} <${M}.${+m2 + 1}.0-0`;
          } else {
            ret = `>=${M}.${m2}.0${z} <${+M + 1}.0.0-0`;
          }
        } else if (pr) {
          debug("replaceCaret pr", pr);
          if (M === "0") {
            if (m2 === "0") {
              ret = `>=${M}.${m2}.${p3}-${pr} <${M}.${m2}.${+p3 + 1}-0`;
            } else {
              ret = `>=${M}.${m2}.${p3}-${pr} <${M}.${+m2 + 1}.0-0`;
            }
          } else {
            ret = `>=${M}.${m2}.${p3}-${pr} <${+M + 1}.0.0-0`;
          }
        } else {
          debug("no pr");
          if (M === "0") {
            if (m2 === "0") {
              ret = `>=${M}.${m2}.${p3}${z} <${M}.${m2}.${+p3 + 1}-0`;
            } else {
              ret = `>=${M}.${m2}.${p3}${z} <${M}.${+m2 + 1}.0-0`;
            }
          } else {
            ret = `>=${M}.${m2}.${p3} <${+M + 1}.0.0-0`;
          }
        }
        debug("caret return", ret);
        return ret;
      });
    };
    var replaceXRanges = (comp, options) => {
      debug("replaceXRanges", comp, options);
      return comp.split(/\s+/).map((c2) => replaceXRange(c2, options)).join(" ");
    };
    var replaceXRange = (comp, options) => {
      comp = comp.trim();
      const r = options.loose ? re[t.XRANGELOOSE] : re[t.XRANGE];
      return comp.replace(r, (ret, gtlt, M, m2, p3, pr) => {
        debug("xRange", comp, ret, gtlt, M, m2, p3, pr);
        const xM = isX(M);
        const xm = xM || isX(m2);
        const xp = xm || isX(p3);
        const anyX = xp;
        if (gtlt === "=" && anyX) {
          gtlt = "";
        }
        pr = options.includePrerelease ? "-0" : "";
        if (xM) {
          if (gtlt === ">" || gtlt === "<") {
            ret = "<0.0.0-0";
          } else {
            ret = "*";
          }
        } else if (gtlt && anyX) {
          if (xm) {
            m2 = 0;
          }
          p3 = 0;
          if (gtlt === ">") {
            gtlt = ">=";
            if (xm) {
              M = +M + 1;
              m2 = 0;
              p3 = 0;
            } else {
              m2 = +m2 + 1;
              p3 = 0;
            }
          } else if (gtlt === "<=") {
            gtlt = "<";
            if (xm) {
              M = +M + 1;
            } else {
              m2 = +m2 + 1;
            }
          }
          if (gtlt === "<") {
            pr = "-0";
          }
          ret = `${gtlt + M}.${m2}.${p3}${pr}`;
        } else if (xm) {
          ret = `>=${M}.0.0${pr} <${+M + 1}.0.0-0`;
        } else if (xp) {
          ret = `>=${M}.${m2}.0${pr} <${M}.${+m2 + 1}.0-0`;
        }
        debug("xRange return", ret);
        return ret;
      });
    };
    var replaceStars = (comp, options) => {
      debug("replaceStars", comp, options);
      return comp.trim().replace(re[t.STAR], "");
    };
    var replaceGTE0 = (comp, options) => {
      debug("replaceGTE0", comp, options);
      return comp.trim().replace(re[options.includePrerelease ? t.GTE0PRE : t.GTE0], "");
    };
    var hyphenReplace = (incPr) => ($0, from, fM, fm, fp, fpr, fb, to, tM, tm, tp, tpr, tb) => {
      if (isX(fM)) {
        from = "";
      } else if (isX(fm)) {
        from = `>=${fM}.0.0${incPr ? "-0" : ""}`;
      } else if (isX(fp)) {
        from = `>=${fM}.${fm}.0${incPr ? "-0" : ""}`;
      } else if (fpr) {
        from = `>=${from}`;
      } else {
        from = `>=${from}${incPr ? "-0" : ""}`;
      }
      if (isX(tM)) {
        to = "";
      } else if (isX(tm)) {
        to = `<${+tM + 1}.0.0-0`;
      } else if (isX(tp)) {
        to = `<${tM}.${+tm + 1}.0-0`;
      } else if (tpr) {
        to = `<=${tM}.${tm}.${tp}-${tpr}`;
      } else if (incPr) {
        to = `<${tM}.${tm}.${+tp + 1}-0`;
      } else {
        to = `<=${to}`;
      }
      return `${from} ${to}`.trim();
    };
    var testSet = (set, version, options) => {
      for (let i = 0; i < set.length; i++) {
        if (!set[i].test(version)) {
          return false;
        }
      }
      if (version.prerelease.length && !options.includePrerelease) {
        for (let i = 0; i < set.length; i++) {
          debug(set[i].semver);
          if (set[i].semver === Comparator.ANY) {
            continue;
          }
          if (set[i].semver.prerelease.length > 0) {
            const allowed = set[i].semver;
            if (allowed.major === version.major && allowed.minor === version.minor && allowed.patch === version.patch) {
              return true;
            }
          }
        }
        return false;
      }
      return true;
    };
  }
});

// node_modules/semver/classes/comparator.js
var require_comparator = __commonJS({
  "node_modules/semver/classes/comparator.js"(exports2, module2) {
    var ANY = Symbol("SemVer ANY");
    var Comparator = class _Comparator {
      static get ANY() {
        return ANY;
      }
      constructor(comp, options) {
        options = parseOptions(options);
        if (comp instanceof _Comparator) {
          if (comp.loose === !!options.loose) {
            return comp;
          } else {
            comp = comp.value;
          }
        }
        comp = comp.trim().split(/\s+/).join(" ");
        debug("comparator", comp, options);
        this.options = options;
        this.loose = !!options.loose;
        this.parse(comp);
        if (this.semver === ANY) {
          this.value = "";
        } else {
          this.value = this.operator + this.semver.version;
        }
        debug("comp", this);
      }
      parse(comp) {
        const r = this.options.loose ? re[t.COMPARATORLOOSE] : re[t.COMPARATOR];
        const m2 = comp.match(r);
        if (!m2) {
          throw new TypeError(`Invalid comparator: ${comp}`);
        }
        this.operator = m2[1] !== void 0 ? m2[1] : "";
        if (this.operator === "=") {
          this.operator = "";
        }
        if (!m2[2]) {
          this.semver = ANY;
        } else {
          this.semver = new SemVer(m2[2], this.options.loose);
        }
      }
      toString() {
        return this.value;
      }
      test(version) {
        debug("Comparator.test", version, this.options.loose);
        if (this.semver === ANY || version === ANY) {
          return true;
        }
        if (typeof version === "string") {
          try {
            version = new SemVer(version, this.options);
          } catch (er) {
            return false;
          }
        }
        return cmp(version, this.operator, this.semver, this.options);
      }
      intersects(comp, options) {
        if (!(comp instanceof _Comparator)) {
          throw new TypeError("a Comparator is required");
        }
        if (this.operator === "") {
          if (this.value === "") {
            return true;
          }
          return new Range(comp.value, options).test(this.value);
        } else if (comp.operator === "") {
          if (comp.value === "") {
            return true;
          }
          return new Range(this.value, options).test(comp.semver);
        }
        options = parseOptions(options);
        if (options.includePrerelease && (this.value === "<0.0.0-0" || comp.value === "<0.0.0-0")) {
          return false;
        }
        if (!options.includePrerelease && (this.value.startsWith("<0.0.0") || comp.value.startsWith("<0.0.0"))) {
          return false;
        }
        if (this.operator.startsWith(">") && comp.operator.startsWith(">")) {
          return true;
        }
        if (this.operator.startsWith("<") && comp.operator.startsWith("<")) {
          return true;
        }
        if (this.semver.version === comp.semver.version && this.operator.includes("=") && comp.operator.includes("=")) {
          return true;
        }
        if (cmp(this.semver, "<", comp.semver, options) && this.operator.startsWith(">") && comp.operator.startsWith("<")) {
          return true;
        }
        if (cmp(this.semver, ">", comp.semver, options) && this.operator.startsWith("<") && comp.operator.startsWith(">")) {
          return true;
        }
        return false;
      }
    };
    module2.exports = Comparator;
    var parseOptions = require_parse_options();
    var { safeRe: re, t } = require_re();
    var cmp = require_cmp();
    var debug = require_debug2();
    var SemVer = require_semver();
    var Range = require_range();
  }
});

// node_modules/semver/functions/satisfies.js
var require_satisfies = __commonJS({
  "node_modules/semver/functions/satisfies.js"(exports2, module2) {
    var Range = require_range();
    var satisfies = (version, range, options) => {
      try {
        range = new Range(range, options);
      } catch (er) {
        return false;
      }
      return range.test(version);
    };
    module2.exports = satisfies;
  }
});

// node_modules/semver/ranges/to-comparators.js
var require_to_comparators = __commonJS({
  "node_modules/semver/ranges/to-comparators.js"(exports2, module2) {
    var Range = require_range();
    var toComparators = (range, options) => new Range(range, options).set.map((comp) => comp.map((c2) => c2.value).join(" ").trim().split(" "));
    module2.exports = toComparators;
  }
});

// node_modules/semver/ranges/max-satisfying.js
var require_max_satisfying = __commonJS({
  "node_modules/semver/ranges/max-satisfying.js"(exports2, module2) {
    var SemVer = require_semver();
    var Range = require_range();
    var maxSatisfying = (versions, range, options) => {
      let max = null;
      let maxSV = null;
      let rangeObj = null;
      try {
        rangeObj = new Range(range, options);
      } catch (er) {
        return null;
      }
      versions.forEach((v) => {
        if (rangeObj.test(v)) {
          if (!max || maxSV.compare(v) === -1) {
            max = v;
            maxSV = new SemVer(max, options);
          }
        }
      });
      return max;
    };
    module2.exports = maxSatisfying;
  }
});

// node_modules/semver/ranges/min-satisfying.js
var require_min_satisfying = __commonJS({
  "node_modules/semver/ranges/min-satisfying.js"(exports2, module2) {
    var SemVer = require_semver();
    var Range = require_range();
    var minSatisfying = (versions, range, options) => {
      let min = null;
      let minSV = null;
      let rangeObj = null;
      try {
        rangeObj = new Range(range, options);
      } catch (er) {
        return null;
      }
      versions.forEach((v) => {
        if (rangeObj.test(v)) {
          if (!min || minSV.compare(v) === 1) {
            min = v;
            minSV = new SemVer(min, options);
          }
        }
      });
      return min;
    };
    module2.exports = minSatisfying;
  }
});

// node_modules/semver/ranges/min-version.js
var require_min_version = __commonJS({
  "node_modules/semver/ranges/min-version.js"(exports2, module2) {
    var SemVer = require_semver();
    var Range = require_range();
    var gt = require_gt();
    var minVersion = (range, loose) => {
      range = new Range(range, loose);
      let minver = new SemVer("0.0.0");
      if (range.test(minver)) {
        return minver;
      }
      minver = new SemVer("0.0.0-0");
      if (range.test(minver)) {
        return minver;
      }
      minver = null;
      for (let i = 0; i < range.set.length; ++i) {
        const comparators = range.set[i];
        let setMin = null;
        comparators.forEach((comparator) => {
          const compver = new SemVer(comparator.semver.version);
          switch (comparator.operator) {
            case ">":
              if (compver.prerelease.length === 0) {
                compver.patch++;
              } else {
                compver.prerelease.push(0);
              }
              compver.raw = compver.format();
            case "":
            case ">=":
              if (!setMin || gt(compver, setMin)) {
                setMin = compver;
              }
              break;
            case "<":
            case "<=":
              break;
            default:
              throw new Error(`Unexpected operation: ${comparator.operator}`);
          }
        });
        if (setMin && (!minver || gt(minver, setMin))) {
          minver = setMin;
        }
      }
      if (minver && range.test(minver)) {
        return minver;
      }
      return null;
    };
    module2.exports = minVersion;
  }
});

// node_modules/semver/ranges/valid.js
var require_valid2 = __commonJS({
  "node_modules/semver/ranges/valid.js"(exports2, module2) {
    var Range = require_range();
    var validRange = (range, options) => {
      try {
        return new Range(range, options).range || "*";
      } catch (er) {
        return null;
      }
    };
    module2.exports = validRange;
  }
});

// node_modules/semver/ranges/outside.js
var require_outside = __commonJS({
  "node_modules/semver/ranges/outside.js"(exports2, module2) {
    var SemVer = require_semver();
    var Comparator = require_comparator();
    var { ANY } = Comparator;
    var Range = require_range();
    var satisfies = require_satisfies();
    var gt = require_gt();
    var lt = require_lt();
    var lte = require_lte();
    var gte = require_gte();
    var outside = (version, range, hilo, options) => {
      version = new SemVer(version, options);
      range = new Range(range, options);
      let gtfn, ltefn, ltfn, comp, ecomp;
      switch (hilo) {
        case ">":
          gtfn = gt;
          ltefn = lte;
          ltfn = lt;
          comp = ">";
          ecomp = ">=";
          break;
        case "<":
          gtfn = lt;
          ltefn = gte;
          ltfn = gt;
          comp = "<";
          ecomp = "<=";
          break;
        default:
          throw new TypeError('Must provide a hilo val of "<" or ">"');
      }
      if (satisfies(version, range, options)) {
        return false;
      }
      for (let i = 0; i < range.set.length; ++i) {
        const comparators = range.set[i];
        let high = null;
        let low = null;
        comparators.forEach((comparator) => {
          if (comparator.semver === ANY) {
            comparator = new Comparator(">=0.0.0");
          }
          high = high || comparator;
          low = low || comparator;
          if (gtfn(comparator.semver, high.semver, options)) {
            high = comparator;
          } else if (ltfn(comparator.semver, low.semver, options)) {
            low = comparator;
          }
        });
        if (high.operator === comp || high.operator === ecomp) {
          return false;
        }
        if ((!low.operator || low.operator === comp) && ltefn(version, low.semver)) {
          return false;
        } else if (low.operator === ecomp && ltfn(version, low.semver)) {
          return false;
        }
      }
      return true;
    };
    module2.exports = outside;
  }
});

// node_modules/semver/ranges/gtr.js
var require_gtr = __commonJS({
  "node_modules/semver/ranges/gtr.js"(exports2, module2) {
    var outside = require_outside();
    var gtr = (version, range, options) => outside(version, range, ">", options);
    module2.exports = gtr;
  }
});

// node_modules/semver/ranges/ltr.js
var require_ltr = __commonJS({
  "node_modules/semver/ranges/ltr.js"(exports2, module2) {
    var outside = require_outside();
    var ltr = (version, range, options) => outside(version, range, "<", options);
    module2.exports = ltr;
  }
});

// node_modules/semver/ranges/intersects.js
var require_intersects = __commonJS({
  "node_modules/semver/ranges/intersects.js"(exports2, module2) {
    var Range = require_range();
    var intersects = (r1, r2, options) => {
      r1 = new Range(r1, options);
      r2 = new Range(r2, options);
      return r1.intersects(r2, options);
    };
    module2.exports = intersects;
  }
});

// node_modules/semver/ranges/simplify.js
var require_simplify = __commonJS({
  "node_modules/semver/ranges/simplify.js"(exports2, module2) {
    var satisfies = require_satisfies();
    var compare = require_compare();
    module2.exports = (versions, range, options) => {
      const set = [];
      let first = null;
      let prev = null;
      const v = versions.sort((a, b) => compare(a, b, options));
      for (const version of v) {
        const included = satisfies(version, range, options);
        if (included) {
          prev = version;
          if (!first) {
            first = version;
          }
        } else {
          if (prev) {
            set.push([first, prev]);
          }
          prev = null;
          first = null;
        }
      }
      if (first) {
        set.push([first, null]);
      }
      const ranges = [];
      for (const [min, max] of set) {
        if (min === max) {
          ranges.push(min);
        } else if (!max && min === v[0]) {
          ranges.push("*");
        } else if (!max) {
          ranges.push(`>=${min}`);
        } else if (min === v[0]) {
          ranges.push(`<=${max}`);
        } else {
          ranges.push(`${min} - ${max}`);
        }
      }
      const simplified = ranges.join(" || ");
      const original = typeof range.raw === "string" ? range.raw : String(range);
      return simplified.length < original.length ? simplified : range;
    };
  }
});

// node_modules/semver/ranges/subset.js
var require_subset = __commonJS({
  "node_modules/semver/ranges/subset.js"(exports2, module2) {
    var Range = require_range();
    var Comparator = require_comparator();
    var { ANY } = Comparator;
    var satisfies = require_satisfies();
    var compare = require_compare();
    var subset = (sub, dom, options = {}) => {
      if (sub === dom) {
        return true;
      }
      sub = new Range(sub, options);
      dom = new Range(dom, options);
      let sawNonNull = false;
      OUTER:
        for (const simpleSub of sub.set) {
          for (const simpleDom of dom.set) {
            const isSub = simpleSubset(simpleSub, simpleDom, options);
            sawNonNull = sawNonNull || isSub !== null;
            if (isSub) {
              continue OUTER;
            }
          }
          if (sawNonNull) {
            return false;
          }
        }
      return true;
    };
    var minimumVersionWithPreRelease = [new Comparator(">=0.0.0-0")];
    var minimumVersion = [new Comparator(">=0.0.0")];
    var simpleSubset = (sub, dom, options) => {
      if (sub === dom) {
        return true;
      }
      if (sub.length === 1 && sub[0].semver === ANY) {
        if (dom.length === 1 && dom[0].semver === ANY) {
          return true;
        } else if (options.includePrerelease) {
          sub = minimumVersionWithPreRelease;
        } else {
          sub = minimumVersion;
        }
      }
      if (dom.length === 1 && dom[0].semver === ANY) {
        if (options.includePrerelease) {
          return true;
        } else {
          dom = minimumVersion;
        }
      }
      const eqSet = /* @__PURE__ */ new Set();
      let gt, lt;
      for (const c2 of sub) {
        if (c2.operator === ">" || c2.operator === ">=") {
          gt = higherGT(gt, c2, options);
        } else if (c2.operator === "<" || c2.operator === "<=") {
          lt = lowerLT(lt, c2, options);
        } else {
          eqSet.add(c2.semver);
        }
      }
      if (eqSet.size > 1) {
        return null;
      }
      let gtltComp;
      if (gt && lt) {
        gtltComp = compare(gt.semver, lt.semver, options);
        if (gtltComp > 0) {
          return null;
        } else if (gtltComp === 0 && (gt.operator !== ">=" || lt.operator !== "<=")) {
          return null;
        }
      }
      for (const eq of eqSet) {
        if (gt && !satisfies(eq, String(gt), options)) {
          return null;
        }
        if (lt && !satisfies(eq, String(lt), options)) {
          return null;
        }
        for (const c2 of dom) {
          if (!satisfies(eq, String(c2), options)) {
            return false;
          }
        }
        return true;
      }
      let higher, lower;
      let hasDomLT, hasDomGT;
      let needDomLTPre = lt && !options.includePrerelease && lt.semver.prerelease.length ? lt.semver : false;
      let needDomGTPre = gt && !options.includePrerelease && gt.semver.prerelease.length ? gt.semver : false;
      if (needDomLTPre && needDomLTPre.prerelease.length === 1 && lt.operator === "<" && needDomLTPre.prerelease[0] === 0) {
        needDomLTPre = false;
      }
      for (const c2 of dom) {
        hasDomGT = hasDomGT || c2.operator === ">" || c2.operator === ">=";
        hasDomLT = hasDomLT || c2.operator === "<" || c2.operator === "<=";
        if (gt) {
          if (needDomGTPre) {
            if (c2.semver.prerelease && c2.semver.prerelease.length && c2.semver.major === needDomGTPre.major && c2.semver.minor === needDomGTPre.minor && c2.semver.patch === needDomGTPre.patch) {
              needDomGTPre = false;
            }
          }
          if (c2.operator === ">" || c2.operator === ">=") {
            higher = higherGT(gt, c2, options);
            if (higher === c2 && higher !== gt) {
              return false;
            }
          } else if (gt.operator === ">=" && !satisfies(gt.semver, String(c2), options)) {
            return false;
          }
        }
        if (lt) {
          if (needDomLTPre) {
            if (c2.semver.prerelease && c2.semver.prerelease.length && c2.semver.major === needDomLTPre.major && c2.semver.minor === needDomLTPre.minor && c2.semver.patch === needDomLTPre.patch) {
              needDomLTPre = false;
            }
          }
          if (c2.operator === "<" || c2.operator === "<=") {
            lower = lowerLT(lt, c2, options);
            if (lower === c2 && lower !== lt) {
              return false;
            }
          } else if (lt.operator === "<=" && !satisfies(lt.semver, String(c2), options)) {
            return false;
          }
        }
        if (!c2.operator && (lt || gt) && gtltComp !== 0) {
          return false;
        }
      }
      if (gt && hasDomLT && !lt && gtltComp !== 0) {
        return false;
      }
      if (lt && hasDomGT && !gt && gtltComp !== 0) {
        return false;
      }
      if (needDomGTPre || needDomLTPre) {
        return false;
      }
      return true;
    };
    var higherGT = (a, b, options) => {
      if (!a) {
        return b;
      }
      const comp = compare(a.semver, b.semver, options);
      return comp > 0 ? a : comp < 0 ? b : b.operator === ">" && a.operator === ">=" ? b : a;
    };
    var lowerLT = (a, b, options) => {
      if (!a) {
        return b;
      }
      const comp = compare(a.semver, b.semver, options);
      return comp < 0 ? a : comp > 0 ? b : b.operator === "<" && a.operator === "<=" ? b : a;
    };
    module2.exports = subset;
  }
});

// node_modules/semver/index.js
var require_semver2 = __commonJS({
  "node_modules/semver/index.js"(exports2, module2) {
    var internalRe = require_re();
    var constants = require_constants4();
    var SemVer = require_semver();
    var identifiers = require_identifiers();
    var parse6 = require_parse();
    var valid = require_valid();
    var clean = require_clean();
    var inc = require_inc();
    var diff = require_diff();
    var major = require_major();
    var minor = require_minor();
    var patch = require_patch();
    var prerelease = require_prerelease();
    var compare = require_compare();
    var rcompare = require_rcompare();
    var compareLoose = require_compare_loose();
    var compareBuild = require_compare_build();
    var sort = require_sort();
    var rsort = require_rsort();
    var gt = require_gt();
    var lt = require_lt();
    var eq = require_eq();
    var neq = require_neq();
    var gte = require_gte();
    var lte = require_lte();
    var cmp = require_cmp();
    var coerce = require_coerce();
    var Comparator = require_comparator();
    var Range = require_range();
    var satisfies = require_satisfies();
    var toComparators = require_to_comparators();
    var maxSatisfying = require_max_satisfying();
    var minSatisfying = require_min_satisfying();
    var minVersion = require_min_version();
    var validRange = require_valid2();
    var outside = require_outside();
    var gtr = require_gtr();
    var ltr = require_ltr();
    var intersects = require_intersects();
    var simplifyRange = require_simplify();
    var subset = require_subset();
    module2.exports = {
      parse: parse6,
      valid,
      clean,
      inc,
      diff,
      major,
      minor,
      patch,
      prerelease,
      compare,
      rcompare,
      compareLoose,
      compareBuild,
      sort,
      rsort,
      gt,
      lt,
      eq,
      neq,
      gte,
      lte,
      cmp,
      coerce,
      Comparator,
      Range,
      satisfies,
      toComparators,
      maxSatisfying,
      minSatisfying,
      minVersion,
      validRange,
      outside,
      gtr,
      ltr,
      intersects,
      simplifyRange,
      subset,
      SemVer,
      re: internalRe.re,
      src: internalRe.src,
      tokens: internalRe.t,
      SEMVER_SPEC_VERSION: constants.SEMVER_SPEC_VERSION,
      RELEASE_TYPES: constants.RELEASE_TYPES,
      compareIdentifiers: identifiers.compareIdentifiers,
      rcompareIdentifiers: identifiers.rcompareIdentifiers
    };
  }
});

// node_modules/node-opcua-assert/dist/index.js
var require_dist14 = __commonJS({
  "node_modules/node-opcua-assert/dist/index.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.renderError = exports2.assert = void 0;
    var chalk_1 = __importDefault3(require_source());
    var displayAssert = typeof process === "object" ? process.env.DISPLAY_ASSERT ? true : false : false;
    function assert(cond, message) {
      if (!cond) {
        const err = new Error(message);
        if (displayAssert) {
          console.log(chalk_1.default.whiteBright.bgRed("-----------------------------------------------------------"));
          console.log(chalk_1.default.whiteBright.bgRed(message));
          console.log(chalk_1.default.whiteBright.bgRed("-----------------------------------------------------------"));
        }
        throw err;
      }
    }
    exports2.assert = assert;
    exports2.default = assert;
    function renderError(err) {
      return err;
    }
    exports2.renderError = renderError;
  }
});

// node_modules/node-opcua-basic-types/dist/array.js
var require_array = __commonJS({
  "node_modules/node-opcua-basic-types/dist/array.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.decodeArray = exports2.encodeArray = void 0;
    var node_opcua_assert_1 = require_dist14();
    function encodeArray(arr, stream, encodeElementFunc) {
      if (arr === null) {
        stream.writeUInt32(4294967295);
        return;
      }
      (0, node_opcua_assert_1.assert)(Array.isArray(arr));
      stream.writeUInt32(arr.length);
      for (const value of arr) {
        encodeElementFunc(value, stream);
      }
    }
    exports2.encodeArray = encodeArray;
    function decodeArray(stream, decodeElementFunc) {
      const length = stream.readUInt32();
      if (length === 4294967295) {
        return null;
      }
      const arr = [];
      for (let i = 0; i < length; i++) {
        arr.push(decodeElementFunc(stream));
      }
      return arr;
    }
    exports2.decodeArray = decodeArray;
  }
});

// node_modules/node-opcua-basic-types/dist/attributeIds.js
var require_attributeIds = __commonJS({
  "node_modules/node-opcua-basic-types/dist/attributeIds.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isValidAttributeId = exports2.attributeNameById = exports2.AttributeIds = void 0;
    var AttributeIds;
    (function(AttributeIds2) {
      AttributeIds2[AttributeIds2["NodeId"] = 1] = "NodeId";
      AttributeIds2[AttributeIds2["NodeClass"] = 2] = "NodeClass";
      AttributeIds2[AttributeIds2["BrowseName"] = 3] = "BrowseName";
      AttributeIds2[AttributeIds2["DisplayName"] = 4] = "DisplayName";
      AttributeIds2[AttributeIds2["Description"] = 5] = "Description";
      AttributeIds2[AttributeIds2["WriteMask"] = 6] = "WriteMask";
      AttributeIds2[AttributeIds2["UserWriteMask"] = 7] = "UserWriteMask";
      AttributeIds2[AttributeIds2["IsAbstract"] = 8] = "IsAbstract";
      AttributeIds2[AttributeIds2["Symmetric"] = 9] = "Symmetric";
      AttributeIds2[AttributeIds2["InverseName"] = 10] = "InverseName";
      AttributeIds2[AttributeIds2["ContainsNoLoops"] = 11] = "ContainsNoLoops";
      AttributeIds2[AttributeIds2["EventNotifier"] = 12] = "EventNotifier";
      AttributeIds2[AttributeIds2["Value"] = 13] = "Value";
      AttributeIds2[AttributeIds2["DataType"] = 14] = "DataType";
      AttributeIds2[AttributeIds2["ValueRank"] = 15] = "ValueRank";
      AttributeIds2[AttributeIds2["ArrayDimensions"] = 16] = "ArrayDimensions";
      AttributeIds2[AttributeIds2["AccessLevel"] = 17] = "AccessLevel";
      AttributeIds2[AttributeIds2["UserAccessLevel"] = 18] = "UserAccessLevel";
      AttributeIds2[AttributeIds2["MinimumSamplingInterval"] = 19] = "MinimumSamplingInterval";
      AttributeIds2[AttributeIds2["Historizing"] = 20] = "Historizing";
      AttributeIds2[AttributeIds2["Executable"] = 21] = "Executable";
      AttributeIds2[AttributeIds2["UserExecutable"] = 22] = "UserExecutable";
      AttributeIds2[AttributeIds2["DataTypeDefinition"] = 23] = "DataTypeDefinition";
      AttributeIds2[AttributeIds2["RolePermissions"] = 24] = "RolePermissions";
      AttributeIds2[AttributeIds2["UserRolePermissions"] = 25] = "UserRolePermissions";
      AttributeIds2[AttributeIds2["AccessRestrictions"] = 26] = "AccessRestrictions";
      AttributeIds2[AttributeIds2["AccessLevelEx"] = 27] = "AccessLevelEx";
      AttributeIds2[AttributeIds2["INVALID"] = 999] = "INVALID";
    })(AttributeIds || (exports2.AttributeIds = AttributeIds = {}));
    var AttributeIds_LAST = AttributeIds.AccessLevelEx;
    function invert(a) {
      return Object.entries(a).reduce((c2, [k, v]) => {
        c2[v] = k;
        return c2;
      }, {});
    }
    exports2.attributeNameById = invert(AttributeIds);
    function isValidAttributeId(attributeId) {
      return attributeId >= 1 && attributeId <= AttributeIds_LAST;
    }
    exports2.isValidAttributeId = isValidAttributeId;
  }
});

// node_modules/node-opcua-basic-types/dist/boolean.js
var require_boolean = __commonJS({
  "node_modules/node-opcua-basic-types/dist/boolean.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.decodeUABoolean = exports2.encodeUABoolean = exports2.coerceBoolean = exports2.decodeBoolean = exports2.encodeBoolean = exports2.randomBoolean = exports2.isValidBoolean = void 0;
    var node_opcua_assert_1 = require_dist14();
    function isValidBoolean(value) {
      return typeof value === "boolean";
    }
    exports2.isValidBoolean = isValidBoolean;
    function randomBoolean() {
      return Math.random() > 0.5;
    }
    exports2.randomBoolean = randomBoolean;
    function encodeBoolean(value, stream) {
      (0, node_opcua_assert_1.assert)(isValidBoolean(value));
      stream.writeUInt8(value ? 1 : 0);
    }
    exports2.encodeBoolean = encodeBoolean;
    function decodeBoolean(stream, _value) {
      return !!stream.readUInt8();
    }
    exports2.decodeBoolean = decodeBoolean;
    var falseDetectionRegex = /^(?:f(?:alse)?|no?|0+)$/i;
    function coerceBoolean(value) {
      return !falseDetectionRegex.test(value) && !!value;
    }
    exports2.coerceBoolean = coerceBoolean;
    exports2.encodeUABoolean = encodeBoolean;
    exports2.decodeUABoolean = decodeBoolean;
  }
});

// node_modules/node-opcua-buffer-utils/dist/buffer_utils.js
var require_buffer_utils = __commonJS({
  "node_modules/node-opcua-buffer-utils/dist/buffer_utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.clone_buffer = exports2.makeBuffer = exports2.createFastUninitializedBuffer = void 0;
    exports2.createFastUninitializedBuffer = Buffer.allocUnsafe;
    function makeBuffer(listOfBytes) {
      const l2 = listOfBytes.split(" ");
      const b = exports2.createFastUninitializedBuffer(l2.length);
      let i = 0;
      l2.forEach((value) => {
        b.writeUInt8(parseInt(value, 16), i);
        i += 1;
      });
      return b;
    }
    exports2.makeBuffer = makeBuffer;
    function clone_buffer(buffer) {
      const clone = exports2.createFastUninitializedBuffer(buffer.length);
      buffer.copy(clone, 0, 0);
      return clone;
    }
    exports2.clone_buffer = clone_buffer;
  }
});

// node_modules/node-opcua-buffer-utils/dist/index.js
var require_dist15 = __commonJS({
  "node_modules/node-opcua-buffer-utils/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_buffer_utils(), exports2);
  }
});

// node_modules/node-opcua-basic-types/dist/utils.js
var require_utils3 = __commonJS({
  "node_modules/node-opcua-basic-types/dist/utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getRandomInt = void 0;
    function getRandomInt(min, max) {
      return Math.floor(Math.random() * (max - min)) + min;
    }
    exports2.getRandomInt = getRandomInt;
  }
});

// node_modules/node-opcua-basic-types/dist/byte_string.js
var require_byte_string = __commonJS({
  "node_modules/node-opcua-basic-types/dist/byte_string.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.coerceByteString = exports2.decodeByteString = exports2.encodeByteString = exports2.randomByteString = exports2.isValidByteString = void 0;
    var node_opcua_buffer_utils_1 = require_dist15();
    var utils_1 = require_utils3();
    function isValidByteString(value) {
      return value === null || value instanceof Buffer;
    }
    exports2.isValidByteString = isValidByteString;
    function randomByteString(value, len) {
      len = len || (0, utils_1.getRandomInt)(1, 200);
      const b = (0, node_opcua_buffer_utils_1.createFastUninitializedBuffer)(len);
      for (let i = 0; i < len; i++) {
        b.writeUInt8((0, utils_1.getRandomInt)(0, 255), i);
      }
      return b;
    }
    exports2.randomByteString = randomByteString;
    function encodeByteString(byteString, stream) {
      stream.writeByteStream(byteString);
    }
    exports2.encodeByteString = encodeByteString;
    function decodeByteString(stream, _value) {
      return stream.readByteStream();
    }
    exports2.decodeByteString = decodeByteString;
    function coerceByteString(value) {
      if (Array.isArray(value)) {
        return Buffer.from(value);
      }
      if (typeof value === "string") {
        return Buffer.from(value, "base64");
      }
      return value;
    }
    exports2.coerceByteString = coerceByteString;
  }
});

// node_modules/node-opcua-basic-types/dist/data_type.js
var require_data_type = __commonJS({
  "node_modules/node-opcua-basic-types/dist/data_type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.DataType = void 0;
    var DataType;
    (function(DataType2) {
      DataType2[DataType2["Null"] = 0] = "Null";
      DataType2[DataType2["Boolean"] = 1] = "Boolean";
      DataType2[DataType2["SByte"] = 2] = "SByte";
      DataType2[DataType2["Byte"] = 3] = "Byte";
      DataType2[DataType2["Int16"] = 4] = "Int16";
      DataType2[DataType2["UInt16"] = 5] = "UInt16";
      DataType2[DataType2["Int32"] = 6] = "Int32";
      DataType2[DataType2["UInt32"] = 7] = "UInt32";
      DataType2[DataType2["Int64"] = 8] = "Int64";
      DataType2[DataType2["UInt64"] = 9] = "UInt64";
      DataType2[DataType2["Float"] = 10] = "Float";
      DataType2[DataType2["Double"] = 11] = "Double";
      DataType2[DataType2["String"] = 12] = "String";
      DataType2[DataType2["DateTime"] = 13] = "DateTime";
      DataType2[DataType2["Guid"] = 14] = "Guid";
      DataType2[DataType2["ByteString"] = 15] = "ByteString";
      DataType2[DataType2["XmlElement"] = 16] = "XmlElement";
      DataType2[DataType2["NodeId"] = 17] = "NodeId";
      DataType2[DataType2["ExpandedNodeId"] = 18] = "ExpandedNodeId";
      DataType2[DataType2["StatusCode"] = 19] = "StatusCode";
      DataType2[DataType2["QualifiedName"] = 20] = "QualifiedName";
      DataType2[DataType2["LocalizedText"] = 21] = "LocalizedText";
      DataType2[DataType2["ExtensionObject"] = 22] = "ExtensionObject";
      DataType2[DataType2["DataValue"] = 23] = "DataValue";
      DataType2[DataType2["Variant"] = 24] = "Variant";
      DataType2[DataType2["DiagnosticInfo"] = 25] = "DiagnosticInfo";
    })(DataType || (exports2.DataType = DataType = {}));
  }
});

// node_modules/long/src/long.js
var require_long = __commonJS({
  "node_modules/long/src/long.js"(exports2, module2) {
    module2.exports = Long;
    var wasm = null;
    try {
      wasm = new WebAssembly.Instance(new WebAssembly.Module(new Uint8Array([
        0,
        97,
        115,
        109,
        1,
        0,
        0,
        0,
        1,
        13,
        2,
        96,
        0,
        1,
        127,
        96,
        4,
        127,
        127,
        127,
        127,
        1,
        127,
        3,
        7,
        6,
        0,
        1,
        1,
        1,
        1,
        1,
        6,
        6,
        1,
        127,
        1,
        65,
        0,
        11,
        7,
        50,
        6,
        3,
        109,
        117,
        108,
        0,
        1,
        5,
        100,
        105,
        118,
        95,
        115,
        0,
        2,
        5,
        100,
        105,
        118,
        95,
        117,
        0,
        3,
        5,
        114,
        101,
        109,
        95,
        115,
        0,
        4,
        5,
        114,
        101,
        109,
        95,
        117,
        0,
        5,
        8,
        103,
        101,
        116,
        95,
        104,
        105,
        103,
        104,
        0,
        0,
        10,
        191,
        1,
        6,
        4,
        0,
        35,
        0,
        11,
        36,
        1,
        1,
        126,
        32,
        0,
        173,
        32,
        1,
        173,
        66,
        32,
        134,
        132,
        32,
        2,
        173,
        32,
        3,
        173,
        66,
        32,
        134,
        132,
        126,
        34,
        4,
        66,
        32,
        135,
        167,
        36,
        0,
        32,
        4,
        167,
        11,
        36,
        1,
        1,
        126,
        32,
        0,
        173,
        32,
        1,
        173,
        66,
        32,
        134,
        132,
        32,
        2,
        173,
        32,
        3,
        173,
        66,
        32,
        134,
        132,
        127,
        34,
        4,
        66,
        32,
        135,
        167,
        36,
        0,
        32,
        4,
        167,
        11,
        36,
        1,
        1,
        126,
        32,
        0,
        173,
        32,
        1,
        173,
        66,
        32,
        134,
        132,
        32,
        2,
        173,
        32,
        3,
        173,
        66,
        32,
        134,
        132,
        128,
        34,
        4,
        66,
        32,
        135,
        167,
        36,
        0,
        32,
        4,
        167,
        11,
        36,
        1,
        1,
        126,
        32,
        0,
        173,
        32,
        1,
        173,
        66,
        32,
        134,
        132,
        32,
        2,
        173,
        32,
        3,
        173,
        66,
        32,
        134,
        132,
        129,
        34,
        4,
        66,
        32,
        135,
        167,
        36,
        0,
        32,
        4,
        167,
        11,
        36,
        1,
        1,
        126,
        32,
        0,
        173,
        32,
        1,
        173,
        66,
        32,
        134,
        132,
        32,
        2,
        173,
        32,
        3,
        173,
        66,
        32,
        134,
        132,
        130,
        34,
        4,
        66,
        32,
        135,
        167,
        36,
        0,
        32,
        4,
        167,
        11
      ])), {}).exports;
    } catch (e) {
    }
    function Long(low, high, unsigned) {
      this.low = low | 0;
      this.high = high | 0;
      this.unsigned = !!unsigned;
    }
    Long.prototype.__isLong__;
    Object.defineProperty(Long.prototype, "__isLong__", { value: true });
    function isLong(obj) {
      return (obj && obj["__isLong__"]) === true;
    }
    Long.isLong = isLong;
    var INT_CACHE = {};
    var UINT_CACHE = {};
    function fromInt(value, unsigned) {
      var obj, cachedObj, cache;
      if (unsigned) {
        value >>>= 0;
        if (cache = 0 <= value && value < 256) {
          cachedObj = UINT_CACHE[value];
          if (cachedObj)
            return cachedObj;
        }
        obj = fromBits(value, (value | 0) < 0 ? -1 : 0, true);
        if (cache)
          UINT_CACHE[value] = obj;
        return obj;
      } else {
        value |= 0;
        if (cache = -128 <= value && value < 128) {
          cachedObj = INT_CACHE[value];
          if (cachedObj)
            return cachedObj;
        }
        obj = fromBits(value, value < 0 ? -1 : 0, false);
        if (cache)
          INT_CACHE[value] = obj;
        return obj;
      }
    }
    Long.fromInt = fromInt;
    function fromNumber(value, unsigned) {
      if (isNaN(value))
        return unsigned ? UZERO : ZERO;
      if (unsigned) {
        if (value < 0)
          return UZERO;
        if (value >= TWO_PWR_64_DBL)
          return MAX_UNSIGNED_VALUE;
      } else {
        if (value <= -TWO_PWR_63_DBL)
          return MIN_VALUE;
        if (value + 1 >= TWO_PWR_63_DBL)
          return MAX_VALUE;
      }
      if (value < 0)
        return fromNumber(-value, unsigned).neg();
      return fromBits(value % TWO_PWR_32_DBL | 0, value / TWO_PWR_32_DBL | 0, unsigned);
    }
    Long.fromNumber = fromNumber;
    function fromBits(lowBits, highBits, unsigned) {
      return new Long(lowBits, highBits, unsigned);
    }
    Long.fromBits = fromBits;
    var pow_dbl = Math.pow;
    function fromString(str, unsigned, radix) {
      if (str.length === 0)
        throw Error("empty string");
      if (str === "NaN" || str === "Infinity" || str === "+Infinity" || str === "-Infinity")
        return ZERO;
      if (typeof unsigned === "number") {
        radix = unsigned, unsigned = false;
      } else {
        unsigned = !!unsigned;
      }
      radix = radix || 10;
      if (radix < 2 || 36 < radix)
        throw RangeError("radix");
      var p3;
      if ((p3 = str.indexOf("-")) > 0)
        throw Error("interior hyphen");
      else if (p3 === 0) {
        return fromString(str.substring(1), unsigned, radix).neg();
      }
      var radixToPower = fromNumber(pow_dbl(radix, 8));
      var result2 = ZERO;
      for (var i = 0; i < str.length; i += 8) {
        var size = Math.min(8, str.length - i), value = parseInt(str.substring(i, i + size), radix);
        if (size < 8) {
          var power = fromNumber(pow_dbl(radix, size));
          result2 = result2.mul(power).add(fromNumber(value));
        } else {
          result2 = result2.mul(radixToPower);
          result2 = result2.add(fromNumber(value));
        }
      }
      result2.unsigned = unsigned;
      return result2;
    }
    Long.fromString = fromString;
    function fromValue(val, unsigned) {
      if (typeof val === "number")
        return fromNumber(val, unsigned);
      if (typeof val === "string")
        return fromString(val, unsigned);
      return fromBits(val.low, val.high, typeof unsigned === "boolean" ? unsigned : val.unsigned);
    }
    Long.fromValue = fromValue;
    var TWO_PWR_16_DBL = 1 << 16;
    var TWO_PWR_24_DBL = 1 << 24;
    var TWO_PWR_32_DBL = TWO_PWR_16_DBL * TWO_PWR_16_DBL;
    var TWO_PWR_64_DBL = TWO_PWR_32_DBL * TWO_PWR_32_DBL;
    var TWO_PWR_63_DBL = TWO_PWR_64_DBL / 2;
    var TWO_PWR_24 = fromInt(TWO_PWR_24_DBL);
    var ZERO = fromInt(0);
    Long.ZERO = ZERO;
    var UZERO = fromInt(0, true);
    Long.UZERO = UZERO;
    var ONE = fromInt(1);
    Long.ONE = ONE;
    var UONE = fromInt(1, true);
    Long.UONE = UONE;
    var NEG_ONE = fromInt(-1);
    Long.NEG_ONE = NEG_ONE;
    var MAX_VALUE = fromBits(4294967295 | 0, 2147483647 | 0, false);
    Long.MAX_VALUE = MAX_VALUE;
    var MAX_UNSIGNED_VALUE = fromBits(4294967295 | 0, 4294967295 | 0, true);
    Long.MAX_UNSIGNED_VALUE = MAX_UNSIGNED_VALUE;
    var MIN_VALUE = fromBits(0, 2147483648 | 0, false);
    Long.MIN_VALUE = MIN_VALUE;
    var LongPrototype = Long.prototype;
    LongPrototype.toInt = function toInt() {
      return this.unsigned ? this.low >>> 0 : this.low;
    };
    LongPrototype.toNumber = function toNumber() {
      if (this.unsigned)
        return (this.high >>> 0) * TWO_PWR_32_DBL + (this.low >>> 0);
      return this.high * TWO_PWR_32_DBL + (this.low >>> 0);
    };
    LongPrototype.toString = function toString(radix) {
      radix = radix || 10;
      if (radix < 2 || 36 < radix)
        throw RangeError("radix");
      if (this.isZero())
        return "0";
      if (this.isNegative()) {
        if (this.eq(MIN_VALUE)) {
          var radixLong = fromNumber(radix), div = this.div(radixLong), rem1 = div.mul(radixLong).sub(this);
          return div.toString(radix) + rem1.toInt().toString(radix);
        } else
          return "-" + this.neg().toString(radix);
      }
      var radixToPower = fromNumber(pow_dbl(radix, 6), this.unsigned), rem = this;
      var result2 = "";
      while (true) {
        var remDiv = rem.div(radixToPower), intval = rem.sub(remDiv.mul(radixToPower)).toInt() >>> 0, digits = intval.toString(radix);
        rem = remDiv;
        if (rem.isZero())
          return digits + result2;
        else {
          while (digits.length < 6)
            digits = "0" + digits;
          result2 = "" + digits + result2;
        }
      }
    };
    LongPrototype.getHighBits = function getHighBits() {
      return this.high;
    };
    LongPrototype.getHighBitsUnsigned = function getHighBitsUnsigned() {
      return this.high >>> 0;
    };
    LongPrototype.getLowBits = function getLowBits() {
      return this.low;
    };
    LongPrototype.getLowBitsUnsigned = function getLowBitsUnsigned() {
      return this.low >>> 0;
    };
    LongPrototype.getNumBitsAbs = function getNumBitsAbs() {
      if (this.isNegative())
        return this.eq(MIN_VALUE) ? 64 : this.neg().getNumBitsAbs();
      var val = this.high != 0 ? this.high : this.low;
      for (var bit = 31; bit > 0; bit--)
        if ((val & 1 << bit) != 0)
          break;
      return this.high != 0 ? bit + 33 : bit + 1;
    };
    LongPrototype.isZero = function isZero() {
      return this.high === 0 && this.low === 0;
    };
    LongPrototype.eqz = LongPrototype.isZero;
    LongPrototype.isNegative = function isNegative() {
      return !this.unsigned && this.high < 0;
    };
    LongPrototype.isPositive = function isPositive() {
      return this.unsigned || this.high >= 0;
    };
    LongPrototype.isOdd = function isOdd() {
      return (this.low & 1) === 1;
    };
    LongPrototype.isEven = function isEven() {
      return (this.low & 1) === 0;
    };
    LongPrototype.equals = function equals(other) {
      if (!isLong(other))
        other = fromValue(other);
      if (this.unsigned !== other.unsigned && this.high >>> 31 === 1 && other.high >>> 31 === 1)
        return false;
      return this.high === other.high && this.low === other.low;
    };
    LongPrototype.eq = LongPrototype.equals;
    LongPrototype.notEquals = function notEquals(other) {
      return !this.eq(
        /* validates */
        other
      );
    };
    LongPrototype.neq = LongPrototype.notEquals;
    LongPrototype.ne = LongPrototype.notEquals;
    LongPrototype.lessThan = function lessThan(other) {
      return this.comp(
        /* validates */
        other
      ) < 0;
    };
    LongPrototype.lt = LongPrototype.lessThan;
    LongPrototype.lessThanOrEqual = function lessThanOrEqual(other) {
      return this.comp(
        /* validates */
        other
      ) <= 0;
    };
    LongPrototype.lte = LongPrototype.lessThanOrEqual;
    LongPrototype.le = LongPrototype.lessThanOrEqual;
    LongPrototype.greaterThan = function greaterThan(other) {
      return this.comp(
        /* validates */
        other
      ) > 0;
    };
    LongPrototype.gt = LongPrototype.greaterThan;
    LongPrototype.greaterThanOrEqual = function greaterThanOrEqual(other) {
      return this.comp(
        /* validates */
        other
      ) >= 0;
    };
    LongPrototype.gte = LongPrototype.greaterThanOrEqual;
    LongPrototype.ge = LongPrototype.greaterThanOrEqual;
    LongPrototype.compare = function compare(other) {
      if (!isLong(other))
        other = fromValue(other);
      if (this.eq(other))
        return 0;
      var thisNeg = this.isNegative(), otherNeg = other.isNegative();
      if (thisNeg && !otherNeg)
        return -1;
      if (!thisNeg && otherNeg)
        return 1;
      if (!this.unsigned)
        return this.sub(other).isNegative() ? -1 : 1;
      return other.high >>> 0 > this.high >>> 0 || other.high === this.high && other.low >>> 0 > this.low >>> 0 ? -1 : 1;
    };
    LongPrototype.comp = LongPrototype.compare;
    LongPrototype.negate = function negate() {
      if (!this.unsigned && this.eq(MIN_VALUE))
        return MIN_VALUE;
      return this.not().add(ONE);
    };
    LongPrototype.neg = LongPrototype.negate;
    LongPrototype.add = function add(addend) {
      if (!isLong(addend))
        addend = fromValue(addend);
      var a48 = this.high >>> 16;
      var a32 = this.high & 65535;
      var a16 = this.low >>> 16;
      var a00 = this.low & 65535;
      var b48 = addend.high >>> 16;
      var b32 = addend.high & 65535;
      var b16 = addend.low >>> 16;
      var b00 = addend.low & 65535;
      var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
      c00 += a00 + b00;
      c16 += c00 >>> 16;
      c00 &= 65535;
      c16 += a16 + b16;
      c32 += c16 >>> 16;
      c16 &= 65535;
      c32 += a32 + b32;
      c48 += c32 >>> 16;
      c32 &= 65535;
      c48 += a48 + b48;
      c48 &= 65535;
      return fromBits(c16 << 16 | c00, c48 << 16 | c32, this.unsigned);
    };
    LongPrototype.subtract = function subtract(subtrahend) {
      if (!isLong(subtrahend))
        subtrahend = fromValue(subtrahend);
      return this.add(subtrahend.neg());
    };
    LongPrototype.sub = LongPrototype.subtract;
    LongPrototype.multiply = function multiply(multiplier) {
      if (this.isZero())
        return ZERO;
      if (!isLong(multiplier))
        multiplier = fromValue(multiplier);
      if (wasm) {
        var low = wasm.mul(
          this.low,
          this.high,
          multiplier.low,
          multiplier.high
        );
        return fromBits(low, wasm.get_high(), this.unsigned);
      }
      if (multiplier.isZero())
        return ZERO;
      if (this.eq(MIN_VALUE))
        return multiplier.isOdd() ? MIN_VALUE : ZERO;
      if (multiplier.eq(MIN_VALUE))
        return this.isOdd() ? MIN_VALUE : ZERO;
      if (this.isNegative()) {
        if (multiplier.isNegative())
          return this.neg().mul(multiplier.neg());
        else
          return this.neg().mul(multiplier).neg();
      } else if (multiplier.isNegative())
        return this.mul(multiplier.neg()).neg();
      if (this.lt(TWO_PWR_24) && multiplier.lt(TWO_PWR_24))
        return fromNumber(this.toNumber() * multiplier.toNumber(), this.unsigned);
      var a48 = this.high >>> 16;
      var a32 = this.high & 65535;
      var a16 = this.low >>> 16;
      var a00 = this.low & 65535;
      var b48 = multiplier.high >>> 16;
      var b32 = multiplier.high & 65535;
      var b16 = multiplier.low >>> 16;
      var b00 = multiplier.low & 65535;
      var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
      c00 += a00 * b00;
      c16 += c00 >>> 16;
      c00 &= 65535;
      c16 += a16 * b00;
      c32 += c16 >>> 16;
      c16 &= 65535;
      c16 += a00 * b16;
      c32 += c16 >>> 16;
      c16 &= 65535;
      c32 += a32 * b00;
      c48 += c32 >>> 16;
      c32 &= 65535;
      c32 += a16 * b16;
      c48 += c32 >>> 16;
      c32 &= 65535;
      c32 += a00 * b32;
      c48 += c32 >>> 16;
      c32 &= 65535;
      c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
      c48 &= 65535;
      return fromBits(c16 << 16 | c00, c48 << 16 | c32, this.unsigned);
    };
    LongPrototype.mul = LongPrototype.multiply;
    LongPrototype.divide = function divide(divisor) {
      if (!isLong(divisor))
        divisor = fromValue(divisor);
      if (divisor.isZero())
        throw Error("division by zero");
      if (wasm) {
        if (!this.unsigned && this.high === -2147483648 && divisor.low === -1 && divisor.high === -1) {
          return this;
        }
        var low = (this.unsigned ? wasm.div_u : wasm.div_s)(
          this.low,
          this.high,
          divisor.low,
          divisor.high
        );
        return fromBits(low, wasm.get_high(), this.unsigned);
      }
      if (this.isZero())
        return this.unsigned ? UZERO : ZERO;
      var approx, rem, res;
      if (!this.unsigned) {
        if (this.eq(MIN_VALUE)) {
          if (divisor.eq(ONE) || divisor.eq(NEG_ONE))
            return MIN_VALUE;
          else if (divisor.eq(MIN_VALUE))
            return ONE;
          else {
            var halfThis = this.shr(1);
            approx = halfThis.div(divisor).shl(1);
            if (approx.eq(ZERO)) {
              return divisor.isNegative() ? ONE : NEG_ONE;
            } else {
              rem = this.sub(divisor.mul(approx));
              res = approx.add(rem.div(divisor));
              return res;
            }
          }
        } else if (divisor.eq(MIN_VALUE))
          return this.unsigned ? UZERO : ZERO;
        if (this.isNegative()) {
          if (divisor.isNegative())
            return this.neg().div(divisor.neg());
          return this.neg().div(divisor).neg();
        } else if (divisor.isNegative())
          return this.div(divisor.neg()).neg();
        res = ZERO;
      } else {
        if (!divisor.unsigned)
          divisor = divisor.toUnsigned();
        if (divisor.gt(this))
          return UZERO;
        if (divisor.gt(this.shru(1)))
          return UONE;
        res = UZERO;
      }
      rem = this;
      while (rem.gte(divisor)) {
        approx = Math.max(1, Math.floor(rem.toNumber() / divisor.toNumber()));
        var log2 = Math.ceil(Math.log(approx) / Math.LN2), delta = log2 <= 48 ? 1 : pow_dbl(2, log2 - 48), approxRes = fromNumber(approx), approxRem = approxRes.mul(divisor);
        while (approxRem.isNegative() || approxRem.gt(rem)) {
          approx -= delta;
          approxRes = fromNumber(approx, this.unsigned);
          approxRem = approxRes.mul(divisor);
        }
        if (approxRes.isZero())
          approxRes = ONE;
        res = res.add(approxRes);
        rem = rem.sub(approxRem);
      }
      return res;
    };
    LongPrototype.div = LongPrototype.divide;
    LongPrototype.modulo = function modulo(divisor) {
      if (!isLong(divisor))
        divisor = fromValue(divisor);
      if (wasm) {
        var low = (this.unsigned ? wasm.rem_u : wasm.rem_s)(
          this.low,
          this.high,
          divisor.low,
          divisor.high
        );
        return fromBits(low, wasm.get_high(), this.unsigned);
      }
      return this.sub(this.div(divisor).mul(divisor));
    };
    LongPrototype.mod = LongPrototype.modulo;
    LongPrototype.rem = LongPrototype.modulo;
    LongPrototype.not = function not() {
      return fromBits(~this.low, ~this.high, this.unsigned);
    };
    LongPrototype.and = function and(other) {
      if (!isLong(other))
        other = fromValue(other);
      return fromBits(this.low & other.low, this.high & other.high, this.unsigned);
    };
    LongPrototype.or = function or(other) {
      if (!isLong(other))
        other = fromValue(other);
      return fromBits(this.low | other.low, this.high | other.high, this.unsigned);
    };
    LongPrototype.xor = function xor(other) {
      if (!isLong(other))
        other = fromValue(other);
      return fromBits(this.low ^ other.low, this.high ^ other.high, this.unsigned);
    };
    LongPrototype.shiftLeft = function shiftLeft(numBits) {
      if (isLong(numBits))
        numBits = numBits.toInt();
      if ((numBits &= 63) === 0)
        return this;
      else if (numBits < 32)
        return fromBits(this.low << numBits, this.high << numBits | this.low >>> 32 - numBits, this.unsigned);
      else
        return fromBits(0, this.low << numBits - 32, this.unsigned);
    };
    LongPrototype.shl = LongPrototype.shiftLeft;
    LongPrototype.shiftRight = function shiftRight(numBits) {
      if (isLong(numBits))
        numBits = numBits.toInt();
      if ((numBits &= 63) === 0)
        return this;
      else if (numBits < 32)
        return fromBits(this.low >>> numBits | this.high << 32 - numBits, this.high >> numBits, this.unsigned);
      else
        return fromBits(this.high >> numBits - 32, this.high >= 0 ? 0 : -1, this.unsigned);
    };
    LongPrototype.shr = LongPrototype.shiftRight;
    LongPrototype.shiftRightUnsigned = function shiftRightUnsigned(numBits) {
      if (isLong(numBits))
        numBits = numBits.toInt();
      numBits &= 63;
      if (numBits === 0)
        return this;
      else {
        var high = this.high;
        if (numBits < 32) {
          var low = this.low;
          return fromBits(low >>> numBits | high << 32 - numBits, high >>> numBits, this.unsigned);
        } else if (numBits === 32)
          return fromBits(high, 0, this.unsigned);
        else
          return fromBits(high >>> numBits - 32, 0, this.unsigned);
      }
    };
    LongPrototype.shru = LongPrototype.shiftRightUnsigned;
    LongPrototype.shr_u = LongPrototype.shiftRightUnsigned;
    LongPrototype.toSigned = function toSigned() {
      if (!this.unsigned)
        return this;
      return fromBits(this.low, this.high, false);
    };
    LongPrototype.toUnsigned = function toUnsigned() {
      if (this.unsigned)
        return this;
      return fromBits(this.low, this.high, true);
    };
    LongPrototype.toBytes = function toBytes(le) {
      return le ? this.toBytesLE() : this.toBytesBE();
    };
    LongPrototype.toBytesLE = function toBytesLE() {
      var hi = this.high, lo = this.low;
      return [
        lo & 255,
        lo >>> 8 & 255,
        lo >>> 16 & 255,
        lo >>> 24,
        hi & 255,
        hi >>> 8 & 255,
        hi >>> 16 & 255,
        hi >>> 24
      ];
    };
    LongPrototype.toBytesBE = function toBytesBE() {
      var hi = this.high, lo = this.low;
      return [
        hi >>> 24,
        hi >>> 16 & 255,
        hi >>> 8 & 255,
        hi & 255,
        lo >>> 24,
        lo >>> 16 & 255,
        lo >>> 8 & 255,
        lo & 255
      ];
    };
    Long.fromBytes = function fromBytes(bytes, unsigned, le) {
      return le ? Long.fromBytesLE(bytes, unsigned) : Long.fromBytesBE(bytes, unsigned);
    };
    Long.fromBytesLE = function fromBytesLE(bytes, unsigned) {
      return new Long(
        bytes[0] | bytes[1] << 8 | bytes[2] << 16 | bytes[3] << 24,
        bytes[4] | bytes[5] << 8 | bytes[6] << 16 | bytes[7] << 24,
        unsigned
      );
    };
    Long.fromBytesBE = function fromBytesBE(bytes, unsigned) {
      return new Long(
        bytes[4] << 24 | bytes[5] << 16 | bytes[6] << 8 | bytes[7],
        bytes[0] << 24 | bytes[1] << 16 | bytes[2] << 8 | bytes[3],
        unsigned
      );
    };
  }
});

// node_modules/node-opcua-utils/dist/buffer_ellipsis.js
var require_buffer_ellipsis = __commonJS({
  "node_modules/node-opcua-utils/dist/buffer_ellipsis.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.buffer_ellipsis = void 0;
    function buffer_ellipsis(buffer, start, end) {
      start = start || 0;
      end = end || buffer.length;
      if (end - start < 40) {
        return buffer.subarray(start, end).toString("hex");
      }
      return buffer.subarray(start, start + 10).toString("hex") + " ... " + buffer.subarray(end - 10, end).toString("hex");
    }
    exports2.buffer_ellipsis = buffer_ellipsis;
    exports2.buffer_ellipsis = buffer_ellipsis;
  }
});

// node_modules/node-opcua-utils/dist/string_utils.js
var require_string_utils = __commonJS({
  "node_modules/node-opcua-utils/dist/string_utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.lowerFirstLetter = exports2.countAlpha = exports2.countUpperCase = exports2.countAlphaSlow = exports2.countUpperCaseSlow = exports2.isAlpha = exports2.isUpperCaseChar = exports2.capitalizeFirstLetter = void 0;
    function capitalizeFirstLetter(str) {
      if (str == null) {
        return str;
      }
      return str.substring(0, 1).toUpperCase() + str.substring(1);
    }
    exports2.capitalizeFirstLetter = capitalizeFirstLetter;
    var ACode = "A".charCodeAt(0);
    var ZCode = "Z".charCodeAt(0);
    function isUpperCaseChar(c2) {
      const code = c2.charCodeAt(0);
      return code >= ACode && code <= ZCode;
    }
    exports2.isUpperCaseChar = isUpperCaseChar;
    var aCode = "a".charCodeAt(0);
    var zCode = "z".charCodeAt(0);
    function isAlpha(c2) {
      const code = c2.charCodeAt(0);
      return code >= ACode && code <= ZCode || code >= aCode && code <= zCode;
    }
    exports2.isAlpha = isAlpha;
    function countUpperCaseSlow(str) {
      return str.split("").reduce((p3, c2) => p3 + (isUpperCaseChar(c2) ? 1 : 0), 0);
    }
    exports2.countUpperCaseSlow = countUpperCaseSlow;
    function countAlphaSlow(str) {
      return str.split("").reduce((p3, c2) => p3 + (isAlpha(c2) ? 1 : 0), 0);
    }
    exports2.countAlphaSlow = countAlphaSlow;
    function countUpperCase(str) {
      let count = 0;
      const n = str.length;
      for (let i = 0; i < n; i++) {
        count += isUpperCaseChar(str[i]) ? 1 : 0;
      }
      return count;
    }
    exports2.countUpperCase = countUpperCase;
    function countAlpha(str) {
      let count = 0;
      const n = str.length;
      for (let i = 0; i < n; i++) {
        count += isAlpha(str[i]) ? 1 : 0;
      }
      return count;
    }
    exports2.countAlpha = countAlpha;
    function lowerFirstLetter(str) {
      if (str == null) {
        return str;
      }
      if (str.length >= 2 && countUpperCase(str) === countAlpha(str)) {
        return str;
      }
      if (str.match(/_/)) {
        return str.split("_").map(lowerFirstLetter).join("_");
      }
      let result2 = str.substring(0, 1).toLowerCase() + str.substring(1);
      if (result2.length > 3 && isUpperCaseChar(str[1]) && isUpperCaseChar(str[2])) {
        result2 = str.substring(0, 2).toLowerCase() + str.substring(2);
      }
      return result2;
    }
    exports2.lowerFirstLetter = lowerFirstLetter;
  }
});

// node_modules/node-opcua-utils/dist/object_classname.js
var require_object_classname = __commonJS({
  "node_modules/node-opcua-utils/dist/object_classname.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getObjectClassName = void 0;
    function getObjectClassName(obj) {
      return Object.prototype.toString.call(obj).slice(8, -1);
    }
    exports2.getObjectClassName = getObjectClassName;
  }
});

// node_modules/node-opcua-utils/dist/get_clock_tick.js
var require_get_clock_tick = __commonJS({
  "node_modules/node-opcua-utils/dist/get_clock_tick.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.get_clock_tick = void 0;
    if (typeof process === "object" && process.hrtime) {
      const tickOrigin = process.hrtime();
      exports2.get_clock_tick = () => {
        const hrt = process.hrtime(tickOrigin);
        const r = hrt[0] * 1e3 + Math.ceil(hrt[1] / 1e6 * 1e3) / 1e3;
        return r;
      };
    } else {
      exports2.get_clock_tick = () => Date.now();
    }
  }
});

// node_modules/node-opcua-utils/dist/compare_buffers.js
var require_compare_buffers = __commonJS({
  "node_modules/node-opcua-utils/dist/compare_buffers.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.compare_buffers = void 0;
    var chalk_1 = __importDefault3(require_source());
    var buffer_ellipsis_1 = require_buffer_ellipsis();
    function compare_buffers(buf1, buf2, max_length) {
      max_length = max_length || buf2.length;
      const block_length = 80;
      let cursor = 0;
      while (cursor < max_length) {
        const slice1 = buf1.subarray(cursor, cursor + block_length);
        const slice2 = buf2.subarray(cursor, cursor + block_length);
        if (slice2.toString("hex") !== slice1.toString("hex")) {
          console.log("pos = ", cursor);
          console.log("slice1 :", chalk_1.default.yellow((0, buffer_ellipsis_1.buffer_ellipsis)(slice1)));
          console.log("slice2 :", chalk_1.default.blue((0, buffer_ellipsis_1.buffer_ellipsis)(slice2)));
        }
        cursor += block_length;
      }
    }
    exports2.compare_buffers = compare_buffers;
  }
});

// node_modules/node-opcua-utils/dist/get_function_parameters_name.js
var require_get_function_parameters_name = __commonJS({
  "node_modules/node-opcua-utils/dist/get_function_parameters_name.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getFunctionParameterNames = void 0;
    var STRIP_COMMENTS = /((\/\/.*$)|(\/\*[\s\S]*?\*\/))/gm;
    var ARGUMENT_NAMES = /([^\s,]+)/g;
    function getFunctionParameterNames(func) {
      const fnStr = func.toString().replace(STRIP_COMMENTS, "");
      const result2 = fnStr.slice(fnStr.indexOf("(") + 1, fnStr.indexOf(")")).match(ARGUMENT_NAMES);
      if (!result2) {
        return [];
      }
      return result2;
    }
    exports2.getFunctionParameterNames = getFunctionParameterNames;
  }
});

// node_modules/node-opcua-utils/dist/watchdog.js
var require_watchdog = __commonJS({
  "node_modules/node-opcua-utils/dist/watchdog.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.WatchDog = void 0;
    var events_1 = require("events");
    var node_opcua_assert_1 = require_dist14();
    var get_clock_tick_1 = require_get_clock_tick();
    function hasExpired(watchDogData, currentTime) {
      const elapsedTime = currentTime - watchDogData.lastSeen;
      return elapsedTime > watchDogData.timeout;
    }
    function keepAliveFunc() {
      (0, node_opcua_assert_1.assert)(this._watchDog instanceof WatchDog);
      if (!this._watchDogData || !this._watchDog) {
        throw new Error("Internal error");
      }
      (0, node_opcua_assert_1.assert)(typeof this._watchDogData.key === "number");
      this._watchDogData.lastSeen = this._watchDog.getCurrentSystemTick();
      if (this.onClientSeen) {
        this.onClientSeen();
      }
    }
    var WatchDog = class _WatchDog extends events_1.EventEmitter {
      static lastSeenToDuration(lastSeen) {
        return (0, get_clock_tick_1.get_clock_tick)() - lastSeen;
      }
      /**
       * returns the number of subscribers using the WatchDog object.
       */
      get subscriberCount() {
        return Object.keys(this._watchdogDataMap).length;
      }
      constructor() {
        super();
        this._watchdogDataMap = {};
        this._counter = 0;
        this._currentTime = this.getCurrentSystemTick();
        this._visitSubscriberB = this._visit_subscriber.bind(this);
        this._timer = null;
      }
      /**
       * add a subscriber to the WatchDog.
       * @method addSubscriber
       *
       * add a subscriber to the WatchDog.
       *
       * This method modifies the subscriber be adding a
       * new method to it called 'keepAlive'
       * The subscriber must also provide a "watchdogReset". watchdogReset will be called
       * if the subscriber failed to call keepAlive withing the timeout period.
       * @param subscriber
       * @param timeout
       * @return the numerical key associated with this subscriber
       */
      addSubscriber(subscriber, timeout) {
        this._currentTime = this.getCurrentSystemTick();
        timeout = timeout || 1e3;
        (0, node_opcua_assert_1.assert)(typeof timeout === "number", " invalid timeout ");
        (0, node_opcua_assert_1.assert)(typeof subscriber.watchdogReset === "function", " the subscriber must provide a watchdogReset method ");
        (0, node_opcua_assert_1.assert)(typeof subscriber.keepAlive !== "function" || subscriber.keepAlive === _WatchDog.emptyKeepAlive);
        this._counter += 1;
        const key = this._counter;
        subscriber._watchDog = this;
        subscriber._watchDogData = {
          key,
          lastSeen: this._currentTime,
          subscriber,
          timeout,
          visitCount: 0
        };
        this._watchdogDataMap[key] = subscriber._watchDogData;
        if (subscriber.onClientSeen) {
          subscriber.onClientSeen();
        }
        subscriber.keepAlive = keepAliveFunc.bind(subscriber);
        if (this.subscriberCount === 1) {
          (0, node_opcua_assert_1.assert)(this._timer === null);
          this._start_timer();
        }
        (0, node_opcua_assert_1.assert)(this._timer !== null);
        return key;
      }
      removeSubscriber(subscriber) {
        if (!subscriber._watchDog) {
          return;
        }
        if (!subscriber._watchDogData) {
          throw new Error("Internal error");
        }
        (0, node_opcua_assert_1.assert)(subscriber._watchDog instanceof _WatchDog);
        (0, node_opcua_assert_1.assert)(typeof subscriber._watchDogData.key === "number");
        (0, node_opcua_assert_1.assert)(typeof subscriber.keepAlive === "function");
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(this._watchdogDataMap, subscriber._watchDogData.key));
        delete this._watchdogDataMap[subscriber._watchDogData.key];
        delete subscriber._watchDog;
        subscriber.keepAlive = _WatchDog.emptyKeepAlive;
        if (this.subscriberCount === 0) {
          this._stop_timer();
        }
      }
      shutdown() {
        (0, node_opcua_assert_1.assert)(this._timer === null && Object.keys(this._watchdogDataMap).length === 0, " leaking subscriber in watchdog");
      }
      getCurrentSystemTick() {
        return (0, get_clock_tick_1.get_clock_tick)();
      }
      _visit_subscriber() {
        this._currentTime = this.getCurrentSystemTick();
        const expiredSubscribers = Object.values(this._watchdogDataMap).filter((watchDogData) => {
          watchDogData.visitCount += 1;
          return hasExpired(watchDogData, this._currentTime);
        });
        if (expiredSubscribers.length) {
          this.emit("timeout", expiredSubscribers);
        }
        expiredSubscribers.forEach((watchDogData) => {
          this.removeSubscriber(watchDogData.subscriber);
          watchDogData.subscriber.watchdogReset();
        });
      }
      _start_timer() {
        (0, node_opcua_assert_1.assert)(this._timer === null, " setInterval already called ?");
        this._timer = setInterval(this._visitSubscriberB, 1e3);
      }
      _stop_timer() {
        (0, node_opcua_assert_1.assert)(this._timer !== null, "_stop_timer already called ?");
        if (this._timer !== null) {
          clearInterval(this._timer);
          this._timer = null;
        }
      }
    };
    exports2.WatchDog = WatchDog;
    WatchDog.emptyKeepAlive = () => {
    };
  }
});

// node_modules/node-opcua-utils/dist/set_deprecated.js
var require_set_deprecated = __commonJS({
  "node_modules/node-opcua-utils/dist/set_deprecated.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.setDeprecated = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    function setDeprecated(constructor, methodName, helpString) {
      const oldMethod = constructor.prototype[methodName];
      (0, node_opcua_assert_1.assert)(oldMethod instanceof Function, "expecting a valid " + methodName + "method on class " + constructor.constructor.name);
      let counter = 0;
      constructor.prototype[methodName] = function(...args) {
        if (counter % 1e3 === 0) {
          console.log(chalk_1.default.green("Warning !"), chalk_1.default.green(chalk_1.default.bold(constructor.name + "#" + methodName), " is now deprecated"));
          console.log("         ", helpString);
        }
        counter++;
        return oldMethod.call(this, ...args);
      };
    }
    exports2.setDeprecated = setDeprecated;
  }
});

// node_modules/node-opcua-utils/dist/replace_buffer_with_hex_dump.js
var require_replace_buffer_with_hex_dump = __commonJS({
  "node_modules/node-opcua-utils/dist/replace_buffer_with_hex_dump.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.replaceBufferWithHexDump = void 0;
    function replaceBufferWithHexDump(obj) {
      for (const p3 in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, p3)) {
          if (obj[p3] instanceof Buffer) {
            obj[p3] = "<BUFFER>" + obj[p3].toString("hex") + "</BUFFER>";
          } else if (typeof obj[p3] === "object") {
            replaceBufferWithHexDump(obj[p3]);
          }
        }
      }
      return obj;
    }
    exports2.replaceBufferWithHexDump = replaceBufferWithHexDump;
  }
});

// node_modules/node-opcua-utils/dist/timestamp.js
var require_timestamp = __commonJS({
  "node_modules/node-opcua-utils/dist/timestamp.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.timestamp = void 0;
    function w(s, length) {
      return ("" + s).padStart(length, "0");
    }
    function t(d2) {
      return w(d2.getUTCHours(), 2) + ":" + w(d2.getUTCMinutes(), 2) + ":" + w(d2.getUTCSeconds(), 2) + ":" + w(d2.getMilliseconds(), 3);
    }
    function timestamp() {
      return t(/* @__PURE__ */ new Date());
    }
    exports2.timestamp = timestamp;
  }
});

// node_modules/node-opcua-utils/dist/line_file.js
var require_line_file = __commonJS({
  "node_modules/node-opcua-utils/dist/line_file.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.LineFile = void 0;
    var LineFile = class {
      constructor() {
        this._line = [];
      }
      write(...args) {
        let str = "";
        for (let i = 0; i < args.length; i++) {
          str += args[i];
        }
        this._line.push(str);
      }
      toString(endOfLine = "\n") {
        return this._line.join(endOfLine);
      }
    };
    exports2.LineFile = LineFile;
  }
});

// node_modules/node-opcua-utils/dist/match_uri.js
var require_match_uri = __commonJS({
  "node_modules/node-opcua-utils/dist/match_uri.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.matchUri = void 0;
    function matchUri(endpointUri1, endpointUri2) {
      if (endpointUri1 === null) {
        return endpointUri2 === null;
      }
      if (endpointUri2 === null) {
        return endpointUri1 === null;
      }
      return endpointUri1.toLowerCase() === endpointUri2.toLowerCase();
    }
    exports2.matchUri = matchUri;
  }
});

// node_modules/node-opcua-utils/dist/hrtime.js
var require_hrtime = __commonJS({
  "node_modules/node-opcua-utils/dist/hrtime.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.hrtime = void 0;
    var performance = typeof global === "object" && global.performance || {};
    var performanceNow = performance.now || performance.mozNow || performance.msNow || performance.oNow || performance.webkitNow || function() {
      return (/* @__PURE__ */ new Date()).getTime();
    };
    function hrtime_for_browser(previousTimestamp) {
      previousTimestamp = previousTimestamp || [0, 0];
      const clocktime = performanceNow.call(performance) * 1e-3;
      let seconds = Math.floor(clocktime);
      let nanoseconds = Math.floor(clocktime % 1 * 1e9);
      if (previousTimestamp) {
        seconds = seconds - previousTimestamp[0];
        nanoseconds = nanoseconds - previousTimestamp[1];
        if (nanoseconds < 0) {
          seconds--;
          nanoseconds += 1e9;
        }
      }
      return [seconds, nanoseconds];
    }
    exports2.hrtime = typeof process === "object" ? process.hrtime || hrtime_for_browser : hrtime_for_browser;
  }
});

// node_modules/node-opcua-utils/dist/index.js
var require_dist16 = __commonJS({
  "node_modules/node-opcua-utils/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.hrtime = exports2.replaceBufferWithHexDump = exports2.setDeprecated = exports2.getFunctionParameterNames = exports2.compare_buffers = exports2.get_clock_tick = exports2.getObjectClassName = exports2.lowerFirstLetter = exports2.capitalizeFirstLetter = exports2.buffer_ellipsis = exports2.isNullOrUndefined = exports2.check_flag = exports2.set_flag = void 0;
    var node_opcua_assert_1 = require_dist14();
    function set_flag(value, mask) {
      if (mask.value) {
        mask = mask.value;
      }
      (0, node_opcua_assert_1.assert)(!Object.prototype.hasOwnProperty.call(mask, "value"));
      (0, node_opcua_assert_1.assert)(mask !== void 0);
      return value | mask;
    }
    exports2.set_flag = set_flag;
    function check_flag(value, mask) {
      if (mask.value) {
        mask = mask.value;
      }
      (0, node_opcua_assert_1.assert)(!Object.prototype.hasOwnProperty.call(mask, "value"));
      return (value & mask) === mask;
    }
    exports2.check_flag = check_flag;
    function isNullOrUndefined(value) {
      return value === void 0 || value === null;
    }
    exports2.isNullOrUndefined = isNullOrUndefined;
    var buffer_ellipsis_1 = require_buffer_ellipsis();
    Object.defineProperty(exports2, "buffer_ellipsis", { enumerable: true, get: function() {
      return buffer_ellipsis_1.buffer_ellipsis;
    } });
    var string_utils_1 = require_string_utils();
    Object.defineProperty(exports2, "capitalizeFirstLetter", { enumerable: true, get: function() {
      return string_utils_1.capitalizeFirstLetter;
    } });
    Object.defineProperty(exports2, "lowerFirstLetter", { enumerable: true, get: function() {
      return string_utils_1.lowerFirstLetter;
    } });
    var object_classname_1 = require_object_classname();
    Object.defineProperty(exports2, "getObjectClassName", { enumerable: true, get: function() {
      return object_classname_1.getObjectClassName;
    } });
    var get_clock_tick_1 = require_get_clock_tick();
    Object.defineProperty(exports2, "get_clock_tick", { enumerable: true, get: function() {
      return get_clock_tick_1.get_clock_tick;
    } });
    var compare_buffers_1 = require_compare_buffers();
    Object.defineProperty(exports2, "compare_buffers", { enumerable: true, get: function() {
      return compare_buffers_1.compare_buffers;
    } });
    var get_function_parameters_name_1 = require_get_function_parameters_name();
    Object.defineProperty(exports2, "getFunctionParameterNames", { enumerable: true, get: function() {
      return get_function_parameters_name_1.getFunctionParameterNames;
    } });
    __exportStar3(require_watchdog(), exports2);
    var set_deprecated_1 = require_set_deprecated();
    Object.defineProperty(exports2, "setDeprecated", { enumerable: true, get: function() {
      return set_deprecated_1.setDeprecated;
    } });
    var replace_buffer_with_hex_dump_1 = require_replace_buffer_with_hex_dump();
    Object.defineProperty(exports2, "replaceBufferWithHexDump", { enumerable: true, get: function() {
      return replace_buffer_with_hex_dump_1.replaceBufferWithHexDump;
    } });
    __exportStar3(require_timestamp(), exports2);
    __exportStar3(require_line_file(), exports2);
    __exportStar3(require_match_uri(), exports2);
    var hrtime_1 = require_hrtime();
    Object.defineProperty(exports2, "hrtime", { enumerable: true, get: function() {
      return hrtime_1.hrtime;
    } });
  }
});

// node_modules/node-opcua-date-time/dist/date_time.js
var require_date_time = __commonJS({
  "node_modules/node-opcua-date-time/dist/date_time.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isMinDate = exports2.minOPCUADate = exports2.minDate = exports2.coerceClock = exports2.getCurrentClock = exports2.uninstallPeriodicClockAdjustment = exports2.installPeriodicClockAdjustment = exports2.periodicClockAdjustment = exports2.getCurrentClockWithJavascriptDate = exports2.bn_hundredNanoSecondFrom1601ToDate = exports2.bn_dateToHundredNanoSecondFrom1601Excess = exports2.bn_dateToHundredNanoSecondFrom1601 = exports2.offsetFactor1601 = void 0;
    var long_1 = __importDefault3(require_long());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_utils_1 = require_dist16();
    exports2.offsetFactor1601 = function offset_factor_1601() {
      const utc1600 = new Date(Date.UTC(1601, 0, 1, 0, 0, 0));
      const t1600 = utc1600.getTime();
      const utc1600PlusOneDay = new Date(Date.UTC(1601, 0, 2, 0, 0, 0));
      const t1600OneDay = utc1600PlusOneDay.getTime();
      const factor1 = 24 * 60 * 60 * 1e3 * 1e4 / (t1600OneDay - t1600);
      const utc1970 = new Date(Date.UTC(1970, 0, 1, 0, 0, 0));
      const t1970 = utc1970.getTime();
      const offsetToGregorianCalendarZero = -t1600 + t1970;
      (0, node_opcua_assert_1.assert)(factor1 === 1e4);
      (0, node_opcua_assert_1.assert)(offsetToGregorianCalendarZero === 116444736e5);
      return [offsetToGregorianCalendarZero, factor1];
    }();
    var offset = exports2.offsetFactor1601[0];
    var factor = exports2.offsetFactor1601[1];
    var offsetLong = long_1.default.fromNumber(offset, true);
    var factorLong = long_1.default.fromNumber(factor, true);
    function bn_dateToHundredNanoSecondFrom1601(date, picoseconds) {
      (0, node_opcua_assert_1.assert)(date instanceof Date);
      if (date.high_low) {
        return date.high_low;
      }
      const t = date.getTime();
      const excess100nanosecond = picoseconds !== void 0 ? Math.floor(picoseconds / 1e5) : 0;
      const tL = long_1.default.fromNumber(t, false);
      const a = tL.add(offsetLong).multiply(factorLong).add(excess100nanosecond);
      date.high_low = [a.getHighBits(), a.getLowBits()];
      date.picoseconds = excess100nanosecond * 1e4 + +picoseconds;
      return date.high_low;
    }
    exports2.bn_dateToHundredNanoSecondFrom1601 = bn_dateToHundredNanoSecondFrom1601;
    function bn_dateToHundredNanoSecondFrom1601Excess(date, picoseconds) {
      return (picoseconds || 0) % 1e5;
    }
    exports2.bn_dateToHundredNanoSecondFrom1601Excess = bn_dateToHundredNanoSecondFrom1601Excess;
    function bn_hundredNanoSecondFrom1601ToDate(high, low, picoseconds = 0, _value = null) {
      (0, node_opcua_assert_1.assert)(low !== void 0);
      const l2 = new long_1.default(
        low,
        high,
        /*unsigned*/
        true
      );
      const value1 = l2.div(factor).toNumber() - offset;
      const date = new Date(value1);
      const excess100nanoInPico = l2.mod(1e4).mul(1e5).toNumber();
      date.high_low = [high, low];
      date.picoseconds = excess100nanoInPico + (picoseconds || 0);
      return date;
    }
    exports2.bn_hundredNanoSecondFrom1601ToDate = bn_hundredNanoSecondFrom1601ToDate;
    var lastNowDate;
    var lastPicoseconds = 0;
    var smallTickPicosecond = 1e3 * 100;
    function getCurrentClockWithJavascriptDate() {
      const now = /* @__PURE__ */ new Date();
      if (lastNowDate && now.getTime() === lastNowDate.getTime()) {
        lastPicoseconds += smallTickPicosecond;
      } else {
        lastPicoseconds = 0;
        lastNowDate = now;
      }
      return {
        timestamp: lastNowDate,
        picoseconds: lastPicoseconds
      };
    }
    exports2.getCurrentClockWithJavascriptDate = getCurrentClockWithJavascriptDate;
    var origin = (0, node_opcua_utils_1.hrtime)();
    var refTime = Date.now();
    exports2.periodicClockAdjustment = {
      adjustmentCount: 0,
      interval: 3e3,
      timerInstallationCount: 0
    };
    var timerId;
    var g_setInterval = typeof global === "object" ? global.setInterval : setInterval;
    var g_clearInterval = typeof global === "object" ? global.clearInterval : clearInterval;
    function installPeriodicClockAdjustment() {
      exports2.periodicClockAdjustment.timerInstallationCount++;
      if (timerId) {
        return;
      }
      timerId = g_setInterval(() => {
        origin = (0, node_opcua_utils_1.hrtime)();
        refTime = Date.now();
        exports2.periodicClockAdjustment.adjustmentCount++;
      }, exports2.periodicClockAdjustment.interval);
    }
    exports2.installPeriodicClockAdjustment = installPeriodicClockAdjustment;
    function uninstallPeriodicClockAdjustment() {
      exports2.periodicClockAdjustment.timerInstallationCount--;
      if (exports2.periodicClockAdjustment.timerInstallationCount <= 0) {
        g_clearInterval(timerId);
        timerId = null;
      }
    }
    exports2.uninstallPeriodicClockAdjustment = uninstallPeriodicClockAdjustment;
    var gClock = {
      tick: [0, 0],
      timestamp: /* @__PURE__ */ new Date(),
      picoseconds: 0
    };
    var original_hrtime = node_opcua_utils_1.hrtime;
    var setTimeout_check = setTimeout;
    function getCurrentClock() {
      if (setTimeout_check !== setTimeout) {
        return getCurrentClockWithJavascriptDate();
      }
      gClock.tick = original_hrtime(origin);
      const milliseconds = gClock.tick[0] * 1e3 + Math.floor(gClock.tick[1] / 1e6) + refTime;
      const picoseconds = gClock.tick[1] % 1e6 * 1e3;
      gClock.timestamp = new Date(milliseconds);
      gClock.picoseconds = picoseconds;
      return gClock;
    }
    exports2.getCurrentClock = getCurrentClock;
    function coerceClock(timestamp, picoseconds = 0) {
      if (timestamp) {
        return { timestamp, picoseconds };
      } else {
        return getCurrentClock();
      }
    }
    exports2.coerceClock = coerceClock;
    exports2.minDate = new Date(Date.UTC(1601, 0, 1, 0, 0, 0));
    exports2.minOPCUADate = exports2.minDate;
    function isMinDate(date) {
      return !date || date.getTime() === exports2.minDate.getTime();
    }
    exports2.isMinDate = isMinDate;
  }
});

// node_modules/node-opcua-date-time/dist/encode_decode.js
var require_encode_decode = __commonJS({
  "node_modules/node-opcua-date-time/dist/encode_decode.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.coerceDateTime = exports2.decodeHighAccuracyDateTime = exports2.decodeDateTime = exports2.encodeDateTime = exports2.encodeHighAccuracyDateTime = exports2.randomDateTime = exports2.isValidDateTime = void 0;
    var date_time_1 = require_date_time();
    function isValidDateTime(value) {
      return value instanceof Date;
    }
    exports2.isValidDateTime = isValidDateTime;
    function getRandomInt(min, max) {
      return Math.floor(Math.random() * (max - min)) + min;
    }
    function randomDateTime() {
      const r = getRandomInt;
      return new Date(1900 + r(0, 200), r(0, 11), r(0, 28), r(0, 24), r(0, 59), r(0, 59), r(0, 1e3));
    }
    exports2.randomDateTime = randomDateTime;
    function encodeHighAccuracyDateTime(date, picoseconds, stream) {
      if (date === null) {
        stream.writeUInt32(0);
        stream.writeUInt32(picoseconds % 1e5);
        return;
      }
      const hl = (0, date_time_1.bn_dateToHundredNanoSecondFrom1601)(date, picoseconds);
      const hi = hl[0];
      const lo = hl[1];
      stream.writeInteger(lo);
      stream.writeInteger(hi);
    }
    exports2.encodeHighAccuracyDateTime = encodeHighAccuracyDateTime;
    function encodeDateTime(date, stream) {
      encodeHighAccuracyDateTime(date, 0, stream);
    }
    exports2.encodeDateTime = encodeDateTime;
    function decodeDateTime(stream, _value) {
      const lo = stream.readInteger();
      const hi = stream.readInteger();
      return (0, date_time_1.bn_hundredNanoSecondFrom1601ToDate)(hi, lo, 0, _value);
    }
    exports2.decodeDateTime = decodeDateTime;
    exports2.decodeHighAccuracyDateTime = decodeDateTime;
    function coerceDateTime(value) {
      if (!value) {
        return date_time_1.minOPCUADate;
      }
      if (value instanceof Date) {
        return value;
      }
      return new Date(value);
    }
    exports2.coerceDateTime = coerceDateTime;
  }
});

// node_modules/node-opcua-date-time/dist/index.js
var require_dist17 = __commonJS({
  "node_modules/node-opcua-date-time/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_date_time(), exports2);
    __exportStar3(require_encode_decode(), exports2);
  }
});

// node_modules/node-opcua-basic-types/dist/date_time.js
var require_date_time2 = __commonJS({
  "node_modules/node-opcua-basic-types/dist/date_time.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_dist17(), exports2);
  }
});

// node_modules/node-opcua-basic-types/dist/floats.js
var require_floats = __commonJS({
  "node_modules/node-opcua-basic-types/dist/floats.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.coerceDouble = exports2.coerceFloat = exports2.decodeDouble = exports2.encodeDouble = exports2.randomDouble = exports2.isValidDouble = exports2.decodeFloat = exports2.encodeFloat = exports2.randomFloat = exports2.isValidFloat = void 0;
    var minFloat = -3.4 * Math.pow(10, 38);
    var maxFloat = 3.4 * Math.pow(10, 38);
    function getRandomDouble(min, max) {
      return Math.random() * (max - min) + min;
    }
    function isValidFloat(value) {
      if (!isFinite(value)) {
        return false;
      }
      return value > minFloat && value < maxFloat;
    }
    exports2.isValidFloat = isValidFloat;
    var r = new Float32Array(1);
    function roundToFloat(float) {
      r[0] = float;
      const floatR = r[0];
      return floatR;
    }
    function randomFloat() {
      return roundToFloat(getRandomDouble(-1e3, 1e3));
    }
    exports2.randomFloat = randomFloat;
    function encodeFloat(value, stream) {
      stream.writeFloat(value);
    }
    exports2.encodeFloat = encodeFloat;
    function decodeFloat(stream, value) {
      return stream.readFloat();
    }
    exports2.decodeFloat = decodeFloat;
    function isValidDouble(value) {
      if (!isFinite(value)) {
        return false;
      }
      return true;
    }
    exports2.isValidDouble = isValidDouble;
    function randomDouble() {
      return getRandomDouble(-1e6, 1e6);
    }
    exports2.randomDouble = randomDouble;
    function encodeDouble(value, stream) {
      stream.writeDouble(value);
    }
    exports2.encodeDouble = encodeDouble;
    function decodeDouble(stream, value) {
      return stream.readDouble();
    }
    exports2.decodeDouble = decodeDouble;
    function coerceFloat(value) {
      if (value === null || value === void 0) {
        return 0;
      }
      if (typeof value === "number") {
        return value;
      }
      return parseFloat(value);
    }
    exports2.coerceFloat = coerceFloat;
    function coerceDouble(value) {
      if (value === null || value === void 0) {
        return 0;
      }
      if (typeof value === "number") {
        return value;
      }
      return parseFloat(value);
    }
    exports2.coerceDouble = coerceDouble;
  }
});

// node_modules/node-opcua-binary-stream/dist/binaryStream.js
var require_binaryStream = __commonJS({
  "node_modules/node-opcua-binary-stream/dist/binaryStream.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.calculateByteLength = exports2.BinaryStream = void 0;
    require("util");
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_buffer_utils_1 = require_dist15();
    var MAXUINT32 = 4294967295;
    var performCheck = false;
    var BinaryStream = class _BinaryStream {
      constructor(data) {
        if (data === void 0) {
          this.buffer = (0, node_opcua_buffer_utils_1.createFastUninitializedBuffer)(1024);
        } else if (typeof data === "number") {
          this.buffer = (0, node_opcua_buffer_utils_1.createFastUninitializedBuffer)(data);
        } else {
          (0, node_opcua_assert_1.assert)(data instanceof Buffer);
          this.buffer = data;
        }
        this.length = 0;
      }
      /**
       * set the cursor to the begining of the stream
       * @method BinaryStream.rewind
       */
      rewind() {
        this.length = 0;
      }
      /**
       * write a single signed byte (8 bits) to the stream.
       * value must be in the range of [-127,128]
       * @param value the value to write
       */
      writeInt8(value) {
        if (performCheck) {
          (0, node_opcua_assert_1.assert)(this.buffer.length >= this.length + 1, "not enough space in buffer");
          (0, node_opcua_assert_1.assert)(value >= -128 && value < 128);
        }
        this.buffer.writeInt8(value, this.length);
        this.length += 1;
      }
      /**
       * write a single unsigned byte (8 bits) to the stream.
       * @param value  the value to write
       */
      writeUInt8(value) {
        if (performCheck) {
          (0, node_opcua_assert_1.assert)(this.buffer.length >= this.length + 1, "not enough space in buffer");
          (0, node_opcua_assert_1.assert)(value >= 0 && value < 256, " writeUInt8 : out of bound ");
        }
        this.buffer.writeUInt8(value, this.length);
        this.length += 1;
      }
      /**
       * write a single 16 bit signed integer to the stream.
       * @param  value  the value to write
       */
      writeInt16(value) {
        if (performCheck) {
          (0, node_opcua_assert_1.assert)(this.buffer.length >= this.length + 2, "not enough space in buffer");
        }
        this.buffer.writeInt16LE(value, this.length);
        this.length += 2;
      }
      /**
       * write a single 16 bit unsigned integer to the stream.
       * @param  value  the value to write
       */
      writeUInt16(value) {
        if (performCheck) {
          (0, node_opcua_assert_1.assert)(this.buffer.length >= this.length + 2, "not enough space in buffer");
        }
        this.buffer.writeUInt16LE(value, this.length);
        this.length += 2;
      }
      /**
       * write a single 32 bit signed integer to the stream.
       * @param  value  the value to write
       */
      writeInteger(value) {
        if (performCheck) {
          (0, node_opcua_assert_1.assert)(this.buffer.length >= this.length + 4, "not enough space in buffer");
        }
        this.buffer.writeInt32LE(value, this.length);
        this.length += 4;
      }
      /**
       * write a single 32 bit unsigned integer to the stream.
       *
       * @param  value the value to write
       */
      writeUInt32(value) {
        if (performCheck) {
          (0, node_opcua_assert_1.assert)(this.buffer.length >= this.length + 4, "not enough space in buffer");
          (0, node_opcua_assert_1.assert)(isFinite(value));
          (0, node_opcua_assert_1.assert)(value >= 0 && value <= MAXUINT32);
        }
        this.buffer.writeUInt32LE(value, this.length);
        this.length += 4;
      }
      /**
       * write a single 32 bit floating number to the stream.
       * @param  value  the value to write
       */
      writeFloat(value) {
        if (performCheck) {
          (0, node_opcua_assert_1.assert)(this.buffer.length >= this.length + 4, "not enough space in buffer");
        }
        this.buffer.writeFloatLE(value, this.length);
        this.length += 4;
      }
      /**
       * write a single 64 bit floating number to the stream.
       * @param  value  the value to write
       */
      writeDouble(value) {
        if (performCheck) {
          (0, node_opcua_assert_1.assert)(this.buffer.length >= this.length + 8, "not enough space in buffer");
        }
        this.buffer.writeDoubleLE(value, this.length);
        this.length += 8;
      }
      /**
       * @param arrayBuf a buffer or byte array write
       * @param offset   the offset position (default =0)
       * @param length   the number of byte to write
       */
      writeArrayBuffer(arrayBuf, offset = 0, length = 0) {
        if (performCheck) {
          (0, node_opcua_assert_1.assert)(arrayBuf instanceof ArrayBuffer);
        }
        const byteArr = new Uint8Array(arrayBuf);
        const n = (length || byteArr.length) + offset;
        for (let i = offset; i < n; i++) {
          this.buffer[this.length++] = byteArr[i];
        }
      }
      // writeArrayBuffer(arrayBuf, offset, length) {
      //     offset = offset || 0;
      //
      //     assert(arrayBuf instanceof ArrayBuffer);
      //     const byteArr = new Uint8Array(arrayBuf);
      //     length = length || byteArr.length;
      //     if (length === 0) {
      //         return;
      //     }
      //     this.length += my_memcpy(this.buffer, this.length, byteArr, offset, offset + length);
      // }
      /**
       * read a single signed byte  (8 bits) from the stream.
       * @return the value read
       */
      readByte() {
        const retVal = this.buffer.readInt8(this.length);
        this.length += 1;
        return retVal;
      }
      readInt8() {
        return this.readByte();
      }
      /**
       * read a single unsigned byte (8 bits) from the stream.
       */
      readUInt8() {
        if (performCheck) {
          (0, node_opcua_assert_1.assert)(this.buffer.length >= this.length + 1);
        }
        const retVal = this.buffer.readUInt8(this.length);
        this.length += 1;
        return retVal;
      }
      /**
       * read a single signed 16-bit integer from the stream.
       */
      readInt16() {
        const retVal = this.buffer.readInt16LE(this.length);
        this.length += 2;
        return retVal;
      }
      /**
       * read a single unsigned 16-bit integer from the stream.
       */
      readUInt16() {
        const retVal = this.buffer.readUInt16LE(this.length);
        this.length += 2;
        return retVal;
      }
      /**
       * read a single signed 32-bit integer from the stream.
       */
      readInteger() {
        const retVal = this.buffer.readInt32LE(this.length);
        this.length += 4;
        return retVal;
      }
      /**
       * read a single unsigned 32-bit integer from the stream.
       */
      readUInt32() {
        const retVal = this.buffer.readUInt32LE(this.length);
        this.length += 4;
        return retVal;
      }
      /**
       * read a single  32-bit floating point number from the stream.
       */
      readFloat() {
        const retVal = this.buffer.readFloatLE(this.length);
        this.length += 4;
        return retVal;
      }
      /**
       * read a single 64-bit floating point number from the stream.
       */
      readDouble() {
        const retVal = this.buffer.readDoubleLE(this.length);
        this.length += 8;
        return retVal;
      }
      /**
       * write a byte stream to the stream.
       * The method writes the length of the byte array into the stream as a 32 bits integer before the byte stream.
       *
       * @param buf the buffer to write.
       */
      writeByteStream(buf) {
        if (!buf) {
          this.writeInteger(-1);
          return;
        }
        (0, node_opcua_assert_1.assert)(buf instanceof Buffer);
        this.writeInteger(buf.length);
        const remainingBytes = this.buffer.length - this.length;
        if (remainingBytes < buf.length) {
          throw new Error("BinaryStream.writeByteStream error : not enough bytes left in buffer :  bufferLength is " + buf.length + " but only " + remainingBytes + " left");
        }
        buf.copy(this.buffer, this.length, 0, buf.length);
        this.length += buf.length;
      }
      writeString(value) {
        if (value === void 0 || value === null) {
          this.writeUInt32(4294967295);
          return;
        }
        const byteLength = calculateByteLength(value);
        this.writeInteger(byteLength);
        if (byteLength === 0) {
          return;
        }
        const remainingBytes = this.buffer.length - this.length;
        if (remainingBytes < byteLength) {
          throw new Error("BinaryStream.writeByteStream error : not enough bytes left in buffer :  bufferLength is " + byteLength + " but only " + remainingBytes + " left");
        }
        this.buffer.write(value, this.length);
        this.length += byteLength;
      }
      // readArrayBuffer(length: number): ArrayBuffer {
      //     assert(this.length + length <= this.buffer.length, "not enough bytes in buffer");
      //     const byteArr = new Uint8Array(new ArrayBuffer(length));
      //     my_memcpy(byteArr, 0, this.buffer, this.length, this.length + length);
      //     this.length += length;
      //     return byteArr;
      // }
      /**
       * @method readArrayBuffer
       * @param length
       */
      readArrayBuffer(length) {
        if (length > _BinaryStream.maxByteStringLength) {
          throw new Error(`maxStringLength(${_BinaryStream.maxByteStringLength}) has been exceeded in BinaryStream.readArrayBuffer len=${length}`);
        }
        if (performCheck) {
          (0, node_opcua_assert_1.assert)(this.length + length <= this.buffer.length, "not enough bytes in buffer");
        }
        const slice = this.buffer.subarray(this.length, this.length + length);
        if (performCheck) {
          (0, node_opcua_assert_1.assert)(slice.length === length);
        }
        const byteArr = new Uint8Array(slice);
        if (performCheck) {
          (0, node_opcua_assert_1.assert)(byteArr.length === length);
        }
        this.length += length;
        return byteArr;
      }
      /**
       * read a byte stream to the stream.
       * The method reads the length of the byte array from the stream as a 32 bits integer
       * before reading the byte stream.
       *
       */
      readByteStream() {
        const bufLen = this.readUInt32();
        if (bufLen === 4294967295) {
          return null;
        }
        if (bufLen === 0) {
          return zeroLengthBuffer;
        }
        if (bufLen > _BinaryStream.maxByteStringLength) {
          throw new Error(`maxStringLength(${_BinaryStream.maxByteStringLength}) has been exceeded in BinaryStream.readArrayBuffer len=${bufLen}`);
        }
        const remainingBytes = this.buffer.length - this.length;
        if (remainingBytes < bufLen) {
          throw new Error("BinaryStream.readByteStream error : not enough bytes left in buffer :  bufferLength is " + bufLen + " but only " + remainingBytes + " left");
        }
        const buf = this.buffer.subarray(this.length, this.length + bufLen);
        this.length += bufLen;
        return buf;
      }
      readString() {
        const bufLen = this.readUInt32();
        if (bufLen === 4294967295) {
          return null;
        }
        if (bufLen === 0) {
          return "";
        }
        if (bufLen > _BinaryStream.maxStringLength) {
          throw new Error(`maxStringLength(${_BinaryStream.maxStringLength}) has been exceeded in BinaryStream.readString len=${bufLen}`);
        }
        const remainingBytes = this.buffer.length - this.length;
        if (remainingBytes < bufLen) {
          throw new Error("BinaryStream.readByteStream error : not enough bytes left in buffer :  bufferLength is " + bufLen + " but only " + remainingBytes + " left");
        }
        const str = this.buffer.toString("utf-8", this.length, this.length + bufLen);
        this.length += bufLen;
        return str;
      }
    };
    exports2.BinaryStream = BinaryStream;
    BinaryStream.maxByteStringLength = 16 * 1024 * 1024;
    BinaryStream.maxStringLength = 16 * 1024 * 1024;
    function calculateByteLength(str) {
      let s = str.length;
      for (let i = s - 1; i >= 0; i--) {
        const code = str.charCodeAt(i);
        if (code > 127 && code <= 2047) {
          s++;
        } else if (code > 2047 && code <= 65535) {
          s += 2;
        }
        if (code >= 56320 && code <= 57343) {
          i--;
        }
      }
      return s;
    }
    exports2.calculateByteLength = calculateByteLength;
    var zeroLengthBuffer = (0, node_opcua_buffer_utils_1.createFastUninitializedBuffer)(0);
  }
});

// node_modules/node-opcua-binary-stream/dist/binaryStreamSizeCalculator.js
var require_binaryStreamSizeCalculator = __commonJS({
  "node_modules/node-opcua-binary-stream/dist/binaryStreamSizeCalculator.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.BinaryStreamSizeCalculator = void 0;
    var node_opcua_assert_1 = require_dist14();
    var binaryStream_1 = require_binaryStream();
    var BinaryStreamSizeCalculator = class {
      constructor() {
        this.length = 0;
      }
      rewind() {
        this.length = 0;
      }
      writeInt8(value) {
        this.length += 1;
      }
      writeUInt8(value) {
        this.length += 1;
      }
      writeInt16(value) {
        this.length += 2;
      }
      writeInteger(value) {
        this.length += 4;
      }
      writeUInt32(value) {
        this.length += 4;
      }
      writeUInt16(value) {
        this.length += 2;
      }
      writeFloat(value) {
        this.length += 4;
      }
      writeDouble(value) {
        this.length += 8;
      }
      writeArrayBuffer(arrayBuf, offset, byteLength) {
        offset = offset || 0;
        (0, node_opcua_assert_1.assert)(arrayBuf instanceof ArrayBuffer);
        this.length += byteLength || arrayBuf.byteLength;
      }
      writeByteStream(buf) {
        if (!buf) {
          this.writeUInt32(0);
        } else {
          this.writeUInt32(buf.length);
          this.length += buf.length;
        }
      }
      writeString(str) {
        if (str === void 0 || str === null) {
          this.writeUInt32(-1);
          return;
        }
        const bufLength = (0, binaryStream_1.calculateByteLength)(str);
        this.writeUInt32(bufLength);
        this.length += bufLength;
      }
    };
    exports2.BinaryStreamSizeCalculator = BinaryStreamSizeCalculator;
  }
});

// node_modules/node-opcua-binary-stream/dist/index.js
var require_dist18 = __commonJS({
  "node_modules/node-opcua-binary-stream/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_binaryStream(), exports2);
    __exportStar3(require_binaryStreamSizeCalculator(), exports2);
  }
});

// node_modules/node-opcua-guid/dist/guid.js
var require_guid = __commonJS({
  "node_modules/node-opcua-guid/dist/guid.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.normalizeGuid = exports2.emptyGuid = exports2.isValidGuid = void 0;
    var regexGUID = /^[0-9A-Fa-f]{8}-[0-9A-Fa-f]{4}-[0-9A-Fa-f]{4}-[0-9A-Fa-f]{4}-[0-9A-Fa-f]{12}/;
    function isValidGuid(guid) {
      return regexGUID.test(guid);
    }
    exports2.isValidGuid = isValidGuid;
    exports2.emptyGuid = "00000000-0000-0000-0000-000000000000";
    function normalizeGuid(guid) {
      return guid ? guid.toUpperCase() : exports2.emptyGuid;
    }
    exports2.normalizeGuid = normalizeGuid;
  }
});

// node_modules/node-opcua-guid/dist/index.js
var require_dist19 = __commonJS({
  "node_modules/node-opcua-guid/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_guid(), exports2);
  }
});

// node_modules/node-opcua-basic-types/dist/guid.js
var require_guid2 = __commonJS({
  "node_modules/node-opcua-basic-types/dist/guid.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.decodeGuid = exports2.encodeGuid = exports2.randomGuid = exports2.emptyGuid = exports2.isValidGuid = void 0;
    var node_opcua_assert_1 = __importDefault3(require_dist14());
    var node_opcua_binary_stream_1 = require_dist18();
    var node_opcua_guid_1 = require_dist19();
    var utils_1 = require_utils3();
    var node_opcua_guid_2 = require_dist19();
    Object.defineProperty(exports2, "isValidGuid", { enumerable: true, get: function() {
      return node_opcua_guid_2.isValidGuid;
    } });
    Object.defineProperty(exports2, "emptyGuid", { enumerable: true, get: function() {
      return node_opcua_guid_2.emptyGuid;
    } });
    function toHex(i, nb) {
      return i.toString(16).padStart(nb, "0");
    }
    function randomGuid() {
      const b = new node_opcua_binary_stream_1.BinaryStream(20);
      for (let i = 0; i < 20; i++) {
        b.writeUInt8((0, utils_1.getRandomInt)(0, 255));
      }
      b.rewind();
      const value = decodeGuid(b);
      return value;
    }
    exports2.randomGuid = randomGuid;
    var hexCharToNum = (h) => {
      const l2 = h & 95;
      const r = l2 <= 25 ? l2 - 16 : l2 - 55;
      return r;
    };
    (0, node_opcua_assert_1.default)(hexCharToNum("A".charCodeAt(0)) === 10);
    (0, node_opcua_assert_1.default)(hexCharToNum("a".charCodeAt(0)) === 10);
    (0, node_opcua_assert_1.default)(hexCharToNum("b".charCodeAt(0)) === 11);
    (0, node_opcua_assert_1.default)(hexCharToNum("B".charCodeAt(0)) === 11);
    (0, node_opcua_assert_1.default)(hexCharToNum("0".charCodeAt(0)) === 0);
    (0, node_opcua_assert_1.default)(hexCharToNum("9".charCodeAt(0)) === 9);
    function write_UInt32(stream, guid, starts) {
      const n = starts.length;
      for (let i = 0; i < n; i++) {
        const start = starts[i];
        const d1 = hexCharToNum(guid.charCodeAt(start));
        const d2 = hexCharToNum(guid.charCodeAt(start + 1));
        const d3 = hexCharToNum(guid.charCodeAt(start + 2));
        const d4 = hexCharToNum(guid.charCodeAt(start + 3));
        const d5 = hexCharToNum(guid.charCodeAt(start + 4));
        const d6 = hexCharToNum(guid.charCodeAt(start + 5));
        const d7 = hexCharToNum(guid.charCodeAt(start + 6));
        const d8 = hexCharToNum(guid.charCodeAt(start + 7));
        const value = ((((((d1 << 4 | d2) << 4 | d3) << 4 | d4) << 4 | d5) << 4 | d6) << 4 | d7) << 4 | d8;
        stream.writeInteger(value);
      }
    }
    function write_UInt16(stream, guid, starts) {
      const n = starts.length;
      for (let i = 0; i < n; i++) {
        const start = starts[i];
        const d1 = hexCharToNum(guid.charCodeAt(start));
        const d2 = hexCharToNum(guid.charCodeAt(start + 1));
        const d3 = hexCharToNum(guid.charCodeAt(start + 2));
        const d4 = hexCharToNum(guid.charCodeAt(start + 3));
        const value = ((d1 << 4 | d2) << 4 | d3) << 4 | d4;
        stream.writeUInt16(value);
      }
    }
    function write_UInt8(stream, guid, starts) {
      const n = starts.length;
      for (let i = 0; i < n; i++) {
        const start = starts[i];
        const d1 = hexCharToNum(guid.charCodeAt(start));
        const d2 = hexCharToNum(guid.charCodeAt(start + 1));
        const value = d1 << 4 | d2;
        stream.writeUInt8(value);
      }
    }
    function encodeGuid(guid, stream) {
      if (!(0, node_opcua_guid_1.isValidGuid)(guid)) {
        throw new Error(" Invalid GUID : '" + JSON.stringify(guid) + ": the format should be 'XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX'");
      }
      write_UInt32(stream, guid, [0]);
      write_UInt16(stream, guid, [9, 14]);
      write_UInt8(stream, guid, [19, 21, 24, 26, 28, 30, 32, 34]);
    }
    exports2.encodeGuid = encodeGuid;
    function read_UInt32(stream) {
      return toHex(stream.readUInt32(), 8);
    }
    function read_UInt16(stream) {
      return toHex(stream.readUInt16(), 4);
    }
    function read_UInt8(stream) {
      return toHex(stream.readUInt8(), 2);
    }
    function read_many(stream, func, nb) {
      let result2 = "";
      for (let i = 0; i < nb; i++) {
        result2 += func(stream);
      }
      return result2;
    }
    function decodeGuid(stream, value) {
      const data1 = read_UInt32(stream);
      const data2 = read_UInt16(stream);
      const data3 = read_UInt16(stream);
      const data45 = read_many(stream, read_UInt8, 2);
      const data6B = read_many(stream, read_UInt8, 6);
      const guid = data1 + "-" + data2 + "-" + data3 + "-" + data45 + "-" + data6B;
      return guid.toUpperCase();
    }
    exports2.decodeGuid = decodeGuid;
  }
});

// node_modules/node-opcua-basic-types/dist/integers.js
var require_integers = __commonJS({
  "node_modules/node-opcua-basic-types/dist/integers.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.coerceUInt32 = exports2.coerceInt16 = exports2.coerceUInt16 = exports2.coerceSByte = exports2.coerceByte = exports2.coerceUInt8 = exports2.coerceInt8 = exports2.decodeInt64 = exports2.encodeInt64 = exports2.isValidInt64 = exports2.coerceInt64 = exports2.randomInt64 = exports2.coerceUInt64 = exports2.constructInt64 = exports2.decodeUInt64 = exports2.encodeUInt64 = exports2.randomUInt64 = exports2.isValidUInt64 = exports2.decodeByte = exports2.encodeByte = exports2.randomByte = exports2.isValidByte = exports2.decodeUInt8 = exports2.encodeUInt8 = exports2.randomUInt8 = exports2.isValidUInt8 = exports2.decodeSByte = exports2.encodeSByte = exports2.randomSByte = exports2.isValidSByte = exports2.decodeInt8 = exports2.encodeInt8 = exports2.randomInt8 = exports2.isValidInt8 = exports2.decodeUInt32 = exports2.encodeUInt32 = exports2.randomUInt32 = exports2.isValidUInt32 = exports2.decodeInt32 = exports2.encodeInt32 = exports2.randomInt32 = exports2.isValidInt32 = exports2.decodeInt16 = exports2.encodeInt16 = exports2.randomInt16 = exports2.isValidInt16 = exports2.decodeUInt16 = exports2.encodeUInt16 = exports2.randomUInt16 = exports2.isValidUInt16 = void 0;
    exports2.coerceUInt64toInt32 = exports2.coerceInt64toInt32 = exports2.UInt64ToBigInt = exports2.Int64ToBigInt = exports2.coerceInt32 = void 0;
    var node_opcua_assert_1 = require_dist14();
    var utils_1 = require_utils3();
    function isValidUInt16(value) {
      if (!isFinite(value)) {
        return false;
      }
      return value >= 0 && value <= 65535;
    }
    exports2.isValidUInt16 = isValidUInt16;
    function randomUInt16() {
      return (0, utils_1.getRandomInt)(0, 65535);
    }
    exports2.randomUInt16 = randomUInt16;
    function encodeUInt16(value, stream) {
      stream.writeUInt16(value);
    }
    exports2.encodeUInt16 = encodeUInt16;
    function decodeUInt16(stream, value) {
      return stream.readUInt16();
    }
    exports2.decodeUInt16 = decodeUInt16;
    function isValidInt16(value) {
      if (!isFinite(value)) {
        return false;
      }
      return value >= -32768 && value <= 32767;
    }
    exports2.isValidInt16 = isValidInt16;
    function randomInt16() {
      return (0, utils_1.getRandomInt)(-32768, 32767);
    }
    exports2.randomInt16 = randomInt16;
    function encodeInt16(value, stream) {
      (0, node_opcua_assert_1.assert)(isFinite(value));
      stream.writeInt16(value);
    }
    exports2.encodeInt16 = encodeInt16;
    function decodeInt16(stream, value) {
      return stream.readInt16();
    }
    exports2.decodeInt16 = decodeInt16;
    function isValidInt32(value) {
      if (!isFinite(value)) {
        return false;
      }
      return value >= -2147483648 && value <= 2147483647;
    }
    exports2.isValidInt32 = isValidInt32;
    function randomInt32() {
      return (0, utils_1.getRandomInt)(-2147483648, 2147483647);
    }
    exports2.randomInt32 = randomInt32;
    function encodeInt32(value, stream) {
      (0, node_opcua_assert_1.assert)(isFinite(value));
      stream.writeInteger(value);
    }
    exports2.encodeInt32 = encodeInt32;
    function decodeInt32(stream, value) {
      return stream.readInteger();
    }
    exports2.decodeInt32 = decodeInt32;
    function isValidUInt32(value) {
      if (!isFinite(value)) {
        return false;
      }
      return value >= 0 && value <= 4294967295;
    }
    exports2.isValidUInt32 = isValidUInt32;
    function randomUInt32() {
      return (0, utils_1.getRandomInt)(0, 4294967295);
    }
    exports2.randomUInt32 = randomUInt32;
    function encodeUInt32(value, stream) {
      stream.writeUInt32(value);
    }
    exports2.encodeUInt32 = encodeUInt32;
    function decodeUInt32(stream, value) {
      return stream.readUInt32();
    }
    exports2.decodeUInt32 = decodeUInt32;
    function isValidInt8(value) {
      if (!isFinite(value)) {
        return false;
      }
      return value >= -128 && value <= 127;
    }
    exports2.isValidInt8 = isValidInt8;
    function randomInt8() {
      return (0, utils_1.getRandomInt)(-127, 126);
    }
    exports2.randomInt8 = randomInt8;
    function encodeInt8(value, stream) {
      (0, node_opcua_assert_1.assert)(isValidInt8(value));
      stream.writeInt8(value);
    }
    exports2.encodeInt8 = encodeInt8;
    function decodeInt8(stream, value) {
      return stream.readInt8();
    }
    exports2.decodeInt8 = decodeInt8;
    exports2.isValidSByte = isValidInt8;
    exports2.randomSByte = randomInt8;
    exports2.encodeSByte = encodeInt8;
    exports2.decodeSByte = decodeInt8;
    function isValidUInt8(value) {
      if (!isFinite(value)) {
        return false;
      }
      return value >= 0 && value <= 255;
    }
    exports2.isValidUInt8 = isValidUInt8;
    function randomUInt8() {
      return (0, utils_1.getRandomInt)(0, 255);
    }
    exports2.randomUInt8 = randomUInt8;
    function encodeUInt8(value, stream) {
      stream.writeUInt8(value);
    }
    exports2.encodeUInt8 = encodeUInt8;
    function decodeUInt8(stream, value) {
      return stream.readUInt8();
    }
    exports2.decodeUInt8 = decodeUInt8;
    exports2.isValidByte = isValidUInt8;
    exports2.randomByte = randomUInt8;
    exports2.encodeByte = encodeUInt8;
    exports2.decodeByte = decodeUInt8;
    function isValidUInt64(value) {
      return value instanceof Array && value.length === 2;
    }
    exports2.isValidUInt64 = isValidUInt64;
    function randomUInt64() {
      return [(0, utils_1.getRandomInt)(0, 4294967295), (0, utils_1.getRandomInt)(0, 4294967295)];
    }
    exports2.randomUInt64 = randomUInt64;
    function encodeUInt64(value, stream) {
      if (typeof value === "number") {
        const arr = coerceUInt64(value);
        stream.writeUInt32(arr[1]);
        stream.writeUInt32(arr[0]);
      } else {
        stream.writeUInt32(value[1]);
        stream.writeUInt32(value[0]);
      }
    }
    exports2.encodeUInt64 = encodeUInt64;
    function decodeUInt64(stream, value) {
      const low = stream.readUInt32();
      const high = stream.readUInt32();
      return constructInt64(high, low);
    }
    exports2.decodeUInt64 = decodeUInt64;
    function constructInt64(high, low) {
      if (high === 0 && low < 0) {
        high = 4294967295;
        low = 4294967295 + low + 1;
      }
      (0, node_opcua_assert_1.assert)(low >= 0 && low <= 4294967295);
      (0, node_opcua_assert_1.assert)(high >= 0 && high <= 4294967295);
      return [high, low];
    }
    exports2.constructInt64 = constructInt64;
    function coerceUInt64(value) {
      let high;
      let low;
      let v;
      if (value === null || value === void 0) {
        return [0, 0];
      }
      if (value instanceof Array) {
        (0, node_opcua_assert_1.assert)(typeof value[0] === "number");
        (0, node_opcua_assert_1.assert)(typeof value[1] === "number");
        return value;
      }
      if (typeof value === "string") {
        v = value.split(",");
        if (v.length === 1) {
          let a = BigInt(value);
          if (a < BigInt(0)) {
            const mask = BigInt("0xFFFFFFFFFFFFFFFF");
            a = mask + a + BigInt(1) & mask;
          }
          high = Number(a >> BigInt(32));
          low = Number(a & BigInt(4294967295));
        } else {
          high = parseInt(v[0], 10);
          low = parseInt(v[1], 10);
        }
        return constructInt64(high, low);
      }
      if (value > 4294967295) {
        high = Math.floor(value / 4294967296);
        low = value - high * 4294967296;
        return constructInt64(high, low);
      }
      return constructInt64(0, value);
    }
    exports2.coerceUInt64 = coerceUInt64;
    function randomInt64() {
      return [(0, utils_1.getRandomInt)(0, 4294967295), (0, utils_1.getRandomInt)(0, 4294967295)];
    }
    exports2.randomInt64 = randomInt64;
    exports2.coerceInt64 = coerceUInt64;
    exports2.isValidInt64 = isValidUInt64;
    exports2.encodeInt64 = encodeUInt64;
    exports2.decodeInt64 = decodeUInt64;
    function coerceInt8(value) {
      if (value === null || value === void 0) {
        return 0;
      }
      if (typeof value === "number") {
        return value;
      }
      return parseInt(value, 10);
    }
    exports2.coerceInt8 = coerceInt8;
    function coerceUInt8(value) {
      if (value === null || value === void 0) {
        return 0;
      }
      if (typeof value === "number") {
        return value;
      }
      return parseInt(value, 10);
    }
    exports2.coerceUInt8 = coerceUInt8;
    function coerceByte(value) {
      if (value === null || value === void 0) {
        return 0;
      }
      if (typeof value === "number") {
        return value;
      }
      return parseInt(value, 10);
    }
    exports2.coerceByte = coerceByte;
    function coerceSByte(value) {
      if (value === null || value === void 0) {
        return 0;
      }
      if (typeof value === "number") {
        return value;
      }
      return parseInt(value, 10);
    }
    exports2.coerceSByte = coerceSByte;
    function coerceUInt16(value) {
      if (value === null || value === void 0) {
        return 0;
      }
      if (typeof value === "number") {
        return value;
      }
      return parseInt(value, 10);
    }
    exports2.coerceUInt16 = coerceUInt16;
    function coerceInt16(value) {
      if (value === null || value === void 0) {
        return 0;
      }
      if (typeof value === "number") {
        return value;
      }
      return parseInt(value, 10);
    }
    exports2.coerceInt16 = coerceInt16;
    function coerceUInt32(value) {
      if (value === null || value === void 0) {
        return 0;
      }
      if (value && Object.prototype.hasOwnProperty.call(value, "value")) {
        return coerceUInt32(value.value);
      }
      if (typeof value === "number") {
        return value;
      }
      return parseInt(value, 10);
    }
    exports2.coerceUInt32 = coerceUInt32;
    function coerceInt32(value) {
      if (value === null || value === void 0) {
        return 0;
      }
      if (value instanceof Array) {
        return coerceInt64toInt32(value);
      }
      if (typeof value === "number") {
        return value;
      }
      return parseInt(value, 10);
    }
    exports2.coerceInt32 = coerceInt32;
    var signMask = 1n << 31n;
    var shiftHigh = 1n << 32n;
    function Int64ToBigInt(value) {
      const h = BigInt(value[0]);
      const l2 = BigInt(value[1]);
      if ((h & signMask) === signMask) {
        const v = (h & ~signMask) * shiftHigh + l2 - 0x8000000000000000n;
        return v;
      } else {
        const v = h * shiftHigh + l2;
        return v;
      }
    }
    exports2.Int64ToBigInt = Int64ToBigInt;
    function UInt64ToBigInt(value) {
      const h = BigInt(value[0]);
      const l2 = BigInt(value[1]);
      const v = h * shiftHigh + l2;
      return v;
    }
    exports2.UInt64ToBigInt = UInt64ToBigInt;
    function coerceInt64toInt32(value) {
      if (value instanceof Array) {
        const b = Int64ToBigInt(value);
        return Number(b);
      }
      return value;
    }
    exports2.coerceInt64toInt32 = coerceInt64toInt32;
    function coerceUInt64toInt32(value) {
      if (value instanceof Array) {
        const b = UInt64ToBigInt(value);
        return Number(b);
      }
      return value;
    }
    exports2.coerceUInt64toInt32 = coerceUInt64toInt32;
  }
});

// node_modules/node-opcua-basic-types/dist/string.js
var require_string = __commonJS({
  "node_modules/node-opcua-basic-types/dist/string.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.encodeUAString = exports2.decodeUAString = exports2.encodeString = exports2.decodeString = exports2.randomString = exports2.isValidString = void 0;
    var utils_1 = require_utils3();
    function isValidString(value) {
      return typeof value === "string";
    }
    exports2.isValidString = isValidString;
    function randomString() {
      const nbCar = (0, utils_1.getRandomInt)(1, 20);
      const cars = [];
      for (let i = 0; i < nbCar; i++) {
        cars.push(String.fromCharCode(65 + (0, utils_1.getRandomInt)(0, 26)));
      }
      return cars.join("");
    }
    exports2.randomString = randomString;
    function decodeString(stream, value) {
      return stream.readString();
    }
    exports2.decodeString = decodeString;
    function encodeString(value, stream) {
      stream.writeString(value);
    }
    exports2.encodeString = encodeString;
    exports2.decodeUAString = decodeString;
    exports2.encodeUAString = encodeString;
  }
});

// node_modules/node-opcua-basic-types/dist/locale_id.js
var require_locale_id = __commonJS({
  "node_modules/node-opcua-basic-types/dist/locale_id.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.decodeLocaleId = exports2.encodeLocaleId = exports2.validateLocaleId = void 0;
    var string_1 = require_string();
    function validateLocaleId(value) {
      return true;
    }
    exports2.validateLocaleId = validateLocaleId;
    function encodeLocaleId(localeId, stream) {
      return (0, string_1.encodeUAString)(localeId, stream);
    }
    exports2.encodeLocaleId = encodeLocaleId;
    function decodeLocaleId(stream) {
      return (0, string_1.decodeUAString)(stream);
    }
    exports2.decodeLocaleId = decodeLocaleId;
  }
});

// node_modules/node-opcua-constants/dist/opcua_node_ids.js
var require_opcua_node_ids = __commonJS({
  "node_modules/node-opcua-constants/dist/opcua_node_ids.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.MethodIds = exports2.VariableIds = exports2.ObjectIds = exports2.VariableTypeIds = exports2.ObjectTypeIds = exports2.ReferenceTypeIds = exports2.DataTypeIds = void 0;
    var DataTypeIds;
    (function(DataTypeIds2) {
      DataTypeIds2[DataTypeIds2["Boolean"] = 1] = "Boolean";
      DataTypeIds2[DataTypeIds2["SByte"] = 2] = "SByte";
      DataTypeIds2[DataTypeIds2["Byte"] = 3] = "Byte";
      DataTypeIds2[DataTypeIds2["Int16"] = 4] = "Int16";
      DataTypeIds2[DataTypeIds2["UInt16"] = 5] = "UInt16";
      DataTypeIds2[DataTypeIds2["Int32"] = 6] = "Int32";
      DataTypeIds2[DataTypeIds2["UInt32"] = 7] = "UInt32";
      DataTypeIds2[DataTypeIds2["Int64"] = 8] = "Int64";
      DataTypeIds2[DataTypeIds2["UInt64"] = 9] = "UInt64";
      DataTypeIds2[DataTypeIds2["Float"] = 10] = "Float";
      DataTypeIds2[DataTypeIds2["Double"] = 11] = "Double";
      DataTypeIds2[DataTypeIds2["String"] = 12] = "String";
      DataTypeIds2[DataTypeIds2["DateTime"] = 13] = "DateTime";
      DataTypeIds2[DataTypeIds2["Guid"] = 14] = "Guid";
      DataTypeIds2[DataTypeIds2["ByteString"] = 15] = "ByteString";
      DataTypeIds2[DataTypeIds2["XmlElement"] = 16] = "XmlElement";
      DataTypeIds2[DataTypeIds2["NodeId"] = 17] = "NodeId";
      DataTypeIds2[DataTypeIds2["ExpandedNodeId"] = 18] = "ExpandedNodeId";
      DataTypeIds2[DataTypeIds2["StatusCode"] = 19] = "StatusCode";
      DataTypeIds2[DataTypeIds2["QualifiedName"] = 20] = "QualifiedName";
      DataTypeIds2[DataTypeIds2["LocalizedText"] = 21] = "LocalizedText";
      DataTypeIds2[DataTypeIds2["Structure"] = 22] = "Structure";
      DataTypeIds2[DataTypeIds2["DataValue"] = 23] = "DataValue";
      DataTypeIds2[DataTypeIds2["BaseDataType"] = 24] = "BaseDataType";
      DataTypeIds2[DataTypeIds2["DiagnosticInfo"] = 25] = "DiagnosticInfo";
      DataTypeIds2[DataTypeIds2["Number"] = 26] = "Number";
      DataTypeIds2[DataTypeIds2["Integer"] = 27] = "Integer";
      DataTypeIds2[DataTypeIds2["UInteger"] = 28] = "UInteger";
      DataTypeIds2[DataTypeIds2["Enumeration"] = 29] = "Enumeration";
      DataTypeIds2[DataTypeIds2["Image"] = 30] = "Image";
      DataTypeIds2[DataTypeIds2["Decimal"] = 50] = "Decimal";
      DataTypeIds2[DataTypeIds2["PermissionType"] = 94] = "PermissionType";
      DataTypeIds2[DataTypeIds2["AccessRestrictionType"] = 95] = "AccessRestrictionType";
      DataTypeIds2[DataTypeIds2["RolePermissionType"] = 96] = "RolePermissionType";
      DataTypeIds2[DataTypeIds2["DataTypeDefinition"] = 97] = "DataTypeDefinition";
      DataTypeIds2[DataTypeIds2["StructureType"] = 98] = "StructureType";
      DataTypeIds2[DataTypeIds2["StructureDefinition"] = 99] = "StructureDefinition";
      DataTypeIds2[DataTypeIds2["EnumDefinition"] = 100] = "EnumDefinition";
      DataTypeIds2[DataTypeIds2["StructureField"] = 101] = "StructureField";
      DataTypeIds2[DataTypeIds2["EnumField"] = 102] = "EnumField";
      DataTypeIds2[DataTypeIds2["NamingRuleType"] = 120] = "NamingRuleType";
      DataTypeIds2[DataTypeIds2["IdType"] = 256] = "IdType";
      DataTypeIds2[DataTypeIds2["NodeClass"] = 257] = "NodeClass";
      DataTypeIds2[DataTypeIds2["Node"] = 258] = "Node";
      DataTypeIds2[DataTypeIds2["ObjectNode"] = 261] = "ObjectNode";
      DataTypeIds2[DataTypeIds2["ObjectTypeNode"] = 264] = "ObjectTypeNode";
      DataTypeIds2[DataTypeIds2["VariableNode"] = 267] = "VariableNode";
      DataTypeIds2[DataTypeIds2["VariableTypeNode"] = 270] = "VariableTypeNode";
      DataTypeIds2[DataTypeIds2["ReferenceTypeNode"] = 273] = "ReferenceTypeNode";
      DataTypeIds2[DataTypeIds2["MethodNode"] = 276] = "MethodNode";
      DataTypeIds2[DataTypeIds2["ViewNode"] = 279] = "ViewNode";
      DataTypeIds2[DataTypeIds2["DataTypeNode"] = 282] = "DataTypeNode";
      DataTypeIds2[DataTypeIds2["ReferenceNode"] = 285] = "ReferenceNode";
      DataTypeIds2[DataTypeIds2["IntegerId"] = 288] = "IntegerId";
      DataTypeIds2[DataTypeIds2["Counter"] = 289] = "Counter";
      DataTypeIds2[DataTypeIds2["Duration"] = 290] = "Duration";
      DataTypeIds2[DataTypeIds2["NumericRange"] = 291] = "NumericRange";
      DataTypeIds2[DataTypeIds2["UtcTime"] = 294] = "UtcTime";
      DataTypeIds2[DataTypeIds2["LocaleId"] = 295] = "LocaleId";
      DataTypeIds2[DataTypeIds2["Argument"] = 296] = "Argument";
      DataTypeIds2[DataTypeIds2["StatusResult"] = 299] = "StatusResult";
      DataTypeIds2[DataTypeIds2["MessageSecurityMode"] = 302] = "MessageSecurityMode";
      DataTypeIds2[DataTypeIds2["UserTokenType"] = 303] = "UserTokenType";
      DataTypeIds2[DataTypeIds2["UserTokenPolicy"] = 304] = "UserTokenPolicy";
      DataTypeIds2[DataTypeIds2["ApplicationType"] = 307] = "ApplicationType";
      DataTypeIds2[DataTypeIds2["ApplicationDescription"] = 308] = "ApplicationDescription";
      DataTypeIds2[DataTypeIds2["ApplicationInstanceCertificate"] = 311] = "ApplicationInstanceCertificate";
      DataTypeIds2[DataTypeIds2["EndpointDescription"] = 312] = "EndpointDescription";
      DataTypeIds2[DataTypeIds2["SecurityTokenRequestType"] = 315] = "SecurityTokenRequestType";
      DataTypeIds2[DataTypeIds2["UserIdentityToken"] = 316] = "UserIdentityToken";
      DataTypeIds2[DataTypeIds2["AnonymousIdentityToken"] = 319] = "AnonymousIdentityToken";
      DataTypeIds2[DataTypeIds2["UserNameIdentityToken"] = 322] = "UserNameIdentityToken";
      DataTypeIds2[DataTypeIds2["X509IdentityToken"] = 325] = "X509IdentityToken";
      DataTypeIds2[DataTypeIds2["EndpointConfiguration"] = 331] = "EndpointConfiguration";
      DataTypeIds2[DataTypeIds2["BuildInfo"] = 338] = "BuildInfo";
      DataTypeIds2[DataTypeIds2["SignedSoftwareCertificate"] = 344] = "SignedSoftwareCertificate";
      DataTypeIds2[DataTypeIds2["AttributeWriteMask"] = 347] = "AttributeWriteMask";
      DataTypeIds2[DataTypeIds2["NodeAttributesMask"] = 348] = "NodeAttributesMask";
      DataTypeIds2[DataTypeIds2["NodeAttributes"] = 349] = "NodeAttributes";
      DataTypeIds2[DataTypeIds2["ObjectAttributes"] = 352] = "ObjectAttributes";
      DataTypeIds2[DataTypeIds2["VariableAttributes"] = 355] = "VariableAttributes";
      DataTypeIds2[DataTypeIds2["MethodAttributes"] = 358] = "MethodAttributes";
      DataTypeIds2[DataTypeIds2["ObjectTypeAttributes"] = 361] = "ObjectTypeAttributes";
      DataTypeIds2[DataTypeIds2["VariableTypeAttributes"] = 364] = "VariableTypeAttributes";
      DataTypeIds2[DataTypeIds2["ReferenceTypeAttributes"] = 367] = "ReferenceTypeAttributes";
      DataTypeIds2[DataTypeIds2["DataTypeAttributes"] = 370] = "DataTypeAttributes";
      DataTypeIds2[DataTypeIds2["ViewAttributes"] = 373] = "ViewAttributes";
      DataTypeIds2[DataTypeIds2["AddNodesItem"] = 376] = "AddNodesItem";
      DataTypeIds2[DataTypeIds2["AddReferencesItem"] = 379] = "AddReferencesItem";
      DataTypeIds2[DataTypeIds2["DeleteNodesItem"] = 382] = "DeleteNodesItem";
      DataTypeIds2[DataTypeIds2["DeleteReferencesItem"] = 385] = "DeleteReferencesItem";
      DataTypeIds2[DataTypeIds2["SessionAuthenticationToken"] = 388] = "SessionAuthenticationToken";
      DataTypeIds2[DataTypeIds2["RequestHeader"] = 389] = "RequestHeader";
      DataTypeIds2[DataTypeIds2["ResponseHeader"] = 392] = "ResponseHeader";
      DataTypeIds2[DataTypeIds2["ServiceFault"] = 395] = "ServiceFault";
      DataTypeIds2[DataTypeIds2["FindServersRequest"] = 420] = "FindServersRequest";
      DataTypeIds2[DataTypeIds2["FindServersResponse"] = 423] = "FindServersResponse";
      DataTypeIds2[DataTypeIds2["GetEndpointsRequest"] = 426] = "GetEndpointsRequest";
      DataTypeIds2[DataTypeIds2["GetEndpointsResponse"] = 429] = "GetEndpointsResponse";
      DataTypeIds2[DataTypeIds2["RegisteredServer"] = 432] = "RegisteredServer";
      DataTypeIds2[DataTypeIds2["RegisterServerRequest"] = 435] = "RegisterServerRequest";
      DataTypeIds2[DataTypeIds2["RegisterServerResponse"] = 438] = "RegisterServerResponse";
      DataTypeIds2[DataTypeIds2["ChannelSecurityToken"] = 441] = "ChannelSecurityToken";
      DataTypeIds2[DataTypeIds2["OpenSecureChannelRequest"] = 444] = "OpenSecureChannelRequest";
      DataTypeIds2[DataTypeIds2["OpenSecureChannelResponse"] = 447] = "OpenSecureChannelResponse";
      DataTypeIds2[DataTypeIds2["CloseSecureChannelRequest"] = 450] = "CloseSecureChannelRequest";
      DataTypeIds2[DataTypeIds2["CloseSecureChannelResponse"] = 453] = "CloseSecureChannelResponse";
      DataTypeIds2[DataTypeIds2["SignatureData"] = 456] = "SignatureData";
      DataTypeIds2[DataTypeIds2["CreateSessionRequest"] = 459] = "CreateSessionRequest";
      DataTypeIds2[DataTypeIds2["CreateSessionResponse"] = 462] = "CreateSessionResponse";
      DataTypeIds2[DataTypeIds2["ActivateSessionRequest"] = 465] = "ActivateSessionRequest";
      DataTypeIds2[DataTypeIds2["ActivateSessionResponse"] = 468] = "ActivateSessionResponse";
      DataTypeIds2[DataTypeIds2["CloseSessionRequest"] = 471] = "CloseSessionRequest";
      DataTypeIds2[DataTypeIds2["CloseSessionResponse"] = 474] = "CloseSessionResponse";
      DataTypeIds2[DataTypeIds2["CancelRequest"] = 477] = "CancelRequest";
      DataTypeIds2[DataTypeIds2["CancelResponse"] = 480] = "CancelResponse";
      DataTypeIds2[DataTypeIds2["AddNodesResult"] = 483] = "AddNodesResult";
      DataTypeIds2[DataTypeIds2["AddNodesRequest"] = 486] = "AddNodesRequest";
      DataTypeIds2[DataTypeIds2["AddNodesResponse"] = 489] = "AddNodesResponse";
      DataTypeIds2[DataTypeIds2["AddReferencesRequest"] = 492] = "AddReferencesRequest";
      DataTypeIds2[DataTypeIds2["AddReferencesResponse"] = 495] = "AddReferencesResponse";
      DataTypeIds2[DataTypeIds2["DeleteNodesRequest"] = 498] = "DeleteNodesRequest";
      DataTypeIds2[DataTypeIds2["DeleteNodesResponse"] = 501] = "DeleteNodesResponse";
      DataTypeIds2[DataTypeIds2["DeleteReferencesRequest"] = 504] = "DeleteReferencesRequest";
      DataTypeIds2[DataTypeIds2["DeleteReferencesResponse"] = 507] = "DeleteReferencesResponse";
      DataTypeIds2[DataTypeIds2["BrowseDirection"] = 510] = "BrowseDirection";
      DataTypeIds2[DataTypeIds2["ViewDescription"] = 511] = "ViewDescription";
      DataTypeIds2[DataTypeIds2["BrowseDescription"] = 514] = "BrowseDescription";
      DataTypeIds2[DataTypeIds2["BrowseResultMask"] = 517] = "BrowseResultMask";
      DataTypeIds2[DataTypeIds2["ReferenceDescription"] = 518] = "ReferenceDescription";
      DataTypeIds2[DataTypeIds2["ContinuationPoint"] = 521] = "ContinuationPoint";
      DataTypeIds2[DataTypeIds2["BrowseResult"] = 522] = "BrowseResult";
      DataTypeIds2[DataTypeIds2["BrowseRequest"] = 525] = "BrowseRequest";
      DataTypeIds2[DataTypeIds2["BrowseResponse"] = 528] = "BrowseResponse";
      DataTypeIds2[DataTypeIds2["BrowseNextRequest"] = 531] = "BrowseNextRequest";
      DataTypeIds2[DataTypeIds2["BrowseNextResponse"] = 534] = "BrowseNextResponse";
      DataTypeIds2[DataTypeIds2["RelativePathElement"] = 537] = "RelativePathElement";
      DataTypeIds2[DataTypeIds2["RelativePath"] = 540] = "RelativePath";
      DataTypeIds2[DataTypeIds2["BrowsePath"] = 543] = "BrowsePath";
      DataTypeIds2[DataTypeIds2["BrowsePathTarget"] = 546] = "BrowsePathTarget";
      DataTypeIds2[DataTypeIds2["BrowsePathResult"] = 549] = "BrowsePathResult";
      DataTypeIds2[DataTypeIds2["TranslateBrowsePathsToNodeIdsRequest"] = 552] = "TranslateBrowsePathsToNodeIdsRequest";
      DataTypeIds2[DataTypeIds2["TranslateBrowsePathsToNodeIdsResponse"] = 555] = "TranslateBrowsePathsToNodeIdsResponse";
      DataTypeIds2[DataTypeIds2["RegisterNodesRequest"] = 558] = "RegisterNodesRequest";
      DataTypeIds2[DataTypeIds2["RegisterNodesResponse"] = 561] = "RegisterNodesResponse";
      DataTypeIds2[DataTypeIds2["UnregisterNodesRequest"] = 564] = "UnregisterNodesRequest";
      DataTypeIds2[DataTypeIds2["UnregisterNodesResponse"] = 567] = "UnregisterNodesResponse";
      DataTypeIds2[DataTypeIds2["QueryDataDescription"] = 570] = "QueryDataDescription";
      DataTypeIds2[DataTypeIds2["NodeTypeDescription"] = 573] = "NodeTypeDescription";
      DataTypeIds2[DataTypeIds2["FilterOperator"] = 576] = "FilterOperator";
      DataTypeIds2[DataTypeIds2["QueryDataSet"] = 577] = "QueryDataSet";
      DataTypeIds2[DataTypeIds2["NodeReference"] = 580] = "NodeReference";
      DataTypeIds2[DataTypeIds2["ContentFilterElement"] = 583] = "ContentFilterElement";
      DataTypeIds2[DataTypeIds2["ContentFilter"] = 586] = "ContentFilter";
      DataTypeIds2[DataTypeIds2["FilterOperand"] = 589] = "FilterOperand";
      DataTypeIds2[DataTypeIds2["ElementOperand"] = 592] = "ElementOperand";
      DataTypeIds2[DataTypeIds2["LiteralOperand"] = 595] = "LiteralOperand";
      DataTypeIds2[DataTypeIds2["AttributeOperand"] = 598] = "AttributeOperand";
      DataTypeIds2[DataTypeIds2["SimpleAttributeOperand"] = 601] = "SimpleAttributeOperand";
      DataTypeIds2[DataTypeIds2["ContentFilterElementResult"] = 604] = "ContentFilterElementResult";
      DataTypeIds2[DataTypeIds2["ContentFilterResult"] = 607] = "ContentFilterResult";
      DataTypeIds2[DataTypeIds2["ParsingResult"] = 610] = "ParsingResult";
      DataTypeIds2[DataTypeIds2["QueryFirstRequest"] = 613] = "QueryFirstRequest";
      DataTypeIds2[DataTypeIds2["QueryFirstResponse"] = 616] = "QueryFirstResponse";
      DataTypeIds2[DataTypeIds2["QueryNextRequest"] = 619] = "QueryNextRequest";
      DataTypeIds2[DataTypeIds2["QueryNextResponse"] = 622] = "QueryNextResponse";
      DataTypeIds2[DataTypeIds2["TimestampsToReturn"] = 625] = "TimestampsToReturn";
      DataTypeIds2[DataTypeIds2["ReadValueId"] = 626] = "ReadValueId";
      DataTypeIds2[DataTypeIds2["ReadRequest"] = 629] = "ReadRequest";
      DataTypeIds2[DataTypeIds2["ReadResponse"] = 632] = "ReadResponse";
      DataTypeIds2[DataTypeIds2["HistoryReadValueId"] = 635] = "HistoryReadValueId";
      DataTypeIds2[DataTypeIds2["HistoryReadResult"] = 638] = "HistoryReadResult";
      DataTypeIds2[DataTypeIds2["HistoryReadDetails"] = 641] = "HistoryReadDetails";
      DataTypeIds2[DataTypeIds2["ReadEventDetails"] = 644] = "ReadEventDetails";
      DataTypeIds2[DataTypeIds2["ReadRawModifiedDetails"] = 647] = "ReadRawModifiedDetails";
      DataTypeIds2[DataTypeIds2["ReadProcessedDetails"] = 650] = "ReadProcessedDetails";
      DataTypeIds2[DataTypeIds2["ReadAtTimeDetails"] = 653] = "ReadAtTimeDetails";
      DataTypeIds2[DataTypeIds2["HistoryData"] = 656] = "HistoryData";
      DataTypeIds2[DataTypeIds2["HistoryEvent"] = 659] = "HistoryEvent";
      DataTypeIds2[DataTypeIds2["HistoryReadRequest"] = 662] = "HistoryReadRequest";
      DataTypeIds2[DataTypeIds2["HistoryReadResponse"] = 665] = "HistoryReadResponse";
      DataTypeIds2[DataTypeIds2["WriteValue"] = 668] = "WriteValue";
      DataTypeIds2[DataTypeIds2["WriteRequest"] = 671] = "WriteRequest";
      DataTypeIds2[DataTypeIds2["WriteResponse"] = 674] = "WriteResponse";
      DataTypeIds2[DataTypeIds2["HistoryUpdateDetails"] = 677] = "HistoryUpdateDetails";
      DataTypeIds2[DataTypeIds2["UpdateDataDetails"] = 680] = "UpdateDataDetails";
      DataTypeIds2[DataTypeIds2["UpdateEventDetails"] = 683] = "UpdateEventDetails";
      DataTypeIds2[DataTypeIds2["DeleteRawModifiedDetails"] = 686] = "DeleteRawModifiedDetails";
      DataTypeIds2[DataTypeIds2["DeleteAtTimeDetails"] = 689] = "DeleteAtTimeDetails";
      DataTypeIds2[DataTypeIds2["DeleteEventDetails"] = 692] = "DeleteEventDetails";
      DataTypeIds2[DataTypeIds2["HistoryUpdateResult"] = 695] = "HistoryUpdateResult";
      DataTypeIds2[DataTypeIds2["HistoryUpdateRequest"] = 698] = "HistoryUpdateRequest";
      DataTypeIds2[DataTypeIds2["HistoryUpdateResponse"] = 701] = "HistoryUpdateResponse";
      DataTypeIds2[DataTypeIds2["CallMethodRequest"] = 704] = "CallMethodRequest";
      DataTypeIds2[DataTypeIds2["CallMethodResult"] = 707] = "CallMethodResult";
      DataTypeIds2[DataTypeIds2["CallRequest"] = 710] = "CallRequest";
      DataTypeIds2[DataTypeIds2["CallResponse"] = 713] = "CallResponse";
      DataTypeIds2[DataTypeIds2["MonitoringMode"] = 716] = "MonitoringMode";
      DataTypeIds2[DataTypeIds2["DataChangeTrigger"] = 717] = "DataChangeTrigger";
      DataTypeIds2[DataTypeIds2["DeadbandType"] = 718] = "DeadbandType";
      DataTypeIds2[DataTypeIds2["MonitoringFilter"] = 719] = "MonitoringFilter";
      DataTypeIds2[DataTypeIds2["DataChangeFilter"] = 722] = "DataChangeFilter";
      DataTypeIds2[DataTypeIds2["EventFilter"] = 725] = "EventFilter";
      DataTypeIds2[DataTypeIds2["AggregateFilter"] = 728] = "AggregateFilter";
      DataTypeIds2[DataTypeIds2["MonitoringFilterResult"] = 731] = "MonitoringFilterResult";
      DataTypeIds2[DataTypeIds2["EventFilterResult"] = 734] = "EventFilterResult";
      DataTypeIds2[DataTypeIds2["AggregateFilterResult"] = 737] = "AggregateFilterResult";
      DataTypeIds2[DataTypeIds2["MonitoringParameters"] = 740] = "MonitoringParameters";
      DataTypeIds2[DataTypeIds2["MonitoredItemCreateRequest"] = 743] = "MonitoredItemCreateRequest";
      DataTypeIds2[DataTypeIds2["MonitoredItemCreateResult"] = 746] = "MonitoredItemCreateResult";
      DataTypeIds2[DataTypeIds2["CreateMonitoredItemsRequest"] = 749] = "CreateMonitoredItemsRequest";
      DataTypeIds2[DataTypeIds2["CreateMonitoredItemsResponse"] = 752] = "CreateMonitoredItemsResponse";
      DataTypeIds2[DataTypeIds2["MonitoredItemModifyRequest"] = 755] = "MonitoredItemModifyRequest";
      DataTypeIds2[DataTypeIds2["MonitoredItemModifyResult"] = 758] = "MonitoredItemModifyResult";
      DataTypeIds2[DataTypeIds2["ModifyMonitoredItemsRequest"] = 761] = "ModifyMonitoredItemsRequest";
      DataTypeIds2[DataTypeIds2["ModifyMonitoredItemsResponse"] = 764] = "ModifyMonitoredItemsResponse";
      DataTypeIds2[DataTypeIds2["SetMonitoringModeRequest"] = 767] = "SetMonitoringModeRequest";
      DataTypeIds2[DataTypeIds2["SetMonitoringModeResponse"] = 770] = "SetMonitoringModeResponse";
      DataTypeIds2[DataTypeIds2["SetTriggeringRequest"] = 773] = "SetTriggeringRequest";
      DataTypeIds2[DataTypeIds2["SetTriggeringResponse"] = 776] = "SetTriggeringResponse";
      DataTypeIds2[DataTypeIds2["DeleteMonitoredItemsRequest"] = 779] = "DeleteMonitoredItemsRequest";
      DataTypeIds2[DataTypeIds2["DeleteMonitoredItemsResponse"] = 782] = "DeleteMonitoredItemsResponse";
      DataTypeIds2[DataTypeIds2["CreateSubscriptionRequest"] = 785] = "CreateSubscriptionRequest";
      DataTypeIds2[DataTypeIds2["CreateSubscriptionResponse"] = 788] = "CreateSubscriptionResponse";
      DataTypeIds2[DataTypeIds2["ModifySubscriptionRequest"] = 791] = "ModifySubscriptionRequest";
      DataTypeIds2[DataTypeIds2["ModifySubscriptionResponse"] = 794] = "ModifySubscriptionResponse";
      DataTypeIds2[DataTypeIds2["SetPublishingModeRequest"] = 797] = "SetPublishingModeRequest";
      DataTypeIds2[DataTypeIds2["SetPublishingModeResponse"] = 800] = "SetPublishingModeResponse";
      DataTypeIds2[DataTypeIds2["NotificationMessage"] = 803] = "NotificationMessage";
      DataTypeIds2[DataTypeIds2["MonitoredItemNotification"] = 806] = "MonitoredItemNotification";
      DataTypeIds2[DataTypeIds2["DataChangeNotification"] = 809] = "DataChangeNotification";
      DataTypeIds2[DataTypeIds2["StatusChangeNotification"] = 818] = "StatusChangeNotification";
      DataTypeIds2[DataTypeIds2["SubscriptionAcknowledgement"] = 821] = "SubscriptionAcknowledgement";
      DataTypeIds2[DataTypeIds2["PublishRequest"] = 824] = "PublishRequest";
      DataTypeIds2[DataTypeIds2["PublishResponse"] = 827] = "PublishResponse";
      DataTypeIds2[DataTypeIds2["RepublishRequest"] = 830] = "RepublishRequest";
      DataTypeIds2[DataTypeIds2["RepublishResponse"] = 833] = "RepublishResponse";
      DataTypeIds2[DataTypeIds2["TransferResult"] = 836] = "TransferResult";
      DataTypeIds2[DataTypeIds2["TransferSubscriptionsRequest"] = 839] = "TransferSubscriptionsRequest";
      DataTypeIds2[DataTypeIds2["TransferSubscriptionsResponse"] = 842] = "TransferSubscriptionsResponse";
      DataTypeIds2[DataTypeIds2["DeleteSubscriptionsRequest"] = 845] = "DeleteSubscriptionsRequest";
      DataTypeIds2[DataTypeIds2["DeleteSubscriptionsResponse"] = 848] = "DeleteSubscriptionsResponse";
      DataTypeIds2[DataTypeIds2["RedundancySupport"] = 851] = "RedundancySupport";
      DataTypeIds2[DataTypeIds2["ServerState"] = 852] = "ServerState";
      DataTypeIds2[DataTypeIds2["RedundantServerDataType"] = 853] = "RedundantServerDataType";
      DataTypeIds2[DataTypeIds2["SamplingIntervalDiagnosticsDataType"] = 856] = "SamplingIntervalDiagnosticsDataType";
      DataTypeIds2[DataTypeIds2["ServerDiagnosticsSummaryDataType"] = 859] = "ServerDiagnosticsSummaryDataType";
      DataTypeIds2[DataTypeIds2["ServerStatusDataType"] = 862] = "ServerStatusDataType";
      DataTypeIds2[DataTypeIds2["SessionDiagnosticsDataType"] = 865] = "SessionDiagnosticsDataType";
      DataTypeIds2[DataTypeIds2["SessionSecurityDiagnosticsDataType"] = 868] = "SessionSecurityDiagnosticsDataType";
      DataTypeIds2[DataTypeIds2["ServiceCounterDataType"] = 871] = "ServiceCounterDataType";
      DataTypeIds2[DataTypeIds2["SubscriptionDiagnosticsDataType"] = 874] = "SubscriptionDiagnosticsDataType";
      DataTypeIds2[DataTypeIds2["ModelChangeStructureDataType"] = 877] = "ModelChangeStructureDataType";
      DataTypeIds2[DataTypeIds2["Range"] = 884] = "Range";
      DataTypeIds2[DataTypeIds2["EUInformation"] = 887] = "EUInformation";
      DataTypeIds2[DataTypeIds2["ExceptionDeviationFormat"] = 890] = "ExceptionDeviationFormat";
      DataTypeIds2[DataTypeIds2["Annotation"] = 891] = "Annotation";
      DataTypeIds2[DataTypeIds2["ProgramDiagnosticDataType"] = 894] = "ProgramDiagnosticDataType";
      DataTypeIds2[DataTypeIds2["SemanticChangeStructureDataType"] = 897] = "SemanticChangeStructureDataType";
      DataTypeIds2[DataTypeIds2["EventNotificationList"] = 914] = "EventNotificationList";
      DataTypeIds2[DataTypeIds2["EventFieldList"] = 917] = "EventFieldList";
      DataTypeIds2[DataTypeIds2["HistoryEventFieldList"] = 920] = "HistoryEventFieldList";
      DataTypeIds2[DataTypeIds2["IssuedIdentityToken"] = 938] = "IssuedIdentityToken";
      DataTypeIds2[DataTypeIds2["NotificationData"] = 945] = "NotificationData";
      DataTypeIds2[DataTypeIds2["AggregateConfiguration"] = 948] = "AggregateConfiguration";
      DataTypeIds2[DataTypeIds2["ImageBMP"] = 2e3] = "ImageBMP";
      DataTypeIds2[DataTypeIds2["ImageGIF"] = 2001] = "ImageGIF";
      DataTypeIds2[DataTypeIds2["ImageJPG"] = 2002] = "ImageJPG";
      DataTypeIds2[DataTypeIds2["ImagePNG"] = 2003] = "ImagePNG";
      DataTypeIds2[DataTypeIds2["EnumValueType"] = 7594] = "EnumValueType";
      DataTypeIds2[DataTypeIds2["TimeZoneDataType"] = 8912] = "TimeZoneDataType";
      DataTypeIds2[DataTypeIds2["ModificationInfo"] = 11216] = "ModificationInfo";
      DataTypeIds2[DataTypeIds2["HistoryModifiedData"] = 11217] = "HistoryModifiedData";
      DataTypeIds2[DataTypeIds2["HistoryUpdateType"] = 11234] = "HistoryUpdateType";
      DataTypeIds2[DataTypeIds2["PerformUpdateType"] = 11293] = "PerformUpdateType";
      DataTypeIds2[DataTypeIds2["UpdateStructureDataDetails"] = 11295] = "UpdateStructureDataDetails";
      DataTypeIds2[DataTypeIds2["BitFieldMaskDataType"] = 11737] = "BitFieldMaskDataType";
      DataTypeIds2[DataTypeIds2["InstanceNode"] = 11879] = "InstanceNode";
      DataTypeIds2[DataTypeIds2["TypeNode"] = 11880] = "TypeNode";
      DataTypeIds2[DataTypeIds2["OpenFileMode"] = 11939] = "OpenFileMode";
      DataTypeIds2[DataTypeIds2["ModelChangeStructureVerbMask"] = 11941] = "ModelChangeStructureVerbMask";
      DataTypeIds2[DataTypeIds2["EndpointUrlListDataType"] = 11943] = "EndpointUrlListDataType";
      DataTypeIds2[DataTypeIds2["NetworkGroupDataType"] = 11944] = "NetworkGroupDataType";
      DataTypeIds2[DataTypeIds2["AxisScaleEnumeration"] = 12077] = "AxisScaleEnumeration";
      DataTypeIds2[DataTypeIds2["AxisInformation"] = 12079] = "AxisInformation";
      DataTypeIds2[DataTypeIds2["XVType"] = 12080] = "XVType";
      DataTypeIds2[DataTypeIds2["ComplexNumberType"] = 12171] = "ComplexNumberType";
      DataTypeIds2[DataTypeIds2["DoubleComplexNumberType"] = 12172] = "DoubleComplexNumberType";
      DataTypeIds2[DataTypeIds2["ServerOnNetwork"] = 12189] = "ServerOnNetwork";
      DataTypeIds2[DataTypeIds2["FindServersOnNetworkRequest"] = 12190] = "FindServersOnNetworkRequest";
      DataTypeIds2[DataTypeIds2["FindServersOnNetworkResponse"] = 12191] = "FindServersOnNetworkResponse";
      DataTypeIds2[DataTypeIds2["RegisterServer2Request"] = 12193] = "RegisterServer2Request";
      DataTypeIds2[DataTypeIds2["RegisterServer2Response"] = 12194] = "RegisterServer2Response";
      DataTypeIds2[DataTypeIds2["TrustListMasks"] = 12552] = "TrustListMasks";
      DataTypeIds2[DataTypeIds2["TrustListDataType"] = 12554] = "TrustListDataType";
      DataTypeIds2[DataTypeIds2["OptionSet"] = 12755] = "OptionSet";
      DataTypeIds2[DataTypeIds2["Union"] = 12756] = "Union";
      DataTypeIds2[DataTypeIds2["NormalizedString"] = 12877] = "NormalizedString";
      DataTypeIds2[DataTypeIds2["DecimalString"] = 12878] = "DecimalString";
      DataTypeIds2[DataTypeIds2["DurationString"] = 12879] = "DurationString";
      DataTypeIds2[DataTypeIds2["TimeString"] = 12880] = "TimeString";
      DataTypeIds2[DataTypeIds2["DateString"] = 12881] = "DateString";
      DataTypeIds2[DataTypeIds2["DiscoveryConfiguration"] = 12890] = "DiscoveryConfiguration";
      DataTypeIds2[DataTypeIds2["MdnsDiscoveryConfiguration"] = 12891] = "MdnsDiscoveryConfiguration";
      DataTypeIds2[DataTypeIds2["PublishedVariableDataType"] = 14273] = "PublishedVariableDataType";
      DataTypeIds2[DataTypeIds2["DataSetMetaDataType"] = 14523] = "DataSetMetaDataType";
      DataTypeIds2[DataTypeIds2["FieldMetaData"] = 14524] = "FieldMetaData";
      DataTypeIds2[DataTypeIds2["DataTypeDescription"] = 14525] = "DataTypeDescription";
      DataTypeIds2[DataTypeIds2["KeyValuePair"] = 14533] = "KeyValuePair";
      DataTypeIds2[DataTypeIds2["ConfigurationVersionDataType"] = 14593] = "ConfigurationVersionDataType";
      DataTypeIds2[DataTypeIds2["PubSubState"] = 14647] = "PubSubState";
      DataTypeIds2[DataTypeIds2["FieldTargetDataType"] = 14744] = "FieldTargetDataType";
      DataTypeIds2[DataTypeIds2["SimpleTypeDescription"] = 15005] = "SimpleTypeDescription";
      DataTypeIds2[DataTypeIds2["UABinaryFileDataType"] = 15006] = "UABinaryFileDataType";
      DataTypeIds2[DataTypeIds2["BrokerConnectionTransportDataType"] = 15007] = "BrokerConnectionTransportDataType";
      DataTypeIds2[DataTypeIds2["BrokerTransportQualityOfService"] = 15008] = "BrokerTransportQualityOfService";
      DataTypeIds2[DataTypeIds2["AccessLevelType"] = 15031] = "AccessLevelType";
      DataTypeIds2[DataTypeIds2["EventNotifierType"] = 15033] = "EventNotifierType";
      DataTypeIds2[DataTypeIds2["AccessLevelExType"] = 15406] = "AccessLevelExType";
      DataTypeIds2[DataTypeIds2["WriterGroupDataType"] = 15480] = "WriterGroupDataType";
      DataTypeIds2[DataTypeIds2["StructureDescription"] = 15487] = "StructureDescription";
      DataTypeIds2[DataTypeIds2["EnumDescription"] = 15488] = "EnumDescription";
      DataTypeIds2[DataTypeIds2["NetworkAddressDataType"] = 15502] = "NetworkAddressDataType";
      DataTypeIds2[DataTypeIds2["NetworkAddressUrlDataType"] = 15510] = "NetworkAddressUrlDataType";
      DataTypeIds2[DataTypeIds2["ReaderGroupDataType"] = 15520] = "ReaderGroupDataType";
      DataTypeIds2[DataTypeIds2["EndpointType"] = 15528] = "EndpointType";
      DataTypeIds2[DataTypeIds2["PubSubConfigurationDataType"] = 15530] = "PubSubConfigurationDataType";
      DataTypeIds2[DataTypeIds2["DatagramWriterGroupTransportDataType"] = 15532] = "DatagramWriterGroupTransportDataType";
      DataTypeIds2[DataTypeIds2["DataTypeSchemaHeader"] = 15534] = "DataTypeSchemaHeader";
      DataTypeIds2[DataTypeIds2["PublishedDataSetDataType"] = 15578] = "PublishedDataSetDataType";
      DataTypeIds2[DataTypeIds2["PublishedDataSetSourceDataType"] = 15580] = "PublishedDataSetSourceDataType";
      DataTypeIds2[DataTypeIds2["PublishedDataItemsDataType"] = 15581] = "PublishedDataItemsDataType";
      DataTypeIds2[DataTypeIds2["PublishedEventsDataType"] = 15582] = "PublishedEventsDataType";
      DataTypeIds2[DataTypeIds2["DataSetFieldContentMask"] = 15583] = "DataSetFieldContentMask";
      DataTypeIds2[DataTypeIds2["DataSetWriterDataType"] = 15597] = "DataSetWriterDataType";
      DataTypeIds2[DataTypeIds2["DataSetWriterTransportDataType"] = 15598] = "DataSetWriterTransportDataType";
      DataTypeIds2[DataTypeIds2["DataSetWriterMessageDataType"] = 15605] = "DataSetWriterMessageDataType";
      DataTypeIds2[DataTypeIds2["PubSubGroupDataType"] = 15609] = "PubSubGroupDataType";
      DataTypeIds2[DataTypeIds2["WriterGroupTransportDataType"] = 15611] = "WriterGroupTransportDataType";
      DataTypeIds2[DataTypeIds2["WriterGroupMessageDataType"] = 15616] = "WriterGroupMessageDataType";
      DataTypeIds2[DataTypeIds2["PubSubConnectionDataType"] = 15617] = "PubSubConnectionDataType";
      DataTypeIds2[DataTypeIds2["ConnectionTransportDataType"] = 15618] = "ConnectionTransportDataType";
      DataTypeIds2[DataTypeIds2["ReaderGroupTransportDataType"] = 15621] = "ReaderGroupTransportDataType";
      DataTypeIds2[DataTypeIds2["ReaderGroupMessageDataType"] = 15622] = "ReaderGroupMessageDataType";
      DataTypeIds2[DataTypeIds2["DataSetReaderDataType"] = 15623] = "DataSetReaderDataType";
      DataTypeIds2[DataTypeIds2["DataSetReaderTransportDataType"] = 15628] = "DataSetReaderTransportDataType";
      DataTypeIds2[DataTypeIds2["DataSetReaderMessageDataType"] = 15629] = "DataSetReaderMessageDataType";
      DataTypeIds2[DataTypeIds2["SubscribedDataSetDataType"] = 15630] = "SubscribedDataSetDataType";
      DataTypeIds2[DataTypeIds2["TargetVariablesDataType"] = 15631] = "TargetVariablesDataType";
      DataTypeIds2[DataTypeIds2["IdentityCriteriaType"] = 15632] = "IdentityCriteriaType";
      DataTypeIds2[DataTypeIds2["IdentityMappingRuleType"] = 15634] = "IdentityMappingRuleType";
      DataTypeIds2[DataTypeIds2["SubscribedDataSetMirrorDataType"] = 15635] = "SubscribedDataSetMirrorDataType";
      DataTypeIds2[DataTypeIds2["UadpNetworkMessageContentMask"] = 15642] = "UadpNetworkMessageContentMask";
      DataTypeIds2[DataTypeIds2["UadpWriterGroupMessageDataType"] = 15645] = "UadpWriterGroupMessageDataType";
      DataTypeIds2[DataTypeIds2["UadpDataSetMessageContentMask"] = 15646] = "UadpDataSetMessageContentMask";
      DataTypeIds2[DataTypeIds2["UadpDataSetWriterMessageDataType"] = 15652] = "UadpDataSetWriterMessageDataType";
      DataTypeIds2[DataTypeIds2["UadpDataSetReaderMessageDataType"] = 15653] = "UadpDataSetReaderMessageDataType";
      DataTypeIds2[DataTypeIds2["JsonNetworkMessageContentMask"] = 15654] = "JsonNetworkMessageContentMask";
      DataTypeIds2[DataTypeIds2["JsonWriterGroupMessageDataType"] = 15657] = "JsonWriterGroupMessageDataType";
      DataTypeIds2[DataTypeIds2["JsonDataSetMessageContentMask"] = 15658] = "JsonDataSetMessageContentMask";
      DataTypeIds2[DataTypeIds2["JsonDataSetWriterMessageDataType"] = 15664] = "JsonDataSetWriterMessageDataType";
      DataTypeIds2[DataTypeIds2["JsonDataSetReaderMessageDataType"] = 15665] = "JsonDataSetReaderMessageDataType";
      DataTypeIds2[DataTypeIds2["BrokerWriterGroupTransportDataType"] = 15667] = "BrokerWriterGroupTransportDataType";
      DataTypeIds2[DataTypeIds2["BrokerDataSetWriterTransportDataType"] = 15669] = "BrokerDataSetWriterTransportDataType";
      DataTypeIds2[DataTypeIds2["BrokerDataSetReaderTransportDataType"] = 15670] = "BrokerDataSetReaderTransportDataType";
      DataTypeIds2[DataTypeIds2["OverrideValueHandling"] = 15874] = "OverrideValueHandling";
      DataTypeIds2[DataTypeIds2["SessionlessInvokeRequestType"] = 15901] = "SessionlessInvokeRequestType";
      DataTypeIds2[DataTypeIds2["DataSetFieldFlags"] = 15904] = "DataSetFieldFlags";
      DataTypeIds2[DataTypeIds2["AudioDataType"] = 16307] = "AudioDataType";
      DataTypeIds2[DataTypeIds2["AdditionalParametersType"] = 16313] = "AdditionalParametersType";
      DataTypeIds2[DataTypeIds2["DatagramConnectionTransportDataType"] = 17467] = "DatagramConnectionTransportDataType";
      DataTypeIds2[DataTypeIds2["RsaEncryptedSecret"] = 17545] = "RsaEncryptedSecret";
      DataTypeIds2[DataTypeIds2["EccEncryptedSecret"] = 17546] = "EccEncryptedSecret";
      DataTypeIds2[DataTypeIds2["EphemeralKeyType"] = 17548] = "EphemeralKeyType";
      DataTypeIds2[DataTypeIds2["Index"] = 17588] = "Index";
      DataTypeIds2[DataTypeIds2["GenericAttributeValue"] = 17606] = "GenericAttributeValue";
      DataTypeIds2[DataTypeIds2["GenericAttributes"] = 17607] = "GenericAttributes";
      DataTypeIds2[DataTypeIds2["DecimalDataType"] = 17861] = "DecimalDataType";
      DataTypeIds2[DataTypeIds2["RationalNumber"] = 18806] = "RationalNumber";
      DataTypeIds2[DataTypeIds2["Vector"] = 18807] = "Vector";
      DataTypeIds2[DataTypeIds2["ThreeDVector"] = 18808] = "ThreeDVector";
      DataTypeIds2[DataTypeIds2["CartesianCoordinates"] = 18809] = "CartesianCoordinates";
      DataTypeIds2[DataTypeIds2["ThreeDCartesianCoordinates"] = 18810] = "ThreeDCartesianCoordinates";
      DataTypeIds2[DataTypeIds2["Orientation"] = 18811] = "Orientation";
      DataTypeIds2[DataTypeIds2["ThreeDOrientation"] = 18812] = "ThreeDOrientation";
      DataTypeIds2[DataTypeIds2["Frame"] = 18813] = "Frame";
      DataTypeIds2[DataTypeIds2["ThreeDFrame"] = 18814] = "ThreeDFrame";
      DataTypeIds2[DataTypeIds2["DiagnosticsLevel"] = 19723] = "DiagnosticsLevel";
      DataTypeIds2[DataTypeIds2["PubSubDiagnosticsCounterClassification"] = 19730] = "PubSubDiagnosticsCounterClassification";
      DataTypeIds2[DataTypeIds2["DataSetOrderingType"] = 20408] = "DataSetOrderingType";
      DataTypeIds2[DataTypeIds2["VersionTime"] = 20998] = "VersionTime";
      DataTypeIds2[DataTypeIds2["SessionlessInvokeResponseType"] = 20999] = "SessionlessInvokeResponseType";
      DataTypeIds2[DataTypeIds2["AliasNameDataType"] = 23468] = "AliasNameDataType";
      DataTypeIds2[DataTypeIds2["ReadAnnotationDataDetails"] = 23497] = "ReadAnnotationDataDetails";
      DataTypeIds2[DataTypeIds2["CurrencyUnitType"] = 23498] = "CurrencyUnitType";
      DataTypeIds2[DataTypeIds2["TrustListValidationOptions"] = 23564] = "TrustListValidationOptions";
      DataTypeIds2[DataTypeIds2["StandaloneSubscribedDataSetRefDataType"] = 23599] = "StandaloneSubscribedDataSetRefDataType";
      DataTypeIds2[DataTypeIds2["StandaloneSubscribedDataSetDataType"] = 23600] = "StandaloneSubscribedDataSetDataType";
      DataTypeIds2[DataTypeIds2["SecurityGroupDataType"] = 23601] = "SecurityGroupDataType";
      DataTypeIds2[DataTypeIds2["PubSubConfiguration2DataType"] = 23602] = "PubSubConfiguration2DataType";
      DataTypeIds2[DataTypeIds2["QosDataType"] = 23603] = "QosDataType";
      DataTypeIds2[DataTypeIds2["TransmitQosDataType"] = 23604] = "TransmitQosDataType";
      DataTypeIds2[DataTypeIds2["TransmitQosPriorityDataType"] = 23605] = "TransmitQosPriorityDataType";
      DataTypeIds2[DataTypeIds2["ReceiveQosDataType"] = 23608] = "ReceiveQosDataType";
      DataTypeIds2[DataTypeIds2["ReceiveQosPriorityDataType"] = 23609] = "ReceiveQosPriorityDataType";
      DataTypeIds2[DataTypeIds2["DatagramConnectionTransport2DataType"] = 23612] = "DatagramConnectionTransport2DataType";
      DataTypeIds2[DataTypeIds2["DatagramWriterGroupTransport2DataType"] = 23613] = "DatagramWriterGroupTransport2DataType";
      DataTypeIds2[DataTypeIds2["DatagramDataSetReaderTransportDataType"] = 23614] = "DatagramDataSetReaderTransportDataType";
      DataTypeIds2[DataTypeIds2["UriString"] = 23751] = "UriString";
      DataTypeIds2[DataTypeIds2["ProgramDiagnostic2DataType"] = 24033] = "ProgramDiagnostic2DataType";
      DataTypeIds2[DataTypeIds2["PortableQualifiedName"] = 24105] = "PortableQualifiedName";
      DataTypeIds2[DataTypeIds2["PortableNodeId"] = 24106] = "PortableNodeId";
      DataTypeIds2[DataTypeIds2["UnsignedRationalNumber"] = 24107] = "UnsignedRationalNumber";
      DataTypeIds2[DataTypeIds2["Duplex"] = 24210] = "Duplex";
      DataTypeIds2[DataTypeIds2["InterfaceAdminStatus"] = 24212] = "InterfaceAdminStatus";
      DataTypeIds2[DataTypeIds2["InterfaceOperStatus"] = 24214] = "InterfaceOperStatus";
      DataTypeIds2[DataTypeIds2["NegotiationStatus"] = 24216] = "NegotiationStatus";
      DataTypeIds2[DataTypeIds2["TsnFailureCode"] = 24218] = "TsnFailureCode";
      DataTypeIds2[DataTypeIds2["TsnStreamState"] = 24220] = "TsnStreamState";
      DataTypeIds2[DataTypeIds2["TsnTalkerStatus"] = 24222] = "TsnTalkerStatus";
      DataTypeIds2[DataTypeIds2["TsnListenerStatus"] = 24224] = "TsnListenerStatus";
      DataTypeIds2[DataTypeIds2["SemanticVersionString"] = 24263] = "SemanticVersionString";
      DataTypeIds2[DataTypeIds2["PasswordOptionsMask"] = 24277] = "PasswordOptionsMask";
      DataTypeIds2[DataTypeIds2["UserConfigurationMask"] = 24279] = "UserConfigurationMask";
      DataTypeIds2[DataTypeIds2["UserManagementDataType"] = 24281] = "UserManagementDataType";
      DataTypeIds2[DataTypeIds2["PriorityMappingEntryType"] = 25220] = "PriorityMappingEntryType";
      DataTypeIds2[DataTypeIds2["PublishedDataSetCustomSourceDataType"] = 25269] = "PublishedDataSetCustomSourceDataType";
      DataTypeIds2[DataTypeIds2["PubSubKeyPushTargetDataType"] = 25270] = "PubSubKeyPushTargetDataType";
      DataTypeIds2[DataTypeIds2["PubSubConfigurationRefMask"] = 25517] = "PubSubConfigurationRefMask";
      DataTypeIds2[DataTypeIds2["PubSubConfigurationRefDataType"] = 25519] = "PubSubConfigurationRefDataType";
      DataTypeIds2[DataTypeIds2["PubSubConfigurationValueDataType"] = 25520] = "PubSubConfigurationValueDataType";
      DataTypeIds2[DataTypeIds2["EncodedTicket"] = 25726] = "EncodedTicket";
      DataTypeIds2[DataTypeIds2["Handle"] = 31917] = "Handle";
      DataTypeIds2[DataTypeIds2["TrimmedString"] = 31918] = "TrimmedString";
      DataTypeIds2[DataTypeIds2["AlarmMask"] = 32251] = "AlarmMask";
      DataTypeIds2[DataTypeIds2["TransactionErrorType"] = 32285] = "TransactionErrorType";
      DataTypeIds2[DataTypeIds2["RedundantServerMode"] = 32417] = "RedundantServerMode";
      DataTypeIds2[DataTypeIds2["BitFieldDefinition"] = 32421] = "BitFieldDefinition";
      DataTypeIds2[DataTypeIds2["AnnotationDataType"] = 32434] = "AnnotationDataType";
      DataTypeIds2[DataTypeIds2["LinearConversionDataType"] = 32435] = "LinearConversionDataType";
      DataTypeIds2[DataTypeIds2["ConversionLimitEnum"] = 32436] = "ConversionLimitEnum";
      DataTypeIds2[DataTypeIds2["QuantityDimension"] = 32438] = "QuantityDimension";
      DataTypeIds2[DataTypeIds2["ReferenceDescriptionDataType"] = 32659] = "ReferenceDescriptionDataType";
      DataTypeIds2[DataTypeIds2["ReferenceListEntryDataType"] = 32660] = "ReferenceListEntryDataType";
      DataTypeIds2[DataTypeIds2["ReadEventDetails2"] = 32799] = "ReadEventDetails2";
      DataTypeIds2[DataTypeIds2["HistoryModifiedEvent"] = 32824] = "HistoryModifiedEvent";
    })(DataTypeIds || (exports2.DataTypeIds = DataTypeIds = {}));
    var ReferenceTypeIds;
    (function(ReferenceTypeIds2) {
      ReferenceTypeIds2[ReferenceTypeIds2["References"] = 31] = "References";
      ReferenceTypeIds2[ReferenceTypeIds2["NonHierarchicalReferences"] = 32] = "NonHierarchicalReferences";
      ReferenceTypeIds2[ReferenceTypeIds2["HierarchicalReferences"] = 33] = "HierarchicalReferences";
      ReferenceTypeIds2[ReferenceTypeIds2["HasChild"] = 34] = "HasChild";
      ReferenceTypeIds2[ReferenceTypeIds2["Organizes"] = 35] = "Organizes";
      ReferenceTypeIds2[ReferenceTypeIds2["HasEventSource"] = 36] = "HasEventSource";
      ReferenceTypeIds2[ReferenceTypeIds2["HasModellingRule"] = 37] = "HasModellingRule";
      ReferenceTypeIds2[ReferenceTypeIds2["HasEncoding"] = 38] = "HasEncoding";
      ReferenceTypeIds2[ReferenceTypeIds2["HasDescription"] = 39] = "HasDescription";
      ReferenceTypeIds2[ReferenceTypeIds2["HasTypeDefinition"] = 40] = "HasTypeDefinition";
      ReferenceTypeIds2[ReferenceTypeIds2["GeneratesEvent"] = 41] = "GeneratesEvent";
      ReferenceTypeIds2[ReferenceTypeIds2["Aggregates"] = 44] = "Aggregates";
      ReferenceTypeIds2[ReferenceTypeIds2["HasSubtype"] = 45] = "HasSubtype";
      ReferenceTypeIds2[ReferenceTypeIds2["HasProperty"] = 46] = "HasProperty";
      ReferenceTypeIds2[ReferenceTypeIds2["HasComponent"] = 47] = "HasComponent";
      ReferenceTypeIds2[ReferenceTypeIds2["HasNotifier"] = 48] = "HasNotifier";
      ReferenceTypeIds2[ReferenceTypeIds2["HasOrderedComponent"] = 49] = "HasOrderedComponent";
      ReferenceTypeIds2[ReferenceTypeIds2["FromState"] = 51] = "FromState";
      ReferenceTypeIds2[ReferenceTypeIds2["ToState"] = 52] = "ToState";
      ReferenceTypeIds2[ReferenceTypeIds2["HasCause"] = 53] = "HasCause";
      ReferenceTypeIds2[ReferenceTypeIds2["HasEffect"] = 54] = "HasEffect";
      ReferenceTypeIds2[ReferenceTypeIds2["HasHistoricalConfiguration"] = 56] = "HasHistoricalConfiguration";
      ReferenceTypeIds2[ReferenceTypeIds2["HasSubStateMachine"] = 117] = "HasSubStateMachine";
      ReferenceTypeIds2[ReferenceTypeIds2["HasArgumentDescription"] = 129] = "HasArgumentDescription";
      ReferenceTypeIds2[ReferenceTypeIds2["HasOptionalInputArgumentDescription"] = 131] = "HasOptionalInputArgumentDescription";
      ReferenceTypeIds2[ReferenceTypeIds2["AlwaysGeneratesEvent"] = 3065] = "AlwaysGeneratesEvent";
      ReferenceTypeIds2[ReferenceTypeIds2["HasTrueSubState"] = 9004] = "HasTrueSubState";
      ReferenceTypeIds2[ReferenceTypeIds2["HasFalseSubState"] = 9005] = "HasFalseSubState";
      ReferenceTypeIds2[ReferenceTypeIds2["HasCondition"] = 9006] = "HasCondition";
      ReferenceTypeIds2[ReferenceTypeIds2["HasPubSubConnection"] = 14476] = "HasPubSubConnection";
      ReferenceTypeIds2[ReferenceTypeIds2["DataSetToWriter"] = 14936] = "DataSetToWriter";
      ReferenceTypeIds2[ReferenceTypeIds2["HasGuard"] = 15112] = "HasGuard";
      ReferenceTypeIds2[ReferenceTypeIds2["HasDataSetWriter"] = 15296] = "HasDataSetWriter";
      ReferenceTypeIds2[ReferenceTypeIds2["HasDataSetReader"] = 15297] = "HasDataSetReader";
      ReferenceTypeIds2[ReferenceTypeIds2["HasAlarmSuppressionGroup"] = 16361] = "HasAlarmSuppressionGroup";
      ReferenceTypeIds2[ReferenceTypeIds2["AlarmGroupMember"] = 16362] = "AlarmGroupMember";
      ReferenceTypeIds2[ReferenceTypeIds2["HasEffectDisable"] = 17276] = "HasEffectDisable";
      ReferenceTypeIds2[ReferenceTypeIds2["HasDictionaryEntry"] = 17597] = "HasDictionaryEntry";
      ReferenceTypeIds2[ReferenceTypeIds2["HasInterface"] = 17603] = "HasInterface";
      ReferenceTypeIds2[ReferenceTypeIds2["HasAddIn"] = 17604] = "HasAddIn";
      ReferenceTypeIds2[ReferenceTypeIds2["HasEffectEnable"] = 17983] = "HasEffectEnable";
      ReferenceTypeIds2[ReferenceTypeIds2["HasEffectSuppressed"] = 17984] = "HasEffectSuppressed";
      ReferenceTypeIds2[ReferenceTypeIds2["HasEffectUnsuppressed"] = 17985] = "HasEffectUnsuppressed";
      ReferenceTypeIds2[ReferenceTypeIds2["HasWriterGroup"] = 18804] = "HasWriterGroup";
      ReferenceTypeIds2[ReferenceTypeIds2["HasReaderGroup"] = 18805] = "HasReaderGroup";
      ReferenceTypeIds2[ReferenceTypeIds2["AliasFor"] = 23469] = "AliasFor";
      ReferenceTypeIds2[ReferenceTypeIds2["IsDeprecated"] = 23562] = "IsDeprecated";
      ReferenceTypeIds2[ReferenceTypeIds2["HasStructuredComponent"] = 24136] = "HasStructuredComponent";
      ReferenceTypeIds2[ReferenceTypeIds2["AssociatedWith"] = 24137] = "AssociatedWith";
      ReferenceTypeIds2[ReferenceTypeIds2["UsesPriorityMappingTable"] = 25237] = "UsesPriorityMappingTable";
      ReferenceTypeIds2[ReferenceTypeIds2["HasLowerLayerInterface"] = 25238] = "HasLowerLayerInterface";
      ReferenceTypeIds2[ReferenceTypeIds2["IsExecutableOn"] = 25253] = "IsExecutableOn";
      ReferenceTypeIds2[ReferenceTypeIds2["Controls"] = 25254] = "Controls";
      ReferenceTypeIds2[ReferenceTypeIds2["Utilizes"] = 25255] = "Utilizes";
      ReferenceTypeIds2[ReferenceTypeIds2["Requires"] = 25256] = "Requires";
      ReferenceTypeIds2[ReferenceTypeIds2["IsPhysicallyConnectedTo"] = 25257] = "IsPhysicallyConnectedTo";
      ReferenceTypeIds2[ReferenceTypeIds2["RepresentsSameEntityAs"] = 25258] = "RepresentsSameEntityAs";
      ReferenceTypeIds2[ReferenceTypeIds2["RepresentsSameHardwareAs"] = 25259] = "RepresentsSameHardwareAs";
      ReferenceTypeIds2[ReferenceTypeIds2["RepresentsSameFunctionalityAs"] = 25260] = "RepresentsSameFunctionalityAs";
      ReferenceTypeIds2[ReferenceTypeIds2["IsHostedBy"] = 25261] = "IsHostedBy";
      ReferenceTypeIds2[ReferenceTypeIds2["HasPhysicalComponent"] = 25262] = "HasPhysicalComponent";
      ReferenceTypeIds2[ReferenceTypeIds2["HasContainedComponent"] = 25263] = "HasContainedComponent";
      ReferenceTypeIds2[ReferenceTypeIds2["HasAttachedComponent"] = 25264] = "HasAttachedComponent";
      ReferenceTypeIds2[ReferenceTypeIds2["IsExecutingOn"] = 25265] = "IsExecutingOn";
      ReferenceTypeIds2[ReferenceTypeIds2["HasPushedSecurityGroup"] = 25345] = "HasPushedSecurityGroup";
      ReferenceTypeIds2[ReferenceTypeIds2["AlarmSuppressionGroupMember"] = 32059] = "AlarmSuppressionGroupMember";
      ReferenceTypeIds2[ReferenceTypeIds2["HasKeyValueDescription"] = 32407] = "HasKeyValueDescription";
      ReferenceTypeIds2[ReferenceTypeIds2["HasEngineeringUnitDetails"] = 32558] = "HasEngineeringUnitDetails";
      ReferenceTypeIds2[ReferenceTypeIds2["HasQuantity"] = 32559] = "HasQuantity";
      ReferenceTypeIds2[ReferenceTypeIds2["HasCurrentData"] = 32633] = "HasCurrentData";
      ReferenceTypeIds2[ReferenceTypeIds2["HasCurrentEvent"] = 32634] = "HasCurrentEvent";
      ReferenceTypeIds2[ReferenceTypeIds2["HasReferenceDescription"] = 32679] = "HasReferenceDescription";
    })(ReferenceTypeIds || (exports2.ReferenceTypeIds = ReferenceTypeIds = {}));
    var ObjectTypeIds;
    (function(ObjectTypeIds2) {
      ObjectTypeIds2[ObjectTypeIds2["BaseObjectType"] = 58] = "BaseObjectType";
      ObjectTypeIds2[ObjectTypeIds2["FolderType"] = 61] = "FolderType";
      ObjectTypeIds2[ObjectTypeIds2["DataTypeSystemType"] = 75] = "DataTypeSystemType";
      ObjectTypeIds2[ObjectTypeIds2["DataTypeEncodingType"] = 76] = "DataTypeEncodingType";
      ObjectTypeIds2[ObjectTypeIds2["ModellingRuleType"] = 77] = "ModellingRuleType";
      ObjectTypeIds2[ObjectTypeIds2["ServerType"] = 2004] = "ServerType";
      ObjectTypeIds2[ObjectTypeIds2["ServerCapabilitiesType"] = 2013] = "ServerCapabilitiesType";
      ObjectTypeIds2[ObjectTypeIds2["ServerDiagnosticsType"] = 2020] = "ServerDiagnosticsType";
      ObjectTypeIds2[ObjectTypeIds2["SessionsDiagnosticsSummaryType"] = 2026] = "SessionsDiagnosticsSummaryType";
      ObjectTypeIds2[ObjectTypeIds2["SessionDiagnosticsObjectType"] = 2029] = "SessionDiagnosticsObjectType";
      ObjectTypeIds2[ObjectTypeIds2["VendorServerInfoType"] = 2033] = "VendorServerInfoType";
      ObjectTypeIds2[ObjectTypeIds2["ServerRedundancyType"] = 2034] = "ServerRedundancyType";
      ObjectTypeIds2[ObjectTypeIds2["TransparentRedundancyType"] = 2036] = "TransparentRedundancyType";
      ObjectTypeIds2[ObjectTypeIds2["NonTransparentRedundancyType"] = 2039] = "NonTransparentRedundancyType";
      ObjectTypeIds2[ObjectTypeIds2["BaseEventType"] = 2041] = "BaseEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditEventType"] = 2052] = "AuditEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditSecurityEventType"] = 2058] = "AuditSecurityEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditChannelEventType"] = 2059] = "AuditChannelEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditOpenSecureChannelEventType"] = 2060] = "AuditOpenSecureChannelEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditSessionEventType"] = 2069] = "AuditSessionEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditCreateSessionEventType"] = 2071] = "AuditCreateSessionEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditActivateSessionEventType"] = 2075] = "AuditActivateSessionEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditCancelEventType"] = 2078] = "AuditCancelEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditCertificateEventType"] = 2080] = "AuditCertificateEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditCertificateDataMismatchEventType"] = 2082] = "AuditCertificateDataMismatchEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditCertificateExpiredEventType"] = 2085] = "AuditCertificateExpiredEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditCertificateInvalidEventType"] = 2086] = "AuditCertificateInvalidEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditCertificateUntrustedEventType"] = 2087] = "AuditCertificateUntrustedEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditCertificateRevokedEventType"] = 2088] = "AuditCertificateRevokedEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditCertificateMismatchEventType"] = 2089] = "AuditCertificateMismatchEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditNodeManagementEventType"] = 2090] = "AuditNodeManagementEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditAddNodesEventType"] = 2091] = "AuditAddNodesEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditDeleteNodesEventType"] = 2093] = "AuditDeleteNodesEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditAddReferencesEventType"] = 2095] = "AuditAddReferencesEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditDeleteReferencesEventType"] = 2097] = "AuditDeleteReferencesEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditUpdateEventType"] = 2099] = "AuditUpdateEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditWriteUpdateEventType"] = 2100] = "AuditWriteUpdateEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditHistoryUpdateEventType"] = 2104] = "AuditHistoryUpdateEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditUpdateMethodEventType"] = 2127] = "AuditUpdateMethodEventType";
      ObjectTypeIds2[ObjectTypeIds2["SystemEventType"] = 2130] = "SystemEventType";
      ObjectTypeIds2[ObjectTypeIds2["DeviceFailureEventType"] = 2131] = "DeviceFailureEventType";
      ObjectTypeIds2[ObjectTypeIds2["BaseModelChangeEventType"] = 2132] = "BaseModelChangeEventType";
      ObjectTypeIds2[ObjectTypeIds2["GeneralModelChangeEventType"] = 2133] = "GeneralModelChangeEventType";
      ObjectTypeIds2[ObjectTypeIds2["StateMachineType"] = 2299] = "StateMachineType";
      ObjectTypeIds2[ObjectTypeIds2["StateType"] = 2307] = "StateType";
      ObjectTypeIds2[ObjectTypeIds2["InitialStateType"] = 2309] = "InitialStateType";
      ObjectTypeIds2[ObjectTypeIds2["TransitionType"] = 2310] = "TransitionType";
      ObjectTypeIds2[ObjectTypeIds2["TransitionEventType"] = 2311] = "TransitionEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditUpdateStateEventType"] = 2315] = "AuditUpdateStateEventType";
      ObjectTypeIds2[ObjectTypeIds2["HistoricalDataConfigurationType"] = 2318] = "HistoricalDataConfigurationType";
      ObjectTypeIds2[ObjectTypeIds2["HistoryServerCapabilitiesType"] = 2330] = "HistoryServerCapabilitiesType";
      ObjectTypeIds2[ObjectTypeIds2["AggregateFunctionType"] = 2340] = "AggregateFunctionType";
      ObjectTypeIds2[ObjectTypeIds2["ProgramTransitionEventType"] = 2378] = "ProgramTransitionEventType";
      ObjectTypeIds2[ObjectTypeIds2["ProgramStateMachineType"] = 2391] = "ProgramStateMachineType";
      ObjectTypeIds2[ObjectTypeIds2["SemanticChangeEventType"] = 2738] = "SemanticChangeEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditUrlMismatchEventType"] = 2748] = "AuditUrlMismatchEventType";
      ObjectTypeIds2[ObjectTypeIds2["FiniteStateMachineType"] = 2771] = "FiniteStateMachineType";
      ObjectTypeIds2[ObjectTypeIds2["ConditionType"] = 2782] = "ConditionType";
      ObjectTypeIds2[ObjectTypeIds2["RefreshStartEventType"] = 2787] = "RefreshStartEventType";
      ObjectTypeIds2[ObjectTypeIds2["RefreshEndEventType"] = 2788] = "RefreshEndEventType";
      ObjectTypeIds2[ObjectTypeIds2["RefreshRequiredEventType"] = 2789] = "RefreshRequiredEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditConditionEventType"] = 2790] = "AuditConditionEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditConditionEnableEventType"] = 2803] = "AuditConditionEnableEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditConditionCommentEventType"] = 2829] = "AuditConditionCommentEventType";
      ObjectTypeIds2[ObjectTypeIds2["DialogConditionType"] = 2830] = "DialogConditionType";
      ObjectTypeIds2[ObjectTypeIds2["AcknowledgeableConditionType"] = 2881] = "AcknowledgeableConditionType";
      ObjectTypeIds2[ObjectTypeIds2["AlarmConditionType"] = 2915] = "AlarmConditionType";
      ObjectTypeIds2[ObjectTypeIds2["ShelvedStateMachineType"] = 2929] = "ShelvedStateMachineType";
      ObjectTypeIds2[ObjectTypeIds2["LimitAlarmType"] = 2955] = "LimitAlarmType";
      ObjectTypeIds2[ObjectTypeIds2["AuditHistoryEventUpdateEventType"] = 2999] = "AuditHistoryEventUpdateEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditHistoryValueUpdateEventType"] = 3006] = "AuditHistoryValueUpdateEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditHistoryDeleteEventType"] = 3012] = "AuditHistoryDeleteEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditHistoryRawModifyDeleteEventType"] = 3014] = "AuditHistoryRawModifyDeleteEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditHistoryAtTimeDeleteEventType"] = 3019] = "AuditHistoryAtTimeDeleteEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditHistoryEventDeleteEventType"] = 3022] = "AuditHistoryEventDeleteEventType";
      ObjectTypeIds2[ObjectTypeIds2["EventQueueOverflowEventType"] = 3035] = "EventQueueOverflowEventType";
      ObjectTypeIds2[ObjectTypeIds2["ProgramTransitionAuditEventType"] = 3806] = "ProgramTransitionAuditEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditConditionRespondEventType"] = 8927] = "AuditConditionRespondEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditConditionAcknowledgeEventType"] = 8944] = "AuditConditionAcknowledgeEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditConditionConfirmEventType"] = 8961] = "AuditConditionConfirmEventType";
      ObjectTypeIds2[ObjectTypeIds2["ExclusiveLimitStateMachineType"] = 9318] = "ExclusiveLimitStateMachineType";
      ObjectTypeIds2[ObjectTypeIds2["ExclusiveLimitAlarmType"] = 9341] = "ExclusiveLimitAlarmType";
      ObjectTypeIds2[ObjectTypeIds2["ExclusiveLevelAlarmType"] = 9482] = "ExclusiveLevelAlarmType";
      ObjectTypeIds2[ObjectTypeIds2["ExclusiveRateOfChangeAlarmType"] = 9623] = "ExclusiveRateOfChangeAlarmType";
      ObjectTypeIds2[ObjectTypeIds2["ExclusiveDeviationAlarmType"] = 9764] = "ExclusiveDeviationAlarmType";
      ObjectTypeIds2[ObjectTypeIds2["NonExclusiveLimitAlarmType"] = 9906] = "NonExclusiveLimitAlarmType";
      ObjectTypeIds2[ObjectTypeIds2["NonExclusiveLevelAlarmType"] = 10060] = "NonExclusiveLevelAlarmType";
      ObjectTypeIds2[ObjectTypeIds2["NonExclusiveRateOfChangeAlarmType"] = 10214] = "NonExclusiveRateOfChangeAlarmType";
      ObjectTypeIds2[ObjectTypeIds2["NonExclusiveDeviationAlarmType"] = 10368] = "NonExclusiveDeviationAlarmType";
      ObjectTypeIds2[ObjectTypeIds2["DiscreteAlarmType"] = 10523] = "DiscreteAlarmType";
      ObjectTypeIds2[ObjectTypeIds2["OffNormalAlarmType"] = 10637] = "OffNormalAlarmType";
      ObjectTypeIds2[ObjectTypeIds2["TripAlarmType"] = 10751] = "TripAlarmType";
      ObjectTypeIds2[ObjectTypeIds2["AuditConditionShelvingEventType"] = 11093] = "AuditConditionShelvingEventType";
      ObjectTypeIds2[ObjectTypeIds2["BaseConditionClassType"] = 11163] = "BaseConditionClassType";
      ObjectTypeIds2[ObjectTypeIds2["ProcessConditionClassType"] = 11164] = "ProcessConditionClassType";
      ObjectTypeIds2[ObjectTypeIds2["MaintenanceConditionClassType"] = 11165] = "MaintenanceConditionClassType";
      ObjectTypeIds2[ObjectTypeIds2["SystemConditionClassType"] = 11166] = "SystemConditionClassType";
      ObjectTypeIds2[ObjectTypeIds2["AggregateConfigurationType"] = 11187] = "AggregateConfigurationType";
      ObjectTypeIds2[ObjectTypeIds2["ProgressEventType"] = 11436] = "ProgressEventType";
      ObjectTypeIds2[ObjectTypeIds2["SystemStatusChangeEventType"] = 11446] = "SystemStatusChangeEventType";
      ObjectTypeIds2[ObjectTypeIds2["OperationLimitsType"] = 11564] = "OperationLimitsType";
      ObjectTypeIds2[ObjectTypeIds2["FileType"] = 11575] = "FileType";
      ObjectTypeIds2[ObjectTypeIds2["AddressSpaceFileType"] = 11595] = "AddressSpaceFileType";
      ObjectTypeIds2[ObjectTypeIds2["NamespaceMetadataType"] = 11616] = "NamespaceMetadataType";
      ObjectTypeIds2[ObjectTypeIds2["NamespacesType"] = 11645] = "NamespacesType";
      ObjectTypeIds2[ObjectTypeIds2["SystemOffNormalAlarmType"] = 11753] = "SystemOffNormalAlarmType";
      ObjectTypeIds2[ObjectTypeIds2["AuditProgramTransitionEventType"] = 11856] = "AuditProgramTransitionEventType";
      ObjectTypeIds2[ObjectTypeIds2["NonTransparentNetworkRedundancyType"] = 11945] = "NonTransparentNetworkRedundancyType";
      ObjectTypeIds2[ObjectTypeIds2["TrustListType"] = 12522] = "TrustListType";
      ObjectTypeIds2[ObjectTypeIds2["CertificateGroupType"] = 12555] = "CertificateGroupType";
      ObjectTypeIds2[ObjectTypeIds2["CertificateType"] = 12556] = "CertificateType";
      ObjectTypeIds2[ObjectTypeIds2["ApplicationCertificateType"] = 12557] = "ApplicationCertificateType";
      ObjectTypeIds2[ObjectTypeIds2["HttpsCertificateType"] = 12558] = "HttpsCertificateType";
      ObjectTypeIds2[ObjectTypeIds2["RsaMinApplicationCertificateType"] = 12559] = "RsaMinApplicationCertificateType";
      ObjectTypeIds2[ObjectTypeIds2["RsaSha256ApplicationCertificateType"] = 12560] = "RsaSha256ApplicationCertificateType";
      ObjectTypeIds2[ObjectTypeIds2["TrustListUpdatedAuditEventType"] = 12561] = "TrustListUpdatedAuditEventType";
      ObjectTypeIds2[ObjectTypeIds2["ServerConfigurationType"] = 12581] = "ServerConfigurationType";
      ObjectTypeIds2[ObjectTypeIds2["CertificateUpdatedAuditEventType"] = 12620] = "CertificateUpdatedAuditEventType";
      ObjectTypeIds2[ObjectTypeIds2["CertificateExpirationAlarmType"] = 13225] = "CertificateExpirationAlarmType";
      ObjectTypeIds2[ObjectTypeIds2["FileDirectoryType"] = 13353] = "FileDirectoryType";
      ObjectTypeIds2[ObjectTypeIds2["CertificateGroupFolderType"] = 13813] = "CertificateGroupFolderType";
      ObjectTypeIds2[ObjectTypeIds2["PubSubConnectionType"] = 14209] = "PubSubConnectionType";
      ObjectTypeIds2[ObjectTypeIds2["PubSubGroupType"] = 14232] = "PubSubGroupType";
      ObjectTypeIds2[ObjectTypeIds2["PublishSubscribeType"] = 14416] = "PublishSubscribeType";
      ObjectTypeIds2[ObjectTypeIds2["DataSetFolderType"] = 14477] = "DataSetFolderType";
      ObjectTypeIds2[ObjectTypeIds2["PublishedDataSetType"] = 14509] = "PublishedDataSetType";
      ObjectTypeIds2[ObjectTypeIds2["PublishedDataItemsType"] = 14534] = "PublishedDataItemsType";
      ObjectTypeIds2[ObjectTypeIds2["PublishedEventsType"] = 14572] = "PublishedEventsType";
      ObjectTypeIds2[ObjectTypeIds2["PubSubStatusType"] = 14643] = "PubSubStatusType";
      ObjectTypeIds2[ObjectTypeIds2["AuditConditionResetEventType"] = 15013] = "AuditConditionResetEventType";
      ObjectTypeIds2[ObjectTypeIds2["DatagramConnectionTransportType"] = 15064] = "DatagramConnectionTransportType";
      ObjectTypeIds2[ObjectTypeIds2["SubscribedDataSetType"] = 15108] = "SubscribedDataSetType";
      ObjectTypeIds2[ObjectTypeIds2["ChoiceStateType"] = 15109] = "ChoiceStateType";
      ObjectTypeIds2[ObjectTypeIds2["TargetVariablesType"] = 15111] = "TargetVariablesType";
      ObjectTypeIds2[ObjectTypeIds2["SubscribedDataSetMirrorType"] = 15127] = "SubscribedDataSetMirrorType";
      ObjectTypeIds2[ObjectTypeIds2["BrokerConnectionTransportType"] = 15155] = "BrokerConnectionTransportType";
      ObjectTypeIds2[ObjectTypeIds2["UserCredentialCertificateType"] = 15181] = "UserCredentialCertificateType";
      ObjectTypeIds2[ObjectTypeIds2["DataSetWriterType"] = 15298] = "DataSetWriterType";
      ObjectTypeIds2[ObjectTypeIds2["DataSetWriterTransportType"] = 15305] = "DataSetWriterTransportType";
      ObjectTypeIds2[ObjectTypeIds2["DataSetReaderType"] = 15306] = "DataSetReaderType";
      ObjectTypeIds2[ObjectTypeIds2["DataSetReaderTransportType"] = 15319] = "DataSetReaderTransportType";
      ObjectTypeIds2[ObjectTypeIds2["SecurityGroupFolderType"] = 15452] = "SecurityGroupFolderType";
      ObjectTypeIds2[ObjectTypeIds2["SecurityGroupType"] = 15471] = "SecurityGroupType";
      ObjectTypeIds2[ObjectTypeIds2["ExtensionFieldsType"] = 15489] = "ExtensionFieldsType";
      ObjectTypeIds2[ObjectTypeIds2["PubSubStatusEventType"] = 15535] = "PubSubStatusEventType";
      ObjectTypeIds2[ObjectTypeIds2["PubSubTransportLimitsExceedEventType"] = 15548] = "PubSubTransportLimitsExceedEventType";
      ObjectTypeIds2[ObjectTypeIds2["PubSubCommunicationFailureEventType"] = 15563] = "PubSubCommunicationFailureEventType";
      ObjectTypeIds2[ObjectTypeIds2["RoleSetType"] = 15607] = "RoleSetType";
      ObjectTypeIds2[ObjectTypeIds2["RoleType"] = 15620] = "RoleType";
      ObjectTypeIds2[ObjectTypeIds2["TemporaryFileTransferType"] = 15744] = "TemporaryFileTransferType";
      ObjectTypeIds2[ObjectTypeIds2["FileTransferStateMachineType"] = 15803] = "FileTransferStateMachineType";
      ObjectTypeIds2[ObjectTypeIds2["PubSubKeyServiceType"] = 15906] = "PubSubKeyServiceType";
      ObjectTypeIds2[ObjectTypeIds2["AlarmGroupType"] = 16405] = "AlarmGroupType";
      ObjectTypeIds2[ObjectTypeIds2["DiscrepancyAlarmType"] = 17080] = "DiscrepancyAlarmType";
      ObjectTypeIds2[ObjectTypeIds2["SafetyConditionClassType"] = 17218] = "SafetyConditionClassType";
      ObjectTypeIds2[ObjectTypeIds2["HighlyManagedAlarmConditionClassType"] = 17219] = "HighlyManagedAlarmConditionClassType";
      ObjectTypeIds2[ObjectTypeIds2["TrainingConditionClassType"] = 17220] = "TrainingConditionClassType";
      ObjectTypeIds2[ObjectTypeIds2["TestingConditionClassType"] = 17221] = "TestingConditionClassType";
      ObjectTypeIds2[ObjectTypeIds2["AuditConditionSuppressionEventType"] = 17225] = "AuditConditionSuppressionEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditConditionSilenceEventType"] = 17242] = "AuditConditionSilenceEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditConditionOutOfServiceEventType"] = 17259] = "AuditConditionOutOfServiceEventType";
      ObjectTypeIds2[ObjectTypeIds2["AlarmMetricsType"] = 17279] = "AlarmMetricsType";
      ObjectTypeIds2[ObjectTypeIds2["KeyCredentialConfigurationFolderType"] = 17496] = "KeyCredentialConfigurationFolderType";
      ObjectTypeIds2[ObjectTypeIds2["DictionaryEntryType"] = 17589] = "DictionaryEntryType";
      ObjectTypeIds2[ObjectTypeIds2["DictionaryFolderType"] = 17591] = "DictionaryFolderType";
      ObjectTypeIds2[ObjectTypeIds2["IrdiDictionaryEntryType"] = 17598] = "IrdiDictionaryEntryType";
      ObjectTypeIds2[ObjectTypeIds2["UriDictionaryEntryType"] = 17600] = "UriDictionaryEntryType";
      ObjectTypeIds2[ObjectTypeIds2["BaseInterfaceType"] = 17602] = "BaseInterfaceType";
      ObjectTypeIds2[ObjectTypeIds2["RoleMappingRuleChangedAuditEventType"] = 17641] = "RoleMappingRuleChangedAuditEventType";
      ObjectTypeIds2[ObjectTypeIds2["ConnectionTransportType"] = 17721] = "ConnectionTransportType";
      ObjectTypeIds2[ObjectTypeIds2["WriterGroupType"] = 17725] = "WriterGroupType";
      ObjectTypeIds2[ObjectTypeIds2["AuthorizationServiceConfigurationType"] = 17852] = "AuthorizationServiceConfigurationType";
      ObjectTypeIds2[ObjectTypeIds2["WriterGroupTransportType"] = 17997] = "WriterGroupTransportType";
      ObjectTypeIds2[ObjectTypeIds2["WriterGroupMessageType"] = 17998] = "WriterGroupMessageType";
      ObjectTypeIds2[ObjectTypeIds2["ReaderGroupType"] = 17999] = "ReaderGroupType";
      ObjectTypeIds2[ObjectTypeIds2["KeyCredentialConfigurationType"] = 18001] = "KeyCredentialConfigurationType";
      ObjectTypeIds2[ObjectTypeIds2["KeyCredentialAuditEventType"] = 18011] = "KeyCredentialAuditEventType";
      ObjectTypeIds2[ObjectTypeIds2["KeyCredentialUpdatedAuditEventType"] = 18029] = "KeyCredentialUpdatedAuditEventType";
      ObjectTypeIds2[ObjectTypeIds2["KeyCredentialDeletedAuditEventType"] = 18047] = "KeyCredentialDeletedAuditEventType";
      ObjectTypeIds2[ObjectTypeIds2["InstrumentDiagnosticAlarmType"] = 18347] = "InstrumentDiagnosticAlarmType";
      ObjectTypeIds2[ObjectTypeIds2["SystemDiagnosticAlarmType"] = 18496] = "SystemDiagnosticAlarmType";
      ObjectTypeIds2[ObjectTypeIds2["StatisticalConditionClassType"] = 18665] = "StatisticalConditionClassType";
      ObjectTypeIds2[ObjectTypeIds2["AuditHistoryAnnotationUpdateEventType"] = 19095] = "AuditHistoryAnnotationUpdateEventType";
      ObjectTypeIds2[ObjectTypeIds2["TrustListOutOfDateAlarmType"] = 19297] = "TrustListOutOfDateAlarmType";
      ObjectTypeIds2[ObjectTypeIds2["PubSubDiagnosticsType"] = 19677] = "PubSubDiagnosticsType";
      ObjectTypeIds2[ObjectTypeIds2["PubSubDiagnosticsRootType"] = 19732] = "PubSubDiagnosticsRootType";
      ObjectTypeIds2[ObjectTypeIds2["PubSubDiagnosticsConnectionType"] = 19786] = "PubSubDiagnosticsConnectionType";
      ObjectTypeIds2[ObjectTypeIds2["PubSubDiagnosticsWriterGroupType"] = 19834] = "PubSubDiagnosticsWriterGroupType";
      ObjectTypeIds2[ObjectTypeIds2["PubSubDiagnosticsReaderGroupType"] = 19903] = "PubSubDiagnosticsReaderGroupType";
      ObjectTypeIds2[ObjectTypeIds2["PubSubDiagnosticsDataSetWriterType"] = 19968] = "PubSubDiagnosticsDataSetWriterType";
      ObjectTypeIds2[ObjectTypeIds2["PubSubDiagnosticsDataSetReaderType"] = 20027] = "PubSubDiagnosticsDataSetReaderType";
      ObjectTypeIds2[ObjectTypeIds2["ReaderGroupTransportType"] = 21090] = "ReaderGroupTransportType";
      ObjectTypeIds2[ObjectTypeIds2["ReaderGroupMessageType"] = 21091] = "ReaderGroupMessageType";
      ObjectTypeIds2[ObjectTypeIds2["DataSetWriterMessageType"] = 21096] = "DataSetWriterMessageType";
      ObjectTypeIds2[ObjectTypeIds2["DataSetReaderMessageType"] = 21104] = "DataSetReaderMessageType";
      ObjectTypeIds2[ObjectTypeIds2["UadpWriterGroupMessageType"] = 21105] = "UadpWriterGroupMessageType";
      ObjectTypeIds2[ObjectTypeIds2["UadpDataSetWriterMessageType"] = 21111] = "UadpDataSetWriterMessageType";
      ObjectTypeIds2[ObjectTypeIds2["UadpDataSetReaderMessageType"] = 21116] = "UadpDataSetReaderMessageType";
      ObjectTypeIds2[ObjectTypeIds2["JsonWriterGroupMessageType"] = 21126] = "JsonWriterGroupMessageType";
      ObjectTypeIds2[ObjectTypeIds2["JsonDataSetWriterMessageType"] = 21128] = "JsonDataSetWriterMessageType";
      ObjectTypeIds2[ObjectTypeIds2["JsonDataSetReaderMessageType"] = 21130] = "JsonDataSetReaderMessageType";
      ObjectTypeIds2[ObjectTypeIds2["DatagramWriterGroupTransportType"] = 21133] = "DatagramWriterGroupTransportType";
      ObjectTypeIds2[ObjectTypeIds2["BrokerWriterGroupTransportType"] = 21136] = "BrokerWriterGroupTransportType";
      ObjectTypeIds2[ObjectTypeIds2["BrokerDataSetWriterTransportType"] = 21138] = "BrokerDataSetWriterTransportType";
      ObjectTypeIds2[ObjectTypeIds2["BrokerDataSetReaderTransportType"] = 21142] = "BrokerDataSetReaderTransportType";
      ObjectTypeIds2[ObjectTypeIds2["NetworkAddressType"] = 21145] = "NetworkAddressType";
      ObjectTypeIds2[ObjectTypeIds2["NetworkAddressUrlType"] = 21147] = "NetworkAddressUrlType";
      ObjectTypeIds2[ObjectTypeIds2["AliasNameType"] = 23455] = "AliasNameType";
      ObjectTypeIds2[ObjectTypeIds2["AliasNameCategoryType"] = 23456] = "AliasNameCategoryType";
      ObjectTypeIds2[ObjectTypeIds2["IOrderedObjectType"] = 23513] = "IOrderedObjectType";
      ObjectTypeIds2[ObjectTypeIds2["OrderedListType"] = 23518] = "OrderedListType";
      ObjectTypeIds2[ObjectTypeIds2["EccApplicationCertificateType"] = 23537] = "EccApplicationCertificateType";
      ObjectTypeIds2[ObjectTypeIds2["EccNistP256ApplicationCertificateType"] = 23538] = "EccNistP256ApplicationCertificateType";
      ObjectTypeIds2[ObjectTypeIds2["EccNistP384ApplicationCertificateType"] = 23539] = "EccNistP384ApplicationCertificateType";
      ObjectTypeIds2[ObjectTypeIds2["EccBrainpoolP256r1ApplicationCertificateType"] = 23540] = "EccBrainpoolP256r1ApplicationCertificateType";
      ObjectTypeIds2[ObjectTypeIds2["EccBrainpoolP384r1ApplicationCertificateType"] = 23541] = "EccBrainpoolP384r1ApplicationCertificateType";
      ObjectTypeIds2[ObjectTypeIds2["EccCurve25519ApplicationCertificateType"] = 23542] = "EccCurve25519ApplicationCertificateType";
      ObjectTypeIds2[ObjectTypeIds2["EccCurve448ApplicationCertificateType"] = 23543] = "EccCurve448ApplicationCertificateType";
      ObjectTypeIds2[ObjectTypeIds2["AuthorizationServicesConfigurationFolderType"] = 23556] = "AuthorizationServicesConfigurationFolderType";
      ObjectTypeIds2[ObjectTypeIds2["AuditClientEventType"] = 23606] = "AuditClientEventType";
      ObjectTypeIds2[ObjectTypeIds2["SubscribedDataSetFolderType"] = 23795] = "SubscribedDataSetFolderType";
      ObjectTypeIds2[ObjectTypeIds2["StandaloneSubscribedDataSetType"] = 23828] = "StandaloneSubscribedDataSetType";
      ObjectTypeIds2[ObjectTypeIds2["PubSubCapabilitiesType"] = 23832] = "PubSubCapabilitiesType";
      ObjectTypeIds2[ObjectTypeIds2["AuditClientUpdateMethodResultEventType"] = 23926] = "AuditClientUpdateMethodResultEventType";
      ObjectTypeIds2[ObjectTypeIds2["DatagramDataSetReaderTransportType"] = 24016] = "DatagramDataSetReaderTransportType";
      ObjectTypeIds2[ObjectTypeIds2["IIetfBaseNetworkInterfaceType"] = 24148] = "IIetfBaseNetworkInterfaceType";
      ObjectTypeIds2[ObjectTypeIds2["IIeeeBaseEthernetPortType"] = 24158] = "IIeeeBaseEthernetPortType";
      ObjectTypeIds2[ObjectTypeIds2["IBaseEthernetCapabilitiesType"] = 24167] = "IBaseEthernetCapabilitiesType";
      ObjectTypeIds2[ObjectTypeIds2["ISrClassType"] = 24169] = "ISrClassType";
      ObjectTypeIds2[ObjectTypeIds2["IIeeeBaseTsnStreamType"] = 24173] = "IIeeeBaseTsnStreamType";
      ObjectTypeIds2[ObjectTypeIds2["IIeeeBaseTsnTrafficSpecificationType"] = 24179] = "IIeeeBaseTsnTrafficSpecificationType";
      ObjectTypeIds2[ObjectTypeIds2["IIeeeBaseTsnStatusStreamType"] = 24183] = "IIeeeBaseTsnStatusStreamType";
      ObjectTypeIds2[ObjectTypeIds2["IIeeeTsnInterfaceConfigurationType"] = 24188] = "IIeeeTsnInterfaceConfigurationType";
      ObjectTypeIds2[ObjectTypeIds2["IIeeeTsnInterfaceConfigurationTalkerType"] = 24191] = "IIeeeTsnInterfaceConfigurationTalkerType";
      ObjectTypeIds2[ObjectTypeIds2["IIeeeTsnInterfaceConfigurationListenerType"] = 24195] = "IIeeeTsnInterfaceConfigurationListenerType";
      ObjectTypeIds2[ObjectTypeIds2["IIeeeTsnMacAddressType"] = 24199] = "IIeeeTsnMacAddressType";
      ObjectTypeIds2[ObjectTypeIds2["IIeeeTsnVlanTagType"] = 24202] = "IIeeeTsnVlanTagType";
      ObjectTypeIds2[ObjectTypeIds2["IPriorityMappingEntryType"] = 24205] = "IPriorityMappingEntryType";
      ObjectTypeIds2[ObjectTypeIds2["IIeeeAutoNegotiationStatusType"] = 24233] = "IIeeeAutoNegotiationStatusType";
      ObjectTypeIds2[ObjectTypeIds2["UserManagementType"] = 24264] = "UserManagementType";
      ObjectTypeIds2[ObjectTypeIds2["IVlanIdType"] = 25218] = "IVlanIdType";
      ObjectTypeIds2[ObjectTypeIds2["IetfBaseNetworkInterfaceType"] = 25221] = "IetfBaseNetworkInterfaceType";
      ObjectTypeIds2[ObjectTypeIds2["PriorityMappingTableType"] = 25227] = "PriorityMappingTableType";
      ObjectTypeIds2[ObjectTypeIds2["PubSubKeyPushTargetType"] = 25337] = "PubSubKeyPushTargetType";
      ObjectTypeIds2[ObjectTypeIds2["PubSubKeyPushTargetFolderType"] = 25346] = "PubSubKeyPushTargetFolderType";
      ObjectTypeIds2[ObjectTypeIds2["PubSubConfigurationType"] = 25482] = "PubSubConfigurationType";
      ObjectTypeIds2[ObjectTypeIds2["ApplicationConfigurationType"] = 25731] = "ApplicationConfigurationType";
      ObjectTypeIds2[ObjectTypeIds2["ProvisionableDeviceType"] = 26871] = "ProvisionableDeviceType";
      ObjectTypeIds2[ObjectTypeIds2["AlarmSuppressionGroupType"] = 32064] = "AlarmSuppressionGroupType";
      ObjectTypeIds2[ObjectTypeIds2["TrustListUpdateRequestedAuditEventType"] = 32260] = "TrustListUpdateRequestedAuditEventType";
      ObjectTypeIds2[ObjectTypeIds2["TransactionDiagnosticsType"] = 32286] = "TransactionDiagnosticsType";
      ObjectTypeIds2[ObjectTypeIds2["CertificateUpdateRequestedAuditEventType"] = 32306] = "CertificateUpdateRequestedAuditEventType";
      ObjectTypeIds2[ObjectTypeIds2["NonTransparentBackupRedundancyType"] = 32411] = "NonTransparentBackupRedundancyType";
      ObjectTypeIds2[ObjectTypeIds2["SyntaxReferenceEntryType"] = 32439] = "SyntaxReferenceEntryType";
      ObjectTypeIds2[ObjectTypeIds2["UnitType"] = 32442] = "UnitType";
      ObjectTypeIds2[ObjectTypeIds2["ServerUnitType"] = 32447] = "ServerUnitType";
      ObjectTypeIds2[ObjectTypeIds2["AlternativeUnitType"] = 32467] = "AlternativeUnitType";
      ObjectTypeIds2[ObjectTypeIds2["QuantityType"] = 32475] = "QuantityType";
      ObjectTypeIds2[ObjectTypeIds2["QuantitiesFolderType"] = 32502] = "QuantitiesFolderType";
      ObjectTypeIds2[ObjectTypeIds2["HistoricalEventConfigurationType"] = 32621] = "HistoricalEventConfigurationType";
      ObjectTypeIds2[ObjectTypeIds2["HistoricalExternalEventSourceType"] = 32625] = "HistoricalExternalEventSourceType";
      ObjectTypeIds2[ObjectTypeIds2["AuditHistoryConfigurationChangeEventType"] = 32758] = "AuditHistoryConfigurationChangeEventType";
      ObjectTypeIds2[ObjectTypeIds2["AuditHistoryBulkInsertEventType"] = 32803] = "AuditHistoryBulkInsertEventType";
    })(ObjectTypeIds || (exports2.ObjectTypeIds = ObjectTypeIds = {}));
    var VariableTypeIds;
    (function(VariableTypeIds2) {
      VariableTypeIds2[VariableTypeIds2["BaseVariableType"] = 62] = "BaseVariableType";
      VariableTypeIds2[VariableTypeIds2["BaseDataVariableType"] = 63] = "BaseDataVariableType";
      VariableTypeIds2[VariableTypeIds2["PropertyType"] = 68] = "PropertyType";
      VariableTypeIds2[VariableTypeIds2["DataTypeDescriptionType"] = 69] = "DataTypeDescriptionType";
      VariableTypeIds2[VariableTypeIds2["DataTypeDictionaryType"] = 72] = "DataTypeDictionaryType";
      VariableTypeIds2[VariableTypeIds2["ServerVendorCapabilityType"] = 2137] = "ServerVendorCapabilityType";
      VariableTypeIds2[VariableTypeIds2["ServerStatusType"] = 2138] = "ServerStatusType";
      VariableTypeIds2[VariableTypeIds2["ServerDiagnosticsSummaryType"] = 2150] = "ServerDiagnosticsSummaryType";
      VariableTypeIds2[VariableTypeIds2["SamplingIntervalDiagnosticsArrayType"] = 2164] = "SamplingIntervalDiagnosticsArrayType";
      VariableTypeIds2[VariableTypeIds2["SamplingIntervalDiagnosticsType"] = 2165] = "SamplingIntervalDiagnosticsType";
      VariableTypeIds2[VariableTypeIds2["SubscriptionDiagnosticsArrayType"] = 2171] = "SubscriptionDiagnosticsArrayType";
      VariableTypeIds2[VariableTypeIds2["SubscriptionDiagnosticsType"] = 2172] = "SubscriptionDiagnosticsType";
      VariableTypeIds2[VariableTypeIds2["SessionDiagnosticsArrayType"] = 2196] = "SessionDiagnosticsArrayType";
      VariableTypeIds2[VariableTypeIds2["SessionDiagnosticsVariableType"] = 2197] = "SessionDiagnosticsVariableType";
      VariableTypeIds2[VariableTypeIds2["SessionSecurityDiagnosticsArrayType"] = 2243] = "SessionSecurityDiagnosticsArrayType";
      VariableTypeIds2[VariableTypeIds2["SessionSecurityDiagnosticsType"] = 2244] = "SessionSecurityDiagnosticsType";
      VariableTypeIds2[VariableTypeIds2["DataItemType"] = 2365] = "DataItemType";
      VariableTypeIds2[VariableTypeIds2["AnalogItemType"] = 2368] = "AnalogItemType";
      VariableTypeIds2[VariableTypeIds2["DiscreteItemType"] = 2372] = "DiscreteItemType";
      VariableTypeIds2[VariableTypeIds2["TwoStateDiscreteType"] = 2373] = "TwoStateDiscreteType";
      VariableTypeIds2[VariableTypeIds2["MultiStateDiscreteType"] = 2376] = "MultiStateDiscreteType";
      VariableTypeIds2[VariableTypeIds2["ProgramDiagnosticType"] = 2380] = "ProgramDiagnosticType";
      VariableTypeIds2[VariableTypeIds2["StateVariableType"] = 2755] = "StateVariableType";
      VariableTypeIds2[VariableTypeIds2["FiniteStateVariableType"] = 2760] = "FiniteStateVariableType";
      VariableTypeIds2[VariableTypeIds2["TransitionVariableType"] = 2762] = "TransitionVariableType";
      VariableTypeIds2[VariableTypeIds2["FiniteTransitionVariableType"] = 2767] = "FiniteTransitionVariableType";
      VariableTypeIds2[VariableTypeIds2["BuildInfoType"] = 3051] = "BuildInfoType";
      VariableTypeIds2[VariableTypeIds2["TwoStateVariableType"] = 8995] = "TwoStateVariableType";
      VariableTypeIds2[VariableTypeIds2["ConditionVariableType"] = 9002] = "ConditionVariableType";
      VariableTypeIds2[VariableTypeIds2["MultiStateValueDiscreteType"] = 11238] = "MultiStateValueDiscreteType";
      VariableTypeIds2[VariableTypeIds2["OptionSetType"] = 11487] = "OptionSetType";
      VariableTypeIds2[VariableTypeIds2["ArrayItemType"] = 12021] = "ArrayItemType";
      VariableTypeIds2[VariableTypeIds2["YArrayItemType"] = 12029] = "YArrayItemType";
      VariableTypeIds2[VariableTypeIds2["XYArrayItemType"] = 12038] = "XYArrayItemType";
      VariableTypeIds2[VariableTypeIds2["ImageItemType"] = 12047] = "ImageItemType";
      VariableTypeIds2[VariableTypeIds2["CubeItemType"] = 12057] = "CubeItemType";
      VariableTypeIds2[VariableTypeIds2["NDimensionArrayItemType"] = 12068] = "NDimensionArrayItemType";
      VariableTypeIds2[VariableTypeIds2["GuardVariableType"] = 15113] = "GuardVariableType";
      VariableTypeIds2[VariableTypeIds2["ExpressionGuardVariableType"] = 15128] = "ExpressionGuardVariableType";
      VariableTypeIds2[VariableTypeIds2["ElseGuardVariableType"] = 15317] = "ElseGuardVariableType";
      VariableTypeIds2[VariableTypeIds2["BaseAnalogType"] = 15318] = "BaseAnalogType";
      VariableTypeIds2[VariableTypeIds2["ProgramDiagnostic2Type"] = 15383] = "ProgramDiagnostic2Type";
      VariableTypeIds2[VariableTypeIds2["SelectionListType"] = 16309] = "SelectionListType";
      VariableTypeIds2[VariableTypeIds2["AlarmRateVariableType"] = 17277] = "AlarmRateVariableType";
      VariableTypeIds2[VariableTypeIds2["AnalogUnitType"] = 17497] = "AnalogUnitType";
      VariableTypeIds2[VariableTypeIds2["AnalogUnitRangeType"] = 17570] = "AnalogUnitRangeType";
      VariableTypeIds2[VariableTypeIds2["RationalNumberType"] = 17709] = "RationalNumberType";
      VariableTypeIds2[VariableTypeIds2["VectorType"] = 17714] = "VectorType";
      VariableTypeIds2[VariableTypeIds2["ThreeDVectorType"] = 17716] = "ThreeDVectorType";
      VariableTypeIds2[VariableTypeIds2["AudioVariableType"] = 17986] = "AudioVariableType";
      VariableTypeIds2[VariableTypeIds2["CartesianCoordinatesType"] = 18772] = "CartesianCoordinatesType";
      VariableTypeIds2[VariableTypeIds2["ThreeDCartesianCoordinatesType"] = 18774] = "ThreeDCartesianCoordinatesType";
      VariableTypeIds2[VariableTypeIds2["OrientationType"] = 18779] = "OrientationType";
      VariableTypeIds2[VariableTypeIds2["ThreeDOrientationType"] = 18781] = "ThreeDOrientationType";
      VariableTypeIds2[VariableTypeIds2["FrameType"] = 18786] = "FrameType";
      VariableTypeIds2[VariableTypeIds2["ThreeDFrameType"] = 18791] = "ThreeDFrameType";
      VariableTypeIds2[VariableTypeIds2["MultiStateDictionaryEntryDiscreteBaseType"] = 19077] = "MultiStateDictionaryEntryDiscreteBaseType";
      VariableTypeIds2[VariableTypeIds2["MultiStateDictionaryEntryDiscreteType"] = 19084] = "MultiStateDictionaryEntryDiscreteType";
      VariableTypeIds2[VariableTypeIds2["PubSubDiagnosticsCounterType"] = 19725] = "PubSubDiagnosticsCounterType";
      VariableTypeIds2[VariableTypeIds2["AlarmStateVariableType"] = 32244] = "AlarmStateVariableType";
      VariableTypeIds2[VariableTypeIds2["BitFieldType"] = 32431] = "BitFieldType";
      VariableTypeIds2[VariableTypeIds2["ReferenceDescriptionVariableType"] = 32657] = "ReferenceDescriptionVariableType";
    })(VariableTypeIds || (exports2.VariableTypeIds = VariableTypeIds = {}));
    var ObjectIds;
    (function(ObjectIds2) {
      ObjectIds2[ObjectIds2["ModellingRule_Mandatory"] = 78] = "ModellingRule_Mandatory";
      ObjectIds2[ObjectIds2["ModellingRule_Optional"] = 80] = "ModellingRule_Optional";
      ObjectIds2[ObjectIds2["ModellingRule_ExposesItsArray"] = 83] = "ModellingRule_ExposesItsArray";
      ObjectIds2[ObjectIds2["RootFolder"] = 84] = "RootFolder";
      ObjectIds2[ObjectIds2["ObjectsFolder"] = 85] = "ObjectsFolder";
      ObjectIds2[ObjectIds2["TypesFolder"] = 86] = "TypesFolder";
      ObjectIds2[ObjectIds2["ViewsFolder"] = 87] = "ViewsFolder";
      ObjectIds2[ObjectIds2["ObjectTypesFolder"] = 88] = "ObjectTypesFolder";
      ObjectIds2[ObjectIds2["VariableTypesFolder"] = 89] = "VariableTypesFolder";
      ObjectIds2[ObjectIds2["DataTypesFolder"] = 90] = "DataTypesFolder";
      ObjectIds2[ObjectIds2["ReferenceTypesFolder"] = 91] = "ReferenceTypesFolder";
      ObjectIds2[ObjectIds2["XmlSchema_TypeSystem"] = 92] = "XmlSchema_TypeSystem";
      ObjectIds2[ObjectIds2["OPCBinarySchema_TypeSystem"] = 93] = "OPCBinarySchema_TypeSystem";
      ObjectIds2[ObjectIds2["DataTypeDefinition_Encoding_DefaultBinary"] = 121] = "DataTypeDefinition_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["StructureDefinition_Encoding_DefaultBinary"] = 122] = "StructureDefinition_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["EnumDefinition_Encoding_DefaultBinary"] = 123] = "EnumDefinition_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DataSetMetaDataType_Encoding_DefaultBinary"] = 124] = "DataSetMetaDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DataTypeDescription_Encoding_DefaultBinary"] = 125] = "DataTypeDescription_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["StructureDescription_Encoding_DefaultBinary"] = 126] = "StructureDescription_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["EnumDescription_Encoding_DefaultBinary"] = 127] = "EnumDescription_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["RolePermissionType_Encoding_DefaultBinary"] = 128] = "RolePermissionType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["Node_Encoding_DefaultXml"] = 259] = "Node_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["Node_Encoding_DefaultBinary"] = 260] = "Node_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ObjectNode_Encoding_DefaultXml"] = 262] = "ObjectNode_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ObjectNode_Encoding_DefaultBinary"] = 263] = "ObjectNode_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ObjectTypeNode_Encoding_DefaultXml"] = 265] = "ObjectTypeNode_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ObjectTypeNode_Encoding_DefaultBinary"] = 266] = "ObjectTypeNode_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["VariableNode_Encoding_DefaultXml"] = 268] = "VariableNode_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["VariableNode_Encoding_DefaultBinary"] = 269] = "VariableNode_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["VariableTypeNode_Encoding_DefaultXml"] = 271] = "VariableTypeNode_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["VariableTypeNode_Encoding_DefaultBinary"] = 272] = "VariableTypeNode_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ReferenceTypeNode_Encoding_DefaultXml"] = 274] = "ReferenceTypeNode_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ReferenceTypeNode_Encoding_DefaultBinary"] = 275] = "ReferenceTypeNode_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["MethodNode_Encoding_DefaultXml"] = 277] = "MethodNode_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["MethodNode_Encoding_DefaultBinary"] = 278] = "MethodNode_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ViewNode_Encoding_DefaultXml"] = 280] = "ViewNode_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ViewNode_Encoding_DefaultBinary"] = 281] = "ViewNode_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DataTypeNode_Encoding_DefaultXml"] = 283] = "DataTypeNode_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DataTypeNode_Encoding_DefaultBinary"] = 284] = "DataTypeNode_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ReferenceNode_Encoding_DefaultXml"] = 286] = "ReferenceNode_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ReferenceNode_Encoding_DefaultBinary"] = 287] = "ReferenceNode_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["Argument_Encoding_DefaultXml"] = 297] = "Argument_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["Argument_Encoding_DefaultBinary"] = 298] = "Argument_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["StatusResult_Encoding_DefaultXml"] = 300] = "StatusResult_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["StatusResult_Encoding_DefaultBinary"] = 301] = "StatusResult_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["UserTokenPolicy_Encoding_DefaultXml"] = 305] = "UserTokenPolicy_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["UserTokenPolicy_Encoding_DefaultBinary"] = 306] = "UserTokenPolicy_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ApplicationDescription_Encoding_DefaultXml"] = 309] = "ApplicationDescription_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ApplicationDescription_Encoding_DefaultBinary"] = 310] = "ApplicationDescription_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["EndpointDescription_Encoding_DefaultXml"] = 313] = "EndpointDescription_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["EndpointDescription_Encoding_DefaultBinary"] = 314] = "EndpointDescription_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["UserIdentityToken_Encoding_DefaultXml"] = 317] = "UserIdentityToken_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["UserIdentityToken_Encoding_DefaultBinary"] = 318] = "UserIdentityToken_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["AnonymousIdentityToken_Encoding_DefaultXml"] = 320] = "AnonymousIdentityToken_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["AnonymousIdentityToken_Encoding_DefaultBinary"] = 321] = "AnonymousIdentityToken_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["UserNameIdentityToken_Encoding_DefaultXml"] = 323] = "UserNameIdentityToken_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["UserNameIdentityToken_Encoding_DefaultBinary"] = 324] = "UserNameIdentityToken_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["X509IdentityToken_Encoding_DefaultXml"] = 326] = "X509IdentityToken_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["X509IdentityToken_Encoding_DefaultBinary"] = 327] = "X509IdentityToken_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["EndpointConfiguration_Encoding_DefaultXml"] = 332] = "EndpointConfiguration_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["EndpointConfiguration_Encoding_DefaultBinary"] = 333] = "EndpointConfiguration_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["BuildInfo_Encoding_DefaultXml"] = 339] = "BuildInfo_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["BuildInfo_Encoding_DefaultBinary"] = 340] = "BuildInfo_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["SignedSoftwareCertificate_Encoding_DefaultXml"] = 345] = "SignedSoftwareCertificate_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["SignedSoftwareCertificate_Encoding_DefaultBinary"] = 346] = "SignedSoftwareCertificate_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["NodeAttributes_Encoding_DefaultXml"] = 350] = "NodeAttributes_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["NodeAttributes_Encoding_DefaultBinary"] = 351] = "NodeAttributes_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ObjectAttributes_Encoding_DefaultXml"] = 353] = "ObjectAttributes_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ObjectAttributes_Encoding_DefaultBinary"] = 354] = "ObjectAttributes_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["VariableAttributes_Encoding_DefaultXml"] = 356] = "VariableAttributes_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["VariableAttributes_Encoding_DefaultBinary"] = 357] = "VariableAttributes_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["MethodAttributes_Encoding_DefaultXml"] = 359] = "MethodAttributes_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["MethodAttributes_Encoding_DefaultBinary"] = 360] = "MethodAttributes_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ObjectTypeAttributes_Encoding_DefaultXml"] = 362] = "ObjectTypeAttributes_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ObjectTypeAttributes_Encoding_DefaultBinary"] = 363] = "ObjectTypeAttributes_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["VariableTypeAttributes_Encoding_DefaultXml"] = 365] = "VariableTypeAttributes_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["VariableTypeAttributes_Encoding_DefaultBinary"] = 366] = "VariableTypeAttributes_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ReferenceTypeAttributes_Encoding_DefaultXml"] = 368] = "ReferenceTypeAttributes_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ReferenceTypeAttributes_Encoding_DefaultBinary"] = 369] = "ReferenceTypeAttributes_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DataTypeAttributes_Encoding_DefaultXml"] = 371] = "DataTypeAttributes_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DataTypeAttributes_Encoding_DefaultBinary"] = 372] = "DataTypeAttributes_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ViewAttributes_Encoding_DefaultXml"] = 374] = "ViewAttributes_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ViewAttributes_Encoding_DefaultBinary"] = 375] = "ViewAttributes_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["AddNodesItem_Encoding_DefaultXml"] = 377] = "AddNodesItem_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["AddNodesItem_Encoding_DefaultBinary"] = 378] = "AddNodesItem_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["AddReferencesItem_Encoding_DefaultXml"] = 380] = "AddReferencesItem_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["AddReferencesItem_Encoding_DefaultBinary"] = 381] = "AddReferencesItem_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DeleteNodesItem_Encoding_DefaultXml"] = 383] = "DeleteNodesItem_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DeleteNodesItem_Encoding_DefaultBinary"] = 384] = "DeleteNodesItem_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DeleteReferencesItem_Encoding_DefaultXml"] = 386] = "DeleteReferencesItem_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DeleteReferencesItem_Encoding_DefaultBinary"] = 387] = "DeleteReferencesItem_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["RequestHeader_Encoding_DefaultXml"] = 390] = "RequestHeader_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["RequestHeader_Encoding_DefaultBinary"] = 391] = "RequestHeader_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ResponseHeader_Encoding_DefaultXml"] = 393] = "ResponseHeader_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ResponseHeader_Encoding_DefaultBinary"] = 394] = "ResponseHeader_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ServiceFault_Encoding_DefaultXml"] = 396] = "ServiceFault_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ServiceFault_Encoding_DefaultBinary"] = 397] = "ServiceFault_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["FindServersRequest_Encoding_DefaultXml"] = 421] = "FindServersRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["FindServersRequest_Encoding_DefaultBinary"] = 422] = "FindServersRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["FindServersResponse_Encoding_DefaultXml"] = 424] = "FindServersResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["FindServersResponse_Encoding_DefaultBinary"] = 425] = "FindServersResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["GetEndpointsRequest_Encoding_DefaultXml"] = 427] = "GetEndpointsRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["GetEndpointsRequest_Encoding_DefaultBinary"] = 428] = "GetEndpointsRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["GetEndpointsResponse_Encoding_DefaultXml"] = 430] = "GetEndpointsResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["GetEndpointsResponse_Encoding_DefaultBinary"] = 431] = "GetEndpointsResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["RegisteredServer_Encoding_DefaultXml"] = 433] = "RegisteredServer_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["RegisteredServer_Encoding_DefaultBinary"] = 434] = "RegisteredServer_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["RegisterServerRequest_Encoding_DefaultXml"] = 436] = "RegisterServerRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["RegisterServerRequest_Encoding_DefaultBinary"] = 437] = "RegisterServerRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["RegisterServerResponse_Encoding_DefaultXml"] = 439] = "RegisterServerResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["RegisterServerResponse_Encoding_DefaultBinary"] = 440] = "RegisterServerResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ChannelSecurityToken_Encoding_DefaultXml"] = 442] = "ChannelSecurityToken_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ChannelSecurityToken_Encoding_DefaultBinary"] = 443] = "ChannelSecurityToken_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["OpenSecureChannelRequest_Encoding_DefaultXml"] = 445] = "OpenSecureChannelRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["OpenSecureChannelRequest_Encoding_DefaultBinary"] = 446] = "OpenSecureChannelRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["OpenSecureChannelResponse_Encoding_DefaultXml"] = 448] = "OpenSecureChannelResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["OpenSecureChannelResponse_Encoding_DefaultBinary"] = 449] = "OpenSecureChannelResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["CloseSecureChannelRequest_Encoding_DefaultXml"] = 451] = "CloseSecureChannelRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["CloseSecureChannelRequest_Encoding_DefaultBinary"] = 452] = "CloseSecureChannelRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["CloseSecureChannelResponse_Encoding_DefaultXml"] = 454] = "CloseSecureChannelResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["CloseSecureChannelResponse_Encoding_DefaultBinary"] = 455] = "CloseSecureChannelResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["SignatureData_Encoding_DefaultXml"] = 457] = "SignatureData_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["SignatureData_Encoding_DefaultBinary"] = 458] = "SignatureData_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["CreateSessionRequest_Encoding_DefaultXml"] = 460] = "CreateSessionRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["CreateSessionRequest_Encoding_DefaultBinary"] = 461] = "CreateSessionRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["CreateSessionResponse_Encoding_DefaultXml"] = 463] = "CreateSessionResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["CreateSessionResponse_Encoding_DefaultBinary"] = 464] = "CreateSessionResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ActivateSessionRequest_Encoding_DefaultXml"] = 466] = "ActivateSessionRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ActivateSessionRequest_Encoding_DefaultBinary"] = 467] = "ActivateSessionRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ActivateSessionResponse_Encoding_DefaultXml"] = 469] = "ActivateSessionResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ActivateSessionResponse_Encoding_DefaultBinary"] = 470] = "ActivateSessionResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["CloseSessionRequest_Encoding_DefaultXml"] = 472] = "CloseSessionRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["CloseSessionRequest_Encoding_DefaultBinary"] = 473] = "CloseSessionRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["CloseSessionResponse_Encoding_DefaultXml"] = 475] = "CloseSessionResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["CloseSessionResponse_Encoding_DefaultBinary"] = 476] = "CloseSessionResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["CancelRequest_Encoding_DefaultXml"] = 478] = "CancelRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["CancelRequest_Encoding_DefaultBinary"] = 479] = "CancelRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["CancelResponse_Encoding_DefaultXml"] = 481] = "CancelResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["CancelResponse_Encoding_DefaultBinary"] = 482] = "CancelResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["AddNodesResult_Encoding_DefaultXml"] = 484] = "AddNodesResult_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["AddNodesResult_Encoding_DefaultBinary"] = 485] = "AddNodesResult_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["AddNodesRequest_Encoding_DefaultXml"] = 487] = "AddNodesRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["AddNodesRequest_Encoding_DefaultBinary"] = 488] = "AddNodesRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["AddNodesResponse_Encoding_DefaultXml"] = 490] = "AddNodesResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["AddNodesResponse_Encoding_DefaultBinary"] = 491] = "AddNodesResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["AddReferencesRequest_Encoding_DefaultXml"] = 493] = "AddReferencesRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["AddReferencesRequest_Encoding_DefaultBinary"] = 494] = "AddReferencesRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["AddReferencesResponse_Encoding_DefaultXml"] = 496] = "AddReferencesResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["AddReferencesResponse_Encoding_DefaultBinary"] = 497] = "AddReferencesResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DeleteNodesRequest_Encoding_DefaultXml"] = 499] = "DeleteNodesRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DeleteNodesRequest_Encoding_DefaultBinary"] = 500] = "DeleteNodesRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DeleteNodesResponse_Encoding_DefaultXml"] = 502] = "DeleteNodesResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DeleteNodesResponse_Encoding_DefaultBinary"] = 503] = "DeleteNodesResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DeleteReferencesRequest_Encoding_DefaultXml"] = 505] = "DeleteReferencesRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DeleteReferencesRequest_Encoding_DefaultBinary"] = 506] = "DeleteReferencesRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DeleteReferencesResponse_Encoding_DefaultXml"] = 508] = "DeleteReferencesResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DeleteReferencesResponse_Encoding_DefaultBinary"] = 509] = "DeleteReferencesResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ViewDescription_Encoding_DefaultXml"] = 512] = "ViewDescription_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ViewDescription_Encoding_DefaultBinary"] = 513] = "ViewDescription_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["BrowseDescription_Encoding_DefaultXml"] = 515] = "BrowseDescription_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["BrowseDescription_Encoding_DefaultBinary"] = 516] = "BrowseDescription_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ReferenceDescription_Encoding_DefaultXml"] = 519] = "ReferenceDescription_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ReferenceDescription_Encoding_DefaultBinary"] = 520] = "ReferenceDescription_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["BrowseResult_Encoding_DefaultXml"] = 523] = "BrowseResult_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["BrowseResult_Encoding_DefaultBinary"] = 524] = "BrowseResult_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["BrowseRequest_Encoding_DefaultXml"] = 526] = "BrowseRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["BrowseRequest_Encoding_DefaultBinary"] = 527] = "BrowseRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["BrowseResponse_Encoding_DefaultXml"] = 529] = "BrowseResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["BrowseResponse_Encoding_DefaultBinary"] = 530] = "BrowseResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["BrowseNextRequest_Encoding_DefaultXml"] = 532] = "BrowseNextRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["BrowseNextRequest_Encoding_DefaultBinary"] = 533] = "BrowseNextRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["BrowseNextResponse_Encoding_DefaultXml"] = 535] = "BrowseNextResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["BrowseNextResponse_Encoding_DefaultBinary"] = 536] = "BrowseNextResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["RelativePathElement_Encoding_DefaultXml"] = 538] = "RelativePathElement_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["RelativePathElement_Encoding_DefaultBinary"] = 539] = "RelativePathElement_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["RelativePath_Encoding_DefaultXml"] = 541] = "RelativePath_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["RelativePath_Encoding_DefaultBinary"] = 542] = "RelativePath_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["BrowsePath_Encoding_DefaultXml"] = 544] = "BrowsePath_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["BrowsePath_Encoding_DefaultBinary"] = 545] = "BrowsePath_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["BrowsePathTarget_Encoding_DefaultXml"] = 547] = "BrowsePathTarget_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["BrowsePathTarget_Encoding_DefaultBinary"] = 548] = "BrowsePathTarget_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["BrowsePathResult_Encoding_DefaultXml"] = 550] = "BrowsePathResult_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["BrowsePathResult_Encoding_DefaultBinary"] = 551] = "BrowsePathResult_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["TranslateBrowsePathsToNodeIdsRequest_Encoding_DefaultXml"] = 553] = "TranslateBrowsePathsToNodeIdsRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["TranslateBrowsePathsToNodeIdsRequest_Encoding_DefaultBinary"] = 554] = "TranslateBrowsePathsToNodeIdsRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["TranslateBrowsePathsToNodeIdsResponse_Encoding_DefaultXml"] = 556] = "TranslateBrowsePathsToNodeIdsResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["TranslateBrowsePathsToNodeIdsResponse_Encoding_DefaultBinary"] = 557] = "TranslateBrowsePathsToNodeIdsResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["RegisterNodesRequest_Encoding_DefaultXml"] = 559] = "RegisterNodesRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["RegisterNodesRequest_Encoding_DefaultBinary"] = 560] = "RegisterNodesRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["RegisterNodesResponse_Encoding_DefaultXml"] = 562] = "RegisterNodesResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["RegisterNodesResponse_Encoding_DefaultBinary"] = 563] = "RegisterNodesResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["UnregisterNodesRequest_Encoding_DefaultXml"] = 565] = "UnregisterNodesRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["UnregisterNodesRequest_Encoding_DefaultBinary"] = 566] = "UnregisterNodesRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["UnregisterNodesResponse_Encoding_DefaultXml"] = 568] = "UnregisterNodesResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["UnregisterNodesResponse_Encoding_DefaultBinary"] = 569] = "UnregisterNodesResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["QueryDataDescription_Encoding_DefaultXml"] = 571] = "QueryDataDescription_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["QueryDataDescription_Encoding_DefaultBinary"] = 572] = "QueryDataDescription_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["NodeTypeDescription_Encoding_DefaultXml"] = 574] = "NodeTypeDescription_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["NodeTypeDescription_Encoding_DefaultBinary"] = 575] = "NodeTypeDescription_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["QueryDataSet_Encoding_DefaultXml"] = 578] = "QueryDataSet_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["QueryDataSet_Encoding_DefaultBinary"] = 579] = "QueryDataSet_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["NodeReference_Encoding_DefaultXml"] = 581] = "NodeReference_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["NodeReference_Encoding_DefaultBinary"] = 582] = "NodeReference_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ContentFilterElement_Encoding_DefaultXml"] = 584] = "ContentFilterElement_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ContentFilterElement_Encoding_DefaultBinary"] = 585] = "ContentFilterElement_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ContentFilter_Encoding_DefaultXml"] = 587] = "ContentFilter_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ContentFilter_Encoding_DefaultBinary"] = 588] = "ContentFilter_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["FilterOperand_Encoding_DefaultXml"] = 590] = "FilterOperand_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["FilterOperand_Encoding_DefaultBinary"] = 591] = "FilterOperand_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ElementOperand_Encoding_DefaultXml"] = 593] = "ElementOperand_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ElementOperand_Encoding_DefaultBinary"] = 594] = "ElementOperand_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["LiteralOperand_Encoding_DefaultXml"] = 596] = "LiteralOperand_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["LiteralOperand_Encoding_DefaultBinary"] = 597] = "LiteralOperand_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["AttributeOperand_Encoding_DefaultXml"] = 599] = "AttributeOperand_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["AttributeOperand_Encoding_DefaultBinary"] = 600] = "AttributeOperand_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["SimpleAttributeOperand_Encoding_DefaultXml"] = 602] = "SimpleAttributeOperand_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["SimpleAttributeOperand_Encoding_DefaultBinary"] = 603] = "SimpleAttributeOperand_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ContentFilterElementResult_Encoding_DefaultXml"] = 605] = "ContentFilterElementResult_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ContentFilterElementResult_Encoding_DefaultBinary"] = 606] = "ContentFilterElementResult_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ContentFilterResult_Encoding_DefaultXml"] = 608] = "ContentFilterResult_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ContentFilterResult_Encoding_DefaultBinary"] = 609] = "ContentFilterResult_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ParsingResult_Encoding_DefaultXml"] = 611] = "ParsingResult_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ParsingResult_Encoding_DefaultBinary"] = 612] = "ParsingResult_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["QueryFirstRequest_Encoding_DefaultXml"] = 614] = "QueryFirstRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["QueryFirstRequest_Encoding_DefaultBinary"] = 615] = "QueryFirstRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["QueryFirstResponse_Encoding_DefaultXml"] = 617] = "QueryFirstResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["QueryFirstResponse_Encoding_DefaultBinary"] = 618] = "QueryFirstResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["QueryNextRequest_Encoding_DefaultXml"] = 620] = "QueryNextRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["QueryNextRequest_Encoding_DefaultBinary"] = 621] = "QueryNextRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["QueryNextResponse_Encoding_DefaultXml"] = 623] = "QueryNextResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["QueryNextResponse_Encoding_DefaultBinary"] = 624] = "QueryNextResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ReadValueId_Encoding_DefaultXml"] = 627] = "ReadValueId_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ReadValueId_Encoding_DefaultBinary"] = 628] = "ReadValueId_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ReadRequest_Encoding_DefaultXml"] = 630] = "ReadRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ReadRequest_Encoding_DefaultBinary"] = 631] = "ReadRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ReadResponse_Encoding_DefaultXml"] = 633] = "ReadResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ReadResponse_Encoding_DefaultBinary"] = 634] = "ReadResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["HistoryReadValueId_Encoding_DefaultXml"] = 636] = "HistoryReadValueId_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["HistoryReadValueId_Encoding_DefaultBinary"] = 637] = "HistoryReadValueId_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["HistoryReadResult_Encoding_DefaultXml"] = 639] = "HistoryReadResult_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["HistoryReadResult_Encoding_DefaultBinary"] = 640] = "HistoryReadResult_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["HistoryReadDetails_Encoding_DefaultXml"] = 642] = "HistoryReadDetails_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["HistoryReadDetails_Encoding_DefaultBinary"] = 643] = "HistoryReadDetails_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ReadEventDetails_Encoding_DefaultXml"] = 645] = "ReadEventDetails_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ReadEventDetails_Encoding_DefaultBinary"] = 646] = "ReadEventDetails_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ReadRawModifiedDetails_Encoding_DefaultXml"] = 648] = "ReadRawModifiedDetails_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ReadRawModifiedDetails_Encoding_DefaultBinary"] = 649] = "ReadRawModifiedDetails_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ReadProcessedDetails_Encoding_DefaultXml"] = 651] = "ReadProcessedDetails_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ReadProcessedDetails_Encoding_DefaultBinary"] = 652] = "ReadProcessedDetails_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ReadAtTimeDetails_Encoding_DefaultXml"] = 654] = "ReadAtTimeDetails_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ReadAtTimeDetails_Encoding_DefaultBinary"] = 655] = "ReadAtTimeDetails_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["HistoryData_Encoding_DefaultXml"] = 657] = "HistoryData_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["HistoryData_Encoding_DefaultBinary"] = 658] = "HistoryData_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["HistoryEvent_Encoding_DefaultXml"] = 660] = "HistoryEvent_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["HistoryEvent_Encoding_DefaultBinary"] = 661] = "HistoryEvent_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["HistoryReadRequest_Encoding_DefaultXml"] = 663] = "HistoryReadRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["HistoryReadRequest_Encoding_DefaultBinary"] = 664] = "HistoryReadRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["HistoryReadResponse_Encoding_DefaultXml"] = 666] = "HistoryReadResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["HistoryReadResponse_Encoding_DefaultBinary"] = 667] = "HistoryReadResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["WriteValue_Encoding_DefaultXml"] = 669] = "WriteValue_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["WriteValue_Encoding_DefaultBinary"] = 670] = "WriteValue_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["WriteRequest_Encoding_DefaultXml"] = 672] = "WriteRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["WriteRequest_Encoding_DefaultBinary"] = 673] = "WriteRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["WriteResponse_Encoding_DefaultXml"] = 675] = "WriteResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["WriteResponse_Encoding_DefaultBinary"] = 676] = "WriteResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["HistoryUpdateDetails_Encoding_DefaultXml"] = 678] = "HistoryUpdateDetails_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["HistoryUpdateDetails_Encoding_DefaultBinary"] = 679] = "HistoryUpdateDetails_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["UpdateDataDetails_Encoding_DefaultXml"] = 681] = "UpdateDataDetails_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["UpdateDataDetails_Encoding_DefaultBinary"] = 682] = "UpdateDataDetails_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["UpdateEventDetails_Encoding_DefaultXml"] = 684] = "UpdateEventDetails_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["UpdateEventDetails_Encoding_DefaultBinary"] = 685] = "UpdateEventDetails_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DeleteRawModifiedDetails_Encoding_DefaultXml"] = 687] = "DeleteRawModifiedDetails_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DeleteRawModifiedDetails_Encoding_DefaultBinary"] = 688] = "DeleteRawModifiedDetails_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DeleteAtTimeDetails_Encoding_DefaultXml"] = 690] = "DeleteAtTimeDetails_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DeleteAtTimeDetails_Encoding_DefaultBinary"] = 691] = "DeleteAtTimeDetails_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DeleteEventDetails_Encoding_DefaultXml"] = 693] = "DeleteEventDetails_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DeleteEventDetails_Encoding_DefaultBinary"] = 694] = "DeleteEventDetails_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["HistoryUpdateResult_Encoding_DefaultXml"] = 696] = "HistoryUpdateResult_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["HistoryUpdateResult_Encoding_DefaultBinary"] = 697] = "HistoryUpdateResult_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["HistoryUpdateRequest_Encoding_DefaultXml"] = 699] = "HistoryUpdateRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["HistoryUpdateRequest_Encoding_DefaultBinary"] = 700] = "HistoryUpdateRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["HistoryUpdateResponse_Encoding_DefaultXml"] = 702] = "HistoryUpdateResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["HistoryUpdateResponse_Encoding_DefaultBinary"] = 703] = "HistoryUpdateResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["CallMethodRequest_Encoding_DefaultXml"] = 705] = "CallMethodRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["CallMethodRequest_Encoding_DefaultBinary"] = 706] = "CallMethodRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["CallMethodResult_Encoding_DefaultXml"] = 708] = "CallMethodResult_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["CallMethodResult_Encoding_DefaultBinary"] = 709] = "CallMethodResult_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["CallRequest_Encoding_DefaultXml"] = 711] = "CallRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["CallRequest_Encoding_DefaultBinary"] = 712] = "CallRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["CallResponse_Encoding_DefaultXml"] = 714] = "CallResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["CallResponse_Encoding_DefaultBinary"] = 715] = "CallResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["MonitoringFilter_Encoding_DefaultXml"] = 720] = "MonitoringFilter_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["MonitoringFilter_Encoding_DefaultBinary"] = 721] = "MonitoringFilter_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DataChangeFilter_Encoding_DefaultXml"] = 723] = "DataChangeFilter_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DataChangeFilter_Encoding_DefaultBinary"] = 724] = "DataChangeFilter_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["EventFilter_Encoding_DefaultXml"] = 726] = "EventFilter_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["EventFilter_Encoding_DefaultBinary"] = 727] = "EventFilter_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["AggregateFilter_Encoding_DefaultXml"] = 729] = "AggregateFilter_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["AggregateFilter_Encoding_DefaultBinary"] = 730] = "AggregateFilter_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["MonitoringFilterResult_Encoding_DefaultXml"] = 732] = "MonitoringFilterResult_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["MonitoringFilterResult_Encoding_DefaultBinary"] = 733] = "MonitoringFilterResult_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["EventFilterResult_Encoding_DefaultXml"] = 735] = "EventFilterResult_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["EventFilterResult_Encoding_DefaultBinary"] = 736] = "EventFilterResult_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["AggregateFilterResult_Encoding_DefaultXml"] = 738] = "AggregateFilterResult_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["AggregateFilterResult_Encoding_DefaultBinary"] = 739] = "AggregateFilterResult_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["MonitoringParameters_Encoding_DefaultXml"] = 741] = "MonitoringParameters_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["MonitoringParameters_Encoding_DefaultBinary"] = 742] = "MonitoringParameters_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["MonitoredItemCreateRequest_Encoding_DefaultXml"] = 744] = "MonitoredItemCreateRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["MonitoredItemCreateRequest_Encoding_DefaultBinary"] = 745] = "MonitoredItemCreateRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["MonitoredItemCreateResult_Encoding_DefaultXml"] = 747] = "MonitoredItemCreateResult_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["MonitoredItemCreateResult_Encoding_DefaultBinary"] = 748] = "MonitoredItemCreateResult_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["CreateMonitoredItemsRequest_Encoding_DefaultXml"] = 750] = "CreateMonitoredItemsRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["CreateMonitoredItemsRequest_Encoding_DefaultBinary"] = 751] = "CreateMonitoredItemsRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["CreateMonitoredItemsResponse_Encoding_DefaultXml"] = 753] = "CreateMonitoredItemsResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["CreateMonitoredItemsResponse_Encoding_DefaultBinary"] = 754] = "CreateMonitoredItemsResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["MonitoredItemModifyRequest_Encoding_DefaultXml"] = 756] = "MonitoredItemModifyRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["MonitoredItemModifyRequest_Encoding_DefaultBinary"] = 757] = "MonitoredItemModifyRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["MonitoredItemModifyResult_Encoding_DefaultXml"] = 759] = "MonitoredItemModifyResult_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["MonitoredItemModifyResult_Encoding_DefaultBinary"] = 760] = "MonitoredItemModifyResult_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ModifyMonitoredItemsRequest_Encoding_DefaultXml"] = 762] = "ModifyMonitoredItemsRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ModifyMonitoredItemsRequest_Encoding_DefaultBinary"] = 763] = "ModifyMonitoredItemsRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ModifyMonitoredItemsResponse_Encoding_DefaultXml"] = 765] = "ModifyMonitoredItemsResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ModifyMonitoredItemsResponse_Encoding_DefaultBinary"] = 766] = "ModifyMonitoredItemsResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["SetMonitoringModeRequest_Encoding_DefaultXml"] = 768] = "SetMonitoringModeRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["SetMonitoringModeRequest_Encoding_DefaultBinary"] = 769] = "SetMonitoringModeRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["SetMonitoringModeResponse_Encoding_DefaultXml"] = 771] = "SetMonitoringModeResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["SetMonitoringModeResponse_Encoding_DefaultBinary"] = 772] = "SetMonitoringModeResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["SetTriggeringRequest_Encoding_DefaultXml"] = 774] = "SetTriggeringRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["SetTriggeringRequest_Encoding_DefaultBinary"] = 775] = "SetTriggeringRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["SetTriggeringResponse_Encoding_DefaultXml"] = 777] = "SetTriggeringResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["SetTriggeringResponse_Encoding_DefaultBinary"] = 778] = "SetTriggeringResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DeleteMonitoredItemsRequest_Encoding_DefaultXml"] = 780] = "DeleteMonitoredItemsRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DeleteMonitoredItemsRequest_Encoding_DefaultBinary"] = 781] = "DeleteMonitoredItemsRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DeleteMonitoredItemsResponse_Encoding_DefaultXml"] = 783] = "DeleteMonitoredItemsResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DeleteMonitoredItemsResponse_Encoding_DefaultBinary"] = 784] = "DeleteMonitoredItemsResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["CreateSubscriptionRequest_Encoding_DefaultXml"] = 786] = "CreateSubscriptionRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["CreateSubscriptionRequest_Encoding_DefaultBinary"] = 787] = "CreateSubscriptionRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["CreateSubscriptionResponse_Encoding_DefaultXml"] = 789] = "CreateSubscriptionResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["CreateSubscriptionResponse_Encoding_DefaultBinary"] = 790] = "CreateSubscriptionResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ModifySubscriptionRequest_Encoding_DefaultXml"] = 792] = "ModifySubscriptionRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ModifySubscriptionRequest_Encoding_DefaultBinary"] = 793] = "ModifySubscriptionRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ModifySubscriptionResponse_Encoding_DefaultXml"] = 795] = "ModifySubscriptionResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ModifySubscriptionResponse_Encoding_DefaultBinary"] = 796] = "ModifySubscriptionResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["SetPublishingModeRequest_Encoding_DefaultXml"] = 798] = "SetPublishingModeRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["SetPublishingModeRequest_Encoding_DefaultBinary"] = 799] = "SetPublishingModeRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["SetPublishingModeResponse_Encoding_DefaultXml"] = 801] = "SetPublishingModeResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["SetPublishingModeResponse_Encoding_DefaultBinary"] = 802] = "SetPublishingModeResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["NotificationMessage_Encoding_DefaultXml"] = 804] = "NotificationMessage_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["NotificationMessage_Encoding_DefaultBinary"] = 805] = "NotificationMessage_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["MonitoredItemNotification_Encoding_DefaultXml"] = 807] = "MonitoredItemNotification_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["MonitoredItemNotification_Encoding_DefaultBinary"] = 808] = "MonitoredItemNotification_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DataChangeNotification_Encoding_DefaultXml"] = 810] = "DataChangeNotification_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DataChangeNotification_Encoding_DefaultBinary"] = 811] = "DataChangeNotification_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["StatusChangeNotification_Encoding_DefaultXml"] = 819] = "StatusChangeNotification_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["StatusChangeNotification_Encoding_DefaultBinary"] = 820] = "StatusChangeNotification_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["SubscriptionAcknowledgement_Encoding_DefaultXml"] = 822] = "SubscriptionAcknowledgement_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["SubscriptionAcknowledgement_Encoding_DefaultBinary"] = 823] = "SubscriptionAcknowledgement_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["PublishRequest_Encoding_DefaultXml"] = 825] = "PublishRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["PublishRequest_Encoding_DefaultBinary"] = 826] = "PublishRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["PublishResponse_Encoding_DefaultXml"] = 828] = "PublishResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["PublishResponse_Encoding_DefaultBinary"] = 829] = "PublishResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["RepublishRequest_Encoding_DefaultXml"] = 831] = "RepublishRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["RepublishRequest_Encoding_DefaultBinary"] = 832] = "RepublishRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["RepublishResponse_Encoding_DefaultXml"] = 834] = "RepublishResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["RepublishResponse_Encoding_DefaultBinary"] = 835] = "RepublishResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["TransferResult_Encoding_DefaultXml"] = 837] = "TransferResult_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["TransferResult_Encoding_DefaultBinary"] = 838] = "TransferResult_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["TransferSubscriptionsRequest_Encoding_DefaultXml"] = 840] = "TransferSubscriptionsRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["TransferSubscriptionsRequest_Encoding_DefaultBinary"] = 841] = "TransferSubscriptionsRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["TransferSubscriptionsResponse_Encoding_DefaultXml"] = 843] = "TransferSubscriptionsResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["TransferSubscriptionsResponse_Encoding_DefaultBinary"] = 844] = "TransferSubscriptionsResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DeleteSubscriptionsRequest_Encoding_DefaultXml"] = 846] = "DeleteSubscriptionsRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DeleteSubscriptionsRequest_Encoding_DefaultBinary"] = 847] = "DeleteSubscriptionsRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DeleteSubscriptionsResponse_Encoding_DefaultXml"] = 849] = "DeleteSubscriptionsResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DeleteSubscriptionsResponse_Encoding_DefaultBinary"] = 850] = "DeleteSubscriptionsResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["RedundantServerDataType_Encoding_DefaultXml"] = 854] = "RedundantServerDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["RedundantServerDataType_Encoding_DefaultBinary"] = 855] = "RedundantServerDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["SamplingIntervalDiagnosticsDataType_Encoding_DefaultXml"] = 857] = "SamplingIntervalDiagnosticsDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["SamplingIntervalDiagnosticsDataType_Encoding_DefaultBinary"] = 858] = "SamplingIntervalDiagnosticsDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ServerDiagnosticsSummaryDataType_Encoding_DefaultXml"] = 860] = "ServerDiagnosticsSummaryDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ServerDiagnosticsSummaryDataType_Encoding_DefaultBinary"] = 861] = "ServerDiagnosticsSummaryDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ServerStatusDataType_Encoding_DefaultXml"] = 863] = "ServerStatusDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ServerStatusDataType_Encoding_DefaultBinary"] = 864] = "ServerStatusDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["SessionDiagnosticsDataType_Encoding_DefaultXml"] = 866] = "SessionDiagnosticsDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["SessionDiagnosticsDataType_Encoding_DefaultBinary"] = 867] = "SessionDiagnosticsDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["SessionSecurityDiagnosticsDataType_Encoding_DefaultXml"] = 869] = "SessionSecurityDiagnosticsDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["SessionSecurityDiagnosticsDataType_Encoding_DefaultBinary"] = 870] = "SessionSecurityDiagnosticsDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ServiceCounterDataType_Encoding_DefaultXml"] = 872] = "ServiceCounterDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ServiceCounterDataType_Encoding_DefaultBinary"] = 873] = "ServiceCounterDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["SubscriptionDiagnosticsDataType_Encoding_DefaultXml"] = 875] = "SubscriptionDiagnosticsDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["SubscriptionDiagnosticsDataType_Encoding_DefaultBinary"] = 876] = "SubscriptionDiagnosticsDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ModelChangeStructureDataType_Encoding_DefaultXml"] = 878] = "ModelChangeStructureDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ModelChangeStructureDataType_Encoding_DefaultBinary"] = 879] = "ModelChangeStructureDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["Range_Encoding_DefaultXml"] = 885] = "Range_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["Range_Encoding_DefaultBinary"] = 886] = "Range_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["EUInformation_Encoding_DefaultXml"] = 888] = "EUInformation_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["EUInformation_Encoding_DefaultBinary"] = 889] = "EUInformation_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["Annotation_Encoding_DefaultXml"] = 892] = "Annotation_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["Annotation_Encoding_DefaultBinary"] = 893] = "Annotation_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ProgramDiagnosticDataType_Encoding_DefaultXml"] = 895] = "ProgramDiagnosticDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ProgramDiagnosticDataType_Encoding_DefaultBinary"] = 896] = "ProgramDiagnosticDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["SemanticChangeStructureDataType_Encoding_DefaultXml"] = 898] = "SemanticChangeStructureDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["SemanticChangeStructureDataType_Encoding_DefaultBinary"] = 899] = "SemanticChangeStructureDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["EventNotificationList_Encoding_DefaultXml"] = 915] = "EventNotificationList_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["EventNotificationList_Encoding_DefaultBinary"] = 916] = "EventNotificationList_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["EventFieldList_Encoding_DefaultXml"] = 918] = "EventFieldList_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["EventFieldList_Encoding_DefaultBinary"] = 919] = "EventFieldList_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["HistoryEventFieldList_Encoding_DefaultXml"] = 921] = "HistoryEventFieldList_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["HistoryEventFieldList_Encoding_DefaultBinary"] = 922] = "HistoryEventFieldList_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["IssuedIdentityToken_Encoding_DefaultXml"] = 939] = "IssuedIdentityToken_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["IssuedIdentityToken_Encoding_DefaultBinary"] = 940] = "IssuedIdentityToken_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["NotificationData_Encoding_DefaultXml"] = 946] = "NotificationData_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["NotificationData_Encoding_DefaultBinary"] = 947] = "NotificationData_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["AggregateConfiguration_Encoding_DefaultXml"] = 949] = "AggregateConfiguration_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["AggregateConfiguration_Encoding_DefaultBinary"] = 950] = "AggregateConfiguration_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["Server"] = 2253] = "Server";
      ObjectIds2[ObjectIds2["Server_ServerCapabilities"] = 2268] = "Server_ServerCapabilities";
      ObjectIds2[ObjectIds2["Server_ServerDiagnostics"] = 2274] = "Server_ServerDiagnostics";
      ObjectIds2[ObjectIds2["Server_VendorServerInfo"] = 2295] = "Server_VendorServerInfo";
      ObjectIds2[ObjectIds2["Server_ServerRedundancy"] = 2296] = "Server_ServerRedundancy";
      ObjectIds2[ObjectIds2["AggregateFunction_Interpolative"] = 2341] = "AggregateFunction_Interpolative";
      ObjectIds2[ObjectIds2["AggregateFunction_Average"] = 2342] = "AggregateFunction_Average";
      ObjectIds2[ObjectIds2["AggregateFunction_TimeAverage"] = 2343] = "AggregateFunction_TimeAverage";
      ObjectIds2[ObjectIds2["AggregateFunction_Total"] = 2344] = "AggregateFunction_Total";
      ObjectIds2[ObjectIds2["AggregateFunction_Minimum"] = 2346] = "AggregateFunction_Minimum";
      ObjectIds2[ObjectIds2["AggregateFunction_Maximum"] = 2347] = "AggregateFunction_Maximum";
      ObjectIds2[ObjectIds2["AggregateFunction_MinimumActualTime"] = 2348] = "AggregateFunction_MinimumActualTime";
      ObjectIds2[ObjectIds2["AggregateFunction_MaximumActualTime"] = 2349] = "AggregateFunction_MaximumActualTime";
      ObjectIds2[ObjectIds2["AggregateFunction_Range"] = 2350] = "AggregateFunction_Range";
      ObjectIds2[ObjectIds2["AggregateFunction_AnnotationCount"] = 2351] = "AggregateFunction_AnnotationCount";
      ObjectIds2[ObjectIds2["AggregateFunction_Count"] = 2352] = "AggregateFunction_Count";
      ObjectIds2[ObjectIds2["AggregateFunction_NumberOfTransitions"] = 2355] = "AggregateFunction_NumberOfTransitions";
      ObjectIds2[ObjectIds2["AggregateFunction_Start"] = 2357] = "AggregateFunction_Start";
      ObjectIds2[ObjectIds2["AggregateFunction_End"] = 2358] = "AggregateFunction_End";
      ObjectIds2[ObjectIds2["AggregateFunction_Delta"] = 2359] = "AggregateFunction_Delta";
      ObjectIds2[ObjectIds2["AggregateFunction_DurationGood"] = 2360] = "AggregateFunction_DurationGood";
      ObjectIds2[ObjectIds2["AggregateFunction_DurationBad"] = 2361] = "AggregateFunction_DurationBad";
      ObjectIds2[ObjectIds2["AggregateFunction_PercentGood"] = 2362] = "AggregateFunction_PercentGood";
      ObjectIds2[ObjectIds2["AggregateFunction_PercentBad"] = 2363] = "AggregateFunction_PercentBad";
      ObjectIds2[ObjectIds2["AggregateFunction_WorstQuality"] = 2364] = "AggregateFunction_WorstQuality";
      ObjectIds2[ObjectIds2["Server_ServerCapabilities_ModellingRules"] = 2996] = "Server_ServerCapabilities_ModellingRules";
      ObjectIds2[ObjectIds2["Server_ServerCapabilities_AggregateFunctions"] = 2997] = "Server_ServerCapabilities_AggregateFunctions";
      ObjectIds2[ObjectIds2["EventTypesFolder"] = 3048] = "EventTypesFolder";
      ObjectIds2[ObjectIds2["DefaultBinary"] = 3062] = "DefaultBinary";
      ObjectIds2[ObjectIds2["DefaultXml"] = 3063] = "DefaultXml";
      ObjectIds2[ObjectIds2["Server_ServerDiagnostics_SessionsDiagnosticsSummary"] = 3706] = "Server_ServerDiagnostics_SessionsDiagnosticsSummary";
      ObjectIds2[ObjectIds2["EnumValueType_Encoding_DefaultXml"] = 7616] = "EnumValueType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["EnumValueType_Encoding_DefaultBinary"] = 8251] = "EnumValueType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["TimeZoneDataType_Encoding_DefaultXml"] = 8913] = "TimeZoneDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["TimeZoneDataType_Encoding_DefaultBinary"] = 8917] = "TimeZoneDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["HistoryServerCapabilities"] = 11192] = "HistoryServerCapabilities";
      ObjectIds2[ObjectIds2["HistoryServerCapabilities_AggregateFunctions"] = 11201] = "HistoryServerCapabilities_AggregateFunctions";
      ObjectIds2[ObjectIds2["HAConfiguration"] = 11202] = "HAConfiguration";
      ObjectIds2[ObjectIds2["HAConfiguration_AggregateConfiguration"] = 11203] = "HAConfiguration_AggregateConfiguration";
      ObjectIds2[ObjectIds2["ModificationInfo_Encoding_DefaultXml"] = 11218] = "ModificationInfo_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["HistoryModifiedData_Encoding_DefaultXml"] = 11219] = "HistoryModifiedData_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ModificationInfo_Encoding_DefaultBinary"] = 11226] = "ModificationInfo_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["HistoryModifiedData_Encoding_DefaultBinary"] = 11227] = "HistoryModifiedData_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["AggregateFunction_TimeAverage2"] = 11285] = "AggregateFunction_TimeAverage2";
      ObjectIds2[ObjectIds2["AggregateFunction_Minimum2"] = 11286] = "AggregateFunction_Minimum2";
      ObjectIds2[ObjectIds2["AggregateFunction_Maximum2"] = 11287] = "AggregateFunction_Maximum2";
      ObjectIds2[ObjectIds2["AggregateFunction_Range2"] = 11288] = "AggregateFunction_Range2";
      ObjectIds2[ObjectIds2["AggregateFunction_WorstQuality2"] = 11292] = "AggregateFunction_WorstQuality2";
      ObjectIds2[ObjectIds2["UpdateStructureDataDetails_Encoding_DefaultXml"] = 11296] = "UpdateStructureDataDetails_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["UpdateStructureDataDetails_Encoding_DefaultBinary"] = 11300] = "UpdateStructureDataDetails_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["AggregateFunction_Total2"] = 11304] = "AggregateFunction_Total2";
      ObjectIds2[ObjectIds2["AggregateFunction_MinimumActualTime2"] = 11305] = "AggregateFunction_MinimumActualTime2";
      ObjectIds2[ObjectIds2["AggregateFunction_MaximumActualTime2"] = 11306] = "AggregateFunction_MaximumActualTime2";
      ObjectIds2[ObjectIds2["AggregateFunction_DurationInStateZero"] = 11307] = "AggregateFunction_DurationInStateZero";
      ObjectIds2[ObjectIds2["AggregateFunction_DurationInStateNonZero"] = 11308] = "AggregateFunction_DurationInStateNonZero";
      ObjectIds2[ObjectIds2["AggregateFunction_StandardDeviationSample"] = 11426] = "AggregateFunction_StandardDeviationSample";
      ObjectIds2[ObjectIds2["AggregateFunction_StandardDeviationPopulation"] = 11427] = "AggregateFunction_StandardDeviationPopulation";
      ObjectIds2[ObjectIds2["AggregateFunction_VarianceSample"] = 11428] = "AggregateFunction_VarianceSample";
      ObjectIds2[ObjectIds2["AggregateFunction_VariancePopulation"] = 11429] = "AggregateFunction_VariancePopulation";
      ObjectIds2[ObjectIds2["AggregateFunction_StartBound"] = 11505] = "AggregateFunction_StartBound";
      ObjectIds2[ObjectIds2["AggregateFunction_EndBound"] = 11506] = "AggregateFunction_EndBound";
      ObjectIds2[ObjectIds2["AggregateFunction_DeltaBounds"] = 11507] = "AggregateFunction_DeltaBounds";
      ObjectIds2[ObjectIds2["ModellingRule_OptionalPlaceholder"] = 11508] = "ModellingRule_OptionalPlaceholder";
      ObjectIds2[ObjectIds2["ModellingRule_MandatoryPlaceholder"] = 11510] = "ModellingRule_MandatoryPlaceholder";
      ObjectIds2[ObjectIds2["Server_ServerCapabilities_OperationLimits"] = 11704] = "Server_ServerCapabilities_OperationLimits";
      ObjectIds2[ObjectIds2["Server_Namespaces"] = 11715] = "Server_Namespaces";
      ObjectIds2[ObjectIds2["HAConfiguration_AggregateFunctions"] = 11877] = "HAConfiguration_AggregateFunctions";
      ObjectIds2[ObjectIds2["InstanceNode_Encoding_DefaultXml"] = 11887] = "InstanceNode_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["TypeNode_Encoding_DefaultXml"] = 11888] = "TypeNode_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["InstanceNode_Encoding_DefaultBinary"] = 11889] = "InstanceNode_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["TypeNode_Encoding_DefaultBinary"] = 11890] = "TypeNode_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["EndpointUrlListDataType_Encoding_DefaultXml"] = 11949] = "EndpointUrlListDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["NetworkGroupDataType_Encoding_DefaultXml"] = 11950] = "NetworkGroupDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["EndpointUrlListDataType_Encoding_DefaultBinary"] = 11957] = "EndpointUrlListDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["NetworkGroupDataType_Encoding_DefaultBinary"] = 11958] = "NetworkGroupDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["AxisInformation_Encoding_DefaultXml"] = 12081] = "AxisInformation_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["XVType_Encoding_DefaultXml"] = 12082] = "XVType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["AxisInformation_Encoding_DefaultBinary"] = 12089] = "AxisInformation_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["XVType_Encoding_DefaultBinary"] = 12090] = "XVType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ComplexNumberType_Encoding_DefaultXml"] = 12173] = "ComplexNumberType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DoubleComplexNumberType_Encoding_DefaultXml"] = 12174] = "DoubleComplexNumberType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ComplexNumberType_Encoding_DefaultBinary"] = 12181] = "ComplexNumberType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DoubleComplexNumberType_Encoding_DefaultBinary"] = 12182] = "DoubleComplexNumberType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ServerOnNetwork_Encoding_DefaultXml"] = 12195] = "ServerOnNetwork_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["FindServersOnNetworkRequest_Encoding_DefaultXml"] = 12196] = "FindServersOnNetworkRequest_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["FindServersOnNetworkResponse_Encoding_DefaultXml"] = 12197] = "FindServersOnNetworkResponse_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["RegisterServer2Request_Encoding_DefaultXml"] = 12199] = "RegisterServer2Request_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["RegisterServer2Response_Encoding_DefaultXml"] = 12200] = "RegisterServer2Response_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ServerOnNetwork_Encoding_DefaultBinary"] = 12207] = "ServerOnNetwork_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["FindServersOnNetworkRequest_Encoding_DefaultBinary"] = 12208] = "FindServersOnNetworkRequest_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["FindServersOnNetworkResponse_Encoding_DefaultBinary"] = 12209] = "FindServersOnNetworkResponse_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["RegisterServer2Request_Encoding_DefaultBinary"] = 12211] = "RegisterServer2Request_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["RegisterServer2Response_Encoding_DefaultBinary"] = 12212] = "RegisterServer2Response_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ServerConfiguration"] = 12637] = "ServerConfiguration";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList"] = 12642] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList";
      ObjectIds2[ObjectIds2["TrustListDataType_Encoding_DefaultXml"] = 12676] = "TrustListDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["TrustListDataType_Encoding_DefaultBinary"] = 12680] = "TrustListDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["OptionSet_Encoding_DefaultXml"] = 12757] = "OptionSet_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["Union_Encoding_DefaultXml"] = 12758] = "Union_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["OptionSet_Encoding_DefaultBinary"] = 12765] = "OptionSet_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["Union_Encoding_DefaultBinary"] = 12766] = "Union_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DiscoveryConfiguration_Encoding_DefaultXml"] = 12892] = "DiscoveryConfiguration_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["MdnsDiscoveryConfiguration_Encoding_DefaultXml"] = 12893] = "MdnsDiscoveryConfiguration_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DiscoveryConfiguration_Encoding_DefaultBinary"] = 12900] = "DiscoveryConfiguration_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["MdnsDiscoveryConfiguration_Encoding_DefaultBinary"] = 12901] = "MdnsDiscoveryConfiguration_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups"] = 14053] = "ServerConfiguration_CertificateGroups";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup"] = 14088] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList"] = 14089] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup"] = 14122] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList"] = 14123] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup"] = 14156] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup";
      ObjectIds2[ObjectIds2["PublishedVariableDataType_Encoding_DefaultXml"] = 14319] = "PublishedVariableDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["PublishedVariableDataType_Encoding_DefaultBinary"] = 14323] = "PublishedVariableDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["PublishSubscribe"] = 14443] = "PublishSubscribe";
      ObjectIds2[ObjectIds2["DataSetMetaDataType_Encoding_DefaultXml"] = 14794] = "DataSetMetaDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["FieldMetaData_Encoding_DefaultXml"] = 14795] = "FieldMetaData_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DataTypeDescription_Encoding_DefaultXml"] = 14796] = "DataTypeDescription_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DataTypeDefinition_Encoding_DefaultXml"] = 14797] = "DataTypeDefinition_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["StructureDefinition_Encoding_DefaultXml"] = 14798] = "StructureDefinition_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["EnumDefinition_Encoding_DefaultXml"] = 14799] = "EnumDefinition_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["StructureField_Encoding_DefaultXml"] = 14800] = "StructureField_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["EnumField_Encoding_DefaultXml"] = 14801] = "EnumField_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["KeyValuePair_Encoding_DefaultXml"] = 14802] = "KeyValuePair_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ConfigurationVersionDataType_Encoding_DefaultXml"] = 14803] = "ConfigurationVersionDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["FieldTargetDataType_Encoding_DefaultXml"] = 14804] = "FieldTargetDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["FieldMetaData_Encoding_DefaultBinary"] = 14839] = "FieldMetaData_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["StructureField_Encoding_DefaultBinary"] = 14844] = "StructureField_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["EnumField_Encoding_DefaultBinary"] = 14845] = "EnumField_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["KeyValuePair_Encoding_DefaultBinary"] = 14846] = "KeyValuePair_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ConfigurationVersionDataType_Encoding_DefaultBinary"] = 14847] = "ConfigurationVersionDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["FieldTargetDataType_Encoding_DefaultBinary"] = 14848] = "FieldTargetDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["KeyValuePair_Encoding_DefaultJson"] = 15041] = "KeyValuePair_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["IdentityMappingRuleType_Encoding_DefaultJson"] = 15042] = "IdentityMappingRuleType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["TrustListDataType_Encoding_DefaultJson"] = 15044] = "TrustListDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DecimalDataType_Encoding_DefaultJson"] = 15045] = "DecimalDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ConfigurationVersionDataType_Encoding_DefaultJson"] = 15049] = "ConfigurationVersionDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DataSetMetaDataType_Encoding_DefaultJson"] = 15050] = "DataSetMetaDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["FieldMetaData_Encoding_DefaultJson"] = 15051] = "FieldMetaData_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DataTypeDescription_Encoding_DefaultJson"] = 15057] = "DataTypeDescription_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["StructureDescription_Encoding_DefaultJson"] = 15058] = "StructureDescription_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["EnumDescription_Encoding_DefaultJson"] = 15059] = "EnumDescription_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["PublishedVariableDataType_Encoding_DefaultJson"] = 15060] = "PublishedVariableDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["FieldTargetDataType_Encoding_DefaultJson"] = 15061] = "FieldTargetDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["RolePermissionType_Encoding_DefaultJson"] = 15062] = "RolePermissionType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DataTypeDefinition_Encoding_DefaultJson"] = 15063] = "DataTypeDefinition_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["StructureField_Encoding_DefaultJson"] = 15065] = "StructureField_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["StructureDefinition_Encoding_DefaultJson"] = 15066] = "StructureDefinition_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["EnumDefinition_Encoding_DefaultJson"] = 15067] = "EnumDefinition_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["Node_Encoding_DefaultJson"] = 15068] = "Node_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["InstanceNode_Encoding_DefaultJson"] = 15069] = "InstanceNode_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["TypeNode_Encoding_DefaultJson"] = 15070] = "TypeNode_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ObjectNode_Encoding_DefaultJson"] = 15071] = "ObjectNode_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ObjectTypeNode_Encoding_DefaultJson"] = 15073] = "ObjectTypeNode_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["VariableNode_Encoding_DefaultJson"] = 15074] = "VariableNode_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["VariableTypeNode_Encoding_DefaultJson"] = 15075] = "VariableTypeNode_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ReferenceTypeNode_Encoding_DefaultJson"] = 15076] = "ReferenceTypeNode_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["MethodNode_Encoding_DefaultJson"] = 15077] = "MethodNode_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ViewNode_Encoding_DefaultJson"] = 15078] = "ViewNode_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DataTypeNode_Encoding_DefaultJson"] = 15079] = "DataTypeNode_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ReferenceNode_Encoding_DefaultJson"] = 15080] = "ReferenceNode_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["Argument_Encoding_DefaultJson"] = 15081] = "Argument_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["EnumValueType_Encoding_DefaultJson"] = 15082] = "EnumValueType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["EnumField_Encoding_DefaultJson"] = 15083] = "EnumField_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["OptionSet_Encoding_DefaultJson"] = 15084] = "OptionSet_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["Union_Encoding_DefaultJson"] = 15085] = "Union_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["TimeZoneDataType_Encoding_DefaultJson"] = 15086] = "TimeZoneDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ApplicationDescription_Encoding_DefaultJson"] = 15087] = "ApplicationDescription_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["RequestHeader_Encoding_DefaultJson"] = 15088] = "RequestHeader_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ResponseHeader_Encoding_DefaultJson"] = 15089] = "ResponseHeader_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ServiceFault_Encoding_DefaultJson"] = 15090] = "ServiceFault_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SessionlessInvokeRequestType_Encoding_DefaultJson"] = 15091] = "SessionlessInvokeRequestType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SessionlessInvokeResponseType_Encoding_DefaultJson"] = 15092] = "SessionlessInvokeResponseType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["FindServersRequest_Encoding_DefaultJson"] = 15093] = "FindServersRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["FindServersResponse_Encoding_DefaultJson"] = 15094] = "FindServersResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ServerOnNetwork_Encoding_DefaultJson"] = 15095] = "ServerOnNetwork_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["FindServersOnNetworkRequest_Encoding_DefaultJson"] = 15096] = "FindServersOnNetworkRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["FindServersOnNetworkResponse_Encoding_DefaultJson"] = 15097] = "FindServersOnNetworkResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["UserTokenPolicy_Encoding_DefaultJson"] = 15098] = "UserTokenPolicy_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["EndpointDescription_Encoding_DefaultJson"] = 15099] = "EndpointDescription_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["GetEndpointsRequest_Encoding_DefaultJson"] = 15100] = "GetEndpointsRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["GetEndpointsResponse_Encoding_DefaultJson"] = 15101] = "GetEndpointsResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["RegisteredServer_Encoding_DefaultJson"] = 15102] = "RegisteredServer_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["RegisterServerRequest_Encoding_DefaultJson"] = 15103] = "RegisterServerRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["RegisterServerResponse_Encoding_DefaultJson"] = 15104] = "RegisterServerResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DiscoveryConfiguration_Encoding_DefaultJson"] = 15105] = "DiscoveryConfiguration_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["MdnsDiscoveryConfiguration_Encoding_DefaultJson"] = 15106] = "MdnsDiscoveryConfiguration_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["RegisterServer2Request_Encoding_DefaultJson"] = 15107] = "RegisterServer2Request_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["RegisterServer2Response_Encoding_DefaultJson"] = 15130] = "RegisterServer2Response_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ChannelSecurityToken_Encoding_DefaultJson"] = 15131] = "ChannelSecurityToken_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["OpenSecureChannelRequest_Encoding_DefaultJson"] = 15132] = "OpenSecureChannelRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["OpenSecureChannelResponse_Encoding_DefaultJson"] = 15133] = "OpenSecureChannelResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["CloseSecureChannelRequest_Encoding_DefaultJson"] = 15134] = "CloseSecureChannelRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["CloseSecureChannelResponse_Encoding_DefaultJson"] = 15135] = "CloseSecureChannelResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SignedSoftwareCertificate_Encoding_DefaultJson"] = 15136] = "SignedSoftwareCertificate_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SignatureData_Encoding_DefaultJson"] = 15137] = "SignatureData_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["CreateSessionRequest_Encoding_DefaultJson"] = 15138] = "CreateSessionRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["CreateSessionResponse_Encoding_DefaultJson"] = 15139] = "CreateSessionResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["UserIdentityToken_Encoding_DefaultJson"] = 15140] = "UserIdentityToken_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["AnonymousIdentityToken_Encoding_DefaultJson"] = 15141] = "AnonymousIdentityToken_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["UserNameIdentityToken_Encoding_DefaultJson"] = 15142] = "UserNameIdentityToken_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["X509IdentityToken_Encoding_DefaultJson"] = 15143] = "X509IdentityToken_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["IssuedIdentityToken_Encoding_DefaultJson"] = 15144] = "IssuedIdentityToken_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ActivateSessionRequest_Encoding_DefaultJson"] = 15145] = "ActivateSessionRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ActivateSessionResponse_Encoding_DefaultJson"] = 15146] = "ActivateSessionResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["CloseSessionRequest_Encoding_DefaultJson"] = 15147] = "CloseSessionRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["CloseSessionResponse_Encoding_DefaultJson"] = 15148] = "CloseSessionResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["CancelRequest_Encoding_DefaultJson"] = 15149] = "CancelRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["CancelResponse_Encoding_DefaultJson"] = 15150] = "CancelResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["NodeAttributes_Encoding_DefaultJson"] = 15151] = "NodeAttributes_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ObjectAttributes_Encoding_DefaultJson"] = 15152] = "ObjectAttributes_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["VariableAttributes_Encoding_DefaultJson"] = 15153] = "VariableAttributes_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["MethodAttributes_Encoding_DefaultJson"] = 15157] = "MethodAttributes_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ObjectTypeAttributes_Encoding_DefaultJson"] = 15158] = "ObjectTypeAttributes_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["VariableTypeAttributes_Encoding_DefaultJson"] = 15159] = "VariableTypeAttributes_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ReferenceTypeAttributes_Encoding_DefaultJson"] = 15160] = "ReferenceTypeAttributes_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DataTypeAttributes_Encoding_DefaultJson"] = 15161] = "DataTypeAttributes_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ViewAttributes_Encoding_DefaultJson"] = 15162] = "ViewAttributes_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["GenericAttributeValue_Encoding_DefaultJson"] = 15163] = "GenericAttributeValue_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["GenericAttributes_Encoding_DefaultJson"] = 15164] = "GenericAttributes_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["AddNodesItem_Encoding_DefaultJson"] = 15165] = "AddNodesItem_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["AddNodesResult_Encoding_DefaultJson"] = 15166] = "AddNodesResult_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["AddNodesRequest_Encoding_DefaultJson"] = 15167] = "AddNodesRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["AddNodesResponse_Encoding_DefaultJson"] = 15168] = "AddNodesResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["AddReferencesItem_Encoding_DefaultJson"] = 15169] = "AddReferencesItem_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["AddReferencesRequest_Encoding_DefaultJson"] = 15170] = "AddReferencesRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["AddReferencesResponse_Encoding_DefaultJson"] = 15171] = "AddReferencesResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DeleteNodesItem_Encoding_DefaultJson"] = 15172] = "DeleteNodesItem_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DeleteNodesRequest_Encoding_DefaultJson"] = 15173] = "DeleteNodesRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DeleteNodesResponse_Encoding_DefaultJson"] = 15174] = "DeleteNodesResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DeleteReferencesItem_Encoding_DefaultJson"] = 15175] = "DeleteReferencesItem_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DeleteReferencesRequest_Encoding_DefaultJson"] = 15176] = "DeleteReferencesRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DeleteReferencesResponse_Encoding_DefaultJson"] = 15177] = "DeleteReferencesResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ViewDescription_Encoding_DefaultJson"] = 15179] = "ViewDescription_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["BrowseDescription_Encoding_DefaultJson"] = 15180] = "BrowseDescription_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ReferenceDescription_Encoding_DefaultJson"] = 15182] = "ReferenceDescription_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["BrowseResult_Encoding_DefaultJson"] = 15183] = "BrowseResult_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["BrowseRequest_Encoding_DefaultJson"] = 15184] = "BrowseRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["BrowseResponse_Encoding_DefaultJson"] = 15185] = "BrowseResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["BrowseNextRequest_Encoding_DefaultJson"] = 15186] = "BrowseNextRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["BrowseNextResponse_Encoding_DefaultJson"] = 15187] = "BrowseNextResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["RelativePathElement_Encoding_DefaultJson"] = 15188] = "RelativePathElement_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["RelativePath_Encoding_DefaultJson"] = 15189] = "RelativePath_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["BrowsePath_Encoding_DefaultJson"] = 15190] = "BrowsePath_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["BrowsePathTarget_Encoding_DefaultJson"] = 15191] = "BrowsePathTarget_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["BrowsePathResult_Encoding_DefaultJson"] = 15192] = "BrowsePathResult_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["TranslateBrowsePathsToNodeIdsRequest_Encoding_DefaultJson"] = 15193] = "TranslateBrowsePathsToNodeIdsRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["TranslateBrowsePathsToNodeIdsResponse_Encoding_DefaultJson"] = 15194] = "TranslateBrowsePathsToNodeIdsResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["RegisterNodesRequest_Encoding_DefaultJson"] = 15195] = "RegisterNodesRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["RegisterNodesResponse_Encoding_DefaultJson"] = 15196] = "RegisterNodesResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["UnregisterNodesRequest_Encoding_DefaultJson"] = 15197] = "UnregisterNodesRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["UnregisterNodesResponse_Encoding_DefaultJson"] = 15198] = "UnregisterNodesResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["EndpointConfiguration_Encoding_DefaultJson"] = 15199] = "EndpointConfiguration_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["QueryDataDescription_Encoding_DefaultJson"] = 15200] = "QueryDataDescription_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["NodeTypeDescription_Encoding_DefaultJson"] = 15201] = "NodeTypeDescription_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["QueryDataSet_Encoding_DefaultJson"] = 15202] = "QueryDataSet_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["NodeReference_Encoding_DefaultJson"] = 15203] = "NodeReference_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ContentFilterElement_Encoding_DefaultJson"] = 15204] = "ContentFilterElement_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ContentFilter_Encoding_DefaultJson"] = 15205] = "ContentFilter_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["FilterOperand_Encoding_DefaultJson"] = 15206] = "FilterOperand_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ElementOperand_Encoding_DefaultJson"] = 15207] = "ElementOperand_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["LiteralOperand_Encoding_DefaultJson"] = 15208] = "LiteralOperand_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["AttributeOperand_Encoding_DefaultJson"] = 15209] = "AttributeOperand_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SimpleAttributeOperand_Encoding_DefaultJson"] = 15210] = "SimpleAttributeOperand_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ContentFilterElementResult_Encoding_DefaultJson"] = 15211] = "ContentFilterElementResult_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ContentFilterResult_Encoding_DefaultJson"] = 15228] = "ContentFilterResult_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ParsingResult_Encoding_DefaultJson"] = 15236] = "ParsingResult_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["QueryFirstRequest_Encoding_DefaultJson"] = 15244] = "QueryFirstRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["QueryFirstResponse_Encoding_DefaultJson"] = 15252] = "QueryFirstResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["QueryNextRequest_Encoding_DefaultJson"] = 15254] = "QueryNextRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["QueryNextResponse_Encoding_DefaultJson"] = 15255] = "QueryNextResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ReadValueId_Encoding_DefaultJson"] = 15256] = "ReadValueId_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ReadRequest_Encoding_DefaultJson"] = 15257] = "ReadRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ReadResponse_Encoding_DefaultJson"] = 15258] = "ReadResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["HistoryReadValueId_Encoding_DefaultJson"] = 15259] = "HistoryReadValueId_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["HistoryReadResult_Encoding_DefaultJson"] = 15260] = "HistoryReadResult_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["HistoryReadDetails_Encoding_DefaultJson"] = 15261] = "HistoryReadDetails_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ReadEventDetails_Encoding_DefaultJson"] = 15262] = "ReadEventDetails_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ReadRawModifiedDetails_Encoding_DefaultJson"] = 15263] = "ReadRawModifiedDetails_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ReadProcessedDetails_Encoding_DefaultJson"] = 15264] = "ReadProcessedDetails_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ReadAtTimeDetails_Encoding_DefaultJson"] = 15269] = "ReadAtTimeDetails_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["HistoryData_Encoding_DefaultJson"] = 15270] = "HistoryData_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ModificationInfo_Encoding_DefaultJson"] = 15271] = "ModificationInfo_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["HistoryModifiedData_Encoding_DefaultJson"] = 15272] = "HistoryModifiedData_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["HistoryEvent_Encoding_DefaultJson"] = 15273] = "HistoryEvent_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["HistoryReadRequest_Encoding_DefaultJson"] = 15274] = "HistoryReadRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["HistoryReadResponse_Encoding_DefaultJson"] = 15275] = "HistoryReadResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["WriteValue_Encoding_DefaultJson"] = 15276] = "WriteValue_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["WriteRequest_Encoding_DefaultJson"] = 15277] = "WriteRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["WriteResponse_Encoding_DefaultJson"] = 15278] = "WriteResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["HistoryUpdateDetails_Encoding_DefaultJson"] = 15279] = "HistoryUpdateDetails_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["UpdateDataDetails_Encoding_DefaultJson"] = 15280] = "UpdateDataDetails_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["UpdateStructureDataDetails_Encoding_DefaultJson"] = 15281] = "UpdateStructureDataDetails_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["UpdateEventDetails_Encoding_DefaultJson"] = 15282] = "UpdateEventDetails_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DeleteRawModifiedDetails_Encoding_DefaultJson"] = 15283] = "DeleteRawModifiedDetails_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DeleteAtTimeDetails_Encoding_DefaultJson"] = 15284] = "DeleteAtTimeDetails_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DeleteEventDetails_Encoding_DefaultJson"] = 15285] = "DeleteEventDetails_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["HistoryUpdateResult_Encoding_DefaultJson"] = 15286] = "HistoryUpdateResult_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["HistoryUpdateRequest_Encoding_DefaultJson"] = 15287] = "HistoryUpdateRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["HistoryUpdateResponse_Encoding_DefaultJson"] = 15288] = "HistoryUpdateResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["CallMethodRequest_Encoding_DefaultJson"] = 15289] = "CallMethodRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["CallMethodResult_Encoding_DefaultJson"] = 15290] = "CallMethodResult_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["CallRequest_Encoding_DefaultJson"] = 15291] = "CallRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["CallResponse_Encoding_DefaultJson"] = 15292] = "CallResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["MonitoringFilter_Encoding_DefaultJson"] = 15293] = "MonitoringFilter_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DataChangeFilter_Encoding_DefaultJson"] = 15294] = "DataChangeFilter_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["EventFilter_Encoding_DefaultJson"] = 15295] = "EventFilter_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["AggregateConfiguration_Encoding_DefaultJson"] = 15304] = "AggregateConfiguration_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["AggregateFilter_Encoding_DefaultJson"] = 15312] = "AggregateFilter_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["MonitoringFilterResult_Encoding_DefaultJson"] = 15313] = "MonitoringFilterResult_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["EventFilterResult_Encoding_DefaultJson"] = 15314] = "EventFilterResult_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["AggregateFilterResult_Encoding_DefaultJson"] = 15315] = "AggregateFilterResult_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["MonitoringParameters_Encoding_DefaultJson"] = 15320] = "MonitoringParameters_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["MonitoredItemCreateRequest_Encoding_DefaultJson"] = 15321] = "MonitoredItemCreateRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["MonitoredItemCreateResult_Encoding_DefaultJson"] = 15322] = "MonitoredItemCreateResult_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["CreateMonitoredItemsRequest_Encoding_DefaultJson"] = 15323] = "CreateMonitoredItemsRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["CreateMonitoredItemsResponse_Encoding_DefaultJson"] = 15324] = "CreateMonitoredItemsResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["MonitoredItemModifyRequest_Encoding_DefaultJson"] = 15325] = "MonitoredItemModifyRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["MonitoredItemModifyResult_Encoding_DefaultJson"] = 15326] = "MonitoredItemModifyResult_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ModifyMonitoredItemsRequest_Encoding_DefaultJson"] = 15327] = "ModifyMonitoredItemsRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ModifyMonitoredItemsResponse_Encoding_DefaultJson"] = 15328] = "ModifyMonitoredItemsResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SetMonitoringModeRequest_Encoding_DefaultJson"] = 15329] = "SetMonitoringModeRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SetMonitoringModeResponse_Encoding_DefaultJson"] = 15331] = "SetMonitoringModeResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SetTriggeringRequest_Encoding_DefaultJson"] = 15332] = "SetTriggeringRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SetTriggeringResponse_Encoding_DefaultJson"] = 15333] = "SetTriggeringResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DeleteMonitoredItemsRequest_Encoding_DefaultJson"] = 15335] = "DeleteMonitoredItemsRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DeleteMonitoredItemsResponse_Encoding_DefaultJson"] = 15336] = "DeleteMonitoredItemsResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["CreateSubscriptionRequest_Encoding_DefaultJson"] = 15337] = "CreateSubscriptionRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["CreateSubscriptionResponse_Encoding_DefaultJson"] = 15338] = "CreateSubscriptionResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ModifySubscriptionRequest_Encoding_DefaultJson"] = 15339] = "ModifySubscriptionRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ModifySubscriptionResponse_Encoding_DefaultJson"] = 15340] = "ModifySubscriptionResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SetPublishingModeRequest_Encoding_DefaultJson"] = 15341] = "SetPublishingModeRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SetPublishingModeResponse_Encoding_DefaultJson"] = 15342] = "SetPublishingModeResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["NotificationMessage_Encoding_DefaultJson"] = 15343] = "NotificationMessage_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["NotificationData_Encoding_DefaultJson"] = 15344] = "NotificationData_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DataChangeNotification_Encoding_DefaultJson"] = 15345] = "DataChangeNotification_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["MonitoredItemNotification_Encoding_DefaultJson"] = 15346] = "MonitoredItemNotification_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["EventNotificationList_Encoding_DefaultJson"] = 15347] = "EventNotificationList_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["EventFieldList_Encoding_DefaultJson"] = 15348] = "EventFieldList_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["HistoryEventFieldList_Encoding_DefaultJson"] = 15349] = "HistoryEventFieldList_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["StatusChangeNotification_Encoding_DefaultJson"] = 15350] = "StatusChangeNotification_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SubscriptionAcknowledgement_Encoding_DefaultJson"] = 15351] = "SubscriptionAcknowledgement_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["PublishRequest_Encoding_DefaultJson"] = 15352] = "PublishRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["PublishResponse_Encoding_DefaultJson"] = 15353] = "PublishResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["RepublishRequest_Encoding_DefaultJson"] = 15354] = "RepublishRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["RepublishResponse_Encoding_DefaultJson"] = 15355] = "RepublishResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["TransferResult_Encoding_DefaultJson"] = 15356] = "TransferResult_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["TransferSubscriptionsRequest_Encoding_DefaultJson"] = 15357] = "TransferSubscriptionsRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["TransferSubscriptionsResponse_Encoding_DefaultJson"] = 15358] = "TransferSubscriptionsResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DeleteSubscriptionsRequest_Encoding_DefaultJson"] = 15359] = "DeleteSubscriptionsRequest_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DeleteSubscriptionsResponse_Encoding_DefaultJson"] = 15360] = "DeleteSubscriptionsResponse_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["BuildInfo_Encoding_DefaultJson"] = 15361] = "BuildInfo_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["RedundantServerDataType_Encoding_DefaultJson"] = 15362] = "RedundantServerDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["EndpointUrlListDataType_Encoding_DefaultJson"] = 15363] = "EndpointUrlListDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["NetworkGroupDataType_Encoding_DefaultJson"] = 15364] = "NetworkGroupDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SamplingIntervalDiagnosticsDataType_Encoding_DefaultJson"] = 15365] = "SamplingIntervalDiagnosticsDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ServerDiagnosticsSummaryDataType_Encoding_DefaultJson"] = 15366] = "ServerDiagnosticsSummaryDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ServerStatusDataType_Encoding_DefaultJson"] = 15367] = "ServerStatusDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SessionDiagnosticsDataType_Encoding_DefaultJson"] = 15368] = "SessionDiagnosticsDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SessionSecurityDiagnosticsDataType_Encoding_DefaultJson"] = 15369] = "SessionSecurityDiagnosticsDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ServiceCounterDataType_Encoding_DefaultJson"] = 15370] = "ServiceCounterDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["StatusResult_Encoding_DefaultJson"] = 15371] = "StatusResult_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SubscriptionDiagnosticsDataType_Encoding_DefaultJson"] = 15372] = "SubscriptionDiagnosticsDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ModelChangeStructureDataType_Encoding_DefaultJson"] = 15373] = "ModelChangeStructureDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SemanticChangeStructureDataType_Encoding_DefaultJson"] = 15374] = "SemanticChangeStructureDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["Range_Encoding_DefaultJson"] = 15375] = "Range_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["EUInformation_Encoding_DefaultJson"] = 15376] = "EUInformation_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ComplexNumberType_Encoding_DefaultJson"] = 15377] = "ComplexNumberType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DoubleComplexNumberType_Encoding_DefaultJson"] = 15378] = "DoubleComplexNumberType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["AxisInformation_Encoding_DefaultJson"] = 15379] = "AxisInformation_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["XVType_Encoding_DefaultJson"] = 15380] = "XVType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ProgramDiagnosticDataType_Encoding_DefaultJson"] = 15381] = "ProgramDiagnosticDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["Annotation_Encoding_DefaultJson"] = 15382] = "Annotation_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SimpleTypeDescription_Encoding_DefaultBinary"] = 15421] = "SimpleTypeDescription_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["UABinaryFileDataType_Encoding_DefaultBinary"] = 15422] = "UABinaryFileDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["PublishSubscribe_SecurityGroups"] = 15443] = "PublishSubscribe_SecurityGroups";
      ObjectIds2[ObjectIds2["BrokerConnectionTransportDataType_Encoding_DefaultBinary"] = 15479] = "BrokerConnectionTransportDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["SimpleTypeDescription_Encoding_DefaultXml"] = 15529] = "SimpleTypeDescription_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["UABinaryFileDataType_Encoding_DefaultXml"] = 15531] = "UABinaryFileDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["BrokerConnectionTransportDataType_Encoding_DefaultXml"] = 15579] = "BrokerConnectionTransportDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["StructureDescription_Encoding_DefaultXml"] = 15589] = "StructureDescription_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["EnumDescription_Encoding_DefaultXml"] = 15590] = "EnumDescription_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["Server_ServerCapabilities_RoleSet"] = 15606] = "Server_ServerCapabilities_RoleSet";
      ObjectIds2[ObjectIds2["WellKnownRole_Anonymous"] = 15644] = "WellKnownRole_Anonymous";
      ObjectIds2[ObjectIds2["WellKnownRole_AuthenticatedUser"] = 15656] = "WellKnownRole_AuthenticatedUser";
      ObjectIds2[ObjectIds2["WellKnownRole_Observer"] = 15668] = "WellKnownRole_Observer";
      ObjectIds2[ObjectIds2["EndpointType_Encoding_DefaultBinary"] = 15671] = "EndpointType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DataTypeSchemaHeader_Encoding_DefaultBinary"] = 15676] = "DataTypeSchemaHeader_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["PublishedDataSetDataType_Encoding_DefaultBinary"] = 15677] = "PublishedDataSetDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["PublishedDataSetSourceDataType_Encoding_DefaultBinary"] = 15678] = "PublishedDataSetSourceDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["PublishedDataItemsDataType_Encoding_DefaultBinary"] = 15679] = "PublishedDataItemsDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["WellKnownRole_Operator"] = 15680] = "WellKnownRole_Operator";
      ObjectIds2[ObjectIds2["PublishedEventsDataType_Encoding_DefaultBinary"] = 15681] = "PublishedEventsDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DataSetWriterDataType_Encoding_DefaultBinary"] = 15682] = "DataSetWriterDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DataSetWriterTransportDataType_Encoding_DefaultBinary"] = 15683] = "DataSetWriterTransportDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DataSetWriterMessageDataType_Encoding_DefaultBinary"] = 15688] = "DataSetWriterMessageDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["PubSubGroupDataType_Encoding_DefaultBinary"] = 15689] = "PubSubGroupDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["WriterGroupTransportDataType_Encoding_DefaultBinary"] = 15691] = "WriterGroupTransportDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["WellKnownRole_Supervisor"] = 15692] = "WellKnownRole_Supervisor";
      ObjectIds2[ObjectIds2["WriterGroupMessageDataType_Encoding_DefaultBinary"] = 15693] = "WriterGroupMessageDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["PubSubConnectionDataType_Encoding_DefaultBinary"] = 15694] = "PubSubConnectionDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ConnectionTransportDataType_Encoding_DefaultBinary"] = 15695] = "ConnectionTransportDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["SimpleTypeDescription_Encoding_DefaultJson"] = 15700] = "SimpleTypeDescription_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ReaderGroupTransportDataType_Encoding_DefaultBinary"] = 15701] = "ReaderGroupTransportDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ReaderGroupMessageDataType_Encoding_DefaultBinary"] = 15702] = "ReaderGroupMessageDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DataSetReaderDataType_Encoding_DefaultBinary"] = 15703] = "DataSetReaderDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["WellKnownRole_SecurityAdmin"] = 15704] = "WellKnownRole_SecurityAdmin";
      ObjectIds2[ObjectIds2["DataSetReaderTransportDataType_Encoding_DefaultBinary"] = 15705] = "DataSetReaderTransportDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DataSetReaderMessageDataType_Encoding_DefaultBinary"] = 15706] = "DataSetReaderMessageDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["SubscribedDataSetDataType_Encoding_DefaultBinary"] = 15707] = "SubscribedDataSetDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["TargetVariablesDataType_Encoding_DefaultBinary"] = 15712] = "TargetVariablesDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["SubscribedDataSetMirrorDataType_Encoding_DefaultBinary"] = 15713] = "SubscribedDataSetMirrorDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["UABinaryFileDataType_Encoding_DefaultJson"] = 15714] = "UABinaryFileDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["UadpWriterGroupMessageDataType_Encoding_DefaultBinary"] = 15715] = "UadpWriterGroupMessageDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["WellKnownRole_ConfigureAdmin"] = 15716] = "WellKnownRole_ConfigureAdmin";
      ObjectIds2[ObjectIds2["UadpDataSetWriterMessageDataType_Encoding_DefaultBinary"] = 15717] = "UadpDataSetWriterMessageDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["UadpDataSetReaderMessageDataType_Encoding_DefaultBinary"] = 15718] = "UadpDataSetReaderMessageDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["JsonWriterGroupMessageDataType_Encoding_DefaultBinary"] = 15719] = "JsonWriterGroupMessageDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["JsonDataSetWriterMessageDataType_Encoding_DefaultBinary"] = 15724] = "JsonDataSetWriterMessageDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["JsonDataSetReaderMessageDataType_Encoding_DefaultBinary"] = 15725] = "JsonDataSetReaderMessageDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["BrokerConnectionTransportDataType_Encoding_DefaultJson"] = 15726] = "BrokerConnectionTransportDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["BrokerWriterGroupTransportDataType_Encoding_DefaultBinary"] = 15727] = "BrokerWriterGroupTransportDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["IdentityMappingRuleType_Encoding_DefaultXml"] = 15728] = "IdentityMappingRuleType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["BrokerDataSetWriterTransportDataType_Encoding_DefaultBinary"] = 15729] = "BrokerDataSetWriterTransportDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["BrokerDataSetReaderTransportDataType_Encoding_DefaultBinary"] = 15733] = "BrokerDataSetReaderTransportDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["IdentityMappingRuleType_Encoding_DefaultBinary"] = 15736] = "IdentityMappingRuleType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["SessionlessInvokeRequestType_Encoding_DefaultXml"] = 15902] = "SessionlessInvokeRequestType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["SessionlessInvokeRequestType_Encoding_DefaultBinary"] = 15903] = "SessionlessInvokeRequestType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["EndpointType_Encoding_DefaultXml"] = 15949] = "EndpointType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DataTypeSchemaHeader_Encoding_DefaultXml"] = 15950] = "DataTypeSchemaHeader_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["PublishedDataSetDataType_Encoding_DefaultXml"] = 15951] = "PublishedDataSetDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["PublishedDataSetSourceDataType_Encoding_DefaultXml"] = 15952] = "PublishedDataSetSourceDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["PublishedDataItemsDataType_Encoding_DefaultXml"] = 15953] = "PublishedDataItemsDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["PublishedEventsDataType_Encoding_DefaultXml"] = 15954] = "PublishedEventsDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DataSetWriterDataType_Encoding_DefaultXml"] = 15955] = "DataSetWriterDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DataSetWriterTransportDataType_Encoding_DefaultXml"] = 15956] = "DataSetWriterTransportDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["OPCUANamespaceMetadata"] = 15957] = "OPCUANamespaceMetadata";
      ObjectIds2[ObjectIds2["OPCUANamespaceMetadata_NamespaceFile"] = 15965] = "OPCUANamespaceMetadata_NamespaceFile";
      ObjectIds2[ObjectIds2["DataSetWriterMessageDataType_Encoding_DefaultXml"] = 15987] = "DataSetWriterMessageDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["PubSubGroupDataType_Encoding_DefaultXml"] = 15988] = "PubSubGroupDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["WriterGroupTransportDataType_Encoding_DefaultXml"] = 15990] = "WriterGroupTransportDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["WriterGroupMessageDataType_Encoding_DefaultXml"] = 15991] = "WriterGroupMessageDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["PubSubConnectionDataType_Encoding_DefaultXml"] = 15992] = "PubSubConnectionDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ConnectionTransportDataType_Encoding_DefaultXml"] = 15993] = "ConnectionTransportDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ReaderGroupTransportDataType_Encoding_DefaultXml"] = 15995] = "ReaderGroupTransportDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ReaderGroupMessageDataType_Encoding_DefaultXml"] = 15996] = "ReaderGroupMessageDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DataSetReaderDataType_Encoding_DefaultXml"] = 16007] = "DataSetReaderDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DataSetReaderTransportDataType_Encoding_DefaultXml"] = 16008] = "DataSetReaderTransportDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DataSetReaderMessageDataType_Encoding_DefaultXml"] = 16009] = "DataSetReaderMessageDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["SubscribedDataSetDataType_Encoding_DefaultXml"] = 16010] = "SubscribedDataSetDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["TargetVariablesDataType_Encoding_DefaultXml"] = 16011] = "TargetVariablesDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["SubscribedDataSetMirrorDataType_Encoding_DefaultXml"] = 16012] = "SubscribedDataSetMirrorDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["UadpWriterGroupMessageDataType_Encoding_DefaultXml"] = 16014] = "UadpWriterGroupMessageDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["UadpDataSetWriterMessageDataType_Encoding_DefaultXml"] = 16015] = "UadpDataSetWriterMessageDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["UadpDataSetReaderMessageDataType_Encoding_DefaultXml"] = 16016] = "UadpDataSetReaderMessageDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["JsonWriterGroupMessageDataType_Encoding_DefaultXml"] = 16017] = "JsonWriterGroupMessageDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["JsonDataSetWriterMessageDataType_Encoding_DefaultXml"] = 16018] = "JsonDataSetWriterMessageDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["JsonDataSetReaderMessageDataType_Encoding_DefaultXml"] = 16019] = "JsonDataSetReaderMessageDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["BrokerWriterGroupTransportDataType_Encoding_DefaultXml"] = 16021] = "BrokerWriterGroupTransportDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["BrokerDataSetWriterTransportDataType_Encoding_DefaultXml"] = 16022] = "BrokerDataSetWriterTransportDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["BrokerDataSetReaderTransportDataType_Encoding_DefaultXml"] = 16023] = "BrokerDataSetReaderTransportDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["WellKnownRole_Engineer"] = 16036] = "WellKnownRole_Engineer";
      ObjectIds2[ObjectIds2["RolePermissionType_Encoding_DefaultXml"] = 16126] = "RolePermissionType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["EndpointType_Encoding_DefaultJson"] = 16150] = "EndpointType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DataTypeSchemaHeader_Encoding_DefaultJson"] = 16151] = "DataTypeSchemaHeader_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["PublishedDataSetDataType_Encoding_DefaultJson"] = 16152] = "PublishedDataSetDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["PublishedDataSetSourceDataType_Encoding_DefaultJson"] = 16153] = "PublishedDataSetSourceDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["PublishedDataItemsDataType_Encoding_DefaultJson"] = 16154] = "PublishedDataItemsDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["PublishedEventsDataType_Encoding_DefaultJson"] = 16155] = "PublishedEventsDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DataSetWriterDataType_Encoding_DefaultJson"] = 16156] = "DataSetWriterDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DataSetWriterTransportDataType_Encoding_DefaultJson"] = 16157] = "DataSetWriterTransportDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DataSetWriterMessageDataType_Encoding_DefaultJson"] = 16158] = "DataSetWriterMessageDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["PubSubGroupDataType_Encoding_DefaultJson"] = 16159] = "PubSubGroupDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["WriterGroupTransportDataType_Encoding_DefaultJson"] = 16161] = "WriterGroupTransportDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["WriterGroupMessageDataType_Encoding_DefaultJson"] = 16280] = "WriterGroupMessageDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["PubSubConnectionDataType_Encoding_DefaultJson"] = 16281] = "PubSubConnectionDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ConnectionTransportDataType_Encoding_DefaultJson"] = 16282] = "ConnectionTransportDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ReaderGroupTransportDataType_Encoding_DefaultJson"] = 16284] = "ReaderGroupTransportDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ReaderGroupMessageDataType_Encoding_DefaultJson"] = 16285] = "ReaderGroupMessageDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DataSetReaderDataType_Encoding_DefaultJson"] = 16286] = "DataSetReaderDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DataSetReaderTransportDataType_Encoding_DefaultJson"] = 16287] = "DataSetReaderTransportDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DataSetReaderMessageDataType_Encoding_DefaultJson"] = 16288] = "DataSetReaderMessageDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SubscribedDataSetDataType_Encoding_DefaultJson"] = 16308] = "SubscribedDataSetDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["TargetVariablesDataType_Encoding_DefaultJson"] = 16310] = "TargetVariablesDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SubscribedDataSetMirrorDataType_Encoding_DefaultJson"] = 16311] = "SubscribedDataSetMirrorDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["FileSystem"] = 16314] = "FileSystem";
      ObjectIds2[ObjectIds2["UadpWriterGroupMessageDataType_Encoding_DefaultJson"] = 16323] = "UadpWriterGroupMessageDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["UadpDataSetWriterMessageDataType_Encoding_DefaultJson"] = 16391] = "UadpDataSetWriterMessageDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["UadpDataSetReaderMessageDataType_Encoding_DefaultJson"] = 16392] = "UadpDataSetReaderMessageDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["JsonWriterGroupMessageDataType_Encoding_DefaultJson"] = 16393] = "JsonWriterGroupMessageDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["JsonDataSetWriterMessageDataType_Encoding_DefaultJson"] = 16394] = "JsonDataSetWriterMessageDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["JsonDataSetReaderMessageDataType_Encoding_DefaultJson"] = 16404] = "JsonDataSetReaderMessageDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["BrokerWriterGroupTransportDataType_Encoding_DefaultJson"] = 16524] = "BrokerWriterGroupTransportDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["BrokerDataSetWriterTransportDataType_Encoding_DefaultJson"] = 16525] = "BrokerDataSetWriterTransportDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["BrokerDataSetReaderTransportDataType_Encoding_DefaultJson"] = 16526] = "BrokerDataSetReaderTransportDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["PublishSubscribe_PublishedDataSets"] = 17371] = "PublishSubscribe_PublishedDataSets";
      ObjectIds2[ObjectIds2["PublishSubscribe_Status"] = 17405] = "PublishSubscribe_Status";
      ObjectIds2[ObjectIds2["PublishSubscribe_Diagnostics"] = 17409] = "PublishSubscribe_Diagnostics";
      ObjectIds2[ObjectIds2["PublishSubscribe_Diagnostics_Counters"] = 17423] = "PublishSubscribe_Diagnostics_Counters";
      ObjectIds2[ObjectIds2["PublishSubscribe_Diagnostics_LiveValues"] = 17457] = "PublishSubscribe_Diagnostics_LiveValues";
      ObjectIds2[ObjectIds2["DatagramConnectionTransportDataType_Encoding_DefaultBinary"] = 17468] = "DatagramConnectionTransportDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DatagramConnectionTransportDataType_Encoding_DefaultXml"] = 17472] = "DatagramConnectionTransportDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DatagramConnectionTransportDataType_Encoding_DefaultJson"] = 17476] = "DatagramConnectionTransportDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["AdditionalParametersType_Encoding_DefaultBinary"] = 17537] = "AdditionalParametersType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["AdditionalParametersType_Encoding_DefaultXml"] = 17541] = "AdditionalParametersType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["AdditionalParametersType_Encoding_DefaultJson"] = 17547] = "AdditionalParametersType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["EphemeralKeyType_Encoding_DefaultBinary"] = 17549] = "EphemeralKeyType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["EphemeralKeyType_Encoding_DefaultXml"] = 17553] = "EphemeralKeyType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["EphemeralKeyType_Encoding_DefaultJson"] = 17557] = "EphemeralKeyType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["Dictionaries"] = 17594] = "Dictionaries";
      ObjectIds2[ObjectIds2["GenericAttributeValue_Encoding_DefaultXml"] = 17608] = "GenericAttributeValue_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["GenericAttributes_Encoding_DefaultXml"] = 17609] = "GenericAttributes_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["GenericAttributeValue_Encoding_DefaultBinary"] = 17610] = "GenericAttributeValue_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["GenericAttributes_Encoding_DefaultBinary"] = 17611] = "GenericAttributes_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["InterfaceTypes"] = 17708] = "InterfaceTypes";
      ObjectIds2[ObjectIds2["AuthorizationServices"] = 17732] = "AuthorizationServices";
      ObjectIds2[ObjectIds2["DecimalDataType_Encoding_DefaultXml"] = 17862] = "DecimalDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DecimalDataType_Encoding_DefaultBinary"] = 17863] = "DecimalDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["KeyCredentialConfiguration"] = 18155] = "KeyCredentialConfiguration";
      ObjectIds2[ObjectIds2["RationalNumber_Encoding_DefaultBinary"] = 18815] = "RationalNumber_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["Vector_Encoding_DefaultBinary"] = 18816] = "Vector_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ThreeDVector_Encoding_DefaultBinary"] = 18817] = "ThreeDVector_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["CartesianCoordinates_Encoding_DefaultBinary"] = 18818] = "CartesianCoordinates_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ThreeDCartesianCoordinates_Encoding_DefaultBinary"] = 18819] = "ThreeDCartesianCoordinates_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["Orientation_Encoding_DefaultBinary"] = 18820] = "Orientation_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ThreeDOrientation_Encoding_DefaultBinary"] = 18821] = "ThreeDOrientation_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["Frame_Encoding_DefaultBinary"] = 18822] = "Frame_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ThreeDFrame_Encoding_DefaultBinary"] = 18823] = "ThreeDFrame_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["RationalNumber_Encoding_DefaultXml"] = 18851] = "RationalNumber_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["Vector_Encoding_DefaultXml"] = 18852] = "Vector_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ThreeDVector_Encoding_DefaultXml"] = 18853] = "ThreeDVector_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["CartesianCoordinates_Encoding_DefaultXml"] = 18854] = "CartesianCoordinates_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ThreeDCartesianCoordinates_Encoding_DefaultXml"] = 18855] = "ThreeDCartesianCoordinates_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["Orientation_Encoding_DefaultXml"] = 18856] = "Orientation_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ThreeDOrientation_Encoding_DefaultXml"] = 18857] = "ThreeDOrientation_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["Frame_Encoding_DefaultXml"] = 18858] = "Frame_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ThreeDFrame_Encoding_DefaultXml"] = 18859] = "ThreeDFrame_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["RationalNumber_Encoding_DefaultJson"] = 19064] = "RationalNumber_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["Vector_Encoding_DefaultJson"] = 19065] = "Vector_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ThreeDVector_Encoding_DefaultJson"] = 19066] = "ThreeDVector_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["CartesianCoordinates_Encoding_DefaultJson"] = 19067] = "CartesianCoordinates_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ThreeDCartesianCoordinates_Encoding_DefaultJson"] = 19068] = "ThreeDCartesianCoordinates_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["Orientation_Encoding_DefaultJson"] = 19069] = "Orientation_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ThreeDOrientation_Encoding_DefaultJson"] = 19070] = "ThreeDOrientation_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["Frame_Encoding_DefaultJson"] = 19071] = "Frame_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ThreeDFrame_Encoding_DefaultJson"] = 19072] = "ThreeDFrame_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SessionlessInvokeResponseType_Encoding_DefaultXml"] = 21e3] = "SessionlessInvokeResponseType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["SessionlessInvokeResponseType_Encoding_DefaultBinary"] = 21001] = "SessionlessInvokeResponseType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["WriterGroupDataType_Encoding_DefaultBinary"] = 21150] = "WriterGroupDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["NetworkAddressDataType_Encoding_DefaultBinary"] = 21151] = "NetworkAddressDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["NetworkAddressUrlDataType_Encoding_DefaultBinary"] = 21152] = "NetworkAddressUrlDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ReaderGroupDataType_Encoding_DefaultBinary"] = 21153] = "ReaderGroupDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["PubSubConfigurationDataType_Encoding_DefaultBinary"] = 21154] = "PubSubConfigurationDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DatagramWriterGroupTransportDataType_Encoding_DefaultBinary"] = 21155] = "DatagramWriterGroupTransportDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["WriterGroupDataType_Encoding_DefaultXml"] = 21174] = "WriterGroupDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["NetworkAddressDataType_Encoding_DefaultXml"] = 21175] = "NetworkAddressDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["NetworkAddressUrlDataType_Encoding_DefaultXml"] = 21176] = "NetworkAddressUrlDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ReaderGroupDataType_Encoding_DefaultXml"] = 21177] = "ReaderGroupDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["PubSubConfigurationDataType_Encoding_DefaultXml"] = 21178] = "PubSubConfigurationDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DatagramWriterGroupTransportDataType_Encoding_DefaultXml"] = 21179] = "DatagramWriterGroupTransportDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["WriterGroupDataType_Encoding_DefaultJson"] = 21198] = "WriterGroupDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["NetworkAddressDataType_Encoding_DefaultJson"] = 21199] = "NetworkAddressDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["NetworkAddressUrlDataType_Encoding_DefaultJson"] = 21200] = "NetworkAddressUrlDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ReaderGroupDataType_Encoding_DefaultJson"] = 21201] = "ReaderGroupDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["PubSubConfigurationDataType_Encoding_DefaultJson"] = 21202] = "PubSubConfigurationDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DatagramWriterGroupTransportDataType_Encoding_DefaultJson"] = 21203] = "DatagramWriterGroupTransportDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired"] = 22568] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState"] = 22655] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_FirstInGroup"] = 22693] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_FirstInGroup";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate"] = 22716] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState"] = 22803] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_FirstInGroup"] = 22841] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_FirstInGroup";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired"] = 22864] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState"] = 22951] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_FirstInGroup"] = 22989] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_FirstInGroup";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate"] = 23012] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState"] = 23099] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_FirstInGroup"] = 23137] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_FirstInGroup";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired"] = 23160] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState"] = 23247] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_FirstInGroup"] = 23285] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_FirstInGroup";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate"] = 23308] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState"] = 23395] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState";
      ObjectIds2[ObjectIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_FirstInGroup"] = 23433] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_FirstInGroup";
      ObjectIds2[ObjectIds2["Aliases"] = 23470] = "Aliases";
      ObjectIds2[ObjectIds2["TagVariables"] = 23479] = "TagVariables";
      ObjectIds2[ObjectIds2["Topics"] = 23488] = "Topics";
      ObjectIds2[ObjectIds2["AliasNameDataType_Encoding_DefaultBinary"] = 23499] = "AliasNameDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ReadAnnotationDataDetails_Encoding_DefaultBinary"] = 23500] = "ReadAnnotationDataDetails_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["AliasNameDataType_Encoding_DefaultXml"] = 23505] = "AliasNameDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ReadAnnotationDataDetails_Encoding_DefaultXml"] = 23506] = "ReadAnnotationDataDetails_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["CurrencyUnitType_Encoding_DefaultBinary"] = 23507] = "CurrencyUnitType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["AliasNameDataType_Encoding_DefaultJson"] = 23511] = "AliasNameDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ReadAnnotationDataDetails_Encoding_DefaultJson"] = 23512] = "ReadAnnotationDataDetails_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["CurrencyUnitType_Encoding_DefaultXml"] = 23520] = "CurrencyUnitType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["CurrencyUnitType_Encoding_DefaultJson"] = 23528] = "CurrencyUnitType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["PublishSubscribe_SubscribedDataSets"] = 23658] = "PublishSubscribe_SubscribedDataSets";
      ObjectIds2[ObjectIds2["PublishSubscribe_PubSubCapablities"] = 23678] = "PublishSubscribe_PubSubCapablities";
      ObjectIds2[ObjectIds2["PublishSubscribe_DataSetClasses"] = 23685] = "PublishSubscribe_DataSetClasses";
      ObjectIds2[ObjectIds2["StandaloneSubscribedDataSetRefDataType_Encoding_DefaultBinary"] = 23851] = "StandaloneSubscribedDataSetRefDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["StandaloneSubscribedDataSetDataType_Encoding_DefaultBinary"] = 23852] = "StandaloneSubscribedDataSetDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["SecurityGroupDataType_Encoding_DefaultBinary"] = 23853] = "SecurityGroupDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["PubSubConfiguration2DataType_Encoding_DefaultBinary"] = 23854] = "PubSubConfiguration2DataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["QosDataType_Encoding_DefaultBinary"] = 23855] = "QosDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["TransmitQosDataType_Encoding_DefaultBinary"] = 23856] = "TransmitQosDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["TransmitQosPriorityDataType_Encoding_DefaultBinary"] = 23857] = "TransmitQosPriorityDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ReceiveQosDataType_Encoding_DefaultBinary"] = 23860] = "ReceiveQosDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ReceiveQosPriorityDataType_Encoding_DefaultBinary"] = 23861] = "ReceiveQosPriorityDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DatagramConnectionTransport2DataType_Encoding_DefaultBinary"] = 23864] = "DatagramConnectionTransport2DataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DatagramWriterGroupTransport2DataType_Encoding_DefaultBinary"] = 23865] = "DatagramWriterGroupTransport2DataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["DatagramDataSetReaderTransportDataType_Encoding_DefaultBinary"] = 23866] = "DatagramDataSetReaderTransportDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["StandaloneSubscribedDataSetRefDataType_Encoding_DefaultXml"] = 23919] = "StandaloneSubscribedDataSetRefDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["StandaloneSubscribedDataSetDataType_Encoding_DefaultXml"] = 23920] = "StandaloneSubscribedDataSetDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["SecurityGroupDataType_Encoding_DefaultXml"] = 23921] = "SecurityGroupDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["PubSubConfiguration2DataType_Encoding_DefaultXml"] = 23922] = "PubSubConfiguration2DataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["QosDataType_Encoding_DefaultXml"] = 23923] = "QosDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["TransmitQosDataType_Encoding_DefaultXml"] = 23924] = "TransmitQosDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["TransmitQosPriorityDataType_Encoding_DefaultXml"] = 23925] = "TransmitQosPriorityDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ReceiveQosDataType_Encoding_DefaultXml"] = 23928] = "ReceiveQosDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ReceiveQosPriorityDataType_Encoding_DefaultXml"] = 23929] = "ReceiveQosPriorityDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DatagramConnectionTransport2DataType_Encoding_DefaultXml"] = 23932] = "DatagramConnectionTransport2DataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DatagramWriterGroupTransport2DataType_Encoding_DefaultXml"] = 23933] = "DatagramWriterGroupTransport2DataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["DatagramDataSetReaderTransportDataType_Encoding_DefaultXml"] = 23934] = "DatagramDataSetReaderTransportDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["StandaloneSubscribedDataSetRefDataType_Encoding_DefaultJson"] = 23987] = "StandaloneSubscribedDataSetRefDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["StandaloneSubscribedDataSetDataType_Encoding_DefaultJson"] = 23988] = "StandaloneSubscribedDataSetDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["SecurityGroupDataType_Encoding_DefaultJson"] = 23989] = "SecurityGroupDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["PubSubConfiguration2DataType_Encoding_DefaultJson"] = 23990] = "PubSubConfiguration2DataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["QosDataType_Encoding_DefaultJson"] = 23991] = "QosDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["TransmitQosDataType_Encoding_DefaultJson"] = 23992] = "TransmitQosDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["TransmitQosPriorityDataType_Encoding_DefaultJson"] = 23993] = "TransmitQosPriorityDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ReceiveQosDataType_Encoding_DefaultJson"] = 23996] = "ReceiveQosDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ReceiveQosPriorityDataType_Encoding_DefaultJson"] = 23997] = "ReceiveQosPriorityDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DatagramConnectionTransport2DataType_Encoding_DefaultJson"] = 24e3] = "DatagramConnectionTransport2DataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DatagramWriterGroupTransport2DataType_Encoding_DefaultJson"] = 24001] = "DatagramWriterGroupTransport2DataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DatagramDataSetReaderTransportDataType_Encoding_DefaultJson"] = 24002] = "DatagramDataSetReaderTransportDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ProgramDiagnostic2DataType_Encoding_DefaultBinary"] = 24034] = "ProgramDiagnostic2DataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ProgramDiagnostic2DataType_Encoding_DefaultXml"] = 24038] = "ProgramDiagnostic2DataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ProgramDiagnostic2DataType_Encoding_DefaultJson"] = 24042] = "ProgramDiagnostic2DataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["PortableQualifiedName_Encoding_DefaultBinary"] = 24108] = "PortableQualifiedName_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["PortableNodeId_Encoding_DefaultBinary"] = 24109] = "PortableNodeId_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["UnsignedRationalNumber_Encoding_DefaultBinary"] = 24110] = "UnsignedRationalNumber_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["PortableQualifiedName_Encoding_DefaultXml"] = 24120] = "PortableQualifiedName_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["PortableNodeId_Encoding_DefaultXml"] = 24121] = "PortableNodeId_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["UnsignedRationalNumber_Encoding_DefaultXml"] = 24122] = "UnsignedRationalNumber_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["PortableQualifiedName_Encoding_DefaultJson"] = 24132] = "PortableQualifiedName_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["PortableNodeId_Encoding_DefaultJson"] = 24133] = "PortableNodeId_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["UnsignedRationalNumber_Encoding_DefaultJson"] = 24134] = "UnsignedRationalNumber_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["Resources"] = 24226] = "Resources";
      ObjectIds2[ObjectIds2["Communication"] = 24227] = "Communication";
      ObjectIds2[ObjectIds2["MappingTables"] = 24228] = "MappingTables";
      ObjectIds2[ObjectIds2["NetworkInterfaces"] = 24229] = "NetworkInterfaces";
      ObjectIds2[ObjectIds2["Streams"] = 24230] = "Streams";
      ObjectIds2[ObjectIds2["TalkerStreams"] = 24231] = "TalkerStreams";
      ObjectIds2[ObjectIds2["ListenerStreams"] = 24232] = "ListenerStreams";
      ObjectIds2[ObjectIds2["UserManagement"] = 24290] = "UserManagement";
      ObjectIds2[ObjectIds2["UserManagementDataType_Encoding_DefaultBinary"] = 24292] = "UserManagementDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["UserManagementDataType_Encoding_DefaultXml"] = 24296] = "UserManagementDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["UserManagementDataType_Encoding_DefaultJson"] = 24300] = "UserManagementDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["PriorityMappingEntryType_Encoding_DefaultBinary"] = 25239] = "PriorityMappingEntryType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["PriorityMappingEntryType_Encoding_DefaultXml"] = 25243] = "PriorityMappingEntryType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["PriorityMappingEntryType_Encoding_DefaultJson"] = 25247] = "PriorityMappingEntryType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["PublishSubscribe_KeyPushTargets"] = 25440] = "PublishSubscribe_KeyPushTargets";
      ObjectIds2[ObjectIds2["PublishSubscribe_PubSubConfiguration"] = 25451] = "PublishSubscribe_PubSubConfiguration";
      ObjectIds2[ObjectIds2["PublishedDataSetCustomSourceDataType_Encoding_DefaultBinary"] = 25529] = "PublishedDataSetCustomSourceDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["PubSubKeyPushTargetDataType_Encoding_DefaultBinary"] = 25530] = "PubSubKeyPushTargetDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["PubSubConfigurationRefDataType_Encoding_DefaultBinary"] = 25531] = "PubSubConfigurationRefDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["PubSubConfigurationValueDataType_Encoding_DefaultBinary"] = 25532] = "PubSubConfigurationValueDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["PublishedDataSetCustomSourceDataType_Encoding_DefaultXml"] = 25545] = "PublishedDataSetCustomSourceDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["PubSubKeyPushTargetDataType_Encoding_DefaultXml"] = 25546] = "PubSubKeyPushTargetDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["PubSubConfigurationRefDataType_Encoding_DefaultXml"] = 25547] = "PubSubConfigurationRefDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["PubSubConfigurationValueDataType_Encoding_DefaultXml"] = 25548] = "PubSubConfigurationValueDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["PublishedDataSetCustomSourceDataType_Encoding_DefaultJson"] = 25561] = "PublishedDataSetCustomSourceDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["PubSubKeyPushTargetDataType_Encoding_DefaultJson"] = 25562] = "PubSubKeyPushTargetDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["PubSubConfigurationRefDataType_Encoding_DefaultJson"] = 25563] = "PubSubConfigurationRefDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["PubSubConfigurationValueDataType_Encoding_DefaultJson"] = 25564] = "PubSubConfigurationValueDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["WellKnownRole_SecurityKeyServerAdmin"] = 25565] = "WellKnownRole_SecurityKeyServerAdmin";
      ObjectIds2[ObjectIds2["WellKnownRole_SecurityKeyServerPush"] = 25584] = "WellKnownRole_SecurityKeyServerPush";
      ObjectIds2[ObjectIds2["WellKnownRole_SecurityKeyServerAccess"] = 25603] = "WellKnownRole_SecurityKeyServerAccess";
      ObjectIds2[ObjectIds2["ProvisionableDevice"] = 29878] = "ProvisionableDevice";
      ObjectIds2[ObjectIds2["Locations"] = 31915] = "Locations";
      ObjectIds2[ObjectIds2["ServerConfiguration_TransactionDiagnostics"] = 32336] = "ServerConfiguration_TransactionDiagnostics";
      ObjectIds2[ObjectIds2["TransactionErrorType_Encoding_DefaultBinary"] = 32382] = "TransactionErrorType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["TransactionErrorType_Encoding_DefaultXml"] = 32386] = "TransactionErrorType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["TransactionErrorType_Encoding_DefaultJson"] = 32390] = "TransactionErrorType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["BitFieldDefinition_Encoding_DefaultBinary"] = 32422] = "BitFieldDefinition_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["BitFieldDefinition_Encoding_DefaultXml"] = 32426] = "BitFieldDefinition_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["BitFieldDefinition_Encoding_DefaultJson"] = 32430] = "BitFieldDefinition_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["Quantities"] = 32530] = "Quantities";
      ObjectIds2[ObjectIds2["AnnotationDataType_Encoding_DefaultBinary"] = 32560] = "AnnotationDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["LinearConversionDataType_Encoding_DefaultBinary"] = 32561] = "LinearConversionDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["QuantityDimension_Encoding_DefaultBinary"] = 32562] = "QuantityDimension_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["AnnotationDataType_Encoding_DefaultXml"] = 32572] = "AnnotationDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["LinearConversionDataType_Encoding_DefaultXml"] = 32573] = "LinearConversionDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["QuantityDimension_Encoding_DefaultXml"] = 32574] = "QuantityDimension_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["AnnotationDataType_Encoding_DefaultJson"] = 32584] = "AnnotationDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["LinearConversionDataType_Encoding_DefaultJson"] = 32585] = "LinearConversionDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["QuantityDimension_Encoding_DefaultJson"] = 32586] = "QuantityDimension_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DefaultHAConfiguration"] = 32637] = "DefaultHAConfiguration";
      ObjectIds2[ObjectIds2["DefaultHAConfiguration_AggregateConfiguration"] = 32638] = "DefaultHAConfiguration_AggregateConfiguration";
      ObjectIds2[ObjectIds2["DefaultHAConfiguration_AggregateFunctions"] = 32643] = "DefaultHAConfiguration_AggregateFunctions";
      ObjectIds2[ObjectIds2["ReferenceDescriptionDataType_Encoding_DefaultBinary"] = 32661] = "ReferenceDescriptionDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ReferenceListEntryDataType_Encoding_DefaultBinary"] = 32662] = "ReferenceListEntryDataType_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ReferenceDescriptionDataType_Encoding_DefaultXml"] = 32669] = "ReferenceDescriptionDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ReferenceListEntryDataType_Encoding_DefaultXml"] = 32670] = "ReferenceListEntryDataType_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ReferenceDescriptionDataType_Encoding_DefaultJson"] = 32677] = "ReferenceDescriptionDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["ReferenceListEntryDataType_Encoding_DefaultJson"] = 32678] = "ReferenceListEntryDataType_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["DefaultHEConfiguration"] = 32754] = "DefaultHEConfiguration";
      ObjectIds2[ObjectIds2["DefaultHEConfiguration_EventTypes"] = 32755] = "DefaultHEConfiguration_EventTypes";
      ObjectIds2[ObjectIds2["ReadEventDetails2_Encoding_DefaultBinary"] = 32800] = "ReadEventDetails2_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["ReadEventDetails2_Encoding_DefaultXml"] = 32801] = "ReadEventDetails2_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["ReadEventDetails2_Encoding_DefaultJson"] = 32802] = "ReadEventDetails2_Encoding_DefaultJson";
      ObjectIds2[ObjectIds2["HistoryModifiedEvent_Encoding_DefaultBinary"] = 32825] = "HistoryModifiedEvent_Encoding_DefaultBinary";
      ObjectIds2[ObjectIds2["HistoryModifiedEvent_Encoding_DefaultXml"] = 32829] = "HistoryModifiedEvent_Encoding_DefaultXml";
      ObjectIds2[ObjectIds2["HistoryModifiedEvent_Encoding_DefaultJson"] = 32833] = "HistoryModifiedEvent_Encoding_DefaultJson";
    })(ObjectIds || (exports2.ObjectIds = ObjectIds = {}));
    var VariableIds;
    (function(VariableIds2) {
      VariableIds2[VariableIds2["DataTypeDescriptionType_DataTypeVersion"] = 104] = "DataTypeDescriptionType_DataTypeVersion";
      VariableIds2[VariableIds2["DataTypeDescriptionType_DictionaryFragment"] = 105] = "DataTypeDescriptionType_DictionaryFragment";
      VariableIds2[VariableIds2["DataTypeDictionaryType_DataTypeVersion"] = 106] = "DataTypeDictionaryType_DataTypeVersion";
      VariableIds2[VariableIds2["DataTypeDictionaryType_NamespaceUri"] = 107] = "DataTypeDictionaryType_NamespaceUri";
      VariableIds2[VariableIds2["Server_ServerArray"] = 2254] = "Server_ServerArray";
      VariableIds2[VariableIds2["Server_NamespaceArray"] = 2255] = "Server_NamespaceArray";
      VariableIds2[VariableIds2["Server_ServerStatus"] = 2256] = "Server_ServerStatus";
      VariableIds2[VariableIds2["Server_ServerStatus_StartTime"] = 2257] = "Server_ServerStatus_StartTime";
      VariableIds2[VariableIds2["Server_ServerStatus_CurrentTime"] = 2258] = "Server_ServerStatus_CurrentTime";
      VariableIds2[VariableIds2["Server_ServerStatus_State"] = 2259] = "Server_ServerStatus_State";
      VariableIds2[VariableIds2["Server_ServerStatus_BuildInfo"] = 2260] = "Server_ServerStatus_BuildInfo";
      VariableIds2[VariableIds2["Server_ServerStatus_BuildInfo_ProductName"] = 2261] = "Server_ServerStatus_BuildInfo_ProductName";
      VariableIds2[VariableIds2["Server_ServerStatus_BuildInfo_ProductUri"] = 2262] = "Server_ServerStatus_BuildInfo_ProductUri";
      VariableIds2[VariableIds2["Server_ServerStatus_BuildInfo_ManufacturerName"] = 2263] = "Server_ServerStatus_BuildInfo_ManufacturerName";
      VariableIds2[VariableIds2["Server_ServerStatus_BuildInfo_SoftwareVersion"] = 2264] = "Server_ServerStatus_BuildInfo_SoftwareVersion";
      VariableIds2[VariableIds2["Server_ServerStatus_BuildInfo_BuildNumber"] = 2265] = "Server_ServerStatus_BuildInfo_BuildNumber";
      VariableIds2[VariableIds2["Server_ServerStatus_BuildInfo_BuildDate"] = 2266] = "Server_ServerStatus_BuildInfo_BuildDate";
      VariableIds2[VariableIds2["Server_ServiceLevel"] = 2267] = "Server_ServiceLevel";
      VariableIds2[VariableIds2["Server_ServerCapabilities_ServerProfileArray"] = 2269] = "Server_ServerCapabilities_ServerProfileArray";
      VariableIds2[VariableIds2["Server_ServerCapabilities_LocaleIdArray"] = 2271] = "Server_ServerCapabilities_LocaleIdArray";
      VariableIds2[VariableIds2["Server_ServerCapabilities_MinSupportedSampleRate"] = 2272] = "Server_ServerCapabilities_MinSupportedSampleRate";
      VariableIds2[VariableIds2["Server_ServerDiagnostics_ServerDiagnosticsSummary"] = 2275] = "Server_ServerDiagnostics_ServerDiagnosticsSummary";
      VariableIds2[VariableIds2["Server_ServerDiagnostics_ServerDiagnosticsSummary_ServerViewCount"] = 2276] = "Server_ServerDiagnostics_ServerDiagnosticsSummary_ServerViewCount";
      VariableIds2[VariableIds2["Server_ServerDiagnostics_ServerDiagnosticsSummary_CurrentSessionCount"] = 2277] = "Server_ServerDiagnostics_ServerDiagnosticsSummary_CurrentSessionCount";
      VariableIds2[VariableIds2["Server_ServerDiagnostics_ServerDiagnosticsSummary_CumulatedSessionCount"] = 2278] = "Server_ServerDiagnostics_ServerDiagnosticsSummary_CumulatedSessionCount";
      VariableIds2[VariableIds2["Server_ServerDiagnostics_ServerDiagnosticsSummary_SecurityRejectedSessionCount"] = 2279] = "Server_ServerDiagnostics_ServerDiagnosticsSummary_SecurityRejectedSessionCount";
      VariableIds2[VariableIds2["Server_ServerDiagnostics_ServerDiagnosticsSummary_SessionTimeoutCount"] = 2281] = "Server_ServerDiagnostics_ServerDiagnosticsSummary_SessionTimeoutCount";
      VariableIds2[VariableIds2["Server_ServerDiagnostics_ServerDiagnosticsSummary_SessionAbortCount"] = 2282] = "Server_ServerDiagnostics_ServerDiagnosticsSummary_SessionAbortCount";
      VariableIds2[VariableIds2["Server_ServerDiagnostics_ServerDiagnosticsSummary_PublishingIntervalCount"] = 2284] = "Server_ServerDiagnostics_ServerDiagnosticsSummary_PublishingIntervalCount";
      VariableIds2[VariableIds2["Server_ServerDiagnostics_ServerDiagnosticsSummary_CurrentSubscriptionCount"] = 2285] = "Server_ServerDiagnostics_ServerDiagnosticsSummary_CurrentSubscriptionCount";
      VariableIds2[VariableIds2["Server_ServerDiagnostics_ServerDiagnosticsSummary_CumulatedSubscriptionCount"] = 2286] = "Server_ServerDiagnostics_ServerDiagnosticsSummary_CumulatedSubscriptionCount";
      VariableIds2[VariableIds2["Server_ServerDiagnostics_ServerDiagnosticsSummary_SecurityRejectedRequestsCount"] = 2287] = "Server_ServerDiagnostics_ServerDiagnosticsSummary_SecurityRejectedRequestsCount";
      VariableIds2[VariableIds2["Server_ServerDiagnostics_ServerDiagnosticsSummary_RejectedRequestsCount"] = 2288] = "Server_ServerDiagnostics_ServerDiagnosticsSummary_RejectedRequestsCount";
      VariableIds2[VariableIds2["Server_ServerDiagnostics_SamplingIntervalDiagnosticsArray"] = 2289] = "Server_ServerDiagnostics_SamplingIntervalDiagnosticsArray";
      VariableIds2[VariableIds2["Server_ServerDiagnostics_SubscriptionDiagnosticsArray"] = 2290] = "Server_ServerDiagnostics_SubscriptionDiagnosticsArray";
      VariableIds2[VariableIds2["Server_ServerDiagnostics_EnabledFlag"] = 2294] = "Server_ServerDiagnostics_EnabledFlag";
      VariableIds2[VariableIds2["Server_ServerCapabilities_MaxBrowseContinuationPoints"] = 2735] = "Server_ServerCapabilities_MaxBrowseContinuationPoints";
      VariableIds2[VariableIds2["Server_ServerCapabilities_MaxQueryContinuationPoints"] = 2736] = "Server_ServerCapabilities_MaxQueryContinuationPoints";
      VariableIds2[VariableIds2["Server_ServerCapabilities_MaxHistoryContinuationPoints"] = 2737] = "Server_ServerCapabilities_MaxHistoryContinuationPoints";
      VariableIds2[VariableIds2["AuditHistoryUpdateEventType_ParameterDataTypeId"] = 2751] = "AuditHistoryUpdateEventType_ParameterDataTypeId";
      VariableIds2[VariableIds2["Server_ServerStatus_SecondsTillShutdown"] = 2992] = "Server_ServerStatus_SecondsTillShutdown";
      VariableIds2[VariableIds2["Server_ServerStatus_ShutdownReason"] = 2993] = "Server_ServerStatus_ShutdownReason";
      VariableIds2[VariableIds2["Server_Auditing"] = 2994] = "Server_Auditing";
      VariableIds2[VariableIds2["Icon"] = 3067] = "Icon";
      VariableIds2[VariableIds2["NodeVersion"] = 3068] = "NodeVersion";
      VariableIds2[VariableIds2["LocalTime"] = 3069] = "LocalTime";
      VariableIds2[VariableIds2["AllowNulls"] = 3070] = "AllowNulls";
      VariableIds2[VariableIds2["EnumValues"] = 3071] = "EnumValues";
      VariableIds2[VariableIds2["InputArguments"] = 3072] = "InputArguments";
      VariableIds2[VariableIds2["OutputArguments"] = 3073] = "OutputArguments";
      VariableIds2[VariableIds2["Server_ServerCapabilities_SoftwareCertificates"] = 3704] = "Server_ServerCapabilities_SoftwareCertificates";
      VariableIds2[VariableIds2["Server_ServerDiagnostics_ServerDiagnosticsSummary_RejectedSessionCount"] = 3705] = "Server_ServerDiagnostics_ServerDiagnosticsSummary_RejectedSessionCount";
      VariableIds2[VariableIds2["Server_ServerDiagnostics_SessionsDiagnosticsSummary_SessionDiagnosticsArray"] = 3707] = "Server_ServerDiagnostics_SessionsDiagnosticsSummary_SessionDiagnosticsArray";
      VariableIds2[VariableIds2["Server_ServerDiagnostics_SessionsDiagnosticsSummary_SessionSecurityDiagnosticsArray"] = 3708] = "Server_ServerDiagnostics_SessionsDiagnosticsSummary_SessionSecurityDiagnosticsArray";
      VariableIds2[VariableIds2["Server_ServerRedundancy_RedundancySupport"] = 3709] = "Server_ServerRedundancy_RedundancySupport";
      VariableIds2[VariableIds2["MessageSecurityMode_EnumStrings"] = 7595] = "MessageSecurityMode_EnumStrings";
      VariableIds2[VariableIds2["BrowseDirection_EnumStrings"] = 7603] = "BrowseDirection_EnumStrings";
      VariableIds2[VariableIds2["FilterOperator_EnumStrings"] = 7605] = "FilterOperator_EnumStrings";
      VariableIds2[VariableIds2["TimestampsToReturn_EnumStrings"] = 7606] = "TimestampsToReturn_EnumStrings";
      VariableIds2[VariableIds2["MonitoringMode_EnumStrings"] = 7608] = "MonitoringMode_EnumStrings";
      VariableIds2[VariableIds2["DataChangeTrigger_EnumStrings"] = 7609] = "DataChangeTrigger_EnumStrings";
      VariableIds2[VariableIds2["RedundancySupport_EnumStrings"] = 7611] = "RedundancySupport_EnumStrings";
      VariableIds2[VariableIds2["ServerState_EnumStrings"] = 7612] = "ServerState_EnumStrings";
      VariableIds2[VariableIds2["ExceptionDeviationFormat_EnumStrings"] = 7614] = "ExceptionDeviationFormat_EnumStrings";
      VariableIds2[VariableIds2["OpcUa_BinarySchema"] = 7617] = "OpcUa_BinarySchema";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataTypeVersion"] = 7618] = "OpcUa_BinarySchema_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_NamespaceUri"] = 7619] = "OpcUa_BinarySchema_NamespaceUri";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Argument"] = 7650] = "OpcUa_BinarySchema_Argument";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Argument_DataTypeVersion"] = 7651] = "OpcUa_BinarySchema_Argument_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Argument_DictionaryFragment"] = 7652] = "OpcUa_BinarySchema_Argument_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EnumValueType"] = 7656] = "OpcUa_BinarySchema_EnumValueType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EnumValueType_DataTypeVersion"] = 7657] = "OpcUa_BinarySchema_EnumValueType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_StatusResult"] = 7659] = "OpcUa_BinarySchema_StatusResult";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_StatusResult_DataTypeVersion"] = 7660] = "OpcUa_BinarySchema_StatusResult_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_StatusResult_DictionaryFragment"] = 7661] = "OpcUa_BinarySchema_StatusResult_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UserTokenPolicy"] = 7662] = "OpcUa_BinarySchema_UserTokenPolicy";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UserTokenPolicy_DataTypeVersion"] = 7663] = "OpcUa_BinarySchema_UserTokenPolicy_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UserTokenPolicy_DictionaryFragment"] = 7664] = "OpcUa_BinarySchema_UserTokenPolicy_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ApplicationDescription"] = 7665] = "OpcUa_BinarySchema_ApplicationDescription";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ApplicationDescription_DataTypeVersion"] = 7666] = "OpcUa_BinarySchema_ApplicationDescription_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ApplicationDescription_DictionaryFragment"] = 7667] = "OpcUa_BinarySchema_ApplicationDescription_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EndpointDescription"] = 7668] = "OpcUa_BinarySchema_EndpointDescription";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EndpointDescription_DataTypeVersion"] = 7669] = "OpcUa_BinarySchema_EndpointDescription_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EndpointDescription_DictionaryFragment"] = 7670] = "OpcUa_BinarySchema_EndpointDescription_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UserIdentityToken"] = 7671] = "OpcUa_BinarySchema_UserIdentityToken";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UserIdentityToken_DataTypeVersion"] = 7672] = "OpcUa_BinarySchema_UserIdentityToken_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UserIdentityToken_DictionaryFragment"] = 7673] = "OpcUa_BinarySchema_UserIdentityToken_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AnonymousIdentityToken"] = 7674] = "OpcUa_BinarySchema_AnonymousIdentityToken";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AnonymousIdentityToken_DataTypeVersion"] = 7675] = "OpcUa_BinarySchema_AnonymousIdentityToken_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AnonymousIdentityToken_DictionaryFragment"] = 7676] = "OpcUa_BinarySchema_AnonymousIdentityToken_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UserNameIdentityToken"] = 7677] = "OpcUa_BinarySchema_UserNameIdentityToken";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UserNameIdentityToken_DataTypeVersion"] = 7678] = "OpcUa_BinarySchema_UserNameIdentityToken_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UserNameIdentityToken_DictionaryFragment"] = 7679] = "OpcUa_BinarySchema_UserNameIdentityToken_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_X509IdentityToken"] = 7680] = "OpcUa_BinarySchema_X509IdentityToken";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_X509IdentityToken_DataTypeVersion"] = 7681] = "OpcUa_BinarySchema_X509IdentityToken_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_X509IdentityToken_DictionaryFragment"] = 7682] = "OpcUa_BinarySchema_X509IdentityToken_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_IssuedIdentityToken"] = 7683] = "OpcUa_BinarySchema_IssuedIdentityToken";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_IssuedIdentityToken_DataTypeVersion"] = 7684] = "OpcUa_BinarySchema_IssuedIdentityToken_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_IssuedIdentityToken_DictionaryFragment"] = 7685] = "OpcUa_BinarySchema_IssuedIdentityToken_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EndpointConfiguration"] = 7686] = "OpcUa_BinarySchema_EndpointConfiguration";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EndpointConfiguration_DataTypeVersion"] = 7687] = "OpcUa_BinarySchema_EndpointConfiguration_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EndpointConfiguration_DictionaryFragment"] = 7688] = "OpcUa_BinarySchema_EndpointConfiguration_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_BuildInfo"] = 7692] = "OpcUa_BinarySchema_BuildInfo";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_BuildInfo_DataTypeVersion"] = 7693] = "OpcUa_BinarySchema_BuildInfo_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_BuildInfo_DictionaryFragment"] = 7694] = "OpcUa_BinarySchema_BuildInfo_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SignedSoftwareCertificate"] = 7698] = "OpcUa_BinarySchema_SignedSoftwareCertificate";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SignedSoftwareCertificate_DataTypeVersion"] = 7699] = "OpcUa_BinarySchema_SignedSoftwareCertificate_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SignedSoftwareCertificate_DictionaryFragment"] = 7700] = "OpcUa_BinarySchema_SignedSoftwareCertificate_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AddNodesItem"] = 7728] = "OpcUa_BinarySchema_AddNodesItem";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AddNodesItem_DataTypeVersion"] = 7729] = "OpcUa_BinarySchema_AddNodesItem_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AddNodesItem_DictionaryFragment"] = 7730] = "OpcUa_BinarySchema_AddNodesItem_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AddReferencesItem"] = 7731] = "OpcUa_BinarySchema_AddReferencesItem";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AddReferencesItem_DataTypeVersion"] = 7732] = "OpcUa_BinarySchema_AddReferencesItem_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AddReferencesItem_DictionaryFragment"] = 7733] = "OpcUa_BinarySchema_AddReferencesItem_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DeleteNodesItem"] = 7734] = "OpcUa_BinarySchema_DeleteNodesItem";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DeleteNodesItem_DataTypeVersion"] = 7735] = "OpcUa_BinarySchema_DeleteNodesItem_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DeleteNodesItem_DictionaryFragment"] = 7736] = "OpcUa_BinarySchema_DeleteNodesItem_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DeleteReferencesItem"] = 7737] = "OpcUa_BinarySchema_DeleteReferencesItem";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DeleteReferencesItem_DataTypeVersion"] = 7738] = "OpcUa_BinarySchema_DeleteReferencesItem_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DeleteReferencesItem_DictionaryFragment"] = 7739] = "OpcUa_BinarySchema_DeleteReferencesItem_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_RegisteredServer"] = 7782] = "OpcUa_BinarySchema_RegisteredServer";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_RegisteredServer_DataTypeVersion"] = 7783] = "OpcUa_BinarySchema_RegisteredServer_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_RegisteredServer_DictionaryFragment"] = 7784] = "OpcUa_BinarySchema_RegisteredServer_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ContentFilterElement"] = 7929] = "OpcUa_BinarySchema_ContentFilterElement";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ContentFilterElement_DataTypeVersion"] = 7930] = "OpcUa_BinarySchema_ContentFilterElement_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ContentFilterElement_DictionaryFragment"] = 7931] = "OpcUa_BinarySchema_ContentFilterElement_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ContentFilter"] = 7932] = "OpcUa_BinarySchema_ContentFilter";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ContentFilter_DataTypeVersion"] = 7933] = "OpcUa_BinarySchema_ContentFilter_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ContentFilter_DictionaryFragment"] = 7934] = "OpcUa_BinarySchema_ContentFilter_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_FilterOperand"] = 7935] = "OpcUa_BinarySchema_FilterOperand";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_FilterOperand_DataTypeVersion"] = 7936] = "OpcUa_BinarySchema_FilterOperand_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_FilterOperand_DictionaryFragment"] = 7937] = "OpcUa_BinarySchema_FilterOperand_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ElementOperand"] = 7938] = "OpcUa_BinarySchema_ElementOperand";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ElementOperand_DataTypeVersion"] = 7939] = "OpcUa_BinarySchema_ElementOperand_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ElementOperand_DictionaryFragment"] = 7940] = "OpcUa_BinarySchema_ElementOperand_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_LiteralOperand"] = 7941] = "OpcUa_BinarySchema_LiteralOperand";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_LiteralOperand_DataTypeVersion"] = 7942] = "OpcUa_BinarySchema_LiteralOperand_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_LiteralOperand_DictionaryFragment"] = 7943] = "OpcUa_BinarySchema_LiteralOperand_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AttributeOperand"] = 7944] = "OpcUa_BinarySchema_AttributeOperand";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AttributeOperand_DataTypeVersion"] = 7945] = "OpcUa_BinarySchema_AttributeOperand_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AttributeOperand_DictionaryFragment"] = 7946] = "OpcUa_BinarySchema_AttributeOperand_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SimpleAttributeOperand"] = 7947] = "OpcUa_BinarySchema_SimpleAttributeOperand";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SimpleAttributeOperand_DataTypeVersion"] = 7948] = "OpcUa_BinarySchema_SimpleAttributeOperand_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SimpleAttributeOperand_DictionaryFragment"] = 7949] = "OpcUa_BinarySchema_SimpleAttributeOperand_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_HistoryEvent"] = 8004] = "OpcUa_BinarySchema_HistoryEvent";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_HistoryEvent_DataTypeVersion"] = 8005] = "OpcUa_BinarySchema_HistoryEvent_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_HistoryEvent_DictionaryFragment"] = 8006] = "OpcUa_BinarySchema_HistoryEvent_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_MonitoringFilter"] = 8067] = "OpcUa_BinarySchema_MonitoringFilter";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_MonitoringFilter_DataTypeVersion"] = 8068] = "OpcUa_BinarySchema_MonitoringFilter_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_MonitoringFilter_DictionaryFragment"] = 8069] = "OpcUa_BinarySchema_MonitoringFilter_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EventFilter"] = 8073] = "OpcUa_BinarySchema_EventFilter";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EventFilter_DataTypeVersion"] = 8074] = "OpcUa_BinarySchema_EventFilter_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EventFilter_DictionaryFragment"] = 8075] = "OpcUa_BinarySchema_EventFilter_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AggregateConfiguration"] = 8076] = "OpcUa_BinarySchema_AggregateConfiguration";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AggregateConfiguration_DataTypeVersion"] = 8077] = "OpcUa_BinarySchema_AggregateConfiguration_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AggregateConfiguration_DictionaryFragment"] = 8078] = "OpcUa_BinarySchema_AggregateConfiguration_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_HistoryEventFieldList"] = 8172] = "OpcUa_BinarySchema_HistoryEventFieldList";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_HistoryEventFieldList_DataTypeVersion"] = 8173] = "OpcUa_BinarySchema_HistoryEventFieldList_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_HistoryEventFieldList_DictionaryFragment"] = 8174] = "OpcUa_BinarySchema_HistoryEventFieldList_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_RedundantServerDataType"] = 8208] = "OpcUa_BinarySchema_RedundantServerDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_RedundantServerDataType_DataTypeVersion"] = 8209] = "OpcUa_BinarySchema_RedundantServerDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_RedundantServerDataType_DictionaryFragment"] = 8210] = "OpcUa_BinarySchema_RedundantServerDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SamplingIntervalDiagnosticsDataType"] = 8211] = "OpcUa_BinarySchema_SamplingIntervalDiagnosticsDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SamplingIntervalDiagnosticsDataType_DataTypeVersion"] = 8212] = "OpcUa_BinarySchema_SamplingIntervalDiagnosticsDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SamplingIntervalDiagnosticsDataType_DictionaryFragment"] = 8213] = "OpcUa_BinarySchema_SamplingIntervalDiagnosticsDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ServerDiagnosticsSummaryDataType"] = 8214] = "OpcUa_BinarySchema_ServerDiagnosticsSummaryDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ServerDiagnosticsSummaryDataType_DataTypeVersion"] = 8215] = "OpcUa_BinarySchema_ServerDiagnosticsSummaryDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ServerDiagnosticsSummaryDataType_DictionaryFragment"] = 8216] = "OpcUa_BinarySchema_ServerDiagnosticsSummaryDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ServerStatusDataType"] = 8217] = "OpcUa_BinarySchema_ServerStatusDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ServerStatusDataType_DataTypeVersion"] = 8218] = "OpcUa_BinarySchema_ServerStatusDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ServerStatusDataType_DictionaryFragment"] = 8219] = "OpcUa_BinarySchema_ServerStatusDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SessionDiagnosticsDataType"] = 8220] = "OpcUa_BinarySchema_SessionDiagnosticsDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SessionDiagnosticsDataType_DataTypeVersion"] = 8221] = "OpcUa_BinarySchema_SessionDiagnosticsDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SessionDiagnosticsDataType_DictionaryFragment"] = 8222] = "OpcUa_BinarySchema_SessionDiagnosticsDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SessionSecurityDiagnosticsDataType"] = 8223] = "OpcUa_BinarySchema_SessionSecurityDiagnosticsDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SessionSecurityDiagnosticsDataType_DataTypeVersion"] = 8224] = "OpcUa_BinarySchema_SessionSecurityDiagnosticsDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SessionSecurityDiagnosticsDataType_DictionaryFragment"] = 8225] = "OpcUa_BinarySchema_SessionSecurityDiagnosticsDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ServiceCounterDataType"] = 8226] = "OpcUa_BinarySchema_ServiceCounterDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ServiceCounterDataType_DataTypeVersion"] = 8227] = "OpcUa_BinarySchema_ServiceCounterDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ServiceCounterDataType_DictionaryFragment"] = 8228] = "OpcUa_BinarySchema_ServiceCounterDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SubscriptionDiagnosticsDataType"] = 8229] = "OpcUa_BinarySchema_SubscriptionDiagnosticsDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SubscriptionDiagnosticsDataType_DataTypeVersion"] = 8230] = "OpcUa_BinarySchema_SubscriptionDiagnosticsDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SubscriptionDiagnosticsDataType_DictionaryFragment"] = 8231] = "OpcUa_BinarySchema_SubscriptionDiagnosticsDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ModelChangeStructureDataType"] = 8232] = "OpcUa_BinarySchema_ModelChangeStructureDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ModelChangeStructureDataType_DataTypeVersion"] = 8233] = "OpcUa_BinarySchema_ModelChangeStructureDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ModelChangeStructureDataType_DictionaryFragment"] = 8234] = "OpcUa_BinarySchema_ModelChangeStructureDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SemanticChangeStructureDataType"] = 8235] = "OpcUa_BinarySchema_SemanticChangeStructureDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SemanticChangeStructureDataType_DataTypeVersion"] = 8236] = "OpcUa_BinarySchema_SemanticChangeStructureDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SemanticChangeStructureDataType_DictionaryFragment"] = 8237] = "OpcUa_BinarySchema_SemanticChangeStructureDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Range"] = 8238] = "OpcUa_BinarySchema_Range";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Range_DataTypeVersion"] = 8239] = "OpcUa_BinarySchema_Range_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Range_DictionaryFragment"] = 8240] = "OpcUa_BinarySchema_Range_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EUInformation"] = 8241] = "OpcUa_BinarySchema_EUInformation";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EUInformation_DataTypeVersion"] = 8242] = "OpcUa_BinarySchema_EUInformation_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EUInformation_DictionaryFragment"] = 8243] = "OpcUa_BinarySchema_EUInformation_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Annotation"] = 8244] = "OpcUa_BinarySchema_Annotation";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Annotation_DataTypeVersion"] = 8245] = "OpcUa_BinarySchema_Annotation_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Annotation_DictionaryFragment"] = 8246] = "OpcUa_BinarySchema_Annotation_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ProgramDiagnosticDataType"] = 8247] = "OpcUa_BinarySchema_ProgramDiagnosticDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ProgramDiagnosticDataType_DataTypeVersion"] = 8248] = "OpcUa_BinarySchema_ProgramDiagnosticDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ProgramDiagnosticDataType_DictionaryFragment"] = 8249] = "OpcUa_BinarySchema_ProgramDiagnosticDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema"] = 8252] = "OpcUa_XmlSchema";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataTypeVersion"] = 8253] = "OpcUa_XmlSchema_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_NamespaceUri"] = 8254] = "OpcUa_XmlSchema_NamespaceUri";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Argument"] = 8285] = "OpcUa_XmlSchema_Argument";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Argument_DataTypeVersion"] = 8286] = "OpcUa_XmlSchema_Argument_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Argument_DictionaryFragment"] = 8287] = "OpcUa_XmlSchema_Argument_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EnumValueType"] = 8291] = "OpcUa_XmlSchema_EnumValueType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EnumValueType_DataTypeVersion"] = 8292] = "OpcUa_XmlSchema_EnumValueType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_StatusResult"] = 8294] = "OpcUa_XmlSchema_StatusResult";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_StatusResult_DataTypeVersion"] = 8295] = "OpcUa_XmlSchema_StatusResult_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_StatusResult_DictionaryFragment"] = 8296] = "OpcUa_XmlSchema_StatusResult_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UserTokenPolicy"] = 8297] = "OpcUa_XmlSchema_UserTokenPolicy";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UserTokenPolicy_DataTypeVersion"] = 8298] = "OpcUa_XmlSchema_UserTokenPolicy_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UserTokenPolicy_DictionaryFragment"] = 8299] = "OpcUa_XmlSchema_UserTokenPolicy_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ApplicationDescription"] = 8300] = "OpcUa_XmlSchema_ApplicationDescription";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ApplicationDescription_DataTypeVersion"] = 8301] = "OpcUa_XmlSchema_ApplicationDescription_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ApplicationDescription_DictionaryFragment"] = 8302] = "OpcUa_XmlSchema_ApplicationDescription_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EndpointDescription"] = 8303] = "OpcUa_XmlSchema_EndpointDescription";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EndpointDescription_DataTypeVersion"] = 8304] = "OpcUa_XmlSchema_EndpointDescription_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EndpointDescription_DictionaryFragment"] = 8305] = "OpcUa_XmlSchema_EndpointDescription_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UserIdentityToken"] = 8306] = "OpcUa_XmlSchema_UserIdentityToken";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UserIdentityToken_DataTypeVersion"] = 8307] = "OpcUa_XmlSchema_UserIdentityToken_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UserIdentityToken_DictionaryFragment"] = 8308] = "OpcUa_XmlSchema_UserIdentityToken_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AnonymousIdentityToken"] = 8309] = "OpcUa_XmlSchema_AnonymousIdentityToken";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AnonymousIdentityToken_DataTypeVersion"] = 8310] = "OpcUa_XmlSchema_AnonymousIdentityToken_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AnonymousIdentityToken_DictionaryFragment"] = 8311] = "OpcUa_XmlSchema_AnonymousIdentityToken_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UserNameIdentityToken"] = 8312] = "OpcUa_XmlSchema_UserNameIdentityToken";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UserNameIdentityToken_DataTypeVersion"] = 8313] = "OpcUa_XmlSchema_UserNameIdentityToken_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UserNameIdentityToken_DictionaryFragment"] = 8314] = "OpcUa_XmlSchema_UserNameIdentityToken_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_X509IdentityToken"] = 8315] = "OpcUa_XmlSchema_X509IdentityToken";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_X509IdentityToken_DataTypeVersion"] = 8316] = "OpcUa_XmlSchema_X509IdentityToken_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_X509IdentityToken_DictionaryFragment"] = 8317] = "OpcUa_XmlSchema_X509IdentityToken_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_IssuedIdentityToken"] = 8318] = "OpcUa_XmlSchema_IssuedIdentityToken";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_IssuedIdentityToken_DataTypeVersion"] = 8319] = "OpcUa_XmlSchema_IssuedIdentityToken_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_IssuedIdentityToken_DictionaryFragment"] = 8320] = "OpcUa_XmlSchema_IssuedIdentityToken_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EndpointConfiguration"] = 8321] = "OpcUa_XmlSchema_EndpointConfiguration";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EndpointConfiguration_DataTypeVersion"] = 8322] = "OpcUa_XmlSchema_EndpointConfiguration_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EndpointConfiguration_DictionaryFragment"] = 8323] = "OpcUa_XmlSchema_EndpointConfiguration_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_BuildInfo"] = 8327] = "OpcUa_XmlSchema_BuildInfo";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_BuildInfo_DataTypeVersion"] = 8328] = "OpcUa_XmlSchema_BuildInfo_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_BuildInfo_DictionaryFragment"] = 8329] = "OpcUa_XmlSchema_BuildInfo_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SignedSoftwareCertificate"] = 8333] = "OpcUa_XmlSchema_SignedSoftwareCertificate";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SignedSoftwareCertificate_DataTypeVersion"] = 8334] = "OpcUa_XmlSchema_SignedSoftwareCertificate_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SignedSoftwareCertificate_DictionaryFragment"] = 8335] = "OpcUa_XmlSchema_SignedSoftwareCertificate_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AddNodesItem"] = 8363] = "OpcUa_XmlSchema_AddNodesItem";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AddNodesItem_DataTypeVersion"] = 8364] = "OpcUa_XmlSchema_AddNodesItem_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AddNodesItem_DictionaryFragment"] = 8365] = "OpcUa_XmlSchema_AddNodesItem_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AddReferencesItem"] = 8366] = "OpcUa_XmlSchema_AddReferencesItem";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AddReferencesItem_DataTypeVersion"] = 8367] = "OpcUa_XmlSchema_AddReferencesItem_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AddReferencesItem_DictionaryFragment"] = 8368] = "OpcUa_XmlSchema_AddReferencesItem_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DeleteNodesItem"] = 8369] = "OpcUa_XmlSchema_DeleteNodesItem";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DeleteNodesItem_DataTypeVersion"] = 8370] = "OpcUa_XmlSchema_DeleteNodesItem_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DeleteNodesItem_DictionaryFragment"] = 8371] = "OpcUa_XmlSchema_DeleteNodesItem_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DeleteReferencesItem"] = 8372] = "OpcUa_XmlSchema_DeleteReferencesItem";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DeleteReferencesItem_DataTypeVersion"] = 8373] = "OpcUa_XmlSchema_DeleteReferencesItem_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DeleteReferencesItem_DictionaryFragment"] = 8374] = "OpcUa_XmlSchema_DeleteReferencesItem_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_RegisteredServer"] = 8417] = "OpcUa_XmlSchema_RegisteredServer";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_RegisteredServer_DataTypeVersion"] = 8418] = "OpcUa_XmlSchema_RegisteredServer_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_RegisteredServer_DictionaryFragment"] = 8419] = "OpcUa_XmlSchema_RegisteredServer_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ContentFilterElement"] = 8564] = "OpcUa_XmlSchema_ContentFilterElement";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ContentFilterElement_DataTypeVersion"] = 8565] = "OpcUa_XmlSchema_ContentFilterElement_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ContentFilterElement_DictionaryFragment"] = 8566] = "OpcUa_XmlSchema_ContentFilterElement_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ContentFilter"] = 8567] = "OpcUa_XmlSchema_ContentFilter";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ContentFilter_DataTypeVersion"] = 8568] = "OpcUa_XmlSchema_ContentFilter_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ContentFilter_DictionaryFragment"] = 8569] = "OpcUa_XmlSchema_ContentFilter_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_FilterOperand"] = 8570] = "OpcUa_XmlSchema_FilterOperand";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_FilterOperand_DataTypeVersion"] = 8571] = "OpcUa_XmlSchema_FilterOperand_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_FilterOperand_DictionaryFragment"] = 8572] = "OpcUa_XmlSchema_FilterOperand_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ElementOperand"] = 8573] = "OpcUa_XmlSchema_ElementOperand";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ElementOperand_DataTypeVersion"] = 8574] = "OpcUa_XmlSchema_ElementOperand_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ElementOperand_DictionaryFragment"] = 8575] = "OpcUa_XmlSchema_ElementOperand_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_LiteralOperand"] = 8576] = "OpcUa_XmlSchema_LiteralOperand";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_LiteralOperand_DataTypeVersion"] = 8577] = "OpcUa_XmlSchema_LiteralOperand_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_LiteralOperand_DictionaryFragment"] = 8578] = "OpcUa_XmlSchema_LiteralOperand_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AttributeOperand"] = 8579] = "OpcUa_XmlSchema_AttributeOperand";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AttributeOperand_DataTypeVersion"] = 8580] = "OpcUa_XmlSchema_AttributeOperand_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AttributeOperand_DictionaryFragment"] = 8581] = "OpcUa_XmlSchema_AttributeOperand_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SimpleAttributeOperand"] = 8582] = "OpcUa_XmlSchema_SimpleAttributeOperand";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SimpleAttributeOperand_DataTypeVersion"] = 8583] = "OpcUa_XmlSchema_SimpleAttributeOperand_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SimpleAttributeOperand_DictionaryFragment"] = 8584] = "OpcUa_XmlSchema_SimpleAttributeOperand_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_HistoryEvent"] = 8639] = "OpcUa_XmlSchema_HistoryEvent";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_HistoryEvent_DataTypeVersion"] = 8640] = "OpcUa_XmlSchema_HistoryEvent_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_HistoryEvent_DictionaryFragment"] = 8641] = "OpcUa_XmlSchema_HistoryEvent_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_MonitoringFilter"] = 8702] = "OpcUa_XmlSchema_MonitoringFilter";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_MonitoringFilter_DataTypeVersion"] = 8703] = "OpcUa_XmlSchema_MonitoringFilter_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_MonitoringFilter_DictionaryFragment"] = 8704] = "OpcUa_XmlSchema_MonitoringFilter_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EventFilter"] = 8708] = "OpcUa_XmlSchema_EventFilter";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EventFilter_DataTypeVersion"] = 8709] = "OpcUa_XmlSchema_EventFilter_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EventFilter_DictionaryFragment"] = 8710] = "OpcUa_XmlSchema_EventFilter_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AggregateConfiguration"] = 8711] = "OpcUa_XmlSchema_AggregateConfiguration";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AggregateConfiguration_DataTypeVersion"] = 8712] = "OpcUa_XmlSchema_AggregateConfiguration_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AggregateConfiguration_DictionaryFragment"] = 8713] = "OpcUa_XmlSchema_AggregateConfiguration_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_HistoryEventFieldList"] = 8807] = "OpcUa_XmlSchema_HistoryEventFieldList";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_HistoryEventFieldList_DataTypeVersion"] = 8808] = "OpcUa_XmlSchema_HistoryEventFieldList_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_HistoryEventFieldList_DictionaryFragment"] = 8809] = "OpcUa_XmlSchema_HistoryEventFieldList_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_RedundantServerDataType"] = 8843] = "OpcUa_XmlSchema_RedundantServerDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_RedundantServerDataType_DataTypeVersion"] = 8844] = "OpcUa_XmlSchema_RedundantServerDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_RedundantServerDataType_DictionaryFragment"] = 8845] = "OpcUa_XmlSchema_RedundantServerDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SamplingIntervalDiagnosticsDataType"] = 8846] = "OpcUa_XmlSchema_SamplingIntervalDiagnosticsDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SamplingIntervalDiagnosticsDataType_DataTypeVersion"] = 8847] = "OpcUa_XmlSchema_SamplingIntervalDiagnosticsDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SamplingIntervalDiagnosticsDataType_DictionaryFragment"] = 8848] = "OpcUa_XmlSchema_SamplingIntervalDiagnosticsDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ServerDiagnosticsSummaryDataType"] = 8849] = "OpcUa_XmlSchema_ServerDiagnosticsSummaryDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ServerDiagnosticsSummaryDataType_DataTypeVersion"] = 8850] = "OpcUa_XmlSchema_ServerDiagnosticsSummaryDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ServerDiagnosticsSummaryDataType_DictionaryFragment"] = 8851] = "OpcUa_XmlSchema_ServerDiagnosticsSummaryDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ServerStatusDataType"] = 8852] = "OpcUa_XmlSchema_ServerStatusDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ServerStatusDataType_DataTypeVersion"] = 8853] = "OpcUa_XmlSchema_ServerStatusDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ServerStatusDataType_DictionaryFragment"] = 8854] = "OpcUa_XmlSchema_ServerStatusDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SessionDiagnosticsDataType"] = 8855] = "OpcUa_XmlSchema_SessionDiagnosticsDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SessionDiagnosticsDataType_DataTypeVersion"] = 8856] = "OpcUa_XmlSchema_SessionDiagnosticsDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SessionDiagnosticsDataType_DictionaryFragment"] = 8857] = "OpcUa_XmlSchema_SessionDiagnosticsDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SessionSecurityDiagnosticsDataType"] = 8858] = "OpcUa_XmlSchema_SessionSecurityDiagnosticsDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SessionSecurityDiagnosticsDataType_DataTypeVersion"] = 8859] = "OpcUa_XmlSchema_SessionSecurityDiagnosticsDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SessionSecurityDiagnosticsDataType_DictionaryFragment"] = 8860] = "OpcUa_XmlSchema_SessionSecurityDiagnosticsDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ServiceCounterDataType"] = 8861] = "OpcUa_XmlSchema_ServiceCounterDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ServiceCounterDataType_DataTypeVersion"] = 8862] = "OpcUa_XmlSchema_ServiceCounterDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ServiceCounterDataType_DictionaryFragment"] = 8863] = "OpcUa_XmlSchema_ServiceCounterDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SubscriptionDiagnosticsDataType"] = 8864] = "OpcUa_XmlSchema_SubscriptionDiagnosticsDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SubscriptionDiagnosticsDataType_DataTypeVersion"] = 8865] = "OpcUa_XmlSchema_SubscriptionDiagnosticsDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SubscriptionDiagnosticsDataType_DictionaryFragment"] = 8866] = "OpcUa_XmlSchema_SubscriptionDiagnosticsDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ModelChangeStructureDataType"] = 8867] = "OpcUa_XmlSchema_ModelChangeStructureDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ModelChangeStructureDataType_DataTypeVersion"] = 8868] = "OpcUa_XmlSchema_ModelChangeStructureDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ModelChangeStructureDataType_DictionaryFragment"] = 8869] = "OpcUa_XmlSchema_ModelChangeStructureDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SemanticChangeStructureDataType"] = 8870] = "OpcUa_XmlSchema_SemanticChangeStructureDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SemanticChangeStructureDataType_DataTypeVersion"] = 8871] = "OpcUa_XmlSchema_SemanticChangeStructureDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SemanticChangeStructureDataType_DictionaryFragment"] = 8872] = "OpcUa_XmlSchema_SemanticChangeStructureDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Range"] = 8873] = "OpcUa_XmlSchema_Range";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Range_DataTypeVersion"] = 8874] = "OpcUa_XmlSchema_Range_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Range_DictionaryFragment"] = 8875] = "OpcUa_XmlSchema_Range_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EUInformation"] = 8876] = "OpcUa_XmlSchema_EUInformation";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EUInformation_DataTypeVersion"] = 8877] = "OpcUa_XmlSchema_EUInformation_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EUInformation_DictionaryFragment"] = 8878] = "OpcUa_XmlSchema_EUInformation_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Annotation"] = 8879] = "OpcUa_XmlSchema_Annotation";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Annotation_DataTypeVersion"] = 8880] = "OpcUa_XmlSchema_Annotation_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Annotation_DictionaryFragment"] = 8881] = "OpcUa_XmlSchema_Annotation_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ProgramDiagnosticDataType"] = 8882] = "OpcUa_XmlSchema_ProgramDiagnosticDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ProgramDiagnosticDataType_DataTypeVersion"] = 8883] = "OpcUa_XmlSchema_ProgramDiagnosticDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ProgramDiagnosticDataType_DictionaryFragment"] = 8884] = "OpcUa_XmlSchema_ProgramDiagnosticDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_TimeZoneDataType"] = 8914] = "OpcUa_BinarySchema_TimeZoneDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_TimeZoneDataType_DataTypeVersion"] = 8915] = "OpcUa_BinarySchema_TimeZoneDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_TimeZoneDataType_DictionaryFragment"] = 8916] = "OpcUa_BinarySchema_TimeZoneDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_TimeZoneDataType"] = 8918] = "OpcUa_XmlSchema_TimeZoneDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_TimeZoneDataType_DataTypeVersion"] = 8919] = "OpcUa_XmlSchema_TimeZoneDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_TimeZoneDataType_DictionaryFragment"] = 8920] = "OpcUa_XmlSchema_TimeZoneDataType_DictionaryFragment";
      VariableIds2[VariableIds2["HistoryServerCapabilities_AccessHistoryDataCapability"] = 11193] = "HistoryServerCapabilities_AccessHistoryDataCapability";
      VariableIds2[VariableIds2["HistoryServerCapabilities_InsertDataCapability"] = 11196] = "HistoryServerCapabilities_InsertDataCapability";
      VariableIds2[VariableIds2["HistoryServerCapabilities_ReplaceDataCapability"] = 11197] = "HistoryServerCapabilities_ReplaceDataCapability";
      VariableIds2[VariableIds2["HistoryServerCapabilities_UpdateDataCapability"] = 11198] = "HistoryServerCapabilities_UpdateDataCapability";
      VariableIds2[VariableIds2["HistoryServerCapabilities_DeleteRawCapability"] = 11199] = "HistoryServerCapabilities_DeleteRawCapability";
      VariableIds2[VariableIds2["HistoryServerCapabilities_DeleteAtTimeCapability"] = 11200] = "HistoryServerCapabilities_DeleteAtTimeCapability";
      VariableIds2[VariableIds2["HAConfiguration_AggregateConfiguration_TreatUncertainAsBad"] = 11204] = "HAConfiguration_AggregateConfiguration_TreatUncertainAsBad";
      VariableIds2[VariableIds2["HAConfiguration_AggregateConfiguration_PercentDataBad"] = 11205] = "HAConfiguration_AggregateConfiguration_PercentDataBad";
      VariableIds2[VariableIds2["HAConfiguration_AggregateConfiguration_PercentDataGood"] = 11206] = "HAConfiguration_AggregateConfiguration_PercentDataGood";
      VariableIds2[VariableIds2["HAConfiguration_AggregateConfiguration_UseSlopedExtrapolation"] = 11207] = "HAConfiguration_AggregateConfiguration_UseSlopedExtrapolation";
      VariableIds2[VariableIds2["HAConfiguration_Stepped"] = 11208] = "HAConfiguration_Stepped";
      VariableIds2[VariableIds2["HAConfiguration_Definition"] = 11209] = "HAConfiguration_Definition";
      VariableIds2[VariableIds2["HAConfiguration_MaxTimeInterval"] = 11210] = "HAConfiguration_MaxTimeInterval";
      VariableIds2[VariableIds2["HAConfiguration_MinTimeInterval"] = 11211] = "HAConfiguration_MinTimeInterval";
      VariableIds2[VariableIds2["HAConfiguration_ExceptionDeviation"] = 11212] = "HAConfiguration_ExceptionDeviation";
      VariableIds2[VariableIds2["HAConfiguration_ExceptionDeviationFormat"] = 11213] = "HAConfiguration_ExceptionDeviationFormat";
      VariableIds2[VariableIds2["Annotations"] = 11214] = "Annotations";
      VariableIds2[VariableIds2["HistoricalEventFilter"] = 11215] = "HistoricalEventFilter";
      VariableIds2[VariableIds2["HistoryServerCapabilities_AccessHistoryEventsCapability"] = 11242] = "HistoryServerCapabilities_AccessHistoryEventsCapability";
      VariableIds2[VariableIds2["HistoryServerCapabilities_MaxReturnDataValues"] = 11273] = "HistoryServerCapabilities_MaxReturnDataValues";
      VariableIds2[VariableIds2["HistoryServerCapabilities_MaxReturnEventValues"] = 11274] = "HistoryServerCapabilities_MaxReturnEventValues";
      VariableIds2[VariableIds2["HistoryServerCapabilities_InsertAnnotationCapability"] = 11275] = "HistoryServerCapabilities_InsertAnnotationCapability";
      VariableIds2[VariableIds2["HistoryServerCapabilities_InsertEventCapability"] = 11281] = "HistoryServerCapabilities_InsertEventCapability";
      VariableIds2[VariableIds2["HistoryServerCapabilities_ReplaceEventCapability"] = 11282] = "HistoryServerCapabilities_ReplaceEventCapability";
      VariableIds2[VariableIds2["HistoryServerCapabilities_UpdateEventCapability"] = 11283] = "HistoryServerCapabilities_UpdateEventCapability";
      VariableIds2[VariableIds2["Server_ServerRedundancy_CurrentServerId"] = 11312] = "Server_ServerRedundancy_CurrentServerId";
      VariableIds2[VariableIds2["Server_ServerRedundancy_RedundantServerArray"] = 11313] = "Server_ServerRedundancy_RedundantServerArray";
      VariableIds2[VariableIds2["Server_ServerRedundancy_ServerUriArray"] = 11314] = "Server_ServerRedundancy_ServerUriArray";
      VariableIds2[VariableIds2["EnumStrings"] = 11432] = "EnumStrings";
      VariableIds2[VariableIds2["ValueAsText"] = 11433] = "ValueAsText";
      VariableIds2[VariableIds2["Server_GetMonitoredItems_InputArguments"] = 11493] = "Server_GetMonitoredItems_InputArguments";
      VariableIds2[VariableIds2["Server_GetMonitoredItems_OutputArguments"] = 11494] = "Server_GetMonitoredItems_OutputArguments";
      VariableIds2[VariableIds2["MaxStringLength"] = 11498] = "MaxStringLength";
      VariableIds2[VariableIds2["HistoryServerCapabilities_DeleteEventCapability"] = 11502] = "HistoryServerCapabilities_DeleteEventCapability";
      VariableIds2[VariableIds2["HAConfiguration_StartOfArchive"] = 11503] = "HAConfiguration_StartOfArchive";
      VariableIds2[VariableIds2["HAConfiguration_StartOfOnlineArchive"] = 11504] = "HAConfiguration_StartOfOnlineArchive";
      VariableIds2[VariableIds2["MaxArrayLength"] = 11512] = "MaxArrayLength";
      VariableIds2[VariableIds2["EngineeringUnits"] = 11513] = "EngineeringUnits";
      VariableIds2[VariableIds2["Server_ServerCapabilities_MaxArrayLength"] = 11702] = "Server_ServerCapabilities_MaxArrayLength";
      VariableIds2[VariableIds2["Server_ServerCapabilities_MaxStringLength"] = 11703] = "Server_ServerCapabilities_MaxStringLength";
      VariableIds2[VariableIds2["Server_ServerCapabilities_OperationLimits_MaxNodesPerRead"] = 11705] = "Server_ServerCapabilities_OperationLimits_MaxNodesPerRead";
      VariableIds2[VariableIds2["Server_ServerCapabilities_OperationLimits_MaxNodesPerWrite"] = 11707] = "Server_ServerCapabilities_OperationLimits_MaxNodesPerWrite";
      VariableIds2[VariableIds2["Server_ServerCapabilities_OperationLimits_MaxNodesPerMethodCall"] = 11709] = "Server_ServerCapabilities_OperationLimits_MaxNodesPerMethodCall";
      VariableIds2[VariableIds2["Server_ServerCapabilities_OperationLimits_MaxNodesPerBrowse"] = 11710] = "Server_ServerCapabilities_OperationLimits_MaxNodesPerBrowse";
      VariableIds2[VariableIds2["Server_ServerCapabilities_OperationLimits_MaxNodesPerRegisterNodes"] = 11711] = "Server_ServerCapabilities_OperationLimits_MaxNodesPerRegisterNodes";
      VariableIds2[VariableIds2["Server_ServerCapabilities_OperationLimits_MaxNodesPerTranslateBrowsePathsToNodeIds"] = 11712] = "Server_ServerCapabilities_OperationLimits_MaxNodesPerTranslateBrowsePathsToNodeIds";
      VariableIds2[VariableIds2["Server_ServerCapabilities_OperationLimits_MaxNodesPerNodeManagement"] = 11713] = "Server_ServerCapabilities_OperationLimits_MaxNodesPerNodeManagement";
      VariableIds2[VariableIds2["Server_ServerCapabilities_OperationLimits_MaxMonitoredItemsPerCall"] = 11714] = "Server_ServerCapabilities_OperationLimits_MaxMonitoredItemsPerCall";
      VariableIds2[VariableIds2["NodeClass_EnumValues"] = 11878] = "NodeClass_EnumValues";
      VariableIds2[VariableIds2["NodeAttributesMask_EnumValues"] = 11881] = "NodeAttributesMask_EnumValues";
      VariableIds2[VariableIds2["BrowseResultMask_EnumValues"] = 11883] = "BrowseResultMask_EnumValues";
      VariableIds2[VariableIds2["OpenFileMode_EnumValues"] = 11940] = "OpenFileMode_EnumValues";
      VariableIds2[VariableIds2["ModelChangeStructureVerbMask_EnumValues"] = 11942] = "ModelChangeStructureVerbMask_EnumValues";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EndpointUrlListDataType"] = 11951] = "OpcUa_XmlSchema_EndpointUrlListDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EndpointUrlListDataType_DataTypeVersion"] = 11952] = "OpcUa_XmlSchema_EndpointUrlListDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EndpointUrlListDataType_DictionaryFragment"] = 11953] = "OpcUa_XmlSchema_EndpointUrlListDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_NetworkGroupDataType"] = 11954] = "OpcUa_XmlSchema_NetworkGroupDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_NetworkGroupDataType_DataTypeVersion"] = 11955] = "OpcUa_XmlSchema_NetworkGroupDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_NetworkGroupDataType_DictionaryFragment"] = 11956] = "OpcUa_XmlSchema_NetworkGroupDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EndpointUrlListDataType"] = 11959] = "OpcUa_BinarySchema_EndpointUrlListDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EndpointUrlListDataType_DataTypeVersion"] = 11960] = "OpcUa_BinarySchema_EndpointUrlListDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EndpointUrlListDataType_DictionaryFragment"] = 11961] = "OpcUa_BinarySchema_EndpointUrlListDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_NetworkGroupDataType"] = 11962] = "OpcUa_BinarySchema_NetworkGroupDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_NetworkGroupDataType_DataTypeVersion"] = 11963] = "OpcUa_BinarySchema_NetworkGroupDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_NetworkGroupDataType_DictionaryFragment"] = 11964] = "OpcUa_BinarySchema_NetworkGroupDataType_DictionaryFragment";
      VariableIds2[VariableIds2["AxisScaleEnumeration_EnumStrings"] = 12078] = "AxisScaleEnumeration_EnumStrings";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AxisInformation"] = 12083] = "OpcUa_XmlSchema_AxisInformation";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AxisInformation_DataTypeVersion"] = 12084] = "OpcUa_XmlSchema_AxisInformation_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AxisInformation_DictionaryFragment"] = 12085] = "OpcUa_XmlSchema_AxisInformation_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_XVType"] = 12086] = "OpcUa_XmlSchema_XVType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_XVType_DataTypeVersion"] = 12087] = "OpcUa_XmlSchema_XVType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AxisInformation"] = 12091] = "OpcUa_BinarySchema_AxisInformation";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AxisInformation_DataTypeVersion"] = 12092] = "OpcUa_BinarySchema_AxisInformation_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AxisInformation_DictionaryFragment"] = 12093] = "OpcUa_BinarySchema_AxisInformation_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_XVType"] = 12094] = "OpcUa_BinarySchema_XVType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_XVType_DataTypeVersion"] = 12095] = "OpcUa_BinarySchema_XVType_DataTypeVersion";
      VariableIds2[VariableIds2["Server_ServerCapabilities_OperationLimits_MaxNodesPerHistoryReadData"] = 12165] = "Server_ServerCapabilities_OperationLimits_MaxNodesPerHistoryReadData";
      VariableIds2[VariableIds2["Server_ServerCapabilities_OperationLimits_MaxNodesPerHistoryReadEvents"] = 12166] = "Server_ServerCapabilities_OperationLimits_MaxNodesPerHistoryReadEvents";
      VariableIds2[VariableIds2["Server_ServerCapabilities_OperationLimits_MaxNodesPerHistoryUpdateData"] = 12167] = "Server_ServerCapabilities_OperationLimits_MaxNodesPerHistoryUpdateData";
      VariableIds2[VariableIds2["Server_ServerCapabilities_OperationLimits_MaxNodesPerHistoryUpdateEvents"] = 12168] = "Server_ServerCapabilities_OperationLimits_MaxNodesPerHistoryUpdateEvents";
      VariableIds2[VariableIds2["ViewVersion"] = 12170] = "ViewVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ComplexNumberType"] = 12175] = "OpcUa_XmlSchema_ComplexNumberType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ComplexNumberType_DataTypeVersion"] = 12176] = "OpcUa_XmlSchema_ComplexNumberType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DoubleComplexNumberType"] = 12178] = "OpcUa_XmlSchema_DoubleComplexNumberType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DoubleComplexNumberType_DataTypeVersion"] = 12179] = "OpcUa_XmlSchema_DoubleComplexNumberType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ComplexNumberType"] = 12183] = "OpcUa_BinarySchema_ComplexNumberType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ComplexNumberType_DataTypeVersion"] = 12184] = "OpcUa_BinarySchema_ComplexNumberType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DoubleComplexNumberType"] = 12186] = "OpcUa_BinarySchema_DoubleComplexNumberType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DoubleComplexNumberType_DataTypeVersion"] = 12187] = "OpcUa_BinarySchema_DoubleComplexNumberType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ServerOnNetwork"] = 12201] = "OpcUa_XmlSchema_ServerOnNetwork";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ServerOnNetwork_DataTypeVersion"] = 12202] = "OpcUa_XmlSchema_ServerOnNetwork_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ServerOnNetwork_DictionaryFragment"] = 12203] = "OpcUa_XmlSchema_ServerOnNetwork_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ServerOnNetwork"] = 12213] = "OpcUa_BinarySchema_ServerOnNetwork";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ServerOnNetwork_DataTypeVersion"] = 12214] = "OpcUa_BinarySchema_ServerOnNetwork_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ServerOnNetwork_DictionaryFragment"] = 12215] = "OpcUa_BinarySchema_ServerOnNetwork_DictionaryFragment";
      VariableIds2[VariableIds2["TrustListMasks_EnumValues"] = 12553] = "TrustListMasks_EnumValues";
      VariableIds2[VariableIds2["ServerConfiguration_SupportedPrivateKeyFormats"] = 12639] = "ServerConfiguration_SupportedPrivateKeyFormats";
      VariableIds2[VariableIds2["ServerConfiguration_MaxTrustListSize"] = 12640] = "ServerConfiguration_MaxTrustListSize";
      VariableIds2[VariableIds2["ServerConfiguration_MulticastDnsEnabled"] = 12641] = "ServerConfiguration_MulticastDnsEnabled";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Size"] = 12643] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Size";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_OpenCount"] = 12646] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_OpenCount";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Open_InputArguments"] = 12648] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Open_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Open_OutputArguments"] = 12649] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Open_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Close_InputArguments"] = 12651] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Close_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Read_InputArguments"] = 12653] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Read_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Read_OutputArguments"] = 12654] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Read_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Write_InputArguments"] = 12656] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Write_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_GetPosition_InputArguments"] = 12658] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_GetPosition_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_GetPosition_OutputArguments"] = 12659] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_GetPosition_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_SetPosition_InputArguments"] = 12661] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_SetPosition_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_LastUpdateTime"] = 12662] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_LastUpdateTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_OpenWithMasks_InputArguments"] = 12664] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_OpenWithMasks_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_OpenWithMasks_OutputArguments"] = 12665] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_OpenWithMasks_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_CloseAndUpdate_OutputArguments"] = 12667] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_CloseAndUpdate_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_AddCertificate_InputArguments"] = 12669] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_AddCertificate_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_RemoveCertificate_InputArguments"] = 12671] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_RemoveCertificate_InputArguments";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_TrustListDataType"] = 12677] = "OpcUa_XmlSchema_TrustListDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_TrustListDataType_DataTypeVersion"] = 12678] = "OpcUa_XmlSchema_TrustListDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_TrustListDataType_DictionaryFragment"] = 12679] = "OpcUa_XmlSchema_TrustListDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_TrustListDataType"] = 12681] = "OpcUa_BinarySchema_TrustListDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_TrustListDataType_DataTypeVersion"] = 12682] = "OpcUa_BinarySchema_TrustListDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_TrustListDataType_DictionaryFragment"] = 12683] = "OpcUa_BinarySchema_TrustListDataType_DictionaryFragment";
      VariableIds2[VariableIds2["ServerConfiguration_ServerCapabilities"] = 12710] = "ServerConfiguration_ServerCapabilities";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_RelativePathElement"] = 12712] = "OpcUa_XmlSchema_RelativePathElement";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_RelativePathElement_DataTypeVersion"] = 12713] = "OpcUa_XmlSchema_RelativePathElement_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_RelativePathElement_DictionaryFragment"] = 12714] = "OpcUa_XmlSchema_RelativePathElement_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_RelativePath"] = 12715] = "OpcUa_XmlSchema_RelativePath";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_RelativePath_DataTypeVersion"] = 12716] = "OpcUa_XmlSchema_RelativePath_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_RelativePath_DictionaryFragment"] = 12717] = "OpcUa_XmlSchema_RelativePath_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_RelativePathElement"] = 12718] = "OpcUa_BinarySchema_RelativePathElement";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_RelativePathElement_DataTypeVersion"] = 12719] = "OpcUa_BinarySchema_RelativePathElement_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_RelativePathElement_DictionaryFragment"] = 12720] = "OpcUa_BinarySchema_RelativePathElement_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_RelativePath"] = 12721] = "OpcUa_BinarySchema_RelativePath";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_RelativePath_DataTypeVersion"] = 12722] = "OpcUa_BinarySchema_RelativePath_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_RelativePath_DictionaryFragment"] = 12723] = "OpcUa_BinarySchema_RelativePath_DictionaryFragment";
      VariableIds2[VariableIds2["ServerConfiguration_CreateSigningRequest_InputArguments"] = 12738] = "ServerConfiguration_CreateSigningRequest_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CreateSigningRequest_OutputArguments"] = 12739] = "ServerConfiguration_CreateSigningRequest_OutputArguments";
      VariableIds2[VariableIds2["OptionSetValues"] = 12745] = "OptionSetValues";
      VariableIds2[VariableIds2["Server_SetSubscriptionDurable_InputArguments"] = 12750] = "Server_SetSubscriptionDurable_InputArguments";
      VariableIds2[VariableIds2["Server_SetSubscriptionDurable_OutputArguments"] = 12751] = "Server_SetSubscriptionDurable_OutputArguments";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_OptionSet"] = 12759] = "OpcUa_XmlSchema_OptionSet";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_OptionSet_DataTypeVersion"] = 12760] = "OpcUa_XmlSchema_OptionSet_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_OptionSet_DictionaryFragment"] = 12761] = "OpcUa_XmlSchema_OptionSet_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Union"] = 12762] = "OpcUa_XmlSchema_Union";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Union_DataTypeVersion"] = 12763] = "OpcUa_XmlSchema_Union_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Union_DictionaryFragment"] = 12764] = "OpcUa_XmlSchema_Union_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_OptionSet"] = 12767] = "OpcUa_BinarySchema_OptionSet";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_OptionSet_DataTypeVersion"] = 12768] = "OpcUa_BinarySchema_OptionSet_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_OptionSet_DictionaryFragment"] = 12769] = "OpcUa_BinarySchema_OptionSet_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Union"] = 12770] = "OpcUa_BinarySchema_Union";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Union_DataTypeVersion"] = 12771] = "OpcUa_BinarySchema_Union_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Union_DictionaryFragment"] = 12772] = "OpcUa_BinarySchema_Union_DictionaryFragment";
      VariableIds2[VariableIds2["ServerConfiguration_GetRejectedList_OutputArguments"] = 12778] = "ServerConfiguration_GetRejectedList_OutputArguments";
      VariableIds2[VariableIds2["Server_ResendData_InputArguments"] = 12874] = "Server_ResendData_InputArguments";
      VariableIds2[VariableIds2["Server_EstimatedReturnTime"] = 12885] = "Server_EstimatedReturnTime";
      VariableIds2[VariableIds2["Server_RequestServerStateChange_InputArguments"] = 12887] = "Server_RequestServerStateChange_InputArguments";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DiscoveryConfiguration"] = 12894] = "OpcUa_XmlSchema_DiscoveryConfiguration";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DiscoveryConfiguration_DataTypeVersion"] = 12895] = "OpcUa_XmlSchema_DiscoveryConfiguration_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DiscoveryConfiguration_DictionaryFragment"] = 12896] = "OpcUa_XmlSchema_DiscoveryConfiguration_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_MdnsDiscoveryConfiguration"] = 12897] = "OpcUa_XmlSchema_MdnsDiscoveryConfiguration";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_MdnsDiscoveryConfiguration_DataTypeVersion"] = 12898] = "OpcUa_XmlSchema_MdnsDiscoveryConfiguration_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_MdnsDiscoveryConfiguration_DictionaryFragment"] = 12899] = "OpcUa_XmlSchema_MdnsDiscoveryConfiguration_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DiscoveryConfiguration"] = 12902] = "OpcUa_BinarySchema_DiscoveryConfiguration";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DiscoveryConfiguration_DataTypeVersion"] = 12903] = "OpcUa_BinarySchema_DiscoveryConfiguration_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DiscoveryConfiguration_DictionaryFragment"] = 12904] = "OpcUa_BinarySchema_DiscoveryConfiguration_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_MdnsDiscoveryConfiguration"] = 12905] = "OpcUa_BinarySchema_MdnsDiscoveryConfiguration";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_MdnsDiscoveryConfiguration_DataTypeVersion"] = 12906] = "OpcUa_BinarySchema_MdnsDiscoveryConfiguration_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_MdnsDiscoveryConfiguration_DictionaryFragment"] = 12907] = "OpcUa_BinarySchema_MdnsDiscoveryConfiguration_DictionaryFragment";
      VariableIds2[VariableIds2["MaxByteStringLength"] = 12908] = "MaxByteStringLength";
      VariableIds2[VariableIds2["Server_ServerCapabilities_MaxByteStringLength"] = 12911] = "Server_ServerCapabilities_MaxByteStringLength";
      VariableIds2[VariableIds2["ServerConfiguration_UpdateCertificate_InputArguments"] = 13738] = "ServerConfiguration_UpdateCertificate_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_UpdateCertificate_OutputArguments"] = 13739] = "ServerConfiguration_UpdateCertificate_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Size"] = 14090] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Size";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Writable"] = 14091] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Writable";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_UserWritable"] = 14092] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_UserWritable";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_OpenCount"] = 14093] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_OpenCount";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_MimeType"] = 14094] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_MimeType";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Open_InputArguments"] = 14096] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Open_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Open_OutputArguments"] = 14097] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Open_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Close_InputArguments"] = 14099] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Close_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Read_InputArguments"] = 14101] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Read_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Read_OutputArguments"] = 14102] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Read_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Write_InputArguments"] = 14104] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Write_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_GetPosition_InputArguments"] = 14106] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_GetPosition_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_GetPosition_OutputArguments"] = 14107] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_GetPosition_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_SetPosition_InputArguments"] = 14109] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_SetPosition_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_LastUpdateTime"] = 14110] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_LastUpdateTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_OpenWithMasks_InputArguments"] = 14112] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_OpenWithMasks_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_OpenWithMasks_OutputArguments"] = 14113] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_OpenWithMasks_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_CloseAndUpdate_InputArguments"] = 14115] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_CloseAndUpdate_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_CloseAndUpdate_OutputArguments"] = 14116] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_CloseAndUpdate_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_AddCertificate_InputArguments"] = 14118] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_AddCertificate_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_RemoveCertificate_InputArguments"] = 14120] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_RemoveCertificate_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateTypes"] = 14121] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateTypes";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Size"] = 14124] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Size";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Writable"] = 14125] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Writable";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_UserWritable"] = 14126] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_UserWritable";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenCount"] = 14127] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenCount";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_MimeType"] = 14128] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_MimeType";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Open_InputArguments"] = 14130] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Open_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Open_OutputArguments"] = 14131] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Open_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Close_InputArguments"] = 14133] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Close_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Read_InputArguments"] = 14135] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Read_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Read_OutputArguments"] = 14136] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Read_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Write_InputArguments"] = 14138] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Write_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_GetPosition_InputArguments"] = 14140] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_GetPosition_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_GetPosition_OutputArguments"] = 14141] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_GetPosition_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_SetPosition_InputArguments"] = 14143] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_SetPosition_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_LastUpdateTime"] = 14144] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_LastUpdateTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenWithMasks_InputArguments"] = 14146] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenWithMasks_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenWithMasks_OutputArguments"] = 14147] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenWithMasks_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_CloseAndUpdate_InputArguments"] = 14149] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_CloseAndUpdate_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_CloseAndUpdate_OutputArguments"] = 14150] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_CloseAndUpdate_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_AddCertificate_InputArguments"] = 14152] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_AddCertificate_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_RemoveCertificate_InputArguments"] = 14154] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_RemoveCertificate_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateTypes"] = 14155] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateTypes";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Writable"] = 14157] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Writable";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_UserWritable"] = 14158] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_UserWritable";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_MimeType"] = 14159] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_MimeType";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_CloseAndUpdate_InputArguments"] = 14160] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_CloseAndUpdate_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateTypes"] = 14161] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateTypes";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PublishedVariableDataType"] = 14320] = "OpcUa_XmlSchema_PublishedVariableDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PublishedVariableDataType_DataTypeVersion"] = 14321] = "OpcUa_XmlSchema_PublishedVariableDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PublishedVariableDataType_DictionaryFragment"] = 14322] = "OpcUa_XmlSchema_PublishedVariableDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PublishedVariableDataType"] = 14324] = "OpcUa_BinarySchema_PublishedVariableDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PublishedVariableDataType_DataTypeVersion"] = 14325] = "OpcUa_BinarySchema_PublishedVariableDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PublishedVariableDataType_DictionaryFragment"] = 14326] = "OpcUa_BinarySchema_PublishedVariableDataType_DictionaryFragment";
      VariableIds2[VariableIds2["Server_ServerRedundancy_ServerNetworkGroups"] = 14415] = "Server_ServerRedundancy_ServerNetworkGroups";
      VariableIds2[VariableIds2["PubSubState_EnumStrings"] = 14648] = "PubSubState_EnumStrings";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataSetMetaDataType"] = 14805] = "OpcUa_XmlSchema_DataSetMetaDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataSetMetaDataType_DataTypeVersion"] = 14806] = "OpcUa_XmlSchema_DataSetMetaDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataSetMetaDataType_DictionaryFragment"] = 14807] = "OpcUa_XmlSchema_DataSetMetaDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_FieldMetaData"] = 14808] = "OpcUa_XmlSchema_FieldMetaData";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_FieldMetaData_DataTypeVersion"] = 14809] = "OpcUa_XmlSchema_FieldMetaData_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_FieldMetaData_DictionaryFragment"] = 14810] = "OpcUa_XmlSchema_FieldMetaData_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataTypeDescription"] = 14811] = "OpcUa_XmlSchema_DataTypeDescription";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataTypeDescription_DataTypeVersion"] = 14812] = "OpcUa_XmlSchema_DataTypeDescription_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataTypeDescription_DictionaryFragment"] = 14813] = "OpcUa_XmlSchema_DataTypeDescription_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EnumField"] = 14826] = "OpcUa_XmlSchema_EnumField";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EnumField_DataTypeVersion"] = 14827] = "OpcUa_XmlSchema_EnumField_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EnumField_DictionaryFragment"] = 14828] = "OpcUa_XmlSchema_EnumField_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_KeyValuePair"] = 14829] = "OpcUa_XmlSchema_KeyValuePair";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_KeyValuePair_DataTypeVersion"] = 14830] = "OpcUa_XmlSchema_KeyValuePair_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_KeyValuePair_DictionaryFragment"] = 14831] = "OpcUa_XmlSchema_KeyValuePair_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ConfigurationVersionDataType"] = 14832] = "OpcUa_XmlSchema_ConfigurationVersionDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ConfigurationVersionDataType_DataTypeVersion"] = 14833] = "OpcUa_XmlSchema_ConfigurationVersionDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ConfigurationVersionDataType_DictionaryFragment"] = 14834] = "OpcUa_XmlSchema_ConfigurationVersionDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_FieldTargetDataType"] = 14835] = "OpcUa_XmlSchema_FieldTargetDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_FieldTargetDataType_DataTypeVersion"] = 14836] = "OpcUa_XmlSchema_FieldTargetDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_FieldTargetDataType_DictionaryFragment"] = 14837] = "OpcUa_XmlSchema_FieldTargetDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataSetMetaDataType"] = 14849] = "OpcUa_BinarySchema_DataSetMetaDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataSetMetaDataType_DataTypeVersion"] = 14850] = "OpcUa_BinarySchema_DataSetMetaDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataSetMetaDataType_DictionaryFragment"] = 14851] = "OpcUa_BinarySchema_DataSetMetaDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_FieldMetaData"] = 14852] = "OpcUa_BinarySchema_FieldMetaData";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_FieldMetaData_DataTypeVersion"] = 14853] = "OpcUa_BinarySchema_FieldMetaData_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_FieldMetaData_DictionaryFragment"] = 14854] = "OpcUa_BinarySchema_FieldMetaData_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataTypeDescription"] = 14855] = "OpcUa_BinarySchema_DataTypeDescription";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataTypeDescription_DataTypeVersion"] = 14856] = "OpcUa_BinarySchema_DataTypeDescription_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataTypeDescription_DictionaryFragment"] = 14857] = "OpcUa_BinarySchema_DataTypeDescription_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EnumField"] = 14870] = "OpcUa_BinarySchema_EnumField";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EnumField_DataTypeVersion"] = 14871] = "OpcUa_BinarySchema_EnumField_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EnumField_DictionaryFragment"] = 14872] = "OpcUa_BinarySchema_EnumField_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_KeyValuePair"] = 14873] = "OpcUa_BinarySchema_KeyValuePair";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_KeyValuePair_DataTypeVersion"] = 14874] = "OpcUa_BinarySchema_KeyValuePair_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_KeyValuePair_DictionaryFragment"] = 14875] = "OpcUa_BinarySchema_KeyValuePair_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ConfigurationVersionDataType"] = 14876] = "OpcUa_BinarySchema_ConfigurationVersionDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ConfigurationVersionDataType_DataTypeVersion"] = 14877] = "OpcUa_BinarySchema_ConfigurationVersionDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ConfigurationVersionDataType_DictionaryFragment"] = 14878] = "OpcUa_BinarySchema_ConfigurationVersionDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_FieldTargetDataType_DataTypeVersion"] = 14880] = "OpcUa_BinarySchema_FieldTargetDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_FieldTargetDataType_DictionaryFragment"] = 14881] = "OpcUa_BinarySchema_FieldTargetDataType_DictionaryFragment";
      VariableIds2[VariableIds2["DataTypeDictionaryType_Deprecated"] = 15001] = "DataTypeDictionaryType_Deprecated";
      VariableIds2[VariableIds2["MaxCharacters"] = 15002] = "MaxCharacters";
      VariableIds2[VariableIds2["Server_UrisVersion"] = 15004] = "Server_UrisVersion";
      VariableIds2[VariableIds2["BrokerTransportQualityOfService_EnumStrings"] = 15009] = "BrokerTransportQualityOfService_EnumStrings";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ModificationInfo"] = 15018] = "OpcUa_BinarySchema_ModificationInfo";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ModificationInfo_DataTypeVersion"] = 15019] = "OpcUa_BinarySchema_ModificationInfo_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ModificationInfo_DictionaryFragment"] = 15020] = "OpcUa_BinarySchema_ModificationInfo_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ModificationInfo"] = 15021] = "OpcUa_XmlSchema_ModificationInfo";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ModificationInfo_DataTypeVersion"] = 15022] = "OpcUa_XmlSchema_ModificationInfo_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ModificationInfo_DictionaryFragment"] = 15023] = "OpcUa_XmlSchema_ModificationInfo_DictionaryFragment";
      VariableIds2[VariableIds2["AttributeWriteMask_OptionSetValues"] = 15036] = "AttributeWriteMask_OptionSetValues";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Deprecated"] = 15037] = "OpcUa_BinarySchema_Deprecated";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Deprecated"] = 15039] = "OpcUa_XmlSchema_Deprecated";
      VariableIds2[VariableIds2["PublishSubscribe_GetSecurityKeys_InputArguments"] = 15216] = "PublishSubscribe_GetSecurityKeys_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_GetSecurityKeys_OutputArguments"] = 15217] = "PublishSubscribe_GetSecurityKeys_OutputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Anonymous_ApplicationsExclude"] = 15412] = "WellKnownRole_Anonymous_ApplicationsExclude";
      VariableIds2[VariableIds2["WellKnownRole_Anonymous_EndpointsExclude"] = 15413] = "WellKnownRole_Anonymous_EndpointsExclude";
      VariableIds2[VariableIds2["WellKnownRole_AuthenticatedUser_ApplicationsExclude"] = 15414] = "WellKnownRole_AuthenticatedUser_ApplicationsExclude";
      VariableIds2[VariableIds2["WellKnownRole_AuthenticatedUser_EndpointsExclude"] = 15415] = "WellKnownRole_AuthenticatedUser_EndpointsExclude";
      VariableIds2[VariableIds2["WellKnownRole_Observer_ApplicationsExclude"] = 15416] = "WellKnownRole_Observer_ApplicationsExclude";
      VariableIds2[VariableIds2["WellKnownRole_Observer_EndpointsExclude"] = 15417] = "WellKnownRole_Observer_EndpointsExclude";
      VariableIds2[VariableIds2["WellKnownRole_Operator_ApplicationsExclude"] = 15418] = "WellKnownRole_Operator_ApplicationsExclude";
      VariableIds2[VariableIds2["WellKnownRole_Operator_EndpointsExclude"] = 15423] = "WellKnownRole_Operator_EndpointsExclude";
      VariableIds2[VariableIds2["WellKnownRole_Engineer_ApplicationsExclude"] = 15424] = "WellKnownRole_Engineer_ApplicationsExclude";
      VariableIds2[VariableIds2["WellKnownRole_Engineer_EndpointsExclude"] = 15425] = "WellKnownRole_Engineer_EndpointsExclude";
      VariableIds2[VariableIds2["WellKnownRole_Supervisor_ApplicationsExclude"] = 15426] = "WellKnownRole_Supervisor_ApplicationsExclude";
      VariableIds2[VariableIds2["WellKnownRole_Supervisor_EndpointsExclude"] = 15427] = "WellKnownRole_Supervisor_EndpointsExclude";
      VariableIds2[VariableIds2["WellKnownRole_ConfigureAdmin_ApplicationsExclude"] = 15428] = "WellKnownRole_ConfigureAdmin_ApplicationsExclude";
      VariableIds2[VariableIds2["WellKnownRole_ConfigureAdmin_EndpointsExclude"] = 15429] = "WellKnownRole_ConfigureAdmin_EndpointsExclude";
      VariableIds2[VariableIds2["WellKnownRole_SecurityAdmin_ApplicationsExclude"] = 15430] = "WellKnownRole_SecurityAdmin_ApplicationsExclude";
      VariableIds2[VariableIds2["PublishSubscribe_GetSecurityGroup_InputArguments"] = 15441] = "PublishSubscribe_GetSecurityGroup_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_GetSecurityGroup_OutputArguments"] = 15442] = "PublishSubscribe_GetSecurityGroup_OutputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_SecurityGroups_AddSecurityGroup_InputArguments"] = 15445] = "PublishSubscribe_SecurityGroups_AddSecurityGroup_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_SecurityGroups_AddSecurityGroup_OutputArguments"] = 15446] = "PublishSubscribe_SecurityGroups_AddSecurityGroup_OutputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_SecurityGroups_RemoveSecurityGroup_InputArguments"] = 15448] = "PublishSubscribe_SecurityGroups_RemoveSecurityGroup_InputArguments";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SimpleTypeDescription"] = 15501] = "OpcUa_BinarySchema_SimpleTypeDescription";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SimpleTypeDescription_DataTypeVersion"] = 15509] = "OpcUa_BinarySchema_SimpleTypeDescription_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SimpleTypeDescription_DictionaryFragment"] = 15519] = "OpcUa_BinarySchema_SimpleTypeDescription_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UABinaryFileDataType"] = 15521] = "OpcUa_BinarySchema_UABinaryFileDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UABinaryFileDataType_DataTypeVersion"] = 15522] = "OpcUa_BinarySchema_UABinaryFileDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UABinaryFileDataType_DictionaryFragment"] = 15523] = "OpcUa_BinarySchema_UABinaryFileDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_BrokerConnectionTransportDataType"] = 15524] = "OpcUa_BinarySchema_BrokerConnectionTransportDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_BrokerConnectionTransportDataType_DataTypeVersion"] = 15525] = "OpcUa_BinarySchema_BrokerConnectionTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_BrokerConnectionTransportDataType_DictionaryFragment"] = 15526] = "OpcUa_BinarySchema_BrokerConnectionTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["WellKnownRole_SecurityAdmin_EndpointsExclude"] = 15527] = "WellKnownRole_SecurityAdmin_EndpointsExclude";
      VariableIds2[VariableIds2["DataSetFieldFlags_OptionSetValues"] = 15577] = "DataSetFieldFlags_OptionSetValues";
      VariableIds2[VariableIds2["DataSetFieldContentMask_OptionSetValues"] = 15584] = "DataSetFieldContentMask_OptionSetValues";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SimpleTypeDescription"] = 15585] = "OpcUa_XmlSchema_SimpleTypeDescription";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SimpleTypeDescription_DataTypeVersion"] = 15586] = "OpcUa_XmlSchema_SimpleTypeDescription_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SimpleTypeDescription_DictionaryFragment"] = 15587] = "OpcUa_XmlSchema_SimpleTypeDescription_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UABinaryFileDataType"] = 15588] = "OpcUa_XmlSchema_UABinaryFileDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_StructureDescription"] = 15591] = "OpcUa_XmlSchema_StructureDescription";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_StructureDescription_DataTypeVersion"] = 15592] = "OpcUa_XmlSchema_StructureDescription_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_StructureDescription_DictionaryFragment"] = 15593] = "OpcUa_XmlSchema_StructureDescription_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EnumDescription"] = 15594] = "OpcUa_XmlSchema_EnumDescription";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EnumDescription_DataTypeVersion"] = 15595] = "OpcUa_XmlSchema_EnumDescription_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EnumDescription_DictionaryFragment"] = 15596] = "OpcUa_XmlSchema_EnumDescription_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_StructureDescription"] = 15599] = "OpcUa_BinarySchema_StructureDescription";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_StructureDescription_DataTypeVersion"] = 15600] = "OpcUa_BinarySchema_StructureDescription_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_StructureDescription_DictionaryFragment"] = 15601] = "OpcUa_BinarySchema_StructureDescription_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EnumDescription"] = 15602] = "OpcUa_BinarySchema_EnumDescription";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EnumDescription_DataTypeVersion"] = 15603] = "OpcUa_BinarySchema_EnumDescription_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EnumDescription_DictionaryFragment"] = 15604] = "OpcUa_BinarySchema_EnumDescription_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UABinaryFileDataType_DataTypeVersion"] = 15610] = "OpcUa_XmlSchema_UABinaryFileDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UABinaryFileDataType_DictionaryFragment"] = 15619] = "OpcUa_XmlSchema_UABinaryFileDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_BrokerConnectionTransportDataType"] = 15640] = "OpcUa_XmlSchema_BrokerConnectionTransportDataType";
      VariableIds2[VariableIds2["UadpNetworkMessageContentMask_OptionSetValues"] = 15643] = "UadpNetworkMessageContentMask_OptionSetValues";
      VariableIds2[VariableIds2["UadpDataSetMessageContentMask_OptionSetValues"] = 15647] = "UadpDataSetMessageContentMask_OptionSetValues";
      VariableIds2[VariableIds2["WellKnownRole_Anonymous_AddIdentity_InputArguments"] = 15649] = "WellKnownRole_Anonymous_AddIdentity_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Anonymous_RemoveIdentity_InputArguments"] = 15651] = "WellKnownRole_Anonymous_RemoveIdentity_InputArguments";
      VariableIds2[VariableIds2["JsonNetworkMessageContentMask_OptionSetValues"] = 15655] = "JsonNetworkMessageContentMask_OptionSetValues";
      VariableIds2[VariableIds2["JsonDataSetMessageContentMask_OptionSetValues"] = 15659] = "JsonDataSetMessageContentMask_OptionSetValues";
      VariableIds2[VariableIds2["WellKnownRole_AuthenticatedUser_AddIdentity_InputArguments"] = 15661] = "WellKnownRole_AuthenticatedUser_AddIdentity_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_AuthenticatedUser_RemoveIdentity_InputArguments"] = 15663] = "WellKnownRole_AuthenticatedUser_RemoveIdentity_InputArguments";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_BrokerConnectionTransportDataType_DataTypeVersion"] = 15666] = "OpcUa_XmlSchema_BrokerConnectionTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["WellKnownRole_Observer_AddIdentity_InputArguments"] = 15673] = "WellKnownRole_Observer_AddIdentity_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Observer_RemoveIdentity_InputArguments"] = 15675] = "WellKnownRole_Observer_RemoveIdentity_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Operator_AddIdentity_InputArguments"] = 15685] = "WellKnownRole_Operator_AddIdentity_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Operator_RemoveIdentity_InputArguments"] = 15687] = "WellKnownRole_Operator_RemoveIdentity_InputArguments";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_BrokerConnectionTransportDataType_DictionaryFragment"] = 15690] = "OpcUa_XmlSchema_BrokerConnectionTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["WellKnownRole_Supervisor_AddIdentity_InputArguments"] = 15697] = "WellKnownRole_Supervisor_AddIdentity_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Supervisor_RemoveIdentity_InputArguments"] = 15699] = "WellKnownRole_Supervisor_RemoveIdentity_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityAdmin_AddIdentity_InputArguments"] = 15709] = "WellKnownRole_SecurityAdmin_AddIdentity_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityAdmin_RemoveIdentity_InputArguments"] = 15711] = "WellKnownRole_SecurityAdmin_RemoveIdentity_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_ConfigureAdmin_AddIdentity_InputArguments"] = 15721] = "WellKnownRole_ConfigureAdmin_AddIdentity_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_ConfigureAdmin_RemoveIdentity_InputArguments"] = 15723] = "WellKnownRole_ConfigureAdmin_RemoveIdentity_InputArguments";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_IdentityMappingRuleType"] = 15730] = "OpcUa_XmlSchema_IdentityMappingRuleType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_IdentityMappingRuleType_DataTypeVersion"] = 15731] = "OpcUa_XmlSchema_IdentityMappingRuleType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EndpointType"] = 15734] = "OpcUa_BinarySchema_EndpointType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EndpointType_DataTypeVersion"] = 15735] = "OpcUa_BinarySchema_EndpointType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_IdentityMappingRuleType"] = 15738] = "OpcUa_BinarySchema_IdentityMappingRuleType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_IdentityMappingRuleType_DataTypeVersion"] = 15739] = "OpcUa_BinarySchema_IdentityMappingRuleType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataTypeSchemaHeader"] = 15741] = "OpcUa_BinarySchema_DataTypeSchemaHeader";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataTypeSchemaHeader_DataTypeVersion"] = 15742] = "OpcUa_BinarySchema_DataTypeSchemaHeader_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataTypeSchemaHeader_DictionaryFragment"] = 15743] = "OpcUa_BinarySchema_DataTypeSchemaHeader_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PublishedDataSetDataType"] = 15766] = "OpcUa_BinarySchema_PublishedDataSetDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PublishedDataSetDataType_DataTypeVersion"] = 15767] = "OpcUa_BinarySchema_PublishedDataSetDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PublishedDataSetDataType_DictionaryFragment"] = 15768] = "OpcUa_BinarySchema_PublishedDataSetDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PublishedDataSetSourceDataType"] = 15769] = "OpcUa_BinarySchema_PublishedDataSetSourceDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PublishedDataSetSourceDataType_DataTypeVersion"] = 15770] = "OpcUa_BinarySchema_PublishedDataSetSourceDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PublishedDataSetSourceDataType_DictionaryFragment"] = 15771] = "OpcUa_BinarySchema_PublishedDataSetSourceDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PublishedDataItemsDataType"] = 15772] = "OpcUa_BinarySchema_PublishedDataItemsDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PublishedDataItemsDataType_DataTypeVersion"] = 15773] = "OpcUa_BinarySchema_PublishedDataItemsDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PublishedDataItemsDataType_DictionaryFragment"] = 15774] = "OpcUa_BinarySchema_PublishedDataItemsDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PublishedEventsDataType"] = 15775] = "OpcUa_BinarySchema_PublishedEventsDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PublishedEventsDataType_DataTypeVersion"] = 15776] = "OpcUa_BinarySchema_PublishedEventsDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PublishedEventsDataType_DictionaryFragment"] = 15777] = "OpcUa_BinarySchema_PublishedEventsDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataSetWriterDataType"] = 15778] = "OpcUa_BinarySchema_DataSetWriterDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataSetWriterDataType_DataTypeVersion"] = 15779] = "OpcUa_BinarySchema_DataSetWriterDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataSetWriterDataType_DictionaryFragment"] = 15780] = "OpcUa_BinarySchema_DataSetWriterDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataSetWriterTransportDataType"] = 15781] = "OpcUa_BinarySchema_DataSetWriterTransportDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataSetWriterTransportDataType_DataTypeVersion"] = 15782] = "OpcUa_BinarySchema_DataSetWriterTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataSetWriterTransportDataType_DictionaryFragment"] = 15783] = "OpcUa_BinarySchema_DataSetWriterTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataSetWriterMessageDataType"] = 15784] = "OpcUa_BinarySchema_DataSetWriterMessageDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataSetWriterMessageDataType_DataTypeVersion"] = 15785] = "OpcUa_BinarySchema_DataSetWriterMessageDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataSetWriterMessageDataType_DictionaryFragment"] = 15786] = "OpcUa_BinarySchema_DataSetWriterMessageDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PubSubGroupDataType"] = 15787] = "OpcUa_BinarySchema_PubSubGroupDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PubSubGroupDataType_DataTypeVersion"] = 15788] = "OpcUa_BinarySchema_PubSubGroupDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PubSubGroupDataType_DictionaryFragment"] = 15789] = "OpcUa_BinarySchema_PubSubGroupDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_WriterGroupTransportDataType"] = 15793] = "OpcUa_BinarySchema_WriterGroupTransportDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_WriterGroupTransportDataType_DataTypeVersion"] = 15852] = "OpcUa_BinarySchema_WriterGroupTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_WriterGroupTransportDataType_DictionaryFragment"] = 15853] = "OpcUa_BinarySchema_WriterGroupTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_WriterGroupMessageDataType"] = 15854] = "OpcUa_BinarySchema_WriterGroupMessageDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_WriterGroupMessageDataType_DataTypeVersion"] = 15855] = "OpcUa_BinarySchema_WriterGroupMessageDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_WriterGroupMessageDataType_DictionaryFragment"] = 15856] = "OpcUa_BinarySchema_WriterGroupMessageDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PubSubConnectionDataType"] = 15857] = "OpcUa_BinarySchema_PubSubConnectionDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PubSubConnectionDataType_DataTypeVersion"] = 15858] = "OpcUa_BinarySchema_PubSubConnectionDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PubSubConnectionDataType_DictionaryFragment"] = 15859] = "OpcUa_BinarySchema_PubSubConnectionDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ConnectionTransportDataType"] = 15860] = "OpcUa_BinarySchema_ConnectionTransportDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ConnectionTransportDataType_DataTypeVersion"] = 15861] = "OpcUa_BinarySchema_ConnectionTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ConnectionTransportDataType_DictionaryFragment"] = 15862] = "OpcUa_BinarySchema_ConnectionTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ReaderGroupTransportDataType"] = 15866] = "OpcUa_BinarySchema_ReaderGroupTransportDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ReaderGroupTransportDataType_DataTypeVersion"] = 15867] = "OpcUa_BinarySchema_ReaderGroupTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ReaderGroupTransportDataType_DictionaryFragment"] = 15868] = "OpcUa_BinarySchema_ReaderGroupTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ReaderGroupMessageDataType"] = 15869] = "OpcUa_BinarySchema_ReaderGroupMessageDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ReaderGroupMessageDataType_DataTypeVersion"] = 15870] = "OpcUa_BinarySchema_ReaderGroupMessageDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ReaderGroupMessageDataType_DictionaryFragment"] = 15871] = "OpcUa_BinarySchema_ReaderGroupMessageDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataSetReaderDataType"] = 15872] = "OpcUa_BinarySchema_DataSetReaderDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataSetReaderDataType_DataTypeVersion"] = 15873] = "OpcUa_BinarySchema_DataSetReaderDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OverrideValueHandling_EnumStrings"] = 15875] = "OverrideValueHandling_EnumStrings";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataSetReaderDataType_DictionaryFragment"] = 15876] = "OpcUa_BinarySchema_DataSetReaderDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataSetReaderTransportDataType"] = 15877] = "OpcUa_BinarySchema_DataSetReaderTransportDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataSetReaderTransportDataType_DataTypeVersion"] = 15878] = "OpcUa_BinarySchema_DataSetReaderTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataSetReaderTransportDataType_DictionaryFragment"] = 15879] = "OpcUa_BinarySchema_DataSetReaderTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataSetReaderMessageDataType"] = 15880] = "OpcUa_BinarySchema_DataSetReaderMessageDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataSetReaderMessageDataType_DataTypeVersion"] = 15881] = "OpcUa_BinarySchema_DataSetReaderMessageDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataSetReaderMessageDataType_DictionaryFragment"] = 15882] = "OpcUa_BinarySchema_DataSetReaderMessageDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SubscribedDataSetDataType"] = 15883] = "OpcUa_BinarySchema_SubscribedDataSetDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SubscribedDataSetDataType_DataTypeVersion"] = 15884] = "OpcUa_BinarySchema_SubscribedDataSetDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SubscribedDataSetDataType_DictionaryFragment"] = 15885] = "OpcUa_BinarySchema_SubscribedDataSetDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_TargetVariablesDataType"] = 15886] = "OpcUa_BinarySchema_TargetVariablesDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_TargetVariablesDataType_DataTypeVersion"] = 15887] = "OpcUa_BinarySchema_TargetVariablesDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_TargetVariablesDataType_DictionaryFragment"] = 15888] = "OpcUa_BinarySchema_TargetVariablesDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SubscribedDataSetMirrorDataType"] = 15889] = "OpcUa_BinarySchema_SubscribedDataSetMirrorDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SubscribedDataSetMirrorDataType_DataTypeVersion"] = 15890] = "OpcUa_BinarySchema_SubscribedDataSetMirrorDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SubscribedDataSetMirrorDataType_DictionaryFragment"] = 15891] = "OpcUa_BinarySchema_SubscribedDataSetMirrorDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UadpWriterGroupMessageDataType"] = 15895] = "OpcUa_BinarySchema_UadpWriterGroupMessageDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UadpWriterGroupMessageDataType_DataTypeVersion"] = 15896] = "OpcUa_BinarySchema_UadpWriterGroupMessageDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UadpWriterGroupMessageDataType_DictionaryFragment"] = 15897] = "OpcUa_BinarySchema_UadpWriterGroupMessageDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UadpDataSetWriterMessageDataType"] = 15898] = "OpcUa_BinarySchema_UadpDataSetWriterMessageDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UadpDataSetWriterMessageDataType_DataTypeVersion"] = 15899] = "OpcUa_BinarySchema_UadpDataSetWriterMessageDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UadpDataSetWriterMessageDataType_DictionaryFragment"] = 15900] = "OpcUa_BinarySchema_UadpDataSetWriterMessageDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UadpDataSetReaderMessageDataType"] = 15919] = "OpcUa_BinarySchema_UadpDataSetReaderMessageDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UadpDataSetReaderMessageDataType_DataTypeVersion"] = 15920] = "OpcUa_BinarySchema_UadpDataSetReaderMessageDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UadpDataSetReaderMessageDataType_DictionaryFragment"] = 15921] = "OpcUa_BinarySchema_UadpDataSetReaderMessageDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_JsonWriterGroupMessageDataType"] = 15922] = "OpcUa_BinarySchema_JsonWriterGroupMessageDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_JsonWriterGroupMessageDataType_DataTypeVersion"] = 15923] = "OpcUa_BinarySchema_JsonWriterGroupMessageDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_JsonWriterGroupMessageDataType_DictionaryFragment"] = 15924] = "OpcUa_BinarySchema_JsonWriterGroupMessageDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_JsonDataSetWriterMessageDataType"] = 15925] = "OpcUa_BinarySchema_JsonDataSetWriterMessageDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_JsonDataSetWriterMessageDataType_DataTypeVersion"] = 15929] = "OpcUa_BinarySchema_JsonDataSetWriterMessageDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_JsonDataSetWriterMessageDataType_DictionaryFragment"] = 15930] = "OpcUa_BinarySchema_JsonDataSetWriterMessageDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_JsonDataSetReaderMessageDataType"] = 15931] = "OpcUa_BinarySchema_JsonDataSetReaderMessageDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_JsonDataSetReaderMessageDataType_DataTypeVersion"] = 15935] = "OpcUa_BinarySchema_JsonDataSetReaderMessageDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_JsonDataSetReaderMessageDataType_DictionaryFragment"] = 15936] = "OpcUa_BinarySchema_JsonDataSetReaderMessageDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_BrokerWriterGroupTransportDataType"] = 15940] = "OpcUa_BinarySchema_BrokerWriterGroupTransportDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_BrokerWriterGroupTransportDataType_DataTypeVersion"] = 15941] = "OpcUa_BinarySchema_BrokerWriterGroupTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_BrokerWriterGroupTransportDataType_DictionaryFragment"] = 15942] = "OpcUa_BinarySchema_BrokerWriterGroupTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_BrokerDataSetWriterTransportDataType"] = 15943] = "OpcUa_BinarySchema_BrokerDataSetWriterTransportDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_BrokerDataSetWriterTransportDataType_DataTypeVersion"] = 15944] = "OpcUa_BinarySchema_BrokerDataSetWriterTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_BrokerDataSetWriterTransportDataType_DictionaryFragment"] = 15945] = "OpcUa_BinarySchema_BrokerDataSetWriterTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_BrokerDataSetReaderTransportDataType"] = 15946] = "OpcUa_BinarySchema_BrokerDataSetReaderTransportDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_BrokerDataSetReaderTransportDataType_DataTypeVersion"] = 15947] = "OpcUa_BinarySchema_BrokerDataSetReaderTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_BrokerDataSetReaderTransportDataType_DictionaryFragment"] = 15948] = "OpcUa_BinarySchema_BrokerDataSetReaderTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_NamespaceUri"] = 15958] = "OPCUANamespaceMetadata_NamespaceUri";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_NamespaceVersion"] = 15959] = "OPCUANamespaceMetadata_NamespaceVersion";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_NamespacePublicationDate"] = 15960] = "OPCUANamespaceMetadata_NamespacePublicationDate";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_IsNamespaceSubset"] = 15961] = "OPCUANamespaceMetadata_IsNamespaceSubset";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_StaticNodeIdTypes"] = 15962] = "OPCUANamespaceMetadata_StaticNodeIdTypes";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_StaticNumericNodeIdRange"] = 15963] = "OPCUANamespaceMetadata_StaticNumericNodeIdRange";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_StaticStringNodeIdPattern"] = 15964] = "OPCUANamespaceMetadata_StaticStringNodeIdPattern";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_NamespaceFile_Size"] = 15966] = "OPCUANamespaceMetadata_NamespaceFile_Size";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_NamespaceFile_Writable"] = 15967] = "OPCUANamespaceMetadata_NamespaceFile_Writable";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_NamespaceFile_UserWritable"] = 15968] = "OPCUANamespaceMetadata_NamespaceFile_UserWritable";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_NamespaceFile_OpenCount"] = 15969] = "OPCUANamespaceMetadata_NamespaceFile_OpenCount";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_NamespaceFile_MimeType"] = 15970] = "OPCUANamespaceMetadata_NamespaceFile_MimeType";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_NamespaceFile_Open_InputArguments"] = 15972] = "OPCUANamespaceMetadata_NamespaceFile_Open_InputArguments";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_NamespaceFile_Open_OutputArguments"] = 15973] = "OPCUANamespaceMetadata_NamespaceFile_Open_OutputArguments";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_NamespaceFile_Close_InputArguments"] = 15975] = "OPCUANamespaceMetadata_NamespaceFile_Close_InputArguments";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_NamespaceFile_Read_InputArguments"] = 15977] = "OPCUANamespaceMetadata_NamespaceFile_Read_InputArguments";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_NamespaceFile_Read_OutputArguments"] = 15978] = "OPCUANamespaceMetadata_NamespaceFile_Read_OutputArguments";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_NamespaceFile_Write_InputArguments"] = 15980] = "OPCUANamespaceMetadata_NamespaceFile_Write_InputArguments";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_NamespaceFile_GetPosition_InputArguments"] = 15982] = "OPCUANamespaceMetadata_NamespaceFile_GetPosition_InputArguments";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_NamespaceFile_GetPosition_OutputArguments"] = 15983] = "OPCUANamespaceMetadata_NamespaceFile_GetPosition_OutputArguments";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_NamespaceFile_SetPosition_InputArguments"] = 15985] = "OPCUANamespaceMetadata_NamespaceFile_SetPosition_InputArguments";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EndpointType"] = 16024] = "OpcUa_XmlSchema_EndpointType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EndpointType_DataTypeVersion"] = 16025] = "OpcUa_XmlSchema_EndpointType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataTypeSchemaHeader"] = 16027] = "OpcUa_XmlSchema_DataTypeSchemaHeader";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataTypeSchemaHeader_DataTypeVersion"] = 16028] = "OpcUa_XmlSchema_DataTypeSchemaHeader_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataTypeSchemaHeader_DictionaryFragment"] = 16029] = "OpcUa_XmlSchema_DataTypeSchemaHeader_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PublishedDataSetDataType"] = 16030] = "OpcUa_XmlSchema_PublishedDataSetDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PublishedDataSetDataType_DataTypeVersion"] = 16031] = "OpcUa_XmlSchema_PublishedDataSetDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PublishedDataSetDataType_DictionaryFragment"] = 16032] = "OpcUa_XmlSchema_PublishedDataSetDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PublishedDataSetSourceDataType"] = 16033] = "OpcUa_XmlSchema_PublishedDataSetSourceDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PublishedDataSetSourceDataType_DataTypeVersion"] = 16034] = "OpcUa_XmlSchema_PublishedDataSetSourceDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PublishedDataSetSourceDataType_DictionaryFragment"] = 16035] = "OpcUa_XmlSchema_PublishedDataSetSourceDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PublishedDataItemsDataType"] = 16037] = "OpcUa_XmlSchema_PublishedDataItemsDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PublishedDataItemsDataType_DataTypeVersion"] = 16038] = "OpcUa_XmlSchema_PublishedDataItemsDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PublishedDataItemsDataType_DictionaryFragment"] = 16039] = "OpcUa_XmlSchema_PublishedDataItemsDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PublishedEventsDataType"] = 16040] = "OpcUa_XmlSchema_PublishedEventsDataType";
      VariableIds2[VariableIds2["WellKnownRole_Engineer_AddIdentity_InputArguments"] = 16042] = "WellKnownRole_Engineer_AddIdentity_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Engineer_RemoveIdentity_InputArguments"] = 16044] = "WellKnownRole_Engineer_RemoveIdentity_InputArguments";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PublishedEventsDataType_DataTypeVersion"] = 16045] = "OpcUa_XmlSchema_PublishedEventsDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PublishedEventsDataType_DictionaryFragment"] = 16046] = "OpcUa_XmlSchema_PublishedEventsDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataSetWriterDataType"] = 16047] = "OpcUa_XmlSchema_DataSetWriterDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataSetWriterDataType_DataTypeVersion"] = 16048] = "OpcUa_XmlSchema_DataSetWriterDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataSetWriterDataType_DictionaryFragment"] = 16049] = "OpcUa_XmlSchema_DataSetWriterDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataSetWriterTransportDataType"] = 16050] = "OpcUa_XmlSchema_DataSetWriterTransportDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataSetWriterTransportDataType_DataTypeVersion"] = 16051] = "OpcUa_XmlSchema_DataSetWriterTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataSetWriterTransportDataType_DictionaryFragment"] = 16052] = "OpcUa_XmlSchema_DataSetWriterTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataSetWriterMessageDataType"] = 16053] = "OpcUa_XmlSchema_DataSetWriterMessageDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataSetWriterMessageDataType_DataTypeVersion"] = 16054] = "OpcUa_XmlSchema_DataSetWriterMessageDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataSetWriterMessageDataType_DictionaryFragment"] = 16055] = "OpcUa_XmlSchema_DataSetWriterMessageDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PubSubGroupDataType"] = 16056] = "OpcUa_XmlSchema_PubSubGroupDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PubSubGroupDataType_DataTypeVersion"] = 16057] = "OpcUa_XmlSchema_PubSubGroupDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PubSubGroupDataType_DictionaryFragment"] = 16058] = "OpcUa_XmlSchema_PubSubGroupDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_WriterGroupTransportDataType"] = 16062] = "OpcUa_XmlSchema_WriterGroupTransportDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_WriterGroupTransportDataType_DataTypeVersion"] = 16063] = "OpcUa_XmlSchema_WriterGroupTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_WriterGroupTransportDataType_DictionaryFragment"] = 16064] = "OpcUa_XmlSchema_WriterGroupTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_WriterGroupMessageDataType"] = 16065] = "OpcUa_XmlSchema_WriterGroupMessageDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_WriterGroupMessageDataType_DataTypeVersion"] = 16066] = "OpcUa_XmlSchema_WriterGroupMessageDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_WriterGroupMessageDataType_DictionaryFragment"] = 16067] = "OpcUa_XmlSchema_WriterGroupMessageDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PubSubConnectionDataType"] = 16068] = "OpcUa_XmlSchema_PubSubConnectionDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PubSubConnectionDataType_DataTypeVersion"] = 16069] = "OpcUa_XmlSchema_PubSubConnectionDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PubSubConnectionDataType_DictionaryFragment"] = 16070] = "OpcUa_XmlSchema_PubSubConnectionDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ConnectionTransportDataType"] = 16071] = "OpcUa_XmlSchema_ConnectionTransportDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ConnectionTransportDataType_DataTypeVersion"] = 16072] = "OpcUa_XmlSchema_ConnectionTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ConnectionTransportDataType_DictionaryFragment"] = 16073] = "OpcUa_XmlSchema_ConnectionTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ReaderGroupTransportDataType"] = 16077] = "OpcUa_XmlSchema_ReaderGroupTransportDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ReaderGroupTransportDataType_DataTypeVersion"] = 16078] = "OpcUa_XmlSchema_ReaderGroupTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ReaderGroupTransportDataType_DictionaryFragment"] = 16079] = "OpcUa_XmlSchema_ReaderGroupTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ReaderGroupMessageDataType"] = 16080] = "OpcUa_XmlSchema_ReaderGroupMessageDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ReaderGroupMessageDataType_DataTypeVersion"] = 16081] = "OpcUa_XmlSchema_ReaderGroupMessageDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ReaderGroupMessageDataType_DictionaryFragment"] = 16082] = "OpcUa_XmlSchema_ReaderGroupMessageDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataSetReaderDataType"] = 16083] = "OpcUa_XmlSchema_DataSetReaderDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataSetReaderDataType_DataTypeVersion"] = 16084] = "OpcUa_XmlSchema_DataSetReaderDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataSetReaderDataType_DictionaryFragment"] = 16085] = "OpcUa_XmlSchema_DataSetReaderDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataSetReaderTransportDataType"] = 16086] = "OpcUa_XmlSchema_DataSetReaderTransportDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataSetReaderTransportDataType_DataTypeVersion"] = 16087] = "OpcUa_XmlSchema_DataSetReaderTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataSetReaderTransportDataType_DictionaryFragment"] = 16088] = "OpcUa_XmlSchema_DataSetReaderTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataSetReaderMessageDataType"] = 16089] = "OpcUa_XmlSchema_DataSetReaderMessageDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataSetReaderMessageDataType_DataTypeVersion"] = 16090] = "OpcUa_XmlSchema_DataSetReaderMessageDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataSetReaderMessageDataType_DictionaryFragment"] = 16091] = "OpcUa_XmlSchema_DataSetReaderMessageDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SubscribedDataSetDataType"] = 16092] = "OpcUa_XmlSchema_SubscribedDataSetDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SubscribedDataSetDataType_DataTypeVersion"] = 16093] = "OpcUa_XmlSchema_SubscribedDataSetDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SubscribedDataSetDataType_DictionaryFragment"] = 16094] = "OpcUa_XmlSchema_SubscribedDataSetDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_TargetVariablesDataType"] = 16095] = "OpcUa_XmlSchema_TargetVariablesDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_TargetVariablesDataType_DataTypeVersion"] = 16096] = "OpcUa_XmlSchema_TargetVariablesDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_TargetVariablesDataType_DictionaryFragment"] = 16097] = "OpcUa_XmlSchema_TargetVariablesDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SubscribedDataSetMirrorDataType"] = 16098] = "OpcUa_XmlSchema_SubscribedDataSetMirrorDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SubscribedDataSetMirrorDataType_DataTypeVersion"] = 16099] = "OpcUa_XmlSchema_SubscribedDataSetMirrorDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SubscribedDataSetMirrorDataType_DictionaryFragment"] = 16100] = "OpcUa_XmlSchema_SubscribedDataSetMirrorDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UadpWriterGroupMessageDataType"] = 16104] = "OpcUa_XmlSchema_UadpWriterGroupMessageDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UadpWriterGroupMessageDataType_DataTypeVersion"] = 16105] = "OpcUa_XmlSchema_UadpWriterGroupMessageDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UadpWriterGroupMessageDataType_DictionaryFragment"] = 16106] = "OpcUa_XmlSchema_UadpWriterGroupMessageDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UadpDataSetWriterMessageDataType"] = 16107] = "OpcUa_XmlSchema_UadpDataSetWriterMessageDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UadpDataSetWriterMessageDataType_DataTypeVersion"] = 16108] = "OpcUa_XmlSchema_UadpDataSetWriterMessageDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UadpDataSetWriterMessageDataType_DictionaryFragment"] = 16109] = "OpcUa_XmlSchema_UadpDataSetWriterMessageDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UadpDataSetReaderMessageDataType"] = 16110] = "OpcUa_XmlSchema_UadpDataSetReaderMessageDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UadpDataSetReaderMessageDataType_DataTypeVersion"] = 16111] = "OpcUa_XmlSchema_UadpDataSetReaderMessageDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UadpDataSetReaderMessageDataType_DictionaryFragment"] = 16112] = "OpcUa_XmlSchema_UadpDataSetReaderMessageDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_JsonWriterGroupMessageDataType"] = 16113] = "OpcUa_XmlSchema_JsonWriterGroupMessageDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_JsonWriterGroupMessageDataType_DataTypeVersion"] = 16114] = "OpcUa_XmlSchema_JsonWriterGroupMessageDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_JsonWriterGroupMessageDataType_DictionaryFragment"] = 16115] = "OpcUa_XmlSchema_JsonWriterGroupMessageDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_JsonDataSetWriterMessageDataType"] = 16116] = "OpcUa_XmlSchema_JsonDataSetWriterMessageDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_JsonDataSetWriterMessageDataType_DataTypeVersion"] = 16117] = "OpcUa_XmlSchema_JsonDataSetWriterMessageDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_JsonDataSetWriterMessageDataType_DictionaryFragment"] = 16118] = "OpcUa_XmlSchema_JsonDataSetWriterMessageDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_JsonDataSetReaderMessageDataType"] = 16119] = "OpcUa_XmlSchema_JsonDataSetReaderMessageDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_JsonDataSetReaderMessageDataType_DataTypeVersion"] = 16120] = "OpcUa_XmlSchema_JsonDataSetReaderMessageDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_JsonDataSetReaderMessageDataType_DictionaryFragment"] = 16121] = "OpcUa_XmlSchema_JsonDataSetReaderMessageDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_BrokerWriterGroupTransportDataType"] = 16125] = "OpcUa_XmlSchema_BrokerWriterGroupTransportDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_RolePermissionType"] = 16127] = "OpcUa_XmlSchema_RolePermissionType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_RolePermissionType_DataTypeVersion"] = 16128] = "OpcUa_XmlSchema_RolePermissionType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_BrokerWriterGroupTransportDataType_DataTypeVersion"] = 16130] = "OpcUa_XmlSchema_BrokerWriterGroupTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_RolePermissionType"] = 16131] = "OpcUa_BinarySchema_RolePermissionType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_RolePermissionType_DataTypeVersion"] = 16132] = "OpcUa_BinarySchema_RolePermissionType_DataTypeVersion";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_DefaultRolePermissions"] = 16134] = "OPCUANamespaceMetadata_DefaultRolePermissions";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_DefaultUserRolePermissions"] = 16135] = "OPCUANamespaceMetadata_DefaultUserRolePermissions";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_DefaultAccessRestrictions"] = 16136] = "OPCUANamespaceMetadata_DefaultAccessRestrictions";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_BrokerWriterGroupTransportDataType_DictionaryFragment"] = 16143] = "OpcUa_XmlSchema_BrokerWriterGroupTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_BrokerDataSetWriterTransportDataType"] = 16144] = "OpcUa_XmlSchema_BrokerDataSetWriterTransportDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_BrokerDataSetWriterTransportDataType_DataTypeVersion"] = 16145] = "OpcUa_XmlSchema_BrokerDataSetWriterTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_BrokerDataSetWriterTransportDataType_DictionaryFragment"] = 16146] = "OpcUa_XmlSchema_BrokerDataSetWriterTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_BrokerDataSetReaderTransportDataType"] = 16147] = "OpcUa_XmlSchema_BrokerDataSetReaderTransportDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_BrokerDataSetReaderTransportDataType_DataTypeVersion"] = 16148] = "OpcUa_XmlSchema_BrokerDataSetReaderTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_BrokerDataSetReaderTransportDataType_DictionaryFragment"] = 16149] = "OpcUa_XmlSchema_BrokerDataSetReaderTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["WellKnownRole_Anonymous_Identities"] = 16192] = "WellKnownRole_Anonymous_Identities";
      VariableIds2[VariableIds2["WellKnownRole_Anonymous_Applications"] = 16193] = "WellKnownRole_Anonymous_Applications";
      VariableIds2[VariableIds2["WellKnownRole_Anonymous_Endpoints"] = 16194] = "WellKnownRole_Anonymous_Endpoints";
      VariableIds2[VariableIds2["WellKnownRole_Anonymous_AddApplication_InputArguments"] = 16196] = "WellKnownRole_Anonymous_AddApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Anonymous_RemoveApplication_InputArguments"] = 16198] = "WellKnownRole_Anonymous_RemoveApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Anonymous_AddEndpoint_InputArguments"] = 16200] = "WellKnownRole_Anonymous_AddEndpoint_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Anonymous_RemoveEndpoint_InputArguments"] = 16202] = "WellKnownRole_Anonymous_RemoveEndpoint_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_AuthenticatedUser_Identities"] = 16203] = "WellKnownRole_AuthenticatedUser_Identities";
      VariableIds2[VariableIds2["WellKnownRole_AuthenticatedUser_Applications"] = 16204] = "WellKnownRole_AuthenticatedUser_Applications";
      VariableIds2[VariableIds2["WellKnownRole_AuthenticatedUser_Endpoints"] = 16205] = "WellKnownRole_AuthenticatedUser_Endpoints";
      VariableIds2[VariableIds2["WellKnownRole_AuthenticatedUser_AddApplication_InputArguments"] = 16207] = "WellKnownRole_AuthenticatedUser_AddApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_AuthenticatedUser_RemoveApplication_InputArguments"] = 16209] = "WellKnownRole_AuthenticatedUser_RemoveApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_AuthenticatedUser_AddEndpoint_InputArguments"] = 16211] = "WellKnownRole_AuthenticatedUser_AddEndpoint_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_AuthenticatedUser_RemoveEndpoint_InputArguments"] = 16213] = "WellKnownRole_AuthenticatedUser_RemoveEndpoint_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Observer_Identities"] = 16214] = "WellKnownRole_Observer_Identities";
      VariableIds2[VariableIds2["WellKnownRole_Observer_Applications"] = 16215] = "WellKnownRole_Observer_Applications";
      VariableIds2[VariableIds2["WellKnownRole_Observer_Endpoints"] = 16216] = "WellKnownRole_Observer_Endpoints";
      VariableIds2[VariableIds2["WellKnownRole_Observer_AddApplication_InputArguments"] = 16218] = "WellKnownRole_Observer_AddApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Observer_RemoveApplication_InputArguments"] = 16220] = "WellKnownRole_Observer_RemoveApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Observer_AddEndpoint_InputArguments"] = 16222] = "WellKnownRole_Observer_AddEndpoint_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Observer_RemoveEndpoint_InputArguments"] = 16224] = "WellKnownRole_Observer_RemoveEndpoint_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Operator_Identities"] = 16225] = "WellKnownRole_Operator_Identities";
      VariableIds2[VariableIds2["WellKnownRole_Operator_Applications"] = 16226] = "WellKnownRole_Operator_Applications";
      VariableIds2[VariableIds2["WellKnownRole_Operator_Endpoints"] = 16227] = "WellKnownRole_Operator_Endpoints";
      VariableIds2[VariableIds2["WellKnownRole_Operator_AddApplication_InputArguments"] = 16229] = "WellKnownRole_Operator_AddApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Operator_RemoveApplication_InputArguments"] = 16231] = "WellKnownRole_Operator_RemoveApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Operator_AddEndpoint_InputArguments"] = 16233] = "WellKnownRole_Operator_AddEndpoint_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Operator_RemoveEndpoint_InputArguments"] = 16235] = "WellKnownRole_Operator_RemoveEndpoint_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Engineer_Identities"] = 16236] = "WellKnownRole_Engineer_Identities";
      VariableIds2[VariableIds2["WellKnownRole_Engineer_Applications"] = 16237] = "WellKnownRole_Engineer_Applications";
      VariableIds2[VariableIds2["WellKnownRole_Engineer_Endpoints"] = 16238] = "WellKnownRole_Engineer_Endpoints";
      VariableIds2[VariableIds2["WellKnownRole_Engineer_AddApplication_InputArguments"] = 16240] = "WellKnownRole_Engineer_AddApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Engineer_RemoveApplication_InputArguments"] = 16242] = "WellKnownRole_Engineer_RemoveApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Engineer_AddEndpoint_InputArguments"] = 16244] = "WellKnownRole_Engineer_AddEndpoint_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Engineer_RemoveEndpoint_InputArguments"] = 16246] = "WellKnownRole_Engineer_RemoveEndpoint_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Supervisor_Identities"] = 16247] = "WellKnownRole_Supervisor_Identities";
      VariableIds2[VariableIds2["WellKnownRole_Supervisor_Applications"] = 16248] = "WellKnownRole_Supervisor_Applications";
      VariableIds2[VariableIds2["WellKnownRole_Supervisor_Endpoints"] = 16249] = "WellKnownRole_Supervisor_Endpoints";
      VariableIds2[VariableIds2["WellKnownRole_Supervisor_AddApplication_InputArguments"] = 16251] = "WellKnownRole_Supervisor_AddApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Supervisor_RemoveApplication_InputArguments"] = 16253] = "WellKnownRole_Supervisor_RemoveApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Supervisor_AddEndpoint_InputArguments"] = 16255] = "WellKnownRole_Supervisor_AddEndpoint_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_Supervisor_RemoveEndpoint_InputArguments"] = 16257] = "WellKnownRole_Supervisor_RemoveEndpoint_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityAdmin_Identities"] = 16258] = "WellKnownRole_SecurityAdmin_Identities";
      VariableIds2[VariableIds2["WellKnownRole_SecurityAdmin_Applications"] = 16259] = "WellKnownRole_SecurityAdmin_Applications";
      VariableIds2[VariableIds2["WellKnownRole_SecurityAdmin_Endpoints"] = 16260] = "WellKnownRole_SecurityAdmin_Endpoints";
      VariableIds2[VariableIds2["WellKnownRole_SecurityAdmin_AddApplication_InputArguments"] = 16262] = "WellKnownRole_SecurityAdmin_AddApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityAdmin_RemoveApplication_InputArguments"] = 16264] = "WellKnownRole_SecurityAdmin_RemoveApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityAdmin_AddEndpoint_InputArguments"] = 16266] = "WellKnownRole_SecurityAdmin_AddEndpoint_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityAdmin_RemoveEndpoint_InputArguments"] = 16268] = "WellKnownRole_SecurityAdmin_RemoveEndpoint_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_ConfigureAdmin_Identities"] = 16269] = "WellKnownRole_ConfigureAdmin_Identities";
      VariableIds2[VariableIds2["WellKnownRole_ConfigureAdmin_Applications"] = 16270] = "WellKnownRole_ConfigureAdmin_Applications";
      VariableIds2[VariableIds2["WellKnownRole_ConfigureAdmin_Endpoints"] = 16271] = "WellKnownRole_ConfigureAdmin_Endpoints";
      VariableIds2[VariableIds2["WellKnownRole_ConfigureAdmin_AddApplication_InputArguments"] = 16273] = "WellKnownRole_ConfigureAdmin_AddApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_ConfigureAdmin_RemoveApplication_InputArguments"] = 16275] = "WellKnownRole_ConfigureAdmin_RemoveApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_ConfigureAdmin_AddEndpoint_InputArguments"] = 16277] = "WellKnownRole_ConfigureAdmin_AddEndpoint_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_ConfigureAdmin_RemoveEndpoint_InputArguments"] = 16279] = "WellKnownRole_ConfigureAdmin_RemoveEndpoint_InputArguments";
      VariableIds2[VariableIds2["Server_ServerCapabilities_RoleSet_AddRole_InputArguments"] = 16302] = "Server_ServerCapabilities_RoleSet_AddRole_InputArguments";
      VariableIds2[VariableIds2["Server_ServerCapabilities_RoleSet_AddRole_OutputArguments"] = 16303] = "Server_ServerCapabilities_RoleSet_AddRole_OutputArguments";
      VariableIds2[VariableIds2["Server_ServerCapabilities_RoleSet_RemoveRole_InputArguments"] = 16305] = "Server_ServerCapabilities_RoleSet_RemoveRole_InputArguments";
      VariableIds2[VariableIds2["FileSystem_CreateDirectory_InputArguments"] = 16349] = "FileSystem_CreateDirectory_InputArguments";
      VariableIds2[VariableIds2["FileSystem_CreateDirectory_OutputArguments"] = 16350] = "FileSystem_CreateDirectory_OutputArguments";
      VariableIds2[VariableIds2["FileSystem_CreateFile_InputArguments"] = 16352] = "FileSystem_CreateFile_InputArguments";
      VariableIds2[VariableIds2["FileSystem_CreateFile_OutputArguments"] = 16353] = "FileSystem_CreateFile_OutputArguments";
      VariableIds2[VariableIds2["FileSystem_DeleteFileSystemObject_InputArguments"] = 16355] = "FileSystem_DeleteFileSystemObject_InputArguments";
      VariableIds2[VariableIds2["FileSystem_MoveOrCopy_InputArguments"] = 16357] = "FileSystem_MoveOrCopy_InputArguments";
      VariableIds2[VariableIds2["FileSystem_MoveOrCopy_OutputArguments"] = 16358] = "FileSystem_MoveOrCopy_OutputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_SetSecurityKeys_InputArguments"] = 17365] = "PublishSubscribe_SetSecurityKeys_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_AddConnection_InputArguments"] = 17367] = "PublishSubscribe_AddConnection_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_AddConnection_OutputArguments"] = 17368] = "PublishSubscribe_AddConnection_OutputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_RemoveConnection_InputArguments"] = 17370] = "PublishSubscribe_RemoveConnection_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PublishedDataSets_AddPublishedDataItems_InputArguments"] = 17373] = "PublishSubscribe_PublishedDataSets_AddPublishedDataItems_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PublishedDataSets_AddPublishedDataItems_OutputArguments"] = 17374] = "PublishSubscribe_PublishedDataSets_AddPublishedDataItems_OutputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PublishedDataSets_AddPublishedEvents_InputArguments"] = 17376] = "PublishSubscribe_PublishedDataSets_AddPublishedEvents_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PublishedDataSets_AddPublishedEvents_OutputArguments"] = 17377] = "PublishSubscribe_PublishedDataSets_AddPublishedEvents_OutputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PublishedDataSets_AddPublishedDataItemsTemplate_InputArguments"] = 17379] = "PublishSubscribe_PublishedDataSets_AddPublishedDataItemsTemplate_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PublishedDataSets_AddPublishedDataItemsTemplate_OutputArguments"] = 17380] = "PublishSubscribe_PublishedDataSets_AddPublishedDataItemsTemplate_OutputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PublishedDataSets_AddPublishedEventsTemplate_InputArguments"] = 17382] = "PublishSubscribe_PublishedDataSets_AddPublishedEventsTemplate_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PublishedDataSets_AddPublishedEventsTemplate_OutputArguments"] = 17383] = "PublishSubscribe_PublishedDataSets_AddPublishedEventsTemplate_OutputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PublishedDataSets_RemovePublishedDataSet_InputArguments"] = 17385] = "PublishSubscribe_PublishedDataSets_RemovePublishedDataSet_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PublishedDataSets_AddDataSetFolder_InputArguments"] = 17401] = "PublishSubscribe_PublishedDataSets_AddDataSetFolder_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PublishedDataSets_AddDataSetFolder_OutputArguments"] = 17402] = "PublishSubscribe_PublishedDataSets_AddDataSetFolder_OutputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PublishedDataSets_RemoveDataSetFolder_InputArguments"] = 17404] = "PublishSubscribe_PublishedDataSets_RemoveDataSetFolder_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_Status_State"] = 17406] = "PublishSubscribe_Status_State";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_DiagnosticsLevel"] = 17410] = "PublishSubscribe_Diagnostics_DiagnosticsLevel";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_TotalInformation"] = 17411] = "PublishSubscribe_Diagnostics_TotalInformation";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_TotalInformation_Active"] = 17412] = "PublishSubscribe_Diagnostics_TotalInformation_Active";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_TotalInformation_Classification"] = 17413] = "PublishSubscribe_Diagnostics_TotalInformation_Classification";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_TotalInformation_DiagnosticsLevel"] = 17414] = "PublishSubscribe_Diagnostics_TotalInformation_DiagnosticsLevel";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_TotalInformation_TimeFirstChange"] = 17415] = "PublishSubscribe_Diagnostics_TotalInformation_TimeFirstChange";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_TotalError"] = 17416] = "PublishSubscribe_Diagnostics_TotalError";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_TotalError_Active"] = 17417] = "PublishSubscribe_Diagnostics_TotalError_Active";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_TotalError_Classification"] = 17418] = "PublishSubscribe_Diagnostics_TotalError_Classification";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_TotalError_DiagnosticsLevel"] = 17419] = "PublishSubscribe_Diagnostics_TotalError_DiagnosticsLevel";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_TotalError_TimeFirstChange"] = 17420] = "PublishSubscribe_Diagnostics_TotalError_TimeFirstChange";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_SubError"] = 17422] = "PublishSubscribe_Diagnostics_SubError";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateError"] = 17424] = "PublishSubscribe_Diagnostics_Counters_StateError";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateError_Active"] = 17425] = "PublishSubscribe_Diagnostics_Counters_StateError_Active";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateError_Classification"] = 17426] = "PublishSubscribe_Diagnostics_Counters_StateError_Classification";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateError_DiagnosticsLevel"] = 17429] = "PublishSubscribe_Diagnostics_Counters_StateError_DiagnosticsLevel";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateError_TimeFirstChange"] = 17430] = "PublishSubscribe_Diagnostics_Counters_StateError_TimeFirstChange";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateOperationalByMethod"] = 17431] = "PublishSubscribe_Diagnostics_Counters_StateOperationalByMethod";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateOperationalByMethod_Active"] = 17432] = "PublishSubscribe_Diagnostics_Counters_StateOperationalByMethod_Active";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateOperationalByMethod_Classification"] = 17433] = "PublishSubscribe_Diagnostics_Counters_StateOperationalByMethod_Classification";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel"] = 17434] = "PublishSubscribe_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange"] = 17435] = "PublishSubscribe_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateOperationalByParent"] = 17436] = "PublishSubscribe_Diagnostics_Counters_StateOperationalByParent";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateOperationalByParent_Active"] = 17437] = "PublishSubscribe_Diagnostics_Counters_StateOperationalByParent_Active";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateOperationalByParent_Classification"] = 17438] = "PublishSubscribe_Diagnostics_Counters_StateOperationalByParent_Classification";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel"] = 17439] = "PublishSubscribe_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange"] = 17440] = "PublishSubscribe_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateOperationalFromError"] = 17441] = "PublishSubscribe_Diagnostics_Counters_StateOperationalFromError";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateOperationalFromError_Active"] = 17442] = "PublishSubscribe_Diagnostics_Counters_StateOperationalFromError_Active";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateOperationalFromError_Classification"] = 17443] = "PublishSubscribe_Diagnostics_Counters_StateOperationalFromError_Classification";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel"] = 17444] = "PublishSubscribe_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange"] = 17445] = "PublishSubscribe_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StatePausedByParent"] = 17446] = "PublishSubscribe_Diagnostics_Counters_StatePausedByParent";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StatePausedByParent_Active"] = 17447] = "PublishSubscribe_Diagnostics_Counters_StatePausedByParent_Active";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StatePausedByParent_Classification"] = 17448] = "PublishSubscribe_Diagnostics_Counters_StatePausedByParent_Classification";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel"] = 17449] = "PublishSubscribe_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StatePausedByParent_TimeFirstChange"] = 17450] = "PublishSubscribe_Diagnostics_Counters_StatePausedByParent_TimeFirstChange";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateDisabledByMethod"] = 17451] = "PublishSubscribe_Diagnostics_Counters_StateDisabledByMethod";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateDisabledByMethod_Active"] = 17452] = "PublishSubscribe_Diagnostics_Counters_StateDisabledByMethod_Active";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateDisabledByMethod_Classification"] = 17453] = "PublishSubscribe_Diagnostics_Counters_StateDisabledByMethod_Classification";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel"] = 17454] = "PublishSubscribe_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange"] = 17455] = "PublishSubscribe_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_LiveValues_ConfiguredDataSetWriters"] = 17458] = "PublishSubscribe_Diagnostics_LiveValues_ConfiguredDataSetWriters";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_LiveValues_ConfiguredDataSetWriters_DiagnosticsLevel"] = 17459] = "PublishSubscribe_Diagnostics_LiveValues_ConfiguredDataSetWriters_DiagnosticsLevel";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_LiveValues_ConfiguredDataSetReaders"] = 17460] = "PublishSubscribe_Diagnostics_LiveValues_ConfiguredDataSetReaders";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_LiveValues_ConfiguredDataSetReaders_DiagnosticsLevel"] = 17461] = "PublishSubscribe_Diagnostics_LiveValues_ConfiguredDataSetReaders_DiagnosticsLevel";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_LiveValues_OperationalDataSetWriters"] = 17462] = "PublishSubscribe_Diagnostics_LiveValues_OperationalDataSetWriters";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_LiveValues_OperationalDataSetWriters_DiagnosticsLevel"] = 17463] = "PublishSubscribe_Diagnostics_LiveValues_OperationalDataSetWriters_DiagnosticsLevel";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_LiveValues_OperationalDataSetReaders"] = 17464] = "PublishSubscribe_Diagnostics_LiveValues_OperationalDataSetReaders";
      VariableIds2[VariableIds2["PublishSubscribe_Diagnostics_LiveValues_OperationalDataSetReaders_DiagnosticsLevel"] = 17466] = "PublishSubscribe_Diagnostics_LiveValues_OperationalDataSetReaders_DiagnosticsLevel";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DatagramConnectionTransportDataType"] = 17469] = "OpcUa_BinarySchema_DatagramConnectionTransportDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DatagramConnectionTransportDataType_DataTypeVersion"] = 17470] = "OpcUa_BinarySchema_DatagramConnectionTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DatagramConnectionTransportDataType_DictionaryFragment"] = 17471] = "OpcUa_BinarySchema_DatagramConnectionTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DatagramConnectionTransportDataType"] = 17473] = "OpcUa_XmlSchema_DatagramConnectionTransportDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DatagramConnectionTransportDataType_DataTypeVersion"] = 17474] = "OpcUa_XmlSchema_DatagramConnectionTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DatagramConnectionTransportDataType_DictionaryFragment"] = 17475] = "OpcUa_XmlSchema_DatagramConnectionTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["PublishSubscribe_SupportedTransportProfiles"] = 17481] = "PublishSubscribe_SupportedTransportProfiles";
      VariableIds2[VariableIds2["KeyCredentialConfiguration_CreateCredential_InputArguments"] = 17529] = "KeyCredentialConfiguration_CreateCredential_InputArguments";
      VariableIds2[VariableIds2["KeyCredentialConfiguration_CreateCredential_OutputArguments"] = 17530] = "KeyCredentialConfiguration_CreateCredential_OutputArguments";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AdditionalParametersType"] = 17538] = "OpcUa_BinarySchema_AdditionalParametersType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AdditionalParametersType_DataTypeVersion"] = 17539] = "OpcUa_BinarySchema_AdditionalParametersType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AdditionalParametersType"] = 17542] = "OpcUa_XmlSchema_AdditionalParametersType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AdditionalParametersType_DataTypeVersion"] = 17543] = "OpcUa_XmlSchema_AdditionalParametersType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EphemeralKeyType"] = 17550] = "OpcUa_BinarySchema_EphemeralKeyType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EphemeralKeyType_DataTypeVersion"] = 17551] = "OpcUa_BinarySchema_EphemeralKeyType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EphemeralKeyType"] = 17554] = "OpcUa_XmlSchema_EphemeralKeyType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EphemeralKeyType_DataTypeVersion"] = 17555] = "OpcUa_XmlSchema_EphemeralKeyType_DataTypeVersion";
      VariableIds2[VariableIds2["DefaultInstanceBrowseName"] = 17605] = "DefaultInstanceBrowseName";
      VariableIds2[VariableIds2["Server_LocalTime"] = 17634] = "Server_LocalTime";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataTypeDefinition"] = 18166] = "OpcUa_XmlSchema_DataTypeDefinition";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataTypeDefinition_DataTypeVersion"] = 18167] = "OpcUa_XmlSchema_DataTypeDefinition_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DataTypeDefinition_DictionaryFragment"] = 18168] = "OpcUa_XmlSchema_DataTypeDefinition_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_StructureField"] = 18169] = "OpcUa_XmlSchema_StructureField";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_StructureField_DataTypeVersion"] = 18170] = "OpcUa_XmlSchema_StructureField_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_StructureField_DictionaryFragment"] = 18171] = "OpcUa_XmlSchema_StructureField_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_StructureDefinition"] = 18172] = "OpcUa_XmlSchema_StructureDefinition";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_StructureDefinition_DataTypeVersion"] = 18173] = "OpcUa_XmlSchema_StructureDefinition_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_StructureDefinition_DictionaryFragment"] = 18174] = "OpcUa_XmlSchema_StructureDefinition_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EnumDefinition"] = 18175] = "OpcUa_XmlSchema_EnumDefinition";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EnumDefinition_DataTypeVersion"] = 18176] = "OpcUa_XmlSchema_EnumDefinition_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_EnumDefinition_DictionaryFragment"] = 18177] = "OpcUa_XmlSchema_EnumDefinition_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataTypeDefinition"] = 18178] = "OpcUa_BinarySchema_DataTypeDefinition";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataTypeDefinition_DataTypeVersion"] = 18179] = "OpcUa_BinarySchema_DataTypeDefinition_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DataTypeDefinition_DictionaryFragment"] = 18180] = "OpcUa_BinarySchema_DataTypeDefinition_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_StructureField"] = 18181] = "OpcUa_BinarySchema_StructureField";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_StructureField_DataTypeVersion"] = 18182] = "OpcUa_BinarySchema_StructureField_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_StructureField_DictionaryFragment"] = 18183] = "OpcUa_BinarySchema_StructureField_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_StructureDefinition"] = 18184] = "OpcUa_BinarySchema_StructureDefinition";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_StructureDefinition_DataTypeVersion"] = 18185] = "OpcUa_BinarySchema_StructureDefinition_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_StructureDefinition_DictionaryFragment"] = 18186] = "OpcUa_BinarySchema_StructureDefinition_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EnumDefinition"] = 18187] = "OpcUa_BinarySchema_EnumDefinition";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EnumDefinition_DataTypeVersion"] = 18188] = "OpcUa_BinarySchema_EnumDefinition_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_EnumDefinition_DictionaryFragment"] = 18189] = "OpcUa_BinarySchema_EnumDefinition_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_RationalNumber"] = 18824] = "OpcUa_BinarySchema_RationalNumber";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_RationalNumber_DataTypeVersion"] = 18825] = "OpcUa_BinarySchema_RationalNumber_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_RationalNumber_DictionaryFragment"] = 18826] = "OpcUa_BinarySchema_RationalNumber_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Vector"] = 18827] = "OpcUa_BinarySchema_Vector";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Vector_DataTypeVersion"] = 18828] = "OpcUa_BinarySchema_Vector_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Vector_DictionaryFragment"] = 18829] = "OpcUa_BinarySchema_Vector_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ThreeDVector"] = 18830] = "OpcUa_BinarySchema_ThreeDVector";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ThreeDVector_DataTypeVersion"] = 18831] = "OpcUa_BinarySchema_ThreeDVector_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ThreeDVector_DictionaryFragment"] = 18832] = "OpcUa_BinarySchema_ThreeDVector_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_CartesianCoordinates"] = 18833] = "OpcUa_BinarySchema_CartesianCoordinates";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_CartesianCoordinates_DataTypeVersion"] = 18834] = "OpcUa_BinarySchema_CartesianCoordinates_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_CartesianCoordinates_DictionaryFragment"] = 18835] = "OpcUa_BinarySchema_CartesianCoordinates_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ThreeDCartesianCoordinates"] = 18836] = "OpcUa_BinarySchema_ThreeDCartesianCoordinates";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ThreeDCartesianCoordinates_DataTypeVersion"] = 18837] = "OpcUa_BinarySchema_ThreeDCartesianCoordinates_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ThreeDCartesianCoordinates_DictionaryFragment"] = 18838] = "OpcUa_BinarySchema_ThreeDCartesianCoordinates_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Orientation"] = 18839] = "OpcUa_BinarySchema_Orientation";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Orientation_DataTypeVersion"] = 18840] = "OpcUa_BinarySchema_Orientation_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Orientation_DictionaryFragment"] = 18841] = "OpcUa_BinarySchema_Orientation_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ThreeDOrientation"] = 18842] = "OpcUa_BinarySchema_ThreeDOrientation";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ThreeDOrientation_DataTypeVersion"] = 18843] = "OpcUa_BinarySchema_ThreeDOrientation_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ThreeDOrientation_DictionaryFragment"] = 18844] = "OpcUa_BinarySchema_ThreeDOrientation_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Frame"] = 18845] = "OpcUa_BinarySchema_Frame";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Frame_DataTypeVersion"] = 18846] = "OpcUa_BinarySchema_Frame_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_Frame_DictionaryFragment"] = 18847] = "OpcUa_BinarySchema_Frame_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ThreeDFrame"] = 18848] = "OpcUa_BinarySchema_ThreeDFrame";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ThreeDFrame_DataTypeVersion"] = 18849] = "OpcUa_BinarySchema_ThreeDFrame_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ThreeDFrame_DictionaryFragment"] = 18850] = "OpcUa_BinarySchema_ThreeDFrame_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_RationalNumber"] = 18860] = "OpcUa_XmlSchema_RationalNumber";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_RationalNumber_DataTypeVersion"] = 18861] = "OpcUa_XmlSchema_RationalNumber_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_RationalNumber_DictionaryFragment"] = 18862] = "OpcUa_XmlSchema_RationalNumber_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Vector"] = 18863] = "OpcUa_XmlSchema_Vector";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Vector_DataTypeVersion"] = 18864] = "OpcUa_XmlSchema_Vector_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Vector_DictionaryFragment"] = 18865] = "OpcUa_XmlSchema_Vector_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ThreeDVector"] = 18866] = "OpcUa_XmlSchema_ThreeDVector";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ThreeDVector_DataTypeVersion"] = 18867] = "OpcUa_XmlSchema_ThreeDVector_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ThreeDVector_DictionaryFragment"] = 18868] = "OpcUa_XmlSchema_ThreeDVector_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_CartesianCoordinates"] = 18869] = "OpcUa_XmlSchema_CartesianCoordinates";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_CartesianCoordinates_DataTypeVersion"] = 18870] = "OpcUa_XmlSchema_CartesianCoordinates_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_CartesianCoordinates_DictionaryFragment"] = 19048] = "OpcUa_XmlSchema_CartesianCoordinates_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ThreeDCartesianCoordinates"] = 19049] = "OpcUa_XmlSchema_ThreeDCartesianCoordinates";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ThreeDCartesianCoordinates_DataTypeVersion"] = 19050] = "OpcUa_XmlSchema_ThreeDCartesianCoordinates_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ThreeDCartesianCoordinates_DictionaryFragment"] = 19051] = "OpcUa_XmlSchema_ThreeDCartesianCoordinates_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Orientation"] = 19052] = "OpcUa_XmlSchema_Orientation";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Orientation_DataTypeVersion"] = 19053] = "OpcUa_XmlSchema_Orientation_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Orientation_DictionaryFragment"] = 19054] = "OpcUa_XmlSchema_Orientation_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ThreeDOrientation"] = 19055] = "OpcUa_XmlSchema_ThreeDOrientation";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ThreeDOrientation_DataTypeVersion"] = 19056] = "OpcUa_XmlSchema_ThreeDOrientation_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ThreeDOrientation_DictionaryFragment"] = 19057] = "OpcUa_XmlSchema_ThreeDOrientation_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Frame"] = 19058] = "OpcUa_XmlSchema_Frame";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Frame_DataTypeVersion"] = 19059] = "OpcUa_XmlSchema_Frame_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_Frame_DictionaryFragment"] = 19060] = "OpcUa_XmlSchema_Frame_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ThreeDFrame"] = 19061] = "OpcUa_XmlSchema_ThreeDFrame";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ThreeDFrame_DataTypeVersion"] = 19062] = "OpcUa_XmlSchema_ThreeDFrame_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ThreeDFrame_DictionaryFragment"] = 19063] = "OpcUa_XmlSchema_ThreeDFrame_DictionaryFragment";
      VariableIds2[VariableIds2["HistoryServerCapabilities_ServerTimestampSupported"] = 19091] = "HistoryServerCapabilities_ServerTimestampSupported";
      VariableIds2[VariableIds2["HAConfiguration_ServerTimestampSupported"] = 19093] = "HAConfiguration_ServerTimestampSupported";
      VariableIds2[VariableIds2["DiagnosticsLevel_EnumStrings"] = 19724] = "DiagnosticsLevel_EnumStrings";
      VariableIds2[VariableIds2["PubSubDiagnosticsCounterClassification_EnumStrings"] = 19731] = "PubSubDiagnosticsCounterClassification_EnumStrings";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_FieldTargetDataType"] = 21002] = "OpcUa_BinarySchema_FieldTargetDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_WriterGroupDataType"] = 21156] = "OpcUa_BinarySchema_WriterGroupDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_WriterGroupDataType_DataTypeVersion"] = 21157] = "OpcUa_BinarySchema_WriterGroupDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_WriterGroupDataType_DictionaryFragment"] = 21158] = "OpcUa_BinarySchema_WriterGroupDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_NetworkAddressDataType"] = 21159] = "OpcUa_BinarySchema_NetworkAddressDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_NetworkAddressDataType_DataTypeVersion"] = 21160] = "OpcUa_BinarySchema_NetworkAddressDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_NetworkAddressDataType_DictionaryFragment"] = 21161] = "OpcUa_BinarySchema_NetworkAddressDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_NetworkAddressUrlDataType"] = 21162] = "OpcUa_BinarySchema_NetworkAddressUrlDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_NetworkAddressUrlDataType_DataTypeVersion"] = 21163] = "OpcUa_BinarySchema_NetworkAddressUrlDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_NetworkAddressUrlDataType_DictionaryFragment"] = 21164] = "OpcUa_BinarySchema_NetworkAddressUrlDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ReaderGroupDataType"] = 21165] = "OpcUa_BinarySchema_ReaderGroupDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ReaderGroupDataType_DataTypeVersion"] = 21166] = "OpcUa_BinarySchema_ReaderGroupDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ReaderGroupDataType_DictionaryFragment"] = 21167] = "OpcUa_BinarySchema_ReaderGroupDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PubSubConfigurationDataType"] = 21168] = "OpcUa_BinarySchema_PubSubConfigurationDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PubSubConfigurationDataType_DataTypeVersion"] = 21169] = "OpcUa_BinarySchema_PubSubConfigurationDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PubSubConfigurationDataType_DictionaryFragment"] = 21170] = "OpcUa_BinarySchema_PubSubConfigurationDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DatagramWriterGroupTransportDataType"] = 21171] = "OpcUa_BinarySchema_DatagramWriterGroupTransportDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DatagramWriterGroupTransportDataType_DataTypeVersion"] = 21172] = "OpcUa_BinarySchema_DatagramWriterGroupTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DatagramWriterGroupTransportDataType_DictionaryFragment"] = 21173] = "OpcUa_BinarySchema_DatagramWriterGroupTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_WriterGroupDataType"] = 21180] = "OpcUa_XmlSchema_WriterGroupDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_WriterGroupDataType_DataTypeVersion"] = 21181] = "OpcUa_XmlSchema_WriterGroupDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_WriterGroupDataType_DictionaryFragment"] = 21182] = "OpcUa_XmlSchema_WriterGroupDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_NetworkAddressDataType"] = 21183] = "OpcUa_XmlSchema_NetworkAddressDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_NetworkAddressDataType_DataTypeVersion"] = 21184] = "OpcUa_XmlSchema_NetworkAddressDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_NetworkAddressDataType_DictionaryFragment"] = 21185] = "OpcUa_XmlSchema_NetworkAddressDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_NetworkAddressUrlDataType"] = 21186] = "OpcUa_XmlSchema_NetworkAddressUrlDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_NetworkAddressUrlDataType_DataTypeVersion"] = 21187] = "OpcUa_XmlSchema_NetworkAddressUrlDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_NetworkAddressUrlDataType_DictionaryFragment"] = 21188] = "OpcUa_XmlSchema_NetworkAddressUrlDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ReaderGroupDataType"] = 21189] = "OpcUa_XmlSchema_ReaderGroupDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ReaderGroupDataType_DataTypeVersion"] = 21190] = "OpcUa_XmlSchema_ReaderGroupDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ReaderGroupDataType_DictionaryFragment"] = 21191] = "OpcUa_XmlSchema_ReaderGroupDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PubSubConfigurationDataType"] = 21192] = "OpcUa_XmlSchema_PubSubConfigurationDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PubSubConfigurationDataType_DataTypeVersion"] = 21193] = "OpcUa_XmlSchema_PubSubConfigurationDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PubSubConfigurationDataType_DictionaryFragment"] = 21194] = "OpcUa_XmlSchema_PubSubConfigurationDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DatagramWriterGroupTransportDataType"] = 21195] = "OpcUa_XmlSchema_DatagramWriterGroupTransportDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DatagramWriterGroupTransportDataType_DataTypeVersion"] = 21196] = "OpcUa_XmlSchema_DatagramWriterGroupTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DatagramWriterGroupTransportDataType_DictionaryFragment"] = 21197] = "OpcUa_XmlSchema_DatagramWriterGroupTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_UpdateFrequency"] = 22567] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_UpdateFrequency";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EventId"] = 22569] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EventId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EventType"] = 22570] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EventType";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SourceNode"] = 22571] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SourceNode";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SourceName"] = 22572] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SourceName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Time"] = 22573] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Time";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ReceiveTime"] = 22574] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ReceiveTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LocalTime"] = 22575] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LocalTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Message"] = 22576] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Message";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Severity"] = 22577] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Severity";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionClassId"] = 22578] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionClassId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionClassName"] = 22579] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionClassName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionSubClassId"] = 22580] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionSubClassId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionSubClassName"] = 22581] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionSubClassName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionName"] = 22582] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_BranchId"] = 22583] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_BranchId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Retain"] = 22584] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Retain";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState"] = 22585] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_Id"] = 22586] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_Name"] = 22587] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_Number"] = 22588] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_EffectiveDisplayName"] = 22589] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_TransitionTime"] = 22590] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_EffectiveTransitionTime"] = 22591] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_TrueState"] = 22592] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_FalseState"] = 22593] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Quality"] = 22594] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Quality";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Quality_SourceTimestamp"] = 22595] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Quality_SourceTimestamp";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LastSeverity"] = 22596] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LastSeverity";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LastSeverity_SourceTimestamp"] = 22597] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LastSeverity_SourceTimestamp";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Comment"] = 22598] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Comment";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Comment_SourceTimestamp"] = 22599] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Comment_SourceTimestamp";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ClientUserId"] = 22600] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ClientUserId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AddComment_InputArguments"] = 22604] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AddComment_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState"] = 22605] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_Id"] = 22606] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_Name"] = 22607] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_Number"] = 22608] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_EffectiveDisplayName"] = 22609] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_TransitionTime"] = 22610] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_EffectiveTransitionTime"] = 22611] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_TrueState"] = 22612] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_FalseState"] = 22613] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState"] = 22614] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Id"] = 22615] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Name"] = 22616] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Number"] = 22617] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName"] = 22618] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_TransitionTime"] = 22619] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime"] = 22620] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_TrueState"] = 22621] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_FalseState"] = 22622] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Acknowledge_InputArguments"] = 22624] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Acknowledge_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Confirm_InputArguments"] = 22626] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Confirm_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState"] = 22627] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_Id"] = 22628] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_Name"] = 22629] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_Number"] = 22630] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_EffectiveDisplayName"] = 22631] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_TransitionTime"] = 22632] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_EffectiveTransitionTime"] = 22633] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_TrueState"] = 22634] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_FalseState"] = 22635] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_InputNode"] = 22636] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_InputNode";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState"] = 22637] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_Id"] = 22638] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_Name"] = 22639] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_Number"] = 22640] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_EffectiveDisplayName"] = 22641] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_TransitionTime"] = 22642] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime"] = 22643] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_TrueState"] = 22644] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_FalseState"] = 22645] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState"] = 22646] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Id"] = 22647] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Name"] = 22648] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Number"] = 22649] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName"] = 22650] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_TransitionTime"] = 22651] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime"] = 22652] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_TrueState"] = 22653] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_FalseState"] = 22654] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState"] = 22656] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Id"] = 22657] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Name"] = 22658] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Number"] = 22659] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName"] = 22660] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition"] = 22661] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Id"] = 22662] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Name"] = 22663] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Number"] = 22664] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime"] = 22665] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime"] = 22666] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_AvailableStates"] = 22667] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_AvailableStates";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_AvailableTransitions"] = 22668] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_AvailableTransitions";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_UnshelveTime"] = 22669] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_UnshelveTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments"] = 22671] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedOrShelved"] = 22674] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedOrShelved";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_MaxTimeShelved"] = 22675] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_MaxTimeShelved";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleEnabled"] = 22676] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleEnabled";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound"] = 22677] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound_ListId"] = 22678] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound_ListId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound_AgencyId"] = 22679] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound_AgencyId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound_VersionId"] = 22680] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound_VersionId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState"] = 22681] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_Id"] = 22682] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_Name"] = 22683] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_Number"] = 22684] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_EffectiveDisplayName"] = 22685] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_TransitionTime"] = 22686] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_EffectiveTransitionTime"] = 22687] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_TrueState"] = 22688] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_FalseState"] = 22689] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OnDelay"] = 22690] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OnDelay";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OffDelay"] = 22691] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OffDelay";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_FirstInGroupFlag"] = 22692] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_FirstInGroupFlag";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState"] = 22694] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_Id"] = 22695] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_Name"] = 22696] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_Number"] = 22697] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_EffectiveDisplayName"] = 22698] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_TransitionTime"] = 22699] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_EffectiveTransitionTime"] = 22700] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_TrueState"] = 22701] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_FalseState"] = 22702] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ReAlarmTime"] = 22703] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ReAlarmTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ReAlarmRepeatCount"] = 22704] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ReAlarmRepeatCount";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_NormalState"] = 22711] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_NormalState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ExpirationDate"] = 22712] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ExpirationDate";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ExpirationLimit"] = 22713] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ExpirationLimit";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_CertificateType"] = 22714] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_CertificateType";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Certificate"] = 22715] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Certificate";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EventId"] = 22717] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EventId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EventType"] = 22718] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EventType";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SourceNode"] = 22719] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SourceNode";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SourceName"] = 22720] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SourceName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Time"] = 22721] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Time";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ReceiveTime"] = 22722] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ReceiveTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LocalTime"] = 22723] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LocalTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Message"] = 22724] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Message";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Severity"] = 22725] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Severity";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionClassId"] = 22726] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionClassId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionClassName"] = 22727] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionClassName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionSubClassId"] = 22728] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionSubClassId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionSubClassName"] = 22729] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionSubClassName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionName"] = 22730] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_BranchId"] = 22731] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_BranchId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Retain"] = 22732] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Retain";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState"] = 22733] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Id"] = 22734] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Name"] = 22735] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Number"] = 22736] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName"] = 22737] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_TransitionTime"] = 22738] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime"] = 22739] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_TrueState"] = 22740] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_FalseState"] = 22741] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Quality"] = 22742] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Quality";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Quality_SourceTimestamp"] = 22743] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Quality_SourceTimestamp";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LastSeverity"] = 22744] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LastSeverity";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp"] = 22745] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Comment"] = 22746] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Comment";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Comment_SourceTimestamp"] = 22747] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Comment_SourceTimestamp";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ClientUserId"] = 22748] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ClientUserId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AddComment_InputArguments"] = 22752] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AddComment_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState"] = 22753] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Id"] = 22754] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Name"] = 22755] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Number"] = 22756] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName"] = 22757] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_TransitionTime"] = 22758] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime"] = 22759] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_TrueState"] = 22760] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_FalseState"] = 22761] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState"] = 22762] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Id"] = 22763] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Name"] = 22764] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Number"] = 22765] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName"] = 22766] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_TransitionTime"] = 22767] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime"] = 22768] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_TrueState"] = 22769] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_FalseState"] = 22770] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Acknowledge_InputArguments"] = 22772] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Acknowledge_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Confirm_InputArguments"] = 22774] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Confirm_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState"] = 22775] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Id"] = 22776] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Name"] = 22777] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Number"] = 22778] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName"] = 22779] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_TransitionTime"] = 22780] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime"] = 22781] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_TrueState"] = 22782] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_FalseState"] = 22783] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_InputNode"] = 22784] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_InputNode";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState"] = 22785] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Id"] = 22786] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Name"] = 22787] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Number"] = 22788] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName"] = 22789] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_TransitionTime"] = 22790] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime"] = 22791] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_TrueState"] = 22792] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_FalseState"] = 22793] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState"] = 22794] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Id"] = 22795] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Name"] = 22796] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Number"] = 22797] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName"] = 22798] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime"] = 22799] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime"] = 22800] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_TrueState"] = 22801] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_FalseState"] = 22802] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState"] = 22804] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id"] = 22805] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name"] = 22806] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number"] = 22807] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName"] = 22808] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition"] = 22809] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id"] = 22810] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name"] = 22811] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number"] = 22812] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime"] = 22813] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime"] = 22814] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_AvailableStates"] = 22815] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_AvailableStates";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions"] = 22816] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_UnshelveTime"] = 22817] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_UnshelveTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments"] = 22819] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedOrShelved"] = 22822] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedOrShelved";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_MaxTimeShelved"] = 22823] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_MaxTimeShelved";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleEnabled"] = 22824] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleEnabled";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound"] = 22825] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_ListId"] = 22826] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_ListId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_AgencyId"] = 22827] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_AgencyId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_VersionId"] = 22828] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_VersionId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState"] = 22829] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Id"] = 22830] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Name"] = 22831] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Number"] = 22832] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName"] = 22833] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_TransitionTime"] = 22834] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime"] = 22835] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_TrueState"] = 22836] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_FalseState"] = 22837] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OnDelay"] = 22838] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OnDelay";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OffDelay"] = 22839] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OffDelay";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_FirstInGroupFlag"] = 22840] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_FirstInGroupFlag";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState"] = 22842] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Id"] = 22843] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Name"] = 22844] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Number"] = 22845] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName"] = 22846] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_TransitionTime"] = 22847] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime"] = 22848] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_TrueState"] = 22849] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_FalseState"] = 22850] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ReAlarmTime"] = 22851] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ReAlarmTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ReAlarmRepeatCount"] = 22852] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ReAlarmRepeatCount";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_NormalState"] = 22859] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_NormalState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_TrustListId"] = 22860] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_TrustListId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LastUpdateTime"] = 22861] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LastUpdateTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_UpdateFrequency"] = 22862] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_UpdateFrequency";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_UpdateFrequency"] = 22863] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_UpdateFrequency";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EventId"] = 22865] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EventId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EventType"] = 22866] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EventType";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SourceNode"] = 22867] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SourceNode";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SourceName"] = 22868] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SourceName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Time"] = 22869] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Time";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ReceiveTime"] = 22870] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ReceiveTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LocalTime"] = 22871] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LocalTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Message"] = 22872] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Message";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Severity"] = 22873] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Severity";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionClassId"] = 22874] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionClassId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionClassName"] = 22875] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionClassName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionSubClassId"] = 22876] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionSubClassId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionSubClassName"] = 22877] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionSubClassName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionName"] = 22878] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_BranchId"] = 22879] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_BranchId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Retain"] = 22880] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Retain";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState"] = 22881] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_Id"] = 22882] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_Name"] = 22883] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_Number"] = 22884] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_EffectiveDisplayName"] = 22885] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_TransitionTime"] = 22886] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_EffectiveTransitionTime"] = 22887] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_TrueState"] = 22888] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_FalseState"] = 22889] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Quality"] = 22890] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Quality";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Quality_SourceTimestamp"] = 22891] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Quality_SourceTimestamp";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LastSeverity"] = 22892] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LastSeverity";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LastSeverity_SourceTimestamp"] = 22893] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LastSeverity_SourceTimestamp";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Comment"] = 22894] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Comment";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Comment_SourceTimestamp"] = 22895] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Comment_SourceTimestamp";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ClientUserId"] = 22896] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ClientUserId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AddComment_InputArguments"] = 22900] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AddComment_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState"] = 22901] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_Id"] = 22902] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_Name"] = 22903] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_Number"] = 22904] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_EffectiveDisplayName"] = 22905] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_TransitionTime"] = 22906] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_EffectiveTransitionTime"] = 22907] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_TrueState"] = 22908] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_FalseState"] = 22909] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState"] = 22910] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Id"] = 22911] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Name"] = 22912] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Number"] = 22913] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName"] = 22914] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_TransitionTime"] = 22915] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime"] = 22916] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_TrueState"] = 22917] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_FalseState"] = 22918] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Acknowledge_InputArguments"] = 22920] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Acknowledge_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Confirm_InputArguments"] = 22922] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Confirm_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState"] = 22923] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_Id"] = 22924] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_Name"] = 22925] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_Number"] = 22926] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_EffectiveDisplayName"] = 22927] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_TransitionTime"] = 22928] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_EffectiveTransitionTime"] = 22929] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_TrueState"] = 22930] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_FalseState"] = 22931] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_InputNode"] = 22932] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_InputNode";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState"] = 22933] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_Id"] = 22934] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_Name"] = 22935] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_Number"] = 22936] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_EffectiveDisplayName"] = 22937] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_TransitionTime"] = 22938] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime"] = 22939] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_TrueState"] = 22940] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_FalseState"] = 22941] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState"] = 22942] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Id"] = 22943] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Name"] = 22944] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Number"] = 22945] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName"] = 22946] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_TransitionTime"] = 22947] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime"] = 22948] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_TrueState"] = 22949] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_FalseState"] = 22950] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState"] = 22952] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Id"] = 22953] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Name"] = 22954] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Number"] = 22955] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName"] = 22956] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition"] = 22957] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Id"] = 22958] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Name"] = 22959] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Number"] = 22960] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime"] = 22961] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime"] = 22962] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_AvailableStates"] = 22963] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_AvailableStates";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_AvailableTransitions"] = 22964] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_AvailableTransitions";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_UnshelveTime"] = 22965] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_UnshelveTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments"] = 22967] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedOrShelved"] = 22970] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedOrShelved";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_MaxTimeShelved"] = 22971] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_MaxTimeShelved";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleEnabled"] = 22972] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleEnabled";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound"] = 22973] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound_ListId"] = 22974] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound_ListId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound_AgencyId"] = 22975] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound_AgencyId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound_VersionId"] = 22976] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound_VersionId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState"] = 22977] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_Id"] = 22978] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_Name"] = 22979] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_Number"] = 22980] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_EffectiveDisplayName"] = 22981] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_TransitionTime"] = 22982] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_EffectiveTransitionTime"] = 22983] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_TrueState"] = 22984] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_FalseState"] = 22985] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OnDelay"] = 22986] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OnDelay";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OffDelay"] = 22987] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OffDelay";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_FirstInGroupFlag"] = 22988] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_FirstInGroupFlag";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState"] = 22990] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_Id"] = 22991] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_Name"] = 22992] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_Number"] = 22993] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_EffectiveDisplayName"] = 22994] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_TransitionTime"] = 22995] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_EffectiveTransitionTime"] = 22996] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_TrueState"] = 22997] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_FalseState"] = 22998] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ReAlarmTime"] = 22999] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ReAlarmTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ReAlarmRepeatCount"] = 23e3] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ReAlarmRepeatCount";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_NormalState"] = 23007] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_NormalState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ExpirationDate"] = 23008] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ExpirationDate";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ExpirationLimit"] = 23009] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ExpirationLimit";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_CertificateType"] = 23010] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_CertificateType";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Certificate"] = 23011] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Certificate";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EventId"] = 23013] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EventId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EventType"] = 23014] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EventType";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SourceNode"] = 23015] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SourceNode";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SourceName"] = 23016] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SourceName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Time"] = 23017] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Time";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ReceiveTime"] = 23018] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ReceiveTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LocalTime"] = 23019] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LocalTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Message"] = 23020] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Message";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Severity"] = 23021] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Severity";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionClassId"] = 23022] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionClassId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionClassName"] = 23023] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionClassName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionSubClassId"] = 23024] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionSubClassId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionSubClassName"] = 23025] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionSubClassName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionName"] = 23026] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_BranchId"] = 23027] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_BranchId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Retain"] = 23028] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Retain";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState"] = 23029] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Id"] = 23030] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Name"] = 23031] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Number"] = 23032] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName"] = 23033] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_TransitionTime"] = 23034] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime"] = 23035] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_TrueState"] = 23036] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_FalseState"] = 23037] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Quality"] = 23038] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Quality";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Quality_SourceTimestamp"] = 23039] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Quality_SourceTimestamp";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LastSeverity"] = 23040] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LastSeverity";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp"] = 23041] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Comment"] = 23042] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Comment";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Comment_SourceTimestamp"] = 23043] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Comment_SourceTimestamp";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ClientUserId"] = 23044] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ClientUserId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AddComment_InputArguments"] = 23048] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AddComment_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState"] = 23049] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Id"] = 23050] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Name"] = 23051] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Number"] = 23052] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName"] = 23053] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_TransitionTime"] = 23054] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime"] = 23055] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_TrueState"] = 23056] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_FalseState"] = 23057] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState"] = 23058] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Id"] = 23059] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Name"] = 23060] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Number"] = 23061] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName"] = 23062] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_TransitionTime"] = 23063] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime"] = 23064] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_TrueState"] = 23065] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_FalseState"] = 23066] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Acknowledge_InputArguments"] = 23068] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Acknowledge_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Confirm_InputArguments"] = 23070] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Confirm_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState"] = 23071] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Id"] = 23072] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Name"] = 23073] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Number"] = 23074] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName"] = 23075] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_TransitionTime"] = 23076] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime"] = 23077] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_TrueState"] = 23078] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_FalseState"] = 23079] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_InputNode"] = 23080] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_InputNode";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState"] = 23081] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Id"] = 23082] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Name"] = 23083] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Number"] = 23084] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName"] = 23085] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_TransitionTime"] = 23086] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime"] = 23087] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_TrueState"] = 23088] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_FalseState"] = 23089] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState"] = 23090] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Id"] = 23091] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Name"] = 23092] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Number"] = 23093] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName"] = 23094] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime"] = 23095] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime"] = 23096] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_TrueState"] = 23097] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_FalseState"] = 23098] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState"] = 23100] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id"] = 23101] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name"] = 23102] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number"] = 23103] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName"] = 23104] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition"] = 23105] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id"] = 23106] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name"] = 23107] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number"] = 23108] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime"] = 23109] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime"] = 23110] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_AvailableStates"] = 23111] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_AvailableStates";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions"] = 23112] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_UnshelveTime"] = 23113] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_UnshelveTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments"] = 23115] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedOrShelved"] = 23118] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedOrShelved";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_MaxTimeShelved"] = 23119] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_MaxTimeShelved";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleEnabled"] = 23120] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleEnabled";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound"] = 23121] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_ListId"] = 23122] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_ListId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_AgencyId"] = 23123] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_AgencyId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_VersionId"] = 23124] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_VersionId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState"] = 23125] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Id"] = 23126] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Name"] = 23127] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Number"] = 23128] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName"] = 23129] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_TransitionTime"] = 23130] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime"] = 23131] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_TrueState"] = 23132] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_FalseState"] = 23133] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OnDelay"] = 23134] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OnDelay";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OffDelay"] = 23135] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OffDelay";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_FirstInGroupFlag"] = 23136] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_FirstInGroupFlag";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState"] = 23138] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Id"] = 23139] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Name"] = 23140] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Number"] = 23141] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName"] = 23142] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_TransitionTime"] = 23143] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime"] = 23144] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_TrueState"] = 23145] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_FalseState"] = 23146] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ReAlarmTime"] = 23147] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ReAlarmTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ReAlarmRepeatCount"] = 23148] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ReAlarmRepeatCount";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_NormalState"] = 23155] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_NormalState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_TrustListId"] = 23156] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_TrustListId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LastUpdateTime"] = 23157] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LastUpdateTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_UpdateFrequency"] = 23158] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_UpdateFrequency";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_UpdateFrequency"] = 23159] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_UpdateFrequency";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EventId"] = 23161] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EventId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EventType"] = 23162] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EventType";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SourceNode"] = 23163] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SourceNode";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SourceName"] = 23164] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SourceName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Time"] = 23165] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Time";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ReceiveTime"] = 23166] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ReceiveTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LocalTime"] = 23167] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LocalTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Message"] = 23168] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Message";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Severity"] = 23169] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Severity";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionClassId"] = 23170] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionClassId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionClassName"] = 23171] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionClassName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionSubClassId"] = 23172] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionSubClassId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionSubClassName"] = 23173] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionSubClassName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionName"] = 23174] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_BranchId"] = 23175] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_BranchId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Retain"] = 23176] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Retain";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState"] = 23177] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_Id"] = 23178] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_Name"] = 23179] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_Number"] = 23180] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_EffectiveDisplayName"] = 23181] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_TransitionTime"] = 23182] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_EffectiveTransitionTime"] = 23183] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_TrueState"] = 23184] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_FalseState"] = 23185] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Quality"] = 23186] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Quality";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Quality_SourceTimestamp"] = 23187] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Quality_SourceTimestamp";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LastSeverity"] = 23188] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LastSeverity";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LastSeverity_SourceTimestamp"] = 23189] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LastSeverity_SourceTimestamp";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Comment"] = 23190] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Comment";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Comment_SourceTimestamp"] = 23191] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Comment_SourceTimestamp";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ClientUserId"] = 23192] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ClientUserId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AddComment_InputArguments"] = 23196] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AddComment_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState"] = 23197] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_Id"] = 23198] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_Name"] = 23199] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_Number"] = 23200] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_EffectiveDisplayName"] = 23201] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_TransitionTime"] = 23202] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_EffectiveTransitionTime"] = 23203] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_TrueState"] = 23204] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_FalseState"] = 23205] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState"] = 23206] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Id"] = 23207] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Name"] = 23208] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Number"] = 23209] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName"] = 23210] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_TransitionTime"] = 23211] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime"] = 23212] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_TrueState"] = 23213] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_FalseState"] = 23214] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Acknowledge_InputArguments"] = 23216] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Acknowledge_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Confirm_InputArguments"] = 23218] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Confirm_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState"] = 23219] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_Id"] = 23220] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_Name"] = 23221] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_Number"] = 23222] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_EffectiveDisplayName"] = 23223] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_TransitionTime"] = 23224] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_EffectiveTransitionTime"] = 23225] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_TrueState"] = 23226] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_FalseState"] = 23227] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_InputNode"] = 23228] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_InputNode";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState"] = 23229] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Id"] = 23230] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Name"] = 23231] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Number"] = 23232] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_EffectiveDisplayName"] = 23233] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_TransitionTime"] = 23234] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime"] = 23235] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_TrueState"] = 23236] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_FalseState"] = 23237] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState"] = 23238] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Id"] = 23239] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Name"] = 23240] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Number"] = 23241] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName"] = 23242] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_TransitionTime"] = 23243] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime"] = 23244] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_TrueState"] = 23245] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_FalseState"] = 23246] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState"] = 23248] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Id"] = 23249] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Name"] = 23250] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Number"] = 23251] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName"] = 23252] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition"] = 23253] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Id"] = 23254] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Name"] = 23255] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Number"] = 23256] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime"] = 23257] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime"] = 23258] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_AvailableStates"] = 23259] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_AvailableStates";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_AvailableTransitions"] = 23260] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_AvailableTransitions";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_UnshelveTime"] = 23261] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_UnshelveTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments"] = 23263] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedOrShelved"] = 23266] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedOrShelved";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_MaxTimeShelved"] = 23267] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_MaxTimeShelved";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleEnabled"] = 23268] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleEnabled";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound"] = 23269] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound_ListId"] = 23270] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound_ListId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound_AgencyId"] = 23271] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound_AgencyId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound_VersionId"] = 23272] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound_VersionId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState"] = 23273] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_Id"] = 23274] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_Name"] = 23275] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_Number"] = 23276] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_EffectiveDisplayName"] = 23277] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_TransitionTime"] = 23278] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_EffectiveTransitionTime"] = 23279] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_TrueState"] = 23280] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_FalseState"] = 23281] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OnDelay"] = 23282] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OnDelay";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OffDelay"] = 23283] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OffDelay";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_FirstInGroupFlag"] = 23284] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_FirstInGroupFlag";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState"] = 23286] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_Id"] = 23287] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_Name"] = 23288] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_Number"] = 23289] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_EffectiveDisplayName"] = 23290] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_TransitionTime"] = 23291] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_EffectiveTransitionTime"] = 23292] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_TrueState"] = 23293] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_FalseState"] = 23294] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ReAlarmTime"] = 23295] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ReAlarmTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ReAlarmRepeatCount"] = 23296] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ReAlarmRepeatCount";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_NormalState"] = 23303] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_NormalState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ExpirationDate"] = 23304] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ExpirationDate";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ExpirationLimit"] = 23305] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ExpirationLimit";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_CertificateType"] = 23306] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_CertificateType";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Certificate"] = 23307] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Certificate";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EventId"] = 23309] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EventId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EventType"] = 23310] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EventType";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SourceNode"] = 23311] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SourceNode";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SourceName"] = 23312] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SourceName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Time"] = 23313] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Time";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ReceiveTime"] = 23314] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ReceiveTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LocalTime"] = 23315] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LocalTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Message"] = 23316] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Message";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Severity"] = 23317] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Severity";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionClassId"] = 23318] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionClassId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionClassName"] = 23319] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionClassName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionSubClassId"] = 23320] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionSubClassId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionSubClassName"] = 23321] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionSubClassName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionName"] = 23322] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_BranchId"] = 23323] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_BranchId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Retain"] = 23324] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Retain";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState"] = 23325] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Id"] = 23326] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Name"] = 23327] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Number"] = 23328] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName"] = 23329] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_TransitionTime"] = 23330] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime"] = 23331] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_TrueState"] = 23332] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_FalseState"] = 23333] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Quality"] = 23334] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Quality";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Quality_SourceTimestamp"] = 23335] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Quality_SourceTimestamp";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LastSeverity"] = 23336] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LastSeverity";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp"] = 23337] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Comment"] = 23338] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Comment";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Comment_SourceTimestamp"] = 23339] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Comment_SourceTimestamp";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ClientUserId"] = 23340] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ClientUserId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AddComment_InputArguments"] = 23344] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AddComment_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState"] = 23345] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Id"] = 23346] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Name"] = 23347] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Number"] = 23348] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName"] = 23349] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_TransitionTime"] = 23350] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime"] = 23351] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_TrueState"] = 23352] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_FalseState"] = 23353] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState"] = 23354] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Id"] = 23355] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Name"] = 23356] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Number"] = 23357] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName"] = 23358] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_TransitionTime"] = 23359] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime"] = 23360] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_TrueState"] = 23361] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_FalseState"] = 23362] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Acknowledge_InputArguments"] = 23364] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Acknowledge_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Confirm_InputArguments"] = 23366] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Confirm_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState"] = 23367] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Id"] = 23368] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Name"] = 23369] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Number"] = 23370] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName"] = 23371] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_TransitionTime"] = 23372] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime"] = 23373] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_TrueState"] = 23374] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_FalseState"] = 23375] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_InputNode"] = 23376] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_InputNode";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState"] = 23377] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Id"] = 23378] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Name"] = 23379] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Number"] = 23380] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName"] = 23381] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_TransitionTime"] = 23382] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime"] = 23383] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_TrueState"] = 23384] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_FalseState"] = 23385] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState"] = 23386] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Id"] = 23387] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Name"] = 23388] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Number"] = 23389] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName"] = 23390] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime"] = 23391] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime"] = 23392] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_TrueState"] = 23393] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_FalseState"] = 23394] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState"] = 23396] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id"] = 23397] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name"] = 23398] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number"] = 23399] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName"] = 23400] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition"] = 23401] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id"] = 23402] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name"] = 23403] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number"] = 23404] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime"] = 23405] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime"] = 23406] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_AvailableStates"] = 23407] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_AvailableStates";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions"] = 23408] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_UnshelveTime"] = 23409] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_UnshelveTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments"] = 23411] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedOrShelved"] = 23414] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedOrShelved";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_MaxTimeShelved"] = 23415] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_MaxTimeShelved";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleEnabled"] = 23416] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleEnabled";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound"] = 23417] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_ListId"] = 23418] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_ListId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_AgencyId"] = 23419] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_AgencyId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_VersionId"] = 23420] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_VersionId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState"] = 23421] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Id"] = 23422] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Name"] = 23423] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Number"] = 23424] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName"] = 23425] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_TransitionTime"] = 23426] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime"] = 23427] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_TrueState"] = 23428] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_FalseState"] = 23429] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OnDelay"] = 23430] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OnDelay";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OffDelay"] = 23431] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OffDelay";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_FirstInGroupFlag"] = 23432] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_FirstInGroupFlag";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState"] = 23434] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Id"] = 23435] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Id";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Name"] = 23436] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Name";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Number"] = 23437] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Number";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName"] = 23438] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_TransitionTime"] = 23439] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_TransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime"] = 23440] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_TrueState"] = 23441] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_TrueState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_FalseState"] = 23442] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_FalseState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ReAlarmTime"] = 23443] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ReAlarmTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ReAlarmRepeatCount"] = 23444] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ReAlarmRepeatCount";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_NormalState"] = 23451] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_NormalState";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_TrustListId"] = 23452] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_TrustListId";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LastUpdateTime"] = 23453] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LastUpdateTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_UpdateFrequency"] = 23454] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_UpdateFrequency";
      VariableIds2[VariableIds2["Aliases_FindAlias_InputArguments"] = 23477] = "Aliases_FindAlias_InputArguments";
      VariableIds2[VariableIds2["Aliases_FindAlias_OutputArguments"] = 23478] = "Aliases_FindAlias_OutputArguments";
      VariableIds2[VariableIds2["TagVariables_FindAlias_InputArguments"] = 23486] = "TagVariables_FindAlias_InputArguments";
      VariableIds2[VariableIds2["TagVariables_FindAlias_OutputArguments"] = 23487] = "TagVariables_FindAlias_OutputArguments";
      VariableIds2[VariableIds2["Topics_FindAlias_InputArguments"] = 23495] = "Topics_FindAlias_InputArguments";
      VariableIds2[VariableIds2["Topics_FindAlias_OutputArguments"] = 23496] = "Topics_FindAlias_OutputArguments";
      VariableIds2[VariableIds2["CurrencyUnit"] = 23501] = "CurrencyUnit";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AliasNameDataType"] = 23502] = "OpcUa_BinarySchema_AliasNameDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AliasNameDataType_DataTypeVersion"] = 23503] = "OpcUa_BinarySchema_AliasNameDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AliasNameDataType_DictionaryFragment"] = 23504] = "OpcUa_BinarySchema_AliasNameDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AliasNameDataType"] = 23508] = "OpcUa_XmlSchema_AliasNameDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AliasNameDataType_DataTypeVersion"] = 23509] = "OpcUa_XmlSchema_AliasNameDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AliasNameDataType_DictionaryFragment"] = 23510] = "OpcUa_XmlSchema_AliasNameDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_CurrencyUnitType"] = 23514] = "OpcUa_BinarySchema_CurrencyUnitType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_CurrencyUnitType_DataTypeVersion"] = 23515] = "OpcUa_BinarySchema_CurrencyUnitType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_CurrencyUnitType"] = 23522] = "OpcUa_XmlSchema_CurrencyUnitType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_CurrencyUnitType_DataTypeVersion"] = 23523] = "OpcUa_XmlSchema_CurrencyUnitType_DataTypeVersion";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_GetRejectedList_OutputArguments"] = 23551] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_GetRejectedList_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_GetRejectedList_OutputArguments"] = 23553] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_GetRejectedList_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_GetRejectedList_OutputArguments"] = 23555] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_GetRejectedList_OutputArguments";
      VariableIds2[VariableIds2["TrustListValidationOptions_OptionSetValues"] = 23565] = "TrustListValidationOptions_OptionSetValues";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_DefaultValidationOptions"] = 23574] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_DefaultValidationOptions";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_DefaultValidationOptions"] = 23575] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_DefaultValidationOptions";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_DefaultValidationOptions"] = 23576] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_DefaultValidationOptions";
      VariableIds2[VariableIds2["ServerConfiguration_HasSecureElement"] = 23597] = "ServerConfiguration_HasSecureElement";
      VariableIds2[VariableIds2["PublishSubscribe_SubscribedDataSets_AddDataSetFolder_InputArguments"] = 23674] = "PublishSubscribe_SubscribedDataSets_AddDataSetFolder_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_SubscribedDataSets_AddDataSetFolder_OutputArguments"] = 23675] = "PublishSubscribe_SubscribedDataSets_AddDataSetFolder_OutputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_SubscribedDataSets_RemoveDataSetFolder_InputArguments"] = 23677] = "PublishSubscribe_SubscribedDataSets_RemoveDataSetFolder_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubCapablities_MaxPubSubConnections"] = 23679] = "PublishSubscribe_PubSubCapablities_MaxPubSubConnections";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubCapablities_MaxWriterGroups"] = 23680] = "PublishSubscribe_PubSubCapablities_MaxWriterGroups";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubCapablities_MaxReaderGroups"] = 23681] = "PublishSubscribe_PubSubCapablities_MaxReaderGroups";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubCapablities_MaxDataSetWriters"] = 23682] = "PublishSubscribe_PubSubCapablities_MaxDataSetWriters";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubCapablities_MaxDataSetReaders"] = 23683] = "PublishSubscribe_PubSubCapablities_MaxDataSetReaders";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubCapablities_MaxFieldsPerDataSet"] = 23684] = "PublishSubscribe_PubSubCapablities_MaxFieldsPerDataSet";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_StandaloneSubscribedDataSetRefDataType"] = 23870] = "OpcUa_BinarySchema_StandaloneSubscribedDataSetRefDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_StandaloneSubscribedDataSetRefDataType_DataTypeVersion"] = 23871] = "OpcUa_BinarySchema_StandaloneSubscribedDataSetRefDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_StandaloneSubscribedDataSetRefDataType_DictionaryFragment"] = 23872] = "OpcUa_BinarySchema_StandaloneSubscribedDataSetRefDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_StandaloneSubscribedDataSetDataType"] = 23873] = "OpcUa_BinarySchema_StandaloneSubscribedDataSetDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_StandaloneSubscribedDataSetDataType_DataTypeVersion"] = 23874] = "OpcUa_BinarySchema_StandaloneSubscribedDataSetDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_StandaloneSubscribedDataSetDataType_DictionaryFragment"] = 23875] = "OpcUa_BinarySchema_StandaloneSubscribedDataSetDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SecurityGroupDataType"] = 23876] = "OpcUa_BinarySchema_SecurityGroupDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SecurityGroupDataType_DataTypeVersion"] = 23877] = "OpcUa_BinarySchema_SecurityGroupDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_SecurityGroupDataType_DictionaryFragment"] = 23878] = "OpcUa_BinarySchema_SecurityGroupDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PubSubConfiguration2DataType"] = 23879] = "OpcUa_BinarySchema_PubSubConfiguration2DataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PubSubConfiguration2DataType_DataTypeVersion"] = 23880] = "OpcUa_BinarySchema_PubSubConfiguration2DataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PubSubConfiguration2DataType_DictionaryFragment"] = 23881] = "OpcUa_BinarySchema_PubSubConfiguration2DataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_QosDataType"] = 23882] = "OpcUa_BinarySchema_QosDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_QosDataType_DataTypeVersion"] = 23883] = "OpcUa_BinarySchema_QosDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_QosDataType_DictionaryFragment"] = 23884] = "OpcUa_BinarySchema_QosDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_TransmitQosDataType"] = 23885] = "OpcUa_BinarySchema_TransmitQosDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_TransmitQosDataType_DataTypeVersion"] = 23886] = "OpcUa_BinarySchema_TransmitQosDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_TransmitQosDataType_DictionaryFragment"] = 23887] = "OpcUa_BinarySchema_TransmitQosDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_TransmitQosPriorityDataType"] = 23888] = "OpcUa_BinarySchema_TransmitQosPriorityDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_TransmitQosPriorityDataType_DataTypeVersion"] = 23889] = "OpcUa_BinarySchema_TransmitQosPriorityDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_TransmitQosPriorityDataType_DictionaryFragment"] = 23890] = "OpcUa_BinarySchema_TransmitQosPriorityDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ReceiveQosDataType"] = 23897] = "OpcUa_BinarySchema_ReceiveQosDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ReceiveQosDataType_DataTypeVersion"] = 23898] = "OpcUa_BinarySchema_ReceiveQosDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ReceiveQosDataType_DictionaryFragment"] = 23899] = "OpcUa_BinarySchema_ReceiveQosDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ReceiveQosPriorityDataType"] = 23900] = "OpcUa_BinarySchema_ReceiveQosPriorityDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ReceiveQosPriorityDataType_DataTypeVersion"] = 23901] = "OpcUa_BinarySchema_ReceiveQosPriorityDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ReceiveQosPriorityDataType_DictionaryFragment"] = 23902] = "OpcUa_BinarySchema_ReceiveQosPriorityDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DatagramConnectionTransport2DataType"] = 23909] = "OpcUa_BinarySchema_DatagramConnectionTransport2DataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DatagramConnectionTransport2DataType_DataTypeVersion"] = 23910] = "OpcUa_BinarySchema_DatagramConnectionTransport2DataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DatagramConnectionTransport2DataType_DictionaryFragment"] = 23911] = "OpcUa_BinarySchema_DatagramConnectionTransport2DataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DatagramWriterGroupTransport2DataType"] = 23912] = "OpcUa_BinarySchema_DatagramWriterGroupTransport2DataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DatagramWriterGroupTransport2DataType_DataTypeVersion"] = 23913] = "OpcUa_BinarySchema_DatagramWriterGroupTransport2DataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DatagramWriterGroupTransport2DataType_DictionaryFragment"] = 23914] = "OpcUa_BinarySchema_DatagramWriterGroupTransport2DataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DatagramDataSetReaderTransportDataType"] = 23915] = "OpcUa_BinarySchema_DatagramDataSetReaderTransportDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DatagramDataSetReaderTransportDataType_DataTypeVersion"] = 23916] = "OpcUa_BinarySchema_DatagramDataSetReaderTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_DatagramDataSetReaderTransportDataType_DictionaryFragment"] = 23917] = "OpcUa_BinarySchema_DatagramDataSetReaderTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_StandaloneSubscribedDataSetRefDataType"] = 23938] = "OpcUa_XmlSchema_StandaloneSubscribedDataSetRefDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_StandaloneSubscribedDataSetRefDataType_DataTypeVersion"] = 23939] = "OpcUa_XmlSchema_StandaloneSubscribedDataSetRefDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_StandaloneSubscribedDataSetRefDataType_DictionaryFragment"] = 23940] = "OpcUa_XmlSchema_StandaloneSubscribedDataSetRefDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_StandaloneSubscribedDataSetDataType"] = 23941] = "OpcUa_XmlSchema_StandaloneSubscribedDataSetDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_StandaloneSubscribedDataSetDataType_DataTypeVersion"] = 23942] = "OpcUa_XmlSchema_StandaloneSubscribedDataSetDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_StandaloneSubscribedDataSetDataType_DictionaryFragment"] = 23943] = "OpcUa_XmlSchema_StandaloneSubscribedDataSetDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SecurityGroupDataType"] = 23944] = "OpcUa_XmlSchema_SecurityGroupDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SecurityGroupDataType_DataTypeVersion"] = 23945] = "OpcUa_XmlSchema_SecurityGroupDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_SecurityGroupDataType_DictionaryFragment"] = 23946] = "OpcUa_XmlSchema_SecurityGroupDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PubSubConfiguration2DataType"] = 23947] = "OpcUa_XmlSchema_PubSubConfiguration2DataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PubSubConfiguration2DataType_DataTypeVersion"] = 23948] = "OpcUa_XmlSchema_PubSubConfiguration2DataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PubSubConfiguration2DataType_DictionaryFragment"] = 23949] = "OpcUa_XmlSchema_PubSubConfiguration2DataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_QosDataType"] = 23950] = "OpcUa_XmlSchema_QosDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_QosDataType_DataTypeVersion"] = 23951] = "OpcUa_XmlSchema_QosDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_QosDataType_DictionaryFragment"] = 23952] = "OpcUa_XmlSchema_QosDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_TransmitQosDataType"] = 23953] = "OpcUa_XmlSchema_TransmitQosDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_TransmitQosDataType_DataTypeVersion"] = 23954] = "OpcUa_XmlSchema_TransmitQosDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_TransmitQosDataType_DictionaryFragment"] = 23955] = "OpcUa_XmlSchema_TransmitQosDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_TransmitQosPriorityDataType"] = 23956] = "OpcUa_XmlSchema_TransmitQosPriorityDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_TransmitQosPriorityDataType_DataTypeVersion"] = 23957] = "OpcUa_XmlSchema_TransmitQosPriorityDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_TransmitQosPriorityDataType_DictionaryFragment"] = 23958] = "OpcUa_XmlSchema_TransmitQosPriorityDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ReceiveQosDataType"] = 23965] = "OpcUa_XmlSchema_ReceiveQosDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ReceiveQosDataType_DataTypeVersion"] = 23966] = "OpcUa_XmlSchema_ReceiveQosDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ReceiveQosDataType_DictionaryFragment"] = 23967] = "OpcUa_XmlSchema_ReceiveQosDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ReceiveQosPriorityDataType"] = 23968] = "OpcUa_XmlSchema_ReceiveQosPriorityDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ReceiveQosPriorityDataType_DataTypeVersion"] = 23969] = "OpcUa_XmlSchema_ReceiveQosPriorityDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ReceiveQosPriorityDataType_DictionaryFragment"] = 23970] = "OpcUa_XmlSchema_ReceiveQosPriorityDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DatagramConnectionTransport2DataType"] = 23977] = "OpcUa_XmlSchema_DatagramConnectionTransport2DataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DatagramConnectionTransport2DataType_DataTypeVersion"] = 23978] = "OpcUa_XmlSchema_DatagramConnectionTransport2DataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DatagramConnectionTransport2DataType_DictionaryFragment"] = 23979] = "OpcUa_XmlSchema_DatagramConnectionTransport2DataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DatagramWriterGroupTransport2DataType"] = 23980] = "OpcUa_XmlSchema_DatagramWriterGroupTransport2DataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DatagramWriterGroupTransport2DataType_DataTypeVersion"] = 23981] = "OpcUa_XmlSchema_DatagramWriterGroupTransport2DataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DatagramWriterGroupTransport2DataType_DictionaryFragment"] = 23982] = "OpcUa_XmlSchema_DatagramWriterGroupTransport2DataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DatagramDataSetReaderTransportDataType"] = 23983] = "OpcUa_XmlSchema_DatagramDataSetReaderTransportDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DatagramDataSetReaderTransportDataType_DataTypeVersion"] = 23984] = "OpcUa_XmlSchema_DatagramDataSetReaderTransportDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_DatagramDataSetReaderTransportDataType_DictionaryFragment"] = 23985] = "OpcUa_XmlSchema_DatagramDataSetReaderTransportDataType_DictionaryFragment";
      VariableIds2[VariableIds2["PublishSubscribe_SubscribedDataSets_AddSubscribedDataSet_InputArguments"] = 24011] = "PublishSubscribe_SubscribedDataSets_AddSubscribedDataSet_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_SubscribedDataSets_AddSubscribedDataSet_OutputArguments"] = 24012] = "PublishSubscribe_SubscribedDataSets_AddSubscribedDataSet_OutputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_SubscribedDataSets_RemoveSubscribedDataSet_InputArguments"] = 24014] = "PublishSubscribe_SubscribedDataSets_RemoveSubscribedDataSet_InputArguments";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ProgramDiagnostic2DataType"] = 24035] = "OpcUa_BinarySchema_ProgramDiagnostic2DataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ProgramDiagnostic2DataType_DataTypeVersion"] = 24036] = "OpcUa_BinarySchema_ProgramDiagnostic2DataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ProgramDiagnostic2DataType_DictionaryFragment"] = 24037] = "OpcUa_BinarySchema_ProgramDiagnostic2DataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ProgramDiagnostic2DataType"] = 24039] = "OpcUa_XmlSchema_ProgramDiagnostic2DataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ProgramDiagnostic2DataType_DataTypeVersion"] = 24040] = "OpcUa_XmlSchema_ProgramDiagnostic2DataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ProgramDiagnostic2DataType_DictionaryFragment"] = 24041] = "OpcUa_XmlSchema_ProgramDiagnostic2DataType_DictionaryFragment";
      VariableIds2[VariableIds2["Server_ServerCapabilities_MaxSessions"] = 24095] = "Server_ServerCapabilities_MaxSessions";
      VariableIds2[VariableIds2["Server_ServerCapabilities_MaxSubscriptions"] = 24096] = "Server_ServerCapabilities_MaxSubscriptions";
      VariableIds2[VariableIds2["Server_ServerCapabilities_MaxMonitoredItems"] = 24097] = "Server_ServerCapabilities_MaxMonitoredItems";
      VariableIds2[VariableIds2["Server_ServerCapabilities_MaxSubscriptionsPerSession"] = 24098] = "Server_ServerCapabilities_MaxSubscriptionsPerSession";
      VariableIds2[VariableIds2["Server_ServerCapabilities_MaxSelectClauseParameters"] = 24099] = "Server_ServerCapabilities_MaxSelectClauseParameters";
      VariableIds2[VariableIds2["Server_ServerCapabilities_MaxWhereClauseParameters"] = 24100] = "Server_ServerCapabilities_MaxWhereClauseParameters";
      VariableIds2[VariableIds2["Server_ServerCapabilities_ConformanceUnits"] = 24101] = "Server_ServerCapabilities_ConformanceUnits";
      VariableIds2[VariableIds2["Server_ServerCapabilities_MaxMonitoredItemsPerSubscription"] = 24104] = "Server_ServerCapabilities_MaxMonitoredItemsPerSubscription";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PortableQualifiedName"] = 24111] = "OpcUa_BinarySchema_PortableQualifiedName";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PortableQualifiedName_DataTypeVersion"] = 24112] = "OpcUa_BinarySchema_PortableQualifiedName_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PortableQualifiedName_DictionaryFragment"] = 24113] = "OpcUa_BinarySchema_PortableQualifiedName_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PortableNodeId"] = 24114] = "OpcUa_BinarySchema_PortableNodeId";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PortableNodeId_DataTypeVersion"] = 24115] = "OpcUa_BinarySchema_PortableNodeId_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PortableNodeId_DictionaryFragment"] = 24116] = "OpcUa_BinarySchema_PortableNodeId_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UnsignedRationalNumber"] = 24117] = "OpcUa_BinarySchema_UnsignedRationalNumber";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UnsignedRationalNumber_DataTypeVersion"] = 24118] = "OpcUa_BinarySchema_UnsignedRationalNumber_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UnsignedRationalNumber_DictionaryFragment"] = 24119] = "OpcUa_BinarySchema_UnsignedRationalNumber_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PortableQualifiedName"] = 24123] = "OpcUa_XmlSchema_PortableQualifiedName";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PortableQualifiedName_DataTypeVersion"] = 24124] = "OpcUa_XmlSchema_PortableQualifiedName_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PortableQualifiedName_DictionaryFragment"] = 24125] = "OpcUa_XmlSchema_PortableQualifiedName_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PortableNodeId"] = 24126] = "OpcUa_XmlSchema_PortableNodeId";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PortableNodeId_DataTypeVersion"] = 24127] = "OpcUa_XmlSchema_PortableNodeId_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PortableNodeId_DictionaryFragment"] = 24128] = "OpcUa_XmlSchema_PortableNodeId_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UnsignedRationalNumber"] = 24129] = "OpcUa_XmlSchema_UnsignedRationalNumber";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UnsignedRationalNumber_DataTypeVersion"] = 24130] = "OpcUa_XmlSchema_UnsignedRationalNumber_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UnsignedRationalNumber_DictionaryFragment"] = 24131] = "OpcUa_XmlSchema_UnsignedRationalNumber_DictionaryFragment";
      VariableIds2[VariableIds2["WellKnownRole_Anonymous_CustomConfiguration"] = 24140] = "WellKnownRole_Anonymous_CustomConfiguration";
      VariableIds2[VariableIds2["WellKnownRole_AuthenticatedUser_CustomConfiguration"] = 24141] = "WellKnownRole_AuthenticatedUser_CustomConfiguration";
      VariableIds2[VariableIds2["WellKnownRole_Observer_CustomConfiguration"] = 24142] = "WellKnownRole_Observer_CustomConfiguration";
      VariableIds2[VariableIds2["WellKnownRole_Operator_CustomConfiguration"] = 24143] = "WellKnownRole_Operator_CustomConfiguration";
      VariableIds2[VariableIds2["WellKnownRole_Engineer_CustomConfiguration"] = 24144] = "WellKnownRole_Engineer_CustomConfiguration";
      VariableIds2[VariableIds2["WellKnownRole_Supervisor_CustomConfiguration"] = 24145] = "WellKnownRole_Supervisor_CustomConfiguration";
      VariableIds2[VariableIds2["WellKnownRole_ConfigureAdmin_CustomConfiguration"] = 24146] = "WellKnownRole_ConfigureAdmin_CustomConfiguration";
      VariableIds2[VariableIds2["WellKnownRole_SecurityAdmin_CustomConfiguration"] = 24147] = "WellKnownRole_SecurityAdmin_CustomConfiguration";
      VariableIds2[VariableIds2["Duplex_EnumValues"] = 24235] = "Duplex_EnumValues";
      VariableIds2[VariableIds2["InterfaceAdminStatus_EnumValues"] = 24236] = "InterfaceAdminStatus_EnumValues";
      VariableIds2[VariableIds2["InterfaceOperStatus_EnumValues"] = 24237] = "InterfaceOperStatus_EnumValues";
      VariableIds2[VariableIds2["NegotiationStatus_EnumValues"] = 24238] = "NegotiationStatus_EnumValues";
      VariableIds2[VariableIds2["TsnFailureCode_EnumValues"] = 24239] = "TsnFailureCode_EnumValues";
      VariableIds2[VariableIds2["TsnStreamState_EnumValues"] = 24240] = "TsnStreamState_EnumValues";
      VariableIds2[VariableIds2["TsnTalkerStatus_EnumValues"] = 24241] = "TsnTalkerStatus_EnumValues";
      VariableIds2[VariableIds2["TsnListenerStatus_EnumValues"] = 24242] = "TsnListenerStatus_EnumValues";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_NamespaceFile_MaxByteStringLength"] = 24243] = "OPCUANamespaceMetadata_NamespaceFile_MaxByteStringLength";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_MaxByteStringLength"] = 24259] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_MaxByteStringLength";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_MaxByteStringLength"] = 24260] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_MaxByteStringLength";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_MaxByteStringLength"] = 24261] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_MaxByteStringLength";
      VariableIds2[VariableIds2["PasswordOptionsMask_OptionSetValues"] = 24278] = "PasswordOptionsMask_OptionSetValues";
      VariableIds2[VariableIds2["UserConfigurationMask_OptionSetValues"] = 24280] = "UserConfigurationMask_OptionSetValues";
      VariableIds2[VariableIds2["UserManagement_PasswordRestrictions"] = 24291] = "UserManagement_PasswordRestrictions";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UserManagementDataType"] = 24293] = "OpcUa_BinarySchema_UserManagementDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UserManagementDataType_DataTypeVersion"] = 24294] = "OpcUa_BinarySchema_UserManagementDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_UserManagementDataType_DictionaryFragment"] = 24295] = "OpcUa_BinarySchema_UserManagementDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UserManagementDataType"] = 24297] = "OpcUa_XmlSchema_UserManagementDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UserManagementDataType_DataTypeVersion"] = 24298] = "OpcUa_XmlSchema_UserManagementDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_UserManagementDataType_DictionaryFragment"] = 24299] = "OpcUa_XmlSchema_UserManagementDataType_DictionaryFragment";
      VariableIds2[VariableIds2["UserManagement_Users"] = 24301] = "UserManagement_Users";
      VariableIds2[VariableIds2["UserManagement_PasswordLength"] = 24302] = "UserManagement_PasswordLength";
      VariableIds2[VariableIds2["UserManagement_PasswordOptions"] = 24303] = "UserManagement_PasswordOptions";
      VariableIds2[VariableIds2["UserManagement_AddUser_InputArguments"] = 24305] = "UserManagement_AddUser_InputArguments";
      VariableIds2[VariableIds2["UserManagement_ModifyUser_InputArguments"] = 24307] = "UserManagement_ModifyUser_InputArguments";
      VariableIds2[VariableIds2["UserManagement_RemoveUser_InputArguments"] = 24309] = "UserManagement_RemoveUser_InputArguments";
      VariableIds2[VariableIds2["UserManagement_ChangePassword_InputArguments"] = 24311] = "UserManagement_ChangePassword_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Suppress2_InputArguments"] = 24679] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Suppress2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Unsuppress2_InputArguments"] = 24681] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Unsuppress2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_RemoveFromService2_InputArguments"] = 24683] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_RemoveFromService2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_PlaceInService2_InputArguments"] = 24685] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_PlaceInService2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Reset2_InputArguments"] = 24687] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Reset2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Suppress2_InputArguments"] = 24689] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Suppress2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Unsuppress2_InputArguments"] = 24691] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Unsuppress2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_RemoveFromService2_InputArguments"] = 24693] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_RemoveFromService2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_PlaceInService2_InputArguments"] = 24695] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_PlaceInService2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Reset2_InputArguments"] = 24697] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Reset2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Suppress2_InputArguments"] = 24699] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Suppress2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Unsuppress2_InputArguments"] = 24701] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Unsuppress2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_RemoveFromService2_InputArguments"] = 24703] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_RemoveFromService2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_PlaceInService2_InputArguments"] = 24705] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_PlaceInService2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Reset2_InputArguments"] = 24707] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Reset2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Suppress2_InputArguments"] = 24709] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Suppress2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Unsuppress2_InputArguments"] = 24711] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Unsuppress2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_RemoveFromService2_InputArguments"] = 24713] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_RemoveFromService2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_PlaceInService2_InputArguments"] = 24715] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_PlaceInService2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Reset2_InputArguments"] = 24717] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Reset2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Suppress2_InputArguments"] = 24719] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Suppress2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Unsuppress2_InputArguments"] = 24721] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Unsuppress2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_RemoveFromService2_InputArguments"] = 24723] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_RemoveFromService2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_PlaceInService2_InputArguments"] = 24725] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_PlaceInService2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Reset2_InputArguments"] = 24727] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Reset2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Suppress2_InputArguments"] = 24729] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Suppress2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Unsuppress2_InputArguments"] = 24731] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Unsuppress2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_RemoveFromService2_InputArguments"] = 24733] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_RemoveFromService2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_PlaceInService2_InputArguments"] = 24735] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_PlaceInService2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Reset2_InputArguments"] = 24737] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Reset2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve2_InputArguments"] = 25107] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_Unshelve2_InputArguments"] = 25109] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_Unshelve2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_OneShotShelve2_InputArguments"] = 25111] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_OneShotShelve2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve2_InputArguments"] = 25115] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_Unshelve2_InputArguments"] = 25117] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_Unshelve2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2_InputArguments"] = 25119] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve2_InputArguments"] = 25123] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_Unshelve2_InputArguments"] = 25125] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_Unshelve2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_OneShotShelve2_InputArguments"] = 25127] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_OneShotShelve2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve2_InputArguments"] = 25131] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_Unshelve2_InputArguments"] = 25133] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_Unshelve2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2_InputArguments"] = 25135] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve2_InputArguments"] = 25139] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_Unshelve2_InputArguments"] = 25141] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_Unshelve2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_OneShotShelve2_InputArguments"] = 25143] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_OneShotShelve2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve2_InputArguments"] = 25147] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_Unshelve2_InputArguments"] = 25149] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_Unshelve2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2_InputArguments"] = 25151] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_GetGroupMemberships_OutputArguments"] = 25193] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_GetGroupMemberships_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_GetGroupMemberships_OutputArguments"] = 25194] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_GetGroupMemberships_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_GetGroupMemberships_OutputArguments"] = 25195] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_GetGroupMemberships_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_GetGroupMemberships_OutputArguments"] = 25196] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_GetGroupMemberships_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_GetGroupMemberships_OutputArguments"] = 25197] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_GetGroupMemberships_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_GetGroupMemberships_OutputArguments"] = 25198] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_GetGroupMemberships_OutputArguments";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_NamespaceFile_LastModifiedTime"] = 25199] = "OPCUANamespaceMetadata_NamespaceFile_LastModifiedTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_LastModifiedTime"] = 25215] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_LastModifiedTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_LastModifiedTime"] = 25216] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_LastModifiedTime";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_LastModifiedTime"] = 25217] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_LastModifiedTime";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PriorityMappingEntryType"] = 25240] = "OpcUa_BinarySchema_PriorityMappingEntryType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PriorityMappingEntryType_DataTypeVersion"] = 25241] = "OpcUa_BinarySchema_PriorityMappingEntryType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PriorityMappingEntryType"] = 25244] = "OpcUa_XmlSchema_PriorityMappingEntryType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PriorityMappingEntryType_DataTypeVersion"] = 25245] = "OpcUa_XmlSchema_PriorityMappingEntryType_DataTypeVersion";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_ConfigurationVersion"] = 25266] = "OPCUANamespaceMetadata_ConfigurationVersion";
      VariableIds2[VariableIds2["PublishSubscribe_SecurityGroups_AddSecurityGroupFolder_InputArguments"] = 25435] = "PublishSubscribe_SecurityGroups_AddSecurityGroupFolder_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_SecurityGroups_AddSecurityGroupFolder_OutputArguments"] = 25436] = "PublishSubscribe_SecurityGroups_AddSecurityGroupFolder_OutputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_SecurityGroups_RemoveSecurityGroupFolder_InputArguments"] = 25438] = "PublishSubscribe_SecurityGroups_RemoveSecurityGroupFolder_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_SecurityGroups_SupportedSecurityPolicyUris"] = 25439] = "PublishSubscribe_SecurityGroups_SupportedSecurityPolicyUris";
      VariableIds2[VariableIds2["PublishSubscribe_KeyPushTargets_AddPushTarget_InputArguments"] = 25442] = "PublishSubscribe_KeyPushTargets_AddPushTarget_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_KeyPushTargets_AddPushTarget_OutputArguments"] = 25443] = "PublishSubscribe_KeyPushTargets_AddPushTarget_OutputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_KeyPushTargets_RemovePushTarget_InputArguments"] = 25445] = "PublishSubscribe_KeyPushTargets_RemovePushTarget_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_KeyPushTargets_AddPushTargetFolder_InputArguments"] = 25447] = "PublishSubscribe_KeyPushTargets_AddPushTargetFolder_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_KeyPushTargets_AddPushTargetFolder_OutputArguments"] = 25448] = "PublishSubscribe_KeyPushTargets_AddPushTargetFolder_OutputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_KeyPushTargets_RemovePushTargetFolder_InputArguments"] = 25450] = "PublishSubscribe_KeyPushTargets_RemovePushTargetFolder_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubConfiguration_Size"] = 25452] = "PublishSubscribe_PubSubConfiguration_Size";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubConfiguration_Writable"] = 25453] = "PublishSubscribe_PubSubConfiguration_Writable";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubConfiguration_UserWritable"] = 25454] = "PublishSubscribe_PubSubConfiguration_UserWritable";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubConfiguration_OpenCount"] = 25455] = "PublishSubscribe_PubSubConfiguration_OpenCount";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubConfiguration_MimeType"] = 25456] = "PublishSubscribe_PubSubConfiguration_MimeType";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubConfiguration_MaxByteStringLength"] = 25457] = "PublishSubscribe_PubSubConfiguration_MaxByteStringLength";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubConfiguration_LastModifiedTime"] = 25458] = "PublishSubscribe_PubSubConfiguration_LastModifiedTime";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubConfiguration_Open_InputArguments"] = 25460] = "PublishSubscribe_PubSubConfiguration_Open_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubConfiguration_Open_OutputArguments"] = 25461] = "PublishSubscribe_PubSubConfiguration_Open_OutputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubConfiguration_Close_InputArguments"] = 25463] = "PublishSubscribe_PubSubConfiguration_Close_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubConfiguration_Read_InputArguments"] = 25465] = "PublishSubscribe_PubSubConfiguration_Read_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubConfiguration_Read_OutputArguments"] = 25466] = "PublishSubscribe_PubSubConfiguration_Read_OutputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubConfiguration_Write_InputArguments"] = 25468] = "PublishSubscribe_PubSubConfiguration_Write_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubConfiguration_GetPosition_InputArguments"] = 25470] = "PublishSubscribe_PubSubConfiguration_GetPosition_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubConfiguration_GetPosition_OutputArguments"] = 25471] = "PublishSubscribe_PubSubConfiguration_GetPosition_OutputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubConfiguration_SetPosition_InputArguments"] = 25473] = "PublishSubscribe_PubSubConfiguration_SetPosition_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubConfiguration_ReserveIds_InputArguments"] = 25475] = "PublishSubscribe_PubSubConfiguration_ReserveIds_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubConfiguration_ReserveIds_OutputArguments"] = 25476] = "PublishSubscribe_PubSubConfiguration_ReserveIds_OutputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubConfiguration_CloseAndUpdate_InputArguments"] = 25478] = "PublishSubscribe_PubSubConfiguration_CloseAndUpdate_InputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubConfiguration_CloseAndUpdate_OutputArguments"] = 25479] = "PublishSubscribe_PubSubConfiguration_CloseAndUpdate_OutputArguments";
      VariableIds2[VariableIds2["PublishSubscribe_DefaultDatagramPublisherId"] = 25480] = "PublishSubscribe_DefaultDatagramPublisherId";
      VariableIds2[VariableIds2["PublishSubscribe_ConfigurationVersion"] = 25481] = "PublishSubscribe_ConfigurationVersion";
      VariableIds2[VariableIds2["PubSubConfigurationRefMask_OptionSetValues"] = 25518] = "PubSubConfigurationRefMask_OptionSetValues";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PublishedDataSetCustomSourceDataType"] = 25533] = "OpcUa_BinarySchema_PublishedDataSetCustomSourceDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PublishedDataSetCustomSourceDataType_DataTypeVersion"] = 25534] = "OpcUa_BinarySchema_PublishedDataSetCustomSourceDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PublishedDataSetCustomSourceDataType_DictionaryFragment"] = 25535] = "OpcUa_BinarySchema_PublishedDataSetCustomSourceDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PubSubKeyPushTargetDataType"] = 25536] = "OpcUa_BinarySchema_PubSubKeyPushTargetDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PubSubKeyPushTargetDataType_DataTypeVersion"] = 25537] = "OpcUa_BinarySchema_PubSubKeyPushTargetDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PubSubKeyPushTargetDataType_DictionaryFragment"] = 25538] = "OpcUa_BinarySchema_PubSubKeyPushTargetDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PubSubConfigurationRefDataType"] = 25539] = "OpcUa_BinarySchema_PubSubConfigurationRefDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PubSubConfigurationRefDataType_DataTypeVersion"] = 25540] = "OpcUa_BinarySchema_PubSubConfigurationRefDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PubSubConfigurationRefDataType_DictionaryFragment"] = 25541] = "OpcUa_BinarySchema_PubSubConfigurationRefDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PubSubConfigurationValueDataType"] = 25542] = "OpcUa_BinarySchema_PubSubConfigurationValueDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PubSubConfigurationValueDataType_DataTypeVersion"] = 25543] = "OpcUa_BinarySchema_PubSubConfigurationValueDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_PubSubConfigurationValueDataType_DictionaryFragment"] = 25544] = "OpcUa_BinarySchema_PubSubConfigurationValueDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PublishedDataSetCustomSourceDataType"] = 25549] = "OpcUa_XmlSchema_PublishedDataSetCustomSourceDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PublishedDataSetCustomSourceDataType_DataTypeVersion"] = 25550] = "OpcUa_XmlSchema_PublishedDataSetCustomSourceDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PublishedDataSetCustomSourceDataType_DictionaryFragment"] = 25551] = "OpcUa_XmlSchema_PublishedDataSetCustomSourceDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PubSubKeyPushTargetDataType"] = 25552] = "OpcUa_XmlSchema_PubSubKeyPushTargetDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PubSubKeyPushTargetDataType_DataTypeVersion"] = 25553] = "OpcUa_XmlSchema_PubSubKeyPushTargetDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PubSubKeyPushTargetDataType_DictionaryFragment"] = 25554] = "OpcUa_XmlSchema_PubSubKeyPushTargetDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PubSubConfigurationRefDataType"] = 25555] = "OpcUa_XmlSchema_PubSubConfigurationRefDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PubSubConfigurationRefDataType_DataTypeVersion"] = 25556] = "OpcUa_XmlSchema_PubSubConfigurationRefDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PubSubConfigurationRefDataType_DictionaryFragment"] = 25557] = "OpcUa_XmlSchema_PubSubConfigurationRefDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PubSubConfigurationValueDataType"] = 25558] = "OpcUa_XmlSchema_PubSubConfigurationValueDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PubSubConfigurationValueDataType_DataTypeVersion"] = 25559] = "OpcUa_XmlSchema_PubSubConfigurationValueDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_PubSubConfigurationValueDataType_DictionaryFragment"] = 25560] = "OpcUa_XmlSchema_PubSubConfigurationValueDataType_DictionaryFragment";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAdmin_Identities"] = 25566] = "WellKnownRole_SecurityKeyServerAdmin_Identities";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAdmin_ApplicationsExclude"] = 25567] = "WellKnownRole_SecurityKeyServerAdmin_ApplicationsExclude";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAdmin_Applications"] = 25568] = "WellKnownRole_SecurityKeyServerAdmin_Applications";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAdmin_EndpointsExclude"] = 25569] = "WellKnownRole_SecurityKeyServerAdmin_EndpointsExclude";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAdmin_Endpoints"] = 25570] = "WellKnownRole_SecurityKeyServerAdmin_Endpoints";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAdmin_CustomConfiguration"] = 25571] = "WellKnownRole_SecurityKeyServerAdmin_CustomConfiguration";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAdmin_AddIdentity_InputArguments"] = 25573] = "WellKnownRole_SecurityKeyServerAdmin_AddIdentity_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAdmin_RemoveIdentity_InputArguments"] = 25575] = "WellKnownRole_SecurityKeyServerAdmin_RemoveIdentity_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAdmin_AddApplication_InputArguments"] = 25577] = "WellKnownRole_SecurityKeyServerAdmin_AddApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAdmin_RemoveApplication_InputArguments"] = 25579] = "WellKnownRole_SecurityKeyServerAdmin_RemoveApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAdmin_AddEndpoint_InputArguments"] = 25581] = "WellKnownRole_SecurityKeyServerAdmin_AddEndpoint_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAdmin_RemoveEndpoint_InputArguments"] = 25583] = "WellKnownRole_SecurityKeyServerAdmin_RemoveEndpoint_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerPush_Identities"] = 25585] = "WellKnownRole_SecurityKeyServerPush_Identities";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerPush_ApplicationsExclude"] = 25586] = "WellKnownRole_SecurityKeyServerPush_ApplicationsExclude";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerPush_Applications"] = 25587] = "WellKnownRole_SecurityKeyServerPush_Applications";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerPush_EndpointsExclude"] = 25588] = "WellKnownRole_SecurityKeyServerPush_EndpointsExclude";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerPush_Endpoints"] = 25589] = "WellKnownRole_SecurityKeyServerPush_Endpoints";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerPush_CustomConfiguration"] = 25590] = "WellKnownRole_SecurityKeyServerPush_CustomConfiguration";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerPush_AddIdentity_InputArguments"] = 25592] = "WellKnownRole_SecurityKeyServerPush_AddIdentity_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerPush_RemoveIdentity_InputArguments"] = 25594] = "WellKnownRole_SecurityKeyServerPush_RemoveIdentity_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerPush_AddApplication_InputArguments"] = 25596] = "WellKnownRole_SecurityKeyServerPush_AddApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerPush_RemoveApplication_InputArguments"] = 25598] = "WellKnownRole_SecurityKeyServerPush_RemoveApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerPush_AddEndpoint_InputArguments"] = 25600] = "WellKnownRole_SecurityKeyServerPush_AddEndpoint_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerPush_RemoveEndpoint_InputArguments"] = 25602] = "WellKnownRole_SecurityKeyServerPush_RemoveEndpoint_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAccess_Identities"] = 25604] = "WellKnownRole_SecurityKeyServerAccess_Identities";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAccess_ApplicationsExclude"] = 25605] = "WellKnownRole_SecurityKeyServerAccess_ApplicationsExclude";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAccess_Applications"] = 25606] = "WellKnownRole_SecurityKeyServerAccess_Applications";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAccess_EndpointsExclude"] = 25607] = "WellKnownRole_SecurityKeyServerAccess_EndpointsExclude";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAccess_Endpoints"] = 25608] = "WellKnownRole_SecurityKeyServerAccess_Endpoints";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAccess_CustomConfiguration"] = 25609] = "WellKnownRole_SecurityKeyServerAccess_CustomConfiguration";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAccess_AddIdentity_InputArguments"] = 25611] = "WellKnownRole_SecurityKeyServerAccess_AddIdentity_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAccess_RemoveIdentity_InputArguments"] = 25613] = "WellKnownRole_SecurityKeyServerAccess_RemoveIdentity_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAccess_AddApplication_InputArguments"] = 25615] = "WellKnownRole_SecurityKeyServerAccess_AddApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAccess_RemoveApplication_InputArguments"] = 25617] = "WellKnownRole_SecurityKeyServerAccess_RemoveApplication_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAccess_AddEndpoint_InputArguments"] = 25619] = "WellKnownRole_SecurityKeyServerAccess_AddEndpoint_InputArguments";
      VariableIds2[VariableIds2["WellKnownRole_SecurityKeyServerAccess_RemoveEndpoint_InputArguments"] = 25621] = "WellKnownRole_SecurityKeyServerAccess_RemoveEndpoint_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_ApplicationUri"] = 25706] = "ServerConfiguration_ApplicationUri";
      VariableIds2[VariableIds2["ServerConfiguration_ApplicationType"] = 25707] = "ServerConfiguration_ApplicationType";
      VariableIds2[VariableIds2["ServerConfiguration_ProductUri"] = 25725] = "ServerConfiguration_ProductUri";
      VariableIds2[VariableIds2["ProvisionableDevice_IsSingleton"] = 29879] = "ProvisionableDevice_IsSingleton";
      VariableIds2[VariableIds2["ProvisionableDevice_RequestTickets_OutputArguments"] = 29881] = "ProvisionableDevice_RequestTickets_OutputArguments";
      VariableIds2[VariableIds2["ProvisionableDevice_SetRegistrarEndpoints_InputArguments"] = 29883] = "ProvisionableDevice_SetRegistrarEndpoints_InputArguments";
      VariableIds2[VariableIds2["Server_ServerCapabilities_MaxMonitoredItemsQueueSize"] = 31916] = "Server_ServerCapabilities_MaxMonitoredItemsQueueSize";
      VariableIds2[VariableIds2["AlarmMask_OptionSetValues"] = 32252] = "AlarmMask_OptionSetValues";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_ActivityTimeout"] = 32330] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_ActivityTimeout";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_ActivityTimeout"] = 32331] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_ActivityTimeout";
      VariableIds2[VariableIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_ActivityTimeout"] = 32332] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_ActivityTimeout";
      VariableIds2[VariableIds2["ServerConfiguration_GetCertificates_InputArguments"] = 32334] = "ServerConfiguration_GetCertificates_InputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_GetCertificates_OutputArguments"] = 32335] = "ServerConfiguration_GetCertificates_OutputArguments";
      VariableIds2[VariableIds2["ServerConfiguration_TransactionDiagnostics_StartTime"] = 32337] = "ServerConfiguration_TransactionDiagnostics_StartTime";
      VariableIds2[VariableIds2["ServerConfiguration_TransactionDiagnostics_EndTime"] = 32338] = "ServerConfiguration_TransactionDiagnostics_EndTime";
      VariableIds2[VariableIds2["ServerConfiguration_TransactionDiagnostics_Result"] = 32339] = "ServerConfiguration_TransactionDiagnostics_Result";
      VariableIds2[VariableIds2["ServerConfiguration_TransactionDiagnostics_AffectedTrustLists"] = 32340] = "ServerConfiguration_TransactionDiagnostics_AffectedTrustLists";
      VariableIds2[VariableIds2["ServerConfiguration_TransactionDiagnostics_AffectedCertificateGroups"] = 32341] = "ServerConfiguration_TransactionDiagnostics_AffectedCertificateGroups";
      VariableIds2[VariableIds2["ServerConfiguration_TransactionDiagnostics_Errors"] = 32342] = "ServerConfiguration_TransactionDiagnostics_Errors";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_TransactionErrorType"] = 32383] = "OpcUa_BinarySchema_TransactionErrorType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_TransactionErrorType_DataTypeVersion"] = 32384] = "OpcUa_BinarySchema_TransactionErrorType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_TransactionErrorType"] = 32387] = "OpcUa_XmlSchema_TransactionErrorType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_TransactionErrorType_DataTypeVersion"] = 32388] = "OpcUa_XmlSchema_TransactionErrorType_DataTypeVersion";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubCapablities_MaxDataSetWritersPerGroup"] = 32398] = "PublishSubscribe_PubSubCapablities_MaxDataSetWritersPerGroup";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubCapablities_MaxNetworkMessageSizeDatagram"] = 32399] = "PublishSubscribe_PubSubCapablities_MaxNetworkMessageSizeDatagram";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubCapablities_MaxNetworkMessageSizeBroker"] = 32400] = "PublishSubscribe_PubSubCapablities_MaxNetworkMessageSizeBroker";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubCapablities_SupportSecurityKeyPull"] = 32401] = "PublishSubscribe_PubSubCapablities_SupportSecurityKeyPull";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubCapablities_SupportSecurityKeyPush"] = 32402] = "PublishSubscribe_PubSubCapablities_SupportSecurityKeyPush";
      VariableIds2[VariableIds2["PublishSubscribe_DefaultSecurityKeyServices"] = 32403] = "PublishSubscribe_DefaultSecurityKeyServices";
      VariableIds2[VariableIds2["PublishSubscribe_ConfigurationProperties"] = 32404] = "PublishSubscribe_ConfigurationProperties";
      VariableIds2[VariableIds2["OPCUANamespaceMetadata_ModelVersion"] = 32408] = "OPCUANamespaceMetadata_ModelVersion";
      VariableIds2[VariableIds2["RedundantServerMode_EnumStrings"] = 32418] = "RedundantServerMode_EnumStrings";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_BitFieldDefinition"] = 32423] = "OpcUa_BinarySchema_BitFieldDefinition";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_BitFieldDefinition_DataTypeVersion"] = 32424] = "OpcUa_BinarySchema_BitFieldDefinition_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_BitFieldDefinition_DictionaryFragment"] = 32425] = "OpcUa_BinarySchema_BitFieldDefinition_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_BitFieldDefinition"] = 32427] = "OpcUa_XmlSchema_BitFieldDefinition";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_BitFieldDefinition_DataTypeVersion"] = 32428] = "OpcUa_XmlSchema_BitFieldDefinition_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_BitFieldDefinition_DictionaryFragment"] = 32429] = "OpcUa_XmlSchema_BitFieldDefinition_DictionaryFragment";
      VariableIds2[VariableIds2["ConversionLimitEnum_EnumStrings"] = 32437] = "ConversionLimitEnum_EnumStrings";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AnnotationDataType"] = 32563] = "OpcUa_BinarySchema_AnnotationDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AnnotationDataType_DataTypeVersion"] = 32564] = "OpcUa_BinarySchema_AnnotationDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_AnnotationDataType_DictionaryFragment"] = 32565] = "OpcUa_BinarySchema_AnnotationDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_LinearConversionDataType"] = 32566] = "OpcUa_BinarySchema_LinearConversionDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_LinearConversionDataType_DataTypeVersion"] = 32567] = "OpcUa_BinarySchema_LinearConversionDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_LinearConversionDataType_DictionaryFragment"] = 32568] = "OpcUa_BinarySchema_LinearConversionDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_QuantityDimension"] = 32569] = "OpcUa_BinarySchema_QuantityDimension";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_QuantityDimension_DataTypeVersion"] = 32570] = "OpcUa_BinarySchema_QuantityDimension_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_QuantityDimension_DictionaryFragment"] = 32571] = "OpcUa_BinarySchema_QuantityDimension_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AnnotationDataType"] = 32575] = "OpcUa_XmlSchema_AnnotationDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AnnotationDataType_DataTypeVersion"] = 32576] = "OpcUa_XmlSchema_AnnotationDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_AnnotationDataType_DictionaryFragment"] = 32577] = "OpcUa_XmlSchema_AnnotationDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_LinearConversionDataType"] = 32578] = "OpcUa_XmlSchema_LinearConversionDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_LinearConversionDataType_DataTypeVersion"] = 32579] = "OpcUa_XmlSchema_LinearConversionDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_LinearConversionDataType_DictionaryFragment"] = 32580] = "OpcUa_XmlSchema_LinearConversionDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_QuantityDimension"] = 32581] = "OpcUa_XmlSchema_QuantityDimension";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_QuantityDimension_DataTypeVersion"] = 32582] = "OpcUa_XmlSchema_QuantityDimension_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_QuantityDimension_DictionaryFragment"] = 32583] = "OpcUa_XmlSchema_QuantityDimension_DictionaryFragment";
      VariableIds2[VariableIds2["HAConfiguration_MaxTimeStoredValues"] = 32635] = "HAConfiguration_MaxTimeStoredValues";
      VariableIds2[VariableIds2["HAConfiguration_MaxCountStoredValues"] = 32636] = "HAConfiguration_MaxCountStoredValues";
      VariableIds2[VariableIds2["DefaultHAConfiguration_AggregateConfiguration_TreatUncertainAsBad"] = 32639] = "DefaultHAConfiguration_AggregateConfiguration_TreatUncertainAsBad";
      VariableIds2[VariableIds2["DefaultHAConfiguration_AggregateConfiguration_PercentDataBad"] = 32640] = "DefaultHAConfiguration_AggregateConfiguration_PercentDataBad";
      VariableIds2[VariableIds2["DefaultHAConfiguration_AggregateConfiguration_PercentDataGood"] = 32641] = "DefaultHAConfiguration_AggregateConfiguration_PercentDataGood";
      VariableIds2[VariableIds2["DefaultHAConfiguration_AggregateConfiguration_UseSlopedExtrapolation"] = 32642] = "DefaultHAConfiguration_AggregateConfiguration_UseSlopedExtrapolation";
      VariableIds2[VariableIds2["DefaultHAConfiguration_Stepped"] = 32644] = "DefaultHAConfiguration_Stepped";
      VariableIds2[VariableIds2["DefaultHAConfiguration_Definition"] = 32645] = "DefaultHAConfiguration_Definition";
      VariableIds2[VariableIds2["DefaultHAConfiguration_MaxTimeInterval"] = 32646] = "DefaultHAConfiguration_MaxTimeInterval";
      VariableIds2[VariableIds2["DefaultHAConfiguration_MinTimeInterval"] = 32647] = "DefaultHAConfiguration_MinTimeInterval";
      VariableIds2[VariableIds2["DefaultHAConfiguration_ExceptionDeviation"] = 32648] = "DefaultHAConfiguration_ExceptionDeviation";
      VariableIds2[VariableIds2["DefaultHAConfiguration_ExceptionDeviationFormat"] = 32649] = "DefaultHAConfiguration_ExceptionDeviationFormat";
      VariableIds2[VariableIds2["DefaultHAConfiguration_StartOfArchive"] = 32650] = "DefaultHAConfiguration_StartOfArchive";
      VariableIds2[VariableIds2["DefaultHAConfiguration_StartOfOnlineArchive"] = 32656] = "DefaultHAConfiguration_StartOfOnlineArchive";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ReferenceDescriptionDataType"] = 32663] = "OpcUa_BinarySchema_ReferenceDescriptionDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ReferenceDescriptionDataType_DataTypeVersion"] = 32664] = "OpcUa_BinarySchema_ReferenceDescriptionDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ReferenceDescriptionDataType_DictionaryFragment"] = 32665] = "OpcUa_BinarySchema_ReferenceDescriptionDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ReferenceListEntryDataType"] = 32666] = "OpcUa_BinarySchema_ReferenceListEntryDataType";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ReferenceListEntryDataType_DataTypeVersion"] = 32667] = "OpcUa_BinarySchema_ReferenceListEntryDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_ReferenceListEntryDataType_DictionaryFragment"] = 32668] = "OpcUa_BinarySchema_ReferenceListEntryDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ReferenceDescriptionDataType"] = 32671] = "OpcUa_XmlSchema_ReferenceDescriptionDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ReferenceDescriptionDataType_DataTypeVersion"] = 32672] = "OpcUa_XmlSchema_ReferenceDescriptionDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ReferenceDescriptionDataType_DictionaryFragment"] = 32673] = "OpcUa_XmlSchema_ReferenceDescriptionDataType_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ReferenceListEntryDataType"] = 32674] = "OpcUa_XmlSchema_ReferenceListEntryDataType";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ReferenceListEntryDataType_DataTypeVersion"] = 32675] = "OpcUa_XmlSchema_ReferenceListEntryDataType_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_ReferenceListEntryDataType_DictionaryFragment"] = 32676] = "OpcUa_XmlSchema_ReferenceListEntryDataType_DictionaryFragment";
      VariableIds2[VariableIds2["DefaultHAConfiguration_ServerTimestampSupported"] = 32682] = "DefaultHAConfiguration_ServerTimestampSupported";
      VariableIds2[VariableIds2["OptionSetLength"] = 32750] = "OptionSetLength";
      VariableIds2[VariableIds2["DefaultHAConfiguration_MaxTimeStoredValues"] = 32752] = "DefaultHAConfiguration_MaxTimeStoredValues";
      VariableIds2[VariableIds2["DefaultHAConfiguration_MaxCountStoredValues"] = 32753] = "DefaultHAConfiguration_MaxCountStoredValues";
      VariableIds2[VariableIds2["DefaultHEConfiguration_StartOfArchive"] = 32756] = "DefaultHEConfiguration_StartOfArchive";
      VariableIds2[VariableIds2["DefaultHEConfiguration_StartOfOnlineArchive"] = 32757] = "DefaultHEConfiguration_StartOfOnlineArchive";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_HistoryModifiedEvent"] = 32826] = "OpcUa_BinarySchema_HistoryModifiedEvent";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_HistoryModifiedEvent_DataTypeVersion"] = 32827] = "OpcUa_BinarySchema_HistoryModifiedEvent_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_BinarySchema_HistoryModifiedEvent_DictionaryFragment"] = 32828] = "OpcUa_BinarySchema_HistoryModifiedEvent_DictionaryFragment";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_HistoryModifiedEvent"] = 32830] = "OpcUa_XmlSchema_HistoryModifiedEvent";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_HistoryModifiedEvent_DataTypeVersion"] = 32831] = "OpcUa_XmlSchema_HistoryModifiedEvent_DataTypeVersion";
      VariableIds2[VariableIds2["OpcUa_XmlSchema_HistoryModifiedEvent_DictionaryFragment"] = 32832] = "OpcUa_XmlSchema_HistoryModifiedEvent_DictionaryFragment";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubCapablities_MaxSecurityGroups"] = 32839] = "PublishSubscribe_PubSubCapablities_MaxSecurityGroups";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubCapablities_MaxPushTargets"] = 32840] = "PublishSubscribe_PubSubCapablities_MaxPushTargets";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubCapablities_MaxPublishedDataSets"] = 32841] = "PublishSubscribe_PubSubCapablities_MaxPublishedDataSets";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubCapablities_MaxStandaloneSubscribedDataSets"] = 32842] = "PublishSubscribe_PubSubCapablities_MaxStandaloneSubscribedDataSets";
      VariableIds2[VariableIds2["PublishSubscribe_PubSubCapablities_SupportSecurityKeyServer"] = 32843] = "PublishSubscribe_PubSubCapablities_SupportSecurityKeyServer";
      VariableIds2[VariableIds2["Aliases_LastChange"] = 32852] = "Aliases_LastChange";
      VariableIds2[VariableIds2["TagVariables_LastChange"] = 32854] = "TagVariables_LastChange";
      VariableIds2[VariableIds2["Topics_LastChange"] = 32856] = "Topics_LastChange";
    })(VariableIds || (exports2.VariableIds = VariableIds = {}));
    var MethodIds;
    (function(MethodIds2) {
      MethodIds2[MethodIds2["ProgramStateMachineType_Start"] = 2426] = "ProgramStateMachineType_Start";
      MethodIds2[MethodIds2["ProgramStateMachineType_Suspend"] = 2427] = "ProgramStateMachineType_Suspend";
      MethodIds2[MethodIds2["ProgramStateMachineType_Resume"] = 2428] = "ProgramStateMachineType_Resume";
      MethodIds2[MethodIds2["ProgramStateMachineType_Halt"] = 2429] = "ProgramStateMachineType_Halt";
      MethodIds2[MethodIds2["ProgramStateMachineType_Reset"] = 2430] = "ProgramStateMachineType_Reset";
      MethodIds2[MethodIds2["ShelvedStateMachineType_Unshelve"] = 2947] = "ShelvedStateMachineType_Unshelve";
      MethodIds2[MethodIds2["ShelvedStateMachineType_OneShotShelve"] = 2948] = "ShelvedStateMachineType_OneShotShelve";
      MethodIds2[MethodIds2["ShelvedStateMachineType_TimedShelve"] = 2949] = "ShelvedStateMachineType_TimedShelve";
      MethodIds2[MethodIds2["AddCommentMethodType"] = 3863] = "AddCommentMethodType";
      MethodIds2[MethodIds2["ConditionType_ConditionRefresh"] = 3875] = "ConditionType_ConditionRefresh";
      MethodIds2[MethodIds2["TimedShelveMethodType"] = 6102] = "TimedShelveMethodType";
      MethodIds2[MethodIds2["ConditionRefreshMethodType"] = 9007] = "ConditionRefreshMethodType";
      MethodIds2[MethodIds2["ConditionType_Enable"] = 9027] = "ConditionType_Enable";
      MethodIds2[MethodIds2["ConditionType_Disable"] = 9028] = "ConditionType_Disable";
      MethodIds2[MethodIds2["ConditionType_AddComment"] = 9029] = "ConditionType_AddComment";
      MethodIds2[MethodIds2["DialogResponseMethodType"] = 9031] = "DialogResponseMethodType";
      MethodIds2[MethodIds2["DialogConditionType_Respond"] = 9069] = "DialogConditionType_Respond";
      MethodIds2[MethodIds2["AcknowledgeableConditionType_Acknowledge"] = 9111] = "AcknowledgeableConditionType_Acknowledge";
      MethodIds2[MethodIds2["AcknowledgeableConditionType_Confirm"] = 9113] = "AcknowledgeableConditionType_Confirm";
      MethodIds2[MethodIds2["AlarmConditionType_ShelvingState_Unshelve"] = 9211] = "AlarmConditionType_ShelvingState_Unshelve";
      MethodIds2[MethodIds2["AlarmConditionType_ShelvingState_OneShotShelve"] = 9212] = "AlarmConditionType_ShelvingState_OneShotShelve";
      MethodIds2[MethodIds2["AlarmConditionType_ShelvingState_TimedShelve"] = 9213] = "AlarmConditionType_ShelvingState_TimedShelve";
      MethodIds2[MethodIds2["ServerType_GetMonitoredItems"] = 11489] = "ServerType_GetMonitoredItems";
      MethodIds2[MethodIds2["Server_GetMonitoredItems"] = 11492] = "Server_GetMonitoredItems";
      MethodIds2[MethodIds2["GetMonitoredItemsMethodType"] = 11495] = "GetMonitoredItemsMethodType";
      MethodIds2[MethodIds2["FileType_Open"] = 11580] = "FileType_Open";
      MethodIds2[MethodIds2["FileType_Close"] = 11583] = "FileType_Close";
      MethodIds2[MethodIds2["FileType_Read"] = 11585] = "FileType_Read";
      MethodIds2[MethodIds2["FileType_Write"] = 11588] = "FileType_Write";
      MethodIds2[MethodIds2["FileType_GetPosition"] = 11590] = "FileType_GetPosition";
      MethodIds2[MethodIds2["FileType_SetPosition"] = 11593] = "FileType_SetPosition";
      MethodIds2[MethodIds2["AddressSpaceFileType_ExportNamespace"] = 11615] = "AddressSpaceFileType_ExportNamespace";
      MethodIds2[MethodIds2["NamespaceMetadataType_NamespaceFile_Open"] = 11629] = "NamespaceMetadataType_NamespaceFile_Open";
      MethodIds2[MethodIds2["NamespaceMetadataType_NamespaceFile_Close"] = 11632] = "NamespaceMetadataType_NamespaceFile_Close";
      MethodIds2[MethodIds2["NamespaceMetadataType_NamespaceFile_Read"] = 11634] = "NamespaceMetadataType_NamespaceFile_Read";
      MethodIds2[MethodIds2["NamespaceMetadataType_NamespaceFile_Write"] = 11637] = "NamespaceMetadataType_NamespaceFile_Write";
      MethodIds2[MethodIds2["NamespaceMetadataType_NamespaceFile_GetPosition"] = 11639] = "NamespaceMetadataType_NamespaceFile_GetPosition";
      MethodIds2[MethodIds2["NamespaceMetadataType_NamespaceFile_SetPosition"] = 11642] = "NamespaceMetadataType_NamespaceFile_SetPosition";
      MethodIds2[MethodIds2["NamespaceMetadataType_NamespaceFile_ExportNamespace"] = 11644] = "NamespaceMetadataType_NamespaceFile_ExportNamespace";
      MethodIds2[MethodIds2["OpenMethodType"] = 11738] = "OpenMethodType";
      MethodIds2[MethodIds2["CloseMethodType"] = 11741] = "CloseMethodType";
      MethodIds2[MethodIds2["ReadMethodType"] = 11743] = "ReadMethodType";
      MethodIds2[MethodIds2["WriteMethodType"] = 11746] = "WriteMethodType";
      MethodIds2[MethodIds2["GetPositionMethodType"] = 11748] = "GetPositionMethodType";
      MethodIds2[MethodIds2["SetPositionMethodType"] = 11751] = "SetPositionMethodType";
      MethodIds2[MethodIds2["OpenWithMasksMethodType"] = 12513] = "OpenWithMasksMethodType";
      MethodIds2[MethodIds2["CloseAndUpdateMethodType"] = 12516] = "CloseAndUpdateMethodType";
      MethodIds2[MethodIds2["AddCertificateMethodType"] = 12518] = "AddCertificateMethodType";
      MethodIds2[MethodIds2["RemoveCertificateMethodType"] = 12520] = "RemoveCertificateMethodType";
      MethodIds2[MethodIds2["TrustListType_OpenWithMasks"] = 12543] = "TrustListType_OpenWithMasks";
      MethodIds2[MethodIds2["TrustListType_CloseAndUpdate"] = 12546] = "TrustListType_CloseAndUpdate";
      MethodIds2[MethodIds2["TrustListType_AddCertificate"] = 12548] = "TrustListType_AddCertificate";
      MethodIds2[MethodIds2["TrustListType_RemoveCertificate"] = 12550] = "TrustListType_RemoveCertificate";
      MethodIds2[MethodIds2["UpdateCertificateMethodType"] = 12578] = "UpdateCertificateMethodType";
      MethodIds2[MethodIds2["ServerConfigurationType_UpdateCertificate"] = 12616] = "ServerConfigurationType_UpdateCertificate";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Open"] = 12647] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Open";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Close"] = 12650] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Close";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Read"] = 12652] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Read";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Write"] = 12655] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Write";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_GetPosition"] = 12657] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_GetPosition";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_SetPosition"] = 12660] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_SetPosition";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_OpenWithMasks"] = 12663] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_OpenWithMasks";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_CloseAndUpdate"] = 12666] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_CloseAndUpdate";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_AddCertificate"] = 12668] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_AddCertificate";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_RemoveCertificate"] = 12670] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_RemoveCertificate";
      MethodIds2[MethodIds2["ServerConfigurationType_CreateSigningRequest"] = 12731] = "ServerConfigurationType_CreateSigningRequest";
      MethodIds2[MethodIds2["ServerConfigurationType_ApplyChanges"] = 12734] = "ServerConfigurationType_ApplyChanges";
      MethodIds2[MethodIds2["ServerConfiguration_CreateSigningRequest"] = 12737] = "ServerConfiguration_CreateSigningRequest";
      MethodIds2[MethodIds2["ServerConfiguration_ApplyChanges"] = 12740] = "ServerConfiguration_ApplyChanges";
      MethodIds2[MethodIds2["CreateSigningRequestMethodType"] = 12741] = "CreateSigningRequestMethodType";
      MethodIds2[MethodIds2["ServerType_SetSubscriptionDurable"] = 12746] = "ServerType_SetSubscriptionDurable";
      MethodIds2[MethodIds2["Server_SetSubscriptionDurable"] = 12749] = "Server_SetSubscriptionDurable";
      MethodIds2[MethodIds2["SetSubscriptionDurableMethodType"] = 12752] = "SetSubscriptionDurableMethodType";
      MethodIds2[MethodIds2["GetRejectedListMethodType"] = 12773] = "GetRejectedListMethodType";
      MethodIds2[MethodIds2["ServerConfigurationType_GetRejectedList"] = 12775] = "ServerConfigurationType_GetRejectedList";
      MethodIds2[MethodIds2["ServerConfiguration_GetRejectedList"] = 12777] = "ServerConfiguration_GetRejectedList";
      MethodIds2[MethodIds2["ServerType_ResendData"] = 12871] = "ServerType_ResendData";
      MethodIds2[MethodIds2["Server_ResendData"] = 12873] = "Server_ResendData";
      MethodIds2[MethodIds2["ResendDataMethodType"] = 12875] = "ResendDataMethodType";
      MethodIds2[MethodIds2["ServerType_RequestServerStateChange"] = 12883] = "ServerType_RequestServerStateChange";
      MethodIds2[MethodIds2["Server_RequestServerStateChange"] = 12886] = "Server_RequestServerStateChange";
      MethodIds2[MethodIds2["RequestServerStateChangeMethodType"] = 12888] = "RequestServerStateChangeMethodType";
      MethodIds2[MethodIds2["ConditionType_ConditionRefresh2"] = 12912] = "ConditionType_ConditionRefresh2";
      MethodIds2[MethodIds2["ConditionRefresh2MethodType"] = 12914] = "ConditionRefresh2MethodType";
      MethodIds2[MethodIds2["CreateDirectoryMethodType"] = 13342] = "CreateDirectoryMethodType";
      MethodIds2[MethodIds2["CreateFileMethodType"] = 13345] = "CreateFileMethodType";
      MethodIds2[MethodIds2["DeleteFileMethodType"] = 13348] = "DeleteFileMethodType";
      MethodIds2[MethodIds2["MoveOrCopyMethodType"] = 13350] = "MoveOrCopyMethodType";
      MethodIds2[MethodIds2["FileDirectoryType_CreateDirectory"] = 13387] = "FileDirectoryType_CreateDirectory";
      MethodIds2[MethodIds2["FileDirectoryType_CreateFile"] = 13390] = "FileDirectoryType_CreateFile";
      MethodIds2[MethodIds2["FileDirectoryType_DeleteFileSystemObject"] = 13393] = "FileDirectoryType_DeleteFileSystemObject";
      MethodIds2[MethodIds2["FileDirectoryType_MoveOrCopy"] = 13395] = "FileDirectoryType_MoveOrCopy";
      MethodIds2[MethodIds2["CertificateGroupType_TrustList_Open"] = 13605] = "CertificateGroupType_TrustList_Open";
      MethodIds2[MethodIds2["CertificateGroupType_TrustList_Close"] = 13608] = "CertificateGroupType_TrustList_Close";
      MethodIds2[MethodIds2["CertificateGroupType_TrustList_Read"] = 13610] = "CertificateGroupType_TrustList_Read";
      MethodIds2[MethodIds2["CertificateGroupType_TrustList_Write"] = 13613] = "CertificateGroupType_TrustList_Write";
      MethodIds2[MethodIds2["CertificateGroupType_TrustList_GetPosition"] = 13615] = "CertificateGroupType_TrustList_GetPosition";
      MethodIds2[MethodIds2["CertificateGroupType_TrustList_SetPosition"] = 13618] = "CertificateGroupType_TrustList_SetPosition";
      MethodIds2[MethodIds2["CertificateGroupType_TrustList_OpenWithMasks"] = 13621] = "CertificateGroupType_TrustList_OpenWithMasks";
      MethodIds2[MethodIds2["CertificateGroupType_TrustList_CloseAndUpdate"] = 13624] = "CertificateGroupType_TrustList_CloseAndUpdate";
      MethodIds2[MethodIds2["CertificateGroupType_TrustList_AddCertificate"] = 13627] = "CertificateGroupType_TrustList_AddCertificate";
      MethodIds2[MethodIds2["CertificateGroupType_TrustList_RemoveCertificate"] = 13629] = "CertificateGroupType_TrustList_RemoveCertificate";
      MethodIds2[MethodIds2["ServerConfiguration_UpdateCertificate"] = 13737] = "ServerConfiguration_UpdateCertificate";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Open"] = 13821] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Open";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Close"] = 13824] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Close";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Read"] = 13826] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Read";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Write"] = 13829] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Write";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustList_GetPosition"] = 13831] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustList_GetPosition";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustList_SetPosition"] = 13834] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustList_SetPosition";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustList_OpenWithMasks"] = 13837] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustList_OpenWithMasks";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustList_CloseAndUpdate"] = 13840] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustList_CloseAndUpdate";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustList_AddCertificate"] = 13843] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustList_AddCertificate";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustList_RemoveCertificate"] = 13845] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustList_RemoveCertificate";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Open"] = 13855] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Open";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Close"] = 13858] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Close";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Read"] = 13860] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Read";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Write"] = 13863] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Write";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustList_GetPosition"] = 13865] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustList_GetPosition";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustList_SetPosition"] = 13868] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustList_SetPosition";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustList_OpenWithMasks"] = 13871] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustList_OpenWithMasks";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustList_CloseAndUpdate"] = 13874] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustList_CloseAndUpdate";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustList_AddCertificate"] = 13877] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustList_AddCertificate";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustList_RemoveCertificate"] = 13879] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustList_RemoveCertificate";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Open"] = 13889] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Open";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Close"] = 13892] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Close";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Read"] = 13894] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Read";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Write"] = 13897] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Write";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_GetPosition"] = 13899] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_GetPosition";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_SetPosition"] = 13902] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_SetPosition";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_OpenWithMasks"] = 13905] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_OpenWithMasks";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_CloseAndUpdate"] = 13908] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_CloseAndUpdate";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_AddCertificate"] = 13911] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_AddCertificate";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_RemoveCertificate"] = 13913] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_RemoveCertificate";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Open"] = 13958] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Open";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Close"] = 13961] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Close";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Read"] = 13963] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Read";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Write"] = 13966] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Write";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_GetPosition"] = 13968] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_GetPosition";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_SetPosition"] = 13971] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_SetPosition";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_OpenWithMasks"] = 13974] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_OpenWithMasks";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_CloseAndUpdate"] = 13977] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_CloseAndUpdate";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_AddCertificate"] = 13980] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_AddCertificate";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_RemoveCertificate"] = 13982] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_RemoveCertificate";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Open"] = 13992] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Open";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Close"] = 13995] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Close";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Read"] = 13997] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Read";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Write"] = 14e3] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Write";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_GetPosition"] = 14002] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_GetPosition";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_SetPosition"] = 14005] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_SetPosition";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_OpenWithMasks"] = 14008] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_OpenWithMasks";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_CloseAndUpdate"] = 14011] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_CloseAndUpdate";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_AddCertificate"] = 14014] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_AddCertificate";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_RemoveCertificate"] = 14016] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_RemoveCertificate";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Open"] = 14026] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Open";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Close"] = 14029] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Close";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Read"] = 14031] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Read";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Write"] = 14034] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Write";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_GetPosition"] = 14036] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_GetPosition";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_SetPosition"] = 14039] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_SetPosition";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenWithMasks"] = 14042] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenWithMasks";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_CloseAndUpdate"] = 14045] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_CloseAndUpdate";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_AddCertificate"] = 14048] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_AddCertificate";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_RemoveCertificate"] = 14050] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_RemoveCertificate";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Open"] = 14095] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Open";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Close"] = 14098] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Close";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Read"] = 14100] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Read";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Write"] = 14103] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Write";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_GetPosition"] = 14105] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_GetPosition";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_SetPosition"] = 14108] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_SetPosition";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_OpenWithMasks"] = 14111] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_OpenWithMasks";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_CloseAndUpdate"] = 14114] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_CloseAndUpdate";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_AddCertificate"] = 14117] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_AddCertificate";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_RemoveCertificate"] = 14119] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_RemoveCertificate";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Open"] = 14129] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Open";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Close"] = 14132] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Close";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Read"] = 14134] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Read";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Write"] = 14137] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Write";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_GetPosition"] = 14139] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_GetPosition";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_SetPosition"] = 14142] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_SetPosition";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenWithMasks"] = 14145] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenWithMasks";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_CloseAndUpdate"] = 14148] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_CloseAndUpdate";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_AddCertificate"] = 14151] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_AddCertificate";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_RemoveCertificate"] = 14153] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_RemoveCertificate";
      MethodIds2[MethodIds2["RemoveConnectionMethodType"] = 14183] = "RemoveConnectionMethodType";
      MethodIds2[MethodIds2["PubSubConnectionType_RemoveGroup"] = 14225] = "PubSubConnectionType_RemoveGroup";
      MethodIds2[MethodIds2["PublishSubscribeType_RemoveConnection"] = 14432] = "PublishSubscribeType_RemoveConnection";
      MethodIds2[MethodIds2["PublishSubscribeType_PublishedDataSets_AddPublishedDataItems"] = 14435] = "PublishSubscribeType_PublishedDataSets_AddPublishedDataItems";
      MethodIds2[MethodIds2["PublishSubscribeType_PublishedDataSets_AddPublishedEvents"] = 14438] = "PublishSubscribeType_PublishedDataSets_AddPublishedEvents";
      MethodIds2[MethodIds2["PublishSubscribeType_PublishedDataSets_RemovePublishedDataSet"] = 14441] = "PublishSubscribeType_PublishedDataSets_RemovePublishedDataSet";
      MethodIds2[MethodIds2["DataSetFolderType_AddPublishedDataItems"] = 14493] = "DataSetFolderType_AddPublishedDataItems";
      MethodIds2[MethodIds2["DataSetFolderType_AddPublishedEvents"] = 14496] = "DataSetFolderType_AddPublishedEvents";
      MethodIds2[MethodIds2["DataSetFolderType_RemovePublishedDataSet"] = 14499] = "DataSetFolderType_RemovePublishedDataSet";
      MethodIds2[MethodIds2["AddPublishedDataItemsMethodType"] = 14501] = "AddPublishedDataItemsMethodType";
      MethodIds2[MethodIds2["AddPublishedEventsMethodType"] = 14504] = "AddPublishedEventsMethodType";
      MethodIds2[MethodIds2["RemovePublishedDataSetMethodType"] = 14507] = "RemovePublishedDataSetMethodType";
      MethodIds2[MethodIds2["PublishedDataItemsType_AddVariables"] = 14555] = "PublishedDataItemsType_AddVariables";
      MethodIds2[MethodIds2["PublishedDataItemsType_RemoveVariables"] = 14558] = "PublishedDataItemsType_RemoveVariables";
      MethodIds2[MethodIds2["PublishedDataItemsAddVariablesMethodType"] = 14564] = "PublishedDataItemsAddVariablesMethodType";
      MethodIds2[MethodIds2["PublishedDataItemsRemoveVariablesMethodType"] = 14567] = "PublishedDataItemsRemoveVariablesMethodType";
      MethodIds2[MethodIds2["PubSubConnectionType_Status_Enable"] = 14602] = "PubSubConnectionType_Status_Enable";
      MethodIds2[MethodIds2["PubSubConnectionType_Status_Disable"] = 14603] = "PubSubConnectionType_Status_Disable";
      MethodIds2[MethodIds2["PubSubConnectionTypeRemoveGroupMethodType"] = 14604] = "PubSubConnectionTypeRemoveGroupMethodType";
      MethodIds2[MethodIds2["PubSubGroupTypeRemoveWriterMethodType"] = 14623] = "PubSubGroupTypeRemoveWriterMethodType";
      MethodIds2[MethodIds2["PubSubGroupTypeRemoveReaderMethodType"] = 14625] = "PubSubGroupTypeRemoveReaderMethodType";
      MethodIds2[MethodIds2["PubSubStatusType_Enable"] = 14645] = "PubSubStatusType_Enable";
      MethodIds2[MethodIds2["PubSubStatusType_Disable"] = 14646] = "PubSubStatusType_Disable";
      MethodIds2[MethodIds2["PublishedEventsType_ModifyFieldSelection"] = 15052] = "PublishedEventsType_ModifyFieldSelection";
      MethodIds2[MethodIds2["PublishedEventsTypeModifyFieldSelectionMethodType"] = 15054] = "PublishedEventsTypeModifyFieldSelectionMethodType";
      MethodIds2[MethodIds2["TargetVariablesType_AddTargetVariables"] = 15115] = "TargetVariablesType_AddTargetVariables";
      MethodIds2[MethodIds2["TargetVariablesType_RemoveTargetVariables"] = 15118] = "TargetVariablesType_RemoveTargetVariables";
      MethodIds2[MethodIds2["TargetVariablesTypeAddTargetVariablesMethodType"] = 15121] = "TargetVariablesTypeAddTargetVariablesMethodType";
      MethodIds2[MethodIds2["TargetVariablesTypeRemoveTargetVariablesMethodType"] = 15124] = "TargetVariablesTypeRemoveTargetVariablesMethodType";
      MethodIds2[MethodIds2["PublishSubscribe_GetSecurityKeys"] = 15215] = "PublishSubscribe_GetSecurityKeys";
      MethodIds2[MethodIds2["GetSecurityKeysMethodType"] = 15218] = "GetSecurityKeysMethodType";
      MethodIds2[MethodIds2["CreateCredentialMethodType"] = 15248] = "CreateCredentialMethodType";
      MethodIds2[MethodIds2["PubSubGroupType_Status_Enable"] = 15267] = "PubSubGroupType_Status_Enable";
      MethodIds2[MethodIds2["PubSubGroupType_Status_Disable"] = 15268] = "PubSubGroupType_Status_Disable";
      MethodIds2[MethodIds2["DataSetWriterType_Status_Enable"] = 15301] = "DataSetWriterType_Status_Enable";
      MethodIds2[MethodIds2["DataSetWriterType_Status_Disable"] = 15302] = "DataSetWriterType_Status_Disable";
      MethodIds2[MethodIds2["DataSetReaderType_Status_Enable"] = 15309] = "DataSetReaderType_Status_Enable";
      MethodIds2[MethodIds2["DataSetReaderType_Status_Disable"] = 15310] = "DataSetReaderType_Status_Disable";
      MethodIds2[MethodIds2["PublishSubscribe_GetSecurityGroup"] = 15440] = "PublishSubscribe_GetSecurityGroup";
      MethodIds2[MethodIds2["PublishSubscribe_SecurityGroups_AddSecurityGroup"] = 15444] = "PublishSubscribe_SecurityGroups_AddSecurityGroup";
      MethodIds2[MethodIds2["PublishSubscribe_SecurityGroups_RemoveSecurityGroup"] = 15447] = "PublishSubscribe_SecurityGroups_RemoveSecurityGroup";
      MethodIds2[MethodIds2["GetSecurityGroupMethodType"] = 15449] = "GetSecurityGroupMethodType";
      MethodIds2[MethodIds2["SecurityGroupFolderType_AddSecurityGroup"] = 15461] = "SecurityGroupFolderType_AddSecurityGroup";
      MethodIds2[MethodIds2["SecurityGroupFolderType_RemoveSecurityGroup"] = 15464] = "SecurityGroupFolderType_RemoveSecurityGroup";
      MethodIds2[MethodIds2["AddSecurityGroupMethodType"] = 15466] = "AddSecurityGroupMethodType";
      MethodIds2[MethodIds2["RemoveSecurityGroupMethodType"] = 15469] = "RemoveSecurityGroupMethodType";
      MethodIds2[MethodIds2["PublishedDataSetType_ExtensionFields_AddExtensionField"] = 15482] = "PublishedDataSetType_ExtensionFields_AddExtensionField";
      MethodIds2[MethodIds2["PublishedDataSetType_ExtensionFields_RemoveExtensionField"] = 15485] = "PublishedDataSetType_ExtensionFields_RemoveExtensionField";
      MethodIds2[MethodIds2["ExtensionFieldsType_AddExtensionField"] = 15491] = "ExtensionFieldsType_AddExtensionField";
      MethodIds2[MethodIds2["ExtensionFieldsType_RemoveExtensionField"] = 15494] = "ExtensionFieldsType_RemoveExtensionField";
      MethodIds2[MethodIds2["AddExtensionFieldMethodType"] = 15496] = "AddExtensionFieldMethodType";
      MethodIds2[MethodIds2["RemoveExtensionFieldMethodType"] = 15499] = "RemoveExtensionFieldMethodType";
      MethodIds2[MethodIds2["RoleType_AddIdentity"] = 15624] = "RoleType_AddIdentity";
      MethodIds2[MethodIds2["RoleType_RemoveIdentity"] = 15626] = "RoleType_RemoveIdentity";
      MethodIds2[MethodIds2["AddIdentityMethodType"] = 15636] = "AddIdentityMethodType";
      MethodIds2[MethodIds2["RemoveIdentityMethodType"] = 15638] = "RemoveIdentityMethodType";
      MethodIds2[MethodIds2["WellKnownRole_Anonymous_AddIdentity"] = 15648] = "WellKnownRole_Anonymous_AddIdentity";
      MethodIds2[MethodIds2["WellKnownRole_Anonymous_RemoveIdentity"] = 15650] = "WellKnownRole_Anonymous_RemoveIdentity";
      MethodIds2[MethodIds2["WellKnownRole_AuthenticatedUser_AddIdentity"] = 15660] = "WellKnownRole_AuthenticatedUser_AddIdentity";
      MethodIds2[MethodIds2["WellKnownRole_AuthenticatedUser_RemoveIdentity"] = 15662] = "WellKnownRole_AuthenticatedUser_RemoveIdentity";
      MethodIds2[MethodIds2["WellKnownRole_Observer_AddIdentity"] = 15672] = "WellKnownRole_Observer_AddIdentity";
      MethodIds2[MethodIds2["WellKnownRole_Observer_RemoveIdentity"] = 15674] = "WellKnownRole_Observer_RemoveIdentity";
      MethodIds2[MethodIds2["WellKnownRole_Operator_AddIdentity"] = 15684] = "WellKnownRole_Operator_AddIdentity";
      MethodIds2[MethodIds2["WellKnownRole_Operator_RemoveIdentity"] = 15686] = "WellKnownRole_Operator_RemoveIdentity";
      MethodIds2[MethodIds2["WellKnownRole_Supervisor_AddIdentity"] = 15696] = "WellKnownRole_Supervisor_AddIdentity";
      MethodIds2[MethodIds2["WellKnownRole_Supervisor_RemoveIdentity"] = 15698] = "WellKnownRole_Supervisor_RemoveIdentity";
      MethodIds2[MethodIds2["WellKnownRole_SecurityAdmin_AddIdentity"] = 15708] = "WellKnownRole_SecurityAdmin_AddIdentity";
      MethodIds2[MethodIds2["WellKnownRole_SecurityAdmin_RemoveIdentity"] = 15710] = "WellKnownRole_SecurityAdmin_RemoveIdentity";
      MethodIds2[MethodIds2["WellKnownRole_ConfigureAdmin_AddIdentity"] = 15720] = "WellKnownRole_ConfigureAdmin_AddIdentity";
      MethodIds2[MethodIds2["WellKnownRole_ConfigureAdmin_RemoveIdentity"] = 15722] = "WellKnownRole_ConfigureAdmin_RemoveIdentity";
      MethodIds2[MethodIds2["TemporaryFileTransferType_GenerateFileForRead"] = 15746] = "TemporaryFileTransferType_GenerateFileForRead";
      MethodIds2[MethodIds2["TemporaryFileTransferType_GenerateFileForWrite"] = 15749] = "TemporaryFileTransferType_GenerateFileForWrite";
      MethodIds2[MethodIds2["TemporaryFileTransferType_CloseAndCommit"] = 15751] = "TemporaryFileTransferType_CloseAndCommit";
      MethodIds2[MethodIds2["GenerateFileForReadMethodType"] = 15795] = "GenerateFileForReadMethodType";
      MethodIds2[MethodIds2["GenerateFileForWriteMethodType"] = 15798] = "GenerateFileForWriteMethodType";
      MethodIds2[MethodIds2["CloseAndCommitMethodType"] = 15800] = "CloseAndCommitMethodType";
      MethodIds2[MethodIds2["FileTransferStateMachineType_Reset"] = 15843] = "FileTransferStateMachineType_Reset";
      MethodIds2[MethodIds2["PublishSubscribeType_Status_Enable"] = 15846] = "PublishSubscribeType_Status_Enable";
      MethodIds2[MethodIds2["PublishSubscribeType_Status_Disable"] = 15847] = "PublishSubscribeType_Status_Disable";
      MethodIds2[MethodIds2["PubSubKeyServiceType_GetSecurityKeys"] = 15907] = "PubSubKeyServiceType_GetSecurityKeys";
      MethodIds2[MethodIds2["PubSubKeyServiceType_GetSecurityGroup"] = 15910] = "PubSubKeyServiceType_GetSecurityGroup";
      MethodIds2[MethodIds2["PubSubKeyServiceType_SecurityGroups_AddSecurityGroup"] = 15914] = "PubSubKeyServiceType_SecurityGroups_AddSecurityGroup";
      MethodIds2[MethodIds2["PubSubKeyServiceType_SecurityGroups_RemoveSecurityGroup"] = 15917] = "PubSubKeyServiceType_SecurityGroups_RemoveSecurityGroup";
      MethodIds2[MethodIds2["OPCUANamespaceMetadata_NamespaceFile_Open"] = 15971] = "OPCUANamespaceMetadata_NamespaceFile_Open";
      MethodIds2[MethodIds2["OPCUANamespaceMetadata_NamespaceFile_Close"] = 15974] = "OPCUANamespaceMetadata_NamespaceFile_Close";
      MethodIds2[MethodIds2["OPCUANamespaceMetadata_NamespaceFile_Read"] = 15976] = "OPCUANamespaceMetadata_NamespaceFile_Read";
      MethodIds2[MethodIds2["OPCUANamespaceMetadata_NamespaceFile_Write"] = 15979] = "OPCUANamespaceMetadata_NamespaceFile_Write";
      MethodIds2[MethodIds2["OPCUANamespaceMetadata_NamespaceFile_GetPosition"] = 15981] = "OPCUANamespaceMetadata_NamespaceFile_GetPosition";
      MethodIds2[MethodIds2["OPCUANamespaceMetadata_NamespaceFile_SetPosition"] = 15984] = "OPCUANamespaceMetadata_NamespaceFile_SetPosition";
      MethodIds2[MethodIds2["OPCUANamespaceMetadata_NamespaceFile_ExportNamespace"] = 15986] = "OPCUANamespaceMetadata_NamespaceFile_ExportNamespace";
      MethodIds2[MethodIds2["RoleSetType_AddRole"] = 15997] = "RoleSetType_AddRole";
      MethodIds2[MethodIds2["RoleSetType_RemoveRole"] = 16e3] = "RoleSetType_RemoveRole";
      MethodIds2[MethodIds2["AddRoleMethodType"] = 16002] = "AddRoleMethodType";
      MethodIds2[MethodIds2["RemoveRoleMethodType"] = 16005] = "RemoveRoleMethodType";
      MethodIds2[MethodIds2["WellKnownRole_Engineer_AddIdentity"] = 16041] = "WellKnownRole_Engineer_AddIdentity";
      MethodIds2[MethodIds2["WellKnownRole_Engineer_RemoveIdentity"] = 16043] = "WellKnownRole_Engineer_RemoveIdentity";
      MethodIds2[MethodIds2["RoleType_AddApplication"] = 16176] = "RoleType_AddApplication";
      MethodIds2[MethodIds2["RoleType_RemoveApplication"] = 16178] = "RoleType_RemoveApplication";
      MethodIds2[MethodIds2["RoleType_AddEndpoint"] = 16180] = "RoleType_AddEndpoint";
      MethodIds2[MethodIds2["RoleType_RemoveEndpoint"] = 16182] = "RoleType_RemoveEndpoint";
      MethodIds2[MethodIds2["AddApplicationMethodType"] = 16184] = "AddApplicationMethodType";
      MethodIds2[MethodIds2["RemoveApplicationMethodType"] = 16186] = "RemoveApplicationMethodType";
      MethodIds2[MethodIds2["AddEndpointMethodType"] = 16188] = "AddEndpointMethodType";
      MethodIds2[MethodIds2["RemoveEndpointMethodType"] = 16190] = "RemoveEndpointMethodType";
      MethodIds2[MethodIds2["WellKnownRole_Anonymous_AddApplication"] = 16195] = "WellKnownRole_Anonymous_AddApplication";
      MethodIds2[MethodIds2["WellKnownRole_Anonymous_RemoveApplication"] = 16197] = "WellKnownRole_Anonymous_RemoveApplication";
      MethodIds2[MethodIds2["WellKnownRole_Anonymous_AddEndpoint"] = 16199] = "WellKnownRole_Anonymous_AddEndpoint";
      MethodIds2[MethodIds2["WellKnownRole_Anonymous_RemoveEndpoint"] = 16201] = "WellKnownRole_Anonymous_RemoveEndpoint";
      MethodIds2[MethodIds2["WellKnownRole_AuthenticatedUser_AddApplication"] = 16206] = "WellKnownRole_AuthenticatedUser_AddApplication";
      MethodIds2[MethodIds2["WellKnownRole_AuthenticatedUser_RemoveApplication"] = 16208] = "WellKnownRole_AuthenticatedUser_RemoveApplication";
      MethodIds2[MethodIds2["WellKnownRole_AuthenticatedUser_AddEndpoint"] = 16210] = "WellKnownRole_AuthenticatedUser_AddEndpoint";
      MethodIds2[MethodIds2["WellKnownRole_AuthenticatedUser_RemoveEndpoint"] = 16212] = "WellKnownRole_AuthenticatedUser_RemoveEndpoint";
      MethodIds2[MethodIds2["WellKnownRole_Observer_AddApplication"] = 16217] = "WellKnownRole_Observer_AddApplication";
      MethodIds2[MethodIds2["WellKnownRole_Observer_RemoveApplication"] = 16219] = "WellKnownRole_Observer_RemoveApplication";
      MethodIds2[MethodIds2["WellKnownRole_Observer_AddEndpoint"] = 16221] = "WellKnownRole_Observer_AddEndpoint";
      MethodIds2[MethodIds2["WellKnownRole_Observer_RemoveEndpoint"] = 16223] = "WellKnownRole_Observer_RemoveEndpoint";
      MethodIds2[MethodIds2["WellKnownRole_Operator_AddApplication"] = 16228] = "WellKnownRole_Operator_AddApplication";
      MethodIds2[MethodIds2["WellKnownRole_Operator_RemoveApplication"] = 16230] = "WellKnownRole_Operator_RemoveApplication";
      MethodIds2[MethodIds2["WellKnownRole_Operator_AddEndpoint"] = 16232] = "WellKnownRole_Operator_AddEndpoint";
      MethodIds2[MethodIds2["WellKnownRole_Operator_RemoveEndpoint"] = 16234] = "WellKnownRole_Operator_RemoveEndpoint";
      MethodIds2[MethodIds2["WellKnownRole_Engineer_AddApplication"] = 16239] = "WellKnownRole_Engineer_AddApplication";
      MethodIds2[MethodIds2["WellKnownRole_Engineer_RemoveApplication"] = 16241] = "WellKnownRole_Engineer_RemoveApplication";
      MethodIds2[MethodIds2["WellKnownRole_Engineer_AddEndpoint"] = 16243] = "WellKnownRole_Engineer_AddEndpoint";
      MethodIds2[MethodIds2["WellKnownRole_Engineer_RemoveEndpoint"] = 16245] = "WellKnownRole_Engineer_RemoveEndpoint";
      MethodIds2[MethodIds2["WellKnownRole_Supervisor_AddApplication"] = 16250] = "WellKnownRole_Supervisor_AddApplication";
      MethodIds2[MethodIds2["WellKnownRole_Supervisor_RemoveApplication"] = 16252] = "WellKnownRole_Supervisor_RemoveApplication";
      MethodIds2[MethodIds2["WellKnownRole_Supervisor_AddEndpoint"] = 16254] = "WellKnownRole_Supervisor_AddEndpoint";
      MethodIds2[MethodIds2["WellKnownRole_Supervisor_RemoveEndpoint"] = 16256] = "WellKnownRole_Supervisor_RemoveEndpoint";
      MethodIds2[MethodIds2["WellKnownRole_SecurityAdmin_AddApplication"] = 16261] = "WellKnownRole_SecurityAdmin_AddApplication";
      MethodIds2[MethodIds2["WellKnownRole_SecurityAdmin_RemoveApplication"] = 16263] = "WellKnownRole_SecurityAdmin_RemoveApplication";
      MethodIds2[MethodIds2["WellKnownRole_SecurityAdmin_AddEndpoint"] = 16265] = "WellKnownRole_SecurityAdmin_AddEndpoint";
      MethodIds2[MethodIds2["WellKnownRole_SecurityAdmin_RemoveEndpoint"] = 16267] = "WellKnownRole_SecurityAdmin_RemoveEndpoint";
      MethodIds2[MethodIds2["WellKnownRole_ConfigureAdmin_AddApplication"] = 16272] = "WellKnownRole_ConfigureAdmin_AddApplication";
      MethodIds2[MethodIds2["WellKnownRole_ConfigureAdmin_RemoveApplication"] = 16274] = "WellKnownRole_ConfigureAdmin_RemoveApplication";
      MethodIds2[MethodIds2["WellKnownRole_ConfigureAdmin_AddEndpoint"] = 16276] = "WellKnownRole_ConfigureAdmin_AddEndpoint";
      MethodIds2[MethodIds2["WellKnownRole_ConfigureAdmin_RemoveEndpoint"] = 16278] = "WellKnownRole_ConfigureAdmin_RemoveEndpoint";
      MethodIds2[MethodIds2["ServerType_ServerCapabilities_RoleSet_AddRole"] = 16290] = "ServerType_ServerCapabilities_RoleSet_AddRole";
      MethodIds2[MethodIds2["ServerType_ServerCapabilities_RoleSet_RemoveRole"] = 16293] = "ServerType_ServerCapabilities_RoleSet_RemoveRole";
      MethodIds2[MethodIds2["ServerCapabilitiesType_RoleSet_AddRole"] = 16296] = "ServerCapabilitiesType_RoleSet_AddRole";
      MethodIds2[MethodIds2["ServerCapabilitiesType_RoleSet_RemoveRole"] = 16299] = "ServerCapabilitiesType_RoleSet_RemoveRole";
      MethodIds2[MethodIds2["Server_ServerCapabilities_RoleSet_AddRole"] = 16301] = "Server_ServerCapabilities_RoleSet_AddRole";
      MethodIds2[MethodIds2["Server_ServerCapabilities_RoleSet_RemoveRole"] = 16304] = "Server_ServerCapabilities_RoleSet_RemoveRole";
      MethodIds2[MethodIds2["FileSystem_CreateDirectory"] = 16348] = "FileSystem_CreateDirectory";
      MethodIds2[MethodIds2["FileSystem_CreateFile"] = 16351] = "FileSystem_CreateFile";
      MethodIds2[MethodIds2["FileSystem_DeleteFileSystemObject"] = 16354] = "FileSystem_DeleteFileSystemObject";
      MethodIds2[MethodIds2["FileSystem_MoveOrCopy"] = 16356] = "FileSystem_MoveOrCopy";
      MethodIds2[MethodIds2["AlarmConditionType_Silence"] = 16402] = "AlarmConditionType_Silence";
      MethodIds2[MethodIds2["AlarmConditionType_Suppress"] = 16403] = "AlarmConditionType_Suppress";
      MethodIds2[MethodIds2["PublishSubscribeType_AddConnection"] = 16598] = "PublishSubscribeType_AddConnection";
      MethodIds2[MethodIds2["PublishSubscribeType_PublishedDataSets_AddPublishedDataItemsTemplate"] = 16601] = "PublishSubscribeType_PublishedDataSets_AddPublishedDataItemsTemplate";
      MethodIds2[MethodIds2["PublishSubscribeType_PublishedDataSets_AddPublishedEventsTemplate"] = 16639] = "PublishSubscribeType_PublishedDataSets_AddPublishedEventsTemplate";
      MethodIds2[MethodIds2["PublishSubscribeType_PublishedDataSets_AddDataSetFolder"] = 16651] = "PublishSubscribeType_PublishedDataSets_AddDataSetFolder";
      MethodIds2[MethodIds2["PublishSubscribeType_PublishedDataSets_RemoveDataSetFolder"] = 16680] = "PublishSubscribeType_PublishedDataSets_RemoveDataSetFolder";
      MethodIds2[MethodIds2["AddConnectionMethodType"] = 16691] = "AddConnectionMethodType";
      MethodIds2[MethodIds2["DataSetFolderType_AddPublishedDataItemsTemplate"] = 16935] = "DataSetFolderType_AddPublishedDataItemsTemplate";
      MethodIds2[MethodIds2["DataSetFolderType_AddPublishedEventsTemplate"] = 16960] = "DataSetFolderType_AddPublishedEventsTemplate";
      MethodIds2[MethodIds2["DataSetFolderType_AddDataSetFolder"] = 16994] = "DataSetFolderType_AddDataSetFolder";
      MethodIds2[MethodIds2["DataSetFolderType_RemoveDataSetFolder"] = 16997] = "DataSetFolderType_RemoveDataSetFolder";
      MethodIds2[MethodIds2["AddPublishedDataItemsTemplateMethodType"] = 17030] = "AddPublishedDataItemsTemplateMethodType";
      MethodIds2[MethodIds2["AddPublishedEventsTemplateMethodType"] = 17033] = "AddPublishedEventsTemplateMethodType";
      MethodIds2[MethodIds2["AddDataSetFolderMethodType"] = 17067] = "AddDataSetFolderMethodType";
      MethodIds2[MethodIds2["RemoveDataSetFolderMethodType"] = 17079] = "RemoveDataSetFolderMethodType";
      MethodIds2[MethodIds2["PublishSubscribeType_SetSecurityKeys"] = 17296] = "PublishSubscribeType_SetSecurityKeys";
      MethodIds2[MethodIds2["SetSecurityKeysMethodType"] = 17298] = "SetSecurityKeysMethodType";
      MethodIds2[MethodIds2["PublishSubscribe_SetSecurityKeys"] = 17364] = "PublishSubscribe_SetSecurityKeys";
      MethodIds2[MethodIds2["PublishSubscribe_AddConnection"] = 17366] = "PublishSubscribe_AddConnection";
      MethodIds2[MethodIds2["PublishSubscribe_RemoveConnection"] = 17369] = "PublishSubscribe_RemoveConnection";
      MethodIds2[MethodIds2["PublishSubscribe_PublishedDataSets_AddPublishedDataItems"] = 17372] = "PublishSubscribe_PublishedDataSets_AddPublishedDataItems";
      MethodIds2[MethodIds2["PublishSubscribe_PublishedDataSets_AddPublishedEvents"] = 17375] = "PublishSubscribe_PublishedDataSets_AddPublishedEvents";
      MethodIds2[MethodIds2["PublishSubscribe_PublishedDataSets_AddPublishedDataItemsTemplate"] = 17378] = "PublishSubscribe_PublishedDataSets_AddPublishedDataItemsTemplate";
      MethodIds2[MethodIds2["PublishSubscribe_PublishedDataSets_AddPublishedEventsTemplate"] = 17381] = "PublishSubscribe_PublishedDataSets_AddPublishedEventsTemplate";
      MethodIds2[MethodIds2["PublishSubscribe_PublishedDataSets_RemovePublishedDataSet"] = 17384] = "PublishSubscribe_PublishedDataSets_RemovePublishedDataSet";
      MethodIds2[MethodIds2["DataSetReaderType_CreateTargetVariables"] = 17386] = "DataSetReaderType_CreateTargetVariables";
      MethodIds2[MethodIds2["DataSetReaderType_CreateDataSetMirror"] = 17389] = "DataSetReaderType_CreateDataSetMirror";
      MethodIds2[MethodIds2["DataSetReaderTypeCreateTargetVariablesMethodType"] = 17392] = "DataSetReaderTypeCreateTargetVariablesMethodType";
      MethodIds2[MethodIds2["DataSetReaderTypeCreateDataSetMirrorMethodType"] = 17395] = "DataSetReaderTypeCreateDataSetMirrorMethodType";
      MethodIds2[MethodIds2["PublishSubscribe_PublishedDataSets_AddDataSetFolder"] = 17398] = "PublishSubscribe_PublishedDataSets_AddDataSetFolder";
      MethodIds2[MethodIds2["PublishSubscribe_PublishedDataSets_RemoveDataSetFolder"] = 17403] = "PublishSubscribe_PublishedDataSets_RemoveDataSetFolder";
      MethodIds2[MethodIds2["PublishSubscribe_Status_Enable"] = 17407] = "PublishSubscribe_Status_Enable";
      MethodIds2[MethodIds2["PublishSubscribe_Status_Disable"] = 17408] = "PublishSubscribe_Status_Disable";
      MethodIds2[MethodIds2["PublishSubscribe_Diagnostics_Reset"] = 17421] = "PublishSubscribe_Diagnostics_Reset";
      MethodIds2[MethodIds2["PubSubConnectionType_AddWriterGroup"] = 17427] = "PubSubConnectionType_AddWriterGroup";
      MethodIds2[MethodIds2["PubSubConnectionType_AddReaderGroup"] = 17465] = "PubSubConnectionType_AddReaderGroup";
      MethodIds2[MethodIds2["KeyCredentialConfigurationFolderType_CreateCredential"] = 17522] = "KeyCredentialConfigurationFolderType_CreateCredential";
      MethodIds2[MethodIds2["KeyCredentialConfiguration_CreateCredential"] = 17528] = "KeyCredentialConfiguration_CreateCredential";
      MethodIds2[MethodIds2["GetEncryptingKeyMethodType"] = 17531] = "GetEncryptingKeyMethodType";
      MethodIds2[MethodIds2["KeyCredentialConfigurationType_GetEncryptingKey"] = 17534] = "KeyCredentialConfigurationType_GetEncryptingKey";
      MethodIds2[MethodIds2["PubSubConnectionTypeAddWriterGroupMethodType"] = 17561] = "PubSubConnectionTypeAddWriterGroupMethodType";
      MethodIds2[MethodIds2["PubSubConnectionAddReaderGroupGroupMethodType"] = 17630] = "PubSubConnectionAddReaderGroupGroupMethodType";
      MethodIds2[MethodIds2["WriterGroupType_Diagnostics_Reset"] = 17824] = "WriterGroupType_Diagnostics_Reset";
      MethodIds2[MethodIds2["AlarmConditionType_Unsuppress"] = 17868] = "AlarmConditionType_Unsuppress";
      MethodIds2[MethodIds2["AlarmConditionType_RemoveFromService"] = 17869] = "AlarmConditionType_RemoveFromService";
      MethodIds2[MethodIds2["AlarmConditionType_PlaceInService"] = 17870] = "AlarmConditionType_PlaceInService";
      MethodIds2[MethodIds2["WriterGroupType_AddDataSetWriter"] = 17969] = "WriterGroupType_AddDataSetWriter";
      MethodIds2[MethodIds2["WriterGroupType_RemoveDataSetWriter"] = 17992] = "WriterGroupType_RemoveDataSetWriter";
      MethodIds2[MethodIds2["PubSubGroupTypeAddWriterMethodType"] = 17994] = "PubSubGroupTypeAddWriterMethodType";
      MethodIds2[MethodIds2["KeyCredentialConfigurationType_UpdateCredential"] = 18006] = "KeyCredentialConfigurationType_UpdateCredential";
      MethodIds2[MethodIds2["KeyCredentialConfigurationType_DeleteCredential"] = 18008] = "KeyCredentialConfigurationType_DeleteCredential";
      MethodIds2[MethodIds2["KeyCredentialUpdateMethodType"] = 18009] = "KeyCredentialUpdateMethodType";
      MethodIds2[MethodIds2["AlarmConditionType_Reset"] = 18199] = "AlarmConditionType_Reset";
      MethodIds2[MethodIds2["AlarmMetricsType_Reset"] = 18666] = "AlarmMetricsType_Reset";
      MethodIds2[MethodIds2["PublishSubscribeType_Diagnostics_Reset"] = 18727] = "PublishSubscribeType_Diagnostics_Reset";
      MethodIds2[MethodIds2["PubSubConnectionType_Diagnostics_Reset"] = 19253] = "PubSubConnectionType_Diagnostics_Reset";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_Disable"] = 19483] = "CertificateGroupType_CertificateExpired_Disable";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_Enable"] = 19484] = "CertificateGroupType_CertificateExpired_Enable";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_AddComment"] = 19485] = "CertificateGroupType_CertificateExpired_AddComment";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_Acknowledge"] = 19505] = "CertificateGroupType_CertificateExpired_Acknowledge";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_Confirm"] = 19507] = "CertificateGroupType_CertificateExpired_Confirm";
      MethodIds2[MethodIds2["DataSetWriterType_Diagnostics_Reset"] = 19562] = "DataSetWriterType_Diagnostics_Reset";
      MethodIds2[MethodIds2["DataSetReaderType_Diagnostics_Reset"] = 19621] = "DataSetReaderType_Diagnostics_Reset";
      MethodIds2[MethodIds2["PubSubDiagnosticsType_Reset"] = 19689] = "PubSubDiagnosticsType_Reset";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_ShelvingState_TimedShelve"] = 20097] = "CertificateGroupType_CertificateExpired_ShelvingState_TimedShelve";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_ShelvingState_Unshelve"] = 20099] = "CertificateGroupType_CertificateExpired_ShelvingState_Unshelve";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_ShelvingState_OneShotShelve"] = 20100] = "CertificateGroupType_CertificateExpired_ShelvingState_OneShotShelve";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_Silence"] = 20132] = "CertificateGroupType_CertificateExpired_Silence";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_Suppress"] = 20133] = "CertificateGroupType_CertificateExpired_Suppress";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_Unsuppress"] = 20134] = "CertificateGroupType_CertificateExpired_Unsuppress";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_RemoveFromService"] = 20135] = "CertificateGroupType_CertificateExpired_RemoveFromService";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_PlaceInService"] = 20136] = "CertificateGroupType_CertificateExpired_PlaceInService";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_Reset"] = 20137] = "CertificateGroupType_CertificateExpired_Reset";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_Disable"] = 20176] = "CertificateGroupType_TrustListOutOfDate_Disable";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_Enable"] = 20177] = "CertificateGroupType_TrustListOutOfDate_Enable";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_AddComment"] = 20178] = "CertificateGroupType_TrustListOutOfDate_AddComment";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_Acknowledge"] = 20198] = "CertificateGroupType_TrustListOutOfDate_Acknowledge";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_Confirm"] = 20200] = "CertificateGroupType_TrustListOutOfDate_Confirm";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_ShelvingState_TimedShelve"] = 20245] = "CertificateGroupType_TrustListOutOfDate_ShelvingState_TimedShelve";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_ShelvingState_Unshelve"] = 20247] = "CertificateGroupType_TrustListOutOfDate_ShelvingState_Unshelve";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_ShelvingState_OneShotShelve"] = 20248] = "CertificateGroupType_TrustListOutOfDate_ShelvingState_OneShotShelve";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_Silence"] = 20280] = "CertificateGroupType_TrustListOutOfDate_Silence";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_Suppress"] = 20281] = "CertificateGroupType_TrustListOutOfDate_Suppress";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_Unsuppress"] = 20282] = "CertificateGroupType_TrustListOutOfDate_Unsuppress";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_RemoveFromService"] = 20283] = "CertificateGroupType_TrustListOutOfDate_RemoveFromService";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_PlaceInService"] = 20284] = "CertificateGroupType_TrustListOutOfDate_PlaceInService";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_Reset"] = 20285] = "CertificateGroupType_TrustListOutOfDate_Reset";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Disable"] = 20324] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Disable";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Enable"] = 20325] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Enable";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AddComment"] = 20326] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AddComment";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Acknowledge"] = 20346] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Acknowledge";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Confirm"] = 20348] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Confirm";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve"] = 20393] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_Unshelve"] = 20395] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_Unshelve";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_OneShotShelve"] = 20396] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_OneShotShelve";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Silence"] = 20430] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Silence";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Suppress"] = 20431] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Suppress";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Unsuppress"] = 20432] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Unsuppress";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_RemoveFromService"] = 20433] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_RemoveFromService";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_PlaceInService"] = 20434] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_PlaceInService";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Reset"] = 20435] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Reset";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Disable"] = 20474] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Disable";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Enable"] = 20475] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Enable";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AddComment"] = 20476] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AddComment";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Acknowledge"] = 20496] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Acknowledge";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Confirm"] = 20498] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Confirm";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve"] = 20543] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_Unshelve"] = 20545] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_Unshelve";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_OneShotShelve"] = 20546] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_OneShotShelve";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Silence"] = 20578] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Silence";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Suppress"] = 20579] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Suppress";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Unsuppress"] = 20580] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Unsuppress";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_RemoveFromService"] = 20581] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_RemoveFromService";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_PlaceInService"] = 20582] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_PlaceInService";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Reset"] = 20583] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Reset";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Disable"] = 20622] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Disable";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Enable"] = 20623] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Enable";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AddComment"] = 20624] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AddComment";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Acknowledge"] = 20644] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Acknowledge";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Confirm"] = 20646] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Confirm";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve"] = 20691] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_Unshelve"] = 20693] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_Unshelve";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_OneShotShelve"] = 20694] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_OneShotShelve";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Silence"] = 20726] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Silence";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Suppress"] = 20727] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Suppress";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Unsuppress"] = 20728] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Unsuppress";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_RemoveFromService"] = 20729] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_RemoveFromService";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_PlaceInService"] = 20730] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_PlaceInService";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Reset"] = 20731] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Reset";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Disable"] = 20770] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Disable";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Enable"] = 20771] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Enable";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AddComment"] = 20772] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AddComment";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Acknowledge"] = 20792] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Acknowledge";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Confirm"] = 20794] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Confirm";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve"] = 20839] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_Unshelve"] = 20841] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_Unshelve";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_OneShotShelve"] = 20842] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_OneShotShelve";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Silence"] = 20874] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Silence";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Suppress"] = 20875] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Suppress";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Unsuppress"] = 20876] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Unsuppress";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_RemoveFromService"] = 20877] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_RemoveFromService";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_PlaceInService"] = 20878] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_PlaceInService";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Reset"] = 20879] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Reset";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Disable"] = 20918] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Disable";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Enable"] = 20919] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Enable";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AddComment"] = 20920] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AddComment";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Acknowledge"] = 20940] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Acknowledge";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Confirm"] = 20942] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Confirm";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve"] = 20987] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_Unshelve"] = 20989] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_Unshelve";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_OneShotShelve"] = 20990] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_OneShotShelve";
      MethodIds2[MethodIds2["ReaderGroupType_Diagnostics_Reset"] = 21027] = "ReaderGroupType_Diagnostics_Reset";
      MethodIds2[MethodIds2["ReaderGroupType_AddDataSetReader"] = 21082] = "ReaderGroupType_AddDataSetReader";
      MethodIds2[MethodIds2["ReaderGroupType_RemoveDataSetReader"] = 21085] = "ReaderGroupType_RemoveDataSetReader";
      MethodIds2[MethodIds2["PubSubGroupTypeAddReaderMethodType"] = 21087] = "PubSubGroupTypeAddReaderMethodType";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Silence"] = 21225] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Silence";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Suppress"] = 21226] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Suppress";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Unsuppress"] = 21227] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Unsuppress";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_RemoveFromService"] = 21228] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_RemoveFromService";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_PlaceInService"] = 21229] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_PlaceInService";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Reset"] = 21230] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Reset";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Disable"] = 21269] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Disable";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Enable"] = 21270] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Enable";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AddComment"] = 21271] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AddComment";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Acknowledge"] = 21291] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Acknowledge";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Confirm"] = 21293] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Confirm";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve"] = 21338] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_Unshelve"] = 21340] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_Unshelve";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_OneShotShelve"] = 21341] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_OneShotShelve";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Silence"] = 21373] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Silence";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Suppress"] = 21374] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Suppress";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Unsuppress"] = 21375] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Unsuppress";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_RemoveFromService"] = 21376] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_RemoveFromService";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_PlaceInService"] = 21377] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_PlaceInService";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Reset"] = 21378] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Reset";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Disable"] = 21713] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Disable";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Enable"] = 21714] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Enable";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AddComment"] = 21715] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AddComment";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Acknowledge"] = 21735] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Acknowledge";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Confirm"] = 21737] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Confirm";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve"] = 21782] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_Unshelve"] = 21784] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_Unshelve";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_OneShotShelve"] = 21785] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_OneShotShelve";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Silence"] = 21817] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Silence";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Suppress"] = 21818] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Suppress";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Unsuppress"] = 21819] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Unsuppress";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_RemoveFromService"] = 21820] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_RemoveFromService";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_PlaceInService"] = 21821] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_PlaceInService";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Reset"] = 21822] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Reset";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Disable"] = 21861] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Disable";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Enable"] = 21862] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Enable";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AddComment"] = 21863] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AddComment";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Acknowledge"] = 21883] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Acknowledge";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Confirm"] = 21885] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Confirm";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve"] = 21930] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_Unshelve"] = 21932] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_Unshelve";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_OneShotShelve"] = 21933] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_OneShotShelve";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Silence"] = 21965] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Silence";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Suppress"] = 21966] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Suppress";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Unsuppress"] = 21967] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Unsuppress";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_RemoveFromService"] = 21968] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_RemoveFromService";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_PlaceInService"] = 21969] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_PlaceInService";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Reset"] = 21970] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Reset";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Disable"] = 22009] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Disable";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Enable"] = 22010] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Enable";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AddComment"] = 22011] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AddComment";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Acknowledge"] = 22031] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Acknowledge";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Confirm"] = 22033] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Confirm";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve"] = 22078] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_Unshelve"] = 22080] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_Unshelve";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_OneShotShelve"] = 22081] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_OneShotShelve";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Silence"] = 22113] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Silence";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Suppress"] = 22114] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Suppress";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Unsuppress"] = 22115] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Unsuppress";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_RemoveFromService"] = 22116] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_RemoveFromService";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_PlaceInService"] = 22117] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_PlaceInService";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Reset"] = 22118] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Reset";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Disable"] = 22157] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Disable";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Enable"] = 22158] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Enable";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AddComment"] = 22159] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AddComment";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Acknowledge"] = 22179] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Acknowledge";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Confirm"] = 22181] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Confirm";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve"] = 22226] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_Unshelve"] = 22228] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_Unshelve";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_OneShotShelve"] = 22229] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_OneShotShelve";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Silence"] = 22261] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Silence";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Suppress"] = 22262] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Suppress";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Unsuppress"] = 22263] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Unsuppress";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_RemoveFromService"] = 22264] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_RemoveFromService";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_PlaceInService"] = 22265] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_PlaceInService";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Reset"] = 22266] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Reset";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Disable"] = 22305] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Disable";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Enable"] = 22306] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Enable";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AddComment"] = 22307] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AddComment";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Acknowledge"] = 22327] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Acknowledge";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Confirm"] = 22329] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Confirm";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve"] = 22374] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_Unshelve"] = 22376] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_Unshelve";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_OneShotShelve"] = 22377] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_OneShotShelve";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Silence"] = 22409] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Silence";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Suppress"] = 22410] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Suppress";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Unsuppress"] = 22411] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Unsuppress";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_RemoveFromService"] = 22412] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_RemoveFromService";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_PlaceInService"] = 22413] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_PlaceInService";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Reset"] = 22414] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Reset";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Disable"] = 22453] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Disable";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Enable"] = 22454] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Enable";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AddComment"] = 22455] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AddComment";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Acknowledge"] = 22475] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Acknowledge";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Confirm"] = 22477] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Confirm";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve"] = 22522] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_Unshelve"] = 22524] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_Unshelve";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_OneShotShelve"] = 22525] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_OneShotShelve";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Silence"] = 22557] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Silence";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Suppress"] = 22558] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Suppress";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Unsuppress"] = 22559] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Unsuppress";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_RemoveFromService"] = 22560] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_RemoveFromService";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_PlaceInService"] = 22561] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_PlaceInService";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Reset"] = 22562] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Reset";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Disable"] = 22601] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Disable";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Enable"] = 22602] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Enable";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AddComment"] = 22603] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AddComment";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Acknowledge"] = 22623] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Acknowledge";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Confirm"] = 22625] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Confirm";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve"] = 22670] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_Unshelve"] = 22672] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_Unshelve";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_OneShotShelve"] = 22673] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_OneShotShelve";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Silence"] = 22705] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Silence";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Suppress"] = 22706] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Suppress";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Unsuppress"] = 22707] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Unsuppress";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_RemoveFromService"] = 22708] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_RemoveFromService";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_PlaceInService"] = 22709] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_PlaceInService";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Reset"] = 22710] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Reset";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Disable"] = 22749] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Disable";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Enable"] = 22750] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Enable";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AddComment"] = 22751] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AddComment";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Acknowledge"] = 22771] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Acknowledge";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Confirm"] = 22773] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Confirm";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve"] = 22818] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_Unshelve"] = 22820] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_Unshelve";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_OneShotShelve"] = 22821] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_OneShotShelve";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Silence"] = 22853] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Silence";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Suppress"] = 22854] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Suppress";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Unsuppress"] = 22855] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Unsuppress";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_RemoveFromService"] = 22856] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_RemoveFromService";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_PlaceInService"] = 22857] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_PlaceInService";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Reset"] = 22858] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Reset";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Disable"] = 22897] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Disable";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Enable"] = 22898] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Enable";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AddComment"] = 22899] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AddComment";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Acknowledge"] = 22919] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Acknowledge";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Confirm"] = 22921] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Confirm";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve"] = 22966] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_Unshelve"] = 22968] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_Unshelve";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_OneShotShelve"] = 22969] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_OneShotShelve";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Silence"] = 23001] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Silence";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Suppress"] = 23002] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Suppress";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Unsuppress"] = 23003] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Unsuppress";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_RemoveFromService"] = 23004] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_RemoveFromService";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_PlaceInService"] = 23005] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_PlaceInService";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Reset"] = 23006] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Reset";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Disable"] = 23045] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Disable";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Enable"] = 23046] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Enable";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AddComment"] = 23047] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AddComment";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Acknowledge"] = 23067] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Acknowledge";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Confirm"] = 23069] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Confirm";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve"] = 23114] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_Unshelve"] = 23116] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_Unshelve";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_OneShotShelve"] = 23117] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_OneShotShelve";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Silence"] = 23149] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Silence";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Suppress"] = 23150] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Suppress";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Unsuppress"] = 23151] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Unsuppress";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_RemoveFromService"] = 23152] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_RemoveFromService";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_PlaceInService"] = 23153] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_PlaceInService";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Reset"] = 23154] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Reset";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Disable"] = 23193] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Disable";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Enable"] = 23194] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Enable";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AddComment"] = 23195] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AddComment";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Acknowledge"] = 23215] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Acknowledge";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Confirm"] = 23217] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Confirm";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve"] = 23262] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_Unshelve"] = 23264] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_Unshelve";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_OneShotShelve"] = 23265] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_OneShotShelve";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Silence"] = 23297] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Silence";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Suppress"] = 23298] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Suppress";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Unsuppress"] = 23299] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Unsuppress";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_RemoveFromService"] = 23300] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_RemoveFromService";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_PlaceInService"] = 23301] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_PlaceInService";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Reset"] = 23302] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Reset";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Disable"] = 23341] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Disable";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Enable"] = 23342] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Enable";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AddComment"] = 23343] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AddComment";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Acknowledge"] = 23363] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Acknowledge";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Confirm"] = 23365] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Confirm";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve"] = 23410] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_Unshelve"] = 23412] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_Unshelve";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_OneShotShelve"] = 23413] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_OneShotShelve";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Silence"] = 23445] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Silence";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Suppress"] = 23446] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Suppress";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Unsuppress"] = 23447] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Unsuppress";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_RemoveFromService"] = 23448] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_RemoveFromService";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_PlaceInService"] = 23449] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_PlaceInService";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Reset"] = 23450] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Reset";
      MethodIds2[MethodIds2["AliasNameCategoryType_FindAlias"] = 23462] = "AliasNameCategoryType_FindAlias";
      MethodIds2[MethodIds2["FindAliasMethodType"] = 23465] = "FindAliasMethodType";
      MethodIds2[MethodIds2["Aliases_FindAlias"] = 23476] = "Aliases_FindAlias";
      MethodIds2[MethodIds2["TagVariables_FindAlias"] = 23485] = "TagVariables_FindAlias";
      MethodIds2[MethodIds2["Topics_FindAlias"] = 23494] = "Topics_FindAlias";
      MethodIds2[MethodIds2["CertificateGroupType_GetRejectedList"] = 23526] = "CertificateGroupType_GetRejectedList";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_GetRejectedList"] = 23529] = "CertificateGroupFolderType_DefaultApplicationGroup_GetRejectedList";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_GetRejectedList"] = 23531] = "CertificateGroupFolderType_DefaultHttpsGroup_GetRejectedList";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_GetRejectedList"] = 23533] = "CertificateGroupFolderType_DefaultUserTokenGroup_GetRejectedList";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_GetRejectedList"] = 23544] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_GetRejectedList";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_GetRejectedList"] = 23546] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_GetRejectedList";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_GetRejectedList"] = 23548] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_GetRejectedList";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_GetRejectedList"] = 23550] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_GetRejectedList";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_GetRejectedList"] = 23552] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_GetRejectedList";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_GetRejectedList"] = 23554] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_GetRejectedList";
      MethodIds2[MethodIds2["PublishSubscribeType_SubscribedDataSets_AddDataSetFolder"] = 23637] = "PublishSubscribeType_SubscribedDataSets_AddDataSetFolder";
      MethodIds2[MethodIds2["PublishSubscribeType_SubscribedDataSets_RemoveDataSetFolder"] = 23640] = "PublishSubscribeType_SubscribedDataSets_RemoveDataSetFolder";
      MethodIds2[MethodIds2["PublishSubscribe_SubscribedDataSets_AddDataSetFolder"] = 23673] = "PublishSubscribe_SubscribedDataSets_AddDataSetFolder";
      MethodIds2[MethodIds2["PublishSubscribe_SubscribedDataSets_RemoveDataSetFolder"] = 23676] = "PublishSubscribe_SubscribedDataSets_RemoveDataSetFolder";
      MethodIds2[MethodIds2["GetConnectionMethodType"] = 23726] = "GetConnectionMethodType";
      MethodIds2[MethodIds2["ModifyConnectionMethodType"] = 23729] = "ModifyConnectionMethodType";
      MethodIds2[MethodIds2["GetWriterGroupMethodType"] = 23745] = "GetWriterGroupMethodType";
      MethodIds2[MethodIds2["ModifyWriterGroupMethodType"] = 23748] = "ModifyWriterGroupMethodType";
      MethodIds2[MethodIds2["GetReaderGroupMethodType"] = 23767] = "GetReaderGroupMethodType";
      MethodIds2[MethodIds2["ModifyReaderGroupMethodType"] = 23770] = "ModifyReaderGroupMethodType";
      MethodIds2[MethodIds2["GetDataSetWriterMethodType"] = 23779] = "GetDataSetWriterMethodType";
      MethodIds2[MethodIds2["ModifyDataSetWriterMethodType"] = 23781] = "ModifyDataSetWriterMethodType";
      MethodIds2[MethodIds2["GetDataSetReaderMethodType"] = 23790] = "GetDataSetReaderMethodType";
      MethodIds2[MethodIds2["ModifyDataSetReaderMethodType"] = 23792] = "ModifyDataSetReaderMethodType";
      MethodIds2[MethodIds2["SubscribedDataSetFolderType_AddSubscribedDataSet"] = 23811] = "SubscribedDataSetFolderType_AddSubscribedDataSet";
      MethodIds2[MethodIds2["SubscribedDataSetFolderType_RemoveSubscribedDataSet"] = 23814] = "SubscribedDataSetFolderType_RemoveSubscribedDataSet";
      MethodIds2[MethodIds2["SubscribedDataSetFolderType_AddDataSetFolder"] = 23816] = "SubscribedDataSetFolderType_AddDataSetFolder";
      MethodIds2[MethodIds2["SubscribedDataSetFolderType_RemoveDataSetFolder"] = 23819] = "SubscribedDataSetFolderType_RemoveDataSetFolder";
      MethodIds2[MethodIds2["AddSubscribedDataSetMethodType"] = 23821] = "AddSubscribedDataSetMethodType";
      MethodIds2[MethodIds2["RemoveSubscribedDataSetMethodType"] = 23824] = "RemoveSubscribedDataSetMethodType";
      MethodIds2[MethodIds2["PublishSubscribeType_SubscribedDataSets_AddSubscribedDataSet"] = 24004] = "PublishSubscribeType_SubscribedDataSets_AddSubscribedDataSet";
      MethodIds2[MethodIds2["PublishSubscribeType_SubscribedDataSets_RemoveSubscribedDataSet"] = 24007] = "PublishSubscribeType_SubscribedDataSets_RemoveSubscribedDataSet";
      MethodIds2[MethodIds2["PublishSubscribe_SubscribedDataSets_AddSubscribedDataSet"] = 24010] = "PublishSubscribe_SubscribedDataSets_AddSubscribedDataSet";
      MethodIds2[MethodIds2["PublishSubscribe_SubscribedDataSets_RemoveSubscribedDataSet"] = 24013] = "PublishSubscribe_SubscribedDataSets_RemoveSubscribedDataSet";
      MethodIds2[MethodIds2["UserManagementType_AddUser"] = 24269] = "UserManagementType_AddUser";
      MethodIds2[MethodIds2["UserManagementType_ModifyUser"] = 24271] = "UserManagementType_ModifyUser";
      MethodIds2[MethodIds2["UserManagementType_RemoveUser"] = 24273] = "UserManagementType_RemoveUser";
      MethodIds2[MethodIds2["UserManagementType_ChangePassword"] = 24275] = "UserManagementType_ChangePassword";
      MethodIds2[MethodIds2["AddUserMethodType"] = 24282] = "AddUserMethodType";
      MethodIds2[MethodIds2["ModifyUserMethodType"] = 24284] = "ModifyUserMethodType";
      MethodIds2[MethodIds2["RemoveUserMethodType"] = 24286] = "RemoveUserMethodType";
      MethodIds2[MethodIds2["ChangePasswordMethodType"] = 24288] = "ChangePasswordMethodType";
      MethodIds2[MethodIds2["UserManagement_AddUser"] = 24304] = "UserManagement_AddUser";
      MethodIds2[MethodIds2["UserManagement_ModifyUser"] = 24306] = "UserManagement_ModifyUser";
      MethodIds2[MethodIds2["UserManagement_RemoveUser"] = 24308] = "UserManagement_RemoveUser";
      MethodIds2[MethodIds2["UserManagement_ChangePassword"] = 24310] = "UserManagement_ChangePassword";
      MethodIds2[MethodIds2["DialogConditionType_Respond2"] = 24312] = "DialogConditionType_Respond2";
      MethodIds2[MethodIds2["DialogResponse2MethodType"] = 24314] = "DialogResponse2MethodType";
      MethodIds2[MethodIds2["AlarmConditionType_Suppress2"] = 24316] = "AlarmConditionType_Suppress2";
      MethodIds2[MethodIds2["AlarmConditionType_Unsuppress2"] = 24318] = "AlarmConditionType_Unsuppress2";
      MethodIds2[MethodIds2["AlarmConditionType_RemoveFromService2"] = 24320] = "AlarmConditionType_RemoveFromService2";
      MethodIds2[MethodIds2["AlarmConditionType_PlaceInService2"] = 24322] = "AlarmConditionType_PlaceInService2";
      MethodIds2[MethodIds2["AlarmConditionType_Reset2"] = 24324] = "AlarmConditionType_Reset2";
      MethodIds2[MethodIds2["WithCommentMethodType"] = 24326] = "WithCommentMethodType";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_Suppress2"] = 24518] = "CertificateGroupType_CertificateExpired_Suppress2";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_Unsuppress2"] = 24520] = "CertificateGroupType_CertificateExpired_Unsuppress2";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_RemoveFromService2"] = 24522] = "CertificateGroupType_CertificateExpired_RemoveFromService2";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_PlaceInService2"] = 24524] = "CertificateGroupType_CertificateExpired_PlaceInService2";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_Reset2"] = 24526] = "CertificateGroupType_CertificateExpired_Reset2";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_Suppress2"] = 24528] = "CertificateGroupType_TrustListOutOfDate_Suppress2";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_Unsuppress2"] = 24530] = "CertificateGroupType_TrustListOutOfDate_Unsuppress2";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_RemoveFromService2"] = 24532] = "CertificateGroupType_TrustListOutOfDate_RemoveFromService2";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_PlaceInService2"] = 24534] = "CertificateGroupType_TrustListOutOfDate_PlaceInService2";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_Reset2"] = 24536] = "CertificateGroupType_TrustListOutOfDate_Reset2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Suppress2"] = 24538] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Suppress2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Unsuppress2"] = 24540] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Unsuppress2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_RemoveFromService2"] = 24542] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_RemoveFromService2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_PlaceInService2"] = 24544] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_PlaceInService2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Reset2"] = 24546] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Reset2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Suppress2"] = 24548] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Suppress2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Unsuppress2"] = 24550] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Unsuppress2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_RemoveFromService2"] = 24552] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_RemoveFromService2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_PlaceInService2"] = 24554] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_PlaceInService2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Reset2"] = 24556] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Reset2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Suppress2"] = 24558] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Suppress2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Unsuppress2"] = 24560] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Unsuppress2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_RemoveFromService2"] = 24562] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_RemoveFromService2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_PlaceInService2"] = 24564] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_PlaceInService2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Reset2"] = 24566] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Reset2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Suppress2"] = 24568] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Suppress2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Unsuppress2"] = 24570] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Unsuppress2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_RemoveFromService2"] = 24572] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_RemoveFromService2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_PlaceInService2"] = 24574] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_PlaceInService2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Reset2"] = 24576] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Reset2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Suppress2"] = 24578] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Suppress2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Unsuppress2"] = 24580] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Unsuppress2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_RemoveFromService2"] = 24582] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_RemoveFromService2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_PlaceInService2"] = 24584] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_PlaceInService2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Reset2"] = 24586] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Reset2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Suppress2"] = 24588] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Suppress2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Unsuppress2"] = 24590] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Unsuppress2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_RemoveFromService2"] = 24592] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_RemoveFromService2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_PlaceInService2"] = 24594] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_PlaceInService2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Reset2"] = 24596] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Reset2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Suppress2"] = 24618] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Suppress2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Unsuppress2"] = 24620] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Unsuppress2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_RemoveFromService2"] = 24622] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_RemoveFromService2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_PlaceInService2"] = 24624] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_PlaceInService2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Reset2"] = 24626] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Reset2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Suppress2"] = 24628] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Suppress2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Unsuppress2"] = 24630] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Unsuppress2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_RemoveFromService2"] = 24632] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_RemoveFromService2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_PlaceInService2"] = 24634] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_PlaceInService2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Reset2"] = 24636] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Reset2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Suppress2"] = 24638] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Suppress2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Unsuppress2"] = 24640] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Unsuppress2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_RemoveFromService2"] = 24642] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_RemoveFromService2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_PlaceInService2"] = 24644] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_PlaceInService2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Reset2"] = 24646] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Reset2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Suppress2"] = 24648] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Suppress2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Unsuppress2"] = 24650] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Unsuppress2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_RemoveFromService2"] = 24652] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_RemoveFromService2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_PlaceInService2"] = 24654] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_PlaceInService2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Reset2"] = 24656] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Reset2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Suppress2"] = 24658] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Suppress2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Unsuppress2"] = 24660] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Unsuppress2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_RemoveFromService2"] = 24662] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_RemoveFromService2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_PlaceInService2"] = 24664] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_PlaceInService2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Reset2"] = 24666] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Reset2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Suppress2"] = 24668] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Suppress2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Unsuppress2"] = 24670] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Unsuppress2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_RemoveFromService2"] = 24672] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_RemoveFromService2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_PlaceInService2"] = 24674] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_PlaceInService2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Reset2"] = 24676] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Reset2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Suppress2"] = 24678] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Suppress2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Unsuppress2"] = 24680] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Unsuppress2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_RemoveFromService2"] = 24682] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_RemoveFromService2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_PlaceInService2"] = 24684] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_PlaceInService2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Reset2"] = 24686] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Reset2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Suppress2"] = 24688] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Suppress2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Unsuppress2"] = 24690] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Unsuppress2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_RemoveFromService2"] = 24692] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_RemoveFromService2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_PlaceInService2"] = 24694] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_PlaceInService2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Reset2"] = 24696] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Reset2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Suppress2"] = 24698] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Suppress2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Unsuppress2"] = 24700] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Unsuppress2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_RemoveFromService2"] = 24702] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_RemoveFromService2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_PlaceInService2"] = 24704] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_PlaceInService2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Reset2"] = 24706] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Reset2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Suppress2"] = 24708] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Suppress2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Unsuppress2"] = 24710] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Unsuppress2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_RemoveFromService2"] = 24712] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_RemoveFromService2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_PlaceInService2"] = 24714] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_PlaceInService2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Reset2"] = 24716] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Reset2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Suppress2"] = 24718] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Suppress2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Unsuppress2"] = 24720] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Unsuppress2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_RemoveFromService2"] = 24722] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_RemoveFromService2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_PlaceInService2"] = 24724] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_PlaceInService2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Reset2"] = 24726] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Reset2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Suppress2"] = 24728] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Suppress2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Unsuppress2"] = 24730] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Unsuppress2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_RemoveFromService2"] = 24732] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_RemoveFromService2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_PlaceInService2"] = 24734] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_PlaceInService2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Reset2"] = 24736] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Reset2";
      MethodIds2[MethodIds2["AlarmConditionType_ShelvingState_TimedShelve2"] = 24738] = "AlarmConditionType_ShelvingState_TimedShelve2";
      MethodIds2[MethodIds2["AlarmConditionType_ShelvingState_Unshelve2"] = 24740] = "AlarmConditionType_ShelvingState_Unshelve2";
      MethodIds2[MethodIds2["AlarmConditionType_ShelvingState_OneShotShelve2"] = 24742] = "AlarmConditionType_ShelvingState_OneShotShelve2";
      MethodIds2[MethodIds2["AlarmConditionType_GetGroupMemberships"] = 24744] = "AlarmConditionType_GetGroupMemberships";
      MethodIds2[MethodIds2["GetGroupMembershipsMethodType"] = 24746] = "GetGroupMembershipsMethodType";
      MethodIds2[MethodIds2["ShelvedStateMachineType_TimedShelve2"] = 24756] = "ShelvedStateMachineType_TimedShelve2";
      MethodIds2[MethodIds2["ShelvedStateMachineType_Unshelve2"] = 24758] = "ShelvedStateMachineType_Unshelve2";
      MethodIds2[MethodIds2["ShelvedStateMachineType_OneShotShelve2"] = 24760] = "ShelvedStateMachineType_OneShotShelve2";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_ShelvingState_TimedShelve2"] = 24978] = "CertificateGroupType_CertificateExpired_ShelvingState_TimedShelve2";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_ShelvingState_Unshelve2"] = 24980] = "CertificateGroupType_CertificateExpired_ShelvingState_Unshelve2";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_ShelvingState_OneShotShelve2"] = 24982] = "CertificateGroupType_CertificateExpired_ShelvingState_OneShotShelve2";
      MethodIds2[MethodIds2["CertificateGroupType_CertificateExpired_GetGroupMemberships"] = 24984] = "CertificateGroupType_CertificateExpired_GetGroupMemberships";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_ShelvingState_TimedShelve2"] = 24986] = "CertificateGroupType_TrustListOutOfDate_ShelvingState_TimedShelve2";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_ShelvingState_Unshelve2"] = 24988] = "CertificateGroupType_TrustListOutOfDate_ShelvingState_Unshelve2";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_ShelvingState_OneShotShelve2"] = 24990] = "CertificateGroupType_TrustListOutOfDate_ShelvingState_OneShotShelve2";
      MethodIds2[MethodIds2["CertificateGroupType_TrustListOutOfDate_GetGroupMemberships"] = 24992] = "CertificateGroupType_TrustListOutOfDate_GetGroupMemberships";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve2"] = 24994] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_Unshelve2"] = 24996] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_Unshelve2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_OneShotShelve2"] = 24998] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_OneShotShelve2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_GetGroupMemberships"] = 25e3] = "CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_GetGroupMemberships";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve2"] = 25002] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_Unshelve2"] = 25004] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_Unshelve2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2"] = 25006] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_GetGroupMemberships"] = 25008] = "CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_GetGroupMemberships";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve2"] = 25010] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_Unshelve2"] = 25012] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_Unshelve2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_OneShotShelve2"] = 25014] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_OneShotShelve2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_GetGroupMemberships"] = 25016] = "CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_GetGroupMemberships";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve2"] = 25018] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_Unshelve2"] = 25020] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_Unshelve2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2"] = 25022] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_GetGroupMemberships"] = 25024] = "CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_GetGroupMemberships";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve2"] = 25026] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_Unshelve2"] = 25028] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_Unshelve2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_OneShotShelve2"] = 25030] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_OneShotShelve2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_GetGroupMemberships"] = 25032] = "CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_GetGroupMemberships";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve2"] = 25034] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_Unshelve2"] = 25036] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_Unshelve2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2"] = 25038] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2";
      MethodIds2[MethodIds2["CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_GetGroupMemberships"] = 25040] = "CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_GetGroupMemberships";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve2"] = 25058] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_Unshelve2"] = 25060] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_Unshelve2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_OneShotShelve2"] = 25062] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_OneShotShelve2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_GetGroupMemberships"] = 25064] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_GetGroupMemberships";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve2"] = 25066] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_Unshelve2"] = 25068] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_Unshelve2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2"] = 25070] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_GetGroupMemberships"] = 25072] = "ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_GetGroupMemberships";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve2"] = 25074] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_Unshelve2"] = 25076] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_Unshelve2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_OneShotShelve2"] = 25078] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_OneShotShelve2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_GetGroupMemberships"] = 25080] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_GetGroupMemberships";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve2"] = 25082] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_Unshelve2"] = 25084] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_Unshelve2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2"] = 25086] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_GetGroupMemberships"] = 25088] = "ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_GetGroupMemberships";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve2"] = 25090] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_Unshelve2"] = 25092] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_Unshelve2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_OneShotShelve2"] = 25094] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_OneShotShelve2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_GetGroupMemberships"] = 25096] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_GetGroupMemberships";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve2"] = 25098] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_Unshelve2"] = 25100] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_Unshelve2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2"] = 25102] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2";
      MethodIds2[MethodIds2["ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_GetGroupMemberships"] = 25104] = "ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_GetGroupMemberships";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve2"] = 25106] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_Unshelve2"] = 25108] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_Unshelve2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_OneShotShelve2"] = 25110] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_OneShotShelve2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_GetGroupMemberships"] = 25112] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_GetGroupMemberships";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve2"] = 25114] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_Unshelve2"] = 25116] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_Unshelve2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2"] = 25118] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_GetGroupMemberships"] = 25120] = "ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_GetGroupMemberships";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve2"] = 25122] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_Unshelve2"] = 25124] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_Unshelve2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_OneShotShelve2"] = 25126] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_OneShotShelve2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_GetGroupMemberships"] = 25128] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_GetGroupMemberships";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve2"] = 25130] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_Unshelve2"] = 25132] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_Unshelve2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2"] = 25134] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_GetGroupMemberships"] = 25136] = "ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_GetGroupMemberships";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve2"] = 25138] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_Unshelve2"] = 25140] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_Unshelve2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_OneShotShelve2"] = 25142] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_OneShotShelve2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_GetGroupMemberships"] = 25144] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_GetGroupMemberships";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve2"] = 25146] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_Unshelve2"] = 25148] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_Unshelve2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2"] = 25150] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_OneShotShelve2";
      MethodIds2[MethodIds2["ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_GetGroupMemberships"] = 25152] = "ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_GetGroupMemberships";
      MethodIds2[MethodIds2["TimedShelve2MethodType"] = 25157] = "TimedShelve2MethodType";
      MethodIds2[MethodIds2["PriorityMappingTableType_AddPriorityMappingEntry"] = 25229] = "PriorityMappingTableType_AddPriorityMappingEntry";
      MethodIds2[MethodIds2["PriorityMappingTableType_DeletePriorityMappingEntry"] = 25231] = "PriorityMappingTableType_DeletePriorityMappingEntry";
      MethodIds2[MethodIds2["AddPriorityMappingEntryMethodType"] = 25233] = "AddPriorityMappingEntryMethodType";
      MethodIds2[MethodIds2["DeletePriorityMappingEntryMethodType"] = 25235] = "DeletePriorityMappingEntryMethodType";
      MethodIds2[MethodIds2["PubSubKeyServiceType_SecurityGroups_AddSecurityGroupFolder"] = 25271] = "PubSubKeyServiceType_SecurityGroups_AddSecurityGroupFolder";
      MethodIds2[MethodIds2["PubSubKeyServiceType_SecurityGroups_RemoveSecurityGroupFolder"] = 25274] = "PubSubKeyServiceType_SecurityGroups_RemoveSecurityGroupFolder";
      MethodIds2[MethodIds2["PubSubKeyServiceType_KeyPushTargets_AddPushTarget"] = 25278] = "PubSubKeyServiceType_KeyPushTargets_AddPushTarget";
      MethodIds2[MethodIds2["PubSubKeyServiceType_KeyPushTargets_RemovePushTarget"] = 25281] = "PubSubKeyServiceType_KeyPushTargets_RemovePushTarget";
      MethodIds2[MethodIds2["PubSubKeyServiceType_KeyPushTargets_AddPushTargetFolder"] = 25283] = "PubSubKeyServiceType_KeyPushTargets_AddPushTargetFolder";
      MethodIds2[MethodIds2["PubSubKeyServiceType_KeyPushTargets_RemovePushTargetFolder"] = 25286] = "PubSubKeyServiceType_KeyPushTargets_RemovePushTargetFolder";
      MethodIds2[MethodIds2["AddSecurityGroupFolderMethodType"] = 25288] = "AddSecurityGroupFolderMethodType";
      MethodIds2[MethodIds2["RemoveSecurityGroupFolderMethodType"] = 25291] = "RemoveSecurityGroupFolderMethodType";
      MethodIds2[MethodIds2["SecurityGroupFolderType_AddSecurityGroupFolder"] = 25312] = "SecurityGroupFolderType_AddSecurityGroupFolder";
      MethodIds2[MethodIds2["SecurityGroupFolderType_RemoveSecurityGroupFolder"] = 25315] = "SecurityGroupFolderType_RemoveSecurityGroupFolder";
      MethodIds2[MethodIds2["ConnectSecurityGroupsMethodType"] = 25331] = "ConnectSecurityGroupsMethodType";
      MethodIds2[MethodIds2["DisconnectSecurityGroupsMethodType"] = 25334] = "DisconnectSecurityGroupsMethodType";
      MethodIds2[MethodIds2["PubSubKeyPushTargetFolderType_AddPushTarget"] = 25366] = "PubSubKeyPushTargetFolderType_AddPushTarget";
      MethodIds2[MethodIds2["PubSubKeyPushTargetFolderType_RemovePushTarget"] = 25369] = "PubSubKeyPushTargetFolderType_RemovePushTarget";
      MethodIds2[MethodIds2["PubSubKeyPushTargetFolderType_AddPushTargetFolder"] = 25371] = "PubSubKeyPushTargetFolderType_AddPushTargetFolder";
      MethodIds2[MethodIds2["PubSubKeyPushTargetFolderType_RemovePushTargetFolder"] = 25374] = "PubSubKeyPushTargetFolderType_RemovePushTargetFolder";
      MethodIds2[MethodIds2["AddPushTargetMethodType"] = 25376] = "AddPushTargetMethodType";
      MethodIds2[MethodIds2["RemovePushTargetMethodType"] = 25379] = "RemovePushTargetMethodType";
      MethodIds2[MethodIds2["AddPushTargetFolderMethodType"] = 25381] = "AddPushTargetFolderMethodType";
      MethodIds2[MethodIds2["RemovePushTargetFolderMethodType"] = 25384] = "RemovePushTargetFolderMethodType";
      MethodIds2[MethodIds2["PublishSubscribeType_PubSubConfiguration_Open"] = 25411] = "PublishSubscribeType_PubSubConfiguration_Open";
      MethodIds2[MethodIds2["PublishSubscribeType_PubSubConfiguration_Close"] = 25414] = "PublishSubscribeType_PubSubConfiguration_Close";
      MethodIds2[MethodIds2["PublishSubscribeType_PubSubConfiguration_Read"] = 25416] = "PublishSubscribeType_PubSubConfiguration_Read";
      MethodIds2[MethodIds2["PublishSubscribeType_PubSubConfiguration_Write"] = 25419] = "PublishSubscribeType_PubSubConfiguration_Write";
      MethodIds2[MethodIds2["PublishSubscribeType_PubSubConfiguration_GetPosition"] = 25421] = "PublishSubscribeType_PubSubConfiguration_GetPosition";
      MethodIds2[MethodIds2["PublishSubscribeType_PubSubConfiguration_SetPosition"] = 25424] = "PublishSubscribeType_PubSubConfiguration_SetPosition";
      MethodIds2[MethodIds2["PublishSubscribeType_PubSubConfiguration_ReserveIds"] = 25426] = "PublishSubscribeType_PubSubConfiguration_ReserveIds";
      MethodIds2[MethodIds2["PublishSubscribeType_PubSubConfiguration_CloseAndUpdate"] = 25429] = "PublishSubscribeType_PubSubConfiguration_CloseAndUpdate";
      MethodIds2[MethodIds2["PublishSubscribe_SecurityGroups_AddSecurityGroupFolder"] = 25434] = "PublishSubscribe_SecurityGroups_AddSecurityGroupFolder";
      MethodIds2[MethodIds2["PublishSubscribe_SecurityGroups_RemoveSecurityGroupFolder"] = 25437] = "PublishSubscribe_SecurityGroups_RemoveSecurityGroupFolder";
      MethodIds2[MethodIds2["PublishSubscribe_KeyPushTargets_AddPushTarget"] = 25441] = "PublishSubscribe_KeyPushTargets_AddPushTarget";
      MethodIds2[MethodIds2["PublishSubscribe_KeyPushTargets_RemovePushTarget"] = 25444] = "PublishSubscribe_KeyPushTargets_RemovePushTarget";
      MethodIds2[MethodIds2["PublishSubscribe_KeyPushTargets_AddPushTargetFolder"] = 25446] = "PublishSubscribe_KeyPushTargets_AddPushTargetFolder";
      MethodIds2[MethodIds2["PublishSubscribe_KeyPushTargets_RemovePushTargetFolder"] = 25449] = "PublishSubscribe_KeyPushTargets_RemovePushTargetFolder";
      MethodIds2[MethodIds2["PublishSubscribe_PubSubConfiguration_Open"] = 25459] = "PublishSubscribe_PubSubConfiguration_Open";
      MethodIds2[MethodIds2["PublishSubscribe_PubSubConfiguration_Close"] = 25462] = "PublishSubscribe_PubSubConfiguration_Close";
      MethodIds2[MethodIds2["PublishSubscribe_PubSubConfiguration_Read"] = 25464] = "PublishSubscribe_PubSubConfiguration_Read";
      MethodIds2[MethodIds2["PublishSubscribe_PubSubConfiguration_Write"] = 25467] = "PublishSubscribe_PubSubConfiguration_Write";
      MethodIds2[MethodIds2["PublishSubscribe_PubSubConfiguration_GetPosition"] = 25469] = "PublishSubscribe_PubSubConfiguration_GetPosition";
      MethodIds2[MethodIds2["PublishSubscribe_PubSubConfiguration_SetPosition"] = 25472] = "PublishSubscribe_PubSubConfiguration_SetPosition";
      MethodIds2[MethodIds2["PublishSubscribe_PubSubConfiguration_ReserveIds"] = 25474] = "PublishSubscribe_PubSubConfiguration_ReserveIds";
      MethodIds2[MethodIds2["PublishSubscribe_PubSubConfiguration_CloseAndUpdate"] = 25477] = "PublishSubscribe_PubSubConfiguration_CloseAndUpdate";
      MethodIds2[MethodIds2["PubSubConfigurationType_ReserveIds"] = 25505] = "PubSubConfigurationType_ReserveIds";
      MethodIds2[MethodIds2["PubSubConfigurationType_CloseAndUpdate"] = 25508] = "PubSubConfigurationType_CloseAndUpdate";
      MethodIds2[MethodIds2["PubSubConfigurationTypeReserveIdsMethodType"] = 25511] = "PubSubConfigurationTypeReserveIdsMethodType";
      MethodIds2[MethodIds2["PubSubConfigurationTypeCloseAndUpdateMethodType"] = 25514] = "PubSubConfigurationTypeCloseAndUpdateMethodType";
      MethodIds2[MethodIds2["WellKnownRole_SecurityKeyServerAdmin_AddIdentity"] = 25572] = "WellKnownRole_SecurityKeyServerAdmin_AddIdentity";
      MethodIds2[MethodIds2["WellKnownRole_SecurityKeyServerAdmin_RemoveIdentity"] = 25574] = "WellKnownRole_SecurityKeyServerAdmin_RemoveIdentity";
      MethodIds2[MethodIds2["WellKnownRole_SecurityKeyServerAdmin_AddApplication"] = 25576] = "WellKnownRole_SecurityKeyServerAdmin_AddApplication";
      MethodIds2[MethodIds2["WellKnownRole_SecurityKeyServerAdmin_RemoveApplication"] = 25578] = "WellKnownRole_SecurityKeyServerAdmin_RemoveApplication";
      MethodIds2[MethodIds2["WellKnownRole_SecurityKeyServerAdmin_AddEndpoint"] = 25580] = "WellKnownRole_SecurityKeyServerAdmin_AddEndpoint";
      MethodIds2[MethodIds2["WellKnownRole_SecurityKeyServerAdmin_RemoveEndpoint"] = 25582] = "WellKnownRole_SecurityKeyServerAdmin_RemoveEndpoint";
      MethodIds2[MethodIds2["WellKnownRole_SecurityKeyServerPush_AddIdentity"] = 25591] = "WellKnownRole_SecurityKeyServerPush_AddIdentity";
      MethodIds2[MethodIds2["WellKnownRole_SecurityKeyServerPush_RemoveIdentity"] = 25593] = "WellKnownRole_SecurityKeyServerPush_RemoveIdentity";
      MethodIds2[MethodIds2["WellKnownRole_SecurityKeyServerPush_AddApplication"] = 25595] = "WellKnownRole_SecurityKeyServerPush_AddApplication";
      MethodIds2[MethodIds2["WellKnownRole_SecurityKeyServerPush_RemoveApplication"] = 25597] = "WellKnownRole_SecurityKeyServerPush_RemoveApplication";
      MethodIds2[MethodIds2["WellKnownRole_SecurityKeyServerPush_AddEndpoint"] = 25599] = "WellKnownRole_SecurityKeyServerPush_AddEndpoint";
      MethodIds2[MethodIds2["WellKnownRole_SecurityKeyServerPush_RemoveEndpoint"] = 25601] = "WellKnownRole_SecurityKeyServerPush_RemoveEndpoint";
      MethodIds2[MethodIds2["WellKnownRole_SecurityKeyServerAccess_AddIdentity"] = 25610] = "WellKnownRole_SecurityKeyServerAccess_AddIdentity";
      MethodIds2[MethodIds2["WellKnownRole_SecurityKeyServerAccess_RemoveIdentity"] = 25612] = "WellKnownRole_SecurityKeyServerAccess_RemoveIdentity";
      MethodIds2[MethodIds2["WellKnownRole_SecurityKeyServerAccess_AddApplication"] = 25614] = "WellKnownRole_SecurityKeyServerAccess_AddApplication";
      MethodIds2[MethodIds2["WellKnownRole_SecurityKeyServerAccess_RemoveApplication"] = 25616] = "WellKnownRole_SecurityKeyServerAccess_RemoveApplication";
      MethodIds2[MethodIds2["WellKnownRole_SecurityKeyServerAccess_AddEndpoint"] = 25618] = "WellKnownRole_SecurityKeyServerAccess_AddEndpoint";
      MethodIds2[MethodIds2["WellKnownRole_SecurityKeyServerAccess_RemoveEndpoint"] = 25620] = "WellKnownRole_SecurityKeyServerAccess_RemoveEndpoint";
      MethodIds2[MethodIds2["SecurityGroupType_InvalidateKeys"] = 25624] = "SecurityGroupType_InvalidateKeys";
      MethodIds2[MethodIds2["SecurityGroupType_ForceKeyRotation"] = 25625] = "SecurityGroupType_ForceKeyRotation";
      MethodIds2[MethodIds2["PubSubKeyPushTargetType_ConnectSecurityGroups"] = 25641] = "PubSubKeyPushTargetType_ConnectSecurityGroups";
      MethodIds2[MethodIds2["PubSubKeyPushTargetType_DisconnectSecurityGroups"] = 25644] = "PubSubKeyPushTargetType_DisconnectSecurityGroups";
      MethodIds2[MethodIds2["PubSubKeyPushTargetType_TriggerKeyUpdate"] = 25647] = "PubSubKeyPushTargetType_TriggerKeyUpdate";
      MethodIds2[MethodIds2["ServerConfigurationType_CancelChanges"] = 25698] = "ServerConfigurationType_CancelChanges";
      MethodIds2[MethodIds2["ServerConfigurationType_ResetToServerDefaults"] = 25699] = "ServerConfigurationType_ResetToServerDefaults";
      MethodIds2[MethodIds2["ServerConfiguration_CancelChanges"] = 25708] = "ServerConfiguration_CancelChanges";
      MethodIds2[MethodIds2["ServerConfiguration_ResetToServerDefaults"] = 25709] = "ServerConfiguration_ResetToServerDefaults";
      MethodIds2[MethodIds2["RequestTicketsMethodType"] = 25727] = "RequestTicketsMethodType";
      MethodIds2[MethodIds2["SetRegistrarEndpointsMethodType"] = 25729] = "SetRegistrarEndpointsMethodType";
      MethodIds2[MethodIds2["ProvisionableDeviceType_RequestTickets"] = 26873] = "ProvisionableDeviceType_RequestTickets";
      MethodIds2[MethodIds2["ProvisionableDeviceType_SetRegistrarEndpoints"] = 26875] = "ProvisionableDeviceType_SetRegistrarEndpoints";
      MethodIds2[MethodIds2["ProvisionableDevice_RequestTickets"] = 29880] = "ProvisionableDevice_RequestTickets";
      MethodIds2[MethodIds2["ProvisionableDevice_SetRegistrarEndpoints"] = 29882] = "ProvisionableDevice_SetRegistrarEndpoints";
      MethodIds2[MethodIds2["GetCertificatesMethodType"] = 32282] = "GetCertificatesMethodType";
      MethodIds2[MethodIds2["ServerConfigurationType_GetCertificates"] = 32296] = "ServerConfigurationType_GetCertificates";
      MethodIds2[MethodIds2["ServerConfiguration_GetCertificates"] = 32333] = "ServerConfiguration_GetCertificates";
      MethodIds2[MethodIds2["NonTransparentBackupRedundancyType_Failover"] = 32416] = "NonTransparentBackupRedundancyType_Failover";
    })(MethodIds || (exports2.MethodIds = MethodIds = {}));
  }
});

// node_modules/node-opcua-constants/dist/aggregate_function_enum.js
var require_aggregate_function_enum = __commonJS({
  "node_modules/node-opcua-constants/dist/aggregate_function_enum.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AggregateFunction = void 0;
    var AggregateFunction;
    (function(AggregateFunction2) {
      AggregateFunction2[AggregateFunction2["AnnotationCount"] = 2351] = "AnnotationCount";
      AggregateFunction2[AggregateFunction2["Average"] = 2342] = "Average";
      AggregateFunction2[AggregateFunction2["Count"] = 2352] = "Count";
      AggregateFunction2[AggregateFunction2["Delta"] = 2359] = "Delta";
      AggregateFunction2[AggregateFunction2["DeltaBounds"] = 11507] = "DeltaBounds";
      AggregateFunction2[AggregateFunction2["DurationBad"] = 2361] = "DurationBad";
      AggregateFunction2[AggregateFunction2["DurationGood"] = 2360] = "DurationGood";
      AggregateFunction2[AggregateFunction2["DurationInStateNonZero"] = 11308] = "DurationInStateNonZero";
      AggregateFunction2[AggregateFunction2["DurationInStateZero"] = 2358] = "DurationInStateZero";
      AggregateFunction2[AggregateFunction2["EndBound"] = 11506] = "EndBound";
      AggregateFunction2[AggregateFunction2["Interpolative"] = 2341] = "Interpolative";
      AggregateFunction2[AggregateFunction2["Maximum"] = 2347] = "Maximum";
      AggregateFunction2[AggregateFunction2["Maximum2"] = 11287] = "Maximum2";
      AggregateFunction2[AggregateFunction2["MaximumActualTime"] = 2349] = "MaximumActualTime";
      AggregateFunction2[AggregateFunction2["MaximumActualTime2"] = 11306] = "MaximumActualTime2";
      AggregateFunction2[AggregateFunction2["Minimum"] = 2346] = "Minimum";
      AggregateFunction2[AggregateFunction2["Minimum2"] = 11286] = "Minimum2";
      AggregateFunction2[AggregateFunction2["MinimumActualTime"] = 2348] = "MinimumActualTime";
      AggregateFunction2[AggregateFunction2["MinimumActualTime2"] = 11305] = "MinimumActualTime2";
      AggregateFunction2[AggregateFunction2["NumberOfTransitions"] = 2355] = "NumberOfTransitions";
      AggregateFunction2[AggregateFunction2["PercentBad"] = 2363] = "PercentBad";
      AggregateFunction2[AggregateFunction2["PercentGood"] = 2362] = "PercentGood";
      AggregateFunction2[AggregateFunction2["Range"] = 2350] = "Range";
      AggregateFunction2[AggregateFunction2["Range2"] = 11288] = "Range2";
      AggregateFunction2[AggregateFunction2["StandardDeviationPopulation"] = 11427] = "StandardDeviationPopulation";
      AggregateFunction2[AggregateFunction2["StandardDeviationSample"] = 11426] = "StandardDeviationSample";
      AggregateFunction2[AggregateFunction2["Start"] = 2357] = "Start";
      AggregateFunction2[AggregateFunction2["StartBound"] = 11505] = "StartBound";
      AggregateFunction2[AggregateFunction2["TimeAverage"] = 2343] = "TimeAverage";
      AggregateFunction2[AggregateFunction2["TimeAverage2"] = 11285] = "TimeAverage2";
      AggregateFunction2[AggregateFunction2["Total"] = 2344] = "Total";
      AggregateFunction2[AggregateFunction2["Total2"] = 11304] = "Total2";
      AggregateFunction2[AggregateFunction2["VariancePopulation"] = 11429] = "VariancePopulation";
      AggregateFunction2[AggregateFunction2["VarianceSample"] = 11428] = "VarianceSample";
      AggregateFunction2[AggregateFunction2["WorstQuality"] = 2364] = "WorstQuality";
      AggregateFunction2[AggregateFunction2["WorstQuality2"] = 11292] = "WorstQuality2";
    })(AggregateFunction || (exports2.AggregateFunction = AggregateFunction = {}));
  }
});

// node_modules/node-opcua-constants/dist/index.js
var require_dist20 = __commonJS({
  "node_modules/node-opcua-constants/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_opcua_node_ids(), exports2);
    __exportStar3(require_aggregate_function_enum(), exports2);
  }
});

// node_modules/node-opcua-nodeid/dist/nodeid.js
var require_nodeid = __commonJS({
  "node_modules/node-opcua-nodeid/dist/nodeid.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.sameNodeId = exports2.resolveNodeId = exports2.makeNodeId = exports2.coerceNodeId = exports2.NodeId = exports2.NodeIdType = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_guid_1 = require_dist19();
    var NodeIdType;
    (function(NodeIdType2) {
      NodeIdType2[NodeIdType2["NUMERIC"] = 1] = "NUMERIC";
      NodeIdType2[NodeIdType2["STRING"] = 2] = "STRING";
      NodeIdType2[NodeIdType2["GUID"] = 3] = "GUID";
      NodeIdType2[NodeIdType2["BYTESTRING"] = 4] = "BYTESTRING";
    })(NodeIdType || (exports2.NodeIdType = NodeIdType = {}));
    function defaultValue(identifierType) {
      switch (identifierType) {
        case NodeIdType.GUID:
          return node_opcua_guid_1.emptyGuid;
        case NodeIdType.BYTESTRING:
          return null;
        case NodeIdType.STRING:
          return "";
        case NodeIdType.NUMERIC:
          return 0;
      }
    }
    var NodeId = class {
      /**
       * @param identifierType   - the nodeID type
       * @param value            - the node id value. The type of Value depends on identifierType.
       * @param namespace        - the index of the related namespace (optional , default value = 0 )
       */
      constructor(identifierType, value, namespace) {
        if (identifierType === null || identifierType === void 0) {
          this.identifierType = NodeIdType.NUMERIC;
          this.value = 0;
          this.namespace = 0;
          return;
        }
        this.identifierType = identifierType;
        this.value = value || defaultValue(identifierType);
        this.namespace = namespace || 0;
        (0, node_opcua_assert_1.assert)(this.namespace >= 0 && this.namespace <= 65535, "NodeId: invalid namespace value");
        (0, node_opcua_assert_1.assert)(this.identifierType !== NodeIdType.NUMERIC || this.value !== null && this.value >= 0 && this.value <= 4294967295);
        (0, node_opcua_assert_1.assert)(this.identifierType !== NodeIdType.GUID || (0, node_opcua_guid_1.isValidGuid)(this.value), "NodeId: Guid is invalid");
        (0, node_opcua_assert_1.assert)(this.identifierType !== NodeIdType.STRING || typeof this.value === "string", "cannot  empty string");
        if (this.identifierType === NodeIdType.GUID) {
          this.value = (0, node_opcua_guid_1.normalizeGuid)(value);
        }
      }
      /**
       * get the string representation of the nodeID.
       *
       * @method toString
       * @example
       *
       *    ``` javascript
       *    const nodeid = new NodeId(NodeIdType.NUMERIC, 123,1);
       *    console.log(nodeid.toString());
       *    ```
       *
       *    ```
       *    >"ns=1;i=123"
       *    ```
       *
       * @param [options.addressSpace] {AddressSpace}
       * @return {String}
       */
      toString(options) {
        const addressSpace = options ? options.addressSpace : null;
        let str;
        const _this = this;
        switch (_this.identifierType) {
          case NodeIdType.NUMERIC:
            str = "ns=" + this.namespace + ";i=" + _this.value;
            break;
          case NodeIdType.STRING:
            str = "ns=" + this.namespace + ";s=" + _this.value;
            break;
          case NodeIdType.GUID:
            str = "ns=" + this.namespace + ";g=" + (0, node_opcua_guid_1.normalizeGuid)(_this.value);
            break;
          default:
            (0, node_opcua_assert_1.assert)(this.identifierType === NodeIdType.BYTESTRING, "invalid identifierType in NodeId : " + this.identifierType);
            if (this.value) {
              str = "ns=" + this.namespace + ";b=" + this.value.toString("base64");
            } else {
              str = "ns=" + this.namespace + ";b=<null>";
            }
            break;
        }
        if (addressSpace) {
          if (this.namespace === 0 && _this.identifierType === NodeIdType.NUMERIC) {
            const name = reverse_map((this.value || 0).toString()) || "<undefined>";
            str += " " + name;
          } else if (addressSpace.findNode) {
            const n = addressSpace.findNode(this);
            str += " " + (n ? n.browseName.toString() : " (????)");
          }
        }
        return str;
      }
      /**
       * convert nodeId to a JSON string. same as {@link NodeId#toString }
       */
      toJSON() {
        return this.toString();
      }
      displayText() {
        if (this.namespace === 0 && this.identifierType === NodeIdType.NUMERIC) {
          const name = reverse_map(this.value.toString());
          if (name) {
            return name + " (" + this.toString() + ")";
          }
        }
        return this.toString();
      }
      /**
       * returns true if the NodeId is null or empty
       */
      isEmpty() {
        const _this = this;
        switch (_this.identifierType) {
          case NodeIdType.NUMERIC:
            return _this.value === 0;
          case NodeIdType.STRING:
            return !_this.value;
          case NodeIdType.GUID:
            return !_this.value || _this.value === node_opcua_guid_1.emptyGuid;
          default:
            return !_this.value || _this.value.length === 0;
        }
      }
    };
    exports2.NodeId = NodeId;
    NodeId.NodeIdType = NodeIdType;
    NodeId.nullNodeId = new Proxy(new NodeId(NodeIdType.NUMERIC, 0, 0), {
      get: (target, prop) => {
        return target[prop];
      },
      set: () => {
        throw new Error("Cannot assign a value to constant NodeId.nullNodeId");
      }
    });
    var regexNamespaceI = /ns=([0-9]+);i=([0-9]+)/;
    var regexNamespaceS = /ns=([0-9]+);s=(.*)/;
    var regexNamespaceB = /ns=([0-9]+);b=(.*)/;
    var regexNamespaceG = /ns=([0-9]+);g=([0-9A-Fa-f]{8}-[0-9A-Fa-f]{4}-[0-9A-Fa-f]{4}-[0-9A-Fa-f]{4}-[0-9A-Fa-f]{12})/;
    function coerceNodeId(value, namespace) {
      let matches;
      let twoFirst;
      if (value instanceof NodeId) {
        return value;
      }
      value = value || 0;
      namespace = namespace || 0;
      let identifierType = NodeIdType.NUMERIC;
      if (typeof value === "string") {
        identifierType = NodeIdType.STRING;
        twoFirst = value.substring(0, 2);
        if (twoFirst === "i=") {
          identifierType = NodeIdType.NUMERIC;
          value = parseInt(value.substring(2), 10);
        } else if (twoFirst === "s=") {
          identifierType = NodeIdType.STRING;
          value = value.substring(2);
        } else if (twoFirst === "b=") {
          identifierType = NodeIdType.BYTESTRING;
          value = Buffer.from(value.substring(2), "base64");
        } else if (twoFirst === "g=") {
          identifierType = NodeIdType.GUID;
          value = (0, node_opcua_guid_1.normalizeGuid)(value.substring(2));
          (0, node_opcua_assert_1.assert)((0, node_opcua_guid_1.isValidGuid)(value));
        } else if ((0, node_opcua_guid_1.isValidGuid)(value)) {
          identifierType = NodeIdType.GUID;
          value = (0, node_opcua_guid_1.normalizeGuid)(value);
        } else if ((matches = regexNamespaceI.exec(value)) !== null) {
          identifierType = NodeIdType.NUMERIC;
          namespace = parseInt(matches[1], 10);
          value = parseInt(matches[2], 10);
        } else if ((matches = regexNamespaceS.exec(value)) !== null) {
          identifierType = NodeIdType.STRING;
          namespace = parseInt(matches[1], 10);
          value = matches[2];
        } else if ((matches = regexNamespaceB.exec(value)) !== null) {
          identifierType = NodeIdType.BYTESTRING;
          namespace = parseInt(matches[1], 10);
          value = Buffer.from(matches[2], "base64");
        } else if ((matches = regexNamespaceG.exec(value)) !== null) {
          identifierType = NodeIdType.GUID;
          namespace = parseInt(matches[1], 10);
          value = (0, node_opcua_guid_1.normalizeGuid)(matches[2]);
        } else {
          throw new Error("String cannot be coerced to a nodeId : " + value);
        }
      } else if (value instanceof Buffer) {
        identifierType = NodeIdType.BYTESTRING;
      } else if (value instanceof Object) {
        const tmp = value;
        value = tmp.value;
        namespace = namespace || tmp.namespace;
        identifierType = tmp.identifierType || identifierType;
        return new NodeId(identifierType, value, namespace);
      }
      return new NodeId(identifierType, value, namespace);
    }
    exports2.coerceNodeId = coerceNodeId;
    var regEx1 = /^(s|g|b|i|ns)=/;
    function makeNodeId(value, namespace) {
      value = value || 0;
      namespace = namespace || 0;
      let identifierType = NodeIdType.NUMERIC;
      if (typeof value === "string") {
        if (value.match(regEx1)) {
          throw new Error("please use coerce NodeId instead");
        }
        if ((0, node_opcua_guid_1.isValidGuid)(value)) {
          identifierType = NodeIdType.GUID;
          value = (0, node_opcua_guid_1.normalizeGuid)(value);
        } else {
          identifierType = NodeIdType.STRING;
        }
      } else if (value instanceof Buffer) {
        identifierType = NodeIdType.BYTESTRING;
      }
      const nodeId = new NodeId(identifierType, value, namespace);
      return nodeId;
    }
    exports2.makeNodeId = makeNodeId;
    var _nodeIdToNameIndex = {};
    var _nameToNodeIdIndex = {};
    var regName = /[a-zA-Z_].*/;
    (function build_standard_nodeid_indexes() {
      function expand_map(directIndex) {
        for (const name in directIndex) {
          if (Object.prototype.hasOwnProperty.call(directIndex, name) && regName.exec(name) !== null) {
            const value = directIndex[name];
            _nodeIdToNameIndex[value] = name;
            _nameToNodeIdIndex[name] = new NodeId(NodeIdType.NUMERIC, value, 0);
          }
        }
      }
      _nodeIdToNameIndex = {};
      _nameToNodeIdIndex = {};
      expand_map(node_opcua_constants_1.ObjectIds);
      expand_map(node_opcua_constants_1.ObjectTypeIds);
      expand_map(node_opcua_constants_1.VariableIds);
      expand_map(node_opcua_constants_1.VariableTypeIds);
      expand_map(node_opcua_constants_1.MethodIds);
      expand_map(node_opcua_constants_1.ReferenceTypeIds);
      expand_map(node_opcua_constants_1.DataTypeIds);
    })();
    function reverse_map(nodeId) {
      return _nodeIdToNameIndex[nodeId];
    }
    function resolveNodeId(nodeIdOrString) {
      let nodeId;
      const rawId = typeof nodeIdOrString === "string" ? _nameToNodeIdIndex[nodeIdOrString] : void 0;
      if (rawId !== void 0) {
        return rawId;
      } else {
        nodeId = coerceNodeId(nodeIdOrString);
      }
      return nodeId;
    }
    exports2.resolveNodeId = resolveNodeId;
    NodeId.resolveNodeId = resolveNodeId;
    function sameNodeId(n1, n2) {
      if (n1.identifierType !== n2.identifierType) {
        return false;
      }
      if (n1.namespace !== n2.namespace) {
        return false;
      }
      switch (n1.identifierType) {
        case NodeIdType.NUMERIC:
        case NodeIdType.STRING:
        case NodeIdType.GUID:
          return n1.value === n2.value;
        case NodeIdType.BYTESTRING:
          return n1.value.toString("hex") === n2.value.toString("hex");
        default:
          throw new Error("Invalid identifier type");
      }
    }
    exports2.sameNodeId = sameNodeId;
    NodeId.sameNodeId = sameNodeId;
  }
});

// node_modules/node-opcua-nodeid/dist/expanded_nodeid.js
var require_expanded_nodeid = __commonJS({
  "node_modules/node-opcua-nodeid/dist/expanded_nodeid.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.makeExpandedNodeId = exports2.coerceExpandedNodeId = exports2.ExpandedNodeId = void 0;
    var nodeid_1 = require_nodeid();
    var ExpandedNodeId = class _ExpandedNodeId extends nodeid_1.NodeId {
      static fromNodeId(nodeId, namespaceUri, serverIndex) {
        return new _ExpandedNodeId(nodeId.identifierType, nodeId.value, nodeId.namespace, namespaceUri, serverIndex);
      }
      constructor(identifierType, value, namespace, namespaceUri, serverIndex) {
        super(identifierType, value, namespace);
        this.namespaceUri = namespaceUri || null;
        this.serverIndex = serverIndex || 0;
      }
      /**
       * @method toString
       * @return {string}
       */
      toString() {
        let str = nodeid_1.NodeId.prototype.toString.call(this);
        if (this.namespaceUri) {
          str += ";namespaceUri:" + this.namespaceUri;
        }
        if (this.serverIndex) {
          str += ";serverIndex:" + this.serverIndex;
        }
        return str;
      }
      /**
       * convert nodeId to a JSON string. same as {@link NodeId#toString }
       * @method  toJSON
       * @return {String}
       */
      toJSON() {
        return this.toString();
      }
    };
    exports2.ExpandedNodeId = ExpandedNodeId;
    ExpandedNodeId.nullExpandedNodeId = new ExpandedNodeId(nodeid_1.NodeIdType.NUMERIC, 0, 0);
    function coerceExpandedNodeId(value) {
      const n = (0, nodeid_1.coerceNodeId)(value);
      return new ExpandedNodeId(
        n.identifierType,
        n.value,
        n.namespace,
        /*namespaceUri*/
        null,
        /*serverIndex*/
        0
      );
    }
    exports2.coerceExpandedNodeId = coerceExpandedNodeId;
    function makeExpandedNodeId(value, namespace) {
      if (value === void 0 && namespace === void 0) {
        return new ExpandedNodeId(nodeid_1.NodeIdType.NUMERIC, 0, 0, null, 0);
      }
      const serverIndex = 0;
      let n;
      const namespaceUri = null;
      if (value instanceof ExpandedNodeId) {
        n = value;
        return new ExpandedNodeId(n.identifierType, n.value, n.namespace, n.namespaceUri, n.serverIndex);
      }
      if (value instanceof nodeid_1.NodeId) {
        n = value;
        return new ExpandedNodeId(n.identifierType, n.value, n.namespace, namespaceUri, serverIndex);
      }
      const valueInt = parseInt(value, 10);
      if (!isFinite(valueInt)) {
        throw new Error(" cannot makeExpandedNodeId out of " + value);
      }
      namespace = namespace || 0;
      return new ExpandedNodeId(nodeid_1.NodeIdType.NUMERIC, valueInt, namespace, namespaceUri, serverIndex);
    }
    exports2.makeExpandedNodeId = makeExpandedNodeId;
  }
});

// node_modules/node-opcua-nodeid/dist/index.js
var require_dist21 = __commonJS({
  "node_modules/node-opcua-nodeid/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_nodeid(), exports2);
    __exportStar3(require_expanded_nodeid(), exports2);
  }
});

// node_modules/node-opcua-basic-types/dist/node_id.js
var require_node_id = __commonJS({
  "node_modules/node-opcua-basic-types/dist/node_id.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.coerceExpandedNodeId = exports2.coerceNodeId = exports2.decodeExpandedNodeId = exports2.decodeNodeId = exports2.encodeExpandedNodeId = exports2.encodeNodeId = exports2.randomNodeId = exports2.isValidNodeId = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_nodeid_1 = require_dist21();
    var byte_string_1 = require_byte_string();
    var guid_1 = require_guid2();
    var integers_1 = require_integers();
    var string_1 = require_string();
    var utils_1 = require_utils3();
    function isUInt8(value) {
      return value >= 0 && value <= 255;
    }
    function isUInt16(value) {
      return value >= 0 && value <= 65535;
    }
    function nodeID_encodingByte(nodeId) {
      let encodingByte = 0;
      if (nodeId.identifierType === node_opcua_nodeid_1.NodeIdType.NUMERIC) {
        if (isUInt8(nodeId.value) && !nodeId.namespace && !nodeId.namespaceUri && !nodeId.serverIndex) {
          encodingByte = encodingByte | 0;
        } else if (isUInt16(nodeId.value) && isUInt8(nodeId.namespace) && !nodeId.namespaceUri && !nodeId.serverIndex) {
          encodingByte = encodingByte | 1;
        } else {
          encodingByte = encodingByte | 2;
        }
      } else if (nodeId.identifierType === node_opcua_nodeid_1.NodeIdType.STRING) {
        encodingByte = encodingByte | 3;
      } else if (nodeId.identifierType === node_opcua_nodeid_1.NodeIdType.BYTESTRING) {
        encodingByte = encodingByte | 5;
      } else if (nodeId.identifierType === node_opcua_nodeid_1.NodeIdType.GUID) {
        encodingByte = encodingByte | 4;
      }
      if (Object.prototype.hasOwnProperty.call(nodeId, "namespaceUri") && nodeId.namespaceUri) {
        encodingByte = encodingByte | 128;
      }
      if (Object.prototype.hasOwnProperty.call(nodeId, "serverIndex") && nodeId.serverIndex) {
        encodingByte = encodingByte | 64;
      }
      return encodingByte;
    }
    function isValidNodeId(nodeId) {
      return nodeId instanceof node_opcua_nodeid_1.NodeId;
    }
    exports2.isValidNodeId = isValidNodeId;
    function randomNodeId() {
      const value = (0, utils_1.getRandomInt)(0, 1048575);
      const namespace = (0, utils_1.getRandomInt)(0, 3);
      return (0, node_opcua_nodeid_1.makeNodeId)(value, namespace);
    }
    exports2.randomNodeId = randomNodeId;
    function _encodeNodeId(encodingByte, nodeId, stream) {
      stream.writeUInt8(encodingByte);
      encodingByte &= 63;
      switch (encodingByte) {
        case 0:
          stream.writeUInt8(nodeId ? nodeId.value : 0);
          break;
        case 1:
          stream.writeUInt8(nodeId.namespace);
          stream.writeUInt16(nodeId.value);
          break;
        case 2:
          stream.writeUInt16(nodeId.namespace);
          stream.writeUInt32(nodeId.value);
          break;
        case 3:
          stream.writeUInt16(nodeId.namespace);
          (0, string_1.encodeString)(nodeId.value, stream);
          break;
        case 5:
          stream.writeUInt16(nodeId.namespace);
          (0, byte_string_1.encodeByteString)(nodeId.value, stream);
          break;
        default:
          (0, node_opcua_assert_1.assert)(
            encodingByte === 4
            /* EnumNodeIdEncoding.Guid */
          );
          stream.writeUInt16(nodeId.namespace);
          (0, guid_1.encodeGuid)(nodeId.value, stream);
          break;
      }
    }
    function encodeNodeId(nodeId, stream) {
      let encodingByte = nodeID_encodingByte(nodeId);
      encodingByte &= 63;
      _encodeNodeId(encodingByte, nodeId, stream);
    }
    exports2.encodeNodeId = encodeNodeId;
    function encodeExpandedNodeId(expandedNodeId, stream) {
      (0, node_opcua_assert_1.assert)(expandedNodeId, "encodeExpandedNodeId: must provide a valid expandedNodeId");
      const encodingByte = nodeID_encodingByte(expandedNodeId);
      _encodeNodeId(encodingByte, expandedNodeId, stream);
      if (encodingByte & 128) {
        (0, string_1.encodeString)(expandedNodeId.namespaceUri, stream);
      }
      if (encodingByte & 64) {
        (0, integers_1.encodeUInt32)(expandedNodeId.serverIndex, stream);
      }
    }
    exports2.encodeExpandedNodeId = encodeExpandedNodeId;
    function _decodeNodeId(encodingByte, stream, _nodeId) {
      let value;
      let namespace;
      let identifierType;
      encodingByte &= 63;
      switch (encodingByte) {
        case 0:
          value = stream.readUInt8();
          identifierType = node_opcua_nodeid_1.NodeIdType.NUMERIC;
          break;
        case 1:
          namespace = stream.readUInt8();
          value = stream.readUInt16();
          identifierType = node_opcua_nodeid_1.NodeIdType.NUMERIC;
          break;
        case 2:
          namespace = stream.readUInt16();
          value = stream.readUInt32();
          identifierType = node_opcua_nodeid_1.NodeIdType.NUMERIC;
          break;
        case 3:
          namespace = stream.readUInt16();
          value = (0, string_1.decodeString)(stream) || "";
          identifierType = node_opcua_nodeid_1.NodeIdType.STRING;
          break;
        case 5:
          namespace = stream.readUInt16();
          value = (0, byte_string_1.decodeByteString)(stream);
          identifierType = node_opcua_nodeid_1.NodeIdType.BYTESTRING;
          break;
        default:
          if (encodingByte !== 4) {
            throw new Error("decodeNodeId: unknown encoding_byte = 0x" + encodingByte.toString(16));
          }
          namespace = stream.readUInt16();
          value = (0, guid_1.decodeGuid)(stream);
          identifierType = node_opcua_nodeid_1.NodeIdType.GUID;
          (0, node_opcua_assert_1.assert)((0, guid_1.isValidGuid)(value));
          break;
      }
      if (_nodeId === void 0) {
        return new node_opcua_nodeid_1.NodeId(identifierType, value, namespace);
      }
      _nodeId.value = value;
      _nodeId.identifierType = identifierType;
      _nodeId.namespace = namespace || 0;
      return _nodeId;
    }
    function decodeNodeId(stream, _nodeId) {
      const encodingByte = stream.readUInt8();
      return _decodeNodeId(encodingByte, stream, _nodeId);
    }
    exports2.decodeNodeId = decodeNodeId;
    function decodeExpandedNodeId(stream, _nodeId) {
      const encodingByte = stream.readUInt8();
      const expandedNodeId = _decodeNodeId(encodingByte, stream, _nodeId);
      expandedNodeId.namespaceUri = null;
      expandedNodeId.serverIndex = 0;
      if (encodingByte & 128) {
        expandedNodeId.namespaceUri = (0, string_1.decodeString)(stream);
      }
      if (encodingByte & 64) {
        expandedNodeId.serverIndex = (0, integers_1.decodeUInt32)(stream);
      }
      const e = expandedNodeId;
      return new node_opcua_nodeid_1.ExpandedNodeId(e.identifierType, e.value, e.namespace, e.namespaceUri, e.serverIndex);
    }
    exports2.decodeExpandedNodeId = decodeExpandedNodeId;
    var node_opcua_nodeid_2 = require_dist21();
    Object.defineProperty(exports2, "coerceNodeId", { enumerable: true, get: function() {
      return node_opcua_nodeid_2.coerceNodeId;
    } });
    Object.defineProperty(exports2, "coerceExpandedNodeId", { enumerable: true, get: function() {
      return node_opcua_nodeid_2.coerceExpandedNodeId;
    } });
  }
});

// node_modules/node-opcua-basic-types/dist/round_to_float.js
var require_round_to_float = __commonJS({
  "node_modules/node-opcua-basic-types/dist/round_to_float.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.roundToFloat2 = void 0;
    function roundToFloat2(float) {
      if (float === 0) {
        return float;
      }
      const nbDigits = Math.ceil(Math.log(Math.abs(float)) / Math.log(10));
      const scale = Math.pow(10, -nbDigits + 2);
      return Math.round(float * scale) / scale;
    }
    exports2.roundToFloat2 = roundToFloat2;
  }
});

// node_modules/node-opcua-status-code/dist/_generated_status_codes.js
var require_generated_status_codes = __commonJS({
  "node_modules/node-opcua-status-code/dist/_generated_status_codes.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.StatusCodes = void 0;
    var opcua_status_code_1 = require_opcua_status_code();
    var StatusCodes = class {
    };
    exports2.StatusCodes = StatusCodes;
    StatusCodes.Good = new opcua_status_code_1.ConstantStatusCode({ name: "Good", value: 0, description: "The operation succeeded." });
    StatusCodes.Uncertain = new opcua_status_code_1.ConstantStatusCode({
      name: "Uncertain",
      value: 1073741824,
      description: "The operation was uncertain."
    });
    StatusCodes.Bad = new opcua_status_code_1.ConstantStatusCode({
      name: "Bad",
      value: 2147483648,
      description: "The operation failed."
    });
    StatusCodes.BadUnexpectedError = new opcua_status_code_1.ConstantStatusCode({
      name: "BadUnexpectedError",
      value: 2147549184,
      description: "An unexpected error occurred."
    });
    StatusCodes.BadInternalError = new opcua_status_code_1.ConstantStatusCode({
      name: "BadInternalError",
      value: 2147614720,
      description: "An internal error occurred as a result of a programming or configuration error."
    });
    StatusCodes.BadOutOfMemory = new opcua_status_code_1.ConstantStatusCode({
      name: "BadOutOfMemory",
      value: 2147680256,
      description: "Not enough memory to complete the operation."
    });
    StatusCodes.BadResourceUnavailable = new opcua_status_code_1.ConstantStatusCode({
      name: "BadResourceUnavailable",
      value: 2147745792,
      description: "An operating system resource is not available."
    });
    StatusCodes.BadCommunicationError = new opcua_status_code_1.ConstantStatusCode({
      name: "BadCommunicationError",
      value: 2147811328,
      description: "A low level communication error occurred."
    });
    StatusCodes.BadEncodingError = new opcua_status_code_1.ConstantStatusCode({
      name: "BadEncodingError",
      value: 2147876864,
      description: "Encoding halted because of invalid data in the objects being serialized."
    });
    StatusCodes.BadDecodingError = new opcua_status_code_1.ConstantStatusCode({
      name: "BadDecodingError",
      value: 2147942400,
      description: "Decoding halted because of invalid data in the stream."
    });
    StatusCodes.BadEncodingLimitsExceeded = new opcua_status_code_1.ConstantStatusCode({
      name: "BadEncodingLimitsExceeded",
      value: 2148007936,
      description: "The message encoding/decoding limits imposed by the stack have been exceeded."
    });
    StatusCodes.BadRequestTooLarge = new opcua_status_code_1.ConstantStatusCode({
      name: "BadRequestTooLarge",
      value: 2159542272,
      description: "The request message size exceeds limits set by the server."
    });
    StatusCodes.BadResponseTooLarge = new opcua_status_code_1.ConstantStatusCode({
      name: "BadResponseTooLarge",
      value: 2159607808,
      description: "The response message size exceeds limits set by the client or server."
    });
    StatusCodes.BadUnknownResponse = new opcua_status_code_1.ConstantStatusCode({
      name: "BadUnknownResponse",
      value: 2148073472,
      description: "An unrecognized response was received from the server."
    });
    StatusCodes.BadTimeout = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTimeout",
      value: 2148139008,
      description: "The operation timed out."
    });
    StatusCodes.BadServiceUnsupported = new opcua_status_code_1.ConstantStatusCode({
      name: "BadServiceUnsupported",
      value: 2148204544,
      description: "The server does not support the requested service."
    });
    StatusCodes.BadShutdown = new opcua_status_code_1.ConstantStatusCode({
      name: "BadShutdown",
      value: 2148270080,
      description: "The operation was cancelled because the application is shutting down."
    });
    StatusCodes.BadServerNotConnected = new opcua_status_code_1.ConstantStatusCode({
      name: "BadServerNotConnected",
      value: 2148335616,
      description: "The operation could not complete because the client is not connected to the server."
    });
    StatusCodes.BadServerHalted = new opcua_status_code_1.ConstantStatusCode({
      name: "BadServerHalted",
      value: 2148401152,
      description: "The server has stopped and cannot process any requests."
    });
    StatusCodes.BadNothingToDo = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNothingToDo",
      value: 2148466688,
      description: "No processing could be done because there was nothing to do."
    });
    StatusCodes.BadTooManyOperations = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTooManyOperations",
      value: 2148532224,
      description: "The request could not be processed because it specified too many operations."
    });
    StatusCodes.BadTooManyMonitoredItems = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTooManyMonitoredItems",
      value: 2161836032,
      description: "The request could not be processed because there are too many monitored items in the subscription."
    });
    StatusCodes.BadDataTypeIdUnknown = new opcua_status_code_1.ConstantStatusCode({
      name: "BadDataTypeIdUnknown",
      value: 2148597760,
      description: "The extension object cannot be (de)serialized because the data type id is not recognized."
    });
    StatusCodes.BadCertificateInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadCertificateInvalid",
      value: 2148663296,
      description: "The certificate provided as a parameter is not valid."
    });
    StatusCodes.BadSecurityChecksFailed = new opcua_status_code_1.ConstantStatusCode({
      name: "BadSecurityChecksFailed",
      value: 2148728832,
      description: "An error occurred verifying security."
    });
    StatusCodes.BadCertificatePolicyCheckFailed = new opcua_status_code_1.ConstantStatusCode({
      name: "BadCertificatePolicyCheckFailed",
      value: 2165571584,
      description: "The certificate does not meet the requirements of the security policy."
    });
    StatusCodes.BadCertificateTimeInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadCertificateTimeInvalid",
      value: 2148794368,
      description: "The certificate has expired or is not yet valid."
    });
    StatusCodes.BadCertificateIssuerTimeInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadCertificateIssuerTimeInvalid",
      value: 2148859904,
      description: "An issuer certificate has expired or is not yet valid."
    });
    StatusCodes.BadCertificateHostNameInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadCertificateHostNameInvalid",
      value: 2148925440,
      description: "The HostName used to connect to a server does not match a HostName in the certificate."
    });
    StatusCodes.BadCertificateUriInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadCertificateUriInvalid",
      value: 2148990976,
      description: "The URI specified in the ApplicationDescription does not match the URI in the certificate."
    });
    StatusCodes.BadCertificateUseNotAllowed = new opcua_status_code_1.ConstantStatusCode({
      name: "BadCertificateUseNotAllowed",
      value: 2149056512,
      description: "The certificate may not be used for the requested operation."
    });
    StatusCodes.BadCertificateIssuerUseNotAllowed = new opcua_status_code_1.ConstantStatusCode({
      name: "BadCertificateIssuerUseNotAllowed",
      value: 2149122048,
      description: "The issuer certificate may not be used for the requested operation."
    });
    StatusCodes.BadCertificateUntrusted = new opcua_status_code_1.ConstantStatusCode({
      name: "BadCertificateUntrusted",
      value: 2149187584,
      description: "The certificate is not trusted."
    });
    StatusCodes.BadCertificateRevocationUnknown = new opcua_status_code_1.ConstantStatusCode({
      name: "BadCertificateRevocationUnknown",
      value: 2149253120,
      description: "It was not possible to determine if the certificate has been revoked."
    });
    StatusCodes.BadCertificateIssuerRevocationUnknown = new opcua_status_code_1.ConstantStatusCode({
      name: "BadCertificateIssuerRevocationUnknown",
      value: 2149318656,
      description: "It was not possible to determine if the issuer certificate has been revoked."
    });
    StatusCodes.BadCertificateRevoked = new opcua_status_code_1.ConstantStatusCode({
      name: "BadCertificateRevoked",
      value: 2149384192,
      description: "The certificate has been revoked."
    });
    StatusCodes.BadCertificateIssuerRevoked = new opcua_status_code_1.ConstantStatusCode({
      name: "BadCertificateIssuerRevoked",
      value: 2149449728,
      description: "The issuer certificate has been revoked."
    });
    StatusCodes.BadCertificateChainIncomplete = new opcua_status_code_1.ConstantStatusCode({
      name: "BadCertificateChainIncomplete",
      value: 2165112832,
      description: "The certificate chain is incomplete."
    });
    StatusCodes.BadUserAccessDenied = new opcua_status_code_1.ConstantStatusCode({
      name: "BadUserAccessDenied",
      value: 2149515264,
      description: "User does not have permission to perform the requested operation."
    });
    StatusCodes.BadIdentityTokenInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadIdentityTokenInvalid",
      value: 2149580800,
      description: "The user identity token is not valid."
    });
    StatusCodes.BadIdentityTokenRejected = new opcua_status_code_1.ConstantStatusCode({
      name: "BadIdentityTokenRejected",
      value: 2149646336,
      description: "The user identity token is valid but the server has rejected it."
    });
    StatusCodes.BadSecureChannelIdInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadSecureChannelIdInvalid",
      value: 2149711872,
      description: "The specified secure channel is no longer valid."
    });
    StatusCodes.BadInvalidTimestamp = new opcua_status_code_1.ConstantStatusCode({
      name: "BadInvalidTimestamp",
      value: 2149777408,
      description: "The timestamp is outside the range allowed by the server."
    });
    StatusCodes.BadNonceInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNonceInvalid",
      value: 2149842944,
      description: "The nonce does appear to be not a random value or it is not the correct length."
    });
    StatusCodes.BadSessionIdInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadSessionIdInvalid",
      value: 2149908480,
      description: "The session id is not valid."
    });
    StatusCodes.BadSessionClosed = new opcua_status_code_1.ConstantStatusCode({
      name: "BadSessionClosed",
      value: 2149974016,
      description: "The session was closed by the client."
    });
    StatusCodes.BadSessionNotActivated = new opcua_status_code_1.ConstantStatusCode({
      name: "BadSessionNotActivated",
      value: 2150039552,
      description: "The session cannot be used because ActivateSession has not been called."
    });
    StatusCodes.BadSubscriptionIdInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadSubscriptionIdInvalid",
      value: 2150105088,
      description: "The subscription id is not valid."
    });
    StatusCodes.BadRequestHeaderInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadRequestHeaderInvalid",
      value: 2150236160,
      description: "The header for the request is missing or invalid."
    });
    StatusCodes.BadTimestampsToReturnInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTimestampsToReturnInvalid",
      value: 2150301696,
      description: "The timestamps to return parameter is invalid."
    });
    StatusCodes.BadRequestCancelledByClient = new opcua_status_code_1.ConstantStatusCode({
      name: "BadRequestCancelledByClient",
      value: 2150367232,
      description: "The request was cancelled by the client."
    });
    StatusCodes.BadTooManyArguments = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTooManyArguments",
      value: 2162491392,
      description: "Too many arguments were provided."
    });
    StatusCodes.BadLicenseExpired = new opcua_status_code_1.ConstantStatusCode({
      name: "BadLicenseExpired",
      value: 2165178368,
      description: "The server requires a license to operate in general or to perform a service or operation, but existing license is expired."
    });
    StatusCodes.BadLicenseLimitsExceeded = new opcua_status_code_1.ConstantStatusCode({
      name: "BadLicenseLimitsExceeded",
      value: 2165243904,
      description: "The server has limits on number of allowed operations / objects, based on installed licenses, and these limits where exceeded."
    });
    StatusCodes.BadLicenseNotAvailable = new opcua_status_code_1.ConstantStatusCode({
      name: "BadLicenseNotAvailable",
      value: 2165309440,
      description: "The server does not have a license which is required to operate in general or to perform a service or operation."
    });
    StatusCodes.BadServerTooBusy = new opcua_status_code_1.ConstantStatusCode({
      name: "BadServerTooBusy",
      value: 2163081216,
      description: "The Server does not have the resources to process the request at this time."
    });
    StatusCodes.GoodPasswordChangeRequired = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodPasswordChangeRequired",
      value: 15663104,
      description: "The log-on for the user succeeded but the user is required to change the password."
    });
    StatusCodes.GoodSubscriptionTransferred = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodSubscriptionTransferred",
      value: 2949120,
      description: "The subscription was transferred to another session."
    });
    StatusCodes.GoodCompletesAsynchronously = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodCompletesAsynchronously",
      value: 3014656,
      description: "The processing will complete asynchronously."
    });
    StatusCodes.GoodOverload = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodOverload",
      value: 3080192,
      description: "Sampling has slowed down due to resource limitations."
    });
    StatusCodes.GoodClamped = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodClamped",
      value: 3145728,
      description: "The value written was accepted but was clamped."
    });
    StatusCodes.BadNoCommunication = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNoCommunication",
      value: 2150694912,
      description: "Communication with the data source is defined, but not established, and there is no last known value available."
    });
    StatusCodes.BadWaitingForInitialData = new opcua_status_code_1.ConstantStatusCode({
      name: "BadWaitingForInitialData",
      value: 2150760448,
      description: "Waiting for the server to obtain values from the underlying data source."
    });
    StatusCodes.BadNodeIdInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNodeIdInvalid",
      value: 2150825984,
      description: "The syntax the node id is not valid or refers to a node that is not valid for the operation."
    });
    StatusCodes.BadNodeIdUnknown = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNodeIdUnknown",
      value: 2150891520,
      description: "The node id refers to a node that does not exist in the server address space."
    });
    StatusCodes.BadAttributeIdInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadAttributeIdInvalid",
      value: 2150957056,
      description: "The attribute is not supported for the specified Node."
    });
    StatusCodes.BadIndexRangeInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadIndexRangeInvalid",
      value: 2151022592,
      description: "The syntax of the index range parameter is invalid."
    });
    StatusCodes.BadIndexRangeNoData = new opcua_status_code_1.ConstantStatusCode({
      name: "BadIndexRangeNoData",
      value: 2151088128,
      description: "No data exists within the range of indexes specified."
    });
    StatusCodes.BadIndexRangeDataMismatch = new opcua_status_code_1.ConstantStatusCode({
      name: "BadIndexRangeDataMismatch",
      value: 2162819072,
      description: "The written data does not match the IndexRange specified."
    });
    StatusCodes.BadDataEncodingInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadDataEncodingInvalid",
      value: 2151153664,
      description: "The data encoding is invalid."
    });
    StatusCodes.BadDataEncodingUnsupported = new opcua_status_code_1.ConstantStatusCode({
      name: "BadDataEncodingUnsupported",
      value: 2151219200,
      description: "The server does not support the requested data encoding for the node."
    });
    StatusCodes.BadNotReadable = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNotReadable",
      value: 2151284736,
      description: "The access level does not allow reading or subscribing to the Node."
    });
    StatusCodes.BadNotWritable = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNotWritable",
      value: 2151350272,
      description: "The access level does not allow writing to the Node."
    });
    StatusCodes.BadOutOfRange = new opcua_status_code_1.ConstantStatusCode({
      name: "BadOutOfRange",
      value: 2151415808,
      description: "The value was out of range."
    });
    StatusCodes.BadNotSupported = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNotSupported",
      value: 2151481344,
      description: "The requested operation is not supported."
    });
    StatusCodes.BadNotFound = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNotFound",
      value: 2151546880,
      description: "A requested item was not found or a search operation ended without success."
    });
    StatusCodes.BadObjectDeleted = new opcua_status_code_1.ConstantStatusCode({
      name: "BadObjectDeleted",
      value: 2151612416,
      description: "The object cannot be used because it has been deleted."
    });
    StatusCodes.BadNotImplemented = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNotImplemented",
      value: 2151677952,
      description: "Requested operation is not implemented."
    });
    StatusCodes.BadMonitoringModeInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadMonitoringModeInvalid",
      value: 2151743488,
      description: "The monitoring mode is invalid."
    });
    StatusCodes.BadMonitoredItemIdInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadMonitoredItemIdInvalid",
      value: 2151809024,
      description: "The monitoring item id does not refer to a valid monitored item."
    });
    StatusCodes.BadMonitoredItemFilterInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadMonitoredItemFilterInvalid",
      value: 2151874560,
      description: "The monitored item filter parameter is not valid."
    });
    StatusCodes.BadMonitoredItemFilterUnsupported = new opcua_status_code_1.ConstantStatusCode({
      name: "BadMonitoredItemFilterUnsupported",
      value: 2151940096,
      description: "The server does not support the requested monitored item filter."
    });
    StatusCodes.BadFilterNotAllowed = new opcua_status_code_1.ConstantStatusCode({
      name: "BadFilterNotAllowed",
      value: 2152005632,
      description: "A monitoring filter cannot be used in combination with the attribute specified."
    });
    StatusCodes.BadStructureMissing = new opcua_status_code_1.ConstantStatusCode({
      name: "BadStructureMissing",
      value: 2152071168,
      description: "A mandatory structured parameter was missing or null."
    });
    StatusCodes.BadEventFilterInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadEventFilterInvalid",
      value: 2152136704,
      description: "The event filter is not valid."
    });
    StatusCodes.BadContentFilterInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadContentFilterInvalid",
      value: 2152202240,
      description: "The content filter is not valid."
    });
    StatusCodes.BadFilterOperatorInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadFilterOperatorInvalid",
      value: 2160132096,
      description: "An unrecognized operator was provided in a filter."
    });
    StatusCodes.BadFilterOperatorUnsupported = new opcua_status_code_1.ConstantStatusCode({
      name: "BadFilterOperatorUnsupported",
      value: 2160197632,
      description: "A valid operator was provided, but the server does not provide support for this filter operator."
    });
    StatusCodes.BadFilterOperandCountMismatch = new opcua_status_code_1.ConstantStatusCode({
      name: "BadFilterOperandCountMismatch",
      value: 2160263168,
      description: "The number of operands provided for the filter operator was less then expected for the operand provided."
    });
    StatusCodes.BadFilterOperandInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadFilterOperandInvalid",
      value: 2152267776,
      description: "The operand used in a content filter is not valid."
    });
    StatusCodes.BadFilterElementInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadFilterElementInvalid",
      value: 2160328704,
      description: "The referenced element is not a valid element in the content filter."
    });
    StatusCodes.BadFilterLiteralInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadFilterLiteralInvalid",
      value: 2160394240,
      description: "The referenced literal is not a valid value."
    });
    StatusCodes.BadContinuationPointInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadContinuationPointInvalid",
      value: 2152333312,
      description: "The continuation point provide is longer valid."
    });
    StatusCodes.BadNoContinuationPoints = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNoContinuationPoints",
      value: 2152398848,
      description: "The operation could not be processed because all continuation points have been allocated."
    });
    StatusCodes.BadReferenceTypeIdInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadReferenceTypeIdInvalid",
      value: 2152464384,
      description: "The reference type id does not refer to a valid reference type node."
    });
    StatusCodes.BadBrowseDirectionInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadBrowseDirectionInvalid",
      value: 2152529920,
      description: "The browse direction is not valid."
    });
    StatusCodes.BadNodeNotInView = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNodeNotInView",
      value: 2152595456,
      description: "The node is not part of the view."
    });
    StatusCodes.BadNumericOverflow = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNumericOverflow",
      value: 2165440512,
      description: "The number was not accepted because of a numeric overflow."
    });
    StatusCodes.BadLocaleNotSupported = new opcua_status_code_1.ConstantStatusCode({
      name: "BadLocaleNotSupported",
      value: 2163015680,
      description: "The locale in the requested write operation is not supported."
    });
    StatusCodes.BadNoValue = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNoValue",
      value: 2163212288,
      description: "The variable has no default value and no initial value."
    });
    StatusCodes.BadServerUriInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadServerUriInvalid",
      value: 2152660992,
      description: "The ServerUri is not a valid URI."
    });
    StatusCodes.BadServerNameMissing = new opcua_status_code_1.ConstantStatusCode({
      name: "BadServerNameMissing",
      value: 2152726528,
      description: "No ServerName was specified."
    });
    StatusCodes.BadDiscoveryUrlMissing = new opcua_status_code_1.ConstantStatusCode({
      name: "BadDiscoveryUrlMissing",
      value: 2152792064,
      description: "No DiscoveryUrl was specified."
    });
    StatusCodes.BadSempahoreFileMissing = new opcua_status_code_1.ConstantStatusCode({
      name: "BadSempahoreFileMissing",
      value: 2152857600,
      description: "The semaphore file specified by the client is not valid."
    });
    StatusCodes.BadRequestTypeInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadRequestTypeInvalid",
      value: 2152923136,
      description: "The security token request type is not valid."
    });
    StatusCodes.BadSecurityModeRejected = new opcua_status_code_1.ConstantStatusCode({
      name: "BadSecurityModeRejected",
      value: 2152988672,
      description: "The security mode does not meet the requirements set by the server."
    });
    StatusCodes.BadSecurityPolicyRejected = new opcua_status_code_1.ConstantStatusCode({
      name: "BadSecurityPolicyRejected",
      value: 2153054208,
      description: "The security policy does not meet the requirements set by the server."
    });
    StatusCodes.BadTooManySessions = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTooManySessions",
      value: 2153119744,
      description: "The server has reached its maximum number of sessions."
    });
    StatusCodes.BadUserSignatureInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadUserSignatureInvalid",
      value: 2153185280,
      description: "The user token signature is missing or invalid."
    });
    StatusCodes.BadApplicationSignatureInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadApplicationSignatureInvalid",
      value: 2153250816,
      description: "The signature generated with the client certificate is missing or invalid."
    });
    StatusCodes.BadNoValidCertificates = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNoValidCertificates",
      value: 2153316352,
      description: "The client did not provide at least one software certificate that is valid and meets the profile requirements for the server."
    });
    StatusCodes.BadIdentityChangeNotSupported = new opcua_status_code_1.ConstantStatusCode({
      name: "BadIdentityChangeNotSupported",
      value: 2160459776,
      description: "The server does not support changing the user identity assigned to the session."
    });
    StatusCodes.BadRequestCancelledByRequest = new opcua_status_code_1.ConstantStatusCode({
      name: "BadRequestCancelledByRequest",
      value: 2153381888,
      description: "The request was cancelled by the client with the Cancel service."
    });
    StatusCodes.BadParentNodeIdInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadParentNodeIdInvalid",
      value: 2153447424,
      description: "The parent node id does not to refer to a valid node."
    });
    StatusCodes.BadReferenceNotAllowed = new opcua_status_code_1.ConstantStatusCode({
      name: "BadReferenceNotAllowed",
      value: 2153512960,
      description: "The reference could not be created because it violates constraints imposed by the data model."
    });
    StatusCodes.BadNodeIdRejected = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNodeIdRejected",
      value: 2153578496,
      description: "The requested node id was reject because it was either invalid or server does not allow node ids to be specified by the client."
    });
    StatusCodes.BadNodeIdExists = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNodeIdExists",
      value: 2153644032,
      description: "The requested node id is already used by another node."
    });
    StatusCodes.BadNodeClassInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNodeClassInvalid",
      value: 2153709568,
      description: "The node class is not valid."
    });
    StatusCodes.BadBrowseNameInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadBrowseNameInvalid",
      value: 2153775104,
      description: "The browse name is invalid."
    });
    StatusCodes.BadBrowseNameDuplicated = new opcua_status_code_1.ConstantStatusCode({
      name: "BadBrowseNameDuplicated",
      value: 2153840640,
      description: "The browse name is not unique among nodes that share the same relationship with the parent."
    });
    StatusCodes.BadNodeAttributesInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNodeAttributesInvalid",
      value: 2153906176,
      description: "The node attributes are not valid for the node class."
    });
    StatusCodes.BadTypeDefinitionInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTypeDefinitionInvalid",
      value: 2153971712,
      description: "The type definition node id does not reference an appropriate type node."
    });
    StatusCodes.BadSourceNodeIdInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadSourceNodeIdInvalid",
      value: 2154037248,
      description: "The source node id does not reference a valid node."
    });
    StatusCodes.BadTargetNodeIdInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTargetNodeIdInvalid",
      value: 2154102784,
      description: "The target node id does not reference a valid node."
    });
    StatusCodes.BadDuplicateReferenceNotAllowed = new opcua_status_code_1.ConstantStatusCode({
      name: "BadDuplicateReferenceNotAllowed",
      value: 2154168320,
      description: "The reference type between the nodes is already defined."
    });
    StatusCodes.BadInvalidSelfReference = new opcua_status_code_1.ConstantStatusCode({
      name: "BadInvalidSelfReference",
      value: 2154233856,
      description: "The server does not allow this type of self reference on this node."
    });
    StatusCodes.BadReferenceLocalOnly = new opcua_status_code_1.ConstantStatusCode({
      name: "BadReferenceLocalOnly",
      value: 2154299392,
      description: "The reference type is not valid for a reference to a remote server."
    });
    StatusCodes.BadNoDeleteRights = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNoDeleteRights",
      value: 2154364928,
      description: "The server will not allow the node to be deleted."
    });
    StatusCodes.UncertainReferenceNotDeleted = new opcua_status_code_1.ConstantStatusCode({
      name: "UncertainReferenceNotDeleted",
      value: 1086062592,
      description: "The server was not able to delete all target references."
    });
    StatusCodes.BadServerIndexInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadServerIndexInvalid",
      value: 2154430464,
      description: "The server index is not valid."
    });
    StatusCodes.BadViewIdUnknown = new opcua_status_code_1.ConstantStatusCode({
      name: "BadViewIdUnknown",
      value: 2154496e3,
      description: "The view id does not refer to a valid view node."
    });
    StatusCodes.BadViewTimestampInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadViewTimestampInvalid",
      value: 2160656384,
      description: "The view timestamp is not available or not supported."
    });
    StatusCodes.BadViewParameterMismatch = new opcua_status_code_1.ConstantStatusCode({
      name: "BadViewParameterMismatch",
      value: 2160721920,
      description: "The view parameters are not consistent with each other."
    });
    StatusCodes.BadViewVersionInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadViewVersionInvalid",
      value: 2160787456,
      description: "The view version is not available or not supported."
    });
    StatusCodes.UncertainNotAllNodesAvailable = new opcua_status_code_1.ConstantStatusCode({
      name: "UncertainNotAllNodesAvailable",
      value: 1086324736,
      description: "The list of references may not be complete because the underlying system is not available."
    });
    StatusCodes.GoodResultsMayBeIncomplete = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodResultsMayBeIncomplete",
      value: 12189696,
      description: "The server should have followed a reference to a node in a remote server but did not. The result set may be incomplete."
    });
    StatusCodes.BadNotTypeDefinition = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNotTypeDefinition",
      value: 2160590848,
      description: "The provided Nodeid was not a type definition nodeid."
    });
    StatusCodes.UncertainReferenceOutOfServer = new opcua_status_code_1.ConstantStatusCode({
      name: "UncertainReferenceOutOfServer",
      value: 1080819712,
      description: "One of the references to follow in the relative path references to a node in the address space in another server."
    });
    StatusCodes.BadTooManyMatches = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTooManyMatches",
      value: 2154627072,
      description: "The requested operation has too many matches to return."
    });
    StatusCodes.BadQueryTooComplex = new opcua_status_code_1.ConstantStatusCode({
      name: "BadQueryTooComplex",
      value: 2154692608,
      description: "The requested operation requires too many resources in the server."
    });
    StatusCodes.BadNoMatch = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNoMatch",
      value: 2154758144,
      description: "The requested operation has no match to return."
    });
    StatusCodes.BadMaxAgeInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadMaxAgeInvalid",
      value: 2154823680,
      description: "The max age parameter is invalid."
    });
    StatusCodes.BadSecurityModeInsufficient = new opcua_status_code_1.ConstantStatusCode({
      name: "BadSecurityModeInsufficient",
      value: 2162556928,
      description: "The operation is not permitted over the current secure channel."
    });
    StatusCodes.BadHistoryOperationInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadHistoryOperationInvalid",
      value: 2154889216,
      description: "The history details parameter is not valid."
    });
    StatusCodes.BadHistoryOperationUnsupported = new opcua_status_code_1.ConstantStatusCode({
      name: "BadHistoryOperationUnsupported",
      value: 2154954752,
      description: "The server does not support the requested operation."
    });
    StatusCodes.BadInvalidTimestampArgument = new opcua_status_code_1.ConstantStatusCode({
      name: "BadInvalidTimestampArgument",
      value: 2159869952,
      description: "The defined timestamp to return was invalid."
    });
    StatusCodes.BadWriteNotSupported = new opcua_status_code_1.ConstantStatusCode({
      name: "BadWriteNotSupported",
      value: 2155020288,
      description: "The server does not support writing the combination of value, status and timestamps provided."
    });
    StatusCodes.BadTypeMismatch = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTypeMismatch",
      value: 2155085824,
      description: "The value supplied for the attribute is not of the same type as the attribute's value."
    });
    StatusCodes.BadMethodInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadMethodInvalid",
      value: 2155151360,
      description: "The method id does not refer to a method for the specified object."
    });
    StatusCodes.BadArgumentsMissing = new opcua_status_code_1.ConstantStatusCode({
      name: "BadArgumentsMissing",
      value: 2155216896,
      description: "The client did not specify all of the input arguments for the method."
    });
    StatusCodes.BadNotExecutable = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNotExecutable",
      value: 2165374976,
      description: "The executable attribute does not allow the execution of the method."
    });
    StatusCodes.BadTooManySubscriptions = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTooManySubscriptions",
      value: 2155282432,
      description: "The server has reached its maximum number of subscriptions."
    });
    StatusCodes.BadTooManyPublishRequests = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTooManyPublishRequests",
      value: 2155347968,
      description: "The server has reached the maximum number of queued publish requests."
    });
    StatusCodes.BadNoSubscription = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNoSubscription",
      value: 2155413504,
      description: "There is no subscription available for this session."
    });
    StatusCodes.BadSequenceNumberUnknown = new opcua_status_code_1.ConstantStatusCode({
      name: "BadSequenceNumberUnknown",
      value: 2155479040,
      description: "The sequence number is unknown to the server."
    });
    StatusCodes.GoodRetransmissionQueueNotSupported = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodRetransmissionQueueNotSupported",
      value: 14614528,
      description: "The Server does not support retransmission queue and acknowledgement of sequence numbers is not available."
    });
    StatusCodes.BadMessageNotAvailable = new opcua_status_code_1.ConstantStatusCode({
      name: "BadMessageNotAvailable",
      value: 2155544576,
      description: "The requested notification message is no longer available."
    });
    StatusCodes.BadInsufficientClientProfile = new opcua_status_code_1.ConstantStatusCode({
      name: "BadInsufficientClientProfile",
      value: 2155610112,
      description: "The client of the current session does not support one or more Profiles that are necessary for the subscription."
    });
    StatusCodes.BadStateNotActive = new opcua_status_code_1.ConstantStatusCode({
      name: "BadStateNotActive",
      value: 2160001024,
      description: "The sub-state machine is not currently active."
    });
    StatusCodes.BadAlreadyExists = new opcua_status_code_1.ConstantStatusCode({
      name: "BadAlreadyExists",
      value: 2165637120,
      description: "An equivalent rule already exists."
    });
    StatusCodes.BadTcpServerTooBusy = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTcpServerTooBusy",
      value: 2155675648,
      description: "The server cannot process the request because it is too busy."
    });
    StatusCodes.BadTcpMessageTypeInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTcpMessageTypeInvalid",
      value: 2155741184,
      description: "The type of the message specified in the header invalid."
    });
    StatusCodes.BadTcpSecureChannelUnknown = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTcpSecureChannelUnknown",
      value: 2155806720,
      description: "The SecureChannelId and/or TokenId are not currently in use."
    });
    StatusCodes.BadTcpMessageTooLarge = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTcpMessageTooLarge",
      value: 2155872256,
      description: "The size of the message chunk specified in the header is too large."
    });
    StatusCodes.BadTcpNotEnoughResources = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTcpNotEnoughResources",
      value: 2155937792,
      description: "There are not enough resources to process the request."
    });
    StatusCodes.BadTcpInternalError = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTcpInternalError",
      value: 2156003328,
      description: "An internal error occurred."
    });
    StatusCodes.BadTcpEndpointUrlInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTcpEndpointUrlInvalid",
      value: 2156068864,
      description: "The server does not recognize the QueryString specified."
    });
    StatusCodes.BadRequestInterrupted = new opcua_status_code_1.ConstantStatusCode({
      name: "BadRequestInterrupted",
      value: 2156134400,
      description: "The request could not be sent because of a network interruption."
    });
    StatusCodes.BadRequestTimeout = new opcua_status_code_1.ConstantStatusCode({
      name: "BadRequestTimeout",
      value: 2156199936,
      description: "Timeout occurred while processing the request."
    });
    StatusCodes.BadSecureChannelClosed = new opcua_status_code_1.ConstantStatusCode({
      name: "BadSecureChannelClosed",
      value: 2156265472,
      description: "The secure channel has been closed."
    });
    StatusCodes.BadSecureChannelTokenUnknown = new opcua_status_code_1.ConstantStatusCode({
      name: "BadSecureChannelTokenUnknown",
      value: 2156331008,
      description: "The token has expired or is not recognized."
    });
    StatusCodes.BadSequenceNumberInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadSequenceNumberInvalid",
      value: 2156396544,
      description: "The sequence number is not valid."
    });
    StatusCodes.BadProtocolVersionUnsupported = new opcua_status_code_1.ConstantStatusCode({
      name: "BadProtocolVersionUnsupported",
      value: 2159935488,
      description: "The applications do not have compatible protocol versions."
    });
    StatusCodes.BadConfigurationError = new opcua_status_code_1.ConstantStatusCode({
      name: "BadConfigurationError",
      value: 2156462080,
      description: "There is a problem with the configuration that affects the usefulness of the value."
    });
    StatusCodes.BadNotConnected = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNotConnected",
      value: 2156527616,
      description: "The variable should receive its value from another variable, but has never been configured to do so."
    });
    StatusCodes.BadDeviceFailure = new opcua_status_code_1.ConstantStatusCode({
      name: "BadDeviceFailure",
      value: 2156593152,
      description: "There has been a failure in the device/data source that generates the value that has affected the value."
    });
    StatusCodes.BadSensorFailure = new opcua_status_code_1.ConstantStatusCode({
      name: "BadSensorFailure",
      value: 2156658688,
      description: "There has been a failure in the sensor from which the value is derived by the device/data source."
    });
    StatusCodes.BadOutOfService = new opcua_status_code_1.ConstantStatusCode({
      name: "BadOutOfService",
      value: 2156724224,
      description: "The source of the data is not operational."
    });
    StatusCodes.BadDeadbandFilterInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadDeadbandFilterInvalid",
      value: 2156789760,
      description: "The deadband filter is not valid."
    });
    StatusCodes.UncertainNoCommunicationLastUsableValue = new opcua_status_code_1.ConstantStatusCode({
      name: "UncertainNoCommunicationLastUsableValue",
      value: 1083113472,
      description: "Communication to the data source has failed. The variable value is the last value that had a good quality."
    });
    StatusCodes.UncertainLastUsableValue = new opcua_status_code_1.ConstantStatusCode({
      name: "UncertainLastUsableValue",
      value: 1083179008,
      description: "Whatever was updating this value has stopped doing so."
    });
    StatusCodes.UncertainSubstituteValue = new opcua_status_code_1.ConstantStatusCode({
      name: "UncertainSubstituteValue",
      value: 1083244544,
      description: "The value is an operational value that was manually overwritten."
    });
    StatusCodes.UncertainInitialValue = new opcua_status_code_1.ConstantStatusCode({
      name: "UncertainInitialValue",
      value: 1083310080,
      description: "The value is an initial value for a variable that normally receives its value from another variable."
    });
    StatusCodes.UncertainSensorNotAccurate = new opcua_status_code_1.ConstantStatusCode({
      name: "UncertainSensorNotAccurate",
      value: 1083375616,
      description: "The value is at one of the sensor limits."
    });
    StatusCodes.UncertainEngineeringUnitsExceeded = new opcua_status_code_1.ConstantStatusCode({
      name: "UncertainEngineeringUnitsExceeded",
      value: 1083441152,
      description: "The value is outside of the range of values defined for this parameter."
    });
    StatusCodes.UncertainSubNormal = new opcua_status_code_1.ConstantStatusCode({
      name: "UncertainSubNormal",
      value: 1083506688,
      description: "The data value is derived from multiple sources and has less than the required number of Good sources."
    });
    StatusCodes.GoodLocalOverride = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodLocalOverride",
      value: 9830400,
      description: "The value has been overridden."
    });
    StatusCodes.GoodSubNormal = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodSubNormal",
      value: 15400960,
      description: "The value is derived from multiple sources and has the required number of Good sources, but less than the full number of Good sources."
    });
    StatusCodes.BadRefreshInProgress = new opcua_status_code_1.ConstantStatusCode({
      name: "BadRefreshInProgress",
      value: 2157379584,
      description: "This Condition refresh failed, a Condition refresh operation is already in progress."
    });
    StatusCodes.BadConditionAlreadyDisabled = new opcua_status_code_1.ConstantStatusCode({
      name: "BadConditionAlreadyDisabled",
      value: 2157445120,
      description: "This condition has already been disabled."
    });
    StatusCodes.BadConditionAlreadyEnabled = new opcua_status_code_1.ConstantStatusCode({
      name: "BadConditionAlreadyEnabled",
      value: 2160852992,
      description: "This condition has already been enabled."
    });
    StatusCodes.BadConditionDisabled = new opcua_status_code_1.ConstantStatusCode({
      name: "BadConditionDisabled",
      value: 2157510656,
      description: "Property not available, this condition is disabled."
    });
    StatusCodes.BadEventIdUnknown = new opcua_status_code_1.ConstantStatusCode({
      name: "BadEventIdUnknown",
      value: 2157576192,
      description: "The specified event id is not recognized."
    });
    StatusCodes.BadEventNotAcknowledgeable = new opcua_status_code_1.ConstantStatusCode({
      name: "BadEventNotAcknowledgeable",
      value: 2159738880,
      description: "The event cannot be acknowledged."
    });
    StatusCodes.BadDialogNotActive = new opcua_status_code_1.ConstantStatusCode({
      name: "BadDialogNotActive",
      value: 2160918528,
      description: "The dialog condition is not active."
    });
    StatusCodes.BadDialogResponseInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadDialogResponseInvalid",
      value: 2160984064,
      description: "The response is not valid for the dialog."
    });
    StatusCodes.BadConditionBranchAlreadyAcked = new opcua_status_code_1.ConstantStatusCode({
      name: "BadConditionBranchAlreadyAcked",
      value: 2161049600,
      description: "The condition branch has already been acknowledged."
    });
    StatusCodes.BadConditionBranchAlreadyConfirmed = new opcua_status_code_1.ConstantStatusCode({
      name: "BadConditionBranchAlreadyConfirmed",
      value: 2161115136,
      description: "The condition branch has already been confirmed."
    });
    StatusCodes.BadConditionAlreadyShelved = new opcua_status_code_1.ConstantStatusCode({
      name: "BadConditionAlreadyShelved",
      value: 2161180672,
      description: "The condition has already been shelved."
    });
    StatusCodes.BadConditionNotShelved = new opcua_status_code_1.ConstantStatusCode({
      name: "BadConditionNotShelved",
      value: 2161246208,
      description: "The condition is not currently shelved."
    });
    StatusCodes.BadShelvingTimeOutOfRange = new opcua_status_code_1.ConstantStatusCode({
      name: "BadShelvingTimeOutOfRange",
      value: 2161311744,
      description: "The shelving time not within an acceptable range."
    });
    StatusCodes.BadNoData = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNoData",
      value: 2157641728,
      description: "No data exists for the requested time range or event filter."
    });
    StatusCodes.BadBoundNotFound = new opcua_status_code_1.ConstantStatusCode({
      name: "BadBoundNotFound",
      value: 2161573888,
      description: "No data found to provide upper or lower bound value."
    });
    StatusCodes.BadBoundNotSupported = new opcua_status_code_1.ConstantStatusCode({
      name: "BadBoundNotSupported",
      value: 2161639424,
      description: "The server cannot retrieve a bound for the variable."
    });
    StatusCodes.BadDataLost = new opcua_status_code_1.ConstantStatusCode({
      name: "BadDataLost",
      value: 2157772800,
      description: "Data is missing due to collection started/stopped/lost."
    });
    StatusCodes.BadDataUnavailable = new opcua_status_code_1.ConstantStatusCode({
      name: "BadDataUnavailable",
      value: 2157838336,
      description: "Expected data is unavailable for the requested time range due to an un-mounted volume, an off-line archive or tape, or similar reason for temporary unavailability."
    });
    StatusCodes.BadEntryExists = new opcua_status_code_1.ConstantStatusCode({
      name: "BadEntryExists",
      value: 2157903872,
      description: "The data or event was not successfully inserted because a matching entry exists."
    });
    StatusCodes.BadNoEntryExists = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNoEntryExists",
      value: 2157969408,
      description: "The data or event was not successfully updated because no matching entry exists."
    });
    StatusCodes.BadTimestampNotSupported = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTimestampNotSupported",
      value: 2158034944,
      description: "The Client requested history using a TimestampsToReturn the Server does not support."
    });
    StatusCodes.GoodEntryInserted = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodEntryInserted",
      value: 10616832,
      description: "The data or event was successfully inserted into the historical database."
    });
    StatusCodes.GoodEntryReplaced = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodEntryReplaced",
      value: 10682368,
      description: "The data or event field was successfully replaced in the historical database."
    });
    StatusCodes.UncertainDataSubNormal = new opcua_status_code_1.ConstantStatusCode({
      name: "UncertainDataSubNormal",
      value: 1084489728,
      description: "The aggregate value is derived from multiple values and has less than the required number of Good values."
    });
    StatusCodes.GoodNoData = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodNoData",
      value: 10813440,
      description: "No data exists for the requested time range or event filter."
    });
    StatusCodes.GoodMoreData = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodMoreData",
      value: 10878976,
      description: "More data is available in the time range beyond the number of values requested."
    });
    StatusCodes.BadAggregateListMismatch = new opcua_status_code_1.ConstantStatusCode({
      name: "BadAggregateListMismatch",
      value: 2161377280,
      description: "The requested number of Aggregates does not match the requested number of NodeIds."
    });
    StatusCodes.BadAggregateNotSupported = new opcua_status_code_1.ConstantStatusCode({
      name: "BadAggregateNotSupported",
      value: 2161442816,
      description: "The requested Aggregate is not support by the server."
    });
    StatusCodes.BadAggregateInvalidInputs = new opcua_status_code_1.ConstantStatusCode({
      name: "BadAggregateInvalidInputs",
      value: 2161508352,
      description: "The aggregate value could not be derived due to invalid data inputs."
    });
    StatusCodes.BadAggregateConfigurationRejected = new opcua_status_code_1.ConstantStatusCode({
      name: "BadAggregateConfigurationRejected",
      value: 2161770496,
      description: "The aggregate configuration is not valid for specified node."
    });
    StatusCodes.GoodDataIgnored = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodDataIgnored",
      value: 14221312,
      description: "The request specifies fields which are not valid for the EventType or cannot be saved by the historian."
    });
    StatusCodes.BadRequestNotAllowed = new opcua_status_code_1.ConstantStatusCode({
      name: "BadRequestNotAllowed",
      value: 2162425856,
      description: "The request was rejected by the server because it did not meet the criteria set by the server."
    });
    StatusCodes.BadRequestNotComplete = new opcua_status_code_1.ConstantStatusCode({
      name: "BadRequestNotComplete",
      value: 2165506048,
      description: "The request has not been processed by the server yet."
    });
    StatusCodes.BadTransactionPending = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTransactionPending",
      value: 2162688e3,
      description: "The operation is not allowed because a transaction is in progress."
    });
    StatusCodes.BadTicketRequired = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTicketRequired",
      value: 2166292480,
      description: "The device identity needs a ticket before it can be accepted."
    });
    StatusCodes.BadTicketInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadTicketInvalid",
      value: 2166358016,
      description: "The device identity needs a ticket before it can be accepted."
    });
    StatusCodes.BadLocked = new opcua_status_code_1.ConstantStatusCode({
      name: "BadLocked",
      value: 2162753536,
      description: "The requested operation is not allowed, because the Node is locked by a different application."
    });
    StatusCodes.BadRequiresLock = new opcua_status_code_1.ConstantStatusCode({
      name: "BadRequiresLock",
      value: 2162950144,
      description: "The requested operation is not allowed, because the Node is not locked by the application."
    });
    StatusCodes.GoodEdited = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodEdited",
      value: 14417920,
      description: "The value does not come from the real source and has been edited by the server."
    });
    StatusCodes.GoodPostActionFailed = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodPostActionFailed",
      value: 14483456,
      description: "There was an error in execution of these post-actions."
    });
    StatusCodes.UncertainDominantValueChanged = new opcua_status_code_1.ConstantStatusCode({
      name: "UncertainDominantValueChanged",
      value: 1088290816,
      description: "The related EngineeringUnit has been changed but the Variable Value is still provided based on the previous unit."
    });
    StatusCodes.GoodDependentValueChanged = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodDependentValueChanged",
      value: 14680064,
      description: "A dependent value has been changed but the change has not been applied to the device."
    });
    StatusCodes.BadDominantValueChanged = new opcua_status_code_1.ConstantStatusCode({
      name: "BadDominantValueChanged",
      value: 2162229248,
      description: "The related EngineeringUnit has been changed but this change has not been applied to the device. The Variable Value is still dependent on the previous unit but its status is currently Bad."
    });
    StatusCodes.UncertainDependentValueChanged = new opcua_status_code_1.ConstantStatusCode({
      name: "UncertainDependentValueChanged",
      value: 1088552960,
      description: "A dependent value has been changed but the change has not been applied to the device. The quality of the dominant variable is uncertain."
    });
    StatusCodes.BadDependentValueChanged = new opcua_status_code_1.ConstantStatusCode({
      name: "BadDependentValueChanged",
      value: 2162360320,
      description: "A dependent value has been changed but the change has not been applied to the device. The quality of the dominant variable is Bad."
    });
    StatusCodes.GoodEdited_DependentValueChanged = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodEdited_DependentValueChanged",
      value: 18219008,
      description: "It is delivered with a dominant Variable value when a dependent Variable has changed but the change has not been applied."
    });
    StatusCodes.GoodEdited_DominantValueChanged = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodEdited_DominantValueChanged",
      value: 18284544,
      description: "It is delivered with a dependent Variable value when a dominant Variable has changed but the change has not been applied."
    });
    StatusCodes.GoodEdited_DominantValueChanged_DependentValueChanged = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodEdited_DominantValueChanged_DependentValueChanged",
      value: 18350080,
      description: "It is delivered with a dependent Variable value when a dominant or dependent Variable has changed but change has not been applied."
    });
    StatusCodes.BadEdited_OutOfRange = new opcua_status_code_1.ConstantStatusCode({
      name: "BadEdited_OutOfRange",
      value: 2165899264,
      description: "It is delivered with a Variable value when Variable has changed but the value is not legal."
    });
    StatusCodes.BadInitialValue_OutOfRange = new opcua_status_code_1.ConstantStatusCode({
      name: "BadInitialValue_OutOfRange",
      value: 2165964800,
      description: "It is delivered with a Variable value when a source Variable has changed but the value is not legal."
    });
    StatusCodes.BadOutOfRange_DominantValueChanged = new opcua_status_code_1.ConstantStatusCode({
      name: "BadOutOfRange_DominantValueChanged",
      value: 2166030336,
      description: "It is delivered with a dependent Variable value when a dominant Variable has changed and the value is not legal."
    });
    StatusCodes.BadEdited_OutOfRange_DominantValueChanged = new opcua_status_code_1.ConstantStatusCode({
      name: "BadEdited_OutOfRange_DominantValueChanged",
      value: 2166095872,
      description: "It is delivered with a dependent Variable value when a dominant Variable has changed, the value is not legal and the change has not been applied."
    });
    StatusCodes.BadOutOfRange_DominantValueChanged_DependentValueChanged = new opcua_status_code_1.ConstantStatusCode({
      name: "BadOutOfRange_DominantValueChanged_DependentValueChanged",
      value: 2166161408,
      description: "It is delivered with a dependent Variable value when a dominant or dependent Variable has changed and the value is not legal."
    });
    StatusCodes.BadEdited_OutOfRange_DominantValueChanged_DependentValueChanged = new opcua_status_code_1.ConstantStatusCode({
      name: "BadEdited_OutOfRange_DominantValueChanged_DependentValueChanged",
      value: 2166226944,
      description: "It is delivered with a dependent Variable value when a dominant or dependent Variable has changed, the value is not legal and the change has not been applied."
    });
    StatusCodes.GoodCommunicationEvent = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodCommunicationEvent",
      value: 10944512,
      description: "The communication layer has raised an event."
    });
    StatusCodes.GoodShutdownEvent = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodShutdownEvent",
      value: 11010048,
      description: "The system is shutting down."
    });
    StatusCodes.GoodCallAgain = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodCallAgain",
      value: 11075584,
      description: "The operation is not finished and needs to be called again."
    });
    StatusCodes.GoodNonCriticalTimeout = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodNonCriticalTimeout",
      value: 11141120,
      description: "A non-critical timeout occurred."
    });
    StatusCodes.BadInvalidArgument = new opcua_status_code_1.ConstantStatusCode({
      name: "BadInvalidArgument",
      value: 2158690304,
      description: "One or more arguments are invalid."
    });
    StatusCodes.BadConnectionRejected = new opcua_status_code_1.ConstantStatusCode({
      name: "BadConnectionRejected",
      value: 2158755840,
      description: "Could not establish a network connection to remote server."
    });
    StatusCodes.BadDisconnect = new opcua_status_code_1.ConstantStatusCode({
      name: "BadDisconnect",
      value: 2158821376,
      description: "The server has disconnected from the client."
    });
    StatusCodes.BadConnectionClosed = new opcua_status_code_1.ConstantStatusCode({
      name: "BadConnectionClosed",
      value: 2158886912,
      description: "The network connection has been closed."
    });
    StatusCodes.BadInvalidState = new opcua_status_code_1.ConstantStatusCode({
      name: "BadInvalidState",
      value: 2158952448,
      description: "The operation cannot be completed because the object is closed, uninitialized or in some other invalid state."
    });
    StatusCodes.BadEndOfStream = new opcua_status_code_1.ConstantStatusCode({
      name: "BadEndOfStream",
      value: 2159017984,
      description: "Cannot move beyond end of the stream."
    });
    StatusCodes.BadNoDataAvailable = new opcua_status_code_1.ConstantStatusCode({
      name: "BadNoDataAvailable",
      value: 2159083520,
      description: "No data is currently available for reading from a non-blocking stream."
    });
    StatusCodes.BadWaitingForResponse = new opcua_status_code_1.ConstantStatusCode({
      name: "BadWaitingForResponse",
      value: 2159149056,
      description: "The asynchronous operation is waiting for a response."
    });
    StatusCodes.BadOperationAbandoned = new opcua_status_code_1.ConstantStatusCode({
      name: "BadOperationAbandoned",
      value: 2159214592,
      description: "The asynchronous operation was abandoned by the caller."
    });
    StatusCodes.BadExpectedStreamToBlock = new opcua_status_code_1.ConstantStatusCode({
      name: "BadExpectedStreamToBlock",
      value: 2159280128,
      description: "The stream did not return all data requested (possibly because it is a non-blocking stream)."
    });
    StatusCodes.BadWouldBlock = new opcua_status_code_1.ConstantStatusCode({
      name: "BadWouldBlock",
      value: 2159345664,
      description: "Non blocking behaviour is required and the operation would block."
    });
    StatusCodes.BadSyntaxError = new opcua_status_code_1.ConstantStatusCode({
      name: "BadSyntaxError",
      value: 2159411200,
      description: "A value had an invalid syntax."
    });
    StatusCodes.BadMaxConnectionsReached = new opcua_status_code_1.ConstantStatusCode({
      name: "BadMaxConnectionsReached",
      value: 2159476736,
      description: "The operation could not be finished because all available connections are in use."
    });
    StatusCodes.UncertainTransducerInManual = new opcua_status_code_1.ConstantStatusCode({
      name: "UncertainTransducerInManual",
      value: 1107820544,
      description: "The value may not be accurate because the transducer is in manual mode."
    });
    StatusCodes.UncertainSimulatedValue = new opcua_status_code_1.ConstantStatusCode({
      name: "UncertainSimulatedValue",
      value: 1107886080,
      description: "The value is simulated."
    });
    StatusCodes.UncertainSensorCalibration = new opcua_status_code_1.ConstantStatusCode({
      name: "UncertainSensorCalibration",
      value: 1107951616,
      description: "The value may not be accurate due to a sensor calibration fault."
    });
    StatusCodes.UncertainConfigurationError = new opcua_status_code_1.ConstantStatusCode({
      name: "UncertainConfigurationError",
      value: 1108279296,
      description: "The value may not be accurate due to a configuration issue."
    });
    StatusCodes.GoodCascadeInitializationAcknowledged = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodCascadeInitializationAcknowledged",
      value: 67174400,
      description: "The value source supports cascade handshaking and the value has been Initialized based on an initialization request from a cascade secondary."
    });
    StatusCodes.GoodCascadeInitializationRequest = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodCascadeInitializationRequest",
      value: 67239936,
      description: "The value source supports cascade handshaking and is requesting initialization of a cascade primary."
    });
    StatusCodes.GoodCascadeNotInvited = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodCascadeNotInvited",
      value: 67305472,
      description: "The value source supports cascade handshaking, however, the source\u2019s current state does not allow for cascade."
    });
    StatusCodes.GoodCascadeNotSelected = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodCascadeNotSelected",
      value: 67371008,
      description: "The value source supports cascade handshaking, however, the source has not selected the corresponding cascade primary for use."
    });
    StatusCodes.GoodFaultStateActive = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodFaultStateActive",
      value: 67567616,
      description: "There is a fault state condition active in the value source."
    });
    StatusCodes.GoodInitiateFaultState = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodInitiateFaultState",
      value: 67633152,
      description: "A fault state condition is being requested of the destination."
    });
    StatusCodes.GoodCascade = new opcua_status_code_1.ConstantStatusCode({
      name: "GoodCascade",
      value: 67698688,
      description: "The value is accurate, and the signal source supports cascade handshaking."
    });
    StatusCodes.BadDataSetIdInvalid = new opcua_status_code_1.ConstantStatusCode({
      name: "BadDataSetIdInvalid",
      value: 2162622464,
      description: "The DataSet specified for the DataSetWriter creation is invalid."
    });
    StatusCodes.GoodWithOverflowBit = opcua_status_code_1.StatusCode.makeStatusCode(StatusCodes.Good, `Overflow | InfoTypeDataValue`);
  }
});

// node_modules/node-opcua-status-code/dist/opcua_status_code.js
var require_opcua_status_code = __commonJS({
  "node_modules/node-opcua-status-code/dist/opcua_status_code.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.coerceStatusCode = exports2.StatusCodes = exports2.ModifiableStatusCode = exports2.decodeStatusCode = exports2.getStatusCodeFromCode = exports2.encodeStatusCode = exports2.ConstantStatusCode = exports2.StatusCode = exports2.extraStatusCodeBits = void 0;
    var node_opcua_assert_1 = require_dist14();
    function warnLog(...args) {
      console.warn(...args);
    }
    exports2.extraStatusCodeBits = {
      /**
       *  **StructureChanged** 15:15
       *   Indicates that the structure of the associated data value has changed since the last
       *   Notification.
       *  - Clients should not process the data value unless they re-read the metadata.
       *  - Servers shall set this bit if the DataTypeEncoding used for a Variable changes.
       *  - Servers shall also set this bit if the EnumStrings Property of the DataType of the Variable changes.
       *  - This bit is provided to warn Clients that parse complex data values that their parsing
       *    routines could fail because the serialized form of the data value has changed.
       *  - This bit has meaning only for StatusCodes returned as part of a data change Notification
       *    or the HistoryRead. StatusCodes used in other contexts shall always set this bit to zero.
       */
      StructureChanged: 1 << 15,
      /**
       * **SemanticsChanged** 14:14  Semantics of the associated data value have changed. Clients should not process the data
       *   value until they re-read the metadata associated with the Variable.
       * - Servers should set this bit if the metadata has changed in way that could cause application errors if the
       * - Client does not re-read the metadata. For example, a change to the engineering units
       *   could create problems if the Client uses the value to perform calculations.
       * - Part 8 defines the conditions where a Server shall set this bit for a DA Variable.
       * - Other specifications may define additional conditions.
       * - A Server may define other conditions that cause this bit to be set. This bit has meaning only for StatusCodes returned as part of a data change Notification
       *   or the HistoryRead. StatusCodes used in other contexts shall always set this bit to zero.
       */
      SemanticChanged: 1 << 14,
      // Reserved         12:13  Reserved for future use. Shall always be zero.
      /**
       * **InfoType**         10:11
       * The type of information contained in the info bits. These bits have the following meanings:
       *
       * | Meaning                           |value | description|
       * |-----------------------------------|------|----------------------------------------------------|
       * |                         NotUsed   | 00   | The info bits are not used and shall be set to zero. |
       * |                         DataValue | 01   | The StatusCode and its info bits are associated with a data value returned from the Server. This flag is only used in combination with StatusCodes defined in Part 8. |
       * |                         Reserved  |1X    | Reserved for future use. The info bits shall be ignored.|
       */
      InfoTypeDataValue: 1 << 10,
      // 0x0400,
      // InfoBits         0:9    Additional information bits that qualify the StatusCode.
      //                         The structure of these bits depends on the Info Type field.
      //
      // LimitBits        8:9    The limit bits associated with the data value. The limits bits have the
      //                         following meanings:
      //                         Limit     Bits   Description
      //                         None      00     The value is free to change.
      //                         Low       01     The value is at the lower limit for the data source.
      //                         High      10     The value is at the higher limit for the data source.
      //                         Constant  11     The value is constant and cannot change.
      LimitLow: 1 << 8,
      LimitHigh: 2 << 8,
      LimitConstant: 3 << 8,
      /**
       * **Overflow**         7:7
       * - This bit shall only be set if the MonitoredItem queue size is greater than 1.
       * - If this bit is set, not every detected change has been returned since the Server’s
       *  queue buffer for the MonitoredItem reached its limit and had to purge out data.
       *
       */
      Overflow: 1 << 7,
      // 1 << 7
      // Reserved         5:6    Reserved for future use. Shall always be zero.
      // HistorianBits    0:4    These bits are set only when reading historical data. They indicate where the data value
      //                         came from and provide information that affects how the Client uses the data value.
      //                         The historian bits have the following meaning:
      //                         Raw            XXX00      A raw data value.
      //                         Calculated     XXX01      A data value which was calculated.
      //                         Interpolated   XXX10      A data value which was interpolated.
      //                         Reserved       XXX11      Undefined.
      //                         Partial        XX1XX      A data value which was calculated with an incomplete interval.
      //                         Extra Data     X1XXX      A raw data value that hides other data at the same timestamp.
      //                         Multi Value    1XXXX      Multiple values match the Aggregate criteria (i.e. multiple
      //                                                   minimum values at different timestamps within the same interval).
      //                         Part 11 describes how these bits are used in more detail.
      /** historical data contains a data value which was calculated. */
      HistorianCalculated: 1 << 0,
      /** historical data contains a data value which was interpolated. */
      HistorianInterpolated: 2 << 0,
      /** historical data contains a data value which was calculated with an incomplete interval. */
      HistorianPartial: 1 << 2,
      /** historical data contains a raw data value that hides other data at the same timestamp. */
      HistorianExtraData: 1 << 3,
      /** Multiple values match the Aggregate criteria (i.e. multiple minimum values at different timestamps within the same interval). */
      HistorianMultiValue: 1 << 4
    };
    var StatusCode = class _StatusCode {
      /**
       *  returns a status code that can be modified
       */
      static makeStatusCode(statusCode, optionalBits) {
        const _base = coerceStatusCode(statusCode);
        const tmp = new ModifiableStatusCode({ _base });
        if (optionalBits || typeof optionalBits === "number") {
          tmp.set(optionalBits);
        }
        return tmp;
      }
      valueOf() {
        return this.value;
      }
      toString() {
        return this.name + " (0x" + this.value.toString(16).padStart(8, "0") + ")";
      }
      checkBit(mask) {
        return (this.value & mask) === mask;
      }
      /** returns true if the overflow bit is set */
      get hasOverflowBit() {
        return this.checkBit(exports2.extraStatusCodeBits.Overflow);
      }
      /** returns true if the semanticChange bit is set */
      get hasSemanticChangedBit() {
        return this.checkBit(exports2.extraStatusCodeBits.SemanticChanged);
      }
      /** returns true if the structureChange bit is set */
      get hasStructureChangedBit() {
        return this.checkBit(exports2.extraStatusCodeBits.StructureChanged);
      }
      isNot(other) {
        (0, node_opcua_assert_1.assert)(other instanceof _StatusCode);
        return this.value !== other.value;
      }
      equals(other) {
        (0, node_opcua_assert_1.assert)(other instanceof _StatusCode);
        return this.value === other.value;
      }
      toJSON() {
        return { value: this.value };
      }
      toJSONFull() {
        return { value: this.value, name: this.name, description: this.description };
      }
      isGood() {
        return this.value === 0;
      }
      isNotGood() {
        return this.value !== 0;
      }
      isGoodish() {
        return this.value < 268435456;
      }
      isBad() {
        return this.value >= 2147483648;
      }
    };
    exports2.StatusCode = StatusCode;
    Object.defineProperty(StatusCode.prototype, "value", { enumerable: true });
    Object.defineProperty(StatusCode.prototype, "description", { enumerable: true });
    Object.defineProperty(StatusCode.prototype, "name", { enumerable: true });
    var ConstantStatusCode = class extends StatusCode {
      /**
       *
       * @param options
       * @param options
       * @param options.value
       * @param options.description
       * @param options.name
       *
       */
      constructor(options) {
        super();
        this._value = options.value;
        this._description = options.description;
        this._name = options.name;
      }
      get value() {
        return this._value;
      }
      get name() {
        return this._name;
      }
      get description() {
        return this._description;
      }
    };
    exports2.ConstantStatusCode = ConstantStatusCode;
    Object.defineProperty(ConstantStatusCode.prototype, "_value", { enumerable: false, writable: true });
    Object.defineProperty(ConstantStatusCode.prototype, "_description", { enumerable: false, writable: true });
    Object.defineProperty(ConstantStatusCode.prototype, "_name", { enumerable: false, writable: true });
    Object.defineProperty(ConstantStatusCode.prototype, "value", { enumerable: true });
    Object.defineProperty(ConstantStatusCode.prototype, "description", { enumerable: true });
    Object.defineProperty(ConstantStatusCode.prototype, "name", { enumerable: true });
    function encodeStatusCode(statusCode, stream) {
      stream.writeUInt32(statusCode.value);
    }
    exports2.encodeStatusCode = encodeStatusCode;
    var statusCodesReversedMap = {};
    function getStatusCodeFromCode(code) {
      const codeWithoutInfoBits = (code & 4294901760) >>> 0;
      const infoBits = code & 65535;
      let sc = statusCodesReversedMap[codeWithoutInfoBits];
      if (!sc) {
        sc = _generated_status_codes_1.StatusCodes.Bad;
        warnLog("expecting a known StatusCode but got 0x" + codeWithoutInfoBits.toString(16), " code was 0x" + code.toString(16));
      }
      if (infoBits) {
        const tmp = new ModifiableStatusCode({ _base: sc });
        tmp.set(infoBits);
        sc = tmp;
      }
      return sc;
    }
    exports2.getStatusCodeFromCode = getStatusCodeFromCode;
    function decodeStatusCode(stream, _value) {
      const code = stream.readUInt32();
      return getStatusCodeFromCode(code);
    }
    exports2.decodeStatusCode = decodeStatusCode;
    var ModifiableStatusCode = class _ModifiableStatusCode extends StatusCode {
      constructor(options) {
        super();
        this._base = options._base;
        this._extraBits = 0;
        if (this._base instanceof _ModifiableStatusCode) {
          this._extraBits = this._base._extraBits;
          this._base = this._base._base;
        }
      }
      get value() {
        return this._base.value + this._extraBits;
      }
      get name() {
        return this._base.name + this._getExtraName();
      }
      get description() {
        return this._base.description;
      }
      set(bit) {
        if (typeof bit === "string") {
          const bitsArray = bit.split(" | ");
          if (bitsArray.length > 1) {
            for (const bitArray of bitsArray) {
              this.set(bitArray);
            }
            return;
          }
          const tmp = exports2.extraStatusCodeBits[bit];
          if (!tmp) {
            throw new Error("Invalid StatusCode Bit " + bit);
          }
          bit = tmp;
        }
        this._extraBits = this._extraBits | bit;
      }
      unset(bit) {
        if (typeof bit === "string") {
          const bitsArray = bit.split(" | ");
          if (bitsArray.length > 1) {
            for (const bitArray of bitsArray) {
              this.unset(bitArray);
            }
            return;
          }
          const tmp = exports2.extraStatusCodeBits[bit];
          if (!tmp) {
            throw new Error("Invalid StatusCode Bit " + bit);
          }
          bit = tmp;
        }
        this._extraBits = this._extraBits & ~bit >>> 0;
      }
      _getExtraName() {
        const str = [];
        for (const [key, value] of Object.entries(exports2.extraStatusCodeBits)) {
          if ((this._extraBits & value) === value) {
            str.push(key);
          }
        }
        if (str.length === 0) {
          return "";
        }
        return "#" + str.join("|");
      }
    };
    exports2.ModifiableStatusCode = ModifiableStatusCode;
    Object.defineProperty(ModifiableStatusCode.prototype, "_base", { enumerable: false, writable: true });
    Object.defineProperty(ModifiableStatusCode.prototype, "_extraBits", { enumerable: false, writable: true });
    var _generated_status_codes_1 = require_generated_status_codes();
    var _generated_status_codes_2 = require_generated_status_codes();
    Object.defineProperty(exports2, "StatusCodes", { enumerable: true, get: function() {
      return _generated_status_codes_2.StatusCodes;
    } });
    function coerceStatusCode(statusCode) {
      if (statusCode instanceof StatusCode) {
        return statusCode;
      }
      if (Object.prototype.hasOwnProperty.call(statusCode, "value")) {
        return getStatusCodeFromCode(statusCode.value);
      }
      if (typeof statusCode === "number") {
        return getStatusCodeFromCode(statusCode);
      }
      const _StatusCodes = _generated_status_codes_1.StatusCodes;
      if (!_StatusCodes[statusCode]) {
        throw new Error("Cannot find StatusCode " + statusCode);
      }
      return _StatusCodes[statusCode];
    }
    exports2.coerceStatusCode = coerceStatusCode;
    for (const name of Object.keys(_generated_status_codes_1.StatusCodes)) {
      const code = _generated_status_codes_1.StatusCodes[name];
      statusCodesReversedMap[code.value.toString()] = code;
    }
    _generated_status_codes_1.StatusCodes.makeStatusCode = StatusCode.makeStatusCode;
  }
});

// node_modules/node-opcua-status-code/dist/callbacks.js
var require_callbacks = __commonJS({
  "node_modules/node-opcua-status-code/dist/callbacks.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-status-code/dist/index.js
var require_dist22 = __commonJS({
  "node_modules/node-opcua-status-code/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_opcua_status_code(), exports2);
    __exportStar3(require_callbacks(), exports2);
  }
});

// node_modules/node-opcua-basic-types/dist/status_code.js
var require_status_code = __commonJS({
  "node_modules/node-opcua-basic-types/dist/status_code.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_dist22(), exports2);
  }
});

// node_modules/node-opcua-basic-types/dist/index.js
var require_dist23 = __commonJS({
  "node_modules/node-opcua-basic-types/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_array(), exports2);
    __exportStar3(require_attributeIds(), exports2);
    __exportStar3(require_boolean(), exports2);
    __exportStar3(require_byte_string(), exports2);
    __exportStar3(require_data_type(), exports2);
    __exportStar3(require_date_time2(), exports2);
    __exportStar3(require_floats(), exports2);
    __exportStar3(require_guid2(), exports2);
    __exportStar3(require_integers(), exports2);
    __exportStar3(require_locale_id(), exports2);
    __exportStar3(require_node_id(), exports2);
    __exportStar3(require_round_to_float(), exports2);
    __exportStar3(require_status_code(), exports2);
    __exportStar3(require_string(), exports2);
  }
});

// node_modules/node-opcua-data-model/dist/_make_flag.js
var require_make_flag = __commonJS({
  "node_modules/node-opcua-data-model/dist/_make_flag.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2._make_flag = void 0;
    function _make_flag(str, noneValue, T) {
      if (typeof str === "number") {
        const value = str;
        if (value === 0) {
          return noneValue;
        }
        return value;
      }
      let accessFlag = 0;
      if (str === "" || str === null) {
        accessFlag = noneValue;
      } else {
        const flags = str.split(" | ");
        accessFlag = 0;
        for (const flag of flags) {
          accessFlag |= T[flag];
        }
      }
      return accessFlag;
    }
    exports2._make_flag = _make_flag;
  }
});

// node_modules/node-opcua-data-model/dist/access_level.js
var require_access_level = __commonJS({
  "node_modules/node-opcua-data-model/dist/access_level.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.encodeAccessLevelFlag = exports2.decodeAccessLevelFlag = exports2.accessLevelFlagToString = exports2._accessLevelFlagToString = exports2.randomAccessLevel = exports2.coerceAccessLevelFlag = exports2.makeAccessLevelFlag = exports2.convertAccessLevelFlagToByte = exports2.AccessLevelFlag = void 0;
    var _make_flag_1 = require_make_flag();
    var AccessLevelFlag;
    (function(AccessLevelFlag2) {
      AccessLevelFlag2[AccessLevelFlag2["CurrentRead"] = 1] = "CurrentRead";
      AccessLevelFlag2[AccessLevelFlag2["CurrentWrite"] = 2] = "CurrentWrite";
      AccessLevelFlag2[AccessLevelFlag2["HistoryRead"] = 4] = "HistoryRead";
      AccessLevelFlag2[AccessLevelFlag2["HistoryWrite"] = 8] = "HistoryWrite";
      AccessLevelFlag2[AccessLevelFlag2["SemanticChange"] = 16] = "SemanticChange";
      AccessLevelFlag2[AccessLevelFlag2["StatusWrite"] = 32] = "StatusWrite";
      AccessLevelFlag2[AccessLevelFlag2["TimestampWrite"] = 64] = "TimestampWrite";
      AccessLevelFlag2[AccessLevelFlag2["NONE"] = 2048] = "NONE";
      AccessLevelFlag2[AccessLevelFlag2["None"] = 2048] = "None";
    })(AccessLevelFlag || (exports2.AccessLevelFlag = AccessLevelFlag = {}));
    function convertAccessLevelFlagToByte(accessLevel) {
      return accessLevel & 127;
    }
    exports2.convertAccessLevelFlagToByte = convertAccessLevelFlagToByte;
    function makeAccessLevelFlag(str) {
      return (0, _make_flag_1._make_flag)(str, AccessLevelFlag.None, AccessLevelFlag);
    }
    exports2.makeAccessLevelFlag = makeAccessLevelFlag;
    exports2.coerceAccessLevelFlag = makeAccessLevelFlag;
    function randomAccessLevel() {
      return AccessLevelFlag.CurrentRead;
    }
    exports2.randomAccessLevel = randomAccessLevel;
    function _accessLevelFlagToString(accessLevelFlag) {
      const retVal = [];
      if (accessLevelFlag & AccessLevelFlag.CurrentRead) {
        retVal.push("CurrentRead");
      }
      if (accessLevelFlag & AccessLevelFlag.CurrentWrite) {
        retVal.push("CurrentWrite");
      }
      if (accessLevelFlag & AccessLevelFlag.StatusWrite) {
        retVal.push("StatusWrite");
      }
      if (accessLevelFlag & AccessLevelFlag.TimestampWrite) {
        retVal.push("TimestampWrite");
      }
      if (accessLevelFlag & AccessLevelFlag.HistoryRead) {
        retVal.push("HistoryRead");
      }
      if (accessLevelFlag & AccessLevelFlag.HistoryWrite) {
        retVal.push("HistoryWrite");
      }
      if (accessLevelFlag & AccessLevelFlag.SemanticChange) {
        retVal.push("SemanticChange");
      }
      return retVal;
    }
    exports2._accessLevelFlagToString = _accessLevelFlagToString;
    function accessLevelFlagToString(accessLevelFlag) {
      const retVal = _accessLevelFlagToString(accessLevelFlag);
      if (retVal.length === 0) {
        retVal.push("None");
      }
      return retVal.join(" | ");
    }
    exports2.accessLevelFlagToString = accessLevelFlagToString;
    function decodeAccessLevelFlag(stream) {
      const code = stream.readUInt8();
      return code;
    }
    exports2.decodeAccessLevelFlag = decodeAccessLevelFlag;
    function encodeAccessLevelFlag(value, stream) {
      stream.writeUInt8(value & 255);
    }
    exports2.encodeAccessLevelFlag = encodeAccessLevelFlag;
  }
});

// node_modules/node-opcua-data-model/dist/access_level_ex.js
var require_access_level_ex = __commonJS({
  "node_modules/node-opcua-data-model/dist/access_level_ex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.decodeAccessLevelExFlag = exports2.encodeAccessLevelExFlag = exports2.accessLevelExFlagToString = exports2.randomAccessLevelEx = exports2.makeAccessLevelExFlag = exports2.AccessLevelExFlag = void 0;
    var access_level_1 = require_access_level();
    var _make_flag_1 = require_make_flag();
    var AccessLevelExFlag;
    (function(AccessLevelExFlag2) {
      AccessLevelExFlag2[AccessLevelExFlag2["CurrentRead"] = 1] = "CurrentRead";
      AccessLevelExFlag2[AccessLevelExFlag2["CurrentWrite"] = 2] = "CurrentWrite";
      AccessLevelExFlag2[AccessLevelExFlag2["HistoryRead"] = 4] = "HistoryRead";
      AccessLevelExFlag2[AccessLevelExFlag2["HistoryWrite"] = 8] = "HistoryWrite";
      AccessLevelExFlag2[AccessLevelExFlag2["SemanticChange"] = 16] = "SemanticChange";
      AccessLevelExFlag2[AccessLevelExFlag2["StatusWrite"] = 32] = "StatusWrite";
      AccessLevelExFlag2[AccessLevelExFlag2["TimestampWrite"] = 64] = "TimestampWrite";
      AccessLevelExFlag2[AccessLevelExFlag2["NonatomicRead"] = 128] = "NonatomicRead";
      AccessLevelExFlag2[AccessLevelExFlag2["NonatomicWrite"] = 256] = "NonatomicWrite";
      AccessLevelExFlag2[AccessLevelExFlag2["WriteFullArrayOnly"] = 512] = "WriteFullArrayOnly";
      AccessLevelExFlag2[AccessLevelExFlag2["NoSubDataTypes"] = 1024] = "NoSubDataTypes";
      AccessLevelExFlag2[AccessLevelExFlag2["NonVolatile"] = 2048] = "NonVolatile";
      AccessLevelExFlag2[AccessLevelExFlag2["Constant"] = 4096] = "Constant";
      AccessLevelExFlag2[AccessLevelExFlag2["None"] = 2048] = "None";
    })(AccessLevelExFlag || (exports2.AccessLevelExFlag = AccessLevelExFlag = {}));
    function makeAccessLevelExFlag(str) {
      return (0, _make_flag_1._make_flag)(str, AccessLevelExFlag.None, AccessLevelExFlag);
    }
    exports2.makeAccessLevelExFlag = makeAccessLevelExFlag;
    function randomAccessLevelEx() {
      return Math.ceil(Math.random() * 512);
    }
    exports2.randomAccessLevelEx = randomAccessLevelEx;
    function accessLevelExFlagToString(accessLevelFlag) {
      const retVal = (0, access_level_1._accessLevelFlagToString)(accessLevelFlag);
      if (accessLevelFlag & AccessLevelExFlag.NonatomicRead) {
        retVal.push("NonatomicRead");
      }
      if (accessLevelFlag & AccessLevelExFlag.NonatomicWrite) {
        retVal.push("NonatomicWrite");
      }
      if (accessLevelFlag & AccessLevelExFlag.WriteFullArrayOnly) {
        retVal.push("WriteFullArrayOnly");
      }
      if (accessLevelFlag & AccessLevelExFlag.NoSubDataTypes) {
        retVal.push("NoSubDataTypes");
      }
      if (accessLevelFlag & AccessLevelExFlag.NonVolatile) {
        retVal.push("NonVolatile");
      }
      if (accessLevelFlag & AccessLevelExFlag.Constant) {
        retVal.push("Constant");
      }
      if (retVal.length === 0) {
        retVal.push("None");
      }
      return retVal.join(" | ");
    }
    exports2.accessLevelExFlagToString = accessLevelExFlagToString;
    function encodeAccessLevelExFlag(value, stream) {
      stream.writeUInt32(value & 1048575);
    }
    exports2.encodeAccessLevelExFlag = encodeAccessLevelExFlag;
    function decodeAccessLevelExFlag(stream) {
      const code = stream.readUInt32();
      return code;
    }
    exports2.decodeAccessLevelExFlag = decodeAccessLevelExFlag;
  }
});

// node_modules/node-opcua-data-model/dist/access_restrictions.js
var require_access_restrictions = __commonJS({
  "node_modules/node-opcua-data-model/dist/access_restrictions.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.accessRestrictionsFlagToString = exports2.makeAccessRestrictionsFlag = exports2.AccessRestrictionsFlag = void 0;
    var _make_flag_1 = require_make_flag();
    var AccessRestrictionsFlag;
    (function(AccessRestrictionsFlag2) {
      AccessRestrictionsFlag2[AccessRestrictionsFlag2["SigningRequired"] = 1] = "SigningRequired";
      AccessRestrictionsFlag2[AccessRestrictionsFlag2["EncryptionRequired"] = 2] = "EncryptionRequired";
      AccessRestrictionsFlag2[AccessRestrictionsFlag2["SessionRequired"] = 4] = "SessionRequired";
      AccessRestrictionsFlag2[AccessRestrictionsFlag2["ApplyRestrictionsToBrowse"] = 8] = "ApplyRestrictionsToBrowse";
      AccessRestrictionsFlag2[AccessRestrictionsFlag2["None"] = 0] = "None";
    })(AccessRestrictionsFlag || (exports2.AccessRestrictionsFlag = AccessRestrictionsFlag = {}));
    function makeAccessRestrictionsFlag(str) {
      return (0, _make_flag_1._make_flag)(str, AccessRestrictionsFlag.None, AccessRestrictionsFlag);
    }
    exports2.makeAccessRestrictionsFlag = makeAccessRestrictionsFlag;
    function accessRestrictionsFlagToString(flags) {
      const retVal = [];
      if (flags & AccessRestrictionsFlag.SigningRequired) {
        retVal.push("SigningRequired");
      }
      if (flags & AccessRestrictionsFlag.EncryptionRequired) {
        retVal.push("EncryptionRequired");
      }
      if (flags & AccessRestrictionsFlag.SessionRequired) {
        retVal.push("SessionRequired");
      }
      if (flags & AccessRestrictionsFlag.ApplyRestrictionsToBrowse) {
        retVal.push("ApplyRestrictionsToBrowse");
      }
      if (retVal.length === 0) {
        retVal.push("None");
      }
      return retVal.join(" | ");
    }
    exports2.accessRestrictionsFlagToString = accessRestrictionsFlagToString;
  }
});

// node_modules/node-opcua-debug/dist/remove_decoration.js
var require_remove_decoration = __commonJS({
  "node_modules/node-opcua-debug/dist/remove_decoration.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.removeDecoration = void 0;
    var nonTextReg = /[\u001b\u009b][[()#;?]*(?:[0-9]{1,4}(?:;[0-9]{0,4})*)?[0-9A-ORZcf-nqry=><]/g;
    function removeDecoration(str) {
      return str.replace(nonTextReg, "");
    }
    exports2.removeDecoration = removeDecoration;
  }
});

// node_modules/node-opcua-debug/dist/display_trace.js
var require_display_trace = __commonJS({
  "node_modules/node-opcua-debug/dist/display_trace.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.displayTraceFromThisProjectOnly = exports2.traceFromThisProjectOnly = void 0;
    var chalk_1 = __importDefault3(require_source());
    function traceFromThisProjectOnly(err) {
      const str = [];
      str.push(chalk_1.default.cyan.bold(" display_trace_from_this_project_only = "));
      if (err) {
        str.push(err.message);
      }
      err = err || new Error("Error used to extract stack trace");
      let stack = err.stack;
      if (stack) {
        stack = stack.split("\n").filter((el) => el.match(/node-opcua/) && !el.match(/node_modules/));
        str.push(chalk_1.default.yellow(stack.join("\n")));
      } else {
        str.push(chalk_1.default.red(" NO STACK TO TRACE !!!!"));
      }
      return str.join("\n");
    }
    exports2.traceFromThisProjectOnly = traceFromThisProjectOnly;
    function displayTraceFromThisProjectOnly(err) {
      console.log(traceFromThisProjectOnly(err));
    }
    exports2.displayTraceFromThisProjectOnly = displayTraceFromThisProjectOnly;
  }
});

// node_modules/node-opcua-debug/dist/make_loggers.js
var require_make_loggers = __commonJS({
  "node_modules/node-opcua-debug/dist/make_loggers.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.make_traceLog = exports2.make_warningLog = exports2.make_errorLog = exports2.make_debugLog = exports2.messageLogger = exports2.MessageLogger = exports2.checkDebugFlag = exports2.setDebugFlag = exports2.setTraceLogger = exports2.setErrorLogger = exports2.setWarningLogger = exports2.setDebugLogger = exports2.setLogLevel = exports2.LogLevel = void 0;
    var events_1 = require("events");
    var util_1 = require("util");
    var chalk_1 = __importDefault3(require_source());
    var debugFlags = {};
    var _process = typeof process === "object" ? process : { env: {} };
    var sTraceFlag = _process.env && _process.env.DEBUG;
    var LogLevel;
    (function(LogLevel2) {
      LogLevel2[LogLevel2["Emergency"] = 0] = "Emergency";
      LogLevel2[LogLevel2["Alert"] = 1] = "Alert";
      LogLevel2[LogLevel2["Critic"] = 2] = "Critic";
      LogLevel2[LogLevel2["Error"] = 3] = "Error";
      LogLevel2[LogLevel2["Warning"] = 4] = "Warning";
      LogLevel2[LogLevel2["Notice"] = 5] = "Notice";
      LogLevel2[LogLevel2["Info"] = 6] = "Info";
      LogLevel2[LogLevel2["Debug"] = 7] = "Debug";
    })(LogLevel || (exports2.LogLevel = LogLevel = {}));
    if (_process.env && false) {
      const old = { ..._process.env };
      const handler = {
        get: function(obj, prop) {
          return old[prop];
        },
        set: function(obj, prop, value) {
          console.log("setting process.env = prop " + prop);
          old[prop] = value;
          return true;
        }
      };
      _process.env = new Proxy(old, handler);
    }
    var maxLines = _process.env && _process.env.NODEOPCUA_DEBUG_MAXLINE_PER_MESSAGE ? parseInt(_process.env.NODEOPCUA_DEBUG_MAXLINE_PER_MESSAGE, 10) : 25;
    var g_logLevel = process.env.NODEOPCUA_LOG_LEVEL ? parseInt(process.env.NODEOPCUA_LOG_LEVEL) : LogLevel.Warning;
    function setLogLevel(level) {
      g_logLevel = level;
    }
    exports2.setLogLevel = setLogLevel;
    function extractBasename(name) {
      if (!name) {
        return "";
      }
      return name.replace(/(.*[\\|/])?/g, "").replace(/\.(js|ts)$/, "");
    }
    function w(str, l2) {
      return str.padEnd(l2, " ").substring(0, l2);
    }
    var contextCounter = {};
    var increaseCounter = (context) => {
      const { filename, callerline } = context;
      const key = `${filename}:${callerline}};`;
      const bucket = contextCounter[key];
      if (!bucket) {
        contextCounter[key] = 1;
        return 1;
      }
      contextCounter[key] = contextCounter[key] + 1;
      return contextCounter[key];
    };
    var threshold = 100;
    var loggers = {
      errorLogger: (context, ...args) => {
        const occurrenceCount = increaseCounter(context);
        if (occurrenceCount > threshold) {
          return;
        }
        const output = dump(context, "E", args);
        exports2.messageLogger.emit("errorMessage", output);
        if (occurrenceCount === threshold) {
          dump(context, "E", [`This error occurred more than ${threshold} times, no more error will be logged for this context`]);
          return;
        }
      },
      warningLogger: (context, ...args) => {
        const occurrenceCount = increaseCounter(context);
        if (occurrenceCount > threshold) {
          return;
        }
        const output = dump(context, "W", args);
        exports2.messageLogger.emit("warningMessage", output);
        if (occurrenceCount === threshold) {
          dump(context, "W", [
            `This warning occurred more than ${threshold} times, no more warning will be logged for this context`
          ]);
          return;
        }
      },
      traceLogger: (context, ...args) => {
        const output = dump(context, "T", args);
      },
      debugLogger: (context, ...args) => {
        const output = dump(context, "D", args);
      }
    };
    function setDebugLogger(log) {
      loggers.debugLogger = log;
    }
    exports2.setDebugLogger = setDebugLogger;
    function setWarningLogger(log) {
      loggers.warningLogger = log;
    }
    exports2.setWarningLogger = setWarningLogger;
    function setErrorLogger(log) {
      loggers.errorLogger = log;
    }
    exports2.setErrorLogger = setErrorLogger;
    function setTraceLogger(log) {
      loggers.traceLogger = log;
    }
    exports2.setTraceLogger = setTraceLogger;
    function setDebugFlag(scriptFullPath, flag) {
      const filename = extractBasename(scriptFullPath);
      if (sTraceFlag && sTraceFlag.length > 1 && flag) {
        const decoratedFilename = chalk_1.default.yellow(w(filename, 60));
        loggers.debugLogger({
          filename: __filename,
          callerline: -1
        }, " Setting debug for ", decoratedFilename, " to ", (flag ? chalk_1.default.cyan : chalk_1.default.red)(flag.toString(), sTraceFlag));
        g_logLevel = LogLevel.Debug;
      }
      debugFlags[filename] = flag;
    }
    exports2.setDebugFlag = setDebugFlag;
    function checkDebugFlag(scriptFullPath) {
      const filename = extractBasename(scriptFullPath);
      let doDebug = debugFlags[filename];
      if (sTraceFlag && !Object.prototype.hasOwnProperty.call(debugFlags, filename)) {
        doDebug = sTraceFlag.indexOf(filename) >= 0 || sTraceFlag.indexOf("ALL") >= 0;
        setDebugFlag(filename, doDebug);
      }
      return doDebug;
    }
    exports2.checkDebugFlag = checkDebugFlag;
    function file_line(mode, filename, callerLine) {
      const d2 = (/* @__PURE__ */ new Date()).toISOString().substring(11);
      if (mode === "T") {
        return chalk_1.default.bgGreenBright.white(w(d2, 14) + ":" + w(filename, 30) + ":" + w(callerLine.toString(), 5));
      } else if (mode === "W") {
        return chalk_1.default.bgCyan.white(w(d2, 14) + ":" + w(filename, 30) + ":" + w(callerLine.toString(), 5));
      } else if (mode === "D") {
        return chalk_1.default.bgWhite.cyan(w(d2, 14) + ":" + w(filename, 30) + ":" + w(callerLine.toString(), 5));
      } else {
        return chalk_1.default.bgRed.white(w(d2, 14) + ":" + w(filename, 30) + ":" + w(callerLine.toString(), 5));
      }
    }
    var continuation = w(" ...                                                            ", 51);
    function getCallerContext(level) {
      const stack = new Error("").stack || "";
      const l2 = stack.split("\n")[level].split(":");
      const callerline = parseInt(l2[l2.length - 2], 10);
      const filename = extractBasename(l2[l2.length - 3]);
      return { filename, callerline };
    }
    function dump(ctx, mode, args1) {
      const a2 = Object.values(args1);
      const output = (0, util_1.format)(...a2);
      const { filename, callerline } = ctx;
      let a1 = [file_line(mode, filename, callerline)];
      let i = 0;
      for (const line of output.split("\n")) {
        const lineArguments = [].concat(a1, [line]);
        console.log(...lineArguments);
        a1 = [continuation];
        i = i + 1;
        if (i > maxLines) {
          const a3 = a1.concat([` .... TRUNCATED ..... (NODEOPCUA_DEBUG_MAXLINE_PER_MESSAGE=${maxLines}`]);
          console.log(...a3);
          break;
        }
      }
      return output;
    }
    var MessageLogger = class extends events_1.EventEmitter {
      constructor() {
        super();
      }
      on(eventName, eventHandler) {
        return super.on(eventName, eventHandler);
      }
    };
    exports2.MessageLogger = MessageLogger;
    exports2.messageLogger = new MessageLogger();
    function make_debugLog(scriptFullPath) {
      const filename = extractBasename(scriptFullPath);
      function debugLogFunc(...args) {
        if (debugFlags[filename] && g_logLevel >= LogLevel.Debug) {
          const ctxt = getCallerContext(3);
          loggers.debugLogger(ctxt, ...args);
        }
      }
      return debugLogFunc;
    }
    exports2.make_debugLog = make_debugLog;
    function errorLogFunc(...args) {
      if (g_logLevel >= LogLevel.Error) {
        const ctxt = getCallerContext(3);
        loggers.errorLogger(ctxt, ...args);
      }
    }
    function make_errorLog(context) {
      return errorLogFunc;
    }
    exports2.make_errorLog = make_errorLog;
    function warningLogFunc(...args) {
      if (g_logLevel >= LogLevel.Warning) {
        const ctxt = getCallerContext(3);
        loggers.warningLogger(ctxt, ...args);
      }
    }
    function make_warningLog(context) {
      return warningLogFunc;
    }
    exports2.make_warningLog = make_warningLog;
    function traceLogFunc(...args) {
      const ctxt = getCallerContext(3);
      loggers.traceLogger(ctxt, ...args);
    }
    function make_traceLog(context) {
      return traceLogFunc;
    }
    exports2.make_traceLog = make_traceLog;
  }
});

// node_modules/node-opcua-debug/dist/make_buffer_from_trace.js
var require_make_buffer_from_trace = __commonJS({
  "node_modules/node-opcua-debug/dist/make_buffer_from_trace.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.makeBufferFromTrace = exports2.inlineText = void 0;
    var node_opcua_buffer_utils_1 = require_dist15();
    function inlineText(f2) {
      let k = f2.toString().replace(/^[^/]+\/\*!?/, "").replace(/\*\/[^/]+$/, "");
      k = k.split("\n").map((t) => t.trim()).join("\n");
      return k;
    }
    exports2.inlineText = inlineText;
    function hexString(str) {
      let hexLine = "";
      let lines = str.split("\n");
      if (lines.length === 0) {
        return hexLine;
      }
      while (lines.length && lines[0].length === 0) {
        lines = lines.splice(1);
      }
      const m2 = lines[0].match(/[0-9a-fA-F:]* +/);
      if (!m2)
        return hexLine;
      const prefixLength = m2[0].length;
      for (let line of lines) {
        line = line.trim();
        if (line.length > 80) {
          line = line.substring(10, 98 + 10).trim();
          hexLine = hexLine ? hexLine + " " + line : line;
        } else if (line.length > 60) {
          line = line.substring(7, 48 + 7).trim();
          hexLine = hexLine ? hexLine + " " + line : line;
        } else if (line.length > prefixLength) {
          line = line.substring(prefixLength, prefixLength + 48).trim();
          hexLine = hexLine ? hexLine + " " + line : line;
        }
      }
      return hexLine;
    }
    function makeBufferFromTrace(func) {
      if (typeof func === "string") {
        return (0, node_opcua_buffer_utils_1.makeBuffer)(hexString(func));
      }
      return (0, node_opcua_buffer_utils_1.makeBuffer)(hexString(inlineText(func)));
    }
    exports2.makeBufferFromTrace = makeBufferFromTrace;
  }
});

// node_modules/hexy/hexy.js
var require_hexy = __commonJS({
  "node_modules/hexy/hexy.js"(exports2) {
    "use strict";
    (function(arg) {
      var hexy = function(buffer, config) {
        const h = new Hexy(buffer, config);
        return h.toString();
      };
      var Hexy = function(buffer, config) {
        const self2 = this;
        const MAX_ADDRESS_LENGTH = 8;
        if (typeof Buffer !== "undefined") {
          buffer = Buffer.isBuffer(buffer) && buffer || typeof buffer === "string" && Buffer.from(buffer) || buffer && buffer.constructor === Array && Buffer.from(buffer) || Buffer.alloc(0);
        }
        buffer = buffer || [];
        config = config || {};
        self2.buffer = buffer;
        self2.bytes_per_line = parseInt(config.width) || 16;
        self2.numbering = config.numbering == "none" ? "none" : "hex_bytes";
        self2.bytes_per_group = 2;
        switch (config.format) {
          case "none":
            self2.bytes_per_group = 0;
            break;
          case "twos":
            self2.bytes_per_group = 1;
            break;
          case "eights":
            self2.bytes_per_group = 4;
            break;
          case "sixteens":
            self2.bytes_per_group = 8;
            break;
        }
        self2.littleEndian = config.littleEndian || false;
        self2.radix = config.radix || 16;
        self2.caps = config.caps == "upper" ? "upper" : "lower";
        self2.annotate = config.annotate == "none" ? "none" : "ascii";
        self2.prefix = config.prefix || "";
        self2.indent = config.indent || 0;
        self2.html = config.html || false;
        self2.offset = config.offset || 0;
        self2.length = config.length || -1;
        self2.extendedChs = config.extendedChs || false;
        self2.display_offset = config.display_offset || 0;
        if (self2.offset) {
          if (self2.offset < self2.buffer.length) {
            self2.buffer = self2.buffer.slice(self2.offset);
          }
        }
        if (self2.length !== -1) {
          if (self2.length <= self2.buffer.length) {
            self2.buffer = self2.buffer.slice(0, self2.length);
          }
        }
        self2.prefix = (self2.html ? "&nbsp;" : " ").repeat(self2.indent) + self2.prefix;
        self2.hex_line_length = maxnumberlen(self2.bytes_per_group, self2.radix) * self2.bytes_per_line / Math.max(self2.bytes_per_group, 1);
        switch (self2.bytes_per_group) {
          case 8:
          case 4:
          case 2:
            self2.hex_line_length += Math.floor(self2.bytes_per_line / self2.bytes_per_group);
            break;
          case 1:
            self2.hex_line_length += self2.bytes_per_line + 3;
            break;
          case 0:
            self2.hex_line_length += 2;
            break;
        }
        self2.bytes_per_group = Math.min(self2.bytes_per_group, self2.bytes_per_line);
        this.toString = function() {
          var str = "";
          var addr = self2.offset + self2.display_offset;
          var odd = false;
          if (self2.html) {
            str += "<div class='hexy'>\n";
          }
          for (var start = 0; start < self2.buffer.length; start += self2.bytes_per_line) {
            const end = Math.min(start + self2.bytes_per_line, self2.buffer.length);
            const slice = self2.buffer.slice(start, end);
            if (self2.html) {
              str += "<div class='" + num2str(addr, MAX_ADDRESS_LENGTH, 16) + (odd ? "  odd" : " even") + "'>";
              odd = !odd;
            }
            str += self2.prefix;
            if (self2.numbering === "hex_bytes") {
              str += num2str(addr, MAX_ADDRESS_LENGTH, 16) + ": ";
            }
            str += hex(slice, self2.bytes_per_line, self2.bytes_per_group, self2.radix, self2.littleEndian);
            if (self2.annotate === "ascii") {
              var text2 = "";
              switch (slice.constructor) {
                case Array:
                  text2 = String.fromCharCode.apply(self2, slice);
                  break;
                case Uint8Array:
                  slice.forEach((ch) => text2 += String.fromCharCode(ch));
                  break;
                default:
                  text2 = slice.toString("latin1");
              }
              str += " " + (self2.html ? html_escape(text2) : ascii_escape(text2));
            }
            str += self2.html ? "</div>\n" : "\n";
            addr += self2.bytes_per_line;
          }
          if (self2.html) {
            str += "</div>\n";
          }
          return str;
        };
        var hex = function(buffer2, bytes_per_line, bytes_per_group, radix, littleEndian) {
          var str = "";
          const delimiter = bytes_per_group == 0 ? "" : " ";
          const group_len = maxnumberlen(bytes_per_group, radix);
          const padlen2 = (bytes_per_line - buffer2.length) * (bytes_per_group == 0 ? group_len : (group_len + 1) / bytes_per_group);
          if (bytes_per_group == 0) {
            bytes_per_group = 1;
          }
          const start = littleEndian ? bytes_per_group - 1 : 0;
          const end = littleEndian ? -1 : bytes_per_group;
          const step = littleEndian ? -1 : 1;
          for (var group = 0; group < buffer2.length / bytes_per_group; ++group) {
            var val = bytes_per_group < 4 ? 0 : BigInt(0);
            for (var ii = start; ii != end; ii += step) {
              const i = group * bytes_per_group + ii;
              if (i >= buffer2.length) {
                break;
              }
              if (bytes_per_group < 4) {
                val = val * 256 + ((buffer2.constructor == String ? buffer2.codePointAt(i) : buffer2[i]) & 255);
              } else {
                val = BigInt(val) * BigInt(256) + BigInt((buffer2.constructor == String ? buffer2.codePointAt(i) : buffer2[i]) & 255);
              }
            }
            const text2 = val.toString(radix);
            for (var c2 = 0; c2 < group_len - text2.length; c2++) {
              str += "0";
            }
            str += text2;
            str += delimiter;
            if (self2.caps === "upper") {
              str = str.toUpperCase();
            }
          }
          if (buffer2.length < bytes_per_line) {
            str += (self2.html ? "&nbsp;" : " ").repeat(padlen2);
          }
          str = rpad(str, self2.hex_line_length);
          return str;
        };
        var num2str = function(b, len, radix) {
          const s = b.toString(radix);
          return "0".repeat(len - s.length) + s;
        };
        var rpad = function(s, len) {
          const to_add = len - s.length - 1;
          if (to_add > 0) {
            s += (self2.html ? "&nbsp;" : " ").repeat(to_add);
          }
          return s;
        };
        const ALL_EXCEPT_PRINTABLE_LATIN = /[^\x20-\x7f]/g;
        const CONTROL_CHARACTERS_ONLY = /[\x00-\x1f]/g;
        var ascii_escape = function(str) {
          return str.replace(self2.extendedChs ? CONTROL_CHARACTERS_ONLY : ALL_EXCEPT_PRINTABLE_LATIN, ".");
        };
        var html_escape = function(str) {
          str = str.replace(/&/g, "&amp;");
          str = str.replace(/</g, "&lt;");
          str = str.replace(/>/g, "&gt;");
          if (self2.extendedChs) {
            str = str.replace(/\'/g, "&apos;");
            str = str.replace(/\"/g, "&quot;");
            str = str.replace(ALL_EXCEPT_PRINTABLE_LATIN, function(ch) {
              ch = ch.codePointAt(0);
              return "&#x" + ch.toString(16) + ";";
            });
          } else {
            str = str.replace(ALL_EXCEPT_PRINTABLE_LATIN, ".");
          }
          return str;
        };
      };
      Hexy.VERSION = "0.3.4";
      var maxnumberlen = function(bytes, radix) {
        var result2 = 2;
        if (bytes == 0) {
          bytes = 1;
        }
        switch (radix) {
          case 2:
            result2 = bytes * 8;
            break;
          case 8:
            switch (bytes) {
              case 1:
                result2 = 3;
                break;
              case 2:
                result2 = 6;
                break;
              case 4:
                result2 = 11;
                break;
              case 8:
                result2 = 22;
                break;
            }
            break;
          case 10:
            switch (bytes) {
              case 1:
                result2 = 3;
                break;
              case 2:
                result2 = 6;
                break;
              case 4:
                result2 = 10;
                break;
              case 8:
                result2 = 20;
                break;
            }
            break;
          case 16:
            result2 = 2 * bytes;
            break;
        }
        return result2;
      };
      var _exp;
      if (typeof exports2 !== "undefined") {
        _exp = exports2;
      } else if (arg === window) {
        _exp = window;
      } else {
        _exp = arg;
      }
      _exp.hexy = hexy;
      _exp.Hexy = Hexy;
      _exp.maxnumberlen = maxnumberlen;
    })(exports2);
  }
});

// node_modules/node-opcua-debug/dist/hexDump.js
var require_hexDump = __commonJS({
  "node_modules/node-opcua-debug/dist/hexDump.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.hexDump = void 0;
    var hexy = require_hexy();
    function hexDump(buffer, width = 32, maxSize = 1024) {
      if (!buffer) {
        return "<>";
      }
      width = width || 32;
      if (buffer.length > maxSize) {
        return hexy.hexy(buffer.subarray(0, maxSize), { width, format: "twos" }) + "\n .... ( " + buffer.length + ")";
      } else {
        return hexy.hexy(buffer, { width, format: "twos" });
      }
    }
    exports2.hexDump = hexDump;
  }
});

// node_modules/node-opcua-debug/dist/dump_if.js
var require_dump_if = __commonJS({
  "node_modules/node-opcua-debug/dist/dump_if.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.dumpIf = exports2.dump = void 0;
    var util_1 = require("util");
    function dump(obj) {
      console.log("\n", (0, util_1.inspect)(JSON.parse(JSON.stringify(obj)), { colors: true, depth: 10 }));
    }
    exports2.dump = dump;
    function dumpIf(condition, obj) {
      if (condition) {
        dump(obj);
      }
    }
    exports2.dumpIf = dumpIf;
  }
});

// node_modules/node-opcua-debug/dist/index.js
var require_dist24 = __commonJS({
  "node_modules/node-opcua-debug/dist/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.setTraceLogger = exports2.setErrorLogger = exports2.setWarningLogger = exports2.setDebugLogger = exports2.setLogLevel = exports2.LogLevel = exports2.dumpIf = exports2.dump = exports2.hexDump = exports2.inlineText = exports2.makeBufferFromTrace = exports2.messageLogger = exports2.make_traceLog = exports2.make_warningLog = exports2.make_errorLog = exports2.make_debugLog = exports2.setDebugFlag = exports2.checkDebugFlag = exports2.displayTraceFromThisProjectOnly = exports2.traceFromThisProjectOnly = exports2.removeDecoration = void 0;
    var remove_decoration_1 = require_remove_decoration();
    Object.defineProperty(exports2, "removeDecoration", { enumerable: true, get: function() {
      return remove_decoration_1.removeDecoration;
    } });
    var display_trace_1 = require_display_trace();
    Object.defineProperty(exports2, "traceFromThisProjectOnly", { enumerable: true, get: function() {
      return display_trace_1.traceFromThisProjectOnly;
    } });
    Object.defineProperty(exports2, "displayTraceFromThisProjectOnly", { enumerable: true, get: function() {
      return display_trace_1.displayTraceFromThisProjectOnly;
    } });
    var make_loggers_1 = require_make_loggers();
    Object.defineProperty(exports2, "checkDebugFlag", { enumerable: true, get: function() {
      return make_loggers_1.checkDebugFlag;
    } });
    Object.defineProperty(exports2, "setDebugFlag", { enumerable: true, get: function() {
      return make_loggers_1.setDebugFlag;
    } });
    Object.defineProperty(exports2, "make_debugLog", { enumerable: true, get: function() {
      return make_loggers_1.make_debugLog;
    } });
    Object.defineProperty(exports2, "make_errorLog", { enumerable: true, get: function() {
      return make_loggers_1.make_errorLog;
    } });
    Object.defineProperty(exports2, "make_warningLog", { enumerable: true, get: function() {
      return make_loggers_1.make_warningLog;
    } });
    Object.defineProperty(exports2, "make_traceLog", { enumerable: true, get: function() {
      return make_loggers_1.make_traceLog;
    } });
    Object.defineProperty(exports2, "messageLogger", { enumerable: true, get: function() {
      return make_loggers_1.messageLogger;
    } });
    var make_buffer_from_trace_1 = require_make_buffer_from_trace();
    Object.defineProperty(exports2, "makeBufferFromTrace", { enumerable: true, get: function() {
      return make_buffer_from_trace_1.makeBufferFromTrace;
    } });
    Object.defineProperty(exports2, "inlineText", { enumerable: true, get: function() {
      return make_buffer_from_trace_1.inlineText;
    } });
    var hexDump_1 = require_hexDump();
    Object.defineProperty(exports2, "hexDump", { enumerable: true, get: function() {
      return hexDump_1.hexDump;
    } });
    var dump_if_1 = require_dump_if();
    Object.defineProperty(exports2, "dump", { enumerable: true, get: function() {
      return dump_if_1.dump;
    } });
    Object.defineProperty(exports2, "dumpIf", { enumerable: true, get: function() {
      return dump_if_1.dumpIf;
    } });
    var make_loggers_2 = require_make_loggers();
    Object.defineProperty(exports2, "LogLevel", { enumerable: true, get: function() {
      return make_loggers_2.LogLevel;
    } });
    Object.defineProperty(exports2, "setLogLevel", { enumerable: true, get: function() {
      return make_loggers_2.setLogLevel;
    } });
    Object.defineProperty(exports2, "setDebugLogger", { enumerable: true, get: function() {
      return make_loggers_2.setDebugLogger;
    } });
    Object.defineProperty(exports2, "setWarningLogger", { enumerable: true, get: function() {
      return make_loggers_2.setWarningLogger;
    } });
    Object.defineProperty(exports2, "setErrorLogger", { enumerable: true, get: function() {
      return make_loggers_2.setErrorLogger;
    } });
    Object.defineProperty(exports2, "setTraceLogger", { enumerable: true, get: function() {
      return make_loggers_2.setTraceLogger;
    } });
  }
});

// node_modules/node-opcua-enum/dist/enum.js
var require_enum = __commonJS({
  "node_modules/node-opcua-enum/dist/enum.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Enum = exports2.adaptTypescriptEnum = exports2.EnumItem = void 0;
    var EnumItem = class _EnumItem {
      /**
       *
       * @param key the enum key
       * @param value the enum value
       */
      constructor(key, value) {
        this.key = key;
        this.value = value;
      }
      /**
       * Checks if the EnumItem is the same as the passing object.
       * @method is
       * @param  {EnumItem | String | Number} item The object to check with.
       * @return {Boolean}                          The check result.
       */
      is(item) {
        if (item instanceof _EnumItem) {
          return this.value === item.value;
        } else if (typeof item === "string") {
          return this.key === item;
        } else {
          return this.value === item;
        }
      }
      /**
       * Checks if the flagged EnumItem has the passing object.
       * @method has
       * @param  {EnumItem | String |Number} value The object to check with.
       * @return {Boolean}                            The check result.
       */
      has(value) {
        if (value instanceof _EnumItem) {
          return (value.value & this.value) !== 0;
        } else if (typeof value === "string") {
          return this.key.indexOf(value) >= 0;
        } else {
          return (value & this.value) !== 0;
        }
      }
      /**
       * Returns String representation of this EnumItem.
       * @method toString
       * @return {String} String representation of this EnumItem.
       */
      toString() {
        return this.key;
      }
      /**
       * Returns JSON object representation of this EnumItem.
       * @method toJSON
       * @return {String} JSON object representation of this EnumItem.
       */
      toJSON() {
        return this.key;
      }
      /**
       * Returns the value to compare with.
       * @method valueOf
       * @return {String} The value to compare with.
       */
      valueOf() {
        return this.value;
      }
    };
    exports2.EnumItem = EnumItem;
    function powerOfTwo(n) {
      return n && !(n & n - 1) ? true : false;
    }
    function checkIsFlaggable(enums) {
      for (const e of enums) {
        const value = +e.value;
        if (isNaN(value)) {
          continue;
        }
        if (value !== 0 && value !== 1 && !powerOfTwo(value)) {
          return false;
        }
      }
      return true;
    }
    function adaptTypescriptEnum(map) {
      if (Array.isArray(map)) {
        let mm = null;
        mm = {};
        for (let i = 0; i < map.length; i++) {
          mm[map[i]] = 1 << i;
        }
        return mm;
      }
      return map;
    }
    exports2.adaptTypescriptEnum = adaptTypescriptEnum;
    var Enum = class {
      constructor(map) {
        this.enumItems = [];
        let mm = null;
        let isFlaggable = null;
        if (Array.isArray(map)) {
          mm = adaptTypescriptEnum(map);
          isFlaggable = true;
        } else {
          mm = map;
        }
        for (const [key, val] of Object.entries(mm)) {
          if (typeof val !== "number") {
            continue;
          }
          const kv = new EnumItem(key, val);
          const pThis = this;
          pThis[key] = kv;
          pThis[val] = kv;
          this.enumItems.push(kv);
        }
        if (!isFlaggable) {
          isFlaggable = checkIsFlaggable(this.enumItems);
        }
        this._isFlaggable = isFlaggable;
      }
      get isFlaggable() {
        return this._isFlaggable;
      }
      /**
       * Returns the appropriate EnumItem.
       * @method get
       * @param  key The object to get with.
       * @return the get result.
       */
      get(key) {
        const pThis = this;
        if (key instanceof EnumItem) {
          if (!pThis[key.key]) {
            throw new Error("Invalid key");
          }
          return key;
        }
        if (key === null || key === void 0) {
          return null;
        }
        const prop = pThis[key];
        if (prop) {
          return prop;
        } else if (this._isFlaggable) {
          if (typeof key === "string") {
            return this._getByString(key);
          } else if (typeof key === "number") {
            return this._getByNum(key);
          }
        }
        return null;
      }
      getDefaultValue() {
        return this.enumItems[0];
      }
      toString() {
        return this.enumItems.join(" , ");
      }
      _getByString(key) {
        const pThis = this;
        const parts = key.split(" | ");
        let val = 0;
        for (const part of parts) {
          const item = pThis[part];
          if (void 0 === item) {
            return null;
          }
          val |= item.value;
        }
        const kv = new EnumItem(key, val);
        let prop = pThis[val];
        if (prop === void 0) {
          pThis[val] = kv;
        }
        prop = pThis[key];
        if (prop === void 0) {
          pThis[key] = kv;
        }
        return kv;
      }
      _getByNum(key) {
        if (key === 0) {
          return null;
        }
        const pThis = this;
        let name;
        let c2 = 1;
        for (let i = 0; c2 < key; i++) {
          if ((c2 & key) === c2) {
            const item = pThis[c2];
            if (void 0 === item) {
              return null;
            }
            if (name) {
              name = name + " | " + item.key;
            } else {
              name = item.key;
            }
          }
          c2 *= 2;
        }
        const kv = new EnumItem(name, key);
        pThis[name] = kv;
        pThis[key] = kv;
        return kv;
      }
    };
    exports2.Enum = Enum;
  }
});

// node_modules/node-opcua-enum/dist/index.js
var require_dist25 = __commonJS({
  "node_modules/node-opcua-enum/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_enum(), exports2);
  }
});

// node_modules/node-opcua-factory/dist/encode_decode.js
var require_encode_decode2 = __commonJS({
  "node_modules/node-opcua-factory/dist/encode_decode.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.decodeNull = exports2.encodeNull = exports2.decodeAny = exports2.encodeAny = exports2.toJSONGuid = exports2.defaultGuidValue = exports2.defaultDecode = exports2.defaultEncode = void 0;
    var node_opcua_assert_1 = __importDefault3(require_dist14());
    function defaultEncode(value, stream) {
    }
    exports2.defaultEncode = defaultEncode;
    function defaultDecode(stream) {
      return null;
    }
    exports2.defaultDecode = defaultDecode;
    function defaultGuidValue() {
      return Buffer.alloc(0);
    }
    exports2.defaultGuidValue = defaultGuidValue;
    function toJSONGuid(value) {
      if (typeof value === "string") {
        return value;
      }
      (0, node_opcua_assert_1.default)(value instanceof Buffer);
      return value.toString("base64");
    }
    exports2.toJSONGuid = toJSONGuid;
    function encodeAny(value, stream) {
      (0, node_opcua_assert_1.default)(false, "type 'Any' cannot be encoded");
    }
    exports2.encodeAny = encodeAny;
    function decodeAny(stream) {
      (0, node_opcua_assert_1.default)(false, "type 'Any' cannot be decoded");
    }
    exports2.decodeAny = decodeAny;
    function encodeNull(value, stream) {
    }
    exports2.encodeNull = encodeNull;
    function decodeNull(stream) {
      return null;
    }
    exports2.decodeNull = decodeNull;
  }
});

// node_modules/node-opcua-factory/dist/types.js
var require_types = __commonJS({
  "node_modules/node-opcua-factory/dist/types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.FieldCategory = void 0;
    var FieldCategory;
    (function(FieldCategory2) {
      FieldCategory2["enumeration"] = "enumeration";
      FieldCategory2["complex"] = "complex";
      FieldCategory2["basic"] = "basic";
    })(FieldCategory || (exports2.FieldCategory = FieldCategory = {}));
  }
});

// node_modules/node-opcua-factory/dist/builtin_types.js
var require_builtin_types = __commonJS({
  "node_modules/node-opcua-factory/dist/builtin_types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.findBuiltInType = exports2.hasBuiltInType = exports2.getBuiltInType = exports2.unregisterType = exports2.registerBuiltInType = exports2.registerType = exports2.BasicTypeSchema = exports2.TypeSchemaBase = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_guid_1 = require_dist19();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_status_code_1 = require_dist22();
    var encode_decode_1 = require_encode_decode2();
    var types_1 = require_types();
    var TypeSchemaBase = class {
      constructor(options) {
        (0, node_opcua_assert_1.assert)(options.category !== null);
        this.encode = options.encode || void 0;
        this.decode = options.decode || void 0;
        this.coerce = options.coerce;
        this.category = options.category || types_1.FieldCategory.basic;
        this.name = options.name;
        for (const prop in options) {
          if (Object.prototype.hasOwnProperty.call(options, prop)) {
            this[prop] = options[prop];
          }
        }
        this.subType = options.subType || "";
        this.isAbstract = options.isAbstract || false;
      }
      /**
       * @method  computer_default_value
       * @param defaultValue {*} the default value
       * @return {*}
       */
      computer_default_value(defaultValue) {
        if (defaultValue === void 0) {
          defaultValue = this.defaultValue;
        }
        if (typeof defaultValue === "function") {
          defaultValue = defaultValue();
        }
        return defaultValue;
      }
      getBaseType() {
        if (!this.subType)
          return null;
        return getBuiltInType(this.subType);
      }
      isSubTypeOf(type) {
        if (this.name === type.name) {
          return true;
        }
        const baseType = this.getBaseType();
        if (!baseType) {
          return false;
        }
        return baseType.isSubTypeOf(type);
      }
    };
    exports2.TypeSchemaBase = TypeSchemaBase;
    var BasicTypeSchema = class extends TypeSchemaBase {
      constructor(options) {
        super(options);
        this.subType = options.subType;
        this.isAbstract = options.isAbstract || false;
        this.encode = options.encode || encode_decode_1.defaultEncode;
        this.decode = options.decode || encode_decode_1.defaultDecode;
      }
    };
    exports2.BasicTypeSchema = BasicTypeSchema;
    var defaultXmlElement = "";
    var _defaultType = [
      // Built-in DataTypes ( see OPCUA Part III v1.02 - $5.8.2 )
      {
        name: "Null",
        decode: encode_decode_1.decodeNull,
        encode: encode_decode_1.encodeNull,
        defaultValue: null
      },
      {
        // special case
        name: "Any",
        decode: encode_decode_1.decodeAny,
        encode: encode_decode_1.encodeAny
      },
      {
        name: "Boolean",
        decode: node_opcua_basic_types_1.decodeBoolean,
        encode: node_opcua_basic_types_1.encodeBoolean,
        coerce: node_opcua_basic_types_1.coerceBoolean,
        defaultValue: false
      },
      { name: "Number", isAbstract: true },
      { name: "Integer", subType: "Number", isAbstract: true },
      { name: "UInteger", subType: "Number", isAbstract: true },
      { name: "SByte", subType: "Integer", encode: node_opcua_basic_types_1.encodeSByte, decode: node_opcua_basic_types_1.decodeSByte, defaultValue: 0, coerce: node_opcua_basic_types_1.coerceSByte },
      { name: "Byte", subType: "UInteger", encode: node_opcua_basic_types_1.encodeByte, decode: node_opcua_basic_types_1.decodeByte, defaultValue: 0, coerce: node_opcua_basic_types_1.coerceByte },
      { name: "Int16", subType: "Integer", encode: node_opcua_basic_types_1.encodeInt16, decode: node_opcua_basic_types_1.decodeInt16, defaultValue: 0, coerce: node_opcua_basic_types_1.coerceInt16 },
      { name: "UInt16", subType: "UInteger", encode: node_opcua_basic_types_1.encodeUInt16, decode: node_opcua_basic_types_1.decodeUInt16, defaultValue: 0, coerce: node_opcua_basic_types_1.coerceUInt16 },
      { name: "Int32", subType: "Integer", encode: node_opcua_basic_types_1.encodeInt32, decode: node_opcua_basic_types_1.decodeInt32, defaultValue: 0, coerce: node_opcua_basic_types_1.coerceInt32 },
      { name: "UInt32", subType: "UInteger", encode: node_opcua_basic_types_1.encodeUInt32, decode: node_opcua_basic_types_1.decodeUInt32, defaultValue: 0, coerce: node_opcua_basic_types_1.coerceUInt32 },
      {
        name: "Int64",
        subType: "Integer",
        decode: node_opcua_basic_types_1.decodeInt64,
        encode: node_opcua_basic_types_1.encodeInt64,
        coerce: node_opcua_basic_types_1.coerceInt64,
        defaultValue: (0, node_opcua_basic_types_1.coerceInt64)(0)
      },
      {
        name: "UInt64",
        subType: "UInteger",
        decode: node_opcua_basic_types_1.decodeUInt64,
        encode: node_opcua_basic_types_1.encodeUInt64,
        coerce: node_opcua_basic_types_1.coerceUInt64,
        defaultValue: (0, node_opcua_basic_types_1.coerceUInt64)(0)
      },
      {
        name: "Float",
        subType: "Number",
        decode: node_opcua_basic_types_1.decodeFloat,
        encode: node_opcua_basic_types_1.encodeFloat,
        coerce: node_opcua_basic_types_1.coerceFloat,
        defaultValue: 0
      },
      {
        name: "Double",
        subType: "Number",
        decode: node_opcua_basic_types_1.decodeDouble,
        encode: node_opcua_basic_types_1.encodeDouble,
        coerce: node_opcua_basic_types_1.coerceDouble,
        defaultValue: 0
      },
      {
        name: "String",
        decode: node_opcua_basic_types_1.decodeString,
        encode: node_opcua_basic_types_1.encodeString,
        defaultValue: ""
      },
      // OPC Unified Architecture, part 3.0 $8.26 page 67
      {
        name: "DateTime",
        decode: node_opcua_basic_types_1.decodeDateTime,
        encode: node_opcua_basic_types_1.encodeDateTime,
        coerce: node_opcua_basic_types_1.coerceDateTime,
        defaultValue: () => node_opcua_basic_types_1.minDate
      },
      {
        name: "Guid",
        decode: node_opcua_basic_types_1.decodeGuid,
        encode: node_opcua_basic_types_1.encodeGuid,
        defaultValue: node_opcua_guid_1.emptyGuid
      },
      {
        name: "ByteString",
        decode: node_opcua_basic_types_1.decodeByteString,
        encode: node_opcua_basic_types_1.encodeByteString,
        coerce: node_opcua_basic_types_1.coerceByteString,
        defaultValue: null,
        toJSON: encode_decode_1.toJSONGuid
      },
      {
        name: "XmlElement",
        decode: node_opcua_basic_types_1.decodeString,
        encode: node_opcua_basic_types_1.encodeString,
        defaultValue: defaultXmlElement
      },
      // see OPCUA Part 3 - V1.02 $8.2.1
      {
        name: "NodeId",
        decode: node_opcua_basic_types_1.decodeNodeId,
        encode: node_opcua_basic_types_1.encodeNodeId,
        coerce: node_opcua_basic_types_1.coerceNodeId,
        defaultValue: node_opcua_nodeid_1.makeNodeId
      },
      {
        name: "ExpandedNodeId",
        decode: node_opcua_basic_types_1.decodeExpandedNodeId,
        encode: node_opcua_basic_types_1.encodeExpandedNodeId,
        coerce: node_opcua_basic_types_1.coerceExpandedNodeId,
        defaultValue: node_opcua_nodeid_1.makeExpandedNodeId
      },
      // ----------------------------------------------------------------------------------------
      // Simple  DataTypes
      // ( see OPCUA Part III v1.02 - $5.8.2 )
      // Simple DataTypes are subtypes of the Built-in DataTypes. They are handled on the wire like the
      // Built-in   DataType, i.e. they cannot be distinguished on the wire from their  Built-in super types.
      // Since they are handled like  Built-in   DataTypes  regarding the encoding they cannot have encodings
      // defined  in the  AddressSpace.  Clients  can read the  DataType  Attribute  of a  Variable  or  VariableType  to
      // identify the  Simple  DataType  of the  Value  Attribute. An example of a  Simple  DataType  is  Duration. It
      // is handled on the wire as a  Double   but the Client can read the  DataType  Attribute  and thus interpret
      // the value as defined by  Duration
      //
      // OPC Unified Architecture, part 4.0 $7.13
      // IntegerID: This primitive data type is an UInt32 that is used as an identifier, such as a handle. All values,
      // except for 0, are valid.
      {
        name: "IntegerId",
        decode: node_opcua_basic_types_1.decodeUInt32,
        encode: node_opcua_basic_types_1.encodeUInt32,
        defaultValue: 4294967295
      },
      // The StatusCode is a 32-bit unsigned integer. The top 16 bits represent the numeric value of the
      // code that shall be used for detecting specific errors or conditions. The bottom 16 bits are bit flags
      // that contain additional information but do not affect the meaning of the StatusCode.
      // 7.33 Part 4 - P 143
      {
        name: "StatusCode",
        decode: node_opcua_status_code_1.decodeStatusCode,
        encode: node_opcua_status_code_1.encodeStatusCode,
        coerce: node_opcua_status_code_1.coerceStatusCode,
        defaultValue: node_opcua_status_code_1.StatusCodes.Good
      }
    ];
    var _defaultTypeMap = /* @__PURE__ */ new Map();
    _defaultType.forEach(registerType);
    function registerType(schema) {
      if (!schema.isAbstract) {
        (0, node_opcua_assert_1.assert)(schema.encode);
        (0, node_opcua_assert_1.assert)(schema.decode);
      }
      schema.category = types_1.FieldCategory.basic;
      schema.subType = schema.subType || "";
      if (schema.name !== "Null" && schema.name !== "Any" && schema.name !== "Variant" && schema.name !== "ExtensionObject") {
        const dataType = node_opcua_constants_1.DataTypeIds[schema.name];
        if (!dataType) {
          throw new Error("registerType : dataType " + schema.name + " is not defined");
        }
      }
      const definition = new BasicTypeSchema(schema);
      _defaultTypeMap.set(schema.name, definition);
    }
    exports2.registerType = registerType;
    exports2.registerBuiltInType = registerType;
    function unregisterType(typeName) {
      _defaultTypeMap.delete(typeName);
    }
    exports2.unregisterType = unregisterType;
    function getBuiltInType(name) {
      const typeSchema = _defaultTypeMap.get(name);
      if (!typeSchema) {
        throw new Error("Cannot find schema for simple type " + name);
      }
      return typeSchema;
    }
    exports2.getBuiltInType = getBuiltInType;
    function hasBuiltInType(name) {
      return _defaultTypeMap.has(name);
    }
    exports2.hasBuiltInType = hasBuiltInType;
    function findBuiltInType(dataTypeName) {
      (0, node_opcua_assert_1.assert)(typeof dataTypeName === "string", "findBuiltInType : expecting a string " + dataTypeName);
      const t = getBuiltInType(dataTypeName);
      if (t.subType && t.subType !== t.name) {
        const st = getBuiltInType(t.subType);
        if (!st.isAbstract) {
          return findBuiltInType(t.subType);
        }
      }
      return t;
    }
    exports2.findBuiltInType = findBuiltInType;
  }
});

// node_modules/node-opcua-factory/dist/enumerations.js
var require_enumerations = __commonJS({
  "node_modules/node-opcua-factory/dist/enumerations.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getBuiltInEnumeration = exports2.hasBuiltInEnumeration = exports2.registerEnumeration = exports2.EnumerationDefinitionSchema = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_enum_1 = require_dist25();
    var node_opcua_nodeid_1 = require_dist21();
    var builtin_types_1 = require_builtin_types();
    function _encode_enumeration(typedEnum, value, stream) {
      (0, node_opcua_assert_1.assert)(typeof value === "number", "Expecting a number here");
      (0, node_opcua_assert_1.assert)(typedEnum.get(value) !== void 0, "expecting a valid value");
      stream.writeInteger(value);
    }
    function _decode_enumeration(typedEnum, stream) {
      const value = stream.readInteger();
      const e = typedEnum.get(value);
      if (!e) {
        throw new Error("cannot  coerce value=" + value + " to " + typedEnum.constructor.name);
      }
      return value;
    }
    var EnumerationDefinitionSchema = class extends builtin_types_1.TypeSchemaBase {
      // xx encode: (value: EnumItem, stream: OutputBinaryStream) => void;
      // xx decode: (stream: BinaryStream) => EnumItem;
      constructor(dataTypeNodeId, options) {
        super(options);
        this.dataTypeNodeId = dataTypeNodeId;
        this.enumValues = (0, node_opcua_enum_1.adaptTypescriptEnum)(options.enumValues);
        const typedEnum = new node_opcua_enum_1.Enum(options.enumValues);
        options.typedEnum = typedEnum;
        (0, node_opcua_assert_1.assert)(!options.encode || typeof options.encode === "function");
        (0, node_opcua_assert_1.assert)(!options.decode || typeof options.decode === "function");
        this.encode = options.encode || _encode_enumeration.bind(null, typedEnum);
        this.decode = options.decode || _decode_enumeration.bind(null, typedEnum);
        this.typedEnum = options.typedEnum;
        this.defaultValue = this.typedEnum.getDefaultValue().value;
        this.lengthInBits = options.lengthInBits || 32;
      }
    };
    exports2.EnumerationDefinitionSchema = EnumerationDefinitionSchema;
    var _enumerations = /* @__PURE__ */ new Map();
    function registerEnumeration(options) {
      const dataTypeNodeId = (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_constants_1.DataTypeIds[options.name]);
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "name"));
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "enumValues"));
      const name = options.name;
      if (Object.prototype.hasOwnProperty.call(_enumerations, name)) {
        throw new Error("factories.registerEnumeration : Enumeration " + options.name + " has been already inserted");
      }
      const enumerationDefinition = new EnumerationDefinitionSchema(dataTypeNodeId, options);
      _enumerations.set(name, enumerationDefinition);
      return enumerationDefinition.typedEnum;
    }
    exports2.registerEnumeration = registerEnumeration;
    function hasBuiltInEnumeration(enumerationName) {
      return _enumerations.has(enumerationName);
    }
    exports2.hasBuiltInEnumeration = hasBuiltInEnumeration;
    function getBuiltInEnumeration(enumerationName) {
      if (!hasBuiltInEnumeration(enumerationName)) {
        throw new Error("Cannot find enumeration with type " + enumerationName);
      }
      return _enumerations.get(enumerationName);
    }
    exports2.getBuiltInEnumeration = getBuiltInEnumeration;
  }
});

// node_modules/node-opcua-factory/dist/datatype_factory.js
var require_datatype_factory = __commonJS({
  "node_modules/node-opcua-factory/dist/datatype_factory.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.DataTypeFactory = void 0;
    var util_1 = __importDefault3(require("util"));
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_constants_1 = require_dist20();
    var builtin_types_1 = require_builtin_types();
    var enumerations_1 = require_enumerations();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var DataTypeFactory = class {
      constructor(baseDataFactories) {
        this.imports = [];
        this._structureInfoByName = /* @__PURE__ */ new Map();
        this._structureInfoByDataTypeMap = /* @__PURE__ */ new Map();
        this._structureInfoByEncodingMap = /* @__PURE__ */ new Map();
        this._enumerations = /* @__PURE__ */ new Map();
        this.defaultByteOrder = "LittleEndian";
        this.targetNamespace = "";
        this.baseDataFactories = baseDataFactories;
      }
      getStructureIterator() {
        return this._structureInfoByDataTypeMap.values();
      }
      getEnumIterator() {
        return this._enumerations.values();
      }
      repairBaseDataFactories(baseDataFactories) {
        this.baseDataFactories = baseDataFactories;
      }
      hasBuiltInType(name) {
        return (0, builtin_types_1.hasBuiltInType)(name);
      }
      getBuiltInType(name) {
        return (0, builtin_types_1.getBuiltInType)(name);
      }
      getBuiltInTypeByDataType(nodeId) {
        return (0, builtin_types_1.getBuiltInType)(node_opcua_constants_1.DataTypeIds[nodeId.value]);
      }
      // -----------------------------
      // EnumerationDefinitionSchema
      registerEnumeration(enumeration) {
        (0, node_opcua_assert_1.assert)(!this._enumerations.has(enumeration.name), "enumeration already registered");
        this._enumerations.set(enumeration.name, enumeration);
      }
      hasEnumeration(enumName) {
        if (this._enumerations.has(enumName)) {
          return true;
        }
        for (const factory of this.baseDataFactories) {
          const e = factory.hasEnumeration(enumName);
          if (e) {
            return true;
          }
        }
        if ((0, enumerations_1.hasBuiltInEnumeration)(enumName)) {
          return true;
        }
        return false;
      }
      getEnumeration(enumName) {
        if (this._enumerations.has(enumName)) {
          return this._enumerations.get(enumName) || null;
        }
        for (const factory of this.baseDataFactories) {
          const hasEnum = factory.hasEnumeration(enumName);
          if (hasEnum) {
            const e = factory.getEnumeration(enumName);
            return e;
          }
        }
        const ee = (0, enumerations_1.getBuiltInEnumeration)(enumName);
        return ee;
      }
      //  ----------------------------
      findStructureInfoForDataType(dataTypeNodeId) {
        const structureInfo = this.getStructureInfoForDataType(dataTypeNodeId);
        if (structureInfo) {
          return structureInfo;
        }
        this.getStructureInfoForDataType(dataTypeNodeId);
        throw new Error("Cannot find StructureType constructor for dataType " + dataTypeNodeId.toString());
      }
      getStructureInfoForDataType(dataTypeNodeId) {
        const structureInfo = this._structureInfoByDataTypeMap.get(dataTypeNodeId.toString());
        if (structureInfo) {
          return structureInfo;
        }
        for (const factory of this.baseDataFactories) {
          const structureInfo2 = factory.getStructureInfoForDataType(dataTypeNodeId);
          if (structureInfo2) {
            return structureInfo2;
          }
        }
        return null;
      }
      // ----------------------------------------------------------------------------------------------------
      // Access by typeName
      // ----------------------------------------------------------------------------------------------------
      structuredTypesNames() {
        return this._structureInfoByName.keys();
      }
      enumerations() {
        return this._enumerations.keys();
      }
      getStructureInfoByTypeName(typeName) {
        const structureInfo = this._structureInfoByName.get(typeName);
        if (structureInfo) {
          return structureInfo;
        }
        for (const factory of this.baseDataFactories) {
          if (!factory.hasStructureByTypeName(typeName)) {
            continue;
          }
          const structureInfo2 = factory.getStructureInfoByTypeName(typeName);
          if (structureInfo2) {
            return structureInfo2;
          }
        }
        if (doDebug) {
          debugLog([...this.structuredTypesNames()].join(" "));
        }
        throw new Error("Cannot find StructureType constructor for " + typeName + " - it may be abstract, or it could be a basic type");
      }
      hasStructureByTypeName(typeName) {
        if (this._structureInfoByName.has(typeName)) {
          return true;
        }
        for (const factory of this.baseDataFactories) {
          if (factory.hasStructureByTypeName(typeName)) {
            return true;
          }
        }
        return false;
      }
      getStructuredTypeSchema(typeName) {
        const structureInfo = this.getStructureInfoByTypeName(typeName);
        return structureInfo.schema;
      }
      // istanbul ignore next
      dump() {
        warningLog(" dumping registered factories");
        warningLog(" Factory ", [...this.structuredTypesNames()].sort().forEach((e) => e));
        warningLog(" done");
      }
      registerAbstractStructure(dataTypeNodeId, className, schema) {
        schema.isAbstract = true;
        this._registerFactory(dataTypeNodeId, className, null, schema);
      }
      registerClassDefinition(dataTypeNodeId, className, classConstructor) {
        this._registerFactory(dataTypeNodeId, className, classConstructor, classConstructor.schema);
        if (classConstructor.schema.isAbstract) {
          return;
        }
        if (classConstructor.encodingDefaultBinary && classConstructor.encodingDefaultBinary.value !== 0) {
          this.associateWithBinaryEncoding(className, classConstructor.encodingDefaultBinary);
        } else {
          warningLog("warning ", dataTypeNodeId.toString(), "name=", className, " does not have binary encoding");
        }
      }
      // ----------------------------------------------------------------------------------------------------
      // Access by binaryEncodingNodeId
      // ----------------------------------------------------------------------------------------------------
      getConstructor(binaryEncodingNodeId) {
        const expandedNodeIdKey = makeExpandedNodeIdKey(binaryEncodingNodeId);
        const structureInfo = this._structureInfoByEncodingMap.get(expandedNodeIdKey);
        if (!structureInfo)
          return null;
        const Constructor = structureInfo.constructor;
        if (Constructor) {
          return Constructor;
        }
        for (const factory of this.baseDataFactories) {
          const Constructor2 = factory.getConstructor(binaryEncodingNodeId);
          if (Constructor2) {
            return Constructor2;
          }
        }
        debugLog(chalk_1.default.red("#getConstructor : cannot find constructor for expandedId "), binaryEncodingNodeId.toString());
        return null;
      }
      hasConstructor(binaryEncodingNodeId) {
        if (!binaryEncodingNodeId) {
          return false;
        }
        verifyExpandedNodeId(binaryEncodingNodeId);
        const expandedNodeIdKey = makeExpandedNodeIdKey(binaryEncodingNodeId);
        const constructor = this._structureInfoByEncodingMap.get(expandedNodeIdKey);
        if (constructor) {
          return true;
        }
        for (const factory of this.baseDataFactories) {
          const constructor2 = factory.getConstructor(binaryEncodingNodeId);
          if (constructor2) {
            return true;
          }
        }
        return false;
      }
      constructObject(binaryEncodingNodeId) {
        verifyExpandedNodeId(binaryEncodingNodeId);
        const Constructor = this.getConstructor(binaryEncodingNodeId);
        if (!Constructor) {
          debugLog("Cannot find constructor for " + binaryEncodingNodeId.toString());
          throw new Error("Cannot find constructor for " + binaryEncodingNodeId.toString());
        }
        return new Constructor();
      }
      associateWithBinaryEncoding(className, expandedNodeId) {
        const structureInfo = this.getStructureInfoByTypeName(className);
        verifyExpandedNodeId(expandedNodeId);
        const expandedNodeIdKey = makeExpandedNodeIdKey(expandedNodeId);
        if (this._structureInfoByEncodingMap.has(expandedNodeIdKey)) {
          throw new Error(" Class " + className + " with ID " + expandedNodeId + "  already in constructorMap for  " + this._structureInfoByEncodingMap.get(expandedNodeIdKey).schema.name);
        }
        this._structureInfoByEncodingMap.set(expandedNodeIdKey, structureInfo);
      }
      toString() {
        const l2 = [];
        function write(...args) {
          l2.push(util_1.default.format.apply(util_1.default.format, args));
        }
        dumpDataFactory(this, write);
        return l2.join("\n");
      }
      _registerFactory(dataTypeNodeId, typeName, constructor, schema) {
        if (this._structureInfoByName.has(typeName)) {
          warningLog("target namespace = `" + this.targetNamespace + "`");
          warningLog("registerFactory  : " + typeName + " already registered. dataTypeNodeId=", dataTypeNodeId.toString());
          return;
        }
        debugLog("registering typeName ", typeName, dataTypeNodeId.toString(), "isAbstract ", schema.isAbstract);
        const structureInfo = { constructor, schema };
        this._structureInfoByName.set(typeName, structureInfo);
        if (dataTypeNodeId.value !== 0) {
          this._structureInfoByDataTypeMap.set(dataTypeNodeId.toString(), structureInfo);
        }
      }
    };
    exports2.DataTypeFactory = DataTypeFactory;
    function dumpSchema(schema, write) {
      write("name           ", schema.name);
      write("dataType       ", schema.dataTypeNodeId.toString());
      write("binaryEncoding ", schema.encodingDefaultBinary.toString());
      for (const f2 of schema.fields) {
        write("          ", f2.name.padEnd(30, " "), f2.isArray ? true : false, f2.fieldType);
      }
    }
    function dumpDataFactory(dataFactory, write) {
      for (const structureTypeName of dataFactory.structuredTypesNames()) {
        const schema = dataFactory.getStructuredTypeSchema(structureTypeName);
        write("structureTypeName =", structureTypeName);
        if (!dataFactory.getStructureInfoForDataType(schema.dataTypeNodeId)) {
          write("  ( No constructor for " + schema.name + "  " + schema.dataTypeNodeId.toString());
        }
        if (!schema.encodingDefaultBinary) {
          write(" (Schema has no encoding defaultBinary )");
        } else {
          if (dataFactory.hasConstructor(schema.encodingDefaultBinary)) {
            write("ERROR: cannot find constructor for encodingDefaultBinary");
            write("schema             name:", schema.name, "(abstract=", schema.isAbstract, ")");
            write("        dataType NodeId:", schema.dataTypeNodeId.toString());
            write("encoding Default Binary:", schema.encodingDefaultBinary ? schema.encodingDefaultBinary.toString() : " ");
            write("encoding Default Xml   :", schema.encodingDefaultXml ? schema.encodingDefaultXml.toString() : " ");
          }
        }
        dumpSchema(schema, write);
      }
    }
    function verifyExpandedNodeId(expandedNodeId) {
      if (expandedNodeId.value instanceof Buffer) {
        throw new Error("getConstructor not implemented for opaque nodeid");
      }
      return true;
    }
    function makeExpandedNodeIdKey(expandedNodeId) {
      return expandedNodeId.toString();
    }
  }
});

// node_modules/node-opcua-factory/dist/get_standard_data_type_factory.js
var require_get_standard_data_type_factory = __commonJS({
  "node_modules/node-opcua-factory/dist/get_standard_data_type_factory.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.dump = exports2.getStructureTypeConstructor = exports2.getStandardDataTypeFactory = void 0;
    var datatype_factory_1 = require_datatype_factory();
    var globalFactory;
    function getStandardDataTypeFactory() {
      if (!globalFactory) {
        globalFactory = new datatype_factory_1.DataTypeFactory([]);
        globalFactory.targetNamespace = "http://opcfoundation.org/UA/";
      }
      return globalFactory;
    }
    exports2.getStandardDataTypeFactory = getStandardDataTypeFactory;
    function getStructureTypeConstructor(typeName) {
      const structureInfo = getStandardDataTypeFactory().getStructureInfoByTypeName(typeName);
      if (!structureInfo) {
        throw new Error("cannot find Structure Information for " + typeName);
      }
      if (!structureInfo.constructor) {
        throw new Error("cannot  Structure is Abstract ! " + typeName);
      }
      return structureInfo.constructor;
    }
    exports2.getStructureTypeConstructor = getStructureTypeConstructor;
    function dump() {
      getStandardDataTypeFactory().dump();
    }
    exports2.dump = dump;
  }
});

// node_modules/node-opcua-factory/dist/base_ua_object.js
var require_base_ua_object = __commonJS({
  "node_modules/node-opcua-factory/dist/base_ua_object.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.BaseUAObject = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_binary_stream_1 = require_dist18();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_utils_1 = require_dist16();
    var enumerations_1 = require_enumerations();
    var get_standard_data_type_factory_1 = require_get_standard_data_type_factory();
    var types_1 = require_types();
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    function r(str, length = 30) {
      return (str + "                                ").substring(0, length);
    }
    function _findFieldSchema(typeDictionary, field, value) {
      const fieldType = field.fieldType;
      if (field.allowSubType && field.category === "complex") {
        const fieldTypeConstructor2 = value ? value.constructor : field.fieldTypeConstructor;
        const _newFieldSchema = fieldTypeConstructor2.schema;
        return _newFieldSchema;
      }
      const fieldTypeConstructor = field.fieldTypeConstructor;
      if (fieldTypeConstructor) {
        return fieldTypeConstructor.prototype.schema;
      }
      const strucutreInfo = typeDictionary.getStructureInfoByTypeName(fieldType);
      return strucutreInfo.schema;
    }
    function _decode_member_(value, field, stream, options) {
      const tracer = options.tracer;
      const cursorBefore = stream.length;
      const fieldType = field.fieldType;
      switch (field.category) {
        case types_1.FieldCategory.basic:
          if (field.schema.decode) {
            value = field.schema.decode(stream);
          }
          tracer.trace("member", options.name, value, cursorBefore, stream.length, fieldType);
          break;
        case types_1.FieldCategory.enumeration:
          if (field.schema.decode) {
            value = field.schema.decode(stream);
          }
          tracer.trace("member", options.name, value, cursorBefore, stream.length, fieldType);
          break;
        case types_1.FieldCategory.complex: {
          (0, node_opcua_assert_1.assert)(field.category === types_1.FieldCategory.complex);
          if (!field.fieldTypeConstructor) {
            field.fieldTypeConstructor = (0, get_standard_data_type_factory_1.getStructureTypeConstructor)(field.fieldType);
          }
          if (typeof field.fieldTypeConstructor !== "function") {
            throw new Error("Cannot find constructor for  " + field.name + "of type " + field.fieldType);
          }
          const constructor = field.fieldTypeConstructor;
          value = new constructor();
          value.decodeDebug(stream, options);
        }
      }
      return value;
    }
    function _applyOnAllSchemaFields(self2, schema, data, functor, args) {
      const baseSchema = schema.getBaseSchema();
      if (baseSchema) {
        _applyOnAllSchemaFields(self2, baseSchema, data, functor, args);
      }
      for (const field of schema.fields) {
        functor(self2, field, data, args);
      }
    }
    var _nbElements = typeof process === "object" ? process.env.ARRAYLENGTH ? parseInt(process.env.ARRAYLENGTH, 10) : 10 : 10;
    var fullBuffer = typeof process === "object" ? !!process.env?.FULLBUFFER : false;
    function _arrayEllipsis(value, data) {
      if (!value) {
        return "null []";
      } else {
        if (value.length === 0) {
          return "[ /* empty*/ ]";
        }
        (0, node_opcua_assert_1.assert)(Array.isArray(value));
        const v = [];
        const m2 = Math.min(_nbElements, value.length);
        const ellipsis = value.length > _nbElements ? " ... " : "";
        const pad = data.padding + "  ";
        let isMultiLine = true;
        for (let i = 0; i < m2; i++) {
          let element = value[i];
          if (element instanceof Buffer) {
            element = (0, node_opcua_debug_1.hexDump)(element, 32, 16);
          } else if ((0, node_opcua_utils_1.isNullOrUndefined)(element)) {
            element = "null";
          } else {
            element = element.toString();
            const s = element.split("\n");
            if (s.length > 1) {
              element = "\n" + pad + s.join("\n" + pad);
              isMultiLine = true;
            }
          }
          if (element.length > 80) {
            isMultiLine = true;
          }
          v.push(element);
        }
        const length = "/* length =" + value.length + "*/";
        if (isMultiLine) {
          return "[ " + length + "\n" + pad + v.join(",\n" + pad + "    ") + ellipsis + "\n" + data.padding + "]";
        } else {
          return "[ " + length + v.join(",") + ellipsis + "]";
        }
      }
    }
    function _exploreObject(self2, field, data, args) {
      if (!self2) {
        return;
      }
      const fieldType = field.fieldType;
      const fieldName = field.name;
      const category = field.category;
      const padding = data.padding;
      let value = self2[fieldName];
      let str;
      let opt = "    ";
      if (field.switchBit !== void 0) {
        opt = " ?" + field.switchBit + " ";
      }
      if (field.switchValue !== void 0) {
        opt = " !" + field.switchValue + " ";
      }
      const allowSubTypeSymbol = field.allowSubType ? "~" : " ";
      const arraySymbol = field.isArray ? "[]" : "  ";
      const fieldNameF = chalk_1.default.yellow(r(padding + fieldName, 30));
      const fieldTypeF = chalk_1.default.cyan(`/* ${allowSubTypeSymbol}${r(fieldType + opt, 38)}${arraySymbol}  */`);
      if (field.switchBit !== void 0 && value === void 0) {
        str = fieldNameF + " " + fieldTypeF + ": " + chalk_1.default.italic.grey("undefined") + " /* optional field not specified */";
        data.lines.push(str);
        return;
      }
      if (field.switchValue !== void 0 && value === void 0) {
        str = fieldNameF + " " + fieldTypeF + ": " + chalk_1.default.italic.grey("undefined") + " /* union field not specified */";
        data.lines.push(str);
        return;
      }
      if (fieldType === "QualifiedName" && !field.isArray && value) {
        value = value.toString() || "<null>";
        str = fieldNameF + " " + fieldTypeF + ": " + chalk_1.default.green(value.toString());
        data.lines.push(str);
        return;
      }
      if (fieldType === "LocalizedText" && !field.isArray && value) {
        value = value.toString() || "<null>";
        str = fieldNameF + " " + fieldTypeF + ": " + chalk_1.default.green(value.toString());
        data.lines.push(str);
        return;
      }
      if (fieldType === "DataValue" && !field.isArray && value) {
        value = value.toString(data);
        str = fieldNameF + " " + fieldTypeF + ": " + chalk_1.default.green(value.toString(data));
        data.lines.push(str);
        return;
      }
      function _dump_enumeration_value(self3, field2, data2, value2, fieldType2) {
        const s = field2.schema;
        if (!s.typedEnum) {
          errorLog("xxxx cannot find typeEnum", s);
        }
        const convert = (value3) => {
          if (!s.typedEnum.get(value3)) {
            return [value3, s.typedEnum.get(value3)];
          } else {
            return [value3, s.typedEnum.get(value3).key];
          }
        };
        const toS = ([n, s2]) => `${n} /*(${s2})*/`;
        if (field2.isArray) {
          str = fieldNameF + " " + fieldTypeF + ": [" + value2.map((c2) => convert(c2)).map(toS).join(", ") + "]";
          data2.lines.push(str);
        } else {
          const c2 = convert(value2);
          str = `${fieldNameF} ${fieldTypeF}: ${toS(c2)}`;
          data2.lines.push(str);
        }
      }
      function _dump_simple_value(self3, field2, data2, value2, fieldType2) {
        let str2 = "";
        if (value2 instanceof Buffer) {
          data2.lines.push(fieldNameF + " " + fieldTypeF);
          if (fullBuffer || value2.length <= 32) {
            const _hexDump = value2.length <= 32 ? "Ox" + value2.toString("hex") : "\n" + (0, node_opcua_debug_1.hexDump)(value2);
            data2.lines.push("Buffer: " + _hexDump);
          } else {
            const _hexDump1 = value2.subarray(0, 16).toString("hex");
            const _hexDump2 = value2.subarray(-16).toString("hex");
            data2.lines.push("Buffer: ", _hexDump1 + "..." + _hexDump2);
          }
        } else {
          if (field2.isArray) {
            str2 = fieldNameF + " " + fieldTypeF + ": " + _arrayEllipsis(value2, data2);
          } else {
            if (field2.fieldType === "NodeId" && value2 instanceof node_opcua_nodeid_1.NodeId) {
              value2 = value2.displayText();
            } else if (fieldType2 === "IntegerId" || fieldType2 === "UInt32") {
              if (field2.name === "attributeId") {
                value2 = "AttributeIds." + node_opcua_basic_types_1.AttributeIds[value2] + "/* " + value2 + " */";
              } else {
                const extra = value2 !== void 0 ? "0x" + value2.toString(16) : "undefined";
                value2 = "" + value2 + "               " + extra;
              }
            } else if (fieldType2 === "DateTime" || fieldType2 === "UtcTime") {
              try {
                value2 = value2 && value2.toISOString ? value2.toISOString() : value2;
              } catch {
                value2 = chalk_1.default.red(value2?.toString() + " *** ERROR ***");
              }
            } else if (typeof value2 === "object" && value2 !== null && value2 !== void 0) {
              value2 = value2.toString.apply(value2, args);
            }
            str2 = fieldNameF + " " + fieldTypeF + ": " + (value2 === null || value2 === void 0 ? chalk_1.default.blue("null") : value2.toString());
          }
          data2.lines.push(str2);
        }
      }
      function _dump_complex_value(self3, field2, data2, value2, fieldType2) {
        if (field2.subType) {
          fieldType2 = field2.subType;
          _dump_simple_value(self3, field2, data2, value2, fieldType2);
        } else {
          const typeDictionary = self3.schema.getDataTypeFactory();
          if (!typeDictionary) {
            errorLog("Internal Error: No typeDictionary for ", self3.schema);
            return;
          }
          if (field2.isArray) {
            if (value2 === null) {
              data2.lines.push(fieldNameF + " " + fieldTypeF + ": null []");
            } else if (value2.length === 0) {
              data2.lines.push(fieldNameF + " " + fieldTypeF + ": [ /* empty */ ]");
            } else {
              data2.lines.push(fieldNameF + " " + fieldTypeF + ": [");
              const m2 = Math.min(_nbElements, value2.length);
              for (let i = 0; i < m2; i++) {
                const element = value2[i];
                const _newFieldSchema = _findFieldSchema(typeDictionary, field2, element);
                data2.lines.push(padding + `  { ` + chalk_1.default.cyan(`/* ${i} - ${_newFieldSchema?.name}*/`));
                const data1 = {
                  lines: [],
                  padding: padding + "    "
                };
                _applyOnAllSchemaFields(element, _newFieldSchema, data1, _exploreObject, args);
                data2.lines = data2.lines.concat(data1.lines);
                data2.lines.push(padding + "  }" + (i === value2.length - 1 ? "" : ","));
              }
              if (m2 < value2.length) {
                data2.lines.push(padding + " ..... ( " + value2.length + " elements )");
              }
              data2.lines.push(padding + "]");
            }
          } else {
            const _newFieldSchema = _findFieldSchema(typeDictionary, field2, value2);
            data2.lines.push(fieldNameF + " " + fieldTypeF + ": {");
            const data1 = { padding: padding + "  ", lines: [] };
            _applyOnAllSchemaFields(value2, _newFieldSchema, data1, _exploreObject, args);
            data2.lines = data2.lines.concat(data1.lines);
            data2.lines.push(padding + "}");
          }
        }
      }
      switch (category) {
        case types_1.FieldCategory.enumeration:
          _dump_enumeration_value(self2, field, data, value, fieldType);
          break;
        case types_1.FieldCategory.basic:
          _dump_simple_value(self2, field, data, value, fieldType);
          break;
        case types_1.FieldCategory.complex:
          _dump_complex_value(self2, field, data, value, fieldType);
          break;
        default:
          throw new Error("internal error: unknown kind_of_field " + category);
      }
    }
    function json_ify(t, value, fieldType) {
      if (value instanceof Array) {
        return value.map((e) => e && e.toJSON ? e.toJSON() : e);
      }
      if (t && t.toJSON) {
        return t.toJSON(value);
      } else if (value.toJSON) {
        return value.toJSON();
      } else {
        return value;
      }
    }
    function _JSONify(self2, schema, pojo) {
      for (const field of schema.fields) {
        const fieldValue = self2[field.name];
        if (fieldValue === null || fieldValue === void 0) {
          continue;
        }
        if ((0, enumerations_1.hasBuiltInEnumeration)(field.fieldType)) {
          const enumeration = (0, enumerations_1.getBuiltInEnumeration)(field.fieldType);
          (0, node_opcua_assert_1.assert)(enumeration !== null);
          if (field.isArray) {
            pojo[field.name] = fieldValue.map((value) => enumeration.enumValues[value.toString()]);
          } else {
            pojo[field.name] = enumeration.enumValues[fieldValue.toString()];
          }
          continue;
        }
        const t = field.schema;
        if (field.isArray) {
          pojo[field.name] = fieldValue.map((value) => json_ify(t, value, field));
        } else {
          pojo[field.name] = json_ify(t, fieldValue, field);
        }
      }
    }
    var BaseUAObject = class {
      constructor() {
      }
      /**
       * Encode the object to the binary stream.
       * @class BaseUAObject
       * @method encode
       * @param stream {BinaryStream}
       */
      encode(stream) {
      }
      /**
       * Decode the object from the binary stream.
       * @class BaseUAObject
       * @method decode
       * @param stream {BinaryStream}
       */
      decode(stream) {
      }
      /**
       * Calculate the required size to store this object in a binary stream.
       * @method binaryStoreSize
       * @return number
       */
      binaryStoreSize() {
        const stream = new node_opcua_binary_stream_1.BinaryStreamSizeCalculator();
        this.encode(stream);
        return stream.length;
      }
      /**
       * @method toString
       * @return {String}
       */
      toString(...args) {
        if (this.schema && Object.prototype.hasOwnProperty.call(this.schema, "toString")) {
          return this.schema.toString.apply(this, arguments);
        } else {
          if (!this.explore) {
            return Object.prototype.toString.apply(this, arguments);
          }
          return this.explore();
        }
      }
      /**
       *
       * verify that all object attributes values are valid according to schema
       * @method isValid
       * @return boolean
       */
      isValid() {
        (0, node_opcua_assert_1.assert)(this.schema);
        if (this.schema.isValid) {
          return this.schema.isValid(this);
        } else {
          return true;
        }
      }
      /**
       * @method decodeDebug
       *
       */
      decodeDebug(stream, options) {
        const tracer = options.tracer;
        const schema = this.schema;
        tracer.trace("start", options.name + "(" + schema.name + ")", stream.length, stream.length);
        const self2 = this;
        for (const field of schema.fields) {
          const value = self2[field.name];
          if (typeof field.switchValue === "number") {
            if (self2["switchField"] !== field.switchValue) {
              continue;
            }
          }
          if (field.isArray) {
            const cursorBefore = stream.length;
            let nb = stream.readUInt32();
            if (nb === 4294967295) {
              nb = 0;
            }
            options.name = field.name + [];
            tracer.trace("start_array", field.name, nb, cursorBefore, stream.length);
            for (let i = 0; i < nb; i++) {
              tracer.trace("start_element", field.name, i);
              options.name = "element #" + i;
              _decode_member_(value, field, stream, options);
              tracer.trace("end_element", field.name, i);
            }
            tracer.trace("end_array", field.name, stream.length - 4);
          } else {
            options.name = field.name;
            _decode_member_(value, field, stream, options);
          }
        }
        tracer.trace("end", schema.name, stream.length, stream.length);
      }
      explore() {
        const data = {
          lines: [],
          padding: " "
        };
        data.lines.push("{" + chalk_1.default.cyan(" /*" + (this.schema ? this.schema.name : "") + "*/"));
        if (this.schema) {
          this.applyOnAllFields(_exploreObject, data);
        }
        data.lines.push("};");
        return data.lines.join("\n");
      }
      applyOnAllFields(func, data) {
        _applyOnAllSchemaFields(this, this.schema, data, func, null);
      }
      toJSON() {
        (0, node_opcua_assert_1.assert)(this.schema);
        if (this.schema.toJSON) {
          return this.schema.toJSON.apply(this, arguments);
        } else {
          (0, node_opcua_assert_1.assert)(this.schema);
          const schema = this.schema;
          const pojo = {};
          _visitSchemaChain(this, schema, pojo, _JSONify, null);
          return pojo;
        }
      }
      clone() {
        const self2 = this;
        const params = {};
        function construct_param(schema, options) {
          for (const field of schema.fields) {
            const f2 = self2[field.name];
            if (f2 === null || f2 === void 0) {
              continue;
            }
            if (field.isArray) {
              options[field.name] = [...self2[field.name]];
            } else {
              options[field.name] = self2[field.name];
            }
          }
        }
        construct_param.call(this, self2.schema, params);
        return new self2.constructor(params);
      }
    };
    exports2.BaseUAObject = BaseUAObject;
    function _visitSchemaChain(self2, schema, pojo, func, extraData) {
      (0, node_opcua_assert_1.assert)(typeof func === "function");
      const baseSchema = schema.getBaseSchema ? schema.getBaseSchema() : null;
      if (baseSchema) {
        _visitSchemaChain(self2, baseSchema, pojo, func, extraData);
      }
      func.call(null, self2, schema, pojo);
    }
  }
});

// node_modules/node-opcua-factory/dist/basic_type.js
var require_basic_type = __commonJS({
  "node_modules/node-opcua-factory/dist/basic_type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.registerBasicType = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_debug_1 = require_dist24();
    var builtin_types_1 = require_builtin_types();
    var errorLog = (0, node_opcua_debug_1.make_errorLog)("Factory");
    function registerBasicType(schema) {
      const exists = (0, builtin_types_1.hasBuiltInType)(schema.name);
      if (exists) {
        errorLog("registerBasicType:", schema);
        throw new Error(`Basic Type ${schema.name} already registered`);
      }
      const name = schema.name;
      const t = (0, builtin_types_1.getBuiltInType)(schema.subType);
      if (!t) {
        throw new Error(" cannot find subtype " + schema.subType);
      }
      (0, node_opcua_assert_1.assert)(typeof t.decode === "function");
      const encodeFunc = schema.encode || t.encode;
      (0, node_opcua_assert_1.assert)(typeof encodeFunc === "function");
      const decodeFunc = schema.decode || t.decode;
      (0, node_opcua_assert_1.assert)(typeof decodeFunc === "function");
      const defaultValue = schema.defaultValue === void 0 ? t.defaultValue : schema.defaultValue;
      const coerceFunc = schema.coerce || t.coerce;
      const toJSONFunc = schema.toJSON || t.toJSON;
      const random = schema.random || defaultValue;
      const newSchema = {
        name,
        subType: schema.subType,
        coerce: coerceFunc,
        decode: decodeFunc,
        encode: encodeFunc,
        random,
        defaultValue,
        toJSON: toJSONFunc
      };
      (0, builtin_types_1.registerType)(newSchema);
    }
    exports2.registerBasicType = registerBasicType;
    registerBasicType({ name: "Counter", subType: "UInt32" });
    registerBasicType({ name: "Duration", subType: "Double" });
    registerBasicType({ name: "UtcTime", subType: "DateTime" });
    registerBasicType({
      name: "LocaleId",
      subType: "String",
      defaultValue: null,
      decode: node_opcua_basic_types_1.decodeLocaleId,
      encode: node_opcua_basic_types_1.encodeLocaleId,
      validate: node_opcua_basic_types_1.validateLocaleId
    });
    registerBasicType({ name: "ContinuationPoint", subType: "ByteString" });
    registerBasicType({ name: "Image", subType: "ByteString" });
    registerBasicType({ name: "ImageBMP", subType: "Image" });
    registerBasicType({ name: "ImageGIF", subType: "Image" });
    registerBasicType({ name: "ImageJPG", subType: "Image" });
    registerBasicType({ name: "ImagePNG", subType: "Image" });
    registerBasicType({ name: "AudioDataType", subType: "ByteString" });
    registerBasicType({ name: "BitFieldMaskDataType", subType: "UInt64" });
    registerBasicType({ name: "DataSetFieldFlags", subType: "UInt16" });
    registerBasicType({ name: "DataSetFieldContentMask", subType: "UInt32" });
    registerBasicType({ name: "UadpNetworkMessageContentMask", subType: "UInt32" });
    registerBasicType({ name: "UadpDataSetMessageContentMask", subType: "UInt32" });
    registerBasicType({ name: "JsonNetworkMessageContentMask", subType: "UInt32" });
    registerBasicType({ name: "JsonDataSetMessageContentMask", subType: "UInt32" });
    registerBasicType({ name: "PermissionType", subType: "UInt32" });
    registerBasicType({ name: "AccessLevelType", subType: "Byte" });
    registerBasicType({ name: "AccessLevelExType", subType: "UInt32" });
    registerBasicType({ name: "EventNotifierType", subType: "Byte" });
    registerBasicType({ name: "AccessRestrictionType", subType: "UInt32" });
    registerBasicType({ name: "NormalizedString", subType: "String" });
    registerBasicType({ name: "DecimalString", subType: "String" });
    registerBasicType({ name: "DurationString", subType: "String" });
    registerBasicType({ name: "TimeString", subType: "String" });
    registerBasicType({ name: "DateString", subType: "String" });
    registerBasicType({ name: "Index", subType: "UInt32" });
    registerBasicType({ name: "VersionTime", subType: "UInt32" });
    registerBasicType({ name: "ApplicationInstanceCertificate", subType: "ByteString" });
    registerBasicType({ name: "AttributeWriteMask", subType: "UInt32" });
  }
});

// node_modules/node-opcua-factory/dist/builtin_types_special.js
var require_builtin_types_special = __commonJS({
  "node_modules/node-opcua-factory/dist/builtin_types_special.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.registerSpecialVariantEncoder = void 0;
    var node_opcua_assert_1 = require_dist14();
    var builtin_types_1 = require_builtin_types();
    function _self_encode(constructor) {
      (0, node_opcua_assert_1.assert)(typeof constructor === "function");
      return (value, stream) => {
        if (!value || !value.encode) {
          value = new constructor(value);
        }
        value.encode(stream);
      };
    }
    function _self_decode(constructor) {
      (0, node_opcua_assert_1.assert)(typeof constructor === "function");
      return (stream) => {
        const value = new constructor();
        value.decode(stream);
        return value;
      };
    }
    function _self_coerce(constructor) {
      (0, node_opcua_assert_1.assert)(typeof constructor === "function");
      return (value) => {
        const obj = new constructor(value);
        return obj;
      };
    }
    function registerSpecialVariantEncoder(constructor) {
      (0, node_opcua_assert_1.assert)(typeof constructor === "function");
      const name = constructor.prototype.schema.name;
      (0, builtin_types_1.registerType)({
        name,
        subType: name,
        encode: _self_encode(constructor),
        decode: _self_decode(constructor),
        coerce: _self_coerce(constructor),
        defaultValue: () => new constructor()
      });
    }
    exports2.registerSpecialVariantEncoder = registerSpecialVariantEncoder;
  }
});

// node_modules/node-opcua-factory/dist/get_structured_type_schema.js
var require_get_structured_type_schema = __commonJS({
  "node_modules/node-opcua-factory/dist/get_structured_type_schema.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-factory/dist/id_generator.js
var require_id_generator = __commonJS({
  "node_modules/node-opcua-factory/dist/id_generator.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.is_internal_id = exports2.next_available_id = exports2.generate_new_id = void 0;
    var _FIRST_INTERNAL_ID = 4294836224;
    var _nextAvailableId = _FIRST_INTERNAL_ID;
    function generate_new_id() {
      _nextAvailableId += 1;
      return _nextAvailableId;
    }
    exports2.generate_new_id = generate_new_id;
    function next_available_id() {
      return -1;
    }
    exports2.next_available_id = next_available_id;
    function is_internal_id(value) {
      return value >= _FIRST_INTERNAL_ID;
    }
    exports2.is_internal_id = is_internal_id;
  }
});

// node_modules/node-opcua-factory/dist/nodeid_type.js
var require_nodeid_type = __commonJS({
  "node_modules/node-opcua-factory/dist/nodeid_type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2._enumerationNodeIdType = exports2.schemaNodeIdType = exports2.NodeIdType = void 0;
    var enumerations_1 = require_enumerations();
    var NodeIdType;
    (function(NodeIdType2) {
      NodeIdType2[NodeIdType2["ReferenceType"] = 1] = "ReferenceType";
      NodeIdType2[NodeIdType2["IsForward"] = 2] = "IsForward";
      NodeIdType2[NodeIdType2["NodeClass"] = 4] = "NodeClass";
      NodeIdType2[NodeIdType2["BrowseName"] = 8] = "BrowseName";
      NodeIdType2[NodeIdType2["DisplayName"] = 16] = "DisplayName";
      NodeIdType2[NodeIdType2["TypeDefinition"] = 32] = "TypeDefinition";
    })(NodeIdType || (exports2.NodeIdType = NodeIdType = {}));
    exports2.schemaNodeIdType = {
      name: "NodeIdType",
      enumValues: NodeIdType
    };
    exports2._enumerationNodeIdType = (0, enumerations_1.registerEnumeration)(exports2.schemaNodeIdType);
  }
});

// node_modules/node-opcua-factory/dist/parameters.js
var require_parameters = __commonJS({
  "node_modules/node-opcua-factory/dist/parameters.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.parameters = void 0;
    exports2.parameters = {
      debugSchemaHelper: typeof process === "object" && !!process.env.DEBUG_CLASS
    };
  }
});

// node_modules/node-opcua-factory/dist/register_class_definition.js
var require_register_class_definition = __commonJS({
  "node_modules/node-opcua-factory/dist/register_class_definition.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.registerClassDefinition = void 0;
    var get_standard_data_type_factory_1 = require_get_standard_data_type_factory();
    function registerClassDefinition(dataTypeNodeId, className, classConstructor) {
      return (0, get_standard_data_type_factory_1.getStandardDataTypeFactory)().registerClassDefinition(dataTypeNodeId, className, classConstructor);
    }
    exports2.registerClassDefinition = registerClassDefinition;
  }
});

// node_modules/node-opcua-factory/dist/schema_helpers.js
var require_schema_helpers = __commonJS({
  "node_modules/node-opcua-factory/dist/schema_helpers.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.initialize_field_array = exports2.initialize_field = exports2.check_schema_correctness = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_constants_1 = require_dist20();
    var base_ua_object_1 = require_base_ua_object();
    var types_1 = require_types();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    function check_schema_correctness(schema) {
      (0, node_opcua_assert_1.assert)(typeof schema.name === "string", " expecting schema to have a name");
      (0, node_opcua_assert_1.assert)(schema.fields instanceof Array, " expecting schema to provide a set of fields " + schema.name);
      (0, node_opcua_assert_1.assert)(schema.baseType === void 0 || typeof schema.baseType === "string");
    }
    exports2.check_schema_correctness = check_schema_correctness;
    function initialize_field(field, value, factory) {
      const _t = field.schema;
      if (field.allowSubType && field.category === "complex") {
        if (value instanceof base_ua_object_1.BaseUAObject) {
          value = { dataType: node_opcua_constants_1.DataTypeIds.Structure, value };
        }
      }
      if (!(_t !== null && typeof _t === "object")) {
        throw new Error("initialize_field: expecting field.schema to be set field.name = '" + field.name + "' type = " + field.fieldType);
      }
      if (field.category === types_1.FieldCategory.complex) {
        if (field.fieldTypeConstructor) {
          return new field.fieldTypeConstructor(value);
        } else {
          debugLog("xxxx => missing constructor for field type", field.fieldType);
        }
      }
      if (value === void 0 || value === null) {
        const defaultValue = _t.computer_default_value ? _t.computer_default_value(field.defaultValue) : field.defaultValue;
        if (value === void 0) {
          if (_t.coerce) {
            return _t.coerce(defaultValue);
          }
          return defaultValue;
        }
        if (defaultValue === null) {
          if (value === null) {
            return null;
          }
        }
      }
      if (_t.coerce) {
        value = _t.coerce(value);
      }
      if (field.validate) {
        if (!field.validate(value)) {
          throw Error(" invalid value " + value + " for field " + field.name + " of type " + field.fieldType);
        }
      }
      return value;
    }
    exports2.initialize_field = initialize_field;
    function initialize_field_array(field, valueArray, factory) {
      const _t = field.schema;
      let value;
      let i;
      (0, node_opcua_assert_1.assert)(field !== null && typeof field === "object");
      (0, node_opcua_assert_1.assert)(field.isArray);
      if (!valueArray && field.defaultValue === null) {
        return null;
      }
      valueArray = valueArray || [];
      const arr = [];
      for (i = 0; i < valueArray.length; i++) {
        value = initialize_field(field, valueArray[i], factory);
        arr.push(value);
      }
      return arr;
    }
    exports2.initialize_field_array = initialize_field_array;
  }
});

// node_modules/node-opcua-factory/dist/structured_type_schema.js
var require_structured_type_schema = __commonJS({
  "node_modules/node-opcua-factory/dist/structured_type_schema.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.buildStructuredType = exports2.check_options_correctness_against_schema = exports2.extractAllPossibleFields = exports2.StructuredTypeSchema = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_utils_1 = require_dist16();
    var builtin_types_1 = require_builtin_types();
    var parameters_1 = require_parameters();
    var get_standard_data_type_factory_1 = require_get_standard_data_type_factory();
    var types_1 = require_types();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    function figureOutFieldCategory(field, dataTypeFactory) {
      const fieldType = field.fieldType;
      if (field.category) {
        return field.category;
      }
      if (dataTypeFactory.hasEnumeration(fieldType)) {
        return types_1.FieldCategory.enumeration;
      } else if (dataTypeFactory.hasBuiltInType(fieldType)) {
        return types_1.FieldCategory.basic;
      } else if (dataTypeFactory.hasStructureByTypeName(fieldType)) {
        (0, node_opcua_assert_1.assert)(fieldType !== "LocalizedText");
        return types_1.FieldCategory.complex;
      }
      warningLog("Cannot figure out field category for ", field);
      return types_1.FieldCategory.basic;
    }
    var regExp = /((ns[0-9]+:)?)(.*)/;
    function figureOutSchema(underConstructSchema, dataTypeFactory, field, category) {
      if (field.schema) {
        return field.schema;
      }
      if (underConstructSchema.name === field.fieldType) {
        return underConstructSchema;
      }
      let returnValue = null;
      const m2 = field.fieldType.match(regExp);
      if (!m2) {
        throw new Error("malformed fieldType ? : " + field.fieldType);
      }
      const fieldTypeWithoutNS = m2[3];
      switch (category) {
        case types_1.FieldCategory.complex:
          if (dataTypeFactory.hasStructureByTypeName(field.fieldType)) {
            returnValue = dataTypeFactory.getStructuredTypeSchema(fieldTypeWithoutNS);
          } else {
            returnValue = dataTypeFactory.getBuiltInType(fieldTypeWithoutNS);
          }
          break;
        case types_1.FieldCategory.basic:
          returnValue = dataTypeFactory.getBuiltInType(fieldTypeWithoutNS);
          if (!returnValue) {
            if (dataTypeFactory.hasEnumeration(fieldTypeWithoutNS)) {
              warningLog("expecting a enumeration!");
            }
            returnValue = dataTypeFactory.getStructuredTypeSchema(fieldTypeWithoutNS);
            if (returnValue) {
              warningLog("Why can't we find a basic type here ?");
            }
          }
          break;
        case types_1.FieldCategory.enumeration:
          returnValue = dataTypeFactory.getEnumeration(fieldTypeWithoutNS);
          break;
      }
      if (null === returnValue || void 0 === returnValue) {
        try {
          returnValue = dataTypeFactory.getEnumeration(fieldTypeWithoutNS);
        } catch (err) {
          warningLog("dataTypeFactory.getEnumeration has failed", err);
        }
        throw new Error("Cannot find Schema for field with name " + field.name + " fieldTypeWithoutNS= " + fieldTypeWithoutNS + " with type " + field.fieldType + " category = " + category + JSON.stringify(field, null, "	"));
      }
      return returnValue;
    }
    function buildField(underConstructSchema, dataTypeFactory, fieldLight, _index) {
      const category = figureOutFieldCategory(fieldLight, dataTypeFactory);
      const schema = figureOutSchema(underConstructSchema, dataTypeFactory, fieldLight, category);
      if (!schema) {
        throw new Error("expecting a valid schema for field with name " + fieldLight.name + " with type " + fieldLight.fieldType + " category" + category + " at index" + _index);
      }
      const { defaultValue, isArray, documentation, fieldType, switchBit, switchValue, allowSubType, dataType, basicDataType } = fieldLight;
      return {
        name: (0, node_opcua_utils_1.lowerFirstLetter)(fieldLight.name),
        originalName: fieldLight.name,
        category,
        defaultValue,
        isArray,
        documentation,
        fieldType,
        switchBit,
        switchValue,
        allowSubType,
        dataType,
        basicDataType,
        schema
      };
    }
    var StructuredTypeSchema = class extends builtin_types_1.TypeSchemaBase {
      constructor(options) {
        super(options);
        this.bitFields = options.bitFields;
        this.baseType = options.baseType;
        this.category = types_1.FieldCategory.complex;
        this._dataTypeFactory = options.dataTypeFactory;
        if (this._dataTypeFactory.hasBuiltInType(options.name)) {
          this.category = types_1.FieldCategory.basic;
        }
        this.dataTypeNodeId = new node_opcua_nodeid_1.NodeId();
        this._baseSchema = void 0;
        this.fields = options.fields.map(buildField.bind(null, this, this._dataTypeFactory));
      }
      getDataTypeFactory() {
        return this._dataTypeFactory || (0, get_standard_data_type_factory_1.getStandardDataTypeFactory)();
      }
      getBaseSchema() {
        if (this._baseSchema !== void 0 && this._baseSchema === null && this.baseType === "ExtensionObject") {
          return this._baseSchema;
        }
        const _schemaBase = _get_base_schema(this);
        this._baseSchema = _schemaBase;
        return _schemaBase || null;
      }
      getPossibleFieldsLocal() {
        return this.fields.map((field) => field.name);
      }
      toString() {
        const str = [];
        str.push("name           = " + this.name);
        str.push("baseType       = " + this.baseType);
        str.push("bitFields      = " + (this.bitFields ? this.bitFields.map((b) => b.name).join(" ") : void 0));
        str.push("dataTypeNodeId = " + (this.dataTypeNodeId ? this.dataTypeNodeId.toString() : void 0));
        str.push("documentation  = " + this.documentation);
        str.push("encodingDefaultBinary  = " + this.encodingDefaultBinary?.toString());
        str.push("encodingDefaultXml     = " + this.encodingDefaultXml?.toString());
        str.push("encodingDefaultJson    = " + this.encodingDefaultJson?.toString());
        for (const f2 of this.fields) {
          str.push("  field   =  " + f2.name.padEnd(30) + " isArray= " + (f2.isArray ? true : false) + " " + f2.fieldType.toString().padEnd(30) + (f2.switchBit !== void 0 ? " switchBit " + f2.switchBit : "") + (f2.switchValue !== void 0 ? " switchValue    " + f2.switchValue : ""));
        }
        return str.join("\n");
      }
    };
    exports2.StructuredTypeSchema = StructuredTypeSchema;
    function _get_base_schema(schema) {
      const dataTypeFactory = schema.getDataTypeFactory();
      if (schema.baseType === "ExtensionObject" || schema.baseType === "DataTypeDefinition") {
        return null;
      }
      if (schema.baseType === "Union") {
        return null;
      }
      if (schema.baseType && schema.baseType !== "BaseUAObject" && schema.baseType !== "Structure" && schema.baseType !== "DataTypeDefinition") {
        if (!dataTypeFactory.hasStructureByTypeName(schema.baseType)) {
          return void 0;
        }
        const structureInfo = dataTypeFactory.getStructureInfoByTypeName(schema.baseType);
        if (!structureInfo) {
          throw new Error(" cannot find factory for " + schema.baseType);
        }
        if (structureInfo.schema) {
          return structureInfo.schema;
        }
      }
      return null;
    }
    function extractAllPossibleFields(schema) {
      let possibleFields = schema.fields.map((field) => field.name);
      const baseSchema = schema.getBaseSchema();
      if (baseSchema) {
        const fields = extractAllPossibleFields(baseSchema);
        possibleFields = fields.concat(possibleFields);
      }
      return possibleFields;
    }
    exports2.extractAllPossibleFields = extractAllPossibleFields;
    function check_options_correctness_against_schema(obj, schema, options) {
      if (!parameters_1.parameters.debugSchemaHelper) {
        return true;
      }
      options = options || {};
      if (!(options !== null && typeof options === "object") && !(typeof options === "object")) {
        let message = chalk_1.default.red(" Invalid options specified while trying to construct a ") + " " + chalk_1.default.yellow(schema.name);
        message += "\n";
        message += chalk_1.default.red(" expecting a ") + chalk_1.default.yellow(" Object ");
        message += "\n";
        message += chalk_1.default.red(" and got a ") + chalk_1.default.yellow(typeof options) + chalk_1.default.red(" instead ");
        throw new Error(message);
      }
      if (options instanceof obj.constructor) {
        return true;
      }
      const possibleFields = obj.constructor.possibleFields || extractAllPossibleFields(schema);
      const currentFields = Object.keys(options);
      function difference(a1, a2) {
        return [a1, a2].reduce((a, b) => a.filter((value) => !b.includes(value)));
      }
      const invalidOptionsFields = difference(currentFields, possibleFields);
      if (invalidOptionsFields.length > 0) {
        errorLog("expected schema", schema.name);
        errorLog(chalk_1.default.yellow("possible fields= "), possibleFields.sort().join(" "));
        errorLog(chalk_1.default.red("current fields= "), currentFields.sort().join(" "));
        errorLog(chalk_1.default.cyan("invalid_options_fields= "), invalidOptionsFields.sort().join(" "));
        errorLog("options = ", options);
      }
      if (invalidOptionsFields.length !== 0) {
        errorLog(chalk_1.default.yellow("possible fields= "), possibleFields.sort().join(" "));
        errorLog(chalk_1.default.red("current fields= "), currentFields.sort().join(" "));
        throw new Error(" invalid field found in option :" + JSON.stringify(invalidOptionsFields));
      }
      return true;
    }
    exports2.check_options_correctness_against_schema = check_options_correctness_against_schema;
    function buildStructuredType(schemaLight) {
      return new StructuredTypeSchema({
        ...schemaLight,
        dataTypeFactory: (0, get_standard_data_type_factory_1.getStandardDataTypeFactory)()
      });
    }
    exports2.buildStructuredType = buildStructuredType;
  }
});

// node_modules/node-opcua-factory/dist/index.js
var require_dist26 = __commonJS({
  "node_modules/node-opcua-factory/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_base_ua_object(), exports2);
    __exportStar3(require_basic_type(), exports2);
    __exportStar3(require_builtin_types_special(), exports2);
    __exportStar3(require_builtin_types(), exports2);
    __exportStar3(require_datatype_factory(), exports2);
    __exportStar3(require_enumerations(), exports2);
    __exportStar3(require_get_standard_data_type_factory(), exports2);
    __exportStar3(require_get_structured_type_schema(), exports2);
    __exportStar3(require_id_generator(), exports2);
    __exportStar3(require_nodeid_type(), exports2);
    __exportStar3(require_parameters(), exports2);
    __exportStar3(require_register_class_definition(), exports2);
    __exportStar3(require_schema_helpers(), exports2);
    __exportStar3(require_structured_type_schema(), exports2);
    __exportStar3(require_types(), exports2);
  }
});

// node_modules/node-opcua-data-model/dist/localized_text.js
var require_localized_text = __commonJS({
  "node_modules/node-opcua-data-model/dist/localized_text.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.decodeLocalizedText = exports2.encodeLocalizedText = exports2.LocalizedText = exports2.coerceLocalizedText = void 0;
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_factory_1 = require_dist26();
    function coerceLocalizedText(value) {
      if (value === void 0 || value === null) {
        return null;
      }
      if (value instanceof LocalizedText) {
        return value;
      }
      return new LocalizedText(value);
    }
    exports2.coerceLocalizedText = coerceLocalizedText;
    var schemaLocalizedText = (0, node_opcua_factory_1.buildStructuredType)({
      name: "LocalizedText",
      baseType: "BaseUAObject",
      fields: [
        {
          name: "Locale",
          fieldType: "LocaleId",
          defaultValue: null
        },
        {
          name: "Text",
          fieldType: "String",
          defaultValue: null
        }
      ]
    });
    schemaLocalizedText.coerce = coerceLocalizedText;
    var LocalizedText = class extends node_opcua_factory_1.BaseUAObject {
      static get schema() {
        return schemaLocalizedText;
      }
      get schema() {
        return schemaLocalizedText;
      }
      static coerce(value) {
        return coerceLocalizedText(value);
      }
      constructor(options) {
        super();
        if (options === null) {
          this.locale = null;
          this.text = null;
          return;
        }
        if (typeof options === "string") {
          this.locale = null;
          this.text = options;
          return;
        }
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          const schema = schemaLocalizedText;
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.locale = options?.locale || null;
        this.text = options?.text || null;
      }
      toString() {
        return "locale=" + this.locale + " text=" + this.text;
      }
      // OPCUA Part 6 $ 5.2.2.14 : localizedText have a special encoding
      encode(stream) {
        const encodingMask = getLocalizeText_EncodingByte(this);
        (0, node_opcua_basic_types_1.encodeByte)(encodingMask, stream);
        if ((encodingMask & 1) === 1) {
          (0, node_opcua_basic_types_1.encodeString)(this.locale, stream);
        }
        if ((encodingMask & 2) === 2) {
          (0, node_opcua_basic_types_1.encodeString)(this.text, stream);
        }
      }
      decodeDebug(stream, options) {
        let cursorBefore;
        const tracer = options.tracer;
        tracer.trace("start", options.name + "(LocalizedText)", stream.length, stream.length);
        cursorBefore = stream.length;
        const encodingMask = (0, node_opcua_basic_types_1.decodeByte)(stream);
        tracer.trace("member", "encodingByte", "0x" + encodingMask.toString(16), cursorBefore, stream.length, "Mask");
        cursorBefore = stream.length;
        if ((encodingMask & 1) === 1) {
          this.locale = (0, node_opcua_basic_types_1.decodeString)(stream);
          tracer.trace("member", "locale", this.locale, cursorBefore, stream.length, "locale");
          cursorBefore = stream.length;
        } else {
          this.locale = null;
        }
        if ((encodingMask & 2) === 2) {
          this.text = (0, node_opcua_basic_types_1.decodeString)(stream);
          tracer.trace("member", "text", this.text, cursorBefore, stream.length, "text");
        } else {
          this.text = null;
        }
        tracer.trace("end", options.name, stream.length, stream.length);
      }
      decode(stream) {
        const encodingMask = (0, node_opcua_basic_types_1.decodeByte)(stream);
        if ((encodingMask & 1) === 1) {
          this.locale = (0, node_opcua_basic_types_1.decodeString)(stream);
        } else {
          this.locale = null;
        }
        if ((encodingMask & 2) === 2) {
          this.text = (0, node_opcua_basic_types_1.decodeString)(stream);
        } else {
          this.text = null;
        }
      }
    };
    exports2.LocalizedText = LocalizedText;
    LocalizedText.possibleFields = ["locale", "text"];
    (0, node_opcua_factory_1.registerSpecialVariantEncoder)(LocalizedText);
    function getLocalizeText_EncodingByte(localizedText) {
      let encodingMask = 0;
      if (localizedText.locale) {
        encodingMask |= 1;
      }
      if (localizedText.text) {
        encodingMask |= 2;
      }
      return encodingMask;
    }
    var emptyLocalizedText = new LocalizedText({});
    function encodeLocalizedText(value, stream) {
      if (value) {
        value.encode(stream);
      } else {
        emptyLocalizedText.encode(stream);
      }
    }
    exports2.encodeLocalizedText = encodeLocalizedText;
    function decodeLocalizedText(stream, value) {
      value = value || new LocalizedText(null);
      value.decode(stream);
      return value;
    }
    exports2.decodeLocalizedText = decodeLocalizedText;
  }
});

// node_modules/node-opcua-data-model/dist/qualified_name.js
var require_qualified_name = __commonJS({
  "node_modules/node-opcua-data-model/dist/qualified_name.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.decodeQualifiedName = exports2.encodeQualifiedName = exports2.coerceQualifiedName = exports2.stringToQualifiedName = exports2.QualifiedName = exports2.schemaQualifiedName = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_factory_1 = require_dist26();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_basic_types_1 = require_dist23();
    exports2.schemaQualifiedName = (0, node_opcua_factory_1.buildStructuredType)({
      baseType: "BaseUAObject",
      name: "QualifiedName",
      fields: [
        {
          name: "NamespaceIndex",
          fieldType: "UInt16"
        },
        {
          name: "Name",
          fieldType: "String",
          defaultValue: null
        }
      ]
    });
    exports2.schemaQualifiedName.coerce = coerceQualifiedName;
    var QualifiedName = class _QualifiedName extends node_opcua_factory_1.BaseUAObject {
      constructor(options) {
        super();
        if (options === null || options === void 0) {
          this.namespaceIndex = 0;
          this.name = null;
          return;
        }
        if (typeof options === "string") {
          options = { name: options };
        }
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          const schema = _QualifiedName.schema;
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.namespaceIndex = options.namespaceIndex || 0;
        this.name = options.name || null;
      }
      /**
       * encode the object into a binary stream
       */
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt16)(this.namespaceIndex, stream);
        (0, node_opcua_basic_types_1.encodeUAString)(this.name, stream);
      }
      /**
       * decode the object from a binary stream
       */
      decode(stream) {
        super.decode(stream);
        this.namespaceIndex = (0, node_opcua_basic_types_1.decodeUInt16)(stream);
        this.name = (0, node_opcua_basic_types_1.decodeUAString)(stream);
      }
      toString() {
        if (this.namespaceIndex) {
          return this.namespaceIndex + ":" + this.name;
        }
        return this.name || "<null>";
      }
      isEmpty() {
        return !this.name || this.name.length === 0;
      }
      equals(other) {
        return this.name === other.name && this.namespaceIndex === other.namespaceIndex;
      }
    };
    exports2.QualifiedName = QualifiedName;
    QualifiedName.schema = exports2.schemaQualifiedName;
    QualifiedName.possibleFields = ["namespaceIndex", "name"];
    QualifiedName.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(0, 0);
    QualifiedName.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(0, 0);
    QualifiedName.prototype.schema = QualifiedName.schema;
    function isInteger(value) {
      return typeof value === "number" && isFinite(value) && Math.floor(value) === value;
    }
    function stringToQualifiedName(value) {
      const splitArray = value.split(":");
      let namespaceIndex = 0;
      if (!isNaN(parseFloat(splitArray[0])) && isFinite(parseInt(splitArray[0], 10)) && isInteger(parseFloat(splitArray[0])) && splitArray.length > 1) {
        namespaceIndex = parseInt(splitArray[0], 10);
        splitArray.shift();
        value = splitArray.join(":");
      }
      return new QualifiedName({ namespaceIndex, name: value });
    }
    exports2.stringToQualifiedName = stringToQualifiedName;
    function coerceQualifiedName(value) {
      if (!value) {
        return null;
      } else if (value instanceof QualifiedName) {
        return value;
      } else if (typeof value === "string") {
        return stringToQualifiedName(value);
      } else {
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(value, "namespaceIndex"));
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(value, "name"));
        return new QualifiedName(value);
      }
    }
    exports2.coerceQualifiedName = coerceQualifiedName;
    (0, node_opcua_factory_1.registerSpecialVariantEncoder)(QualifiedName);
    function encodeQualifiedName(value, stream) {
      value.encode(stream);
    }
    exports2.encodeQualifiedName = encodeQualifiedName;
    function decodeQualifiedName(stream, value) {
      value = value || new QualifiedName(null);
      value.decode(stream);
      return value;
    }
    exports2.decodeQualifiedName = decodeQualifiedName;
  }
});

// node_modules/node-opcua-data-model/dist/diagnostic_info.js
var require_diagnostic_info = __commonJS({
  "node_modules/node-opcua-data-model/dist/diagnostic_info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.decodeDiagnosticInfo = exports2.encodeDiagnosticInfo = exports2.DiagnosticInfo_EncodingByte = exports2.filterDiagnosticServiceLevel = exports2.filterDiagnosticOperationLevel = exports2.filterDiagnosticInfoLevel = exports2.RESPONSE_DIAGNOSTICS_MASK_ALL = exports2.DiagnosticInfo_OperationLevelMask = exports2.DiagnosticInfo_ServiceLevelMask = exports2.DiagnosticInfo = exports2.schemaDiagnosticInfo = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_factory_1 = require_dist26();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_factory_2 = require_dist26();
    exports2.schemaDiagnosticInfo = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DiagnosticInfo",
      baseType: "BaseUAObject",
      fields: [
        {
          name: "NamespaceUri",
          fieldType: "Int32",
          defaultValue: -1,
          documentation: "The symbolicId is defined within the context of a namespace."
        },
        {
          name: "SymbolicId",
          fieldType: "Int32",
          defaultValue: -1,
          documentation: "The symbolicId shall be used to identify a vendor-specific error or condition"
        },
        {
          name: "Locale",
          fieldType: "Int32",
          defaultValue: -1,
          documentation: "The locale part of the vendor-specific localized text describing the symbolic id."
        },
        { name: "LocalizedText", fieldType: "Int32", defaultValue: -1 },
        {
          name: "AdditionalInfo",
          fieldType: "String",
          defaultValue: null,
          documentation: "Vendor-specific diagnostic information."
        },
        {
          name: "InnerStatusCode",
          fieldType: "StatusCode",
          defaultValue: node_opcua_status_code_1.StatusCodes.Good,
          documentation: "The StatusCode from the inner operation."
        },
        {
          name: "InnerDiagnosticInfo",
          fieldType: "DiagnosticInfo",
          category: node_opcua_factory_1.FieldCategory.basic,
          defaultValue: null,
          documentation: "The diagnostic info associated with the inner StatusCode."
        }
      ]
    });
    var DiagnosticInfo = class _DiagnosticInfo extends node_opcua_factory_1.BaseUAObject {
      /**
       *
       * @class DiagnosticInfo
       * @constructor
       * @extends BaseUAObject
       * @param  options {Object}
       */
      constructor(options = {}) {
        super();
        const schema = exports2.schemaDiagnosticInfo;
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_2.check_options_correctness_against_schema)(this, schema, options);
        }
        this.symbolicId = (0, node_opcua_factory_2.initialize_field)(schema.fields[0], options.symbolicId);
        this.namespaceURI = (0, node_opcua_factory_2.initialize_field)(schema.fields[1], options.namespaceURI);
        this.locale = (0, node_opcua_factory_2.initialize_field)(schema.fields[2], options.locale);
        this.localizedText = (0, node_opcua_factory_2.initialize_field)(schema.fields[3], options.localizedText);
        this.additionalInfo = (0, node_opcua_factory_2.initialize_field)(schema.fields[4], options.additionalInfo);
        this.innerStatusCode = (0, node_opcua_factory_2.initialize_field)(schema.fields[5], options.innerStatusCode);
        this.innerDiagnosticInfo = (0, node_opcua_factory_2.initialize_field)(schema.fields[6], options.innerDiagnosticInfo);
      }
      encode(stream) {
        encode_DiagnosticInfo(this, stream);
      }
      decode(stream) {
        decode_DiagnosticInfo(this, stream);
      }
      decodeDebug(stream, options) {
        decodeDebug_DiagnosticInfo(this, stream, options);
      }
      static filterForResponse(diagnostic, requestedDiagnostics, diagnosticInfoMask) {
        const options = {
          symbolicId: requestedDiagnostics & diagnosticInfoMask.SymbolicId ? diagnostic.symbolicId : void 0,
          localizedText: requestedDiagnostics & diagnosticInfoMask.LocalizedText ? diagnostic.localizedText : void 0,
          additionalInfo: requestedDiagnostics & diagnosticInfoMask.AdditionalInfo ? diagnostic.additionalInfo : void 0,
          innerStatusCode: requestedDiagnostics & diagnosticInfoMask.InnerStatusCode ? diagnostic.innerStatusCode : void 0,
          innerDiagnosticInfo: requestedDiagnostics & diagnosticInfoMask.InnerDiagnostics ? diagnostic.innerDiagnosticInfo : diagnostic.innerDiagnosticInfo ? _DiagnosticInfo.filterForResponse(diagnostic.innerDiagnosticInfo, requestedDiagnostics, diagnosticInfoMask) : void 0
        };
        return new _DiagnosticInfo(options);
      }
    };
    exports2.DiagnosticInfo = DiagnosticInfo;
    DiagnosticInfo.schema = exports2.schemaDiagnosticInfo;
    DiagnosticInfo.possibleFields = [
      "symbolicId",
      "namespaceURI",
      "locale",
      "localizedText",
      "additionalInfo",
      "innerStatusCode",
      "innerDiagnosticInfo"
    ];
    DiagnosticInfo.prototype.schema = DiagnosticInfo.schema;
    DiagnosticInfo.schema.fields[6].schema = DiagnosticInfo.schema;
    var DiagnosticInfo_ServiceLevelMask;
    (function(DiagnosticInfo_ServiceLevelMask2) {
      DiagnosticInfo_ServiceLevelMask2[DiagnosticInfo_ServiceLevelMask2["None"] = 0] = "None";
      DiagnosticInfo_ServiceLevelMask2[DiagnosticInfo_ServiceLevelMask2["SymbolicId"] = 1] = "SymbolicId";
      DiagnosticInfo_ServiceLevelMask2[DiagnosticInfo_ServiceLevelMask2["LocalizedText"] = 2] = "LocalizedText";
      DiagnosticInfo_ServiceLevelMask2[DiagnosticInfo_ServiceLevelMask2["AdditionalInfo"] = 4] = "AdditionalInfo";
      DiagnosticInfo_ServiceLevelMask2[DiagnosticInfo_ServiceLevelMask2["InnerStatusCode"] = 8] = "InnerStatusCode";
      DiagnosticInfo_ServiceLevelMask2[DiagnosticInfo_ServiceLevelMask2["InnerDiagnostics"] = 16] = "InnerDiagnostics";
    })(DiagnosticInfo_ServiceLevelMask || (exports2.DiagnosticInfo_ServiceLevelMask = DiagnosticInfo_ServiceLevelMask = {}));
    var DiagnosticInfo_OperationLevelMask;
    (function(DiagnosticInfo_OperationLevelMask2) {
      DiagnosticInfo_OperationLevelMask2[DiagnosticInfo_OperationLevelMask2["SymbolicId"] = 32] = "SymbolicId";
      DiagnosticInfo_OperationLevelMask2[DiagnosticInfo_OperationLevelMask2["LocalizedText"] = 64] = "LocalizedText";
      DiagnosticInfo_OperationLevelMask2[DiagnosticInfo_OperationLevelMask2["AdditionalInfo"] = 128] = "AdditionalInfo";
      DiagnosticInfo_OperationLevelMask2[DiagnosticInfo_OperationLevelMask2["InnerStatusCode"] = 256] = "InnerStatusCode";
      DiagnosticInfo_OperationLevelMask2[DiagnosticInfo_OperationLevelMask2["InnerDiagnostics"] = 512] = "InnerDiagnostics";
    })(DiagnosticInfo_OperationLevelMask || (exports2.DiagnosticInfo_OperationLevelMask = DiagnosticInfo_OperationLevelMask = {}));
    exports2.RESPONSE_DIAGNOSTICS_MASK_ALL = 1023;
    function filterDiagnosticInfoLevel(returnDiagnostics, diagnostic, diagnosticInfoMask) {
      if (!diagnostic) {
        return null;
      }
      return DiagnosticInfo.filterForResponse(diagnostic, returnDiagnostics, diagnosticInfoMask);
    }
    exports2.filterDiagnosticInfoLevel = filterDiagnosticInfoLevel;
    function filterDiagnosticOperationLevel(returnDiagnostics, diagnostic) {
      return filterDiagnosticInfoLevel(returnDiagnostics, diagnostic, DiagnosticInfo_OperationLevelMask);
    }
    exports2.filterDiagnosticOperationLevel = filterDiagnosticOperationLevel;
    function filterDiagnosticServiceLevel(returnDiagnostics, diagnostic) {
      return filterDiagnosticInfoLevel(returnDiagnostics, diagnostic, DiagnosticInfo_ServiceLevelMask);
    }
    exports2.filterDiagnosticServiceLevel = filterDiagnosticServiceLevel;
    var DiagnosticInfo_EncodingByte;
    (function(DiagnosticInfo_EncodingByte2) {
      DiagnosticInfo_EncodingByte2[DiagnosticInfo_EncodingByte2["SymbolicId"] = 1] = "SymbolicId";
      DiagnosticInfo_EncodingByte2[DiagnosticInfo_EncodingByte2["NamespaceURI"] = 2] = "NamespaceURI";
      DiagnosticInfo_EncodingByte2[DiagnosticInfo_EncodingByte2["LocalizedText"] = 4] = "LocalizedText";
      DiagnosticInfo_EncodingByte2[DiagnosticInfo_EncodingByte2["Locale"] = 8] = "Locale";
      DiagnosticInfo_EncodingByte2[DiagnosticInfo_EncodingByte2["AdditionalInfo"] = 16] = "AdditionalInfo";
      DiagnosticInfo_EncodingByte2[DiagnosticInfo_EncodingByte2["InnerStatusCode"] = 32] = "InnerStatusCode";
      DiagnosticInfo_EncodingByte2[DiagnosticInfo_EncodingByte2["InnerDiagnosticInfo"] = 64] = "InnerDiagnosticInfo";
    })(DiagnosticInfo_EncodingByte || (exports2.DiagnosticInfo_EncodingByte = DiagnosticInfo_EncodingByte = {}));
    function getDiagnosticInfoEncodingByte(diagnosticInfo) {
      (0, node_opcua_assert_1.assert)(diagnosticInfo);
      let encodingMask = 0;
      if (diagnosticInfo.symbolicId >= 0) {
        encodingMask |= DiagnosticInfo_EncodingByte.SymbolicId;
      }
      if (diagnosticInfo.namespaceURI >= 0) {
        encodingMask |= DiagnosticInfo_EncodingByte.NamespaceURI;
      }
      if (diagnosticInfo.localizedText >= 0) {
        encodingMask |= DiagnosticInfo_EncodingByte.LocalizedText;
      }
      if (diagnosticInfo.locale >= 0) {
        encodingMask |= DiagnosticInfo_EncodingByte.Locale;
      }
      if (diagnosticInfo.additionalInfo) {
        encodingMask |= DiagnosticInfo_EncodingByte.AdditionalInfo;
      }
      if (diagnosticInfo.innerStatusCode && diagnosticInfo.innerStatusCode !== node_opcua_status_code_1.StatusCodes.Good) {
        encodingMask |= DiagnosticInfo_EncodingByte.InnerStatusCode;
      }
      if (diagnosticInfo.innerDiagnosticInfo) {
        encodingMask |= DiagnosticInfo_EncodingByte.InnerDiagnosticInfo;
      }
      return encodingMask;
    }
    function encode_DiagnosticInfo(diagnosticInfo, stream) {
      const encodingMask = getDiagnosticInfoEncodingByte(diagnosticInfo);
      (0, node_opcua_basic_types_1.encodeByte)(encodingMask, stream);
      if (encodingMask & DiagnosticInfo_EncodingByte.SymbolicId) {
        (0, node_opcua_basic_types_1.encodeInt32)(diagnosticInfo.symbolicId, stream);
      }
      if (encodingMask & DiagnosticInfo_EncodingByte.NamespaceURI) {
        (0, node_opcua_basic_types_1.encodeInt32)(diagnosticInfo.namespaceURI, stream);
      }
      if (encodingMask & DiagnosticInfo_EncodingByte.Locale) {
        (0, node_opcua_basic_types_1.encodeInt32)(diagnosticInfo.locale, stream);
      }
      if (encodingMask & DiagnosticInfo_EncodingByte.LocalizedText) {
        (0, node_opcua_basic_types_1.encodeInt32)(diagnosticInfo.localizedText, stream);
      }
      if (encodingMask & DiagnosticInfo_EncodingByte.AdditionalInfo) {
        (0, node_opcua_basic_types_1.encodeString)(diagnosticInfo.additionalInfo, stream);
      }
      if (encodingMask & DiagnosticInfo_EncodingByte.InnerStatusCode) {
        (0, node_opcua_basic_types_1.encodeStatusCode)(diagnosticInfo.innerStatusCode, stream);
      }
      if (encodingMask & DiagnosticInfo_EncodingByte.InnerDiagnosticInfo) {
        (0, node_opcua_assert_1.assert)(diagnosticInfo.innerDiagnosticInfo !== null, "missing innerDiagnosticInfo");
        if (diagnosticInfo.innerDiagnosticInfo) {
          encode_DiagnosticInfo(diagnosticInfo.innerDiagnosticInfo, stream);
        }
      }
    }
    function decodeDebug_DiagnosticInfo(diagnosticInfo, stream, options) {
      const tracer = options.tracer;
      tracer.trace("start", options.name + "(DiagnosticInfo)", stream.length, stream.length);
      let cursorBefore = stream.length;
      const encodingMask = (0, node_opcua_basic_types_1.decodeByte)(stream);
      tracer.trace("member", "encodingByte", "0x" + encodingMask.toString(16), cursorBefore, stream.length, "Mask");
      tracer.encoding_byte(encodingMask, DiagnosticInfo_EncodingByte, cursorBefore, stream.length);
      cursorBefore = stream.length;
      if (encodingMask & DiagnosticInfo_EncodingByte.SymbolicId) {
        diagnosticInfo.symbolicId = (0, node_opcua_basic_types_1.decodeInt32)(stream);
        tracer.trace("member", "symbolicId", diagnosticInfo.symbolicId, cursorBefore, stream.length, "Int32");
        cursorBefore = stream.length;
      }
      if (encodingMask & DiagnosticInfo_EncodingByte.NamespaceURI) {
        diagnosticInfo.namespaceURI = (0, node_opcua_basic_types_1.decodeInt32)(stream);
        tracer.trace("member", "symbolicId", diagnosticInfo.namespaceURI, cursorBefore, stream.length, "Int32");
        cursorBefore = stream.length;
      }
      if (encodingMask & DiagnosticInfo_EncodingByte.Locale) {
        diagnosticInfo.locale = (0, node_opcua_basic_types_1.decodeInt32)(stream);
        tracer.trace("member", "locale", diagnosticInfo.locale, cursorBefore, stream.length, "Int32");
        cursorBefore = stream.length;
      }
      if (encodingMask & DiagnosticInfo_EncodingByte.LocalizedText) {
        diagnosticInfo.localizedText = (0, node_opcua_basic_types_1.decodeInt32)(stream);
        tracer.trace("member", "localizedText", diagnosticInfo.localizedText, cursorBefore, stream.length, "Int32");
        cursorBefore = stream.length;
      }
      if (encodingMask & DiagnosticInfo_EncodingByte.AdditionalInfo) {
        diagnosticInfo.additionalInfo = (0, node_opcua_basic_types_1.decodeString)(stream);
        tracer.trace("member", "additionalInfo", diagnosticInfo.additionalInfo, cursorBefore, stream.length, "String");
        cursorBefore = stream.length;
      }
      if (encodingMask & DiagnosticInfo_EncodingByte.InnerStatusCode) {
        diagnosticInfo.innerStatusCode = (0, node_opcua_basic_types_1.decodeStatusCode)(stream);
        tracer.trace("member", "innerStatusCode", diagnosticInfo.innerStatusCode, cursorBefore, stream.length, "StatusCode");
        cursorBefore = stream.length;
      }
      if (encodingMask & DiagnosticInfo_EncodingByte.InnerDiagnosticInfo) {
        diagnosticInfo.innerDiagnosticInfo = new DiagnosticInfo({});
        if (diagnosticInfo.innerDiagnosticInfo) {
          diagnosticInfo.innerDiagnosticInfo.decodeDebug(stream, options);
        }
        tracer.trace("member", "innerDiagnosticInfo", diagnosticInfo.innerDiagnosticInfo, cursorBefore, stream.length, "DiagnosticInfo");
      }
      tracer.trace("end", options.name, stream.length, stream.length);
    }
    function decode_DiagnosticInfo(diagnosticInfo, stream) {
      const encodingMask = (0, node_opcua_basic_types_1.decodeByte)(stream);
      if (encodingMask & DiagnosticInfo_EncodingByte.SymbolicId) {
        diagnosticInfo.symbolicId = (0, node_opcua_basic_types_1.decodeInt32)(stream);
      }
      if (encodingMask & DiagnosticInfo_EncodingByte.NamespaceURI) {
        diagnosticInfo.namespaceURI = (0, node_opcua_basic_types_1.decodeInt32)(stream);
      }
      if (encodingMask & DiagnosticInfo_EncodingByte.Locale) {
        diagnosticInfo.locale = (0, node_opcua_basic_types_1.decodeInt32)(stream);
      }
      if (encodingMask & DiagnosticInfo_EncodingByte.LocalizedText) {
        diagnosticInfo.localizedText = (0, node_opcua_basic_types_1.decodeInt32)(stream);
      }
      if (encodingMask & DiagnosticInfo_EncodingByte.AdditionalInfo) {
        diagnosticInfo.additionalInfo = (0, node_opcua_basic_types_1.decodeString)(stream);
      }
      if (encodingMask & DiagnosticInfo_EncodingByte.InnerStatusCode) {
        diagnosticInfo.innerStatusCode = (0, node_opcua_basic_types_1.decodeStatusCode)(stream);
      }
      if (encodingMask & DiagnosticInfo_EncodingByte.InnerDiagnosticInfo) {
        diagnosticInfo.innerDiagnosticInfo = new DiagnosticInfo({});
        if (diagnosticInfo.innerDiagnosticInfo) {
          diagnosticInfo.innerDiagnosticInfo.decode(stream);
        }
      }
    }
    var emptyDiagnosticInfo = new DiagnosticInfo({});
    function encodeDiagnosticInfo(value, stream) {
      if (value === null) {
        emptyDiagnosticInfo.encode(stream);
      } else {
        value.encode(stream);
      }
    }
    exports2.encodeDiagnosticInfo = encodeDiagnosticInfo;
    function decodeDiagnosticInfo(stream, _value) {
      const value = _value || new DiagnosticInfo();
      value.decode(stream);
      return value;
    }
    exports2.decodeDiagnosticInfo = decodeDiagnosticInfo;
    (0, node_opcua_factory_1.registerSpecialVariantEncoder)(DiagnosticInfo);
  }
});

// node_modules/node-opcua-data-model/dist/nodeclass.js
var require_nodeclass = __commonJS({
  "node_modules/node-opcua-data-model/dist/nodeclass.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.schemaEnumNodeClass = exports2.NodeClass = void 0;
    var node_opcua_factory_1 = require_dist26();
    var NodeClass;
    (function(NodeClass2) {
      NodeClass2[NodeClass2["Unspecified"] = 0] = "Unspecified";
      NodeClass2[NodeClass2["Object"] = 1] = "Object";
      NodeClass2[NodeClass2["Variable"] = 2] = "Variable";
      NodeClass2[NodeClass2["Method"] = 4] = "Method";
      NodeClass2[NodeClass2["ObjectType"] = 8] = "ObjectType";
      NodeClass2[NodeClass2["VariableType"] = 16] = "VariableType";
      NodeClass2[NodeClass2["ReferenceType"] = 32] = "ReferenceType";
      NodeClass2[NodeClass2["DataType"] = 64] = "DataType";
      NodeClass2[NodeClass2["View"] = 128] = "View";
    })(NodeClass || (exports2.NodeClass = NodeClass = {}));
    exports2.schemaEnumNodeClass = {
      name: "NodeClass",
      documentation: "A mask specifying the class of the node.",
      enumValues: NodeClass
    };
    (0, node_opcua_factory_1.registerEnumeration)(exports2.schemaEnumNodeClass);
  }
});

// node_modules/node-opcua-data-model/dist/attributeIds.js
var require_attributeIds2 = __commonJS({
  "node_modules/node-opcua-data-model/dist/attributeIds.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AttributeIds = exports2.attributeNameById = exports2.isValidAttributeId = void 0;
    var node_opcua_basic_types_1 = require_dist23();
    Object.defineProperty(exports2, "isValidAttributeId", { enumerable: true, get: function() {
      return node_opcua_basic_types_1.isValidAttributeId;
    } });
    Object.defineProperty(exports2, "attributeNameById", { enumerable: true, get: function() {
      return node_opcua_basic_types_1.attributeNameById;
    } });
    Object.defineProperty(exports2, "AttributeIds", { enumerable: true, get: function() {
      return node_opcua_basic_types_1.AttributeIds;
    } });
  }
});

// node_modules/node-opcua-data-model/dist/node_class_mask.js
var require_node_class_mask = __commonJS({
  "node_modules/node-opcua-data-model/dist/node_class_mask.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.makeNodeClassMask = exports2.NodeClassMask = void 0;
    var NodeClassMask;
    (function(NodeClassMask2) {
      NodeClassMask2[NodeClassMask2["Object"] = 1] = "Object";
      NodeClassMask2[NodeClassMask2["Variable"] = 2] = "Variable";
      NodeClassMask2[NodeClassMask2["Method"] = 4] = "Method";
      NodeClassMask2[NodeClassMask2["ObjectType"] = 8] = "ObjectType";
      NodeClassMask2[NodeClassMask2["VariableType"] = 16] = "VariableType";
      NodeClassMask2[NodeClassMask2["ReferenceType"] = 32] = "ReferenceType";
      NodeClassMask2[NodeClassMask2["DataType"] = 64] = "DataType";
      NodeClassMask2[NodeClassMask2["View"] = 128] = "View";
    })(NodeClassMask || (exports2.NodeClassMask = NodeClassMask = {}));
    function makeFlagFromString(type, str) {
      const flags = str.split(" | ");
      let result2 = 0;
      for (const flag of flags) {
        result2 |= type[flag];
      }
      return result2;
    }
    function makeNodeClassMask(str) {
      const classMask = makeFlagFromString(NodeClassMask, str);
      if (!classMask) {
        throw new Error(" cannot find class mask for " + str);
      }
      return classMask;
    }
    exports2.makeNodeClassMask = makeNodeClassMask;
  }
});

// node_modules/node-opcua-data-model/dist/result_mask.js
var require_result_mask = __commonJS({
  "node_modules/node-opcua-data-model/dist/result_mask.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.makeResultMask = exports2._enumerationResultMask = exports2.schemaResultMask = exports2.ResultMask = void 0;
    var node_opcua_factory_1 = require_dist26();
    var ResultMask;
    (function(ResultMask2) {
      ResultMask2[ResultMask2["ReferenceType"] = 1] = "ReferenceType";
      ResultMask2[ResultMask2["IsForward"] = 2] = "IsForward";
      ResultMask2[ResultMask2["NodeClass"] = 4] = "NodeClass";
      ResultMask2[ResultMask2["BrowseName"] = 8] = "BrowseName";
      ResultMask2[ResultMask2["DisplayName"] = 16] = "DisplayName";
      ResultMask2[ResultMask2["TypeDefinition"] = 32] = "TypeDefinition";
    })(ResultMask || (exports2.ResultMask = ResultMask = {}));
    exports2.schemaResultMask = {
      name: "ResultMask",
      enumValues: ResultMask
    };
    exports2._enumerationResultMask = (0, node_opcua_factory_1.registerEnumeration)(exports2.schemaResultMask);
    function makeResultMask(str) {
      const flags = str.split(" | ");
      let r = 0;
      for (const flag of flags) {
        r |= ResultMask[flag];
      }
      return r;
    }
    exports2.makeResultMask = makeResultMask;
  }
});

// node_modules/node-opcua-data-model/dist/BrowseDirection.js
var require_BrowseDirection = __commonJS({
  "node_modules/node-opcua-data-model/dist/BrowseDirection.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2._enumerationBrowseDirection = exports2.decodeBrowseDirection = exports2.encodeBrowseDirection = exports2.schemaBrowseDirection = exports2.BrowseDirection = void 0;
    var node_opcua_factory_1 = require_dist26();
    var BrowseDirection;
    (function(BrowseDirection2) {
      BrowseDirection2[BrowseDirection2["Forward"] = 0] = "Forward";
      BrowseDirection2[BrowseDirection2["Inverse"] = 1] = "Inverse";
      BrowseDirection2[BrowseDirection2["Both"] = 2] = "Both";
      BrowseDirection2[BrowseDirection2["Invalid"] = 3] = "Invalid";
    })(BrowseDirection || (exports2.BrowseDirection = BrowseDirection = {}));
    exports2.schemaBrowseDirection = {
      name: "BrowseDirection",
      enumValues: BrowseDirection
      // decode: (stream: BinaryStream) => {
      //
      //     const value = stream.readInteger();
      //     if (value < 0 || value > 2) {
      //         return BrowseDirection.Invalid;
      //     }
      //     return BrowseDirection[value];
      // }
    };
    function encodeBrowseDirection(value, stream) {
      stream.writeUInt32(value);
    }
    exports2.encodeBrowseDirection = encodeBrowseDirection;
    function decodeBrowseDirection(stream, _value) {
      let value = stream.readUInt32();
      if (value < 0 || value > 3 || Number.isNaN(value)) {
        value = BrowseDirection.Invalid;
      }
      return value;
    }
    exports2.decodeBrowseDirection = decodeBrowseDirection;
    exports2._enumerationBrowseDirection = (0, node_opcua_factory_1.registerEnumeration)(exports2.schemaBrowseDirection);
  }
});

// node_modules/node-opcua-data-model/dist/data_encoding.js
var require_data_encoding = __commonJS({
  "node_modules/node-opcua-data-model/dist/data_encoding.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isValidDataEncoding = exports2.isDataEncoding = void 0;
    function isDataEncoding(dataEncoding) {
      return !!dataEncoding && typeof dataEncoding === "object" && typeof dataEncoding.name === "string";
    }
    exports2.isDataEncoding = isDataEncoding;
    var validEncoding = ["DefaultBinary", "DefaultXml", "DefaultJson"];
    function isValidDataEncoding(dataEncoding) {
      if (!dataEncoding) {
        return true;
      }
      if (Object.prototype.hasOwnProperty.call(dataEncoding, "name")) {
        dataEncoding = dataEncoding.name;
      }
      if (!dataEncoding) {
        return true;
      }
      return validEncoding.indexOf(dataEncoding) !== -1;
    }
    exports2.isValidDataEncoding = isValidDataEncoding;
  }
});

// node_modules/node-opcua-data-model/dist/permission_flag.js
var require_permission_flag = __commonJS({
  "node_modules/node-opcua-data-model/dist/permission_flag.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.permissionFlagToString = exports2.makePermissionFlag = exports2.allPermissions = exports2.PermissionFlag = void 0;
    var _make_flag_1 = require_make_flag();
    var PermissionFlag;
    (function(PermissionFlag2) {
      PermissionFlag2[PermissionFlag2["None"] = 0] = "None";
      PermissionFlag2[PermissionFlag2["Browse"] = 1] = "Browse";
      PermissionFlag2[PermissionFlag2["ReadRolePermissions"] = 2] = "ReadRolePermissions";
      PermissionFlag2[PermissionFlag2["WriteAttribute"] = 4] = "WriteAttribute";
      PermissionFlag2[PermissionFlag2["WriteRolePermissions"] = 8] = "WriteRolePermissions";
      PermissionFlag2[PermissionFlag2["WriteHistorizing"] = 16] = "WriteHistorizing";
      PermissionFlag2[PermissionFlag2["Read"] = 32] = "Read";
      PermissionFlag2[PermissionFlag2["Write"] = 64] = "Write";
      PermissionFlag2[PermissionFlag2["ReadHistory"] = 128] = "ReadHistory";
      PermissionFlag2[PermissionFlag2["InsertHistory"] = 256] = "InsertHistory";
      PermissionFlag2[PermissionFlag2["ModifyHistory"] = 512] = "ModifyHistory";
      PermissionFlag2[PermissionFlag2["DeleteHistory"] = 1024] = "DeleteHistory";
      PermissionFlag2[PermissionFlag2["ReceiveEvents"] = 2048] = "ReceiveEvents";
      PermissionFlag2[PermissionFlag2["Call"] = 4096] = "Call";
      PermissionFlag2[PermissionFlag2["AddReference"] = 8192] = "AddReference";
      PermissionFlag2[PermissionFlag2["RemoveReference"] = 16384] = "RemoveReference";
      PermissionFlag2[PermissionFlag2["DeleteNode"] = 32768] = "DeleteNode";
      PermissionFlag2[PermissionFlag2["AddNode"] = 65536] = "AddNode";
    })(PermissionFlag || (exports2.PermissionFlag = PermissionFlag = {}));
    exports2.allPermissions = PermissionFlag.Browse | PermissionFlag.Browse | PermissionFlag.ReadRolePermissions | PermissionFlag.WriteAttribute | PermissionFlag.WriteRolePermissions | PermissionFlag.WriteHistorizing | PermissionFlag.Read | PermissionFlag.Write | PermissionFlag.ReadHistory | PermissionFlag.InsertHistory | PermissionFlag.ModifyHistory | PermissionFlag.DeleteHistory | PermissionFlag.ReceiveEvents | PermissionFlag.Call | PermissionFlag.AddReference | PermissionFlag.RemoveReference | PermissionFlag.DeleteNode | PermissionFlag.AddNode;
    function makePermissionFlag(str) {
      if (str === "All") {
        return exports2.allPermissions;
      }
      return (0, _make_flag_1._make_flag)(str, PermissionFlag.None, PermissionFlag);
    }
    exports2.makePermissionFlag = makePermissionFlag;
    function permissionFlagToString(permissionFlag) {
      const retVal = [];
      for (const [key, value] of Object.entries(PermissionFlag)) {
        const numKey = parseInt(key, 10);
        if (numKey.toString() !== key || numKey === 0) {
          continue;
        }
        if ((permissionFlag & numKey) === numKey) {
          retVal.push(value);
        }
      }
      if (retVal.length === 0) {
        retVal.push("None");
      }
      return retVal.join(" | ");
    }
    exports2.permissionFlagToString = permissionFlagToString;
  }
});

// node_modules/node-opcua-data-model/dist/index.js
var require_dist27 = __commonJS({
  "node_modules/node-opcua-data-model/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_access_level(), exports2);
    __exportStar3(require_access_level_ex(), exports2);
    __exportStar3(require_access_restrictions(), exports2);
    __exportStar3(require_localized_text(), exports2);
    __exportStar3(require_qualified_name(), exports2);
    __exportStar3(require_diagnostic_info(), exports2);
    __exportStar3(require_nodeclass(), exports2);
    __exportStar3(require_attributeIds2(), exports2);
    __exportStar3(require_node_class_mask(), exports2);
    __exportStar3(require_result_mask(), exports2);
    __exportStar3(require_BrowseDirection(), exports2);
    __exportStar3(require_data_encoding(), exports2);
    __exportStar3(require_permission_flag(), exports2);
  }
});

// node_modules/node-opcua-variant/dist/DataType_enum.js
var require_DataType_enum = __commonJS({
  "node_modules/node-opcua-variant/dist/DataType_enum.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2._enumerationDataType = exports2.DataType = void 0;
    var node_opcua_factory_1 = require_dist26();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_basic_types_2 = require_dist23();
    Object.defineProperty(exports2, "DataType", { enumerable: true, get: function() {
      return node_opcua_basic_types_2.DataType;
    } });
    var schemaDataType = {
      name: "DataType",
      enumValues: node_opcua_basic_types_1.DataType
    };
    exports2._enumerationDataType = (0, node_opcua_factory_1.registerEnumeration)(schemaDataType);
  }
});

// node_modules/node-opcua-variant/dist/VariantArrayType_enum.js
var require_VariantArrayType_enum = __commonJS({
  "node_modules/node-opcua-variant/dist/VariantArrayType_enum.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2._enumerationVariantArrayType = exports2.VariantArrayType = void 0;
    var node_opcua_factory_1 = require_dist26();
    var VariantArrayType;
    (function(VariantArrayType2) {
      VariantArrayType2[VariantArrayType2["Scalar"] = 0] = "Scalar";
      VariantArrayType2[VariantArrayType2["Array"] = 1] = "Array";
      VariantArrayType2[VariantArrayType2["Matrix"] = 2] = "Matrix";
    })(VariantArrayType || (exports2.VariantArrayType = VariantArrayType = {}));
    var schemaVariantArrayType = {
      enumValues: VariantArrayType,
      name: "VariantArrayType"
    };
    exports2._enumerationVariantArrayType = (0, node_opcua_factory_1.registerEnumeration)(schemaVariantArrayType);
  }
});

// node_modules/node-opcua-variant/dist/variant.js
var require_variant = __commonJS({
  "node_modules/node-opcua-variant/dist/variant.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.sameVariant = exports2.buildVariantArray = exports2.isValidVariant = exports2.coerceVariantType = exports2.decodeVariant = exports2.encodeVariant = exports2.VARIANT_TYPE_MASK = exports2.VARIANT_ARRAY_DIMENSIONS_MASK = exports2.VARIANT_ARRAY_MASK = exports2.Variant = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_factory_1 = require_dist26();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_debug_1 = require_dist24();
    var DataType_enum_1 = require_DataType_enum();
    var VariantArrayType_enum_1 = require_VariantArrayType_enum();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var schemaVariant = (0, node_opcua_factory_1.buildStructuredType)({
      baseType: "BaseUAObject",
      fields: [
        {
          defaultValue: DataType_enum_1.DataType.Null,
          documentation: "the variant type.",
          fieldType: "DataType",
          name: "dataType"
        },
        {
          defaultValue: VariantArrayType_enum_1.VariantArrayType.Scalar,
          fieldType: "VariantArrayType",
          name: "arrayType"
        },
        {
          defaultValue: null,
          fieldType: "Any",
          name: "value"
        },
        {
          defaultValue: null,
          documentation: "the matrix dimensions",
          fieldType: "UInt32",
          isArray: true,
          name: "dimensions"
        }
      ],
      name: "Variant"
    });
    function _coerceVariant(variantLike) {
      const value = variantLike instanceof Variant ? variantLike : new Variant(variantLike);
      return value;
    }
    var Variant = class _Variant extends node_opcua_factory_1.BaseUAObject {
      constructor(options) {
        super();
        if (options === null) {
          this.dataType = DataType_enum_1.DataType.Null;
          this.arrayType = VariantArrayType_enum_1.VariantArrayType.Scalar;
          this.value = null;
          this.dimensions = null;
          return;
        }
        const options2 = constructHook(options || {});
        this.dataType = DataType_enum_1.DataType.Null;
        this.arrayType = VariantArrayType_enum_1.VariantArrayType.Scalar;
        const schema = schemaVariant;
        this.dataType = options2.dataType;
        this.arrayType = options2.arrayType;
        this.value = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options2.value);
        this.dimensions = options2.dimensions || null;
        if (this.dataType === DataType_enum_1.DataType.ExtensionObject) {
          if (this.arrayType === VariantArrayType_enum_1.VariantArrayType.Scalar) {
            if (this.value && !(this.value instanceof node_opcua_factory_1.BaseUAObject)) {
              throw new Error(`A variant with DataType.ExtensionObject must have a ExtensionObject value.
Make sure that you specify a valid ExtensionObject to the value options in the Variant Constructor`);
            }
          } else {
            if (this.value) {
              for (const e of this.value) {
                if (e && !(e instanceof node_opcua_factory_1.BaseUAObject)) {
                  throw new Error("A variant with DataType.ExtensionObject must have a ExtensionObject value\nMake sure that you specify a valid ExtensionObject for all element of the value array passed to the  Variant Constructor`");
                }
              }
            }
          }
        }
      }
      encode(stream) {
        encodeVariant(this, stream);
      }
      decode(stream) {
        internalDecodeVariant(this, stream);
      }
      decodeDebug(stream, options) {
        decodeDebugVariant(this, stream, options);
      }
      toString() {
        return variantToString(this);
      }
      isValid() {
        return isValidVariant(this.arrayType, this.dataType, this.value, this.dimensions);
      }
      clone() {
        return new _Variant(this);
      }
    };
    exports2.Variant = Variant;
    Variant.maxTypedArrayLength = 16 * 1024 * 1024;
    Variant.maxArrayLength = 1 * 1024 * 1024;
    Variant.schema = schemaVariant;
    Variant.coerce = _coerceVariant;
    Variant.computer_default_value = () => new Variant({ dataType: DataType_enum_1.DataType.Null });
    Variant.prototype.schema = schemaVariant;
    function variantToString(self2, options) {
      function toString(value) {
        switch (self2.dataType) {
          case DataType_enum_1.DataType.ByteString:
            return value ? "0x" + value.toString("hex") : "<null>";
          case DataType_enum_1.DataType.NodeId:
            return value instanceof node_opcua_nodeid_1.NodeId ? value.displayText() : value ? value.toString(options) : "";
          case DataType_enum_1.DataType.Boolean:
            return value.toString();
          case DataType_enum_1.DataType.DateTime:
            return value ? value.toISOString ? value.toISOString() : value.toString() : "<null>";
          default:
            return value ? value.toString(options) : "0";
        }
      }
      function f2(value) {
        if (value === void 0 || value === null && typeof value === "object") {
          return "<null>";
        }
        return toString(value);
      }
      let data = VariantArrayType_enum_1.VariantArrayType[self2.arrayType];
      if (self2.dimensions && self2.dimensions.length >= 0) {
        data += "[ " + self2.dimensions.join(",") + " ]";
      }
      data += "<" + DataType_enum_1.DataType[self2.dataType] + ">";
      if (self2.arrayType === VariantArrayType_enum_1.VariantArrayType.Scalar) {
        data += ", value: " + f2(self2.value);
      } else if (self2.arrayType === VariantArrayType_enum_1.VariantArrayType.Array || self2.arrayType === VariantArrayType_enum_1.VariantArrayType.Matrix) {
        if (!self2.value) {
          data += ", null";
        } else {
          const a = [];
          (0, node_opcua_assert_1.assert)(Array.isArray(self2.value) || self2.value.buffer instanceof ArrayBuffer);
          for (let i = 0; i < Math.min(10, self2.value.length); i++) {
            a[i] = self2.value[i];
          }
          if (self2.value.length > 10) {
            a.push("...");
          }
          data += ", l= " + self2.value.length + ", value=[" + a.map(f2).join(",") + "]";
        }
      }
      return "Variant(" + data + ")";
    }
    exports2.VARIANT_ARRAY_MASK = 128;
    exports2.VARIANT_ARRAY_DIMENSIONS_MASK = 64;
    exports2.VARIANT_TYPE_MASK = 63;
    var nullVariant = new Variant({ dataType: DataType_enum_1.DataType.Null });
    function encodeVariant(variant, stream) {
      if (!variant) {
        variant = nullVariant;
      }
      let encodingByte = variant.dataType;
      if (variant.arrayType === VariantArrayType_enum_1.VariantArrayType.Array || variant.arrayType === VariantArrayType_enum_1.VariantArrayType.Matrix) {
        encodingByte |= exports2.VARIANT_ARRAY_MASK;
      }
      if (variant.dimensions && variant.arrayType === VariantArrayType_enum_1.VariantArrayType.Matrix) {
        (0, node_opcua_assert_1.assert)(variant.dimensions.length >= 0);
        encodingByte |= exports2.VARIANT_ARRAY_DIMENSIONS_MASK;
      }
      (0, node_opcua_basic_types_1.encodeUInt8)(encodingByte, stream);
      if (variant.arrayType === VariantArrayType_enum_1.VariantArrayType.Array || variant.arrayType === VariantArrayType_enum_1.VariantArrayType.Matrix) {
        encodeVariantArray(variant.dataType, stream, variant.value);
      } else {
        const encode = get_encoder(variant.dataType || DataType_enum_1.DataType.Null);
        encode(variant.value, stream);
      }
      if ((encodingByte & exports2.VARIANT_ARRAY_DIMENSIONS_MASK) === exports2.VARIANT_ARRAY_DIMENSIONS_MASK && variant.dimensions) {
        encodeDimension(variant.dimensions, stream);
      }
    }
    exports2.encodeVariant = encodeVariant;
    function decodeDebugVariant(self2, stream, options) {
      const tracer = options.tracer;
      const encodingByte = (0, node_opcua_basic_types_1.decodeUInt8)(stream);
      const isArray = (encodingByte & exports2.VARIANT_ARRAY_MASK) === exports2.VARIANT_ARRAY_MASK;
      const hasDimension = (encodingByte & exports2.VARIANT_ARRAY_DIMENSIONS_MASK) === exports2.VARIANT_ARRAY_DIMENSIONS_MASK;
      self2.dataType = encodingByte & exports2.VARIANT_TYPE_MASK;
      tracer.dump("dataType:  ", self2.dataType);
      tracer.dump("isArray:   ", isArray ? "true" : "false");
      tracer.dump("dimension: ", hasDimension);
      const decode = (0, node_opcua_factory_1.findBuiltInType)(DataType_enum_1.DataType[self2.dataType]).decode;
      if (!decode) {
        throw new Error("Variant.decode : cannot find decoder for type " + DataType_enum_1.DataType[self2.dataType]);
      }
      const cursorBefore = stream.length;
      if (isArray) {
        self2.arrayType = hasDimension ? VariantArrayType_enum_1.VariantArrayType.Matrix : VariantArrayType_enum_1.VariantArrayType.Array;
        _decodeVariantArrayDebug(stream, decode, tracer, self2.dataType);
      } else {
        self2.arrayType = VariantArrayType_enum_1.VariantArrayType.Scalar;
        self2.value = decode(stream);
        tracer.trace("member", "Variant", self2.value, cursorBefore, stream.length, DataType_enum_1.DataType[self2.dataType]);
      }
      if (hasDimension) {
        self2.dimensions = decodeDimension(stream);
        const verification = calculate_product(self2.dimensions);
      }
    }
    function internalDecodeVariant(self2, stream) {
      const encodingByte = (0, node_opcua_basic_types_1.decodeUInt8)(stream);
      const isArray = (encodingByte & exports2.VARIANT_ARRAY_MASK) === exports2.VARIANT_ARRAY_MASK;
      const hasDimension = (encodingByte & exports2.VARIANT_ARRAY_DIMENSIONS_MASK) === exports2.VARIANT_ARRAY_DIMENSIONS_MASK;
      self2.dataType = encodingByte & exports2.VARIANT_TYPE_MASK;
      if (isArray) {
        self2.arrayType = hasDimension ? VariantArrayType_enum_1.VariantArrayType.Matrix : VariantArrayType_enum_1.VariantArrayType.Array;
        self2.value = decodeVariantArray(self2.dataType, stream);
      } else {
        self2.arrayType = VariantArrayType_enum_1.VariantArrayType.Scalar;
        const decode = get_decoder(self2.dataType);
        self2.value = decode(stream);
      }
      if (hasDimension) {
        self2.dimensions = decodeDimension(stream);
        const verification = calculate_product(self2.dimensions);
        if (verification !== self2.value.length) {
          throw new Error("internalDecodeVariant: BadDecodingError: inconsistent matrix ");
        }
      }
    }
    function decodeVariant(stream, value) {
      value = value || new Variant(null);
      value.decode(stream);
      return value;
    }
    exports2.decodeVariant = decodeVariant;
    function constructHook(options) {
      let isArrayTypeUnspecified = options.arrayType === void 0;
      if (options instanceof Variant) {
        const opts = {
          arrayType: options.arrayType,
          dataType: options.dataType,
          dimensions: options.dimensions,
          value: options.value
        };
        if (opts.dataType === DataType_enum_1.DataType.ExtensionObject) {
          if (opts.arrayType === VariantArrayType_enum_1.VariantArrayType.Scalar) {
            if (opts.value && opts.value.constructor) {
              opts.value = new opts.value.constructor(opts.value);
            }
          } else {
            if (opts.value) {
              opts.value = opts.value.map((e) => {
                if (e && e.constructor) {
                  return new e.constructor(e);
                }
                return null;
              });
            }
          }
        } else if (opts.arrayType !== VariantArrayType_enum_1.VariantArrayType.Scalar) {
          opts.value = coerceVariantArray(opts.dataType, options.value);
        }
        return opts;
      }
      options.dataType = options.dataType || DataType_enum_1.DataType.Null;
      if (typeof options.dataType === "string") {
        const d2 = (0, node_opcua_factory_1.findBuiltInType)(options.dataType);
        if (!d2) {
          throw new Error("Cannot find Built-In data type or any DataType resolving to " + options.dataType);
        }
        options.dataType = DataType_enum_1.DataType[d2.name];
      }
      if (typeof options.arrayType === "string") {
        const at = VariantArrayType_enum_1.VariantArrayType[options.arrayType];
        if (at === void 0) {
          throw new Error("ArrayType: invalid " + options.arrayType);
        }
        options.arrayType = at;
      }
      if (isArrayTypeUnspecified && Array.isArray(options.value)) {
        if (options.dataType === DataType_enum_1.DataType.UInt64 || options.dataType === DataType_enum_1.DataType.Int64) {
          throw new Error("Variant#constructor : when using UInt64 ou Int64 arrayType must be specified , as automatic detection cannot be made");
        } else {
          options.arrayType = VariantArrayType_enum_1.VariantArrayType.Array;
          isArrayTypeUnspecified = false;
        }
      }
      if (options.arrayType !== VariantArrayType_enum_1.VariantArrayType.Scalar && !isArrayTypeUnspecified) {
        (0, node_opcua_assert_1.assert)(options.arrayType === VariantArrayType_enum_1.VariantArrayType.Array || options.arrayType === VariantArrayType_enum_1.VariantArrayType.Matrix);
        if (options.arrayType === VariantArrayType_enum_1.VariantArrayType.Array) {
          const value1 = coerceVariantArray(options.dataType, options.value);
          (0, node_opcua_assert_1.assert)(value1 === null || value1 !== options.value);
          options.value = value1;
        } else {
          (0, node_opcua_assert_1.assert)(options.arrayType === VariantArrayType_enum_1.VariantArrayType.Matrix);
          options.value = options.value || [];
          options.value = coerceVariantArray(options.dataType, options.value);
          if (!options.dimensions) {
            throw new Error("Matrix Variant : missing dimensions");
          }
          if (options.value.length !== calculate_product(options.dimensions)) {
            throw new Error("Matrix Variant : invalid value size = options.value.length " + options.value.length + "!=" + calculate_product(options.dimensions) + " => " + JSON.stringify(options.dimensions));
          }
        }
      } else {
        (0, node_opcua_assert_1.assert)(options.arrayType === VariantArrayType_enum_1.VariantArrayType.Scalar || options.arrayType === void 0);
        options.arrayType = VariantArrayType_enum_1.VariantArrayType.Scalar;
        const tmp = options.value;
        options.value = coerceVariantType(options.dataType, options.value);
        if (!isValidVariant(options.arrayType, options.dataType, options.value, null)) {
          throw new Error("Invalid variant arrayType: " + VariantArrayType_enum_1.VariantArrayType[options.arrayType] + "  dataType: " + DataType_enum_1.DataType[options.dataType] + " value:" + options.value + " (javascript type = " + typeof options.value + " )");
        }
      }
      if (options.dimensions) {
        (0, node_opcua_assert_1.assert)(options.arrayType === VariantArrayType_enum_1.VariantArrayType.Matrix, "dimension can only provided if variant is a matrix");
      }
      return options;
    }
    function calculate_product(array) {
      if (!array || array.length === 0) {
        return 0;
      }
      return array.reduce((n, p3) => n * p3, 1);
    }
    function get_encoder(dataType) {
      const dataTypeAsString = typeof dataType === "string" ? dataType : DataType_enum_1.DataType[dataType];
      if (!dataTypeAsString) {
        throw new Error("invalid dataType " + dataType);
      }
      const encode = (0, node_opcua_factory_1.findBuiltInType)(dataTypeAsString).encode;
      if (!encode) {
        throw new Error("Cannot find encode function for dataType " + dataTypeAsString);
      }
      return encode;
    }
    function get_decoder(dataType) {
      const dataTypeAsString = DataType_enum_1.DataType[dataType];
      const decode = (0, node_opcua_factory_1.findBuiltInType)(dataTypeAsString).decode;
      if (!decode) {
        throw new Error("Variant.decode : cannot find decoder for type " + dataTypeAsString);
      }
      return decode;
    }
    var displayWarning = true;
    function convertTo(dataType, arrayTypeConstructor, value) {
      if (value === void 0 || value === null) {
        return null;
      }
      if (arrayTypeConstructor && value instanceof arrayTypeConstructor) {
        const newArray = new value.constructor(value.length);
        if (newArray instanceof Buffer) {
          value.copy(newArray);
        } else {
          newArray.set(value);
        }
        return newArray;
      }
      const coerceFunc = coerceVariantType.bind(null, dataType);
      const n = value.length;
      const newArr = arrayTypeConstructor ? new arrayTypeConstructor(n) : new Array(n);
      for (let i = 0; i < n; i++) {
        newArr[i] = coerceFunc(value[i]);
      }
      if (arrayTypeConstructor && displayWarning && n > 10) {
        warningLog("Warning ! an array containing  " + DataType_enum_1.DataType[dataType] + " elements has been provided as a generic array. ");
        warningLog("          This is inefficient as every array value will have to be coerced and verified against the expected type");
        warningLog("          It is highly recommended that you use a  typed array ", arrayTypeConstructor.constructor.name, " instead");
      }
      return newArr;
    }
    var typedArrayHelpers = {};
    function _getHelper(dataType) {
      return typedArrayHelpers[DataType_enum_1.DataType[dataType]];
    }
    function coerceVariantArray(dataType, value) {
      const helper = _getHelper(dataType);
      if (helper) {
        return helper.coerce(value);
      } else {
        return convertTo(dataType, null, value);
      }
    }
    function encodeTypedArray(arrayTypeConstructor, stream, value) {
      (0, node_opcua_assert_1.assert)(value instanceof arrayTypeConstructor);
      (0, node_opcua_assert_1.assert)(value.buffer instanceof ArrayBuffer);
      (0, node_opcua_basic_types_1.encodeUInt32)(value.length, stream);
      stream.writeArrayBuffer(value.buffer, value.byteOffset, value.byteLength);
    }
    function encodeGeneralArray(dataType, stream, value) {
      if (!value) {
        (0, node_opcua_assert_1.assert)(value === null);
        (0, node_opcua_basic_types_1.encodeUInt32)(4294967295, stream);
        return;
      }
      (0, node_opcua_basic_types_1.encodeUInt32)(value.length, stream);
      const encode = get_encoder(dataType);
      for (const e of value) {
        encode(e, stream);
      }
    }
    function encodeVariantArray(dataType, stream, value) {
      if (value && value.buffer) {
        return _getHelper(dataType).encode(stream, value);
      }
      return encodeGeneralArray(dataType, stream, value);
    }
    function decodeTypedArray(arrayTypeConstructor, stream) {
      const length = (0, node_opcua_basic_types_1.decodeUInt32)(stream);
      if (length === 4294967295) {
        return null;
      }
      if (length > Variant.maxTypedArrayLength) {
        throw new Error(`maxTypedArrayLength(${Variant.maxTypedArrayLength}) has been exceeded in Variant.decodeArray (typed Array) len=${length}`);
      }
      const byteLength = length * arrayTypeConstructor.BYTES_PER_ELEMENT;
      const arr = stream.readArrayBuffer(byteLength);
      const value = new arrayTypeConstructor(arr.buffer);
      (0, node_opcua_assert_1.assert)(value.length === length);
      return value;
    }
    function decodeGeneralArray(dataType, stream) {
      const length = (0, node_opcua_basic_types_1.decodeUInt32)(stream);
      if (length === 4294967295) {
        return null;
      }
      if (length > Variant.maxArrayLength) {
        throw new Error(`maxArrayLength(${Variant.maxArrayLength}) has been exceeded in Variant.decodeArray len=${length}`);
      }
      const decode = get_decoder(dataType);
      const arr = [];
      for (let i = 0; i < length; i++) {
        arr.push(decode(stream));
      }
      return arr;
    }
    function decodeVariantArray(dataType, stream) {
      const helper = _getHelper(dataType);
      if (helper) {
        return helper.decode(stream);
      } else {
        return decodeGeneralArray(dataType, stream);
      }
    }
    function _declareTypeArrayHelper(dataType, typedArrayConstructor) {
      typedArrayHelpers[DataType_enum_1.DataType[dataType]] = {
        coerce: convertTo.bind(null, dataType, typedArrayConstructor),
        decode: decodeTypedArray.bind(null, typedArrayConstructor),
        encode: encodeTypedArray.bind(null, typedArrayConstructor)
      };
    }
    _declareTypeArrayHelper(DataType_enum_1.DataType.Float, Float32Array);
    _declareTypeArrayHelper(DataType_enum_1.DataType.Double, Float64Array);
    _declareTypeArrayHelper(DataType_enum_1.DataType.SByte, Int8Array);
    _declareTypeArrayHelper(DataType_enum_1.DataType.Byte, Uint8Array);
    _declareTypeArrayHelper(DataType_enum_1.DataType.Int16, Int16Array);
    _declareTypeArrayHelper(DataType_enum_1.DataType.Int32, Int32Array);
    _declareTypeArrayHelper(DataType_enum_1.DataType.UInt16, Uint16Array);
    _declareTypeArrayHelper(DataType_enum_1.DataType.UInt32, Uint32Array);
    function _decodeVariantArrayDebug(stream, decode, tracer, dataType) {
      let cursorBefore = stream.length;
      const length = (0, node_opcua_basic_types_1.decodeUInt32)(stream);
      let i;
      let element;
      tracer.trace("start_array", "Variant", -1, cursorBefore, stream.length);
      if (length === 4294967295) {
        tracer.trace("end_array", "Variant", stream.length);
        return;
      }
      const n1 = Math.min(10, length);
      for (i = 0; i < n1; i++) {
        tracer.trace("start_element", "", i);
        cursorBefore = stream.length;
        element = decode(stream);
        tracer.trace("member", "Variant", element, cursorBefore, stream.length, DataType_enum_1.DataType[dataType]);
        tracer.trace("end_element", "", i);
      }
      if (length >= n1) {
        for (i = n1; i < length; i++) {
          decode(stream);
        }
        tracer.trace("start_element", "", n1);
        tracer.trace("member", "Variant", "...", cursorBefore, stream.length, DataType_enum_1.DataType[dataType]);
        tracer.trace("end_element", "", n1);
      }
      tracer.trace("end_array", "Variant", stream.length);
    }
    function decodeDimension(stream) {
      return decodeGeneralArray(DataType_enum_1.DataType.UInt32, stream);
    }
    function encodeDimension(dimensions, stream) {
      return encodeGeneralArray(DataType_enum_1.DataType.UInt32, stream, dimensions);
    }
    function isEnumerationItem(value) {
      return value instanceof Object && Object.prototype.hasOwnProperty.call(value, "value") && Object.prototype.hasOwnProperty.call(value, "key") && value.constructor.name === "EnumValueType";
    }
    function coerceVariantType(dataType, value) {
      if (value === void 0) {
        value = null;
      }
      if (isEnumerationItem(value)) {
        if (dataType !== DataType_enum_1.DataType.Int32 && dataType !== DataType_enum_1.DataType.ExtensionObject) {
          throw new Error("expecting DataType.Int32 for enumeration values ; got DataType." + dataType.toString() + " instead");
        }
      }
      switch (dataType) {
        case DataType_enum_1.DataType.Null:
          value = null;
          break;
        case DataType_enum_1.DataType.LocalizedText:
          if (!value || !value.schema || value.schema !== node_opcua_data_model_1.LocalizedText.schema) {
            value = new node_opcua_data_model_1.LocalizedText(value);
          }
          break;
        case DataType_enum_1.DataType.QualifiedName:
          if (!value || !value.schema || value.schema !== node_opcua_data_model_1.QualifiedName.schema) {
            value = new node_opcua_data_model_1.QualifiedName(value);
          }
          break;
        case DataType_enum_1.DataType.Int32:
        case DataType_enum_1.DataType.Int16:
        case DataType_enum_1.DataType.UInt32:
        case DataType_enum_1.DataType.UInt16:
          (0, node_opcua_assert_1.assert)(value !== void 0);
          value = parseInt(value, 10);
          if (!isFinite(value)) {
            throw new Error("expecting a number " + value);
          }
          break;
        case DataType_enum_1.DataType.UInt64:
          value = (0, node_opcua_basic_types_1.coerceUInt64)(value);
          break;
        case DataType_enum_1.DataType.Int64:
          value = (0, node_opcua_basic_types_1.coerceInt64)(value);
          break;
        case DataType_enum_1.DataType.ExtensionObject:
          break;
        case DataType_enum_1.DataType.DateTime:
          (0, node_opcua_assert_1.assert)(value === null || value instanceof Date);
          break;
        case DataType_enum_1.DataType.String:
          (0, node_opcua_assert_1.assert)(typeof value === "string" || value === null);
          break;
        case DataType_enum_1.DataType.ByteString:
          value = typeof value === "string" ? Buffer.from(value) : value;
          if (!(value === null || value instanceof Buffer)) {
            throw new Error("ByteString should be null or a Buffer");
          }
          (0, node_opcua_assert_1.assert)(value === null || value instanceof Buffer);
          break;
        default:
          (0, node_opcua_assert_1.assert)(dataType !== void 0 && dataType !== null, "Invalid DataType");
          break;
        case DataType_enum_1.DataType.NodeId:
          break;
      }
      return value;
    }
    exports2.coerceVariantType = coerceVariantType;
    function isValidScalarVariant(dataType, value) {
      (0, node_opcua_assert_1.assert)(value === null || DataType_enum_1.DataType.Int64 === dataType || DataType_enum_1.DataType.ByteString === dataType || DataType_enum_1.DataType.UInt64 === dataType || !(value instanceof Array));
      (0, node_opcua_assert_1.assert)(value === null || !(value instanceof Int32Array));
      (0, node_opcua_assert_1.assert)(value === null || !(value instanceof Uint32Array));
      switch (dataType) {
        case DataType_enum_1.DataType.NodeId:
          return (0, node_opcua_basic_types_1.isValidNodeId)(value);
        case DataType_enum_1.DataType.String:
          return typeof value === "string" || (0, node_opcua_utils_1.isNullOrUndefined)(value);
        case DataType_enum_1.DataType.Int64:
          return (0, node_opcua_basic_types_1.isValidInt64)(value);
        case DataType_enum_1.DataType.UInt64:
          return (0, node_opcua_basic_types_1.isValidUInt64)(value);
        case DataType_enum_1.DataType.UInt32:
          return (0, node_opcua_basic_types_1.isValidUInt32)(value);
        case DataType_enum_1.DataType.Int32:
          return (0, node_opcua_basic_types_1.isValidInt32)(value);
        case DataType_enum_1.DataType.UInt16:
          return (0, node_opcua_basic_types_1.isValidUInt16)(value);
        case DataType_enum_1.DataType.Int16:
          return (0, node_opcua_basic_types_1.isValidInt16)(value);
        case DataType_enum_1.DataType.Byte:
          return (0, node_opcua_basic_types_1.isValidUInt8)(value);
        case DataType_enum_1.DataType.SByte:
          return (0, node_opcua_basic_types_1.isValidInt8)(value);
        case DataType_enum_1.DataType.Boolean:
          return (0, node_opcua_basic_types_1.isValidBoolean)(value);
        case DataType_enum_1.DataType.ByteString:
          return (0, node_opcua_basic_types_1.isValidByteString)(value);
        default:
          return true;
      }
    }
    function isValidArrayVariant(dataType, value) {
      if (value === null) {
        return true;
      }
      if (dataType === DataType_enum_1.DataType.Float && value instanceof Float32Array) {
        return true;
      } else if (dataType === DataType_enum_1.DataType.Double && value instanceof Float64Array) {
        return true;
      } else if (dataType === DataType_enum_1.DataType.SByte && value instanceof Int8Array) {
        return true;
      } else if (dataType === DataType_enum_1.DataType.Byte && (value instanceof Buffer || value instanceof Uint8Array)) {
        return true;
      } else if (dataType === DataType_enum_1.DataType.Int16 && value instanceof Int16Array) {
        return true;
      } else if (dataType === DataType_enum_1.DataType.Int32 && value instanceof Int32Array) {
        return true;
      } else if (dataType === DataType_enum_1.DataType.UInt16 && value instanceof Uint16Array) {
        return true;
      } else if (dataType === DataType_enum_1.DataType.UInt32 && value instanceof Uint32Array) {
        return true;
      }
      (0, node_opcua_assert_1.assert)(Array.isArray(value));
      for (const valueItem of value) {
        if (!isValidScalarVariant(dataType, valueItem)) {
          return false;
        }
      }
      return true;
    }
    function isValidMatrixVariant(dataType, value, dimensions) {
      if (!dimensions) {
        return false;
      }
      if (!isValidArrayVariant(dataType, value)) {
        return false;
      }
      return true;
    }
    function isValidVariant(arrayType, dataType, value, dimensions) {
      switch (arrayType) {
        case VariantArrayType_enum_1.VariantArrayType.Scalar:
          return isValidScalarVariant(dataType, value);
        case VariantArrayType_enum_1.VariantArrayType.Array:
          return isValidArrayVariant(dataType, value);
        default:
          (0, node_opcua_assert_1.assert)(arrayType === VariantArrayType_enum_1.VariantArrayType.Matrix);
          return isValidMatrixVariant(dataType, value, dimensions);
      }
    }
    exports2.isValidVariant = isValidVariant;
    function buildVariantArray(dataType, nbElements, defaultValue) {
      let value;
      switch (dataType) {
        case DataType_enum_1.DataType.Float:
          value = new Float32Array(nbElements);
          break;
        case DataType_enum_1.DataType.Double:
          value = new Float64Array(nbElements);
          break;
        case DataType_enum_1.DataType.UInt32:
          value = new Uint32Array(nbElements);
          break;
        case DataType_enum_1.DataType.Int32:
          value = new Int32Array(nbElements);
          break;
        case DataType_enum_1.DataType.UInt16:
          value = new Uint16Array(nbElements);
          break;
        case DataType_enum_1.DataType.Int16:
          value = new Int16Array(nbElements);
          break;
        case DataType_enum_1.DataType.Byte:
          value = new Uint8Array(nbElements);
          break;
        case DataType_enum_1.DataType.SByte:
          value = new Int8Array(nbElements);
          break;
        default:
          value = new Array(nbElements);
      }
      if (defaultValue !== void 0) {
        for (let i = 0; i < nbElements; i++) {
          value[i] = defaultValue;
        }
      }
      return value;
    }
    exports2.buildVariantArray = buildVariantArray;
    var oldNodeVersion = typeof process === "object" && process.versions && process.versions.node && process.versions.node.substring(0, 1) === "0";
    function __type(a) {
      return Object.prototype.toString.call(a);
    }
    function __check_same_object(o1, o2) {
      if (o1 === o2)
        return true;
      if (!o1 && o2 || !o2 && o1)
        return false;
      const t1 = __type(o1);
      const t2 = __type(o2);
      if (t1 !== t2)
        return false;
      switch (t1) {
        case "[object Array]":
          return __check_same_array(o1, o2);
        case "[object Object]": {
          if (o1.constructor?.name !== o2.constructor?.name) {
            return false;
          }
          const keys1 = Object.keys(o1);
          const keys2 = Object.keys(o2);
          if (keys1.length !== keys2.length) {
            return false;
          }
          for (const k of Object.keys(o1)) {
            if (!__check_same_object(o1[k], o2[k])) {
              return false;
            }
          }
          return true;
        }
        case "[object Float32Array]":
        case "[object Float64Array]":
        case "[object Int32Array]":
        case "[object Int16Array]":
        case "[object Int8Array]":
        case "[object Uint32Array]":
        case "[object Uint16Array]":
        case "[object Uint8Array]": {
          const b1 = Buffer.from(o1.buffer, o1.byteOffset, o1.byteLength);
          const b2 = Buffer.from(o2.buffer, o2.byteOffset, o2.byteLength);
          return b1.equals(b2);
        }
        default:
          return o1 === o2;
      }
    }
    function __check_same_array(arr1, arr2) {
      if (!arr1 || !arr2) {
        return !arr1 && !arr2;
      }
      if (arr1.length !== arr2.length) {
        return false;
      }
      if (arr1.length === 0 && 0 === arr2.length) {
        return true;
      }
      if (!oldNodeVersion && arr1.buffer) {
        (0, node_opcua_assert_1.assert)(arr2.buffer && __type(arr2.buffer) === "[object ArrayBuffer]");
        const b1 = Buffer.from(arr1.buffer, arr1.byteOffset, arr1.byteLength);
        const b2 = Buffer.from(arr2.buffer, arr2.byteOffset, arr2.byteLength);
        return b1.equals(b2);
      }
      const n = arr1.length;
      for (let i = 0; i < n; i++) {
        if (!__check_same_object(arr1[i], arr2[i])) {
          return false;
        }
      }
      return true;
    }
    function sameVariant(v1, v2) {
      if (v1 === v2) {
        return true;
      }
      if (!v1 && v2 || v1 && !v2) {
        return false;
      }
      if (v1.arrayType !== v2.arrayType) {
        return false;
      }
      if (v1.dataType !== v2.dataType) {
        return false;
      }
      if (v1.value === v2.value) {
        return true;
      }
      if (v1.arrayType === VariantArrayType_enum_1.VariantArrayType.Scalar) {
        if (v1.dataType === DataType_enum_1.DataType.ExtensionObject) {
          return __check_same_object(v1.value, v2.value);
        }
        if (Array.isArray(v1.value) && Array.isArray(v2.value)) {
          return __check_same_array(v1.value, v2.value);
        }
        if (Buffer.isBuffer(v1.value) && Buffer.isBuffer(v2.value)) {
          return v1.value.equals(v2.value);
        }
      }
      if (v1.arrayType === VariantArrayType_enum_1.VariantArrayType.Array) {
        return __check_same_array(v1.value, v2.value);
      } else if (v1.arrayType === VariantArrayType_enum_1.VariantArrayType.Matrix) {
        if (!__check_same_array(v1.dimensions, v2.dimensions)) {
          return false;
        }
        return __check_same_array(v1.value, v2.value);
      }
      return false;
    }
    exports2.sameVariant = sameVariant;
    (0, node_opcua_factory_1.registerSpecialVariantEncoder)(Variant);
    (0, node_opcua_factory_1.registerType)({
      name: "Variant",
      subType: "",
      coerce: _coerceVariant,
      encode: encodeVariant,
      decode: decodeVariant
    });
  }
});

// node_modules/node-opcua-variant/dist/adjust_variant.js
var require_adjust_variant = __commonJS({
  "node_modules/node-opcua-variant/dist/adjust_variant.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.adjustVariant = void 0;
    var node_opcua_assert_1 = __importDefault3(require_dist14());
    var DataType_enum_1 = require_DataType_enum();
    var VariantArrayType_enum_1 = require_VariantArrayType_enum();
    function adjustVariant(variant, valueRank, targetDataType) {
      if (targetDataType === DataType_enum_1.DataType.Byte && valueRank === 1) {
        if (variant.arrayType === VariantArrayType_enum_1.VariantArrayType.Scalar && variant.dataType === DataType_enum_1.DataType.ByteString) {
          variant.arrayType = VariantArrayType_enum_1.VariantArrayType.Array;
          variant.dataType = DataType_enum_1.DataType.Byte;
          (0, node_opcua_assert_1.default)(variant.dataType === DataType_enum_1.DataType.Byte);
          (0, node_opcua_assert_1.default)(!variant.value || variant.value instanceof Buffer);
        }
      }
      if (targetDataType === DataType_enum_1.DataType.ByteString && valueRank === -1) {
        if (variant.arrayType === VariantArrayType_enum_1.VariantArrayType.Array && variant.dataType === DataType_enum_1.DataType.Byte) {
          variant.arrayType = VariantArrayType_enum_1.VariantArrayType.Scalar;
          variant.dataType = DataType_enum_1.DataType.ByteString;
          (0, node_opcua_assert_1.default)(variant.dataType === DataType_enum_1.DataType.ByteString);
          (0, node_opcua_assert_1.default)(!variant.value || variant.value instanceof Buffer);
        }
      }
      return variant;
    }
    exports2.adjustVariant = adjustVariant;
  }
});

// node_modules/node-opcua-variant/dist/cast_variant.js
var require_cast_variant = __commonJS({
  "node_modules/node-opcua-variant/dist/cast_variant.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-variant/dist/verify_rank_and_dimension.js
var require_verify_rank_and_dimension = __commonJS({
  "node_modules/node-opcua-variant/dist/verify_rank_and_dimension.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.verifyRankAndDimensions = void 0;
    var node_opcua_assert_1 = __importDefault3(require_dist14());
    function verifyRankAndDimensions(options) {
      options.arrayDimensions = options.arrayDimensions || null;
      (0, node_opcua_assert_1.default)(options.arrayDimensions === null || Array.isArray(options.arrayDimensions));
      if (options.arrayDimensions && options.valueRank === void 0) {
        options.valueRank = options.arrayDimensions.length || -1;
      }
      options.valueRank = options.valueRank === void 0 ? -1 : options.valueRank || 0;
      (0, node_opcua_assert_1.default)(typeof options.valueRank === "number");
      if (options.arrayDimensions && options.valueRank <= 0) {
        if (options.arrayDimensions.length > 0) {
          throw new Error("[CONFORMANCE] arrayDimensions must be null if valueRank <=0");
        }
        options.arrayDimensions = null;
      }
      if (options.valueRank > 0 && (!options.arrayDimensions || options.arrayDimensions.length === 0)) {
        options.arrayDimensions = new Array(options.valueRank).fill(0);
      }
      if (!options.arrayDimensions && options.valueRank > 0) {
        throw new Error("[CONFORMANCE] arrayDimension must be specified  if valueRank >0 " + options.valueRank);
      }
      if (options.valueRank > 0 && options.arrayDimensions.length !== options.valueRank) {
        throw new Error("[CONFORMANCE] when valueRank> 0, arrayDimensions must have valueRank elements, this.valueRank =" + options.valueRank + "  whereas arrayDimensions.length =" + options.arrayDimensions.length);
      }
    }
    exports2.verifyRankAndDimensions = verifyRankAndDimensions;
  }
});

// node_modules/node-opcua-variant/dist/index.js
var require_dist28 = __commonJS({
  "node_modules/node-opcua-variant/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_DataType_enum(), exports2);
    __exportStar3(require_VariantArrayType_enum(), exports2);
    __exportStar3(require_variant(), exports2);
    __exportStar3(require_adjust_variant(), exports2);
    __exportStar3(require_cast_variant(), exports2);
    __exportStar3(require_verify_rank_and_dimension(), exports2);
  }
});

// node_modules/node-opcua-data-value/dist/DataValueEncodingByte_enum.js
var require_DataValueEncodingByte_enum = __commonJS({
  "node_modules/node-opcua-data-value/dist/DataValueEncodingByte_enum.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2._enumerationDataValueEncodingByte = exports2.schemaDataValueEncodingByte = exports2.DataValueEncodingByte = void 0;
    var node_opcua_factory_1 = require_dist26();
    var DataValueEncodingByte;
    (function(DataValueEncodingByte2) {
      DataValueEncodingByte2[DataValueEncodingByte2["Value"] = 1] = "Value";
      DataValueEncodingByte2[DataValueEncodingByte2["StatusCode"] = 2] = "StatusCode";
      DataValueEncodingByte2[DataValueEncodingByte2["SourceTimestamp"] = 4] = "SourceTimestamp";
      DataValueEncodingByte2[DataValueEncodingByte2["ServerTimestamp"] = 8] = "ServerTimestamp";
      DataValueEncodingByte2[DataValueEncodingByte2["SourcePicoseconds"] = 16] = "SourcePicoseconds";
      DataValueEncodingByte2[DataValueEncodingByte2["ServerPicoseconds"] = 32] = "ServerPicoseconds";
    })(DataValueEncodingByte || (exports2.DataValueEncodingByte = DataValueEncodingByte = {}));
    exports2.schemaDataValueEncodingByte = {
      name: "DataValue_EncodingByte",
      enumValues: DataValueEncodingByte
    };
    exports2._enumerationDataValueEncodingByte = (0, node_opcua_factory_1.registerEnumeration)(exports2.schemaDataValueEncodingByte);
  }
});

// node_modules/node-opcua-data-value/dist/TimestampsToReturn_enum.js
var require_TimestampsToReturn_enum = __commonJS({
  "node_modules/node-opcua-data-value/dist/TimestampsToReturn_enum.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.coerceTimestampsToReturn = exports2._enumerationTimestampsToReturn = exports2.decodeTimestampsToReturn = exports2.encodeTimestampsToReturn = exports2.schemaTimestampsToReturn = exports2.TimestampsToReturn = void 0;
    var node_opcua_factory_1 = require_dist26();
    var TimestampsToReturn;
    (function(TimestampsToReturn2) {
      TimestampsToReturn2[TimestampsToReturn2["Source"] = 0] = "Source";
      TimestampsToReturn2[TimestampsToReturn2["Server"] = 1] = "Server";
      TimestampsToReturn2[TimestampsToReturn2["Both"] = 2] = "Both";
      TimestampsToReturn2[TimestampsToReturn2["Neither"] = 3] = "Neither";
      TimestampsToReturn2[TimestampsToReturn2["Invalid"] = 4] = "Invalid";
    })(TimestampsToReturn || (exports2.TimestampsToReturn = TimestampsToReturn = {}));
    exports2.schemaTimestampsToReturn = {
      name: "TimestampsToReturn",
      enumValues: TimestampsToReturn
    };
    function encodeTimestampsToReturn(value, stream) {
      stream.writeUInt32(value);
    }
    exports2.encodeTimestampsToReturn = encodeTimestampsToReturn;
    function clamp(min, a, max) {
      return Math.max(Math.min(a, max), min);
    }
    function decodeTimestampsToReturn(stream, value) {
      return clamp(TimestampsToReturn.Source, stream.readUInt32(), TimestampsToReturn.Invalid);
    }
    exports2.decodeTimestampsToReturn = decodeTimestampsToReturn;
    exports2._enumerationTimestampsToReturn = (0, node_opcua_factory_1.registerEnumeration)(exports2.schemaTimestampsToReturn);
    function coerceTimestampsToReturn(value) {
      return typeof value === "number" ? +value : TimestampsToReturn.Neither;
    }
    exports2.coerceTimestampsToReturn = coerceTimestampsToReturn;
  }
});

// node_modules/node-opcua-data-value/dist/datavalue.js
var require_datavalue = __commonJS({
  "node_modules/node-opcua-data-value/dist/datavalue.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.DataValueT = exports2.sameDataValue = exports2.sameStatusCode = exports2.timestampHasChanged = exports2.serverTimestampHasChanged = exports2.sourceTimestampHasChanged = exports2.extractRange = exports2.apply_timestamps_no_copy = exports2.apply_timestamps = exports2.DataValue = exports2.decodeDataValue = exports2.encodeDataValue = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_date_time_1 = require_dist17();
    var node_opcua_factory_1 = require_dist26();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_data_model_1 = require_dist27();
    var DataValueEncodingByte_enum_1 = require_DataValueEncodingByte_enum();
    var TimestampsToReturn_enum_1 = require_TimestampsToReturn_enum();
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    function getDataValue_EncodingByte(dataValue) {
      let encodingMask = 0;
      if (dataValue.value && dataValue.value.dataType !== node_opcua_variant_1.DataType.Null) {
        encodingMask |= DataValueEncodingByte_enum_1.DataValueEncodingByte.Value;
      }
      if (dataValue.statusCode !== null && typeof dataValue.statusCode === "object" && dataValue.statusCode.value !== 0) {
        encodingMask |= DataValueEncodingByte_enum_1.DataValueEncodingByte.StatusCode;
      }
      if (dataValue.sourceTimestamp && dataValue.sourceTimestamp !== "null") {
        encodingMask |= DataValueEncodingByte_enum_1.DataValueEncodingByte.SourceTimestamp;
      }
      if (dataValue.sourcePicoseconds ? dataValue.sourcePicoseconds % 1e5 : false) {
        encodingMask |= DataValueEncodingByte_enum_1.DataValueEncodingByte.SourcePicoseconds;
      }
      if (dataValue.serverTimestamp && dataValue.serverTimestamp !== "null") {
        encodingMask |= DataValueEncodingByte_enum_1.DataValueEncodingByte.ServerTimestamp;
      }
      if (dataValue.serverPicoseconds ? dataValue.serverPicoseconds % 1e5 : false) {
        encodingMask |= DataValueEncodingByte_enum_1.DataValueEncodingByte.ServerPicoseconds;
      }
      return encodingMask;
    }
    function encodeDataValue(dataValue, stream) {
      const encodingMask = getDataValue_EncodingByte(dataValue);
      (0, node_opcua_assert_1.assert)(isFinite(encodingMask) && encodingMask >= 0 && encodingMask <= 63);
      (0, node_opcua_basic_types_1.encodeUInt8)(encodingMask, stream);
      if (encodingMask & DataValueEncodingByte_enum_1.DataValueEncodingByte.Value) {
        if (!dataValue.value) {
          dataValue.value = new node_opcua_variant_1.Variant();
        }
        if (!dataValue.value.encode) {
          errorLog(" CANNOT FIND ENCODE METHOD ON VARIANT !!! HELP", JSON.stringify(dataValue, null, " "));
        }
        dataValue.value.encode(stream);
      }
      if (encodingMask & DataValueEncodingByte_enum_1.DataValueEncodingByte.StatusCode) {
        (0, node_opcua_basic_types_1.encodeStatusCode)(dataValue.statusCode, stream);
      }
      if (encodingMask & DataValueEncodingByte_enum_1.DataValueEncodingByte.SourceTimestamp && dataValue.sourceTimestamp !== null) {
        (0, node_opcua_basic_types_1.encodeHighAccuracyDateTime)(dataValue.sourceTimestamp, dataValue.sourcePicoseconds, stream);
      }
      if (encodingMask & DataValueEncodingByte_enum_1.DataValueEncodingByte.SourcePicoseconds) {
        (0, node_opcua_assert_1.assert)(dataValue.sourcePicoseconds !== null);
        const sourcePicoseconds = Math.floor(dataValue.sourcePicoseconds % 1e5 / 10);
        (0, node_opcua_basic_types_1.encodeUInt16)(sourcePicoseconds, stream);
      }
      if (encodingMask & DataValueEncodingByte_enum_1.DataValueEncodingByte.ServerTimestamp && dataValue.serverTimestamp !== null) {
        (0, node_opcua_basic_types_1.encodeHighAccuracyDateTime)(dataValue.serverTimestamp, dataValue.serverPicoseconds, stream);
      }
      if (encodingMask & DataValueEncodingByte_enum_1.DataValueEncodingByte.ServerPicoseconds) {
        (0, node_opcua_assert_1.assert)(dataValue.serverPicoseconds !== null);
        const serverPicoseconds = Math.floor(dataValue.serverPicoseconds % 1e5 / 10);
        (0, node_opcua_basic_types_1.encodeUInt16)(serverPicoseconds, stream);
      }
    }
    exports2.encodeDataValue = encodeDataValue;
    function decodeDebugDataValue(dataValue, stream, options) {
      const tracer = options.tracer;
      let cur = stream.length;
      const encodingMask = (0, node_opcua_basic_types_1.decodeUInt8)(stream);
      (0, node_opcua_assert_1.assert)(encodingMask <= 63);
      tracer.trace("member", "encodingByte", "0x" + encodingMask.toString(16), cur, stream.length, "Mask");
      tracer.encoding_byte(encodingMask, DataValueEncodingByte_enum_1.DataValueEncodingByte, cur, stream.length);
      if (encodingMask & DataValueEncodingByte_enum_1.DataValueEncodingByte.Value) {
        dataValue.value = new node_opcua_variant_1.Variant();
        dataValue.value.decodeDebug(stream, options);
      }
      cur = stream.length;
      if (encodingMask & DataValueEncodingByte_enum_1.DataValueEncodingByte.StatusCode) {
        dataValue.statusCode = (0, node_opcua_basic_types_1.decodeStatusCode)(stream);
        tracer.trace("member", "statusCode", dataValue.statusCode, cur, stream.length, "StatusCode");
      }
      cur = stream.length;
      if (encodingMask & DataValueEncodingByte_enum_1.DataValueEncodingByte.SourceTimestamp) {
        dataValue.sourceTimestamp = (0, node_opcua_basic_types_1.decodeHighAccuracyDateTime)(stream);
        dataValue.sourcePicoseconds = dataValue.sourceTimestamp.picoseconds;
        tracer.trace("member", "sourceTimestamp", dataValue.sourceTimestamp, cur, stream.length, "DateTime");
      }
      cur = stream.length;
      dataValue.sourcePicoseconds = 0;
      if (encodingMask & DataValueEncodingByte_enum_1.DataValueEncodingByte.SourcePicoseconds) {
        const tenPico = (0, node_opcua_basic_types_1.decodeUInt16)(stream);
        dataValue.sourcePicoseconds += tenPico * 10;
        tracer.trace("member", "sourcePicoseconds", dataValue.sourcePicoseconds, cur, stream.length, "UInt16");
      }
      cur = stream.length;
      dataValue.serverPicoseconds = 0;
      if (encodingMask & DataValueEncodingByte_enum_1.DataValueEncodingByte.ServerTimestamp) {
        dataValue.serverTimestamp = (0, node_opcua_basic_types_1.decodeHighAccuracyDateTime)(stream);
        dataValue.serverPicoseconds = dataValue.serverTimestamp.picoseconds | 0;
        tracer.trace("member", "serverTimestamp", dataValue.serverTimestamp, cur, stream.length, "DateTime");
      }
      cur = stream.length;
      if (encodingMask & DataValueEncodingByte_enum_1.DataValueEncodingByte.ServerPicoseconds) {
        const tenPico = (0, node_opcua_basic_types_1.decodeUInt16)(stream);
        dataValue.serverPicoseconds += tenPico * 10;
        tracer.trace("member", "serverPicoseconds", dataValue.serverPicoseconds, cur, stream.length, "UInt16");
      }
    }
    function decodeDataValueInternal(dataValue, stream) {
      const encodingMask = (0, node_opcua_basic_types_1.decodeUInt8)(stream);
      if (encodingMask & DataValueEncodingByte_enum_1.DataValueEncodingByte.Value) {
        dataValue.value = new node_opcua_variant_1.Variant();
        dataValue.value.decode(stream);
      }
      if (encodingMask & DataValueEncodingByte_enum_1.DataValueEncodingByte.StatusCode) {
        dataValue.statusCode = (0, node_opcua_basic_types_1.decodeStatusCode)(stream);
      } else {
        dataValue.statusCode = node_opcua_status_code_1.StatusCodes.Good;
      }
      dataValue.sourcePicoseconds = 0;
      if (encodingMask & DataValueEncodingByte_enum_1.DataValueEncodingByte.SourceTimestamp) {
        dataValue.sourceTimestamp = (0, node_opcua_basic_types_1.decodeHighAccuracyDateTime)(stream);
        dataValue.sourcePicoseconds += dataValue.sourceTimestamp.picoseconds | 0;
      }
      if (encodingMask & DataValueEncodingByte_enum_1.DataValueEncodingByte.SourcePicoseconds) {
        dataValue.sourcePicoseconds += (0, node_opcua_basic_types_1.decodeUInt16)(stream) * 10;
      }
      dataValue.serverPicoseconds = 0;
      if (encodingMask & DataValueEncodingByte_enum_1.DataValueEncodingByte.ServerTimestamp) {
        dataValue.serverTimestamp = (0, node_opcua_basic_types_1.decodeHighAccuracyDateTime)(stream);
        dataValue.serverPicoseconds += dataValue.serverTimestamp.picoseconds | 0;
      }
      if (encodingMask & DataValueEncodingByte_enum_1.DataValueEncodingByte.ServerPicoseconds) {
        dataValue.serverPicoseconds += (0, node_opcua_basic_types_1.decodeUInt16)(stream) * 10;
      }
    }
    function decodeDataValue(stream, dataValue) {
      dataValue = dataValue || new DataValue();
      decodeDataValueInternal(dataValue, stream);
      return dataValue;
    }
    exports2.decodeDataValue = decodeDataValue;
    function isValidDataValue(self2) {
      if (self2.value !== null && typeof self2.value === "object") {
        (0, node_opcua_assert_1.assert)(self2.value);
        return self2.value.isValid();
      } else {
        (0, node_opcua_assert_1.assert)(!self2.value);
        (0, node_opcua_assert_1.assert)(self2.statusCode.isNotGood());
      }
      return true;
    }
    var schemaDataValue = (0, node_opcua_factory_1.buildStructuredType)({
      baseType: "BaseUAObject",
      name: "DataValue",
      fields: [
        { name: "Value", fieldType: "Variant", defaultValue: null },
        { name: "StatusCode", fieldType: "StatusCode", defaultValue: node_opcua_status_code_1.StatusCodes.Good },
        { name: "SourceTimestamp", fieldType: "DateTime", defaultValue: null },
        { name: "SourcePicoseconds", fieldType: "UInt16", defaultValue: 0 },
        { name: "ServerTimestamp", fieldType: "DateTime", defaultValue: null },
        { name: "ServerPicoseconds", fieldType: "UInt16", defaultValue: 0 }
      ]
    });
    function toMicroNanoPico(picoseconds) {
      return "" + w(picoseconds / 1e6 >> 0) + "." + w(picoseconds % 1e6 / 1e3 >> 0) + "." + w(picoseconds % 1e3 >> 0);
    }
    function d2(timestamp, picoseconds) {
      return timestamp ? timestamp.toISOString() + " $ " + toMicroNanoPico(picoseconds) : "null";
    }
    var emptyObject = {};
    var defaultDate = node_opcua_date_time_1.minOPCUADate;
    var DataValue = class _DataValue extends node_opcua_factory_1.BaseUAObject {
      /**
       *
       * @class DataValue
       * @constructor
       * @extends BaseUAObject
       * @param  options {Object}
       */
      constructor(options) {
        super();
        if (options === null) {
          this.statusCode = node_opcua_status_code_1.StatusCodes.Bad;
          this.sourceTimestamp = null;
          this.sourcePicoseconds = 0;
          this.serverTimestamp = null;
          this.serverPicoseconds = 0;
          this.value = new node_opcua_variant_1.Variant(null);
          return;
        }
        options = options || emptyObject;
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          const schema = schemaDataValue;
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        if (options.value === void 0 || options.value === null) {
          this.value = new node_opcua_variant_1.Variant({ dataType: node_opcua_variant_1.DataType.Null });
        } else {
          this.value = options.value ? new node_opcua_variant_1.Variant(options.value) : new node_opcua_variant_1.Variant({ dataType: node_opcua_variant_1.DataType.Null });
        }
        this.statusCode = (0, node_opcua_status_code_1.coerceStatusCode)(options.statusCode || node_opcua_status_code_1.StatusCodes.Good);
        this.sourceTimestamp = options.sourceTimestamp ? (0, node_opcua_date_time_1.coerceDateTime)(options.sourceTimestamp) : null;
        this.sourcePicoseconds = options.sourcePicoseconds || 0;
        this.serverTimestamp = options.serverTimestamp ? (0, node_opcua_date_time_1.coerceDateTime)(options.serverTimestamp) : null;
        this.serverPicoseconds = options.serverPicoseconds || 0;
      }
      encode(stream) {
        encodeDataValue(this, stream);
      }
      decode(stream) {
        decodeDataValueInternal(this, stream);
      }
      decodeDebug(stream, options) {
        decodeDebugDataValue(this, stream, options);
      }
      isValid() {
        return isValidDataValue(this);
      }
      toString() {
        let str = "{ /* DataValue */";
        if (this.value) {
          str += "\n   value: " + node_opcua_variant_1.Variant.prototype.toString.apply(this.value);
        } else {
          str += "\n   value:            <null>";
        }
        str += "\n   statusCode:      " + (this.statusCode ? this.statusCode.toString() : "null");
        str += "\n   serverTimestamp: " + d2(this.serverTimestamp, this.serverPicoseconds);
        str += "\n   sourceTimestamp: " + d2(this.sourceTimestamp, this.sourcePicoseconds);
        str += "\n}";
        return str;
      }
      clone() {
        return new _DataValue({
          serverPicoseconds: this.serverPicoseconds,
          serverTimestamp: this.serverTimestamp,
          sourcePicoseconds: this.sourcePicoseconds,
          sourceTimestamp: this.sourceTimestamp,
          statusCode: this.statusCode,
          value: this.value ? this.value.clone() : void 0
        });
      }
    };
    exports2.DataValue = DataValue;
    DataValue.possibleFields = [
      "value",
      "statusCode",
      "sourceTimestamp",
      "sourcePicoseconds",
      "serverTimestamp",
      "serverPicoseconds"
    ];
    DataValue.schema = schemaDataValue;
    DataValue.prototype.schema = DataValue.schema;
    (0, node_opcua_factory_1.registerSpecialVariantEncoder)(DataValue);
    function w(n) {
      return n.toString().padStart(3, "0");
    }
    function _partial_clone(dataValue) {
      const cloneDataValue = new DataValue({ value: void 0 });
      cloneDataValue.value = dataValue.value;
      cloneDataValue.statusCode = dataValue.statusCode;
      return cloneDataValue;
    }
    function apply_timestamps(dataValue, timestampsToReturn, attributeId) {
      let cloneDataValue = null;
      let now = null;
      switch (timestampsToReturn) {
        case TimestampsToReturn_enum_1.TimestampsToReturn.Neither:
          cloneDataValue = cloneDataValue || _partial_clone(dataValue);
          break;
        case TimestampsToReturn_enum_1.TimestampsToReturn.Server:
          cloneDataValue = cloneDataValue || _partial_clone(dataValue);
          cloneDataValue.serverTimestamp = dataValue.serverTimestamp;
          cloneDataValue.serverPicoseconds = dataValue.serverPicoseconds;
          if (!cloneDataValue.serverTimestamp) {
            now = now || (0, node_opcua_date_time_1.getCurrentClock)();
            cloneDataValue.serverTimestamp = now.timestamp;
            cloneDataValue.serverPicoseconds = now.picoseconds;
          }
          break;
        case TimestampsToReturn_enum_1.TimestampsToReturn.Source:
          cloneDataValue = cloneDataValue || _partial_clone(dataValue);
          cloneDataValue.sourceTimestamp = dataValue.sourceTimestamp;
          cloneDataValue.sourcePicoseconds = dataValue.sourcePicoseconds;
          break;
        case TimestampsToReturn_enum_1.TimestampsToReturn.Both:
        default:
          (0, node_opcua_assert_1.assert)(timestampsToReturn === TimestampsToReturn_enum_1.TimestampsToReturn.Both);
          cloneDataValue = cloneDataValue || _partial_clone(dataValue);
          cloneDataValue.serverTimestamp = dataValue.serverTimestamp;
          cloneDataValue.serverPicoseconds = dataValue.serverPicoseconds;
          if (!dataValue.serverTimestamp) {
            now = now || (0, node_opcua_date_time_1.getCurrentClock)();
            cloneDataValue.serverTimestamp = now.timestamp;
            cloneDataValue.serverPicoseconds = now.picoseconds;
          }
          cloneDataValue.sourceTimestamp = dataValue.sourceTimestamp;
          cloneDataValue.sourcePicoseconds = dataValue.sourcePicoseconds;
          break;
      }
      if (attributeId !== node_opcua_data_model_1.AttributeIds.Value) {
        cloneDataValue.sourceTimestamp = null;
      }
      return cloneDataValue;
    }
    exports2.apply_timestamps = apply_timestamps;
    function apply_timestamps_no_copy(dataValue, timestampsToReturn, attributeId, now) {
      switch (timestampsToReturn) {
        case TimestampsToReturn_enum_1.TimestampsToReturn.Neither:
          dataValue.sourceTimestamp = null;
          dataValue.sourcePicoseconds = 0;
          dataValue.serverTimestamp = null;
          dataValue.serverPicoseconds = 0;
          break;
        case TimestampsToReturn_enum_1.TimestampsToReturn.Server:
          now = now || (0, node_opcua_date_time_1.getCurrentClock)();
          dataValue.serverTimestamp = now.timestamp;
          dataValue.serverPicoseconds = now.picoseconds;
          dataValue.sourceTimestamp = null;
          dataValue.sourcePicoseconds = 0;
          break;
        case TimestampsToReturn_enum_1.TimestampsToReturn.Source:
          break;
        case TimestampsToReturn_enum_1.TimestampsToReturn.Both:
        default:
          (0, node_opcua_assert_1.assert)(timestampsToReturn === TimestampsToReturn_enum_1.TimestampsToReturn.Both);
          now = now || (0, node_opcua_date_time_1.getCurrentClock)();
          dataValue.serverTimestamp = now.timestamp;
          dataValue.serverPicoseconds = now.picoseconds;
          break;
      }
      if (attributeId !== node_opcua_data_model_1.AttributeIds.Value) {
        dataValue.sourceTimestamp = null;
      }
      return dataValue;
    }
    exports2.apply_timestamps_no_copy = apply_timestamps_no_copy;
    function _clone_with_array_replacement(dataValue, result2) {
      const statusCode = result2.statusCode.isGood() ? dataValue.statusCode : result2.statusCode;
      const clonedDataValue = new DataValue({
        statusCode,
        serverTimestamp: dataValue.serverTimestamp,
        serverPicoseconds: dataValue.serverPicoseconds,
        sourceTimestamp: dataValue.sourceTimestamp,
        sourcePicoseconds: dataValue.sourcePicoseconds,
        value: {
          dataType: node_opcua_variant_1.DataType.Null
        }
      });
      clonedDataValue.value.dataType = dataValue.value.dataType;
      clonedDataValue.value.arrayType = dataValue.value.arrayType;
      clonedDataValue.value.dimensions = result2.dimensions;
      if (Array.isArray(result2.array)) {
        clonedDataValue.value.value = [...result2.array];
      } else {
        clonedDataValue.value.value = result2.array;
      }
      return clonedDataValue;
    }
    function canRange(dataValue) {
      return dataValue.value && (dataValue.value.arrayType !== node_opcua_variant_1.VariantArrayType.Scalar || dataValue.value.arrayType === node_opcua_variant_1.VariantArrayType.Scalar && dataValue.value.dataType === node_opcua_variant_1.DataType.ByteString || dataValue.value.arrayType === node_opcua_variant_1.VariantArrayType.Scalar && dataValue.value.dataType === node_opcua_variant_1.DataType.String);
    }
    function extractRange(dataValue, indexRange) {
      const variant = dataValue.value;
      if (indexRange && canRange(dataValue)) {
        if (!indexRange.isValid()) {
          return new DataValue({ statusCode: node_opcua_status_code_1.StatusCodes.BadIndexRangeInvalid });
        }
        const result2 = indexRange.extract_values(variant.value, variant.dimensions);
        dataValue = _clone_with_array_replacement(dataValue, result2);
      } else {
        dataValue = dataValue.clone();
      }
      return dataValue;
    }
    exports2.extractRange = extractRange;
    function sameDate(date1, date2) {
      if (date1 === date2) {
        return true;
      }
      if (date1 && date2 === null) {
        return false;
      }
      if (date1 === null && date2) {
        return false;
      }
      if (date1 === null || date2 === null) {
        return false;
      }
      return date1.getTime() === date2.getTime();
    }
    function sourceTimestampHasChanged(dataValue1, dataValue2) {
      return !sameDate(dataValue1.sourceTimestamp, dataValue2.sourceTimestamp) || dataValue1.sourcePicoseconds !== dataValue2.sourcePicoseconds;
    }
    exports2.sourceTimestampHasChanged = sourceTimestampHasChanged;
    function serverTimestampHasChanged(dataValue1, dataValue2) {
      return !sameDate(dataValue1.serverTimestamp, dataValue2.serverTimestamp) || dataValue1.serverPicoseconds !== dataValue2.serverPicoseconds;
    }
    exports2.serverTimestampHasChanged = serverTimestampHasChanged;
    function timestampHasChanged(dataValue1, dataValue2, timestampsToReturn) {
      if (timestampsToReturn === void 0) {
        return sourceTimestampHasChanged(dataValue1, dataValue2);
      }
      switch (timestampsToReturn) {
        case TimestampsToReturn_enum_1.TimestampsToReturn.Neither:
          return false;
        case TimestampsToReturn_enum_1.TimestampsToReturn.Both:
          return sourceTimestampHasChanged(dataValue1, dataValue2) || serverTimestampHasChanged(dataValue1, dataValue2);
        case TimestampsToReturn_enum_1.TimestampsToReturn.Source:
          return sourceTimestampHasChanged(dataValue1, dataValue2);
        default:
          (0, node_opcua_assert_1.assert)(timestampsToReturn === TimestampsToReturn_enum_1.TimestampsToReturn.Server);
          return serverTimestampHasChanged(dataValue1, dataValue2);
      }
    }
    exports2.timestampHasChanged = timestampHasChanged;
    function sameStatusCode(statusCode1, statusCode2) {
      return statusCode1.value === statusCode2.value;
    }
    exports2.sameStatusCode = sameStatusCode;
    function sameDataValue(v1, v2, timestampsToReturn) {
      if (v1 === v2) {
        return true;
      }
      if (v1 && !v2) {
        return false;
      }
      if (v2 && !v1) {
        return false;
      }
      if (!sameStatusCode(v1.statusCode, v2.statusCode)) {
        return false;
      }
      if (timestampHasChanged(v1, v2, timestampsToReturn)) {
        return false;
      }
      return (0, node_opcua_variant_1.sameVariant)(v1.value, v2.value);
    }
    exports2.sameDataValue = sameDataValue;
    var DataValueT = class extends DataValue {
    };
    exports2.DataValueT = DataValueT;
  }
});

// node_modules/node-opcua-data-value/dist/index.js
var require_dist29 = __commonJS({
  "node_modules/node-opcua-data-value/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_datavalue(), exports2);
    __exportStar3(require_TimestampsToReturn_enum(), exports2);
  }
});

// node_modules/node-opcua-extension-object/dist/extension_object.js
var require_extension_object = __commonJS({
  "node_modules/node-opcua-extension-object/dist/extension_object.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.decodeExtensionObject = exports2.OpaqueStructure = exports2.encodeExtensionObject = exports2.ExtensionObject = void 0;
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_factory_1 = require_dist26();
    var node_opcua_nodeid_1 = require_dist21();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var chalk_1 = __importDefault3(require_source());
    var ExtensionObject = class extends node_opcua_factory_1.BaseUAObject {
      constructor(options) {
        super();
      }
    };
    exports2.ExtensionObject = ExtensionObject;
    ExtensionObject.schema = new node_opcua_factory_1.StructuredTypeSchema({
      baseType: "",
      documentation: "",
      fields: [],
      name: "ExtensionObject",
      dataTypeFactory: (0, node_opcua_factory_1.getStandardDataTypeFactory)()
    });
    ExtensionObject.prototype.schema = ExtensionObject.schema;
    function encodeExtensionObject(object, stream) {
      if (!object) {
        (0, node_opcua_basic_types_1.encodeNodeId)((0, node_opcua_nodeid_1.makeNodeId)(0), stream);
        stream.writeUInt8(0);
      } else {
        if (object instanceof OpaqueStructure) {
          (0, node_opcua_basic_types_1.encodeNodeId)(object.nodeId, stream);
          stream.writeUInt8(1);
          stream.writeByteStream(object.buffer);
          return;
        }
        if (!(object instanceof node_opcua_factory_1.BaseUAObject)) {
          throw new Error("Expecting a extension object");
        }
        if (!object.schema) {
          debugLog(" object = ", object);
          throw new Error("object has no schema " + object.constructor.name);
        }
        const encodingDefaultBinary = object.schema.encodingDefaultBinary;
        if (!encodingDefaultBinary) {
          debugLog(chalk_1.default.yellow("encoding ExtObj "), object);
          throw new Error("Cannot find encodingDefaultBinary for this object : " + object.schema.name);
        }
        if (encodingDefaultBinary.isEmpty()) {
          debugLog(chalk_1.default.yellow("encoding ExtObj "), object.constructor.encodingDefaultBinary.toString());
          throw new Error("Cannot find encodingDefaultBinary for this object : " + object.schema.name);
        }
        if ((0, node_opcua_factory_1.is_internal_id)(encodingDefaultBinary.value)) {
          debugLog(chalk_1.default.yellow("encoding ExtObj "), object.constructor.encodingDefaultBinary.toString(), object.schema.name);
          throw new Error("Cannot find valid OPCUA encodingDefaultBinary for this object : " + object.schema.name);
        }
        (0, node_opcua_basic_types_1.encodeNodeId)(encodingDefaultBinary, stream);
        stream.writeUInt8(1);
        stream.writeUInt32(object.binaryStoreSize());
        object.encode(stream);
      }
    }
    exports2.encodeExtensionObject = encodeExtensionObject;
    var OpaqueStructure = class extends ExtensionObject {
      constructor(nodeId, buffer) {
        super();
        this.nodeId = nodeId;
        this.buffer = buffer;
      }
      toString() {
        const str = "/* OpaqueStructure */ { \nnodeId " + this.nodeId.toString() + "\nbuffer = \n" + (0, node_opcua_debug_1.hexDump)(this.buffer) + "\n}";
        return str;
      }
    };
    exports2.OpaqueStructure = OpaqueStructure;
    function decodeExtensionObject(stream, _value) {
      const nodeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream);
      const encodingType = stream.readUInt8();
      if (encodingType === 0) {
        return null;
      }
      const length = stream.readUInt32();
      if (nodeId.value === 0 || encodingType === 0) {
        return {};
      }
      const streamLengthBefore = stream.length;
      let object;
      if (nodeId.namespace !== 0) {
        stream.length -= 4;
        object = new OpaqueStructure(nodeId, stream.readByteStream());
      } else {
        try {
          object = (0, node_opcua_factory_1.getStandardDataTypeFactory)().constructObject(nodeId);
        } catch (err) {
          warningLog("cannot construct object with dataType nodeId", nodeId.toString());
        }
        if (object === null) {
          stream.length -= 4;
          object = new OpaqueStructure(nodeId, stream.readByteStream());
        } else {
          try {
            object.decode(stream);
          } catch (err) {
            debugLog("Cannot decode object ", err);
          }
        }
      }
      if (streamLengthBefore + length !== stream.length) {
        debugLog(chalk_1.default.bgWhiteBright.red("========================================="));
        warningLog("WARNING => decodeExtensionObject: Extension object decoding error on ", object?.constructor.name, " expected size was", length, "but only this amount of bytes have been read :", stream.length - streamLengthBefore, "\n           encoding nodeId = ", nodeId.toString(), "encodingType = ", encodingType);
        stream.length = streamLengthBefore + length;
      }
      return object;
    }
    exports2.decodeExtensionObject = decodeExtensionObject;
    (0, node_opcua_factory_1.registerBuiltInType)({
      name: "ExtensionObject",
      subType: "",
      encode: encodeExtensionObject,
      decode: decodeExtensionObject,
      defaultValue: () => null
    });
  }
});

// node_modules/node-opcua-extension-object/dist/index.js
var require_dist30 = __commonJS({
  "node_modules/node-opcua-extension-object/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_extension_object(), exports2);
  }
});

// node_modules/node-opcua-numeric-range/dist/numeric_range.js
var require_numeric_range = __commonJS({
  "node_modules/node-opcua-numeric-range/dist/numeric_range.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.decodeNumericRange = exports2.encodeNumericRange = exports2.NumericRange = exports2.NumericRangeType = exports2.schemaNumericRange = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_factory_1 = require_dist26();
    var node_opcua_status_code_1 = require_dist22();
    var NUMERIC_RANGE_EMPTY_STRING = "NumericRange:<Empty>";
    exports2.schemaNumericRange = {
      name: "NumericRange",
      subType: "String",
      defaultValue: () => {
        return new NumericRange();
      },
      encode: encodeNumericRange,
      decode: decodeNumericRange,
      random: () => {
        function r() {
          return Math.ceil(Math.random() * 100);
        }
        const start = r();
        const end = start + r();
        return new NumericRange(start, end);
      },
      coerce: coerceNumericRange
    };
    (0, node_opcua_factory_1.registerBasicType)(exports2.schemaNumericRange);
    var NumericRangeType;
    (function(NumericRangeType2) {
      NumericRangeType2[NumericRangeType2["Empty"] = 0] = "Empty";
      NumericRangeType2[NumericRangeType2["SingleValue"] = 1] = "SingleValue";
      NumericRangeType2[NumericRangeType2["ArrayRange"] = 2] = "ArrayRange";
      NumericRangeType2[NumericRangeType2["MatrixRange"] = 3] = "MatrixRange";
      NumericRangeType2[NumericRangeType2["InvalidRange"] = 4] = "InvalidRange";
    })(NumericRangeType || (exports2.NumericRangeType = NumericRangeType = {}));
    var regexNumericRange = /^[0-9:,]*$/;
    function _valid_range(low, high) {
      return !(low >= high || low < 0 || high < 0);
    }
    function construct_numeric_range_bit_from_string(str) {
      const values = str.split(":");
      if (values.length === 1) {
        return {
          type: NumericRangeType.SingleValue,
          value: parseInt(values[0], 10)
        };
      } else if (values.length === 2) {
        const array = values.map((a) => parseInt(a, 10));
        if (!_valid_range(array[0], array[1])) {
          return {
            type: NumericRangeType.InvalidRange,
            value: str
          };
        }
        return {
          type: NumericRangeType.ArrayRange,
          value: array
        };
      } else {
        return {
          type: NumericRangeType.InvalidRange,
          value: str
        };
      }
    }
    function _normalize(e) {
      if (e.type === NumericRangeType.SingleValue) {
        const ee = e;
        return [ee.value, ee.value];
      }
      return e.value;
    }
    function construct_numeric_range_from_string(str) {
      if (!regexNumericRange.test(str)) {
        return {
          type: NumericRangeType.InvalidRange,
          value: str
        };
      }
      const values = str.split(",");
      if (values.length === 1) {
        return construct_numeric_range_bit_from_string(values[0]);
      } else if (values.length === 2) {
        const elements = values.map(construct_numeric_range_bit_from_string);
        let rowRange = elements[0];
        let colRange = elements[1];
        if (rowRange.type === NumericRangeType.InvalidRange || colRange.type === NumericRangeType.InvalidRange) {
          return { type: NumericRangeType.InvalidRange, value: str };
        }
        rowRange = _normalize(rowRange);
        colRange = _normalize(colRange);
        return {
          type: NumericRangeType.MatrixRange,
          value: [rowRange, colRange]
        };
      } else {
        return { type: NumericRangeType.InvalidRange, value: str };
      }
    }
    function construct_from_string(value) {
      return construct_numeric_range_from_string(value);
    }
    function _set_single_value(value) {
      if (value === null || value < 0 || !isFinite(value)) {
        return {
          type: NumericRangeType.InvalidRange,
          value: "" + value?.toString()
        };
      } else {
        return {
          type: NumericRangeType.SingleValue,
          value
        };
      }
    }
    function _check_range(numericalRange) {
      switch (numericalRange.type) {
        case NumericRangeType.ArrayRange:
          return _valid_range(numericalRange.value[0], numericalRange.value[1]);
      }
      throw new Error("unsupported case");
    }
    function _set_range_value(low, high) {
      if (low === high) {
        return {
          type: NumericRangeType.SingleValue,
          value: low
        };
      }
      const numericalRange = {
        type: NumericRangeType.ArrayRange,
        value: [low, high]
      };
      if (!_check_range(numericalRange)) {
        return {
          type: NumericRangeType.InvalidRange,
          value: ""
        };
      }
      return numericalRange;
    }
    function construct_from_values(value, secondValue) {
      if (secondValue === void 0) {
        return _set_single_value(value);
      } else {
        if (!isFinite(secondValue)) {
          throw new Error(" invalid second argument, expecting a number");
        }
        return _set_range_value(value, secondValue);
      }
    }
    function _construct_from_array(value, value2) {
      (0, node_opcua_assert_1.assert)(value.length === 2);
      if (!isFinite(value[0]) || !isFinite(value[1])) {
        return { type: NumericRangeType.InvalidRange, value: "" + value };
      }
      let range1 = _set_range_value(value[0], value[1]);
      if (!value2) {
        return range1;
      }
      const nr2 = new NumericRange(value2);
      if (nr2.type === NumericRangeType.InvalidRange || nr2.type === NumericRangeType.MatrixRange || nr2.type === NumericRangeType.Empty) {
        return { type: NumericRangeType.InvalidRange, value: "" + value };
      }
      if (range1.type === NumericRangeType.SingleValue) {
        range1 = {
          type: NumericRangeType.ArrayRange,
          value: [range1.value, range1.value]
        };
      }
      if (nr2.type === NumericRangeType.SingleValue) {
        nr2.type = NumericRangeType.ArrayRange;
        nr2.value = [nr2.value, nr2.value];
      }
      return {
        type: NumericRangeType.MatrixRange,
        value: [range1.value, nr2.value]
      };
    }
    var NumericRange = class _NumericRange {
      static overlap(nr1, nr2) {
        nr1 = nr1 || _NumericRange.empty;
        nr2 = nr2 || _NumericRange.empty;
        if (NumericRangeType.Empty === nr1.type || NumericRangeType.Empty === nr2.type) {
          return true;
        }
        if (NumericRangeType.SingleValue === nr1.type && NumericRangeType.SingleValue === nr2.type) {
          return nr1.value === nr2.value;
        }
        if (NumericRangeType.ArrayRange === nr1.type && NumericRangeType.ArrayRange === nr2.type) {
          const l1 = nr1.value[0];
          const h1 = nr1.value[1];
          const l2 = nr2.value[0];
          const h2 = nr2.value[1];
          return _overlap(l1, h1, l2, h2);
        }
        (0, node_opcua_assert_1.assert)(false, "NumericalRange#overlap : case not implemented yet ");
        return false;
      }
      constructor(value, secondValue) {
        this.type = NumericRangeType.InvalidRange;
        this.value = null;
        (0, node_opcua_assert_1.assert)(!value || !(value instanceof _NumericRange), "use coerce to create a NumericRange");
        (0, node_opcua_assert_1.assert)(!secondValue || typeof secondValue === "number" || Array.isArray(secondValue));
        if (typeof value === "string") {
          const a = construct_from_string(value);
          this.type = a.type;
          this.value = a.value;
        } else if (typeof value === "number" && isFinite(value) && (secondValue === void 0 || typeof secondValue === "number" && isFinite(secondValue))) {
          const a = construct_from_values(value, secondValue);
          this.type = a.type;
          this.value = a.value;
        } else if (Array.isArray(value)) {
          const a = _construct_from_array(value, secondValue);
          this.type = a.type;
          this.value = a.value;
        } else {
          this.value = "<invalid>";
          this.type = NumericRangeType.Empty;
        }
      }
      isValid() {
        if (this.type === NumericRangeType.ArrayRange) {
          const value = this.value;
          if (value[0] < 0 || value[1] < 0) {
            return false;
          }
        }
        if (this.type === NumericRangeType.SingleValue) {
          const value = this.value;
          if (value < 0) {
            return false;
          }
        }
        return this.type !== NumericRangeType.InvalidRange;
      }
      isEmpty() {
        return this.type === NumericRangeType.Empty;
      }
      isDefined() {
        return this.type !== NumericRangeType.Empty && this.type !== NumericRangeType.InvalidRange;
      }
      toString() {
        function array_range_to_string(values) {
          (0, node_opcua_assert_1.assert)(Array.isArray(values));
          if (values.length === 2 && values[0] === values[1]) {
            return values[0].toString();
          }
          return values.map((value) => value.toString(10)).join(":");
        }
        function matrix_range_to_string(values) {
          return values.map((value) => {
            return Array.isArray(value) ? array_range_to_string(value) : value.toString(10);
          }).join(",");
        }
        switch (this.type) {
          case NumericRangeType.SingleValue:
            return this.value.toString(10);
          case NumericRangeType.ArrayRange:
            return array_range_to_string(this.value);
          case NumericRangeType.Empty:
            return NUMERIC_RANGE_EMPTY_STRING;
          case NumericRangeType.MatrixRange:
            return matrix_range_to_string(this.value);
          default:
            (0, node_opcua_assert_1.assert)(this.type === NumericRangeType.InvalidRange);
            return "NumericRange:<Invalid>";
        }
      }
      toJSON() {
        return this.toString();
      }
      toEncodeableString() {
        switch (this.type) {
          case NumericRangeType.SingleValue:
          case NumericRangeType.ArrayRange:
          case NumericRangeType.MatrixRange:
            return this.toString();
          case NumericRangeType.InvalidRange:
            if (!(typeof this.value === "string")) {
              throw new Error("Internal Error");
            }
            return this.value;
          default:
            return null;
        }
      }
      /**
       * @method extract_values
       * @param array   flat array containing values or string
       * @param dimensions: of the matrix if data is a matrix
       * @return {*}
       */
      extract_values(array, dimensions) {
        const self2 = this;
        if (!array) {
          return {
            array,
            statusCode: this.type === NumericRangeType.Empty ? node_opcua_status_code_1.StatusCodes.Good : node_opcua_status_code_1.StatusCodes.BadIndexRangeNoData
          };
        }
        let index;
        let low_index;
        let high_index;
        let rowRange;
        let colRange;
        switch (self2.type) {
          case NumericRangeType.Empty:
            return extract_empty(array, dimensions);
          case NumericRangeType.SingleValue:
            index = self2.value;
            return extract_single_value(array, index);
          case NumericRangeType.ArrayRange:
            low_index = self2.value[0];
            high_index = self2.value[1];
            return extract_array_range(array, low_index, high_index);
          case NumericRangeType.MatrixRange:
            rowRange = self2.value[0];
            colRange = self2.value[1];
            return extract_matrix_range(array, rowRange, colRange, dimensions);
          default:
            return { statusCode: node_opcua_status_code_1.StatusCodes.BadIndexRangeInvalid };
        }
      }
      set_values_matrix(sourceToAlter, newMatrix) {
        const { matrix, dimensions } = sourceToAlter;
        const self2 = this;
        (0, node_opcua_assert_1.assert)(dimensions, "expecting valid dimensions here");
        if (self2.type !== NumericRangeType.MatrixRange) {
          return { matrix, statusCode: node_opcua_status_code_1.StatusCodes.BadTypeMismatch };
        }
        (0, node_opcua_assert_1.assert)(dimensions.length === 2);
        const nbRows = dimensions[0];
        const nbCols = dimensions[1];
        (0, node_opcua_assert_1.assert)(sourceToAlter.matrix.length === nbRows * nbCols);
        const [rowStart, rowEnd] = self2.value[0];
        const [colStart, colEnd] = self2.value[1];
        const nbRowInNew = rowEnd - rowStart + 1;
        const nbColInNew = colEnd - colStart + 1;
        if (nbRowInNew * nbColInNew !== newMatrix.length) {
          return { matrix, statusCode: node_opcua_status_code_1.StatusCodes.BadTypeMismatch };
        }
        if (rowEnd >= nbRows || colEnd >= nbCols) {
          return { matrix, statusCode: node_opcua_status_code_1.StatusCodes.BadTypeMismatch };
        }
        for (let row = rowStart; row <= rowEnd; row++) {
          const ri = row - rowStart;
          for (let col = colStart; col <= colEnd; col++) {
            const ci = col - colStart;
            matrix[row * nbCols + col] = newMatrix[ri * nbColInNew + ci];
          }
        }
        return {
          matrix,
          statusCode: node_opcua_status_code_1.StatusCodes.Good
        };
      }
      set_values(arrayToAlter, newValues) {
        assert_array_or_buffer(arrayToAlter);
        assert_array_or_buffer(newValues);
        const self2 = this;
        let low_index;
        let high_index;
        switch (self2.type) {
          case NumericRangeType.Empty:
            low_index = 0;
            high_index = arrayToAlter.length - 1;
            break;
          case NumericRangeType.SingleValue:
            low_index = self2.value;
            high_index = self2.value;
            break;
          case NumericRangeType.ArrayRange:
            low_index = self2.value[0];
            high_index = self2.value[1];
            break;
          case NumericRangeType.MatrixRange:
            return { array: arrayToAlter, statusCode: node_opcua_status_code_1.StatusCodes.BadIndexRangeNoData };
          default:
            return { array: null, statusCode: node_opcua_status_code_1.StatusCodes.BadIndexRangeInvalid };
        }
        if (high_index >= arrayToAlter.length || low_index >= arrayToAlter.length) {
          return { array: null, statusCode: node_opcua_status_code_1.StatusCodes.BadIndexRangeNoData };
        }
        if (this.type !== NumericRangeType.Empty && newValues.length !== high_index - low_index + 1) {
          return { array: null, statusCode: node_opcua_status_code_1.StatusCodes.BadIndexRangeInvalid };
        }
        const insertInPlace = Array.isArray(arrayToAlter) ? insertInPlaceStandardArray : arrayToAlter instanceof Buffer ? insertInPlaceBuffer : insertInPlaceTypedArray;
        return {
          array: insertInPlace(arrayToAlter, low_index, high_index, newValues),
          statusCode: node_opcua_status_code_1.StatusCodes.Good
        };
      }
    };
    exports2.NumericRange = NumericRange;
    NumericRange.coerce = coerceNumericRange;
    NumericRange.schema = exports2.schemaNumericRange;
    NumericRange.NumericRangeType = NumericRangeType;
    NumericRange.empty = new NumericRange();
    function slice(arr, start, end) {
      if (start === 0 && end === arr.length) {
        return arr;
      }
      let res;
      if (arr.buffer instanceof ArrayBuffer) {
        res = arr.subarray(start, end);
      } else if (arr instanceof Buffer) {
        res = arr.subarray(start, end);
      } else {
        (0, node_opcua_assert_1.assert)(typeof arr.slice === "function");
        (0, node_opcua_assert_1.assert)(arr instanceof Buffer || arr instanceof Array || typeof arr === "string");
        res = arr.slice(start, end);
      }
      if (res instanceof Uint8Array && arr instanceof Buffer) {
        res = Buffer.from(res);
      }
      return res;
    }
    function extract_empty(array, dimensions) {
      return {
        array: slice(array, 0, array.length),
        dimensions,
        statusCode: node_opcua_status_code_1.StatusCodes.Good
      };
    }
    function extract_single_value(array, index) {
      if (index >= array.length) {
        if (typeof array === "string") {
          return { array: "", statusCode: node_opcua_status_code_1.StatusCodes.BadIndexRangeNoData };
        }
        return { array: null, statusCode: node_opcua_status_code_1.StatusCodes.BadIndexRangeNoData };
      }
      return {
        array: slice(array, index, index + 1),
        statusCode: node_opcua_status_code_1.StatusCodes.Good
      };
    }
    function extract_array_range(array, low_index, high_index) {
      (0, node_opcua_assert_1.assert)(isFinite(low_index) && isFinite(high_index));
      (0, node_opcua_assert_1.assert)(low_index >= 0);
      (0, node_opcua_assert_1.assert)(low_index <= high_index);
      if (low_index >= array.length) {
        if (typeof array === "string") {
          return { array: "", statusCode: node_opcua_status_code_1.StatusCodes.BadIndexRangeNoData };
        }
        return { array: null, statusCode: node_opcua_status_code_1.StatusCodes.BadIndexRangeNoData };
      }
      high_index = Math.min(high_index, array.length - 1);
      return {
        array: slice(array, low_index, high_index + 1),
        statusCode: node_opcua_status_code_1.StatusCodes.Good
      };
    }
    function isArrayLike(value) {
      return typeof value.length === "number" || Object.prototype.hasOwnProperty.call(value, "length");
    }
    function extract_matrix_range(array, rowRange, colRange, dimension) {
      (0, node_opcua_assert_1.assert)(Array.isArray(rowRange) && Array.isArray(colRange));
      if (array.length === 0) {
        return {
          array: null,
          statusCode: node_opcua_status_code_1.StatusCodes.BadIndexRangeNoData
        };
      }
      if (isArrayLike(array[0]) && !dimension) {
        const result2 = extract_array_range(array, rowRange[0], rowRange[1]);
        for (let i = 0; i < result2.array.length; i++) {
          const e = result2.array[i];
          result2.array[i] = extract_array_range(e, colRange[0], colRange[1]).array;
        }
        return result2;
      }
      if (!dimension) {
        return {
          array: null,
          statusCode: node_opcua_status_code_1.StatusCodes.BadIndexRangeNoData
        };
      }
      (0, node_opcua_assert_1.assert)(dimension, "expecting dimension to know the shape of the matrix represented by the flat array");
      const rowLow = rowRange[0];
      const rowHigh = rowRange[1];
      const colLow = colRange[0];
      const colHigh = colRange[1];
      const nbRow = dimension[0];
      const nbCol = dimension[1];
      const nbRowDest = rowHigh - rowLow + 1;
      const nbColDest = colHigh - colLow + 1;
      const tmp = new array.constructor(nbColDest * nbRowDest);
      let row;
      let col;
      let r;
      let c2;
      r = 0;
      for (row = rowLow; row <= rowHigh; row++) {
        c2 = 0;
        for (col = colLow; col <= colHigh; col++) {
          const srcIndex = row * nbCol + col;
          const destIndex = r * nbColDest + c2;
          tmp[destIndex] = array[srcIndex];
          c2++;
        }
        r += 1;
      }
      return {
        array: tmp,
        dimensions: [nbRowDest, nbColDest],
        statusCode: node_opcua_status_code_1.StatusCodes.Good
      };
    }
    function assert_array_or_buffer(array) {
      (0, node_opcua_assert_1.assert)(Array.isArray(array) || array.buffer instanceof ArrayBuffer || array instanceof Buffer);
    }
    function insertInPlaceStandardArray(arrayToAlter, low, high, newValues) {
      const args = [low, high - low + 1].concat(newValues);
      arrayToAlter.splice(...args);
      return arrayToAlter;
    }
    function insertInPlaceTypedArray(arrayToAlter, low, high, newValues) {
      if (low === 0 && high === arrayToAlter.length - 1) {
        return new arrayToAlter.constructor(newValues);
      }
      (0, node_opcua_assert_1.assert)(newValues.length === high - low + 1);
      arrayToAlter.subarray(low, high + 1).set(newValues);
      return arrayToAlter;
    }
    function insertInPlaceBuffer(bufferToAlter, low, high, newValues) {
      if (!(bufferToAlter instanceof Buffer))
        throw new Error("expecting a buffer");
      if (low === 0 && high === bufferToAlter.length - 1) {
        bufferToAlter = Buffer.from(newValues);
        return bufferToAlter;
      }
      (0, node_opcua_assert_1.assert)(newValues.length === high - low + 1);
      for (let i = 0; i < newValues.length; i++) {
        bufferToAlter[i + low] = newValues[i];
      }
      return bufferToAlter;
    }
    function _overlap(l1, h1, l2, h2) {
      return Math.max(l1, l2) <= Math.min(h1, h2);
    }
    function encodeNumericRange(numericRange, stream) {
      (0, node_opcua_assert_1.assert)(numericRange instanceof NumericRange);
      (0, node_opcua_basic_types_1.encodeString)(numericRange.toEncodeableString(), stream);
    }
    exports2.encodeNumericRange = encodeNumericRange;
    function decodeNumericRange(stream, _value) {
      const str = (0, node_opcua_basic_types_1.decodeString)(stream);
      return new NumericRange(str);
    }
    exports2.decodeNumericRange = decodeNumericRange;
    function coerceNumericRange(value) {
      if (value instanceof NumericRange) {
        return value;
      }
      if (value === null || value === void 0) {
        return new NumericRange();
      }
      if (value === NUMERIC_RANGE_EMPTY_STRING) {
        return new NumericRange();
      }
      (0, node_opcua_assert_1.assert)(typeof value === "string" || Array.isArray(value));
      return new NumericRange(value);
    }
  }
});

// node_modules/node-opcua-numeric-range/dist/index.js
var require_dist31 = __commonJS({
  "node_modules/node-opcua-numeric-range/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_numeric_range(), exports2);
  }
});

// node_modules/node-opcua-types/dist/_generated_opcua_types.js
var require_generated_opcua_types = __commonJS({
  "node_modules/node-opcua-types/dist/_generated_opcua_types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.BrokerWriterGroupTransportDataType = exports2.WriterGroupTransportDataType = exports2.BrokerDataSetWriterTransportDataType = exports2.DataSetWriterTransportDataType = exports2.BrokerDataSetReaderTransportDataType = exports2._enumerationBrokerTransportQualityOfService = exports2.BrokerTransportQualityOfService = exports2.DataSetReaderTransportDataType = exports2.BrokerConnectionTransportDataType = exports2.ConnectionTransportDataType = exports2.AttributeOperand = exports2.RelativePath = exports2.RelativePathElement = exports2.Argument = exports2.ApplicationDescription = exports2._enumerationApplicationType = exports2.ApplicationType = exports2.AnonymousIdentityToken = exports2.UserIdentityToken = exports2.Annotation = exports2.AliasNameDataType = exports2.AggregateFilterResult = exports2.MonitoringFilterResult = exports2.AggregateFilter = exports2.MonitoringFilter = exports2.AggregateConfiguration = exports2.AdditionalParametersType = exports2.KeyValuePair = exports2.AddReferencesResponse = exports2.AddReferencesRequest = exports2.AddReferencesItem = exports2.AddNodesResponse = exports2.AddNodesResult = exports2.AddNodesRequest = exports2.AddNodesItem = exports2._enumerationNodeClass = exports2.NodeClass = exports2.ActivateSessionResponse = exports2.ResponseHeader = exports2.ActivateSessionRequest = exports2.SignedSoftwareCertificate = exports2.SignatureData = exports2.RequestHeader = exports2.SimpleAttributeOperand = exports2.FilterOperand = exports2.AxisInformation = exports2._enumerationAxisScaleEnumeration = exports2.AxisScaleEnumeration = exports2.Range = exports2.EUInformation = void 0;
    exports2.CreateSubscriptionResponse = exports2.CreateSubscriptionRequest = exports2.CreateSessionResponse = exports2.EndpointDescription = exports2.UserTokenPolicy = exports2._enumerationUserTokenType = exports2.UserTokenType = exports2._enumerationMessageSecurityMode = exports2.MessageSecurityMode = exports2.CreateSessionRequest = exports2.CreateMonitoredItemsResponse = exports2.MonitoredItemCreateResult = exports2.CreateMonitoredItemsRequest = exports2.MonitoredItemCreateRequest = exports2.MonitoringParameters = exports2._enumerationMonitoringMode = exports2.MonitoringMode = exports2.ReadValueId = exports2.ContentFilterResult = exports2.ContentFilterElementResult = exports2.ContentFilter = exports2.ContentFilterElement = exports2._enumerationFilterOperator = exports2.FilterOperator = exports2.ConfigurationVersionDataType = exports2.ComplexNumberType = exports2.CloseSessionResponse = exports2.CloseSessionRequest = exports2.CloseSecureChannelResponse = exports2.CloseSecureChannelRequest = exports2.ChannelSecurityToken = exports2.CartesianCoordinates = exports2.CancelResponse = exports2.CancelRequest = exports2.CallResponse = exports2.CallRequest = exports2.CallMethodResult = exports2.CallMethodRequest = exports2.BuildInfo = exports2.BrowseResponse = exports2.BrowseRequest = exports2.ViewDescription = exports2.BrowsePathResult = exports2.BrowsePathTarget = exports2.BrowsePath = exports2.BrowseNextResponse = exports2.BrowseResult = exports2.ReferenceDescription = exports2.BrowseNextRequest = exports2.BrowseDescription = void 0;
    exports2.DeleteMonitoredItemsResponse = exports2.DeleteMonitoredItemsRequest = exports2.DeleteEventDetails = exports2.DeleteAtTimeDetails = exports2.HistoryUpdateDetails = exports2.DecimalDataType = exports2.DatagramWriterGroupTransport2DataType = exports2.DatagramWriterGroupTransportDataType = exports2.DatagramDataSetReaderTransportDataType = exports2.DatagramConnectionTransport2DataType = exports2.DatagramConnectionTransportDataType = exports2.DataTypeNode = exports2.TypeNode = exports2.Node = exports2.ReferenceNode = exports2.RolePermissionType = exports2._enumerationPermissionType = exports2.PermissionType = exports2.DataTypeAttributes = exports2.NodeAttributes = exports2.DataSetWriterMessageDataType = exports2.DataSetWriterDataType = exports2.DataSetReaderMessageDataType = exports2.DataSetReaderDataType = exports2._enumerationDataSetFieldContentMask = exports2.DataSetFieldContentMask = exports2.DataSetMetaDataType = exports2.FieldMetaData = exports2._enumerationDataSetFieldFlags = exports2.DataSetFieldFlags = exports2.DataTypeSchemaHeader = exports2.SimpleTypeDescription = exports2.EnumDescription = exports2.EnumDefinition = exports2.EnumField = exports2.EnumValueType = exports2.StructureDescription = exports2.StructureDefinition = exports2.StructureField = exports2._enumerationStructureType = exports2.StructureType = exports2.DataTypeDefinition = exports2.DataTypeDescription = exports2.DataChangeNotification = exports2.MonitoredItemNotification = exports2.NotificationData = exports2.DataChangeFilter = exports2._enumerationDataChangeTrigger = exports2.DataChangeTrigger = exports2.CurrencyUnitType = void 0;
    exports2._enumerationIdentityCriteriaType = exports2.IdentityCriteriaType = exports2.HistoryUpdateResponse = exports2.HistoryUpdateResult = exports2.HistoryUpdateRequest = exports2.HistoryReadResponse = exports2.HistoryReadResult = exports2.HistoryReadRequest = exports2.HistoryReadValueId = exports2.HistoryReadDetails = exports2.HistoryModifiedData = exports2.ModificationInfo = exports2._enumerationHistoryUpdateType = exports2.HistoryUpdateType = exports2.HistoryEvent = exports2.HistoryEventFieldList = exports2.HistoryData = exports2.GetEndpointsResponse = exports2.GetEndpointsRequest = exports2.GenericAttributes = exports2.GenericAttributeValue = exports2.Frame = exports2.FindServersResponse = exports2.FindServersRequest = exports2.FindServersOnNetworkResponse = exports2.ServerOnNetwork = exports2.FindServersOnNetworkRequest = exports2.FieldTargetDataType = exports2._enumerationOverrideValueHandling = exports2.OverrideValueHandling = exports2.EventNotificationList = exports2.EventFilterResult = exports2.EventFilter = exports2.EventFieldList = exports2.EphemeralKeyType = exports2.EndpointUrlListDataType = exports2.EndpointType = exports2.EndpointConfiguration = exports2.ElementOperand = exports2.DoubleComplexNumberType = exports2.DiscoveryConfiguration = exports2.DeleteSubscriptionsResponse = exports2.DeleteSubscriptionsRequest = exports2.DeleteReferencesResponse = exports2.DeleteReferencesRequest = exports2.DeleteReferencesItem = exports2.DeleteRawModifiedDetails = exports2.DeleteNodesResponse = exports2.DeleteNodesRequest = exports2.DeleteNodesItem = void 0;
    exports2.ReaderGroupDataType = exports2.WriterGroupDataType = exports2.PubSubGroupDataType = exports2.PublishedDataSetDataType = exports2.ProgramDiagnosticDataType = exports2.StatusResult = exports2.ProgramDiagnostic2DataType = exports2.PriorityMappingEntryType = exports2.PortableQualifiedName = exports2.PortableNodeId = exports2.ParsingResult = exports2.Orientation = exports2.OptionSet = exports2.OpenSecureChannelResponse = exports2.OpenSecureChannelRequest = exports2._enumerationSecurityTokenRequestType = exports2.SecurityTokenRequestType = exports2.ObjectTypeNode = exports2.ObjectTypeAttributes = exports2.ObjectNode = exports2.ObjectAttributes = exports2.NotificationMessage = exports2.NodeTypeDescription = exports2.QueryDataDescription = exports2.NodeReference = exports2.NetworkGroupDataType = exports2.NetworkAddressUrlDataType = exports2.NetworkAddressDataType = exports2.ModifySubscriptionResponse = exports2.ModifySubscriptionRequest = exports2.ModifyMonitoredItemsResponse = exports2.MonitoredItemModifyResult = exports2.ModifyMonitoredItemsRequest = exports2.MonitoredItemModifyRequest = exports2.ModelChangeStructureDataType = exports2.MethodNode = exports2.MethodAttributes = exports2.MdnsDiscoveryConfiguration = exports2.LiteralOperand = exports2.JsonWriterGroupMessageDataType = exports2.WriterGroupMessageDataType = exports2.JsonDataSetWriterMessageDataType = exports2.JsonDataSetReaderMessageDataType = exports2._enumerationJsonDataSetMessageContentMask = exports2.JsonDataSetMessageContentMask = exports2._enumerationJsonNetworkMessageContentMask = exports2.JsonNetworkMessageContentMask = exports2.IssuedIdentityToken = exports2.InstanceNode = exports2.IdentityMappingRuleType = void 0;
    exports2.RepublishRequest = exports2.RegisterServerResponse = exports2.RegisterServerRequest = exports2.RegisterServer2Response = exports2.RegisterServer2Request = exports2.RegisteredServer = exports2.RegisterNodesResponse = exports2.RegisterNodesRequest = exports2.ReferenceTypeNode = exports2.ReferenceTypeAttributes = exports2.RedundantServerDataType = exports2._enumerationServerState = exports2.ServerState = exports2.ReceiveQosPriorityDataType = exports2.ReceiveQosDataType = exports2.ReaderGroupTransportDataType = exports2.ReaderGroupMessageDataType = exports2.ReadResponse = exports2.ReadRequest = exports2.ReadRawModifiedDetails = exports2.ReadProcessedDetails = exports2.ReadEventDetails = exports2.ReadAtTimeDetails = exports2.ReadAnnotationDataDetails = exports2.RationalNumber = exports2.QueryNextResponse = exports2.QueryNextRequest = exports2.QueryFirstResponse = exports2.QueryFirstRequest = exports2.QueryDataSet = exports2.QosDataType = exports2.PublishedEventsDataType = exports2.PublishedDataSetCustomSourceDataType = exports2.PublishedDataItemsDataType = exports2.PublishedVariableDataType = exports2.PublishedDataSetSourceDataType = exports2.PublishResponse = exports2.PublishRequest = exports2.SubscriptionAcknowledgement = exports2.PubSubConfigurationValueDataType = exports2.PubSubConfigurationRefDataType = exports2._enumerationPubSubConfigurationRefMask = exports2.PubSubConfigurationRefMask = exports2.PubSubConfiguration2DataType = exports2.PubSubKeyPushTargetDataType = exports2.SecurityGroupDataType = exports2.StandaloneSubscribedDataSetDataType = exports2.SubscribedDataSetDataType = exports2.PubSubConfigurationDataType = exports2.PubSubConnectionDataType = void 0;
    exports2.UnsignedRationalNumber = exports2.UnregisterNodesResponse = exports2.UnregisterNodesRequest = exports2.Union = exports2.UadpWriterGroupMessageDataType = exports2._enumerationDataSetOrderingType = exports2.DataSetOrderingType = exports2.UadpDataSetWriterMessageDataType = exports2.UadpDataSetReaderMessageDataType = exports2._enumerationUadpDataSetMessageContentMask = exports2.UadpDataSetMessageContentMask = exports2._enumerationUadpNetworkMessageContentMask = exports2.UadpNetworkMessageContentMask = exports2.UABinaryFileDataType = exports2.TrustListDataType = exports2.TransmitQosPriorityDataType = exports2.TransmitQosDataType = exports2.TranslateBrowsePathsToNodeIdsResponse = exports2.TranslateBrowsePathsToNodeIdsRequest = exports2.TransferSubscriptionsResponse = exports2.TransferSubscriptionsRequest = exports2.TransferResult = exports2.TimeZoneDataType = exports2.ThreeDVector = exports2.Vector = exports2.ThreeDFrame = exports2.ThreeDOrientation = exports2.ThreeDCartesianCoordinates = exports2.TargetVariablesDataType = exports2.SubscriptionDiagnosticsDataType = exports2.SubscribedDataSetMirrorDataType = exports2.StatusChangeNotification = exports2.StandaloneSubscribedDataSetRefDataType = exports2.SetTriggeringResponse = exports2.SetTriggeringRequest = exports2.SetPublishingModeResponse = exports2.SetPublishingModeRequest = exports2.SetMonitoringModeResponse = exports2.SetMonitoringModeRequest = exports2.SessionlessInvokeResponseType = exports2.SessionlessInvokeRequestType = exports2.SessionSecurityDiagnosticsDataType = exports2.SessionDiagnosticsDataType = exports2.ServiceFault = exports2.ServiceCounterDataType = exports2.ServerStatusDataType = exports2.ServerDiagnosticsSummaryDataType = exports2.SemanticChangeStructureDataType = exports2.SamplingIntervalDiagnosticsDataType = exports2.RepublishResponse = void 0;
    exports2.XVType = exports2.X509IdentityToken = exports2.WriteResponse = exports2.WriteRequest = exports2.WriteValue = exports2.ViewNode = exports2.ViewAttributes = exports2.VariableTypeNode = exports2.VariableTypeAttributes = exports2.VariableNode = exports2.VariableAttributes = exports2.UserNameIdentityToken = exports2.UserManagementDataType = exports2._enumerationUserConfigurationMask = exports2.UserConfigurationMask = exports2.UpdateStructureDataDetails = exports2.UpdateEventDetails = exports2.UpdateDataDetails = exports2._enumerationPerformUpdateType = exports2.PerformUpdateType = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_extension_object_1 = require_dist30();
    var node_opcua_factory_1 = require_dist26();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_numeric_range_1 = require_dist31();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_variant_1 = require_dist28();
    var schemaEUInformation = (0, node_opcua_factory_1.buildStructuredType)({
      name: "EUInformation",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "NamespaceUri",
          fieldType: "String"
        },
        {
          name: "UnitId",
          fieldType: "Int32"
        },
        {
          name: "DisplayName",
          fieldType: "LocalizedText"
        },
        {
          name: "Description",
          fieldType: "LocalizedText"
        }
      ]
    });
    var EUInformation = class _EUInformation extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaEUInformation;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.namespaceUri = null;
          this.unitId = 0;
          this.displayName = new node_opcua_data_model_1.LocalizedText(null);
          this.description = new node_opcua_data_model_1.LocalizedText(null);
          return;
        }
        const schema = _EUInformation.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.namespaceUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.namespaceUri);
        this.unitId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.unitId);
        this.displayName = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.displayName);
        this.description = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.description);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.namespaceUri, stream);
        (0, node_opcua_basic_types_1.encodeInt32)(this.unitId, stream);
        (0, node_opcua_data_model_1.encodeLocalizedText)(this.displayName, stream);
        (0, node_opcua_data_model_1.encodeLocalizedText)(this.description, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.namespaceUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.namespaceUri);
        this.unitId = (0, node_opcua_basic_types_1.decodeInt32)(stream, this.unitId);
        this.displayName = (0, node_opcua_data_model_1.decodeLocalizedText)(stream, this.displayName);
        this.description = (0, node_opcua_data_model_1.decodeLocalizedText)(stream, this.description);
      }
      get schema() {
        return schemaEUInformation;
      }
    };
    exports2.EUInformation = EUInformation;
    EUInformation.possibleFields = [
      "namespaceUri",
      "unitId",
      "displayName",
      "description"
    ];
    EUInformation.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(887, 0);
    EUInformation.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(889, 0);
    EUInformation.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(888, 0);
    EUInformation.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15376, 0);
    EUInformation.schema.dataTypeNodeId = EUInformation.dataTypeNodeId;
    EUInformation.schema.encodingDefaultBinary = EUInformation.encodingDefaultBinary;
    EUInformation.schema.encodingDefaultXml = EUInformation.encodingDefaultXml;
    EUInformation.schema.encodingDefaultJson = EUInformation.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(EUInformation.dataTypeNodeId, "EUInformation", EUInformation);
    var schemaRange = (0, node_opcua_factory_1.buildStructuredType)({
      name: "Range",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Low",
          fieldType: "Double"
        },
        {
          name: "High",
          fieldType: "Double"
        }
      ]
    });
    var Range = class _Range extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaRange;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.low = 0;
          this.high = 0;
          return;
        }
        const schema = _Range.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.low = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.low);
        this.high = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.high);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.low, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.high, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.low = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.low);
        this.high = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.high);
      }
      get schema() {
        return schemaRange;
      }
    };
    exports2.Range = Range;
    Range.possibleFields = [
      "low",
      "high"
    ];
    Range.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(884, 0);
    Range.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(886, 0);
    Range.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(885, 0);
    Range.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15375, 0);
    Range.schema.dataTypeNodeId = Range.dataTypeNodeId;
    Range.schema.encodingDefaultBinary = Range.encodingDefaultBinary;
    Range.schema.encodingDefaultXml = Range.encodingDefaultXml;
    Range.schema.encodingDefaultJson = Range.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(Range.dataTypeNodeId, "Range", Range);
    var AxisScaleEnumeration;
    (function(AxisScaleEnumeration2) {
      AxisScaleEnumeration2[AxisScaleEnumeration2["Linear"] = 0] = "Linear";
      AxisScaleEnumeration2[AxisScaleEnumeration2["Log"] = 1] = "Log";
      AxisScaleEnumeration2[AxisScaleEnumeration2["Ln"] = 2] = "Ln";
      AxisScaleEnumeration2[AxisScaleEnumeration2["Invalid"] = 4294967295] = "Invalid";
    })(AxisScaleEnumeration || (exports2.AxisScaleEnumeration = AxisScaleEnumeration = {}));
    var schemaAxisScaleEnumeration = {
      enumValues: AxisScaleEnumeration,
      flaggable: false,
      minValue: 0,
      maxValue: 2,
      name: "AxisScaleEnumeration"
    };
    function decodeAxisScaleEnumeration(stream, _value) {
      let value = stream.readUInt32();
      value = value < schemaAxisScaleEnumeration.minValue || value > schemaAxisScaleEnumeration.maxValue ? AxisScaleEnumeration.Invalid : value;
      return value;
    }
    function encodeAxisScaleEnumeration(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationAxisScaleEnumeration = (0, node_opcua_factory_1.registerEnumeration)(schemaAxisScaleEnumeration);
    (0, node_opcua_assert_1.assert)(exports2._enumerationAxisScaleEnumeration.isFlaggable === false);
    var schemaAxisInformation = (0, node_opcua_factory_1.buildStructuredType)({
      name: "AxisInformation",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "EngineeringUnits",
          fieldType: "EUInformation"
        },
        {
          name: "EURange",
          fieldType: "Range"
        },
        {
          name: "Title",
          fieldType: "LocalizedText"
        },
        {
          name: "AxisScaleType",
          fieldType: "AxisScaleEnumeration"
        },
        {
          name: "AxisSteps",
          fieldType: "Double",
          isArray: true
        }
      ]
    });
    var AxisInformation = class _AxisInformation extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaAxisInformation;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.engineeringUnits = new EUInformation(null);
          this.euRange = new Range(null);
          this.title = new node_opcua_data_model_1.LocalizedText(null);
          this.axisScaleType = 0;
          this.axisSteps = [];
          return;
        }
        const schema = _AxisInformation.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.engineeringUnits = new EUInformation(options.engineeringUnits);
        this.euRange = new Range(options.euRange);
        this.title = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.title);
        this.axisScaleType = this.setAxisScaleType((0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.axisScaleType));
        this.axisSteps = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[4], options?.axisSteps);
      }
      encode(stream) {
        super.encode(stream);
        this.engineeringUnits.encode(stream);
        this.euRange.encode(stream);
        (0, node_opcua_data_model_1.encodeLocalizedText)(this.title, stream);
        encodeAxisScaleEnumeration(this.axisScaleType, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.axisSteps, stream, node_opcua_basic_types_1.encodeDouble);
      }
      decode(stream) {
        super.decode(stream);
        this.engineeringUnits.decode(stream);
        this.euRange.decode(stream);
        this.title = (0, node_opcua_data_model_1.decodeLocalizedText)(stream, this.title);
        this.axisScaleType = decodeAxisScaleEnumeration(stream, this.axisScaleType);
        this.axisSteps = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeDouble);
      }
      // Define Enumeration setters
      setAxisScaleType(value) {
        const coercedValue = exports2._enumerationAxisScaleEnumeration.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to AxisScaleEnumeration :" + value);
        }
        this.axisScaleType = coercedValue.value;
        return this.axisScaleType;
      }
      get schema() {
        return schemaAxisInformation;
      }
    };
    exports2.AxisInformation = AxisInformation;
    AxisInformation.possibleFields = [
      "engineeringUnits",
      "euRange",
      "title",
      "axisScaleType",
      "axisSteps"
    ];
    AxisInformation.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12079, 0);
    AxisInformation.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12089, 0);
    AxisInformation.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12081, 0);
    AxisInformation.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15379, 0);
    AxisInformation.schema.dataTypeNodeId = AxisInformation.dataTypeNodeId;
    AxisInformation.schema.encodingDefaultBinary = AxisInformation.encodingDefaultBinary;
    AxisInformation.schema.encodingDefaultXml = AxisInformation.encodingDefaultXml;
    AxisInformation.schema.encodingDefaultJson = AxisInformation.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(AxisInformation.dataTypeNodeId, "AxisInformation", AxisInformation);
    var schemaFilterOperand = (0, node_opcua_factory_1.buildStructuredType)({
      name: "FilterOperand",
      baseType: "ExtensionObject",
      fields: []
    });
    var FilterOperand = class _FilterOperand extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaFilterOperand;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _FilterOperand.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaFilterOperand;
      }
    };
    exports2.FilterOperand = FilterOperand;
    FilterOperand.possibleFields = [];
    FilterOperand.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(589, 0);
    FilterOperand.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(591, 0);
    FilterOperand.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(590, 0);
    FilterOperand.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15206, 0);
    FilterOperand.schema.dataTypeNodeId = FilterOperand.dataTypeNodeId;
    FilterOperand.schema.encodingDefaultBinary = FilterOperand.encodingDefaultBinary;
    FilterOperand.schema.encodingDefaultXml = FilterOperand.encodingDefaultXml;
    FilterOperand.schema.encodingDefaultJson = FilterOperand.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(FilterOperand.dataTypeNodeId, "FilterOperand", FilterOperand);
    var schemaSimpleAttributeOperand = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SimpleAttributeOperand",
      baseType: "FilterOperand",
      fields: [
        {
          name: "TypeDefinitionId",
          fieldType: "NodeId"
        },
        {
          name: "BrowsePath",
          fieldType: "QualifiedName",
          isArray: true
        },
        {
          name: "AttributeId",
          fieldType: "UInt32"
        },
        {
          name: "IndexRange",
          fieldType: "NumericRange"
        }
      ]
    });
    var SimpleAttributeOperand = class _SimpleAttributeOperand extends FilterOperand {
      static get schema() {
        return schemaSimpleAttributeOperand;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.typeDefinitionId = new node_opcua_nodeid_1.NodeId(null);
          this.browsePath = [];
          this.attributeId = 0;
          this.indexRange = new node_opcua_numeric_range_1.NumericRange(null);
          return;
        }
        const schema = _SimpleAttributeOperand.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.typeDefinitionId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.typeDefinitionId);
        this.browsePath = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.browsePath);
        this.attributeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.attributeId);
        this.indexRange = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.indexRange);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.typeDefinitionId, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.browsePath, stream, node_opcua_data_model_1.encodeQualifiedName);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.attributeId, stream);
        (0, node_opcua_numeric_range_1.encodeNumericRange)(this.indexRange, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.typeDefinitionId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.typeDefinitionId);
        this.browsePath = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeQualifiedName);
        this.attributeId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.attributeId);
        this.indexRange = (0, node_opcua_numeric_range_1.decodeNumericRange)(stream, this.indexRange);
      }
      get schema() {
        return schemaSimpleAttributeOperand;
      }
    };
    exports2.SimpleAttributeOperand = SimpleAttributeOperand;
    SimpleAttributeOperand.possibleFields = [
      "typeDefinitionId",
      "browsePath",
      "attributeId",
      "indexRange"
    ];
    SimpleAttributeOperand.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(601, 0);
    SimpleAttributeOperand.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(603, 0);
    SimpleAttributeOperand.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(602, 0);
    SimpleAttributeOperand.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15210, 0);
    SimpleAttributeOperand.schema.dataTypeNodeId = SimpleAttributeOperand.dataTypeNodeId;
    SimpleAttributeOperand.schema.encodingDefaultBinary = SimpleAttributeOperand.encodingDefaultBinary;
    SimpleAttributeOperand.schema.encodingDefaultXml = SimpleAttributeOperand.encodingDefaultXml;
    SimpleAttributeOperand.schema.encodingDefaultJson = SimpleAttributeOperand.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(SimpleAttributeOperand.dataTypeNodeId, "SimpleAttributeOperand", SimpleAttributeOperand);
    var schemaRequestHeader = (0, node_opcua_factory_1.buildStructuredType)({
      name: "RequestHeader",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "AuthenticationToken",
          fieldType: "NodeId"
        },
        {
          name: "Timestamp",
          fieldType: "DateTime"
        },
        {
          name: "RequestHandle",
          fieldType: "UInt32"
        },
        {
          name: "ReturnDiagnostics",
          fieldType: "UInt32"
        },
        {
          name: "AuditEntryId",
          fieldType: "String"
        },
        {
          name: "TimeoutHint",
          fieldType: "UInt32"
        },
        {
          name: "AdditionalHeader",
          fieldType: "ExtensionObject"
        }
      ]
    });
    var RequestHeader = class _RequestHeader extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaRequestHeader;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.authenticationToken = new node_opcua_nodeid_1.NodeId(null);
          this.timestamp = /* @__PURE__ */ new Date();
          this.requestHandle = 0;
          this.returnDiagnostics = 0;
          this.auditEntryId = null;
          this.timeoutHint = 0;
          this.additionalHeader = null;
          return;
        }
        const schema = _RequestHeader.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.authenticationToken = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.authenticationToken);
        this.timestamp = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.timestamp);
        this.requestHandle = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.requestHandle);
        this.returnDiagnostics = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.returnDiagnostics);
        this.auditEntryId = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.auditEntryId);
        this.timeoutHint = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.timeoutHint);
        this.additionalHeader = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.additionalHeader);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.authenticationToken, stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.timestamp, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.requestHandle, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.returnDiagnostics, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.auditEntryId, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.timeoutHint, stream);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.additionalHeader, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.authenticationToken = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.authenticationToken);
        this.timestamp = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.timestamp);
        this.requestHandle = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.requestHandle);
        this.returnDiagnostics = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.returnDiagnostics);
        this.auditEntryId = (0, node_opcua_basic_types_1.decodeString)(stream, this.auditEntryId);
        this.timeoutHint = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.timeoutHint);
        this.additionalHeader = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.additionalHeader);
      }
      get schema() {
        return schemaRequestHeader;
      }
    };
    exports2.RequestHeader = RequestHeader;
    RequestHeader.possibleFields = [
      "authenticationToken",
      "timestamp",
      "requestHandle",
      "returnDiagnostics",
      "auditEntryId",
      "timeoutHint",
      "additionalHeader"
    ];
    RequestHeader.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(389, 0);
    RequestHeader.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(391, 0);
    RequestHeader.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(390, 0);
    RequestHeader.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15088, 0);
    RequestHeader.schema.dataTypeNodeId = RequestHeader.dataTypeNodeId;
    RequestHeader.schema.encodingDefaultBinary = RequestHeader.encodingDefaultBinary;
    RequestHeader.schema.encodingDefaultXml = RequestHeader.encodingDefaultXml;
    RequestHeader.schema.encodingDefaultJson = RequestHeader.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(RequestHeader.dataTypeNodeId, "RequestHeader", RequestHeader);
    var schemaSignatureData = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SignatureData",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Algorithm",
          fieldType: "String"
        },
        {
          name: "Signature",
          fieldType: "ByteString"
        }
      ]
    });
    var SignatureData = class _SignatureData extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaSignatureData;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.algorithm = null;
          this.signature = Buffer.alloc(0);
          return;
        }
        const schema = _SignatureData.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.algorithm = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.algorithm);
        this.signature = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.signature);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.algorithm, stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.signature, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.algorithm = (0, node_opcua_basic_types_1.decodeString)(stream, this.algorithm);
        this.signature = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.signature);
      }
      get schema() {
        return schemaSignatureData;
      }
    };
    exports2.SignatureData = SignatureData;
    SignatureData.possibleFields = [
      "algorithm",
      "signature"
    ];
    SignatureData.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(456, 0);
    SignatureData.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(458, 0);
    SignatureData.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(457, 0);
    SignatureData.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15137, 0);
    SignatureData.schema.dataTypeNodeId = SignatureData.dataTypeNodeId;
    SignatureData.schema.encodingDefaultBinary = SignatureData.encodingDefaultBinary;
    SignatureData.schema.encodingDefaultXml = SignatureData.encodingDefaultXml;
    SignatureData.schema.encodingDefaultJson = SignatureData.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(SignatureData.dataTypeNodeId, "SignatureData", SignatureData);
    var schemaSignedSoftwareCertificate = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SignedSoftwareCertificate",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "CertificateData",
          fieldType: "ByteString"
        },
        {
          name: "Signature",
          fieldType: "ByteString"
        }
      ]
    });
    var SignedSoftwareCertificate = class _SignedSoftwareCertificate extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaSignedSoftwareCertificate;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.certificateData = Buffer.alloc(0);
          this.signature = Buffer.alloc(0);
          return;
        }
        const schema = _SignedSoftwareCertificate.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.certificateData = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.certificateData);
        this.signature = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.signature);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.certificateData, stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.signature, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.certificateData = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.certificateData);
        this.signature = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.signature);
      }
      get schema() {
        return schemaSignedSoftwareCertificate;
      }
    };
    exports2.SignedSoftwareCertificate = SignedSoftwareCertificate;
    SignedSoftwareCertificate.possibleFields = [
      "certificateData",
      "signature"
    ];
    SignedSoftwareCertificate.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(344, 0);
    SignedSoftwareCertificate.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(346, 0);
    SignedSoftwareCertificate.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(345, 0);
    SignedSoftwareCertificate.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15136, 0);
    SignedSoftwareCertificate.schema.dataTypeNodeId = SignedSoftwareCertificate.dataTypeNodeId;
    SignedSoftwareCertificate.schema.encodingDefaultBinary = SignedSoftwareCertificate.encodingDefaultBinary;
    SignedSoftwareCertificate.schema.encodingDefaultXml = SignedSoftwareCertificate.encodingDefaultXml;
    SignedSoftwareCertificate.schema.encodingDefaultJson = SignedSoftwareCertificate.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(SignedSoftwareCertificate.dataTypeNodeId, "SignedSoftwareCertificate", SignedSoftwareCertificate);
    var schemaActivateSessionRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ActivateSessionRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "ClientSignature",
          fieldType: "SignatureData"
        },
        {
          name: "ClientSoftwareCertificates",
          fieldType: "SignedSoftwareCertificate",
          isArray: true
        },
        {
          name: "LocaleIds",
          fieldType: "String",
          isArray: true
        },
        {
          name: "UserIdentityToken",
          fieldType: "ExtensionObject"
        },
        {
          name: "UserTokenSignature",
          fieldType: "SignatureData"
        }
      ]
    });
    var ActivateSessionRequest = class _ActivateSessionRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaActivateSessionRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.clientSignature = new SignatureData(null);
          this.clientSoftwareCertificates = null;
          this.localeIds = [];
          this.userIdentityToken = null;
          this.userTokenSignature = new SignatureData(null);
          return;
        }
        const schema = _ActivateSessionRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.clientSignature = new SignatureData(options.clientSignature);
        this.clientSoftwareCertificates = [];
        if (options.clientSoftwareCertificates) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.clientSoftwareCertificates));
          this.clientSoftwareCertificates = options.clientSoftwareCertificates.map((e) => new SignedSoftwareCertificate(e));
        }
        this.localeIds = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[3], options?.localeIds);
        this.userIdentityToken = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.userIdentityToken);
        this.userTokenSignature = new SignatureData(options.userTokenSignature);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        this.clientSignature.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.clientSoftwareCertificates, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.localeIds, stream, node_opcua_basic_types_1.encodeString);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.userIdentityToken, stream);
        this.userTokenSignature.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.clientSignature.decode(stream);
        this.clientSoftwareCertificates = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new SignedSoftwareCertificate(null);
          obj.decode(stream1);
          return obj;
        });
        this.localeIds = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
        this.userIdentityToken = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.userIdentityToken);
        this.userTokenSignature.decode(stream);
      }
      get schema() {
        return schemaActivateSessionRequest;
      }
    };
    exports2.ActivateSessionRequest = ActivateSessionRequest;
    ActivateSessionRequest.possibleFields = [
      "requestHeader",
      "clientSignature",
      "clientSoftwareCertificates",
      "localeIds",
      "userIdentityToken",
      "userTokenSignature"
    ];
    ActivateSessionRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(465, 0);
    ActivateSessionRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(467, 0);
    ActivateSessionRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(466, 0);
    ActivateSessionRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15145, 0);
    ActivateSessionRequest.schema.dataTypeNodeId = ActivateSessionRequest.dataTypeNodeId;
    ActivateSessionRequest.schema.encodingDefaultBinary = ActivateSessionRequest.encodingDefaultBinary;
    ActivateSessionRequest.schema.encodingDefaultXml = ActivateSessionRequest.encodingDefaultXml;
    ActivateSessionRequest.schema.encodingDefaultJson = ActivateSessionRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ActivateSessionRequest.dataTypeNodeId, "ActivateSessionRequest", ActivateSessionRequest);
    var schemaResponseHeader = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ResponseHeader",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Timestamp",
          fieldType: "DateTime"
        },
        {
          name: "RequestHandle",
          fieldType: "UInt32"
        },
        {
          name: "ServiceResult",
          fieldType: "StatusCode"
        },
        {
          name: "ServiceDiagnostics",
          fieldType: "DiagnosticInfo"
        },
        {
          name: "StringTable",
          fieldType: "String",
          isArray: true
        },
        {
          name: "AdditionalHeader",
          fieldType: "ExtensionObject"
        }
      ]
    });
    var ResponseHeader = class _ResponseHeader extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaResponseHeader;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.timestamp = /* @__PURE__ */ new Date();
          this.requestHandle = 0;
          this.serviceResult = node_opcua_status_code_1.StatusCodes.Good;
          this.serviceDiagnostics = null;
          this.stringTable = [];
          this.additionalHeader = null;
          return;
        }
        const schema = _ResponseHeader.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.timestamp = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.timestamp);
        this.requestHandle = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.requestHandle);
        this.serviceResult = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.serviceResult);
        this.serviceDiagnostics = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.serviceDiagnostics);
        this.stringTable = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[4], options?.stringTable);
        this.additionalHeader = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.additionalHeader);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.timestamp, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.requestHandle, stream);
        (0, node_opcua_status_code_1.encodeStatusCode)(this.serviceResult, stream);
        (0, node_opcua_data_model_1.encodeDiagnosticInfo)(this.serviceDiagnostics, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.stringTable, stream, node_opcua_basic_types_1.encodeString);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.additionalHeader, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.timestamp = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.timestamp);
        this.requestHandle = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.requestHandle);
        this.serviceResult = (0, node_opcua_status_code_1.decodeStatusCode)(stream, this.serviceResult);
        this.serviceDiagnostics = (0, node_opcua_data_model_1.decodeDiagnosticInfo)(stream, this.serviceDiagnostics);
        this.stringTable = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
        this.additionalHeader = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.additionalHeader);
      }
      get schema() {
        return schemaResponseHeader;
      }
    };
    exports2.ResponseHeader = ResponseHeader;
    ResponseHeader.possibleFields = [
      "timestamp",
      "requestHandle",
      "serviceResult",
      "serviceDiagnostics",
      "stringTable",
      "additionalHeader"
    ];
    ResponseHeader.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(392, 0);
    ResponseHeader.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(394, 0);
    ResponseHeader.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(393, 0);
    ResponseHeader.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15089, 0);
    ResponseHeader.schema.dataTypeNodeId = ResponseHeader.dataTypeNodeId;
    ResponseHeader.schema.encodingDefaultBinary = ResponseHeader.encodingDefaultBinary;
    ResponseHeader.schema.encodingDefaultXml = ResponseHeader.encodingDefaultXml;
    ResponseHeader.schema.encodingDefaultJson = ResponseHeader.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ResponseHeader.dataTypeNodeId, "ResponseHeader", ResponseHeader);
    var schemaActivateSessionResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ActivateSessionResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "ServerNonce",
          fieldType: "ByteString"
        },
        {
          name: "Results",
          fieldType: "StatusCode",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var ActivateSessionResponse = class _ActivateSessionResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaActivateSessionResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.serverNonce = Buffer.alloc(0);
          this.results = [];
          this.diagnosticInfos = [];
          return;
        }
        const schema = _ActivateSessionResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.serverNonce = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.serverNonce);
        this.results = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.results);
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[3], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.serverNonce, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.results, stream, node_opcua_status_code_1.encodeStatusCode);
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.serverNonce = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.serverNonce);
        this.results = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_status_code_1.decodeStatusCode);
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaActivateSessionResponse;
      }
    };
    exports2.ActivateSessionResponse = ActivateSessionResponse;
    ActivateSessionResponse.possibleFields = [
      "responseHeader",
      "serverNonce",
      "results",
      "diagnosticInfos"
    ];
    ActivateSessionResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(468, 0);
    ActivateSessionResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(470, 0);
    ActivateSessionResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(469, 0);
    ActivateSessionResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15146, 0);
    ActivateSessionResponse.schema.dataTypeNodeId = ActivateSessionResponse.dataTypeNodeId;
    ActivateSessionResponse.schema.encodingDefaultBinary = ActivateSessionResponse.encodingDefaultBinary;
    ActivateSessionResponse.schema.encodingDefaultXml = ActivateSessionResponse.encodingDefaultXml;
    ActivateSessionResponse.schema.encodingDefaultJson = ActivateSessionResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ActivateSessionResponse.dataTypeNodeId, "ActivateSessionResponse", ActivateSessionResponse);
    var NodeClass;
    (function(NodeClass2) {
      NodeClass2[NodeClass2["Unspecified"] = 0] = "Unspecified";
      NodeClass2[NodeClass2["Object"] = 1] = "Object";
      NodeClass2[NodeClass2["Variable"] = 2] = "Variable";
      NodeClass2[NodeClass2["Method"] = 4] = "Method";
      NodeClass2[NodeClass2["ObjectType"] = 8] = "ObjectType";
      NodeClass2[NodeClass2["VariableType"] = 16] = "VariableType";
      NodeClass2[NodeClass2["ReferenceType"] = 32] = "ReferenceType";
      NodeClass2[NodeClass2["DataType"] = 64] = "DataType";
      NodeClass2[NodeClass2["View"] = 128] = "View";
    })(NodeClass || (exports2.NodeClass = NodeClass = {}));
    var schemaNodeClass = {
      enumValues: NodeClass,
      flaggable: true,
      name: "NodeClass"
    };
    function decodeNodeClass(stream, _value) {
      return stream.readUInt32();
    }
    function encodeNodeClass(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationNodeClass = (0, node_opcua_factory_1.registerEnumeration)(schemaNodeClass);
    (0, node_opcua_assert_1.assert)(exports2._enumerationNodeClass.isFlaggable === true);
    var schemaAddNodesItem = (0, node_opcua_factory_1.buildStructuredType)({
      name: "AddNodesItem",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ParentNodeId",
          fieldType: "ExpandedNodeId"
        },
        {
          name: "ReferenceTypeId",
          fieldType: "NodeId"
        },
        {
          name: "RequestedNewNodeId",
          fieldType: "ExpandedNodeId"
        },
        {
          name: "BrowseName",
          fieldType: "QualifiedName"
        },
        {
          name: "NodeClass",
          fieldType: "NodeClass"
        },
        {
          name: "NodeAttributes",
          fieldType: "ExtensionObject"
        },
        {
          name: "TypeDefinition",
          fieldType: "ExpandedNodeId"
        }
      ]
    });
    var AddNodesItem = class _AddNodesItem extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaAddNodesItem;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.parentNodeId = new node_opcua_nodeid_1.ExpandedNodeId(null);
          this.referenceTypeId = new node_opcua_nodeid_1.NodeId(null);
          this.requestedNewNodeId = new node_opcua_nodeid_1.ExpandedNodeId(null);
          this.browseName = new node_opcua_data_model_1.QualifiedName(null);
          this.nodeClass = 0;
          this.nodeAttributes = null;
          this.typeDefinition = new node_opcua_nodeid_1.ExpandedNodeId(null);
          return;
        }
        const schema = _AddNodesItem.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.parentNodeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.parentNodeId);
        this.referenceTypeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.referenceTypeId);
        this.requestedNewNodeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.requestedNewNodeId);
        this.browseName = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.browseName);
        this.nodeClass = this.setNodeClass((0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.nodeClass));
        this.nodeAttributes = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.nodeAttributes);
        this.typeDefinition = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.typeDefinition);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeExpandedNodeId)(this.parentNodeId, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.referenceTypeId, stream);
        (0, node_opcua_basic_types_1.encodeExpandedNodeId)(this.requestedNewNodeId, stream);
        (0, node_opcua_data_model_1.encodeQualifiedName)(this.browseName, stream);
        encodeNodeClass(this.nodeClass, stream);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.nodeAttributes, stream);
        (0, node_opcua_basic_types_1.encodeExpandedNodeId)(this.typeDefinition, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.parentNodeId = (0, node_opcua_basic_types_1.decodeExpandedNodeId)(stream, this.parentNodeId);
        this.referenceTypeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.referenceTypeId);
        this.requestedNewNodeId = (0, node_opcua_basic_types_1.decodeExpandedNodeId)(stream, this.requestedNewNodeId);
        this.browseName = (0, node_opcua_data_model_1.decodeQualifiedName)(stream, this.browseName);
        this.nodeClass = decodeNodeClass(stream, this.nodeClass);
        this.nodeAttributes = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.nodeAttributes);
        this.typeDefinition = (0, node_opcua_basic_types_1.decodeExpandedNodeId)(stream, this.typeDefinition);
      }
      // Define Enumeration setters
      setNodeClass(value) {
        const coercedValue = exports2._enumerationNodeClass.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to NodeClass :" + value);
        }
        this.nodeClass = coercedValue.value;
        return this.nodeClass;
      }
      get schema() {
        return schemaAddNodesItem;
      }
    };
    exports2.AddNodesItem = AddNodesItem;
    AddNodesItem.possibleFields = [
      "parentNodeId",
      "referenceTypeId",
      "requestedNewNodeId",
      "browseName",
      "nodeClass",
      "nodeAttributes",
      "typeDefinition"
    ];
    AddNodesItem.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(376, 0);
    AddNodesItem.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(378, 0);
    AddNodesItem.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(377, 0);
    AddNodesItem.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15165, 0);
    AddNodesItem.schema.dataTypeNodeId = AddNodesItem.dataTypeNodeId;
    AddNodesItem.schema.encodingDefaultBinary = AddNodesItem.encodingDefaultBinary;
    AddNodesItem.schema.encodingDefaultXml = AddNodesItem.encodingDefaultXml;
    AddNodesItem.schema.encodingDefaultJson = AddNodesItem.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(AddNodesItem.dataTypeNodeId, "AddNodesItem", AddNodesItem);
    var schemaAddNodesRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "AddNodesRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "NodesToAdd",
          fieldType: "AddNodesItem",
          isArray: true
        }
      ]
    });
    var AddNodesRequest = class _AddNodesRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaAddNodesRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.nodesToAdd = null;
          return;
        }
        const schema = _AddNodesRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.nodesToAdd = [];
        if (options.nodesToAdd) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.nodesToAdd));
          this.nodesToAdd = options.nodesToAdd.map((e) => new AddNodesItem(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.nodesToAdd, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.nodesToAdd = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new AddNodesItem(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaAddNodesRequest;
      }
    };
    exports2.AddNodesRequest = AddNodesRequest;
    AddNodesRequest.possibleFields = [
      "requestHeader",
      "nodesToAdd"
    ];
    AddNodesRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(486, 0);
    AddNodesRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(488, 0);
    AddNodesRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(487, 0);
    AddNodesRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15167, 0);
    AddNodesRequest.schema.dataTypeNodeId = AddNodesRequest.dataTypeNodeId;
    AddNodesRequest.schema.encodingDefaultBinary = AddNodesRequest.encodingDefaultBinary;
    AddNodesRequest.schema.encodingDefaultXml = AddNodesRequest.encodingDefaultXml;
    AddNodesRequest.schema.encodingDefaultJson = AddNodesRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(AddNodesRequest.dataTypeNodeId, "AddNodesRequest", AddNodesRequest);
    var schemaAddNodesResult = (0, node_opcua_factory_1.buildStructuredType)({
      name: "AddNodesResult",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "StatusCode",
          fieldType: "StatusCode"
        },
        {
          name: "AddedNodeId",
          fieldType: "NodeId"
        }
      ]
    });
    var AddNodesResult = class _AddNodesResult extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaAddNodesResult;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.statusCode = node_opcua_status_code_1.StatusCodes.Good;
          this.addedNodeId = new node_opcua_nodeid_1.NodeId(null);
          return;
        }
        const schema = _AddNodesResult.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.statusCode = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.statusCode);
        this.addedNodeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.addedNodeId);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_status_code_1.encodeStatusCode)(this.statusCode, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.addedNodeId, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.statusCode = (0, node_opcua_status_code_1.decodeStatusCode)(stream, this.statusCode);
        this.addedNodeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.addedNodeId);
      }
      get schema() {
        return schemaAddNodesResult;
      }
    };
    exports2.AddNodesResult = AddNodesResult;
    AddNodesResult.possibleFields = [
      "statusCode",
      "addedNodeId"
    ];
    AddNodesResult.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(483, 0);
    AddNodesResult.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(485, 0);
    AddNodesResult.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(484, 0);
    AddNodesResult.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15166, 0);
    AddNodesResult.schema.dataTypeNodeId = AddNodesResult.dataTypeNodeId;
    AddNodesResult.schema.encodingDefaultBinary = AddNodesResult.encodingDefaultBinary;
    AddNodesResult.schema.encodingDefaultXml = AddNodesResult.encodingDefaultXml;
    AddNodesResult.schema.encodingDefaultJson = AddNodesResult.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(AddNodesResult.dataTypeNodeId, "AddNodesResult", AddNodesResult);
    var schemaAddNodesResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "AddNodesResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "Results",
          fieldType: "AddNodesResult",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var AddNodesResponse = class _AddNodesResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaAddNodesResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.results = null;
          this.diagnosticInfos = [];
          return;
        }
        const schema = _AddNodesResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.results = [];
        if (options.results) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.results));
          this.results = options.results.map((e) => new AddNodesResult(e));
        }
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.results, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.results = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new AddNodesResult(null);
          obj.decode(stream1);
          return obj;
        });
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaAddNodesResponse;
      }
    };
    exports2.AddNodesResponse = AddNodesResponse;
    AddNodesResponse.possibleFields = [
      "responseHeader",
      "results",
      "diagnosticInfos"
    ];
    AddNodesResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(489, 0);
    AddNodesResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(491, 0);
    AddNodesResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(490, 0);
    AddNodesResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15168, 0);
    AddNodesResponse.schema.dataTypeNodeId = AddNodesResponse.dataTypeNodeId;
    AddNodesResponse.schema.encodingDefaultBinary = AddNodesResponse.encodingDefaultBinary;
    AddNodesResponse.schema.encodingDefaultXml = AddNodesResponse.encodingDefaultXml;
    AddNodesResponse.schema.encodingDefaultJson = AddNodesResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(AddNodesResponse.dataTypeNodeId, "AddNodesResponse", AddNodesResponse);
    var schemaAddReferencesItem = (0, node_opcua_factory_1.buildStructuredType)({
      name: "AddReferencesItem",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "SourceNodeId",
          fieldType: "NodeId"
        },
        {
          name: "ReferenceTypeId",
          fieldType: "NodeId"
        },
        {
          name: "IsForward",
          fieldType: "Boolean"
        },
        {
          name: "TargetServerUri",
          fieldType: "String"
        },
        {
          name: "TargetNodeId",
          fieldType: "ExpandedNodeId"
        },
        {
          name: "TargetNodeClass",
          fieldType: "NodeClass"
        }
      ]
    });
    var AddReferencesItem = class _AddReferencesItem extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaAddReferencesItem;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.sourceNodeId = new node_opcua_nodeid_1.NodeId(null);
          this.referenceTypeId = new node_opcua_nodeid_1.NodeId(null);
          this.isForward = false;
          this.targetServerUri = null;
          this.targetNodeId = new node_opcua_nodeid_1.ExpandedNodeId(null);
          this.targetNodeClass = 0;
          return;
        }
        const schema = _AddReferencesItem.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.sourceNodeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.sourceNodeId);
        this.referenceTypeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.referenceTypeId);
        this.isForward = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.isForward);
        this.targetServerUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.targetServerUri);
        this.targetNodeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.targetNodeId);
        this.targetNodeClass = this.setTargetNodeClass((0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.targetNodeClass));
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.sourceNodeId, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.referenceTypeId, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.isForward, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.targetServerUri, stream);
        (0, node_opcua_basic_types_1.encodeExpandedNodeId)(this.targetNodeId, stream);
        encodeNodeClass(this.targetNodeClass, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.sourceNodeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.sourceNodeId);
        this.referenceTypeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.referenceTypeId);
        this.isForward = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.isForward);
        this.targetServerUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.targetServerUri);
        this.targetNodeId = (0, node_opcua_basic_types_1.decodeExpandedNodeId)(stream, this.targetNodeId);
        this.targetNodeClass = decodeNodeClass(stream, this.targetNodeClass);
      }
      // Define Enumeration setters
      setTargetNodeClass(value) {
        const coercedValue = exports2._enumerationNodeClass.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to NodeClass :" + value);
        }
        this.targetNodeClass = coercedValue.value;
        return this.targetNodeClass;
      }
      get schema() {
        return schemaAddReferencesItem;
      }
    };
    exports2.AddReferencesItem = AddReferencesItem;
    AddReferencesItem.possibleFields = [
      "sourceNodeId",
      "referenceTypeId",
      "isForward",
      "targetServerUri",
      "targetNodeId",
      "targetNodeClass"
    ];
    AddReferencesItem.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(379, 0);
    AddReferencesItem.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(381, 0);
    AddReferencesItem.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(380, 0);
    AddReferencesItem.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15169, 0);
    AddReferencesItem.schema.dataTypeNodeId = AddReferencesItem.dataTypeNodeId;
    AddReferencesItem.schema.encodingDefaultBinary = AddReferencesItem.encodingDefaultBinary;
    AddReferencesItem.schema.encodingDefaultXml = AddReferencesItem.encodingDefaultXml;
    AddReferencesItem.schema.encodingDefaultJson = AddReferencesItem.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(AddReferencesItem.dataTypeNodeId, "AddReferencesItem", AddReferencesItem);
    var schemaAddReferencesRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "AddReferencesRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "ReferencesToAdd",
          fieldType: "AddReferencesItem",
          isArray: true
        }
      ]
    });
    var AddReferencesRequest = class _AddReferencesRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaAddReferencesRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.referencesToAdd = null;
          return;
        }
        const schema = _AddReferencesRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.referencesToAdd = [];
        if (options.referencesToAdd) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.referencesToAdd));
          this.referencesToAdd = options.referencesToAdd.map((e) => new AddReferencesItem(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.referencesToAdd, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.referencesToAdd = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new AddReferencesItem(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaAddReferencesRequest;
      }
    };
    exports2.AddReferencesRequest = AddReferencesRequest;
    AddReferencesRequest.possibleFields = [
      "requestHeader",
      "referencesToAdd"
    ];
    AddReferencesRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(492, 0);
    AddReferencesRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(494, 0);
    AddReferencesRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(493, 0);
    AddReferencesRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15170, 0);
    AddReferencesRequest.schema.dataTypeNodeId = AddReferencesRequest.dataTypeNodeId;
    AddReferencesRequest.schema.encodingDefaultBinary = AddReferencesRequest.encodingDefaultBinary;
    AddReferencesRequest.schema.encodingDefaultXml = AddReferencesRequest.encodingDefaultXml;
    AddReferencesRequest.schema.encodingDefaultJson = AddReferencesRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(AddReferencesRequest.dataTypeNodeId, "AddReferencesRequest", AddReferencesRequest);
    var schemaAddReferencesResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "AddReferencesResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "Results",
          fieldType: "StatusCode",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var AddReferencesResponse = class _AddReferencesResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaAddReferencesResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.results = [];
          this.diagnosticInfos = [];
          return;
        }
        const schema = _AddReferencesResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.results = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.results);
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.results, stream, node_opcua_status_code_1.encodeStatusCode);
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.results = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_status_code_1.decodeStatusCode);
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaAddReferencesResponse;
      }
    };
    exports2.AddReferencesResponse = AddReferencesResponse;
    AddReferencesResponse.possibleFields = [
      "responseHeader",
      "results",
      "diagnosticInfos"
    ];
    AddReferencesResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(495, 0);
    AddReferencesResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(497, 0);
    AddReferencesResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(496, 0);
    AddReferencesResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15171, 0);
    AddReferencesResponse.schema.dataTypeNodeId = AddReferencesResponse.dataTypeNodeId;
    AddReferencesResponse.schema.encodingDefaultBinary = AddReferencesResponse.encodingDefaultBinary;
    AddReferencesResponse.schema.encodingDefaultXml = AddReferencesResponse.encodingDefaultXml;
    AddReferencesResponse.schema.encodingDefaultJson = AddReferencesResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(AddReferencesResponse.dataTypeNodeId, "AddReferencesResponse", AddReferencesResponse);
    var schemaKeyValuePair = (0, node_opcua_factory_1.buildStructuredType)({
      name: "KeyValuePair",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Key",
          fieldType: "QualifiedName"
        },
        {
          name: "Value",
          fieldType: "Variant"
        }
      ]
    });
    var KeyValuePair = class _KeyValuePair extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaKeyValuePair;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.key = new node_opcua_data_model_1.QualifiedName(null);
          this.value = new node_opcua_variant_1.Variant(null);
          return;
        }
        const schema = _KeyValuePair.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.key = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.key);
        this.value = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.value);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_data_model_1.encodeQualifiedName)(this.key, stream);
        (0, node_opcua_variant_1.encodeVariant)(this.value, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.key = (0, node_opcua_data_model_1.decodeQualifiedName)(stream, this.key);
        this.value = (0, node_opcua_variant_1.decodeVariant)(stream, this.value);
      }
      get schema() {
        return schemaKeyValuePair;
      }
    };
    exports2.KeyValuePair = KeyValuePair;
    KeyValuePair.possibleFields = [
      "key",
      "value"
    ];
    KeyValuePair.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14533, 0);
    KeyValuePair.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14846, 0);
    KeyValuePair.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14802, 0);
    KeyValuePair.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15041, 0);
    KeyValuePair.schema.dataTypeNodeId = KeyValuePair.dataTypeNodeId;
    KeyValuePair.schema.encodingDefaultBinary = KeyValuePair.encodingDefaultBinary;
    KeyValuePair.schema.encodingDefaultXml = KeyValuePair.encodingDefaultXml;
    KeyValuePair.schema.encodingDefaultJson = KeyValuePair.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(KeyValuePair.dataTypeNodeId, "KeyValuePair", KeyValuePair);
    var schemaAdditionalParametersType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "AdditionalParametersType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Parameters",
          fieldType: "KeyValuePair",
          isArray: true
        }
      ]
    });
    var AdditionalParametersType = class _AdditionalParametersType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaAdditionalParametersType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.parameters = null;
          return;
        }
        const schema = _AdditionalParametersType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.parameters = [];
        if (options.parameters) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.parameters));
          this.parameters = options.parameters.map((e) => new KeyValuePair(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.parameters, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.parameters = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new KeyValuePair(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaAdditionalParametersType;
      }
    };
    exports2.AdditionalParametersType = AdditionalParametersType;
    AdditionalParametersType.possibleFields = [
      "parameters"
    ];
    AdditionalParametersType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16313, 0);
    AdditionalParametersType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(17537, 0);
    AdditionalParametersType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(17541, 0);
    AdditionalParametersType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(17547, 0);
    AdditionalParametersType.schema.dataTypeNodeId = AdditionalParametersType.dataTypeNodeId;
    AdditionalParametersType.schema.encodingDefaultBinary = AdditionalParametersType.encodingDefaultBinary;
    AdditionalParametersType.schema.encodingDefaultXml = AdditionalParametersType.encodingDefaultXml;
    AdditionalParametersType.schema.encodingDefaultJson = AdditionalParametersType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(AdditionalParametersType.dataTypeNodeId, "AdditionalParametersType", AdditionalParametersType);
    var schemaAggregateConfiguration = (0, node_opcua_factory_1.buildStructuredType)({
      name: "AggregateConfiguration",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "UseServerCapabilitiesDefaults",
          fieldType: "Boolean"
        },
        {
          name: "TreatUncertainAsBad",
          fieldType: "Boolean"
        },
        {
          name: "PercentDataBad",
          fieldType: "Byte"
        },
        {
          name: "PercentDataGood",
          fieldType: "Byte"
        },
        {
          name: "UseSlopedExtrapolation",
          fieldType: "Boolean"
        }
      ]
    });
    var AggregateConfiguration = class _AggregateConfiguration extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaAggregateConfiguration;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.useServerCapabilitiesDefaults = false;
          this.treatUncertainAsBad = false;
          this.percentDataBad = 0;
          this.percentDataGood = 0;
          this.useSlopedExtrapolation = false;
          return;
        }
        const schema = _AggregateConfiguration.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.useServerCapabilitiesDefaults = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.useServerCapabilitiesDefaults);
        this.treatUncertainAsBad = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.treatUncertainAsBad);
        this.percentDataBad = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.percentDataBad);
        this.percentDataGood = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.percentDataGood);
        this.useSlopedExtrapolation = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.useSlopedExtrapolation);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.useServerCapabilitiesDefaults, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.treatUncertainAsBad, stream);
        (0, node_opcua_basic_types_1.encodeByte)(this.percentDataBad, stream);
        (0, node_opcua_basic_types_1.encodeByte)(this.percentDataGood, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.useSlopedExtrapolation, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.useServerCapabilitiesDefaults = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.useServerCapabilitiesDefaults);
        this.treatUncertainAsBad = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.treatUncertainAsBad);
        this.percentDataBad = (0, node_opcua_basic_types_1.decodeByte)(stream, this.percentDataBad);
        this.percentDataGood = (0, node_opcua_basic_types_1.decodeByte)(stream, this.percentDataGood);
        this.useSlopedExtrapolation = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.useSlopedExtrapolation);
      }
      get schema() {
        return schemaAggregateConfiguration;
      }
    };
    exports2.AggregateConfiguration = AggregateConfiguration;
    AggregateConfiguration.possibleFields = [
      "useServerCapabilitiesDefaults",
      "treatUncertainAsBad",
      "percentDataBad",
      "percentDataGood",
      "useSlopedExtrapolation"
    ];
    AggregateConfiguration.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(948, 0);
    AggregateConfiguration.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(950, 0);
    AggregateConfiguration.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(949, 0);
    AggregateConfiguration.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15304, 0);
    AggregateConfiguration.schema.dataTypeNodeId = AggregateConfiguration.dataTypeNodeId;
    AggregateConfiguration.schema.encodingDefaultBinary = AggregateConfiguration.encodingDefaultBinary;
    AggregateConfiguration.schema.encodingDefaultXml = AggregateConfiguration.encodingDefaultXml;
    AggregateConfiguration.schema.encodingDefaultJson = AggregateConfiguration.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(AggregateConfiguration.dataTypeNodeId, "AggregateConfiguration", AggregateConfiguration);
    var schemaMonitoringFilter = (0, node_opcua_factory_1.buildStructuredType)({
      name: "MonitoringFilter",
      baseType: "ExtensionObject",
      fields: []
    });
    var MonitoringFilter = class _MonitoringFilter extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaMonitoringFilter;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _MonitoringFilter.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaMonitoringFilter;
      }
    };
    exports2.MonitoringFilter = MonitoringFilter;
    MonitoringFilter.possibleFields = [];
    MonitoringFilter.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(719, 0);
    MonitoringFilter.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(721, 0);
    MonitoringFilter.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(720, 0);
    MonitoringFilter.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15293, 0);
    MonitoringFilter.schema.dataTypeNodeId = MonitoringFilter.dataTypeNodeId;
    MonitoringFilter.schema.encodingDefaultBinary = MonitoringFilter.encodingDefaultBinary;
    MonitoringFilter.schema.encodingDefaultXml = MonitoringFilter.encodingDefaultXml;
    MonitoringFilter.schema.encodingDefaultJson = MonitoringFilter.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(MonitoringFilter.dataTypeNodeId, "MonitoringFilter", MonitoringFilter);
    var schemaAggregateFilter = (0, node_opcua_factory_1.buildStructuredType)({
      name: "AggregateFilter",
      baseType: "MonitoringFilter",
      fields: [
        {
          name: "StartTime",
          fieldType: "DateTime"
        },
        {
          name: "AggregateType",
          fieldType: "NodeId"
        },
        {
          name: "ProcessingInterval",
          fieldType: "Double"
        },
        {
          name: "AggregateConfiguration",
          fieldType: "AggregateConfiguration"
        }
      ]
    });
    var AggregateFilter = class _AggregateFilter extends MonitoringFilter {
      static get schema() {
        return schemaAggregateFilter;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.startTime = /* @__PURE__ */ new Date();
          this.aggregateType = new node_opcua_nodeid_1.NodeId(null);
          this.processingInterval = 0;
          this.aggregateConfiguration = new AggregateConfiguration(null);
          return;
        }
        const schema = _AggregateFilter.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.startTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.startTime);
        this.aggregateType = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.aggregateType);
        this.processingInterval = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.processingInterval);
        this.aggregateConfiguration = new AggregateConfiguration(options.aggregateConfiguration);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.startTime, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.aggregateType, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.processingInterval, stream);
        this.aggregateConfiguration.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.startTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.startTime);
        this.aggregateType = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.aggregateType);
        this.processingInterval = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.processingInterval);
        this.aggregateConfiguration.decode(stream);
      }
      get schema() {
        return schemaAggregateFilter;
      }
    };
    exports2.AggregateFilter = AggregateFilter;
    AggregateFilter.possibleFields = [
      "startTime",
      "aggregateType",
      "processingInterval",
      "aggregateConfiguration"
    ];
    AggregateFilter.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(728, 0);
    AggregateFilter.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(730, 0);
    AggregateFilter.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(729, 0);
    AggregateFilter.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15312, 0);
    AggregateFilter.schema.dataTypeNodeId = AggregateFilter.dataTypeNodeId;
    AggregateFilter.schema.encodingDefaultBinary = AggregateFilter.encodingDefaultBinary;
    AggregateFilter.schema.encodingDefaultXml = AggregateFilter.encodingDefaultXml;
    AggregateFilter.schema.encodingDefaultJson = AggregateFilter.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(AggregateFilter.dataTypeNodeId, "AggregateFilter", AggregateFilter);
    var schemaMonitoringFilterResult = (0, node_opcua_factory_1.buildStructuredType)({
      name: "MonitoringFilterResult",
      baseType: "ExtensionObject",
      fields: []
    });
    var MonitoringFilterResult = class _MonitoringFilterResult extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaMonitoringFilterResult;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _MonitoringFilterResult.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaMonitoringFilterResult;
      }
    };
    exports2.MonitoringFilterResult = MonitoringFilterResult;
    MonitoringFilterResult.possibleFields = [];
    MonitoringFilterResult.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(731, 0);
    MonitoringFilterResult.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(733, 0);
    MonitoringFilterResult.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(732, 0);
    MonitoringFilterResult.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15313, 0);
    MonitoringFilterResult.schema.dataTypeNodeId = MonitoringFilterResult.dataTypeNodeId;
    MonitoringFilterResult.schema.encodingDefaultBinary = MonitoringFilterResult.encodingDefaultBinary;
    MonitoringFilterResult.schema.encodingDefaultXml = MonitoringFilterResult.encodingDefaultXml;
    MonitoringFilterResult.schema.encodingDefaultJson = MonitoringFilterResult.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(MonitoringFilterResult.dataTypeNodeId, "MonitoringFilterResult", MonitoringFilterResult);
    var schemaAggregateFilterResult = (0, node_opcua_factory_1.buildStructuredType)({
      name: "AggregateFilterResult",
      baseType: "MonitoringFilterResult",
      fields: [
        {
          name: "RevisedStartTime",
          fieldType: "DateTime"
        },
        {
          name: "RevisedProcessingInterval",
          fieldType: "Double"
        },
        {
          name: "RevisedAggregateConfiguration",
          fieldType: "AggregateConfiguration"
        }
      ]
    });
    var AggregateFilterResult = class _AggregateFilterResult extends MonitoringFilterResult {
      static get schema() {
        return schemaAggregateFilterResult;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.revisedStartTime = /* @__PURE__ */ new Date();
          this.revisedProcessingInterval = 0;
          this.revisedAggregateConfiguration = new AggregateConfiguration(null);
          return;
        }
        const schema = _AggregateFilterResult.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.revisedStartTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.revisedStartTime);
        this.revisedProcessingInterval = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.revisedProcessingInterval);
        this.revisedAggregateConfiguration = new AggregateConfiguration(options.revisedAggregateConfiguration);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.revisedStartTime, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.revisedProcessingInterval, stream);
        this.revisedAggregateConfiguration.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.revisedStartTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.revisedStartTime);
        this.revisedProcessingInterval = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.revisedProcessingInterval);
        this.revisedAggregateConfiguration.decode(stream);
      }
      get schema() {
        return schemaAggregateFilterResult;
      }
    };
    exports2.AggregateFilterResult = AggregateFilterResult;
    AggregateFilterResult.possibleFields = [
      "revisedStartTime",
      "revisedProcessingInterval",
      "revisedAggregateConfiguration"
    ];
    AggregateFilterResult.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(737, 0);
    AggregateFilterResult.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(739, 0);
    AggregateFilterResult.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(738, 0);
    AggregateFilterResult.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15315, 0);
    AggregateFilterResult.schema.dataTypeNodeId = AggregateFilterResult.dataTypeNodeId;
    AggregateFilterResult.schema.encodingDefaultBinary = AggregateFilterResult.encodingDefaultBinary;
    AggregateFilterResult.schema.encodingDefaultXml = AggregateFilterResult.encodingDefaultXml;
    AggregateFilterResult.schema.encodingDefaultJson = AggregateFilterResult.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(AggregateFilterResult.dataTypeNodeId, "AggregateFilterResult", AggregateFilterResult);
    var schemaAliasNameDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "AliasNameDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "AliasName",
          fieldType: "QualifiedName"
        },
        {
          name: "ReferencedNodes",
          fieldType: "ExpandedNodeId",
          isArray: true
        }
      ]
    });
    var AliasNameDataType = class _AliasNameDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaAliasNameDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.aliasName = new node_opcua_data_model_1.QualifiedName(null);
          this.referencedNodes = [];
          return;
        }
        const schema = _AliasNameDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.aliasName = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.aliasName);
        this.referencedNodes = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.referencedNodes);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_data_model_1.encodeQualifiedName)(this.aliasName, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.referencedNodes, stream, node_opcua_basic_types_1.encodeExpandedNodeId);
      }
      decode(stream) {
        super.decode(stream);
        this.aliasName = (0, node_opcua_data_model_1.decodeQualifiedName)(stream, this.aliasName);
        this.referencedNodes = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeExpandedNodeId);
      }
      get schema() {
        return schemaAliasNameDataType;
      }
    };
    exports2.AliasNameDataType = AliasNameDataType;
    AliasNameDataType.possibleFields = [
      "aliasName",
      "referencedNodes"
    ];
    AliasNameDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23468, 0);
    AliasNameDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23499, 0);
    AliasNameDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23505, 0);
    AliasNameDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23511, 0);
    AliasNameDataType.schema.dataTypeNodeId = AliasNameDataType.dataTypeNodeId;
    AliasNameDataType.schema.encodingDefaultBinary = AliasNameDataType.encodingDefaultBinary;
    AliasNameDataType.schema.encodingDefaultXml = AliasNameDataType.encodingDefaultXml;
    AliasNameDataType.schema.encodingDefaultJson = AliasNameDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(AliasNameDataType.dataTypeNodeId, "AliasNameDataType", AliasNameDataType);
    var schemaAnnotation = (0, node_opcua_factory_1.buildStructuredType)({
      name: "Annotation",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Message",
          fieldType: "String"
        },
        {
          name: "UserName",
          fieldType: "String"
        },
        {
          name: "AnnotationTime",
          fieldType: "DateTime"
        }
      ]
    });
    var Annotation = class _Annotation extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaAnnotation;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.message = null;
          this.userName = null;
          this.annotationTime = /* @__PURE__ */ new Date();
          return;
        }
        const schema = _Annotation.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.message = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.message);
        this.userName = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.userName);
        this.annotationTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.annotationTime);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.message, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.userName, stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.annotationTime, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.message = (0, node_opcua_basic_types_1.decodeString)(stream, this.message);
        this.userName = (0, node_opcua_basic_types_1.decodeString)(stream, this.userName);
        this.annotationTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.annotationTime);
      }
      get schema() {
        return schemaAnnotation;
      }
    };
    exports2.Annotation = Annotation;
    Annotation.possibleFields = [
      "message",
      "userName",
      "annotationTime"
    ];
    Annotation.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(891, 0);
    Annotation.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(893, 0);
    Annotation.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(892, 0);
    Annotation.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15382, 0);
    Annotation.schema.dataTypeNodeId = Annotation.dataTypeNodeId;
    Annotation.schema.encodingDefaultBinary = Annotation.encodingDefaultBinary;
    Annotation.schema.encodingDefaultXml = Annotation.encodingDefaultXml;
    Annotation.schema.encodingDefaultJson = Annotation.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(Annotation.dataTypeNodeId, "Annotation", Annotation);
    var schemaUserIdentityToken = (0, node_opcua_factory_1.buildStructuredType)({
      name: "UserIdentityToken",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "PolicyId",
          fieldType: "String"
        }
      ]
    });
    var UserIdentityToken = class _UserIdentityToken extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaUserIdentityToken;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.policyId = null;
          return;
        }
        const schema = _UserIdentityToken.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.policyId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.policyId);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.policyId, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.policyId = (0, node_opcua_basic_types_1.decodeString)(stream, this.policyId);
      }
      get schema() {
        return schemaUserIdentityToken;
      }
    };
    exports2.UserIdentityToken = UserIdentityToken;
    UserIdentityToken.possibleFields = [
      "policyId"
    ];
    UserIdentityToken.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(316, 0);
    UserIdentityToken.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(318, 0);
    UserIdentityToken.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(317, 0);
    UserIdentityToken.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15140, 0);
    UserIdentityToken.schema.dataTypeNodeId = UserIdentityToken.dataTypeNodeId;
    UserIdentityToken.schema.encodingDefaultBinary = UserIdentityToken.encodingDefaultBinary;
    UserIdentityToken.schema.encodingDefaultXml = UserIdentityToken.encodingDefaultXml;
    UserIdentityToken.schema.encodingDefaultJson = UserIdentityToken.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(UserIdentityToken.dataTypeNodeId, "UserIdentityToken", UserIdentityToken);
    var schemaAnonymousIdentityToken = (0, node_opcua_factory_1.buildStructuredType)({
      name: "AnonymousIdentityToken",
      baseType: "UserIdentityToken",
      fields: []
    });
    var AnonymousIdentityToken = class _AnonymousIdentityToken extends UserIdentityToken {
      static get schema() {
        return schemaAnonymousIdentityToken;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _AnonymousIdentityToken.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaAnonymousIdentityToken;
      }
    };
    exports2.AnonymousIdentityToken = AnonymousIdentityToken;
    AnonymousIdentityToken.possibleFields = [
      "policyId"
    ];
    AnonymousIdentityToken.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(319, 0);
    AnonymousIdentityToken.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(321, 0);
    AnonymousIdentityToken.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(320, 0);
    AnonymousIdentityToken.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15141, 0);
    AnonymousIdentityToken.schema.dataTypeNodeId = AnonymousIdentityToken.dataTypeNodeId;
    AnonymousIdentityToken.schema.encodingDefaultBinary = AnonymousIdentityToken.encodingDefaultBinary;
    AnonymousIdentityToken.schema.encodingDefaultXml = AnonymousIdentityToken.encodingDefaultXml;
    AnonymousIdentityToken.schema.encodingDefaultJson = AnonymousIdentityToken.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(AnonymousIdentityToken.dataTypeNodeId, "AnonymousIdentityToken", AnonymousIdentityToken);
    var ApplicationType;
    (function(ApplicationType2) {
      ApplicationType2[ApplicationType2["Server"] = 0] = "Server";
      ApplicationType2[ApplicationType2["Client"] = 1] = "Client";
      ApplicationType2[ApplicationType2["ClientAndServer"] = 2] = "ClientAndServer";
      ApplicationType2[ApplicationType2["DiscoveryServer"] = 3] = "DiscoveryServer";
      ApplicationType2[ApplicationType2["Invalid"] = 4294967295] = "Invalid";
    })(ApplicationType || (exports2.ApplicationType = ApplicationType = {}));
    var schemaApplicationType = {
      enumValues: ApplicationType,
      flaggable: false,
      minValue: 0,
      maxValue: 3,
      name: "ApplicationType"
    };
    function decodeApplicationType(stream, _value) {
      let value = stream.readUInt32();
      value = value < schemaApplicationType.minValue || value > schemaApplicationType.maxValue ? ApplicationType.Invalid : value;
      return value;
    }
    function encodeApplicationType(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationApplicationType = (0, node_opcua_factory_1.registerEnumeration)(schemaApplicationType);
    (0, node_opcua_assert_1.assert)(exports2._enumerationApplicationType.isFlaggable === false);
    var schemaApplicationDescription = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ApplicationDescription",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ApplicationUri",
          fieldType: "String"
        },
        {
          name: "ProductUri",
          fieldType: "String"
        },
        {
          name: "ApplicationName",
          fieldType: "LocalizedText"
        },
        {
          name: "ApplicationType",
          fieldType: "ApplicationType"
        },
        {
          name: "GatewayServerUri",
          fieldType: "String"
        },
        {
          name: "DiscoveryProfileUri",
          fieldType: "String"
        },
        {
          name: "DiscoveryUrls",
          fieldType: "String",
          isArray: true
        }
      ]
    });
    var ApplicationDescription = class _ApplicationDescription extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaApplicationDescription;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.applicationUri = null;
          this.productUri = null;
          this.applicationName = new node_opcua_data_model_1.LocalizedText(null);
          this.applicationType = 0;
          this.gatewayServerUri = null;
          this.discoveryProfileUri = null;
          this.discoveryUrls = [];
          return;
        }
        const schema = _ApplicationDescription.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.applicationUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.applicationUri);
        this.productUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.productUri);
        this.applicationName = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.applicationName);
        this.applicationType = this.setApplicationType((0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.applicationType));
        this.gatewayServerUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.gatewayServerUri);
        this.discoveryProfileUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.discoveryProfileUri);
        this.discoveryUrls = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[6], options?.discoveryUrls);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.applicationUri, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.productUri, stream);
        (0, node_opcua_data_model_1.encodeLocalizedText)(this.applicationName, stream);
        encodeApplicationType(this.applicationType, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.gatewayServerUri, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.discoveryProfileUri, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.discoveryUrls, stream, node_opcua_basic_types_1.encodeString);
      }
      decode(stream) {
        super.decode(stream);
        this.applicationUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.applicationUri);
        this.productUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.productUri);
        this.applicationName = (0, node_opcua_data_model_1.decodeLocalizedText)(stream, this.applicationName);
        this.applicationType = decodeApplicationType(stream, this.applicationType);
        this.gatewayServerUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.gatewayServerUri);
        this.discoveryProfileUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.discoveryProfileUri);
        this.discoveryUrls = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
      }
      // Define Enumeration setters
      setApplicationType(value) {
        const coercedValue = exports2._enumerationApplicationType.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to ApplicationType :" + value);
        }
        this.applicationType = coercedValue.value;
        return this.applicationType;
      }
      get schema() {
        return schemaApplicationDescription;
      }
    };
    exports2.ApplicationDescription = ApplicationDescription;
    ApplicationDescription.possibleFields = [
      "applicationUri",
      "productUri",
      "applicationName",
      "applicationType",
      "gatewayServerUri",
      "discoveryProfileUri",
      "discoveryUrls"
    ];
    ApplicationDescription.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(308, 0);
    ApplicationDescription.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(310, 0);
    ApplicationDescription.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(309, 0);
    ApplicationDescription.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15087, 0);
    ApplicationDescription.schema.dataTypeNodeId = ApplicationDescription.dataTypeNodeId;
    ApplicationDescription.schema.encodingDefaultBinary = ApplicationDescription.encodingDefaultBinary;
    ApplicationDescription.schema.encodingDefaultXml = ApplicationDescription.encodingDefaultXml;
    ApplicationDescription.schema.encodingDefaultJson = ApplicationDescription.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ApplicationDescription.dataTypeNodeId, "ApplicationDescription", ApplicationDescription);
    var schemaArgument = (0, node_opcua_factory_1.buildStructuredType)({
      name: "Argument",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Name",
          fieldType: "String"
        },
        {
          name: "DataType",
          fieldType: "NodeId"
        },
        {
          name: "ValueRank",
          fieldType: "Int32"
        },
        {
          name: "ArrayDimensions",
          fieldType: "UInt32",
          isArray: true
        },
        {
          name: "Description",
          fieldType: "LocalizedText"
        }
      ]
    });
    var Argument = class _Argument extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaArgument;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.name = null;
          this.dataType = new node_opcua_nodeid_1.NodeId(null);
          this.valueRank = 0;
          this.arrayDimensions = [];
          this.description = new node_opcua_data_model_1.LocalizedText(null);
          return;
        }
        const schema = _Argument.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.name = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.name);
        this.dataType = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.dataType);
        this.valueRank = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.valueRank);
        this.arrayDimensions = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[3], options?.arrayDimensions);
        this.description = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.description);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.name, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.dataType, stream);
        (0, node_opcua_basic_types_1.encodeInt32)(this.valueRank, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.arrayDimensions, stream, node_opcua_basic_types_1.encodeUInt32);
        (0, node_opcua_data_model_1.encodeLocalizedText)(this.description, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.name = (0, node_opcua_basic_types_1.decodeString)(stream, this.name);
        this.dataType = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.dataType);
        this.valueRank = (0, node_opcua_basic_types_1.decodeInt32)(stream, this.valueRank);
        this.arrayDimensions = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeUInt32);
        this.description = (0, node_opcua_data_model_1.decodeLocalizedText)(stream, this.description);
      }
      get schema() {
        return schemaArgument;
      }
    };
    exports2.Argument = Argument;
    Argument.possibleFields = [
      "name",
      "dataType",
      "valueRank",
      "arrayDimensions",
      "description"
    ];
    Argument.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(296, 0);
    Argument.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(298, 0);
    Argument.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(297, 0);
    Argument.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15081, 0);
    Argument.schema.dataTypeNodeId = Argument.dataTypeNodeId;
    Argument.schema.encodingDefaultBinary = Argument.encodingDefaultBinary;
    Argument.schema.encodingDefaultXml = Argument.encodingDefaultXml;
    Argument.schema.encodingDefaultJson = Argument.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(Argument.dataTypeNodeId, "Argument", Argument);
    var schemaRelativePathElement = (0, node_opcua_factory_1.buildStructuredType)({
      name: "RelativePathElement",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ReferenceTypeId",
          fieldType: "NodeId"
        },
        {
          name: "IsInverse",
          fieldType: "Boolean"
        },
        {
          name: "IncludeSubtypes",
          fieldType: "Boolean"
        },
        {
          name: "TargetName",
          fieldType: "QualifiedName"
        }
      ]
    });
    var RelativePathElement = class _RelativePathElement extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaRelativePathElement;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.referenceTypeId = new node_opcua_nodeid_1.NodeId(null);
          this.isInverse = false;
          this.includeSubtypes = false;
          this.targetName = new node_opcua_data_model_1.QualifiedName(null);
          return;
        }
        const schema = _RelativePathElement.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.referenceTypeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.referenceTypeId);
        this.isInverse = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.isInverse);
        this.includeSubtypes = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.includeSubtypes);
        this.targetName = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.targetName);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.referenceTypeId, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.isInverse, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.includeSubtypes, stream);
        (0, node_opcua_data_model_1.encodeQualifiedName)(this.targetName, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.referenceTypeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.referenceTypeId);
        this.isInverse = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.isInverse);
        this.includeSubtypes = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.includeSubtypes);
        this.targetName = (0, node_opcua_data_model_1.decodeQualifiedName)(stream, this.targetName);
      }
      get schema() {
        return schemaRelativePathElement;
      }
    };
    exports2.RelativePathElement = RelativePathElement;
    RelativePathElement.possibleFields = [
      "referenceTypeId",
      "isInverse",
      "includeSubtypes",
      "targetName"
    ];
    RelativePathElement.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(537, 0);
    RelativePathElement.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(539, 0);
    RelativePathElement.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(538, 0);
    RelativePathElement.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15188, 0);
    RelativePathElement.schema.dataTypeNodeId = RelativePathElement.dataTypeNodeId;
    RelativePathElement.schema.encodingDefaultBinary = RelativePathElement.encodingDefaultBinary;
    RelativePathElement.schema.encodingDefaultXml = RelativePathElement.encodingDefaultXml;
    RelativePathElement.schema.encodingDefaultJson = RelativePathElement.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(RelativePathElement.dataTypeNodeId, "RelativePathElement", RelativePathElement);
    var schemaRelativePath = (0, node_opcua_factory_1.buildStructuredType)({
      name: "RelativePath",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Elements",
          fieldType: "RelativePathElement",
          isArray: true
        }
      ]
    });
    var RelativePath = class _RelativePath extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaRelativePath;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.elements = null;
          return;
        }
        const schema = _RelativePath.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.elements = [];
        if (options.elements) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.elements));
          this.elements = options.elements.map((e) => new RelativePathElement(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.elements, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.elements = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new RelativePathElement(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaRelativePath;
      }
    };
    exports2.RelativePath = RelativePath;
    RelativePath.possibleFields = [
      "elements"
    ];
    RelativePath.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(540, 0);
    RelativePath.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(542, 0);
    RelativePath.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(541, 0);
    RelativePath.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15189, 0);
    RelativePath.schema.dataTypeNodeId = RelativePath.dataTypeNodeId;
    RelativePath.schema.encodingDefaultBinary = RelativePath.encodingDefaultBinary;
    RelativePath.schema.encodingDefaultXml = RelativePath.encodingDefaultXml;
    RelativePath.schema.encodingDefaultJson = RelativePath.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(RelativePath.dataTypeNodeId, "RelativePath", RelativePath);
    var schemaAttributeOperand = (0, node_opcua_factory_1.buildStructuredType)({
      name: "AttributeOperand",
      baseType: "FilterOperand",
      fields: [
        {
          name: "NodeId",
          fieldType: "NodeId"
        },
        {
          name: "Alias",
          fieldType: "String"
        },
        {
          name: "BrowsePath",
          fieldType: "RelativePath"
        },
        {
          name: "AttributeId",
          fieldType: "UInt32"
        },
        {
          name: "IndexRange",
          fieldType: "NumericRange"
        }
      ]
    });
    var AttributeOperand = class _AttributeOperand extends FilterOperand {
      static get schema() {
        return schemaAttributeOperand;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.nodeId = new node_opcua_nodeid_1.NodeId(null);
          this.alias = null;
          this.browsePath = new RelativePath(null);
          this.attributeId = 0;
          this.indexRange = new node_opcua_numeric_range_1.NumericRange(null);
          return;
        }
        const schema = _AttributeOperand.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.nodeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.nodeId);
        this.alias = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.alias);
        this.browsePath = new RelativePath(options.browsePath);
        this.attributeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.attributeId);
        this.indexRange = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.indexRange);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.nodeId, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.alias, stream);
        this.browsePath.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.attributeId, stream);
        (0, node_opcua_numeric_range_1.encodeNumericRange)(this.indexRange, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.nodeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.nodeId);
        this.alias = (0, node_opcua_basic_types_1.decodeString)(stream, this.alias);
        this.browsePath.decode(stream);
        this.attributeId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.attributeId);
        this.indexRange = (0, node_opcua_numeric_range_1.decodeNumericRange)(stream, this.indexRange);
      }
      get schema() {
        return schemaAttributeOperand;
      }
    };
    exports2.AttributeOperand = AttributeOperand;
    AttributeOperand.possibleFields = [
      "nodeId",
      "alias",
      "browsePath",
      "attributeId",
      "indexRange"
    ];
    AttributeOperand.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(598, 0);
    AttributeOperand.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(600, 0);
    AttributeOperand.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(599, 0);
    AttributeOperand.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15209, 0);
    AttributeOperand.schema.dataTypeNodeId = AttributeOperand.dataTypeNodeId;
    AttributeOperand.schema.encodingDefaultBinary = AttributeOperand.encodingDefaultBinary;
    AttributeOperand.schema.encodingDefaultXml = AttributeOperand.encodingDefaultXml;
    AttributeOperand.schema.encodingDefaultJson = AttributeOperand.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(AttributeOperand.dataTypeNodeId, "AttributeOperand", AttributeOperand);
    var schemaConnectionTransportDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ConnectionTransportDataType",
      baseType: "ExtensionObject",
      fields: []
    });
    var ConnectionTransportDataType = class _ConnectionTransportDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaConnectionTransportDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _ConnectionTransportDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaConnectionTransportDataType;
      }
    };
    exports2.ConnectionTransportDataType = ConnectionTransportDataType;
    ConnectionTransportDataType.possibleFields = [];
    ConnectionTransportDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15618, 0);
    ConnectionTransportDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15695, 0);
    ConnectionTransportDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15993, 0);
    ConnectionTransportDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16282, 0);
    ConnectionTransportDataType.schema.dataTypeNodeId = ConnectionTransportDataType.dataTypeNodeId;
    ConnectionTransportDataType.schema.encodingDefaultBinary = ConnectionTransportDataType.encodingDefaultBinary;
    ConnectionTransportDataType.schema.encodingDefaultXml = ConnectionTransportDataType.encodingDefaultXml;
    ConnectionTransportDataType.schema.encodingDefaultJson = ConnectionTransportDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ConnectionTransportDataType.dataTypeNodeId, "ConnectionTransportDataType", ConnectionTransportDataType);
    var schemaBrokerConnectionTransportDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "BrokerConnectionTransportDataType",
      baseType: "ConnectionTransportDataType",
      fields: [
        {
          name: "ResourceUri",
          fieldType: "String"
        },
        {
          name: "AuthenticationProfileUri",
          fieldType: "String"
        }
      ]
    });
    var BrokerConnectionTransportDataType = class _BrokerConnectionTransportDataType extends ConnectionTransportDataType {
      static get schema() {
        return schemaBrokerConnectionTransportDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.resourceUri = null;
          this.authenticationProfileUri = null;
          return;
        }
        const schema = _BrokerConnectionTransportDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.resourceUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.resourceUri);
        this.authenticationProfileUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.authenticationProfileUri);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.resourceUri, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.authenticationProfileUri, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.resourceUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.resourceUri);
        this.authenticationProfileUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.authenticationProfileUri);
      }
      get schema() {
        return schemaBrokerConnectionTransportDataType;
      }
    };
    exports2.BrokerConnectionTransportDataType = BrokerConnectionTransportDataType;
    BrokerConnectionTransportDataType.possibleFields = [
      "resourceUri",
      "authenticationProfileUri"
    ];
    BrokerConnectionTransportDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15007, 0);
    BrokerConnectionTransportDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15479, 0);
    BrokerConnectionTransportDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15579, 0);
    BrokerConnectionTransportDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15726, 0);
    BrokerConnectionTransportDataType.schema.dataTypeNodeId = BrokerConnectionTransportDataType.dataTypeNodeId;
    BrokerConnectionTransportDataType.schema.encodingDefaultBinary = BrokerConnectionTransportDataType.encodingDefaultBinary;
    BrokerConnectionTransportDataType.schema.encodingDefaultXml = BrokerConnectionTransportDataType.encodingDefaultXml;
    BrokerConnectionTransportDataType.schema.encodingDefaultJson = BrokerConnectionTransportDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(BrokerConnectionTransportDataType.dataTypeNodeId, "BrokerConnectionTransportDataType", BrokerConnectionTransportDataType);
    var schemaDataSetReaderTransportDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DataSetReaderTransportDataType",
      baseType: "ExtensionObject",
      fields: []
    });
    var DataSetReaderTransportDataType = class _DataSetReaderTransportDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDataSetReaderTransportDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _DataSetReaderTransportDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaDataSetReaderTransportDataType;
      }
    };
    exports2.DataSetReaderTransportDataType = DataSetReaderTransportDataType;
    DataSetReaderTransportDataType.possibleFields = [];
    DataSetReaderTransportDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15628, 0);
    DataSetReaderTransportDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15705, 0);
    DataSetReaderTransportDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16008, 0);
    DataSetReaderTransportDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16287, 0);
    DataSetReaderTransportDataType.schema.dataTypeNodeId = DataSetReaderTransportDataType.dataTypeNodeId;
    DataSetReaderTransportDataType.schema.encodingDefaultBinary = DataSetReaderTransportDataType.encodingDefaultBinary;
    DataSetReaderTransportDataType.schema.encodingDefaultXml = DataSetReaderTransportDataType.encodingDefaultXml;
    DataSetReaderTransportDataType.schema.encodingDefaultJson = DataSetReaderTransportDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DataSetReaderTransportDataType.dataTypeNodeId, "DataSetReaderTransportDataType", DataSetReaderTransportDataType);
    var BrokerTransportQualityOfService;
    (function(BrokerTransportQualityOfService2) {
      BrokerTransportQualityOfService2[BrokerTransportQualityOfService2["NotSpecified"] = 0] = "NotSpecified";
      BrokerTransportQualityOfService2[BrokerTransportQualityOfService2["BestEffort"] = 1] = "BestEffort";
      BrokerTransportQualityOfService2[BrokerTransportQualityOfService2["AtLeastOnce"] = 2] = "AtLeastOnce";
      BrokerTransportQualityOfService2[BrokerTransportQualityOfService2["AtMostOnce"] = 3] = "AtMostOnce";
      BrokerTransportQualityOfService2[BrokerTransportQualityOfService2["ExactlyOnce"] = 4] = "ExactlyOnce";
      BrokerTransportQualityOfService2[BrokerTransportQualityOfService2["Invalid"] = 4294967295] = "Invalid";
    })(BrokerTransportQualityOfService || (exports2.BrokerTransportQualityOfService = BrokerTransportQualityOfService = {}));
    var schemaBrokerTransportQualityOfService = {
      enumValues: BrokerTransportQualityOfService,
      flaggable: false,
      minValue: 0,
      maxValue: 4,
      name: "BrokerTransportQualityOfService"
    };
    function decodeBrokerTransportQualityOfService(stream, _value) {
      let value = stream.readUInt32();
      value = value < schemaBrokerTransportQualityOfService.minValue || value > schemaBrokerTransportQualityOfService.maxValue ? BrokerTransportQualityOfService.Invalid : value;
      return value;
    }
    function encodeBrokerTransportQualityOfService(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationBrokerTransportQualityOfService = (0, node_opcua_factory_1.registerEnumeration)(schemaBrokerTransportQualityOfService);
    (0, node_opcua_assert_1.assert)(exports2._enumerationBrokerTransportQualityOfService.isFlaggable === false);
    var schemaBrokerDataSetReaderTransportDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "BrokerDataSetReaderTransportDataType",
      baseType: "DataSetReaderTransportDataType",
      fields: [
        {
          name: "QueueName",
          fieldType: "String"
        },
        {
          name: "ResourceUri",
          fieldType: "String"
        },
        {
          name: "AuthenticationProfileUri",
          fieldType: "String"
        },
        {
          name: "RequestedDeliveryGuarantee",
          fieldType: "BrokerTransportQualityOfService"
        },
        {
          name: "MetaDataQueueName",
          fieldType: "String"
        }
      ]
    });
    var BrokerDataSetReaderTransportDataType = class _BrokerDataSetReaderTransportDataType extends DataSetReaderTransportDataType {
      static get schema() {
        return schemaBrokerDataSetReaderTransportDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.queueName = null;
          this.resourceUri = null;
          this.authenticationProfileUri = null;
          this.requestedDeliveryGuarantee = 0;
          this.metaDataQueueName = null;
          return;
        }
        const schema = _BrokerDataSetReaderTransportDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.queueName = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.queueName);
        this.resourceUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.resourceUri);
        this.authenticationProfileUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.authenticationProfileUri);
        this.requestedDeliveryGuarantee = this.setRequestedDeliveryGuarantee((0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.requestedDeliveryGuarantee));
        this.metaDataQueueName = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.metaDataQueueName);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.queueName, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.resourceUri, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.authenticationProfileUri, stream);
        encodeBrokerTransportQualityOfService(this.requestedDeliveryGuarantee, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.metaDataQueueName, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.queueName = (0, node_opcua_basic_types_1.decodeString)(stream, this.queueName);
        this.resourceUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.resourceUri);
        this.authenticationProfileUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.authenticationProfileUri);
        this.requestedDeliveryGuarantee = decodeBrokerTransportQualityOfService(stream, this.requestedDeliveryGuarantee);
        this.metaDataQueueName = (0, node_opcua_basic_types_1.decodeString)(stream, this.metaDataQueueName);
      }
      // Define Enumeration setters
      setRequestedDeliveryGuarantee(value) {
        const coercedValue = exports2._enumerationBrokerTransportQualityOfService.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to BrokerTransportQualityOfService :" + value);
        }
        this.requestedDeliveryGuarantee = coercedValue.value;
        return this.requestedDeliveryGuarantee;
      }
      get schema() {
        return schemaBrokerDataSetReaderTransportDataType;
      }
    };
    exports2.BrokerDataSetReaderTransportDataType = BrokerDataSetReaderTransportDataType;
    BrokerDataSetReaderTransportDataType.possibleFields = [
      "queueName",
      "resourceUri",
      "authenticationProfileUri",
      "requestedDeliveryGuarantee",
      "metaDataQueueName"
    ];
    BrokerDataSetReaderTransportDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15670, 0);
    BrokerDataSetReaderTransportDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15733, 0);
    BrokerDataSetReaderTransportDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16023, 0);
    BrokerDataSetReaderTransportDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16526, 0);
    BrokerDataSetReaderTransportDataType.schema.dataTypeNodeId = BrokerDataSetReaderTransportDataType.dataTypeNodeId;
    BrokerDataSetReaderTransportDataType.schema.encodingDefaultBinary = BrokerDataSetReaderTransportDataType.encodingDefaultBinary;
    BrokerDataSetReaderTransportDataType.schema.encodingDefaultXml = BrokerDataSetReaderTransportDataType.encodingDefaultXml;
    BrokerDataSetReaderTransportDataType.schema.encodingDefaultJson = BrokerDataSetReaderTransportDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(BrokerDataSetReaderTransportDataType.dataTypeNodeId, "BrokerDataSetReaderTransportDataType", BrokerDataSetReaderTransportDataType);
    var schemaDataSetWriterTransportDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DataSetWriterTransportDataType",
      baseType: "ExtensionObject",
      fields: []
    });
    var DataSetWriterTransportDataType = class _DataSetWriterTransportDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDataSetWriterTransportDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _DataSetWriterTransportDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaDataSetWriterTransportDataType;
      }
    };
    exports2.DataSetWriterTransportDataType = DataSetWriterTransportDataType;
    DataSetWriterTransportDataType.possibleFields = [];
    DataSetWriterTransportDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15598, 0);
    DataSetWriterTransportDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15683, 0);
    DataSetWriterTransportDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15956, 0);
    DataSetWriterTransportDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16157, 0);
    DataSetWriterTransportDataType.schema.dataTypeNodeId = DataSetWriterTransportDataType.dataTypeNodeId;
    DataSetWriterTransportDataType.schema.encodingDefaultBinary = DataSetWriterTransportDataType.encodingDefaultBinary;
    DataSetWriterTransportDataType.schema.encodingDefaultXml = DataSetWriterTransportDataType.encodingDefaultXml;
    DataSetWriterTransportDataType.schema.encodingDefaultJson = DataSetWriterTransportDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DataSetWriterTransportDataType.dataTypeNodeId, "DataSetWriterTransportDataType", DataSetWriterTransportDataType);
    var schemaBrokerDataSetWriterTransportDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "BrokerDataSetWriterTransportDataType",
      baseType: "DataSetWriterTransportDataType",
      fields: [
        {
          name: "QueueName",
          fieldType: "String"
        },
        {
          name: "ResourceUri",
          fieldType: "String"
        },
        {
          name: "AuthenticationProfileUri",
          fieldType: "String"
        },
        {
          name: "RequestedDeliveryGuarantee",
          fieldType: "BrokerTransportQualityOfService"
        },
        {
          name: "MetaDataQueueName",
          fieldType: "String"
        },
        {
          name: "MetaDataUpdateTime",
          fieldType: "Double"
        }
      ]
    });
    var BrokerDataSetWriterTransportDataType = class _BrokerDataSetWriterTransportDataType extends DataSetWriterTransportDataType {
      static get schema() {
        return schemaBrokerDataSetWriterTransportDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.queueName = null;
          this.resourceUri = null;
          this.authenticationProfileUri = null;
          this.requestedDeliveryGuarantee = 0;
          this.metaDataQueueName = null;
          this.metaDataUpdateTime = 0;
          return;
        }
        const schema = _BrokerDataSetWriterTransportDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.queueName = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.queueName);
        this.resourceUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.resourceUri);
        this.authenticationProfileUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.authenticationProfileUri);
        this.requestedDeliveryGuarantee = this.setRequestedDeliveryGuarantee((0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.requestedDeliveryGuarantee));
        this.metaDataQueueName = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.metaDataQueueName);
        this.metaDataUpdateTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.metaDataUpdateTime);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.queueName, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.resourceUri, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.authenticationProfileUri, stream);
        encodeBrokerTransportQualityOfService(this.requestedDeliveryGuarantee, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.metaDataQueueName, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.metaDataUpdateTime, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.queueName = (0, node_opcua_basic_types_1.decodeString)(stream, this.queueName);
        this.resourceUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.resourceUri);
        this.authenticationProfileUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.authenticationProfileUri);
        this.requestedDeliveryGuarantee = decodeBrokerTransportQualityOfService(stream, this.requestedDeliveryGuarantee);
        this.metaDataQueueName = (0, node_opcua_basic_types_1.decodeString)(stream, this.metaDataQueueName);
        this.metaDataUpdateTime = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.metaDataUpdateTime);
      }
      // Define Enumeration setters
      setRequestedDeliveryGuarantee(value) {
        const coercedValue = exports2._enumerationBrokerTransportQualityOfService.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to BrokerTransportQualityOfService :" + value);
        }
        this.requestedDeliveryGuarantee = coercedValue.value;
        return this.requestedDeliveryGuarantee;
      }
      get schema() {
        return schemaBrokerDataSetWriterTransportDataType;
      }
    };
    exports2.BrokerDataSetWriterTransportDataType = BrokerDataSetWriterTransportDataType;
    BrokerDataSetWriterTransportDataType.possibleFields = [
      "queueName",
      "resourceUri",
      "authenticationProfileUri",
      "requestedDeliveryGuarantee",
      "metaDataQueueName",
      "metaDataUpdateTime"
    ];
    BrokerDataSetWriterTransportDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15669, 0);
    BrokerDataSetWriterTransportDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15729, 0);
    BrokerDataSetWriterTransportDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16022, 0);
    BrokerDataSetWriterTransportDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16525, 0);
    BrokerDataSetWriterTransportDataType.schema.dataTypeNodeId = BrokerDataSetWriterTransportDataType.dataTypeNodeId;
    BrokerDataSetWriterTransportDataType.schema.encodingDefaultBinary = BrokerDataSetWriterTransportDataType.encodingDefaultBinary;
    BrokerDataSetWriterTransportDataType.schema.encodingDefaultXml = BrokerDataSetWriterTransportDataType.encodingDefaultXml;
    BrokerDataSetWriterTransportDataType.schema.encodingDefaultJson = BrokerDataSetWriterTransportDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(BrokerDataSetWriterTransportDataType.dataTypeNodeId, "BrokerDataSetWriterTransportDataType", BrokerDataSetWriterTransportDataType);
    var schemaWriterGroupTransportDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "WriterGroupTransportDataType",
      baseType: "ExtensionObject",
      fields: []
    });
    var WriterGroupTransportDataType = class _WriterGroupTransportDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaWriterGroupTransportDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _WriterGroupTransportDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaWriterGroupTransportDataType;
      }
    };
    exports2.WriterGroupTransportDataType = WriterGroupTransportDataType;
    WriterGroupTransportDataType.possibleFields = [];
    WriterGroupTransportDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15611, 0);
    WriterGroupTransportDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15691, 0);
    WriterGroupTransportDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15990, 0);
    WriterGroupTransportDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16161, 0);
    WriterGroupTransportDataType.schema.dataTypeNodeId = WriterGroupTransportDataType.dataTypeNodeId;
    WriterGroupTransportDataType.schema.encodingDefaultBinary = WriterGroupTransportDataType.encodingDefaultBinary;
    WriterGroupTransportDataType.schema.encodingDefaultXml = WriterGroupTransportDataType.encodingDefaultXml;
    WriterGroupTransportDataType.schema.encodingDefaultJson = WriterGroupTransportDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(WriterGroupTransportDataType.dataTypeNodeId, "WriterGroupTransportDataType", WriterGroupTransportDataType);
    var schemaBrokerWriterGroupTransportDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "BrokerWriterGroupTransportDataType",
      baseType: "WriterGroupTransportDataType",
      fields: [
        {
          name: "QueueName",
          fieldType: "String"
        },
        {
          name: "ResourceUri",
          fieldType: "String"
        },
        {
          name: "AuthenticationProfileUri",
          fieldType: "String"
        },
        {
          name: "RequestedDeliveryGuarantee",
          fieldType: "BrokerTransportQualityOfService"
        }
      ]
    });
    var BrokerWriterGroupTransportDataType = class _BrokerWriterGroupTransportDataType extends WriterGroupTransportDataType {
      static get schema() {
        return schemaBrokerWriterGroupTransportDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.queueName = null;
          this.resourceUri = null;
          this.authenticationProfileUri = null;
          this.requestedDeliveryGuarantee = 0;
          return;
        }
        const schema = _BrokerWriterGroupTransportDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.queueName = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.queueName);
        this.resourceUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.resourceUri);
        this.authenticationProfileUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.authenticationProfileUri);
        this.requestedDeliveryGuarantee = this.setRequestedDeliveryGuarantee((0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.requestedDeliveryGuarantee));
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.queueName, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.resourceUri, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.authenticationProfileUri, stream);
        encodeBrokerTransportQualityOfService(this.requestedDeliveryGuarantee, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.queueName = (0, node_opcua_basic_types_1.decodeString)(stream, this.queueName);
        this.resourceUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.resourceUri);
        this.authenticationProfileUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.authenticationProfileUri);
        this.requestedDeliveryGuarantee = decodeBrokerTransportQualityOfService(stream, this.requestedDeliveryGuarantee);
      }
      // Define Enumeration setters
      setRequestedDeliveryGuarantee(value) {
        const coercedValue = exports2._enumerationBrokerTransportQualityOfService.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to BrokerTransportQualityOfService :" + value);
        }
        this.requestedDeliveryGuarantee = coercedValue.value;
        return this.requestedDeliveryGuarantee;
      }
      get schema() {
        return schemaBrokerWriterGroupTransportDataType;
      }
    };
    exports2.BrokerWriterGroupTransportDataType = BrokerWriterGroupTransportDataType;
    BrokerWriterGroupTransportDataType.possibleFields = [
      "queueName",
      "resourceUri",
      "authenticationProfileUri",
      "requestedDeliveryGuarantee"
    ];
    BrokerWriterGroupTransportDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15667, 0);
    BrokerWriterGroupTransportDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15727, 0);
    BrokerWriterGroupTransportDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16021, 0);
    BrokerWriterGroupTransportDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16524, 0);
    BrokerWriterGroupTransportDataType.schema.dataTypeNodeId = BrokerWriterGroupTransportDataType.dataTypeNodeId;
    BrokerWriterGroupTransportDataType.schema.encodingDefaultBinary = BrokerWriterGroupTransportDataType.encodingDefaultBinary;
    BrokerWriterGroupTransportDataType.schema.encodingDefaultXml = BrokerWriterGroupTransportDataType.encodingDefaultXml;
    BrokerWriterGroupTransportDataType.schema.encodingDefaultJson = BrokerWriterGroupTransportDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(BrokerWriterGroupTransportDataType.dataTypeNodeId, "BrokerWriterGroupTransportDataType", BrokerWriterGroupTransportDataType);
    var schemaBrowseDescription = (0, node_opcua_factory_1.buildStructuredType)({
      name: "BrowseDescription",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "NodeId",
          fieldType: "NodeId"
        },
        {
          name: "BrowseDirection",
          fieldType: "BrowseDirection"
        },
        {
          name: "ReferenceTypeId",
          fieldType: "NodeId"
        },
        {
          name: "IncludeSubtypes",
          fieldType: "Boolean"
        },
        {
          name: "NodeClassMask",
          fieldType: "UInt32"
        },
        {
          name: "ResultMask",
          fieldType: "UInt32"
        }
      ]
    });
    var BrowseDescription = class _BrowseDescription extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaBrowseDescription;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.nodeId = new node_opcua_nodeid_1.NodeId(null);
          this.browseDirection = 0;
          this.referenceTypeId = new node_opcua_nodeid_1.NodeId(null);
          this.includeSubtypes = false;
          this.nodeClassMask = 0;
          this.resultMask = 0;
          return;
        }
        const schema = _BrowseDescription.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.nodeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.nodeId);
        this.browseDirection = this.setBrowseDirection((0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.browseDirection));
        this.referenceTypeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.referenceTypeId);
        this.includeSubtypes = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.includeSubtypes);
        this.nodeClassMask = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.nodeClassMask);
        this.resultMask = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.resultMask);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.nodeId, stream);
        (0, node_opcua_data_model_1.encodeBrowseDirection)(this.browseDirection, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.referenceTypeId, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.includeSubtypes, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.nodeClassMask, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.resultMask, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.nodeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.nodeId);
        this.browseDirection = (0, node_opcua_data_model_1.decodeBrowseDirection)(stream, this.browseDirection);
        this.referenceTypeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.referenceTypeId);
        this.includeSubtypes = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.includeSubtypes);
        this.nodeClassMask = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.nodeClassMask);
        this.resultMask = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.resultMask);
      }
      // Define Enumeration setters
      setBrowseDirection(value) {
        const coercedValue = node_opcua_data_model_1._enumerationBrowseDirection.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to BrowseDirection :" + value);
        }
        this.browseDirection = coercedValue.value;
        return this.browseDirection;
      }
      get schema() {
        return schemaBrowseDescription;
      }
    };
    exports2.BrowseDescription = BrowseDescription;
    BrowseDescription.possibleFields = [
      "nodeId",
      "browseDirection",
      "referenceTypeId",
      "includeSubtypes",
      "nodeClassMask",
      "resultMask"
    ];
    BrowseDescription.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(514, 0);
    BrowseDescription.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(516, 0);
    BrowseDescription.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(515, 0);
    BrowseDescription.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15180, 0);
    BrowseDescription.schema.dataTypeNodeId = BrowseDescription.dataTypeNodeId;
    BrowseDescription.schema.encodingDefaultBinary = BrowseDescription.encodingDefaultBinary;
    BrowseDescription.schema.encodingDefaultXml = BrowseDescription.encodingDefaultXml;
    BrowseDescription.schema.encodingDefaultJson = BrowseDescription.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(BrowseDescription.dataTypeNodeId, "BrowseDescription", BrowseDescription);
    var schemaBrowseNextRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "BrowseNextRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "ReleaseContinuationPoints",
          fieldType: "Boolean"
        },
        {
          name: "ContinuationPoints",
          fieldType: "ByteString",
          isArray: true
        }
      ]
    });
    var BrowseNextRequest = class _BrowseNextRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaBrowseNextRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.releaseContinuationPoints = false;
          this.continuationPoints = [];
          return;
        }
        const schema = _BrowseNextRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.releaseContinuationPoints = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.releaseContinuationPoints);
        this.continuationPoints = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.continuationPoints);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.releaseContinuationPoints, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.continuationPoints, stream, node_opcua_basic_types_1.encodeByteString);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.releaseContinuationPoints = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.releaseContinuationPoints);
        this.continuationPoints = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeByteString);
      }
      get schema() {
        return schemaBrowseNextRequest;
      }
    };
    exports2.BrowseNextRequest = BrowseNextRequest;
    BrowseNextRequest.possibleFields = [
      "requestHeader",
      "releaseContinuationPoints",
      "continuationPoints"
    ];
    BrowseNextRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(531, 0);
    BrowseNextRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(533, 0);
    BrowseNextRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(532, 0);
    BrowseNextRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15186, 0);
    BrowseNextRequest.schema.dataTypeNodeId = BrowseNextRequest.dataTypeNodeId;
    BrowseNextRequest.schema.encodingDefaultBinary = BrowseNextRequest.encodingDefaultBinary;
    BrowseNextRequest.schema.encodingDefaultXml = BrowseNextRequest.encodingDefaultXml;
    BrowseNextRequest.schema.encodingDefaultJson = BrowseNextRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(BrowseNextRequest.dataTypeNodeId, "BrowseNextRequest", BrowseNextRequest);
    var schemaReferenceDescription = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ReferenceDescription",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ReferenceTypeId",
          fieldType: "NodeId"
        },
        {
          name: "IsForward",
          fieldType: "Boolean"
        },
        {
          name: "NodeId",
          fieldType: "ExpandedNodeId"
        },
        {
          name: "BrowseName",
          fieldType: "QualifiedName"
        },
        {
          name: "DisplayName",
          fieldType: "LocalizedText"
        },
        {
          name: "NodeClass",
          fieldType: "NodeClass"
        },
        {
          name: "TypeDefinition",
          fieldType: "ExpandedNodeId"
        }
      ]
    });
    var ReferenceDescription = class _ReferenceDescription extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaReferenceDescription;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.referenceTypeId = new node_opcua_nodeid_1.NodeId(null);
          this.isForward = false;
          this.nodeId = new node_opcua_nodeid_1.ExpandedNodeId(null);
          this.browseName = new node_opcua_data_model_1.QualifiedName(null);
          this.displayName = new node_opcua_data_model_1.LocalizedText(null);
          this.nodeClass = 0;
          this.typeDefinition = new node_opcua_nodeid_1.ExpandedNodeId(null);
          return;
        }
        const schema = _ReferenceDescription.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.referenceTypeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.referenceTypeId);
        this.isForward = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.isForward);
        this.nodeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.nodeId);
        this.browseName = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.browseName);
        this.displayName = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.displayName);
        this.nodeClass = this.setNodeClass((0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.nodeClass));
        this.typeDefinition = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.typeDefinition);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.referenceTypeId, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.isForward, stream);
        (0, node_opcua_basic_types_1.encodeExpandedNodeId)(this.nodeId, stream);
        (0, node_opcua_data_model_1.encodeQualifiedName)(this.browseName, stream);
        (0, node_opcua_data_model_1.encodeLocalizedText)(this.displayName, stream);
        encodeNodeClass(this.nodeClass, stream);
        (0, node_opcua_basic_types_1.encodeExpandedNodeId)(this.typeDefinition, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.referenceTypeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.referenceTypeId);
        this.isForward = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.isForward);
        this.nodeId = (0, node_opcua_basic_types_1.decodeExpandedNodeId)(stream, this.nodeId);
        this.browseName = (0, node_opcua_data_model_1.decodeQualifiedName)(stream, this.browseName);
        this.displayName = (0, node_opcua_data_model_1.decodeLocalizedText)(stream, this.displayName);
        this.nodeClass = decodeNodeClass(stream, this.nodeClass);
        this.typeDefinition = (0, node_opcua_basic_types_1.decodeExpandedNodeId)(stream, this.typeDefinition);
      }
      // Define Enumeration setters
      setNodeClass(value) {
        const coercedValue = exports2._enumerationNodeClass.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to NodeClass :" + value);
        }
        this.nodeClass = coercedValue.value;
        return this.nodeClass;
      }
      get schema() {
        return schemaReferenceDescription;
      }
    };
    exports2.ReferenceDescription = ReferenceDescription;
    ReferenceDescription.possibleFields = [
      "referenceTypeId",
      "isForward",
      "nodeId",
      "browseName",
      "displayName",
      "nodeClass",
      "typeDefinition"
    ];
    ReferenceDescription.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(518, 0);
    ReferenceDescription.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(520, 0);
    ReferenceDescription.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(519, 0);
    ReferenceDescription.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15182, 0);
    ReferenceDescription.schema.dataTypeNodeId = ReferenceDescription.dataTypeNodeId;
    ReferenceDescription.schema.encodingDefaultBinary = ReferenceDescription.encodingDefaultBinary;
    ReferenceDescription.schema.encodingDefaultXml = ReferenceDescription.encodingDefaultXml;
    ReferenceDescription.schema.encodingDefaultJson = ReferenceDescription.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ReferenceDescription.dataTypeNodeId, "ReferenceDescription", ReferenceDescription);
    var schemaBrowseResult = (0, node_opcua_factory_1.buildStructuredType)({
      name: "BrowseResult",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "StatusCode",
          fieldType: "StatusCode"
        },
        {
          name: "ContinuationPoint",
          fieldType: "ByteString"
        },
        {
          name: "References",
          fieldType: "ReferenceDescription",
          isArray: true
        }
      ]
    });
    var BrowseResult = class _BrowseResult extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaBrowseResult;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.statusCode = node_opcua_status_code_1.StatusCodes.Good;
          this.continuationPoint = Buffer.alloc(0);
          this.references = null;
          return;
        }
        const schema = _BrowseResult.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.statusCode = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.statusCode);
        this.continuationPoint = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.continuationPoint);
        this.references = [];
        if (options.references) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.references));
          this.references = options.references.map((e) => new ReferenceDescription(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_status_code_1.encodeStatusCode)(this.statusCode, stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.continuationPoint, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.references, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.statusCode = (0, node_opcua_status_code_1.decodeStatusCode)(stream, this.statusCode);
        this.continuationPoint = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.continuationPoint);
        this.references = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new ReferenceDescription(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaBrowseResult;
      }
    };
    exports2.BrowseResult = BrowseResult;
    BrowseResult.possibleFields = [
      "statusCode",
      "continuationPoint",
      "references"
    ];
    BrowseResult.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(522, 0);
    BrowseResult.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(524, 0);
    BrowseResult.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(523, 0);
    BrowseResult.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15183, 0);
    BrowseResult.schema.dataTypeNodeId = BrowseResult.dataTypeNodeId;
    BrowseResult.schema.encodingDefaultBinary = BrowseResult.encodingDefaultBinary;
    BrowseResult.schema.encodingDefaultXml = BrowseResult.encodingDefaultXml;
    BrowseResult.schema.encodingDefaultJson = BrowseResult.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(BrowseResult.dataTypeNodeId, "BrowseResult", BrowseResult);
    var schemaBrowseNextResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "BrowseNextResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "Results",
          fieldType: "BrowseResult",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var BrowseNextResponse = class _BrowseNextResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaBrowseNextResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.results = null;
          this.diagnosticInfos = [];
          return;
        }
        const schema = _BrowseNextResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.results = [];
        if (options.results) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.results));
          this.results = options.results.map((e) => new BrowseResult(e));
        }
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.results, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.results = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new BrowseResult(null);
          obj.decode(stream1);
          return obj;
        });
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaBrowseNextResponse;
      }
    };
    exports2.BrowseNextResponse = BrowseNextResponse;
    BrowseNextResponse.possibleFields = [
      "responseHeader",
      "results",
      "diagnosticInfos"
    ];
    BrowseNextResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(534, 0);
    BrowseNextResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(536, 0);
    BrowseNextResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(535, 0);
    BrowseNextResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15187, 0);
    BrowseNextResponse.schema.dataTypeNodeId = BrowseNextResponse.dataTypeNodeId;
    BrowseNextResponse.schema.encodingDefaultBinary = BrowseNextResponse.encodingDefaultBinary;
    BrowseNextResponse.schema.encodingDefaultXml = BrowseNextResponse.encodingDefaultXml;
    BrowseNextResponse.schema.encodingDefaultJson = BrowseNextResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(BrowseNextResponse.dataTypeNodeId, "BrowseNextResponse", BrowseNextResponse);
    var schemaBrowsePath = (0, node_opcua_factory_1.buildStructuredType)({
      name: "BrowsePath",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "StartingNode",
          fieldType: "NodeId"
        },
        {
          name: "RelativePath",
          fieldType: "RelativePath"
        }
      ]
    });
    var BrowsePath = class _BrowsePath extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaBrowsePath;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.startingNode = new node_opcua_nodeid_1.NodeId(null);
          this.relativePath = new RelativePath(null);
          return;
        }
        const schema = _BrowsePath.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.startingNode = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.startingNode);
        this.relativePath = new RelativePath(options.relativePath);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.startingNode, stream);
        this.relativePath.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.startingNode = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.startingNode);
        this.relativePath.decode(stream);
      }
      get schema() {
        return schemaBrowsePath;
      }
    };
    exports2.BrowsePath = BrowsePath;
    BrowsePath.possibleFields = [
      "startingNode",
      "relativePath"
    ];
    BrowsePath.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(543, 0);
    BrowsePath.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(545, 0);
    BrowsePath.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(544, 0);
    BrowsePath.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15190, 0);
    BrowsePath.schema.dataTypeNodeId = BrowsePath.dataTypeNodeId;
    BrowsePath.schema.encodingDefaultBinary = BrowsePath.encodingDefaultBinary;
    BrowsePath.schema.encodingDefaultXml = BrowsePath.encodingDefaultXml;
    BrowsePath.schema.encodingDefaultJson = BrowsePath.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(BrowsePath.dataTypeNodeId, "BrowsePath", BrowsePath);
    var schemaBrowsePathTarget = (0, node_opcua_factory_1.buildStructuredType)({
      name: "BrowsePathTarget",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "TargetId",
          fieldType: "ExpandedNodeId"
        },
        {
          name: "RemainingPathIndex",
          fieldType: "UInt32"
        }
      ]
    });
    var BrowsePathTarget = class _BrowsePathTarget extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaBrowsePathTarget;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.targetId = new node_opcua_nodeid_1.ExpandedNodeId(null);
          this.remainingPathIndex = 0;
          return;
        }
        const schema = _BrowsePathTarget.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.targetId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.targetId);
        this.remainingPathIndex = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.remainingPathIndex);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeExpandedNodeId)(this.targetId, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.remainingPathIndex, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.targetId = (0, node_opcua_basic_types_1.decodeExpandedNodeId)(stream, this.targetId);
        this.remainingPathIndex = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.remainingPathIndex);
      }
      get schema() {
        return schemaBrowsePathTarget;
      }
    };
    exports2.BrowsePathTarget = BrowsePathTarget;
    BrowsePathTarget.possibleFields = [
      "targetId",
      "remainingPathIndex"
    ];
    BrowsePathTarget.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(546, 0);
    BrowsePathTarget.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(548, 0);
    BrowsePathTarget.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(547, 0);
    BrowsePathTarget.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15191, 0);
    BrowsePathTarget.schema.dataTypeNodeId = BrowsePathTarget.dataTypeNodeId;
    BrowsePathTarget.schema.encodingDefaultBinary = BrowsePathTarget.encodingDefaultBinary;
    BrowsePathTarget.schema.encodingDefaultXml = BrowsePathTarget.encodingDefaultXml;
    BrowsePathTarget.schema.encodingDefaultJson = BrowsePathTarget.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(BrowsePathTarget.dataTypeNodeId, "BrowsePathTarget", BrowsePathTarget);
    var schemaBrowsePathResult = (0, node_opcua_factory_1.buildStructuredType)({
      name: "BrowsePathResult",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "StatusCode",
          fieldType: "StatusCode"
        },
        {
          name: "Targets",
          fieldType: "BrowsePathTarget",
          isArray: true
        }
      ]
    });
    var BrowsePathResult = class _BrowsePathResult extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaBrowsePathResult;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.statusCode = node_opcua_status_code_1.StatusCodes.Good;
          this.targets = null;
          return;
        }
        const schema = _BrowsePathResult.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.statusCode = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.statusCode);
        this.targets = [];
        if (options.targets) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.targets));
          this.targets = options.targets.map((e) => new BrowsePathTarget(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_status_code_1.encodeStatusCode)(this.statusCode, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.targets, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.statusCode = (0, node_opcua_status_code_1.decodeStatusCode)(stream, this.statusCode);
        this.targets = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new BrowsePathTarget(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaBrowsePathResult;
      }
    };
    exports2.BrowsePathResult = BrowsePathResult;
    BrowsePathResult.possibleFields = [
      "statusCode",
      "targets"
    ];
    BrowsePathResult.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(549, 0);
    BrowsePathResult.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(551, 0);
    BrowsePathResult.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(550, 0);
    BrowsePathResult.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15192, 0);
    BrowsePathResult.schema.dataTypeNodeId = BrowsePathResult.dataTypeNodeId;
    BrowsePathResult.schema.encodingDefaultBinary = BrowsePathResult.encodingDefaultBinary;
    BrowsePathResult.schema.encodingDefaultXml = BrowsePathResult.encodingDefaultXml;
    BrowsePathResult.schema.encodingDefaultJson = BrowsePathResult.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(BrowsePathResult.dataTypeNodeId, "BrowsePathResult", BrowsePathResult);
    var schemaViewDescription = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ViewDescription",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ViewId",
          fieldType: "NodeId"
        },
        {
          name: "Timestamp",
          fieldType: "DateTime"
        },
        {
          name: "ViewVersion",
          fieldType: "UInt32"
        }
      ]
    });
    var ViewDescription = class _ViewDescription extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaViewDescription;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.viewId = new node_opcua_nodeid_1.NodeId(null);
          this.timestamp = /* @__PURE__ */ new Date();
          this.viewVersion = 0;
          return;
        }
        const schema = _ViewDescription.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.viewId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.viewId);
        this.timestamp = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.timestamp);
        this.viewVersion = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.viewVersion);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.viewId, stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.timestamp, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.viewVersion, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.viewId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.viewId);
        this.timestamp = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.timestamp);
        this.viewVersion = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.viewVersion);
      }
      get schema() {
        return schemaViewDescription;
      }
    };
    exports2.ViewDescription = ViewDescription;
    ViewDescription.possibleFields = [
      "viewId",
      "timestamp",
      "viewVersion"
    ];
    ViewDescription.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(511, 0);
    ViewDescription.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(513, 0);
    ViewDescription.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(512, 0);
    ViewDescription.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15179, 0);
    ViewDescription.schema.dataTypeNodeId = ViewDescription.dataTypeNodeId;
    ViewDescription.schema.encodingDefaultBinary = ViewDescription.encodingDefaultBinary;
    ViewDescription.schema.encodingDefaultXml = ViewDescription.encodingDefaultXml;
    ViewDescription.schema.encodingDefaultJson = ViewDescription.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ViewDescription.dataTypeNodeId, "ViewDescription", ViewDescription);
    var schemaBrowseRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "BrowseRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "View",
          fieldType: "ViewDescription"
        },
        {
          name: "RequestedMaxReferencesPerNode",
          fieldType: "UInt32"
        },
        {
          name: "NodesToBrowse",
          fieldType: "BrowseDescription",
          isArray: true
        }
      ]
    });
    var BrowseRequest = class _BrowseRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaBrowseRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.view = new ViewDescription(null);
          this.requestedMaxReferencesPerNode = 0;
          this.nodesToBrowse = null;
          return;
        }
        const schema = _BrowseRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.view = new ViewDescription(options.view);
        this.requestedMaxReferencesPerNode = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.requestedMaxReferencesPerNode);
        this.nodesToBrowse = [];
        if (options.nodesToBrowse) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.nodesToBrowse));
          this.nodesToBrowse = options.nodesToBrowse.map((e) => new BrowseDescription(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        this.view.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.requestedMaxReferencesPerNode, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.nodesToBrowse, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.view.decode(stream);
        this.requestedMaxReferencesPerNode = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.requestedMaxReferencesPerNode);
        this.nodesToBrowse = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new BrowseDescription(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaBrowseRequest;
      }
    };
    exports2.BrowseRequest = BrowseRequest;
    BrowseRequest.possibleFields = [
      "requestHeader",
      "view",
      "requestedMaxReferencesPerNode",
      "nodesToBrowse"
    ];
    BrowseRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(525, 0);
    BrowseRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(527, 0);
    BrowseRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(526, 0);
    BrowseRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15184, 0);
    BrowseRequest.schema.dataTypeNodeId = BrowseRequest.dataTypeNodeId;
    BrowseRequest.schema.encodingDefaultBinary = BrowseRequest.encodingDefaultBinary;
    BrowseRequest.schema.encodingDefaultXml = BrowseRequest.encodingDefaultXml;
    BrowseRequest.schema.encodingDefaultJson = BrowseRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(BrowseRequest.dataTypeNodeId, "BrowseRequest", BrowseRequest);
    var schemaBrowseResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "BrowseResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "Results",
          fieldType: "BrowseResult",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var BrowseResponse = class _BrowseResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaBrowseResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.results = null;
          this.diagnosticInfos = [];
          return;
        }
        const schema = _BrowseResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.results = [];
        if (options.results) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.results));
          this.results = options.results.map((e) => new BrowseResult(e));
        }
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.results, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.results = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new BrowseResult(null);
          obj.decode(stream1);
          return obj;
        });
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaBrowseResponse;
      }
    };
    exports2.BrowseResponse = BrowseResponse;
    BrowseResponse.possibleFields = [
      "responseHeader",
      "results",
      "diagnosticInfos"
    ];
    BrowseResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(528, 0);
    BrowseResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(530, 0);
    BrowseResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(529, 0);
    BrowseResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15185, 0);
    BrowseResponse.schema.dataTypeNodeId = BrowseResponse.dataTypeNodeId;
    BrowseResponse.schema.encodingDefaultBinary = BrowseResponse.encodingDefaultBinary;
    BrowseResponse.schema.encodingDefaultXml = BrowseResponse.encodingDefaultXml;
    BrowseResponse.schema.encodingDefaultJson = BrowseResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(BrowseResponse.dataTypeNodeId, "BrowseResponse", BrowseResponse);
    var schemaBuildInfo = (0, node_opcua_factory_1.buildStructuredType)({
      name: "BuildInfo",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ProductUri",
          fieldType: "String"
        },
        {
          name: "ManufacturerName",
          fieldType: "String"
        },
        {
          name: "ProductName",
          fieldType: "String"
        },
        {
          name: "SoftwareVersion",
          fieldType: "String"
        },
        {
          name: "BuildNumber",
          fieldType: "String"
        },
        {
          name: "BuildDate",
          fieldType: "DateTime"
        }
      ]
    });
    var BuildInfo = class _BuildInfo extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaBuildInfo;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.productUri = null;
          this.manufacturerName = null;
          this.productName = null;
          this.softwareVersion = null;
          this.buildNumber = null;
          this.buildDate = /* @__PURE__ */ new Date();
          return;
        }
        const schema = _BuildInfo.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.productUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.productUri);
        this.manufacturerName = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.manufacturerName);
        this.productName = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.productName);
        this.softwareVersion = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.softwareVersion);
        this.buildNumber = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.buildNumber);
        this.buildDate = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.buildDate);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.productUri, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.manufacturerName, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.productName, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.softwareVersion, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.buildNumber, stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.buildDate, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.productUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.productUri);
        this.manufacturerName = (0, node_opcua_basic_types_1.decodeString)(stream, this.manufacturerName);
        this.productName = (0, node_opcua_basic_types_1.decodeString)(stream, this.productName);
        this.softwareVersion = (0, node_opcua_basic_types_1.decodeString)(stream, this.softwareVersion);
        this.buildNumber = (0, node_opcua_basic_types_1.decodeString)(stream, this.buildNumber);
        this.buildDate = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.buildDate);
      }
      get schema() {
        return schemaBuildInfo;
      }
    };
    exports2.BuildInfo = BuildInfo;
    BuildInfo.possibleFields = [
      "productUri",
      "manufacturerName",
      "productName",
      "softwareVersion",
      "buildNumber",
      "buildDate"
    ];
    BuildInfo.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(338, 0);
    BuildInfo.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(340, 0);
    BuildInfo.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(339, 0);
    BuildInfo.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15361, 0);
    BuildInfo.schema.dataTypeNodeId = BuildInfo.dataTypeNodeId;
    BuildInfo.schema.encodingDefaultBinary = BuildInfo.encodingDefaultBinary;
    BuildInfo.schema.encodingDefaultXml = BuildInfo.encodingDefaultXml;
    BuildInfo.schema.encodingDefaultJson = BuildInfo.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(BuildInfo.dataTypeNodeId, "BuildInfo", BuildInfo);
    var schemaCallMethodRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "CallMethodRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ObjectId",
          fieldType: "NodeId"
        },
        {
          name: "MethodId",
          fieldType: "NodeId"
        },
        {
          name: "InputArguments",
          fieldType: "Variant",
          isArray: true
        }
      ]
    });
    var CallMethodRequest = class _CallMethodRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaCallMethodRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.objectId = new node_opcua_nodeid_1.NodeId(null);
          this.methodId = new node_opcua_nodeid_1.NodeId(null);
          this.inputArguments = [];
          return;
        }
        const schema = _CallMethodRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.objectId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.objectId);
        this.methodId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.methodId);
        this.inputArguments = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.inputArguments);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.objectId, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.methodId, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.inputArguments, stream, node_opcua_variant_1.encodeVariant);
      }
      decode(stream) {
        super.decode(stream);
        this.objectId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.objectId);
        this.methodId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.methodId);
        this.inputArguments = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_variant_1.decodeVariant);
      }
      get schema() {
        return schemaCallMethodRequest;
      }
    };
    exports2.CallMethodRequest = CallMethodRequest;
    CallMethodRequest.possibleFields = [
      "objectId",
      "methodId",
      "inputArguments"
    ];
    CallMethodRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(704, 0);
    CallMethodRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(706, 0);
    CallMethodRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(705, 0);
    CallMethodRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15289, 0);
    CallMethodRequest.schema.dataTypeNodeId = CallMethodRequest.dataTypeNodeId;
    CallMethodRequest.schema.encodingDefaultBinary = CallMethodRequest.encodingDefaultBinary;
    CallMethodRequest.schema.encodingDefaultXml = CallMethodRequest.encodingDefaultXml;
    CallMethodRequest.schema.encodingDefaultJson = CallMethodRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(CallMethodRequest.dataTypeNodeId, "CallMethodRequest", CallMethodRequest);
    var schemaCallMethodResult = (0, node_opcua_factory_1.buildStructuredType)({
      name: "CallMethodResult",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "StatusCode",
          fieldType: "StatusCode"
        },
        {
          name: "InputArgumentResults",
          fieldType: "StatusCode",
          isArray: true
        },
        {
          name: "InputArgumentDiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        },
        {
          name: "OutputArguments",
          fieldType: "Variant",
          isArray: true
        }
      ]
    });
    var CallMethodResult = class _CallMethodResult extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaCallMethodResult;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.statusCode = node_opcua_status_code_1.StatusCodes.Good;
          this.inputArgumentResults = [];
          this.inputArgumentDiagnosticInfos = [];
          this.outputArguments = [];
          return;
        }
        const schema = _CallMethodResult.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.statusCode = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.statusCode);
        this.inputArgumentResults = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.inputArgumentResults);
        this.inputArgumentDiagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.inputArgumentDiagnosticInfos);
        this.outputArguments = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[3], options?.outputArguments);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_status_code_1.encodeStatusCode)(this.statusCode, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.inputArgumentResults, stream, node_opcua_status_code_1.encodeStatusCode);
        (0, node_opcua_basic_types_1.encodeArray)(this.inputArgumentDiagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
        (0, node_opcua_basic_types_1.encodeArray)(this.outputArguments, stream, node_opcua_variant_1.encodeVariant);
      }
      decode(stream) {
        super.decode(stream);
        this.statusCode = (0, node_opcua_status_code_1.decodeStatusCode)(stream, this.statusCode);
        this.inputArgumentResults = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_status_code_1.decodeStatusCode);
        this.inputArgumentDiagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
        this.outputArguments = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_variant_1.decodeVariant);
      }
      get schema() {
        return schemaCallMethodResult;
      }
    };
    exports2.CallMethodResult = CallMethodResult;
    CallMethodResult.possibleFields = [
      "statusCode",
      "inputArgumentResults",
      "inputArgumentDiagnosticInfos",
      "outputArguments"
    ];
    CallMethodResult.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(707, 0);
    CallMethodResult.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(709, 0);
    CallMethodResult.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(708, 0);
    CallMethodResult.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15290, 0);
    CallMethodResult.schema.dataTypeNodeId = CallMethodResult.dataTypeNodeId;
    CallMethodResult.schema.encodingDefaultBinary = CallMethodResult.encodingDefaultBinary;
    CallMethodResult.schema.encodingDefaultXml = CallMethodResult.encodingDefaultXml;
    CallMethodResult.schema.encodingDefaultJson = CallMethodResult.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(CallMethodResult.dataTypeNodeId, "CallMethodResult", CallMethodResult);
    var schemaCallRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "CallRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "MethodsToCall",
          fieldType: "CallMethodRequest",
          isArray: true
        }
      ]
    });
    var CallRequest = class _CallRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaCallRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.methodsToCall = null;
          return;
        }
        const schema = _CallRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.methodsToCall = [];
        if (options.methodsToCall) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.methodsToCall));
          this.methodsToCall = options.methodsToCall.map((e) => new CallMethodRequest(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.methodsToCall, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.methodsToCall = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new CallMethodRequest(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaCallRequest;
      }
    };
    exports2.CallRequest = CallRequest;
    CallRequest.possibleFields = [
      "requestHeader",
      "methodsToCall"
    ];
    CallRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(710, 0);
    CallRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(712, 0);
    CallRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(711, 0);
    CallRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15291, 0);
    CallRequest.schema.dataTypeNodeId = CallRequest.dataTypeNodeId;
    CallRequest.schema.encodingDefaultBinary = CallRequest.encodingDefaultBinary;
    CallRequest.schema.encodingDefaultXml = CallRequest.encodingDefaultXml;
    CallRequest.schema.encodingDefaultJson = CallRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(CallRequest.dataTypeNodeId, "CallRequest", CallRequest);
    var schemaCallResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "CallResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "Results",
          fieldType: "CallMethodResult",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var CallResponse = class _CallResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaCallResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.results = null;
          this.diagnosticInfos = [];
          return;
        }
        const schema = _CallResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.results = [];
        if (options.results) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.results));
          this.results = options.results.map((e) => new CallMethodResult(e));
        }
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.results, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.results = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new CallMethodResult(null);
          obj.decode(stream1);
          return obj;
        });
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaCallResponse;
      }
    };
    exports2.CallResponse = CallResponse;
    CallResponse.possibleFields = [
      "responseHeader",
      "results",
      "diagnosticInfos"
    ];
    CallResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(713, 0);
    CallResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(715, 0);
    CallResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(714, 0);
    CallResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15292, 0);
    CallResponse.schema.dataTypeNodeId = CallResponse.dataTypeNodeId;
    CallResponse.schema.encodingDefaultBinary = CallResponse.encodingDefaultBinary;
    CallResponse.schema.encodingDefaultXml = CallResponse.encodingDefaultXml;
    CallResponse.schema.encodingDefaultJson = CallResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(CallResponse.dataTypeNodeId, "CallResponse", CallResponse);
    var schemaCancelRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "CancelRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "RequestHandle",
          fieldType: "UInt32"
        }
      ]
    });
    var CancelRequest = class _CancelRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaCancelRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.requestHandle = 0;
          return;
        }
        const schema = _CancelRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.requestHandle = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.requestHandle);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.requestHandle, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.requestHandle = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.requestHandle);
      }
      get schema() {
        return schemaCancelRequest;
      }
    };
    exports2.CancelRequest = CancelRequest;
    CancelRequest.possibleFields = [
      "requestHeader",
      "requestHandle"
    ];
    CancelRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(477, 0);
    CancelRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(479, 0);
    CancelRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(478, 0);
    CancelRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15149, 0);
    CancelRequest.schema.dataTypeNodeId = CancelRequest.dataTypeNodeId;
    CancelRequest.schema.encodingDefaultBinary = CancelRequest.encodingDefaultBinary;
    CancelRequest.schema.encodingDefaultXml = CancelRequest.encodingDefaultXml;
    CancelRequest.schema.encodingDefaultJson = CancelRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(CancelRequest.dataTypeNodeId, "CancelRequest", CancelRequest);
    var schemaCancelResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "CancelResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "CancelCount",
          fieldType: "UInt32"
        }
      ]
    });
    var CancelResponse = class _CancelResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaCancelResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.cancelCount = 0;
          return;
        }
        const schema = _CancelResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.cancelCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.cancelCount);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.cancelCount, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.cancelCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.cancelCount);
      }
      get schema() {
        return schemaCancelResponse;
      }
    };
    exports2.CancelResponse = CancelResponse;
    CancelResponse.possibleFields = [
      "responseHeader",
      "cancelCount"
    ];
    CancelResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(480, 0);
    CancelResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(482, 0);
    CancelResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(481, 0);
    CancelResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15150, 0);
    CancelResponse.schema.dataTypeNodeId = CancelResponse.dataTypeNodeId;
    CancelResponse.schema.encodingDefaultBinary = CancelResponse.encodingDefaultBinary;
    CancelResponse.schema.encodingDefaultXml = CancelResponse.encodingDefaultXml;
    CancelResponse.schema.encodingDefaultJson = CancelResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(CancelResponse.dataTypeNodeId, "CancelResponse", CancelResponse);
    var schemaCartesianCoordinates = (0, node_opcua_factory_1.buildStructuredType)({
      name: "CartesianCoordinates",
      baseType: "ExtensionObject",
      fields: []
    });
    var CartesianCoordinates = class _CartesianCoordinates extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaCartesianCoordinates;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _CartesianCoordinates.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaCartesianCoordinates;
      }
    };
    exports2.CartesianCoordinates = CartesianCoordinates;
    CartesianCoordinates.possibleFields = [];
    CartesianCoordinates.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18809, 0);
    CartesianCoordinates.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18818, 0);
    CartesianCoordinates.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18854, 0);
    CartesianCoordinates.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(19067, 0);
    CartesianCoordinates.schema.dataTypeNodeId = CartesianCoordinates.dataTypeNodeId;
    CartesianCoordinates.schema.encodingDefaultBinary = CartesianCoordinates.encodingDefaultBinary;
    CartesianCoordinates.schema.encodingDefaultXml = CartesianCoordinates.encodingDefaultXml;
    CartesianCoordinates.schema.encodingDefaultJson = CartesianCoordinates.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(CartesianCoordinates.dataTypeNodeId, "CartesianCoordinates", CartesianCoordinates);
    var schemaChannelSecurityToken = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ChannelSecurityToken",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ChannelId",
          fieldType: "UInt32"
        },
        {
          name: "TokenId",
          fieldType: "UInt32"
        },
        {
          name: "CreatedAt",
          fieldType: "DateTime"
        },
        {
          name: "RevisedLifetime",
          fieldType: "UInt32"
        }
      ]
    });
    var ChannelSecurityToken = class _ChannelSecurityToken extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaChannelSecurityToken;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.channelId = 0;
          this.tokenId = 0;
          this.createdAt = /* @__PURE__ */ new Date();
          this.revisedLifetime = 0;
          return;
        }
        const schema = _ChannelSecurityToken.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.channelId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.channelId);
        this.tokenId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.tokenId);
        this.createdAt = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.createdAt);
        this.revisedLifetime = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.revisedLifetime);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.channelId, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.tokenId, stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.createdAt, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.revisedLifetime, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.channelId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.channelId);
        this.tokenId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.tokenId);
        this.createdAt = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.createdAt);
        this.revisedLifetime = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.revisedLifetime);
      }
      get schema() {
        return schemaChannelSecurityToken;
      }
    };
    exports2.ChannelSecurityToken = ChannelSecurityToken;
    ChannelSecurityToken.possibleFields = [
      "channelId",
      "tokenId",
      "createdAt",
      "revisedLifetime"
    ];
    ChannelSecurityToken.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(441, 0);
    ChannelSecurityToken.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(443, 0);
    ChannelSecurityToken.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(442, 0);
    ChannelSecurityToken.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15131, 0);
    ChannelSecurityToken.schema.dataTypeNodeId = ChannelSecurityToken.dataTypeNodeId;
    ChannelSecurityToken.schema.encodingDefaultBinary = ChannelSecurityToken.encodingDefaultBinary;
    ChannelSecurityToken.schema.encodingDefaultXml = ChannelSecurityToken.encodingDefaultXml;
    ChannelSecurityToken.schema.encodingDefaultJson = ChannelSecurityToken.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ChannelSecurityToken.dataTypeNodeId, "ChannelSecurityToken", ChannelSecurityToken);
    var schemaCloseSecureChannelRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "CloseSecureChannelRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        }
      ]
    });
    var CloseSecureChannelRequest = class _CloseSecureChannelRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaCloseSecureChannelRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          return;
        }
        const schema = _CloseSecureChannelRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
      }
      get schema() {
        return schemaCloseSecureChannelRequest;
      }
    };
    exports2.CloseSecureChannelRequest = CloseSecureChannelRequest;
    CloseSecureChannelRequest.possibleFields = [
      "requestHeader"
    ];
    CloseSecureChannelRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(450, 0);
    CloseSecureChannelRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(452, 0);
    CloseSecureChannelRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(451, 0);
    CloseSecureChannelRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15134, 0);
    CloseSecureChannelRequest.schema.dataTypeNodeId = CloseSecureChannelRequest.dataTypeNodeId;
    CloseSecureChannelRequest.schema.encodingDefaultBinary = CloseSecureChannelRequest.encodingDefaultBinary;
    CloseSecureChannelRequest.schema.encodingDefaultXml = CloseSecureChannelRequest.encodingDefaultXml;
    CloseSecureChannelRequest.schema.encodingDefaultJson = CloseSecureChannelRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(CloseSecureChannelRequest.dataTypeNodeId, "CloseSecureChannelRequest", CloseSecureChannelRequest);
    var schemaCloseSecureChannelResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "CloseSecureChannelResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        }
      ]
    });
    var CloseSecureChannelResponse = class _CloseSecureChannelResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaCloseSecureChannelResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          return;
        }
        const schema = _CloseSecureChannelResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
      }
      get schema() {
        return schemaCloseSecureChannelResponse;
      }
    };
    exports2.CloseSecureChannelResponse = CloseSecureChannelResponse;
    CloseSecureChannelResponse.possibleFields = [
      "responseHeader"
    ];
    CloseSecureChannelResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(453, 0);
    CloseSecureChannelResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(455, 0);
    CloseSecureChannelResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(454, 0);
    CloseSecureChannelResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15135, 0);
    CloseSecureChannelResponse.schema.dataTypeNodeId = CloseSecureChannelResponse.dataTypeNodeId;
    CloseSecureChannelResponse.schema.encodingDefaultBinary = CloseSecureChannelResponse.encodingDefaultBinary;
    CloseSecureChannelResponse.schema.encodingDefaultXml = CloseSecureChannelResponse.encodingDefaultXml;
    CloseSecureChannelResponse.schema.encodingDefaultJson = CloseSecureChannelResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(CloseSecureChannelResponse.dataTypeNodeId, "CloseSecureChannelResponse", CloseSecureChannelResponse);
    var schemaCloseSessionRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "CloseSessionRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "DeleteSubscriptions",
          fieldType: "Boolean"
        }
      ]
    });
    var CloseSessionRequest = class _CloseSessionRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaCloseSessionRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.deleteSubscriptions = false;
          return;
        }
        const schema = _CloseSessionRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.deleteSubscriptions = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.deleteSubscriptions);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.deleteSubscriptions, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.deleteSubscriptions = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.deleteSubscriptions);
      }
      get schema() {
        return schemaCloseSessionRequest;
      }
    };
    exports2.CloseSessionRequest = CloseSessionRequest;
    CloseSessionRequest.possibleFields = [
      "requestHeader",
      "deleteSubscriptions"
    ];
    CloseSessionRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(471, 0);
    CloseSessionRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(473, 0);
    CloseSessionRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(472, 0);
    CloseSessionRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15147, 0);
    CloseSessionRequest.schema.dataTypeNodeId = CloseSessionRequest.dataTypeNodeId;
    CloseSessionRequest.schema.encodingDefaultBinary = CloseSessionRequest.encodingDefaultBinary;
    CloseSessionRequest.schema.encodingDefaultXml = CloseSessionRequest.encodingDefaultXml;
    CloseSessionRequest.schema.encodingDefaultJson = CloseSessionRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(CloseSessionRequest.dataTypeNodeId, "CloseSessionRequest", CloseSessionRequest);
    var schemaCloseSessionResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "CloseSessionResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        }
      ]
    });
    var CloseSessionResponse = class _CloseSessionResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaCloseSessionResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          return;
        }
        const schema = _CloseSessionResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
      }
      get schema() {
        return schemaCloseSessionResponse;
      }
    };
    exports2.CloseSessionResponse = CloseSessionResponse;
    CloseSessionResponse.possibleFields = [
      "responseHeader"
    ];
    CloseSessionResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(474, 0);
    CloseSessionResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(476, 0);
    CloseSessionResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(475, 0);
    CloseSessionResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15148, 0);
    CloseSessionResponse.schema.dataTypeNodeId = CloseSessionResponse.dataTypeNodeId;
    CloseSessionResponse.schema.encodingDefaultBinary = CloseSessionResponse.encodingDefaultBinary;
    CloseSessionResponse.schema.encodingDefaultXml = CloseSessionResponse.encodingDefaultXml;
    CloseSessionResponse.schema.encodingDefaultJson = CloseSessionResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(CloseSessionResponse.dataTypeNodeId, "CloseSessionResponse", CloseSessionResponse);
    var schemaComplexNumberType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ComplexNumberType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Real",
          fieldType: "Float"
        },
        {
          name: "Imaginary",
          fieldType: "Float"
        }
      ]
    });
    var ComplexNumberType = class _ComplexNumberType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaComplexNumberType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.real = 0;
          this.imaginary = 0;
          return;
        }
        const schema = _ComplexNumberType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.real = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.real);
        this.imaginary = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.imaginary);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeFloat)(this.real, stream);
        (0, node_opcua_basic_types_1.encodeFloat)(this.imaginary, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.real = (0, node_opcua_basic_types_1.decodeFloat)(stream, this.real);
        this.imaginary = (0, node_opcua_basic_types_1.decodeFloat)(stream, this.imaginary);
      }
      get schema() {
        return schemaComplexNumberType;
      }
    };
    exports2.ComplexNumberType = ComplexNumberType;
    ComplexNumberType.possibleFields = [
      "real",
      "imaginary"
    ];
    ComplexNumberType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12171, 0);
    ComplexNumberType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12181, 0);
    ComplexNumberType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12173, 0);
    ComplexNumberType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15377, 0);
    ComplexNumberType.schema.dataTypeNodeId = ComplexNumberType.dataTypeNodeId;
    ComplexNumberType.schema.encodingDefaultBinary = ComplexNumberType.encodingDefaultBinary;
    ComplexNumberType.schema.encodingDefaultXml = ComplexNumberType.encodingDefaultXml;
    ComplexNumberType.schema.encodingDefaultJson = ComplexNumberType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ComplexNumberType.dataTypeNodeId, "ComplexNumberType", ComplexNumberType);
    var schemaConfigurationVersionDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ConfigurationVersionDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "MajorVersion",
          fieldType: "UInt32"
        },
        {
          name: "MinorVersion",
          fieldType: "UInt32"
        }
      ]
    });
    var ConfigurationVersionDataType = class _ConfigurationVersionDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaConfigurationVersionDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.majorVersion = 0;
          this.minorVersion = 0;
          return;
        }
        const schema = _ConfigurationVersionDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.majorVersion = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.majorVersion);
        this.minorVersion = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.minorVersion);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.majorVersion, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.minorVersion, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.majorVersion = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.majorVersion);
        this.minorVersion = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.minorVersion);
      }
      get schema() {
        return schemaConfigurationVersionDataType;
      }
    };
    exports2.ConfigurationVersionDataType = ConfigurationVersionDataType;
    ConfigurationVersionDataType.possibleFields = [
      "majorVersion",
      "minorVersion"
    ];
    ConfigurationVersionDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14593, 0);
    ConfigurationVersionDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14847, 0);
    ConfigurationVersionDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14803, 0);
    ConfigurationVersionDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15049, 0);
    ConfigurationVersionDataType.schema.dataTypeNodeId = ConfigurationVersionDataType.dataTypeNodeId;
    ConfigurationVersionDataType.schema.encodingDefaultBinary = ConfigurationVersionDataType.encodingDefaultBinary;
    ConfigurationVersionDataType.schema.encodingDefaultXml = ConfigurationVersionDataType.encodingDefaultXml;
    ConfigurationVersionDataType.schema.encodingDefaultJson = ConfigurationVersionDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ConfigurationVersionDataType.dataTypeNodeId, "ConfigurationVersionDataType", ConfigurationVersionDataType);
    var FilterOperator;
    (function(FilterOperator2) {
      FilterOperator2[FilterOperator2["Equals"] = 0] = "Equals";
      FilterOperator2[FilterOperator2["IsNull"] = 1] = "IsNull";
      FilterOperator2[FilterOperator2["GreaterThan"] = 2] = "GreaterThan";
      FilterOperator2[FilterOperator2["LessThan"] = 3] = "LessThan";
      FilterOperator2[FilterOperator2["GreaterThanOrEqual"] = 4] = "GreaterThanOrEqual";
      FilterOperator2[FilterOperator2["LessThanOrEqual"] = 5] = "LessThanOrEqual";
      FilterOperator2[FilterOperator2["Like"] = 6] = "Like";
      FilterOperator2[FilterOperator2["Not"] = 7] = "Not";
      FilterOperator2[FilterOperator2["Between"] = 8] = "Between";
      FilterOperator2[FilterOperator2["InList"] = 9] = "InList";
      FilterOperator2[FilterOperator2["And"] = 10] = "And";
      FilterOperator2[FilterOperator2["Or"] = 11] = "Or";
      FilterOperator2[FilterOperator2["Cast"] = 12] = "Cast";
      FilterOperator2[FilterOperator2["InView"] = 13] = "InView";
      FilterOperator2[FilterOperator2["OfType"] = 14] = "OfType";
      FilterOperator2[FilterOperator2["RelatedTo"] = 15] = "RelatedTo";
      FilterOperator2[FilterOperator2["BitwiseAnd"] = 16] = "BitwiseAnd";
      FilterOperator2[FilterOperator2["BitwiseOr"] = 17] = "BitwiseOr";
      FilterOperator2[FilterOperator2["Invalid"] = 4294967295] = "Invalid";
    })(FilterOperator || (exports2.FilterOperator = FilterOperator = {}));
    var schemaFilterOperator = {
      enumValues: FilterOperator,
      flaggable: false,
      minValue: 0,
      maxValue: 17,
      name: "FilterOperator"
    };
    function decodeFilterOperator(stream, _value) {
      let value = stream.readUInt32();
      value = value < schemaFilterOperator.minValue || value > schemaFilterOperator.maxValue ? FilterOperator.Invalid : value;
      return value;
    }
    function encodeFilterOperator(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationFilterOperator = (0, node_opcua_factory_1.registerEnumeration)(schemaFilterOperator);
    (0, node_opcua_assert_1.assert)(exports2._enumerationFilterOperator.isFlaggable === false);
    var schemaContentFilterElement = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ContentFilterElement",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "FilterOperator",
          fieldType: "FilterOperator"
        },
        {
          name: "FilterOperands",
          fieldType: "ExtensionObject",
          isArray: true
        }
      ]
    });
    var ContentFilterElement = class _ContentFilterElement extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaContentFilterElement;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.filterOperator = 0;
          this.filterOperands = [];
          return;
        }
        const schema = _ContentFilterElement.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.filterOperator = this.setFilterOperator((0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.filterOperator));
        this.filterOperands = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.filterOperands);
      }
      encode(stream) {
        super.encode(stream);
        encodeFilterOperator(this.filterOperator, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.filterOperands, stream, node_opcua_extension_object_1.encodeExtensionObject);
      }
      decode(stream) {
        super.decode(stream);
        this.filterOperator = decodeFilterOperator(stream, this.filterOperator);
        this.filterOperands = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_extension_object_1.decodeExtensionObject);
      }
      // Define Enumeration setters
      setFilterOperator(value) {
        const coercedValue = exports2._enumerationFilterOperator.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to FilterOperator :" + value);
        }
        this.filterOperator = coercedValue.value;
        return this.filterOperator;
      }
      get schema() {
        return schemaContentFilterElement;
      }
    };
    exports2.ContentFilterElement = ContentFilterElement;
    ContentFilterElement.possibleFields = [
      "filterOperator",
      "filterOperands"
    ];
    ContentFilterElement.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(583, 0);
    ContentFilterElement.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(585, 0);
    ContentFilterElement.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(584, 0);
    ContentFilterElement.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15204, 0);
    ContentFilterElement.schema.dataTypeNodeId = ContentFilterElement.dataTypeNodeId;
    ContentFilterElement.schema.encodingDefaultBinary = ContentFilterElement.encodingDefaultBinary;
    ContentFilterElement.schema.encodingDefaultXml = ContentFilterElement.encodingDefaultXml;
    ContentFilterElement.schema.encodingDefaultJson = ContentFilterElement.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ContentFilterElement.dataTypeNodeId, "ContentFilterElement", ContentFilterElement);
    var schemaContentFilter = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ContentFilter",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Elements",
          fieldType: "ContentFilterElement",
          isArray: true
        }
      ]
    });
    var ContentFilter = class _ContentFilter extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaContentFilter;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.elements = null;
          return;
        }
        const schema = _ContentFilter.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.elements = [];
        if (options.elements) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.elements));
          this.elements = options.elements.map((e) => new ContentFilterElement(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.elements, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.elements = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new ContentFilterElement(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaContentFilter;
      }
    };
    exports2.ContentFilter = ContentFilter;
    ContentFilter.possibleFields = [
      "elements"
    ];
    ContentFilter.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(586, 0);
    ContentFilter.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(588, 0);
    ContentFilter.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(587, 0);
    ContentFilter.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15205, 0);
    ContentFilter.schema.dataTypeNodeId = ContentFilter.dataTypeNodeId;
    ContentFilter.schema.encodingDefaultBinary = ContentFilter.encodingDefaultBinary;
    ContentFilter.schema.encodingDefaultXml = ContentFilter.encodingDefaultXml;
    ContentFilter.schema.encodingDefaultJson = ContentFilter.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ContentFilter.dataTypeNodeId, "ContentFilter", ContentFilter);
    var schemaContentFilterElementResult = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ContentFilterElementResult",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "StatusCode",
          fieldType: "StatusCode"
        },
        {
          name: "OperandStatusCodes",
          fieldType: "StatusCode",
          isArray: true
        },
        {
          name: "OperandDiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var ContentFilterElementResult = class _ContentFilterElementResult extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaContentFilterElementResult;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.statusCode = node_opcua_status_code_1.StatusCodes.Good;
          this.operandStatusCodes = [];
          this.operandDiagnosticInfos = [];
          return;
        }
        const schema = _ContentFilterElementResult.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.statusCode = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.statusCode);
        this.operandStatusCodes = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.operandStatusCodes);
        this.operandDiagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.operandDiagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_status_code_1.encodeStatusCode)(this.statusCode, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.operandStatusCodes, stream, node_opcua_status_code_1.encodeStatusCode);
        (0, node_opcua_basic_types_1.encodeArray)(this.operandDiagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.statusCode = (0, node_opcua_status_code_1.decodeStatusCode)(stream, this.statusCode);
        this.operandStatusCodes = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_status_code_1.decodeStatusCode);
        this.operandDiagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaContentFilterElementResult;
      }
    };
    exports2.ContentFilterElementResult = ContentFilterElementResult;
    ContentFilterElementResult.possibleFields = [
      "statusCode",
      "operandStatusCodes",
      "operandDiagnosticInfos"
    ];
    ContentFilterElementResult.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(604, 0);
    ContentFilterElementResult.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(606, 0);
    ContentFilterElementResult.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(605, 0);
    ContentFilterElementResult.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15211, 0);
    ContentFilterElementResult.schema.dataTypeNodeId = ContentFilterElementResult.dataTypeNodeId;
    ContentFilterElementResult.schema.encodingDefaultBinary = ContentFilterElementResult.encodingDefaultBinary;
    ContentFilterElementResult.schema.encodingDefaultXml = ContentFilterElementResult.encodingDefaultXml;
    ContentFilterElementResult.schema.encodingDefaultJson = ContentFilterElementResult.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ContentFilterElementResult.dataTypeNodeId, "ContentFilterElementResult", ContentFilterElementResult);
    var schemaContentFilterResult = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ContentFilterResult",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ElementResults",
          fieldType: "ContentFilterElementResult",
          isArray: true
        },
        {
          name: "ElementDiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var ContentFilterResult = class _ContentFilterResult extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaContentFilterResult;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.elementResults = null;
          this.elementDiagnosticInfos = [];
          return;
        }
        const schema = _ContentFilterResult.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.elementResults = [];
        if (options.elementResults) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.elementResults));
          this.elementResults = options.elementResults.map((e) => new ContentFilterElementResult(e));
        }
        this.elementDiagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.elementDiagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.elementResults, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.elementDiagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.elementResults = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new ContentFilterElementResult(null);
          obj.decode(stream1);
          return obj;
        });
        this.elementDiagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaContentFilterResult;
      }
    };
    exports2.ContentFilterResult = ContentFilterResult;
    ContentFilterResult.possibleFields = [
      "elementResults",
      "elementDiagnosticInfos"
    ];
    ContentFilterResult.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(607, 0);
    ContentFilterResult.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(609, 0);
    ContentFilterResult.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(608, 0);
    ContentFilterResult.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15228, 0);
    ContentFilterResult.schema.dataTypeNodeId = ContentFilterResult.dataTypeNodeId;
    ContentFilterResult.schema.encodingDefaultBinary = ContentFilterResult.encodingDefaultBinary;
    ContentFilterResult.schema.encodingDefaultXml = ContentFilterResult.encodingDefaultXml;
    ContentFilterResult.schema.encodingDefaultJson = ContentFilterResult.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ContentFilterResult.dataTypeNodeId, "ContentFilterResult", ContentFilterResult);
    var schemaReadValueId = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ReadValueId",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "NodeId",
          fieldType: "NodeId"
        },
        {
          name: "AttributeId",
          fieldType: "UInt32"
        },
        {
          name: "IndexRange",
          fieldType: "NumericRange"
        },
        {
          name: "DataEncoding",
          fieldType: "QualifiedName"
        }
      ]
    });
    var ReadValueId = class _ReadValueId extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaReadValueId;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.nodeId = new node_opcua_nodeid_1.NodeId(null);
          this.attributeId = 0;
          this.indexRange = new node_opcua_numeric_range_1.NumericRange(null);
          this.dataEncoding = new node_opcua_data_model_1.QualifiedName(null);
          return;
        }
        const schema = _ReadValueId.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.nodeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.nodeId);
        this.attributeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.attributeId);
        this.indexRange = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.indexRange);
        this.dataEncoding = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.dataEncoding);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.nodeId, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.attributeId, stream);
        (0, node_opcua_numeric_range_1.encodeNumericRange)(this.indexRange, stream);
        (0, node_opcua_data_model_1.encodeQualifiedName)(this.dataEncoding, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.nodeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.nodeId);
        this.attributeId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.attributeId);
        this.indexRange = (0, node_opcua_numeric_range_1.decodeNumericRange)(stream, this.indexRange);
        this.dataEncoding = (0, node_opcua_data_model_1.decodeQualifiedName)(stream, this.dataEncoding);
      }
      get schema() {
        return schemaReadValueId;
      }
    };
    exports2.ReadValueId = ReadValueId;
    ReadValueId.possibleFields = [
      "nodeId",
      "attributeId",
      "indexRange",
      "dataEncoding"
    ];
    ReadValueId.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(626, 0);
    ReadValueId.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(628, 0);
    ReadValueId.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(627, 0);
    ReadValueId.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15256, 0);
    ReadValueId.schema.dataTypeNodeId = ReadValueId.dataTypeNodeId;
    ReadValueId.schema.encodingDefaultBinary = ReadValueId.encodingDefaultBinary;
    ReadValueId.schema.encodingDefaultXml = ReadValueId.encodingDefaultXml;
    ReadValueId.schema.encodingDefaultJson = ReadValueId.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ReadValueId.dataTypeNodeId, "ReadValueId", ReadValueId);
    var MonitoringMode;
    (function(MonitoringMode2) {
      MonitoringMode2[MonitoringMode2["Disabled"] = 0] = "Disabled";
      MonitoringMode2[MonitoringMode2["Sampling"] = 1] = "Sampling";
      MonitoringMode2[MonitoringMode2["Reporting"] = 2] = "Reporting";
      MonitoringMode2[MonitoringMode2["Invalid"] = 4294967295] = "Invalid";
    })(MonitoringMode || (exports2.MonitoringMode = MonitoringMode = {}));
    var schemaMonitoringMode = {
      enumValues: MonitoringMode,
      flaggable: false,
      minValue: 0,
      maxValue: 2,
      name: "MonitoringMode"
    };
    function decodeMonitoringMode(stream, _value) {
      let value = stream.readUInt32();
      value = value < schemaMonitoringMode.minValue || value > schemaMonitoringMode.maxValue ? MonitoringMode.Invalid : value;
      return value;
    }
    function encodeMonitoringMode(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationMonitoringMode = (0, node_opcua_factory_1.registerEnumeration)(schemaMonitoringMode);
    (0, node_opcua_assert_1.assert)(exports2._enumerationMonitoringMode.isFlaggable === false);
    var schemaMonitoringParameters = (0, node_opcua_factory_1.buildStructuredType)({
      name: "MonitoringParameters",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ClientHandle",
          fieldType: "UInt32"
        },
        {
          name: "SamplingInterval",
          fieldType: "Double"
        },
        {
          name: "Filter",
          fieldType: "ExtensionObject"
        },
        {
          name: "QueueSize",
          fieldType: "UInt32"
        },
        {
          name: "DiscardOldest",
          fieldType: "Boolean"
        }
      ]
    });
    var MonitoringParameters = class _MonitoringParameters extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaMonitoringParameters;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.clientHandle = 0;
          this.samplingInterval = 0;
          this.filter = null;
          this.queueSize = 0;
          this.discardOldest = false;
          return;
        }
        const schema = _MonitoringParameters.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.clientHandle = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.clientHandle);
        this.samplingInterval = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.samplingInterval);
        this.filter = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.filter);
        this.queueSize = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.queueSize);
        this.discardOldest = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.discardOldest);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.clientHandle, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.samplingInterval, stream);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.filter, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.queueSize, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.discardOldest, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.clientHandle = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.clientHandle);
        this.samplingInterval = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.samplingInterval);
        this.filter = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.filter);
        this.queueSize = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.queueSize);
        this.discardOldest = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.discardOldest);
      }
      get schema() {
        return schemaMonitoringParameters;
      }
    };
    exports2.MonitoringParameters = MonitoringParameters;
    MonitoringParameters.possibleFields = [
      "clientHandle",
      "samplingInterval",
      "filter",
      "queueSize",
      "discardOldest"
    ];
    MonitoringParameters.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(740, 0);
    MonitoringParameters.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(742, 0);
    MonitoringParameters.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(741, 0);
    MonitoringParameters.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15320, 0);
    MonitoringParameters.schema.dataTypeNodeId = MonitoringParameters.dataTypeNodeId;
    MonitoringParameters.schema.encodingDefaultBinary = MonitoringParameters.encodingDefaultBinary;
    MonitoringParameters.schema.encodingDefaultXml = MonitoringParameters.encodingDefaultXml;
    MonitoringParameters.schema.encodingDefaultJson = MonitoringParameters.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(MonitoringParameters.dataTypeNodeId, "MonitoringParameters", MonitoringParameters);
    var schemaMonitoredItemCreateRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "MonitoredItemCreateRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ItemToMonitor",
          fieldType: "ReadValueId"
        },
        {
          name: "MonitoringMode",
          fieldType: "MonitoringMode"
        },
        {
          name: "RequestedParameters",
          fieldType: "MonitoringParameters"
        }
      ]
    });
    var MonitoredItemCreateRequest = class _MonitoredItemCreateRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaMonitoredItemCreateRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.itemToMonitor = new ReadValueId(null);
          this.monitoringMode = 0;
          this.requestedParameters = new MonitoringParameters(null);
          return;
        }
        const schema = _MonitoredItemCreateRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.itemToMonitor = new ReadValueId(options.itemToMonitor);
        this.monitoringMode = this.setMonitoringMode((0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.monitoringMode));
        this.requestedParameters = new MonitoringParameters(options.requestedParameters);
      }
      encode(stream) {
        super.encode(stream);
        this.itemToMonitor.encode(stream);
        encodeMonitoringMode(this.monitoringMode, stream);
        this.requestedParameters.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.itemToMonitor.decode(stream);
        this.monitoringMode = decodeMonitoringMode(stream, this.monitoringMode);
        this.requestedParameters.decode(stream);
      }
      // Define Enumeration setters
      setMonitoringMode(value) {
        const coercedValue = exports2._enumerationMonitoringMode.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to MonitoringMode :" + value);
        }
        this.monitoringMode = coercedValue.value;
        return this.monitoringMode;
      }
      get schema() {
        return schemaMonitoredItemCreateRequest;
      }
    };
    exports2.MonitoredItemCreateRequest = MonitoredItemCreateRequest;
    MonitoredItemCreateRequest.possibleFields = [
      "itemToMonitor",
      "monitoringMode",
      "requestedParameters"
    ];
    MonitoredItemCreateRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(743, 0);
    MonitoredItemCreateRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(745, 0);
    MonitoredItemCreateRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(744, 0);
    MonitoredItemCreateRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15321, 0);
    MonitoredItemCreateRequest.schema.dataTypeNodeId = MonitoredItemCreateRequest.dataTypeNodeId;
    MonitoredItemCreateRequest.schema.encodingDefaultBinary = MonitoredItemCreateRequest.encodingDefaultBinary;
    MonitoredItemCreateRequest.schema.encodingDefaultXml = MonitoredItemCreateRequest.encodingDefaultXml;
    MonitoredItemCreateRequest.schema.encodingDefaultJson = MonitoredItemCreateRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(MonitoredItemCreateRequest.dataTypeNodeId, "MonitoredItemCreateRequest", MonitoredItemCreateRequest);
    var schemaCreateMonitoredItemsRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "CreateMonitoredItemsRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "SubscriptionId",
          fieldType: "UInt32"
        },
        {
          name: "TimestampsToReturn",
          fieldType: "TimestampsToReturn"
        },
        {
          name: "ItemsToCreate",
          fieldType: "MonitoredItemCreateRequest",
          isArray: true
        }
      ]
    });
    var CreateMonitoredItemsRequest = class _CreateMonitoredItemsRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaCreateMonitoredItemsRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.subscriptionId = 0;
          this.timestampsToReturn = 0;
          this.itemsToCreate = null;
          return;
        }
        const schema = _CreateMonitoredItemsRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.subscriptionId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.subscriptionId);
        this.timestampsToReturn = this.setTimestampsToReturn((0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.timestampsToReturn));
        this.itemsToCreate = [];
        if (options.itemsToCreate) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.itemsToCreate));
          this.itemsToCreate = options.itemsToCreate.map((e) => new MonitoredItemCreateRequest(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.subscriptionId, stream);
        (0, node_opcua_data_value_1.encodeTimestampsToReturn)(this.timestampsToReturn, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.itemsToCreate, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.subscriptionId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.subscriptionId);
        this.timestampsToReturn = (0, node_opcua_data_value_1.decodeTimestampsToReturn)(stream, this.timestampsToReturn);
        this.itemsToCreate = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new MonitoredItemCreateRequest(null);
          obj.decode(stream1);
          return obj;
        });
      }
      // Define Enumeration setters
      setTimestampsToReturn(value) {
        const coercedValue = node_opcua_data_value_1._enumerationTimestampsToReturn.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to TimestampsToReturn :" + value);
        }
        this.timestampsToReturn = coercedValue.value;
        return this.timestampsToReturn;
      }
      get schema() {
        return schemaCreateMonitoredItemsRequest;
      }
    };
    exports2.CreateMonitoredItemsRequest = CreateMonitoredItemsRequest;
    CreateMonitoredItemsRequest.possibleFields = [
      "requestHeader",
      "subscriptionId",
      "timestampsToReturn",
      "itemsToCreate"
    ];
    CreateMonitoredItemsRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(749, 0);
    CreateMonitoredItemsRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(751, 0);
    CreateMonitoredItemsRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(750, 0);
    CreateMonitoredItemsRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15323, 0);
    CreateMonitoredItemsRequest.schema.dataTypeNodeId = CreateMonitoredItemsRequest.dataTypeNodeId;
    CreateMonitoredItemsRequest.schema.encodingDefaultBinary = CreateMonitoredItemsRequest.encodingDefaultBinary;
    CreateMonitoredItemsRequest.schema.encodingDefaultXml = CreateMonitoredItemsRequest.encodingDefaultXml;
    CreateMonitoredItemsRequest.schema.encodingDefaultJson = CreateMonitoredItemsRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(CreateMonitoredItemsRequest.dataTypeNodeId, "CreateMonitoredItemsRequest", CreateMonitoredItemsRequest);
    var schemaMonitoredItemCreateResult = (0, node_opcua_factory_1.buildStructuredType)({
      name: "MonitoredItemCreateResult",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "StatusCode",
          fieldType: "StatusCode"
        },
        {
          name: "MonitoredItemId",
          fieldType: "UInt32"
        },
        {
          name: "RevisedSamplingInterval",
          fieldType: "Double"
        },
        {
          name: "RevisedQueueSize",
          fieldType: "UInt32"
        },
        {
          name: "FilterResult",
          fieldType: "ExtensionObject"
        }
      ]
    });
    var MonitoredItemCreateResult = class _MonitoredItemCreateResult extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaMonitoredItemCreateResult;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.statusCode = node_opcua_status_code_1.StatusCodes.Good;
          this.monitoredItemId = 0;
          this.revisedSamplingInterval = 0;
          this.revisedQueueSize = 0;
          this.filterResult = null;
          return;
        }
        const schema = _MonitoredItemCreateResult.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.statusCode = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.statusCode);
        this.monitoredItemId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.monitoredItemId);
        this.revisedSamplingInterval = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.revisedSamplingInterval);
        this.revisedQueueSize = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.revisedQueueSize);
        this.filterResult = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.filterResult);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_status_code_1.encodeStatusCode)(this.statusCode, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.monitoredItemId, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.revisedSamplingInterval, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.revisedQueueSize, stream);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.filterResult, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.statusCode = (0, node_opcua_status_code_1.decodeStatusCode)(stream, this.statusCode);
        this.monitoredItemId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.monitoredItemId);
        this.revisedSamplingInterval = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.revisedSamplingInterval);
        this.revisedQueueSize = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.revisedQueueSize);
        this.filterResult = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.filterResult);
      }
      get schema() {
        return schemaMonitoredItemCreateResult;
      }
    };
    exports2.MonitoredItemCreateResult = MonitoredItemCreateResult;
    MonitoredItemCreateResult.possibleFields = [
      "statusCode",
      "monitoredItemId",
      "revisedSamplingInterval",
      "revisedQueueSize",
      "filterResult"
    ];
    MonitoredItemCreateResult.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(746, 0);
    MonitoredItemCreateResult.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(748, 0);
    MonitoredItemCreateResult.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(747, 0);
    MonitoredItemCreateResult.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15322, 0);
    MonitoredItemCreateResult.schema.dataTypeNodeId = MonitoredItemCreateResult.dataTypeNodeId;
    MonitoredItemCreateResult.schema.encodingDefaultBinary = MonitoredItemCreateResult.encodingDefaultBinary;
    MonitoredItemCreateResult.schema.encodingDefaultXml = MonitoredItemCreateResult.encodingDefaultXml;
    MonitoredItemCreateResult.schema.encodingDefaultJson = MonitoredItemCreateResult.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(MonitoredItemCreateResult.dataTypeNodeId, "MonitoredItemCreateResult", MonitoredItemCreateResult);
    var schemaCreateMonitoredItemsResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "CreateMonitoredItemsResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "Results",
          fieldType: "MonitoredItemCreateResult",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var CreateMonitoredItemsResponse = class _CreateMonitoredItemsResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaCreateMonitoredItemsResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.results = null;
          this.diagnosticInfos = [];
          return;
        }
        const schema = _CreateMonitoredItemsResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.results = [];
        if (options.results) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.results));
          this.results = options.results.map((e) => new MonitoredItemCreateResult(e));
        }
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.results, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.results = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new MonitoredItemCreateResult(null);
          obj.decode(stream1);
          return obj;
        });
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaCreateMonitoredItemsResponse;
      }
    };
    exports2.CreateMonitoredItemsResponse = CreateMonitoredItemsResponse;
    CreateMonitoredItemsResponse.possibleFields = [
      "responseHeader",
      "results",
      "diagnosticInfos"
    ];
    CreateMonitoredItemsResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(752, 0);
    CreateMonitoredItemsResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(754, 0);
    CreateMonitoredItemsResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(753, 0);
    CreateMonitoredItemsResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15324, 0);
    CreateMonitoredItemsResponse.schema.dataTypeNodeId = CreateMonitoredItemsResponse.dataTypeNodeId;
    CreateMonitoredItemsResponse.schema.encodingDefaultBinary = CreateMonitoredItemsResponse.encodingDefaultBinary;
    CreateMonitoredItemsResponse.schema.encodingDefaultXml = CreateMonitoredItemsResponse.encodingDefaultXml;
    CreateMonitoredItemsResponse.schema.encodingDefaultJson = CreateMonitoredItemsResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(CreateMonitoredItemsResponse.dataTypeNodeId, "CreateMonitoredItemsResponse", CreateMonitoredItemsResponse);
    var schemaCreateSessionRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "CreateSessionRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "ClientDescription",
          fieldType: "ApplicationDescription"
        },
        {
          name: "ServerUri",
          fieldType: "String"
        },
        {
          name: "EndpointUrl",
          fieldType: "String"
        },
        {
          name: "SessionName",
          fieldType: "String"
        },
        {
          name: "ClientNonce",
          fieldType: "ByteString"
        },
        {
          name: "ClientCertificate",
          fieldType: "ByteString"
        },
        {
          name: "RequestedSessionTimeout",
          fieldType: "Double"
        },
        {
          name: "MaxResponseMessageSize",
          fieldType: "UInt32"
        }
      ]
    });
    var CreateSessionRequest = class _CreateSessionRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaCreateSessionRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.clientDescription = new ApplicationDescription(null);
          this.serverUri = null;
          this.endpointUrl = null;
          this.sessionName = null;
          this.clientNonce = Buffer.alloc(0);
          this.clientCertificate = Buffer.alloc(0);
          this.requestedSessionTimeout = 0;
          this.maxResponseMessageSize = 0;
          return;
        }
        const schema = _CreateSessionRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.clientDescription = new ApplicationDescription(options.clientDescription);
        this.serverUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.serverUri);
        this.endpointUrl = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.endpointUrl);
        this.sessionName = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.sessionName);
        this.clientNonce = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.clientNonce);
        this.clientCertificate = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.clientCertificate);
        this.requestedSessionTimeout = (0, node_opcua_factory_1.initialize_field)(schema.fields[7], options?.requestedSessionTimeout);
        this.maxResponseMessageSize = (0, node_opcua_factory_1.initialize_field)(schema.fields[8], options?.maxResponseMessageSize);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        this.clientDescription.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.serverUri, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.endpointUrl, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.sessionName, stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.clientNonce, stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.clientCertificate, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.requestedSessionTimeout, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.maxResponseMessageSize, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.clientDescription.decode(stream);
        this.serverUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.serverUri);
        this.endpointUrl = (0, node_opcua_basic_types_1.decodeString)(stream, this.endpointUrl);
        this.sessionName = (0, node_opcua_basic_types_1.decodeString)(stream, this.sessionName);
        this.clientNonce = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.clientNonce);
        this.clientCertificate = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.clientCertificate);
        this.requestedSessionTimeout = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.requestedSessionTimeout);
        this.maxResponseMessageSize = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.maxResponseMessageSize);
      }
      get schema() {
        return schemaCreateSessionRequest;
      }
    };
    exports2.CreateSessionRequest = CreateSessionRequest;
    CreateSessionRequest.possibleFields = [
      "requestHeader",
      "clientDescription",
      "serverUri",
      "endpointUrl",
      "sessionName",
      "clientNonce",
      "clientCertificate",
      "requestedSessionTimeout",
      "maxResponseMessageSize"
    ];
    CreateSessionRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(459, 0);
    CreateSessionRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(461, 0);
    CreateSessionRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(460, 0);
    CreateSessionRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15138, 0);
    CreateSessionRequest.schema.dataTypeNodeId = CreateSessionRequest.dataTypeNodeId;
    CreateSessionRequest.schema.encodingDefaultBinary = CreateSessionRequest.encodingDefaultBinary;
    CreateSessionRequest.schema.encodingDefaultXml = CreateSessionRequest.encodingDefaultXml;
    CreateSessionRequest.schema.encodingDefaultJson = CreateSessionRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(CreateSessionRequest.dataTypeNodeId, "CreateSessionRequest", CreateSessionRequest);
    var MessageSecurityMode;
    (function(MessageSecurityMode2) {
      MessageSecurityMode2[MessageSecurityMode2["Invalid"] = 0] = "Invalid";
      MessageSecurityMode2[MessageSecurityMode2["None"] = 1] = "None";
      MessageSecurityMode2[MessageSecurityMode2["Sign"] = 2] = "Sign";
      MessageSecurityMode2[MessageSecurityMode2["SignAndEncrypt"] = 3] = "SignAndEncrypt";
    })(MessageSecurityMode || (exports2.MessageSecurityMode = MessageSecurityMode = {}));
    var schemaMessageSecurityMode = {
      enumValues: MessageSecurityMode,
      flaggable: false,
      minValue: 0,
      maxValue: 3,
      name: "MessageSecurityMode"
    };
    function decodeMessageSecurityMode(stream, _value) {
      let value = stream.readUInt32();
      value = value < schemaMessageSecurityMode.minValue || value > schemaMessageSecurityMode.maxValue ? MessageSecurityMode.Invalid : value;
      return value;
    }
    function encodeMessageSecurityMode(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationMessageSecurityMode = (0, node_opcua_factory_1.registerEnumeration)(schemaMessageSecurityMode);
    (0, node_opcua_assert_1.assert)(exports2._enumerationMessageSecurityMode.isFlaggable === false);
    var UserTokenType;
    (function(UserTokenType2) {
      UserTokenType2[UserTokenType2["Anonymous"] = 0] = "Anonymous";
      UserTokenType2[UserTokenType2["UserName"] = 1] = "UserName";
      UserTokenType2[UserTokenType2["Certificate"] = 2] = "Certificate";
      UserTokenType2[UserTokenType2["IssuedToken"] = 3] = "IssuedToken";
      UserTokenType2[UserTokenType2["Invalid"] = 4294967295] = "Invalid";
    })(UserTokenType || (exports2.UserTokenType = UserTokenType = {}));
    var schemaUserTokenType = {
      enumValues: UserTokenType,
      flaggable: false,
      minValue: 0,
      maxValue: 3,
      name: "UserTokenType"
    };
    function decodeUserTokenType(stream, _value) {
      let value = stream.readUInt32();
      value = value < schemaUserTokenType.minValue || value > schemaUserTokenType.maxValue ? UserTokenType.Invalid : value;
      return value;
    }
    function encodeUserTokenType(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationUserTokenType = (0, node_opcua_factory_1.registerEnumeration)(schemaUserTokenType);
    (0, node_opcua_assert_1.assert)(exports2._enumerationUserTokenType.isFlaggable === false);
    var schemaUserTokenPolicy = (0, node_opcua_factory_1.buildStructuredType)({
      name: "UserTokenPolicy",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "PolicyId",
          fieldType: "String"
        },
        {
          name: "TokenType",
          fieldType: "UserTokenType"
        },
        {
          name: "IssuedTokenType",
          fieldType: "String"
        },
        {
          name: "IssuerEndpointUrl",
          fieldType: "String"
        },
        {
          name: "SecurityPolicyUri",
          fieldType: "String"
        }
      ]
    });
    var UserTokenPolicy = class _UserTokenPolicy extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaUserTokenPolicy;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.policyId = null;
          this.tokenType = 0;
          this.issuedTokenType = null;
          this.issuerEndpointUrl = null;
          this.securityPolicyUri = null;
          return;
        }
        const schema = _UserTokenPolicy.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.policyId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.policyId);
        this.tokenType = this.setTokenType((0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.tokenType));
        this.issuedTokenType = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.issuedTokenType);
        this.issuerEndpointUrl = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.issuerEndpointUrl);
        this.securityPolicyUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.securityPolicyUri);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.policyId, stream);
        encodeUserTokenType(this.tokenType, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.issuedTokenType, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.issuerEndpointUrl, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.securityPolicyUri, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.policyId = (0, node_opcua_basic_types_1.decodeString)(stream, this.policyId);
        this.tokenType = decodeUserTokenType(stream, this.tokenType);
        this.issuedTokenType = (0, node_opcua_basic_types_1.decodeString)(stream, this.issuedTokenType);
        this.issuerEndpointUrl = (0, node_opcua_basic_types_1.decodeString)(stream, this.issuerEndpointUrl);
        this.securityPolicyUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.securityPolicyUri);
      }
      // Define Enumeration setters
      setTokenType(value) {
        const coercedValue = exports2._enumerationUserTokenType.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to UserTokenType :" + value);
        }
        this.tokenType = coercedValue.value;
        return this.tokenType;
      }
      get schema() {
        return schemaUserTokenPolicy;
      }
    };
    exports2.UserTokenPolicy = UserTokenPolicy;
    UserTokenPolicy.possibleFields = [
      "policyId",
      "tokenType",
      "issuedTokenType",
      "issuerEndpointUrl",
      "securityPolicyUri"
    ];
    UserTokenPolicy.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(304, 0);
    UserTokenPolicy.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(306, 0);
    UserTokenPolicy.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(305, 0);
    UserTokenPolicy.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15098, 0);
    UserTokenPolicy.schema.dataTypeNodeId = UserTokenPolicy.dataTypeNodeId;
    UserTokenPolicy.schema.encodingDefaultBinary = UserTokenPolicy.encodingDefaultBinary;
    UserTokenPolicy.schema.encodingDefaultXml = UserTokenPolicy.encodingDefaultXml;
    UserTokenPolicy.schema.encodingDefaultJson = UserTokenPolicy.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(UserTokenPolicy.dataTypeNodeId, "UserTokenPolicy", UserTokenPolicy);
    var schemaEndpointDescription = (0, node_opcua_factory_1.buildStructuredType)({
      name: "EndpointDescription",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "EndpointUrl",
          fieldType: "String"
        },
        {
          name: "Server",
          fieldType: "ApplicationDescription"
        },
        {
          name: "ServerCertificate",
          fieldType: "ByteString"
        },
        {
          name: "SecurityMode",
          fieldType: "MessageSecurityMode"
        },
        {
          name: "SecurityPolicyUri",
          fieldType: "String"
        },
        {
          name: "UserIdentityTokens",
          fieldType: "UserTokenPolicy",
          isArray: true
        },
        {
          name: "TransportProfileUri",
          fieldType: "String"
        },
        {
          name: "SecurityLevel",
          fieldType: "Byte"
        }
      ]
    });
    var EndpointDescription = class _EndpointDescription extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaEndpointDescription;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.endpointUrl = null;
          this.server = new ApplicationDescription(null);
          this.serverCertificate = Buffer.alloc(0);
          this.securityMode = 0;
          this.securityPolicyUri = null;
          this.userIdentityTokens = null;
          this.transportProfileUri = null;
          this.securityLevel = 0;
          return;
        }
        const schema = _EndpointDescription.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.endpointUrl = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.endpointUrl);
        this.server = new ApplicationDescription(options.server);
        this.serverCertificate = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.serverCertificate);
        this.securityMode = this.setSecurityMode((0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.securityMode));
        this.securityPolicyUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.securityPolicyUri);
        this.userIdentityTokens = [];
        if (options.userIdentityTokens) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.userIdentityTokens));
          this.userIdentityTokens = options.userIdentityTokens.map((e) => new UserTokenPolicy(e));
        }
        this.transportProfileUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.transportProfileUri);
        this.securityLevel = (0, node_opcua_factory_1.initialize_field)(schema.fields[7], options?.securityLevel);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.endpointUrl, stream);
        this.server.encode(stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.serverCertificate, stream);
        encodeMessageSecurityMode(this.securityMode, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.securityPolicyUri, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.userIdentityTokens, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeString)(this.transportProfileUri, stream);
        (0, node_opcua_basic_types_1.encodeByte)(this.securityLevel, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.endpointUrl = (0, node_opcua_basic_types_1.decodeString)(stream, this.endpointUrl);
        this.server.decode(stream);
        this.serverCertificate = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.serverCertificate);
        this.securityMode = decodeMessageSecurityMode(stream, this.securityMode);
        this.securityPolicyUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.securityPolicyUri);
        this.userIdentityTokens = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new UserTokenPolicy(null);
          obj.decode(stream1);
          return obj;
        });
        this.transportProfileUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.transportProfileUri);
        this.securityLevel = (0, node_opcua_basic_types_1.decodeByte)(stream, this.securityLevel);
      }
      // Define Enumeration setters
      setSecurityMode(value) {
        const coercedValue = exports2._enumerationMessageSecurityMode.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to MessageSecurityMode :" + value);
        }
        this.securityMode = coercedValue.value;
        return this.securityMode;
      }
      get schema() {
        return schemaEndpointDescription;
      }
    };
    exports2.EndpointDescription = EndpointDescription;
    EndpointDescription.possibleFields = [
      "endpointUrl",
      "server",
      "serverCertificate",
      "securityMode",
      "securityPolicyUri",
      "userIdentityTokens",
      "transportProfileUri",
      "securityLevel"
    ];
    EndpointDescription.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(312, 0);
    EndpointDescription.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(314, 0);
    EndpointDescription.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(313, 0);
    EndpointDescription.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15099, 0);
    EndpointDescription.schema.dataTypeNodeId = EndpointDescription.dataTypeNodeId;
    EndpointDescription.schema.encodingDefaultBinary = EndpointDescription.encodingDefaultBinary;
    EndpointDescription.schema.encodingDefaultXml = EndpointDescription.encodingDefaultXml;
    EndpointDescription.schema.encodingDefaultJson = EndpointDescription.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(EndpointDescription.dataTypeNodeId, "EndpointDescription", EndpointDescription);
    var schemaCreateSessionResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "CreateSessionResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "SessionId",
          fieldType: "NodeId"
        },
        {
          name: "AuthenticationToken",
          fieldType: "NodeId"
        },
        {
          name: "RevisedSessionTimeout",
          fieldType: "Double"
        },
        {
          name: "ServerNonce",
          fieldType: "ByteString"
        },
        {
          name: "ServerCertificate",
          fieldType: "ByteString"
        },
        {
          name: "ServerEndpoints",
          fieldType: "EndpointDescription",
          isArray: true
        },
        {
          name: "ServerSoftwareCertificates",
          fieldType: "SignedSoftwareCertificate",
          isArray: true
        },
        {
          name: "ServerSignature",
          fieldType: "SignatureData"
        },
        {
          name: "MaxRequestMessageSize",
          fieldType: "UInt32"
        }
      ]
    });
    var CreateSessionResponse = class _CreateSessionResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaCreateSessionResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.sessionId = new node_opcua_nodeid_1.NodeId(null);
          this.authenticationToken = new node_opcua_nodeid_1.NodeId(null);
          this.revisedSessionTimeout = 0;
          this.serverNonce = Buffer.alloc(0);
          this.serverCertificate = Buffer.alloc(0);
          this.serverEndpoints = null;
          this.serverSoftwareCertificates = null;
          this.serverSignature = new SignatureData(null);
          this.maxRequestMessageSize = 0;
          return;
        }
        const schema = _CreateSessionResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.sessionId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.sessionId);
        this.authenticationToken = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.authenticationToken);
        this.revisedSessionTimeout = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.revisedSessionTimeout);
        this.serverNonce = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.serverNonce);
        this.serverCertificate = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.serverCertificate);
        this.serverEndpoints = [];
        if (options.serverEndpoints) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.serverEndpoints));
          this.serverEndpoints = options.serverEndpoints.map((e) => new EndpointDescription(e));
        }
        this.serverSoftwareCertificates = [];
        if (options.serverSoftwareCertificates) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.serverSoftwareCertificates));
          this.serverSoftwareCertificates = options.serverSoftwareCertificates.map((e) => new SignedSoftwareCertificate(e));
        }
        this.serverSignature = new SignatureData(options.serverSignature);
        this.maxRequestMessageSize = (0, node_opcua_factory_1.initialize_field)(schema.fields[9], options?.maxRequestMessageSize);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.sessionId, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.authenticationToken, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.revisedSessionTimeout, stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.serverNonce, stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.serverCertificate, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.serverEndpoints, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.serverSoftwareCertificates, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        this.serverSignature.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.maxRequestMessageSize, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.sessionId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.sessionId);
        this.authenticationToken = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.authenticationToken);
        this.revisedSessionTimeout = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.revisedSessionTimeout);
        this.serverNonce = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.serverNonce);
        this.serverCertificate = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.serverCertificate);
        this.serverEndpoints = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new EndpointDescription(null);
          obj.decode(stream1);
          return obj;
        });
        this.serverSoftwareCertificates = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new SignedSoftwareCertificate(null);
          obj.decode(stream1);
          return obj;
        });
        this.serverSignature.decode(stream);
        this.maxRequestMessageSize = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.maxRequestMessageSize);
      }
      get schema() {
        return schemaCreateSessionResponse;
      }
    };
    exports2.CreateSessionResponse = CreateSessionResponse;
    CreateSessionResponse.possibleFields = [
      "responseHeader",
      "sessionId",
      "authenticationToken",
      "revisedSessionTimeout",
      "serverNonce",
      "serverCertificate",
      "serverEndpoints",
      "serverSoftwareCertificates",
      "serverSignature",
      "maxRequestMessageSize"
    ];
    CreateSessionResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(462, 0);
    CreateSessionResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(464, 0);
    CreateSessionResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(463, 0);
    CreateSessionResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15139, 0);
    CreateSessionResponse.schema.dataTypeNodeId = CreateSessionResponse.dataTypeNodeId;
    CreateSessionResponse.schema.encodingDefaultBinary = CreateSessionResponse.encodingDefaultBinary;
    CreateSessionResponse.schema.encodingDefaultXml = CreateSessionResponse.encodingDefaultXml;
    CreateSessionResponse.schema.encodingDefaultJson = CreateSessionResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(CreateSessionResponse.dataTypeNodeId, "CreateSessionResponse", CreateSessionResponse);
    var schemaCreateSubscriptionRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "CreateSubscriptionRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "RequestedPublishingInterval",
          fieldType: "Double"
        },
        {
          name: "RequestedLifetimeCount",
          fieldType: "UInt32"
        },
        {
          name: "RequestedMaxKeepAliveCount",
          fieldType: "UInt32"
        },
        {
          name: "MaxNotificationsPerPublish",
          fieldType: "UInt32"
        },
        {
          name: "PublishingEnabled",
          fieldType: "Boolean"
        },
        {
          name: "Priority",
          fieldType: "Byte"
        }
      ]
    });
    var CreateSubscriptionRequest = class _CreateSubscriptionRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaCreateSubscriptionRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.requestedPublishingInterval = 0;
          this.requestedLifetimeCount = 0;
          this.requestedMaxKeepAliveCount = 0;
          this.maxNotificationsPerPublish = 0;
          this.publishingEnabled = false;
          this.priority = 0;
          return;
        }
        const schema = _CreateSubscriptionRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.requestedPublishingInterval = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.requestedPublishingInterval);
        this.requestedLifetimeCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.requestedLifetimeCount);
        this.requestedMaxKeepAliveCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.requestedMaxKeepAliveCount);
        this.maxNotificationsPerPublish = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.maxNotificationsPerPublish);
        this.publishingEnabled = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.publishingEnabled);
        this.priority = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.priority);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.requestedPublishingInterval, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.requestedLifetimeCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.requestedMaxKeepAliveCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.maxNotificationsPerPublish, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.publishingEnabled, stream);
        (0, node_opcua_basic_types_1.encodeByte)(this.priority, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.requestedPublishingInterval = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.requestedPublishingInterval);
        this.requestedLifetimeCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.requestedLifetimeCount);
        this.requestedMaxKeepAliveCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.requestedMaxKeepAliveCount);
        this.maxNotificationsPerPublish = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.maxNotificationsPerPublish);
        this.publishingEnabled = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.publishingEnabled);
        this.priority = (0, node_opcua_basic_types_1.decodeByte)(stream, this.priority);
      }
      get schema() {
        return schemaCreateSubscriptionRequest;
      }
    };
    exports2.CreateSubscriptionRequest = CreateSubscriptionRequest;
    CreateSubscriptionRequest.possibleFields = [
      "requestHeader",
      "requestedPublishingInterval",
      "requestedLifetimeCount",
      "requestedMaxKeepAliveCount",
      "maxNotificationsPerPublish",
      "publishingEnabled",
      "priority"
    ];
    CreateSubscriptionRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(785, 0);
    CreateSubscriptionRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(787, 0);
    CreateSubscriptionRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(786, 0);
    CreateSubscriptionRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15337, 0);
    CreateSubscriptionRequest.schema.dataTypeNodeId = CreateSubscriptionRequest.dataTypeNodeId;
    CreateSubscriptionRequest.schema.encodingDefaultBinary = CreateSubscriptionRequest.encodingDefaultBinary;
    CreateSubscriptionRequest.schema.encodingDefaultXml = CreateSubscriptionRequest.encodingDefaultXml;
    CreateSubscriptionRequest.schema.encodingDefaultJson = CreateSubscriptionRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(CreateSubscriptionRequest.dataTypeNodeId, "CreateSubscriptionRequest", CreateSubscriptionRequest);
    var schemaCreateSubscriptionResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "CreateSubscriptionResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "SubscriptionId",
          fieldType: "UInt32"
        },
        {
          name: "RevisedPublishingInterval",
          fieldType: "Double"
        },
        {
          name: "RevisedLifetimeCount",
          fieldType: "UInt32"
        },
        {
          name: "RevisedMaxKeepAliveCount",
          fieldType: "UInt32"
        }
      ]
    });
    var CreateSubscriptionResponse = class _CreateSubscriptionResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaCreateSubscriptionResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.subscriptionId = 0;
          this.revisedPublishingInterval = 0;
          this.revisedLifetimeCount = 0;
          this.revisedMaxKeepAliveCount = 0;
          return;
        }
        const schema = _CreateSubscriptionResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.subscriptionId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.subscriptionId);
        this.revisedPublishingInterval = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.revisedPublishingInterval);
        this.revisedLifetimeCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.revisedLifetimeCount);
        this.revisedMaxKeepAliveCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.revisedMaxKeepAliveCount);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.subscriptionId, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.revisedPublishingInterval, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.revisedLifetimeCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.revisedMaxKeepAliveCount, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.subscriptionId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.subscriptionId);
        this.revisedPublishingInterval = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.revisedPublishingInterval);
        this.revisedLifetimeCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.revisedLifetimeCount);
        this.revisedMaxKeepAliveCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.revisedMaxKeepAliveCount);
      }
      get schema() {
        return schemaCreateSubscriptionResponse;
      }
    };
    exports2.CreateSubscriptionResponse = CreateSubscriptionResponse;
    CreateSubscriptionResponse.possibleFields = [
      "responseHeader",
      "subscriptionId",
      "revisedPublishingInterval",
      "revisedLifetimeCount",
      "revisedMaxKeepAliveCount"
    ];
    CreateSubscriptionResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(788, 0);
    CreateSubscriptionResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(790, 0);
    CreateSubscriptionResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(789, 0);
    CreateSubscriptionResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15338, 0);
    CreateSubscriptionResponse.schema.dataTypeNodeId = CreateSubscriptionResponse.dataTypeNodeId;
    CreateSubscriptionResponse.schema.encodingDefaultBinary = CreateSubscriptionResponse.encodingDefaultBinary;
    CreateSubscriptionResponse.schema.encodingDefaultXml = CreateSubscriptionResponse.encodingDefaultXml;
    CreateSubscriptionResponse.schema.encodingDefaultJson = CreateSubscriptionResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(CreateSubscriptionResponse.dataTypeNodeId, "CreateSubscriptionResponse", CreateSubscriptionResponse);
    var schemaCurrencyUnitType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "CurrencyUnitType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "NumericCode",
          fieldType: "Int16"
        },
        {
          name: "Exponent",
          fieldType: "SByte"
        },
        {
          name: "AlphabeticCode",
          fieldType: "String"
        },
        {
          name: "Currency",
          fieldType: "LocalizedText"
        }
      ]
    });
    var CurrencyUnitType = class _CurrencyUnitType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaCurrencyUnitType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.numericCode = 0;
          this.exponent = 0;
          this.alphabeticCode = null;
          this.currency = new node_opcua_data_model_1.LocalizedText(null);
          return;
        }
        const schema = _CurrencyUnitType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.numericCode = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.numericCode);
        this.exponent = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.exponent);
        this.alphabeticCode = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.alphabeticCode);
        this.currency = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.currency);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeInt16)(this.numericCode, stream);
        (0, node_opcua_basic_types_1.encodeSByte)(this.exponent, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.alphabeticCode, stream);
        (0, node_opcua_data_model_1.encodeLocalizedText)(this.currency, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.numericCode = (0, node_opcua_basic_types_1.decodeInt16)(stream, this.numericCode);
        this.exponent = (0, node_opcua_basic_types_1.decodeSByte)(stream, this.exponent);
        this.alphabeticCode = (0, node_opcua_basic_types_1.decodeString)(stream, this.alphabeticCode);
        this.currency = (0, node_opcua_data_model_1.decodeLocalizedText)(stream, this.currency);
      }
      get schema() {
        return schemaCurrencyUnitType;
      }
    };
    exports2.CurrencyUnitType = CurrencyUnitType;
    CurrencyUnitType.possibleFields = [
      "numericCode",
      "exponent",
      "alphabeticCode",
      "currency"
    ];
    CurrencyUnitType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23498, 0);
    CurrencyUnitType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23507, 0);
    CurrencyUnitType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23520, 0);
    CurrencyUnitType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23528, 0);
    CurrencyUnitType.schema.dataTypeNodeId = CurrencyUnitType.dataTypeNodeId;
    CurrencyUnitType.schema.encodingDefaultBinary = CurrencyUnitType.encodingDefaultBinary;
    CurrencyUnitType.schema.encodingDefaultXml = CurrencyUnitType.encodingDefaultXml;
    CurrencyUnitType.schema.encodingDefaultJson = CurrencyUnitType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(CurrencyUnitType.dataTypeNodeId, "CurrencyUnitType", CurrencyUnitType);
    var DataChangeTrigger;
    (function(DataChangeTrigger2) {
      DataChangeTrigger2[DataChangeTrigger2["Status"] = 0] = "Status";
      DataChangeTrigger2[DataChangeTrigger2["StatusValue"] = 1] = "StatusValue";
      DataChangeTrigger2[DataChangeTrigger2["StatusValueTimestamp"] = 2] = "StatusValueTimestamp";
      DataChangeTrigger2[DataChangeTrigger2["Invalid"] = 4294967295] = "Invalid";
    })(DataChangeTrigger || (exports2.DataChangeTrigger = DataChangeTrigger = {}));
    var schemaDataChangeTrigger = {
      enumValues: DataChangeTrigger,
      flaggable: false,
      minValue: 0,
      maxValue: 2,
      name: "DataChangeTrigger"
    };
    function decodeDataChangeTrigger(stream, _value) {
      let value = stream.readUInt32();
      value = value < schemaDataChangeTrigger.minValue || value > schemaDataChangeTrigger.maxValue ? DataChangeTrigger.Invalid : value;
      return value;
    }
    function encodeDataChangeTrigger(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationDataChangeTrigger = (0, node_opcua_factory_1.registerEnumeration)(schemaDataChangeTrigger);
    (0, node_opcua_assert_1.assert)(exports2._enumerationDataChangeTrigger.isFlaggable === false);
    var schemaDataChangeFilter = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DataChangeFilter",
      baseType: "MonitoringFilter",
      fields: [
        {
          name: "Trigger",
          fieldType: "DataChangeTrigger"
        },
        {
          name: "DeadbandType",
          fieldType: "UInt32"
        },
        {
          name: "DeadbandValue",
          fieldType: "Double"
        }
      ]
    });
    var DataChangeFilter = class _DataChangeFilter extends MonitoringFilter {
      static get schema() {
        return schemaDataChangeFilter;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.trigger = 0;
          this.deadbandType = 0;
          this.deadbandValue = 0;
          return;
        }
        const schema = _DataChangeFilter.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.trigger = this.setTrigger((0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.trigger));
        this.deadbandType = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.deadbandType);
        this.deadbandValue = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.deadbandValue);
      }
      encode(stream) {
        super.encode(stream);
        encodeDataChangeTrigger(this.trigger, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.deadbandType, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.deadbandValue, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.trigger = decodeDataChangeTrigger(stream, this.trigger);
        this.deadbandType = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.deadbandType);
        this.deadbandValue = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.deadbandValue);
      }
      // Define Enumeration setters
      setTrigger(value) {
        const coercedValue = exports2._enumerationDataChangeTrigger.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to DataChangeTrigger :" + value);
        }
        this.trigger = coercedValue.value;
        return this.trigger;
      }
      get schema() {
        return schemaDataChangeFilter;
      }
    };
    exports2.DataChangeFilter = DataChangeFilter;
    DataChangeFilter.possibleFields = [
      "trigger",
      "deadbandType",
      "deadbandValue"
    ];
    DataChangeFilter.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(722, 0);
    DataChangeFilter.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(724, 0);
    DataChangeFilter.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(723, 0);
    DataChangeFilter.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15294, 0);
    DataChangeFilter.schema.dataTypeNodeId = DataChangeFilter.dataTypeNodeId;
    DataChangeFilter.schema.encodingDefaultBinary = DataChangeFilter.encodingDefaultBinary;
    DataChangeFilter.schema.encodingDefaultXml = DataChangeFilter.encodingDefaultXml;
    DataChangeFilter.schema.encodingDefaultJson = DataChangeFilter.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DataChangeFilter.dataTypeNodeId, "DataChangeFilter", DataChangeFilter);
    var schemaNotificationData = (0, node_opcua_factory_1.buildStructuredType)({
      name: "NotificationData",
      baseType: "ExtensionObject",
      fields: []
    });
    var NotificationData = class _NotificationData extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaNotificationData;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _NotificationData.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaNotificationData;
      }
    };
    exports2.NotificationData = NotificationData;
    NotificationData.possibleFields = [];
    NotificationData.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(945, 0);
    NotificationData.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(947, 0);
    NotificationData.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(946, 0);
    NotificationData.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15344, 0);
    NotificationData.schema.dataTypeNodeId = NotificationData.dataTypeNodeId;
    NotificationData.schema.encodingDefaultBinary = NotificationData.encodingDefaultBinary;
    NotificationData.schema.encodingDefaultXml = NotificationData.encodingDefaultXml;
    NotificationData.schema.encodingDefaultJson = NotificationData.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(NotificationData.dataTypeNodeId, "NotificationData", NotificationData);
    var schemaMonitoredItemNotification = (0, node_opcua_factory_1.buildStructuredType)({
      name: "MonitoredItemNotification",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ClientHandle",
          fieldType: "UInt32"
        },
        {
          name: "Value",
          fieldType: "DataValue"
        }
      ]
    });
    var MonitoredItemNotification = class _MonitoredItemNotification extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaMonitoredItemNotification;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.clientHandle = 0;
          this.value = new node_opcua_data_value_1.DataValue(null);
          return;
        }
        const schema = _MonitoredItemNotification.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.clientHandle = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.clientHandle);
        this.value = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.value);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.clientHandle, stream);
        (0, node_opcua_data_value_1.encodeDataValue)(this.value, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.clientHandle = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.clientHandle);
        this.value = (0, node_opcua_data_value_1.decodeDataValue)(stream, this.value);
      }
      get schema() {
        return schemaMonitoredItemNotification;
      }
    };
    exports2.MonitoredItemNotification = MonitoredItemNotification;
    MonitoredItemNotification.possibleFields = [
      "clientHandle",
      "value"
    ];
    MonitoredItemNotification.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(806, 0);
    MonitoredItemNotification.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(808, 0);
    MonitoredItemNotification.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(807, 0);
    MonitoredItemNotification.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15346, 0);
    MonitoredItemNotification.schema.dataTypeNodeId = MonitoredItemNotification.dataTypeNodeId;
    MonitoredItemNotification.schema.encodingDefaultBinary = MonitoredItemNotification.encodingDefaultBinary;
    MonitoredItemNotification.schema.encodingDefaultXml = MonitoredItemNotification.encodingDefaultXml;
    MonitoredItemNotification.schema.encodingDefaultJson = MonitoredItemNotification.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(MonitoredItemNotification.dataTypeNodeId, "MonitoredItemNotification", MonitoredItemNotification);
    var schemaDataChangeNotification = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DataChangeNotification",
      baseType: "NotificationData",
      fields: [
        {
          name: "MonitoredItems",
          fieldType: "MonitoredItemNotification",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var DataChangeNotification = class _DataChangeNotification extends NotificationData {
      static get schema() {
        return schemaDataChangeNotification;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.monitoredItems = null;
          this.diagnosticInfos = [];
          return;
        }
        const schema = _DataChangeNotification.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.monitoredItems = [];
        if (options.monitoredItems) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.monitoredItems));
          this.monitoredItems = options.monitoredItems.map((e) => new MonitoredItemNotification(e));
        }
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.monitoredItems, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.monitoredItems = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new MonitoredItemNotification(null);
          obj.decode(stream1);
          return obj;
        });
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaDataChangeNotification;
      }
    };
    exports2.DataChangeNotification = DataChangeNotification;
    DataChangeNotification.possibleFields = [
      "monitoredItems",
      "diagnosticInfos"
    ];
    DataChangeNotification.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(809, 0);
    DataChangeNotification.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(811, 0);
    DataChangeNotification.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(810, 0);
    DataChangeNotification.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15345, 0);
    DataChangeNotification.schema.dataTypeNodeId = DataChangeNotification.dataTypeNodeId;
    DataChangeNotification.schema.encodingDefaultBinary = DataChangeNotification.encodingDefaultBinary;
    DataChangeNotification.schema.encodingDefaultXml = DataChangeNotification.encodingDefaultXml;
    DataChangeNotification.schema.encodingDefaultJson = DataChangeNotification.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DataChangeNotification.dataTypeNodeId, "DataChangeNotification", DataChangeNotification);
    var schemaDataTypeDescription = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DataTypeDescription",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "DataTypeId",
          fieldType: "NodeId"
        },
        {
          name: "Name",
          fieldType: "QualifiedName"
        }
      ]
    });
    var DataTypeDescription = class _DataTypeDescription extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDataTypeDescription;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.dataTypeId = new node_opcua_nodeid_1.NodeId(null);
          this.name = new node_opcua_data_model_1.QualifiedName(null);
          return;
        }
        const schema = _DataTypeDescription.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.dataTypeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.dataTypeId);
        this.name = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.name);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.dataTypeId, stream);
        (0, node_opcua_data_model_1.encodeQualifiedName)(this.name, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.dataTypeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.dataTypeId);
        this.name = (0, node_opcua_data_model_1.decodeQualifiedName)(stream, this.name);
      }
      get schema() {
        return schemaDataTypeDescription;
      }
    };
    exports2.DataTypeDescription = DataTypeDescription;
    DataTypeDescription.possibleFields = [
      "dataTypeId",
      "name"
    ];
    DataTypeDescription.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14525, 0);
    DataTypeDescription.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(125, 0);
    DataTypeDescription.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14796, 0);
    DataTypeDescription.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15057, 0);
    DataTypeDescription.schema.dataTypeNodeId = DataTypeDescription.dataTypeNodeId;
    DataTypeDescription.schema.encodingDefaultBinary = DataTypeDescription.encodingDefaultBinary;
    DataTypeDescription.schema.encodingDefaultXml = DataTypeDescription.encodingDefaultXml;
    DataTypeDescription.schema.encodingDefaultJson = DataTypeDescription.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DataTypeDescription.dataTypeNodeId, "DataTypeDescription", DataTypeDescription);
    var schemaDataTypeDefinition = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DataTypeDefinition",
      baseType: "ExtensionObject",
      fields: []
    });
    var DataTypeDefinition = class _DataTypeDefinition extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDataTypeDefinition;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _DataTypeDefinition.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaDataTypeDefinition;
      }
    };
    exports2.DataTypeDefinition = DataTypeDefinition;
    DataTypeDefinition.possibleFields = [];
    DataTypeDefinition.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(97, 0);
    DataTypeDefinition.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(121, 0);
    DataTypeDefinition.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14797, 0);
    DataTypeDefinition.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15063, 0);
    DataTypeDefinition.schema.dataTypeNodeId = DataTypeDefinition.dataTypeNodeId;
    DataTypeDefinition.schema.encodingDefaultBinary = DataTypeDefinition.encodingDefaultBinary;
    DataTypeDefinition.schema.encodingDefaultXml = DataTypeDefinition.encodingDefaultXml;
    DataTypeDefinition.schema.encodingDefaultJson = DataTypeDefinition.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DataTypeDefinition.dataTypeNodeId, "DataTypeDefinition", DataTypeDefinition);
    var StructureType;
    (function(StructureType2) {
      StructureType2[StructureType2["Structure"] = 0] = "Structure";
      StructureType2[StructureType2["StructureWithOptionalFields"] = 1] = "StructureWithOptionalFields";
      StructureType2[StructureType2["Union"] = 2] = "Union";
      StructureType2[StructureType2["StructureWithSubtypedValues"] = 3] = "StructureWithSubtypedValues";
      StructureType2[StructureType2["UnionWithSubtypedValues"] = 4] = "UnionWithSubtypedValues";
      StructureType2[StructureType2["Invalid"] = 4294967295] = "Invalid";
    })(StructureType || (exports2.StructureType = StructureType = {}));
    var schemaStructureType = {
      enumValues: StructureType,
      flaggable: false,
      minValue: 0,
      maxValue: 4,
      name: "StructureType"
    };
    function decodeStructureType(stream, _value) {
      let value = stream.readUInt32();
      value = value < schemaStructureType.minValue || value > schemaStructureType.maxValue ? StructureType.Invalid : value;
      return value;
    }
    function encodeStructureType(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationStructureType = (0, node_opcua_factory_1.registerEnumeration)(schemaStructureType);
    (0, node_opcua_assert_1.assert)(exports2._enumerationStructureType.isFlaggable === false);
    var schemaStructureField = (0, node_opcua_factory_1.buildStructuredType)({
      name: "StructureField",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Name",
          fieldType: "String"
        },
        {
          name: "Description",
          fieldType: "LocalizedText"
        },
        {
          name: "DataType",
          fieldType: "NodeId"
        },
        {
          name: "ValueRank",
          fieldType: "Int32"
        },
        {
          name: "ArrayDimensions",
          fieldType: "UInt32",
          isArray: true
        },
        {
          name: "MaxStringLength",
          fieldType: "UInt32"
        },
        {
          name: "IsOptional",
          fieldType: "Boolean"
        }
      ]
    });
    var StructureField = class _StructureField extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaStructureField;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.name = null;
          this.description = new node_opcua_data_model_1.LocalizedText(null);
          this.dataType = new node_opcua_nodeid_1.NodeId(null);
          this.valueRank = 0;
          this.arrayDimensions = [];
          this.maxStringLength = 0;
          this.isOptional = false;
          return;
        }
        const schema = _StructureField.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.name = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.name);
        this.description = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.description);
        this.dataType = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.dataType);
        this.valueRank = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.valueRank);
        this.arrayDimensions = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[4], options?.arrayDimensions);
        this.maxStringLength = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.maxStringLength);
        this.isOptional = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.isOptional);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.name, stream);
        (0, node_opcua_data_model_1.encodeLocalizedText)(this.description, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.dataType, stream);
        (0, node_opcua_basic_types_1.encodeInt32)(this.valueRank, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.arrayDimensions, stream, node_opcua_basic_types_1.encodeUInt32);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.maxStringLength, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.isOptional, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.name = (0, node_opcua_basic_types_1.decodeString)(stream, this.name);
        this.description = (0, node_opcua_data_model_1.decodeLocalizedText)(stream, this.description);
        this.dataType = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.dataType);
        this.valueRank = (0, node_opcua_basic_types_1.decodeInt32)(stream, this.valueRank);
        this.arrayDimensions = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeUInt32);
        this.maxStringLength = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.maxStringLength);
        this.isOptional = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.isOptional);
      }
      get schema() {
        return schemaStructureField;
      }
    };
    exports2.StructureField = StructureField;
    StructureField.possibleFields = [
      "name",
      "description",
      "dataType",
      "valueRank",
      "arrayDimensions",
      "maxStringLength",
      "isOptional"
    ];
    StructureField.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(101, 0);
    StructureField.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14844, 0);
    StructureField.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14800, 0);
    StructureField.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15065, 0);
    StructureField.schema.dataTypeNodeId = StructureField.dataTypeNodeId;
    StructureField.schema.encodingDefaultBinary = StructureField.encodingDefaultBinary;
    StructureField.schema.encodingDefaultXml = StructureField.encodingDefaultXml;
    StructureField.schema.encodingDefaultJson = StructureField.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(StructureField.dataTypeNodeId, "StructureField", StructureField);
    var schemaStructureDefinition = (0, node_opcua_factory_1.buildStructuredType)({
      name: "StructureDefinition",
      baseType: "DataTypeDefinition",
      fields: [
        {
          name: "DefaultEncodingId",
          fieldType: "NodeId"
        },
        {
          name: "BaseDataType",
          fieldType: "NodeId"
        },
        {
          name: "StructureType",
          fieldType: "StructureType"
        },
        {
          name: "Fields",
          fieldType: "StructureField",
          isArray: true
        }
      ]
    });
    var StructureDefinition = class _StructureDefinition extends DataTypeDefinition {
      static get schema() {
        return schemaStructureDefinition;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.defaultEncodingId = new node_opcua_nodeid_1.NodeId(null);
          this.baseDataType = new node_opcua_nodeid_1.NodeId(null);
          this.structureType = 0;
          this.fields = null;
          return;
        }
        const schema = _StructureDefinition.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.defaultEncodingId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.defaultEncodingId);
        this.baseDataType = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.baseDataType);
        this.structureType = this.setStructureType((0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.structureType));
        this.fields = [];
        if (options.fields) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.fields));
          this.fields = options.fields.map((e) => new StructureField(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.defaultEncodingId, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.baseDataType, stream);
        encodeStructureType(this.structureType, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.fields, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.defaultEncodingId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.defaultEncodingId);
        this.baseDataType = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.baseDataType);
        this.structureType = decodeStructureType(stream, this.structureType);
        this.fields = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new StructureField(null);
          obj.decode(stream1);
          return obj;
        });
      }
      // Define Enumeration setters
      setStructureType(value) {
        const coercedValue = exports2._enumerationStructureType.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to StructureType :" + value);
        }
        this.structureType = coercedValue.value;
        return this.structureType;
      }
      get schema() {
        return schemaStructureDefinition;
      }
    };
    exports2.StructureDefinition = StructureDefinition;
    StructureDefinition.possibleFields = [
      "defaultEncodingId",
      "baseDataType",
      "structureType",
      "fields"
    ];
    StructureDefinition.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(99, 0);
    StructureDefinition.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(122, 0);
    StructureDefinition.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14798, 0);
    StructureDefinition.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15066, 0);
    StructureDefinition.schema.dataTypeNodeId = StructureDefinition.dataTypeNodeId;
    StructureDefinition.schema.encodingDefaultBinary = StructureDefinition.encodingDefaultBinary;
    StructureDefinition.schema.encodingDefaultXml = StructureDefinition.encodingDefaultXml;
    StructureDefinition.schema.encodingDefaultJson = StructureDefinition.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(StructureDefinition.dataTypeNodeId, "StructureDefinition", StructureDefinition);
    var schemaStructureDescription = (0, node_opcua_factory_1.buildStructuredType)({
      name: "StructureDescription",
      baseType: "DataTypeDescription",
      fields: [
        {
          name: "StructureDefinition",
          fieldType: "StructureDefinition"
        }
      ]
    });
    var StructureDescription = class _StructureDescription extends DataTypeDescription {
      static get schema() {
        return schemaStructureDescription;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.structureDefinition = new StructureDefinition(null);
          return;
        }
        const schema = _StructureDescription.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.structureDefinition = new StructureDefinition(options.structureDefinition);
      }
      encode(stream) {
        super.encode(stream);
        this.structureDefinition.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.structureDefinition.decode(stream);
      }
      get schema() {
        return schemaStructureDescription;
      }
    };
    exports2.StructureDescription = StructureDescription;
    StructureDescription.possibleFields = [
      "dataTypeId",
      "name",
      "structureDefinition"
    ];
    StructureDescription.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15487, 0);
    StructureDescription.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(126, 0);
    StructureDescription.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15589, 0);
    StructureDescription.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15058, 0);
    StructureDescription.schema.dataTypeNodeId = StructureDescription.dataTypeNodeId;
    StructureDescription.schema.encodingDefaultBinary = StructureDescription.encodingDefaultBinary;
    StructureDescription.schema.encodingDefaultXml = StructureDescription.encodingDefaultXml;
    StructureDescription.schema.encodingDefaultJson = StructureDescription.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(StructureDescription.dataTypeNodeId, "StructureDescription", StructureDescription);
    var schemaEnumValueType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "EnumValueType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Value",
          fieldType: "Int64"
        },
        {
          name: "DisplayName",
          fieldType: "LocalizedText"
        },
        {
          name: "Description",
          fieldType: "LocalizedText"
        }
      ]
    });
    var EnumValueType = class _EnumValueType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaEnumValueType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.value = [];
          this.displayName = new node_opcua_data_model_1.LocalizedText(null);
          this.description = new node_opcua_data_model_1.LocalizedText(null);
          return;
        }
        const schema = _EnumValueType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.value = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.value);
        this.displayName = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.displayName);
        this.description = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.description);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeInt64)(this.value, stream);
        (0, node_opcua_data_model_1.encodeLocalizedText)(this.displayName, stream);
        (0, node_opcua_data_model_1.encodeLocalizedText)(this.description, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.value = (0, node_opcua_basic_types_1.decodeInt64)(stream, this.value);
        this.displayName = (0, node_opcua_data_model_1.decodeLocalizedText)(stream, this.displayName);
        this.description = (0, node_opcua_data_model_1.decodeLocalizedText)(stream, this.description);
      }
      get schema() {
        return schemaEnumValueType;
      }
    };
    exports2.EnumValueType = EnumValueType;
    EnumValueType.possibleFields = [
      "value",
      "displayName",
      "description"
    ];
    EnumValueType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(7594, 0);
    EnumValueType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(8251, 0);
    EnumValueType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(7616, 0);
    EnumValueType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15082, 0);
    EnumValueType.schema.dataTypeNodeId = EnumValueType.dataTypeNodeId;
    EnumValueType.schema.encodingDefaultBinary = EnumValueType.encodingDefaultBinary;
    EnumValueType.schema.encodingDefaultXml = EnumValueType.encodingDefaultXml;
    EnumValueType.schema.encodingDefaultJson = EnumValueType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(EnumValueType.dataTypeNodeId, "EnumValueType", EnumValueType);
    var schemaEnumField = (0, node_opcua_factory_1.buildStructuredType)({
      name: "EnumField",
      baseType: "EnumValueType",
      fields: [
        {
          name: "Name",
          fieldType: "String"
        }
      ]
    });
    var EnumField = class _EnumField extends EnumValueType {
      static get schema() {
        return schemaEnumField;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.name = null;
          return;
        }
        const schema = _EnumField.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.name = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.name);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.name, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.name = (0, node_opcua_basic_types_1.decodeString)(stream, this.name);
      }
      get schema() {
        return schemaEnumField;
      }
    };
    exports2.EnumField = EnumField;
    EnumField.possibleFields = [
      "value",
      "displayName",
      "description",
      "name"
    ];
    EnumField.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(102, 0);
    EnumField.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14845, 0);
    EnumField.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14801, 0);
    EnumField.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15083, 0);
    EnumField.schema.dataTypeNodeId = EnumField.dataTypeNodeId;
    EnumField.schema.encodingDefaultBinary = EnumField.encodingDefaultBinary;
    EnumField.schema.encodingDefaultXml = EnumField.encodingDefaultXml;
    EnumField.schema.encodingDefaultJson = EnumField.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(EnumField.dataTypeNodeId, "EnumField", EnumField);
    var schemaEnumDefinition = (0, node_opcua_factory_1.buildStructuredType)({
      name: "EnumDefinition",
      baseType: "DataTypeDefinition",
      fields: [
        {
          name: "Fields",
          fieldType: "EnumField",
          isArray: true
        }
      ]
    });
    var EnumDefinition = class _EnumDefinition extends DataTypeDefinition {
      static get schema() {
        return schemaEnumDefinition;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.fields = null;
          return;
        }
        const schema = _EnumDefinition.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.fields = [];
        if (options.fields) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.fields));
          this.fields = options.fields.map((e) => new EnumField(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.fields, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.fields = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new EnumField(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaEnumDefinition;
      }
    };
    exports2.EnumDefinition = EnumDefinition;
    EnumDefinition.possibleFields = [
      "fields"
    ];
    EnumDefinition.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(100, 0);
    EnumDefinition.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(123, 0);
    EnumDefinition.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14799, 0);
    EnumDefinition.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15067, 0);
    EnumDefinition.schema.dataTypeNodeId = EnumDefinition.dataTypeNodeId;
    EnumDefinition.schema.encodingDefaultBinary = EnumDefinition.encodingDefaultBinary;
    EnumDefinition.schema.encodingDefaultXml = EnumDefinition.encodingDefaultXml;
    EnumDefinition.schema.encodingDefaultJson = EnumDefinition.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(EnumDefinition.dataTypeNodeId, "EnumDefinition", EnumDefinition);
    var schemaEnumDescription = (0, node_opcua_factory_1.buildStructuredType)({
      name: "EnumDescription",
      baseType: "DataTypeDescription",
      fields: [
        {
          name: "EnumDefinition",
          fieldType: "EnumDefinition"
        },
        {
          name: "BuiltInType",
          fieldType: "Byte"
        }
      ]
    });
    var EnumDescription = class _EnumDescription extends DataTypeDescription {
      static get schema() {
        return schemaEnumDescription;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.enumDefinition = new EnumDefinition(null);
          this.builtInType = 0;
          return;
        }
        const schema = _EnumDescription.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.enumDefinition = new EnumDefinition(options.enumDefinition);
        this.builtInType = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.builtInType);
      }
      encode(stream) {
        super.encode(stream);
        this.enumDefinition.encode(stream);
        (0, node_opcua_basic_types_1.encodeByte)(this.builtInType, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.enumDefinition.decode(stream);
        this.builtInType = (0, node_opcua_basic_types_1.decodeByte)(stream, this.builtInType);
      }
      get schema() {
        return schemaEnumDescription;
      }
    };
    exports2.EnumDescription = EnumDescription;
    EnumDescription.possibleFields = [
      "dataTypeId",
      "name",
      "enumDefinition",
      "builtInType"
    ];
    EnumDescription.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15488, 0);
    EnumDescription.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(127, 0);
    EnumDescription.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15590, 0);
    EnumDescription.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15059, 0);
    EnumDescription.schema.dataTypeNodeId = EnumDescription.dataTypeNodeId;
    EnumDescription.schema.encodingDefaultBinary = EnumDescription.encodingDefaultBinary;
    EnumDescription.schema.encodingDefaultXml = EnumDescription.encodingDefaultXml;
    EnumDescription.schema.encodingDefaultJson = EnumDescription.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(EnumDescription.dataTypeNodeId, "EnumDescription", EnumDescription);
    var schemaSimpleTypeDescription = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SimpleTypeDescription",
      baseType: "DataTypeDescription",
      fields: [
        {
          name: "BaseDataType",
          fieldType: "NodeId"
        },
        {
          name: "BuiltInType",
          fieldType: "Byte"
        }
      ]
    });
    var SimpleTypeDescription = class _SimpleTypeDescription extends DataTypeDescription {
      static get schema() {
        return schemaSimpleTypeDescription;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.baseDataType = new node_opcua_nodeid_1.NodeId(null);
          this.builtInType = 0;
          return;
        }
        const schema = _SimpleTypeDescription.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.baseDataType = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.baseDataType);
        this.builtInType = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.builtInType);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.baseDataType, stream);
        (0, node_opcua_basic_types_1.encodeByte)(this.builtInType, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.baseDataType = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.baseDataType);
        this.builtInType = (0, node_opcua_basic_types_1.decodeByte)(stream, this.builtInType);
      }
      get schema() {
        return schemaSimpleTypeDescription;
      }
    };
    exports2.SimpleTypeDescription = SimpleTypeDescription;
    SimpleTypeDescription.possibleFields = [
      "dataTypeId",
      "name",
      "baseDataType",
      "builtInType"
    ];
    SimpleTypeDescription.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15005, 0);
    SimpleTypeDescription.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15421, 0);
    SimpleTypeDescription.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15529, 0);
    SimpleTypeDescription.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15700, 0);
    SimpleTypeDescription.schema.dataTypeNodeId = SimpleTypeDescription.dataTypeNodeId;
    SimpleTypeDescription.schema.encodingDefaultBinary = SimpleTypeDescription.encodingDefaultBinary;
    SimpleTypeDescription.schema.encodingDefaultXml = SimpleTypeDescription.encodingDefaultXml;
    SimpleTypeDescription.schema.encodingDefaultJson = SimpleTypeDescription.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(SimpleTypeDescription.dataTypeNodeId, "SimpleTypeDescription", SimpleTypeDescription);
    var schemaDataTypeSchemaHeader = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DataTypeSchemaHeader",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Namespaces",
          fieldType: "String",
          isArray: true
        },
        {
          name: "StructureDataTypes",
          fieldType: "StructureDescription",
          isArray: true
        },
        {
          name: "EnumDataTypes",
          fieldType: "EnumDescription",
          isArray: true
        },
        {
          name: "SimpleDataTypes",
          fieldType: "SimpleTypeDescription",
          isArray: true
        }
      ]
    });
    var DataTypeSchemaHeader = class _DataTypeSchemaHeader extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDataTypeSchemaHeader;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.namespaces = [];
          this.structureDataTypes = null;
          this.enumDataTypes = null;
          this.simpleDataTypes = null;
          return;
        }
        const schema = _DataTypeSchemaHeader.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.namespaces = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[0], options?.namespaces);
        this.structureDataTypes = [];
        if (options.structureDataTypes) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.structureDataTypes));
          this.structureDataTypes = options.structureDataTypes.map((e) => new StructureDescription(e));
        }
        this.enumDataTypes = [];
        if (options.enumDataTypes) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.enumDataTypes));
          this.enumDataTypes = options.enumDataTypes.map((e) => new EnumDescription(e));
        }
        this.simpleDataTypes = [];
        if (options.simpleDataTypes) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.simpleDataTypes));
          this.simpleDataTypes = options.simpleDataTypes.map((e) => new SimpleTypeDescription(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.namespaces, stream, node_opcua_basic_types_1.encodeString);
        (0, node_opcua_basic_types_1.encodeArray)(this.structureDataTypes, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.enumDataTypes, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.simpleDataTypes, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.namespaces = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
        this.structureDataTypes = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new StructureDescription(null);
          obj.decode(stream1);
          return obj;
        });
        this.enumDataTypes = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new EnumDescription(null);
          obj.decode(stream1);
          return obj;
        });
        this.simpleDataTypes = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new SimpleTypeDescription(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaDataTypeSchemaHeader;
      }
    };
    exports2.DataTypeSchemaHeader = DataTypeSchemaHeader;
    DataTypeSchemaHeader.possibleFields = [
      "namespaces",
      "structureDataTypes",
      "enumDataTypes",
      "simpleDataTypes"
    ];
    DataTypeSchemaHeader.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15534, 0);
    DataTypeSchemaHeader.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15676, 0);
    DataTypeSchemaHeader.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15950, 0);
    DataTypeSchemaHeader.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16151, 0);
    DataTypeSchemaHeader.schema.dataTypeNodeId = DataTypeSchemaHeader.dataTypeNodeId;
    DataTypeSchemaHeader.schema.encodingDefaultBinary = DataTypeSchemaHeader.encodingDefaultBinary;
    DataTypeSchemaHeader.schema.encodingDefaultXml = DataTypeSchemaHeader.encodingDefaultXml;
    DataTypeSchemaHeader.schema.encodingDefaultJson = DataTypeSchemaHeader.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DataTypeSchemaHeader.dataTypeNodeId, "DataTypeSchemaHeader", DataTypeSchemaHeader);
    var DataSetFieldFlags;
    (function(DataSetFieldFlags2) {
      DataSetFieldFlags2[DataSetFieldFlags2["None"] = 0] = "None";
      DataSetFieldFlags2[DataSetFieldFlags2["PromotedField"] = 1] = "PromotedField";
      DataSetFieldFlags2[DataSetFieldFlags2["Invalid"] = 4294967295] = "Invalid";
    })(DataSetFieldFlags || (exports2.DataSetFieldFlags = DataSetFieldFlags = {}));
    var schemaDataSetFieldFlags = {
      enumValues: DataSetFieldFlags,
      flaggable: false,
      minValue: 0,
      maxValue: 1,
      name: "DataSetFieldFlags"
    };
    function decodeDataSetFieldFlags(stream, _value) {
      let value = stream.readUInt16();
      value = value < schemaDataSetFieldFlags.minValue || value > schemaDataSetFieldFlags.maxValue ? DataSetFieldFlags.Invalid : value;
      return value;
    }
    function encodeDataSetFieldFlags(value, stream) {
      stream.writeUInt16(value);
    }
    exports2._enumerationDataSetFieldFlags = (0, node_opcua_factory_1.registerEnumeration)(schemaDataSetFieldFlags);
    (0, node_opcua_assert_1.assert)(exports2._enumerationDataSetFieldFlags.isFlaggable === false);
    var schemaFieldMetaData = (0, node_opcua_factory_1.buildStructuredType)({
      name: "FieldMetaData",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Name",
          fieldType: "String"
        },
        {
          name: "Description",
          fieldType: "LocalizedText"
        },
        {
          name: "FieldFlags",
          fieldType: "DataSetFieldFlags"
        },
        {
          name: "BuiltInType",
          fieldType: "Byte"
        },
        {
          name: "DataType",
          fieldType: "NodeId"
        },
        {
          name: "ValueRank",
          fieldType: "Int32"
        },
        {
          name: "ArrayDimensions",
          fieldType: "UInt32",
          isArray: true
        },
        {
          name: "MaxStringLength",
          fieldType: "UInt32"
        },
        {
          name: "DataSetFieldId",
          fieldType: "Guid"
        },
        {
          name: "Properties",
          fieldType: "KeyValuePair",
          isArray: true
        }
      ]
    });
    var FieldMetaData = class _FieldMetaData extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaFieldMetaData;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.name = null;
          this.description = new node_opcua_data_model_1.LocalizedText(null);
          this.fieldFlags = 0;
          this.builtInType = 0;
          this.dataType = new node_opcua_nodeid_1.NodeId(null);
          this.valueRank = 0;
          this.arrayDimensions = [];
          this.maxStringLength = 0;
          this.dataSetFieldId = "";
          this.properties = null;
          return;
        }
        const schema = _FieldMetaData.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.name = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.name);
        this.description = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.description);
        this.fieldFlags = this.setFieldFlags((0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.fieldFlags));
        this.builtInType = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.builtInType);
        this.dataType = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.dataType);
        this.valueRank = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.valueRank);
        this.arrayDimensions = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[6], options?.arrayDimensions);
        this.maxStringLength = (0, node_opcua_factory_1.initialize_field)(schema.fields[7], options?.maxStringLength);
        this.dataSetFieldId = (0, node_opcua_factory_1.initialize_field)(schema.fields[8], options?.dataSetFieldId);
        this.properties = [];
        if (options.properties) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.properties));
          this.properties = options.properties.map((e) => new KeyValuePair(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.name, stream);
        (0, node_opcua_data_model_1.encodeLocalizedText)(this.description, stream);
        encodeDataSetFieldFlags(this.fieldFlags, stream);
        (0, node_opcua_basic_types_1.encodeByte)(this.builtInType, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.dataType, stream);
        (0, node_opcua_basic_types_1.encodeInt32)(this.valueRank, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.arrayDimensions, stream, node_opcua_basic_types_1.encodeUInt32);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.maxStringLength, stream);
        (0, node_opcua_basic_types_1.encodeGuid)(this.dataSetFieldId, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.properties, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.name = (0, node_opcua_basic_types_1.decodeString)(stream, this.name);
        this.description = (0, node_opcua_data_model_1.decodeLocalizedText)(stream, this.description);
        this.fieldFlags = decodeDataSetFieldFlags(stream, this.fieldFlags);
        this.builtInType = (0, node_opcua_basic_types_1.decodeByte)(stream, this.builtInType);
        this.dataType = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.dataType);
        this.valueRank = (0, node_opcua_basic_types_1.decodeInt32)(stream, this.valueRank);
        this.arrayDimensions = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeUInt32);
        this.maxStringLength = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.maxStringLength);
        this.dataSetFieldId = (0, node_opcua_basic_types_1.decodeGuid)(stream, this.dataSetFieldId);
        this.properties = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new KeyValuePair(null);
          obj.decode(stream1);
          return obj;
        });
      }
      // Define Enumeration setters
      setFieldFlags(value) {
        const coercedValue = exports2._enumerationDataSetFieldFlags.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to DataSetFieldFlags :" + value);
        }
        this.fieldFlags = coercedValue.value;
        return this.fieldFlags;
      }
      get schema() {
        return schemaFieldMetaData;
      }
    };
    exports2.FieldMetaData = FieldMetaData;
    FieldMetaData.possibleFields = [
      "name",
      "description",
      "fieldFlags",
      "builtInType",
      "dataType",
      "valueRank",
      "arrayDimensions",
      "maxStringLength",
      "dataSetFieldId",
      "properties"
    ];
    FieldMetaData.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14524, 0);
    FieldMetaData.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14839, 0);
    FieldMetaData.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14795, 0);
    FieldMetaData.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15051, 0);
    FieldMetaData.schema.dataTypeNodeId = FieldMetaData.dataTypeNodeId;
    FieldMetaData.schema.encodingDefaultBinary = FieldMetaData.encodingDefaultBinary;
    FieldMetaData.schema.encodingDefaultXml = FieldMetaData.encodingDefaultXml;
    FieldMetaData.schema.encodingDefaultJson = FieldMetaData.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(FieldMetaData.dataTypeNodeId, "FieldMetaData", FieldMetaData);
    var schemaDataSetMetaDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DataSetMetaDataType",
      baseType: "DataTypeSchemaHeader",
      fields: [
        {
          name: "Name",
          fieldType: "String"
        },
        {
          name: "Description",
          fieldType: "LocalizedText"
        },
        {
          name: "Fields",
          fieldType: "FieldMetaData",
          isArray: true
        },
        {
          name: "DataSetClassId",
          fieldType: "Guid"
        },
        {
          name: "ConfigurationVersion",
          fieldType: "ConfigurationVersionDataType"
        }
      ]
    });
    var DataSetMetaDataType = class _DataSetMetaDataType extends DataTypeSchemaHeader {
      static get schema() {
        return schemaDataSetMetaDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.name = null;
          this.description = new node_opcua_data_model_1.LocalizedText(null);
          this.fields = null;
          this.dataSetClassId = "";
          this.configurationVersion = new ConfigurationVersionDataType(null);
          return;
        }
        const schema = _DataSetMetaDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.name = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.name);
        this.description = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.description);
        this.fields = [];
        if (options.fields) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.fields));
          this.fields = options.fields.map((e) => new FieldMetaData(e));
        }
        this.dataSetClassId = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.dataSetClassId);
        this.configurationVersion = new ConfigurationVersionDataType(options.configurationVersion);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.name, stream);
        (0, node_opcua_data_model_1.encodeLocalizedText)(this.description, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.fields, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeGuid)(this.dataSetClassId, stream);
        this.configurationVersion.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.name = (0, node_opcua_basic_types_1.decodeString)(stream, this.name);
        this.description = (0, node_opcua_data_model_1.decodeLocalizedText)(stream, this.description);
        this.fields = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new FieldMetaData(null);
          obj.decode(stream1);
          return obj;
        });
        this.dataSetClassId = (0, node_opcua_basic_types_1.decodeGuid)(stream, this.dataSetClassId);
        this.configurationVersion.decode(stream);
      }
      get schema() {
        return schemaDataSetMetaDataType;
      }
    };
    exports2.DataSetMetaDataType = DataSetMetaDataType;
    DataSetMetaDataType.possibleFields = [
      "namespaces",
      "structureDataTypes",
      "enumDataTypes",
      "simpleDataTypes",
      "name",
      "description",
      "fields",
      "dataSetClassId",
      "configurationVersion"
    ];
    DataSetMetaDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14523, 0);
    DataSetMetaDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(124, 0);
    DataSetMetaDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14794, 0);
    DataSetMetaDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15050, 0);
    DataSetMetaDataType.schema.dataTypeNodeId = DataSetMetaDataType.dataTypeNodeId;
    DataSetMetaDataType.schema.encodingDefaultBinary = DataSetMetaDataType.encodingDefaultBinary;
    DataSetMetaDataType.schema.encodingDefaultXml = DataSetMetaDataType.encodingDefaultXml;
    DataSetMetaDataType.schema.encodingDefaultJson = DataSetMetaDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DataSetMetaDataType.dataTypeNodeId, "DataSetMetaDataType", DataSetMetaDataType);
    var DataSetFieldContentMask;
    (function(DataSetFieldContentMask2) {
      DataSetFieldContentMask2[DataSetFieldContentMask2["None"] = 0] = "None";
      DataSetFieldContentMask2[DataSetFieldContentMask2["StatusCode"] = 1] = "StatusCode";
      DataSetFieldContentMask2[DataSetFieldContentMask2["SourceTimestamp"] = 2] = "SourceTimestamp";
      DataSetFieldContentMask2[DataSetFieldContentMask2["ServerTimestamp"] = 4] = "ServerTimestamp";
      DataSetFieldContentMask2[DataSetFieldContentMask2["SourcePicoSeconds"] = 8] = "SourcePicoSeconds";
      DataSetFieldContentMask2[DataSetFieldContentMask2["ServerPicoSeconds"] = 16] = "ServerPicoSeconds";
      DataSetFieldContentMask2[DataSetFieldContentMask2["RawData"] = 32] = "RawData";
    })(DataSetFieldContentMask || (exports2.DataSetFieldContentMask = DataSetFieldContentMask = {}));
    var schemaDataSetFieldContentMask = {
      enumValues: DataSetFieldContentMask,
      flaggable: true,
      name: "DataSetFieldContentMask"
    };
    function decodeDataSetFieldContentMask(stream, _value) {
      return stream.readUInt32();
    }
    function encodeDataSetFieldContentMask(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationDataSetFieldContentMask = (0, node_opcua_factory_1.registerEnumeration)(schemaDataSetFieldContentMask);
    (0, node_opcua_assert_1.assert)(exports2._enumerationDataSetFieldContentMask.isFlaggable === true);
    var schemaDataSetReaderDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DataSetReaderDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Name",
          fieldType: "String"
        },
        {
          name: "Enabled",
          fieldType: "Boolean"
        },
        {
          name: "PublisherId",
          fieldType: "Variant"
        },
        {
          name: "WriterGroupId",
          fieldType: "UInt16"
        },
        {
          name: "DataSetWriterId",
          fieldType: "UInt16"
        },
        {
          name: "DataSetMetaData",
          fieldType: "DataSetMetaDataType"
        },
        {
          name: "DataSetFieldContentMask",
          fieldType: "DataSetFieldContentMask"
        },
        {
          name: "MessageReceiveTimeout",
          fieldType: "Double"
        },
        {
          name: "KeyFrameCount",
          fieldType: "UInt32"
        },
        {
          name: "HeaderLayoutUri",
          fieldType: "String"
        },
        {
          name: "SecurityMode",
          fieldType: "MessageSecurityMode"
        },
        {
          name: "SecurityGroupId",
          fieldType: "String"
        },
        {
          name: "SecurityKeyServices",
          fieldType: "EndpointDescription",
          isArray: true
        },
        {
          name: "DataSetReaderProperties",
          fieldType: "KeyValuePair",
          isArray: true
        },
        {
          name: "TransportSettings",
          fieldType: "ExtensionObject"
        },
        {
          name: "MessageSettings",
          fieldType: "ExtensionObject"
        },
        {
          name: "SubscribedDataSet",
          fieldType: "ExtensionObject"
        }
      ]
    });
    var DataSetReaderDataType = class _DataSetReaderDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDataSetReaderDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.name = null;
          this.enabled = false;
          this.publisherId = new node_opcua_variant_1.Variant(null);
          this.writerGroupId = 0;
          this.dataSetWriterId = 0;
          this.dataSetMetaData = new DataSetMetaDataType(null);
          this.dataSetFieldContentMask = 0;
          this.messageReceiveTimeout = 0;
          this.keyFrameCount = 0;
          this.headerLayoutUri = null;
          this.securityMode = 0;
          this.securityGroupId = null;
          this.securityKeyServices = null;
          this.dataSetReaderProperties = null;
          this.transportSettings = null;
          this.messageSettings = null;
          this.subscribedDataSet = null;
          return;
        }
        const schema = _DataSetReaderDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.name = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.name);
        this.enabled = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.enabled);
        this.publisherId = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.publisherId);
        this.writerGroupId = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.writerGroupId);
        this.dataSetWriterId = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.dataSetWriterId);
        this.dataSetMetaData = new DataSetMetaDataType(options.dataSetMetaData);
        this.dataSetFieldContentMask = this.setDataSetFieldContentMask((0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.dataSetFieldContentMask));
        this.messageReceiveTimeout = (0, node_opcua_factory_1.initialize_field)(schema.fields[7], options?.messageReceiveTimeout);
        this.keyFrameCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[8], options?.keyFrameCount);
        this.headerLayoutUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[9], options?.headerLayoutUri);
        this.securityMode = this.setSecurityMode((0, node_opcua_factory_1.initialize_field)(schema.fields[10], options?.securityMode));
        this.securityGroupId = (0, node_opcua_factory_1.initialize_field)(schema.fields[11], options?.securityGroupId);
        this.securityKeyServices = [];
        if (options.securityKeyServices) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.securityKeyServices));
          this.securityKeyServices = options.securityKeyServices.map((e) => new EndpointDescription(e));
        }
        this.dataSetReaderProperties = [];
        if (options.dataSetReaderProperties) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.dataSetReaderProperties));
          this.dataSetReaderProperties = options.dataSetReaderProperties.map((e) => new KeyValuePair(e));
        }
        this.transportSettings = (0, node_opcua_factory_1.initialize_field)(schema.fields[14], options?.transportSettings);
        this.messageSettings = (0, node_opcua_factory_1.initialize_field)(schema.fields[15], options?.messageSettings);
        this.subscribedDataSet = (0, node_opcua_factory_1.initialize_field)(schema.fields[16], options?.subscribedDataSet);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.name, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.enabled, stream);
        (0, node_opcua_variant_1.encodeVariant)(this.publisherId, stream);
        (0, node_opcua_basic_types_1.encodeUInt16)(this.writerGroupId, stream);
        (0, node_opcua_basic_types_1.encodeUInt16)(this.dataSetWriterId, stream);
        this.dataSetMetaData.encode(stream);
        encodeDataSetFieldContentMask(this.dataSetFieldContentMask, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.messageReceiveTimeout, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.keyFrameCount, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.headerLayoutUri, stream);
        encodeMessageSecurityMode(this.securityMode, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.securityGroupId, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.securityKeyServices, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.dataSetReaderProperties, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.transportSettings, stream);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.messageSettings, stream);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.subscribedDataSet, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.name = (0, node_opcua_basic_types_1.decodeString)(stream, this.name);
        this.enabled = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.enabled);
        this.publisherId = (0, node_opcua_variant_1.decodeVariant)(stream, this.publisherId);
        this.writerGroupId = (0, node_opcua_basic_types_1.decodeUInt16)(stream, this.writerGroupId);
        this.dataSetWriterId = (0, node_opcua_basic_types_1.decodeUInt16)(stream, this.dataSetWriterId);
        this.dataSetMetaData.decode(stream);
        this.dataSetFieldContentMask = decodeDataSetFieldContentMask(stream, this.dataSetFieldContentMask);
        this.messageReceiveTimeout = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.messageReceiveTimeout);
        this.keyFrameCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.keyFrameCount);
        this.headerLayoutUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.headerLayoutUri);
        this.securityMode = decodeMessageSecurityMode(stream, this.securityMode);
        this.securityGroupId = (0, node_opcua_basic_types_1.decodeString)(stream, this.securityGroupId);
        this.securityKeyServices = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new EndpointDescription(null);
          obj.decode(stream1);
          return obj;
        });
        this.dataSetReaderProperties = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new KeyValuePair(null);
          obj.decode(stream1);
          return obj;
        });
        this.transportSettings = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.transportSettings);
        this.messageSettings = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.messageSettings);
        this.subscribedDataSet = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.subscribedDataSet);
      }
      // Define Enumeration setters
      setDataSetFieldContentMask(value) {
        const coercedValue = exports2._enumerationDataSetFieldContentMask.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to DataSetFieldContentMask :" + value);
        }
        this.dataSetFieldContentMask = coercedValue.value;
        return this.dataSetFieldContentMask;
      }
      setSecurityMode(value) {
        const coercedValue = exports2._enumerationMessageSecurityMode.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to MessageSecurityMode :" + value);
        }
        this.securityMode = coercedValue.value;
        return this.securityMode;
      }
      get schema() {
        return schemaDataSetReaderDataType;
      }
    };
    exports2.DataSetReaderDataType = DataSetReaderDataType;
    DataSetReaderDataType.possibleFields = [
      "name",
      "enabled",
      "publisherId",
      "writerGroupId",
      "dataSetWriterId",
      "dataSetMetaData",
      "dataSetFieldContentMask",
      "messageReceiveTimeout",
      "keyFrameCount",
      "headerLayoutUri",
      "securityMode",
      "securityGroupId",
      "securityKeyServices",
      "dataSetReaderProperties",
      "transportSettings",
      "messageSettings",
      "subscribedDataSet"
    ];
    DataSetReaderDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15623, 0);
    DataSetReaderDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15703, 0);
    DataSetReaderDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16007, 0);
    DataSetReaderDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16286, 0);
    DataSetReaderDataType.schema.dataTypeNodeId = DataSetReaderDataType.dataTypeNodeId;
    DataSetReaderDataType.schema.encodingDefaultBinary = DataSetReaderDataType.encodingDefaultBinary;
    DataSetReaderDataType.schema.encodingDefaultXml = DataSetReaderDataType.encodingDefaultXml;
    DataSetReaderDataType.schema.encodingDefaultJson = DataSetReaderDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DataSetReaderDataType.dataTypeNodeId, "DataSetReaderDataType", DataSetReaderDataType);
    var schemaDataSetReaderMessageDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DataSetReaderMessageDataType",
      baseType: "ExtensionObject",
      fields: []
    });
    var DataSetReaderMessageDataType = class _DataSetReaderMessageDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDataSetReaderMessageDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _DataSetReaderMessageDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaDataSetReaderMessageDataType;
      }
    };
    exports2.DataSetReaderMessageDataType = DataSetReaderMessageDataType;
    DataSetReaderMessageDataType.possibleFields = [];
    DataSetReaderMessageDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15629, 0);
    DataSetReaderMessageDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15706, 0);
    DataSetReaderMessageDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16009, 0);
    DataSetReaderMessageDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16288, 0);
    DataSetReaderMessageDataType.schema.dataTypeNodeId = DataSetReaderMessageDataType.dataTypeNodeId;
    DataSetReaderMessageDataType.schema.encodingDefaultBinary = DataSetReaderMessageDataType.encodingDefaultBinary;
    DataSetReaderMessageDataType.schema.encodingDefaultXml = DataSetReaderMessageDataType.encodingDefaultXml;
    DataSetReaderMessageDataType.schema.encodingDefaultJson = DataSetReaderMessageDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DataSetReaderMessageDataType.dataTypeNodeId, "DataSetReaderMessageDataType", DataSetReaderMessageDataType);
    var schemaDataSetWriterDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DataSetWriterDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Name",
          fieldType: "String"
        },
        {
          name: "Enabled",
          fieldType: "Boolean"
        },
        {
          name: "DataSetWriterId",
          fieldType: "UInt16"
        },
        {
          name: "DataSetFieldContentMask",
          fieldType: "DataSetFieldContentMask"
        },
        {
          name: "KeyFrameCount",
          fieldType: "UInt32"
        },
        {
          name: "DataSetName",
          fieldType: "String"
        },
        {
          name: "DataSetWriterProperties",
          fieldType: "KeyValuePair",
          isArray: true
        },
        {
          name: "TransportSettings",
          fieldType: "ExtensionObject"
        },
        {
          name: "MessageSettings",
          fieldType: "ExtensionObject"
        }
      ]
    });
    var DataSetWriterDataType = class _DataSetWriterDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDataSetWriterDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.name = null;
          this.enabled = false;
          this.dataSetWriterId = 0;
          this.dataSetFieldContentMask = 0;
          this.keyFrameCount = 0;
          this.dataSetName = null;
          this.dataSetWriterProperties = null;
          this.transportSettings = null;
          this.messageSettings = null;
          return;
        }
        const schema = _DataSetWriterDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.name = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.name);
        this.enabled = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.enabled);
        this.dataSetWriterId = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.dataSetWriterId);
        this.dataSetFieldContentMask = this.setDataSetFieldContentMask((0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.dataSetFieldContentMask));
        this.keyFrameCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.keyFrameCount);
        this.dataSetName = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.dataSetName);
        this.dataSetWriterProperties = [];
        if (options.dataSetWriterProperties) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.dataSetWriterProperties));
          this.dataSetWriterProperties = options.dataSetWriterProperties.map((e) => new KeyValuePair(e));
        }
        this.transportSettings = (0, node_opcua_factory_1.initialize_field)(schema.fields[7], options?.transportSettings);
        this.messageSettings = (0, node_opcua_factory_1.initialize_field)(schema.fields[8], options?.messageSettings);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.name, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.enabled, stream);
        (0, node_opcua_basic_types_1.encodeUInt16)(this.dataSetWriterId, stream);
        encodeDataSetFieldContentMask(this.dataSetFieldContentMask, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.keyFrameCount, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.dataSetName, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.dataSetWriterProperties, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.transportSettings, stream);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.messageSettings, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.name = (0, node_opcua_basic_types_1.decodeString)(stream, this.name);
        this.enabled = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.enabled);
        this.dataSetWriterId = (0, node_opcua_basic_types_1.decodeUInt16)(stream, this.dataSetWriterId);
        this.dataSetFieldContentMask = decodeDataSetFieldContentMask(stream, this.dataSetFieldContentMask);
        this.keyFrameCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.keyFrameCount);
        this.dataSetName = (0, node_opcua_basic_types_1.decodeString)(stream, this.dataSetName);
        this.dataSetWriterProperties = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new KeyValuePair(null);
          obj.decode(stream1);
          return obj;
        });
        this.transportSettings = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.transportSettings);
        this.messageSettings = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.messageSettings);
      }
      // Define Enumeration setters
      setDataSetFieldContentMask(value) {
        const coercedValue = exports2._enumerationDataSetFieldContentMask.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to DataSetFieldContentMask :" + value);
        }
        this.dataSetFieldContentMask = coercedValue.value;
        return this.dataSetFieldContentMask;
      }
      get schema() {
        return schemaDataSetWriterDataType;
      }
    };
    exports2.DataSetWriterDataType = DataSetWriterDataType;
    DataSetWriterDataType.possibleFields = [
      "name",
      "enabled",
      "dataSetWriterId",
      "dataSetFieldContentMask",
      "keyFrameCount",
      "dataSetName",
      "dataSetWriterProperties",
      "transportSettings",
      "messageSettings"
    ];
    DataSetWriterDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15597, 0);
    DataSetWriterDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15682, 0);
    DataSetWriterDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15955, 0);
    DataSetWriterDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16156, 0);
    DataSetWriterDataType.schema.dataTypeNodeId = DataSetWriterDataType.dataTypeNodeId;
    DataSetWriterDataType.schema.encodingDefaultBinary = DataSetWriterDataType.encodingDefaultBinary;
    DataSetWriterDataType.schema.encodingDefaultXml = DataSetWriterDataType.encodingDefaultXml;
    DataSetWriterDataType.schema.encodingDefaultJson = DataSetWriterDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DataSetWriterDataType.dataTypeNodeId, "DataSetWriterDataType", DataSetWriterDataType);
    var schemaDataSetWriterMessageDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DataSetWriterMessageDataType",
      baseType: "ExtensionObject",
      fields: []
    });
    var DataSetWriterMessageDataType = class _DataSetWriterMessageDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDataSetWriterMessageDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _DataSetWriterMessageDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaDataSetWriterMessageDataType;
      }
    };
    exports2.DataSetWriterMessageDataType = DataSetWriterMessageDataType;
    DataSetWriterMessageDataType.possibleFields = [];
    DataSetWriterMessageDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15605, 0);
    DataSetWriterMessageDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15688, 0);
    DataSetWriterMessageDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15987, 0);
    DataSetWriterMessageDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16158, 0);
    DataSetWriterMessageDataType.schema.dataTypeNodeId = DataSetWriterMessageDataType.dataTypeNodeId;
    DataSetWriterMessageDataType.schema.encodingDefaultBinary = DataSetWriterMessageDataType.encodingDefaultBinary;
    DataSetWriterMessageDataType.schema.encodingDefaultXml = DataSetWriterMessageDataType.encodingDefaultXml;
    DataSetWriterMessageDataType.schema.encodingDefaultJson = DataSetWriterMessageDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DataSetWriterMessageDataType.dataTypeNodeId, "DataSetWriterMessageDataType", DataSetWriterMessageDataType);
    var schemaNodeAttributes = (0, node_opcua_factory_1.buildStructuredType)({
      name: "NodeAttributes",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "SpecifiedAttributes",
          fieldType: "UInt32"
        },
        {
          name: "DisplayName",
          fieldType: "LocalizedText"
        },
        {
          name: "Description",
          fieldType: "LocalizedText"
        },
        {
          name: "WriteMask",
          fieldType: "UInt32"
        },
        {
          name: "UserWriteMask",
          fieldType: "UInt32"
        }
      ]
    });
    var NodeAttributes = class _NodeAttributes extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaNodeAttributes;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.specifiedAttributes = 0;
          this.displayName = new node_opcua_data_model_1.LocalizedText(null);
          this.description = new node_opcua_data_model_1.LocalizedText(null);
          this.writeMask = 0;
          this.userWriteMask = 0;
          return;
        }
        const schema = _NodeAttributes.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.specifiedAttributes = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.specifiedAttributes);
        this.displayName = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.displayName);
        this.description = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.description);
        this.writeMask = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.writeMask);
        this.userWriteMask = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.userWriteMask);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.specifiedAttributes, stream);
        (0, node_opcua_data_model_1.encodeLocalizedText)(this.displayName, stream);
        (0, node_opcua_data_model_1.encodeLocalizedText)(this.description, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.writeMask, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.userWriteMask, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.specifiedAttributes = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.specifiedAttributes);
        this.displayName = (0, node_opcua_data_model_1.decodeLocalizedText)(stream, this.displayName);
        this.description = (0, node_opcua_data_model_1.decodeLocalizedText)(stream, this.description);
        this.writeMask = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.writeMask);
        this.userWriteMask = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.userWriteMask);
      }
      get schema() {
        return schemaNodeAttributes;
      }
    };
    exports2.NodeAttributes = NodeAttributes;
    NodeAttributes.possibleFields = [
      "specifiedAttributes",
      "displayName",
      "description",
      "writeMask",
      "userWriteMask"
    ];
    NodeAttributes.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(349, 0);
    NodeAttributes.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(351, 0);
    NodeAttributes.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(350, 0);
    NodeAttributes.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15151, 0);
    NodeAttributes.schema.dataTypeNodeId = NodeAttributes.dataTypeNodeId;
    NodeAttributes.schema.encodingDefaultBinary = NodeAttributes.encodingDefaultBinary;
    NodeAttributes.schema.encodingDefaultXml = NodeAttributes.encodingDefaultXml;
    NodeAttributes.schema.encodingDefaultJson = NodeAttributes.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(NodeAttributes.dataTypeNodeId, "NodeAttributes", NodeAttributes);
    var schemaDataTypeAttributes = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DataTypeAttributes",
      baseType: "NodeAttributes",
      fields: [
        {
          name: "IsAbstract",
          fieldType: "Boolean"
        }
      ]
    });
    var DataTypeAttributes = class _DataTypeAttributes extends NodeAttributes {
      static get schema() {
        return schemaDataTypeAttributes;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.isAbstract = false;
          return;
        }
        const schema = _DataTypeAttributes.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.isAbstract = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.isAbstract);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.isAbstract, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.isAbstract = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.isAbstract);
      }
      get schema() {
        return schemaDataTypeAttributes;
      }
    };
    exports2.DataTypeAttributes = DataTypeAttributes;
    DataTypeAttributes.possibleFields = [
      "specifiedAttributes",
      "displayName",
      "description",
      "writeMask",
      "userWriteMask",
      "isAbstract"
    ];
    DataTypeAttributes.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(370, 0);
    DataTypeAttributes.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(372, 0);
    DataTypeAttributes.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(371, 0);
    DataTypeAttributes.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15161, 0);
    DataTypeAttributes.schema.dataTypeNodeId = DataTypeAttributes.dataTypeNodeId;
    DataTypeAttributes.schema.encodingDefaultBinary = DataTypeAttributes.encodingDefaultBinary;
    DataTypeAttributes.schema.encodingDefaultXml = DataTypeAttributes.encodingDefaultXml;
    DataTypeAttributes.schema.encodingDefaultJson = DataTypeAttributes.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DataTypeAttributes.dataTypeNodeId, "DataTypeAttributes", DataTypeAttributes);
    var PermissionType;
    (function(PermissionType2) {
      PermissionType2[PermissionType2["None"] = 0] = "None";
      PermissionType2[PermissionType2["Browse"] = 1] = "Browse";
      PermissionType2[PermissionType2["ReadRolePermissions"] = 2] = "ReadRolePermissions";
      PermissionType2[PermissionType2["WriteAttribute"] = 4] = "WriteAttribute";
      PermissionType2[PermissionType2["WriteRolePermissions"] = 8] = "WriteRolePermissions";
      PermissionType2[PermissionType2["WriteHistorizing"] = 16] = "WriteHistorizing";
      PermissionType2[PermissionType2["Read"] = 32] = "Read";
      PermissionType2[PermissionType2["Write"] = 64] = "Write";
      PermissionType2[PermissionType2["ReadHistory"] = 128] = "ReadHistory";
      PermissionType2[PermissionType2["InsertHistory"] = 256] = "InsertHistory";
      PermissionType2[PermissionType2["ModifyHistory"] = 512] = "ModifyHistory";
      PermissionType2[PermissionType2["DeleteHistory"] = 1024] = "DeleteHistory";
      PermissionType2[PermissionType2["ReceiveEvents"] = 2048] = "ReceiveEvents";
      PermissionType2[PermissionType2["Call"] = 4096] = "Call";
      PermissionType2[PermissionType2["AddReference"] = 8192] = "AddReference";
      PermissionType2[PermissionType2["RemoveReference"] = 16384] = "RemoveReference";
      PermissionType2[PermissionType2["DeleteNode"] = 32768] = "DeleteNode";
      PermissionType2[PermissionType2["AddNode"] = 65536] = "AddNode";
    })(PermissionType || (exports2.PermissionType = PermissionType = {}));
    var schemaPermissionType = {
      enumValues: PermissionType,
      flaggable: true,
      name: "PermissionType"
    };
    function decodePermissionType(stream, _value) {
      return stream.readUInt32();
    }
    function encodePermissionType(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationPermissionType = (0, node_opcua_factory_1.registerEnumeration)(schemaPermissionType);
    (0, node_opcua_assert_1.assert)(exports2._enumerationPermissionType.isFlaggable === true);
    var schemaRolePermissionType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "RolePermissionType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RoleId",
          fieldType: "NodeId"
        },
        {
          name: "Permissions",
          fieldType: "PermissionType"
        }
      ]
    });
    var RolePermissionType = class _RolePermissionType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaRolePermissionType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.roleId = new node_opcua_nodeid_1.NodeId(null);
          this.permissions = 0;
          return;
        }
        const schema = _RolePermissionType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.roleId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.roleId);
        this.permissions = this.setPermissions((0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.permissions));
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.roleId, stream);
        encodePermissionType(this.permissions, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.roleId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.roleId);
        this.permissions = decodePermissionType(stream, this.permissions);
      }
      // Define Enumeration setters
      setPermissions(value) {
        const coercedValue = exports2._enumerationPermissionType.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to PermissionType :" + value);
        }
        this.permissions = coercedValue.value;
        return this.permissions;
      }
      get schema() {
        return schemaRolePermissionType;
      }
    };
    exports2.RolePermissionType = RolePermissionType;
    RolePermissionType.possibleFields = [
      "roleId",
      "permissions"
    ];
    RolePermissionType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(96, 0);
    RolePermissionType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(128, 0);
    RolePermissionType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16126, 0);
    RolePermissionType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15062, 0);
    RolePermissionType.schema.dataTypeNodeId = RolePermissionType.dataTypeNodeId;
    RolePermissionType.schema.encodingDefaultBinary = RolePermissionType.encodingDefaultBinary;
    RolePermissionType.schema.encodingDefaultXml = RolePermissionType.encodingDefaultXml;
    RolePermissionType.schema.encodingDefaultJson = RolePermissionType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(RolePermissionType.dataTypeNodeId, "RolePermissionType", RolePermissionType);
    var schemaReferenceNode = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ReferenceNode",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ReferenceTypeId",
          fieldType: "NodeId"
        },
        {
          name: "IsInverse",
          fieldType: "Boolean"
        },
        {
          name: "TargetId",
          fieldType: "ExpandedNodeId"
        }
      ]
    });
    var ReferenceNode = class _ReferenceNode extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaReferenceNode;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.referenceTypeId = new node_opcua_nodeid_1.NodeId(null);
          this.isInverse = false;
          this.targetId = new node_opcua_nodeid_1.ExpandedNodeId(null);
          return;
        }
        const schema = _ReferenceNode.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.referenceTypeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.referenceTypeId);
        this.isInverse = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.isInverse);
        this.targetId = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.targetId);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.referenceTypeId, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.isInverse, stream);
        (0, node_opcua_basic_types_1.encodeExpandedNodeId)(this.targetId, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.referenceTypeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.referenceTypeId);
        this.isInverse = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.isInverse);
        this.targetId = (0, node_opcua_basic_types_1.decodeExpandedNodeId)(stream, this.targetId);
      }
      get schema() {
        return schemaReferenceNode;
      }
    };
    exports2.ReferenceNode = ReferenceNode;
    ReferenceNode.possibleFields = [
      "referenceTypeId",
      "isInverse",
      "targetId"
    ];
    ReferenceNode.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(285, 0);
    ReferenceNode.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(287, 0);
    ReferenceNode.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(286, 0);
    ReferenceNode.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15080, 0);
    ReferenceNode.schema.dataTypeNodeId = ReferenceNode.dataTypeNodeId;
    ReferenceNode.schema.encodingDefaultBinary = ReferenceNode.encodingDefaultBinary;
    ReferenceNode.schema.encodingDefaultXml = ReferenceNode.encodingDefaultXml;
    ReferenceNode.schema.encodingDefaultJson = ReferenceNode.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ReferenceNode.dataTypeNodeId, "ReferenceNode", ReferenceNode);
    var schemaNode = (0, node_opcua_factory_1.buildStructuredType)({
      name: "Node",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "NodeId",
          fieldType: "NodeId"
        },
        {
          name: "NodeClass",
          fieldType: "NodeClass"
        },
        {
          name: "BrowseName",
          fieldType: "QualifiedName"
        },
        {
          name: "DisplayName",
          fieldType: "LocalizedText"
        },
        {
          name: "Description",
          fieldType: "LocalizedText"
        },
        {
          name: "WriteMask",
          fieldType: "UInt32"
        },
        {
          name: "UserWriteMask",
          fieldType: "UInt32"
        },
        {
          name: "RolePermissions",
          fieldType: "RolePermissionType",
          isArray: true
        },
        {
          name: "UserRolePermissions",
          fieldType: "RolePermissionType",
          isArray: true
        },
        {
          name: "AccessRestrictions",
          fieldType: "UInt16"
        },
        {
          name: "References",
          fieldType: "ReferenceNode",
          isArray: true
        }
      ]
    });
    var Node = class _Node extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaNode;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.nodeId = new node_opcua_nodeid_1.NodeId(null);
          this.nodeClass = 0;
          this.browseName = new node_opcua_data_model_1.QualifiedName(null);
          this.displayName = new node_opcua_data_model_1.LocalizedText(null);
          this.description = new node_opcua_data_model_1.LocalizedText(null);
          this.writeMask = 0;
          this.userWriteMask = 0;
          this.rolePermissions = null;
          this.userRolePermissions = null;
          this.accessRestrictions = 0;
          this.references = null;
          return;
        }
        const schema = _Node.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.nodeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.nodeId);
        this.nodeClass = this.setNodeClass((0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.nodeClass));
        this.browseName = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.browseName);
        this.displayName = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.displayName);
        this.description = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.description);
        this.writeMask = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.writeMask);
        this.userWriteMask = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.userWriteMask);
        this.rolePermissions = [];
        if (options.rolePermissions) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.rolePermissions));
          this.rolePermissions = options.rolePermissions.map((e) => new RolePermissionType(e));
        }
        this.userRolePermissions = [];
        if (options.userRolePermissions) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.userRolePermissions));
          this.userRolePermissions = options.userRolePermissions.map((e) => new RolePermissionType(e));
        }
        this.accessRestrictions = (0, node_opcua_factory_1.initialize_field)(schema.fields[9], options?.accessRestrictions);
        this.references = [];
        if (options.references) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.references));
          this.references = options.references.map((e) => new ReferenceNode(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.nodeId, stream);
        encodeNodeClass(this.nodeClass, stream);
        (0, node_opcua_data_model_1.encodeQualifiedName)(this.browseName, stream);
        (0, node_opcua_data_model_1.encodeLocalizedText)(this.displayName, stream);
        (0, node_opcua_data_model_1.encodeLocalizedText)(this.description, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.writeMask, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.userWriteMask, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.rolePermissions, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.userRolePermissions, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeUInt16)(this.accessRestrictions, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.references, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.nodeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.nodeId);
        this.nodeClass = decodeNodeClass(stream, this.nodeClass);
        this.browseName = (0, node_opcua_data_model_1.decodeQualifiedName)(stream, this.browseName);
        this.displayName = (0, node_opcua_data_model_1.decodeLocalizedText)(stream, this.displayName);
        this.description = (0, node_opcua_data_model_1.decodeLocalizedText)(stream, this.description);
        this.writeMask = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.writeMask);
        this.userWriteMask = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.userWriteMask);
        this.rolePermissions = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new RolePermissionType(null);
          obj.decode(stream1);
          return obj;
        });
        this.userRolePermissions = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new RolePermissionType(null);
          obj.decode(stream1);
          return obj;
        });
        this.accessRestrictions = (0, node_opcua_basic_types_1.decodeUInt16)(stream, this.accessRestrictions);
        this.references = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new ReferenceNode(null);
          obj.decode(stream1);
          return obj;
        });
      }
      // Define Enumeration setters
      setNodeClass(value) {
        const coercedValue = exports2._enumerationNodeClass.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to NodeClass :" + value);
        }
        this.nodeClass = coercedValue.value;
        return this.nodeClass;
      }
      get schema() {
        return schemaNode;
      }
    };
    exports2.Node = Node;
    Node.possibleFields = [
      "nodeId",
      "nodeClass",
      "browseName",
      "displayName",
      "description",
      "writeMask",
      "userWriteMask",
      "rolePermissions",
      "userRolePermissions",
      "accessRestrictions",
      "references"
    ];
    Node.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(258, 0);
    Node.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(260, 0);
    Node.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(259, 0);
    Node.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15068, 0);
    Node.schema.dataTypeNodeId = Node.dataTypeNodeId;
    Node.schema.encodingDefaultBinary = Node.encodingDefaultBinary;
    Node.schema.encodingDefaultXml = Node.encodingDefaultXml;
    Node.schema.encodingDefaultJson = Node.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(Node.dataTypeNodeId, "Node", Node);
    var schemaTypeNode = (0, node_opcua_factory_1.buildStructuredType)({
      name: "TypeNode",
      baseType: "Node",
      fields: []
    });
    var TypeNode = class _TypeNode extends Node {
      static get schema() {
        return schemaTypeNode;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _TypeNode.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaTypeNode;
      }
    };
    exports2.TypeNode = TypeNode;
    TypeNode.possibleFields = [
      "nodeId",
      "nodeClass",
      "browseName",
      "displayName",
      "description",
      "writeMask",
      "userWriteMask",
      "rolePermissions",
      "userRolePermissions",
      "accessRestrictions",
      "references"
    ];
    TypeNode.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(11880, 0);
    TypeNode.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(11890, 0);
    TypeNode.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(11888, 0);
    TypeNode.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15070, 0);
    TypeNode.schema.dataTypeNodeId = TypeNode.dataTypeNodeId;
    TypeNode.schema.encodingDefaultBinary = TypeNode.encodingDefaultBinary;
    TypeNode.schema.encodingDefaultXml = TypeNode.encodingDefaultXml;
    TypeNode.schema.encodingDefaultJson = TypeNode.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(TypeNode.dataTypeNodeId, "TypeNode", TypeNode);
    var schemaDataTypeNode = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DataTypeNode",
      baseType: "TypeNode",
      fields: [
        {
          name: "RolePermissions",
          fieldType: "RolePermissionType",
          isArray: true
        },
        {
          name: "UserRolePermissions",
          fieldType: "RolePermissionType",
          isArray: true
        },
        {
          name: "References",
          fieldType: "ReferenceNode",
          isArray: true
        },
        {
          name: "IsAbstract",
          fieldType: "Boolean"
        },
        {
          name: "DataTypeDefinition",
          fieldType: "ExtensionObject"
        }
      ]
    });
    var DataTypeNode = class _DataTypeNode extends TypeNode {
      static get schema() {
        return schemaDataTypeNode;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.rolePermissions = null;
          this.userRolePermissions = null;
          this.references = null;
          this.isAbstract = false;
          this.dataTypeDefinition = null;
          return;
        }
        const schema = _DataTypeNode.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.rolePermissions = [];
        if (options.rolePermissions) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.rolePermissions));
          this.rolePermissions = options.rolePermissions.map((e) => new RolePermissionType(e));
        }
        this.userRolePermissions = [];
        if (options.userRolePermissions) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.userRolePermissions));
          this.userRolePermissions = options.userRolePermissions.map((e) => new RolePermissionType(e));
        }
        this.references = [];
        if (options.references) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.references));
          this.references = options.references.map((e) => new ReferenceNode(e));
        }
        this.isAbstract = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.isAbstract);
        this.dataTypeDefinition = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.dataTypeDefinition);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.rolePermissions, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.userRolePermissions, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.references, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeBoolean)(this.isAbstract, stream);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.dataTypeDefinition, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.rolePermissions = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new RolePermissionType(null);
          obj.decode(stream1);
          return obj;
        });
        this.userRolePermissions = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new RolePermissionType(null);
          obj.decode(stream1);
          return obj;
        });
        this.references = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new ReferenceNode(null);
          obj.decode(stream1);
          return obj;
        });
        this.isAbstract = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.isAbstract);
        this.dataTypeDefinition = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.dataTypeDefinition);
      }
      get schema() {
        return schemaDataTypeNode;
      }
    };
    exports2.DataTypeNode = DataTypeNode;
    DataTypeNode.possibleFields = [
      "nodeId",
      "nodeClass",
      "browseName",
      "displayName",
      "description",
      "writeMask",
      "userWriteMask",
      "rolePermissions",
      "userRolePermissions",
      "accessRestrictions",
      "references",
      "rolePermissions",
      "userRolePermissions",
      "references",
      "isAbstract",
      "dataTypeDefinition"
    ];
    DataTypeNode.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(282, 0);
    DataTypeNode.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(284, 0);
    DataTypeNode.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(283, 0);
    DataTypeNode.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15079, 0);
    DataTypeNode.schema.dataTypeNodeId = DataTypeNode.dataTypeNodeId;
    DataTypeNode.schema.encodingDefaultBinary = DataTypeNode.encodingDefaultBinary;
    DataTypeNode.schema.encodingDefaultXml = DataTypeNode.encodingDefaultXml;
    DataTypeNode.schema.encodingDefaultJson = DataTypeNode.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DataTypeNode.dataTypeNodeId, "DataTypeNode", DataTypeNode);
    var schemaDatagramConnectionTransportDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DatagramConnectionTransportDataType",
      baseType: "ConnectionTransportDataType",
      fields: [
        {
          name: "DiscoveryAddress",
          fieldType: "ExtensionObject"
        }
      ]
    });
    var DatagramConnectionTransportDataType = class _DatagramConnectionTransportDataType extends ConnectionTransportDataType {
      static get schema() {
        return schemaDatagramConnectionTransportDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.discoveryAddress = null;
          return;
        }
        const schema = _DatagramConnectionTransportDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.discoveryAddress = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.discoveryAddress);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.discoveryAddress, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.discoveryAddress = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.discoveryAddress);
      }
      get schema() {
        return schemaDatagramConnectionTransportDataType;
      }
    };
    exports2.DatagramConnectionTransportDataType = DatagramConnectionTransportDataType;
    DatagramConnectionTransportDataType.possibleFields = [
      "discoveryAddress"
    ];
    DatagramConnectionTransportDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(17467, 0);
    DatagramConnectionTransportDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(17468, 0);
    DatagramConnectionTransportDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(17472, 0);
    DatagramConnectionTransportDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(17476, 0);
    DatagramConnectionTransportDataType.schema.dataTypeNodeId = DatagramConnectionTransportDataType.dataTypeNodeId;
    DatagramConnectionTransportDataType.schema.encodingDefaultBinary = DatagramConnectionTransportDataType.encodingDefaultBinary;
    DatagramConnectionTransportDataType.schema.encodingDefaultXml = DatagramConnectionTransportDataType.encodingDefaultXml;
    DatagramConnectionTransportDataType.schema.encodingDefaultJson = DatagramConnectionTransportDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DatagramConnectionTransportDataType.dataTypeNodeId, "DatagramConnectionTransportDataType", DatagramConnectionTransportDataType);
    var schemaDatagramConnectionTransport2DataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DatagramConnectionTransport2DataType",
      baseType: "DatagramConnectionTransportDataType",
      fields: [
        {
          name: "DiscoveryAnnounceRate",
          fieldType: "UInt32"
        },
        {
          name: "DiscoveryMaxMessageSize",
          fieldType: "UInt32"
        },
        {
          name: "QosCategory",
          fieldType: "String"
        },
        {
          name: "DatagramQos",
          fieldType: "ExtensionObject",
          isArray: true
        }
      ]
    });
    var DatagramConnectionTransport2DataType = class _DatagramConnectionTransport2DataType extends DatagramConnectionTransportDataType {
      static get schema() {
        return schemaDatagramConnectionTransport2DataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.discoveryAnnounceRate = 0;
          this.discoveryMaxMessageSize = 0;
          this.qosCategory = null;
          this.datagramQos = [];
          return;
        }
        const schema = _DatagramConnectionTransport2DataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.discoveryAnnounceRate = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.discoveryAnnounceRate);
        this.discoveryMaxMessageSize = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.discoveryMaxMessageSize);
        this.qosCategory = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.qosCategory);
        this.datagramQos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[3], options?.datagramQos);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.discoveryAnnounceRate, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.discoveryMaxMessageSize, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.qosCategory, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.datagramQos, stream, node_opcua_extension_object_1.encodeExtensionObject);
      }
      decode(stream) {
        super.decode(stream);
        this.discoveryAnnounceRate = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.discoveryAnnounceRate);
        this.discoveryMaxMessageSize = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.discoveryMaxMessageSize);
        this.qosCategory = (0, node_opcua_basic_types_1.decodeString)(stream, this.qosCategory);
        this.datagramQos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_extension_object_1.decodeExtensionObject);
      }
      get schema() {
        return schemaDatagramConnectionTransport2DataType;
      }
    };
    exports2.DatagramConnectionTransport2DataType = DatagramConnectionTransport2DataType;
    DatagramConnectionTransport2DataType.possibleFields = [
      "discoveryAddress",
      "discoveryAnnounceRate",
      "discoveryMaxMessageSize",
      "qosCategory",
      "datagramQos"
    ];
    DatagramConnectionTransport2DataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23612, 0);
    DatagramConnectionTransport2DataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23864, 0);
    DatagramConnectionTransport2DataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23932, 0);
    DatagramConnectionTransport2DataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24e3, 0);
    DatagramConnectionTransport2DataType.schema.dataTypeNodeId = DatagramConnectionTransport2DataType.dataTypeNodeId;
    DatagramConnectionTransport2DataType.schema.encodingDefaultBinary = DatagramConnectionTransport2DataType.encodingDefaultBinary;
    DatagramConnectionTransport2DataType.schema.encodingDefaultXml = DatagramConnectionTransport2DataType.encodingDefaultXml;
    DatagramConnectionTransport2DataType.schema.encodingDefaultJson = DatagramConnectionTransport2DataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DatagramConnectionTransport2DataType.dataTypeNodeId, "DatagramConnectionTransport2DataType", DatagramConnectionTransport2DataType);
    var schemaDatagramDataSetReaderTransportDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DatagramDataSetReaderTransportDataType",
      baseType: "DataSetReaderTransportDataType",
      fields: [
        {
          name: "Address",
          fieldType: "ExtensionObject"
        },
        {
          name: "QosCategory",
          fieldType: "String"
        },
        {
          name: "DatagramQos",
          fieldType: "ExtensionObject",
          isArray: true
        },
        {
          name: "Topic",
          fieldType: "String"
        }
      ]
    });
    var DatagramDataSetReaderTransportDataType = class _DatagramDataSetReaderTransportDataType extends DataSetReaderTransportDataType {
      static get schema() {
        return schemaDatagramDataSetReaderTransportDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.address = null;
          this.qosCategory = null;
          this.datagramQos = [];
          this.topic = null;
          return;
        }
        const schema = _DatagramDataSetReaderTransportDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.address = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.address);
        this.qosCategory = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.qosCategory);
        this.datagramQos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.datagramQos);
        this.topic = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.topic);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.address, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.qosCategory, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.datagramQos, stream, node_opcua_extension_object_1.encodeExtensionObject);
        (0, node_opcua_basic_types_1.encodeString)(this.topic, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.address = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.address);
        this.qosCategory = (0, node_opcua_basic_types_1.decodeString)(stream, this.qosCategory);
        this.datagramQos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_extension_object_1.decodeExtensionObject);
        this.topic = (0, node_opcua_basic_types_1.decodeString)(stream, this.topic);
      }
      get schema() {
        return schemaDatagramDataSetReaderTransportDataType;
      }
    };
    exports2.DatagramDataSetReaderTransportDataType = DatagramDataSetReaderTransportDataType;
    DatagramDataSetReaderTransportDataType.possibleFields = [
      "address",
      "qosCategory",
      "datagramQos",
      "topic"
    ];
    DatagramDataSetReaderTransportDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23614, 0);
    DatagramDataSetReaderTransportDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23866, 0);
    DatagramDataSetReaderTransportDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23934, 0);
    DatagramDataSetReaderTransportDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24002, 0);
    DatagramDataSetReaderTransportDataType.schema.dataTypeNodeId = DatagramDataSetReaderTransportDataType.dataTypeNodeId;
    DatagramDataSetReaderTransportDataType.schema.encodingDefaultBinary = DatagramDataSetReaderTransportDataType.encodingDefaultBinary;
    DatagramDataSetReaderTransportDataType.schema.encodingDefaultXml = DatagramDataSetReaderTransportDataType.encodingDefaultXml;
    DatagramDataSetReaderTransportDataType.schema.encodingDefaultJson = DatagramDataSetReaderTransportDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DatagramDataSetReaderTransportDataType.dataTypeNodeId, "DatagramDataSetReaderTransportDataType", DatagramDataSetReaderTransportDataType);
    var schemaDatagramWriterGroupTransportDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DatagramWriterGroupTransportDataType",
      baseType: "WriterGroupTransportDataType",
      fields: [
        {
          name: "MessageRepeatCount",
          fieldType: "Byte"
        },
        {
          name: "MessageRepeatDelay",
          fieldType: "Double"
        }
      ]
    });
    var DatagramWriterGroupTransportDataType = class _DatagramWriterGroupTransportDataType extends WriterGroupTransportDataType {
      static get schema() {
        return schemaDatagramWriterGroupTransportDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.messageRepeatCount = 0;
          this.messageRepeatDelay = 0;
          return;
        }
        const schema = _DatagramWriterGroupTransportDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.messageRepeatCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.messageRepeatCount);
        this.messageRepeatDelay = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.messageRepeatDelay);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeByte)(this.messageRepeatCount, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.messageRepeatDelay, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.messageRepeatCount = (0, node_opcua_basic_types_1.decodeByte)(stream, this.messageRepeatCount);
        this.messageRepeatDelay = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.messageRepeatDelay);
      }
      get schema() {
        return schemaDatagramWriterGroupTransportDataType;
      }
    };
    exports2.DatagramWriterGroupTransportDataType = DatagramWriterGroupTransportDataType;
    DatagramWriterGroupTransportDataType.possibleFields = [
      "messageRepeatCount",
      "messageRepeatDelay"
    ];
    DatagramWriterGroupTransportDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15532, 0);
    DatagramWriterGroupTransportDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(21155, 0);
    DatagramWriterGroupTransportDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(21179, 0);
    DatagramWriterGroupTransportDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(21203, 0);
    DatagramWriterGroupTransportDataType.schema.dataTypeNodeId = DatagramWriterGroupTransportDataType.dataTypeNodeId;
    DatagramWriterGroupTransportDataType.schema.encodingDefaultBinary = DatagramWriterGroupTransportDataType.encodingDefaultBinary;
    DatagramWriterGroupTransportDataType.schema.encodingDefaultXml = DatagramWriterGroupTransportDataType.encodingDefaultXml;
    DatagramWriterGroupTransportDataType.schema.encodingDefaultJson = DatagramWriterGroupTransportDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DatagramWriterGroupTransportDataType.dataTypeNodeId, "DatagramWriterGroupTransportDataType", DatagramWriterGroupTransportDataType);
    var schemaDatagramWriterGroupTransport2DataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DatagramWriterGroupTransport2DataType",
      baseType: "DatagramWriterGroupTransportDataType",
      fields: [
        {
          name: "Address",
          fieldType: "ExtensionObject"
        },
        {
          name: "QosCategory",
          fieldType: "String"
        },
        {
          name: "DatagramQos",
          fieldType: "ExtensionObject",
          isArray: true
        },
        {
          name: "DiscoveryAnnounceRate",
          fieldType: "UInt32"
        },
        {
          name: "Topic",
          fieldType: "String"
        }
      ]
    });
    var DatagramWriterGroupTransport2DataType = class _DatagramWriterGroupTransport2DataType extends DatagramWriterGroupTransportDataType {
      static get schema() {
        return schemaDatagramWriterGroupTransport2DataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.address = null;
          this.qosCategory = null;
          this.datagramQos = [];
          this.discoveryAnnounceRate = 0;
          this.topic = null;
          return;
        }
        const schema = _DatagramWriterGroupTransport2DataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.address = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.address);
        this.qosCategory = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.qosCategory);
        this.datagramQos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.datagramQos);
        this.discoveryAnnounceRate = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.discoveryAnnounceRate);
        this.topic = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.topic);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.address, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.qosCategory, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.datagramQos, stream, node_opcua_extension_object_1.encodeExtensionObject);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.discoveryAnnounceRate, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.topic, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.address = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.address);
        this.qosCategory = (0, node_opcua_basic_types_1.decodeString)(stream, this.qosCategory);
        this.datagramQos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_extension_object_1.decodeExtensionObject);
        this.discoveryAnnounceRate = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.discoveryAnnounceRate);
        this.topic = (0, node_opcua_basic_types_1.decodeString)(stream, this.topic);
      }
      get schema() {
        return schemaDatagramWriterGroupTransport2DataType;
      }
    };
    exports2.DatagramWriterGroupTransport2DataType = DatagramWriterGroupTransport2DataType;
    DatagramWriterGroupTransport2DataType.possibleFields = [
      "messageRepeatCount",
      "messageRepeatDelay",
      "address",
      "qosCategory",
      "datagramQos",
      "discoveryAnnounceRate",
      "topic"
    ];
    DatagramWriterGroupTransport2DataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23613, 0);
    DatagramWriterGroupTransport2DataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23865, 0);
    DatagramWriterGroupTransport2DataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23933, 0);
    DatagramWriterGroupTransport2DataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24001, 0);
    DatagramWriterGroupTransport2DataType.schema.dataTypeNodeId = DatagramWriterGroupTransport2DataType.dataTypeNodeId;
    DatagramWriterGroupTransport2DataType.schema.encodingDefaultBinary = DatagramWriterGroupTransport2DataType.encodingDefaultBinary;
    DatagramWriterGroupTransport2DataType.schema.encodingDefaultXml = DatagramWriterGroupTransport2DataType.encodingDefaultXml;
    DatagramWriterGroupTransport2DataType.schema.encodingDefaultJson = DatagramWriterGroupTransport2DataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DatagramWriterGroupTransport2DataType.dataTypeNodeId, "DatagramWriterGroupTransport2DataType", DatagramWriterGroupTransport2DataType);
    var schemaDecimalDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DecimalDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Scale",
          fieldType: "Int16"
        },
        {
          name: "Value",
          fieldType: "ByteString"
        }
      ]
    });
    var DecimalDataType = class _DecimalDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDecimalDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.scale = 0;
          this.value = Buffer.alloc(0);
          return;
        }
        const schema = _DecimalDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.scale = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.scale);
        this.value = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.value);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeInt16)(this.scale, stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.value, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.scale = (0, node_opcua_basic_types_1.decodeInt16)(stream, this.scale);
        this.value = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.value);
      }
      get schema() {
        return schemaDecimalDataType;
      }
    };
    exports2.DecimalDataType = DecimalDataType;
    DecimalDataType.possibleFields = [
      "scale",
      "value"
    ];
    DecimalDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(17861, 0);
    DecimalDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(17863, 0);
    DecimalDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(17862, 0);
    DecimalDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15045, 0);
    DecimalDataType.schema.dataTypeNodeId = DecimalDataType.dataTypeNodeId;
    DecimalDataType.schema.encodingDefaultBinary = DecimalDataType.encodingDefaultBinary;
    DecimalDataType.schema.encodingDefaultXml = DecimalDataType.encodingDefaultXml;
    DecimalDataType.schema.encodingDefaultJson = DecimalDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DecimalDataType.dataTypeNodeId, "DecimalDataType", DecimalDataType);
    var schemaHistoryUpdateDetails = (0, node_opcua_factory_1.buildStructuredType)({
      name: "HistoryUpdateDetails",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "NodeId",
          fieldType: "NodeId"
        }
      ]
    });
    var HistoryUpdateDetails = class _HistoryUpdateDetails extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaHistoryUpdateDetails;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.nodeId = new node_opcua_nodeid_1.NodeId(null);
          return;
        }
        const schema = _HistoryUpdateDetails.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.nodeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.nodeId);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.nodeId, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.nodeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.nodeId);
      }
      get schema() {
        return schemaHistoryUpdateDetails;
      }
    };
    exports2.HistoryUpdateDetails = HistoryUpdateDetails;
    HistoryUpdateDetails.possibleFields = [
      "nodeId"
    ];
    HistoryUpdateDetails.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(677, 0);
    HistoryUpdateDetails.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(679, 0);
    HistoryUpdateDetails.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(678, 0);
    HistoryUpdateDetails.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15279, 0);
    HistoryUpdateDetails.schema.dataTypeNodeId = HistoryUpdateDetails.dataTypeNodeId;
    HistoryUpdateDetails.schema.encodingDefaultBinary = HistoryUpdateDetails.encodingDefaultBinary;
    HistoryUpdateDetails.schema.encodingDefaultXml = HistoryUpdateDetails.encodingDefaultXml;
    HistoryUpdateDetails.schema.encodingDefaultJson = HistoryUpdateDetails.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(HistoryUpdateDetails.dataTypeNodeId, "HistoryUpdateDetails", HistoryUpdateDetails);
    var schemaDeleteAtTimeDetails = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DeleteAtTimeDetails",
      baseType: "HistoryUpdateDetails",
      fields: [
        {
          name: "ReqTimes",
          fieldType: "DateTime",
          isArray: true
        }
      ]
    });
    var DeleteAtTimeDetails = class _DeleteAtTimeDetails extends HistoryUpdateDetails {
      static get schema() {
        return schemaDeleteAtTimeDetails;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.reqTimes = [];
          return;
        }
        const schema = _DeleteAtTimeDetails.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.reqTimes = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[0], options?.reqTimes);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.reqTimes, stream, node_opcua_basic_types_1.encodeDateTime);
      }
      decode(stream) {
        super.decode(stream);
        this.reqTimes = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeDateTime);
      }
      get schema() {
        return schemaDeleteAtTimeDetails;
      }
    };
    exports2.DeleteAtTimeDetails = DeleteAtTimeDetails;
    DeleteAtTimeDetails.possibleFields = [
      "nodeId",
      "reqTimes"
    ];
    DeleteAtTimeDetails.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(689, 0);
    DeleteAtTimeDetails.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(691, 0);
    DeleteAtTimeDetails.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(690, 0);
    DeleteAtTimeDetails.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15284, 0);
    DeleteAtTimeDetails.schema.dataTypeNodeId = DeleteAtTimeDetails.dataTypeNodeId;
    DeleteAtTimeDetails.schema.encodingDefaultBinary = DeleteAtTimeDetails.encodingDefaultBinary;
    DeleteAtTimeDetails.schema.encodingDefaultXml = DeleteAtTimeDetails.encodingDefaultXml;
    DeleteAtTimeDetails.schema.encodingDefaultJson = DeleteAtTimeDetails.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DeleteAtTimeDetails.dataTypeNodeId, "DeleteAtTimeDetails", DeleteAtTimeDetails);
    var schemaDeleteEventDetails = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DeleteEventDetails",
      baseType: "HistoryUpdateDetails",
      fields: [
        {
          name: "EventIds",
          fieldType: "ByteString",
          isArray: true
        }
      ]
    });
    var DeleteEventDetails = class _DeleteEventDetails extends HistoryUpdateDetails {
      static get schema() {
        return schemaDeleteEventDetails;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.eventIds = [];
          return;
        }
        const schema = _DeleteEventDetails.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.eventIds = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[0], options?.eventIds);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.eventIds, stream, node_opcua_basic_types_1.encodeByteString);
      }
      decode(stream) {
        super.decode(stream);
        this.eventIds = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeByteString);
      }
      get schema() {
        return schemaDeleteEventDetails;
      }
    };
    exports2.DeleteEventDetails = DeleteEventDetails;
    DeleteEventDetails.possibleFields = [
      "nodeId",
      "eventIds"
    ];
    DeleteEventDetails.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(692, 0);
    DeleteEventDetails.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(694, 0);
    DeleteEventDetails.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(693, 0);
    DeleteEventDetails.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15285, 0);
    DeleteEventDetails.schema.dataTypeNodeId = DeleteEventDetails.dataTypeNodeId;
    DeleteEventDetails.schema.encodingDefaultBinary = DeleteEventDetails.encodingDefaultBinary;
    DeleteEventDetails.schema.encodingDefaultXml = DeleteEventDetails.encodingDefaultXml;
    DeleteEventDetails.schema.encodingDefaultJson = DeleteEventDetails.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DeleteEventDetails.dataTypeNodeId, "DeleteEventDetails", DeleteEventDetails);
    var schemaDeleteMonitoredItemsRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DeleteMonitoredItemsRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "SubscriptionId",
          fieldType: "UInt32"
        },
        {
          name: "MonitoredItemIds",
          fieldType: "UInt32",
          isArray: true
        }
      ]
    });
    var DeleteMonitoredItemsRequest = class _DeleteMonitoredItemsRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDeleteMonitoredItemsRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.subscriptionId = 0;
          this.monitoredItemIds = [];
          return;
        }
        const schema = _DeleteMonitoredItemsRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.subscriptionId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.subscriptionId);
        this.monitoredItemIds = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.monitoredItemIds);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.subscriptionId, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.monitoredItemIds, stream, node_opcua_basic_types_1.encodeUInt32);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.subscriptionId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.subscriptionId);
        this.monitoredItemIds = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeUInt32);
      }
      get schema() {
        return schemaDeleteMonitoredItemsRequest;
      }
    };
    exports2.DeleteMonitoredItemsRequest = DeleteMonitoredItemsRequest;
    DeleteMonitoredItemsRequest.possibleFields = [
      "requestHeader",
      "subscriptionId",
      "monitoredItemIds"
    ];
    DeleteMonitoredItemsRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(779, 0);
    DeleteMonitoredItemsRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(781, 0);
    DeleteMonitoredItemsRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(780, 0);
    DeleteMonitoredItemsRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15335, 0);
    DeleteMonitoredItemsRequest.schema.dataTypeNodeId = DeleteMonitoredItemsRequest.dataTypeNodeId;
    DeleteMonitoredItemsRequest.schema.encodingDefaultBinary = DeleteMonitoredItemsRequest.encodingDefaultBinary;
    DeleteMonitoredItemsRequest.schema.encodingDefaultXml = DeleteMonitoredItemsRequest.encodingDefaultXml;
    DeleteMonitoredItemsRequest.schema.encodingDefaultJson = DeleteMonitoredItemsRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DeleteMonitoredItemsRequest.dataTypeNodeId, "DeleteMonitoredItemsRequest", DeleteMonitoredItemsRequest);
    var schemaDeleteMonitoredItemsResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DeleteMonitoredItemsResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "Results",
          fieldType: "StatusCode",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var DeleteMonitoredItemsResponse = class _DeleteMonitoredItemsResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDeleteMonitoredItemsResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.results = [];
          this.diagnosticInfos = [];
          return;
        }
        const schema = _DeleteMonitoredItemsResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.results = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.results);
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.results, stream, node_opcua_status_code_1.encodeStatusCode);
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.results = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_status_code_1.decodeStatusCode);
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaDeleteMonitoredItemsResponse;
      }
    };
    exports2.DeleteMonitoredItemsResponse = DeleteMonitoredItemsResponse;
    DeleteMonitoredItemsResponse.possibleFields = [
      "responseHeader",
      "results",
      "diagnosticInfos"
    ];
    DeleteMonitoredItemsResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(782, 0);
    DeleteMonitoredItemsResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(784, 0);
    DeleteMonitoredItemsResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(783, 0);
    DeleteMonitoredItemsResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15336, 0);
    DeleteMonitoredItemsResponse.schema.dataTypeNodeId = DeleteMonitoredItemsResponse.dataTypeNodeId;
    DeleteMonitoredItemsResponse.schema.encodingDefaultBinary = DeleteMonitoredItemsResponse.encodingDefaultBinary;
    DeleteMonitoredItemsResponse.schema.encodingDefaultXml = DeleteMonitoredItemsResponse.encodingDefaultXml;
    DeleteMonitoredItemsResponse.schema.encodingDefaultJson = DeleteMonitoredItemsResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DeleteMonitoredItemsResponse.dataTypeNodeId, "DeleteMonitoredItemsResponse", DeleteMonitoredItemsResponse);
    var schemaDeleteNodesItem = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DeleteNodesItem",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "NodeId",
          fieldType: "NodeId"
        },
        {
          name: "DeleteTargetReferences",
          fieldType: "Boolean"
        }
      ]
    });
    var DeleteNodesItem = class _DeleteNodesItem extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDeleteNodesItem;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.nodeId = new node_opcua_nodeid_1.NodeId(null);
          this.deleteTargetReferences = false;
          return;
        }
        const schema = _DeleteNodesItem.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.nodeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.nodeId);
        this.deleteTargetReferences = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.deleteTargetReferences);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.nodeId, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.deleteTargetReferences, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.nodeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.nodeId);
        this.deleteTargetReferences = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.deleteTargetReferences);
      }
      get schema() {
        return schemaDeleteNodesItem;
      }
    };
    exports2.DeleteNodesItem = DeleteNodesItem;
    DeleteNodesItem.possibleFields = [
      "nodeId",
      "deleteTargetReferences"
    ];
    DeleteNodesItem.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(382, 0);
    DeleteNodesItem.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(384, 0);
    DeleteNodesItem.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(383, 0);
    DeleteNodesItem.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15172, 0);
    DeleteNodesItem.schema.dataTypeNodeId = DeleteNodesItem.dataTypeNodeId;
    DeleteNodesItem.schema.encodingDefaultBinary = DeleteNodesItem.encodingDefaultBinary;
    DeleteNodesItem.schema.encodingDefaultXml = DeleteNodesItem.encodingDefaultXml;
    DeleteNodesItem.schema.encodingDefaultJson = DeleteNodesItem.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DeleteNodesItem.dataTypeNodeId, "DeleteNodesItem", DeleteNodesItem);
    var schemaDeleteNodesRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DeleteNodesRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "NodesToDelete",
          fieldType: "DeleteNodesItem",
          isArray: true
        }
      ]
    });
    var DeleteNodesRequest = class _DeleteNodesRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDeleteNodesRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.nodesToDelete = null;
          return;
        }
        const schema = _DeleteNodesRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.nodesToDelete = [];
        if (options.nodesToDelete) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.nodesToDelete));
          this.nodesToDelete = options.nodesToDelete.map((e) => new DeleteNodesItem(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.nodesToDelete, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.nodesToDelete = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new DeleteNodesItem(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaDeleteNodesRequest;
      }
    };
    exports2.DeleteNodesRequest = DeleteNodesRequest;
    DeleteNodesRequest.possibleFields = [
      "requestHeader",
      "nodesToDelete"
    ];
    DeleteNodesRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(498, 0);
    DeleteNodesRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(500, 0);
    DeleteNodesRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(499, 0);
    DeleteNodesRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15173, 0);
    DeleteNodesRequest.schema.dataTypeNodeId = DeleteNodesRequest.dataTypeNodeId;
    DeleteNodesRequest.schema.encodingDefaultBinary = DeleteNodesRequest.encodingDefaultBinary;
    DeleteNodesRequest.schema.encodingDefaultXml = DeleteNodesRequest.encodingDefaultXml;
    DeleteNodesRequest.schema.encodingDefaultJson = DeleteNodesRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DeleteNodesRequest.dataTypeNodeId, "DeleteNodesRequest", DeleteNodesRequest);
    var schemaDeleteNodesResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DeleteNodesResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "Results",
          fieldType: "StatusCode",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var DeleteNodesResponse = class _DeleteNodesResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDeleteNodesResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.results = [];
          this.diagnosticInfos = [];
          return;
        }
        const schema = _DeleteNodesResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.results = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.results);
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.results, stream, node_opcua_status_code_1.encodeStatusCode);
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.results = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_status_code_1.decodeStatusCode);
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaDeleteNodesResponse;
      }
    };
    exports2.DeleteNodesResponse = DeleteNodesResponse;
    DeleteNodesResponse.possibleFields = [
      "responseHeader",
      "results",
      "diagnosticInfos"
    ];
    DeleteNodesResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(501, 0);
    DeleteNodesResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(503, 0);
    DeleteNodesResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(502, 0);
    DeleteNodesResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15174, 0);
    DeleteNodesResponse.schema.dataTypeNodeId = DeleteNodesResponse.dataTypeNodeId;
    DeleteNodesResponse.schema.encodingDefaultBinary = DeleteNodesResponse.encodingDefaultBinary;
    DeleteNodesResponse.schema.encodingDefaultXml = DeleteNodesResponse.encodingDefaultXml;
    DeleteNodesResponse.schema.encodingDefaultJson = DeleteNodesResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DeleteNodesResponse.dataTypeNodeId, "DeleteNodesResponse", DeleteNodesResponse);
    var schemaDeleteRawModifiedDetails = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DeleteRawModifiedDetails",
      baseType: "HistoryUpdateDetails",
      fields: [
        {
          name: "IsDeleteModified",
          fieldType: "Boolean"
        },
        {
          name: "StartTime",
          fieldType: "DateTime"
        },
        {
          name: "EndTime",
          fieldType: "DateTime"
        }
      ]
    });
    var DeleteRawModifiedDetails = class _DeleteRawModifiedDetails extends HistoryUpdateDetails {
      static get schema() {
        return schemaDeleteRawModifiedDetails;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.isDeleteModified = false;
          this.startTime = /* @__PURE__ */ new Date();
          this.endTime = /* @__PURE__ */ new Date();
          return;
        }
        const schema = _DeleteRawModifiedDetails.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.isDeleteModified = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.isDeleteModified);
        this.startTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.startTime);
        this.endTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.endTime);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.isDeleteModified, stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.startTime, stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.endTime, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.isDeleteModified = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.isDeleteModified);
        this.startTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.startTime);
        this.endTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.endTime);
      }
      get schema() {
        return schemaDeleteRawModifiedDetails;
      }
    };
    exports2.DeleteRawModifiedDetails = DeleteRawModifiedDetails;
    DeleteRawModifiedDetails.possibleFields = [
      "nodeId",
      "isDeleteModified",
      "startTime",
      "endTime"
    ];
    DeleteRawModifiedDetails.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(686, 0);
    DeleteRawModifiedDetails.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(688, 0);
    DeleteRawModifiedDetails.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(687, 0);
    DeleteRawModifiedDetails.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15283, 0);
    DeleteRawModifiedDetails.schema.dataTypeNodeId = DeleteRawModifiedDetails.dataTypeNodeId;
    DeleteRawModifiedDetails.schema.encodingDefaultBinary = DeleteRawModifiedDetails.encodingDefaultBinary;
    DeleteRawModifiedDetails.schema.encodingDefaultXml = DeleteRawModifiedDetails.encodingDefaultXml;
    DeleteRawModifiedDetails.schema.encodingDefaultJson = DeleteRawModifiedDetails.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DeleteRawModifiedDetails.dataTypeNodeId, "DeleteRawModifiedDetails", DeleteRawModifiedDetails);
    var schemaDeleteReferencesItem = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DeleteReferencesItem",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "SourceNodeId",
          fieldType: "NodeId"
        },
        {
          name: "ReferenceTypeId",
          fieldType: "NodeId"
        },
        {
          name: "IsForward",
          fieldType: "Boolean"
        },
        {
          name: "TargetNodeId",
          fieldType: "ExpandedNodeId"
        },
        {
          name: "DeleteBidirectional",
          fieldType: "Boolean"
        }
      ]
    });
    var DeleteReferencesItem = class _DeleteReferencesItem extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDeleteReferencesItem;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.sourceNodeId = new node_opcua_nodeid_1.NodeId(null);
          this.referenceTypeId = new node_opcua_nodeid_1.NodeId(null);
          this.isForward = false;
          this.targetNodeId = new node_opcua_nodeid_1.ExpandedNodeId(null);
          this.deleteBidirectional = false;
          return;
        }
        const schema = _DeleteReferencesItem.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.sourceNodeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.sourceNodeId);
        this.referenceTypeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.referenceTypeId);
        this.isForward = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.isForward);
        this.targetNodeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.targetNodeId);
        this.deleteBidirectional = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.deleteBidirectional);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.sourceNodeId, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.referenceTypeId, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.isForward, stream);
        (0, node_opcua_basic_types_1.encodeExpandedNodeId)(this.targetNodeId, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.deleteBidirectional, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.sourceNodeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.sourceNodeId);
        this.referenceTypeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.referenceTypeId);
        this.isForward = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.isForward);
        this.targetNodeId = (0, node_opcua_basic_types_1.decodeExpandedNodeId)(stream, this.targetNodeId);
        this.deleteBidirectional = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.deleteBidirectional);
      }
      get schema() {
        return schemaDeleteReferencesItem;
      }
    };
    exports2.DeleteReferencesItem = DeleteReferencesItem;
    DeleteReferencesItem.possibleFields = [
      "sourceNodeId",
      "referenceTypeId",
      "isForward",
      "targetNodeId",
      "deleteBidirectional"
    ];
    DeleteReferencesItem.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(385, 0);
    DeleteReferencesItem.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(387, 0);
    DeleteReferencesItem.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(386, 0);
    DeleteReferencesItem.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15175, 0);
    DeleteReferencesItem.schema.dataTypeNodeId = DeleteReferencesItem.dataTypeNodeId;
    DeleteReferencesItem.schema.encodingDefaultBinary = DeleteReferencesItem.encodingDefaultBinary;
    DeleteReferencesItem.schema.encodingDefaultXml = DeleteReferencesItem.encodingDefaultXml;
    DeleteReferencesItem.schema.encodingDefaultJson = DeleteReferencesItem.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DeleteReferencesItem.dataTypeNodeId, "DeleteReferencesItem", DeleteReferencesItem);
    var schemaDeleteReferencesRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DeleteReferencesRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "ReferencesToDelete",
          fieldType: "DeleteReferencesItem",
          isArray: true
        }
      ]
    });
    var DeleteReferencesRequest = class _DeleteReferencesRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDeleteReferencesRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.referencesToDelete = null;
          return;
        }
        const schema = _DeleteReferencesRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.referencesToDelete = [];
        if (options.referencesToDelete) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.referencesToDelete));
          this.referencesToDelete = options.referencesToDelete.map((e) => new DeleteReferencesItem(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.referencesToDelete, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.referencesToDelete = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new DeleteReferencesItem(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaDeleteReferencesRequest;
      }
    };
    exports2.DeleteReferencesRequest = DeleteReferencesRequest;
    DeleteReferencesRequest.possibleFields = [
      "requestHeader",
      "referencesToDelete"
    ];
    DeleteReferencesRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(504, 0);
    DeleteReferencesRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(506, 0);
    DeleteReferencesRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(505, 0);
    DeleteReferencesRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15176, 0);
    DeleteReferencesRequest.schema.dataTypeNodeId = DeleteReferencesRequest.dataTypeNodeId;
    DeleteReferencesRequest.schema.encodingDefaultBinary = DeleteReferencesRequest.encodingDefaultBinary;
    DeleteReferencesRequest.schema.encodingDefaultXml = DeleteReferencesRequest.encodingDefaultXml;
    DeleteReferencesRequest.schema.encodingDefaultJson = DeleteReferencesRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DeleteReferencesRequest.dataTypeNodeId, "DeleteReferencesRequest", DeleteReferencesRequest);
    var schemaDeleteReferencesResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DeleteReferencesResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "Results",
          fieldType: "StatusCode",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var DeleteReferencesResponse = class _DeleteReferencesResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDeleteReferencesResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.results = [];
          this.diagnosticInfos = [];
          return;
        }
        const schema = _DeleteReferencesResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.results = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.results);
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.results, stream, node_opcua_status_code_1.encodeStatusCode);
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.results = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_status_code_1.decodeStatusCode);
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaDeleteReferencesResponse;
      }
    };
    exports2.DeleteReferencesResponse = DeleteReferencesResponse;
    DeleteReferencesResponse.possibleFields = [
      "responseHeader",
      "results",
      "diagnosticInfos"
    ];
    DeleteReferencesResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(507, 0);
    DeleteReferencesResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(509, 0);
    DeleteReferencesResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(508, 0);
    DeleteReferencesResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15177, 0);
    DeleteReferencesResponse.schema.dataTypeNodeId = DeleteReferencesResponse.dataTypeNodeId;
    DeleteReferencesResponse.schema.encodingDefaultBinary = DeleteReferencesResponse.encodingDefaultBinary;
    DeleteReferencesResponse.schema.encodingDefaultXml = DeleteReferencesResponse.encodingDefaultXml;
    DeleteReferencesResponse.schema.encodingDefaultJson = DeleteReferencesResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DeleteReferencesResponse.dataTypeNodeId, "DeleteReferencesResponse", DeleteReferencesResponse);
    var schemaDeleteSubscriptionsRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DeleteSubscriptionsRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "SubscriptionIds",
          fieldType: "UInt32",
          isArray: true
        }
      ]
    });
    var DeleteSubscriptionsRequest = class _DeleteSubscriptionsRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDeleteSubscriptionsRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.subscriptionIds = [];
          return;
        }
        const schema = _DeleteSubscriptionsRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.subscriptionIds = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.subscriptionIds);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.subscriptionIds, stream, node_opcua_basic_types_1.encodeUInt32);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.subscriptionIds = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeUInt32);
      }
      get schema() {
        return schemaDeleteSubscriptionsRequest;
      }
    };
    exports2.DeleteSubscriptionsRequest = DeleteSubscriptionsRequest;
    DeleteSubscriptionsRequest.possibleFields = [
      "requestHeader",
      "subscriptionIds"
    ];
    DeleteSubscriptionsRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(845, 0);
    DeleteSubscriptionsRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(847, 0);
    DeleteSubscriptionsRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(846, 0);
    DeleteSubscriptionsRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15359, 0);
    DeleteSubscriptionsRequest.schema.dataTypeNodeId = DeleteSubscriptionsRequest.dataTypeNodeId;
    DeleteSubscriptionsRequest.schema.encodingDefaultBinary = DeleteSubscriptionsRequest.encodingDefaultBinary;
    DeleteSubscriptionsRequest.schema.encodingDefaultXml = DeleteSubscriptionsRequest.encodingDefaultXml;
    DeleteSubscriptionsRequest.schema.encodingDefaultJson = DeleteSubscriptionsRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DeleteSubscriptionsRequest.dataTypeNodeId, "DeleteSubscriptionsRequest", DeleteSubscriptionsRequest);
    var schemaDeleteSubscriptionsResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DeleteSubscriptionsResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "Results",
          fieldType: "StatusCode",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var DeleteSubscriptionsResponse = class _DeleteSubscriptionsResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDeleteSubscriptionsResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.results = [];
          this.diagnosticInfos = [];
          return;
        }
        const schema = _DeleteSubscriptionsResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.results = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.results);
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.results, stream, node_opcua_status_code_1.encodeStatusCode);
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.results = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_status_code_1.decodeStatusCode);
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaDeleteSubscriptionsResponse;
      }
    };
    exports2.DeleteSubscriptionsResponse = DeleteSubscriptionsResponse;
    DeleteSubscriptionsResponse.possibleFields = [
      "responseHeader",
      "results",
      "diagnosticInfos"
    ];
    DeleteSubscriptionsResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(848, 0);
    DeleteSubscriptionsResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(850, 0);
    DeleteSubscriptionsResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(849, 0);
    DeleteSubscriptionsResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15360, 0);
    DeleteSubscriptionsResponse.schema.dataTypeNodeId = DeleteSubscriptionsResponse.dataTypeNodeId;
    DeleteSubscriptionsResponse.schema.encodingDefaultBinary = DeleteSubscriptionsResponse.encodingDefaultBinary;
    DeleteSubscriptionsResponse.schema.encodingDefaultXml = DeleteSubscriptionsResponse.encodingDefaultXml;
    DeleteSubscriptionsResponse.schema.encodingDefaultJson = DeleteSubscriptionsResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DeleteSubscriptionsResponse.dataTypeNodeId, "DeleteSubscriptionsResponse", DeleteSubscriptionsResponse);
    var schemaDiscoveryConfiguration = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DiscoveryConfiguration",
      baseType: "ExtensionObject",
      fields: []
    });
    var DiscoveryConfiguration = class _DiscoveryConfiguration extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDiscoveryConfiguration;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _DiscoveryConfiguration.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaDiscoveryConfiguration;
      }
    };
    exports2.DiscoveryConfiguration = DiscoveryConfiguration;
    DiscoveryConfiguration.possibleFields = [];
    DiscoveryConfiguration.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12890, 0);
    DiscoveryConfiguration.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12900, 0);
    DiscoveryConfiguration.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12892, 0);
    DiscoveryConfiguration.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15105, 0);
    DiscoveryConfiguration.schema.dataTypeNodeId = DiscoveryConfiguration.dataTypeNodeId;
    DiscoveryConfiguration.schema.encodingDefaultBinary = DiscoveryConfiguration.encodingDefaultBinary;
    DiscoveryConfiguration.schema.encodingDefaultXml = DiscoveryConfiguration.encodingDefaultXml;
    DiscoveryConfiguration.schema.encodingDefaultJson = DiscoveryConfiguration.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DiscoveryConfiguration.dataTypeNodeId, "DiscoveryConfiguration", DiscoveryConfiguration);
    var schemaDoubleComplexNumberType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "DoubleComplexNumberType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Real",
          fieldType: "Double"
        },
        {
          name: "Imaginary",
          fieldType: "Double"
        }
      ]
    });
    var DoubleComplexNumberType = class _DoubleComplexNumberType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaDoubleComplexNumberType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.real = 0;
          this.imaginary = 0;
          return;
        }
        const schema = _DoubleComplexNumberType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.real = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.real);
        this.imaginary = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.imaginary);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.real, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.imaginary, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.real = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.real);
        this.imaginary = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.imaginary);
      }
      get schema() {
        return schemaDoubleComplexNumberType;
      }
    };
    exports2.DoubleComplexNumberType = DoubleComplexNumberType;
    DoubleComplexNumberType.possibleFields = [
      "real",
      "imaginary"
    ];
    DoubleComplexNumberType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12172, 0);
    DoubleComplexNumberType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12182, 0);
    DoubleComplexNumberType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12174, 0);
    DoubleComplexNumberType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15378, 0);
    DoubleComplexNumberType.schema.dataTypeNodeId = DoubleComplexNumberType.dataTypeNodeId;
    DoubleComplexNumberType.schema.encodingDefaultBinary = DoubleComplexNumberType.encodingDefaultBinary;
    DoubleComplexNumberType.schema.encodingDefaultXml = DoubleComplexNumberType.encodingDefaultXml;
    DoubleComplexNumberType.schema.encodingDefaultJson = DoubleComplexNumberType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(DoubleComplexNumberType.dataTypeNodeId, "DoubleComplexNumberType", DoubleComplexNumberType);
    var schemaElementOperand = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ElementOperand",
      baseType: "FilterOperand",
      fields: [
        {
          name: "Index",
          fieldType: "UInt32"
        }
      ]
    });
    var ElementOperand = class _ElementOperand extends FilterOperand {
      static get schema() {
        return schemaElementOperand;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.index = 0;
          return;
        }
        const schema = _ElementOperand.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.index = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.index);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.index, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.index = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.index);
      }
      get schema() {
        return schemaElementOperand;
      }
    };
    exports2.ElementOperand = ElementOperand;
    ElementOperand.possibleFields = [
      "index"
    ];
    ElementOperand.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(592, 0);
    ElementOperand.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(594, 0);
    ElementOperand.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(593, 0);
    ElementOperand.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15207, 0);
    ElementOperand.schema.dataTypeNodeId = ElementOperand.dataTypeNodeId;
    ElementOperand.schema.encodingDefaultBinary = ElementOperand.encodingDefaultBinary;
    ElementOperand.schema.encodingDefaultXml = ElementOperand.encodingDefaultXml;
    ElementOperand.schema.encodingDefaultJson = ElementOperand.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ElementOperand.dataTypeNodeId, "ElementOperand", ElementOperand);
    var schemaEndpointConfiguration = (0, node_opcua_factory_1.buildStructuredType)({
      name: "EndpointConfiguration",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "OperationTimeout",
          fieldType: "Int32"
        },
        {
          name: "UseBinaryEncoding",
          fieldType: "Boolean"
        },
        {
          name: "MaxStringLength",
          fieldType: "Int32"
        },
        {
          name: "MaxByteStringLength",
          fieldType: "Int32"
        },
        {
          name: "MaxArrayLength",
          fieldType: "Int32"
        },
        {
          name: "MaxMessageSize",
          fieldType: "Int32"
        },
        {
          name: "MaxBufferSize",
          fieldType: "Int32"
        },
        {
          name: "ChannelLifetime",
          fieldType: "Int32"
        },
        {
          name: "SecurityTokenLifetime",
          fieldType: "Int32"
        }
      ]
    });
    var EndpointConfiguration = class _EndpointConfiguration extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaEndpointConfiguration;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.operationTimeout = 0;
          this.useBinaryEncoding = false;
          this.maxStringLength = 0;
          this.maxByteStringLength = 0;
          this.maxArrayLength = 0;
          this.maxMessageSize = 0;
          this.maxBufferSize = 0;
          this.channelLifetime = 0;
          this.securityTokenLifetime = 0;
          return;
        }
        const schema = _EndpointConfiguration.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.operationTimeout = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.operationTimeout);
        this.useBinaryEncoding = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.useBinaryEncoding);
        this.maxStringLength = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.maxStringLength);
        this.maxByteStringLength = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.maxByteStringLength);
        this.maxArrayLength = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.maxArrayLength);
        this.maxMessageSize = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.maxMessageSize);
        this.maxBufferSize = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.maxBufferSize);
        this.channelLifetime = (0, node_opcua_factory_1.initialize_field)(schema.fields[7], options?.channelLifetime);
        this.securityTokenLifetime = (0, node_opcua_factory_1.initialize_field)(schema.fields[8], options?.securityTokenLifetime);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeInt32)(this.operationTimeout, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.useBinaryEncoding, stream);
        (0, node_opcua_basic_types_1.encodeInt32)(this.maxStringLength, stream);
        (0, node_opcua_basic_types_1.encodeInt32)(this.maxByteStringLength, stream);
        (0, node_opcua_basic_types_1.encodeInt32)(this.maxArrayLength, stream);
        (0, node_opcua_basic_types_1.encodeInt32)(this.maxMessageSize, stream);
        (0, node_opcua_basic_types_1.encodeInt32)(this.maxBufferSize, stream);
        (0, node_opcua_basic_types_1.encodeInt32)(this.channelLifetime, stream);
        (0, node_opcua_basic_types_1.encodeInt32)(this.securityTokenLifetime, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.operationTimeout = (0, node_opcua_basic_types_1.decodeInt32)(stream, this.operationTimeout);
        this.useBinaryEncoding = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.useBinaryEncoding);
        this.maxStringLength = (0, node_opcua_basic_types_1.decodeInt32)(stream, this.maxStringLength);
        this.maxByteStringLength = (0, node_opcua_basic_types_1.decodeInt32)(stream, this.maxByteStringLength);
        this.maxArrayLength = (0, node_opcua_basic_types_1.decodeInt32)(stream, this.maxArrayLength);
        this.maxMessageSize = (0, node_opcua_basic_types_1.decodeInt32)(stream, this.maxMessageSize);
        this.maxBufferSize = (0, node_opcua_basic_types_1.decodeInt32)(stream, this.maxBufferSize);
        this.channelLifetime = (0, node_opcua_basic_types_1.decodeInt32)(stream, this.channelLifetime);
        this.securityTokenLifetime = (0, node_opcua_basic_types_1.decodeInt32)(stream, this.securityTokenLifetime);
      }
      get schema() {
        return schemaEndpointConfiguration;
      }
    };
    exports2.EndpointConfiguration = EndpointConfiguration;
    EndpointConfiguration.possibleFields = [
      "operationTimeout",
      "useBinaryEncoding",
      "maxStringLength",
      "maxByteStringLength",
      "maxArrayLength",
      "maxMessageSize",
      "maxBufferSize",
      "channelLifetime",
      "securityTokenLifetime"
    ];
    EndpointConfiguration.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(331, 0);
    EndpointConfiguration.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(333, 0);
    EndpointConfiguration.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(332, 0);
    EndpointConfiguration.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15199, 0);
    EndpointConfiguration.schema.dataTypeNodeId = EndpointConfiguration.dataTypeNodeId;
    EndpointConfiguration.schema.encodingDefaultBinary = EndpointConfiguration.encodingDefaultBinary;
    EndpointConfiguration.schema.encodingDefaultXml = EndpointConfiguration.encodingDefaultXml;
    EndpointConfiguration.schema.encodingDefaultJson = EndpointConfiguration.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(EndpointConfiguration.dataTypeNodeId, "EndpointConfiguration", EndpointConfiguration);
    var schemaEndpointType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "EndpointType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "EndpointUrl",
          fieldType: "String"
        },
        {
          name: "SecurityMode",
          fieldType: "MessageSecurityMode"
        },
        {
          name: "SecurityPolicyUri",
          fieldType: "String"
        },
        {
          name: "TransportProfileUri",
          fieldType: "String"
        }
      ]
    });
    var EndpointType = class _EndpointType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaEndpointType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.endpointUrl = null;
          this.securityMode = 0;
          this.securityPolicyUri = null;
          this.transportProfileUri = null;
          return;
        }
        const schema = _EndpointType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.endpointUrl = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.endpointUrl);
        this.securityMode = this.setSecurityMode((0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.securityMode));
        this.securityPolicyUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.securityPolicyUri);
        this.transportProfileUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.transportProfileUri);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.endpointUrl, stream);
        encodeMessageSecurityMode(this.securityMode, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.securityPolicyUri, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.transportProfileUri, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.endpointUrl = (0, node_opcua_basic_types_1.decodeString)(stream, this.endpointUrl);
        this.securityMode = decodeMessageSecurityMode(stream, this.securityMode);
        this.securityPolicyUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.securityPolicyUri);
        this.transportProfileUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.transportProfileUri);
      }
      // Define Enumeration setters
      setSecurityMode(value) {
        const coercedValue = exports2._enumerationMessageSecurityMode.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to MessageSecurityMode :" + value);
        }
        this.securityMode = coercedValue.value;
        return this.securityMode;
      }
      get schema() {
        return schemaEndpointType;
      }
    };
    exports2.EndpointType = EndpointType;
    EndpointType.possibleFields = [
      "endpointUrl",
      "securityMode",
      "securityPolicyUri",
      "transportProfileUri"
    ];
    EndpointType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15528, 0);
    EndpointType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15671, 0);
    EndpointType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15949, 0);
    EndpointType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16150, 0);
    EndpointType.schema.dataTypeNodeId = EndpointType.dataTypeNodeId;
    EndpointType.schema.encodingDefaultBinary = EndpointType.encodingDefaultBinary;
    EndpointType.schema.encodingDefaultXml = EndpointType.encodingDefaultXml;
    EndpointType.schema.encodingDefaultJson = EndpointType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(EndpointType.dataTypeNodeId, "EndpointType", EndpointType);
    var schemaEndpointUrlListDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "EndpointUrlListDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "EndpointUrlList",
          fieldType: "String",
          isArray: true
        }
      ]
    });
    var EndpointUrlListDataType = class _EndpointUrlListDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaEndpointUrlListDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.endpointUrlList = [];
          return;
        }
        const schema = _EndpointUrlListDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.endpointUrlList = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[0], options?.endpointUrlList);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.endpointUrlList, stream, node_opcua_basic_types_1.encodeString);
      }
      decode(stream) {
        super.decode(stream);
        this.endpointUrlList = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
      }
      get schema() {
        return schemaEndpointUrlListDataType;
      }
    };
    exports2.EndpointUrlListDataType = EndpointUrlListDataType;
    EndpointUrlListDataType.possibleFields = [
      "endpointUrlList"
    ];
    EndpointUrlListDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(11943, 0);
    EndpointUrlListDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(11957, 0);
    EndpointUrlListDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(11949, 0);
    EndpointUrlListDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15363, 0);
    EndpointUrlListDataType.schema.dataTypeNodeId = EndpointUrlListDataType.dataTypeNodeId;
    EndpointUrlListDataType.schema.encodingDefaultBinary = EndpointUrlListDataType.encodingDefaultBinary;
    EndpointUrlListDataType.schema.encodingDefaultXml = EndpointUrlListDataType.encodingDefaultXml;
    EndpointUrlListDataType.schema.encodingDefaultJson = EndpointUrlListDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(EndpointUrlListDataType.dataTypeNodeId, "EndpointUrlListDataType", EndpointUrlListDataType);
    var schemaEphemeralKeyType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "EphemeralKeyType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "PublicKey",
          fieldType: "ByteString"
        },
        {
          name: "Signature",
          fieldType: "ByteString"
        }
      ]
    });
    var EphemeralKeyType = class _EphemeralKeyType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaEphemeralKeyType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.publicKey = Buffer.alloc(0);
          this.signature = Buffer.alloc(0);
          return;
        }
        const schema = _EphemeralKeyType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.publicKey = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.publicKey);
        this.signature = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.signature);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.publicKey, stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.signature, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.publicKey = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.publicKey);
        this.signature = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.signature);
      }
      get schema() {
        return schemaEphemeralKeyType;
      }
    };
    exports2.EphemeralKeyType = EphemeralKeyType;
    EphemeralKeyType.possibleFields = [
      "publicKey",
      "signature"
    ];
    EphemeralKeyType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(17548, 0);
    EphemeralKeyType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(17549, 0);
    EphemeralKeyType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(17553, 0);
    EphemeralKeyType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(17557, 0);
    EphemeralKeyType.schema.dataTypeNodeId = EphemeralKeyType.dataTypeNodeId;
    EphemeralKeyType.schema.encodingDefaultBinary = EphemeralKeyType.encodingDefaultBinary;
    EphemeralKeyType.schema.encodingDefaultXml = EphemeralKeyType.encodingDefaultXml;
    EphemeralKeyType.schema.encodingDefaultJson = EphemeralKeyType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(EphemeralKeyType.dataTypeNodeId, "EphemeralKeyType", EphemeralKeyType);
    var schemaEventFieldList = (0, node_opcua_factory_1.buildStructuredType)({
      name: "EventFieldList",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ClientHandle",
          fieldType: "UInt32"
        },
        {
          name: "EventFields",
          fieldType: "Variant",
          isArray: true
        }
      ]
    });
    var EventFieldList = class _EventFieldList extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaEventFieldList;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.clientHandle = 0;
          this.eventFields = [];
          return;
        }
        const schema = _EventFieldList.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.clientHandle = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.clientHandle);
        this.eventFields = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.eventFields);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.clientHandle, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.eventFields, stream, node_opcua_variant_1.encodeVariant);
      }
      decode(stream) {
        super.decode(stream);
        this.clientHandle = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.clientHandle);
        this.eventFields = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_variant_1.decodeVariant);
      }
      get schema() {
        return schemaEventFieldList;
      }
    };
    exports2.EventFieldList = EventFieldList;
    EventFieldList.possibleFields = [
      "clientHandle",
      "eventFields"
    ];
    EventFieldList.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(917, 0);
    EventFieldList.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(919, 0);
    EventFieldList.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(918, 0);
    EventFieldList.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15348, 0);
    EventFieldList.schema.dataTypeNodeId = EventFieldList.dataTypeNodeId;
    EventFieldList.schema.encodingDefaultBinary = EventFieldList.encodingDefaultBinary;
    EventFieldList.schema.encodingDefaultXml = EventFieldList.encodingDefaultXml;
    EventFieldList.schema.encodingDefaultJson = EventFieldList.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(EventFieldList.dataTypeNodeId, "EventFieldList", EventFieldList);
    var schemaEventFilter = (0, node_opcua_factory_1.buildStructuredType)({
      name: "EventFilter",
      baseType: "MonitoringFilter",
      fields: [
        {
          name: "SelectClauses",
          fieldType: "SimpleAttributeOperand",
          isArray: true
        },
        {
          name: "WhereClause",
          fieldType: "ContentFilter"
        }
      ]
    });
    var EventFilter = class _EventFilter extends MonitoringFilter {
      static get schema() {
        return schemaEventFilter;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.selectClauses = null;
          this.whereClause = new ContentFilter(null);
          return;
        }
        const schema = _EventFilter.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.selectClauses = [];
        if (options.selectClauses) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.selectClauses));
          this.selectClauses = options.selectClauses.map((e) => new SimpleAttributeOperand(e));
        }
        this.whereClause = new ContentFilter(options.whereClause);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.selectClauses, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        this.whereClause.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.selectClauses = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new SimpleAttributeOperand(null);
          obj.decode(stream1);
          return obj;
        });
        this.whereClause.decode(stream);
      }
      get schema() {
        return schemaEventFilter;
      }
    };
    exports2.EventFilter = EventFilter;
    EventFilter.possibleFields = [
      "selectClauses",
      "whereClause"
    ];
    EventFilter.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(725, 0);
    EventFilter.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(727, 0);
    EventFilter.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(726, 0);
    EventFilter.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15295, 0);
    EventFilter.schema.dataTypeNodeId = EventFilter.dataTypeNodeId;
    EventFilter.schema.encodingDefaultBinary = EventFilter.encodingDefaultBinary;
    EventFilter.schema.encodingDefaultXml = EventFilter.encodingDefaultXml;
    EventFilter.schema.encodingDefaultJson = EventFilter.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(EventFilter.dataTypeNodeId, "EventFilter", EventFilter);
    var schemaEventFilterResult = (0, node_opcua_factory_1.buildStructuredType)({
      name: "EventFilterResult",
      baseType: "MonitoringFilterResult",
      fields: [
        {
          name: "SelectClauseResults",
          fieldType: "StatusCode",
          isArray: true
        },
        {
          name: "SelectClauseDiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        },
        {
          name: "WhereClauseResult",
          fieldType: "ContentFilterResult"
        }
      ]
    });
    var EventFilterResult = class _EventFilterResult extends MonitoringFilterResult {
      static get schema() {
        return schemaEventFilterResult;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.selectClauseResults = [];
          this.selectClauseDiagnosticInfos = [];
          this.whereClauseResult = new ContentFilterResult(null);
          return;
        }
        const schema = _EventFilterResult.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.selectClauseResults = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[0], options?.selectClauseResults);
        this.selectClauseDiagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.selectClauseDiagnosticInfos);
        this.whereClauseResult = new ContentFilterResult(options.whereClauseResult);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.selectClauseResults, stream, node_opcua_status_code_1.encodeStatusCode);
        (0, node_opcua_basic_types_1.encodeArray)(this.selectClauseDiagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
        this.whereClauseResult.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.selectClauseResults = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_status_code_1.decodeStatusCode);
        this.selectClauseDiagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
        this.whereClauseResult.decode(stream);
      }
      get schema() {
        return schemaEventFilterResult;
      }
    };
    exports2.EventFilterResult = EventFilterResult;
    EventFilterResult.possibleFields = [
      "selectClauseResults",
      "selectClauseDiagnosticInfos",
      "whereClauseResult"
    ];
    EventFilterResult.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(734, 0);
    EventFilterResult.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(736, 0);
    EventFilterResult.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(735, 0);
    EventFilterResult.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15314, 0);
    EventFilterResult.schema.dataTypeNodeId = EventFilterResult.dataTypeNodeId;
    EventFilterResult.schema.encodingDefaultBinary = EventFilterResult.encodingDefaultBinary;
    EventFilterResult.schema.encodingDefaultXml = EventFilterResult.encodingDefaultXml;
    EventFilterResult.schema.encodingDefaultJson = EventFilterResult.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(EventFilterResult.dataTypeNodeId, "EventFilterResult", EventFilterResult);
    var schemaEventNotificationList = (0, node_opcua_factory_1.buildStructuredType)({
      name: "EventNotificationList",
      baseType: "NotificationData",
      fields: [
        {
          name: "Events",
          fieldType: "EventFieldList",
          isArray: true
        }
      ]
    });
    var EventNotificationList = class _EventNotificationList extends NotificationData {
      static get schema() {
        return schemaEventNotificationList;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.events = null;
          return;
        }
        const schema = _EventNotificationList.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.events = [];
        if (options.events) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.events));
          this.events = options.events.map((e) => new EventFieldList(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.events, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.events = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new EventFieldList(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaEventNotificationList;
      }
    };
    exports2.EventNotificationList = EventNotificationList;
    EventNotificationList.possibleFields = [
      "events"
    ];
    EventNotificationList.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(914, 0);
    EventNotificationList.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(916, 0);
    EventNotificationList.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(915, 0);
    EventNotificationList.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15347, 0);
    EventNotificationList.schema.dataTypeNodeId = EventNotificationList.dataTypeNodeId;
    EventNotificationList.schema.encodingDefaultBinary = EventNotificationList.encodingDefaultBinary;
    EventNotificationList.schema.encodingDefaultXml = EventNotificationList.encodingDefaultXml;
    EventNotificationList.schema.encodingDefaultJson = EventNotificationList.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(EventNotificationList.dataTypeNodeId, "EventNotificationList", EventNotificationList);
    var OverrideValueHandling;
    (function(OverrideValueHandling2) {
      OverrideValueHandling2[OverrideValueHandling2["Disabled"] = 0] = "Disabled";
      OverrideValueHandling2[OverrideValueHandling2["LastUsableValue"] = 1] = "LastUsableValue";
      OverrideValueHandling2[OverrideValueHandling2["OverrideValue"] = 2] = "OverrideValue";
      OverrideValueHandling2[OverrideValueHandling2["Invalid"] = 4294967295] = "Invalid";
    })(OverrideValueHandling || (exports2.OverrideValueHandling = OverrideValueHandling = {}));
    var schemaOverrideValueHandling = {
      enumValues: OverrideValueHandling,
      flaggable: false,
      minValue: 0,
      maxValue: 2,
      name: "OverrideValueHandling"
    };
    function decodeOverrideValueHandling(stream, _value) {
      let value = stream.readUInt32();
      value = value < schemaOverrideValueHandling.minValue || value > schemaOverrideValueHandling.maxValue ? OverrideValueHandling.Invalid : value;
      return value;
    }
    function encodeOverrideValueHandling(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationOverrideValueHandling = (0, node_opcua_factory_1.registerEnumeration)(schemaOverrideValueHandling);
    (0, node_opcua_assert_1.assert)(exports2._enumerationOverrideValueHandling.isFlaggable === false);
    var schemaFieldTargetDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "FieldTargetDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "DataSetFieldId",
          fieldType: "Guid"
        },
        {
          name: "ReceiverIndexRange",
          fieldType: "String"
        },
        {
          name: "TargetNodeId",
          fieldType: "NodeId"
        },
        {
          name: "AttributeId",
          fieldType: "UInt32"
        },
        {
          name: "WriteIndexRange",
          fieldType: "String"
        },
        {
          name: "OverrideValueHandling",
          fieldType: "OverrideValueHandling"
        },
        {
          name: "OverrideValue",
          fieldType: "Variant"
        }
      ]
    });
    var FieldTargetDataType = class _FieldTargetDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaFieldTargetDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.dataSetFieldId = "";
          this.receiverIndexRange = null;
          this.targetNodeId = new node_opcua_nodeid_1.NodeId(null);
          this.attributeId = 0;
          this.writeIndexRange = null;
          this.overrideValueHandling = 0;
          this.overrideValue = new node_opcua_variant_1.Variant(null);
          return;
        }
        const schema = _FieldTargetDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.dataSetFieldId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.dataSetFieldId);
        this.receiverIndexRange = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.receiverIndexRange);
        this.targetNodeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.targetNodeId);
        this.attributeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.attributeId);
        this.writeIndexRange = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.writeIndexRange);
        this.overrideValueHandling = this.setOverrideValueHandling((0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.overrideValueHandling));
        this.overrideValue = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.overrideValue);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeGuid)(this.dataSetFieldId, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.receiverIndexRange, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.targetNodeId, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.attributeId, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.writeIndexRange, stream);
        encodeOverrideValueHandling(this.overrideValueHandling, stream);
        (0, node_opcua_variant_1.encodeVariant)(this.overrideValue, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.dataSetFieldId = (0, node_opcua_basic_types_1.decodeGuid)(stream, this.dataSetFieldId);
        this.receiverIndexRange = (0, node_opcua_basic_types_1.decodeString)(stream, this.receiverIndexRange);
        this.targetNodeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.targetNodeId);
        this.attributeId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.attributeId);
        this.writeIndexRange = (0, node_opcua_basic_types_1.decodeString)(stream, this.writeIndexRange);
        this.overrideValueHandling = decodeOverrideValueHandling(stream, this.overrideValueHandling);
        this.overrideValue = (0, node_opcua_variant_1.decodeVariant)(stream, this.overrideValue);
      }
      // Define Enumeration setters
      setOverrideValueHandling(value) {
        const coercedValue = exports2._enumerationOverrideValueHandling.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to OverrideValueHandling :" + value);
        }
        this.overrideValueHandling = coercedValue.value;
        return this.overrideValueHandling;
      }
      get schema() {
        return schemaFieldTargetDataType;
      }
    };
    exports2.FieldTargetDataType = FieldTargetDataType;
    FieldTargetDataType.possibleFields = [
      "dataSetFieldId",
      "receiverIndexRange",
      "targetNodeId",
      "attributeId",
      "writeIndexRange",
      "overrideValueHandling",
      "overrideValue"
    ];
    FieldTargetDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14744, 0);
    FieldTargetDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14848, 0);
    FieldTargetDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14804, 0);
    FieldTargetDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15061, 0);
    FieldTargetDataType.schema.dataTypeNodeId = FieldTargetDataType.dataTypeNodeId;
    FieldTargetDataType.schema.encodingDefaultBinary = FieldTargetDataType.encodingDefaultBinary;
    FieldTargetDataType.schema.encodingDefaultXml = FieldTargetDataType.encodingDefaultXml;
    FieldTargetDataType.schema.encodingDefaultJson = FieldTargetDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(FieldTargetDataType.dataTypeNodeId, "FieldTargetDataType", FieldTargetDataType);
    var schemaFindServersOnNetworkRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "FindServersOnNetworkRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "StartingRecordId",
          fieldType: "UInt32"
        },
        {
          name: "MaxRecordsToReturn",
          fieldType: "UInt32"
        },
        {
          name: "ServerCapabilityFilter",
          fieldType: "String",
          isArray: true
        }
      ]
    });
    var FindServersOnNetworkRequest = class _FindServersOnNetworkRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaFindServersOnNetworkRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.startingRecordId = 0;
          this.maxRecordsToReturn = 0;
          this.serverCapabilityFilter = [];
          return;
        }
        const schema = _FindServersOnNetworkRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.startingRecordId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.startingRecordId);
        this.maxRecordsToReturn = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.maxRecordsToReturn);
        this.serverCapabilityFilter = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[3], options?.serverCapabilityFilter);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.startingRecordId, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.maxRecordsToReturn, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.serverCapabilityFilter, stream, node_opcua_basic_types_1.encodeString);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.startingRecordId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.startingRecordId);
        this.maxRecordsToReturn = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.maxRecordsToReturn);
        this.serverCapabilityFilter = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
      }
      get schema() {
        return schemaFindServersOnNetworkRequest;
      }
    };
    exports2.FindServersOnNetworkRequest = FindServersOnNetworkRequest;
    FindServersOnNetworkRequest.possibleFields = [
      "requestHeader",
      "startingRecordId",
      "maxRecordsToReturn",
      "serverCapabilityFilter"
    ];
    FindServersOnNetworkRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12190, 0);
    FindServersOnNetworkRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12208, 0);
    FindServersOnNetworkRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12196, 0);
    FindServersOnNetworkRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15096, 0);
    FindServersOnNetworkRequest.schema.dataTypeNodeId = FindServersOnNetworkRequest.dataTypeNodeId;
    FindServersOnNetworkRequest.schema.encodingDefaultBinary = FindServersOnNetworkRequest.encodingDefaultBinary;
    FindServersOnNetworkRequest.schema.encodingDefaultXml = FindServersOnNetworkRequest.encodingDefaultXml;
    FindServersOnNetworkRequest.schema.encodingDefaultJson = FindServersOnNetworkRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(FindServersOnNetworkRequest.dataTypeNodeId, "FindServersOnNetworkRequest", FindServersOnNetworkRequest);
    var schemaServerOnNetwork = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ServerOnNetwork",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RecordId",
          fieldType: "UInt32"
        },
        {
          name: "ServerName",
          fieldType: "String"
        },
        {
          name: "DiscoveryUrl",
          fieldType: "String"
        },
        {
          name: "ServerCapabilities",
          fieldType: "String",
          isArray: true
        }
      ]
    });
    var ServerOnNetwork = class _ServerOnNetwork extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaServerOnNetwork;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.recordId = 0;
          this.serverName = null;
          this.discoveryUrl = null;
          this.serverCapabilities = [];
          return;
        }
        const schema = _ServerOnNetwork.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.recordId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.recordId);
        this.serverName = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.serverName);
        this.discoveryUrl = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.discoveryUrl);
        this.serverCapabilities = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[3], options?.serverCapabilities);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.recordId, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.serverName, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.discoveryUrl, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.serverCapabilities, stream, node_opcua_basic_types_1.encodeString);
      }
      decode(stream) {
        super.decode(stream);
        this.recordId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.recordId);
        this.serverName = (0, node_opcua_basic_types_1.decodeString)(stream, this.serverName);
        this.discoveryUrl = (0, node_opcua_basic_types_1.decodeString)(stream, this.discoveryUrl);
        this.serverCapabilities = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
      }
      get schema() {
        return schemaServerOnNetwork;
      }
    };
    exports2.ServerOnNetwork = ServerOnNetwork;
    ServerOnNetwork.possibleFields = [
      "recordId",
      "serverName",
      "discoveryUrl",
      "serverCapabilities"
    ];
    ServerOnNetwork.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12189, 0);
    ServerOnNetwork.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12207, 0);
    ServerOnNetwork.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12195, 0);
    ServerOnNetwork.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15095, 0);
    ServerOnNetwork.schema.dataTypeNodeId = ServerOnNetwork.dataTypeNodeId;
    ServerOnNetwork.schema.encodingDefaultBinary = ServerOnNetwork.encodingDefaultBinary;
    ServerOnNetwork.schema.encodingDefaultXml = ServerOnNetwork.encodingDefaultXml;
    ServerOnNetwork.schema.encodingDefaultJson = ServerOnNetwork.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ServerOnNetwork.dataTypeNodeId, "ServerOnNetwork", ServerOnNetwork);
    var schemaFindServersOnNetworkResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "FindServersOnNetworkResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "LastCounterResetTime",
          fieldType: "DateTime"
        },
        {
          name: "Servers",
          fieldType: "ServerOnNetwork",
          isArray: true
        }
      ]
    });
    var FindServersOnNetworkResponse = class _FindServersOnNetworkResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaFindServersOnNetworkResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.lastCounterResetTime = /* @__PURE__ */ new Date();
          this.servers = null;
          return;
        }
        const schema = _FindServersOnNetworkResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.lastCounterResetTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.lastCounterResetTime);
        this.servers = [];
        if (options.servers) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.servers));
          this.servers = options.servers.map((e) => new ServerOnNetwork(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.lastCounterResetTime, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.servers, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.lastCounterResetTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.lastCounterResetTime);
        this.servers = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new ServerOnNetwork(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaFindServersOnNetworkResponse;
      }
    };
    exports2.FindServersOnNetworkResponse = FindServersOnNetworkResponse;
    FindServersOnNetworkResponse.possibleFields = [
      "responseHeader",
      "lastCounterResetTime",
      "servers"
    ];
    FindServersOnNetworkResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12191, 0);
    FindServersOnNetworkResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12209, 0);
    FindServersOnNetworkResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12197, 0);
    FindServersOnNetworkResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15097, 0);
    FindServersOnNetworkResponse.schema.dataTypeNodeId = FindServersOnNetworkResponse.dataTypeNodeId;
    FindServersOnNetworkResponse.schema.encodingDefaultBinary = FindServersOnNetworkResponse.encodingDefaultBinary;
    FindServersOnNetworkResponse.schema.encodingDefaultXml = FindServersOnNetworkResponse.encodingDefaultXml;
    FindServersOnNetworkResponse.schema.encodingDefaultJson = FindServersOnNetworkResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(FindServersOnNetworkResponse.dataTypeNodeId, "FindServersOnNetworkResponse", FindServersOnNetworkResponse);
    var schemaFindServersRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "FindServersRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "EndpointUrl",
          fieldType: "String"
        },
        {
          name: "LocaleIds",
          fieldType: "String",
          isArray: true
        },
        {
          name: "ServerUris",
          fieldType: "String",
          isArray: true
        }
      ]
    });
    var FindServersRequest = class _FindServersRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaFindServersRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.endpointUrl = null;
          this.localeIds = [];
          this.serverUris = [];
          return;
        }
        const schema = _FindServersRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.endpointUrl = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.endpointUrl);
        this.localeIds = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.localeIds);
        this.serverUris = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[3], options?.serverUris);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.endpointUrl, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.localeIds, stream, node_opcua_basic_types_1.encodeString);
        (0, node_opcua_basic_types_1.encodeArray)(this.serverUris, stream, node_opcua_basic_types_1.encodeString);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.endpointUrl = (0, node_opcua_basic_types_1.decodeString)(stream, this.endpointUrl);
        this.localeIds = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
        this.serverUris = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
      }
      get schema() {
        return schemaFindServersRequest;
      }
    };
    exports2.FindServersRequest = FindServersRequest;
    FindServersRequest.possibleFields = [
      "requestHeader",
      "endpointUrl",
      "localeIds",
      "serverUris"
    ];
    FindServersRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(420, 0);
    FindServersRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(422, 0);
    FindServersRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(421, 0);
    FindServersRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15093, 0);
    FindServersRequest.schema.dataTypeNodeId = FindServersRequest.dataTypeNodeId;
    FindServersRequest.schema.encodingDefaultBinary = FindServersRequest.encodingDefaultBinary;
    FindServersRequest.schema.encodingDefaultXml = FindServersRequest.encodingDefaultXml;
    FindServersRequest.schema.encodingDefaultJson = FindServersRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(FindServersRequest.dataTypeNodeId, "FindServersRequest", FindServersRequest);
    var schemaFindServersResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "FindServersResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "Servers",
          fieldType: "ApplicationDescription",
          isArray: true
        }
      ]
    });
    var FindServersResponse = class _FindServersResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaFindServersResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.servers = null;
          return;
        }
        const schema = _FindServersResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.servers = [];
        if (options.servers) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.servers));
          this.servers = options.servers.map((e) => new ApplicationDescription(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.servers, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.servers = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new ApplicationDescription(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaFindServersResponse;
      }
    };
    exports2.FindServersResponse = FindServersResponse;
    FindServersResponse.possibleFields = [
      "responseHeader",
      "servers"
    ];
    FindServersResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(423, 0);
    FindServersResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(425, 0);
    FindServersResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(424, 0);
    FindServersResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15094, 0);
    FindServersResponse.schema.dataTypeNodeId = FindServersResponse.dataTypeNodeId;
    FindServersResponse.schema.encodingDefaultBinary = FindServersResponse.encodingDefaultBinary;
    FindServersResponse.schema.encodingDefaultXml = FindServersResponse.encodingDefaultXml;
    FindServersResponse.schema.encodingDefaultJson = FindServersResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(FindServersResponse.dataTypeNodeId, "FindServersResponse", FindServersResponse);
    var schemaFrame = (0, node_opcua_factory_1.buildStructuredType)({
      name: "Frame",
      baseType: "ExtensionObject",
      fields: []
    });
    var Frame = class _Frame extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaFrame;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _Frame.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaFrame;
      }
    };
    exports2.Frame = Frame;
    Frame.possibleFields = [];
    Frame.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18813, 0);
    Frame.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18822, 0);
    Frame.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18858, 0);
    Frame.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(19071, 0);
    Frame.schema.dataTypeNodeId = Frame.dataTypeNodeId;
    Frame.schema.encodingDefaultBinary = Frame.encodingDefaultBinary;
    Frame.schema.encodingDefaultXml = Frame.encodingDefaultXml;
    Frame.schema.encodingDefaultJson = Frame.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(Frame.dataTypeNodeId, "Frame", Frame);
    var schemaGenericAttributeValue = (0, node_opcua_factory_1.buildStructuredType)({
      name: "GenericAttributeValue",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "AttributeId",
          fieldType: "UInt32"
        },
        {
          name: "Value",
          fieldType: "Variant"
        }
      ]
    });
    var GenericAttributeValue = class _GenericAttributeValue extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaGenericAttributeValue;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.attributeId = 0;
          this.value = new node_opcua_variant_1.Variant(null);
          return;
        }
        const schema = _GenericAttributeValue.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.attributeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.attributeId);
        this.value = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.value);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.attributeId, stream);
        (0, node_opcua_variant_1.encodeVariant)(this.value, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.attributeId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.attributeId);
        this.value = (0, node_opcua_variant_1.decodeVariant)(stream, this.value);
      }
      get schema() {
        return schemaGenericAttributeValue;
      }
    };
    exports2.GenericAttributeValue = GenericAttributeValue;
    GenericAttributeValue.possibleFields = [
      "attributeId",
      "value"
    ];
    GenericAttributeValue.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(17606, 0);
    GenericAttributeValue.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(17610, 0);
    GenericAttributeValue.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(17608, 0);
    GenericAttributeValue.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15163, 0);
    GenericAttributeValue.schema.dataTypeNodeId = GenericAttributeValue.dataTypeNodeId;
    GenericAttributeValue.schema.encodingDefaultBinary = GenericAttributeValue.encodingDefaultBinary;
    GenericAttributeValue.schema.encodingDefaultXml = GenericAttributeValue.encodingDefaultXml;
    GenericAttributeValue.schema.encodingDefaultJson = GenericAttributeValue.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(GenericAttributeValue.dataTypeNodeId, "GenericAttributeValue", GenericAttributeValue);
    var schemaGenericAttributes = (0, node_opcua_factory_1.buildStructuredType)({
      name: "GenericAttributes",
      baseType: "NodeAttributes",
      fields: [
        {
          name: "AttributeValues",
          fieldType: "GenericAttributeValue",
          isArray: true
        }
      ]
    });
    var GenericAttributes = class _GenericAttributes extends NodeAttributes {
      static get schema() {
        return schemaGenericAttributes;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.attributeValues = null;
          return;
        }
        const schema = _GenericAttributes.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.attributeValues = [];
        if (options.attributeValues) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.attributeValues));
          this.attributeValues = options.attributeValues.map((e) => new GenericAttributeValue(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.attributeValues, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.attributeValues = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new GenericAttributeValue(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaGenericAttributes;
      }
    };
    exports2.GenericAttributes = GenericAttributes;
    GenericAttributes.possibleFields = [
      "specifiedAttributes",
      "displayName",
      "description",
      "writeMask",
      "userWriteMask",
      "attributeValues"
    ];
    GenericAttributes.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(17607, 0);
    GenericAttributes.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(17611, 0);
    GenericAttributes.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(17609, 0);
    GenericAttributes.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15164, 0);
    GenericAttributes.schema.dataTypeNodeId = GenericAttributes.dataTypeNodeId;
    GenericAttributes.schema.encodingDefaultBinary = GenericAttributes.encodingDefaultBinary;
    GenericAttributes.schema.encodingDefaultXml = GenericAttributes.encodingDefaultXml;
    GenericAttributes.schema.encodingDefaultJson = GenericAttributes.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(GenericAttributes.dataTypeNodeId, "GenericAttributes", GenericAttributes);
    var schemaGetEndpointsRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "GetEndpointsRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "EndpointUrl",
          fieldType: "String"
        },
        {
          name: "LocaleIds",
          fieldType: "String",
          isArray: true
        },
        {
          name: "ProfileUris",
          fieldType: "String",
          isArray: true
        }
      ]
    });
    var GetEndpointsRequest = class _GetEndpointsRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaGetEndpointsRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.endpointUrl = null;
          this.localeIds = [];
          this.profileUris = [];
          return;
        }
        const schema = _GetEndpointsRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.endpointUrl = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.endpointUrl);
        this.localeIds = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.localeIds);
        this.profileUris = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[3], options?.profileUris);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.endpointUrl, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.localeIds, stream, node_opcua_basic_types_1.encodeString);
        (0, node_opcua_basic_types_1.encodeArray)(this.profileUris, stream, node_opcua_basic_types_1.encodeString);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.endpointUrl = (0, node_opcua_basic_types_1.decodeString)(stream, this.endpointUrl);
        this.localeIds = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
        this.profileUris = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
      }
      get schema() {
        return schemaGetEndpointsRequest;
      }
    };
    exports2.GetEndpointsRequest = GetEndpointsRequest;
    GetEndpointsRequest.possibleFields = [
      "requestHeader",
      "endpointUrl",
      "localeIds",
      "profileUris"
    ];
    GetEndpointsRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(426, 0);
    GetEndpointsRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(428, 0);
    GetEndpointsRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(427, 0);
    GetEndpointsRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15100, 0);
    GetEndpointsRequest.schema.dataTypeNodeId = GetEndpointsRequest.dataTypeNodeId;
    GetEndpointsRequest.schema.encodingDefaultBinary = GetEndpointsRequest.encodingDefaultBinary;
    GetEndpointsRequest.schema.encodingDefaultXml = GetEndpointsRequest.encodingDefaultXml;
    GetEndpointsRequest.schema.encodingDefaultJson = GetEndpointsRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(GetEndpointsRequest.dataTypeNodeId, "GetEndpointsRequest", GetEndpointsRequest);
    var schemaGetEndpointsResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "GetEndpointsResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "Endpoints",
          fieldType: "EndpointDescription",
          isArray: true
        }
      ]
    });
    var GetEndpointsResponse = class _GetEndpointsResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaGetEndpointsResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.endpoints = null;
          return;
        }
        const schema = _GetEndpointsResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.endpoints = [];
        if (options.endpoints) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.endpoints));
          this.endpoints = options.endpoints.map((e) => new EndpointDescription(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.endpoints, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.endpoints = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new EndpointDescription(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaGetEndpointsResponse;
      }
    };
    exports2.GetEndpointsResponse = GetEndpointsResponse;
    GetEndpointsResponse.possibleFields = [
      "responseHeader",
      "endpoints"
    ];
    GetEndpointsResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(429, 0);
    GetEndpointsResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(431, 0);
    GetEndpointsResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(430, 0);
    GetEndpointsResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15101, 0);
    GetEndpointsResponse.schema.dataTypeNodeId = GetEndpointsResponse.dataTypeNodeId;
    GetEndpointsResponse.schema.encodingDefaultBinary = GetEndpointsResponse.encodingDefaultBinary;
    GetEndpointsResponse.schema.encodingDefaultXml = GetEndpointsResponse.encodingDefaultXml;
    GetEndpointsResponse.schema.encodingDefaultJson = GetEndpointsResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(GetEndpointsResponse.dataTypeNodeId, "GetEndpointsResponse", GetEndpointsResponse);
    var schemaHistoryData = (0, node_opcua_factory_1.buildStructuredType)({
      name: "HistoryData",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "DataValues",
          fieldType: "DataValue",
          isArray: true
        }
      ]
    });
    var HistoryData = class _HistoryData extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaHistoryData;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.dataValues = [];
          return;
        }
        const schema = _HistoryData.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.dataValues = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[0], options?.dataValues);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.dataValues, stream, node_opcua_data_value_1.encodeDataValue);
      }
      decode(stream) {
        super.decode(stream);
        this.dataValues = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_value_1.decodeDataValue);
      }
      get schema() {
        return schemaHistoryData;
      }
    };
    exports2.HistoryData = HistoryData;
    HistoryData.possibleFields = [
      "dataValues"
    ];
    HistoryData.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(656, 0);
    HistoryData.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(658, 0);
    HistoryData.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(657, 0);
    HistoryData.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15270, 0);
    HistoryData.schema.dataTypeNodeId = HistoryData.dataTypeNodeId;
    HistoryData.schema.encodingDefaultBinary = HistoryData.encodingDefaultBinary;
    HistoryData.schema.encodingDefaultXml = HistoryData.encodingDefaultXml;
    HistoryData.schema.encodingDefaultJson = HistoryData.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(HistoryData.dataTypeNodeId, "HistoryData", HistoryData);
    var schemaHistoryEventFieldList = (0, node_opcua_factory_1.buildStructuredType)({
      name: "HistoryEventFieldList",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "EventFields",
          fieldType: "Variant",
          isArray: true
        }
      ]
    });
    var HistoryEventFieldList = class _HistoryEventFieldList extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaHistoryEventFieldList;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.eventFields = [];
          return;
        }
        const schema = _HistoryEventFieldList.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.eventFields = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[0], options?.eventFields);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.eventFields, stream, node_opcua_variant_1.encodeVariant);
      }
      decode(stream) {
        super.decode(stream);
        this.eventFields = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_variant_1.decodeVariant);
      }
      get schema() {
        return schemaHistoryEventFieldList;
      }
    };
    exports2.HistoryEventFieldList = HistoryEventFieldList;
    HistoryEventFieldList.possibleFields = [
      "eventFields"
    ];
    HistoryEventFieldList.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(920, 0);
    HistoryEventFieldList.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(922, 0);
    HistoryEventFieldList.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(921, 0);
    HistoryEventFieldList.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15349, 0);
    HistoryEventFieldList.schema.dataTypeNodeId = HistoryEventFieldList.dataTypeNodeId;
    HistoryEventFieldList.schema.encodingDefaultBinary = HistoryEventFieldList.encodingDefaultBinary;
    HistoryEventFieldList.schema.encodingDefaultXml = HistoryEventFieldList.encodingDefaultXml;
    HistoryEventFieldList.schema.encodingDefaultJson = HistoryEventFieldList.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(HistoryEventFieldList.dataTypeNodeId, "HistoryEventFieldList", HistoryEventFieldList);
    var schemaHistoryEvent = (0, node_opcua_factory_1.buildStructuredType)({
      name: "HistoryEvent",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Events",
          fieldType: "HistoryEventFieldList",
          isArray: true
        }
      ]
    });
    var HistoryEvent = class _HistoryEvent extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaHistoryEvent;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.events = null;
          return;
        }
        const schema = _HistoryEvent.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.events = [];
        if (options.events) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.events));
          this.events = options.events.map((e) => new HistoryEventFieldList(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.events, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.events = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new HistoryEventFieldList(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaHistoryEvent;
      }
    };
    exports2.HistoryEvent = HistoryEvent;
    HistoryEvent.possibleFields = [
      "events"
    ];
    HistoryEvent.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(659, 0);
    HistoryEvent.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(661, 0);
    HistoryEvent.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(660, 0);
    HistoryEvent.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15273, 0);
    HistoryEvent.schema.dataTypeNodeId = HistoryEvent.dataTypeNodeId;
    HistoryEvent.schema.encodingDefaultBinary = HistoryEvent.encodingDefaultBinary;
    HistoryEvent.schema.encodingDefaultXml = HistoryEvent.encodingDefaultXml;
    HistoryEvent.schema.encodingDefaultJson = HistoryEvent.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(HistoryEvent.dataTypeNodeId, "HistoryEvent", HistoryEvent);
    var HistoryUpdateType;
    (function(HistoryUpdateType2) {
      HistoryUpdateType2[HistoryUpdateType2["Insert"] = 1] = "Insert";
      HistoryUpdateType2[HistoryUpdateType2["Replace"] = 2] = "Replace";
      HistoryUpdateType2[HistoryUpdateType2["Update"] = 3] = "Update";
      HistoryUpdateType2[HistoryUpdateType2["Delete"] = 4] = "Delete";
      HistoryUpdateType2[HistoryUpdateType2["Invalid"] = 4294967295] = "Invalid";
    })(HistoryUpdateType || (exports2.HistoryUpdateType = HistoryUpdateType = {}));
    var schemaHistoryUpdateType = {
      enumValues: HistoryUpdateType,
      flaggable: false,
      minValue: 1,
      maxValue: 4,
      name: "HistoryUpdateType"
    };
    function decodeHistoryUpdateType(stream, _value) {
      let value = stream.readUInt32();
      value = value < schemaHistoryUpdateType.minValue || value > schemaHistoryUpdateType.maxValue ? HistoryUpdateType.Invalid : value;
      return value;
    }
    function encodeHistoryUpdateType(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationHistoryUpdateType = (0, node_opcua_factory_1.registerEnumeration)(schemaHistoryUpdateType);
    (0, node_opcua_assert_1.assert)(exports2._enumerationHistoryUpdateType.isFlaggable === false);
    var schemaModificationInfo = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ModificationInfo",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ModificationTime",
          fieldType: "DateTime"
        },
        {
          name: "UpdateType",
          fieldType: "HistoryUpdateType"
        },
        {
          name: "UserName",
          fieldType: "String"
        }
      ]
    });
    var ModificationInfo = class _ModificationInfo extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaModificationInfo;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.modificationTime = /* @__PURE__ */ new Date();
          this.updateType = 0;
          this.userName = null;
          return;
        }
        const schema = _ModificationInfo.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.modificationTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.modificationTime);
        this.updateType = this.setUpdateType((0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.updateType));
        this.userName = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.userName);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.modificationTime, stream);
        encodeHistoryUpdateType(this.updateType, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.userName, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.modificationTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.modificationTime);
        this.updateType = decodeHistoryUpdateType(stream, this.updateType);
        this.userName = (0, node_opcua_basic_types_1.decodeString)(stream, this.userName);
      }
      // Define Enumeration setters
      setUpdateType(value) {
        const coercedValue = exports2._enumerationHistoryUpdateType.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to HistoryUpdateType :" + value);
        }
        this.updateType = coercedValue.value;
        return this.updateType;
      }
      get schema() {
        return schemaModificationInfo;
      }
    };
    exports2.ModificationInfo = ModificationInfo;
    ModificationInfo.possibleFields = [
      "modificationTime",
      "updateType",
      "userName"
    ];
    ModificationInfo.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(11216, 0);
    ModificationInfo.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(11226, 0);
    ModificationInfo.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(11218, 0);
    ModificationInfo.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15271, 0);
    ModificationInfo.schema.dataTypeNodeId = ModificationInfo.dataTypeNodeId;
    ModificationInfo.schema.encodingDefaultBinary = ModificationInfo.encodingDefaultBinary;
    ModificationInfo.schema.encodingDefaultXml = ModificationInfo.encodingDefaultXml;
    ModificationInfo.schema.encodingDefaultJson = ModificationInfo.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ModificationInfo.dataTypeNodeId, "ModificationInfo", ModificationInfo);
    var schemaHistoryModifiedData = (0, node_opcua_factory_1.buildStructuredType)({
      name: "HistoryModifiedData",
      baseType: "HistoryData",
      fields: [
        {
          name: "ModificationInfos",
          fieldType: "ModificationInfo",
          isArray: true
        }
      ]
    });
    var HistoryModifiedData = class _HistoryModifiedData extends HistoryData {
      static get schema() {
        return schemaHistoryModifiedData;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.modificationInfos = null;
          return;
        }
        const schema = _HistoryModifiedData.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.modificationInfos = [];
        if (options.modificationInfos) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.modificationInfos));
          this.modificationInfos = options.modificationInfos.map((e) => new ModificationInfo(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.modificationInfos, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.modificationInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new ModificationInfo(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaHistoryModifiedData;
      }
    };
    exports2.HistoryModifiedData = HistoryModifiedData;
    HistoryModifiedData.possibleFields = [
      "dataValues",
      "modificationInfos"
    ];
    HistoryModifiedData.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(11217, 0);
    HistoryModifiedData.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(11227, 0);
    HistoryModifiedData.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(11219, 0);
    HistoryModifiedData.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15272, 0);
    HistoryModifiedData.schema.dataTypeNodeId = HistoryModifiedData.dataTypeNodeId;
    HistoryModifiedData.schema.encodingDefaultBinary = HistoryModifiedData.encodingDefaultBinary;
    HistoryModifiedData.schema.encodingDefaultXml = HistoryModifiedData.encodingDefaultXml;
    HistoryModifiedData.schema.encodingDefaultJson = HistoryModifiedData.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(HistoryModifiedData.dataTypeNodeId, "HistoryModifiedData", HistoryModifiedData);
    var schemaHistoryReadDetails = (0, node_opcua_factory_1.buildStructuredType)({
      name: "HistoryReadDetails",
      baseType: "ExtensionObject",
      fields: []
    });
    var HistoryReadDetails = class _HistoryReadDetails extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaHistoryReadDetails;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _HistoryReadDetails.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaHistoryReadDetails;
      }
    };
    exports2.HistoryReadDetails = HistoryReadDetails;
    HistoryReadDetails.possibleFields = [];
    HistoryReadDetails.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(641, 0);
    HistoryReadDetails.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(643, 0);
    HistoryReadDetails.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(642, 0);
    HistoryReadDetails.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15261, 0);
    HistoryReadDetails.schema.dataTypeNodeId = HistoryReadDetails.dataTypeNodeId;
    HistoryReadDetails.schema.encodingDefaultBinary = HistoryReadDetails.encodingDefaultBinary;
    HistoryReadDetails.schema.encodingDefaultXml = HistoryReadDetails.encodingDefaultXml;
    HistoryReadDetails.schema.encodingDefaultJson = HistoryReadDetails.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(HistoryReadDetails.dataTypeNodeId, "HistoryReadDetails", HistoryReadDetails);
    var schemaHistoryReadValueId = (0, node_opcua_factory_1.buildStructuredType)({
      name: "HistoryReadValueId",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "NodeId",
          fieldType: "NodeId"
        },
        {
          name: "IndexRange",
          fieldType: "NumericRange"
        },
        {
          name: "DataEncoding",
          fieldType: "QualifiedName"
        },
        {
          name: "ContinuationPoint",
          fieldType: "ByteString"
        }
      ]
    });
    var HistoryReadValueId = class _HistoryReadValueId extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaHistoryReadValueId;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.nodeId = new node_opcua_nodeid_1.NodeId(null);
          this.indexRange = new node_opcua_numeric_range_1.NumericRange(null);
          this.dataEncoding = new node_opcua_data_model_1.QualifiedName(null);
          this.continuationPoint = Buffer.alloc(0);
          return;
        }
        const schema = _HistoryReadValueId.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.nodeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.nodeId);
        this.indexRange = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.indexRange);
        this.dataEncoding = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.dataEncoding);
        this.continuationPoint = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.continuationPoint);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.nodeId, stream);
        (0, node_opcua_numeric_range_1.encodeNumericRange)(this.indexRange, stream);
        (0, node_opcua_data_model_1.encodeQualifiedName)(this.dataEncoding, stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.continuationPoint, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.nodeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.nodeId);
        this.indexRange = (0, node_opcua_numeric_range_1.decodeNumericRange)(stream, this.indexRange);
        this.dataEncoding = (0, node_opcua_data_model_1.decodeQualifiedName)(stream, this.dataEncoding);
        this.continuationPoint = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.continuationPoint);
      }
      get schema() {
        return schemaHistoryReadValueId;
      }
    };
    exports2.HistoryReadValueId = HistoryReadValueId;
    HistoryReadValueId.possibleFields = [
      "nodeId",
      "indexRange",
      "dataEncoding",
      "continuationPoint"
    ];
    HistoryReadValueId.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(635, 0);
    HistoryReadValueId.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(637, 0);
    HistoryReadValueId.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(636, 0);
    HistoryReadValueId.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15259, 0);
    HistoryReadValueId.schema.dataTypeNodeId = HistoryReadValueId.dataTypeNodeId;
    HistoryReadValueId.schema.encodingDefaultBinary = HistoryReadValueId.encodingDefaultBinary;
    HistoryReadValueId.schema.encodingDefaultXml = HistoryReadValueId.encodingDefaultXml;
    HistoryReadValueId.schema.encodingDefaultJson = HistoryReadValueId.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(HistoryReadValueId.dataTypeNodeId, "HistoryReadValueId", HistoryReadValueId);
    var schemaHistoryReadRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "HistoryReadRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "HistoryReadDetails",
          fieldType: "ExtensionObject"
        },
        {
          name: "TimestampsToReturn",
          fieldType: "TimestampsToReturn"
        },
        {
          name: "ReleaseContinuationPoints",
          fieldType: "Boolean"
        },
        {
          name: "NodesToRead",
          fieldType: "HistoryReadValueId",
          isArray: true
        }
      ]
    });
    var HistoryReadRequest = class _HistoryReadRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaHistoryReadRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.historyReadDetails = null;
          this.timestampsToReturn = 0;
          this.releaseContinuationPoints = false;
          this.nodesToRead = null;
          return;
        }
        const schema = _HistoryReadRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.historyReadDetails = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.historyReadDetails);
        this.timestampsToReturn = this.setTimestampsToReturn((0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.timestampsToReturn));
        this.releaseContinuationPoints = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.releaseContinuationPoints);
        this.nodesToRead = [];
        if (options.nodesToRead) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.nodesToRead));
          this.nodesToRead = options.nodesToRead.map((e) => new HistoryReadValueId(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.historyReadDetails, stream);
        (0, node_opcua_data_value_1.encodeTimestampsToReturn)(this.timestampsToReturn, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.releaseContinuationPoints, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.nodesToRead, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.historyReadDetails = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.historyReadDetails);
        this.timestampsToReturn = (0, node_opcua_data_value_1.decodeTimestampsToReturn)(stream, this.timestampsToReturn);
        this.releaseContinuationPoints = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.releaseContinuationPoints);
        this.nodesToRead = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new HistoryReadValueId(null);
          obj.decode(stream1);
          return obj;
        });
      }
      // Define Enumeration setters
      setTimestampsToReturn(value) {
        const coercedValue = node_opcua_data_value_1._enumerationTimestampsToReturn.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to TimestampsToReturn :" + value);
        }
        this.timestampsToReturn = coercedValue.value;
        return this.timestampsToReturn;
      }
      get schema() {
        return schemaHistoryReadRequest;
      }
    };
    exports2.HistoryReadRequest = HistoryReadRequest;
    HistoryReadRequest.possibleFields = [
      "requestHeader",
      "historyReadDetails",
      "timestampsToReturn",
      "releaseContinuationPoints",
      "nodesToRead"
    ];
    HistoryReadRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(662, 0);
    HistoryReadRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(664, 0);
    HistoryReadRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(663, 0);
    HistoryReadRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15274, 0);
    HistoryReadRequest.schema.dataTypeNodeId = HistoryReadRequest.dataTypeNodeId;
    HistoryReadRequest.schema.encodingDefaultBinary = HistoryReadRequest.encodingDefaultBinary;
    HistoryReadRequest.schema.encodingDefaultXml = HistoryReadRequest.encodingDefaultXml;
    HistoryReadRequest.schema.encodingDefaultJson = HistoryReadRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(HistoryReadRequest.dataTypeNodeId, "HistoryReadRequest", HistoryReadRequest);
    var schemaHistoryReadResult = (0, node_opcua_factory_1.buildStructuredType)({
      name: "HistoryReadResult",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "StatusCode",
          fieldType: "StatusCode"
        },
        {
          name: "ContinuationPoint",
          fieldType: "ByteString"
        },
        {
          name: "HistoryData",
          fieldType: "ExtensionObject"
        }
      ]
    });
    var HistoryReadResult = class _HistoryReadResult extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaHistoryReadResult;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.statusCode = node_opcua_status_code_1.StatusCodes.Good;
          this.continuationPoint = Buffer.alloc(0);
          this.historyData = null;
          return;
        }
        const schema = _HistoryReadResult.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.statusCode = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.statusCode);
        this.continuationPoint = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.continuationPoint);
        this.historyData = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.historyData);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_status_code_1.encodeStatusCode)(this.statusCode, stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.continuationPoint, stream);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.historyData, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.statusCode = (0, node_opcua_status_code_1.decodeStatusCode)(stream, this.statusCode);
        this.continuationPoint = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.continuationPoint);
        this.historyData = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.historyData);
      }
      get schema() {
        return schemaHistoryReadResult;
      }
    };
    exports2.HistoryReadResult = HistoryReadResult;
    HistoryReadResult.possibleFields = [
      "statusCode",
      "continuationPoint",
      "historyData"
    ];
    HistoryReadResult.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(638, 0);
    HistoryReadResult.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(640, 0);
    HistoryReadResult.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(639, 0);
    HistoryReadResult.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15260, 0);
    HistoryReadResult.schema.dataTypeNodeId = HistoryReadResult.dataTypeNodeId;
    HistoryReadResult.schema.encodingDefaultBinary = HistoryReadResult.encodingDefaultBinary;
    HistoryReadResult.schema.encodingDefaultXml = HistoryReadResult.encodingDefaultXml;
    HistoryReadResult.schema.encodingDefaultJson = HistoryReadResult.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(HistoryReadResult.dataTypeNodeId, "HistoryReadResult", HistoryReadResult);
    var schemaHistoryReadResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "HistoryReadResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "Results",
          fieldType: "HistoryReadResult",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var HistoryReadResponse = class _HistoryReadResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaHistoryReadResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.results = null;
          this.diagnosticInfos = [];
          return;
        }
        const schema = _HistoryReadResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.results = [];
        if (options.results) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.results));
          this.results = options.results.map((e) => new HistoryReadResult(e));
        }
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.results, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.results = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new HistoryReadResult(null);
          obj.decode(stream1);
          return obj;
        });
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaHistoryReadResponse;
      }
    };
    exports2.HistoryReadResponse = HistoryReadResponse;
    HistoryReadResponse.possibleFields = [
      "responseHeader",
      "results",
      "diagnosticInfos"
    ];
    HistoryReadResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(665, 0);
    HistoryReadResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(667, 0);
    HistoryReadResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(666, 0);
    HistoryReadResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15275, 0);
    HistoryReadResponse.schema.dataTypeNodeId = HistoryReadResponse.dataTypeNodeId;
    HistoryReadResponse.schema.encodingDefaultBinary = HistoryReadResponse.encodingDefaultBinary;
    HistoryReadResponse.schema.encodingDefaultXml = HistoryReadResponse.encodingDefaultXml;
    HistoryReadResponse.schema.encodingDefaultJson = HistoryReadResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(HistoryReadResponse.dataTypeNodeId, "HistoryReadResponse", HistoryReadResponse);
    var schemaHistoryUpdateRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "HistoryUpdateRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "HistoryUpdateDetails",
          fieldType: "ExtensionObject",
          isArray: true
        }
      ]
    });
    var HistoryUpdateRequest = class _HistoryUpdateRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaHistoryUpdateRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.historyUpdateDetails = [];
          return;
        }
        const schema = _HistoryUpdateRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.historyUpdateDetails = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.historyUpdateDetails);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.historyUpdateDetails, stream, node_opcua_extension_object_1.encodeExtensionObject);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.historyUpdateDetails = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_extension_object_1.decodeExtensionObject);
      }
      get schema() {
        return schemaHistoryUpdateRequest;
      }
    };
    exports2.HistoryUpdateRequest = HistoryUpdateRequest;
    HistoryUpdateRequest.possibleFields = [
      "requestHeader",
      "historyUpdateDetails"
    ];
    HistoryUpdateRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(698, 0);
    HistoryUpdateRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(700, 0);
    HistoryUpdateRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(699, 0);
    HistoryUpdateRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15287, 0);
    HistoryUpdateRequest.schema.dataTypeNodeId = HistoryUpdateRequest.dataTypeNodeId;
    HistoryUpdateRequest.schema.encodingDefaultBinary = HistoryUpdateRequest.encodingDefaultBinary;
    HistoryUpdateRequest.schema.encodingDefaultXml = HistoryUpdateRequest.encodingDefaultXml;
    HistoryUpdateRequest.schema.encodingDefaultJson = HistoryUpdateRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(HistoryUpdateRequest.dataTypeNodeId, "HistoryUpdateRequest", HistoryUpdateRequest);
    var schemaHistoryUpdateResult = (0, node_opcua_factory_1.buildStructuredType)({
      name: "HistoryUpdateResult",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "StatusCode",
          fieldType: "StatusCode"
        },
        {
          name: "OperationResults",
          fieldType: "StatusCode",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var HistoryUpdateResult = class _HistoryUpdateResult extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaHistoryUpdateResult;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.statusCode = node_opcua_status_code_1.StatusCodes.Good;
          this.operationResults = [];
          this.diagnosticInfos = [];
          return;
        }
        const schema = _HistoryUpdateResult.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.statusCode = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.statusCode);
        this.operationResults = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.operationResults);
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_status_code_1.encodeStatusCode)(this.statusCode, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.operationResults, stream, node_opcua_status_code_1.encodeStatusCode);
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.statusCode = (0, node_opcua_status_code_1.decodeStatusCode)(stream, this.statusCode);
        this.operationResults = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_status_code_1.decodeStatusCode);
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaHistoryUpdateResult;
      }
    };
    exports2.HistoryUpdateResult = HistoryUpdateResult;
    HistoryUpdateResult.possibleFields = [
      "statusCode",
      "operationResults",
      "diagnosticInfos"
    ];
    HistoryUpdateResult.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(695, 0);
    HistoryUpdateResult.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(697, 0);
    HistoryUpdateResult.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(696, 0);
    HistoryUpdateResult.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15286, 0);
    HistoryUpdateResult.schema.dataTypeNodeId = HistoryUpdateResult.dataTypeNodeId;
    HistoryUpdateResult.schema.encodingDefaultBinary = HistoryUpdateResult.encodingDefaultBinary;
    HistoryUpdateResult.schema.encodingDefaultXml = HistoryUpdateResult.encodingDefaultXml;
    HistoryUpdateResult.schema.encodingDefaultJson = HistoryUpdateResult.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(HistoryUpdateResult.dataTypeNodeId, "HistoryUpdateResult", HistoryUpdateResult);
    var schemaHistoryUpdateResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "HistoryUpdateResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "Results",
          fieldType: "HistoryUpdateResult",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var HistoryUpdateResponse = class _HistoryUpdateResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaHistoryUpdateResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.results = null;
          this.diagnosticInfos = [];
          return;
        }
        const schema = _HistoryUpdateResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.results = [];
        if (options.results) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.results));
          this.results = options.results.map((e) => new HistoryUpdateResult(e));
        }
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.results, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.results = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new HistoryUpdateResult(null);
          obj.decode(stream1);
          return obj;
        });
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaHistoryUpdateResponse;
      }
    };
    exports2.HistoryUpdateResponse = HistoryUpdateResponse;
    HistoryUpdateResponse.possibleFields = [
      "responseHeader",
      "results",
      "diagnosticInfos"
    ];
    HistoryUpdateResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(701, 0);
    HistoryUpdateResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(703, 0);
    HistoryUpdateResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(702, 0);
    HistoryUpdateResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15288, 0);
    HistoryUpdateResponse.schema.dataTypeNodeId = HistoryUpdateResponse.dataTypeNodeId;
    HistoryUpdateResponse.schema.encodingDefaultBinary = HistoryUpdateResponse.encodingDefaultBinary;
    HistoryUpdateResponse.schema.encodingDefaultXml = HistoryUpdateResponse.encodingDefaultXml;
    HistoryUpdateResponse.schema.encodingDefaultJson = HistoryUpdateResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(HistoryUpdateResponse.dataTypeNodeId, "HistoryUpdateResponse", HistoryUpdateResponse);
    var IdentityCriteriaType;
    (function(IdentityCriteriaType2) {
      IdentityCriteriaType2[IdentityCriteriaType2["UserName"] = 1] = "UserName";
      IdentityCriteriaType2[IdentityCriteriaType2["Thumbprint"] = 2] = "Thumbprint";
      IdentityCriteriaType2[IdentityCriteriaType2["Role"] = 3] = "Role";
      IdentityCriteriaType2[IdentityCriteriaType2["GroupId"] = 4] = "GroupId";
      IdentityCriteriaType2[IdentityCriteriaType2["Anonymous"] = 5] = "Anonymous";
      IdentityCriteriaType2[IdentityCriteriaType2["AuthenticatedUser"] = 6] = "AuthenticatedUser";
      IdentityCriteriaType2[IdentityCriteriaType2["Application"] = 7] = "Application";
      IdentityCriteriaType2[IdentityCriteriaType2["X509Subject"] = 8] = "X509Subject";
      IdentityCriteriaType2[IdentityCriteriaType2["Invalid"] = 4294967295] = "Invalid";
    })(IdentityCriteriaType || (exports2.IdentityCriteriaType = IdentityCriteriaType = {}));
    var schemaIdentityCriteriaType = {
      enumValues: IdentityCriteriaType,
      flaggable: false,
      minValue: NaN,
      maxValue: NaN,
      name: "IdentityCriteriaType"
    };
    function decodeIdentityCriteriaType(stream, _value) {
      let value = stream.readUInt32();
      value = value < schemaIdentityCriteriaType.minValue || value > schemaIdentityCriteriaType.maxValue ? IdentityCriteriaType.Invalid : value;
      return value;
    }
    function encodeIdentityCriteriaType(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationIdentityCriteriaType = (0, node_opcua_factory_1.registerEnumeration)(schemaIdentityCriteriaType);
    (0, node_opcua_assert_1.assert)(exports2._enumerationIdentityCriteriaType.isFlaggable === false);
    var schemaIdentityMappingRuleType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "IdentityMappingRuleType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "CriteriaType",
          fieldType: "IdentityCriteriaType"
        },
        {
          name: "Criteria",
          fieldType: "String"
        }
      ]
    });
    var IdentityMappingRuleType = class _IdentityMappingRuleType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaIdentityMappingRuleType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.criteriaType = 0;
          this.criteria = null;
          return;
        }
        const schema = _IdentityMappingRuleType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.criteriaType = this.setCriteriaType((0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.criteriaType));
        this.criteria = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.criteria);
      }
      encode(stream) {
        super.encode(stream);
        encodeIdentityCriteriaType(this.criteriaType, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.criteria, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.criteriaType = decodeIdentityCriteriaType(stream, this.criteriaType);
        this.criteria = (0, node_opcua_basic_types_1.decodeString)(stream, this.criteria);
      }
      // Define Enumeration setters
      setCriteriaType(value) {
        const coercedValue = exports2._enumerationIdentityCriteriaType.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to IdentityCriteriaType :" + value);
        }
        this.criteriaType = coercedValue.value;
        return this.criteriaType;
      }
      get schema() {
        return schemaIdentityMappingRuleType;
      }
    };
    exports2.IdentityMappingRuleType = IdentityMappingRuleType;
    IdentityMappingRuleType.possibleFields = [
      "criteriaType",
      "criteria"
    ];
    IdentityMappingRuleType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15634, 0);
    IdentityMappingRuleType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15736, 0);
    IdentityMappingRuleType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15728, 0);
    IdentityMappingRuleType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15042, 0);
    IdentityMappingRuleType.schema.dataTypeNodeId = IdentityMappingRuleType.dataTypeNodeId;
    IdentityMappingRuleType.schema.encodingDefaultBinary = IdentityMappingRuleType.encodingDefaultBinary;
    IdentityMappingRuleType.schema.encodingDefaultXml = IdentityMappingRuleType.encodingDefaultXml;
    IdentityMappingRuleType.schema.encodingDefaultJson = IdentityMappingRuleType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(IdentityMappingRuleType.dataTypeNodeId, "IdentityMappingRuleType", IdentityMappingRuleType);
    var schemaInstanceNode = (0, node_opcua_factory_1.buildStructuredType)({
      name: "InstanceNode",
      baseType: "Node",
      fields: []
    });
    var InstanceNode = class _InstanceNode extends Node {
      static get schema() {
        return schemaInstanceNode;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _InstanceNode.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaInstanceNode;
      }
    };
    exports2.InstanceNode = InstanceNode;
    InstanceNode.possibleFields = [
      "nodeId",
      "nodeClass",
      "browseName",
      "displayName",
      "description",
      "writeMask",
      "userWriteMask",
      "rolePermissions",
      "userRolePermissions",
      "accessRestrictions",
      "references"
    ];
    InstanceNode.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(11879, 0);
    InstanceNode.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(11889, 0);
    InstanceNode.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(11887, 0);
    InstanceNode.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15069, 0);
    InstanceNode.schema.dataTypeNodeId = InstanceNode.dataTypeNodeId;
    InstanceNode.schema.encodingDefaultBinary = InstanceNode.encodingDefaultBinary;
    InstanceNode.schema.encodingDefaultXml = InstanceNode.encodingDefaultXml;
    InstanceNode.schema.encodingDefaultJson = InstanceNode.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(InstanceNode.dataTypeNodeId, "InstanceNode", InstanceNode);
    var schemaIssuedIdentityToken = (0, node_opcua_factory_1.buildStructuredType)({
      name: "IssuedIdentityToken",
      baseType: "UserIdentityToken",
      fields: [
        {
          name: "TokenData",
          fieldType: "ByteString"
        },
        {
          name: "EncryptionAlgorithm",
          fieldType: "String"
        }
      ]
    });
    var IssuedIdentityToken = class _IssuedIdentityToken extends UserIdentityToken {
      static get schema() {
        return schemaIssuedIdentityToken;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.tokenData = Buffer.alloc(0);
          this.encryptionAlgorithm = null;
          return;
        }
        const schema = _IssuedIdentityToken.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.tokenData = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.tokenData);
        this.encryptionAlgorithm = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.encryptionAlgorithm);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.tokenData, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.encryptionAlgorithm, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.tokenData = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.tokenData);
        this.encryptionAlgorithm = (0, node_opcua_basic_types_1.decodeString)(stream, this.encryptionAlgorithm);
      }
      get schema() {
        return schemaIssuedIdentityToken;
      }
    };
    exports2.IssuedIdentityToken = IssuedIdentityToken;
    IssuedIdentityToken.possibleFields = [
      "policyId",
      "tokenData",
      "encryptionAlgorithm"
    ];
    IssuedIdentityToken.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(938, 0);
    IssuedIdentityToken.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(940, 0);
    IssuedIdentityToken.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(939, 0);
    IssuedIdentityToken.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15144, 0);
    IssuedIdentityToken.schema.dataTypeNodeId = IssuedIdentityToken.dataTypeNodeId;
    IssuedIdentityToken.schema.encodingDefaultBinary = IssuedIdentityToken.encodingDefaultBinary;
    IssuedIdentityToken.schema.encodingDefaultXml = IssuedIdentityToken.encodingDefaultXml;
    IssuedIdentityToken.schema.encodingDefaultJson = IssuedIdentityToken.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(IssuedIdentityToken.dataTypeNodeId, "IssuedIdentityToken", IssuedIdentityToken);
    var JsonNetworkMessageContentMask;
    (function(JsonNetworkMessageContentMask2) {
      JsonNetworkMessageContentMask2[JsonNetworkMessageContentMask2["None"] = 0] = "None";
      JsonNetworkMessageContentMask2[JsonNetworkMessageContentMask2["NetworkMessageHeader"] = 1] = "NetworkMessageHeader";
      JsonNetworkMessageContentMask2[JsonNetworkMessageContentMask2["DataSetMessageHeader"] = 2] = "DataSetMessageHeader";
      JsonNetworkMessageContentMask2[JsonNetworkMessageContentMask2["SingleDataSetMessage"] = 4] = "SingleDataSetMessage";
      JsonNetworkMessageContentMask2[JsonNetworkMessageContentMask2["PublisherId"] = 8] = "PublisherId";
      JsonNetworkMessageContentMask2[JsonNetworkMessageContentMask2["DataSetClassId"] = 16] = "DataSetClassId";
      JsonNetworkMessageContentMask2[JsonNetworkMessageContentMask2["ReplyTo"] = 32] = "ReplyTo";
    })(JsonNetworkMessageContentMask || (exports2.JsonNetworkMessageContentMask = JsonNetworkMessageContentMask = {}));
    var schemaJsonNetworkMessageContentMask = {
      enumValues: JsonNetworkMessageContentMask,
      flaggable: true,
      name: "JsonNetworkMessageContentMask"
    };
    function decodeJsonNetworkMessageContentMask(stream, _value) {
      return stream.readUInt32();
    }
    function encodeJsonNetworkMessageContentMask(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationJsonNetworkMessageContentMask = (0, node_opcua_factory_1.registerEnumeration)(schemaJsonNetworkMessageContentMask);
    (0, node_opcua_assert_1.assert)(exports2._enumerationJsonNetworkMessageContentMask.isFlaggable === true);
    var JsonDataSetMessageContentMask;
    (function(JsonDataSetMessageContentMask2) {
      JsonDataSetMessageContentMask2[JsonDataSetMessageContentMask2["None"] = 0] = "None";
      JsonDataSetMessageContentMask2[JsonDataSetMessageContentMask2["DataSetWriterId"] = 1] = "DataSetWriterId";
      JsonDataSetMessageContentMask2[JsonDataSetMessageContentMask2["MetaDataVersion"] = 2] = "MetaDataVersion";
      JsonDataSetMessageContentMask2[JsonDataSetMessageContentMask2["SequenceNumber"] = 4] = "SequenceNumber";
      JsonDataSetMessageContentMask2[JsonDataSetMessageContentMask2["Timestamp"] = 8] = "Timestamp";
      JsonDataSetMessageContentMask2[JsonDataSetMessageContentMask2["Status"] = 16] = "Status";
      JsonDataSetMessageContentMask2[JsonDataSetMessageContentMask2["MessageType"] = 32] = "MessageType";
      JsonDataSetMessageContentMask2[JsonDataSetMessageContentMask2["DataSetWriterName"] = 64] = "DataSetWriterName";
      JsonDataSetMessageContentMask2[JsonDataSetMessageContentMask2["ReversibleFieldEncoding"] = 128] = "ReversibleFieldEncoding";
    })(JsonDataSetMessageContentMask || (exports2.JsonDataSetMessageContentMask = JsonDataSetMessageContentMask = {}));
    var schemaJsonDataSetMessageContentMask = {
      enumValues: JsonDataSetMessageContentMask,
      flaggable: true,
      name: "JsonDataSetMessageContentMask"
    };
    function decodeJsonDataSetMessageContentMask(stream, _value) {
      return stream.readUInt32();
    }
    function encodeJsonDataSetMessageContentMask(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationJsonDataSetMessageContentMask = (0, node_opcua_factory_1.registerEnumeration)(schemaJsonDataSetMessageContentMask);
    (0, node_opcua_assert_1.assert)(exports2._enumerationJsonDataSetMessageContentMask.isFlaggable === true);
    var schemaJsonDataSetReaderMessageDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "JsonDataSetReaderMessageDataType",
      baseType: "DataSetReaderMessageDataType",
      fields: [
        {
          name: "NetworkMessageContentMask",
          fieldType: "JsonNetworkMessageContentMask"
        },
        {
          name: "DataSetMessageContentMask",
          fieldType: "JsonDataSetMessageContentMask"
        }
      ]
    });
    var JsonDataSetReaderMessageDataType = class _JsonDataSetReaderMessageDataType extends DataSetReaderMessageDataType {
      static get schema() {
        return schemaJsonDataSetReaderMessageDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.networkMessageContentMask = 0;
          this.dataSetMessageContentMask = 0;
          return;
        }
        const schema = _JsonDataSetReaderMessageDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.networkMessageContentMask = this.setNetworkMessageContentMask((0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.networkMessageContentMask));
        this.dataSetMessageContentMask = this.setDataSetMessageContentMask((0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.dataSetMessageContentMask));
      }
      encode(stream) {
        super.encode(stream);
        encodeJsonNetworkMessageContentMask(this.networkMessageContentMask, stream);
        encodeJsonDataSetMessageContentMask(this.dataSetMessageContentMask, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.networkMessageContentMask = decodeJsonNetworkMessageContentMask(stream, this.networkMessageContentMask);
        this.dataSetMessageContentMask = decodeJsonDataSetMessageContentMask(stream, this.dataSetMessageContentMask);
      }
      // Define Enumeration setters
      setNetworkMessageContentMask(value) {
        const coercedValue = exports2._enumerationJsonNetworkMessageContentMask.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to JsonNetworkMessageContentMask :" + value);
        }
        this.networkMessageContentMask = coercedValue.value;
        return this.networkMessageContentMask;
      }
      setDataSetMessageContentMask(value) {
        const coercedValue = exports2._enumerationJsonDataSetMessageContentMask.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to JsonDataSetMessageContentMask :" + value);
        }
        this.dataSetMessageContentMask = coercedValue.value;
        return this.dataSetMessageContentMask;
      }
      get schema() {
        return schemaJsonDataSetReaderMessageDataType;
      }
    };
    exports2.JsonDataSetReaderMessageDataType = JsonDataSetReaderMessageDataType;
    JsonDataSetReaderMessageDataType.possibleFields = [
      "networkMessageContentMask",
      "dataSetMessageContentMask"
    ];
    JsonDataSetReaderMessageDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15665, 0);
    JsonDataSetReaderMessageDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15725, 0);
    JsonDataSetReaderMessageDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16019, 0);
    JsonDataSetReaderMessageDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16404, 0);
    JsonDataSetReaderMessageDataType.schema.dataTypeNodeId = JsonDataSetReaderMessageDataType.dataTypeNodeId;
    JsonDataSetReaderMessageDataType.schema.encodingDefaultBinary = JsonDataSetReaderMessageDataType.encodingDefaultBinary;
    JsonDataSetReaderMessageDataType.schema.encodingDefaultXml = JsonDataSetReaderMessageDataType.encodingDefaultXml;
    JsonDataSetReaderMessageDataType.schema.encodingDefaultJson = JsonDataSetReaderMessageDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(JsonDataSetReaderMessageDataType.dataTypeNodeId, "JsonDataSetReaderMessageDataType", JsonDataSetReaderMessageDataType);
    var schemaJsonDataSetWriterMessageDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "JsonDataSetWriterMessageDataType",
      baseType: "DataSetWriterMessageDataType",
      fields: [
        {
          name: "DataSetMessageContentMask",
          fieldType: "JsonDataSetMessageContentMask"
        }
      ]
    });
    var JsonDataSetWriterMessageDataType = class _JsonDataSetWriterMessageDataType extends DataSetWriterMessageDataType {
      static get schema() {
        return schemaJsonDataSetWriterMessageDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.dataSetMessageContentMask = 0;
          return;
        }
        const schema = _JsonDataSetWriterMessageDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.dataSetMessageContentMask = this.setDataSetMessageContentMask((0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.dataSetMessageContentMask));
      }
      encode(stream) {
        super.encode(stream);
        encodeJsonDataSetMessageContentMask(this.dataSetMessageContentMask, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.dataSetMessageContentMask = decodeJsonDataSetMessageContentMask(stream, this.dataSetMessageContentMask);
      }
      // Define Enumeration setters
      setDataSetMessageContentMask(value) {
        const coercedValue = exports2._enumerationJsonDataSetMessageContentMask.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to JsonDataSetMessageContentMask :" + value);
        }
        this.dataSetMessageContentMask = coercedValue.value;
        return this.dataSetMessageContentMask;
      }
      get schema() {
        return schemaJsonDataSetWriterMessageDataType;
      }
    };
    exports2.JsonDataSetWriterMessageDataType = JsonDataSetWriterMessageDataType;
    JsonDataSetWriterMessageDataType.possibleFields = [
      "dataSetMessageContentMask"
    ];
    JsonDataSetWriterMessageDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15664, 0);
    JsonDataSetWriterMessageDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15724, 0);
    JsonDataSetWriterMessageDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16018, 0);
    JsonDataSetWriterMessageDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16394, 0);
    JsonDataSetWriterMessageDataType.schema.dataTypeNodeId = JsonDataSetWriterMessageDataType.dataTypeNodeId;
    JsonDataSetWriterMessageDataType.schema.encodingDefaultBinary = JsonDataSetWriterMessageDataType.encodingDefaultBinary;
    JsonDataSetWriterMessageDataType.schema.encodingDefaultXml = JsonDataSetWriterMessageDataType.encodingDefaultXml;
    JsonDataSetWriterMessageDataType.schema.encodingDefaultJson = JsonDataSetWriterMessageDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(JsonDataSetWriterMessageDataType.dataTypeNodeId, "JsonDataSetWriterMessageDataType", JsonDataSetWriterMessageDataType);
    var schemaWriterGroupMessageDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "WriterGroupMessageDataType",
      baseType: "ExtensionObject",
      fields: []
    });
    var WriterGroupMessageDataType = class _WriterGroupMessageDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaWriterGroupMessageDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _WriterGroupMessageDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaWriterGroupMessageDataType;
      }
    };
    exports2.WriterGroupMessageDataType = WriterGroupMessageDataType;
    WriterGroupMessageDataType.possibleFields = [];
    WriterGroupMessageDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15616, 0);
    WriterGroupMessageDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15693, 0);
    WriterGroupMessageDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15991, 0);
    WriterGroupMessageDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16280, 0);
    WriterGroupMessageDataType.schema.dataTypeNodeId = WriterGroupMessageDataType.dataTypeNodeId;
    WriterGroupMessageDataType.schema.encodingDefaultBinary = WriterGroupMessageDataType.encodingDefaultBinary;
    WriterGroupMessageDataType.schema.encodingDefaultXml = WriterGroupMessageDataType.encodingDefaultXml;
    WriterGroupMessageDataType.schema.encodingDefaultJson = WriterGroupMessageDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(WriterGroupMessageDataType.dataTypeNodeId, "WriterGroupMessageDataType", WriterGroupMessageDataType);
    var schemaJsonWriterGroupMessageDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "JsonWriterGroupMessageDataType",
      baseType: "WriterGroupMessageDataType",
      fields: [
        {
          name: "NetworkMessageContentMask",
          fieldType: "JsonNetworkMessageContentMask"
        }
      ]
    });
    var JsonWriterGroupMessageDataType = class _JsonWriterGroupMessageDataType extends WriterGroupMessageDataType {
      static get schema() {
        return schemaJsonWriterGroupMessageDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.networkMessageContentMask = 0;
          return;
        }
        const schema = _JsonWriterGroupMessageDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.networkMessageContentMask = this.setNetworkMessageContentMask((0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.networkMessageContentMask));
      }
      encode(stream) {
        super.encode(stream);
        encodeJsonNetworkMessageContentMask(this.networkMessageContentMask, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.networkMessageContentMask = decodeJsonNetworkMessageContentMask(stream, this.networkMessageContentMask);
      }
      // Define Enumeration setters
      setNetworkMessageContentMask(value) {
        const coercedValue = exports2._enumerationJsonNetworkMessageContentMask.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to JsonNetworkMessageContentMask :" + value);
        }
        this.networkMessageContentMask = coercedValue.value;
        return this.networkMessageContentMask;
      }
      get schema() {
        return schemaJsonWriterGroupMessageDataType;
      }
    };
    exports2.JsonWriterGroupMessageDataType = JsonWriterGroupMessageDataType;
    JsonWriterGroupMessageDataType.possibleFields = [
      "networkMessageContentMask"
    ];
    JsonWriterGroupMessageDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15657, 0);
    JsonWriterGroupMessageDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15719, 0);
    JsonWriterGroupMessageDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16017, 0);
    JsonWriterGroupMessageDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16393, 0);
    JsonWriterGroupMessageDataType.schema.dataTypeNodeId = JsonWriterGroupMessageDataType.dataTypeNodeId;
    JsonWriterGroupMessageDataType.schema.encodingDefaultBinary = JsonWriterGroupMessageDataType.encodingDefaultBinary;
    JsonWriterGroupMessageDataType.schema.encodingDefaultXml = JsonWriterGroupMessageDataType.encodingDefaultXml;
    JsonWriterGroupMessageDataType.schema.encodingDefaultJson = JsonWriterGroupMessageDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(JsonWriterGroupMessageDataType.dataTypeNodeId, "JsonWriterGroupMessageDataType", JsonWriterGroupMessageDataType);
    var schemaLiteralOperand = (0, node_opcua_factory_1.buildStructuredType)({
      name: "LiteralOperand",
      baseType: "FilterOperand",
      fields: [
        {
          name: "Value",
          fieldType: "Variant"
        }
      ]
    });
    var LiteralOperand = class _LiteralOperand extends FilterOperand {
      static get schema() {
        return schemaLiteralOperand;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.value = new node_opcua_variant_1.Variant(null);
          return;
        }
        const schema = _LiteralOperand.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.value = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.value);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_variant_1.encodeVariant)(this.value, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.value = (0, node_opcua_variant_1.decodeVariant)(stream, this.value);
      }
      get schema() {
        return schemaLiteralOperand;
      }
    };
    exports2.LiteralOperand = LiteralOperand;
    LiteralOperand.possibleFields = [
      "value"
    ];
    LiteralOperand.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(595, 0);
    LiteralOperand.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(597, 0);
    LiteralOperand.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(596, 0);
    LiteralOperand.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15208, 0);
    LiteralOperand.schema.dataTypeNodeId = LiteralOperand.dataTypeNodeId;
    LiteralOperand.schema.encodingDefaultBinary = LiteralOperand.encodingDefaultBinary;
    LiteralOperand.schema.encodingDefaultXml = LiteralOperand.encodingDefaultXml;
    LiteralOperand.schema.encodingDefaultJson = LiteralOperand.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(LiteralOperand.dataTypeNodeId, "LiteralOperand", LiteralOperand);
    var schemaMdnsDiscoveryConfiguration = (0, node_opcua_factory_1.buildStructuredType)({
      name: "MdnsDiscoveryConfiguration",
      baseType: "DiscoveryConfiguration",
      fields: [
        {
          name: "MdnsServerName",
          fieldType: "String"
        },
        {
          name: "ServerCapabilities",
          fieldType: "String",
          isArray: true
        }
      ]
    });
    var MdnsDiscoveryConfiguration = class _MdnsDiscoveryConfiguration extends DiscoveryConfiguration {
      static get schema() {
        return schemaMdnsDiscoveryConfiguration;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.mdnsServerName = null;
          this.serverCapabilities = [];
          return;
        }
        const schema = _MdnsDiscoveryConfiguration.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.mdnsServerName = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.mdnsServerName);
        this.serverCapabilities = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.serverCapabilities);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.mdnsServerName, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.serverCapabilities, stream, node_opcua_basic_types_1.encodeString);
      }
      decode(stream) {
        super.decode(stream);
        this.mdnsServerName = (0, node_opcua_basic_types_1.decodeString)(stream, this.mdnsServerName);
        this.serverCapabilities = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
      }
      get schema() {
        return schemaMdnsDiscoveryConfiguration;
      }
    };
    exports2.MdnsDiscoveryConfiguration = MdnsDiscoveryConfiguration;
    MdnsDiscoveryConfiguration.possibleFields = [
      "mdnsServerName",
      "serverCapabilities"
    ];
    MdnsDiscoveryConfiguration.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12891, 0);
    MdnsDiscoveryConfiguration.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12901, 0);
    MdnsDiscoveryConfiguration.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12893, 0);
    MdnsDiscoveryConfiguration.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15106, 0);
    MdnsDiscoveryConfiguration.schema.dataTypeNodeId = MdnsDiscoveryConfiguration.dataTypeNodeId;
    MdnsDiscoveryConfiguration.schema.encodingDefaultBinary = MdnsDiscoveryConfiguration.encodingDefaultBinary;
    MdnsDiscoveryConfiguration.schema.encodingDefaultXml = MdnsDiscoveryConfiguration.encodingDefaultXml;
    MdnsDiscoveryConfiguration.schema.encodingDefaultJson = MdnsDiscoveryConfiguration.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(MdnsDiscoveryConfiguration.dataTypeNodeId, "MdnsDiscoveryConfiguration", MdnsDiscoveryConfiguration);
    var schemaMethodAttributes = (0, node_opcua_factory_1.buildStructuredType)({
      name: "MethodAttributes",
      baseType: "NodeAttributes",
      fields: [
        {
          name: "Executable",
          fieldType: "Boolean"
        },
        {
          name: "UserExecutable",
          fieldType: "Boolean"
        }
      ]
    });
    var MethodAttributes = class _MethodAttributes extends NodeAttributes {
      static get schema() {
        return schemaMethodAttributes;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.executable = false;
          this.userExecutable = false;
          return;
        }
        const schema = _MethodAttributes.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.executable = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.executable);
        this.userExecutable = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.userExecutable);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.executable, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.userExecutable, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.executable = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.executable);
        this.userExecutable = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.userExecutable);
      }
      get schema() {
        return schemaMethodAttributes;
      }
    };
    exports2.MethodAttributes = MethodAttributes;
    MethodAttributes.possibleFields = [
      "specifiedAttributes",
      "displayName",
      "description",
      "writeMask",
      "userWriteMask",
      "executable",
      "userExecutable"
    ];
    MethodAttributes.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(358, 0);
    MethodAttributes.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(360, 0);
    MethodAttributes.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(359, 0);
    MethodAttributes.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15157, 0);
    MethodAttributes.schema.dataTypeNodeId = MethodAttributes.dataTypeNodeId;
    MethodAttributes.schema.encodingDefaultBinary = MethodAttributes.encodingDefaultBinary;
    MethodAttributes.schema.encodingDefaultXml = MethodAttributes.encodingDefaultXml;
    MethodAttributes.schema.encodingDefaultJson = MethodAttributes.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(MethodAttributes.dataTypeNodeId, "MethodAttributes", MethodAttributes);
    var schemaMethodNode = (0, node_opcua_factory_1.buildStructuredType)({
      name: "MethodNode",
      baseType: "InstanceNode",
      fields: [
        {
          name: "RolePermissions",
          fieldType: "RolePermissionType",
          isArray: true
        },
        {
          name: "UserRolePermissions",
          fieldType: "RolePermissionType",
          isArray: true
        },
        {
          name: "References",
          fieldType: "ReferenceNode",
          isArray: true
        },
        {
          name: "Executable",
          fieldType: "Boolean"
        },
        {
          name: "UserExecutable",
          fieldType: "Boolean"
        }
      ]
    });
    var MethodNode = class _MethodNode extends InstanceNode {
      static get schema() {
        return schemaMethodNode;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.rolePermissions = null;
          this.userRolePermissions = null;
          this.references = null;
          this.executable = false;
          this.userExecutable = false;
          return;
        }
        const schema = _MethodNode.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.rolePermissions = [];
        if (options.rolePermissions) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.rolePermissions));
          this.rolePermissions = options.rolePermissions.map((e) => new RolePermissionType(e));
        }
        this.userRolePermissions = [];
        if (options.userRolePermissions) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.userRolePermissions));
          this.userRolePermissions = options.userRolePermissions.map((e) => new RolePermissionType(e));
        }
        this.references = [];
        if (options.references) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.references));
          this.references = options.references.map((e) => new ReferenceNode(e));
        }
        this.executable = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.executable);
        this.userExecutable = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.userExecutable);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.rolePermissions, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.userRolePermissions, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.references, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeBoolean)(this.executable, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.userExecutable, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.rolePermissions = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new RolePermissionType(null);
          obj.decode(stream1);
          return obj;
        });
        this.userRolePermissions = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new RolePermissionType(null);
          obj.decode(stream1);
          return obj;
        });
        this.references = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new ReferenceNode(null);
          obj.decode(stream1);
          return obj;
        });
        this.executable = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.executable);
        this.userExecutable = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.userExecutable);
      }
      get schema() {
        return schemaMethodNode;
      }
    };
    exports2.MethodNode = MethodNode;
    MethodNode.possibleFields = [
      "nodeId",
      "nodeClass",
      "browseName",
      "displayName",
      "description",
      "writeMask",
      "userWriteMask",
      "rolePermissions",
      "userRolePermissions",
      "accessRestrictions",
      "references",
      "rolePermissions",
      "userRolePermissions",
      "references",
      "executable",
      "userExecutable"
    ];
    MethodNode.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(276, 0);
    MethodNode.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(278, 0);
    MethodNode.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(277, 0);
    MethodNode.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15077, 0);
    MethodNode.schema.dataTypeNodeId = MethodNode.dataTypeNodeId;
    MethodNode.schema.encodingDefaultBinary = MethodNode.encodingDefaultBinary;
    MethodNode.schema.encodingDefaultXml = MethodNode.encodingDefaultXml;
    MethodNode.schema.encodingDefaultJson = MethodNode.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(MethodNode.dataTypeNodeId, "MethodNode", MethodNode);
    var schemaModelChangeStructureDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ModelChangeStructureDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Affected",
          fieldType: "NodeId"
        },
        {
          name: "AffectedType",
          fieldType: "NodeId"
        },
        {
          name: "Verb",
          fieldType: "Byte"
        }
      ]
    });
    var ModelChangeStructureDataType = class _ModelChangeStructureDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaModelChangeStructureDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.affected = new node_opcua_nodeid_1.NodeId(null);
          this.affectedType = new node_opcua_nodeid_1.NodeId(null);
          this.verb = 0;
          return;
        }
        const schema = _ModelChangeStructureDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.affected = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.affected);
        this.affectedType = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.affectedType);
        this.verb = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.verb);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.affected, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.affectedType, stream);
        (0, node_opcua_basic_types_1.encodeByte)(this.verb, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.affected = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.affected);
        this.affectedType = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.affectedType);
        this.verb = (0, node_opcua_basic_types_1.decodeByte)(stream, this.verb);
      }
      get schema() {
        return schemaModelChangeStructureDataType;
      }
    };
    exports2.ModelChangeStructureDataType = ModelChangeStructureDataType;
    ModelChangeStructureDataType.possibleFields = [
      "affected",
      "affectedType",
      "verb"
    ];
    ModelChangeStructureDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(877, 0);
    ModelChangeStructureDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(879, 0);
    ModelChangeStructureDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(878, 0);
    ModelChangeStructureDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15373, 0);
    ModelChangeStructureDataType.schema.dataTypeNodeId = ModelChangeStructureDataType.dataTypeNodeId;
    ModelChangeStructureDataType.schema.encodingDefaultBinary = ModelChangeStructureDataType.encodingDefaultBinary;
    ModelChangeStructureDataType.schema.encodingDefaultXml = ModelChangeStructureDataType.encodingDefaultXml;
    ModelChangeStructureDataType.schema.encodingDefaultJson = ModelChangeStructureDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ModelChangeStructureDataType.dataTypeNodeId, "ModelChangeStructureDataType", ModelChangeStructureDataType);
    var schemaMonitoredItemModifyRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "MonitoredItemModifyRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "MonitoredItemId",
          fieldType: "UInt32"
        },
        {
          name: "RequestedParameters",
          fieldType: "MonitoringParameters"
        }
      ]
    });
    var MonitoredItemModifyRequest = class _MonitoredItemModifyRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaMonitoredItemModifyRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.monitoredItemId = 0;
          this.requestedParameters = new MonitoringParameters(null);
          return;
        }
        const schema = _MonitoredItemModifyRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.monitoredItemId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.monitoredItemId);
        this.requestedParameters = new MonitoringParameters(options.requestedParameters);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.monitoredItemId, stream);
        this.requestedParameters.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.monitoredItemId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.monitoredItemId);
        this.requestedParameters.decode(stream);
      }
      get schema() {
        return schemaMonitoredItemModifyRequest;
      }
    };
    exports2.MonitoredItemModifyRequest = MonitoredItemModifyRequest;
    MonitoredItemModifyRequest.possibleFields = [
      "monitoredItemId",
      "requestedParameters"
    ];
    MonitoredItemModifyRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(755, 0);
    MonitoredItemModifyRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(757, 0);
    MonitoredItemModifyRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(756, 0);
    MonitoredItemModifyRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15325, 0);
    MonitoredItemModifyRequest.schema.dataTypeNodeId = MonitoredItemModifyRequest.dataTypeNodeId;
    MonitoredItemModifyRequest.schema.encodingDefaultBinary = MonitoredItemModifyRequest.encodingDefaultBinary;
    MonitoredItemModifyRequest.schema.encodingDefaultXml = MonitoredItemModifyRequest.encodingDefaultXml;
    MonitoredItemModifyRequest.schema.encodingDefaultJson = MonitoredItemModifyRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(MonitoredItemModifyRequest.dataTypeNodeId, "MonitoredItemModifyRequest", MonitoredItemModifyRequest);
    var schemaModifyMonitoredItemsRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ModifyMonitoredItemsRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "SubscriptionId",
          fieldType: "UInt32"
        },
        {
          name: "TimestampsToReturn",
          fieldType: "TimestampsToReturn"
        },
        {
          name: "ItemsToModify",
          fieldType: "MonitoredItemModifyRequest",
          isArray: true
        }
      ]
    });
    var ModifyMonitoredItemsRequest = class _ModifyMonitoredItemsRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaModifyMonitoredItemsRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.subscriptionId = 0;
          this.timestampsToReturn = 0;
          this.itemsToModify = null;
          return;
        }
        const schema = _ModifyMonitoredItemsRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.subscriptionId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.subscriptionId);
        this.timestampsToReturn = this.setTimestampsToReturn((0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.timestampsToReturn));
        this.itemsToModify = [];
        if (options.itemsToModify) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.itemsToModify));
          this.itemsToModify = options.itemsToModify.map((e) => new MonitoredItemModifyRequest(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.subscriptionId, stream);
        (0, node_opcua_data_value_1.encodeTimestampsToReturn)(this.timestampsToReturn, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.itemsToModify, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.subscriptionId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.subscriptionId);
        this.timestampsToReturn = (0, node_opcua_data_value_1.decodeTimestampsToReturn)(stream, this.timestampsToReturn);
        this.itemsToModify = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new MonitoredItemModifyRequest(null);
          obj.decode(stream1);
          return obj;
        });
      }
      // Define Enumeration setters
      setTimestampsToReturn(value) {
        const coercedValue = node_opcua_data_value_1._enumerationTimestampsToReturn.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to TimestampsToReturn :" + value);
        }
        this.timestampsToReturn = coercedValue.value;
        return this.timestampsToReturn;
      }
      get schema() {
        return schemaModifyMonitoredItemsRequest;
      }
    };
    exports2.ModifyMonitoredItemsRequest = ModifyMonitoredItemsRequest;
    ModifyMonitoredItemsRequest.possibleFields = [
      "requestHeader",
      "subscriptionId",
      "timestampsToReturn",
      "itemsToModify"
    ];
    ModifyMonitoredItemsRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(761, 0);
    ModifyMonitoredItemsRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(763, 0);
    ModifyMonitoredItemsRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(762, 0);
    ModifyMonitoredItemsRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15327, 0);
    ModifyMonitoredItemsRequest.schema.dataTypeNodeId = ModifyMonitoredItemsRequest.dataTypeNodeId;
    ModifyMonitoredItemsRequest.schema.encodingDefaultBinary = ModifyMonitoredItemsRequest.encodingDefaultBinary;
    ModifyMonitoredItemsRequest.schema.encodingDefaultXml = ModifyMonitoredItemsRequest.encodingDefaultXml;
    ModifyMonitoredItemsRequest.schema.encodingDefaultJson = ModifyMonitoredItemsRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ModifyMonitoredItemsRequest.dataTypeNodeId, "ModifyMonitoredItemsRequest", ModifyMonitoredItemsRequest);
    var schemaMonitoredItemModifyResult = (0, node_opcua_factory_1.buildStructuredType)({
      name: "MonitoredItemModifyResult",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "StatusCode",
          fieldType: "StatusCode"
        },
        {
          name: "RevisedSamplingInterval",
          fieldType: "Double"
        },
        {
          name: "RevisedQueueSize",
          fieldType: "UInt32"
        },
        {
          name: "FilterResult",
          fieldType: "ExtensionObject"
        }
      ]
    });
    var MonitoredItemModifyResult = class _MonitoredItemModifyResult extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaMonitoredItemModifyResult;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.statusCode = node_opcua_status_code_1.StatusCodes.Good;
          this.revisedSamplingInterval = 0;
          this.revisedQueueSize = 0;
          this.filterResult = null;
          return;
        }
        const schema = _MonitoredItemModifyResult.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.statusCode = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.statusCode);
        this.revisedSamplingInterval = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.revisedSamplingInterval);
        this.revisedQueueSize = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.revisedQueueSize);
        this.filterResult = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.filterResult);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_status_code_1.encodeStatusCode)(this.statusCode, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.revisedSamplingInterval, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.revisedQueueSize, stream);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.filterResult, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.statusCode = (0, node_opcua_status_code_1.decodeStatusCode)(stream, this.statusCode);
        this.revisedSamplingInterval = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.revisedSamplingInterval);
        this.revisedQueueSize = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.revisedQueueSize);
        this.filterResult = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.filterResult);
      }
      get schema() {
        return schemaMonitoredItemModifyResult;
      }
    };
    exports2.MonitoredItemModifyResult = MonitoredItemModifyResult;
    MonitoredItemModifyResult.possibleFields = [
      "statusCode",
      "revisedSamplingInterval",
      "revisedQueueSize",
      "filterResult"
    ];
    MonitoredItemModifyResult.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(758, 0);
    MonitoredItemModifyResult.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(760, 0);
    MonitoredItemModifyResult.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(759, 0);
    MonitoredItemModifyResult.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15326, 0);
    MonitoredItemModifyResult.schema.dataTypeNodeId = MonitoredItemModifyResult.dataTypeNodeId;
    MonitoredItemModifyResult.schema.encodingDefaultBinary = MonitoredItemModifyResult.encodingDefaultBinary;
    MonitoredItemModifyResult.schema.encodingDefaultXml = MonitoredItemModifyResult.encodingDefaultXml;
    MonitoredItemModifyResult.schema.encodingDefaultJson = MonitoredItemModifyResult.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(MonitoredItemModifyResult.dataTypeNodeId, "MonitoredItemModifyResult", MonitoredItemModifyResult);
    var schemaModifyMonitoredItemsResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ModifyMonitoredItemsResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "Results",
          fieldType: "MonitoredItemModifyResult",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var ModifyMonitoredItemsResponse = class _ModifyMonitoredItemsResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaModifyMonitoredItemsResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.results = null;
          this.diagnosticInfos = [];
          return;
        }
        const schema = _ModifyMonitoredItemsResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.results = [];
        if (options.results) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.results));
          this.results = options.results.map((e) => new MonitoredItemModifyResult(e));
        }
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.results, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.results = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new MonitoredItemModifyResult(null);
          obj.decode(stream1);
          return obj;
        });
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaModifyMonitoredItemsResponse;
      }
    };
    exports2.ModifyMonitoredItemsResponse = ModifyMonitoredItemsResponse;
    ModifyMonitoredItemsResponse.possibleFields = [
      "responseHeader",
      "results",
      "diagnosticInfos"
    ];
    ModifyMonitoredItemsResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(764, 0);
    ModifyMonitoredItemsResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(766, 0);
    ModifyMonitoredItemsResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(765, 0);
    ModifyMonitoredItemsResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15328, 0);
    ModifyMonitoredItemsResponse.schema.dataTypeNodeId = ModifyMonitoredItemsResponse.dataTypeNodeId;
    ModifyMonitoredItemsResponse.schema.encodingDefaultBinary = ModifyMonitoredItemsResponse.encodingDefaultBinary;
    ModifyMonitoredItemsResponse.schema.encodingDefaultXml = ModifyMonitoredItemsResponse.encodingDefaultXml;
    ModifyMonitoredItemsResponse.schema.encodingDefaultJson = ModifyMonitoredItemsResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ModifyMonitoredItemsResponse.dataTypeNodeId, "ModifyMonitoredItemsResponse", ModifyMonitoredItemsResponse);
    var schemaModifySubscriptionRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ModifySubscriptionRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "SubscriptionId",
          fieldType: "UInt32"
        },
        {
          name: "RequestedPublishingInterval",
          fieldType: "Double"
        },
        {
          name: "RequestedLifetimeCount",
          fieldType: "UInt32"
        },
        {
          name: "RequestedMaxKeepAliveCount",
          fieldType: "UInt32"
        },
        {
          name: "MaxNotificationsPerPublish",
          fieldType: "UInt32"
        },
        {
          name: "Priority",
          fieldType: "Byte"
        }
      ]
    });
    var ModifySubscriptionRequest = class _ModifySubscriptionRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaModifySubscriptionRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.subscriptionId = 0;
          this.requestedPublishingInterval = 0;
          this.requestedLifetimeCount = 0;
          this.requestedMaxKeepAliveCount = 0;
          this.maxNotificationsPerPublish = 0;
          this.priority = 0;
          return;
        }
        const schema = _ModifySubscriptionRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.subscriptionId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.subscriptionId);
        this.requestedPublishingInterval = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.requestedPublishingInterval);
        this.requestedLifetimeCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.requestedLifetimeCount);
        this.requestedMaxKeepAliveCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.requestedMaxKeepAliveCount);
        this.maxNotificationsPerPublish = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.maxNotificationsPerPublish);
        this.priority = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.priority);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.subscriptionId, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.requestedPublishingInterval, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.requestedLifetimeCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.requestedMaxKeepAliveCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.maxNotificationsPerPublish, stream);
        (0, node_opcua_basic_types_1.encodeByte)(this.priority, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.subscriptionId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.subscriptionId);
        this.requestedPublishingInterval = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.requestedPublishingInterval);
        this.requestedLifetimeCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.requestedLifetimeCount);
        this.requestedMaxKeepAliveCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.requestedMaxKeepAliveCount);
        this.maxNotificationsPerPublish = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.maxNotificationsPerPublish);
        this.priority = (0, node_opcua_basic_types_1.decodeByte)(stream, this.priority);
      }
      get schema() {
        return schemaModifySubscriptionRequest;
      }
    };
    exports2.ModifySubscriptionRequest = ModifySubscriptionRequest;
    ModifySubscriptionRequest.possibleFields = [
      "requestHeader",
      "subscriptionId",
      "requestedPublishingInterval",
      "requestedLifetimeCount",
      "requestedMaxKeepAliveCount",
      "maxNotificationsPerPublish",
      "priority"
    ];
    ModifySubscriptionRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(791, 0);
    ModifySubscriptionRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(793, 0);
    ModifySubscriptionRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(792, 0);
    ModifySubscriptionRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15339, 0);
    ModifySubscriptionRequest.schema.dataTypeNodeId = ModifySubscriptionRequest.dataTypeNodeId;
    ModifySubscriptionRequest.schema.encodingDefaultBinary = ModifySubscriptionRequest.encodingDefaultBinary;
    ModifySubscriptionRequest.schema.encodingDefaultXml = ModifySubscriptionRequest.encodingDefaultXml;
    ModifySubscriptionRequest.schema.encodingDefaultJson = ModifySubscriptionRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ModifySubscriptionRequest.dataTypeNodeId, "ModifySubscriptionRequest", ModifySubscriptionRequest);
    var schemaModifySubscriptionResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ModifySubscriptionResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "RevisedPublishingInterval",
          fieldType: "Double"
        },
        {
          name: "RevisedLifetimeCount",
          fieldType: "UInt32"
        },
        {
          name: "RevisedMaxKeepAliveCount",
          fieldType: "UInt32"
        }
      ]
    });
    var ModifySubscriptionResponse = class _ModifySubscriptionResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaModifySubscriptionResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.revisedPublishingInterval = 0;
          this.revisedLifetimeCount = 0;
          this.revisedMaxKeepAliveCount = 0;
          return;
        }
        const schema = _ModifySubscriptionResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.revisedPublishingInterval = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.revisedPublishingInterval);
        this.revisedLifetimeCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.revisedLifetimeCount);
        this.revisedMaxKeepAliveCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.revisedMaxKeepAliveCount);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.revisedPublishingInterval, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.revisedLifetimeCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.revisedMaxKeepAliveCount, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.revisedPublishingInterval = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.revisedPublishingInterval);
        this.revisedLifetimeCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.revisedLifetimeCount);
        this.revisedMaxKeepAliveCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.revisedMaxKeepAliveCount);
      }
      get schema() {
        return schemaModifySubscriptionResponse;
      }
    };
    exports2.ModifySubscriptionResponse = ModifySubscriptionResponse;
    ModifySubscriptionResponse.possibleFields = [
      "responseHeader",
      "revisedPublishingInterval",
      "revisedLifetimeCount",
      "revisedMaxKeepAliveCount"
    ];
    ModifySubscriptionResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(794, 0);
    ModifySubscriptionResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(796, 0);
    ModifySubscriptionResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(795, 0);
    ModifySubscriptionResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15340, 0);
    ModifySubscriptionResponse.schema.dataTypeNodeId = ModifySubscriptionResponse.dataTypeNodeId;
    ModifySubscriptionResponse.schema.encodingDefaultBinary = ModifySubscriptionResponse.encodingDefaultBinary;
    ModifySubscriptionResponse.schema.encodingDefaultXml = ModifySubscriptionResponse.encodingDefaultXml;
    ModifySubscriptionResponse.schema.encodingDefaultJson = ModifySubscriptionResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ModifySubscriptionResponse.dataTypeNodeId, "ModifySubscriptionResponse", ModifySubscriptionResponse);
    var schemaNetworkAddressDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "NetworkAddressDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "NetworkInterface",
          fieldType: "String"
        }
      ]
    });
    var NetworkAddressDataType = class _NetworkAddressDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaNetworkAddressDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.networkInterface = null;
          return;
        }
        const schema = _NetworkAddressDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.networkInterface = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.networkInterface);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.networkInterface, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.networkInterface = (0, node_opcua_basic_types_1.decodeString)(stream, this.networkInterface);
      }
      get schema() {
        return schemaNetworkAddressDataType;
      }
    };
    exports2.NetworkAddressDataType = NetworkAddressDataType;
    NetworkAddressDataType.possibleFields = [
      "networkInterface"
    ];
    NetworkAddressDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15502, 0);
    NetworkAddressDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(21151, 0);
    NetworkAddressDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(21175, 0);
    NetworkAddressDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(21199, 0);
    NetworkAddressDataType.schema.dataTypeNodeId = NetworkAddressDataType.dataTypeNodeId;
    NetworkAddressDataType.schema.encodingDefaultBinary = NetworkAddressDataType.encodingDefaultBinary;
    NetworkAddressDataType.schema.encodingDefaultXml = NetworkAddressDataType.encodingDefaultXml;
    NetworkAddressDataType.schema.encodingDefaultJson = NetworkAddressDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(NetworkAddressDataType.dataTypeNodeId, "NetworkAddressDataType", NetworkAddressDataType);
    var schemaNetworkAddressUrlDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "NetworkAddressUrlDataType",
      baseType: "NetworkAddressDataType",
      fields: [
        {
          name: "Url",
          fieldType: "String"
        }
      ]
    });
    var NetworkAddressUrlDataType = class _NetworkAddressUrlDataType extends NetworkAddressDataType {
      static get schema() {
        return schemaNetworkAddressUrlDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.url = null;
          return;
        }
        const schema = _NetworkAddressUrlDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.url = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.url);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.url, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.url = (0, node_opcua_basic_types_1.decodeString)(stream, this.url);
      }
      get schema() {
        return schemaNetworkAddressUrlDataType;
      }
    };
    exports2.NetworkAddressUrlDataType = NetworkAddressUrlDataType;
    NetworkAddressUrlDataType.possibleFields = [
      "networkInterface",
      "url"
    ];
    NetworkAddressUrlDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15510, 0);
    NetworkAddressUrlDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(21152, 0);
    NetworkAddressUrlDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(21176, 0);
    NetworkAddressUrlDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(21200, 0);
    NetworkAddressUrlDataType.schema.dataTypeNodeId = NetworkAddressUrlDataType.dataTypeNodeId;
    NetworkAddressUrlDataType.schema.encodingDefaultBinary = NetworkAddressUrlDataType.encodingDefaultBinary;
    NetworkAddressUrlDataType.schema.encodingDefaultXml = NetworkAddressUrlDataType.encodingDefaultXml;
    NetworkAddressUrlDataType.schema.encodingDefaultJson = NetworkAddressUrlDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(NetworkAddressUrlDataType.dataTypeNodeId, "NetworkAddressUrlDataType", NetworkAddressUrlDataType);
    var schemaNetworkGroupDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "NetworkGroupDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ServerUri",
          fieldType: "String"
        },
        {
          name: "NetworkPaths",
          fieldType: "EndpointUrlListDataType",
          isArray: true
        }
      ]
    });
    var NetworkGroupDataType = class _NetworkGroupDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaNetworkGroupDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.serverUri = null;
          this.networkPaths = null;
          return;
        }
        const schema = _NetworkGroupDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.serverUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.serverUri);
        this.networkPaths = [];
        if (options.networkPaths) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.networkPaths));
          this.networkPaths = options.networkPaths.map((e) => new EndpointUrlListDataType(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.serverUri, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.networkPaths, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.serverUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.serverUri);
        this.networkPaths = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new EndpointUrlListDataType(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaNetworkGroupDataType;
      }
    };
    exports2.NetworkGroupDataType = NetworkGroupDataType;
    NetworkGroupDataType.possibleFields = [
      "serverUri",
      "networkPaths"
    ];
    NetworkGroupDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(11944, 0);
    NetworkGroupDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(11958, 0);
    NetworkGroupDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(11950, 0);
    NetworkGroupDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15364, 0);
    NetworkGroupDataType.schema.dataTypeNodeId = NetworkGroupDataType.dataTypeNodeId;
    NetworkGroupDataType.schema.encodingDefaultBinary = NetworkGroupDataType.encodingDefaultBinary;
    NetworkGroupDataType.schema.encodingDefaultXml = NetworkGroupDataType.encodingDefaultXml;
    NetworkGroupDataType.schema.encodingDefaultJson = NetworkGroupDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(NetworkGroupDataType.dataTypeNodeId, "NetworkGroupDataType", NetworkGroupDataType);
    var schemaNodeReference = (0, node_opcua_factory_1.buildStructuredType)({
      name: "NodeReference",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "NodeId",
          fieldType: "NodeId"
        },
        {
          name: "ReferenceTypeId",
          fieldType: "NodeId"
        },
        {
          name: "IsForward",
          fieldType: "Boolean"
        },
        {
          name: "ReferencedNodeIds",
          fieldType: "NodeId",
          isArray: true
        }
      ]
    });
    var NodeReference = class _NodeReference extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaNodeReference;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.nodeId = new node_opcua_nodeid_1.NodeId(null);
          this.referenceTypeId = new node_opcua_nodeid_1.NodeId(null);
          this.isForward = false;
          this.referencedNodeIds = [];
          return;
        }
        const schema = _NodeReference.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.nodeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.nodeId);
        this.referenceTypeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.referenceTypeId);
        this.isForward = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.isForward);
        this.referencedNodeIds = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[3], options?.referencedNodeIds);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.nodeId, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.referenceTypeId, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.isForward, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.referencedNodeIds, stream, node_opcua_basic_types_1.encodeNodeId);
      }
      decode(stream) {
        super.decode(stream);
        this.nodeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.nodeId);
        this.referenceTypeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.referenceTypeId);
        this.isForward = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.isForward);
        this.referencedNodeIds = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeNodeId);
      }
      get schema() {
        return schemaNodeReference;
      }
    };
    exports2.NodeReference = NodeReference;
    NodeReference.possibleFields = [
      "nodeId",
      "referenceTypeId",
      "isForward",
      "referencedNodeIds"
    ];
    NodeReference.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(580, 0);
    NodeReference.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(582, 0);
    NodeReference.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(581, 0);
    NodeReference.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15203, 0);
    NodeReference.schema.dataTypeNodeId = NodeReference.dataTypeNodeId;
    NodeReference.schema.encodingDefaultBinary = NodeReference.encodingDefaultBinary;
    NodeReference.schema.encodingDefaultXml = NodeReference.encodingDefaultXml;
    NodeReference.schema.encodingDefaultJson = NodeReference.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(NodeReference.dataTypeNodeId, "NodeReference", NodeReference);
    var schemaQueryDataDescription = (0, node_opcua_factory_1.buildStructuredType)({
      name: "QueryDataDescription",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RelativePath",
          fieldType: "RelativePath"
        },
        {
          name: "AttributeId",
          fieldType: "UInt32"
        },
        {
          name: "IndexRange",
          fieldType: "NumericRange"
        }
      ]
    });
    var QueryDataDescription = class _QueryDataDescription extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaQueryDataDescription;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.relativePath = new RelativePath(null);
          this.attributeId = 0;
          this.indexRange = new node_opcua_numeric_range_1.NumericRange(null);
          return;
        }
        const schema = _QueryDataDescription.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.relativePath = new RelativePath(options.relativePath);
        this.attributeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.attributeId);
        this.indexRange = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.indexRange);
      }
      encode(stream) {
        super.encode(stream);
        this.relativePath.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.attributeId, stream);
        (0, node_opcua_numeric_range_1.encodeNumericRange)(this.indexRange, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.relativePath.decode(stream);
        this.attributeId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.attributeId);
        this.indexRange = (0, node_opcua_numeric_range_1.decodeNumericRange)(stream, this.indexRange);
      }
      get schema() {
        return schemaQueryDataDescription;
      }
    };
    exports2.QueryDataDescription = QueryDataDescription;
    QueryDataDescription.possibleFields = [
      "relativePath",
      "attributeId",
      "indexRange"
    ];
    QueryDataDescription.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(570, 0);
    QueryDataDescription.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(572, 0);
    QueryDataDescription.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(571, 0);
    QueryDataDescription.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15200, 0);
    QueryDataDescription.schema.dataTypeNodeId = QueryDataDescription.dataTypeNodeId;
    QueryDataDescription.schema.encodingDefaultBinary = QueryDataDescription.encodingDefaultBinary;
    QueryDataDescription.schema.encodingDefaultXml = QueryDataDescription.encodingDefaultXml;
    QueryDataDescription.schema.encodingDefaultJson = QueryDataDescription.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(QueryDataDescription.dataTypeNodeId, "QueryDataDescription", QueryDataDescription);
    var schemaNodeTypeDescription = (0, node_opcua_factory_1.buildStructuredType)({
      name: "NodeTypeDescription",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "TypeDefinitionNode",
          fieldType: "ExpandedNodeId"
        },
        {
          name: "IncludeSubTypes",
          fieldType: "Boolean"
        },
        {
          name: "DataToReturn",
          fieldType: "QueryDataDescription",
          isArray: true
        }
      ]
    });
    var NodeTypeDescription = class _NodeTypeDescription extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaNodeTypeDescription;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.typeDefinitionNode = new node_opcua_nodeid_1.ExpandedNodeId(null);
          this.includeSubTypes = false;
          this.dataToReturn = null;
          return;
        }
        const schema = _NodeTypeDescription.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.typeDefinitionNode = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.typeDefinitionNode);
        this.includeSubTypes = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.includeSubTypes);
        this.dataToReturn = [];
        if (options.dataToReturn) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.dataToReturn));
          this.dataToReturn = options.dataToReturn.map((e) => new QueryDataDescription(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeExpandedNodeId)(this.typeDefinitionNode, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.includeSubTypes, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.dataToReturn, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.typeDefinitionNode = (0, node_opcua_basic_types_1.decodeExpandedNodeId)(stream, this.typeDefinitionNode);
        this.includeSubTypes = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.includeSubTypes);
        this.dataToReturn = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new QueryDataDescription(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaNodeTypeDescription;
      }
    };
    exports2.NodeTypeDescription = NodeTypeDescription;
    NodeTypeDescription.possibleFields = [
      "typeDefinitionNode",
      "includeSubTypes",
      "dataToReturn"
    ];
    NodeTypeDescription.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(573, 0);
    NodeTypeDescription.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(575, 0);
    NodeTypeDescription.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(574, 0);
    NodeTypeDescription.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15201, 0);
    NodeTypeDescription.schema.dataTypeNodeId = NodeTypeDescription.dataTypeNodeId;
    NodeTypeDescription.schema.encodingDefaultBinary = NodeTypeDescription.encodingDefaultBinary;
    NodeTypeDescription.schema.encodingDefaultXml = NodeTypeDescription.encodingDefaultXml;
    NodeTypeDescription.schema.encodingDefaultJson = NodeTypeDescription.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(NodeTypeDescription.dataTypeNodeId, "NodeTypeDescription", NodeTypeDescription);
    var schemaNotificationMessage = (0, node_opcua_factory_1.buildStructuredType)({
      name: "NotificationMessage",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "SequenceNumber",
          fieldType: "UInt32"
        },
        {
          name: "PublishTime",
          fieldType: "DateTime"
        },
        {
          name: "NotificationData",
          fieldType: "ExtensionObject",
          isArray: true
        }
      ]
    });
    var NotificationMessage = class _NotificationMessage extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaNotificationMessage;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.sequenceNumber = 0;
          this.publishTime = /* @__PURE__ */ new Date();
          this.notificationData = [];
          return;
        }
        const schema = _NotificationMessage.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.sequenceNumber = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.sequenceNumber);
        this.publishTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.publishTime);
        this.notificationData = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.notificationData);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.sequenceNumber, stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.publishTime, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.notificationData, stream, node_opcua_extension_object_1.encodeExtensionObject);
      }
      decode(stream) {
        super.decode(stream);
        this.sequenceNumber = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.sequenceNumber);
        this.publishTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.publishTime);
        this.notificationData = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_extension_object_1.decodeExtensionObject);
      }
      get schema() {
        return schemaNotificationMessage;
      }
    };
    exports2.NotificationMessage = NotificationMessage;
    NotificationMessage.possibleFields = [
      "sequenceNumber",
      "publishTime",
      "notificationData"
    ];
    NotificationMessage.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(803, 0);
    NotificationMessage.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(805, 0);
    NotificationMessage.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(804, 0);
    NotificationMessage.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15343, 0);
    NotificationMessage.schema.dataTypeNodeId = NotificationMessage.dataTypeNodeId;
    NotificationMessage.schema.encodingDefaultBinary = NotificationMessage.encodingDefaultBinary;
    NotificationMessage.schema.encodingDefaultXml = NotificationMessage.encodingDefaultXml;
    NotificationMessage.schema.encodingDefaultJson = NotificationMessage.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(NotificationMessage.dataTypeNodeId, "NotificationMessage", NotificationMessage);
    var schemaObjectAttributes = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ObjectAttributes",
      baseType: "NodeAttributes",
      fields: [
        {
          name: "EventNotifier",
          fieldType: "Byte"
        }
      ]
    });
    var ObjectAttributes = class _ObjectAttributes extends NodeAttributes {
      static get schema() {
        return schemaObjectAttributes;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.eventNotifier = 0;
          return;
        }
        const schema = _ObjectAttributes.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.eventNotifier = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.eventNotifier);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeByte)(this.eventNotifier, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.eventNotifier = (0, node_opcua_basic_types_1.decodeByte)(stream, this.eventNotifier);
      }
      get schema() {
        return schemaObjectAttributes;
      }
    };
    exports2.ObjectAttributes = ObjectAttributes;
    ObjectAttributes.possibleFields = [
      "specifiedAttributes",
      "displayName",
      "description",
      "writeMask",
      "userWriteMask",
      "eventNotifier"
    ];
    ObjectAttributes.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(352, 0);
    ObjectAttributes.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(354, 0);
    ObjectAttributes.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(353, 0);
    ObjectAttributes.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15152, 0);
    ObjectAttributes.schema.dataTypeNodeId = ObjectAttributes.dataTypeNodeId;
    ObjectAttributes.schema.encodingDefaultBinary = ObjectAttributes.encodingDefaultBinary;
    ObjectAttributes.schema.encodingDefaultXml = ObjectAttributes.encodingDefaultXml;
    ObjectAttributes.schema.encodingDefaultJson = ObjectAttributes.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ObjectAttributes.dataTypeNodeId, "ObjectAttributes", ObjectAttributes);
    var schemaObjectNode = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ObjectNode",
      baseType: "InstanceNode",
      fields: [
        {
          name: "RolePermissions",
          fieldType: "RolePermissionType",
          isArray: true
        },
        {
          name: "UserRolePermissions",
          fieldType: "RolePermissionType",
          isArray: true
        },
        {
          name: "References",
          fieldType: "ReferenceNode",
          isArray: true
        },
        {
          name: "EventNotifier",
          fieldType: "Byte"
        }
      ]
    });
    var ObjectNode = class _ObjectNode extends InstanceNode {
      static get schema() {
        return schemaObjectNode;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.rolePermissions = null;
          this.userRolePermissions = null;
          this.references = null;
          this.eventNotifier = 0;
          return;
        }
        const schema = _ObjectNode.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.rolePermissions = [];
        if (options.rolePermissions) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.rolePermissions));
          this.rolePermissions = options.rolePermissions.map((e) => new RolePermissionType(e));
        }
        this.userRolePermissions = [];
        if (options.userRolePermissions) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.userRolePermissions));
          this.userRolePermissions = options.userRolePermissions.map((e) => new RolePermissionType(e));
        }
        this.references = [];
        if (options.references) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.references));
          this.references = options.references.map((e) => new ReferenceNode(e));
        }
        this.eventNotifier = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.eventNotifier);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.rolePermissions, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.userRolePermissions, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.references, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeByte)(this.eventNotifier, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.rolePermissions = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new RolePermissionType(null);
          obj.decode(stream1);
          return obj;
        });
        this.userRolePermissions = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new RolePermissionType(null);
          obj.decode(stream1);
          return obj;
        });
        this.references = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new ReferenceNode(null);
          obj.decode(stream1);
          return obj;
        });
        this.eventNotifier = (0, node_opcua_basic_types_1.decodeByte)(stream, this.eventNotifier);
      }
      get schema() {
        return schemaObjectNode;
      }
    };
    exports2.ObjectNode = ObjectNode;
    ObjectNode.possibleFields = [
      "nodeId",
      "nodeClass",
      "browseName",
      "displayName",
      "description",
      "writeMask",
      "userWriteMask",
      "rolePermissions",
      "userRolePermissions",
      "accessRestrictions",
      "references",
      "rolePermissions",
      "userRolePermissions",
      "references",
      "eventNotifier"
    ];
    ObjectNode.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(261, 0);
    ObjectNode.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(263, 0);
    ObjectNode.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(262, 0);
    ObjectNode.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15071, 0);
    ObjectNode.schema.dataTypeNodeId = ObjectNode.dataTypeNodeId;
    ObjectNode.schema.encodingDefaultBinary = ObjectNode.encodingDefaultBinary;
    ObjectNode.schema.encodingDefaultXml = ObjectNode.encodingDefaultXml;
    ObjectNode.schema.encodingDefaultJson = ObjectNode.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ObjectNode.dataTypeNodeId, "ObjectNode", ObjectNode);
    var schemaObjectTypeAttributes = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ObjectTypeAttributes",
      baseType: "NodeAttributes",
      fields: [
        {
          name: "IsAbstract",
          fieldType: "Boolean"
        }
      ]
    });
    var ObjectTypeAttributes = class _ObjectTypeAttributes extends NodeAttributes {
      static get schema() {
        return schemaObjectTypeAttributes;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.isAbstract = false;
          return;
        }
        const schema = _ObjectTypeAttributes.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.isAbstract = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.isAbstract);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.isAbstract, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.isAbstract = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.isAbstract);
      }
      get schema() {
        return schemaObjectTypeAttributes;
      }
    };
    exports2.ObjectTypeAttributes = ObjectTypeAttributes;
    ObjectTypeAttributes.possibleFields = [
      "specifiedAttributes",
      "displayName",
      "description",
      "writeMask",
      "userWriteMask",
      "isAbstract"
    ];
    ObjectTypeAttributes.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(361, 0);
    ObjectTypeAttributes.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(363, 0);
    ObjectTypeAttributes.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(362, 0);
    ObjectTypeAttributes.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15158, 0);
    ObjectTypeAttributes.schema.dataTypeNodeId = ObjectTypeAttributes.dataTypeNodeId;
    ObjectTypeAttributes.schema.encodingDefaultBinary = ObjectTypeAttributes.encodingDefaultBinary;
    ObjectTypeAttributes.schema.encodingDefaultXml = ObjectTypeAttributes.encodingDefaultXml;
    ObjectTypeAttributes.schema.encodingDefaultJson = ObjectTypeAttributes.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ObjectTypeAttributes.dataTypeNodeId, "ObjectTypeAttributes", ObjectTypeAttributes);
    var schemaObjectTypeNode = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ObjectTypeNode",
      baseType: "TypeNode",
      fields: [
        {
          name: "RolePermissions",
          fieldType: "RolePermissionType",
          isArray: true
        },
        {
          name: "UserRolePermissions",
          fieldType: "RolePermissionType",
          isArray: true
        },
        {
          name: "References",
          fieldType: "ReferenceNode",
          isArray: true
        },
        {
          name: "IsAbstract",
          fieldType: "Boolean"
        }
      ]
    });
    var ObjectTypeNode = class _ObjectTypeNode extends TypeNode {
      static get schema() {
        return schemaObjectTypeNode;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.rolePermissions = null;
          this.userRolePermissions = null;
          this.references = null;
          this.isAbstract = false;
          return;
        }
        const schema = _ObjectTypeNode.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.rolePermissions = [];
        if (options.rolePermissions) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.rolePermissions));
          this.rolePermissions = options.rolePermissions.map((e) => new RolePermissionType(e));
        }
        this.userRolePermissions = [];
        if (options.userRolePermissions) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.userRolePermissions));
          this.userRolePermissions = options.userRolePermissions.map((e) => new RolePermissionType(e));
        }
        this.references = [];
        if (options.references) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.references));
          this.references = options.references.map((e) => new ReferenceNode(e));
        }
        this.isAbstract = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.isAbstract);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.rolePermissions, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.userRolePermissions, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.references, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeBoolean)(this.isAbstract, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.rolePermissions = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new RolePermissionType(null);
          obj.decode(stream1);
          return obj;
        });
        this.userRolePermissions = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new RolePermissionType(null);
          obj.decode(stream1);
          return obj;
        });
        this.references = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new ReferenceNode(null);
          obj.decode(stream1);
          return obj;
        });
        this.isAbstract = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.isAbstract);
      }
      get schema() {
        return schemaObjectTypeNode;
      }
    };
    exports2.ObjectTypeNode = ObjectTypeNode;
    ObjectTypeNode.possibleFields = [
      "nodeId",
      "nodeClass",
      "browseName",
      "displayName",
      "description",
      "writeMask",
      "userWriteMask",
      "rolePermissions",
      "userRolePermissions",
      "accessRestrictions",
      "references",
      "rolePermissions",
      "userRolePermissions",
      "references",
      "isAbstract"
    ];
    ObjectTypeNode.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(264, 0);
    ObjectTypeNode.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(266, 0);
    ObjectTypeNode.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(265, 0);
    ObjectTypeNode.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15073, 0);
    ObjectTypeNode.schema.dataTypeNodeId = ObjectTypeNode.dataTypeNodeId;
    ObjectTypeNode.schema.encodingDefaultBinary = ObjectTypeNode.encodingDefaultBinary;
    ObjectTypeNode.schema.encodingDefaultXml = ObjectTypeNode.encodingDefaultXml;
    ObjectTypeNode.schema.encodingDefaultJson = ObjectTypeNode.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ObjectTypeNode.dataTypeNodeId, "ObjectTypeNode", ObjectTypeNode);
    var SecurityTokenRequestType;
    (function(SecurityTokenRequestType2) {
      SecurityTokenRequestType2[SecurityTokenRequestType2["Issue"] = 0] = "Issue";
      SecurityTokenRequestType2[SecurityTokenRequestType2["Renew"] = 1] = "Renew";
      SecurityTokenRequestType2[SecurityTokenRequestType2["Invalid"] = 4294967295] = "Invalid";
    })(SecurityTokenRequestType || (exports2.SecurityTokenRequestType = SecurityTokenRequestType = {}));
    var schemaSecurityTokenRequestType = {
      enumValues: SecurityTokenRequestType,
      flaggable: false,
      minValue: 0,
      maxValue: 1,
      name: "SecurityTokenRequestType"
    };
    function decodeSecurityTokenRequestType(stream, _value) {
      let value = stream.readUInt32();
      value = value < schemaSecurityTokenRequestType.minValue || value > schemaSecurityTokenRequestType.maxValue ? SecurityTokenRequestType.Invalid : value;
      return value;
    }
    function encodeSecurityTokenRequestType(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationSecurityTokenRequestType = (0, node_opcua_factory_1.registerEnumeration)(schemaSecurityTokenRequestType);
    (0, node_opcua_assert_1.assert)(exports2._enumerationSecurityTokenRequestType.isFlaggable === false);
    var schemaOpenSecureChannelRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "OpenSecureChannelRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "ClientProtocolVersion",
          fieldType: "UInt32"
        },
        {
          name: "RequestType",
          fieldType: "SecurityTokenRequestType"
        },
        {
          name: "SecurityMode",
          fieldType: "MessageSecurityMode"
        },
        {
          name: "ClientNonce",
          fieldType: "ByteString"
        },
        {
          name: "RequestedLifetime",
          fieldType: "UInt32"
        }
      ]
    });
    var OpenSecureChannelRequest = class _OpenSecureChannelRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaOpenSecureChannelRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.clientProtocolVersion = 0;
          this.requestType = 0;
          this.securityMode = 0;
          this.clientNonce = Buffer.alloc(0);
          this.requestedLifetime = 0;
          return;
        }
        const schema = _OpenSecureChannelRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.clientProtocolVersion = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.clientProtocolVersion);
        this.requestType = this.setRequestType((0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.requestType));
        this.securityMode = this.setSecurityMode((0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.securityMode));
        this.clientNonce = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.clientNonce);
        this.requestedLifetime = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.requestedLifetime);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.clientProtocolVersion, stream);
        encodeSecurityTokenRequestType(this.requestType, stream);
        encodeMessageSecurityMode(this.securityMode, stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.clientNonce, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.requestedLifetime, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.clientProtocolVersion = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.clientProtocolVersion);
        this.requestType = decodeSecurityTokenRequestType(stream, this.requestType);
        this.securityMode = decodeMessageSecurityMode(stream, this.securityMode);
        this.clientNonce = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.clientNonce);
        this.requestedLifetime = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.requestedLifetime);
      }
      // Define Enumeration setters
      setRequestType(value) {
        const coercedValue = exports2._enumerationSecurityTokenRequestType.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to SecurityTokenRequestType :" + value);
        }
        this.requestType = coercedValue.value;
        return this.requestType;
      }
      setSecurityMode(value) {
        const coercedValue = exports2._enumerationMessageSecurityMode.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to MessageSecurityMode :" + value);
        }
        this.securityMode = coercedValue.value;
        return this.securityMode;
      }
      get schema() {
        return schemaOpenSecureChannelRequest;
      }
    };
    exports2.OpenSecureChannelRequest = OpenSecureChannelRequest;
    OpenSecureChannelRequest.possibleFields = [
      "requestHeader",
      "clientProtocolVersion",
      "requestType",
      "securityMode",
      "clientNonce",
      "requestedLifetime"
    ];
    OpenSecureChannelRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(444, 0);
    OpenSecureChannelRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(446, 0);
    OpenSecureChannelRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(445, 0);
    OpenSecureChannelRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15132, 0);
    OpenSecureChannelRequest.schema.dataTypeNodeId = OpenSecureChannelRequest.dataTypeNodeId;
    OpenSecureChannelRequest.schema.encodingDefaultBinary = OpenSecureChannelRequest.encodingDefaultBinary;
    OpenSecureChannelRequest.schema.encodingDefaultXml = OpenSecureChannelRequest.encodingDefaultXml;
    OpenSecureChannelRequest.schema.encodingDefaultJson = OpenSecureChannelRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(OpenSecureChannelRequest.dataTypeNodeId, "OpenSecureChannelRequest", OpenSecureChannelRequest);
    var schemaOpenSecureChannelResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "OpenSecureChannelResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "ServerProtocolVersion",
          fieldType: "UInt32"
        },
        {
          name: "SecurityToken",
          fieldType: "ChannelSecurityToken"
        },
        {
          name: "ServerNonce",
          fieldType: "ByteString"
        }
      ]
    });
    var OpenSecureChannelResponse = class _OpenSecureChannelResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaOpenSecureChannelResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.serverProtocolVersion = 0;
          this.securityToken = new ChannelSecurityToken(null);
          this.serverNonce = Buffer.alloc(0);
          return;
        }
        const schema = _OpenSecureChannelResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.serverProtocolVersion = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.serverProtocolVersion);
        this.securityToken = new ChannelSecurityToken(options.securityToken);
        this.serverNonce = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.serverNonce);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.serverProtocolVersion, stream);
        this.securityToken.encode(stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.serverNonce, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.serverProtocolVersion = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.serverProtocolVersion);
        this.securityToken.decode(stream);
        this.serverNonce = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.serverNonce);
      }
      get schema() {
        return schemaOpenSecureChannelResponse;
      }
    };
    exports2.OpenSecureChannelResponse = OpenSecureChannelResponse;
    OpenSecureChannelResponse.possibleFields = [
      "responseHeader",
      "serverProtocolVersion",
      "securityToken",
      "serverNonce"
    ];
    OpenSecureChannelResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(447, 0);
    OpenSecureChannelResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(449, 0);
    OpenSecureChannelResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(448, 0);
    OpenSecureChannelResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15133, 0);
    OpenSecureChannelResponse.schema.dataTypeNodeId = OpenSecureChannelResponse.dataTypeNodeId;
    OpenSecureChannelResponse.schema.encodingDefaultBinary = OpenSecureChannelResponse.encodingDefaultBinary;
    OpenSecureChannelResponse.schema.encodingDefaultXml = OpenSecureChannelResponse.encodingDefaultXml;
    OpenSecureChannelResponse.schema.encodingDefaultJson = OpenSecureChannelResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(OpenSecureChannelResponse.dataTypeNodeId, "OpenSecureChannelResponse", OpenSecureChannelResponse);
    var schemaOptionSet = (0, node_opcua_factory_1.buildStructuredType)({
      name: "OptionSet",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Value",
          fieldType: "ByteString"
        },
        {
          name: "ValidBits",
          fieldType: "ByteString"
        }
      ]
    });
    var OptionSet = class _OptionSet extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaOptionSet;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.value = Buffer.alloc(0);
          this.validBits = Buffer.alloc(0);
          return;
        }
        const schema = _OptionSet.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.value = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.value);
        this.validBits = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.validBits);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.value, stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.validBits, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.value = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.value);
        this.validBits = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.validBits);
      }
      get schema() {
        return schemaOptionSet;
      }
    };
    exports2.OptionSet = OptionSet;
    OptionSet.possibleFields = [
      "value",
      "validBits"
    ];
    OptionSet.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12755, 0);
    OptionSet.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12765, 0);
    OptionSet.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12757, 0);
    OptionSet.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15084, 0);
    OptionSet.schema.dataTypeNodeId = OptionSet.dataTypeNodeId;
    OptionSet.schema.encodingDefaultBinary = OptionSet.encodingDefaultBinary;
    OptionSet.schema.encodingDefaultXml = OptionSet.encodingDefaultXml;
    OptionSet.schema.encodingDefaultJson = OptionSet.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(OptionSet.dataTypeNodeId, "OptionSet", OptionSet);
    var schemaOrientation = (0, node_opcua_factory_1.buildStructuredType)({
      name: "Orientation",
      baseType: "ExtensionObject",
      fields: []
    });
    var Orientation = class _Orientation extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaOrientation;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _Orientation.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaOrientation;
      }
    };
    exports2.Orientation = Orientation;
    Orientation.possibleFields = [];
    Orientation.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18811, 0);
    Orientation.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18820, 0);
    Orientation.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18856, 0);
    Orientation.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(19069, 0);
    Orientation.schema.dataTypeNodeId = Orientation.dataTypeNodeId;
    Orientation.schema.encodingDefaultBinary = Orientation.encodingDefaultBinary;
    Orientation.schema.encodingDefaultXml = Orientation.encodingDefaultXml;
    Orientation.schema.encodingDefaultJson = Orientation.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(Orientation.dataTypeNodeId, "Orientation", Orientation);
    var schemaParsingResult = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ParsingResult",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "StatusCode",
          fieldType: "StatusCode"
        },
        {
          name: "DataStatusCodes",
          fieldType: "StatusCode",
          isArray: true
        },
        {
          name: "DataDiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var ParsingResult = class _ParsingResult extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaParsingResult;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.statusCode = node_opcua_status_code_1.StatusCodes.Good;
          this.dataStatusCodes = [];
          this.dataDiagnosticInfos = [];
          return;
        }
        const schema = _ParsingResult.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.statusCode = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.statusCode);
        this.dataStatusCodes = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.dataStatusCodes);
        this.dataDiagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.dataDiagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_status_code_1.encodeStatusCode)(this.statusCode, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.dataStatusCodes, stream, node_opcua_status_code_1.encodeStatusCode);
        (0, node_opcua_basic_types_1.encodeArray)(this.dataDiagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.statusCode = (0, node_opcua_status_code_1.decodeStatusCode)(stream, this.statusCode);
        this.dataStatusCodes = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_status_code_1.decodeStatusCode);
        this.dataDiagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaParsingResult;
      }
    };
    exports2.ParsingResult = ParsingResult;
    ParsingResult.possibleFields = [
      "statusCode",
      "dataStatusCodes",
      "dataDiagnosticInfos"
    ];
    ParsingResult.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(610, 0);
    ParsingResult.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(612, 0);
    ParsingResult.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(611, 0);
    ParsingResult.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15236, 0);
    ParsingResult.schema.dataTypeNodeId = ParsingResult.dataTypeNodeId;
    ParsingResult.schema.encodingDefaultBinary = ParsingResult.encodingDefaultBinary;
    ParsingResult.schema.encodingDefaultXml = ParsingResult.encodingDefaultXml;
    ParsingResult.schema.encodingDefaultJson = ParsingResult.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ParsingResult.dataTypeNodeId, "ParsingResult", ParsingResult);
    var schemaPortableNodeId = (0, node_opcua_factory_1.buildStructuredType)({
      name: "PortableNodeId",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "NamespaceUri",
          fieldType: "String"
        },
        {
          name: "Identifier",
          fieldType: "NodeId"
        }
      ]
    });
    var PortableNodeId = class _PortableNodeId extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaPortableNodeId;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.namespaceUri = null;
          this.identifier = new node_opcua_nodeid_1.NodeId(null);
          return;
        }
        const schema = _PortableNodeId.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.namespaceUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.namespaceUri);
        this.identifier = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.identifier);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.namespaceUri, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.identifier, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.namespaceUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.namespaceUri);
        this.identifier = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.identifier);
      }
      get schema() {
        return schemaPortableNodeId;
      }
    };
    exports2.PortableNodeId = PortableNodeId;
    PortableNodeId.possibleFields = [
      "namespaceUri",
      "identifier"
    ];
    PortableNodeId.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24106, 0);
    PortableNodeId.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24109, 0);
    PortableNodeId.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24121, 0);
    PortableNodeId.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24133, 0);
    PortableNodeId.schema.dataTypeNodeId = PortableNodeId.dataTypeNodeId;
    PortableNodeId.schema.encodingDefaultBinary = PortableNodeId.encodingDefaultBinary;
    PortableNodeId.schema.encodingDefaultXml = PortableNodeId.encodingDefaultXml;
    PortableNodeId.schema.encodingDefaultJson = PortableNodeId.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(PortableNodeId.dataTypeNodeId, "PortableNodeId", PortableNodeId);
    var schemaPortableQualifiedName = (0, node_opcua_factory_1.buildStructuredType)({
      name: "PortableQualifiedName",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "NamespaceUri",
          fieldType: "String"
        },
        {
          name: "Name",
          fieldType: "String"
        }
      ]
    });
    var PortableQualifiedName = class _PortableQualifiedName extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaPortableQualifiedName;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.namespaceUri = null;
          this.name = null;
          return;
        }
        const schema = _PortableQualifiedName.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.namespaceUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.namespaceUri);
        this.name = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.name);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.namespaceUri, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.name, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.namespaceUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.namespaceUri);
        this.name = (0, node_opcua_basic_types_1.decodeString)(stream, this.name);
      }
      get schema() {
        return schemaPortableQualifiedName;
      }
    };
    exports2.PortableQualifiedName = PortableQualifiedName;
    PortableQualifiedName.possibleFields = [
      "namespaceUri",
      "name"
    ];
    PortableQualifiedName.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24105, 0);
    PortableQualifiedName.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24108, 0);
    PortableQualifiedName.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24120, 0);
    PortableQualifiedName.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24132, 0);
    PortableQualifiedName.schema.dataTypeNodeId = PortableQualifiedName.dataTypeNodeId;
    PortableQualifiedName.schema.encodingDefaultBinary = PortableQualifiedName.encodingDefaultBinary;
    PortableQualifiedName.schema.encodingDefaultXml = PortableQualifiedName.encodingDefaultXml;
    PortableQualifiedName.schema.encodingDefaultJson = PortableQualifiedName.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(PortableQualifiedName.dataTypeNodeId, "PortableQualifiedName", PortableQualifiedName);
    var schemaPriorityMappingEntryType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "PriorityMappingEntryType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "MappingUri",
          fieldType: "String"
        },
        {
          name: "PriorityLabel",
          fieldType: "String"
        },
        {
          name: "PriorityValue_PCP",
          fieldType: "Byte"
        },
        {
          name: "PriorityValue_DSCP",
          fieldType: "UInt32"
        }
      ]
    });
    var PriorityMappingEntryType = class _PriorityMappingEntryType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaPriorityMappingEntryType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.mappingUri = null;
          this.priorityLabel = null;
          this.priorityValue_PCP = 0;
          this.priorityValue_DSCP = 0;
          return;
        }
        const schema = _PriorityMappingEntryType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.mappingUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.mappingUri);
        this.priorityLabel = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.priorityLabel);
        this.priorityValue_PCP = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.priorityValue_PCP);
        this.priorityValue_DSCP = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.priorityValue_DSCP);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.mappingUri, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.priorityLabel, stream);
        (0, node_opcua_basic_types_1.encodeByte)(this.priorityValue_PCP, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.priorityValue_DSCP, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.mappingUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.mappingUri);
        this.priorityLabel = (0, node_opcua_basic_types_1.decodeString)(stream, this.priorityLabel);
        this.priorityValue_PCP = (0, node_opcua_basic_types_1.decodeByte)(stream, this.priorityValue_PCP);
        this.priorityValue_DSCP = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.priorityValue_DSCP);
      }
      get schema() {
        return schemaPriorityMappingEntryType;
      }
    };
    exports2.PriorityMappingEntryType = PriorityMappingEntryType;
    PriorityMappingEntryType.possibleFields = [
      "mappingUri",
      "priorityLabel",
      "priorityValue_PCP",
      "priorityValue_DSCP"
    ];
    PriorityMappingEntryType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(25220, 0);
    PriorityMappingEntryType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(25239, 0);
    PriorityMappingEntryType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(25243, 0);
    PriorityMappingEntryType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(25247, 0);
    PriorityMappingEntryType.schema.dataTypeNodeId = PriorityMappingEntryType.dataTypeNodeId;
    PriorityMappingEntryType.schema.encodingDefaultBinary = PriorityMappingEntryType.encodingDefaultBinary;
    PriorityMappingEntryType.schema.encodingDefaultXml = PriorityMappingEntryType.encodingDefaultXml;
    PriorityMappingEntryType.schema.encodingDefaultJson = PriorityMappingEntryType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(PriorityMappingEntryType.dataTypeNodeId, "PriorityMappingEntryType", PriorityMappingEntryType);
    var schemaProgramDiagnostic2DataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ProgramDiagnostic2DataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "CreateSessionId",
          fieldType: "NodeId"
        },
        {
          name: "CreateClientName",
          fieldType: "String"
        },
        {
          name: "InvocationCreationTime",
          fieldType: "DateTime"
        },
        {
          name: "LastTransitionTime",
          fieldType: "DateTime"
        },
        {
          name: "LastMethodCall",
          fieldType: "String"
        },
        {
          name: "LastMethodSessionId",
          fieldType: "NodeId"
        },
        {
          name: "LastMethodInputArguments",
          fieldType: "Argument",
          isArray: true
        },
        {
          name: "LastMethodOutputArguments",
          fieldType: "Argument",
          isArray: true
        },
        {
          name: "LastMethodInputValues",
          fieldType: "Variant",
          isArray: true
        },
        {
          name: "LastMethodOutputValues",
          fieldType: "Variant",
          isArray: true
        },
        {
          name: "LastMethodCallTime",
          fieldType: "DateTime"
        },
        {
          name: "LastMethodReturnStatus",
          fieldType: "StatusCode"
        }
      ]
    });
    var ProgramDiagnostic2DataType = class _ProgramDiagnostic2DataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaProgramDiagnostic2DataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.createSessionId = new node_opcua_nodeid_1.NodeId(null);
          this.createClientName = null;
          this.invocationCreationTime = /* @__PURE__ */ new Date();
          this.lastTransitionTime = /* @__PURE__ */ new Date();
          this.lastMethodCall = null;
          this.lastMethodSessionId = new node_opcua_nodeid_1.NodeId(null);
          this.lastMethodInputArguments = null;
          this.lastMethodOutputArguments = null;
          this.lastMethodInputValues = [];
          this.lastMethodOutputValues = [];
          this.lastMethodCallTime = /* @__PURE__ */ new Date();
          this.lastMethodReturnStatus = node_opcua_status_code_1.StatusCodes.Good;
          return;
        }
        const schema = _ProgramDiagnostic2DataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.createSessionId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.createSessionId);
        this.createClientName = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.createClientName);
        this.invocationCreationTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.invocationCreationTime);
        this.lastTransitionTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.lastTransitionTime);
        this.lastMethodCall = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.lastMethodCall);
        this.lastMethodSessionId = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.lastMethodSessionId);
        this.lastMethodInputArguments = [];
        if (options.lastMethodInputArguments) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.lastMethodInputArguments));
          this.lastMethodInputArguments = options.lastMethodInputArguments.map((e) => new Argument(e));
        }
        this.lastMethodOutputArguments = [];
        if (options.lastMethodOutputArguments) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.lastMethodOutputArguments));
          this.lastMethodOutputArguments = options.lastMethodOutputArguments.map((e) => new Argument(e));
        }
        this.lastMethodInputValues = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[8], options?.lastMethodInputValues);
        this.lastMethodOutputValues = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[9], options?.lastMethodOutputValues);
        this.lastMethodCallTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[10], options?.lastMethodCallTime);
        this.lastMethodReturnStatus = (0, node_opcua_factory_1.initialize_field)(schema.fields[11], options?.lastMethodReturnStatus);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.createSessionId, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.createClientName, stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.invocationCreationTime, stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.lastTransitionTime, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.lastMethodCall, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.lastMethodSessionId, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.lastMethodInputArguments, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.lastMethodOutputArguments, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.lastMethodInputValues, stream, node_opcua_variant_1.encodeVariant);
        (0, node_opcua_basic_types_1.encodeArray)(this.lastMethodOutputValues, stream, node_opcua_variant_1.encodeVariant);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.lastMethodCallTime, stream);
        (0, node_opcua_status_code_1.encodeStatusCode)(this.lastMethodReturnStatus, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.createSessionId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.createSessionId);
        this.createClientName = (0, node_opcua_basic_types_1.decodeString)(stream, this.createClientName);
        this.invocationCreationTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.invocationCreationTime);
        this.lastTransitionTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.lastTransitionTime);
        this.lastMethodCall = (0, node_opcua_basic_types_1.decodeString)(stream, this.lastMethodCall);
        this.lastMethodSessionId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.lastMethodSessionId);
        this.lastMethodInputArguments = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new Argument(null);
          obj.decode(stream1);
          return obj;
        });
        this.lastMethodOutputArguments = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new Argument(null);
          obj.decode(stream1);
          return obj;
        });
        this.lastMethodInputValues = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_variant_1.decodeVariant);
        this.lastMethodOutputValues = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_variant_1.decodeVariant);
        this.lastMethodCallTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.lastMethodCallTime);
        this.lastMethodReturnStatus = (0, node_opcua_status_code_1.decodeStatusCode)(stream, this.lastMethodReturnStatus);
      }
      get schema() {
        return schemaProgramDiagnostic2DataType;
      }
    };
    exports2.ProgramDiagnostic2DataType = ProgramDiagnostic2DataType;
    ProgramDiagnostic2DataType.possibleFields = [
      "createSessionId",
      "createClientName",
      "invocationCreationTime",
      "lastTransitionTime",
      "lastMethodCall",
      "lastMethodSessionId",
      "lastMethodInputArguments",
      "lastMethodOutputArguments",
      "lastMethodInputValues",
      "lastMethodOutputValues",
      "lastMethodCallTime",
      "lastMethodReturnStatus"
    ];
    ProgramDiagnostic2DataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24033, 0);
    ProgramDiagnostic2DataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24034, 0);
    ProgramDiagnostic2DataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24038, 0);
    ProgramDiagnostic2DataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24042, 0);
    ProgramDiagnostic2DataType.schema.dataTypeNodeId = ProgramDiagnostic2DataType.dataTypeNodeId;
    ProgramDiagnostic2DataType.schema.encodingDefaultBinary = ProgramDiagnostic2DataType.encodingDefaultBinary;
    ProgramDiagnostic2DataType.schema.encodingDefaultXml = ProgramDiagnostic2DataType.encodingDefaultXml;
    ProgramDiagnostic2DataType.schema.encodingDefaultJson = ProgramDiagnostic2DataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ProgramDiagnostic2DataType.dataTypeNodeId, "ProgramDiagnostic2DataType", ProgramDiagnostic2DataType);
    var schemaStatusResult = (0, node_opcua_factory_1.buildStructuredType)({
      name: "StatusResult",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "StatusCode",
          fieldType: "StatusCode"
        },
        {
          name: "DiagnosticInfo",
          fieldType: "DiagnosticInfo"
        }
      ]
    });
    var StatusResult = class _StatusResult extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaStatusResult;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.statusCode = node_opcua_status_code_1.StatusCodes.Good;
          this.diagnosticInfo = null;
          return;
        }
        const schema = _StatusResult.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.statusCode = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.statusCode);
        this.diagnosticInfo = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.diagnosticInfo);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_status_code_1.encodeStatusCode)(this.statusCode, stream);
        (0, node_opcua_data_model_1.encodeDiagnosticInfo)(this.diagnosticInfo, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.statusCode = (0, node_opcua_status_code_1.decodeStatusCode)(stream, this.statusCode);
        this.diagnosticInfo = (0, node_opcua_data_model_1.decodeDiagnosticInfo)(stream, this.diagnosticInfo);
      }
      get schema() {
        return schemaStatusResult;
      }
    };
    exports2.StatusResult = StatusResult;
    StatusResult.possibleFields = [
      "statusCode",
      "diagnosticInfo"
    ];
    StatusResult.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(299, 0);
    StatusResult.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(301, 0);
    StatusResult.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(300, 0);
    StatusResult.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15371, 0);
    StatusResult.schema.dataTypeNodeId = StatusResult.dataTypeNodeId;
    StatusResult.schema.encodingDefaultBinary = StatusResult.encodingDefaultBinary;
    StatusResult.schema.encodingDefaultXml = StatusResult.encodingDefaultXml;
    StatusResult.schema.encodingDefaultJson = StatusResult.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(StatusResult.dataTypeNodeId, "StatusResult", StatusResult);
    var schemaProgramDiagnosticDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ProgramDiagnosticDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "CreateSessionId",
          fieldType: "NodeId"
        },
        {
          name: "CreateClientName",
          fieldType: "String"
        },
        {
          name: "InvocationCreationTime",
          fieldType: "DateTime"
        },
        {
          name: "LastTransitionTime",
          fieldType: "DateTime"
        },
        {
          name: "LastMethodCall",
          fieldType: "String"
        },
        {
          name: "LastMethodSessionId",
          fieldType: "NodeId"
        },
        {
          name: "LastMethodInputArguments",
          fieldType: "Argument",
          isArray: true
        },
        {
          name: "LastMethodOutputArguments",
          fieldType: "Argument",
          isArray: true
        },
        {
          name: "LastMethodCallTime",
          fieldType: "DateTime"
        },
        {
          name: "LastMethodReturnStatus",
          fieldType: "StatusResult"
        }
      ]
    });
    var ProgramDiagnosticDataType = class _ProgramDiagnosticDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaProgramDiagnosticDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.createSessionId = new node_opcua_nodeid_1.NodeId(null);
          this.createClientName = null;
          this.invocationCreationTime = /* @__PURE__ */ new Date();
          this.lastTransitionTime = /* @__PURE__ */ new Date();
          this.lastMethodCall = null;
          this.lastMethodSessionId = new node_opcua_nodeid_1.NodeId(null);
          this.lastMethodInputArguments = null;
          this.lastMethodOutputArguments = null;
          this.lastMethodCallTime = /* @__PURE__ */ new Date();
          this.lastMethodReturnStatus = new StatusResult(null);
          return;
        }
        const schema = _ProgramDiagnosticDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.createSessionId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.createSessionId);
        this.createClientName = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.createClientName);
        this.invocationCreationTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.invocationCreationTime);
        this.lastTransitionTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.lastTransitionTime);
        this.lastMethodCall = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.lastMethodCall);
        this.lastMethodSessionId = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.lastMethodSessionId);
        this.lastMethodInputArguments = [];
        if (options.lastMethodInputArguments) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.lastMethodInputArguments));
          this.lastMethodInputArguments = options.lastMethodInputArguments.map((e) => new Argument(e));
        }
        this.lastMethodOutputArguments = [];
        if (options.lastMethodOutputArguments) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.lastMethodOutputArguments));
          this.lastMethodOutputArguments = options.lastMethodOutputArguments.map((e) => new Argument(e));
        }
        this.lastMethodCallTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[8], options?.lastMethodCallTime);
        this.lastMethodReturnStatus = new StatusResult(options.lastMethodReturnStatus);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.createSessionId, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.createClientName, stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.invocationCreationTime, stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.lastTransitionTime, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.lastMethodCall, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.lastMethodSessionId, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.lastMethodInputArguments, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.lastMethodOutputArguments, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeDateTime)(this.lastMethodCallTime, stream);
        this.lastMethodReturnStatus.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.createSessionId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.createSessionId);
        this.createClientName = (0, node_opcua_basic_types_1.decodeString)(stream, this.createClientName);
        this.invocationCreationTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.invocationCreationTime);
        this.lastTransitionTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.lastTransitionTime);
        this.lastMethodCall = (0, node_opcua_basic_types_1.decodeString)(stream, this.lastMethodCall);
        this.lastMethodSessionId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.lastMethodSessionId);
        this.lastMethodInputArguments = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new Argument(null);
          obj.decode(stream1);
          return obj;
        });
        this.lastMethodOutputArguments = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new Argument(null);
          obj.decode(stream1);
          return obj;
        });
        this.lastMethodCallTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.lastMethodCallTime);
        this.lastMethodReturnStatus.decode(stream);
      }
      get schema() {
        return schemaProgramDiagnosticDataType;
      }
    };
    exports2.ProgramDiagnosticDataType = ProgramDiagnosticDataType;
    ProgramDiagnosticDataType.possibleFields = [
      "createSessionId",
      "createClientName",
      "invocationCreationTime",
      "lastTransitionTime",
      "lastMethodCall",
      "lastMethodSessionId",
      "lastMethodInputArguments",
      "lastMethodOutputArguments",
      "lastMethodCallTime",
      "lastMethodReturnStatus"
    ];
    ProgramDiagnosticDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(894, 0);
    ProgramDiagnosticDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(896, 0);
    ProgramDiagnosticDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(895, 0);
    ProgramDiagnosticDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15381, 0);
    ProgramDiagnosticDataType.schema.dataTypeNodeId = ProgramDiagnosticDataType.dataTypeNodeId;
    ProgramDiagnosticDataType.schema.encodingDefaultBinary = ProgramDiagnosticDataType.encodingDefaultBinary;
    ProgramDiagnosticDataType.schema.encodingDefaultXml = ProgramDiagnosticDataType.encodingDefaultXml;
    ProgramDiagnosticDataType.schema.encodingDefaultJson = ProgramDiagnosticDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ProgramDiagnosticDataType.dataTypeNodeId, "ProgramDiagnosticDataType", ProgramDiagnosticDataType);
    var schemaPublishedDataSetDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "PublishedDataSetDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Name",
          fieldType: "String"
        },
        {
          name: "DataSetFolder",
          fieldType: "String",
          isArray: true
        },
        {
          name: "DataSetMetaData",
          fieldType: "DataSetMetaDataType"
        },
        {
          name: "ExtensionFields",
          fieldType: "KeyValuePair",
          isArray: true
        },
        {
          name: "DataSetSource",
          fieldType: "ExtensionObject"
        }
      ]
    });
    var PublishedDataSetDataType = class _PublishedDataSetDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaPublishedDataSetDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.name = null;
          this.dataSetFolder = [];
          this.dataSetMetaData = new DataSetMetaDataType(null);
          this.extensionFields = null;
          this.dataSetSource = null;
          return;
        }
        const schema = _PublishedDataSetDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.name = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.name);
        this.dataSetFolder = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.dataSetFolder);
        this.dataSetMetaData = new DataSetMetaDataType(options.dataSetMetaData);
        this.extensionFields = [];
        if (options.extensionFields) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.extensionFields));
          this.extensionFields = options.extensionFields.map((e) => new KeyValuePair(e));
        }
        this.dataSetSource = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.dataSetSource);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.name, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.dataSetFolder, stream, node_opcua_basic_types_1.encodeString);
        this.dataSetMetaData.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.extensionFields, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.dataSetSource, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.name = (0, node_opcua_basic_types_1.decodeString)(stream, this.name);
        this.dataSetFolder = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
        this.dataSetMetaData.decode(stream);
        this.extensionFields = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new KeyValuePair(null);
          obj.decode(stream1);
          return obj;
        });
        this.dataSetSource = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.dataSetSource);
      }
      get schema() {
        return schemaPublishedDataSetDataType;
      }
    };
    exports2.PublishedDataSetDataType = PublishedDataSetDataType;
    PublishedDataSetDataType.possibleFields = [
      "name",
      "dataSetFolder",
      "dataSetMetaData",
      "extensionFields",
      "dataSetSource"
    ];
    PublishedDataSetDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15578, 0);
    PublishedDataSetDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15677, 0);
    PublishedDataSetDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15951, 0);
    PublishedDataSetDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16152, 0);
    PublishedDataSetDataType.schema.dataTypeNodeId = PublishedDataSetDataType.dataTypeNodeId;
    PublishedDataSetDataType.schema.encodingDefaultBinary = PublishedDataSetDataType.encodingDefaultBinary;
    PublishedDataSetDataType.schema.encodingDefaultXml = PublishedDataSetDataType.encodingDefaultXml;
    PublishedDataSetDataType.schema.encodingDefaultJson = PublishedDataSetDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(PublishedDataSetDataType.dataTypeNodeId, "PublishedDataSetDataType", PublishedDataSetDataType);
    var schemaPubSubGroupDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "PubSubGroupDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Name",
          fieldType: "String"
        },
        {
          name: "Enabled",
          fieldType: "Boolean"
        },
        {
          name: "SecurityMode",
          fieldType: "MessageSecurityMode"
        },
        {
          name: "SecurityGroupId",
          fieldType: "String"
        },
        {
          name: "SecurityKeyServices",
          fieldType: "EndpointDescription",
          isArray: true
        },
        {
          name: "MaxNetworkMessageSize",
          fieldType: "UInt32"
        },
        {
          name: "GroupProperties",
          fieldType: "KeyValuePair",
          isArray: true
        }
      ]
    });
    var PubSubGroupDataType = class _PubSubGroupDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaPubSubGroupDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.name = null;
          this.enabled = false;
          this.securityMode = 0;
          this.securityGroupId = null;
          this.securityKeyServices = null;
          this.maxNetworkMessageSize = 0;
          this.groupProperties = null;
          return;
        }
        const schema = _PubSubGroupDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.name = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.name);
        this.enabled = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.enabled);
        this.securityMode = this.setSecurityMode((0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.securityMode));
        this.securityGroupId = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.securityGroupId);
        this.securityKeyServices = [];
        if (options.securityKeyServices) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.securityKeyServices));
          this.securityKeyServices = options.securityKeyServices.map((e) => new EndpointDescription(e));
        }
        this.maxNetworkMessageSize = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.maxNetworkMessageSize);
        this.groupProperties = [];
        if (options.groupProperties) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.groupProperties));
          this.groupProperties = options.groupProperties.map((e) => new KeyValuePair(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.name, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.enabled, stream);
        encodeMessageSecurityMode(this.securityMode, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.securityGroupId, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.securityKeyServices, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeUInt32)(this.maxNetworkMessageSize, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.groupProperties, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.name = (0, node_opcua_basic_types_1.decodeString)(stream, this.name);
        this.enabled = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.enabled);
        this.securityMode = decodeMessageSecurityMode(stream, this.securityMode);
        this.securityGroupId = (0, node_opcua_basic_types_1.decodeString)(stream, this.securityGroupId);
        this.securityKeyServices = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new EndpointDescription(null);
          obj.decode(stream1);
          return obj;
        });
        this.maxNetworkMessageSize = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.maxNetworkMessageSize);
        this.groupProperties = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new KeyValuePair(null);
          obj.decode(stream1);
          return obj;
        });
      }
      // Define Enumeration setters
      setSecurityMode(value) {
        const coercedValue = exports2._enumerationMessageSecurityMode.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to MessageSecurityMode :" + value);
        }
        this.securityMode = coercedValue.value;
        return this.securityMode;
      }
      get schema() {
        return schemaPubSubGroupDataType;
      }
    };
    exports2.PubSubGroupDataType = PubSubGroupDataType;
    PubSubGroupDataType.possibleFields = [
      "name",
      "enabled",
      "securityMode",
      "securityGroupId",
      "securityKeyServices",
      "maxNetworkMessageSize",
      "groupProperties"
    ];
    PubSubGroupDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15609, 0);
    PubSubGroupDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15689, 0);
    PubSubGroupDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15988, 0);
    PubSubGroupDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16159, 0);
    PubSubGroupDataType.schema.dataTypeNodeId = PubSubGroupDataType.dataTypeNodeId;
    PubSubGroupDataType.schema.encodingDefaultBinary = PubSubGroupDataType.encodingDefaultBinary;
    PubSubGroupDataType.schema.encodingDefaultXml = PubSubGroupDataType.encodingDefaultXml;
    PubSubGroupDataType.schema.encodingDefaultJson = PubSubGroupDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(PubSubGroupDataType.dataTypeNodeId, "PubSubGroupDataType", PubSubGroupDataType);
    var schemaWriterGroupDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "WriterGroupDataType",
      baseType: "PubSubGroupDataType",
      fields: [
        {
          name: "WriterGroupId",
          fieldType: "UInt16"
        },
        {
          name: "PublishingInterval",
          fieldType: "Double"
        },
        {
          name: "KeepAliveTime",
          fieldType: "Double"
        },
        {
          name: "Priority",
          fieldType: "Byte"
        },
        {
          name: "LocaleIds",
          fieldType: "String",
          isArray: true
        },
        {
          name: "HeaderLayoutUri",
          fieldType: "String"
        },
        {
          name: "TransportSettings",
          fieldType: "ExtensionObject"
        },
        {
          name: "MessageSettings",
          fieldType: "ExtensionObject"
        },
        {
          name: "DataSetWriters",
          fieldType: "DataSetWriterDataType",
          isArray: true
        }
      ]
    });
    var WriterGroupDataType = class _WriterGroupDataType extends PubSubGroupDataType {
      static get schema() {
        return schemaWriterGroupDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.writerGroupId = 0;
          this.publishingInterval = 0;
          this.keepAliveTime = 0;
          this.priority = 0;
          this.localeIds = [];
          this.headerLayoutUri = null;
          this.transportSettings = null;
          this.messageSettings = null;
          this.dataSetWriters = null;
          return;
        }
        const schema = _WriterGroupDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.writerGroupId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.writerGroupId);
        this.publishingInterval = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.publishingInterval);
        this.keepAliveTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.keepAliveTime);
        this.priority = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.priority);
        this.localeIds = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[4], options?.localeIds);
        this.headerLayoutUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.headerLayoutUri);
        this.transportSettings = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.transportSettings);
        this.messageSettings = (0, node_opcua_factory_1.initialize_field)(schema.fields[7], options?.messageSettings);
        this.dataSetWriters = [];
        if (options.dataSetWriters) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.dataSetWriters));
          this.dataSetWriters = options.dataSetWriters.map((e) => new DataSetWriterDataType(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt16)(this.writerGroupId, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.publishingInterval, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.keepAliveTime, stream);
        (0, node_opcua_basic_types_1.encodeByte)(this.priority, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.localeIds, stream, node_opcua_basic_types_1.encodeString);
        (0, node_opcua_basic_types_1.encodeString)(this.headerLayoutUri, stream);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.transportSettings, stream);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.messageSettings, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.dataSetWriters, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.writerGroupId = (0, node_opcua_basic_types_1.decodeUInt16)(stream, this.writerGroupId);
        this.publishingInterval = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.publishingInterval);
        this.keepAliveTime = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.keepAliveTime);
        this.priority = (0, node_opcua_basic_types_1.decodeByte)(stream, this.priority);
        this.localeIds = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
        this.headerLayoutUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.headerLayoutUri);
        this.transportSettings = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.transportSettings);
        this.messageSettings = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.messageSettings);
        this.dataSetWriters = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new DataSetWriterDataType(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaWriterGroupDataType;
      }
    };
    exports2.WriterGroupDataType = WriterGroupDataType;
    WriterGroupDataType.possibleFields = [
      "name",
      "enabled",
      "securityMode",
      "securityGroupId",
      "securityKeyServices",
      "maxNetworkMessageSize",
      "groupProperties",
      "writerGroupId",
      "publishingInterval",
      "keepAliveTime",
      "priority",
      "localeIds",
      "headerLayoutUri",
      "transportSettings",
      "messageSettings",
      "dataSetWriters"
    ];
    WriterGroupDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15480, 0);
    WriterGroupDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(21150, 0);
    WriterGroupDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(21174, 0);
    WriterGroupDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(21198, 0);
    WriterGroupDataType.schema.dataTypeNodeId = WriterGroupDataType.dataTypeNodeId;
    WriterGroupDataType.schema.encodingDefaultBinary = WriterGroupDataType.encodingDefaultBinary;
    WriterGroupDataType.schema.encodingDefaultXml = WriterGroupDataType.encodingDefaultXml;
    WriterGroupDataType.schema.encodingDefaultJson = WriterGroupDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(WriterGroupDataType.dataTypeNodeId, "WriterGroupDataType", WriterGroupDataType);
    var schemaReaderGroupDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ReaderGroupDataType",
      baseType: "PubSubGroupDataType",
      fields: [
        {
          name: "TransportSettings",
          fieldType: "ExtensionObject"
        },
        {
          name: "MessageSettings",
          fieldType: "ExtensionObject"
        },
        {
          name: "DataSetReaders",
          fieldType: "DataSetReaderDataType",
          isArray: true
        }
      ]
    });
    var ReaderGroupDataType = class _ReaderGroupDataType extends PubSubGroupDataType {
      static get schema() {
        return schemaReaderGroupDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.transportSettings = null;
          this.messageSettings = null;
          this.dataSetReaders = null;
          return;
        }
        const schema = _ReaderGroupDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.transportSettings = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.transportSettings);
        this.messageSettings = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.messageSettings);
        this.dataSetReaders = [];
        if (options.dataSetReaders) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.dataSetReaders));
          this.dataSetReaders = options.dataSetReaders.map((e) => new DataSetReaderDataType(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.transportSettings, stream);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.messageSettings, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.dataSetReaders, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.transportSettings = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.transportSettings);
        this.messageSettings = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.messageSettings);
        this.dataSetReaders = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new DataSetReaderDataType(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaReaderGroupDataType;
      }
    };
    exports2.ReaderGroupDataType = ReaderGroupDataType;
    ReaderGroupDataType.possibleFields = [
      "name",
      "enabled",
      "securityMode",
      "securityGroupId",
      "securityKeyServices",
      "maxNetworkMessageSize",
      "groupProperties",
      "transportSettings",
      "messageSettings",
      "dataSetReaders"
    ];
    ReaderGroupDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15520, 0);
    ReaderGroupDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(21153, 0);
    ReaderGroupDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(21177, 0);
    ReaderGroupDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(21201, 0);
    ReaderGroupDataType.schema.dataTypeNodeId = ReaderGroupDataType.dataTypeNodeId;
    ReaderGroupDataType.schema.encodingDefaultBinary = ReaderGroupDataType.encodingDefaultBinary;
    ReaderGroupDataType.schema.encodingDefaultXml = ReaderGroupDataType.encodingDefaultXml;
    ReaderGroupDataType.schema.encodingDefaultJson = ReaderGroupDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ReaderGroupDataType.dataTypeNodeId, "ReaderGroupDataType", ReaderGroupDataType);
    var schemaPubSubConnectionDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "PubSubConnectionDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Name",
          fieldType: "String"
        },
        {
          name: "Enabled",
          fieldType: "Boolean"
        },
        {
          name: "PublisherId",
          fieldType: "Variant"
        },
        {
          name: "TransportProfileUri",
          fieldType: "String"
        },
        {
          name: "Address",
          fieldType: "ExtensionObject"
        },
        {
          name: "ConnectionProperties",
          fieldType: "KeyValuePair",
          isArray: true
        },
        {
          name: "TransportSettings",
          fieldType: "ExtensionObject"
        },
        {
          name: "WriterGroups",
          fieldType: "WriterGroupDataType",
          isArray: true
        },
        {
          name: "ReaderGroups",
          fieldType: "ReaderGroupDataType",
          isArray: true
        }
      ]
    });
    var PubSubConnectionDataType = class _PubSubConnectionDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaPubSubConnectionDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.name = null;
          this.enabled = false;
          this.publisherId = new node_opcua_variant_1.Variant(null);
          this.transportProfileUri = null;
          this.address = null;
          this.connectionProperties = null;
          this.transportSettings = null;
          this.writerGroups = null;
          this.readerGroups = null;
          return;
        }
        const schema = _PubSubConnectionDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.name = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.name);
        this.enabled = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.enabled);
        this.publisherId = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.publisherId);
        this.transportProfileUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.transportProfileUri);
        this.address = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.address);
        this.connectionProperties = [];
        if (options.connectionProperties) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.connectionProperties));
          this.connectionProperties = options.connectionProperties.map((e) => new KeyValuePair(e));
        }
        this.transportSettings = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.transportSettings);
        this.writerGroups = [];
        if (options.writerGroups) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.writerGroups));
          this.writerGroups = options.writerGroups.map((e) => new WriterGroupDataType(e));
        }
        this.readerGroups = [];
        if (options.readerGroups) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.readerGroups));
          this.readerGroups = options.readerGroups.map((e) => new ReaderGroupDataType(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.name, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.enabled, stream);
        (0, node_opcua_variant_1.encodeVariant)(this.publisherId, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.transportProfileUri, stream);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.address, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.connectionProperties, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.transportSettings, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.writerGroups, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.readerGroups, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.name = (0, node_opcua_basic_types_1.decodeString)(stream, this.name);
        this.enabled = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.enabled);
        this.publisherId = (0, node_opcua_variant_1.decodeVariant)(stream, this.publisherId);
        this.transportProfileUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.transportProfileUri);
        this.address = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.address);
        this.connectionProperties = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new KeyValuePair(null);
          obj.decode(stream1);
          return obj;
        });
        this.transportSettings = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.transportSettings);
        this.writerGroups = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new WriterGroupDataType(null);
          obj.decode(stream1);
          return obj;
        });
        this.readerGroups = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new ReaderGroupDataType(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaPubSubConnectionDataType;
      }
    };
    exports2.PubSubConnectionDataType = PubSubConnectionDataType;
    PubSubConnectionDataType.possibleFields = [
      "name",
      "enabled",
      "publisherId",
      "transportProfileUri",
      "address",
      "connectionProperties",
      "transportSettings",
      "writerGroups",
      "readerGroups"
    ];
    PubSubConnectionDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15617, 0);
    PubSubConnectionDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15694, 0);
    PubSubConnectionDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15992, 0);
    PubSubConnectionDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16281, 0);
    PubSubConnectionDataType.schema.dataTypeNodeId = PubSubConnectionDataType.dataTypeNodeId;
    PubSubConnectionDataType.schema.encodingDefaultBinary = PubSubConnectionDataType.encodingDefaultBinary;
    PubSubConnectionDataType.schema.encodingDefaultXml = PubSubConnectionDataType.encodingDefaultXml;
    PubSubConnectionDataType.schema.encodingDefaultJson = PubSubConnectionDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(PubSubConnectionDataType.dataTypeNodeId, "PubSubConnectionDataType", PubSubConnectionDataType);
    var schemaPubSubConfigurationDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "PubSubConfigurationDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "PublishedDataSets",
          fieldType: "PublishedDataSetDataType",
          isArray: true
        },
        {
          name: "Connections",
          fieldType: "PubSubConnectionDataType",
          isArray: true
        },
        {
          name: "Enabled",
          fieldType: "Boolean"
        }
      ]
    });
    var PubSubConfigurationDataType = class _PubSubConfigurationDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaPubSubConfigurationDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.publishedDataSets = null;
          this.connections = null;
          this.enabled = false;
          return;
        }
        const schema = _PubSubConfigurationDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.publishedDataSets = [];
        if (options.publishedDataSets) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.publishedDataSets));
          this.publishedDataSets = options.publishedDataSets.map((e) => new PublishedDataSetDataType(e));
        }
        this.connections = [];
        if (options.connections) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.connections));
          this.connections = options.connections.map((e) => new PubSubConnectionDataType(e));
        }
        this.enabled = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.enabled);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.publishedDataSets, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.connections, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeBoolean)(this.enabled, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.publishedDataSets = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new PublishedDataSetDataType(null);
          obj.decode(stream1);
          return obj;
        });
        this.connections = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new PubSubConnectionDataType(null);
          obj.decode(stream1);
          return obj;
        });
        this.enabled = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.enabled);
      }
      get schema() {
        return schemaPubSubConfigurationDataType;
      }
    };
    exports2.PubSubConfigurationDataType = PubSubConfigurationDataType;
    PubSubConfigurationDataType.possibleFields = [
      "publishedDataSets",
      "connections",
      "enabled"
    ];
    PubSubConfigurationDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15530, 0);
    PubSubConfigurationDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(21154, 0);
    PubSubConfigurationDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(21178, 0);
    PubSubConfigurationDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(21202, 0);
    PubSubConfigurationDataType.schema.dataTypeNodeId = PubSubConfigurationDataType.dataTypeNodeId;
    PubSubConfigurationDataType.schema.encodingDefaultBinary = PubSubConfigurationDataType.encodingDefaultBinary;
    PubSubConfigurationDataType.schema.encodingDefaultXml = PubSubConfigurationDataType.encodingDefaultXml;
    PubSubConfigurationDataType.schema.encodingDefaultJson = PubSubConfigurationDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(PubSubConfigurationDataType.dataTypeNodeId, "PubSubConfigurationDataType", PubSubConfigurationDataType);
    var schemaSubscribedDataSetDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SubscribedDataSetDataType",
      baseType: "ExtensionObject",
      fields: []
    });
    var SubscribedDataSetDataType = class _SubscribedDataSetDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaSubscribedDataSetDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _SubscribedDataSetDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaSubscribedDataSetDataType;
      }
    };
    exports2.SubscribedDataSetDataType = SubscribedDataSetDataType;
    SubscribedDataSetDataType.possibleFields = [];
    SubscribedDataSetDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15630, 0);
    SubscribedDataSetDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15707, 0);
    SubscribedDataSetDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16010, 0);
    SubscribedDataSetDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16308, 0);
    SubscribedDataSetDataType.schema.dataTypeNodeId = SubscribedDataSetDataType.dataTypeNodeId;
    SubscribedDataSetDataType.schema.encodingDefaultBinary = SubscribedDataSetDataType.encodingDefaultBinary;
    SubscribedDataSetDataType.schema.encodingDefaultXml = SubscribedDataSetDataType.encodingDefaultXml;
    SubscribedDataSetDataType.schema.encodingDefaultJson = SubscribedDataSetDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(SubscribedDataSetDataType.dataTypeNodeId, "SubscribedDataSetDataType", SubscribedDataSetDataType);
    var schemaStandaloneSubscribedDataSetDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "StandaloneSubscribedDataSetDataType",
      baseType: "SubscribedDataSetDataType",
      fields: [
        {
          name: "Name",
          fieldType: "String"
        },
        {
          name: "DataSetFolder",
          fieldType: "String",
          isArray: true
        },
        {
          name: "DataSetMetaData",
          fieldType: "DataSetMetaDataType"
        },
        {
          name: "SubscribedDataSet",
          fieldType: "ExtensionObject"
        }
      ]
    });
    var StandaloneSubscribedDataSetDataType = class _StandaloneSubscribedDataSetDataType extends SubscribedDataSetDataType {
      static get schema() {
        return schemaStandaloneSubscribedDataSetDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.name = null;
          this.dataSetFolder = [];
          this.dataSetMetaData = new DataSetMetaDataType(null);
          this.subscribedDataSet = null;
          return;
        }
        const schema = _StandaloneSubscribedDataSetDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.name = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.name);
        this.dataSetFolder = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.dataSetFolder);
        this.dataSetMetaData = new DataSetMetaDataType(options.dataSetMetaData);
        this.subscribedDataSet = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.subscribedDataSet);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.name, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.dataSetFolder, stream, node_opcua_basic_types_1.encodeString);
        this.dataSetMetaData.encode(stream);
        (0, node_opcua_extension_object_1.encodeExtensionObject)(this.subscribedDataSet, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.name = (0, node_opcua_basic_types_1.decodeString)(stream, this.name);
        this.dataSetFolder = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
        this.dataSetMetaData.decode(stream);
        this.subscribedDataSet = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream, this.subscribedDataSet);
      }
      get schema() {
        return schemaStandaloneSubscribedDataSetDataType;
      }
    };
    exports2.StandaloneSubscribedDataSetDataType = StandaloneSubscribedDataSetDataType;
    StandaloneSubscribedDataSetDataType.possibleFields = [
      "name",
      "dataSetFolder",
      "dataSetMetaData",
      "subscribedDataSet"
    ];
    StandaloneSubscribedDataSetDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23600, 0);
    StandaloneSubscribedDataSetDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23852, 0);
    StandaloneSubscribedDataSetDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23920, 0);
    StandaloneSubscribedDataSetDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23988, 0);
    StandaloneSubscribedDataSetDataType.schema.dataTypeNodeId = StandaloneSubscribedDataSetDataType.dataTypeNodeId;
    StandaloneSubscribedDataSetDataType.schema.encodingDefaultBinary = StandaloneSubscribedDataSetDataType.encodingDefaultBinary;
    StandaloneSubscribedDataSetDataType.schema.encodingDefaultXml = StandaloneSubscribedDataSetDataType.encodingDefaultXml;
    StandaloneSubscribedDataSetDataType.schema.encodingDefaultJson = StandaloneSubscribedDataSetDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(StandaloneSubscribedDataSetDataType.dataTypeNodeId, "StandaloneSubscribedDataSetDataType", StandaloneSubscribedDataSetDataType);
    var schemaSecurityGroupDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SecurityGroupDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Name",
          fieldType: "String"
        },
        {
          name: "SecurityGroupFolder",
          fieldType: "String",
          isArray: true
        },
        {
          name: "KeyLifetime",
          fieldType: "Double"
        },
        {
          name: "SecurityPolicyUri",
          fieldType: "String"
        },
        {
          name: "MaxFutureKeyCount",
          fieldType: "UInt32"
        },
        {
          name: "MaxPastKeyCount",
          fieldType: "UInt32"
        },
        {
          name: "SecurityGroupId",
          fieldType: "String"
        },
        {
          name: "RolePermissions",
          fieldType: "RolePermissionType",
          isArray: true
        },
        {
          name: "GroupProperties",
          fieldType: "KeyValuePair",
          isArray: true
        }
      ]
    });
    var SecurityGroupDataType = class _SecurityGroupDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaSecurityGroupDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.name = null;
          this.securityGroupFolder = [];
          this.keyLifetime = 0;
          this.securityPolicyUri = null;
          this.maxFutureKeyCount = 0;
          this.maxPastKeyCount = 0;
          this.securityGroupId = null;
          this.rolePermissions = null;
          this.groupProperties = null;
          return;
        }
        const schema = _SecurityGroupDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.name = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.name);
        this.securityGroupFolder = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.securityGroupFolder);
        this.keyLifetime = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.keyLifetime);
        this.securityPolicyUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.securityPolicyUri);
        this.maxFutureKeyCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.maxFutureKeyCount);
        this.maxPastKeyCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.maxPastKeyCount);
        this.securityGroupId = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.securityGroupId);
        this.rolePermissions = [];
        if (options.rolePermissions) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.rolePermissions));
          this.rolePermissions = options.rolePermissions.map((e) => new RolePermissionType(e));
        }
        this.groupProperties = [];
        if (options.groupProperties) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.groupProperties));
          this.groupProperties = options.groupProperties.map((e) => new KeyValuePair(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.name, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.securityGroupFolder, stream, node_opcua_basic_types_1.encodeString);
        (0, node_opcua_basic_types_1.encodeDouble)(this.keyLifetime, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.securityPolicyUri, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.maxFutureKeyCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.maxPastKeyCount, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.securityGroupId, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.rolePermissions, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.groupProperties, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.name = (0, node_opcua_basic_types_1.decodeString)(stream, this.name);
        this.securityGroupFolder = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
        this.keyLifetime = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.keyLifetime);
        this.securityPolicyUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.securityPolicyUri);
        this.maxFutureKeyCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.maxFutureKeyCount);
        this.maxPastKeyCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.maxPastKeyCount);
        this.securityGroupId = (0, node_opcua_basic_types_1.decodeString)(stream, this.securityGroupId);
        this.rolePermissions = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new RolePermissionType(null);
          obj.decode(stream1);
          return obj;
        });
        this.groupProperties = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new KeyValuePair(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaSecurityGroupDataType;
      }
    };
    exports2.SecurityGroupDataType = SecurityGroupDataType;
    SecurityGroupDataType.possibleFields = [
      "name",
      "securityGroupFolder",
      "keyLifetime",
      "securityPolicyUri",
      "maxFutureKeyCount",
      "maxPastKeyCount",
      "securityGroupId",
      "rolePermissions",
      "groupProperties"
    ];
    SecurityGroupDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23601, 0);
    SecurityGroupDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23853, 0);
    SecurityGroupDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23921, 0);
    SecurityGroupDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23989, 0);
    SecurityGroupDataType.schema.dataTypeNodeId = SecurityGroupDataType.dataTypeNodeId;
    SecurityGroupDataType.schema.encodingDefaultBinary = SecurityGroupDataType.encodingDefaultBinary;
    SecurityGroupDataType.schema.encodingDefaultXml = SecurityGroupDataType.encodingDefaultXml;
    SecurityGroupDataType.schema.encodingDefaultJson = SecurityGroupDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(SecurityGroupDataType.dataTypeNodeId, "SecurityGroupDataType", SecurityGroupDataType);
    var schemaPubSubKeyPushTargetDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "PubSubKeyPushTargetDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ApplicationUri",
          fieldType: "String"
        },
        {
          name: "PushTargetFolder",
          fieldType: "String",
          isArray: true
        },
        {
          name: "EndpointUrl",
          fieldType: "String"
        },
        {
          name: "SecurityPolicyUri",
          fieldType: "String"
        },
        {
          name: "UserTokenType",
          fieldType: "UserTokenPolicy"
        },
        {
          name: "RequestedKeyCount",
          fieldType: "UInt16"
        },
        {
          name: "RetryInterval",
          fieldType: "Double"
        },
        {
          name: "PushTargetProperties",
          fieldType: "KeyValuePair",
          isArray: true
        },
        {
          name: "SecurityGroups",
          fieldType: "String",
          isArray: true
        }
      ]
    });
    var PubSubKeyPushTargetDataType = class _PubSubKeyPushTargetDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaPubSubKeyPushTargetDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.applicationUri = null;
          this.pushTargetFolder = [];
          this.endpointUrl = null;
          this.securityPolicyUri = null;
          this.userTokenType = new UserTokenPolicy(null);
          this.requestedKeyCount = 0;
          this.retryInterval = 0;
          this.pushTargetProperties = null;
          this.securityGroups = [];
          return;
        }
        const schema = _PubSubKeyPushTargetDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.applicationUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.applicationUri);
        this.pushTargetFolder = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.pushTargetFolder);
        this.endpointUrl = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.endpointUrl);
        this.securityPolicyUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.securityPolicyUri);
        this.userTokenType = new UserTokenPolicy(options.userTokenType);
        this.requestedKeyCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.requestedKeyCount);
        this.retryInterval = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.retryInterval);
        this.pushTargetProperties = [];
        if (options.pushTargetProperties) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.pushTargetProperties));
          this.pushTargetProperties = options.pushTargetProperties.map((e) => new KeyValuePair(e));
        }
        this.securityGroups = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[8], options?.securityGroups);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.applicationUri, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.pushTargetFolder, stream, node_opcua_basic_types_1.encodeString);
        (0, node_opcua_basic_types_1.encodeString)(this.endpointUrl, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.securityPolicyUri, stream);
        this.userTokenType.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt16)(this.requestedKeyCount, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.retryInterval, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.pushTargetProperties, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.securityGroups, stream, node_opcua_basic_types_1.encodeString);
      }
      decode(stream) {
        super.decode(stream);
        this.applicationUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.applicationUri);
        this.pushTargetFolder = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
        this.endpointUrl = (0, node_opcua_basic_types_1.decodeString)(stream, this.endpointUrl);
        this.securityPolicyUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.securityPolicyUri);
        this.userTokenType.decode(stream);
        this.requestedKeyCount = (0, node_opcua_basic_types_1.decodeUInt16)(stream, this.requestedKeyCount);
        this.retryInterval = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.retryInterval);
        this.pushTargetProperties = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new KeyValuePair(null);
          obj.decode(stream1);
          return obj;
        });
        this.securityGroups = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
      }
      get schema() {
        return schemaPubSubKeyPushTargetDataType;
      }
    };
    exports2.PubSubKeyPushTargetDataType = PubSubKeyPushTargetDataType;
    PubSubKeyPushTargetDataType.possibleFields = [
      "applicationUri",
      "pushTargetFolder",
      "endpointUrl",
      "securityPolicyUri",
      "userTokenType",
      "requestedKeyCount",
      "retryInterval",
      "pushTargetProperties",
      "securityGroups"
    ];
    PubSubKeyPushTargetDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(25270, 0);
    PubSubKeyPushTargetDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(25530, 0);
    PubSubKeyPushTargetDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(25546, 0);
    PubSubKeyPushTargetDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(25562, 0);
    PubSubKeyPushTargetDataType.schema.dataTypeNodeId = PubSubKeyPushTargetDataType.dataTypeNodeId;
    PubSubKeyPushTargetDataType.schema.encodingDefaultBinary = PubSubKeyPushTargetDataType.encodingDefaultBinary;
    PubSubKeyPushTargetDataType.schema.encodingDefaultXml = PubSubKeyPushTargetDataType.encodingDefaultXml;
    PubSubKeyPushTargetDataType.schema.encodingDefaultJson = PubSubKeyPushTargetDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(PubSubKeyPushTargetDataType.dataTypeNodeId, "PubSubKeyPushTargetDataType", PubSubKeyPushTargetDataType);
    var schemaPubSubConfiguration2DataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "PubSubConfiguration2DataType",
      baseType: "PubSubConfigurationDataType",
      fields: [
        {
          name: "SubscribedDataSets",
          fieldType: "StandaloneSubscribedDataSetDataType",
          isArray: true
        },
        {
          name: "DataSetClasses",
          fieldType: "DataSetMetaDataType",
          isArray: true
        },
        {
          name: "DefaultSecurityKeyServices",
          fieldType: "EndpointDescription",
          isArray: true
        },
        {
          name: "SecurityGroups",
          fieldType: "SecurityGroupDataType",
          isArray: true
        },
        {
          name: "PubSubKeyPushTargets",
          fieldType: "PubSubKeyPushTargetDataType",
          isArray: true
        },
        {
          name: "ConfigurationVersion",
          fieldType: "UInt32"
        },
        {
          name: "ConfigurationProperties",
          fieldType: "KeyValuePair",
          isArray: true
        }
      ]
    });
    var PubSubConfiguration2DataType = class _PubSubConfiguration2DataType extends PubSubConfigurationDataType {
      static get schema() {
        return schemaPubSubConfiguration2DataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.subscribedDataSets = null;
          this.dataSetClasses = null;
          this.defaultSecurityKeyServices = null;
          this.securityGroups = null;
          this.pubSubKeyPushTargets = null;
          this.configurationVersion = 0;
          this.configurationProperties = null;
          return;
        }
        const schema = _PubSubConfiguration2DataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.subscribedDataSets = [];
        if (options.subscribedDataSets) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.subscribedDataSets));
          this.subscribedDataSets = options.subscribedDataSets.map((e) => new StandaloneSubscribedDataSetDataType(e));
        }
        this.dataSetClasses = [];
        if (options.dataSetClasses) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.dataSetClasses));
          this.dataSetClasses = options.dataSetClasses.map((e) => new DataSetMetaDataType(e));
        }
        this.defaultSecurityKeyServices = [];
        if (options.defaultSecurityKeyServices) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.defaultSecurityKeyServices));
          this.defaultSecurityKeyServices = options.defaultSecurityKeyServices.map((e) => new EndpointDescription(e));
        }
        this.securityGroups = [];
        if (options.securityGroups) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.securityGroups));
          this.securityGroups = options.securityGroups.map((e) => new SecurityGroupDataType(e));
        }
        this.pubSubKeyPushTargets = [];
        if (options.pubSubKeyPushTargets) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.pubSubKeyPushTargets));
          this.pubSubKeyPushTargets = options.pubSubKeyPushTargets.map((e) => new PubSubKeyPushTargetDataType(e));
        }
        this.configurationVersion = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.configurationVersion);
        this.configurationProperties = [];
        if (options.configurationProperties) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.configurationProperties));
          this.configurationProperties = options.configurationProperties.map((e) => new KeyValuePair(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.subscribedDataSets, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.dataSetClasses, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.defaultSecurityKeyServices, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.securityGroups, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.pubSubKeyPushTargets, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeUInt32)(this.configurationVersion, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.configurationProperties, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.subscribedDataSets = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new StandaloneSubscribedDataSetDataType(null);
          obj.decode(stream1);
          return obj;
        });
        this.dataSetClasses = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new DataSetMetaDataType(null);
          obj.decode(stream1);
          return obj;
        });
        this.defaultSecurityKeyServices = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new EndpointDescription(null);
          obj.decode(stream1);
          return obj;
        });
        this.securityGroups = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new SecurityGroupDataType(null);
          obj.decode(stream1);
          return obj;
        });
        this.pubSubKeyPushTargets = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new PubSubKeyPushTargetDataType(null);
          obj.decode(stream1);
          return obj;
        });
        this.configurationVersion = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.configurationVersion);
        this.configurationProperties = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new KeyValuePair(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaPubSubConfiguration2DataType;
      }
    };
    exports2.PubSubConfiguration2DataType = PubSubConfiguration2DataType;
    PubSubConfiguration2DataType.possibleFields = [
      "publishedDataSets",
      "connections",
      "enabled",
      "subscribedDataSets",
      "dataSetClasses",
      "defaultSecurityKeyServices",
      "securityGroups",
      "pubSubKeyPushTargets",
      "configurationVersion",
      "configurationProperties"
    ];
    PubSubConfiguration2DataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23602, 0);
    PubSubConfiguration2DataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23854, 0);
    PubSubConfiguration2DataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23922, 0);
    PubSubConfiguration2DataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23990, 0);
    PubSubConfiguration2DataType.schema.dataTypeNodeId = PubSubConfiguration2DataType.dataTypeNodeId;
    PubSubConfiguration2DataType.schema.encodingDefaultBinary = PubSubConfiguration2DataType.encodingDefaultBinary;
    PubSubConfiguration2DataType.schema.encodingDefaultXml = PubSubConfiguration2DataType.encodingDefaultXml;
    PubSubConfiguration2DataType.schema.encodingDefaultJson = PubSubConfiguration2DataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(PubSubConfiguration2DataType.dataTypeNodeId, "PubSubConfiguration2DataType", PubSubConfiguration2DataType);
    var PubSubConfigurationRefMask;
    (function(PubSubConfigurationRefMask2) {
      PubSubConfigurationRefMask2[PubSubConfigurationRefMask2["None"] = 0] = "None";
      PubSubConfigurationRefMask2[PubSubConfigurationRefMask2["ElementAdd"] = 1] = "ElementAdd";
      PubSubConfigurationRefMask2[PubSubConfigurationRefMask2["ElementMatch"] = 2] = "ElementMatch";
      PubSubConfigurationRefMask2[PubSubConfigurationRefMask2["ElementModify"] = 4] = "ElementModify";
      PubSubConfigurationRefMask2[PubSubConfigurationRefMask2["ElementRemove"] = 8] = "ElementRemove";
      PubSubConfigurationRefMask2[PubSubConfigurationRefMask2["ReferenceWriter"] = 16] = "ReferenceWriter";
      PubSubConfigurationRefMask2[PubSubConfigurationRefMask2["ReferenceReader"] = 32] = "ReferenceReader";
      PubSubConfigurationRefMask2[PubSubConfigurationRefMask2["ReferenceWriterGroup"] = 64] = "ReferenceWriterGroup";
      PubSubConfigurationRefMask2[PubSubConfigurationRefMask2["ReferenceReaderGroup"] = 128] = "ReferenceReaderGroup";
      PubSubConfigurationRefMask2[PubSubConfigurationRefMask2["ReferenceConnection"] = 256] = "ReferenceConnection";
      PubSubConfigurationRefMask2[PubSubConfigurationRefMask2["ReferencePubDataset"] = 512] = "ReferencePubDataset";
      PubSubConfigurationRefMask2[PubSubConfigurationRefMask2["ReferenceSubDataset"] = 1024] = "ReferenceSubDataset";
      PubSubConfigurationRefMask2[PubSubConfigurationRefMask2["ReferenceSecurityGroup"] = 2048] = "ReferenceSecurityGroup";
      PubSubConfigurationRefMask2[PubSubConfigurationRefMask2["ReferencePushTarget"] = 4096] = "ReferencePushTarget";
    })(PubSubConfigurationRefMask || (exports2.PubSubConfigurationRefMask = PubSubConfigurationRefMask = {}));
    var schemaPubSubConfigurationRefMask = {
      enumValues: PubSubConfigurationRefMask,
      flaggable: true,
      name: "PubSubConfigurationRefMask"
    };
    function decodePubSubConfigurationRefMask(stream, _value) {
      return stream.readUInt32();
    }
    function encodePubSubConfigurationRefMask(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationPubSubConfigurationRefMask = (0, node_opcua_factory_1.registerEnumeration)(schemaPubSubConfigurationRefMask);
    (0, node_opcua_assert_1.assert)(exports2._enumerationPubSubConfigurationRefMask.isFlaggable === true);
    var schemaPubSubConfigurationRefDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "PubSubConfigurationRefDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ConfigurationMask",
          fieldType: "PubSubConfigurationRefMask"
        },
        {
          name: "ElementIndex",
          fieldType: "UInt16"
        },
        {
          name: "ConnectionIndex",
          fieldType: "UInt16"
        },
        {
          name: "GroupIndex",
          fieldType: "UInt16"
        }
      ]
    });
    var PubSubConfigurationRefDataType = class _PubSubConfigurationRefDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaPubSubConfigurationRefDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.configurationMask = 0;
          this.elementIndex = 0;
          this.connectionIndex = 0;
          this.groupIndex = 0;
          return;
        }
        const schema = _PubSubConfigurationRefDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.configurationMask = this.setConfigurationMask((0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.configurationMask));
        this.elementIndex = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.elementIndex);
        this.connectionIndex = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.connectionIndex);
        this.groupIndex = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.groupIndex);
      }
      encode(stream) {
        super.encode(stream);
        encodePubSubConfigurationRefMask(this.configurationMask, stream);
        (0, node_opcua_basic_types_1.encodeUInt16)(this.elementIndex, stream);
        (0, node_opcua_basic_types_1.encodeUInt16)(this.connectionIndex, stream);
        (0, node_opcua_basic_types_1.encodeUInt16)(this.groupIndex, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.configurationMask = decodePubSubConfigurationRefMask(stream, this.configurationMask);
        this.elementIndex = (0, node_opcua_basic_types_1.decodeUInt16)(stream, this.elementIndex);
        this.connectionIndex = (0, node_opcua_basic_types_1.decodeUInt16)(stream, this.connectionIndex);
        this.groupIndex = (0, node_opcua_basic_types_1.decodeUInt16)(stream, this.groupIndex);
      }
      // Define Enumeration setters
      setConfigurationMask(value) {
        const coercedValue = exports2._enumerationPubSubConfigurationRefMask.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to PubSubConfigurationRefMask :" + value);
        }
        this.configurationMask = coercedValue.value;
        return this.configurationMask;
      }
      get schema() {
        return schemaPubSubConfigurationRefDataType;
      }
    };
    exports2.PubSubConfigurationRefDataType = PubSubConfigurationRefDataType;
    PubSubConfigurationRefDataType.possibleFields = [
      "configurationMask",
      "elementIndex",
      "connectionIndex",
      "groupIndex"
    ];
    PubSubConfigurationRefDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(25519, 0);
    PubSubConfigurationRefDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(25531, 0);
    PubSubConfigurationRefDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(25547, 0);
    PubSubConfigurationRefDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(25563, 0);
    PubSubConfigurationRefDataType.schema.dataTypeNodeId = PubSubConfigurationRefDataType.dataTypeNodeId;
    PubSubConfigurationRefDataType.schema.encodingDefaultBinary = PubSubConfigurationRefDataType.encodingDefaultBinary;
    PubSubConfigurationRefDataType.schema.encodingDefaultXml = PubSubConfigurationRefDataType.encodingDefaultXml;
    PubSubConfigurationRefDataType.schema.encodingDefaultJson = PubSubConfigurationRefDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(PubSubConfigurationRefDataType.dataTypeNodeId, "PubSubConfigurationRefDataType", PubSubConfigurationRefDataType);
    var schemaPubSubConfigurationValueDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "PubSubConfigurationValueDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ConfigurationElement",
          fieldType: "PubSubConfigurationRefDataType"
        },
        {
          name: "Name",
          fieldType: "String"
        },
        {
          name: "Identifier",
          fieldType: "Variant"
        }
      ]
    });
    var PubSubConfigurationValueDataType = class _PubSubConfigurationValueDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaPubSubConfigurationValueDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.configurationElement = new PubSubConfigurationRefDataType(null);
          this.name = null;
          this.identifier = new node_opcua_variant_1.Variant(null);
          return;
        }
        const schema = _PubSubConfigurationValueDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.configurationElement = new PubSubConfigurationRefDataType(options.configurationElement);
        this.name = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.name);
        this.identifier = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.identifier);
      }
      encode(stream) {
        super.encode(stream);
        this.configurationElement.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.name, stream);
        (0, node_opcua_variant_1.encodeVariant)(this.identifier, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.configurationElement.decode(stream);
        this.name = (0, node_opcua_basic_types_1.decodeString)(stream, this.name);
        this.identifier = (0, node_opcua_variant_1.decodeVariant)(stream, this.identifier);
      }
      get schema() {
        return schemaPubSubConfigurationValueDataType;
      }
    };
    exports2.PubSubConfigurationValueDataType = PubSubConfigurationValueDataType;
    PubSubConfigurationValueDataType.possibleFields = [
      "configurationElement",
      "name",
      "identifier"
    ];
    PubSubConfigurationValueDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(25520, 0);
    PubSubConfigurationValueDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(25532, 0);
    PubSubConfigurationValueDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(25548, 0);
    PubSubConfigurationValueDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(25564, 0);
    PubSubConfigurationValueDataType.schema.dataTypeNodeId = PubSubConfigurationValueDataType.dataTypeNodeId;
    PubSubConfigurationValueDataType.schema.encodingDefaultBinary = PubSubConfigurationValueDataType.encodingDefaultBinary;
    PubSubConfigurationValueDataType.schema.encodingDefaultXml = PubSubConfigurationValueDataType.encodingDefaultXml;
    PubSubConfigurationValueDataType.schema.encodingDefaultJson = PubSubConfigurationValueDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(PubSubConfigurationValueDataType.dataTypeNodeId, "PubSubConfigurationValueDataType", PubSubConfigurationValueDataType);
    var schemaSubscriptionAcknowledgement = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SubscriptionAcknowledgement",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "SubscriptionId",
          fieldType: "UInt32"
        },
        {
          name: "SequenceNumber",
          fieldType: "UInt32"
        }
      ]
    });
    var SubscriptionAcknowledgement = class _SubscriptionAcknowledgement extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaSubscriptionAcknowledgement;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.subscriptionId = 0;
          this.sequenceNumber = 0;
          return;
        }
        const schema = _SubscriptionAcknowledgement.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.subscriptionId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.subscriptionId);
        this.sequenceNumber = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.sequenceNumber);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.subscriptionId, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.sequenceNumber, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.subscriptionId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.subscriptionId);
        this.sequenceNumber = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.sequenceNumber);
      }
      get schema() {
        return schemaSubscriptionAcknowledgement;
      }
    };
    exports2.SubscriptionAcknowledgement = SubscriptionAcknowledgement;
    SubscriptionAcknowledgement.possibleFields = [
      "subscriptionId",
      "sequenceNumber"
    ];
    SubscriptionAcknowledgement.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(821, 0);
    SubscriptionAcknowledgement.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(823, 0);
    SubscriptionAcknowledgement.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(822, 0);
    SubscriptionAcknowledgement.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15351, 0);
    SubscriptionAcknowledgement.schema.dataTypeNodeId = SubscriptionAcknowledgement.dataTypeNodeId;
    SubscriptionAcknowledgement.schema.encodingDefaultBinary = SubscriptionAcknowledgement.encodingDefaultBinary;
    SubscriptionAcknowledgement.schema.encodingDefaultXml = SubscriptionAcknowledgement.encodingDefaultXml;
    SubscriptionAcknowledgement.schema.encodingDefaultJson = SubscriptionAcknowledgement.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(SubscriptionAcknowledgement.dataTypeNodeId, "SubscriptionAcknowledgement", SubscriptionAcknowledgement);
    var schemaPublishRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "PublishRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "SubscriptionAcknowledgements",
          fieldType: "SubscriptionAcknowledgement",
          isArray: true
        }
      ]
    });
    var PublishRequest = class _PublishRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaPublishRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.subscriptionAcknowledgements = null;
          return;
        }
        const schema = _PublishRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.subscriptionAcknowledgements = [];
        if (options.subscriptionAcknowledgements) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.subscriptionAcknowledgements));
          this.subscriptionAcknowledgements = options.subscriptionAcknowledgements.map((e) => new SubscriptionAcknowledgement(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.subscriptionAcknowledgements, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.subscriptionAcknowledgements = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new SubscriptionAcknowledgement(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaPublishRequest;
      }
    };
    exports2.PublishRequest = PublishRequest;
    PublishRequest.possibleFields = [
      "requestHeader",
      "subscriptionAcknowledgements"
    ];
    PublishRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(824, 0);
    PublishRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(826, 0);
    PublishRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(825, 0);
    PublishRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15352, 0);
    PublishRequest.schema.dataTypeNodeId = PublishRequest.dataTypeNodeId;
    PublishRequest.schema.encodingDefaultBinary = PublishRequest.encodingDefaultBinary;
    PublishRequest.schema.encodingDefaultXml = PublishRequest.encodingDefaultXml;
    PublishRequest.schema.encodingDefaultJson = PublishRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(PublishRequest.dataTypeNodeId, "PublishRequest", PublishRequest);
    var schemaPublishResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "PublishResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "SubscriptionId",
          fieldType: "UInt32"
        },
        {
          name: "AvailableSequenceNumbers",
          fieldType: "UInt32",
          isArray: true
        },
        {
          name: "MoreNotifications",
          fieldType: "Boolean"
        },
        {
          name: "NotificationMessage",
          fieldType: "NotificationMessage"
        },
        {
          name: "Results",
          fieldType: "StatusCode",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var PublishResponse = class _PublishResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaPublishResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.subscriptionId = 0;
          this.availableSequenceNumbers = [];
          this.moreNotifications = false;
          this.notificationMessage = new NotificationMessage(null);
          this.results = [];
          this.diagnosticInfos = [];
          return;
        }
        const schema = _PublishResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.subscriptionId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.subscriptionId);
        this.availableSequenceNumbers = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.availableSequenceNumbers);
        this.moreNotifications = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.moreNotifications);
        this.notificationMessage = new NotificationMessage(options.notificationMessage);
        this.results = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[5], options?.results);
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[6], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.subscriptionId, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.availableSequenceNumbers, stream, node_opcua_basic_types_1.encodeUInt32);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.moreNotifications, stream);
        this.notificationMessage.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.results, stream, node_opcua_status_code_1.encodeStatusCode);
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.subscriptionId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.subscriptionId);
        this.availableSequenceNumbers = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeUInt32);
        this.moreNotifications = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.moreNotifications);
        this.notificationMessage.decode(stream);
        this.results = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_status_code_1.decodeStatusCode);
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaPublishResponse;
      }
    };
    exports2.PublishResponse = PublishResponse;
    PublishResponse.possibleFields = [
      "responseHeader",
      "subscriptionId",
      "availableSequenceNumbers",
      "moreNotifications",
      "notificationMessage",
      "results",
      "diagnosticInfos"
    ];
    PublishResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(827, 0);
    PublishResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(829, 0);
    PublishResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(828, 0);
    PublishResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15353, 0);
    PublishResponse.schema.dataTypeNodeId = PublishResponse.dataTypeNodeId;
    PublishResponse.schema.encodingDefaultBinary = PublishResponse.encodingDefaultBinary;
    PublishResponse.schema.encodingDefaultXml = PublishResponse.encodingDefaultXml;
    PublishResponse.schema.encodingDefaultJson = PublishResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(PublishResponse.dataTypeNodeId, "PublishResponse", PublishResponse);
    var schemaPublishedDataSetSourceDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "PublishedDataSetSourceDataType",
      baseType: "ExtensionObject",
      fields: []
    });
    var PublishedDataSetSourceDataType = class _PublishedDataSetSourceDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaPublishedDataSetSourceDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _PublishedDataSetSourceDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaPublishedDataSetSourceDataType;
      }
    };
    exports2.PublishedDataSetSourceDataType = PublishedDataSetSourceDataType;
    PublishedDataSetSourceDataType.possibleFields = [];
    PublishedDataSetSourceDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15580, 0);
    PublishedDataSetSourceDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15678, 0);
    PublishedDataSetSourceDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15952, 0);
    PublishedDataSetSourceDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16153, 0);
    PublishedDataSetSourceDataType.schema.dataTypeNodeId = PublishedDataSetSourceDataType.dataTypeNodeId;
    PublishedDataSetSourceDataType.schema.encodingDefaultBinary = PublishedDataSetSourceDataType.encodingDefaultBinary;
    PublishedDataSetSourceDataType.schema.encodingDefaultXml = PublishedDataSetSourceDataType.encodingDefaultXml;
    PublishedDataSetSourceDataType.schema.encodingDefaultJson = PublishedDataSetSourceDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(PublishedDataSetSourceDataType.dataTypeNodeId, "PublishedDataSetSourceDataType", PublishedDataSetSourceDataType);
    var schemaPublishedVariableDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "PublishedVariableDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "PublishedVariable",
          fieldType: "NodeId"
        },
        {
          name: "AttributeId",
          fieldType: "UInt32"
        },
        {
          name: "SamplingIntervalHint",
          fieldType: "Double"
        },
        {
          name: "DeadbandType",
          fieldType: "UInt32"
        },
        {
          name: "DeadbandValue",
          fieldType: "Double"
        },
        {
          name: "IndexRange",
          fieldType: "NumericRange"
        },
        {
          name: "SubstituteValue",
          fieldType: "Variant"
        },
        {
          name: "MetaDataProperties",
          fieldType: "QualifiedName",
          isArray: true
        }
      ]
    });
    var PublishedVariableDataType = class _PublishedVariableDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaPublishedVariableDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.publishedVariable = new node_opcua_nodeid_1.NodeId(null);
          this.attributeId = 0;
          this.samplingIntervalHint = 0;
          this.deadbandType = 0;
          this.deadbandValue = 0;
          this.indexRange = new node_opcua_numeric_range_1.NumericRange(null);
          this.substituteValue = new node_opcua_variant_1.Variant(null);
          this.metaDataProperties = [];
          return;
        }
        const schema = _PublishedVariableDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.publishedVariable = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.publishedVariable);
        this.attributeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.attributeId);
        this.samplingIntervalHint = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.samplingIntervalHint);
        this.deadbandType = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.deadbandType);
        this.deadbandValue = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.deadbandValue);
        this.indexRange = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.indexRange);
        this.substituteValue = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.substituteValue);
        this.metaDataProperties = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[7], options?.metaDataProperties);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.publishedVariable, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.attributeId, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.samplingIntervalHint, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.deadbandType, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.deadbandValue, stream);
        (0, node_opcua_numeric_range_1.encodeNumericRange)(this.indexRange, stream);
        (0, node_opcua_variant_1.encodeVariant)(this.substituteValue, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.metaDataProperties, stream, node_opcua_data_model_1.encodeQualifiedName);
      }
      decode(stream) {
        super.decode(stream);
        this.publishedVariable = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.publishedVariable);
        this.attributeId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.attributeId);
        this.samplingIntervalHint = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.samplingIntervalHint);
        this.deadbandType = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.deadbandType);
        this.deadbandValue = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.deadbandValue);
        this.indexRange = (0, node_opcua_numeric_range_1.decodeNumericRange)(stream, this.indexRange);
        this.substituteValue = (0, node_opcua_variant_1.decodeVariant)(stream, this.substituteValue);
        this.metaDataProperties = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeQualifiedName);
      }
      get schema() {
        return schemaPublishedVariableDataType;
      }
    };
    exports2.PublishedVariableDataType = PublishedVariableDataType;
    PublishedVariableDataType.possibleFields = [
      "publishedVariable",
      "attributeId",
      "samplingIntervalHint",
      "deadbandType",
      "deadbandValue",
      "indexRange",
      "substituteValue",
      "metaDataProperties"
    ];
    PublishedVariableDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14273, 0);
    PublishedVariableDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14323, 0);
    PublishedVariableDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(14319, 0);
    PublishedVariableDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15060, 0);
    PublishedVariableDataType.schema.dataTypeNodeId = PublishedVariableDataType.dataTypeNodeId;
    PublishedVariableDataType.schema.encodingDefaultBinary = PublishedVariableDataType.encodingDefaultBinary;
    PublishedVariableDataType.schema.encodingDefaultXml = PublishedVariableDataType.encodingDefaultXml;
    PublishedVariableDataType.schema.encodingDefaultJson = PublishedVariableDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(PublishedVariableDataType.dataTypeNodeId, "PublishedVariableDataType", PublishedVariableDataType);
    var schemaPublishedDataItemsDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "PublishedDataItemsDataType",
      baseType: "PublishedDataSetSourceDataType",
      fields: [
        {
          name: "PublishedData",
          fieldType: "PublishedVariableDataType",
          isArray: true
        }
      ]
    });
    var PublishedDataItemsDataType = class _PublishedDataItemsDataType extends PublishedDataSetSourceDataType {
      static get schema() {
        return schemaPublishedDataItemsDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.publishedData = null;
          return;
        }
        const schema = _PublishedDataItemsDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.publishedData = [];
        if (options.publishedData) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.publishedData));
          this.publishedData = options.publishedData.map((e) => new PublishedVariableDataType(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.publishedData, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.publishedData = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new PublishedVariableDataType(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaPublishedDataItemsDataType;
      }
    };
    exports2.PublishedDataItemsDataType = PublishedDataItemsDataType;
    PublishedDataItemsDataType.possibleFields = [
      "publishedData"
    ];
    PublishedDataItemsDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15581, 0);
    PublishedDataItemsDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15679, 0);
    PublishedDataItemsDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15953, 0);
    PublishedDataItemsDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16154, 0);
    PublishedDataItemsDataType.schema.dataTypeNodeId = PublishedDataItemsDataType.dataTypeNodeId;
    PublishedDataItemsDataType.schema.encodingDefaultBinary = PublishedDataItemsDataType.encodingDefaultBinary;
    PublishedDataItemsDataType.schema.encodingDefaultXml = PublishedDataItemsDataType.encodingDefaultXml;
    PublishedDataItemsDataType.schema.encodingDefaultJson = PublishedDataItemsDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(PublishedDataItemsDataType.dataTypeNodeId, "PublishedDataItemsDataType", PublishedDataItemsDataType);
    var schemaPublishedDataSetCustomSourceDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "PublishedDataSetCustomSourceDataType",
      baseType: "PublishedDataSetSourceDataType",
      fields: [
        {
          name: "CyclicDataSet",
          fieldType: "Boolean"
        }
      ]
    });
    var PublishedDataSetCustomSourceDataType = class _PublishedDataSetCustomSourceDataType extends PublishedDataSetSourceDataType {
      static get schema() {
        return schemaPublishedDataSetCustomSourceDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.cyclicDataSet = false;
          return;
        }
        const schema = _PublishedDataSetCustomSourceDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.cyclicDataSet = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.cyclicDataSet);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.cyclicDataSet, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.cyclicDataSet = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.cyclicDataSet);
      }
      get schema() {
        return schemaPublishedDataSetCustomSourceDataType;
      }
    };
    exports2.PublishedDataSetCustomSourceDataType = PublishedDataSetCustomSourceDataType;
    PublishedDataSetCustomSourceDataType.possibleFields = [
      "cyclicDataSet"
    ];
    PublishedDataSetCustomSourceDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(25269, 0);
    PublishedDataSetCustomSourceDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(25529, 0);
    PublishedDataSetCustomSourceDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(25545, 0);
    PublishedDataSetCustomSourceDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(25561, 0);
    PublishedDataSetCustomSourceDataType.schema.dataTypeNodeId = PublishedDataSetCustomSourceDataType.dataTypeNodeId;
    PublishedDataSetCustomSourceDataType.schema.encodingDefaultBinary = PublishedDataSetCustomSourceDataType.encodingDefaultBinary;
    PublishedDataSetCustomSourceDataType.schema.encodingDefaultXml = PublishedDataSetCustomSourceDataType.encodingDefaultXml;
    PublishedDataSetCustomSourceDataType.schema.encodingDefaultJson = PublishedDataSetCustomSourceDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(PublishedDataSetCustomSourceDataType.dataTypeNodeId, "PublishedDataSetCustomSourceDataType", PublishedDataSetCustomSourceDataType);
    var schemaPublishedEventsDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "PublishedEventsDataType",
      baseType: "PublishedDataSetSourceDataType",
      fields: [
        {
          name: "EventNotifier",
          fieldType: "NodeId"
        },
        {
          name: "SelectedFields",
          fieldType: "SimpleAttributeOperand",
          isArray: true
        },
        {
          name: "Filter",
          fieldType: "ContentFilter"
        }
      ]
    });
    var PublishedEventsDataType = class _PublishedEventsDataType extends PublishedDataSetSourceDataType {
      static get schema() {
        return schemaPublishedEventsDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.eventNotifier = new node_opcua_nodeid_1.NodeId(null);
          this.selectedFields = null;
          this.filter = new ContentFilter(null);
          return;
        }
        const schema = _PublishedEventsDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.eventNotifier = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.eventNotifier);
        this.selectedFields = [];
        if (options.selectedFields) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.selectedFields));
          this.selectedFields = options.selectedFields.map((e) => new SimpleAttributeOperand(e));
        }
        this.filter = new ContentFilter(options.filter);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.eventNotifier, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.selectedFields, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        this.filter.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.eventNotifier = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.eventNotifier);
        this.selectedFields = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new SimpleAttributeOperand(null);
          obj.decode(stream1);
          return obj;
        });
        this.filter.decode(stream);
      }
      get schema() {
        return schemaPublishedEventsDataType;
      }
    };
    exports2.PublishedEventsDataType = PublishedEventsDataType;
    PublishedEventsDataType.possibleFields = [
      "eventNotifier",
      "selectedFields",
      "filter"
    ];
    PublishedEventsDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15582, 0);
    PublishedEventsDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15681, 0);
    PublishedEventsDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15954, 0);
    PublishedEventsDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16155, 0);
    PublishedEventsDataType.schema.dataTypeNodeId = PublishedEventsDataType.dataTypeNodeId;
    PublishedEventsDataType.schema.encodingDefaultBinary = PublishedEventsDataType.encodingDefaultBinary;
    PublishedEventsDataType.schema.encodingDefaultXml = PublishedEventsDataType.encodingDefaultXml;
    PublishedEventsDataType.schema.encodingDefaultJson = PublishedEventsDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(PublishedEventsDataType.dataTypeNodeId, "PublishedEventsDataType", PublishedEventsDataType);
    var schemaQosDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "QosDataType",
      baseType: "ExtensionObject",
      fields: []
    });
    var QosDataType = class _QosDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaQosDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _QosDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaQosDataType;
      }
    };
    exports2.QosDataType = QosDataType;
    QosDataType.possibleFields = [];
    QosDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23603, 0);
    QosDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23855, 0);
    QosDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23923, 0);
    QosDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23991, 0);
    QosDataType.schema.dataTypeNodeId = QosDataType.dataTypeNodeId;
    QosDataType.schema.encodingDefaultBinary = QosDataType.encodingDefaultBinary;
    QosDataType.schema.encodingDefaultXml = QosDataType.encodingDefaultXml;
    QosDataType.schema.encodingDefaultJson = QosDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(QosDataType.dataTypeNodeId, "QosDataType", QosDataType);
    var schemaQueryDataSet = (0, node_opcua_factory_1.buildStructuredType)({
      name: "QueryDataSet",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "NodeId",
          fieldType: "ExpandedNodeId"
        },
        {
          name: "TypeDefinitionNode",
          fieldType: "ExpandedNodeId"
        },
        {
          name: "Values",
          fieldType: "Variant",
          isArray: true
        }
      ]
    });
    var QueryDataSet = class _QueryDataSet extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaQueryDataSet;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.nodeId = new node_opcua_nodeid_1.ExpandedNodeId(null);
          this.typeDefinitionNode = new node_opcua_nodeid_1.ExpandedNodeId(null);
          this.values = [];
          return;
        }
        const schema = _QueryDataSet.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.nodeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.nodeId);
        this.typeDefinitionNode = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.typeDefinitionNode);
        this.values = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.values);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeExpandedNodeId)(this.nodeId, stream);
        (0, node_opcua_basic_types_1.encodeExpandedNodeId)(this.typeDefinitionNode, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.values, stream, node_opcua_variant_1.encodeVariant);
      }
      decode(stream) {
        super.decode(stream);
        this.nodeId = (0, node_opcua_basic_types_1.decodeExpandedNodeId)(stream, this.nodeId);
        this.typeDefinitionNode = (0, node_opcua_basic_types_1.decodeExpandedNodeId)(stream, this.typeDefinitionNode);
        this.values = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_variant_1.decodeVariant);
      }
      get schema() {
        return schemaQueryDataSet;
      }
    };
    exports2.QueryDataSet = QueryDataSet;
    QueryDataSet.possibleFields = [
      "nodeId",
      "typeDefinitionNode",
      "values"
    ];
    QueryDataSet.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(577, 0);
    QueryDataSet.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(579, 0);
    QueryDataSet.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(578, 0);
    QueryDataSet.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15202, 0);
    QueryDataSet.schema.dataTypeNodeId = QueryDataSet.dataTypeNodeId;
    QueryDataSet.schema.encodingDefaultBinary = QueryDataSet.encodingDefaultBinary;
    QueryDataSet.schema.encodingDefaultXml = QueryDataSet.encodingDefaultXml;
    QueryDataSet.schema.encodingDefaultJson = QueryDataSet.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(QueryDataSet.dataTypeNodeId, "QueryDataSet", QueryDataSet);
    var schemaQueryFirstRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "QueryFirstRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "View",
          fieldType: "ViewDescription"
        },
        {
          name: "NodeTypes",
          fieldType: "NodeTypeDescription",
          isArray: true
        },
        {
          name: "Filter",
          fieldType: "ContentFilter"
        },
        {
          name: "MaxDataSetsToReturn",
          fieldType: "UInt32"
        },
        {
          name: "MaxReferencesToReturn",
          fieldType: "UInt32"
        }
      ]
    });
    var QueryFirstRequest = class _QueryFirstRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaQueryFirstRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.view = new ViewDescription(null);
          this.nodeTypes = null;
          this.filter = new ContentFilter(null);
          this.maxDataSetsToReturn = 0;
          this.maxReferencesToReturn = 0;
          return;
        }
        const schema = _QueryFirstRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.view = new ViewDescription(options.view);
        this.nodeTypes = [];
        if (options.nodeTypes) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.nodeTypes));
          this.nodeTypes = options.nodeTypes.map((e) => new NodeTypeDescription(e));
        }
        this.filter = new ContentFilter(options.filter);
        this.maxDataSetsToReturn = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.maxDataSetsToReturn);
        this.maxReferencesToReturn = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.maxReferencesToReturn);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        this.view.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.nodeTypes, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        this.filter.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.maxDataSetsToReturn, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.maxReferencesToReturn, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.view.decode(stream);
        this.nodeTypes = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new NodeTypeDescription(null);
          obj.decode(stream1);
          return obj;
        });
        this.filter.decode(stream);
        this.maxDataSetsToReturn = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.maxDataSetsToReturn);
        this.maxReferencesToReturn = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.maxReferencesToReturn);
      }
      get schema() {
        return schemaQueryFirstRequest;
      }
    };
    exports2.QueryFirstRequest = QueryFirstRequest;
    QueryFirstRequest.possibleFields = [
      "requestHeader",
      "view",
      "nodeTypes",
      "filter",
      "maxDataSetsToReturn",
      "maxReferencesToReturn"
    ];
    QueryFirstRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(613, 0);
    QueryFirstRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(615, 0);
    QueryFirstRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(614, 0);
    QueryFirstRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15244, 0);
    QueryFirstRequest.schema.dataTypeNodeId = QueryFirstRequest.dataTypeNodeId;
    QueryFirstRequest.schema.encodingDefaultBinary = QueryFirstRequest.encodingDefaultBinary;
    QueryFirstRequest.schema.encodingDefaultXml = QueryFirstRequest.encodingDefaultXml;
    QueryFirstRequest.schema.encodingDefaultJson = QueryFirstRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(QueryFirstRequest.dataTypeNodeId, "QueryFirstRequest", QueryFirstRequest);
    var schemaQueryFirstResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "QueryFirstResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "QueryDataSets",
          fieldType: "QueryDataSet",
          isArray: true
        },
        {
          name: "ContinuationPoint",
          fieldType: "ByteString"
        },
        {
          name: "ParsingResults",
          fieldType: "ParsingResult",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        },
        {
          name: "FilterResult",
          fieldType: "ContentFilterResult"
        }
      ]
    });
    var QueryFirstResponse = class _QueryFirstResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaQueryFirstResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.queryDataSets = null;
          this.continuationPoint = Buffer.alloc(0);
          this.parsingResults = null;
          this.diagnosticInfos = [];
          this.filterResult = new ContentFilterResult(null);
          return;
        }
        const schema = _QueryFirstResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.queryDataSets = [];
        if (options.queryDataSets) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.queryDataSets));
          this.queryDataSets = options.queryDataSets.map((e) => new QueryDataSet(e));
        }
        this.continuationPoint = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.continuationPoint);
        this.parsingResults = [];
        if (options.parsingResults) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.parsingResults));
          this.parsingResults = options.parsingResults.map((e) => new ParsingResult(e));
        }
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[4], options?.diagnosticInfos);
        this.filterResult = new ContentFilterResult(options.filterResult);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.queryDataSets, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeByteString)(this.continuationPoint, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.parsingResults, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
        this.filterResult.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.queryDataSets = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new QueryDataSet(null);
          obj.decode(stream1);
          return obj;
        });
        this.continuationPoint = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.continuationPoint);
        this.parsingResults = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new ParsingResult(null);
          obj.decode(stream1);
          return obj;
        });
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
        this.filterResult.decode(stream);
      }
      get schema() {
        return schemaQueryFirstResponse;
      }
    };
    exports2.QueryFirstResponse = QueryFirstResponse;
    QueryFirstResponse.possibleFields = [
      "responseHeader",
      "queryDataSets",
      "continuationPoint",
      "parsingResults",
      "diagnosticInfos",
      "filterResult"
    ];
    QueryFirstResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(616, 0);
    QueryFirstResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(618, 0);
    QueryFirstResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(617, 0);
    QueryFirstResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15252, 0);
    QueryFirstResponse.schema.dataTypeNodeId = QueryFirstResponse.dataTypeNodeId;
    QueryFirstResponse.schema.encodingDefaultBinary = QueryFirstResponse.encodingDefaultBinary;
    QueryFirstResponse.schema.encodingDefaultXml = QueryFirstResponse.encodingDefaultXml;
    QueryFirstResponse.schema.encodingDefaultJson = QueryFirstResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(QueryFirstResponse.dataTypeNodeId, "QueryFirstResponse", QueryFirstResponse);
    var schemaQueryNextRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "QueryNextRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "ReleaseContinuationPoint",
          fieldType: "Boolean"
        },
        {
          name: "ContinuationPoint",
          fieldType: "ByteString"
        }
      ]
    });
    var QueryNextRequest = class _QueryNextRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaQueryNextRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.releaseContinuationPoint = false;
          this.continuationPoint = Buffer.alloc(0);
          return;
        }
        const schema = _QueryNextRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.releaseContinuationPoint = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.releaseContinuationPoint);
        this.continuationPoint = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.continuationPoint);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.releaseContinuationPoint, stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.continuationPoint, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.releaseContinuationPoint = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.releaseContinuationPoint);
        this.continuationPoint = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.continuationPoint);
      }
      get schema() {
        return schemaQueryNextRequest;
      }
    };
    exports2.QueryNextRequest = QueryNextRequest;
    QueryNextRequest.possibleFields = [
      "requestHeader",
      "releaseContinuationPoint",
      "continuationPoint"
    ];
    QueryNextRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(619, 0);
    QueryNextRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(621, 0);
    QueryNextRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(620, 0);
    QueryNextRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15254, 0);
    QueryNextRequest.schema.dataTypeNodeId = QueryNextRequest.dataTypeNodeId;
    QueryNextRequest.schema.encodingDefaultBinary = QueryNextRequest.encodingDefaultBinary;
    QueryNextRequest.schema.encodingDefaultXml = QueryNextRequest.encodingDefaultXml;
    QueryNextRequest.schema.encodingDefaultJson = QueryNextRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(QueryNextRequest.dataTypeNodeId, "QueryNextRequest", QueryNextRequest);
    var schemaQueryNextResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "QueryNextResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "QueryDataSets",
          fieldType: "QueryDataSet",
          isArray: true
        },
        {
          name: "RevisedContinuationPoint",
          fieldType: "ByteString"
        }
      ]
    });
    var QueryNextResponse = class _QueryNextResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaQueryNextResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.queryDataSets = null;
          this.revisedContinuationPoint = Buffer.alloc(0);
          return;
        }
        const schema = _QueryNextResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.queryDataSets = [];
        if (options.queryDataSets) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.queryDataSets));
          this.queryDataSets = options.queryDataSets.map((e) => new QueryDataSet(e));
        }
        this.revisedContinuationPoint = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.revisedContinuationPoint);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.queryDataSets, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeByteString)(this.revisedContinuationPoint, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.queryDataSets = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new QueryDataSet(null);
          obj.decode(stream1);
          return obj;
        });
        this.revisedContinuationPoint = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.revisedContinuationPoint);
      }
      get schema() {
        return schemaQueryNextResponse;
      }
    };
    exports2.QueryNextResponse = QueryNextResponse;
    QueryNextResponse.possibleFields = [
      "responseHeader",
      "queryDataSets",
      "revisedContinuationPoint"
    ];
    QueryNextResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(622, 0);
    QueryNextResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(624, 0);
    QueryNextResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(623, 0);
    QueryNextResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15255, 0);
    QueryNextResponse.schema.dataTypeNodeId = QueryNextResponse.dataTypeNodeId;
    QueryNextResponse.schema.encodingDefaultBinary = QueryNextResponse.encodingDefaultBinary;
    QueryNextResponse.schema.encodingDefaultXml = QueryNextResponse.encodingDefaultXml;
    QueryNextResponse.schema.encodingDefaultJson = QueryNextResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(QueryNextResponse.dataTypeNodeId, "QueryNextResponse", QueryNextResponse);
    var schemaRationalNumber = (0, node_opcua_factory_1.buildStructuredType)({
      name: "RationalNumber",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Numerator",
          fieldType: "Int32"
        },
        {
          name: "Denominator",
          fieldType: "UInt32"
        }
      ]
    });
    var RationalNumber = class _RationalNumber extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaRationalNumber;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.numerator = 0;
          this.denominator = 0;
          return;
        }
        const schema = _RationalNumber.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.numerator = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.numerator);
        this.denominator = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.denominator);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeInt32)(this.numerator, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.denominator, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.numerator = (0, node_opcua_basic_types_1.decodeInt32)(stream, this.numerator);
        this.denominator = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.denominator);
      }
      get schema() {
        return schemaRationalNumber;
      }
    };
    exports2.RationalNumber = RationalNumber;
    RationalNumber.possibleFields = [
      "numerator",
      "denominator"
    ];
    RationalNumber.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18806, 0);
    RationalNumber.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18815, 0);
    RationalNumber.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18851, 0);
    RationalNumber.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(19064, 0);
    RationalNumber.schema.dataTypeNodeId = RationalNumber.dataTypeNodeId;
    RationalNumber.schema.encodingDefaultBinary = RationalNumber.encodingDefaultBinary;
    RationalNumber.schema.encodingDefaultXml = RationalNumber.encodingDefaultXml;
    RationalNumber.schema.encodingDefaultJson = RationalNumber.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(RationalNumber.dataTypeNodeId, "RationalNumber", RationalNumber);
    var schemaReadAnnotationDataDetails = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ReadAnnotationDataDetails",
      baseType: "HistoryReadDetails",
      fields: [
        {
          name: "ReqTimes",
          fieldType: "DateTime",
          isArray: true
        }
      ]
    });
    var ReadAnnotationDataDetails = class _ReadAnnotationDataDetails extends HistoryReadDetails {
      static get schema() {
        return schemaReadAnnotationDataDetails;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.reqTimes = [];
          return;
        }
        const schema = _ReadAnnotationDataDetails.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.reqTimes = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[0], options?.reqTimes);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.reqTimes, stream, node_opcua_basic_types_1.encodeDateTime);
      }
      decode(stream) {
        super.decode(stream);
        this.reqTimes = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeDateTime);
      }
      get schema() {
        return schemaReadAnnotationDataDetails;
      }
    };
    exports2.ReadAnnotationDataDetails = ReadAnnotationDataDetails;
    ReadAnnotationDataDetails.possibleFields = [
      "reqTimes"
    ];
    ReadAnnotationDataDetails.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23497, 0);
    ReadAnnotationDataDetails.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23500, 0);
    ReadAnnotationDataDetails.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23506, 0);
    ReadAnnotationDataDetails.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23512, 0);
    ReadAnnotationDataDetails.schema.dataTypeNodeId = ReadAnnotationDataDetails.dataTypeNodeId;
    ReadAnnotationDataDetails.schema.encodingDefaultBinary = ReadAnnotationDataDetails.encodingDefaultBinary;
    ReadAnnotationDataDetails.schema.encodingDefaultXml = ReadAnnotationDataDetails.encodingDefaultXml;
    ReadAnnotationDataDetails.schema.encodingDefaultJson = ReadAnnotationDataDetails.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ReadAnnotationDataDetails.dataTypeNodeId, "ReadAnnotationDataDetails", ReadAnnotationDataDetails);
    var schemaReadAtTimeDetails = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ReadAtTimeDetails",
      baseType: "HistoryReadDetails",
      fields: [
        {
          name: "ReqTimes",
          fieldType: "DateTime",
          isArray: true
        },
        {
          name: "UseSimpleBounds",
          fieldType: "Boolean"
        }
      ]
    });
    var ReadAtTimeDetails = class _ReadAtTimeDetails extends HistoryReadDetails {
      static get schema() {
        return schemaReadAtTimeDetails;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.reqTimes = [];
          this.useSimpleBounds = false;
          return;
        }
        const schema = _ReadAtTimeDetails.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.reqTimes = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[0], options?.reqTimes);
        this.useSimpleBounds = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.useSimpleBounds);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.reqTimes, stream, node_opcua_basic_types_1.encodeDateTime);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.useSimpleBounds, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.reqTimes = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeDateTime);
        this.useSimpleBounds = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.useSimpleBounds);
      }
      get schema() {
        return schemaReadAtTimeDetails;
      }
    };
    exports2.ReadAtTimeDetails = ReadAtTimeDetails;
    ReadAtTimeDetails.possibleFields = [
      "reqTimes",
      "useSimpleBounds"
    ];
    ReadAtTimeDetails.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(653, 0);
    ReadAtTimeDetails.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(655, 0);
    ReadAtTimeDetails.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(654, 0);
    ReadAtTimeDetails.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15269, 0);
    ReadAtTimeDetails.schema.dataTypeNodeId = ReadAtTimeDetails.dataTypeNodeId;
    ReadAtTimeDetails.schema.encodingDefaultBinary = ReadAtTimeDetails.encodingDefaultBinary;
    ReadAtTimeDetails.schema.encodingDefaultXml = ReadAtTimeDetails.encodingDefaultXml;
    ReadAtTimeDetails.schema.encodingDefaultJson = ReadAtTimeDetails.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ReadAtTimeDetails.dataTypeNodeId, "ReadAtTimeDetails", ReadAtTimeDetails);
    var schemaReadEventDetails = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ReadEventDetails",
      baseType: "HistoryReadDetails",
      fields: [
        {
          name: "NumValuesPerNode",
          fieldType: "UInt32"
        },
        {
          name: "StartTime",
          fieldType: "DateTime"
        },
        {
          name: "EndTime",
          fieldType: "DateTime"
        },
        {
          name: "Filter",
          fieldType: "EventFilter"
        }
      ]
    });
    var ReadEventDetails = class _ReadEventDetails extends HistoryReadDetails {
      static get schema() {
        return schemaReadEventDetails;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.numValuesPerNode = 0;
          this.startTime = /* @__PURE__ */ new Date();
          this.endTime = /* @__PURE__ */ new Date();
          this.filter = new EventFilter(null);
          return;
        }
        const schema = _ReadEventDetails.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.numValuesPerNode = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.numValuesPerNode);
        this.startTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.startTime);
        this.endTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.endTime);
        this.filter = new EventFilter(options.filter);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.numValuesPerNode, stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.startTime, stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.endTime, stream);
        this.filter.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.numValuesPerNode = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.numValuesPerNode);
        this.startTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.startTime);
        this.endTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.endTime);
        this.filter.decode(stream);
      }
      get schema() {
        return schemaReadEventDetails;
      }
    };
    exports2.ReadEventDetails = ReadEventDetails;
    ReadEventDetails.possibleFields = [
      "numValuesPerNode",
      "startTime",
      "endTime",
      "filter"
    ];
    ReadEventDetails.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(644, 0);
    ReadEventDetails.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(646, 0);
    ReadEventDetails.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(645, 0);
    ReadEventDetails.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15262, 0);
    ReadEventDetails.schema.dataTypeNodeId = ReadEventDetails.dataTypeNodeId;
    ReadEventDetails.schema.encodingDefaultBinary = ReadEventDetails.encodingDefaultBinary;
    ReadEventDetails.schema.encodingDefaultXml = ReadEventDetails.encodingDefaultXml;
    ReadEventDetails.schema.encodingDefaultJson = ReadEventDetails.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ReadEventDetails.dataTypeNodeId, "ReadEventDetails", ReadEventDetails);
    var schemaReadProcessedDetails = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ReadProcessedDetails",
      baseType: "HistoryReadDetails",
      fields: [
        {
          name: "StartTime",
          fieldType: "DateTime"
        },
        {
          name: "EndTime",
          fieldType: "DateTime"
        },
        {
          name: "ProcessingInterval",
          fieldType: "Double"
        },
        {
          name: "AggregateType",
          fieldType: "NodeId",
          isArray: true
        },
        {
          name: "AggregateConfiguration",
          fieldType: "AggregateConfiguration"
        }
      ]
    });
    var ReadProcessedDetails = class _ReadProcessedDetails extends HistoryReadDetails {
      static get schema() {
        return schemaReadProcessedDetails;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.startTime = /* @__PURE__ */ new Date();
          this.endTime = /* @__PURE__ */ new Date();
          this.processingInterval = 0;
          this.aggregateType = [];
          this.aggregateConfiguration = new AggregateConfiguration(null);
          return;
        }
        const schema = _ReadProcessedDetails.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.startTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.startTime);
        this.endTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.endTime);
        this.processingInterval = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.processingInterval);
        this.aggregateType = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[3], options?.aggregateType);
        this.aggregateConfiguration = new AggregateConfiguration(options.aggregateConfiguration);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.startTime, stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.endTime, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.processingInterval, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.aggregateType, stream, node_opcua_basic_types_1.encodeNodeId);
        this.aggregateConfiguration.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.startTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.startTime);
        this.endTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.endTime);
        this.processingInterval = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.processingInterval);
        this.aggregateType = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeNodeId);
        this.aggregateConfiguration.decode(stream);
      }
      get schema() {
        return schemaReadProcessedDetails;
      }
    };
    exports2.ReadProcessedDetails = ReadProcessedDetails;
    ReadProcessedDetails.possibleFields = [
      "startTime",
      "endTime",
      "processingInterval",
      "aggregateType",
      "aggregateConfiguration"
    ];
    ReadProcessedDetails.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(650, 0);
    ReadProcessedDetails.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(652, 0);
    ReadProcessedDetails.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(651, 0);
    ReadProcessedDetails.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15264, 0);
    ReadProcessedDetails.schema.dataTypeNodeId = ReadProcessedDetails.dataTypeNodeId;
    ReadProcessedDetails.schema.encodingDefaultBinary = ReadProcessedDetails.encodingDefaultBinary;
    ReadProcessedDetails.schema.encodingDefaultXml = ReadProcessedDetails.encodingDefaultXml;
    ReadProcessedDetails.schema.encodingDefaultJson = ReadProcessedDetails.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ReadProcessedDetails.dataTypeNodeId, "ReadProcessedDetails", ReadProcessedDetails);
    var schemaReadRawModifiedDetails = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ReadRawModifiedDetails",
      baseType: "HistoryReadDetails",
      fields: [
        {
          name: "IsReadModified",
          fieldType: "Boolean"
        },
        {
          name: "StartTime",
          fieldType: "DateTime"
        },
        {
          name: "EndTime",
          fieldType: "DateTime"
        },
        {
          name: "NumValuesPerNode",
          fieldType: "UInt32"
        },
        {
          name: "ReturnBounds",
          fieldType: "Boolean"
        }
      ]
    });
    var ReadRawModifiedDetails = class _ReadRawModifiedDetails extends HistoryReadDetails {
      static get schema() {
        return schemaReadRawModifiedDetails;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.isReadModified = false;
          this.startTime = /* @__PURE__ */ new Date();
          this.endTime = /* @__PURE__ */ new Date();
          this.numValuesPerNode = 0;
          this.returnBounds = false;
          return;
        }
        const schema = _ReadRawModifiedDetails.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.isReadModified = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.isReadModified);
        this.startTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.startTime);
        this.endTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.endTime);
        this.numValuesPerNode = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.numValuesPerNode);
        this.returnBounds = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.returnBounds);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.isReadModified, stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.startTime, stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.endTime, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.numValuesPerNode, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.returnBounds, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.isReadModified = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.isReadModified);
        this.startTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.startTime);
        this.endTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.endTime);
        this.numValuesPerNode = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.numValuesPerNode);
        this.returnBounds = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.returnBounds);
      }
      get schema() {
        return schemaReadRawModifiedDetails;
      }
    };
    exports2.ReadRawModifiedDetails = ReadRawModifiedDetails;
    ReadRawModifiedDetails.possibleFields = [
      "isReadModified",
      "startTime",
      "endTime",
      "numValuesPerNode",
      "returnBounds"
    ];
    ReadRawModifiedDetails.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(647, 0);
    ReadRawModifiedDetails.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(649, 0);
    ReadRawModifiedDetails.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(648, 0);
    ReadRawModifiedDetails.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15263, 0);
    ReadRawModifiedDetails.schema.dataTypeNodeId = ReadRawModifiedDetails.dataTypeNodeId;
    ReadRawModifiedDetails.schema.encodingDefaultBinary = ReadRawModifiedDetails.encodingDefaultBinary;
    ReadRawModifiedDetails.schema.encodingDefaultXml = ReadRawModifiedDetails.encodingDefaultXml;
    ReadRawModifiedDetails.schema.encodingDefaultJson = ReadRawModifiedDetails.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ReadRawModifiedDetails.dataTypeNodeId, "ReadRawModifiedDetails", ReadRawModifiedDetails);
    var schemaReadRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ReadRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "MaxAge",
          fieldType: "Double"
        },
        {
          name: "TimestampsToReturn",
          fieldType: "TimestampsToReturn"
        },
        {
          name: "NodesToRead",
          fieldType: "ReadValueId",
          isArray: true
        }
      ]
    });
    var ReadRequest = class _ReadRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaReadRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.maxAge = 0;
          this.timestampsToReturn = 0;
          this.nodesToRead = null;
          return;
        }
        const schema = _ReadRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.maxAge = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.maxAge);
        this.timestampsToReturn = this.setTimestampsToReturn((0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.timestampsToReturn));
        this.nodesToRead = [];
        if (options.nodesToRead) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.nodesToRead));
          this.nodesToRead = options.nodesToRead.map((e) => new ReadValueId(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.maxAge, stream);
        (0, node_opcua_data_value_1.encodeTimestampsToReturn)(this.timestampsToReturn, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.nodesToRead, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.maxAge = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.maxAge);
        this.timestampsToReturn = (0, node_opcua_data_value_1.decodeTimestampsToReturn)(stream, this.timestampsToReturn);
        this.nodesToRead = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new ReadValueId(null);
          obj.decode(stream1);
          return obj;
        });
      }
      // Define Enumeration setters
      setTimestampsToReturn(value) {
        const coercedValue = node_opcua_data_value_1._enumerationTimestampsToReturn.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to TimestampsToReturn :" + value);
        }
        this.timestampsToReturn = coercedValue.value;
        return this.timestampsToReturn;
      }
      get schema() {
        return schemaReadRequest;
      }
    };
    exports2.ReadRequest = ReadRequest;
    ReadRequest.possibleFields = [
      "requestHeader",
      "maxAge",
      "timestampsToReturn",
      "nodesToRead"
    ];
    ReadRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(629, 0);
    ReadRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(631, 0);
    ReadRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(630, 0);
    ReadRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15257, 0);
    ReadRequest.schema.dataTypeNodeId = ReadRequest.dataTypeNodeId;
    ReadRequest.schema.encodingDefaultBinary = ReadRequest.encodingDefaultBinary;
    ReadRequest.schema.encodingDefaultXml = ReadRequest.encodingDefaultXml;
    ReadRequest.schema.encodingDefaultJson = ReadRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ReadRequest.dataTypeNodeId, "ReadRequest", ReadRequest);
    var schemaReadResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ReadResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "Results",
          fieldType: "DataValue",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var ReadResponse = class _ReadResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaReadResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.results = [];
          this.diagnosticInfos = [];
          return;
        }
        const schema = _ReadResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.results = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.results);
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.results, stream, node_opcua_data_value_1.encodeDataValue);
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.results = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_value_1.decodeDataValue);
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaReadResponse;
      }
    };
    exports2.ReadResponse = ReadResponse;
    ReadResponse.possibleFields = [
      "responseHeader",
      "results",
      "diagnosticInfos"
    ];
    ReadResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(632, 0);
    ReadResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(634, 0);
    ReadResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(633, 0);
    ReadResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15258, 0);
    ReadResponse.schema.dataTypeNodeId = ReadResponse.dataTypeNodeId;
    ReadResponse.schema.encodingDefaultBinary = ReadResponse.encodingDefaultBinary;
    ReadResponse.schema.encodingDefaultXml = ReadResponse.encodingDefaultXml;
    ReadResponse.schema.encodingDefaultJson = ReadResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ReadResponse.dataTypeNodeId, "ReadResponse", ReadResponse);
    var schemaReaderGroupMessageDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ReaderGroupMessageDataType",
      baseType: "ExtensionObject",
      fields: []
    });
    var ReaderGroupMessageDataType = class _ReaderGroupMessageDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaReaderGroupMessageDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _ReaderGroupMessageDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaReaderGroupMessageDataType;
      }
    };
    exports2.ReaderGroupMessageDataType = ReaderGroupMessageDataType;
    ReaderGroupMessageDataType.possibleFields = [];
    ReaderGroupMessageDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15622, 0);
    ReaderGroupMessageDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15702, 0);
    ReaderGroupMessageDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15996, 0);
    ReaderGroupMessageDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16285, 0);
    ReaderGroupMessageDataType.schema.dataTypeNodeId = ReaderGroupMessageDataType.dataTypeNodeId;
    ReaderGroupMessageDataType.schema.encodingDefaultBinary = ReaderGroupMessageDataType.encodingDefaultBinary;
    ReaderGroupMessageDataType.schema.encodingDefaultXml = ReaderGroupMessageDataType.encodingDefaultXml;
    ReaderGroupMessageDataType.schema.encodingDefaultJson = ReaderGroupMessageDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ReaderGroupMessageDataType.dataTypeNodeId, "ReaderGroupMessageDataType", ReaderGroupMessageDataType);
    var schemaReaderGroupTransportDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ReaderGroupTransportDataType",
      baseType: "ExtensionObject",
      fields: []
    });
    var ReaderGroupTransportDataType = class _ReaderGroupTransportDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaReaderGroupTransportDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _ReaderGroupTransportDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaReaderGroupTransportDataType;
      }
    };
    exports2.ReaderGroupTransportDataType = ReaderGroupTransportDataType;
    ReaderGroupTransportDataType.possibleFields = [];
    ReaderGroupTransportDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15621, 0);
    ReaderGroupTransportDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15701, 0);
    ReaderGroupTransportDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15995, 0);
    ReaderGroupTransportDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16284, 0);
    ReaderGroupTransportDataType.schema.dataTypeNodeId = ReaderGroupTransportDataType.dataTypeNodeId;
    ReaderGroupTransportDataType.schema.encodingDefaultBinary = ReaderGroupTransportDataType.encodingDefaultBinary;
    ReaderGroupTransportDataType.schema.encodingDefaultXml = ReaderGroupTransportDataType.encodingDefaultXml;
    ReaderGroupTransportDataType.schema.encodingDefaultJson = ReaderGroupTransportDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ReaderGroupTransportDataType.dataTypeNodeId, "ReaderGroupTransportDataType", ReaderGroupTransportDataType);
    var schemaReceiveQosDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ReceiveQosDataType",
      baseType: "QosDataType",
      fields: []
    });
    var ReceiveQosDataType = class _ReceiveQosDataType extends QosDataType {
      static get schema() {
        return schemaReceiveQosDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _ReceiveQosDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaReceiveQosDataType;
      }
    };
    exports2.ReceiveQosDataType = ReceiveQosDataType;
    ReceiveQosDataType.possibleFields = [];
    ReceiveQosDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23608, 0);
    ReceiveQosDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23860, 0);
    ReceiveQosDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23928, 0);
    ReceiveQosDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23996, 0);
    ReceiveQosDataType.schema.dataTypeNodeId = ReceiveQosDataType.dataTypeNodeId;
    ReceiveQosDataType.schema.encodingDefaultBinary = ReceiveQosDataType.encodingDefaultBinary;
    ReceiveQosDataType.schema.encodingDefaultXml = ReceiveQosDataType.encodingDefaultXml;
    ReceiveQosDataType.schema.encodingDefaultJson = ReceiveQosDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ReceiveQosDataType.dataTypeNodeId, "ReceiveQosDataType", ReceiveQosDataType);
    var schemaReceiveQosPriorityDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ReceiveQosPriorityDataType",
      baseType: "ReceiveQosDataType",
      fields: [
        {
          name: "PriorityLabel",
          fieldType: "String"
        }
      ]
    });
    var ReceiveQosPriorityDataType = class _ReceiveQosPriorityDataType extends ReceiveQosDataType {
      static get schema() {
        return schemaReceiveQosPriorityDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.priorityLabel = null;
          return;
        }
        const schema = _ReceiveQosPriorityDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.priorityLabel = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.priorityLabel);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.priorityLabel, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.priorityLabel = (0, node_opcua_basic_types_1.decodeString)(stream, this.priorityLabel);
      }
      get schema() {
        return schemaReceiveQosPriorityDataType;
      }
    };
    exports2.ReceiveQosPriorityDataType = ReceiveQosPriorityDataType;
    ReceiveQosPriorityDataType.possibleFields = [
      "priorityLabel"
    ];
    ReceiveQosPriorityDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23609, 0);
    ReceiveQosPriorityDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23861, 0);
    ReceiveQosPriorityDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23929, 0);
    ReceiveQosPriorityDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23997, 0);
    ReceiveQosPriorityDataType.schema.dataTypeNodeId = ReceiveQosPriorityDataType.dataTypeNodeId;
    ReceiveQosPriorityDataType.schema.encodingDefaultBinary = ReceiveQosPriorityDataType.encodingDefaultBinary;
    ReceiveQosPriorityDataType.schema.encodingDefaultXml = ReceiveQosPriorityDataType.encodingDefaultXml;
    ReceiveQosPriorityDataType.schema.encodingDefaultJson = ReceiveQosPriorityDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ReceiveQosPriorityDataType.dataTypeNodeId, "ReceiveQosPriorityDataType", ReceiveQosPriorityDataType);
    var ServerState;
    (function(ServerState2) {
      ServerState2[ServerState2["Running"] = 0] = "Running";
      ServerState2[ServerState2["Failed"] = 1] = "Failed";
      ServerState2[ServerState2["NoConfiguration"] = 2] = "NoConfiguration";
      ServerState2[ServerState2["Suspended"] = 3] = "Suspended";
      ServerState2[ServerState2["Shutdown"] = 4] = "Shutdown";
      ServerState2[ServerState2["Test"] = 5] = "Test";
      ServerState2[ServerState2["CommunicationFault"] = 6] = "CommunicationFault";
      ServerState2[ServerState2["Unknown"] = 7] = "Unknown";
      ServerState2[ServerState2["Invalid"] = 4294967295] = "Invalid";
    })(ServerState || (exports2.ServerState = ServerState = {}));
    var schemaServerState = {
      enumValues: ServerState,
      flaggable: false,
      minValue: 0,
      maxValue: 7,
      name: "ServerState"
    };
    function decodeServerState(stream, _value) {
      let value = stream.readUInt32();
      value = value < schemaServerState.minValue || value > schemaServerState.maxValue ? ServerState.Invalid : value;
      return value;
    }
    function encodeServerState(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationServerState = (0, node_opcua_factory_1.registerEnumeration)(schemaServerState);
    (0, node_opcua_assert_1.assert)(exports2._enumerationServerState.isFlaggable === false);
    var schemaRedundantServerDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "RedundantServerDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ServerId",
          fieldType: "String"
        },
        {
          name: "ServiceLevel",
          fieldType: "Byte"
        },
        {
          name: "ServerState",
          fieldType: "ServerState"
        }
      ]
    });
    var RedundantServerDataType = class _RedundantServerDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaRedundantServerDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.serverId = null;
          this.serviceLevel = 0;
          this.serverState = 0;
          return;
        }
        const schema = _RedundantServerDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.serverId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.serverId);
        this.serviceLevel = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.serviceLevel);
        this.serverState = this.setServerState((0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.serverState));
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.serverId, stream);
        (0, node_opcua_basic_types_1.encodeByte)(this.serviceLevel, stream);
        encodeServerState(this.serverState, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.serverId = (0, node_opcua_basic_types_1.decodeString)(stream, this.serverId);
        this.serviceLevel = (0, node_opcua_basic_types_1.decodeByte)(stream, this.serviceLevel);
        this.serverState = decodeServerState(stream, this.serverState);
      }
      // Define Enumeration setters
      setServerState(value) {
        const coercedValue = exports2._enumerationServerState.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to ServerState :" + value);
        }
        this.serverState = coercedValue.value;
        return this.serverState;
      }
      get schema() {
        return schemaRedundantServerDataType;
      }
    };
    exports2.RedundantServerDataType = RedundantServerDataType;
    RedundantServerDataType.possibleFields = [
      "serverId",
      "serviceLevel",
      "serverState"
    ];
    RedundantServerDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(853, 0);
    RedundantServerDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(855, 0);
    RedundantServerDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(854, 0);
    RedundantServerDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15362, 0);
    RedundantServerDataType.schema.dataTypeNodeId = RedundantServerDataType.dataTypeNodeId;
    RedundantServerDataType.schema.encodingDefaultBinary = RedundantServerDataType.encodingDefaultBinary;
    RedundantServerDataType.schema.encodingDefaultXml = RedundantServerDataType.encodingDefaultXml;
    RedundantServerDataType.schema.encodingDefaultJson = RedundantServerDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(RedundantServerDataType.dataTypeNodeId, "RedundantServerDataType", RedundantServerDataType);
    var schemaReferenceTypeAttributes = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ReferenceTypeAttributes",
      baseType: "NodeAttributes",
      fields: [
        {
          name: "IsAbstract",
          fieldType: "Boolean"
        },
        {
          name: "Symmetric",
          fieldType: "Boolean"
        },
        {
          name: "InverseName",
          fieldType: "LocalizedText"
        }
      ]
    });
    var ReferenceTypeAttributes = class _ReferenceTypeAttributes extends NodeAttributes {
      static get schema() {
        return schemaReferenceTypeAttributes;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.isAbstract = false;
          this.symmetric = false;
          this.inverseName = new node_opcua_data_model_1.LocalizedText(null);
          return;
        }
        const schema = _ReferenceTypeAttributes.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.isAbstract = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.isAbstract);
        this.symmetric = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.symmetric);
        this.inverseName = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.inverseName);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.isAbstract, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.symmetric, stream);
        (0, node_opcua_data_model_1.encodeLocalizedText)(this.inverseName, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.isAbstract = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.isAbstract);
        this.symmetric = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.symmetric);
        this.inverseName = (0, node_opcua_data_model_1.decodeLocalizedText)(stream, this.inverseName);
      }
      get schema() {
        return schemaReferenceTypeAttributes;
      }
    };
    exports2.ReferenceTypeAttributes = ReferenceTypeAttributes;
    ReferenceTypeAttributes.possibleFields = [
      "specifiedAttributes",
      "displayName",
      "description",
      "writeMask",
      "userWriteMask",
      "isAbstract",
      "symmetric",
      "inverseName"
    ];
    ReferenceTypeAttributes.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(367, 0);
    ReferenceTypeAttributes.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(369, 0);
    ReferenceTypeAttributes.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(368, 0);
    ReferenceTypeAttributes.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15160, 0);
    ReferenceTypeAttributes.schema.dataTypeNodeId = ReferenceTypeAttributes.dataTypeNodeId;
    ReferenceTypeAttributes.schema.encodingDefaultBinary = ReferenceTypeAttributes.encodingDefaultBinary;
    ReferenceTypeAttributes.schema.encodingDefaultXml = ReferenceTypeAttributes.encodingDefaultXml;
    ReferenceTypeAttributes.schema.encodingDefaultJson = ReferenceTypeAttributes.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ReferenceTypeAttributes.dataTypeNodeId, "ReferenceTypeAttributes", ReferenceTypeAttributes);
    var schemaReferenceTypeNode = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ReferenceTypeNode",
      baseType: "TypeNode",
      fields: [
        {
          name: "RolePermissions",
          fieldType: "RolePermissionType",
          isArray: true
        },
        {
          name: "UserRolePermissions",
          fieldType: "RolePermissionType",
          isArray: true
        },
        {
          name: "References",
          fieldType: "ReferenceNode",
          isArray: true
        },
        {
          name: "IsAbstract",
          fieldType: "Boolean"
        },
        {
          name: "Symmetric",
          fieldType: "Boolean"
        },
        {
          name: "InverseName",
          fieldType: "LocalizedText"
        }
      ]
    });
    var ReferenceTypeNode = class _ReferenceTypeNode extends TypeNode {
      static get schema() {
        return schemaReferenceTypeNode;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.rolePermissions = null;
          this.userRolePermissions = null;
          this.references = null;
          this.isAbstract = false;
          this.symmetric = false;
          this.inverseName = new node_opcua_data_model_1.LocalizedText(null);
          return;
        }
        const schema = _ReferenceTypeNode.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.rolePermissions = [];
        if (options.rolePermissions) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.rolePermissions));
          this.rolePermissions = options.rolePermissions.map((e) => new RolePermissionType(e));
        }
        this.userRolePermissions = [];
        if (options.userRolePermissions) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.userRolePermissions));
          this.userRolePermissions = options.userRolePermissions.map((e) => new RolePermissionType(e));
        }
        this.references = [];
        if (options.references) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.references));
          this.references = options.references.map((e) => new ReferenceNode(e));
        }
        this.isAbstract = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.isAbstract);
        this.symmetric = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.symmetric);
        this.inverseName = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.inverseName);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.rolePermissions, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.userRolePermissions, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.references, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeBoolean)(this.isAbstract, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.symmetric, stream);
        (0, node_opcua_data_model_1.encodeLocalizedText)(this.inverseName, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.rolePermissions = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new RolePermissionType(null);
          obj.decode(stream1);
          return obj;
        });
        this.userRolePermissions = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new RolePermissionType(null);
          obj.decode(stream1);
          return obj;
        });
        this.references = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new ReferenceNode(null);
          obj.decode(stream1);
          return obj;
        });
        this.isAbstract = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.isAbstract);
        this.symmetric = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.symmetric);
        this.inverseName = (0, node_opcua_data_model_1.decodeLocalizedText)(stream, this.inverseName);
      }
      get schema() {
        return schemaReferenceTypeNode;
      }
    };
    exports2.ReferenceTypeNode = ReferenceTypeNode;
    ReferenceTypeNode.possibleFields = [
      "nodeId",
      "nodeClass",
      "browseName",
      "displayName",
      "description",
      "writeMask",
      "userWriteMask",
      "rolePermissions",
      "userRolePermissions",
      "accessRestrictions",
      "references",
      "rolePermissions",
      "userRolePermissions",
      "references",
      "isAbstract",
      "symmetric",
      "inverseName"
    ];
    ReferenceTypeNode.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(273, 0);
    ReferenceTypeNode.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(275, 0);
    ReferenceTypeNode.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(274, 0);
    ReferenceTypeNode.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15076, 0);
    ReferenceTypeNode.schema.dataTypeNodeId = ReferenceTypeNode.dataTypeNodeId;
    ReferenceTypeNode.schema.encodingDefaultBinary = ReferenceTypeNode.encodingDefaultBinary;
    ReferenceTypeNode.schema.encodingDefaultXml = ReferenceTypeNode.encodingDefaultXml;
    ReferenceTypeNode.schema.encodingDefaultJson = ReferenceTypeNode.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ReferenceTypeNode.dataTypeNodeId, "ReferenceTypeNode", ReferenceTypeNode);
    var schemaRegisterNodesRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "RegisterNodesRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "NodesToRegister",
          fieldType: "NodeId",
          isArray: true
        }
      ]
    });
    var RegisterNodesRequest = class _RegisterNodesRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaRegisterNodesRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.nodesToRegister = [];
          return;
        }
        const schema = _RegisterNodesRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.nodesToRegister = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.nodesToRegister);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.nodesToRegister, stream, node_opcua_basic_types_1.encodeNodeId);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.nodesToRegister = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeNodeId);
      }
      get schema() {
        return schemaRegisterNodesRequest;
      }
    };
    exports2.RegisterNodesRequest = RegisterNodesRequest;
    RegisterNodesRequest.possibleFields = [
      "requestHeader",
      "nodesToRegister"
    ];
    RegisterNodesRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(558, 0);
    RegisterNodesRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(560, 0);
    RegisterNodesRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(559, 0);
    RegisterNodesRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15195, 0);
    RegisterNodesRequest.schema.dataTypeNodeId = RegisterNodesRequest.dataTypeNodeId;
    RegisterNodesRequest.schema.encodingDefaultBinary = RegisterNodesRequest.encodingDefaultBinary;
    RegisterNodesRequest.schema.encodingDefaultXml = RegisterNodesRequest.encodingDefaultXml;
    RegisterNodesRequest.schema.encodingDefaultJson = RegisterNodesRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(RegisterNodesRequest.dataTypeNodeId, "RegisterNodesRequest", RegisterNodesRequest);
    var schemaRegisterNodesResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "RegisterNodesResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "RegisteredNodeIds",
          fieldType: "NodeId",
          isArray: true
        }
      ]
    });
    var RegisterNodesResponse = class _RegisterNodesResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaRegisterNodesResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.registeredNodeIds = [];
          return;
        }
        const schema = _RegisterNodesResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.registeredNodeIds = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.registeredNodeIds);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.registeredNodeIds, stream, node_opcua_basic_types_1.encodeNodeId);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.registeredNodeIds = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeNodeId);
      }
      get schema() {
        return schemaRegisterNodesResponse;
      }
    };
    exports2.RegisterNodesResponse = RegisterNodesResponse;
    RegisterNodesResponse.possibleFields = [
      "responseHeader",
      "registeredNodeIds"
    ];
    RegisterNodesResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(561, 0);
    RegisterNodesResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(563, 0);
    RegisterNodesResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(562, 0);
    RegisterNodesResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15196, 0);
    RegisterNodesResponse.schema.dataTypeNodeId = RegisterNodesResponse.dataTypeNodeId;
    RegisterNodesResponse.schema.encodingDefaultBinary = RegisterNodesResponse.encodingDefaultBinary;
    RegisterNodesResponse.schema.encodingDefaultXml = RegisterNodesResponse.encodingDefaultXml;
    RegisterNodesResponse.schema.encodingDefaultJson = RegisterNodesResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(RegisterNodesResponse.dataTypeNodeId, "RegisterNodesResponse", RegisterNodesResponse);
    var schemaRegisteredServer = (0, node_opcua_factory_1.buildStructuredType)({
      name: "RegisteredServer",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ServerUri",
          fieldType: "String"
        },
        {
          name: "ProductUri",
          fieldType: "String"
        },
        {
          name: "ServerNames",
          fieldType: "LocalizedText",
          isArray: true
        },
        {
          name: "ServerType",
          fieldType: "ApplicationType"
        },
        {
          name: "GatewayServerUri",
          fieldType: "String"
        },
        {
          name: "DiscoveryUrls",
          fieldType: "String",
          isArray: true
        },
        {
          name: "SemaphoreFilePath",
          fieldType: "String"
        },
        {
          name: "IsOnline",
          fieldType: "Boolean"
        }
      ]
    });
    var RegisteredServer = class _RegisteredServer extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaRegisteredServer;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.serverUri = null;
          this.productUri = null;
          this.serverNames = [];
          this.serverType = 0;
          this.gatewayServerUri = null;
          this.discoveryUrls = [];
          this.semaphoreFilePath = null;
          this.isOnline = false;
          return;
        }
        const schema = _RegisteredServer.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.serverUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.serverUri);
        this.productUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.productUri);
        this.serverNames = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.serverNames);
        this.serverType = this.setServerType((0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.serverType));
        this.gatewayServerUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.gatewayServerUri);
        this.discoveryUrls = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[5], options?.discoveryUrls);
        this.semaphoreFilePath = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.semaphoreFilePath);
        this.isOnline = (0, node_opcua_factory_1.initialize_field)(schema.fields[7], options?.isOnline);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.serverUri, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.productUri, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.serverNames, stream, node_opcua_data_model_1.encodeLocalizedText);
        encodeApplicationType(this.serverType, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.gatewayServerUri, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.discoveryUrls, stream, node_opcua_basic_types_1.encodeString);
        (0, node_opcua_basic_types_1.encodeString)(this.semaphoreFilePath, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.isOnline, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.serverUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.serverUri);
        this.productUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.productUri);
        this.serverNames = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeLocalizedText);
        this.serverType = decodeApplicationType(stream, this.serverType);
        this.gatewayServerUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.gatewayServerUri);
        this.discoveryUrls = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
        this.semaphoreFilePath = (0, node_opcua_basic_types_1.decodeString)(stream, this.semaphoreFilePath);
        this.isOnline = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.isOnline);
      }
      // Define Enumeration setters
      setServerType(value) {
        const coercedValue = exports2._enumerationApplicationType.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to ApplicationType :" + value);
        }
        this.serverType = coercedValue.value;
        return this.serverType;
      }
      get schema() {
        return schemaRegisteredServer;
      }
    };
    exports2.RegisteredServer = RegisteredServer;
    RegisteredServer.possibleFields = [
      "serverUri",
      "productUri",
      "serverNames",
      "serverType",
      "gatewayServerUri",
      "discoveryUrls",
      "semaphoreFilePath",
      "isOnline"
    ];
    RegisteredServer.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(432, 0);
    RegisteredServer.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(434, 0);
    RegisteredServer.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(433, 0);
    RegisteredServer.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15102, 0);
    RegisteredServer.schema.dataTypeNodeId = RegisteredServer.dataTypeNodeId;
    RegisteredServer.schema.encodingDefaultBinary = RegisteredServer.encodingDefaultBinary;
    RegisteredServer.schema.encodingDefaultXml = RegisteredServer.encodingDefaultXml;
    RegisteredServer.schema.encodingDefaultJson = RegisteredServer.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(RegisteredServer.dataTypeNodeId, "RegisteredServer", RegisteredServer);
    var schemaRegisterServer2Request = (0, node_opcua_factory_1.buildStructuredType)({
      name: "RegisterServer2Request",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "Server",
          fieldType: "RegisteredServer"
        },
        {
          name: "DiscoveryConfiguration",
          fieldType: "ExtensionObject",
          isArray: true
        }
      ]
    });
    var RegisterServer2Request = class _RegisterServer2Request extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaRegisterServer2Request;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.server = new RegisteredServer(null);
          this.discoveryConfiguration = [];
          return;
        }
        const schema = _RegisterServer2Request.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.server = new RegisteredServer(options.server);
        this.discoveryConfiguration = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.discoveryConfiguration);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        this.server.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.discoveryConfiguration, stream, node_opcua_extension_object_1.encodeExtensionObject);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.server.decode(stream);
        this.discoveryConfiguration = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_extension_object_1.decodeExtensionObject);
      }
      get schema() {
        return schemaRegisterServer2Request;
      }
    };
    exports2.RegisterServer2Request = RegisterServer2Request;
    RegisterServer2Request.possibleFields = [
      "requestHeader",
      "server",
      "discoveryConfiguration"
    ];
    RegisterServer2Request.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12193, 0);
    RegisterServer2Request.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12211, 0);
    RegisterServer2Request.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12199, 0);
    RegisterServer2Request.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15107, 0);
    RegisterServer2Request.schema.dataTypeNodeId = RegisterServer2Request.dataTypeNodeId;
    RegisterServer2Request.schema.encodingDefaultBinary = RegisterServer2Request.encodingDefaultBinary;
    RegisterServer2Request.schema.encodingDefaultXml = RegisterServer2Request.encodingDefaultXml;
    RegisterServer2Request.schema.encodingDefaultJson = RegisterServer2Request.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(RegisterServer2Request.dataTypeNodeId, "RegisterServer2Request", RegisterServer2Request);
    var schemaRegisterServer2Response = (0, node_opcua_factory_1.buildStructuredType)({
      name: "RegisterServer2Response",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "ConfigurationResults",
          fieldType: "StatusCode",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var RegisterServer2Response = class _RegisterServer2Response extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaRegisterServer2Response;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.configurationResults = [];
          this.diagnosticInfos = [];
          return;
        }
        const schema = _RegisterServer2Response.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.configurationResults = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.configurationResults);
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.configurationResults, stream, node_opcua_status_code_1.encodeStatusCode);
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.configurationResults = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_status_code_1.decodeStatusCode);
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaRegisterServer2Response;
      }
    };
    exports2.RegisterServer2Response = RegisterServer2Response;
    RegisterServer2Response.possibleFields = [
      "responseHeader",
      "configurationResults",
      "diagnosticInfos"
    ];
    RegisterServer2Response.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12194, 0);
    RegisterServer2Response.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12212, 0);
    RegisterServer2Response.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12200, 0);
    RegisterServer2Response.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15130, 0);
    RegisterServer2Response.schema.dataTypeNodeId = RegisterServer2Response.dataTypeNodeId;
    RegisterServer2Response.schema.encodingDefaultBinary = RegisterServer2Response.encodingDefaultBinary;
    RegisterServer2Response.schema.encodingDefaultXml = RegisterServer2Response.encodingDefaultXml;
    RegisterServer2Response.schema.encodingDefaultJson = RegisterServer2Response.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(RegisterServer2Response.dataTypeNodeId, "RegisterServer2Response", RegisterServer2Response);
    var schemaRegisterServerRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "RegisterServerRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "Server",
          fieldType: "RegisteredServer"
        }
      ]
    });
    var RegisterServerRequest = class _RegisterServerRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaRegisterServerRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.server = new RegisteredServer(null);
          return;
        }
        const schema = _RegisterServerRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.server = new RegisteredServer(options.server);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        this.server.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.server.decode(stream);
      }
      get schema() {
        return schemaRegisterServerRequest;
      }
    };
    exports2.RegisterServerRequest = RegisterServerRequest;
    RegisterServerRequest.possibleFields = [
      "requestHeader",
      "server"
    ];
    RegisterServerRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(435, 0);
    RegisterServerRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(437, 0);
    RegisterServerRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(436, 0);
    RegisterServerRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15103, 0);
    RegisterServerRequest.schema.dataTypeNodeId = RegisterServerRequest.dataTypeNodeId;
    RegisterServerRequest.schema.encodingDefaultBinary = RegisterServerRequest.encodingDefaultBinary;
    RegisterServerRequest.schema.encodingDefaultXml = RegisterServerRequest.encodingDefaultXml;
    RegisterServerRequest.schema.encodingDefaultJson = RegisterServerRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(RegisterServerRequest.dataTypeNodeId, "RegisterServerRequest", RegisterServerRequest);
    var schemaRegisterServerResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "RegisterServerResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        }
      ]
    });
    var RegisterServerResponse = class _RegisterServerResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaRegisterServerResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          return;
        }
        const schema = _RegisterServerResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
      }
      get schema() {
        return schemaRegisterServerResponse;
      }
    };
    exports2.RegisterServerResponse = RegisterServerResponse;
    RegisterServerResponse.possibleFields = [
      "responseHeader"
    ];
    RegisterServerResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(438, 0);
    RegisterServerResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(440, 0);
    RegisterServerResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(439, 0);
    RegisterServerResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15104, 0);
    RegisterServerResponse.schema.dataTypeNodeId = RegisterServerResponse.dataTypeNodeId;
    RegisterServerResponse.schema.encodingDefaultBinary = RegisterServerResponse.encodingDefaultBinary;
    RegisterServerResponse.schema.encodingDefaultXml = RegisterServerResponse.encodingDefaultXml;
    RegisterServerResponse.schema.encodingDefaultJson = RegisterServerResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(RegisterServerResponse.dataTypeNodeId, "RegisterServerResponse", RegisterServerResponse);
    var schemaRepublishRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "RepublishRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "SubscriptionId",
          fieldType: "UInt32"
        },
        {
          name: "RetransmitSequenceNumber",
          fieldType: "UInt32"
        }
      ]
    });
    var RepublishRequest = class _RepublishRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaRepublishRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.subscriptionId = 0;
          this.retransmitSequenceNumber = 0;
          return;
        }
        const schema = _RepublishRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.subscriptionId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.subscriptionId);
        this.retransmitSequenceNumber = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.retransmitSequenceNumber);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.subscriptionId, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.retransmitSequenceNumber, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.subscriptionId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.subscriptionId);
        this.retransmitSequenceNumber = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.retransmitSequenceNumber);
      }
      get schema() {
        return schemaRepublishRequest;
      }
    };
    exports2.RepublishRequest = RepublishRequest;
    RepublishRequest.possibleFields = [
      "requestHeader",
      "subscriptionId",
      "retransmitSequenceNumber"
    ];
    RepublishRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(830, 0);
    RepublishRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(832, 0);
    RepublishRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(831, 0);
    RepublishRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15354, 0);
    RepublishRequest.schema.dataTypeNodeId = RepublishRequest.dataTypeNodeId;
    RepublishRequest.schema.encodingDefaultBinary = RepublishRequest.encodingDefaultBinary;
    RepublishRequest.schema.encodingDefaultXml = RepublishRequest.encodingDefaultXml;
    RepublishRequest.schema.encodingDefaultJson = RepublishRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(RepublishRequest.dataTypeNodeId, "RepublishRequest", RepublishRequest);
    var schemaRepublishResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "RepublishResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "NotificationMessage",
          fieldType: "NotificationMessage"
        }
      ]
    });
    var RepublishResponse = class _RepublishResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaRepublishResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.notificationMessage = new NotificationMessage(null);
          return;
        }
        const schema = _RepublishResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.notificationMessage = new NotificationMessage(options.notificationMessage);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        this.notificationMessage.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.notificationMessage.decode(stream);
      }
      get schema() {
        return schemaRepublishResponse;
      }
    };
    exports2.RepublishResponse = RepublishResponse;
    RepublishResponse.possibleFields = [
      "responseHeader",
      "notificationMessage"
    ];
    RepublishResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(833, 0);
    RepublishResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(835, 0);
    RepublishResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(834, 0);
    RepublishResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15355, 0);
    RepublishResponse.schema.dataTypeNodeId = RepublishResponse.dataTypeNodeId;
    RepublishResponse.schema.encodingDefaultBinary = RepublishResponse.encodingDefaultBinary;
    RepublishResponse.schema.encodingDefaultXml = RepublishResponse.encodingDefaultXml;
    RepublishResponse.schema.encodingDefaultJson = RepublishResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(RepublishResponse.dataTypeNodeId, "RepublishResponse", RepublishResponse);
    var schemaSamplingIntervalDiagnosticsDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SamplingIntervalDiagnosticsDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "SamplingInterval",
          fieldType: "Double"
        },
        {
          name: "MonitoredItemCount",
          fieldType: "UInt32"
        },
        {
          name: "MaxMonitoredItemCount",
          fieldType: "UInt32"
        },
        {
          name: "DisabledMonitoredItemCount",
          fieldType: "UInt32"
        }
      ]
    });
    var SamplingIntervalDiagnosticsDataType = class _SamplingIntervalDiagnosticsDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaSamplingIntervalDiagnosticsDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.samplingInterval = 0;
          this.monitoredItemCount = 0;
          this.maxMonitoredItemCount = 0;
          this.disabledMonitoredItemCount = 0;
          return;
        }
        const schema = _SamplingIntervalDiagnosticsDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.samplingInterval = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.samplingInterval);
        this.monitoredItemCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.monitoredItemCount);
        this.maxMonitoredItemCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.maxMonitoredItemCount);
        this.disabledMonitoredItemCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.disabledMonitoredItemCount);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.samplingInterval, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.monitoredItemCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.maxMonitoredItemCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.disabledMonitoredItemCount, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.samplingInterval = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.samplingInterval);
        this.monitoredItemCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.monitoredItemCount);
        this.maxMonitoredItemCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.maxMonitoredItemCount);
        this.disabledMonitoredItemCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.disabledMonitoredItemCount);
      }
      get schema() {
        return schemaSamplingIntervalDiagnosticsDataType;
      }
    };
    exports2.SamplingIntervalDiagnosticsDataType = SamplingIntervalDiagnosticsDataType;
    SamplingIntervalDiagnosticsDataType.possibleFields = [
      "samplingInterval",
      "monitoredItemCount",
      "maxMonitoredItemCount",
      "disabledMonitoredItemCount"
    ];
    SamplingIntervalDiagnosticsDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(856, 0);
    SamplingIntervalDiagnosticsDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(858, 0);
    SamplingIntervalDiagnosticsDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(857, 0);
    SamplingIntervalDiagnosticsDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15365, 0);
    SamplingIntervalDiagnosticsDataType.schema.dataTypeNodeId = SamplingIntervalDiagnosticsDataType.dataTypeNodeId;
    SamplingIntervalDiagnosticsDataType.schema.encodingDefaultBinary = SamplingIntervalDiagnosticsDataType.encodingDefaultBinary;
    SamplingIntervalDiagnosticsDataType.schema.encodingDefaultXml = SamplingIntervalDiagnosticsDataType.encodingDefaultXml;
    SamplingIntervalDiagnosticsDataType.schema.encodingDefaultJson = SamplingIntervalDiagnosticsDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(SamplingIntervalDiagnosticsDataType.dataTypeNodeId, "SamplingIntervalDiagnosticsDataType", SamplingIntervalDiagnosticsDataType);
    var schemaSemanticChangeStructureDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SemanticChangeStructureDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Affected",
          fieldType: "NodeId"
        },
        {
          name: "AffectedType",
          fieldType: "NodeId"
        }
      ]
    });
    var SemanticChangeStructureDataType = class _SemanticChangeStructureDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaSemanticChangeStructureDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.affected = new node_opcua_nodeid_1.NodeId(null);
          this.affectedType = new node_opcua_nodeid_1.NodeId(null);
          return;
        }
        const schema = _SemanticChangeStructureDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.affected = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.affected);
        this.affectedType = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.affectedType);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.affected, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.affectedType, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.affected = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.affected);
        this.affectedType = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.affectedType);
      }
      get schema() {
        return schemaSemanticChangeStructureDataType;
      }
    };
    exports2.SemanticChangeStructureDataType = SemanticChangeStructureDataType;
    SemanticChangeStructureDataType.possibleFields = [
      "affected",
      "affectedType"
    ];
    SemanticChangeStructureDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(897, 0);
    SemanticChangeStructureDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(899, 0);
    SemanticChangeStructureDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(898, 0);
    SemanticChangeStructureDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15374, 0);
    SemanticChangeStructureDataType.schema.dataTypeNodeId = SemanticChangeStructureDataType.dataTypeNodeId;
    SemanticChangeStructureDataType.schema.encodingDefaultBinary = SemanticChangeStructureDataType.encodingDefaultBinary;
    SemanticChangeStructureDataType.schema.encodingDefaultXml = SemanticChangeStructureDataType.encodingDefaultXml;
    SemanticChangeStructureDataType.schema.encodingDefaultJson = SemanticChangeStructureDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(SemanticChangeStructureDataType.dataTypeNodeId, "SemanticChangeStructureDataType", SemanticChangeStructureDataType);
    var schemaServerDiagnosticsSummaryDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ServerDiagnosticsSummaryDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ServerViewCount",
          fieldType: "UInt32"
        },
        {
          name: "CurrentSessionCount",
          fieldType: "UInt32"
        },
        {
          name: "CumulatedSessionCount",
          fieldType: "UInt32"
        },
        {
          name: "SecurityRejectedSessionCount",
          fieldType: "UInt32"
        },
        {
          name: "RejectedSessionCount",
          fieldType: "UInt32"
        },
        {
          name: "SessionTimeoutCount",
          fieldType: "UInt32"
        },
        {
          name: "SessionAbortCount",
          fieldType: "UInt32"
        },
        {
          name: "CurrentSubscriptionCount",
          fieldType: "UInt32"
        },
        {
          name: "CumulatedSubscriptionCount",
          fieldType: "UInt32"
        },
        {
          name: "PublishingIntervalCount",
          fieldType: "UInt32"
        },
        {
          name: "SecurityRejectedRequestsCount",
          fieldType: "UInt32"
        },
        {
          name: "RejectedRequestsCount",
          fieldType: "UInt32"
        }
      ]
    });
    var ServerDiagnosticsSummaryDataType = class _ServerDiagnosticsSummaryDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaServerDiagnosticsSummaryDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.serverViewCount = 0;
          this.currentSessionCount = 0;
          this.cumulatedSessionCount = 0;
          this.securityRejectedSessionCount = 0;
          this.rejectedSessionCount = 0;
          this.sessionTimeoutCount = 0;
          this.sessionAbortCount = 0;
          this.currentSubscriptionCount = 0;
          this.cumulatedSubscriptionCount = 0;
          this.publishingIntervalCount = 0;
          this.securityRejectedRequestsCount = 0;
          this.rejectedRequestsCount = 0;
          return;
        }
        const schema = _ServerDiagnosticsSummaryDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.serverViewCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.serverViewCount);
        this.currentSessionCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.currentSessionCount);
        this.cumulatedSessionCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.cumulatedSessionCount);
        this.securityRejectedSessionCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.securityRejectedSessionCount);
        this.rejectedSessionCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.rejectedSessionCount);
        this.sessionTimeoutCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.sessionTimeoutCount);
        this.sessionAbortCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.sessionAbortCount);
        this.currentSubscriptionCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[7], options?.currentSubscriptionCount);
        this.cumulatedSubscriptionCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[8], options?.cumulatedSubscriptionCount);
        this.publishingIntervalCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[9], options?.publishingIntervalCount);
        this.securityRejectedRequestsCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[10], options?.securityRejectedRequestsCount);
        this.rejectedRequestsCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[11], options?.rejectedRequestsCount);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.serverViewCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.currentSessionCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.cumulatedSessionCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.securityRejectedSessionCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.rejectedSessionCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.sessionTimeoutCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.sessionAbortCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.currentSubscriptionCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.cumulatedSubscriptionCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.publishingIntervalCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.securityRejectedRequestsCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.rejectedRequestsCount, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.serverViewCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.serverViewCount);
        this.currentSessionCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.currentSessionCount);
        this.cumulatedSessionCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.cumulatedSessionCount);
        this.securityRejectedSessionCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.securityRejectedSessionCount);
        this.rejectedSessionCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.rejectedSessionCount);
        this.sessionTimeoutCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.sessionTimeoutCount);
        this.sessionAbortCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.sessionAbortCount);
        this.currentSubscriptionCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.currentSubscriptionCount);
        this.cumulatedSubscriptionCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.cumulatedSubscriptionCount);
        this.publishingIntervalCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.publishingIntervalCount);
        this.securityRejectedRequestsCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.securityRejectedRequestsCount);
        this.rejectedRequestsCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.rejectedRequestsCount);
      }
      get schema() {
        return schemaServerDiagnosticsSummaryDataType;
      }
    };
    exports2.ServerDiagnosticsSummaryDataType = ServerDiagnosticsSummaryDataType;
    ServerDiagnosticsSummaryDataType.possibleFields = [
      "serverViewCount",
      "currentSessionCount",
      "cumulatedSessionCount",
      "securityRejectedSessionCount",
      "rejectedSessionCount",
      "sessionTimeoutCount",
      "sessionAbortCount",
      "currentSubscriptionCount",
      "cumulatedSubscriptionCount",
      "publishingIntervalCount",
      "securityRejectedRequestsCount",
      "rejectedRequestsCount"
    ];
    ServerDiagnosticsSummaryDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(859, 0);
    ServerDiagnosticsSummaryDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(861, 0);
    ServerDiagnosticsSummaryDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(860, 0);
    ServerDiagnosticsSummaryDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15366, 0);
    ServerDiagnosticsSummaryDataType.schema.dataTypeNodeId = ServerDiagnosticsSummaryDataType.dataTypeNodeId;
    ServerDiagnosticsSummaryDataType.schema.encodingDefaultBinary = ServerDiagnosticsSummaryDataType.encodingDefaultBinary;
    ServerDiagnosticsSummaryDataType.schema.encodingDefaultXml = ServerDiagnosticsSummaryDataType.encodingDefaultXml;
    ServerDiagnosticsSummaryDataType.schema.encodingDefaultJson = ServerDiagnosticsSummaryDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ServerDiagnosticsSummaryDataType.dataTypeNodeId, "ServerDiagnosticsSummaryDataType", ServerDiagnosticsSummaryDataType);
    var schemaServerStatusDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ServerStatusDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "StartTime",
          fieldType: "DateTime"
        },
        {
          name: "CurrentTime",
          fieldType: "DateTime"
        },
        {
          name: "State",
          fieldType: "ServerState"
        },
        {
          name: "BuildInfo",
          fieldType: "BuildInfo"
        },
        {
          name: "SecondsTillShutdown",
          fieldType: "UInt32"
        },
        {
          name: "ShutdownReason",
          fieldType: "LocalizedText"
        }
      ]
    });
    var ServerStatusDataType = class _ServerStatusDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaServerStatusDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.startTime = /* @__PURE__ */ new Date();
          this.currentTime = /* @__PURE__ */ new Date();
          this.state = 0;
          this.buildInfo = new BuildInfo(null);
          this.secondsTillShutdown = 0;
          this.shutdownReason = new node_opcua_data_model_1.LocalizedText(null);
          return;
        }
        const schema = _ServerStatusDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.startTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.startTime);
        this.currentTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.currentTime);
        this.state = this.setState((0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.state));
        this.buildInfo = new BuildInfo(options.buildInfo);
        this.secondsTillShutdown = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.secondsTillShutdown);
        this.shutdownReason = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.shutdownReason);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.startTime, stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.currentTime, stream);
        encodeServerState(this.state, stream);
        this.buildInfo.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.secondsTillShutdown, stream);
        (0, node_opcua_data_model_1.encodeLocalizedText)(this.shutdownReason, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.startTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.startTime);
        this.currentTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.currentTime);
        this.state = decodeServerState(stream, this.state);
        this.buildInfo.decode(stream);
        this.secondsTillShutdown = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.secondsTillShutdown);
        this.shutdownReason = (0, node_opcua_data_model_1.decodeLocalizedText)(stream, this.shutdownReason);
      }
      // Define Enumeration setters
      setState(value) {
        const coercedValue = exports2._enumerationServerState.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to ServerState :" + value);
        }
        this.state = coercedValue.value;
        return this.state;
      }
      get schema() {
        return schemaServerStatusDataType;
      }
    };
    exports2.ServerStatusDataType = ServerStatusDataType;
    ServerStatusDataType.possibleFields = [
      "startTime",
      "currentTime",
      "state",
      "buildInfo",
      "secondsTillShutdown",
      "shutdownReason"
    ];
    ServerStatusDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(862, 0);
    ServerStatusDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(864, 0);
    ServerStatusDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(863, 0);
    ServerStatusDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15367, 0);
    ServerStatusDataType.schema.dataTypeNodeId = ServerStatusDataType.dataTypeNodeId;
    ServerStatusDataType.schema.encodingDefaultBinary = ServerStatusDataType.encodingDefaultBinary;
    ServerStatusDataType.schema.encodingDefaultXml = ServerStatusDataType.encodingDefaultXml;
    ServerStatusDataType.schema.encodingDefaultJson = ServerStatusDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ServerStatusDataType.dataTypeNodeId, "ServerStatusDataType", ServerStatusDataType);
    var schemaServiceCounterDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ServiceCounterDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "TotalCount",
          fieldType: "UInt32"
        },
        {
          name: "ErrorCount",
          fieldType: "UInt32"
        }
      ]
    });
    var ServiceCounterDataType = class _ServiceCounterDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaServiceCounterDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.totalCount = 0;
          this.errorCount = 0;
          return;
        }
        const schema = _ServiceCounterDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.totalCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.totalCount);
        this.errorCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.errorCount);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.totalCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.errorCount, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.totalCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.totalCount);
        this.errorCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.errorCount);
      }
      get schema() {
        return schemaServiceCounterDataType;
      }
    };
    exports2.ServiceCounterDataType = ServiceCounterDataType;
    ServiceCounterDataType.possibleFields = [
      "totalCount",
      "errorCount"
    ];
    ServiceCounterDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(871, 0);
    ServiceCounterDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(873, 0);
    ServiceCounterDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(872, 0);
    ServiceCounterDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15370, 0);
    ServiceCounterDataType.schema.dataTypeNodeId = ServiceCounterDataType.dataTypeNodeId;
    ServiceCounterDataType.schema.encodingDefaultBinary = ServiceCounterDataType.encodingDefaultBinary;
    ServiceCounterDataType.schema.encodingDefaultXml = ServiceCounterDataType.encodingDefaultXml;
    ServiceCounterDataType.schema.encodingDefaultJson = ServiceCounterDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ServiceCounterDataType.dataTypeNodeId, "ServiceCounterDataType", ServiceCounterDataType);
    var schemaServiceFault = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ServiceFault",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        }
      ]
    });
    var ServiceFault = class _ServiceFault extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaServiceFault;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          return;
        }
        const schema = _ServiceFault.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
      }
      get schema() {
        return schemaServiceFault;
      }
    };
    exports2.ServiceFault = ServiceFault;
    ServiceFault.possibleFields = [
      "responseHeader"
    ];
    ServiceFault.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(395, 0);
    ServiceFault.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(397, 0);
    ServiceFault.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(396, 0);
    ServiceFault.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15090, 0);
    ServiceFault.schema.dataTypeNodeId = ServiceFault.dataTypeNodeId;
    ServiceFault.schema.encodingDefaultBinary = ServiceFault.encodingDefaultBinary;
    ServiceFault.schema.encodingDefaultXml = ServiceFault.encodingDefaultXml;
    ServiceFault.schema.encodingDefaultJson = ServiceFault.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ServiceFault.dataTypeNodeId, "ServiceFault", ServiceFault);
    var schemaSessionDiagnosticsDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SessionDiagnosticsDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "SessionId",
          fieldType: "NodeId"
        },
        {
          name: "SessionName",
          fieldType: "String"
        },
        {
          name: "ClientDescription",
          fieldType: "ApplicationDescription"
        },
        {
          name: "ServerUri",
          fieldType: "String"
        },
        {
          name: "EndpointUrl",
          fieldType: "String"
        },
        {
          name: "LocaleIds",
          fieldType: "String",
          isArray: true
        },
        {
          name: "ActualSessionTimeout",
          fieldType: "Double"
        },
        {
          name: "MaxResponseMessageSize",
          fieldType: "UInt32"
        },
        {
          name: "ClientConnectionTime",
          fieldType: "DateTime"
        },
        {
          name: "ClientLastContactTime",
          fieldType: "DateTime"
        },
        {
          name: "CurrentSubscriptionsCount",
          fieldType: "UInt32"
        },
        {
          name: "CurrentMonitoredItemsCount",
          fieldType: "UInt32"
        },
        {
          name: "CurrentPublishRequestsInQueue",
          fieldType: "UInt32"
        },
        {
          name: "TotalRequestCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "UnauthorizedRequestCount",
          fieldType: "UInt32"
        },
        {
          name: "ReadCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "HistoryReadCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "WriteCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "HistoryUpdateCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "CallCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "CreateMonitoredItemsCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "ModifyMonitoredItemsCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "SetMonitoringModeCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "SetTriggeringCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "DeleteMonitoredItemsCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "CreateSubscriptionCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "ModifySubscriptionCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "SetPublishingModeCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "PublishCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "RepublishCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "TransferSubscriptionsCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "DeleteSubscriptionsCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "AddNodesCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "AddReferencesCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "DeleteNodesCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "DeleteReferencesCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "BrowseCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "BrowseNextCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "TranslateBrowsePathsToNodeIdsCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "QueryFirstCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "QueryNextCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "RegisterNodesCount",
          fieldType: "ServiceCounterDataType"
        },
        {
          name: "UnregisterNodesCount",
          fieldType: "ServiceCounterDataType"
        }
      ]
    });
    var SessionDiagnosticsDataType = class _SessionDiagnosticsDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaSessionDiagnosticsDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.sessionId = new node_opcua_nodeid_1.NodeId(null);
          this.sessionName = null;
          this.clientDescription = new ApplicationDescription(null);
          this.serverUri = null;
          this.endpointUrl = null;
          this.localeIds = [];
          this.actualSessionTimeout = 0;
          this.maxResponseMessageSize = 0;
          this.clientConnectionTime = /* @__PURE__ */ new Date();
          this.clientLastContactTime = /* @__PURE__ */ new Date();
          this.currentSubscriptionsCount = 0;
          this.currentMonitoredItemsCount = 0;
          this.currentPublishRequestsInQueue = 0;
          this.totalRequestCount = new ServiceCounterDataType(null);
          this.unauthorizedRequestCount = 0;
          this.readCount = new ServiceCounterDataType(null);
          this.historyReadCount = new ServiceCounterDataType(null);
          this.writeCount = new ServiceCounterDataType(null);
          this.historyUpdateCount = new ServiceCounterDataType(null);
          this.callCount = new ServiceCounterDataType(null);
          this.createMonitoredItemsCount = new ServiceCounterDataType(null);
          this.modifyMonitoredItemsCount = new ServiceCounterDataType(null);
          this.setMonitoringModeCount = new ServiceCounterDataType(null);
          this.setTriggeringCount = new ServiceCounterDataType(null);
          this.deleteMonitoredItemsCount = new ServiceCounterDataType(null);
          this.createSubscriptionCount = new ServiceCounterDataType(null);
          this.modifySubscriptionCount = new ServiceCounterDataType(null);
          this.setPublishingModeCount = new ServiceCounterDataType(null);
          this.publishCount = new ServiceCounterDataType(null);
          this.republishCount = new ServiceCounterDataType(null);
          this.transferSubscriptionsCount = new ServiceCounterDataType(null);
          this.deleteSubscriptionsCount = new ServiceCounterDataType(null);
          this.addNodesCount = new ServiceCounterDataType(null);
          this.addReferencesCount = new ServiceCounterDataType(null);
          this.deleteNodesCount = new ServiceCounterDataType(null);
          this.deleteReferencesCount = new ServiceCounterDataType(null);
          this.browseCount = new ServiceCounterDataType(null);
          this.browseNextCount = new ServiceCounterDataType(null);
          this.translateBrowsePathsToNodeIdsCount = new ServiceCounterDataType(null);
          this.queryFirstCount = new ServiceCounterDataType(null);
          this.queryNextCount = new ServiceCounterDataType(null);
          this.registerNodesCount = new ServiceCounterDataType(null);
          this.unregisterNodesCount = new ServiceCounterDataType(null);
          return;
        }
        const schema = _SessionDiagnosticsDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.sessionId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.sessionId);
        this.sessionName = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.sessionName);
        this.clientDescription = new ApplicationDescription(options.clientDescription);
        this.serverUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.serverUri);
        this.endpointUrl = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.endpointUrl);
        this.localeIds = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[5], options?.localeIds);
        this.actualSessionTimeout = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.actualSessionTimeout);
        this.maxResponseMessageSize = (0, node_opcua_factory_1.initialize_field)(schema.fields[7], options?.maxResponseMessageSize);
        this.clientConnectionTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[8], options?.clientConnectionTime);
        this.clientLastContactTime = (0, node_opcua_factory_1.initialize_field)(schema.fields[9], options?.clientLastContactTime);
        this.currentSubscriptionsCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[10], options?.currentSubscriptionsCount);
        this.currentMonitoredItemsCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[11], options?.currentMonitoredItemsCount);
        this.currentPublishRequestsInQueue = (0, node_opcua_factory_1.initialize_field)(schema.fields[12], options?.currentPublishRequestsInQueue);
        this.totalRequestCount = new ServiceCounterDataType(options.totalRequestCount);
        this.unauthorizedRequestCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[14], options?.unauthorizedRequestCount);
        this.readCount = new ServiceCounterDataType(options.readCount);
        this.historyReadCount = new ServiceCounterDataType(options.historyReadCount);
        this.writeCount = new ServiceCounterDataType(options.writeCount);
        this.historyUpdateCount = new ServiceCounterDataType(options.historyUpdateCount);
        this.callCount = new ServiceCounterDataType(options.callCount);
        this.createMonitoredItemsCount = new ServiceCounterDataType(options.createMonitoredItemsCount);
        this.modifyMonitoredItemsCount = new ServiceCounterDataType(options.modifyMonitoredItemsCount);
        this.setMonitoringModeCount = new ServiceCounterDataType(options.setMonitoringModeCount);
        this.setTriggeringCount = new ServiceCounterDataType(options.setTriggeringCount);
        this.deleteMonitoredItemsCount = new ServiceCounterDataType(options.deleteMonitoredItemsCount);
        this.createSubscriptionCount = new ServiceCounterDataType(options.createSubscriptionCount);
        this.modifySubscriptionCount = new ServiceCounterDataType(options.modifySubscriptionCount);
        this.setPublishingModeCount = new ServiceCounterDataType(options.setPublishingModeCount);
        this.publishCount = new ServiceCounterDataType(options.publishCount);
        this.republishCount = new ServiceCounterDataType(options.republishCount);
        this.transferSubscriptionsCount = new ServiceCounterDataType(options.transferSubscriptionsCount);
        this.deleteSubscriptionsCount = new ServiceCounterDataType(options.deleteSubscriptionsCount);
        this.addNodesCount = new ServiceCounterDataType(options.addNodesCount);
        this.addReferencesCount = new ServiceCounterDataType(options.addReferencesCount);
        this.deleteNodesCount = new ServiceCounterDataType(options.deleteNodesCount);
        this.deleteReferencesCount = new ServiceCounterDataType(options.deleteReferencesCount);
        this.browseCount = new ServiceCounterDataType(options.browseCount);
        this.browseNextCount = new ServiceCounterDataType(options.browseNextCount);
        this.translateBrowsePathsToNodeIdsCount = new ServiceCounterDataType(options.translateBrowsePathsToNodeIdsCount);
        this.queryFirstCount = new ServiceCounterDataType(options.queryFirstCount);
        this.queryNextCount = new ServiceCounterDataType(options.queryNextCount);
        this.registerNodesCount = new ServiceCounterDataType(options.registerNodesCount);
        this.unregisterNodesCount = new ServiceCounterDataType(options.unregisterNodesCount);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.sessionId, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.sessionName, stream);
        this.clientDescription.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.serverUri, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.endpointUrl, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.localeIds, stream, node_opcua_basic_types_1.encodeString);
        (0, node_opcua_basic_types_1.encodeDouble)(this.actualSessionTimeout, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.maxResponseMessageSize, stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.clientConnectionTime, stream);
        (0, node_opcua_basic_types_1.encodeDateTime)(this.clientLastContactTime, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.currentSubscriptionsCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.currentMonitoredItemsCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.currentPublishRequestsInQueue, stream);
        this.totalRequestCount.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.unauthorizedRequestCount, stream);
        this.readCount.encode(stream);
        this.historyReadCount.encode(stream);
        this.writeCount.encode(stream);
        this.historyUpdateCount.encode(stream);
        this.callCount.encode(stream);
        this.createMonitoredItemsCount.encode(stream);
        this.modifyMonitoredItemsCount.encode(stream);
        this.setMonitoringModeCount.encode(stream);
        this.setTriggeringCount.encode(stream);
        this.deleteMonitoredItemsCount.encode(stream);
        this.createSubscriptionCount.encode(stream);
        this.modifySubscriptionCount.encode(stream);
        this.setPublishingModeCount.encode(stream);
        this.publishCount.encode(stream);
        this.republishCount.encode(stream);
        this.transferSubscriptionsCount.encode(stream);
        this.deleteSubscriptionsCount.encode(stream);
        this.addNodesCount.encode(stream);
        this.addReferencesCount.encode(stream);
        this.deleteNodesCount.encode(stream);
        this.deleteReferencesCount.encode(stream);
        this.browseCount.encode(stream);
        this.browseNextCount.encode(stream);
        this.translateBrowsePathsToNodeIdsCount.encode(stream);
        this.queryFirstCount.encode(stream);
        this.queryNextCount.encode(stream);
        this.registerNodesCount.encode(stream);
        this.unregisterNodesCount.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.sessionId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.sessionId);
        this.sessionName = (0, node_opcua_basic_types_1.decodeString)(stream, this.sessionName);
        this.clientDescription.decode(stream);
        this.serverUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.serverUri);
        this.endpointUrl = (0, node_opcua_basic_types_1.decodeString)(stream, this.endpointUrl);
        this.localeIds = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
        this.actualSessionTimeout = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.actualSessionTimeout);
        this.maxResponseMessageSize = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.maxResponseMessageSize);
        this.clientConnectionTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.clientConnectionTime);
        this.clientLastContactTime = (0, node_opcua_basic_types_1.decodeDateTime)(stream, this.clientLastContactTime);
        this.currentSubscriptionsCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.currentSubscriptionsCount);
        this.currentMonitoredItemsCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.currentMonitoredItemsCount);
        this.currentPublishRequestsInQueue = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.currentPublishRequestsInQueue);
        this.totalRequestCount.decode(stream);
        this.unauthorizedRequestCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.unauthorizedRequestCount);
        this.readCount.decode(stream);
        this.historyReadCount.decode(stream);
        this.writeCount.decode(stream);
        this.historyUpdateCount.decode(stream);
        this.callCount.decode(stream);
        this.createMonitoredItemsCount.decode(stream);
        this.modifyMonitoredItemsCount.decode(stream);
        this.setMonitoringModeCount.decode(stream);
        this.setTriggeringCount.decode(stream);
        this.deleteMonitoredItemsCount.decode(stream);
        this.createSubscriptionCount.decode(stream);
        this.modifySubscriptionCount.decode(stream);
        this.setPublishingModeCount.decode(stream);
        this.publishCount.decode(stream);
        this.republishCount.decode(stream);
        this.transferSubscriptionsCount.decode(stream);
        this.deleteSubscriptionsCount.decode(stream);
        this.addNodesCount.decode(stream);
        this.addReferencesCount.decode(stream);
        this.deleteNodesCount.decode(stream);
        this.deleteReferencesCount.decode(stream);
        this.browseCount.decode(stream);
        this.browseNextCount.decode(stream);
        this.translateBrowsePathsToNodeIdsCount.decode(stream);
        this.queryFirstCount.decode(stream);
        this.queryNextCount.decode(stream);
        this.registerNodesCount.decode(stream);
        this.unregisterNodesCount.decode(stream);
      }
      get schema() {
        return schemaSessionDiagnosticsDataType;
      }
    };
    exports2.SessionDiagnosticsDataType = SessionDiagnosticsDataType;
    SessionDiagnosticsDataType.possibleFields = [
      "sessionId",
      "sessionName",
      "clientDescription",
      "serverUri",
      "endpointUrl",
      "localeIds",
      "actualSessionTimeout",
      "maxResponseMessageSize",
      "clientConnectionTime",
      "clientLastContactTime",
      "currentSubscriptionsCount",
      "currentMonitoredItemsCount",
      "currentPublishRequestsInQueue",
      "totalRequestCount",
      "unauthorizedRequestCount",
      "readCount",
      "historyReadCount",
      "writeCount",
      "historyUpdateCount",
      "callCount",
      "createMonitoredItemsCount",
      "modifyMonitoredItemsCount",
      "setMonitoringModeCount",
      "setTriggeringCount",
      "deleteMonitoredItemsCount",
      "createSubscriptionCount",
      "modifySubscriptionCount",
      "setPublishingModeCount",
      "publishCount",
      "republishCount",
      "transferSubscriptionsCount",
      "deleteSubscriptionsCount",
      "addNodesCount",
      "addReferencesCount",
      "deleteNodesCount",
      "deleteReferencesCount",
      "browseCount",
      "browseNextCount",
      "translateBrowsePathsToNodeIdsCount",
      "queryFirstCount",
      "queryNextCount",
      "registerNodesCount",
      "unregisterNodesCount"
    ];
    SessionDiagnosticsDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(865, 0);
    SessionDiagnosticsDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(867, 0);
    SessionDiagnosticsDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(866, 0);
    SessionDiagnosticsDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15368, 0);
    SessionDiagnosticsDataType.schema.dataTypeNodeId = SessionDiagnosticsDataType.dataTypeNodeId;
    SessionDiagnosticsDataType.schema.encodingDefaultBinary = SessionDiagnosticsDataType.encodingDefaultBinary;
    SessionDiagnosticsDataType.schema.encodingDefaultXml = SessionDiagnosticsDataType.encodingDefaultXml;
    SessionDiagnosticsDataType.schema.encodingDefaultJson = SessionDiagnosticsDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(SessionDiagnosticsDataType.dataTypeNodeId, "SessionDiagnosticsDataType", SessionDiagnosticsDataType);
    var schemaSessionSecurityDiagnosticsDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SessionSecurityDiagnosticsDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "SessionId",
          fieldType: "NodeId"
        },
        {
          name: "ClientUserIdOfSession",
          fieldType: "String"
        },
        {
          name: "ClientUserIdHistory",
          fieldType: "String",
          isArray: true
        },
        {
          name: "AuthenticationMechanism",
          fieldType: "String"
        },
        {
          name: "Encoding",
          fieldType: "String"
        },
        {
          name: "TransportProtocol",
          fieldType: "String"
        },
        {
          name: "SecurityMode",
          fieldType: "MessageSecurityMode"
        },
        {
          name: "SecurityPolicyUri",
          fieldType: "String"
        },
        {
          name: "ClientCertificate",
          fieldType: "ByteString"
        }
      ]
    });
    var SessionSecurityDiagnosticsDataType = class _SessionSecurityDiagnosticsDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaSessionSecurityDiagnosticsDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.sessionId = new node_opcua_nodeid_1.NodeId(null);
          this.clientUserIdOfSession = null;
          this.clientUserIdHistory = [];
          this.authenticationMechanism = null;
          this.encoding = null;
          this.transportProtocol = null;
          this.securityMode = 0;
          this.securityPolicyUri = null;
          this.clientCertificate = Buffer.alloc(0);
          return;
        }
        const schema = _SessionSecurityDiagnosticsDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.sessionId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.sessionId);
        this.clientUserIdOfSession = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.clientUserIdOfSession);
        this.clientUserIdHistory = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.clientUserIdHistory);
        this.authenticationMechanism = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.authenticationMechanism);
        this.encoding = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.encoding);
        this.transportProtocol = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.transportProtocol);
        this.securityMode = this.setSecurityMode((0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.securityMode));
        this.securityPolicyUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[7], options?.securityPolicyUri);
        this.clientCertificate = (0, node_opcua_factory_1.initialize_field)(schema.fields[8], options?.clientCertificate);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.sessionId, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.clientUserIdOfSession, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.clientUserIdHistory, stream, node_opcua_basic_types_1.encodeString);
        (0, node_opcua_basic_types_1.encodeString)(this.authenticationMechanism, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.encoding, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.transportProtocol, stream);
        encodeMessageSecurityMode(this.securityMode, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.securityPolicyUri, stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.clientCertificate, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.sessionId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.sessionId);
        this.clientUserIdOfSession = (0, node_opcua_basic_types_1.decodeString)(stream, this.clientUserIdOfSession);
        this.clientUserIdHistory = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
        this.authenticationMechanism = (0, node_opcua_basic_types_1.decodeString)(stream, this.authenticationMechanism);
        this.encoding = (0, node_opcua_basic_types_1.decodeString)(stream, this.encoding);
        this.transportProtocol = (0, node_opcua_basic_types_1.decodeString)(stream, this.transportProtocol);
        this.securityMode = decodeMessageSecurityMode(stream, this.securityMode);
        this.securityPolicyUri = (0, node_opcua_basic_types_1.decodeString)(stream, this.securityPolicyUri);
        this.clientCertificate = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.clientCertificate);
      }
      // Define Enumeration setters
      setSecurityMode(value) {
        const coercedValue = exports2._enumerationMessageSecurityMode.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to MessageSecurityMode :" + value);
        }
        this.securityMode = coercedValue.value;
        return this.securityMode;
      }
      get schema() {
        return schemaSessionSecurityDiagnosticsDataType;
      }
    };
    exports2.SessionSecurityDiagnosticsDataType = SessionSecurityDiagnosticsDataType;
    SessionSecurityDiagnosticsDataType.possibleFields = [
      "sessionId",
      "clientUserIdOfSession",
      "clientUserIdHistory",
      "authenticationMechanism",
      "encoding",
      "transportProtocol",
      "securityMode",
      "securityPolicyUri",
      "clientCertificate"
    ];
    SessionSecurityDiagnosticsDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(868, 0);
    SessionSecurityDiagnosticsDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(870, 0);
    SessionSecurityDiagnosticsDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(869, 0);
    SessionSecurityDiagnosticsDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15369, 0);
    SessionSecurityDiagnosticsDataType.schema.dataTypeNodeId = SessionSecurityDiagnosticsDataType.dataTypeNodeId;
    SessionSecurityDiagnosticsDataType.schema.encodingDefaultBinary = SessionSecurityDiagnosticsDataType.encodingDefaultBinary;
    SessionSecurityDiagnosticsDataType.schema.encodingDefaultXml = SessionSecurityDiagnosticsDataType.encodingDefaultXml;
    SessionSecurityDiagnosticsDataType.schema.encodingDefaultJson = SessionSecurityDiagnosticsDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(SessionSecurityDiagnosticsDataType.dataTypeNodeId, "SessionSecurityDiagnosticsDataType", SessionSecurityDiagnosticsDataType);
    var schemaSessionlessInvokeRequestType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SessionlessInvokeRequestType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "UrisVersion",
          fieldType: "UInt32"
        },
        {
          name: "NamespaceUris",
          fieldType: "String",
          isArray: true
        },
        {
          name: "ServerUris",
          fieldType: "String",
          isArray: true
        },
        {
          name: "LocaleIds",
          fieldType: "String",
          isArray: true
        },
        {
          name: "ServiceId",
          fieldType: "UInt32"
        }
      ]
    });
    var SessionlessInvokeRequestType = class _SessionlessInvokeRequestType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaSessionlessInvokeRequestType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.urisVersion = 0;
          this.namespaceUris = [];
          this.serverUris = [];
          this.localeIds = [];
          this.serviceId = 0;
          return;
        }
        const schema = _SessionlessInvokeRequestType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.urisVersion = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.urisVersion);
        this.namespaceUris = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.namespaceUris);
        this.serverUris = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.serverUris);
        this.localeIds = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[3], options?.localeIds);
        this.serviceId = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.serviceId);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.urisVersion, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.namespaceUris, stream, node_opcua_basic_types_1.encodeString);
        (0, node_opcua_basic_types_1.encodeArray)(this.serverUris, stream, node_opcua_basic_types_1.encodeString);
        (0, node_opcua_basic_types_1.encodeArray)(this.localeIds, stream, node_opcua_basic_types_1.encodeString);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.serviceId, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.urisVersion = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.urisVersion);
        this.namespaceUris = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
        this.serverUris = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
        this.localeIds = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
        this.serviceId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.serviceId);
      }
      get schema() {
        return schemaSessionlessInvokeRequestType;
      }
    };
    exports2.SessionlessInvokeRequestType = SessionlessInvokeRequestType;
    SessionlessInvokeRequestType.possibleFields = [
      "urisVersion",
      "namespaceUris",
      "serverUris",
      "localeIds",
      "serviceId"
    ];
    SessionlessInvokeRequestType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15901, 0);
    SessionlessInvokeRequestType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15903, 0);
    SessionlessInvokeRequestType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15902, 0);
    SessionlessInvokeRequestType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15091, 0);
    SessionlessInvokeRequestType.schema.dataTypeNodeId = SessionlessInvokeRequestType.dataTypeNodeId;
    SessionlessInvokeRequestType.schema.encodingDefaultBinary = SessionlessInvokeRequestType.encodingDefaultBinary;
    SessionlessInvokeRequestType.schema.encodingDefaultXml = SessionlessInvokeRequestType.encodingDefaultXml;
    SessionlessInvokeRequestType.schema.encodingDefaultJson = SessionlessInvokeRequestType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(SessionlessInvokeRequestType.dataTypeNodeId, "SessionlessInvokeRequestType", SessionlessInvokeRequestType);
    var schemaSessionlessInvokeResponseType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SessionlessInvokeResponseType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "NamespaceUris",
          fieldType: "String",
          isArray: true
        },
        {
          name: "ServerUris",
          fieldType: "String",
          isArray: true
        },
        {
          name: "ServiceId",
          fieldType: "UInt32"
        }
      ]
    });
    var SessionlessInvokeResponseType = class _SessionlessInvokeResponseType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaSessionlessInvokeResponseType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.namespaceUris = [];
          this.serverUris = [];
          this.serviceId = 0;
          return;
        }
        const schema = _SessionlessInvokeResponseType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.namespaceUris = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[0], options?.namespaceUris);
        this.serverUris = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.serverUris);
        this.serviceId = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.serviceId);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.namespaceUris, stream, node_opcua_basic_types_1.encodeString);
        (0, node_opcua_basic_types_1.encodeArray)(this.serverUris, stream, node_opcua_basic_types_1.encodeString);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.serviceId, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.namespaceUris = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
        this.serverUris = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeString);
        this.serviceId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.serviceId);
      }
      get schema() {
        return schemaSessionlessInvokeResponseType;
      }
    };
    exports2.SessionlessInvokeResponseType = SessionlessInvokeResponseType;
    SessionlessInvokeResponseType.possibleFields = [
      "namespaceUris",
      "serverUris",
      "serviceId"
    ];
    SessionlessInvokeResponseType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(20999, 0);
    SessionlessInvokeResponseType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(21001, 0);
    SessionlessInvokeResponseType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(21e3, 0);
    SessionlessInvokeResponseType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15092, 0);
    SessionlessInvokeResponseType.schema.dataTypeNodeId = SessionlessInvokeResponseType.dataTypeNodeId;
    SessionlessInvokeResponseType.schema.encodingDefaultBinary = SessionlessInvokeResponseType.encodingDefaultBinary;
    SessionlessInvokeResponseType.schema.encodingDefaultXml = SessionlessInvokeResponseType.encodingDefaultXml;
    SessionlessInvokeResponseType.schema.encodingDefaultJson = SessionlessInvokeResponseType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(SessionlessInvokeResponseType.dataTypeNodeId, "SessionlessInvokeResponseType", SessionlessInvokeResponseType);
    var schemaSetMonitoringModeRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SetMonitoringModeRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "SubscriptionId",
          fieldType: "UInt32"
        },
        {
          name: "MonitoringMode",
          fieldType: "MonitoringMode"
        },
        {
          name: "MonitoredItemIds",
          fieldType: "UInt32",
          isArray: true
        }
      ]
    });
    var SetMonitoringModeRequest = class _SetMonitoringModeRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaSetMonitoringModeRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.subscriptionId = 0;
          this.monitoringMode = 0;
          this.monitoredItemIds = [];
          return;
        }
        const schema = _SetMonitoringModeRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.subscriptionId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.subscriptionId);
        this.monitoringMode = this.setMonitoringMode((0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.monitoringMode));
        this.monitoredItemIds = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[3], options?.monitoredItemIds);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.subscriptionId, stream);
        encodeMonitoringMode(this.monitoringMode, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.monitoredItemIds, stream, node_opcua_basic_types_1.encodeUInt32);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.subscriptionId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.subscriptionId);
        this.monitoringMode = decodeMonitoringMode(stream, this.monitoringMode);
        this.monitoredItemIds = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeUInt32);
      }
      // Define Enumeration setters
      setMonitoringMode(value) {
        const coercedValue = exports2._enumerationMonitoringMode.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to MonitoringMode :" + value);
        }
        this.monitoringMode = coercedValue.value;
        return this.monitoringMode;
      }
      get schema() {
        return schemaSetMonitoringModeRequest;
      }
    };
    exports2.SetMonitoringModeRequest = SetMonitoringModeRequest;
    SetMonitoringModeRequest.possibleFields = [
      "requestHeader",
      "subscriptionId",
      "monitoringMode",
      "monitoredItemIds"
    ];
    SetMonitoringModeRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(767, 0);
    SetMonitoringModeRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(769, 0);
    SetMonitoringModeRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(768, 0);
    SetMonitoringModeRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15329, 0);
    SetMonitoringModeRequest.schema.dataTypeNodeId = SetMonitoringModeRequest.dataTypeNodeId;
    SetMonitoringModeRequest.schema.encodingDefaultBinary = SetMonitoringModeRequest.encodingDefaultBinary;
    SetMonitoringModeRequest.schema.encodingDefaultXml = SetMonitoringModeRequest.encodingDefaultXml;
    SetMonitoringModeRequest.schema.encodingDefaultJson = SetMonitoringModeRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(SetMonitoringModeRequest.dataTypeNodeId, "SetMonitoringModeRequest", SetMonitoringModeRequest);
    var schemaSetMonitoringModeResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SetMonitoringModeResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "Results",
          fieldType: "StatusCode",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var SetMonitoringModeResponse = class _SetMonitoringModeResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaSetMonitoringModeResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.results = [];
          this.diagnosticInfos = [];
          return;
        }
        const schema = _SetMonitoringModeResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.results = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.results);
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.results, stream, node_opcua_status_code_1.encodeStatusCode);
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.results = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_status_code_1.decodeStatusCode);
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaSetMonitoringModeResponse;
      }
    };
    exports2.SetMonitoringModeResponse = SetMonitoringModeResponse;
    SetMonitoringModeResponse.possibleFields = [
      "responseHeader",
      "results",
      "diagnosticInfos"
    ];
    SetMonitoringModeResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(770, 0);
    SetMonitoringModeResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(772, 0);
    SetMonitoringModeResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(771, 0);
    SetMonitoringModeResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15331, 0);
    SetMonitoringModeResponse.schema.dataTypeNodeId = SetMonitoringModeResponse.dataTypeNodeId;
    SetMonitoringModeResponse.schema.encodingDefaultBinary = SetMonitoringModeResponse.encodingDefaultBinary;
    SetMonitoringModeResponse.schema.encodingDefaultXml = SetMonitoringModeResponse.encodingDefaultXml;
    SetMonitoringModeResponse.schema.encodingDefaultJson = SetMonitoringModeResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(SetMonitoringModeResponse.dataTypeNodeId, "SetMonitoringModeResponse", SetMonitoringModeResponse);
    var schemaSetPublishingModeRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SetPublishingModeRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "PublishingEnabled",
          fieldType: "Boolean"
        },
        {
          name: "SubscriptionIds",
          fieldType: "UInt32",
          isArray: true
        }
      ]
    });
    var SetPublishingModeRequest = class _SetPublishingModeRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaSetPublishingModeRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.publishingEnabled = false;
          this.subscriptionIds = [];
          return;
        }
        const schema = _SetPublishingModeRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.publishingEnabled = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.publishingEnabled);
        this.subscriptionIds = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.subscriptionIds);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.publishingEnabled, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.subscriptionIds, stream, node_opcua_basic_types_1.encodeUInt32);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.publishingEnabled = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.publishingEnabled);
        this.subscriptionIds = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeUInt32);
      }
      get schema() {
        return schemaSetPublishingModeRequest;
      }
    };
    exports2.SetPublishingModeRequest = SetPublishingModeRequest;
    SetPublishingModeRequest.possibleFields = [
      "requestHeader",
      "publishingEnabled",
      "subscriptionIds"
    ];
    SetPublishingModeRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(797, 0);
    SetPublishingModeRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(799, 0);
    SetPublishingModeRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(798, 0);
    SetPublishingModeRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15341, 0);
    SetPublishingModeRequest.schema.dataTypeNodeId = SetPublishingModeRequest.dataTypeNodeId;
    SetPublishingModeRequest.schema.encodingDefaultBinary = SetPublishingModeRequest.encodingDefaultBinary;
    SetPublishingModeRequest.schema.encodingDefaultXml = SetPublishingModeRequest.encodingDefaultXml;
    SetPublishingModeRequest.schema.encodingDefaultJson = SetPublishingModeRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(SetPublishingModeRequest.dataTypeNodeId, "SetPublishingModeRequest", SetPublishingModeRequest);
    var schemaSetPublishingModeResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SetPublishingModeResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "Results",
          fieldType: "StatusCode",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var SetPublishingModeResponse = class _SetPublishingModeResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaSetPublishingModeResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.results = [];
          this.diagnosticInfos = [];
          return;
        }
        const schema = _SetPublishingModeResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.results = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.results);
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.results, stream, node_opcua_status_code_1.encodeStatusCode);
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.results = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_status_code_1.decodeStatusCode);
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaSetPublishingModeResponse;
      }
    };
    exports2.SetPublishingModeResponse = SetPublishingModeResponse;
    SetPublishingModeResponse.possibleFields = [
      "responseHeader",
      "results",
      "diagnosticInfos"
    ];
    SetPublishingModeResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(800, 0);
    SetPublishingModeResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(802, 0);
    SetPublishingModeResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(801, 0);
    SetPublishingModeResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15342, 0);
    SetPublishingModeResponse.schema.dataTypeNodeId = SetPublishingModeResponse.dataTypeNodeId;
    SetPublishingModeResponse.schema.encodingDefaultBinary = SetPublishingModeResponse.encodingDefaultBinary;
    SetPublishingModeResponse.schema.encodingDefaultXml = SetPublishingModeResponse.encodingDefaultXml;
    SetPublishingModeResponse.schema.encodingDefaultJson = SetPublishingModeResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(SetPublishingModeResponse.dataTypeNodeId, "SetPublishingModeResponse", SetPublishingModeResponse);
    var schemaSetTriggeringRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SetTriggeringRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "SubscriptionId",
          fieldType: "UInt32"
        },
        {
          name: "TriggeringItemId",
          fieldType: "UInt32"
        },
        {
          name: "LinksToAdd",
          fieldType: "UInt32",
          isArray: true
        },
        {
          name: "LinksToRemove",
          fieldType: "UInt32",
          isArray: true
        }
      ]
    });
    var SetTriggeringRequest = class _SetTriggeringRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaSetTriggeringRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.subscriptionId = 0;
          this.triggeringItemId = 0;
          this.linksToAdd = [];
          this.linksToRemove = [];
          return;
        }
        const schema = _SetTriggeringRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.subscriptionId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.subscriptionId);
        this.triggeringItemId = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.triggeringItemId);
        this.linksToAdd = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[3], options?.linksToAdd);
        this.linksToRemove = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[4], options?.linksToRemove);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.subscriptionId, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.triggeringItemId, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.linksToAdd, stream, node_opcua_basic_types_1.encodeUInt32);
        (0, node_opcua_basic_types_1.encodeArray)(this.linksToRemove, stream, node_opcua_basic_types_1.encodeUInt32);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.subscriptionId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.subscriptionId);
        this.triggeringItemId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.triggeringItemId);
        this.linksToAdd = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeUInt32);
        this.linksToRemove = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeUInt32);
      }
      get schema() {
        return schemaSetTriggeringRequest;
      }
    };
    exports2.SetTriggeringRequest = SetTriggeringRequest;
    SetTriggeringRequest.possibleFields = [
      "requestHeader",
      "subscriptionId",
      "triggeringItemId",
      "linksToAdd",
      "linksToRemove"
    ];
    SetTriggeringRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(773, 0);
    SetTriggeringRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(775, 0);
    SetTriggeringRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(774, 0);
    SetTriggeringRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15332, 0);
    SetTriggeringRequest.schema.dataTypeNodeId = SetTriggeringRequest.dataTypeNodeId;
    SetTriggeringRequest.schema.encodingDefaultBinary = SetTriggeringRequest.encodingDefaultBinary;
    SetTriggeringRequest.schema.encodingDefaultXml = SetTriggeringRequest.encodingDefaultXml;
    SetTriggeringRequest.schema.encodingDefaultJson = SetTriggeringRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(SetTriggeringRequest.dataTypeNodeId, "SetTriggeringRequest", SetTriggeringRequest);
    var schemaSetTriggeringResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SetTriggeringResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "AddResults",
          fieldType: "StatusCode",
          isArray: true
        },
        {
          name: "AddDiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        },
        {
          name: "RemoveResults",
          fieldType: "StatusCode",
          isArray: true
        },
        {
          name: "RemoveDiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var SetTriggeringResponse = class _SetTriggeringResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaSetTriggeringResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.addResults = [];
          this.addDiagnosticInfos = [];
          this.removeResults = [];
          this.removeDiagnosticInfos = [];
          return;
        }
        const schema = _SetTriggeringResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.addResults = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.addResults);
        this.addDiagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.addDiagnosticInfos);
        this.removeResults = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[3], options?.removeResults);
        this.removeDiagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[4], options?.removeDiagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.addResults, stream, node_opcua_status_code_1.encodeStatusCode);
        (0, node_opcua_basic_types_1.encodeArray)(this.addDiagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
        (0, node_opcua_basic_types_1.encodeArray)(this.removeResults, stream, node_opcua_status_code_1.encodeStatusCode);
        (0, node_opcua_basic_types_1.encodeArray)(this.removeDiagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.addResults = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_status_code_1.decodeStatusCode);
        this.addDiagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
        this.removeResults = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_status_code_1.decodeStatusCode);
        this.removeDiagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaSetTriggeringResponse;
      }
    };
    exports2.SetTriggeringResponse = SetTriggeringResponse;
    SetTriggeringResponse.possibleFields = [
      "responseHeader",
      "addResults",
      "addDiagnosticInfos",
      "removeResults",
      "removeDiagnosticInfos"
    ];
    SetTriggeringResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(776, 0);
    SetTriggeringResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(778, 0);
    SetTriggeringResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(777, 0);
    SetTriggeringResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15333, 0);
    SetTriggeringResponse.schema.dataTypeNodeId = SetTriggeringResponse.dataTypeNodeId;
    SetTriggeringResponse.schema.encodingDefaultBinary = SetTriggeringResponse.encodingDefaultBinary;
    SetTriggeringResponse.schema.encodingDefaultXml = SetTriggeringResponse.encodingDefaultXml;
    SetTriggeringResponse.schema.encodingDefaultJson = SetTriggeringResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(SetTriggeringResponse.dataTypeNodeId, "SetTriggeringResponse", SetTriggeringResponse);
    var schemaStandaloneSubscribedDataSetRefDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "StandaloneSubscribedDataSetRefDataType",
      baseType: "SubscribedDataSetDataType",
      fields: [
        {
          name: "DataSetName",
          fieldType: "String"
        }
      ]
    });
    var StandaloneSubscribedDataSetRefDataType = class _StandaloneSubscribedDataSetRefDataType extends SubscribedDataSetDataType {
      static get schema() {
        return schemaStandaloneSubscribedDataSetRefDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.dataSetName = null;
          return;
        }
        const schema = _StandaloneSubscribedDataSetRefDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.dataSetName = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.dataSetName);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.dataSetName, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.dataSetName = (0, node_opcua_basic_types_1.decodeString)(stream, this.dataSetName);
      }
      get schema() {
        return schemaStandaloneSubscribedDataSetRefDataType;
      }
    };
    exports2.StandaloneSubscribedDataSetRefDataType = StandaloneSubscribedDataSetRefDataType;
    StandaloneSubscribedDataSetRefDataType.possibleFields = [
      "dataSetName"
    ];
    StandaloneSubscribedDataSetRefDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23599, 0);
    StandaloneSubscribedDataSetRefDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23851, 0);
    StandaloneSubscribedDataSetRefDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23919, 0);
    StandaloneSubscribedDataSetRefDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23987, 0);
    StandaloneSubscribedDataSetRefDataType.schema.dataTypeNodeId = StandaloneSubscribedDataSetRefDataType.dataTypeNodeId;
    StandaloneSubscribedDataSetRefDataType.schema.encodingDefaultBinary = StandaloneSubscribedDataSetRefDataType.encodingDefaultBinary;
    StandaloneSubscribedDataSetRefDataType.schema.encodingDefaultXml = StandaloneSubscribedDataSetRefDataType.encodingDefaultXml;
    StandaloneSubscribedDataSetRefDataType.schema.encodingDefaultJson = StandaloneSubscribedDataSetRefDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(StandaloneSubscribedDataSetRefDataType.dataTypeNodeId, "StandaloneSubscribedDataSetRefDataType", StandaloneSubscribedDataSetRefDataType);
    var schemaStatusChangeNotification = (0, node_opcua_factory_1.buildStructuredType)({
      name: "StatusChangeNotification",
      baseType: "NotificationData",
      fields: [
        {
          name: "Status",
          fieldType: "StatusCode"
        },
        {
          name: "DiagnosticInfo",
          fieldType: "DiagnosticInfo"
        }
      ]
    });
    var StatusChangeNotification = class _StatusChangeNotification extends NotificationData {
      static get schema() {
        return schemaStatusChangeNotification;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.status = node_opcua_status_code_1.StatusCodes.Good;
          this.diagnosticInfo = null;
          return;
        }
        const schema = _StatusChangeNotification.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.status = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.status);
        this.diagnosticInfo = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.diagnosticInfo);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_status_code_1.encodeStatusCode)(this.status, stream);
        (0, node_opcua_data_model_1.encodeDiagnosticInfo)(this.diagnosticInfo, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.status = (0, node_opcua_status_code_1.decodeStatusCode)(stream, this.status);
        this.diagnosticInfo = (0, node_opcua_data_model_1.decodeDiagnosticInfo)(stream, this.diagnosticInfo);
      }
      get schema() {
        return schemaStatusChangeNotification;
      }
    };
    exports2.StatusChangeNotification = StatusChangeNotification;
    StatusChangeNotification.possibleFields = [
      "status",
      "diagnosticInfo"
    ];
    StatusChangeNotification.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(818, 0);
    StatusChangeNotification.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(820, 0);
    StatusChangeNotification.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(819, 0);
    StatusChangeNotification.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15350, 0);
    StatusChangeNotification.schema.dataTypeNodeId = StatusChangeNotification.dataTypeNodeId;
    StatusChangeNotification.schema.encodingDefaultBinary = StatusChangeNotification.encodingDefaultBinary;
    StatusChangeNotification.schema.encodingDefaultXml = StatusChangeNotification.encodingDefaultXml;
    StatusChangeNotification.schema.encodingDefaultJson = StatusChangeNotification.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(StatusChangeNotification.dataTypeNodeId, "StatusChangeNotification", StatusChangeNotification);
    var schemaSubscribedDataSetMirrorDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SubscribedDataSetMirrorDataType",
      baseType: "SubscribedDataSetDataType",
      fields: [
        {
          name: "ParentNodeName",
          fieldType: "String"
        },
        {
          name: "RolePermissions",
          fieldType: "RolePermissionType",
          isArray: true
        }
      ]
    });
    var SubscribedDataSetMirrorDataType = class _SubscribedDataSetMirrorDataType extends SubscribedDataSetDataType {
      static get schema() {
        return schemaSubscribedDataSetMirrorDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.parentNodeName = null;
          this.rolePermissions = null;
          return;
        }
        const schema = _SubscribedDataSetMirrorDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.parentNodeName = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.parentNodeName);
        this.rolePermissions = [];
        if (options.rolePermissions) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.rolePermissions));
          this.rolePermissions = options.rolePermissions.map((e) => new RolePermissionType(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.parentNodeName, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.rolePermissions, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.parentNodeName = (0, node_opcua_basic_types_1.decodeString)(stream, this.parentNodeName);
        this.rolePermissions = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new RolePermissionType(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaSubscribedDataSetMirrorDataType;
      }
    };
    exports2.SubscribedDataSetMirrorDataType = SubscribedDataSetMirrorDataType;
    SubscribedDataSetMirrorDataType.possibleFields = [
      "parentNodeName",
      "rolePermissions"
    ];
    SubscribedDataSetMirrorDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15635, 0);
    SubscribedDataSetMirrorDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15713, 0);
    SubscribedDataSetMirrorDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16012, 0);
    SubscribedDataSetMirrorDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16311, 0);
    SubscribedDataSetMirrorDataType.schema.dataTypeNodeId = SubscribedDataSetMirrorDataType.dataTypeNodeId;
    SubscribedDataSetMirrorDataType.schema.encodingDefaultBinary = SubscribedDataSetMirrorDataType.encodingDefaultBinary;
    SubscribedDataSetMirrorDataType.schema.encodingDefaultXml = SubscribedDataSetMirrorDataType.encodingDefaultXml;
    SubscribedDataSetMirrorDataType.schema.encodingDefaultJson = SubscribedDataSetMirrorDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(SubscribedDataSetMirrorDataType.dataTypeNodeId, "SubscribedDataSetMirrorDataType", SubscribedDataSetMirrorDataType);
    var schemaSubscriptionDiagnosticsDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SubscriptionDiagnosticsDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "SessionId",
          fieldType: "NodeId"
        },
        {
          name: "SubscriptionId",
          fieldType: "UInt32"
        },
        {
          name: "Priority",
          fieldType: "Byte"
        },
        {
          name: "PublishingInterval",
          fieldType: "Double"
        },
        {
          name: "MaxKeepAliveCount",
          fieldType: "UInt32"
        },
        {
          name: "MaxLifetimeCount",
          fieldType: "UInt32"
        },
        {
          name: "MaxNotificationsPerPublish",
          fieldType: "UInt32"
        },
        {
          name: "PublishingEnabled",
          fieldType: "Boolean"
        },
        {
          name: "ModifyCount",
          fieldType: "UInt32"
        },
        {
          name: "EnableCount",
          fieldType: "UInt32"
        },
        {
          name: "DisableCount",
          fieldType: "UInt32"
        },
        {
          name: "RepublishRequestCount",
          fieldType: "UInt32"
        },
        {
          name: "RepublishMessageRequestCount",
          fieldType: "UInt32"
        },
        {
          name: "RepublishMessageCount",
          fieldType: "UInt32"
        },
        {
          name: "TransferRequestCount",
          fieldType: "UInt32"
        },
        {
          name: "TransferredToAltClientCount",
          fieldType: "UInt32"
        },
        {
          name: "TransferredToSameClientCount",
          fieldType: "UInt32"
        },
        {
          name: "PublishRequestCount",
          fieldType: "UInt32"
        },
        {
          name: "DataChangeNotificationsCount",
          fieldType: "UInt32"
        },
        {
          name: "EventNotificationsCount",
          fieldType: "UInt32"
        },
        {
          name: "NotificationsCount",
          fieldType: "UInt32"
        },
        {
          name: "LatePublishRequestCount",
          fieldType: "UInt32"
        },
        {
          name: "CurrentKeepAliveCount",
          fieldType: "UInt32"
        },
        {
          name: "CurrentLifetimeCount",
          fieldType: "UInt32"
        },
        {
          name: "UnacknowledgedMessageCount",
          fieldType: "UInt32"
        },
        {
          name: "DiscardedMessageCount",
          fieldType: "UInt32"
        },
        {
          name: "MonitoredItemCount",
          fieldType: "UInt32"
        },
        {
          name: "DisabledMonitoredItemCount",
          fieldType: "UInt32"
        },
        {
          name: "MonitoringQueueOverflowCount",
          fieldType: "UInt32"
        },
        {
          name: "NextSequenceNumber",
          fieldType: "UInt32"
        },
        {
          name: "EventQueueOverFlowCount",
          fieldType: "UInt32"
        }
      ]
    });
    var SubscriptionDiagnosticsDataType = class _SubscriptionDiagnosticsDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaSubscriptionDiagnosticsDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.sessionId = new node_opcua_nodeid_1.NodeId(null);
          this.subscriptionId = 0;
          this.priority = 0;
          this.publishingInterval = 0;
          this.maxKeepAliveCount = 0;
          this.maxLifetimeCount = 0;
          this.maxNotificationsPerPublish = 0;
          this.publishingEnabled = false;
          this.modifyCount = 0;
          this.enableCount = 0;
          this.disableCount = 0;
          this.republishRequestCount = 0;
          this.republishMessageRequestCount = 0;
          this.republishMessageCount = 0;
          this.transferRequestCount = 0;
          this.transferredToAltClientCount = 0;
          this.transferredToSameClientCount = 0;
          this.publishRequestCount = 0;
          this.dataChangeNotificationsCount = 0;
          this.eventNotificationsCount = 0;
          this.notificationsCount = 0;
          this.latePublishRequestCount = 0;
          this.currentKeepAliveCount = 0;
          this.currentLifetimeCount = 0;
          this.unacknowledgedMessageCount = 0;
          this.discardedMessageCount = 0;
          this.monitoredItemCount = 0;
          this.disabledMonitoredItemCount = 0;
          this.monitoringQueueOverflowCount = 0;
          this.nextSequenceNumber = 0;
          this.eventQueueOverFlowCount = 0;
          return;
        }
        const schema = _SubscriptionDiagnosticsDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.sessionId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.sessionId);
        this.subscriptionId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.subscriptionId);
        this.priority = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.priority);
        this.publishingInterval = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.publishingInterval);
        this.maxKeepAliveCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.maxKeepAliveCount);
        this.maxLifetimeCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.maxLifetimeCount);
        this.maxNotificationsPerPublish = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.maxNotificationsPerPublish);
        this.publishingEnabled = (0, node_opcua_factory_1.initialize_field)(schema.fields[7], options?.publishingEnabled);
        this.modifyCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[8], options?.modifyCount);
        this.enableCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[9], options?.enableCount);
        this.disableCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[10], options?.disableCount);
        this.republishRequestCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[11], options?.republishRequestCount);
        this.republishMessageRequestCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[12], options?.republishMessageRequestCount);
        this.republishMessageCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[13], options?.republishMessageCount);
        this.transferRequestCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[14], options?.transferRequestCount);
        this.transferredToAltClientCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[15], options?.transferredToAltClientCount);
        this.transferredToSameClientCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[16], options?.transferredToSameClientCount);
        this.publishRequestCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[17], options?.publishRequestCount);
        this.dataChangeNotificationsCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[18], options?.dataChangeNotificationsCount);
        this.eventNotificationsCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[19], options?.eventNotificationsCount);
        this.notificationsCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[20], options?.notificationsCount);
        this.latePublishRequestCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[21], options?.latePublishRequestCount);
        this.currentKeepAliveCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[22], options?.currentKeepAliveCount);
        this.currentLifetimeCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[23], options?.currentLifetimeCount);
        this.unacknowledgedMessageCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[24], options?.unacknowledgedMessageCount);
        this.discardedMessageCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[25], options?.discardedMessageCount);
        this.monitoredItemCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[26], options?.monitoredItemCount);
        this.disabledMonitoredItemCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[27], options?.disabledMonitoredItemCount);
        this.monitoringQueueOverflowCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[28], options?.monitoringQueueOverflowCount);
        this.nextSequenceNumber = (0, node_opcua_factory_1.initialize_field)(schema.fields[29], options?.nextSequenceNumber);
        this.eventQueueOverFlowCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[30], options?.eventQueueOverFlowCount);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.sessionId, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.subscriptionId, stream);
        (0, node_opcua_basic_types_1.encodeByte)(this.priority, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.publishingInterval, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.maxKeepAliveCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.maxLifetimeCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.maxNotificationsPerPublish, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.publishingEnabled, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.modifyCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.enableCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.disableCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.republishRequestCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.republishMessageRequestCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.republishMessageCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.transferRequestCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.transferredToAltClientCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.transferredToSameClientCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.publishRequestCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.dataChangeNotificationsCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.eventNotificationsCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.notificationsCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.latePublishRequestCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.currentKeepAliveCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.currentLifetimeCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.unacknowledgedMessageCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.discardedMessageCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.monitoredItemCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.disabledMonitoredItemCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.monitoringQueueOverflowCount, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.nextSequenceNumber, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.eventQueueOverFlowCount, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.sessionId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.sessionId);
        this.subscriptionId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.subscriptionId);
        this.priority = (0, node_opcua_basic_types_1.decodeByte)(stream, this.priority);
        this.publishingInterval = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.publishingInterval);
        this.maxKeepAliveCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.maxKeepAliveCount);
        this.maxLifetimeCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.maxLifetimeCount);
        this.maxNotificationsPerPublish = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.maxNotificationsPerPublish);
        this.publishingEnabled = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.publishingEnabled);
        this.modifyCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.modifyCount);
        this.enableCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.enableCount);
        this.disableCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.disableCount);
        this.republishRequestCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.republishRequestCount);
        this.republishMessageRequestCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.republishMessageRequestCount);
        this.republishMessageCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.republishMessageCount);
        this.transferRequestCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.transferRequestCount);
        this.transferredToAltClientCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.transferredToAltClientCount);
        this.transferredToSameClientCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.transferredToSameClientCount);
        this.publishRequestCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.publishRequestCount);
        this.dataChangeNotificationsCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.dataChangeNotificationsCount);
        this.eventNotificationsCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.eventNotificationsCount);
        this.notificationsCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.notificationsCount);
        this.latePublishRequestCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.latePublishRequestCount);
        this.currentKeepAliveCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.currentKeepAliveCount);
        this.currentLifetimeCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.currentLifetimeCount);
        this.unacknowledgedMessageCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.unacknowledgedMessageCount);
        this.discardedMessageCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.discardedMessageCount);
        this.monitoredItemCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.monitoredItemCount);
        this.disabledMonitoredItemCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.disabledMonitoredItemCount);
        this.monitoringQueueOverflowCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.monitoringQueueOverflowCount);
        this.nextSequenceNumber = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.nextSequenceNumber);
        this.eventQueueOverFlowCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.eventQueueOverFlowCount);
      }
      get schema() {
        return schemaSubscriptionDiagnosticsDataType;
      }
    };
    exports2.SubscriptionDiagnosticsDataType = SubscriptionDiagnosticsDataType;
    SubscriptionDiagnosticsDataType.possibleFields = [
      "sessionId",
      "subscriptionId",
      "priority",
      "publishingInterval",
      "maxKeepAliveCount",
      "maxLifetimeCount",
      "maxNotificationsPerPublish",
      "publishingEnabled",
      "modifyCount",
      "enableCount",
      "disableCount",
      "republishRequestCount",
      "republishMessageRequestCount",
      "republishMessageCount",
      "transferRequestCount",
      "transferredToAltClientCount",
      "transferredToSameClientCount",
      "publishRequestCount",
      "dataChangeNotificationsCount",
      "eventNotificationsCount",
      "notificationsCount",
      "latePublishRequestCount",
      "currentKeepAliveCount",
      "currentLifetimeCount",
      "unacknowledgedMessageCount",
      "discardedMessageCount",
      "monitoredItemCount",
      "disabledMonitoredItemCount",
      "monitoringQueueOverflowCount",
      "nextSequenceNumber",
      "eventQueueOverFlowCount"
    ];
    SubscriptionDiagnosticsDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(874, 0);
    SubscriptionDiagnosticsDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(876, 0);
    SubscriptionDiagnosticsDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(875, 0);
    SubscriptionDiagnosticsDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15372, 0);
    SubscriptionDiagnosticsDataType.schema.dataTypeNodeId = SubscriptionDiagnosticsDataType.dataTypeNodeId;
    SubscriptionDiagnosticsDataType.schema.encodingDefaultBinary = SubscriptionDiagnosticsDataType.encodingDefaultBinary;
    SubscriptionDiagnosticsDataType.schema.encodingDefaultXml = SubscriptionDiagnosticsDataType.encodingDefaultXml;
    SubscriptionDiagnosticsDataType.schema.encodingDefaultJson = SubscriptionDiagnosticsDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(SubscriptionDiagnosticsDataType.dataTypeNodeId, "SubscriptionDiagnosticsDataType", SubscriptionDiagnosticsDataType);
    var schemaTargetVariablesDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "TargetVariablesDataType",
      baseType: "SubscribedDataSetDataType",
      fields: [
        {
          name: "TargetVariables",
          fieldType: "FieldTargetDataType",
          isArray: true
        }
      ]
    });
    var TargetVariablesDataType = class _TargetVariablesDataType extends SubscribedDataSetDataType {
      static get schema() {
        return schemaTargetVariablesDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.targetVariables = null;
          return;
        }
        const schema = _TargetVariablesDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.targetVariables = [];
        if (options.targetVariables) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.targetVariables));
          this.targetVariables = options.targetVariables.map((e) => new FieldTargetDataType(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.targetVariables, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.targetVariables = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new FieldTargetDataType(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaTargetVariablesDataType;
      }
    };
    exports2.TargetVariablesDataType = TargetVariablesDataType;
    TargetVariablesDataType.possibleFields = [
      "targetVariables"
    ];
    TargetVariablesDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15631, 0);
    TargetVariablesDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15712, 0);
    TargetVariablesDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16011, 0);
    TargetVariablesDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16310, 0);
    TargetVariablesDataType.schema.dataTypeNodeId = TargetVariablesDataType.dataTypeNodeId;
    TargetVariablesDataType.schema.encodingDefaultBinary = TargetVariablesDataType.encodingDefaultBinary;
    TargetVariablesDataType.schema.encodingDefaultXml = TargetVariablesDataType.encodingDefaultXml;
    TargetVariablesDataType.schema.encodingDefaultJson = TargetVariablesDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(TargetVariablesDataType.dataTypeNodeId, "TargetVariablesDataType", TargetVariablesDataType);
    var schemaThreeDCartesianCoordinates = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ThreeDCartesianCoordinates",
      baseType: "CartesianCoordinates",
      fields: [
        {
          name: "X",
          fieldType: "Double"
        },
        {
          name: "Y",
          fieldType: "Double"
        },
        {
          name: "Z",
          fieldType: "Double"
        }
      ]
    });
    var ThreeDCartesianCoordinates = class _ThreeDCartesianCoordinates extends CartesianCoordinates {
      static get schema() {
        return schemaThreeDCartesianCoordinates;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.x = 0;
          this.y = 0;
          this.z = 0;
          return;
        }
        const schema = _ThreeDCartesianCoordinates.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.x = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.x);
        this.y = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.y);
        this.z = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.z);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.x, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.y, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.z, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.x = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.x);
        this.y = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.y);
        this.z = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.z);
      }
      get schema() {
        return schemaThreeDCartesianCoordinates;
      }
    };
    exports2.ThreeDCartesianCoordinates = ThreeDCartesianCoordinates;
    ThreeDCartesianCoordinates.possibleFields = [
      "x",
      "y",
      "z"
    ];
    ThreeDCartesianCoordinates.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18810, 0);
    ThreeDCartesianCoordinates.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18819, 0);
    ThreeDCartesianCoordinates.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18855, 0);
    ThreeDCartesianCoordinates.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(19068, 0);
    ThreeDCartesianCoordinates.schema.dataTypeNodeId = ThreeDCartesianCoordinates.dataTypeNodeId;
    ThreeDCartesianCoordinates.schema.encodingDefaultBinary = ThreeDCartesianCoordinates.encodingDefaultBinary;
    ThreeDCartesianCoordinates.schema.encodingDefaultXml = ThreeDCartesianCoordinates.encodingDefaultXml;
    ThreeDCartesianCoordinates.schema.encodingDefaultJson = ThreeDCartesianCoordinates.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ThreeDCartesianCoordinates.dataTypeNodeId, "ThreeDCartesianCoordinates", ThreeDCartesianCoordinates);
    var schemaThreeDOrientation = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ThreeDOrientation",
      baseType: "Orientation",
      fields: [
        {
          name: "A",
          fieldType: "Double"
        },
        {
          name: "B",
          fieldType: "Double"
        },
        {
          name: "C",
          fieldType: "Double"
        }
      ]
    });
    var ThreeDOrientation = class _ThreeDOrientation extends Orientation {
      static get schema() {
        return schemaThreeDOrientation;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.a = 0;
          this.b = 0;
          this.c = 0;
          return;
        }
        const schema = _ThreeDOrientation.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.a = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.a);
        this.b = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.b);
        this.c = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.c);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.a, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.b, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.c, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.a = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.a);
        this.b = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.b);
        this.c = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.c);
      }
      get schema() {
        return schemaThreeDOrientation;
      }
    };
    exports2.ThreeDOrientation = ThreeDOrientation;
    ThreeDOrientation.possibleFields = [
      "a",
      "b",
      "c"
    ];
    ThreeDOrientation.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18812, 0);
    ThreeDOrientation.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18821, 0);
    ThreeDOrientation.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18857, 0);
    ThreeDOrientation.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(19070, 0);
    ThreeDOrientation.schema.dataTypeNodeId = ThreeDOrientation.dataTypeNodeId;
    ThreeDOrientation.schema.encodingDefaultBinary = ThreeDOrientation.encodingDefaultBinary;
    ThreeDOrientation.schema.encodingDefaultXml = ThreeDOrientation.encodingDefaultXml;
    ThreeDOrientation.schema.encodingDefaultJson = ThreeDOrientation.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ThreeDOrientation.dataTypeNodeId, "ThreeDOrientation", ThreeDOrientation);
    var schemaThreeDFrame = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ThreeDFrame",
      baseType: "Frame",
      fields: [
        {
          name: "CartesianCoordinates",
          fieldType: "ThreeDCartesianCoordinates"
        },
        {
          name: "Orientation",
          fieldType: "ThreeDOrientation"
        }
      ]
    });
    var ThreeDFrame = class _ThreeDFrame extends Frame {
      static get schema() {
        return schemaThreeDFrame;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.cartesianCoordinates = new ThreeDCartesianCoordinates(null);
          this.orientation = new ThreeDOrientation(null);
          return;
        }
        const schema = _ThreeDFrame.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.cartesianCoordinates = new ThreeDCartesianCoordinates(options.cartesianCoordinates);
        this.orientation = new ThreeDOrientation(options.orientation);
      }
      encode(stream) {
        super.encode(stream);
        this.cartesianCoordinates.encode(stream);
        this.orientation.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.cartesianCoordinates.decode(stream);
        this.orientation.decode(stream);
      }
      get schema() {
        return schemaThreeDFrame;
      }
    };
    exports2.ThreeDFrame = ThreeDFrame;
    ThreeDFrame.possibleFields = [
      "cartesianCoordinates",
      "orientation"
    ];
    ThreeDFrame.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18814, 0);
    ThreeDFrame.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18823, 0);
    ThreeDFrame.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18859, 0);
    ThreeDFrame.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(19072, 0);
    ThreeDFrame.schema.dataTypeNodeId = ThreeDFrame.dataTypeNodeId;
    ThreeDFrame.schema.encodingDefaultBinary = ThreeDFrame.encodingDefaultBinary;
    ThreeDFrame.schema.encodingDefaultXml = ThreeDFrame.encodingDefaultXml;
    ThreeDFrame.schema.encodingDefaultJson = ThreeDFrame.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ThreeDFrame.dataTypeNodeId, "ThreeDFrame", ThreeDFrame);
    var schemaVector = (0, node_opcua_factory_1.buildStructuredType)({
      name: "Vector",
      baseType: "ExtensionObject",
      fields: []
    });
    var Vector = class _Vector extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaVector;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _Vector.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaVector;
      }
    };
    exports2.Vector = Vector;
    Vector.possibleFields = [];
    Vector.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18807, 0);
    Vector.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18816, 0);
    Vector.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18852, 0);
    Vector.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(19065, 0);
    Vector.schema.dataTypeNodeId = Vector.dataTypeNodeId;
    Vector.schema.encodingDefaultBinary = Vector.encodingDefaultBinary;
    Vector.schema.encodingDefaultXml = Vector.encodingDefaultXml;
    Vector.schema.encodingDefaultJson = Vector.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(Vector.dataTypeNodeId, "Vector", Vector);
    var schemaThreeDVector = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ThreeDVector",
      baseType: "Vector",
      fields: [
        {
          name: "X",
          fieldType: "Double"
        },
        {
          name: "Y",
          fieldType: "Double"
        },
        {
          name: "Z",
          fieldType: "Double"
        }
      ]
    });
    var ThreeDVector = class _ThreeDVector extends Vector {
      static get schema() {
        return schemaThreeDVector;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.x = 0;
          this.y = 0;
          this.z = 0;
          return;
        }
        const schema = _ThreeDVector.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.x = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.x);
        this.y = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.y);
        this.z = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.z);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.x, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.y, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.z, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.x = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.x);
        this.y = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.y);
        this.z = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.z);
      }
      get schema() {
        return schemaThreeDVector;
      }
    };
    exports2.ThreeDVector = ThreeDVector;
    ThreeDVector.possibleFields = [
      "x",
      "y",
      "z"
    ];
    ThreeDVector.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18808, 0);
    ThreeDVector.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18817, 0);
    ThreeDVector.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(18853, 0);
    ThreeDVector.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(19066, 0);
    ThreeDVector.schema.dataTypeNodeId = ThreeDVector.dataTypeNodeId;
    ThreeDVector.schema.encodingDefaultBinary = ThreeDVector.encodingDefaultBinary;
    ThreeDVector.schema.encodingDefaultXml = ThreeDVector.encodingDefaultXml;
    ThreeDVector.schema.encodingDefaultJson = ThreeDVector.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ThreeDVector.dataTypeNodeId, "ThreeDVector", ThreeDVector);
    var schemaTimeZoneDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "TimeZoneDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Offset",
          fieldType: "Int16"
        },
        {
          name: "DaylightSavingInOffset",
          fieldType: "Boolean"
        }
      ]
    });
    var TimeZoneDataType = class _TimeZoneDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaTimeZoneDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.offset = 0;
          this.daylightSavingInOffset = false;
          return;
        }
        const schema = _TimeZoneDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.offset = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.offset);
        this.daylightSavingInOffset = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.daylightSavingInOffset);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeInt16)(this.offset, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.daylightSavingInOffset, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.offset = (0, node_opcua_basic_types_1.decodeInt16)(stream, this.offset);
        this.daylightSavingInOffset = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.daylightSavingInOffset);
      }
      get schema() {
        return schemaTimeZoneDataType;
      }
    };
    exports2.TimeZoneDataType = TimeZoneDataType;
    TimeZoneDataType.possibleFields = [
      "offset",
      "daylightSavingInOffset"
    ];
    TimeZoneDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(8912, 0);
    TimeZoneDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(8917, 0);
    TimeZoneDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(8913, 0);
    TimeZoneDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15086, 0);
    TimeZoneDataType.schema.dataTypeNodeId = TimeZoneDataType.dataTypeNodeId;
    TimeZoneDataType.schema.encodingDefaultBinary = TimeZoneDataType.encodingDefaultBinary;
    TimeZoneDataType.schema.encodingDefaultXml = TimeZoneDataType.encodingDefaultXml;
    TimeZoneDataType.schema.encodingDefaultJson = TimeZoneDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(TimeZoneDataType.dataTypeNodeId, "TimeZoneDataType", TimeZoneDataType);
    var schemaTransferResult = (0, node_opcua_factory_1.buildStructuredType)({
      name: "TransferResult",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "StatusCode",
          fieldType: "StatusCode"
        },
        {
          name: "AvailableSequenceNumbers",
          fieldType: "UInt32",
          isArray: true
        }
      ]
    });
    var TransferResult = class _TransferResult extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaTransferResult;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.statusCode = node_opcua_status_code_1.StatusCodes.Good;
          this.availableSequenceNumbers = [];
          return;
        }
        const schema = _TransferResult.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.statusCode = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.statusCode);
        this.availableSequenceNumbers = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.availableSequenceNumbers);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_status_code_1.encodeStatusCode)(this.statusCode, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.availableSequenceNumbers, stream, node_opcua_basic_types_1.encodeUInt32);
      }
      decode(stream) {
        super.decode(stream);
        this.statusCode = (0, node_opcua_status_code_1.decodeStatusCode)(stream, this.statusCode);
        this.availableSequenceNumbers = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeUInt32);
      }
      get schema() {
        return schemaTransferResult;
      }
    };
    exports2.TransferResult = TransferResult;
    TransferResult.possibleFields = [
      "statusCode",
      "availableSequenceNumbers"
    ];
    TransferResult.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(836, 0);
    TransferResult.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(838, 0);
    TransferResult.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(837, 0);
    TransferResult.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15356, 0);
    TransferResult.schema.dataTypeNodeId = TransferResult.dataTypeNodeId;
    TransferResult.schema.encodingDefaultBinary = TransferResult.encodingDefaultBinary;
    TransferResult.schema.encodingDefaultXml = TransferResult.encodingDefaultXml;
    TransferResult.schema.encodingDefaultJson = TransferResult.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(TransferResult.dataTypeNodeId, "TransferResult", TransferResult);
    var schemaTransferSubscriptionsRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "TransferSubscriptionsRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "SubscriptionIds",
          fieldType: "UInt32",
          isArray: true
        },
        {
          name: "SendInitialValues",
          fieldType: "Boolean"
        }
      ]
    });
    var TransferSubscriptionsRequest = class _TransferSubscriptionsRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaTransferSubscriptionsRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.subscriptionIds = [];
          this.sendInitialValues = false;
          return;
        }
        const schema = _TransferSubscriptionsRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.subscriptionIds = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.subscriptionIds);
        this.sendInitialValues = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.sendInitialValues);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.subscriptionIds, stream, node_opcua_basic_types_1.encodeUInt32);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.sendInitialValues, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.subscriptionIds = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeUInt32);
        this.sendInitialValues = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.sendInitialValues);
      }
      get schema() {
        return schemaTransferSubscriptionsRequest;
      }
    };
    exports2.TransferSubscriptionsRequest = TransferSubscriptionsRequest;
    TransferSubscriptionsRequest.possibleFields = [
      "requestHeader",
      "subscriptionIds",
      "sendInitialValues"
    ];
    TransferSubscriptionsRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(839, 0);
    TransferSubscriptionsRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(841, 0);
    TransferSubscriptionsRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(840, 0);
    TransferSubscriptionsRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15357, 0);
    TransferSubscriptionsRequest.schema.dataTypeNodeId = TransferSubscriptionsRequest.dataTypeNodeId;
    TransferSubscriptionsRequest.schema.encodingDefaultBinary = TransferSubscriptionsRequest.encodingDefaultBinary;
    TransferSubscriptionsRequest.schema.encodingDefaultXml = TransferSubscriptionsRequest.encodingDefaultXml;
    TransferSubscriptionsRequest.schema.encodingDefaultJson = TransferSubscriptionsRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(TransferSubscriptionsRequest.dataTypeNodeId, "TransferSubscriptionsRequest", TransferSubscriptionsRequest);
    var schemaTransferSubscriptionsResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "TransferSubscriptionsResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "Results",
          fieldType: "TransferResult",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var TransferSubscriptionsResponse = class _TransferSubscriptionsResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaTransferSubscriptionsResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.results = null;
          this.diagnosticInfos = [];
          return;
        }
        const schema = _TransferSubscriptionsResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.results = [];
        if (options.results) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.results));
          this.results = options.results.map((e) => new TransferResult(e));
        }
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.results, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.results = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new TransferResult(null);
          obj.decode(stream1);
          return obj;
        });
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaTransferSubscriptionsResponse;
      }
    };
    exports2.TransferSubscriptionsResponse = TransferSubscriptionsResponse;
    TransferSubscriptionsResponse.possibleFields = [
      "responseHeader",
      "results",
      "diagnosticInfos"
    ];
    TransferSubscriptionsResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(842, 0);
    TransferSubscriptionsResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(844, 0);
    TransferSubscriptionsResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(843, 0);
    TransferSubscriptionsResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15358, 0);
    TransferSubscriptionsResponse.schema.dataTypeNodeId = TransferSubscriptionsResponse.dataTypeNodeId;
    TransferSubscriptionsResponse.schema.encodingDefaultBinary = TransferSubscriptionsResponse.encodingDefaultBinary;
    TransferSubscriptionsResponse.schema.encodingDefaultXml = TransferSubscriptionsResponse.encodingDefaultXml;
    TransferSubscriptionsResponse.schema.encodingDefaultJson = TransferSubscriptionsResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(TransferSubscriptionsResponse.dataTypeNodeId, "TransferSubscriptionsResponse", TransferSubscriptionsResponse);
    var schemaTranslateBrowsePathsToNodeIdsRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "TranslateBrowsePathsToNodeIdsRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "BrowsePaths",
          fieldType: "BrowsePath",
          isArray: true
        }
      ]
    });
    var TranslateBrowsePathsToNodeIdsRequest = class _TranslateBrowsePathsToNodeIdsRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaTranslateBrowsePathsToNodeIdsRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.browsePaths = null;
          return;
        }
        const schema = _TranslateBrowsePathsToNodeIdsRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.browsePaths = [];
        if (options.browsePaths) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.browsePaths));
          this.browsePaths = options.browsePaths.map((e) => new BrowsePath(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.browsePaths, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.browsePaths = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new BrowsePath(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaTranslateBrowsePathsToNodeIdsRequest;
      }
    };
    exports2.TranslateBrowsePathsToNodeIdsRequest = TranslateBrowsePathsToNodeIdsRequest;
    TranslateBrowsePathsToNodeIdsRequest.possibleFields = [
      "requestHeader",
      "browsePaths"
    ];
    TranslateBrowsePathsToNodeIdsRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(552, 0);
    TranslateBrowsePathsToNodeIdsRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(554, 0);
    TranslateBrowsePathsToNodeIdsRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(553, 0);
    TranslateBrowsePathsToNodeIdsRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15193, 0);
    TranslateBrowsePathsToNodeIdsRequest.schema.dataTypeNodeId = TranslateBrowsePathsToNodeIdsRequest.dataTypeNodeId;
    TranslateBrowsePathsToNodeIdsRequest.schema.encodingDefaultBinary = TranslateBrowsePathsToNodeIdsRequest.encodingDefaultBinary;
    TranslateBrowsePathsToNodeIdsRequest.schema.encodingDefaultXml = TranslateBrowsePathsToNodeIdsRequest.encodingDefaultXml;
    TranslateBrowsePathsToNodeIdsRequest.schema.encodingDefaultJson = TranslateBrowsePathsToNodeIdsRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(TranslateBrowsePathsToNodeIdsRequest.dataTypeNodeId, "TranslateBrowsePathsToNodeIdsRequest", TranslateBrowsePathsToNodeIdsRequest);
    var schemaTranslateBrowsePathsToNodeIdsResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "TranslateBrowsePathsToNodeIdsResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "Results",
          fieldType: "BrowsePathResult",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var TranslateBrowsePathsToNodeIdsResponse = class _TranslateBrowsePathsToNodeIdsResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaTranslateBrowsePathsToNodeIdsResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.results = null;
          this.diagnosticInfos = [];
          return;
        }
        const schema = _TranslateBrowsePathsToNodeIdsResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.results = [];
        if (options.results) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.results));
          this.results = options.results.map((e) => new BrowsePathResult(e));
        }
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.results, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.results = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new BrowsePathResult(null);
          obj.decode(stream1);
          return obj;
        });
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaTranslateBrowsePathsToNodeIdsResponse;
      }
    };
    exports2.TranslateBrowsePathsToNodeIdsResponse = TranslateBrowsePathsToNodeIdsResponse;
    TranslateBrowsePathsToNodeIdsResponse.possibleFields = [
      "responseHeader",
      "results",
      "diagnosticInfos"
    ];
    TranslateBrowsePathsToNodeIdsResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(555, 0);
    TranslateBrowsePathsToNodeIdsResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(557, 0);
    TranslateBrowsePathsToNodeIdsResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(556, 0);
    TranslateBrowsePathsToNodeIdsResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15194, 0);
    TranslateBrowsePathsToNodeIdsResponse.schema.dataTypeNodeId = TranslateBrowsePathsToNodeIdsResponse.dataTypeNodeId;
    TranslateBrowsePathsToNodeIdsResponse.schema.encodingDefaultBinary = TranslateBrowsePathsToNodeIdsResponse.encodingDefaultBinary;
    TranslateBrowsePathsToNodeIdsResponse.schema.encodingDefaultXml = TranslateBrowsePathsToNodeIdsResponse.encodingDefaultXml;
    TranslateBrowsePathsToNodeIdsResponse.schema.encodingDefaultJson = TranslateBrowsePathsToNodeIdsResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(TranslateBrowsePathsToNodeIdsResponse.dataTypeNodeId, "TranslateBrowsePathsToNodeIdsResponse", TranslateBrowsePathsToNodeIdsResponse);
    var schemaTransmitQosDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "TransmitQosDataType",
      baseType: "QosDataType",
      fields: []
    });
    var TransmitQosDataType = class _TransmitQosDataType extends QosDataType {
      static get schema() {
        return schemaTransmitQosDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _TransmitQosDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaTransmitQosDataType;
      }
    };
    exports2.TransmitQosDataType = TransmitQosDataType;
    TransmitQosDataType.possibleFields = [];
    TransmitQosDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23604, 0);
    TransmitQosDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23856, 0);
    TransmitQosDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23924, 0);
    TransmitQosDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23992, 0);
    TransmitQosDataType.schema.dataTypeNodeId = TransmitQosDataType.dataTypeNodeId;
    TransmitQosDataType.schema.encodingDefaultBinary = TransmitQosDataType.encodingDefaultBinary;
    TransmitQosDataType.schema.encodingDefaultXml = TransmitQosDataType.encodingDefaultXml;
    TransmitQosDataType.schema.encodingDefaultJson = TransmitQosDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(TransmitQosDataType.dataTypeNodeId, "TransmitQosDataType", TransmitQosDataType);
    var schemaTransmitQosPriorityDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "TransmitQosPriorityDataType",
      baseType: "TransmitQosDataType",
      fields: [
        {
          name: "PriorityLabel",
          fieldType: "String"
        }
      ]
    });
    var TransmitQosPriorityDataType = class _TransmitQosPriorityDataType extends TransmitQosDataType {
      static get schema() {
        return schemaTransmitQosPriorityDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.priorityLabel = null;
          return;
        }
        const schema = _TransmitQosPriorityDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.priorityLabel = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.priorityLabel);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.priorityLabel, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.priorityLabel = (0, node_opcua_basic_types_1.decodeString)(stream, this.priorityLabel);
      }
      get schema() {
        return schemaTransmitQosPriorityDataType;
      }
    };
    exports2.TransmitQosPriorityDataType = TransmitQosPriorityDataType;
    TransmitQosPriorityDataType.possibleFields = [
      "priorityLabel"
    ];
    TransmitQosPriorityDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23605, 0);
    TransmitQosPriorityDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23857, 0);
    TransmitQosPriorityDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23925, 0);
    TransmitQosPriorityDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(23993, 0);
    TransmitQosPriorityDataType.schema.dataTypeNodeId = TransmitQosPriorityDataType.dataTypeNodeId;
    TransmitQosPriorityDataType.schema.encodingDefaultBinary = TransmitQosPriorityDataType.encodingDefaultBinary;
    TransmitQosPriorityDataType.schema.encodingDefaultXml = TransmitQosPriorityDataType.encodingDefaultXml;
    TransmitQosPriorityDataType.schema.encodingDefaultJson = TransmitQosPriorityDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(TransmitQosPriorityDataType.dataTypeNodeId, "TransmitQosPriorityDataType", TransmitQosPriorityDataType);
    var schemaTrustListDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "TrustListDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "SpecifiedLists",
          fieldType: "UInt32"
        },
        {
          name: "TrustedCertificates",
          fieldType: "ByteString",
          isArray: true
        },
        {
          name: "TrustedCrls",
          fieldType: "ByteString",
          isArray: true
        },
        {
          name: "IssuerCertificates",
          fieldType: "ByteString",
          isArray: true
        },
        {
          name: "IssuerCrls",
          fieldType: "ByteString",
          isArray: true
        }
      ]
    });
    var TrustListDataType = class _TrustListDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaTrustListDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.specifiedLists = 0;
          this.trustedCertificates = [];
          this.trustedCrls = [];
          this.issuerCertificates = [];
          this.issuerCrls = [];
          return;
        }
        const schema = _TrustListDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.specifiedLists = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.specifiedLists);
        this.trustedCertificates = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.trustedCertificates);
        this.trustedCrls = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.trustedCrls);
        this.issuerCertificates = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[3], options?.issuerCertificates);
        this.issuerCrls = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[4], options?.issuerCrls);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.specifiedLists, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.trustedCertificates, stream, node_opcua_basic_types_1.encodeByteString);
        (0, node_opcua_basic_types_1.encodeArray)(this.trustedCrls, stream, node_opcua_basic_types_1.encodeByteString);
        (0, node_opcua_basic_types_1.encodeArray)(this.issuerCertificates, stream, node_opcua_basic_types_1.encodeByteString);
        (0, node_opcua_basic_types_1.encodeArray)(this.issuerCrls, stream, node_opcua_basic_types_1.encodeByteString);
      }
      decode(stream) {
        super.decode(stream);
        this.specifiedLists = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.specifiedLists);
        this.trustedCertificates = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeByteString);
        this.trustedCrls = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeByteString);
        this.issuerCertificates = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeByteString);
        this.issuerCrls = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeByteString);
      }
      get schema() {
        return schemaTrustListDataType;
      }
    };
    exports2.TrustListDataType = TrustListDataType;
    TrustListDataType.possibleFields = [
      "specifiedLists",
      "trustedCertificates",
      "trustedCrls",
      "issuerCertificates",
      "issuerCrls"
    ];
    TrustListDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12554, 0);
    TrustListDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12680, 0);
    TrustListDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12676, 0);
    TrustListDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15044, 0);
    TrustListDataType.schema.dataTypeNodeId = TrustListDataType.dataTypeNodeId;
    TrustListDataType.schema.encodingDefaultBinary = TrustListDataType.encodingDefaultBinary;
    TrustListDataType.schema.encodingDefaultXml = TrustListDataType.encodingDefaultXml;
    TrustListDataType.schema.encodingDefaultJson = TrustListDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(TrustListDataType.dataTypeNodeId, "TrustListDataType", TrustListDataType);
    var schemaUABinaryFileDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "UABinaryFileDataType",
      baseType: "DataTypeSchemaHeader",
      fields: [
        {
          name: "SchemaLocation",
          fieldType: "String"
        },
        {
          name: "FileHeader",
          fieldType: "KeyValuePair",
          isArray: true
        },
        {
          name: "Body",
          fieldType: "Variant"
        }
      ]
    });
    var UABinaryFileDataType = class _UABinaryFileDataType extends DataTypeSchemaHeader {
      static get schema() {
        return schemaUABinaryFileDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.schemaLocation = null;
          this.fileHeader = null;
          this.body = new node_opcua_variant_1.Variant(null);
          return;
        }
        const schema = _UABinaryFileDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.schemaLocation = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.schemaLocation);
        this.fileHeader = [];
        if (options.fileHeader) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.fileHeader));
          this.fileHeader = options.fileHeader.map((e) => new KeyValuePair(e));
        }
        this.body = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.body);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.schemaLocation, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.fileHeader, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_variant_1.encodeVariant)(this.body, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.schemaLocation = (0, node_opcua_basic_types_1.decodeString)(stream, this.schemaLocation);
        this.fileHeader = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new KeyValuePair(null);
          obj.decode(stream1);
          return obj;
        });
        this.body = (0, node_opcua_variant_1.decodeVariant)(stream, this.body);
      }
      get schema() {
        return schemaUABinaryFileDataType;
      }
    };
    exports2.UABinaryFileDataType = UABinaryFileDataType;
    UABinaryFileDataType.possibleFields = [
      "namespaces",
      "structureDataTypes",
      "enumDataTypes",
      "simpleDataTypes",
      "schemaLocation",
      "fileHeader",
      "body"
    ];
    UABinaryFileDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15006, 0);
    UABinaryFileDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15422, 0);
    UABinaryFileDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15531, 0);
    UABinaryFileDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15714, 0);
    UABinaryFileDataType.schema.dataTypeNodeId = UABinaryFileDataType.dataTypeNodeId;
    UABinaryFileDataType.schema.encodingDefaultBinary = UABinaryFileDataType.encodingDefaultBinary;
    UABinaryFileDataType.schema.encodingDefaultXml = UABinaryFileDataType.encodingDefaultXml;
    UABinaryFileDataType.schema.encodingDefaultJson = UABinaryFileDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(UABinaryFileDataType.dataTypeNodeId, "UABinaryFileDataType", UABinaryFileDataType);
    var UadpNetworkMessageContentMask;
    (function(UadpNetworkMessageContentMask2) {
      UadpNetworkMessageContentMask2[UadpNetworkMessageContentMask2["None"] = 0] = "None";
      UadpNetworkMessageContentMask2[UadpNetworkMessageContentMask2["PublisherId"] = 1] = "PublisherId";
      UadpNetworkMessageContentMask2[UadpNetworkMessageContentMask2["GroupHeader"] = 2] = "GroupHeader";
      UadpNetworkMessageContentMask2[UadpNetworkMessageContentMask2["WriterGroupId"] = 4] = "WriterGroupId";
      UadpNetworkMessageContentMask2[UadpNetworkMessageContentMask2["GroupVersion"] = 8] = "GroupVersion";
      UadpNetworkMessageContentMask2[UadpNetworkMessageContentMask2["NetworkMessageNumber"] = 16] = "NetworkMessageNumber";
      UadpNetworkMessageContentMask2[UadpNetworkMessageContentMask2["SequenceNumber"] = 32] = "SequenceNumber";
      UadpNetworkMessageContentMask2[UadpNetworkMessageContentMask2["PayloadHeader"] = 64] = "PayloadHeader";
      UadpNetworkMessageContentMask2[UadpNetworkMessageContentMask2["Timestamp"] = 128] = "Timestamp";
      UadpNetworkMessageContentMask2[UadpNetworkMessageContentMask2["PicoSeconds"] = 256] = "PicoSeconds";
      UadpNetworkMessageContentMask2[UadpNetworkMessageContentMask2["DataSetClassId"] = 512] = "DataSetClassId";
      UadpNetworkMessageContentMask2[UadpNetworkMessageContentMask2["PromotedFields"] = 1024] = "PromotedFields";
    })(UadpNetworkMessageContentMask || (exports2.UadpNetworkMessageContentMask = UadpNetworkMessageContentMask = {}));
    var schemaUadpNetworkMessageContentMask = {
      enumValues: UadpNetworkMessageContentMask,
      flaggable: true,
      name: "UadpNetworkMessageContentMask"
    };
    function decodeUadpNetworkMessageContentMask(stream, _value) {
      return stream.readUInt32();
    }
    function encodeUadpNetworkMessageContentMask(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationUadpNetworkMessageContentMask = (0, node_opcua_factory_1.registerEnumeration)(schemaUadpNetworkMessageContentMask);
    (0, node_opcua_assert_1.assert)(exports2._enumerationUadpNetworkMessageContentMask.isFlaggable === true);
    var UadpDataSetMessageContentMask;
    (function(UadpDataSetMessageContentMask2) {
      UadpDataSetMessageContentMask2[UadpDataSetMessageContentMask2["None"] = 0] = "None";
      UadpDataSetMessageContentMask2[UadpDataSetMessageContentMask2["Timestamp"] = 1] = "Timestamp";
      UadpDataSetMessageContentMask2[UadpDataSetMessageContentMask2["PicoSeconds"] = 2] = "PicoSeconds";
      UadpDataSetMessageContentMask2[UadpDataSetMessageContentMask2["Status"] = 4] = "Status";
      UadpDataSetMessageContentMask2[UadpDataSetMessageContentMask2["MajorVersion"] = 8] = "MajorVersion";
      UadpDataSetMessageContentMask2[UadpDataSetMessageContentMask2["MinorVersion"] = 16] = "MinorVersion";
      UadpDataSetMessageContentMask2[UadpDataSetMessageContentMask2["SequenceNumber"] = 32] = "SequenceNumber";
    })(UadpDataSetMessageContentMask || (exports2.UadpDataSetMessageContentMask = UadpDataSetMessageContentMask = {}));
    var schemaUadpDataSetMessageContentMask = {
      enumValues: UadpDataSetMessageContentMask,
      flaggable: true,
      name: "UadpDataSetMessageContentMask"
    };
    function decodeUadpDataSetMessageContentMask(stream, _value) {
      return stream.readUInt32();
    }
    function encodeUadpDataSetMessageContentMask(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationUadpDataSetMessageContentMask = (0, node_opcua_factory_1.registerEnumeration)(schemaUadpDataSetMessageContentMask);
    (0, node_opcua_assert_1.assert)(exports2._enumerationUadpDataSetMessageContentMask.isFlaggable === true);
    var schemaUadpDataSetReaderMessageDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "UadpDataSetReaderMessageDataType",
      baseType: "DataSetReaderMessageDataType",
      fields: [
        {
          name: "GroupVersion",
          fieldType: "UInt32"
        },
        {
          name: "NetworkMessageNumber",
          fieldType: "UInt16"
        },
        {
          name: "DataSetOffset",
          fieldType: "UInt16"
        },
        {
          name: "DataSetClassId",
          fieldType: "Guid"
        },
        {
          name: "NetworkMessageContentMask",
          fieldType: "UadpNetworkMessageContentMask"
        },
        {
          name: "DataSetMessageContentMask",
          fieldType: "UadpDataSetMessageContentMask"
        },
        {
          name: "PublishingInterval",
          fieldType: "Double"
        },
        {
          name: "ReceiveOffset",
          fieldType: "Double"
        },
        {
          name: "ProcessingOffset",
          fieldType: "Double"
        }
      ]
    });
    var UadpDataSetReaderMessageDataType = class _UadpDataSetReaderMessageDataType extends DataSetReaderMessageDataType {
      static get schema() {
        return schemaUadpDataSetReaderMessageDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.groupVersion = 0;
          this.networkMessageNumber = 0;
          this.dataSetOffset = 0;
          this.dataSetClassId = "";
          this.networkMessageContentMask = 0;
          this.dataSetMessageContentMask = 0;
          this.publishingInterval = 0;
          this.receiveOffset = 0;
          this.processingOffset = 0;
          return;
        }
        const schema = _UadpDataSetReaderMessageDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.groupVersion = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.groupVersion);
        this.networkMessageNumber = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.networkMessageNumber);
        this.dataSetOffset = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.dataSetOffset);
        this.dataSetClassId = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.dataSetClassId);
        this.networkMessageContentMask = this.setNetworkMessageContentMask((0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.networkMessageContentMask));
        this.dataSetMessageContentMask = this.setDataSetMessageContentMask((0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.dataSetMessageContentMask));
        this.publishingInterval = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.publishingInterval);
        this.receiveOffset = (0, node_opcua_factory_1.initialize_field)(schema.fields[7], options?.receiveOffset);
        this.processingOffset = (0, node_opcua_factory_1.initialize_field)(schema.fields[8], options?.processingOffset);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.groupVersion, stream);
        (0, node_opcua_basic_types_1.encodeUInt16)(this.networkMessageNumber, stream);
        (0, node_opcua_basic_types_1.encodeUInt16)(this.dataSetOffset, stream);
        (0, node_opcua_basic_types_1.encodeGuid)(this.dataSetClassId, stream);
        encodeUadpNetworkMessageContentMask(this.networkMessageContentMask, stream);
        encodeUadpDataSetMessageContentMask(this.dataSetMessageContentMask, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.publishingInterval, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.receiveOffset, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.processingOffset, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.groupVersion = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.groupVersion);
        this.networkMessageNumber = (0, node_opcua_basic_types_1.decodeUInt16)(stream, this.networkMessageNumber);
        this.dataSetOffset = (0, node_opcua_basic_types_1.decodeUInt16)(stream, this.dataSetOffset);
        this.dataSetClassId = (0, node_opcua_basic_types_1.decodeGuid)(stream, this.dataSetClassId);
        this.networkMessageContentMask = decodeUadpNetworkMessageContentMask(stream, this.networkMessageContentMask);
        this.dataSetMessageContentMask = decodeUadpDataSetMessageContentMask(stream, this.dataSetMessageContentMask);
        this.publishingInterval = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.publishingInterval);
        this.receiveOffset = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.receiveOffset);
        this.processingOffset = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.processingOffset);
      }
      // Define Enumeration setters
      setNetworkMessageContentMask(value) {
        const coercedValue = exports2._enumerationUadpNetworkMessageContentMask.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to UadpNetworkMessageContentMask :" + value);
        }
        this.networkMessageContentMask = coercedValue.value;
        return this.networkMessageContentMask;
      }
      setDataSetMessageContentMask(value) {
        const coercedValue = exports2._enumerationUadpDataSetMessageContentMask.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to UadpDataSetMessageContentMask :" + value);
        }
        this.dataSetMessageContentMask = coercedValue.value;
        return this.dataSetMessageContentMask;
      }
      get schema() {
        return schemaUadpDataSetReaderMessageDataType;
      }
    };
    exports2.UadpDataSetReaderMessageDataType = UadpDataSetReaderMessageDataType;
    UadpDataSetReaderMessageDataType.possibleFields = [
      "groupVersion",
      "networkMessageNumber",
      "dataSetOffset",
      "dataSetClassId",
      "networkMessageContentMask",
      "dataSetMessageContentMask",
      "publishingInterval",
      "receiveOffset",
      "processingOffset"
    ];
    UadpDataSetReaderMessageDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15653, 0);
    UadpDataSetReaderMessageDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15718, 0);
    UadpDataSetReaderMessageDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16016, 0);
    UadpDataSetReaderMessageDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16392, 0);
    UadpDataSetReaderMessageDataType.schema.dataTypeNodeId = UadpDataSetReaderMessageDataType.dataTypeNodeId;
    UadpDataSetReaderMessageDataType.schema.encodingDefaultBinary = UadpDataSetReaderMessageDataType.encodingDefaultBinary;
    UadpDataSetReaderMessageDataType.schema.encodingDefaultXml = UadpDataSetReaderMessageDataType.encodingDefaultXml;
    UadpDataSetReaderMessageDataType.schema.encodingDefaultJson = UadpDataSetReaderMessageDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(UadpDataSetReaderMessageDataType.dataTypeNodeId, "UadpDataSetReaderMessageDataType", UadpDataSetReaderMessageDataType);
    var schemaUadpDataSetWriterMessageDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "UadpDataSetWriterMessageDataType",
      baseType: "DataSetWriterMessageDataType",
      fields: [
        {
          name: "DataSetMessageContentMask",
          fieldType: "UadpDataSetMessageContentMask"
        },
        {
          name: "ConfiguredSize",
          fieldType: "UInt16"
        },
        {
          name: "NetworkMessageNumber",
          fieldType: "UInt16"
        },
        {
          name: "DataSetOffset",
          fieldType: "UInt16"
        }
      ]
    });
    var UadpDataSetWriterMessageDataType = class _UadpDataSetWriterMessageDataType extends DataSetWriterMessageDataType {
      static get schema() {
        return schemaUadpDataSetWriterMessageDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.dataSetMessageContentMask = 0;
          this.configuredSize = 0;
          this.networkMessageNumber = 0;
          this.dataSetOffset = 0;
          return;
        }
        const schema = _UadpDataSetWriterMessageDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.dataSetMessageContentMask = this.setDataSetMessageContentMask((0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.dataSetMessageContentMask));
        this.configuredSize = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.configuredSize);
        this.networkMessageNumber = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.networkMessageNumber);
        this.dataSetOffset = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.dataSetOffset);
      }
      encode(stream) {
        super.encode(stream);
        encodeUadpDataSetMessageContentMask(this.dataSetMessageContentMask, stream);
        (0, node_opcua_basic_types_1.encodeUInt16)(this.configuredSize, stream);
        (0, node_opcua_basic_types_1.encodeUInt16)(this.networkMessageNumber, stream);
        (0, node_opcua_basic_types_1.encodeUInt16)(this.dataSetOffset, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.dataSetMessageContentMask = decodeUadpDataSetMessageContentMask(stream, this.dataSetMessageContentMask);
        this.configuredSize = (0, node_opcua_basic_types_1.decodeUInt16)(stream, this.configuredSize);
        this.networkMessageNumber = (0, node_opcua_basic_types_1.decodeUInt16)(stream, this.networkMessageNumber);
        this.dataSetOffset = (0, node_opcua_basic_types_1.decodeUInt16)(stream, this.dataSetOffset);
      }
      // Define Enumeration setters
      setDataSetMessageContentMask(value) {
        const coercedValue = exports2._enumerationUadpDataSetMessageContentMask.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to UadpDataSetMessageContentMask :" + value);
        }
        this.dataSetMessageContentMask = coercedValue.value;
        return this.dataSetMessageContentMask;
      }
      get schema() {
        return schemaUadpDataSetWriterMessageDataType;
      }
    };
    exports2.UadpDataSetWriterMessageDataType = UadpDataSetWriterMessageDataType;
    UadpDataSetWriterMessageDataType.possibleFields = [
      "dataSetMessageContentMask",
      "configuredSize",
      "networkMessageNumber",
      "dataSetOffset"
    ];
    UadpDataSetWriterMessageDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15652, 0);
    UadpDataSetWriterMessageDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15717, 0);
    UadpDataSetWriterMessageDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16015, 0);
    UadpDataSetWriterMessageDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16391, 0);
    UadpDataSetWriterMessageDataType.schema.dataTypeNodeId = UadpDataSetWriterMessageDataType.dataTypeNodeId;
    UadpDataSetWriterMessageDataType.schema.encodingDefaultBinary = UadpDataSetWriterMessageDataType.encodingDefaultBinary;
    UadpDataSetWriterMessageDataType.schema.encodingDefaultXml = UadpDataSetWriterMessageDataType.encodingDefaultXml;
    UadpDataSetWriterMessageDataType.schema.encodingDefaultJson = UadpDataSetWriterMessageDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(UadpDataSetWriterMessageDataType.dataTypeNodeId, "UadpDataSetWriterMessageDataType", UadpDataSetWriterMessageDataType);
    var DataSetOrderingType;
    (function(DataSetOrderingType2) {
      DataSetOrderingType2[DataSetOrderingType2["Undefined"] = 0] = "Undefined";
      DataSetOrderingType2[DataSetOrderingType2["AscendingWriterId"] = 1] = "AscendingWriterId";
      DataSetOrderingType2[DataSetOrderingType2["AscendingWriterIdSingle"] = 2] = "AscendingWriterIdSingle";
      DataSetOrderingType2[DataSetOrderingType2["Invalid"] = 4294967295] = "Invalid";
    })(DataSetOrderingType || (exports2.DataSetOrderingType = DataSetOrderingType = {}));
    var schemaDataSetOrderingType = {
      enumValues: DataSetOrderingType,
      flaggable: false,
      minValue: 0,
      maxValue: 2,
      name: "DataSetOrderingType"
    };
    function decodeDataSetOrderingType(stream, _value) {
      let value = stream.readUInt32();
      value = value < schemaDataSetOrderingType.minValue || value > schemaDataSetOrderingType.maxValue ? DataSetOrderingType.Invalid : value;
      return value;
    }
    function encodeDataSetOrderingType(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationDataSetOrderingType = (0, node_opcua_factory_1.registerEnumeration)(schemaDataSetOrderingType);
    (0, node_opcua_assert_1.assert)(exports2._enumerationDataSetOrderingType.isFlaggable === false);
    var schemaUadpWriterGroupMessageDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "UadpWriterGroupMessageDataType",
      baseType: "WriterGroupMessageDataType",
      fields: [
        {
          name: "GroupVersion",
          fieldType: "UInt32"
        },
        {
          name: "DataSetOrdering",
          fieldType: "DataSetOrderingType"
        },
        {
          name: "NetworkMessageContentMask",
          fieldType: "UadpNetworkMessageContentMask"
        },
        {
          name: "SamplingOffset",
          fieldType: "Double"
        },
        {
          name: "PublishingOffset",
          fieldType: "Double",
          isArray: true
        }
      ]
    });
    var UadpWriterGroupMessageDataType = class _UadpWriterGroupMessageDataType extends WriterGroupMessageDataType {
      static get schema() {
        return schemaUadpWriterGroupMessageDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.groupVersion = 0;
          this.dataSetOrdering = 0;
          this.networkMessageContentMask = 0;
          this.samplingOffset = 0;
          this.publishingOffset = [];
          return;
        }
        const schema = _UadpWriterGroupMessageDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.groupVersion = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.groupVersion);
        this.dataSetOrdering = this.setDataSetOrdering((0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.dataSetOrdering));
        this.networkMessageContentMask = this.setNetworkMessageContentMask((0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.networkMessageContentMask));
        this.samplingOffset = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.samplingOffset);
        this.publishingOffset = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[4], options?.publishingOffset);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.groupVersion, stream);
        encodeDataSetOrderingType(this.dataSetOrdering, stream);
        encodeUadpNetworkMessageContentMask(this.networkMessageContentMask, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.samplingOffset, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.publishingOffset, stream, node_opcua_basic_types_1.encodeDouble);
      }
      decode(stream) {
        super.decode(stream);
        this.groupVersion = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.groupVersion);
        this.dataSetOrdering = decodeDataSetOrderingType(stream, this.dataSetOrdering);
        this.networkMessageContentMask = decodeUadpNetworkMessageContentMask(stream, this.networkMessageContentMask);
        this.samplingOffset = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.samplingOffset);
        this.publishingOffset = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeDouble);
      }
      // Define Enumeration setters
      setDataSetOrdering(value) {
        const coercedValue = exports2._enumerationDataSetOrderingType.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to DataSetOrderingType :" + value);
        }
        this.dataSetOrdering = coercedValue.value;
        return this.dataSetOrdering;
      }
      setNetworkMessageContentMask(value) {
        const coercedValue = exports2._enumerationUadpNetworkMessageContentMask.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to UadpNetworkMessageContentMask :" + value);
        }
        this.networkMessageContentMask = coercedValue.value;
        return this.networkMessageContentMask;
      }
      get schema() {
        return schemaUadpWriterGroupMessageDataType;
      }
    };
    exports2.UadpWriterGroupMessageDataType = UadpWriterGroupMessageDataType;
    UadpWriterGroupMessageDataType.possibleFields = [
      "groupVersion",
      "dataSetOrdering",
      "networkMessageContentMask",
      "samplingOffset",
      "publishingOffset"
    ];
    UadpWriterGroupMessageDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15645, 0);
    UadpWriterGroupMessageDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15715, 0);
    UadpWriterGroupMessageDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16014, 0);
    UadpWriterGroupMessageDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(16323, 0);
    UadpWriterGroupMessageDataType.schema.dataTypeNodeId = UadpWriterGroupMessageDataType.dataTypeNodeId;
    UadpWriterGroupMessageDataType.schema.encodingDefaultBinary = UadpWriterGroupMessageDataType.encodingDefaultBinary;
    UadpWriterGroupMessageDataType.schema.encodingDefaultXml = UadpWriterGroupMessageDataType.encodingDefaultXml;
    UadpWriterGroupMessageDataType.schema.encodingDefaultJson = UadpWriterGroupMessageDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(UadpWriterGroupMessageDataType.dataTypeNodeId, "UadpWriterGroupMessageDataType", UadpWriterGroupMessageDataType);
    var schemaUnion = (0, node_opcua_factory_1.buildStructuredType)({
      name: "Union",
      baseType: "ExtensionObject",
      fields: []
    });
    var Union = class _Union extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaUnion;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          return;
        }
        const schema = _Union.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
      }
      encode(stream) {
        super.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
      }
      get schema() {
        return schemaUnion;
      }
    };
    exports2.Union = Union;
    Union.possibleFields = [];
    Union.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12756, 0);
    Union.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12766, 0);
    Union.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12758, 0);
    Union.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15085, 0);
    Union.schema.dataTypeNodeId = Union.dataTypeNodeId;
    Union.schema.encodingDefaultBinary = Union.encodingDefaultBinary;
    Union.schema.encodingDefaultXml = Union.encodingDefaultXml;
    Union.schema.encodingDefaultJson = Union.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(Union.dataTypeNodeId, "Union", Union);
    var schemaUnregisterNodesRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "UnregisterNodesRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "NodesToUnregister",
          fieldType: "NodeId",
          isArray: true
        }
      ]
    });
    var UnregisterNodesRequest = class _UnregisterNodesRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaUnregisterNodesRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.nodesToUnregister = [];
          return;
        }
        const schema = _UnregisterNodesRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.nodesToUnregister = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.nodesToUnregister);
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.nodesToUnregister, stream, node_opcua_basic_types_1.encodeNodeId);
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.nodesToUnregister = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeNodeId);
      }
      get schema() {
        return schemaUnregisterNodesRequest;
      }
    };
    exports2.UnregisterNodesRequest = UnregisterNodesRequest;
    UnregisterNodesRequest.possibleFields = [
      "requestHeader",
      "nodesToUnregister"
    ];
    UnregisterNodesRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(564, 0);
    UnregisterNodesRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(566, 0);
    UnregisterNodesRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(565, 0);
    UnregisterNodesRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15197, 0);
    UnregisterNodesRequest.schema.dataTypeNodeId = UnregisterNodesRequest.dataTypeNodeId;
    UnregisterNodesRequest.schema.encodingDefaultBinary = UnregisterNodesRequest.encodingDefaultBinary;
    UnregisterNodesRequest.schema.encodingDefaultXml = UnregisterNodesRequest.encodingDefaultXml;
    UnregisterNodesRequest.schema.encodingDefaultJson = UnregisterNodesRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(UnregisterNodesRequest.dataTypeNodeId, "UnregisterNodesRequest", UnregisterNodesRequest);
    var schemaUnregisterNodesResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "UnregisterNodesResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        }
      ]
    });
    var UnregisterNodesResponse = class _UnregisterNodesResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaUnregisterNodesResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          return;
        }
        const schema = _UnregisterNodesResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
      }
      get schema() {
        return schemaUnregisterNodesResponse;
      }
    };
    exports2.UnregisterNodesResponse = UnregisterNodesResponse;
    UnregisterNodesResponse.possibleFields = [
      "responseHeader"
    ];
    UnregisterNodesResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(567, 0);
    UnregisterNodesResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(569, 0);
    UnregisterNodesResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(568, 0);
    UnregisterNodesResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15198, 0);
    UnregisterNodesResponse.schema.dataTypeNodeId = UnregisterNodesResponse.dataTypeNodeId;
    UnregisterNodesResponse.schema.encodingDefaultBinary = UnregisterNodesResponse.encodingDefaultBinary;
    UnregisterNodesResponse.schema.encodingDefaultXml = UnregisterNodesResponse.encodingDefaultXml;
    UnregisterNodesResponse.schema.encodingDefaultJson = UnregisterNodesResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(UnregisterNodesResponse.dataTypeNodeId, "UnregisterNodesResponse", UnregisterNodesResponse);
    var schemaUnsignedRationalNumber = (0, node_opcua_factory_1.buildStructuredType)({
      name: "UnsignedRationalNumber",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "Numerator",
          fieldType: "UInt32"
        },
        {
          name: "Denominator",
          fieldType: "UInt32"
        }
      ]
    });
    var UnsignedRationalNumber = class _UnsignedRationalNumber extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaUnsignedRationalNumber;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.numerator = 0;
          this.denominator = 0;
          return;
        }
        const schema = _UnsignedRationalNumber.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.numerator = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.numerator);
        this.denominator = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.denominator);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.numerator, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.denominator, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.numerator = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.numerator);
        this.denominator = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.denominator);
      }
      get schema() {
        return schemaUnsignedRationalNumber;
      }
    };
    exports2.UnsignedRationalNumber = UnsignedRationalNumber;
    UnsignedRationalNumber.possibleFields = [
      "numerator",
      "denominator"
    ];
    UnsignedRationalNumber.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24107, 0);
    UnsignedRationalNumber.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24110, 0);
    UnsignedRationalNumber.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24122, 0);
    UnsignedRationalNumber.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24134, 0);
    UnsignedRationalNumber.schema.dataTypeNodeId = UnsignedRationalNumber.dataTypeNodeId;
    UnsignedRationalNumber.schema.encodingDefaultBinary = UnsignedRationalNumber.encodingDefaultBinary;
    UnsignedRationalNumber.schema.encodingDefaultXml = UnsignedRationalNumber.encodingDefaultXml;
    UnsignedRationalNumber.schema.encodingDefaultJson = UnsignedRationalNumber.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(UnsignedRationalNumber.dataTypeNodeId, "UnsignedRationalNumber", UnsignedRationalNumber);
    var PerformUpdateType;
    (function(PerformUpdateType2) {
      PerformUpdateType2[PerformUpdateType2["Insert"] = 1] = "Insert";
      PerformUpdateType2[PerformUpdateType2["Replace"] = 2] = "Replace";
      PerformUpdateType2[PerformUpdateType2["Update"] = 3] = "Update";
      PerformUpdateType2[PerformUpdateType2["Remove"] = 4] = "Remove";
      PerformUpdateType2[PerformUpdateType2["Invalid"] = 4294967295] = "Invalid";
    })(PerformUpdateType || (exports2.PerformUpdateType = PerformUpdateType = {}));
    var schemaPerformUpdateType = {
      enumValues: PerformUpdateType,
      flaggable: false,
      minValue: 1,
      maxValue: 4,
      name: "PerformUpdateType"
    };
    function decodePerformUpdateType(stream, _value) {
      let value = stream.readUInt32();
      value = value < schemaPerformUpdateType.minValue || value > schemaPerformUpdateType.maxValue ? PerformUpdateType.Invalid : value;
      return value;
    }
    function encodePerformUpdateType(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationPerformUpdateType = (0, node_opcua_factory_1.registerEnumeration)(schemaPerformUpdateType);
    (0, node_opcua_assert_1.assert)(exports2._enumerationPerformUpdateType.isFlaggable === false);
    var schemaUpdateDataDetails = (0, node_opcua_factory_1.buildStructuredType)({
      name: "UpdateDataDetails",
      baseType: "HistoryUpdateDetails",
      fields: [
        {
          name: "PerformInsertReplace",
          fieldType: "PerformUpdateType"
        },
        {
          name: "UpdateValues",
          fieldType: "DataValue",
          isArray: true
        }
      ]
    });
    var UpdateDataDetails = class _UpdateDataDetails extends HistoryUpdateDetails {
      static get schema() {
        return schemaUpdateDataDetails;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.performInsertReplace = 0;
          this.updateValues = [];
          return;
        }
        const schema = _UpdateDataDetails.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.performInsertReplace = this.setPerformInsertReplace((0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.performInsertReplace));
        this.updateValues = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.updateValues);
      }
      encode(stream) {
        super.encode(stream);
        encodePerformUpdateType(this.performInsertReplace, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.updateValues, stream, node_opcua_data_value_1.encodeDataValue);
      }
      decode(stream) {
        super.decode(stream);
        this.performInsertReplace = decodePerformUpdateType(stream, this.performInsertReplace);
        this.updateValues = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_value_1.decodeDataValue);
      }
      // Define Enumeration setters
      setPerformInsertReplace(value) {
        const coercedValue = exports2._enumerationPerformUpdateType.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to PerformUpdateType :" + value);
        }
        this.performInsertReplace = coercedValue.value;
        return this.performInsertReplace;
      }
      get schema() {
        return schemaUpdateDataDetails;
      }
    };
    exports2.UpdateDataDetails = UpdateDataDetails;
    UpdateDataDetails.possibleFields = [
      "nodeId",
      "performInsertReplace",
      "updateValues"
    ];
    UpdateDataDetails.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(680, 0);
    UpdateDataDetails.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(682, 0);
    UpdateDataDetails.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(681, 0);
    UpdateDataDetails.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15280, 0);
    UpdateDataDetails.schema.dataTypeNodeId = UpdateDataDetails.dataTypeNodeId;
    UpdateDataDetails.schema.encodingDefaultBinary = UpdateDataDetails.encodingDefaultBinary;
    UpdateDataDetails.schema.encodingDefaultXml = UpdateDataDetails.encodingDefaultXml;
    UpdateDataDetails.schema.encodingDefaultJson = UpdateDataDetails.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(UpdateDataDetails.dataTypeNodeId, "UpdateDataDetails", UpdateDataDetails);
    var schemaUpdateEventDetails = (0, node_opcua_factory_1.buildStructuredType)({
      name: "UpdateEventDetails",
      baseType: "HistoryUpdateDetails",
      fields: [
        {
          name: "PerformInsertReplace",
          fieldType: "PerformUpdateType"
        },
        {
          name: "Filter",
          fieldType: "EventFilter"
        },
        {
          name: "EventData",
          fieldType: "HistoryEventFieldList",
          isArray: true
        }
      ]
    });
    var UpdateEventDetails = class _UpdateEventDetails extends HistoryUpdateDetails {
      static get schema() {
        return schemaUpdateEventDetails;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.performInsertReplace = 0;
          this.filter = new EventFilter(null);
          this.eventData = null;
          return;
        }
        const schema = _UpdateEventDetails.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.performInsertReplace = this.setPerformInsertReplace((0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.performInsertReplace));
        this.filter = new EventFilter(options.filter);
        this.eventData = [];
        if (options.eventData) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.eventData));
          this.eventData = options.eventData.map((e) => new HistoryEventFieldList(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        encodePerformUpdateType(this.performInsertReplace, stream);
        this.filter.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.eventData, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.performInsertReplace = decodePerformUpdateType(stream, this.performInsertReplace);
        this.filter.decode(stream);
        this.eventData = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new HistoryEventFieldList(null);
          obj.decode(stream1);
          return obj;
        });
      }
      // Define Enumeration setters
      setPerformInsertReplace(value) {
        const coercedValue = exports2._enumerationPerformUpdateType.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to PerformUpdateType :" + value);
        }
        this.performInsertReplace = coercedValue.value;
        return this.performInsertReplace;
      }
      get schema() {
        return schemaUpdateEventDetails;
      }
    };
    exports2.UpdateEventDetails = UpdateEventDetails;
    UpdateEventDetails.possibleFields = [
      "nodeId",
      "performInsertReplace",
      "filter",
      "eventData"
    ];
    UpdateEventDetails.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(683, 0);
    UpdateEventDetails.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(685, 0);
    UpdateEventDetails.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(684, 0);
    UpdateEventDetails.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15282, 0);
    UpdateEventDetails.schema.dataTypeNodeId = UpdateEventDetails.dataTypeNodeId;
    UpdateEventDetails.schema.encodingDefaultBinary = UpdateEventDetails.encodingDefaultBinary;
    UpdateEventDetails.schema.encodingDefaultXml = UpdateEventDetails.encodingDefaultXml;
    UpdateEventDetails.schema.encodingDefaultJson = UpdateEventDetails.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(UpdateEventDetails.dataTypeNodeId, "UpdateEventDetails", UpdateEventDetails);
    var schemaUpdateStructureDataDetails = (0, node_opcua_factory_1.buildStructuredType)({
      name: "UpdateStructureDataDetails",
      baseType: "HistoryUpdateDetails",
      fields: [
        {
          name: "PerformInsertReplace",
          fieldType: "PerformUpdateType"
        },
        {
          name: "UpdateValues",
          fieldType: "DataValue",
          isArray: true
        }
      ]
    });
    var UpdateStructureDataDetails = class _UpdateStructureDataDetails extends HistoryUpdateDetails {
      static get schema() {
        return schemaUpdateStructureDataDetails;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.performInsertReplace = 0;
          this.updateValues = [];
          return;
        }
        const schema = _UpdateStructureDataDetails.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.performInsertReplace = this.setPerformInsertReplace((0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.performInsertReplace));
        this.updateValues = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.updateValues);
      }
      encode(stream) {
        super.encode(stream);
        encodePerformUpdateType(this.performInsertReplace, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.updateValues, stream, node_opcua_data_value_1.encodeDataValue);
      }
      decode(stream) {
        super.decode(stream);
        this.performInsertReplace = decodePerformUpdateType(stream, this.performInsertReplace);
        this.updateValues = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_value_1.decodeDataValue);
      }
      // Define Enumeration setters
      setPerformInsertReplace(value) {
        const coercedValue = exports2._enumerationPerformUpdateType.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to PerformUpdateType :" + value);
        }
        this.performInsertReplace = coercedValue.value;
        return this.performInsertReplace;
      }
      get schema() {
        return schemaUpdateStructureDataDetails;
      }
    };
    exports2.UpdateStructureDataDetails = UpdateStructureDataDetails;
    UpdateStructureDataDetails.possibleFields = [
      "nodeId",
      "performInsertReplace",
      "updateValues"
    ];
    UpdateStructureDataDetails.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(11295, 0);
    UpdateStructureDataDetails.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(11300, 0);
    UpdateStructureDataDetails.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(11296, 0);
    UpdateStructureDataDetails.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15281, 0);
    UpdateStructureDataDetails.schema.dataTypeNodeId = UpdateStructureDataDetails.dataTypeNodeId;
    UpdateStructureDataDetails.schema.encodingDefaultBinary = UpdateStructureDataDetails.encodingDefaultBinary;
    UpdateStructureDataDetails.schema.encodingDefaultXml = UpdateStructureDataDetails.encodingDefaultXml;
    UpdateStructureDataDetails.schema.encodingDefaultJson = UpdateStructureDataDetails.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(UpdateStructureDataDetails.dataTypeNodeId, "UpdateStructureDataDetails", UpdateStructureDataDetails);
    var UserConfigurationMask;
    (function(UserConfigurationMask2) {
      UserConfigurationMask2[UserConfigurationMask2["None"] = 0] = "None";
      UserConfigurationMask2[UserConfigurationMask2["NoDelete"] = 1] = "NoDelete";
      UserConfigurationMask2[UserConfigurationMask2["Disabled"] = 2] = "Disabled";
      UserConfigurationMask2[UserConfigurationMask2["NoChangeByUser"] = 4] = "NoChangeByUser";
      UserConfigurationMask2[UserConfigurationMask2["MustChangePassword"] = 8] = "MustChangePassword";
    })(UserConfigurationMask || (exports2.UserConfigurationMask = UserConfigurationMask = {}));
    var schemaUserConfigurationMask = {
      enumValues: UserConfigurationMask,
      flaggable: true,
      name: "UserConfigurationMask"
    };
    function decodeUserConfigurationMask(stream, _value) {
      return stream.readUInt32();
    }
    function encodeUserConfigurationMask(value, stream) {
      stream.writeUInt32(value);
    }
    exports2._enumerationUserConfigurationMask = (0, node_opcua_factory_1.registerEnumeration)(schemaUserConfigurationMask);
    (0, node_opcua_assert_1.assert)(exports2._enumerationUserConfigurationMask.isFlaggable === true);
    var schemaUserManagementDataType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "UserManagementDataType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "UserName",
          fieldType: "String"
        },
        {
          name: "UserConfiguration",
          fieldType: "UserConfigurationMask"
        },
        {
          name: "Description",
          fieldType: "String"
        }
      ]
    });
    var UserManagementDataType = class _UserManagementDataType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaUserManagementDataType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.userName = null;
          this.userConfiguration = 0;
          this.description = null;
          return;
        }
        const schema = _UserManagementDataType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.userName = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.userName);
        this.userConfiguration = this.setUserConfiguration((0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.userConfiguration));
        this.description = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.description);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.userName, stream);
        encodeUserConfigurationMask(this.userConfiguration, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.description, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.userName = (0, node_opcua_basic_types_1.decodeString)(stream, this.userName);
        this.userConfiguration = decodeUserConfigurationMask(stream, this.userConfiguration);
        this.description = (0, node_opcua_basic_types_1.decodeString)(stream, this.description);
      }
      // Define Enumeration setters
      setUserConfiguration(value) {
        const coercedValue = exports2._enumerationUserConfigurationMask.get(value);
        if (coercedValue === void 0 || coercedValue === null) {
          throw new Error("value cannot be coerced to UserConfigurationMask :" + value);
        }
        this.userConfiguration = coercedValue.value;
        return this.userConfiguration;
      }
      get schema() {
        return schemaUserManagementDataType;
      }
    };
    exports2.UserManagementDataType = UserManagementDataType;
    UserManagementDataType.possibleFields = [
      "userName",
      "userConfiguration",
      "description"
    ];
    UserManagementDataType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24281, 0);
    UserManagementDataType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24292, 0);
    UserManagementDataType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24296, 0);
    UserManagementDataType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(24300, 0);
    UserManagementDataType.schema.dataTypeNodeId = UserManagementDataType.dataTypeNodeId;
    UserManagementDataType.schema.encodingDefaultBinary = UserManagementDataType.encodingDefaultBinary;
    UserManagementDataType.schema.encodingDefaultXml = UserManagementDataType.encodingDefaultXml;
    UserManagementDataType.schema.encodingDefaultJson = UserManagementDataType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(UserManagementDataType.dataTypeNodeId, "UserManagementDataType", UserManagementDataType);
    var schemaUserNameIdentityToken = (0, node_opcua_factory_1.buildStructuredType)({
      name: "UserNameIdentityToken",
      baseType: "UserIdentityToken",
      fields: [
        {
          name: "UserName",
          fieldType: "String"
        },
        {
          name: "Password",
          fieldType: "ByteString"
        },
        {
          name: "EncryptionAlgorithm",
          fieldType: "String"
        }
      ]
    });
    var UserNameIdentityToken = class _UserNameIdentityToken extends UserIdentityToken {
      static get schema() {
        return schemaUserNameIdentityToken;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.userName = null;
          this.password = Buffer.alloc(0);
          this.encryptionAlgorithm = null;
          return;
        }
        const schema = _UserNameIdentityToken.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.userName = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.userName);
        this.password = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.password);
        this.encryptionAlgorithm = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.encryptionAlgorithm);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.userName, stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.password, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.encryptionAlgorithm, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.userName = (0, node_opcua_basic_types_1.decodeString)(stream, this.userName);
        this.password = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.password);
        this.encryptionAlgorithm = (0, node_opcua_basic_types_1.decodeString)(stream, this.encryptionAlgorithm);
      }
      get schema() {
        return schemaUserNameIdentityToken;
      }
    };
    exports2.UserNameIdentityToken = UserNameIdentityToken;
    UserNameIdentityToken.possibleFields = [
      "policyId",
      "userName",
      "password",
      "encryptionAlgorithm"
    ];
    UserNameIdentityToken.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(322, 0);
    UserNameIdentityToken.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(324, 0);
    UserNameIdentityToken.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(323, 0);
    UserNameIdentityToken.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15142, 0);
    UserNameIdentityToken.schema.dataTypeNodeId = UserNameIdentityToken.dataTypeNodeId;
    UserNameIdentityToken.schema.encodingDefaultBinary = UserNameIdentityToken.encodingDefaultBinary;
    UserNameIdentityToken.schema.encodingDefaultXml = UserNameIdentityToken.encodingDefaultXml;
    UserNameIdentityToken.schema.encodingDefaultJson = UserNameIdentityToken.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(UserNameIdentityToken.dataTypeNodeId, "UserNameIdentityToken", UserNameIdentityToken);
    var schemaVariableAttributes = (0, node_opcua_factory_1.buildStructuredType)({
      name: "VariableAttributes",
      baseType: "NodeAttributes",
      fields: [
        {
          name: "Value",
          fieldType: "Variant"
        },
        {
          name: "DataType",
          fieldType: "NodeId"
        },
        {
          name: "ValueRank",
          fieldType: "Int32"
        },
        {
          name: "ArrayDimensions",
          fieldType: "UInt32",
          isArray: true
        },
        {
          name: "AccessLevel",
          fieldType: "Byte"
        },
        {
          name: "UserAccessLevel",
          fieldType: "Byte"
        },
        {
          name: "MinimumSamplingInterval",
          fieldType: "Double"
        },
        {
          name: "Historizing",
          fieldType: "Boolean"
        }
      ]
    });
    var VariableAttributes = class _VariableAttributes extends NodeAttributes {
      static get schema() {
        return schemaVariableAttributes;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.value = new node_opcua_variant_1.Variant(null);
          this.dataType = new node_opcua_nodeid_1.NodeId(null);
          this.valueRank = 0;
          this.arrayDimensions = [];
          this.accessLevel = 0;
          this.userAccessLevel = 0;
          this.minimumSamplingInterval = 0;
          this.historizing = false;
          return;
        }
        const schema = _VariableAttributes.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.value = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.value);
        this.dataType = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.dataType);
        this.valueRank = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.valueRank);
        this.arrayDimensions = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[3], options?.arrayDimensions);
        this.accessLevel = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.accessLevel);
        this.userAccessLevel = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.userAccessLevel);
        this.minimumSamplingInterval = (0, node_opcua_factory_1.initialize_field)(schema.fields[6], options?.minimumSamplingInterval);
        this.historizing = (0, node_opcua_factory_1.initialize_field)(schema.fields[7], options?.historizing);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_variant_1.encodeVariant)(this.value, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.dataType, stream);
        (0, node_opcua_basic_types_1.encodeInt32)(this.valueRank, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.arrayDimensions, stream, node_opcua_basic_types_1.encodeUInt32);
        (0, node_opcua_basic_types_1.encodeByte)(this.accessLevel, stream);
        (0, node_opcua_basic_types_1.encodeByte)(this.userAccessLevel, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.minimumSamplingInterval, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.historizing, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.value = (0, node_opcua_variant_1.decodeVariant)(stream, this.value);
        this.dataType = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.dataType);
        this.valueRank = (0, node_opcua_basic_types_1.decodeInt32)(stream, this.valueRank);
        this.arrayDimensions = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeUInt32);
        this.accessLevel = (0, node_opcua_basic_types_1.decodeByte)(stream, this.accessLevel);
        this.userAccessLevel = (0, node_opcua_basic_types_1.decodeByte)(stream, this.userAccessLevel);
        this.minimumSamplingInterval = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.minimumSamplingInterval);
        this.historizing = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.historizing);
      }
      get schema() {
        return schemaVariableAttributes;
      }
    };
    exports2.VariableAttributes = VariableAttributes;
    VariableAttributes.possibleFields = [
      "specifiedAttributes",
      "displayName",
      "description",
      "writeMask",
      "userWriteMask",
      "value",
      "dataType",
      "valueRank",
      "arrayDimensions",
      "accessLevel",
      "userAccessLevel",
      "minimumSamplingInterval",
      "historizing"
    ];
    VariableAttributes.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(355, 0);
    VariableAttributes.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(357, 0);
    VariableAttributes.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(356, 0);
    VariableAttributes.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15153, 0);
    VariableAttributes.schema.dataTypeNodeId = VariableAttributes.dataTypeNodeId;
    VariableAttributes.schema.encodingDefaultBinary = VariableAttributes.encodingDefaultBinary;
    VariableAttributes.schema.encodingDefaultXml = VariableAttributes.encodingDefaultXml;
    VariableAttributes.schema.encodingDefaultJson = VariableAttributes.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(VariableAttributes.dataTypeNodeId, "VariableAttributes", VariableAttributes);
    var schemaVariableNode = (0, node_opcua_factory_1.buildStructuredType)({
      name: "VariableNode",
      baseType: "InstanceNode",
      fields: [
        {
          name: "RolePermissions",
          fieldType: "RolePermissionType",
          isArray: true
        },
        {
          name: "UserRolePermissions",
          fieldType: "RolePermissionType",
          isArray: true
        },
        {
          name: "References",
          fieldType: "ReferenceNode",
          isArray: true
        },
        {
          name: "Value",
          fieldType: "Variant"
        },
        {
          name: "DataType",
          fieldType: "NodeId"
        },
        {
          name: "ValueRank",
          fieldType: "Int32"
        },
        {
          name: "ArrayDimensions",
          fieldType: "UInt32",
          isArray: true
        },
        {
          name: "AccessLevel",
          fieldType: "Byte"
        },
        {
          name: "UserAccessLevel",
          fieldType: "Byte"
        },
        {
          name: "MinimumSamplingInterval",
          fieldType: "Double"
        },
        {
          name: "Historizing",
          fieldType: "Boolean"
        },
        {
          name: "AccessLevelEx",
          fieldType: "UInt32"
        }
      ]
    });
    var VariableNode = class _VariableNode extends InstanceNode {
      static get schema() {
        return schemaVariableNode;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.rolePermissions = null;
          this.userRolePermissions = null;
          this.references = null;
          this.value = new node_opcua_variant_1.Variant(null);
          this.dataType = new node_opcua_nodeid_1.NodeId(null);
          this.valueRank = 0;
          this.arrayDimensions = [];
          this.accessLevel = 0;
          this.userAccessLevel = 0;
          this.minimumSamplingInterval = 0;
          this.historizing = false;
          this.accessLevelEx = 0;
          return;
        }
        const schema = _VariableNode.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.rolePermissions = [];
        if (options.rolePermissions) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.rolePermissions));
          this.rolePermissions = options.rolePermissions.map((e) => new RolePermissionType(e));
        }
        this.userRolePermissions = [];
        if (options.userRolePermissions) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.userRolePermissions));
          this.userRolePermissions = options.userRolePermissions.map((e) => new RolePermissionType(e));
        }
        this.references = [];
        if (options.references) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.references));
          this.references = options.references.map((e) => new ReferenceNode(e));
        }
        this.value = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.value);
        this.dataType = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.dataType);
        this.valueRank = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.valueRank);
        this.arrayDimensions = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[6], options?.arrayDimensions);
        this.accessLevel = (0, node_opcua_factory_1.initialize_field)(schema.fields[7], options?.accessLevel);
        this.userAccessLevel = (0, node_opcua_factory_1.initialize_field)(schema.fields[8], options?.userAccessLevel);
        this.minimumSamplingInterval = (0, node_opcua_factory_1.initialize_field)(schema.fields[9], options?.minimumSamplingInterval);
        this.historizing = (0, node_opcua_factory_1.initialize_field)(schema.fields[10], options?.historizing);
        this.accessLevelEx = (0, node_opcua_factory_1.initialize_field)(schema.fields[11], options?.accessLevelEx);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.rolePermissions, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.userRolePermissions, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.references, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_variant_1.encodeVariant)(this.value, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.dataType, stream);
        (0, node_opcua_basic_types_1.encodeInt32)(this.valueRank, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.arrayDimensions, stream, node_opcua_basic_types_1.encodeUInt32);
        (0, node_opcua_basic_types_1.encodeByte)(this.accessLevel, stream);
        (0, node_opcua_basic_types_1.encodeByte)(this.userAccessLevel, stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.minimumSamplingInterval, stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.historizing, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.accessLevelEx, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.rolePermissions = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new RolePermissionType(null);
          obj.decode(stream1);
          return obj;
        });
        this.userRolePermissions = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new RolePermissionType(null);
          obj.decode(stream1);
          return obj;
        });
        this.references = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new ReferenceNode(null);
          obj.decode(stream1);
          return obj;
        });
        this.value = (0, node_opcua_variant_1.decodeVariant)(stream, this.value);
        this.dataType = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.dataType);
        this.valueRank = (0, node_opcua_basic_types_1.decodeInt32)(stream, this.valueRank);
        this.arrayDimensions = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeUInt32);
        this.accessLevel = (0, node_opcua_basic_types_1.decodeByte)(stream, this.accessLevel);
        this.userAccessLevel = (0, node_opcua_basic_types_1.decodeByte)(stream, this.userAccessLevel);
        this.minimumSamplingInterval = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.minimumSamplingInterval);
        this.historizing = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.historizing);
        this.accessLevelEx = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.accessLevelEx);
      }
      get schema() {
        return schemaVariableNode;
      }
    };
    exports2.VariableNode = VariableNode;
    VariableNode.possibleFields = [
      "nodeId",
      "nodeClass",
      "browseName",
      "displayName",
      "description",
      "writeMask",
      "userWriteMask",
      "rolePermissions",
      "userRolePermissions",
      "accessRestrictions",
      "references",
      "rolePermissions",
      "userRolePermissions",
      "references",
      "value",
      "dataType",
      "valueRank",
      "arrayDimensions",
      "accessLevel",
      "userAccessLevel",
      "minimumSamplingInterval",
      "historizing",
      "accessLevelEx"
    ];
    VariableNode.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(267, 0);
    VariableNode.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(269, 0);
    VariableNode.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(268, 0);
    VariableNode.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15074, 0);
    VariableNode.schema.dataTypeNodeId = VariableNode.dataTypeNodeId;
    VariableNode.schema.encodingDefaultBinary = VariableNode.encodingDefaultBinary;
    VariableNode.schema.encodingDefaultXml = VariableNode.encodingDefaultXml;
    VariableNode.schema.encodingDefaultJson = VariableNode.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(VariableNode.dataTypeNodeId, "VariableNode", VariableNode);
    var schemaVariableTypeAttributes = (0, node_opcua_factory_1.buildStructuredType)({
      name: "VariableTypeAttributes",
      baseType: "NodeAttributes",
      fields: [
        {
          name: "Value",
          fieldType: "Variant"
        },
        {
          name: "DataType",
          fieldType: "NodeId"
        },
        {
          name: "ValueRank",
          fieldType: "Int32"
        },
        {
          name: "ArrayDimensions",
          fieldType: "UInt32",
          isArray: true
        },
        {
          name: "IsAbstract",
          fieldType: "Boolean"
        }
      ]
    });
    var VariableTypeAttributes = class _VariableTypeAttributes extends NodeAttributes {
      static get schema() {
        return schemaVariableTypeAttributes;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.value = new node_opcua_variant_1.Variant(null);
          this.dataType = new node_opcua_nodeid_1.NodeId(null);
          this.valueRank = 0;
          this.arrayDimensions = [];
          this.isAbstract = false;
          return;
        }
        const schema = _VariableTypeAttributes.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.value = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.value);
        this.dataType = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.dataType);
        this.valueRank = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.valueRank);
        this.arrayDimensions = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[3], options?.arrayDimensions);
        this.isAbstract = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.isAbstract);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_variant_1.encodeVariant)(this.value, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.dataType, stream);
        (0, node_opcua_basic_types_1.encodeInt32)(this.valueRank, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.arrayDimensions, stream, node_opcua_basic_types_1.encodeUInt32);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.isAbstract, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.value = (0, node_opcua_variant_1.decodeVariant)(stream, this.value);
        this.dataType = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.dataType);
        this.valueRank = (0, node_opcua_basic_types_1.decodeInt32)(stream, this.valueRank);
        this.arrayDimensions = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeUInt32);
        this.isAbstract = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.isAbstract);
      }
      get schema() {
        return schemaVariableTypeAttributes;
      }
    };
    exports2.VariableTypeAttributes = VariableTypeAttributes;
    VariableTypeAttributes.possibleFields = [
      "specifiedAttributes",
      "displayName",
      "description",
      "writeMask",
      "userWriteMask",
      "value",
      "dataType",
      "valueRank",
      "arrayDimensions",
      "isAbstract"
    ];
    VariableTypeAttributes.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(364, 0);
    VariableTypeAttributes.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(366, 0);
    VariableTypeAttributes.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(365, 0);
    VariableTypeAttributes.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15159, 0);
    VariableTypeAttributes.schema.dataTypeNodeId = VariableTypeAttributes.dataTypeNodeId;
    VariableTypeAttributes.schema.encodingDefaultBinary = VariableTypeAttributes.encodingDefaultBinary;
    VariableTypeAttributes.schema.encodingDefaultXml = VariableTypeAttributes.encodingDefaultXml;
    VariableTypeAttributes.schema.encodingDefaultJson = VariableTypeAttributes.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(VariableTypeAttributes.dataTypeNodeId, "VariableTypeAttributes", VariableTypeAttributes);
    var schemaVariableTypeNode = (0, node_opcua_factory_1.buildStructuredType)({
      name: "VariableTypeNode",
      baseType: "TypeNode",
      fields: [
        {
          name: "RolePermissions",
          fieldType: "RolePermissionType",
          isArray: true
        },
        {
          name: "UserRolePermissions",
          fieldType: "RolePermissionType",
          isArray: true
        },
        {
          name: "References",
          fieldType: "ReferenceNode",
          isArray: true
        },
        {
          name: "Value",
          fieldType: "Variant"
        },
        {
          name: "DataType",
          fieldType: "NodeId"
        },
        {
          name: "ValueRank",
          fieldType: "Int32"
        },
        {
          name: "ArrayDimensions",
          fieldType: "UInt32",
          isArray: true
        },
        {
          name: "IsAbstract",
          fieldType: "Boolean"
        }
      ]
    });
    var VariableTypeNode = class _VariableTypeNode extends TypeNode {
      static get schema() {
        return schemaVariableTypeNode;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.rolePermissions = null;
          this.userRolePermissions = null;
          this.references = null;
          this.value = new node_opcua_variant_1.Variant(null);
          this.dataType = new node_opcua_nodeid_1.NodeId(null);
          this.valueRank = 0;
          this.arrayDimensions = [];
          this.isAbstract = false;
          return;
        }
        const schema = _VariableTypeNode.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.rolePermissions = [];
        if (options.rolePermissions) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.rolePermissions));
          this.rolePermissions = options.rolePermissions.map((e) => new RolePermissionType(e));
        }
        this.userRolePermissions = [];
        if (options.userRolePermissions) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.userRolePermissions));
          this.userRolePermissions = options.userRolePermissions.map((e) => new RolePermissionType(e));
        }
        this.references = [];
        if (options.references) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.references));
          this.references = options.references.map((e) => new ReferenceNode(e));
        }
        this.value = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.value);
        this.dataType = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.dataType);
        this.valueRank = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options?.valueRank);
        this.arrayDimensions = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[6], options?.arrayDimensions);
        this.isAbstract = (0, node_opcua_factory_1.initialize_field)(schema.fields[7], options?.isAbstract);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.rolePermissions, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.userRolePermissions, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.references, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_variant_1.encodeVariant)(this.value, stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.dataType, stream);
        (0, node_opcua_basic_types_1.encodeInt32)(this.valueRank, stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.arrayDimensions, stream, node_opcua_basic_types_1.encodeUInt32);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.isAbstract, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.rolePermissions = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new RolePermissionType(null);
          obj.decode(stream1);
          return obj;
        });
        this.userRolePermissions = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new RolePermissionType(null);
          obj.decode(stream1);
          return obj;
        });
        this.references = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new ReferenceNode(null);
          obj.decode(stream1);
          return obj;
        });
        this.value = (0, node_opcua_variant_1.decodeVariant)(stream, this.value);
        this.dataType = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.dataType);
        this.valueRank = (0, node_opcua_basic_types_1.decodeInt32)(stream, this.valueRank);
        this.arrayDimensions = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_basic_types_1.decodeUInt32);
        this.isAbstract = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.isAbstract);
      }
      get schema() {
        return schemaVariableTypeNode;
      }
    };
    exports2.VariableTypeNode = VariableTypeNode;
    VariableTypeNode.possibleFields = [
      "nodeId",
      "nodeClass",
      "browseName",
      "displayName",
      "description",
      "writeMask",
      "userWriteMask",
      "rolePermissions",
      "userRolePermissions",
      "accessRestrictions",
      "references",
      "rolePermissions",
      "userRolePermissions",
      "references",
      "value",
      "dataType",
      "valueRank",
      "arrayDimensions",
      "isAbstract"
    ];
    VariableTypeNode.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(270, 0);
    VariableTypeNode.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(272, 0);
    VariableTypeNode.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(271, 0);
    VariableTypeNode.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15075, 0);
    VariableTypeNode.schema.dataTypeNodeId = VariableTypeNode.dataTypeNodeId;
    VariableTypeNode.schema.encodingDefaultBinary = VariableTypeNode.encodingDefaultBinary;
    VariableTypeNode.schema.encodingDefaultXml = VariableTypeNode.encodingDefaultXml;
    VariableTypeNode.schema.encodingDefaultJson = VariableTypeNode.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(VariableTypeNode.dataTypeNodeId, "VariableTypeNode", VariableTypeNode);
    var schemaViewAttributes = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ViewAttributes",
      baseType: "NodeAttributes",
      fields: [
        {
          name: "ContainsNoLoops",
          fieldType: "Boolean"
        },
        {
          name: "EventNotifier",
          fieldType: "Byte"
        }
      ]
    });
    var ViewAttributes = class _ViewAttributes extends NodeAttributes {
      static get schema() {
        return schemaViewAttributes;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.containsNoLoops = false;
          this.eventNotifier = 0;
          return;
        }
        const schema = _ViewAttributes.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.containsNoLoops = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.containsNoLoops);
        this.eventNotifier = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.eventNotifier);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeBoolean)(this.containsNoLoops, stream);
        (0, node_opcua_basic_types_1.encodeByte)(this.eventNotifier, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.containsNoLoops = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.containsNoLoops);
        this.eventNotifier = (0, node_opcua_basic_types_1.decodeByte)(stream, this.eventNotifier);
      }
      get schema() {
        return schemaViewAttributes;
      }
    };
    exports2.ViewAttributes = ViewAttributes;
    ViewAttributes.possibleFields = [
      "specifiedAttributes",
      "displayName",
      "description",
      "writeMask",
      "userWriteMask",
      "containsNoLoops",
      "eventNotifier"
    ];
    ViewAttributes.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(373, 0);
    ViewAttributes.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(375, 0);
    ViewAttributes.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(374, 0);
    ViewAttributes.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15162, 0);
    ViewAttributes.schema.dataTypeNodeId = ViewAttributes.dataTypeNodeId;
    ViewAttributes.schema.encodingDefaultBinary = ViewAttributes.encodingDefaultBinary;
    ViewAttributes.schema.encodingDefaultXml = ViewAttributes.encodingDefaultXml;
    ViewAttributes.schema.encodingDefaultJson = ViewAttributes.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ViewAttributes.dataTypeNodeId, "ViewAttributes", ViewAttributes);
    var schemaViewNode = (0, node_opcua_factory_1.buildStructuredType)({
      name: "ViewNode",
      baseType: "InstanceNode",
      fields: [
        {
          name: "RolePermissions",
          fieldType: "RolePermissionType",
          isArray: true
        },
        {
          name: "UserRolePermissions",
          fieldType: "RolePermissionType",
          isArray: true
        },
        {
          name: "References",
          fieldType: "ReferenceNode",
          isArray: true
        },
        {
          name: "ContainsNoLoops",
          fieldType: "Boolean"
        },
        {
          name: "EventNotifier",
          fieldType: "Byte"
        }
      ]
    });
    var ViewNode = class _ViewNode extends InstanceNode {
      static get schema() {
        return schemaViewNode;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.rolePermissions = null;
          this.userRolePermissions = null;
          this.references = null;
          this.containsNoLoops = false;
          this.eventNotifier = 0;
          return;
        }
        const schema = _ViewNode.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.rolePermissions = [];
        if (options.rolePermissions) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.rolePermissions));
          this.rolePermissions = options.rolePermissions.map((e) => new RolePermissionType(e));
        }
        this.userRolePermissions = [];
        if (options.userRolePermissions) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.userRolePermissions));
          this.userRolePermissions = options.userRolePermissions.map((e) => new RolePermissionType(e));
        }
        this.references = [];
        if (options.references) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.references));
          this.references = options.references.map((e) => new ReferenceNode(e));
        }
        this.containsNoLoops = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.containsNoLoops);
        this.eventNotifier = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options?.eventNotifier);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.rolePermissions, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.userRolePermissions, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeArray)(this.references, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
        (0, node_opcua_basic_types_1.encodeBoolean)(this.containsNoLoops, stream);
        (0, node_opcua_basic_types_1.encodeByte)(this.eventNotifier, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.rolePermissions = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new RolePermissionType(null);
          obj.decode(stream1);
          return obj;
        });
        this.userRolePermissions = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new RolePermissionType(null);
          obj.decode(stream1);
          return obj;
        });
        this.references = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new ReferenceNode(null);
          obj.decode(stream1);
          return obj;
        });
        this.containsNoLoops = (0, node_opcua_basic_types_1.decodeBoolean)(stream, this.containsNoLoops);
        this.eventNotifier = (0, node_opcua_basic_types_1.decodeByte)(stream, this.eventNotifier);
      }
      get schema() {
        return schemaViewNode;
      }
    };
    exports2.ViewNode = ViewNode;
    ViewNode.possibleFields = [
      "nodeId",
      "nodeClass",
      "browseName",
      "displayName",
      "description",
      "writeMask",
      "userWriteMask",
      "rolePermissions",
      "userRolePermissions",
      "accessRestrictions",
      "references",
      "rolePermissions",
      "userRolePermissions",
      "references",
      "containsNoLoops",
      "eventNotifier"
    ];
    ViewNode.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(279, 0);
    ViewNode.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(281, 0);
    ViewNode.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(280, 0);
    ViewNode.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15078, 0);
    ViewNode.schema.dataTypeNodeId = ViewNode.dataTypeNodeId;
    ViewNode.schema.encodingDefaultBinary = ViewNode.encodingDefaultBinary;
    ViewNode.schema.encodingDefaultXml = ViewNode.encodingDefaultXml;
    ViewNode.schema.encodingDefaultJson = ViewNode.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(ViewNode.dataTypeNodeId, "ViewNode", ViewNode);
    var schemaWriteValue = (0, node_opcua_factory_1.buildStructuredType)({
      name: "WriteValue",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "NodeId",
          fieldType: "NodeId"
        },
        {
          name: "AttributeId",
          fieldType: "UInt32"
        },
        {
          name: "IndexRange",
          fieldType: "NumericRange"
        },
        {
          name: "Value",
          fieldType: "DataValue"
        }
      ]
    });
    var WriteValue = class _WriteValue extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaWriteValue;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.nodeId = new node_opcua_nodeid_1.NodeId(null);
          this.attributeId = 0;
          this.indexRange = new node_opcua_numeric_range_1.NumericRange(null);
          this.value = new node_opcua_data_value_1.DataValue(null);
          return;
        }
        const schema = _WriteValue.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.nodeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.nodeId);
        this.attributeId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.attributeId);
        this.indexRange = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options?.indexRange);
        this.value = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options?.value);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeNodeId)(this.nodeId, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.attributeId, stream);
        (0, node_opcua_numeric_range_1.encodeNumericRange)(this.indexRange, stream);
        (0, node_opcua_data_value_1.encodeDataValue)(this.value, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.nodeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream, this.nodeId);
        this.attributeId = (0, node_opcua_basic_types_1.decodeUInt32)(stream, this.attributeId);
        this.indexRange = (0, node_opcua_numeric_range_1.decodeNumericRange)(stream, this.indexRange);
        this.value = (0, node_opcua_data_value_1.decodeDataValue)(stream, this.value);
      }
      get schema() {
        return schemaWriteValue;
      }
    };
    exports2.WriteValue = WriteValue;
    WriteValue.possibleFields = [
      "nodeId",
      "attributeId",
      "indexRange",
      "value"
    ];
    WriteValue.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(668, 0);
    WriteValue.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(670, 0);
    WriteValue.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(669, 0);
    WriteValue.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15276, 0);
    WriteValue.schema.dataTypeNodeId = WriteValue.dataTypeNodeId;
    WriteValue.schema.encodingDefaultBinary = WriteValue.encodingDefaultBinary;
    WriteValue.schema.encodingDefaultXml = WriteValue.encodingDefaultXml;
    WriteValue.schema.encodingDefaultJson = WriteValue.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(WriteValue.dataTypeNodeId, "WriteValue", WriteValue);
    var schemaWriteRequest = (0, node_opcua_factory_1.buildStructuredType)({
      name: "WriteRequest",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "RequestHeader",
          fieldType: "RequestHeader"
        },
        {
          name: "NodesToWrite",
          fieldType: "WriteValue",
          isArray: true
        }
      ]
    });
    var WriteRequest = class _WriteRequest extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaWriteRequest;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.requestHeader = new RequestHeader(null);
          this.nodesToWrite = null;
          return;
        }
        const schema = _WriteRequest.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.requestHeader = new RequestHeader(options.requestHeader);
        this.nodesToWrite = [];
        if (options.nodesToWrite) {
          (0, node_opcua_assert_1.assert)(Array.isArray(options.nodesToWrite));
          this.nodesToWrite = options.nodesToWrite.map((e) => new WriteValue(e));
        }
      }
      encode(stream) {
        super.encode(stream);
        this.requestHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.nodesToWrite, stream, (obj, stream1) => {
          obj.encode(stream1);
        });
      }
      decode(stream) {
        super.decode(stream);
        this.requestHeader.decode(stream);
        this.nodesToWrite = (0, node_opcua_basic_types_1.decodeArray)(stream, (stream1) => {
          const obj = new WriteValue(null);
          obj.decode(stream1);
          return obj;
        });
      }
      get schema() {
        return schemaWriteRequest;
      }
    };
    exports2.WriteRequest = WriteRequest;
    WriteRequest.possibleFields = [
      "requestHeader",
      "nodesToWrite"
    ];
    WriteRequest.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(671, 0);
    WriteRequest.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(673, 0);
    WriteRequest.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(672, 0);
    WriteRequest.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15277, 0);
    WriteRequest.schema.dataTypeNodeId = WriteRequest.dataTypeNodeId;
    WriteRequest.schema.encodingDefaultBinary = WriteRequest.encodingDefaultBinary;
    WriteRequest.schema.encodingDefaultXml = WriteRequest.encodingDefaultXml;
    WriteRequest.schema.encodingDefaultJson = WriteRequest.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(WriteRequest.dataTypeNodeId, "WriteRequest", WriteRequest);
    var schemaWriteResponse = (0, node_opcua_factory_1.buildStructuredType)({
      name: "WriteResponse",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "ResponseHeader",
          fieldType: "ResponseHeader"
        },
        {
          name: "Results",
          fieldType: "StatusCode",
          isArray: true
        },
        {
          name: "DiagnosticInfos",
          fieldType: "DiagnosticInfo",
          isArray: true
        }
      ]
    });
    var WriteResponse = class _WriteResponse extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaWriteResponse;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.responseHeader = new ResponseHeader(null);
          this.results = [];
          this.diagnosticInfos = [];
          return;
        }
        const schema = _WriteResponse.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.responseHeader = new ResponseHeader(options.responseHeader);
        this.results = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[1], options?.results);
        this.diagnosticInfos = (0, node_opcua_factory_1.initialize_field_array)(schema.fields[2], options?.diagnosticInfos);
      }
      encode(stream) {
        super.encode(stream);
        this.responseHeader.encode(stream);
        (0, node_opcua_basic_types_1.encodeArray)(this.results, stream, node_opcua_status_code_1.encodeStatusCode);
        (0, node_opcua_basic_types_1.encodeArray)(this.diagnosticInfos, stream, node_opcua_data_model_1.encodeDiagnosticInfo);
      }
      decode(stream) {
        super.decode(stream);
        this.responseHeader.decode(stream);
        this.results = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_status_code_1.decodeStatusCode);
        this.diagnosticInfos = (0, node_opcua_basic_types_1.decodeArray)(stream, node_opcua_data_model_1.decodeDiagnosticInfo);
      }
      get schema() {
        return schemaWriteResponse;
      }
    };
    exports2.WriteResponse = WriteResponse;
    WriteResponse.possibleFields = [
      "responseHeader",
      "results",
      "diagnosticInfos"
    ];
    WriteResponse.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(674, 0);
    WriteResponse.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(676, 0);
    WriteResponse.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(675, 0);
    WriteResponse.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15278, 0);
    WriteResponse.schema.dataTypeNodeId = WriteResponse.dataTypeNodeId;
    WriteResponse.schema.encodingDefaultBinary = WriteResponse.encodingDefaultBinary;
    WriteResponse.schema.encodingDefaultXml = WriteResponse.encodingDefaultXml;
    WriteResponse.schema.encodingDefaultJson = WriteResponse.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(WriteResponse.dataTypeNodeId, "WriteResponse", WriteResponse);
    var schemaX509IdentityToken = (0, node_opcua_factory_1.buildStructuredType)({
      name: "X509IdentityToken",
      baseType: "UserIdentityToken",
      fields: [
        {
          name: "CertificateData",
          fieldType: "ByteString"
        }
      ]
    });
    var X509IdentityToken = class _X509IdentityToken extends UserIdentityToken {
      static get schema() {
        return schemaX509IdentityToken;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.certificateData = Buffer.alloc(0);
          return;
        }
        const schema = _X509IdentityToken.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.certificateData = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.certificateData);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.certificateData, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.certificateData = (0, node_opcua_basic_types_1.decodeByteString)(stream, this.certificateData);
      }
      get schema() {
        return schemaX509IdentityToken;
      }
    };
    exports2.X509IdentityToken = X509IdentityToken;
    X509IdentityToken.possibleFields = [
      "policyId",
      "certificateData"
    ];
    X509IdentityToken.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(325, 0);
    X509IdentityToken.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(327, 0);
    X509IdentityToken.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(326, 0);
    X509IdentityToken.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15143, 0);
    X509IdentityToken.schema.dataTypeNodeId = X509IdentityToken.dataTypeNodeId;
    X509IdentityToken.schema.encodingDefaultBinary = X509IdentityToken.encodingDefaultBinary;
    X509IdentityToken.schema.encodingDefaultXml = X509IdentityToken.encodingDefaultXml;
    X509IdentityToken.schema.encodingDefaultJson = X509IdentityToken.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(X509IdentityToken.dataTypeNodeId, "X509IdentityToken", X509IdentityToken);
    var schemaXVType = (0, node_opcua_factory_1.buildStructuredType)({
      name: "XVType",
      baseType: "ExtensionObject",
      fields: [
        {
          name: "X",
          fieldType: "Double"
        },
        {
          name: "Value",
          fieldType: "Float"
        }
      ]
    });
    var XVType = class _XVType extends node_opcua_extension_object_1.ExtensionObject {
      static get schema() {
        return schemaXVType;
      }
      constructor(options) {
        super(options);
        if (options === null) {
          this.x = 0;
          this.value = 0;
          return;
        }
        const schema = _XVType.schema;
        options = (schema.constructHook ? schema.constructHook(options) : options) || {};
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.x = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options?.x);
        this.value = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options?.value);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeDouble)(this.x, stream);
        (0, node_opcua_basic_types_1.encodeFloat)(this.value, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.x = (0, node_opcua_basic_types_1.decodeDouble)(stream, this.x);
        this.value = (0, node_opcua_basic_types_1.decodeFloat)(stream, this.value);
      }
      get schema() {
        return schemaXVType;
      }
    };
    exports2.XVType = XVType;
    XVType.possibleFields = [
      "x",
      "value"
    ];
    XVType.dataTypeNodeId = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12080, 0);
    XVType.encodingDefaultBinary = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12090, 0);
    XVType.encodingDefaultXml = (0, node_opcua_nodeid_1.makeExpandedNodeId)(12082, 0);
    XVType.encodingDefaultJson = (0, node_opcua_nodeid_1.makeExpandedNodeId)(15380, 0);
    XVType.schema.dataTypeNodeId = XVType.dataTypeNodeId;
    XVType.schema.encodingDefaultBinary = XVType.encodingDefaultBinary;
    XVType.schema.encodingDefaultXml = XVType.encodingDefaultXml;
    XVType.schema.encodingDefaultJson = XVType.encodingDefaultJson;
    (0, node_opcua_factory_1.registerClassDefinition)(XVType.dataTypeNodeId, "XVType", XVType);
  }
});

// node_modules/node-opcua-types/dist/index.js
var require_dist32 = __commonJS({
  "node_modules/node-opcua-types/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_generated_opcua_types(), exports2);
  }
});

// node_modules/node-opcua-common/dist/applicationurn.js
var require_applicationurn = __commonJS({
  "node_modules/node-opcua-common/dist/applicationurn.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.makeApplicationUrn = void 0;
    var crypto_1 = require("crypto");
    var node_opcua_assert_1 = require_dist14();
    function makeApplicationUrn(hostname2, suffix) {
      (0, node_opcua_assert_1.assert)(!suffix.match(/urn:/), "already a application URN ?");
      let hostnameHash = hostname2;
      if (hostnameHash.length + 7 + suffix.length >= 64) {
        hostnameHash = (0, crypto_1.createHash)("md5").update(hostname2).digest("hex").substring(0, 16);
      }
      const applicationUrn = "urn:" + hostnameHash + ":" + suffix;
      (0, node_opcua_assert_1.assert)(applicationUrn.length <= 64);
      return applicationUrn;
    }
    exports2.makeApplicationUrn = makeApplicationUrn;
  }
});

// node_modules/jsrsasign/lib/jsrsasign.js
var require_jsrsasign = __commonJS({
  "node_modules/jsrsasign/lib/jsrsasign.js"(exports2) {
    var navigator2 = {};
    navigator2.userAgent = false;
    var window2 = {};
    var VERSION2 = "11.1.0";
    var VERSION_FULL = "jsrsasign(all) 11.1.0 (2024-02-01) (c) 2010-2023 Kenji Urushima | kjur.github.io/jsrsasign/license";
    var CryptoJS = CryptoJS || function(e, g2) {
      var a = {};
      var b = a.lib = {};
      var j = b.Base = /* @__PURE__ */ function() {
        function n() {
        }
        return { extend: function(p3) {
          n.prototype = this;
          var o2 = new n();
          if (p3) {
            o2.mixIn(p3);
          }
          if (!o2.hasOwnProperty("init")) {
            o2.init = function() {
              o2.$super.init.apply(this, arguments);
            };
          }
          o2.init.prototype = o2;
          o2.$super = this;
          return o2;
        }, create: function() {
          var o2 = this.extend();
          o2.init.apply(o2, arguments);
          return o2;
        }, init: function() {
        }, mixIn: function(p3) {
          for (var o2 in p3) {
            if (p3.hasOwnProperty(o2)) {
              this[o2] = p3[o2];
            }
          }
          if (p3.hasOwnProperty("toString")) {
            this.toString = p3.toString;
          }
        }, clone: function() {
          return this.init.prototype.extend(this);
        } };
      }();
      var l2 = b.WordArray = j.extend({ init: function(o2, n) {
        o2 = this.words = o2 || [];
        if (n != g2) {
          this.sigBytes = n;
        } else {
          this.sigBytes = o2.length * 4;
        }
      }, toString: function(n) {
        return (n || h).stringify(this);
      }, concat: function(t2) {
        var q2 = this.words;
        var p3 = t2.words;
        var n = this.sigBytes;
        var s = t2.sigBytes;
        this.clamp();
        if (n % 4) {
          for (var r = 0; r < s; r++) {
            var o2 = p3[r >>> 2] >>> 24 - r % 4 * 8 & 255;
            q2[n + r >>> 2] |= o2 << 24 - (n + r) % 4 * 8;
          }
        } else {
          for (var r = 0; r < s; r += 4) {
            q2[n + r >>> 2] = p3[r >>> 2];
          }
        }
        this.sigBytes += s;
        return this;
      }, clamp: function() {
        var o2 = this.words;
        var n = this.sigBytes;
        o2[n >>> 2] &= 4294967295 << 32 - n % 4 * 8;
        o2.length = e.ceil(n / 4);
      }, clone: function() {
        var n = j.clone.call(this);
        n.words = this.words.slice(0);
        return n;
      }, random: function(p3) {
        var o2 = [];
        for (var n = 0; n < p3; n += 4) {
          o2.push(e.random() * 4294967296 | 0);
        }
        return new l2.init(o2, p3);
      } });
      var m2 = a.enc = {};
      var h = m2.Hex = { stringify: function(p3) {
        var r = p3.words;
        var o2 = p3.sigBytes;
        var q2 = [];
        for (var n = 0; n < o2; n++) {
          var s = r[n >>> 2] >>> 24 - n % 4 * 8 & 255;
          q2.push((s >>> 4).toString(16));
          q2.push((s & 15).toString(16));
        }
        return q2.join("");
      }, parse: function(p3) {
        var n = p3.length;
        var q2 = [];
        for (var o2 = 0; o2 < n; o2 += 2) {
          q2[o2 >>> 3] |= parseInt(p3.substr(o2, 2), 16) << 24 - o2 % 8 * 4;
        }
        return new l2.init(q2, n / 2);
      } };
      var d2 = m2.Latin1 = { stringify: function(q2) {
        var r = q2.words;
        var p3 = q2.sigBytes;
        var n = [];
        for (var o2 = 0; o2 < p3; o2++) {
          var s = r[o2 >>> 2] >>> 24 - o2 % 4 * 8 & 255;
          n.push(String.fromCharCode(s));
        }
        return n.join("");
      }, parse: function(p3) {
        var n = p3.length;
        var q2 = [];
        for (var o2 = 0; o2 < n; o2++) {
          q2[o2 >>> 2] |= (p3.charCodeAt(o2) & 255) << 24 - o2 % 4 * 8;
        }
        return new l2.init(q2, n);
      } };
      var c2 = m2.Utf8 = { stringify: function(n) {
        try {
          return decodeURIComponent(escape(d2.stringify(n)));
        } catch (o2) {
          throw new Error("Malformed UTF-8 data");
        }
      }, parse: function(n) {
        return d2.parse(unescape(encodeURIComponent(n)));
      } };
      var i = b.BufferedBlockAlgorithm = j.extend({ reset: function() {
        this._data = new l2.init();
        this._nDataBytes = 0;
      }, _append: function(n) {
        if (typeof n == "string") {
          n = c2.parse(n);
        }
        this._data.concat(n);
        this._nDataBytes += n.sigBytes;
      }, _process: function(w) {
        var q2 = this._data;
        var x2 = q2.words;
        var n = q2.sigBytes;
        var t2 = this.blockSize;
        var v = t2 * 4;
        var u2 = n / v;
        if (w) {
          u2 = e.ceil(u2);
        } else {
          u2 = e.max((u2 | 0) - this._minBufferSize, 0);
        }
        var s = u2 * t2;
        var r = e.min(s * 4, n);
        if (s) {
          for (var p3 = 0; p3 < s; p3 += t2) {
            this._doProcessBlock(x2, p3);
          }
          var o2 = x2.splice(0, s);
          q2.sigBytes -= r;
        }
        return new l2.init(o2, r);
      }, clone: function() {
        var n = j.clone.call(this);
        n._data = this._data.clone();
        return n;
      }, _minBufferSize: 0 });
      var f2 = b.Hasher = i.extend({ cfg: j.extend(), init: function(n) {
        this.cfg = this.cfg.extend(n);
        this.reset();
      }, reset: function() {
        i.reset.call(this);
        this._doReset();
      }, update: function(n) {
        this._append(n);
        this._process();
        return this;
      }, finalize: function(n) {
        if (n) {
          this._append(n);
        }
        var o2 = this._doFinalize();
        return o2;
      }, blockSize: 512 / 32, _createHelper: function(n) {
        return function(p3, o2) {
          return new n.init(o2).finalize(p3);
        };
      }, _createHmacHelper: function(n) {
        return function(p3, o2) {
          return new k.HMAC.init(n, o2).finalize(p3);
        };
      } });
      var k = a.algo = {};
      return a;
    }(Math);
    (function(g2) {
      var a = CryptoJS, f2 = a.lib, e = f2.Base, h = f2.WordArray, a = a.x64 = {};
      a.Word = e.extend({ init: function(b, c2) {
        this.high = b;
        this.low = c2;
      } });
      a.WordArray = e.extend({ init: function(b, c2) {
        b = this.words = b || [];
        this.sigBytes = c2 != g2 ? c2 : 8 * b.length;
      }, toX32: function() {
        for (var b = this.words, c2 = b.length, a2 = [], d2 = 0; d2 < c2; d2++) {
          var e2 = b[d2];
          a2.push(e2.high);
          a2.push(e2.low);
        }
        return h.create(a2, this.sigBytes);
      }, clone: function() {
        for (var b = e.clone.call(this), c2 = b.words = this.words.slice(0), a2 = c2.length, d2 = 0; d2 < a2; d2++)
          c2[d2] = c2[d2].clone();
        return b;
      } });
    })();
    CryptoJS.lib.Cipher || function(u2) {
      var g2 = CryptoJS, f2 = g2.lib, k = f2.Base, l2 = f2.WordArray, q2 = f2.BufferedBlockAlgorithm, r = g2.enc.Base64, v = g2.algo.EvpKDF, n = f2.Cipher = q2.extend({ cfg: k.extend(), createEncryptor: function(a, b) {
        return this.create(this._ENC_XFORM_MODE, a, b);
      }, createDecryptor: function(a, b) {
        return this.create(this._DEC_XFORM_MODE, a, b);
      }, init: function(a, b, c2) {
        this.cfg = this.cfg.extend(c2);
        this._xformMode = a;
        this._key = b;
        this.reset();
      }, reset: function() {
        q2.reset.call(this);
        this._doReset();
      }, process: function(a) {
        this._append(a);
        return this._process();
      }, finalize: function(a) {
        a && this._append(a);
        return this._doFinalize();
      }, keySize: 4, ivSize: 4, _ENC_XFORM_MODE: 1, _DEC_XFORM_MODE: 2, _createHelper: function(a) {
        return { encrypt: function(b, c2, d2) {
          return ("string" == typeof c2 ? s : j).encrypt(a, b, c2, d2);
        }, decrypt: function(b, c2, d2) {
          return ("string" == typeof c2 ? s : j).decrypt(a, b, c2, d2);
        } };
      } });
      f2.StreamCipher = n.extend({ _doFinalize: function() {
        return this._process(true);
      }, blockSize: 1 });
      var m2 = g2.mode = {}, t2 = function(a, b, c2) {
        var d2 = this._iv;
        d2 ? this._iv = u2 : d2 = this._prevBlock;
        for (var e = 0; e < c2; e++)
          a[b + e] ^= d2[e];
      }, h = (f2.BlockCipherMode = k.extend({ createEncryptor: function(a, b) {
        return this.Encryptor.create(a, b);
      }, createDecryptor: function(a, b) {
        return this.Decryptor.create(a, b);
      }, init: function(a, b) {
        this._cipher = a;
        this._iv = b;
      } })).extend();
      h.Encryptor = h.extend({ processBlock: function(a, b) {
        var c2 = this._cipher, d2 = c2.blockSize;
        t2.call(this, a, b, d2);
        c2.encryptBlock(a, b);
        this._prevBlock = a.slice(b, b + d2);
      } });
      h.Decryptor = h.extend({ processBlock: function(a, b) {
        var c2 = this._cipher, d2 = c2.blockSize, e = a.slice(b, b + d2);
        c2.decryptBlock(
          a,
          b
        );
        t2.call(this, a, b, d2);
        this._prevBlock = e;
      } });
      m2 = m2.CBC = h;
      h = (g2.pad = {}).Pkcs7 = { pad: function(a, b) {
        for (var c2 = 4 * b, c2 = c2 - a.sigBytes % c2, d2 = c2 << 24 | c2 << 16 | c2 << 8 | c2, e = [], f3 = 0; f3 < c2; f3 += 4)
          e.push(d2);
        c2 = l2.create(e, c2);
        a.concat(c2);
      }, unpad: function(a) {
        a.sigBytes -= a.words[a.sigBytes - 1 >>> 2] & 255;
      } };
      f2.BlockCipher = n.extend({ cfg: n.cfg.extend({ mode: m2, padding: h }), reset: function() {
        n.reset.call(this);
        var a = this.cfg, b = a.iv, a = a.mode;
        if (this._xformMode == this._ENC_XFORM_MODE)
          var c2 = a.createEncryptor;
        else
          c2 = a.createDecryptor, this._minBufferSize = 1;
        this._mode = c2.call(a, this, b && b.words);
      }, _doProcessBlock: function(a, b) {
        this._mode.processBlock(a, b);
      }, _doFinalize: function() {
        var a = this.cfg.padding;
        if (this._xformMode == this._ENC_XFORM_MODE) {
          a.pad(this._data, this.blockSize);
          var b = this._process(true);
        } else
          b = this._process(true), a.unpad(b);
        return b;
      }, blockSize: 4 });
      var p3 = f2.CipherParams = k.extend({ init: function(a) {
        this.mixIn(a);
      }, toString: function(a) {
        return (a || this.formatter).stringify(this);
      } }), m2 = (g2.format = {}).OpenSSL = { stringify: function(a) {
        var b = a.ciphertext;
        a = a.salt;
        return (a ? l2.create([1398893684, 1701076831]).concat(a).concat(b) : b).toString(r);
      }, parse: function(a) {
        a = r.parse(a);
        var b = a.words;
        if (1398893684 == b[0] && 1701076831 == b[1]) {
          var c2 = l2.create(b.slice(2, 4));
          b.splice(0, 4);
          a.sigBytes -= 16;
        }
        return p3.create({ ciphertext: a, salt: c2 });
      } }, j = f2.SerializableCipher = k.extend({ cfg: k.extend({ format: m2 }), encrypt: function(a, b, c2, d2) {
        d2 = this.cfg.extend(d2);
        var e = a.createEncryptor(c2, d2);
        b = e.finalize(b);
        e = e.cfg;
        return p3.create({
          ciphertext: b,
          key: c2,
          iv: e.iv,
          algorithm: a,
          mode: e.mode,
          padding: e.padding,
          blockSize: a.blockSize,
          formatter: d2.format
        });
      }, decrypt: function(a, b, c2, d2) {
        d2 = this.cfg.extend(d2);
        b = this._parse(b, d2.format);
        return a.createDecryptor(c2, d2).finalize(b.ciphertext);
      }, _parse: function(a, b) {
        return "string" == typeof a ? b.parse(a, this) : a;
      } }), g2 = (g2.kdf = {}).OpenSSL = { execute: function(a, b, c2, d2) {
        d2 || (d2 = l2.random(8));
        a = v.create({ keySize: b + c2 }).compute(a, d2);
        c2 = l2.create(a.words.slice(b), 4 * c2);
        a.sigBytes = 4 * b;
        return p3.create({ key: a, iv: c2, salt: d2 });
      } }, s = f2.PasswordBasedCipher = j.extend({ cfg: j.cfg.extend({ kdf: g2 }), encrypt: function(a, b, c2, d2) {
        d2 = this.cfg.extend(d2);
        c2 = d2.kdf.execute(c2, a.keySize, a.ivSize);
        d2.iv = c2.iv;
        a = j.encrypt.call(this, a, b, c2.key, d2);
        a.mixIn(c2);
        return a;
      }, decrypt: function(a, b, c2, d2) {
        d2 = this.cfg.extend(d2);
        b = this._parse(b, d2.format);
        c2 = d2.kdf.execute(c2, a.keySize, a.ivSize, b.salt);
        d2.iv = c2.iv;
        return j.decrypt.call(this, a, b, c2.key, d2);
      } });
    }();
    (function() {
      for (var q2 = CryptoJS, x2 = q2.lib.BlockCipher, r = q2.algo, j = [], y = [], z2 = [], A = [], B = [], C = [], s = [], u2 = [], v = [], w = [], g2 = [], k = 0; 256 > k; k++)
        g2[k] = 128 > k ? k << 1 : k << 1 ^ 283;
      for (var n = 0, l2 = 0, k = 0; 256 > k; k++) {
        var f2 = l2 ^ l2 << 1 ^ l2 << 2 ^ l2 << 3 ^ l2 << 4, f2 = f2 >>> 8 ^ f2 & 255 ^ 99;
        j[n] = f2;
        y[f2] = n;
        var t2 = g2[n], D = g2[t2], E = g2[D], b = 257 * g2[f2] ^ 16843008 * f2;
        z2[n] = b << 24 | b >>> 8;
        A[n] = b << 16 | b >>> 16;
        B[n] = b << 8 | b >>> 24;
        C[n] = b;
        b = 16843009 * E ^ 65537 * D ^ 257 * t2 ^ 16843008 * n;
        s[f2] = b << 24 | b >>> 8;
        u2[f2] = b << 16 | b >>> 16;
        v[f2] = b << 8 | b >>> 24;
        w[f2] = b;
        n ? (n = t2 ^ g2[g2[g2[E ^ t2]]], l2 ^= g2[g2[l2]]) : n = l2 = 1;
      }
      var F = [
        0,
        1,
        2,
        4,
        8,
        16,
        32,
        64,
        128,
        27,
        54
      ], r = r.AES = x2.extend({ _doReset: function() {
        for (var c2 = this._key, e = c2.words, a = c2.sigBytes / 4, c2 = 4 * ((this._nRounds = a + 6) + 1), b2 = this._keySchedule = [], h = 0; h < c2; h++)
          if (h < a)
            b2[h] = e[h];
          else {
            var d2 = b2[h - 1];
            h % a ? 6 < a && 4 == h % a && (d2 = j[d2 >>> 24] << 24 | j[d2 >>> 16 & 255] << 16 | j[d2 >>> 8 & 255] << 8 | j[d2 & 255]) : (d2 = d2 << 8 | d2 >>> 24, d2 = j[d2 >>> 24] << 24 | j[d2 >>> 16 & 255] << 16 | j[d2 >>> 8 & 255] << 8 | j[d2 & 255], d2 ^= F[h / a | 0] << 24);
            b2[h] = b2[h - a] ^ d2;
          }
        e = this._invKeySchedule = [];
        for (a = 0; a < c2; a++)
          h = c2 - a, d2 = a % 4 ? b2[h] : b2[h - 4], e[a] = 4 > a || 4 >= h ? d2 : s[j[d2 >>> 24]] ^ u2[j[d2 >>> 16 & 255]] ^ v[j[d2 >>> 8 & 255]] ^ w[j[d2 & 255]];
      }, encryptBlock: function(c2, e) {
        this._doCryptBlock(c2, e, this._keySchedule, z2, A, B, C, j);
      }, decryptBlock: function(c2, e) {
        var a = c2[e + 1];
        c2[e + 1] = c2[e + 3];
        c2[e + 3] = a;
        this._doCryptBlock(c2, e, this._invKeySchedule, s, u2, v, w, y);
        a = c2[e + 1];
        c2[e + 1] = c2[e + 3];
        c2[e + 3] = a;
      }, _doCryptBlock: function(c2, e, a, b2, h, d2, j2, m2) {
        for (var n2 = this._nRounds, f3 = c2[e] ^ a[0], g3 = c2[e + 1] ^ a[1], k2 = c2[e + 2] ^ a[2], p3 = c2[e + 3] ^ a[3], l3 = 4, t3 = 1; t3 < n2; t3++)
          var q3 = b2[f3 >>> 24] ^ h[g3 >>> 16 & 255] ^ d2[k2 >>> 8 & 255] ^ j2[p3 & 255] ^ a[l3++], r2 = b2[g3 >>> 24] ^ h[k2 >>> 16 & 255] ^ d2[p3 >>> 8 & 255] ^ j2[f3 & 255] ^ a[l3++], s2 = b2[k2 >>> 24] ^ h[p3 >>> 16 & 255] ^ d2[f3 >>> 8 & 255] ^ j2[g3 & 255] ^ a[l3++], p3 = b2[p3 >>> 24] ^ h[f3 >>> 16 & 255] ^ d2[g3 >>> 8 & 255] ^ j2[k2 & 255] ^ a[l3++], f3 = q3, g3 = r2, k2 = s2;
        q3 = (m2[f3 >>> 24] << 24 | m2[g3 >>> 16 & 255] << 16 | m2[k2 >>> 8 & 255] << 8 | m2[p3 & 255]) ^ a[l3++];
        r2 = (m2[g3 >>> 24] << 24 | m2[k2 >>> 16 & 255] << 16 | m2[p3 >>> 8 & 255] << 8 | m2[f3 & 255]) ^ a[l3++];
        s2 = (m2[k2 >>> 24] << 24 | m2[p3 >>> 16 & 255] << 16 | m2[f3 >>> 8 & 255] << 8 | m2[g3 & 255]) ^ a[l3++];
        p3 = (m2[p3 >>> 24] << 24 | m2[f3 >>> 16 & 255] << 16 | m2[g3 >>> 8 & 255] << 8 | m2[k2 & 255]) ^ a[l3++];
        c2[e] = q3;
        c2[e + 1] = r2;
        c2[e + 2] = s2;
        c2[e + 3] = p3;
      }, keySize: 8 });
      q2.AES = x2._createHelper(r);
    })();
    (function() {
      function j(b, c2) {
        var a = (this._lBlock >>> b ^ this._rBlock) & c2;
        this._rBlock ^= a;
        this._lBlock ^= a << b;
      }
      function l2(b, c2) {
        var a = (this._rBlock >>> b ^ this._lBlock) & c2;
        this._lBlock ^= a;
        this._rBlock ^= a << b;
      }
      var h = CryptoJS, e = h.lib, n = e.WordArray, e = e.BlockCipher, g2 = h.algo, q2 = [57, 49, 41, 33, 25, 17, 9, 1, 58, 50, 42, 34, 26, 18, 10, 2, 59, 51, 43, 35, 27, 19, 11, 3, 60, 52, 44, 36, 63, 55, 47, 39, 31, 23, 15, 7, 62, 54, 46, 38, 30, 22, 14, 6, 61, 53, 45, 37, 29, 21, 13, 5, 28, 20, 12, 4], p3 = [
        14,
        17,
        11,
        24,
        1,
        5,
        3,
        28,
        15,
        6,
        21,
        10,
        23,
        19,
        12,
        4,
        26,
        8,
        16,
        7,
        27,
        20,
        13,
        2,
        41,
        52,
        31,
        37,
        47,
        55,
        30,
        40,
        51,
        45,
        33,
        48,
        44,
        49,
        39,
        56,
        34,
        53,
        46,
        42,
        50,
        36,
        29,
        32
      ], r = [1, 2, 4, 6, 8, 10, 12, 14, 15, 17, 19, 21, 23, 25, 27, 28], s = [{
        "0": 8421888,
        268435456: 32768,
        536870912: 8421378,
        805306368: 2,
        1073741824: 512,
        1342177280: 8421890,
        1610612736: 8389122,
        1879048192: 8388608,
        2147483648: 514,
        2415919104: 8389120,
        2684354560: 33280,
        2952790016: 8421376,
        3221225472: 32770,
        3489660928: 8388610,
        3758096384: 0,
        4026531840: 33282,
        134217728: 0,
        402653184: 8421890,
        671088640: 33282,
        939524096: 32768,
        1207959552: 8421888,
        1476395008: 512,
        1744830464: 8421378,
        2013265920: 2,
        2281701376: 8389120,
        2550136832: 33280,
        2818572288: 8421376,
        3087007744: 8389122,
        3355443200: 8388610,
        3623878656: 32770,
        3892314112: 514,
        4160749568: 8388608,
        1: 32768,
        268435457: 2,
        536870913: 8421888,
        805306369: 8388608,
        1073741825: 8421378,
        1342177281: 33280,
        1610612737: 512,
        1879048193: 8389122,
        2147483649: 8421890,
        2415919105: 8421376,
        2684354561: 8388610,
        2952790017: 33282,
        3221225473: 514,
        3489660929: 8389120,
        3758096385: 32770,
        4026531841: 0,
        134217729: 8421890,
        402653185: 8421376,
        671088641: 8388608,
        939524097: 512,
        1207959553: 32768,
        1476395009: 8388610,
        1744830465: 2,
        2013265921: 33282,
        2281701377: 32770,
        2550136833: 8389122,
        2818572289: 514,
        3087007745: 8421888,
        3355443201: 8389120,
        3623878657: 0,
        3892314113: 33280,
        4160749569: 8421378
      }, {
        "0": 1074282512,
        16777216: 16384,
        33554432: 524288,
        50331648: 1074266128,
        67108864: 1073741840,
        83886080: 1074282496,
        100663296: 1073758208,
        117440512: 16,
        134217728: 540672,
        150994944: 1073758224,
        167772160: 1073741824,
        184549376: 540688,
        201326592: 524304,
        218103808: 0,
        234881024: 16400,
        251658240: 1074266112,
        8388608: 1073758208,
        25165824: 540688,
        41943040: 16,
        58720256: 1073758224,
        75497472: 1074282512,
        92274688: 1073741824,
        109051904: 524288,
        125829120: 1074266128,
        142606336: 524304,
        159383552: 0,
        176160768: 16384,
        192937984: 1074266112,
        209715200: 1073741840,
        226492416: 540672,
        243269632: 1074282496,
        260046848: 16400,
        268435456: 0,
        285212672: 1074266128,
        301989888: 1073758224,
        318767104: 1074282496,
        335544320: 1074266112,
        352321536: 16,
        369098752: 540688,
        385875968: 16384,
        402653184: 16400,
        419430400: 524288,
        436207616: 524304,
        452984832: 1073741840,
        469762048: 540672,
        486539264: 1073758208,
        503316480: 1073741824,
        520093696: 1074282512,
        276824064: 540688,
        293601280: 524288,
        310378496: 1074266112,
        327155712: 16384,
        343932928: 1073758208,
        360710144: 1074282512,
        377487360: 16,
        394264576: 1073741824,
        411041792: 1074282496,
        427819008: 1073741840,
        444596224: 1073758224,
        461373440: 524304,
        478150656: 0,
        494927872: 16400,
        511705088: 1074266128,
        528482304: 540672
      }, {
        "0": 260,
        1048576: 0,
        2097152: 67109120,
        3145728: 65796,
        4194304: 65540,
        5242880: 67108868,
        6291456: 67174660,
        7340032: 67174400,
        8388608: 67108864,
        9437184: 67174656,
        10485760: 65792,
        11534336: 67174404,
        12582912: 67109124,
        13631488: 65536,
        14680064: 4,
        15728640: 256,
        524288: 67174656,
        1572864: 67174404,
        2621440: 0,
        3670016: 67109120,
        4718592: 67108868,
        5767168: 65536,
        6815744: 65540,
        7864320: 260,
        8912896: 4,
        9961472: 256,
        11010048: 67174400,
        12058624: 65796,
        13107200: 65792,
        14155776: 67109124,
        15204352: 67174660,
        16252928: 67108864,
        16777216: 67174656,
        17825792: 65540,
        18874368: 65536,
        19922944: 67109120,
        20971520: 256,
        22020096: 67174660,
        23068672: 67108868,
        24117248: 0,
        25165824: 67109124,
        26214400: 67108864,
        27262976: 4,
        28311552: 65792,
        29360128: 67174400,
        30408704: 260,
        31457280: 65796,
        32505856: 67174404,
        17301504: 67108864,
        18350080: 260,
        19398656: 67174656,
        20447232: 0,
        21495808: 65540,
        22544384: 67109120,
        23592960: 256,
        24641536: 67174404,
        25690112: 65536,
        26738688: 67174660,
        27787264: 65796,
        28835840: 67108868,
        29884416: 67109124,
        30932992: 67174400,
        31981568: 4,
        33030144: 65792
      }, {
        "0": 2151682048,
        65536: 2147487808,
        131072: 4198464,
        196608: 2151677952,
        262144: 0,
        327680: 4198400,
        393216: 2147483712,
        458752: 4194368,
        524288: 2147483648,
        589824: 4194304,
        655360: 64,
        720896: 2147487744,
        786432: 2151678016,
        851968: 4160,
        917504: 4096,
        983040: 2151682112,
        32768: 2147487808,
        98304: 64,
        163840: 2151678016,
        229376: 2147487744,
        294912: 4198400,
        360448: 2151682112,
        425984: 0,
        491520: 2151677952,
        557056: 4096,
        622592: 2151682048,
        688128: 4194304,
        753664: 4160,
        819200: 2147483648,
        884736: 4194368,
        950272: 4198464,
        1015808: 2147483712,
        1048576: 4194368,
        1114112: 4198400,
        1179648: 2147483712,
        1245184: 0,
        1310720: 4160,
        1376256: 2151678016,
        1441792: 2151682048,
        1507328: 2147487808,
        1572864: 2151682112,
        1638400: 2147483648,
        1703936: 2151677952,
        1769472: 4198464,
        1835008: 2147487744,
        1900544: 4194304,
        1966080: 64,
        2031616: 4096,
        1081344: 2151677952,
        1146880: 2151682112,
        1212416: 0,
        1277952: 4198400,
        1343488: 4194368,
        1409024: 2147483648,
        1474560: 2147487808,
        1540096: 64,
        1605632: 2147483712,
        1671168: 4096,
        1736704: 2147487744,
        1802240: 2151678016,
        1867776: 4160,
        1933312: 2151682048,
        1998848: 4194304,
        2064384: 4198464
      }, {
        "0": 128,
        4096: 17039360,
        8192: 262144,
        12288: 536870912,
        16384: 537133184,
        20480: 16777344,
        24576: 553648256,
        28672: 262272,
        32768: 16777216,
        36864: 537133056,
        40960: 536871040,
        45056: 553910400,
        49152: 553910272,
        53248: 0,
        57344: 17039488,
        61440: 553648128,
        2048: 17039488,
        6144: 553648256,
        10240: 128,
        14336: 17039360,
        18432: 262144,
        22528: 537133184,
        26624: 553910272,
        30720: 536870912,
        34816: 537133056,
        38912: 0,
        43008: 553910400,
        47104: 16777344,
        51200: 536871040,
        55296: 553648128,
        59392: 16777216,
        63488: 262272,
        65536: 262144,
        69632: 128,
        73728: 536870912,
        77824: 553648256,
        81920: 16777344,
        86016: 553910272,
        90112: 537133184,
        94208: 16777216,
        98304: 553910400,
        102400: 553648128,
        106496: 17039360,
        110592: 537133056,
        114688: 262272,
        118784: 536871040,
        122880: 0,
        126976: 17039488,
        67584: 553648256,
        71680: 16777216,
        75776: 17039360,
        79872: 537133184,
        83968: 536870912,
        88064: 17039488,
        92160: 128,
        96256: 553910272,
        100352: 262272,
        104448: 553910400,
        108544: 0,
        112640: 553648128,
        116736: 16777344,
        120832: 262144,
        124928: 537133056,
        129024: 536871040
      }, {
        "0": 268435464,
        256: 8192,
        512: 270532608,
        768: 270540808,
        1024: 268443648,
        1280: 2097152,
        1536: 2097160,
        1792: 268435456,
        2048: 0,
        2304: 268443656,
        2560: 2105344,
        2816: 8,
        3072: 270532616,
        3328: 2105352,
        3584: 8200,
        3840: 270540800,
        128: 270532608,
        384: 270540808,
        640: 8,
        896: 2097152,
        1152: 2105352,
        1408: 268435464,
        1664: 268443648,
        1920: 8200,
        2176: 2097160,
        2432: 8192,
        2688: 268443656,
        2944: 270532616,
        3200: 0,
        3456: 270540800,
        3712: 2105344,
        3968: 268435456,
        4096: 268443648,
        4352: 270532616,
        4608: 270540808,
        4864: 8200,
        5120: 2097152,
        5376: 268435456,
        5632: 268435464,
        5888: 2105344,
        6144: 2105352,
        6400: 0,
        6656: 8,
        6912: 270532608,
        7168: 8192,
        7424: 268443656,
        7680: 270540800,
        7936: 2097160,
        4224: 8,
        4480: 2105344,
        4736: 2097152,
        4992: 268435464,
        5248: 268443648,
        5504: 8200,
        5760: 270540808,
        6016: 270532608,
        6272: 270540800,
        6528: 270532616,
        6784: 8192,
        7040: 2105352,
        7296: 2097160,
        7552: 0,
        7808: 268435456,
        8064: 268443656
      }, {
        "0": 1048576,
        16: 33555457,
        32: 1024,
        48: 1049601,
        64: 34604033,
        80: 0,
        96: 1,
        112: 34603009,
        128: 33555456,
        144: 1048577,
        160: 33554433,
        176: 34604032,
        192: 34603008,
        208: 1025,
        224: 1049600,
        240: 33554432,
        8: 34603009,
        24: 0,
        40: 33555457,
        56: 34604032,
        72: 1048576,
        88: 33554433,
        104: 33554432,
        120: 1025,
        136: 1049601,
        152: 33555456,
        168: 34603008,
        184: 1048577,
        200: 1024,
        216: 34604033,
        232: 1,
        248: 1049600,
        256: 33554432,
        272: 1048576,
        288: 33555457,
        304: 34603009,
        320: 1048577,
        336: 33555456,
        352: 34604032,
        368: 1049601,
        384: 1025,
        400: 34604033,
        416: 1049600,
        432: 1,
        448: 0,
        464: 34603008,
        480: 33554433,
        496: 1024,
        264: 1049600,
        280: 33555457,
        296: 34603009,
        312: 1,
        328: 33554432,
        344: 1048576,
        360: 1025,
        376: 34604032,
        392: 33554433,
        408: 34603008,
        424: 0,
        440: 34604033,
        456: 1049601,
        472: 1024,
        488: 33555456,
        504: 1048577
      }, {
        "0": 134219808,
        1: 131072,
        2: 134217728,
        3: 32,
        4: 131104,
        5: 134350880,
        6: 134350848,
        7: 2048,
        8: 134348800,
        9: 134219776,
        10: 133120,
        11: 134348832,
        12: 2080,
        13: 0,
        14: 134217760,
        15: 133152,
        2147483648: 2048,
        2147483649: 134350880,
        2147483650: 134219808,
        2147483651: 134217728,
        2147483652: 134348800,
        2147483653: 133120,
        2147483654: 133152,
        2147483655: 32,
        2147483656: 134217760,
        2147483657: 2080,
        2147483658: 131104,
        2147483659: 134350848,
        2147483660: 0,
        2147483661: 134348832,
        2147483662: 134219776,
        2147483663: 131072,
        16: 133152,
        17: 134350848,
        18: 32,
        19: 2048,
        20: 134219776,
        21: 134217760,
        22: 134348832,
        23: 131072,
        24: 0,
        25: 131104,
        26: 134348800,
        27: 134219808,
        28: 134350880,
        29: 133120,
        30: 2080,
        31: 134217728,
        2147483664: 131072,
        2147483665: 2048,
        2147483666: 134348832,
        2147483667: 133152,
        2147483668: 32,
        2147483669: 134348800,
        2147483670: 134217728,
        2147483671: 134219808,
        2147483672: 134350880,
        2147483673: 134217760,
        2147483674: 134219776,
        2147483675: 0,
        2147483676: 133120,
        2147483677: 2080,
        2147483678: 131104,
        2147483679: 134350848
      }], t2 = [4160749569, 528482304, 33030144, 2064384, 129024, 8064, 504, 2147483679], m2 = g2.DES = e.extend({ _doReset: function() {
        for (var b = this._key.words, c2 = [], a = 0; 56 > a; a++) {
          var f2 = q2[a] - 1;
          c2[a] = b[f2 >>> 5] >>> 31 - f2 % 32 & 1;
        }
        b = this._subKeys = [];
        for (f2 = 0; 16 > f2; f2++) {
          for (var d2 = b[f2] = [], e2 = r[f2], a = 0; 24 > a; a++)
            d2[a / 6 | 0] |= c2[(p3[a] - 1 + e2) % 28] << 31 - a % 6, d2[4 + (a / 6 | 0)] |= c2[28 + (p3[a + 24] - 1 + e2) % 28] << 31 - a % 6;
          d2[0] = d2[0] << 1 | d2[0] >>> 31;
          for (a = 1; 7 > a; a++)
            d2[a] >>>= 4 * (a - 1) + 3;
          d2[7] = d2[7] << 5 | d2[7] >>> 27;
        }
        c2 = this._invSubKeys = [];
        for (a = 0; 16 > a; a++)
          c2[a] = b[15 - a];
      }, encryptBlock: function(b, c2) {
        this._doCryptBlock(b, c2, this._subKeys);
      }, decryptBlock: function(b, c2) {
        this._doCryptBlock(b, c2, this._invSubKeys);
      }, _doCryptBlock: function(b, c2, a) {
        this._lBlock = b[c2];
        this._rBlock = b[c2 + 1];
        j.call(this, 4, 252645135);
        j.call(this, 16, 65535);
        l2.call(this, 2, 858993459);
        l2.call(this, 8, 16711935);
        j.call(this, 1, 1431655765);
        for (var f2 = 0; 16 > f2; f2++) {
          for (var d2 = a[f2], e2 = this._lBlock, h2 = this._rBlock, g3 = 0, k = 0; 8 > k; k++)
            g3 |= s[k][((h2 ^ d2[k]) & t2[k]) >>> 0];
          this._lBlock = h2;
          this._rBlock = e2 ^ g3;
        }
        a = this._lBlock;
        this._lBlock = this._rBlock;
        this._rBlock = a;
        j.call(this, 1, 1431655765);
        l2.call(this, 8, 16711935);
        l2.call(this, 2, 858993459);
        j.call(this, 16, 65535);
        j.call(this, 4, 252645135);
        b[c2] = this._lBlock;
        b[c2 + 1] = this._rBlock;
      }, keySize: 2, ivSize: 2, blockSize: 2 });
      h.DES = e._createHelper(m2);
      g2 = g2.TripleDES = e.extend({ _doReset: function() {
        var b = this._key.words;
        this._des1 = m2.createEncryptor(n.create(b.slice(0, 2)));
        this._des2 = m2.createEncryptor(n.create(b.slice(2, 4)));
        this._des3 = m2.createEncryptor(n.create(b.slice(4, 6)));
      }, encryptBlock: function(b, c2) {
        this._des1.encryptBlock(b, c2);
        this._des2.decryptBlock(b, c2);
        this._des3.encryptBlock(b, c2);
      }, decryptBlock: function(b, c2) {
        this._des3.decryptBlock(b, c2);
        this._des2.encryptBlock(b, c2);
        this._des1.decryptBlock(b, c2);
      }, keySize: 6, ivSize: 2, blockSize: 2 });
      h.TripleDES = e._createHelper(g2);
    })();
    (function() {
      var h = CryptoJS, j = h.lib.WordArray;
      h.enc.Base64 = { stringify: function(b) {
        var e = b.words, f2 = b.sigBytes, c2 = this._map;
        b.clamp();
        b = [];
        for (var a = 0; a < f2; a += 3)
          for (var d2 = (e[a >>> 2] >>> 24 - 8 * (a % 4) & 255) << 16 | (e[a + 1 >>> 2] >>> 24 - 8 * ((a + 1) % 4) & 255) << 8 | e[a + 2 >>> 2] >>> 24 - 8 * ((a + 2) % 4) & 255, g2 = 0; 4 > g2 && a + 0.75 * g2 < f2; g2++)
            b.push(c2.charAt(d2 >>> 6 * (3 - g2) & 63));
        if (e = c2.charAt(64))
          for (; b.length % 4; )
            b.push(e);
        return b.join("");
      }, parse: function(b) {
        var e = b.length, f2 = this._map, c2 = f2.charAt(64);
        c2 && (c2 = b.indexOf(c2), -1 != c2 && (e = c2));
        for (var c2 = [], a = 0, d2 = 0; d2 < e; d2++)
          if (d2 % 4) {
            var g2 = f2.indexOf(b.charAt(d2 - 1)) << 2 * (d2 % 4), h2 = f2.indexOf(b.charAt(d2)) >>> 6 - 2 * (d2 % 4);
            c2[a >>> 2] |= (g2 | h2) << 24 - 8 * (a % 4);
            a++;
          }
        return j.create(c2, a);
      }, _map: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=" };
    })();
    (function(E) {
      function h(a2, f2, g2, j, p3, h2, k2) {
        a2 = a2 + (f2 & g2 | ~f2 & j) + p3 + k2;
        return (a2 << h2 | a2 >>> 32 - h2) + f2;
      }
      function k(a2, f2, g2, j, p3, h2, k2) {
        a2 = a2 + (f2 & j | g2 & ~j) + p3 + k2;
        return (a2 << h2 | a2 >>> 32 - h2) + f2;
      }
      function l2(a2, f2, g2, j, h2, k2, l3) {
        a2 = a2 + (f2 ^ g2 ^ j) + h2 + l3;
        return (a2 << k2 | a2 >>> 32 - k2) + f2;
      }
      function n(a2, f2, g2, j, h2, k2, l3) {
        a2 = a2 + (g2 ^ (f2 | ~j)) + h2 + l3;
        return (a2 << k2 | a2 >>> 32 - k2) + f2;
      }
      for (var r = CryptoJS, q2 = r.lib, F = q2.WordArray, s = q2.Hasher, q2 = r.algo, a = [], t2 = 0; 64 > t2; t2++)
        a[t2] = 4294967296 * E.abs(E.sin(t2 + 1)) | 0;
      q2 = q2.MD5 = s.extend({
        _doReset: function() {
          this._hash = new F.init([1732584193, 4023233417, 2562383102, 271733878]);
        },
        _doProcessBlock: function(m2, f2) {
          for (var g2 = 0; 16 > g2; g2++) {
            var j = f2 + g2, p3 = m2[j];
            m2[j] = (p3 << 8 | p3 >>> 24) & 16711935 | (p3 << 24 | p3 >>> 8) & 4278255360;
          }
          var g2 = this._hash.words, j = m2[f2 + 0], p3 = m2[f2 + 1], q3 = m2[f2 + 2], r2 = m2[f2 + 3], s2 = m2[f2 + 4], t3 = m2[f2 + 5], u2 = m2[f2 + 6], v = m2[f2 + 7], w = m2[f2 + 8], x2 = m2[f2 + 9], y = m2[f2 + 10], z2 = m2[f2 + 11], A = m2[f2 + 12], B = m2[f2 + 13], C = m2[f2 + 14], D = m2[f2 + 15], b = g2[0], c2 = g2[1], d2 = g2[2], e = g2[3], b = h(b, c2, d2, e, j, 7, a[0]), e = h(e, b, c2, d2, p3, 12, a[1]), d2 = h(d2, e, b, c2, q3, 17, a[2]), c2 = h(c2, d2, e, b, r2, 22, a[3]), b = h(b, c2, d2, e, s2, 7, a[4]), e = h(e, b, c2, d2, t3, 12, a[5]), d2 = h(d2, e, b, c2, u2, 17, a[6]), c2 = h(c2, d2, e, b, v, 22, a[7]), b = h(b, c2, d2, e, w, 7, a[8]), e = h(e, b, c2, d2, x2, 12, a[9]), d2 = h(d2, e, b, c2, y, 17, a[10]), c2 = h(c2, d2, e, b, z2, 22, a[11]), b = h(b, c2, d2, e, A, 7, a[12]), e = h(e, b, c2, d2, B, 12, a[13]), d2 = h(d2, e, b, c2, C, 17, a[14]), c2 = h(c2, d2, e, b, D, 22, a[15]), b = k(b, c2, d2, e, p3, 5, a[16]), e = k(e, b, c2, d2, u2, 9, a[17]), d2 = k(d2, e, b, c2, z2, 14, a[18]), c2 = k(c2, d2, e, b, j, 20, a[19]), b = k(b, c2, d2, e, t3, 5, a[20]), e = k(e, b, c2, d2, y, 9, a[21]), d2 = k(d2, e, b, c2, D, 14, a[22]), c2 = k(c2, d2, e, b, s2, 20, a[23]), b = k(b, c2, d2, e, x2, 5, a[24]), e = k(e, b, c2, d2, C, 9, a[25]), d2 = k(d2, e, b, c2, r2, 14, a[26]), c2 = k(c2, d2, e, b, w, 20, a[27]), b = k(b, c2, d2, e, B, 5, a[28]), e = k(
            e,
            b,
            c2,
            d2,
            q3,
            9,
            a[29]
          ), d2 = k(d2, e, b, c2, v, 14, a[30]), c2 = k(c2, d2, e, b, A, 20, a[31]), b = l2(b, c2, d2, e, t3, 4, a[32]), e = l2(e, b, c2, d2, w, 11, a[33]), d2 = l2(d2, e, b, c2, z2, 16, a[34]), c2 = l2(c2, d2, e, b, C, 23, a[35]), b = l2(b, c2, d2, e, p3, 4, a[36]), e = l2(e, b, c2, d2, s2, 11, a[37]), d2 = l2(d2, e, b, c2, v, 16, a[38]), c2 = l2(c2, d2, e, b, y, 23, a[39]), b = l2(b, c2, d2, e, B, 4, a[40]), e = l2(e, b, c2, d2, j, 11, a[41]), d2 = l2(d2, e, b, c2, r2, 16, a[42]), c2 = l2(c2, d2, e, b, u2, 23, a[43]), b = l2(b, c2, d2, e, x2, 4, a[44]), e = l2(e, b, c2, d2, A, 11, a[45]), d2 = l2(d2, e, b, c2, D, 16, a[46]), c2 = l2(c2, d2, e, b, q3, 23, a[47]), b = n(b, c2, d2, e, j, 6, a[48]), e = n(e, b, c2, d2, v, 10, a[49]), d2 = n(
            d2,
            e,
            b,
            c2,
            C,
            15,
            a[50]
          ), c2 = n(c2, d2, e, b, t3, 21, a[51]), b = n(b, c2, d2, e, A, 6, a[52]), e = n(e, b, c2, d2, r2, 10, a[53]), d2 = n(d2, e, b, c2, y, 15, a[54]), c2 = n(c2, d2, e, b, p3, 21, a[55]), b = n(b, c2, d2, e, w, 6, a[56]), e = n(e, b, c2, d2, D, 10, a[57]), d2 = n(d2, e, b, c2, u2, 15, a[58]), c2 = n(c2, d2, e, b, B, 21, a[59]), b = n(b, c2, d2, e, s2, 6, a[60]), e = n(e, b, c2, d2, z2, 10, a[61]), d2 = n(d2, e, b, c2, q3, 15, a[62]), c2 = n(c2, d2, e, b, x2, 21, a[63]);
          g2[0] = g2[0] + b | 0;
          g2[1] = g2[1] + c2 | 0;
          g2[2] = g2[2] + d2 | 0;
          g2[3] = g2[3] + e | 0;
        },
        _doFinalize: function() {
          var a2 = this._data, f2 = a2.words, g2 = 8 * this._nDataBytes, j = 8 * a2.sigBytes;
          f2[j >>> 5] |= 128 << 24 - j % 32;
          var h2 = E.floor(g2 / 4294967296);
          f2[(j + 64 >>> 9 << 4) + 15] = (h2 << 8 | h2 >>> 24) & 16711935 | (h2 << 24 | h2 >>> 8) & 4278255360;
          f2[(j + 64 >>> 9 << 4) + 14] = (g2 << 8 | g2 >>> 24) & 16711935 | (g2 << 24 | g2 >>> 8) & 4278255360;
          a2.sigBytes = 4 * (f2.length + 1);
          this._process();
          a2 = this._hash;
          f2 = a2.words;
          for (g2 = 0; 4 > g2; g2++)
            j = f2[g2], f2[g2] = (j << 8 | j >>> 24) & 16711935 | (j << 24 | j >>> 8) & 4278255360;
          return a2;
        },
        clone: function() {
          var a2 = s.clone.call(this);
          a2._hash = this._hash.clone();
          return a2;
        }
      });
      r.MD5 = s._createHelper(q2);
      r.HmacMD5 = s._createHmacHelper(q2);
    })(Math);
    (function() {
      var k = CryptoJS, b = k.lib, m2 = b.WordArray, l2 = b.Hasher, d2 = [], b = k.algo.SHA1 = l2.extend({ _doReset: function() {
        this._hash = new m2.init([1732584193, 4023233417, 2562383102, 271733878, 3285377520]);
      }, _doProcessBlock: function(n, p3) {
        for (var a = this._hash.words, e = a[0], f2 = a[1], h = a[2], j = a[3], b2 = a[4], c2 = 0; 80 > c2; c2++) {
          if (16 > c2)
            d2[c2] = n[p3 + c2] | 0;
          else {
            var g2 = d2[c2 - 3] ^ d2[c2 - 8] ^ d2[c2 - 14] ^ d2[c2 - 16];
            d2[c2] = g2 << 1 | g2 >>> 31;
          }
          g2 = (e << 5 | e >>> 27) + b2 + d2[c2];
          g2 = 20 > c2 ? g2 + ((f2 & h | ~f2 & j) + 1518500249) : 40 > c2 ? g2 + ((f2 ^ h ^ j) + 1859775393) : 60 > c2 ? g2 + ((f2 & h | f2 & j | h & j) - 1894007588) : g2 + ((f2 ^ h ^ j) - 899497514);
          b2 = j;
          j = h;
          h = f2 << 30 | f2 >>> 2;
          f2 = e;
          e = g2;
        }
        a[0] = a[0] + e | 0;
        a[1] = a[1] + f2 | 0;
        a[2] = a[2] + h | 0;
        a[3] = a[3] + j | 0;
        a[4] = a[4] + b2 | 0;
      }, _doFinalize: function() {
        var b2 = this._data, d3 = b2.words, a = 8 * this._nDataBytes, e = 8 * b2.sigBytes;
        d3[e >>> 5] |= 128 << 24 - e % 32;
        d3[(e + 64 >>> 9 << 4) + 14] = Math.floor(a / 4294967296);
        d3[(e + 64 >>> 9 << 4) + 15] = a;
        b2.sigBytes = 4 * d3.length;
        this._process();
        return this._hash;
      }, clone: function() {
        var b2 = l2.clone.call(this);
        b2._hash = this._hash.clone();
        return b2;
      } });
      k.SHA1 = l2._createHelper(b);
      k.HmacSHA1 = l2._createHmacHelper(b);
    })();
    (function(k) {
      for (var g2 = CryptoJS, h = g2.lib, v = h.WordArray, j = h.Hasher, h = g2.algo, s = [], t2 = [], u2 = function(q2) {
        return 4294967296 * (q2 - (q2 | 0)) | 0;
      }, l2 = 2, b = 0; 64 > b; ) {
        var d2;
        a: {
          d2 = l2;
          for (var w = k.sqrt(d2), r = 2; r <= w; r++)
            if (!(d2 % r)) {
              d2 = false;
              break a;
            }
          d2 = true;
        }
        d2 && (8 > b && (s[b] = u2(k.pow(l2, 0.5))), t2[b] = u2(k.pow(l2, 1 / 3)), b++);
        l2++;
      }
      var n = [], h = h.SHA256 = j.extend({ _doReset: function() {
        this._hash = new v.init(s.slice(0));
      }, _doProcessBlock: function(q2, h2) {
        for (var a = this._hash.words, c2 = a[0], d3 = a[1], b2 = a[2], k2 = a[3], f2 = a[4], g3 = a[5], j2 = a[6], l3 = a[7], e = 0; 64 > e; e++) {
          if (16 > e)
            n[e] = q2[h2 + e] | 0;
          else {
            var m2 = n[e - 15], p3 = n[e - 2];
            n[e] = ((m2 << 25 | m2 >>> 7) ^ (m2 << 14 | m2 >>> 18) ^ m2 >>> 3) + n[e - 7] + ((p3 << 15 | p3 >>> 17) ^ (p3 << 13 | p3 >>> 19) ^ p3 >>> 10) + n[e - 16];
          }
          m2 = l3 + ((f2 << 26 | f2 >>> 6) ^ (f2 << 21 | f2 >>> 11) ^ (f2 << 7 | f2 >>> 25)) + (f2 & g3 ^ ~f2 & j2) + t2[e] + n[e];
          p3 = ((c2 << 30 | c2 >>> 2) ^ (c2 << 19 | c2 >>> 13) ^ (c2 << 10 | c2 >>> 22)) + (c2 & d3 ^ c2 & b2 ^ d3 & b2);
          l3 = j2;
          j2 = g3;
          g3 = f2;
          f2 = k2 + m2 | 0;
          k2 = b2;
          b2 = d3;
          d3 = c2;
          c2 = m2 + p3 | 0;
        }
        a[0] = a[0] + c2 | 0;
        a[1] = a[1] + d3 | 0;
        a[2] = a[2] + b2 | 0;
        a[3] = a[3] + k2 | 0;
        a[4] = a[4] + f2 | 0;
        a[5] = a[5] + g3 | 0;
        a[6] = a[6] + j2 | 0;
        a[7] = a[7] + l3 | 0;
      }, _doFinalize: function() {
        var d3 = this._data, b2 = d3.words, a = 8 * this._nDataBytes, c2 = 8 * d3.sigBytes;
        b2[c2 >>> 5] |= 128 << 24 - c2 % 32;
        b2[(c2 + 64 >>> 9 << 4) + 14] = k.floor(a / 4294967296);
        b2[(c2 + 64 >>> 9 << 4) + 15] = a;
        d3.sigBytes = 4 * b2.length;
        this._process();
        return this._hash;
      }, clone: function() {
        var b2 = j.clone.call(this);
        b2._hash = this._hash.clone();
        return b2;
      } });
      g2.SHA256 = j._createHelper(h);
      g2.HmacSHA256 = j._createHmacHelper(h);
    })(Math);
    (function() {
      var b = CryptoJS, d2 = b.lib.WordArray, a = b.algo, c2 = a.SHA256, a = a.SHA224 = c2.extend({ _doReset: function() {
        this._hash = new d2.init([3238371032, 914150663, 812702999, 4144912697, 4290775857, 1750603025, 1694076839, 3204075428]);
      }, _doFinalize: function() {
        var a2 = c2._doFinalize.call(this);
        a2.sigBytes -= 4;
        return a2;
      } });
      b.SHA224 = c2._createHelper(a);
      b.HmacSHA224 = c2._createHmacHelper(a);
    })();
    (function() {
      function a() {
        return d2.create.apply(d2, arguments);
      }
      for (var n = CryptoJS, r = n.lib.Hasher, e = n.x64, d2 = e.Word, T = e.WordArray, e = n.algo, ea = [
        a(1116352408, 3609767458),
        a(1899447441, 602891725),
        a(3049323471, 3964484399),
        a(3921009573, 2173295548),
        a(961987163, 4081628472),
        a(1508970993, 3053834265),
        a(2453635748, 2937671579),
        a(2870763221, 3664609560),
        a(3624381080, 2734883394),
        a(310598401, 1164996542),
        a(607225278, 1323610764),
        a(1426881987, 3590304994),
        a(1925078388, 4068182383),
        a(2162078206, 991336113),
        a(2614888103, 633803317),
        a(3248222580, 3479774868),
        a(3835390401, 2666613458),
        a(4022224774, 944711139),
        a(264347078, 2341262773),
        a(604807628, 2007800933),
        a(770255983, 1495990901),
        a(1249150122, 1856431235),
        a(1555081692, 3175218132),
        a(1996064986, 2198950837),
        a(2554220882, 3999719339),
        a(2821834349, 766784016),
        a(2952996808, 2566594879),
        a(3210313671, 3203337956),
        a(3336571891, 1034457026),
        a(3584528711, 2466948901),
        a(113926993, 3758326383),
        a(338241895, 168717936),
        a(666307205, 1188179964),
        a(773529912, 1546045734),
        a(1294757372, 1522805485),
        a(
          1396182291,
          2643833823
        ),
        a(1695183700, 2343527390),
        a(1986661051, 1014477480),
        a(2177026350, 1206759142),
        a(2456956037, 344077627),
        a(2730485921, 1290863460),
        a(2820302411, 3158454273),
        a(3259730800, 3505952657),
        a(3345764771, 106217008),
        a(3516065817, 3606008344),
        a(3600352804, 1432725776),
        a(4094571909, 1467031594),
        a(275423344, 851169720),
        a(430227734, 3100823752),
        a(506948616, 1363258195),
        a(659060556, 3750685593),
        a(883997877, 3785050280),
        a(958139571, 3318307427),
        a(1322822218, 3812723403),
        a(1537002063, 2003034995),
        a(1747873779, 3602036899),
        a(1955562222, 1575990012),
        a(2024104815, 1125592928),
        a(2227730452, 2716904306),
        a(2361852424, 442776044),
        a(2428436474, 593698344),
        a(2756734187, 3733110249),
        a(3204031479, 2999351573),
        a(3329325298, 3815920427),
        a(3391569614, 3928383900),
        a(3515267271, 566280711),
        a(3940187606, 3454069534),
        a(4118630271, 4000239992),
        a(116418474, 1914138554),
        a(174292421, 2731055270),
        a(289380356, 3203993006),
        a(460393269, 320620315),
        a(685471733, 587496836),
        a(852142971, 1086792851),
        a(1017036298, 365543100),
        a(1126000580, 2618297676),
        a(
          1288033470,
          3409855158
        ),
        a(1501505948, 4234509866),
        a(1607167915, 987167468),
        a(1816402316, 1246189591)
      ], v = [], w = 0; 80 > w; w++)
        v[w] = a();
      e = e.SHA512 = r.extend({ _doReset: function() {
        this._hash = new T.init([new d2.init(1779033703, 4089235720), new d2.init(3144134277, 2227873595), new d2.init(1013904242, 4271175723), new d2.init(2773480762, 1595750129), new d2.init(1359893119, 2917565137), new d2.init(2600822924, 725511199), new d2.init(528734635, 4215389547), new d2.init(1541459225, 327033209)]);
      }, _doProcessBlock: function(a2, d3) {
        for (var f2 = this._hash.words, F = f2[0], e2 = f2[1], n2 = f2[2], r2 = f2[3], G = f2[4], H = f2[5], I = f2[6], f2 = f2[7], w2 = F.high, J = F.low, X = e2.high, K = e2.low, Y = n2.high, L = n2.low, Z = r2.high, M = r2.low, $ = G.high, N = G.low, aa = H.high, O = H.low, ba = I.high, P = I.low, ca = f2.high, Q = f2.low, k = w2, g2 = J, z2 = X, x2 = K, A = Y, y = L, U = Z, B = M, l2 = $, h = N, R2 = aa, C = O, S = ba, D = P, V = ca, E = Q, m2 = 0; 80 > m2; m2++) {
          var s = v[m2];
          if (16 > m2)
            var j = s.high = a2[d3 + 2 * m2] | 0, b = s.low = a2[d3 + 2 * m2 + 1] | 0;
          else {
            var j = v[m2 - 15], b = j.high, p3 = j.low, j = (b >>> 1 | p3 << 31) ^ (b >>> 8 | p3 << 24) ^ b >>> 7, p3 = (p3 >>> 1 | b << 31) ^ (p3 >>> 8 | b << 24) ^ (p3 >>> 7 | b << 25), u2 = v[m2 - 2], b = u2.high, c2 = u2.low, u2 = (b >>> 19 | c2 << 13) ^ (b << 3 | c2 >>> 29) ^ b >>> 6, c2 = (c2 >>> 19 | b << 13) ^ (c2 << 3 | b >>> 29) ^ (c2 >>> 6 | b << 26), b = v[m2 - 7], W = b.high, t2 = v[m2 - 16], q2 = t2.high, t2 = t2.low, b = p3 + b.low, j = j + W + (b >>> 0 < p3 >>> 0 ? 1 : 0), b = b + c2, j = j + u2 + (b >>> 0 < c2 >>> 0 ? 1 : 0), b = b + t2, j = j + q2 + (b >>> 0 < t2 >>> 0 ? 1 : 0);
            s.high = j;
            s.low = b;
          }
          var W = l2 & R2 ^ ~l2 & S, t2 = h & C ^ ~h & D, s = k & z2 ^ k & A ^ z2 & A, T2 = g2 & x2 ^ g2 & y ^ x2 & y, p3 = (k >>> 28 | g2 << 4) ^ (k << 30 | g2 >>> 2) ^ (k << 25 | g2 >>> 7), u2 = (g2 >>> 28 | k << 4) ^ (g2 << 30 | k >>> 2) ^ (g2 << 25 | k >>> 7), c2 = ea[m2], fa = c2.high, da = c2.low, c2 = E + ((h >>> 14 | l2 << 18) ^ (h >>> 18 | l2 << 14) ^ (h << 23 | l2 >>> 9)), q2 = V + ((l2 >>> 14 | h << 18) ^ (l2 >>> 18 | h << 14) ^ (l2 << 23 | h >>> 9)) + (c2 >>> 0 < E >>> 0 ? 1 : 0), c2 = c2 + t2, q2 = q2 + W + (c2 >>> 0 < t2 >>> 0 ? 1 : 0), c2 = c2 + da, q2 = q2 + fa + (c2 >>> 0 < da >>> 0 ? 1 : 0), c2 = c2 + b, q2 = q2 + j + (c2 >>> 0 < b >>> 0 ? 1 : 0), b = u2 + T2, s = p3 + s + (b >>> 0 < u2 >>> 0 ? 1 : 0), V = S, E = D, S = R2, D = C, R2 = l2, C = h, h = B + c2 | 0, l2 = U + q2 + (h >>> 0 < B >>> 0 ? 1 : 0) | 0, U = A, B = y, A = z2, y = x2, z2 = k, x2 = g2, g2 = c2 + b | 0, k = q2 + s + (g2 >>> 0 < c2 >>> 0 ? 1 : 0) | 0;
        }
        J = F.low = J + g2;
        F.high = w2 + k + (J >>> 0 < g2 >>> 0 ? 1 : 0);
        K = e2.low = K + x2;
        e2.high = X + z2 + (K >>> 0 < x2 >>> 0 ? 1 : 0);
        L = n2.low = L + y;
        n2.high = Y + A + (L >>> 0 < y >>> 0 ? 1 : 0);
        M = r2.low = M + B;
        r2.high = Z + U + (M >>> 0 < B >>> 0 ? 1 : 0);
        N = G.low = N + h;
        G.high = $ + l2 + (N >>> 0 < h >>> 0 ? 1 : 0);
        O = H.low = O + C;
        H.high = aa + R2 + (O >>> 0 < C >>> 0 ? 1 : 0);
        P = I.low = P + D;
        I.high = ba + S + (P >>> 0 < D >>> 0 ? 1 : 0);
        Q = f2.low = Q + E;
        f2.high = ca + V + (Q >>> 0 < E >>> 0 ? 1 : 0);
      }, _doFinalize: function() {
        var a2 = this._data, d3 = a2.words, f2 = 8 * this._nDataBytes, e2 = 8 * a2.sigBytes;
        d3[e2 >>> 5] |= 128 << 24 - e2 % 32;
        d3[(e2 + 128 >>> 10 << 5) + 30] = Math.floor(f2 / 4294967296);
        d3[(e2 + 128 >>> 10 << 5) + 31] = f2;
        a2.sigBytes = 4 * d3.length;
        this._process();
        return this._hash.toX32();
      }, clone: function() {
        var a2 = r.clone.call(this);
        a2._hash = this._hash.clone();
        return a2;
      }, blockSize: 32 });
      n.SHA512 = r._createHelper(e);
      n.HmacSHA512 = r._createHmacHelper(e);
    })();
    (function() {
      var c2 = CryptoJS, a = c2.x64, b = a.Word, e = a.WordArray, a = c2.algo, d2 = a.SHA512, a = a.SHA384 = d2.extend({ _doReset: function() {
        this._hash = new e.init([new b.init(3418070365, 3238371032), new b.init(1654270250, 914150663), new b.init(2438529370, 812702999), new b.init(355462360, 4144912697), new b.init(1731405415, 4290775857), new b.init(2394180231, 1750603025), new b.init(3675008525, 1694076839), new b.init(1203062813, 3204075428)]);
      }, _doFinalize: function() {
        var a2 = d2._doFinalize.call(this);
        a2.sigBytes -= 16;
        return a2;
      } });
      c2.SHA384 = d2._createHelper(a);
      c2.HmacSHA384 = d2._createHmacHelper(a);
    })();
    (function() {
      var q2 = CryptoJS, d2 = q2.lib, n = d2.WordArray, p3 = d2.Hasher, d2 = q2.algo, x2 = n.create([0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 7, 4, 13, 1, 10, 6, 15, 3, 12, 0, 9, 5, 2, 14, 11, 8, 3, 10, 14, 4, 9, 15, 8, 1, 2, 7, 0, 6, 13, 11, 5, 12, 1, 9, 11, 10, 0, 8, 12, 4, 13, 3, 7, 15, 14, 5, 6, 2, 4, 0, 5, 9, 7, 12, 2, 10, 14, 1, 3, 8, 11, 6, 15, 13]), y = n.create([5, 14, 7, 0, 9, 2, 11, 4, 13, 6, 15, 8, 1, 10, 3, 12, 6, 11, 3, 7, 0, 13, 5, 10, 14, 15, 8, 12, 4, 9, 1, 2, 15, 5, 1, 3, 7, 14, 6, 9, 11, 8, 12, 2, 10, 0, 4, 13, 8, 6, 4, 1, 3, 11, 15, 0, 5, 12, 2, 13, 9, 7, 10, 14, 12, 15, 10, 4, 1, 5, 8, 7, 6, 2, 13, 14, 0, 3, 9, 11]), z2 = n.create([
        11,
        14,
        15,
        12,
        5,
        8,
        7,
        9,
        11,
        13,
        14,
        15,
        6,
        7,
        9,
        8,
        7,
        6,
        8,
        13,
        11,
        9,
        7,
        15,
        7,
        12,
        15,
        9,
        11,
        7,
        13,
        12,
        11,
        13,
        6,
        7,
        14,
        9,
        13,
        15,
        14,
        8,
        13,
        6,
        5,
        12,
        7,
        5,
        11,
        12,
        14,
        15,
        14,
        15,
        9,
        8,
        9,
        14,
        5,
        6,
        8,
        6,
        5,
        12,
        9,
        15,
        5,
        11,
        6,
        8,
        13,
        12,
        5,
        12,
        13,
        14,
        11,
        8,
        5,
        6
      ]), A = n.create([8, 9, 9, 11, 13, 15, 15, 5, 7, 7, 8, 11, 14, 14, 12, 6, 9, 13, 15, 7, 12, 8, 9, 11, 7, 7, 12, 7, 6, 15, 13, 11, 9, 7, 15, 11, 8, 6, 6, 14, 12, 13, 5, 14, 13, 13, 7, 5, 15, 5, 8, 11, 14, 14, 6, 14, 6, 9, 12, 9, 12, 5, 15, 8, 8, 5, 12, 9, 12, 5, 14, 6, 8, 13, 6, 5, 15, 13, 11, 11]), B = n.create([0, 1518500249, 1859775393, 2400959708, 2840853838]), C = n.create([
        1352829926,
        1548603684,
        1836072691,
        2053994217,
        0
      ]), d2 = d2.RIPEMD160 = p3.extend({ _doReset: function() {
        this._hash = n.create([1732584193, 4023233417, 2562383102, 271733878, 3285377520]);
      }, _doProcessBlock: function(e, v) {
        for (var b = 0; 16 > b; b++) {
          var c2 = v + b, f2 = e[c2];
          e[c2] = (f2 << 8 | f2 >>> 24) & 16711935 | (f2 << 24 | f2 >>> 8) & 4278255360;
        }
        var c2 = this._hash.words, f2 = B.words, d3 = C.words, n2 = x2.words, q3 = y.words, p4 = z2.words, w = A.words, t2, g2, h, j, r, u2, k, l2, m2, s;
        u2 = t2 = c2[0];
        k = g2 = c2[1];
        l2 = h = c2[2];
        m2 = j = c2[3];
        s = r = c2[4];
        for (var a, b = 0; 80 > b; b += 1)
          a = t2 + e[v + n2[b]] | 0, a = 16 > b ? a + ((g2 ^ h ^ j) + f2[0]) : 32 > b ? a + ((g2 & h | ~g2 & j) + f2[1]) : 48 > b ? a + (((g2 | ~h) ^ j) + f2[2]) : 64 > b ? a + ((g2 & j | h & ~j) + f2[3]) : a + ((g2 ^ (h | ~j)) + f2[4]), a |= 0, a = a << p4[b] | a >>> 32 - p4[b], a = a + r | 0, t2 = r, r = j, j = h << 10 | h >>> 22, h = g2, g2 = a, a = u2 + e[v + q3[b]] | 0, a = 16 > b ? a + ((k ^ (l2 | ~m2)) + d3[0]) : 32 > b ? a + ((k & m2 | l2 & ~m2) + d3[1]) : 48 > b ? a + (((k | ~l2) ^ m2) + d3[2]) : 64 > b ? a + ((k & l2 | ~k & m2) + d3[3]) : a + ((k ^ l2 ^ m2) + d3[4]), a |= 0, a = a << w[b] | a >>> 32 - w[b], a = a + s | 0, u2 = s, s = m2, m2 = l2 << 10 | l2 >>> 22, l2 = k, k = a;
        a = c2[1] + h + m2 | 0;
        c2[1] = c2[2] + j + s | 0;
        c2[2] = c2[3] + r + u2 | 0;
        c2[3] = c2[4] + t2 + k | 0;
        c2[4] = c2[0] + g2 + l2 | 0;
        c2[0] = a;
      }, _doFinalize: function() {
        var e = this._data, d3 = e.words, b = 8 * this._nDataBytes, c2 = 8 * e.sigBytes;
        d3[c2 >>> 5] |= 128 << 24 - c2 % 32;
        d3[(c2 + 64 >>> 9 << 4) + 14] = (b << 8 | b >>> 24) & 16711935 | (b << 24 | b >>> 8) & 4278255360;
        e.sigBytes = 4 * (d3.length + 1);
        this._process();
        e = this._hash;
        d3 = e.words;
        for (b = 0; 5 > b; b++)
          c2 = d3[b], d3[b] = (c2 << 8 | c2 >>> 24) & 16711935 | (c2 << 24 | c2 >>> 8) & 4278255360;
        return e;
      }, clone: function() {
        var d3 = p3.clone.call(this);
        d3._hash = this._hash.clone();
        return d3;
      } });
      q2.RIPEMD160 = p3._createHelper(d2);
      q2.HmacRIPEMD160 = p3._createHmacHelper(d2);
    })(Math);
    (function() {
      var c2 = CryptoJS, k = c2.enc.Utf8;
      c2.algo.HMAC = c2.lib.Base.extend({ init: function(a, b) {
        a = this._hasher = new a.init();
        "string" == typeof b && (b = k.parse(b));
        var c3 = a.blockSize, e = 4 * c3;
        b.sigBytes > e && (b = a.finalize(b));
        b.clamp();
        for (var f2 = this._oKey = b.clone(), g2 = this._iKey = b.clone(), h = f2.words, j = g2.words, d2 = 0; d2 < c3; d2++)
          h[d2] ^= 1549556828, j[d2] ^= 909522486;
        f2.sigBytes = g2.sigBytes = e;
        this.reset();
      }, reset: function() {
        var a = this._hasher;
        a.reset();
        a.update(this._iKey);
      }, update: function(a) {
        this._hasher.update(a);
        return this;
      }, finalize: function(a) {
        var b = this._hasher;
        a = b.finalize(a);
        b.reset();
        return b.finalize(this._oKey.clone().concat(a));
      } });
    })();
    (function() {
      var b = CryptoJS, a = b.lib, d2 = a.Base, m2 = a.WordArray, a = b.algo, q2 = a.HMAC, l2 = a.PBKDF2 = d2.extend({ cfg: d2.extend({ keySize: 4, hasher: a.SHA1, iterations: 1 }), init: function(a2) {
        this.cfg = this.cfg.extend(a2);
      }, compute: function(a2, b2) {
        for (var c2 = this.cfg, f2 = q2.create(c2.hasher, a2), g2 = m2.create(), d3 = m2.create([1]), l3 = g2.words, r = d3.words, n = c2.keySize, c2 = c2.iterations; l3.length < n; ) {
          var h = f2.update(b2).finalize(d3);
          f2.reset();
          for (var j = h.words, s = j.length, k = h, p3 = 1; p3 < c2; p3++) {
            k = f2.finalize(k);
            f2.reset();
            for (var t2 = k.words, e = 0; e < s; e++)
              j[e] ^= t2[e];
          }
          g2.concat(h);
          r[0]++;
        }
        g2.sigBytes = 4 * n;
        return g2;
      } });
      b.PBKDF2 = function(a2, b2, c2) {
        return l2.create(c2).compute(a2, b2);
      };
    })();
    var b64map = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    var b64pad = "=";
    function hex2b64(d2) {
      var b;
      var e;
      var a = "";
      for (b = 0; b + 3 <= d2.length; b += 3) {
        e = parseInt(d2.substring(b, b + 3), 16);
        a += b64map.charAt(e >> 6) + b64map.charAt(e & 63);
      }
      if (b + 1 == d2.length) {
        e = parseInt(d2.substring(b, b + 1), 16);
        a += b64map.charAt(e << 2);
      } else {
        if (b + 2 == d2.length) {
          e = parseInt(d2.substring(b, b + 2), 16);
          a += b64map.charAt(e >> 2) + b64map.charAt((e & 3) << 4);
        }
      }
      if (b64pad) {
        while ((a.length & 3) > 0) {
          a += b64pad;
        }
      }
      return a;
    }
    function b64tohex(f2) {
      var d2 = "";
      var e;
      var b = 0;
      var c2;
      var a;
      for (e = 0; e < f2.length; ++e) {
        if (f2.charAt(e) == b64pad) {
          break;
        }
        a = b64map.indexOf(f2.charAt(e));
        if (a < 0) {
          continue;
        }
        if (b == 0) {
          d2 += int2char(a >> 2);
          c2 = a & 3;
          b = 1;
        } else {
          if (b == 1) {
            d2 += int2char(c2 << 2 | a >> 4);
            c2 = a & 15;
            b = 2;
          } else {
            if (b == 2) {
              d2 += int2char(c2);
              d2 += int2char(a >> 2);
              c2 = a & 3;
              b = 3;
            } else {
              d2 += int2char(c2 << 2 | a >> 4);
              d2 += int2char(a & 15);
              b = 0;
            }
          }
        }
      }
      if (b == 1) {
        d2 += int2char(c2 << 2);
      }
      return d2;
    }
    function b64toBA(e) {
      var d2 = b64tohex(e);
      var c2;
      var b = new Array();
      for (c2 = 0; 2 * c2 < d2.length; ++c2) {
        b[c2] = parseInt(d2.substring(2 * c2, 2 * c2 + 2), 16);
      }
      return b;
    }
    var dbits;
    var canary = 244837814094590;
    var j_lm = (canary & 16777215) == 15715070;
    function BigInteger(e, d2, f2) {
      if (e != null) {
        if ("number" == typeof e) {
          this.fromNumber(e, d2, f2);
        } else {
          if (d2 == null && "string" != typeof e) {
            this.fromString(e, 256);
          } else {
            this.fromString(e, d2);
          }
        }
      }
    }
    function nbi() {
      return new BigInteger(null);
    }
    function am1(f2, a, b, e, h, g2) {
      while (--g2 >= 0) {
        var d2 = a * this[f2++] + b[e] + h;
        h = Math.floor(d2 / 67108864);
        b[e++] = d2 & 67108863;
      }
      return h;
    }
    function am2(f2, q2, r, e, o2, a) {
      var k = q2 & 32767, p3 = q2 >> 15;
      while (--a >= 0) {
        var d2 = this[f2] & 32767;
        var g2 = this[f2++] >> 15;
        var b = p3 * d2 + g2 * k;
        d2 = k * d2 + ((b & 32767) << 15) + r[e] + (o2 & 1073741823);
        o2 = (d2 >>> 30) + (b >>> 15) + p3 * g2 + (o2 >>> 30);
        r[e++] = d2 & 1073741823;
      }
      return o2;
    }
    function am3(f2, q2, r, e, o2, a) {
      var k = q2 & 16383, p3 = q2 >> 14;
      while (--a >= 0) {
        var d2 = this[f2] & 16383;
        var g2 = this[f2++] >> 14;
        var b = p3 * d2 + g2 * k;
        d2 = k * d2 + ((b & 16383) << 14) + r[e] + o2;
        o2 = (d2 >> 28) + (b >> 14) + p3 * g2;
        r[e++] = d2 & 268435455;
      }
      return o2;
    }
    if (j_lm && navigator2.appName == "Microsoft Internet Explorer") {
      BigInteger.prototype.am = am2;
      dbits = 30;
    } else {
      if (j_lm && navigator2.appName != "Netscape") {
        BigInteger.prototype.am = am1;
        dbits = 26;
      } else {
        BigInteger.prototype.am = am3;
        dbits = 28;
      }
    }
    BigInteger.prototype.DB = dbits;
    BigInteger.prototype.DM = (1 << dbits) - 1;
    BigInteger.prototype.DV = 1 << dbits;
    var BI_FP = 52;
    BigInteger.prototype.FV = Math.pow(2, BI_FP);
    BigInteger.prototype.F1 = BI_FP - dbits;
    BigInteger.prototype.F2 = 2 * dbits - BI_FP;
    var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
    var BI_RC = new Array();
    var rr;
    var vv;
    rr = "0".charCodeAt(0);
    for (vv = 0; vv <= 9; ++vv) {
      BI_RC[rr++] = vv;
    }
    rr = "a".charCodeAt(0);
    for (vv = 10; vv < 36; ++vv) {
      BI_RC[rr++] = vv;
    }
    rr = "A".charCodeAt(0);
    for (vv = 10; vv < 36; ++vv) {
      BI_RC[rr++] = vv;
    }
    function int2char(a) {
      return BI_RM.charAt(a);
    }
    function intAt(b, a) {
      var d2 = BI_RC[b.charCodeAt(a)];
      return d2 == null ? -1 : d2;
    }
    function bnpCopyTo(b) {
      for (var a = this.t - 1; a >= 0; --a) {
        b[a] = this[a];
      }
      b.t = this.t;
      b.s = this.s;
    }
    function bnpFromInt(a) {
      this.t = 1;
      this.s = a < 0 ? -1 : 0;
      if (a > 0) {
        this[0] = a;
      } else {
        if (a < -1) {
          this[0] = a + this.DV;
        } else {
          this.t = 0;
        }
      }
    }
    function nbv(a) {
      var b = nbi();
      b.fromInt(a);
      return b;
    }
    function bnpFromString(h, c2) {
      var e;
      if (c2 == 16) {
        e = 4;
      } else {
        if (c2 == 8) {
          e = 3;
        } else {
          if (c2 == 256) {
            e = 8;
          } else {
            if (c2 == 2) {
              e = 1;
            } else {
              if (c2 == 32) {
                e = 5;
              } else {
                if (c2 == 4) {
                  e = 2;
                } else {
                  this.fromRadix(h, c2);
                  return;
                }
              }
            }
          }
        }
      }
      this.t = 0;
      this.s = 0;
      var g2 = h.length, d2 = false, f2 = 0;
      while (--g2 >= 0) {
        var a = e == 8 ? h[g2] & 255 : intAt(h, g2);
        if (a < 0) {
          if (h.charAt(g2) == "-") {
            d2 = true;
          }
          continue;
        }
        d2 = false;
        if (f2 == 0) {
          this[this.t++] = a;
        } else {
          if (f2 + e > this.DB) {
            this[this.t - 1] |= (a & (1 << this.DB - f2) - 1) << f2;
            this[this.t++] = a >> this.DB - f2;
          } else {
            this[this.t - 1] |= a << f2;
          }
        }
        f2 += e;
        if (f2 >= this.DB) {
          f2 -= this.DB;
        }
      }
      if (e == 8 && (h[0] & 128) != 0) {
        this.s = -1;
        if (f2 > 0) {
          this[this.t - 1] |= (1 << this.DB - f2) - 1 << f2;
        }
      }
      this.clamp();
      if (d2) {
        BigInteger.ZERO.subTo(this, this);
      }
    }
    function bnpClamp() {
      var a = this.s & this.DM;
      while (this.t > 0 && this[this.t - 1] == a) {
        --this.t;
      }
    }
    function bnToString(c2) {
      if (this.s < 0) {
        return "-" + this.negate().toString(c2);
      }
      var e;
      if (c2 == 16) {
        e = 4;
      } else {
        if (c2 == 8) {
          e = 3;
        } else {
          if (c2 == 2) {
            e = 1;
          } else {
            if (c2 == 32) {
              e = 5;
            } else {
              if (c2 == 4) {
                e = 2;
              } else {
                return this.toRadix(c2);
              }
            }
          }
        }
      }
      var g2 = (1 << e) - 1, l2, a = false, h = "", f2 = this.t;
      var j = this.DB - f2 * this.DB % e;
      if (f2-- > 0) {
        if (j < this.DB && (l2 = this[f2] >> j) > 0) {
          a = true;
          h = int2char(l2);
        }
        while (f2 >= 0) {
          if (j < e) {
            l2 = (this[f2] & (1 << j) - 1) << e - j;
            l2 |= this[--f2] >> (j += this.DB - e);
          } else {
            l2 = this[f2] >> (j -= e) & g2;
            if (j <= 0) {
              j += this.DB;
              --f2;
            }
          }
          if (l2 > 0) {
            a = true;
          }
          if (a) {
            h += int2char(l2);
          }
        }
      }
      return a ? h : "0";
    }
    function bnNegate() {
      var a = nbi();
      BigInteger.ZERO.subTo(this, a);
      return a;
    }
    function bnAbs() {
      return this.s < 0 ? this.negate() : this;
    }
    function bnCompareTo(b) {
      var d2 = this.s - b.s;
      if (d2 != 0) {
        return d2;
      }
      var c2 = this.t;
      d2 = c2 - b.t;
      if (d2 != 0) {
        return this.s < 0 ? -d2 : d2;
      }
      while (--c2 >= 0) {
        if ((d2 = this[c2] - b[c2]) != 0) {
          return d2;
        }
      }
      return 0;
    }
    function nbits(a) {
      var c2 = 1, b;
      if ((b = a >>> 16) != 0) {
        a = b;
        c2 += 16;
      }
      if ((b = a >> 8) != 0) {
        a = b;
        c2 += 8;
      }
      if ((b = a >> 4) != 0) {
        a = b;
        c2 += 4;
      }
      if ((b = a >> 2) != 0) {
        a = b;
        c2 += 2;
      }
      if ((b = a >> 1) != 0) {
        a = b;
        c2 += 1;
      }
      return c2;
    }
    function bnBitLength() {
      if (this.t <= 0) {
        return 0;
      }
      return this.DB * (this.t - 1) + nbits(this[this.t - 1] ^ this.s & this.DM);
    }
    function bnpDLShiftTo(c2, b) {
      var a;
      for (a = this.t - 1; a >= 0; --a) {
        b[a + c2] = this[a];
      }
      for (a = c2 - 1; a >= 0; --a) {
        b[a] = 0;
      }
      b.t = this.t + c2;
      b.s = this.s;
    }
    function bnpDRShiftTo(c2, b) {
      for (var a = c2; a < this.t; ++a) {
        b[a - c2] = this[a];
      }
      b.t = Math.max(this.t - c2, 0);
      b.s = this.s;
    }
    function bnpLShiftTo(j, e) {
      var b = j % this.DB;
      var a = this.DB - b;
      var g2 = (1 << a) - 1;
      var f2 = Math.floor(j / this.DB), h = this.s << b & this.DM, d2;
      for (d2 = this.t - 1; d2 >= 0; --d2) {
        e[d2 + f2 + 1] = this[d2] >> a | h;
        h = (this[d2] & g2) << b;
      }
      for (d2 = f2 - 1; d2 >= 0; --d2) {
        e[d2] = 0;
      }
      e[f2] = h;
      e.t = this.t + f2 + 1;
      e.s = this.s;
      e.clamp();
    }
    function bnpRShiftTo(g2, d2) {
      d2.s = this.s;
      var e = Math.floor(g2 / this.DB);
      if (e >= this.t) {
        d2.t = 0;
        return;
      }
      var b = g2 % this.DB;
      var a = this.DB - b;
      var f2 = (1 << b) - 1;
      d2[0] = this[e] >> b;
      for (var c2 = e + 1; c2 < this.t; ++c2) {
        d2[c2 - e - 1] |= (this[c2] & f2) << a;
        d2[c2 - e] = this[c2] >> b;
      }
      if (b > 0) {
        d2[this.t - e - 1] |= (this.s & f2) << a;
      }
      d2.t = this.t - e;
      d2.clamp();
    }
    function bnpSubTo(d2, f2) {
      var e = 0, g2 = 0, b = Math.min(d2.t, this.t);
      while (e < b) {
        g2 += this[e] - d2[e];
        f2[e++] = g2 & this.DM;
        g2 >>= this.DB;
      }
      if (d2.t < this.t) {
        g2 -= d2.s;
        while (e < this.t) {
          g2 += this[e];
          f2[e++] = g2 & this.DM;
          g2 >>= this.DB;
        }
        g2 += this.s;
      } else {
        g2 += this.s;
        while (e < d2.t) {
          g2 -= d2[e];
          f2[e++] = g2 & this.DM;
          g2 >>= this.DB;
        }
        g2 -= d2.s;
      }
      f2.s = g2 < 0 ? -1 : 0;
      if (g2 < -1) {
        f2[e++] = this.DV + g2;
      } else {
        if (g2 > 0) {
          f2[e++] = g2;
        }
      }
      f2.t = e;
      f2.clamp();
    }
    function bnpMultiplyTo(c2, e) {
      var b = this.abs(), f2 = c2.abs();
      var d2 = b.t;
      e.t = d2 + f2.t;
      while (--d2 >= 0) {
        e[d2] = 0;
      }
      for (d2 = 0; d2 < f2.t; ++d2) {
        e[d2 + b.t] = b.am(0, f2[d2], e, d2, 0, b.t);
      }
      e.s = 0;
      e.clamp();
      if (this.s != c2.s) {
        BigInteger.ZERO.subTo(e, e);
      }
    }
    function bnpSquareTo(d2) {
      var a = this.abs();
      var b = d2.t = 2 * a.t;
      while (--b >= 0) {
        d2[b] = 0;
      }
      for (b = 0; b < a.t - 1; ++b) {
        var e = a.am(b, a[b], d2, 2 * b, 0, 1);
        if ((d2[b + a.t] += a.am(b + 1, 2 * a[b], d2, 2 * b + 1, e, a.t - b - 1)) >= a.DV) {
          d2[b + a.t] -= a.DV;
          d2[b + a.t + 1] = 1;
        }
      }
      if (d2.t > 0) {
        d2[d2.t - 1] += a.am(b, a[b], d2, 2 * b, 0, 1);
      }
      d2.s = 0;
      d2.clamp();
    }
    function bnpDivRemTo(n, h, g2) {
      var w = n.abs();
      if (w.t <= 0) {
        return;
      }
      var k = this.abs();
      if (k.t < w.t) {
        if (h != null) {
          h.fromInt(0);
        }
        if (g2 != null) {
          this.copyTo(g2);
        }
        return;
      }
      if (g2 == null) {
        g2 = nbi();
      }
      var d2 = nbi(), a = this.s, l2 = n.s;
      var v = this.DB - nbits(w[w.t - 1]);
      if (v > 0) {
        w.lShiftTo(v, d2);
        k.lShiftTo(v, g2);
      } else {
        w.copyTo(d2);
        k.copyTo(g2);
      }
      var p3 = d2.t;
      var b = d2[p3 - 1];
      if (b == 0) {
        return;
      }
      var o2 = b * (1 << this.F1) + (p3 > 1 ? d2[p3 - 2] >> this.F2 : 0);
      var A = this.FV / o2, z2 = (1 << this.F1) / o2, x2 = 1 << this.F2;
      var u2 = g2.t, s = u2 - p3, f2 = h == null ? nbi() : h;
      d2.dlShiftTo(s, f2);
      if (g2.compareTo(f2) >= 0) {
        g2[g2.t++] = 1;
        g2.subTo(f2, g2);
      }
      BigInteger.ONE.dlShiftTo(p3, f2);
      f2.subTo(d2, d2);
      while (d2.t < p3) {
        d2[d2.t++] = 0;
      }
      while (--s >= 0) {
        var c2 = g2[--u2] == b ? this.DM : Math.floor(g2[u2] * A + (g2[u2 - 1] + x2) * z2);
        if ((g2[u2] += d2.am(0, c2, g2, s, 0, p3)) < c2) {
          d2.dlShiftTo(s, f2);
          g2.subTo(f2, g2);
          while (g2[u2] < --c2) {
            g2.subTo(f2, g2);
          }
        }
      }
      if (h != null) {
        g2.drShiftTo(p3, h);
        if (a != l2) {
          BigInteger.ZERO.subTo(h, h);
        }
      }
      g2.t = p3;
      g2.clamp();
      if (v > 0) {
        g2.rShiftTo(v, g2);
      }
      if (a < 0) {
        BigInteger.ZERO.subTo(g2, g2);
      }
    }
    function bnMod(b) {
      var c2 = nbi();
      this.abs().divRemTo(b, null, c2);
      if (this.s < 0 && c2.compareTo(BigInteger.ZERO) > 0) {
        b.subTo(c2, c2);
      }
      return c2;
    }
    function Classic(a) {
      this.m = a;
    }
    function cConvert(a) {
      if (a.s < 0 || a.compareTo(this.m) >= 0) {
        return a.mod(this.m);
      } else {
        return a;
      }
    }
    function cRevert(a) {
      return a;
    }
    function cReduce(a) {
      a.divRemTo(this.m, null, a);
    }
    function cMulTo(a, c2, b) {
      a.multiplyTo(c2, b);
      this.reduce(b);
    }
    function cSqrTo(a, b) {
      a.squareTo(b);
      this.reduce(b);
    }
    Classic.prototype.convert = cConvert;
    Classic.prototype.revert = cRevert;
    Classic.prototype.reduce = cReduce;
    Classic.prototype.mulTo = cMulTo;
    Classic.prototype.sqrTo = cSqrTo;
    function bnpInvDigit() {
      if (this.t < 1) {
        return 0;
      }
      var a = this[0];
      if ((a & 1) == 0) {
        return 0;
      }
      var b = a & 3;
      b = b * (2 - (a & 15) * b) & 15;
      b = b * (2 - (a & 255) * b) & 255;
      b = b * (2 - ((a & 65535) * b & 65535)) & 65535;
      b = b * (2 - a * b % this.DV) % this.DV;
      return b > 0 ? this.DV - b : -b;
    }
    function Montgomery(a) {
      this.m = a;
      this.mp = a.invDigit();
      this.mpl = this.mp & 32767;
      this.mph = this.mp >> 15;
      this.um = (1 << a.DB - 15) - 1;
      this.mt2 = 2 * a.t;
    }
    function montConvert(a) {
      var b = nbi();
      a.abs().dlShiftTo(this.m.t, b);
      b.divRemTo(this.m, null, b);
      if (a.s < 0 && b.compareTo(BigInteger.ZERO) > 0) {
        this.m.subTo(b, b);
      }
      return b;
    }
    function montRevert(a) {
      var b = nbi();
      a.copyTo(b);
      this.reduce(b);
      return b;
    }
    function montReduce(a) {
      while (a.t <= this.mt2) {
        a[a.t++] = 0;
      }
      for (var c2 = 0; c2 < this.m.t; ++c2) {
        var b = a[c2] & 32767;
        var d2 = b * this.mpl + ((b * this.mph + (a[c2] >> 15) * this.mpl & this.um) << 15) & a.DM;
        b = c2 + this.m.t;
        a[b] += this.m.am(0, d2, a, c2, 0, this.m.t);
        while (a[b] >= a.DV) {
          a[b] -= a.DV;
          a[++b]++;
        }
      }
      a.clamp();
      a.drShiftTo(this.m.t, a);
      if (a.compareTo(this.m) >= 0) {
        a.subTo(this.m, a);
      }
    }
    function montSqrTo(a, b) {
      a.squareTo(b);
      this.reduce(b);
    }
    function montMulTo(a, c2, b) {
      a.multiplyTo(c2, b);
      this.reduce(b);
    }
    Montgomery.prototype.convert = montConvert;
    Montgomery.prototype.revert = montRevert;
    Montgomery.prototype.reduce = montReduce;
    Montgomery.prototype.mulTo = montMulTo;
    Montgomery.prototype.sqrTo = montSqrTo;
    function bnpIsEven() {
      return (this.t > 0 ? this[0] & 1 : this.s) == 0;
    }
    function bnpExp(h, j) {
      if (h > 4294967295 || h < 1) {
        return BigInteger.ONE;
      }
      var f2 = nbi(), a = nbi(), d2 = j.convert(this), c2 = nbits(h) - 1;
      d2.copyTo(f2);
      while (--c2 >= 0) {
        j.sqrTo(f2, a);
        if ((h & 1 << c2) > 0) {
          j.mulTo(a, d2, f2);
        } else {
          var b = f2;
          f2 = a;
          a = b;
        }
      }
      return j.revert(f2);
    }
    function bnModPowInt(b, a) {
      var c2;
      if (b < 256 || a.isEven()) {
        c2 = new Classic(a);
      } else {
        c2 = new Montgomery(a);
      }
      return this.exp(b, c2);
    }
    BigInteger.prototype.copyTo = bnpCopyTo;
    BigInteger.prototype.fromInt = bnpFromInt;
    BigInteger.prototype.fromString = bnpFromString;
    BigInteger.prototype.clamp = bnpClamp;
    BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
    BigInteger.prototype.drShiftTo = bnpDRShiftTo;
    BigInteger.prototype.lShiftTo = bnpLShiftTo;
    BigInteger.prototype.rShiftTo = bnpRShiftTo;
    BigInteger.prototype.subTo = bnpSubTo;
    BigInteger.prototype.multiplyTo = bnpMultiplyTo;
    BigInteger.prototype.squareTo = bnpSquareTo;
    BigInteger.prototype.divRemTo = bnpDivRemTo;
    BigInteger.prototype.invDigit = bnpInvDigit;
    BigInteger.prototype.isEven = bnpIsEven;
    BigInteger.prototype.exp = bnpExp;
    BigInteger.prototype.toString = bnToString;
    BigInteger.prototype.negate = bnNegate;
    BigInteger.prototype.abs = bnAbs;
    BigInteger.prototype.compareTo = bnCompareTo;
    BigInteger.prototype.bitLength = bnBitLength;
    BigInteger.prototype.mod = bnMod;
    BigInteger.prototype.modPowInt = bnModPowInt;
    BigInteger.ZERO = nbv(0);
    BigInteger.ONE = nbv(1);
    function bnClone() {
      var a = nbi();
      this.copyTo(a);
      return a;
    }
    function bnIntValue() {
      if (this.s < 0) {
        if (this.t == 1) {
          return this[0] - this.DV;
        } else {
          if (this.t == 0) {
            return -1;
          }
        }
      } else {
        if (this.t == 1) {
          return this[0];
        } else {
          if (this.t == 0) {
            return 0;
          }
        }
      }
      return (this[1] & (1 << 32 - this.DB) - 1) << this.DB | this[0];
    }
    function bnByteValue() {
      return this.t == 0 ? this.s : this[0] << 24 >> 24;
    }
    function bnShortValue() {
      return this.t == 0 ? this.s : this[0] << 16 >> 16;
    }
    function bnpChunkSize(a) {
      return Math.floor(Math.LN2 * this.DB / Math.log(a));
    }
    function bnSigNum() {
      if (this.s < 0) {
        return -1;
      } else {
        if (this.t <= 0 || this.t == 1 && this[0] <= 0) {
          return 0;
        } else {
          return 1;
        }
      }
    }
    function bnpToRadix(c2) {
      if (c2 == null) {
        c2 = 10;
      }
      if (this.signum() == 0 || c2 < 2 || c2 > 36) {
        return "0";
      }
      var f2 = this.chunkSize(c2);
      var e = Math.pow(c2, f2);
      var i = nbv(e), j = nbi(), h = nbi(), g2 = "";
      this.divRemTo(i, j, h);
      while (j.signum() > 0) {
        g2 = (e + h.intValue()).toString(c2).substr(1) + g2;
        j.divRemTo(i, j, h);
      }
      return h.intValue().toString(c2) + g2;
    }
    function bnpFromRadix(m2, h) {
      this.fromInt(0);
      if (h == null) {
        h = 10;
      }
      var f2 = this.chunkSize(h);
      var g2 = Math.pow(h, f2), e = false, a = 0, l2 = 0;
      for (var c2 = 0; c2 < m2.length; ++c2) {
        var k = intAt(m2, c2);
        if (k < 0) {
          if (m2.charAt(c2) == "-" && this.signum() == 0) {
            e = true;
          }
          continue;
        }
        l2 = h * l2 + k;
        if (++a >= f2) {
          this.dMultiply(g2);
          this.dAddOffset(l2, 0);
          a = 0;
          l2 = 0;
        }
      }
      if (a > 0) {
        this.dMultiply(Math.pow(h, a));
        this.dAddOffset(l2, 0);
      }
      if (e) {
        BigInteger.ZERO.subTo(this, this);
      }
    }
    function bnpFromNumber(f2, e, h) {
      if ("number" == typeof e) {
        if (f2 < 2) {
          this.fromInt(1);
        } else {
          this.fromNumber(f2, h);
          if (!this.testBit(f2 - 1)) {
            this.bitwiseTo(BigInteger.ONE.shiftLeft(f2 - 1), op_or, this);
          }
          if (this.isEven()) {
            this.dAddOffset(1, 0);
          }
          while (!this.isProbablePrime(e)) {
            this.dAddOffset(2, 0);
            if (this.bitLength() > f2) {
              this.subTo(BigInteger.ONE.shiftLeft(f2 - 1), this);
            }
          }
        }
      } else {
        var d2 = new Array(), g2 = f2 & 7;
        d2.length = (f2 >> 3) + 1;
        e.nextBytes(d2);
        if (g2 > 0) {
          d2[0] &= (1 << g2) - 1;
        } else {
          d2[0] = 0;
        }
        this.fromString(d2, 256);
      }
    }
    function bnToByteArray() {
      var b = this.t, c2 = new Array();
      c2[0] = this.s;
      var e = this.DB - b * this.DB % 8, f2, a = 0;
      if (b-- > 0) {
        if (e < this.DB && (f2 = this[b] >> e) != (this.s & this.DM) >> e) {
          c2[a++] = f2 | this.s << this.DB - e;
        }
        while (b >= 0) {
          if (e < 8) {
            f2 = (this[b] & (1 << e) - 1) << 8 - e;
            f2 |= this[--b] >> (e += this.DB - 8);
          } else {
            f2 = this[b] >> (e -= 8) & 255;
            if (e <= 0) {
              e += this.DB;
              --b;
            }
          }
          if ((f2 & 128) != 0) {
            f2 |= -256;
          }
          if (a == 0 && (this.s & 128) != (f2 & 128)) {
            ++a;
          }
          if (a > 0 || f2 != this.s) {
            c2[a++] = f2;
          }
        }
      }
      return c2;
    }
    function bnEquals(b) {
      return this.compareTo(b) == 0;
    }
    function bnMin(b) {
      return this.compareTo(b) < 0 ? this : b;
    }
    function bnMax(b) {
      return this.compareTo(b) > 0 ? this : b;
    }
    function bnpBitwiseTo(c2, h, e) {
      var d2, g2, b = Math.min(c2.t, this.t);
      for (d2 = 0; d2 < b; ++d2) {
        e[d2] = h(this[d2], c2[d2]);
      }
      if (c2.t < this.t) {
        g2 = c2.s & this.DM;
        for (d2 = b; d2 < this.t; ++d2) {
          e[d2] = h(this[d2], g2);
        }
        e.t = this.t;
      } else {
        g2 = this.s & this.DM;
        for (d2 = b; d2 < c2.t; ++d2) {
          e[d2] = h(g2, c2[d2]);
        }
        e.t = c2.t;
      }
      e.s = h(this.s, c2.s);
      e.clamp();
    }
    function op_and(a, b) {
      return a & b;
    }
    function bnAnd(b) {
      var c2 = nbi();
      this.bitwiseTo(b, op_and, c2);
      return c2;
    }
    function op_or(a, b) {
      return a | b;
    }
    function bnOr(b) {
      var c2 = nbi();
      this.bitwiseTo(b, op_or, c2);
      return c2;
    }
    function op_xor(a, b) {
      return a ^ b;
    }
    function bnXor(b) {
      var c2 = nbi();
      this.bitwiseTo(b, op_xor, c2);
      return c2;
    }
    function op_andnot(a, b) {
      return a & ~b;
    }
    function bnAndNot(b) {
      var c2 = nbi();
      this.bitwiseTo(b, op_andnot, c2);
      return c2;
    }
    function bnNot() {
      var b = nbi();
      for (var a = 0; a < this.t; ++a) {
        b[a] = this.DM & ~this[a];
      }
      b.t = this.t;
      b.s = ~this.s;
      return b;
    }
    function bnShiftLeft(b) {
      var a = nbi();
      if (b < 0) {
        this.rShiftTo(-b, a);
      } else {
        this.lShiftTo(b, a);
      }
      return a;
    }
    function bnShiftRight(b) {
      var a = nbi();
      if (b < 0) {
        this.lShiftTo(-b, a);
      } else {
        this.rShiftTo(b, a);
      }
      return a;
    }
    function lbit(a) {
      if (a == 0) {
        return -1;
      }
      var b = 0;
      if ((a & 65535) == 0) {
        a >>= 16;
        b += 16;
      }
      if ((a & 255) == 0) {
        a >>= 8;
        b += 8;
      }
      if ((a & 15) == 0) {
        a >>= 4;
        b += 4;
      }
      if ((a & 3) == 0) {
        a >>= 2;
        b += 2;
      }
      if ((a & 1) == 0) {
        ++b;
      }
      return b;
    }
    function bnGetLowestSetBit() {
      for (var a = 0; a < this.t; ++a) {
        if (this[a] != 0) {
          return a * this.DB + lbit(this[a]);
        }
      }
      if (this.s < 0) {
        return this.t * this.DB;
      }
      return -1;
    }
    function cbit(a) {
      var b = 0;
      while (a != 0) {
        a &= a - 1;
        ++b;
      }
      return b;
    }
    function bnBitCount() {
      var c2 = 0, a = this.s & this.DM;
      for (var b = 0; b < this.t; ++b) {
        c2 += cbit(this[b] ^ a);
      }
      return c2;
    }
    function bnTestBit(b) {
      var a = Math.floor(b / this.DB);
      if (a >= this.t) {
        return this.s != 0;
      }
      return (this[a] & 1 << b % this.DB) != 0;
    }
    function bnpChangeBit(c2, b) {
      var a = BigInteger.ONE.shiftLeft(c2);
      this.bitwiseTo(a, b, a);
      return a;
    }
    function bnSetBit(a) {
      return this.changeBit(a, op_or);
    }
    function bnClearBit(a) {
      return this.changeBit(a, op_andnot);
    }
    function bnFlipBit(a) {
      return this.changeBit(a, op_xor);
    }
    function bnpAddTo(d2, f2) {
      var e = 0, g2 = 0, b = Math.min(d2.t, this.t);
      while (e < b) {
        g2 += this[e] + d2[e];
        f2[e++] = g2 & this.DM;
        g2 >>= this.DB;
      }
      if (d2.t < this.t) {
        g2 += d2.s;
        while (e < this.t) {
          g2 += this[e];
          f2[e++] = g2 & this.DM;
          g2 >>= this.DB;
        }
        g2 += this.s;
      } else {
        g2 += this.s;
        while (e < d2.t) {
          g2 += d2[e];
          f2[e++] = g2 & this.DM;
          g2 >>= this.DB;
        }
        g2 += d2.s;
      }
      f2.s = g2 < 0 ? -1 : 0;
      if (g2 > 0) {
        f2[e++] = g2;
      } else {
        if (g2 < -1) {
          f2[e++] = this.DV + g2;
        }
      }
      f2.t = e;
      f2.clamp();
    }
    function bnAdd(b) {
      var c2 = nbi();
      this.addTo(b, c2);
      return c2;
    }
    function bnSubtract(b) {
      var c2 = nbi();
      this.subTo(b, c2);
      return c2;
    }
    function bnMultiply(b) {
      var c2 = nbi();
      this.multiplyTo(b, c2);
      return c2;
    }
    function bnSquare() {
      var a = nbi();
      this.squareTo(a);
      return a;
    }
    function bnDivide(b) {
      var c2 = nbi();
      this.divRemTo(b, c2, null);
      return c2;
    }
    function bnRemainder(b) {
      var c2 = nbi();
      this.divRemTo(b, null, c2);
      return c2;
    }
    function bnDivideAndRemainder(b) {
      var d2 = nbi(), c2 = nbi();
      this.divRemTo(b, d2, c2);
      return new Array(d2, c2);
    }
    function bnpDMultiply(a) {
      this[this.t] = this.am(0, a - 1, this, 0, 0, this.t);
      ++this.t;
      this.clamp();
    }
    function bnpDAddOffset(b, a) {
      if (b == 0) {
        return;
      }
      while (this.t <= a) {
        this[this.t++] = 0;
      }
      this[a] += b;
      while (this[a] >= this.DV) {
        this[a] -= this.DV;
        if (++a >= this.t) {
          this[this.t++] = 0;
        }
        ++this[a];
      }
    }
    function NullExp() {
    }
    function nNop(a) {
      return a;
    }
    function nMulTo(a, c2, b) {
      a.multiplyTo(c2, b);
    }
    function nSqrTo(a, b) {
      a.squareTo(b);
    }
    NullExp.prototype.convert = nNop;
    NullExp.prototype.revert = nNop;
    NullExp.prototype.mulTo = nMulTo;
    NullExp.prototype.sqrTo = nSqrTo;
    function bnPow(a) {
      return this.exp(a, new NullExp());
    }
    function bnpMultiplyLowerTo(b, f2, e) {
      var d2 = Math.min(this.t + b.t, f2);
      e.s = 0;
      e.t = d2;
      while (d2 > 0) {
        e[--d2] = 0;
      }
      var c2;
      for (c2 = e.t - this.t; d2 < c2; ++d2) {
        e[d2 + this.t] = this.am(0, b[d2], e, d2, 0, this.t);
      }
      for (c2 = Math.min(b.t, f2); d2 < c2; ++d2) {
        this.am(0, b[d2], e, d2, 0, f2 - d2);
      }
      e.clamp();
    }
    function bnpMultiplyUpperTo(b, e, d2) {
      --e;
      var c2 = d2.t = this.t + b.t - e;
      d2.s = 0;
      while (--c2 >= 0) {
        d2[c2] = 0;
      }
      for (c2 = Math.max(e - this.t, 0); c2 < b.t; ++c2) {
        d2[this.t + c2 - e] = this.am(e - c2, b[c2], d2, 0, 0, this.t + c2 - e);
      }
      d2.clamp();
      d2.drShiftTo(1, d2);
    }
    function Barrett(a) {
      this.r2 = nbi();
      this.q3 = nbi();
      BigInteger.ONE.dlShiftTo(2 * a.t, this.r2);
      this.mu = this.r2.divide(a);
      this.m = a;
    }
    function barrettConvert(a) {
      if (a.s < 0 || a.t > 2 * this.m.t) {
        return a.mod(this.m);
      } else {
        if (a.compareTo(this.m) < 0) {
          return a;
        } else {
          var b = nbi();
          a.copyTo(b);
          this.reduce(b);
          return b;
        }
      }
    }
    function barrettRevert(a) {
      return a;
    }
    function barrettReduce(a) {
      a.drShiftTo(this.m.t - 1, this.r2);
      if (a.t > this.m.t + 1) {
        a.t = this.m.t + 1;
        a.clamp();
      }
      this.mu.multiplyUpperTo(this.r2, this.m.t + 1, this.q3);
      this.m.multiplyLowerTo(this.q3, this.m.t + 1, this.r2);
      while (a.compareTo(this.r2) < 0) {
        a.dAddOffset(1, this.m.t + 1);
      }
      a.subTo(this.r2, a);
      while (a.compareTo(this.m) >= 0) {
        a.subTo(this.m, a);
      }
    }
    function barrettSqrTo(a, b) {
      a.squareTo(b);
      this.reduce(b);
    }
    function barrettMulTo(a, c2, b) {
      a.multiplyTo(c2, b);
      this.reduce(b);
    }
    Barrett.prototype.convert = barrettConvert;
    Barrett.prototype.revert = barrettRevert;
    Barrett.prototype.reduce = barrettReduce;
    Barrett.prototype.mulTo = barrettMulTo;
    Barrett.prototype.sqrTo = barrettSqrTo;
    function bnModPow(q2, f2) {
      var o2 = q2.bitLength(), h, b = nbv(1), v;
      if (o2 <= 0) {
        return b;
      } else {
        if (o2 < 18) {
          h = 1;
        } else {
          if (o2 < 48) {
            h = 3;
          } else {
            if (o2 < 144) {
              h = 4;
            } else {
              if (o2 < 768) {
                h = 5;
              } else {
                h = 6;
              }
            }
          }
        }
      }
      if (o2 < 8) {
        v = new Classic(f2);
      } else {
        if (f2.isEven()) {
          v = new Barrett(f2);
        } else {
          v = new Montgomery(f2);
        }
      }
      var p3 = new Array(), d2 = 3, s = h - 1, a = (1 << h) - 1;
      p3[1] = v.convert(this);
      if (h > 1) {
        var A = nbi();
        v.sqrTo(p3[1], A);
        while (d2 <= a) {
          p3[d2] = nbi();
          v.mulTo(A, p3[d2 - 2], p3[d2]);
          d2 += 2;
        }
      }
      var l2 = q2.t - 1, x2, u2 = true, c2 = nbi(), y;
      o2 = nbits(q2[l2]) - 1;
      while (l2 >= 0) {
        if (o2 >= s) {
          x2 = q2[l2] >> o2 - s & a;
        } else {
          x2 = (q2[l2] & (1 << o2 + 1) - 1) << s - o2;
          if (l2 > 0) {
            x2 |= q2[l2 - 1] >> this.DB + o2 - s;
          }
        }
        d2 = h;
        while ((x2 & 1) == 0) {
          x2 >>= 1;
          --d2;
        }
        if ((o2 -= d2) < 0) {
          o2 += this.DB;
          --l2;
        }
        if (u2) {
          p3[x2].copyTo(b);
          u2 = false;
        } else {
          while (d2 > 1) {
            v.sqrTo(b, c2);
            v.sqrTo(c2, b);
            d2 -= 2;
          }
          if (d2 > 0) {
            v.sqrTo(b, c2);
          } else {
            y = b;
            b = c2;
            c2 = y;
          }
          v.mulTo(c2, p3[x2], b);
        }
        while (l2 >= 0 && (q2[l2] & 1 << o2) == 0) {
          v.sqrTo(b, c2);
          y = b;
          b = c2;
          c2 = y;
          if (--o2 < 0) {
            o2 = this.DB - 1;
            --l2;
          }
        }
      }
      return v.revert(b);
    }
    function bnGCD(c2) {
      var b = this.s < 0 ? this.negate() : this.clone();
      var h = c2.s < 0 ? c2.negate() : c2.clone();
      if (b.compareTo(h) < 0) {
        var e = b;
        b = h;
        h = e;
      }
      var d2 = b.getLowestSetBit(), f2 = h.getLowestSetBit();
      if (f2 < 0) {
        return b;
      }
      if (d2 < f2) {
        f2 = d2;
      }
      if (f2 > 0) {
        b.rShiftTo(f2, b);
        h.rShiftTo(f2, h);
      }
      while (b.signum() > 0) {
        if ((d2 = b.getLowestSetBit()) > 0) {
          b.rShiftTo(d2, b);
        }
        if ((d2 = h.getLowestSetBit()) > 0) {
          h.rShiftTo(d2, h);
        }
        if (b.compareTo(h) >= 0) {
          b.subTo(h, b);
          b.rShiftTo(1, b);
        } else {
          h.subTo(b, h);
          h.rShiftTo(1, h);
        }
      }
      if (f2 > 0) {
        h.lShiftTo(f2, h);
      }
      return h;
    }
    function bnpModInt(e) {
      if (e <= 0) {
        return 0;
      }
      var c2 = this.DV % e, b = this.s < 0 ? e - 1 : 0;
      if (this.t > 0) {
        if (c2 == 0) {
          b = this[0] % e;
        } else {
          for (var a = this.t - 1; a >= 0; --a) {
            b = (c2 * b + this[a]) % e;
          }
        }
      }
      return b;
    }
    function bnModInverse(f2) {
      var j = f2.isEven();
      if (this.isEven() && j || f2.signum() == 0) {
        return BigInteger.ZERO;
      }
      var i = f2.clone(), h = this.clone();
      var g2 = nbv(1), e = nbv(0), l2 = nbv(0), k = nbv(1);
      while (i.signum() != 0) {
        while (i.isEven()) {
          i.rShiftTo(1, i);
          if (j) {
            if (!g2.isEven() || !e.isEven()) {
              g2.addTo(this, g2);
              e.subTo(f2, e);
            }
            g2.rShiftTo(1, g2);
          } else {
            if (!e.isEven()) {
              e.subTo(f2, e);
            }
          }
          e.rShiftTo(1, e);
        }
        while (h.isEven()) {
          h.rShiftTo(1, h);
          if (j) {
            if (!l2.isEven() || !k.isEven()) {
              l2.addTo(this, l2);
              k.subTo(f2, k);
            }
            l2.rShiftTo(1, l2);
          } else {
            if (!k.isEven()) {
              k.subTo(f2, k);
            }
          }
          k.rShiftTo(1, k);
        }
        if (i.compareTo(h) >= 0) {
          i.subTo(h, i);
          if (j) {
            g2.subTo(l2, g2);
          }
          e.subTo(k, e);
        } else {
          h.subTo(i, h);
          if (j) {
            l2.subTo(g2, l2);
          }
          k.subTo(e, k);
        }
      }
      if (h.compareTo(BigInteger.ONE) != 0) {
        return BigInteger.ZERO;
      }
      if (k.compareTo(f2) >= 0) {
        return k.subtract(f2);
      }
      if (k.signum() < 0) {
        k.addTo(f2, k);
      } else {
        return k;
      }
      if (k.signum() < 0) {
        return k.add(f2);
      } else {
        return k;
      }
    }
    var lowprimes = [2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101, 103, 107, 109, 113, 127, 131, 137, 139, 149, 151, 157, 163, 167, 173, 179, 181, 191, 193, 197, 199, 211, 223, 227, 229, 233, 239, 241, 251, 257, 263, 269, 271, 277, 281, 283, 293, 307, 311, 313, 317, 331, 337, 347, 349, 353, 359, 367, 373, 379, 383, 389, 397, 401, 409, 419, 421, 431, 433, 439, 443, 449, 457, 461, 463, 467, 479, 487, 491, 499, 503, 509, 521, 523, 541, 547, 557, 563, 569, 571, 577, 587, 593, 599, 601, 607, 613, 617, 619, 631, 641, 643, 647, 653, 659, 661, 673, 677, 683, 691, 701, 709, 719, 727, 733, 739, 743, 751, 757, 761, 769, 773, 787, 797, 809, 811, 821, 823, 827, 829, 839, 853, 857, 859, 863, 877, 881, 883, 887, 907, 911, 919, 929, 937, 941, 947, 953, 967, 971, 977, 983, 991, 997];
    var lplim = (1 << 26) / lowprimes[lowprimes.length - 1];
    function bnIsProbablePrime(e) {
      var d2, b = this.abs();
      if (b.t == 1 && b[0] <= lowprimes[lowprimes.length - 1]) {
        for (d2 = 0; d2 < lowprimes.length; ++d2) {
          if (b[0] == lowprimes[d2]) {
            return true;
          }
        }
        return false;
      }
      if (b.isEven()) {
        return false;
      }
      d2 = 1;
      while (d2 < lowprimes.length) {
        var a = lowprimes[d2], c2 = d2 + 1;
        while (c2 < lowprimes.length && a < lplim) {
          a *= lowprimes[c2++];
        }
        a = b.modInt(a);
        while (d2 < c2) {
          if (a % lowprimes[d2++] == 0) {
            return false;
          }
        }
      }
      return b.millerRabin(e);
    }
    function bnpMillerRabin(f2) {
      var g2 = this.subtract(BigInteger.ONE);
      var c2 = g2.getLowestSetBit();
      if (c2 <= 0) {
        return false;
      }
      var h = g2.shiftRight(c2);
      f2 = f2 + 1 >> 1;
      if (f2 > lowprimes.length) {
        f2 = lowprimes.length;
      }
      var b = nbi();
      for (var e = 0; e < f2; ++e) {
        b.fromInt(lowprimes[Math.floor(Math.random() * lowprimes.length)]);
        var l2 = b.modPow(h, this);
        if (l2.compareTo(BigInteger.ONE) != 0 && l2.compareTo(g2) != 0) {
          var d2 = 1;
          while (d2++ < c2 && l2.compareTo(g2) != 0) {
            l2 = l2.modPowInt(2, this);
            if (l2.compareTo(BigInteger.ONE) == 0) {
              return false;
            }
          }
          if (l2.compareTo(g2) != 0) {
            return false;
          }
        }
      }
      return true;
    }
    BigInteger.prototype.chunkSize = bnpChunkSize;
    BigInteger.prototype.toRadix = bnpToRadix;
    BigInteger.prototype.fromRadix = bnpFromRadix;
    BigInteger.prototype.fromNumber = bnpFromNumber;
    BigInteger.prototype.bitwiseTo = bnpBitwiseTo;
    BigInteger.prototype.changeBit = bnpChangeBit;
    BigInteger.prototype.addTo = bnpAddTo;
    BigInteger.prototype.dMultiply = bnpDMultiply;
    BigInteger.prototype.dAddOffset = bnpDAddOffset;
    BigInteger.prototype.multiplyLowerTo = bnpMultiplyLowerTo;
    BigInteger.prototype.multiplyUpperTo = bnpMultiplyUpperTo;
    BigInteger.prototype.modInt = bnpModInt;
    BigInteger.prototype.millerRabin = bnpMillerRabin;
    BigInteger.prototype.clone = bnClone;
    BigInteger.prototype.intValue = bnIntValue;
    BigInteger.prototype.byteValue = bnByteValue;
    BigInteger.prototype.shortValue = bnShortValue;
    BigInteger.prototype.signum = bnSigNum;
    BigInteger.prototype.toByteArray = bnToByteArray;
    BigInteger.prototype.equals = bnEquals;
    BigInteger.prototype.min = bnMin;
    BigInteger.prototype.max = bnMax;
    BigInteger.prototype.and = bnAnd;
    BigInteger.prototype.or = bnOr;
    BigInteger.prototype.xor = bnXor;
    BigInteger.prototype.andNot = bnAndNot;
    BigInteger.prototype.not = bnNot;
    BigInteger.prototype.shiftLeft = bnShiftLeft;
    BigInteger.prototype.shiftRight = bnShiftRight;
    BigInteger.prototype.getLowestSetBit = bnGetLowestSetBit;
    BigInteger.prototype.bitCount = bnBitCount;
    BigInteger.prototype.testBit = bnTestBit;
    BigInteger.prototype.setBit = bnSetBit;
    BigInteger.prototype.clearBit = bnClearBit;
    BigInteger.prototype.flipBit = bnFlipBit;
    BigInteger.prototype.add = bnAdd;
    BigInteger.prototype.subtract = bnSubtract;
    BigInteger.prototype.multiply = bnMultiply;
    BigInteger.prototype.divide = bnDivide;
    BigInteger.prototype.remainder = bnRemainder;
    BigInteger.prototype.divideAndRemainder = bnDivideAndRemainder;
    BigInteger.prototype.modPow = bnModPow;
    BigInteger.prototype.modInverse = bnModInverse;
    BigInteger.prototype.pow = bnPow;
    BigInteger.prototype.gcd = bnGCD;
    BigInteger.prototype.isProbablePrime = bnIsProbablePrime;
    BigInteger.prototype.square = bnSquare;
    function Arcfour() {
      this.i = 0;
      this.j = 0;
      this.S = new Array();
    }
    function ARC4init(d2) {
      var c2, a, b;
      for (c2 = 0; c2 < 256; ++c2) {
        this.S[c2] = c2;
      }
      a = 0;
      for (c2 = 0; c2 < 256; ++c2) {
        a = a + this.S[c2] + d2[c2 % d2.length] & 255;
        b = this.S[c2];
        this.S[c2] = this.S[a];
        this.S[a] = b;
      }
      this.i = 0;
      this.j = 0;
    }
    function ARC4next() {
      var a;
      this.i = this.i + 1 & 255;
      this.j = this.j + this.S[this.i] & 255;
      a = this.S[this.i];
      this.S[this.i] = this.S[this.j];
      this.S[this.j] = a;
      return this.S[a + this.S[this.i] & 255];
    }
    Arcfour.prototype.init = ARC4init;
    Arcfour.prototype.next = ARC4next;
    function prng_newstate() {
      return new Arcfour();
    }
    var rng_psize = 256;
    var rng_state;
    var rng_pool;
    var rng_pptr;
    function rng_seed_int(a) {
      rng_pool[rng_pptr++] ^= a & 255;
      rng_pool[rng_pptr++] ^= a >> 8 & 255;
      rng_pool[rng_pptr++] ^= a >> 16 & 255;
      rng_pool[rng_pptr++] ^= a >> 24 & 255;
      if (rng_pptr >= rng_psize) {
        rng_pptr -= rng_psize;
      }
    }
    function rng_seed_time() {
      rng_seed_int((/* @__PURE__ */ new Date()).getTime());
    }
    if (rng_pool == null) {
      rng_pool = new Array();
      rng_pptr = 0;
      if (window2 !== void 0 && (window2.crypto !== void 0 || window2.msCrypto !== void 0)) {
        crypto2 = window2.crypto || window2.msCrypto;
        if (crypto2.getRandomValues) {
          ua = new Uint8Array(32);
          crypto2.getRandomValues(ua);
          for (t = 0; t < 32; ++t) {
            rng_pool[rng_pptr++] = ua[t];
          }
        } else {
          if (navigator2.appName == "Netscape" && navigator2.appVersion < "5") {
            z = window2.crypto.random(32);
            for (t = 0; t < z.length; ++t) {
              rng_pool[rng_pptr++] = z.charCodeAt(t) & 255;
            }
          }
        }
      }
      while (rng_pptr < rng_psize) {
        t = Math.floor(65536 * Math.random());
        rng_pool[rng_pptr++] = t >>> 8;
        rng_pool[rng_pptr++] = t & 255;
      }
      rng_pptr = 0;
      rng_seed_time();
    }
    var t;
    var crypto2;
    var ua;
    var z;
    function rng_get_byte() {
      if (rng_state == null) {
        rng_seed_time();
        rng_state = prng_newstate();
        rng_state.init(rng_pool);
        for (rng_pptr = 0; rng_pptr < rng_pool.length; ++rng_pptr) {
          rng_pool[rng_pptr] = 0;
        }
        rng_pptr = 0;
      }
      return rng_state.next();
    }
    function rng_get_bytes(b) {
      var a;
      for (a = 0; a < b.length; ++a) {
        b[a] = rng_get_byte();
      }
    }
    function SecureRandom2() {
    }
    SecureRandom2.prototype.nextBytes = rng_get_bytes;
    function parseBigInt(b, a) {
      return new BigInteger(b, a);
    }
    function RSAKey() {
      this.n = null;
      this.e = 0;
      this.d = null;
      this.p = null;
      this.q = null;
      this.dmp1 = null;
      this.dmq1 = null;
      this.coeff = null;
    }
    function RSASetPublic(b, a) {
      this.isPublic = true;
      this.isPrivate = false;
      if (typeof b !== "string") {
        this.n = b;
        this.e = a;
      } else {
        if (b != null && a != null && b.length > 0 && a.length > 0) {
          this.n = parseBigInt(b, 16);
          this.e = parseInt(a, 16);
        } else {
          throw "Invalid RSA public key";
        }
      }
    }
    function RSADoPublic(a) {
      return a.modPowInt(this.e, this.n);
    }
    RSAKey.prototype.doPublic = RSADoPublic;
    RSAKey.prototype.setPublic = RSASetPublic;
    RSAKey.prototype.type = "RSA";
    function RSASetPrivate(c2, a, b) {
      this.isPrivate = true;
      if (typeof c2 !== "string") {
        this.n = c2;
        this.e = a;
        this.d = b;
      } else {
        if (c2 != null && a != null && c2.length > 0 && a.length > 0) {
          this.n = parseBigInt(c2, 16);
          this.e = parseInt(a, 16);
          this.d = parseBigInt(b, 16);
        } else {
          throw "Invalid RSA private key";
        }
      }
    }
    function RSASetPrivateEx(g2, d2, e, c2, b, a, h, f2) {
      this.isPrivate = true;
      this.isPublic = false;
      if (g2 == null) {
        throw "RSASetPrivateEx N == null";
      }
      if (d2 == null) {
        throw "RSASetPrivateEx E == null";
      }
      if (g2.length == 0) {
        throw "RSASetPrivateEx N.length == 0";
      }
      if (d2.length == 0) {
        throw "RSASetPrivateEx E.length == 0";
      }
      if (g2 != null && d2 != null && g2.length > 0 && d2.length > 0) {
        this.n = parseBigInt(g2, 16);
        this.e = parseInt(d2, 16);
        this.d = parseBigInt(e, 16);
        this.p = parseBigInt(c2, 16);
        this.q = parseBigInt(b, 16);
        this.dmp1 = parseBigInt(a, 16);
        this.dmq1 = parseBigInt(h, 16);
        this.coeff = parseBigInt(f2, 16);
      } else {
        throw "Invalid RSA private key in RSASetPrivateEx";
      }
    }
    function RSAGenerate(b, l2) {
      var a = new SecureRandom2();
      var g2 = b >> 1;
      this.e = parseInt(l2, 16);
      var c2 = new BigInteger(l2, 16);
      var d2 = b / 2 - 100;
      var k = BigInteger.ONE.shiftLeft(d2);
      for (; ; ) {
        for (; ; ) {
          this.p = new BigInteger(b - g2, 1, a);
          if (this.p.subtract(BigInteger.ONE).gcd(c2).compareTo(BigInteger.ONE) == 0 && this.p.isProbablePrime(10)) {
            break;
          }
        }
        for (; ; ) {
          this.q = new BigInteger(g2, 1, a);
          if (this.q.subtract(BigInteger.ONE).gcd(c2).compareTo(BigInteger.ONE) == 0 && this.q.isProbablePrime(10)) {
            break;
          }
        }
        if (this.p.compareTo(this.q) <= 0) {
          var j = this.p;
          this.p = this.q;
          this.q = j;
        }
        var h = this.q.subtract(this.p).abs();
        if (h.bitLength() < d2 || h.compareTo(k) <= 0) {
          continue;
        }
        var i = this.p.subtract(BigInteger.ONE);
        var e = this.q.subtract(BigInteger.ONE);
        var f2 = i.multiply(e);
        if (f2.gcd(c2).compareTo(BigInteger.ONE) == 0) {
          this.n = this.p.multiply(this.q);
          if (this.n.bitLength() == b) {
            this.d = c2.modInverse(f2);
            this.dmp1 = this.d.mod(i);
            this.dmq1 = this.d.mod(e);
            this.coeff = this.q.modInverse(this.p);
            break;
          }
        }
      }
      this.isPrivate = true;
    }
    function RSADoPrivate(a) {
      if (this.p == null || this.q == null) {
        return a.modPow(this.d, this.n);
      }
      var c2 = a.mod(this.p).modPow(this.dmp1, this.p);
      var b = a.mod(this.q).modPow(this.dmq1, this.q);
      while (c2.compareTo(b) < 0) {
        c2 = c2.add(this.p);
      }
      return c2.subtract(b).multiply(this.coeff).mod(this.p).multiply(this.q).add(b);
    }
    RSAKey.prototype.doPrivate = RSADoPrivate;
    RSAKey.prototype.setPrivate = RSASetPrivate;
    RSAKey.prototype.setPrivateEx = RSASetPrivateEx;
    RSAKey.prototype.generate = RSAGenerate;
    function ECFieldElementFp(b, a) {
      this.x = a;
      this.q = b;
    }
    function feFpEquals(a) {
      if (a == this) {
        return true;
      }
      return this.q.equals(a.q) && this.x.equals(a.x);
    }
    function feFpToBigInteger() {
      return this.x;
    }
    function feFpNegate() {
      return new ECFieldElementFp(this.q, this.x.negate().mod(this.q));
    }
    function feFpAdd(a) {
      return new ECFieldElementFp(this.q, this.x.add(a.toBigInteger()).mod(this.q));
    }
    function feFpSubtract(a) {
      return new ECFieldElementFp(this.q, this.x.subtract(a.toBigInteger()).mod(this.q));
    }
    function feFpMultiply(a) {
      return new ECFieldElementFp(this.q, this.x.multiply(a.toBigInteger()).mod(this.q));
    }
    function feFpSquare() {
      return new ECFieldElementFp(this.q, this.x.square().mod(this.q));
    }
    function feFpDivide(a) {
      return new ECFieldElementFp(this.q, this.x.multiply(a.toBigInteger().modInverse(this.q)).mod(this.q));
    }
    ECFieldElementFp.prototype.equals = feFpEquals;
    ECFieldElementFp.prototype.toBigInteger = feFpToBigInteger;
    ECFieldElementFp.prototype.negate = feFpNegate;
    ECFieldElementFp.prototype.add = feFpAdd;
    ECFieldElementFp.prototype.subtract = feFpSubtract;
    ECFieldElementFp.prototype.multiply = feFpMultiply;
    ECFieldElementFp.prototype.square = feFpSquare;
    ECFieldElementFp.prototype.divide = feFpDivide;
    ECFieldElementFp.prototype.sqrt = function() {
      return new ECFieldElementFp(this.q, this.x.sqrt().mod(this.q));
    };
    function ECPointFp(c2, a, d2, b) {
      this.curve = c2;
      this.x = a;
      this.y = d2;
      if (b == null) {
        this.z = BigInteger.ONE;
      } else {
        this.z = b;
      }
      this.zinv = null;
    }
    function pointFpGetX() {
      if (this.zinv == null) {
        this.zinv = this.z.modInverse(this.curve.q);
      }
      return this.curve.fromBigInteger(this.x.toBigInteger().multiply(this.zinv).mod(this.curve.q));
    }
    function pointFpGetY() {
      if (this.zinv == null) {
        this.zinv = this.z.modInverse(this.curve.q);
      }
      return this.curve.fromBigInteger(this.y.toBigInteger().multiply(this.zinv).mod(this.curve.q));
    }
    function pointFpEquals(a) {
      if (a == this) {
        return true;
      }
      if (this.isInfinity()) {
        return a.isInfinity();
      }
      if (a.isInfinity()) {
        return this.isInfinity();
      }
      var c2, b;
      c2 = a.y.toBigInteger().multiply(this.z).subtract(this.y.toBigInteger().multiply(a.z)).mod(this.curve.q);
      if (!c2.equals(BigInteger.ZERO)) {
        return false;
      }
      b = a.x.toBigInteger().multiply(this.z).subtract(this.x.toBigInteger().multiply(a.z)).mod(this.curve.q);
      return b.equals(BigInteger.ZERO);
    }
    function pointFpIsInfinity() {
      if (this.x == null && this.y == null) {
        return true;
      }
      return this.z.equals(BigInteger.ZERO) && !this.y.toBigInteger().equals(BigInteger.ZERO);
    }
    function pointFpNegate() {
      return new ECPointFp(this.curve, this.x, this.y.negate(), this.z);
    }
    function pointFpAdd(l2) {
      if (this.isInfinity()) {
        return l2;
      }
      if (l2.isInfinity()) {
        return this;
      }
      var p3 = l2.y.toBigInteger().multiply(this.z).subtract(this.y.toBigInteger().multiply(l2.z)).mod(this.curve.q);
      var o2 = l2.x.toBigInteger().multiply(this.z).subtract(this.x.toBigInteger().multiply(l2.z)).mod(this.curve.q);
      if (BigInteger.ZERO.equals(o2)) {
        if (BigInteger.ZERO.equals(p3)) {
          return this.twice();
        }
        return this.curve.getInfinity();
      }
      var j = new BigInteger("3");
      var e = this.x.toBigInteger();
      var n = this.y.toBigInteger();
      var c2 = l2.x.toBigInteger();
      var k = l2.y.toBigInteger();
      var m2 = o2.square();
      var i = m2.multiply(o2);
      var d2 = e.multiply(m2);
      var g2 = p3.square().multiply(this.z);
      var a = g2.subtract(d2.shiftLeft(1)).multiply(l2.z).subtract(i).multiply(o2).mod(this.curve.q);
      var h = d2.multiply(j).multiply(p3).subtract(n.multiply(i)).subtract(g2.multiply(p3)).multiply(l2.z).add(p3.multiply(i)).mod(this.curve.q);
      var f2 = i.multiply(this.z).multiply(l2.z).mod(this.curve.q);
      return new ECPointFp(this.curve, this.curve.fromBigInteger(a), this.curve.fromBigInteger(h), f2);
    }
    function pointFpTwice() {
      if (this.isInfinity()) {
        return this;
      }
      if (this.y.toBigInteger().signum() == 0) {
        return this.curve.getInfinity();
      }
      var g2 = new BigInteger("3");
      var c2 = this.x.toBigInteger();
      var h = this.y.toBigInteger();
      var e = h.multiply(this.z);
      var j = e.multiply(h).mod(this.curve.q);
      var i = this.curve.a.toBigInteger();
      var k = c2.square().multiply(g2);
      if (!BigInteger.ZERO.equals(i)) {
        k = k.add(this.z.square().multiply(i));
      }
      k = k.mod(this.curve.q);
      var b = k.square().subtract(c2.shiftLeft(3).multiply(j)).shiftLeft(1).multiply(e).mod(this.curve.q);
      var f2 = k.multiply(g2).multiply(c2).subtract(j.shiftLeft(1)).shiftLeft(2).multiply(j).subtract(k.square().multiply(k)).mod(this.curve.q);
      var d2 = e.square().multiply(e).shiftLeft(3).mod(this.curve.q);
      return new ECPointFp(this.curve, this.curve.fromBigInteger(b), this.curve.fromBigInteger(f2), d2);
    }
    function pointFpMultiply(d2) {
      if (this.isInfinity()) {
        return this;
      }
      if (d2.signum() == 0) {
        return this.curve.getInfinity();
      }
      var m2 = d2;
      var l2 = m2.multiply(new BigInteger("3"));
      var b = this.negate();
      var j = this;
      var q2 = this.curve.q.subtract(d2);
      var o2 = q2.multiply(new BigInteger("3"));
      var c2 = new ECPointFp(this.curve, this.x, this.y);
      var a = c2.negate();
      var g2;
      for (g2 = l2.bitLength() - 2; g2 > 0; --g2) {
        j = j.twice();
        var n = l2.testBit(g2);
        var f2 = m2.testBit(g2);
        if (n != f2) {
          j = j.add(n ? this : b);
        }
      }
      for (g2 = o2.bitLength() - 2; g2 > 0; --g2) {
        c2 = c2.twice();
        var p3 = o2.testBit(g2);
        var r = q2.testBit(g2);
        if (p3 != r) {
          c2 = c2.add(p3 ? c2 : a);
        }
      }
      return j;
    }
    function pointFpMultiplyTwo(c2, a, b) {
      var d2;
      if (c2.bitLength() > b.bitLength()) {
        d2 = c2.bitLength() - 1;
      } else {
        d2 = b.bitLength() - 1;
      }
      var f2 = this.curve.getInfinity();
      var e = this.add(a);
      while (d2 >= 0) {
        f2 = f2.twice();
        if (c2.testBit(d2)) {
          if (b.testBit(d2)) {
            f2 = f2.add(e);
          } else {
            f2 = f2.add(this);
          }
        } else {
          if (b.testBit(d2)) {
            f2 = f2.add(a);
          }
        }
        --d2;
      }
      return f2;
    }
    ECPointFp.prototype.getX = pointFpGetX;
    ECPointFp.prototype.getY = pointFpGetY;
    ECPointFp.prototype.equals = pointFpEquals;
    ECPointFp.prototype.isInfinity = pointFpIsInfinity;
    ECPointFp.prototype.negate = pointFpNegate;
    ECPointFp.prototype.add = pointFpAdd;
    ECPointFp.prototype.twice = pointFpTwice;
    ECPointFp.prototype.multiply = pointFpMultiply;
    ECPointFp.prototype.multiplyTwo = pointFpMultiplyTwo;
    function ECCurveFp(e, d2, c2) {
      this.q = e;
      this.a = this.fromBigInteger(d2);
      this.b = this.fromBigInteger(c2);
      this.infinity = new ECPointFp(this, null, null);
    }
    function curveFpGetQ() {
      return this.q;
    }
    function curveFpGetA() {
      return this.a;
    }
    function curveFpGetB() {
      return this.b;
    }
    function curveFpEquals(a) {
      if (a == this) {
        return true;
      }
      return this.q.equals(a.q) && this.a.equals(a.a) && this.b.equals(a.b);
    }
    function curveFpGetInfinity() {
      return this.infinity;
    }
    function curveFpFromBigInteger(a) {
      return new ECFieldElementFp(this.q, a);
    }
    function curveFpDecodePointHex(m2) {
      switch (parseInt(m2.substr(0, 2), 16)) {
        case 0:
          return this.infinity;
        case 2:
        case 3:
          var c2 = m2.substr(0, 2);
          var l2 = m2.substr(2);
          var j = this.fromBigInteger(new BigInteger(k, 16));
          var i = this.getA();
          var h = this.getB();
          var e = j.square().add(i).multiply(j).add(h);
          var g2 = e.sqrt();
          if (c2 == "03") {
            g2 = g2.negate();
          }
          return new ECPointFp(this, j, g2);
        case 4:
        case 6:
        case 7:
          var d2 = (m2.length - 2) / 2;
          var k = m2.substr(2, d2);
          var f2 = m2.substr(d2 + 2, d2);
          return new ECPointFp(this, this.fromBigInteger(new BigInteger(k, 16)), this.fromBigInteger(new BigInteger(f2, 16)));
        default:
          return null;
      }
    }
    ECCurveFp.prototype.getQ = curveFpGetQ;
    ECCurveFp.prototype.getA = curveFpGetA;
    ECCurveFp.prototype.getB = curveFpGetB;
    ECCurveFp.prototype.equals = curveFpEquals;
    ECCurveFp.prototype.getInfinity = curveFpGetInfinity;
    ECCurveFp.prototype.fromBigInteger = curveFpFromBigInteger;
    ECCurveFp.prototype.decodePointHex = curveFpDecodePointHex;
    ECFieldElementFp.prototype.getByteLength = function() {
      return Math.floor((this.toBigInteger().bitLength() + 7) / 8);
    };
    ECPointFp.prototype.getEncoded = function(c2) {
      var d2 = function(h, f2) {
        var g2 = h.toByteArrayUnsigned();
        if (f2 < g2.length) {
          g2 = g2.slice(g2.length - f2);
        } else {
          while (f2 > g2.length) {
            g2.unshift(0);
          }
        }
        return g2;
      };
      var a = this.getX().toBigInteger();
      var e = this.getY().toBigInteger();
      var b = d2(a, 32);
      if (c2) {
        if (e.isEven()) {
          b.unshift(2);
        } else {
          b.unshift(3);
        }
      } else {
        b.unshift(4);
        b = b.concat(d2(e, 32));
      }
      return b;
    };
    ECPointFp.decodeFrom = function(g2, c2) {
      var f2 = c2[0];
      var e = c2.length - 1;
      var d2 = c2.slice(1, 1 + e / 2);
      var b = c2.slice(1 + e / 2, 1 + e);
      d2.unshift(0);
      b.unshift(0);
      var a = new BigInteger(d2);
      var h = new BigInteger(b);
      return new ECPointFp(g2, g2.fromBigInteger(a), g2.fromBigInteger(h));
    };
    ECPointFp.decodeFromHex = function(g2, c2) {
      var f2 = c2.substr(0, 2);
      var e = c2.length - 2;
      var d2 = c2.substr(2, e / 2);
      var b = c2.substr(2 + e / 2, e / 2);
      var a = new BigInteger(d2, 16);
      var h = new BigInteger(b, 16);
      return new ECPointFp(g2, g2.fromBigInteger(a), g2.fromBigInteger(h));
    };
    ECPointFp.prototype.add2D = function(c2) {
      if (this.isInfinity()) {
        return c2;
      }
      if (c2.isInfinity()) {
        return this;
      }
      if (this.x.equals(c2.x)) {
        if (this.y.equals(c2.y)) {
          return this.twice();
        }
        return this.curve.getInfinity();
      }
      var g2 = c2.x.subtract(this.x);
      var e = c2.y.subtract(this.y);
      var a = e.divide(g2);
      var d2 = a.square().subtract(this.x).subtract(c2.x);
      var f2 = a.multiply(this.x.subtract(d2)).subtract(this.y);
      return new ECPointFp(this.curve, d2, f2);
    };
    ECPointFp.prototype.twice2D = function() {
      if (this.isInfinity()) {
        return this;
      }
      if (this.y.toBigInteger().signum() == 0) {
        return this.curve.getInfinity();
      }
      var b = this.curve.fromBigInteger(BigInteger.valueOf(2));
      var e = this.curve.fromBigInteger(BigInteger.valueOf(3));
      var a = this.x.square().multiply(e).add(this.curve.a).divide(this.y.multiply(b));
      var c2 = a.square().subtract(this.x.multiply(b));
      var d2 = a.multiply(this.x.subtract(c2)).subtract(this.y);
      return new ECPointFp(this.curve, c2, d2);
    };
    ECPointFp.prototype.multiply2D = function(b) {
      if (this.isInfinity()) {
        return this;
      }
      if (b.signum() == 0) {
        return this.curve.getInfinity();
      }
      var g2 = b;
      var f2 = g2.multiply(new BigInteger("3"));
      var l2 = this.negate();
      var d2 = this;
      var c2;
      for (c2 = f2.bitLength() - 2; c2 > 0; --c2) {
        d2 = d2.twice();
        var a = f2.testBit(c2);
        var j = g2.testBit(c2);
        if (a != j) {
          d2 = d2.add2D(a ? this : l2);
        }
      }
      return d2;
    };
    ECPointFp.prototype.isOnCurve = function() {
      var d2 = this.getX().toBigInteger();
      var i = this.getY().toBigInteger();
      var f2 = this.curve.getA().toBigInteger();
      var c2 = this.curve.getB().toBigInteger();
      var h = this.curve.getQ();
      var e = i.multiply(i).mod(h);
      var g2 = d2.multiply(d2).multiply(d2).add(f2.multiply(d2)).add(c2).mod(h);
      return e.equals(g2);
    };
    ECPointFp.prototype.toString = function() {
      return "(" + this.getX().toBigInteger().toString() + "," + this.getY().toBigInteger().toString() + ")";
    };
    ECPointFp.prototype.validate = function() {
      var c2 = this.curve.getQ();
      if (this.isInfinity()) {
        throw new Error("Point is at infinity.");
      }
      var a = this.getX().toBigInteger();
      var b = this.getY().toBigInteger();
      if (a.compareTo(BigInteger.ONE) < 0 || a.compareTo(c2.subtract(BigInteger.ONE)) > 0) {
        throw new Error("x coordinate out of bounds");
      }
      if (b.compareTo(BigInteger.ONE) < 0 || b.compareTo(c2.subtract(BigInteger.ONE)) > 0) {
        throw new Error("y coordinate out of bounds");
      }
      if (!this.isOnCurve()) {
        throw new Error("Point is not on the curve.");
      }
      if (this.multiply(c2).isInfinity()) {
        throw new Error("Point is not a scalar multiple of G.");
      }
      return true;
    };
    var jsonParse = function() {
      var e = "(?:-?\\b(?:0|[1-9][0-9]*)(?:\\.[0-9]+)?(?:[eE][+-]?[0-9]+)?\\b)";
      var j = '(?:[^\\0-\\x08\\x0a-\\x1f"\\\\]|\\\\(?:["/\\\\bfnrt]|u[0-9A-Fa-f]{4}))';
      var i = '(?:"' + j + '*")';
      var d2 = new RegExp("(?:false|true|null|[\\{\\}\\[\\]]|" + e + "|" + i + ")", "g");
      var k = new RegExp("\\\\(?:([^u])|u(.{4}))", "g");
      var g2 = { '"': '"', "/": "/", "\\": "\\", b: "\b", f: "\f", n: "\n", r: "\r", t: "	" };
      function h(l2, m2, n) {
        return m2 ? g2[m2] : String.fromCharCode(parseInt(n, 16));
      }
      var c2 = new String("");
      var a = "\\";
      var f2 = { "{": Object, "[": Array };
      var b = Object.hasOwnProperty;
      return function(u2, q2) {
        var p3 = u2.match(d2);
        var x2;
        var v = p3[0];
        var l2 = false;
        if ("{" === v) {
          x2 = {};
        } else {
          if ("[" === v) {
            x2 = [];
          } else {
            x2 = [];
            l2 = true;
          }
        }
        var t2;
        var r = [x2];
        for (var o2 = 1 - l2, m2 = p3.length; o2 < m2; ++o2) {
          v = p3[o2];
          var w;
          switch (v.charCodeAt(0)) {
            default:
              w = r[0];
              w[t2 || w.length] = +v;
              t2 = void 0;
              break;
            case 34:
              v = v.substring(1, v.length - 1);
              if (v.indexOf(a) !== -1) {
                v = v.replace(k, h);
              }
              w = r[0];
              if (!t2) {
                if (w instanceof Array) {
                  t2 = w.length;
                } else {
                  t2 = v || c2;
                  break;
                }
              }
              w[t2] = v;
              t2 = void 0;
              break;
            case 91:
              w = r[0];
              r.unshift(w[t2 || w.length] = []);
              t2 = void 0;
              break;
            case 93:
              r.shift();
              break;
            case 102:
              w = r[0];
              w[t2 || w.length] = false;
              t2 = void 0;
              break;
            case 110:
              w = r[0];
              w[t2 || w.length] = null;
              t2 = void 0;
              break;
            case 116:
              w = r[0];
              w[t2 || w.length] = true;
              t2 = void 0;
              break;
            case 123:
              w = r[0];
              r.unshift(w[t2 || w.length] = {});
              t2 = void 0;
              break;
            case 125:
              r.shift();
              break;
          }
        }
        if (l2) {
          if (r.length !== 1) {
            throw new Error();
          }
          x2 = x2[0];
        } else {
          if (r.length) {
            throw new Error();
          }
        }
        if (q2) {
          var s = function(C, B) {
            var D = C[B];
            if (D && typeof D === "object") {
              var n = null;
              for (var z2 in D) {
                if (b.call(D, z2) && D !== C) {
                  var y = s(D, z2);
                  if (y !== void 0) {
                    D[z2] = y;
                  } else {
                    if (!n) {
                      n = [];
                    }
                    n.push(z2);
                  }
                }
              }
              if (n) {
                for (var A = n.length; --A >= 0; ) {
                  delete D[n[A]];
                }
              }
            }
            return q2.call(C, B, D);
          };
          x2 = s({ "": x2 }, "");
        }
        return x2;
      };
    }();
    if (typeof KJUR == "undefined" || !KJUR) {
      KJUR = {};
    }
    if (typeof KJUR.asn1 == "undefined" || !KJUR.asn1) {
      KJUR.asn1 = {};
    }
    KJUR.asn1.ASN1Util = new function() {
      this.integerToByteHex = function(a) {
        var b = a.toString(16);
        if (b.length % 2 == 1) {
          b = "0" + b;
        }
        return b;
      };
      this.bigIntToMinTwosComplementsHex = function(a) {
        return twoscompl(a);
      };
      this.getPEMStringFromHex = function(a, b) {
        return hextopem(a, b);
      };
      this.newObject = function(k) {
        var F = KJUR, o2 = F.asn1, v = o2.ASN1Object, B = o2.DERBoolean, e = o2.DERInteger, t2 = o2.DERBitString, h = o2.DEROctetString, x2 = o2.DERNull, y = o2.DERObjectIdentifier, m2 = o2.DEREnumerated, g2 = o2.DERUTF8String, f2 = o2.DERNumericString, A = o2.DERPrintableString, w = o2.DERTeletexString, q2 = o2.DERIA5String, E = o2.DERUTCTime, j = o2.DERGeneralizedTime, b = o2.DERVisibleString, l2 = o2.DERBMPString, n = o2.DERSequence, c2 = o2.DERSet, s = o2.DERTaggedObject, p3 = o2.ASN1Util.newObject;
        if (k instanceof o2.ASN1Object) {
          return k;
        }
        var u2 = Object.keys(k);
        if (u2.length != 1) {
          throw new Error("key of param shall be only one.");
        }
        var H = u2[0];
        if (":asn1:bool:int:bitstr:octstr:null:oid:enum:utf8str:numstr:prnstr:telstr:ia5str:utctime:gentime:visstr:bmpstr:seq:set:tag:".indexOf(":" + H + ":") == -1) {
          throw new Error("undefined key: " + H);
        }
        if (H == "bool") {
          return new B(k[H]);
        }
        if (H == "int") {
          return new e(k[H]);
        }
        if (H == "bitstr") {
          return new t2(k[H]);
        }
        if (H == "octstr") {
          return new h(k[H]);
        }
        if (H == "null") {
          return new x2(k[H]);
        }
        if (H == "oid") {
          return new y(k[H]);
        }
        if (H == "enum") {
          return new m2(k[H]);
        }
        if (H == "utf8str") {
          return new g2(k[H]);
        }
        if (H == "numstr") {
          return new f2(k[H]);
        }
        if (H == "prnstr") {
          return new A(k[H]);
        }
        if (H == "telstr") {
          return new w(k[H]);
        }
        if (H == "ia5str") {
          return new q2(k[H]);
        }
        if (H == "utctime") {
          return new E(k[H]);
        }
        if (H == "gentime") {
          return new j(k[H]);
        }
        if (H == "visstr") {
          return new b(k[H]);
        }
        if (H == "bmpstr") {
          return new l2(k[H]);
        }
        if (H == "asn1") {
          return new v(k[H]);
        }
        if (H == "seq") {
          var d2 = k[H];
          var G = [];
          for (var z2 = 0; z2 < d2.length; z2++) {
            var D = p3(d2[z2]);
            G.push(D);
          }
          return new n({ array: G });
        }
        if (H == "set") {
          var d2 = k[H];
          var G = [];
          for (var z2 = 0; z2 < d2.length; z2++) {
            var D = p3(d2[z2]);
            G.push(D);
          }
          return new c2({ array: G });
        }
        if (H == "tag") {
          var C = k[H];
          if (Object.prototype.toString.call(C) === "[object Array]" && C.length == 3) {
            var r = p3(C[2]);
            return new s({ tag: C[0], explicit: C[1], obj: r });
          } else {
            return new s(C);
          }
        }
      };
      this.jsonToASN1HEX = function(b) {
        var a = this.newObject(b);
        return a.tohex();
      };
    }();
    KJUR.asn1.ASN1Util.oidHexToInt = function(a) {
      var j = "";
      var k = parseInt(a.substr(0, 2), 16);
      var d2 = Math.floor(k / 40);
      var c2 = k % 40;
      var j = d2 + "." + c2;
      var e = "";
      for (var f2 = 2; f2 < a.length; f2 += 2) {
        var g2 = parseInt(a.substr(f2, 2), 16);
        var h = ("00000000" + g2.toString(2)).slice(-8);
        e = e + h.substr(1, 7);
        if (h.substr(0, 1) == "0") {
          var b = new BigInteger(e, 2);
          j = j + "." + b.toString(10);
          e = "";
        }
      }
      return j;
    };
    KJUR.asn1.ASN1Util.oidIntToHex = function(f2) {
      var e = function(a) {
        var k = a.toString(16);
        if (k.length == 1) {
          k = "0" + k;
        }
        return k;
      };
      var d2 = function(o2) {
        var n = "";
        var k = new BigInteger(o2, 10);
        var a = k.toString(2);
        var l2 = 7 - a.length % 7;
        if (l2 == 7) {
          l2 = 0;
        }
        var q2 = "";
        for (var m2 = 0; m2 < l2; m2++) {
          q2 += "0";
        }
        a = q2 + a;
        for (var m2 = 0; m2 < a.length - 1; m2 += 7) {
          var p3 = a.substr(m2, 7);
          if (m2 != a.length - 7) {
            p3 = "1" + p3;
          }
          n += e(parseInt(p3, 2));
        }
        return n;
      };
      if (!f2.match(/^[0-9.]+$/)) {
        throw "malformed oid string: " + f2;
      }
      var g2 = "";
      var b = f2.split(".");
      var j = parseInt(b[0]) * 40 + parseInt(b[1]);
      g2 += e(j);
      b.splice(0, 2);
      for (var c2 = 0; c2 < b.length; c2++) {
        g2 += d2(b[c2]);
      }
      return g2;
    };
    KJUR.asn1.ASN1Object = function(e) {
      var c2 = true;
      var b = null;
      var d2 = "00";
      var f2 = "00";
      var a = "";
      this.params = null;
      this.getLengthHexFromValue = function() {
        if (typeof this.hV == "undefined" || this.hV == null) {
          throw new Error("this.hV is null or undefined");
        }
        if (this.hV.length % 2 == 1) {
          throw new Error("value hex must be even length: n=" + a.length + ",v=" + this.hV);
        }
        var j = this.hV.length / 2;
        var i = j.toString(16);
        if (i.length % 2 == 1) {
          i = "0" + i;
        }
        if (j < 128) {
          return i;
        } else {
          var h = i.length / 2;
          if (h > 15) {
            throw new Error("ASN.1 length too long to represent by 8x: n = " + j.toString(16));
          }
          var g2 = 128 + h;
          return g2.toString(16) + i;
        }
      };
      this.tohex = function() {
        if (this.hTLV == null || this.isModified) {
          this.hV = this.getFreshValueHex();
          this.hL = this.getLengthHexFromValue();
          this.hTLV = this.hT + this.hL + this.hV;
          this.isModified = false;
        }
        return this.hTLV;
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      this.getValueHex = function() {
        this.tohex();
        return this.hV;
      };
      this.getFreshValueHex = function() {
        return "";
      };
      this.setByParam = function(g2) {
        this.params = g2;
      };
      if (e != void 0) {
        if (e.tlv != void 0) {
          this.hTLV = e.tlv;
          this.isModified = false;
        }
      }
    };
    KJUR.asn1.DERAbstractString = function(c2) {
      KJUR.asn1.DERAbstractString.superclass.constructor.call(this);
      var b = null;
      var a = null;
      this.getString = function() {
        return this.s;
      };
      this.setString = function(d2) {
        this.hTLV = null;
        this.isModified = true;
        this.s = d2;
        this.hV = utf8tohex(this.s).toLowerCase();
      };
      this.setStringHex = function(d2) {
        this.hTLV = null;
        this.isModified = true;
        this.s = null;
        this.hV = d2;
      };
      this.getFreshValueHex = function() {
        return this.hV;
      };
      if (typeof c2 != "undefined") {
        if (typeof c2 == "string") {
          this.setString(c2);
        } else {
          if (typeof c2.str != "undefined") {
            this.setString(c2.str);
          } else {
            if (typeof c2.hex != "undefined") {
              this.setStringHex(c2.hex);
            }
          }
        }
      }
    };
    extendClass(KJUR.asn1.DERAbstractString, KJUR.asn1.ASN1Object);
    KJUR.asn1.DERAbstractTime = function(c2) {
      KJUR.asn1.DERAbstractTime.superclass.constructor.call(this);
      var b = null;
      var a = null;
      this.localDateToUTC = function(g2) {
        var e = g2.getTime() + g2.getTimezoneOffset() * 6e4;
        var f2 = new Date(e);
        return f2;
      };
      this.formatDate = function(m2, o2, e) {
        var g2 = this.zeroPadding;
        var n = this.localDateToUTC(m2);
        var p3 = String(n.getFullYear());
        if (o2 == "utc") {
          p3 = p3.substr(2, 2);
        }
        var l2 = g2(String(n.getMonth() + 1), 2);
        var q2 = g2(String(n.getDate()), 2);
        var h = g2(String(n.getHours()), 2);
        var i = g2(String(n.getMinutes()), 2);
        var j = g2(String(n.getSeconds()), 2);
        var r = p3 + l2 + q2 + h + i + j;
        if (e === true) {
          var f2 = n.getMilliseconds();
          if (f2 != 0) {
            var k = g2(String(f2), 3);
            k = k.replace(/[0]+$/, "");
            r = r + "." + k;
          }
        }
        return r + "Z";
      };
      this.zeroPadding = function(e, d2) {
        if (e.length >= d2) {
          return e;
        }
        return new Array(d2 - e.length + 1).join("0") + e;
      };
      this.setByParam = function(d2) {
        this.hV = null;
        this.hTLV = null;
        this.params = d2;
      };
      this.getString = function() {
        return void 0;
      };
      this.setString = function(d2) {
        this.hTLV = null;
        this.isModified = true;
        if (this.params == void 0) {
          this.params = {};
        }
        this.params.str = d2;
      };
      this.setByDate = function(d2) {
        this.hTLV = null;
        this.isModified = true;
        if (this.params == void 0) {
          this.params = {};
        }
        this.params.date = d2;
      };
      this.setByDateValue = function(h, j, e, d2, f2, g2) {
        var i = new Date(Date.UTC(h, j - 1, e, d2, f2, g2, 0));
        this.setByDate(i);
      };
      this.getFreshValueHex = function() {
        return this.hV;
      };
    };
    extendClass(KJUR.asn1.DERAbstractTime, KJUR.asn1.ASN1Object);
    KJUR.asn1.DERAbstractStructured = function(b) {
      KJUR.asn1.DERAbstractString.superclass.constructor.call(this);
      var a = null;
      this.setByASN1ObjectArray = function(c2) {
        this.hTLV = null;
        this.isModified = true;
        this.asn1Array = c2;
      };
      this.appendASN1Object = function(c2) {
        this.hTLV = null;
        this.isModified = true;
        this.asn1Array.push(c2);
      };
      this.asn1Array = new Array();
      if (typeof b != "undefined") {
        if (typeof b.array != "undefined") {
          this.asn1Array = b.array;
        }
      }
    };
    extendClass(KJUR.asn1.DERAbstractStructured, KJUR.asn1.ASN1Object);
    KJUR.asn1.DERBoolean = function(a) {
      KJUR.asn1.DERBoolean.superclass.constructor.call(this);
      this.hT = "01";
      if (a == false) {
        this.hTLV = "010100";
      } else {
        this.hTLV = "0101ff";
      }
    };
    extendClass(KJUR.asn1.DERBoolean, KJUR.asn1.ASN1Object);
    KJUR.asn1.DERInteger = function(b) {
      KJUR.asn1.DERInteger.superclass.constructor.call(this);
      this.hT = "02";
      this.params = null;
      var a = twoscompl;
      this.setByBigInteger = function(c2) {
        this.isModified = true;
        this.params = { bigint: c2 };
      };
      this.setByInteger = function(c2) {
        this.isModified = true;
        this.params = c2;
      };
      this.setValueHex = function(c2) {
        this.isModified = true;
        this.params = { hex: c2 };
      };
      this.getFreshValueHex = function() {
        var d2 = this.params;
        var c2 = null;
        if (d2 == null) {
          throw new Error("value not set");
        }
        if (typeof d2 == "object" && d2.hex != void 0) {
          this.hV = d2.hex;
          return this.hV;
        }
        if (typeof d2 == "number") {
          c2 = new BigInteger(String(d2), 10);
        } else {
          if (d2["int"] != void 0) {
            c2 = new BigInteger(String(d2["int"]), 10);
          } else {
            if (d2.bigint != void 0) {
              c2 = d2.bigint;
            } else {
              throw new Error("wrong parameter");
            }
          }
        }
        this.hV = a(c2);
        return this.hV;
      };
      if (b != void 0) {
        this.params = b;
      }
    };
    extendClass(KJUR.asn1.DERInteger, KJUR.asn1.ASN1Object);
    KJUR.asn1.DERBitString = function(b) {
      if (b !== void 0 && typeof b.obj !== "undefined") {
        var a = KJUR.asn1.ASN1Util.newObject(b.obj);
        b.hex = "00" + a.tohex();
      }
      KJUR.asn1.DERBitString.superclass.constructor.call(this);
      this.hT = "03";
      this.setHexValueIncludingUnusedBits = function(c2) {
        this.hTLV = null;
        this.isModified = true;
        this.hV = c2;
      };
      this.setUnusedBitsAndHexValue = function(c2, e) {
        if (c2 < 0 || 7 < c2) {
          throw "unused bits shall be from 0 to 7: u = " + c2;
        }
        var d2 = "0" + c2;
        this.hTLV = null;
        this.isModified = true;
        this.hV = d2 + e;
      };
      this.setByBinaryString = function(e) {
        e = e.replace(/0+$/, "");
        var f2 = 8 - e.length % 8;
        if (f2 == 8) {
          f2 = 0;
        }
        e += "0000000".substr(0, f2);
        var j = "";
        for (var g2 = 0; g2 < e.length - 1; g2 += 8) {
          var d2 = e.substr(g2, 8);
          var c2 = parseInt(d2, 2).toString(16);
          if (c2.length == 1) {
            c2 = "0" + c2;
          }
          j += c2;
        }
        this.hTLV = null;
        this.isModified = true;
        this.hV = "0" + f2 + j;
      };
      this.setByBooleanArray = function(e) {
        var d2 = "";
        for (var c2 = 0; c2 < e.length; c2++) {
          if (e[c2] == true) {
            d2 += "1";
          } else {
            d2 += "0";
          }
        }
        this.setByBinaryString(d2);
      };
      this.newFalseArray = function(e) {
        var c2 = new Array(e);
        for (var d2 = 0; d2 < e; d2++) {
          c2[d2] = false;
        }
        return c2;
      };
      this.getFreshValueHex = function() {
        return this.hV;
      };
      if (typeof b != "undefined") {
        if (typeof b == "string" && b.toLowerCase().match(/^[0-9a-f]+$/)) {
          this.setHexValueIncludingUnusedBits(b);
        } else {
          if (typeof b.hex != "undefined") {
            this.setHexValueIncludingUnusedBits(b.hex);
          } else {
            if (typeof b.bin != "undefined") {
              this.setByBinaryString(b.bin);
            } else {
              if (typeof b.array != "undefined") {
                this.setByBooleanArray(b.array);
              }
            }
          }
        }
      }
    };
    extendClass(KJUR.asn1.DERBitString, KJUR.asn1.ASN1Object);
    KJUR.asn1.DEROctetString = function(b) {
      if (b !== void 0 && typeof b.obj !== "undefined") {
        var a = KJUR.asn1.ASN1Util.newObject(b.obj);
        b.hex = a.tohex();
      }
      KJUR.asn1.DEROctetString.superclass.constructor.call(this, b);
      this.hT = "04";
    };
    extendClass(KJUR.asn1.DEROctetString, KJUR.asn1.DERAbstractString);
    KJUR.asn1.DERNull = function() {
      KJUR.asn1.DERNull.superclass.constructor.call(this);
      this.hT = "05";
      this.hTLV = "0500";
    };
    extendClass(KJUR.asn1.DERNull, KJUR.asn1.ASN1Object);
    KJUR.asn1.DERObjectIdentifier = function(a) {
      KJUR.asn1.DERObjectIdentifier.superclass.constructor.call(this);
      this.hT = "06";
      this.setValueHex = function(b) {
        this.hTLV = null;
        this.isModified = true;
        this.s = null;
        this.hV = b;
      };
      this.setValueOidString = function(b) {
        var c2 = oidtohex(b);
        if (c2 == null) {
          throw new Error("malformed oid string: " + b);
        }
        this.hTLV = null;
        this.isModified = true;
        this.s = null;
        this.hV = c2;
      };
      this.setValueName = function(c2) {
        var b = KJUR.asn1.x509.OID.name2oid(c2);
        if (b !== "") {
          this.setValueOidString(b);
        } else {
          throw new Error("DERObjectIdentifier oidName undefined: " + c2);
        }
      };
      this.setValueNameOrOid = function(b) {
        if (b.match(/^[0-2].[0-9.]+$/)) {
          this.setValueOidString(b);
        } else {
          this.setValueName(b);
        }
      };
      this.getFreshValueHex = function() {
        return this.hV;
      };
      this.setByParam = function(b) {
        if (typeof b === "string") {
          this.setValueNameOrOid(b);
        } else {
          if (b.oid !== void 0) {
            this.setValueNameOrOid(b.oid);
          } else {
            if (b.name !== void 0) {
              this.setValueNameOrOid(b.name);
            } else {
              if (b.hex !== void 0) {
                this.setValueHex(b.hex);
              }
            }
          }
        }
      };
      if (a !== void 0) {
        this.setByParam(a);
      }
    };
    extendClass(KJUR.asn1.DERObjectIdentifier, KJUR.asn1.ASN1Object);
    KJUR.asn1.DEREnumerated = function(a) {
      KJUR.asn1.DEREnumerated.superclass.constructor.call(this);
      this.hT = "0a";
      this.setByBigInteger = function(b) {
        this.hTLV = null;
        this.isModified = true;
        this.hV = twoscompl(b);
      };
      this.setByInteger = function(c2) {
        var b = new BigInteger(String(c2), 10);
        this.setByBigInteger(b);
      };
      this.setValueHex = function(b) {
        this.hV = b;
      };
      this.getFreshValueHex = function() {
        return this.hV;
      };
      if (typeof a != "undefined") {
        if (typeof a["int"] != "undefined") {
          this.setByInteger(a["int"]);
        } else {
          if (typeof a == "number") {
            this.setByInteger(a);
          } else {
            if (typeof a.hex != "undefined") {
              this.setValueHex(a.hex);
            }
          }
        }
      }
    };
    extendClass(KJUR.asn1.DEREnumerated, KJUR.asn1.ASN1Object);
    KJUR.asn1.DERUTF8String = function(a) {
      KJUR.asn1.DERUTF8String.superclass.constructor.call(this, a);
      this.hT = "0c";
    };
    extendClass(KJUR.asn1.DERUTF8String, KJUR.asn1.DERAbstractString);
    KJUR.asn1.DERNumericString = function(a) {
      KJUR.asn1.DERNumericString.superclass.constructor.call(this, a);
      this.hT = "12";
    };
    extendClass(KJUR.asn1.DERNumericString, KJUR.asn1.DERAbstractString);
    KJUR.asn1.DERPrintableString = function(a) {
      KJUR.asn1.DERPrintableString.superclass.constructor.call(this, a);
      this.hT = "13";
    };
    extendClass(KJUR.asn1.DERPrintableString, KJUR.asn1.DERAbstractString);
    KJUR.asn1.DERTeletexString = function(a) {
      KJUR.asn1.DERTeletexString.superclass.constructor.call(this, a);
      this.hT = "14";
    };
    extendClass(KJUR.asn1.DERTeletexString, KJUR.asn1.DERAbstractString);
    KJUR.asn1.DERIA5String = function(a) {
      KJUR.asn1.DERIA5String.superclass.constructor.call(this, a);
      this.hT = "16";
    };
    extendClass(KJUR.asn1.DERIA5String, KJUR.asn1.DERAbstractString);
    KJUR.asn1.DERVisibleString = function(a) {
      KJUR.asn1.DERIA5String.superclass.constructor.call(this, a);
      this.hT = "1a";
    };
    extendClass(KJUR.asn1.DERVisibleString, KJUR.asn1.DERAbstractString);
    KJUR.asn1.DERBMPString = function(a) {
      KJUR.asn1.DERBMPString.superclass.constructor.call(this, a);
      this.hT = "1e";
    };
    extendClass(KJUR.asn1.DERBMPString, KJUR.asn1.DERAbstractString);
    KJUR.asn1.DERUTCTime = function(a) {
      KJUR.asn1.DERUTCTime.superclass.constructor.call(this, a);
      this.hT = "17";
      this.params = void 0;
      this.getFreshValueHex = function() {
        var d2 = this.params;
        if (this.params == void 0) {
          d2 = { date: /* @__PURE__ */ new Date() };
        }
        if (typeof d2 == "string") {
          if (d2.match(/^[0-9]{12}Z$/) || d2.match(/^[0-9]{12}\.[0-9]+Z$/)) {
            this.hV = stohex(d2);
          } else {
            throw new Error("malformed string for UTCTime: " + d2);
          }
        } else {
          if (d2.str != void 0) {
            this.hV = stohex(d2.str);
          } else {
            if (d2.date == void 0 && d2.millis == true) {
              var c2 = /* @__PURE__ */ new Date();
              this.hV = stohex(this.formatDate(c2, "utc", true));
            } else {
              if (d2.date != void 0 && d2.date instanceof Date) {
                var b = d2.millis === true;
                this.hV = stohex(this.formatDate(d2.date, "utc", b));
              } else {
                if (d2 instanceof Date) {
                  this.hV = stohex(this.formatDate(d2, "utc"));
                }
              }
            }
          }
        }
        if (this.hV == void 0) {
          throw new Error("parameter not specified properly for UTCTime");
        }
        return this.hV;
      };
      if (a != void 0) {
        this.setByParam(a);
      }
    };
    extendClass(KJUR.asn1.DERUTCTime, KJUR.asn1.DERAbstractTime);
    KJUR.asn1.DERGeneralizedTime = function(a) {
      KJUR.asn1.DERGeneralizedTime.superclass.constructor.call(this, a);
      this.hT = "18";
      this.params = a;
      this.getFreshValueHex = function() {
        var d2 = this.params;
        if (this.params == void 0) {
          d2 = { date: /* @__PURE__ */ new Date() };
        }
        if (typeof d2 == "string") {
          if (d2.match(/^[0-9]{14}Z$/) || d2.match(/^[0-9]{14}\.[0-9]+Z$/)) {
            this.hV = stohex(d2);
          } else {
            throw new Error("malformed string for GeneralizedTime: " + d2);
          }
        } else {
          if (d2.str != void 0) {
            this.hV = stohex(d2.str);
          } else {
            if (d2.date == void 0 && d2.millis == true) {
              var c2 = /* @__PURE__ */ new Date();
              this.hV = stohex(this.formatDate(c2, "gen", true));
            } else {
              if (d2.date != void 0 && d2.date instanceof Date) {
                var b = d2.millis === true;
                this.hV = stohex(this.formatDate(d2.date, "gen", b));
              } else {
                if (d2 instanceof Date) {
                  this.hV = stohex(this.formatDate(d2, "gen"));
                }
              }
            }
          }
        }
        if (this.hV == void 0) {
          throw new Error("parameter not specified properly for GeneralizedTime");
        }
        return this.hV;
      };
      if (a != void 0) {
        this.setByParam(a);
      }
    };
    extendClass(KJUR.asn1.DERGeneralizedTime, KJUR.asn1.DERAbstractTime);
    KJUR.asn1.DERSequence = function(a) {
      KJUR.asn1.DERSequence.superclass.constructor.call(this, a);
      this.hT = "30";
      this.getFreshValueHex = function() {
        var c2 = "";
        for (var b = 0; b < this.asn1Array.length; b++) {
          var d2 = this.asn1Array[b];
          c2 += d2.tohex();
        }
        this.hV = c2;
        return this.hV;
      };
    };
    extendClass(KJUR.asn1.DERSequence, KJUR.asn1.DERAbstractStructured);
    KJUR.asn1.DERSet = function(a) {
      KJUR.asn1.DERSet.superclass.constructor.call(this, a);
      this.hT = "31";
      this.sortFlag = true;
      this.getFreshValueHex = function() {
        var b = new Array();
        for (var c2 = 0; c2 < this.asn1Array.length; c2++) {
          var d2 = this.asn1Array[c2];
          b.push(d2.tohex());
        }
        if (this.sortFlag == true) {
          b.sort();
        }
        this.hV = b.join("");
        return this.hV;
      };
      if (typeof a != "undefined") {
        if (typeof a.sortflag != "undefined" && a.sortflag == false) {
          this.sortFlag = false;
        }
      }
    };
    extendClass(KJUR.asn1.DERSet, KJUR.asn1.DERAbstractStructured);
    KJUR.asn1.DERTaggedObject = function(f2) {
      KJUR.asn1.DERTaggedObject.superclass.constructor.call(this);
      var d2 = KJUR.asn1, e = ASN1HEX, a = e.getV, c2 = e.isASN1HEX, b = d2.ASN1Util.newObject;
      this.hT = "a0";
      this.hV = "";
      this.isExplicit = true;
      this.asn1Object = null;
      this.params = { tag: "a0", explicit: true };
      this.setASN1Object = function(g2, h, i) {
        this.params = { tag: h, explicit: g2, obj: i };
      };
      this.getFreshValueHex = function() {
        var h = this.params;
        if (h.explicit == void 0) {
          h.explicit = true;
        }
        if (h.tage != void 0) {
          h.tag = h.tage;
          h.explicit = true;
        }
        if (h.tagi != void 0) {
          h.tag = h.tagi;
          h.explicit = false;
        }
        if (h.str != void 0) {
          this.hV = utf8tohex(h.str);
        } else {
          if (h.hex != void 0) {
            this.hV = h.hex;
          } else {
            if (h.obj != void 0) {
              var g2;
              if (h.obj instanceof d2.ASN1Object) {
                g2 = h.obj.tohex();
              } else {
                if (typeof h.obj == "object") {
                  g2 = b(h.obj).tohex();
                }
              }
              if (h.explicit) {
                this.hV = g2;
              } else {
                this.hV = a(g2, 0);
              }
            } else {
              throw new Error("str, hex nor obj not specified");
            }
          }
        }
        if (h.tag == void 0) {
          h.tag = "a0";
        }
        this.hT = h.tag;
        this.hTLV = null;
        this.isModified = true;
        return this.hV;
      };
      this.setByParam = function(g2) {
        this.params = g2;
      };
      if (f2 !== void 0) {
        this.setByParam(f2);
      }
    };
    extendClass(KJUR.asn1.DERTaggedObject, KJUR.asn1.ASN1Object);
    var ASN1HEX = new function() {
    }();
    ASN1HEX.getLblen = function(c2, a) {
      if (c2.substr(a + 2, 1) != "8") {
        return 1;
      }
      var b = parseInt(c2.substr(a + 3, 1));
      if (b == 0) {
        return -1;
      }
      if (0 < b && b < 10) {
        return b + 1;
      }
      return -2;
    };
    ASN1HEX.getL = function(c2, b) {
      var a = ASN1HEX.getLblen(c2, b);
      if (a < 1) {
        return "";
      }
      return c2.substr(b + 2, a * 2);
    };
    ASN1HEX.getVblen = function(d2, a) {
      var c2, b;
      c2 = ASN1HEX.getL(d2, a);
      if (c2 == "") {
        return -1;
      }
      if (c2.substr(0, 1) === "8") {
        b = new BigInteger(c2.substr(2), 16);
      } else {
        b = new BigInteger(c2, 16);
      }
      return b.intValue();
    };
    ASN1HEX.getVidx = function(c2, b) {
      var a = ASN1HEX.getLblen(c2, b);
      if (a < 0) {
        return a;
      }
      return b + (a + 1) * 2;
    };
    ASN1HEX.getV = function(d2, a) {
      var c2 = ASN1HEX.getVidx(d2, a);
      var b = ASN1HEX.getVblen(d2, a);
      return d2.substr(c2, b * 2);
    };
    ASN1HEX.getTLV = function(b, a) {
      return b.substr(a, 2) + ASN1HEX.getL(b, a) + ASN1HEX.getV(b, a);
    };
    ASN1HEX.getTLVblen = function(b, a) {
      return 2 + ASN1HEX.getLblen(b, a) * 2 + ASN1HEX.getVblen(b, a) * 2;
    };
    ASN1HEX.getNextSiblingIdx = function(d2, a) {
      var c2 = ASN1HEX.getVidx(d2, a);
      var b = ASN1HEX.getVblen(d2, a);
      return c2 + b * 2;
    };
    ASN1HEX.getChildIdx = function(e, k) {
      var l2 = ASN1HEX;
      var j = [];
      var c2, f2, g2;
      c2 = l2.getVidx(e, k);
      f2 = l2.getVblen(e, k) * 2;
      if (e.substr(k, 2) == "03") {
        c2 += 2;
        f2 -= 2;
      }
      g2 = 0;
      var d2 = c2;
      while (g2 <= f2) {
        var b = l2.getTLVblen(e, d2);
        g2 += b;
        if (g2 <= f2) {
          j.push(d2);
        }
        d2 += b;
        if (g2 >= f2) {
          break;
        }
      }
      return j;
    };
    ASN1HEX.getNthChildIdx = function(d2, b, e) {
      var c2 = ASN1HEX.getChildIdx(d2, b);
      return c2[e];
    };
    ASN1HEX.getIdxbyList = function(e, d2, c2, i) {
      var g2 = ASN1HEX;
      var f2, b;
      if (c2.length == 0) {
        if (i !== void 0) {
          if (e.substr(d2, 2) !== i) {
            return -1;
          }
        }
        return d2;
      }
      f2 = c2.shift();
      b = g2.getChildIdx(e, d2);
      if (f2 >= b.length) {
        return -1;
      }
      return g2.getIdxbyList(e, b[f2], c2, i);
    };
    ASN1HEX.getIdxbyListEx = function(f2, k, b, g2) {
      var m2 = ASN1HEX;
      var d2, l2;
      if (b.length == 0) {
        if (g2 !== void 0) {
          if (f2.substr(k, 2) !== g2) {
            return -1;
          }
        }
        return k;
      }
      d2 = b.shift();
      l2 = m2.getChildIdx(f2, k);
      var j = 0;
      for (var e = 0; e < l2.length; e++) {
        var c2 = f2.substr(l2[e], 2);
        if (typeof d2 == "number" && !m2.isContextTag(c2) && j == d2 || typeof d2 == "string" && m2.isContextTag(c2, d2)) {
          return m2.getIdxbyListEx(f2, l2[e], b, g2);
        }
        if (!m2.isContextTag(c2)) {
          j++;
        }
      }
      return -1;
    };
    ASN1HEX.getTLVbyList = function(d2, c2, b, f2) {
      var e = ASN1HEX;
      var a = e.getIdxbyList(d2, c2, b, f2);
      if (a == -1) {
        return null;
      }
      if (a >= d2.length) {
        return null;
      }
      return e.getTLV(d2, a);
    };
    ASN1HEX.getTLVbyListEx = function(d2, c2, b, f2) {
      var e = ASN1HEX;
      var a = e.getIdxbyListEx(d2, c2, b, f2);
      if (a == -1) {
        return null;
      }
      return e.getTLV(d2, a);
    };
    ASN1HEX.getVbyList = function(e, c2, b, g2, i) {
      var f2 = ASN1HEX;
      var a, d2;
      a = f2.getIdxbyList(e, c2, b, g2);
      if (a == -1) {
        return null;
      }
      if (a >= e.length) {
        return null;
      }
      d2 = f2.getV(e, a);
      if (i === true) {
        d2 = d2.substr(2);
      }
      return d2;
    };
    ASN1HEX.getVbyListEx = function(b, e, a, d2, f2) {
      var j = ASN1HEX;
      var g2, c2, i;
      g2 = j.getIdxbyListEx(b, e, a, d2);
      if (g2 == -1) {
        return null;
      }
      i = j.getV(b, g2);
      if (b.substr(g2, 2) == "03" && f2 !== false) {
        i = i.substr(2);
      }
      return i;
    };
    ASN1HEX.getInt = function(e, b, f2) {
      if (f2 == void 0) {
        f2 = -1;
      }
      try {
        var c2 = e.substr(b, 2);
        if (c2 != "02" && c2 != "03") {
          return f2;
        }
        var a = ASN1HEX.getV(e, b);
        if (c2 == "02") {
          return parseInt(a, 16);
        } else {
          return bitstrtoint(a);
        }
      } catch (d2) {
        return f2;
      }
    };
    ASN1HEX.getOID = function(c2, a, d2) {
      if (d2 == void 0) {
        d2 = null;
      }
      try {
        if (c2.substr(a, 2) != "06") {
          return d2;
        }
        var e = ASN1HEX.getV(c2, a);
        return hextooid(e);
      } catch (b) {
        return d2;
      }
    };
    ASN1HEX.getOIDName = function(d2, a, f2) {
      if (f2 == void 0) {
        f2 = null;
      }
      try {
        var e = ASN1HEX.getOID(d2, a, f2);
        if (e == f2) {
          return f2;
        }
        var b = KJUR.asn1.x509.OID.oid2name(e);
        if (b == "") {
          return e;
        }
        return b;
      } catch (c2) {
        return f2;
      }
    };
    ASN1HEX.getString = function(d2, b, e) {
      if (e == void 0) {
        e = null;
      }
      try {
        var a = ASN1HEX.getV(d2, b);
        return hextorstr(a);
      } catch (c2) {
        return e;
      }
    };
    ASN1HEX.hextooidstr = function(e) {
      var h = function(b, a) {
        if (b.length >= a) {
          return b;
        }
        return new Array(a - b.length + 1).join("0") + b;
      };
      var l2 = [];
      var o2 = e.substr(0, 2);
      var f2 = parseInt(o2, 16);
      l2[0] = new String(Math.floor(f2 / 40));
      l2[1] = new String(f2 % 40);
      var m2 = e.substr(2);
      var k = [];
      for (var g2 = 0; g2 < m2.length / 2; g2++) {
        k.push(parseInt(m2.substr(g2 * 2, 2), 16));
      }
      var j = [];
      var d2 = "";
      for (var g2 = 0; g2 < k.length; g2++) {
        if (k[g2] & 128) {
          d2 = d2 + h((k[g2] & 127).toString(2), 7);
        } else {
          d2 = d2 + h((k[g2] & 127).toString(2), 7);
          j.push(new String(parseInt(d2, 2)));
          d2 = "";
        }
      }
      var n = l2.join(".");
      if (j.length > 0) {
        n = n + "." + j.join(".");
      }
      return n;
    };
    ASN1HEX.dump = function(t2, c2, l2, g2) {
      var p3 = ASN1HEX;
      var j = p3.getV;
      var y = p3.dump;
      var w = p3.getChildIdx;
      var e = t2;
      if (t2 instanceof KJUR.asn1.ASN1Object) {
        e = t2.tohex();
      }
      var q2 = function(A, i) {
        if (A.length <= i * 2) {
          return A;
        } else {
          var v = A.substr(0, i) + "..(total " + A.length / 2 + "bytes).." + A.substr(A.length - i, i);
          return v;
        }
      };
      if (c2 === void 0) {
        c2 = { ommit_long_octet: 32 };
      }
      if (l2 === void 0) {
        l2 = 0;
      }
      if (g2 === void 0) {
        g2 = "";
      }
      var x2 = c2.ommit_long_octet;
      var z2 = e.substr(l2, 2);
      if (z2 == "01") {
        var h = j(e, l2);
        if (h == "00") {
          return g2 + "BOOLEAN FALSE\n";
        } else {
          return g2 + "BOOLEAN TRUE\n";
        }
      }
      if (z2 == "02") {
        var h = j(e, l2);
        return g2 + "INTEGER " + q2(h, x2) + "\n";
      }
      if (z2 == "03") {
        var h = j(e, l2);
        if (p3.isASN1HEX(h.substr(2))) {
          var k = g2 + "BITSTRING, encapsulates\n";
          k = k + y(h.substr(2), c2, 0, g2 + "  ");
          return k;
        } else {
          return g2 + "BITSTRING " + q2(h, x2) + "\n";
        }
      }
      if (z2 == "04") {
        var h = j(e, l2);
        if (p3.isASN1HEX(h)) {
          var k = g2 + "OCTETSTRING, encapsulates\n";
          k = k + y(h, c2, 0, g2 + "  ");
          return k;
        } else {
          return g2 + "OCTETSTRING " + q2(h, x2) + "\n";
        }
      }
      if (z2 == "05") {
        return g2 + "NULL\n";
      }
      if (z2 == "06") {
        var m2 = j(e, l2);
        var b = KJUR.asn1.ASN1Util.oidHexToInt(m2);
        var o2 = KJUR.asn1.x509.OID.oid2name(b);
        var a = b.replace(/\./g, " ");
        if (o2 != "") {
          return g2 + "ObjectIdentifier " + o2 + " (" + a + ")\n";
        } else {
          return g2 + "ObjectIdentifier (" + a + ")\n";
        }
      }
      if (z2 == "0a") {
        return g2 + "ENUMERATED " + parseInt(j(e, l2)) + "\n";
      }
      if (z2 == "0c") {
        return g2 + "UTF8String '" + hextoutf8(j(e, l2)) + "'\n";
      }
      if (z2 == "13") {
        return g2 + "PrintableString '" + hextoutf8(j(e, l2)) + "'\n";
      }
      if (z2 == "14") {
        return g2 + "TeletexString '" + hextoutf8(j(e, l2)) + "'\n";
      }
      if (z2 == "16") {
        return g2 + "IA5String '" + hextoutf8(j(e, l2)) + "'\n";
      }
      if (z2 == "17") {
        return g2 + "UTCTime " + hextoutf8(j(e, l2)) + "\n";
      }
      if (z2 == "18") {
        return g2 + "GeneralizedTime " + hextoutf8(j(e, l2)) + "\n";
      }
      if (z2 == "1a") {
        return g2 + "VisualString '" + hextoutf8(j(e, l2)) + "'\n";
      }
      if (z2 == "1e") {
        return g2 + "BMPString '" + ucs2hextoutf8(j(e, l2)) + "'\n";
      }
      if (z2 == "30") {
        if (e.substr(l2, 4) == "3000") {
          return g2 + "SEQUENCE {}\n";
        }
        var k = g2 + "SEQUENCE\n";
        var d2 = w(e, l2);
        var f2 = c2;
        if ((d2.length == 2 || d2.length == 3) && e.substr(d2[0], 2) == "06" && e.substr(d2[d2.length - 1], 2) == "04") {
          var o2 = p3.oidname(j(e, d2[0]));
          var r = JSON.parse(JSON.stringify(c2));
          r.x509ExtName = o2;
          f2 = r;
        }
        for (var u2 = 0; u2 < d2.length; u2++) {
          k = k + y(e, f2, d2[u2], g2 + "  ");
        }
        return k;
      }
      if (z2 == "31") {
        var k = g2 + "SET\n";
        var d2 = w(e, l2);
        for (var u2 = 0; u2 < d2.length; u2++) {
          k = k + y(e, c2, d2[u2], g2 + "  ");
        }
        return k;
      }
      var z2 = parseInt(z2, 16);
      if ((z2 & 128) != 0) {
        var n = z2 & 31;
        if ((z2 & 32) != 0) {
          var k = g2 + "[" + n + "]\n";
          var d2 = w(e, l2);
          for (var u2 = 0; u2 < d2.length; u2++) {
            k = k + y(e, c2, d2[u2], g2 + "  ");
          }
          return k;
        } else {
          var h = j(e, l2);
          if (ASN1HEX.isASN1HEX(h)) {
            var k = g2 + "[" + n + "]\n";
            k = k + y(h, c2, 0, g2 + "  ");
            return k;
          } else {
            if (h.substr(0, 8) == "68747470") {
              h = hextoutf8(h);
            } else {
              if (c2.x509ExtName === "subjectAltName" && n == 2) {
                h = hextoutf8(h);
              }
            }
          }
          var k = g2 + "[" + n + "] " + h + "\n";
          return k;
        }
      }
      return g2 + "UNKNOWN(" + z2 + ") " + j(e, l2) + "\n";
    };
    ASN1HEX.parse = function(x2) {
      var t2 = ASN1HEX, f2 = t2.parse, a = t2.isASN1HEX, l2 = t2.getV, b = t2.getTLV, y = t2.getChildIdx, i = KJUR.asn1, e = i.ASN1Util.oidHexToInt, B = i.x509.OID.oid2name, k = hextoutf8, n = ucs2hextoutf8, q2 = iso88591hextoutf8;
      var c2 = { "0c": "utf8str", "12": "numstr", "13": "prnstr", "14": "telstr", "16": "ia5str", "17": "utctime", "18": "gentime", "1a": "visstr", "1e": "bmpstr", "30": "seq", "31": "set" };
      var u2 = function(H) {
        var D = [];
        var E = y(H, 0);
        for (var G = 0; G < E.length; G++) {
          var s = E[G];
          var d2 = b(H, s);
          var F = f2(d2);
          D.push(F);
        }
        return D;
      };
      var C = x2.substr(0, 2);
      var j = {};
      var p3 = l2(x2, 0);
      if (C == "01") {
        if (x2 == "0101ff") {
          return { bool: true };
        }
        return { bool: false };
      } else {
        if (C == "02") {
          return { "int": { hex: p3 } };
        } else {
          if (C == "03") {
            try {
              if (p3.substr(0, 2) != "00") {
                throw "not encap";
              }
              var v = p3.substr(2);
              if (!a(v)) {
                throw "not encap";
              }
              return { bitstr: { obj: f2(v) } };
            } catch (z2) {
              var m2 = null;
              if (p3.length <= 10) {
                m2 = bitstrtobinstr(p3);
              }
              if (m2 == null) {
                return { bitstr: { hex: p3 } };
              } else {
                return { bitstr: { bin: m2 } };
              }
            }
          } else {
            if (C == "04") {
              try {
                if (!a(p3)) {
                  throw "not encap";
                }
                return { octstr: { obj: f2(p3) } };
              } catch (z2) {
                return { octstr: { hex: p3 } };
              }
            } else {
              if (C == "05") {
                return { "null": "" };
              } else {
                if (C == "06") {
                  var g2 = e(p3);
                  var r = B(g2);
                  if (r == "") {
                    return { oid: g2 };
                  } else {
                    return { oid: r };
                  }
                } else {
                  if (C == "0a") {
                    if (p3.length > 4) {
                      return { "enum": { hex: p3 } };
                    } else {
                      return { "enum": parseInt(p3, 16) };
                    }
                  } else {
                    if (C == "30" || C == "31") {
                      j[c2[C]] = u2(x2);
                      return j;
                    } else {
                      if (C == "14") {
                        var o2 = q2(p3);
                        j[c2[C]] = { str: o2 };
                        return j;
                      } else {
                        if (C == "1e") {
                          var o2 = n(p3);
                          j[c2[C]] = { str: o2 };
                          return j;
                        } else {
                          if (":0c:12:13:16:17:18:1a:".indexOf(C) != -1) {
                            var o2 = k(p3);
                            j[c2[C]] = { str: o2 };
                            return j;
                          } else {
                            if (C.match(/^8[0-9]$/)) {
                              var o2 = k(p3);
                              if (o2 == null | o2 == "") {
                                return { tag: { tag: C, explicit: false, hex: p3 } };
                              } else {
                                if (o2.match(/[\x00-\x1F\x7F-\x9F]/) != null || o2.match(/[\u0000-\u001F\u0080–\u009F]/) != null) {
                                  return { tag: { tag: C, explicit: false, hex: p3 } };
                                } else {
                                  return { tag: { tag: C, explicit: false, str: o2 } };
                                }
                              }
                            } else {
                              if (C.match(/^a[0-9]$/)) {
                                try {
                                  if (!a(p3)) {
                                    throw new Error("not encap");
                                  }
                                  return { tag: { tag: C, explicit: true, obj: f2(p3) } };
                                } catch (z2) {
                                  return { tag: { tag: C, explicit: true, hex: p3 } };
                                }
                              } else {
                                var A = new KJUR.asn1.ASN1Object();
                                A.hV = p3;
                                var w = A.getLengthHexFromValue();
                                return { asn1: { tlv: C + w + p3 } };
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    };
    ASN1HEX.isContextTag = function(c2, b) {
      c2 = c2.toLowerCase();
      var f2, e;
      try {
        f2 = parseInt(c2, 16);
      } catch (d2) {
        return -1;
      }
      if (b === void 0) {
        if ((f2 & 192) == 128) {
          return true;
        } else {
          return false;
        }
      }
      try {
        var a = b.match(/^\[[0-9]+\]$/);
        if (a == null) {
          return false;
        }
        e = parseInt(b.substr(1, b.length - 1), 10);
        if (e > 31) {
          return false;
        }
        if ((f2 & 192) == 128 && (f2 & 31) == e) {
          return true;
        }
        return false;
      } catch (d2) {
        return false;
      }
    };
    ASN1HEX.isASN1HEX = function(e) {
      var d2 = ASN1HEX;
      if (e.length % 2 == 1) {
        return false;
      }
      var c2 = d2.getVblen(e, 0);
      var b = e.substr(0, 2);
      var f2 = d2.getL(e, 0);
      var a = e.length - b.length - f2.length;
      if (a == c2 * 2) {
        return true;
      }
      return false;
    };
    ASN1HEX.checkStrictDER = function(g2, o2, d2, c2, r) {
      var s = ASN1HEX;
      if (d2 === void 0) {
        if (typeof g2 != "string") {
          throw new Error("not hex string");
        }
        g2 = g2.toLowerCase();
        if (!KJUR.lang.String.isHex(g2)) {
          throw new Error("not hex string");
        }
        d2 = g2.length;
        c2 = g2.length / 2;
        if (c2 < 128) {
          r = 1;
        } else {
          r = Math.ceil(c2.toString(16)) + 1;
        }
      }
      var k = s.getL(g2, o2);
      if (k.length > r * 2) {
        throw new Error("L of TLV too long: idx=" + o2);
      }
      var n = s.getVblen(g2, o2);
      if (n > c2) {
        throw new Error("value of L too long than hex: idx=" + o2);
      }
      var q2 = s.getTLV(g2, o2);
      var f2 = q2.length - 2 - s.getL(g2, o2).length;
      if (f2 !== n * 2) {
        throw new Error("V string length and L's value not the same:" + f2 + "/" + n * 2);
      }
      if (o2 === 0) {
        if (g2.length != q2.length) {
          throw new Error("total length and TLV length unmatch:" + g2.length + "!=" + q2.length);
        }
      }
      var b = g2.substr(o2, 2);
      if (b === "02") {
        var a = s.getVidx(g2, o2);
        if (g2.substr(a, 2) == "00" && g2.charCodeAt(a + 2) < 56) {
          throw new Error("not least zeros for DER INTEGER");
        }
      }
      if (parseInt(b, 16) & 32) {
        var p3 = s.getVblen(g2, o2);
        var m2 = 0;
        var l2 = s.getChildIdx(g2, o2);
        for (var e = 0; e < l2.length; e++) {
          var j = s.getTLV(g2, l2[e]);
          m2 += j.length;
          s.checkStrictDER(g2, l2[e], d2, c2, r);
        }
        if (p3 * 2 != m2) {
          throw new Error("sum of children's TLV length and L unmatch: " + p3 * 2 + "!=" + m2);
        }
      }
    };
    ASN1HEX.oidname = function(a) {
      var c2 = KJUR.asn1;
      if (KJUR.lang.String.isHex(a)) {
        a = c2.ASN1Util.oidHexToInt(a);
      }
      var b = c2.x509.OID.oid2name(a);
      if (b === "") {
        b = a;
      }
      return b;
    };
    if (typeof KJUR == "undefined" || !KJUR) {
      KJUR = {};
    }
    if (typeof KJUR.asn1 == "undefined" || !KJUR.asn1) {
      KJUR.asn1 = {};
    }
    if (typeof KJUR.asn1.x509 == "undefined" || !KJUR.asn1.x509) {
      KJUR.asn1.x509 = {};
    }
    KJUR.asn1.x509.Certificate = function(h) {
      KJUR.asn1.x509.Certificate.superclass.constructor.call(this);
      var d2 = KJUR, c2 = d2.asn1, f2 = c2.DERBitString, b = c2.DERSequence, g2 = c2.x509, a = g2.TBSCertificate, e = g2.AlgorithmIdentifier;
      this.params = void 0;
      this.setByParam = function(i) {
        this.params = i;
      };
      this.sign = function() {
        var l2 = this.params;
        var k = l2.sigalg;
        if (l2.sigalg.name != void 0) {
          k = l2.sigalg.name;
        }
        var i = l2.tbsobj.tohex();
        var j = new KJUR.crypto.Signature({ alg: k });
        j.init(l2.cakey);
        j.updateHex(i);
        l2.sighex = j.sign();
      };
      this.getPEM = function() {
        return hextopem(this.tohex(), "CERTIFICATE");
      };
      this.tohex = function() {
        var k = this.params;
        if (k.tbsobj == void 0 || k.tbsobj == null) {
          k.tbsobj = new a(k);
        }
        if (k.sighex == void 0 && k.cakey != void 0) {
          this.sign();
        }
        if (k.sighex == void 0) {
          throw new Error("sighex or cakey parameter not defined");
        }
        var i = [];
        i.push(k.tbsobj);
        i.push(new e({ name: k.sigalg }));
        i.push(new f2({ hex: "00" + k.sighex }));
        var j = new b({ array: i });
        return j.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (h != void 0) {
        this.params = h;
      }
    };
    extendClass(KJUR.asn1.x509.Certificate, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.TBSCertificate = function(f2) {
      KJUR.asn1.x509.TBSCertificate.superclass.constructor.call(this);
      var b = KJUR, i = b.asn1, d2 = i.x509, c2 = i.DERTaggedObject, h = i.DERInteger, g2 = i.DERSequence, l2 = d2.AlgorithmIdentifier, e = d2.Time, a = d2.X500Name, j = d2.Extensions, k = d2.SubjectPublicKeyInfo;
      this.params = null;
      this.setByParam = function(m2) {
        this.params = m2;
      };
      this.tohex = function() {
        var n = [];
        var q2 = this.params;
        if (q2.version != void 0 || q2.version != 1) {
          var m2 = 2;
          if (q2.version != void 0) {
            m2 = q2.version - 1;
          }
          var p3 = new c2({ obj: new h({ "int": m2 }) });
          n.push(p3);
        }
        n.push(new h(q2.serial));
        n.push(new l2({ name: q2.sigalg }));
        n.push(new a(q2.issuer));
        n.push(new g2({ array: [new e(q2.notbefore), new e(q2.notafter)] }));
        n.push(new a(q2.subject));
        n.push(new k(KEYUTIL.getKey(q2.sbjpubkey)));
        if (q2.ext !== void 0 && q2.ext.length > 0) {
          n.push(new c2({ tag: "a3", obj: new j(q2.ext) }));
        }
        var o2 = new KJUR.asn1.DERSequence({ array: n });
        return o2.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (f2 !== void 0) {
        this.setByParam(f2);
      }
    };
    extendClass(KJUR.asn1.x509.TBSCertificate, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.Extensions = function(d2) {
      KJUR.asn1.x509.Extensions.superclass.constructor.call(this);
      var c2 = KJUR, b = c2.asn1, a = b.DERSequence, e = b.x509;
      this.aParam = [];
      this.setByParam = function(f2) {
        this.aParam = f2;
      };
      this.tohex = function() {
        var f2 = [];
        for (var h = 0; h < this.aParam.length; h++) {
          var l2 = this.aParam[h];
          var k = l2.extname;
          var j = null;
          if (l2.extn != void 0) {
            j = new e.PrivateExtension(l2);
          } else {
            if (k == "subjectKeyIdentifier") {
              j = new e.SubjectKeyIdentifier(l2);
            } else {
              if (k == "keyUsage") {
                j = new e.KeyUsage(l2);
              } else {
                if (k == "subjectAltName") {
                  j = new e.SubjectAltName(l2);
                } else {
                  if (k == "issuerAltName") {
                    j = new e.IssuerAltName(l2);
                  } else {
                    if (k == "basicConstraints") {
                      j = new e.BasicConstraints(l2);
                    } else {
                      if (k == "nameConstraints") {
                        j = new e.NameConstraints(l2);
                      } else {
                        if (k == "cRLDistributionPoints") {
                          j = new e.CRLDistributionPoints(l2);
                        } else {
                          if (k == "certificatePolicies") {
                            j = new e.CertificatePolicies(l2);
                          } else {
                            if (k == "policyMappings") {
                              j = new e.PolicyMappings(l2);
                            } else {
                              if (k == "policyConstraints") {
                                j = new e.PolicyConstraints(l2);
                              } else {
                                if (k == "inhibitAnyPolicy") {
                                  j = new e.InhibitAnyPolicy(l2);
                                } else {
                                  if (k == "authorityKeyIdentifier") {
                                    j = new e.AuthorityKeyIdentifier(l2);
                                  } else {
                                    if (k == "extKeyUsage") {
                                      j = new e.ExtKeyUsage(l2);
                                    } else {
                                      if (k == "authorityInfoAccess") {
                                        j = new e.AuthorityInfoAccess(l2);
                                      } else {
                                        if (k == "cRLNumber") {
                                          j = new e.CRLNumber(l2);
                                        } else {
                                          if (k == "cRLReason") {
                                            j = new e.CRLReason(l2);
                                          } else {
                                            if (k == "ocspNonce") {
                                              j = new e.OCSPNonce(l2);
                                            } else {
                                              if (k == "ocspNoCheck") {
                                                j = new e.OCSPNoCheck(l2);
                                              } else {
                                                if (k == "adobeTimeStamp") {
                                                  j = new e.AdobeTimeStamp(l2);
                                                } else {
                                                  if (k == "subjectDirectoryAttributes") {
                                                    j = new e.SubjectDirectoryAttributes(l2);
                                                  } else {
                                                    throw new Error("extension not supported:" + JSON.stringify(l2));
                                                  }
                                                }
                                              }
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
          if (j != null) {
            f2.push(j);
          }
        }
        var g2 = new a({ array: f2 });
        return g2.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (d2 != void 0) {
        this.setByParam(d2);
      }
    };
    extendClass(KJUR.asn1.x509.Extensions, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.Extension = function(d2) {
      KJUR.asn1.x509.Extension.superclass.constructor.call(this);
      var f2 = null, a = KJUR, e = a.asn1, h = e.DERObjectIdentifier, i = e.DEROctetString, b = e.DERBitString, g2 = e.DERBoolean, c2 = e.DERSequence;
      this.tohex = function() {
        var m2 = new h({ oid: this.oid });
        var l2 = new i({ hex: this.getExtnValueHex() });
        var k = new Array();
        k.push(m2);
        if (this.critical) {
          k.push(new g2());
        }
        k.push(l2);
        var j = new c2({ array: k });
        return j.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      this.critical = false;
      if (d2 !== void 0) {
        if (d2.critical !== void 0) {
          this.critical = d2.critical;
        }
      }
    };
    extendClass(KJUR.asn1.x509.Extension, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.KeyUsage = function(c2) {
      KJUR.asn1.x509.KeyUsage.superclass.constructor.call(this, c2);
      var b = Error;
      var a = { digitalSignature: 0, nonRepudiation: 1, keyEncipherment: 2, dataEncipherment: 3, keyAgreement: 4, keyCertSign: 5, cRLSign: 6, encipherOnly: 7, decipherOnly: 8 };
      this.getExtnValueHex = function() {
        var d2 = this.getBinValue();
        this.asn1ExtnValue = new KJUR.asn1.DERBitString({ bin: d2 });
        return this.asn1ExtnValue.tohex();
      };
      this.getBinValue = function() {
        var d2 = this.params;
        if (typeof d2 != "object" || typeof d2.names != "object" && typeof d2.bin != "string") {
          throw new b("parameter not yet set");
        }
        if (d2.names != void 0) {
          return namearraytobinstr(d2.names, a);
        } else {
          if (d2.bin != void 0) {
            return d2.bin;
          } else {
            throw new b("parameter not set properly");
          }
        }
      };
      this.oid = "2.5.29.15";
      if (c2 !== void 0) {
        this.params = c2;
      }
    };
    extendClass(KJUR.asn1.x509.KeyUsage, KJUR.asn1.x509.Extension);
    KJUR.asn1.x509.BasicConstraints = function(g2) {
      KJUR.asn1.x509.BasicConstraints.superclass.constructor.call(this, g2);
      var c2 = KJUR.asn1, e = c2.DERBoolean, f2 = c2.DERInteger, b = c2.DERSequence;
      var a = false;
      var d2 = -1;
      this.getExtnValueHex = function() {
        var i = new Array();
        if (this.cA) {
          i.push(new e());
        }
        if (this.pathLen > -1) {
          i.push(new f2({ "int": this.pathLen }));
        }
        var h = new b({ array: i });
        this.asn1ExtnValue = h;
        return this.asn1ExtnValue.tohex();
      };
      this.oid = "2.5.29.19";
      this.cA = false;
      this.pathLen = -1;
      if (g2 !== void 0) {
        if (g2.cA !== void 0) {
          this.cA = g2.cA;
        }
        if (g2.pathLen !== void 0) {
          this.pathLen = g2.pathLen;
        }
      }
    };
    extendClass(KJUR.asn1.x509.BasicConstraints, KJUR.asn1.x509.Extension);
    KJUR.asn1.x509.CRLDistributionPoints = function(d2) {
      KJUR.asn1.x509.CRLDistributionPoints.superclass.constructor.call(this, d2);
      var b = KJUR, a = b.asn1, c2 = a.x509;
      this.getExtnValueHex = function() {
        return this.asn1ExtnValue.tohex();
      };
      this.setByDPArray = function(e) {
        var f2 = [];
        for (var g2 = 0; g2 < e.length; g2++) {
          if (e[g2] instanceof KJUR.asn1.ASN1Object) {
            f2.push(e[g2]);
          } else {
            var h = new c2.DistributionPoint(e[g2]);
            f2.push(h);
          }
        }
        this.asn1ExtnValue = new a.DERSequence({ array: f2 });
      };
      this.setByOneURI = function(f2) {
        var e = new c2.DistributionPoint({ fulluri: f2 });
        this.setByDPArray([e]);
      };
      this.oid = "2.5.29.31";
      if (d2 !== void 0) {
        if (d2.array !== void 0) {
          this.setByDPArray(d2.array);
        } else {
          if (d2.uri !== void 0) {
            this.setByOneURI(d2.uri);
          }
        }
      }
    };
    extendClass(KJUR.asn1.x509.CRLDistributionPoints, KJUR.asn1.x509.Extension);
    KJUR.asn1.x509.DistributionPoint = function(e) {
      KJUR.asn1.x509.DistributionPoint.superclass.constructor.call(this);
      var a = null, c2 = KJUR, b = c2.asn1, d2 = b.x509.DistributionPointName;
      this.tohex = function() {
        var f2 = new b.DERSequence();
        if (this.asn1DP != null) {
          var g2 = new b.DERTaggedObject({ explicit: true, tag: "a0", obj: this.asn1DP });
          f2.appendASN1Object(g2);
        }
        this.hTLV = f2.tohex();
        return this.hTLV;
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (e !== void 0) {
        if (e.dpobj !== void 0) {
          this.asn1DP = e.dpobj;
        } else {
          if (e.dpname !== void 0) {
            this.asn1DP = new d2(e.dpname);
          } else {
            if (e.fulluri !== void 0) {
              this.asn1DP = new d2({ full: [{ uri: e.fulluri }] });
            }
          }
        }
      }
    };
    extendClass(KJUR.asn1.x509.DistributionPoint, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.DistributionPointName = function(h) {
      KJUR.asn1.x509.DistributionPointName.superclass.constructor.call(this);
      var g2 = null, d2 = null, a = null, f2 = null, c2 = KJUR, b = c2.asn1, e = b.DERTaggedObject;
      this.tohex = function() {
        if (this.type != "full") {
          throw new Error("currently type shall be 'full': " + this.type);
        }
        this.asn1Obj = new e({ explicit: false, tag: this.tag, obj: this.asn1V });
        this.hTLV = this.asn1Obj.tohex();
        return this.hTLV;
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (h !== void 0) {
        if (b.x509.GeneralNames.prototype.isPrototypeOf(h)) {
          this.type = "full";
          this.tag = "a0";
          this.asn1V = h;
        } else {
          if (h.full !== void 0) {
            this.type = "full";
            this.tag = "a0";
            this.asn1V = new b.x509.GeneralNames(h.full);
          } else {
            throw new Error("This class supports GeneralNames only as argument");
          }
        }
      }
    };
    extendClass(KJUR.asn1.x509.DistributionPointName, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.CertificatePolicies = function(f2) {
      KJUR.asn1.x509.CertificatePolicies.superclass.constructor.call(this, f2);
      var c2 = KJUR, b = c2.asn1, e = b.x509, a = b.DERSequence, d2 = e.PolicyInformation;
      this.params = null;
      this.getExtnValueHex = function() {
        var j = [];
        for (var h = 0; h < this.params.array.length; h++) {
          j.push(new d2(this.params.array[h]));
        }
        var g2 = new a({ array: j });
        this.asn1ExtnValue = g2;
        return this.asn1ExtnValue.tohex();
      };
      this.oid = "2.5.29.32";
      if (f2 !== void 0) {
        this.params = f2;
      }
    };
    extendClass(KJUR.asn1.x509.CertificatePolicies, KJUR.asn1.x509.Extension);
    KJUR.asn1.x509.PolicyInformation = function(d2) {
      KJUR.asn1.x509.PolicyInformation.superclass.constructor.call(this, d2);
      var c2 = KJUR.asn1, b = c2.DERSequence, e = c2.DERObjectIdentifier, a = c2.x509.PolicyQualifierInfo;
      this.params = null;
      this.tohex = function() {
        if (this.params.policyoid === void 0 && this.params.array === void 0) {
          throw new Error("parameter oid and array missing");
        }
        var f2 = [new e(this.params.policyoid)];
        if (this.params.array !== void 0) {
          var j = [];
          for (var h = 0; h < this.params.array.length; h++) {
            j.push(new a(this.params.array[h]));
          }
          if (j.length > 0) {
            f2.push(new b({ array: j }));
          }
        }
        var g2 = new b({ array: f2 });
        return g2.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (d2 !== void 0) {
        this.params = d2;
      }
    };
    extendClass(KJUR.asn1.x509.PolicyInformation, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.PolicyQualifierInfo = function(e) {
      KJUR.asn1.x509.PolicyQualifierInfo.superclass.constructor.call(this, e);
      var c2 = KJUR.asn1, b = c2.DERSequence, d2 = c2.DERIA5String, f2 = c2.DERObjectIdentifier, a = c2.x509.UserNotice;
      this.params = null;
      this.tohex = function() {
        if (this.params.cps !== void 0) {
          var g2 = new b({ array: [new f2({ oid: "1.3.6.1.5.5.7.2.1" }), new d2({ str: this.params.cps })] });
          return g2.tohex();
        }
        if (this.params.unotice != void 0) {
          var g2 = new b({ array: [new f2({ oid: "1.3.6.1.5.5.7.2.2" }), new a(this.params.unotice)] });
          return g2.tohex();
        }
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (e !== void 0) {
        this.params = e;
      }
    };
    extendClass(KJUR.asn1.x509.PolicyQualifierInfo, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.UserNotice = function(e) {
      KJUR.asn1.x509.UserNotice.superclass.constructor.call(this, e);
      var a = KJUR.asn1.DERSequence, d2 = KJUR.asn1.DERInteger, c2 = KJUR.asn1.x509.DisplayText, b = KJUR.asn1.x509.NoticeReference;
      this.params = null;
      this.tohex = function() {
        var f2 = [];
        if (this.params.noticeref !== void 0) {
          f2.push(new b(this.params.noticeref));
        }
        if (this.params.exptext !== void 0) {
          f2.push(new c2(this.params.exptext));
        }
        var g2 = new a({ array: f2 });
        return g2.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (e !== void 0) {
        this.params = e;
      }
    };
    extendClass(KJUR.asn1.x509.UserNotice, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.NoticeReference = function(d2) {
      KJUR.asn1.x509.NoticeReference.superclass.constructor.call(this, d2);
      var a = KJUR.asn1.DERSequence, c2 = KJUR.asn1.DERInteger, b = KJUR.asn1.x509.DisplayText;
      this.params = null;
      this.tohex = function() {
        var f2 = [];
        if (this.params.org !== void 0) {
          f2.push(new b(this.params.org));
        }
        if (this.params.noticenum !== void 0) {
          var h = [];
          var e = this.params.noticenum;
          for (var j = 0; j < e.length; j++) {
            h.push(new c2(e[j]));
          }
          f2.push(new a({ array: h }));
        }
        if (f2.length == 0) {
          throw new Error("parameter is empty");
        }
        var g2 = new a({ array: f2 });
        return g2.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (d2 !== void 0) {
        this.params = d2;
      }
    };
    extendClass(KJUR.asn1.x509.NoticeReference, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.DisplayText = function(a) {
      KJUR.asn1.x509.DisplayText.superclass.constructor.call(this, a);
      this.hT = "0c";
      if (a !== void 0) {
        if (a.type === "ia5") {
          this.hT = "16";
        } else {
          if (a.type === "vis") {
            this.hT = "1a";
          } else {
            if (a.type === "bmp") {
              this.hT = "1e";
            }
          }
        }
      }
    };
    extendClass(KJUR.asn1.x509.DisplayText, KJUR.asn1.DERAbstractString);
    KJUR.asn1.x509.PolicyMappings = function(e) {
      KJUR.asn1.x509.PolicyMappings.superclass.constructor.call(this, e);
      var c2 = KJUR, b = c2.asn1, d2 = b.x509, a = b.ASN1Util.newObject;
      this.params = null;
      this.getExtnValueHex = function() {
        var j = this.params;
        var f2 = [];
        for (var g2 = 0; g2 < j.array.length; g2++) {
          var h = j.array[g2];
          f2.push({ seq: [{ oid: h[0] }, { oid: h[1] }] });
        }
        this.asn1ExtnValue = a({ seq: f2 });
        return this.asn1ExtnValue.tohex();
      };
      this.oid = "2.5.29.33";
      if (e !== void 0) {
        this.params = e;
      }
    };
    extendClass(KJUR.asn1.x509.PolicyMappings, KJUR.asn1.x509.Extension);
    KJUR.asn1.x509.PolicyConstraints = function(e) {
      KJUR.asn1.x509.PolicyConstraints.superclass.constructor.call(this, e);
      var c2 = KJUR, b = c2.asn1, d2 = b.x509, a = b.ASN1Util.newObject;
      this.params = null;
      this.getExtnValueHex = function() {
        var g2 = this.params;
        var f2 = [];
        if (g2.reqexp != void 0) {
          f2.push({ tag: { tagi: "80", obj: { "int": g2.reqexp } } });
        }
        if (g2.inhibit != void 0) {
          f2.push({ tag: { tagi: "81", obj: { "int": g2.inhibit } } });
        }
        this.asn1ExtnValue = a({ seq: f2 });
        return this.asn1ExtnValue.tohex();
      };
      this.oid = "2.5.29.36";
      if (e !== void 0) {
        this.params = e;
      }
    };
    extendClass(KJUR.asn1.x509.PolicyConstraints, KJUR.asn1.x509.Extension);
    KJUR.asn1.x509.InhibitAnyPolicy = function(e) {
      KJUR.asn1.x509.InhibitAnyPolicy.superclass.constructor.call(this, e);
      var c2 = KJUR, b = c2.asn1, d2 = b.x509, a = b.ASN1Util.newObject;
      this.params = null;
      this.getExtnValueHex = function() {
        this.asn1ExtnValue = a({ "int": this.params.skip });
        return this.asn1ExtnValue.tohex();
      };
      this.oid = "2.5.29.54";
      if (e !== void 0) {
        this.params = e;
      }
    };
    extendClass(KJUR.asn1.x509.InhibitAnyPolicy, KJUR.asn1.x509.Extension);
    KJUR.asn1.x509.NameConstraints = function(f2) {
      KJUR.asn1.x509.NameConstraints.superclass.constructor.call(this, f2);
      var c2 = KJUR, b = c2.asn1, e = b.x509, a = b.ASN1Util.newObject, d2 = e.GeneralSubtree;
      this.params = null;
      this.getExtnValueHex = function() {
        var l2 = this.params;
        var g2 = [];
        if (l2.permit != void 0 && l2.permit.length != void 0) {
          var k = [];
          for (var h = 0; h < l2.permit.length; h++) {
            k.push(new d2(l2.permit[h]));
          }
          g2.push({ tag: { tagi: "a0", obj: { seq: k } } });
        }
        if (l2.exclude != void 0 && l2.exclude.length != void 0) {
          var j = [];
          for (var h = 0; h < l2.exclude.length; h++) {
            j.push(new d2(l2.exclude[h]));
          }
          g2.push({ tag: { tagi: "a1", obj: { seq: j } } });
        }
        this.asn1ExtnValue = a({ seq: g2 });
        return this.asn1ExtnValue.tohex();
      };
      this.oid = "2.5.29.30";
      if (f2 !== void 0) {
        this.params = f2;
      }
    };
    extendClass(KJUR.asn1.x509.NameConstraints, KJUR.asn1.x509.Extension);
    KJUR.asn1.x509.GeneralSubtree = function(e) {
      KJUR.asn1.x509.GeneralSubtree.superclass.constructor.call(this);
      var b = KJUR.asn1, d2 = b.x509, c2 = d2.GeneralName, a = b.ASN1Util.newObject;
      this.params = null;
      this.setByParam = function(f2) {
        this.params = f2;
      };
      this.tohex = function() {
        var h = this.params;
        var f2 = [new c2(h)];
        if (h.min != void 0) {
          f2.push({ tag: { tagi: "80", obj: { "int": h.min } } });
        }
        if (h.max != void 0) {
          f2.push({ tag: { tagi: "81", obj: { "int": h.max } } });
        }
        var g2 = a({ seq: f2 });
        return g2.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (e !== void 0) {
        this.setByParam(e);
      }
    };
    extendClass(KJUR.asn1.x509.GeneralSubtree, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.ExtKeyUsage = function(c2) {
      KJUR.asn1.x509.ExtKeyUsage.superclass.constructor.call(this, c2);
      var b = KJUR, a = b.asn1;
      this.setPurposeArray = function(d2) {
        this.asn1ExtnValue = new a.DERSequence();
        for (var e = 0; e < d2.length; e++) {
          var f2 = new a.DERObjectIdentifier(d2[e]);
          this.asn1ExtnValue.appendASN1Object(f2);
        }
      };
      this.getExtnValueHex = function() {
        return this.asn1ExtnValue.tohex();
      };
      this.oid = "2.5.29.37";
      if (c2 !== void 0) {
        if (c2.array !== void 0) {
          this.setPurposeArray(c2.array);
        }
      }
    };
    extendClass(KJUR.asn1.x509.ExtKeyUsage, KJUR.asn1.x509.Extension);
    KJUR.asn1.x509.AuthorityKeyIdentifier = function(f2) {
      KJUR.asn1.x509.AuthorityKeyIdentifier.superclass.constructor.call(this, f2);
      var b = KJUR, a = b.asn1, d2 = a.DERTaggedObject, e = a.x509.GeneralNames, c2 = b.crypto.Util.isKey;
      this.asn1KID = null;
      this.asn1CertIssuer = null;
      this.asn1CertSN = null;
      this.getExtnValueHex = function() {
        var h = new Array();
        if (this.asn1KID) {
          h.push(new d2({ explicit: false, tag: "80", obj: this.asn1KID }));
        }
        if (this.asn1CertIssuer) {
          h.push(new d2({ explicit: false, tag: "a1", obj: new e([{ dn: this.asn1CertIssuer }]) }));
        }
        if (this.asn1CertSN) {
          h.push(new d2({ explicit: false, tag: "82", obj: this.asn1CertSN }));
        }
        var g2 = new a.DERSequence({ array: h });
        this.asn1ExtnValue = g2;
        return this.asn1ExtnValue.tohex();
      };
      this.setKIDByParam = function(i) {
        if (i.str !== void 0 || i.hex !== void 0) {
          this.asn1KID = new KJUR.asn1.DEROctetString(i);
        } else {
          if (typeof i === "object" && KJUR.crypto.Util.isKey(i) || typeof i === "string" && i.indexOf("BEGIN ") != -1) {
            var h = i;
            if (typeof i === "string") {
              h = KEYUTIL.getKey(i);
            }
            var g2 = KEYUTIL.getKeyID(h);
            this.asn1KID = new KJUR.asn1.DEROctetString({ hex: g2 });
          }
        }
      };
      this.setCertIssuerByParam = function(g2) {
        if (g2.str !== void 0 || g2.ldapstr !== void 0 || g2.hex !== void 0 || g2.certsubject !== void 0 || g2.certissuer !== void 0) {
          this.asn1CertIssuer = new KJUR.asn1.x509.X500Name(g2);
        } else {
          if (typeof g2 === "string" && g2.indexOf("BEGIN ") != -1 && g2.indexOf("CERTIFICATE") != -1) {
            this.asn1CertIssuer = new KJUR.asn1.x509.X500Name({ certissuer: g2 });
          }
        }
      };
      this.setCertSNByParam = function(i) {
        if (i.str !== void 0 || i.bigint !== void 0 || i.hex !== void 0) {
          this.asn1CertSN = new KJUR.asn1.DERInteger(i);
        } else {
          if (typeof i === "string" && i.indexOf("BEGIN ") != -1 && i.indexOf("CERTIFICATE")) {
            var g2 = new X509();
            g2.readCertPEM(i);
            var h = g2.getSerialNumberHex();
            this.asn1CertSN = new KJUR.asn1.DERInteger({ hex: h });
          }
        }
      };
      this.oid = "2.5.29.35";
      if (f2 !== void 0) {
        if (f2.kid !== void 0) {
          this.setKIDByParam(f2.kid);
        }
        if (f2.issuer !== void 0) {
          this.setCertIssuerByParam(f2.issuer);
        }
        if (f2.sn !== void 0) {
          this.setCertSNByParam(f2.sn);
        }
        if (f2.issuersn !== void 0 && typeof f2.issuersn === "string" && f2.issuersn.indexOf("BEGIN ") != -1 && f2.issuersn.indexOf("CERTIFICATE")) {
          this.setCertSNByParam(f2.issuersn);
          this.setCertIssuerByParam(f2.issuersn);
        }
      }
    };
    extendClass(KJUR.asn1.x509.AuthorityKeyIdentifier, KJUR.asn1.x509.Extension);
    KJUR.asn1.x509.SubjectKeyIdentifier = function(d2) {
      KJUR.asn1.x509.SubjectKeyIdentifier.superclass.constructor.call(this, d2);
      var b = KJUR, a = b.asn1, c2 = a.DEROctetString;
      this.asn1KID = null;
      this.getExtnValueHex = function() {
        this.asn1ExtnValue = this.asn1KID;
        return this.asn1ExtnValue.tohex();
      };
      this.setKIDByParam = function(g2) {
        if (g2.str !== void 0 || g2.hex !== void 0) {
          this.asn1KID = new c2(g2);
        } else {
          if (typeof g2 === "object" && KJUR.crypto.Util.isKey(g2) || typeof g2 === "string" && g2.indexOf("BEGIN") != -1) {
            var f2 = g2;
            if (typeof g2 === "string") {
              f2 = KEYUTIL.getKey(g2);
            }
            var e = KEYUTIL.getKeyID(f2);
            this.asn1KID = new KJUR.asn1.DEROctetString({ hex: e });
          }
        }
      };
      this.oid = "2.5.29.14";
      if (d2 !== void 0) {
        if (d2.kid !== void 0) {
          this.setKIDByParam(d2.kid);
        }
      }
    };
    extendClass(KJUR.asn1.x509.SubjectKeyIdentifier, KJUR.asn1.x509.Extension);
    KJUR.asn1.x509.AuthorityInfoAccess = function(a) {
      KJUR.asn1.x509.AuthorityInfoAccess.superclass.constructor.call(this, a);
      this.setAccessDescriptionArray = function(k) {
        var d2 = new Array(), b = KJUR, g2 = b.asn1, c2 = g2.DERSequence, j = g2.DERObjectIdentifier, l2 = g2.x509.GeneralName;
        for (var f2 = 0; f2 < k.length; f2++) {
          var e;
          var h = k[f2];
          if (h.ocsp !== void 0) {
            e = new c2({ array: [new j({ oid: "1.3.6.1.5.5.7.48.1" }), new l2({ uri: h.ocsp })] });
          } else {
            if (h.caissuer !== void 0) {
              e = new c2({ array: [new j({ oid: "1.3.6.1.5.5.7.48.2" }), new l2({ uri: h.caissuer })] });
            } else {
              throw new Error("unknown AccessMethod parameter: " + JSON.stringify(h));
            }
          }
          d2.push(e);
        }
        this.asn1ExtnValue = new c2({ array: d2 });
      };
      this.getExtnValueHex = function() {
        return this.asn1ExtnValue.tohex();
      };
      this.oid = "1.3.6.1.5.5.7.1.1";
      if (a !== void 0) {
        if (a.array !== void 0) {
          this.setAccessDescriptionArray(a.array);
        }
      }
    };
    extendClass(KJUR.asn1.x509.AuthorityInfoAccess, KJUR.asn1.x509.Extension);
    KJUR.asn1.x509.SubjectAltName = function(a) {
      KJUR.asn1.x509.SubjectAltName.superclass.constructor.call(this, a);
      this.setNameArray = function(b) {
        this.asn1ExtnValue = new KJUR.asn1.x509.GeneralNames(b);
      };
      this.getExtnValueHex = function() {
        return this.asn1ExtnValue.tohex();
      };
      this.oid = "2.5.29.17";
      if (a !== void 0) {
        if (a.array !== void 0) {
          this.setNameArray(a.array);
        }
      }
    };
    extendClass(KJUR.asn1.x509.SubjectAltName, KJUR.asn1.x509.Extension);
    KJUR.asn1.x509.IssuerAltName = function(a) {
      KJUR.asn1.x509.IssuerAltName.superclass.constructor.call(this, a);
      this.setNameArray = function(b) {
        this.asn1ExtnValue = new KJUR.asn1.x509.GeneralNames(b);
      };
      this.getExtnValueHex = function() {
        return this.asn1ExtnValue.tohex();
      };
      this.oid = "2.5.29.18";
      if (a !== void 0) {
        if (a.array !== void 0) {
          this.setNameArray(a.array);
        }
      }
    };
    extendClass(KJUR.asn1.x509.IssuerAltName, KJUR.asn1.x509.Extension);
    KJUR.asn1.x509.SubjectDirectoryAttributes = function(e) {
      KJUR.asn1.x509.SubjectDirectoryAttributes.superclass.constructor.call(this, e);
      var c2 = KJUR.asn1, a = c2.DERSequence, b = c2.ASN1Util.newObject, d2 = c2.x509.OID.name2oid;
      this.params = null;
      this.getExtnValueHex = function() {
        var f2 = [];
        for (var j = 0; j < this.params.array.length; j++) {
          var l2 = this.params.array[j];
          if (l2.attr != void 0 && l2.array != void 0) {
            var k = { seq: [{ oid: l2.attr }, { set: l2.array }] };
            f2.push(b(k));
            continue;
          }
          var h = { seq: [{ oid: "1.2.3.4" }, { set: [{ utf8str: "DE" }] }] };
          if (l2.attr == "dateOfBirth") {
            h.seq[0].oid = d2(l2.attr);
            h.seq[1].set[0] = { gentime: l2.str };
          } else {
            if (l2.attr == "placeOfBirth") {
              h.seq[0].oid = d2(l2.attr);
              h.seq[1].set[0] = { utf8str: l2.str };
            } else {
              if (l2.attr == "gender") {
                h.seq[0].oid = d2(l2.attr);
                h.seq[1].set[0] = { prnstr: l2.str };
              } else {
                if (l2.attr == "countryOfCitizenship") {
                  h.seq[0].oid = d2(l2.attr);
                  h.seq[1].set[0] = { prnstr: l2.str };
                } else {
                  if (l2.attr == "countryOfResidence") {
                    h.seq[0].oid = d2(l2.attr);
                    h.seq[1].set[0] = { prnstr: l2.str };
                  } else {
                    throw new Error("unsupported attribute: " + l2.attr);
                  }
                }
              }
            }
          }
          f2.push(new b(h));
        }
        var g2 = new a({ array: f2 });
        this.asn1ExtnValue = g2;
        return this.asn1ExtnValue.tohex();
      };
      this.oid = "2.5.29.9";
      if (e !== void 0) {
        this.params = e;
      }
    };
    extendClass(KJUR.asn1.x509.SubjectDirectoryAttributes, KJUR.asn1.x509.Extension);
    KJUR.asn1.x509.PrivateExtension = function(f2) {
      KJUR.asn1.x509.PrivateExtension.superclass.constructor.call(this, f2);
      var c2 = KJUR, e = c2.lang.String.isHex, b = c2.asn1, d2 = b.x509.OID.name2oid, a = b.ASN1Util.newObject;
      this.params = null;
      this.setByParam = function(g2) {
        this.oid = d2(g2.extname);
        this.params = g2;
      };
      this.getExtnValueHex = function() {
        if (this.params.extname == void 0 || this.params.extn == void 0) {
          throw new Error("extname or extnhex not specified");
        }
        var h = this.params.extn;
        if (typeof h == "string" && e(h)) {
          return h;
        } else {
          if (typeof h == "object") {
            try {
              return a(h).tohex();
            } catch (g2) {
            }
          }
        }
        throw new Error("unsupported extn value");
      };
      if (f2 != void 0) {
        this.setByParam(f2);
      }
    };
    extendClass(KJUR.asn1.x509.PrivateExtension, KJUR.asn1.x509.Extension);
    KJUR.asn1.x509.CRL = function(g2) {
      KJUR.asn1.x509.CRL.superclass.constructor.call(this);
      var c2 = KJUR, b = c2.asn1, a = b.DERSequence, e = b.DERBitString, f2 = b.x509, d2 = f2.AlgorithmIdentifier, h = f2.TBSCertList;
      this.params = void 0;
      this.setByParam = function(i) {
        this.params = i;
      };
      this.sign = function() {
        var j = new h(this.params).tohex();
        var k = new KJUR.crypto.Signature({ alg: this.params.sigalg });
        k.init(this.params.cakey);
        k.updateHex(j);
        var i = k.sign();
        this.params.sighex = i;
      };
      this.getPEM = function() {
        return hextopem(this.tohex(), "X509 CRL");
      };
      this.tohex = function() {
        var k = this.params;
        if (k.tbsobj == void 0) {
          k.tbsobj = new h(k);
        }
        if (k.sighex == void 0 && k.cakey != void 0) {
          this.sign();
        }
        if (k.sighex == void 0) {
          throw new Error("sighex or cakey parameter not defined");
        }
        var i = [];
        i.push(k.tbsobj);
        i.push(new d2({ name: k.sigalg }));
        i.push(new e({ hex: "00" + k.sighex }));
        var j = new a({ array: i });
        return j.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (g2 != void 0) {
        this.params = g2;
      }
    };
    extendClass(KJUR.asn1.x509.CRL, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.TBSCertList = function(f2) {
      KJUR.asn1.x509.TBSCertList.superclass.constructor.call(this);
      var b = KJUR, i = b.asn1, h = i.DERInteger, g2 = i.DERSequence, c2 = i.DERTaggedObject, k = i.DERObjectIdentifier, d2 = i.x509, l2 = d2.AlgorithmIdentifier, e = d2.Time, j = d2.Extensions, a = d2.X500Name;
      this.params = null;
      this.setByParam = function(m2) {
        this.params = m2;
      };
      this.getRevCertSequence = function() {
        var m2 = [];
        var n = this.params.revcert;
        for (var o2 = 0; o2 < n.length; o2++) {
          var p3 = [new h(n[o2].sn), new e(n[o2].date)];
          if (n[o2].ext != void 0) {
            p3.push(new j(n[o2].ext));
          }
          m2.push(new g2({ array: p3 }));
        }
        return new g2({ array: m2 });
      };
      this.tohex = function() {
        var n = [];
        var r = this.params;
        if (r.version != void 0) {
          var m2 = r.version - 1;
          var p3 = new h({ "int": m2 });
          n.push(p3);
        }
        n.push(new l2({ name: r.sigalg }));
        n.push(new a(r.issuer));
        n.push(new e(r.thisupdate));
        if (r.nextupdate != void 0) {
          n.push(new e(r.nextupdate));
        }
        if (r.revcert != void 0) {
          n.push(this.getRevCertSequence());
        }
        if (r.ext != void 0) {
          var q2 = new j(r.ext);
          n.push(new c2({ tag: "a0", explicit: true, obj: q2 }));
        }
        var o2 = new g2({ array: n });
        return o2.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (f2 !== void 0) {
        this.setByParam(f2);
      }
    };
    extendClass(KJUR.asn1.x509.TBSCertList, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.CRLEntry = function(e) {
      KJUR.asn1.x509.CRLEntry.superclass.constructor.call(this);
      var d2 = null, c2 = null, b = KJUR, a = b.asn1;
      this.setCertSerial = function(f2) {
        this.sn = new a.DERInteger(f2);
      };
      this.setRevocationDate = function(f2) {
        this.time = new a.x509.Time(f2);
      };
      this.tohex = function() {
        var f2 = new a.DERSequence({ array: [this.sn, this.time] });
        this.TLV = f2.tohex();
        return this.TLV;
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (e !== void 0) {
        if (e.time !== void 0) {
          this.setRevocationDate(e.time);
        }
        if (e.sn !== void 0) {
          this.setCertSerial(e.sn);
        }
      }
    };
    extendClass(KJUR.asn1.x509.CRLEntry, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.CRLNumber = function(a) {
      KJUR.asn1.x509.CRLNumber.superclass.constructor.call(this, a);
      this.params = void 0;
      this.getExtnValueHex = function() {
        this.asn1ExtnValue = new KJUR.asn1.DERInteger(this.params.num);
        return this.asn1ExtnValue.tohex();
      };
      this.oid = "2.5.29.20";
      if (a != void 0) {
        this.params = a;
      }
    };
    extendClass(KJUR.asn1.x509.CRLNumber, KJUR.asn1.x509.Extension);
    KJUR.asn1.x509.CRLReason = function(a) {
      KJUR.asn1.x509.CRLReason.superclass.constructor.call(this, a);
      this.params = void 0;
      this.getExtnValueHex = function() {
        this.asn1ExtnValue = new KJUR.asn1.DEREnumerated(this.params.code);
        return this.asn1ExtnValue.tohex();
      };
      this.oid = "2.5.29.21";
      if (a != void 0) {
        this.params = a;
      }
    };
    extendClass(KJUR.asn1.x509.CRLReason, KJUR.asn1.x509.Extension);
    KJUR.asn1.x509.OCSPNonce = function(a) {
      KJUR.asn1.x509.OCSPNonce.superclass.constructor.call(this, a);
      this.params = void 0;
      this.getExtnValueHex = function() {
        this.asn1ExtnValue = new KJUR.asn1.DEROctetString(this.params);
        return this.asn1ExtnValue.tohex();
      };
      this.oid = "1.3.6.1.5.5.7.48.1.2";
      if (a != void 0) {
        this.params = a;
      }
    };
    extendClass(KJUR.asn1.x509.OCSPNonce, KJUR.asn1.x509.Extension);
    KJUR.asn1.x509.OCSPNoCheck = function(a) {
      KJUR.asn1.x509.OCSPNoCheck.superclass.constructor.call(this, a);
      this.params = void 0;
      this.getExtnValueHex = function() {
        this.asn1ExtnValue = new KJUR.asn1.DERNull();
        return this.asn1ExtnValue.tohex();
      };
      this.oid = "1.3.6.1.5.5.7.48.1.5";
      if (a != void 0) {
        this.params = a;
      }
    };
    extendClass(KJUR.asn1.x509.OCSPNoCheck, KJUR.asn1.x509.Extension);
    KJUR.asn1.x509.AdobeTimeStamp = function(g2) {
      KJUR.asn1.x509.AdobeTimeStamp.superclass.constructor.call(this, g2);
      var c2 = KJUR, b = c2.asn1, f2 = b.DERInteger, d2 = b.DERBoolean, a = b.DERSequence, e = b.x509.GeneralName;
      this.params = null;
      this.getExtnValueHex = function() {
        var i = this.params;
        var h = [new f2(1)];
        h.push(new e({ uri: i.uri }));
        if (i.reqauth != void 0) {
          h.push(new d2(i.reqauth));
        }
        this.asn1ExtnValue = new a({ array: h });
        return this.asn1ExtnValue.tohex();
      };
      this.oid = "1.2.840.113583.1.1.9.1";
      if (g2 !== void 0) {
        this.setByParam(g2);
      }
    };
    extendClass(KJUR.asn1.x509.AdobeTimeStamp, KJUR.asn1.x509.Extension);
    KJUR.asn1.x509.X500Name = function(f2) {
      KJUR.asn1.x509.X500Name.superclass.constructor.call(this);
      this.asn1Array = [];
      this.paramArray = [];
      this.sRule = "utf8";
      var c2 = KJUR, b = c2.asn1, e = b.x509, d2 = e.RDN, a = pemtohex;
      this.setByString = function(g2, l2) {
        if (l2 !== void 0) {
          this.sRule = l2;
        }
        var k = g2.split("/");
        k.shift();
        var j = [];
        for (var m2 = 0; m2 < k.length; m2++) {
          if (k[m2].match(/^[^=]+=.+$/)) {
            j.push(k[m2]);
          } else {
            var h = j.length - 1;
            j[h] = j[h] + "/" + k[m2];
          }
        }
        for (var m2 = 0; m2 < j.length; m2++) {
          this.asn1Array.push(new d2({ str: j[m2], rule: this.sRule }));
        }
      };
      this.setByLdapString = function(g2, h) {
        if (h !== void 0) {
          this.sRule = h;
        }
        var i = e.X500Name.ldapToCompat(g2);
        this.setByString(i, h);
      };
      this.setByObject = function(j, i) {
        if (i !== void 0) {
          this.sRule = i;
        }
        for (var g2 in j) {
          if (j.hasOwnProperty(g2)) {
            var h = new d2({ str: g2 + "=" + j[g2], rule: this.sRule });
            this.asn1Array ? this.asn1Array.push(h) : this.asn1Array = [h];
          }
        }
      };
      this.setByParam = function(h) {
        if (h.rule !== void 0) {
          this.sRule = h.rule;
        }
        if (h.array !== void 0) {
          this.paramArray = h.array;
        } else {
          if (h.str !== void 0) {
            this.setByString(h.str);
          } else {
            if (h.ldapstr !== void 0) {
              this.setByLdapString(h.ldapstr);
            } else {
              if (h.hex !== void 0) {
                this.hTLV = h.hex;
              } else {
                if (h.certissuer !== void 0) {
                  var g2 = new X509();
                  g2.readCertPEM(h.certissuer);
                  this.hTLV = g2.getIssuerHex();
                } else {
                  if (h.certsubject !== void 0) {
                    var g2 = new X509();
                    g2.readCertPEM(h.certsubject);
                    this.hTLV = g2.getSubjectHex();
                  } else {
                    if (typeof h === "object" && h.certsubject === void 0 && h.certissuer === void 0) {
                      this.setByObject(h);
                    }
                  }
                }
              }
            }
          }
        }
      };
      this.tohex = function() {
        if (typeof this.hTLV == "string") {
          return this.hTLV;
        }
        if (this.asn1Array.length == 0 && this.paramArray.length > 0) {
          for (var g2 = 0; g2 < this.paramArray.length; g2++) {
            var k = { array: this.paramArray[g2] };
            if (this.sRule != "utf8") {
              k.rule = this.sRule;
            }
            var h = new d2(k);
            this.asn1Array.push(h);
          }
        }
        var j = new b.DERSequence({ array: this.asn1Array });
        this.hTLV = j.tohex();
        return this.hTLV;
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (f2 !== void 0) {
        this.setByParam(f2);
      }
    };
    extendClass(KJUR.asn1.x509.X500Name, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.X500Name.compatToLDAP = function(d2) {
      if (d2.substr(0, 1) !== "/") {
        throw "malformed input";
      }
      var b = "";
      d2 = d2.substr(1);
      var c2 = d2.split("/");
      c2.reverse();
      c2 = c2.map(function(a) {
        return a.replace(/,/, "\\,");
      });
      return c2.join(",");
    };
    KJUR.asn1.x509.X500Name.onelineToLDAP = function(a) {
      return KJUR.asn1.x509.X500Name.compatToLDAP(a);
    };
    KJUR.asn1.x509.X500Name.ldapToCompat = function(g2) {
      var c2 = g2.split(",");
      var e = false;
      var b = [];
      for (var f2 = 0; c2.length > 0; f2++) {
        var h = c2.shift();
        if (e === true) {
          var d2 = b.pop();
          var j = (d2 + "," + h).replace(/\\,/g, ",");
          b.push(j);
          e = false;
        } else {
          b.push(h);
        }
        if (h.substr(-1, 1) === "\\") {
          e = true;
        }
      }
      b = b.map(function(a) {
        return a.replace("/", "\\/");
      });
      b.reverse();
      return "/" + b.join("/");
    };
    KJUR.asn1.x509.X500Name.ldapToOneline = function(a) {
      return KJUR.asn1.x509.X500Name.ldapToCompat(a);
    };
    KJUR.asn1.x509.RDN = function(b) {
      KJUR.asn1.x509.RDN.superclass.constructor.call(this);
      this.asn1Array = [];
      this.paramArray = [];
      this.sRule = "utf8";
      var a = KJUR.asn1.x509.AttributeTypeAndValue;
      this.setByParam = function(c2) {
        if (c2.rule !== void 0) {
          this.sRule = c2.rule;
        }
        if (c2.str !== void 0) {
          this.addByMultiValuedString(c2.str);
        }
        if (c2.array !== void 0) {
          this.paramArray = c2.array;
        }
      };
      this.addByString = function(c2) {
        this.asn1Array.push(new KJUR.asn1.x509.AttributeTypeAndValue({ str: c2, rule: this.sRule }));
      };
      this.addByMultiValuedString = function(e) {
        var c2 = KJUR.asn1.x509.RDN.parseString(e);
        for (var d2 = 0; d2 < c2.length; d2++) {
          this.addByString(c2[d2]);
        }
      };
      this.tohex = function() {
        if (this.asn1Array.length == 0 && this.paramArray.length > 0) {
          for (var d2 = 0; d2 < this.paramArray.length; d2++) {
            var f2 = this.paramArray[d2];
            if (f2.rule !== void 0 && this.sRule != "utf8") {
              f2.rule = this.sRule;
            }
            var c2 = new a(f2);
            this.asn1Array.push(c2);
          }
        }
        var e = new KJUR.asn1.DERSet({ array: this.asn1Array });
        this.TLV = e.tohex();
        return this.TLV;
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (b !== void 0) {
        this.setByParam(b);
      }
    };
    extendClass(KJUR.asn1.x509.RDN, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.RDN.parseString = function(m2) {
      var j = m2.split(/\+/);
      var h = false;
      var c2 = [];
      for (var g2 = 0; j.length > 0; g2++) {
        var k = j.shift();
        if (h === true) {
          var f2 = c2.pop();
          var d2 = (f2 + "+" + k).replace(/\\\+/g, "+");
          c2.push(d2);
          h = false;
        } else {
          c2.push(k);
        }
        if (k.substr(-1, 1) === "\\") {
          h = true;
        }
      }
      var l2 = false;
      var b = [];
      for (var g2 = 0; c2.length > 0; g2++) {
        var k = c2.shift();
        if (l2 === true) {
          var e = b.pop();
          if (k.match(/"$/)) {
            var d2 = (e + "+" + k).replace(/^([^=]+)="(.*)"$/, "$1=$2");
            b.push(d2);
            l2 = false;
          } else {
            b.push(e + "+" + k);
          }
        } else {
          b.push(k);
        }
        if (k.match(/^[^=]+="/)) {
          l2 = true;
        }
      }
      return b;
    };
    KJUR.asn1.x509.AttributeTypeAndValue = function(c2) {
      KJUR.asn1.x509.AttributeTypeAndValue.superclass.constructor.call(this);
      this.sRule = "utf8";
      this.sType = null;
      this.sValue = null;
      this.dsType = null;
      var a = KJUR, g2 = a.asn1, d2 = g2.DERSequence, l2 = g2.DERUTF8String, i = g2.DERPrintableString, h = g2.DERTeletexString, b = g2.DERIA5String, e = g2.DERVisibleString, k = g2.DERBMPString, f2 = a.lang.String.isMail, j = a.lang.String.isPrintable;
      this.setByParam = function(o2) {
        if (o2.rule !== void 0) {
          this.sRule = o2.rule;
        }
        if (o2.ds !== void 0) {
          this.dsType = o2.ds;
        }
        if (o2.value === void 0 && o2.str !== void 0) {
          var n = o2.str;
          var m2 = n.match(/^([^=]+)=(.+)$/);
          if (m2) {
            this.sType = m2[1];
            this.sValue = m2[2];
          } else {
            throw new Error("malformed attrTypeAndValueStr: " + attrTypeAndValueStr);
          }
        } else {
          this.sType = o2.type;
          this.sValue = o2.value;
        }
      };
      this.setByString = function(n, o2) {
        if (o2 !== void 0) {
          this.sRule = o2;
        }
        var m2 = n.match(/^([^=]+)=(.+)$/);
        if (m2) {
          this.setByAttrTypeAndValueStr(m2[1], m2[2]);
        } else {
          throw new Error("malformed attrTypeAndValueStr: " + attrTypeAndValueStr);
        }
      };
      this._getDsType = function() {
        var o2 = this.sType;
        var n = this.sValue;
        var m2 = this.sRule;
        if (m2 === "prn") {
          if (o2 == "CN" && f2(n)) {
            return "ia5";
          }
          if (j(n)) {
            return "prn";
          }
          return "utf8";
        } else {
          if (m2 === "utf8") {
            if (o2 == "CN" && f2(n)) {
              return "ia5";
            }
            if (o2 == "C") {
              return "prn";
            }
            return "utf8";
          }
        }
        return "utf8";
      };
      this.setByAttrTypeAndValueStr = function(o2, n, m2) {
        if (m2 !== void 0) {
          this.sRule = m2;
        }
        this.sType = o2;
        this.sValue = n;
      };
      this.getValueObj = function(n, m2) {
        if (n == "utf8") {
          return new l2({ str: m2 });
        }
        if (n == "prn") {
          return new i({ str: m2 });
        }
        if (n == "tel") {
          return new h({ str: m2 });
        }
        if (n == "ia5") {
          return new b({ str: m2 });
        }
        if (n == "vis") {
          return new e({ str: m2 });
        }
        if (n == "bmp") {
          return new k({ str: m2 });
        }
        throw new Error("unsupported directory string type: type=" + n + " value=" + m2);
      };
      this.tohex = function() {
        if (this.dsType == null) {
          this.dsType = this._getDsType();
        }
        var n = KJUR.asn1.x509.OID.atype2obj(this.sType);
        var m2 = this.getValueObj(this.dsType, this.sValue);
        var p3 = new d2({ array: [n, m2] });
        this.TLV = p3.tohex();
        return this.TLV;
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (c2 !== void 0) {
        this.setByParam(c2);
      }
    };
    extendClass(KJUR.asn1.x509.AttributeTypeAndValue, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.SubjectPublicKeyInfo = function(f2) {
      KJUR.asn1.x509.SubjectPublicKeyInfo.superclass.constructor.call(this);
      var l2 = null, k = null, a = KJUR, j = a.asn1, i = j.DERInteger, b = j.DERBitString, m2 = j.DERObjectIdentifier, e = j.DERSequence, h = j.ASN1Util.newObject, d2 = j.x509, o2 = d2.AlgorithmIdentifier, g2 = a.crypto, n = g2.ECDSA, c2 = g2.DSA;
      this.getASN1Object = function() {
        if (this.asn1AlgId == null || this.asn1SubjPKey == null) {
          throw "algId and/or subjPubKey not set";
        }
        var p3 = new e({ array: [this.asn1AlgId, this.asn1SubjPKey] });
        return p3;
      };
      this.tohex = function() {
        var p3 = this.getASN1Object();
        this.hTLV = p3.tohex();
        return this.hTLV;
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      this.setPubKey = function(q2) {
        try {
          if (q2 instanceof RSAKey) {
            var u2 = h({ seq: [{ "int": { bigint: q2.n } }, { "int": { "int": q2.e } }] });
            var s = u2.tohex();
            this.asn1AlgId = new o2({ name: "rsaEncryption" });
            this.asn1SubjPKey = new b({ hex: "00" + s });
          }
        } catch (p3) {
        }
        try {
          if (q2 instanceof KJUR.crypto.ECDSA) {
            var r = new m2({ name: q2.curveName });
            this.asn1AlgId = new o2({ name: "ecPublicKey", asn1params: r });
            this.asn1SubjPKey = new b({ hex: "00" + q2.pubKeyHex });
          }
        } catch (p3) {
        }
        try {
          if (q2 instanceof KJUR.crypto.DSA) {
            var r = new h({ seq: [{ "int": { bigint: q2.p } }, { "int": { bigint: q2.q } }, { "int": { bigint: q2.g } }] });
            this.asn1AlgId = new o2({ name: "dsa", asn1params: r });
            var t2 = new i({ bigint: q2.y });
            this.asn1SubjPKey = new b({ hex: "00" + t2.tohex() });
          }
        } catch (p3) {
        }
      };
      if (f2 !== void 0) {
        this.setPubKey(f2);
      }
    };
    extendClass(KJUR.asn1.x509.SubjectPublicKeyInfo, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.Time = function(f2) {
      KJUR.asn1.x509.Time.superclass.constructor.call(this);
      var e = null, a = null, d2 = KJUR, c2 = d2.asn1, b = c2.DERUTCTime, g2 = c2.DERGeneralizedTime;
      this.params = null;
      this.type = null;
      this.setTimeParams = function(h) {
        this.timeParams = h;
      };
      this.setByParam = function(h) {
        this.params = h;
      };
      this.getType = function(h) {
        if (h.match(/^[0-9]{12}Z$/)) {
          return "utc";
        }
        if (h.match(/^[0-9]{14}Z$/)) {
          return "gen";
        }
        if (h.match(/^[0-9]{12}\.[0-9]+Z$/)) {
          return "utc";
        }
        if (h.match(/^[0-9]{14}\.[0-9]+Z$/)) {
          return "gen";
        }
        return null;
      };
      this.tohex = function() {
        var i = this.params;
        var h = null;
        if (typeof i == "string") {
          i = { str: i };
        }
        if (i != null && i.str && (i.type == null || i.type == void 0)) {
          i.type = this.getType(i.str);
        }
        if (i != null && i.str) {
          if (i.type == "utc") {
            h = new b(i.str);
          }
          if (i.type == "gen") {
            h = new g2(i.str);
          }
        } else {
          if (this.type == "gen") {
            h = new g2();
          } else {
            h = new b();
          }
        }
        if (h == null) {
          throw new Error("wrong setting for Time");
        }
        this.TLV = h.tohex();
        return this.TLV;
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (f2 != void 0) {
        this.setByParam(f2);
      }
    };
    KJUR.asn1.x509.Time_bak = function(f2) {
      KJUR.asn1.x509.Time_bak.superclass.constructor.call(this);
      var e = null, a = null, d2 = KJUR, c2 = d2.asn1, b = c2.DERUTCTime, g2 = c2.DERGeneralizedTime;
      this.setTimeParams = function(h) {
        this.timeParams = h;
      };
      this.tohex = function() {
        var h = null;
        if (this.timeParams != null) {
          if (this.type == "utc") {
            h = new b(this.timeParams);
          } else {
            h = new g2(this.timeParams);
          }
        } else {
          if (this.type == "utc") {
            h = new b();
          } else {
            h = new g2();
          }
        }
        this.TLV = h.tohex();
        return this.TLV;
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      this.type = "utc";
      if (f2 !== void 0) {
        if (f2.type !== void 0) {
          this.type = f2.type;
        } else {
          if (f2.str !== void 0) {
            if (f2.str.match(/^[0-9]{12}Z$/)) {
              this.type = "utc";
            }
            if (f2.str.match(/^[0-9]{14}Z$/)) {
              this.type = "gen";
            }
          }
        }
        this.timeParams = f2;
      }
    };
    extendClass(KJUR.asn1.x509.Time, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.AlgorithmIdentifier = function(e) {
      KJUR.asn1.x509.AlgorithmIdentifier.superclass.constructor.call(this);
      this.nameAlg = null;
      this.asn1Alg = null;
      this.asn1Params = null;
      this.paramEmpty = false;
      var b = KJUR, a = b.asn1, c2 = a.x509.AlgorithmIdentifier.PSSNAME2ASN1TLV;
      this.tohex = function() {
        if (this.nameAlg === null && this.asn1Alg === null) {
          throw new Error("algorithm not specified");
        }
        if (this.nameAlg !== null) {
          var f2 = null;
          for (var h in c2) {
            if (h === this.nameAlg) {
              f2 = c2[h];
            }
          }
          if (f2 !== null) {
            this.hTLV = f2;
            return this.hTLV;
          }
        }
        if (this.nameAlg !== null && this.asn1Alg === null) {
          this.asn1Alg = a.x509.OID.name2obj(this.nameAlg);
        }
        var g2 = [this.asn1Alg];
        if (this.asn1Params !== null) {
          g2.push(this.asn1Params);
        }
        var i = new a.DERSequence({ array: g2 });
        this.hTLV = i.tohex();
        return this.hTLV;
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (e !== void 0) {
        if (e.name !== void 0) {
          this.nameAlg = e.name;
        }
        if (e.asn1params !== void 0) {
          this.asn1Params = e.asn1params;
        }
        if (e.paramempty !== void 0) {
          this.paramEmpty = e.paramempty;
        }
      }
      if (this.asn1Params === null && this.paramEmpty === false && this.nameAlg !== null) {
        if (this.nameAlg.name !== void 0) {
          this.nameAlg = this.nameAlg.name;
        }
        var d2 = this.nameAlg.toLowerCase();
        if (d2.substr(-7, 7) !== "withdsa" && d2.substr(-9, 9) !== "withecdsa") {
          this.asn1Params = new a.DERNull();
        }
      }
    };
    extendClass(KJUR.asn1.x509.AlgorithmIdentifier, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.AlgorithmIdentifier.PSSNAME2ASN1TLV = { SHAwithRSAandMGF1: "300d06092a864886f70d01010a3000", SHA256withRSAandMGF1: "303d06092a864886f70d01010a3030a00d300b0609608648016503040201a11a301806092a864886f70d010108300b0609608648016503040201a203020120", SHA384withRSAandMGF1: "303d06092a864886f70d01010a3030a00d300b0609608648016503040202a11a301806092a864886f70d010108300b0609608648016503040202a203020130", SHA512withRSAandMGF1: "303d06092a864886f70d01010a3030a00d300b0609608648016503040203a11a301806092a864886f70d010108300b0609608648016503040203a203020140" };
    KJUR.asn1.x509.GeneralName = function(f2) {
      KJUR.asn1.x509.GeneralName.superclass.constructor.call(this);
      var l2 = { rfc822: "81", dns: "82", dn: "a4", uri: "86", ip: "87", otherName: "a0" }, b = KJUR, h = b.asn1, d2 = h.x509, a = d2.X500Name, g2 = d2.OtherName, e = h.DERIA5String, i = h.DERPrintableString, k = h.DEROctetString, c2 = h.DERTaggedObject, m2 = h.ASN1Object, j = Error;
      this.params = null;
      this.setByParam = function(n) {
        this.params = n;
      };
      this.tohex = function() {
        var p3 = this.params;
        var A, y, q2;
        var y = false;
        if (p3.other !== void 0) {
          A = "a0", q2 = new g2(p3.other);
        } else {
          if (p3.rfc822 !== void 0) {
            A = "81";
            q2 = new e({ str: p3.rfc822 });
          } else {
            if (p3.dns !== void 0) {
              A = "82";
              q2 = new e({ str: p3.dns });
            } else {
              if (p3.dn !== void 0) {
                A = "a4";
                y = true;
                if (typeof p3.dn === "string") {
                  q2 = new a({ str: p3.dn });
                } else {
                  if (p3.dn instanceof KJUR.asn1.x509.X500Name) {
                    q2 = p3.dn;
                  } else {
                    q2 = new a(p3.dn);
                  }
                }
              } else {
                if (p3.ldapdn !== void 0) {
                  A = "a4";
                  y = true;
                  q2 = new a({ ldapstr: p3.ldapdn });
                } else {
                  if (p3.certissuer !== void 0 || p3.certsubj !== void 0) {
                    A = "a4";
                    y = true;
                    var n, o2;
                    var z2 = null;
                    if (p3.certsubj !== void 0) {
                      n = false;
                      o2 = p3.certsubj;
                    } else {
                      n = true;
                      o2 = p3.certissuer;
                    }
                    if (o2.match(/^[0-9A-Fa-f]+$/)) {
                      z2 == o2;
                    }
                    if (o2.indexOf("-----BEGIN ") != -1) {
                      z2 = pemtohex(o2);
                    }
                    if (z2 == null) {
                      throw new Error("certsubj/certissuer not cert");
                    }
                    var w = new X509();
                    w.hex = z2;
                    var s;
                    if (n) {
                      s = w.getIssuerHex();
                    } else {
                      s = w.getSubjectHex();
                    }
                    q2 = new m2();
                    q2.hTLV = s;
                  } else {
                    if (p3.uri !== void 0) {
                      A = "86";
                      q2 = new e({ str: p3.uri });
                    } else {
                      if (p3.ip !== void 0) {
                        A = "87";
                        var v;
                        var t2 = p3.ip;
                        try {
                          if (t2.match(/^[0-9a-f]+$/)) {
                            var r = t2.length;
                            if (r == 8 || r == 16 || r == 32 || r == 64) {
                              v = t2;
                            } else {
                              throw "err";
                            }
                          } else {
                            v = iptohex(t2);
                          }
                        } catch (u2) {
                          throw new j("malformed IP address: " + p3.ip + ":" + u2.message);
                        }
                        q2 = new k({ hex: v });
                      } else {
                        throw new j("improper params");
                      }
                    }
                  }
                }
              }
            }
          }
        }
        var B = new c2({ tag: A, explicit: y, obj: q2 });
        return B.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (f2 !== void 0) {
        this.setByParam(f2);
      }
    };
    extendClass(KJUR.asn1.x509.GeneralName, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.GeneralNames = function(d2) {
      KJUR.asn1.x509.GeneralNames.superclass.constructor.call(this);
      var a = null, c2 = KJUR, b = c2.asn1;
      this.setByParamArray = function(g2) {
        for (var e = 0; e < g2.length; e++) {
          var f2 = new b.x509.GeneralName(g2[e]);
          this.asn1Array.push(f2);
        }
      };
      this.tohex = function() {
        var e = new b.DERSequence({ array: this.asn1Array });
        return e.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      this.asn1Array = new Array();
      if (typeof d2 != "undefined") {
        this.setByParamArray(d2);
      }
    };
    extendClass(KJUR.asn1.x509.GeneralNames, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.OtherName = function(g2) {
      KJUR.asn1.x509.OtherName.superclass.constructor.call(this);
      var f2 = null, e = null, d2 = KJUR, c2 = d2.asn1, h = c2.DERObjectIdentifier, a = c2.DERSequence, b = c2.ASN1Util.newObject;
      this.params = null;
      this.setByParam = function(i) {
        this.params = i;
      };
      this.tohex = function() {
        var k = this.params;
        if (k.oid == void 0 || k.value == void 0) {
          throw new Error("oid or value not specified");
        }
        var l2 = new h({ oid: k.oid });
        var i = b({ tag: { tag: "a0", explicit: true, obj: k.value } });
        var j = new a({ array: [l2, i] });
        return j.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (g2 !== void 0) {
        this.setByParam(g2);
      }
    };
    extendClass(KJUR.asn1.x509.OtherName, KJUR.asn1.ASN1Object);
    KJUR.asn1.x509.OID = new function() {
      var a = KJUR.asn1.DERObjectIdentifier;
      this.name2oidList = { "aes128-CBC": "2.16.840.1.101.3.4.1.2", "aes256-CBC": "2.16.840.1.101.3.4.1.42", sha1: "1.3.14.3.2.26", sha256: "2.16.840.1.101.3.4.2.1", sha384: "2.16.840.1.101.3.4.2.2", sha512: "2.16.840.1.101.3.4.2.3", sha224: "2.16.840.1.101.3.4.2.4", md5: "1.2.840.113549.2.5", md2: "1.3.14.7.2.2.1", ripemd160: "1.3.36.3.2.1", hmacWithSHA1: "1.2.840.113549.2.7", hmacWithSHA224: "1.2.840.113549.2.8", hmacWithSHA256: "1.2.840.113549.2.9", hmacWithSHA384: "1.2.840.113549.2.10", hmacWithSHA512: "1.2.840.113549.2.11", MD2withRSA: "1.2.840.113549.1.1.2", MD4withRSA: "1.2.840.113549.1.1.3", MD5withRSA: "1.2.840.113549.1.1.4", SHA1withRSA: "1.2.840.113549.1.1.5", "pkcs1-MGF": "1.2.840.113549.1.1.8", rsaPSS: "1.2.840.113549.1.1.10", SHA224withRSA: "1.2.840.113549.1.1.14", SHA256withRSA: "1.2.840.113549.1.1.11", SHA384withRSA: "1.2.840.113549.1.1.12", SHA512withRSA: "1.2.840.113549.1.1.13", SHA1withECDSA: "1.2.840.10045.4.1", SHA224withECDSA: "1.2.840.10045.4.3.1", SHA256withECDSA: "1.2.840.10045.4.3.2", SHA384withECDSA: "1.2.840.10045.4.3.3", SHA512withECDSA: "1.2.840.10045.4.3.4", dsa: "1.2.840.10040.4.1", SHA1withDSA: "1.2.840.10040.4.3", SHA224withDSA: "2.16.840.1.101.3.4.3.1", SHA256withDSA: "2.16.840.1.101.3.4.3.2", rsaEncryption: "1.2.840.113549.1.1.1", commonName: "2.5.4.3", countryName: "2.5.4.6", localityName: "2.5.4.7", stateOrProvinceName: "2.5.4.8", streetAddress: "2.5.4.9", organizationName: "2.5.4.10", organizationalUnitName: "2.5.4.11", domainComponent: "0.9.2342.19200300.100.1.25", userId: "0.9.2342.19200300.100.1.1", surname: "2.5.4.4", givenName: "2.5.4.42", title: "2.5.4.12", distinguishedName: "2.5.4.49", emailAddress: "1.2.840.113549.1.9.1", description: "2.5.4.13", businessCategory: "2.5.4.15", postalCode: "2.5.4.17", uniqueIdentifier: "2.5.4.45", organizationIdentifier: "2.5.4.97", jurisdictionOfIncorporationL: "1.3.6.1.4.1.311.60.2.1.1", jurisdictionOfIncorporationSP: "1.3.6.1.4.1.311.60.2.1.2", jurisdictionOfIncorporationC: "1.3.6.1.4.1.311.60.2.1.3", subjectDirectoryAttributes: "2.5.29.9", subjectKeyIdentifier: "2.5.29.14", keyUsage: "2.5.29.15", subjectAltName: "2.5.29.17", issuerAltName: "2.5.29.18", basicConstraints: "2.5.29.19", cRLNumber: "2.5.29.20", cRLReason: "2.5.29.21", nameConstraints: "2.5.29.30", cRLDistributionPoints: "2.5.29.31", certificatePolicies: "2.5.29.32", anyPolicy: "2.5.29.32.0", policyMappings: "2.5.29.33", authorityKeyIdentifier: "2.5.29.35", policyConstraints: "2.5.29.36", extKeyUsage: "2.5.29.37", inhibitAnyPolicy: "2.5.29.54", authorityInfoAccess: "1.3.6.1.5.5.7.1.1", ocsp: "1.3.6.1.5.5.7.48.1", ocspBasic: "1.3.6.1.5.5.7.48.1.1", ocspNonce: "1.3.6.1.5.5.7.48.1.2", ocspNoCheck: "1.3.6.1.5.5.7.48.1.5", caIssuers: "1.3.6.1.5.5.7.48.2", anyExtendedKeyUsage: "2.5.29.37.0", serverAuth: "1.3.6.1.5.5.7.3.1", clientAuth: "1.3.6.1.5.5.7.3.2", codeSigning: "1.3.6.1.5.5.7.3.3", emailProtection: "1.3.6.1.5.5.7.3.4", timeStamping: "1.3.6.1.5.5.7.3.8", ocspSigning: "1.3.6.1.5.5.7.3.9", smtpUTF8Mailbox: "1.3.6.1.5.5.7.8.9", dateOfBirth: "1.3.6.1.5.5.7.9.1", placeOfBirth: "1.3.6.1.5.5.7.9.2", gender: "1.3.6.1.5.5.7.9.3", countryOfCitizenship: "1.3.6.1.5.5.7.9.4", countryOfResidence: "1.3.6.1.5.5.7.9.5", ecPublicKey: "1.2.840.10045.2.1", "P-256": "1.2.840.10045.3.1.7", secp256r1: "1.2.840.10045.3.1.7", secp256k1: "1.3.132.0.10", secp384r1: "1.3.132.0.34", secp521r1: "1.3.132.0.35", pkcs5PBES2: "1.2.840.113549.1.5.13", pkcs5PBKDF2: "1.2.840.113549.1.5.12", "des-EDE3-CBC": "1.2.840.113549.3.7", data: "1.2.840.113549.1.7.1", "signed-data": "1.2.840.113549.1.7.2", "enveloped-data": "1.2.840.113549.1.7.3", "digested-data": "1.2.840.113549.1.7.5", "encrypted-data": "1.2.840.113549.1.7.6", "authenticated-data": "1.2.840.113549.1.9.16.1.2", tstinfo: "1.2.840.113549.1.9.16.1.4", signingCertificate: "1.2.840.113549.1.9.16.2.12", timeStampToken: "1.2.840.113549.1.9.16.2.14", signaturePolicyIdentifier: "1.2.840.113549.1.9.16.2.15", etsArchiveTimeStamp: "1.2.840.113549.1.9.16.2.27", signingCertificateV2: "1.2.840.113549.1.9.16.2.47", etsArchiveTimeStampV2: "1.2.840.113549.1.9.16.2.48", extensionRequest: "1.2.840.113549.1.9.14", contentType: "1.2.840.113549.1.9.3", messageDigest: "1.2.840.113549.1.9.4", signingTime: "1.2.840.113549.1.9.5", counterSignature: "1.2.840.113549.1.9.6", archiveTimeStampV3: "0.4.0.1733.2.4", pdfRevocationInfoArchival: "1.2.840.113583.1.1.8", adobeTimeStamp: "1.2.840.113583.1.1.9.1", smimeMailboxLegacy: "2.23.140.1.5.1.1", smimeMailboxMulti: "2.23.140.1.5.1.2", smimeMailboxStrict: "2.23.140.1.5.1.3", smimeOrganizationLegacy: "2.23.140.1.5.2.1", smimeOrganizationMulti: "2.23.140.1.5.2.2", smimeOrganizationStrict: "2.23.140.1.5.2.3", smimeSponsorLegacy: "2.23.140.1.5.3.1", smimeSponsorMulti: "2.23.140.1.5.3.2", smimeSponsorStrict: "2.23.140.1.5.3.3", smimeIndividualLegacy: "2.23.140.1.5.4.1", smimeIndividualMulti: "2.23.140.1.5.4.2", smimeIndividualStrict: "2.23.140.1.5.4.3" };
      this.atype2oidList = { CN: "2.5.4.3", L: "2.5.4.7", ST: "2.5.4.8", O: "2.5.4.10", OU: "2.5.4.11", C: "2.5.4.6", STREET: "2.5.4.9", DC: "0.9.2342.19200300.100.1.25", UID: "0.9.2342.19200300.100.1.1", SN: "2.5.4.4", T: "2.5.4.12", GN: "2.5.4.42", DN: "2.5.4.49", E: "1.2.840.113549.1.9.1", description: "2.5.4.13", businessCategory: "2.5.4.15", postalCode: "2.5.4.17", serialNumber: "2.5.4.5", uniqueIdentifier: "2.5.4.45", organizationIdentifier: "2.5.4.97", jurisdictionOfIncorporationL: "1.3.6.1.4.1.311.60.2.1.1", jurisdictionOfIncorporationSP: "1.3.6.1.4.1.311.60.2.1.2", jurisdictionOfIncorporationC: "1.3.6.1.4.1.311.60.2.1.3" };
      this.objCache = {};
      this.name2obj = function(b) {
        if (typeof this.objCache[b] != "undefined") {
          return this.objCache[b];
        }
        if (typeof this.name2oidList[b] == "undefined") {
          throw "Name of ObjectIdentifier not defined: " + b;
        }
        var c2 = this.name2oidList[b];
        var d2 = new a({ oid: c2 });
        this.objCache[b] = d2;
        return d2;
      };
      this.atype2obj = function(b) {
        if (this.objCache[b] !== void 0) {
          return this.objCache[b];
        }
        var c2;
        if (b.match(/^\d+\.\d+\.[0-9.]+$/)) {
          c2 = b;
        } else {
          if (this.atype2oidList[b] !== void 0) {
            c2 = this.atype2oidList[b];
          } else {
            if (this.name2oidList[b] !== void 0) {
              c2 = this.name2oidList[b];
            } else {
              throw new Error("AttributeType name undefined: " + b);
            }
          }
        }
        var d2 = new a({ oid: c2 });
        this.objCache[b] = d2;
        return d2;
      };
      this.registerOIDs = function(b) {
        if (!this.checkOIDs(b)) {
          return;
        }
        for (var c2 in b) {
          this.name2oidList[c2] = b[c2];
        }
      };
      this.checkOIDs = function(b) {
        try {
          var d2 = Object.keys(b);
          if (d2.length == 0) {
            return false;
          }
          d2.map(function(g2, e, h) {
            var f2 = this[g2];
            if (!f2.match(/^[0-2]\.[0-9.]+$/)) {
              throw new Error("value is not OID");
            }
          }, b);
          return true;
        } catch (c2) {
          return false;
        }
      };
    }();
    KJUR.asn1.x509.OID.oid2name = function(b) {
      var c2 = KJUR.asn1.x509.OID.name2oidList;
      for (var a in c2) {
        if (c2[a] == b) {
          return a;
        }
      }
      return "";
    };
    KJUR.asn1.x509.OID.oid2atype = function(b) {
      var c2 = KJUR.asn1.x509.OID.atype2oidList;
      for (var a in c2) {
        if (c2[a] == b) {
          return a;
        }
      }
      return b;
    };
    KJUR.asn1.x509.OID.name2oid = function(a) {
      if (a.match(/^[0-9.]+$/)) {
        return a;
      }
      var b = KJUR.asn1.x509.OID.name2oidList;
      if (b[a] === void 0) {
        return "";
      }
      return b[a];
    };
    KJUR.asn1.x509.X509Util = {};
    KJUR.asn1.x509.X509Util.newCertPEM = function(e) {
      var d2 = KJUR.asn1.x509, b = d2.TBSCertificate, a = d2.Certificate;
      var c2 = new a(e);
      return c2.getPEM();
    };
    if (typeof KJUR == "undefined" || !KJUR) {
      KJUR = {};
    }
    if (typeof KJUR.asn1 == "undefined" || !KJUR.asn1) {
      KJUR.asn1 = {};
    }
    if (typeof KJUR.asn1.cms == "undefined" || !KJUR.asn1.cms) {
      KJUR.asn1.cms = {};
    }
    KJUR.asn1.cms.Attribute = function(f2) {
      var e = Error, d2 = KJUR, c2 = d2.asn1, b = c2.DERSequence, a = c2.DERSet, g2 = c2.DERObjectIdentifier;
      this.params = null;
      this.typeOid = null;
      this.setByParam = function(h) {
        this.params = h;
      };
      this.getValueArray = function() {
        throw new e("not yet implemented abstract");
      };
      this.tohex = function() {
        var j = new g2({ oid: this.typeOid });
        var h = new a({ array: this.getValueArray() });
        var i = new b({ array: [j, h] });
        return i.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
    };
    extendClass(KJUR.asn1.cms.Attribute, KJUR.asn1.ASN1Object);
    KJUR.asn1.cms.ContentType = function(c2) {
      var b = KJUR, a = b.asn1;
      a.cms.ContentType.superclass.constructor.call(this);
      this.typeOid = "1.2.840.113549.1.9.3";
      this.getValueArray = function() {
        var d2 = new a.DERObjectIdentifier(this.params.type);
        return [d2];
      };
      if (c2 != void 0) {
        this.setByParam(c2);
      }
    };
    extendClass(KJUR.asn1.cms.ContentType, KJUR.asn1.cms.Attribute);
    KJUR.asn1.cms.MessageDigest = function(e) {
      var b = KJUR, a = b.asn1, c2 = a.DEROctetString, d2 = a.cms;
      d2.MessageDigest.superclass.constructor.call(this);
      this.typeOid = "1.2.840.113549.1.9.4";
      this.getValueArray = function() {
        var f2 = new c2(this.params);
        return [f2];
      };
      if (e != void 0) {
        this.setByParam(e);
      }
    };
    extendClass(KJUR.asn1.cms.MessageDigest, KJUR.asn1.cms.Attribute);
    KJUR.asn1.cms.SigningTime = function(c2) {
      var b = KJUR, a = b.asn1;
      a.cms.SigningTime.superclass.constructor.call(this);
      this.typeOid = "1.2.840.113549.1.9.5";
      this.getValueArray = function() {
        var d2 = new a.x509.Time(this.params);
        return [d2];
      };
      if (c2 != void 0) {
        this.setByParam(c2);
      }
    };
    extendClass(KJUR.asn1.cms.SigningTime, KJUR.asn1.cms.Attribute);
    KJUR.asn1.cms.SigningCertificate = function(h) {
      var e = Error, d2 = KJUR, c2 = d2.asn1, b = c2.DERSequence, g2 = c2.cms, a = g2.ESSCertID, f2 = d2.crypto;
      g2.SigningCertificate.superclass.constructor.call(this);
      this.typeOid = "1.2.840.113549.1.9.16.2.12";
      this.getValueArray = function() {
        if (this.params == null || this.params == void 0 || this.params.array == void 0) {
          throw new e("parameter 'array' not specified");
        }
        var o2 = this.params.array;
        var k = [];
        for (var l2 = 0; l2 < o2.length; l2++) {
          var n = o2[l2];
          if (h.hasis == false && (typeof n == "string" && (n.indexOf("-----BEGIN") != -1 || ASN1HEX.isASN1HEX(n)))) {
            n = { cert: n };
          }
          if (n.hasis != false && h.hasis == false) {
            n.hasis = false;
          }
          k.push(new a(n));
        }
        var j = new b({ array: k });
        var m2 = new b({ array: [j] });
        return [m2];
      };
      if (h != void 0) {
        this.setByParam(h);
      }
    };
    extendClass(KJUR.asn1.cms.SigningCertificate, KJUR.asn1.cms.Attribute);
    KJUR.asn1.cms.ESSCertID = function(g2) {
      KJUR.asn1.cms.ESSCertID.superclass.constructor.call(this);
      var d2 = Error, c2 = KJUR, b = c2.asn1, f2 = b.DEROctetString, a = b.DERSequence, e = b.cms.IssuerSerial;
      this.params = null;
      this.getCertHash = function(k, h) {
        if (k.hash != void 0) {
          return k.hash;
        }
        if (typeof k == "string" && k.indexOf("-----BEGIN") == -1 && !ASN1HEX.isASN1HEX(k)) {
          return k;
        }
        var i;
        if (typeof k == "string") {
          i = k;
        } else {
          if (k.cert != void 0) {
            i = k.cert;
          } else {
            throw new d2("hash nor cert unspecified");
          }
        }
        var j;
        if (i.indexOf("-----BEGIN") != -1) {
          j = pemtohex(i);
        } else {
          j = i;
        }
        if (typeof k == "string") {
          if (k.indexOf("-----BEGIN") != -1) {
            j = pemtohex(k);
          } else {
            if (ASN1HEX.isASN1HEX(k)) {
              j = k;
            }
          }
        }
        var l2;
        if (k.alg != void 0) {
          l2 = k.alg;
        } else {
          if (h != void 0) {
            l2 = h;
          } else {
            throw new d2("hash alg unspecified");
          }
        }
        return c2.crypto.Util.hashHex(j, l2);
      };
      this.tohex = function() {
        var k = this.params;
        var j = this.getCertHash(k, "sha1");
        var h = [];
        h.push(new f2({ hex: j }));
        if (typeof k == "string" && k.indexOf("-----BEGIN") != -1 || k.cert != void 0 && k.hasis != false || k.issuer != void 0 && k.serial != void 0) {
          h.push(new e(k));
        }
        var i = new a({ array: h });
        return i.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (g2 != void 0) {
        this.setByParam(g2);
      }
    };
    extendClass(KJUR.asn1.cms.ESSCertID, KJUR.asn1.ASN1Object);
    KJUR.asn1.cms.SigningCertificateV2 = function(d2) {
      var h = Error, a = KJUR, g2 = a.asn1, e = g2.DERSequence, b = g2.x509, i = g2.cms, c2 = i.ESSCertIDv2, f2 = a.crypto;
      i.SigningCertificateV2.superclass.constructor.call(this);
      this.typeOid = "1.2.840.113549.1.9.16.2.47";
      this.getValueArray = function() {
        if (this.params == null || this.params == void 0 || this.params.array == void 0) {
          throw new h("parameter 'array' not specified");
        }
        var o2 = this.params.array;
        var l2 = [];
        for (var m2 = 0; m2 < o2.length; m2++) {
          var n = o2[m2];
          if ((d2.alg != void 0 || d2.hasis == false) && (typeof n == "string" && (n.indexOf("-----BEGIN") != -1 || ASN1HEX.isASN1HEX(n)))) {
            n = { cert: n };
          }
          if (n.alg == void 0 && d2.alg != void 0) {
            n.alg = d2.alg;
          }
          if (n.hasis != false && d2.hasis == false) {
            n.hasis = false;
          }
          l2.push(new c2(n));
        }
        var k = new e({ array: l2 });
        var j = new e({ array: [k] });
        return [j];
      };
      if (d2 != void 0) {
        this.setByParam(d2);
      }
    };
    extendClass(KJUR.asn1.cms.SigningCertificateV2, KJUR.asn1.cms.Attribute);
    KJUR.asn1.cms.ESSCertIDv2 = function(h) {
      KJUR.asn1.cms.ESSCertIDv2.superclass.constructor.call(this);
      var d2 = Error, c2 = KJUR, b = c2.asn1, f2 = b.DEROctetString, a = b.DERSequence, e = b.cms.IssuerSerial, g2 = b.x509.AlgorithmIdentifier;
      this.params = null;
      this.tohex = function() {
        var l2 = this.params;
        var k = this.getCertHash(l2, "sha256");
        var i = [];
        if (l2.alg != void 0 && l2.alg != "sha256") {
          i.push(new g2({ name: l2.alg }));
        }
        i.push(new f2({ hex: k }));
        if (typeof l2 == "string" && l2.indexOf("-----BEGIN") != -1 || l2.cert != void 0 && l2.hasis != false || l2.issuer != void 0 && l2.serial != void 0) {
          i.push(new e(l2));
        }
        var j = new a({ array: i });
        return j.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (h != void 0) {
        this.setByParam(h);
      }
    };
    extendClass(KJUR.asn1.cms.ESSCertIDv2, KJUR.asn1.cms.ESSCertID);
    KJUR.asn1.cms.IssuerSerial = function(e) {
      var i = Error, c2 = KJUR, h = c2.asn1, g2 = h.DERInteger, f2 = h.DERSequence, j = h.cms, d2 = h.x509, a = d2.GeneralNames, b = X509;
      j.IssuerSerial.superclass.constructor.call(this);
      this.setByParam = function(k) {
        this.params = k;
      };
      this.tohex = function() {
        var p3 = this.params;
        var l2, r;
        if (typeof p3 == "string" && p3.indexOf("-----BEGIN") != -1 || p3.cert != void 0) {
          var n;
          if (p3.cert != void 0) {
            n = p3.cert;
          } else {
            n = p3;
          }
          var k = new b();
          k.readCertPEM(n);
          l2 = k.getIssuer();
          r = { hex: k.getSerialNumberHex() };
        } else {
          if (p3.issuer != void 0 && p3.serial) {
            l2 = p3.issuer;
            r = p3.serial;
          } else {
            throw new i("cert or issuer and serial parameter not specified");
          }
        }
        var q2 = new a([{ dn: l2 }]);
        var o2 = new g2(r);
        var m2 = new f2({ array: [q2, o2] });
        return m2.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (e != void 0) {
        this.setByParam(e);
      }
    };
    extendClass(KJUR.asn1.cms.IssuerSerial, KJUR.asn1.ASN1Object);
    KJUR.asn1.cms.SignerIdentifier = function(f2) {
      var c2 = KJUR, i = c2.asn1, h = i.DERInteger, g2 = i.DERSequence, l2 = i.cms, k = l2.IssuerAndSerialNumber, d2 = l2.SubjectKeyIdentifier, e = i.x509, a = e.X500Name, b = X509, j = Error;
      l2.SignerIdentifier.superclass.constructor.call(this);
      this.params = null;
      this.tohex = function() {
        var o2 = this.params;
        if (o2.type == "isssn") {
          var m2 = new k(o2);
          return m2.tohex();
        } else {
          if (o2.type == "skid") {
            var n = new d2(o2);
            return n.tohex();
          } else {
            throw new Error("wrong property for isssn or skid");
          }
        }
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (f2 != void 0) {
        this.setByParam(f2);
      }
    };
    extendClass(KJUR.asn1.cms.SignerIdentifier, KJUR.asn1.ASN1Object);
    KJUR.asn1.cms.IssuerAndSerialNumber = function(e) {
      var c2 = KJUR, h = c2.asn1, g2 = h.DERInteger, f2 = h.DERSequence, j = h.cms, d2 = h.x509, a = d2.X500Name, b = X509, i = Error;
      j.IssuerAndSerialNumber.superclass.constructor.call(this);
      this.params = null;
      this.tohex = function() {
        var p3 = this.params;
        var l2, r;
        if (typeof p3 == "string" && p3.indexOf("-----BEGIN") != -1 || p3.cert != void 0) {
          var n;
          if (p3.cert != void 0) {
            n = p3.cert;
          } else {
            n = p3;
          }
          var k = new b();
          k.readCertPEM(n);
          l2 = k.getIssuer();
          r = { hex: k.getSerialNumberHex() };
        } else {
          if (p3.issuer != void 0 && p3.serial) {
            l2 = p3.issuer;
            r = p3.serial;
          } else {
            throw new i("cert or issuer and serial parameter not specified");
          }
        }
        var q2 = new a(l2);
        var o2 = new g2(r);
        var m2 = new f2({ array: [q2, o2] });
        return m2.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      this.setByParam = function(k) {
        this.params = k;
      };
      if (e != void 0) {
        this.setByParam(e);
      }
    };
    extendClass(KJUR.asn1.cms.IssuerAndSerialNumber, KJUR.asn1.ASN1Object);
    KJUR.asn1.cms.SubjectKeyIdentifier = function(g2) {
      var d2 = KJUR, k = d2.asn1, i = k.DERInteger, h = k.DERSequence, j = k.ASN1Util.newObject, m2 = k.cms, f2 = m2.IssuerAndSerialName, c2 = m2.SubjectKeyIdentifier, e = k.x509, a = e.X500Name, b = X509, l2 = Error;
      m2.SubjectKeyIdentifier.superclass.constructor.call(this);
      this.tohex = function() {
        var r = this.params;
        if (r.cert == void 0 && r.skid == void 0) {
          throw new l2("property cert nor skid undefined");
        }
        var q2;
        if (r.cert != void 0) {
          var n = new b(r.cert);
          var o2 = n.getExtSubjectKeyIdentifier();
          q2 = o2.kid.hex;
        } else {
          if (r.skid != void 0) {
            q2 = r.skid;
          }
        }
        var p3 = j({ tag: { tage: "a0", obj: { octstr: { hex: q2 } } } });
        return p3.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (g2 != void 0) {
        this.setByParam(g2);
      }
    };
    extendClass(KJUR.asn1.cms.SubjectKeyIdentifier, KJUR.asn1.ASN1Object);
    KJUR.asn1.cms.AttributeList = function(f2) {
      var d2 = Error, c2 = KJUR, b = c2.asn1, a = b.DERSet, e = b.cms;
      e.AttributeList.superclass.constructor.call(this);
      this.params = null;
      this.hTLV = null;
      this.setByParam = function(g2) {
        this.params = g2;
      };
      this.tohex = function() {
        var o2 = this.params;
        if (this.hTLV != null) {
          return this.hTLV;
        }
        var m2 = true;
        if (o2.sortflag != void 0) {
          m2 = o2.sortflag;
        }
        var j = o2.array;
        var g2 = [];
        for (var l2 = 0; l2 < j.length; l2++) {
          var n = j[l2];
          var k = n.attr;
          if (k == "contentType") {
            g2.push(new e.ContentType(n));
          } else {
            if (k == "messageDigest") {
              g2.push(new e.MessageDigest(n));
            } else {
              if (k == "signingTime") {
                g2.push(new e.SigningTime(n));
              } else {
                if (k == "signingCertificate") {
                  g2.push(new e.SigningCertificate(n));
                } else {
                  if (k == "signingCertificateV2") {
                    g2.push(new e.SigningCertificateV2(n));
                  } else {
                    if (k == "signaturePolicyIdentifier") {
                      g2.push(new KJUR.asn1.cades.SignaturePolicyIdentifier(n));
                    } else {
                      if (k == "signatureTimeStamp" || k == "timeStampToken") {
                        g2.push(new KJUR.asn1.cades.SignatureTimeStamp(n));
                      } else {
                        throw new d2("unknown attr: " + k);
                      }
                    }
                  }
                }
              }
            }
          }
        }
        var h = new a({ array: g2, sortflag: m2 });
        this.hTLV = h.tohex();
        return this.hTLV;
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (f2 != void 0) {
        this.setByParam(f2);
      }
    };
    extendClass(KJUR.asn1.cms.AttributeList, KJUR.asn1.ASN1Object);
    KJUR.asn1.cms.SignerInfo = function(q2) {
      var n = Error, r = KJUR, i = r.asn1, c2 = i.DERInteger, f2 = i.DEROctetString, h = i.DERSequence, m2 = i.DERTaggedObject, k = i.cms, p3 = k.SignerIdentifier, l2 = k.AttributeList, g2 = k.ContentType, e = k.EncapsulatedContentInfo, d2 = k.MessageDigest, j = k.SignedData, a = i.x509, s = a.AlgorithmIdentifier, b = r.crypto, o2 = KEYUTIL;
      k.SignerInfo.superclass.constructor.call(this);
      this.params = null;
      this.sign = function() {
        var y = this.params;
        var x2 = y.sigalg;
        var u2 = new l2(y.sattrs).tohex();
        var v = o2.getKey(y.signkey);
        var w = new b.Signature({ alg: x2 });
        w.init(v);
        w.updateHex(u2);
        var t2 = w.sign();
        y.sighex = t2;
      };
      this.tohex = function() {
        var w = this.params;
        var t2 = [];
        t2.push(new c2({ "int": w.version }));
        t2.push(new p3(w.id));
        t2.push(new s({ name: w.hashalg }));
        if (w.sattrs != void 0) {
          var x2 = new l2(w.sattrs);
          try {
            t2.push(new m2({ tag: "a0", explicit: false, obj: x2 }));
          } catch (v) {
            throw new n("si sattr error: " + v);
          }
        }
        if (w.sigalgfield != void 0) {
          t2.push(new s({ name: w.sigalgfield }));
        } else {
          t2.push(new s({ name: w.sigalg }));
        }
        if (w.sighex == void 0 && w.signkey != void 0) {
          this.sign();
        }
        t2.push(new f2({ hex: w.sighex }));
        if (w.uattrs != void 0) {
          var x2 = new l2(w.uattrs);
          try {
            t2.push(new m2({ tag: "a1", explicit: false, obj: x2 }));
          } catch (v) {
            throw new n("si uattr error: " + v);
          }
        }
        var u2 = new h({ array: t2 });
        return u2.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (q2 != void 0) {
        this.setByParam(q2);
      }
    };
    extendClass(KJUR.asn1.cms.SignerInfo, KJUR.asn1.ASN1Object);
    KJUR.asn1.cms.EncapsulatedContentInfo = function(g2) {
      var c2 = KJUR, b = c2.asn1, e = b.DERTaggedObject, a = b.DERSequence, h = b.DERObjectIdentifier, d2 = b.DEROctetString, f2 = b.cms;
      f2.EncapsulatedContentInfo.superclass.constructor.call(this);
      this.params = null;
      this.tohex = function() {
        var m2 = this.params;
        var i = [];
        i.push(new h(m2.type));
        if (m2.content != void 0 && (m2.content.hex != void 0 || m2.content.str != void 0) && m2.isDetached != true) {
          var k = new d2(m2.content);
          var l2 = new e({ tag: "a0", explicit: true, obj: k });
          i.push(l2);
        }
        var j = new a({ array: i });
        return j.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      this.setByParam = function(i) {
        this.params = i;
      };
      if (g2 != void 0) {
        this.setByParam(g2);
      }
    };
    extendClass(KJUR.asn1.cms.EncapsulatedContentInfo, KJUR.asn1.ASN1Object);
    KJUR.asn1.cms.ContentInfo = function(g2) {
      var c2 = KJUR, b = c2.asn1, d2 = b.DERTaggedObject, a = b.DERSequence, h = b.DERObjectIdentifier, f2 = b.x509, e = f2.OID.name2obj;
      KJUR.asn1.cms.ContentInfo.superclass.constructor.call(this);
      this.params = null;
      this.tohex = function() {
        var l2 = this.params;
        var i = [];
        i.push(new h(l2.type));
        var k = new d2({ tag: "a0", explicit: true, obj: l2.obj });
        i.push(k);
        var j = new a({ array: i });
        return j.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      this.setByParam = function(i) {
        this.params = i;
      };
      if (g2 != void 0) {
        this.setByParam(g2);
      }
    };
    extendClass(KJUR.asn1.cms.ContentInfo, KJUR.asn1.ASN1Object);
    KJUR.asn1.cms.SignedData = function(e) {
      var j = Error, a = KJUR, h = a.asn1, m2 = h.ASN1Object, g2 = h.DERInteger, p3 = h.DERSet, f2 = h.DERSequence, b = h.DERTaggedObject, o2 = h.cms, l2 = o2.EncapsulatedContentInfo, d2 = o2.SignerInfo, q2 = o2.ContentInfo, k = o2.CertificateSet, i = o2.RevocationInfoChoices, c2 = h.x509, n = c2.AlgorithmIdentifier;
      KJUR.asn1.cms.SignedData.superclass.constructor.call(this);
      this.params = null;
      this.checkAndFixParam = function() {
        var r = this.params;
        this._setDigestAlgs(r);
        this._setContentTypeByEContent(r);
        this._setMessageDigestByEContent(r);
        this._setSignerInfoVersion(r);
        this._setSignedDataVersion(r);
      };
      this._setDigestAlgs = function(v) {
        var u2 = {};
        var t2 = v.sinfos;
        for (var r = 0; r < t2.length; r++) {
          var s = t2[r];
          u2[s.hashalg] = 1;
        }
        v.hashalgs = Object.keys(u2).sort();
      };
      this._setContentTypeByEContent = function(w) {
        var u2 = w.econtent.type;
        var v = w.sinfos;
        for (var r = 0; r < v.length; r++) {
          var t2 = v[r];
          var s = this._getAttrParamByName(t2, "contentType");
          s.type = u2;
        }
      };
      this._setMessageDigestByEContent = function(r) {
        var v = r.econtent;
        var y = r.econtent.type;
        var x2 = v.content.hex;
        if (x2 == void 0 && v.type == "data" && v.content.str != void 0) {
          x2 = rstrtohex(v.content.str);
        }
        var A = r.sinfos;
        for (var u2 = 0; u2 < A.length; u2++) {
          var t2 = A[u2];
          var s = t2.hashalg;
          var z2 = this._getAttrParamByName(t2, "messageDigest");
          var w = KJUR.crypto.Util.hashHex(x2, s);
          z2.hex = w;
        }
      };
      this._getAttrParamByName = function(t2, s) {
        var u2 = t2.sattrs.array;
        for (var r = 0; r < u2.length; r++) {
          if (u2[r].attr == s) {
            return u2[r];
          }
        }
      };
      this._setSignerInfoVersion = function(v) {
        var t2 = v.sinfos;
        for (var r = 0; r < t2.length; r++) {
          var s = t2[r];
          var u2 = 1;
          if (s.id.type == "skid") {
            u2 = 3;
          }
          s.version = u2;
        }
      };
      this._setSignedDataVersion = function(s) {
        var r = this._getSignedDataVersion(s);
        s.version = r;
      };
      this._getSignedDataVersion = function(w) {
        if (w.revinfos != void 0) {
          var r = w.revinfos;
          for (var t2 = 0; t2 < r.length; t2++) {
            var s = r[t2];
            if (s.ocsp != void 0) {
              return 5;
            }
          }
        }
        var v = w.sinfos;
        for (var t2 = 0; t2 < v.length; t2++) {
          var u2 = w.sinfos[t2];
          if (u2.version == 3) {
            return 3;
          }
        }
        if (w.econtent.type != "data") {
          return 3;
        }
        return 1;
      };
      this.tohex = function() {
        var y = this.params;
        if (this.getEncodedHexPrepare != void 0) {
          this.getEncodedHexPrepare();
        }
        if (y.fixed != true) {
          this.checkAndFixParam();
        }
        var r = [];
        r.push(new g2({ "int": y.version }));
        var w = [];
        for (var v = 0; v < y.hashalgs.length; v++) {
          var t2 = y.hashalgs[v];
          w.push(new n({ name: t2 }));
        }
        r.push(new p3({ array: w }));
        r.push(new l2(y.econtent));
        if (y.certs != void 0) {
          r.push(new k(y.certs));
        }
        if (y.revinfos != void 0) {
          r.push(new i(y.revinfos));
        }
        var u2 = [];
        for (var v = 0; v < y.sinfos.length; v++) {
          var x2 = y.sinfos[v];
          u2.push(new d2(x2));
        }
        r.push(new p3({ array: u2 }));
        var s = new f2({ array: r });
        return s.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      this.getContentInfo = function() {
        var r = new q2({ type: "signed-data", obj: this });
        return r;
      };
      this.getContentInfoEncodedHex = function() {
        return this.getContentInfo().tohex();
      };
      if (e != void 0) {
        this.setByParam(e);
      }
    };
    extendClass(KJUR.asn1.cms.SignedData, KJUR.asn1.ASN1Object);
    KJUR.asn1.cms.CertificateSet = function(f2) {
      KJUR.asn1.cms.CertificateSet.superclass.constructor.call(this);
      var c2 = Error, b = KJUR.asn1, e = b.DERTaggedObject, a = b.DERSet, d2 = b.ASN1Object;
      this.params = null;
      this.tohex = function() {
        var j = this.params;
        var p3 = [];
        var q2;
        if (j instanceof Array) {
          q2 = j;
        } else {
          if (j.array != void 0) {
            q2 = j.array;
          } else {
            throw new c2("cert array not specified");
          }
        }
        for (var k = 0; k < q2.length; k++) {
          var l2 = q2[k];
          var n = pemtohex(l2);
          var g2 = new d2();
          g2.hTLV = n;
          p3.push(g2);
        }
        var m2 = { array: p3 };
        if (j.sortflag == false) {
          m2.sortflag = false;
        }
        var o2 = new a(m2);
        var h = new e({ tag: "a0", explicit: false, obj: o2 });
        return h.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (f2 != void 0) {
        this.setByParam(f2);
      }
    };
    extendClass(KJUR.asn1.cms.CertificateSet, KJUR.asn1.ASN1Object);
    KJUR.asn1.cms.RevocationInfoChoices = function(a) {
      KJUR.asn1.cms.RevocationInfoChoices.superclass.constructor.call(this);
      this.params = null;
      this.tohex = function() {
        var e = this.params;
        if (!e instanceof Array) {
          throw new Error("params is not array");
        }
        var b = [];
        for (var c2 = 0; c2 < e.length; c2++) {
          b.push(new KJUR.asn1.cms.RevocationInfoChoice(e[c2]));
        }
        var d2 = KJUR.asn1.ASN1Util.newObject({ tag: { tagi: "a1", obj: { set: b } } });
        return d2.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (a != void 0) {
        this.setByParam(a);
      }
    };
    extendClass(KJUR.asn1.cms.RevocationInfoChoices, KJUR.asn1.ASN1Object);
    KJUR.asn1.cms.RevocationInfoChoice = function(a) {
      KJUR.asn1.cms.RevocationInfoChoice.superclass.constructor.call(this);
      this.params = null;
      this.tohex = function() {
        var d2 = this.params;
        if (d2.crl != void 0 && typeof d2.crl == "string") {
          var b = d2.crl;
          if (d2.crl.indexOf("-----BEGIN") != -1) {
            b = pemtohex(d2.crl);
          }
          return b;
        } else {
          if (d2.ocsp != void 0) {
            var c2 = KJUR.asn1.ASN1Util.newObject({ tag: { tagi: "a1", obj: new KJUR.asn1.cms.OtherRevocationFormat(d2) } });
            return c2.tohex();
          } else {
            throw new Error("property crl or ocsp undefined");
          }
        }
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (a != void 0) {
        this.setByParam(a);
      }
    };
    extendClass(KJUR.asn1.cms.RevocationInfoChoice, KJUR.asn1.ASN1Object);
    KJUR.asn1.cms.OtherRevocationFormat = function(f2) {
      KJUR.asn1.cms.OtherRevocationFormat.superclass.constructor.call(this);
      var d2 = Error, c2 = KJUR, b = c2.asn1, a = b.ASN1Util.newObject, e = c2.lang.String.isHex;
      this.params = null;
      this.tohex = function() {
        var h = this.params;
        if (h.ocsp == void 0) {
          throw new d2("property ocsp not specified");
        }
        if (!e(h.ocsp) || !ASN1HEX.isASN1HEX(h.ocsp)) {
          throw new d2("ocsp value not ASN.1 hex string");
        }
        var g2 = a({ seq: [{ oid: "1.3.6.1.5.5.7.16.2" }, { asn1: { tlv: h.ocsp } }] });
        return g2.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (f2 != void 0) {
        this.setByParam(f2);
      }
    };
    extendClass(KJUR.asn1.cms.OtherRevocationFormat, KJUR.asn1.ASN1Object);
    KJUR.asn1.cms.CMSUtil = new function() {
    }();
    KJUR.asn1.cms.CMSUtil.newSignedData = function(a) {
      return new KJUR.asn1.cms.SignedData(a);
    };
    KJUR.asn1.cms.CMSUtil.verifySignedData = function(n) {
      var C = KJUR, p3 = C.asn1, s = p3.cms, D = s.SignerInfo, q2 = s.SignedData, y = s.SigningTime, b = s.SigningCertificate, d2 = s.SigningCertificateV2, A = p3.cades, u2 = A.SignaturePolicyIdentifier, i = C.lang.String.isHex, v = ASN1HEX, h = v.getVbyList, a = v.getTLVbyList, t2 = v.getIdxbyList, z2 = v.getChildIdx, c2 = v.getTLV, B = v.oidname, j = C.crypto.Util.hashHex;
      if (n.cms === void 0 && !i(n.cms)) {
      }
      var E = n.cms;
      var g2 = function(J, H) {
        var G;
        for (var I = 3; I < 6; I++) {
          G = t2(J, 0, [1, 0, I]);
          if (G !== void 0) {
            var F = J.substr(G, 2);
            if (F === "a0") {
              H.certsIdx = G;
            }
            if (F === "a1") {
              H.revinfosIdx = G;
            }
            if (F === "31") {
              H.signerinfosIdx = G;
            }
          }
        }
      };
      var l2 = function(I, F) {
        var H = F.signerinfosIdx;
        if (H === void 0) {
          return;
        }
        var L = z2(I, H);
        F.signerInfoIdxList = L;
        for (var G = 0; G < L.length; G++) {
          var K = L[G];
          var J = { idx: K };
          k(I, J);
          F.signerInfos.push(J);
        }
      };
      var k = function(I, J) {
        var F = J.idx;
        J.signerid_issuer1 = a(I, F, [1, 0], "30");
        J.signerid_serial1 = h(I, F, [1, 1], "02");
        J.hashalg = B(h(I, F, [2, 0], "06"));
        var H = t2(I, F, [3], "a0");
        J.idxSignedAttrs = H;
        f2(I, J, H);
        var G = z2(I, F);
        var K = G.length;
        if (K < 6) {
          throw "malformed SignerInfo";
        }
        J.sigalg = B(h(I, F, [K - 2, 0], "06"));
        J.sigval = h(I, F, [K - 1], "04");
      };
      var f2 = function(L, M, F) {
        var J = z2(L, F);
        M.signedAttrIdxList = J;
        for (var K = 0; K < J.length; K++) {
          var I = J[K];
          var G = h(L, I, [0], "06");
          var H;
          if (G === "2a864886f70d010905") {
            H = hextoutf8(h(L, I, [1, 0]));
            M.saSigningTime = H;
          } else {
            if (G === "2a864886f70d010904") {
              H = h(L, I, [1, 0], "04");
              M.saMessageDigest = H;
            }
          }
        }
      };
      var w = function(G, F) {
        if (h(G, 0, [0], "06") !== "2a864886f70d010702") {
          return F;
        }
        F.cmsType = "signedData";
        F.econtent = h(G, 0, [1, 0, 2, 1, 0]);
        g2(G, F);
        F.signerInfos = [];
        l2(G, F);
      };
      var o2 = function(J, F) {
        var G = F.parse.signerInfos;
        var L = G.length;
        var K = true;
        for (var I = 0; I < L; I++) {
          var H = G[I];
          e(J, F, H, I);
          if (!H.isValid) {
            K = false;
          }
        }
        F.isValid = K;
      };
      var x2 = function(F, Q, J, P) {
        var N = Q.parse.certsIdx;
        var H;
        if (Q.certs === void 0) {
          H = [];
          Q.certkeys = [];
          var K = z2(F, N);
          for (var I = 0; I < K.length; I++) {
            var M = c2(F, K[I]);
            var O = new X509();
            O.readCertHex(M);
            H[I] = O;
            Q.certkeys[I] = O.getPublicKey();
          }
          Q.certs = H;
        } else {
          H = Q.certs;
        }
        Q.cccc = H.length;
        Q.cccci = K.length;
        for (var I = 0; I < H.length; I++) {
          var L = O.getIssuerHex();
          var G = O.getSerialNumberHex();
          if (J.signerid_issuer1 === L && J.signerid_serial1 === G) {
            J.certkey_idx = I;
          }
        }
      };
      var e = function(F, R2, I, N) {
        I.verifyDetail = {};
        var Q = I.verifyDetail;
        var K = R2.parse.econtent;
        var G = I.hashalg;
        var L = I.saMessageDigest;
        Q.validMessageDigest = false;
        if (j(K, G) === L) {
          Q.validMessageDigest = true;
        }
        x2(F, R2, I, N);
        Q.validSignatureValue = false;
        var H = I.sigalg;
        var M = "31" + c2(F, I.idxSignedAttrs).substr(2);
        I.signedattrshex = M;
        var J = R2.certs[I.certkey_idx].getPublicKey();
        var P = new KJUR.crypto.Signature({ alg: H });
        P.init(J);
        P.updateHex(M);
        var O = P.verify(I.sigval);
        Q.validSignatureValue_isValid = O;
        if (O === true) {
          Q.validSignatureValue = true;
        }
        I.isValid = false;
        if (Q.validMessageDigest && Q.validSignatureValue) {
          I.isValid = true;
        }
      };
      var m2 = function() {
      };
      var r = { isValid: false, parse: {} };
      w(E, r.parse);
      o2(E, r);
      return r;
    };
    KJUR.asn1.cms.CMSParser = function() {
      var g2 = Error, a = X509, h = new a(), l2 = ASN1HEX, i = l2.getV, b = l2.getTLV, f2 = l2.getIdxbyList, c2 = l2.getTLVbyList, d2 = l2.getTLVbyListEx, e = l2.getVbyList, k = l2.getVbyListEx, j = l2.getChildIdx;
      this.getCMSSignedData = function(m2) {
        var o2 = c2(m2, 0, [1, 0]);
        var n = this.getSignedData(o2);
        return n;
      };
      this.getSignedData = function(o2) {
        var q2 = j(o2, 0);
        var v = {};
        var p3 = i(o2, q2[0]);
        var n = parseInt(p3, 16);
        v.version = n;
        var r = b(o2, q2[1]);
        v.hashalgs = this.getHashAlgArray(r);
        var t2 = b(o2, q2[2]);
        v.econtent = this.getEContent(t2);
        var m2 = d2(o2, 0, ["[0]"]);
        if (m2 != null) {
          v.certs = this.getCertificateSet(m2);
        }
        var u2 = d2(o2, 0, ["[1]"]);
        if (u2 != null) {
        }
        var s = d2(o2, 0, [3]);
        v.sinfos = this.getSignerInfos(s);
        return v;
      };
      this.getHashAlgArray = function(s) {
        var q2 = j(s, 0);
        var m2 = new a();
        var n = [];
        for (var r = 0; r < q2.length; r++) {
          var p3 = b(s, q2[r]);
          var o2 = m2.getAlgorithmIdentifierName(p3);
          n.push(o2);
        }
        return n;
      };
      this.getEContent = function(m2) {
        var n = {};
        var p3 = e(m2, 0, [0]);
        var o2 = e(m2, 0, [1, 0]);
        n.type = KJUR.asn1.x509.OID.oid2name(ASN1HEX.hextooidstr(p3));
        n.content = { hex: o2 };
        return n;
      };
      this.getSignerInfos = function(p3) {
        var r = [];
        var m2 = j(p3, 0);
        for (var n = 0; n < m2.length; n++) {
          var o2 = b(p3, m2[n]);
          var q2 = this.getSignerInfo(o2);
          r.push(q2);
        }
        return r;
      };
      this.getSignerInfo = function(s) {
        var y = {};
        var u2 = j(s, 0);
        var q2 = l2.getInt(s, u2[0], -1);
        if (q2 != -1) {
          y.version = q2;
        }
        var t2 = b(s, u2[1]);
        var p3 = this.getIssuerAndSerialNumber(t2);
        y.id = p3;
        var z2 = b(s, u2[2]);
        var n = h.getAlgorithmIdentifierName(z2);
        y.hashalg = n;
        var w = d2(s, 0, ["[0]"]);
        if (w != null) {
          var A = this.getAttributeList(w);
          y.sattrs = A;
        }
        var m2 = d2(s, 0, [3]);
        var x2 = h.getAlgorithmIdentifierName(m2);
        y.sigalg = x2;
        var o2 = k(s, 0, [4]);
        y.sighex = o2;
        var r = d2(s, 0, ["[1]"]);
        if (r != null) {
          var v = this.getAttributeList(r);
          y.uattrs = v;
        }
        return y;
      };
      this.getSignerIdentifier = function(m2) {
        if (m2.substr(0, 2) == "30") {
          return this.getIssuerAndSerialNumber(m2);
        } else {
          throw new Error("SKID of signerIdentifier not supported");
        }
      };
      this.getIssuerAndSerialNumber = function(n) {
        var o2 = { type: "isssn" };
        var m2 = j(n, 0);
        var p3 = b(n, m2[0]);
        o2.issuer = h.getX500Name(p3);
        var q2 = i(n, m2[1]);
        o2.serial = { hex: q2 };
        return o2;
      };
      this.getAttributeList = function(q2) {
        var m2 = [];
        var n = j(q2, 0);
        for (var o2 = 0; o2 < n.length; o2++) {
          var p3 = b(q2, n[o2]);
          var r = this.getAttribute(p3);
          m2.push(r);
        }
        return { array: m2 };
      };
      this.getAttribute = function(p3) {
        var t2 = {};
        var q2 = j(p3, 0);
        var o2 = l2.getOID(p3, q2[0]);
        var m2 = KJUR.asn1.x509.OID.oid2name(o2);
        t2.attr = m2;
        var r = b(p3, q2[1]);
        var u2 = j(r, 0);
        if (u2.length == 1) {
          t2.valhex = b(r, u2[0]);
        } else {
          var s = [];
          for (var n = 0; n < u2.length; n++) {
            s.push(b(r, u2[n]));
          }
          t2.valhex = s;
        }
        if (m2 == "contentType") {
          this.setContentType(t2);
        } else {
          if (m2 == "messageDigest") {
            this.setMessageDigest(t2);
          } else {
            if (m2 == "signingTime") {
              this.setSigningTime(t2);
            } else {
              if (m2 == "signingCertificate") {
                this.setSigningCertificate(t2);
              } else {
                if (m2 == "signingCertificateV2") {
                  this.setSigningCertificateV2(t2);
                } else {
                  if (m2 == "signaturePolicyIdentifier") {
                    this.setSignaturePolicyIdentifier(t2);
                  }
                }
              }
            }
          }
        }
        return t2;
      };
      this.setContentType = function(m2) {
        var n = l2.getOIDName(m2.valhex, 0, null);
        if (n != null) {
          m2.type = n;
          delete m2.valhex;
        }
      };
      this.setSigningTime = function(o2) {
        var n = i(o2.valhex, 0);
        var m2 = hextoutf8(n);
        o2.str = m2;
        delete o2.valhex;
      };
      this.setMessageDigest = function(m2) {
        var n = i(m2.valhex, 0);
        m2.hex = n;
        delete m2.valhex;
      };
      this.setSigningCertificate = function(n) {
        var q2 = j(n.valhex, 0);
        if (q2.length > 0) {
          var m2 = b(n.valhex, q2[0]);
          var p3 = j(m2, 0);
          var t2 = [];
          for (var o2 = 0; o2 < p3.length; o2++) {
            var s = b(m2, p3[o2]);
            var u2 = this.getESSCertID(s);
            t2.push(u2);
          }
          n.array = t2;
        }
        if (q2.length > 1) {
          var r = b(n.valhex, q2[1]);
          n.polhex = r;
        }
        delete n.valhex;
      };
      this.setSignaturePolicyIdentifier = function(s) {
        var q2 = j(s.valhex, 0);
        if (q2.length > 0) {
          var r = l2.getOID(s.valhex, q2[0]);
          s.oid = r;
        }
        if (q2.length > 1) {
          var m2 = new a();
          var t2 = j(s.valhex, q2[1]);
          var p3 = b(s.valhex, t2[0]);
          var o2 = m2.getAlgorithmIdentifierName(p3);
          s.alg = o2;
          var n = i(s.valhex, t2[1]);
          s.hash = n;
        }
        delete s.valhex;
      };
      this.setSigningCertificateV2 = function(o2) {
        var s = j(o2.valhex, 0);
        if (s.length > 0) {
          var n = b(o2.valhex, s[0]);
          var r = j(n, 0);
          var u2 = [];
          for (var q2 = 0; q2 < r.length; q2++) {
            var m2 = b(n, r[q2]);
            var p3 = this.getESSCertIDv2(m2);
            u2.push(p3);
          }
          o2.array = u2;
        }
        if (s.length > 1) {
          var t2 = b(o2.valhex, s[1]);
          o2.polhex = t2;
        }
        delete o2.valhex;
      };
      this.getESSCertID = function(o2) {
        var p3 = {};
        var n = j(o2, 0);
        if (n.length > 0) {
          var q2 = i(o2, n[0]);
          p3.hash = q2;
        }
        if (n.length > 1) {
          var m2 = b(o2, n[1]);
          var r = this.getIssuerSerial(m2);
          if (r.serial != void 0) {
            p3.serial = r.serial;
          }
          if (r.issuer != void 0) {
            p3.issuer = r.issuer;
          }
        }
        return p3;
      };
      this.getESSCertIDv2 = function(q2) {
        var s = {};
        var p3 = j(q2, 0);
        if (p3.length < 1 || 3 < p3.length) {
          throw new g2("wrong number of elements");
        }
        var r = 0;
        if (q2.substr(p3[0], 2) == "30") {
          var o2 = b(q2, p3[0]);
          s.alg = h.getAlgorithmIdentifierName(o2);
          r++;
        } else {
          s.alg = "sha256";
        }
        var n = i(q2, p3[r]);
        s.hash = n;
        if (p3.length > r + 1) {
          var m2 = b(q2, p3[r + 1]);
          var t2 = this.getIssuerSerial(m2);
          s.issuer = t2.issuer;
          s.serial = t2.serial;
        }
        return s;
      };
      this.getIssuerSerial = function(q2) {
        var r = {};
        var n = j(q2, 0);
        var m2 = b(q2, n[0]);
        var p3 = h.getGeneralNames(m2);
        var o2 = p3[0].dn;
        r.issuer = o2;
        var s = i(q2, n[1]);
        r.serial = { hex: s };
        return r;
      };
      this.getCertificateSet = function(p3) {
        var n = j(p3, 0);
        var m2 = [];
        for (var o2 = 0; o2 < n.length; o2++) {
          var r = b(p3, n[o2]);
          if (r.substr(0, 2) == "30") {
            var q2 = hextopem(r, "CERTIFICATE");
            m2.push(q2);
          }
        }
        return { array: m2, sortflag: false };
      };
    };
    if (typeof KJUR == "undefined" || !KJUR) {
      KJUR = {};
    }
    if (typeof KJUR.asn1 == "undefined" || !KJUR.asn1) {
      KJUR.asn1 = {};
    }
    if (typeof KJUR.asn1.tsp == "undefined" || !KJUR.asn1.tsp) {
      KJUR.asn1.tsp = {};
    }
    KJUR.asn1.tsp.TimeStampToken = function(d2) {
      var c2 = KJUR, b = c2.asn1, a = b.tsp;
      a.TimeStampToken.superclass.constructor.call(this);
      this.params = null;
      this.getEncodedHexPrepare = function() {
        var e = new a.TSTInfo(this.params.econtent.content);
        this.params.econtent.content.hex = e.tohex();
      };
      if (d2 != void 0) {
        this.setByParam(d2);
      }
    };
    extendClass(KJUR.asn1.tsp.TimeStampToken, KJUR.asn1.cms.SignedData);
    KJUR.asn1.tsp.TSTInfo = function(f2) {
      var m2 = Error, c2 = KJUR, j = c2.asn1, g2 = j.DERSequence, i = j.DERInteger, l2 = j.DERBoolean, h = j.DERGeneralizedTime, n = j.DERObjectIdentifier, e = j.DERTaggedObject, k = j.tsp, d2 = k.MessageImprint, b = k.Accuracy, a = j.x509.X500Name, o2 = j.x509.GeneralName;
      k.TSTInfo.superclass.constructor.call(this);
      this.dVersion = new i({ "int": 1 });
      this.dPolicy = null;
      this.dMessageImprint = null;
      this.dSerial = null;
      this.dGenTime = null;
      this.dAccuracy = null;
      this.dOrdering = null;
      this.dNonce = null;
      this.dTsa = null;
      this.tohex = function() {
        var p3 = [this.dVersion];
        if (this.dPolicy == null) {
          throw new Error("policy shall be specified.");
        }
        p3.push(this.dPolicy);
        if (this.dMessageImprint == null) {
          throw new Error("messageImprint shall be specified.");
        }
        p3.push(this.dMessageImprint);
        if (this.dSerial == null) {
          throw new Error("serialNumber shall be specified.");
        }
        p3.push(this.dSerial);
        if (this.dGenTime == null) {
          throw new Error("genTime shall be specified.");
        }
        p3.push(this.dGenTime);
        if (this.dAccuracy != null) {
          p3.push(this.dAccuracy);
        }
        if (this.dOrdering != null) {
          p3.push(this.dOrdering);
        }
        if (this.dNonce != null) {
          p3.push(this.dNonce);
        }
        if (this.dTsa != null) {
          p3.push(this.dTsa);
        }
        var q2 = new g2({ array: p3 });
        this.hTLV = q2.tohex();
        return this.hTLV;
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (f2 !== void 0) {
        if (typeof f2.policy == "string") {
          if (!f2.policy.match(/^[0-9.]+$/)) {
            throw "policy shall be oid like 0.1.4.134";
          }
          this.dPolicy = new n({ oid: f2.policy });
        }
        if (f2.messageImprint !== void 0) {
          this.dMessageImprint = new d2(f2.messageImprint);
        }
        if (f2.serial !== void 0) {
          this.dSerial = new i(f2.serial);
        }
        if (f2.genTime !== void 0) {
          this.dGenTime = new h(f2.genTime);
        }
        if (f2.accuracy !== void 0) {
          this.dAccuracy = new b(f2.accuracy);
        }
        if (f2.ordering !== void 0 && f2.ordering == true) {
          this.dOrdering = new l2();
        }
        if (f2.nonce !== void 0) {
          this.dNonce = new i(f2.nonce);
        }
        if (f2.tsa !== void 0) {
          this.dTsa = new e({ tag: "a0", explicit: true, obj: new o2({ dn: f2.tsa }) });
        }
      }
    };
    extendClass(KJUR.asn1.tsp.TSTInfo, KJUR.asn1.ASN1Object);
    KJUR.asn1.tsp.Accuracy = function(d2) {
      var c2 = KJUR, b = c2.asn1, a = b.ASN1Util.newObject;
      b.tsp.Accuracy.superclass.constructor.call(this);
      this.params = null;
      this.tohex = function() {
        var f2 = this.params;
        var e = [];
        if (f2.seconds != void 0 && typeof f2.seconds == "number") {
          e.push({ "int": f2.seconds });
        }
        if (f2.millis != void 0 && typeof f2.millis == "number") {
          e.push({ tag: { tagi: "80", obj: { "int": f2.millis } } });
        }
        if (f2.micros != void 0 && typeof f2.micros == "number") {
          e.push({ tag: { tagi: "81", obj: { "int": f2.micros } } });
        }
        return a({ seq: e }).tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (d2 != void 0) {
        this.setByParam(d2);
      }
    };
    extendClass(KJUR.asn1.tsp.Accuracy, KJUR.asn1.ASN1Object);
    KJUR.asn1.tsp.MessageImprint = function(g2) {
      var c2 = KJUR, b = c2.asn1, a = b.DERSequence, d2 = b.DEROctetString, f2 = b.x509, e = f2.AlgorithmIdentifier;
      b.tsp.MessageImprint.superclass.constructor.call(this);
      this.params = null;
      this.tohex = function() {
        var k = this.params;
        var j = new e({ name: k.alg });
        var h = new d2({ hex: k.hash });
        var i = new a({ array: [j, h] });
        return i.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (g2 !== void 0) {
        this.setByParam(g2);
      }
    };
    extendClass(KJUR.asn1.tsp.MessageImprint, KJUR.asn1.ASN1Object);
    KJUR.asn1.tsp.TimeStampReq = function(c2) {
      var a = KJUR, f2 = a.asn1, d2 = f2.DERSequence, e = f2.DERInteger, h = f2.DERBoolean, j = f2.ASN1Object, i = f2.DERObjectIdentifier, g2 = f2.tsp, b = g2.MessageImprint;
      g2.TimeStampReq.superclass.constructor.call(this);
      this.params = null;
      this.tohex = function() {
        var m2 = this.params;
        var k = [];
        k.push(new e({ "int": 1 }));
        if (m2.messageImprint instanceof KJUR.asn1.ASN1Object) {
          k.push(m2.messageImprint);
        } else {
          k.push(new b(m2.messageImprint));
        }
        if (m2.policy != void 0) {
          k.push(new i(m2.policy));
        }
        if (m2.nonce != void 0) {
          k.push(new e(m2.nonce));
        }
        if (m2.certreq == true) {
          k.push(new h());
        }
        var l2 = new d2({ array: k });
        return l2.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (c2 != void 0) {
        this.setByParam(c2);
      }
    };
    extendClass(KJUR.asn1.tsp.TimeStampReq, KJUR.asn1.ASN1Object);
    KJUR.asn1.tsp.TimeStampResp = function(g2) {
      var e = KJUR, d2 = e.asn1, c2 = d2.DERSequence, f2 = d2.ASN1Object, a = d2.tsp, b = a.PKIStatusInfo;
      a.TimeStampResp.superclass.constructor.call(this);
      this.params = null;
      this.tohex = function() {
        var j = this.params;
        var h = [];
        if (j.econtent != void 0 || j.tst != void 0) {
          if (j.statusinfo != void 0) {
            h.push(new b(j.statusinfo));
          } else {
            h.push(new b("granted"));
          }
          if (j.econtent != void 0) {
            h.push(new a.TimeStampToken(j).getContentInfo());
          } else {
            if (j.tst instanceof d2.ASN1Object) {
              h.push(j.tst);
            } else {
              throw new Error("improper member tst value");
            }
          }
        } else {
          if (j.statusinfo != void 0) {
            h.push(new b(j.statusinfo));
          } else {
            throw new Error("parameter for token nor statusinfo not specified");
          }
        }
        var i = new c2({ array: h });
        return i.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (g2 != void 0) {
        this.setByParam(g2);
      }
    };
    extendClass(KJUR.asn1.tsp.TimeStampResp, KJUR.asn1.ASN1Object);
    KJUR.asn1.tsp.PKIStatusInfo = function(d2) {
      var h = Error, a = KJUR, g2 = a.asn1, e = g2.DERSequence, i = g2.tsp, f2 = i.PKIStatus, c2 = i.PKIFreeText, b = i.PKIFailureInfo;
      i.PKIStatusInfo.superclass.constructor.call(this);
      this.params = null;
      this.tohex = function() {
        var l2 = this.params;
        var j = [];
        if (typeof l2 == "string") {
          j.push(new f2(l2));
        } else {
          if (l2.status == void 0) {
            throw new h("property 'status' unspecified");
          }
          j.push(new f2(l2.status));
          if (l2.statusstr != void 0) {
            j.push(new c2(l2.statusstr));
          }
          if (l2.failinfo != void 0) {
            j.push(new b(l2.failinfo));
          }
        }
        var k = new e({ array: j });
        return k.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (d2 != void 0) {
        this.setByParam(d2);
      }
    };
    extendClass(KJUR.asn1.tsp.PKIStatusInfo, KJUR.asn1.ASN1Object);
    KJUR.asn1.tsp.PKIStatus = function(g2) {
      var e = Error, d2 = KJUR, c2 = d2.asn1, f2 = c2.DERInteger, b = c2.tsp;
      b.PKIStatus.superclass.constructor.call(this);
      var a = { granted: 0, grantedWithMods: 1, rejection: 2, waiting: 3, revocationWarning: 4, revocationNotification: 5 };
      this.params = null;
      this.tohex = function() {
        var k = this.params;
        var h, j;
        if (typeof k == "string") {
          try {
            j = a[k];
          } catch (i) {
            throw new e("undefined name: " + k);
          }
        } else {
          if (typeof k == "number") {
            j = k;
          } else {
            throw new e("unsupported params");
          }
        }
        return new f2({ "int": j }).tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (g2 != void 0) {
        this.setByParam(g2);
      }
    };
    extendClass(KJUR.asn1.tsp.PKIStatus, KJUR.asn1.ASN1Object);
    KJUR.asn1.tsp.PKIFreeText = function(g2) {
      var f2 = Error, e = KJUR, d2 = e.asn1, b = d2.DERSequence, c2 = d2.DERUTF8String, a = d2.tsp;
      a.PKIFreeText.superclass.constructor.call(this);
      this.params = null;
      this.tohex = function() {
        var l2 = this.params;
        if (!l2 instanceof Array) {
          throw new f2("wrong params: not array");
        }
        var h = [];
        for (var k = 0; k < l2.length; k++) {
          h.push(new c2({ str: l2[k] }));
        }
        var j = new b({ array: h });
        return j.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (g2 != void 0) {
        this.setByParam(g2);
      }
    };
    extendClass(KJUR.asn1.tsp.PKIFreeText, KJUR.asn1.ASN1Object);
    KJUR.asn1.tsp.PKIFailureInfo = function(h) {
      var f2 = Error, e = KJUR, d2 = e.asn1, g2 = d2.DERBitString, b = d2.tsp, c2 = b.PKIFailureInfo;
      var a = { badAlg: 0, badRequest: 2, badDataFormat: 5, timeNotAvailable: 14, unacceptedPolicy: 15, unacceptedExtension: 16, addInfoNotAvailable: 17, systemFailure: 25 };
      c2.superclass.constructor.call(this);
      this.params = null;
      this.getBinValue = function() {
        var n = this.params;
        var m2 = 0;
        if (typeof n == "number" && 0 <= n && n <= 25) {
          m2 |= 1 << n;
          var k = m2.toString(2);
          var l2 = "";
          for (var j = k.length - 1; j >= 0; j--) {
            l2 += k[j];
          }
          return l2;
        } else {
          if (typeof n == "string" && a[n] != void 0) {
            return namearraytobinstr([n], a);
          } else {
            if (typeof n == "object" && n.length != void 0) {
              return namearraytobinstr(n, a);
            } else {
              throw new f2("wrong params");
            }
          }
        }
        return;
      };
      this.tohex = function() {
        var j = this.params;
        var i = this.getBinValue();
        return new g2({ bin: i }).tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (h != void 0) {
        this.setByParam(h);
      }
    };
    extendClass(KJUR.asn1.tsp.PKIFailureInfo, KJUR.asn1.ASN1Object);
    KJUR.asn1.tsp.AbstractTSAAdapter = function(a) {
      this.getTSTHex = function(c2, b) {
        throw "not implemented yet";
      };
    };
    KJUR.asn1.tsp.SimpleTSAAdapter = function(e) {
      var d2 = KJUR, c2 = d2.asn1, a = c2.tsp, b = d2.crypto.Util.hashHex;
      a.SimpleTSAAdapter.superclass.constructor.call(this);
      this.params = null;
      this.serial = 0;
      this.getTSTHex = function(g2, f2) {
        var i = b(g2, f2);
        this.params.econtent.content.messageImprint = { alg: f2, hash: i };
        this.params.econtent.content.serial = { "int": this.serial++ };
        var h = Math.floor(Math.random() * 1e9);
        this.params.econtent.content.nonce = { "int": h };
        var j = new a.TimeStampToken(this.params);
        return j.getContentInfoEncodedHex();
      };
      if (e !== void 0) {
        this.params = e;
      }
    };
    extendClass(KJUR.asn1.tsp.SimpleTSAAdapter, KJUR.asn1.tsp.AbstractTSAAdapter);
    KJUR.asn1.tsp.FixedTSAAdapter = function(e) {
      var d2 = KJUR, c2 = d2.asn1, a = c2.tsp, b = d2.crypto.Util.hashHex;
      a.FixedTSAAdapter.superclass.constructor.call(this);
      this.params = null;
      this.getTSTHex = function(g2, f2) {
        var h = b(g2, f2);
        this.params.econtent.content.messageImprint = { alg: f2, hash: h };
        var i = new a.TimeStampToken(this.params);
        return i.getContentInfoEncodedHex();
      };
      if (e !== void 0) {
        this.params = e;
      }
    };
    extendClass(KJUR.asn1.tsp.FixedTSAAdapter, KJUR.asn1.tsp.AbstractTSAAdapter);
    KJUR.asn1.tsp.TSPUtil = new function() {
    }();
    KJUR.asn1.tsp.TSPUtil.newTimeStampToken = function(a) {
      return new KJUR.asn1.tsp.TimeStampToken(a);
    };
    KJUR.asn1.tsp.TSPUtil.parseTimeStampReq = function(a) {
      var b = new KJUR.asn1.tsp.TSPParser();
      return b.getTimeStampReq(a);
    };
    KJUR.asn1.tsp.TSPUtil.parseMessageImprint = function(a) {
      var b = new KJUR.asn1.tsp.TSPParser();
      return b.getMessageImprint(a);
    };
    KJUR.asn1.tsp.TSPParser = function() {
      var e = Error, a = X509, f2 = new a(), k = ASN1HEX, g2 = k.getV, b = k.getTLV, d2 = k.getIdxbyList, c2 = k.getTLVbyListEx, i = k.getChildIdx;
      var j = ["granted", "grantedWithMods", "rejection", "waiting", "revocationWarning", "revocationNotification"];
      var h = { 0: "badAlg", 2: "badRequest", 5: "badDataFormat", 14: "timeNotAvailable", 15: "unacceptedPolicy", 16: "unacceptedExtension", 17: "addInfoNotAvailable", 25: "systemFailure" };
      this.getResponse = function(n) {
        var l2 = i(n, 0);
        if (l2.length == 1) {
          return this.getPKIStatusInfo(b(n, l2[0]));
        } else {
          if (l2.length > 1) {
            var o2 = this.getPKIStatusInfo(b(n, l2[0]));
            var m2 = b(n, l2[1]);
            var p3 = this.getToken(m2);
            p3.statusinfo = o2;
            return p3;
          }
        }
      };
      this.getToken = function(m2) {
        var l2 = new KJUR.asn1.cms.CMSParser();
        var n = l2.getCMSSignedData(m2);
        this.setTSTInfo(n);
        return n;
      };
      this.setTSTInfo = function(l2) {
        var o2 = l2.econtent;
        if (o2.type == "tstinfo") {
          var n = o2.content.hex;
          var m2 = this.getTSTInfo(n);
          o2.content = m2;
        }
      };
      this.getTSTInfo = function(r) {
        var x2 = {};
        var s = i(r, 0);
        var p3 = g2(r, s[1]);
        x2.policy = hextooid(p3);
        var o2 = b(r, s[2]);
        x2.messageImprint = this.getMessageImprint(o2);
        var u2 = g2(r, s[3]);
        x2.serial = { hex: u2 };
        var y = g2(r, s[4]);
        x2.genTime = { str: hextoutf8(y) };
        var q2 = 0;
        if (s.length > 5 && r.substr(s[5], 2) == "30") {
          var v = b(r, s[5]);
          x2.accuracy = this.getAccuracy(v);
          q2++;
        }
        if (s.length > 5 + q2 && r.substr(s[5 + q2], 2) == "01") {
          var z2 = g2(r, s[5 + q2]);
          if (z2 == "ff") {
            x2.ordering = true;
          }
          q2++;
        }
        if (s.length > 5 + q2 && r.substr(s[5 + q2], 2) == "02") {
          var n = g2(r, s[5 + q2]);
          x2.nonce = { hex: n };
          q2++;
        }
        if (s.length > 5 + q2 && r.substr(s[5 + q2], 2) == "a0") {
          var m2 = b(r, s[5 + q2]);
          m2 = "30" + m2.substr(2);
          pGeneralNames = f2.getGeneralNames(m2);
          var t2 = pGeneralNames[0].dn;
          x2.tsa = t2;
          q2++;
        }
        if (s.length > 5 + q2 && r.substr(s[5 + q2], 2) == "a1") {
          var l2 = b(r, s[5 + q2]);
          l2 = "30" + l2.substr(2);
          var w = f2.getExtParamArray(l2);
          x2.ext = w;
          q2++;
        }
        return x2;
      };
      this.getAccuracy = function(q2) {
        var r = {};
        var o2 = i(q2, 0);
        for (var p3 = 0; p3 < o2.length; p3++) {
          var m2 = q2.substr(o2[p3], 2);
          var l2 = g2(q2, o2[p3]);
          var n = parseInt(l2, 16);
          if (m2 == "02") {
            r.seconds = n;
          } else {
            if (m2 == "80") {
              r.millis = n;
            } else {
              if (m2 == "81") {
                r.micros = n;
              }
            }
          }
        }
        return r;
      };
      this.getMessageImprint = function(n) {
        if (n.substr(0, 2) != "30") {
          throw new Error("head of messageImprint hex shall be x30");
        }
        var s = {};
        var l2 = i(n, 0);
        var t2 = d2(n, 0, [0, 0]);
        var o2 = g2(n, t2);
        var p3 = k.hextooidstr(o2);
        var r = KJUR.asn1.x509.OID.oid2name(p3);
        if (r == "") {
          throw new Error("hashAlg name undefined: " + p3);
        }
        var m2 = r;
        var q2 = d2(n, 0, [1]);
        s.alg = m2;
        s.hash = g2(n, q2);
        return s;
      };
      this.getPKIStatusInfo = function(o2) {
        var t2 = {};
        var r = i(o2, 0);
        var n = 0;
        try {
          var l2 = g2(o2, r[0]);
          var p3 = parseInt(l2, 16);
          t2.status = j[p3];
        } catch (s) {
        }
        if (r.length > 1 && o2.substr(r[1], 2) == "30") {
          var m2 = b(o2, r[1]);
          t2.statusstr = this.getPKIFreeText(m2);
          n++;
        }
        if (r.length > n && o2.substr(r[1 + n], 2) == "03") {
          var q2 = b(o2, r[1 + n]);
          t2.failinfo = this.getPKIFailureInfo(q2);
        }
        return t2;
      };
      this.getPKIFreeText = function(n) {
        var o2 = [];
        var l2 = i(n, 0);
        for (var m2 = 0; m2 < l2.length; m2++) {
          o2.push(k.getString(n, l2[m2]));
        }
        return o2;
      };
      this.getPKIFailureInfo = function(l2) {
        var m2 = k.getInt(l2, 0);
        if (h[m2] != void 0) {
          return h[m2];
        } else {
          return m2;
        }
      };
      this.getTimeStampReq = function(q2) {
        var p3 = {};
        p3.certreq = false;
        var s = i(q2, 0);
        if (s.length < 2) {
          throw new Error("TimeStampReq must have at least 2 items");
        }
        var n = b(q2, s[1]);
        p3.messageImprint = KJUR.asn1.tsp.TSPUtil.parseMessageImprint(n);
        for (var o2 = 2; o2 < s.length; o2++) {
          var m2 = s[o2];
          var l2 = q2.substr(m2, 2);
          if (l2 == "06") {
            var r = g2(q2, m2);
            p3.policy = k.hextooidstr(r);
          }
          if (l2 == "02") {
            p3.nonce = g2(q2, m2);
          }
          if (l2 == "01") {
            p3.certreq = true;
          }
        }
        return p3;
      };
    };
    if (typeof KJUR == "undefined" || !KJUR) {
      KJUR = {};
    }
    if (typeof KJUR.asn1 == "undefined" || !KJUR.asn1) {
      KJUR.asn1 = {};
    }
    if (typeof KJUR.asn1.cades == "undefined" || !KJUR.asn1.cades) {
      KJUR.asn1.cades = {};
    }
    KJUR.asn1.cades.SignaturePolicyIdentifier = function(e) {
      var c2 = KJUR, b = c2.asn1, a = b.cades, d2 = a.SignaturePolicyId;
      a.SignaturePolicyIdentifier.superclass.constructor.call(this);
      this.typeOid = "1.2.840.113549.1.9.16.2.15";
      this.params = null;
      this.getValueArray = function() {
        return [new d2(this.params)];
      };
      this.setByParam = function(f2) {
        this.params = f2;
      };
      if (e != void 0) {
        this.setByParam(e);
      }
    };
    extendClass(KJUR.asn1.cades.SignaturePolicyIdentifier, KJUR.asn1.cms.Attribute);
    KJUR.asn1.cades.SignaturePolicyId = function(e) {
      var a = KJUR, g2 = a.asn1, f2 = g2.DERSequence, i = g2.DERObjectIdentifier, d2 = g2.x509, j = d2.AlgorithmIdentifier, c2 = g2.cades, h = c2.SignaturePolicyId, b = c2.OtherHashAlgAndValue;
      h.superclass.constructor.call(this);
      this.params = null;
      this.tohex = function() {
        var m2 = this.params;
        var k = [];
        k.push(new i(m2.oid));
        k.push(new b(m2));
        var l2 = new f2({ array: k });
        return l2.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      this.setByParam = function(k) {
        this.params = k;
      };
      if (e != void 0) {
        this.setByParam(e);
      }
    };
    extendClass(KJUR.asn1.cades.SignaturePolicyId, KJUR.asn1.ASN1Object);
    KJUR.asn1.cades.OtherHashAlgAndValue = function(e) {
      var h = Error, a = KJUR, g2 = a.asn1, f2 = g2.DERSequence, i = g2.DEROctetString, d2 = g2.x509, j = d2.AlgorithmIdentifier, c2 = g2.cades, b = c2.OtherHashAlgAndValue;
      b.superclass.constructor.call(this);
      this.params = null;
      this.tohex = function() {
        var o2 = this.params;
        if (o2.alg == void 0) {
          throw new h("property 'alg' not specified");
        }
        if (o2.hash == void 0 && o2.cert == void 0) {
          throw new h("property 'hash' nor 'cert' not specified");
        }
        var m2 = null;
        if (o2.hash != void 0) {
          m2 = o2.hash;
        } else {
          if (o2.cert != void 0) {
            if (typeof o2.cert != "string") {
              throw new h("cert not string");
            }
            var n = o2.cert;
            if (o2.cert.indexOf("-----BEGIN") != -1) {
              n = pemtohex(o2.cert);
            }
            m2 = KJUR.crypto.Util.hashHex(n, o2.alg);
          }
        }
        var k = [];
        k.push(new j({ name: o2.alg }));
        k.push(new i({ hex: m2 }));
        var l2 = new f2({ array: k });
        return l2.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (e != void 0) {
        this.setByParam(e);
      }
    };
    extendClass(KJUR.asn1.cades.OtherHashAlgAndValue, KJUR.asn1.ASN1Object);
    KJUR.asn1.cades.OtherHashValue = function(g2) {
      KJUR.asn1.cades.OtherHashValue.superclass.constructor.call(this);
      var d2 = Error, c2 = KJUR, f2 = c2.lang.String.isHex, b = c2.asn1, e = b.DEROctetString, a = c2.crypto.Util.hashHex;
      this.params = null;
      this.tohex = function() {
        var j = this.params;
        if (j.hash == void 0 && j.cert == void 0) {
          throw new d2("hash or cert not specified");
        }
        var h = null;
        if (j.hash != void 0) {
          h = j.hash;
        } else {
          if (j.cert != void 0) {
            if (typeof j.cert != "string") {
              throw new d2("cert not string");
            }
            var i = j.cert;
            if (j.cert.indexOf("-----BEGIN") != -1) {
              i = pemtohex(j.cert);
            }
            h = KJUR.crypto.Util.hashHex(i, "sha1");
          }
        }
        return new e({ hex: h }).tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (g2 != void 0) {
        this.setByParam(g2);
      }
    };
    extendClass(KJUR.asn1.cades.OtherHashValue, KJUR.asn1.ASN1Object);
    KJUR.asn1.cades.SignatureTimeStamp = function(h) {
      var d2 = Error, c2 = KJUR, f2 = c2.lang.String.isHex, b = c2.asn1, e = b.ASN1Object, g2 = b.x509, a = b.cades;
      a.SignatureTimeStamp.superclass.constructor.call(this);
      this.typeOid = "1.2.840.113549.1.9.16.2.14";
      this.params = null;
      this.getValueArray = function() {
        var l2 = this.params;
        if (l2.tst != void 0) {
          if (f2(l2.tst)) {
            var j = new e();
            j.hTLV = l2.tst;
            return [j];
          } else {
            if (l2.tst instanceof e) {
              return [l2.tst];
            } else {
              throw new d2("params.tst has wrong value");
            }
          }
        } else {
          if (l2.res != void 0) {
            var k = l2.res;
            if (k instanceof e) {
              k = k.tohex();
            }
            if (typeof k != "string" || !f2(k)) {
              throw new d2("params.res has wrong value");
            }
            var i = ASN1HEX.getTLVbyList(k, 0, [1]);
            var j = new e();
            j.hTLV = l2.tst;
            return [j];
          }
        }
      };
      if (h != null) {
        this.setByParam(h);
      }
    };
    extendClass(KJUR.asn1.cades.SignatureTimeStamp, KJUR.asn1.cms.Attribute);
    KJUR.asn1.cades.CompleteCertificateRefs = function(h) {
      var f2 = Error, e = KJUR, d2 = e.asn1, b = d2.DERSequence, c2 = d2.cades, a = c2.OtherCertID, g2 = e.lang.String.isHex;
      c2.CompleteCertificateRefs.superclass.constructor.call(this);
      this.typeOid = "1.2.840.113549.1.9.16.2.21";
      this.params = null;
      this.getValueArray = function() {
        var o2 = this.params;
        var k = [];
        for (var m2 = 0; m2 < o2.array.length; m2++) {
          var n = o2.array[m2];
          if (typeof n == "string") {
            if (n.indexOf("-----BEGIN") != -1) {
              n = { cert: n };
            } else {
              if (g2(n)) {
                n = { hash: n };
              } else {
                throw new f2("unsupported value: " + n);
              }
            }
          }
          if (o2.alg != void 0 && n.alg == void 0) {
            n.alg = o2.alg;
          }
          if (o2.hasis != void 0 && n.hasis == void 0) {
            n.hasis = o2.hasis;
          }
          var j = new a(n);
          k.push(j);
        }
        var l2 = new b({ array: k });
        return [l2];
      };
      if (h != void 0) {
        this.setByParam(h);
      }
    };
    extendClass(KJUR.asn1.cades.CompleteCertificateRefs, KJUR.asn1.cms.Attribute);
    KJUR.asn1.cades.OtherCertID = function(e) {
      var a = KJUR, h = a.asn1, f2 = h.DERSequence, i = h.cms, g2 = i.IssuerSerial, c2 = h.cades, d2 = c2.OtherHashValue, b = c2.OtherHashAlgAndValue;
      c2.OtherCertID.superclass.constructor.call(this);
      this.params = e;
      this.tohex = function() {
        var n = this.params;
        if (typeof n == "string") {
          if (n.indexOf("-----BEGIN") != -1) {
            n = { cert: n };
          } else {
            if (_isHex(n)) {
              n = { hash: n };
            }
          }
        }
        var j = [];
        var m2 = null;
        if (n.alg != void 0) {
          m2 = new b(n);
        } else {
          m2 = new d2(n);
        }
        j.push(m2);
        if (n.cert != void 0 && n.hasis == true || n.issuer != void 0 && n.serial != void 0) {
          var l2 = new g2(n);
          j.push(l2);
        }
        var k = new f2({ array: j });
        return k.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (e != void 0) {
        this.setByParam(e);
      }
    };
    extendClass(KJUR.asn1.cades.OtherCertID, KJUR.asn1.ASN1Object);
    KJUR.asn1.cades.OtherHash = function(g2) {
      var i = Error, a = KJUR, h = a.asn1, j = h.cms, c2 = h.cades, b = c2.OtherHashAlgAndValue, e = c2.OtherHashValue, d2 = a.crypto.Util.hashHex, f2 = a.lang.String.isHex;
      c2.OtherHash.superclass.constructor.call(this);
      this.params = null;
      this.tohex = function() {
        var l2 = this.params;
        if (typeof l2 == "string") {
          if (l2.indexOf("-----BEGIN") != -1) {
            l2 = { cert: l2 };
          } else {
            if (f2(l2)) {
              l2 = { hash: l2 };
            }
          }
        }
        var k = null;
        if (l2.alg != void 0) {
          k = new b(l2);
        } else {
          k = new e(l2);
        }
        return k.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (g2 != void 0) {
        this.setByParam(g2);
      }
    };
    extendClass(KJUR.asn1.cades.OtherHash, KJUR.asn1.ASN1Object);
    KJUR.asn1.cades.CAdESUtil = new function() {
    }();
    KJUR.asn1.cades.CAdESUtil.parseSignedDataForAddingUnsigned = function(a) {
      var c2 = new KJUR.asn1.cms.CMSParser();
      var b = c2.getCMSSignedData(a);
      return b;
    };
    KJUR.asn1.cades.CAdESUtil.parseSignerInfoForAddingUnsigned = function(g2, q2, c2) {
      var p3 = ASN1HEX, s = p3.getChildIdx, a = p3.getTLV, l2 = p3.getV, v = KJUR, h = v.asn1, n = h.ASN1Object, j = h.cms, k = j.AttributeList, w = j.SignerInfo;
      var o2 = {};
      var t2 = s(g2, q2);
      if (t2.length != 6) {
        throw "not supported items for SignerInfo (!=6)";
      }
      var d2 = t2.shift();
      o2.version = a(g2, d2);
      var e = t2.shift();
      o2.si = a(g2, e);
      var m2 = t2.shift();
      o2.digalg = a(g2, m2);
      var f2 = t2.shift();
      o2.sattrs = a(g2, f2);
      var i = t2.shift();
      o2.sigalg = a(g2, i);
      var b = t2.shift();
      o2.sig = a(g2, b);
      o2.sigval = l2(g2, b);
      var u2 = null;
      o2.obj = new w();
      u2 = new n();
      u2.hTLV = o2.version;
      o2.obj.dCMSVersion = u2;
      u2 = new n();
      u2.hTLV = o2.si;
      o2.obj.dSignerIdentifier = u2;
      u2 = new n();
      u2.hTLV = o2.digalg;
      o2.obj.dDigestAlgorithm = u2;
      u2 = new n();
      u2.hTLV = o2.sattrs;
      o2.obj.dSignedAttrs = u2;
      u2 = new n();
      u2.hTLV = o2.sigalg;
      o2.obj.dSigAlg = u2;
      u2 = new n();
      u2.hTLV = o2.sig;
      o2.obj.dSig = u2;
      o2.obj.dUnsignedAttrs = new k();
      return o2;
    };
    if (typeof KJUR.asn1.csr == "undefined" || !KJUR.asn1.csr) {
      KJUR.asn1.csr = {};
    }
    KJUR.asn1.csr.CertificationRequest = function(g2) {
      var d2 = KJUR, c2 = d2.asn1, e = c2.DERBitString, b = c2.DERSequence, a = c2.csr, f2 = c2.x509, h = a.CertificationRequestInfo;
      a.CertificationRequest.superclass.constructor.call(this);
      this.setByParam = function(i) {
        this.params = i;
      };
      this.sign = function() {
        var j = new h(this.params).tohex();
        var k = new KJUR.crypto.Signature({ alg: this.params.sigalg });
        k.init(this.params.sbjprvkey);
        k.updateHex(j);
        var i = k.sign();
        this.params.sighex = i;
      };
      this.getPEM = function() {
        return hextopem(this.tohex(), "CERTIFICATE REQUEST");
      };
      this.tohex = function() {
        var l2 = this.params;
        var j = new KJUR.asn1.csr.CertificationRequestInfo(this.params);
        var m2 = new KJUR.asn1.x509.AlgorithmIdentifier({ name: l2.sigalg });
        if (l2.sighex == void 0 && l2.sbjprvkey != void 0) {
          this.sign();
        }
        if (l2.sighex == void 0) {
          throw new Error("sighex or sbjprvkey parameter not defined");
        }
        var k = new e({ hex: "00" + l2.sighex });
        var i = new b({ array: [j, m2, k] });
        return i.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (g2 !== void 0) {
        this.setByParam(g2);
      }
    };
    extendClass(KJUR.asn1.csr.CertificationRequest, KJUR.asn1.ASN1Object);
    KJUR.asn1.csr.CertificationRequestInfo = function(f2) {
      var b = KJUR, j = b.asn1, c2 = j.DERBitString, g2 = j.DERSequence, i = j.DERInteger, p3 = j.DERUTF8String, d2 = j.DERTaggedObject, h = j.ASN1Util.newObject, n = j.csr, e = j.x509, a = e.X500Name, l2 = e.Extensions, o2 = e.SubjectPublicKeyInfo, k = n.AttributeList;
      n.CertificationRequestInfo.superclass.constructor.call(this);
      this.params = null;
      this.setByParam = function(q2) {
        if (q2 != void 0) {
          this.params = q2;
        }
      };
      this.tohex = function() {
        var v = this.params;
        var r = [];
        r.push(new i({ "int": 0 }));
        r.push(new a(v.subject));
        r.push(new o2(KEYUTIL.getKey(v.sbjpubkey)));
        if (v.attrs != void 0) {
          var u2 = m2(v.attrs);
          var t2 = h({ tag: { tage: "a0", obj: u2 } });
          r.push(t2);
        } else {
          if (v.extreq != void 0) {
            var q2 = new l2(v.extreq);
            var t2 = h({ tag: { tage: "a0", obj: { seq: [{ oid: "1.2.840.113549.1.9.14" }, { set: [q2] }] } } });
            r.push(t2);
          } else {
            r.push(new d2({ tag: "a0", explicit: false, obj: new p3({ str: "" }) }));
          }
        }
        var s = new g2({ array: r });
        return s.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      function m2(s) {
        var w = Error, v = KJUR.asn1.x509.Extensions;
        var y = [];
        for (var u2 = 0; u2 < s.length; u2++) {
          var r = s[u2];
          var x2 = r.attr;
          if (x2 == "extensionRequest") {
            var t2 = new v(r.ext);
            var q2 = { seq: [{ oid: "1.2.840.113549.1.9.14" }, { set: [t2] }] };
            y.push(q2);
          } else {
            if (x2 == "unstructuredName") {
              var q2 = { seq: [{ oid: "1.2.840.113549.1.9.2" }, { set: r.names }] };
              y.push(q2);
            } else {
              if (x2 == "challengePassword") {
                var q2 = { seq: [{ oid: "1.2.840.113549.1.9.7" }, { set: [{ utf8str: r.password }] }] };
                y.push(q2);
              } else {
                throw new w("unknown CSR attribute");
              }
            }
          }
        }
        return { set: y };
      }
      if (f2 != void 0) {
        this.setByParam(f2);
      }
    };
    extendClass(KJUR.asn1.csr.CertificationRequestInfo, KJUR.asn1.ASN1Object);
    KJUR.asn1.csr.AttributeList = function(b) {
      function a(c2) {
      }
    };
    extendClass(KJUR.asn1.csr.AttributeList, KJUR.asn1.ASN1Object);
    KJUR.asn1.csr.CSRUtil = new function() {
    }();
    KJUR.asn1.csr.CSRUtil.newCSRPEM = function(e) {
      var b = KEYUTIL, a = KJUR.asn1.csr;
      var c2 = new a.CertificationRequest(e);
      var d2 = c2.getPEM();
      return d2;
    };
    KJUR.asn1.csr.CSRUtil.getParam = function(d2, a) {
      var m2 = ASN1HEX, i = m2.getV, j = m2.getIdxbyList, b = m2.getTLVbyList, o2 = m2.getTLVbyListEx, n = m2.getVbyListEx;
      var l2 = function(u2) {
        var t2 = j(u2, 0, [0, 3, 0, 0], "06");
        if (i(u2, t2) != "2a864886f70d01090e") {
          return null;
        }
        return b(u2, 0, [0, 3, 0, 1, 0], "30");
      };
      var g2 = {};
      if (d2.indexOf("-----BEGIN CERTIFICATE REQUEST") == -1) {
        throw new Error("argument is not PEM file");
      }
      var e = pemtohex(d2, "CERTIFICATE REQUEST");
      if (a) {
        g2.tbs = b(e, 0, [0]);
      }
      try {
        var p3 = o2(e, 0, [0, 1]);
        if (p3 == "3000") {
          g2.subject = {};
        } else {
          var f2 = new X509();
          g2.subject = f2.getX500Name(p3);
        }
      } catch (q2) {
      }
      var k = o2(e, 0, [0, 2]);
      var r = KEYUTIL.getKey(k, null, "pkcs8pub");
      g2.sbjpubkey = KEYUTIL.getPEM(r, "PKCS8PUB");
      var c2 = l2(e);
      var f2 = new X509();
      if (c2 != null) {
        g2.extreq = f2.getExtParamArray(c2);
      }
      try {
        var h = o2(e, 0, [1], "30");
        var f2 = new X509();
        g2.sigalg = f2.getAlgorithmIdentifierName(h);
      } catch (q2) {
      }
      try {
        var s = n(e, 0, [2]);
        g2.sighex = s;
      } catch (q2) {
      }
      return g2;
    };
    KJUR.asn1.csr.CSRUtil.verifySignature = function(b) {
      try {
        var c2 = null;
        if (typeof b == "string" && b.indexOf("-----BEGIN CERTIFICATE REQUEST") != -1) {
          c2 = KJUR.asn1.csr.CSRUtil.getParam(b, true);
        } else {
          if (typeof b == "object" && b.sbjpubkey != void 0 && b.sigalg != void 0 && b.sighex != void 0 && b.tbs != void 0) {
            c2 = b;
          }
        }
        if (c2 == null) {
          return false;
        }
        var d2 = new KJUR.crypto.Signature({ alg: c2.sigalg });
        d2.init(c2.sbjpubkey);
        d2.updateHex(c2.tbs);
        return d2.verify(c2.sighex);
      } catch (a) {
        alert(a);
        return false;
      }
    };
    if (typeof KJUR == "undefined" || !KJUR) {
      KJUR = {};
    }
    if (typeof KJUR.asn1 == "undefined" || !KJUR.asn1) {
      KJUR.asn1 = {};
    }
    if (typeof KJUR.asn1.ocsp == "undefined" || !KJUR.asn1.ocsp) {
      KJUR.asn1.ocsp = {};
    }
    KJUR.asn1.ocsp.DEFAULT_HASH = "sha1";
    KJUR.asn1.ocsp.OCSPResponse = function(e) {
      KJUR.asn1.ocsp.OCSPResponse.superclass.constructor.call(this);
      var a = KJUR.asn1.DEREnumerated, b = KJUR.asn1.ASN1Util.newObject, c2 = KJUR.asn1.ocsp.ResponseBytes;
      var d2 = ["successful", "malformedRequest", "internalError", "tryLater", "_not_used_", "sigRequired", "unauthorized"];
      this.params = null;
      this._getStatusCode = function() {
        var f2 = this.params.resstatus;
        if (typeof f2 == "number") {
          return f2;
        }
        if (typeof f2 != "string") {
          return -1;
        }
        return d2.indexOf(f2);
      };
      this.setByParam = function(f2) {
        this.params = f2;
      };
      this.tohex = function() {
        var h = this.params;
        var g2 = this._getStatusCode();
        if (g2 == -1) {
          throw new Error("responseStatus not supported: " + h.resstatus);
        }
        if (g2 != 0) {
          return b({ seq: [{ "enum": { "int": g2 } }] }).tohex();
        }
        var f2 = new c2(h);
        return b({ seq: [{ "enum": { "int": 0 } }, { tag: { tag: "a0", explicit: true, obj: f2 } }] }).tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (e !== void 0) {
        this.setByParam(e);
      }
    };
    extendClass(KJUR.asn1.ocsp.OCSPResponse, KJUR.asn1.ASN1Object);
    KJUR.asn1.ocsp.ResponseBytes = function(e) {
      KJUR.asn1.ocsp.ResponseBytes.superclass.constructor.call(this);
      var b = KJUR.asn1, a = b.DERSequence, f2 = b.DERObjectIdentifier, c2 = b.DEROctetString, d2 = b.ocsp.BasicOCSPResponse;
      this.params = null;
      this.setByParam = function(g2) {
        this.params = g2;
      };
      this.tohex = function() {
        var j = this.params;
        if (j.restype != "ocspBasic") {
          throw new Error("not supported responseType: " + j.restype);
        }
        var i = new d2(j);
        var g2 = [];
        g2.push(new f2({ name: "ocspBasic" }));
        g2.push(new c2({ hex: i.tohex() }));
        var h = new a({ array: g2 });
        return h.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (e !== void 0) {
        this.setByParam(e);
      }
    };
    extendClass(KJUR.asn1.ocsp.ResponseBytes, KJUR.asn1.ASN1Object);
    KJUR.asn1.ocsp.BasicOCSPResponse = function(d2) {
      KJUR.asn1.ocsp.BasicOCSPResponse.superclass.constructor.call(this);
      var i = Error, g2 = KJUR.asn1, j = g2.ASN1Object, e = g2.DERSequence, f2 = g2.DERGeneralizedTime, c2 = g2.DERTaggedObject, b = g2.DERBitString, h = g2.x509.Extensions, k = g2.x509.AlgorithmIdentifier, l2 = g2.ocsp, a = l2.ResponderID;
      _SingleResponseList = l2.SingleResponseList, _ResponseData = l2.ResponseData;
      this.params = null;
      this.setByParam = function(m2) {
        this.params = m2;
      };
      this.sign = function() {
        var o2 = this.params;
        var m2 = o2.tbsresp.tohex();
        var n = new KJUR.crypto.Signature({ alg: o2.sigalg });
        n.init(o2.reskey);
        n.updateHex(m2);
        o2.sighex = n.sign();
      };
      this.tohex = function() {
        var t2 = this.params;
        if (t2.tbsresp == void 0) {
          t2.tbsresp = new _ResponseData(t2);
        }
        if (t2.sighex == void 0 && t2.reskey != void 0) {
          this.sign();
        }
        var n = [];
        n.push(t2.tbsresp);
        n.push(new k({ name: t2.sigalg }));
        n.push(new b({ hex: "00" + t2.sighex }));
        if (t2.certs != void 0 && t2.certs.length != void 0) {
          var m2 = [];
          for (var q2 = 0; q2 < t2.certs.length; q2++) {
            var s = t2.certs[q2];
            var r = null;
            if (ASN1HEX.isASN1HEX(s)) {
              r = s;
            } else {
              if (s.match(/-----BEGIN/)) {
                r = pemtohex(s);
              } else {
                throw new i("certs[" + q2 + "] not hex or PEM");
              }
            }
            m2.push(new j({ tlv: r }));
          }
          var p3 = new e({ array: m2 });
          n.push(new c2({ tag: "a0", explicit: true, obj: p3 }));
        }
        var o2 = new e({ array: n });
        return o2.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (d2 !== void 0) {
        this.setByParam(d2);
      }
    };
    extendClass(KJUR.asn1.ocsp.BasicOCSPResponse, KJUR.asn1.ASN1Object);
    KJUR.asn1.ocsp.ResponseData = function(c2) {
      KJUR.asn1.ocsp.ResponseData.superclass.constructor.call(this);
      var h = Error, f2 = KJUR.asn1, d2 = f2.DERSequence, e = f2.DERGeneralizedTime, b = f2.DERTaggedObject, g2 = f2.x509.Extensions, i = f2.ocsp, a = i.ResponderID;
      _SingleResponseList = i.SingleResponseList;
      this.params = null;
      this.tohex = function() {
        var m2 = this.params;
        if (m2.respid != void 0) {
          new h("respid not specified");
        }
        if (m2.prodat != void 0) {
          new h("prodat not specified");
        }
        if (m2.array != void 0) {
          new h("array not specified");
        }
        var j = [];
        j.push(new a(m2.respid));
        j.push(new e(m2.prodat));
        j.push(new _SingleResponseList(m2.array));
        if (m2.ext != void 0) {
          var l2 = new g2(m2.ext);
          j.push(new b({ tag: "a1", explicit: true, obj: l2 }));
        }
        var k = new d2({ array: j });
        return k.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      this.setByParam = function(j) {
        this.params = j;
      };
      if (c2 !== void 0) {
        this.setByParam(c2);
      }
    };
    extendClass(KJUR.asn1.ocsp.ResponseData, KJUR.asn1.ASN1Object);
    KJUR.asn1.ocsp.ResponderID = function(g2) {
      KJUR.asn1.ocsp.ResponderID.superclass.constructor.call(this);
      var d2 = KJUR, c2 = d2.asn1, b = c2.ASN1Util.newObject, f2 = c2.x509.X500Name, e = d2.lang.String.isHex, a = Error;
      this.params = null;
      this.tohex = function() {
        var m2 = this.params;
        if (m2.key != void 0) {
          var l2 = null;
          if (typeof m2.key == "string") {
            if (e(m2.key)) {
              l2 = m2.key;
            }
            if (m2.key.match(/-----BEGIN CERTIFICATE/)) {
              var h = new X509(m2.key);
              var k = h.getExtSubjectKeyIdentifier();
              if (k != null) {
                l2 = k.kid.hex;
              }
            }
          } else {
            if (m2.key instanceof X509) {
              var k = m2.key.getExtSubjectKeyIdentifier();
              if (k != null) {
                l2 = k.kid.hex;
              }
            }
          }
          if (l2 == null) {
            throw new a("wrong key member value");
          }
          var j = b({ tag: { tag: "a2", explicit: true, obj: { octstr: { hex: l2 } } } });
          return j.tohex();
        } else {
          if (m2.name != void 0) {
            var i = null;
            if (typeof m2.name == "string" && m2.name.match(/-----BEGIN CERTIFICATE/)) {
              var h = new X509(m2.name);
              i = h.getSubject();
            } else {
              if (m2.name instanceof X509) {
                i = m2.name.getSubject();
              } else {
                if (typeof m2.name == "object" && (m2.name.array != void 0 || m2.name.str != void 0)) {
                  i = m2.name;
                }
              }
            }
            if (i == null) {
              throw new a("wrong name member value");
            }
            var j = b({ tag: { tag: "a1", explicit: true, obj: new f2(i) } });
            return j.tohex();
          }
        }
        throw new a("key or name not specified");
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      this.setByParam = function(h) {
        this.params = h;
      };
      if (g2 !== void 0) {
        this.setByParam(g2);
      }
    };
    extendClass(KJUR.asn1.ocsp.ResponderID, KJUR.asn1.ASN1Object);
    KJUR.asn1.ocsp.SingleResponseList = function(d2) {
      KJUR.asn1.ocsp.SingleResponseList.superclass.constructor.call(this);
      var c2 = KJUR.asn1, b = c2.DERSequence, a = c2.ocsp.SingleResponse;
      this.params = null;
      this.tohex = function() {
        var h = this.params;
        if (typeof h != "object" || h.length == void 0) {
          throw new Error("params not specified properly");
        }
        var e = [];
        for (var g2 = 0; g2 < h.length; g2++) {
          e.push(new a(h[g2]));
        }
        var f2 = new b({ array: e });
        return f2.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      this.setByParam = function(e) {
        this.params = e;
      };
      if (d2 !== void 0) {
        this.setByParam(d2);
      }
    };
    extendClass(KJUR.asn1.ocsp.SingleResponseList, KJUR.asn1.ASN1Object);
    KJUR.asn1.ocsp.SingleResponse = function(e) {
      var k = Error, a = KJUR, i = a.asn1, f2 = i.DERSequence, g2 = i.DERGeneralizedTime, b = i.DERTaggedObject, l2 = i.ocsp, h = l2.CertID, c2 = l2.CertStatus, d2 = i.x509, j = d2.Extensions;
      l2.SingleResponse.superclass.constructor.call(this);
      this.params = null;
      this.tohex = function() {
        var q2 = this.params;
        var n = [];
        if (q2.certid == void 0) {
          throw new k("certid unspecified");
        }
        if (q2.status == void 0) {
          throw new k("status unspecified");
        }
        if (q2.thisupdate == void 0) {
          throw new k("thisupdate unspecified");
        }
        n.push(new h(q2.certid));
        n.push(new c2(q2.status));
        n.push(new g2(q2.thisupdate));
        if (q2.nextupdate != void 0) {
          var m2 = new g2(q2.nextupdate);
          n.push(new b({ tag: "a0", explicit: true, obj: m2 }));
        }
        if (q2.ext != void 0) {
          var p3 = new j(q2.ext);
          n.push(new b({ tag: "a1", explicit: true, obj: p3 }));
        }
        var o2 = new f2({ array: n });
        return o2.tohex();
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      this.setByParam = function(m2) {
        this.params = m2;
      };
      if (e !== void 0) {
        this.setByParam(e);
      }
    };
    extendClass(KJUR.asn1.ocsp.SingleResponse, KJUR.asn1.ASN1Object);
    KJUR.asn1.ocsp.CertID = function(e) {
      var b = KJUR, i = b.asn1, l2 = i.DEROctetString, h = i.DERInteger, f2 = i.DERSequence, d2 = i.x509, m2 = d2.AlgorithmIdentifier, n = i.ocsp, k = n.DEFAULT_HASH, g2 = b.crypto, c2 = g2.Util.hashHex, a = X509, o2 = ASN1HEX, j = o2.getVbyList;
      n.CertID.superclass.constructor.call(this);
      this.DEFAULT_HASH = "sha1";
      this.params = null;
      this.setByValue = function(s, r, p3, q2) {
        if (q2 == void 0) {
          q2 = this.DEFAULT_HASH;
        }
        this.params = { alg: q2, issname: s, isskey: r, sbjsn: p3 };
      };
      this.setByCert = function(p3, q2, r) {
        if (r == void 0) {
          r = this.DEFAULT_HASH;
        }
        this.params = { alg: r, issuerCert: p3, subjectCert: q2 };
      };
      this.getParamByCerts = function(y, x2, t2) {
        if (t2 == void 0) {
          t2 = this.DEFAULT_HASH;
        }
        var q2 = new a(y);
        var v = new a(x2);
        var s = c2(q2.getSubjectHex(), t2);
        var u2 = q2.getPublicKeyHex();
        var p3 = c2(j(u2, 0, [1], "03", true), t2);
        var w = v.getSerialNumberHex();
        var r = { alg: t2, issname: s, isskey: p3, sbjsn: w };
        return r;
      };
      this.tohex = function() {
        if (typeof this.params != "object") {
          throw new Error("params not set");
        }
        var s = this.params;
        var u2, r, y, q2;
        if (s.alg == void 0) {
          q2 = this.DEFAULT_HASH;
        } else {
          q2 = s.alg;
        }
        if (s.issuerCert != void 0 && s.subjectCert != void 0) {
          var t2 = this.getParamByCerts(s.issuerCert, s.subjectCert, q2);
          u2 = t2.issname;
          r = t2.isskey;
          y = t2.sbjsn;
        } else {
          if (s.issname != void 0 && s.isskey != void 0 && s.sbjsn != void 0) {
            u2 = s.issname;
            r = s.isskey;
            y = s.sbjsn;
          } else {
            throw new Error("required param members not defined");
          }
        }
        var A = new m2({ name: q2 });
        var v = new l2({ hex: u2 });
        var x2 = new l2({ hex: r });
        var w = new h({ hex: y });
        var z2 = new f2({ array: [A, v, x2, w] });
        this.hTLV = z2.tohex();
        return this.hTLV;
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (e !== void 0) {
        this.setByParam(e);
      }
    };
    extendClass(KJUR.asn1.ocsp.CertID, KJUR.asn1.ASN1Object);
    KJUR.asn1.ocsp.CertStatus = function(a) {
      KJUR.asn1.ocsp.CertStatus.superclass.constructor.call(this);
      this.params = null;
      this.tohex = function() {
        var d2 = this.params;
        if (d2.status == "good") {
          return "8000";
        }
        if (d2.status == "unknown") {
          return "8200";
        }
        if (d2.status == "revoked") {
          var c2 = [{ gentime: { str: d2.time } }];
          if (d2.reason != void 0) {
            c2.push({ tag: { tag: "a0", explicit: true, obj: { "enum": { "int": d2.reason } } } });
          }
          var b = { tag: "a1", explicit: false, obj: { seq: c2 } };
          return KJUR.asn1.ASN1Util.newObject({ tag: b }).tohex();
        }
        throw new Error("bad status");
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      this.setByParam = function(b) {
        this.params = b;
      };
      if (a !== void 0) {
        this.setByParam(a);
      }
    };
    extendClass(KJUR.asn1.ocsp.CertStatus, KJUR.asn1.ASN1Object);
    KJUR.asn1.ocsp.Request = function(f2) {
      var c2 = KJUR, b = c2.asn1, a = b.DERSequence, d2 = b.ocsp;
      d2.Request.superclass.constructor.call(this);
      this.dReqCert = null;
      this.dExt = null;
      this.tohex = function() {
        var g2 = [];
        if (this.dReqCert === null) {
          throw "reqCert not set";
        }
        g2.push(this.dReqCert);
        var h = new a({ array: g2 });
        this.hTLV = h.tohex();
        return this.hTLV;
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (typeof f2 !== "undefined") {
        var e = new d2.CertID(f2);
        this.dReqCert = e;
      }
    };
    extendClass(KJUR.asn1.ocsp.Request, KJUR.asn1.ASN1Object);
    KJUR.asn1.ocsp.TBSRequest = function(e) {
      var c2 = KJUR, b = c2.asn1, a = b.DERSequence, d2 = b.ocsp;
      d2.TBSRequest.superclass.constructor.call(this);
      this.version = 0;
      this.dRequestorName = null;
      this.dRequestList = [];
      this.dRequestExt = null;
      this.setRequestListByParam = function(h) {
        var f2 = [];
        for (var g2 = 0; g2 < h.length; g2++) {
          var j = new d2.Request(h[0]);
          f2.push(j);
        }
        this.dRequestList = f2;
      };
      this.tohex = function() {
        var f2 = [];
        if (this.version !== 0) {
          throw "not supported version: " + this.version;
        }
        if (this.dRequestorName !== null) {
          throw "requestorName not supported";
        }
        var h = new a({ array: this.dRequestList });
        f2.push(h);
        if (this.dRequestExt !== null) {
          throw "requestExtensions not supported";
        }
        var g2 = new a({ array: f2 });
        this.hTLV = g2.tohex();
        return this.hTLV;
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (e !== void 0) {
        if (e.reqList !== void 0) {
          this.setRequestListByParam(e.reqList);
        }
      }
    };
    extendClass(KJUR.asn1.ocsp.TBSRequest, KJUR.asn1.ASN1Object);
    KJUR.asn1.ocsp.OCSPRequest = function(f2) {
      var c2 = KJUR, b = c2.asn1, a = b.DERSequence, d2 = b.ocsp;
      d2.OCSPRequest.superclass.constructor.call(this);
      this.dTbsRequest = null;
      this.dOptionalSignature = null;
      this.tohex = function() {
        var g2 = [];
        if (this.dTbsRequest !== null) {
          g2.push(this.dTbsRequest);
        } else {
          throw "tbsRequest not set";
        }
        if (this.dOptionalSignature !== null) {
          throw "optionalSignature not supported";
        }
        var h = new a({ array: g2 });
        this.hTLV = h.tohex();
        return this.hTLV;
      };
      this.getEncodedHex = function() {
        return this.tohex();
      };
      if (f2 !== void 0) {
        if (f2.reqList !== void 0) {
          var e = new d2.TBSRequest(f2);
          this.dTbsRequest = e;
        }
      }
    };
    extendClass(KJUR.asn1.ocsp.OCSPRequest, KJUR.asn1.ASN1Object);
    KJUR.asn1.ocsp.OCSPUtil = {};
    KJUR.asn1.ocsp.OCSPUtil.getRequestHex = function(a, b, h) {
      var d2 = KJUR, c2 = d2.asn1, e = c2.ocsp;
      if (h === void 0) {
        h = e.DEFAULT_HASH;
      }
      var g2 = { alg: h, issuerCert: a, subjectCert: b };
      var f2 = new e.OCSPRequest({ reqList: [g2] });
      return f2.tohex();
    };
    KJUR.asn1.ocsp.OCSPUtil.getOCSPResponseInfo = function(b) {
      var m2 = ASN1HEX, c2 = m2.getVbyList, k = m2.getVbyListEx, e = m2.getIdxbyList, d2 = m2.getIdxbyListEx, g2 = m2.getV;
      var n = {};
      try {
        var j = k(b, 0, [0], "0a");
        n.responseStatus = parseInt(j, 16);
      } catch (f2) {
      }
      if (n.responseStatus !== 0) {
        return n;
      }
      try {
        var i = e(b, 0, [1, 0, 1, 0, 0, 2, 0, 1]);
        if (b.substr(i, 2) === "80") {
          n.certStatus = "good";
        } else {
          if (b.substr(i, 2) === "a1") {
            n.certStatus = "revoked";
            n.revocationTime = hextoutf8(c2(b, i, [0]));
          } else {
            if (b.substr(i, 2) === "82") {
              n.certStatus = "unknown";
            }
          }
        }
      } catch (f2) {
      }
      try {
        var a = e(b, 0, [1, 0, 1, 0, 0, 2, 0, 2]);
        n.thisUpdate = hextoutf8(g2(b, a));
      } catch (f2) {
      }
      try {
        var l2 = e(b, 0, [1, 0, 1, 0, 0, 2, 0, 3]);
        if (b.substr(l2, 2) === "a0") {
          n.nextUpdate = hextoutf8(c2(b, l2, [0]));
        }
      } catch (f2) {
      }
      return n;
    };
    KJUR.asn1.ocsp.OCSPParser = function() {
      var g2 = Error, a = X509, h = new a(), l2 = ASN1HEX, i = l2.getV, b = l2.getTLV, f2 = l2.getIdxbyList, e = l2.getVbyList, c2 = l2.getTLVbyList, k = l2.getVbyListEx, d2 = l2.getTLVbyListEx, j = l2.getChildIdx;
      this.getOCSPRequest = function(o2) {
        var n = j(o2, 0);
        if (n.length != 1 && n.length != 2) {
          throw new g2("wrong number elements: " + n.length);
        }
        var m2 = this.getTBSRequest(b(o2, n[0]));
        return m2;
      };
      this.getTBSRequest = function(o2) {
        var m2 = {};
        var n = d2(o2, 0, [0], "30");
        m2.array = this.getRequestList(n);
        var p3 = d2(o2, 0, ["[2]", 0], "30");
        if (p3 != null) {
          m2.ext = h.getExtParamArray(p3);
        }
        return m2;
      };
      this.getRequestList = function(p3) {
        var m2 = [];
        var n = j(p3, 0);
        for (var o2 = 0; o2 < n.length; o2++) {
          var p3 = b(p3, n[o2]);
          m2.push(this.getRequest(p3));
        }
        return m2;
      };
      this.getRequest = function(n) {
        var m2 = j(n, 0);
        if (m2.length != 1 && m2.length != 2) {
          throw new g2("wrong number elements: " + m2.length);
        }
        var p3 = this.getCertID(b(n, m2[0]));
        if (m2.length == 2) {
          var o2 = f2(n, 0, [1, 0]);
          p3.ext = h.getExtParamArray(b(n, o2));
        }
        return p3;
      };
      this.getCertID = function(p3) {
        var o2 = j(p3, 0);
        if (o2.length != 4) {
          throw new g2("wrong number elements: " + o2.length);
        }
        var n = new a();
        var m2 = {};
        m2.alg = n.getAlgorithmIdentifierName(b(p3, o2[0]));
        m2.issname = i(p3, o2[1]);
        m2.isskey = i(p3, o2[2]);
        m2.sbjsn = i(p3, o2[3]);
        return m2;
      };
      this.getOCSPResponse = function(r) {
        var o2 = j(r, 0);
        var m2;
        var q2 = i(r, o2[0]);
        var p3 = parseInt(q2);
        if (o2.length == 1) {
          return { resstatus: p3 };
        }
        var n = c2(r, 0, [1, 0]);
        m2 = this.getResponseBytes(n);
        m2.resstatus = p3;
        return m2;
      };
      this.getResponseBytes = function(p3) {
        var o2 = j(p3, 0);
        var n;
        var q2 = c2(p3, 0, [1, 0]);
        n = this.getBasicOCSPResponse(q2);
        var m2 = i(p3, o2[0]);
        n.restype = KJUR.asn1.x509.OID.oid2name(hextooid(m2));
        return n;
      };
      this.getBasicOCSPResponse = function(q2) {
        var t2 = j(q2, 0);
        var v;
        v = this.getResponseData(b(q2, t2[0]));
        var u2 = new X509();
        v.alg = u2.getAlgorithmIdentifierName(b(q2, t2[1]));
        var n = i(q2, t2[2]);
        v.sighex = n.substr(2);
        var m2 = k(q2, 0, ["[0]"]);
        if (m2 != null) {
          var r = j(m2, 0);
          var o2 = [];
          for (var p3 = 0; p3 < r.length; p3++) {
            var s = b(m2, r[p3]);
            o2.push(s);
          }
          v.certs = o2;
        }
        return v;
      };
      this.getResponseData = function(q2) {
        var p3 = j(q2, 0);
        var r = p3.length;
        var o2 = {};
        var n = 0;
        if (q2.substr(p3[0], 2) == "a0") {
          n++;
        }
        o2.respid = this.getResponderID(b(q2, p3[n++]));
        var t2 = i(q2, p3[n++]);
        o2.prodat = hextoutf8(t2);
        o2.array = this.getSingleResponseList(b(q2, p3[n++]));
        if (q2.substr(p3[r - 1], 2) == "a1") {
          var s = c2(q2, p3[r - 1], [0]);
          var m2 = new X509();
          o2.ext = m2.getExtParamArray(s);
        }
        return o2;
      };
      this.getResponderID = function(o2) {
        var n = {};
        if (o2.substr(0, 2) == "a2") {
          var p3 = e(o2, 0, [0]);
          n.key = p3;
        }
        if (o2.substr(0, 2) == "a1") {
          var q2 = c2(o2, 0, [0]);
          var m2 = new X509();
          n.name = m2.getX500Name(q2);
        }
        return n;
      };
      this.getSingleResponseList = function(q2) {
        var n = j(q2, 0);
        var m2 = [];
        for (var o2 = 0; o2 < n.length; o2++) {
          var r = this.getSingleResponse(b(q2, n[o2]));
          m2.push(r);
        }
        return m2;
      };
      this.getSingleResponse = function(p3) {
        var t2 = j(p3, 0);
        var v = {};
        var r = this.getCertID(b(p3, t2[0]));
        v.certid = r;
        var u2 = this.getCertStatus(b(p3, t2[1]));
        v.status = u2;
        if (p3.substr(t2[2], 2) == "18") {
          var q2 = i(p3, t2[2]);
          v.thisupdate = hextoutf8(q2);
        }
        for (var o2 = 3; o2 < t2.length; o2++) {
          if (p3.substr(t2[o2], 2) == "a0") {
            var m2 = e(p3, t2[o2], [0], "18");
            v.nextupdate = hextoutf8(m2);
          }
          if (p3.substr(t2[o2], 2) == "a1") {
            var s = new X509();
            var n = c2(p3, 0, [o2, 0]);
            v.ext = s.getExtParamArray(n);
          }
        }
        return v;
      };
      this.getCertStatus = function(p3) {
        var m2 = {};
        if (p3 == "8000") {
          return { status: "good" };
        }
        if (p3 == "8200") {
          return { status: "unknown" };
        }
        if (p3.substr(0, 2) == "a1") {
          m2.status = "revoked";
          var o2 = e(p3, 0, [0]);
          var n = hextoutf8(o2);
          m2.time = n;
        }
        return m2;
      };
    };
    var KJUR;
    if (typeof KJUR == "undefined" || !KJUR) {
      KJUR = {};
    }
    if (typeof KJUR.lang == "undefined" || !KJUR.lang) {
      KJUR.lang = {};
    }
    KJUR.lang.String = function() {
    };
    function stoBA(d2) {
      var b = new Array();
      for (var c2 = 0; c2 < d2.length; c2++) {
        b[c2] = d2.charCodeAt(c2);
      }
      return b;
    }
    function BAtos(b) {
      var d2 = "";
      for (var c2 = 0; c2 < b.length; c2++) {
        d2 = d2 + String.fromCharCode(b[c2]);
      }
      return d2;
    }
    function BAtohex(b) {
      var e = "";
      for (var d2 = 0; d2 < b.length; d2++) {
        var c2 = b[d2].toString(16);
        if (c2.length == 1) {
          c2 = "0" + c2;
        }
        e = e + c2;
      }
      return e;
    }
    function stohex(a) {
      return BAtohex(stoBA(a));
    }
    function stob64(a) {
      return hex2b64(stohex(a));
    }
    function stob64u(a) {
      return b64tob64u(hex2b64(stohex(a)));
    }
    function b64utos(a) {
      return BAtos(b64toBA(b64utob64(a)));
    }
    function b64tob64u(a) {
      a = a.replace(/\=/g, "");
      a = a.replace(/\+/g, "-");
      a = a.replace(/\//g, "_");
      return a;
    }
    function b64utob64(a) {
      if (a.length % 4 == 2) {
        a = a + "==";
      } else {
        if (a.length % 4 == 3) {
          a = a + "=";
        }
      }
      a = a.replace(/-/g, "+");
      a = a.replace(/_/g, "/");
      return a;
    }
    function hextob64u(a) {
      if (a.length % 2 == 1) {
        a = "0" + a;
      }
      return b64tob64u(hex2b64(a));
    }
    function b64utohex(a) {
      return b64tohex(b64utob64(a));
    }
    var utf8tob64u;
    var b64utoutf8;
    if (typeof Buffer === "function") {
      utf8tob64u = function(a) {
        return b64tob64u(Buffer.from(a, "utf8").toString("base64"));
      };
      b64utoutf8 = function(a) {
        return Buffer.from(b64utob64(a), "base64").toString("utf8");
      };
    } else {
      utf8tob64u = function(a) {
        return hextob64u(uricmptohex(encodeURIComponentAll(a)));
      };
      b64utoutf8 = function(a) {
        return decodeURIComponent(hextouricmp(b64utohex(a)));
      };
    }
    function utf8tob64(a) {
      return hex2b64(uricmptohex(encodeURIComponentAll(a)));
    }
    function b64toutf8(a) {
      return decodeURIComponent(hextouricmp(b64tohex(a)));
    }
    function utf8tohex(a) {
      return uricmptohex(encodeURIComponentAll(a)).toLowerCase();
    }
    function hextoutf8(b) {
      try {
        return decodeURIComponent(hextouricmp(b));
      } catch (a) {
        return null;
      }
    }
    function iso88591hextoutf8(a) {
      return hextoutf8(iso88591hextoutf8hex(a));
    }
    function iso88591hextoutf8hex(e) {
      var c2 = e.match(/.{1,2}/g);
      var b = [];
      for (var d2 = 0; d2 < c2.length; d2++) {
        var f2 = parseInt(c2[d2], 16);
        if (161 <= f2 && f2 <= 191) {
          b.push("c2");
          b.push(c2[d2]);
        } else {
          if (192 <= f2 && f2 <= 255) {
            b.push("c3");
            b.push((f2 - 64).toString(16));
          } else {
            b.push(c2[d2]);
          }
        }
      }
      return b.join("");
    }
    function hextorstr(c2) {
      var b = "";
      for (var a = 0; a < c2.length - 1; a += 2) {
        b += String.fromCharCode(parseInt(c2.substr(a, 2), 16));
      }
      return b;
    }
    function rstrtohex(c2) {
      var a = "";
      for (var b = 0; b < c2.length; b++) {
        a += ("0" + c2.charCodeAt(b).toString(16)).slice(-2);
      }
      return a;
    }
    function hextob64(a) {
      return hex2b64(a);
    }
    function hextob64nl(a) {
      return foldnl(hextob64(a), 64);
    }
    function foldnl(a, b) {
      a = a.replace(new RegExp("(.{" + b + "})", "g"), "$1\r\n");
      a = a.replace(/\s+$/, "");
      return a;
    }
    function b64nltohex(b) {
      var a = b.replace(/[^0-9A-Za-z\/+=]*/g, "");
      var c2 = b64tohex(a);
      return c2;
    }
    function b64topem(b, a) {
      return "-----BEGIN " + a + "-----\r\n" + foldnl(b, 64) + "\r\n-----END " + a + "-----\r\n";
    }
    function hextopem(a, b) {
      return "-----BEGIN " + b + "-----\r\n" + foldnl(hextob64(a), 64) + "\r\n-----END " + b + "-----\r\n";
    }
    function pemtohex(a, b) {
      if (a.indexOf("-----BEGIN ") == -1) {
        throw new Error("can't find PEM header");
      }
      if (b !== void 0) {
        a = a.replace(new RegExp("^[^]*-----BEGIN " + b + "-----"), "");
        a = a.replace(new RegExp("-----END " + b + "-----[^]*$"), "");
      } else {
        a = a.replace(/^[^]*-----BEGIN [^-]+-----/, "");
        a = a.replace(/-----END [^-]+-----[^]*$/, "");
      }
      return b64nltohex(a);
    }
    function pemtob64(a) {
      if (a.indexOf("-----BEGIN ") == -1 || a.indexOf("-----END ") == -1) {
        return null;
      }
      a = a.replace(/^[\s\S]*?-----BEGIN [^-]+-----/m, "");
      a = a.replace(/-----END [\s\S]+$/m, "");
      a = a.replace(/\s+/g, "");
      return a.match(/^[0-9a-zA-Z+/=]+$/) ? a : null;
    }
    function hextoArrayBuffer(d2) {
      if (d2.length % 2 != 0) {
        throw "input is not even length";
      }
      if (d2.match(/^[0-9A-Fa-f]+$/) == null) {
        throw "input is not hexadecimal";
      }
      var b = new ArrayBuffer(d2.length / 2);
      var a = new DataView(b);
      for (var c2 = 0; c2 < d2.length / 2; c2++) {
        a.setUint8(c2, parseInt(d2.substr(c2 * 2, 2), 16));
      }
      return b;
    }
    function ArrayBuffertohex(b) {
      var d2 = "";
      var a = new DataView(b);
      for (var c2 = 0; c2 < b.byteLength; c2++) {
        d2 += ("00" + a.getUint8(c2).toString(16)).slice(-2);
      }
      return d2;
    }
    function zulutomsec(n) {
      var l2, j, m2, e, f2, i, b, k;
      var a, h, g2, c2;
      n = timetogen(n);
      c2 = n.match(/^(\d{4})(\d\d)(\d\d)(\d\d)(\d\d)(\d\d)(|\.\d+)Z$/);
      if (c2) {
        l2 = parseInt(c2[1]);
        j = parseInt(c2[2]) - 1;
        m2 = parseInt(c2[3]);
        e = parseInt(c2[4]);
        f2 = parseInt(c2[5]);
        i = parseInt(c2[6]);
        b = 0;
        h = c2[7];
        if (h !== "") {
          g2 = (h.substr(1) + "00").substr(0, 3);
          b = parseInt(g2);
        }
        return Date.UTC(l2, j, m2, e, f2, i, b);
      }
      throw new Error("unsupported zulu format: " + n);
    }
    function msectozulu(b) {
      var h = new Date(b), i = ("0000" + h.getUTCFullYear()).slice(-4), c2 = ("00" + (h.getUTCMonth() + 1)).slice(-2), j = ("00" + h.getUTCDate()).slice(-2), e = ("00" + h.getUTCHours()).slice(-2), f2 = ("00" + h.getUTCMinutes()).slice(-2), g2 = ("00" + h.getUTCSeconds()).slice(-2), a = ("000" + h.getUTCMilliseconds()).slice(-3);
      a = a.replace(/0+$/, "");
      a = a != "" ? "." + a : a;
      return i + c2 + j + e + f2 + g2 + a + "Z";
    }
    function zulutosec(a) {
      return Math.round(zulutomsec(a) / 1e3);
    }
    function zulutodate(a) {
      return new Date(zulutomsec(a));
    }
    function datetozulu(g2, e, f2) {
      var b;
      var a = g2.getUTCFullYear();
      if (e) {
        if (a < 1950 || 2049 < a) {
          throw "not proper year for UTCTime: " + a;
        }
        b = ("" + a).slice(-2);
      } else {
        b = ("000" + a).slice(-4);
      }
      b += ("0" + (g2.getUTCMonth() + 1)).slice(-2);
      b += ("0" + g2.getUTCDate()).slice(-2);
      b += ("0" + g2.getUTCHours()).slice(-2);
      b += ("0" + g2.getUTCMinutes()).slice(-2);
      b += ("0" + g2.getUTCSeconds()).slice(-2);
      if (f2) {
        var c2 = g2.getUTCMilliseconds();
        if (c2 !== 0) {
          c2 = ("00" + c2).slice(-3);
          c2 = c2.replace(/0+$/g, "");
          b += "." + c2;
        }
      }
      b += "Z";
      return b;
    }
    function timetogen(a) {
      if (a.match(/^[0-9]{12}Z$/) || a.match(/^[0-9]{12}[.][0-9]*Z$/)) {
        return a.match(/^[0-4]/) ? "20" + a : "19" + a;
      }
      return a;
    }
    function uricmptohex(a) {
      return a.replace(/%/g, "");
    }
    function hextouricmp(a) {
      return a.replace(/(..)/g, "%$1");
    }
    function ipv6tohex(g2) {
      var b = "malformed IPv6 address";
      if (!g2.match(/^[0-9A-Fa-f:]+$/)) {
        throw b;
      }
      g2 = g2.toLowerCase();
      var d2 = g2.split(":").length - 1;
      if (d2 < 2) {
        throw b;
      }
      var e = ":".repeat(7 - d2 + 2);
      g2 = g2.replace("::", e);
      var c2 = g2.split(":");
      if (c2.length != 8) {
        throw b;
      }
      for (var f2 = 0; f2 < 8; f2++) {
        c2[f2] = ("0000" + c2[f2]).slice(-4);
      }
      return c2.join("");
    }
    function hextoipv6(d2) {
      if (!d2.match(/^[0-9A-Fa-f]{32}$/)) {
        throw new Error("malformed IPv6 address: " + d2);
      }
      d2 = d2.toLowerCase();
      var b = d2.match(/.{1,4}/g);
      b = b.map(function(a) {
        return a.replace(/^0+/, "");
      });
      b = b.map(function(a) {
        return a == "" ? "0" : a;
      });
      d2 = ":" + b.join(":") + ":";
      var c2 = d2.match(/:(0:){2,}/g);
      if (c2 == null) {
        return d2.slice(1, -1);
      }
      var e = c2.sort().slice(-1)[0];
      d2 = d2.replace(e.substr(0, e.length - 1), ":");
      if (d2.substr(0, 2) != "::") {
        d2 = d2.substr(1);
      }
      if (d2.substr(-2, 2) != "::") {
        d2 = d2.substr(0, d2.length - 1);
      }
      return d2;
    }
    function hextoip(b) {
      var c2 = new Error("malformed hex value");
      if (!b.match(/^([0-9A-Fa-f][0-9A-Fa-f]){1,}$/)) {
        throw c2;
      }
      if (b.length == 8) {
        var d2;
        try {
          d2 = parseInt(b.substr(0, 2), 16) + "." + parseInt(b.substr(2, 2), 16) + "." + parseInt(b.substr(4, 2), 16) + "." + parseInt(b.substr(6, 2), 16);
          return d2;
        } catch (a) {
          throw c2;
        }
      } else {
        if (b.length == 16) {
          try {
            return hextoip(b.substr(0, 8)) + "/" + ipprefixlen(b.substr(8));
          } catch (a) {
            throw c2;
          }
        } else {
          if (b.length == 32) {
            return hextoipv6(b);
          } else {
            if (b.length == 64) {
              try {
                return hextoipv6(b.substr(0, 32)) + "/" + ipprefixlen(b.substr(32));
              } catch (a) {
                throw c2;
              }
              return;
            } else {
              return b;
            }
          }
        }
      }
    }
    function ipprefixlen(c2) {
      var d2 = new Error("malformed mask");
      var a;
      try {
        a = new BigInteger(c2, 16).toString(2);
      } catch (b) {
        throw d2;
      }
      if (!a.match(/^1*0*$/)) {
        throw d2;
      }
      return a.replace(/0+$/, "").length;
    }
    function iptohex(g2) {
      var j = new Error("malformed IP address");
      g2 = g2.toLowerCase(g2);
      if (!g2.match(/^[0-9a-f.:/]+$/)) {
        throw j;
      }
      if (g2.match(/^[0-9.]+$/)) {
        var b = g2.split(".");
        if (b.length !== 4) {
          throw j;
        }
        var h = "";
        try {
          for (var f2 = 0; f2 < 4; f2++) {
            var k = parseInt(b[f2]);
            h += ("0" + k.toString(16)).slice(-2);
          }
          return h;
        } catch (e) {
          throw j;
        }
      } else {
        if (g2.match(/^[0-9.]+\/[0-9]+$/)) {
          var c2 = g2.split("/");
          return iptohex(c2[0]) + ipnetmask(parseInt(c2[1]), 32);
        } else {
          if (g2.match(/^[0-9a-f:]+$/) && g2.indexOf(":") !== -1) {
            return ipv6tohex(g2);
          } else {
            if (g2.match(/^[0-9a-f:]+\/[0-9]+$/) && g2.indexOf(":") !== -1) {
              var c2 = g2.split("/");
              return ipv6tohex(c2[0]) + ipnetmask(parseInt(c2[1]), 128);
            } else {
              throw j;
            }
          }
        }
      }
    }
    function ipnetmask(d2, c2) {
      if (c2 == 32 && d2 == 0) {
        return "00000000";
      }
      if (c2 == 128 && d2 == 0) {
        return "00000000000000000000000000000000";
      }
      var a = Array(d2 + 1).join("1") + Array(c2 - d2 + 1).join("0");
      return new BigInteger(a, 2).toString(16);
    }
    function ucs2hextoutf8(d2) {
      function e(f2) {
        var h = parseInt(f2.substr(0, 2), 16);
        var a = parseInt(f2.substr(2), 16);
        if (h == 0 & a < 128) {
          return String.fromCharCode(a);
        }
        if (h < 8) {
          var j = 192 | (h & 7) << 3 | (a & 192) >> 6;
          var i = 128 | a & 63;
          return hextoutf8(j.toString(16) + i.toString(16));
        }
        var j = 224 | (h & 240) >> 4;
        var i = 128 | (h & 15) << 2 | (a & 192) >> 6;
        var g2 = 128 | a & 63;
        return hextoutf8(j.toString(16) + i.toString(16) + g2.toString(16));
      }
      var c2 = d2.match(/.{4}/g);
      var b = c2.map(e);
      return b.join("");
    }
    function encodeURIComponentAll(a) {
      var d2 = encodeURIComponent(a);
      var b = "";
      for (var c2 = 0; c2 < d2.length; c2++) {
        if (d2[c2] == "%") {
          b = b + d2.substr(c2, 3);
          c2 = c2 + 2;
        } else {
          b = b + "%" + stohex(d2[c2]);
        }
      }
      return b;
    }
    function newline_toUnix(a) {
      a = a.replace(/\r\n/mg, "\n");
      return a;
    }
    function newline_toDos(a) {
      a = a.replace(/\r\n/mg, "\n");
      a = a.replace(/\n/mg, "\r\n");
      return a;
    }
    KJUR.lang.String.isInteger = function(a) {
      if (a.match(/^[0-9]+$/)) {
        return true;
      } else {
        if (a.match(/^-[0-9]+$/)) {
          return true;
        } else {
          return false;
        }
      }
    };
    KJUR.lang.String.isHex = function(a) {
      return ishex(a);
    };
    function ishex(a) {
      if (a.length % 2 == 0 && (a.match(/^[0-9a-f]+$/) || a.match(/^[0-9A-F]+$/))) {
        return true;
      } else {
        return false;
      }
    }
    KJUR.lang.String.isBase64 = function(a) {
      a = a.replace(/\s+/g, "");
      if (a.match(/^[0-9A-Za-z+\/]+={0,3}$/) && a.length % 4 == 0) {
        return true;
      } else {
        return false;
      }
    };
    KJUR.lang.String.isBase64URL = function(a) {
      if (a.match(/[+/=]/)) {
        return false;
      }
      a = b64utob64(a);
      return KJUR.lang.String.isBase64(a);
    };
    function isBase64URLDot(a) {
      if (a.match(/^[0-9A-Za-z-_.]+$/)) {
        return true;
      }
      return false;
    }
    KJUR.lang.String.isIntegerArray = function(a) {
      a = a.replace(/\s+/g, "");
      if (a.match(/^\[[0-9,]+\]$/)) {
        return true;
      } else {
        return false;
      }
    };
    KJUR.lang.String.isPrintable = function(a) {
      if (a.match(/^[0-9A-Za-z '()+,-./:=?]*$/) !== null) {
        return true;
      }
      return false;
    };
    KJUR.lang.String.isIA5 = function(a) {
      if (a.match(/^[\x20-\x21\x23-\x7f]*$/) !== null) {
        return true;
      }
      return false;
    };
    KJUR.lang.String.isMail = function(a) {
      if (a.match(/^[A-Za-z0-9]{1}[A-Za-z0-9_.-]*@{1}[A-Za-z0-9_.-]{1,}\.[A-Za-z0-9]{1,}$/) !== null) {
        return true;
      }
      return false;
    };
    function hextoposhex(a) {
      if (a.length % 2 == 1) {
        return "0" + a;
      }
      if (a.substr(0, 1) > "7") {
        return "00" + a;
      }
      return a;
    }
    function intarystrtohex(b) {
      b = b.replace(/^\s*\[\s*/, "");
      b = b.replace(/\s*\]\s*$/, "");
      b = b.replace(/\s*/g, "");
      try {
        var c2 = b.split(/,/).map(function(g2, e, h) {
          var f2 = parseInt(g2);
          if (f2 < 0 || 255 < f2) {
            throw "integer not in range 0-255";
          }
          var d2 = ("00" + f2.toString(16)).slice(-2);
          return d2;
        }).join("");
        return c2;
      } catch (a) {
        throw "malformed integer array string: " + a;
      }
    }
    var strdiffidx = function(c2, a) {
      var d2 = c2.length;
      if (c2.length > a.length) {
        d2 = a.length;
      }
      for (var b = 0; b < d2; b++) {
        if (c2.charCodeAt(b) != a.charCodeAt(b)) {
          return b;
        }
      }
      if (c2.length != a.length) {
        return d2;
      }
      return -1;
    };
    function oidtohex(g2) {
      var f2 = function(a) {
        var l2 = a.toString(16);
        if (l2.length == 1) {
          l2 = "0" + l2;
        }
        return l2;
      };
      var e = function(p3) {
        var o2 = "";
        var l2 = parseInt(p3, 10);
        var a = l2.toString(2);
        var m2 = 7 - a.length % 7;
        if (m2 == 7) {
          m2 = 0;
        }
        var r = "";
        for (var n = 0; n < m2; n++) {
          r += "0";
        }
        a = r + a;
        for (var n = 0; n < a.length - 1; n += 7) {
          var q2 = a.substr(n, 7);
          if (n != a.length - 7) {
            q2 = "1" + q2;
          }
          o2 += f2(parseInt(q2, 2));
        }
        return o2;
      };
      try {
        if (!g2.match(/^[0-9.]+$/)) {
          return null;
        }
        var j = "";
        var b = g2.split(".");
        var k = parseInt(b[0], 10) * 40 + parseInt(b[1], 10);
        j += f2(k);
        b.splice(0, 2);
        for (var d2 = 0; d2 < b.length; d2++) {
          j += e(b[d2]);
        }
        return j;
      } catch (c2) {
        return null;
      }
    }
    function hextooid(g2) {
      if (!ishex(g2)) {
        return null;
      }
      try {
        var m2 = [];
        var p3 = g2.substr(0, 2);
        var e = parseInt(p3, 16);
        m2[0] = new String(Math.floor(e / 40));
        m2[1] = new String(e % 40);
        var n = g2.substr(2);
        var l2 = [];
        for (var f2 = 0; f2 < n.length / 2; f2++) {
          l2.push(parseInt(n.substr(f2 * 2, 2), 16));
        }
        var k = [];
        var d2 = "";
        for (var f2 = 0; f2 < l2.length; f2++) {
          if (l2[f2] & 128) {
            d2 = d2 + strpad((l2[f2] & 127).toString(2), 7);
          } else {
            d2 = d2 + strpad((l2[f2] & 127).toString(2), 7);
            k.push(new String(parseInt(d2, 2)));
            d2 = "";
          }
        }
        var o2 = m2.join(".");
        if (k.length > 0) {
          o2 = o2 + "." + k.join(".");
        }
        return o2;
      } catch (j) {
        return null;
      }
    }
    function inttohex(b) {
      var a = new BigInteger(String(b), 10);
      return twoscompl(a);
    }
    function twoscompl(b) {
      var g2 = b.toString(16);
      if (g2.substr(0, 1) != "-") {
        if (g2.length % 2 == 1) {
          g2 = "0" + g2;
        } else {
          if (!g2.match(/^[0-7]/)) {
            g2 = "00" + g2;
          }
        }
        return g2;
      }
      var a = g2.substr(1);
      var f2 = a.length;
      if (f2 % 2 == 1) {
        f2 += 1;
      } else {
        if (!g2.match(/^[0-7]/)) {
          f2 += 2;
        }
      }
      var j = "";
      for (var e = 0; e < f2; e++) {
        j += "f";
      }
      var d2 = new BigInteger(j, 16);
      var c2 = d2.xor(b).add(BigInteger.ONE);
      g2 = c2.toString(16).replace(/^-/, "");
      return g2;
    }
    var strpad = function(c2, b, a) {
      if (a == void 0) {
        a = "0";
      }
      if (c2.length >= b) {
        return c2;
      }
      return new Array(b - c2.length + 1).join(a) + c2;
    };
    function bitstrtoint(e) {
      if (e.length % 2 != 0) {
        return -1;
      }
      e = e.toLowerCase();
      if (e.match(/^[0-9a-f]+$/) == null) {
        return -1;
      }
      try {
        var a = e.substr(0, 2);
        if (a == "00") {
          return parseInt(e.substr(2), 16);
        }
        var b = parseInt(a, 16);
        if (b > 7) {
          return -1;
        }
        var g2 = e.substr(2);
        var d2 = parseInt(g2, 16).toString(2);
        if (d2 == "0") {
          d2 = "00000000";
        }
        d2 = d2.slice(0, 0 - b);
        var f2 = parseInt(d2, 2);
        if (f2 == NaN) {
          return -1;
        }
        return f2;
      } catch (c2) {
        return -1;
      }
    }
    function inttobitstr(e) {
      if (typeof e != "number") {
        return null;
      }
      if (e < 0) {
        return null;
      }
      var c2 = Number(e).toString(2);
      var b = 8 - c2.length % 8;
      if (b == 8) {
        b = 0;
      }
      c2 = c2 + strpad("", b, "0");
      var d2 = parseInt(c2, 2).toString(16);
      if (d2.length % 2 == 1) {
        d2 = "0" + d2;
      }
      var a = "0" + b;
      return a + d2;
    }
    function bitstrtobinstr(g2) {
      if (typeof g2 != "string") {
        return null;
      }
      if (g2.length % 2 != 0) {
        return null;
      }
      if (!g2.match(/^[0-9a-f]+$/)) {
        return null;
      }
      try {
        var c2 = parseInt(g2.substr(0, 2), 16);
        if (c2 < 0 || 7 < c2) {
          return null;
        }
        var j = g2.substr(2);
        var f2 = "";
        for (var e = 0; e < j.length; e += 2) {
          var b = j.substr(e, 2);
          var a = parseInt(b, 16).toString(2);
          a = ("0000000" + a).slice(-8);
          f2 += a;
        }
        return f2.substr(0, f2.length - c2);
      } catch (d2) {
        return null;
      }
    }
    function binstrtobitstr(b) {
      if (typeof b != "string") {
        return null;
      }
      if (b.match(/^[01]+$/) == null) {
        return null;
      }
      try {
        var c2 = parseInt(b, 2);
        return inttobitstr(c2);
      } catch (a) {
        return null;
      }
    }
    function namearraytobinstr(e, g2) {
      var f2 = 0;
      for (var a = 0; a < e.length; a++) {
        f2 |= 1 << g2[e[a]];
      }
      var b = f2.toString(2);
      var c2 = "";
      for (var a = b.length - 1; a >= 0; a--) {
        c2 += b[a];
      }
      return c2;
    }
    function aryval(e, c2, d2) {
      if (typeof e != "object") {
        return void 0;
      }
      var c2 = String(c2).split(".");
      for (var b = 0; b < c2.length && e; b++) {
        var a = c2[b];
        if (a.match(/^[0-9]+$/)) {
          a = parseInt(a);
        }
        e = e[a];
      }
      return e || e === false ? e : d2;
    }
    function extendClass(c2, a) {
      var b = function() {
      };
      b.prototype = a.prototype;
      c2.prototype = new b();
      c2.prototype.constructor = c2;
      c2.superclass = a.prototype;
      if (a.prototype.constructor == Object.prototype.constructor) {
        a.prototype.constructor = a;
      }
    }
    if (typeof KJUR == "undefined" || !KJUR) {
      KJUR = {};
    }
    if (typeof KJUR.crypto == "undefined" || !KJUR.crypto) {
      KJUR.crypto = {};
    }
    KJUR.crypto.Util = new function() {
      this.DIGESTINFOHEAD = { sha1: "3021300906052b0e03021a05000414", sha224: "302d300d06096086480165030402040500041c", sha256: "3031300d060960864801650304020105000420", sha384: "3041300d060960864801650304020205000430", sha512: "3051300d060960864801650304020305000440", md2: "3020300c06082a864886f70d020205000410", md5: "3020300c06082a864886f70d020505000410", ripemd160: "3021300906052b2403020105000414" };
      this.DEFAULTPROVIDER = { md5: "cryptojs", sha1: "cryptojs", sha224: "cryptojs", sha256: "cryptojs", sha384: "cryptojs", sha512: "cryptojs", ripemd160: "cryptojs", hmacmd5: "cryptojs", hmacsha1: "cryptojs", hmacsha224: "cryptojs", hmacsha256: "cryptojs", hmacsha384: "cryptojs", hmacsha512: "cryptojs", hmacripemd160: "cryptojs", MD5withRSA: "cryptojs/jsrsa", SHA1withRSA: "cryptojs/jsrsa", SHA224withRSA: "cryptojs/jsrsa", SHA256withRSA: "cryptojs/jsrsa", SHA384withRSA: "cryptojs/jsrsa", SHA512withRSA: "cryptojs/jsrsa", RIPEMD160withRSA: "cryptojs/jsrsa", MD5withECDSA: "cryptojs/jsrsa", SHA1withECDSA: "cryptojs/jsrsa", SHA224withECDSA: "cryptojs/jsrsa", SHA256withECDSA: "cryptojs/jsrsa", SHA384withECDSA: "cryptojs/jsrsa", SHA512withECDSA: "cryptojs/jsrsa", RIPEMD160withECDSA: "cryptojs/jsrsa", SHA1withDSA: "cryptojs/jsrsa", SHA224withDSA: "cryptojs/jsrsa", SHA256withDSA: "cryptojs/jsrsa", MD5withRSAandMGF1: "cryptojs/jsrsa", SHAwithRSAandMGF1: "cryptojs/jsrsa", SHA1withRSAandMGF1: "cryptojs/jsrsa", SHA224withRSAandMGF1: "cryptojs/jsrsa", SHA256withRSAandMGF1: "cryptojs/jsrsa", SHA384withRSAandMGF1: "cryptojs/jsrsa", SHA512withRSAandMGF1: "cryptojs/jsrsa", RIPEMD160withRSAandMGF1: "cryptojs/jsrsa" };
      this.CRYPTOJSMESSAGEDIGESTNAME = { md5: CryptoJS.algo.MD5, sha1: CryptoJS.algo.SHA1, sha224: CryptoJS.algo.SHA224, sha256: CryptoJS.algo.SHA256, sha384: CryptoJS.algo.SHA384, sha512: CryptoJS.algo.SHA512, ripemd160: CryptoJS.algo.RIPEMD160 };
      this.getDigestInfoHex = function(a, b) {
        if (typeof this.DIGESTINFOHEAD[b] == "undefined") {
          throw "alg not supported in Util.DIGESTINFOHEAD: " + b;
        }
        return this.DIGESTINFOHEAD[b] + a;
      };
      this.getPaddedDigestInfoHex = function(h, a, j) {
        var c2 = this.getDigestInfoHex(h, a);
        var d2 = j / 4;
        if (c2.length + 22 > d2) {
          throw "key is too short for SigAlg: keylen=" + j + "," + a;
        }
        var b = "0001";
        var k = "00" + c2;
        var g2 = "";
        var l2 = d2 - b.length - k.length;
        for (var f2 = 0; f2 < l2; f2 += 2) {
          g2 += "ff";
        }
        var e = b + g2 + k;
        return e;
      };
      this.hashString = function(a, c2) {
        var b = new KJUR.crypto.MessageDigest({ alg: c2 });
        return b.digestString(a);
      };
      this.hashHex = function(b, c2) {
        var a = new KJUR.crypto.MessageDigest({ alg: c2 });
        return a.digestHex(b);
      };
      this.sha1 = function(a) {
        return this.hashString(a, "sha1");
      };
      this.sha256 = function(a) {
        return this.hashString(a, "sha256");
      };
      this.sha256Hex = function(a) {
        return this.hashHex(a, "sha256");
      };
      this.sha512 = function(a) {
        return this.hashString(a, "sha512");
      };
      this.sha512Hex = function(a) {
        return this.hashHex(a, "sha512");
      };
      this.isKey = function(a) {
        if (a instanceof RSAKey || a instanceof KJUR.crypto.DSA || a instanceof KJUR.crypto.ECDSA) {
          return true;
        } else {
          return false;
        }
      };
    }();
    KJUR.crypto.Util.md5 = function(a) {
      var b = new KJUR.crypto.MessageDigest({ alg: "md5", prov: "cryptojs" });
      return b.digestString(a);
    };
    KJUR.crypto.Util.ripemd160 = function(a) {
      var b = new KJUR.crypto.MessageDigest({ alg: "ripemd160", prov: "cryptojs" });
      return b.digestString(a);
    };
    KJUR.crypto.Util.SECURERANDOMGEN = new SecureRandom2();
    KJUR.crypto.Util.getRandomHexOfNbytes = function(b) {
      var a = new Array(b);
      KJUR.crypto.Util.SECURERANDOMGEN.nextBytes(a);
      return BAtohex(a);
    };
    KJUR.crypto.Util.getRandomBigIntegerOfNbytes = function(a) {
      return new BigInteger(KJUR.crypto.Util.getRandomHexOfNbytes(a), 16);
    };
    KJUR.crypto.Util.getRandomHexOfNbits = function(d2) {
      var c2 = d2 % 8;
      var a = (d2 - c2) / 8;
      var b = new Array(a + 1);
      KJUR.crypto.Util.SECURERANDOMGEN.nextBytes(b);
      b[0] = (255 << c2 & 255 ^ 255) & b[0];
      return BAtohex(b);
    };
    KJUR.crypto.Util.getRandomBigIntegerOfNbits = function(a) {
      return new BigInteger(KJUR.crypto.Util.getRandomHexOfNbits(a), 16);
    };
    KJUR.crypto.Util.getRandomBigIntegerZeroToMax = function(b) {
      var a = b.bitLength();
      while (1) {
        var c2 = KJUR.crypto.Util.getRandomBigIntegerOfNbits(a);
        if (b.compareTo(c2) != -1) {
          return c2;
        }
      }
    };
    KJUR.crypto.Util.getRandomBigIntegerMinToMax = function(e, b) {
      var c2 = e.compareTo(b);
      if (c2 == 1) {
        throw "biMin is greater than biMax";
      }
      if (c2 == 0) {
        return e;
      }
      var a = b.subtract(e);
      var d2 = KJUR.crypto.Util.getRandomBigIntegerZeroToMax(a);
      return d2.add(e);
    };
    KJUR.crypto.MessageDigest = function(c2) {
      var b = null;
      var a = null;
      var d2 = null;
      this.setAlgAndProvider = function(g2, f2) {
        g2 = KJUR.crypto.MessageDigest.getCanonicalAlgName(g2);
        if (g2 !== null && f2 === void 0) {
          f2 = KJUR.crypto.Util.DEFAULTPROVIDER[g2];
        }
        if (":md5:sha1:sha224:sha256:sha384:sha512:ripemd160:".indexOf(g2) != -1 && f2 == "cryptojs") {
          try {
            this.md = KJUR.crypto.Util.CRYPTOJSMESSAGEDIGESTNAME[g2].create();
          } catch (e) {
            throw "setAlgAndProvider hash alg set fail alg=" + g2 + "/" + e;
          }
          this.updateString = function(h) {
            this.md.update(h);
          };
          this.updateHex = function(h) {
            var i = CryptoJS.enc.Hex.parse(h);
            this.md.update(i);
          };
          this.digest = function() {
            var h = this.md.finalize();
            return h.toString(CryptoJS.enc.Hex);
          };
          this.digestString = function(h) {
            this.updateString(h);
            return this.digest();
          };
          this.digestHex = function(h) {
            this.updateHex(h);
            return this.digest();
          };
        }
        if (":sha256:".indexOf(g2) != -1 && f2 == "sjcl") {
          try {
            this.md = new sjcl.hash.sha256();
          } catch (e) {
            throw "setAlgAndProvider hash alg set fail alg=" + g2 + "/" + e;
          }
          this.updateString = function(h) {
            this.md.update(h);
          };
          this.updateHex = function(i) {
            var h = sjcl.codec.hex.toBits(i);
            this.md.update(h);
          };
          this.digest = function() {
            var h = this.md.finalize();
            return sjcl.codec.hex.fromBits(h);
          };
          this.digestString = function(h) {
            this.updateString(h);
            return this.digest();
          };
          this.digestHex = function(h) {
            this.updateHex(h);
            return this.digest();
          };
        }
      };
      this.updateString = function(e) {
        throw "updateString(str) not supported for this alg/prov: " + this.algName + "/" + this.provName;
      };
      this.updateHex = function(e) {
        throw "updateHex(hex) not supported for this alg/prov: " + this.algName + "/" + this.provName;
      };
      this.digest = function() {
        throw "digest() not supported for this alg/prov: " + this.algName + "/" + this.provName;
      };
      this.digestString = function(e) {
        throw "digestString(str) not supported for this alg/prov: " + this.algName + "/" + this.provName;
      };
      this.digestHex = function(e) {
        throw "digestHex(hex) not supported for this alg/prov: " + this.algName + "/" + this.provName;
      };
      if (c2 !== void 0) {
        if (c2.alg !== void 0) {
          this.algName = c2.alg;
          if (c2.prov === void 0) {
            this.provName = KJUR.crypto.Util.DEFAULTPROVIDER[this.algName];
          }
          this.setAlgAndProvider(this.algName, this.provName);
        }
      }
    };
    KJUR.crypto.MessageDigest.getCanonicalAlgName = function(a) {
      if (typeof a === "string") {
        a = a.toLowerCase();
        a = a.replace(/-/, "");
      }
      return a;
    };
    KJUR.crypto.MessageDigest.getHashLength = function(c2) {
      var b = KJUR.crypto.MessageDigest;
      var a = b.getCanonicalAlgName(c2);
      if (b.HASHLENGTH[a] === void 0) {
        throw "not supported algorithm: " + c2;
      }
      return b.HASHLENGTH[a];
    };
    KJUR.crypto.MessageDigest.HASHLENGTH = { md5: 16, sha1: 20, sha224: 28, sha256: 32, sha384: 48, sha512: 64, ripemd160: 20 };
    KJUR.crypto.Mac = function(d2) {
      var f2 = null;
      var c2 = null;
      var a = null;
      var e = null;
      var b = null;
      this.setAlgAndProvider = function(k, i) {
        k = k.toLowerCase();
        if (k == null) {
          k = "hmacsha1";
        }
        k = k.toLowerCase();
        if (k.substr(0, 4) != "hmac") {
          throw "setAlgAndProvider unsupported HMAC alg: " + k;
        }
        if (i === void 0) {
          i = KJUR.crypto.Util.DEFAULTPROVIDER[k];
        }
        this.algProv = k + "/" + i;
        var g2 = k.substr(4);
        if (":md5:sha1:sha224:sha256:sha384:sha512:ripemd160:".indexOf(g2) != -1 && i == "cryptojs") {
          try {
            var j = KJUR.crypto.Util.CRYPTOJSMESSAGEDIGESTNAME[g2];
            this.mac = CryptoJS.algo.HMAC.create(j, this.pass);
          } catch (h) {
            throw "setAlgAndProvider hash alg set fail hashAlg=" + g2 + "/" + h;
          }
          this.updateString = function(l2) {
            this.mac.update(l2);
          };
          this.updateHex = function(l2) {
            var m2 = CryptoJS.enc.Hex.parse(l2);
            this.mac.update(m2);
          };
          this.doFinal = function() {
            var l2 = this.mac.finalize();
            return l2.toString(CryptoJS.enc.Hex);
          };
          this.doFinalString = function(l2) {
            this.updateString(l2);
            return this.doFinal();
          };
          this.doFinalHex = function(l2) {
            this.updateHex(l2);
            return this.doFinal();
          };
        }
      };
      this.updateString = function(g2) {
        throw "updateString(str) not supported for this alg/prov: " + this.algProv;
      };
      this.updateHex = function(g2) {
        throw "updateHex(hex) not supported for this alg/prov: " + this.algProv;
      };
      this.doFinal = function() {
        throw "digest() not supported for this alg/prov: " + this.algProv;
      };
      this.doFinalString = function(g2) {
        throw "digestString(str) not supported for this alg/prov: " + this.algProv;
      };
      this.doFinalHex = function(g2) {
        throw "digestHex(hex) not supported for this alg/prov: " + this.algProv;
      };
      this.setPassword = function(h) {
        if (typeof h == "string") {
          var g2 = h;
          if (h.length % 2 == 1 || !h.match(/^[0-9A-Fa-f]+$/)) {
            g2 = rstrtohex(h);
          }
          this.pass = CryptoJS.enc.Hex.parse(g2);
          return;
        }
        if (typeof h != "object") {
          throw "KJUR.crypto.Mac unsupported password type: " + h;
        }
        var g2 = null;
        if (h.hex !== void 0) {
          if (h.hex.length % 2 != 0 || !h.hex.match(/^[0-9A-Fa-f]+$/)) {
            throw "Mac: wrong hex password: " + h.hex;
          }
          g2 = h.hex;
        }
        if (h.utf8 !== void 0) {
          g2 = utf8tohex(h.utf8);
        }
        if (h.rstr !== void 0) {
          g2 = rstrtohex(h.rstr);
        }
        if (h.b64 !== void 0) {
          g2 = b64tohex(h.b64);
        }
        if (h.b64u !== void 0) {
          g2 = b64utohex(h.b64u);
        }
        if (g2 == null) {
          throw "KJUR.crypto.Mac unsupported password type: " + h;
        }
        this.pass = CryptoJS.enc.Hex.parse(g2);
      };
      if (d2 !== void 0) {
        if (d2.pass !== void 0) {
          this.setPassword(d2.pass);
        }
        if (d2.alg !== void 0) {
          this.algName = d2.alg;
          if (d2.prov === void 0) {
            this.provName = KJUR.crypto.Util.DEFAULTPROVIDER[this.algName];
          }
          this.setAlgAndProvider(this.algName, this.provName);
        }
      }
    };
    KJUR.crypto.Signature = function(o2) {
      var q2 = null;
      var n = null;
      var r = null;
      var c2 = null;
      var l2 = null;
      var d2 = null;
      var k = null;
      var h = null;
      var p3 = null;
      var e = null;
      var b = -1;
      var g2 = null;
      var j = null;
      var a = null;
      var i = null;
      var f2 = null;
      this._setAlgNames = function() {
        var s = this.algName.match(/^(.+)with(.+)$/);
        if (s) {
          this.mdAlgName = s[1].toLowerCase();
          this.pubkeyAlgName = s[2].toLowerCase();
          if (this.pubkeyAlgName == "rsaandmgf1" && this.mdAlgName == "sha") {
            this.mdAlgName = "sha1";
          }
        }
      };
      this._zeroPaddingOfSignature = function(x2, w) {
        var v = "";
        var t2 = w / 4 - x2.length;
        for (var u2 = 0; u2 < t2; u2++) {
          v = v + "0";
        }
        return v + x2;
      };
      this.setAlgAndProvider = function(u2, t2) {
        this._setAlgNames();
        if (t2 != "cryptojs/jsrsa") {
          throw new Error("provider not supported: " + t2);
        }
        if (":md5:sha1:sha224:sha256:sha384:sha512:ripemd160:".indexOf(this.mdAlgName) != -1) {
          try {
            this.md = new KJUR.crypto.MessageDigest({ alg: this.mdAlgName });
          } catch (s) {
            throw new Error("setAlgAndProvider hash alg set fail alg=" + this.mdAlgName + "/" + s);
          }
          this.init = function(w, x2) {
            var y = null;
            try {
              if (x2 === void 0) {
                y = KEYUTIL.getKey(w);
              } else {
                y = KEYUTIL.getKey(w, x2);
              }
            } catch (v) {
              throw "init failed:" + v;
            }
            if (y.isPrivate === true) {
              this.prvKey = y;
              this.state = "SIGN";
            } else {
              if (y.isPublic === true) {
                this.pubKey = y;
                this.state = "VERIFY";
              } else {
                throw "init failed.:" + y;
              }
            }
          };
          this.updateString = function(v) {
            this.md.updateString(v);
          };
          this.updateHex = function(v) {
            this.md.updateHex(v);
          };
          this.sign = function() {
            this.sHashHex = this.md.digest();
            if (this.prvKey === void 0 && this.ecprvhex !== void 0 && this.eccurvename !== void 0 && KJUR.crypto.ECDSA !== void 0) {
              this.prvKey = new KJUR.crypto.ECDSA({ curve: this.eccurvename, prv: this.ecprvhex });
            }
            if (this.prvKey instanceof RSAKey && this.pubkeyAlgName === "rsaandmgf1") {
              this.hSign = this.prvKey.signWithMessageHashPSS(this.sHashHex, this.mdAlgName, this.pssSaltLen);
            } else {
              if (this.prvKey instanceof RSAKey && this.pubkeyAlgName === "rsa") {
                this.hSign = this.prvKey.signWithMessageHash(this.sHashHex, this.mdAlgName);
              } else {
                if (this.prvKey instanceof KJUR.crypto.ECDSA) {
                  this.hSign = this.prvKey.signWithMessageHash(this.sHashHex);
                } else {
                  if (this.prvKey instanceof KJUR.crypto.DSA) {
                    this.hSign = this.prvKey.signWithMessageHash(this.sHashHex);
                  } else {
                    throw "Signature: unsupported private key alg: " + this.pubkeyAlgName;
                  }
                }
              }
            }
            return this.hSign;
          };
          this.signString = function(v) {
            this.updateString(v);
            return this.sign();
          };
          this.signHex = function(v) {
            this.updateHex(v);
            return this.sign();
          };
          this.verify = function(v) {
            this.sHashHex = this.md.digest();
            if (this.pubKey === void 0 && this.ecpubhex !== void 0 && this.eccurvename !== void 0 && KJUR.crypto.ECDSA !== void 0) {
              this.pubKey = new KJUR.crypto.ECDSA({ curve: this.eccurvename, pub: this.ecpubhex });
            }
            if (this.pubKey instanceof RSAKey && this.pubkeyAlgName === "rsaandmgf1") {
              return this.pubKey.verifyWithMessageHashPSS(this.sHashHex, v, this.mdAlgName, this.pssSaltLen);
            } else {
              if (this.pubKey instanceof RSAKey && this.pubkeyAlgName === "rsa") {
                return this.pubKey.verifyWithMessageHash(this.sHashHex, v);
              } else {
                if (KJUR.crypto.ECDSA !== void 0 && this.pubKey instanceof KJUR.crypto.ECDSA) {
                  return this.pubKey.verifyWithMessageHash(this.sHashHex, v);
                } else {
                  if (KJUR.crypto.DSA !== void 0 && this.pubKey instanceof KJUR.crypto.DSA) {
                    return this.pubKey.verifyWithMessageHash(this.sHashHex, v);
                  } else {
                    throw "Signature: unsupported public key alg: " + this.pubkeyAlgName;
                  }
                }
              }
            }
          };
        }
      };
      this.init = function(s, t2) {
        throw "init(key, pass) not supported for this alg:prov=" + this.algProvName;
      };
      this.updateString = function(s) {
        throw "updateString(str) not supported for this alg:prov=" + this.algProvName;
      };
      this.updateHex = function(s) {
        throw "updateHex(hex) not supported for this alg:prov=" + this.algProvName;
      };
      this.sign = function() {
        throw "sign() not supported for this alg:prov=" + this.algProvName;
      };
      this.signString = function(s) {
        throw "digestString(str) not supported for this alg:prov=" + this.algProvName;
      };
      this.signHex = function(s) {
        throw "digestHex(hex) not supported for this alg:prov=" + this.algProvName;
      };
      this.verify = function(s) {
        throw "verify(hSigVal) not supported for this alg:prov=" + this.algProvName;
      };
      this.initParams = o2;
      if (o2 !== void 0) {
        if (o2.alg !== void 0) {
          this.algName = o2.alg;
          if (o2.prov === void 0) {
            this.provName = KJUR.crypto.Util.DEFAULTPROVIDER[this.algName];
          } else {
            this.provName = o2.prov;
          }
          this.algProvName = this.algName + ":" + this.provName;
          this.setAlgAndProvider(this.algName, this.provName);
          this._setAlgNames();
        }
        if (o2.psssaltlen !== void 0) {
          this.pssSaltLen = o2.psssaltlen;
        }
        if (o2.prvkeypem !== void 0) {
          if (o2.prvkeypas !== void 0) {
            throw "both prvkeypem and prvkeypas parameters not supported";
          } else {
            try {
              var q2 = KEYUTIL.getKey(o2.prvkeypem);
              this.init(q2);
            } catch (m2) {
              throw "fatal error to load pem private key: " + m2;
            }
          }
        }
      }
    };
    KJUR.crypto.Cipher = function(a) {
    };
    KJUR.crypto.Cipher.encrypt = function(j, i, b, c2) {
      if (aryval(c2, "enclag") != void 0) {
        b = c2.encalg;
      }
      if (typeof b == "string" && b.substr(-4) == "-CBC") {
        var g2 = i;
        var e = j;
        if (aryval(c2, "key") != void 0) {
          g2 = c2.key;
        }
        if (aryval(c2, "enc") != void 0) {
          hEnc = c2.enc;
        }
        var h = CryptoJS.enc.Hex.parse(g2);
        var a = CryptoJS.enc.Hex.parse(e);
        var f2 = CryptoJS.enc.Hex.parse(c2.iv);
        var d2;
        if (b == "des-EDE3-CBC") {
          d2 = CryptoJS.TripleDES.encrypt(a, h, { iv: f2 });
        } else {
          if (b == "aes128-CBC" || b == "aes256-CBC") {
            d2 = CryptoJS.AES.encrypt(a, h, { iv: f2 });
          } else {
            throw new Error("unsupported algorithm: " + b);
          }
        }
        return d2 + "";
      } else {
        throw new Error("Cipher.encrypt: unsupported key or algorithm");
      }
    };
    KJUR.crypto.Cipher.decrypt = function(c2, j, a, b) {
      if (aryval(b, "enclag") != void 0) {
        a = b.encalg;
      }
      if (typeof a == "string" && a.substr(-4) == "-CBC") {
        var h = j;
        var e = c2;
        if (aryval(b, "key") != void 0) {
          h = b.key;
        }
        if (aryval(b, "enc") != void 0) {
          e = b.enc;
        }
        var i = CryptoJS.enc.Hex.parse(h);
        var f2 = CryptoJS.enc.Hex.parse(e);
        var g2 = CryptoJS.enc.Hex.parse(b.iv);
        var d2;
        if (a == "des-EDE3-CBC") {
          d2 = CryptoJS.TripleDES.decrypt({ ciphertext: f2 }, i, { iv: g2 });
        } else {
          if (a == "aes128-CBC" || a == "aes256-CBC") {
            d2 = CryptoJS.AES.decrypt({ ciphertext: f2 }, i, { iv: g2 });
          } else {
            throw new Error("unsupported algorithm: " + a);
          }
        }
        return CryptoJS.enc.Hex.stringify(d2);
      } else {
        throw new Error("Cipher.decrypt: unsupported key or algorithm");
      }
    };
    KJUR.crypto.OID = new function() {
      this.oidhex2name = { "2a864886f70d010101": "rsaEncryption", "2a8648ce3d0201": "ecPublicKey", "2a8648ce380401": "dsa", "2a8648ce3d030107": "secp256r1", "2b8104001f": "secp192k1", "2b81040021": "secp224r1", "2b8104000a": "secp256k1", "2b81040022": "secp384r1", "2b81040023": "secp521r1", "2a8648ce380403": "SHA1withDSA", "608648016503040301": "SHA224withDSA", "608648016503040302": "SHA256withDSA" };
    }();
    if (typeof KJUR == "undefined" || !KJUR) {
      KJUR = {};
    }
    if (typeof KJUR.crypto == "undefined" || !KJUR.crypto) {
      KJUR.crypto = {};
    }
    KJUR.crypto.ECDSA = function(e) {
      var g2 = "secp256r1";
      var p3 = null;
      var b = null;
      var i = null;
      var j = Error, f2 = BigInteger, h = ECPointFp, m2 = KJUR.crypto.ECDSA, c2 = KJUR.crypto.ECParameterDB, d2 = m2.getName, q2 = ASN1HEX, n = q2.getVbyListEx, k = q2.isASN1HEX;
      var a = new SecureRandom2();
      var o2 = null;
      this.type = "EC";
      this.isPrivate = false;
      this.isPublic = false;
      function l2(x2, t2, w, s) {
        var r = Math.max(t2.bitLength(), s.bitLength());
        var y = x2.add2D(w);
        var v = x2.curve.getInfinity();
        for (var u2 = r - 1; u2 >= 0; --u2) {
          v = v.twice2D();
          v.z = f2.ONE;
          if (t2.testBit(u2)) {
            if (s.testBit(u2)) {
              v = v.add2D(y);
            } else {
              v = v.add2D(x2);
            }
          } else {
            if (s.testBit(u2)) {
              v = v.add2D(w);
            }
          }
        }
        return v;
      }
      this.getBigRandom = function(r) {
        return new f2(r.bitLength(), a).mod(r.subtract(f2.ONE)).add(f2.ONE);
      };
      this.setNamedCurve = function(r) {
        this.ecparams = c2.getByName(r);
        this.prvKeyHex = null;
        this.pubKeyHex = null;
        this.curveName = r;
      };
      this.setPrivateKeyHex = function(r) {
        this.isPrivate = true;
        this.prvKeyHex = r;
      };
      this.setPublicKeyHex = function(r) {
        this.isPublic = true;
        this.pubKeyHex = r;
      };
      this.getPublicKeyXYHex = function() {
        var t2 = this.pubKeyHex;
        if (t2.substr(0, 2) !== "04") {
          throw "this method supports uncompressed format(04) only";
        }
        var s = this.ecparams.keycharlen;
        if (t2.length !== 2 + s * 2) {
          throw "malformed public key hex length";
        }
        var r = {};
        r.x = t2.substr(2, s);
        r.y = t2.substr(2 + s);
        return r;
      };
      this.getShortNISTPCurveName = function() {
        var r = this.curveName;
        if (r === "secp256r1" || r === "NIST P-256" || r === "P-256" || r === "prime256v1") {
          return "P-256";
        }
        if (r === "secp384r1" || r === "NIST P-384" || r === "P-384") {
          return "P-384";
        }
        if (r === "secp521r1" || r === "NIST P-521" || r === "P-521") {
          return "P-521";
        }
        return null;
      };
      this.generateKeyPairHex = function() {
        var s = this.ecparams.n;
        var u2 = this.getBigRandom(s);
        var r = this.ecparams.keycharlen;
        var t2 = ("0000000000" + u2.toString(16)).slice(-r);
        this.setPrivateKeyHex(t2);
        var v = this.generatePublicKeyHex();
        return { ecprvhex: t2, ecpubhex: v };
      };
      this.generatePublicKeyHex = function() {
        var u2 = new f2(this.prvKeyHex, 16);
        var w = this.ecparams.G.multiply(u2);
        var t2 = w.getX().toBigInteger();
        var s = w.getY().toBigInteger();
        var r = this.ecparams.keycharlen;
        var y = ("0000000000" + t2.toString(16)).slice(-r);
        var v = ("0000000000" + s.toString(16)).slice(-r);
        var x2 = "04" + y + v;
        this.setPublicKeyHex(x2);
        return x2;
      };
      this.signWithMessageHash = function(r) {
        return this.signHex(r, this.prvKeyHex);
      };
      this.signHex = function(x2, u2) {
        var A = new f2(u2, 16);
        var v = this.ecparams.n;
        var z2 = new f2(x2.substring(0, this.ecparams.keycharlen), 16);
        do {
          var w = this.getBigRandom(v);
          var B = this.ecparams.G;
          var y = B.multiply(w);
          var t2 = y.getX().toBigInteger().mod(v);
        } while (t2.compareTo(f2.ZERO) <= 0);
        var C = w.modInverse(v).multiply(z2.add(A.multiply(t2))).mod(v);
        return m2.biRSSigToASN1Sig(t2, C);
      };
      this.sign = function(w, B) {
        var z2 = B;
        var u2 = this.ecparams.n;
        var y = f2.fromByteArrayUnsigned(w);
        do {
          var v = this.getBigRandom(u2);
          var A = this.ecparams.G;
          var x2 = A.multiply(v);
          var t2 = x2.getX().toBigInteger().mod(u2);
        } while (t2.compareTo(BigInteger.ZERO) <= 0);
        var C = v.modInverse(u2).multiply(y.add(z2.multiply(t2))).mod(u2);
        return this.serializeSig(t2, C);
      };
      this.verifyWithMessageHash = function(s, r) {
        return this.verifyHex(s, r, this.pubKeyHex);
      };
      this.verifyHex = function(v, y, u2) {
        try {
          var t2, B;
          var w = m2.parseSigHex(y);
          t2 = w.r;
          B = w.s;
          var x2 = h.decodeFromHex(this.ecparams.curve, u2);
          var z2 = new f2(v.substring(0, this.ecparams.keycharlen), 16);
          return this.verifyRaw(z2, t2, B, x2);
        } catch (A) {
          return false;
        }
      };
      this.verify = function(z2, A, u2) {
        var w, t2;
        if (Bitcoin.Util.isArray(A)) {
          var y = this.parseSig(A);
          w = y.r;
          t2 = y.s;
        } else {
          if ("object" === typeof A && A.r && A.s) {
            w = A.r;
            t2 = A.s;
          } else {
            throw "Invalid value for signature";
          }
        }
        var v;
        if (u2 instanceof ECPointFp) {
          v = u2;
        } else {
          if (Bitcoin.Util.isArray(u2)) {
            v = h.decodeFrom(this.ecparams.curve, u2);
          } else {
            throw "Invalid format for pubkey value, must be byte array or ECPointFp";
          }
        }
        var x2 = f2.fromByteArrayUnsigned(z2);
        return this.verifyRaw(x2, w, t2, v);
      };
      this.verifyRaw = function(z2, t2, E, y) {
        var x2 = this.ecparams.n;
        var D = this.ecparams.G;
        if (t2.compareTo(f2.ONE) < 0 || t2.compareTo(x2) >= 0) {
          return false;
        }
        if (E.compareTo(f2.ONE) < 0 || E.compareTo(x2) >= 0) {
          return false;
        }
        var A = E.modInverse(x2);
        var w = z2.multiply(A).mod(x2);
        var u2 = t2.multiply(A).mod(x2);
        var B = D.multiply(w).add(y.multiply(u2));
        var C = B.getX().toBigInteger().mod(x2);
        return C.equals(t2);
      };
      this.serializeSig = function(v, u2) {
        var w = v.toByteArraySigned();
        var t2 = u2.toByteArraySigned();
        var x2 = [];
        x2.push(2);
        x2.push(w.length);
        x2 = x2.concat(w);
        x2.push(2);
        x2.push(t2.length);
        x2 = x2.concat(t2);
        x2.unshift(x2.length);
        x2.unshift(48);
        return x2;
      };
      this.parseSig = function(y) {
        var x2;
        if (y[0] != 48) {
          throw new Error("Signature not a valid DERSequence");
        }
        x2 = 2;
        if (y[x2] != 2) {
          throw new Error("First element in signature must be a DERInteger");
        }
        var w = y.slice(x2 + 2, x2 + 2 + y[x2 + 1]);
        x2 += 2 + y[x2 + 1];
        if (y[x2] != 2) {
          throw new Error("Second element in signature must be a DERInteger");
        }
        var t2 = y.slice(x2 + 2, x2 + 2 + y[x2 + 1]);
        x2 += 2 + y[x2 + 1];
        var v = f2.fromByteArrayUnsigned(w);
        var u2 = f2.fromByteArrayUnsigned(t2);
        return { r: v, s: u2 };
      };
      this.parseSigCompact = function(w) {
        if (w.length !== 65) {
          throw "Signature has the wrong length";
        }
        var t2 = w[0] - 27;
        if (t2 < 0 || t2 > 7) {
          throw "Invalid signature type";
        }
        var x2 = this.ecparams.n;
        var v = f2.fromByteArrayUnsigned(w.slice(1, 33)).mod(x2);
        var u2 = f2.fromByteArrayUnsigned(w.slice(33, 65)).mod(x2);
        return { r: v, s: u2, i: t2 };
      };
      this.readPKCS5PrvKeyHex = function(u2) {
        if (k(u2) === false) {
          throw new Error("not ASN.1 hex string");
        }
        var r, t2, v;
        try {
          r = n(u2, 0, ["[0]", 0], "06");
          t2 = n(u2, 0, [1], "04");
          try {
            v = n(u2, 0, ["[1]", 0], "03");
          } catch (s) {
          }
        } catch (s) {
          throw new Error("malformed PKCS#1/5 plain ECC private key");
        }
        this.curveName = d2(r);
        if (this.curveName === void 0) {
          throw "unsupported curve name";
        }
        this.setNamedCurve(this.curveName);
        this.setPublicKeyHex(v);
        this.setPrivateKeyHex(t2);
        this.isPublic = false;
      };
      this.readPKCS8PrvKeyHex = function(v) {
        if (k(v) === false) {
          throw new j("not ASN.1 hex string");
        }
        var t2, r, u2, w;
        try {
          t2 = n(v, 0, [1, 0], "06");
          r = n(v, 0, [1, 1], "06");
          u2 = n(v, 0, [2, 0, 1], "04");
          try {
            w = n(v, 0, [2, 0, "[1]", 0], "03");
          } catch (s) {
          }
        } catch (s) {
          throw new j("malformed PKCS#8 plain ECC private key");
        }
        this.curveName = d2(r);
        if (this.curveName === void 0) {
          throw new j("unsupported curve name");
        }
        this.setNamedCurve(this.curveName);
        this.setPublicKeyHex(w);
        this.setPrivateKeyHex(u2);
        this.isPublic = false;
      };
      this.readPKCS8PubKeyHex = function(u2) {
        if (k(u2) === false) {
          throw new j("not ASN.1 hex string");
        }
        var t2, r, v;
        try {
          t2 = n(u2, 0, [0, 0], "06");
          r = n(u2, 0, [0, 1], "06");
          v = n(u2, 0, [1], "03");
        } catch (s) {
          throw new j("malformed PKCS#8 ECC public key");
        }
        this.curveName = d2(r);
        if (this.curveName === null) {
          throw new j("unsupported curve name");
        }
        this.setNamedCurve(this.curveName);
        this.setPublicKeyHex(v);
      };
      this.readCertPubKeyHex = function(t2, v) {
        if (k(t2) === false) {
          throw new j("not ASN.1 hex string");
        }
        var r, u2;
        try {
          r = n(t2, 0, [0, 5, 0, 1], "06");
          u2 = n(t2, 0, [0, 5, 1], "03");
        } catch (s) {
          throw new j("malformed X.509 certificate ECC public key");
        }
        this.curveName = d2(r);
        if (this.curveName === null) {
          throw new j("unsupported curve name");
        }
        this.setNamedCurve(this.curveName);
        this.setPublicKeyHex(u2);
      };
      if (e !== void 0) {
        if (e.curve !== void 0) {
          this.curveName = e.curve;
        }
      }
      if (this.curveName === void 0) {
        this.curveName = g2;
      }
      this.setNamedCurve(this.curveName);
      if (e !== void 0) {
        if (e.prv !== void 0) {
          this.setPrivateKeyHex(e.prv);
        }
        if (e.pub !== void 0) {
          this.setPublicKeyHex(e.pub);
        }
      }
    };
    KJUR.crypto.ECDSA.parseSigHex = function(a) {
      var b = KJUR.crypto.ECDSA.parseSigHexInHexRS(a);
      var d2 = new BigInteger(b.r, 16);
      var c2 = new BigInteger(b.s, 16);
      return { r: d2, s: c2 };
    };
    KJUR.crypto.ECDSA.parseSigHexInHexRS = function(f2) {
      var j = ASN1HEX, i = j.getChildIdx, g2 = j.getV;
      j.checkStrictDER(f2, 0);
      if (f2.substr(0, 2) != "30") {
        throw new Error("signature is not a ASN.1 sequence");
      }
      var h = i(f2, 0);
      if (h.length != 2) {
        throw new Error("signature shall have two elements");
      }
      var e = h[0];
      var d2 = h[1];
      if (f2.substr(e, 2) != "02") {
        throw new Error("1st item not ASN.1 integer");
      }
      if (f2.substr(d2, 2) != "02") {
        throw new Error("2nd item not ASN.1 integer");
      }
      var c2 = g2(f2, e);
      var b = g2(f2, d2);
      return { r: c2, s: b };
    };
    KJUR.crypto.ECDSA.asn1SigToConcatSig = function(d2) {
      var e = KJUR.crypto.ECDSA.parseSigHexInHexRS(d2);
      var b = e.r;
      var a = e.s;
      if (b.length >= 130 && b.length <= 134) {
        if (b.length % 2 != 0) {
          throw Error("unknown ECDSA sig r length error");
        }
        if (a.length % 2 != 0) {
          throw Error("unknown ECDSA sig s length error");
        }
        if (b.substr(0, 2) == "00") {
          b = b.substr(2);
        }
        if (a.substr(0, 2) == "00") {
          a = a.substr(2);
        }
        var c2 = Math.max(b.length, a.length);
        b = ("000000" + b).slice(-c2);
        a = ("000000" + a).slice(-c2);
        return b + a;
      }
      if (b.substr(0, 2) == "00" && b.length % 32 == 2) {
        b = b.substr(2);
      }
      if (a.substr(0, 2) == "00" && a.length % 32 == 2) {
        a = a.substr(2);
      }
      if (b.length % 32 == 30) {
        b = "00" + b;
      }
      if (a.length % 32 == 30) {
        a = "00" + a;
      }
      if (b.length % 32 != 0) {
        throw Error("unknown ECDSA sig r length error");
      }
      if (a.length % 32 != 0) {
        throw Error("unknown ECDSA sig s length error");
      }
      return b + a;
    };
    KJUR.crypto.ECDSA.concatSigToASN1Sig = function(a) {
      if (a.length % 4 != 0) {
        throw Error("unknown ECDSA concatinated r-s sig length error");
      }
      var c2 = a.substr(0, a.length / 2);
      var b = a.substr(a.length / 2);
      return KJUR.crypto.ECDSA.hexRSSigToASN1Sig(c2, b);
    };
    KJUR.crypto.ECDSA.hexRSSigToASN1Sig = function(b, a) {
      var d2 = new BigInteger(b, 16);
      var c2 = new BigInteger(a, 16);
      return KJUR.crypto.ECDSA.biRSSigToASN1Sig(d2, c2);
    };
    KJUR.crypto.ECDSA.biRSSigToASN1Sig = function(f2, d2) {
      var c2 = KJUR.asn1;
      var b = new c2.DERInteger({ bigint: f2 });
      var a = new c2.DERInteger({ bigint: d2 });
      var e = new c2.DERSequence({ array: [b, a] });
      return e.tohex();
    };
    KJUR.crypto.ECDSA.getName = function(a) {
      if (a === "2b8104001f") {
        return "secp192k1";
      }
      if (a === "2a8648ce3d030107") {
        return "secp256r1";
      }
      if (a === "2b8104000a") {
        return "secp256k1";
      }
      if (a === "2b81040021") {
        return "secp224r1";
      }
      if (a === "2b81040022") {
        return "secp384r1";
      }
      if (a === "2b81040023") {
        return "secp521r1";
      }
      if ("|secp256r1|NIST P-256|P-256|prime256v1|".indexOf(a) !== -1) {
        return "secp256r1";
      }
      if ("|secp256k1|".indexOf(a) !== -1) {
        return "secp256k1";
      }
      if ("|secp224r1|NIST P-224|P-224|".indexOf(a) !== -1) {
        return "secp224r1";
      }
      if ("|secp384r1|NIST P-384|P-384|".indexOf(a) !== -1) {
        return "secp384r1";
      }
      if ("|secp521r1|NIST P-521|P-521|".indexOf(a) !== -1) {
        return "secp521r1";
      }
      return null;
    };
    if (typeof KJUR == "undefined" || !KJUR) {
      KJUR = {};
    }
    if (typeof KJUR.crypto == "undefined" || !KJUR.crypto) {
      KJUR.crypto = {};
    }
    KJUR.crypto.ECParameterDB = new function() {
      var b = {};
      var c2 = {};
      function a(d2) {
        return new BigInteger(d2, 16);
      }
      this.getByName = function(e) {
        var d2 = e;
        if (typeof c2[d2] != "undefined") {
          d2 = c2[e];
        }
        if (typeof b[d2] != "undefined") {
          return b[d2];
        }
        throw "unregistered EC curve name: " + d2;
      };
      this.regist = function(A, l2, o2, g2, m2, e, j, f2, k, u2, d2, x2) {
        b[A] = {};
        var s = a(o2);
        var z2 = a(g2);
        var y = a(m2);
        var t2 = a(e);
        var w = a(j);
        var r = new ECCurveFp(s, z2, y);
        var q2 = r.decodePointHex("04" + f2 + k);
        b[A]["name"] = A;
        b[A]["keylen"] = l2;
        b[A]["keycharlen"] = Math.ceil(l2 / 8) * 2;
        b[A]["curve"] = r;
        b[A]["G"] = q2;
        b[A]["n"] = t2;
        b[A]["h"] = w;
        b[A]["oid"] = d2;
        b[A]["info"] = x2;
        for (var v = 0; v < u2.length; v++) {
          c2[u2[v]] = A;
        }
      };
    }();
    KJUR.crypto.ECParameterDB.regist("secp128r1", 128, "FFFFFFFDFFFFFFFFFFFFFFFFFFFFFFFF", "FFFFFFFDFFFFFFFFFFFFFFFFFFFFFFFC", "E87579C11079F43DD824993C2CEE5ED3", "FFFFFFFE0000000075A30D1B9038A115", "1", "161FF7528B899B2D0C28607CA52C5B86", "CF5AC8395BAFEB13C02DA292DDED7A83", [], "", "secp128r1 : SECG curve over a 128 bit prime field");
    KJUR.crypto.ECParameterDB.regist("secp160k1", 160, "FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFAC73", "0", "7", "0100000000000000000001B8FA16DFAB9ACA16B6B3", "1", "3B4C382CE37AA192A4019E763036F4F5DD4D7EBB", "938CF935318FDCED6BC28286531733C3F03C4FEE", [], "", "secp160k1 : SECG curve over a 160 bit prime field");
    KJUR.crypto.ECParameterDB.regist("secp160r1", 160, "FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFF", "FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFC", "1C97BEFC54BD7A8B65ACF89F81D4D4ADC565FA45", "0100000000000000000001F4C8F927AED3CA752257", "1", "4A96B5688EF573284664698968C38BB913CBFC82", "23A628553168947D59DCC912042351377AC5FB32", [], "", "secp160r1 : SECG curve over a 160 bit prime field");
    KJUR.crypto.ECParameterDB.regist("secp192k1", 192, "FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFEE37", "0", "3", "FFFFFFFFFFFFFFFFFFFFFFFE26F2FC170F69466A74DEFD8D", "1", "DB4FF10EC057E9AE26B07D0280B7F4341DA5D1B1EAE06C7D", "9B2F2F6D9C5628A7844163D015BE86344082AA88D95E2F9D", []);
    KJUR.crypto.ECParameterDB.regist("secp192r1", 192, "FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFFFFFFFF", "FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFFFFFFFC", "64210519E59C80E70FA7E9AB72243049FEB8DEECC146B9B1", "FFFFFFFFFFFFFFFFFFFFFFFF99DEF836146BC9B1B4D22831", "1", "188DA80EB03090F67CBF20EB43A18800F4FF0AFD82FF1012", "07192B95FFC8DA78631011ED6B24CDD573F977A11E794811", []);
    KJUR.crypto.ECParameterDB.regist("secp224r1", 224, "FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000000000000000000001", "FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFE", "B4050A850C04B3ABF54132565044B0B7D7BFD8BA270B39432355FFB4", "FFFFFFFFFFFFFFFFFFFFFFFFFFFF16A2E0B8F03E13DD29455C5C2A3D", "1", "B70E0CBD6BB4BF7F321390B94A03C1D356C21122343280D6115C1D21", "BD376388B5F723FB4C22DFE6CD4375A05A07476444D5819985007E34", []);
    KJUR.crypto.ECParameterDB.regist("secp256k1", 256, "FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFC2F", "0", "7", "FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEBAAEDCE6AF48A03BBFD25E8CD0364141", "1", "79BE667EF9DCBBAC55A06295CE870B07029BFCDB2DCE28D959F2815B16F81798", "483ADA7726A3C4655DA4FBFC0E1108A8FD17B448A68554199C47D08FFB10D4B8", []);
    KJUR.crypto.ECParameterDB.regist("secp256r1", 256, "FFFFFFFF00000001000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFF", "FFFFFFFF00000001000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFC", "5AC635D8AA3A93E7B3EBBD55769886BC651D06B0CC53B0F63BCE3C3E27D2604B", "FFFFFFFF00000000FFFFFFFFFFFFFFFFBCE6FAADA7179E84F3B9CAC2FC632551", "1", "6B17D1F2E12C4247F8BCE6E563A440F277037D812DEB33A0F4A13945D898C296", "4FE342E2FE1A7F9B8EE7EB4A7C0F9E162BCE33576B315ECECBB6406837BF51F5", ["NIST P-256", "P-256", "prime256v1"]);
    KJUR.crypto.ECParameterDB.regist("secp384r1", 384, "FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFF0000000000000000FFFFFFFF", "FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFF0000000000000000FFFFFFFC", "B3312FA7E23EE7E4988E056BE3F82D19181D9C6EFE8141120314088F5013875AC656398D8A2ED19D2A85C8EDD3EC2AEF", "FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC7634D81F4372DDF581A0DB248B0A77AECEC196ACCC52973", "1", "AA87CA22BE8B05378EB1C71EF320AD746E1D3B628BA79B9859F741E082542A385502F25DBF55296C3A545E3872760AB7", "3617de4a96262c6f5d9e98bf9292dc29f8f41dbd289a147ce9da3113b5f0b8c00a60b1ce1d7e819d7a431d7c90ea0e5f", ["NIST P-384", "P-384"]);
    KJUR.crypto.ECParameterDB.regist("secp521r1", 521, "1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF", "1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC", "051953EB9618E1C9A1F929A21A0B68540EEA2DA725B99B315F3B8B489918EF109E156193951EC7E937B1652C0BD3BB1BF073573DF883D2C34F1EF451FD46B503F00", "1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFA51868783BF2F966B7FCC0148F709A5D03BB5C9B8899C47AEBB6FB71E91386409", "1", "00C6858E06B70404E9CD9E3ECB662395B4429C648139053FB521F828AF606B4D3DBAA14B5E77EFE75928FE1DC127A2FFA8DE3348B3C1856A429BF97E7E31C2E5BD66", "011839296a789a3bc0045c8a5fb42c7d1bd998f54449579b446817afbd17273e662c97ee72995ef42640c550b9013fad0761353c7086a272c24088be94769fd16650", ["NIST P-521", "P-521"]);
    if (typeof KJUR == "undefined" || !KJUR) {
      KJUR = {};
    }
    if (typeof KJUR.crypto == "undefined" || !KJUR.crypto) {
      KJUR.crypto = {};
    }
    KJUR.crypto.DSA = function() {
      var b = ASN1HEX, e = b.getVbyList, d2 = b.getVbyListEx, a = b.isASN1HEX, c2 = BigInteger;
      this.p = null;
      this.q = null;
      this.g = null;
      this.y = null;
      this.x = null;
      this.type = "DSA";
      this.isPrivate = false;
      this.isPublic = false;
      this.setPrivate = function(j, i, h, k, f2) {
        this.isPrivate = true;
        this.p = j;
        this.q = i;
        this.g = h;
        this.y = k;
        this.x = f2;
      };
      this.setPrivateHex = function(i, g2, k, n, o2) {
        var h, f2, j, l2, m2;
        h = new BigInteger(i, 16);
        f2 = new BigInteger(g2, 16);
        j = new BigInteger(k, 16);
        if (typeof n === "string" && n.length > 1) {
          l2 = new BigInteger(n, 16);
        } else {
          l2 = null;
        }
        m2 = new BigInteger(o2, 16);
        this.setPrivate(h, f2, j, l2, m2);
      };
      this.setPublic = function(i, h, f2, j) {
        this.isPublic = true;
        this.p = i;
        this.q = h;
        this.g = f2;
        this.y = j;
        this.x = null;
      };
      this.setPublicHex = function(k, j, i, l2) {
        var g2, f2, m2, h;
        g2 = new BigInteger(k, 16);
        f2 = new BigInteger(j, 16);
        m2 = new BigInteger(i, 16);
        h = new BigInteger(l2, 16);
        this.setPublic(g2, f2, m2, h);
      };
      this.signWithMessageHash = function(j) {
        var i = this.p;
        var h = this.q;
        var m2 = this.g;
        var o2 = this.y;
        var t2 = this.x;
        var l2 = KJUR.crypto.Util.getRandomBigIntegerMinToMax(BigInteger.ONE.add(BigInteger.ONE), h.subtract(BigInteger.ONE));
        var u2 = j.substr(0, h.bitLength() / 4);
        var n = new BigInteger(u2, 16);
        var f2 = m2.modPow(l2, i).mod(h);
        var w = l2.modInverse(h).multiply(n.add(t2.multiply(f2))).mod(h);
        var v = KJUR.asn1.ASN1Util.jsonToASN1HEX({ seq: [{ "int": { bigint: f2 } }, { "int": { bigint: w } }] });
        return v;
      };
      this.verifyWithMessageHash = function(m2, l2) {
        var j = this.p;
        var h = this.q;
        var o2 = this.g;
        var u2 = this.y;
        var n = this.parseASN1Signature(l2);
        var f2 = n[0];
        var C = n[1];
        var B = m2.substr(0, h.bitLength() / 4);
        var t2 = new BigInteger(B, 16);
        if (BigInteger.ZERO.compareTo(f2) > 0 || f2.compareTo(h) > 0) {
          throw "invalid DSA signature";
        }
        if (BigInteger.ZERO.compareTo(C) >= 0 || C.compareTo(h) > 0) {
          throw "invalid DSA signature";
        }
        var x2 = C.modInverse(h);
        var k = t2.multiply(x2).mod(h);
        var i = f2.multiply(x2).mod(h);
        var A = o2.modPow(k, j).multiply(u2.modPow(i, j)).mod(j).mod(h);
        return A.compareTo(f2) == 0;
      };
      this.parseASN1Signature = function(f2) {
        try {
          var i = new c2(d2(f2, 0, [0], "02"), 16);
          var h = new c2(d2(f2, 0, [1], "02"), 16);
          return [i, h];
        } catch (g2) {
          throw new Error("malformed ASN.1 DSA signature");
        }
      };
      this.readPKCS5PrvKeyHex = function(j) {
        var k, i, g2, l2, m2;
        if (a(j) === false) {
          throw new Error("not ASN.1 hex string");
        }
        try {
          k = d2(j, 0, [1], "02");
          i = d2(j, 0, [2], "02");
          g2 = d2(j, 0, [3], "02");
          l2 = d2(j, 0, [4], "02");
          m2 = d2(j, 0, [5], "02");
        } catch (f2) {
          throw new Error("malformed PKCS#1/5 plain DSA private key");
        }
        this.setPrivateHex(k, i, g2, l2, m2);
      };
      this.readPKCS8PrvKeyHex = function(j) {
        var k, i, g2, l2;
        if (a(j) === false) {
          throw new Error("not ASN.1 hex string");
        }
        try {
          k = d2(j, 0, [1, 1, 0], "02");
          i = d2(j, 0, [1, 1, 1], "02");
          g2 = d2(j, 0, [1, 1, 2], "02");
          l2 = d2(j, 0, [2, 0], "02");
        } catch (f2) {
          throw new Error("malformed PKCS#8 plain DSA private key");
        }
        this.setPrivateHex(k, i, g2, null, l2);
      };
      this.readPKCS8PubKeyHex = function(j) {
        var k, i, g2, l2;
        if (a(j) === false) {
          throw new Error("not ASN.1 hex string");
        }
        try {
          k = d2(j, 0, [0, 1, 0], "02");
          i = d2(j, 0, [0, 1, 1], "02");
          g2 = d2(j, 0, [0, 1, 2], "02");
          l2 = d2(j, 0, [1, 0], "02");
        } catch (f2) {
          throw new Error("malformed PKCS#8 DSA public key");
        }
        this.setPublicHex(k, i, g2, l2);
      };
      this.readCertPubKeyHex = function(j, m2) {
        var k, i, g2, l2;
        if (a(j) === false) {
          throw new Error("not ASN.1 hex string");
        }
        try {
          k = d2(j, 0, [0, 5, 0, 1, 0], "02");
          i = d2(j, 0, [0, 5, 0, 1, 1], "02");
          g2 = d2(j, 0, [0, 5, 0, 1, 2], "02");
          l2 = d2(j, 0, [0, 5, 1, 0], "02");
        } catch (f2) {
          throw new Error("malformed X.509 certificate DSA public key");
        }
        this.setPublicHex(k, i, g2, l2);
      };
    };
    var KEYUTIL = /* @__PURE__ */ function() {
      var d2 = function(p3, r, q2) {
        return k(CryptoJS.AES, p3, r, q2);
      };
      var e = function(p3, r, q2) {
        return k(CryptoJS.TripleDES, p3, r, q2);
      };
      var a = function(p3, r, q2) {
        return k(CryptoJS.DES, p3, r, q2);
      };
      var k = function(s, x2, u2, q2) {
        var r = CryptoJS.enc.Hex.parse(x2);
        var w = CryptoJS.enc.Hex.parse(u2);
        var p3 = CryptoJS.enc.Hex.parse(q2);
        var t2 = {};
        t2.key = w;
        t2.iv = p3;
        t2.ciphertext = r;
        var v = s.decrypt(t2, w, { iv: p3 });
        return CryptoJS.enc.Hex.stringify(v);
      };
      var l2 = function(p3, r, q2) {
        return g2(CryptoJS.AES, p3, r, q2);
      };
      var o2 = function(p3, r, q2) {
        return g2(CryptoJS.TripleDES, p3, r, q2);
      };
      var f2 = function(p3, r, q2) {
        return g2(CryptoJS.DES, p3, r, q2);
      };
      var g2 = function(t2, y, v, q2) {
        var s = CryptoJS.enc.Hex.parse(y);
        var x2 = CryptoJS.enc.Hex.parse(v);
        var p3 = CryptoJS.enc.Hex.parse(q2);
        var w = t2.encrypt(s, x2, { iv: p3 });
        var r = CryptoJS.enc.Hex.parse(w.toString());
        var u2 = CryptoJS.enc.Base64.stringify(r);
        return u2;
      };
      var i = { "AES-256-CBC": { proc: d2, eproc: l2, keylen: 32, ivlen: 16 }, "AES-192-CBC": { proc: d2, eproc: l2, keylen: 24, ivlen: 16 }, "AES-128-CBC": { proc: d2, eproc: l2, keylen: 16, ivlen: 16 }, "DES-EDE3-CBC": { proc: e, eproc: o2, keylen: 24, ivlen: 8 }, "DES-CBC": { proc: a, eproc: f2, keylen: 8, ivlen: 8 } };
      var c2 = function(p3) {
        return i[p3]["proc"];
      };
      var m2 = function(p3) {
        var r = CryptoJS.lib.WordArray.random(p3);
        var q2 = CryptoJS.enc.Hex.stringify(r);
        return q2;
      };
      var n = function(v) {
        var w = {};
        var q2 = v.match(new RegExp("DEK-Info: ([^,]+),([0-9A-Fa-f]+)", "m"));
        if (q2) {
          w.cipher = q2[1];
          w.ivsalt = q2[2];
        }
        var p3 = v.match(new RegExp("-----BEGIN ([A-Z]+) PRIVATE KEY-----"));
        if (p3) {
          w.type = p3[1];
        }
        var u2 = -1;
        var x2 = 0;
        if (v.indexOf("\r\n\r\n") != -1) {
          u2 = v.indexOf("\r\n\r\n");
          x2 = 2;
        }
        if (v.indexOf("\n\n") != -1) {
          u2 = v.indexOf("\n\n");
          x2 = 1;
        }
        var t2 = v.indexOf("-----END");
        if (u2 != -1 && t2 != -1) {
          var r = v.substring(u2 + x2 * 2, t2 - x2);
          r = r.replace(/\s+/g, "");
          w.data = r;
        }
        return w;
      };
      var j = function(q2, y, p3) {
        var v = p3.substring(0, 16);
        var t2 = CryptoJS.enc.Hex.parse(v);
        var r = CryptoJS.enc.Utf8.parse(y);
        var u2 = i[q2]["keylen"] + i[q2]["ivlen"];
        var x2 = "";
        var w = null;
        for (; ; ) {
          var s = CryptoJS.algo.MD5.create();
          if (w != null) {
            s.update(w);
          }
          s.update(r);
          s.update(t2);
          w = s.finalize();
          x2 = x2 + CryptoJS.enc.Hex.stringify(w);
          if (x2.length >= u2 * 2) {
            break;
          }
        }
        var z2 = {};
        z2.keyhex = x2.substr(0, i[q2]["keylen"] * 2);
        z2.ivhex = x2.substr(i[q2]["keylen"] * 2, i[q2]["ivlen"] * 2);
        return z2;
      };
      var b = function(p3, v, r, w) {
        var s = CryptoJS.enc.Base64.parse(p3);
        var q2 = CryptoJS.enc.Hex.stringify(s);
        var u2 = i[v]["proc"];
        var t2 = u2(q2, r, w);
        return t2;
      };
      var h = function(p3, s, q2, u2) {
        var r = i[s]["eproc"];
        var t2 = r(p3, q2, u2);
        return t2;
      };
      return { version: "1.0.0", parsePKCS5PEM: function(p3) {
        return n(p3);
      }, getKeyAndUnusedIvByPasscodeAndIvsalt: function(q2, p3, r) {
        return j(q2, p3, r);
      }, decryptKeyB64: function(p3, r, q2, s) {
        return b(p3, r, q2, s);
      }, getDecryptedKeyHex: function(y, x2) {
        var q2 = n(y);
        var t2 = q2.type;
        var r = q2.cipher;
        var p3 = q2.ivsalt;
        var s = q2.data;
        var w = j(r, x2, p3);
        var v = w.keyhex;
        var u2 = b(s, r, v, p3);
        return u2;
      }, getEncryptedPKCS5PEMFromPrvKeyHex: function(x2, s, A, t2, r) {
        var p3 = "";
        if (typeof t2 == "undefined" || t2 == null) {
          t2 = "AES-256-CBC";
        }
        if (typeof i[t2] == "undefined") {
          throw new Error("KEYUTIL unsupported algorithm: " + t2);
        }
        if (typeof r == "undefined" || r == null) {
          var v = i[t2]["ivlen"];
          var u2 = m2(v);
          r = u2.toUpperCase();
        }
        var z2 = j(t2, A, r);
        var y = z2.keyhex;
        var w = h(s, t2, y, r);
        var q2 = w.replace(/(.{64})/g, "$1\r\n");
        var p3 = "-----BEGIN " + x2 + " PRIVATE KEY-----\r\n";
        p3 += "Proc-Type: 4,ENCRYPTED\r\n";
        p3 += "DEK-Info: " + t2 + "," + r + "\r\n";
        p3 += "\r\n";
        p3 += q2;
        p3 += "\r\n-----END " + x2 + " PRIVATE KEY-----\r\n";
        return p3;
      }, getEncryptedPKCS8PEM: function(r, p3, s) {
        var q2 = this.getEncryptedPKCS8Hex(r, p3, s);
        return hextopem(q2, "ENCRYPTED PRIVATE KEY");
      }, getEncryptedPKCS8Hex: function(r, p3, t2) {
        var q2;
        if (t2 == void 0 || t2 == null) {
          q2 = {};
        } else {
          q2 = JSON.parse(JSON.stringify(t2));
        }
        q2.plain = r;
        this.initPBES2Param(q2);
        this.encryptPBES2Param(q2, p3);
        var s = this.generatePBES2ASN1Param(q2);
        return KJUR.asn1.ASN1Util.newObject(s).tohex();
      }, initPBES2Param: function(p3) {
        if (aryval(p3, "encalg") == void 0) {
          p3.encalg = "aes256-CBC";
        }
        if (aryval(p3, "iter") == void 0) {
          p3.iter = 2048;
        }
        if (aryval(p3, "prf") == void 0) {
          p3.prf = "hmacWithSHA256";
        }
        if (aryval(p3, "salt") == void 0) {
          p3.salt = CryptoJS.enc.Hex.stringify(CryptoJS.lib.WordArray.random(8));
        }
        if (aryval(p3, "enciv") == void 0) {
          var q2;
          if (p3.encalg == "des-EDE3-CBC") {
            q2 = 8;
          }
          if (p3.encalg == "aes128-CBC") {
            q2 = 16;
          }
          if (p3.encalg == "aes256-CBC") {
            q2 = 16;
          }
          p3.enciv = CryptoJS.enc.Hex.stringify(CryptoJS.lib.WordArray.random(q2));
        }
      }, encryptPBES2Param: function(p3, q2) {
        var t2 = KEYUTIL.getDKFromPBES2Param(p3, q2);
        try {
          var s = KJUR.crypto.Cipher.encrypt(p3.plain, t2, p3.encalg, { iv: p3.enciv });
        } catch (r) {
          throw new Error("encrypt error: " + p3.plain + " " + t2 + " " + p3.encalg + " " + p3.enciv);
        }
        p3.enc = s;
      }, generatePBES2ASN1Param: function(p3) {
        var q2 = { seq: [{ seq: [{ oid: "pkcs5PBES2" }, { seq: [{ seq: [{ oid: "pkcs5PBKDF2" }, { seq: [{ octstr: { hex: p3.salt } }, { "int": { hex: inttohex(p3.iter) } }] }] }, { seq: [{ oid: p3.encalg }, { octstr: { hex: p3.enciv } }] }] }] }, { octstr: { hex: p3.enc } }] };
        if (p3.prf != "hmacWithSHA1") {
          q2.seq[0].seq[1].seq[0].seq[1].seq.push({ seq: [{ oid: p3.prf }, { "null": "" }] });
        }
        return q2;
      }, parseHexOfEncryptedPKCS8: function(y) {
        var B = ASN1HEX;
        var z2 = B.getChildIdx;
        var w = B.getV;
        var t2 = {};
        var r = z2(y, 0);
        if (r.length != 2) {
          throw new Error("malformed format: SEQUENCE(0).items != 2: " + r.length);
        }
        t2.ciphertext = w(y, r[1]);
        var A = z2(y, r[0]);
        if (A.length != 2) {
          throw new Error("malformed format: SEQUENCE(0.0).items != 2: " + A.length);
        }
        if (w(y, A[0]) != "2a864886f70d01050d") {
          throw new Error("this only supports pkcs5PBES2");
        }
        var p3 = z2(y, A[1]);
        if (A.length != 2) {
          throw new Error("malformed format: SEQUENCE(0.0.1).items != 2: " + p3.length);
        }
        var q2 = z2(y, p3[1]);
        if (q2.length != 2) {
          throw new Error("malformed format: SEQUENCE(0.0.1.1).items != 2: " + q2.length);
        }
        if (w(y, q2[0]) != "2a864886f70d0307") {
          throw "this only supports TripleDES";
        }
        t2.encryptionSchemeAlg = "TripleDES";
        t2.encryptionSchemeIV = w(y, q2[1]);
        var s = z2(y, p3[0]);
        if (s.length != 2) {
          throw new Error("malformed format: SEQUENCE(0.0.1.0).items != 2: " + s.length);
        }
        if (w(y, s[0]) != "2a864886f70d01050c") {
          throw new Error("this only supports pkcs5PBKDF2");
        }
        var x2 = z2(y, s[1]);
        if (x2.length < 2) {
          throw new Error("malformed format: SEQUENCE(0.0.1.0.1).items < 2: " + x2.length);
        }
        t2.pbkdf2Salt = w(y, x2[0]);
        var u2 = w(y, x2[1]);
        try {
          t2.pbkdf2Iter = parseInt(u2, 16);
        } catch (v) {
          throw new Error("malformed format pbkdf2Iter: " + u2);
        }
        return t2;
      }, getPBKDF2KeyHexFromParam: function(u2, p3) {
        var t2 = CryptoJS.enc.Hex.parse(u2.pbkdf2Salt);
        var q2 = u2.pbkdf2Iter;
        var s = CryptoJS.PBKDF2(p3, t2, { keySize: 192 / 32, iterations: q2 });
        var r = CryptoJS.enc.Hex.stringify(s);
        return r;
      }, _getPlainPKCS8HexFromEncryptedPKCS8PEM: function(x2, y) {
        var r = pemtohex(x2, "ENCRYPTED PRIVATE KEY");
        var p3 = this.parseHexOfEncryptedPKCS8(r);
        var u2 = KEYUTIL.getPBKDF2KeyHexFromParam(p3, y);
        var v = {};
        v.ciphertext = CryptoJS.enc.Hex.parse(p3.ciphertext);
        var t2 = CryptoJS.enc.Hex.parse(u2);
        var s = CryptoJS.enc.Hex.parse(p3.encryptionSchemeIV);
        var w = CryptoJS.TripleDES.decrypt(v, t2, { iv: s });
        var q2 = CryptoJS.enc.Hex.stringify(w);
        return q2;
      }, parsePBES2: function(z2) {
        var v = ASN1HEX.parse(z2);
        if (aryval(v, "seq.0.seq.0.oid") != "pkcs5PBES2" || aryval(v, "seq.0.seq.1.seq.0.seq.0.oid") != "pkcs5PBKDF2") {
          throw new Error("not pkcs5PBES2 and pkcs5PBKDF2 used");
        }
        var y = aryval(v, "seq.0.seq.1.seq.0.seq.1.seq");
        if (y == void 0) {
          throw new Error("PBKDF2 parameter not found");
        }
        var t2 = aryval(y, "0.octstr.hex");
        var p3 = aryval(y, "1.int.hex");
        var q2 = aryval(y, "2.seq.0.oid", "hmacWithSHA1");
        var x2 = -1;
        try {
          x2 = parseInt(p3, 16);
        } catch (w) {
          throw new Error("iter not proper value");
        }
        var u2 = aryval(v, "seq.0.seq.1.seq.1.seq.0.oid");
        var s = aryval(v, "seq.0.seq.1.seq.1.seq.1.octstr.hex");
        var r = aryval(v, "seq.1.octstr.hex");
        if (u2 == void 0 || s == void 0 || r == void 0) {
          throw new Error("encalg, enciv or enc is undefined");
        }
        var A = { salt: t2, iter: x2, prf: q2, encalg: u2, enciv: s, enc: r };
        return A;
      }, getDKFromPBES2Param: function(p3, w) {
        var x2 = { hmacWithSHA1: CryptoJS.algo.SHA1, hmacWithSHA224: CryptoJS.algo.SHA224, hmacWithSHA256: CryptoJS.algo.SHA256, hmacWithSHA384: CryptoJS.algo.SHA384, hmacWithSHA512: CryptoJS.algo.SHA512 };
        var q2 = { "des-EDE3-CBC": 192 / 32, "aes128-CBC": 128 / 32, "aes256-CBC": 256 / 32 };
        var y = x2[p3.prf];
        if (y == void 0) {
          throw new Error("unsupported prf");
        }
        var r = q2[p3.encalg];
        if (r == void 0) {
          throw new Error("unsupported encalg");
        }
        var s = CryptoJS.enc.Hex.parse(p3.salt);
        var u2 = p3.iter;
        try {
          var v = CryptoJS.PBKDF2(w, s, { keySize: r, iterations: u2, hasher: y });
          return CryptoJS.enc.Hex.stringify(v);
        } catch (t2) {
          throw new Error("PBKDF2 error: " + t2 + " " + JSON.stringify(p3) + " " + w);
        }
      }, getPlainHexFromEncryptedPKCS8PEM: function(t2, q2) {
        if (t2.indexOf("BEGIN ENCRYPTED PRIVATE KEY") == -1) {
          throw new Error("not Encrypted PKCS#8 PEM string");
        }
        var u2 = pemtohex(t2);
        var p3;
        try {
          p3 = KEYUTIL.parsePBES2(u2);
        } catch (r) {
          throw new Error("malformed PBES2 format: " + r.message);
        }
        var s = KEYUTIL.getDKFromPBES2Param(p3, q2);
        return KJUR.crypto.Cipher.decrypt(p3.enc, s, p3.encalg, { iv: p3.enciv });
      }, getKeyFromEncryptedPKCS8PEM: function(s, q2) {
        var p3 = this.getPlainHexFromEncryptedPKCS8PEM(s, q2);
        var r = this.getKeyFromPlainPrivatePKCS8Hex(p3);
        return r;
      }, parsePlainPrivatePKCS8Hex: function(s) {
        var v = ASN1HEX;
        var u2 = v.getChildIdx;
        var t2 = v.getV;
        var q2 = {};
        q2.algparam = null;
        if (s.substr(0, 2) != "30") {
          throw new Error("malformed plain PKCS8 private key(code:001)");
        }
        var r = u2(s, 0);
        if (r.length < 3) {
          throw new Error("malformed plain PKCS8 private key(code:002)");
        }
        if (s.substr(r[1], 2) != "30") {
          throw new Error("malformed PKCS8 private key(code:003)");
        }
        var p3 = u2(s, r[1]);
        if (p3.length != 2) {
          throw new Error("malformed PKCS8 private key(code:004)");
        }
        if (s.substr(p3[0], 2) != "06") {
          throw new Error("malformed PKCS8 private key(code:005)");
        }
        q2.algoid = t2(s, p3[0]);
        if (s.substr(p3[1], 2) == "06") {
          q2.algparam = t2(s, p3[1]);
        }
        if (s.substr(r[2], 2) != "04") {
          throw new Error("malformed PKCS8 private key(code:006)");
        }
        q2.keyidx = v.getVidx(s, r[2]);
        return q2;
      }, getKeyFromPlainPrivatePKCS8PEM: function(q2) {
        var p3 = pemtohex(q2, "PRIVATE KEY");
        var r = this.getKeyFromPlainPrivatePKCS8Hex(p3);
        return r;
      }, getKeyFromPlainPrivatePKCS8Hex: function(p3) {
        var q2 = this.parsePlainPrivatePKCS8Hex(p3);
        var r;
        if (q2.algoid == "2a864886f70d010101") {
          r = new RSAKey();
        } else {
          if (q2.algoid == "2a8648ce380401") {
            r = new KJUR.crypto.DSA();
          } else {
            if (q2.algoid == "2a8648ce3d0201") {
              r = new KJUR.crypto.ECDSA();
            } else {
              throw new Error("unsupported private key algorithm");
            }
          }
        }
        r.readPKCS8PrvKeyHex(p3);
        return r;
      }, _getKeyFromPublicPKCS8Hex: function(q2) {
        var p3;
        var r = ASN1HEX.getVbyList(q2, 0, [0, 0], "06");
        if (r === "2a864886f70d010101") {
          p3 = new RSAKey();
        } else {
          if (r === "2a8648ce380401") {
            p3 = new KJUR.crypto.DSA();
          } else {
            if (r === "2a8648ce3d0201") {
              p3 = new KJUR.crypto.ECDSA();
            } else {
              throw new Error("unsupported PKCS#8 public key hex");
            }
          }
        }
        p3.readPKCS8PubKeyHex(q2);
        return p3;
      }, parsePublicRawRSAKeyHex: function(r) {
        var u2 = ASN1HEX;
        var t2 = u2.getChildIdx;
        var s = u2.getV;
        var p3 = {};
        if (r.substr(0, 2) != "30") {
          throw new Error("malformed RSA key(code:001)");
        }
        var q2 = t2(r, 0);
        if (q2.length != 2) {
          throw new Error("malformed RSA key(code:002)");
        }
        if (r.substr(q2[0], 2) != "02") {
          throw new Error("malformed RSA key(code:003)");
        }
        p3.n = s(r, q2[0]);
        if (r.substr(q2[1], 2) != "02") {
          throw new Error("malformed RSA key(code:004)");
        }
        p3.e = s(r, q2[1]);
        return p3;
      }, parsePublicPKCS8Hex: function(t2) {
        var v = ASN1HEX;
        var u2 = v.getChildIdx;
        var s = v.getV;
        var q2 = {};
        q2.algparam = null;
        var r = u2(t2, 0);
        if (r.length != 2) {
          throw new Error("outer DERSequence shall have 2 elements: " + r.length);
        }
        var w = r[0];
        if (t2.substr(w, 2) != "30") {
          throw new Error("malformed PKCS8 public key(code:001)");
        }
        var p3 = u2(t2, w);
        if (p3.length != 2) {
          throw new Error("malformed PKCS8 public key(code:002)");
        }
        if (t2.substr(p3[0], 2) != "06") {
          throw new Error("malformed PKCS8 public key(code:003)");
        }
        q2.algoid = s(t2, p3[0]);
        if (t2.substr(p3[1], 2) == "06") {
          q2.algparam = s(t2, p3[1]);
        } else {
          if (t2.substr(p3[1], 2) == "30") {
            q2.algparam = {};
            q2.algparam.p = v.getVbyList(t2, p3[1], [0], "02");
            q2.algparam.q = v.getVbyList(t2, p3[1], [1], "02");
            q2.algparam.g = v.getVbyList(t2, p3[1], [2], "02");
          }
        }
        if (t2.substr(r[1], 2) != "03") {
          throw new Error("malformed PKCS8 public key(code:004)");
        }
        q2.key = s(t2, r[1]).substr(2);
        return q2;
      } };
    }();
    KEYUTIL.getKey = function(l2, k, n) {
      var G = ASN1HEX, L = G.getChildIdx, v = G.getV, d2 = G.getVbyList, c2 = KJUR.crypto, i = c2.ECDSA, C = c2.DSA, w = RSAKey, M = pemtohex, F = KEYUTIL;
      if (typeof w != "undefined" && l2 instanceof w) {
        return l2;
      }
      if (typeof i != "undefined" && l2 instanceof i) {
        return l2;
      }
      if (typeof C != "undefined" && l2 instanceof C) {
        return l2;
      }
      if (l2.curve !== void 0 && l2.xy !== void 0 && l2.d === void 0) {
        return new i({ pub: l2.xy, curve: l2.curve });
      }
      if (l2.curve !== void 0 && l2.d !== void 0) {
        return new i({ prv: l2.d, curve: l2.curve });
      }
      if (l2.kty === void 0 && l2.n !== void 0 && l2.e !== void 0 && l2.d === void 0) {
        var P = new w();
        P.setPublic(l2.n, l2.e);
        return P;
      }
      if (l2.kty === void 0 && l2.n !== void 0 && l2.e !== void 0 && l2.d !== void 0 && l2.p !== void 0 && l2.q !== void 0 && l2.dp !== void 0 && l2.dq !== void 0 && l2.co !== void 0 && l2.qi === void 0) {
        var P = new w();
        P.setPrivateEx(l2.n, l2.e, l2.d, l2.p, l2.q, l2.dp, l2.dq, l2.co);
        return P;
      }
      if (l2.kty === void 0 && l2.n !== void 0 && l2.e !== void 0 && l2.d !== void 0 && l2.p === void 0) {
        var P = new w();
        P.setPrivate(l2.n, l2.e, l2.d);
        return P;
      }
      if (l2.p !== void 0 && l2.q !== void 0 && l2.g !== void 0 && l2.y !== void 0 && l2.x === void 0) {
        var P = new C();
        P.setPublic(l2.p, l2.q, l2.g, l2.y);
        return P;
      }
      if (l2.p !== void 0 && l2.q !== void 0 && l2.g !== void 0 && l2.y !== void 0 && l2.x !== void 0) {
        var P = new C();
        P.setPrivate(l2.p, l2.q, l2.g, l2.y, l2.x);
        return P;
      }
      if (l2.kty === "RSA" && l2.n !== void 0 && l2.e !== void 0 && l2.d === void 0) {
        var P = new w();
        P.setPublic(b64utohex(l2.n), b64utohex(l2.e));
        return P;
      }
      if (l2.kty === "RSA" && l2.n !== void 0 && l2.e !== void 0 && l2.d !== void 0 && l2.p !== void 0 && l2.q !== void 0 && l2.dp !== void 0 && l2.dq !== void 0 && l2.qi !== void 0) {
        var P = new w();
        P.setPrivateEx(b64utohex(l2.n), b64utohex(l2.e), b64utohex(l2.d), b64utohex(l2.p), b64utohex(l2.q), b64utohex(l2.dp), b64utohex(l2.dq), b64utohex(l2.qi));
        return P;
      }
      if (l2.kty === "RSA" && l2.n !== void 0 && l2.e !== void 0 && l2.d !== void 0) {
        var P = new w();
        P.setPrivate(b64utohex(l2.n), b64utohex(l2.e), b64utohex(l2.d));
        return P;
      }
      if (l2.kty === "EC" && l2.crv !== void 0 && l2.x !== void 0 && l2.y !== void 0 && l2.d === void 0) {
        var j = new i({ curve: l2.crv });
        var t2 = j.ecparams.keycharlen;
        var B = ("0000000000" + b64utohex(l2.x)).slice(-t2);
        var z2 = ("0000000000" + b64utohex(l2.y)).slice(-t2);
        var u2 = "04" + B + z2;
        j.setPublicKeyHex(u2);
        return j;
      }
      if (l2.kty === "EC" && l2.crv !== void 0 && l2.x !== void 0 && l2.y !== void 0 && l2.d !== void 0) {
        var j = new i({ curve: l2.crv });
        var t2 = j.ecparams.keycharlen;
        var B = ("0000000000" + b64utohex(l2.x)).slice(-t2);
        var z2 = ("0000000000" + b64utohex(l2.y)).slice(-t2);
        var u2 = "04" + B + z2;
        var b = ("0000000000" + b64utohex(l2.d)).slice(-t2);
        j.setPublicKeyHex(u2);
        j.setPrivateKeyHex(b);
        return j;
      }
      if (n === "pkcs5prv") {
        var J = l2, G = ASN1HEX, N, P;
        N = L(J, 0);
        if (N.length === 9) {
          P = new w();
          P.readPKCS5PrvKeyHex(J);
        } else {
          if (N.length === 6) {
            P = new C();
            P.readPKCS5PrvKeyHex(J);
          } else {
            if (N.length > 2 && J.substr(N[1], 2) === "04") {
              P = new i();
              P.readPKCS5PrvKeyHex(J);
            } else {
              throw new Error("unsupported PKCS#1/5 hexadecimal key");
            }
          }
        }
        return P;
      }
      if (n === "pkcs8prv") {
        var P = F.getKeyFromPlainPrivatePKCS8Hex(l2);
        return P;
      }
      if (n === "pkcs8pub") {
        return F._getKeyFromPublicPKCS8Hex(l2);
      }
      if (n === "x509pub") {
        return X509.getPublicKeyFromCertHex(l2);
      }
      if (l2.indexOf("-END CERTIFICATE-", 0) != -1 || l2.indexOf("-END X509 CERTIFICATE-", 0) != -1 || l2.indexOf("-END TRUSTED CERTIFICATE-", 0) != -1) {
        return X509.getPublicKeyFromCertPEM(l2);
      }
      if (l2.indexOf("-END PUBLIC KEY-") != -1) {
        var O = pemtohex(l2, "PUBLIC KEY");
        return F._getKeyFromPublicPKCS8Hex(O);
      }
      if (l2.indexOf("-END RSA PRIVATE KEY-") != -1 && l2.indexOf("4,ENCRYPTED") == -1) {
        var m2 = M(l2, "RSA PRIVATE KEY");
        return F.getKey(m2, null, "pkcs5prv");
      }
      if (l2.indexOf("-END DSA PRIVATE KEY-") != -1 && l2.indexOf("4,ENCRYPTED") == -1) {
        var I = M(l2, "DSA PRIVATE KEY");
        var E = d2(I, 0, [1], "02");
        var D = d2(I, 0, [2], "02");
        var K = d2(I, 0, [3], "02");
        var r = d2(I, 0, [4], "02");
        var s = d2(I, 0, [5], "02");
        var P = new C();
        P.setPrivate(new BigInteger(E, 16), new BigInteger(D, 16), new BigInteger(K, 16), new BigInteger(r, 16), new BigInteger(s, 16));
        return P;
      }
      if (l2.indexOf("-END EC PRIVATE KEY-") != -1 && l2.indexOf("4,ENCRYPTED") == -1) {
        var m2 = M(l2, "EC PRIVATE KEY");
        return F.getKey(m2, null, "pkcs5prv");
      }
      if (l2.indexOf("-END PRIVATE KEY-") != -1) {
        return F.getKeyFromPlainPrivatePKCS8PEM(l2);
      }
      if (l2.indexOf("-END RSA PRIVATE KEY-") != -1 && l2.indexOf("4,ENCRYPTED") != -1) {
        var o2 = F.getDecryptedKeyHex(l2, k);
        var H = new RSAKey();
        H.readPKCS5PrvKeyHex(o2);
        return H;
      }
      if (l2.indexOf("-END EC PRIVATE KEY-") != -1 && l2.indexOf("4,ENCRYPTED") != -1) {
        var I = F.getDecryptedKeyHex(l2, k);
        var P = d2(I, 0, [1], "04");
        var f2 = d2(I, 0, [2, 0], "06");
        var A = d2(I, 0, [3, 0], "03").substr(2);
        var e = "";
        if (KJUR.crypto.OID.oidhex2name[f2] !== void 0) {
          e = KJUR.crypto.OID.oidhex2name[f2];
        } else {
          throw new Error("undefined OID(hex) in KJUR.crypto.OID: " + f2);
        }
        var j = new i({ curve: e });
        j.setPublicKeyHex(A);
        j.setPrivateKeyHex(P);
        j.isPublic = false;
        return j;
      }
      if (l2.indexOf("-END DSA PRIVATE KEY-") != -1 && l2.indexOf("4,ENCRYPTED") != -1) {
        var I = F.getDecryptedKeyHex(l2, k);
        var E = d2(I, 0, [1], "02");
        var D = d2(I, 0, [2], "02");
        var K = d2(I, 0, [3], "02");
        var r = d2(I, 0, [4], "02");
        var s = d2(I, 0, [5], "02");
        var P = new C();
        P.setPrivate(new BigInteger(E, 16), new BigInteger(D, 16), new BigInteger(K, 16), new BigInteger(r, 16), new BigInteger(s, 16));
        return P;
      }
      if (l2.indexOf("-END ENCRYPTED PRIVATE KEY-") != -1) {
        return F.getKeyFromEncryptedPKCS8PEM(l2, k);
      }
      throw new Error("not supported argument");
    };
    KEYUTIL.generateKeypair = function(a, c2) {
      if (a == "RSA") {
        var b = c2;
        var h = new RSAKey();
        h.generate(b, "10001");
        h.isPrivate = true;
        h.isPublic = true;
        var f2 = new RSAKey();
        var e = h.n.toString(16);
        var i = h.e.toString(16);
        f2.setPublic(e, i);
        f2.isPrivate = false;
        f2.isPublic = true;
        var k = {};
        k.prvKeyObj = h;
        k.pubKeyObj = f2;
        return k;
      } else {
        if (a == "EC") {
          var d2 = c2;
          var g2 = new KJUR.crypto.ECDSA({ curve: d2 });
          var j = g2.generateKeyPairHex();
          var h = new KJUR.crypto.ECDSA({ curve: d2 });
          h.setPublicKeyHex(j.ecpubhex);
          h.setPrivateKeyHex(j.ecprvhex);
          h.isPrivate = true;
          h.isPublic = false;
          var f2 = new KJUR.crypto.ECDSA({ curve: d2 });
          f2.setPublicKeyHex(j.ecpubhex);
          f2.isPrivate = false;
          f2.isPublic = true;
          var k = {};
          k.prvKeyObj = h;
          k.pubKeyObj = f2;
          return k;
        } else {
          throw new Error("unknown algorithm: " + a);
        }
      }
    };
    KEYUTIL.getPEM = function(b, C, x2, m2, p3, j) {
      var E = KJUR, k = E.asn1, y = k.DERObjectIdentifier, e = k.DERInteger, l2 = k.ASN1Util.newObject, a = k.x509, B = a.SubjectPublicKeyInfo, d2 = E.crypto, t2 = d2.DSA, q2 = d2.ECDSA, n = RSAKey;
      function z2(s) {
        var G = l2({ seq: [{ "int": 0 }, { "int": { bigint: s.n } }, { "int": s.e }, { "int": { bigint: s.d } }, { "int": { bigint: s.p } }, { "int": { bigint: s.q } }, { "int": { bigint: s.dmp1 } }, { "int": { bigint: s.dmq1 } }, { "int": { bigint: s.coeff } }] });
        return G;
      }
      function A(G) {
        var s = l2({ seq: [{ "int": 1 }, { octstr: { hex: G.prvKeyHex } }, { tag: ["a0", true, { oid: { name: G.curveName } }] }, { tag: ["a1", true, { bitstr: { hex: "00" + G.pubKeyHex } }] }] });
        return s;
      }
      function w(s) {
        var G = l2({ seq: [{ "int": 0 }, { "int": { bigint: s.p } }, { "int": { bigint: s.q } }, { "int": { bigint: s.g } }, { "int": { bigint: s.y } }, { "int": { bigint: s.x } }] });
        return G;
      }
      if ((n !== void 0 && b instanceof n || t2 !== void 0 && b instanceof t2 || q2 !== void 0 && b instanceof q2) && b.isPublic == true && (C === void 0 || C == "PKCS8PUB")) {
        var D = new B(b);
        var v = D.tohex();
        return hextopem(v, "PUBLIC KEY");
      }
      if (C == "PKCS1PRV" && n !== void 0 && b instanceof n && (x2 === void 0 || x2 == null) && b.isPrivate == true) {
        var D = z2(b);
        var v = D.tohex();
        return hextopem(v, "RSA PRIVATE KEY");
      }
      if (C == "PKCS1PRV" && q2 !== void 0 && b instanceof q2 && (x2 === void 0 || x2 == null) && b.isPrivate == true) {
        var i = new y({ name: b.curveName });
        var u2 = i.tohex();
        var h = A(b);
        var r = h.tohex();
        var o2 = "";
        o2 += hextopem(u2, "EC PARAMETERS");
        o2 += hextopem(r, "EC PRIVATE KEY");
        return o2;
      }
      if (C == "PKCS1PRV" && t2 !== void 0 && b instanceof t2 && (x2 === void 0 || x2 == null) && b.isPrivate == true) {
        var D = w(b);
        var v = D.tohex();
        return hextopem(v, "DSA PRIVATE KEY");
      }
      if (C == "PKCS5PRV" && n !== void 0 && b instanceof n && (x2 !== void 0 && x2 != null) && b.isPrivate == true) {
        var D = z2(b);
        var v = D.tohex();
        if (m2 === void 0) {
          m2 = "DES-EDE3-CBC";
        }
        return this.getEncryptedPKCS5PEMFromPrvKeyHex("RSA", v, x2, m2, j);
      }
      if (C == "PKCS5PRV" && q2 !== void 0 && b instanceof q2 && (x2 !== void 0 && x2 != null) && b.isPrivate == true) {
        var D = A(b);
        var v = D.tohex();
        if (m2 === void 0) {
          m2 = "DES-EDE3-CBC";
        }
        return this.getEncryptedPKCS5PEMFromPrvKeyHex("EC", v, x2, m2, j);
      }
      if (C == "PKCS5PRV" && t2 !== void 0 && b instanceof t2 && (x2 !== void 0 && x2 != null) && b.isPrivate == true) {
        var D = w(b);
        var v = D.tohex();
        if (m2 === void 0) {
          m2 = "DES-EDE3-CBC";
        }
        return this.getEncryptedPKCS5PEMFromPrvKeyHex("DSA", v, x2, m2, j);
      }
      var f2 = function(G, H) {
        if (typeof H == "string") {
          return KEYUTIL.getEncryptedPKCS8PEM(G, H);
        } else {
          if (typeof H == "object" && aryval(H, "passcode") != void 0) {
            var I = JSON.parse(JSON.stringify(H));
            var s = I.passcode;
            delete I.passcode;
            return KEYUTIL.getEncryptedPKCS8PEM(G, s, I);
          }
        }
      };
      if (C == "PKCS8PRV" && n != void 0 && b instanceof n && b.isPrivate == true) {
        var g2 = z2(b);
        var c2 = g2.tohex();
        var D = l2({ seq: [{ "int": 0 }, { seq: [{ oid: { name: "rsaEncryption" } }, { "null": true }] }, { octstr: { hex: c2 } }] });
        var v = D.tohex();
        if (x2 === void 0 || x2 == null) {
          return hextopem(v, "PRIVATE KEY");
        } else {
          return f2(v, x2);
        }
      }
      if (C == "PKCS8PRV" && q2 !== void 0 && b instanceof q2 && b.isPrivate == true) {
        var F = { seq: [{ "int": 1 }, { octstr: { hex: b.prvKeyHex } }] };
        if (typeof b.pubKeyHex == "string") {
          F.seq.push({ tag: ["a1", true, { bitstr: { hex: "00" + b.pubKeyHex } }] });
        }
        var g2 = new l2(F);
        var c2 = g2.tohex();
        var D = l2({ seq: [{ "int": 0 }, { seq: [{ oid: { name: "ecPublicKey" } }, { oid: { name: b.curveName } }] }, { octstr: { hex: c2 } }] });
        var v = D.tohex();
        if (x2 === void 0 || x2 == null) {
          return hextopem(v, "PRIVATE KEY");
        } else {
          return f2(v, x2);
        }
      }
      if (C == "PKCS8PRV" && t2 !== void 0 && b instanceof t2 && b.isPrivate == true) {
        var g2 = new e({ bigint: b.x });
        var c2 = g2.tohex();
        var D = l2({ seq: [{ "int": 0 }, { seq: [{ oid: { name: "dsa" } }, { seq: [{ "int": { bigint: b.p } }, { "int": { bigint: b.q } }, { "int": { bigint: b.g } }] }] }, { octstr: { hex: c2 } }] });
        var v = D.tohex();
        if (x2 === void 0 || x2 == null) {
          return hextopem(v, "PRIVATE KEY");
        } else {
          return f2(v, x2);
        }
      }
      throw new Error("unsupported object nor format");
    };
    KEYUTIL.getKeyFromCSRPEM = function(b) {
      var a = pemtohex(b, "CERTIFICATE REQUEST");
      var c2 = KEYUTIL.getKeyFromCSRHex(a);
      return c2;
    };
    KEYUTIL.getKeyFromCSRHex = function(a) {
      var c2 = KEYUTIL.parseCSRHex(a);
      var b = KEYUTIL.getKey(c2.p8pubkeyhex, null, "pkcs8pub");
      return b;
    };
    KEYUTIL.parseCSRHex = function(d2) {
      var i = ASN1HEX;
      var f2 = i.getChildIdx;
      var c2 = i.getTLV;
      var b = {};
      var g2 = d2;
      if (g2.substr(0, 2) != "30") {
        throw new Error("malformed CSR(code:001)");
      }
      var e = f2(g2, 0);
      if (e.length < 1) {
        throw new Error("malformed CSR(code:002)");
      }
      if (g2.substr(e[0], 2) != "30") {
        throw new Error("malformed CSR(code:003)");
      }
      var a = f2(g2, e[0]);
      if (a.length < 3) {
        throw new Error("malformed CSR(code:004)");
      }
      b.p8pubkeyhex = c2(g2, a[2]);
      return b;
    };
    KEYUTIL.getKeyID = function(f2) {
      var c2 = KEYUTIL;
      var e = ASN1HEX;
      if (typeof f2 === "string" && f2.indexOf("BEGIN ") != -1) {
        f2 = c2.getKey(f2);
      }
      var d2 = pemtohex(c2.getPEM(f2));
      var b = e.getIdxbyList(d2, 0, [1]);
      var a = e.getV(d2, b).substring(2);
      return KJUR.crypto.Util.hashHex(a, "sha1");
    };
    KEYUTIL.getJWK = function(d2, h, g2, b, f2) {
      var i;
      var k = {};
      var e;
      var c2 = KJUR.crypto.Util.hashHex;
      if (typeof d2 == "string") {
        i = KEYUTIL.getKey(d2);
        if (d2.indexOf("CERTIFICATE") != -1) {
          e = pemtohex(d2);
        }
      } else {
        if (typeof d2 == "object") {
          if (d2 instanceof X509) {
            i = d2.getPublicKey();
            e = d2.hex;
          } else {
            i = d2;
          }
        } else {
          throw new Error("unsupported keyinfo type");
        }
      }
      if (i instanceof RSAKey && i.isPrivate) {
        k.kty = "RSA";
        k.n = hextob64u(i.n.toString(16));
        k.e = hextob64u(i.e.toString(16));
        k.d = hextob64u(i.d.toString(16));
        k.p = hextob64u(i.p.toString(16));
        k.q = hextob64u(i.q.toString(16));
        k.dp = hextob64u(i.dmp1.toString(16));
        k.dq = hextob64u(i.dmq1.toString(16));
        k.qi = hextob64u(i.coeff.toString(16));
      } else {
        if (i instanceof RSAKey && i.isPublic) {
          k.kty = "RSA";
          k.n = hextob64u(i.n.toString(16));
          k.e = hextob64u(i.e.toString(16));
        } else {
          if (i instanceof KJUR.crypto.ECDSA && i.isPrivate) {
            var a = i.getShortNISTPCurveName();
            if (a !== "P-256" && a !== "P-384" && a !== "P-521") {
              throw new Error("unsupported curve name for JWT: " + a);
            }
            var j = i.getPublicKeyXYHex();
            k.kty = "EC";
            k.crv = a;
            k.x = hextob64u(j.x);
            k.y = hextob64u(j.y);
            k.d = hextob64u(i.prvKeyHex);
          } else {
            if (i instanceof KJUR.crypto.ECDSA && i.isPublic) {
              var a = i.getShortNISTPCurveName();
              if (a !== "P-256" && a !== "P-384" && a !== "P-521") {
                throw new Error("unsupported curve name for JWT: " + a);
              }
              var j = i.getPublicKeyXYHex();
              k.kty = "EC";
              k.crv = a;
              k.x = hextob64u(j.x);
              k.y = hextob64u(j.y);
            }
          }
        }
      }
      if (k.kty == void 0) {
        throw new Error("unsupported keyinfo");
      }
      if (!i.isPrivate && h != true) {
        k.kid = KJUR.jws.JWS.getJWKthumbprint(k);
      }
      if (e != void 0 && g2 != true) {
        k.x5c = [hex2b64(e)];
      }
      if (e != void 0 && b != true) {
        k.x5t = b64tob64u(hex2b64(c2(e, "sha1")));
      }
      if (e != void 0 && f2 != true) {
        k["x5t#S256"] = b64tob64u(hex2b64(c2(e, "sha256")));
      }
      return k;
    };
    KEYUTIL.getJWKFromKey = function(a) {
      return KEYUTIL.getJWK(a, true, true, true, true);
    };
    RSAKey.getPosArrayOfChildrenFromHex = function(a) {
      return ASN1HEX.getChildIdx(a, 0);
    };
    RSAKey.getHexValueArrayOfChildrenFromHex = function(f2) {
      var n = ASN1HEX;
      var i = n.getV;
      var k = RSAKey.getPosArrayOfChildrenFromHex(f2);
      var e = i(f2, k[0]);
      var j = i(f2, k[1]);
      var b = i(f2, k[2]);
      var c2 = i(f2, k[3]);
      var h = i(f2, k[4]);
      var g2 = i(f2, k[5]);
      var m2 = i(f2, k[6]);
      var l2 = i(f2, k[7]);
      var d2 = i(f2, k[8]);
      var k = new Array();
      k.push(e, j, b, c2, h, g2, m2, l2, d2);
      return k;
    };
    RSAKey.prototype.readPrivateKeyFromPEMString = function(d2) {
      var c2 = pemtohex(d2);
      var b = RSAKey.getHexValueArrayOfChildrenFromHex(c2);
      this.setPrivateEx(b[1], b[2], b[3], b[4], b[5], b[6], b[7], b[8]);
    };
    RSAKey.prototype.readPKCS5PrvKeyHex = function(c2) {
      var b = RSAKey.getHexValueArrayOfChildrenFromHex(c2);
      this.setPrivateEx(b[1], b[2], b[3], b[4], b[5], b[6], b[7], b[8]);
    };
    RSAKey.prototype.readPKCS8PrvKeyHex = function(e) {
      var c2, i, k, b, a, f2, d2, j;
      var m2 = ASN1HEX;
      var l2 = m2.getVbyListEx;
      if (m2.isASN1HEX(e) === false) {
        throw new Error("not ASN.1 hex string");
      }
      try {
        c2 = l2(e, 0, [2, 0, 1], "02");
        i = l2(e, 0, [2, 0, 2], "02");
        k = l2(e, 0, [2, 0, 3], "02");
        b = l2(e, 0, [2, 0, 4], "02");
        a = l2(e, 0, [2, 0, 5], "02");
        f2 = l2(e, 0, [2, 0, 6], "02");
        d2 = l2(e, 0, [2, 0, 7], "02");
        j = l2(e, 0, [2, 0, 8], "02");
      } catch (g2) {
        throw new Error("malformed PKCS#8 plain RSA private key");
      }
      this.setPrivateEx(c2, i, k, b, a, f2, d2, j);
    };
    RSAKey.prototype.readPKCS5PubKeyHex = function(c2) {
      var e = ASN1HEX;
      var b = e.getV;
      if (e.isASN1HEX(c2) === false) {
        throw new Error("keyHex is not ASN.1 hex string");
      }
      var a = e.getChildIdx(c2, 0);
      if (a.length !== 2 || c2.substr(a[0], 2) !== "02" || c2.substr(a[1], 2) !== "02") {
        throw new Error("wrong hex for PKCS#5 public key");
      }
      var f2 = b(c2, a[0]);
      var d2 = b(c2, a[1]);
      this.setPublic(f2, d2);
    };
    RSAKey.prototype.readPKCS8PubKeyHex = function(b) {
      var c2 = ASN1HEX;
      if (c2.isASN1HEX(b) === false) {
        throw new Error("not ASN.1 hex string");
      }
      if (c2.getTLVbyListEx(b, 0, [0, 0]) !== "06092a864886f70d010101") {
        throw new Error("not PKCS8 RSA public key");
      }
      var a = c2.getTLVbyListEx(b, 0, [1, 0]);
      this.readPKCS5PubKeyHex(a);
    };
    RSAKey.prototype.readCertPubKeyHex = function(b, d2) {
      var a, c2;
      a = new X509();
      a.readCertHex(b);
      c2 = a.getPublicKeyHex();
      this.readPKCS8PubKeyHex(c2);
    };
    var _RE_HEXDECONLY = new RegExp("[^0-9a-f]", "gi");
    function _zeroPaddingOfSignature(e, d2) {
      var c2 = "";
      var a = d2 / 4 - e.length;
      for (var b = 0; b < a; b++) {
        c2 = c2 + "0";
      }
      return c2 + e;
    }
    RSAKey.prototype.sign = function(d2, a) {
      var b = function(e) {
        return KJUR.crypto.Util.hashString(e, a);
      };
      var c2 = b(d2);
      return this.signWithMessageHash(c2, a);
    };
    RSAKey.prototype.signWithMessageHash = function(e, c2) {
      var f2 = KJUR.crypto.Util.getPaddedDigestInfoHex(e, c2, this.n.bitLength());
      var b = parseBigInt(f2, 16);
      var d2 = this.doPrivate(b);
      var a = d2.toString(16);
      return _zeroPaddingOfSignature(a, this.n.bitLength());
    };
    function pss_mgf1_str(c2, a, e) {
      var b = "", d2 = 0;
      while (b.length < a) {
        b += hextorstr(e(rstrtohex(c2 + String.fromCharCode.apply(String, [(d2 & 4278190080) >> 24, (d2 & 16711680) >> 16, (d2 & 65280) >> 8, d2 & 255]))));
        d2 += 1;
      }
      return b;
    }
    RSAKey.prototype.signPSS = function(e, a, d2) {
      var c2 = function(f2) {
        return KJUR.crypto.Util.hashHex(f2, a);
      };
      var b = c2(rstrtohex(e));
      if (d2 === void 0) {
        d2 = -1;
      }
      return this.signWithMessageHashPSS(b, a, d2);
    };
    RSAKey.prototype.signWithMessageHashPSS = function(l2, a, k) {
      var b = hextorstr(l2);
      var g2 = b.length;
      var m2 = this.n.bitLength() - 1;
      var c2 = Math.ceil(m2 / 8);
      var d2;
      var o2 = function(i) {
        return KJUR.crypto.Util.hashHex(i, a);
      };
      if (k === -1 || k === void 0) {
        k = g2;
      } else {
        if (k === -2) {
          k = c2 - g2 - 2;
        } else {
          if (k < -2) {
            throw new Error("invalid salt length");
          }
        }
      }
      if (c2 < g2 + k + 2) {
        throw new Error("data too long");
      }
      var f2 = "";
      if (k > 0) {
        f2 = new Array(k);
        new SecureRandom2().nextBytes(f2);
        f2 = String.fromCharCode.apply(String, f2);
      }
      var n = hextorstr(o2(rstrtohex("\0\0\0\0\0\0\0\0" + b + f2)));
      var j = [];
      for (d2 = 0; d2 < c2 - k - g2 - 2; d2 += 1) {
        j[d2] = 0;
      }
      var e = String.fromCharCode.apply(String, j) + "" + f2;
      var h = pss_mgf1_str(n, e.length, o2);
      var q2 = [];
      for (d2 = 0; d2 < e.length; d2 += 1) {
        q2[d2] = e.charCodeAt(d2) ^ h.charCodeAt(d2);
      }
      var p3 = 65280 >> 8 * c2 - m2 & 255;
      q2[0] &= ~p3;
      for (d2 = 0; d2 < g2; d2++) {
        q2.push(n.charCodeAt(d2));
      }
      q2.push(188);
      return _zeroPaddingOfSignature(this.doPrivate(new BigInteger(q2)).toString(16), this.n.bitLength());
    };
    function _rsasign_getAlgNameAndHashFromHexDisgestInfo(f2) {
      for (var e in KJUR.crypto.Util.DIGESTINFOHEAD) {
        var d2 = KJUR.crypto.Util.DIGESTINFOHEAD[e];
        var b = d2.length;
        if (f2.substring(0, b) == d2) {
          var c2 = [e, f2.substring(b)];
          return c2;
        }
      }
      return [];
    }
    RSAKey.prototype.verify = function(f2, l2) {
      l2 = l2.toLowerCase();
      if (l2.match(/^[0-9a-f]+$/) == null) {
        return false;
      }
      var b = parseBigInt(l2, 16);
      var k = this.n.bitLength();
      if (b.bitLength() > k) {
        return false;
      }
      var j = this.doPublic(b);
      var i = j.toString(16);
      if (i.length + 3 != k / 4) {
        return false;
      }
      var e = i.replace(/^1f+00/, "");
      var g2 = _rsasign_getAlgNameAndHashFromHexDisgestInfo(e);
      if (g2.length == 0) {
        return false;
      }
      var d2 = g2[0];
      var h = g2[1];
      var a = function(m2) {
        return KJUR.crypto.Util.hashString(m2, d2);
      };
      var c2 = a(f2);
      return h == c2;
    };
    RSAKey.prototype.verifyWithMessageHash = function(e, a) {
      if (a.length != Math.ceil(this.n.bitLength() / 4)) {
        return false;
      }
      var b = parseBigInt(a, 16);
      if (b.bitLength() > this.n.bitLength()) {
        return 0;
      }
      var h = this.doPublic(b);
      var g2 = h.toString(16).replace(/^1f+00/, "");
      var c2 = _rsasign_getAlgNameAndHashFromHexDisgestInfo(g2);
      if (c2.length == 0) {
        return false;
      }
      var d2 = c2[0];
      var f2 = c2[1];
      return f2 == e;
    };
    RSAKey.prototype.verifyPSS = function(c2, b, a, f2) {
      var e = function(g2) {
        return KJUR.crypto.Util.hashHex(g2, a);
      };
      var d2 = e(rstrtohex(c2));
      if (f2 === void 0) {
        f2 = -1;
      }
      return this.verifyWithMessageHashPSS(d2, b, a, f2);
    };
    RSAKey.prototype.verifyWithMessageHashPSS = function(f2, s, l2, c2) {
      if (s.length != Math.ceil(this.n.bitLength() / 4)) {
        return false;
      }
      var k = new BigInteger(s, 16);
      var r = function(i) {
        return KJUR.crypto.Util.hashHex(i, l2);
      };
      var j = hextorstr(f2);
      var h = j.length;
      var g2 = this.n.bitLength() - 1;
      var m2 = Math.ceil(g2 / 8);
      var q2;
      if (c2 === -1 || c2 === void 0) {
        c2 = h;
      } else {
        if (c2 === -2) {
          c2 = m2 - h - 2;
        } else {
          if (c2 < -2) {
            throw new Error("invalid salt length");
          }
        }
      }
      if (m2 < h + c2 + 2) {
        throw new Error("data too long");
      }
      var a = this.doPublic(k).toByteArray();
      for (q2 = 0; q2 < a.length; q2 += 1) {
        a[q2] &= 255;
      }
      while (a.length < m2) {
        a.unshift(0);
      }
      if (a[m2 - 1] !== 188) {
        throw new Error("encoded message does not end in 0xbc");
      }
      a = String.fromCharCode.apply(String, a);
      var d2 = a.substr(0, m2 - h - 1);
      var e = a.substr(d2.length, h);
      var p3 = 65280 >> 8 * m2 - g2 & 255;
      if ((d2.charCodeAt(0) & p3) !== 0) {
        throw new Error("bits beyond keysize not zero");
      }
      var n = pss_mgf1_str(e, d2.length, r);
      var o2 = [];
      for (q2 = 0; q2 < d2.length; q2 += 1) {
        o2[q2] = d2.charCodeAt(q2) ^ n.charCodeAt(q2);
      }
      o2[0] &= ~p3;
      var b = m2 - h - c2 - 2;
      for (q2 = 0; q2 < b; q2 += 1) {
        if (o2[q2] !== 0) {
          throw new Error("leftmost octets not zero");
        }
      }
      if (o2[b] !== 1) {
        throw new Error("0x01 marker not found");
      }
      return e === hextorstr(r(rstrtohex("\0\0\0\0\0\0\0\0" + j + String.fromCharCode.apply(String, o2.slice(-c2)))));
    };
    RSAKey.SALT_LEN_HLEN = -1;
    RSAKey.SALT_LEN_MAX = -2;
    RSAKey.SALT_LEN_RECOVER = -2;
    function X509(v) {
      var o2 = ASN1HEX, s = o2.getChildIdx, k = o2.getV, y = o2.dump, j = o2.parse, b = o2.getTLV, c2 = o2.getVbyList, p3 = o2.getVbyListEx, a = o2.getTLVbyList, q2 = o2.getTLVbyListEx, l2 = o2.getIdxbyList, f2 = o2.getIdxbyListEx, n = o2.getVidx, x2 = o2.getInt, u2 = o2.oidname, r = o2.hextooidstr, d2 = X509, w = pemtohex, g2, m2 = Error;
      try {
        g2 = KJUR.asn1.x509.AlgorithmIdentifier.PSSNAME2ASN1TLV;
      } catch (t2) {
      }
      this.HEX2STAG = { "0c": "utf8", "13": "prn", "16": "ia5", "1a": "vis", "1e": "bmp" };
      this.hex = null;
      this.version = 0;
      this.foffset = 0;
      this.aExtInfo = null;
      this.getVersion = function() {
        if (this.hex === null || this.version !== 0) {
          return this.version;
        }
        var A = a(this.hex, 0, [0, 0]);
        if (A.substr(0, 2) == "a0") {
          var B = a(A, 0, [0]);
          var z2 = x2(B, 0);
          if (z2 < 0 || 2 < z2) {
            throw new Error("malformed version field");
          }
          this.version = z2 + 1;
          return this.version;
        } else {
          this.version = 1;
          this.foffset = -1;
          return 1;
        }
      };
      this.getSerialNumberHex = function() {
        return p3(this.hex, 0, [0, 0], "02");
      };
      this.getSignatureAlgorithmField = function() {
        var z2 = q2(this.hex, 0, [0, 1]);
        return this.getAlgorithmIdentifierName(z2);
      };
      this.getAlgorithmIdentifierName = function(z2) {
        for (var A in g2) {
          if (z2 === g2[A]) {
            return A;
          }
        }
        return u2(p3(z2, 0, [0], "06"));
      };
      this.getIssuer = function(A, z2) {
        return this.getX500Name(this.getIssuerHex(), A, z2);
      };
      this.getIssuerHex = function() {
        return a(this.hex, 0, [0, 3 + this.foffset], "30");
      };
      this.getIssuerString = function() {
        var z2 = this.getIssuer();
        return z2.str;
      };
      this.getSubject = function(A, z2) {
        return this.getX500Name(this.getSubjectHex(), A, z2);
      };
      this.getSubjectHex = function() {
        return a(this.hex, 0, [0, 5 + this.foffset], "30");
      };
      this.getSubjectString = function() {
        var z2 = this.getSubject();
        return z2.str;
      };
      this.getNotBefore = function() {
        var z2 = c2(this.hex, 0, [0, 4 + this.foffset, 0]);
        z2 = z2.replace(/(..)/g, "%$1");
        z2 = decodeURIComponent(z2);
        return z2;
      };
      this.getNotAfter = function() {
        var z2 = c2(this.hex, 0, [0, 4 + this.foffset, 1]);
        z2 = z2.replace(/(..)/g, "%$1");
        z2 = decodeURIComponent(z2);
        return z2;
      };
      this.getPublicKeyHex = function() {
        return this.getSPKI();
      };
      this.getSPKI = function() {
        return a(this.hex, 0, [0, 6 + this.foffset], "30");
      };
      this.getSPKIValue = function() {
        var z2 = this.getSPKI();
        if (z2 == null) {
          return null;
        }
        return c2(z2, 0, [1], "03", true);
      };
      this.getPublicKeyIdx = function() {
        return l2(this.hex, 0, [0, 6 + this.foffset], "30");
      };
      this.getPublicKeyContentIdx = function() {
        var z2 = this.getPublicKeyIdx();
        return l2(this.hex, z2, [1, 0], "30");
      };
      this.getPublicKey = function() {
        return KEYUTIL.getKey(this.getPublicKeyHex(), null, "pkcs8pub");
      };
      this.getSignatureAlgorithmName = function() {
        var z2 = a(this.hex, 0, [1], "30");
        return this.getAlgorithmIdentifierName(z2);
      };
      this.getSignatureValueHex = function() {
        return c2(this.hex, 0, [2], "03", true);
      };
      this.verifySignature = function(B) {
        var C = this.getSignatureAlgorithmField();
        var z2 = this.getSignatureValueHex();
        var A = a(this.hex, 0, [0], "30");
        var D = new KJUR.crypto.Signature({ alg: C });
        D.init(B);
        D.updateHex(A);
        return D.verify(z2);
      };
      this.parseExt = function(I) {
        var B, z2, D;
        if (I === void 0) {
          D = this.hex;
          if (this.version !== 3) {
            return -1;
          }
          B = l2(D, 0, [0, 7, 0], "30");
          z2 = s(D, B);
        } else {
          D = pemtohex(I);
          var E = l2(D, 0, [0, 3, 0, 0], "06");
          if (k(D, E) != "2a864886f70d01090e") {
            this.aExtInfo = new Array();
            return;
          }
          B = l2(D, 0, [0, 3, 0, 1, 0], "30");
          z2 = s(D, B);
          this.hex = D;
        }
        this.aExtInfo = new Array();
        for (var C = 0; C < z2.length; C++) {
          var G = {};
          G.critical = false;
          var F = s(D, z2[C]);
          var A = 0;
          if (F.length === 3) {
            G.critical = true;
            A = 1;
          }
          G.oid = o2.hextooidstr(c2(D, z2[C], [0], "06"));
          var H = l2(D, z2[C], [1 + A]);
          G.vidx = n(D, H);
          this.aExtInfo.push(G);
        }
      };
      this.getExtInfo = function(B) {
        var z2 = this.aExtInfo;
        var C = B;
        if (!B.match(/^[0-9.]+$/)) {
          C = KJUR.asn1.x509.OID.name2oid(B);
        }
        if (C === "") {
          return void 0;
        }
        for (var A = 0; A < z2.length; A++) {
          if (z2[A].oid === C) {
            return z2[A];
          }
        }
        return void 0;
      };
      this.getCriticalExtV = function(C, z2, B) {
        if (z2 != void 0) {
          return [z2, B];
        }
        var A = this.getExtInfo(C);
        if (A == void 0) {
          return [null, null];
        }
        return [b(this.hex, A.vidx), A.critical];
      };
      this.getExtBasicConstraints = function(A, E) {
        if (A === void 0 && E === void 0) {
          var C = this.getExtInfo("basicConstraints");
          if (C === void 0) {
            return void 0;
          }
          A = b(this.hex, C.vidx);
          E = C.critical;
        }
        var z2 = { extname: "basicConstraints" };
        if (E) {
          z2.critical = true;
        }
        if (A === "3000") {
          return z2;
        }
        if (A === "30030101ff") {
          z2.cA = true;
          return z2;
        }
        if (A.substr(0, 12) === "30060101ff02") {
          var D = k(A, 10);
          var B = parseInt(D, 16);
          z2.cA = true;
          z2.pathLen = B;
          return z2;
        }
        throw new Error("hExtV parse error: " + A);
      };
      this.getExtNameConstraints = function(I, G) {
        var A = this.getCriticalExtV("nameConstraints", I, G);
        I = A[0];
        G = A[1];
        if (I == null) {
          return void 0;
        }
        var K = { extname: "nameConstraints" };
        if (G) {
          K.critical = true;
        }
        var F = s(I, 0);
        for (var D = 0; D < F.length; D++) {
          var E = [];
          var B = s(I, F[D]);
          for (var C = 0; C < B.length; C++) {
            var H = b(I, B[C]);
            var z2 = this.getGeneralSubtree(H);
            E.push(z2);
          }
          var J = I.substr(F[D], 2);
          if (J == "a0") {
            K.permit = E;
          } else {
            if (J == "a1") {
              K.exclude = E;
            }
          }
        }
        return K;
      };
      this.getGeneralSubtree = function(F) {
        var D = s(F, 0);
        var C = D.length;
        if (C < 1 || 2 < C) {
          throw new Error("wrong num elements");
        }
        var B = this.getGeneralName(b(F, D[0]));
        for (var E = 1; E < C; E++) {
          var A = F.substr(D[E], 2);
          var z2 = k(F, D[E]);
          var G = parseInt(z2, 16);
          if (A == "80") {
            B.min = G;
          }
          if (A == "81") {
            B.max = G;
          }
        }
        return B;
      };
      this.getExtKeyUsage = function(A, C) {
        var B = this.getCriticalExtV("keyUsage", A, C);
        A = B[0];
        C = B[1];
        if (A == null) {
          return void 0;
        }
        var z2 = { extname: "keyUsage" };
        if (C) {
          z2.critical = true;
        }
        z2.names = this.getExtKeyUsageString(A).split(",");
        return z2;
      };
      this.getExtKeyUsageBin = function(A) {
        if (A === void 0) {
          var B = this.getExtInfo("keyUsage");
          if (B === void 0) {
            return "";
          }
          A = b(this.hex, B.vidx);
        }
        if (A.length != 8 && A.length != 10) {
          throw new Error("malformed key usage value: " + A);
        }
        var z2 = "000000000000000" + parseInt(A.substr(6), 16).toString(2);
        if (A.length == 8) {
          z2 = z2.slice(-8);
        }
        if (A.length == 10) {
          z2 = z2.slice(-16);
        }
        z2 = z2.replace(/0+$/, "");
        if (z2 == "") {
          z2 = "0";
        }
        return z2;
      };
      this.getExtKeyUsageString = function(B) {
        var C = this.getExtKeyUsageBin(B);
        var z2 = new Array();
        for (var A = 0; A < C.length; A++) {
          if (C.substr(A, 1) == "1") {
            z2.push(X509.KEYUSAGE_NAME[A]);
          }
        }
        return z2.join(",");
      };
      this.getExtSubjectKeyIdentifier = function(B, D) {
        if (B === void 0 && D === void 0) {
          var C = this.getExtInfo("subjectKeyIdentifier");
          if (C === void 0) {
            return void 0;
          }
          B = b(this.hex, C.vidx);
          D = C.critical;
        }
        var z2 = { extname: "subjectKeyIdentifier" };
        if (D) {
          z2.critical = true;
        }
        var A = k(B, 0);
        z2.kid = { hex: A };
        return z2;
      };
      this.getExtAuthorityKeyIdentifier = function(F, D) {
        if (F === void 0 && D === void 0) {
          var z2 = this.getExtInfo("authorityKeyIdentifier");
          if (z2 === void 0) {
            return void 0;
          }
          F = b(this.hex, z2.vidx);
          D = z2.critical;
        }
        var G = { extname: "authorityKeyIdentifier" };
        if (D) {
          G.critical = true;
        }
        var E = s(F, 0);
        for (var A = 0; A < E.length; A++) {
          var H = F.substr(E[A], 2);
          if (H === "80") {
            G.kid = { hex: k(F, E[A]) };
          }
          if (H === "a1") {
            var C = b(F, E[A]);
            var B = this.getGeneralNames(C);
            G.issuer = B[0]["dn"];
          }
          if (H === "82") {
            G.sn = { hex: k(F, E[A]) };
          }
        }
        return G;
      };
      this.getExtExtKeyUsage = function(C, E) {
        if (C === void 0 && E === void 0) {
          var D = this.getExtInfo("extKeyUsage");
          if (D === void 0) {
            return void 0;
          }
          C = b(this.hex, D.vidx);
          E = D.critical;
        }
        var z2 = { extname: "extKeyUsage", array: [] };
        if (E) {
          z2.critical = true;
        }
        var A = s(C, 0);
        for (var B = 0; B < A.length; B++) {
          z2.array.push(u2(k(C, A[B])));
        }
        return z2;
      };
      this.getExtExtKeyUsageName = function() {
        var D = this.getExtInfo("extKeyUsage");
        if (D === void 0) {
          return D;
        }
        var z2 = new Array();
        var C = b(this.hex, D.vidx);
        if (C === "") {
          return z2;
        }
        var A = s(C, 0);
        for (var B = 0; B < A.length; B++) {
          z2.push(u2(k(C, A[B])));
        }
        return z2;
      };
      this.getExtSubjectAltName = function(A, C) {
        if (A === void 0 && C === void 0) {
          var B = this.getExtInfo("subjectAltName");
          if (B === void 0) {
            return void 0;
          }
          A = b(this.hex, B.vidx);
          C = B.critical;
        }
        var z2 = { extname: "subjectAltName", array: [] };
        if (C) {
          z2.critical = true;
        }
        z2.array = this.getGeneralNames(A);
        return z2;
      };
      this.getExtIssuerAltName = function(A, C) {
        if (A === void 0 && C === void 0) {
          var B = this.getExtInfo("issuerAltName");
          if (B === void 0) {
            return void 0;
          }
          A = b(this.hex, B.vidx);
          C = B.critical;
        }
        var z2 = { extname: "issuerAltName", array: [] };
        if (C) {
          z2.critical = true;
        }
        z2.array = this.getGeneralNames(A);
        return z2;
      };
      this.getGeneralNames = function(D) {
        var B = s(D, 0);
        var z2 = [];
        for (var C = 0; C < B.length; C++) {
          var A = this.getGeneralName(b(D, B[C]));
          if (A !== void 0) {
            z2.push(A);
          }
        }
        return z2;
      };
      this.getGeneralName = function(A) {
        var z2 = A.substr(0, 2);
        var C = k(A, 0);
        var B = hextorstr(C);
        if (z2 == "81") {
          return { rfc822: B };
        }
        if (z2 == "82") {
          return { dns: B };
        }
        if (z2 == "86") {
          return { uri: B };
        }
        if (z2 == "87") {
          return { ip: hextoip(C) };
        }
        if (z2 == "a4") {
          return { dn: this.getX500Name(C) };
        }
        if (z2 == "a0") {
          return { other: this.getOtherName(A) };
        }
        return void 0;
      };
      this.getExtSubjectAltName2 = function() {
        var D, G, F;
        var E = this.getExtInfo("subjectAltName");
        if (E === void 0) {
          return E;
        }
        var z2 = new Array();
        var C = b(this.hex, E.vidx);
        var A = s(C, 0);
        for (var B = 0; B < A.length; B++) {
          F = C.substr(A[B], 2);
          D = k(C, A[B]);
          if (F === "81") {
            G = hextoutf8(D);
            z2.push(["MAIL", G]);
          }
          if (F === "82") {
            G = hextoutf8(D);
            z2.push(["DNS", G]);
          }
          if (F === "84") {
            G = X509.hex2dn(D, 0);
            z2.push(["DN", G]);
          }
          if (F === "86") {
            G = hextoutf8(D);
            z2.push(["URI", G]);
          }
          if (F === "87") {
            G = hextoip(D);
            z2.push(["IP", G]);
          }
        }
        return z2;
      };
      this.getExtCRLDistributionPoints = function(D, F) {
        if (D === void 0 && F === void 0) {
          var E = this.getExtInfo("cRLDistributionPoints");
          if (E === void 0) {
            return void 0;
          }
          D = b(this.hex, E.vidx);
          F = E.critical;
        }
        var A = { extname: "cRLDistributionPoints", array: [] };
        if (F) {
          A.critical = true;
        }
        var B = s(D, 0);
        for (var C = 0; C < B.length; C++) {
          var z2 = b(D, B[C]);
          A.array.push(this.getDistributionPoint(z2));
        }
        return A;
      };
      this.getDistributionPoint = function(E) {
        var B = {};
        var C = s(E, 0);
        for (var D = 0; D < C.length; D++) {
          var A = E.substr(C[D], 2);
          var z2 = b(E, C[D]);
          if (A == "a0") {
            B.dpname = this.getDistributionPointName(z2);
          }
        }
        return B;
      };
      this.getDistributionPointName = function(E) {
        var B = {};
        var C = s(E, 0);
        for (var D = 0; D < C.length; D++) {
          var A = E.substr(C[D], 2);
          var z2 = b(E, C[D]);
          if (A == "a0") {
            B.full = this.getGeneralNames(z2);
          }
        }
        return B;
      };
      this.getExtCRLDistributionPointsURI = function() {
        var D = this.getExtCRLDistributionPoints();
        if (D == void 0) {
          return D;
        }
        var A = D.array;
        var z2 = [];
        for (var C = 0; C < A.length; C++) {
          try {
            if (A[C].dpname.full[0].uri != void 0) {
              z2.push(A[C].dpname.full[0].uri);
            }
          } catch (B) {
          }
        }
        return z2;
      };
      this.getExtAIAInfo = function() {
        var D = this.getExtInfo("authorityInfoAccess");
        if (D === void 0) {
          return D;
        }
        var z2 = { ocsp: [], caissuer: [] };
        var A = s(this.hex, D.vidx);
        for (var B = 0; B < A.length; B++) {
          var E = c2(this.hex, A[B], [0], "06");
          var C = c2(this.hex, A[B], [1], "86");
          if (E === "2b06010505073001") {
            z2.ocsp.push(hextoutf8(C));
          }
          if (E === "2b06010505073002") {
            z2.caissuer.push(hextoutf8(C));
          }
        }
        return z2;
      };
      this.getExtAuthorityInfoAccess = function(G, E) {
        if (G === void 0 && E === void 0) {
          var z2 = this.getExtInfo("authorityInfoAccess");
          if (z2 === void 0) {
            return void 0;
          }
          G = b(this.hex, z2.vidx);
          E = z2.critical;
        }
        var H = { extname: "authorityInfoAccess", array: [] };
        if (E) {
          H.critical = true;
        }
        var F = s(G, 0);
        for (var A = 0; A < F.length; A++) {
          var D = p3(G, F[A], [0], "06");
          var B = c2(G, F[A], [1], "86");
          var C = hextoutf8(B);
          if (D == "2b06010505073001") {
            H.array.push({ ocsp: C });
          } else {
            if (D == "2b06010505073002") {
              H.array.push({ caissuer: C });
            } else {
              throw new Error("unknown method: " + D);
            }
          }
        }
        return H;
      };
      this.getExtCertificatePolicies = function(D, G) {
        if (D === void 0 && G === void 0) {
          var F = this.getExtInfo("certificatePolicies");
          if (F === void 0) {
            return void 0;
          }
          D = b(this.hex, F.vidx);
          G = F.critical;
        }
        var z2 = { extname: "certificatePolicies", array: [] };
        if (G) {
          z2.critical = true;
        }
        var A = s(D, 0);
        for (var B = 0; B < A.length; B++) {
          var E = b(D, A[B]);
          var C = this.getPolicyInformation(E);
          z2.array.push(C);
        }
        return z2;
      };
      this.getPolicyInformation = function(D) {
        var z2 = {};
        var F = c2(D, 0, [0], "06");
        z2.policyoid = u2(F);
        var G = f2(D, 0, [1], "30");
        if (G != -1) {
          z2.array = [];
          var A = s(D, G);
          for (var B = 0; B < A.length; B++) {
            var E = b(D, A[B]);
            var C = this.getPolicyQualifierInfo(E);
            z2.array.push(C);
          }
        }
        return z2;
      };
      this.getOtherName = function(B) {
        var z2 = {};
        var A = s(B, 0);
        var D = c2(B, A[0], [], "06");
        var C = c2(B, A[1], []);
        z2.oid = u2(D);
        z2.value = j(C);
        return z2;
      };
      this.getPolicyQualifierInfo = function(A) {
        var z2 = {};
        var B = c2(A, 0, [0], "06");
        if (B === "2b06010505070201") {
          var D = p3(A, 0, [1], "16");
          z2.cps = hextorstr(D);
        } else {
          if (B === "2b06010505070202") {
            var C = a(A, 0, [1], "30");
            z2.unotice = this.getUserNotice(C);
          }
        }
        return z2;
      };
      this.getUserNotice = function(B) {
        var D = null;
        var z2 = {};
        try {
          D = o2.parse(B);
          var C = this._asn1ToUnotice(D);
          return C;
        } catch (A) {
          return void 0;
        }
      };
      this._asn1ToUnotice = function(E) {
        try {
          var z2 = {};
          var A = aryval(E, "seq");
          for (var C = 0; C < A.length; C++) {
            var D = this._asn1ToNoticeRef(A[C]);
            if (D != void 0) {
              z2.noticeref = D;
            }
            var F = this.asn1ToDisplayText(A[C]);
            if (F != void 0) {
              z2.exptext = F;
            }
          }
          if (Object.keys(z2).length > 0) {
            return z2;
          }
          return void 0;
        } catch (B) {
          return void 0;
        }
      };
      this._asn1ToNoticeRef = function(F) {
        try {
          var A = {};
          var B = aryval(F, "seq");
          for (var D = 0; D < B.length; D++) {
            var E = this._asn1ToNoticeNum(B[D]);
            if (E != void 0) {
              A.noticenum = E;
            }
            var z2 = this.asn1ToDisplayText(B[D]);
            if (z2 != void 0) {
              A.org = z2;
            }
          }
          if (Object.keys(A).length > 0) {
            return A;
          }
          return void 0;
        } catch (C) {
          return void 0;
        }
      };
      this._asn1ToNoticeNum = function(E) {
        try {
          var A = aryval(E, "seq");
          var z2 = [];
          for (var C = 0; C < A.length; C++) {
            var D = A[C];
            z2.push(parseInt(aryval(D, "int.hex"), 16));
          }
          return z2;
        } catch (B) {
          return void 0;
        }
      };
      this.getDisplayText = function(A) {
        var B = { "0c": "utf8", "16": "ia5", "1a": "vis", "1e": "bmp" };
        var z2 = {};
        z2.type = B[A.substr(0, 2)];
        z2.str = hextorstr(k(A, 0));
        return z2;
      };
      this.asn1ToDisplayText = function(z2) {
        if (z2.utf8str != void 0) {
          return { type: "utf8", str: z2.utf8str.str };
        }
        if (z2.ia5str != void 0) {
          return { type: "ia5", str: z2.ia5str.str };
        }
        if (z2.visstr != void 0) {
          return { type: "vis", str: z2.visstr.str };
        }
        if (z2.bmpstr != void 0) {
          return { type: "bmp", str: z2.bmpstr.str };
        }
        if (z2.prnstr != void 0) {
          return { type: "prn", str: z2.prnstr.str };
        }
        return void 0;
      };
      this.getExtPolicyMappings = function(G, E) {
        var z2 = this.getCriticalExtV("policyMappings", G, E);
        G = z2[0];
        E = z2[1];
        if (G == null) {
          return void 0;
        }
        var I = { extname: "policyMappings" };
        if (E) {
          I.critical = true;
        }
        try {
          var A = j(G);
          var B = A.seq;
          var F = [];
          for (var C = 0; C < B.length; C++) {
            var H = B[C].seq;
            F.push([H[0].oid, H[1].oid]);
          }
          I.array = F;
        } catch (D) {
          throw new m2("malformed policyMappings");
        }
        return I;
      };
      this.getExtPolicyConstraints = function(G, D) {
        var z2 = this.getCriticalExtV("policyConstraints", G, D);
        G = z2[0];
        D = z2[1];
        if (G == null) {
          return void 0;
        }
        var H = { extname: "policyConstraints" };
        if (D) {
          H.critical = true;
        }
        var A = j(G);
        try {
          var F = A.seq;
          for (var B = 0; B < F.length; B++) {
            var E = F[B].tag;
            if (E.explicit != false) {
              continue;
            }
            if (E.tag == "80") {
              H.reqexp = parseInt(E.hex, 16);
            }
            if (E.tag == "81") {
              H.inhibit = parseInt(E.hex, 16);
            }
          }
        } catch (C) {
          return new m2("malformed policyConstraints value");
        }
        return H;
      };
      this.getExtInhibitAnyPolicy = function(A, D) {
        var C = this.getCriticalExtV("inhibitAnyPolicy", A, D);
        A = C[0];
        D = C[1];
        if (A == null) {
          return void 0;
        }
        var z2 = { extname: "inhibitAnyPolicy" };
        if (D) {
          z2.critical = true;
        }
        var B = x2(A, 0);
        if (B == -1) {
          return new m2("wrong value");
        }
        z2.skip = B;
        return z2;
      };
      this.getExtCRLNumber = function(A, B) {
        var z2 = { extname: "cRLNumber" };
        if (B) {
          z2.critical = true;
        }
        if (A.substr(0, 2) == "02") {
          z2.num = { hex: k(A, 0) };
          return z2;
        }
        throw new m2("hExtV parse error: " + A);
      };
      this.getExtCRLReason = function(A, B) {
        var z2 = { extname: "cRLReason" };
        if (B) {
          z2.critical = true;
        }
        if (A.substr(0, 2) == "0a") {
          z2.code = parseInt(k(A, 0), 16);
          return z2;
        }
        throw new Error("hExtV parse error: " + A);
      };
      this.getExtOcspNonce = function(A, C) {
        var z2 = { extname: "ocspNonce" };
        if (C) {
          z2.critical = true;
        }
        var B = k(A, 0);
        z2.hex = B;
        return z2;
      };
      this.getExtOcspNoCheck = function(A, B) {
        var z2 = { extname: "ocspNoCheck" };
        if (B) {
          z2.critical = true;
        }
        return z2;
      };
      this.getExtAdobeTimeStamp = function(C, F) {
        if (C === void 0 && F === void 0) {
          var E = this.getExtInfo("adobeTimeStamp");
          if (E === void 0) {
            return void 0;
          }
          C = b(this.hex, E.vidx);
          F = E.critical;
        }
        var z2 = { extname: "adobeTimeStamp" };
        if (F) {
          z2.critical = true;
        }
        var B = s(C, 0);
        if (B.length > 1) {
          var G = b(C, B[1]);
          var A = this.getGeneralName(G);
          if (A.uri != void 0) {
            z2.uri = A.uri;
          }
        }
        if (B.length > 2) {
          var D = b(C, B[2]);
          if (D == "0101ff") {
            z2.reqauth = true;
          }
          if (D == "010100") {
            z2.reqauth = false;
          }
        }
        return z2;
      };
      this.getExtSubjectDirectoryAttributes = function(I, H) {
        if (I === void 0 && H === void 0) {
          var B = this.getExtInfo("subjectDirectoryAttributes");
          if (B === void 0) {
            return void 0;
          }
          I = b(this.hex, B.vidx);
          H = B.critical;
        }
        var J = { extname: "subjectDirectoryAttributes" };
        if (H) {
          J.critical = true;
        }
        try {
          var z2 = j(I);
          var D = [];
          for (var E = 0; E < z2.seq.length; E++) {
            var A = z2.seq[E];
            var C = aryval(A, "seq.0.oid");
            var F = aryval(A, "seq.1.set");
            if (C == void 0 || F == void 0) {
              throw "error";
            }
            D.push({ attr: C, array: F });
          }
          J.array = D;
          return J;
        } catch (G) {
          throw new Error("malformed subjectDirectoryAttributes extension value");
        }
      };
      var e = function(E) {
        var z2 = {};
        try {
          var B = E.seq[0].oid;
          var D = KJUR.asn1.x509.OID.name2oid(B);
          z2.type = KJUR.asn1.x509.OID.oid2atype(D);
          var A = E.seq[1];
          if (A.utf8str != void 0) {
            z2.ds = "utf8";
            z2.value = A.utf8str.str;
          } else {
            if (A.numstr != void 0) {
              z2.ds = "num";
              z2.value = A.numstr.str;
            } else {
              if (A.telstr != void 0) {
                z2.ds = "tel";
                z2.value = A.telstr.str;
              } else {
                if (A.prnstr != void 0) {
                  z2.ds = "prn";
                  z2.value = A.prnstr.str;
                } else {
                  if (A.ia5str != void 0) {
                    z2.ds = "ia5";
                    z2.value = A.ia5str.str;
                  } else {
                    if (A.visstr != void 0) {
                      z2.ds = "vis";
                      z2.value = A.visstr.str;
                    } else {
                      if (A.bmpstr != void 0) {
                        z2.ds = "bmp";
                        z2.value = A.bmpstr.str;
                      } else {
                        throw "error";
                      }
                    }
                  }
                }
              }
            }
          }
          return z2;
        } catch (C) {
          throw new Erorr("improper ASN.1 parsed AttrTypeAndValue");
        }
      };
      var i = function(A) {
        try {
          return A.set.map(function(B) {
            return e(B);
          });
        } catch (z2) {
          throw new Error("improper ASN.1 parsed RDN: " + z2);
        }
      };
      var h = function(A) {
        try {
          return A.seq.map(function(B) {
            return i(B);
          });
        } catch (z2) {
          throw new Error("improper ASN.1 parsed X500Name: " + z2);
        }
      };
      this.getX500NameRule = function(z2) {
        var G = true;
        var K = true;
        var J = false;
        var A = "";
        var D = "";
        var M = null;
        var H = [];
        for (var C = 0; C < z2.length; C++) {
          var E = z2[C];
          for (var B = 0; B < E.length; B++) {
            H.push(E[B]);
          }
        }
        for (var C = 0; C < H.length; C++) {
          var L = H[C];
          var N = L.ds;
          var I = L.value;
          var F = L.type;
          A += ":" + N;
          if (N != "prn" && N != "utf8" && N != "ia5") {
            return "mixed";
          }
          if (N == "ia5") {
            if (F != "CN") {
              return "mixed";
            } else {
              if (!KJUR.lang.String.isMail(I)) {
                return "mixed";
              } else {
                continue;
              }
            }
          }
          if (F == "C") {
            if (N == "prn") {
              continue;
            } else {
              return "mixed";
            }
          }
          D += ":" + N;
          if (M == null) {
            M = N;
          } else {
            if (M !== N) {
              return "mixed";
            }
          }
        }
        if (M == null) {
          return "prn";
        } else {
          return M;
        }
      };
      this.getAttrTypeAndValue = function(z2) {
        var A = j(z2);
        return e(A);
      };
      this.getRDN = function(z2) {
        var A = j(z2);
        return i(A);
      };
      this.getX500NameArray = function(z2) {
        var A = j(z2);
        return h(A);
      };
      this.getX500Name = function(C, E, D) {
        var A = this.getX500NameArray(C);
        var B = this.dnarraytostr(A);
        var z2 = { str: B };
        z2.array = A;
        if (D == true) {
          z2.hex = C;
        }
        if (E == true) {
          z2.canon = this.c14nRDNArray(A);
        }
        return z2;
      };
      this.readCertPEM = function(z2) {
        this.readCertHex(w(z2));
      };
      this.readCertHex = function(z2) {
        this.hex = z2;
        this.getVersion();
        try {
          l2(this.hex, 0, [0, 7], "a3");
          this.parseExt();
        } catch (A) {
        }
      };
      this.getParam = function(A) {
        var z2 = {};
        if (A == void 0) {
          A = {};
        }
        z2.version = this.getVersion();
        z2.serial = { hex: this.getSerialNumberHex() };
        z2.sigalg = this.getSignatureAlgorithmField();
        z2.issuer = this.getIssuer(A.dncanon, A.dnhex);
        z2.notbefore = this.getNotBefore();
        z2.notafter = this.getNotAfter();
        z2.subject = this.getSubject(A.dncanon, A.dnhex);
        z2.sbjpubkey = hextopem(this.getPublicKeyHex(), "PUBLIC KEY");
        if (this.aExtInfo != void 0 && this.aExtInfo.length > 0) {
          z2.ext = this.getExtParamArray();
        }
        z2.sighex = this.getSignatureValueHex();
        if (A.tbshex == true) {
          z2.tbshex = a(this.hex, 0, [0]);
        }
        if (A.nodnarray == true) {
          delete z2.issuer.array;
          delete z2.subject.array;
        }
        return z2;
      };
      this.getExtParamArray = function(A) {
        if (A == void 0) {
          var C = f2(this.hex, 0, [0, "[3]"]);
          if (C != -1) {
            A = q2(this.hex, 0, [0, "[3]", 0], "30");
          }
        }
        var z2 = [];
        var B = s(A, 0);
        for (var D = 0; D < B.length; D++) {
          var F = b(A, B[D]);
          var E = this.getExtParam(F);
          if (E != null) {
            z2.push(E);
          }
        }
        return z2;
      };
      this.getExtParam = function(A) {
        var I = {};
        var C = s(A, 0);
        var E = C.length;
        if (E != 2 && E != 3) {
          throw new Error("wrong number elements in Extension: " + E + " " + A);
        }
        var B = r(c2(A, 0, [0], "06"));
        var G = false;
        if (E == 3 && a(A, 0, [1]) == "0101ff") {
          G = true;
        }
        var H = a(A, 0, [E - 1, 0]);
        var F = void 0;
        if (B == "2.5.29.14") {
          F = this.getExtSubjectKeyIdentifier(H, G);
        } else {
          if (B == "2.5.29.15") {
            F = this.getExtKeyUsage(H, G);
          } else {
            if (B == "2.5.29.17") {
              F = this.getExtSubjectAltName(H, G);
            } else {
              if (B == "2.5.29.18") {
                F = this.getExtIssuerAltName(H, G);
              } else {
                if (B == "2.5.29.19") {
                  F = this.getExtBasicConstraints(H, G);
                } else {
                  if (B == "2.5.29.30") {
                    F = this.getExtNameConstraints(H, G);
                  } else {
                    if (B == "2.5.29.31") {
                      F = this.getExtCRLDistributionPoints(H, G);
                    } else {
                      if (B == "2.5.29.32") {
                        F = this.getExtCertificatePolicies(H, G);
                      } else {
                        if (B == "2.5.29.33") {
                          F = this.getExtPolicyMappings(H, G);
                        } else {
                          if (B == "2.5.29.35") {
                            F = this.getExtAuthorityKeyIdentifier(H, G);
                          } else {
                            if (B == "2.5.29.36") {
                              F = this.getExtPolicyConstraints(H, G);
                            } else {
                              if (B == "2.5.29.37") {
                                F = this.getExtExtKeyUsage(H, G);
                              } else {
                                if (B == "2.5.29.54") {
                                  F = this.getExtInhibitAnyPolicy(H, G);
                                } else {
                                  if (B == "1.3.6.1.5.5.7.1.1") {
                                    F = this.getExtAuthorityInfoAccess(H, G);
                                  } else {
                                    if (B == "2.5.29.20") {
                                      F = this.getExtCRLNumber(H, G);
                                    } else {
                                      if (B == "2.5.29.21") {
                                        F = this.getExtCRLReason(H, G);
                                      } else {
                                        if (B == "2.5.29.9") {
                                          F = this.getExtSubjectDirectoryAttributes(H, G);
                                        } else {
                                          if (B == "1.3.6.1.5.5.7.48.1.2") {
                                            F = this.getExtOcspNonce(H, G);
                                          } else {
                                            if (B == "1.3.6.1.5.5.7.48.1.5") {
                                              F = this.getExtOcspNoCheck(H, G);
                                            } else {
                                              if (B == "1.2.840.113583.1.1.9.1") {
                                                F = this.getExtAdobeTimeStamp(H, G);
                                              } else {
                                                if (X509.EXT_PARSER[B] != void 0) {
                                                  F = X509.EXT_PARSER[B](B, G, H);
                                                }
                                              }
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
        if (F != void 0) {
          return F;
        }
        var z2 = { extname: B, extn: H };
        try {
          z2.extn = j(H);
        } catch (D) {
        }
        if (G) {
          z2.critical = true;
        }
        return z2;
      };
      this.findExt = function(A, B) {
        for (var z2 = 0; z2 < A.length; z2++) {
          if (A[z2].extname == B) {
            return A[z2];
          }
        }
        return null;
      };
      this.updateExtCDPFullURI = function(D, z2) {
        var C = this.findExt(D, "cRLDistributionPoints");
        if (C == null) {
          return;
        }
        if (C.array == void 0) {
          return;
        }
        var F = C.array;
        for (var B = 0; B < F.length; B++) {
          if (F[B].dpname == void 0) {
            continue;
          }
          if (F[B].dpname.full == void 0) {
            continue;
          }
          var G = F[B].dpname.full;
          for (var A = 0; A < G.length; A++) {
            var E = G[B];
            if (E.uri == void 0) {
              continue;
            }
            E.uri = z2;
          }
        }
      };
      this.updateExtAIAOCSP = function(D, A) {
        var C = this.findExt(D, "authorityInfoAccess");
        if (C == null) {
          return;
        }
        if (C.array == void 0) {
          return;
        }
        var z2 = C.array;
        for (var B = 0; B < z2.length; B++) {
          if (z2[B].ocsp != void 0) {
            z2[B].ocsp = A;
          }
        }
      };
      this.updateExtAIACAIssuer = function(D, A) {
        var C = this.findExt(D, "authorityInfoAccess");
        if (C == null) {
          return;
        }
        if (C.array == void 0) {
          return;
        }
        var z2 = C.array;
        for (var B = 0; B < z2.length; B++) {
          if (z2[B].caissuer != void 0) {
            z2[B].caissuer = A;
          }
        }
      };
      this.dnarraytostr = function(B) {
        function z2(C) {
          return C.map(function(D) {
            return A(D).replace(/\+/, "\\+");
          }).join("+");
        }
        function A(C) {
          return C.type + "=" + C.value;
        }
        return "/" + B.map(function(C) {
          return z2(C).replace(/\//, "\\/");
        }).join("/");
      };
      this.setCanonicalizedDN = function(A) {
        var C;
        if (A.str != void 0 && A.array == void 0) {
          var B = new KJUR.asn1.x509.X500Name({ str: A.str });
          var z2 = B.tohex();
          C = this.getX500NameArray(z2);
        } else {
          C = A.array;
        }
        if (A.canon == void 0) {
          A.canon = this.c14nRDNArray(C);
        }
      };
      this.c14nRDNArray = function(G) {
        var A = [];
        for (var C = 0; C < G.length; C++) {
          var E = G[C];
          var z2 = [];
          for (var B = 0; B < E.length; B++) {
            var D = E[B];
            var F = D.value;
            F = F.replace(/^\s*/, "");
            F = F.replace(/\s*$/, "");
            F = F.replace(/\s+/g, " ");
            F = F.toLowerCase();
            z2.push(D.type.toLowerCase() + "=" + F);
          }
          A.push(z2.join("+"));
        }
        return "/" + A.join("/");
      };
      this.getInfo = function() {
        var A = function(W) {
          var ac = "";
          var U = "    ";
          var Y = "\n";
          var Z = W.array;
          for (var X = 0; X < Z.length; X++) {
            var V = Z[X];
            if (V.dn != void 0) {
              ac += U + "dn: " + V.dn.str + Y;
            }
            if (V.ip != void 0) {
              ac += U + "ip: " + V.ip + Y;
            }
            if (V.rfc822 != void 0) {
              ac += U + "rfc822: " + V.rfc822 + Y;
            }
            if (V.dns != void 0) {
              ac += U + "dns: " + V.dns + Y;
            }
            if (V.uri != void 0) {
              ac += U + "uri: " + V.uri + Y;
            }
            if (V.other != void 0) {
              var ab = V.other.oid;
              var aa = JSON.stringify(V.other.value).replace(/\"/g, "");
              ac += U + "other: " + ab + "=" + aa + Y;
            }
          }
          ac = ac.replace(/\n$/, "");
          return ac;
        };
        var H = function(aa) {
          var Y = "";
          var U = aa.array;
          for (var X = 0; X < U.length; X++) {
            var Z = U[X];
            Y += "    policy oid: " + Z.policyoid + "\n";
            if (Z.array === void 0) {
              continue;
            }
            for (var W = 0; W < Z.array.length; W++) {
              var V = Z.array[W];
              if (V.cps !== void 0) {
                Y += "    cps: " + V.cps + "\n";
              }
            }
          }
          return Y;
        };
        var K = function(Y) {
          var X = "";
          var U = Y.array;
          for (var W = 0; W < U.length; W++) {
            var Z = U[W];
            try {
              if (Z.dpname.full[0].uri !== void 0) {
                X += "    " + Z.dpname.full[0].uri + "\n";
              }
            } catch (V) {
            }
            try {
              if (Z.dname.full[0].dn.hex !== void 0) {
                X += "    " + X509.hex2dn(Z.dpname.full[0].dn.hex) + "\n";
              }
            } catch (V) {
            }
          }
          return X;
        };
        var I = function(Y) {
          var X = "";
          var U = Y.array;
          for (var V = 0; V < U.length; V++) {
            var W = U[V];
            if (W.caissuer !== void 0) {
              X += "    caissuer: " + W.caissuer + "\n";
            }
            if (W.ocsp !== void 0) {
              X += "    ocsp: " + W.ocsp + "\n";
            }
          }
          return X;
        };
        var B = X509;
        var M, L, T;
        M = "Basic Fields\n";
        M += "  serial number: " + this.getSerialNumberHex() + "\n";
        M += "  signature algorithm: " + this.getSignatureAlgorithmField() + "\n";
        M += "  issuer: " + this.getIssuerString() + "\n";
        M += "  notBefore: " + this.getNotBefore() + "\n";
        M += "  notAfter: " + this.getNotAfter() + "\n";
        M += "  subject: " + this.getSubjectString() + "\n";
        M += "  subject public key info: \n";
        L = this.getPublicKey();
        M += "    key algorithm: " + L.type + "\n";
        if (L.type === "RSA") {
          M += "    n=" + hextoposhex(L.n.toString(16)).substr(0, 16) + "...\n";
          M += "    e=" + hextoposhex(L.e.toString(16)) + "\n";
        }
        T = this.aExtInfo;
        if (T !== void 0 && T !== null) {
          M += "X509v3 Extensions:\n";
          for (var P = 0; P < T.length; P++) {
            var R2 = T[P];
            var z2 = KJUR.asn1.x509.OID.oid2name(R2.oid);
            if (z2 === "") {
              z2 = R2.oid;
            }
            var O = "";
            if (R2.critical === true) {
              O = "CRITICAL";
            }
            M += "  " + z2 + " " + O + ":\n";
            if (z2 === "basicConstraints") {
              var C = this.getExtBasicConstraints();
              if (C.cA === void 0) {
                M += "    {}\n";
              } else {
                M += "    cA=true";
                if (C.pathLen !== void 0) {
                  M += ", pathLen=" + C.pathLen;
                }
                M += "\n";
              }
            } else {
              if (z2 == "policyMappings") {
                var S = this.getExtPolicyMappings().array;
                var G = S.map(function(U) {
                  var V = U;
                  return V[0] + ":" + V[1];
                }).join(", ");
                M += "    " + G + "\n";
              } else {
                if (z2 == "policyConstraints") {
                  var N = this.getExtPolicyConstraints();
                  M += "    ";
                  if (N.reqexp != void 0) {
                    M += " reqexp=" + N.reqexp;
                  }
                  if (N.inhibit != void 0) {
                    M += " inhibit=" + N.inhibit;
                  }
                  M += "\n";
                } else {
                  if (z2 == "inhibitAnyPolicy") {
                    var N = this.getExtInhibitAnyPolicy();
                    M += "    skip=" + N.skip + "\n";
                  } else {
                    if (z2 == "keyUsage") {
                      M += "    " + this.getExtKeyUsageString() + "\n";
                    } else {
                      if (z2 == "subjectKeyIdentifier") {
                        M += "    " + this.getExtSubjectKeyIdentifier().kid.hex + "\n";
                      } else {
                        if (z2 == "authorityKeyIdentifier") {
                          var D = this.getExtAuthorityKeyIdentifier();
                          if (D.kid !== void 0) {
                            M += "    kid=" + D.kid.hex + "\n";
                          }
                        } else {
                          if (z2 == "extKeyUsage") {
                            var Q = this.getExtExtKeyUsage().array;
                            M += "    " + Q.join(", ") + "\n";
                          } else {
                            if (z2 == "subjectAltName") {
                              var E = A(this.getExtSubjectAltName());
                              M += E + "\n";
                            } else {
                              if (z2 == "cRLDistributionPoints") {
                                var J = this.getExtCRLDistributionPoints();
                                M += K(J);
                              } else {
                                if (z2 == "authorityInfoAccess") {
                                  var F = this.getExtAuthorityInfoAccess();
                                  M += I(F);
                                } else {
                                  if (z2 == "certificatePolicies") {
                                    M += H(this.getExtCertificatePolicies());
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
        M += "signature algorithm: " + this.getSignatureAlgorithmName() + "\n";
        M += "signature: " + this.getSignatureValueHex().substr(0, 16) + "...\n";
        return M;
      };
      if (typeof v == "string") {
        if (v.indexOf("-----BEGIN") != -1) {
          this.readCertPEM(v);
        } else {
          if (KJUR.lang.String.isHex(v)) {
            this.readCertHex(v);
          }
        }
      }
    }
    X509.EXT_PARSER = {};
    X509.registExtParser = function(b, a) {
      X509.EXT_PARSER[b] = a;
    };
    X509.hex2dn = function(e, b) {
      if (b === void 0) {
        b = 0;
      }
      var a = new X509();
      var c2 = ASN1HEX.getTLV(e, b);
      var d2 = a.getX500Name(e);
      return d2.str;
    };
    X509.hex2rdn = function(f2, b) {
      if (b === void 0) {
        b = 0;
      }
      if (f2.substr(b, 2) !== "31") {
        throw new Error("malformed RDN");
      }
      var c2 = new Array();
      var d2 = ASN1HEX.getChildIdx(f2, b);
      for (var e = 0; e < d2.length; e++) {
        c2.push(X509.hex2attrTypeValue(f2, d2[e]));
      }
      c2 = c2.map(function(a) {
        return a.replace("+", "\\+");
      });
      return c2.join("+");
    };
    X509.hex2attrTypeValue = function(d2, i) {
      var j = ASN1HEX;
      var h = j.getV;
      if (i === void 0) {
        i = 0;
      }
      if (d2.substr(i, 2) !== "30") {
        throw new Error("malformed attribute type and value");
      }
      var g2 = j.getChildIdx(d2, i);
      if (g2.length !== 2 || d2.substr(g2[0], 2) !== "06") {
        "malformed attribute type and value";
      }
      var b = h(d2, g2[0]);
      var f2 = KJUR.asn1.ASN1Util.oidHexToInt(b);
      var e = KJUR.asn1.x509.OID.oid2atype(f2);
      var a = h(d2, g2[1]);
      var c2 = hextorstr(a);
      return e + "=" + c2;
    };
    X509.getPublicKeyFromCertHex = function(b) {
      var a = new X509();
      a.readCertHex(b);
      return a.getPublicKey();
    };
    X509.getPublicKeyFromCertPEM = function(b) {
      var a = new X509();
      a.readCertPEM(b);
      return a.getPublicKey();
    };
    X509.getPublicKeyInfoPropOfCertPEM = function(c2) {
      var e = ASN1HEX;
      var g2 = e.getVbyList;
      var b = {};
      var a, f2, d2;
      b.algparam = null;
      a = new X509();
      a.readCertPEM(c2);
      f2 = a.getPublicKeyHex();
      b.keyhex = g2(f2, 0, [1], "03").substr(2);
      b.algoid = g2(f2, 0, [0, 0], "06");
      if (b.algoid === "2a8648ce3d0201") {
        b.algparam = g2(f2, 0, [0, 1], "06");
      }
      return b;
    };
    X509.KEYUSAGE_NAME = ["digitalSignature", "nonRepudiation", "keyEncipherment", "dataEncipherment", "keyAgreement", "keyCertSign", "cRLSign", "encipherOnly", "decipherOnly"];
    var X509CRL = function(e) {
      var a = KJUR, f2 = a.lang.String.isHex, m2 = ASN1HEX, k = m2.getV, b = m2.getTLV, h = m2.getVbyList, c2 = m2.getTLVbyList, d2 = m2.getTLVbyListEx, i = m2.getIdxbyList, g2 = m2.getIdxbyListEx, l2 = m2.getChildIdx, j = new X509();
      this.hex = null;
      this.posSigAlg = null;
      this.posRevCert = null;
      this.parsed = null;
      this._setPos = function() {
        var o2 = i(this.hex, 0, [0, 0]);
        var n = this.hex.substr(o2, 2);
        if (n == "02") {
          this.posSigAlg = 1;
        } else {
          if (n == "30") {
            this.posSigAlg = 0;
          } else {
            throw new Error("malformed 1st item of TBSCertList: " + n);
          }
        }
        var s = i(this.hex, 0, [0, this.posSigAlg + 3]);
        var r = this.hex.substr(s, 2);
        if (r == "17" || r == "18") {
          var q2, p3;
          q2 = i(this.hex, 0, [0, this.posSigAlg + 4]);
          this.posRevCert = null;
          if (q2 != -1) {
            p3 = this.hex.substr(q2, 2);
            if (p3 == "30") {
              this.posRevCert = this.posSigAlg + 4;
            }
          }
        } else {
          if (r == "30") {
            this.posRevCert = this.posSigAlg + 3;
          } else {
            if (r == "a0") {
              this.posRevCert = null;
            } else {
              throw new Error("malformed nextUpdate or revCert tag: " + r);
            }
          }
        }
      };
      this.getVersion = function() {
        if (this.posSigAlg == 0) {
          return null;
        }
        return parseInt(h(this.hex, 0, [0, 0], "02"), 16) + 1;
      };
      this.getSignatureAlgorithmField = function() {
        var n = c2(this.hex, 0, [0, this.posSigAlg], "30");
        return j.getAlgorithmIdentifierName(n);
      };
      this.getIssuer = function() {
        return j.getX500Name(this.getIssuerHex());
      };
      this.getIssuerHex = function() {
        return c2(this.hex, 0, [0, this.posSigAlg + 1], "30");
      };
      this.getThisUpdate = function() {
        var n = h(this.hex, 0, [0, this.posSigAlg + 2]);
        return result = hextorstr(n);
      };
      this.getNextUpdate = function() {
        var o2 = i(this.hex, 0, [0, this.posSigAlg + 3]);
        var n = this.hex.substr(o2, 2);
        if (n != "17" && n != "18") {
          return null;
        }
        return hextorstr(k(this.hex, o2));
      };
      this.getRevCertArray = function() {
        if (this.posRevCert == null) {
          return null;
        }
        var o2 = [];
        var n = i(this.hex, 0, [0, this.posRevCert]);
        var p3 = l2(this.hex, n);
        for (var q2 = 0; q2 < p3.length; q2++) {
          var r = b(this.hex, p3[q2]);
          o2.push(this.getRevCert(r));
        }
        return o2;
      };
      this.getRevCert = function(p3) {
        var o2 = {};
        var n = l2(p3, 0);
        o2.sn = { hex: h(p3, 0, [0], "02") };
        o2.date = hextorstr(h(p3, 0, [1]));
        if (n.length == 3) {
          o2.ext = j.getExtParamArray(c2(p3, 0, [2]));
        }
        return o2;
      };
      this.findRevCert = function(p3) {
        var n = new X509(p3);
        var o2 = n.getSerialNumberHex();
        return this.findRevCertBySN(o2);
      };
      this.findRevCertBySN = function(o2) {
        if (this.parsed == null) {
          this.getParam();
        }
        if (this.parsed.revcert == null) {
          return null;
        }
        var n = this.parsed.revcert;
        for (var p3 = 0; p3 < n.length; p3++) {
          if (o2 == n[p3].sn.hex) {
            return n[p3];
          }
        }
        return null;
      };
      this.getSignatureValueHex = function() {
        return h(this.hex, 0, [2], "03", true);
      };
      this.verifySignature = function(o2) {
        var p3 = this.getSignatureAlgorithmField();
        var n = this.getSignatureValueHex();
        var q2 = c2(this.hex, 0, [0], "30");
        var r = new KJUR.crypto.Signature({ alg: p3 });
        r.init(o2);
        r.updateHex(q2);
        return r.verify(n);
      };
      this.getParam = function(r) {
        var n = {};
        var p3 = this.getVersion();
        if (p3 != null) {
          n.version = p3;
        }
        n.sigalg = this.getSignatureAlgorithmField();
        n.issuer = this.getIssuer();
        n.thisupdate = this.getThisUpdate();
        var q2 = this.getNextUpdate();
        if (q2 != null) {
          n.nextupdate = q2;
        }
        var t2 = this.getRevCertArray();
        if (t2 != null) {
          n.revcert = t2;
        }
        var s = g2(this.hex, 0, [0, "[0]"]);
        if (s != -1) {
          var o2 = d2(this.hex, 0, [0, "[0]", 0]);
          n.ext = j.getExtParamArray(o2);
        }
        n.sighex = this.getSignatureValueHex();
        this.parsed = n;
        if (typeof r == "object") {
          if (r.tbshex == true) {
            n.tbshex = c2(this.hex, 0, [0]);
          }
          if (r.nodnarray == true) {
            delete n.issuer.array;
          }
        }
        return n;
      };
      if (typeof e == "string") {
        if (f2(e)) {
          this.hex = e;
        } else {
          if (e.match(/-----BEGIN X509 CRL/)) {
            this.hex = pemtohex(e);
          }
        }
        this._setPos();
      }
    };
    if (typeof KJUR == "undefined" || !KJUR) {
      KJUR = {};
    }
    if (typeof KJUR.jws == "undefined" || !KJUR.jws) {
      KJUR.jws = {};
    }
    KJUR.jws.JWS = function() {
      var b = KJUR, a = b.jws.JWS, c2 = a.isSafeJSONString;
      this.parseJWS = function(g2, j) {
        if (this.parsedJWS !== void 0 && (j || this.parsedJWS.sigvalH !== void 0)) {
          return;
        }
        var i = g2.match(/^([^.]+)\.([^.]+)\.([^.]+)$/);
        if (i == null) {
          throw "JWS signature is not a form of 'Head.Payload.SigValue'.";
        }
        var k = i[1];
        var e = i[2];
        var l2 = i[3];
        var n = k + "." + e;
        this.parsedJWS = {};
        this.parsedJWS.headB64U = k;
        this.parsedJWS.payloadB64U = e;
        this.parsedJWS.sigvalB64U = l2;
        this.parsedJWS.si = n;
        if (!j) {
          var h = b64utohex(l2);
          var f2 = parseBigInt(h, 16);
          this.parsedJWS.sigvalH = h;
          this.parsedJWS.sigvalBI = f2;
        }
        var d2 = b64utoutf8(k);
        var m2 = b64utoutf8(e);
        this.parsedJWS.headS = d2;
        this.parsedJWS.payloadS = m2;
        if (!c2(d2, this.parsedJWS, "headP")) {
          throw "malformed JSON string for JWS Head: " + d2;
        }
      };
    };
    KJUR.jws.JWS.sign = function(j, w, z2, A, a) {
      var x2 = KJUR, n = x2.jws, r = n.JWS, h = r.readSafeJSONString, q2 = r.isSafeJSONString, d2 = x2.crypto, l2 = d2.ECDSA, p3 = d2.Mac, c2 = d2.Signature, u2 = JSON;
      var t2, k, o2;
      if (typeof w != "string" && typeof w != "object") {
        throw "spHeader must be JSON string or object: " + w;
      }
      if (typeof w == "object") {
        k = w;
        t2 = u2.stringify(k);
      }
      if (typeof w == "string") {
        t2 = w;
        if (!q2(t2)) {
          throw "JWS Head is not safe JSON string: " + t2;
        }
        k = h(t2);
      }
      o2 = z2;
      if (typeof z2 == "object") {
        o2 = u2.stringify(z2);
      }
      if ((j == "" || j == null) && k.alg !== void 0) {
        j = k.alg;
      }
      if (j != "" && j != null && k.alg === void 0) {
        k.alg = j;
        t2 = u2.stringify(k);
      }
      if (j !== k.alg) {
        throw "alg and sHeader.alg doesn't match: " + j + "!=" + k.alg;
      }
      var s = null;
      if (r.jwsalg2sigalg[j] === void 0) {
        throw "unsupported alg name: " + j;
      } else {
        s = r.jwsalg2sigalg[j];
      }
      var e = utf8tob64u(t2);
      var m2 = utf8tob64u(o2);
      var b = e + "." + m2;
      var y = "";
      if (s.substr(0, 4) == "Hmac") {
        if (A === void 0) {
          throw "mac key shall be specified for HS* alg";
        }
        var i = new p3({ alg: s, prov: "cryptojs", pass: A });
        i.updateString(b);
        y = i.doFinal();
      } else {
        if (s.indexOf("withECDSA") != -1) {
          var f2 = new c2({ alg: s });
          f2.init(A, a);
          f2.updateString(b);
          var g2 = f2.sign();
          y = KJUR.crypto.ECDSA.asn1SigToConcatSig(g2);
        } else {
          if (s != "none") {
            var f2 = new c2({ alg: s });
            f2.init(A, a);
            f2.updateString(b);
            y = f2.sign();
          }
        }
      }
      var v = hextob64u(y);
      return b + "." + v;
    };
    KJUR.jws.JWS.verify = function(w, B, n) {
      var x2 = KJUR, q2 = x2.jws, t2 = q2.JWS, i = t2.readSafeJSONString, e = x2.crypto, p3 = e.ECDSA, s = e.Mac, d2 = e.Signature, m2;
      if (typeof RSAKey !== void 0) {
        m2 = RSAKey;
      }
      if (!isBase64URLDot(w)) {
        return false;
      }
      var y = w.split(".");
      if (y.length !== 3) {
        return false;
      }
      var f2 = y[0];
      var r = y[1];
      var c2 = f2 + "." + r;
      var A = b64utohex(y[2]);
      var l2 = i(b64utoutf8(y[0]));
      var k = null;
      var z2 = null;
      if (l2.alg === void 0) {
        throw "algorithm not specified in header";
      } else {
        k = l2.alg;
        z2 = k.substr(0, 2);
      }
      if (n != null && Object.prototype.toString.call(n) === "[object Array]" && n.length > 0) {
        var b = ":" + n.join(":") + ":";
        if (b.indexOf(":" + k + ":") == -1) {
          throw "algorithm '" + k + "' not accepted in the list";
        }
      }
      if (k != "none" && B === null) {
        throw "key shall be specified to verify.";
      }
      if (typeof B == "string" && B.indexOf("-----BEGIN ") != -1) {
        B = KEYUTIL.getKey(B);
      }
      if (z2 == "RS" || z2 == "PS") {
        if (!(B instanceof m2)) {
          throw "key shall be a RSAKey obj for RS* and PS* algs";
        }
      }
      if (z2 == "ES") {
        if (!(B instanceof p3)) {
          throw "key shall be a ECDSA obj for ES* algs";
        }
      }
      if (k == "none") {
      }
      var u2 = null;
      if (t2.jwsalg2sigalg[l2.alg] === void 0) {
        throw "unsupported alg name: " + k;
      } else {
        u2 = t2.jwsalg2sigalg[k];
      }
      if (u2 == "none") {
        throw "not supported";
      } else {
        if (u2.substr(0, 4) == "Hmac") {
          var o2 = null;
          if (B === void 0) {
            throw "hexadecimal key shall be specified for HMAC";
          }
          var j = new s({ alg: u2, pass: B });
          j.updateString(c2);
          o2 = j.doFinal();
          return A == o2;
        } else {
          if (u2.indexOf("withECDSA") != -1) {
            var h = null;
            try {
              h = p3.concatSigToASN1Sig(A);
            } catch (v) {
              return false;
            }
            var g2 = new d2({ alg: u2 });
            g2.init(B);
            g2.updateString(c2);
            return g2.verify(h);
          } else {
            var g2 = new d2({ alg: u2 });
            g2.init(B);
            g2.updateString(c2);
            return g2.verify(A);
          }
        }
      }
    };
    KJUR.jws.JWS.parse = function(g2) {
      var c2 = g2.split(".");
      var b = {};
      var f2, e, d2;
      if (c2.length != 2 && c2.length != 3) {
        throw "malformed sJWS: wrong number of '.' splitted elements";
      }
      f2 = c2[0];
      e = c2[1];
      if (c2.length == 3) {
        d2 = c2[2];
      }
      b.headerObj = KJUR.jws.JWS.readSafeJSONString(b64utoutf8(f2));
      b.payloadObj = KJUR.jws.JWS.readSafeJSONString(b64utoutf8(e));
      b.headerPP = JSON.stringify(b.headerObj, null, "  ");
      if (b.payloadObj == null) {
        b.payloadPP = b64utoutf8(e);
      } else {
        b.payloadPP = JSON.stringify(b.payloadObj, null, "  ");
      }
      if (d2 !== void 0) {
        b.sigHex = b64utohex(d2);
      }
      return b;
    };
    KJUR.jws.JWS.verifyJWT = function(e, l2, r) {
      var d2 = KJUR, j = d2.jws, o2 = j.JWS, n = o2.readSafeJSONString, p3 = o2.inArray, f2 = o2.includedArray;
      if (!isBase64URLDot(e)) {
        return false;
      }
      var k = e.split(".");
      if (k.length != 3) {
        return false;
      }
      var c2 = k[0];
      var i = k[1];
      var q2 = c2 + "." + i;
      var m2 = b64utohex(k[2]);
      var h = n(b64utoutf8(c2));
      var g2 = n(b64utoutf8(i));
      if (h.alg === void 0) {
        return false;
      }
      if (r.alg === void 0) {
        throw "acceptField.alg shall be specified";
      }
      if (!p3(h.alg, r.alg)) {
        return false;
      }
      if (g2.iss !== void 0 && typeof r.iss === "object") {
        if (!p3(g2.iss, r.iss)) {
          return false;
        }
      }
      if (g2.sub !== void 0 && typeof r.sub === "object") {
        if (!p3(g2.sub, r.sub)) {
          return false;
        }
      }
      if (g2.aud !== void 0 && typeof r.aud === "object") {
        if (typeof g2.aud == "string") {
          if (!p3(g2.aud, r.aud)) {
            return false;
          }
        } else {
          if (typeof g2.aud == "object") {
            if (!f2(g2.aud, r.aud)) {
              return false;
            }
          }
        }
      }
      var b = j.IntDate.getNow();
      if (r.verifyAt !== void 0 && typeof r.verifyAt === "number") {
        b = r.verifyAt;
      }
      if (r.gracePeriod === void 0 || typeof r.gracePeriod !== "number") {
        r.gracePeriod = 0;
      }
      if (g2.exp !== void 0 && typeof g2.exp == "number") {
        if (g2.exp + r.gracePeriod < b) {
          return false;
        }
      }
      if (g2.nbf !== void 0 && typeof g2.nbf == "number") {
        if (b < g2.nbf - r.gracePeriod) {
          return false;
        }
      }
      if (g2.iat !== void 0 && typeof g2.iat == "number") {
        if (b < g2.iat - r.gracePeriod) {
          return false;
        }
      }
      if (g2.jti !== void 0 && r.jti !== void 0) {
        if (g2.jti !== r.jti) {
          return false;
        }
      }
      if (!o2.verify(e, l2, r.alg)) {
        return false;
      }
      return true;
    };
    KJUR.jws.JWS.includedArray = function(b, a) {
      var c2 = KJUR.jws.JWS.inArray;
      if (b === null) {
        return false;
      }
      if (typeof b !== "object") {
        return false;
      }
      if (typeof b.length !== "number") {
        return false;
      }
      for (var d2 = 0; d2 < b.length; d2++) {
        if (!c2(b[d2], a)) {
          return false;
        }
      }
      return true;
    };
    KJUR.jws.JWS.inArray = function(d2, b) {
      if (b === null) {
        return false;
      }
      if (typeof b !== "object") {
        return false;
      }
      if (typeof b.length !== "number") {
        return false;
      }
      for (var c2 = 0; c2 < b.length; c2++) {
        if (b[c2] == d2) {
          return true;
        }
      }
      return false;
    };
    KJUR.jws.JWS.jwsalg2sigalg = { HS256: "HmacSHA256", HS384: "HmacSHA384", HS512: "HmacSHA512", RS256: "SHA256withRSA", RS384: "SHA384withRSA", RS512: "SHA512withRSA", ES256: "SHA256withECDSA", ES384: "SHA384withECDSA", ES512: "SHA512withECDSA", PS256: "SHA256withRSAandMGF1", PS384: "SHA384withRSAandMGF1", PS512: "SHA512withRSAandMGF1", none: "none" };
    KJUR.jws.JWS.isSafeJSONString = function(c2, b, d2) {
      var e = null;
      try {
        e = jsonParse(c2);
        if (typeof e != "object") {
          return 0;
        }
        if (e.constructor === Array) {
          return 0;
        }
        if (b) {
          b[d2] = e;
        }
        return 1;
      } catch (a) {
        return 0;
      }
    };
    KJUR.jws.JWS.readSafeJSONString = function(b) {
      var c2 = null;
      try {
        c2 = jsonParse(b);
        if (typeof c2 != "object") {
          return null;
        }
        if (c2.constructor === Array) {
          return null;
        }
        return c2;
      } catch (a) {
        return null;
      }
    };
    KJUR.jws.JWS.getEncodedSignatureValueFromJWS = function(b) {
      var a = b.match(/^[^.]+\.[^.]+\.([^.]+)$/);
      if (a == null) {
        throw "JWS signature is not a form of 'Head.Payload.SigValue'.";
      }
      return a[1];
    };
    KJUR.jws.JWS.getJWKthumbprint = function(d2) {
      if (d2.kty !== "RSA" && d2.kty !== "EC" && d2.kty !== "oct") {
        throw "unsupported algorithm for JWK Thumprint";
      }
      var a = "{";
      if (d2.kty === "RSA") {
        if (typeof d2.n != "string" || typeof d2.e != "string") {
          throw "wrong n and e value for RSA key";
        }
        a += '"e":"' + d2.e + '",';
        a += '"kty":"' + d2.kty + '",';
        a += '"n":"' + d2.n + '"}';
      } else {
        if (d2.kty === "EC") {
          if (typeof d2.crv != "string" || typeof d2.x != "string" || typeof d2.y != "string") {
            throw "wrong crv, x and y value for EC key";
          }
          a += '"crv":"' + d2.crv + '",';
          a += '"kty":"' + d2.kty + '",';
          a += '"x":"' + d2.x + '",';
          a += '"y":"' + d2.y + '"}';
        } else {
          if (d2.kty === "oct") {
            if (typeof d2.k != "string") {
              throw "wrong k value for oct(symmetric) key";
            }
            a += '"kty":"' + d2.kty + '",';
            a += '"k":"' + d2.k + '"}';
          }
        }
      }
      var b = rstrtohex(a);
      var c2 = KJUR.crypto.Util.hashHex(b, "sha256");
      var e = hextob64u(c2);
      return e;
    };
    KJUR.jws.IntDate = {};
    KJUR.jws.IntDate.get = function(c2) {
      var b = KJUR.jws.IntDate, d2 = b.getNow, a = b.getZulu;
      if (c2 == "now") {
        return d2();
      } else {
        if (c2 == "now + 1hour") {
          return d2() + 60 * 60;
        } else {
          if (c2 == "now + 1day") {
            return d2() + 60 * 60 * 24;
          } else {
            if (c2 == "now + 1month") {
              return d2() + 60 * 60 * 24 * 30;
            } else {
              if (c2 == "now + 1year") {
                return d2() + 60 * 60 * 24 * 365;
              } else {
                if (c2.match(/Z$/)) {
                  return a(c2);
                } else {
                  if (c2.match(/^[0-9]+$/)) {
                    return parseInt(c2);
                  }
                }
              }
            }
          }
        }
      }
      throw "unsupported format: " + c2;
    };
    KJUR.jws.IntDate.getZulu = function(a) {
      return zulutosec(a);
    };
    KJUR.jws.IntDate.getNow = function() {
      var a = ~~(/* @__PURE__ */ new Date() / 1e3);
      return a;
    };
    KJUR.jws.IntDate.intDate2UTCString = function(a) {
      var b = new Date(a * 1e3);
      return b.toUTCString();
    };
    KJUR.jws.IntDate.intDate2Zulu = function(e) {
      var i = new Date(e * 1e3), h = ("0000" + i.getUTCFullYear()).slice(-4), g2 = ("00" + (i.getUTCMonth() + 1)).slice(-2), b = ("00" + i.getUTCDate()).slice(-2), a = ("00" + i.getUTCHours()).slice(-2), c2 = ("00" + i.getUTCMinutes()).slice(-2), f2 = ("00" + i.getUTCSeconds()).slice(-2);
      return h + g2 + b + a + c2 + f2 + "Z";
    };
    if (typeof KJUR == "undefined" || !KJUR) {
      KJUR = {};
    }
    if (typeof KJUR.jws == "undefined" || !KJUR.jws) {
      KJUR.jws = {};
    }
    KJUR.jws.JWSJS = function() {
      var c2 = KJUR, b = c2.jws, a = b.JWS, d2 = a.readSafeJSONString;
      this.aHeader = [];
      this.sPayload = "";
      this.aSignature = [];
      this.init = function() {
        this.aHeader = [];
        this.sPayload = void 0;
        this.aSignature = [];
      };
      this.initWithJWS = function(f2) {
        this.init();
        var e = f2.split(".");
        if (e.length != 3) {
          throw "malformed input JWS";
        }
        this.aHeader.push(e[0]);
        this.sPayload = e[1];
        this.aSignature.push(e[2]);
      };
      this.addSignature = function(e, h, m2, k) {
        if (this.sPayload === void 0 || this.sPayload === null) {
          throw "there's no JSON-JS signature to add.";
        }
        var l2 = this.aHeader.length;
        if (this.aHeader.length != this.aSignature.length) {
          throw "aHeader.length != aSignature.length";
        }
        try {
          var f2 = KJUR.jws.JWS.sign(e, h, this.sPayload, m2, k);
          var j = f2.split(".");
          var n = j[0];
          var g2 = j[2];
          this.aHeader.push(j[0]);
          this.aSignature.push(j[2]);
        } catch (i) {
          if (this.aHeader.length > l2) {
            this.aHeader.pop();
          }
          if (this.aSignature.length > l2) {
            this.aSignature.pop();
          }
          throw "addSignature failed: " + i;
        }
      };
      this.verifyAll = function(h) {
        if (this.aHeader.length !== h.length || this.aSignature.length !== h.length) {
          return false;
        }
        for (var g2 = 0; g2 < h.length; g2++) {
          var f2 = h[g2];
          if (f2.length !== 2) {
            return false;
          }
          var e = this.verifyNth(g2, f2[0], f2[1]);
          if (e === false) {
            return false;
          }
        }
        return true;
      };
      this.verifyNth = function(f2, j, g2) {
        if (this.aHeader.length <= f2 || this.aSignature.length <= f2) {
          return false;
        }
        var h = this.aHeader[f2];
        var k = this.aSignature[f2];
        var l2 = h + "." + this.sPayload + "." + k;
        var e = false;
        try {
          e = a.verify(l2, j, g2);
        } catch (i) {
          return false;
        }
        return e;
      };
      this.readJWSJS = function(g2) {
        if (typeof g2 === "string") {
          var f2 = d2(g2);
          if (f2 == null) {
            throw "argument is not safe JSON object string";
          }
          this.aHeader = f2.headers;
          this.sPayload = f2.payload;
          this.aSignature = f2.signatures;
        } else {
          try {
            if (g2.headers.length > 0) {
              this.aHeader = g2.headers;
            } else {
              throw "malformed header";
            }
            if (typeof g2.payload === "string") {
              this.sPayload = g2.payload;
            } else {
              throw "malformed signatures";
            }
            if (g2.signatures.length > 0) {
              this.aSignature = g2.signatures;
            } else {
              throw "malformed signatures";
            }
          } catch (e) {
            throw "malformed JWS-JS JSON object: " + e;
          }
        }
      };
      this.getJSON = function() {
        return { headers: this.aHeader, payload: this.sPayload, signatures: this.aSignature };
      };
      this.isEmpty = function() {
        if (this.aHeader.length == 0) {
          return 1;
        }
        return 0;
      };
    };
    exports2.SecureRandom = SecureRandom2;
    exports2.rng_seed_time = rng_seed_time;
    exports2.BigInteger = BigInteger;
    exports2.RSAKey = RSAKey;
    exports2.ECDSA = KJUR.crypto.ECDSA;
    exports2.DSA = KJUR.crypto.DSA;
    exports2.Signature = KJUR.crypto.Signature;
    exports2.MessageDigest = KJUR.crypto.MessageDigest;
    exports2.Mac = KJUR.crypto.Mac;
    exports2.KEYUTIL = KEYUTIL;
    exports2.ASN1HEX = ASN1HEX;
    exports2.X509 = X509;
    exports2.X509CRL = X509CRL;
    exports2.CryptoJS = CryptoJS;
    exports2.b64tohex = b64tohex;
    exports2.b64toBA = b64toBA;
    exports2.ECFieldElementFp = ECFieldElementFp;
    exports2.ECPointFp = ECPointFp;
    exports2.ECCurveFp = ECCurveFp;
    exports2.stoBA = stoBA;
    exports2.BAtos = BAtos;
    exports2.BAtohex = BAtohex;
    exports2.stohex = stohex;
    exports2.stob64 = stob64;
    exports2.stob64u = stob64u;
    exports2.b64utos = b64utos;
    exports2.b64tob64u = b64tob64u;
    exports2.b64utob64 = b64utob64;
    exports2.hex2b64 = hex2b64;
    exports2.hextob64u = hextob64u;
    exports2.b64utohex = b64utohex;
    exports2.utf8tob64u = utf8tob64u;
    exports2.b64utoutf8 = b64utoutf8;
    exports2.utf8tob64 = utf8tob64;
    exports2.b64toutf8 = b64toutf8;
    exports2.utf8tohex = utf8tohex;
    exports2.hextoutf8 = hextoutf8;
    exports2.hextorstr = hextorstr;
    exports2.rstrtohex = rstrtohex;
    exports2.hextob64 = hextob64;
    exports2.hextob64nl = hextob64nl;
    exports2.b64nltohex = b64nltohex;
    exports2.hextopem = hextopem;
    exports2.pemtohex = pemtohex;
    exports2.hextoArrayBuffer = hextoArrayBuffer;
    exports2.ArrayBuffertohex = ArrayBuffertohex;
    exports2.zulutomsec = zulutomsec;
    exports2.msectozulu = msectozulu;
    exports2.zulutosec = zulutosec;
    exports2.zulutodate = zulutodate;
    exports2.datetozulu = datetozulu;
    exports2.uricmptohex = uricmptohex;
    exports2.hextouricmp = hextouricmp;
    exports2.ipv6tohex = ipv6tohex;
    exports2.hextoipv6 = hextoipv6;
    exports2.hextoip = hextoip;
    exports2.iptohex = iptohex;
    exports2.ucs2hextoutf8 = ucs2hextoutf8;
    exports2.encodeURIComponentAll = encodeURIComponentAll;
    exports2.newline_toUnix = newline_toUnix;
    exports2.newline_toDos = newline_toDos;
    exports2.hextoposhex = hextoposhex;
    exports2.intarystrtohex = intarystrtohex;
    exports2.strdiffidx = strdiffidx;
    exports2.oidtohex = oidtohex;
    exports2.hextooid = hextooid;
    exports2.strpad = strpad;
    exports2.bitstrtoint = bitstrtoint;
    exports2.inttobitstr = inttobitstr;
    exports2.bitstrtobinstr = bitstrtobinstr;
    exports2.binstrtobitstr = binstrtobitstr;
    exports2.isBase64URLDot = isBase64URLDot;
    exports2.namearraytobinstr = namearraytobinstr;
    exports2.extendClass = extendClass;
    exports2.foldnl = foldnl;
    exports2.b64topem = b64topem;
    exports2.pemtob64 = pemtob64;
    exports2.timeogen = timetogen;
    exports2.aryval = aryval;
    exports2.inttohex = inttohex;
    exports2.twoscompl = twoscompl;
    exports2.KJUR = KJUR;
    exports2.crypto = KJUR.crypto;
    exports2.asn1 = KJUR.asn1;
    exports2.jws = KJUR.jws;
    exports2.lang = KJUR.lang;
    exports2.VERSION = VERSION2;
    exports2.VERSION_FULL = VERSION_FULL;
  }
});

// node_modules/reflect-metadata/Reflect.js
var require_Reflect = __commonJS({
  "node_modules/reflect-metadata/Reflect.js"() {
    var Reflect2;
    (function(Reflect3) {
      (function(factory) {
        var root = typeof globalThis === "object" ? globalThis : typeof global === "object" ? global : typeof self === "object" ? self : typeof this === "object" ? this : sloppyModeThis();
        var exporter = makeExporter(Reflect3);
        if (typeof root.Reflect !== "undefined") {
          exporter = makeExporter(root.Reflect, exporter);
        }
        factory(exporter, root);
        if (typeof root.Reflect === "undefined") {
          root.Reflect = Reflect3;
        }
        function makeExporter(target, previous) {
          return function(key, value) {
            Object.defineProperty(target, key, { configurable: true, writable: true, value });
            if (previous)
              previous(key, value);
          };
        }
        function functionThis() {
          try {
            return Function("return this;")();
          } catch (_) {
          }
        }
        function indirectEvalThis() {
          try {
            return (void 0, eval)("(function() { return this; })()");
          } catch (_) {
          }
        }
        function sloppyModeThis() {
          return functionThis() || indirectEvalThis();
        }
      })(function(exporter, root) {
        var hasOwn = Object.prototype.hasOwnProperty;
        var supportsSymbol = typeof Symbol === "function";
        var toPrimitiveSymbol = supportsSymbol && typeof Symbol.toPrimitive !== "undefined" ? Symbol.toPrimitive : "@@toPrimitive";
        var iteratorSymbol = supportsSymbol && typeof Symbol.iterator !== "undefined" ? Symbol.iterator : "@@iterator";
        var supportsCreate = typeof Object.create === "function";
        var supportsProto = { __proto__: [] } instanceof Array;
        var downLevel = !supportsCreate && !supportsProto;
        var HashMap = {
          // create an object in dictionary mode (a.k.a. "slow" mode in v8)
          create: supportsCreate ? function() {
            return MakeDictionary(/* @__PURE__ */ Object.create(null));
          } : supportsProto ? function() {
            return MakeDictionary({ __proto__: null });
          } : function() {
            return MakeDictionary({});
          },
          has: downLevel ? function(map, key) {
            return hasOwn.call(map, key);
          } : function(map, key) {
            return key in map;
          },
          get: downLevel ? function(map, key) {
            return hasOwn.call(map, key) ? map[key] : void 0;
          } : function(map, key) {
            return map[key];
          }
        };
        var functionPrototype = Object.getPrototypeOf(Function);
        var _Map = typeof Map === "function" && typeof Map.prototype.entries === "function" ? Map : CreateMapPolyfill();
        var _Set = typeof Set === "function" && typeof Set.prototype.entries === "function" ? Set : CreateSetPolyfill();
        var _WeakMap = typeof WeakMap === "function" ? WeakMap : CreateWeakMapPolyfill();
        var registrySymbol = supportsSymbol ? Symbol.for("@reflect-metadata:registry") : void 0;
        var metadataRegistry = GetOrCreateMetadataRegistry();
        var metadataProvider = CreateMetadataProvider(metadataRegistry);
        function decorate(decorators, target, propertyKey, attributes) {
          if (!IsUndefined(propertyKey)) {
            if (!IsArray(decorators))
              throw new TypeError();
            if (!IsObject(target))
              throw new TypeError();
            if (!IsObject(attributes) && !IsUndefined(attributes) && !IsNull(attributes))
              throw new TypeError();
            if (IsNull(attributes))
              attributes = void 0;
            propertyKey = ToPropertyKey(propertyKey);
            return DecorateProperty(decorators, target, propertyKey, attributes);
          } else {
            if (!IsArray(decorators))
              throw new TypeError();
            if (!IsConstructor(target))
              throw new TypeError();
            return DecorateConstructor(decorators, target);
          }
        }
        exporter("decorate", decorate);
        function metadata(metadataKey, metadataValue) {
          function decorator(target, propertyKey) {
            if (!IsObject(target))
              throw new TypeError();
            if (!IsUndefined(propertyKey) && !IsPropertyKey(propertyKey))
              throw new TypeError();
            OrdinaryDefineOwnMetadata(metadataKey, metadataValue, target, propertyKey);
          }
          return decorator;
        }
        exporter("metadata", metadata);
        function defineMetadata(metadataKey, metadataValue, target, propertyKey) {
          if (!IsObject(target))
            throw new TypeError();
          if (!IsUndefined(propertyKey))
            propertyKey = ToPropertyKey(propertyKey);
          return OrdinaryDefineOwnMetadata(metadataKey, metadataValue, target, propertyKey);
        }
        exporter("defineMetadata", defineMetadata);
        function hasMetadata(metadataKey, target, propertyKey) {
          if (!IsObject(target))
            throw new TypeError();
          if (!IsUndefined(propertyKey))
            propertyKey = ToPropertyKey(propertyKey);
          return OrdinaryHasMetadata(metadataKey, target, propertyKey);
        }
        exporter("hasMetadata", hasMetadata);
        function hasOwnMetadata(metadataKey, target, propertyKey) {
          if (!IsObject(target))
            throw new TypeError();
          if (!IsUndefined(propertyKey))
            propertyKey = ToPropertyKey(propertyKey);
          return OrdinaryHasOwnMetadata(metadataKey, target, propertyKey);
        }
        exporter("hasOwnMetadata", hasOwnMetadata);
        function getMetadata(metadataKey, target, propertyKey) {
          if (!IsObject(target))
            throw new TypeError();
          if (!IsUndefined(propertyKey))
            propertyKey = ToPropertyKey(propertyKey);
          return OrdinaryGetMetadata(metadataKey, target, propertyKey);
        }
        exporter("getMetadata", getMetadata);
        function getOwnMetadata(metadataKey, target, propertyKey) {
          if (!IsObject(target))
            throw new TypeError();
          if (!IsUndefined(propertyKey))
            propertyKey = ToPropertyKey(propertyKey);
          return OrdinaryGetOwnMetadata(metadataKey, target, propertyKey);
        }
        exporter("getOwnMetadata", getOwnMetadata);
        function getMetadataKeys(target, propertyKey) {
          if (!IsObject(target))
            throw new TypeError();
          if (!IsUndefined(propertyKey))
            propertyKey = ToPropertyKey(propertyKey);
          return OrdinaryMetadataKeys(target, propertyKey);
        }
        exporter("getMetadataKeys", getMetadataKeys);
        function getOwnMetadataKeys(target, propertyKey) {
          if (!IsObject(target))
            throw new TypeError();
          if (!IsUndefined(propertyKey))
            propertyKey = ToPropertyKey(propertyKey);
          return OrdinaryOwnMetadataKeys(target, propertyKey);
        }
        exporter("getOwnMetadataKeys", getOwnMetadataKeys);
        function deleteMetadata(metadataKey, target, propertyKey) {
          if (!IsObject(target))
            throw new TypeError();
          if (!IsUndefined(propertyKey))
            propertyKey = ToPropertyKey(propertyKey);
          if (!IsObject(target))
            throw new TypeError();
          if (!IsUndefined(propertyKey))
            propertyKey = ToPropertyKey(propertyKey);
          var provider = GetMetadataProvider(
            target,
            propertyKey,
            /*Create*/
            false
          );
          if (IsUndefined(provider))
            return false;
          return provider.OrdinaryDeleteMetadata(metadataKey, target, propertyKey);
        }
        exporter("deleteMetadata", deleteMetadata);
        function DecorateConstructor(decorators, target) {
          for (var i = decorators.length - 1; i >= 0; --i) {
            var decorator = decorators[i];
            var decorated = decorator(target);
            if (!IsUndefined(decorated) && !IsNull(decorated)) {
              if (!IsConstructor(decorated))
                throw new TypeError();
              target = decorated;
            }
          }
          return target;
        }
        function DecorateProperty(decorators, target, propertyKey, descriptor) {
          for (var i = decorators.length - 1; i >= 0; --i) {
            var decorator = decorators[i];
            var decorated = decorator(target, propertyKey, descriptor);
            if (!IsUndefined(decorated) && !IsNull(decorated)) {
              if (!IsObject(decorated))
                throw new TypeError();
              descriptor = decorated;
            }
          }
          return descriptor;
        }
        function OrdinaryHasMetadata(MetadataKey, O, P) {
          var hasOwn2 = OrdinaryHasOwnMetadata(MetadataKey, O, P);
          if (hasOwn2)
            return true;
          var parent = OrdinaryGetPrototypeOf(O);
          if (!IsNull(parent))
            return OrdinaryHasMetadata(MetadataKey, parent, P);
          return false;
        }
        function OrdinaryHasOwnMetadata(MetadataKey, O, P) {
          var provider = GetMetadataProvider(
            O,
            P,
            /*Create*/
            false
          );
          if (IsUndefined(provider))
            return false;
          return ToBoolean(provider.OrdinaryHasOwnMetadata(MetadataKey, O, P));
        }
        function OrdinaryGetMetadata(MetadataKey, O, P) {
          var hasOwn2 = OrdinaryHasOwnMetadata(MetadataKey, O, P);
          if (hasOwn2)
            return OrdinaryGetOwnMetadata(MetadataKey, O, P);
          var parent = OrdinaryGetPrototypeOf(O);
          if (!IsNull(parent))
            return OrdinaryGetMetadata(MetadataKey, parent, P);
          return void 0;
        }
        function OrdinaryGetOwnMetadata(MetadataKey, O, P) {
          var provider = GetMetadataProvider(
            O,
            P,
            /*Create*/
            false
          );
          if (IsUndefined(provider))
            return;
          return provider.OrdinaryGetOwnMetadata(MetadataKey, O, P);
        }
        function OrdinaryDefineOwnMetadata(MetadataKey, MetadataValue, O, P) {
          var provider = GetMetadataProvider(
            O,
            P,
            /*Create*/
            true
          );
          provider.OrdinaryDefineOwnMetadata(MetadataKey, MetadataValue, O, P);
        }
        function OrdinaryMetadataKeys(O, P) {
          var ownKeys = OrdinaryOwnMetadataKeys(O, P);
          var parent = OrdinaryGetPrototypeOf(O);
          if (parent === null)
            return ownKeys;
          var parentKeys = OrdinaryMetadataKeys(parent, P);
          if (parentKeys.length <= 0)
            return ownKeys;
          if (ownKeys.length <= 0)
            return parentKeys;
          var set = new _Set();
          var keys = [];
          for (var _i = 0, ownKeys_1 = ownKeys; _i < ownKeys_1.length; _i++) {
            var key = ownKeys_1[_i];
            var hasKey = set.has(key);
            if (!hasKey) {
              set.add(key);
              keys.push(key);
            }
          }
          for (var _a = 0, parentKeys_1 = parentKeys; _a < parentKeys_1.length; _a++) {
            var key = parentKeys_1[_a];
            var hasKey = set.has(key);
            if (!hasKey) {
              set.add(key);
              keys.push(key);
            }
          }
          return keys;
        }
        function OrdinaryOwnMetadataKeys(O, P) {
          var provider = GetMetadataProvider(
            O,
            P,
            /*create*/
            false
          );
          if (!provider) {
            return [];
          }
          return provider.OrdinaryOwnMetadataKeys(O, P);
        }
        function Type(x2) {
          if (x2 === null)
            return 1;
          switch (typeof x2) {
            case "undefined":
              return 0;
            case "boolean":
              return 2;
            case "string":
              return 3;
            case "symbol":
              return 4;
            case "number":
              return 5;
            case "object":
              return x2 === null ? 1 : 6;
            default:
              return 6;
          }
        }
        function IsUndefined(x2) {
          return x2 === void 0;
        }
        function IsNull(x2) {
          return x2 === null;
        }
        function IsSymbol(x2) {
          return typeof x2 === "symbol";
        }
        function IsObject(x2) {
          return typeof x2 === "object" ? x2 !== null : typeof x2 === "function";
        }
        function ToPrimitive(input, PreferredType) {
          switch (Type(input)) {
            case 0:
              return input;
            case 1:
              return input;
            case 2:
              return input;
            case 3:
              return input;
            case 4:
              return input;
            case 5:
              return input;
          }
          var hint = PreferredType === 3 ? "string" : PreferredType === 5 ? "number" : "default";
          var exoticToPrim = GetMethod(input, toPrimitiveSymbol);
          if (exoticToPrim !== void 0) {
            var result2 = exoticToPrim.call(input, hint);
            if (IsObject(result2))
              throw new TypeError();
            return result2;
          }
          return OrdinaryToPrimitive(input, hint === "default" ? "number" : hint);
        }
        function OrdinaryToPrimitive(O, hint) {
          if (hint === "string") {
            var toString_1 = O.toString;
            if (IsCallable(toString_1)) {
              var result2 = toString_1.call(O);
              if (!IsObject(result2))
                return result2;
            }
            var valueOf = O.valueOf;
            if (IsCallable(valueOf)) {
              var result2 = valueOf.call(O);
              if (!IsObject(result2))
                return result2;
            }
          } else {
            var valueOf = O.valueOf;
            if (IsCallable(valueOf)) {
              var result2 = valueOf.call(O);
              if (!IsObject(result2))
                return result2;
            }
            var toString_2 = O.toString;
            if (IsCallable(toString_2)) {
              var result2 = toString_2.call(O);
              if (!IsObject(result2))
                return result2;
            }
          }
          throw new TypeError();
        }
        function ToBoolean(argument) {
          return !!argument;
        }
        function ToString(argument) {
          return "" + argument;
        }
        function ToPropertyKey(argument) {
          var key = ToPrimitive(
            argument,
            3
            /* String */
          );
          if (IsSymbol(key))
            return key;
          return ToString(key);
        }
        function IsArray(argument) {
          return Array.isArray ? Array.isArray(argument) : argument instanceof Object ? argument instanceof Array : Object.prototype.toString.call(argument) === "[object Array]";
        }
        function IsCallable(argument) {
          return typeof argument === "function";
        }
        function IsConstructor(argument) {
          return typeof argument === "function";
        }
        function IsPropertyKey(argument) {
          switch (Type(argument)) {
            case 3:
              return true;
            case 4:
              return true;
            default:
              return false;
          }
        }
        function SameValueZero(x2, y) {
          return x2 === y || x2 !== x2 && y !== y;
        }
        function GetMethod(V, P) {
          var func = V[P];
          if (func === void 0 || func === null)
            return void 0;
          if (!IsCallable(func))
            throw new TypeError();
          return func;
        }
        function GetIterator(obj) {
          var method = GetMethod(obj, iteratorSymbol);
          if (!IsCallable(method))
            throw new TypeError();
          var iterator = method.call(obj);
          if (!IsObject(iterator))
            throw new TypeError();
          return iterator;
        }
        function IteratorValue(iterResult) {
          return iterResult.value;
        }
        function IteratorStep(iterator) {
          var result2 = iterator.next();
          return result2.done ? false : result2;
        }
        function IteratorClose(iterator) {
          var f2 = iterator["return"];
          if (f2)
            f2.call(iterator);
        }
        function OrdinaryGetPrototypeOf(O) {
          var proto = Object.getPrototypeOf(O);
          if (typeof O !== "function" || O === functionPrototype)
            return proto;
          if (proto !== functionPrototype)
            return proto;
          var prototype = O.prototype;
          var prototypeProto = prototype && Object.getPrototypeOf(prototype);
          if (prototypeProto == null || prototypeProto === Object.prototype)
            return proto;
          var constructor = prototypeProto.constructor;
          if (typeof constructor !== "function")
            return proto;
          if (constructor === O)
            return proto;
          return constructor;
        }
        function CreateMetadataRegistry() {
          var fallback;
          if (!IsUndefined(registrySymbol) && typeof root.Reflect !== "undefined" && !(registrySymbol in root.Reflect) && typeof root.Reflect.defineMetadata === "function") {
            fallback = CreateFallbackProvider(root.Reflect);
          }
          var first;
          var second;
          var rest;
          var targetProviderMap = new _WeakMap();
          var registry = {
            registerProvider,
            getProvider,
            setProvider
          };
          return registry;
          function registerProvider(provider) {
            if (!Object.isExtensible(registry)) {
              throw new Error("Cannot add provider to a frozen registry.");
            }
            switch (true) {
              case fallback === provider:
                break;
              case IsUndefined(first):
                first = provider;
                break;
              case first === provider:
                break;
              case IsUndefined(second):
                second = provider;
                break;
              case second === provider:
                break;
              default:
                if (rest === void 0)
                  rest = new _Set();
                rest.add(provider);
                break;
            }
          }
          function getProviderNoCache(O, P) {
            if (!IsUndefined(first)) {
              if (first.isProviderFor(O, P))
                return first;
              if (!IsUndefined(second)) {
                if (second.isProviderFor(O, P))
                  return first;
                if (!IsUndefined(rest)) {
                  var iterator = GetIterator(rest);
                  while (true) {
                    var next = IteratorStep(iterator);
                    if (!next) {
                      return void 0;
                    }
                    var provider = IteratorValue(next);
                    if (provider.isProviderFor(O, P)) {
                      IteratorClose(iterator);
                      return provider;
                    }
                  }
                }
              }
            }
            if (!IsUndefined(fallback) && fallback.isProviderFor(O, P)) {
              return fallback;
            }
            return void 0;
          }
          function getProvider(O, P) {
            var providerMap = targetProviderMap.get(O);
            var provider;
            if (!IsUndefined(providerMap)) {
              provider = providerMap.get(P);
            }
            if (!IsUndefined(provider)) {
              return provider;
            }
            provider = getProviderNoCache(O, P);
            if (!IsUndefined(provider)) {
              if (IsUndefined(providerMap)) {
                providerMap = new _Map();
                targetProviderMap.set(O, providerMap);
              }
              providerMap.set(P, provider);
            }
            return provider;
          }
          function hasProvider(provider) {
            if (IsUndefined(provider))
              throw new TypeError();
            return first === provider || second === provider || !IsUndefined(rest) && rest.has(provider);
          }
          function setProvider(O, P, provider) {
            if (!hasProvider(provider)) {
              throw new Error("Metadata provider not registered.");
            }
            var existingProvider = getProvider(O, P);
            if (existingProvider !== provider) {
              if (!IsUndefined(existingProvider)) {
                return false;
              }
              var providerMap = targetProviderMap.get(O);
              if (IsUndefined(providerMap)) {
                providerMap = new _Map();
                targetProviderMap.set(O, providerMap);
              }
              providerMap.set(P, provider);
            }
            return true;
          }
        }
        function GetOrCreateMetadataRegistry() {
          var metadataRegistry2;
          if (!IsUndefined(registrySymbol) && IsObject(root.Reflect) && Object.isExtensible(root.Reflect)) {
            metadataRegistry2 = root.Reflect[registrySymbol];
          }
          if (IsUndefined(metadataRegistry2)) {
            metadataRegistry2 = CreateMetadataRegistry();
          }
          if (!IsUndefined(registrySymbol) && IsObject(root.Reflect) && Object.isExtensible(root.Reflect)) {
            Object.defineProperty(root.Reflect, registrySymbol, {
              enumerable: false,
              configurable: false,
              writable: false,
              value: metadataRegistry2
            });
          }
          return metadataRegistry2;
        }
        function CreateMetadataProvider(registry) {
          var metadata2 = new _WeakMap();
          var provider = {
            isProviderFor: function(O, P) {
              var targetMetadata = metadata2.get(O);
              if (IsUndefined(targetMetadata))
                return false;
              return targetMetadata.has(P);
            },
            OrdinaryDefineOwnMetadata: OrdinaryDefineOwnMetadata2,
            OrdinaryHasOwnMetadata: OrdinaryHasOwnMetadata2,
            OrdinaryGetOwnMetadata: OrdinaryGetOwnMetadata2,
            OrdinaryOwnMetadataKeys: OrdinaryOwnMetadataKeys2,
            OrdinaryDeleteMetadata
          };
          metadataRegistry.registerProvider(provider);
          return provider;
          function GetOrCreateMetadataMap(O, P, Create) {
            var targetMetadata = metadata2.get(O);
            var createdTargetMetadata = false;
            if (IsUndefined(targetMetadata)) {
              if (!Create)
                return void 0;
              targetMetadata = new _Map();
              metadata2.set(O, targetMetadata);
              createdTargetMetadata = true;
            }
            var metadataMap = targetMetadata.get(P);
            if (IsUndefined(metadataMap)) {
              if (!Create)
                return void 0;
              metadataMap = new _Map();
              targetMetadata.set(P, metadataMap);
              if (!registry.setProvider(O, P, provider)) {
                targetMetadata.delete(P);
                if (createdTargetMetadata) {
                  metadata2.delete(O);
                }
                throw new Error("Wrong provider for target.");
              }
            }
            return metadataMap;
          }
          function OrdinaryHasOwnMetadata2(MetadataKey, O, P) {
            var metadataMap = GetOrCreateMetadataMap(
              O,
              P,
              /*Create*/
              false
            );
            if (IsUndefined(metadataMap))
              return false;
            return ToBoolean(metadataMap.has(MetadataKey));
          }
          function OrdinaryGetOwnMetadata2(MetadataKey, O, P) {
            var metadataMap = GetOrCreateMetadataMap(
              O,
              P,
              /*Create*/
              false
            );
            if (IsUndefined(metadataMap))
              return void 0;
            return metadataMap.get(MetadataKey);
          }
          function OrdinaryDefineOwnMetadata2(MetadataKey, MetadataValue, O, P) {
            var metadataMap = GetOrCreateMetadataMap(
              O,
              P,
              /*Create*/
              true
            );
            metadataMap.set(MetadataKey, MetadataValue);
          }
          function OrdinaryOwnMetadataKeys2(O, P) {
            var keys = [];
            var metadataMap = GetOrCreateMetadataMap(
              O,
              P,
              /*Create*/
              false
            );
            if (IsUndefined(metadataMap))
              return keys;
            var keysObj = metadataMap.keys();
            var iterator = GetIterator(keysObj);
            var k = 0;
            while (true) {
              var next = IteratorStep(iterator);
              if (!next) {
                keys.length = k;
                return keys;
              }
              var nextValue = IteratorValue(next);
              try {
                keys[k] = nextValue;
              } catch (e) {
                try {
                  IteratorClose(iterator);
                } finally {
                  throw e;
                }
              }
              k++;
            }
          }
          function OrdinaryDeleteMetadata(MetadataKey, O, P) {
            var metadataMap = GetOrCreateMetadataMap(
              O,
              P,
              /*Create*/
              false
            );
            if (IsUndefined(metadataMap))
              return false;
            if (!metadataMap.delete(MetadataKey))
              return false;
            if (metadataMap.size === 0) {
              var targetMetadata = metadata2.get(O);
              if (!IsUndefined(targetMetadata)) {
                targetMetadata.delete(P);
                if (targetMetadata.size === 0) {
                  metadata2.delete(targetMetadata);
                }
              }
            }
            return true;
          }
        }
        function CreateFallbackProvider(reflect) {
          var defineMetadata2 = reflect.defineMetadata, hasOwnMetadata2 = reflect.hasOwnMetadata, getOwnMetadata2 = reflect.getOwnMetadata, getOwnMetadataKeys2 = reflect.getOwnMetadataKeys, deleteMetadata2 = reflect.deleteMetadata;
          var metadataOwner = new _WeakMap();
          var provider = {
            isProviderFor: function(O, P) {
              var metadataPropertySet = metadataOwner.get(O);
              if (!IsUndefined(metadataPropertySet)) {
                return metadataPropertySet.has(P);
              }
              if (getOwnMetadataKeys2(O, P).length) {
                if (IsUndefined(metadataPropertySet)) {
                  metadataPropertySet = new _Set();
                  metadataOwner.set(O, metadataPropertySet);
                }
                metadataPropertySet.add(P);
                return true;
              }
              return false;
            },
            OrdinaryDefineOwnMetadata: defineMetadata2,
            OrdinaryHasOwnMetadata: hasOwnMetadata2,
            OrdinaryGetOwnMetadata: getOwnMetadata2,
            OrdinaryOwnMetadataKeys: getOwnMetadataKeys2,
            OrdinaryDeleteMetadata: deleteMetadata2
          };
          return provider;
        }
        function GetMetadataProvider(O, P, Create) {
          var registeredProvider = metadataRegistry.getProvider(O, P);
          if (!IsUndefined(registeredProvider)) {
            return registeredProvider;
          }
          if (Create) {
            if (metadataRegistry.setProvider(O, P, metadataProvider)) {
              return metadataProvider;
            }
            throw new Error("Illegal state.");
          }
          return void 0;
        }
        function CreateMapPolyfill() {
          var cacheSentinel = {};
          var arraySentinel = [];
          var MapIterator = (
            /** @class */
            function() {
              function MapIterator2(keys, values, selector) {
                this._index = 0;
                this._keys = keys;
                this._values = values;
                this._selector = selector;
              }
              MapIterator2.prototype["@@iterator"] = function() {
                return this;
              };
              MapIterator2.prototype[iteratorSymbol] = function() {
                return this;
              };
              MapIterator2.prototype.next = function() {
                var index = this._index;
                if (index >= 0 && index < this._keys.length) {
                  var result2 = this._selector(this._keys[index], this._values[index]);
                  if (index + 1 >= this._keys.length) {
                    this._index = -1;
                    this._keys = arraySentinel;
                    this._values = arraySentinel;
                  } else {
                    this._index++;
                  }
                  return { value: result2, done: false };
                }
                return { value: void 0, done: true };
              };
              MapIterator2.prototype.throw = function(error) {
                if (this._index >= 0) {
                  this._index = -1;
                  this._keys = arraySentinel;
                  this._values = arraySentinel;
                }
                throw error;
              };
              MapIterator2.prototype.return = function(value) {
                if (this._index >= 0) {
                  this._index = -1;
                  this._keys = arraySentinel;
                  this._values = arraySentinel;
                }
                return { value, done: true };
              };
              return MapIterator2;
            }()
          );
          var Map2 = (
            /** @class */
            function() {
              function Map3() {
                this._keys = [];
                this._values = [];
                this._cacheKey = cacheSentinel;
                this._cacheIndex = -2;
              }
              Object.defineProperty(Map3.prototype, "size", {
                get: function() {
                  return this._keys.length;
                },
                enumerable: true,
                configurable: true
              });
              Map3.prototype.has = function(key) {
                return this._find(
                  key,
                  /*insert*/
                  false
                ) >= 0;
              };
              Map3.prototype.get = function(key) {
                var index = this._find(
                  key,
                  /*insert*/
                  false
                );
                return index >= 0 ? this._values[index] : void 0;
              };
              Map3.prototype.set = function(key, value) {
                var index = this._find(
                  key,
                  /*insert*/
                  true
                );
                this._values[index] = value;
                return this;
              };
              Map3.prototype.delete = function(key) {
                var index = this._find(
                  key,
                  /*insert*/
                  false
                );
                if (index >= 0) {
                  var size = this._keys.length;
                  for (var i = index + 1; i < size; i++) {
                    this._keys[i - 1] = this._keys[i];
                    this._values[i - 1] = this._values[i];
                  }
                  this._keys.length--;
                  this._values.length--;
                  if (SameValueZero(key, this._cacheKey)) {
                    this._cacheKey = cacheSentinel;
                    this._cacheIndex = -2;
                  }
                  return true;
                }
                return false;
              };
              Map3.prototype.clear = function() {
                this._keys.length = 0;
                this._values.length = 0;
                this._cacheKey = cacheSentinel;
                this._cacheIndex = -2;
              };
              Map3.prototype.keys = function() {
                return new MapIterator(this._keys, this._values, getKey);
              };
              Map3.prototype.values = function() {
                return new MapIterator(this._keys, this._values, getValue);
              };
              Map3.prototype.entries = function() {
                return new MapIterator(this._keys, this._values, getEntry);
              };
              Map3.prototype["@@iterator"] = function() {
                return this.entries();
              };
              Map3.prototype[iteratorSymbol] = function() {
                return this.entries();
              };
              Map3.prototype._find = function(key, insert) {
                if (!SameValueZero(this._cacheKey, key)) {
                  this._cacheIndex = -1;
                  for (var i = 0; i < this._keys.length; i++) {
                    if (SameValueZero(this._keys[i], key)) {
                      this._cacheIndex = i;
                      break;
                    }
                  }
                }
                if (this._cacheIndex < 0 && insert) {
                  this._cacheIndex = this._keys.length;
                  this._keys.push(key);
                  this._values.push(void 0);
                }
                return this._cacheIndex;
              };
              return Map3;
            }()
          );
          return Map2;
          function getKey(key, _) {
            return key;
          }
          function getValue(_, value) {
            return value;
          }
          function getEntry(key, value) {
            return [key, value];
          }
        }
        function CreateSetPolyfill() {
          var Set2 = (
            /** @class */
            function() {
              function Set3() {
                this._map = new _Map();
              }
              Object.defineProperty(Set3.prototype, "size", {
                get: function() {
                  return this._map.size;
                },
                enumerable: true,
                configurable: true
              });
              Set3.prototype.has = function(value) {
                return this._map.has(value);
              };
              Set3.prototype.add = function(value) {
                return this._map.set(value, value), this;
              };
              Set3.prototype.delete = function(value) {
                return this._map.delete(value);
              };
              Set3.prototype.clear = function() {
                this._map.clear();
              };
              Set3.prototype.keys = function() {
                return this._map.keys();
              };
              Set3.prototype.values = function() {
                return this._map.keys();
              };
              Set3.prototype.entries = function() {
                return this._map.entries();
              };
              Set3.prototype["@@iterator"] = function() {
                return this.keys();
              };
              Set3.prototype[iteratorSymbol] = function() {
                return this.keys();
              };
              return Set3;
            }()
          );
          return Set2;
        }
        function CreateWeakMapPolyfill() {
          var UUID_SIZE = 16;
          var keys = HashMap.create();
          var rootKey = CreateUniqueKey();
          return (
            /** @class */
            function() {
              function WeakMap2() {
                this._key = CreateUniqueKey();
              }
              WeakMap2.prototype.has = function(target) {
                var table = GetOrCreateWeakMapTable(
                  target,
                  /*create*/
                  false
                );
                return table !== void 0 ? HashMap.has(table, this._key) : false;
              };
              WeakMap2.prototype.get = function(target) {
                var table = GetOrCreateWeakMapTable(
                  target,
                  /*create*/
                  false
                );
                return table !== void 0 ? HashMap.get(table, this._key) : void 0;
              };
              WeakMap2.prototype.set = function(target, value) {
                var table = GetOrCreateWeakMapTable(
                  target,
                  /*create*/
                  true
                );
                table[this._key] = value;
                return this;
              };
              WeakMap2.prototype.delete = function(target) {
                var table = GetOrCreateWeakMapTable(
                  target,
                  /*create*/
                  false
                );
                return table !== void 0 ? delete table[this._key] : false;
              };
              WeakMap2.prototype.clear = function() {
                this._key = CreateUniqueKey();
              };
              return WeakMap2;
            }()
          );
          function CreateUniqueKey() {
            var key;
            do
              key = "@@WeakMap@@" + CreateUUID();
            while (HashMap.has(keys, key));
            keys[key] = true;
            return key;
          }
          function GetOrCreateWeakMapTable(target, create) {
            if (!hasOwn.call(target, rootKey)) {
              if (!create)
                return void 0;
              Object.defineProperty(target, rootKey, { value: HashMap.create() });
            }
            return target[rootKey];
          }
          function FillRandomBytes(buffer, size) {
            for (var i = 0; i < size; ++i)
              buffer[i] = Math.random() * 255 | 0;
            return buffer;
          }
          function GenRandomBytes(size) {
            if (typeof Uint8Array === "function") {
              if (typeof crypto !== "undefined")
                return crypto.getRandomValues(new Uint8Array(size));
              if (typeof msCrypto !== "undefined")
                return msCrypto.getRandomValues(new Uint8Array(size));
              return FillRandomBytes(new Uint8Array(size), size);
            }
            return FillRandomBytes(new Array(size), size);
          }
          function CreateUUID() {
            var data = GenRandomBytes(UUID_SIZE);
            data[6] = data[6] & 79 | 64;
            data[8] = data[8] & 191 | 128;
            var result2 = "";
            for (var offset = 0; offset < UUID_SIZE; ++offset) {
              var byte = data[offset];
              if (offset === 4 || offset === 6 || offset === 8)
                result2 += "-";
              if (byte < 16)
                result2 += "0";
              result2 += byte.toString(16).toLowerCase();
            }
            return result2;
          }
        }
        function MakeDictionary(obj) {
          obj.__ = void 0;
          delete obj.__;
          return obj;
        }
      });
    })(Reflect2 || (Reflect2 = {}));
  }
});

// node_modules/tslib/tslib.es6.mjs
var tslib_es6_exports = {};
__export(tslib_es6_exports, {
  __addDisposableResource: () => __addDisposableResource,
  __assign: () => __assign,
  __asyncDelegator: () => __asyncDelegator,
  __asyncGenerator: () => __asyncGenerator,
  __asyncValues: () => __asyncValues,
  __await: () => __await,
  __awaiter: () => __awaiter,
  __classPrivateFieldGet: () => __classPrivateFieldGet,
  __classPrivateFieldIn: () => __classPrivateFieldIn,
  __classPrivateFieldSet: () => __classPrivateFieldSet,
  __createBinding: () => __createBinding,
  __decorate: () => __decorate,
  __disposeResources: () => __disposeResources,
  __esDecorate: () => __esDecorate,
  __exportStar: () => __exportStar,
  __extends: () => __extends,
  __generator: () => __generator,
  __importDefault: () => __importDefault,
  __importStar: () => __importStar,
  __makeTemplateObject: () => __makeTemplateObject,
  __metadata: () => __metadata,
  __param: () => __param,
  __propKey: () => __propKey,
  __read: () => __read,
  __rest: () => __rest,
  __runInitializers: () => __runInitializers,
  __setFunctionName: () => __setFunctionName,
  __spread: () => __spread,
  __spreadArray: () => __spreadArray,
  __spreadArrays: () => __spreadArrays,
  __values: () => __values,
  default: () => tslib_es6_default
});
function __extends(d2, b) {
  if (typeof b !== "function" && b !== null)
    throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
  extendStatics(d2, b);
  function __() {
    this.constructor = d2;
  }
  d2.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}
function __rest(s, e) {
  var t = {};
  for (var p3 in s)
    if (Object.prototype.hasOwnProperty.call(s, p3) && e.indexOf(p3) < 0)
      t[p3] = s[p3];
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p3 = Object.getOwnPropertySymbols(s); i < p3.length; i++) {
      if (e.indexOf(p3[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p3[i]))
        t[p3[i]] = s[p3[i]];
    }
  return t;
}
function __decorate(decorators, target, key, desc) {
  var c2 = arguments.length, r = c2 < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d2;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
    r = Reflect.decorate(decorators, target, key, desc);
  else
    for (var i = decorators.length - 1; i >= 0; i--)
      if (d2 = decorators[i])
        r = (c2 < 3 ? d2(r) : c2 > 3 ? d2(target, key, r) : d2(target, key)) || r;
  return c2 > 3 && r && Object.defineProperty(target, key, r), r;
}
function __param(paramIndex, decorator) {
  return function(target, key) {
    decorator(target, key, paramIndex);
  };
}
function __esDecorate(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
  function accept(f2) {
    if (f2 !== void 0 && typeof f2 !== "function")
      throw new TypeError("Function expected");
    return f2;
  }
  var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
  var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
  var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
  var _, done = false;
  for (var i = decorators.length - 1; i >= 0; i--) {
    var context = {};
    for (var p3 in contextIn)
      context[p3] = p3 === "access" ? {} : contextIn[p3];
    for (var p3 in contextIn.access)
      context.access[p3] = contextIn.access[p3];
    context.addInitializer = function(f2) {
      if (done)
        throw new TypeError("Cannot add initializers after decoration has completed");
      extraInitializers.push(accept(f2 || null));
    };
    var result2 = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
    if (kind === "accessor") {
      if (result2 === void 0)
        continue;
      if (result2 === null || typeof result2 !== "object")
        throw new TypeError("Object expected");
      if (_ = accept(result2.get))
        descriptor.get = _;
      if (_ = accept(result2.set))
        descriptor.set = _;
      if (_ = accept(result2.init))
        initializers.unshift(_);
    } else if (_ = accept(result2)) {
      if (kind === "field")
        initializers.unshift(_);
      else
        descriptor[key] = _;
    }
  }
  if (target)
    Object.defineProperty(target, contextIn.name, descriptor);
  done = true;
}
function __runInitializers(thisArg, initializers, value) {
  var useValue = arguments.length > 2;
  for (var i = 0; i < initializers.length; i++) {
    value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
  }
  return useValue ? value : void 0;
}
function __propKey(x2) {
  return typeof x2 === "symbol" ? x2 : "".concat(x2);
}
function __setFunctionName(f2, name, prefix) {
  if (typeof name === "symbol")
    name = name.description ? "[".concat(name.description, "]") : "";
  return Object.defineProperty(f2, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
}
function __metadata(metadataKey, metadataValue) {
  if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
    return Reflect.metadata(metadataKey, metadataValue);
}
function __awaiter(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function(resolve2) {
      resolve2(value);
    });
  }
  return new (P || (P = Promise))(function(resolve2, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result2) {
      result2.done ? resolve2(result2.value) : adopt(result2.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
}
function __generator(thisArg, body) {
  var _ = { label: 0, sent: function() {
    if (t[0] & 1)
      throw t[1];
    return t[1];
  }, trys: [], ops: [] }, f2, y, t, g2;
  return g2 = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g2[Symbol.iterator] = function() {
    return this;
  }), g2;
  function verb(n) {
    return function(v) {
      return step([n, v]);
    };
  }
  function step(op) {
    if (f2)
      throw new TypeError("Generator is already executing.");
    while (g2 && (g2 = 0, op[0] && (_ = 0)), _)
      try {
        if (f2 = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
          return t;
        if (y = 0, t)
          op = [op[0] & 2, t.value];
        switch (op[0]) {
          case 0:
          case 1:
            t = op;
            break;
          case 4:
            _.label++;
            return { value: op[1], done: false };
          case 5:
            _.label++;
            y = op[1];
            op = [0];
            continue;
          case 7:
            op = _.ops.pop();
            _.trys.pop();
            continue;
          default:
            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
              _ = 0;
              continue;
            }
            if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
              _.label = op[1];
              break;
            }
            if (op[0] === 6 && _.label < t[1]) {
              _.label = t[1];
              t = op;
              break;
            }
            if (t && _.label < t[2]) {
              _.label = t[2];
              _.ops.push(op);
              break;
            }
            if (t[2])
              _.ops.pop();
            _.trys.pop();
            continue;
        }
        op = body.call(thisArg, _);
      } catch (e) {
        op = [6, e];
        y = 0;
      } finally {
        f2 = t = 0;
      }
    if (op[0] & 5)
      throw op[1];
    return { value: op[0] ? op[1] : void 0, done: true };
  }
}
function __exportStar(m2, o2) {
  for (var p3 in m2)
    if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(o2, p3))
      __createBinding(o2, m2, p3);
}
function __values(o2) {
  var s = typeof Symbol === "function" && Symbol.iterator, m2 = s && o2[s], i = 0;
  if (m2)
    return m2.call(o2);
  if (o2 && typeof o2.length === "number")
    return {
      next: function() {
        if (o2 && i >= o2.length)
          o2 = void 0;
        return { value: o2 && o2[i++], done: !o2 };
      }
    };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
}
function __read(o2, n) {
  var m2 = typeof Symbol === "function" && o2[Symbol.iterator];
  if (!m2)
    return o2;
  var i = m2.call(o2), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
      ar.push(r.value);
  } catch (error) {
    e = { error };
  } finally {
    try {
      if (r && !r.done && (m2 = i["return"]))
        m2.call(i);
    } finally {
      if (e)
        throw e.error;
    }
  }
  return ar;
}
function __spread() {
  for (var ar = [], i = 0; i < arguments.length; i++)
    ar = ar.concat(__read(arguments[i]));
  return ar;
}
function __spreadArrays() {
  for (var s = 0, i = 0, il = arguments.length; i < il; i++)
    s += arguments[i].length;
  for (var r = Array(s), k = 0, i = 0; i < il; i++)
    for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
      r[k] = a[j];
  return r;
}
function __spreadArray(to, from, pack) {
  if (pack || arguments.length === 2)
    for (var i = 0, l2 = from.length, ar; i < l2; i++) {
      if (ar || !(i in from)) {
        if (!ar)
          ar = Array.prototype.slice.call(from, 0, i);
        ar[i] = from[i];
      }
    }
  return to.concat(ar || Array.prototype.slice.call(from));
}
function __await(v) {
  return this instanceof __await ? (this.v = v, this) : new __await(v);
}
function __asyncGenerator(thisArg, _arguments, generator) {
  if (!Symbol.asyncIterator)
    throw new TypeError("Symbol.asyncIterator is not defined.");
  var g2 = generator.apply(thisArg, _arguments || []), i, q2 = [];
  return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function() {
    return this;
  }, i;
  function verb(n) {
    if (g2[n])
      i[n] = function(v) {
        return new Promise(function(a, b) {
          q2.push([n, v, a, b]) > 1 || resume(n, v);
        });
      };
  }
  function resume(n, v) {
    try {
      step(g2[n](v));
    } catch (e) {
      settle(q2[0][3], e);
    }
  }
  function step(r) {
    r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q2[0][2], r);
  }
  function fulfill(value) {
    resume("next", value);
  }
  function reject(value) {
    resume("throw", value);
  }
  function settle(f2, v) {
    if (f2(v), q2.shift(), q2.length)
      resume(q2[0][0], q2[0][1]);
  }
}
function __asyncDelegator(o2) {
  var i, p3;
  return i = {}, verb("next"), verb("throw", function(e) {
    throw e;
  }), verb("return"), i[Symbol.iterator] = function() {
    return this;
  }, i;
  function verb(n, f2) {
    i[n] = o2[n] ? function(v) {
      return (p3 = !p3) ? { value: __await(o2[n](v)), done: false } : f2 ? f2(v) : v;
    } : f2;
  }
}
function __asyncValues(o2) {
  if (!Symbol.asyncIterator)
    throw new TypeError("Symbol.asyncIterator is not defined.");
  var m2 = o2[Symbol.asyncIterator], i;
  return m2 ? m2.call(o2) : (o2 = typeof __values === "function" ? __values(o2) : o2[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function() {
    return this;
  }, i);
  function verb(n) {
    i[n] = o2[n] && function(v) {
      return new Promise(function(resolve2, reject) {
        v = o2[n](v), settle(resolve2, reject, v.done, v.value);
      });
    };
  }
  function settle(resolve2, reject, d2, v) {
    Promise.resolve(v).then(function(v2) {
      resolve2({ value: v2, done: d2 });
    }, reject);
  }
}
function __makeTemplateObject(cooked, raw2) {
  if (Object.defineProperty) {
    Object.defineProperty(cooked, "raw", { value: raw2 });
  } else {
    cooked.raw = raw2;
  }
  return cooked;
}
function __importStar(mod) {
  if (mod && mod.__esModule)
    return mod;
  var result2 = {};
  if (mod != null) {
    for (var k in mod)
      if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
        __createBinding(result2, mod, k);
  }
  __setModuleDefault(result2, mod);
  return result2;
}
function __importDefault(mod) {
  return mod && mod.__esModule ? mod : { default: mod };
}
function __classPrivateFieldGet(receiver, state, kind, f2) {
  if (kind === "a" && !f2)
    throw new TypeError("Private accessor was defined without a getter");
  if (typeof state === "function" ? receiver !== state || !f2 : !state.has(receiver))
    throw new TypeError("Cannot read private member from an object whose class did not declare it");
  return kind === "m" ? f2 : kind === "a" ? f2.call(receiver) : f2 ? f2.value : state.get(receiver);
}
function __classPrivateFieldSet(receiver, state, value, kind, f2) {
  if (kind === "m")
    throw new TypeError("Private method is not writable");
  if (kind === "a" && !f2)
    throw new TypeError("Private accessor was defined without a setter");
  if (typeof state === "function" ? receiver !== state || !f2 : !state.has(receiver))
    throw new TypeError("Cannot write private member to an object whose class did not declare it");
  return kind === "a" ? f2.call(receiver, value) : f2 ? f2.value = value : state.set(receiver, value), value;
}
function __classPrivateFieldIn(state, receiver) {
  if (receiver === null || typeof receiver !== "object" && typeof receiver !== "function")
    throw new TypeError("Cannot use 'in' operator on non-object");
  return typeof state === "function" ? receiver === state : state.has(receiver);
}
function __addDisposableResource(env, value, async) {
  if (value !== null && value !== void 0) {
    if (typeof value !== "object" && typeof value !== "function")
      throw new TypeError("Object expected.");
    var dispose;
    if (async) {
      if (!Symbol.asyncDispose)
        throw new TypeError("Symbol.asyncDispose is not defined.");
      dispose = value[Symbol.asyncDispose];
    }
    if (dispose === void 0) {
      if (!Symbol.dispose)
        throw new TypeError("Symbol.dispose is not defined.");
      dispose = value[Symbol.dispose];
    }
    if (typeof dispose !== "function")
      throw new TypeError("Object not disposable.");
    env.stack.push({ value, dispose, async });
  } else if (async) {
    env.stack.push({ async: true });
  }
  return value;
}
function __disposeResources(env) {
  function fail(e) {
    env.error = env.hasError ? new _SuppressedError(e, env.error, "An error was suppressed during disposal.") : e;
    env.hasError = true;
  }
  function next() {
    while (env.stack.length) {
      var rec = env.stack.pop();
      try {
        var result2 = rec.dispose && rec.dispose.call(rec.value);
        if (rec.async)
          return Promise.resolve(result2).then(next, function(e) {
            fail(e);
            return next();
          });
      } catch (e) {
        fail(e);
      }
    }
    if (env.hasError)
      throw env.error;
  }
  return next();
}
var extendStatics, __assign, __createBinding, __setModuleDefault, _SuppressedError, tslib_es6_default;
var init_tslib_es6 = __esm({
  "node_modules/tslib/tslib.es6.mjs"() {
    extendStatics = function(d2, b) {
      extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d3, b2) {
        d3.__proto__ = b2;
      } || function(d3, b2) {
        for (var p3 in b2)
          if (Object.prototype.hasOwnProperty.call(b2, p3))
            d3[p3] = b2[p3];
      };
      return extendStatics(d2, b);
    };
    __assign = function() {
      __assign = Object.assign || function __assign3(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
          s = arguments[i];
          for (var p3 in s)
            if (Object.prototype.hasOwnProperty.call(s, p3))
              t[p3] = s[p3];
        }
        return t;
      };
      return __assign.apply(this, arguments);
    };
    __createBinding = Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    };
    __setModuleDefault = Object.create ? function(o2, v) {
      Object.defineProperty(o2, "default", { enumerable: true, value: v });
    } : function(o2, v) {
      o2["default"] = v;
    };
    _SuppressedError = typeof SuppressedError === "function" ? SuppressedError : function(error, suppressed, message) {
      var e = new Error(message);
      return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
    };
    tslib_es6_default = {
      __extends,
      __assign,
      __rest,
      __decorate,
      __param,
      __metadata,
      __awaiter,
      __generator,
      __createBinding,
      __exportStar,
      __values,
      __read,
      __spread,
      __spreadArrays,
      __spreadArray,
      __await,
      __asyncGenerator,
      __asyncDelegator,
      __asyncValues,
      __makeTemplateObject,
      __importStar,
      __importDefault,
      __classPrivateFieldGet,
      __classPrivateFieldSet,
      __classPrivateFieldIn,
      __addDisposableResource,
      __disposeResources
    };
  }
});

// node_modules/pvtsutils/build/index.js
var require_build3 = __commonJS({
  "node_modules/pvtsutils/build/index.js"(exports2) {
    "use strict";
    var ARRAY_BUFFER_NAME = "[object ArrayBuffer]";
    var BufferSourceConverter = class _BufferSourceConverter {
      static isArrayBuffer(data) {
        return Object.prototype.toString.call(data) === ARRAY_BUFFER_NAME;
      }
      static toArrayBuffer(data) {
        if (this.isArrayBuffer(data)) {
          return data;
        }
        if (data.byteLength === data.buffer.byteLength) {
          return data.buffer;
        }
        if (data.byteOffset === 0 && data.byteLength === data.buffer.byteLength) {
          return data.buffer;
        }
        return this.toUint8Array(data.buffer).slice(data.byteOffset, data.byteOffset + data.byteLength).buffer;
      }
      static toUint8Array(data) {
        return this.toView(data, Uint8Array);
      }
      static toView(data, type) {
        if (data.constructor === type) {
          return data;
        }
        if (this.isArrayBuffer(data)) {
          return new type(data);
        }
        if (this.isArrayBufferView(data)) {
          return new type(data.buffer, data.byteOffset, data.byteLength);
        }
        throw new TypeError("The provided value is not of type '(ArrayBuffer or ArrayBufferView)'");
      }
      static isBufferSource(data) {
        return this.isArrayBufferView(data) || this.isArrayBuffer(data);
      }
      static isArrayBufferView(data) {
        return ArrayBuffer.isView(data) || data && this.isArrayBuffer(data.buffer);
      }
      static isEqual(a, b) {
        const aView = _BufferSourceConverter.toUint8Array(a);
        const bView = _BufferSourceConverter.toUint8Array(b);
        if (aView.length !== bView.byteLength) {
          return false;
        }
        for (let i = 0; i < aView.length; i++) {
          if (aView[i] !== bView[i]) {
            return false;
          }
        }
        return true;
      }
      static concat(...args) {
        let buffers;
        if (Array.isArray(args[0]) && !(args[1] instanceof Function)) {
          buffers = args[0];
        } else if (Array.isArray(args[0]) && args[1] instanceof Function) {
          buffers = args[0];
        } else {
          if (args[args.length - 1] instanceof Function) {
            buffers = args.slice(0, args.length - 1);
          } else {
            buffers = args;
          }
        }
        let size = 0;
        for (const buffer of buffers) {
          size += buffer.byteLength;
        }
        const res = new Uint8Array(size);
        let offset = 0;
        for (const buffer of buffers) {
          const view = this.toUint8Array(buffer);
          res.set(view, offset);
          offset += view.length;
        }
        if (args[args.length - 1] instanceof Function) {
          return this.toView(res, args[args.length - 1]);
        }
        return res.buffer;
      }
    };
    var STRING_TYPE = "string";
    var HEX_REGEX = /^[0-9a-f]+$/i;
    var BASE64_REGEX = /^(?:[A-Za-z0-9+/]{4})*(?:[A-Za-z0-9+/]{2}==|[A-Za-z0-9+/]{3}=)?$/;
    var BASE64URL_REGEX = /^[a-zA-Z0-9-_]+$/;
    var Utf8Converter = class {
      static fromString(text2) {
        const s = unescape(encodeURIComponent(text2));
        const uintArray = new Uint8Array(s.length);
        for (let i = 0; i < s.length; i++) {
          uintArray[i] = s.charCodeAt(i);
        }
        return uintArray.buffer;
      }
      static toString(buffer) {
        const buf = BufferSourceConverter.toUint8Array(buffer);
        let encodedString = "";
        for (let i = 0; i < buf.length; i++) {
          encodedString += String.fromCharCode(buf[i]);
        }
        const decodedString = decodeURIComponent(escape(encodedString));
        return decodedString;
      }
    };
    var Utf16Converter = class {
      static toString(buffer, littleEndian = false) {
        const arrayBuffer = BufferSourceConverter.toArrayBuffer(buffer);
        const dataView = new DataView(arrayBuffer);
        let res = "";
        for (let i = 0; i < arrayBuffer.byteLength; i += 2) {
          const code = dataView.getUint16(i, littleEndian);
          res += String.fromCharCode(code);
        }
        return res;
      }
      static fromString(text2, littleEndian = false) {
        const res = new ArrayBuffer(text2.length * 2);
        const dataView = new DataView(res);
        for (let i = 0; i < text2.length; i++) {
          dataView.setUint16(i * 2, text2.charCodeAt(i), littleEndian);
        }
        return res;
      }
    };
    var Convert = class _Convert {
      static isHex(data) {
        return typeof data === STRING_TYPE && HEX_REGEX.test(data);
      }
      static isBase64(data) {
        return typeof data === STRING_TYPE && BASE64_REGEX.test(data);
      }
      static isBase64Url(data) {
        return typeof data === STRING_TYPE && BASE64URL_REGEX.test(data);
      }
      static ToString(buffer, enc = "utf8") {
        const buf = BufferSourceConverter.toUint8Array(buffer);
        switch (enc.toLowerCase()) {
          case "utf8":
            return this.ToUtf8String(buf);
          case "binary":
            return this.ToBinary(buf);
          case "hex":
            return this.ToHex(buf);
          case "base64":
            return this.ToBase64(buf);
          case "base64url":
            return this.ToBase64Url(buf);
          case "utf16le":
            return Utf16Converter.toString(buf, true);
          case "utf16":
          case "utf16be":
            return Utf16Converter.toString(buf);
          default:
            throw new Error(`Unknown type of encoding '${enc}'`);
        }
      }
      static FromString(str, enc = "utf8") {
        if (!str) {
          return new ArrayBuffer(0);
        }
        switch (enc.toLowerCase()) {
          case "utf8":
            return this.FromUtf8String(str);
          case "binary":
            return this.FromBinary(str);
          case "hex":
            return this.FromHex(str);
          case "base64":
            return this.FromBase64(str);
          case "base64url":
            return this.FromBase64Url(str);
          case "utf16le":
            return Utf16Converter.fromString(str, true);
          case "utf16":
          case "utf16be":
            return Utf16Converter.fromString(str);
          default:
            throw new Error(`Unknown type of encoding '${enc}'`);
        }
      }
      static ToBase64(buffer) {
        const buf = BufferSourceConverter.toUint8Array(buffer);
        if (typeof btoa !== "undefined") {
          const binary = this.ToString(buf, "binary");
          return btoa(binary);
        } else {
          return Buffer.from(buf).toString("base64");
        }
      }
      static FromBase64(base64) {
        const formatted = this.formatString(base64);
        if (!formatted) {
          return new ArrayBuffer(0);
        }
        if (!_Convert.isBase64(formatted)) {
          throw new TypeError("Argument 'base64Text' is not Base64 encoded");
        }
        if (typeof atob !== "undefined") {
          return this.FromBinary(atob(formatted));
        } else {
          return new Uint8Array(Buffer.from(formatted, "base64")).buffer;
        }
      }
      static FromBase64Url(base64url) {
        const formatted = this.formatString(base64url);
        if (!formatted) {
          return new ArrayBuffer(0);
        }
        if (!_Convert.isBase64Url(formatted)) {
          throw new TypeError("Argument 'base64url' is not Base64Url encoded");
        }
        return this.FromBase64(this.Base64Padding(formatted.replace(/\-/g, "+").replace(/\_/g, "/")));
      }
      static ToBase64Url(data) {
        return this.ToBase64(data).replace(/\+/g, "-").replace(/\//g, "_").replace(/\=/g, "");
      }
      static FromUtf8String(text2, encoding = _Convert.DEFAULT_UTF8_ENCODING) {
        switch (encoding) {
          case "ascii":
            return this.FromBinary(text2);
          case "utf8":
            return Utf8Converter.fromString(text2);
          case "utf16":
          case "utf16be":
            return Utf16Converter.fromString(text2);
          case "utf16le":
          case "usc2":
            return Utf16Converter.fromString(text2, true);
          default:
            throw new Error(`Unknown type of encoding '${encoding}'`);
        }
      }
      static ToUtf8String(buffer, encoding = _Convert.DEFAULT_UTF8_ENCODING) {
        switch (encoding) {
          case "ascii":
            return this.ToBinary(buffer);
          case "utf8":
            return Utf8Converter.toString(buffer);
          case "utf16":
          case "utf16be":
            return Utf16Converter.toString(buffer);
          case "utf16le":
          case "usc2":
            return Utf16Converter.toString(buffer, true);
          default:
            throw new Error(`Unknown type of encoding '${encoding}'`);
        }
      }
      static FromBinary(text2) {
        const stringLength = text2.length;
        const resultView = new Uint8Array(stringLength);
        for (let i = 0; i < stringLength; i++) {
          resultView[i] = text2.charCodeAt(i);
        }
        return resultView.buffer;
      }
      static ToBinary(buffer) {
        const buf = BufferSourceConverter.toUint8Array(buffer);
        let res = "";
        for (let i = 0; i < buf.length; i++) {
          res += String.fromCharCode(buf[i]);
        }
        return res;
      }
      static ToHex(buffer) {
        const buf = BufferSourceConverter.toUint8Array(buffer);
        let result2 = "";
        const len = buf.length;
        for (let i = 0; i < len; i++) {
          const byte = buf[i];
          if (byte < 16) {
            result2 += "0";
          }
          result2 += byte.toString(16);
        }
        return result2;
      }
      static FromHex(hexString) {
        let formatted = this.formatString(hexString);
        if (!formatted) {
          return new ArrayBuffer(0);
        }
        if (!_Convert.isHex(formatted)) {
          throw new TypeError("Argument 'hexString' is not HEX encoded");
        }
        if (formatted.length % 2) {
          formatted = `0${formatted}`;
        }
        const res = new Uint8Array(formatted.length / 2);
        for (let i = 0; i < formatted.length; i = i + 2) {
          const c2 = formatted.slice(i, i + 2);
          res[i / 2] = parseInt(c2, 16);
        }
        return res.buffer;
      }
      static ToUtf16String(buffer, littleEndian = false) {
        return Utf16Converter.toString(buffer, littleEndian);
      }
      static FromUtf16String(text2, littleEndian = false) {
        return Utf16Converter.fromString(text2, littleEndian);
      }
      static Base64Padding(base64) {
        const padCount = 4 - base64.length % 4;
        if (padCount < 4) {
          for (let i = 0; i < padCount; i++) {
            base64 += "=";
          }
        }
        return base64;
      }
      static formatString(data) {
        return (data === null || data === void 0 ? void 0 : data.replace(/[\n\r\t ]/g, "")) || "";
      }
    };
    Convert.DEFAULT_UTF8_ENCODING = "utf8";
    function assign(target, ...sources) {
      const res = arguments[0];
      for (let i = 1; i < arguments.length; i++) {
        const obj = arguments[i];
        for (const prop in obj) {
          res[prop] = obj[prop];
        }
      }
      return res;
    }
    function combine(...buf) {
      const totalByteLength = buf.map((item) => item.byteLength).reduce((prev, cur) => prev + cur);
      const res = new Uint8Array(totalByteLength);
      let currentPos = 0;
      buf.map((item) => new Uint8Array(item)).forEach((arr) => {
        for (const item2 of arr) {
          res[currentPos++] = item2;
        }
      });
      return res.buffer;
    }
    function isEqual(bytes1, bytes2) {
      if (!(bytes1 && bytes2)) {
        return false;
      }
      if (bytes1.byteLength !== bytes2.byteLength) {
        return false;
      }
      const b1 = new Uint8Array(bytes1);
      const b2 = new Uint8Array(bytes2);
      for (let i = 0; i < bytes1.byteLength; i++) {
        if (b1[i] !== b2[i]) {
          return false;
        }
      }
      return true;
    }
    exports2.BufferSourceConverter = BufferSourceConverter;
    exports2.Convert = Convert;
    exports2.assign = assign;
    exports2.combine = combine;
    exports2.isEqual = isEqual;
  }
});

// node_modules/pvutils/build/utils.js
var require_utils4 = __commonJS({
  "node_modules/pvutils/build/utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    function getUTCDate(date) {
      return new Date(date.getTime() + date.getTimezoneOffset() * 6e4);
    }
    function getParametersValue(parameters, name, defaultValue) {
      var _a;
      if (parameters instanceof Object === false) {
        return defaultValue;
      }
      return (_a = parameters[name]) !== null && _a !== void 0 ? _a : defaultValue;
    }
    function bufferToHexCodes(inputBuffer, inputOffset = 0, inputLength = inputBuffer.byteLength - inputOffset, insertSpace = false) {
      let result2 = "";
      for (const item of new Uint8Array(inputBuffer, inputOffset, inputLength)) {
        const str = item.toString(16).toUpperCase();
        if (str.length === 1) {
          result2 += "0";
        }
        result2 += str;
        if (insertSpace) {
          result2 += " ";
        }
      }
      return result2.trim();
    }
    function checkBufferParams(baseBlock, inputBuffer, inputOffset, inputLength) {
      if (!(inputBuffer instanceof ArrayBuffer)) {
        baseBlock.error = 'Wrong parameter: inputBuffer must be "ArrayBuffer"';
        return false;
      }
      if (!inputBuffer.byteLength) {
        baseBlock.error = "Wrong parameter: inputBuffer has zero length";
        return false;
      }
      if (inputOffset < 0) {
        baseBlock.error = "Wrong parameter: inputOffset less than zero";
        return false;
      }
      if (inputLength < 0) {
        baseBlock.error = "Wrong parameter: inputLength less than zero";
        return false;
      }
      if (inputBuffer.byteLength - inputOffset - inputLength < 0) {
        baseBlock.error = "End of input reached before message was fully decoded (inconsistent offset and length values)";
        return false;
      }
      return true;
    }
    function utilFromBase(inputBuffer, inputBase) {
      let result2 = 0;
      if (inputBuffer.length === 1) {
        return inputBuffer[0];
      }
      for (let i = inputBuffer.length - 1; i >= 0; i--) {
        result2 += inputBuffer[inputBuffer.length - 1 - i] * Math.pow(2, inputBase * i);
      }
      return result2;
    }
    function utilToBase(value, base, reserved = -1) {
      const internalReserved = reserved;
      let internalValue = value;
      let result2 = 0;
      let biggest = Math.pow(2, base);
      for (let i = 1; i < 8; i++) {
        if (value < biggest) {
          let retBuf;
          if (internalReserved < 0) {
            retBuf = new ArrayBuffer(i);
            result2 = i;
          } else {
            if (internalReserved < i) {
              return new ArrayBuffer(0);
            }
            retBuf = new ArrayBuffer(internalReserved);
            result2 = internalReserved;
          }
          const retView = new Uint8Array(retBuf);
          for (let j = i - 1; j >= 0; j--) {
            const basis = Math.pow(2, j * base);
            retView[result2 - j - 1] = Math.floor(internalValue / basis);
            internalValue -= retView[result2 - j - 1] * basis;
          }
          return retBuf;
        }
        biggest *= Math.pow(2, base);
      }
      return new ArrayBuffer(0);
    }
    function utilConcatBuf(...buffers) {
      let outputLength = 0;
      let prevLength = 0;
      for (const buffer of buffers) {
        outputLength += buffer.byteLength;
      }
      const retBuf = new ArrayBuffer(outputLength);
      const retView = new Uint8Array(retBuf);
      for (const buffer of buffers) {
        retView.set(new Uint8Array(buffer), prevLength);
        prevLength += buffer.byteLength;
      }
      return retBuf;
    }
    function utilConcatView(...views) {
      let outputLength = 0;
      let prevLength = 0;
      for (const view of views) {
        outputLength += view.length;
      }
      const retBuf = new ArrayBuffer(outputLength);
      const retView = new Uint8Array(retBuf);
      for (const view of views) {
        retView.set(view, prevLength);
        prevLength += view.length;
      }
      return retView;
    }
    function utilDecodeTC() {
      const buf = new Uint8Array(this.valueHex);
      if (this.valueHex.byteLength >= 2) {
        const condition1 = buf[0] === 255 && buf[1] & 128;
        const condition2 = buf[0] === 0 && (buf[1] & 128) === 0;
        if (condition1 || condition2) {
          this.warnings.push("Needlessly long format");
        }
      }
      const bigIntBuffer = new ArrayBuffer(this.valueHex.byteLength);
      const bigIntView = new Uint8Array(bigIntBuffer);
      for (let i = 0; i < this.valueHex.byteLength; i++) {
        bigIntView[i] = 0;
      }
      bigIntView[0] = buf[0] & 128;
      const bigInt = utilFromBase(bigIntView, 8);
      const smallIntBuffer = new ArrayBuffer(this.valueHex.byteLength);
      const smallIntView = new Uint8Array(smallIntBuffer);
      for (let j = 0; j < this.valueHex.byteLength; j++) {
        smallIntView[j] = buf[j];
      }
      smallIntView[0] &= 127;
      const smallInt = utilFromBase(smallIntView, 8);
      return smallInt - bigInt;
    }
    function utilEncodeTC(value) {
      const modValue = value < 0 ? value * -1 : value;
      let bigInt = 128;
      for (let i = 1; i < 8; i++) {
        if (modValue <= bigInt) {
          if (value < 0) {
            const smallInt = bigInt - modValue;
            const retBuf2 = utilToBase(smallInt, 8, i);
            const retView2 = new Uint8Array(retBuf2);
            retView2[0] |= 128;
            return retBuf2;
          }
          let retBuf = utilToBase(modValue, 8, i);
          let retView = new Uint8Array(retBuf);
          if (retView[0] & 128) {
            const tempBuf = retBuf.slice(0);
            const tempView = new Uint8Array(tempBuf);
            retBuf = new ArrayBuffer(retBuf.byteLength + 1);
            retView = new Uint8Array(retBuf);
            for (let k = 0; k < tempBuf.byteLength; k++) {
              retView[k + 1] = tempView[k];
            }
            retView[0] = 0;
          }
          return retBuf;
        }
        bigInt *= Math.pow(2, 8);
      }
      return new ArrayBuffer(0);
    }
    function isEqualBuffer(inputBuffer1, inputBuffer2) {
      if (inputBuffer1.byteLength !== inputBuffer2.byteLength) {
        return false;
      }
      const view1 = new Uint8Array(inputBuffer1);
      const view2 = new Uint8Array(inputBuffer2);
      for (let i = 0; i < view1.length; i++) {
        if (view1[i] !== view2[i]) {
          return false;
        }
      }
      return true;
    }
    function padNumber(inputNumber, fullLength) {
      const str = inputNumber.toString(10);
      if (fullLength < str.length) {
        return "";
      }
      const dif = fullLength - str.length;
      const padding = new Array(dif);
      for (let i = 0; i < dif; i++) {
        padding[i] = "0";
      }
      const paddingString = padding.join("");
      return paddingString.concat(str);
    }
    var base64Template = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
    var base64UrlTemplate = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_=";
    function toBase64(input, useUrlTemplate = false, skipPadding = false, skipLeadingZeros = false) {
      let i = 0;
      let flag1 = 0;
      let flag2 = 0;
      let output = "";
      const template = useUrlTemplate ? base64UrlTemplate : base64Template;
      if (skipLeadingZeros) {
        let nonZeroPosition = 0;
        for (let i2 = 0; i2 < input.length; i2++) {
          if (input.charCodeAt(i2) !== 0) {
            nonZeroPosition = i2;
            break;
          }
        }
        input = input.slice(nonZeroPosition);
      }
      while (i < input.length) {
        const chr1 = input.charCodeAt(i++);
        if (i >= input.length) {
          flag1 = 1;
        }
        const chr2 = input.charCodeAt(i++);
        if (i >= input.length) {
          flag2 = 1;
        }
        const chr3 = input.charCodeAt(i++);
        const enc1 = chr1 >> 2;
        const enc2 = (chr1 & 3) << 4 | chr2 >> 4;
        let enc3 = (chr2 & 15) << 2 | chr3 >> 6;
        let enc4 = chr3 & 63;
        if (flag1 === 1) {
          enc3 = enc4 = 64;
        } else {
          if (flag2 === 1) {
            enc4 = 64;
          }
        }
        if (skipPadding) {
          if (enc3 === 64) {
            output += `${template.charAt(enc1)}${template.charAt(enc2)}`;
          } else {
            if (enc4 === 64) {
              output += `${template.charAt(enc1)}${template.charAt(enc2)}${template.charAt(enc3)}`;
            } else {
              output += `${template.charAt(enc1)}${template.charAt(enc2)}${template.charAt(enc3)}${template.charAt(enc4)}`;
            }
          }
        } else {
          output += `${template.charAt(enc1)}${template.charAt(enc2)}${template.charAt(enc3)}${template.charAt(enc4)}`;
        }
      }
      return output;
    }
    function fromBase64(input, useUrlTemplate = false, cutTailZeros = false) {
      const template = useUrlTemplate ? base64UrlTemplate : base64Template;
      function indexOf(toSearch) {
        for (let i2 = 0; i2 < 64; i2++) {
          if (template.charAt(i2) === toSearch)
            return i2;
        }
        return 64;
      }
      function test(incoming) {
        return incoming === 64 ? 0 : incoming;
      }
      let i = 0;
      let output = "";
      while (i < input.length) {
        const enc1 = indexOf(input.charAt(i++));
        const enc2 = i >= input.length ? 0 : indexOf(input.charAt(i++));
        const enc3 = i >= input.length ? 0 : indexOf(input.charAt(i++));
        const enc4 = i >= input.length ? 0 : indexOf(input.charAt(i++));
        const chr1 = test(enc1) << 2 | test(enc2) >> 4;
        const chr2 = (test(enc2) & 15) << 4 | test(enc3) >> 2;
        const chr3 = (test(enc3) & 3) << 6 | test(enc4);
        output += String.fromCharCode(chr1);
        if (enc3 !== 64) {
          output += String.fromCharCode(chr2);
        }
        if (enc4 !== 64) {
          output += String.fromCharCode(chr3);
        }
      }
      if (cutTailZeros) {
        const outputLength = output.length;
        let nonZeroStart = -1;
        for (let i2 = outputLength - 1; i2 >= 0; i2--) {
          if (output.charCodeAt(i2) !== 0) {
            nonZeroStart = i2;
            break;
          }
        }
        if (nonZeroStart !== -1) {
          output = output.slice(0, nonZeroStart + 1);
        } else {
          output = "";
        }
      }
      return output;
    }
    function arrayBufferToString(buffer) {
      let resultString = "";
      const view = new Uint8Array(buffer);
      for (const element of view) {
        resultString += String.fromCharCode(element);
      }
      return resultString;
    }
    function stringToArrayBuffer(str) {
      const stringLength = str.length;
      const resultBuffer = new ArrayBuffer(stringLength);
      const resultView = new Uint8Array(resultBuffer);
      for (let i = 0; i < stringLength; i++) {
        resultView[i] = str.charCodeAt(i);
      }
      return resultBuffer;
    }
    var log2 = Math.log(2);
    function nearestPowerOf2(length) {
      const base = Math.log(length) / log2;
      const floor = Math.floor(base);
      const round = Math.round(base);
      return floor === round ? floor : round;
    }
    function clearProps(object, propsArray) {
      for (const prop of propsArray) {
        delete object[prop];
      }
    }
    exports2.arrayBufferToString = arrayBufferToString;
    exports2.bufferToHexCodes = bufferToHexCodes;
    exports2.checkBufferParams = checkBufferParams;
    exports2.clearProps = clearProps;
    exports2.fromBase64 = fromBase64;
    exports2.getParametersValue = getParametersValue;
    exports2.getUTCDate = getUTCDate;
    exports2.isEqualBuffer = isEqualBuffer;
    exports2.nearestPowerOf2 = nearestPowerOf2;
    exports2.padNumber = padNumber;
    exports2.stringToArrayBuffer = stringToArrayBuffer;
    exports2.toBase64 = toBase64;
    exports2.utilConcatBuf = utilConcatBuf;
    exports2.utilConcatView = utilConcatView;
    exports2.utilDecodeTC = utilDecodeTC;
    exports2.utilEncodeTC = utilEncodeTC;
    exports2.utilFromBase = utilFromBase;
    exports2.utilToBase = utilToBase;
  }
});

// node_modules/asn1js/build/index.js
var require_build4 = __commonJS({
  "node_modules/asn1js/build/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var pvtsutils = require_build3();
    var pvutils = require_utils4();
    function _interopNamespace(e) {
      if (e && e.__esModule)
        return e;
      var n = /* @__PURE__ */ Object.create(null);
      if (e) {
        Object.keys(e).forEach(function(k) {
          if (k !== "default") {
            var d2 = Object.getOwnPropertyDescriptor(e, k);
            Object.defineProperty(n, k, d2.get ? d2 : {
              enumerable: true,
              get: function() {
                return e[k];
              }
            });
          }
        });
      }
      n["default"] = e;
      return Object.freeze(n);
    }
    var pvtsutils__namespace = /* @__PURE__ */ _interopNamespace(pvtsutils);
    var pvutils__namespace = /* @__PURE__ */ _interopNamespace(pvutils);
    function assertBigInt() {
      if (typeof BigInt === "undefined") {
        throw new Error("BigInt is not defined. Your environment doesn't implement BigInt.");
      }
    }
    function concat(buffers) {
      let outputLength = 0;
      let prevLength = 0;
      for (let i = 0; i < buffers.length; i++) {
        const buffer = buffers[i];
        outputLength += buffer.byteLength;
      }
      const retView = new Uint8Array(outputLength);
      for (let i = 0; i < buffers.length; i++) {
        const buffer = buffers[i];
        retView.set(new Uint8Array(buffer), prevLength);
        prevLength += buffer.byteLength;
      }
      return retView.buffer;
    }
    function checkBufferParams(baseBlock, inputBuffer, inputOffset, inputLength) {
      if (!(inputBuffer instanceof Uint8Array)) {
        baseBlock.error = "Wrong parameter: inputBuffer must be 'Uint8Array'";
        return false;
      }
      if (!inputBuffer.byteLength) {
        baseBlock.error = "Wrong parameter: inputBuffer has zero length";
        return false;
      }
      if (inputOffset < 0) {
        baseBlock.error = "Wrong parameter: inputOffset less than zero";
        return false;
      }
      if (inputLength < 0) {
        baseBlock.error = "Wrong parameter: inputLength less than zero";
        return false;
      }
      if (inputBuffer.byteLength - inputOffset - inputLength < 0) {
        baseBlock.error = "End of input reached before message was fully decoded (inconsistent offset and length values)";
        return false;
      }
      return true;
    }
    var ViewWriter = class {
      constructor() {
        this.items = [];
      }
      write(buf) {
        this.items.push(buf);
      }
      final() {
        return concat(this.items);
      }
    };
    var powers2 = [new Uint8Array([1])];
    var digitsString = "0123456789";
    var NAME = "name";
    var VALUE_HEX_VIEW = "valueHexView";
    var IS_HEX_ONLY = "isHexOnly";
    var ID_BLOCK = "idBlock";
    var TAG_CLASS = "tagClass";
    var TAG_NUMBER = "tagNumber";
    var IS_CONSTRUCTED = "isConstructed";
    var FROM_BER = "fromBER";
    var TO_BER = "toBER";
    var LOCAL = "local";
    var EMPTY_STRING = "";
    var EMPTY_BUFFER = new ArrayBuffer(0);
    var EMPTY_VIEW = new Uint8Array(0);
    var END_OF_CONTENT_NAME = "EndOfContent";
    var OCTET_STRING_NAME = "OCTET STRING";
    var BIT_STRING_NAME = "BIT STRING";
    function HexBlock(BaseClass) {
      var _a2;
      return _a2 = class Some extends BaseClass {
        constructor(...args) {
          var _a3;
          super(...args);
          const params = args[0] || {};
          this.isHexOnly = (_a3 = params.isHexOnly) !== null && _a3 !== void 0 ? _a3 : false;
          this.valueHexView = params.valueHex ? pvtsutils__namespace.BufferSourceConverter.toUint8Array(params.valueHex) : EMPTY_VIEW;
        }
        get valueHex() {
          return this.valueHexView.slice().buffer;
        }
        set valueHex(value) {
          this.valueHexView = new Uint8Array(value);
        }
        fromBER(inputBuffer, inputOffset, inputLength) {
          const view = inputBuffer instanceof ArrayBuffer ? new Uint8Array(inputBuffer) : inputBuffer;
          if (!checkBufferParams(this, view, inputOffset, inputLength)) {
            return -1;
          }
          const endLength = inputOffset + inputLength;
          this.valueHexView = view.subarray(inputOffset, endLength);
          if (!this.valueHexView.length) {
            this.warnings.push("Zero buffer length");
            return inputOffset;
          }
          this.blockLength = inputLength;
          return endLength;
        }
        toBER(sizeOnly = false) {
          if (!this.isHexOnly) {
            this.error = "Flag 'isHexOnly' is not set, abort";
            return EMPTY_BUFFER;
          }
          if (sizeOnly) {
            return new ArrayBuffer(this.valueHexView.byteLength);
          }
          return this.valueHexView.byteLength === this.valueHexView.buffer.byteLength ? this.valueHexView.buffer : this.valueHexView.slice().buffer;
        }
        toJSON() {
          return {
            ...super.toJSON(),
            isHexOnly: this.isHexOnly,
            valueHex: pvtsutils__namespace.Convert.ToHex(this.valueHexView)
          };
        }
      }, _a2.NAME = "hexBlock", _a2;
    }
    var LocalBaseBlock = class {
      constructor({ blockLength = 0, error = EMPTY_STRING, warnings = [], valueBeforeDecode = EMPTY_VIEW } = {}) {
        this.blockLength = blockLength;
        this.error = error;
        this.warnings = warnings;
        this.valueBeforeDecodeView = pvtsutils__namespace.BufferSourceConverter.toUint8Array(valueBeforeDecode);
      }
      static blockName() {
        return this.NAME;
      }
      get valueBeforeDecode() {
        return this.valueBeforeDecodeView.slice().buffer;
      }
      set valueBeforeDecode(value) {
        this.valueBeforeDecodeView = new Uint8Array(value);
      }
      toJSON() {
        return {
          blockName: this.constructor.NAME,
          blockLength: this.blockLength,
          error: this.error,
          warnings: this.warnings,
          valueBeforeDecode: pvtsutils__namespace.Convert.ToHex(this.valueBeforeDecodeView)
        };
      }
    };
    LocalBaseBlock.NAME = "baseBlock";
    var ValueBlock = class extends LocalBaseBlock {
      fromBER(inputBuffer, inputOffset, inputLength) {
        throw TypeError("User need to make a specific function in a class which extends 'ValueBlock'");
      }
      toBER(sizeOnly, writer) {
        throw TypeError("User need to make a specific function in a class which extends 'ValueBlock'");
      }
    };
    ValueBlock.NAME = "valueBlock";
    var LocalIdentificationBlock = class extends HexBlock(LocalBaseBlock) {
      constructor({ idBlock = {} } = {}) {
        var _a2, _b, _c, _d;
        super();
        if (idBlock) {
          this.isHexOnly = (_a2 = idBlock.isHexOnly) !== null && _a2 !== void 0 ? _a2 : false;
          this.valueHexView = idBlock.valueHex ? pvtsutils__namespace.BufferSourceConverter.toUint8Array(idBlock.valueHex) : EMPTY_VIEW;
          this.tagClass = (_b = idBlock.tagClass) !== null && _b !== void 0 ? _b : -1;
          this.tagNumber = (_c = idBlock.tagNumber) !== null && _c !== void 0 ? _c : -1;
          this.isConstructed = (_d = idBlock.isConstructed) !== null && _d !== void 0 ? _d : false;
        } else {
          this.tagClass = -1;
          this.tagNumber = -1;
          this.isConstructed = false;
        }
      }
      toBER(sizeOnly = false) {
        let firstOctet = 0;
        switch (this.tagClass) {
          case 1:
            firstOctet |= 0;
            break;
          case 2:
            firstOctet |= 64;
            break;
          case 3:
            firstOctet |= 128;
            break;
          case 4:
            firstOctet |= 192;
            break;
          default:
            this.error = "Unknown tag class";
            return EMPTY_BUFFER;
        }
        if (this.isConstructed)
          firstOctet |= 32;
        if (this.tagNumber < 31 && !this.isHexOnly) {
          const retView2 = new Uint8Array(1);
          if (!sizeOnly) {
            let number = this.tagNumber;
            number &= 31;
            firstOctet |= number;
            retView2[0] = firstOctet;
          }
          return retView2.buffer;
        }
        if (!this.isHexOnly) {
          const encodedBuf = pvutils__namespace.utilToBase(this.tagNumber, 7);
          const encodedView = new Uint8Array(encodedBuf);
          const size = encodedBuf.byteLength;
          const retView2 = new Uint8Array(size + 1);
          retView2[0] = firstOctet | 31;
          if (!sizeOnly) {
            for (let i = 0; i < size - 1; i++)
              retView2[i + 1] = encodedView[i] | 128;
            retView2[size] = encodedView[size - 1];
          }
          return retView2.buffer;
        }
        const retView = new Uint8Array(this.valueHexView.byteLength + 1);
        retView[0] = firstOctet | 31;
        if (!sizeOnly) {
          const curView = this.valueHexView;
          for (let i = 0; i < curView.length - 1; i++)
            retView[i + 1] = curView[i] | 128;
          retView[this.valueHexView.byteLength] = curView[curView.length - 1];
        }
        return retView.buffer;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        const inputView = pvtsutils__namespace.BufferSourceConverter.toUint8Array(inputBuffer);
        if (!checkBufferParams(this, inputView, inputOffset, inputLength)) {
          return -1;
        }
        const intBuffer = inputView.subarray(inputOffset, inputOffset + inputLength);
        if (intBuffer.length === 0) {
          this.error = "Zero buffer length";
          return -1;
        }
        const tagClassMask = intBuffer[0] & 192;
        switch (tagClassMask) {
          case 0:
            this.tagClass = 1;
            break;
          case 64:
            this.tagClass = 2;
            break;
          case 128:
            this.tagClass = 3;
            break;
          case 192:
            this.tagClass = 4;
            break;
          default:
            this.error = "Unknown tag class";
            return -1;
        }
        this.isConstructed = (intBuffer[0] & 32) === 32;
        this.isHexOnly = false;
        const tagNumberMask = intBuffer[0] & 31;
        if (tagNumberMask !== 31) {
          this.tagNumber = tagNumberMask;
          this.blockLength = 1;
        } else {
          let count = 1;
          let intTagNumberBuffer = this.valueHexView = new Uint8Array(255);
          let tagNumberBufferMaxLength = 255;
          while (intBuffer[count] & 128) {
            intTagNumberBuffer[count - 1] = intBuffer[count] & 127;
            count++;
            if (count >= intBuffer.length) {
              this.error = "End of input reached before message was fully decoded";
              return -1;
            }
            if (count === tagNumberBufferMaxLength) {
              tagNumberBufferMaxLength += 255;
              const tempBufferView2 = new Uint8Array(tagNumberBufferMaxLength);
              for (let i = 0; i < intTagNumberBuffer.length; i++)
                tempBufferView2[i] = intTagNumberBuffer[i];
              intTagNumberBuffer = this.valueHexView = new Uint8Array(tagNumberBufferMaxLength);
            }
          }
          this.blockLength = count + 1;
          intTagNumberBuffer[count - 1] = intBuffer[count] & 127;
          const tempBufferView = new Uint8Array(count);
          for (let i = 0; i < count; i++)
            tempBufferView[i] = intTagNumberBuffer[i];
          intTagNumberBuffer = this.valueHexView = new Uint8Array(count);
          intTagNumberBuffer.set(tempBufferView);
          if (this.blockLength <= 9)
            this.tagNumber = pvutils__namespace.utilFromBase(intTagNumberBuffer, 7);
          else {
            this.isHexOnly = true;
            this.warnings.push("Tag too long, represented as hex-coded");
          }
        }
        if (this.tagClass === 1 && this.isConstructed) {
          switch (this.tagNumber) {
            case 1:
            case 2:
            case 5:
            case 6:
            case 9:
            case 13:
            case 14:
            case 23:
            case 24:
            case 31:
            case 32:
            case 33:
            case 34:
              this.error = "Constructed encoding used for primitive type";
              return -1;
          }
        }
        return inputOffset + this.blockLength;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          tagClass: this.tagClass,
          tagNumber: this.tagNumber,
          isConstructed: this.isConstructed
        };
      }
    };
    LocalIdentificationBlock.NAME = "identificationBlock";
    var LocalLengthBlock = class extends LocalBaseBlock {
      constructor({ lenBlock = {} } = {}) {
        var _a2, _b, _c;
        super();
        this.isIndefiniteForm = (_a2 = lenBlock.isIndefiniteForm) !== null && _a2 !== void 0 ? _a2 : false;
        this.longFormUsed = (_b = lenBlock.longFormUsed) !== null && _b !== void 0 ? _b : false;
        this.length = (_c = lenBlock.length) !== null && _c !== void 0 ? _c : 0;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        const view = pvtsutils__namespace.BufferSourceConverter.toUint8Array(inputBuffer);
        if (!checkBufferParams(this, view, inputOffset, inputLength)) {
          return -1;
        }
        const intBuffer = view.subarray(inputOffset, inputOffset + inputLength);
        if (intBuffer.length === 0) {
          this.error = "Zero buffer length";
          return -1;
        }
        if (intBuffer[0] === 255) {
          this.error = "Length block 0xFF is reserved by standard";
          return -1;
        }
        this.isIndefiniteForm = intBuffer[0] === 128;
        if (this.isIndefiniteForm) {
          this.blockLength = 1;
          return inputOffset + this.blockLength;
        }
        this.longFormUsed = !!(intBuffer[0] & 128);
        if (this.longFormUsed === false) {
          this.length = intBuffer[0];
          this.blockLength = 1;
          return inputOffset + this.blockLength;
        }
        const count = intBuffer[0] & 127;
        if (count > 8) {
          this.error = "Too big integer";
          return -1;
        }
        if (count + 1 > intBuffer.length) {
          this.error = "End of input reached before message was fully decoded";
          return -1;
        }
        const lenOffset = inputOffset + 1;
        const lengthBufferView = view.subarray(lenOffset, lenOffset + count);
        if (lengthBufferView[count - 1] === 0)
          this.warnings.push("Needlessly long encoded length");
        this.length = pvutils__namespace.utilFromBase(lengthBufferView, 8);
        if (this.longFormUsed && this.length <= 127)
          this.warnings.push("Unnecessary usage of long length form");
        this.blockLength = count + 1;
        return inputOffset + this.blockLength;
      }
      toBER(sizeOnly = false) {
        let retBuf;
        let retView;
        if (this.length > 127)
          this.longFormUsed = true;
        if (this.isIndefiniteForm) {
          retBuf = new ArrayBuffer(1);
          if (sizeOnly === false) {
            retView = new Uint8Array(retBuf);
            retView[0] = 128;
          }
          return retBuf;
        }
        if (this.longFormUsed) {
          const encodedBuf = pvutils__namespace.utilToBase(this.length, 8);
          if (encodedBuf.byteLength > 127) {
            this.error = "Too big length";
            return EMPTY_BUFFER;
          }
          retBuf = new ArrayBuffer(encodedBuf.byteLength + 1);
          if (sizeOnly)
            return retBuf;
          const encodedView = new Uint8Array(encodedBuf);
          retView = new Uint8Array(retBuf);
          retView[0] = encodedBuf.byteLength | 128;
          for (let i = 0; i < encodedBuf.byteLength; i++)
            retView[i + 1] = encodedView[i];
          return retBuf;
        }
        retBuf = new ArrayBuffer(1);
        if (sizeOnly === false) {
          retView = new Uint8Array(retBuf);
          retView[0] = this.length;
        }
        return retBuf;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          isIndefiniteForm: this.isIndefiniteForm,
          longFormUsed: this.longFormUsed,
          length: this.length
        };
      }
    };
    LocalLengthBlock.NAME = "lengthBlock";
    var typeStore = {};
    var BaseBlock = class extends LocalBaseBlock {
      constructor({ name = EMPTY_STRING, optional = false, primitiveSchema, ...parameters } = {}, valueBlockType) {
        super(parameters);
        this.name = name;
        this.optional = optional;
        if (primitiveSchema) {
          this.primitiveSchema = primitiveSchema;
        }
        this.idBlock = new LocalIdentificationBlock(parameters);
        this.lenBlock = new LocalLengthBlock(parameters);
        this.valueBlock = valueBlockType ? new valueBlockType(parameters) : new ValueBlock(parameters);
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        const resultOffset = this.valueBlock.fromBER(inputBuffer, inputOffset, this.lenBlock.isIndefiniteForm ? inputLength : this.lenBlock.length);
        if (resultOffset === -1) {
          this.error = this.valueBlock.error;
          return resultOffset;
        }
        if (!this.idBlock.error.length)
          this.blockLength += this.idBlock.blockLength;
        if (!this.lenBlock.error.length)
          this.blockLength += this.lenBlock.blockLength;
        if (!this.valueBlock.error.length)
          this.blockLength += this.valueBlock.blockLength;
        return resultOffset;
      }
      toBER(sizeOnly, writer) {
        const _writer = writer || new ViewWriter();
        if (!writer) {
          prepareIndefiniteForm(this);
        }
        const idBlockBuf = this.idBlock.toBER(sizeOnly);
        _writer.write(idBlockBuf);
        if (this.lenBlock.isIndefiniteForm) {
          _writer.write(new Uint8Array([128]).buffer);
          this.valueBlock.toBER(sizeOnly, _writer);
          _writer.write(new ArrayBuffer(2));
        } else {
          const valueBlockBuf = this.valueBlock.toBER(sizeOnly);
          this.lenBlock.length = valueBlockBuf.byteLength;
          const lenBlockBuf = this.lenBlock.toBER(sizeOnly);
          _writer.write(lenBlockBuf);
          _writer.write(valueBlockBuf);
        }
        if (!writer) {
          return _writer.final();
        }
        return EMPTY_BUFFER;
      }
      toJSON() {
        const object = {
          ...super.toJSON(),
          idBlock: this.idBlock.toJSON(),
          lenBlock: this.lenBlock.toJSON(),
          valueBlock: this.valueBlock.toJSON(),
          name: this.name,
          optional: this.optional
        };
        if (this.primitiveSchema)
          object.primitiveSchema = this.primitiveSchema.toJSON();
        return object;
      }
      toString(encoding = "ascii") {
        if (encoding === "ascii") {
          return this.onAsciiEncoding();
        }
        return pvtsutils__namespace.Convert.ToHex(this.toBER());
      }
      onAsciiEncoding() {
        return `${this.constructor.NAME} : ${pvtsutils__namespace.Convert.ToHex(this.valueBlock.valueBeforeDecodeView)}`;
      }
      isEqual(other) {
        if (this === other) {
          return true;
        }
        if (!(other instanceof this.constructor)) {
          return false;
        }
        const thisRaw = this.toBER();
        const otherRaw = other.toBER();
        return pvutils__namespace.isEqualBuffer(thisRaw, otherRaw);
      }
    };
    BaseBlock.NAME = "BaseBlock";
    function prepareIndefiniteForm(baseBlock) {
      if (baseBlock instanceof typeStore.Constructed) {
        for (const value of baseBlock.valueBlock.value) {
          if (prepareIndefiniteForm(value)) {
            baseBlock.lenBlock.isIndefiniteForm = true;
          }
        }
      }
      return !!baseBlock.lenBlock.isIndefiniteForm;
    }
    var BaseStringBlock = class extends BaseBlock {
      constructor({ value = EMPTY_STRING, ...parameters } = {}, stringValueBlockType) {
        super(parameters, stringValueBlockType);
        if (value) {
          this.fromString(value);
        }
      }
      getValue() {
        return this.valueBlock.value;
      }
      setValue(value) {
        this.valueBlock.value = value;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        const resultOffset = this.valueBlock.fromBER(inputBuffer, inputOffset, this.lenBlock.isIndefiniteForm ? inputLength : this.lenBlock.length);
        if (resultOffset === -1) {
          this.error = this.valueBlock.error;
          return resultOffset;
        }
        this.fromBuffer(this.valueBlock.valueHexView);
        if (!this.idBlock.error.length)
          this.blockLength += this.idBlock.blockLength;
        if (!this.lenBlock.error.length)
          this.blockLength += this.lenBlock.blockLength;
        if (!this.valueBlock.error.length)
          this.blockLength += this.valueBlock.blockLength;
        return resultOffset;
      }
      onAsciiEncoding() {
        return `${this.constructor.NAME} : '${this.valueBlock.value}'`;
      }
    };
    BaseStringBlock.NAME = "BaseStringBlock";
    var LocalPrimitiveValueBlock = class extends HexBlock(ValueBlock) {
      constructor({ isHexOnly = true, ...parameters } = {}) {
        super(parameters);
        this.isHexOnly = isHexOnly;
      }
    };
    LocalPrimitiveValueBlock.NAME = "PrimitiveValueBlock";
    var _a$w;
    var Primitive = class extends BaseBlock {
      constructor(parameters = {}) {
        super(parameters, LocalPrimitiveValueBlock);
        this.idBlock.isConstructed = false;
      }
    };
    _a$w = Primitive;
    (() => {
      typeStore.Primitive = _a$w;
    })();
    Primitive.NAME = "PRIMITIVE";
    function localChangeType(inputObject, newType) {
      if (inputObject instanceof newType) {
        return inputObject;
      }
      const newObject = new newType();
      newObject.idBlock = inputObject.idBlock;
      newObject.lenBlock = inputObject.lenBlock;
      newObject.warnings = inputObject.warnings;
      newObject.valueBeforeDecodeView = inputObject.valueBeforeDecodeView;
      return newObject;
    }
    function localFromBER(inputBuffer, inputOffset = 0, inputLength = inputBuffer.length) {
      const incomingOffset = inputOffset;
      let returnObject = new BaseBlock({}, ValueBlock);
      const baseBlock = new LocalBaseBlock();
      if (!checkBufferParams(baseBlock, inputBuffer, inputOffset, inputLength)) {
        returnObject.error = baseBlock.error;
        return {
          offset: -1,
          result: returnObject
        };
      }
      const intBuffer = inputBuffer.subarray(inputOffset, inputOffset + inputLength);
      if (!intBuffer.length) {
        returnObject.error = "Zero buffer length";
        return {
          offset: -1,
          result: returnObject
        };
      }
      let resultOffset = returnObject.idBlock.fromBER(inputBuffer, inputOffset, inputLength);
      if (returnObject.idBlock.warnings.length) {
        returnObject.warnings.concat(returnObject.idBlock.warnings);
      }
      if (resultOffset === -1) {
        returnObject.error = returnObject.idBlock.error;
        return {
          offset: -1,
          result: returnObject
        };
      }
      inputOffset = resultOffset;
      inputLength -= returnObject.idBlock.blockLength;
      resultOffset = returnObject.lenBlock.fromBER(inputBuffer, inputOffset, inputLength);
      if (returnObject.lenBlock.warnings.length) {
        returnObject.warnings.concat(returnObject.lenBlock.warnings);
      }
      if (resultOffset === -1) {
        returnObject.error = returnObject.lenBlock.error;
        return {
          offset: -1,
          result: returnObject
        };
      }
      inputOffset = resultOffset;
      inputLength -= returnObject.lenBlock.blockLength;
      if (!returnObject.idBlock.isConstructed && returnObject.lenBlock.isIndefiniteForm) {
        returnObject.error = "Indefinite length form used for primitive encoding form";
        return {
          offset: -1,
          result: returnObject
        };
      }
      let newASN1Type = BaseBlock;
      switch (returnObject.idBlock.tagClass) {
        case 1:
          if (returnObject.idBlock.tagNumber >= 37 && returnObject.idBlock.isHexOnly === false) {
            returnObject.error = "UNIVERSAL 37 and upper tags are reserved by ASN.1 standard";
            return {
              offset: -1,
              result: returnObject
            };
          }
          switch (returnObject.idBlock.tagNumber) {
            case 0:
              if (returnObject.idBlock.isConstructed && returnObject.lenBlock.length > 0) {
                returnObject.error = "Type [UNIVERSAL 0] is reserved";
                return {
                  offset: -1,
                  result: returnObject
                };
              }
              newASN1Type = typeStore.EndOfContent;
              break;
            case 1:
              newASN1Type = typeStore.Boolean;
              break;
            case 2:
              newASN1Type = typeStore.Integer;
              break;
            case 3:
              newASN1Type = typeStore.BitString;
              break;
            case 4:
              newASN1Type = typeStore.OctetString;
              break;
            case 5:
              newASN1Type = typeStore.Null;
              break;
            case 6:
              newASN1Type = typeStore.ObjectIdentifier;
              break;
            case 10:
              newASN1Type = typeStore.Enumerated;
              break;
            case 12:
              newASN1Type = typeStore.Utf8String;
              break;
            case 13:
              newASN1Type = typeStore.RelativeObjectIdentifier;
              break;
            case 14:
              newASN1Type = typeStore.TIME;
              break;
            case 15:
              returnObject.error = "[UNIVERSAL 15] is reserved by ASN.1 standard";
              return {
                offset: -1,
                result: returnObject
              };
            case 16:
              newASN1Type = typeStore.Sequence;
              break;
            case 17:
              newASN1Type = typeStore.Set;
              break;
            case 18:
              newASN1Type = typeStore.NumericString;
              break;
            case 19:
              newASN1Type = typeStore.PrintableString;
              break;
            case 20:
              newASN1Type = typeStore.TeletexString;
              break;
            case 21:
              newASN1Type = typeStore.VideotexString;
              break;
            case 22:
              newASN1Type = typeStore.IA5String;
              break;
            case 23:
              newASN1Type = typeStore.UTCTime;
              break;
            case 24:
              newASN1Type = typeStore.GeneralizedTime;
              break;
            case 25:
              newASN1Type = typeStore.GraphicString;
              break;
            case 26:
              newASN1Type = typeStore.VisibleString;
              break;
            case 27:
              newASN1Type = typeStore.GeneralString;
              break;
            case 28:
              newASN1Type = typeStore.UniversalString;
              break;
            case 29:
              newASN1Type = typeStore.CharacterString;
              break;
            case 30:
              newASN1Type = typeStore.BmpString;
              break;
            case 31:
              newASN1Type = typeStore.DATE;
              break;
            case 32:
              newASN1Type = typeStore.TimeOfDay;
              break;
            case 33:
              newASN1Type = typeStore.DateTime;
              break;
            case 34:
              newASN1Type = typeStore.Duration;
              break;
            default: {
              const newObject = returnObject.idBlock.isConstructed ? new typeStore.Constructed() : new typeStore.Primitive();
              newObject.idBlock = returnObject.idBlock;
              newObject.lenBlock = returnObject.lenBlock;
              newObject.warnings = returnObject.warnings;
              returnObject = newObject;
            }
          }
          break;
        case 2:
        case 3:
        case 4:
        default: {
          newASN1Type = returnObject.idBlock.isConstructed ? typeStore.Constructed : typeStore.Primitive;
        }
      }
      returnObject = localChangeType(returnObject, newASN1Type);
      resultOffset = returnObject.fromBER(inputBuffer, inputOffset, returnObject.lenBlock.isIndefiniteForm ? inputLength : returnObject.lenBlock.length);
      returnObject.valueBeforeDecodeView = inputBuffer.subarray(incomingOffset, incomingOffset + returnObject.blockLength);
      return {
        offset: resultOffset,
        result: returnObject
      };
    }
    function fromBER(inputBuffer) {
      if (!inputBuffer.byteLength) {
        const result2 = new BaseBlock({}, ValueBlock);
        result2.error = "Input buffer has zero length";
        return {
          offset: -1,
          result: result2
        };
      }
      return localFromBER(pvtsutils__namespace.BufferSourceConverter.toUint8Array(inputBuffer).slice(), 0, inputBuffer.byteLength);
    }
    function checkLen(indefiniteLength, length) {
      if (indefiniteLength) {
        return 1;
      }
      return length;
    }
    var LocalConstructedValueBlock = class extends ValueBlock {
      constructor({ value = [], isIndefiniteForm = false, ...parameters } = {}) {
        super(parameters);
        this.value = value;
        this.isIndefiniteForm = isIndefiniteForm;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        const view = pvtsutils__namespace.BufferSourceConverter.toUint8Array(inputBuffer);
        if (!checkBufferParams(this, view, inputOffset, inputLength)) {
          return -1;
        }
        this.valueBeforeDecodeView = view.subarray(inputOffset, inputOffset + inputLength);
        if (this.valueBeforeDecodeView.length === 0) {
          this.warnings.push("Zero buffer length");
          return inputOffset;
        }
        let currentOffset = inputOffset;
        while (checkLen(this.isIndefiniteForm, inputLength) > 0) {
          const returnObject = localFromBER(view, currentOffset, inputLength);
          if (returnObject.offset === -1) {
            this.error = returnObject.result.error;
            this.warnings.concat(returnObject.result.warnings);
            return -1;
          }
          currentOffset = returnObject.offset;
          this.blockLength += returnObject.result.blockLength;
          inputLength -= returnObject.result.blockLength;
          this.value.push(returnObject.result);
          if (this.isIndefiniteForm && returnObject.result.constructor.NAME === END_OF_CONTENT_NAME) {
            break;
          }
        }
        if (this.isIndefiniteForm) {
          if (this.value[this.value.length - 1].constructor.NAME === END_OF_CONTENT_NAME) {
            this.value.pop();
          } else {
            this.warnings.push("No EndOfContent block encoded");
          }
        }
        return currentOffset;
      }
      toBER(sizeOnly, writer) {
        const _writer = writer || new ViewWriter();
        for (let i = 0; i < this.value.length; i++) {
          this.value[i].toBER(sizeOnly, _writer);
        }
        if (!writer) {
          return _writer.final();
        }
        return EMPTY_BUFFER;
      }
      toJSON() {
        const object = {
          ...super.toJSON(),
          isIndefiniteForm: this.isIndefiniteForm,
          value: []
        };
        for (const value of this.value) {
          object.value.push(value.toJSON());
        }
        return object;
      }
    };
    LocalConstructedValueBlock.NAME = "ConstructedValueBlock";
    var _a$v;
    var Constructed = class extends BaseBlock {
      constructor(parameters = {}) {
        super(parameters, LocalConstructedValueBlock);
        this.idBlock.isConstructed = true;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        this.valueBlock.isIndefiniteForm = this.lenBlock.isIndefiniteForm;
        const resultOffset = this.valueBlock.fromBER(inputBuffer, inputOffset, this.lenBlock.isIndefiniteForm ? inputLength : this.lenBlock.length);
        if (resultOffset === -1) {
          this.error = this.valueBlock.error;
          return resultOffset;
        }
        if (!this.idBlock.error.length)
          this.blockLength += this.idBlock.blockLength;
        if (!this.lenBlock.error.length)
          this.blockLength += this.lenBlock.blockLength;
        if (!this.valueBlock.error.length)
          this.blockLength += this.valueBlock.blockLength;
        return resultOffset;
      }
      onAsciiEncoding() {
        const values = [];
        for (const value of this.valueBlock.value) {
          values.push(value.toString("ascii").split("\n").map((o2) => `  ${o2}`).join("\n"));
        }
        const blockName = this.idBlock.tagClass === 3 ? `[${this.idBlock.tagNumber}]` : this.constructor.NAME;
        return values.length ? `${blockName} :
${values.join("\n")}` : `${blockName} :`;
      }
    };
    _a$v = Constructed;
    (() => {
      typeStore.Constructed = _a$v;
    })();
    Constructed.NAME = "CONSTRUCTED";
    var LocalEndOfContentValueBlock = class extends ValueBlock {
      fromBER(inputBuffer, inputOffset, inputLength) {
        return inputOffset;
      }
      toBER(sizeOnly) {
        return EMPTY_BUFFER;
      }
    };
    LocalEndOfContentValueBlock.override = "EndOfContentValueBlock";
    var _a$u;
    var EndOfContent = class extends BaseBlock {
      constructor(parameters = {}) {
        super(parameters, LocalEndOfContentValueBlock);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 0;
      }
    };
    _a$u = EndOfContent;
    (() => {
      typeStore.EndOfContent = _a$u;
    })();
    EndOfContent.NAME = END_OF_CONTENT_NAME;
    var _a$t;
    var Null = class extends BaseBlock {
      constructor(parameters = {}) {
        super(parameters, ValueBlock);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 5;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        if (this.lenBlock.length > 0)
          this.warnings.push("Non-zero length of value block for Null type");
        if (!this.idBlock.error.length)
          this.blockLength += this.idBlock.blockLength;
        if (!this.lenBlock.error.length)
          this.blockLength += this.lenBlock.blockLength;
        this.blockLength += inputLength;
        if (inputOffset + inputLength > inputBuffer.byteLength) {
          this.error = "End of input reached before message was fully decoded (inconsistent offset and length values)";
          return -1;
        }
        return inputOffset + inputLength;
      }
      toBER(sizeOnly, writer) {
        const retBuf = new ArrayBuffer(2);
        if (!sizeOnly) {
          const retView = new Uint8Array(retBuf);
          retView[0] = 5;
          retView[1] = 0;
        }
        if (writer) {
          writer.write(retBuf);
        }
        return retBuf;
      }
      onAsciiEncoding() {
        return `${this.constructor.NAME}`;
      }
    };
    _a$t = Null;
    (() => {
      typeStore.Null = _a$t;
    })();
    Null.NAME = "NULL";
    var LocalBooleanValueBlock = class extends HexBlock(ValueBlock) {
      constructor({ value, ...parameters } = {}) {
        super(parameters);
        if (parameters.valueHex) {
          this.valueHexView = pvtsutils__namespace.BufferSourceConverter.toUint8Array(parameters.valueHex);
        } else {
          this.valueHexView = new Uint8Array(1);
        }
        if (value) {
          this.value = value;
        }
      }
      get value() {
        for (const octet of this.valueHexView) {
          if (octet > 0) {
            return true;
          }
        }
        return false;
      }
      set value(value) {
        this.valueHexView[0] = value ? 255 : 0;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        const inputView = pvtsutils__namespace.BufferSourceConverter.toUint8Array(inputBuffer);
        if (!checkBufferParams(this, inputView, inputOffset, inputLength)) {
          return -1;
        }
        this.valueHexView = inputView.subarray(inputOffset, inputOffset + inputLength);
        if (inputLength > 1)
          this.warnings.push("Boolean value encoded in more then 1 octet");
        this.isHexOnly = true;
        pvutils__namespace.utilDecodeTC.call(this);
        this.blockLength = inputLength;
        return inputOffset + inputLength;
      }
      toBER() {
        return this.valueHexView.slice();
      }
      toJSON() {
        return {
          ...super.toJSON(),
          value: this.value
        };
      }
    };
    LocalBooleanValueBlock.NAME = "BooleanValueBlock";
    var _a$s;
    var Boolean2 = class extends BaseBlock {
      constructor(parameters = {}) {
        super(parameters, LocalBooleanValueBlock);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 1;
      }
      getValue() {
        return this.valueBlock.value;
      }
      setValue(value) {
        this.valueBlock.value = value;
      }
      onAsciiEncoding() {
        return `${this.constructor.NAME} : ${this.getValue}`;
      }
    };
    _a$s = Boolean2;
    (() => {
      typeStore.Boolean = _a$s;
    })();
    Boolean2.NAME = "BOOLEAN";
    var LocalOctetStringValueBlock = class extends HexBlock(LocalConstructedValueBlock) {
      constructor({ isConstructed = false, ...parameters } = {}) {
        super(parameters);
        this.isConstructed = isConstructed;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        let resultOffset = 0;
        if (this.isConstructed) {
          this.isHexOnly = false;
          resultOffset = LocalConstructedValueBlock.prototype.fromBER.call(this, inputBuffer, inputOffset, inputLength);
          if (resultOffset === -1)
            return resultOffset;
          for (let i = 0; i < this.value.length; i++) {
            const currentBlockName = this.value[i].constructor.NAME;
            if (currentBlockName === END_OF_CONTENT_NAME) {
              if (this.isIndefiniteForm)
                break;
              else {
                this.error = "EndOfContent is unexpected, OCTET STRING may consists of OCTET STRINGs only";
                return -1;
              }
            }
            if (currentBlockName !== OCTET_STRING_NAME) {
              this.error = "OCTET STRING may consists of OCTET STRINGs only";
              return -1;
            }
          }
        } else {
          this.isHexOnly = true;
          resultOffset = super.fromBER(inputBuffer, inputOffset, inputLength);
          this.blockLength = inputLength;
        }
        return resultOffset;
      }
      toBER(sizeOnly, writer) {
        if (this.isConstructed)
          return LocalConstructedValueBlock.prototype.toBER.call(this, sizeOnly, writer);
        return sizeOnly ? new ArrayBuffer(this.valueHexView.byteLength) : this.valueHexView.slice().buffer;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          isConstructed: this.isConstructed
        };
      }
    };
    LocalOctetStringValueBlock.NAME = "OctetStringValueBlock";
    var _a$r;
    var OctetString = class _OctetString extends BaseBlock {
      constructor({ idBlock = {}, lenBlock = {}, ...parameters } = {}) {
        var _b, _c;
        (_b = parameters.isConstructed) !== null && _b !== void 0 ? _b : parameters.isConstructed = !!((_c = parameters.value) === null || _c === void 0 ? void 0 : _c.length);
        super({
          idBlock: {
            isConstructed: parameters.isConstructed,
            ...idBlock
          },
          lenBlock: {
            ...lenBlock,
            isIndefiniteForm: !!parameters.isIndefiniteForm
          },
          ...parameters
        }, LocalOctetStringValueBlock);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 4;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        this.valueBlock.isConstructed = this.idBlock.isConstructed;
        this.valueBlock.isIndefiniteForm = this.lenBlock.isIndefiniteForm;
        if (inputLength === 0) {
          if (this.idBlock.error.length === 0)
            this.blockLength += this.idBlock.blockLength;
          if (this.lenBlock.error.length === 0)
            this.blockLength += this.lenBlock.blockLength;
          return inputOffset;
        }
        if (!this.valueBlock.isConstructed) {
          const view = inputBuffer instanceof ArrayBuffer ? new Uint8Array(inputBuffer) : inputBuffer;
          const buf = view.subarray(inputOffset, inputOffset + inputLength);
          try {
            if (buf.byteLength) {
              const asn = localFromBER(buf, 0, buf.byteLength);
              if (asn.offset !== -1 && asn.offset === inputLength) {
                this.valueBlock.value = [asn.result];
              }
            }
          } catch (e) {
          }
        }
        return super.fromBER(inputBuffer, inputOffset, inputLength);
      }
      onAsciiEncoding() {
        if (this.valueBlock.isConstructed || this.valueBlock.value && this.valueBlock.value.length) {
          return Constructed.prototype.onAsciiEncoding.call(this);
        }
        return `${this.constructor.NAME} : ${pvtsutils__namespace.Convert.ToHex(this.valueBlock.valueHexView)}`;
      }
      getValue() {
        if (!this.idBlock.isConstructed) {
          return this.valueBlock.valueHexView.slice().buffer;
        }
        const array = [];
        for (const content of this.valueBlock.value) {
          if (content instanceof _OctetString) {
            array.push(content.valueBlock.valueHexView);
          }
        }
        return pvtsutils__namespace.BufferSourceConverter.concat(array);
      }
    };
    _a$r = OctetString;
    (() => {
      typeStore.OctetString = _a$r;
    })();
    OctetString.NAME = OCTET_STRING_NAME;
    var LocalBitStringValueBlock = class extends HexBlock(LocalConstructedValueBlock) {
      constructor({ unusedBits = 0, isConstructed = false, ...parameters } = {}) {
        super(parameters);
        this.unusedBits = unusedBits;
        this.isConstructed = isConstructed;
        this.blockLength = this.valueHexView.byteLength;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        if (!inputLength) {
          return inputOffset;
        }
        let resultOffset = -1;
        if (this.isConstructed) {
          resultOffset = LocalConstructedValueBlock.prototype.fromBER.call(this, inputBuffer, inputOffset, inputLength);
          if (resultOffset === -1)
            return resultOffset;
          for (const value of this.value) {
            const currentBlockName = value.constructor.NAME;
            if (currentBlockName === END_OF_CONTENT_NAME) {
              if (this.isIndefiniteForm)
                break;
              else {
                this.error = "EndOfContent is unexpected, BIT STRING may consists of BIT STRINGs only";
                return -1;
              }
            }
            if (currentBlockName !== BIT_STRING_NAME) {
              this.error = "BIT STRING may consists of BIT STRINGs only";
              return -1;
            }
            const valueBlock = value.valueBlock;
            if (this.unusedBits > 0 && valueBlock.unusedBits > 0) {
              this.error = 'Using of "unused bits" inside constructive BIT STRING allowed for least one only';
              return -1;
            }
            this.unusedBits = valueBlock.unusedBits;
          }
          return resultOffset;
        }
        const inputView = pvtsutils__namespace.BufferSourceConverter.toUint8Array(inputBuffer);
        if (!checkBufferParams(this, inputView, inputOffset, inputLength)) {
          return -1;
        }
        const intBuffer = inputView.subarray(inputOffset, inputOffset + inputLength);
        this.unusedBits = intBuffer[0];
        if (this.unusedBits > 7) {
          this.error = "Unused bits for BitString must be in range 0-7";
          return -1;
        }
        if (!this.unusedBits) {
          const buf = intBuffer.subarray(1);
          try {
            if (buf.byteLength) {
              const asn = localFromBER(buf, 0, buf.byteLength);
              if (asn.offset !== -1 && asn.offset === inputLength - 1) {
                this.value = [asn.result];
              }
            }
          } catch (e) {
          }
        }
        this.valueHexView = intBuffer.subarray(1);
        this.blockLength = intBuffer.length;
        return inputOffset + inputLength;
      }
      toBER(sizeOnly, writer) {
        if (this.isConstructed) {
          return LocalConstructedValueBlock.prototype.toBER.call(this, sizeOnly, writer);
        }
        if (sizeOnly) {
          return new ArrayBuffer(this.valueHexView.byteLength + 1);
        }
        if (!this.valueHexView.byteLength) {
          return EMPTY_BUFFER;
        }
        const retView = new Uint8Array(this.valueHexView.length + 1);
        retView[0] = this.unusedBits;
        retView.set(this.valueHexView, 1);
        return retView.buffer;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          unusedBits: this.unusedBits,
          isConstructed: this.isConstructed
        };
      }
    };
    LocalBitStringValueBlock.NAME = "BitStringValueBlock";
    var _a$q;
    var BitString = class extends BaseBlock {
      constructor({ idBlock = {}, lenBlock = {}, ...parameters } = {}) {
        var _b, _c;
        (_b = parameters.isConstructed) !== null && _b !== void 0 ? _b : parameters.isConstructed = !!((_c = parameters.value) === null || _c === void 0 ? void 0 : _c.length);
        super({
          idBlock: {
            isConstructed: parameters.isConstructed,
            ...idBlock
          },
          lenBlock: {
            ...lenBlock,
            isIndefiniteForm: !!parameters.isIndefiniteForm
          },
          ...parameters
        }, LocalBitStringValueBlock);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 3;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        this.valueBlock.isConstructed = this.idBlock.isConstructed;
        this.valueBlock.isIndefiniteForm = this.lenBlock.isIndefiniteForm;
        return super.fromBER(inputBuffer, inputOffset, inputLength);
      }
      onAsciiEncoding() {
        if (this.valueBlock.isConstructed || this.valueBlock.value && this.valueBlock.value.length) {
          return Constructed.prototype.onAsciiEncoding.call(this);
        } else {
          const bits = [];
          const valueHex = this.valueBlock.valueHexView;
          for (const byte of valueHex) {
            bits.push(byte.toString(2).padStart(8, "0"));
          }
          const bitsStr = bits.join("");
          return `${this.constructor.NAME} : ${bitsStr.substring(0, bitsStr.length - this.valueBlock.unusedBits)}`;
        }
      }
    };
    _a$q = BitString;
    (() => {
      typeStore.BitString = _a$q;
    })();
    BitString.NAME = BIT_STRING_NAME;
    var _a$p;
    function viewAdd(first, second) {
      const c2 = new Uint8Array([0]);
      const firstView = new Uint8Array(first);
      const secondView = new Uint8Array(second);
      let firstViewCopy = firstView.slice(0);
      const firstViewCopyLength = firstViewCopy.length - 1;
      const secondViewCopy = secondView.slice(0);
      const secondViewCopyLength = secondViewCopy.length - 1;
      let value = 0;
      const max = secondViewCopyLength < firstViewCopyLength ? firstViewCopyLength : secondViewCopyLength;
      let counter = 0;
      for (let i = max; i >= 0; i--, counter++) {
        switch (true) {
          case counter < secondViewCopy.length:
            value = firstViewCopy[firstViewCopyLength - counter] + secondViewCopy[secondViewCopyLength - counter] + c2[0];
            break;
          default:
            value = firstViewCopy[firstViewCopyLength - counter] + c2[0];
        }
        c2[0] = value / 10;
        switch (true) {
          case counter >= firstViewCopy.length:
            firstViewCopy = pvutils__namespace.utilConcatView(new Uint8Array([value % 10]), firstViewCopy);
            break;
          default:
            firstViewCopy[firstViewCopyLength - counter] = value % 10;
        }
      }
      if (c2[0] > 0)
        firstViewCopy = pvutils__namespace.utilConcatView(c2, firstViewCopy);
      return firstViewCopy;
    }
    function power2(n) {
      if (n >= powers2.length) {
        for (let p3 = powers2.length; p3 <= n; p3++) {
          const c2 = new Uint8Array([0]);
          let digits = powers2[p3 - 1].slice(0);
          for (let i = digits.length - 1; i >= 0; i--) {
            const newValue = new Uint8Array([(digits[i] << 1) + c2[0]]);
            c2[0] = newValue[0] / 10;
            digits[i] = newValue[0] % 10;
          }
          if (c2[0] > 0)
            digits = pvutils__namespace.utilConcatView(c2, digits);
          powers2.push(digits);
        }
      }
      return powers2[n];
    }
    function viewSub(first, second) {
      let b = 0;
      const firstView = new Uint8Array(first);
      const secondView = new Uint8Array(second);
      const firstViewCopy = firstView.slice(0);
      const firstViewCopyLength = firstViewCopy.length - 1;
      const secondViewCopy = secondView.slice(0);
      const secondViewCopyLength = secondViewCopy.length - 1;
      let value;
      let counter = 0;
      for (let i = secondViewCopyLength; i >= 0; i--, counter++) {
        value = firstViewCopy[firstViewCopyLength - counter] - secondViewCopy[secondViewCopyLength - counter] - b;
        switch (true) {
          case value < 0:
            b = 1;
            firstViewCopy[firstViewCopyLength - counter] = value + 10;
            break;
          default:
            b = 0;
            firstViewCopy[firstViewCopyLength - counter] = value;
        }
      }
      if (b > 0) {
        for (let i = firstViewCopyLength - secondViewCopyLength + 1; i >= 0; i--, counter++) {
          value = firstViewCopy[firstViewCopyLength - counter] - b;
          if (value < 0) {
            b = 1;
            firstViewCopy[firstViewCopyLength - counter] = value + 10;
          } else {
            b = 0;
            firstViewCopy[firstViewCopyLength - counter] = value;
            break;
          }
        }
      }
      return firstViewCopy.slice();
    }
    var LocalIntegerValueBlock = class extends HexBlock(ValueBlock) {
      constructor({ value, ...parameters } = {}) {
        super(parameters);
        this._valueDec = 0;
        if (parameters.valueHex) {
          this.setValueHex();
        }
        if (value !== void 0) {
          this.valueDec = value;
        }
      }
      setValueHex() {
        if (this.valueHexView.length >= 4) {
          this.warnings.push("Too big Integer for decoding, hex only");
          this.isHexOnly = true;
          this._valueDec = 0;
        } else {
          this.isHexOnly = false;
          if (this.valueHexView.length > 0) {
            this._valueDec = pvutils__namespace.utilDecodeTC.call(this);
          }
        }
      }
      set valueDec(v) {
        this._valueDec = v;
        this.isHexOnly = false;
        this.valueHexView = new Uint8Array(pvutils__namespace.utilEncodeTC(v));
      }
      get valueDec() {
        return this._valueDec;
      }
      fromDER(inputBuffer, inputOffset, inputLength, expectedLength = 0) {
        const offset = this.fromBER(inputBuffer, inputOffset, inputLength);
        if (offset === -1)
          return offset;
        const view = this.valueHexView;
        if (view[0] === 0 && (view[1] & 128) !== 0) {
          this.valueHexView = view.subarray(1);
        } else {
          if (expectedLength !== 0) {
            if (view.length < expectedLength) {
              if (expectedLength - view.length > 1)
                expectedLength = view.length + 1;
              this.valueHexView = view.subarray(expectedLength - view.length);
            }
          }
        }
        return offset;
      }
      toDER(sizeOnly = false) {
        const view = this.valueHexView;
        switch (true) {
          case (view[0] & 128) !== 0:
            {
              const updatedView = new Uint8Array(this.valueHexView.length + 1);
              updatedView[0] = 0;
              updatedView.set(view, 1);
              this.valueHexView = updatedView;
            }
            break;
          case (view[0] === 0 && (view[1] & 128) === 0):
            {
              this.valueHexView = this.valueHexView.subarray(1);
            }
            break;
        }
        return this.toBER(sizeOnly);
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        const resultOffset = super.fromBER(inputBuffer, inputOffset, inputLength);
        if (resultOffset === -1) {
          return resultOffset;
        }
        this.setValueHex();
        return resultOffset;
      }
      toBER(sizeOnly) {
        return sizeOnly ? new ArrayBuffer(this.valueHexView.length) : this.valueHexView.slice().buffer;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          valueDec: this.valueDec
        };
      }
      toString() {
        const firstBit = this.valueHexView.length * 8 - 1;
        let digits = new Uint8Array(this.valueHexView.length * 8 / 3);
        let bitNumber = 0;
        let currentByte;
        const asn1View = this.valueHexView;
        let result2 = "";
        let flag = false;
        for (let byteNumber = asn1View.byteLength - 1; byteNumber >= 0; byteNumber--) {
          currentByte = asn1View[byteNumber];
          for (let i = 0; i < 8; i++) {
            if ((currentByte & 1) === 1) {
              switch (bitNumber) {
                case firstBit:
                  digits = viewSub(power2(bitNumber), digits);
                  result2 = "-";
                  break;
                default:
                  digits = viewAdd(digits, power2(bitNumber));
              }
            }
            bitNumber++;
            currentByte >>= 1;
          }
        }
        for (let i = 0; i < digits.length; i++) {
          if (digits[i])
            flag = true;
          if (flag)
            result2 += digitsString.charAt(digits[i]);
        }
        if (flag === false)
          result2 += digitsString.charAt(0);
        return result2;
      }
    };
    _a$p = LocalIntegerValueBlock;
    LocalIntegerValueBlock.NAME = "IntegerValueBlock";
    (() => {
      Object.defineProperty(_a$p.prototype, "valueHex", {
        set: function(v) {
          this.valueHexView = new Uint8Array(v);
          this.setValueHex();
        },
        get: function() {
          return this.valueHexView.slice().buffer;
        }
      });
    })();
    var _a$o;
    var Integer = class _Integer extends BaseBlock {
      constructor(parameters = {}) {
        super(parameters, LocalIntegerValueBlock);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 2;
      }
      toBigInt() {
        assertBigInt();
        return BigInt(this.valueBlock.toString());
      }
      static fromBigInt(value) {
        assertBigInt();
        const bigIntValue = BigInt(value);
        const writer = new ViewWriter();
        const hex = bigIntValue.toString(16).replace(/^-/, "");
        const view = new Uint8Array(pvtsutils__namespace.Convert.FromHex(hex));
        if (bigIntValue < 0) {
          const first = new Uint8Array(view.length + (view[0] & 128 ? 1 : 0));
          first[0] |= 128;
          const firstInt = BigInt(`0x${pvtsutils__namespace.Convert.ToHex(first)}`);
          const secondInt = firstInt + bigIntValue;
          const second = pvtsutils__namespace.BufferSourceConverter.toUint8Array(pvtsutils__namespace.Convert.FromHex(secondInt.toString(16)));
          second[0] |= 128;
          writer.write(second);
        } else {
          if (view[0] & 128) {
            writer.write(new Uint8Array([0]));
          }
          writer.write(view);
        }
        const res = new _Integer({
          valueHex: writer.final()
        });
        return res;
      }
      convertToDER() {
        const integer = new _Integer({ valueHex: this.valueBlock.valueHexView });
        integer.valueBlock.toDER();
        return integer;
      }
      convertFromDER() {
        return new _Integer({
          valueHex: this.valueBlock.valueHexView[0] === 0 ? this.valueBlock.valueHexView.subarray(1) : this.valueBlock.valueHexView
        });
      }
      onAsciiEncoding() {
        return `${this.constructor.NAME} : ${this.valueBlock.toString()}`;
      }
    };
    _a$o = Integer;
    (() => {
      typeStore.Integer = _a$o;
    })();
    Integer.NAME = "INTEGER";
    var _a$n;
    var Enumerated = class extends Integer {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 10;
      }
    };
    _a$n = Enumerated;
    (() => {
      typeStore.Enumerated = _a$n;
    })();
    Enumerated.NAME = "ENUMERATED";
    var LocalSidValueBlock = class extends HexBlock(ValueBlock) {
      constructor({ valueDec = -1, isFirstSid = false, ...parameters } = {}) {
        super(parameters);
        this.valueDec = valueDec;
        this.isFirstSid = isFirstSid;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        if (!inputLength) {
          return inputOffset;
        }
        const inputView = pvtsutils__namespace.BufferSourceConverter.toUint8Array(inputBuffer);
        if (!checkBufferParams(this, inputView, inputOffset, inputLength)) {
          return -1;
        }
        const intBuffer = inputView.subarray(inputOffset, inputOffset + inputLength);
        this.valueHexView = new Uint8Array(inputLength);
        for (let i = 0; i < inputLength; i++) {
          this.valueHexView[i] = intBuffer[i] & 127;
          this.blockLength++;
          if ((intBuffer[i] & 128) === 0)
            break;
        }
        const tempView = new Uint8Array(this.blockLength);
        for (let i = 0; i < this.blockLength; i++) {
          tempView[i] = this.valueHexView[i];
        }
        this.valueHexView = tempView;
        if ((intBuffer[this.blockLength - 1] & 128) !== 0) {
          this.error = "End of input reached before message was fully decoded";
          return -1;
        }
        if (this.valueHexView[0] === 0)
          this.warnings.push("Needlessly long format of SID encoding");
        if (this.blockLength <= 8)
          this.valueDec = pvutils__namespace.utilFromBase(this.valueHexView, 7);
        else {
          this.isHexOnly = true;
          this.warnings.push("Too big SID for decoding, hex only");
        }
        return inputOffset + this.blockLength;
      }
      set valueBigInt(value) {
        assertBigInt();
        let bits = BigInt(value).toString(2);
        while (bits.length % 7) {
          bits = "0" + bits;
        }
        const bytes = new Uint8Array(bits.length / 7);
        for (let i = 0; i < bytes.length; i++) {
          bytes[i] = parseInt(bits.slice(i * 7, i * 7 + 7), 2) + (i + 1 < bytes.length ? 128 : 0);
        }
        this.fromBER(bytes.buffer, 0, bytes.length);
      }
      toBER(sizeOnly) {
        if (this.isHexOnly) {
          if (sizeOnly)
            return new ArrayBuffer(this.valueHexView.byteLength);
          const curView = this.valueHexView;
          const retView2 = new Uint8Array(this.blockLength);
          for (let i = 0; i < this.blockLength - 1; i++)
            retView2[i] = curView[i] | 128;
          retView2[this.blockLength - 1] = curView[this.blockLength - 1];
          return retView2.buffer;
        }
        const encodedBuf = pvutils__namespace.utilToBase(this.valueDec, 7);
        if (encodedBuf.byteLength === 0) {
          this.error = "Error during encoding SID value";
          return EMPTY_BUFFER;
        }
        const retView = new Uint8Array(encodedBuf.byteLength);
        if (!sizeOnly) {
          const encodedView = new Uint8Array(encodedBuf);
          const len = encodedBuf.byteLength - 1;
          for (let i = 0; i < len; i++)
            retView[i] = encodedView[i] | 128;
          retView[len] = encodedView[len];
        }
        return retView;
      }
      toString() {
        let result2 = "";
        if (this.isHexOnly)
          result2 = pvtsutils__namespace.Convert.ToHex(this.valueHexView);
        else {
          if (this.isFirstSid) {
            let sidValue = this.valueDec;
            if (this.valueDec <= 39)
              result2 = "0.";
            else {
              if (this.valueDec <= 79) {
                result2 = "1.";
                sidValue -= 40;
              } else {
                result2 = "2.";
                sidValue -= 80;
              }
            }
            result2 += sidValue.toString();
          } else
            result2 = this.valueDec.toString();
        }
        return result2;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          valueDec: this.valueDec,
          isFirstSid: this.isFirstSid
        };
      }
    };
    LocalSidValueBlock.NAME = "sidBlock";
    var LocalObjectIdentifierValueBlock = class extends ValueBlock {
      constructor({ value = EMPTY_STRING, ...parameters } = {}) {
        super(parameters);
        this.value = [];
        if (value) {
          this.fromString(value);
        }
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        let resultOffset = inputOffset;
        while (inputLength > 0) {
          const sidBlock = new LocalSidValueBlock();
          resultOffset = sidBlock.fromBER(inputBuffer, resultOffset, inputLength);
          if (resultOffset === -1) {
            this.blockLength = 0;
            this.error = sidBlock.error;
            return resultOffset;
          }
          if (this.value.length === 0)
            sidBlock.isFirstSid = true;
          this.blockLength += sidBlock.blockLength;
          inputLength -= sidBlock.blockLength;
          this.value.push(sidBlock);
        }
        return resultOffset;
      }
      toBER(sizeOnly) {
        const retBuffers = [];
        for (let i = 0; i < this.value.length; i++) {
          const valueBuf = this.value[i].toBER(sizeOnly);
          if (valueBuf.byteLength === 0) {
            this.error = this.value[i].error;
            return EMPTY_BUFFER;
          }
          retBuffers.push(valueBuf);
        }
        return concat(retBuffers);
      }
      fromString(string) {
        this.value = [];
        let pos1 = 0;
        let pos2 = 0;
        let sid = "";
        let flag = false;
        do {
          pos2 = string.indexOf(".", pos1);
          if (pos2 === -1)
            sid = string.substring(pos1);
          else
            sid = string.substring(pos1, pos2);
          pos1 = pos2 + 1;
          if (flag) {
            const sidBlock = this.value[0];
            let plus = 0;
            switch (sidBlock.valueDec) {
              case 0:
                break;
              case 1:
                plus = 40;
                break;
              case 2:
                plus = 80;
                break;
              default:
                this.value = [];
                return;
            }
            const parsedSID = parseInt(sid, 10);
            if (isNaN(parsedSID))
              return;
            sidBlock.valueDec = parsedSID + plus;
            flag = false;
          } else {
            const sidBlock = new LocalSidValueBlock();
            if (sid > Number.MAX_SAFE_INTEGER) {
              assertBigInt();
              const sidValue = BigInt(sid);
              sidBlock.valueBigInt = sidValue;
            } else {
              sidBlock.valueDec = parseInt(sid, 10);
              if (isNaN(sidBlock.valueDec))
                return;
            }
            if (!this.value.length) {
              sidBlock.isFirstSid = true;
              flag = true;
            }
            this.value.push(sidBlock);
          }
        } while (pos2 !== -1);
      }
      toString() {
        let result2 = "";
        let isHexOnly = false;
        for (let i = 0; i < this.value.length; i++) {
          isHexOnly = this.value[i].isHexOnly;
          let sidStr = this.value[i].toString();
          if (i !== 0)
            result2 = `${result2}.`;
          if (isHexOnly) {
            sidStr = `{${sidStr}}`;
            if (this.value[i].isFirstSid)
              result2 = `2.{${sidStr} - 80}`;
            else
              result2 += sidStr;
          } else
            result2 += sidStr;
        }
        return result2;
      }
      toJSON() {
        const object = {
          ...super.toJSON(),
          value: this.toString(),
          sidArray: []
        };
        for (let i = 0; i < this.value.length; i++) {
          object.sidArray.push(this.value[i].toJSON());
        }
        return object;
      }
    };
    LocalObjectIdentifierValueBlock.NAME = "ObjectIdentifierValueBlock";
    var _a$m;
    var ObjectIdentifier = class extends BaseBlock {
      constructor(parameters = {}) {
        super(parameters, LocalObjectIdentifierValueBlock);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 6;
      }
      getValue() {
        return this.valueBlock.toString();
      }
      setValue(value) {
        this.valueBlock.fromString(value);
      }
      onAsciiEncoding() {
        return `${this.constructor.NAME} : ${this.valueBlock.toString() || "empty"}`;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          value: this.getValue()
        };
      }
    };
    _a$m = ObjectIdentifier;
    (() => {
      typeStore.ObjectIdentifier = _a$m;
    })();
    ObjectIdentifier.NAME = "OBJECT IDENTIFIER";
    var LocalRelativeSidValueBlock = class extends HexBlock(LocalBaseBlock) {
      constructor({ valueDec = 0, ...parameters } = {}) {
        super(parameters);
        this.valueDec = valueDec;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        if (inputLength === 0)
          return inputOffset;
        const inputView = pvtsutils__namespace.BufferSourceConverter.toUint8Array(inputBuffer);
        if (!checkBufferParams(this, inputView, inputOffset, inputLength))
          return -1;
        const intBuffer = inputView.subarray(inputOffset, inputOffset + inputLength);
        this.valueHexView = new Uint8Array(inputLength);
        for (let i = 0; i < inputLength; i++) {
          this.valueHexView[i] = intBuffer[i] & 127;
          this.blockLength++;
          if ((intBuffer[i] & 128) === 0)
            break;
        }
        const tempView = new Uint8Array(this.blockLength);
        for (let i = 0; i < this.blockLength; i++)
          tempView[i] = this.valueHexView[i];
        this.valueHexView = tempView;
        if ((intBuffer[this.blockLength - 1] & 128) !== 0) {
          this.error = "End of input reached before message was fully decoded";
          return -1;
        }
        if (this.valueHexView[0] === 0)
          this.warnings.push("Needlessly long format of SID encoding");
        if (this.blockLength <= 8)
          this.valueDec = pvutils__namespace.utilFromBase(this.valueHexView, 7);
        else {
          this.isHexOnly = true;
          this.warnings.push("Too big SID for decoding, hex only");
        }
        return inputOffset + this.blockLength;
      }
      toBER(sizeOnly) {
        if (this.isHexOnly) {
          if (sizeOnly)
            return new ArrayBuffer(this.valueHexView.byteLength);
          const curView = this.valueHexView;
          const retView2 = new Uint8Array(this.blockLength);
          for (let i = 0; i < this.blockLength - 1; i++)
            retView2[i] = curView[i] | 128;
          retView2[this.blockLength - 1] = curView[this.blockLength - 1];
          return retView2.buffer;
        }
        const encodedBuf = pvutils__namespace.utilToBase(this.valueDec, 7);
        if (encodedBuf.byteLength === 0) {
          this.error = "Error during encoding SID value";
          return EMPTY_BUFFER;
        }
        const retView = new Uint8Array(encodedBuf.byteLength);
        if (!sizeOnly) {
          const encodedView = new Uint8Array(encodedBuf);
          const len = encodedBuf.byteLength - 1;
          for (let i = 0; i < len; i++)
            retView[i] = encodedView[i] | 128;
          retView[len] = encodedView[len];
        }
        return retView.buffer;
      }
      toString() {
        let result2 = "";
        if (this.isHexOnly)
          result2 = pvtsutils__namespace.Convert.ToHex(this.valueHexView);
        else {
          result2 = this.valueDec.toString();
        }
        return result2;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          valueDec: this.valueDec
        };
      }
    };
    LocalRelativeSidValueBlock.NAME = "relativeSidBlock";
    var LocalRelativeObjectIdentifierValueBlock = class extends ValueBlock {
      constructor({ value = EMPTY_STRING, ...parameters } = {}) {
        super(parameters);
        this.value = [];
        if (value) {
          this.fromString(value);
        }
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        let resultOffset = inputOffset;
        while (inputLength > 0) {
          const sidBlock = new LocalRelativeSidValueBlock();
          resultOffset = sidBlock.fromBER(inputBuffer, resultOffset, inputLength);
          if (resultOffset === -1) {
            this.blockLength = 0;
            this.error = sidBlock.error;
            return resultOffset;
          }
          this.blockLength += sidBlock.blockLength;
          inputLength -= sidBlock.blockLength;
          this.value.push(sidBlock);
        }
        return resultOffset;
      }
      toBER(sizeOnly, writer) {
        const retBuffers = [];
        for (let i = 0; i < this.value.length; i++) {
          const valueBuf = this.value[i].toBER(sizeOnly);
          if (valueBuf.byteLength === 0) {
            this.error = this.value[i].error;
            return EMPTY_BUFFER;
          }
          retBuffers.push(valueBuf);
        }
        return concat(retBuffers);
      }
      fromString(string) {
        this.value = [];
        let pos1 = 0;
        let pos2 = 0;
        let sid = "";
        do {
          pos2 = string.indexOf(".", pos1);
          if (pos2 === -1)
            sid = string.substring(pos1);
          else
            sid = string.substring(pos1, pos2);
          pos1 = pos2 + 1;
          const sidBlock = new LocalRelativeSidValueBlock();
          sidBlock.valueDec = parseInt(sid, 10);
          if (isNaN(sidBlock.valueDec))
            return true;
          this.value.push(sidBlock);
        } while (pos2 !== -1);
        return true;
      }
      toString() {
        let result2 = "";
        let isHexOnly = false;
        for (let i = 0; i < this.value.length; i++) {
          isHexOnly = this.value[i].isHexOnly;
          let sidStr = this.value[i].toString();
          if (i !== 0)
            result2 = `${result2}.`;
          if (isHexOnly) {
            sidStr = `{${sidStr}}`;
            result2 += sidStr;
          } else
            result2 += sidStr;
        }
        return result2;
      }
      toJSON() {
        const object = {
          ...super.toJSON(),
          value: this.toString(),
          sidArray: []
        };
        for (let i = 0; i < this.value.length; i++)
          object.sidArray.push(this.value[i].toJSON());
        return object;
      }
    };
    LocalRelativeObjectIdentifierValueBlock.NAME = "RelativeObjectIdentifierValueBlock";
    var _a$l;
    var RelativeObjectIdentifier = class extends BaseBlock {
      constructor(parameters = {}) {
        super(parameters, LocalRelativeObjectIdentifierValueBlock);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 13;
      }
      getValue() {
        return this.valueBlock.toString();
      }
      setValue(value) {
        this.valueBlock.fromString(value);
      }
      onAsciiEncoding() {
        return `${this.constructor.NAME} : ${this.valueBlock.toString() || "empty"}`;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          value: this.getValue()
        };
      }
    };
    _a$l = RelativeObjectIdentifier;
    (() => {
      typeStore.RelativeObjectIdentifier = _a$l;
    })();
    RelativeObjectIdentifier.NAME = "RelativeObjectIdentifier";
    var _a$k;
    var Sequence = class extends Constructed {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 16;
      }
    };
    _a$k = Sequence;
    (() => {
      typeStore.Sequence = _a$k;
    })();
    Sequence.NAME = "SEQUENCE";
    var _a$j;
    var Set2 = class extends Constructed {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 17;
      }
    };
    _a$j = Set2;
    (() => {
      typeStore.Set = _a$j;
    })();
    Set2.NAME = "SET";
    var LocalStringValueBlock = class extends HexBlock(ValueBlock) {
      constructor({ ...parameters } = {}) {
        super(parameters);
        this.isHexOnly = true;
        this.value = EMPTY_STRING;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          value: this.value
        };
      }
    };
    LocalStringValueBlock.NAME = "StringValueBlock";
    var LocalSimpleStringValueBlock = class extends LocalStringValueBlock {
    };
    LocalSimpleStringValueBlock.NAME = "SimpleStringValueBlock";
    var LocalSimpleStringBlock = class extends BaseStringBlock {
      constructor({ ...parameters } = {}) {
        super(parameters, LocalSimpleStringValueBlock);
      }
      fromBuffer(inputBuffer) {
        this.valueBlock.value = String.fromCharCode.apply(null, pvtsutils__namespace.BufferSourceConverter.toUint8Array(inputBuffer));
      }
      fromString(inputString) {
        const strLen = inputString.length;
        const view = this.valueBlock.valueHexView = new Uint8Array(strLen);
        for (let i = 0; i < strLen; i++)
          view[i] = inputString.charCodeAt(i);
        this.valueBlock.value = inputString;
      }
    };
    LocalSimpleStringBlock.NAME = "SIMPLE STRING";
    var LocalUtf8StringValueBlock = class extends LocalSimpleStringBlock {
      fromBuffer(inputBuffer) {
        this.valueBlock.valueHexView = pvtsutils__namespace.BufferSourceConverter.toUint8Array(inputBuffer);
        try {
          this.valueBlock.value = pvtsutils__namespace.Convert.ToUtf8String(inputBuffer);
        } catch (ex) {
          this.warnings.push(`Error during "decodeURIComponent": ${ex}, using raw string`);
          this.valueBlock.value = pvtsutils__namespace.Convert.ToBinary(inputBuffer);
        }
      }
      fromString(inputString) {
        this.valueBlock.valueHexView = new Uint8Array(pvtsutils__namespace.Convert.FromUtf8String(inputString));
        this.valueBlock.value = inputString;
      }
    };
    LocalUtf8StringValueBlock.NAME = "Utf8StringValueBlock";
    var _a$i;
    var Utf8String = class extends LocalUtf8StringValueBlock {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 12;
      }
    };
    _a$i = Utf8String;
    (() => {
      typeStore.Utf8String = _a$i;
    })();
    Utf8String.NAME = "UTF8String";
    var LocalBmpStringValueBlock = class extends LocalSimpleStringBlock {
      fromBuffer(inputBuffer) {
        this.valueBlock.value = pvtsutils__namespace.Convert.ToUtf16String(inputBuffer);
        this.valueBlock.valueHexView = pvtsutils__namespace.BufferSourceConverter.toUint8Array(inputBuffer);
      }
      fromString(inputString) {
        this.valueBlock.value = inputString;
        this.valueBlock.valueHexView = new Uint8Array(pvtsutils__namespace.Convert.FromUtf16String(inputString));
      }
    };
    LocalBmpStringValueBlock.NAME = "BmpStringValueBlock";
    var _a$h;
    var BmpString = class extends LocalBmpStringValueBlock {
      constructor({ ...parameters } = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 30;
      }
    };
    _a$h = BmpString;
    (() => {
      typeStore.BmpString = _a$h;
    })();
    BmpString.NAME = "BMPString";
    var LocalUniversalStringValueBlock = class extends LocalSimpleStringBlock {
      fromBuffer(inputBuffer) {
        const copyBuffer = ArrayBuffer.isView(inputBuffer) ? inputBuffer.slice().buffer : inputBuffer.slice(0);
        const valueView = new Uint8Array(copyBuffer);
        for (let i = 0; i < valueView.length; i += 4) {
          valueView[i] = valueView[i + 3];
          valueView[i + 1] = valueView[i + 2];
          valueView[i + 2] = 0;
          valueView[i + 3] = 0;
        }
        this.valueBlock.value = String.fromCharCode.apply(null, new Uint32Array(copyBuffer));
      }
      fromString(inputString) {
        const strLength = inputString.length;
        const valueHexView = this.valueBlock.valueHexView = new Uint8Array(strLength * 4);
        for (let i = 0; i < strLength; i++) {
          const codeBuf = pvutils__namespace.utilToBase(inputString.charCodeAt(i), 8);
          const codeView = new Uint8Array(codeBuf);
          if (codeView.length > 4)
            continue;
          const dif = 4 - codeView.length;
          for (let j = codeView.length - 1; j >= 0; j--)
            valueHexView[i * 4 + j + dif] = codeView[j];
        }
        this.valueBlock.value = inputString;
      }
    };
    LocalUniversalStringValueBlock.NAME = "UniversalStringValueBlock";
    var _a$g;
    var UniversalString = class extends LocalUniversalStringValueBlock {
      constructor({ ...parameters } = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 28;
      }
    };
    _a$g = UniversalString;
    (() => {
      typeStore.UniversalString = _a$g;
    })();
    UniversalString.NAME = "UniversalString";
    var _a$f;
    var NumericString = class extends LocalSimpleStringBlock {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 18;
      }
    };
    _a$f = NumericString;
    (() => {
      typeStore.NumericString = _a$f;
    })();
    NumericString.NAME = "NumericString";
    var _a$e;
    var PrintableString = class extends LocalSimpleStringBlock {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 19;
      }
    };
    _a$e = PrintableString;
    (() => {
      typeStore.PrintableString = _a$e;
    })();
    PrintableString.NAME = "PrintableString";
    var _a$d;
    var TeletexString = class extends LocalSimpleStringBlock {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 20;
      }
    };
    _a$d = TeletexString;
    (() => {
      typeStore.TeletexString = _a$d;
    })();
    TeletexString.NAME = "TeletexString";
    var _a$c;
    var VideotexString = class extends LocalSimpleStringBlock {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 21;
      }
    };
    _a$c = VideotexString;
    (() => {
      typeStore.VideotexString = _a$c;
    })();
    VideotexString.NAME = "VideotexString";
    var _a$b;
    var IA5String = class extends LocalSimpleStringBlock {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 22;
      }
    };
    _a$b = IA5String;
    (() => {
      typeStore.IA5String = _a$b;
    })();
    IA5String.NAME = "IA5String";
    var _a$a;
    var GraphicString = class extends LocalSimpleStringBlock {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 25;
      }
    };
    _a$a = GraphicString;
    (() => {
      typeStore.GraphicString = _a$a;
    })();
    GraphicString.NAME = "GraphicString";
    var _a$9;
    var VisibleString = class extends LocalSimpleStringBlock {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 26;
      }
    };
    _a$9 = VisibleString;
    (() => {
      typeStore.VisibleString = _a$9;
    })();
    VisibleString.NAME = "VisibleString";
    var _a$8;
    var GeneralString = class extends LocalSimpleStringBlock {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 27;
      }
    };
    _a$8 = GeneralString;
    (() => {
      typeStore.GeneralString = _a$8;
    })();
    GeneralString.NAME = "GeneralString";
    var _a$7;
    var CharacterString = class extends LocalSimpleStringBlock {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 29;
      }
    };
    _a$7 = CharacterString;
    (() => {
      typeStore.CharacterString = _a$7;
    })();
    CharacterString.NAME = "CharacterString";
    var _a$6;
    var UTCTime = class extends VisibleString {
      constructor({ value, valueDate, ...parameters } = {}) {
        super(parameters);
        this.year = 0;
        this.month = 0;
        this.day = 0;
        this.hour = 0;
        this.minute = 0;
        this.second = 0;
        if (value) {
          this.fromString(value);
          this.valueBlock.valueHexView = new Uint8Array(value.length);
          for (let i = 0; i < value.length; i++)
            this.valueBlock.valueHexView[i] = value.charCodeAt(i);
        }
        if (valueDate) {
          this.fromDate(valueDate);
          this.valueBlock.valueHexView = new Uint8Array(this.toBuffer());
        }
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 23;
      }
      fromBuffer(inputBuffer) {
        this.fromString(String.fromCharCode.apply(null, pvtsutils__namespace.BufferSourceConverter.toUint8Array(inputBuffer)));
      }
      toBuffer() {
        const str = this.toString();
        const buffer = new ArrayBuffer(str.length);
        const view = new Uint8Array(buffer);
        for (let i = 0; i < str.length; i++)
          view[i] = str.charCodeAt(i);
        return buffer;
      }
      fromDate(inputDate) {
        this.year = inputDate.getUTCFullYear();
        this.month = inputDate.getUTCMonth() + 1;
        this.day = inputDate.getUTCDate();
        this.hour = inputDate.getUTCHours();
        this.minute = inputDate.getUTCMinutes();
        this.second = inputDate.getUTCSeconds();
      }
      toDate() {
        return new Date(Date.UTC(this.year, this.month - 1, this.day, this.hour, this.minute, this.second));
      }
      fromString(inputString) {
        const parser = /(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})Z/ig;
        const parserArray = parser.exec(inputString);
        if (parserArray === null) {
          this.error = "Wrong input string for conversion";
          return;
        }
        const year = parseInt(parserArray[1], 10);
        if (year >= 50)
          this.year = 1900 + year;
        else
          this.year = 2e3 + year;
        this.month = parseInt(parserArray[2], 10);
        this.day = parseInt(parserArray[3], 10);
        this.hour = parseInt(parserArray[4], 10);
        this.minute = parseInt(parserArray[5], 10);
        this.second = parseInt(parserArray[6], 10);
      }
      toString(encoding = "iso") {
        if (encoding === "iso") {
          const outputArray = new Array(7);
          outputArray[0] = pvutils__namespace.padNumber(this.year < 2e3 ? this.year - 1900 : this.year - 2e3, 2);
          outputArray[1] = pvutils__namespace.padNumber(this.month, 2);
          outputArray[2] = pvutils__namespace.padNumber(this.day, 2);
          outputArray[3] = pvutils__namespace.padNumber(this.hour, 2);
          outputArray[4] = pvutils__namespace.padNumber(this.minute, 2);
          outputArray[5] = pvutils__namespace.padNumber(this.second, 2);
          outputArray[6] = "Z";
          return outputArray.join("");
        }
        return super.toString(encoding);
      }
      onAsciiEncoding() {
        return `${this.constructor.NAME} : ${this.toDate().toISOString()}`;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          year: this.year,
          month: this.month,
          day: this.day,
          hour: this.hour,
          minute: this.minute,
          second: this.second
        };
      }
    };
    _a$6 = UTCTime;
    (() => {
      typeStore.UTCTime = _a$6;
    })();
    UTCTime.NAME = "UTCTime";
    var _a$5;
    var GeneralizedTime = class extends UTCTime {
      constructor(parameters = {}) {
        var _b;
        super(parameters);
        (_b = this.millisecond) !== null && _b !== void 0 ? _b : this.millisecond = 0;
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 24;
      }
      fromDate(inputDate) {
        super.fromDate(inputDate);
        this.millisecond = inputDate.getUTCMilliseconds();
      }
      toDate() {
        return new Date(Date.UTC(this.year, this.month - 1, this.day, this.hour, this.minute, this.second, this.millisecond));
      }
      fromString(inputString) {
        let isUTC = false;
        let timeString = "";
        let dateTimeString = "";
        let fractionPart = 0;
        let parser;
        let hourDifference = 0;
        let minuteDifference = 0;
        if (inputString[inputString.length - 1] === "Z") {
          timeString = inputString.substring(0, inputString.length - 1);
          isUTC = true;
        } else {
          const number = new Number(inputString[inputString.length - 1]);
          if (isNaN(number.valueOf()))
            throw new Error("Wrong input string for conversion");
          timeString = inputString;
        }
        if (isUTC) {
          if (timeString.indexOf("+") !== -1)
            throw new Error("Wrong input string for conversion");
          if (timeString.indexOf("-") !== -1)
            throw new Error("Wrong input string for conversion");
        } else {
          let multiplier = 1;
          let differencePosition = timeString.indexOf("+");
          let differenceString = "";
          if (differencePosition === -1) {
            differencePosition = timeString.indexOf("-");
            multiplier = -1;
          }
          if (differencePosition !== -1) {
            differenceString = timeString.substring(differencePosition + 1);
            timeString = timeString.substring(0, differencePosition);
            if (differenceString.length !== 2 && differenceString.length !== 4)
              throw new Error("Wrong input string for conversion");
            let number = parseInt(differenceString.substring(0, 2), 10);
            if (isNaN(number.valueOf()))
              throw new Error("Wrong input string for conversion");
            hourDifference = multiplier * number;
            if (differenceString.length === 4) {
              number = parseInt(differenceString.substring(2, 4), 10);
              if (isNaN(number.valueOf()))
                throw new Error("Wrong input string for conversion");
              minuteDifference = multiplier * number;
            }
          }
        }
        let fractionPointPosition = timeString.indexOf(".");
        if (fractionPointPosition === -1)
          fractionPointPosition = timeString.indexOf(",");
        if (fractionPointPosition !== -1) {
          const fractionPartCheck = new Number(`0${timeString.substring(fractionPointPosition)}`);
          if (isNaN(fractionPartCheck.valueOf()))
            throw new Error("Wrong input string for conversion");
          fractionPart = fractionPartCheck.valueOf();
          dateTimeString = timeString.substring(0, fractionPointPosition);
        } else
          dateTimeString = timeString;
        switch (true) {
          case dateTimeString.length === 8:
            parser = /(\d{4})(\d{2})(\d{2})/ig;
            if (fractionPointPosition !== -1)
              throw new Error("Wrong input string for conversion");
            break;
          case dateTimeString.length === 10:
            parser = /(\d{4})(\d{2})(\d{2})(\d{2})/ig;
            if (fractionPointPosition !== -1) {
              let fractionResult = 60 * fractionPart;
              this.minute = Math.floor(fractionResult);
              fractionResult = 60 * (fractionResult - this.minute);
              this.second = Math.floor(fractionResult);
              fractionResult = 1e3 * (fractionResult - this.second);
              this.millisecond = Math.floor(fractionResult);
            }
            break;
          case dateTimeString.length === 12:
            parser = /(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})/ig;
            if (fractionPointPosition !== -1) {
              let fractionResult = 60 * fractionPart;
              this.second = Math.floor(fractionResult);
              fractionResult = 1e3 * (fractionResult - this.second);
              this.millisecond = Math.floor(fractionResult);
            }
            break;
          case dateTimeString.length === 14:
            parser = /(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})/ig;
            if (fractionPointPosition !== -1) {
              const fractionResult = 1e3 * fractionPart;
              this.millisecond = Math.floor(fractionResult);
            }
            break;
          default:
            throw new Error("Wrong input string for conversion");
        }
        const parserArray = parser.exec(dateTimeString);
        if (parserArray === null)
          throw new Error("Wrong input string for conversion");
        for (let j = 1; j < parserArray.length; j++) {
          switch (j) {
            case 1:
              this.year = parseInt(parserArray[j], 10);
              break;
            case 2:
              this.month = parseInt(parserArray[j], 10);
              break;
            case 3:
              this.day = parseInt(parserArray[j], 10);
              break;
            case 4:
              this.hour = parseInt(parserArray[j], 10) + hourDifference;
              break;
            case 5:
              this.minute = parseInt(parserArray[j], 10) + minuteDifference;
              break;
            case 6:
              this.second = parseInt(parserArray[j], 10);
              break;
            default:
              throw new Error("Wrong input string for conversion");
          }
        }
        if (isUTC === false) {
          const tempDate = new Date(this.year, this.month, this.day, this.hour, this.minute, this.second, this.millisecond);
          this.year = tempDate.getUTCFullYear();
          this.month = tempDate.getUTCMonth();
          this.day = tempDate.getUTCDay();
          this.hour = tempDate.getUTCHours();
          this.minute = tempDate.getUTCMinutes();
          this.second = tempDate.getUTCSeconds();
          this.millisecond = tempDate.getUTCMilliseconds();
        }
      }
      toString(encoding = "iso") {
        if (encoding === "iso") {
          const outputArray = [];
          outputArray.push(pvutils__namespace.padNumber(this.year, 4));
          outputArray.push(pvutils__namespace.padNumber(this.month, 2));
          outputArray.push(pvutils__namespace.padNumber(this.day, 2));
          outputArray.push(pvutils__namespace.padNumber(this.hour, 2));
          outputArray.push(pvutils__namespace.padNumber(this.minute, 2));
          outputArray.push(pvutils__namespace.padNumber(this.second, 2));
          if (this.millisecond !== 0) {
            outputArray.push(".");
            outputArray.push(pvutils__namespace.padNumber(this.millisecond, 3));
          }
          outputArray.push("Z");
          return outputArray.join("");
        }
        return super.toString(encoding);
      }
      toJSON() {
        return {
          ...super.toJSON(),
          millisecond: this.millisecond
        };
      }
    };
    _a$5 = GeneralizedTime;
    (() => {
      typeStore.GeneralizedTime = _a$5;
    })();
    GeneralizedTime.NAME = "GeneralizedTime";
    var _a$4;
    var DATE = class extends Utf8String {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 31;
      }
    };
    _a$4 = DATE;
    (() => {
      typeStore.DATE = _a$4;
    })();
    DATE.NAME = "DATE";
    var _a$3;
    var TimeOfDay = class extends Utf8String {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 32;
      }
    };
    _a$3 = TimeOfDay;
    (() => {
      typeStore.TimeOfDay = _a$3;
    })();
    TimeOfDay.NAME = "TimeOfDay";
    var _a$2;
    var DateTime = class extends Utf8String {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 33;
      }
    };
    _a$2 = DateTime;
    (() => {
      typeStore.DateTime = _a$2;
    })();
    DateTime.NAME = "DateTime";
    var _a$1;
    var Duration = class extends Utf8String {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 34;
      }
    };
    _a$1 = Duration;
    (() => {
      typeStore.Duration = _a$1;
    })();
    Duration.NAME = "Duration";
    var _a;
    var TIME = class extends Utf8String {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 14;
      }
    };
    _a = TIME;
    (() => {
      typeStore.TIME = _a;
    })();
    TIME.NAME = "TIME";
    var Any = class {
      constructor({ name = EMPTY_STRING, optional = false } = {}) {
        this.name = name;
        this.optional = optional;
      }
    };
    var Choice = class extends Any {
      constructor({ value = [], ...parameters } = {}) {
        super(parameters);
        this.value = value;
      }
    };
    var Repeated = class extends Any {
      constructor({ value = new Any(), local = false, ...parameters } = {}) {
        super(parameters);
        this.value = value;
        this.local = local;
      }
    };
    var RawData = class {
      constructor({ data = EMPTY_VIEW } = {}) {
        this.dataView = pvtsutils__namespace.BufferSourceConverter.toUint8Array(data);
      }
      get data() {
        return this.dataView.slice().buffer;
      }
      set data(value) {
        this.dataView = pvtsutils__namespace.BufferSourceConverter.toUint8Array(value);
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        const endLength = inputOffset + inputLength;
        this.dataView = pvtsutils__namespace.BufferSourceConverter.toUint8Array(inputBuffer).subarray(inputOffset, endLength);
        return endLength;
      }
      toBER(sizeOnly) {
        return this.dataView.slice().buffer;
      }
    };
    function compareSchema(root, inputData, inputSchema) {
      if (inputSchema instanceof Choice) {
        for (let j = 0; j < inputSchema.value.length; j++) {
          const result2 = compareSchema(root, inputData, inputSchema.value[j]);
          if (result2.verified) {
            return {
              verified: true,
              result: root
            };
          }
        }
        {
          const _result = {
            verified: false,
            result: {
              error: "Wrong values for Choice type"
            }
          };
          if (inputSchema.hasOwnProperty(NAME))
            _result.name = inputSchema.name;
          return _result;
        }
      }
      if (inputSchema instanceof Any) {
        if (inputSchema.hasOwnProperty(NAME))
          root[inputSchema.name] = inputData;
        return {
          verified: true,
          result: root
        };
      }
      if (root instanceof Object === false) {
        return {
          verified: false,
          result: { error: "Wrong root object" }
        };
      }
      if (inputData instanceof Object === false) {
        return {
          verified: false,
          result: { error: "Wrong ASN.1 data" }
        };
      }
      if (inputSchema instanceof Object === false) {
        return {
          verified: false,
          result: { error: "Wrong ASN.1 schema" }
        };
      }
      if (ID_BLOCK in inputSchema === false) {
        return {
          verified: false,
          result: { error: "Wrong ASN.1 schema" }
        };
      }
      if (FROM_BER in inputSchema.idBlock === false) {
        return {
          verified: false,
          result: { error: "Wrong ASN.1 schema" }
        };
      }
      if (TO_BER in inputSchema.idBlock === false) {
        return {
          verified: false,
          result: { error: "Wrong ASN.1 schema" }
        };
      }
      const encodedId = inputSchema.idBlock.toBER(false);
      if (encodedId.byteLength === 0) {
        return {
          verified: false,
          result: { error: "Error encoding idBlock for ASN.1 schema" }
        };
      }
      const decodedOffset = inputSchema.idBlock.fromBER(encodedId, 0, encodedId.byteLength);
      if (decodedOffset === -1) {
        return {
          verified: false,
          result: { error: "Error decoding idBlock for ASN.1 schema" }
        };
      }
      if (inputSchema.idBlock.hasOwnProperty(TAG_CLASS) === false) {
        return {
          verified: false,
          result: { error: "Wrong ASN.1 schema" }
        };
      }
      if (inputSchema.idBlock.tagClass !== inputData.idBlock.tagClass) {
        return {
          verified: false,
          result: root
        };
      }
      if (inputSchema.idBlock.hasOwnProperty(TAG_NUMBER) === false) {
        return {
          verified: false,
          result: { error: "Wrong ASN.1 schema" }
        };
      }
      if (inputSchema.idBlock.tagNumber !== inputData.idBlock.tagNumber) {
        return {
          verified: false,
          result: root
        };
      }
      if (inputSchema.idBlock.hasOwnProperty(IS_CONSTRUCTED) === false) {
        return {
          verified: false,
          result: { error: "Wrong ASN.1 schema" }
        };
      }
      if (inputSchema.idBlock.isConstructed !== inputData.idBlock.isConstructed) {
        return {
          verified: false,
          result: root
        };
      }
      if (!(IS_HEX_ONLY in inputSchema.idBlock)) {
        return {
          verified: false,
          result: { error: "Wrong ASN.1 schema" }
        };
      }
      if (inputSchema.idBlock.isHexOnly !== inputData.idBlock.isHexOnly) {
        return {
          verified: false,
          result: root
        };
      }
      if (inputSchema.idBlock.isHexOnly) {
        if (VALUE_HEX_VIEW in inputSchema.idBlock === false) {
          return {
            verified: false,
            result: { error: "Wrong ASN.1 schema" }
          };
        }
        const schemaView = inputSchema.idBlock.valueHexView;
        const asn1View = inputData.idBlock.valueHexView;
        if (schemaView.length !== asn1View.length) {
          return {
            verified: false,
            result: root
          };
        }
        for (let i = 0; i < schemaView.length; i++) {
          if (schemaView[i] !== asn1View[1]) {
            return {
              verified: false,
              result: root
            };
          }
        }
      }
      if (inputSchema.name) {
        inputSchema.name = inputSchema.name.replace(/^\s+|\s+$/g, EMPTY_STRING);
        if (inputSchema.name)
          root[inputSchema.name] = inputData;
      }
      if (inputSchema instanceof typeStore.Constructed) {
        let admission = 0;
        let result2 = {
          verified: false,
          result: {
            error: "Unknown error"
          }
        };
        let maxLength = inputSchema.valueBlock.value.length;
        if (maxLength > 0) {
          if (inputSchema.valueBlock.value[0] instanceof Repeated) {
            maxLength = inputData.valueBlock.value.length;
          }
        }
        if (maxLength === 0) {
          return {
            verified: true,
            result: root
          };
        }
        if (inputData.valueBlock.value.length === 0 && inputSchema.valueBlock.value.length !== 0) {
          let _optional = true;
          for (let i = 0; i < inputSchema.valueBlock.value.length; i++)
            _optional = _optional && (inputSchema.valueBlock.value[i].optional || false);
          if (_optional) {
            return {
              verified: true,
              result: root
            };
          }
          if (inputSchema.name) {
            inputSchema.name = inputSchema.name.replace(/^\s+|\s+$/g, EMPTY_STRING);
            if (inputSchema.name)
              delete root[inputSchema.name];
          }
          root.error = "Inconsistent object length";
          return {
            verified: false,
            result: root
          };
        }
        for (let i = 0; i < maxLength; i++) {
          if (i - admission >= inputData.valueBlock.value.length) {
            if (inputSchema.valueBlock.value[i].optional === false) {
              const _result = {
                verified: false,
                result: root
              };
              root.error = "Inconsistent length between ASN.1 data and schema";
              if (inputSchema.name) {
                inputSchema.name = inputSchema.name.replace(/^\s+|\s+$/g, EMPTY_STRING);
                if (inputSchema.name) {
                  delete root[inputSchema.name];
                  _result.name = inputSchema.name;
                }
              }
              return _result;
            }
          } else {
            if (inputSchema.valueBlock.value[0] instanceof Repeated) {
              result2 = compareSchema(root, inputData.valueBlock.value[i], inputSchema.valueBlock.value[0].value);
              if (result2.verified === false) {
                if (inputSchema.valueBlock.value[0].optional)
                  admission++;
                else {
                  if (inputSchema.name) {
                    inputSchema.name = inputSchema.name.replace(/^\s+|\s+$/g, EMPTY_STRING);
                    if (inputSchema.name)
                      delete root[inputSchema.name];
                  }
                  return result2;
                }
              }
              if (NAME in inputSchema.valueBlock.value[0] && inputSchema.valueBlock.value[0].name.length > 0) {
                let arrayRoot = {};
                if (LOCAL in inputSchema.valueBlock.value[0] && inputSchema.valueBlock.value[0].local)
                  arrayRoot = inputData;
                else
                  arrayRoot = root;
                if (typeof arrayRoot[inputSchema.valueBlock.value[0].name] === "undefined")
                  arrayRoot[inputSchema.valueBlock.value[0].name] = [];
                arrayRoot[inputSchema.valueBlock.value[0].name].push(inputData.valueBlock.value[i]);
              }
            } else {
              result2 = compareSchema(root, inputData.valueBlock.value[i - admission], inputSchema.valueBlock.value[i]);
              if (result2.verified === false) {
                if (inputSchema.valueBlock.value[i].optional)
                  admission++;
                else {
                  if (inputSchema.name) {
                    inputSchema.name = inputSchema.name.replace(/^\s+|\s+$/g, EMPTY_STRING);
                    if (inputSchema.name)
                      delete root[inputSchema.name];
                  }
                  return result2;
                }
              }
            }
          }
        }
        if (result2.verified === false) {
          const _result = {
            verified: false,
            result: root
          };
          if (inputSchema.name) {
            inputSchema.name = inputSchema.name.replace(/^\s+|\s+$/g, EMPTY_STRING);
            if (inputSchema.name) {
              delete root[inputSchema.name];
              _result.name = inputSchema.name;
            }
          }
          return _result;
        }
        return {
          verified: true,
          result: root
        };
      }
      if (inputSchema.primitiveSchema && VALUE_HEX_VIEW in inputData.valueBlock) {
        const asn1 = localFromBER(inputData.valueBlock.valueHexView);
        if (asn1.offset === -1) {
          const _result = {
            verified: false,
            result: asn1.result
          };
          if (inputSchema.name) {
            inputSchema.name = inputSchema.name.replace(/^\s+|\s+$/g, EMPTY_STRING);
            if (inputSchema.name) {
              delete root[inputSchema.name];
              _result.name = inputSchema.name;
            }
          }
          return _result;
        }
        return compareSchema(root, asn1.result, inputSchema.primitiveSchema);
      }
      return {
        verified: true,
        result: root
      };
    }
    function verifySchema(inputBuffer, inputSchema) {
      if (inputSchema instanceof Object === false) {
        return {
          verified: false,
          result: { error: "Wrong ASN.1 schema type" }
        };
      }
      const asn1 = localFromBER(pvtsutils__namespace.BufferSourceConverter.toUint8Array(inputBuffer));
      if (asn1.offset === -1) {
        return {
          verified: false,
          result: asn1.result
        };
      }
      return compareSchema(asn1.result, asn1.result, inputSchema);
    }
    exports2.Any = Any;
    exports2.BaseBlock = BaseBlock;
    exports2.BaseStringBlock = BaseStringBlock;
    exports2.BitString = BitString;
    exports2.BmpString = BmpString;
    exports2.Boolean = Boolean2;
    exports2.CharacterString = CharacterString;
    exports2.Choice = Choice;
    exports2.Constructed = Constructed;
    exports2.DATE = DATE;
    exports2.DateTime = DateTime;
    exports2.Duration = Duration;
    exports2.EndOfContent = EndOfContent;
    exports2.Enumerated = Enumerated;
    exports2.GeneralString = GeneralString;
    exports2.GeneralizedTime = GeneralizedTime;
    exports2.GraphicString = GraphicString;
    exports2.HexBlock = HexBlock;
    exports2.IA5String = IA5String;
    exports2.Integer = Integer;
    exports2.Null = Null;
    exports2.NumericString = NumericString;
    exports2.ObjectIdentifier = ObjectIdentifier;
    exports2.OctetString = OctetString;
    exports2.Primitive = Primitive;
    exports2.PrintableString = PrintableString;
    exports2.RawData = RawData;
    exports2.RelativeObjectIdentifier = RelativeObjectIdentifier;
    exports2.Repeated = Repeated;
    exports2.Sequence = Sequence;
    exports2.Set = Set2;
    exports2.TIME = TIME;
    exports2.TeletexString = TeletexString;
    exports2.TimeOfDay = TimeOfDay;
    exports2.UTCTime = UTCTime;
    exports2.UniversalString = UniversalString;
    exports2.Utf8String = Utf8String;
    exports2.ValueBlock = ValueBlock;
    exports2.VideotexString = VideotexString;
    exports2.ViewWriter = ViewWriter;
    exports2.VisibleString = VisibleString;
    exports2.compareSchema = compareSchema;
    exports2.fromBER = fromBER;
    exports2.verifySchema = verifySchema;
  }
});

// node_modules/@peculiar/asn1-schema/build/cjs/enums.js
var require_enums = __commonJS({
  "node_modules/@peculiar/asn1-schema/build/cjs/enums.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AsnPropTypes = exports2.AsnTypeTypes = void 0;
    var AsnTypeTypes;
    (function(AsnTypeTypes2) {
      AsnTypeTypes2[AsnTypeTypes2["Sequence"] = 0] = "Sequence";
      AsnTypeTypes2[AsnTypeTypes2["Set"] = 1] = "Set";
      AsnTypeTypes2[AsnTypeTypes2["Choice"] = 2] = "Choice";
    })(AsnTypeTypes || (exports2.AsnTypeTypes = AsnTypeTypes = {}));
    var AsnPropTypes;
    (function(AsnPropTypes2) {
      AsnPropTypes2[AsnPropTypes2["Any"] = 1] = "Any";
      AsnPropTypes2[AsnPropTypes2["Boolean"] = 2] = "Boolean";
      AsnPropTypes2[AsnPropTypes2["OctetString"] = 3] = "OctetString";
      AsnPropTypes2[AsnPropTypes2["BitString"] = 4] = "BitString";
      AsnPropTypes2[AsnPropTypes2["Integer"] = 5] = "Integer";
      AsnPropTypes2[AsnPropTypes2["Enumerated"] = 6] = "Enumerated";
      AsnPropTypes2[AsnPropTypes2["ObjectIdentifier"] = 7] = "ObjectIdentifier";
      AsnPropTypes2[AsnPropTypes2["Utf8String"] = 8] = "Utf8String";
      AsnPropTypes2[AsnPropTypes2["BmpString"] = 9] = "BmpString";
      AsnPropTypes2[AsnPropTypes2["UniversalString"] = 10] = "UniversalString";
      AsnPropTypes2[AsnPropTypes2["NumericString"] = 11] = "NumericString";
      AsnPropTypes2[AsnPropTypes2["PrintableString"] = 12] = "PrintableString";
      AsnPropTypes2[AsnPropTypes2["TeletexString"] = 13] = "TeletexString";
      AsnPropTypes2[AsnPropTypes2["VideotexString"] = 14] = "VideotexString";
      AsnPropTypes2[AsnPropTypes2["IA5String"] = 15] = "IA5String";
      AsnPropTypes2[AsnPropTypes2["GraphicString"] = 16] = "GraphicString";
      AsnPropTypes2[AsnPropTypes2["VisibleString"] = 17] = "VisibleString";
      AsnPropTypes2[AsnPropTypes2["GeneralString"] = 18] = "GeneralString";
      AsnPropTypes2[AsnPropTypes2["CharacterString"] = 19] = "CharacterString";
      AsnPropTypes2[AsnPropTypes2["UTCTime"] = 20] = "UTCTime";
      AsnPropTypes2[AsnPropTypes2["GeneralizedTime"] = 21] = "GeneralizedTime";
      AsnPropTypes2[AsnPropTypes2["DATE"] = 22] = "DATE";
      AsnPropTypes2[AsnPropTypes2["TimeOfDay"] = 23] = "TimeOfDay";
      AsnPropTypes2[AsnPropTypes2["DateTime"] = 24] = "DateTime";
      AsnPropTypes2[AsnPropTypes2["Duration"] = 25] = "Duration";
      AsnPropTypes2[AsnPropTypes2["TIME"] = 26] = "TIME";
      AsnPropTypes2[AsnPropTypes2["Null"] = 27] = "Null";
    })(AsnPropTypes || (exports2.AsnPropTypes = AsnPropTypes = {}));
  }
});

// node_modules/@peculiar/asn1-schema/build/cjs/types/bit_string.js
var require_bit_string = __commonJS({
  "node_modules/@peculiar/asn1-schema/build/cjs/types/bit_string.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.BitString = void 0;
    var asn1js = require_build4();
    var pvtsutils_1 = require_build3();
    var BitString = class {
      constructor(params, unusedBits = 0) {
        this.unusedBits = 0;
        this.value = new ArrayBuffer(0);
        if (params) {
          if (typeof params === "number") {
            this.fromNumber(params);
          } else if (pvtsutils_1.BufferSourceConverter.isBufferSource(params)) {
            this.unusedBits = unusedBits;
            this.value = pvtsutils_1.BufferSourceConverter.toArrayBuffer(params);
          } else {
            throw TypeError("Unsupported type of 'params' argument for BitString");
          }
        }
      }
      fromASN(asn) {
        if (!(asn instanceof asn1js.BitString)) {
          throw new TypeError("Argument 'asn' is not instance of ASN.1 BitString");
        }
        this.unusedBits = asn.valueBlock.unusedBits;
        this.value = asn.valueBlock.valueHex;
        return this;
      }
      toASN() {
        return new asn1js.BitString({ unusedBits: this.unusedBits, valueHex: this.value });
      }
      toSchema(name) {
        return new asn1js.BitString({ name });
      }
      toNumber() {
        let res = "";
        const uintArray = new Uint8Array(this.value);
        for (const octet of uintArray) {
          res += octet.toString(2).padStart(8, "0");
        }
        res = res.split("").reverse().join("");
        if (this.unusedBits) {
          res = res.slice(this.unusedBits).padStart(this.unusedBits, "0");
        }
        return parseInt(res, 2);
      }
      fromNumber(value) {
        let bits = value.toString(2);
        const octetSize = bits.length + 7 >> 3;
        this.unusedBits = (octetSize << 3) - bits.length;
        const octets = new Uint8Array(octetSize);
        bits = bits.padStart(octetSize << 3, "0").split("").reverse().join("");
        let index = 0;
        while (index < octetSize) {
          octets[index] = parseInt(bits.slice(index << 3, (index << 3) + 8), 2);
          index++;
        }
        this.value = octets.buffer;
      }
    };
    exports2.BitString = BitString;
  }
});

// node_modules/@peculiar/asn1-schema/build/cjs/types/octet_string.js
var require_octet_string = __commonJS({
  "node_modules/@peculiar/asn1-schema/build/cjs/types/octet_string.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OctetString = void 0;
    var asn1js = require_build4();
    var pvtsutils_1 = require_build3();
    var OctetString = class {
      get byteLength() {
        return this.buffer.byteLength;
      }
      get byteOffset() {
        return 0;
      }
      constructor(param) {
        if (typeof param === "number") {
          this.buffer = new ArrayBuffer(param);
        } else {
          if (pvtsutils_1.BufferSourceConverter.isBufferSource(param)) {
            this.buffer = pvtsutils_1.BufferSourceConverter.toArrayBuffer(param);
          } else if (Array.isArray(param)) {
            this.buffer = new Uint8Array(param);
          } else {
            this.buffer = new ArrayBuffer(0);
          }
        }
      }
      fromASN(asn) {
        if (!(asn instanceof asn1js.OctetString)) {
          throw new TypeError("Argument 'asn' is not instance of ASN.1 OctetString");
        }
        this.buffer = asn.valueBlock.valueHex;
        return this;
      }
      toASN() {
        return new asn1js.OctetString({ valueHex: this.buffer });
      }
      toSchema(name) {
        return new asn1js.OctetString({ name });
      }
    };
    exports2.OctetString = OctetString;
  }
});

// node_modules/@peculiar/asn1-schema/build/cjs/types/index.js
var require_types2 = __commonJS({
  "node_modules/@peculiar/asn1-schema/build/cjs/types/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    tslib_1.__exportStar(require_bit_string(), exports2);
    tslib_1.__exportStar(require_octet_string(), exports2);
  }
});

// node_modules/@peculiar/asn1-schema/build/cjs/converters.js
var require_converters = __commonJS({
  "node_modules/@peculiar/asn1-schema/build/cjs/converters.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.defaultConverter = exports2.AsnNullConverter = exports2.AsnGeneralizedTimeConverter = exports2.AsnUTCTimeConverter = exports2.AsnCharacterStringConverter = exports2.AsnGeneralStringConverter = exports2.AsnVisibleStringConverter = exports2.AsnGraphicStringConverter = exports2.AsnIA5StringConverter = exports2.AsnVideotexStringConverter = exports2.AsnTeletexStringConverter = exports2.AsnPrintableStringConverter = exports2.AsnNumericStringConverter = exports2.AsnUniversalStringConverter = exports2.AsnBmpStringConverter = exports2.AsnUtf8StringConverter = exports2.AsnConstructedOctetStringConverter = exports2.AsnOctetStringConverter = exports2.AsnBooleanConverter = exports2.AsnObjectIdentifierConverter = exports2.AsnBitStringConverter = exports2.AsnIntegerBigIntConverter = exports2.AsnIntegerArrayBufferConverter = exports2.AsnEnumeratedConverter = exports2.AsnIntegerConverter = exports2.AsnAnyConverter = void 0;
    var asn1js = require_build4();
    var enums_1 = require_enums();
    var index_1 = require_types2();
    exports2.AsnAnyConverter = {
      fromASN: (value) => value instanceof asn1js.Null ? null : value.valueBeforeDecodeView,
      toASN: (value) => {
        if (value === null) {
          return new asn1js.Null();
        }
        const schema = asn1js.fromBER(value);
        if (schema.result.error) {
          throw new Error(schema.result.error);
        }
        return schema.result;
      }
    };
    exports2.AsnIntegerConverter = {
      fromASN: (value) => value.valueBlock.valueHexView.byteLength >= 4 ? value.valueBlock.toString() : value.valueBlock.valueDec,
      toASN: (value) => new asn1js.Integer({ value: +value })
    };
    exports2.AsnEnumeratedConverter = {
      fromASN: (value) => value.valueBlock.valueDec,
      toASN: (value) => new asn1js.Enumerated({ value })
    };
    exports2.AsnIntegerArrayBufferConverter = {
      fromASN: (value) => value.valueBlock.valueHexView,
      toASN: (value) => new asn1js.Integer({ valueHex: value })
    };
    exports2.AsnIntegerBigIntConverter = {
      fromASN: (value) => value.toBigInt(),
      toASN: (value) => asn1js.Integer.fromBigInt(value)
    };
    exports2.AsnBitStringConverter = {
      fromASN: (value) => value.valueBlock.valueHexView,
      toASN: (value) => new asn1js.BitString({ valueHex: value })
    };
    exports2.AsnObjectIdentifierConverter = {
      fromASN: (value) => value.valueBlock.toString(),
      toASN: (value) => new asn1js.ObjectIdentifier({ value })
    };
    exports2.AsnBooleanConverter = {
      fromASN: (value) => value.valueBlock.value,
      toASN: (value) => new asn1js.Boolean({ value })
    };
    exports2.AsnOctetStringConverter = {
      fromASN: (value) => value.valueBlock.valueHexView,
      toASN: (value) => new asn1js.OctetString({ valueHex: value })
    };
    exports2.AsnConstructedOctetStringConverter = {
      fromASN: (value) => new index_1.OctetString(value.getValue()),
      toASN: (value) => value.toASN()
    };
    function createStringConverter(Asn1Type) {
      return {
        fromASN: (value) => value.valueBlock.value,
        toASN: (value) => new Asn1Type({ value })
      };
    }
    exports2.AsnUtf8StringConverter = createStringConverter(asn1js.Utf8String);
    exports2.AsnBmpStringConverter = createStringConverter(asn1js.BmpString);
    exports2.AsnUniversalStringConverter = createStringConverter(asn1js.UniversalString);
    exports2.AsnNumericStringConverter = createStringConverter(asn1js.NumericString);
    exports2.AsnPrintableStringConverter = createStringConverter(asn1js.PrintableString);
    exports2.AsnTeletexStringConverter = createStringConverter(asn1js.TeletexString);
    exports2.AsnVideotexStringConverter = createStringConverter(asn1js.VideotexString);
    exports2.AsnIA5StringConverter = createStringConverter(asn1js.IA5String);
    exports2.AsnGraphicStringConverter = createStringConverter(asn1js.GraphicString);
    exports2.AsnVisibleStringConverter = createStringConverter(asn1js.VisibleString);
    exports2.AsnGeneralStringConverter = createStringConverter(asn1js.GeneralString);
    exports2.AsnCharacterStringConverter = createStringConverter(asn1js.CharacterString);
    exports2.AsnUTCTimeConverter = {
      fromASN: (value) => value.toDate(),
      toASN: (value) => new asn1js.UTCTime({ valueDate: value })
    };
    exports2.AsnGeneralizedTimeConverter = {
      fromASN: (value) => value.toDate(),
      toASN: (value) => new asn1js.GeneralizedTime({ valueDate: value })
    };
    exports2.AsnNullConverter = {
      fromASN: () => null,
      toASN: () => {
        return new asn1js.Null();
      }
    };
    function defaultConverter(type) {
      switch (type) {
        case enums_1.AsnPropTypes.Any:
          return exports2.AsnAnyConverter;
        case enums_1.AsnPropTypes.BitString:
          return exports2.AsnBitStringConverter;
        case enums_1.AsnPropTypes.BmpString:
          return exports2.AsnBmpStringConverter;
        case enums_1.AsnPropTypes.Boolean:
          return exports2.AsnBooleanConverter;
        case enums_1.AsnPropTypes.CharacterString:
          return exports2.AsnCharacterStringConverter;
        case enums_1.AsnPropTypes.Enumerated:
          return exports2.AsnEnumeratedConverter;
        case enums_1.AsnPropTypes.GeneralString:
          return exports2.AsnGeneralStringConverter;
        case enums_1.AsnPropTypes.GeneralizedTime:
          return exports2.AsnGeneralizedTimeConverter;
        case enums_1.AsnPropTypes.GraphicString:
          return exports2.AsnGraphicStringConverter;
        case enums_1.AsnPropTypes.IA5String:
          return exports2.AsnIA5StringConverter;
        case enums_1.AsnPropTypes.Integer:
          return exports2.AsnIntegerConverter;
        case enums_1.AsnPropTypes.Null:
          return exports2.AsnNullConverter;
        case enums_1.AsnPropTypes.NumericString:
          return exports2.AsnNumericStringConverter;
        case enums_1.AsnPropTypes.ObjectIdentifier:
          return exports2.AsnObjectIdentifierConverter;
        case enums_1.AsnPropTypes.OctetString:
          return exports2.AsnOctetStringConverter;
        case enums_1.AsnPropTypes.PrintableString:
          return exports2.AsnPrintableStringConverter;
        case enums_1.AsnPropTypes.TeletexString:
          return exports2.AsnTeletexStringConverter;
        case enums_1.AsnPropTypes.UTCTime:
          return exports2.AsnUTCTimeConverter;
        case enums_1.AsnPropTypes.UniversalString:
          return exports2.AsnUniversalStringConverter;
        case enums_1.AsnPropTypes.Utf8String:
          return exports2.AsnUtf8StringConverter;
        case enums_1.AsnPropTypes.VideotexString:
          return exports2.AsnVideotexStringConverter;
        case enums_1.AsnPropTypes.VisibleString:
          return exports2.AsnVisibleStringConverter;
        default:
          return null;
      }
    }
    exports2.defaultConverter = defaultConverter;
  }
});

// node_modules/@peculiar/asn1-schema/build/cjs/helper.js
var require_helper = __commonJS({
  "node_modules/@peculiar/asn1-schema/build/cjs/helper.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isArrayEqual = exports2.isTypeOfArray = exports2.isConvertible = void 0;
    function isConvertible(target) {
      if (typeof target === "function" && target.prototype) {
        if (target.prototype.toASN && target.prototype.fromASN) {
          return true;
        } else {
          return isConvertible(target.prototype);
        }
      } else {
        return !!(target && typeof target === "object" && "toASN" in target && "fromASN" in target);
      }
    }
    exports2.isConvertible = isConvertible;
    function isTypeOfArray(target) {
      var _a;
      if (target) {
        const proto = Object.getPrototypeOf(target);
        if (((_a = proto === null || proto === void 0 ? void 0 : proto.prototype) === null || _a === void 0 ? void 0 : _a.constructor) === Array) {
          return true;
        }
        return isTypeOfArray(proto);
      }
      return false;
    }
    exports2.isTypeOfArray = isTypeOfArray;
    function isArrayEqual(bytes1, bytes2) {
      if (!(bytes1 && bytes2)) {
        return false;
      }
      if (bytes1.byteLength !== bytes2.byteLength) {
        return false;
      }
      const b1 = new Uint8Array(bytes1);
      const b2 = new Uint8Array(bytes2);
      for (let i = 0; i < bytes1.byteLength; i++) {
        if (b1[i] !== b2[i]) {
          return false;
        }
      }
      return true;
    }
    exports2.isArrayEqual = isArrayEqual;
  }
});

// node_modules/@peculiar/asn1-schema/build/cjs/schema.js
var require_schema = __commonJS({
  "node_modules/@peculiar/asn1-schema/build/cjs/schema.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AsnSchemaStorage = void 0;
    var asn1js = require_build4();
    var enums_1 = require_enums();
    var helper_1 = require_helper();
    var AsnSchemaStorage = class {
      constructor() {
        this.items = /* @__PURE__ */ new WeakMap();
      }
      has(target) {
        return this.items.has(target);
      }
      get(target, checkSchema = false) {
        const schema = this.items.get(target);
        if (!schema) {
          throw new Error(`Cannot get schema for '${target.prototype.constructor.name}' target`);
        }
        if (checkSchema && !schema.schema) {
          throw new Error(`Schema '${target.prototype.constructor.name}' doesn't contain ASN.1 schema. Call 'AsnSchemaStorage.cache'.`);
        }
        return schema;
      }
      cache(target) {
        const schema = this.get(target);
        if (!schema.schema) {
          schema.schema = this.create(target, true);
        }
      }
      createDefault(target) {
        const schema = {
          type: enums_1.AsnTypeTypes.Sequence,
          items: {}
        };
        const parentSchema = this.findParentSchema(target);
        if (parentSchema) {
          Object.assign(schema, parentSchema);
          schema.items = Object.assign({}, schema.items, parentSchema.items);
        }
        return schema;
      }
      create(target, useNames) {
        const schema = this.items.get(target) || this.createDefault(target);
        const asn1Value = [];
        for (const key in schema.items) {
          const item = schema.items[key];
          const name = useNames ? key : "";
          let asn1Item;
          if (typeof item.type === "number") {
            const Asn1TypeName = enums_1.AsnPropTypes[item.type];
            const Asn1Type = asn1js[Asn1TypeName];
            if (!Asn1Type) {
              throw new Error(`Cannot get ASN1 class by name '${Asn1TypeName}'`);
            }
            asn1Item = new Asn1Type({ name });
          } else if ((0, helper_1.isConvertible)(item.type)) {
            const instance = new item.type();
            asn1Item = instance.toSchema(name);
          } else if (item.optional) {
            const itemSchema = this.get(item.type);
            if (itemSchema.type === enums_1.AsnTypeTypes.Choice) {
              asn1Item = new asn1js.Any({ name });
            } else {
              asn1Item = this.create(item.type, false);
              asn1Item.name = name;
            }
          } else {
            asn1Item = new asn1js.Any({ name });
          }
          const optional = !!item.optional || item.defaultValue !== void 0;
          if (item.repeated) {
            asn1Item.name = "";
            const Container = item.repeated === "set" ? asn1js.Set : asn1js.Sequence;
            asn1Item = new Container({
              name: "",
              value: [
                new asn1js.Repeated({
                  name,
                  value: asn1Item
                })
              ]
            });
          }
          if (item.context !== null && item.context !== void 0) {
            if (item.implicit) {
              if (typeof item.type === "number" || (0, helper_1.isConvertible)(item.type)) {
                const Container = item.repeated ? asn1js.Constructed : asn1js.Primitive;
                asn1Value.push(new Container({
                  name,
                  optional,
                  idBlock: {
                    tagClass: 3,
                    tagNumber: item.context
                  }
                }));
              } else {
                this.cache(item.type);
                const isRepeated = !!item.repeated;
                let value = !isRepeated ? this.get(item.type, true).schema : asn1Item;
                value = "valueBlock" in value ? value.valueBlock.value : value.value;
                asn1Value.push(new asn1js.Constructed({
                  name: !isRepeated ? name : "",
                  optional,
                  idBlock: {
                    tagClass: 3,
                    tagNumber: item.context
                  },
                  value
                }));
              }
            } else {
              asn1Value.push(new asn1js.Constructed({
                optional,
                idBlock: {
                  tagClass: 3,
                  tagNumber: item.context
                },
                value: [asn1Item]
              }));
            }
          } else {
            asn1Item.optional = optional;
            asn1Value.push(asn1Item);
          }
        }
        switch (schema.type) {
          case enums_1.AsnTypeTypes.Sequence:
            return new asn1js.Sequence({ value: asn1Value, name: "" });
          case enums_1.AsnTypeTypes.Set:
            return new asn1js.Set({ value: asn1Value, name: "" });
          case enums_1.AsnTypeTypes.Choice:
            return new asn1js.Choice({ value: asn1Value, name: "" });
          default:
            throw new Error(`Unsupported ASN1 type in use`);
        }
      }
      set(target, schema) {
        this.items.set(target, schema);
        return this;
      }
      findParentSchema(target) {
        const parent = Object.getPrototypeOf(target);
        if (parent) {
          const schema = this.items.get(parent);
          return schema || this.findParentSchema(parent);
        }
        return null;
      }
    };
    exports2.AsnSchemaStorage = AsnSchemaStorage;
  }
});

// node_modules/@peculiar/asn1-schema/build/cjs/storage.js
var require_storage = __commonJS({
  "node_modules/@peculiar/asn1-schema/build/cjs/storage.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.schemaStorage = void 0;
    var schema_1 = require_schema();
    exports2.schemaStorage = new schema_1.AsnSchemaStorage();
  }
});

// node_modules/@peculiar/asn1-schema/build/cjs/decorators.js
var require_decorators = __commonJS({
  "node_modules/@peculiar/asn1-schema/build/cjs/decorators.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AsnProp = exports2.AsnSequenceType = exports2.AsnSetType = exports2.AsnChoiceType = exports2.AsnType = void 0;
    var converters = require_converters();
    var enums_1 = require_enums();
    var storage_1 = require_storage();
    var AsnType = (options) => (target) => {
      let schema;
      if (!storage_1.schemaStorage.has(target)) {
        schema = storage_1.schemaStorage.createDefault(target);
        storage_1.schemaStorage.set(target, schema);
      } else {
        schema = storage_1.schemaStorage.get(target);
      }
      Object.assign(schema, options);
    };
    exports2.AsnType = AsnType;
    var AsnChoiceType = () => (0, exports2.AsnType)({ type: enums_1.AsnTypeTypes.Choice });
    exports2.AsnChoiceType = AsnChoiceType;
    var AsnSetType = (options) => (0, exports2.AsnType)({ type: enums_1.AsnTypeTypes.Set, ...options });
    exports2.AsnSetType = AsnSetType;
    var AsnSequenceType = (options) => (0, exports2.AsnType)({ type: enums_1.AsnTypeTypes.Sequence, ...options });
    exports2.AsnSequenceType = AsnSequenceType;
    var AsnProp = (options) => (target, propertyKey) => {
      let schema;
      if (!storage_1.schemaStorage.has(target.constructor)) {
        schema = storage_1.schemaStorage.createDefault(target.constructor);
        storage_1.schemaStorage.set(target.constructor, schema);
      } else {
        schema = storage_1.schemaStorage.get(target.constructor);
      }
      const copyOptions = Object.assign({}, options);
      if (typeof copyOptions.type === "number" && !copyOptions.converter) {
        const defaultConverter = converters.defaultConverter(options.type);
        if (!defaultConverter) {
          throw new Error(`Cannot get default converter for property '${propertyKey}' of ${target.constructor.name}`);
        }
        copyOptions.converter = defaultConverter;
      }
      schema.items[propertyKey] = copyOptions;
    };
    exports2.AsnProp = AsnProp;
  }
});

// node_modules/@peculiar/asn1-schema/build/cjs/errors/schema_validation.js
var require_schema_validation = __commonJS({
  "node_modules/@peculiar/asn1-schema/build/cjs/errors/schema_validation.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AsnSchemaValidationError = void 0;
    var AsnSchemaValidationError = class extends Error {
      constructor() {
        super(...arguments);
        this.schemas = [];
      }
    };
    exports2.AsnSchemaValidationError = AsnSchemaValidationError;
  }
});

// node_modules/@peculiar/asn1-schema/build/cjs/errors/index.js
var require_errors2 = __commonJS({
  "node_modules/@peculiar/asn1-schema/build/cjs/errors/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    tslib_1.__exportStar(require_schema_validation(), exports2);
  }
});

// node_modules/@peculiar/asn1-schema/build/cjs/parser.js
var require_parser2 = __commonJS({
  "node_modules/@peculiar/asn1-schema/build/cjs/parser.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AsnParser = void 0;
    var asn1js = require_build4();
    var enums_1 = require_enums();
    var converters = require_converters();
    var errors_1 = require_errors2();
    var helper_1 = require_helper();
    var storage_1 = require_storage();
    var AsnParser = class {
      static parse(data, target) {
        const asn1Parsed = asn1js.fromBER(data);
        if (asn1Parsed.result.error) {
          throw new Error(asn1Parsed.result.error);
        }
        const res = this.fromASN(asn1Parsed.result, target);
        return res;
      }
      static fromASN(asn1Schema, target) {
        var _a;
        try {
          if ((0, helper_1.isConvertible)(target)) {
            const value = new target();
            return value.fromASN(asn1Schema);
          }
          const schema = storage_1.schemaStorage.get(target);
          storage_1.schemaStorage.cache(target);
          let targetSchema = schema.schema;
          if (asn1Schema.constructor === asn1js.Constructed && schema.type !== enums_1.AsnTypeTypes.Choice) {
            targetSchema = new asn1js.Constructed({
              idBlock: {
                tagClass: 3,
                tagNumber: asn1Schema.idBlock.tagNumber
              },
              value: schema.schema.valueBlock.value
            });
            for (const key in schema.items) {
              delete asn1Schema[key];
            }
          }
          const asn1ComparedSchema = asn1js.compareSchema({}, asn1Schema, targetSchema);
          if (!asn1ComparedSchema.verified) {
            throw new errors_1.AsnSchemaValidationError(`Data does not match to ${target.name} ASN1 schema. ${asn1ComparedSchema.result.error}`);
          }
          const res = new target();
          if ((0, helper_1.isTypeOfArray)(target)) {
            if (!("value" in asn1Schema.valueBlock && Array.isArray(asn1Schema.valueBlock.value))) {
              throw new Error(`Cannot get items from the ASN.1 parsed value. ASN.1 object is not constructed.`);
            }
            const itemType = schema.itemType;
            if (typeof itemType === "number") {
              const converter = converters.defaultConverter(itemType);
              if (!converter) {
                throw new Error(`Cannot get default converter for array item of ${target.name} ASN1 schema`);
              }
              return target.from(asn1Schema.valueBlock.value, (element) => converter.fromASN(element));
            } else {
              return target.from(asn1Schema.valueBlock.value, (element) => this.fromASN(element, itemType));
            }
          }
          for (const key in schema.items) {
            const asn1SchemaValue = asn1ComparedSchema.result[key];
            if (!asn1SchemaValue) {
              continue;
            }
            const schemaItem = schema.items[key];
            const schemaItemType = schemaItem.type;
            if (typeof schemaItemType === "number" || (0, helper_1.isConvertible)(schemaItemType)) {
              const converter = (_a = schemaItem.converter) !== null && _a !== void 0 ? _a : (0, helper_1.isConvertible)(schemaItemType) ? new schemaItemType() : null;
              if (!converter) {
                throw new Error("Converter is empty");
              }
              if (schemaItem.repeated) {
                if (schemaItem.implicit) {
                  const Container = schemaItem.repeated === "sequence" ? asn1js.Sequence : asn1js.Set;
                  const newItem = new Container();
                  newItem.valueBlock = asn1SchemaValue.valueBlock;
                  const newItemAsn = asn1js.fromBER(newItem.toBER(false));
                  if (newItemAsn.offset === -1) {
                    throw new Error(`Cannot parse the child item. ${newItemAsn.result.error}`);
                  }
                  if (!("value" in newItemAsn.result.valueBlock && Array.isArray(newItemAsn.result.valueBlock.value))) {
                    throw new Error("Cannot get items from the ASN.1 parsed value. ASN.1 object is not constructed.");
                  }
                  const value = newItemAsn.result.valueBlock.value;
                  res[key] = Array.from(value, (element) => converter.fromASN(element));
                } else {
                  res[key] = Array.from(asn1SchemaValue, (element) => converter.fromASN(element));
                }
              } else {
                let value = asn1SchemaValue;
                if (schemaItem.implicit) {
                  let newItem;
                  if ((0, helper_1.isConvertible)(schemaItemType)) {
                    newItem = new schemaItemType().toSchema("");
                  } else {
                    const Asn1TypeName = enums_1.AsnPropTypes[schemaItemType];
                    const Asn1Type = asn1js[Asn1TypeName];
                    if (!Asn1Type) {
                      throw new Error(`Cannot get '${Asn1TypeName}' class from asn1js module`);
                    }
                    newItem = new Asn1Type();
                  }
                  newItem.valueBlock = value.valueBlock;
                  value = asn1js.fromBER(newItem.toBER(false)).result;
                }
                res[key] = converter.fromASN(value);
              }
            } else {
              if (schemaItem.repeated) {
                if (!Array.isArray(asn1SchemaValue)) {
                  throw new Error("Cannot get list of items from the ASN.1 parsed value. ASN.1 value should be iterable.");
                }
                res[key] = Array.from(asn1SchemaValue, (element) => this.fromASN(element, schemaItemType));
              } else {
                res[key] = this.fromASN(asn1SchemaValue, schemaItemType);
              }
            }
          }
          return res;
        } catch (error) {
          if (error instanceof errors_1.AsnSchemaValidationError) {
            error.schemas.push(target.name);
          }
          throw error;
        }
      }
    };
    exports2.AsnParser = AsnParser;
  }
});

// node_modules/@peculiar/asn1-schema/build/cjs/serializer.js
var require_serializer = __commonJS({
  "node_modules/@peculiar/asn1-schema/build/cjs/serializer.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AsnSerializer = void 0;
    var asn1js = require_build4();
    var converters = require_converters();
    var enums_1 = require_enums();
    var helper_1 = require_helper();
    var storage_1 = require_storage();
    var AsnSerializer = class _AsnSerializer {
      static serialize(obj) {
        if (obj instanceof asn1js.BaseBlock) {
          return obj.toBER(false);
        }
        return this.toASN(obj).toBER(false);
      }
      static toASN(obj) {
        if (obj && typeof obj === "object" && (0, helper_1.isConvertible)(obj)) {
          return obj.toASN();
        }
        if (!(obj && typeof obj === "object")) {
          throw new TypeError("Parameter 1 should be type of Object.");
        }
        const target = obj.constructor;
        const schema = storage_1.schemaStorage.get(target);
        storage_1.schemaStorage.cache(target);
        let asn1Value = [];
        if (schema.itemType) {
          if (!Array.isArray(obj)) {
            throw new TypeError("Parameter 1 should be type of Array.");
          }
          if (typeof schema.itemType === "number") {
            const converter = converters.defaultConverter(schema.itemType);
            if (!converter) {
              throw new Error(`Cannot get default converter for array item of ${target.name} ASN1 schema`);
            }
            asn1Value = obj.map((o2) => converter.toASN(o2));
          } else {
            asn1Value = obj.map((o2) => this.toAsnItem({ type: schema.itemType }, "[]", target, o2));
          }
        } else {
          for (const key in schema.items) {
            const schemaItem = schema.items[key];
            const objProp = obj[key];
            if (objProp === void 0 || schemaItem.defaultValue === objProp || typeof schemaItem.defaultValue === "object" && typeof objProp === "object" && (0, helper_1.isArrayEqual)(this.serialize(schemaItem.defaultValue), this.serialize(objProp))) {
              continue;
            }
            const asn1Item = _AsnSerializer.toAsnItem(schemaItem, key, target, objProp);
            if (typeof schemaItem.context === "number") {
              if (schemaItem.implicit) {
                if (!schemaItem.repeated && (typeof schemaItem.type === "number" || (0, helper_1.isConvertible)(schemaItem.type))) {
                  const value = {};
                  value.valueHex = asn1Item instanceof asn1js.Null ? asn1Item.valueBeforeDecodeView : asn1Item.valueBlock.toBER();
                  asn1Value.push(new asn1js.Primitive({
                    optional: schemaItem.optional,
                    idBlock: {
                      tagClass: 3,
                      tagNumber: schemaItem.context
                    },
                    ...value
                  }));
                } else {
                  asn1Value.push(new asn1js.Constructed({
                    optional: schemaItem.optional,
                    idBlock: {
                      tagClass: 3,
                      tagNumber: schemaItem.context
                    },
                    value: asn1Item.valueBlock.value
                  }));
                }
              } else {
                asn1Value.push(new asn1js.Constructed({
                  optional: schemaItem.optional,
                  idBlock: {
                    tagClass: 3,
                    tagNumber: schemaItem.context
                  },
                  value: [asn1Item]
                }));
              }
            } else if (schemaItem.repeated) {
              asn1Value = asn1Value.concat(asn1Item);
            } else {
              asn1Value.push(asn1Item);
            }
          }
        }
        let asnSchema;
        switch (schema.type) {
          case enums_1.AsnTypeTypes.Sequence:
            asnSchema = new asn1js.Sequence({ value: asn1Value });
            break;
          case enums_1.AsnTypeTypes.Set:
            asnSchema = new asn1js.Set({ value: asn1Value });
            break;
          case enums_1.AsnTypeTypes.Choice:
            if (!asn1Value[0]) {
              throw new Error(`Schema '${target.name}' has wrong data. Choice cannot be empty.`);
            }
            asnSchema = asn1Value[0];
            break;
        }
        return asnSchema;
      }
      static toAsnItem(schemaItem, key, target, objProp) {
        let asn1Item;
        if (typeof schemaItem.type === "number") {
          const converter = schemaItem.converter;
          if (!converter) {
            throw new Error(`Property '${key}' doesn't have converter for type ${enums_1.AsnPropTypes[schemaItem.type]} in schema '${target.name}'`);
          }
          if (schemaItem.repeated) {
            if (!Array.isArray(objProp)) {
              throw new TypeError("Parameter 'objProp' should be type of Array.");
            }
            const items = Array.from(objProp, (element) => converter.toASN(element));
            const Container = schemaItem.repeated === "sequence" ? asn1js.Sequence : asn1js.Set;
            asn1Item = new Container({
              value: items
            });
          } else {
            asn1Item = converter.toASN(objProp);
          }
        } else {
          if (schemaItem.repeated) {
            if (!Array.isArray(objProp)) {
              throw new TypeError("Parameter 'objProp' should be type of Array.");
            }
            const items = Array.from(objProp, (element) => this.toASN(element));
            const Container = schemaItem.repeated === "sequence" ? asn1js.Sequence : asn1js.Set;
            asn1Item = new Container({
              value: items
            });
          } else {
            asn1Item = this.toASN(objProp);
          }
        }
        return asn1Item;
      }
    };
    exports2.AsnSerializer = AsnSerializer;
  }
});

// node_modules/@peculiar/asn1-schema/build/cjs/objects.js
var require_objects = __commonJS({
  "node_modules/@peculiar/asn1-schema/build/cjs/objects.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AsnArray = void 0;
    var AsnArray = class extends Array {
      constructor(items = []) {
        if (typeof items === "number") {
          super(items);
        } else {
          super();
          for (const item of items) {
            this.push(item);
          }
        }
      }
    };
    exports2.AsnArray = AsnArray;
  }
});

// node_modules/@peculiar/asn1-schema/build/cjs/convert.js
var require_convert = __commonJS({
  "node_modules/@peculiar/asn1-schema/build/cjs/convert.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AsnConvert = void 0;
    var asn1js = require_build4();
    var pvtsutils_1 = require_build3();
    var parser_1 = require_parser2();
    var serializer_1 = require_serializer();
    var AsnConvert = class _AsnConvert {
      static serialize(obj) {
        return serializer_1.AsnSerializer.serialize(obj);
      }
      static parse(data, target) {
        return parser_1.AsnParser.parse(data, target);
      }
      static toString(data) {
        const buf = pvtsutils_1.BufferSourceConverter.isBufferSource(data) ? pvtsutils_1.BufferSourceConverter.toArrayBuffer(data) : _AsnConvert.serialize(data);
        const asn = asn1js.fromBER(buf);
        if (asn.offset === -1) {
          throw new Error(`Cannot decode ASN.1 data. ${asn.result.error}`);
        }
        return asn.result.toString();
      }
    };
    exports2.AsnConvert = AsnConvert;
  }
});

// node_modules/@peculiar/asn1-schema/build/cjs/index.js
var require_cjs2 = __commonJS({
  "node_modules/@peculiar/asn1-schema/build/cjs/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AsnSerializer = exports2.AsnParser = exports2.AsnPropTypes = exports2.AsnTypeTypes = exports2.AsnSetType = exports2.AsnSequenceType = exports2.AsnChoiceType = exports2.AsnType = exports2.AsnProp = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    tslib_1.__exportStar(require_converters(), exports2);
    tslib_1.__exportStar(require_types2(), exports2);
    var decorators_1 = require_decorators();
    Object.defineProperty(exports2, "AsnProp", { enumerable: true, get: function() {
      return decorators_1.AsnProp;
    } });
    Object.defineProperty(exports2, "AsnType", { enumerable: true, get: function() {
      return decorators_1.AsnType;
    } });
    Object.defineProperty(exports2, "AsnChoiceType", { enumerable: true, get: function() {
      return decorators_1.AsnChoiceType;
    } });
    Object.defineProperty(exports2, "AsnSequenceType", { enumerable: true, get: function() {
      return decorators_1.AsnSequenceType;
    } });
    Object.defineProperty(exports2, "AsnSetType", { enumerable: true, get: function() {
      return decorators_1.AsnSetType;
    } });
    var enums_1 = require_enums();
    Object.defineProperty(exports2, "AsnTypeTypes", { enumerable: true, get: function() {
      return enums_1.AsnTypeTypes;
    } });
    Object.defineProperty(exports2, "AsnPropTypes", { enumerable: true, get: function() {
      return enums_1.AsnPropTypes;
    } });
    var parser_1 = require_parser2();
    Object.defineProperty(exports2, "AsnParser", { enumerable: true, get: function() {
      return parser_1.AsnParser;
    } });
    var serializer_1 = require_serializer();
    Object.defineProperty(exports2, "AsnSerializer", { enumerable: true, get: function() {
      return serializer_1.AsnSerializer;
    } });
    tslib_1.__exportStar(require_errors2(), exports2);
    tslib_1.__exportStar(require_objects(), exports2);
    tslib_1.__exportStar(require_convert(), exports2);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/ip_converter.js
var require_ip_converter = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/ip_converter.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.IpConverter = void 0;
    var ip = require_ipaddr();
    var pvtsutils_1 = require_build3();
    var IpConverter = class {
      static decodeIP(value) {
        if (value.length === 64 && parseInt(value, 16) === 0) {
          return "::/0";
        }
        if (value.length !== 16) {
          return value;
        }
        const mask = parseInt(value.slice(8), 16).toString(2).split("").reduce((a, k) => a + +k, 0);
        let ip2 = value.slice(0, 8).replace(/(.{2})/g, (match) => `${parseInt(match, 16)}.`);
        ip2 = ip2.slice(0, -1);
        return `${ip2}/${mask}`;
      }
      static toString(buf) {
        if (buf.byteLength === 4 || buf.byteLength === 16) {
          const uint8 = new Uint8Array(buf);
          const addr = ip.fromByteArray(Array.from(uint8));
          return addr.toString();
        }
        return this.decodeIP(pvtsutils_1.Convert.ToHex(buf));
      }
      static fromString(text2) {
        const addr = ip.parse(text2);
        return new Uint8Array(addr.toByteArray()).buffer;
      }
    };
    exports2.IpConverter = IpConverter;
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/name.js
var require_name = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/name.js"(exports2) {
    "use strict";
    var RelativeDistinguishedName_1;
    var RDNSequence_1;
    var Name_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Name = exports2.RDNSequence = exports2.RelativeDistinguishedName = exports2.AttributeTypeAndValue = exports2.AttributeValue = exports2.DirectoryString = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var pvtsutils_1 = require_build3();
    var DirectoryString = class DirectoryString {
      constructor(params = {}) {
        Object.assign(this, params);
      }
      toString() {
        return this.bmpString || this.printableString || this.teletexString || this.universalString || this.utf8String || "";
      }
    };
    exports2.DirectoryString = DirectoryString;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.TeletexString })
    ], DirectoryString.prototype, "teletexString", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.PrintableString })
    ], DirectoryString.prototype, "printableString", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.UniversalString })
    ], DirectoryString.prototype, "universalString", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Utf8String })
    ], DirectoryString.prototype, "utf8String", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.BmpString })
    ], DirectoryString.prototype, "bmpString", void 0);
    exports2.DirectoryString = DirectoryString = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], DirectoryString);
    var AttributeValue = class AttributeValue extends DirectoryString {
      constructor(params = {}) {
        super(params);
        Object.assign(this, params);
      }
      toString() {
        return this.ia5String || (this.anyValue ? pvtsutils_1.Convert.ToHex(this.anyValue) : super.toString());
      }
    };
    exports2.AttributeValue = AttributeValue;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.IA5String })
    ], AttributeValue.prototype, "ia5String", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Any })
    ], AttributeValue.prototype, "anyValue", void 0);
    exports2.AttributeValue = AttributeValue = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], AttributeValue);
    var AttributeTypeAndValue = class {
      constructor(params = {}) {
        this.type = "";
        this.value = new AttributeValue();
        Object.assign(this, params);
      }
    };
    exports2.AttributeTypeAndValue = AttributeTypeAndValue;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], AttributeTypeAndValue.prototype, "type", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: AttributeValue })
    ], AttributeTypeAndValue.prototype, "value", void 0);
    var RelativeDistinguishedName = RelativeDistinguishedName_1 = class RelativeDistinguishedName extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, RelativeDistinguishedName_1.prototype);
      }
    };
    exports2.RelativeDistinguishedName = RelativeDistinguishedName;
    exports2.RelativeDistinguishedName = RelativeDistinguishedName = RelativeDistinguishedName_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Set, itemType: AttributeTypeAndValue })
    ], RelativeDistinguishedName);
    var RDNSequence = RDNSequence_1 = class RDNSequence extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, RDNSequence_1.prototype);
      }
    };
    exports2.RDNSequence = RDNSequence;
    exports2.RDNSequence = RDNSequence = RDNSequence_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: RelativeDistinguishedName })
    ], RDNSequence);
    var Name = Name_1 = class Name extends RDNSequence {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, Name_1.prototype);
      }
    };
    exports2.Name = Name;
    exports2.Name = Name = Name_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence })
    ], Name);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/general_name.js
var require_general_name = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/general_name.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.GeneralName = exports2.EDIPartyName = exports2.OtherName = exports2.AsnIpConverter = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var ip_converter_1 = require_ip_converter();
    var name_1 = require_name();
    exports2.AsnIpConverter = {
      fromASN: (value) => ip_converter_1.IpConverter.toString(asn1_schema_1.AsnOctetStringConverter.fromASN(value)),
      toASN: (value) => asn1_schema_1.AsnOctetStringConverter.toASN(ip_converter_1.IpConverter.fromString(value))
    };
    var OtherName = class {
      constructor(params = {}) {
        this.typeId = "";
        this.value = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.OtherName = OtherName;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], OtherName.prototype, "typeId", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Any, context: 0 })
    ], OtherName.prototype, "value", void 0);
    var EDIPartyName = class {
      constructor(params = {}) {
        this.partyName = new name_1.DirectoryString();
        Object.assign(this, params);
      }
    };
    exports2.EDIPartyName = EDIPartyName;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: name_1.DirectoryString, optional: true, context: 0, implicit: true })
    ], EDIPartyName.prototype, "nameAssigner", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: name_1.DirectoryString, context: 1, implicit: true })
    ], EDIPartyName.prototype, "partyName", void 0);
    var GeneralName = class GeneralName {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.GeneralName = GeneralName;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: OtherName, context: 0, implicit: true })
    ], GeneralName.prototype, "otherName", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.IA5String, context: 1, implicit: true })
    ], GeneralName.prototype, "rfc822Name", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.IA5String, context: 2, implicit: true })
    ], GeneralName.prototype, "dNSName", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Any, context: 3, implicit: true })
    ], GeneralName.prototype, "x400Address", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: name_1.Name, context: 4, implicit: false })
    ], GeneralName.prototype, "directoryName", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: EDIPartyName, context: 5 })
    ], GeneralName.prototype, "ediPartyName", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.IA5String, context: 6, implicit: true })
    ], GeneralName.prototype, "uniformResourceIdentifier", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.OctetString, context: 7, implicit: true, converter: exports2.AsnIpConverter })
    ], GeneralName.prototype, "iPAddress", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier, context: 8, implicit: true })
    ], GeneralName.prototype, "registeredID", void 0);
    exports2.GeneralName = GeneralName = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], GeneralName);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/object_identifiers.js
var require_object_identifiers = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/object_identifiers.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.id_ce = exports2.id_ad_caRepository = exports2.id_ad_timeStamping = exports2.id_ad_caIssuers = exports2.id_ad_ocsp = exports2.id_qt_unotice = exports2.id_qt_csp = exports2.id_ad = exports2.id_kp = exports2.id_qt = exports2.id_pe = exports2.id_pkix = void 0;
    exports2.id_pkix = "1.3.6.1.5.5.7";
    exports2.id_pe = `${exports2.id_pkix}.1`;
    exports2.id_qt = `${exports2.id_pkix}.2`;
    exports2.id_kp = `${exports2.id_pkix}.3`;
    exports2.id_ad = `${exports2.id_pkix}.48`;
    exports2.id_qt_csp = `${exports2.id_qt}.1`;
    exports2.id_qt_unotice = `${exports2.id_qt}.2`;
    exports2.id_ad_ocsp = `${exports2.id_ad}.1`;
    exports2.id_ad_caIssuers = `${exports2.id_ad}.2`;
    exports2.id_ad_timeStamping = `${exports2.id_ad}.3`;
    exports2.id_ad_caRepository = `${exports2.id_ad}.5`;
    exports2.id_ce = "2.5.29";
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/authority_information_access.js
var require_authority_information_access = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/authority_information_access.js"(exports2) {
    "use strict";
    var AuthorityInfoAccessSyntax_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AuthorityInfoAccessSyntax = exports2.AccessDescription = exports2.id_pe_authorityInfoAccess = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var general_name_1 = require_general_name();
    var object_identifiers_1 = require_object_identifiers();
    exports2.id_pe_authorityInfoAccess = `${object_identifiers_1.id_pe}.1`;
    var AccessDescription = class {
      constructor(params = {}) {
        this.accessMethod = "";
        this.accessLocation = new general_name_1.GeneralName();
        Object.assign(this, params);
      }
    };
    exports2.AccessDescription = AccessDescription;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], AccessDescription.prototype, "accessMethod", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: general_name_1.GeneralName })
    ], AccessDescription.prototype, "accessLocation", void 0);
    var AuthorityInfoAccessSyntax = AuthorityInfoAccessSyntax_1 = class AuthorityInfoAccessSyntax extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, AuthorityInfoAccessSyntax_1.prototype);
      }
    };
    exports2.AuthorityInfoAccessSyntax = AuthorityInfoAccessSyntax;
    exports2.AuthorityInfoAccessSyntax = AuthorityInfoAccessSyntax = AuthorityInfoAccessSyntax_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: AccessDescription })
    ], AuthorityInfoAccessSyntax);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/authority_key_identifier.js
var require_authority_key_identifier = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/authority_key_identifier.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AuthorityKeyIdentifier = exports2.KeyIdentifier = exports2.id_ce_authorityKeyIdentifier = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var general_name_1 = require_general_name();
    var object_identifiers_1 = require_object_identifiers();
    exports2.id_ce_authorityKeyIdentifier = `${object_identifiers_1.id_ce}.35`;
    var KeyIdentifier = class extends asn1_schema_1.OctetString {
    };
    exports2.KeyIdentifier = KeyIdentifier;
    var AuthorityKeyIdentifier = class {
      constructor(params = {}) {
        if (params) {
          Object.assign(this, params);
        }
      }
    };
    exports2.AuthorityKeyIdentifier = AuthorityKeyIdentifier;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: KeyIdentifier, context: 0, optional: true, implicit: true })
    ], AuthorityKeyIdentifier.prototype, "keyIdentifier", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: general_name_1.GeneralName, context: 1, optional: true, implicit: true, repeated: "sequence" })
    ], AuthorityKeyIdentifier.prototype, "authorityCertIssuer", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({
        type: asn1_schema_1.AsnPropTypes.Integer,
        context: 2,
        optional: true,
        implicit: true,
        converter: asn1_schema_1.AsnIntegerArrayBufferConverter
      })
    ], AuthorityKeyIdentifier.prototype, "authorityCertSerialNumber", void 0);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/basic_constraints.js
var require_basic_constraints = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/basic_constraints.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.BasicConstraints = exports2.id_ce_basicConstraints = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var object_identifiers_1 = require_object_identifiers();
    exports2.id_ce_basicConstraints = `${object_identifiers_1.id_ce}.19`;
    var BasicConstraints = class {
      constructor(params = {}) {
        this.cA = false;
        Object.assign(this, params);
      }
    };
    exports2.BasicConstraints = BasicConstraints;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Boolean, defaultValue: false })
    ], BasicConstraints.prototype, "cA", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, optional: true })
    ], BasicConstraints.prototype, "pathLenConstraint", void 0);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/general_names.js
var require_general_names = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/general_names.js"(exports2) {
    "use strict";
    var GeneralNames_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.GeneralNames = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var general_name_1 = require_general_name();
    var asn1_schema_2 = require_cjs2();
    var GeneralNames = GeneralNames_1 = class GeneralNames extends asn1_schema_2.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, GeneralNames_1.prototype);
      }
    };
    exports2.GeneralNames = GeneralNames;
    exports2.GeneralNames = GeneralNames = GeneralNames_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: general_name_1.GeneralName })
    ], GeneralNames);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/certificate_issuer.js
var require_certificate_issuer = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/certificate_issuer.js"(exports2) {
    "use strict";
    var CertificateIssuer_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.CertificateIssuer = exports2.id_ce_certificateIssuer = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var general_names_1 = require_general_names();
    var object_identifiers_1 = require_object_identifiers();
    exports2.id_ce_certificateIssuer = `${object_identifiers_1.id_ce}.29`;
    var CertificateIssuer = CertificateIssuer_1 = class CertificateIssuer extends general_names_1.GeneralNames {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, CertificateIssuer_1.prototype);
      }
    };
    exports2.CertificateIssuer = CertificateIssuer;
    exports2.CertificateIssuer = CertificateIssuer = CertificateIssuer_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence })
    ], CertificateIssuer);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/certificate_policies.js
var require_certificate_policies = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/certificate_policies.js"(exports2) {
    "use strict";
    var CertificatePolicies_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.CertificatePolicies = exports2.PolicyInformation = exports2.PolicyQualifierInfo = exports2.Qualifier = exports2.UserNotice = exports2.NoticeReference = exports2.DisplayText = exports2.id_ce_certificatePolicies_anyPolicy = exports2.id_ce_certificatePolicies = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var object_identifiers_1 = require_object_identifiers();
    exports2.id_ce_certificatePolicies = `${object_identifiers_1.id_ce}.32`;
    exports2.id_ce_certificatePolicies_anyPolicy = `${exports2.id_ce_certificatePolicies}.0`;
    var DisplayText = class DisplayText {
      constructor(params = {}) {
        Object.assign(this, params);
      }
      toString() {
        return this.ia5String || this.visibleString || this.bmpString || this.utf8String || "";
      }
    };
    exports2.DisplayText = DisplayText;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.IA5String })
    ], DisplayText.prototype, "ia5String", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.VisibleString })
    ], DisplayText.prototype, "visibleString", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.BmpString })
    ], DisplayText.prototype, "bmpString", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Utf8String })
    ], DisplayText.prototype, "utf8String", void 0);
    exports2.DisplayText = DisplayText = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], DisplayText);
    var NoticeReference = class {
      constructor(params = {}) {
        this.organization = new DisplayText();
        this.noticeNumbers = [];
        Object.assign(this, params);
      }
    };
    exports2.NoticeReference = NoticeReference;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: DisplayText })
    ], NoticeReference.prototype, "organization", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, repeated: "sequence" })
    ], NoticeReference.prototype, "noticeNumbers", void 0);
    var UserNotice = class {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.UserNotice = UserNotice;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: NoticeReference, optional: true })
    ], UserNotice.prototype, "noticeRef", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: DisplayText, optional: true })
    ], UserNotice.prototype, "explicitText", void 0);
    var Qualifier = class Qualifier {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.Qualifier = Qualifier;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.IA5String })
    ], Qualifier.prototype, "cPSuri", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: UserNotice })
    ], Qualifier.prototype, "userNotice", void 0);
    exports2.Qualifier = Qualifier = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], Qualifier);
    var PolicyQualifierInfo = class {
      constructor(params = {}) {
        this.policyQualifierId = "";
        this.qualifier = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.PolicyQualifierInfo = PolicyQualifierInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], PolicyQualifierInfo.prototype, "policyQualifierId", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Any })
    ], PolicyQualifierInfo.prototype, "qualifier", void 0);
    var PolicyInformation = class {
      constructor(params = {}) {
        this.policyIdentifier = "";
        Object.assign(this, params);
      }
    };
    exports2.PolicyInformation = PolicyInformation;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], PolicyInformation.prototype, "policyIdentifier", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: PolicyQualifierInfo, repeated: "sequence", optional: true })
    ], PolicyInformation.prototype, "policyQualifiers", void 0);
    var CertificatePolicies = CertificatePolicies_1 = class CertificatePolicies extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, CertificatePolicies_1.prototype);
      }
    };
    exports2.CertificatePolicies = CertificatePolicies;
    exports2.CertificatePolicies = CertificatePolicies = CertificatePolicies_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: PolicyInformation })
    ], CertificatePolicies);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/crl_number.js
var require_crl_number = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/crl_number.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.CRLNumber = exports2.id_ce_cRLNumber = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var object_identifiers_1 = require_object_identifiers();
    exports2.id_ce_cRLNumber = `${object_identifiers_1.id_ce}.20`;
    var CRLNumber = class CRLNumber {
      constructor(value = 0) {
        this.value = value;
      }
    };
    exports2.CRLNumber = CRLNumber;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer })
    ], CRLNumber.prototype, "value", void 0);
    exports2.CRLNumber = CRLNumber = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], CRLNumber);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/crl_delta_indicator.js
var require_crl_delta_indicator = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/crl_delta_indicator.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.BaseCRLNumber = exports2.id_ce_deltaCRLIndicator = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var object_identifiers_1 = require_object_identifiers();
    var crl_number_1 = require_crl_number();
    exports2.id_ce_deltaCRLIndicator = `${object_identifiers_1.id_ce}.27`;
    var BaseCRLNumber = class BaseCRLNumber extends crl_number_1.CRLNumber {
    };
    exports2.BaseCRLNumber = BaseCRLNumber;
    exports2.BaseCRLNumber = BaseCRLNumber = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], BaseCRLNumber);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/crl_distribution_points.js
var require_crl_distribution_points = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/crl_distribution_points.js"(exports2) {
    "use strict";
    var CRLDistributionPoints_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.CRLDistributionPoints = exports2.DistributionPoint = exports2.DistributionPointName = exports2.Reason = exports2.ReasonFlags = exports2.id_ce_cRLDistributionPoints = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var name_1 = require_name();
    var general_name_1 = require_general_name();
    var object_identifiers_1 = require_object_identifiers();
    exports2.id_ce_cRLDistributionPoints = `${object_identifiers_1.id_ce}.31`;
    var ReasonFlags;
    (function(ReasonFlags2) {
      ReasonFlags2[ReasonFlags2["unused"] = 1] = "unused";
      ReasonFlags2[ReasonFlags2["keyCompromise"] = 2] = "keyCompromise";
      ReasonFlags2[ReasonFlags2["cACompromise"] = 4] = "cACompromise";
      ReasonFlags2[ReasonFlags2["affiliationChanged"] = 8] = "affiliationChanged";
      ReasonFlags2[ReasonFlags2["superseded"] = 16] = "superseded";
      ReasonFlags2[ReasonFlags2["cessationOfOperation"] = 32] = "cessationOfOperation";
      ReasonFlags2[ReasonFlags2["certificateHold"] = 64] = "certificateHold";
      ReasonFlags2[ReasonFlags2["privilegeWithdrawn"] = 128] = "privilegeWithdrawn";
      ReasonFlags2[ReasonFlags2["aACompromise"] = 256] = "aACompromise";
    })(ReasonFlags || (exports2.ReasonFlags = ReasonFlags = {}));
    var Reason = class extends asn1_schema_1.BitString {
      toJSON() {
        const res = [];
        const flags = this.toNumber();
        if (flags & ReasonFlags.aACompromise) {
          res.push("aACompromise");
        }
        if (flags & ReasonFlags.affiliationChanged) {
          res.push("affiliationChanged");
        }
        if (flags & ReasonFlags.cACompromise) {
          res.push("cACompromise");
        }
        if (flags & ReasonFlags.certificateHold) {
          res.push("certificateHold");
        }
        if (flags & ReasonFlags.cessationOfOperation) {
          res.push("cessationOfOperation");
        }
        if (flags & ReasonFlags.keyCompromise) {
          res.push("keyCompromise");
        }
        if (flags & ReasonFlags.privilegeWithdrawn) {
          res.push("privilegeWithdrawn");
        }
        if (flags & ReasonFlags.superseded) {
          res.push("superseded");
        }
        if (flags & ReasonFlags.unused) {
          res.push("unused");
        }
        return res;
      }
      toString() {
        return `[${this.toJSON().join(", ")}]`;
      }
    };
    exports2.Reason = Reason;
    var DistributionPointName = class DistributionPointName {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.DistributionPointName = DistributionPointName;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: general_name_1.GeneralName, context: 0, repeated: "sequence", implicit: true })
    ], DistributionPointName.prototype, "fullName", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: name_1.RelativeDistinguishedName, context: 1, implicit: true })
    ], DistributionPointName.prototype, "nameRelativeToCRLIssuer", void 0);
    exports2.DistributionPointName = DistributionPointName = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], DistributionPointName);
    var DistributionPoint = class {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.DistributionPoint = DistributionPoint;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: DistributionPointName, context: 0, optional: true })
    ], DistributionPoint.prototype, "distributionPoint", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: Reason, context: 1, optional: true, implicit: true })
    ], DistributionPoint.prototype, "reasons", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: general_name_1.GeneralName, context: 2, optional: true, repeated: "sequence", implicit: true })
    ], DistributionPoint.prototype, "cRLIssuer", void 0);
    var CRLDistributionPoints = CRLDistributionPoints_1 = class CRLDistributionPoints extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, CRLDistributionPoints_1.prototype);
      }
    };
    exports2.CRLDistributionPoints = CRLDistributionPoints;
    exports2.CRLDistributionPoints = CRLDistributionPoints = CRLDistributionPoints_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: DistributionPoint })
    ], CRLDistributionPoints);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/crl_freshest.js
var require_crl_freshest = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/crl_freshest.js"(exports2) {
    "use strict";
    var FreshestCRL_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.FreshestCRL = exports2.id_ce_freshestCRL = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var object_identifiers_1 = require_object_identifiers();
    var crl_distribution_points_1 = require_crl_distribution_points();
    exports2.id_ce_freshestCRL = `${object_identifiers_1.id_ce}.46`;
    var FreshestCRL = FreshestCRL_1 = class FreshestCRL extends crl_distribution_points_1.CRLDistributionPoints {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, FreshestCRL_1.prototype);
      }
    };
    exports2.FreshestCRL = FreshestCRL;
    exports2.FreshestCRL = FreshestCRL = FreshestCRL_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: crl_distribution_points_1.DistributionPoint })
    ], FreshestCRL);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/crl_issuing_distribution_point.js
var require_crl_issuing_distribution_point = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/crl_issuing_distribution_point.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.IssuingDistributionPoint = exports2.id_ce_issuingDistributionPoint = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var crl_distribution_points_1 = require_crl_distribution_points();
    var object_identifiers_1 = require_object_identifiers();
    var asn1_schema_2 = require_cjs2();
    exports2.id_ce_issuingDistributionPoint = `${object_identifiers_1.id_ce}.28`;
    var IssuingDistributionPoint = class _IssuingDistributionPoint {
      constructor(params = {}) {
        this.onlyContainsUserCerts = _IssuingDistributionPoint.ONLY;
        this.onlyContainsCACerts = _IssuingDistributionPoint.ONLY;
        this.indirectCRL = _IssuingDistributionPoint.ONLY;
        this.onlyContainsAttributeCerts = _IssuingDistributionPoint.ONLY;
        Object.assign(this, params);
      }
    };
    exports2.IssuingDistributionPoint = IssuingDistributionPoint;
    IssuingDistributionPoint.ONLY = false;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: crl_distribution_points_1.DistributionPointName, context: 0, optional: true })
    ], IssuingDistributionPoint.prototype, "distributionPoint", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_2.AsnPropTypes.Boolean, context: 1, defaultValue: IssuingDistributionPoint.ONLY, implicit: true })
    ], IssuingDistributionPoint.prototype, "onlyContainsUserCerts", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_2.AsnPropTypes.Boolean, context: 2, defaultValue: IssuingDistributionPoint.ONLY, implicit: true })
    ], IssuingDistributionPoint.prototype, "onlyContainsCACerts", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: crl_distribution_points_1.Reason, context: 3, optional: true, implicit: true })
    ], IssuingDistributionPoint.prototype, "onlySomeReasons", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_2.AsnPropTypes.Boolean, context: 4, defaultValue: IssuingDistributionPoint.ONLY, implicit: true })
    ], IssuingDistributionPoint.prototype, "indirectCRL", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_2.AsnPropTypes.Boolean, context: 5, defaultValue: IssuingDistributionPoint.ONLY, implicit: true })
    ], IssuingDistributionPoint.prototype, "onlyContainsAttributeCerts", void 0);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/crl_reason.js
var require_crl_reason = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/crl_reason.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.CRLReason = exports2.CRLReasons = exports2.id_ce_cRLReasons = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var object_identifiers_1 = require_object_identifiers();
    exports2.id_ce_cRLReasons = `${object_identifiers_1.id_ce}.21`;
    var CRLReasons;
    (function(CRLReasons2) {
      CRLReasons2[CRLReasons2["unspecified"] = 0] = "unspecified";
      CRLReasons2[CRLReasons2["keyCompromise"] = 1] = "keyCompromise";
      CRLReasons2[CRLReasons2["cACompromise"] = 2] = "cACompromise";
      CRLReasons2[CRLReasons2["affiliationChanged"] = 3] = "affiliationChanged";
      CRLReasons2[CRLReasons2["superseded"] = 4] = "superseded";
      CRLReasons2[CRLReasons2["cessationOfOperation"] = 5] = "cessationOfOperation";
      CRLReasons2[CRLReasons2["certificateHold"] = 6] = "certificateHold";
      CRLReasons2[CRLReasons2["removeFromCRL"] = 8] = "removeFromCRL";
      CRLReasons2[CRLReasons2["privilegeWithdrawn"] = 9] = "privilegeWithdrawn";
      CRLReasons2[CRLReasons2["aACompromise"] = 10] = "aACompromise";
    })(CRLReasons || (exports2.CRLReasons = CRLReasons = {}));
    var CRLReason = class CRLReason {
      constructor(reason = CRLReasons.unspecified) {
        this.reason = CRLReasons.unspecified;
        this.reason = reason;
      }
      toJSON() {
        return CRLReasons[this.reason];
      }
      toString() {
        return this.toJSON();
      }
    };
    exports2.CRLReason = CRLReason;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Enumerated })
    ], CRLReason.prototype, "reason", void 0);
    exports2.CRLReason = CRLReason = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], CRLReason);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/extended_key_usage.js
var require_extended_key_usage = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/extended_key_usage.js"(exports2) {
    "use strict";
    var ExtendedKeyUsage_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.id_kp_OCSPSigning = exports2.id_kp_timeStamping = exports2.id_kp_emailProtection = exports2.id_kp_codeSigning = exports2.id_kp_clientAuth = exports2.id_kp_serverAuth = exports2.anyExtendedKeyUsage = exports2.ExtendedKeyUsage = exports2.id_ce_extKeyUsage = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var object_identifiers_1 = require_object_identifiers();
    exports2.id_ce_extKeyUsage = `${object_identifiers_1.id_ce}.37`;
    var ExtendedKeyUsage = ExtendedKeyUsage_1 = class ExtendedKeyUsage extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, ExtendedKeyUsage_1.prototype);
      }
    };
    exports2.ExtendedKeyUsage = ExtendedKeyUsage;
    exports2.ExtendedKeyUsage = ExtendedKeyUsage = ExtendedKeyUsage_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], ExtendedKeyUsage);
    exports2.anyExtendedKeyUsage = `${exports2.id_ce_extKeyUsage}.0`;
    exports2.id_kp_serverAuth = `${object_identifiers_1.id_kp}.1`;
    exports2.id_kp_clientAuth = `${object_identifiers_1.id_kp}.2`;
    exports2.id_kp_codeSigning = `${object_identifiers_1.id_kp}.3`;
    exports2.id_kp_emailProtection = `${object_identifiers_1.id_kp}.4`;
    exports2.id_kp_timeStamping = `${object_identifiers_1.id_kp}.8`;
    exports2.id_kp_OCSPSigning = `${object_identifiers_1.id_kp}.9`;
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/inhibit_any_policy.js
var require_inhibit_any_policy = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/inhibit_any_policy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.InhibitAnyPolicy = exports2.id_ce_inhibitAnyPolicy = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var object_identifiers_1 = require_object_identifiers();
    exports2.id_ce_inhibitAnyPolicy = `${object_identifiers_1.id_ce}.54`;
    var InhibitAnyPolicy = class InhibitAnyPolicy {
      constructor(value = new ArrayBuffer(0)) {
        this.value = value;
      }
    };
    exports2.InhibitAnyPolicy = InhibitAnyPolicy;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, converter: asn1_schema_1.AsnIntegerArrayBufferConverter })
    ], InhibitAnyPolicy.prototype, "value", void 0);
    exports2.InhibitAnyPolicy = InhibitAnyPolicy = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], InhibitAnyPolicy);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/invalidity_date.js
var require_invalidity_date = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/invalidity_date.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.InvalidityDate = exports2.id_ce_invalidityDate = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var object_identifiers_1 = require_object_identifiers();
    exports2.id_ce_invalidityDate = `${object_identifiers_1.id_ce}.24`;
    var InvalidityDate = class InvalidityDate {
      constructor(value) {
        this.value = /* @__PURE__ */ new Date();
        if (value) {
          this.value = value;
        }
      }
    };
    exports2.InvalidityDate = InvalidityDate;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.GeneralizedTime })
    ], InvalidityDate.prototype, "value", void 0);
    exports2.InvalidityDate = InvalidityDate = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], InvalidityDate);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/issuer_alternative_name.js
var require_issuer_alternative_name = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/issuer_alternative_name.js"(exports2) {
    "use strict";
    var IssueAlternativeName_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.IssueAlternativeName = exports2.id_ce_issuerAltName = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var general_names_1 = require_general_names();
    var object_identifiers_1 = require_object_identifiers();
    exports2.id_ce_issuerAltName = `${object_identifiers_1.id_ce}.18`;
    var IssueAlternativeName = IssueAlternativeName_1 = class IssueAlternativeName extends general_names_1.GeneralNames {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, IssueAlternativeName_1.prototype);
      }
    };
    exports2.IssueAlternativeName = IssueAlternativeName;
    exports2.IssueAlternativeName = IssueAlternativeName = IssueAlternativeName_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence })
    ], IssueAlternativeName);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/key_usage.js
var require_key_usage = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/key_usage.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.KeyUsage = exports2.KeyUsageFlags = exports2.id_ce_keyUsage = void 0;
    var asn1_schema_1 = require_cjs2();
    var object_identifiers_1 = require_object_identifiers();
    exports2.id_ce_keyUsage = `${object_identifiers_1.id_ce}.15`;
    var KeyUsageFlags;
    (function(KeyUsageFlags2) {
      KeyUsageFlags2[KeyUsageFlags2["digitalSignature"] = 1] = "digitalSignature";
      KeyUsageFlags2[KeyUsageFlags2["nonRepudiation"] = 2] = "nonRepudiation";
      KeyUsageFlags2[KeyUsageFlags2["keyEncipherment"] = 4] = "keyEncipherment";
      KeyUsageFlags2[KeyUsageFlags2["dataEncipherment"] = 8] = "dataEncipherment";
      KeyUsageFlags2[KeyUsageFlags2["keyAgreement"] = 16] = "keyAgreement";
      KeyUsageFlags2[KeyUsageFlags2["keyCertSign"] = 32] = "keyCertSign";
      KeyUsageFlags2[KeyUsageFlags2["cRLSign"] = 64] = "cRLSign";
      KeyUsageFlags2[KeyUsageFlags2["encipherOnly"] = 128] = "encipherOnly";
      KeyUsageFlags2[KeyUsageFlags2["decipherOnly"] = 256] = "decipherOnly";
    })(KeyUsageFlags || (exports2.KeyUsageFlags = KeyUsageFlags = {}));
    var KeyUsage = class extends asn1_schema_1.BitString {
      toJSON() {
        const flag = this.toNumber();
        const res = [];
        if (flag & KeyUsageFlags.cRLSign) {
          res.push("crlSign");
        }
        if (flag & KeyUsageFlags.dataEncipherment) {
          res.push("dataEncipherment");
        }
        if (flag & KeyUsageFlags.decipherOnly) {
          res.push("decipherOnly");
        }
        if (flag & KeyUsageFlags.digitalSignature) {
          res.push("digitalSignature");
        }
        if (flag & KeyUsageFlags.encipherOnly) {
          res.push("encipherOnly");
        }
        if (flag & KeyUsageFlags.keyAgreement) {
          res.push("keyAgreement");
        }
        if (flag & KeyUsageFlags.keyCertSign) {
          res.push("keyCertSign");
        }
        if (flag & KeyUsageFlags.keyEncipherment) {
          res.push("keyEncipherment");
        }
        if (flag & KeyUsageFlags.nonRepudiation) {
          res.push("nonRepudiation");
        }
        return res;
      }
      toString() {
        return `[${this.toJSON().join(", ")}]`;
      }
    };
    exports2.KeyUsage = KeyUsage;
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/name_constraints.js
var require_name_constraints = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/name_constraints.js"(exports2) {
    "use strict";
    var GeneralSubtrees_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NameConstraints = exports2.GeneralSubtrees = exports2.GeneralSubtree = exports2.id_ce_nameConstraints = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var general_name_1 = require_general_name();
    var object_identifiers_1 = require_object_identifiers();
    exports2.id_ce_nameConstraints = `${object_identifiers_1.id_ce}.30`;
    var GeneralSubtree = class {
      constructor(params = {}) {
        this.base = new general_name_1.GeneralName();
        this.minimum = 0;
        Object.assign(this, params);
      }
    };
    exports2.GeneralSubtree = GeneralSubtree;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: general_name_1.GeneralName })
    ], GeneralSubtree.prototype, "base", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, context: 0, defaultValue: 0, implicit: true })
    ], GeneralSubtree.prototype, "minimum", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, context: 1, optional: true, implicit: true })
    ], GeneralSubtree.prototype, "maximum", void 0);
    var GeneralSubtrees = GeneralSubtrees_1 = class GeneralSubtrees extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, GeneralSubtrees_1.prototype);
      }
    };
    exports2.GeneralSubtrees = GeneralSubtrees;
    exports2.GeneralSubtrees = GeneralSubtrees = GeneralSubtrees_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: GeneralSubtree })
    ], GeneralSubtrees);
    var NameConstraints = class {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.NameConstraints = NameConstraints;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: GeneralSubtrees, context: 0, optional: true, implicit: true })
    ], NameConstraints.prototype, "permittedSubtrees", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: GeneralSubtrees, context: 1, optional: true, implicit: true })
    ], NameConstraints.prototype, "excludedSubtrees", void 0);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/policy_constraints.js
var require_policy_constraints = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/policy_constraints.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PolicyConstraints = exports2.id_ce_policyConstraints = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var object_identifiers_1 = require_object_identifiers();
    exports2.id_ce_policyConstraints = `${object_identifiers_1.id_ce}.36`;
    var PolicyConstraints = class {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.PolicyConstraints = PolicyConstraints;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({
        type: asn1_schema_1.AsnPropTypes.Integer,
        context: 0,
        implicit: true,
        optional: true,
        converter: asn1_schema_1.AsnIntegerArrayBufferConverter
      })
    ], PolicyConstraints.prototype, "requireExplicitPolicy", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({
        type: asn1_schema_1.AsnPropTypes.Integer,
        context: 1,
        implicit: true,
        optional: true,
        converter: asn1_schema_1.AsnIntegerArrayBufferConverter
      })
    ], PolicyConstraints.prototype, "inhibitPolicyMapping", void 0);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/policy_mappings.js
var require_policy_mappings = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/policy_mappings.js"(exports2) {
    "use strict";
    var PolicyMappings_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PolicyMappings = exports2.PolicyMapping = exports2.id_ce_policyMappings = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var object_identifiers_1 = require_object_identifiers();
    exports2.id_ce_policyMappings = `${object_identifiers_1.id_ce}.33`;
    var PolicyMapping = class {
      constructor(params = {}) {
        this.issuerDomainPolicy = "";
        this.subjectDomainPolicy = "";
        Object.assign(this, params);
      }
    };
    exports2.PolicyMapping = PolicyMapping;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], PolicyMapping.prototype, "issuerDomainPolicy", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], PolicyMapping.prototype, "subjectDomainPolicy", void 0);
    var PolicyMappings = PolicyMappings_1 = class PolicyMappings extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, PolicyMappings_1.prototype);
      }
    };
    exports2.PolicyMappings = PolicyMappings;
    exports2.PolicyMappings = PolicyMappings = PolicyMappings_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: PolicyMapping })
    ], PolicyMappings);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/subject_alternative_name.js
var require_subject_alternative_name = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/subject_alternative_name.js"(exports2) {
    "use strict";
    var SubjectAlternativeName_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SubjectAlternativeName = exports2.id_ce_subjectAltName = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var general_names_1 = require_general_names();
    var object_identifiers_1 = require_object_identifiers();
    exports2.id_ce_subjectAltName = `${object_identifiers_1.id_ce}.17`;
    var SubjectAlternativeName = SubjectAlternativeName_1 = class SubjectAlternativeName extends general_names_1.GeneralNames {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, SubjectAlternativeName_1.prototype);
      }
    };
    exports2.SubjectAlternativeName = SubjectAlternativeName;
    exports2.SubjectAlternativeName = SubjectAlternativeName = SubjectAlternativeName_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence })
    ], SubjectAlternativeName);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/attribute.js
var require_attribute = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/attribute.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Attribute = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var Attribute = class {
      constructor(params = {}) {
        this.type = "";
        this.values = [];
        Object.assign(this, params);
      }
    };
    exports2.Attribute = Attribute;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], Attribute.prototype, "type", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Any, repeated: "set" })
    ], Attribute.prototype, "values", void 0);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/subject_directory_attributes.js
var require_subject_directory_attributes = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/subject_directory_attributes.js"(exports2) {
    "use strict";
    var SubjectDirectoryAttributes_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SubjectDirectoryAttributes = exports2.id_ce_subjectDirectoryAttributes = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var attribute_1 = require_attribute();
    var object_identifiers_1 = require_object_identifiers();
    exports2.id_ce_subjectDirectoryAttributes = `${object_identifiers_1.id_ce}.9`;
    var SubjectDirectoryAttributes = SubjectDirectoryAttributes_1 = class SubjectDirectoryAttributes extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, SubjectDirectoryAttributes_1.prototype);
      }
    };
    exports2.SubjectDirectoryAttributes = SubjectDirectoryAttributes;
    exports2.SubjectDirectoryAttributes = SubjectDirectoryAttributes = SubjectDirectoryAttributes_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: attribute_1.Attribute })
    ], SubjectDirectoryAttributes);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/subject_key_identifier.js
var require_subject_key_identifier = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/subject_key_identifier.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SubjectKeyIdentifier = exports2.id_ce_subjectKeyIdentifier = void 0;
    var object_identifiers_1 = require_object_identifiers();
    var authority_key_identifier_1 = require_authority_key_identifier();
    exports2.id_ce_subjectKeyIdentifier = `${object_identifiers_1.id_ce}.14`;
    var SubjectKeyIdentifier = class extends authority_key_identifier_1.KeyIdentifier {
    };
    exports2.SubjectKeyIdentifier = SubjectKeyIdentifier;
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/private_key_usage_period.js
var require_private_key_usage_period = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/private_key_usage_period.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PrivateKeyUsagePeriod = exports2.id_ce_privateKeyUsagePeriod = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var object_identifiers_1 = require_object_identifiers();
    exports2.id_ce_privateKeyUsagePeriod = `${object_identifiers_1.id_ce}.16`;
    var PrivateKeyUsagePeriod = class {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.PrivateKeyUsagePeriod = PrivateKeyUsagePeriod;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.GeneralizedTime, context: 0, implicit: true, optional: true })
    ], PrivateKeyUsagePeriod.prototype, "notBefore", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.GeneralizedTime, context: 1, implicit: true, optional: true })
    ], PrivateKeyUsagePeriod.prototype, "notAfter", void 0);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/entrust_version_info.js
var require_entrust_version_info = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/entrust_version_info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EntrustVersionInfo = exports2.EntrustInfo = exports2.EntrustInfoFlags = exports2.id_entrust_entrustVersInfo = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    exports2.id_entrust_entrustVersInfo = "1.2.840.113533.7.65.0";
    var EntrustInfoFlags;
    (function(EntrustInfoFlags2) {
      EntrustInfoFlags2[EntrustInfoFlags2["keyUpdateAllowed"] = 1] = "keyUpdateAllowed";
      EntrustInfoFlags2[EntrustInfoFlags2["newExtensions"] = 2] = "newExtensions";
      EntrustInfoFlags2[EntrustInfoFlags2["pKIXCertificate"] = 4] = "pKIXCertificate";
    })(EntrustInfoFlags || (exports2.EntrustInfoFlags = EntrustInfoFlags = {}));
    var EntrustInfo = class extends asn1_schema_1.BitString {
      toJSON() {
        const res = [];
        const flags = this.toNumber();
        if (flags & EntrustInfoFlags.pKIXCertificate) {
          res.push("pKIXCertificate");
        }
        if (flags & EntrustInfoFlags.newExtensions) {
          res.push("newExtensions");
        }
        if (flags & EntrustInfoFlags.keyUpdateAllowed) {
          res.push("keyUpdateAllowed");
        }
        return res;
      }
      toString() {
        return `[${this.toJSON().join(", ")}]`;
      }
    };
    exports2.EntrustInfo = EntrustInfo;
    var EntrustVersionInfo = class {
      constructor(params = {}) {
        this.entrustVers = "";
        this.entrustInfoFlags = new EntrustInfo();
        Object.assign(this, params);
      }
    };
    exports2.EntrustVersionInfo = EntrustVersionInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.GeneralString })
    ], EntrustVersionInfo.prototype, "entrustVers", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: EntrustInfo })
    ], EntrustVersionInfo.prototype, "entrustInfoFlags", void 0);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/subject_info_access.js
var require_subject_info_access = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/subject_info_access.js"(exports2) {
    "use strict";
    var SubjectInfoAccessSyntax_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SubjectInfoAccessSyntax = exports2.id_pe_subjectInfoAccess = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var object_identifiers_1 = require_object_identifiers();
    var authority_information_access_1 = require_authority_information_access();
    exports2.id_pe_subjectInfoAccess = `${object_identifiers_1.id_pe}.11`;
    var SubjectInfoAccessSyntax = SubjectInfoAccessSyntax_1 = class SubjectInfoAccessSyntax extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, SubjectInfoAccessSyntax_1.prototype);
      }
    };
    exports2.SubjectInfoAccessSyntax = SubjectInfoAccessSyntax;
    exports2.SubjectInfoAccessSyntax = SubjectInfoAccessSyntax = SubjectInfoAccessSyntax_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: authority_information_access_1.AccessDescription })
    ], SubjectInfoAccessSyntax);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extensions/index.js
var require_extensions = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extensions/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    tslib_1.__exportStar(require_authority_information_access(), exports2);
    tslib_1.__exportStar(require_authority_key_identifier(), exports2);
    tslib_1.__exportStar(require_basic_constraints(), exports2);
    tslib_1.__exportStar(require_certificate_issuer(), exports2);
    tslib_1.__exportStar(require_certificate_policies(), exports2);
    tslib_1.__exportStar(require_crl_delta_indicator(), exports2);
    tslib_1.__exportStar(require_crl_distribution_points(), exports2);
    tslib_1.__exportStar(require_crl_freshest(), exports2);
    tslib_1.__exportStar(require_crl_issuing_distribution_point(), exports2);
    tslib_1.__exportStar(require_crl_number(), exports2);
    tslib_1.__exportStar(require_crl_reason(), exports2);
    tslib_1.__exportStar(require_extended_key_usage(), exports2);
    tslib_1.__exportStar(require_inhibit_any_policy(), exports2);
    tslib_1.__exportStar(require_invalidity_date(), exports2);
    tslib_1.__exportStar(require_issuer_alternative_name(), exports2);
    tslib_1.__exportStar(require_key_usage(), exports2);
    tslib_1.__exportStar(require_name_constraints(), exports2);
    tslib_1.__exportStar(require_policy_constraints(), exports2);
    tslib_1.__exportStar(require_policy_mappings(), exports2);
    tslib_1.__exportStar(require_subject_alternative_name(), exports2);
    tslib_1.__exportStar(require_subject_directory_attributes(), exports2);
    tslib_1.__exportStar(require_subject_key_identifier(), exports2);
    tslib_1.__exportStar(require_private_key_usage_period(), exports2);
    tslib_1.__exportStar(require_entrust_version_info(), exports2);
    tslib_1.__exportStar(require_subject_info_access(), exports2);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/algorithm_identifier.js
var require_algorithm_identifier = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/algorithm_identifier.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AlgorithmIdentifier = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var pvtsutils = require_build3();
    var AlgorithmIdentifier = class _AlgorithmIdentifier {
      constructor(params = {}) {
        this.algorithm = "";
        Object.assign(this, params);
      }
      isEqual(data) {
        return data instanceof _AlgorithmIdentifier && data.algorithm == this.algorithm && (data.parameters && this.parameters && pvtsutils.isEqual(data.parameters, this.parameters) || data.parameters === this.parameters);
      }
    };
    exports2.AlgorithmIdentifier = AlgorithmIdentifier;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({
        type: asn1_schema_1.AsnPropTypes.ObjectIdentifier
      })
    ], AlgorithmIdentifier.prototype, "algorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({
        type: asn1_schema_1.AsnPropTypes.Any,
        optional: true
      })
    ], AlgorithmIdentifier.prototype, "parameters", void 0);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/subject_public_key_info.js
var require_subject_public_key_info = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/subject_public_key_info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SubjectPublicKeyInfo = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var algorithm_identifier_1 = require_algorithm_identifier();
    var SubjectPublicKeyInfo = class {
      constructor(params = {}) {
        this.algorithm = new algorithm_identifier_1.AlgorithmIdentifier();
        this.subjectPublicKey = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.SubjectPublicKeyInfo = SubjectPublicKeyInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: algorithm_identifier_1.AlgorithmIdentifier })
    ], SubjectPublicKeyInfo.prototype, "algorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.BitString })
    ], SubjectPublicKeyInfo.prototype, "subjectPublicKey", void 0);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/time.js
var require_time = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/time.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Time = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var Time = class Time {
      constructor(time) {
        if (time) {
          if (typeof time === "string" || typeof time === "number" || time instanceof Date) {
            const date = new Date(time);
            if (date.getUTCFullYear() > 2049) {
              this.generalTime = date;
            } else {
              this.utcTime = date;
            }
          } else {
            Object.assign(this, time);
          }
        }
      }
      getTime() {
        const time = this.utcTime || this.generalTime;
        if (!time) {
          throw new Error("Cannot get time from CHOICE object");
        }
        return time;
      }
    };
    exports2.Time = Time;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({
        type: asn1_schema_1.AsnPropTypes.UTCTime
      })
    ], Time.prototype, "utcTime", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({
        type: asn1_schema_1.AsnPropTypes.GeneralizedTime
      })
    ], Time.prototype, "generalTime", void 0);
    exports2.Time = Time = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], Time);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/validity.js
var require_validity = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/validity.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Validity = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var time_1 = require_time();
    var Validity = class {
      constructor(params) {
        this.notBefore = new time_1.Time(/* @__PURE__ */ new Date());
        this.notAfter = new time_1.Time(/* @__PURE__ */ new Date());
        if (params) {
          this.notBefore = new time_1.Time(params.notBefore);
          this.notAfter = new time_1.Time(params.notAfter);
        }
      }
    };
    exports2.Validity = Validity;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: time_1.Time })
    ], Validity.prototype, "notBefore", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: time_1.Time })
    ], Validity.prototype, "notAfter", void 0);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/extension.js
var require_extension3 = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/extension.js"(exports2) {
    "use strict";
    var Extensions_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Extensions = exports2.Extension = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var Extension = class _Extension {
      constructor(params = {}) {
        this.extnID = "";
        this.critical = _Extension.CRITICAL;
        this.extnValue = new asn1_schema_1.OctetString();
        Object.assign(this, params);
      }
    };
    exports2.Extension = Extension;
    Extension.CRITICAL = false;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], Extension.prototype, "extnID", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({
        type: asn1_schema_1.AsnPropTypes.Boolean,
        defaultValue: Extension.CRITICAL
      })
    ], Extension.prototype, "critical", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.OctetString })
    ], Extension.prototype, "extnValue", void 0);
    var Extensions = Extensions_1 = class Extensions extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, Extensions_1.prototype);
      }
    };
    exports2.Extensions = Extensions;
    exports2.Extensions = Extensions = Extensions_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: Extension })
    ], Extensions);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/types.js
var require_types3 = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Version = void 0;
    var Version;
    (function(Version2) {
      Version2[Version2["v1"] = 0] = "v1";
      Version2[Version2["v2"] = 1] = "v2";
      Version2[Version2["v3"] = 2] = "v3";
    })(Version || (exports2.Version = Version = {}));
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/tbs_certificate.js
var require_tbs_certificate = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/tbs_certificate.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.TBSCertificate = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var algorithm_identifier_1 = require_algorithm_identifier();
    var name_1 = require_name();
    var subject_public_key_info_1 = require_subject_public_key_info();
    var validity_1 = require_validity();
    var extension_1 = require_extension3();
    var types_1 = require_types3();
    var TBSCertificate = class {
      constructor(params = {}) {
        this.version = types_1.Version.v1;
        this.serialNumber = new ArrayBuffer(0);
        this.signature = new algorithm_identifier_1.AlgorithmIdentifier();
        this.issuer = new name_1.Name();
        this.validity = new validity_1.Validity();
        this.subject = new name_1.Name();
        this.subjectPublicKeyInfo = new subject_public_key_info_1.SubjectPublicKeyInfo();
        Object.assign(this, params);
      }
    };
    exports2.TBSCertificate = TBSCertificate;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({
        type: asn1_schema_1.AsnPropTypes.Integer,
        context: 0,
        defaultValue: types_1.Version.v1
      })
    ], TBSCertificate.prototype, "version", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({
        type: asn1_schema_1.AsnPropTypes.Integer,
        converter: asn1_schema_1.AsnIntegerArrayBufferConverter
      })
    ], TBSCertificate.prototype, "serialNumber", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: algorithm_identifier_1.AlgorithmIdentifier })
    ], TBSCertificate.prototype, "signature", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: name_1.Name })
    ], TBSCertificate.prototype, "issuer", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: validity_1.Validity })
    ], TBSCertificate.prototype, "validity", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: name_1.Name })
    ], TBSCertificate.prototype, "subject", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: subject_public_key_info_1.SubjectPublicKeyInfo })
    ], TBSCertificate.prototype, "subjectPublicKeyInfo", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({
        type: asn1_schema_1.AsnPropTypes.BitString,
        context: 1,
        implicit: true,
        optional: true
      })
    ], TBSCertificate.prototype, "issuerUniqueID", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.BitString, context: 2, implicit: true, optional: true })
    ], TBSCertificate.prototype, "subjectUniqueID", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: extension_1.Extensions, context: 3, optional: true })
    ], TBSCertificate.prototype, "extensions", void 0);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/certificate.js
var require_certificate = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/certificate.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Certificate = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var algorithm_identifier_1 = require_algorithm_identifier();
    var tbs_certificate_1 = require_tbs_certificate();
    var Certificate = class {
      constructor(params = {}) {
        this.tbsCertificate = new tbs_certificate_1.TBSCertificate();
        this.signatureAlgorithm = new algorithm_identifier_1.AlgorithmIdentifier();
        this.signatureValue = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.Certificate = Certificate;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: tbs_certificate_1.TBSCertificate })
    ], Certificate.prototype, "tbsCertificate", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: algorithm_identifier_1.AlgorithmIdentifier })
    ], Certificate.prototype, "signatureAlgorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.BitString })
    ], Certificate.prototype, "signatureValue", void 0);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/tbs_cert_list.js
var require_tbs_cert_list = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/tbs_cert_list.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.TBSCertList = exports2.RevokedCertificate = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var algorithm_identifier_1 = require_algorithm_identifier();
    var name_1 = require_name();
    var time_1 = require_time();
    var extension_1 = require_extension3();
    var RevokedCertificate = class {
      constructor(params = {}) {
        this.userCertificate = new ArrayBuffer(0);
        this.revocationDate = new time_1.Time();
        Object.assign(this, params);
      }
    };
    exports2.RevokedCertificate = RevokedCertificate;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, converter: asn1_schema_1.AsnIntegerArrayBufferConverter })
    ], RevokedCertificate.prototype, "userCertificate", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: time_1.Time })
    ], RevokedCertificate.prototype, "revocationDate", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: extension_1.Extension, optional: true, repeated: "sequence" })
    ], RevokedCertificate.prototype, "crlEntryExtensions", void 0);
    var TBSCertList = class {
      constructor(params = {}) {
        this.signature = new algorithm_identifier_1.AlgorithmIdentifier();
        this.issuer = new name_1.Name();
        this.thisUpdate = new time_1.Time();
        Object.assign(this, params);
      }
    };
    exports2.TBSCertList = TBSCertList;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, optional: true })
    ], TBSCertList.prototype, "version", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: algorithm_identifier_1.AlgorithmIdentifier })
    ], TBSCertList.prototype, "signature", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: name_1.Name })
    ], TBSCertList.prototype, "issuer", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: time_1.Time })
    ], TBSCertList.prototype, "thisUpdate", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: time_1.Time, optional: true })
    ], TBSCertList.prototype, "nextUpdate", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: RevokedCertificate, repeated: "sequence", optional: true })
    ], TBSCertList.prototype, "revokedCertificates", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: extension_1.Extension, optional: true, context: 0, repeated: "sequence" })
    ], TBSCertList.prototype, "crlExtensions", void 0);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/certificate_list.js
var require_certificate_list = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/certificate_list.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.CertificateList = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var algorithm_identifier_1 = require_algorithm_identifier();
    var tbs_cert_list_1 = require_tbs_cert_list();
    var CertificateList = class {
      constructor(params = {}) {
        this.tbsCertList = new tbs_cert_list_1.TBSCertList();
        this.signatureAlgorithm = new algorithm_identifier_1.AlgorithmIdentifier();
        this.signature = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.CertificateList = CertificateList;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: tbs_cert_list_1.TBSCertList })
    ], CertificateList.prototype, "tbsCertList", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: algorithm_identifier_1.AlgorithmIdentifier })
    ], CertificateList.prototype, "signatureAlgorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.BitString })
    ], CertificateList.prototype, "signature", void 0);
  }
});

// node_modules/@peculiar/asn1-x509/build/cjs/index.js
var require_cjs3 = __commonJS({
  "node_modules/@peculiar/asn1-x509/build/cjs/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    tslib_1.__exportStar(require_extensions(), exports2);
    tslib_1.__exportStar(require_algorithm_identifier(), exports2);
    tslib_1.__exportStar(require_attribute(), exports2);
    tslib_1.__exportStar(require_certificate(), exports2);
    tslib_1.__exportStar(require_certificate_list(), exports2);
    tslib_1.__exportStar(require_extension3(), exports2);
    tslib_1.__exportStar(require_general_name(), exports2);
    tslib_1.__exportStar(require_general_names(), exports2);
    tslib_1.__exportStar(require_name(), exports2);
    tslib_1.__exportStar(require_object_identifiers(), exports2);
    tslib_1.__exportStar(require_subject_public_key_info(), exports2);
    tslib_1.__exportStar(require_tbs_cert_list(), exports2);
    tslib_1.__exportStar(require_tbs_certificate(), exports2);
    tslib_1.__exportStar(require_time(), exports2);
    tslib_1.__exportStar(require_types3(), exports2);
    tslib_1.__exportStar(require_validity(), exports2);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/issuer_and_serial_number.js
var require_issuer_and_serial_number = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/issuer_and_serial_number.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.IssuerAndSerialNumber = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    var IssuerAndSerialNumber = class {
      constructor(params = {}) {
        this.issuer = new asn1_x509_1.Name();
        this.serialNumber = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.IssuerAndSerialNumber = IssuerAndSerialNumber;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.Name })
    ], IssuerAndSerialNumber.prototype, "issuer", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, converter: asn1_schema_1.AsnIntegerArrayBufferConverter })
    ], IssuerAndSerialNumber.prototype, "serialNumber", void 0);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/signer_identifier.js
var require_signer_identifier = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/signer_identifier.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SignerIdentifier = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var issuer_and_serial_number_1 = require_issuer_and_serial_number();
    var asn1_x509_1 = require_cjs3();
    var SignerIdentifier = class SignerIdentifier {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.SignerIdentifier = SignerIdentifier;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.SubjectKeyIdentifier, context: 0, implicit: true })
    ], SignerIdentifier.prototype, "subjectKeyIdentifier", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: issuer_and_serial_number_1.IssuerAndSerialNumber })
    ], SignerIdentifier.prototype, "issuerAndSerialNumber", void 0);
    exports2.SignerIdentifier = SignerIdentifier = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], SignerIdentifier);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/types.js
var require_types4 = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.KeyDerivationAlgorithmIdentifier = exports2.MessageAuthenticationCodeAlgorithm = exports2.ContentEncryptionAlgorithmIdentifier = exports2.KeyEncryptionAlgorithmIdentifier = exports2.SignatureAlgorithmIdentifier = exports2.DigestAlgorithmIdentifier = exports2.CMSVersion = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_x509_1 = require_cjs3();
    var asn1_schema_1 = require_cjs2();
    var CMSVersion;
    (function(CMSVersion2) {
      CMSVersion2[CMSVersion2["v0"] = 0] = "v0";
      CMSVersion2[CMSVersion2["v1"] = 1] = "v1";
      CMSVersion2[CMSVersion2["v2"] = 2] = "v2";
      CMSVersion2[CMSVersion2["v3"] = 3] = "v3";
      CMSVersion2[CMSVersion2["v4"] = 4] = "v4";
      CMSVersion2[CMSVersion2["v5"] = 5] = "v5";
    })(CMSVersion || (exports2.CMSVersion = CMSVersion = {}));
    var DigestAlgorithmIdentifier = class DigestAlgorithmIdentifier extends asn1_x509_1.AlgorithmIdentifier {
    };
    exports2.DigestAlgorithmIdentifier = DigestAlgorithmIdentifier;
    exports2.DigestAlgorithmIdentifier = DigestAlgorithmIdentifier = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence })
    ], DigestAlgorithmIdentifier);
    var SignatureAlgorithmIdentifier = class SignatureAlgorithmIdentifier extends asn1_x509_1.AlgorithmIdentifier {
    };
    exports2.SignatureAlgorithmIdentifier = SignatureAlgorithmIdentifier;
    exports2.SignatureAlgorithmIdentifier = SignatureAlgorithmIdentifier = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence })
    ], SignatureAlgorithmIdentifier);
    var KeyEncryptionAlgorithmIdentifier = class KeyEncryptionAlgorithmIdentifier extends asn1_x509_1.AlgorithmIdentifier {
    };
    exports2.KeyEncryptionAlgorithmIdentifier = KeyEncryptionAlgorithmIdentifier;
    exports2.KeyEncryptionAlgorithmIdentifier = KeyEncryptionAlgorithmIdentifier = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence })
    ], KeyEncryptionAlgorithmIdentifier);
    var ContentEncryptionAlgorithmIdentifier = class ContentEncryptionAlgorithmIdentifier extends asn1_x509_1.AlgorithmIdentifier {
    };
    exports2.ContentEncryptionAlgorithmIdentifier = ContentEncryptionAlgorithmIdentifier;
    exports2.ContentEncryptionAlgorithmIdentifier = ContentEncryptionAlgorithmIdentifier = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence })
    ], ContentEncryptionAlgorithmIdentifier);
    var MessageAuthenticationCodeAlgorithm = class MessageAuthenticationCodeAlgorithm extends asn1_x509_1.AlgorithmIdentifier {
    };
    exports2.MessageAuthenticationCodeAlgorithm = MessageAuthenticationCodeAlgorithm;
    exports2.MessageAuthenticationCodeAlgorithm = MessageAuthenticationCodeAlgorithm = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence })
    ], MessageAuthenticationCodeAlgorithm);
    var KeyDerivationAlgorithmIdentifier = class KeyDerivationAlgorithmIdentifier extends asn1_x509_1.AlgorithmIdentifier {
    };
    exports2.KeyDerivationAlgorithmIdentifier = KeyDerivationAlgorithmIdentifier;
    exports2.KeyDerivationAlgorithmIdentifier = KeyDerivationAlgorithmIdentifier = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence })
    ], KeyDerivationAlgorithmIdentifier);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/attribute.js
var require_attribute2 = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/attribute.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Attribute = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var Attribute = class {
      constructor(params = {}) {
        this.attrType = "";
        this.attrValues = [];
        Object.assign(this, params);
      }
    };
    exports2.Attribute = Attribute;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], Attribute.prototype, "attrType", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Any, repeated: "set" })
    ], Attribute.prototype, "attrValues", void 0);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/signer_info.js
var require_signer_info = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/signer_info.js"(exports2) {
    "use strict";
    var SignerInfos_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SignerInfos = exports2.SignerInfo = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var signer_identifier_1 = require_signer_identifier();
    var types_1 = require_types4();
    var attribute_1 = require_attribute2();
    var SignerInfo = class {
      constructor(params = {}) {
        this.version = types_1.CMSVersion.v0;
        this.sid = new signer_identifier_1.SignerIdentifier();
        this.digestAlgorithm = new types_1.DigestAlgorithmIdentifier();
        this.signatureAlgorithm = new types_1.SignatureAlgorithmIdentifier();
        this.signature = new asn1_schema_1.OctetString();
        Object.assign(this, params);
      }
    };
    exports2.SignerInfo = SignerInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer })
    ], SignerInfo.prototype, "version", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: signer_identifier_1.SignerIdentifier })
    ], SignerInfo.prototype, "sid", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: types_1.DigestAlgorithmIdentifier })
    ], SignerInfo.prototype, "digestAlgorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: attribute_1.Attribute, repeated: "set", context: 0, implicit: true, optional: true })
    ], SignerInfo.prototype, "signedAttrs", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: types_1.SignatureAlgorithmIdentifier })
    ], SignerInfo.prototype, "signatureAlgorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.OctetString })
    ], SignerInfo.prototype, "signature", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: attribute_1.Attribute, repeated: "set", context: 1, implicit: true, optional: true })
    ], SignerInfo.prototype, "unsignedAttrs", void 0);
    var SignerInfos = SignerInfos_1 = class SignerInfos extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, SignerInfos_1.prototype);
      }
    };
    exports2.SignerInfos = SignerInfos;
    exports2.SignerInfos = SignerInfos = SignerInfos_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Set, itemType: SignerInfo })
    ], SignerInfos);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/attributes.js
var require_attributes = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/attributes.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.CounterSignature = exports2.SigningTime = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    var signer_info_1 = require_signer_info();
    var SigningTime = class SigningTime extends asn1_x509_1.Time {
    };
    SigningTime = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], SigningTime);
    exports2.SigningTime = SigningTime;
    var CounterSignature = class CounterSignature extends signer_info_1.SignerInfo {
    };
    CounterSignature = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence })
    ], CounterSignature);
    exports2.CounterSignature = CounterSignature;
  }
});

// node_modules/@peculiar/asn1-x509-attr/build/cjs/aa_clear_attrs.js
var require_aa_clear_attrs = __commonJS({
  "node_modules/@peculiar/asn1-x509-attr/build/cjs/aa_clear_attrs.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ACClearAttrs = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    var ACClearAttrs = class {
      constructor(params = {}) {
        this.acIssuer = new asn1_x509_1.GeneralName();
        this.acSerial = 0;
        this.attrs = [];
        Object.assign(this, params);
      }
    };
    exports2.ACClearAttrs = ACClearAttrs;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.GeneralName })
    ], ACClearAttrs.prototype, "acIssuer", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer })
    ], ACClearAttrs.prototype, "acSerial", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.Attribute, repeated: "sequence" })
    ], ACClearAttrs.prototype, "attrs", void 0);
  }
});

// node_modules/@peculiar/asn1-x509-attr/build/cjs/attr_spec.js
var require_attr_spec = __commonJS({
  "node_modules/@peculiar/asn1-x509-attr/build/cjs/attr_spec.js"(exports2) {
    "use strict";
    var AttrSpec_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AttrSpec = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var AttrSpec = AttrSpec_1 = class AttrSpec extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, AttrSpec_1.prototype);
      }
    };
    exports2.AttrSpec = AttrSpec;
    exports2.AttrSpec = AttrSpec = AttrSpec_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], AttrSpec);
  }
});

// node_modules/@peculiar/asn1-x509-attr/build/cjs/aa_controls.js
var require_aa_controls = __commonJS({
  "node_modules/@peculiar/asn1-x509-attr/build/cjs/aa_controls.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AAControls = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var attr_spec_1 = require_attr_spec();
    var AAControls = class {
      constructor(params = {}) {
        this.permitUnSpecified = true;
        Object.assign(this, params);
      }
    };
    exports2.AAControls = AAControls;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, optional: true })
    ], AAControls.prototype, "pathLenConstraint", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: attr_spec_1.AttrSpec, implicit: true, context: 0, optional: true })
    ], AAControls.prototype, "permittedAttrs", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: attr_spec_1.AttrSpec, implicit: true, context: 1, optional: true })
    ], AAControls.prototype, "excludedAttrs", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Boolean, defaultValue: true })
    ], AAControls.prototype, "permitUnSpecified", void 0);
  }
});

// node_modules/@peculiar/asn1-x509-attr/build/cjs/issuer_serial.js
var require_issuer_serial = __commonJS({
  "node_modules/@peculiar/asn1-x509-attr/build/cjs/issuer_serial.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.IssuerSerial = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    var IssuerSerial = class {
      constructor(params = {}) {
        this.issuer = new asn1_x509_1.GeneralNames();
        this.serial = new ArrayBuffer(0);
        this.issuerUID = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.IssuerSerial = IssuerSerial;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.GeneralNames })
    ], IssuerSerial.prototype, "issuer", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, converter: asn1_schema_1.AsnIntegerArrayBufferConverter })
    ], IssuerSerial.prototype, "serial", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.BitString, optional: true })
    ], IssuerSerial.prototype, "issuerUID", void 0);
  }
});

// node_modules/@peculiar/asn1-x509-attr/build/cjs/object_digest_info.js
var require_object_digest_info = __commonJS({
  "node_modules/@peculiar/asn1-x509-attr/build/cjs/object_digest_info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ObjectDigestInfo = exports2.DigestedObjectType = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    var DigestedObjectType;
    (function(DigestedObjectType2) {
      DigestedObjectType2[DigestedObjectType2["publicKey"] = 0] = "publicKey";
      DigestedObjectType2[DigestedObjectType2["publicKeyCert"] = 1] = "publicKeyCert";
      DigestedObjectType2[DigestedObjectType2["otherObjectTypes"] = 2] = "otherObjectTypes";
    })(DigestedObjectType || (exports2.DigestedObjectType = DigestedObjectType = {}));
    var ObjectDigestInfo = class {
      constructor(params = {}) {
        this.digestedObjectType = DigestedObjectType.publicKey;
        this.digestAlgorithm = new asn1_x509_1.AlgorithmIdentifier();
        this.objectDigest = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.ObjectDigestInfo = ObjectDigestInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Enumerated })
    ], ObjectDigestInfo.prototype, "digestedObjectType", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier, optional: true })
    ], ObjectDigestInfo.prototype, "otherObjectTypeID", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.AlgorithmIdentifier })
    ], ObjectDigestInfo.prototype, "digestAlgorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.BitString })
    ], ObjectDigestInfo.prototype, "objectDigest", void 0);
  }
});

// node_modules/@peculiar/asn1-x509-attr/build/cjs/v2_form.js
var require_v2_form = __commonJS({
  "node_modules/@peculiar/asn1-x509-attr/build/cjs/v2_form.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.V2Form = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    var issuer_serial_1 = require_issuer_serial();
    var object_digest_info_1 = require_object_digest_info();
    var V2Form = class {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.V2Form = V2Form;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.GeneralNames, optional: true })
    ], V2Form.prototype, "issuerName", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: issuer_serial_1.IssuerSerial, context: 0, implicit: true, optional: true })
    ], V2Form.prototype, "baseCertificateID", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: object_digest_info_1.ObjectDigestInfo, context: 1, implicit: true, optional: true })
    ], V2Form.prototype, "objectDigestInfo", void 0);
  }
});

// node_modules/@peculiar/asn1-x509-attr/build/cjs/attr_cert_issuer.js
var require_attr_cert_issuer = __commonJS({
  "node_modules/@peculiar/asn1-x509-attr/build/cjs/attr_cert_issuer.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AttCertIssuer = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    var v2_form_1 = require_v2_form();
    var AttCertIssuer = class AttCertIssuer {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.AttCertIssuer = AttCertIssuer;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.GeneralName, repeated: "sequence" })
    ], AttCertIssuer.prototype, "v1Form", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: v2_form_1.V2Form, context: 0, implicit: true })
    ], AttCertIssuer.prototype, "v2Form", void 0);
    exports2.AttCertIssuer = AttCertIssuer = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], AttCertIssuer);
  }
});

// node_modules/@peculiar/asn1-x509-attr/build/cjs/attr_cert_validity_period.js
var require_attr_cert_validity_period = __commonJS({
  "node_modules/@peculiar/asn1-x509-attr/build/cjs/attr_cert_validity_period.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AttCertValidityPeriod = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var AttCertValidityPeriod = class {
      constructor(params = {}) {
        this.notBeforeTime = /* @__PURE__ */ new Date();
        this.notAfterTime = /* @__PURE__ */ new Date();
        Object.assign(this, params);
      }
    };
    exports2.AttCertValidityPeriod = AttCertValidityPeriod;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.GeneralizedTime })
    ], AttCertValidityPeriod.prototype, "notBeforeTime", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.GeneralizedTime })
    ], AttCertValidityPeriod.prototype, "notAfterTime", void 0);
  }
});

// node_modules/@peculiar/asn1-x509-attr/build/cjs/holder.js
var require_holder = __commonJS({
  "node_modules/@peculiar/asn1-x509-attr/build/cjs/holder.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Holder = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var issuer_serial_1 = require_issuer_serial();
    var asn1_x509_1 = require_cjs3();
    var object_digest_info_1 = require_object_digest_info();
    var Holder = class {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.Holder = Holder;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: issuer_serial_1.IssuerSerial, implicit: true, context: 0, optional: true })
    ], Holder.prototype, "baseCertificateID", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.GeneralNames, implicit: true, context: 1, optional: true })
    ], Holder.prototype, "entityName", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: object_digest_info_1.ObjectDigestInfo, implicit: true, context: 2, optional: true })
    ], Holder.prototype, "objectDigestInfo", void 0);
  }
});

// node_modules/@peculiar/asn1-x509-attr/build/cjs/attribute_certificate_info.js
var require_attribute_certificate_info = __commonJS({
  "node_modules/@peculiar/asn1-x509-attr/build/cjs/attribute_certificate_info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AttributeCertificateInfo = exports2.AttCertVersion = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    var holder_1 = require_holder();
    var attr_cert_issuer_1 = require_attr_cert_issuer();
    var attr_cert_validity_period_1 = require_attr_cert_validity_period();
    var AttCertVersion;
    (function(AttCertVersion2) {
      AttCertVersion2[AttCertVersion2["v2"] = 1] = "v2";
    })(AttCertVersion || (exports2.AttCertVersion = AttCertVersion = {}));
    var AttributeCertificateInfo = class {
      constructor(params = {}) {
        this.version = AttCertVersion.v2;
        this.holder = new holder_1.Holder();
        this.issuer = new attr_cert_issuer_1.AttCertIssuer();
        this.signature = new asn1_x509_1.AlgorithmIdentifier();
        this.serialNumber = new ArrayBuffer(0);
        this.attrCertValidityPeriod = new attr_cert_validity_period_1.AttCertValidityPeriod();
        this.attributes = [];
        Object.assign(this, params);
      }
    };
    exports2.AttributeCertificateInfo = AttributeCertificateInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer })
    ], AttributeCertificateInfo.prototype, "version", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: holder_1.Holder })
    ], AttributeCertificateInfo.prototype, "holder", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: attr_cert_issuer_1.AttCertIssuer })
    ], AttributeCertificateInfo.prototype, "issuer", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.AlgorithmIdentifier })
    ], AttributeCertificateInfo.prototype, "signature", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, converter: asn1_schema_1.AsnIntegerArrayBufferConverter })
    ], AttributeCertificateInfo.prototype, "serialNumber", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: attr_cert_validity_period_1.AttCertValidityPeriod })
    ], AttributeCertificateInfo.prototype, "attrCertValidityPeriod", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.Attribute, repeated: "sequence" })
    ], AttributeCertificateInfo.prototype, "attributes", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.BitString, optional: true })
    ], AttributeCertificateInfo.prototype, "issuerUniqueID", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.Extensions, optional: true })
    ], AttributeCertificateInfo.prototype, "extensions", void 0);
  }
});

// node_modules/@peculiar/asn1-x509-attr/build/cjs/attribute_certificate.js
var require_attribute_certificate = __commonJS({
  "node_modules/@peculiar/asn1-x509-attr/build/cjs/attribute_certificate.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AttributeCertificate = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    var attribute_certificate_info_1 = require_attribute_certificate_info();
    var AttributeCertificate = class {
      constructor(params = {}) {
        this.acinfo = new attribute_certificate_info_1.AttributeCertificateInfo();
        this.signatureAlgorithm = new asn1_x509_1.AlgorithmIdentifier();
        this.signatureValue = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.AttributeCertificate = AttributeCertificate;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: attribute_certificate_info_1.AttributeCertificateInfo })
    ], AttributeCertificate.prototype, "acinfo", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.AlgorithmIdentifier })
    ], AttributeCertificate.prototype, "signatureAlgorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.BitString })
    ], AttributeCertificate.prototype, "signatureValue", void 0);
  }
});

// node_modules/@peculiar/asn1-x509-attr/build/cjs/class_list.js
var require_class_list = __commonJS({
  "node_modules/@peculiar/asn1-x509-attr/build/cjs/class_list.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ClassList = exports2.ClassListFlags = void 0;
    var asn1_schema_1 = require_cjs2();
    var ClassListFlags;
    (function(ClassListFlags2) {
      ClassListFlags2[ClassListFlags2["unmarked"] = 1] = "unmarked";
      ClassListFlags2[ClassListFlags2["unclassified"] = 2] = "unclassified";
      ClassListFlags2[ClassListFlags2["restricted"] = 4] = "restricted";
      ClassListFlags2[ClassListFlags2["confidential"] = 8] = "confidential";
      ClassListFlags2[ClassListFlags2["secret"] = 16] = "secret";
      ClassListFlags2[ClassListFlags2["topSecret"] = 32] = "topSecret";
    })(ClassListFlags || (exports2.ClassListFlags = ClassListFlags = {}));
    var ClassList = class extends asn1_schema_1.BitString {
    };
    exports2.ClassList = ClassList;
  }
});

// node_modules/@peculiar/asn1-x509-attr/build/cjs/security_category.js
var require_security_category = __commonJS({
  "node_modules/@peculiar/asn1-x509-attr/build/cjs/security_category.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SecurityCategory = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var SecurityCategory = class {
      constructor(params = {}) {
        this.type = "";
        this.value = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.SecurityCategory = SecurityCategory;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier, implicit: true, context: 0 })
    ], SecurityCategory.prototype, "type", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Any, implicit: true, context: 1 })
    ], SecurityCategory.prototype, "value", void 0);
  }
});

// node_modules/@peculiar/asn1-x509-attr/build/cjs/clearance.js
var require_clearance = __commonJS({
  "node_modules/@peculiar/asn1-x509-attr/build/cjs/clearance.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Clearance = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var class_list_1 = require_class_list();
    var security_category_1 = require_security_category();
    var Clearance = class {
      constructor(params = {}) {
        this.policyId = "";
        this.classList = new class_list_1.ClassList(class_list_1.ClassListFlags.unclassified);
        Object.assign(this, params);
      }
    };
    exports2.Clearance = Clearance;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], Clearance.prototype, "policyId", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: class_list_1.ClassList, defaultValue: new class_list_1.ClassList(class_list_1.ClassListFlags.unclassified) })
    ], Clearance.prototype, "classList", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: security_category_1.SecurityCategory, repeated: "set" })
    ], Clearance.prototype, "securityCategories", void 0);
  }
});

// node_modules/@peculiar/asn1-x509-attr/build/cjs/ietf_attr_syntax.js
var require_ietf_attr_syntax = __commonJS({
  "node_modules/@peculiar/asn1-x509-attr/build/cjs/ietf_attr_syntax.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.IetfAttrSyntax = exports2.IetfAttrSyntaxValueChoices = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    var IetfAttrSyntaxValueChoices = class {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.IetfAttrSyntaxValueChoices = IetfAttrSyntaxValueChoices;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.OctetString })
    ], IetfAttrSyntaxValueChoices.prototype, "cotets", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], IetfAttrSyntaxValueChoices.prototype, "oid", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Utf8String })
    ], IetfAttrSyntaxValueChoices.prototype, "string", void 0);
    var IetfAttrSyntax = class {
      constructor(params = {}) {
        this.values = [];
        Object.assign(this, params);
      }
    };
    exports2.IetfAttrSyntax = IetfAttrSyntax;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.GeneralNames, implicit: true, context: 0, optional: true })
    ], IetfAttrSyntax.prototype, "policyAuthority", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: IetfAttrSyntaxValueChoices, repeated: "sequence" })
    ], IetfAttrSyntax.prototype, "values", void 0);
  }
});

// node_modules/@peculiar/asn1-x509-attr/build/cjs/object_identifiers.js
var require_object_identifiers2 = __commonJS({
  "node_modules/@peculiar/asn1-x509-attr/build/cjs/object_identifiers.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.id_at_clearance = exports2.id_at_role = exports2.id_at = exports2.id_aca_encAttrs = exports2.id_aca_group = exports2.id_aca_chargingIdentity = exports2.id_aca_accessIdentity = exports2.id_aca_authenticationInfo = exports2.id_aca = exports2.id_ce_targetInformation = exports2.id_pe_ac_proxying = exports2.id_pe_aaControls = exports2.id_pe_ac_auditIdentity = void 0;
    var asn1_x509_1 = require_cjs3();
    exports2.id_pe_ac_auditIdentity = `${asn1_x509_1.id_pe}.4`;
    exports2.id_pe_aaControls = `${asn1_x509_1.id_pe}.6`;
    exports2.id_pe_ac_proxying = `${asn1_x509_1.id_pe}.10`;
    exports2.id_ce_targetInformation = `${asn1_x509_1.id_ce}.55`;
    exports2.id_aca = `${asn1_x509_1.id_pkix}.10`;
    exports2.id_aca_authenticationInfo = `${exports2.id_aca}.1`;
    exports2.id_aca_accessIdentity = `${exports2.id_aca}.2`;
    exports2.id_aca_chargingIdentity = `${exports2.id_aca}.3`;
    exports2.id_aca_group = `${exports2.id_aca}.4`;
    exports2.id_aca_encAttrs = `${exports2.id_aca}.6`;
    exports2.id_at = "2.5.4";
    exports2.id_at_role = `${exports2.id_at}.72`;
    exports2.id_at_clearance = "2.5.1.5.55";
  }
});

// node_modules/@peculiar/asn1-x509-attr/build/cjs/target.js
var require_target = __commonJS({
  "node_modules/@peculiar/asn1-x509-attr/build/cjs/target.js"(exports2) {
    "use strict";
    var Targets_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Targets = exports2.Target = exports2.TargetCert = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    var issuer_serial_1 = require_issuer_serial();
    var object_digest_info_1 = require_object_digest_info();
    var TargetCert = class {
      constructor(params = {}) {
        this.targetCertificate = new issuer_serial_1.IssuerSerial();
        Object.assign(this, params);
      }
    };
    exports2.TargetCert = TargetCert;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: issuer_serial_1.IssuerSerial })
    ], TargetCert.prototype, "targetCertificate", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.GeneralName, optional: true })
    ], TargetCert.prototype, "targetName", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: object_digest_info_1.ObjectDigestInfo, optional: true })
    ], TargetCert.prototype, "certDigestInfo", void 0);
    var Target = class Target {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.Target = Target;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.GeneralName, context: 0, implicit: true })
    ], Target.prototype, "targetName", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.GeneralName, context: 1, implicit: true })
    ], Target.prototype, "targetGroup", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: TargetCert, context: 2, implicit: true })
    ], Target.prototype, "targetCert", void 0);
    exports2.Target = Target = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], Target);
    var Targets = Targets_1 = class Targets extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, Targets_1.prototype);
      }
    };
    exports2.Targets = Targets;
    exports2.Targets = Targets = Targets_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: Target })
    ], Targets);
  }
});

// node_modules/@peculiar/asn1-x509-attr/build/cjs/proxy_info.js
var require_proxy_info = __commonJS({
  "node_modules/@peculiar/asn1-x509-attr/build/cjs/proxy_info.js"(exports2) {
    "use strict";
    var ProxyInfo_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ProxyInfo = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var target_1 = require_target();
    var ProxyInfo = ProxyInfo_1 = class ProxyInfo extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, ProxyInfo_1.prototype);
      }
    };
    exports2.ProxyInfo = ProxyInfo;
    exports2.ProxyInfo = ProxyInfo = ProxyInfo_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: target_1.Targets })
    ], ProxyInfo);
  }
});

// node_modules/@peculiar/asn1-x509-attr/build/cjs/role_syntax.js
var require_role_syntax = __commonJS({
  "node_modules/@peculiar/asn1-x509-attr/build/cjs/role_syntax.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RoleSyntax = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    var RoleSyntax = class {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.RoleSyntax = RoleSyntax;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.GeneralNames, implicit: true, context: 0, optional: true })
    ], RoleSyntax.prototype, "roleAuthority", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.GeneralName, implicit: true, context: 1 })
    ], RoleSyntax.prototype, "roleName", void 0);
  }
});

// node_modules/@peculiar/asn1-x509-attr/build/cjs/svce_auth_info.js
var require_svce_auth_info = __commonJS({
  "node_modules/@peculiar/asn1-x509-attr/build/cjs/svce_auth_info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SvceAuthInfo = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    var SvceAuthInfo = class {
      constructor(params = {}) {
        this.service = new asn1_x509_1.GeneralName();
        this.ident = new asn1_x509_1.GeneralName();
        Object.assign(this, params);
      }
    };
    exports2.SvceAuthInfo = SvceAuthInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.GeneralName })
    ], SvceAuthInfo.prototype, "service", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.GeneralName })
    ], SvceAuthInfo.prototype, "ident", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.OctetString, optional: true })
    ], SvceAuthInfo.prototype, "authInfo", void 0);
  }
});

// node_modules/@peculiar/asn1-x509-attr/build/cjs/index.js
var require_cjs4 = __commonJS({
  "node_modules/@peculiar/asn1-x509-attr/build/cjs/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    tslib_1.__exportStar(require_aa_clear_attrs(), exports2);
    tslib_1.__exportStar(require_aa_controls(), exports2);
    tslib_1.__exportStar(require_attr_cert_issuer(), exports2);
    tslib_1.__exportStar(require_attr_cert_validity_period(), exports2);
    tslib_1.__exportStar(require_attr_spec(), exports2);
    tslib_1.__exportStar(require_attribute_certificate(), exports2);
    tslib_1.__exportStar(require_attribute_certificate_info(), exports2);
    tslib_1.__exportStar(require_class_list(), exports2);
    tslib_1.__exportStar(require_clearance(), exports2);
    tslib_1.__exportStar(require_holder(), exports2);
    tslib_1.__exportStar(require_ietf_attr_syntax(), exports2);
    tslib_1.__exportStar(require_issuer_serial(), exports2);
    tslib_1.__exportStar(require_object_digest_info(), exports2);
    tslib_1.__exportStar(require_object_identifiers2(), exports2);
    tslib_1.__exportStar(require_proxy_info(), exports2);
    tslib_1.__exportStar(require_role_syntax(), exports2);
    tslib_1.__exportStar(require_security_category(), exports2);
    tslib_1.__exportStar(require_svce_auth_info(), exports2);
    tslib_1.__exportStar(require_target(), exports2);
    tslib_1.__exportStar(require_v2_form(), exports2);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/certificate_choices.js
var require_certificate_choices = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/certificate_choices.js"(exports2) {
    "use strict";
    var CertificateSet_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.CertificateSet = exports2.CertificateChoices = exports2.OtherCertificateFormat = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    var asn1_x509_attr_1 = require_cjs4();
    var OtherCertificateFormat = class {
      constructor(params = {}) {
        this.otherCertFormat = "";
        this.otherCert = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.OtherCertificateFormat = OtherCertificateFormat;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], OtherCertificateFormat.prototype, "otherCertFormat", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Any })
    ], OtherCertificateFormat.prototype, "otherCert", void 0);
    var CertificateChoices = class CertificateChoices {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.CertificateChoices = CertificateChoices;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.Certificate })
    ], CertificateChoices.prototype, "certificate", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_attr_1.AttributeCertificate, context: 2, implicit: true })
    ], CertificateChoices.prototype, "v2AttrCert", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: OtherCertificateFormat, context: 3, implicit: true })
    ], CertificateChoices.prototype, "other", void 0);
    exports2.CertificateChoices = CertificateChoices = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], CertificateChoices);
    var CertificateSet = CertificateSet_1 = class CertificateSet extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, CertificateSet_1.prototype);
      }
    };
    exports2.CertificateSet = CertificateSet;
    exports2.CertificateSet = CertificateSet = CertificateSet_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Set, itemType: CertificateChoices })
    ], CertificateSet);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/content_info.js
var require_content_info = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/content_info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ContentInfo = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var ContentInfo = class {
      constructor(params = {}) {
        this.contentType = "";
        this.content = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.ContentInfo = ContentInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], ContentInfo.prototype, "contentType", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Any, context: 0 })
    ], ContentInfo.prototype, "content", void 0);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/encapsulated_content_info.js
var require_encapsulated_content_info = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/encapsulated_content_info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EncapsulatedContentInfo = exports2.EncapsulatedContent = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var EncapsulatedContent = class EncapsulatedContent {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.EncapsulatedContent = EncapsulatedContent;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.OctetString })
    ], EncapsulatedContent.prototype, "single", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Any })
    ], EncapsulatedContent.prototype, "any", void 0);
    exports2.EncapsulatedContent = EncapsulatedContent = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], EncapsulatedContent);
    var EncapsulatedContentInfo = class {
      constructor(params = {}) {
        this.eContentType = "";
        Object.assign(this, params);
      }
    };
    exports2.EncapsulatedContentInfo = EncapsulatedContentInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], EncapsulatedContentInfo.prototype, "eContentType", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: EncapsulatedContent, context: 0, optional: true })
    ], EncapsulatedContentInfo.prototype, "eContent", void 0);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/encrypted_content_info.js
var require_encrypted_content_info = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/encrypted_content_info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EncryptedContentInfo = exports2.EncryptedContent = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var types_1 = require_types4();
    var EncryptedContent = class EncryptedContent {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.EncryptedContent = EncryptedContent;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.OctetString, context: 0, implicit: true, optional: true })
    ], EncryptedContent.prototype, "value", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.OctetString, converter: asn1_schema_1.AsnConstructedOctetStringConverter, context: 0, implicit: true, optional: true, repeated: "sequence" })
    ], EncryptedContent.prototype, "constructedValue", void 0);
    exports2.EncryptedContent = EncryptedContent = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], EncryptedContent);
    var EncryptedContentInfo = class {
      constructor(params = {}) {
        this.contentType = "";
        this.contentEncryptionAlgorithm = new types_1.ContentEncryptionAlgorithmIdentifier();
        Object.assign(this, params);
      }
    };
    exports2.EncryptedContentInfo = EncryptedContentInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], EncryptedContentInfo.prototype, "contentType", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: types_1.ContentEncryptionAlgorithmIdentifier })
    ], EncryptedContentInfo.prototype, "contentEncryptionAlgorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: EncryptedContent, optional: true })
    ], EncryptedContentInfo.prototype, "encryptedContent", void 0);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/other_key_attribute.js
var require_other_key_attribute = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/other_key_attribute.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OtherKeyAttribute = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var OtherKeyAttribute = class {
      constructor(params = {}) {
        this.keyAttrId = "";
        Object.assign(this, params);
      }
    };
    exports2.OtherKeyAttribute = OtherKeyAttribute;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], OtherKeyAttribute.prototype, "keyAttrId", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Any, optional: true })
    ], OtherKeyAttribute.prototype, "keyAttr", void 0);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/key_agree_recipient_info.js
var require_key_agree_recipient_info = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/key_agree_recipient_info.js"(exports2) {
    "use strict";
    var RecipientEncryptedKeys_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.KeyAgreeRecipientInfo = exports2.OriginatorIdentifierOrKey = exports2.OriginatorPublicKey = exports2.RecipientEncryptedKeys = exports2.RecipientEncryptedKey = exports2.KeyAgreeRecipientIdentifier = exports2.RecipientKeyIdentifier = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var types_1 = require_types4();
    var issuer_and_serial_number_1 = require_issuer_and_serial_number();
    var asn1_x509_1 = require_cjs3();
    var other_key_attribute_1 = require_other_key_attribute();
    var RecipientKeyIdentifier = class {
      constructor(params = {}) {
        this.subjectKeyIdentifier = new asn1_x509_1.SubjectKeyIdentifier();
        Object.assign(this, params);
      }
    };
    exports2.RecipientKeyIdentifier = RecipientKeyIdentifier;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.SubjectKeyIdentifier })
    ], RecipientKeyIdentifier.prototype, "subjectKeyIdentifier", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.GeneralizedTime, optional: true })
    ], RecipientKeyIdentifier.prototype, "date", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: other_key_attribute_1.OtherKeyAttribute, optional: true })
    ], RecipientKeyIdentifier.prototype, "other", void 0);
    var KeyAgreeRecipientIdentifier = class KeyAgreeRecipientIdentifier {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.KeyAgreeRecipientIdentifier = KeyAgreeRecipientIdentifier;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: RecipientKeyIdentifier, context: 0, implicit: true, optional: true })
    ], KeyAgreeRecipientIdentifier.prototype, "rKeyId", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: issuer_and_serial_number_1.IssuerAndSerialNumber, optional: true })
    ], KeyAgreeRecipientIdentifier.prototype, "issuerAndSerialNumber", void 0);
    exports2.KeyAgreeRecipientIdentifier = KeyAgreeRecipientIdentifier = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], KeyAgreeRecipientIdentifier);
    var RecipientEncryptedKey = class {
      constructor(params = {}) {
        this.rid = new KeyAgreeRecipientIdentifier();
        this.encryptedKey = new asn1_schema_1.OctetString();
        Object.assign(this, params);
      }
    };
    exports2.RecipientEncryptedKey = RecipientEncryptedKey;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: KeyAgreeRecipientIdentifier })
    ], RecipientEncryptedKey.prototype, "rid", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.OctetString })
    ], RecipientEncryptedKey.prototype, "encryptedKey", void 0);
    var RecipientEncryptedKeys = RecipientEncryptedKeys_1 = class RecipientEncryptedKeys extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, RecipientEncryptedKeys_1.prototype);
      }
    };
    exports2.RecipientEncryptedKeys = RecipientEncryptedKeys;
    exports2.RecipientEncryptedKeys = RecipientEncryptedKeys = RecipientEncryptedKeys_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: RecipientEncryptedKey })
    ], RecipientEncryptedKeys);
    var OriginatorPublicKey = class {
      constructor(params = {}) {
        this.algorithm = new asn1_x509_1.AlgorithmIdentifier();
        this.publicKey = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.OriginatorPublicKey = OriginatorPublicKey;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.AlgorithmIdentifier })
    ], OriginatorPublicKey.prototype, "algorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.BitString })
    ], OriginatorPublicKey.prototype, "publicKey", void 0);
    var OriginatorIdentifierOrKey = class OriginatorIdentifierOrKey {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.OriginatorIdentifierOrKey = OriginatorIdentifierOrKey;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.SubjectKeyIdentifier, context: 0, implicit: true, optional: true })
    ], OriginatorIdentifierOrKey.prototype, "subjectKeyIdentifier", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: OriginatorPublicKey, context: 1, implicit: true, optional: true })
    ], OriginatorIdentifierOrKey.prototype, "originatorKey", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: issuer_and_serial_number_1.IssuerAndSerialNumber, optional: true })
    ], OriginatorIdentifierOrKey.prototype, "issuerAndSerialNumber", void 0);
    exports2.OriginatorIdentifierOrKey = OriginatorIdentifierOrKey = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], OriginatorIdentifierOrKey);
    var KeyAgreeRecipientInfo = class {
      constructor(params = {}) {
        this.version = types_1.CMSVersion.v3;
        this.originator = new OriginatorIdentifierOrKey();
        this.keyEncryptionAlgorithm = new types_1.KeyEncryptionAlgorithmIdentifier();
        this.recipientEncryptedKeys = new RecipientEncryptedKeys();
        Object.assign(this, params);
      }
    };
    exports2.KeyAgreeRecipientInfo = KeyAgreeRecipientInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer })
    ], KeyAgreeRecipientInfo.prototype, "version", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: OriginatorIdentifierOrKey, context: 0 })
    ], KeyAgreeRecipientInfo.prototype, "originator", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.OctetString, context: 1, optional: true })
    ], KeyAgreeRecipientInfo.prototype, "ukm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: types_1.KeyEncryptionAlgorithmIdentifier })
    ], KeyAgreeRecipientInfo.prototype, "keyEncryptionAlgorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: RecipientEncryptedKeys })
    ], KeyAgreeRecipientInfo.prototype, "recipientEncryptedKeys", void 0);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/key_trans_recipient_info.js
var require_key_trans_recipient_info = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/key_trans_recipient_info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.KeyTransRecipientInfo = exports2.RecipientIdentifier = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var types_1 = require_types4();
    var issuer_and_serial_number_1 = require_issuer_and_serial_number();
    var asn1_x509_1 = require_cjs3();
    var RecipientIdentifier = class RecipientIdentifier {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.RecipientIdentifier = RecipientIdentifier;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.SubjectKeyIdentifier, context: 0, implicit: true })
    ], RecipientIdentifier.prototype, "subjectKeyIdentifier", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: issuer_and_serial_number_1.IssuerAndSerialNumber })
    ], RecipientIdentifier.prototype, "issuerAndSerialNumber", void 0);
    exports2.RecipientIdentifier = RecipientIdentifier = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], RecipientIdentifier);
    var KeyTransRecipientInfo = class {
      constructor(params = {}) {
        this.version = types_1.CMSVersion.v0;
        this.rid = new RecipientIdentifier();
        this.keyEncryptionAlgorithm = new types_1.KeyEncryptionAlgorithmIdentifier();
        this.encryptedKey = new asn1_schema_1.OctetString();
        Object.assign(this, params);
      }
    };
    exports2.KeyTransRecipientInfo = KeyTransRecipientInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer })
    ], KeyTransRecipientInfo.prototype, "version", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: RecipientIdentifier })
    ], KeyTransRecipientInfo.prototype, "rid", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: types_1.KeyEncryptionAlgorithmIdentifier })
    ], KeyTransRecipientInfo.prototype, "keyEncryptionAlgorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.OctetString })
    ], KeyTransRecipientInfo.prototype, "encryptedKey", void 0);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/kek_recipient_info.js
var require_kek_recipient_info = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/kek_recipient_info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.KEKRecipientInfo = exports2.KEKIdentifier = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var other_key_attribute_1 = require_other_key_attribute();
    var types_1 = require_types4();
    var KEKIdentifier = class {
      constructor(params = {}) {
        this.keyIdentifier = new asn1_schema_1.OctetString();
        Object.assign(this, params);
      }
    };
    exports2.KEKIdentifier = KEKIdentifier;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.OctetString })
    ], KEKIdentifier.prototype, "keyIdentifier", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.GeneralizedTime, optional: true })
    ], KEKIdentifier.prototype, "date", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: other_key_attribute_1.OtherKeyAttribute, optional: true })
    ], KEKIdentifier.prototype, "other", void 0);
    var KEKRecipientInfo = class {
      constructor(params = {}) {
        this.version = types_1.CMSVersion.v4;
        this.kekid = new KEKIdentifier();
        this.keyEncryptionAlgorithm = new types_1.KeyEncryptionAlgorithmIdentifier();
        this.encryptedKey = new asn1_schema_1.OctetString();
        Object.assign(this, params);
      }
    };
    exports2.KEKRecipientInfo = KEKRecipientInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer })
    ], KEKRecipientInfo.prototype, "version", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: KEKIdentifier })
    ], KEKRecipientInfo.prototype, "kekid", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: types_1.KeyEncryptionAlgorithmIdentifier })
    ], KEKRecipientInfo.prototype, "keyEncryptionAlgorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.OctetString })
    ], KEKRecipientInfo.prototype, "encryptedKey", void 0);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/password_recipient_info.js
var require_password_recipient_info = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/password_recipient_info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PasswordRecipientInfo = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var types_1 = require_types4();
    var PasswordRecipientInfo = class {
      constructor(params = {}) {
        this.version = types_1.CMSVersion.v0;
        this.keyEncryptionAlgorithm = new types_1.KeyEncryptionAlgorithmIdentifier();
        this.encryptedKey = new asn1_schema_1.OctetString();
        Object.assign(this, params);
      }
    };
    exports2.PasswordRecipientInfo = PasswordRecipientInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer })
    ], PasswordRecipientInfo.prototype, "version", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: types_1.KeyDerivationAlgorithmIdentifier, context: 0, optional: true })
    ], PasswordRecipientInfo.prototype, "keyDerivationAlgorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: types_1.KeyEncryptionAlgorithmIdentifier })
    ], PasswordRecipientInfo.prototype, "keyEncryptionAlgorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.OctetString })
    ], PasswordRecipientInfo.prototype, "encryptedKey", void 0);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/recipient_info.js
var require_recipient_info = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/recipient_info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RecipientInfo = exports2.OtherRecipientInfo = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var key_agree_recipient_info_1 = require_key_agree_recipient_info();
    var key_trans_recipient_info_1 = require_key_trans_recipient_info();
    var kek_recipient_info_1 = require_kek_recipient_info();
    var password_recipient_info_1 = require_password_recipient_info();
    var OtherRecipientInfo = class {
      constructor(params = {}) {
        this.oriType = "";
        this.oriValue = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.OtherRecipientInfo = OtherRecipientInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], OtherRecipientInfo.prototype, "oriType", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Any })
    ], OtherRecipientInfo.prototype, "oriValue", void 0);
    var RecipientInfo = class RecipientInfo {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.RecipientInfo = RecipientInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: key_trans_recipient_info_1.KeyTransRecipientInfo, optional: true })
    ], RecipientInfo.prototype, "ktri", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: key_agree_recipient_info_1.KeyAgreeRecipientInfo, context: 1, implicit: true, optional: true })
    ], RecipientInfo.prototype, "kari", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: kek_recipient_info_1.KEKRecipientInfo, context: 2, implicit: true, optional: true })
    ], RecipientInfo.prototype, "kekri", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: password_recipient_info_1.PasswordRecipientInfo, context: 3, implicit: true, optional: true })
    ], RecipientInfo.prototype, "pwri", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: OtherRecipientInfo, context: 4, implicit: true, optional: true })
    ], RecipientInfo.prototype, "ori", void 0);
    exports2.RecipientInfo = RecipientInfo = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], RecipientInfo);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/recipient_infos.js
var require_recipient_infos = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/recipient_infos.js"(exports2) {
    "use strict";
    var RecipientInfos_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RecipientInfos = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var recipient_info_1 = require_recipient_info();
    var RecipientInfos = RecipientInfos_1 = class RecipientInfos extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, RecipientInfos_1.prototype);
      }
    };
    exports2.RecipientInfos = RecipientInfos;
    exports2.RecipientInfos = RecipientInfos = RecipientInfos_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Set, itemType: recipient_info_1.RecipientInfo })
    ], RecipientInfos);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/revocation_info_choice.js
var require_revocation_info_choice = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/revocation_info_choice.js"(exports2) {
    "use strict";
    var RevocationInfoChoices_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RevocationInfoChoices = exports2.RevocationInfoChoice = exports2.OtherRevocationInfoFormat = exports2.id_ri_scvp = exports2.id_ri_ocsp_response = exports2.id_ri = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    exports2.id_ri = `${asn1_x509_1.id_pkix}.16`;
    exports2.id_ri_ocsp_response = `${exports2.id_ri}.2`;
    exports2.id_ri_scvp = `${exports2.id_ri}.4`;
    var OtherRevocationInfoFormat = class {
      constructor(params = {}) {
        this.otherRevInfoFormat = "";
        this.otherRevInfo = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.OtherRevocationInfoFormat = OtherRevocationInfoFormat;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], OtherRevocationInfoFormat.prototype, "otherRevInfoFormat", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Any })
    ], OtherRevocationInfoFormat.prototype, "otherRevInfo", void 0);
    var RevocationInfoChoice = class RevocationInfoChoice {
      constructor(params = {}) {
        this.other = new OtherRevocationInfoFormat();
        Object.assign(this, params);
      }
    };
    exports2.RevocationInfoChoice = RevocationInfoChoice;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: OtherRevocationInfoFormat, context: 1, implicit: true })
    ], RevocationInfoChoice.prototype, "other", void 0);
    exports2.RevocationInfoChoice = RevocationInfoChoice = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], RevocationInfoChoice);
    var RevocationInfoChoices = RevocationInfoChoices_1 = class RevocationInfoChoices extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, RevocationInfoChoices_1.prototype);
      }
    };
    exports2.RevocationInfoChoices = RevocationInfoChoices;
    exports2.RevocationInfoChoices = RevocationInfoChoices = RevocationInfoChoices_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Set, itemType: RevocationInfoChoice })
    ], RevocationInfoChoices);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/originator_info.js
var require_originator_info = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/originator_info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OriginatorInfo = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var certificate_choices_1 = require_certificate_choices();
    var revocation_info_choice_1 = require_revocation_info_choice();
    var OriginatorInfo = class {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.OriginatorInfo = OriginatorInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: certificate_choices_1.CertificateSet, context: 0, implicit: true, optional: true })
    ], OriginatorInfo.prototype, "certs", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: revocation_info_choice_1.RevocationInfoChoices, context: 1, implicit: true, optional: true })
    ], OriginatorInfo.prototype, "crls", void 0);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/enveloped_data.js
var require_enveloped_data = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/enveloped_data.js"(exports2) {
    "use strict";
    var UnprotectedAttributes_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnvelopedData = exports2.UnprotectedAttributes = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var types_1 = require_types4();
    var attribute_1 = require_attribute2();
    var recipient_infos_1 = require_recipient_infos();
    var originator_info_1 = require_originator_info();
    var encrypted_content_info_1 = require_encrypted_content_info();
    var UnprotectedAttributes = UnprotectedAttributes_1 = class UnprotectedAttributes extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, UnprotectedAttributes_1.prototype);
      }
    };
    exports2.UnprotectedAttributes = UnprotectedAttributes;
    exports2.UnprotectedAttributes = UnprotectedAttributes = UnprotectedAttributes_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Set, itemType: attribute_1.Attribute })
    ], UnprotectedAttributes);
    var EnvelopedData = class {
      constructor(params = {}) {
        this.version = types_1.CMSVersion.v0;
        this.recipientInfos = new recipient_infos_1.RecipientInfos();
        this.encryptedContentInfo = new encrypted_content_info_1.EncryptedContentInfo();
        Object.assign(this, params);
      }
    };
    exports2.EnvelopedData = EnvelopedData;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer })
    ], EnvelopedData.prototype, "version", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: originator_info_1.OriginatorInfo, context: 0, implicit: true, optional: true })
    ], EnvelopedData.prototype, "originatorInfo", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: recipient_infos_1.RecipientInfos })
    ], EnvelopedData.prototype, "recipientInfos", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: encrypted_content_info_1.EncryptedContentInfo })
    ], EnvelopedData.prototype, "encryptedContentInfo", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: UnprotectedAttributes, context: 1, implicit: true, optional: true })
    ], EnvelopedData.prototype, "unprotectedAttrs", void 0);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/object_identifiers.js
var require_object_identifiers3 = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/object_identifiers.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.id_authData = exports2.id_encryptedData = exports2.id_digestedData = exports2.id_envelopedData = exports2.id_signedData = exports2.id_data = exports2.id_ct_contentInfo = void 0;
    exports2.id_ct_contentInfo = "1.2.840.113549.1.9.16.1.6";
    exports2.id_data = "1.2.840.113549.1.7.1";
    exports2.id_signedData = "1.2.840.113549.1.7.2";
    exports2.id_envelopedData = "1.2.840.113549.1.7.3";
    exports2.id_digestedData = "1.2.840.113549.1.7.5";
    exports2.id_encryptedData = "1.2.840.113549.1.7.6";
    exports2.id_authData = "1.2.840.113549.1.9.16.1.2";
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/signed_data.js
var require_signed_data = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/signed_data.js"(exports2) {
    "use strict";
    var DigestAlgorithmIdentifiers_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SignedData = exports2.DigestAlgorithmIdentifiers = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var certificate_choices_1 = require_certificate_choices();
    var types_1 = require_types4();
    var encapsulated_content_info_1 = require_encapsulated_content_info();
    var revocation_info_choice_1 = require_revocation_info_choice();
    var signer_info_1 = require_signer_info();
    var DigestAlgorithmIdentifiers = DigestAlgorithmIdentifiers_1 = class DigestAlgorithmIdentifiers extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, DigestAlgorithmIdentifiers_1.prototype);
      }
    };
    exports2.DigestAlgorithmIdentifiers = DigestAlgorithmIdentifiers;
    exports2.DigestAlgorithmIdentifiers = DigestAlgorithmIdentifiers = DigestAlgorithmIdentifiers_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Set, itemType: types_1.DigestAlgorithmIdentifier })
    ], DigestAlgorithmIdentifiers);
    var SignedData = class {
      constructor(params = {}) {
        this.version = types_1.CMSVersion.v0;
        this.digestAlgorithms = new DigestAlgorithmIdentifiers();
        this.encapContentInfo = new encapsulated_content_info_1.EncapsulatedContentInfo();
        this.signerInfos = new signer_info_1.SignerInfos();
        Object.assign(this, params);
      }
    };
    exports2.SignedData = SignedData;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer })
    ], SignedData.prototype, "version", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: DigestAlgorithmIdentifiers })
    ], SignedData.prototype, "digestAlgorithms", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: encapsulated_content_info_1.EncapsulatedContentInfo })
    ], SignedData.prototype, "encapContentInfo", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: certificate_choices_1.CertificateSet, context: 0, implicit: true, optional: true })
    ], SignedData.prototype, "certificates", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: revocation_info_choice_1.RevocationInfoChoice, context: 1, implicit: true, optional: true })
    ], SignedData.prototype, "crls", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: signer_info_1.SignerInfos })
    ], SignedData.prototype, "signerInfos", void 0);
  }
});

// node_modules/@peculiar/asn1-cms/build/cjs/index.js
var require_cjs5 = __commonJS({
  "node_modules/@peculiar/asn1-cms/build/cjs/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    tslib_1.__exportStar(require_attributes(), exports2);
    tslib_1.__exportStar(require_attribute2(), exports2);
    tslib_1.__exportStar(require_certificate_choices(), exports2);
    tslib_1.__exportStar(require_content_info(), exports2);
    tslib_1.__exportStar(require_encapsulated_content_info(), exports2);
    tslib_1.__exportStar(require_encrypted_content_info(), exports2);
    tslib_1.__exportStar(require_enveloped_data(), exports2);
    tslib_1.__exportStar(require_issuer_and_serial_number(), exports2);
    tslib_1.__exportStar(require_kek_recipient_info(), exports2);
    tslib_1.__exportStar(require_key_agree_recipient_info(), exports2);
    tslib_1.__exportStar(require_key_trans_recipient_info(), exports2);
    tslib_1.__exportStar(require_object_identifiers3(), exports2);
    tslib_1.__exportStar(require_originator_info(), exports2);
    tslib_1.__exportStar(require_password_recipient_info(), exports2);
    tslib_1.__exportStar(require_recipient_info(), exports2);
    tslib_1.__exportStar(require_recipient_infos(), exports2);
    tslib_1.__exportStar(require_revocation_info_choice(), exports2);
    tslib_1.__exportStar(require_signed_data(), exports2);
    tslib_1.__exportStar(require_signer_identifier(), exports2);
    tslib_1.__exportStar(require_signer_info(), exports2);
    tslib_1.__exportStar(require_types4(), exports2);
  }
});

// node_modules/@peculiar/asn1-ecc/build/cjs/object_identifiers.js
var require_object_identifiers4 = __commonJS({
  "node_modules/@peculiar/asn1-ecc/build/cjs/object_identifiers.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.id_sect571r1 = exports2.id_sect571k1 = exports2.id_secp521r1 = exports2.id_sect409r1 = exports2.id_sect409k1 = exports2.id_secp384r1 = exports2.id_sect283r1 = exports2.id_sect283k1 = exports2.id_secp256r1 = exports2.id_sect233r1 = exports2.id_sect233k1 = exports2.id_secp224r1 = exports2.id_sect163r2 = exports2.id_sect163k1 = exports2.id_secp192r1 = exports2.id_ecdsaWithSHA512 = exports2.id_ecdsaWithSHA384 = exports2.id_ecdsaWithSHA256 = exports2.id_ecdsaWithSHA224 = exports2.id_ecdsaWithSHA1 = exports2.id_ecMQV = exports2.id_ecDH = exports2.id_ecPublicKey = void 0;
    exports2.id_ecPublicKey = "1.2.840.10045.2.1";
    exports2.id_ecDH = "1.3.132.1.12";
    exports2.id_ecMQV = "1.3.132.1.13";
    exports2.id_ecdsaWithSHA1 = "1.2.840.10045.4.1";
    exports2.id_ecdsaWithSHA224 = "1.2.840.10045.4.3.1";
    exports2.id_ecdsaWithSHA256 = "1.2.840.10045.4.3.2";
    exports2.id_ecdsaWithSHA384 = "1.2.840.10045.4.3.3";
    exports2.id_ecdsaWithSHA512 = "1.2.840.10045.4.3.4";
    exports2.id_secp192r1 = "1.2.840.10045.3.1.1";
    exports2.id_sect163k1 = "1.3.132.0.1";
    exports2.id_sect163r2 = "1.3.132.0.15";
    exports2.id_secp224r1 = "1.3.132.0.33";
    exports2.id_sect233k1 = "1.3.132.0.26";
    exports2.id_sect233r1 = "1.3.132.0.27";
    exports2.id_secp256r1 = "1.2.840.10045.3.1.7";
    exports2.id_sect283k1 = "1.3.132.0.16";
    exports2.id_sect283r1 = "1.3.132.0.17";
    exports2.id_secp384r1 = "1.3.132.0.34";
    exports2.id_sect409k1 = "1.3.132.0.36";
    exports2.id_sect409r1 = "1.3.132.0.37";
    exports2.id_secp521r1 = "1.3.132.0.35";
    exports2.id_sect571k1 = "1.3.132.0.38";
    exports2.id_sect571r1 = "1.3.132.0.39";
  }
});

// node_modules/@peculiar/asn1-ecc/build/cjs/algorithms.js
var require_algorithms = __commonJS({
  "node_modules/@peculiar/asn1-ecc/build/cjs/algorithms.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ecdsaWithSHA512 = exports2.ecdsaWithSHA384 = exports2.ecdsaWithSHA256 = exports2.ecdsaWithSHA224 = exports2.ecdsaWithSHA1 = void 0;
    var asn1_x509_1 = require_cjs3();
    var oid = require_object_identifiers4();
    function create(algorithm) {
      return new asn1_x509_1.AlgorithmIdentifier({ algorithm });
    }
    exports2.ecdsaWithSHA1 = create(oid.id_ecdsaWithSHA1);
    exports2.ecdsaWithSHA224 = create(oid.id_ecdsaWithSHA224);
    exports2.ecdsaWithSHA256 = create(oid.id_ecdsaWithSHA256);
    exports2.ecdsaWithSHA384 = create(oid.id_ecdsaWithSHA384);
    exports2.ecdsaWithSHA512 = create(oid.id_ecdsaWithSHA512);
  }
});

// node_modules/@peculiar/asn1-ecc/build/cjs/ec_parameters.js
var require_ec_parameters = __commonJS({
  "node_modules/@peculiar/asn1-ecc/build/cjs/ec_parameters.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ECParameters = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var ECParameters = class ECParameters {
      constructor(params = {}) {
        Object.assign(this, params);
      }
    };
    exports2.ECParameters = ECParameters;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], ECParameters.prototype, "namedCurve", void 0);
    exports2.ECParameters = ECParameters = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], ECParameters);
  }
});

// node_modules/@peculiar/asn1-ecc/build/cjs/ec_private_key.js
var require_ec_private_key = __commonJS({
  "node_modules/@peculiar/asn1-ecc/build/cjs/ec_private_key.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ECPrivateKey = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var ec_parameters_1 = require_ec_parameters();
    var ECPrivateKey = class {
      constructor(params = {}) {
        this.version = 1;
        this.privateKey = new asn1_schema_1.OctetString();
        Object.assign(this, params);
      }
    };
    exports2.ECPrivateKey = ECPrivateKey;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer })
    ], ECPrivateKey.prototype, "version", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.OctetString })
    ], ECPrivateKey.prototype, "privateKey", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: ec_parameters_1.ECParameters, context: 0, optional: true })
    ], ECPrivateKey.prototype, "parameters", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.BitString, context: 1, optional: true })
    ], ECPrivateKey.prototype, "publicKey", void 0);
  }
});

// node_modules/@peculiar/asn1-ecc/build/cjs/ec_signature_value.js
var require_ec_signature_value = __commonJS({
  "node_modules/@peculiar/asn1-ecc/build/cjs/ec_signature_value.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ECDSASigValue = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var ECDSASigValue = class {
      constructor(params = {}) {
        this.r = new ArrayBuffer(0);
        this.s = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.ECDSASigValue = ECDSASigValue;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, converter: asn1_schema_1.AsnIntegerArrayBufferConverter })
    ], ECDSASigValue.prototype, "r", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, converter: asn1_schema_1.AsnIntegerArrayBufferConverter })
    ], ECDSASigValue.prototype, "s", void 0);
  }
});

// node_modules/@peculiar/asn1-ecc/build/cjs/index.js
var require_cjs6 = __commonJS({
  "node_modules/@peculiar/asn1-ecc/build/cjs/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    tslib_1.__exportStar(require_algorithms(), exports2);
    tslib_1.__exportStar(require_ec_parameters(), exports2);
    tslib_1.__exportStar(require_ec_private_key(), exports2);
    tslib_1.__exportStar(require_ec_signature_value(), exports2);
    tslib_1.__exportStar(require_object_identifiers4(), exports2);
  }
});

// node_modules/@peculiar/asn1-rsa/build/cjs/object_identifiers.js
var require_object_identifiers5 = __commonJS({
  "node_modules/@peculiar/asn1-rsa/build/cjs/object_identifiers.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.id_mgf1 = exports2.id_md5 = exports2.id_md2 = exports2.id_sha512_256 = exports2.id_sha512_224 = exports2.id_sha512 = exports2.id_sha384 = exports2.id_sha256 = exports2.id_sha224 = exports2.id_sha1 = exports2.id_sha512_256WithRSAEncryption = exports2.id_sha512_224WithRSAEncryption = exports2.id_sha512WithRSAEncryption = exports2.id_sha384WithRSAEncryption = exports2.id_sha256WithRSAEncryption = exports2.id_ssha224WithRSAEncryption = exports2.id_sha224WithRSAEncryption = exports2.id_sha1WithRSAEncryption = exports2.id_md5WithRSAEncryption = exports2.id_md2WithRSAEncryption = exports2.id_RSASSA_PSS = exports2.id_pSpecified = exports2.id_RSAES_OAEP = exports2.id_rsaEncryption = exports2.id_pkcs_1 = void 0;
    exports2.id_pkcs_1 = "1.2.840.113549.1.1";
    exports2.id_rsaEncryption = `${exports2.id_pkcs_1}.1`;
    exports2.id_RSAES_OAEP = `${exports2.id_pkcs_1}.7`;
    exports2.id_pSpecified = `${exports2.id_pkcs_1}.9`;
    exports2.id_RSASSA_PSS = `${exports2.id_pkcs_1}.10`;
    exports2.id_md2WithRSAEncryption = `${exports2.id_pkcs_1}.2`;
    exports2.id_md5WithRSAEncryption = `${exports2.id_pkcs_1}.4`;
    exports2.id_sha1WithRSAEncryption = `${exports2.id_pkcs_1}.5`;
    exports2.id_sha224WithRSAEncryption = `${exports2.id_pkcs_1}.14`;
    exports2.id_ssha224WithRSAEncryption = exports2.id_sha224WithRSAEncryption;
    exports2.id_sha256WithRSAEncryption = `${exports2.id_pkcs_1}.11`;
    exports2.id_sha384WithRSAEncryption = `${exports2.id_pkcs_1}.12`;
    exports2.id_sha512WithRSAEncryption = `${exports2.id_pkcs_1}.13`;
    exports2.id_sha512_224WithRSAEncryption = `${exports2.id_pkcs_1}.15`;
    exports2.id_sha512_256WithRSAEncryption = `${exports2.id_pkcs_1}.16`;
    exports2.id_sha1 = "1.3.14.3.2.26";
    exports2.id_sha224 = "2.16.840.1.101.3.4.2.4";
    exports2.id_sha256 = "2.16.840.1.101.3.4.2.1";
    exports2.id_sha384 = "2.16.840.1.101.3.4.2.2";
    exports2.id_sha512 = "2.16.840.1.101.3.4.2.3";
    exports2.id_sha512_224 = "2.16.840.1.101.3.4.2.5";
    exports2.id_sha512_256 = "2.16.840.1.101.3.4.2.6";
    exports2.id_md2 = "1.2.840.113549.2.2";
    exports2.id_md5 = "1.2.840.113549.2.5";
    exports2.id_mgf1 = `${exports2.id_pkcs_1}.8`;
  }
});

// node_modules/@peculiar/asn1-rsa/build/cjs/algorithms.js
var require_algorithms2 = __commonJS({
  "node_modules/@peculiar/asn1-rsa/build/cjs/algorithms.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.sha512_256WithRSAEncryption = exports2.sha512_224WithRSAEncryption = exports2.sha512WithRSAEncryption = exports2.sha384WithRSAEncryption = exports2.sha256WithRSAEncryption = exports2.sha224WithRSAEncryption = exports2.sha1WithRSAEncryption = exports2.md5WithRSAEncryption = exports2.md2WithRSAEncryption = exports2.rsaEncryption = exports2.pSpecifiedEmpty = exports2.mgf1SHA1 = exports2.sha512_256 = exports2.sha512_224 = exports2.sha512 = exports2.sha384 = exports2.sha256 = exports2.sha224 = exports2.sha1 = exports2.md4 = exports2.md2 = void 0;
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    var oid = require_object_identifiers5();
    function create(algorithm) {
      return new asn1_x509_1.AlgorithmIdentifier({ algorithm, parameters: null });
    }
    exports2.md2 = create(oid.id_md2);
    exports2.md4 = create(oid.id_md5);
    exports2.sha1 = create(oid.id_sha1);
    exports2.sha224 = create(oid.id_sha224);
    exports2.sha256 = create(oid.id_sha256);
    exports2.sha384 = create(oid.id_sha384);
    exports2.sha512 = create(oid.id_sha512);
    exports2.sha512_224 = create(oid.id_sha512_224);
    exports2.sha512_256 = create(oid.id_sha512_256);
    exports2.mgf1SHA1 = new asn1_x509_1.AlgorithmIdentifier({
      algorithm: oid.id_mgf1,
      parameters: asn1_schema_1.AsnConvert.serialize(exports2.sha1)
    });
    exports2.pSpecifiedEmpty = new asn1_x509_1.AlgorithmIdentifier({
      algorithm: oid.id_pSpecified,
      parameters: asn1_schema_1.AsnConvert.serialize(asn1_schema_1.AsnOctetStringConverter.toASN(new Uint8Array([218, 57, 163, 238, 94, 107, 75, 13, 50, 85, 191, 239, 149, 96, 24, 144, 175, 216, 7, 9]).buffer))
    });
    exports2.rsaEncryption = create(oid.id_rsaEncryption);
    exports2.md2WithRSAEncryption = create(oid.id_md2WithRSAEncryption);
    exports2.md5WithRSAEncryption = create(oid.id_md5WithRSAEncryption);
    exports2.sha1WithRSAEncryption = create(oid.id_sha1WithRSAEncryption);
    exports2.sha224WithRSAEncryption = create(oid.id_sha512_224WithRSAEncryption);
    exports2.sha256WithRSAEncryption = create(oid.id_sha512_256WithRSAEncryption);
    exports2.sha384WithRSAEncryption = create(oid.id_sha384WithRSAEncryption);
    exports2.sha512WithRSAEncryption = create(oid.id_sha512WithRSAEncryption);
    exports2.sha512_224WithRSAEncryption = create(oid.id_sha512_224WithRSAEncryption);
    exports2.sha512_256WithRSAEncryption = create(oid.id_sha512_256WithRSAEncryption);
  }
});

// node_modules/@peculiar/asn1-rsa/build/cjs/parameters/rsaes_oaep.js
var require_rsaes_oaep = __commonJS({
  "node_modules/@peculiar/asn1-rsa/build/cjs/parameters/rsaes_oaep.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RSAES_OAEP = exports2.RsaEsOaepParams = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    var object_identifiers_1 = require_object_identifiers5();
    var algorithms_1 = require_algorithms2();
    var RsaEsOaepParams = class {
      constructor(params = {}) {
        this.hashAlgorithm = new asn1_x509_1.AlgorithmIdentifier(algorithms_1.sha1);
        this.maskGenAlgorithm = new asn1_x509_1.AlgorithmIdentifier({
          algorithm: object_identifiers_1.id_mgf1,
          parameters: asn1_schema_1.AsnConvert.serialize(algorithms_1.sha1)
        });
        this.pSourceAlgorithm = new asn1_x509_1.AlgorithmIdentifier(algorithms_1.pSpecifiedEmpty);
        Object.assign(this, params);
      }
    };
    exports2.RsaEsOaepParams = RsaEsOaepParams;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.AlgorithmIdentifier, context: 0, defaultValue: algorithms_1.sha1 })
    ], RsaEsOaepParams.prototype, "hashAlgorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.AlgorithmIdentifier, context: 1, defaultValue: algorithms_1.mgf1SHA1 })
    ], RsaEsOaepParams.prototype, "maskGenAlgorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.AlgorithmIdentifier, context: 2, defaultValue: algorithms_1.pSpecifiedEmpty })
    ], RsaEsOaepParams.prototype, "pSourceAlgorithm", void 0);
    exports2.RSAES_OAEP = new asn1_x509_1.AlgorithmIdentifier({
      algorithm: object_identifiers_1.id_RSAES_OAEP,
      parameters: asn1_schema_1.AsnConvert.serialize(new RsaEsOaepParams())
    });
  }
});

// node_modules/@peculiar/asn1-rsa/build/cjs/parameters/rsassa_pss.js
var require_rsassa_pss = __commonJS({
  "node_modules/@peculiar/asn1-rsa/build/cjs/parameters/rsassa_pss.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RSASSA_PSS = exports2.RsaSaPssParams = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    var object_identifiers_1 = require_object_identifiers5();
    var algorithms_1 = require_algorithms2();
    var RsaSaPssParams = class {
      constructor(params = {}) {
        this.hashAlgorithm = new asn1_x509_1.AlgorithmIdentifier(algorithms_1.sha1);
        this.maskGenAlgorithm = new asn1_x509_1.AlgorithmIdentifier({
          algorithm: object_identifiers_1.id_mgf1,
          parameters: asn1_schema_1.AsnConvert.serialize(algorithms_1.sha1)
        });
        this.saltLength = 20;
        this.trailerField = 1;
        Object.assign(this, params);
      }
    };
    exports2.RsaSaPssParams = RsaSaPssParams;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.AlgorithmIdentifier, context: 0, defaultValue: algorithms_1.sha1 })
    ], RsaSaPssParams.prototype, "hashAlgorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.AlgorithmIdentifier, context: 1, defaultValue: algorithms_1.mgf1SHA1 })
    ], RsaSaPssParams.prototype, "maskGenAlgorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, context: 2, defaultValue: 20 })
    ], RsaSaPssParams.prototype, "saltLength", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, context: 3, defaultValue: 1 })
    ], RsaSaPssParams.prototype, "trailerField", void 0);
    exports2.RSASSA_PSS = new asn1_x509_1.AlgorithmIdentifier({
      algorithm: object_identifiers_1.id_RSASSA_PSS,
      parameters: asn1_schema_1.AsnConvert.serialize(new RsaSaPssParams())
    });
  }
});

// node_modules/@peculiar/asn1-rsa/build/cjs/parameters/rsassa_pkcs1_v1_5.js
var require_rsassa_pkcs1_v1_5 = __commonJS({
  "node_modules/@peculiar/asn1-rsa/build/cjs/parameters/rsassa_pkcs1_v1_5.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.DigestInfo = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_x509_1 = require_cjs3();
    var asn1_schema_1 = require_cjs2();
    var DigestInfo = class {
      constructor(params = {}) {
        this.digestAlgorithm = new asn1_x509_1.AlgorithmIdentifier();
        this.digest = new asn1_schema_1.OctetString();
        Object.assign(this, params);
      }
    };
    exports2.DigestInfo = DigestInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.AlgorithmIdentifier })
    ], DigestInfo.prototype, "digestAlgorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.OctetString })
    ], DigestInfo.prototype, "digest", void 0);
  }
});

// node_modules/@peculiar/asn1-rsa/build/cjs/parameters/index.js
var require_parameters2 = __commonJS({
  "node_modules/@peculiar/asn1-rsa/build/cjs/parameters/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    tslib_1.__exportStar(require_rsaes_oaep(), exports2);
    tslib_1.__exportStar(require_rsassa_pss(), exports2);
    tslib_1.__exportStar(require_rsassa_pkcs1_v1_5(), exports2);
  }
});

// node_modules/@peculiar/asn1-rsa/build/cjs/other_prime_info.js
var require_other_prime_info = __commonJS({
  "node_modules/@peculiar/asn1-rsa/build/cjs/other_prime_info.js"(exports2) {
    "use strict";
    var OtherPrimeInfos_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OtherPrimeInfos = exports2.OtherPrimeInfo = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var OtherPrimeInfo = class {
      constructor(params = {}) {
        this.prime = new ArrayBuffer(0);
        this.exponent = new ArrayBuffer(0);
        this.coefficient = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.OtherPrimeInfo = OtherPrimeInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, converter: asn1_schema_1.AsnIntegerArrayBufferConverter })
    ], OtherPrimeInfo.prototype, "prime", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, converter: asn1_schema_1.AsnIntegerArrayBufferConverter })
    ], OtherPrimeInfo.prototype, "exponent", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, converter: asn1_schema_1.AsnIntegerArrayBufferConverter })
    ], OtherPrimeInfo.prototype, "coefficient", void 0);
    var OtherPrimeInfos = OtherPrimeInfos_1 = class OtherPrimeInfos extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, OtherPrimeInfos_1.prototype);
      }
    };
    exports2.OtherPrimeInfos = OtherPrimeInfos;
    exports2.OtherPrimeInfos = OtherPrimeInfos = OtherPrimeInfos_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: OtherPrimeInfo })
    ], OtherPrimeInfos);
  }
});

// node_modules/@peculiar/asn1-rsa/build/cjs/rsa_private_key.js
var require_rsa_private_key = __commonJS({
  "node_modules/@peculiar/asn1-rsa/build/cjs/rsa_private_key.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RSAPrivateKey = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var other_prime_info_1 = require_other_prime_info();
    var RSAPrivateKey = class {
      constructor(params = {}) {
        this.version = 0;
        this.modulus = new ArrayBuffer(0);
        this.publicExponent = new ArrayBuffer(0);
        this.privateExponent = new ArrayBuffer(0);
        this.prime1 = new ArrayBuffer(0);
        this.prime2 = new ArrayBuffer(0);
        this.exponent1 = new ArrayBuffer(0);
        this.exponent2 = new ArrayBuffer(0);
        this.coefficient = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.RSAPrivateKey = RSAPrivateKey;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer })
    ], RSAPrivateKey.prototype, "version", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, converter: asn1_schema_1.AsnIntegerArrayBufferConverter })
    ], RSAPrivateKey.prototype, "modulus", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, converter: asn1_schema_1.AsnIntegerArrayBufferConverter })
    ], RSAPrivateKey.prototype, "publicExponent", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, converter: asn1_schema_1.AsnIntegerArrayBufferConverter })
    ], RSAPrivateKey.prototype, "privateExponent", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, converter: asn1_schema_1.AsnIntegerArrayBufferConverter })
    ], RSAPrivateKey.prototype, "prime1", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, converter: asn1_schema_1.AsnIntegerArrayBufferConverter })
    ], RSAPrivateKey.prototype, "prime2", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, converter: asn1_schema_1.AsnIntegerArrayBufferConverter })
    ], RSAPrivateKey.prototype, "exponent1", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, converter: asn1_schema_1.AsnIntegerArrayBufferConverter })
    ], RSAPrivateKey.prototype, "exponent2", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, converter: asn1_schema_1.AsnIntegerArrayBufferConverter })
    ], RSAPrivateKey.prototype, "coefficient", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: other_prime_info_1.OtherPrimeInfos, optional: true })
    ], RSAPrivateKey.prototype, "otherPrimeInfos", void 0);
  }
});

// node_modules/@peculiar/asn1-rsa/build/cjs/rsa_public_key.js
var require_rsa_public_key = __commonJS({
  "node_modules/@peculiar/asn1-rsa/build/cjs/rsa_public_key.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RSAPublicKey = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var RSAPublicKey = class {
      constructor(params = {}) {
        this.modulus = new ArrayBuffer(0);
        this.publicExponent = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.RSAPublicKey = RSAPublicKey;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, converter: asn1_schema_1.AsnIntegerArrayBufferConverter })
    ], RSAPublicKey.prototype, "modulus", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, converter: asn1_schema_1.AsnIntegerArrayBufferConverter })
    ], RSAPublicKey.prototype, "publicExponent", void 0);
  }
});

// node_modules/@peculiar/asn1-rsa/build/cjs/index.js
var require_cjs7 = __commonJS({
  "node_modules/@peculiar/asn1-rsa/build/cjs/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    tslib_1.__exportStar(require_parameters2(), exports2);
    tslib_1.__exportStar(require_algorithms2(), exports2);
    tslib_1.__exportStar(require_object_identifiers5(), exports2);
    tslib_1.__exportStar(require_other_prime_info(), exports2);
    tslib_1.__exportStar(require_rsa_private_key(), exports2);
    tslib_1.__exportStar(require_rsa_public_key(), exports2);
  }
});

// node_modules/tsyringe/node_modules/tslib/tslib.es6.js
var tslib_es6_exports2 = {};
__export(tslib_es6_exports2, {
  __assign: () => __assign2,
  __asyncDelegator: () => __asyncDelegator2,
  __asyncGenerator: () => __asyncGenerator2,
  __asyncValues: () => __asyncValues2,
  __await: () => __await2,
  __awaiter: () => __awaiter2,
  __classPrivateFieldGet: () => __classPrivateFieldGet2,
  __classPrivateFieldSet: () => __classPrivateFieldSet2,
  __createBinding: () => __createBinding2,
  __decorate: () => __decorate2,
  __exportStar: () => __exportStar2,
  __extends: () => __extends2,
  __generator: () => __generator2,
  __importDefault: () => __importDefault2,
  __importStar: () => __importStar2,
  __makeTemplateObject: () => __makeTemplateObject2,
  __metadata: () => __metadata2,
  __param: () => __param2,
  __read: () => __read2,
  __rest: () => __rest2,
  __spread: () => __spread2,
  __spreadArrays: () => __spreadArrays2,
  __values: () => __values2
});
function __extends2(d2, b) {
  extendStatics2(d2, b);
  function __() {
    this.constructor = d2;
  }
  d2.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}
function __rest2(s, e) {
  var t = {};
  for (var p3 in s)
    if (Object.prototype.hasOwnProperty.call(s, p3) && e.indexOf(p3) < 0)
      t[p3] = s[p3];
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p3 = Object.getOwnPropertySymbols(s); i < p3.length; i++) {
      if (e.indexOf(p3[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p3[i]))
        t[p3[i]] = s[p3[i]];
    }
  return t;
}
function __decorate2(decorators, target, key, desc) {
  var c2 = arguments.length, r = c2 < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d2;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
    r = Reflect.decorate(decorators, target, key, desc);
  else
    for (var i = decorators.length - 1; i >= 0; i--)
      if (d2 = decorators[i])
        r = (c2 < 3 ? d2(r) : c2 > 3 ? d2(target, key, r) : d2(target, key)) || r;
  return c2 > 3 && r && Object.defineProperty(target, key, r), r;
}
function __param2(paramIndex, decorator) {
  return function(target, key) {
    decorator(target, key, paramIndex);
  };
}
function __metadata2(metadataKey, metadataValue) {
  if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
    return Reflect.metadata(metadataKey, metadataValue);
}
function __awaiter2(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function(resolve2) {
      resolve2(value);
    });
  }
  return new (P || (P = Promise))(function(resolve2, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result2) {
      result2.done ? resolve2(result2.value) : adopt(result2.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
}
function __generator2(thisArg, body) {
  var _ = { label: 0, sent: function() {
    if (t[0] & 1)
      throw t[1];
    return t[1];
  }, trys: [], ops: [] }, f2, y, t, g2;
  return g2 = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g2[Symbol.iterator] = function() {
    return this;
  }), g2;
  function verb(n) {
    return function(v) {
      return step([n, v]);
    };
  }
  function step(op) {
    if (f2)
      throw new TypeError("Generator is already executing.");
    while (_)
      try {
        if (f2 = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
          return t;
        if (y = 0, t)
          op = [op[0] & 2, t.value];
        switch (op[0]) {
          case 0:
          case 1:
            t = op;
            break;
          case 4:
            _.label++;
            return { value: op[1], done: false };
          case 5:
            _.label++;
            y = op[1];
            op = [0];
            continue;
          case 7:
            op = _.ops.pop();
            _.trys.pop();
            continue;
          default:
            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
              _ = 0;
              continue;
            }
            if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
              _.label = op[1];
              break;
            }
            if (op[0] === 6 && _.label < t[1]) {
              _.label = t[1];
              t = op;
              break;
            }
            if (t && _.label < t[2]) {
              _.label = t[2];
              _.ops.push(op);
              break;
            }
            if (t[2])
              _.ops.pop();
            _.trys.pop();
            continue;
        }
        op = body.call(thisArg, _);
      } catch (e) {
        op = [6, e];
        y = 0;
      } finally {
        f2 = t = 0;
      }
    if (op[0] & 5)
      throw op[1];
    return { value: op[0] ? op[1] : void 0, done: true };
  }
}
function __createBinding2(o2, m2, k, k2) {
  if (k2 === void 0)
    k2 = k;
  o2[k2] = m2[k];
}
function __exportStar2(m2, exports2) {
  for (var p3 in m2)
    if (p3 !== "default" && !exports2.hasOwnProperty(p3))
      exports2[p3] = m2[p3];
}
function __values2(o2) {
  var s = typeof Symbol === "function" && Symbol.iterator, m2 = s && o2[s], i = 0;
  if (m2)
    return m2.call(o2);
  if (o2 && typeof o2.length === "number")
    return {
      next: function() {
        if (o2 && i >= o2.length)
          o2 = void 0;
        return { value: o2 && o2[i++], done: !o2 };
      }
    };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
}
function __read2(o2, n) {
  var m2 = typeof Symbol === "function" && o2[Symbol.iterator];
  if (!m2)
    return o2;
  var i = m2.call(o2), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
      ar.push(r.value);
  } catch (error) {
    e = { error };
  } finally {
    try {
      if (r && !r.done && (m2 = i["return"]))
        m2.call(i);
    } finally {
      if (e)
        throw e.error;
    }
  }
  return ar;
}
function __spread2() {
  for (var ar = [], i = 0; i < arguments.length; i++)
    ar = ar.concat(__read2(arguments[i]));
  return ar;
}
function __spreadArrays2() {
  for (var s = 0, i = 0, il = arguments.length; i < il; i++)
    s += arguments[i].length;
  for (var r = Array(s), k = 0, i = 0; i < il; i++)
    for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
      r[k] = a[j];
  return r;
}
function __await2(v) {
  return this instanceof __await2 ? (this.v = v, this) : new __await2(v);
}
function __asyncGenerator2(thisArg, _arguments, generator) {
  if (!Symbol.asyncIterator)
    throw new TypeError("Symbol.asyncIterator is not defined.");
  var g2 = generator.apply(thisArg, _arguments || []), i, q2 = [];
  return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function() {
    return this;
  }, i;
  function verb(n) {
    if (g2[n])
      i[n] = function(v) {
        return new Promise(function(a, b) {
          q2.push([n, v, a, b]) > 1 || resume(n, v);
        });
      };
  }
  function resume(n, v) {
    try {
      step(g2[n](v));
    } catch (e) {
      settle(q2[0][3], e);
    }
  }
  function step(r) {
    r.value instanceof __await2 ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q2[0][2], r);
  }
  function fulfill(value) {
    resume("next", value);
  }
  function reject(value) {
    resume("throw", value);
  }
  function settle(f2, v) {
    if (f2(v), q2.shift(), q2.length)
      resume(q2[0][0], q2[0][1]);
  }
}
function __asyncDelegator2(o2) {
  var i, p3;
  return i = {}, verb("next"), verb("throw", function(e) {
    throw e;
  }), verb("return"), i[Symbol.iterator] = function() {
    return this;
  }, i;
  function verb(n, f2) {
    i[n] = o2[n] ? function(v) {
      return (p3 = !p3) ? { value: __await2(o2[n](v)), done: n === "return" } : f2 ? f2(v) : v;
    } : f2;
  }
}
function __asyncValues2(o2) {
  if (!Symbol.asyncIterator)
    throw new TypeError("Symbol.asyncIterator is not defined.");
  var m2 = o2[Symbol.asyncIterator], i;
  return m2 ? m2.call(o2) : (o2 = typeof __values2 === "function" ? __values2(o2) : o2[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function() {
    return this;
  }, i);
  function verb(n) {
    i[n] = o2[n] && function(v) {
      return new Promise(function(resolve2, reject) {
        v = o2[n](v), settle(resolve2, reject, v.done, v.value);
      });
    };
  }
  function settle(resolve2, reject, d2, v) {
    Promise.resolve(v).then(function(v2) {
      resolve2({ value: v2, done: d2 });
    }, reject);
  }
}
function __makeTemplateObject2(cooked, raw2) {
  if (Object.defineProperty) {
    Object.defineProperty(cooked, "raw", { value: raw2 });
  } else {
    cooked.raw = raw2;
  }
  return cooked;
}
function __importStar2(mod) {
  if (mod && mod.__esModule)
    return mod;
  var result2 = {};
  if (mod != null) {
    for (var k in mod)
      if (Object.hasOwnProperty.call(mod, k))
        result2[k] = mod[k];
  }
  result2.default = mod;
  return result2;
}
function __importDefault2(mod) {
  return mod && mod.__esModule ? mod : { default: mod };
}
function __classPrivateFieldGet2(receiver, privateMap) {
  if (!privateMap.has(receiver)) {
    throw new TypeError("attempted to get private field on non-instance");
  }
  return privateMap.get(receiver);
}
function __classPrivateFieldSet2(receiver, privateMap, value) {
  if (!privateMap.has(receiver)) {
    throw new TypeError("attempted to set private field on non-instance");
  }
  privateMap.set(receiver, value);
  return value;
}
var extendStatics2, __assign2;
var init_tslib_es62 = __esm({
  "node_modules/tsyringe/node_modules/tslib/tslib.es6.js"() {
    extendStatics2 = function(d2, b) {
      extendStatics2 = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d3, b2) {
        d3.__proto__ = b2;
      } || function(d3, b2) {
        for (var p3 in b2)
          if (b2.hasOwnProperty(p3))
            d3[p3] = b2[p3];
      };
      return extendStatics2(d2, b);
    };
    __assign2 = function() {
      __assign2 = Object.assign || function __assign3(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
          s = arguments[i];
          for (var p3 in s)
            if (Object.prototype.hasOwnProperty.call(s, p3))
              t[p3] = s[p3];
        }
        return t;
      };
      return __assign2.apply(this, arguments);
    };
  }
});

// node_modules/tsyringe/dist/cjs/types/lifecycle.js
var require_lifecycle = __commonJS({
  "node_modules/tsyringe/dist/cjs/types/lifecycle.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var Lifecycle;
    (function(Lifecycle2) {
      Lifecycle2[Lifecycle2["Transient"] = 0] = "Transient";
      Lifecycle2[Lifecycle2["Singleton"] = 1] = "Singleton";
      Lifecycle2[Lifecycle2["ResolutionScoped"] = 2] = "ResolutionScoped";
      Lifecycle2[Lifecycle2["ContainerScoped"] = 3] = "ContainerScoped";
    })(Lifecycle || (Lifecycle = {}));
    exports2.default = Lifecycle;
  }
});

// node_modules/tsyringe/dist/cjs/types/index.js
var require_types5 = __commonJS({
  "node_modules/tsyringe/dist/cjs/types/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var lifecycle_1 = require_lifecycle();
    Object.defineProperty(exports2, "Lifecycle", { enumerable: true, get: function() {
      return lifecycle_1.default;
    } });
  }
});

// node_modules/tsyringe/dist/cjs/reflection-helpers.js
var require_reflection_helpers = __commonJS({
  "node_modules/tsyringe/dist/cjs/reflection-helpers.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.defineInjectionTokenMetadata = exports2.getParamInfo = exports2.INJECTION_TOKEN_METADATA_KEY = void 0;
    exports2.INJECTION_TOKEN_METADATA_KEY = "injectionTokens";
    function getParamInfo(target) {
      const params = Reflect.getMetadata("design:paramtypes", target) || [];
      const injectionTokens = Reflect.getOwnMetadata(exports2.INJECTION_TOKEN_METADATA_KEY, target) || {};
      Object.keys(injectionTokens).forEach((key) => {
        params[+key] = injectionTokens[key];
      });
      return params;
    }
    exports2.getParamInfo = getParamInfo;
    function defineInjectionTokenMetadata(data, transform) {
      return function(target, _propertyKey, parameterIndex) {
        const descriptors = Reflect.getOwnMetadata(exports2.INJECTION_TOKEN_METADATA_KEY, target) || {};
        descriptors[parameterIndex] = transform ? {
          token: data,
          transform: transform.transformToken,
          transformArgs: transform.args || []
        } : data;
        Reflect.defineMetadata(exports2.INJECTION_TOKEN_METADATA_KEY, descriptors, target);
      };
    }
    exports2.defineInjectionTokenMetadata = defineInjectionTokenMetadata;
  }
});

// node_modules/tsyringe/dist/cjs/providers/class-provider.js
var require_class_provider = __commonJS({
  "node_modules/tsyringe/dist/cjs/providers/class-provider.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isClassProvider = void 0;
    function isClassProvider(provider) {
      return !!provider.useClass;
    }
    exports2.isClassProvider = isClassProvider;
  }
});

// node_modules/tsyringe/dist/cjs/providers/factory-provider.js
var require_factory_provider = __commonJS({
  "node_modules/tsyringe/dist/cjs/providers/factory-provider.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isFactoryProvider = void 0;
    function isFactoryProvider(provider) {
      return !!provider.useFactory;
    }
    exports2.isFactoryProvider = isFactoryProvider;
  }
});

// node_modules/tsyringe/dist/cjs/lazy-helpers.js
var require_lazy_helpers = __commonJS({
  "node_modules/tsyringe/dist/cjs/lazy-helpers.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.delay = exports2.DelayedConstructor = void 0;
    var DelayedConstructor = class {
      constructor(wrap) {
        this.wrap = wrap;
        this.reflectMethods = [
          "get",
          "getPrototypeOf",
          "setPrototypeOf",
          "getOwnPropertyDescriptor",
          "defineProperty",
          "has",
          "set",
          "deleteProperty",
          "apply",
          "construct",
          "ownKeys"
        ];
      }
      createProxy(createObject) {
        const target = {};
        let init2 = false;
        let value;
        const delayedObject = () => {
          if (!init2) {
            value = createObject(this.wrap());
            init2 = true;
          }
          return value;
        };
        return new Proxy(target, this.createHandler(delayedObject));
      }
      createHandler(delayedObject) {
        const handler = {};
        const install = (name) => {
          handler[name] = (...args) => {
            args[0] = delayedObject();
            const method = Reflect[name];
            return method(...args);
          };
        };
        this.reflectMethods.forEach(install);
        return handler;
      }
    };
    exports2.DelayedConstructor = DelayedConstructor;
    function delay(wrappedConstructor) {
      if (typeof wrappedConstructor === "undefined") {
        throw new Error("Attempt to `delay` undefined. Constructor must be wrapped in a callback");
      }
      return new DelayedConstructor(wrappedConstructor);
    }
    exports2.delay = delay;
  }
});

// node_modules/tsyringe/dist/cjs/providers/injection-token.js
var require_injection_token = __commonJS({
  "node_modules/tsyringe/dist/cjs/providers/injection-token.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isConstructorToken = exports2.isTransformDescriptor = exports2.isTokenDescriptor = exports2.isNormalToken = void 0;
    var lazy_helpers_1 = require_lazy_helpers();
    function isNormalToken(token) {
      return typeof token === "string" || typeof token === "symbol";
    }
    exports2.isNormalToken = isNormalToken;
    function isTokenDescriptor(descriptor) {
      return typeof descriptor === "object" && "token" in descriptor && "multiple" in descriptor;
    }
    exports2.isTokenDescriptor = isTokenDescriptor;
    function isTransformDescriptor(descriptor) {
      return typeof descriptor === "object" && "token" in descriptor && "transform" in descriptor;
    }
    exports2.isTransformDescriptor = isTransformDescriptor;
    function isConstructorToken(token) {
      return typeof token === "function" || token instanceof lazy_helpers_1.DelayedConstructor;
    }
    exports2.isConstructorToken = isConstructorToken;
  }
});

// node_modules/tsyringe/dist/cjs/providers/token-provider.js
var require_token_provider = __commonJS({
  "node_modules/tsyringe/dist/cjs/providers/token-provider.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isTokenProvider = void 0;
    function isTokenProvider(provider) {
      return !!provider.useToken;
    }
    exports2.isTokenProvider = isTokenProvider;
  }
});

// node_modules/tsyringe/dist/cjs/providers/value-provider.js
var require_value_provider = __commonJS({
  "node_modules/tsyringe/dist/cjs/providers/value-provider.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isValueProvider = void 0;
    function isValueProvider(provider) {
      return provider.useValue != void 0;
    }
    exports2.isValueProvider = isValueProvider;
  }
});

// node_modules/tsyringe/dist/cjs/providers/index.js
var require_providers = __commonJS({
  "node_modules/tsyringe/dist/cjs/providers/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var class_provider_1 = require_class_provider();
    Object.defineProperty(exports2, "isClassProvider", { enumerable: true, get: function() {
      return class_provider_1.isClassProvider;
    } });
    var factory_provider_1 = require_factory_provider();
    Object.defineProperty(exports2, "isFactoryProvider", { enumerable: true, get: function() {
      return factory_provider_1.isFactoryProvider;
    } });
    var injection_token_1 = require_injection_token();
    Object.defineProperty(exports2, "isNormalToken", { enumerable: true, get: function() {
      return injection_token_1.isNormalToken;
    } });
    var token_provider_1 = require_token_provider();
    Object.defineProperty(exports2, "isTokenProvider", { enumerable: true, get: function() {
      return token_provider_1.isTokenProvider;
    } });
    var value_provider_1 = require_value_provider();
    Object.defineProperty(exports2, "isValueProvider", { enumerable: true, get: function() {
      return value_provider_1.isValueProvider;
    } });
  }
});

// node_modules/tsyringe/dist/cjs/providers/provider.js
var require_provider = __commonJS({
  "node_modules/tsyringe/dist/cjs/providers/provider.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isProvider = void 0;
    var class_provider_1 = require_class_provider();
    var value_provider_1 = require_value_provider();
    var token_provider_1 = require_token_provider();
    var factory_provider_1 = require_factory_provider();
    function isProvider(provider) {
      return class_provider_1.isClassProvider(provider) || value_provider_1.isValueProvider(provider) || token_provider_1.isTokenProvider(provider) || factory_provider_1.isFactoryProvider(provider);
    }
    exports2.isProvider = isProvider;
  }
});

// node_modules/tsyringe/dist/cjs/registry-base.js
var require_registry_base = __commonJS({
  "node_modules/tsyringe/dist/cjs/registry-base.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var RegistryBase = class {
      constructor() {
        this._registryMap = /* @__PURE__ */ new Map();
      }
      entries() {
        return this._registryMap.entries();
      }
      getAll(key) {
        this.ensure(key);
        return this._registryMap.get(key);
      }
      get(key) {
        this.ensure(key);
        const value = this._registryMap.get(key);
        return value[value.length - 1] || null;
      }
      set(key, value) {
        this.ensure(key);
        this._registryMap.get(key).push(value);
      }
      setAll(key, value) {
        this._registryMap.set(key, value);
      }
      has(key) {
        this.ensure(key);
        return this._registryMap.get(key).length > 0;
      }
      clear() {
        this._registryMap.clear();
      }
      ensure(key) {
        if (!this._registryMap.has(key)) {
          this._registryMap.set(key, []);
        }
      }
    };
    exports2.default = RegistryBase;
  }
});

// node_modules/tsyringe/dist/cjs/registry.js
var require_registry = __commonJS({
  "node_modules/tsyringe/dist/cjs/registry.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var registry_base_1 = require_registry_base();
    var Registry = class extends registry_base_1.default {
    };
    exports2.default = Registry;
  }
});

// node_modules/tsyringe/dist/cjs/resolution-context.js
var require_resolution_context = __commonJS({
  "node_modules/tsyringe/dist/cjs/resolution-context.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var ResolutionContext = class {
      constructor() {
        this.scopedResolutions = /* @__PURE__ */ new Map();
      }
    };
    exports2.default = ResolutionContext;
  }
});

// node_modules/tsyringe/dist/cjs/error-helpers.js
var require_error_helpers = __commonJS({
  "node_modules/tsyringe/dist/cjs/error-helpers.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.formatErrorCtor = void 0;
    function formatDependency(params, idx) {
      if (params === null) {
        return `at position #${idx}`;
      }
      const argName = params.split(",")[idx].trim();
      return `"${argName}" at position #${idx}`;
    }
    function composeErrorMessage(msg, e, indent = "    ") {
      return [msg, ...e.message.split("\n").map((l2) => indent + l2)].join("\n");
    }
    function formatErrorCtor(ctor, paramIdx, error) {
      const [, params = null] = ctor.toString().match(/constructor\(([\w, ]+)\)/) || [];
      const dep = formatDependency(params, paramIdx);
      return composeErrorMessage(`Cannot inject the dependency ${dep} of "${ctor.name}" constructor. Reason:`, error);
    }
    exports2.formatErrorCtor = formatErrorCtor;
  }
});

// node_modules/tsyringe/dist/cjs/types/disposable.js
var require_disposable = __commonJS({
  "node_modules/tsyringe/dist/cjs/types/disposable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isDisposable = void 0;
    function isDisposable(value) {
      if (typeof value.dispose !== "function")
        return false;
      const disposeFun = value.dispose;
      if (disposeFun.length > 0) {
        return false;
      }
      return true;
    }
    exports2.isDisposable = isDisposable;
  }
});

// node_modules/tsyringe/dist/cjs/interceptors.js
var require_interceptors = __commonJS({
  "node_modules/tsyringe/dist/cjs/interceptors.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PostResolutionInterceptors = exports2.PreResolutionInterceptors = void 0;
    var registry_base_1 = require_registry_base();
    var PreResolutionInterceptors = class extends registry_base_1.default {
    };
    exports2.PreResolutionInterceptors = PreResolutionInterceptors;
    var PostResolutionInterceptors = class extends registry_base_1.default {
    };
    exports2.PostResolutionInterceptors = PostResolutionInterceptors;
    var Interceptors = class {
      constructor() {
        this.preResolution = new PreResolutionInterceptors();
        this.postResolution = new PostResolutionInterceptors();
      }
    };
    exports2.default = Interceptors;
  }
});

// node_modules/tsyringe/dist/cjs/dependency-container.js
var require_dependency_container = __commonJS({
  "node_modules/tsyringe/dist/cjs/dependency-container.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.instance = exports2.typeInfo = void 0;
    var tslib_1 = (init_tslib_es62(), __toCommonJS(tslib_es6_exports2));
    var providers_1 = require_providers();
    var provider_1 = require_provider();
    var injection_token_1 = require_injection_token();
    var registry_1 = require_registry();
    var lifecycle_1 = require_lifecycle();
    var resolution_context_1 = require_resolution_context();
    var error_helpers_1 = require_error_helpers();
    var lazy_helpers_1 = require_lazy_helpers();
    var disposable_1 = require_disposable();
    var interceptors_1 = require_interceptors();
    exports2.typeInfo = /* @__PURE__ */ new Map();
    var InternalDependencyContainer = class _InternalDependencyContainer {
      constructor(parent) {
        this.parent = parent;
        this._registry = new registry_1.default();
        this.interceptors = new interceptors_1.default();
        this.disposed = false;
        this.disposables = /* @__PURE__ */ new Set();
      }
      register(token, providerOrConstructor, options = { lifecycle: lifecycle_1.default.Transient }) {
        this.ensureNotDisposed();
        let provider;
        if (!provider_1.isProvider(providerOrConstructor)) {
          provider = { useClass: providerOrConstructor };
        } else {
          provider = providerOrConstructor;
        }
        if (providers_1.isTokenProvider(provider)) {
          const path3 = [token];
          let tokenProvider = provider;
          while (tokenProvider != null) {
            const currentToken = tokenProvider.useToken;
            if (path3.includes(currentToken)) {
              throw new Error(`Token registration cycle detected! ${[...path3, currentToken].join(" -> ")}`);
            }
            path3.push(currentToken);
            const registration = this._registry.get(currentToken);
            if (registration && providers_1.isTokenProvider(registration.provider)) {
              tokenProvider = registration.provider;
            } else {
              tokenProvider = null;
            }
          }
        }
        if (options.lifecycle === lifecycle_1.default.Singleton || options.lifecycle == lifecycle_1.default.ContainerScoped || options.lifecycle == lifecycle_1.default.ResolutionScoped) {
          if (providers_1.isValueProvider(provider) || providers_1.isFactoryProvider(provider)) {
            throw new Error(`Cannot use lifecycle "${lifecycle_1.default[options.lifecycle]}" with ValueProviders or FactoryProviders`);
          }
        }
        this._registry.set(token, { provider, options });
        return this;
      }
      registerType(from, to) {
        this.ensureNotDisposed();
        if (providers_1.isNormalToken(to)) {
          return this.register(from, {
            useToken: to
          });
        }
        return this.register(from, {
          useClass: to
        });
      }
      registerInstance(token, instance) {
        this.ensureNotDisposed();
        return this.register(token, {
          useValue: instance
        });
      }
      registerSingleton(from, to) {
        this.ensureNotDisposed();
        if (providers_1.isNormalToken(from)) {
          if (providers_1.isNormalToken(to)) {
            return this.register(from, {
              useToken: to
            }, { lifecycle: lifecycle_1.default.Singleton });
          } else if (to) {
            return this.register(from, {
              useClass: to
            }, { lifecycle: lifecycle_1.default.Singleton });
          }
          throw new Error('Cannot register a type name as a singleton without a "to" token');
        }
        let useClass = from;
        if (to && !providers_1.isNormalToken(to)) {
          useClass = to;
        }
        return this.register(from, {
          useClass
        }, { lifecycle: lifecycle_1.default.Singleton });
      }
      resolve(token, context = new resolution_context_1.default()) {
        this.ensureNotDisposed();
        const registration = this.getRegistration(token);
        if (!registration && providers_1.isNormalToken(token)) {
          throw new Error(`Attempted to resolve unregistered dependency token: "${token.toString()}"`);
        }
        this.executePreResolutionInterceptor(token, "Single");
        if (registration) {
          const result2 = this.resolveRegistration(registration, context);
          this.executePostResolutionInterceptor(token, result2, "Single");
          return result2;
        }
        if (injection_token_1.isConstructorToken(token)) {
          const result2 = this.construct(token, context);
          this.executePostResolutionInterceptor(token, result2, "Single");
          return result2;
        }
        throw new Error("Attempted to construct an undefined constructor. Could mean a circular dependency problem. Try using `delay` function.");
      }
      executePreResolutionInterceptor(token, resolutionType) {
        if (this.interceptors.preResolution.has(token)) {
          const remainingInterceptors = [];
          for (const interceptor of this.interceptors.preResolution.getAll(token)) {
            if (interceptor.options.frequency != "Once") {
              remainingInterceptors.push(interceptor);
            }
            interceptor.callback(token, resolutionType);
          }
          this.interceptors.preResolution.setAll(token, remainingInterceptors);
        }
      }
      executePostResolutionInterceptor(token, result2, resolutionType) {
        if (this.interceptors.postResolution.has(token)) {
          const remainingInterceptors = [];
          for (const interceptor of this.interceptors.postResolution.getAll(token)) {
            if (interceptor.options.frequency != "Once") {
              remainingInterceptors.push(interceptor);
            }
            interceptor.callback(token, result2, resolutionType);
          }
          this.interceptors.postResolution.setAll(token, remainingInterceptors);
        }
      }
      resolveRegistration(registration, context) {
        this.ensureNotDisposed();
        if (registration.options.lifecycle === lifecycle_1.default.ResolutionScoped && context.scopedResolutions.has(registration)) {
          return context.scopedResolutions.get(registration);
        }
        const isSingleton = registration.options.lifecycle === lifecycle_1.default.Singleton;
        const isContainerScoped = registration.options.lifecycle === lifecycle_1.default.ContainerScoped;
        const returnInstance = isSingleton || isContainerScoped;
        let resolved;
        if (providers_1.isValueProvider(registration.provider)) {
          resolved = registration.provider.useValue;
        } else if (providers_1.isTokenProvider(registration.provider)) {
          resolved = returnInstance ? registration.instance || (registration.instance = this.resolve(registration.provider.useToken, context)) : this.resolve(registration.provider.useToken, context);
        } else if (providers_1.isClassProvider(registration.provider)) {
          resolved = returnInstance ? registration.instance || (registration.instance = this.construct(registration.provider.useClass, context)) : this.construct(registration.provider.useClass, context);
        } else if (providers_1.isFactoryProvider(registration.provider)) {
          resolved = registration.provider.useFactory(this);
        } else {
          resolved = this.construct(registration.provider, context);
        }
        if (registration.options.lifecycle === lifecycle_1.default.ResolutionScoped) {
          context.scopedResolutions.set(registration, resolved);
        }
        return resolved;
      }
      resolveAll(token, context = new resolution_context_1.default()) {
        this.ensureNotDisposed();
        const registrations = this.getAllRegistrations(token);
        if (!registrations && providers_1.isNormalToken(token)) {
          throw new Error(`Attempted to resolve unregistered dependency token: "${token.toString()}"`);
        }
        this.executePreResolutionInterceptor(token, "All");
        if (registrations) {
          const result3 = registrations.map((item) => this.resolveRegistration(item, context));
          this.executePostResolutionInterceptor(token, result3, "All");
          return result3;
        }
        const result2 = [this.construct(token, context)];
        this.executePostResolutionInterceptor(token, result2, "All");
        return result2;
      }
      isRegistered(token, recursive = false) {
        this.ensureNotDisposed();
        return this._registry.has(token) || recursive && (this.parent || false) && this.parent.isRegistered(token, true);
      }
      reset() {
        this.ensureNotDisposed();
        this._registry.clear();
        this.interceptors.preResolution.clear();
        this.interceptors.postResolution.clear();
      }
      clearInstances() {
        this.ensureNotDisposed();
        for (const [token, registrations] of this._registry.entries()) {
          this._registry.setAll(token, registrations.filter((registration) => !providers_1.isValueProvider(registration.provider)).map((registration) => {
            registration.instance = void 0;
            return registration;
          }));
        }
      }
      createChildContainer() {
        this.ensureNotDisposed();
        const childContainer = new _InternalDependencyContainer(this);
        for (const [token, registrations] of this._registry.entries()) {
          if (registrations.some(({ options }) => options.lifecycle === lifecycle_1.default.ContainerScoped)) {
            childContainer._registry.setAll(token, registrations.map((registration) => {
              if (registration.options.lifecycle === lifecycle_1.default.ContainerScoped) {
                return {
                  provider: registration.provider,
                  options: registration.options
                };
              }
              return registration;
            }));
          }
        }
        return childContainer;
      }
      beforeResolution(token, callback, options = { frequency: "Always" }) {
        this.interceptors.preResolution.set(token, {
          callback,
          options
        });
      }
      afterResolution(token, callback, options = { frequency: "Always" }) {
        this.interceptors.postResolution.set(token, {
          callback,
          options
        });
      }
      dispose() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
          this.disposed = true;
          const promises = [];
          this.disposables.forEach((disposable) => {
            const maybePromise = disposable.dispose();
            if (maybePromise) {
              promises.push(maybePromise);
            }
          });
          yield Promise.all(promises);
        });
      }
      getRegistration(token) {
        if (this.isRegistered(token)) {
          return this._registry.get(token);
        }
        if (this.parent) {
          return this.parent.getRegistration(token);
        }
        return null;
      }
      getAllRegistrations(token) {
        if (this.isRegistered(token)) {
          return this._registry.getAll(token);
        }
        if (this.parent) {
          return this.parent.getAllRegistrations(token);
        }
        return null;
      }
      construct(ctor, context) {
        if (ctor instanceof lazy_helpers_1.DelayedConstructor) {
          return ctor.createProxy((target) => this.resolve(target, context));
        }
        const instance = (() => {
          const paramInfo = exports2.typeInfo.get(ctor);
          if (!paramInfo || paramInfo.length === 0) {
            if (ctor.length === 0) {
              return new ctor();
            } else {
              throw new Error(`TypeInfo not known for "${ctor.name}"`);
            }
          }
          const params = paramInfo.map(this.resolveParams(context, ctor));
          return new ctor(...params);
        })();
        if (disposable_1.isDisposable(instance)) {
          this.disposables.add(instance);
        }
        return instance;
      }
      resolveParams(context, ctor) {
        return (param, idx) => {
          try {
            if (injection_token_1.isTokenDescriptor(param)) {
              if (injection_token_1.isTransformDescriptor(param)) {
                return param.multiple ? this.resolve(param.transform).transform(this.resolveAll(param.token), ...param.transformArgs) : this.resolve(param.transform).transform(this.resolve(param.token, context), ...param.transformArgs);
              } else {
                return param.multiple ? this.resolveAll(param.token) : this.resolve(param.token, context);
              }
            } else if (injection_token_1.isTransformDescriptor(param)) {
              return this.resolve(param.transform, context).transform(this.resolve(param.token, context), ...param.transformArgs);
            }
            return this.resolve(param, context);
          } catch (e) {
            throw new Error(error_helpers_1.formatErrorCtor(ctor, idx, e));
          }
        };
      }
      ensureNotDisposed() {
        if (this.disposed) {
          throw new Error("This container has been disposed, you cannot interact with a disposed container");
        }
      }
    };
    exports2.instance = new InternalDependencyContainer();
    exports2.default = exports2.instance;
  }
});

// node_modules/tsyringe/dist/cjs/decorators/auto-injectable.js
var require_auto_injectable = __commonJS({
  "node_modules/tsyringe/dist/cjs/decorators/auto-injectable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var reflection_helpers_1 = require_reflection_helpers();
    var dependency_container_1 = require_dependency_container();
    var injection_token_1 = require_injection_token();
    var error_helpers_1 = require_error_helpers();
    function autoInjectable() {
      return function(target) {
        const paramInfo = reflection_helpers_1.getParamInfo(target);
        return class extends target {
          constructor(...args) {
            super(...args.concat(paramInfo.slice(args.length).map((type, index) => {
              try {
                if (injection_token_1.isTokenDescriptor(type)) {
                  if (injection_token_1.isTransformDescriptor(type)) {
                    return type.multiple ? dependency_container_1.instance.resolve(type.transform).transform(dependency_container_1.instance.resolveAll(type.token), ...type.transformArgs) : dependency_container_1.instance.resolve(type.transform).transform(dependency_container_1.instance.resolve(type.token), ...type.transformArgs);
                  } else {
                    return type.multiple ? dependency_container_1.instance.resolveAll(type.token) : dependency_container_1.instance.resolve(type.token);
                  }
                } else if (injection_token_1.isTransformDescriptor(type)) {
                  return dependency_container_1.instance.resolve(type.transform).transform(dependency_container_1.instance.resolve(type.token), ...type.transformArgs);
                }
                return dependency_container_1.instance.resolve(type);
              } catch (e) {
                const argIndex = index + args.length;
                throw new Error(error_helpers_1.formatErrorCtor(target, argIndex, e));
              }
            })));
          }
        };
      };
    }
    exports2.default = autoInjectable;
  }
});

// node_modules/tsyringe/dist/cjs/decorators/inject.js
var require_inject = __commonJS({
  "node_modules/tsyringe/dist/cjs/decorators/inject.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var reflection_helpers_1 = require_reflection_helpers();
    function inject(token) {
      return reflection_helpers_1.defineInjectionTokenMetadata(token);
    }
    exports2.default = inject;
  }
});

// node_modules/tsyringe/dist/cjs/decorators/injectable.js
var require_injectable = __commonJS({
  "node_modules/tsyringe/dist/cjs/decorators/injectable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var reflection_helpers_1 = require_reflection_helpers();
    var dependency_container_1 = require_dependency_container();
    function injectable() {
      return function(target) {
        dependency_container_1.typeInfo.set(target, reflection_helpers_1.getParamInfo(target));
      };
    }
    exports2.default = injectable;
  }
});

// node_modules/tsyringe/dist/cjs/decorators/registry.js
var require_registry2 = __commonJS({
  "node_modules/tsyringe/dist/cjs/decorators/registry.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var tslib_1 = (init_tslib_es62(), __toCommonJS(tslib_es6_exports2));
    var dependency_container_1 = require_dependency_container();
    function registry(registrations = []) {
      return function(target) {
        registrations.forEach((_a) => {
          var { token, options } = _a, provider = tslib_1.__rest(_a, ["token", "options"]);
          return dependency_container_1.instance.register(token, provider, options);
        });
        return target;
      };
    }
    exports2.default = registry;
  }
});

// node_modules/tsyringe/dist/cjs/decorators/singleton.js
var require_singleton = __commonJS({
  "node_modules/tsyringe/dist/cjs/decorators/singleton.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var injectable_1 = require_injectable();
    var dependency_container_1 = require_dependency_container();
    function singleton() {
      return function(target) {
        injectable_1.default()(target);
        dependency_container_1.instance.registerSingleton(target);
      };
    }
    exports2.default = singleton;
  }
});

// node_modules/tsyringe/dist/cjs/decorators/inject-all.js
var require_inject_all = __commonJS({
  "node_modules/tsyringe/dist/cjs/decorators/inject-all.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var reflection_helpers_1 = require_reflection_helpers();
    function injectAll(token) {
      const data = { token, multiple: true };
      return reflection_helpers_1.defineInjectionTokenMetadata(data);
    }
    exports2.default = injectAll;
  }
});

// node_modules/tsyringe/dist/cjs/decorators/inject-all-with-transform.js
var require_inject_all_with_transform = __commonJS({
  "node_modules/tsyringe/dist/cjs/decorators/inject-all-with-transform.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var reflection_helpers_1 = require_reflection_helpers();
    function injectAllWithTransform(token, transformer, ...args) {
      const data = {
        token,
        multiple: true,
        transform: transformer,
        transformArgs: args
      };
      return reflection_helpers_1.defineInjectionTokenMetadata(data);
    }
    exports2.default = injectAllWithTransform;
  }
});

// node_modules/tsyringe/dist/cjs/decorators/inject-with-transform.js
var require_inject_with_transform = __commonJS({
  "node_modules/tsyringe/dist/cjs/decorators/inject-with-transform.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var reflection_helpers_1 = require_reflection_helpers();
    function injectWithTransform(token, transformer, ...args) {
      return reflection_helpers_1.defineInjectionTokenMetadata(token, {
        transformToken: transformer,
        args
      });
    }
    exports2.default = injectWithTransform;
  }
});

// node_modules/tsyringe/dist/cjs/decorators/scoped.js
var require_scoped = __commonJS({
  "node_modules/tsyringe/dist/cjs/decorators/scoped.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var injectable_1 = require_injectable();
    var dependency_container_1 = require_dependency_container();
    function scoped(lifecycle, token) {
      return function(target) {
        injectable_1.default()(target);
        dependency_container_1.instance.register(token || target, target, {
          lifecycle
        });
      };
    }
    exports2.default = scoped;
  }
});

// node_modules/tsyringe/dist/cjs/decorators/index.js
var require_decorators2 = __commonJS({
  "node_modules/tsyringe/dist/cjs/decorators/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var auto_injectable_1 = require_auto_injectable();
    Object.defineProperty(exports2, "autoInjectable", { enumerable: true, get: function() {
      return auto_injectable_1.default;
    } });
    var inject_1 = require_inject();
    Object.defineProperty(exports2, "inject", { enumerable: true, get: function() {
      return inject_1.default;
    } });
    var injectable_1 = require_injectable();
    Object.defineProperty(exports2, "injectable", { enumerable: true, get: function() {
      return injectable_1.default;
    } });
    var registry_1 = require_registry2();
    Object.defineProperty(exports2, "registry", { enumerable: true, get: function() {
      return registry_1.default;
    } });
    var singleton_1 = require_singleton();
    Object.defineProperty(exports2, "singleton", { enumerable: true, get: function() {
      return singleton_1.default;
    } });
    var inject_all_1 = require_inject_all();
    Object.defineProperty(exports2, "injectAll", { enumerable: true, get: function() {
      return inject_all_1.default;
    } });
    var inject_all_with_transform_1 = require_inject_all_with_transform();
    Object.defineProperty(exports2, "injectAllWithTransform", { enumerable: true, get: function() {
      return inject_all_with_transform_1.default;
    } });
    var inject_with_transform_1 = require_inject_with_transform();
    Object.defineProperty(exports2, "injectWithTransform", { enumerable: true, get: function() {
      return inject_with_transform_1.default;
    } });
    var scoped_1 = require_scoped();
    Object.defineProperty(exports2, "scoped", { enumerable: true, get: function() {
      return scoped_1.default;
    } });
  }
});

// node_modules/tsyringe/dist/cjs/factories/instance-caching-factory.js
var require_instance_caching_factory = __commonJS({
  "node_modules/tsyringe/dist/cjs/factories/instance-caching-factory.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    function instanceCachingFactory(factoryFunc) {
      let instance;
      return (dependencyContainer) => {
        if (instance == void 0) {
          instance = factoryFunc(dependencyContainer);
        }
        return instance;
      };
    }
    exports2.default = instanceCachingFactory;
  }
});

// node_modules/tsyringe/dist/cjs/factories/instance-per-container-caching-factory.js
var require_instance_per_container_caching_factory = __commonJS({
  "node_modules/tsyringe/dist/cjs/factories/instance-per-container-caching-factory.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    function instancePerContainerCachingFactory(factoryFunc) {
      const cache = /* @__PURE__ */ new WeakMap();
      return (dependencyContainer) => {
        let instance = cache.get(dependencyContainer);
        if (instance == void 0) {
          instance = factoryFunc(dependencyContainer);
          cache.set(dependencyContainer, instance);
        }
        return instance;
      };
    }
    exports2.default = instancePerContainerCachingFactory;
  }
});

// node_modules/tsyringe/dist/cjs/factories/predicate-aware-class-factory.js
var require_predicate_aware_class_factory = __commonJS({
  "node_modules/tsyringe/dist/cjs/factories/predicate-aware-class-factory.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    function predicateAwareClassFactory(predicate, trueConstructor, falseConstructor, useCaching = true) {
      let instance;
      let previousPredicate;
      return (dependencyContainer) => {
        const currentPredicate = predicate(dependencyContainer);
        if (!useCaching || previousPredicate !== currentPredicate) {
          if (previousPredicate = currentPredicate) {
            instance = dependencyContainer.resolve(trueConstructor);
          } else {
            instance = dependencyContainer.resolve(falseConstructor);
          }
        }
        return instance;
      };
    }
    exports2.default = predicateAwareClassFactory;
  }
});

// node_modules/tsyringe/dist/cjs/factories/index.js
var require_factories = __commonJS({
  "node_modules/tsyringe/dist/cjs/factories/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var instance_caching_factory_1 = require_instance_caching_factory();
    Object.defineProperty(exports2, "instanceCachingFactory", { enumerable: true, get: function() {
      return instance_caching_factory_1.default;
    } });
    var instance_per_container_caching_factory_1 = require_instance_per_container_caching_factory();
    Object.defineProperty(exports2, "instancePerContainerCachingFactory", { enumerable: true, get: function() {
      return instance_per_container_caching_factory_1.default;
    } });
    var predicate_aware_class_factory_1 = require_predicate_aware_class_factory();
    Object.defineProperty(exports2, "predicateAwareClassFactory", { enumerable: true, get: function() {
      return predicate_aware_class_factory_1.default;
    } });
  }
});

// node_modules/tsyringe/dist/cjs/index.js
var require_cjs8 = __commonJS({
  "node_modules/tsyringe/dist/cjs/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var tslib_1 = (init_tslib_es62(), __toCommonJS(tslib_es6_exports2));
    if (typeof Reflect === "undefined" || !Reflect.getMetadata) {
      throw new Error(`tsyringe requires a reflect polyfill. Please add 'import "reflect-metadata"' to the top of your entry point.`);
    }
    var types_1 = require_types5();
    Object.defineProperty(exports2, "Lifecycle", { enumerable: true, get: function() {
      return types_1.Lifecycle;
    } });
    tslib_1.__exportStar(require_decorators2(), exports2);
    tslib_1.__exportStar(require_factories(), exports2);
    tslib_1.__exportStar(require_providers(), exports2);
    var lazy_helpers_1 = require_lazy_helpers();
    Object.defineProperty(exports2, "delay", { enumerable: true, get: function() {
      return lazy_helpers_1.delay;
    } });
    var dependency_container_1 = require_dependency_container();
    Object.defineProperty(exports2, "container", { enumerable: true, get: function() {
      return dependency_container_1.instance;
    } });
  }
});

// node_modules/@peculiar/asn1-pfx/build/cjs/attribute.js
var require_attribute3 = __commonJS({
  "node_modules/@peculiar/asn1-pfx/build/cjs/attribute.js"(exports2) {
    "use strict";
    var PKCS12AttrSet_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PKCS12AttrSet = exports2.PKCS12Attribute = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var PKCS12Attribute = class {
      constructor(params = {}) {
        this.attrId = "";
        this.attrValues = [];
        Object.assign(params);
      }
    };
    exports2.PKCS12Attribute = PKCS12Attribute;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], PKCS12Attribute.prototype, "attrId", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Any, repeated: "set" })
    ], PKCS12Attribute.prototype, "attrValues", void 0);
    var PKCS12AttrSet = PKCS12AttrSet_1 = class PKCS12AttrSet extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, PKCS12AttrSet_1.prototype);
      }
    };
    exports2.PKCS12AttrSet = PKCS12AttrSet;
    exports2.PKCS12AttrSet = PKCS12AttrSet = PKCS12AttrSet_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: PKCS12Attribute })
    ], PKCS12AttrSet);
  }
});

// node_modules/@peculiar/asn1-pfx/build/cjs/authenticated_safe.js
var require_authenticated_safe = __commonJS({
  "node_modules/@peculiar/asn1-pfx/build/cjs/authenticated_safe.js"(exports2) {
    "use strict";
    var AuthenticatedSafe_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AuthenticatedSafe = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_cms_1 = require_cjs5();
    var AuthenticatedSafe = AuthenticatedSafe_1 = class AuthenticatedSafe extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, AuthenticatedSafe_1.prototype);
      }
    };
    exports2.AuthenticatedSafe = AuthenticatedSafe;
    exports2.AuthenticatedSafe = AuthenticatedSafe = AuthenticatedSafe_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: asn1_cms_1.ContentInfo })
    ], AuthenticatedSafe);
  }
});

// node_modules/@peculiar/asn1-pfx/build/cjs/object_identifiers.js
var require_object_identifiers6 = __commonJS({
  "node_modules/@peculiar/asn1-pfx/build/cjs/object_identifiers.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.id_bagtypes = exports2.id_pbewithSHAAnd40BitRC2_CBC = exports2.id_pbeWithSHAAnd128BitRC2_CBC = exports2.id_pbeWithSHAAnd2_KeyTripleDES_CBC = exports2.id_pbeWithSHAAnd3_KeyTripleDES_CBC = exports2.id_pbeWithSHAAnd40BitRC4 = exports2.id_pbeWithSHAAnd128BitRC4 = exports2.id_pkcs_12PbeIds = exports2.id_pkcs_12 = exports2.id_pkcs = exports2.id_rsadsi = void 0;
    exports2.id_rsadsi = "1.2.840.113549";
    exports2.id_pkcs = `${exports2.id_rsadsi}.1`;
    exports2.id_pkcs_12 = `${exports2.id_pkcs}.12`;
    exports2.id_pkcs_12PbeIds = `${exports2.id_pkcs_12}.1`;
    exports2.id_pbeWithSHAAnd128BitRC4 = `${exports2.id_pkcs_12PbeIds}.1`;
    exports2.id_pbeWithSHAAnd40BitRC4 = `${exports2.id_pkcs_12PbeIds}.2`;
    exports2.id_pbeWithSHAAnd3_KeyTripleDES_CBC = `${exports2.id_pkcs_12PbeIds}.3`;
    exports2.id_pbeWithSHAAnd2_KeyTripleDES_CBC = `${exports2.id_pkcs_12PbeIds}.4`;
    exports2.id_pbeWithSHAAnd128BitRC2_CBC = `${exports2.id_pkcs_12PbeIds}.5`;
    exports2.id_pbewithSHAAnd40BitRC2_CBC = `${exports2.id_pkcs_12PbeIds}.6`;
    exports2.id_bagtypes = `${exports2.id_pkcs_12}.10.1`;
  }
});

// node_modules/@peculiar/asn1-pfx/build/cjs/bags/types.js
var require_types6 = __commonJS({
  "node_modules/@peculiar/asn1-pfx/build/cjs/bags/types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.id_pkcs_9 = exports2.id_SafeContents = exports2.id_SecretBag = exports2.id_CRLBag = exports2.id_certBag = exports2.id_pkcs8ShroudedKeyBag = exports2.id_keyBag = void 0;
    var object_identifiers_1 = require_object_identifiers6();
    exports2.id_keyBag = `${object_identifiers_1.id_bagtypes}.1`;
    exports2.id_pkcs8ShroudedKeyBag = `${object_identifiers_1.id_bagtypes}.2`;
    exports2.id_certBag = `${object_identifiers_1.id_bagtypes}.3`;
    exports2.id_CRLBag = `${object_identifiers_1.id_bagtypes}.4`;
    exports2.id_SecretBag = `${object_identifiers_1.id_bagtypes}.5`;
    exports2.id_SafeContents = `${object_identifiers_1.id_bagtypes}.6`;
    exports2.id_pkcs_9 = "1.2.840.113549.1.9";
  }
});

// node_modules/@peculiar/asn1-pfx/build/cjs/bags/cert_bag.js
var require_cert_bag = __commonJS({
  "node_modules/@peculiar/asn1-pfx/build/cjs/bags/cert_bag.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.id_sdsiCertificate = exports2.id_x509Certificate = exports2.id_certTypes = exports2.CertBag = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var types_1 = require_types6();
    var CertBag = class {
      constructor(params = {}) {
        this.certId = "";
        this.certValue = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.CertBag = CertBag;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], CertBag.prototype, "certId", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Any, context: 0 })
    ], CertBag.prototype, "certValue", void 0);
    exports2.id_certTypes = `${types_1.id_pkcs_9}.22`;
    exports2.id_x509Certificate = `${exports2.id_certTypes}.1`;
    exports2.id_sdsiCertificate = `${exports2.id_certTypes}.2`;
  }
});

// node_modules/@peculiar/asn1-pfx/build/cjs/bags/crl_bag.js
var require_crl_bag = __commonJS({
  "node_modules/@peculiar/asn1-pfx/build/cjs/bags/crl_bag.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.id_x509CRL = exports2.id_crlTypes = exports2.CRLBag = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var types_1 = require_types6();
    var CRLBag = class {
      constructor(params = {}) {
        this.crlId = "";
        this.crltValue = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.CRLBag = CRLBag;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], CRLBag.prototype, "crlId", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Any, context: 0 })
    ], CRLBag.prototype, "crltValue", void 0);
    exports2.id_crlTypes = `${types_1.id_pkcs_9}.23`;
    exports2.id_x509CRL = `${exports2.id_crlTypes}.1`;
  }
});

// node_modules/@peculiar/asn1-pkcs8/build/cjs/encrypted_private_key_info.js
var require_encrypted_private_key_info = __commonJS({
  "node_modules/@peculiar/asn1-pkcs8/build/cjs/encrypted_private_key_info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EncryptedPrivateKeyInfo = exports2.EncryptedData = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    var EncryptedData = class extends asn1_schema_1.OctetString {
    };
    exports2.EncryptedData = EncryptedData;
    var EncryptedPrivateKeyInfo = class {
      constructor(params = {}) {
        this.encryptionAlgorithm = new asn1_x509_1.AlgorithmIdentifier();
        this.encryptedData = new EncryptedData();
        Object.assign(this, params);
      }
    };
    exports2.EncryptedPrivateKeyInfo = EncryptedPrivateKeyInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.AlgorithmIdentifier })
    ], EncryptedPrivateKeyInfo.prototype, "encryptionAlgorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: EncryptedData })
    ], EncryptedPrivateKeyInfo.prototype, "encryptedData", void 0);
  }
});

// node_modules/@peculiar/asn1-pkcs8/build/cjs/private_key_info.js
var require_private_key_info = __commonJS({
  "node_modules/@peculiar/asn1-pkcs8/build/cjs/private_key_info.js"(exports2) {
    "use strict";
    var Attributes_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PrivateKeyInfo = exports2.Attributes = exports2.PrivateKey = exports2.Version = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    var Version;
    (function(Version2) {
      Version2[Version2["v1"] = 0] = "v1";
    })(Version || (exports2.Version = Version = {}));
    var PrivateKey = class extends asn1_schema_1.OctetString {
    };
    exports2.PrivateKey = PrivateKey;
    var Attributes = Attributes_1 = class Attributes extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, Attributes_1.prototype);
      }
    };
    exports2.Attributes = Attributes;
    exports2.Attributes = Attributes = Attributes_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: asn1_x509_1.Attribute })
    ], Attributes);
    var PrivateKeyInfo = class {
      constructor(params = {}) {
        this.version = Version.v1;
        this.privateKeyAlgorithm = new asn1_x509_1.AlgorithmIdentifier();
        this.privateKey = new PrivateKey();
        Object.assign(this, params);
      }
    };
    exports2.PrivateKeyInfo = PrivateKeyInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer })
    ], PrivateKeyInfo.prototype, "version", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.AlgorithmIdentifier })
    ], PrivateKeyInfo.prototype, "privateKeyAlgorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: PrivateKey })
    ], PrivateKeyInfo.prototype, "privateKey", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: Attributes, implicit: true, context: 0, optional: true })
    ], PrivateKeyInfo.prototype, "attributes", void 0);
  }
});

// node_modules/@peculiar/asn1-pkcs8/build/cjs/index.js
var require_cjs9 = __commonJS({
  "node_modules/@peculiar/asn1-pkcs8/build/cjs/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    tslib_1.__exportStar(require_encrypted_private_key_info(), exports2);
    tslib_1.__exportStar(require_private_key_info(), exports2);
  }
});

// node_modules/@peculiar/asn1-pfx/build/cjs/bags/key_bag.js
var require_key_bag = __commonJS({
  "node_modules/@peculiar/asn1-pfx/build/cjs/bags/key_bag.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.KeyBag = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_pkcs8_1 = require_cjs9();
    var asn1_schema_1 = require_cjs2();
    var KeyBag = class KeyBag extends asn1_pkcs8_1.PrivateKeyInfo {
    };
    exports2.KeyBag = KeyBag;
    exports2.KeyBag = KeyBag = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence })
    ], KeyBag);
  }
});

// node_modules/@peculiar/asn1-pfx/build/cjs/bags/pkcs8_shrouded_key_bag.js
var require_pkcs8_shrouded_key_bag = __commonJS({
  "node_modules/@peculiar/asn1-pfx/build/cjs/bags/pkcs8_shrouded_key_bag.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PKCS8ShroudedKeyBag = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_pkcs8_1 = require_cjs9();
    var asn1_schema_1 = require_cjs2();
    var PKCS8ShroudedKeyBag = class PKCS8ShroudedKeyBag extends asn1_pkcs8_1.EncryptedPrivateKeyInfo {
    };
    exports2.PKCS8ShroudedKeyBag = PKCS8ShroudedKeyBag;
    exports2.PKCS8ShroudedKeyBag = PKCS8ShroudedKeyBag = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence })
    ], PKCS8ShroudedKeyBag);
  }
});

// node_modules/@peculiar/asn1-pfx/build/cjs/bags/secret_bag.js
var require_secret_bag = __commonJS({
  "node_modules/@peculiar/asn1-pfx/build/cjs/bags/secret_bag.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SecretBag = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var SecretBag = class {
      constructor(params = {}) {
        this.secretTypeId = "";
        this.secretValue = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.SecretBag = SecretBag;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], SecretBag.prototype, "secretTypeId", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Any, context: 0 })
    ], SecretBag.prototype, "secretValue", void 0);
  }
});

// node_modules/@peculiar/asn1-pfx/build/cjs/bags/index.js
var require_bags = __commonJS({
  "node_modules/@peculiar/asn1-pfx/build/cjs/bags/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    tslib_1.__exportStar(require_cert_bag(), exports2);
    tslib_1.__exportStar(require_crl_bag(), exports2);
    tslib_1.__exportStar(require_key_bag(), exports2);
    tslib_1.__exportStar(require_pkcs8_shrouded_key_bag(), exports2);
    tslib_1.__exportStar(require_secret_bag(), exports2);
    tslib_1.__exportStar(require_types6(), exports2);
  }
});

// node_modules/@peculiar/asn1-pfx/build/cjs/mac_data.js
var require_mac_data = __commonJS({
  "node_modules/@peculiar/asn1-pfx/build/cjs/mac_data.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.MacData = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_rsa_1 = require_cjs7();
    var asn1_schema_1 = require_cjs2();
    var MacData = class {
      constructor(params = {}) {
        this.mac = new asn1_rsa_1.DigestInfo();
        this.macSalt = new asn1_schema_1.OctetString();
        this.iterations = 1;
        Object.assign(this, params);
      }
    };
    exports2.MacData = MacData;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_rsa_1.DigestInfo })
    ], MacData.prototype, "mac", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.OctetString })
    ], MacData.prototype, "macSalt", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer, defaultValue: 1 })
    ], MacData.prototype, "iterations", void 0);
  }
});

// node_modules/@peculiar/asn1-pfx/build/cjs/pfx.js
var require_pfx = __commonJS({
  "node_modules/@peculiar/asn1-pfx/build/cjs/pfx.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PFX = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_cms_1 = require_cjs5();
    var mac_data_1 = require_mac_data();
    var PFX = class {
      constructor(params = {}) {
        this.version = 3;
        this.authSafe = new asn1_cms_1.ContentInfo();
        this.macData = new mac_data_1.MacData();
        Object.assign(this, params);
      }
    };
    exports2.PFX = PFX;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer })
    ], PFX.prototype, "version", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_cms_1.ContentInfo })
    ], PFX.prototype, "authSafe", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: mac_data_1.MacData, optional: true })
    ], PFX.prototype, "macData", void 0);
  }
});

// node_modules/@peculiar/asn1-pfx/build/cjs/safe_bag.js
var require_safe_bag = __commonJS({
  "node_modules/@peculiar/asn1-pfx/build/cjs/safe_bag.js"(exports2) {
    "use strict";
    var SafeContents_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SafeContents = exports2.SafeBag = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var attribute_1 = require_attribute3();
    var SafeBag = class {
      constructor(params = {}) {
        this.bagId = "";
        this.bagValue = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.SafeBag = SafeBag;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], SafeBag.prototype, "bagId", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Any, context: 0 })
    ], SafeBag.prototype, "bagValue", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: attribute_1.PKCS12Attribute, repeated: "set", optional: true })
    ], SafeBag.prototype, "bagAttributes", void 0);
    var SafeContents = SafeContents_1 = class SafeContents extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, SafeContents_1.prototype);
      }
    };
    exports2.SafeContents = SafeContents;
    exports2.SafeContents = SafeContents = SafeContents_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: SafeBag })
    ], SafeContents);
  }
});

// node_modules/@peculiar/asn1-pfx/build/cjs/index.js
var require_cjs10 = __commonJS({
  "node_modules/@peculiar/asn1-pfx/build/cjs/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    tslib_1.__exportStar(require_attribute3(), exports2);
    tslib_1.__exportStar(require_authenticated_safe(), exports2);
    tslib_1.__exportStar(require_bags(), exports2);
    tslib_1.__exportStar(require_mac_data(), exports2);
    tslib_1.__exportStar(require_object_identifiers6(), exports2);
    tslib_1.__exportStar(require_pfx(), exports2);
    tslib_1.__exportStar(require_safe_bag(), exports2);
  }
});

// node_modules/@peculiar/asn1-pkcs9/build/cjs/index.js
var require_cjs11 = __commonJS({
  "node_modules/@peculiar/asn1-pkcs9/build/cjs/index.js"(exports2) {
    "use strict";
    var ExtensionRequest_1;
    var ExtendedCertificateAttributes_1;
    var SMIMECapabilities_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.DateOfBirth = exports2.UnstructuredAddress = exports2.UnstructuredName = exports2.EmailAddress = exports2.EncryptedPrivateKeyInfo = exports2.UserPKCS12 = exports2.Pkcs7PDU = exports2.PKCS9String = exports2.id_at_pseudonym = exports2.crlTypes = exports2.id_certTypes = exports2.id_smime = exports2.id_pkcs9_mr_signingTimeMatch = exports2.id_pkcs9_mr_caseIgnoreMatch = exports2.id_pkcs9_sx_signingTime = exports2.id_pkcs9_sx_pkcs9String = exports2.id_pkcs9_at_countryOfResidence = exports2.id_pkcs9_at_countryOfCitizenship = exports2.id_pkcs9_at_gender = exports2.id_pkcs9_at_placeOfBirth = exports2.id_pkcs9_at_dateOfBirth = exports2.id_ietf_at = exports2.id_pkcs9_at_pkcs7PDU = exports2.id_pkcs9_at_sequenceNumber = exports2.id_pkcs9_at_randomNonce = exports2.id_pkcs9_at_encryptedPrivateKeyInfo = exports2.id_pkcs9_at_pkcs15Token = exports2.id_pkcs9_at_userPKCS12 = exports2.id_pkcs9_at_localKeyId = exports2.id_pkcs9_at_friendlyName = exports2.id_pkcs9_at_smimeCapabilities = exports2.id_pkcs9_at_extensionRequest = exports2.id_pkcs9_at_signingDescription = exports2.id_pkcs9_at_extendedCertificateAttributes = exports2.id_pkcs9_at_unstructuredAddress = exports2.id_pkcs9_at_challengePassword = exports2.id_pkcs9_at_counterSignature = exports2.id_pkcs9_at_signingTime = exports2.id_pkcs9_at_messageDigest = exports2.id_pkcs9_at_contentType = exports2.id_pkcs9_at_unstructuredName = exports2.id_pkcs9_at_emailAddress = exports2.id_pkcs9_oc_naturalPerson = exports2.id_pkcs9_oc_pkcsEntity = exports2.id_pkcs9_mr = exports2.id_pkcs9_sx = exports2.id_pkcs9_at = exports2.id_pkcs9_oc = exports2.id_pkcs9_mo = exports2.id_pkcs9 = void 0;
    exports2.SMIMECapabilities = exports2.SMIMECapability = exports2.SigningDescription = exports2.LocalKeyId = exports2.FriendlyName = exports2.ExtendedCertificateAttributes = exports2.ExtensionRequest = exports2.ChallengePassword = exports2.CounterSignature = exports2.SequenceNumber = exports2.RandomNonce = exports2.SigningTime = exports2.MessageDigest = exports2.ContentType = exports2.Pseudonym = exports2.CountryOfResidence = exports2.CountryOfCitizenship = exports2.Gender = exports2.PlaceOfBirth = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var cms = require_cjs5();
    var pfx = require_cjs10();
    var pkcs8 = require_cjs9();
    var x509 = require_cjs3();
    var attr = require_cjs4();
    exports2.id_pkcs9 = "1.2.840.113549.1.9";
    exports2.id_pkcs9_mo = `${exports2.id_pkcs9}.0`;
    exports2.id_pkcs9_oc = `${exports2.id_pkcs9}.24`;
    exports2.id_pkcs9_at = `${exports2.id_pkcs9}.25`;
    exports2.id_pkcs9_sx = `${exports2.id_pkcs9}.26`;
    exports2.id_pkcs9_mr = `${exports2.id_pkcs9}.27`;
    exports2.id_pkcs9_oc_pkcsEntity = `${exports2.id_pkcs9_oc}.1`;
    exports2.id_pkcs9_oc_naturalPerson = `${exports2.id_pkcs9_oc}.2`;
    exports2.id_pkcs9_at_emailAddress = `${exports2.id_pkcs9}.1`;
    exports2.id_pkcs9_at_unstructuredName = `${exports2.id_pkcs9}.2`;
    exports2.id_pkcs9_at_contentType = `${exports2.id_pkcs9}.3`;
    exports2.id_pkcs9_at_messageDigest = `${exports2.id_pkcs9}.4`;
    exports2.id_pkcs9_at_signingTime = `${exports2.id_pkcs9}.5`;
    exports2.id_pkcs9_at_counterSignature = `${exports2.id_pkcs9}.6`;
    exports2.id_pkcs9_at_challengePassword = `${exports2.id_pkcs9}.7`;
    exports2.id_pkcs9_at_unstructuredAddress = `${exports2.id_pkcs9}.8`;
    exports2.id_pkcs9_at_extendedCertificateAttributes = `${exports2.id_pkcs9}.9`;
    exports2.id_pkcs9_at_signingDescription = `${exports2.id_pkcs9}.13`;
    exports2.id_pkcs9_at_extensionRequest = `${exports2.id_pkcs9}.14`;
    exports2.id_pkcs9_at_smimeCapabilities = `${exports2.id_pkcs9}.15`;
    exports2.id_pkcs9_at_friendlyName = `${exports2.id_pkcs9}.20`;
    exports2.id_pkcs9_at_localKeyId = `${exports2.id_pkcs9}.21`;
    exports2.id_pkcs9_at_userPKCS12 = `2.16.840.1.113730.3.1.216`;
    exports2.id_pkcs9_at_pkcs15Token = `${exports2.id_pkcs9_at}.1`;
    exports2.id_pkcs9_at_encryptedPrivateKeyInfo = `${exports2.id_pkcs9_at}.2`;
    exports2.id_pkcs9_at_randomNonce = `${exports2.id_pkcs9_at}.3`;
    exports2.id_pkcs9_at_sequenceNumber = `${exports2.id_pkcs9_at}.4`;
    exports2.id_pkcs9_at_pkcs7PDU = `${exports2.id_pkcs9_at}.5`;
    exports2.id_ietf_at = `1.3.6.1.5.5.7.9`;
    exports2.id_pkcs9_at_dateOfBirth = `${exports2.id_ietf_at}.1`;
    exports2.id_pkcs9_at_placeOfBirth = `${exports2.id_ietf_at}.2`;
    exports2.id_pkcs9_at_gender = `${exports2.id_ietf_at}.3`;
    exports2.id_pkcs9_at_countryOfCitizenship = `${exports2.id_ietf_at}.4`;
    exports2.id_pkcs9_at_countryOfResidence = `${exports2.id_ietf_at}.5`;
    exports2.id_pkcs9_sx_pkcs9String = `${exports2.id_pkcs9_sx}.1`;
    exports2.id_pkcs9_sx_signingTime = `${exports2.id_pkcs9_sx}.2`;
    exports2.id_pkcs9_mr_caseIgnoreMatch = `${exports2.id_pkcs9_mr}.1`;
    exports2.id_pkcs9_mr_signingTimeMatch = `${exports2.id_pkcs9_mr}.2`;
    exports2.id_smime = `${exports2.id_pkcs9}.16`;
    exports2.id_certTypes = `${exports2.id_pkcs9}.22`;
    exports2.crlTypes = `${exports2.id_pkcs9}.23`;
    exports2.id_at_pseudonym = `${attr.id_at}.65`;
    var PKCS9String = class PKCS9String extends x509.DirectoryString {
      constructor(params = {}) {
        super(params);
      }
      toString() {
        const o2 = {};
        o2.toString();
        return this.ia5String || super.toString();
      }
    };
    exports2.PKCS9String = PKCS9String;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.IA5String })
    ], PKCS9String.prototype, "ia5String", void 0);
    exports2.PKCS9String = PKCS9String = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], PKCS9String);
    var Pkcs7PDU = class Pkcs7PDU extends cms.ContentInfo {
    };
    exports2.Pkcs7PDU = Pkcs7PDU;
    exports2.Pkcs7PDU = Pkcs7PDU = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence })
    ], Pkcs7PDU);
    var UserPKCS12 = class UserPKCS12 extends pfx.PFX {
    };
    exports2.UserPKCS12 = UserPKCS12;
    exports2.UserPKCS12 = UserPKCS12 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence })
    ], UserPKCS12);
    var EncryptedPrivateKeyInfo = class EncryptedPrivateKeyInfo extends pkcs8.EncryptedPrivateKeyInfo {
    };
    exports2.EncryptedPrivateKeyInfo = EncryptedPrivateKeyInfo;
    exports2.EncryptedPrivateKeyInfo = EncryptedPrivateKeyInfo = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence })
    ], EncryptedPrivateKeyInfo);
    var EmailAddress = class EmailAddress {
      constructor(value = "") {
        this.value = value;
      }
      toString() {
        return this.value;
      }
    };
    exports2.EmailAddress = EmailAddress;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.IA5String })
    ], EmailAddress.prototype, "value", void 0);
    exports2.EmailAddress = EmailAddress = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], EmailAddress);
    var UnstructuredName = class UnstructuredName extends PKCS9String {
    };
    exports2.UnstructuredName = UnstructuredName;
    exports2.UnstructuredName = UnstructuredName = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], UnstructuredName);
    var UnstructuredAddress = class UnstructuredAddress extends x509.DirectoryString {
    };
    exports2.UnstructuredAddress = UnstructuredAddress;
    exports2.UnstructuredAddress = UnstructuredAddress = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], UnstructuredAddress);
    var DateOfBirth = class DateOfBirth {
      constructor(value = /* @__PURE__ */ new Date()) {
        this.value = value;
      }
    };
    exports2.DateOfBirth = DateOfBirth;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.GeneralizedTime })
    ], DateOfBirth.prototype, "value", void 0);
    exports2.DateOfBirth = DateOfBirth = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], DateOfBirth);
    var PlaceOfBirth = class PlaceOfBirth extends x509.DirectoryString {
    };
    exports2.PlaceOfBirth = PlaceOfBirth;
    exports2.PlaceOfBirth = PlaceOfBirth = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], PlaceOfBirth);
    var Gender = class Gender {
      constructor(value = "M") {
        this.value = value;
      }
      toString() {
        return this.value;
      }
    };
    exports2.Gender = Gender;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.PrintableString })
    ], Gender.prototype, "value", void 0);
    exports2.Gender = Gender = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], Gender);
    var CountryOfCitizenship = class CountryOfCitizenship {
      constructor(value = "") {
        this.value = value;
      }
      toString() {
        return this.value;
      }
    };
    exports2.CountryOfCitizenship = CountryOfCitizenship;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.PrintableString })
    ], CountryOfCitizenship.prototype, "value", void 0);
    exports2.CountryOfCitizenship = CountryOfCitizenship = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], CountryOfCitizenship);
    var CountryOfResidence = class CountryOfResidence extends CountryOfCitizenship {
    };
    exports2.CountryOfResidence = CountryOfResidence;
    exports2.CountryOfResidence = CountryOfResidence = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], CountryOfResidence);
    var Pseudonym = class Pseudonym extends x509.DirectoryString {
    };
    exports2.Pseudonym = Pseudonym;
    exports2.Pseudonym = Pseudonym = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], Pseudonym);
    var ContentType2 = class ContentType {
      constructor(value = "") {
        this.value = value;
      }
      toString() {
        return this.value;
      }
    };
    exports2.ContentType = ContentType2;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.ObjectIdentifier })
    ], ContentType2.prototype, "value", void 0);
    exports2.ContentType = ContentType2 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], ContentType2);
    var MessageDigest = class extends asn1_schema_1.OctetString {
    };
    exports2.MessageDigest = MessageDigest;
    var SigningTime = class SigningTime extends x509.Time {
    };
    exports2.SigningTime = SigningTime;
    exports2.SigningTime = SigningTime = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], SigningTime);
    var RandomNonce = class extends asn1_schema_1.OctetString {
    };
    exports2.RandomNonce = RandomNonce;
    var SequenceNumber = class SequenceNumber {
      constructor(value = 0) {
        this.value = value;
      }
      toString() {
        return this.value.toString();
      }
    };
    exports2.SequenceNumber = SequenceNumber;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer })
    ], SequenceNumber.prototype, "value", void 0);
    exports2.SequenceNumber = SequenceNumber = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], SequenceNumber);
    var CounterSignature = class CounterSignature extends cms.SignerInfo {
    };
    exports2.CounterSignature = CounterSignature;
    exports2.CounterSignature = CounterSignature = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence })
    ], CounterSignature);
    var ChallengePassword = class ChallengePassword extends x509.DirectoryString {
    };
    exports2.ChallengePassword = ChallengePassword;
    exports2.ChallengePassword = ChallengePassword = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], ChallengePassword);
    var ExtensionRequest = ExtensionRequest_1 = class ExtensionRequest extends x509.Extensions {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, ExtensionRequest_1.prototype);
      }
    };
    exports2.ExtensionRequest = ExtensionRequest;
    exports2.ExtensionRequest = ExtensionRequest = ExtensionRequest_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence })
    ], ExtensionRequest);
    var ExtendedCertificateAttributes = ExtendedCertificateAttributes_1 = class ExtendedCertificateAttributes extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, ExtendedCertificateAttributes_1.prototype);
      }
    };
    exports2.ExtendedCertificateAttributes = ExtendedCertificateAttributes;
    exports2.ExtendedCertificateAttributes = ExtendedCertificateAttributes = ExtendedCertificateAttributes_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Set, itemType: cms.Attribute })
    ], ExtendedCertificateAttributes);
    var FriendlyName = class FriendlyName {
      constructor(value = "") {
        this.value = value;
      }
      toString() {
        return this.value;
      }
    };
    exports2.FriendlyName = FriendlyName;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.BmpString })
    ], FriendlyName.prototype, "value", void 0);
    exports2.FriendlyName = FriendlyName = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Choice })
    ], FriendlyName);
    var LocalKeyId = class extends asn1_schema_1.OctetString {
    };
    exports2.LocalKeyId = LocalKeyId;
    var SigningDescription = class extends x509.DirectoryString {
    };
    exports2.SigningDescription = SigningDescription;
    var SMIMECapability = class SMIMECapability extends x509.AlgorithmIdentifier {
    };
    exports2.SMIMECapability = SMIMECapability;
    exports2.SMIMECapability = SMIMECapability = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence })
    ], SMIMECapability);
    var SMIMECapabilities = SMIMECapabilities_1 = class SMIMECapabilities extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, SMIMECapabilities_1.prototype);
      }
    };
    exports2.SMIMECapabilities = SMIMECapabilities;
    exports2.SMIMECapabilities = SMIMECapabilities = SMIMECapabilities_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: SMIMECapability })
    ], SMIMECapabilities);
  }
});

// node_modules/@peculiar/asn1-csr/build/cjs/attributes.js
var require_attributes2 = __commonJS({
  "node_modules/@peculiar/asn1-csr/build/cjs/attributes.js"(exports2) {
    "use strict";
    var Attributes_1;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Attributes = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    var Attributes = Attributes_1 = class Attributes extends asn1_schema_1.AsnArray {
      constructor(items) {
        super(items);
        Object.setPrototypeOf(this, Attributes_1.prototype);
      }
    };
    exports2.Attributes = Attributes;
    exports2.Attributes = Attributes = Attributes_1 = tslib_1.__decorate([
      (0, asn1_schema_1.AsnType)({ type: asn1_schema_1.AsnTypeTypes.Sequence, itemType: asn1_x509_1.Attribute })
    ], Attributes);
  }
});

// node_modules/@peculiar/asn1-csr/build/cjs/certification_request_info.js
var require_certification_request_info = __commonJS({
  "node_modules/@peculiar/asn1-csr/build/cjs/certification_request_info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.CertificationRequestInfo = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var asn1_x509_1 = require_cjs3();
    var attributes_1 = require_attributes2();
    var CertificationRequestInfo = class {
      constructor(params = {}) {
        this.version = 0;
        this.subject = new asn1_x509_1.Name();
        this.subjectPKInfo = new asn1_x509_1.SubjectPublicKeyInfo();
        this.attributes = new attributes_1.Attributes();
        Object.assign(this, params);
      }
    };
    exports2.CertificationRequestInfo = CertificationRequestInfo;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.Integer })
    ], CertificationRequestInfo.prototype, "version", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.Name })
    ], CertificationRequestInfo.prototype, "subject", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.SubjectPublicKeyInfo })
    ], CertificationRequestInfo.prototype, "subjectPKInfo", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: attributes_1.Attributes, implicit: true, context: 0 })
    ], CertificationRequestInfo.prototype, "attributes", void 0);
  }
});

// node_modules/@peculiar/asn1-csr/build/cjs/certification_request.js
var require_certification_request = __commonJS({
  "node_modules/@peculiar/asn1-csr/build/cjs/certification_request.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.CertificationRequest = void 0;
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var asn1_schema_1 = require_cjs2();
    var certification_request_info_1 = require_certification_request_info();
    var asn1_x509_1 = require_cjs3();
    var CertificationRequest = class {
      constructor(params = {}) {
        this.certificationRequestInfo = new certification_request_info_1.CertificationRequestInfo();
        this.signatureAlgorithm = new asn1_x509_1.AlgorithmIdentifier();
        this.signature = new ArrayBuffer(0);
        Object.assign(this, params);
      }
    };
    exports2.CertificationRequest = CertificationRequest;
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: certification_request_info_1.CertificationRequestInfo })
    ], CertificationRequest.prototype, "certificationRequestInfo", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_x509_1.AlgorithmIdentifier })
    ], CertificationRequest.prototype, "signatureAlgorithm", void 0);
    tslib_1.__decorate([
      (0, asn1_schema_1.AsnProp)({ type: asn1_schema_1.AsnPropTypes.BitString })
    ], CertificationRequest.prototype, "signature", void 0);
  }
});

// node_modules/@peculiar/asn1-csr/build/cjs/index.js
var require_cjs12 = __commonJS({
  "node_modules/@peculiar/asn1-csr/build/cjs/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var tslib_1 = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    tslib_1.__exportStar(require_attributes2(), exports2);
    tslib_1.__exportStar(require_certification_request(), exports2);
    tslib_1.__exportStar(require_certification_request_info(), exports2);
  }
});

// node_modules/@peculiar/x509/build/x509.cjs.js
var require_x509_cjs = __commonJS({
  "node_modules/@peculiar/x509/build/x509.cjs.js"(exports2) {
    "use strict";
    require_Reflect();
    var asn1Schema = require_cjs2();
    var asn1X509 = require_cjs3();
    var pvtsutils = require_build3();
    var asn1Cms = require_cjs5();
    var asn1Ecc = require_cjs6();
    var asn1Rsa = require_cjs7();
    var tslib = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var tsyringe = require_cjs8();
    var asnPkcs9 = require_cjs11();
    var asn1Csr = require_cjs12();
    function _interopNamespaceDefault(e) {
      var n = /* @__PURE__ */ Object.create(null);
      if (e) {
        Object.keys(e).forEach(function(k) {
          if (k !== "default") {
            var d2 = Object.getOwnPropertyDescriptor(e, k);
            Object.defineProperty(n, k, d2.get ? d2 : {
              enumerable: true,
              get: function() {
                return e[k];
              }
            });
          }
        });
      }
      n.default = e;
      return Object.freeze(n);
    }
    var asn1X509__namespace = /* @__PURE__ */ _interopNamespaceDefault(asn1X509);
    var asn1Cms__namespace = /* @__PURE__ */ _interopNamespaceDefault(asn1Cms);
    var asn1Ecc__namespace = /* @__PURE__ */ _interopNamespaceDefault(asn1Ecc);
    var asn1Rsa__namespace = /* @__PURE__ */ _interopNamespaceDefault(asn1Rsa);
    var asnPkcs9__namespace = /* @__PURE__ */ _interopNamespaceDefault(asnPkcs9);
    var diAlgorithm = "crypto.algorithm";
    var AlgorithmProvider = class {
      getAlgorithms() {
        return tsyringe.container.resolveAll(diAlgorithm);
      }
      toAsnAlgorithm(alg) {
        ({ ...alg });
        for (const algorithm of this.getAlgorithms()) {
          const res = algorithm.toAsnAlgorithm(alg);
          if (res) {
            return res;
          }
        }
        if (/^[0-9.]+$/.test(alg.name)) {
          const res = new asn1X509.AlgorithmIdentifier({
            algorithm: alg.name
          });
          if ("parameters" in alg) {
            const unknown = alg;
            res.parameters = unknown.parameters;
          }
          return res;
        }
        throw new Error("Cannot convert WebCrypto algorithm to ASN.1 algorithm");
      }
      toWebAlgorithm(alg) {
        for (const algorithm of this.getAlgorithms()) {
          const res = algorithm.toWebAlgorithm(alg);
          if (res) {
            return res;
          }
        }
        const unknown = {
          name: alg.algorithm,
          parameters: alg.parameters
        };
        return unknown;
      }
    };
    var diAlgorithmProvider = "crypto.algorithmProvider";
    tsyringe.container.registerSingleton(diAlgorithmProvider, AlgorithmProvider);
    var EcAlgorithm_1;
    var idVersionOne = "1.3.36.3.3.2.8.1.1";
    var idBrainpoolP160r1 = `${idVersionOne}.1`;
    var idBrainpoolP160t1 = `${idVersionOne}.2`;
    var idBrainpoolP192r1 = `${idVersionOne}.3`;
    var idBrainpoolP192t1 = `${idVersionOne}.4`;
    var idBrainpoolP224r1 = `${idVersionOne}.5`;
    var idBrainpoolP224t1 = `${idVersionOne}.6`;
    var idBrainpoolP256r1 = `${idVersionOne}.7`;
    var idBrainpoolP256t1 = `${idVersionOne}.8`;
    var idBrainpoolP320r1 = `${idVersionOne}.9`;
    var idBrainpoolP320t1 = `${idVersionOne}.10`;
    var idBrainpoolP384r1 = `${idVersionOne}.11`;
    var idBrainpoolP384t1 = `${idVersionOne}.12`;
    var idBrainpoolP512r1 = `${idVersionOne}.13`;
    var idBrainpoolP512t1 = `${idVersionOne}.14`;
    var brainpoolP160r1 = "brainpoolP160r1";
    var brainpoolP160t1 = "brainpoolP160t1";
    var brainpoolP192r1 = "brainpoolP192r1";
    var brainpoolP192t1 = "brainpoolP192t1";
    var brainpoolP224r1 = "brainpoolP224r1";
    var brainpoolP224t1 = "brainpoolP224t1";
    var brainpoolP256r1 = "brainpoolP256r1";
    var brainpoolP256t1 = "brainpoolP256t1";
    var brainpoolP320r1 = "brainpoolP320r1";
    var brainpoolP320t1 = "brainpoolP320t1";
    var brainpoolP384r1 = "brainpoolP384r1";
    var brainpoolP384t1 = "brainpoolP384t1";
    var brainpoolP512r1 = "brainpoolP512r1";
    var brainpoolP512t1 = "brainpoolP512t1";
    var ECDSA = "ECDSA";
    exports2.EcAlgorithm = EcAlgorithm_1 = class EcAlgorithm {
      toAsnAlgorithm(alg) {
        switch (alg.name.toLowerCase()) {
          case ECDSA.toLowerCase():
            if ("hash" in alg) {
              const hash = typeof alg.hash === "string" ? alg.hash : alg.hash.name;
              switch (hash.toLowerCase()) {
                case "sha-1":
                  return asn1Ecc__namespace.ecdsaWithSHA1;
                case "sha-256":
                  return asn1Ecc__namespace.ecdsaWithSHA256;
                case "sha-384":
                  return asn1Ecc__namespace.ecdsaWithSHA384;
                case "sha-512":
                  return asn1Ecc__namespace.ecdsaWithSHA512;
              }
            } else if ("namedCurve" in alg) {
              let parameters = "";
              switch (alg.namedCurve) {
                case "P-256":
                  parameters = asn1Ecc__namespace.id_secp256r1;
                  break;
                case "K-256":
                  parameters = EcAlgorithm_1.SECP256K1;
                  break;
                case "P-384":
                  parameters = asn1Ecc__namespace.id_secp384r1;
                  break;
                case "P-521":
                  parameters = asn1Ecc__namespace.id_secp521r1;
                  break;
                case brainpoolP160r1:
                  parameters = idBrainpoolP160r1;
                  break;
                case brainpoolP160t1:
                  parameters = idBrainpoolP160t1;
                  break;
                case brainpoolP192r1:
                  parameters = idBrainpoolP192r1;
                  break;
                case brainpoolP192t1:
                  parameters = idBrainpoolP192t1;
                  break;
                case brainpoolP224r1:
                  parameters = idBrainpoolP224r1;
                  break;
                case brainpoolP224t1:
                  parameters = idBrainpoolP224t1;
                  break;
                case brainpoolP256r1:
                  parameters = idBrainpoolP256r1;
                  break;
                case brainpoolP256t1:
                  parameters = idBrainpoolP256t1;
                  break;
                case brainpoolP320r1:
                  parameters = idBrainpoolP320r1;
                  break;
                case brainpoolP320t1:
                  parameters = idBrainpoolP320t1;
                  break;
                case brainpoolP384r1:
                  parameters = idBrainpoolP384r1;
                  break;
                case brainpoolP384t1:
                  parameters = idBrainpoolP384t1;
                  break;
                case brainpoolP512r1:
                  parameters = idBrainpoolP512r1;
                  break;
                case brainpoolP512t1:
                  parameters = idBrainpoolP512t1;
                  break;
              }
              if (parameters) {
                return new asn1X509.AlgorithmIdentifier({
                  algorithm: asn1Ecc__namespace.id_ecPublicKey,
                  parameters: asn1Schema.AsnConvert.serialize(new asn1Ecc__namespace.ECParameters({ namedCurve: parameters }))
                });
              }
            }
        }
        return null;
      }
      toWebAlgorithm(alg) {
        switch (alg.algorithm) {
          case asn1Ecc__namespace.id_ecdsaWithSHA1:
            return { name: ECDSA, hash: { name: "SHA-1" } };
          case asn1Ecc__namespace.id_ecdsaWithSHA256:
            return { name: ECDSA, hash: { name: "SHA-256" } };
          case asn1Ecc__namespace.id_ecdsaWithSHA384:
            return { name: ECDSA, hash: { name: "SHA-384" } };
          case asn1Ecc__namespace.id_ecdsaWithSHA512:
            return { name: ECDSA, hash: { name: "SHA-512" } };
          case asn1Ecc__namespace.id_ecPublicKey: {
            if (!alg.parameters) {
              throw new TypeError("Cannot get required parameters from EC algorithm");
            }
            const parameters = asn1Schema.AsnConvert.parse(alg.parameters, asn1Ecc__namespace.ECParameters);
            switch (parameters.namedCurve) {
              case asn1Ecc__namespace.id_secp256r1:
                return { name: ECDSA, namedCurve: "P-256" };
              case EcAlgorithm_1.SECP256K1:
                return { name: ECDSA, namedCurve: "K-256" };
              case asn1Ecc__namespace.id_secp384r1:
                return { name: ECDSA, namedCurve: "P-384" };
              case asn1Ecc__namespace.id_secp521r1:
                return { name: ECDSA, namedCurve: "P-521" };
              case idBrainpoolP160r1:
                return { name: ECDSA, namedCurve: brainpoolP160r1 };
              case idBrainpoolP160t1:
                return { name: ECDSA, namedCurve: brainpoolP160t1 };
              case idBrainpoolP192r1:
                return { name: ECDSA, namedCurve: brainpoolP192r1 };
              case idBrainpoolP192t1:
                return { name: ECDSA, namedCurve: brainpoolP192t1 };
              case idBrainpoolP224r1:
                return { name: ECDSA, namedCurve: brainpoolP224r1 };
              case idBrainpoolP224t1:
                return { name: ECDSA, namedCurve: brainpoolP224t1 };
              case idBrainpoolP256r1:
                return { name: ECDSA, namedCurve: brainpoolP256r1 };
              case idBrainpoolP256t1:
                return { name: ECDSA, namedCurve: brainpoolP256t1 };
              case idBrainpoolP320r1:
                return { name: ECDSA, namedCurve: brainpoolP320r1 };
              case idBrainpoolP320t1:
                return { name: ECDSA, namedCurve: brainpoolP320t1 };
              case idBrainpoolP384r1:
                return { name: ECDSA, namedCurve: brainpoolP384r1 };
              case idBrainpoolP384t1:
                return { name: ECDSA, namedCurve: brainpoolP384t1 };
              case idBrainpoolP512r1:
                return { name: ECDSA, namedCurve: brainpoolP512r1 };
              case idBrainpoolP512t1:
                return { name: ECDSA, namedCurve: brainpoolP512t1 };
            }
          }
        }
        return null;
      }
    };
    exports2.EcAlgorithm.SECP256K1 = "1.3.132.0.10";
    exports2.EcAlgorithm = EcAlgorithm_1 = tslib.__decorate([
      tsyringe.injectable()
    ], exports2.EcAlgorithm);
    tsyringe.container.registerSingleton(diAlgorithm, exports2.EcAlgorithm);
    var NAME = Symbol("name");
    var VALUE = Symbol("value");
    var TextObject = class {
      constructor(name, items = {}, value = "") {
        this[NAME] = name;
        this[VALUE] = value;
        for (const key in items) {
          this[key] = items[key];
        }
      }
    };
    TextObject.NAME = NAME;
    TextObject.VALUE = VALUE;
    var DefaultAlgorithmSerializer = class {
      static toTextObject(alg) {
        const obj = new TextObject("Algorithm Identifier", {}, OidSerializer.toString(alg.algorithm));
        if (alg.parameters) {
          switch (alg.algorithm) {
            case asn1Ecc__namespace.id_ecPublicKey: {
              const ecAlg = new exports2.EcAlgorithm().toWebAlgorithm(alg);
              if (ecAlg && "namedCurve" in ecAlg) {
                obj["Named Curve"] = ecAlg.namedCurve;
              } else {
                obj["Parameters"] = alg.parameters;
              }
              break;
            }
            default:
              obj["Parameters"] = alg.parameters;
          }
        }
        return obj;
      }
    };
    var OidSerializer = class {
      static toString(oid) {
        const name = this.items[oid];
        if (name) {
          return name;
        }
        return oid;
      }
    };
    OidSerializer.items = {
      [asn1Rsa__namespace.id_sha1]: "sha1",
      [asn1Rsa__namespace.id_sha224]: "sha224",
      [asn1Rsa__namespace.id_sha256]: "sha256",
      [asn1Rsa__namespace.id_sha384]: "sha384",
      [asn1Rsa__namespace.id_sha512]: "sha512",
      [asn1Rsa__namespace.id_rsaEncryption]: "rsaEncryption",
      [asn1Rsa__namespace.id_sha1WithRSAEncryption]: "sha1WithRSAEncryption",
      [asn1Rsa__namespace.id_sha224WithRSAEncryption]: "sha224WithRSAEncryption",
      [asn1Rsa__namespace.id_sha256WithRSAEncryption]: "sha256WithRSAEncryption",
      [asn1Rsa__namespace.id_sha384WithRSAEncryption]: "sha384WithRSAEncryption",
      [asn1Rsa__namespace.id_sha512WithRSAEncryption]: "sha512WithRSAEncryption",
      [asn1Ecc__namespace.id_ecPublicKey]: "ecPublicKey",
      [asn1Ecc__namespace.id_ecdsaWithSHA1]: "ecdsaWithSHA1",
      [asn1Ecc__namespace.id_ecdsaWithSHA224]: "ecdsaWithSHA224",
      [asn1Ecc__namespace.id_ecdsaWithSHA256]: "ecdsaWithSHA256",
      [asn1Ecc__namespace.id_ecdsaWithSHA384]: "ecdsaWithSHA384",
      [asn1Ecc__namespace.id_ecdsaWithSHA512]: "ecdsaWithSHA512",
      [asn1X509__namespace.id_kp_serverAuth]: "TLS WWW server authentication",
      [asn1X509__namespace.id_kp_clientAuth]: "TLS WWW client authentication",
      [asn1X509__namespace.id_kp_codeSigning]: "Code Signing",
      [asn1X509__namespace.id_kp_emailProtection]: "E-mail Protection",
      [asn1X509__namespace.id_kp_timeStamping]: "Time Stamping",
      [asn1X509__namespace.id_kp_OCSPSigning]: "OCSP Signing",
      [asn1Cms__namespace.id_signedData]: "Signed Data"
    };
    var TextConverter = class {
      static serialize(obj) {
        return this.serializeObj(obj).join("\n");
      }
      static pad(deep = 0) {
        return "".padStart(2 * deep, " ");
      }
      static serializeObj(obj, deep = 0) {
        const res = [];
        let pad = this.pad(deep++);
        let value = "";
        const objValue = obj[TextObject.VALUE];
        if (objValue) {
          value = ` ${objValue}`;
        }
        res.push(`${pad}${obj[TextObject.NAME]}:${value}`);
        pad = this.pad(deep);
        for (const key in obj) {
          if (typeof key === "symbol") {
            continue;
          }
          const value2 = obj[key];
          const keyValue = key ? `${key}: ` : "";
          if (typeof value2 === "string" || typeof value2 === "number" || typeof value2 === "boolean") {
            res.push(`${pad}${keyValue}${value2}`);
          } else if (value2 instanceof Date) {
            res.push(`${pad}${keyValue}${value2.toUTCString()}`);
          } else if (Array.isArray(value2)) {
            for (const obj2 of value2) {
              obj2[TextObject.NAME] = key;
              res.push(...this.serializeObj(obj2, deep));
            }
          } else if (value2 instanceof TextObject) {
            value2[TextObject.NAME] = key;
            res.push(...this.serializeObj(value2, deep));
          } else if (pvtsutils.BufferSourceConverter.isBufferSource(value2)) {
            if (key) {
              res.push(`${pad}${keyValue}`);
              res.push(...this.serializeBufferSource(value2, deep + 1));
            } else {
              res.push(...this.serializeBufferSource(value2, deep));
            }
          } else if ("toTextObject" in value2) {
            const obj2 = value2.toTextObject();
            obj2[TextObject.NAME] = key;
            res.push(...this.serializeObj(obj2, deep));
          } else {
            throw new TypeError("Cannot serialize data in text format. Unsupported type.");
          }
        }
        return res;
      }
      static serializeBufferSource(buffer, deep = 0) {
        const pad = this.pad(deep);
        const view = pvtsutils.BufferSourceConverter.toUint8Array(buffer);
        const res = [];
        for (let i = 0; i < view.length; ) {
          const row = [];
          for (let j = 0; j < 16 && i < view.length; j++) {
            if (j === 8) {
              row.push("");
            }
            const hex = view[i++].toString(16).padStart(2, "0");
            row.push(hex);
          }
          res.push(`${pad}${row.join(" ")}`);
        }
        return res;
      }
      static serializeAlgorithm(alg) {
        return this.algorithmSerializer.toTextObject(alg);
      }
    };
    TextConverter.oidSerializer = OidSerializer;
    TextConverter.algorithmSerializer = DefaultAlgorithmSerializer;
    var AsnData = class _AsnData {
      constructor(...args) {
        if (args.length === 1) {
          const asn = args[0];
          this.rawData = asn1Schema.AsnConvert.serialize(asn);
          this.onInit(asn);
        } else {
          const asn = asn1Schema.AsnConvert.parse(args[0], args[1]);
          this.rawData = pvtsutils.BufferSourceConverter.toArrayBuffer(args[0]);
          this.onInit(asn);
        }
      }
      equal(data) {
        if (data instanceof _AsnData) {
          return pvtsutils.isEqual(data.rawData, this.rawData);
        }
        return false;
      }
      toString(format3 = "text") {
        switch (format3) {
          case "asn":
            return asn1Schema.AsnConvert.toString(this.rawData);
          case "text":
            return TextConverter.serialize(this.toTextObject());
          case "hex":
            return pvtsutils.Convert.ToHex(this.rawData);
          case "base64":
            return pvtsutils.Convert.ToBase64(this.rawData);
          case "base64url":
            return pvtsutils.Convert.ToBase64Url(this.rawData);
          default:
            throw TypeError("Argument 'format' is unsupported value");
        }
      }
      getTextName() {
        const constructor = this.constructor;
        return constructor.NAME;
      }
      toTextObject() {
        const obj = this.toTextObjectEmpty();
        obj[""] = this.rawData;
        return obj;
      }
      toTextObjectEmpty(value) {
        return new TextObject(this.getTextName(), {}, value);
      }
    };
    AsnData.NAME = "ASN";
    var Extension = class _Extension extends AsnData {
      constructor(...args) {
        let raw2;
        if (pvtsutils.BufferSourceConverter.isBufferSource(args[0])) {
          raw2 = pvtsutils.BufferSourceConverter.toArrayBuffer(args[0]);
        } else {
          raw2 = asn1Schema.AsnConvert.serialize(new asn1X509.Extension({
            extnID: args[0],
            critical: args[1],
            extnValue: new asn1Schema.OctetString(pvtsutils.BufferSourceConverter.toArrayBuffer(args[2]))
          }));
        }
        super(raw2, asn1X509.Extension);
      }
      onInit(asn) {
        this.type = asn.extnID;
        this.critical = asn.critical;
        this.value = asn.extnValue.buffer;
      }
      toTextObject() {
        const obj = this.toTextObjectWithoutValue();
        obj[""] = this.value;
        return obj;
      }
      toTextObjectWithoutValue() {
        const obj = this.toTextObjectEmpty(this.critical ? "critical" : void 0);
        if (obj[TextObject.NAME] === _Extension.NAME) {
          obj[TextObject.NAME] = OidSerializer.toString(this.type);
        }
        return obj;
      }
    };
    var _a;
    var CryptoProvider = class _CryptoProvider {
      static isCryptoKeyPair(data) {
        return data && data.privateKey && data.publicKey;
      }
      static isCryptoKey(data) {
        return data && data.usages && data.type && data.algorithm && data.extractable !== void 0;
      }
      constructor() {
        this.items = /* @__PURE__ */ new Map();
        this[_a] = "CryptoProvider";
        if (typeof self !== "undefined" && typeof crypto !== "undefined") {
          this.set(_CryptoProvider.DEFAULT, crypto);
        }
      }
      clear() {
        this.items.clear();
      }
      delete(key) {
        return this.items.delete(key);
      }
      forEach(callbackfn, thisArg) {
        return this.items.forEach(callbackfn, thisArg);
      }
      has(key) {
        return this.items.has(key);
      }
      get size() {
        return this.items.size;
      }
      entries() {
        return this.items.entries();
      }
      keys() {
        return this.items.keys();
      }
      values() {
        return this.items.values();
      }
      [Symbol.iterator]() {
        return this.items[Symbol.iterator]();
      }
      get(key = _CryptoProvider.DEFAULT) {
        const crypto2 = this.items.get(key.toLowerCase());
        if (!crypto2) {
          throw new Error(`Cannot get Crypto by name '${key}'`);
        }
        return crypto2;
      }
      set(key, value) {
        if (typeof key === "string") {
          if (!value) {
            throw new TypeError("Argument 'value' is required");
          }
          this.items.set(key.toLowerCase(), value);
        } else {
          this.items.set(_CryptoProvider.DEFAULT, key);
        }
        return this;
      }
    };
    _a = Symbol.toStringTag;
    CryptoProvider.DEFAULT = "default";
    var cryptoProvider = new CryptoProvider();
    var OID_REGEX = /^[0-2](?:\.[1-9][0-9]*)+$/;
    function isOID(id) {
      return new RegExp(OID_REGEX).test(id);
    }
    var NameIdentifier = class {
      constructor(names2 = {}) {
        this.items = {};
        for (const id in names2) {
          this.register(id, names2[id]);
        }
      }
      get(idOrName) {
        return this.items[idOrName] || null;
      }
      findId(idOrName) {
        if (!isOID(idOrName)) {
          return this.get(idOrName);
        }
        return idOrName;
      }
      register(id, name) {
        this.items[id] = name;
        this.items[name] = id;
      }
    };
    var names = new NameIdentifier();
    names.register("CN", "2.5.4.3");
    names.register("L", "2.5.4.7");
    names.register("ST", "2.5.4.8");
    names.register("O", "2.5.4.10");
    names.register("OU", "2.5.4.11");
    names.register("C", "2.5.4.6");
    names.register("DC", "0.9.2342.19200300.100.1.25");
    names.register("E", "1.2.840.113549.1.9.1");
    names.register("G", "2.5.4.42");
    names.register("I", "2.5.4.43");
    names.register("SN", "2.5.4.4");
    names.register("T", "2.5.4.12");
    function replaceUnknownCharacter(text2, char) {
      return `\\${pvtsutils.Convert.ToHex(pvtsutils.Convert.FromUtf8String(char)).toUpperCase()}`;
    }
    function escape2(data) {
      return data.replace(/([,+"\\<>;])/g, "\\$1").replace(/^([ #])/, "\\$1").replace(/([ ]$)/, "\\$1").replace(/([\r\n\t])/, replaceUnknownCharacter);
    }
    var Name = class _Name {
      static isASCII(text2) {
        for (let i = 0; i < text2.length; i++) {
          const code = text2.charCodeAt(i);
          if (code > 255) {
            return false;
          }
        }
        return true;
      }
      static isPrintableString(text2) {
        return /^[A-Za-z0-9 '()+,-./:=?]*$/g.test(text2);
      }
      constructor(data, extraNames = {}) {
        this.extraNames = new NameIdentifier();
        this.asn = new asn1X509.Name();
        for (const key in extraNames) {
          if (Object.prototype.hasOwnProperty.call(extraNames, key)) {
            const value = extraNames[key];
            this.extraNames.register(key, value);
          }
        }
        if (typeof data === "string") {
          this.asn = this.fromString(data);
        } else if (data instanceof asn1X509.Name) {
          this.asn = data;
        } else if (pvtsutils.BufferSourceConverter.isBufferSource(data)) {
          this.asn = asn1Schema.AsnConvert.parse(data, asn1X509.Name);
        } else {
          this.asn = this.fromJSON(data);
        }
      }
      getField(idOrName) {
        const id = this.extraNames.findId(idOrName) || names.findId(idOrName);
        const res = [];
        for (const name of this.asn) {
          for (const rdn of name) {
            if (rdn.type === id) {
              res.push(rdn.value.toString());
            }
          }
        }
        return res;
      }
      getName(idOrName) {
        return this.extraNames.get(idOrName) || names.get(idOrName);
      }
      toString() {
        return this.asn.map((rdn) => rdn.map((o2) => {
          const type = this.getName(o2.type) || o2.type;
          const value = o2.value.anyValue ? `#${pvtsutils.Convert.ToHex(o2.value.anyValue)}` : escape2(o2.value.toString());
          return `${type}=${value}`;
        }).join("+")).join(", ");
      }
      toJSON() {
        var _a2;
        const json3 = [];
        for (const rdn of this.asn) {
          const jsonItem = {};
          for (const attr of rdn) {
            const type = this.getName(attr.type) || attr.type;
            (_a2 = jsonItem[type]) !== null && _a2 !== void 0 ? _a2 : jsonItem[type] = [];
            jsonItem[type].push(attr.value.anyValue ? `#${pvtsutils.Convert.ToHex(attr.value.anyValue)}` : attr.value.toString());
          }
          json3.push(jsonItem);
        }
        return json3;
      }
      fromString(data) {
        const asn = new asn1X509.Name();
        const regex = /(\d\.[\d.]*\d|[A-Za-z]+)=((?:"")|(?:".*?[^\\]")|(?:[^,+].*?(?:[^\\][,+]))|(?:))([,+])?/g;
        let matches = null;
        let level = ",";
        while (matches = regex.exec(`${data},`)) {
          let [, type, value] = matches;
          const lastChar = value[value.length - 1];
          if (lastChar === "," || lastChar === "+") {
            value = value.slice(0, value.length - 1);
            matches[3] = lastChar;
          }
          const next = matches[3];
          if (!/[\d.]+/.test(type)) {
            type = this.getName(type) || "";
          }
          if (!type) {
            throw new Error(`Cannot get OID for name type '${type}'`);
          }
          const attr = new asn1X509.AttributeTypeAndValue({ type });
          if (value.charAt(0) === "#") {
            attr.value.anyValue = pvtsutils.Convert.FromHex(value.slice(1));
          } else {
            const quotedMatches = /"(.*?[^\\])?"/.exec(value);
            if (quotedMatches) {
              value = quotedMatches[1];
            }
            value = value.replace(/\\0a/ig, "\n").replace(/\\0d/ig, "\r").replace(/\\0g/ig, "	").replace(/\\(.)/g, "$1");
            if (type === this.getName("E") || type === this.getName("DC")) {
              attr.value.ia5String = value;
            } else {
              if (_Name.isPrintableString(value)) {
                attr.value.printableString = value;
              } else {
                attr.value.utf8String = value;
              }
            }
          }
          if (level === "+") {
            asn[asn.length - 1].push(attr);
          } else {
            asn.push(new asn1X509.RelativeDistinguishedName([attr]));
          }
          level = next;
        }
        return asn;
      }
      fromJSON(data) {
        const asn = new asn1X509.Name();
        for (const item of data) {
          const asnRdn = new asn1X509.RelativeDistinguishedName();
          for (const type in item) {
            let typeId = type;
            if (!/[\d.]+/.test(type)) {
              typeId = this.getName(type) || "";
            }
            if (!typeId) {
              throw new Error(`Cannot get OID for name type '${type}'`);
            }
            const values = item[type];
            for (const value of values) {
              const asnAttr = new asn1X509.AttributeTypeAndValue({ type: typeId });
              if (typeof value === "object") {
                for (const key in value) {
                  switch (key) {
                    case "ia5String":
                      asnAttr.value.ia5String = value[key];
                      break;
                    case "utf8String":
                      asnAttr.value.utf8String = value[key];
                      break;
                    case "universalString":
                      asnAttr.value.universalString = value[key];
                      break;
                    case "bmpString":
                      asnAttr.value.bmpString = value[key];
                      break;
                    case "printableString":
                      asnAttr.value.printableString = value[key];
                      break;
                  }
                }
              } else if (value[0] === "#") {
                asnAttr.value.anyValue = pvtsutils.Convert.FromHex(value.slice(1));
              } else {
                if (typeId === this.getName("E") || typeId === this.getName("DC")) {
                  asnAttr.value.ia5String = value;
                } else {
                  asnAttr.value.printableString = value;
                }
              }
              asnRdn.push(asnAttr);
            }
          }
          asn.push(asnRdn);
        }
        return asn;
      }
      toArrayBuffer() {
        return asn1Schema.AsnConvert.serialize(this.asn);
      }
      async getThumbprint(...args) {
        var _a2;
        let crypto2;
        let algorithm = "SHA-1";
        if (args.length >= 1 && !((_a2 = args[0]) === null || _a2 === void 0 ? void 0 : _a2.subtle)) {
          algorithm = args[0] || algorithm;
          crypto2 = args[1] || cryptoProvider.get();
        } else {
          crypto2 = args[0] || cryptoProvider.get();
        }
        return await crypto2.subtle.digest(algorithm, this.toArrayBuffer());
      }
    };
    var ERR_GN_CONSTRUCTOR = "Cannot initialize GeneralName from ASN.1 data.";
    var ERR_GN_STRING_FORMAT = `${ERR_GN_CONSTRUCTOR} Unsupported string format in use.`;
    var ERR_GUID = `${ERR_GN_CONSTRUCTOR} Value doesn't match to GUID regular expression.`;
    var GUID_REGEX = /^([0-9a-f]{8})-?([0-9a-f]{4})-?([0-9a-f]{4})-?([0-9a-f]{4})-?([0-9a-f]{12})$/i;
    var id_GUID = "1.3.6.1.4.1.311.25.1";
    var id_UPN = "1.3.6.1.4.1.311.20.2.3";
    var DNS = "dns";
    var DN = "dn";
    var EMAIL = "email";
    var IP = "ip";
    var URL2 = "url";
    var GUID = "guid";
    var UPN = "upn";
    var REGISTERED_ID = "id";
    var GeneralName = class extends AsnData {
      constructor(...args) {
        let name;
        if (args.length === 2) {
          switch (args[0]) {
            case DN: {
              const derName = new Name(args[1]).toArrayBuffer();
              const asnName = asn1Schema.AsnConvert.parse(derName, asn1X509__namespace.Name);
              name = new asn1X509__namespace.GeneralName({ directoryName: asnName });
              break;
            }
            case DNS:
              name = new asn1X509__namespace.GeneralName({ dNSName: args[1] });
              break;
            case EMAIL:
              name = new asn1X509__namespace.GeneralName({ rfc822Name: args[1] });
              break;
            case GUID: {
              const matches = new RegExp(GUID_REGEX, "i").exec(args[1]);
              if (!matches) {
                throw new Error("Cannot parse GUID value. Value doesn't match to regular expression");
              }
              const hex = matches.slice(1).map((o2, i) => {
                if (i < 3) {
                  return pvtsutils.Convert.ToHex(new Uint8Array(pvtsutils.Convert.FromHex(o2)).reverse());
                }
                return o2;
              }).join("");
              name = new asn1X509__namespace.GeneralName({
                otherName: new asn1X509__namespace.OtherName({
                  typeId: id_GUID,
                  value: asn1Schema.AsnConvert.serialize(new asn1Schema.OctetString(pvtsutils.Convert.FromHex(hex)))
                })
              });
              break;
            }
            case IP:
              name = new asn1X509__namespace.GeneralName({ iPAddress: args[1] });
              break;
            case REGISTERED_ID:
              name = new asn1X509__namespace.GeneralName({ registeredID: args[1] });
              break;
            case UPN: {
              name = new asn1X509__namespace.GeneralName({
                otherName: new asn1X509__namespace.OtherName({
                  typeId: id_UPN,
                  value: asn1Schema.AsnConvert.serialize(asn1Schema.AsnUtf8StringConverter.toASN(args[1]))
                })
              });
              break;
            }
            case URL2:
              name = new asn1X509__namespace.GeneralName({ uniformResourceIdentifier: args[1] });
              break;
            default:
              throw new Error("Cannot create GeneralName. Unsupported type of the name");
          }
        } else if (pvtsutils.BufferSourceConverter.isBufferSource(args[0])) {
          name = asn1Schema.AsnConvert.parse(args[0], asn1X509__namespace.GeneralName);
        } else {
          name = args[0];
        }
        super(name);
      }
      onInit(asn) {
        if (asn.dNSName != void 0) {
          this.type = DNS;
          this.value = asn.dNSName;
        } else if (asn.rfc822Name != void 0) {
          this.type = EMAIL;
          this.value = asn.rfc822Name;
        } else if (asn.iPAddress != void 0) {
          this.type = IP;
          this.value = asn.iPAddress;
        } else if (asn.uniformResourceIdentifier != void 0) {
          this.type = URL2;
          this.value = asn.uniformResourceIdentifier;
        } else if (asn.registeredID != void 0) {
          this.type = REGISTERED_ID;
          this.value = asn.registeredID;
        } else if (asn.directoryName != void 0) {
          this.type = DN;
          this.value = new Name(asn.directoryName).toString();
        } else if (asn.otherName != void 0) {
          if (asn.otherName.typeId === id_GUID) {
            this.type = GUID;
            const guid = asn1Schema.AsnConvert.parse(asn.otherName.value, asn1Schema.OctetString);
            const matches = new RegExp(GUID_REGEX, "i").exec(pvtsutils.Convert.ToHex(guid));
            if (!matches) {
              throw new Error(ERR_GUID);
            }
            this.value = matches.slice(1).map((o2, i) => {
              if (i < 3) {
                return pvtsutils.Convert.ToHex(new Uint8Array(pvtsutils.Convert.FromHex(o2)).reverse());
              }
              return o2;
            }).join("-");
          } else if (asn.otherName.typeId === id_UPN) {
            this.type = UPN;
            this.value = asn1Schema.AsnConvert.parse(asn.otherName.value, asn1X509__namespace.DirectoryString).toString();
          } else {
            throw new Error(ERR_GN_STRING_FORMAT);
          }
        } else {
          throw new Error(ERR_GN_STRING_FORMAT);
        }
      }
      toJSON() {
        return {
          type: this.type,
          value: this.value
        };
      }
      toTextObject() {
        let type;
        switch (this.type) {
          case DN:
          case DNS:
          case GUID:
          case IP:
          case REGISTERED_ID:
          case UPN:
          case URL2:
            type = this.type.toUpperCase();
            break;
          case EMAIL:
            type = "Email";
            break;
          default:
            throw new Error("Unsupported GeneralName type");
        }
        let value = this.value;
        if (this.type === REGISTERED_ID) {
          value = OidSerializer.toString(value);
        }
        return new TextObject(type, void 0, value);
      }
    };
    var GeneralNames = class extends AsnData {
      constructor(params) {
        let names2;
        if (params instanceof asn1X509__namespace.GeneralNames) {
          names2 = params;
        } else if (Array.isArray(params)) {
          const items = [];
          for (const name of params) {
            if (name instanceof asn1X509__namespace.GeneralName) {
              items.push(name);
            } else {
              const asnName = asn1Schema.AsnConvert.parse(new GeneralName(name.type, name.value).rawData, asn1X509__namespace.GeneralName);
              items.push(asnName);
            }
          }
          names2 = new asn1X509__namespace.GeneralNames(items);
        } else if (pvtsutils.BufferSourceConverter.isBufferSource(params)) {
          names2 = asn1Schema.AsnConvert.parse(params, asn1X509__namespace.GeneralNames);
        } else {
          throw new Error("Cannot initialize GeneralNames. Incorrect incoming arguments");
        }
        super(names2);
      }
      onInit(asn) {
        const items = [];
        for (const asnName of asn) {
          let name = null;
          try {
            name = new GeneralName(asnName);
          } catch {
            continue;
          }
          items.push(name);
        }
        this.items = items;
      }
      toJSON() {
        return this.items.map((o2) => o2.toJSON());
      }
      toTextObject() {
        const res = super.toTextObjectEmpty();
        for (const name of this.items) {
          const nameObj = name.toTextObject();
          let field = res[nameObj[TextObject.NAME]];
          if (!Array.isArray(field)) {
            field = [];
            res[nameObj[TextObject.NAME]] = field;
          }
          field.push(nameObj);
        }
        return res;
      }
    };
    GeneralNames.NAME = "GeneralNames";
    var rPaddingTag = "-{5}";
    var rEolChars = "\\n";
    var rNameTag = `[^${rEolChars}]+`;
    var rBeginTag = `${rPaddingTag}BEGIN (${rNameTag}(?=${rPaddingTag}))${rPaddingTag}`;
    var rEndTag = `${rPaddingTag}END \\1${rPaddingTag}`;
    var rEolGroup = "\\n";
    var rHeaderKey = `[^:${rEolChars}]+`;
    var rHeaderValue = `(?:[^${rEolChars}]+${rEolGroup}(?: +[^${rEolChars}]+${rEolGroup})*)`;
    var rBase64Chars = "[a-zA-Z0-9=+/]+";
    var rBase64 = `(?:${rBase64Chars}${rEolGroup})+`;
    var rPem = `${rBeginTag}${rEolGroup}(?:((?:${rHeaderKey}: ${rHeaderValue})+))?${rEolGroup}?(${rBase64})${rEndTag}`;
    var PemConverter = class {
      static isPem(data) {
        return typeof data === "string" && new RegExp(rPem, "g").test(data);
      }
      static decodeWithHeaders(pem) {
        pem = pem.replace(/\r/g, "");
        const pattern = new RegExp(rPem, "g");
        const res = [];
        let matches = null;
        while (matches = pattern.exec(pem)) {
          const base64 = matches[3].replace(new RegExp(`[${rEolChars}]+`, "g"), "");
          const pemStruct = {
            type: matches[1],
            headers: [],
            rawData: pvtsutils.Convert.FromBase64(base64)
          };
          const headersString = matches[2];
          if (headersString) {
            const headers = headersString.split(new RegExp(rEolGroup, "g"));
            let lastHeader = null;
            for (const header of headers) {
              const [key, value] = header.split(/:(.*)/);
              if (value === void 0) {
                if (!lastHeader) {
                  throw new Error("Cannot parse PEM string. Incorrect header value");
                }
                lastHeader.value += key.trim();
              } else {
                if (lastHeader) {
                  pemStruct.headers.push(lastHeader);
                }
                lastHeader = { key, value: value.trim() };
              }
            }
            if (lastHeader) {
              pemStruct.headers.push(lastHeader);
            }
          }
          res.push(pemStruct);
        }
        return res;
      }
      static decode(pem) {
        const blocks = this.decodeWithHeaders(pem);
        return blocks.map((o2) => o2.rawData);
      }
      static decodeFirst(pem) {
        const items = this.decode(pem);
        if (!items.length) {
          throw new RangeError("PEM string doesn't contain any objects");
        }
        return items[0];
      }
      static encode(rawData, tag) {
        if (Array.isArray(rawData)) {
          const raws = new Array();
          if (tag) {
            rawData.forEach((element) => {
              if (!pvtsutils.BufferSourceConverter.isBufferSource(element)) {
                throw new TypeError("Cannot encode array of BufferSource in PEM format. Not all items of the array are BufferSource");
              }
              raws.push(this.encodeStruct({
                type: tag,
                rawData: pvtsutils.BufferSourceConverter.toArrayBuffer(element)
              }));
            });
          } else {
            rawData.forEach((element) => {
              if (!("type" in element)) {
                throw new TypeError("Cannot encode array of PemStruct in PEM format. Not all items of the array are PemStrut");
              }
              raws.push(this.encodeStruct(element));
            });
          }
          return raws.join("\n");
        } else {
          if (!tag) {
            throw new Error("Required argument 'tag' is missed");
          }
          return this.encodeStruct({
            type: tag,
            rawData: pvtsutils.BufferSourceConverter.toArrayBuffer(rawData)
          });
        }
      }
      static encodeStruct(pem) {
        var _a2;
        const upperCaseType = pem.type.toLocaleUpperCase();
        const res = [];
        res.push(`-----BEGIN ${upperCaseType}-----`);
        if ((_a2 = pem.headers) === null || _a2 === void 0 ? void 0 : _a2.length) {
          for (const header of pem.headers) {
            res.push(`${header.key}: ${header.value}`);
          }
          res.push("");
        }
        const base64 = pvtsutils.Convert.ToBase64(pem.rawData);
        let sliced;
        let offset = 0;
        const rows = Array();
        while (offset < base64.length) {
          if (base64.length - offset < 64) {
            sliced = base64.substring(offset);
          } else {
            sliced = base64.substring(offset, offset + 64);
            offset += 64;
          }
          if (sliced.length !== 0) {
            rows.push(sliced);
            if (sliced.length < 64) {
              break;
            }
          } else {
            break;
          }
        }
        res.push(...rows);
        res.push(`-----END ${upperCaseType}-----`);
        return res.join("\n");
      }
    };
    PemConverter.CertificateTag = "CERTIFICATE";
    PemConverter.CrlTag = "CRL";
    PemConverter.CertificateRequestTag = "CERTIFICATE REQUEST";
    PemConverter.PublicKeyTag = "PUBLIC KEY";
    PemConverter.PrivateKeyTag = "PRIVATE KEY";
    var PemData = class _PemData extends AsnData {
      static isAsnEncoded(data) {
        return pvtsutils.BufferSourceConverter.isBufferSource(data) || typeof data === "string";
      }
      static toArrayBuffer(raw2) {
        if (typeof raw2 === "string") {
          if (PemConverter.isPem(raw2)) {
            return PemConverter.decode(raw2)[0];
          } else if (pvtsutils.Convert.isHex(raw2)) {
            return pvtsutils.Convert.FromHex(raw2);
          } else if (pvtsutils.Convert.isBase64(raw2)) {
            return pvtsutils.Convert.FromBase64(raw2);
          } else if (pvtsutils.Convert.isBase64Url(raw2)) {
            return pvtsutils.Convert.FromBase64Url(raw2);
          } else {
            throw new TypeError("Unsupported format of 'raw' argument. Must be one of DER, PEM, HEX, Base64, or Base4Url");
          }
        } else {
          const stringRaw = pvtsutils.Convert.ToBinary(raw2);
          if (PemConverter.isPem(stringRaw)) {
            return PemConverter.decode(stringRaw)[0];
          } else if (pvtsutils.Convert.isHex(stringRaw)) {
            return pvtsutils.Convert.FromHex(stringRaw);
          } else if (pvtsutils.Convert.isBase64(stringRaw)) {
            return pvtsutils.Convert.FromBase64(stringRaw);
          } else if (pvtsutils.Convert.isBase64Url(stringRaw)) {
            return pvtsutils.Convert.FromBase64Url(stringRaw);
          }
          return pvtsutils.BufferSourceConverter.toArrayBuffer(raw2);
        }
      }
      constructor(...args) {
        if (_PemData.isAsnEncoded(args[0])) {
          super(_PemData.toArrayBuffer(args[0]), args[1]);
        } else {
          super(args[0]);
        }
      }
      toString(format3 = "pem") {
        switch (format3) {
          case "pem":
            return PemConverter.encode(this.rawData, this.tag);
          default:
            return super.toString(format3);
        }
      }
    };
    var PublicKey = class extends PemData {
      constructor(param) {
        if (PemData.isAsnEncoded(param)) {
          super(param, asn1X509.SubjectPublicKeyInfo);
        } else {
          super(param);
        }
        this.tag = PemConverter.PublicKeyTag;
      }
      async export(...args) {
        let crypto2;
        let keyUsages = ["verify"];
        let algorithm = { hash: "SHA-256", ...this.algorithm };
        if (args.length > 1) {
          algorithm = args[0] || algorithm;
          keyUsages = args[1] || keyUsages;
          crypto2 = args[2] || cryptoProvider.get();
        } else {
          crypto2 = args[0] || cryptoProvider.get();
        }
        return crypto2.subtle.importKey("spki", this.rawData, algorithm, true, keyUsages);
      }
      onInit(asn) {
        const algProv = tsyringe.container.resolve(diAlgorithmProvider);
        const algorithm = this.algorithm = algProv.toWebAlgorithm(asn.algorithm);
        switch (asn.algorithm.algorithm) {
          case asn1Rsa.id_rsaEncryption: {
            const rsaPublicKey = asn1Schema.AsnConvert.parse(asn.subjectPublicKey, asn1Rsa.RSAPublicKey);
            const modulus = pvtsutils.BufferSourceConverter.toUint8Array(rsaPublicKey.modulus);
            algorithm.publicExponent = pvtsutils.BufferSourceConverter.toUint8Array(rsaPublicKey.publicExponent);
            algorithm.modulusLength = (!modulus[0] ? modulus.slice(1) : modulus).byteLength << 3;
            break;
          }
        }
      }
      async getThumbprint(...args) {
        var _a2;
        let crypto2;
        let algorithm = "SHA-1";
        if (args.length >= 1 && !((_a2 = args[0]) === null || _a2 === void 0 ? void 0 : _a2.subtle)) {
          algorithm = args[0] || algorithm;
          crypto2 = args[1] || cryptoProvider.get();
        } else {
          crypto2 = args[0] || cryptoProvider.get();
        }
        return await crypto2.subtle.digest(algorithm, this.rawData);
      }
      async getKeyIdentifier(crypto2) {
        if (!crypto2) {
          crypto2 = cryptoProvider.get();
        }
        const asn = asn1Schema.AsnConvert.parse(this.rawData, asn1X509.SubjectPublicKeyInfo);
        return await crypto2.subtle.digest("SHA-1", asn.subjectPublicKey);
      }
      toTextObject() {
        const obj = this.toTextObjectEmpty();
        const asn = asn1Schema.AsnConvert.parse(this.rawData, asn1X509.SubjectPublicKeyInfo);
        obj["Algorithm"] = TextConverter.serializeAlgorithm(asn.algorithm);
        switch (asn.algorithm.algorithm) {
          case asn1Ecc.id_ecPublicKey:
            obj["EC Point"] = asn.subjectPublicKey;
            break;
          case asn1Rsa.id_rsaEncryption:
          default:
            obj["Raw Data"] = asn.subjectPublicKey;
        }
        return obj;
      }
    };
    var ExtensionFactory = class {
      static register(id, type) {
        this.items.set(id, type);
      }
      static create(data) {
        const extension = new Extension(data);
        const Type = this.items.get(extension.type);
        if (Type) {
          return new Type(data);
        }
        return extension;
      }
    };
    ExtensionFactory.items = /* @__PURE__ */ new Map();
    var diAsnSignatureFormatter = "crypto.signatureFormatter";
    var AsnDefaultSignatureFormatter = class {
      toAsnSignature(algorithm, signature) {
        return pvtsutils.BufferSourceConverter.toArrayBuffer(signature);
      }
      toWebSignature(algorithm, signature) {
        return pvtsutils.BufferSourceConverter.toArrayBuffer(signature);
      }
    };
    var X509Certificate = class extends PemData {
      constructor(param) {
        if (PemData.isAsnEncoded(param)) {
          super(param, asn1X509.Certificate);
        } else {
          super(param);
        }
        this.tag = PemConverter.CertificateTag;
      }
      onInit(asn) {
        const tbs = asn.tbsCertificate;
        this.tbs = asn1Schema.AsnConvert.serialize(tbs);
        this.serialNumber = pvtsutils.Convert.ToHex(tbs.serialNumber);
        this.subjectName = new Name(tbs.subject);
        this.subject = new Name(tbs.subject).toString();
        this.issuerName = new Name(tbs.issuer);
        this.issuer = this.issuerName.toString();
        const algProv = tsyringe.container.resolve(diAlgorithmProvider);
        this.signatureAlgorithm = algProv.toWebAlgorithm(asn.signatureAlgorithm);
        this.signature = asn.signatureValue;
        const notBefore = tbs.validity.notBefore.utcTime || tbs.validity.notBefore.generalTime;
        if (!notBefore) {
          throw new Error("Cannot get 'notBefore' value");
        }
        this.notBefore = notBefore;
        const notAfter = tbs.validity.notAfter.utcTime || tbs.validity.notAfter.generalTime;
        if (!notAfter) {
          throw new Error("Cannot get 'notAfter' value");
        }
        this.notAfter = notAfter;
        this.extensions = [];
        if (tbs.extensions) {
          this.extensions = tbs.extensions.map((o2) => ExtensionFactory.create(asn1Schema.AsnConvert.serialize(o2)));
        }
        this.publicKey = new PublicKey(tbs.subjectPublicKeyInfo);
      }
      getExtension(type) {
        for (const ext of this.extensions) {
          if (typeof type === "string") {
            if (ext.type === type) {
              return ext;
            }
          } else {
            if (ext instanceof type) {
              return ext;
            }
          }
        }
        return null;
      }
      getExtensions(type) {
        return this.extensions.filter((o2) => {
          if (typeof type === "string") {
            return o2.type === type;
          } else {
            return o2 instanceof type;
          }
        });
      }
      async verify(params = {}, crypto2 = cryptoProvider.get()) {
        let keyAlgorithm;
        let publicKey;
        const paramsKey = params.publicKey;
        try {
          if (!paramsKey) {
            keyAlgorithm = { ...this.publicKey.algorithm, ...this.signatureAlgorithm };
            publicKey = await this.publicKey.export(keyAlgorithm, ["verify"], crypto2);
          } else if ("publicKey" in paramsKey) {
            keyAlgorithm = { ...paramsKey.publicKey.algorithm, ...this.signatureAlgorithm };
            publicKey = await paramsKey.publicKey.export(keyAlgorithm, ["verify"], crypto2);
          } else if (paramsKey instanceof PublicKey) {
            keyAlgorithm = { ...paramsKey.algorithm, ...this.signatureAlgorithm };
            publicKey = await paramsKey.export(keyAlgorithm, ["verify"], crypto2);
          } else if (pvtsutils.BufferSourceConverter.isBufferSource(paramsKey)) {
            const key = new PublicKey(paramsKey);
            keyAlgorithm = { ...key.algorithm, ...this.signatureAlgorithm };
            publicKey = await key.export(keyAlgorithm, ["verify"], crypto2);
          } else {
            keyAlgorithm = { ...paramsKey.algorithm, ...this.signatureAlgorithm };
            publicKey = paramsKey;
          }
        } catch (e) {
          return false;
        }
        const signatureFormatters = tsyringe.container.resolveAll(diAsnSignatureFormatter).reverse();
        let signature = null;
        for (const signatureFormatter of signatureFormatters) {
          signature = signatureFormatter.toWebSignature(keyAlgorithm, this.signature);
          if (signature) {
            break;
          }
        }
        if (!signature) {
          throw Error("Cannot convert ASN.1 signature value to WebCrypto format");
        }
        const ok = await crypto2.subtle.verify(this.signatureAlgorithm, publicKey, signature, this.tbs);
        if (params.signatureOnly) {
          return ok;
        } else {
          const date = params.date || /* @__PURE__ */ new Date();
          const time = date.getTime();
          return ok && this.notBefore.getTime() < time && time < this.notAfter.getTime();
        }
      }
      async getThumbprint(...args) {
        let crypto2;
        let algorithm = "SHA-1";
        if (args[0]) {
          if (!args[0].subtle) {
            algorithm = args[0] || algorithm;
            crypto2 = args[1];
          } else {
            crypto2 = args[0];
          }
        }
        crypto2 !== null && crypto2 !== void 0 ? crypto2 : crypto2 = cryptoProvider.get();
        return await crypto2.subtle.digest(algorithm, this.rawData);
      }
      async isSelfSigned(crypto2 = cryptoProvider.get()) {
        return this.subject === this.issuer && await this.verify({ signatureOnly: true }, crypto2);
      }
      toTextObject() {
        const obj = this.toTextObjectEmpty();
        const cert = asn1Schema.AsnConvert.parse(this.rawData, asn1X509.Certificate);
        const tbs = cert.tbsCertificate;
        const data = new TextObject("", {
          "Version": `${asn1X509.Version[tbs.version]} (${tbs.version})`,
          "Serial Number": tbs.serialNumber,
          "Signature Algorithm": TextConverter.serializeAlgorithm(tbs.signature),
          "Issuer": this.issuer,
          "Validity": new TextObject("", {
            "Not Before": tbs.validity.notBefore.getTime(),
            "Not After": tbs.validity.notAfter.getTime()
          }),
          "Subject": this.subject,
          "Subject Public Key Info": this.publicKey
        });
        if (tbs.issuerUniqueID) {
          data["Issuer Unique ID"] = tbs.issuerUniqueID;
        }
        if (tbs.subjectUniqueID) {
          data["Subject Unique ID"] = tbs.subjectUniqueID;
        }
        if (this.extensions.length) {
          const extensions2 = new TextObject("");
          for (const ext of this.extensions) {
            const extObj = ext.toTextObject();
            extensions2[extObj[TextObject.NAME]] = extObj;
          }
          data["Extensions"] = extensions2;
        }
        obj["Data"] = data;
        obj["Signature"] = new TextObject("", {
          "Algorithm": TextConverter.serializeAlgorithm(cert.signatureAlgorithm),
          "": cert.signatureValue
        });
        return obj;
      }
    };
    X509Certificate.NAME = "Certificate";
    var AuthorityKeyIdentifierExtension = class _AuthorityKeyIdentifierExtension extends Extension {
      static async create(param, critical = false, crypto2 = cryptoProvider.get()) {
        if (param instanceof X509Certificate || CryptoProvider.isCryptoKey(param)) {
          const publicKey = param instanceof X509Certificate ? await param.publicKey.export(crypto2) : param;
          const spki = await crypto2.subtle.exportKey("spki", publicKey);
          const key = new PublicKey(spki);
          const id = await key.getKeyIdentifier(crypto2);
          return new _AuthorityKeyIdentifierExtension(pvtsutils.Convert.ToHex(id), critical);
        } else {
          return new _AuthorityKeyIdentifierExtension(param, critical);
        }
      }
      constructor(...args) {
        if (pvtsutils.BufferSourceConverter.isBufferSource(args[0])) {
          super(args[0]);
        } else if (typeof args[0] === "string") {
          const value = new asn1X509__namespace.AuthorityKeyIdentifier({ keyIdentifier: new asn1X509__namespace.KeyIdentifier(pvtsutils.Convert.FromHex(args[0])) });
          super(asn1X509__namespace.id_ce_authorityKeyIdentifier, args[1], asn1Schema.AsnConvert.serialize(value));
        } else {
          const certId = args[0];
          const certIdName = certId.name instanceof GeneralNames ? asn1Schema.AsnConvert.parse(certId.name.rawData, asn1X509__namespace.GeneralNames) : certId.name;
          const value = new asn1X509__namespace.AuthorityKeyIdentifier({
            authorityCertIssuer: certIdName,
            authorityCertSerialNumber: pvtsutils.Convert.FromHex(certId.serialNumber)
          });
          super(asn1X509__namespace.id_ce_authorityKeyIdentifier, args[1], asn1Schema.AsnConvert.serialize(value));
        }
      }
      onInit(asn) {
        super.onInit(asn);
        const aki = asn1Schema.AsnConvert.parse(asn.extnValue, asn1X509__namespace.AuthorityKeyIdentifier);
        if (aki.keyIdentifier) {
          this.keyId = pvtsutils.Convert.ToHex(aki.keyIdentifier);
        }
        if (aki.authorityCertIssuer && aki.authorityCertSerialNumber) {
          this.certId = {
            name: aki.authorityCertIssuer,
            serialNumber: pvtsutils.Convert.ToHex(aki.authorityCertSerialNumber)
          };
        }
      }
      toTextObject() {
        const obj = this.toTextObjectWithoutValue();
        const asn = asn1Schema.AsnConvert.parse(this.value, asn1X509__namespace.AuthorityKeyIdentifier);
        if (asn.authorityCertIssuer) {
          obj["Authority Issuer"] = new GeneralNames(asn.authorityCertIssuer).toTextObject();
        }
        if (asn.authorityCertSerialNumber) {
          obj["Authority Serial Number"] = asn.authorityCertSerialNumber;
        }
        if (asn.keyIdentifier) {
          obj[""] = asn.keyIdentifier;
        }
        return obj;
      }
    };
    AuthorityKeyIdentifierExtension.NAME = "Authority Key Identifier";
    var BasicConstraintsExtension = class extends Extension {
      constructor(...args) {
        if (pvtsutils.BufferSourceConverter.isBufferSource(args[0])) {
          super(args[0]);
          const value = asn1Schema.AsnConvert.parse(this.value, asn1X509.BasicConstraints);
          this.ca = value.cA;
          this.pathLength = value.pathLenConstraint;
        } else {
          const value = new asn1X509.BasicConstraints({
            cA: args[0],
            pathLenConstraint: args[1]
          });
          super(asn1X509.id_ce_basicConstraints, args[2], asn1Schema.AsnConvert.serialize(value));
          this.ca = args[0];
          this.pathLength = args[1];
        }
      }
      toTextObject() {
        const obj = this.toTextObjectWithoutValue();
        if (this.ca) {
          obj["CA"] = this.ca;
        }
        if (this.pathLength !== void 0) {
          obj["Path Length"] = this.pathLength;
        }
        return obj;
      }
    };
    BasicConstraintsExtension.NAME = "Basic Constraints";
    exports2.ExtendedKeyUsage = void 0;
    (function(ExtendedKeyUsage) {
      ExtendedKeyUsage["serverAuth"] = "1.3.6.1.5.5.7.3.1";
      ExtendedKeyUsage["clientAuth"] = "1.3.6.1.5.5.7.3.2";
      ExtendedKeyUsage["codeSigning"] = "1.3.6.1.5.5.7.3.3";
      ExtendedKeyUsage["emailProtection"] = "1.3.6.1.5.5.7.3.4";
      ExtendedKeyUsage["timeStamping"] = "1.3.6.1.5.5.7.3.8";
      ExtendedKeyUsage["ocspSigning"] = "1.3.6.1.5.5.7.3.9";
    })(exports2.ExtendedKeyUsage || (exports2.ExtendedKeyUsage = {}));
    var ExtendedKeyUsageExtension = class extends Extension {
      constructor(...args) {
        if (pvtsutils.BufferSourceConverter.isBufferSource(args[0])) {
          super(args[0]);
          const value = asn1Schema.AsnConvert.parse(this.value, asn1X509__namespace.ExtendedKeyUsage);
          this.usages = value.map((o2) => o2);
        } else {
          const value = new asn1X509__namespace.ExtendedKeyUsage(args[0]);
          super(asn1X509__namespace.id_ce_extKeyUsage, args[1], asn1Schema.AsnConvert.serialize(value));
          this.usages = args[0];
        }
      }
      toTextObject() {
        const obj = this.toTextObjectWithoutValue();
        obj[""] = this.usages.map((o2) => OidSerializer.toString(o2)).join(", ");
        return obj;
      }
    };
    ExtendedKeyUsageExtension.NAME = "Extended Key Usages";
    exports2.KeyUsageFlags = void 0;
    (function(KeyUsageFlags) {
      KeyUsageFlags[KeyUsageFlags["digitalSignature"] = 1] = "digitalSignature";
      KeyUsageFlags[KeyUsageFlags["nonRepudiation"] = 2] = "nonRepudiation";
      KeyUsageFlags[KeyUsageFlags["keyEncipherment"] = 4] = "keyEncipherment";
      KeyUsageFlags[KeyUsageFlags["dataEncipherment"] = 8] = "dataEncipherment";
      KeyUsageFlags[KeyUsageFlags["keyAgreement"] = 16] = "keyAgreement";
      KeyUsageFlags[KeyUsageFlags["keyCertSign"] = 32] = "keyCertSign";
      KeyUsageFlags[KeyUsageFlags["cRLSign"] = 64] = "cRLSign";
      KeyUsageFlags[KeyUsageFlags["encipherOnly"] = 128] = "encipherOnly";
      KeyUsageFlags[KeyUsageFlags["decipherOnly"] = 256] = "decipherOnly";
    })(exports2.KeyUsageFlags || (exports2.KeyUsageFlags = {}));
    var KeyUsagesExtension = class extends Extension {
      constructor(...args) {
        if (pvtsutils.BufferSourceConverter.isBufferSource(args[0])) {
          super(args[0]);
          const value = asn1Schema.AsnConvert.parse(this.value, asn1X509.KeyUsage);
          this.usages = value.toNumber();
        } else {
          const value = new asn1X509.KeyUsage(args[0]);
          super(asn1X509.id_ce_keyUsage, args[1], asn1Schema.AsnConvert.serialize(value));
          this.usages = args[0];
        }
      }
      toTextObject() {
        const obj = this.toTextObjectWithoutValue();
        const asn = asn1Schema.AsnConvert.parse(this.value, asn1X509.KeyUsage);
        obj[""] = asn.toJSON().join(", ");
        return obj;
      }
    };
    KeyUsagesExtension.NAME = "Key Usages";
    var SubjectKeyIdentifierExtension = class _SubjectKeyIdentifierExtension extends Extension {
      static async create(publicKey, critical = false, crypto2 = cryptoProvider.get()) {
        let spki;
        if (publicKey instanceof PublicKey) {
          spki = publicKey.rawData;
        } else if ("publicKey" in publicKey) {
          spki = publicKey.publicKey.rawData;
        } else if (pvtsutils.BufferSourceConverter.isBufferSource(publicKey)) {
          spki = publicKey;
        } else {
          spki = await crypto2.subtle.exportKey("spki", publicKey);
        }
        const key = new PublicKey(spki);
        const id = await key.getKeyIdentifier(crypto2);
        return new _SubjectKeyIdentifierExtension(pvtsutils.Convert.ToHex(id), critical);
      }
      constructor(...args) {
        if (pvtsutils.BufferSourceConverter.isBufferSource(args[0])) {
          super(args[0]);
          const value = asn1Schema.AsnConvert.parse(this.value, asn1X509__namespace.SubjectKeyIdentifier);
          this.keyId = pvtsutils.Convert.ToHex(value);
        } else {
          const identifier = typeof args[0] === "string" ? pvtsutils.Convert.FromHex(args[0]) : args[0];
          const value = new asn1X509__namespace.SubjectKeyIdentifier(identifier);
          super(asn1X509__namespace.id_ce_subjectKeyIdentifier, args[1], asn1Schema.AsnConvert.serialize(value));
          this.keyId = pvtsutils.Convert.ToHex(identifier);
        }
      }
      toTextObject() {
        const obj = this.toTextObjectWithoutValue();
        const asn = asn1Schema.AsnConvert.parse(this.value, asn1X509__namespace.SubjectKeyIdentifier);
        obj[""] = asn;
        return obj;
      }
    };
    SubjectKeyIdentifierExtension.NAME = "Subject Key Identifier";
    var SubjectAlternativeNameExtension = class extends Extension {
      constructor(...args) {
        if (pvtsutils.BufferSourceConverter.isBufferSource(args[0])) {
          super(args[0]);
        } else {
          super(asn1X509__namespace.id_ce_subjectAltName, args[1], new GeneralNames(args[0] || []).rawData);
        }
      }
      onInit(asn) {
        super.onInit(asn);
        const value = asn1Schema.AsnConvert.parse(asn.extnValue, asn1X509__namespace.SubjectAlternativeName);
        this.names = new GeneralNames(value);
      }
      toTextObject() {
        const obj = this.toTextObjectWithoutValue();
        const namesObj = this.names.toTextObject();
        for (const key in namesObj) {
          obj[key] = namesObj[key];
        }
        return obj;
      }
    };
    SubjectAlternativeNameExtension.NAME = "Subject Alternative Name";
    var CertificatePolicyExtension = class extends Extension {
      constructor(...args) {
        var _a2;
        if (pvtsutils.BufferSourceConverter.isBufferSource(args[0])) {
          super(args[0]);
          const asnPolicies = asn1Schema.AsnConvert.parse(this.value, asn1X509__namespace.CertificatePolicies);
          this.policies = asnPolicies.map((o2) => o2.policyIdentifier);
        } else {
          const policies = args[0];
          const critical = (_a2 = args[1]) !== null && _a2 !== void 0 ? _a2 : false;
          const value = new asn1X509__namespace.CertificatePolicies(policies.map((o2) => new asn1X509__namespace.PolicyInformation({
            policyIdentifier: o2
          })));
          super(asn1X509__namespace.id_ce_certificatePolicies, critical, asn1Schema.AsnConvert.serialize(value));
          this.policies = policies;
        }
      }
      toTextObject() {
        const obj = this.toTextObjectWithoutValue();
        obj["Policy"] = this.policies.map((o2) => new TextObject("", {}, OidSerializer.toString(o2)));
        return obj;
      }
    };
    CertificatePolicyExtension.NAME = "Certificate Policies";
    ExtensionFactory.register(asn1X509__namespace.id_ce_certificatePolicies, CertificatePolicyExtension);
    var Attribute = class _Attribute extends AsnData {
      constructor(...args) {
        let raw2;
        if (pvtsutils.BufferSourceConverter.isBufferSource(args[0])) {
          raw2 = pvtsutils.BufferSourceConverter.toArrayBuffer(args[0]);
        } else {
          const type = args[0];
          const values = Array.isArray(args[1]) ? args[1].map((o2) => pvtsutils.BufferSourceConverter.toArrayBuffer(o2)) : [];
          raw2 = asn1Schema.AsnConvert.serialize(new asn1X509.Attribute({ type, values }));
        }
        super(raw2, asn1X509.Attribute);
      }
      onInit(asn) {
        this.type = asn.type;
        this.values = asn.values;
      }
      toTextObject() {
        const obj = this.toTextObjectWithoutValue();
        obj["Value"] = this.values.map((o2) => new TextObject("", { "": o2 }));
        return obj;
      }
      toTextObjectWithoutValue() {
        const obj = this.toTextObjectEmpty();
        if (obj[TextObject.NAME] === _Attribute.NAME) {
          obj[TextObject.NAME] = OidSerializer.toString(this.type);
        }
        return obj;
      }
    };
    Attribute.NAME = "Attribute";
    var ChallengePasswordAttribute = class extends Attribute {
      constructor(...args) {
        var _a2;
        if (pvtsutils.BufferSourceConverter.isBufferSource(args[0])) {
          super(args[0]);
        } else {
          const value = new asnPkcs9__namespace.ChallengePassword({
            printableString: args[0]
          });
          super(asnPkcs9__namespace.id_pkcs9_at_challengePassword, [asn1Schema.AsnConvert.serialize(value)]);
        }
        (_a2 = this.password) !== null && _a2 !== void 0 ? _a2 : this.password = "";
      }
      onInit(asn) {
        super.onInit(asn);
        if (this.values[0]) {
          const value = asn1Schema.AsnConvert.parse(this.values[0], asnPkcs9__namespace.ChallengePassword);
          this.password = value.toString();
        }
      }
      toTextObject() {
        const obj = this.toTextObjectWithoutValue();
        obj[TextObject.VALUE] = this.password;
        return obj;
      }
    };
    ChallengePasswordAttribute.NAME = "Challenge Password";
    var ExtensionsAttribute = class extends Attribute {
      constructor(...args) {
        var _a2;
        if (pvtsutils.BufferSourceConverter.isBufferSource(args[0])) {
          super(args[0]);
        } else {
          const extensions2 = args[0];
          const value = new asn1X509__namespace.Extensions();
          for (const extension of extensions2) {
            value.push(asn1Schema.AsnConvert.parse(extension.rawData, asn1X509__namespace.Extension));
          }
          super(asnPkcs9__namespace.id_pkcs9_at_extensionRequest, [asn1Schema.AsnConvert.serialize(value)]);
        }
        (_a2 = this.items) !== null && _a2 !== void 0 ? _a2 : this.items = [];
      }
      onInit(asn) {
        super.onInit(asn);
        if (this.values[0]) {
          const value = asn1Schema.AsnConvert.parse(this.values[0], asn1X509__namespace.Extensions);
          this.items = value.map((o2) => ExtensionFactory.create(asn1Schema.AsnConvert.serialize(o2)));
        }
      }
      toTextObject() {
        const obj = this.toTextObjectWithoutValue();
        const extensions2 = this.items.map((o2) => o2.toTextObject());
        for (const extension of extensions2) {
          obj[extension[TextObject.NAME]] = extension;
        }
        return obj;
      }
    };
    ExtensionsAttribute.NAME = "Extensions";
    var AttributeFactory = class {
      static register(id, type) {
        this.items.set(id, type);
      }
      static create(data) {
        const attribute = new Attribute(data);
        const Type = this.items.get(attribute.type);
        if (Type) {
          return new Type(data);
        }
        return attribute;
      }
    };
    AttributeFactory.items = /* @__PURE__ */ new Map();
    exports2.RsaAlgorithm = class RsaAlgorithm {
      toAsnAlgorithm(alg) {
        switch (alg.name.toLowerCase()) {
          case "rsassa-pkcs1-v1_5":
            if ("hash" in alg) {
              let hash;
              if (typeof alg.hash === "string") {
                hash = alg.hash;
              } else if (alg.hash && typeof alg.hash === "object" && "name" in alg.hash && typeof alg.hash.name === "string") {
                hash = alg.hash.name.toUpperCase();
              } else {
                throw new Error("Cannot get hash algorithm name");
              }
              switch (hash.toLowerCase()) {
                case "sha-1":
                  return new asn1X509.AlgorithmIdentifier({ algorithm: asn1Rsa__namespace.id_sha1WithRSAEncryption, parameters: null });
                case "sha-256":
                  return new asn1X509.AlgorithmIdentifier({ algorithm: asn1Rsa__namespace.id_sha256WithRSAEncryption, parameters: null });
                case "sha-384":
                  return new asn1X509.AlgorithmIdentifier({ algorithm: asn1Rsa__namespace.id_sha384WithRSAEncryption, parameters: null });
                case "sha-512":
                  return new asn1X509.AlgorithmIdentifier({ algorithm: asn1Rsa__namespace.id_sha512WithRSAEncryption, parameters: null });
              }
            } else {
              return new asn1X509.AlgorithmIdentifier({ algorithm: asn1Rsa__namespace.id_rsaEncryption, parameters: null });
            }
        }
        return null;
      }
      toWebAlgorithm(alg) {
        switch (alg.algorithm) {
          case asn1Rsa__namespace.id_rsaEncryption:
            return { name: "RSASSA-PKCS1-v1_5" };
          case asn1Rsa__namespace.id_sha1WithRSAEncryption:
            return { name: "RSASSA-PKCS1-v1_5", hash: { name: "SHA-1" } };
          case asn1Rsa__namespace.id_sha256WithRSAEncryption:
            return { name: "RSASSA-PKCS1-v1_5", hash: { name: "SHA-256" } };
          case asn1Rsa__namespace.id_sha384WithRSAEncryption:
            return { name: "RSASSA-PKCS1-v1_5", hash: { name: "SHA-384" } };
          case asn1Rsa__namespace.id_sha512WithRSAEncryption:
            return { name: "RSASSA-PKCS1-v1_5", hash: { name: "SHA-512" } };
        }
        return null;
      }
    };
    exports2.RsaAlgorithm = tslib.__decorate([
      tsyringe.injectable()
    ], exports2.RsaAlgorithm);
    tsyringe.container.registerSingleton(diAlgorithm, exports2.RsaAlgorithm);
    var AsnEcSignatureFormatter = class _AsnEcSignatureFormatter {
      addPadding(pointSize, data) {
        const bytes = pvtsutils.BufferSourceConverter.toUint8Array(data);
        const res = new Uint8Array(pointSize);
        res.set(bytes, pointSize - bytes.length);
        return res;
      }
      removePadding(data, positive = false) {
        let bytes = pvtsutils.BufferSourceConverter.toUint8Array(data);
        for (let i = 0; i < bytes.length; i++) {
          if (!bytes[i]) {
            continue;
          }
          bytes = bytes.slice(i);
          break;
        }
        if (positive && bytes[0] > 127) {
          const result2 = new Uint8Array(bytes.length + 1);
          result2.set(bytes, 1);
          return result2.buffer;
        }
        return bytes.buffer;
      }
      toAsnSignature(algorithm, signature) {
        if (algorithm.name === "ECDSA") {
          const namedCurve = algorithm.namedCurve;
          const pointSize = _AsnEcSignatureFormatter.namedCurveSize.get(namedCurve) || _AsnEcSignatureFormatter.defaultNamedCurveSize;
          const ecSignature = new asn1Ecc.ECDSASigValue();
          const uint8Signature = pvtsutils.BufferSourceConverter.toUint8Array(signature);
          ecSignature.r = this.removePadding(uint8Signature.slice(0, pointSize), true);
          ecSignature.s = this.removePadding(uint8Signature.slice(pointSize, pointSize + pointSize), true);
          return asn1Schema.AsnConvert.serialize(ecSignature);
        }
        return null;
      }
      toWebSignature(algorithm, signature) {
        if (algorithm.name === "ECDSA") {
          const ecSigValue = asn1Schema.AsnConvert.parse(signature, asn1Ecc.ECDSASigValue);
          const namedCurve = algorithm.namedCurve;
          const pointSize = _AsnEcSignatureFormatter.namedCurveSize.get(namedCurve) || _AsnEcSignatureFormatter.defaultNamedCurveSize;
          const r = this.addPadding(pointSize, this.removePadding(ecSigValue.r));
          const s = this.addPadding(pointSize, this.removePadding(ecSigValue.s));
          return pvtsutils.combine(r, s);
        }
        return null;
      }
    };
    AsnEcSignatureFormatter.namedCurveSize = /* @__PURE__ */ new Map();
    AsnEcSignatureFormatter.defaultNamedCurveSize = 32;
    var idX25519 = "1.3.101.110";
    var idX448 = "1.3.101.111";
    var idEd25519 = "1.3.101.112";
    var idEd448 = "1.3.101.113";
    exports2.EdAlgorithm = class EdAlgorithm {
      toAsnAlgorithm(alg) {
        let algorithm = null;
        switch (alg.name.toLowerCase()) {
          case "eddsa":
            switch (alg.namedCurve.toLowerCase()) {
              case "ed25519":
                algorithm = idEd25519;
                break;
              case "ed448":
                algorithm = idEd448;
                break;
            }
            break;
          case "ecdh-es":
            switch (alg.namedCurve.toLowerCase()) {
              case "x25519":
                algorithm = idX25519;
                break;
              case "x448":
                algorithm = idX448;
                break;
            }
        }
        if (algorithm) {
          return new asn1X509.AlgorithmIdentifier({
            algorithm
          });
        }
        return null;
      }
      toWebAlgorithm(alg) {
        switch (alg.algorithm) {
          case idEd25519:
            return { name: "EdDSA", namedCurve: "Ed25519" };
          case idEd448:
            return { name: "EdDSA", namedCurve: "Ed448" };
          case idX25519:
            return { name: "ECDH-ES", namedCurve: "X25519" };
          case idX448:
            return { name: "ECDH-ES", namedCurve: "X448" };
        }
        return null;
      }
    };
    exports2.EdAlgorithm = tslib.__decorate([
      tsyringe.injectable()
    ], exports2.EdAlgorithm);
    tsyringe.container.registerSingleton(diAlgorithm, exports2.EdAlgorithm);
    var Pkcs10CertificateRequest = class extends PemData {
      constructor(param) {
        if (PemData.isAsnEncoded(param)) {
          super(param, asn1Csr.CertificationRequest);
        } else {
          super(param);
        }
        this.tag = PemConverter.CertificateRequestTag;
      }
      onInit(asn) {
        this.tbs = asn1Schema.AsnConvert.serialize(asn.certificationRequestInfo);
        this.publicKey = new PublicKey(asn.certificationRequestInfo.subjectPKInfo);
        const algProv = tsyringe.container.resolve(diAlgorithmProvider);
        this.signatureAlgorithm = algProv.toWebAlgorithm(asn.signatureAlgorithm);
        this.signature = asn.signature;
        this.attributes = asn.certificationRequestInfo.attributes.map((o2) => AttributeFactory.create(asn1Schema.AsnConvert.serialize(o2)));
        const extensions2 = this.getAttribute(asnPkcs9.id_pkcs9_at_extensionRequest);
        this.extensions = [];
        if (extensions2 instanceof ExtensionsAttribute) {
          this.extensions = extensions2.items;
        }
        this.subjectName = new Name(asn.certificationRequestInfo.subject);
        this.subject = this.subjectName.toString();
      }
      getAttribute(type) {
        for (const attr of this.attributes) {
          if (attr.type === type) {
            return attr;
          }
        }
        return null;
      }
      getAttributes(type) {
        return this.attributes.filter((o2) => o2.type === type);
      }
      getExtension(type) {
        for (const ext of this.extensions) {
          if (ext.type === type) {
            return ext;
          }
        }
        return null;
      }
      getExtensions(type) {
        return this.extensions.filter((o2) => o2.type === type);
      }
      async verify(crypto2 = cryptoProvider.get()) {
        const algorithm = { ...this.publicKey.algorithm, ...this.signatureAlgorithm };
        const publicKey = await this.publicKey.export(algorithm, ["verify"], crypto2);
        const signatureFormatters = tsyringe.container.resolveAll(diAsnSignatureFormatter).reverse();
        let signature = null;
        for (const signatureFormatter of signatureFormatters) {
          signature = signatureFormatter.toWebSignature(algorithm, this.signature);
          if (signature) {
            break;
          }
        }
        if (!signature) {
          throw Error("Cannot convert WebCrypto signature value to ASN.1 format");
        }
        const ok = await crypto2.subtle.verify(this.signatureAlgorithm, publicKey, signature, this.tbs);
        return ok;
      }
      toTextObject() {
        const obj = this.toTextObjectEmpty();
        const req = asn1Schema.AsnConvert.parse(this.rawData, asn1Csr.CertificationRequest);
        const tbs = req.certificationRequestInfo;
        const data = new TextObject("", {
          "Version": `${asn1X509.Version[tbs.version]} (${tbs.version})`,
          "Subject": this.subject,
          "Subject Public Key Info": this.publicKey
        });
        if (this.attributes.length) {
          const attrs = new TextObject("");
          for (const ext of this.attributes) {
            const attrObj = ext.toTextObject();
            attrs[attrObj[TextObject.NAME]] = attrObj;
          }
          data["Attributes"] = attrs;
        }
        obj["Data"] = data;
        obj["Signature"] = new TextObject("", {
          "Algorithm": TextConverter.serializeAlgorithm(req.signatureAlgorithm),
          "": req.signature
        });
        return obj;
      }
    };
    Pkcs10CertificateRequest.NAME = "PKCS#10 Certificate Request";
    var Pkcs10CertificateRequestGenerator = class {
      static async create(params, crypto2 = cryptoProvider.get()) {
        if (!params.keys.privateKey) {
          throw new Error("Bad field 'keys' in 'params' argument. 'privateKey' is empty");
        }
        if (!params.keys.publicKey) {
          throw new Error("Bad field 'keys' in 'params' argument. 'publicKey' is empty");
        }
        const spki = await crypto2.subtle.exportKey("spki", params.keys.publicKey);
        const asnReq = new asn1Csr.CertificationRequest({
          certificationRequestInfo: new asn1Csr.CertificationRequestInfo({
            subjectPKInfo: asn1Schema.AsnConvert.parse(spki, asn1X509.SubjectPublicKeyInfo)
          })
        });
        if (params.name) {
          const name = params.name instanceof Name ? params.name : new Name(params.name);
          asnReq.certificationRequestInfo.subject = asn1Schema.AsnConvert.parse(name.toArrayBuffer(), asn1X509.Name);
        }
        if (params.attributes) {
          for (const o2 of params.attributes) {
            asnReq.certificationRequestInfo.attributes.push(asn1Schema.AsnConvert.parse(o2.rawData, asn1X509.Attribute));
          }
        }
        if (params.extensions && params.extensions.length) {
          const attr = new asn1X509.Attribute({ type: asnPkcs9.id_pkcs9_at_extensionRequest });
          const extensions2 = new asn1X509.Extensions();
          for (const o2 of params.extensions) {
            extensions2.push(asn1Schema.AsnConvert.parse(o2.rawData, asn1X509.Extension));
          }
          attr.values.push(asn1Schema.AsnConvert.serialize(extensions2));
          asnReq.certificationRequestInfo.attributes.push(attr);
        }
        const signingAlgorithm = { ...params.signingAlgorithm, ...params.keys.privateKey.algorithm };
        const algProv = tsyringe.container.resolve(diAlgorithmProvider);
        asnReq.signatureAlgorithm = algProv.toAsnAlgorithm(signingAlgorithm);
        const tbs = asn1Schema.AsnConvert.serialize(asnReq.certificationRequestInfo);
        const signature = await crypto2.subtle.sign(signingAlgorithm, params.keys.privateKey, tbs);
        const signatureFormatters = tsyringe.container.resolveAll(diAsnSignatureFormatter).reverse();
        let asnSignature = null;
        for (const signatureFormatter of signatureFormatters) {
          asnSignature = signatureFormatter.toAsnSignature(signingAlgorithm, signature);
          if (asnSignature) {
            break;
          }
        }
        if (!asnSignature) {
          throw Error("Cannot convert WebCrypto signature value to ASN.1 format");
        }
        asnReq.signature = asnSignature;
        return new Pkcs10CertificateRequest(asn1Schema.AsnConvert.serialize(asnReq));
      }
    };
    var X509Certificates = class extends Array {
      constructor(param) {
        super();
        if (PemData.isAsnEncoded(param)) {
          this.import(param);
        } else if (param instanceof X509Certificate) {
          this.push(param);
        } else if (Array.isArray(param)) {
          for (const item of param) {
            this.push(item);
          }
        }
      }
      export(format3) {
        const signedData = new asn1Cms__namespace.SignedData();
        signedData.version = 1;
        signedData.encapContentInfo.eContentType = asn1Cms__namespace.id_data;
        signedData.encapContentInfo.eContent = new asn1Cms__namespace.EncapsulatedContent({
          single: new asn1Schema.OctetString()
        });
        signedData.certificates = new asn1Cms__namespace.CertificateSet(this.map((o2) => new asn1Cms__namespace.CertificateChoices({
          certificate: asn1Schema.AsnConvert.parse(o2.rawData, asn1X509.Certificate)
        })));
        const cms = new asn1Cms__namespace.ContentInfo({
          contentType: asn1Cms__namespace.id_signedData,
          content: asn1Schema.AsnConvert.serialize(signedData)
        });
        const raw2 = asn1Schema.AsnConvert.serialize(cms);
        if (format3 === "raw") {
          return raw2;
        }
        return this.toString(format3);
      }
      import(data) {
        const raw2 = PemData.toArrayBuffer(data);
        const cms = asn1Schema.AsnConvert.parse(raw2, asn1Cms__namespace.ContentInfo);
        if (cms.contentType !== asn1Cms__namespace.id_signedData) {
          throw new TypeError("Cannot parse CMS package. Incoming data is not a SignedData object.");
        }
        const signedData = asn1Schema.AsnConvert.parse(cms.content, asn1Cms__namespace.SignedData);
        this.clear();
        for (const item of signedData.certificates || []) {
          if (item.certificate) {
            this.push(new X509Certificate(item.certificate));
          }
        }
      }
      clear() {
        while (this.pop()) {
        }
      }
      toString(format3 = "pem") {
        const raw2 = this.export("raw");
        switch (format3) {
          case "pem":
            return PemConverter.encode(raw2, "CMS");
          case "pem-chain":
            return this.map((o2) => o2.toString("pem")).join("\n");
          case "asn":
            return asn1Schema.AsnConvert.toString(raw2);
          case "hex":
            return pvtsutils.Convert.ToHex(raw2);
          case "base64":
            return pvtsutils.Convert.ToBase64(raw2);
          case "base64url":
            return pvtsutils.Convert.ToBase64Url(raw2);
          case "text":
            return TextConverter.serialize(this.toTextObject());
          default:
            throw TypeError("Argument 'format' is unsupported value");
        }
      }
      toTextObject() {
        const contentInfo = asn1Schema.AsnConvert.parse(this.export("raw"), asn1Cms__namespace.ContentInfo);
        const signedData = asn1Schema.AsnConvert.parse(contentInfo.content, asn1Cms__namespace.SignedData);
        const obj = new TextObject("X509Certificates", {
          "Content Type": OidSerializer.toString(contentInfo.contentType),
          "Content": new TextObject("", {
            "Version": `${asn1Cms__namespace.CMSVersion[signedData.version]} (${signedData.version})`,
            "Certificates": new TextObject("", { "Certificate": this.map((o2) => o2.toTextObject()) })
          })
        });
        return obj;
      }
    };
    var X509ChainBuilder = class {
      constructor(params = {}) {
        this.certificates = [];
        if (params.certificates) {
          this.certificates = params.certificates;
        }
      }
      async build(cert, crypto2 = cryptoProvider.get()) {
        const chain = new X509Certificates(cert);
        let current = cert;
        while (current = await this.findIssuer(current, crypto2)) {
          const thumbprint = await current.getThumbprint(crypto2);
          for (const item of chain) {
            const thumbprint2 = await item.getThumbprint(crypto2);
            if (pvtsutils.isEqual(thumbprint, thumbprint2)) {
              throw new Error("Cannot build a certificate chain. Circular dependency.");
            }
          }
          chain.push(current);
        }
        return chain;
      }
      async findIssuer(cert, crypto2 = cryptoProvider.get()) {
        if (!await cert.isSelfSigned(crypto2)) {
          const akiExt = cert.getExtension(asn1X509__namespace.id_ce_authorityKeyIdentifier);
          for (const item of this.certificates) {
            if (item.subject !== cert.issuer) {
              continue;
            }
            if (akiExt) {
              if (akiExt.keyId) {
                const skiExt = item.getExtension(asn1X509__namespace.id_ce_subjectKeyIdentifier);
                if (skiExt && skiExt.keyId !== akiExt.keyId) {
                  continue;
                }
              } else if (akiExt.certId) {
                const sanExt = item.getExtension(asn1X509__namespace.id_ce_subjectAltName);
                if (sanExt && !(akiExt.certId.serialNumber === item.serialNumber && pvtsutils.isEqual(asn1Schema.AsnConvert.serialize(akiExt.certId.name), asn1Schema.AsnConvert.serialize(sanExt)))) {
                  continue;
                }
              }
            }
            try {
              const algorithm = { ...item.publicKey.algorithm, ...cert.signatureAlgorithm };
              const publicKey = await item.publicKey.export(algorithm, ["verify"], crypto2);
              if (!await cert.verify({ publicKey, signatureOnly: true }, crypto2)) {
                continue;
              }
            } catch (e) {
              continue;
            }
            return item;
          }
        }
        return null;
      }
    };
    var X509CertificateGenerator = class {
      static async createSelfSigned(params, crypto2 = cryptoProvider.get()) {
        if (!params.keys.privateKey) {
          throw new Error("Bad field 'keys' in 'params' argument. 'privateKey' is empty");
        }
        if (!params.keys.publicKey) {
          throw new Error("Bad field 'keys' in 'params' argument. 'publicKey' is empty");
        }
        return this.create({
          serialNumber: params.serialNumber,
          subject: params.name,
          issuer: params.name,
          notBefore: params.notBefore,
          notAfter: params.notAfter,
          publicKey: params.keys.publicKey,
          signingKey: params.keys.privateKey,
          signingAlgorithm: params.signingAlgorithm,
          extensions: params.extensions
        }, crypto2);
      }
      static async create(params, crypto2 = cryptoProvider.get()) {
        var _a2;
        let spki;
        if (params.publicKey instanceof PublicKey) {
          spki = params.publicKey.rawData;
        } else if ("publicKey" in params.publicKey) {
          spki = params.publicKey.publicKey.rawData;
        } else if (pvtsutils.BufferSourceConverter.isBufferSource(params.publicKey)) {
          spki = params.publicKey;
        } else {
          spki = await crypto2.subtle.exportKey("spki", params.publicKey);
        }
        const serialNumber = params.serialNumber ? pvtsutils.BufferSourceConverter.toUint8Array(pvtsutils.Convert.FromHex(params.serialNumber)) : crypto2.getRandomValues(new Uint8Array(16));
        if (serialNumber[0] > 127) {
          serialNumber[0] &= 127;
        }
        const notBefore = params.notBefore || /* @__PURE__ */ new Date();
        const notAfter = params.notAfter || new Date(notBefore.getTime() + 31536e6);
        const asnX509 = new asn1X509__namespace.Certificate({
          tbsCertificate: new asn1X509__namespace.TBSCertificate({
            version: asn1X509__namespace.Version.v3,
            serialNumber,
            validity: new asn1X509__namespace.Validity({
              notBefore,
              notAfter
            }),
            extensions: new asn1X509__namespace.Extensions(((_a2 = params.extensions) === null || _a2 === void 0 ? void 0 : _a2.map((o2) => asn1Schema.AsnConvert.parse(o2.rawData, asn1X509__namespace.Extension))) || []),
            subjectPublicKeyInfo: asn1Schema.AsnConvert.parse(spki, asn1X509__namespace.SubjectPublicKeyInfo)
          })
        });
        if (params.subject) {
          const name = params.subject instanceof Name ? params.subject : new Name(params.subject);
          asnX509.tbsCertificate.subject = asn1Schema.AsnConvert.parse(name.toArrayBuffer(), asn1X509__namespace.Name);
        }
        if (params.issuer) {
          const name = params.issuer instanceof Name ? params.issuer : new Name(params.issuer);
          asnX509.tbsCertificate.issuer = asn1Schema.AsnConvert.parse(name.toArrayBuffer(), asn1X509__namespace.Name);
        }
        const defaultSigningAlgorithm = {
          hash: "SHA-256"
        };
        const signatureAlgorithm = "signingKey" in params ? { ...defaultSigningAlgorithm, ...params.signingAlgorithm, ...params.signingKey.algorithm } : params.publicKey.algorithm;
        const algProv = tsyringe.container.resolve(diAlgorithmProvider);
        asnX509.tbsCertificate.signature = asnX509.signatureAlgorithm = algProv.toAsnAlgorithm(signatureAlgorithm);
        const tbs = asn1Schema.AsnConvert.serialize(asnX509.tbsCertificate);
        const signatureValue = "signingKey" in params ? await crypto2.subtle.sign(signatureAlgorithm, params.signingKey, tbs) : params.signature;
        const signatureFormatters = tsyringe.container.resolveAll(diAsnSignatureFormatter).reverse();
        let asnSignature = null;
        for (const signatureFormatter of signatureFormatters) {
          asnSignature = signatureFormatter.toAsnSignature(signatureAlgorithm, signatureValue);
          if (asnSignature) {
            break;
          }
        }
        if (!asnSignature) {
          throw Error("Cannot convert ASN.1 signature value to WebCrypto format");
        }
        asnX509.signatureValue = asnSignature;
        return new X509Certificate(asn1Schema.AsnConvert.serialize(asnX509));
      }
    };
    exports2.X509CrlReason = void 0;
    (function(X509CrlReason) {
      X509CrlReason[X509CrlReason["unspecified"] = 0] = "unspecified";
      X509CrlReason[X509CrlReason["keyCompromise"] = 1] = "keyCompromise";
      X509CrlReason[X509CrlReason["cACompromise"] = 2] = "cACompromise";
      X509CrlReason[X509CrlReason["affiliationChanged"] = 3] = "affiliationChanged";
      X509CrlReason[X509CrlReason["superseded"] = 4] = "superseded";
      X509CrlReason[X509CrlReason["cessationOfOperation"] = 5] = "cessationOfOperation";
      X509CrlReason[X509CrlReason["certificateHold"] = 6] = "certificateHold";
      X509CrlReason[X509CrlReason["removeFromCRL"] = 8] = "removeFromCRL";
      X509CrlReason[X509CrlReason["privilegeWithdrawn"] = 9] = "privilegeWithdrawn";
      X509CrlReason[X509CrlReason["aACompromise"] = 10] = "aACompromise";
    })(exports2.X509CrlReason || (exports2.X509CrlReason = {}));
    var X509CrlEntry = class extends AsnData {
      constructor(...args) {
        let raw2;
        if (pvtsutils.BufferSourceConverter.isBufferSource(args[0])) {
          raw2 = pvtsutils.BufferSourceConverter.toArrayBuffer(args[0]);
        } else {
          raw2 = asn1Schema.AsnConvert.serialize(new asn1X509.RevokedCertificate({
            userCertificate: args[0],
            revocationDate: new asn1X509.Time(args[1]),
            crlEntryExtensions: args[2]
          }));
        }
        super(raw2, asn1X509.RevokedCertificate);
      }
      onInit(asn) {
        this.serialNumber = pvtsutils.Convert.ToHex(asn.userCertificate);
        this.revocationDate = asn.revocationDate.getTime();
        this.extensions = [];
        if (asn.crlEntryExtensions) {
          this.extensions = asn.crlEntryExtensions.map((o2) => {
            const extension = ExtensionFactory.create(asn1Schema.AsnConvert.serialize(o2));
            switch (extension.type) {
              case asn1X509.id_ce_cRLReasons:
                this.reason = asn1Schema.AsnConvert.parse(extension.value, asn1X509.CRLReason).reason;
                break;
              case asn1X509.id_ce_invalidityDate:
                this.invalidity = asn1Schema.AsnConvert.parse(extension.value, asn1X509.InvalidityDate).value;
                break;
            }
            return extension;
          });
        }
      }
    };
    var X509Crl = class extends PemData {
      constructor(param) {
        if (PemData.isAsnEncoded(param)) {
          super(param, asn1X509.CertificateList);
        } else {
          super(param);
        }
        this.tag = PemConverter.CrlTag;
      }
      onInit(asn) {
        var _a2, _b;
        const tbs = asn.tbsCertList;
        this.tbs = asn1Schema.AsnConvert.serialize(tbs);
        this.version = tbs.version;
        const algProv = tsyringe.container.resolve(diAlgorithmProvider);
        this.signatureAlgorithm = algProv.toWebAlgorithm(asn.signatureAlgorithm);
        this.tbsCertListSignatureAlgorithm = tbs.signature;
        this.certListSignatureAlgorithm = asn.signatureAlgorithm;
        this.signature = asn.signature;
        this.issuerName = new Name(tbs.issuer);
        this.issuer = this.issuerName.toString();
        const thisUpdate = tbs.thisUpdate.getTime();
        if (!thisUpdate) {
          throw new Error("Cannot get 'thisUpdate' value");
        }
        this.thisUpdate = thisUpdate;
        const nextUpdate = (_a2 = tbs.nextUpdate) === null || _a2 === void 0 ? void 0 : _a2.getTime();
        this.nextUpdate = nextUpdate;
        this.entries = ((_b = tbs.revokedCertificates) === null || _b === void 0 ? void 0 : _b.map((o2) => new X509CrlEntry(asn1Schema.AsnConvert.serialize(o2)))) || [];
        this.extensions = [];
        if (tbs.crlExtensions) {
          this.extensions = tbs.crlExtensions.map((o2) => ExtensionFactory.create(asn1Schema.AsnConvert.serialize(o2)));
        }
      }
      getExtension(type) {
        for (const ext of this.extensions) {
          if (typeof type === "string") {
            if (ext.type === type) {
              return ext;
            }
          } else {
            if (ext instanceof type) {
              return ext;
            }
          }
        }
        return null;
      }
      getExtensions(type) {
        return this.extensions.filter((o2) => {
          if (typeof type === "string") {
            return o2.type === type;
          } else {
            return o2 instanceof type;
          }
        });
      }
      async verify(params, crypto2 = cryptoProvider.get()) {
        if (!this.certListSignatureAlgorithm.isEqual(this.tbsCertListSignatureAlgorithm)) {
          throw new Error("algorithm identifier in the sequence tbsCertList and CertificateList mismatch");
        }
        let keyAlgorithm;
        let publicKey;
        const paramsKey = params.publicKey;
        try {
          if (paramsKey instanceof X509Certificate) {
            keyAlgorithm = {
              ...paramsKey.publicKey.algorithm,
              ...paramsKey.signatureAlgorithm
            };
            publicKey = await paramsKey.publicKey.export(keyAlgorithm, ["verify"]);
          } else if (paramsKey instanceof PublicKey) {
            keyAlgorithm = { ...paramsKey.algorithm, ...this.signature };
            publicKey = await paramsKey.export(keyAlgorithm, ["verify"]);
          } else {
            keyAlgorithm = { ...paramsKey.algorithm, ...this.signature };
            publicKey = paramsKey;
          }
        } catch (e) {
          return false;
        }
        const signatureFormatters = tsyringe.container.resolveAll(diAsnSignatureFormatter).reverse();
        let signature = null;
        for (const signatureFormatter of signatureFormatters) {
          signature = signatureFormatter.toWebSignature(keyAlgorithm, this.signature);
          if (signature) {
            break;
          }
        }
        if (!signature) {
          throw Error("Cannot convert ASN.1 signature value to WebCrypto format");
        }
        return await crypto2.subtle.verify(this.signatureAlgorithm, publicKey, signature, this.tbs);
      }
      async getThumbprint(...args) {
        let crypto2;
        let algorithm = "SHA-1";
        if (args[0]) {
          if (!args[0].subtle) {
            algorithm = args[0] || algorithm;
            crypto2 = args[1];
          } else {
            crypto2 = args[0];
          }
        }
        crypto2 !== null && crypto2 !== void 0 ? crypto2 : crypto2 = cryptoProvider.get();
        return await crypto2.subtle.digest(algorithm, this.rawData);
      }
      findRevoked(certOrSerialNumber) {
        const serialNumber = typeof certOrSerialNumber === "string" ? certOrSerialNumber : certOrSerialNumber.serialNumber;
        for (const entry of this.entries) {
          if (entry.serialNumber === serialNumber) {
            return entry;
          }
        }
        return null;
      }
    };
    var X509CrlGenerator = class {
      static async create(params, crypto2 = cryptoProvider.get()) {
        var _a2;
        const name = params.issuer instanceof Name ? params.issuer : new Name(params.issuer);
        const asnX509Crl = new asn1X509__namespace.CertificateList({
          tbsCertList: new asn1X509__namespace.TBSCertList({
            version: asn1X509__namespace.Version.v2,
            issuer: asn1Schema.AsnConvert.parse(name.toArrayBuffer(), asn1X509__namespace.Name),
            thisUpdate: new asn1X509.Time(params.thisUpdate || /* @__PURE__ */ new Date())
          })
        });
        if (params.nextUpdate) {
          asnX509Crl.tbsCertList.nextUpdate = new asn1X509.Time(params.nextUpdate);
        }
        if (params.extensions && params.extensions.length) {
          asnX509Crl.tbsCertList.crlExtensions = new asn1X509__namespace.Extensions(params.extensions.map((o2) => asn1Schema.AsnConvert.parse(o2.rawData, asn1X509__namespace.Extension)) || []);
        }
        if (params.entries && params.entries.length) {
          asnX509Crl.tbsCertList.revokedCertificates = [];
          for (const entry of params.entries) {
            const userCertificate = PemData.toArrayBuffer(entry.serialNumber);
            const index = asnX509Crl.tbsCertList.revokedCertificates.findIndex((cert) => pvtsutils.isEqual(cert.userCertificate, userCertificate));
            if (index > -1) {
              throw new Error(`Certificate serial number ${entry.serialNumber} already exists in tbsCertList`);
            }
            const revokedCert = new asn1X509.RevokedCertificate({
              userCertificate,
              revocationDate: new asn1X509.Time(entry.revocationDate || /* @__PURE__ */ new Date())
            });
            if ("extensions" in entry && ((_a2 = entry.extensions) === null || _a2 === void 0 ? void 0 : _a2.length)) {
              revokedCert.crlEntryExtensions = entry.extensions.map((o2) => asn1Schema.AsnConvert.parse(o2.rawData, asn1X509__namespace.Extension));
            } else {
              revokedCert.crlEntryExtensions = [];
            }
            if (!(entry instanceof X509CrlEntry)) {
              if (entry.reason) {
                revokedCert.crlEntryExtensions.push(new asn1X509__namespace.Extension({
                  extnID: asn1X509__namespace.id_ce_cRLReasons,
                  critical: false,
                  extnValue: new asn1Schema.OctetString(asn1Schema.AsnConvert.serialize(new asn1X509__namespace.CRLReason(entry.reason)))
                }));
              }
              if (entry.invalidity) {
                revokedCert.crlEntryExtensions.push(new asn1X509__namespace.Extension({
                  extnID: asn1X509__namespace.id_ce_invalidityDate,
                  critical: false,
                  extnValue: new asn1Schema.OctetString(asn1Schema.AsnConvert.serialize(new asn1X509__namespace.InvalidityDate(entry.invalidity)))
                }));
              }
              if (entry.issuer) {
                const name2 = params.issuer instanceof Name ? params.issuer : new Name(params.issuer);
                revokedCert.crlEntryExtensions.push(new asn1X509__namespace.Extension({
                  extnID: asn1X509__namespace.id_ce_certificateIssuer,
                  critical: false,
                  extnValue: new asn1Schema.OctetString(asn1Schema.AsnConvert.serialize(asn1Schema.AsnConvert.parse(name2.toArrayBuffer(), asn1X509__namespace.Name)))
                }));
              }
            }
            asnX509Crl.tbsCertList.revokedCertificates.push(revokedCert);
          }
        }
        const signingAlgorithm = { ...params.signingAlgorithm, ...params.signingKey.algorithm };
        const algProv = tsyringe.container.resolve(diAlgorithmProvider);
        asnX509Crl.tbsCertList.signature = asnX509Crl.signatureAlgorithm = algProv.toAsnAlgorithm(signingAlgorithm);
        const tbs = asn1Schema.AsnConvert.serialize(asnX509Crl.tbsCertList);
        const signature = await crypto2.subtle.sign(signingAlgorithm, params.signingKey, tbs);
        const signatureFormatters = tsyringe.container.resolveAll(diAsnSignatureFormatter).reverse();
        let asnSignature = null;
        for (const signatureFormatter of signatureFormatters) {
          asnSignature = signatureFormatter.toAsnSignature(signingAlgorithm, signature);
          if (asnSignature) {
            break;
          }
        }
        if (!asnSignature) {
          throw Error("Cannot convert ASN.1 signature value to WebCrypto format");
        }
        asnX509Crl.signature = asnSignature;
        return new X509Crl(asn1Schema.AsnConvert.serialize(asnX509Crl));
      }
    };
    ExtensionFactory.register(asn1X509__namespace.id_ce_basicConstraints, BasicConstraintsExtension);
    ExtensionFactory.register(asn1X509__namespace.id_ce_extKeyUsage, ExtendedKeyUsageExtension);
    ExtensionFactory.register(asn1X509__namespace.id_ce_keyUsage, KeyUsagesExtension);
    ExtensionFactory.register(asn1X509__namespace.id_ce_subjectKeyIdentifier, SubjectKeyIdentifierExtension);
    ExtensionFactory.register(asn1X509__namespace.id_ce_authorityKeyIdentifier, AuthorityKeyIdentifierExtension);
    ExtensionFactory.register(asn1X509__namespace.id_ce_subjectAltName, SubjectAlternativeNameExtension);
    AttributeFactory.register(asnPkcs9__namespace.id_pkcs9_at_challengePassword, ChallengePasswordAttribute);
    AttributeFactory.register(asnPkcs9__namespace.id_pkcs9_at_extensionRequest, ExtensionsAttribute);
    tsyringe.container.registerSingleton(diAsnSignatureFormatter, AsnDefaultSignatureFormatter);
    tsyringe.container.registerSingleton(diAsnSignatureFormatter, AsnEcSignatureFormatter);
    AsnEcSignatureFormatter.namedCurveSize.set("P-256", 32);
    AsnEcSignatureFormatter.namedCurveSize.set("K-256", 32);
    AsnEcSignatureFormatter.namedCurveSize.set("P-384", 48);
    AsnEcSignatureFormatter.namedCurveSize.set("P-521", 66);
    exports2.AlgorithmProvider = AlgorithmProvider;
    exports2.AsnData = AsnData;
    exports2.AsnDefaultSignatureFormatter = AsnDefaultSignatureFormatter;
    exports2.AsnEcSignatureFormatter = AsnEcSignatureFormatter;
    exports2.Attribute = Attribute;
    exports2.AttributeFactory = AttributeFactory;
    exports2.AuthorityKeyIdentifierExtension = AuthorityKeyIdentifierExtension;
    exports2.BasicConstraintsExtension = BasicConstraintsExtension;
    exports2.CertificatePolicyExtension = CertificatePolicyExtension;
    exports2.ChallengePasswordAttribute = ChallengePasswordAttribute;
    exports2.CryptoProvider = CryptoProvider;
    exports2.DefaultAlgorithmSerializer = DefaultAlgorithmSerializer;
    exports2.ExtendedKeyUsageExtension = ExtendedKeyUsageExtension;
    exports2.Extension = Extension;
    exports2.ExtensionFactory = ExtensionFactory;
    exports2.ExtensionsAttribute = ExtensionsAttribute;
    exports2.GeneralName = GeneralName;
    exports2.GeneralNames = GeneralNames;
    exports2.KeyUsagesExtension = KeyUsagesExtension;
    exports2.Name = Name;
    exports2.NameIdentifier = NameIdentifier;
    exports2.OidSerializer = OidSerializer;
    exports2.PemConverter = PemConverter;
    exports2.Pkcs10CertificateRequest = Pkcs10CertificateRequest;
    exports2.Pkcs10CertificateRequestGenerator = Pkcs10CertificateRequestGenerator;
    exports2.PublicKey = PublicKey;
    exports2.SubjectAlternativeNameExtension = SubjectAlternativeNameExtension;
    exports2.SubjectKeyIdentifierExtension = SubjectKeyIdentifierExtension;
    exports2.TextConverter = TextConverter;
    exports2.TextObject = TextObject;
    exports2.X509Certificate = X509Certificate;
    exports2.X509CertificateGenerator = X509CertificateGenerator;
    exports2.X509Certificates = X509Certificates;
    exports2.X509ChainBuilder = X509ChainBuilder;
    exports2.X509Crl = X509Crl;
    exports2.X509CrlEntry = X509CrlEntry;
    exports2.X509CrlGenerator = X509CrlGenerator;
    exports2.cryptoProvider = cryptoProvider;
    exports2.diAlgorithm = diAlgorithm;
    exports2.diAlgorithmProvider = diAlgorithmProvider;
    exports2.diAsnSignatureFormatter = diAsnSignatureFormatter;
    exports2.idEd25519 = idEd25519;
    exports2.idEd448 = idEd448;
    exports2.idX25519 = idX25519;
    exports2.idX448 = idX448;
  }
});

// node_modules/@peculiar/json-schema/build/index.js
var require_build5 = __commonJS({
  "node_modules/@peculiar/json-schema/build/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var JsonError = class extends Error {
      constructor(message, innerError) {
        super(innerError ? `${message}. See the inner exception for more details.` : message);
        this.message = message;
        this.innerError = innerError;
      }
    };
    var TransformError = class extends JsonError {
      constructor(schema, message, innerError) {
        super(message, innerError);
        this.schema = schema;
      }
    };
    var ParserError = class extends TransformError {
      constructor(schema, message, innerError) {
        super(schema, `JSON doesn't match to '${schema.target.name}' schema. ${message}`, innerError);
      }
    };
    var ValidationError = class extends JsonError {
    };
    var SerializerError = class extends JsonError {
      constructor(schemaName, message, innerError) {
        super(`Cannot serialize by '${schemaName}' schema. ${message}`, innerError);
        this.schemaName = schemaName;
      }
    };
    var KeyError = class extends ParserError {
      constructor(schema, keys, errors = {}) {
        super(schema, "Some keys doesn't match to schema");
        this.keys = keys;
        this.errors = errors;
      }
    };
    (function(JsonPropTypes) {
      JsonPropTypes[JsonPropTypes["Any"] = 0] = "Any";
      JsonPropTypes[JsonPropTypes["Boolean"] = 1] = "Boolean";
      JsonPropTypes[JsonPropTypes["Number"] = 2] = "Number";
      JsonPropTypes[JsonPropTypes["String"] = 3] = "String";
    })(exports2.JsonPropTypes || (exports2.JsonPropTypes = {}));
    function checkType(value, type) {
      switch (type) {
        case exports2.JsonPropTypes.Boolean:
          return typeof value === "boolean";
        case exports2.JsonPropTypes.Number:
          return typeof value === "number";
        case exports2.JsonPropTypes.String:
          return typeof value === "string";
      }
      return true;
    }
    function throwIfTypeIsWrong(value, type) {
      if (!checkType(value, type)) {
        throw new TypeError(`Value must be ${exports2.JsonPropTypes[type]}`);
      }
    }
    function isConvertible(target) {
      if (target && target.prototype) {
        if (target.prototype.toJSON && target.prototype.fromJSON) {
          return true;
        } else {
          return isConvertible(target.prototype);
        }
      } else {
        return !!(target && target.toJSON && target.fromJSON);
      }
    }
    var JsonSchemaStorage = class {
      constructor() {
        this.items = /* @__PURE__ */ new Map();
      }
      has(target) {
        return this.items.has(target) || !!this.findParentSchema(target);
      }
      get(target) {
        const schema = this.items.get(target) || this.findParentSchema(target);
        if (!schema) {
          throw new Error("Cannot get schema for current target");
        }
        return schema;
      }
      create(target) {
        const schema = { names: {} };
        const parentSchema = this.findParentSchema(target);
        if (parentSchema) {
          Object.assign(schema, parentSchema);
          schema.names = {};
          for (const name in parentSchema.names) {
            schema.names[name] = Object.assign({}, parentSchema.names[name]);
          }
        }
        schema.target = target;
        return schema;
      }
      set(target, schema) {
        this.items.set(target, schema);
        return this;
      }
      findParentSchema(target) {
        const parent = target.__proto__;
        if (parent) {
          const schema = this.items.get(parent);
          return schema || this.findParentSchema(parent);
        }
        return null;
      }
    };
    var DEFAULT_SCHEMA = "default";
    var schemaStorage = new JsonSchemaStorage();
    var PatternValidation = class {
      constructor(pattern) {
        this.pattern = new RegExp(pattern);
      }
      validate(value) {
        const pattern = new RegExp(this.pattern.source, this.pattern.flags);
        if (typeof value !== "string") {
          throw new ValidationError("Incoming value must be string");
        }
        if (!pattern.exec(value)) {
          throw new ValidationError(`Value doesn't match to pattern '${pattern.toString()}'`);
        }
      }
    };
    var InclusiveValidation = class {
      constructor(min = Number.MIN_VALUE, max = Number.MAX_VALUE) {
        this.min = min;
        this.max = max;
      }
      validate(value) {
        throwIfTypeIsWrong(value, exports2.JsonPropTypes.Number);
        if (!(this.min <= value && value <= this.max)) {
          const min = this.min === Number.MIN_VALUE ? "MIN" : this.min;
          const max = this.max === Number.MAX_VALUE ? "MAX" : this.max;
          throw new ValidationError(`Value doesn't match to diapason [${min},${max}]`);
        }
      }
    };
    var ExclusiveValidation = class {
      constructor(min = Number.MIN_VALUE, max = Number.MAX_VALUE) {
        this.min = min;
        this.max = max;
      }
      validate(value) {
        throwIfTypeIsWrong(value, exports2.JsonPropTypes.Number);
        if (!(this.min < value && value < this.max)) {
          const min = this.min === Number.MIN_VALUE ? "MIN" : this.min;
          const max = this.max === Number.MAX_VALUE ? "MAX" : this.max;
          throw new ValidationError(`Value doesn't match to diapason (${min},${max})`);
        }
      }
    };
    var LengthValidation = class {
      constructor(length, minLength, maxLength) {
        this.length = length;
        this.minLength = minLength;
        this.maxLength = maxLength;
      }
      validate(value) {
        if (this.length !== void 0) {
          if (value.length !== this.length) {
            throw new ValidationError(`Value length must be exactly ${this.length}.`);
          }
          return;
        }
        if (this.minLength !== void 0) {
          if (value.length < this.minLength) {
            throw new ValidationError(`Value length must be more than ${this.minLength}.`);
          }
        }
        if (this.maxLength !== void 0) {
          if (value.length > this.maxLength) {
            throw new ValidationError(`Value length must be less than ${this.maxLength}.`);
          }
        }
      }
    };
    var EnumerationValidation = class {
      constructor(enumeration) {
        this.enumeration = enumeration;
      }
      validate(value) {
        throwIfTypeIsWrong(value, exports2.JsonPropTypes.String);
        if (!this.enumeration.includes(value)) {
          throw new ValidationError(`Value must be one of ${this.enumeration.map((v) => `'${v}'`).join(", ")}`);
        }
      }
    };
    var JsonTransform = class {
      static checkValues(data, schemaItem) {
        const values = Array.isArray(data) ? data : [data];
        for (const value of values) {
          for (const validation of schemaItem.validations) {
            if (validation instanceof LengthValidation && schemaItem.repeated) {
              validation.validate(data);
            } else {
              validation.validate(value);
            }
          }
        }
      }
      static checkTypes(value, schemaItem) {
        if (schemaItem.repeated && !Array.isArray(value)) {
          throw new TypeError("Value must be Array");
        }
        if (typeof schemaItem.type === "number") {
          const values = Array.isArray(value) ? value : [value];
          for (const v of values) {
            throwIfTypeIsWrong(v, schemaItem.type);
          }
        }
      }
      static getSchemaByName(schema, name = DEFAULT_SCHEMA) {
        return { ...schema.names[DEFAULT_SCHEMA], ...schema.names[name] };
      }
    };
    var JsonSerializer = class extends JsonTransform {
      static serialize(obj, options, replacer, space) {
        const json3 = this.toJSON(obj, options);
        return JSON.stringify(json3, replacer, space);
      }
      static toJSON(obj, options = {}) {
        let res;
        let targetSchema = options.targetSchema;
        const schemaName = options.schemaName || DEFAULT_SCHEMA;
        if (isConvertible(obj)) {
          return obj.toJSON();
        }
        if (Array.isArray(obj)) {
          res = [];
          for (const item of obj) {
            res.push(this.toJSON(item, options));
          }
        } else if (typeof obj === "object") {
          if (targetSchema && !schemaStorage.has(targetSchema)) {
            throw new JsonError("Cannot get schema for `targetSchema` param");
          }
          targetSchema = targetSchema || obj.constructor;
          if (schemaStorage.has(targetSchema)) {
            const schema = schemaStorage.get(targetSchema);
            res = {};
            const namedSchema = this.getSchemaByName(schema, schemaName);
            for (const key in namedSchema) {
              try {
                const item = namedSchema[key];
                const objItem = obj[key];
                let value;
                if (item.optional && objItem === void 0 || item.defaultValue !== void 0 && objItem === item.defaultValue) {
                  continue;
                }
                if (!item.optional && objItem === void 0) {
                  throw new SerializerError(targetSchema.name, `Property '${key}' is required.`);
                }
                if (typeof item.type === "number") {
                  if (item.converter) {
                    if (item.repeated) {
                      value = objItem.map((el) => item.converter.toJSON(el, obj));
                    } else {
                      value = item.converter.toJSON(objItem, obj);
                    }
                  } else {
                    value = objItem;
                  }
                } else {
                  if (item.repeated) {
                    value = objItem.map((el) => this.toJSON(el, { schemaName }));
                  } else {
                    value = this.toJSON(objItem, { schemaName });
                  }
                }
                this.checkTypes(value, item);
                this.checkValues(value, item);
                res[item.name || key] = value;
              } catch (e) {
                if (e instanceof SerializerError) {
                  throw e;
                } else {
                  throw new SerializerError(schema.target.name, `Property '${key}' is wrong. ${e.message}`, e);
                }
              }
            }
          } else {
            res = {};
            for (const key in obj) {
              res[key] = this.toJSON(obj[key], { schemaName });
            }
          }
        } else {
          res = obj;
        }
        return res;
      }
    };
    var JsonParser = class _JsonParser extends JsonTransform {
      static parse(data, options) {
        const obj = JSON.parse(data);
        return this.fromJSON(obj, options);
      }
      static fromJSON(target, options) {
        const targetSchema = options.targetSchema;
        const schemaName = options.schemaName || DEFAULT_SCHEMA;
        const obj = new targetSchema();
        if (isConvertible(obj)) {
          return obj.fromJSON(target);
        }
        const schema = schemaStorage.get(targetSchema);
        const namedSchema = this.getSchemaByName(schema, schemaName);
        const keyErrors = {};
        if (options.strictProperty && !Array.isArray(target)) {
          _JsonParser.checkStrictProperty(target, namedSchema, schema);
        }
        for (const key in namedSchema) {
          try {
            const item = namedSchema[key];
            const name = item.name || key;
            const value = target[name];
            if (value === void 0 && (item.optional || item.defaultValue !== void 0)) {
              continue;
            }
            if (!item.optional && value === void 0) {
              throw new ParserError(schema, `Property '${name}' is required.`);
            }
            this.checkTypes(value, item);
            this.checkValues(value, item);
            if (typeof item.type === "number") {
              if (item.converter) {
                if (item.repeated) {
                  obj[key] = value.map((el) => item.converter.fromJSON(el, obj));
                } else {
                  obj[key] = item.converter.fromJSON(value, obj);
                }
              } else {
                obj[key] = value;
              }
            } else {
              const newOptions = {
                ...options,
                targetSchema: item.type,
                schemaName
              };
              if (item.repeated) {
                obj[key] = value.map((el) => this.fromJSON(el, newOptions));
              } else {
                obj[key] = this.fromJSON(value, newOptions);
              }
            }
          } catch (e) {
            if (!(e instanceof ParserError)) {
              e = new ParserError(schema, `Property '${key}' is wrong. ${e.message}`, e);
            }
            if (options.strictAllKeys) {
              keyErrors[key] = e;
            } else {
              throw e;
            }
          }
        }
        const keys = Object.keys(keyErrors);
        if (keys.length) {
          throw new KeyError(schema, keys, keyErrors);
        }
        return obj;
      }
      static checkStrictProperty(target, namedSchema, schema) {
        const jsonProps = Object.keys(target);
        const schemaProps = Object.keys(namedSchema);
        const keys = [];
        for (const key of jsonProps) {
          if (schemaProps.indexOf(key) === -1) {
            keys.push(key);
          }
        }
        if (keys.length) {
          throw new KeyError(schema, keys);
        }
      }
    };
    function getValidations(item) {
      const validations = [];
      if (item.pattern) {
        validations.push(new PatternValidation(item.pattern));
      }
      if (item.type === exports2.JsonPropTypes.Number || item.type === exports2.JsonPropTypes.Any) {
        if (item.minInclusive !== void 0 || item.maxInclusive !== void 0) {
          validations.push(new InclusiveValidation(item.minInclusive, item.maxInclusive));
        }
        if (item.minExclusive !== void 0 || item.maxExclusive !== void 0) {
          validations.push(new ExclusiveValidation(item.minExclusive, item.maxExclusive));
        }
        if (item.enumeration !== void 0) {
          validations.push(new EnumerationValidation(item.enumeration));
        }
      }
      if (item.type === exports2.JsonPropTypes.String || item.repeated || item.type === exports2.JsonPropTypes.Any) {
        if (item.length !== void 0 || item.minLength !== void 0 || item.maxLength !== void 0) {
          validations.push(new LengthValidation(item.length, item.minLength, item.maxLength));
        }
      }
      return validations;
    }
    var JsonProp = (options = {}) => (target, propertyKey) => {
      const errorMessage = `Cannot set type for ${propertyKey} property of ${target.constructor.name} schema`;
      let schema;
      if (!schemaStorage.has(target.constructor)) {
        schema = schemaStorage.create(target.constructor);
        schemaStorage.set(target.constructor, schema);
      } else {
        schema = schemaStorage.get(target.constructor);
        if (schema.target !== target.constructor) {
          schema = schemaStorage.create(target.constructor);
          schemaStorage.set(target.constructor, schema);
        }
      }
      const defaultSchema = {
        type: exports2.JsonPropTypes.Any,
        validations: []
      };
      const copyOptions = Object.assign(defaultSchema, options);
      copyOptions.validations = getValidations(copyOptions);
      if (typeof copyOptions.type !== "number") {
        if (!schemaStorage.has(copyOptions.type) && !isConvertible(copyOptions.type)) {
          throw new Error(`${errorMessage}. Assigning type doesn't have schema.`);
        }
      }
      let schemaNames;
      if (Array.isArray(options.schema)) {
        schemaNames = options.schema;
      } else {
        schemaNames = [options.schema || DEFAULT_SCHEMA];
      }
      for (const schemaName of schemaNames) {
        if (!schema.names[schemaName]) {
          schema.names[schemaName] = {};
        }
        const namedSchema = schema.names[schemaName];
        namedSchema[propertyKey] = copyOptions;
      }
    };
    exports2.JsonError = JsonError;
    exports2.JsonParser = JsonParser;
    exports2.JsonProp = JsonProp;
    exports2.JsonSerializer = JsonSerializer;
    exports2.KeyError = KeyError;
    exports2.ParserError = ParserError;
    exports2.SerializerError = SerializerError;
    exports2.TransformError = TransformError;
    exports2.ValidationError = ValidationError;
  }
});

// node_modules/webcrypto-core/build/webcrypto-core.js
var require_webcrypto_core = __commonJS({
  "node_modules/webcrypto-core/build/webcrypto-core.js"(exports2) {
    "use strict";
    var pvtsutils = require_build3();
    var asn1Schema = require_cjs2();
    var tslib = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var jsonSchema = require_build5();
    var asn1 = require_build4();
    function _interopNamespaceDefault(e) {
      var n = /* @__PURE__ */ Object.create(null);
      if (e) {
        Object.keys(e).forEach(function(k) {
          if (k !== "default") {
            var d2 = Object.getOwnPropertyDescriptor(e, k);
            Object.defineProperty(n, k, d2.get ? d2 : {
              enumerable: true,
              get: function() {
                return e[k];
              }
            });
          }
        });
      }
      n.default = e;
      return Object.freeze(n);
    }
    var asn1__namespace = /* @__PURE__ */ _interopNamespaceDefault(asn1);
    var CryptoError = class extends Error {
    };
    var AlgorithmError = class extends CryptoError {
    };
    var UnsupportedOperationError = class extends CryptoError {
      constructor(methodName) {
        super(`Unsupported operation: ${methodName ? `${methodName}` : ""}`);
      }
    };
    var OperationError = class extends CryptoError {
    };
    var RequiredPropertyError = class extends CryptoError {
      constructor(propName) {
        super(`${propName}: Missing required property`);
      }
    };
    var PemConverter = class {
      static toArrayBuffer(pem) {
        const base64 = pem.replace(/-{5}(BEGIN|END) .*-{5}/g, "").replace("\r", "").replace("\n", "");
        return pvtsutils.Convert.FromBase64(base64);
      }
      static toUint8Array(pem) {
        const bytes = this.toArrayBuffer(pem);
        return new Uint8Array(bytes);
      }
      static fromBufferSource(buffer, tag) {
        const base64 = pvtsutils.Convert.ToBase64(buffer);
        let sliced;
        let offset = 0;
        const rows = [];
        while (offset < base64.length) {
          sliced = base64.slice(offset, offset + 64);
          if (sliced.length) {
            rows.push(sliced);
          } else {
            break;
          }
          offset += 64;
        }
        const upperCaseTag = tag.toUpperCase();
        return `-----BEGIN ${upperCaseTag}-----
${rows.join("\n")}
-----END ${upperCaseTag}-----`;
      }
      static isPEM(data) {
        return /-----BEGIN .+-----[A-Za-z0-9+/+=\s\n]+-----END .+-----/i.test(data);
      }
      static getTagName(pem) {
        if (!this.isPEM(pem)) {
          throw new Error("Bad parameter. Incoming data is not right PEM");
        }
        const res = /-----BEGIN (.+)-----/.exec(pem);
        if (!res) {
          throw new Error("Cannot get tag from PEM");
        }
        return res[1];
      }
      static hasTagName(pem, tagName) {
        const tag = this.getTagName(pem);
        return tagName.toLowerCase() === tag.toLowerCase();
      }
      static isCertificate(pem) {
        return this.hasTagName(pem, "certificate");
      }
      static isCertificateRequest(pem) {
        return this.hasTagName(pem, "certificate request");
      }
      static isCRL(pem) {
        return this.hasTagName(pem, "x509 crl");
      }
      static isPublicKey(pem) {
        return this.hasTagName(pem, "public key");
      }
    };
    function isJWK(data) {
      return typeof data === "object" && "kty" in data;
    }
    var ProviderCrypto = class {
      async digest(...args) {
        this.checkDigest.apply(this, args);
        return this.onDigest.apply(this, args);
      }
      checkDigest(algorithm, _data) {
        this.checkAlgorithmName(algorithm);
      }
      async onDigest(_algorithm, _data) {
        throw new UnsupportedOperationError("digest");
      }
      async generateKey(...args) {
        this.checkGenerateKey.apply(this, args);
        return this.onGenerateKey.apply(this, args);
      }
      checkGenerateKey(algorithm, _extractable, keyUsages, ..._args) {
        this.checkAlgorithmName(algorithm);
        this.checkGenerateKeyParams(algorithm);
        if (!(keyUsages && keyUsages.length)) {
          throw new TypeError(`Usages cannot be empty when creating a key.`);
        }
        let allowedUsages;
        if (Array.isArray(this.usages)) {
          allowedUsages = this.usages;
        } else {
          allowedUsages = this.usages.privateKey.concat(this.usages.publicKey);
        }
        this.checkKeyUsages(keyUsages, allowedUsages);
      }
      checkGenerateKeyParams(_algorithm) {
      }
      async onGenerateKey(_algorithm, _extractable, _keyUsages, ..._args) {
        throw new UnsupportedOperationError("generateKey");
      }
      async sign(...args) {
        this.checkSign.apply(this, args);
        return this.onSign.apply(this, args);
      }
      checkSign(algorithm, key, _data, ..._args) {
        this.checkAlgorithmName(algorithm);
        this.checkAlgorithmParams(algorithm);
        this.checkCryptoKey(key, "sign");
      }
      async onSign(_algorithm, _key, _data, ..._args) {
        throw new UnsupportedOperationError("sign");
      }
      async verify(...args) {
        this.checkVerify.apply(this, args);
        return this.onVerify.apply(this, args);
      }
      checkVerify(algorithm, key, _signature, _data, ..._args) {
        this.checkAlgorithmName(algorithm);
        this.checkAlgorithmParams(algorithm);
        this.checkCryptoKey(key, "verify");
      }
      async onVerify(_algorithm, _key, _signature, _data, ..._args) {
        throw new UnsupportedOperationError("verify");
      }
      async encrypt(...args) {
        this.checkEncrypt.apply(this, args);
        return this.onEncrypt.apply(this, args);
      }
      checkEncrypt(algorithm, key, _data, options = {}, ..._args) {
        this.checkAlgorithmName(algorithm);
        this.checkAlgorithmParams(algorithm);
        this.checkCryptoKey(key, options.keyUsage ? "encrypt" : void 0);
      }
      async onEncrypt(_algorithm, _key, _data, ..._args) {
        throw new UnsupportedOperationError("encrypt");
      }
      async decrypt(...args) {
        this.checkDecrypt.apply(this, args);
        return this.onDecrypt.apply(this, args);
      }
      checkDecrypt(algorithm, key, _data, options = {}, ..._args) {
        this.checkAlgorithmName(algorithm);
        this.checkAlgorithmParams(algorithm);
        this.checkCryptoKey(key, options.keyUsage ? "decrypt" : void 0);
      }
      async onDecrypt(_algorithm, _key, _data, ..._args) {
        throw new UnsupportedOperationError("decrypt");
      }
      async deriveBits(...args) {
        this.checkDeriveBits.apply(this, args);
        return this.onDeriveBits.apply(this, args);
      }
      checkDeriveBits(algorithm, baseKey, length, options = {}, ..._args) {
        this.checkAlgorithmName(algorithm);
        this.checkAlgorithmParams(algorithm);
        this.checkCryptoKey(baseKey, options.keyUsage ? "deriveBits" : void 0);
        if (length % 8 !== 0) {
          throw new OperationError("length: Is not multiple of 8");
        }
      }
      async onDeriveBits(_algorithm, _baseKey, _length, ..._args) {
        throw new UnsupportedOperationError("deriveBits");
      }
      async exportKey(...args) {
        this.checkExportKey.apply(this, args);
        return this.onExportKey.apply(this, args);
      }
      checkExportKey(format3, key, ..._args) {
        this.checkKeyFormat(format3);
        this.checkCryptoKey(key);
        if (!key.extractable) {
          throw new CryptoError("key: Is not extractable");
        }
      }
      async onExportKey(_format, _key, ..._args) {
        throw new UnsupportedOperationError("exportKey");
      }
      async importKey(...args) {
        this.checkImportKey.apply(this, args);
        return this.onImportKey.apply(this, args);
      }
      checkImportKey(format3, keyData, algorithm, _extractable, keyUsages, ..._args) {
        this.checkKeyFormat(format3);
        this.checkKeyData(format3, keyData);
        this.checkAlgorithmName(algorithm);
        this.checkImportParams(algorithm);
        if (Array.isArray(this.usages)) {
          this.checkKeyUsages(keyUsages, this.usages);
        }
      }
      async onImportKey(_format, _keyData, _algorithm, _extractable, _keyUsages, ..._args) {
        throw new UnsupportedOperationError("importKey");
      }
      checkAlgorithmName(algorithm) {
        if (algorithm.name.toLowerCase() !== this.name.toLowerCase()) {
          throw new AlgorithmError("Unrecognized name");
        }
      }
      checkAlgorithmParams(_algorithm) {
      }
      checkDerivedKeyParams(_algorithm) {
      }
      checkKeyUsages(usages, allowed) {
        for (const usage of usages) {
          if (allowed.indexOf(usage) === -1) {
            throw new TypeError("Cannot create a key using the specified key usages");
          }
        }
      }
      checkCryptoKey(key, keyUsage) {
        this.checkAlgorithmName(key.algorithm);
        if (keyUsage && key.usages.indexOf(keyUsage) === -1) {
          throw new CryptoError(`key does not match that of operation`);
        }
      }
      checkRequiredProperty(data, propName) {
        if (!(propName in data)) {
          throw new RequiredPropertyError(propName);
        }
      }
      checkHashAlgorithm(algorithm, hashAlgorithms) {
        for (const item of hashAlgorithms) {
          if (item.toLowerCase() === algorithm.name.toLowerCase()) {
            return;
          }
        }
        throw new OperationError(`hash: Must be one of ${hashAlgorithms.join(", ")}`);
      }
      checkImportParams(_algorithm) {
      }
      checkKeyFormat(format3) {
        switch (format3) {
          case "raw":
          case "pkcs8":
          case "spki":
          case "jwk":
            break;
          default:
            throw new TypeError("format: Is invalid value. Must be 'jwk', 'raw', 'spki', or 'pkcs8'");
        }
      }
      checkKeyData(format3, keyData) {
        if (!keyData) {
          throw new TypeError("keyData: Cannot be empty on empty on key importing");
        }
        if (format3 === "jwk") {
          if (!isJWK(keyData)) {
            throw new TypeError("keyData: Is not JsonWebToken");
          }
        } else if (!pvtsutils.BufferSourceConverter.isBufferSource(keyData)) {
          throw new TypeError("keyData: Is not ArrayBufferView or ArrayBuffer");
        }
      }
      prepareData(data) {
        return pvtsutils.BufferSourceConverter.toArrayBuffer(data);
      }
    };
    var AesProvider = class extends ProviderCrypto {
      checkGenerateKeyParams(algorithm) {
        this.checkRequiredProperty(algorithm, "length");
        if (typeof algorithm.length !== "number") {
          throw new TypeError("length: Is not of type Number");
        }
        switch (algorithm.length) {
          case 128:
          case 192:
          case 256:
            break;
          default:
            throw new TypeError("length: Must be 128, 192, or 256");
        }
      }
      checkDerivedKeyParams(algorithm) {
        this.checkGenerateKeyParams(algorithm);
      }
    };
    var AesCbcProvider = class extends AesProvider {
      constructor() {
        super(...arguments);
        this.name = "AES-CBC";
        this.usages = ["encrypt", "decrypt", "wrapKey", "unwrapKey"];
      }
      checkAlgorithmParams(algorithm) {
        this.checkRequiredProperty(algorithm, "iv");
        if (!(algorithm.iv instanceof ArrayBuffer || ArrayBuffer.isView(algorithm.iv))) {
          throw new TypeError("iv: Is not of type '(ArrayBuffer or ArrayBufferView)'");
        }
        if (algorithm.iv.byteLength !== 16) {
          throw new TypeError("iv: Must have length 16 bytes");
        }
      }
    };
    var AesCmacProvider = class extends AesProvider {
      constructor() {
        super(...arguments);
        this.name = "AES-CMAC";
        this.usages = ["sign", "verify"];
      }
      checkAlgorithmParams(algorithm) {
        this.checkRequiredProperty(algorithm, "length");
        if (typeof algorithm.length !== "number") {
          throw new TypeError("length: Is not a Number");
        }
        if (algorithm.length < 1) {
          throw new OperationError("length: Must be more than 0");
        }
      }
    };
    var AesCtrProvider = class extends AesProvider {
      constructor() {
        super(...arguments);
        this.name = "AES-CTR";
        this.usages = ["encrypt", "decrypt", "wrapKey", "unwrapKey"];
      }
      checkAlgorithmParams(algorithm) {
        this.checkRequiredProperty(algorithm, "counter");
        if (!(algorithm.counter instanceof ArrayBuffer || ArrayBuffer.isView(algorithm.counter))) {
          throw new TypeError("counter: Is not of type '(ArrayBuffer or ArrayBufferView)'");
        }
        if (algorithm.counter.byteLength !== 16) {
          throw new TypeError("iv: Must have length 16 bytes");
        }
        this.checkRequiredProperty(algorithm, "length");
        if (typeof algorithm.length !== "number") {
          throw new TypeError("length: Is not a Number");
        }
        if (algorithm.length < 1) {
          throw new OperationError("length: Must be more than 0");
        }
      }
    };
    var AesEcbProvider = class extends AesProvider {
      constructor() {
        super(...arguments);
        this.name = "AES-ECB";
        this.usages = ["encrypt", "decrypt", "wrapKey", "unwrapKey"];
      }
    };
    var AesGcmProvider = class extends AesProvider {
      constructor() {
        super(...arguments);
        this.name = "AES-GCM";
        this.usages = ["encrypt", "decrypt", "wrapKey", "unwrapKey"];
      }
      checkAlgorithmParams(algorithm) {
        this.checkRequiredProperty(algorithm, "iv");
        if (!(algorithm.iv instanceof ArrayBuffer || ArrayBuffer.isView(algorithm.iv))) {
          throw new TypeError("iv: Is not of type '(ArrayBuffer or ArrayBufferView)'");
        }
        if (algorithm.iv.byteLength < 1) {
          throw new OperationError("iv: Must have length more than 0 and less than 2^64 - 1");
        }
        if (!("tagLength" in algorithm)) {
          algorithm.tagLength = 128;
        }
        switch (algorithm.tagLength) {
          case 32:
          case 64:
          case 96:
          case 104:
          case 112:
          case 120:
          case 128:
            break;
          default:
            throw new OperationError("tagLength: Must be one of 32, 64, 96, 104, 112, 120 or 128");
        }
      }
    };
    var AesKwProvider = class extends AesProvider {
      constructor() {
        super(...arguments);
        this.name = "AES-KW";
        this.usages = ["wrapKey", "unwrapKey"];
      }
    };
    var DesProvider = class extends ProviderCrypto {
      constructor() {
        super(...arguments);
        this.usages = ["encrypt", "decrypt", "wrapKey", "unwrapKey"];
      }
      checkAlgorithmParams(algorithm) {
        if (this.ivSize) {
          this.checkRequiredProperty(algorithm, "iv");
          if (!(algorithm.iv instanceof ArrayBuffer || ArrayBuffer.isView(algorithm.iv))) {
            throw new TypeError("iv: Is not of type '(ArrayBuffer or ArrayBufferView)'");
          }
          if (algorithm.iv.byteLength !== this.ivSize) {
            throw new TypeError(`iv: Must have length ${this.ivSize} bytes`);
          }
        }
      }
      checkGenerateKeyParams(algorithm) {
        this.checkRequiredProperty(algorithm, "length");
        if (typeof algorithm.length !== "number") {
          throw new TypeError("length: Is not of type Number");
        }
        if (algorithm.length !== this.keySizeBits) {
          throw new OperationError(`algorithm.length: Must be ${this.keySizeBits}`);
        }
      }
      checkDerivedKeyParams(algorithm) {
        this.checkGenerateKeyParams(algorithm);
      }
    };
    var RsaProvider = class extends ProviderCrypto {
      constructor() {
        super(...arguments);
        this.hashAlgorithms = ["SHA-1", "SHA-256", "SHA-384", "SHA-512"];
      }
      checkGenerateKeyParams(algorithm) {
        this.checkRequiredProperty(algorithm, "hash");
        this.checkHashAlgorithm(algorithm.hash, this.hashAlgorithms);
        this.checkRequiredProperty(algorithm, "publicExponent");
        if (!(algorithm.publicExponent && algorithm.publicExponent instanceof Uint8Array)) {
          throw new TypeError("publicExponent: Missing or not a Uint8Array");
        }
        const publicExponent = pvtsutils.Convert.ToBase64(algorithm.publicExponent);
        if (!(publicExponent === "Aw==" || publicExponent === "AQAB")) {
          throw new TypeError("publicExponent: Must be [3] or [1,0,1]");
        }
        this.checkRequiredProperty(algorithm, "modulusLength");
        if (algorithm.modulusLength % 8 || algorithm.modulusLength < 256 || algorithm.modulusLength > 16384) {
          throw new TypeError("The modulus length must be a multiple of 8 bits and >= 256 and <= 16384");
        }
      }
      checkImportParams(algorithm) {
        this.checkRequiredProperty(algorithm, "hash");
        this.checkHashAlgorithm(algorithm.hash, this.hashAlgorithms);
      }
    };
    var RsaSsaProvider = class extends RsaProvider {
      constructor() {
        super(...arguments);
        this.name = "RSASSA-PKCS1-v1_5";
        this.usages = {
          privateKey: ["sign"],
          publicKey: ["verify"]
        };
      }
    };
    var RsaPssProvider = class extends RsaProvider {
      constructor() {
        super(...arguments);
        this.name = "RSA-PSS";
        this.usages = {
          privateKey: ["sign"],
          publicKey: ["verify"]
        };
      }
      checkAlgorithmParams(algorithm) {
        this.checkRequiredProperty(algorithm, "saltLength");
        if (typeof algorithm.saltLength !== "number") {
          throw new TypeError("saltLength: Is not a Number");
        }
        if (algorithm.saltLength < 0) {
          throw new RangeError("saltLength: Must be positive number");
        }
      }
    };
    var RsaOaepProvider = class extends RsaProvider {
      constructor() {
        super(...arguments);
        this.name = "RSA-OAEP";
        this.usages = {
          privateKey: ["decrypt", "unwrapKey"],
          publicKey: ["encrypt", "wrapKey"]
        };
      }
      checkAlgorithmParams(algorithm) {
        if (algorithm.label && !(algorithm.label instanceof ArrayBuffer || ArrayBuffer.isView(algorithm.label))) {
          throw new TypeError("label: Is not of type '(ArrayBuffer or ArrayBufferView)'");
        }
      }
    };
    var EllipticProvider = class extends ProviderCrypto {
      checkGenerateKeyParams(algorithm) {
        this.checkRequiredProperty(algorithm, "namedCurve");
        this.checkNamedCurve(algorithm.namedCurve);
      }
      checkNamedCurve(namedCurve) {
        for (const item of this.namedCurves) {
          if (item.toLowerCase() === namedCurve.toLowerCase()) {
            return;
          }
        }
        throw new OperationError(`namedCurve: Must be one of ${this.namedCurves.join(", ")}`);
      }
    };
    var EcdsaProvider = class extends EllipticProvider {
      constructor() {
        super(...arguments);
        this.name = "ECDSA";
        this.hashAlgorithms = ["SHA-1", "SHA-256", "SHA-384", "SHA-512"];
        this.usages = {
          privateKey: ["sign"],
          publicKey: ["verify"]
        };
        this.namedCurves = ["P-256", "P-384", "P-521", "K-256"];
      }
      checkAlgorithmParams(algorithm) {
        this.checkRequiredProperty(algorithm, "hash");
        this.checkHashAlgorithm(algorithm.hash, this.hashAlgorithms);
      }
    };
    var KEY_TYPES = ["secret", "private", "public"];
    var CryptoKey = class {
      static create(algorithm, type, extractable, usages) {
        const key = new this();
        key.algorithm = algorithm;
        key.type = type;
        key.extractable = extractable;
        key.usages = usages;
        return key;
      }
      static isKeyType(data) {
        return KEY_TYPES.indexOf(data) !== -1;
      }
      get [Symbol.toStringTag]() {
        return "CryptoKey";
      }
    };
    var EcdhProvider = class extends EllipticProvider {
      constructor() {
        super(...arguments);
        this.name = "ECDH";
        this.usages = {
          privateKey: ["deriveBits", "deriveKey"],
          publicKey: []
        };
        this.namedCurves = ["P-256", "P-384", "P-521", "K-256"];
      }
      checkAlgorithmParams(algorithm) {
        this.checkRequiredProperty(algorithm, "public");
        if (!(algorithm.public instanceof CryptoKey)) {
          throw new TypeError("public: Is not a CryptoKey");
        }
        if (algorithm.public.type !== "public") {
          throw new OperationError("public: Is not a public key");
        }
        if (algorithm.public.algorithm.name !== this.name) {
          throw new OperationError(`public: Is not ${this.name} key`);
        }
      }
    };
    var EcdhEsProvider = class extends EcdhProvider {
      constructor() {
        super(...arguments);
        this.name = "ECDH-ES";
        this.namedCurves = ["X25519", "X448"];
      }
    };
    var EdDsaProvider = class extends EllipticProvider {
      constructor() {
        super(...arguments);
        this.name = "EdDSA";
        this.usages = {
          privateKey: ["sign"],
          publicKey: ["verify"]
        };
        this.namedCurves = ["Ed25519", "Ed448"];
      }
    };
    var ObjectIdentifier = class ObjectIdentifier {
      constructor(value) {
        if (value) {
          this.value = value;
        }
      }
    };
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.ObjectIdentifier })
    ], ObjectIdentifier.prototype, "value", void 0);
    ObjectIdentifier = tslib.__decorate([
      asn1Schema.AsnType({ type: asn1Schema.AsnTypeTypes.Choice })
    ], ObjectIdentifier);
    var AlgorithmIdentifier = class {
      constructor(params) {
        Object.assign(this, params);
      }
    };
    tslib.__decorate([
      asn1Schema.AsnProp({
        type: asn1Schema.AsnPropTypes.ObjectIdentifier
      })
    ], AlgorithmIdentifier.prototype, "algorithm", void 0);
    tslib.__decorate([
      asn1Schema.AsnProp({
        type: asn1Schema.AsnPropTypes.Any,
        optional: true
      })
    ], AlgorithmIdentifier.prototype, "parameters", void 0);
    var PrivateKeyInfo = class {
      constructor() {
        this.version = 0;
        this.privateKeyAlgorithm = new AlgorithmIdentifier();
        this.privateKey = new ArrayBuffer(0);
      }
    };
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.Integer })
    ], PrivateKeyInfo.prototype, "version", void 0);
    tslib.__decorate([
      asn1Schema.AsnProp({ type: AlgorithmIdentifier })
    ], PrivateKeyInfo.prototype, "privateKeyAlgorithm", void 0);
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.OctetString })
    ], PrivateKeyInfo.prototype, "privateKey", void 0);
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.Any, optional: true })
    ], PrivateKeyInfo.prototype, "attributes", void 0);
    var PublicKeyInfo = class {
      constructor() {
        this.publicKeyAlgorithm = new AlgorithmIdentifier();
        this.publicKey = new ArrayBuffer(0);
      }
    };
    tslib.__decorate([
      asn1Schema.AsnProp({ type: AlgorithmIdentifier })
    ], PublicKeyInfo.prototype, "publicKeyAlgorithm", void 0);
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.BitString })
    ], PublicKeyInfo.prototype, "publicKey", void 0);
    var JsonBase64UrlArrayBufferConverter = {
      fromJSON: (value) => pvtsutils.Convert.FromBase64Url(value),
      toJSON: (value) => pvtsutils.Convert.ToBase64Url(new Uint8Array(value))
    };
    var AsnIntegerArrayBufferConverter = {
      fromASN: (value) => {
        const valueHex = value.valueBlock.valueHex;
        return !new Uint8Array(valueHex)[0] ? value.valueBlock.valueHex.slice(1) : value.valueBlock.valueHex;
      },
      toASN: (value) => {
        const valueHex = new Uint8Array(value)[0] > 127 ? pvtsutils.combine(new Uint8Array([0]).buffer, value) : value;
        return new asn1__namespace.Integer({ valueHex });
      }
    };
    var index$3 = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      AsnIntegerArrayBufferConverter,
      JsonBase64UrlArrayBufferConverter
    });
    var RsaPrivateKey = class {
      constructor() {
        this.version = 0;
        this.modulus = new ArrayBuffer(0);
        this.publicExponent = new ArrayBuffer(0);
        this.privateExponent = new ArrayBuffer(0);
        this.prime1 = new ArrayBuffer(0);
        this.prime2 = new ArrayBuffer(0);
        this.exponent1 = new ArrayBuffer(0);
        this.exponent2 = new ArrayBuffer(0);
        this.coefficient = new ArrayBuffer(0);
      }
    };
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.Integer, converter: asn1Schema.AsnIntegerConverter })
    ], RsaPrivateKey.prototype, "version", void 0);
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.Integer, converter: AsnIntegerArrayBufferConverter }),
      jsonSchema.JsonProp({ name: "n", converter: JsonBase64UrlArrayBufferConverter })
    ], RsaPrivateKey.prototype, "modulus", void 0);
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.Integer, converter: AsnIntegerArrayBufferConverter }),
      jsonSchema.JsonProp({ name: "e", converter: JsonBase64UrlArrayBufferConverter })
    ], RsaPrivateKey.prototype, "publicExponent", void 0);
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.Integer, converter: AsnIntegerArrayBufferConverter }),
      jsonSchema.JsonProp({ name: "d", converter: JsonBase64UrlArrayBufferConverter })
    ], RsaPrivateKey.prototype, "privateExponent", void 0);
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.Integer, converter: AsnIntegerArrayBufferConverter }),
      jsonSchema.JsonProp({ name: "p", converter: JsonBase64UrlArrayBufferConverter })
    ], RsaPrivateKey.prototype, "prime1", void 0);
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.Integer, converter: AsnIntegerArrayBufferConverter }),
      jsonSchema.JsonProp({ name: "q", converter: JsonBase64UrlArrayBufferConverter })
    ], RsaPrivateKey.prototype, "prime2", void 0);
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.Integer, converter: AsnIntegerArrayBufferConverter }),
      jsonSchema.JsonProp({ name: "dp", converter: JsonBase64UrlArrayBufferConverter })
    ], RsaPrivateKey.prototype, "exponent1", void 0);
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.Integer, converter: AsnIntegerArrayBufferConverter }),
      jsonSchema.JsonProp({ name: "dq", converter: JsonBase64UrlArrayBufferConverter })
    ], RsaPrivateKey.prototype, "exponent2", void 0);
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.Integer, converter: AsnIntegerArrayBufferConverter }),
      jsonSchema.JsonProp({ name: "qi", converter: JsonBase64UrlArrayBufferConverter })
    ], RsaPrivateKey.prototype, "coefficient", void 0);
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.Any, optional: true })
    ], RsaPrivateKey.prototype, "otherPrimeInfos", void 0);
    var RsaPublicKey = class {
      constructor() {
        this.modulus = new ArrayBuffer(0);
        this.publicExponent = new ArrayBuffer(0);
      }
    };
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.Integer, converter: AsnIntegerArrayBufferConverter }),
      jsonSchema.JsonProp({ name: "n", converter: JsonBase64UrlArrayBufferConverter })
    ], RsaPublicKey.prototype, "modulus", void 0);
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.Integer, converter: AsnIntegerArrayBufferConverter }),
      jsonSchema.JsonProp({ name: "e", converter: JsonBase64UrlArrayBufferConverter })
    ], RsaPublicKey.prototype, "publicExponent", void 0);
    var EcPublicKey = class EcPublicKey {
      constructor(value) {
        this.value = new ArrayBuffer(0);
        if (value) {
          this.value = value;
        }
      }
      toJSON() {
        let bytes = new Uint8Array(this.value);
        if (bytes[0] !== 4) {
          throw new CryptoError("Wrong ECPoint. Current version supports only Uncompressed (0x04) point");
        }
        bytes = new Uint8Array(this.value.slice(1));
        const size = bytes.length / 2;
        const offset = 0;
        const json3 = {
          x: pvtsutils.Convert.ToBase64Url(bytes.buffer.slice(offset, offset + size)),
          y: pvtsutils.Convert.ToBase64Url(bytes.buffer.slice(offset + size, offset + size + size))
        };
        return json3;
      }
      fromJSON(json3) {
        if (!("x" in json3)) {
          throw new Error("x: Missing required property");
        }
        if (!("y" in json3)) {
          throw new Error("y: Missing required property");
        }
        const x2 = pvtsutils.Convert.FromBase64Url(json3.x);
        const y = pvtsutils.Convert.FromBase64Url(json3.y);
        const value = pvtsutils.combine(new Uint8Array([4]).buffer, x2, y);
        this.value = new Uint8Array(value).buffer;
        return this;
      }
    };
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.OctetString })
    ], EcPublicKey.prototype, "value", void 0);
    EcPublicKey = tslib.__decorate([
      asn1Schema.AsnType({ type: asn1Schema.AsnTypeTypes.Choice })
    ], EcPublicKey);
    var EcPrivateKey = class {
      constructor() {
        this.version = 1;
        this.privateKey = new ArrayBuffer(0);
      }
      fromJSON(json3) {
        if (!("d" in json3)) {
          throw new Error("d: Missing required property");
        }
        this.privateKey = pvtsutils.Convert.FromBase64Url(json3.d);
        if ("x" in json3) {
          const publicKey = new EcPublicKey();
          publicKey.fromJSON(json3);
          const asn = asn1Schema.AsnSerializer.toASN(publicKey);
          if ("valueHex" in asn.valueBlock) {
            this.publicKey = asn.valueBlock.valueHex;
          }
        }
        return this;
      }
      toJSON() {
        const jwk = {};
        jwk.d = pvtsutils.Convert.ToBase64Url(this.privateKey);
        if (this.publicKey) {
          Object.assign(jwk, new EcPublicKey(this.publicKey).toJSON());
        }
        return jwk;
      }
    };
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.Integer, converter: asn1Schema.AsnIntegerConverter })
    ], EcPrivateKey.prototype, "version", void 0);
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.OctetString })
    ], EcPrivateKey.prototype, "privateKey", void 0);
    tslib.__decorate([
      asn1Schema.AsnProp({ context: 0, type: asn1Schema.AsnPropTypes.Any, optional: true })
    ], EcPrivateKey.prototype, "parameters", void 0);
    tslib.__decorate([
      asn1Schema.AsnProp({ context: 1, type: asn1Schema.AsnPropTypes.BitString, optional: true })
    ], EcPrivateKey.prototype, "publicKey", void 0);
    var AsnIntegerWithoutPaddingConverter = {
      fromASN: (value) => {
        const bytes = new Uint8Array(value.valueBlock.valueHex);
        return bytes[0] === 0 ? bytes.buffer.slice(1) : bytes.buffer;
      },
      toASN: (value) => {
        const bytes = new Uint8Array(value);
        if (bytes[0] > 127) {
          const newValue = new Uint8Array(bytes.length + 1);
          newValue.set(bytes, 1);
          return new asn1__namespace.Integer({ valueHex: newValue.buffer });
        }
        return new asn1__namespace.Integer({ valueHex: value });
      }
    };
    var index$2 = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      AsnIntegerWithoutPaddingConverter
    });
    var EcUtils = class {
      static decodePoint(data, pointSize) {
        const view = pvtsutils.BufferSourceConverter.toUint8Array(data);
        if (view.length === 0 || view[0] !== 4) {
          throw new Error("Only uncompressed point format supported");
        }
        const n = (view.length - 1) / 2;
        if (n !== Math.ceil(pointSize / 8)) {
          throw new Error("Point does not match field size");
        }
        const xb = view.slice(1, n + 1);
        const yb = view.slice(n + 1, n + 1 + n);
        return { x: xb, y: yb };
      }
      static encodePoint(point, pointSize) {
        const size = Math.ceil(pointSize / 8);
        if (point.x.byteLength !== size || point.y.byteLength !== size) {
          throw new Error("X,Y coordinates don't match point size criteria");
        }
        const x2 = pvtsutils.BufferSourceConverter.toUint8Array(point.x);
        const y = pvtsutils.BufferSourceConverter.toUint8Array(point.y);
        const res = new Uint8Array(size * 2 + 1);
        res[0] = 4;
        res.set(x2, 1);
        res.set(y, size + 1);
        return res;
      }
      static getSize(pointSize) {
        return Math.ceil(pointSize / 8);
      }
      static encodeSignature(signature, pointSize) {
        const size = this.getSize(pointSize);
        const r = pvtsutils.BufferSourceConverter.toUint8Array(signature.r);
        const s = pvtsutils.BufferSourceConverter.toUint8Array(signature.s);
        const res = new Uint8Array(size * 2);
        res.set(this.padStart(r, size));
        res.set(this.padStart(s, size), size);
        return res;
      }
      static decodeSignature(data, pointSize) {
        const size = this.getSize(pointSize);
        const view = pvtsutils.BufferSourceConverter.toUint8Array(data);
        if (view.length !== size * 2) {
          throw new Error("Incorrect size of the signature");
        }
        const r = view.slice(0, size);
        const s = view.slice(size);
        return {
          r: this.trimStart(r),
          s: this.trimStart(s)
        };
      }
      static trimStart(data) {
        let i = 0;
        while (i < data.length - 1 && data[i] === 0) {
          i++;
        }
        if (i === 0) {
          return data;
        }
        return data.slice(i, data.length);
      }
      static padStart(data, size) {
        if (size === data.length) {
          return data;
        }
        const res = new Uint8Array(size);
        res.set(data, size - data.length);
        return res;
      }
    };
    var EcDsaSignature = class _EcDsaSignature {
      constructor() {
        this.r = new ArrayBuffer(0);
        this.s = new ArrayBuffer(0);
      }
      static fromWebCryptoSignature(value) {
        const pointSize = value.byteLength / 2;
        const point = EcUtils.decodeSignature(value, pointSize * 8);
        const ecSignature = new _EcDsaSignature();
        ecSignature.r = pvtsutils.BufferSourceConverter.toArrayBuffer(point.r);
        ecSignature.s = pvtsutils.BufferSourceConverter.toArrayBuffer(point.s);
        return ecSignature;
      }
      toWebCryptoSignature(pointSize) {
        pointSize !== null && pointSize !== void 0 ? pointSize : pointSize = Math.max(this.r.byteLength, this.s.byteLength) * 8;
        const signature = EcUtils.encodeSignature(this, pointSize);
        return signature.buffer;
      }
    };
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.Integer, converter: AsnIntegerWithoutPaddingConverter })
    ], EcDsaSignature.prototype, "r", void 0);
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.Integer, converter: AsnIntegerWithoutPaddingConverter })
    ], EcDsaSignature.prototype, "s", void 0);
    var OneAsymmetricKey = class extends PrivateKeyInfo {
    };
    tslib.__decorate([
      asn1Schema.AsnProp({ context: 1, implicit: true, type: asn1Schema.AsnPropTypes.BitString, optional: true })
    ], OneAsymmetricKey.prototype, "publicKey", void 0);
    var EdPrivateKey = class EdPrivateKey {
      constructor() {
        this.value = new ArrayBuffer(0);
      }
      fromJSON(json3) {
        if (!json3.d) {
          throw new Error("d: Missing required property");
        }
        this.value = pvtsutils.Convert.FromBase64Url(json3.d);
        return this;
      }
      toJSON() {
        const jwk = {
          d: pvtsutils.Convert.ToBase64Url(this.value)
        };
        return jwk;
      }
    };
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.OctetString })
    ], EdPrivateKey.prototype, "value", void 0);
    EdPrivateKey = tslib.__decorate([
      asn1Schema.AsnType({ type: asn1Schema.AsnTypeTypes.Choice })
    ], EdPrivateKey);
    var EdPublicKey = class EdPublicKey {
      constructor(value) {
        this.value = new ArrayBuffer(0);
        if (value) {
          this.value = value;
        }
      }
      toJSON() {
        const json3 = {
          x: pvtsutils.Convert.ToBase64Url(this.value)
        };
        return json3;
      }
      fromJSON(json3) {
        if (!("x" in json3)) {
          throw new Error("x: Missing required property");
        }
        this.value = pvtsutils.Convert.FromBase64Url(json3.x);
        return this;
      }
    };
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.BitString })
    ], EdPublicKey.prototype, "value", void 0);
    EdPublicKey = tslib.__decorate([
      asn1Schema.AsnType({ type: asn1Schema.AsnTypeTypes.Choice })
    ], EdPublicKey);
    var CurvePrivateKey = class CurvePrivateKey {
    };
    tslib.__decorate([
      asn1Schema.AsnProp({ type: asn1Schema.AsnPropTypes.OctetString }),
      jsonSchema.JsonProp({ type: jsonSchema.JsonPropTypes.String, converter: JsonBase64UrlArrayBufferConverter })
    ], CurvePrivateKey.prototype, "d", void 0);
    CurvePrivateKey = tslib.__decorate([
      asn1Schema.AsnType({ type: asn1Schema.AsnTypeTypes.Choice })
    ], CurvePrivateKey);
    var idSecp256r1 = "1.2.840.10045.3.1.7";
    var idEllipticCurve = "1.3.132.0";
    var idSecp384r1 = `${idEllipticCurve}.34`;
    var idSecp521r1 = `${idEllipticCurve}.35`;
    var idSecp256k1 = `${idEllipticCurve}.10`;
    var idVersionOne = "1.3.36.3.3.2.8.1.1";
    var idBrainpoolP160r1 = `${idVersionOne}.1`;
    var idBrainpoolP160t1 = `${idVersionOne}.2`;
    var idBrainpoolP192r1 = `${idVersionOne}.3`;
    var idBrainpoolP192t1 = `${idVersionOne}.4`;
    var idBrainpoolP224r1 = `${idVersionOne}.5`;
    var idBrainpoolP224t1 = `${idVersionOne}.6`;
    var idBrainpoolP256r1 = `${idVersionOne}.7`;
    var idBrainpoolP256t1 = `${idVersionOne}.8`;
    var idBrainpoolP320r1 = `${idVersionOne}.9`;
    var idBrainpoolP320t1 = `${idVersionOne}.10`;
    var idBrainpoolP384r1 = `${idVersionOne}.11`;
    var idBrainpoolP384t1 = `${idVersionOne}.12`;
    var idBrainpoolP512r1 = `${idVersionOne}.13`;
    var idBrainpoolP512t1 = `${idVersionOne}.14`;
    var idX25519 = "1.3.101.110";
    var idX448 = "1.3.101.111";
    var idEd25519 = "1.3.101.112";
    var idEd448 = "1.3.101.113";
    var index$1 = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      AlgorithmIdentifier,
      get CurvePrivateKey() {
        return CurvePrivateKey;
      },
      EcDsaSignature,
      EcPrivateKey,
      get EcPublicKey() {
        return EcPublicKey;
      },
      get EdPrivateKey() {
        return EdPrivateKey;
      },
      get EdPublicKey() {
        return EdPublicKey;
      },
      get ObjectIdentifier() {
        return ObjectIdentifier;
      },
      OneAsymmetricKey,
      PrivateKeyInfo,
      PublicKeyInfo,
      RsaPrivateKey,
      RsaPublicKey,
      converters: index$2,
      idBrainpoolP160r1,
      idBrainpoolP160t1,
      idBrainpoolP192r1,
      idBrainpoolP192t1,
      idBrainpoolP224r1,
      idBrainpoolP224t1,
      idBrainpoolP256r1,
      idBrainpoolP256t1,
      idBrainpoolP320r1,
      idBrainpoolP320t1,
      idBrainpoolP384r1,
      idBrainpoolP384t1,
      idBrainpoolP512r1,
      idBrainpoolP512t1,
      idEd25519,
      idEd448,
      idEllipticCurve,
      idSecp256k1,
      idSecp256r1,
      idSecp384r1,
      idSecp521r1,
      idVersionOne,
      idX25519,
      idX448
    });
    var EcCurves = class {
      constructor() {
      }
      static register(item) {
        const oid = new ObjectIdentifier();
        oid.value = item.id;
        const raw2 = asn1Schema.AsnConvert.serialize(oid);
        this.items.push({
          ...item,
          raw: raw2
        });
        this.names.push(item.name);
      }
      static find(nameOrId) {
        nameOrId = nameOrId.toUpperCase();
        for (const item of this.items) {
          if (item.name.toUpperCase() === nameOrId || item.id.toUpperCase() === nameOrId) {
            return item;
          }
        }
        return null;
      }
      static get(nameOrId) {
        const res = this.find(nameOrId);
        if (!res) {
          throw new Error(`Unsupported EC named curve '${nameOrId}'`);
        }
        return res;
      }
    };
    EcCurves.items = [];
    EcCurves.names = [];
    EcCurves.register({ name: "P-256", id: idSecp256r1, size: 256 });
    EcCurves.register({ name: "P-384", id: idSecp384r1, size: 384 });
    EcCurves.register({ name: "P-521", id: idSecp521r1, size: 521 });
    EcCurves.register({ name: "K-256", id: idSecp256k1, size: 256 });
    EcCurves.register({ name: "brainpoolP160r1", id: idBrainpoolP160r1, size: 160 });
    EcCurves.register({ name: "brainpoolP160t1", id: idBrainpoolP160t1, size: 160 });
    EcCurves.register({ name: "brainpoolP192r1", id: idBrainpoolP192r1, size: 192 });
    EcCurves.register({ name: "brainpoolP192t1", id: idBrainpoolP192t1, size: 192 });
    EcCurves.register({ name: "brainpoolP224r1", id: idBrainpoolP224r1, size: 224 });
    EcCurves.register({ name: "brainpoolP224t1", id: idBrainpoolP224t1, size: 224 });
    EcCurves.register({ name: "brainpoolP256r1", id: idBrainpoolP256r1, size: 256 });
    EcCurves.register({ name: "brainpoolP256t1", id: idBrainpoolP256t1, size: 256 });
    EcCurves.register({ name: "brainpoolP320r1", id: idBrainpoolP320r1, size: 320 });
    EcCurves.register({ name: "brainpoolP320t1", id: idBrainpoolP320t1, size: 320 });
    EcCurves.register({ name: "brainpoolP384r1", id: idBrainpoolP384r1, size: 384 });
    EcCurves.register({ name: "brainpoolP384t1", id: idBrainpoolP384t1, size: 384 });
    EcCurves.register({ name: "brainpoolP512r1", id: idBrainpoolP512r1, size: 512 });
    EcCurves.register({ name: "brainpoolP512t1", id: idBrainpoolP512t1, size: 512 });
    var HmacProvider = class extends ProviderCrypto {
      constructor() {
        super(...arguments);
        this.name = "HMAC";
        this.hashAlgorithms = ["SHA-1", "SHA-256", "SHA-384", "SHA-512"];
        this.usages = ["sign", "verify"];
      }
      getDefaultLength(algName) {
        switch (algName.toUpperCase()) {
          case "SHA-1":
          case "SHA-256":
          case "SHA-384":
          case "SHA-512":
            return 512;
          default:
            throw new Error(`Unknown algorithm name '${algName}'`);
        }
      }
      checkGenerateKeyParams(algorithm) {
        this.checkRequiredProperty(algorithm, "hash");
        this.checkHashAlgorithm(algorithm.hash, this.hashAlgorithms);
        if ("length" in algorithm) {
          if (typeof algorithm.length !== "number") {
            throw new TypeError("length: Is not a Number");
          }
          if (algorithm.length < 1) {
            throw new RangeError("length: Number is out of range");
          }
        }
      }
      checkImportParams(algorithm) {
        this.checkRequiredProperty(algorithm, "hash");
        this.checkHashAlgorithm(algorithm.hash, this.hashAlgorithms);
      }
    };
    var Pbkdf2Provider = class extends ProviderCrypto {
      constructor() {
        super(...arguments);
        this.name = "PBKDF2";
        this.hashAlgorithms = ["SHA-1", "SHA-256", "SHA-384", "SHA-512"];
        this.usages = ["deriveBits", "deriveKey"];
      }
      checkAlgorithmParams(algorithm) {
        this.checkRequiredProperty(algorithm, "hash");
        this.checkHashAlgorithm(algorithm.hash, this.hashAlgorithms);
        this.checkRequiredProperty(algorithm, "salt");
        if (!(algorithm.salt instanceof ArrayBuffer || ArrayBuffer.isView(algorithm.salt))) {
          throw new TypeError("salt: Is not of type '(ArrayBuffer or ArrayBufferView)'");
        }
        this.checkRequiredProperty(algorithm, "iterations");
        if (typeof algorithm.iterations !== "number") {
          throw new TypeError("iterations: Is not a Number");
        }
        if (algorithm.iterations < 1) {
          throw new TypeError("iterations: Is less than 1");
        }
      }
      checkImportKey(format3, keyData, algorithm, extractable, keyUsages, ...args) {
        super.checkImportKey(format3, keyData, algorithm, extractable, keyUsages, ...args);
        if (extractable) {
          throw new SyntaxError("extractable: Must be 'false'");
        }
      }
    };
    var HkdfProvider = class extends ProviderCrypto {
      constructor() {
        super(...arguments);
        this.name = "HKDF";
        this.hashAlgorithms = ["SHA-1", "SHA-256", "SHA-384", "SHA-512"];
        this.usages = ["deriveKey", "deriveBits"];
      }
      checkAlgorithmParams(algorithm) {
        this.checkRequiredProperty(algorithm, "hash");
        this.checkHashAlgorithm(algorithm.hash, this.hashAlgorithms);
        this.checkRequiredProperty(algorithm, "salt");
        if (!pvtsutils.BufferSourceConverter.isBufferSource(algorithm.salt)) {
          throw new TypeError("salt: Is not of type '(ArrayBuffer or ArrayBufferView)'");
        }
        this.checkRequiredProperty(algorithm, "info");
        if (!pvtsutils.BufferSourceConverter.isBufferSource(algorithm.info)) {
          throw new TypeError("salt: Is not of type '(ArrayBuffer or ArrayBufferView)'");
        }
      }
      checkImportKey(format3, keyData, algorithm, extractable, keyUsages, ...args) {
        super.checkImportKey(format3, keyData, algorithm, extractable, keyUsages, ...args);
        if (extractable) {
          throw new SyntaxError("extractable: Must be 'false'");
        }
      }
    };
    var ShakeProvider = class extends ProviderCrypto {
      constructor() {
        super(...arguments);
        this.usages = [];
        this.defaultLength = 0;
      }
      digest(...args) {
        args[0] = { length: this.defaultLength, ...args[0] };
        return super.digest.apply(this, args);
      }
      checkDigest(algorithm, data) {
        super.checkDigest(algorithm, data);
        const length = algorithm.length || 0;
        if (typeof length !== "number") {
          throw new TypeError("length: Is not a Number");
        }
        if (length < 0) {
          throw new TypeError("length: Is negative");
        }
      }
    };
    var Shake128Provider = class extends ShakeProvider {
      constructor() {
        super(...arguments);
        this.name = "shake128";
        this.defaultLength = 16;
      }
    };
    var Shake256Provider = class extends ShakeProvider {
      constructor() {
        super(...arguments);
        this.name = "shake256";
        this.defaultLength = 32;
      }
    };
    var Crypto = class {
      get [Symbol.toStringTag]() {
        return "Crypto";
      }
      randomUUID() {
        const b = this.getRandomValues(new Uint8Array(16));
        b[6] = b[6] & 15 | 64;
        b[8] = b[8] & 63 | 128;
        const uuid = pvtsutils.Convert.ToHex(b).toLowerCase();
        return `${uuid.substring(0, 8)}-${uuid.substring(8, 12)}-${uuid.substring(12, 16)}-${uuid.substring(16, 20)}-${uuid.substring(20)}`;
      }
    };
    var ProviderStorage = class {
      constructor() {
        this.items = {};
      }
      get(algorithmName) {
        return this.items[algorithmName.toLowerCase()] || null;
      }
      set(provider) {
        this.items[provider.name.toLowerCase()] = provider;
      }
      removeAt(algorithmName) {
        const provider = this.get(algorithmName.toLowerCase());
        if (provider) {
          delete this.items[algorithmName];
        }
        return provider;
      }
      has(name) {
        return !!this.get(name);
      }
      get length() {
        return Object.keys(this.items).length;
      }
      get algorithms() {
        const algorithms = [];
        for (const key in this.items) {
          const provider = this.items[key];
          algorithms.push(provider.name);
        }
        return algorithms.sort();
      }
    };
    var SubtleCrypto = class _SubtleCrypto {
      constructor() {
        this.providers = new ProviderStorage();
      }
      static isHashedAlgorithm(data) {
        return data && typeof data === "object" && "name" in data && "hash" in data ? true : false;
      }
      get [Symbol.toStringTag]() {
        return "SubtleCrypto";
      }
      async digest(...args) {
        this.checkRequiredArguments(args, 2, "digest");
        const [algorithm, data, ...params] = args;
        const preparedAlgorithm = this.prepareAlgorithm(algorithm);
        const preparedData = pvtsutils.BufferSourceConverter.toArrayBuffer(data);
        const provider = this.getProvider(preparedAlgorithm.name);
        const result2 = await provider.digest(preparedAlgorithm, preparedData, ...params);
        return result2;
      }
      async generateKey(...args) {
        this.checkRequiredArguments(args, 3, "generateKey");
        const [algorithm, extractable, keyUsages, ...params] = args;
        const preparedAlgorithm = this.prepareAlgorithm(algorithm);
        const provider = this.getProvider(preparedAlgorithm.name);
        const result2 = await provider.generateKey({ ...preparedAlgorithm, name: provider.name }, extractable, keyUsages, ...params);
        return result2;
      }
      async sign(...args) {
        this.checkRequiredArguments(args, 3, "sign");
        const [algorithm, key, data, ...params] = args;
        this.checkCryptoKey(key);
        const preparedAlgorithm = this.prepareAlgorithm(algorithm);
        const preparedData = pvtsutils.BufferSourceConverter.toArrayBuffer(data);
        const provider = this.getProvider(preparedAlgorithm.name);
        const result2 = await provider.sign({ ...preparedAlgorithm, name: provider.name }, key, preparedData, ...params);
        return result2;
      }
      async verify(...args) {
        this.checkRequiredArguments(args, 4, "verify");
        const [algorithm, key, signature, data, ...params] = args;
        this.checkCryptoKey(key);
        const preparedAlgorithm = this.prepareAlgorithm(algorithm);
        const preparedData = pvtsutils.BufferSourceConverter.toArrayBuffer(data);
        const preparedSignature = pvtsutils.BufferSourceConverter.toArrayBuffer(signature);
        const provider = this.getProvider(preparedAlgorithm.name);
        const result2 = await provider.verify({ ...preparedAlgorithm, name: provider.name }, key, preparedSignature, preparedData, ...params);
        return result2;
      }
      async encrypt(...args) {
        this.checkRequiredArguments(args, 3, "encrypt");
        const [algorithm, key, data, ...params] = args;
        this.checkCryptoKey(key);
        const preparedAlgorithm = this.prepareAlgorithm(algorithm);
        const preparedData = pvtsutils.BufferSourceConverter.toArrayBuffer(data);
        const provider = this.getProvider(preparedAlgorithm.name);
        const result2 = await provider.encrypt({ ...preparedAlgorithm, name: provider.name }, key, preparedData, { keyUsage: true }, ...params);
        return result2;
      }
      async decrypt(...args) {
        this.checkRequiredArguments(args, 3, "decrypt");
        const [algorithm, key, data, ...params] = args;
        this.checkCryptoKey(key);
        const preparedAlgorithm = this.prepareAlgorithm(algorithm);
        const preparedData = pvtsutils.BufferSourceConverter.toArrayBuffer(data);
        const provider = this.getProvider(preparedAlgorithm.name);
        const result2 = await provider.decrypt({ ...preparedAlgorithm, name: provider.name }, key, preparedData, { keyUsage: true }, ...params);
        return result2;
      }
      async deriveBits(...args) {
        this.checkRequiredArguments(args, 3, "deriveBits");
        const [algorithm, baseKey, length, ...params] = args;
        this.checkCryptoKey(baseKey);
        const preparedAlgorithm = this.prepareAlgorithm(algorithm);
        const provider = this.getProvider(preparedAlgorithm.name);
        const result2 = await provider.deriveBits({ ...preparedAlgorithm, name: provider.name }, baseKey, length, { keyUsage: true }, ...params);
        return result2;
      }
      async deriveKey(...args) {
        this.checkRequiredArguments(args, 5, "deriveKey");
        const [algorithm, baseKey, derivedKeyType, extractable, keyUsages, ...params] = args;
        const preparedDerivedKeyType = this.prepareAlgorithm(derivedKeyType);
        const importProvider = this.getProvider(preparedDerivedKeyType.name);
        importProvider.checkDerivedKeyParams(preparedDerivedKeyType);
        const preparedAlgorithm = this.prepareAlgorithm(algorithm);
        const provider = this.getProvider(preparedAlgorithm.name);
        provider.checkCryptoKey(baseKey, "deriveKey");
        const derivedBits = await provider.deriveBits({ ...preparedAlgorithm, name: provider.name }, baseKey, derivedKeyType.length || 512, { keyUsage: false }, ...params);
        return this.importKey("raw", derivedBits, derivedKeyType, extractable, keyUsages, ...params);
      }
      async exportKey(...args) {
        this.checkRequiredArguments(args, 2, "exportKey");
        const [format3, key, ...params] = args;
        this.checkCryptoKey(key);
        const provider = this.getProvider(key.algorithm.name);
        const result2 = await provider.exportKey(format3, key, ...params);
        return result2;
      }
      async importKey(...args) {
        this.checkRequiredArguments(args, 5, "importKey");
        const [format3, keyData, algorithm, extractable, keyUsages, ...params] = args;
        const preparedAlgorithm = this.prepareAlgorithm(algorithm);
        const provider = this.getProvider(preparedAlgorithm.name);
        if (["pkcs8", "spki", "raw"].indexOf(format3) !== -1) {
          const preparedData = pvtsutils.BufferSourceConverter.toArrayBuffer(keyData);
          return provider.importKey(format3, preparedData, { ...preparedAlgorithm, name: provider.name }, extractable, keyUsages, ...params);
        } else {
          if (!keyData.kty) {
            throw new TypeError("keyData: Is not JSON");
          }
        }
        return provider.importKey(format3, keyData, { ...preparedAlgorithm, name: provider.name }, extractable, keyUsages, ...params);
      }
      async wrapKey(format3, key, wrappingKey, wrapAlgorithm, ...args) {
        let keyData = await this.exportKey(format3, key, ...args);
        if (format3 === "jwk") {
          const json3 = JSON.stringify(keyData);
          keyData = pvtsutils.Convert.FromUtf8String(json3);
        }
        const preparedAlgorithm = this.prepareAlgorithm(wrapAlgorithm);
        const preparedData = pvtsutils.BufferSourceConverter.toArrayBuffer(keyData);
        const provider = this.getProvider(preparedAlgorithm.name);
        return provider.encrypt({ ...preparedAlgorithm, name: provider.name }, wrappingKey, preparedData, { keyUsage: false }, ...args);
      }
      async unwrapKey(format3, wrappedKey, unwrappingKey, unwrapAlgorithm, unwrappedKeyAlgorithm, extractable, keyUsages, ...args) {
        const preparedAlgorithm = this.prepareAlgorithm(unwrapAlgorithm);
        const preparedData = pvtsutils.BufferSourceConverter.toArrayBuffer(wrappedKey);
        const provider = this.getProvider(preparedAlgorithm.name);
        let keyData = await provider.decrypt({ ...preparedAlgorithm, name: provider.name }, unwrappingKey, preparedData, { keyUsage: false }, ...args);
        if (format3 === "jwk") {
          try {
            keyData = JSON.parse(pvtsutils.Convert.ToUtf8String(keyData));
          } catch (e) {
            const error = new TypeError("wrappedKey: Is not a JSON");
            error.internal = e;
            throw error;
          }
        }
        return this.importKey(format3, keyData, unwrappedKeyAlgorithm, extractable, keyUsages, ...args);
      }
      checkRequiredArguments(args, size, methodName) {
        if (args.length < size) {
          throw new TypeError(`Failed to execute '${methodName}' on 'SubtleCrypto': ${size} arguments required, but only ${args.length} present`);
        }
      }
      prepareAlgorithm(algorithm) {
        if (typeof algorithm === "string") {
          return {
            name: algorithm
          };
        }
        if (_SubtleCrypto.isHashedAlgorithm(algorithm)) {
          const preparedAlgorithm = { ...algorithm };
          preparedAlgorithm.hash = this.prepareAlgorithm(algorithm.hash);
          return preparedAlgorithm;
        }
        return { ...algorithm };
      }
      getProvider(name) {
        const provider = this.providers.get(name);
        if (!provider) {
          throw new AlgorithmError("Unrecognized name");
        }
        return provider;
      }
      checkCryptoKey(key) {
        if (!(key instanceof CryptoKey)) {
          throw new TypeError(`Key is not of type 'CryptoKey'`);
        }
      }
    };
    var index = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      converters: index$3
    });
    var REQUIRED_FIELDS = ["crv", "e", "k", "kty", "n", "x", "y"];
    var JwkUtils = class {
      static async thumbprint(hash, jwk, crypto2) {
        const data = this.format(jwk, true);
        return crypto2.subtle.digest(hash, pvtsutils.Convert.FromBinary(JSON.stringify(data)));
      }
      static format(jwk, remove = false) {
        let res = Object.entries(jwk);
        if (remove) {
          res = res.filter((o2) => REQUIRED_FIELDS.includes(o2[0]));
        }
        res = res.sort(([keyA], [keyB]) => keyA > keyB ? 1 : keyA < keyB ? -1 : 0);
        return Object.fromEntries(res);
      }
    };
    Object.defineProperty(exports2, "BufferSourceConverter", {
      enumerable: true,
      get: function() {
        return pvtsutils.BufferSourceConverter;
      }
    });
    exports2.AesCbcProvider = AesCbcProvider;
    exports2.AesCmacProvider = AesCmacProvider;
    exports2.AesCtrProvider = AesCtrProvider;
    exports2.AesEcbProvider = AesEcbProvider;
    exports2.AesGcmProvider = AesGcmProvider;
    exports2.AesKwProvider = AesKwProvider;
    exports2.AesProvider = AesProvider;
    exports2.AlgorithmError = AlgorithmError;
    exports2.Crypto = Crypto;
    exports2.CryptoError = CryptoError;
    exports2.CryptoKey = CryptoKey;
    exports2.DesProvider = DesProvider;
    exports2.EcCurves = EcCurves;
    exports2.EcUtils = EcUtils;
    exports2.EcdhEsProvider = EcdhEsProvider;
    exports2.EcdhProvider = EcdhProvider;
    exports2.EcdsaProvider = EcdsaProvider;
    exports2.EdDsaProvider = EdDsaProvider;
    exports2.EllipticProvider = EllipticProvider;
    exports2.HkdfProvider = HkdfProvider;
    exports2.HmacProvider = HmacProvider;
    exports2.JwkUtils = JwkUtils;
    exports2.OperationError = OperationError;
    exports2.Pbkdf2Provider = Pbkdf2Provider;
    exports2.PemConverter = PemConverter;
    exports2.ProviderCrypto = ProviderCrypto;
    exports2.ProviderStorage = ProviderStorage;
    exports2.RequiredPropertyError = RequiredPropertyError;
    exports2.RsaOaepProvider = RsaOaepProvider;
    exports2.RsaProvider = RsaProvider;
    exports2.RsaPssProvider = RsaPssProvider;
    exports2.RsaSsaProvider = RsaSsaProvider;
    exports2.Shake128Provider = Shake128Provider;
    exports2.Shake256Provider = Shake256Provider;
    exports2.ShakeProvider = ShakeProvider;
    exports2.SubtleCrypto = SubtleCrypto;
    exports2.UnsupportedOperationError = UnsupportedOperationError;
    exports2.asn1 = index$1;
    exports2.isJWK = isJWK;
    exports2.json = index;
  }
});

// node_modules/@peculiar/webcrypto/build/webcrypto.js
var require_webcrypto = __commonJS({
  "node_modules/@peculiar/webcrypto/build/webcrypto.js"(exports2) {
    "use strict";
    var core = require_webcrypto_core();
    var buffer = require("buffer");
    var crypto2 = require("crypto");
    var process2 = require("process");
    var tslib = (init_tslib_es6(), __toCommonJS(tslib_es6_exports));
    var jsonSchema = require_build5();
    var pvtsutils = require_build3();
    var asn1Schema = require_cjs2();
    function _interopNamespaceDefault(e) {
      var n = /* @__PURE__ */ Object.create(null);
      if (e) {
        Object.keys(e).forEach(function(k) {
          if (k !== "default") {
            var d2 = Object.getOwnPropertyDescriptor(e, k);
            Object.defineProperty(n, k, d2.get ? d2 : {
              enumerable: true,
              get: function() {
                return e[k];
              }
            });
          }
        });
      }
      n.default = e;
      return Object.freeze(n);
    }
    var core__namespace = /* @__PURE__ */ _interopNamespaceDefault(core);
    var crypto__namespace = /* @__PURE__ */ _interopNamespaceDefault(crypto2);
    var process__namespace = /* @__PURE__ */ _interopNamespaceDefault(process2);
    var JsonBase64UrlConverter = {
      fromJSON: (value) => buffer.Buffer.from(pvtsutils.Convert.FromBase64Url(value)),
      toJSON: (value) => pvtsutils.Convert.ToBase64Url(value)
    };
    var CryptoKey = class extends core__namespace.CryptoKey {
      constructor() {
        super(...arguments);
        this.data = buffer.Buffer.alloc(0);
        this.algorithm = { name: "" };
        this.extractable = false;
        this.type = "secret";
        this.usages = [];
        this.kty = "oct";
        this.alg = "";
      }
    };
    tslib.__decorate([
      jsonSchema.JsonProp({ name: "ext", type: jsonSchema.JsonPropTypes.Boolean, optional: true })
    ], CryptoKey.prototype, "extractable", void 0);
    tslib.__decorate([
      jsonSchema.JsonProp({ name: "key_ops", type: jsonSchema.JsonPropTypes.String, repeated: true, optional: true })
    ], CryptoKey.prototype, "usages", void 0);
    tslib.__decorate([
      jsonSchema.JsonProp({ type: jsonSchema.JsonPropTypes.String })
    ], CryptoKey.prototype, "kty", void 0);
    tslib.__decorate([
      jsonSchema.JsonProp({ type: jsonSchema.JsonPropTypes.String, optional: true })
    ], CryptoKey.prototype, "alg", void 0);
    var SymmetricKey = class extends CryptoKey {
      constructor() {
        super(...arguments);
        this.kty = "oct";
        this.type = "secret";
      }
    };
    var AsymmetricKey = class extends CryptoKey {
    };
    var AesCryptoKey = class extends SymmetricKey {
      get alg() {
        switch (this.algorithm.name.toUpperCase()) {
          case "AES-CBC":
            return `A${this.algorithm.length}CBC`;
          case "AES-CTR":
            return `A${this.algorithm.length}CTR`;
          case "AES-GCM":
            return `A${this.algorithm.length}GCM`;
          case "AES-KW":
            return `A${this.algorithm.length}KW`;
          case "AES-CMAC":
            return `A${this.algorithm.length}CMAC`;
          case "AES-ECB":
            return `A${this.algorithm.length}ECB`;
          default:
            throw new core__namespace.AlgorithmError("Unsupported algorithm name");
        }
      }
      set alg(value) {
      }
    };
    tslib.__decorate([
      jsonSchema.JsonProp({ name: "k", converter: JsonBase64UrlConverter })
    ], AesCryptoKey.prototype, "data", void 0);
    var AesCrypto = class {
      static async generateKey(algorithm, extractable, keyUsages) {
        const key = new AesCryptoKey();
        key.algorithm = algorithm;
        key.extractable = extractable;
        key.usages = keyUsages;
        key.data = crypto2.randomBytes(algorithm.length >> 3);
        return key;
      }
      static async exportKey(format3, key) {
        if (!(key instanceof AesCryptoKey)) {
          throw new Error("key: Is not AesCryptoKey");
        }
        switch (format3.toLowerCase()) {
          case "jwk":
            return jsonSchema.JsonSerializer.toJSON(key);
          case "raw":
            return new Uint8Array(key.data).buffer;
          default:
            throw new core__namespace.OperationError("format: Must be 'jwk' or 'raw'");
        }
      }
      static async importKey(format3, keyData, algorithm, extractable, keyUsages) {
        let key;
        switch (format3.toLowerCase()) {
          case "jwk":
            key = jsonSchema.JsonParser.fromJSON(keyData, { targetSchema: AesCryptoKey });
            break;
          case "raw":
            key = new AesCryptoKey();
            key.data = buffer.Buffer.from(keyData);
            break;
          default:
            throw new core__namespace.OperationError("format: Must be 'jwk' or 'raw'");
        }
        key.algorithm = algorithm;
        key.algorithm.length = key.data.length << 3;
        key.extractable = extractable;
        key.usages = keyUsages;
        switch (key.algorithm.length) {
          case 128:
          case 192:
          case 256:
            break;
          default:
            throw new core__namespace.OperationError("keyData: Is wrong key length");
        }
        return key;
      }
      static async encrypt(algorithm, key, data) {
        switch (algorithm.name.toUpperCase()) {
          case "AES-CBC":
            return this.encryptAesCBC(algorithm, key, buffer.Buffer.from(data));
          case "AES-CTR":
            return this.encryptAesCTR(algorithm, key, buffer.Buffer.from(data));
          case "AES-GCM":
            return this.encryptAesGCM(algorithm, key, buffer.Buffer.from(data));
          case "AES-KW":
            return this.encryptAesKW(algorithm, key, buffer.Buffer.from(data));
          case "AES-ECB":
            return this.encryptAesECB(algorithm, key, buffer.Buffer.from(data));
          default:
            throw new core__namespace.OperationError("algorithm: Is not recognized");
        }
      }
      static async decrypt(algorithm, key, data) {
        if (!(key instanceof AesCryptoKey)) {
          throw new Error("key: Is not AesCryptoKey");
        }
        switch (algorithm.name.toUpperCase()) {
          case "AES-CBC":
            return this.decryptAesCBC(algorithm, key, buffer.Buffer.from(data));
          case "AES-CTR":
            return this.decryptAesCTR(algorithm, key, buffer.Buffer.from(data));
          case "AES-GCM":
            return this.decryptAesGCM(algorithm, key, buffer.Buffer.from(data));
          case "AES-KW":
            return this.decryptAesKW(algorithm, key, buffer.Buffer.from(data));
          case "AES-ECB":
            return this.decryptAesECB(algorithm, key, buffer.Buffer.from(data));
          default:
            throw new core__namespace.OperationError("algorithm: Is not recognized");
        }
      }
      static async encryptAesCBC(algorithm, key, data) {
        const cipher = crypto2.createCipheriv(`aes-${key.algorithm.length}-cbc`, key.data, new Uint8Array(algorithm.iv));
        let enc = cipher.update(data);
        enc = buffer.Buffer.concat([enc, cipher.final()]);
        const res = new Uint8Array(enc).buffer;
        return res;
      }
      static async decryptAesCBC(algorithm, key, data) {
        const decipher = crypto2.createDecipheriv(`aes-${key.algorithm.length}-cbc`, key.data, new Uint8Array(algorithm.iv));
        let dec = decipher.update(data);
        dec = buffer.Buffer.concat([dec, decipher.final()]);
        return new Uint8Array(dec).buffer;
      }
      static async encryptAesCTR(algorithm, key, data) {
        const cipher = crypto2.createCipheriv(`aes-${key.algorithm.length}-ctr`, key.data, buffer.Buffer.from(algorithm.counter));
        let enc = cipher.update(data);
        enc = buffer.Buffer.concat([enc, cipher.final()]);
        const res = new Uint8Array(enc).buffer;
        return res;
      }
      static async decryptAesCTR(algorithm, key, data) {
        const decipher = crypto2.createDecipheriv(`aes-${key.algorithm.length}-ctr`, key.data, new Uint8Array(algorithm.counter));
        let dec = decipher.update(data);
        dec = buffer.Buffer.concat([dec, decipher.final()]);
        return new Uint8Array(dec).buffer;
      }
      static async encryptAesGCM(algorithm, key, data) {
        const cipher = crypto2.createCipheriv(`aes-${key.algorithm.length}-gcm`, key.data, buffer.Buffer.from(algorithm.iv), {
          authTagLength: (algorithm.tagLength || 128) >> 3
        });
        if (algorithm.additionalData) {
          cipher.setAAD(buffer.Buffer.from(algorithm.additionalData));
        }
        let enc = cipher.update(data);
        enc = buffer.Buffer.concat([enc, cipher.final(), cipher.getAuthTag()]);
        const res = new Uint8Array(enc).buffer;
        return res;
      }
      static async decryptAesGCM(algorithm, key, data) {
        const decipher = crypto2.createDecipheriv(`aes-${key.algorithm.length}-gcm`, key.data, new Uint8Array(algorithm.iv));
        const tagLength = (algorithm.tagLength || 128) >> 3;
        const enc = data.slice(0, data.length - tagLength);
        const tag = data.slice(data.length - tagLength);
        if (algorithm.additionalData) {
          decipher.setAAD(buffer.Buffer.from(algorithm.additionalData));
        }
        decipher.setAuthTag(tag);
        let dec = decipher.update(enc);
        dec = buffer.Buffer.concat([dec, decipher.final()]);
        return new Uint8Array(dec).buffer;
      }
      static async encryptAesKW(algorithm, key, data) {
        const cipher = crypto2.createCipheriv(`id-aes${key.algorithm.length}-wrap`, key.data, this.AES_KW_IV);
        let enc = cipher.update(data);
        enc = buffer.Buffer.concat([enc, cipher.final()]);
        return new Uint8Array(enc).buffer;
      }
      static async decryptAesKW(algorithm, key, data) {
        const decipher = crypto2.createDecipheriv(`id-aes${key.algorithm.length}-wrap`, key.data, this.AES_KW_IV);
        let dec = decipher.update(data);
        dec = buffer.Buffer.concat([dec, decipher.final()]);
        return new Uint8Array(dec).buffer;
      }
      static async encryptAesECB(algorithm, key, data) {
        const cipher = crypto2.createCipheriv(`aes-${key.algorithm.length}-ecb`, key.data, new Uint8Array(0));
        let enc = cipher.update(data);
        enc = buffer.Buffer.concat([enc, cipher.final()]);
        const res = new Uint8Array(enc).buffer;
        return res;
      }
      static async decryptAesECB(algorithm, key, data) {
        const decipher = crypto2.createDecipheriv(`aes-${key.algorithm.length}-ecb`, key.data, new Uint8Array(0));
        let dec = decipher.update(data);
        dec = buffer.Buffer.concat([dec, decipher.final()]);
        return new Uint8Array(dec).buffer;
      }
    };
    AesCrypto.AES_KW_IV = buffer.Buffer.from("A6A6A6A6A6A6A6A6", "hex");
    var keyStorage = /* @__PURE__ */ new WeakMap();
    function getCryptoKey(key) {
      const res = keyStorage.get(key);
      if (!res) {
        throw new core__namespace.OperationError("Cannot get CryptoKey from secure storage");
      }
      return res;
    }
    function setCryptoKey(value) {
      const key = core__namespace.CryptoKey.create(value.algorithm, value.type, value.extractable, value.usages);
      Object.freeze(key);
      keyStorage.set(key, value);
      return key;
    }
    var AesCbcProvider = class extends core__namespace.AesCbcProvider {
      async onGenerateKey(algorithm, extractable, keyUsages) {
        const key = await AesCrypto.generateKey({
          name: this.name,
          length: algorithm.length
        }, extractable, keyUsages);
        return setCryptoKey(key);
      }
      async onEncrypt(algorithm, key, data) {
        return AesCrypto.encrypt(algorithm, getCryptoKey(key), new Uint8Array(data));
      }
      async onDecrypt(algorithm, key, data) {
        return AesCrypto.decrypt(algorithm, getCryptoKey(key), new Uint8Array(data));
      }
      async onExportKey(format3, key) {
        return AesCrypto.exportKey(format3, getCryptoKey(key));
      }
      async onImportKey(format3, keyData, algorithm, extractable, keyUsages) {
        const key = await AesCrypto.importKey(format3, keyData, { name: algorithm.name }, extractable, keyUsages);
        return setCryptoKey(key);
      }
      checkCryptoKey(key, keyUsage) {
        super.checkCryptoKey(key, keyUsage);
        if (!(getCryptoKey(key) instanceof AesCryptoKey)) {
          throw new TypeError("key: Is not a AesCryptoKey");
        }
      }
    };
    var zero = buffer.Buffer.from([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]);
    var rb = buffer.Buffer.from([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135]);
    var blockSize = 16;
    function bitShiftLeft(buffer$1) {
      const shifted = buffer.Buffer.alloc(buffer$1.length);
      const last = buffer$1.length - 1;
      for (let index = 0; index < last; index++) {
        shifted[index] = buffer$1[index] << 1;
        if (buffer$1[index + 1] & 128) {
          shifted[index] += 1;
        }
      }
      shifted[last] = buffer$1[last] << 1;
      return shifted;
    }
    function xor(a, b) {
      const length = Math.min(a.length, b.length);
      const output = buffer.Buffer.alloc(length);
      for (let index = 0; index < length; index++) {
        output[index] = a[index] ^ b[index];
      }
      return output;
    }
    function aes(key, message) {
      const cipher = crypto__namespace.createCipheriv(`aes${key.length << 3}`, key, zero);
      const result2 = cipher.update(message);
      cipher.final();
      return result2;
    }
    function getMessageBlock(message, blockIndex) {
      const block = buffer.Buffer.alloc(blockSize);
      const start = blockIndex * blockSize;
      const end = start + blockSize;
      message.copy(block, 0, start, end);
      return block;
    }
    function getPaddedMessageBlock(message, blockIndex) {
      const block = buffer.Buffer.alloc(blockSize);
      const start = blockIndex * blockSize;
      const end = message.length;
      block.fill(0);
      message.copy(block, 0, start, end);
      block[end - start] = 128;
      return block;
    }
    function generateSubkeys(key) {
      const l2 = aes(key, zero);
      let subkey1 = bitShiftLeft(l2);
      if (l2[0] & 128) {
        subkey1 = xor(subkey1, rb);
      }
      let subkey2 = bitShiftLeft(subkey1);
      if (subkey1[0] & 128) {
        subkey2 = xor(subkey2, rb);
      }
      return { subkey1, subkey2 };
    }
    function aesCmac(key, message) {
      const subkeys = generateSubkeys(key);
      let blockCount = Math.ceil(message.length / blockSize);
      let lastBlockCompleteFlag;
      let lastBlock;
      if (blockCount === 0) {
        blockCount = 1;
        lastBlockCompleteFlag = false;
      } else {
        lastBlockCompleteFlag = message.length % blockSize === 0;
      }
      const lastBlockIndex = blockCount - 1;
      if (lastBlockCompleteFlag) {
        lastBlock = xor(getMessageBlock(message, lastBlockIndex), subkeys.subkey1);
      } else {
        lastBlock = xor(getPaddedMessageBlock(message, lastBlockIndex), subkeys.subkey2);
      }
      let x2 = zero;
      let y;
      for (let index = 0; index < lastBlockIndex; index++) {
        y = xor(x2, getMessageBlock(message, index));
        x2 = aes(key, y);
      }
      y = xor(lastBlock, x2);
      return aes(key, y);
    }
    var AesCmacProvider = class extends core__namespace.AesCmacProvider {
      async onGenerateKey(algorithm, extractable, keyUsages) {
        const key = await AesCrypto.generateKey({
          name: this.name,
          length: algorithm.length
        }, extractable, keyUsages);
        return setCryptoKey(key);
      }
      async onSign(algorithm, key, data) {
        const result2 = aesCmac(getCryptoKey(key).data, buffer.Buffer.from(data));
        return new Uint8Array(result2).buffer;
      }
      async onVerify(algorithm, key, signature, data) {
        const signature2 = await this.sign(algorithm, key, data);
        return buffer.Buffer.from(signature).compare(buffer.Buffer.from(signature2)) === 0;
      }
      async onExportKey(format3, key) {
        return AesCrypto.exportKey(format3, getCryptoKey(key));
      }
      async onImportKey(format3, keyData, algorithm, extractable, keyUsages) {
        const res = await AesCrypto.importKey(format3, keyData, { name: algorithm.name }, extractable, keyUsages);
        return setCryptoKey(res);
      }
      checkCryptoKey(key, keyUsage) {
        super.checkCryptoKey(key, keyUsage);
        if (!(getCryptoKey(key) instanceof AesCryptoKey)) {
          throw new TypeError("key: Is not a AesCryptoKey");
        }
      }
    };
    var AesCtrProvider = class extends core__namespace.AesCtrProvider {
      async onGenerateKey(algorithm, extractable, keyUsages) {
        const key = await AesCrypto.generateKey({
          name: this.name,
          length: algorithm.length
        }, extractable, keyUsages);
        return setCryptoKey(key);
      }
      async onEncrypt(algorithm, key, data) {
        return AesCrypto.encrypt(algorithm, getCryptoKey(key), new Uint8Array(data));
      }
      async onDecrypt(algorithm, key, data) {
        return AesCrypto.decrypt(algorithm, getCryptoKey(key), new Uint8Array(data));
      }
      async onExportKey(format3, key) {
        return AesCrypto.exportKey(format3, getCryptoKey(key));
      }
      async onImportKey(format3, keyData, algorithm, extractable, keyUsages) {
        const res = await AesCrypto.importKey(format3, keyData, { name: algorithm.name }, extractable, keyUsages);
        return setCryptoKey(res);
      }
      checkCryptoKey(key, keyUsage) {
        super.checkCryptoKey(key, keyUsage);
        if (!(getCryptoKey(key) instanceof AesCryptoKey)) {
          throw new TypeError("key: Is not a AesCryptoKey");
        }
      }
    };
    var AesGcmProvider = class extends core__namespace.AesGcmProvider {
      async onGenerateKey(algorithm, extractable, keyUsages) {
        const key = await AesCrypto.generateKey({
          name: this.name,
          length: algorithm.length
        }, extractable, keyUsages);
        return setCryptoKey(key);
      }
      async onEncrypt(algorithm, key, data) {
        return AesCrypto.encrypt(algorithm, getCryptoKey(key), new Uint8Array(data));
      }
      async onDecrypt(algorithm, key, data) {
        return AesCrypto.decrypt(algorithm, getCryptoKey(key), new Uint8Array(data));
      }
      async onExportKey(format3, key) {
        return AesCrypto.exportKey(format3, getCryptoKey(key));
      }
      async onImportKey(format3, keyData, algorithm, extractable, keyUsages) {
        const res = await AesCrypto.importKey(format3, keyData, { name: algorithm.name }, extractable, keyUsages);
        return setCryptoKey(res);
      }
      checkCryptoKey(key, keyUsage) {
        super.checkCryptoKey(key, keyUsage);
        if (!(getCryptoKey(key) instanceof AesCryptoKey)) {
          throw new TypeError("key: Is not a AesCryptoKey");
        }
      }
    };
    var AesKwProvider = class extends core__namespace.AesKwProvider {
      async onGenerateKey(algorithm, extractable, keyUsages) {
        const res = await AesCrypto.generateKey({
          name: this.name,
          length: algorithm.length
        }, extractable, keyUsages);
        return setCryptoKey(res);
      }
      async onExportKey(format3, key) {
        return AesCrypto.exportKey(format3, getCryptoKey(key));
      }
      async onImportKey(format3, keyData, algorithm, extractable, keyUsages) {
        const res = await AesCrypto.importKey(format3, keyData, { name: algorithm.name }, extractable, keyUsages);
        return setCryptoKey(res);
      }
      async onEncrypt(algorithm, key, data) {
        return AesCrypto.encrypt(algorithm, getCryptoKey(key), new Uint8Array(data));
      }
      async onDecrypt(algorithm, key, data) {
        return AesCrypto.decrypt(algorithm, getCryptoKey(key), new Uint8Array(data));
      }
      checkCryptoKey(key, keyUsage) {
        super.checkCryptoKey(key, keyUsage);
        if (!(getCryptoKey(key) instanceof AesCryptoKey)) {
          throw new TypeError("key: Is not a AesCryptoKey");
        }
      }
    };
    var AesEcbProvider = class extends core__namespace.AesEcbProvider {
      async onGenerateKey(algorithm, extractable, keyUsages) {
        const key = await AesCrypto.generateKey({
          name: this.name,
          length: algorithm.length
        }, extractable, keyUsages);
        return setCryptoKey(key);
      }
      async onEncrypt(algorithm, key, data) {
        return AesCrypto.encrypt(algorithm, getCryptoKey(key), new Uint8Array(data));
      }
      async onDecrypt(algorithm, key, data) {
        return AesCrypto.decrypt(algorithm, getCryptoKey(key), new Uint8Array(data));
      }
      async onExportKey(format3, key) {
        return AesCrypto.exportKey(format3, getCryptoKey(key));
      }
      async onImportKey(format3, keyData, algorithm, extractable, keyUsages) {
        const res = await AesCrypto.importKey(format3, keyData, { name: algorithm.name }, extractable, keyUsages);
        return setCryptoKey(res);
      }
      checkCryptoKey(key, keyUsage) {
        super.checkCryptoKey(key, keyUsage);
        if (!(getCryptoKey(key) instanceof AesCryptoKey)) {
          throw new TypeError("key: Is not a AesCryptoKey");
        }
      }
    };
    var DesCryptoKey = class extends SymmetricKey {
      get alg() {
        switch (this.algorithm.name.toUpperCase()) {
          case "DES-CBC":
            return `DES-CBC`;
          case "DES-EDE3-CBC":
            return `3DES-CBC`;
          default:
            throw new core__namespace.AlgorithmError("Unsupported algorithm name");
        }
      }
      set alg(value) {
      }
    };
    tslib.__decorate([
      jsonSchema.JsonProp({ name: "k", converter: JsonBase64UrlConverter })
    ], DesCryptoKey.prototype, "data", void 0);
    var DesCrypto = class {
      static async generateKey(algorithm, extractable, keyUsages) {
        const key = new DesCryptoKey();
        key.algorithm = algorithm;
        key.extractable = extractable;
        key.usages = keyUsages;
        key.data = crypto2.randomBytes(algorithm.length >> 3);
        return key;
      }
      static async exportKey(format3, key) {
        switch (format3.toLowerCase()) {
          case "jwk":
            return jsonSchema.JsonSerializer.toJSON(key);
          case "raw":
            return new Uint8Array(key.data).buffer;
          default:
            throw new core__namespace.OperationError("format: Must be 'jwk' or 'raw'");
        }
      }
      static async importKey(format3, keyData, algorithm, extractable, keyUsages) {
        let key;
        switch (format3.toLowerCase()) {
          case "jwk":
            key = jsonSchema.JsonParser.fromJSON(keyData, { targetSchema: DesCryptoKey });
            break;
          case "raw":
            key = new DesCryptoKey();
            key.data = buffer.Buffer.from(keyData);
            break;
          default:
            throw new core__namespace.OperationError("format: Must be 'jwk' or 'raw'");
        }
        key.algorithm = algorithm;
        key.extractable = extractable;
        key.usages = keyUsages;
        return key;
      }
      static async encrypt(algorithm, key, data) {
        switch (algorithm.name.toUpperCase()) {
          case "DES-CBC":
            return this.encryptDesCBC(algorithm, key, buffer.Buffer.from(data));
          case "DES-EDE3-CBC":
            return this.encryptDesEDE3CBC(algorithm, key, buffer.Buffer.from(data));
          default:
            throw new core__namespace.OperationError("algorithm: Is not recognized");
        }
      }
      static async decrypt(algorithm, key, data) {
        if (!(key instanceof DesCryptoKey)) {
          throw new Error("key: Is not DesCryptoKey");
        }
        switch (algorithm.name.toUpperCase()) {
          case "DES-CBC":
            return this.decryptDesCBC(algorithm, key, buffer.Buffer.from(data));
          case "DES-EDE3-CBC":
            return this.decryptDesEDE3CBC(algorithm, key, buffer.Buffer.from(data));
          default:
            throw new core__namespace.OperationError("algorithm: Is not recognized");
        }
      }
      static async encryptDesCBC(algorithm, key, data) {
        const cipher = crypto2.createCipheriv(`des-cbc`, key.data, new Uint8Array(algorithm.iv));
        let enc = cipher.update(data);
        enc = buffer.Buffer.concat([enc, cipher.final()]);
        const res = new Uint8Array(enc).buffer;
        return res;
      }
      static async decryptDesCBC(algorithm, key, data) {
        const decipher = crypto2.createDecipheriv(`des-cbc`, key.data, new Uint8Array(algorithm.iv));
        let dec = decipher.update(data);
        dec = buffer.Buffer.concat([dec, decipher.final()]);
        return new Uint8Array(dec).buffer;
      }
      static async encryptDesEDE3CBC(algorithm, key, data) {
        const cipher = crypto2.createCipheriv(`des-ede3-cbc`, key.data, buffer.Buffer.from(algorithm.iv));
        let enc = cipher.update(data);
        enc = buffer.Buffer.concat([enc, cipher.final()]);
        const res = new Uint8Array(enc).buffer;
        return res;
      }
      static async decryptDesEDE3CBC(algorithm, key, data) {
        const decipher = crypto2.createDecipheriv(`des-ede3-cbc`, key.data, new Uint8Array(algorithm.iv));
        let dec = decipher.update(data);
        dec = buffer.Buffer.concat([dec, decipher.final()]);
        return new Uint8Array(dec).buffer;
      }
    };
    var DesCbcProvider = class extends core__namespace.DesProvider {
      constructor() {
        super(...arguments);
        this.keySizeBits = 64;
        this.ivSize = 8;
        this.name = "DES-CBC";
      }
      async onGenerateKey(algorithm, extractable, keyUsages) {
        const key = await DesCrypto.generateKey({
          name: this.name,
          length: this.keySizeBits
        }, extractable, keyUsages);
        return setCryptoKey(key);
      }
      async onEncrypt(algorithm, key, data) {
        return DesCrypto.encrypt(algorithm, getCryptoKey(key), new Uint8Array(data));
      }
      async onDecrypt(algorithm, key, data) {
        return DesCrypto.decrypt(algorithm, getCryptoKey(key), new Uint8Array(data));
      }
      async onExportKey(format3, key) {
        return DesCrypto.exportKey(format3, getCryptoKey(key));
      }
      async onImportKey(format3, keyData, algorithm, extractable, keyUsages) {
        const key = await DesCrypto.importKey(format3, keyData, { name: this.name, length: this.keySizeBits }, extractable, keyUsages);
        if (key.data.length !== this.keySizeBits >> 3) {
          throw new core__namespace.OperationError("keyData: Wrong key size");
        }
        return setCryptoKey(key);
      }
      checkCryptoKey(key, keyUsage) {
        super.checkCryptoKey(key, keyUsage);
        if (!(getCryptoKey(key) instanceof DesCryptoKey)) {
          throw new TypeError("key: Is not a DesCryptoKey");
        }
      }
    };
    var DesEde3CbcProvider = class extends core__namespace.DesProvider {
      constructor() {
        super(...arguments);
        this.keySizeBits = 192;
        this.ivSize = 8;
        this.name = "DES-EDE3-CBC";
      }
      async onGenerateKey(algorithm, extractable, keyUsages) {
        const key = await DesCrypto.generateKey({
          name: this.name,
          length: this.keySizeBits
        }, extractable, keyUsages);
        return setCryptoKey(key);
      }
      async onEncrypt(algorithm, key, data) {
        return DesCrypto.encrypt(algorithm, getCryptoKey(key), new Uint8Array(data));
      }
      async onDecrypt(algorithm, key, data) {
        return DesCrypto.decrypt(algorithm, getCryptoKey(key), new Uint8Array(data));
      }
      async onExportKey(format3, key) {
        return DesCrypto.exportKey(format3, getCryptoKey(key));
      }
      async onImportKey(format3, keyData, algorithm, extractable, keyUsages) {
        const key = await DesCrypto.importKey(format3, keyData, { name: this.name, length: this.keySizeBits }, extractable, keyUsages);
        if (key.data.length !== this.keySizeBits >> 3) {
          throw new core__namespace.OperationError("keyData: Wrong key size");
        }
        return setCryptoKey(key);
      }
      checkCryptoKey(key, keyUsage) {
        super.checkCryptoKey(key, keyUsage);
        if (!(getCryptoKey(key) instanceof DesCryptoKey)) {
          throw new TypeError("key: Is not a DesCryptoKey");
        }
      }
    };
    function getJwkAlgorithm(algorithm) {
      switch (algorithm.name.toUpperCase()) {
        case "RSA-OAEP": {
          const mdSize = /(\d+)$/.exec(algorithm.hash.name)[1];
          return `RSA-OAEP${mdSize !== "1" ? `-${mdSize}` : ""}`;
        }
        case "RSASSA-PKCS1-V1_5":
          return `RS${/(\d+)$/.exec(algorithm.hash.name)[1]}`;
        case "RSA-PSS":
          return `PS${/(\d+)$/.exec(algorithm.hash.name)[1]}`;
        case "RSA-PKCS1":
          return `RS1`;
        default:
          throw new core__namespace.OperationError("algorithm: Is not recognized");
      }
    }
    var RsaPrivateKey = class extends AsymmetricKey {
      constructor() {
        super(...arguments);
        this.type = "private";
      }
      getKey() {
        const keyInfo = asn1Schema.AsnParser.parse(this.data, core__namespace.asn1.PrivateKeyInfo);
        return asn1Schema.AsnParser.parse(keyInfo.privateKey, core__namespace.asn1.RsaPrivateKey);
      }
      toJSON() {
        const key = this.getKey();
        const json3 = {
          kty: "RSA",
          alg: getJwkAlgorithm(this.algorithm),
          key_ops: this.usages,
          ext: this.extractable
        };
        return Object.assign(json3, jsonSchema.JsonSerializer.toJSON(key));
      }
      fromJSON(json3) {
        const key = jsonSchema.JsonParser.fromJSON(json3, { targetSchema: core__namespace.asn1.RsaPrivateKey });
        const keyInfo = new core__namespace.asn1.PrivateKeyInfo();
        keyInfo.privateKeyAlgorithm.algorithm = "1.2.840.113549.1.1.1";
        keyInfo.privateKeyAlgorithm.parameters = null;
        keyInfo.privateKey = asn1Schema.AsnSerializer.serialize(key);
        this.data = buffer.Buffer.from(asn1Schema.AsnSerializer.serialize(keyInfo));
      }
    };
    var RsaPublicKey = class extends AsymmetricKey {
      constructor() {
        super(...arguments);
        this.type = "public";
      }
      getKey() {
        const keyInfo = asn1Schema.AsnParser.parse(this.data, core__namespace.asn1.PublicKeyInfo);
        return asn1Schema.AsnParser.parse(keyInfo.publicKey, core__namespace.asn1.RsaPublicKey);
      }
      toJSON() {
        const key = this.getKey();
        const json3 = {
          kty: "RSA",
          alg: getJwkAlgorithm(this.algorithm),
          key_ops: this.usages,
          ext: this.extractable
        };
        return Object.assign(json3, jsonSchema.JsonSerializer.toJSON(key));
      }
      fromJSON(json3) {
        const key = jsonSchema.JsonParser.fromJSON(json3, { targetSchema: core__namespace.asn1.RsaPublicKey });
        const keyInfo = new core__namespace.asn1.PublicKeyInfo();
        keyInfo.publicKeyAlgorithm.algorithm = "1.2.840.113549.1.1.1";
        keyInfo.publicKeyAlgorithm.parameters = null;
        keyInfo.publicKey = asn1Schema.AsnSerializer.serialize(key);
        this.data = buffer.Buffer.from(asn1Schema.AsnSerializer.serialize(keyInfo));
      }
    };
    var RsaCrypto = class {
      static async generateKey(algorithm, extractable, keyUsages) {
        const privateKey = new RsaPrivateKey();
        privateKey.algorithm = algorithm;
        privateKey.extractable = extractable;
        privateKey.usages = keyUsages.filter((usage) => this.privateKeyUsages.indexOf(usage) !== -1);
        const publicKey = new RsaPublicKey();
        publicKey.algorithm = algorithm;
        publicKey.extractable = true;
        publicKey.usages = keyUsages.filter((usage) => this.publicKeyUsages.indexOf(usage) !== -1);
        const publicExponent = buffer.Buffer.concat([
          buffer.Buffer.alloc(4 - algorithm.publicExponent.byteLength, 0),
          buffer.Buffer.from(algorithm.publicExponent)
        ]).readInt32BE(0);
        const keys = crypto2.generateKeyPairSync("rsa", {
          modulusLength: algorithm.modulusLength,
          publicExponent,
          publicKeyEncoding: {
            format: "der",
            type: "spki"
          },
          privateKeyEncoding: {
            format: "der",
            type: "pkcs8"
          }
        });
        privateKey.data = keys.privateKey;
        publicKey.data = keys.publicKey;
        const res = {
          privateKey,
          publicKey
        };
        return res;
      }
      static async exportKey(format3, key) {
        switch (format3.toLowerCase()) {
          case "jwk":
            return jsonSchema.JsonSerializer.toJSON(key);
          case "pkcs8":
          case "spki":
            return new Uint8Array(key.data).buffer;
          default:
            throw new core__namespace.OperationError("format: Must be 'jwk', 'pkcs8' or 'spki'");
        }
      }
      static async importKey(format3, keyData, algorithm, extractable, keyUsages) {
        switch (format3.toLowerCase()) {
          case "jwk": {
            const jwk = keyData;
            if (jwk.d) {
              const asnKey = jsonSchema.JsonParser.fromJSON(keyData, { targetSchema: core__namespace.asn1.RsaPrivateKey });
              return this.importPrivateKey(asnKey, algorithm, extractable, keyUsages);
            } else {
              const asnKey = jsonSchema.JsonParser.fromJSON(keyData, { targetSchema: core__namespace.asn1.RsaPublicKey });
              return this.importPublicKey(asnKey, algorithm, extractable, keyUsages);
            }
          }
          case "spki": {
            const keyInfo = asn1Schema.AsnParser.parse(new Uint8Array(keyData), core__namespace.asn1.PublicKeyInfo);
            const asnKey = asn1Schema.AsnParser.parse(keyInfo.publicKey, core__namespace.asn1.RsaPublicKey);
            return this.importPublicKey(asnKey, algorithm, extractable, keyUsages);
          }
          case "pkcs8": {
            const keyInfo = asn1Schema.AsnParser.parse(new Uint8Array(keyData), core__namespace.asn1.PrivateKeyInfo);
            const asnKey = asn1Schema.AsnParser.parse(keyInfo.privateKey, core__namespace.asn1.RsaPrivateKey);
            return this.importPrivateKey(asnKey, algorithm, extractable, keyUsages);
          }
          default:
            throw new core__namespace.OperationError("format: Must be 'jwk', 'pkcs8' or 'spki'");
        }
      }
      static async sign(algorithm, key, data) {
        switch (algorithm.name.toUpperCase()) {
          case "RSA-PSS":
          case "RSASSA-PKCS1-V1_5":
            return this.signRsa(algorithm, key, data);
          default:
            throw new core__namespace.OperationError("algorithm: Is not recognized");
        }
      }
      static async verify(algorithm, key, signature, data) {
        switch (algorithm.name.toUpperCase()) {
          case "RSA-PSS":
          case "RSASSA-PKCS1-V1_5":
            return this.verifySSA(algorithm, key, data, signature);
          default:
            throw new core__namespace.OperationError("algorithm: Is not recognized");
        }
      }
      static async encrypt(algorithm, key, data) {
        switch (algorithm.name.toUpperCase()) {
          case "RSA-OAEP":
            return this.encryptOAEP(algorithm, key, data);
          default:
            throw new core__namespace.OperationError("algorithm: Is not recognized");
        }
      }
      static async decrypt(algorithm, key, data) {
        switch (algorithm.name.toUpperCase()) {
          case "RSA-OAEP":
            return this.decryptOAEP(algorithm, key, data);
          default:
            throw new core__namespace.OperationError("algorithm: Is not recognized");
        }
      }
      static importPrivateKey(asnKey, algorithm, extractable, keyUsages) {
        const keyInfo = new core__namespace.asn1.PrivateKeyInfo();
        keyInfo.privateKeyAlgorithm.algorithm = "1.2.840.113549.1.1.1";
        keyInfo.privateKeyAlgorithm.parameters = null;
        keyInfo.privateKey = asn1Schema.AsnSerializer.serialize(asnKey);
        const key = new RsaPrivateKey();
        key.data = buffer.Buffer.from(asn1Schema.AsnSerializer.serialize(keyInfo));
        key.algorithm = Object.assign({}, algorithm);
        key.algorithm.publicExponent = new Uint8Array(asnKey.publicExponent);
        key.algorithm.modulusLength = asnKey.modulus.byteLength << 3;
        key.extractable = extractable;
        key.usages = keyUsages;
        return key;
      }
      static importPublicKey(asnKey, algorithm, extractable, keyUsages) {
        const keyInfo = new core__namespace.asn1.PublicKeyInfo();
        keyInfo.publicKeyAlgorithm.algorithm = "1.2.840.113549.1.1.1";
        keyInfo.publicKeyAlgorithm.parameters = null;
        keyInfo.publicKey = asn1Schema.AsnSerializer.serialize(asnKey);
        const key = new RsaPublicKey();
        key.data = buffer.Buffer.from(asn1Schema.AsnSerializer.serialize(keyInfo));
        key.algorithm = Object.assign({}, algorithm);
        key.algorithm.publicExponent = new Uint8Array(asnKey.publicExponent);
        key.algorithm.modulusLength = asnKey.modulus.byteLength << 3;
        key.extractable = extractable;
        key.usages = keyUsages;
        return key;
      }
      static getCryptoAlgorithm(alg) {
        switch (alg.hash.name.toUpperCase()) {
          case "SHA-1":
            return "RSA-SHA1";
          case "SHA-256":
            return "RSA-SHA256";
          case "SHA-384":
            return "RSA-SHA384";
          case "SHA-512":
            return "RSA-SHA512";
          case "SHA3-256":
            return "RSA-SHA3-256";
          case "SHA3-384":
            return "RSA-SHA3-384";
          case "SHA3-512":
            return "RSA-SHA3-512";
          default:
            throw new core__namespace.OperationError("algorithm.hash: Is not recognized");
        }
      }
      static signRsa(algorithm, key, data) {
        const cryptoAlg = this.getCryptoAlgorithm(key.algorithm);
        const signer = crypto2.createSign(cryptoAlg);
        signer.update(buffer.Buffer.from(data));
        if (!key.pem) {
          key.pem = `-----BEGIN PRIVATE KEY-----
${key.data.toString("base64")}
-----END PRIVATE KEY-----`;
        }
        const options = {
          key: key.pem
        };
        if (algorithm.name.toUpperCase() === "RSA-PSS") {
          options.padding = crypto2.constants.RSA_PKCS1_PSS_PADDING;
          options.saltLength = algorithm.saltLength;
        }
        const signature = signer.sign(options);
        return new Uint8Array(signature).buffer;
      }
      static verifySSA(algorithm, key, data, signature) {
        const cryptoAlg = this.getCryptoAlgorithm(key.algorithm);
        const signer = crypto2.createVerify(cryptoAlg);
        signer.update(buffer.Buffer.from(data));
        if (!key.pem) {
          key.pem = `-----BEGIN PUBLIC KEY-----
${key.data.toString("base64")}
-----END PUBLIC KEY-----`;
        }
        const options = {
          key: key.pem
        };
        if (algorithm.name.toUpperCase() === "RSA-PSS") {
          options.padding = crypto2.constants.RSA_PKCS1_PSS_PADDING;
          options.saltLength = algorithm.saltLength;
        }
        const ok = signer.verify(options, signature);
        return ok;
      }
      static encryptOAEP(algorithm, key, data) {
        const options = {
          key: `-----BEGIN PUBLIC KEY-----
${key.data.toString("base64")}
-----END PUBLIC KEY-----`,
          padding: crypto2.constants.RSA_PKCS1_OAEP_PADDING
        };
        if (algorithm.label)
          ;
        return new Uint8Array(crypto2.publicEncrypt(options, data)).buffer;
      }
      static decryptOAEP(algorithm, key, data) {
        const options = {
          key: `-----BEGIN PRIVATE KEY-----
${key.data.toString("base64")}
-----END PRIVATE KEY-----`,
          padding: crypto2.constants.RSA_PKCS1_OAEP_PADDING
        };
        if (algorithm.label)
          ;
        return new Uint8Array(crypto2.privateDecrypt(options, data)).buffer;
      }
    };
    RsaCrypto.publicKeyUsages = ["verify", "encrypt", "wrapKey"];
    RsaCrypto.privateKeyUsages = ["sign", "decrypt", "unwrapKey"];
    var RsaSsaProvider = class extends core__namespace.RsaSsaProvider {
      constructor() {
        super(...arguments);
        this.hashAlgorithms = [
          "SHA-1",
          "SHA-256",
          "SHA-384",
          "SHA-512",
          "shake128",
          "shake256",
          "SHA3-256",
          "SHA3-384",
          "SHA3-512"
        ];
      }
      async onGenerateKey(algorithm, extractable, keyUsages) {
        const keys = await RsaCrypto.generateKey({
          ...algorithm,
          name: this.name
        }, extractable, keyUsages);
        return {
          privateKey: setCryptoKey(keys.privateKey),
          publicKey: setCryptoKey(keys.publicKey)
        };
      }
      async onSign(algorithm, key, data) {
        return RsaCrypto.sign(algorithm, getCryptoKey(key), new Uint8Array(data));
      }
      async onVerify(algorithm, key, signature, data) {
        return RsaCrypto.verify(algorithm, getCryptoKey(key), new Uint8Array(signature), new Uint8Array(data));
      }
      async onExportKey(format3, key) {
        return RsaCrypto.exportKey(format3, getCryptoKey(key));
      }
      async onImportKey(format3, keyData, algorithm, extractable, keyUsages) {
        const key = await RsaCrypto.importKey(format3, keyData, { ...algorithm, name: this.name }, extractable, keyUsages);
        return setCryptoKey(key);
      }
      checkCryptoKey(key, keyUsage) {
        super.checkCryptoKey(key, keyUsage);
        const internalKey = getCryptoKey(key);
        if (!(internalKey instanceof RsaPrivateKey || internalKey instanceof RsaPublicKey)) {
          throw new TypeError("key: Is not RSA CryptoKey");
        }
      }
    };
    var RsaPssProvider = class extends core__namespace.RsaPssProvider {
      constructor() {
        super(...arguments);
        this.hashAlgorithms = [
          "SHA-1",
          "SHA-256",
          "SHA-384",
          "SHA-512",
          "shake128",
          "shake256",
          "SHA3-256",
          "SHA3-384",
          "SHA3-512"
        ];
      }
      async onGenerateKey(algorithm, extractable, keyUsages) {
        const keys = await RsaCrypto.generateKey({
          ...algorithm,
          name: this.name
        }, extractable, keyUsages);
        return {
          privateKey: setCryptoKey(keys.privateKey),
          publicKey: setCryptoKey(keys.publicKey)
        };
      }
      async onSign(algorithm, key, data) {
        return RsaCrypto.sign(algorithm, getCryptoKey(key), new Uint8Array(data));
      }
      async onVerify(algorithm, key, signature, data) {
        return RsaCrypto.verify(algorithm, getCryptoKey(key), new Uint8Array(signature), new Uint8Array(data));
      }
      async onExportKey(format3, key) {
        return RsaCrypto.exportKey(format3, getCryptoKey(key));
      }
      async onImportKey(format3, keyData, algorithm, extractable, keyUsages) {
        const key = await RsaCrypto.importKey(format3, keyData, { ...algorithm, name: this.name }, extractable, keyUsages);
        return setCryptoKey(key);
      }
      checkCryptoKey(key, keyUsage) {
        super.checkCryptoKey(key, keyUsage);
        const internalKey = getCryptoKey(key);
        if (!(internalKey instanceof RsaPrivateKey || internalKey instanceof RsaPublicKey)) {
          throw new TypeError("key: Is not RSA CryptoKey");
        }
      }
    };
    var ShaCrypto = class {
      static size(algorithm) {
        switch (algorithm.name.toUpperCase()) {
          case "SHA-1":
            return 160;
          case "SHA-256":
          case "SHA3-256":
            return 256;
          case "SHA-384":
          case "SHA3-384":
            return 384;
          case "SHA-512":
          case "SHA3-512":
            return 512;
          default:
            throw new Error("Unrecognized name");
        }
      }
      static getAlgorithmName(algorithm) {
        switch (algorithm.name.toUpperCase()) {
          case "SHA-1":
            return "sha1";
          case "SHA-256":
            return "sha256";
          case "SHA-384":
            return "sha384";
          case "SHA-512":
            return "sha512";
          case "SHA3-256":
            return "sha3-256";
          case "SHA3-384":
            return "sha3-384";
          case "SHA3-512":
            return "sha3-512";
          default:
            throw new Error("Unrecognized name");
        }
      }
      static digest(algorithm, data) {
        const hashAlg = this.getAlgorithmName(algorithm);
        const hash = crypto2.createHash(hashAlg).update(buffer.Buffer.from(data)).digest();
        return new Uint8Array(hash).buffer;
      }
    };
    var RsaOaepProvider = class extends core__namespace.RsaOaepProvider {
      async onGenerateKey(algorithm, extractable, keyUsages) {
        const keys = await RsaCrypto.generateKey({
          ...algorithm,
          name: this.name
        }, extractable, keyUsages);
        return {
          privateKey: setCryptoKey(keys.privateKey),
          publicKey: setCryptoKey(keys.publicKey)
        };
      }
      async onEncrypt(algorithm, key, data) {
        const internalKey = getCryptoKey(key);
        const dataView = new Uint8Array(data);
        const keySize = Math.ceil(internalKey.algorithm.modulusLength >> 3);
        const hashSize = ShaCrypto.size(internalKey.algorithm.hash) >> 3;
        const dataLength = dataView.byteLength;
        const psLength = keySize - dataLength - 2 * hashSize - 2;
        if (dataLength > keySize - 2 * hashSize - 2) {
          throw new Error("Data too large");
        }
        const message = new Uint8Array(keySize);
        const seed = message.subarray(1, hashSize + 1);
        const dataBlock = message.subarray(hashSize + 1);
        dataBlock.set(dataView, hashSize + psLength + 1);
        const labelHash = crypto2.createHash(internalKey.algorithm.hash.name.replace("-", "")).update(core__namespace.BufferSourceConverter.toUint8Array(algorithm.label || new Uint8Array(0))).digest();
        dataBlock.set(labelHash, 0);
        dataBlock[hashSize + psLength] = 1;
        crypto2.randomFillSync(seed);
        const dataBlockMask = this.mgf1(internalKey.algorithm.hash, seed, dataBlock.length);
        for (let i = 0; i < dataBlock.length; i++) {
          dataBlock[i] ^= dataBlockMask[i];
        }
        const seedMask = this.mgf1(internalKey.algorithm.hash, dataBlock, seed.length);
        for (let i = 0; i < seed.length; i++) {
          seed[i] ^= seedMask[i];
        }
        if (!internalKey.pem) {
          internalKey.pem = `-----BEGIN PUBLIC KEY-----
${internalKey.data.toString("base64")}
-----END PUBLIC KEY-----`;
        }
        const pkcs0 = crypto2.publicEncrypt({
          key: internalKey.pem,
          padding: crypto2.constants.RSA_NO_PADDING
        }, buffer.Buffer.from(message));
        return new Uint8Array(pkcs0).buffer;
      }
      async onDecrypt(algorithm, key, data) {
        const internalKey = getCryptoKey(key);
        const keySize = Math.ceil(internalKey.algorithm.modulusLength >> 3);
        const hashSize = ShaCrypto.size(internalKey.algorithm.hash) >> 3;
        const dataLength = data.byteLength;
        if (dataLength !== keySize) {
          throw new Error("Bad data");
        }
        if (!internalKey.pem) {
          internalKey.pem = `-----BEGIN PRIVATE KEY-----
${internalKey.data.toString("base64")}
-----END PRIVATE KEY-----`;
        }
        let pkcs0 = crypto2.privateDecrypt({
          key: internalKey.pem,
          padding: crypto2.constants.RSA_NO_PADDING
        }, buffer.Buffer.from(data));
        const z = pkcs0[0];
        const seed = pkcs0.subarray(1, hashSize + 1);
        const dataBlock = pkcs0.subarray(hashSize + 1);
        if (z !== 0) {
          throw new Error("Decryption failed");
        }
        const seedMask = this.mgf1(internalKey.algorithm.hash, dataBlock, seed.length);
        for (let i = 0; i < seed.length; i++) {
          seed[i] ^= seedMask[i];
        }
        const dataBlockMask = this.mgf1(internalKey.algorithm.hash, seed, dataBlock.length);
        for (let i = 0; i < dataBlock.length; i++) {
          dataBlock[i] ^= dataBlockMask[i];
        }
        const labelHash = crypto2.createHash(internalKey.algorithm.hash.name.replace("-", "")).update(core__namespace.BufferSourceConverter.toUint8Array(algorithm.label || new Uint8Array(0))).digest();
        for (let i = 0; i < hashSize; i++) {
          if (labelHash[i] !== dataBlock[i]) {
            throw new Error("Decryption failed");
          }
        }
        let psEnd = hashSize;
        for (; psEnd < dataBlock.length; psEnd++) {
          const psz = dataBlock[psEnd];
          if (psz === 1) {
            break;
          }
          if (psz !== 0) {
            throw new Error("Decryption failed");
          }
        }
        if (psEnd === dataBlock.length) {
          throw new Error("Decryption failed");
        }
        pkcs0 = dataBlock.subarray(psEnd + 1);
        return new Uint8Array(pkcs0).buffer;
      }
      async onExportKey(format3, key) {
        return RsaCrypto.exportKey(format3, getCryptoKey(key));
      }
      async onImportKey(format3, keyData, algorithm, extractable, keyUsages) {
        const key = await RsaCrypto.importKey(format3, keyData, { ...algorithm, name: this.name }, extractable, keyUsages);
        return setCryptoKey(key);
      }
      checkCryptoKey(key, keyUsage) {
        super.checkCryptoKey(key, keyUsage);
        const internalKey = getCryptoKey(key);
        if (!(internalKey instanceof RsaPrivateKey || internalKey instanceof RsaPublicKey)) {
          throw new TypeError("key: Is not RSA CryptoKey");
        }
      }
      mgf1(algorithm, seed, length = 0) {
        const hashSize = ShaCrypto.size(algorithm) >> 3;
        const mask = new Uint8Array(length);
        const counter = new Uint8Array(4);
        const chunks = Math.ceil(length / hashSize);
        for (let i = 0; i < chunks; i++) {
          counter[0] = i >>> 24;
          counter[1] = i >>> 16 & 255;
          counter[2] = i >>> 8 & 255;
          counter[3] = i & 255;
          const submask = mask.subarray(i * hashSize);
          let chunk = crypto2.createHash(algorithm.name.replace("-", "")).update(seed).update(counter).digest();
          if (chunk.length > submask.length) {
            chunk = chunk.subarray(0, submask.length);
          }
          submask.set(chunk);
        }
        return mask;
      }
    };
    var RsaEsProvider = class extends core__namespace.ProviderCrypto {
      constructor() {
        super(...arguments);
        this.name = "RSAES-PKCS1-v1_5";
        this.usages = {
          publicKey: ["encrypt", "wrapKey"],
          privateKey: ["decrypt", "unwrapKey"]
        };
      }
      async onGenerateKey(algorithm, extractable, keyUsages) {
        const keys = await RsaCrypto.generateKey({
          ...algorithm,
          name: this.name
        }, extractable, keyUsages);
        return {
          privateKey: setCryptoKey(keys.privateKey),
          publicKey: setCryptoKey(keys.publicKey)
        };
      }
      checkGenerateKeyParams(algorithm) {
        this.checkRequiredProperty(algorithm, "publicExponent");
        if (!(algorithm.publicExponent && algorithm.publicExponent instanceof Uint8Array)) {
          throw new TypeError("publicExponent: Missing or not a Uint8Array");
        }
        const publicExponent = pvtsutils.Convert.ToBase64(algorithm.publicExponent);
        if (!(publicExponent === "Aw==" || publicExponent === "AQAB")) {
          throw new TypeError("publicExponent: Must be [3] or [1,0,1]");
        }
        this.checkRequiredProperty(algorithm, "modulusLength");
        switch (algorithm.modulusLength) {
          case 1024:
          case 2048:
          case 4096:
            break;
          default:
            throw new TypeError("modulusLength: Must be 1024, 2048, or 4096");
        }
      }
      async onEncrypt(algorithm, key, data) {
        const options = this.toCryptoOptions(key);
        const enc = crypto__namespace.publicEncrypt(options, new Uint8Array(data));
        return new Uint8Array(enc).buffer;
      }
      async onDecrypt(algorithm, key, data) {
        const options = this.toCryptoOptions(key);
        const dec = crypto__namespace.privateDecrypt(options, new Uint8Array(data));
        return new Uint8Array(dec).buffer;
      }
      async onExportKey(format3, key) {
        return RsaCrypto.exportKey(format3, getCryptoKey(key));
      }
      async onImportKey(format3, keyData, algorithm, extractable, keyUsages) {
        const key = await RsaCrypto.importKey(format3, keyData, { ...algorithm, name: this.name }, extractable, keyUsages);
        return setCryptoKey(key);
      }
      checkCryptoKey(key, keyUsage) {
        super.checkCryptoKey(key, keyUsage);
        const internalKey = getCryptoKey(key);
        if (!(internalKey instanceof RsaPrivateKey || internalKey instanceof RsaPublicKey)) {
          throw new TypeError("key: Is not RSA CryptoKey");
        }
      }
      toCryptoOptions(key) {
        const type = key.type.toUpperCase();
        return {
          key: `-----BEGIN ${type} KEY-----
${getCryptoKey(key).data.toString("base64")}
-----END ${type} KEY-----`,
          padding: crypto__namespace.constants.RSA_PKCS1_PADDING
        };
      }
    };
    var namedOIDs = {
      "1.2.840.10045.3.1.7": "P-256",
      "P-256": "1.2.840.10045.3.1.7",
      "1.3.132.0.34": "P-384",
      "P-384": "1.3.132.0.34",
      "1.3.132.0.35": "P-521",
      "P-521": "1.3.132.0.35",
      "1.3.132.0.10": "K-256",
      "K-256": "1.3.132.0.10",
      "brainpoolP160r1": "1.3.36.3.3.2.8.1.1.1",
      "1.3.36.3.3.2.8.1.1.1": "brainpoolP160r1",
      "brainpoolP160t1": "1.3.36.3.3.2.8.1.1.2",
      "1.3.36.3.3.2.8.1.1.2": "brainpoolP160t1",
      "brainpoolP192r1": "1.3.36.3.3.2.8.1.1.3",
      "1.3.36.3.3.2.8.1.1.3": "brainpoolP192r1",
      "brainpoolP192t1": "1.3.36.3.3.2.8.1.1.4",
      "1.3.36.3.3.2.8.1.1.4": "brainpoolP192t1",
      "brainpoolP224r1": "1.3.36.3.3.2.8.1.1.5",
      "1.3.36.3.3.2.8.1.1.5": "brainpoolP224r1",
      "brainpoolP224t1": "1.3.36.3.3.2.8.1.1.6",
      "1.3.36.3.3.2.8.1.1.6": "brainpoolP224t1",
      "brainpoolP256r1": "1.3.36.3.3.2.8.1.1.7",
      "1.3.36.3.3.2.8.1.1.7": "brainpoolP256r1",
      "brainpoolP256t1": "1.3.36.3.3.2.8.1.1.8",
      "1.3.36.3.3.2.8.1.1.8": "brainpoolP256t1",
      "brainpoolP320r1": "1.3.36.3.3.2.8.1.1.9",
      "1.3.36.3.3.2.8.1.1.9": "brainpoolP320r1",
      "brainpoolP320t1": "1.3.36.3.3.2.8.1.1.10",
      "1.3.36.3.3.2.8.1.1.10": "brainpoolP320t1",
      "brainpoolP384r1": "1.3.36.3.3.2.8.1.1.11",
      "1.3.36.3.3.2.8.1.1.11": "brainpoolP384r1",
      "brainpoolP384t1": "1.3.36.3.3.2.8.1.1.12",
      "1.3.36.3.3.2.8.1.1.12": "brainpoolP384t1",
      "brainpoolP512r1": "1.3.36.3.3.2.8.1.1.13",
      "1.3.36.3.3.2.8.1.1.13": "brainpoolP512r1",
      "brainpoolP512t1": "1.3.36.3.3.2.8.1.1.14",
      "1.3.36.3.3.2.8.1.1.14": "brainpoolP512t1"
    };
    function getOidByNamedCurve$1(namedCurve) {
      const oid = namedOIDs[namedCurve];
      if (!oid) {
        throw new core__namespace.OperationError(`Cannot convert WebCrypto named curve '${namedCurve}' to OID`);
      }
      return oid;
    }
    var EcPrivateKey = class extends AsymmetricKey {
      constructor() {
        super(...arguments);
        this.type = "private";
      }
      getKey() {
        const keyInfo = asn1Schema.AsnParser.parse(this.data, core__namespace.asn1.PrivateKeyInfo);
        return asn1Schema.AsnParser.parse(keyInfo.privateKey, core__namespace.asn1.EcPrivateKey);
      }
      toJSON() {
        const key = this.getKey();
        const json3 = {
          kty: "EC",
          crv: this.algorithm.namedCurve,
          key_ops: this.usages,
          ext: this.extractable
        };
        return Object.assign(json3, jsonSchema.JsonSerializer.toJSON(key));
      }
      fromJSON(json3) {
        if (!json3.crv) {
          throw new core__namespace.OperationError(`Cannot get named curve from JWK. Property 'crv' is required`);
        }
        const keyInfo = new core__namespace.asn1.PrivateKeyInfo();
        keyInfo.privateKeyAlgorithm.algorithm = "1.2.840.10045.2.1";
        keyInfo.privateKeyAlgorithm.parameters = asn1Schema.AsnSerializer.serialize(new core__namespace.asn1.ObjectIdentifier(getOidByNamedCurve$1(json3.crv)));
        const key = jsonSchema.JsonParser.fromJSON(json3, { targetSchema: core__namespace.asn1.EcPrivateKey });
        keyInfo.privateKey = asn1Schema.AsnSerializer.serialize(key);
        this.data = buffer.Buffer.from(asn1Schema.AsnSerializer.serialize(keyInfo));
        return this;
      }
    };
    var EcPublicKey = class extends AsymmetricKey {
      constructor() {
        super(...arguments);
        this.type = "public";
      }
      getKey() {
        const keyInfo = asn1Schema.AsnParser.parse(this.data, core__namespace.asn1.PublicKeyInfo);
        return new core__namespace.asn1.EcPublicKey(keyInfo.publicKey);
      }
      toJSON() {
        const key = this.getKey();
        const json3 = {
          kty: "EC",
          crv: this.algorithm.namedCurve,
          key_ops: this.usages,
          ext: this.extractable
        };
        return Object.assign(json3, jsonSchema.JsonSerializer.toJSON(key));
      }
      fromJSON(json3) {
        if (!json3.crv) {
          throw new core__namespace.OperationError(`Cannot get named curve from JWK. Property 'crv' is required`);
        }
        const key = jsonSchema.JsonParser.fromJSON(json3, { targetSchema: core__namespace.asn1.EcPublicKey });
        const keyInfo = new core__namespace.asn1.PublicKeyInfo();
        keyInfo.publicKeyAlgorithm.algorithm = "1.2.840.10045.2.1";
        keyInfo.publicKeyAlgorithm.parameters = asn1Schema.AsnSerializer.serialize(new core__namespace.asn1.ObjectIdentifier(getOidByNamedCurve$1(json3.crv)));
        keyInfo.publicKey = asn1Schema.AsnSerializer.toASN(key).valueHex;
        this.data = buffer.Buffer.from(asn1Schema.AsnSerializer.serialize(keyInfo));
        return this;
      }
    };
    var Sha1Provider = class extends core__namespace.ProviderCrypto {
      constructor() {
        super(...arguments);
        this.name = "SHA-1";
        this.usages = [];
      }
      async onDigest(algorithm, data) {
        return ShaCrypto.digest(algorithm, data);
      }
    };
    var Sha256Provider = class extends core__namespace.ProviderCrypto {
      constructor() {
        super(...arguments);
        this.name = "SHA-256";
        this.usages = [];
      }
      async onDigest(algorithm, data) {
        return ShaCrypto.digest(algorithm, data);
      }
    };
    var Sha384Provider = class extends core__namespace.ProviderCrypto {
      constructor() {
        super(...arguments);
        this.name = "SHA-384";
        this.usages = [];
      }
      async onDigest(algorithm, data) {
        return ShaCrypto.digest(algorithm, data);
      }
    };
    var Sha512Provider = class extends core__namespace.ProviderCrypto {
      constructor() {
        super(...arguments);
        this.name = "SHA-512";
        this.usages = [];
      }
      async onDigest(algorithm, data) {
        return ShaCrypto.digest(algorithm, data);
      }
    };
    var Sha3256Provider = class extends core__namespace.ProviderCrypto {
      constructor() {
        super(...arguments);
        this.name = "SHA3-256";
        this.usages = [];
      }
      async onDigest(algorithm, data) {
        return ShaCrypto.digest(algorithm, data);
      }
    };
    var Sha3384Provider = class extends core__namespace.ProviderCrypto {
      constructor() {
        super(...arguments);
        this.name = "SHA3-384";
        this.usages = [];
      }
      async onDigest(algorithm, data) {
        return ShaCrypto.digest(algorithm, data);
      }
    };
    var Sha3512Provider = class extends core__namespace.ProviderCrypto {
      constructor() {
        super(...arguments);
        this.name = "SHA3-512";
        this.usages = [];
      }
      async onDigest(algorithm, data) {
        return ShaCrypto.digest(algorithm, data);
      }
    };
    var EcCrypto = class {
      static async generateKey(algorithm, extractable, keyUsages) {
        const privateKey = new EcPrivateKey();
        privateKey.algorithm = algorithm;
        privateKey.extractable = extractable;
        privateKey.usages = keyUsages.filter((usage) => this.privateKeyUsages.indexOf(usage) !== -1);
        const publicKey = new EcPublicKey();
        publicKey.algorithm = algorithm;
        publicKey.extractable = true;
        publicKey.usages = keyUsages.filter((usage) => this.publicKeyUsages.indexOf(usage) !== -1);
        const keys = crypto2.generateKeyPairSync("ec", {
          namedCurve: this.getOpenSSLNamedCurve(algorithm.namedCurve),
          publicKeyEncoding: {
            format: "der",
            type: "spki"
          },
          privateKeyEncoding: {
            format: "der",
            type: "pkcs8"
          }
        });
        privateKey.data = keys.privateKey;
        publicKey.data = keys.publicKey;
        const res = {
          privateKey,
          publicKey
        };
        return res;
      }
      static async sign(algorithm, key, data) {
        const cryptoAlg = ShaCrypto.getAlgorithmName(algorithm.hash);
        const signer = crypto2.createSign(cryptoAlg);
        signer.update(buffer.Buffer.from(data));
        if (!key.pem) {
          key.pem = `-----BEGIN PRIVATE KEY-----
${key.data.toString("base64")}
-----END PRIVATE KEY-----`;
        }
        const options = {
          key: key.pem
        };
        const signature = signer.sign(options);
        const ecSignature = asn1Schema.AsnParser.parse(signature, core__namespace.asn1.EcDsaSignature);
        const signatureRaw = core__namespace.EcUtils.encodeSignature(ecSignature, core__namespace.EcCurves.get(key.algorithm.namedCurve).size);
        return signatureRaw.buffer;
      }
      static async verify(algorithm, key, signature, data) {
        const cryptoAlg = ShaCrypto.getAlgorithmName(algorithm.hash);
        const signer = crypto2.createVerify(cryptoAlg);
        signer.update(buffer.Buffer.from(data));
        if (!key.pem) {
          key.pem = `-----BEGIN PUBLIC KEY-----
${key.data.toString("base64")}
-----END PUBLIC KEY-----`;
        }
        const options = {
          key: key.pem
        };
        const ecSignature = new core__namespace.asn1.EcDsaSignature();
        const namedCurve = core__namespace.EcCurves.get(key.algorithm.namedCurve);
        const signaturePoint = core__namespace.EcUtils.decodeSignature(signature, namedCurve.size);
        ecSignature.r = pvtsutils.BufferSourceConverter.toArrayBuffer(signaturePoint.r);
        ecSignature.s = pvtsutils.BufferSourceConverter.toArrayBuffer(signaturePoint.s);
        const ecSignatureRaw = buffer.Buffer.from(asn1Schema.AsnSerializer.serialize(ecSignature));
        const ok = signer.verify(options, ecSignatureRaw);
        return ok;
      }
      static async deriveBits(algorithm, baseKey, length) {
        const cryptoAlg = this.getOpenSSLNamedCurve(baseKey.algorithm.namedCurve);
        const ecdh = crypto2.createECDH(cryptoAlg);
        const asnPrivateKey = asn1Schema.AsnParser.parse(baseKey.data, core__namespace.asn1.PrivateKeyInfo);
        const asnEcPrivateKey = asn1Schema.AsnParser.parse(asnPrivateKey.privateKey, core__namespace.asn1.EcPrivateKey);
        ecdh.setPrivateKey(buffer.Buffer.from(asnEcPrivateKey.privateKey));
        const asnPublicKey = asn1Schema.AsnParser.parse(algorithm.public.data, core__namespace.asn1.PublicKeyInfo);
        const bits = ecdh.computeSecret(buffer.Buffer.from(asnPublicKey.publicKey));
        if (length === null) {
          return bits;
        }
        return new Uint8Array(bits).buffer.slice(0, length >> 3);
      }
      static async exportKey(format3, key) {
        switch (format3.toLowerCase()) {
          case "jwk":
            return jsonSchema.JsonSerializer.toJSON(key);
          case "pkcs8":
          case "spki":
            return new Uint8Array(key.data).buffer;
          case "raw": {
            const publicKeyInfo = asn1Schema.AsnParser.parse(key.data, core__namespace.asn1.PublicKeyInfo);
            return publicKeyInfo.publicKey;
          }
          default:
            throw new core__namespace.OperationError("format: Must be 'jwk', 'raw', pkcs8' or 'spki'");
        }
      }
      static async importKey(format3, keyData, algorithm, extractable, keyUsages) {
        switch (format3.toLowerCase()) {
          case "jwk": {
            const jwk = keyData;
            if (jwk.d) {
              const asnKey = jsonSchema.JsonParser.fromJSON(keyData, { targetSchema: core__namespace.asn1.EcPrivateKey });
              return this.importPrivateKey(asnKey, algorithm, extractable, keyUsages);
            } else {
              const asnKey = jsonSchema.JsonParser.fromJSON(keyData, { targetSchema: core__namespace.asn1.EcPublicKey });
              return this.importPublicKey(asnKey, algorithm, extractable, keyUsages);
            }
          }
          case "raw": {
            const asnKey = new core__namespace.asn1.EcPublicKey(keyData);
            return this.importPublicKey(asnKey, algorithm, extractable, keyUsages);
          }
          case "spki": {
            const keyInfo = asn1Schema.AsnParser.parse(new Uint8Array(keyData), core__namespace.asn1.PublicKeyInfo);
            const asnKey = new core__namespace.asn1.EcPublicKey(keyInfo.publicKey);
            this.assertKeyParameters(keyInfo.publicKeyAlgorithm.parameters, algorithm.namedCurve);
            return this.importPublicKey(asnKey, algorithm, extractable, keyUsages);
          }
          case "pkcs8": {
            const keyInfo = asn1Schema.AsnParser.parse(new Uint8Array(keyData), core__namespace.asn1.PrivateKeyInfo);
            const asnKey = asn1Schema.AsnParser.parse(keyInfo.privateKey, core__namespace.asn1.EcPrivateKey);
            this.assertKeyParameters(keyInfo.privateKeyAlgorithm.parameters, algorithm.namedCurve);
            return this.importPrivateKey(asnKey, algorithm, extractable, keyUsages);
          }
          default:
            throw new core__namespace.OperationError("format: Must be 'jwk', 'raw', 'pkcs8' or 'spki'");
        }
      }
      static assertKeyParameters(parameters, namedCurve) {
        if (!parameters) {
          throw new core__namespace.CryptoError("Key info doesn't have required parameters");
        }
        let namedCurveIdentifier = "";
        try {
          namedCurveIdentifier = asn1Schema.AsnParser.parse(parameters, core__namespace.asn1.ObjectIdentifier).value;
        } catch (e) {
          throw new core__namespace.CryptoError("Cannot read key info parameters");
        }
        if (getOidByNamedCurve$1(namedCurve) !== namedCurveIdentifier) {
          throw new core__namespace.CryptoError("Key info parameter doesn't match to named curve");
        }
      }
      static async importPrivateKey(asnKey, algorithm, extractable, keyUsages) {
        const keyInfo = new core__namespace.asn1.PrivateKeyInfo();
        keyInfo.privateKeyAlgorithm.algorithm = "1.2.840.10045.2.1";
        keyInfo.privateKeyAlgorithm.parameters = asn1Schema.AsnSerializer.serialize(new core__namespace.asn1.ObjectIdentifier(getOidByNamedCurve$1(algorithm.namedCurve)));
        keyInfo.privateKey = asn1Schema.AsnSerializer.serialize(asnKey);
        const key = new EcPrivateKey();
        key.data = buffer.Buffer.from(asn1Schema.AsnSerializer.serialize(keyInfo));
        key.algorithm = Object.assign({}, algorithm);
        key.extractable = extractable;
        key.usages = keyUsages;
        return key;
      }
      static async importPublicKey(asnKey, algorithm, extractable, keyUsages) {
        const keyInfo = new core__namespace.asn1.PublicKeyInfo();
        keyInfo.publicKeyAlgorithm.algorithm = "1.2.840.10045.2.1";
        const namedCurve = getOidByNamedCurve$1(algorithm.namedCurve);
        keyInfo.publicKeyAlgorithm.parameters = asn1Schema.AsnSerializer.serialize(new core__namespace.asn1.ObjectIdentifier(namedCurve));
        keyInfo.publicKey = asnKey.value;
        const key = new EcPublicKey();
        key.data = buffer.Buffer.from(asn1Schema.AsnSerializer.serialize(keyInfo));
        key.algorithm = Object.assign({}, algorithm);
        key.extractable = extractable;
        key.usages = keyUsages;
        return key;
      }
      static getOpenSSLNamedCurve(curve) {
        switch (curve.toUpperCase()) {
          case "P-256":
            return "prime256v1";
          case "K-256":
            return "secp256k1";
          case "P-384":
            return "secp384r1";
          case "P-521":
            return "secp521r1";
          default:
            return curve;
        }
      }
    };
    EcCrypto.publicKeyUsages = ["verify"];
    EcCrypto.privateKeyUsages = ["sign", "deriveKey", "deriveBits"];
    var EcdsaProvider = class extends core__namespace.EcdsaProvider {
      constructor() {
        super(...arguments);
        this.namedCurves = core__namespace.EcCurves.names;
        this.hashAlgorithms = [
          "SHA-1",
          "SHA-256",
          "SHA-384",
          "SHA-512",
          "shake128",
          "shake256",
          "SHA3-256",
          "SHA3-384",
          "SHA3-512"
        ];
      }
      async onGenerateKey(algorithm, extractable, keyUsages) {
        const keys = await EcCrypto.generateKey({
          ...algorithm,
          name: this.name
        }, extractable, keyUsages);
        return {
          privateKey: setCryptoKey(keys.privateKey),
          publicKey: setCryptoKey(keys.publicKey)
        };
      }
      async onSign(algorithm, key, data) {
        return EcCrypto.sign(algorithm, getCryptoKey(key), new Uint8Array(data));
      }
      async onVerify(algorithm, key, signature, data) {
        return EcCrypto.verify(algorithm, getCryptoKey(key), new Uint8Array(signature), new Uint8Array(data));
      }
      async onExportKey(format3, key) {
        return EcCrypto.exportKey(format3, getCryptoKey(key));
      }
      async onImportKey(format3, keyData, algorithm, extractable, keyUsages) {
        const key = await EcCrypto.importKey(format3, keyData, { ...algorithm, name: this.name }, extractable, keyUsages);
        return setCryptoKey(key);
      }
      checkCryptoKey(key, keyUsage) {
        super.checkCryptoKey(key, keyUsage);
        const internalKey = getCryptoKey(key);
        if (!(internalKey instanceof EcPrivateKey || internalKey instanceof EcPublicKey)) {
          throw new TypeError("key: Is not EC CryptoKey");
        }
      }
    };
    var EcdhProvider = class extends core__namespace.EcdhProvider {
      constructor() {
        super(...arguments);
        this.namedCurves = core__namespace.EcCurves.names;
      }
      async onGenerateKey(algorithm, extractable, keyUsages) {
        const keys = await EcCrypto.generateKey({
          ...algorithm,
          name: this.name
        }, extractable, keyUsages);
        return {
          privateKey: setCryptoKey(keys.privateKey),
          publicKey: setCryptoKey(keys.publicKey)
        };
      }
      async onExportKey(format3, key) {
        return EcCrypto.exportKey(format3, getCryptoKey(key));
      }
      async onImportKey(format3, keyData, algorithm, extractable, keyUsages) {
        const key = await EcCrypto.importKey(format3, keyData, { ...algorithm, name: this.name }, extractable, keyUsages);
        return setCryptoKey(key);
      }
      checkCryptoKey(key, keyUsage) {
        super.checkCryptoKey(key, keyUsage);
        const internalKey = getCryptoKey(key);
        if (!(internalKey instanceof EcPrivateKey || internalKey instanceof EcPublicKey)) {
          throw new TypeError("key: Is not EC CryptoKey");
        }
      }
      async onDeriveBits(algorithm, baseKey, length) {
        const bits = await EcCrypto.deriveBits({ ...algorithm, public: getCryptoKey(algorithm.public) }, getCryptoKey(baseKey), length);
        return bits;
      }
    };
    var edOIDs = {
      [core__namespace.asn1.idEd448]: "Ed448",
      "ed448": core__namespace.asn1.idEd448,
      [core__namespace.asn1.idX448]: "X448",
      "x448": core__namespace.asn1.idX448,
      [core__namespace.asn1.idEd25519]: "Ed25519",
      "ed25519": core__namespace.asn1.idEd25519,
      [core__namespace.asn1.idX25519]: "X25519",
      "x25519": core__namespace.asn1.idX25519
    };
    function getOidByNamedCurve(namedCurve) {
      const oid = edOIDs[namedCurve.toLowerCase()];
      if (!oid) {
        throw new core__namespace.OperationError(`Cannot convert WebCrypto named curve '${namedCurve}' to OID`);
      }
      return oid;
    }
    var EdPrivateKey = class extends AsymmetricKey {
      constructor() {
        super(...arguments);
        this.type = "private";
      }
      getKey() {
        const keyInfo = asn1Schema.AsnParser.parse(this.data, core__namespace.asn1.PrivateKeyInfo);
        return asn1Schema.AsnParser.parse(keyInfo.privateKey, core__namespace.asn1.CurvePrivateKey);
      }
      toJSON() {
        const key = this.getKey();
        const json3 = {
          kty: "OKP",
          crv: this.algorithm.namedCurve,
          key_ops: this.usages,
          ext: this.extractable
        };
        return Object.assign(json3, jsonSchema.JsonSerializer.toJSON(key));
      }
      fromJSON(json3) {
        if (!json3.crv) {
          throw new core__namespace.OperationError(`Cannot get named curve from JWK. Property 'crv' is required`);
        }
        const keyInfo = new core__namespace.asn1.PrivateKeyInfo();
        keyInfo.privateKeyAlgorithm.algorithm = getOidByNamedCurve(json3.crv);
        const key = jsonSchema.JsonParser.fromJSON(json3, { targetSchema: core__namespace.asn1.CurvePrivateKey });
        keyInfo.privateKey = asn1Schema.AsnSerializer.serialize(key);
        this.data = buffer.Buffer.from(asn1Schema.AsnSerializer.serialize(keyInfo));
        return this;
      }
    };
    var EdPublicKey = class extends AsymmetricKey {
      constructor() {
        super(...arguments);
        this.type = "public";
      }
      getKey() {
        const keyInfo = asn1Schema.AsnParser.parse(this.data, core__namespace.asn1.PublicKeyInfo);
        return keyInfo.publicKey;
      }
      toJSON() {
        const key = this.getKey();
        const json3 = {
          kty: "OKP",
          crv: this.algorithm.namedCurve,
          key_ops: this.usages,
          ext: this.extractable
        };
        return Object.assign(json3, {
          x: pvtsutils.Convert.ToBase64Url(key)
        });
      }
      fromJSON(json3) {
        if (!json3.crv) {
          throw new core__namespace.OperationError(`Cannot get named curve from JWK. Property 'crv' is required`);
        }
        if (!json3.x) {
          throw new core__namespace.OperationError(`Cannot get property from JWK. Property 'x' is required`);
        }
        const keyInfo = new core__namespace.asn1.PublicKeyInfo();
        keyInfo.publicKeyAlgorithm.algorithm = getOidByNamedCurve(json3.crv);
        keyInfo.publicKey = pvtsutils.Convert.FromBase64Url(json3.x);
        this.data = buffer.Buffer.from(asn1Schema.AsnSerializer.serialize(keyInfo));
        return this;
      }
    };
    var EdCrypto = class {
      static async generateKey(algorithm, extractable, keyUsages) {
        const privateKey = new EdPrivateKey();
        privateKey.algorithm = algorithm;
        privateKey.extractable = extractable;
        privateKey.usages = keyUsages.filter((usage) => this.privateKeyUsages.indexOf(usage) !== -1);
        const publicKey = new EdPublicKey();
        publicKey.algorithm = algorithm;
        publicKey.extractable = true;
        publicKey.usages = keyUsages.filter((usage) => this.publicKeyUsages.indexOf(usage) !== -1);
        const type = algorithm.namedCurve.toLowerCase();
        const keys = crypto2.generateKeyPairSync(type, {
          publicKeyEncoding: {
            format: "der",
            type: "spki"
          },
          privateKeyEncoding: {
            format: "der",
            type: "pkcs8"
          }
        });
        privateKey.data = keys.privateKey;
        publicKey.data = keys.publicKey;
        const res = {
          privateKey,
          publicKey
        };
        return res;
      }
      static async sign(algorithm, key, data) {
        if (!key.pem) {
          key.pem = `-----BEGIN PRIVATE KEY-----
${key.data.toString("base64")}
-----END PRIVATE KEY-----`;
        }
        const options = {
          key: key.pem
        };
        const signature = crypto2.sign(null, buffer.Buffer.from(data), options);
        return core__namespace.BufferSourceConverter.toArrayBuffer(signature);
      }
      static async verify(algorithm, key, signature, data) {
        if (!key.pem) {
          key.pem = `-----BEGIN PUBLIC KEY-----
${key.data.toString("base64")}
-----END PUBLIC KEY-----`;
        }
        const options = {
          key: key.pem
        };
        const ok = crypto2.verify(null, buffer.Buffer.from(data), options, buffer.Buffer.from(signature));
        return ok;
      }
      static async deriveBits(algorithm, baseKey, length) {
        const publicKey = crypto2.createPublicKey({
          key: algorithm.public.data,
          format: "der",
          type: "spki"
        });
        const privateKey = crypto2.createPrivateKey({
          key: baseKey.data,
          format: "der",
          type: "pkcs8"
        });
        const bits = crypto2.diffieHellman({
          publicKey,
          privateKey
        });
        return new Uint8Array(bits).buffer.slice(0, length >> 3);
      }
      static async exportKey(format3, key) {
        switch (format3.toLowerCase()) {
          case "jwk":
            return jsonSchema.JsonSerializer.toJSON(key);
          case "pkcs8":
          case "spki":
            return new Uint8Array(key.data).buffer;
          case "raw": {
            const publicKeyInfo = asn1Schema.AsnParser.parse(key.data, core__namespace.asn1.PublicKeyInfo);
            return publicKeyInfo.publicKey;
          }
          default:
            throw new core__namespace.OperationError("format: Must be 'jwk', 'raw', pkcs8' or 'spki'");
        }
      }
      static async importKey(format3, keyData, algorithm, extractable, keyUsages) {
        switch (format3.toLowerCase()) {
          case "jwk": {
            const jwk = keyData;
            if (jwk.d) {
              const asnKey = jsonSchema.JsonParser.fromJSON(keyData, { targetSchema: core__namespace.asn1.CurvePrivateKey });
              return this.importPrivateKey(asnKey, algorithm, extractable, keyUsages);
            } else {
              if (!jwk.x) {
                throw new TypeError("keyData: Cannot get required 'x' filed");
              }
              return this.importPublicKey(pvtsutils.Convert.FromBase64Url(jwk.x), algorithm, extractable, keyUsages);
            }
          }
          case "raw": {
            return this.importPublicKey(keyData, algorithm, extractable, keyUsages);
          }
          case "spki": {
            const keyInfo = asn1Schema.AsnParser.parse(new Uint8Array(keyData), core__namespace.asn1.PublicKeyInfo);
            return this.importPublicKey(keyInfo.publicKey, algorithm, extractable, keyUsages);
          }
          case "pkcs8": {
            const keyInfo = asn1Schema.AsnParser.parse(new Uint8Array(keyData), core__namespace.asn1.PrivateKeyInfo);
            const asnKey = asn1Schema.AsnParser.parse(keyInfo.privateKey, core__namespace.asn1.CurvePrivateKey);
            return this.importPrivateKey(asnKey, algorithm, extractable, keyUsages);
          }
          default:
            throw new core__namespace.OperationError("format: Must be 'jwk', 'raw', 'pkcs8' or 'spki'");
        }
      }
      static importPrivateKey(asnKey, algorithm, extractable, keyUsages) {
        const key = new EdPrivateKey();
        key.fromJSON({
          crv: algorithm.namedCurve,
          d: pvtsutils.Convert.ToBase64Url(asnKey.d)
        });
        key.algorithm = Object.assign({}, algorithm);
        key.extractable = extractable;
        key.usages = keyUsages;
        return key;
      }
      static async importPublicKey(asnKey, algorithm, extractable, keyUsages) {
        const key = new EdPublicKey();
        key.fromJSON({
          crv: algorithm.namedCurve,
          x: pvtsutils.Convert.ToBase64Url(asnKey)
        });
        key.algorithm = Object.assign({}, algorithm);
        key.extractable = extractable;
        key.usages = keyUsages;
        return key;
      }
    };
    EdCrypto.publicKeyUsages = ["verify"];
    EdCrypto.privateKeyUsages = ["sign", "deriveKey", "deriveBits"];
    var EdDsaProvider = class extends core__namespace.EdDsaProvider {
      async onGenerateKey(algorithm, extractable, keyUsages) {
        const keys = await EdCrypto.generateKey({
          name: this.name,
          namedCurve: algorithm.namedCurve.replace(/^ed/i, "Ed")
        }, extractable, keyUsages);
        return {
          privateKey: setCryptoKey(keys.privateKey),
          publicKey: setCryptoKey(keys.publicKey)
        };
      }
      async onSign(algorithm, key, data) {
        return EdCrypto.sign(algorithm, getCryptoKey(key), new Uint8Array(data));
      }
      async onVerify(algorithm, key, signature, data) {
        return EdCrypto.verify(algorithm, getCryptoKey(key), new Uint8Array(signature), new Uint8Array(data));
      }
      async onExportKey(format3, key) {
        return EdCrypto.exportKey(format3, getCryptoKey(key));
      }
      async onImportKey(format3, keyData, algorithm, extractable, keyUsages) {
        const key = await EdCrypto.importKey(format3, keyData, { ...algorithm, name: this.name }, extractable, keyUsages);
        return setCryptoKey(key);
      }
    };
    var EcdhEsProvider = class extends core__namespace.EcdhEsProvider {
      async onGenerateKey(algorithm, extractable, keyUsages) {
        const keys = await EdCrypto.generateKey({
          name: this.name,
          namedCurve: algorithm.namedCurve.toUpperCase()
        }, extractable, keyUsages);
        return {
          privateKey: setCryptoKey(keys.privateKey),
          publicKey: setCryptoKey(keys.publicKey)
        };
      }
      async onDeriveBits(algorithm, baseKey, length) {
        const bits = await EdCrypto.deriveBits({ ...algorithm, public: getCryptoKey(algorithm.public) }, getCryptoKey(baseKey), length);
        return bits;
      }
      async onExportKey(format3, key) {
        return EdCrypto.exportKey(format3, getCryptoKey(key));
      }
      async onImportKey(format3, keyData, algorithm, extractable, keyUsages) {
        const key = await EdCrypto.importKey(format3, keyData, { ...algorithm, name: this.name }, extractable, keyUsages);
        return setCryptoKey(key);
      }
    };
    var PbkdfCryptoKey = class extends CryptoKey {
    };
    var Pbkdf2Provider = class extends core__namespace.Pbkdf2Provider {
      async onDeriveBits(algorithm, baseKey, length) {
        return new Promise((resolve2, reject) => {
          const salt = core__namespace.BufferSourceConverter.toArrayBuffer(algorithm.salt);
          const hash = algorithm.hash.name.replace("-", "");
          crypto2.pbkdf2(getCryptoKey(baseKey).data, buffer.Buffer.from(salt), algorithm.iterations, length >> 3, hash, (err, derivedBits) => {
            if (err) {
              reject(err);
            } else {
              resolve2(new Uint8Array(derivedBits).buffer);
            }
          });
        });
      }
      async onImportKey(format3, keyData, algorithm, extractable, keyUsages) {
        if (format3 === "raw") {
          const key = new PbkdfCryptoKey();
          key.data = buffer.Buffer.from(keyData);
          key.algorithm = { name: this.name };
          key.extractable = false;
          key.usages = keyUsages;
          return setCryptoKey(key);
        }
        throw new core__namespace.OperationError("format: Must be 'raw'");
      }
      checkCryptoKey(key, keyUsage) {
        super.checkCryptoKey(key, keyUsage);
        if (!(getCryptoKey(key) instanceof PbkdfCryptoKey)) {
          throw new TypeError("key: Is not PBKDF CryptoKey");
        }
      }
    };
    var HmacCryptoKey = class extends CryptoKey {
      get alg() {
        const hash = this.algorithm.hash.name.toUpperCase();
        return `HS${hash.replace("SHA-", "")}`;
      }
      set alg(value) {
      }
    };
    tslib.__decorate([
      jsonSchema.JsonProp({ name: "k", converter: JsonBase64UrlConverter })
    ], HmacCryptoKey.prototype, "data", void 0);
    var HmacProvider = class extends core__namespace.HmacProvider {
      async onGenerateKey(algorithm, extractable, keyUsages) {
        const length = (algorithm.length || this.getDefaultLength(algorithm.hash.name)) >> 3 << 3;
        const key = new HmacCryptoKey();
        key.algorithm = {
          ...algorithm,
          length,
          name: this.name
        };
        key.extractable = extractable;
        key.usages = keyUsages;
        key.data = crypto2.randomBytes(length >> 3);
        return setCryptoKey(key);
      }
      async onSign(algorithm, key, data) {
        const cryptoAlg = ShaCrypto.getAlgorithmName(key.algorithm.hash);
        const hmac = crypto2.createHmac(cryptoAlg, getCryptoKey(key).data).update(buffer.Buffer.from(data)).digest();
        return new Uint8Array(hmac).buffer;
      }
      async onVerify(algorithm, key, signature, data) {
        const cryptoAlg = ShaCrypto.getAlgorithmName(key.algorithm.hash);
        const hmac = crypto2.createHmac(cryptoAlg, getCryptoKey(key).data).update(buffer.Buffer.from(data)).digest();
        return hmac.compare(buffer.Buffer.from(signature)) === 0;
      }
      async onImportKey(format3, keyData, algorithm, extractable, keyUsages) {
        let key;
        switch (format3.toLowerCase()) {
          case "jwk":
            key = jsonSchema.JsonParser.fromJSON(keyData, { targetSchema: HmacCryptoKey });
            break;
          case "raw":
            key = new HmacCryptoKey();
            key.data = buffer.Buffer.from(keyData);
            break;
          default:
            throw new core__namespace.OperationError("format: Must be 'jwk' or 'raw'");
        }
        key.algorithm = {
          hash: { name: algorithm.hash.name },
          name: this.name,
          length: key.data.length << 3
        };
        key.extractable = extractable;
        key.usages = keyUsages;
        return setCryptoKey(key);
      }
      async onExportKey(format3, key) {
        switch (format3.toLowerCase()) {
          case "jwk":
            return jsonSchema.JsonSerializer.toJSON(getCryptoKey(key));
          case "raw":
            return new Uint8Array(getCryptoKey(key).data).buffer;
          default:
            throw new core__namespace.OperationError("format: Must be 'jwk' or 'raw'");
        }
      }
      checkCryptoKey(key, keyUsage) {
        super.checkCryptoKey(key, keyUsage);
        if (!(getCryptoKey(key) instanceof HmacCryptoKey)) {
          throw new TypeError("key: Is not HMAC CryptoKey");
        }
      }
    };
    var HkdfCryptoKey = class extends CryptoKey {
    };
    var HkdfProvider = class extends core__namespace.HkdfProvider {
      async onImportKey(format3, keyData, algorithm, extractable, keyUsages) {
        if (format3.toLowerCase() !== "raw") {
          throw new core__namespace.OperationError("Operation not supported");
        }
        const key = new HkdfCryptoKey();
        key.data = buffer.Buffer.from(keyData);
        key.algorithm = { name: this.name };
        key.extractable = extractable;
        key.usages = keyUsages;
        return setCryptoKey(key);
      }
      async onDeriveBits(params, baseKey, length) {
        const hash = params.hash.name.replace("-", "");
        const hashLength = crypto2.createHash(hash).digest().length;
        const byteLength = length / 8;
        const info = core.BufferSourceConverter.toUint8Array(params.info);
        const PRK = crypto2.createHmac(hash, core.BufferSourceConverter.toUint8Array(params.salt)).update(core.BufferSourceConverter.toUint8Array(getCryptoKey(baseKey).data)).digest();
        const blocks = [buffer.Buffer.alloc(0)];
        const blockCount = Math.ceil(byteLength / hashLength) + 1;
        for (let i = 1; i < blockCount; ++i) {
          blocks.push(crypto2.createHmac(hash, PRK).update(buffer.Buffer.concat([blocks[i - 1], info, buffer.Buffer.from([i])])).digest());
        }
        return buffer.Buffer.concat(blocks).slice(0, byteLength);
      }
      checkCryptoKey(key, keyUsage) {
        super.checkCryptoKey(key, keyUsage);
        if (!(getCryptoKey(key) instanceof HkdfCryptoKey)) {
          throw new TypeError("key: Is not HKDF CryptoKey");
        }
      }
    };
    var ShakeCrypto = class {
      static digest(algorithm, data) {
        const hash = crypto2.createHash(algorithm.name.toLowerCase(), { outputLength: algorithm.length }).update(buffer.Buffer.from(data)).digest();
        return new Uint8Array(hash).buffer;
      }
    };
    var Shake128Provider = class extends core__namespace.Shake128Provider {
      async onDigest(algorithm, data) {
        return ShakeCrypto.digest(algorithm, data);
      }
    };
    var Shake256Provider = class extends core__namespace.Shake256Provider {
      async onDigest(algorithm, data) {
        return ShakeCrypto.digest(algorithm, data);
      }
    };
    var SubtleCrypto = class extends core__namespace.SubtleCrypto {
      constructor() {
        var _a;
        super();
        this.providers.set(new AesCbcProvider());
        this.providers.set(new AesCtrProvider());
        this.providers.set(new AesGcmProvider());
        this.providers.set(new AesCmacProvider());
        this.providers.set(new AesKwProvider());
        this.providers.set(new AesEcbProvider());
        const ciphers = crypto__namespace.getCiphers();
        if (ciphers.includes("des-cbc")) {
          this.providers.set(new DesCbcProvider());
        }
        this.providers.set(new DesEde3CbcProvider());
        this.providers.set(new RsaSsaProvider());
        this.providers.set(new RsaPssProvider());
        this.providers.set(new RsaOaepProvider());
        this.providers.set(new RsaEsProvider());
        this.providers.set(new EcdsaProvider());
        this.providers.set(new EcdhProvider());
        this.providers.set(new Sha1Provider());
        this.providers.set(new Sha256Provider());
        this.providers.set(new Sha384Provider());
        this.providers.set(new Sha512Provider());
        this.providers.set(new Pbkdf2Provider());
        this.providers.set(new HmacProvider());
        this.providers.set(new HkdfProvider());
        const nodeMajorVersion = (_a = /^v(\d+)/.exec(process__namespace.version)) === null || _a === void 0 ? void 0 : _a[1];
        if (nodeMajorVersion && parseInt(nodeMajorVersion, 10) >= 12) {
          this.providers.set(new Shake128Provider());
          this.providers.set(new Shake256Provider());
        }
        const hashes = crypto__namespace.getHashes();
        if (hashes.includes("sha3-256")) {
          this.providers.set(new Sha3256Provider());
        }
        if (hashes.includes("sha3-384")) {
          this.providers.set(new Sha3384Provider());
        }
        if (hashes.includes("sha3-512")) {
          this.providers.set(new Sha3512Provider());
        }
        if (nodeMajorVersion && parseInt(nodeMajorVersion, 10) >= 14) {
          this.providers.set(new EdDsaProvider());
          this.providers.set(new EcdhEsProvider());
        }
      }
    };
    var Crypto = class extends core__namespace.Crypto {
      constructor() {
        super(...arguments);
        this.subtle = new SubtleCrypto();
      }
      getRandomValues(array) {
        if (!ArrayBuffer.isView(array)) {
          throw new TypeError("Failed to execute 'getRandomValues' on 'Crypto': parameter 1 is not of type 'ArrayBufferView'");
        }
        const buffer$1 = buffer.Buffer.from(array.buffer, array.byteOffset, array.byteLength);
        crypto2.randomFillSync(buffer$1);
        return array;
      }
    };
    Object.defineProperty(exports2, "CryptoKey", {
      enumerable: true,
      get: function() {
        return core.CryptoKey;
      }
    });
    exports2.Crypto = Crypto;
  }
});

// node_modules/assert-plus/assert.js
var require_assert = __commonJS({
  "node_modules/assert-plus/assert.js"(exports2, module2) {
    var assert = require("assert");
    var Stream = require("stream").Stream;
    var util = require("util");
    var UUID_REGEXP = /^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/;
    function _capitalize(str) {
      return str.charAt(0).toUpperCase() + str.slice(1);
    }
    function _toss(name, expected, oper, arg, actual) {
      throw new assert.AssertionError({
        message: util.format("%s (%s) is required", name, expected),
        actual: actual === void 0 ? typeof arg : actual(arg),
        expected,
        operator: oper || "===",
        stackStartFunction: _toss.caller
      });
    }
    function _getClass(arg) {
      return Object.prototype.toString.call(arg).slice(8, -1);
    }
    function noop() {
    }
    var types2 = {
      bool: {
        check: function(arg) {
          return typeof arg === "boolean";
        }
      },
      func: {
        check: function(arg) {
          return typeof arg === "function";
        }
      },
      string: {
        check: function(arg) {
          return typeof arg === "string";
        }
      },
      object: {
        check: function(arg) {
          return typeof arg === "object" && arg !== null;
        }
      },
      number: {
        check: function(arg) {
          return typeof arg === "number" && !isNaN(arg);
        }
      },
      finite: {
        check: function(arg) {
          return typeof arg === "number" && !isNaN(arg) && isFinite(arg);
        }
      },
      buffer: {
        check: function(arg) {
          return Buffer.isBuffer(arg);
        },
        operator: "Buffer.isBuffer"
      },
      array: {
        check: function(arg) {
          return Array.isArray(arg);
        },
        operator: "Array.isArray"
      },
      stream: {
        check: function(arg) {
          return arg instanceof Stream;
        },
        operator: "instanceof",
        actual: _getClass
      },
      date: {
        check: function(arg) {
          return arg instanceof Date;
        },
        operator: "instanceof",
        actual: _getClass
      },
      regexp: {
        check: function(arg) {
          return arg instanceof RegExp;
        },
        operator: "instanceof",
        actual: _getClass
      },
      uuid: {
        check: function(arg) {
          return typeof arg === "string" && UUID_REGEXP.test(arg);
        },
        operator: "isUUID"
      }
    };
    function _setExports(ndebug) {
      var keys = Object.keys(types2);
      var out;
      if (process.env.NODE_NDEBUG) {
        out = noop;
      } else {
        out = function(arg, msg) {
          if (!arg) {
            _toss(msg, "true", arg);
          }
        };
      }
      keys.forEach(function(k) {
        if (ndebug) {
          out[k] = noop;
          return;
        }
        var type = types2[k];
        out[k] = function(arg, msg) {
          if (!type.check(arg)) {
            _toss(msg, k, type.operator, arg, type.actual);
          }
        };
      });
      keys.forEach(function(k) {
        var name = "optional" + _capitalize(k);
        if (ndebug) {
          out[name] = noop;
          return;
        }
        var type = types2[k];
        out[name] = function(arg, msg) {
          if (arg === void 0 || arg === null) {
            return;
          }
          if (!type.check(arg)) {
            _toss(msg, k, type.operator, arg, type.actual);
          }
        };
      });
      keys.forEach(function(k) {
        var name = "arrayOf" + _capitalize(k);
        if (ndebug) {
          out[name] = noop;
          return;
        }
        var type = types2[k];
        var expected = "[" + k + "]";
        out[name] = function(arg, msg) {
          if (!Array.isArray(arg)) {
            _toss(msg, expected, type.operator, arg, type.actual);
          }
          var i;
          for (i = 0; i < arg.length; i++) {
            if (!type.check(arg[i])) {
              _toss(msg, expected, type.operator, arg, type.actual);
            }
          }
        };
      });
      keys.forEach(function(k) {
        var name = "optionalArrayOf" + _capitalize(k);
        if (ndebug) {
          out[name] = noop;
          return;
        }
        var type = types2[k];
        var expected = "[" + k + "]";
        out[name] = function(arg, msg) {
          if (arg === void 0 || arg === null) {
            return;
          }
          if (!Array.isArray(arg)) {
            _toss(msg, expected, type.operator, arg, type.actual);
          }
          var i;
          for (i = 0; i < arg.length; i++) {
            if (!type.check(arg[i])) {
              _toss(msg, expected, type.operator, arg, type.actual);
            }
          }
        };
      });
      Object.keys(assert).forEach(function(k) {
        if (k === "AssertionError") {
          out[k] = assert[k];
          return;
        }
        if (ndebug) {
          out[k] = noop;
          return;
        }
        out[k] = assert[k];
      });
      out._setExports = _setExports;
      return out;
    }
    module2.exports = _setExports(process.env.NODE_NDEBUG);
  }
});

// node_modules/safer-buffer/safer.js
var require_safer = __commonJS({
  "node_modules/safer-buffer/safer.js"(exports2, module2) {
    "use strict";
    var buffer = require("buffer");
    var Buffer2 = buffer.Buffer;
    var safer = {};
    var key;
    for (key in buffer) {
      if (!buffer.hasOwnProperty(key))
        continue;
      if (key === "SlowBuffer" || key === "Buffer")
        continue;
      safer[key] = buffer[key];
    }
    var Safer = safer.Buffer = {};
    for (key in Buffer2) {
      if (!Buffer2.hasOwnProperty(key))
        continue;
      if (key === "allocUnsafe" || key === "allocUnsafeSlow")
        continue;
      Safer[key] = Buffer2[key];
    }
    safer.Buffer.prototype = Buffer2.prototype;
    if (!Safer.from || Safer.from === Uint8Array.from) {
      Safer.from = function(value, encodingOrOffset, length) {
        if (typeof value === "number") {
          throw new TypeError('The "value" argument must not be of type number. Received type ' + typeof value);
        }
        if (value && typeof value.length === "undefined") {
          throw new TypeError("The first argument must be one of type string, Buffer, ArrayBuffer, Array, or Array-like Object. Received type " + typeof value);
        }
        return Buffer2(value, encodingOrOffset, length);
      };
    }
    if (!Safer.alloc) {
      Safer.alloc = function(size, fill, encoding) {
        if (typeof size !== "number") {
          throw new TypeError('The "size" argument must be of type number. Received type ' + typeof size);
        }
        if (size < 0 || size >= 2 * (1 << 30)) {
          throw new RangeError('The value "' + size + '" is invalid for option "size"');
        }
        var buf = Buffer2(size);
        if (!fill || fill.length === 0) {
          buf.fill(0);
        } else if (typeof encoding === "string") {
          buf.fill(fill, encoding);
        } else {
          buf.fill(fill);
        }
        return buf;
      };
    }
    if (!safer.kStringMaxLength) {
      try {
        safer.kStringMaxLength = process.binding("buffer").kStringMaxLength;
      } catch (e) {
      }
    }
    if (!safer.constants) {
      safer.constants = {
        MAX_LENGTH: safer.kMaxLength
      };
      if (safer.kStringMaxLength) {
        safer.constants.MAX_STRING_LENGTH = safer.kStringMaxLength;
      }
    }
    module2.exports = safer;
  }
});

// node_modules/sshpk/lib/algs.js
var require_algs = __commonJS({
  "node_modules/sshpk/lib/algs.js"(exports2, module2) {
    var Buffer2 = require_safer().Buffer;
    var algInfo = {
      "dsa": {
        parts: ["p", "q", "g", "y"],
        sizePart: "p"
      },
      "rsa": {
        parts: ["e", "n"],
        sizePart: "n"
      },
      "ecdsa": {
        parts: ["curve", "Q"],
        sizePart: "Q"
      },
      "ed25519": {
        parts: ["A"],
        sizePart: "A"
      }
    };
    algInfo["curve25519"] = algInfo["ed25519"];
    var algPrivInfo = {
      "dsa": {
        parts: ["p", "q", "g", "y", "x"]
      },
      "rsa": {
        parts: ["n", "e", "d", "iqmp", "p", "q"]
      },
      "ecdsa": {
        parts: ["curve", "Q", "d"]
      },
      "ed25519": {
        parts: ["A", "k"]
      }
    };
    algPrivInfo["curve25519"] = algPrivInfo["ed25519"];
    var hashAlgs = {
      "md5": true,
      "sha1": true,
      "sha256": true,
      "sha384": true,
      "sha512": true
    };
    var curves = {
      "nistp256": {
        size: 256,
        pkcs8oid: "1.2.840.10045.3.1.7",
        p: Buffer2.from("00ffffffff 00000001 00000000 0000000000000000 ffffffff ffffffff ffffffff".replace(/ /g, ""), "hex"),
        a: Buffer2.from("00FFFFFFFF 00000001 00000000 0000000000000000 FFFFFFFF FFFFFFFF FFFFFFFC".replace(/ /g, ""), "hex"),
        b: Buffer2.from("5ac635d8 aa3a93e7 b3ebbd55 769886bc651d06b0 cc53b0f6 3bce3c3e 27d2604b".replace(/ /g, ""), "hex"),
        s: Buffer2.from("00c49d3608 86e70493 6a6678e1 139d26b7819f7e90".replace(/ /g, ""), "hex"),
        n: Buffer2.from("00ffffffff 00000000 ffffffff ffffffffbce6faad a7179e84 f3b9cac2 fc632551".replace(/ /g, ""), "hex"),
        G: Buffer2.from("046b17d1f2 e12c4247 f8bce6e5 63a440f277037d81 2deb33a0 f4a13945 d898c2964fe342e2 fe1a7f9b 8ee7eb4a 7c0f9e162bce3357 6b315ece cbb64068 37bf51f5".replace(/ /g, ""), "hex")
      },
      "nistp384": {
        size: 384,
        pkcs8oid: "1.3.132.0.34",
        p: Buffer2.from("00ffffffff ffffffff ffffffff ffffffffffffffff ffffffff ffffffff fffffffeffffffff 00000000 00000000 ffffffff".replace(/ /g, ""), "hex"),
        a: Buffer2.from("00FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFFFFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFEFFFFFFFF 00000000 00000000 FFFFFFFC".replace(/ /g, ""), "hex"),
        b: Buffer2.from("b3312fa7 e23ee7e4 988e056b e3f82d19181d9c6e fe814112 0314088f 5013875ac656398d 8a2ed19d 2a85c8ed d3ec2aef".replace(/ /g, ""), "hex"),
        s: Buffer2.from("00a335926a a319a27a 1d00896a 6773a4827acdac73".replace(/ /g, ""), "hex"),
        n: Buffer2.from("00ffffffff ffffffff ffffffff ffffffffffffffff ffffffff c7634d81 f4372ddf581a0db2 48b0a77a ecec196a ccc52973".replace(/ /g, ""), "hex"),
        G: Buffer2.from("04aa87ca22 be8b0537 8eb1c71e f320ad746e1d3b62 8ba79b98 59f741e0 82542a385502f25d bf55296c 3a545e38 72760ab73617de4a 96262c6f 5d9e98bf 9292dc29f8f41dbd 289a147c e9da3113 b5f0b8c00a60b1ce 1d7e819d 7a431d7c 90ea0e5f".replace(/ /g, ""), "hex")
      },
      "nistp521": {
        size: 521,
        pkcs8oid: "1.3.132.0.35",
        p: Buffer2.from("01ffffff ffffffff ffffffff ffffffffffffffff ffffffff ffffffff ffffffffffffffff ffffffff ffffffff ffffffffffffffff ffffffff ffffffff ffffffffffff".replace(/ /g, ""), "hex"),
        a: Buffer2.from("01FFFFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFFFFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFFFFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFFFFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFC".replace(/ /g, ""), "hex"),
        b: Buffer2.from("51953eb961 8e1c9a1f 929a21a0 b68540eea2da725b 99b315f3 b8b48991 8ef109e156193951 ec7e937b 1652c0bd 3bb1bf073573df88 3d2c34f1 ef451fd4 6b503f00".replace(/ /g, ""), "hex"),
        s: Buffer2.from("00d09e8800 291cb853 96cc6717 393284aaa0da64ba".replace(/ /g, ""), "hex"),
        n: Buffer2.from("01ffffffffff ffffffff ffffffff ffffffffffffffff ffffffff ffffffff fffffffa51868783 bf2f966b 7fcc0148 f709a5d03bb5c9b8 899c47ae bb6fb71e 91386409".replace(/ /g, ""), "hex"),
        G: Buffer2.from("0400c6 858e06b7 0404e9cd 9e3ecb66 2395b4429c648139 053fb521 f828af60 6b4d3dbaa14b5e77 efe75928 fe1dc127 a2ffa8de3348b3c1 856a429b f97e7e31 c2e5bd660118 39296a78 9a3bc004 5c8a5fb4 2c7d1bd998f54449 579b4468 17afbd17 273e662c97ee7299 5ef42640 c550b901 3fad0761353c7086 a272c240 88be9476 9fd16650".replace(/ /g, ""), "hex")
      }
    };
    module2.exports = {
      info: algInfo,
      privInfo: algPrivInfo,
      hashAlgs,
      curves
    };
  }
});

// node_modules/sshpk/lib/errors.js
var require_errors3 = __commonJS({
  "node_modules/sshpk/lib/errors.js"(exports2, module2) {
    var assert = require_assert();
    var util = require("util");
    function FingerprintFormatError(fp, format3) {
      if (Error.captureStackTrace)
        Error.captureStackTrace(this, FingerprintFormatError);
      this.name = "FingerprintFormatError";
      this.fingerprint = fp;
      this.format = format3;
      this.message = "Fingerprint format is not supported, or is invalid: ";
      if (fp !== void 0)
        this.message += " fingerprint = " + fp;
      if (format3 !== void 0)
        this.message += " format = " + format3;
    }
    util.inherits(FingerprintFormatError, Error);
    function InvalidAlgorithmError(alg) {
      if (Error.captureStackTrace)
        Error.captureStackTrace(this, InvalidAlgorithmError);
      this.name = "InvalidAlgorithmError";
      this.algorithm = alg;
      this.message = 'Algorithm "' + alg + '" is not supported';
    }
    util.inherits(InvalidAlgorithmError, Error);
    function KeyParseError(name, format3, innerErr) {
      if (Error.captureStackTrace)
        Error.captureStackTrace(this, KeyParseError);
      this.name = "KeyParseError";
      this.format = format3;
      this.keyName = name;
      this.innerErr = innerErr;
      this.message = "Failed to parse " + name + " as a valid " + format3 + " format key: " + innerErr.message;
    }
    util.inherits(KeyParseError, Error);
    function SignatureParseError(type, format3, innerErr) {
      if (Error.captureStackTrace)
        Error.captureStackTrace(this, SignatureParseError);
      this.name = "SignatureParseError";
      this.type = type;
      this.format = format3;
      this.innerErr = innerErr;
      this.message = "Failed to parse the given data as a " + type + " signature in " + format3 + " format: " + innerErr.message;
    }
    util.inherits(SignatureParseError, Error);
    function CertificateParseError(name, format3, innerErr) {
      if (Error.captureStackTrace)
        Error.captureStackTrace(this, CertificateParseError);
      this.name = "CertificateParseError";
      this.format = format3;
      this.certName = name;
      this.innerErr = innerErr;
      this.message = "Failed to parse " + name + " as a valid " + format3 + " format certificate: " + innerErr.message;
    }
    util.inherits(CertificateParseError, Error);
    function KeyEncryptedError(name, format3) {
      if (Error.captureStackTrace)
        Error.captureStackTrace(this, KeyEncryptedError);
      this.name = "KeyEncryptedError";
      this.format = format3;
      this.keyName = name;
      this.message = "The " + format3 + " format key " + name + " is encrypted (password-protected), and no passphrase was provided in `options`";
    }
    util.inherits(KeyEncryptedError, Error);
    module2.exports = {
      FingerprintFormatError,
      InvalidAlgorithmError,
      KeyParseError,
      SignatureParseError,
      KeyEncryptedError,
      CertificateParseError
    };
  }
});

// node_modules/asn1/lib/ber/errors.js
var require_errors4 = __commonJS({
  "node_modules/asn1/lib/ber/errors.js"(exports2, module2) {
    module2.exports = {
      newInvalidAsn1Error: function(msg) {
        var e = new Error();
        e.name = "InvalidAsn1Error";
        e.message = msg || "";
        return e;
      }
    };
  }
});

// node_modules/asn1/lib/ber/types.js
var require_types7 = __commonJS({
  "node_modules/asn1/lib/ber/types.js"(exports2, module2) {
    module2.exports = {
      EOC: 0,
      Boolean: 1,
      Integer: 2,
      BitString: 3,
      OctetString: 4,
      Null: 5,
      OID: 6,
      ObjectDescriptor: 7,
      External: 8,
      Real: 9,
      // float
      Enumeration: 10,
      PDV: 11,
      Utf8String: 12,
      RelativeOID: 13,
      Sequence: 16,
      Set: 17,
      NumericString: 18,
      PrintableString: 19,
      T61String: 20,
      VideotexString: 21,
      IA5String: 22,
      UTCTime: 23,
      GeneralizedTime: 24,
      GraphicString: 25,
      VisibleString: 26,
      GeneralString: 28,
      UniversalString: 29,
      CharacterString: 30,
      BMPString: 31,
      Constructor: 32,
      Context: 128
    };
  }
});

// node_modules/asn1/lib/ber/reader.js
var require_reader = __commonJS({
  "node_modules/asn1/lib/ber/reader.js"(exports2, module2) {
    var assert = require("assert");
    var Buffer2 = require_safer().Buffer;
    var ASN1 = require_types7();
    var errors = require_errors4();
    var newInvalidAsn1Error = errors.newInvalidAsn1Error;
    function Reader(data) {
      if (!data || !Buffer2.isBuffer(data))
        throw new TypeError("data must be a node Buffer");
      this._buf = data;
      this._size = data.length;
      this._len = 0;
      this._offset = 0;
    }
    Object.defineProperty(Reader.prototype, "length", {
      enumerable: true,
      get: function() {
        return this._len;
      }
    });
    Object.defineProperty(Reader.prototype, "offset", {
      enumerable: true,
      get: function() {
        return this._offset;
      }
    });
    Object.defineProperty(Reader.prototype, "remain", {
      get: function() {
        return this._size - this._offset;
      }
    });
    Object.defineProperty(Reader.prototype, "buffer", {
      get: function() {
        return this._buf.slice(this._offset);
      }
    });
    Reader.prototype.readByte = function(peek) {
      if (this._size - this._offset < 1)
        return null;
      var b = this._buf[this._offset] & 255;
      if (!peek)
        this._offset += 1;
      return b;
    };
    Reader.prototype.peek = function() {
      return this.readByte(true);
    };
    Reader.prototype.readLength = function(offset) {
      if (offset === void 0)
        offset = this._offset;
      if (offset >= this._size)
        return null;
      var lenB = this._buf[offset++] & 255;
      if (lenB === null)
        return null;
      if ((lenB & 128) === 128) {
        lenB &= 127;
        if (lenB === 0)
          throw newInvalidAsn1Error("Indefinite length not supported");
        if (lenB > 4)
          throw newInvalidAsn1Error("encoding too long");
        if (this._size - offset < lenB)
          return null;
        this._len = 0;
        for (var i = 0; i < lenB; i++)
          this._len = (this._len << 8) + (this._buf[offset++] & 255);
      } else {
        this._len = lenB;
      }
      return offset;
    };
    Reader.prototype.readSequence = function(tag) {
      var seq = this.peek();
      if (seq === null)
        return null;
      if (tag !== void 0 && tag !== seq)
        throw newInvalidAsn1Error("Expected 0x" + tag.toString(16) + ": got 0x" + seq.toString(16));
      var o2 = this.readLength(this._offset + 1);
      if (o2 === null)
        return null;
      this._offset = o2;
      return seq;
    };
    Reader.prototype.readInt = function() {
      return this._readTag(ASN1.Integer);
    };
    Reader.prototype.readBoolean = function() {
      return this._readTag(ASN1.Boolean) === 0 ? false : true;
    };
    Reader.prototype.readEnumeration = function() {
      return this._readTag(ASN1.Enumeration);
    };
    Reader.prototype.readString = function(tag, retbuf) {
      if (!tag)
        tag = ASN1.OctetString;
      var b = this.peek();
      if (b === null)
        return null;
      if (b !== tag)
        throw newInvalidAsn1Error("Expected 0x" + tag.toString(16) + ": got 0x" + b.toString(16));
      var o2 = this.readLength(this._offset + 1);
      if (o2 === null)
        return null;
      if (this.length > this._size - o2)
        return null;
      this._offset = o2;
      if (this.length === 0)
        return retbuf ? Buffer2.alloc(0) : "";
      var str = this._buf.slice(this._offset, this._offset + this.length);
      this._offset += this.length;
      return retbuf ? str : str.toString("utf8");
    };
    Reader.prototype.readOID = function(tag) {
      if (!tag)
        tag = ASN1.OID;
      var b = this.readString(tag, true);
      if (b === null)
        return null;
      var values = [];
      var value = 0;
      for (var i = 0; i < b.length; i++) {
        var byte = b[i] & 255;
        value <<= 7;
        value += byte & 127;
        if ((byte & 128) === 0) {
          values.push(value);
          value = 0;
        }
      }
      value = values.shift();
      values.unshift(value % 40);
      values.unshift(value / 40 >> 0);
      return values.join(".");
    };
    Reader.prototype._readTag = function(tag) {
      assert.ok(tag !== void 0);
      var b = this.peek();
      if (b === null)
        return null;
      if (b !== tag)
        throw newInvalidAsn1Error("Expected 0x" + tag.toString(16) + ": got 0x" + b.toString(16));
      var o2 = this.readLength(this._offset + 1);
      if (o2 === null)
        return null;
      if (this.length > 4)
        throw newInvalidAsn1Error("Integer too long: " + this.length);
      if (this.length > this._size - o2)
        return null;
      this._offset = o2;
      var fb = this._buf[this._offset];
      var value = 0;
      for (var i = 0; i < this.length; i++) {
        value <<= 8;
        value |= this._buf[this._offset++] & 255;
      }
      if ((fb & 128) === 128 && i !== 4)
        value -= 1 << i * 8;
      return value >> 0;
    };
    module2.exports = Reader;
  }
});

// node_modules/asn1/lib/ber/writer.js
var require_writer = __commonJS({
  "node_modules/asn1/lib/ber/writer.js"(exports2, module2) {
    var assert = require("assert");
    var Buffer2 = require_safer().Buffer;
    var ASN1 = require_types7();
    var errors = require_errors4();
    var newInvalidAsn1Error = errors.newInvalidAsn1Error;
    var DEFAULT_OPTS = {
      size: 1024,
      growthFactor: 8
    };
    function merge(from, to) {
      assert.ok(from);
      assert.equal(typeof from, "object");
      assert.ok(to);
      assert.equal(typeof to, "object");
      var keys = Object.getOwnPropertyNames(from);
      keys.forEach(function(key) {
        if (to[key])
          return;
        var value = Object.getOwnPropertyDescriptor(from, key);
        Object.defineProperty(to, key, value);
      });
      return to;
    }
    function Writer(options) {
      options = merge(DEFAULT_OPTS, options || {});
      this._buf = Buffer2.alloc(options.size || 1024);
      this._size = this._buf.length;
      this._offset = 0;
      this._options = options;
      this._seq = [];
    }
    Object.defineProperty(Writer.prototype, "buffer", {
      get: function() {
        if (this._seq.length)
          throw newInvalidAsn1Error(this._seq.length + " unended sequence(s)");
        return this._buf.slice(0, this._offset);
      }
    });
    Writer.prototype.writeByte = function(b) {
      if (typeof b !== "number")
        throw new TypeError("argument must be a Number");
      this._ensure(1);
      this._buf[this._offset++] = b;
    };
    Writer.prototype.writeInt = function(i, tag) {
      if (typeof i !== "number")
        throw new TypeError("argument must be a Number");
      if (typeof tag !== "number")
        tag = ASN1.Integer;
      var sz = 4;
      while (((i & 4286578688) === 0 || (i & 4286578688) === 4286578688 >> 0) && sz > 1) {
        sz--;
        i <<= 8;
      }
      if (sz > 4)
        throw newInvalidAsn1Error("BER ints cannot be > 0xffffffff");
      this._ensure(2 + sz);
      this._buf[this._offset++] = tag;
      this._buf[this._offset++] = sz;
      while (sz-- > 0) {
        this._buf[this._offset++] = (i & 4278190080) >>> 24;
        i <<= 8;
      }
    };
    Writer.prototype.writeNull = function() {
      this.writeByte(ASN1.Null);
      this.writeByte(0);
    };
    Writer.prototype.writeEnumeration = function(i, tag) {
      if (typeof i !== "number")
        throw new TypeError("argument must be a Number");
      if (typeof tag !== "number")
        tag = ASN1.Enumeration;
      return this.writeInt(i, tag);
    };
    Writer.prototype.writeBoolean = function(b, tag) {
      if (typeof b !== "boolean")
        throw new TypeError("argument must be a Boolean");
      if (typeof tag !== "number")
        tag = ASN1.Boolean;
      this._ensure(3);
      this._buf[this._offset++] = tag;
      this._buf[this._offset++] = 1;
      this._buf[this._offset++] = b ? 255 : 0;
    };
    Writer.prototype.writeString = function(s, tag) {
      if (typeof s !== "string")
        throw new TypeError("argument must be a string (was: " + typeof s + ")");
      if (typeof tag !== "number")
        tag = ASN1.OctetString;
      var len = Buffer2.byteLength(s);
      this.writeByte(tag);
      this.writeLength(len);
      if (len) {
        this._ensure(len);
        this._buf.write(s, this._offset);
        this._offset += len;
      }
    };
    Writer.prototype.writeBuffer = function(buf, tag) {
      if (typeof tag !== "number")
        throw new TypeError("tag must be a number");
      if (!Buffer2.isBuffer(buf))
        throw new TypeError("argument must be a buffer");
      this.writeByte(tag);
      this.writeLength(buf.length);
      this._ensure(buf.length);
      buf.copy(this._buf, this._offset, 0, buf.length);
      this._offset += buf.length;
    };
    Writer.prototype.writeStringArray = function(strings) {
      if (!strings instanceof Array)
        throw new TypeError("argument must be an Array[String]");
      var self2 = this;
      strings.forEach(function(s) {
        self2.writeString(s);
      });
    };
    Writer.prototype.writeOID = function(s, tag) {
      if (typeof s !== "string")
        throw new TypeError("argument must be a string");
      if (typeof tag !== "number")
        tag = ASN1.OID;
      if (!/^([0-9]+\.){3,}[0-9]+$/.test(s))
        throw new Error("argument is not a valid OID string");
      function encodeOctet(bytes2, octet) {
        if (octet < 128) {
          bytes2.push(octet);
        } else if (octet < 16384) {
          bytes2.push(octet >>> 7 | 128);
          bytes2.push(octet & 127);
        } else if (octet < 2097152) {
          bytes2.push(octet >>> 14 | 128);
          bytes2.push((octet >>> 7 | 128) & 255);
          bytes2.push(octet & 127);
        } else if (octet < 268435456) {
          bytes2.push(octet >>> 21 | 128);
          bytes2.push((octet >>> 14 | 128) & 255);
          bytes2.push((octet >>> 7 | 128) & 255);
          bytes2.push(octet & 127);
        } else {
          bytes2.push((octet >>> 28 | 128) & 255);
          bytes2.push((octet >>> 21 | 128) & 255);
          bytes2.push((octet >>> 14 | 128) & 255);
          bytes2.push((octet >>> 7 | 128) & 255);
          bytes2.push(octet & 127);
        }
      }
      var tmp = s.split(".");
      var bytes = [];
      bytes.push(parseInt(tmp[0], 10) * 40 + parseInt(tmp[1], 10));
      tmp.slice(2).forEach(function(b) {
        encodeOctet(bytes, parseInt(b, 10));
      });
      var self2 = this;
      this._ensure(2 + bytes.length);
      this.writeByte(tag);
      this.writeLength(bytes.length);
      bytes.forEach(function(b) {
        self2.writeByte(b);
      });
    };
    Writer.prototype.writeLength = function(len) {
      if (typeof len !== "number")
        throw new TypeError("argument must be a Number");
      this._ensure(4);
      if (len <= 127) {
        this._buf[this._offset++] = len;
      } else if (len <= 255) {
        this._buf[this._offset++] = 129;
        this._buf[this._offset++] = len;
      } else if (len <= 65535) {
        this._buf[this._offset++] = 130;
        this._buf[this._offset++] = len >> 8;
        this._buf[this._offset++] = len;
      } else if (len <= 16777215) {
        this._buf[this._offset++] = 131;
        this._buf[this._offset++] = len >> 16;
        this._buf[this._offset++] = len >> 8;
        this._buf[this._offset++] = len;
      } else {
        throw newInvalidAsn1Error("Length too long (> 4 bytes)");
      }
    };
    Writer.prototype.startSequence = function(tag) {
      if (typeof tag !== "number")
        tag = ASN1.Sequence | ASN1.Constructor;
      this.writeByte(tag);
      this._seq.push(this._offset);
      this._ensure(3);
      this._offset += 3;
    };
    Writer.prototype.endSequence = function() {
      var seq = this._seq.pop();
      var start = seq + 3;
      var len = this._offset - start;
      if (len <= 127) {
        this._shift(start, len, -2);
        this._buf[seq] = len;
      } else if (len <= 255) {
        this._shift(start, len, -1);
        this._buf[seq] = 129;
        this._buf[seq + 1] = len;
      } else if (len <= 65535) {
        this._buf[seq] = 130;
        this._buf[seq + 1] = len >> 8;
        this._buf[seq + 2] = len;
      } else if (len <= 16777215) {
        this._shift(start, len, 1);
        this._buf[seq] = 131;
        this._buf[seq + 1] = len >> 16;
        this._buf[seq + 2] = len >> 8;
        this._buf[seq + 3] = len;
      } else {
        throw newInvalidAsn1Error("Sequence too long");
      }
    };
    Writer.prototype._shift = function(start, len, shift) {
      assert.ok(start !== void 0);
      assert.ok(len !== void 0);
      assert.ok(shift);
      this._buf.copy(this._buf, start + shift, start, start + len);
      this._offset += shift;
    };
    Writer.prototype._ensure = function(len) {
      assert.ok(len);
      if (this._size - this._offset < len) {
        var sz = this._size * this._options.growthFactor;
        if (sz - this._offset < len)
          sz += len;
        var buf = Buffer2.alloc(sz);
        this._buf.copy(buf, 0, 0, this._offset);
        this._buf = buf;
        this._size = sz;
      }
    };
    module2.exports = Writer;
  }
});

// node_modules/asn1/lib/ber/index.js
var require_ber = __commonJS({
  "node_modules/asn1/lib/ber/index.js"(exports2, module2) {
    var errors = require_errors4();
    var types2 = require_types7();
    var Reader = require_reader();
    var Writer = require_writer();
    module2.exports = {
      Reader,
      Writer
    };
    for (t in types2) {
      if (types2.hasOwnProperty(t))
        module2.exports[t] = types2[t];
    }
    var t;
    for (e in errors) {
      if (errors.hasOwnProperty(e))
        module2.exports[e] = errors[e];
    }
    var e;
  }
});

// node_modules/asn1/lib/index.js
var require_lib14 = __commonJS({
  "node_modules/asn1/lib/index.js"(exports2, module2) {
    var Ber = require_ber();
    module2.exports = {
      Ber,
      BerReader: Ber.Reader,
      BerWriter: Ber.Writer
    };
  }
});

// node_modules/ecc-jsbn/node_modules/jsbn/index.js
var require_jsbn = __commonJS({
  "node_modules/ecc-jsbn/node_modules/jsbn/index.js"(exports2, module2) {
    (function() {
      var dbits;
      var canary = 244837814094590;
      var j_lm = (canary & 16777215) == 15715070;
      function BigInteger(a, b, c2) {
        if (a != null)
          if ("number" == typeof a)
            this.fromNumber(a, b, c2);
          else if (b == null && "string" != typeof a)
            this.fromString(a, 256);
          else
            this.fromString(a, b);
      }
      function nbi() {
        return new BigInteger(null);
      }
      function am1(i, x2, w, j, c2, n) {
        while (--n >= 0) {
          var v = x2 * this[i++] + w[j] + c2;
          c2 = Math.floor(v / 67108864);
          w[j++] = v & 67108863;
        }
        return c2;
      }
      function am2(i, x2, w, j, c2, n) {
        var xl = x2 & 32767, xh = x2 >> 15;
        while (--n >= 0) {
          var l2 = this[i] & 32767;
          var h = this[i++] >> 15;
          var m2 = xh * l2 + h * xl;
          l2 = xl * l2 + ((m2 & 32767) << 15) + w[j] + (c2 & 1073741823);
          c2 = (l2 >>> 30) + (m2 >>> 15) + xh * h + (c2 >>> 30);
          w[j++] = l2 & 1073741823;
        }
        return c2;
      }
      function am3(i, x2, w, j, c2, n) {
        var xl = x2 & 16383, xh = x2 >> 14;
        while (--n >= 0) {
          var l2 = this[i] & 16383;
          var h = this[i++] >> 14;
          var m2 = xh * l2 + h * xl;
          l2 = xl * l2 + ((m2 & 16383) << 14) + w[j] + c2;
          c2 = (l2 >> 28) + (m2 >> 14) + xh * h;
          w[j++] = l2 & 268435455;
        }
        return c2;
      }
      var inBrowser = typeof navigator !== "undefined";
      if (inBrowser && j_lm && navigator.appName == "Microsoft Internet Explorer") {
        BigInteger.prototype.am = am2;
        dbits = 30;
      } else if (inBrowser && j_lm && navigator.appName != "Netscape") {
        BigInteger.prototype.am = am1;
        dbits = 26;
      } else {
        BigInteger.prototype.am = am3;
        dbits = 28;
      }
      BigInteger.prototype.DB = dbits;
      BigInteger.prototype.DM = (1 << dbits) - 1;
      BigInteger.prototype.DV = 1 << dbits;
      var BI_FP = 52;
      BigInteger.prototype.FV = Math.pow(2, BI_FP);
      BigInteger.prototype.F1 = BI_FP - dbits;
      BigInteger.prototype.F2 = 2 * dbits - BI_FP;
      var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
      var BI_RC = new Array();
      var rr, vv;
      rr = "0".charCodeAt(0);
      for (vv = 0; vv <= 9; ++vv)
        BI_RC[rr++] = vv;
      rr = "a".charCodeAt(0);
      for (vv = 10; vv < 36; ++vv)
        BI_RC[rr++] = vv;
      rr = "A".charCodeAt(0);
      for (vv = 10; vv < 36; ++vv)
        BI_RC[rr++] = vv;
      function int2char(n) {
        return BI_RM.charAt(n);
      }
      function intAt(s, i) {
        var c2 = BI_RC[s.charCodeAt(i)];
        return c2 == null ? -1 : c2;
      }
      function bnpCopyTo(r) {
        for (var i = this.t - 1; i >= 0; --i)
          r[i] = this[i];
        r.t = this.t;
        r.s = this.s;
      }
      function bnpFromInt(x2) {
        this.t = 1;
        this.s = x2 < 0 ? -1 : 0;
        if (x2 > 0)
          this[0] = x2;
        else if (x2 < -1)
          this[0] = x2 + this.DV;
        else
          this.t = 0;
      }
      function nbv(i) {
        var r = nbi();
        r.fromInt(i);
        return r;
      }
      function bnpFromString(s, b) {
        var k;
        if (b == 16)
          k = 4;
        else if (b == 8)
          k = 3;
        else if (b == 256)
          k = 8;
        else if (b == 2)
          k = 1;
        else if (b == 32)
          k = 5;
        else if (b == 4)
          k = 2;
        else {
          this.fromRadix(s, b);
          return;
        }
        this.t = 0;
        this.s = 0;
        var i = s.length, mi = false, sh = 0;
        while (--i >= 0) {
          var x2 = k == 8 ? s[i] & 255 : intAt(s, i);
          if (x2 < 0) {
            if (s.charAt(i) == "-")
              mi = true;
            continue;
          }
          mi = false;
          if (sh == 0)
            this[this.t++] = x2;
          else if (sh + k > this.DB) {
            this[this.t - 1] |= (x2 & (1 << this.DB - sh) - 1) << sh;
            this[this.t++] = x2 >> this.DB - sh;
          } else
            this[this.t - 1] |= x2 << sh;
          sh += k;
          if (sh >= this.DB)
            sh -= this.DB;
        }
        if (k == 8 && (s[0] & 128) != 0) {
          this.s = -1;
          if (sh > 0)
            this[this.t - 1] |= (1 << this.DB - sh) - 1 << sh;
        }
        this.clamp();
        if (mi)
          BigInteger.ZERO.subTo(this, this);
      }
      function bnpClamp() {
        var c2 = this.s & this.DM;
        while (this.t > 0 && this[this.t - 1] == c2)
          --this.t;
      }
      function bnToString(b) {
        if (this.s < 0)
          return "-" + this.negate().toString(b);
        var k;
        if (b == 16)
          k = 4;
        else if (b == 8)
          k = 3;
        else if (b == 2)
          k = 1;
        else if (b == 32)
          k = 5;
        else if (b == 4)
          k = 2;
        else
          return this.toRadix(b);
        var km = (1 << k) - 1, d2, m2 = false, r = "", i = this.t;
        var p3 = this.DB - i * this.DB % k;
        if (i-- > 0) {
          if (p3 < this.DB && (d2 = this[i] >> p3) > 0) {
            m2 = true;
            r = int2char(d2);
          }
          while (i >= 0) {
            if (p3 < k) {
              d2 = (this[i] & (1 << p3) - 1) << k - p3;
              d2 |= this[--i] >> (p3 += this.DB - k);
            } else {
              d2 = this[i] >> (p3 -= k) & km;
              if (p3 <= 0) {
                p3 += this.DB;
                --i;
              }
            }
            if (d2 > 0)
              m2 = true;
            if (m2)
              r += int2char(d2);
          }
        }
        return m2 ? r : "0";
      }
      function bnNegate() {
        var r = nbi();
        BigInteger.ZERO.subTo(this, r);
        return r;
      }
      function bnAbs() {
        return this.s < 0 ? this.negate() : this;
      }
      function bnCompareTo(a) {
        var r = this.s - a.s;
        if (r != 0)
          return r;
        var i = this.t;
        r = i - a.t;
        if (r != 0)
          return this.s < 0 ? -r : r;
        while (--i >= 0)
          if ((r = this[i] - a[i]) != 0)
            return r;
        return 0;
      }
      function nbits(x2) {
        var r = 1, t2;
        if ((t2 = x2 >>> 16) != 0) {
          x2 = t2;
          r += 16;
        }
        if ((t2 = x2 >> 8) != 0) {
          x2 = t2;
          r += 8;
        }
        if ((t2 = x2 >> 4) != 0) {
          x2 = t2;
          r += 4;
        }
        if ((t2 = x2 >> 2) != 0) {
          x2 = t2;
          r += 2;
        }
        if ((t2 = x2 >> 1) != 0) {
          x2 = t2;
          r += 1;
        }
        return r;
      }
      function bnBitLength() {
        if (this.t <= 0)
          return 0;
        return this.DB * (this.t - 1) + nbits(this[this.t - 1] ^ this.s & this.DM);
      }
      function bnpDLShiftTo(n, r) {
        var i;
        for (i = this.t - 1; i >= 0; --i)
          r[i + n] = this[i];
        for (i = n - 1; i >= 0; --i)
          r[i] = 0;
        r.t = this.t + n;
        r.s = this.s;
      }
      function bnpDRShiftTo(n, r) {
        for (var i = n; i < this.t; ++i)
          r[i - n] = this[i];
        r.t = Math.max(this.t - n, 0);
        r.s = this.s;
      }
      function bnpLShiftTo(n, r) {
        var bs = n % this.DB;
        var cbs = this.DB - bs;
        var bm = (1 << cbs) - 1;
        var ds = Math.floor(n / this.DB), c2 = this.s << bs & this.DM, i;
        for (i = this.t - 1; i >= 0; --i) {
          r[i + ds + 1] = this[i] >> cbs | c2;
          c2 = (this[i] & bm) << bs;
        }
        for (i = ds - 1; i >= 0; --i)
          r[i] = 0;
        r[ds] = c2;
        r.t = this.t + ds + 1;
        r.s = this.s;
        r.clamp();
      }
      function bnpRShiftTo(n, r) {
        r.s = this.s;
        var ds = Math.floor(n / this.DB);
        if (ds >= this.t) {
          r.t = 0;
          return;
        }
        var bs = n % this.DB;
        var cbs = this.DB - bs;
        var bm = (1 << bs) - 1;
        r[0] = this[ds] >> bs;
        for (var i = ds + 1; i < this.t; ++i) {
          r[i - ds - 1] |= (this[i] & bm) << cbs;
          r[i - ds] = this[i] >> bs;
        }
        if (bs > 0)
          r[this.t - ds - 1] |= (this.s & bm) << cbs;
        r.t = this.t - ds;
        r.clamp();
      }
      function bnpSubTo(a, r) {
        var i = 0, c2 = 0, m2 = Math.min(a.t, this.t);
        while (i < m2) {
          c2 += this[i] - a[i];
          r[i++] = c2 & this.DM;
          c2 >>= this.DB;
        }
        if (a.t < this.t) {
          c2 -= a.s;
          while (i < this.t) {
            c2 += this[i];
            r[i++] = c2 & this.DM;
            c2 >>= this.DB;
          }
          c2 += this.s;
        } else {
          c2 += this.s;
          while (i < a.t) {
            c2 -= a[i];
            r[i++] = c2 & this.DM;
            c2 >>= this.DB;
          }
          c2 -= a.s;
        }
        r.s = c2 < 0 ? -1 : 0;
        if (c2 < -1)
          r[i++] = this.DV + c2;
        else if (c2 > 0)
          r[i++] = c2;
        r.t = i;
        r.clamp();
      }
      function bnpMultiplyTo(a, r) {
        var x2 = this.abs(), y = a.abs();
        var i = x2.t;
        r.t = i + y.t;
        while (--i >= 0)
          r[i] = 0;
        for (i = 0; i < y.t; ++i)
          r[i + x2.t] = x2.am(0, y[i], r, i, 0, x2.t);
        r.s = 0;
        r.clamp();
        if (this.s != a.s)
          BigInteger.ZERO.subTo(r, r);
      }
      function bnpSquareTo(r) {
        var x2 = this.abs();
        var i = r.t = 2 * x2.t;
        while (--i >= 0)
          r[i] = 0;
        for (i = 0; i < x2.t - 1; ++i) {
          var c2 = x2.am(i, x2[i], r, 2 * i, 0, 1);
          if ((r[i + x2.t] += x2.am(i + 1, 2 * x2[i], r, 2 * i + 1, c2, x2.t - i - 1)) >= x2.DV) {
            r[i + x2.t] -= x2.DV;
            r[i + x2.t + 1] = 1;
          }
        }
        if (r.t > 0)
          r[r.t - 1] += x2.am(i, x2[i], r, 2 * i, 0, 1);
        r.s = 0;
        r.clamp();
      }
      function bnpDivRemTo(m2, q2, r) {
        var pm = m2.abs();
        if (pm.t <= 0)
          return;
        var pt = this.abs();
        if (pt.t < pm.t) {
          if (q2 != null)
            q2.fromInt(0);
          if (r != null)
            this.copyTo(r);
          return;
        }
        if (r == null)
          r = nbi();
        var y = nbi(), ts = this.s, ms = m2.s;
        var nsh = this.DB - nbits(pm[pm.t - 1]);
        if (nsh > 0) {
          pm.lShiftTo(nsh, y);
          pt.lShiftTo(nsh, r);
        } else {
          pm.copyTo(y);
          pt.copyTo(r);
        }
        var ys = y.t;
        var y0 = y[ys - 1];
        if (y0 == 0)
          return;
        var yt = y0 * (1 << this.F1) + (ys > 1 ? y[ys - 2] >> this.F2 : 0);
        var d1 = this.FV / yt, d2 = (1 << this.F1) / yt, e = 1 << this.F2;
        var i = r.t, j = i - ys, t2 = q2 == null ? nbi() : q2;
        y.dlShiftTo(j, t2);
        if (r.compareTo(t2) >= 0) {
          r[r.t++] = 1;
          r.subTo(t2, r);
        }
        BigInteger.ONE.dlShiftTo(ys, t2);
        t2.subTo(y, y);
        while (y.t < ys)
          y[y.t++] = 0;
        while (--j >= 0) {
          var qd = r[--i] == y0 ? this.DM : Math.floor(r[i] * d1 + (r[i - 1] + e) * d2);
          if ((r[i] += y.am(0, qd, r, j, 0, ys)) < qd) {
            y.dlShiftTo(j, t2);
            r.subTo(t2, r);
            while (r[i] < --qd)
              r.subTo(t2, r);
          }
        }
        if (q2 != null) {
          r.drShiftTo(ys, q2);
          if (ts != ms)
            BigInteger.ZERO.subTo(q2, q2);
        }
        r.t = ys;
        r.clamp();
        if (nsh > 0)
          r.rShiftTo(nsh, r);
        if (ts < 0)
          BigInteger.ZERO.subTo(r, r);
      }
      function bnMod(a) {
        var r = nbi();
        this.abs().divRemTo(a, null, r);
        if (this.s < 0 && r.compareTo(BigInteger.ZERO) > 0)
          a.subTo(r, r);
        return r;
      }
      function Classic(m2) {
        this.m = m2;
      }
      function cConvert(x2) {
        if (x2.s < 0 || x2.compareTo(this.m) >= 0)
          return x2.mod(this.m);
        else
          return x2;
      }
      function cRevert(x2) {
        return x2;
      }
      function cReduce(x2) {
        x2.divRemTo(this.m, null, x2);
      }
      function cMulTo(x2, y, r) {
        x2.multiplyTo(y, r);
        this.reduce(r);
      }
      function cSqrTo(x2, r) {
        x2.squareTo(r);
        this.reduce(r);
      }
      Classic.prototype.convert = cConvert;
      Classic.prototype.revert = cRevert;
      Classic.prototype.reduce = cReduce;
      Classic.prototype.mulTo = cMulTo;
      Classic.prototype.sqrTo = cSqrTo;
      function bnpInvDigit() {
        if (this.t < 1)
          return 0;
        var x2 = this[0];
        if ((x2 & 1) == 0)
          return 0;
        var y = x2 & 3;
        y = y * (2 - (x2 & 15) * y) & 15;
        y = y * (2 - (x2 & 255) * y) & 255;
        y = y * (2 - ((x2 & 65535) * y & 65535)) & 65535;
        y = y * (2 - x2 * y % this.DV) % this.DV;
        return y > 0 ? this.DV - y : -y;
      }
      function Montgomery(m2) {
        this.m = m2;
        this.mp = m2.invDigit();
        this.mpl = this.mp & 32767;
        this.mph = this.mp >> 15;
        this.um = (1 << m2.DB - 15) - 1;
        this.mt2 = 2 * m2.t;
      }
      function montConvert(x2) {
        var r = nbi();
        x2.abs().dlShiftTo(this.m.t, r);
        r.divRemTo(this.m, null, r);
        if (x2.s < 0 && r.compareTo(BigInteger.ZERO) > 0)
          this.m.subTo(r, r);
        return r;
      }
      function montRevert(x2) {
        var r = nbi();
        x2.copyTo(r);
        this.reduce(r);
        return r;
      }
      function montReduce(x2) {
        while (x2.t <= this.mt2)
          x2[x2.t++] = 0;
        for (var i = 0; i < this.m.t; ++i) {
          var j = x2[i] & 32767;
          var u0 = j * this.mpl + ((j * this.mph + (x2[i] >> 15) * this.mpl & this.um) << 15) & x2.DM;
          j = i + this.m.t;
          x2[j] += this.m.am(0, u0, x2, i, 0, this.m.t);
          while (x2[j] >= x2.DV) {
            x2[j] -= x2.DV;
            x2[++j]++;
          }
        }
        x2.clamp();
        x2.drShiftTo(this.m.t, x2);
        if (x2.compareTo(this.m) >= 0)
          x2.subTo(this.m, x2);
      }
      function montSqrTo(x2, r) {
        x2.squareTo(r);
        this.reduce(r);
      }
      function montMulTo(x2, y, r) {
        x2.multiplyTo(y, r);
        this.reduce(r);
      }
      Montgomery.prototype.convert = montConvert;
      Montgomery.prototype.revert = montRevert;
      Montgomery.prototype.reduce = montReduce;
      Montgomery.prototype.mulTo = montMulTo;
      Montgomery.prototype.sqrTo = montSqrTo;
      function bnpIsEven() {
        return (this.t > 0 ? this[0] & 1 : this.s) == 0;
      }
      function bnpExp(e, z2) {
        if (e > 4294967295 || e < 1)
          return BigInteger.ONE;
        var r = nbi(), r2 = nbi(), g2 = z2.convert(this), i = nbits(e) - 1;
        g2.copyTo(r);
        while (--i >= 0) {
          z2.sqrTo(r, r2);
          if ((e & 1 << i) > 0)
            z2.mulTo(r2, g2, r);
          else {
            var t2 = r;
            r = r2;
            r2 = t2;
          }
        }
        return z2.revert(r);
      }
      function bnModPowInt(e, m2) {
        var z2;
        if (e < 256 || m2.isEven())
          z2 = new Classic(m2);
        else
          z2 = new Montgomery(m2);
        return this.exp(e, z2);
      }
      BigInteger.prototype.copyTo = bnpCopyTo;
      BigInteger.prototype.fromInt = bnpFromInt;
      BigInteger.prototype.fromString = bnpFromString;
      BigInteger.prototype.clamp = bnpClamp;
      BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
      BigInteger.prototype.drShiftTo = bnpDRShiftTo;
      BigInteger.prototype.lShiftTo = bnpLShiftTo;
      BigInteger.prototype.rShiftTo = bnpRShiftTo;
      BigInteger.prototype.subTo = bnpSubTo;
      BigInteger.prototype.multiplyTo = bnpMultiplyTo;
      BigInteger.prototype.squareTo = bnpSquareTo;
      BigInteger.prototype.divRemTo = bnpDivRemTo;
      BigInteger.prototype.invDigit = bnpInvDigit;
      BigInteger.prototype.isEven = bnpIsEven;
      BigInteger.prototype.exp = bnpExp;
      BigInteger.prototype.toString = bnToString;
      BigInteger.prototype.negate = bnNegate;
      BigInteger.prototype.abs = bnAbs;
      BigInteger.prototype.compareTo = bnCompareTo;
      BigInteger.prototype.bitLength = bnBitLength;
      BigInteger.prototype.mod = bnMod;
      BigInteger.prototype.modPowInt = bnModPowInt;
      BigInteger.ZERO = nbv(0);
      BigInteger.ONE = nbv(1);
      function bnClone() {
        var r = nbi();
        this.copyTo(r);
        return r;
      }
      function bnIntValue() {
        if (this.s < 0) {
          if (this.t == 1)
            return this[0] - this.DV;
          else if (this.t == 0)
            return -1;
        } else if (this.t == 1)
          return this[0];
        else if (this.t == 0)
          return 0;
        return (this[1] & (1 << 32 - this.DB) - 1) << this.DB | this[0];
      }
      function bnByteValue() {
        return this.t == 0 ? this.s : this[0] << 24 >> 24;
      }
      function bnShortValue() {
        return this.t == 0 ? this.s : this[0] << 16 >> 16;
      }
      function bnpChunkSize(r) {
        return Math.floor(Math.LN2 * this.DB / Math.log(r));
      }
      function bnSigNum() {
        if (this.s < 0)
          return -1;
        else if (this.t <= 0 || this.t == 1 && this[0] <= 0)
          return 0;
        else
          return 1;
      }
      function bnpToRadix(b) {
        if (b == null)
          b = 10;
        if (this.signum() == 0 || b < 2 || b > 36)
          return "0";
        var cs = this.chunkSize(b);
        var a = Math.pow(b, cs);
        var d2 = nbv(a), y = nbi(), z2 = nbi(), r = "";
        this.divRemTo(d2, y, z2);
        while (y.signum() > 0) {
          r = (a + z2.intValue()).toString(b).substr(1) + r;
          y.divRemTo(d2, y, z2);
        }
        return z2.intValue().toString(b) + r;
      }
      function bnpFromRadix(s, b) {
        this.fromInt(0);
        if (b == null)
          b = 10;
        var cs = this.chunkSize(b);
        var d2 = Math.pow(b, cs), mi = false, j = 0, w = 0;
        for (var i = 0; i < s.length; ++i) {
          var x2 = intAt(s, i);
          if (x2 < 0) {
            if (s.charAt(i) == "-" && this.signum() == 0)
              mi = true;
            continue;
          }
          w = b * w + x2;
          if (++j >= cs) {
            this.dMultiply(d2);
            this.dAddOffset(w, 0);
            j = 0;
            w = 0;
          }
        }
        if (j > 0) {
          this.dMultiply(Math.pow(b, j));
          this.dAddOffset(w, 0);
        }
        if (mi)
          BigInteger.ZERO.subTo(this, this);
      }
      function bnpFromNumber(a, b, c2) {
        if ("number" == typeof b) {
          if (a < 2)
            this.fromInt(1);
          else {
            this.fromNumber(a, c2);
            if (!this.testBit(a - 1))
              this.bitwiseTo(BigInteger.ONE.shiftLeft(a - 1), op_or, this);
            if (this.isEven())
              this.dAddOffset(1, 0);
            while (!this.isProbablePrime(b)) {
              this.dAddOffset(2, 0);
              if (this.bitLength() > a)
                this.subTo(BigInteger.ONE.shiftLeft(a - 1), this);
            }
          }
        } else {
          var x2 = new Array(), t2 = a & 7;
          x2.length = (a >> 3) + 1;
          b.nextBytes(x2);
          if (t2 > 0)
            x2[0] &= (1 << t2) - 1;
          else
            x2[0] = 0;
          this.fromString(x2, 256);
        }
      }
      function bnToByteArray() {
        var i = this.t, r = new Array();
        r[0] = this.s;
        var p3 = this.DB - i * this.DB % 8, d2, k = 0;
        if (i-- > 0) {
          if (p3 < this.DB && (d2 = this[i] >> p3) != (this.s & this.DM) >> p3)
            r[k++] = d2 | this.s << this.DB - p3;
          while (i >= 0) {
            if (p3 < 8) {
              d2 = (this[i] & (1 << p3) - 1) << 8 - p3;
              d2 |= this[--i] >> (p3 += this.DB - 8);
            } else {
              d2 = this[i] >> (p3 -= 8) & 255;
              if (p3 <= 0) {
                p3 += this.DB;
                --i;
              }
            }
            if ((d2 & 128) != 0)
              d2 |= -256;
            if (k == 0 && (this.s & 128) != (d2 & 128))
              ++k;
            if (k > 0 || d2 != this.s)
              r[k++] = d2;
          }
        }
        return r;
      }
      function bnEquals(a) {
        return this.compareTo(a) == 0;
      }
      function bnMin(a) {
        return this.compareTo(a) < 0 ? this : a;
      }
      function bnMax(a) {
        return this.compareTo(a) > 0 ? this : a;
      }
      function bnpBitwiseTo(a, op, r) {
        var i, f2, m2 = Math.min(a.t, this.t);
        for (i = 0; i < m2; ++i)
          r[i] = op(this[i], a[i]);
        if (a.t < this.t) {
          f2 = a.s & this.DM;
          for (i = m2; i < this.t; ++i)
            r[i] = op(this[i], f2);
          r.t = this.t;
        } else {
          f2 = this.s & this.DM;
          for (i = m2; i < a.t; ++i)
            r[i] = op(f2, a[i]);
          r.t = a.t;
        }
        r.s = op(this.s, a.s);
        r.clamp();
      }
      function op_and(x2, y) {
        return x2 & y;
      }
      function bnAnd(a) {
        var r = nbi();
        this.bitwiseTo(a, op_and, r);
        return r;
      }
      function op_or(x2, y) {
        return x2 | y;
      }
      function bnOr(a) {
        var r = nbi();
        this.bitwiseTo(a, op_or, r);
        return r;
      }
      function op_xor(x2, y) {
        return x2 ^ y;
      }
      function bnXor(a) {
        var r = nbi();
        this.bitwiseTo(a, op_xor, r);
        return r;
      }
      function op_andnot(x2, y) {
        return x2 & ~y;
      }
      function bnAndNot(a) {
        var r = nbi();
        this.bitwiseTo(a, op_andnot, r);
        return r;
      }
      function bnNot() {
        var r = nbi();
        for (var i = 0; i < this.t; ++i)
          r[i] = this.DM & ~this[i];
        r.t = this.t;
        r.s = ~this.s;
        return r;
      }
      function bnShiftLeft(n) {
        var r = nbi();
        if (n < 0)
          this.rShiftTo(-n, r);
        else
          this.lShiftTo(n, r);
        return r;
      }
      function bnShiftRight(n) {
        var r = nbi();
        if (n < 0)
          this.lShiftTo(-n, r);
        else
          this.rShiftTo(n, r);
        return r;
      }
      function lbit(x2) {
        if (x2 == 0)
          return -1;
        var r = 0;
        if ((x2 & 65535) == 0) {
          x2 >>= 16;
          r += 16;
        }
        if ((x2 & 255) == 0) {
          x2 >>= 8;
          r += 8;
        }
        if ((x2 & 15) == 0) {
          x2 >>= 4;
          r += 4;
        }
        if ((x2 & 3) == 0) {
          x2 >>= 2;
          r += 2;
        }
        if ((x2 & 1) == 0)
          ++r;
        return r;
      }
      function bnGetLowestSetBit() {
        for (var i = 0; i < this.t; ++i)
          if (this[i] != 0)
            return i * this.DB + lbit(this[i]);
        if (this.s < 0)
          return this.t * this.DB;
        return -1;
      }
      function cbit(x2) {
        var r = 0;
        while (x2 != 0) {
          x2 &= x2 - 1;
          ++r;
        }
        return r;
      }
      function bnBitCount() {
        var r = 0, x2 = this.s & this.DM;
        for (var i = 0; i < this.t; ++i)
          r += cbit(this[i] ^ x2);
        return r;
      }
      function bnTestBit(n) {
        var j = Math.floor(n / this.DB);
        if (j >= this.t)
          return this.s != 0;
        return (this[j] & 1 << n % this.DB) != 0;
      }
      function bnpChangeBit(n, op) {
        var r = BigInteger.ONE.shiftLeft(n);
        this.bitwiseTo(r, op, r);
        return r;
      }
      function bnSetBit(n) {
        return this.changeBit(n, op_or);
      }
      function bnClearBit(n) {
        return this.changeBit(n, op_andnot);
      }
      function bnFlipBit(n) {
        return this.changeBit(n, op_xor);
      }
      function bnpAddTo(a, r) {
        var i = 0, c2 = 0, m2 = Math.min(a.t, this.t);
        while (i < m2) {
          c2 += this[i] + a[i];
          r[i++] = c2 & this.DM;
          c2 >>= this.DB;
        }
        if (a.t < this.t) {
          c2 += a.s;
          while (i < this.t) {
            c2 += this[i];
            r[i++] = c2 & this.DM;
            c2 >>= this.DB;
          }
          c2 += this.s;
        } else {
          c2 += this.s;
          while (i < a.t) {
            c2 += a[i];
            r[i++] = c2 & this.DM;
            c2 >>= this.DB;
          }
          c2 += a.s;
        }
        r.s = c2 < 0 ? -1 : 0;
        if (c2 > 0)
          r[i++] = c2;
        else if (c2 < -1)
          r[i++] = this.DV + c2;
        r.t = i;
        r.clamp();
      }
      function bnAdd(a) {
        var r = nbi();
        this.addTo(a, r);
        return r;
      }
      function bnSubtract(a) {
        var r = nbi();
        this.subTo(a, r);
        return r;
      }
      function bnMultiply(a) {
        var r = nbi();
        this.multiplyTo(a, r);
        return r;
      }
      function bnSquare() {
        var r = nbi();
        this.squareTo(r);
        return r;
      }
      function bnDivide(a) {
        var r = nbi();
        this.divRemTo(a, r, null);
        return r;
      }
      function bnRemainder(a) {
        var r = nbi();
        this.divRemTo(a, null, r);
        return r;
      }
      function bnDivideAndRemainder(a) {
        var q2 = nbi(), r = nbi();
        this.divRemTo(a, q2, r);
        return new Array(q2, r);
      }
      function bnpDMultiply(n) {
        this[this.t] = this.am(0, n - 1, this, 0, 0, this.t);
        ++this.t;
        this.clamp();
      }
      function bnpDAddOffset(n, w) {
        if (n == 0)
          return;
        while (this.t <= w)
          this[this.t++] = 0;
        this[w] += n;
        while (this[w] >= this.DV) {
          this[w] -= this.DV;
          if (++w >= this.t)
            this[this.t++] = 0;
          ++this[w];
        }
      }
      function NullExp() {
      }
      function nNop(x2) {
        return x2;
      }
      function nMulTo(x2, y, r) {
        x2.multiplyTo(y, r);
      }
      function nSqrTo(x2, r) {
        x2.squareTo(r);
      }
      NullExp.prototype.convert = nNop;
      NullExp.prototype.revert = nNop;
      NullExp.prototype.mulTo = nMulTo;
      NullExp.prototype.sqrTo = nSqrTo;
      function bnPow(e) {
        return this.exp(e, new NullExp());
      }
      function bnpMultiplyLowerTo(a, n, r) {
        var i = Math.min(this.t + a.t, n);
        r.s = 0;
        r.t = i;
        while (i > 0)
          r[--i] = 0;
        var j;
        for (j = r.t - this.t; i < j; ++i)
          r[i + this.t] = this.am(0, a[i], r, i, 0, this.t);
        for (j = Math.min(a.t, n); i < j; ++i)
          this.am(0, a[i], r, i, 0, n - i);
        r.clamp();
      }
      function bnpMultiplyUpperTo(a, n, r) {
        --n;
        var i = r.t = this.t + a.t - n;
        r.s = 0;
        while (--i >= 0)
          r[i] = 0;
        for (i = Math.max(n - this.t, 0); i < a.t; ++i)
          r[this.t + i - n] = this.am(n - i, a[i], r, 0, 0, this.t + i - n);
        r.clamp();
        r.drShiftTo(1, r);
      }
      function Barrett(m2) {
        this.r2 = nbi();
        this.q3 = nbi();
        BigInteger.ONE.dlShiftTo(2 * m2.t, this.r2);
        this.mu = this.r2.divide(m2);
        this.m = m2;
      }
      function barrettConvert(x2) {
        if (x2.s < 0 || x2.t > 2 * this.m.t)
          return x2.mod(this.m);
        else if (x2.compareTo(this.m) < 0)
          return x2;
        else {
          var r = nbi();
          x2.copyTo(r);
          this.reduce(r);
          return r;
        }
      }
      function barrettRevert(x2) {
        return x2;
      }
      function barrettReduce(x2) {
        x2.drShiftTo(this.m.t - 1, this.r2);
        if (x2.t > this.m.t + 1) {
          x2.t = this.m.t + 1;
          x2.clamp();
        }
        this.mu.multiplyUpperTo(this.r2, this.m.t + 1, this.q3);
        this.m.multiplyLowerTo(this.q3, this.m.t + 1, this.r2);
        while (x2.compareTo(this.r2) < 0)
          x2.dAddOffset(1, this.m.t + 1);
        x2.subTo(this.r2, x2);
        while (x2.compareTo(this.m) >= 0)
          x2.subTo(this.m, x2);
      }
      function barrettSqrTo(x2, r) {
        x2.squareTo(r);
        this.reduce(r);
      }
      function barrettMulTo(x2, y, r) {
        x2.multiplyTo(y, r);
        this.reduce(r);
      }
      Barrett.prototype.convert = barrettConvert;
      Barrett.prototype.revert = barrettRevert;
      Barrett.prototype.reduce = barrettReduce;
      Barrett.prototype.mulTo = barrettMulTo;
      Barrett.prototype.sqrTo = barrettSqrTo;
      function bnModPow(e, m2) {
        var i = e.bitLength(), k, r = nbv(1), z2;
        if (i <= 0)
          return r;
        else if (i < 18)
          k = 1;
        else if (i < 48)
          k = 3;
        else if (i < 144)
          k = 4;
        else if (i < 768)
          k = 5;
        else
          k = 6;
        if (i < 8)
          z2 = new Classic(m2);
        else if (m2.isEven())
          z2 = new Barrett(m2);
        else
          z2 = new Montgomery(m2);
        var g2 = new Array(), n = 3, k1 = k - 1, km = (1 << k) - 1;
        g2[1] = z2.convert(this);
        if (k > 1) {
          var g22 = nbi();
          z2.sqrTo(g2[1], g22);
          while (n <= km) {
            g2[n] = nbi();
            z2.mulTo(g22, g2[n - 2], g2[n]);
            n += 2;
          }
        }
        var j = e.t - 1, w, is1 = true, r2 = nbi(), t2;
        i = nbits(e[j]) - 1;
        while (j >= 0) {
          if (i >= k1)
            w = e[j] >> i - k1 & km;
          else {
            w = (e[j] & (1 << i + 1) - 1) << k1 - i;
            if (j > 0)
              w |= e[j - 1] >> this.DB + i - k1;
          }
          n = k;
          while ((w & 1) == 0) {
            w >>= 1;
            --n;
          }
          if ((i -= n) < 0) {
            i += this.DB;
            --j;
          }
          if (is1) {
            g2[w].copyTo(r);
            is1 = false;
          } else {
            while (n > 1) {
              z2.sqrTo(r, r2);
              z2.sqrTo(r2, r);
              n -= 2;
            }
            if (n > 0)
              z2.sqrTo(r, r2);
            else {
              t2 = r;
              r = r2;
              r2 = t2;
            }
            z2.mulTo(r2, g2[w], r);
          }
          while (j >= 0 && (e[j] & 1 << i) == 0) {
            z2.sqrTo(r, r2);
            t2 = r;
            r = r2;
            r2 = t2;
            if (--i < 0) {
              i = this.DB - 1;
              --j;
            }
          }
        }
        return z2.revert(r);
      }
      function bnGCD(a) {
        var x2 = this.s < 0 ? this.negate() : this.clone();
        var y = a.s < 0 ? a.negate() : a.clone();
        if (x2.compareTo(y) < 0) {
          var t2 = x2;
          x2 = y;
          y = t2;
        }
        var i = x2.getLowestSetBit(), g2 = y.getLowestSetBit();
        if (g2 < 0)
          return x2;
        if (i < g2)
          g2 = i;
        if (g2 > 0) {
          x2.rShiftTo(g2, x2);
          y.rShiftTo(g2, y);
        }
        while (x2.signum() > 0) {
          if ((i = x2.getLowestSetBit()) > 0)
            x2.rShiftTo(i, x2);
          if ((i = y.getLowestSetBit()) > 0)
            y.rShiftTo(i, y);
          if (x2.compareTo(y) >= 0) {
            x2.subTo(y, x2);
            x2.rShiftTo(1, x2);
          } else {
            y.subTo(x2, y);
            y.rShiftTo(1, y);
          }
        }
        if (g2 > 0)
          y.lShiftTo(g2, y);
        return y;
      }
      function bnpModInt(n) {
        if (n <= 0)
          return 0;
        var d2 = this.DV % n, r = this.s < 0 ? n - 1 : 0;
        if (this.t > 0)
          if (d2 == 0)
            r = this[0] % n;
          else
            for (var i = this.t - 1; i >= 0; --i)
              r = (d2 * r + this[i]) % n;
        return r;
      }
      function bnModInverse(m2) {
        var ac = m2.isEven();
        if (this.isEven() && ac || m2.signum() == 0)
          return BigInteger.ZERO;
        var u2 = m2.clone(), v = this.clone();
        var a = nbv(1), b = nbv(0), c2 = nbv(0), d2 = nbv(1);
        while (u2.signum() != 0) {
          while (u2.isEven()) {
            u2.rShiftTo(1, u2);
            if (ac) {
              if (!a.isEven() || !b.isEven()) {
                a.addTo(this, a);
                b.subTo(m2, b);
              }
              a.rShiftTo(1, a);
            } else if (!b.isEven())
              b.subTo(m2, b);
            b.rShiftTo(1, b);
          }
          while (v.isEven()) {
            v.rShiftTo(1, v);
            if (ac) {
              if (!c2.isEven() || !d2.isEven()) {
                c2.addTo(this, c2);
                d2.subTo(m2, d2);
              }
              c2.rShiftTo(1, c2);
            } else if (!d2.isEven())
              d2.subTo(m2, d2);
            d2.rShiftTo(1, d2);
          }
          if (u2.compareTo(v) >= 0) {
            u2.subTo(v, u2);
            if (ac)
              a.subTo(c2, a);
            b.subTo(d2, b);
          } else {
            v.subTo(u2, v);
            if (ac)
              c2.subTo(a, c2);
            d2.subTo(b, d2);
          }
        }
        if (v.compareTo(BigInteger.ONE) != 0)
          return BigInteger.ZERO;
        if (d2.compareTo(m2) >= 0)
          return d2.subtract(m2);
        if (d2.signum() < 0)
          d2.addTo(m2, d2);
        else
          return d2;
        if (d2.signum() < 0)
          return d2.add(m2);
        else
          return d2;
      }
      var lowprimes = [2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101, 103, 107, 109, 113, 127, 131, 137, 139, 149, 151, 157, 163, 167, 173, 179, 181, 191, 193, 197, 199, 211, 223, 227, 229, 233, 239, 241, 251, 257, 263, 269, 271, 277, 281, 283, 293, 307, 311, 313, 317, 331, 337, 347, 349, 353, 359, 367, 373, 379, 383, 389, 397, 401, 409, 419, 421, 431, 433, 439, 443, 449, 457, 461, 463, 467, 479, 487, 491, 499, 503, 509, 521, 523, 541, 547, 557, 563, 569, 571, 577, 587, 593, 599, 601, 607, 613, 617, 619, 631, 641, 643, 647, 653, 659, 661, 673, 677, 683, 691, 701, 709, 719, 727, 733, 739, 743, 751, 757, 761, 769, 773, 787, 797, 809, 811, 821, 823, 827, 829, 839, 853, 857, 859, 863, 877, 881, 883, 887, 907, 911, 919, 929, 937, 941, 947, 953, 967, 971, 977, 983, 991, 997];
      var lplim = (1 << 26) / lowprimes[lowprimes.length - 1];
      function bnIsProbablePrime(t2) {
        var i, x2 = this.abs();
        if (x2.t == 1 && x2[0] <= lowprimes[lowprimes.length - 1]) {
          for (i = 0; i < lowprimes.length; ++i)
            if (x2[0] == lowprimes[i])
              return true;
          return false;
        }
        if (x2.isEven())
          return false;
        i = 1;
        while (i < lowprimes.length) {
          var m2 = lowprimes[i], j = i + 1;
          while (j < lowprimes.length && m2 < lplim)
            m2 *= lowprimes[j++];
          m2 = x2.modInt(m2);
          while (i < j)
            if (m2 % lowprimes[i++] == 0)
              return false;
        }
        return x2.millerRabin(t2);
      }
      function bnpMillerRabin(t2) {
        var n1 = this.subtract(BigInteger.ONE);
        var k = n1.getLowestSetBit();
        if (k <= 0)
          return false;
        var r = n1.shiftRight(k);
        t2 = t2 + 1 >> 1;
        if (t2 > lowprimes.length)
          t2 = lowprimes.length;
        var a = nbi();
        for (var i = 0; i < t2; ++i) {
          a.fromInt(lowprimes[Math.floor(Math.random() * lowprimes.length)]);
          var y = a.modPow(r, this);
          if (y.compareTo(BigInteger.ONE) != 0 && y.compareTo(n1) != 0) {
            var j = 1;
            while (j++ < k && y.compareTo(n1) != 0) {
              y = y.modPowInt(2, this);
              if (y.compareTo(BigInteger.ONE) == 0)
                return false;
            }
            if (y.compareTo(n1) != 0)
              return false;
          }
        }
        return true;
      }
      BigInteger.prototype.chunkSize = bnpChunkSize;
      BigInteger.prototype.toRadix = bnpToRadix;
      BigInteger.prototype.fromRadix = bnpFromRadix;
      BigInteger.prototype.fromNumber = bnpFromNumber;
      BigInteger.prototype.bitwiseTo = bnpBitwiseTo;
      BigInteger.prototype.changeBit = bnpChangeBit;
      BigInteger.prototype.addTo = bnpAddTo;
      BigInteger.prototype.dMultiply = bnpDMultiply;
      BigInteger.prototype.dAddOffset = bnpDAddOffset;
      BigInteger.prototype.multiplyLowerTo = bnpMultiplyLowerTo;
      BigInteger.prototype.multiplyUpperTo = bnpMultiplyUpperTo;
      BigInteger.prototype.modInt = bnpModInt;
      BigInteger.prototype.millerRabin = bnpMillerRabin;
      BigInteger.prototype.clone = bnClone;
      BigInteger.prototype.intValue = bnIntValue;
      BigInteger.prototype.byteValue = bnByteValue;
      BigInteger.prototype.shortValue = bnShortValue;
      BigInteger.prototype.signum = bnSigNum;
      BigInteger.prototype.toByteArray = bnToByteArray;
      BigInteger.prototype.equals = bnEquals;
      BigInteger.prototype.min = bnMin;
      BigInteger.prototype.max = bnMax;
      BigInteger.prototype.and = bnAnd;
      BigInteger.prototype.or = bnOr;
      BigInteger.prototype.xor = bnXor;
      BigInteger.prototype.andNot = bnAndNot;
      BigInteger.prototype.not = bnNot;
      BigInteger.prototype.shiftLeft = bnShiftLeft;
      BigInteger.prototype.shiftRight = bnShiftRight;
      BigInteger.prototype.getLowestSetBit = bnGetLowestSetBit;
      BigInteger.prototype.bitCount = bnBitCount;
      BigInteger.prototype.testBit = bnTestBit;
      BigInteger.prototype.setBit = bnSetBit;
      BigInteger.prototype.clearBit = bnClearBit;
      BigInteger.prototype.flipBit = bnFlipBit;
      BigInteger.prototype.add = bnAdd;
      BigInteger.prototype.subtract = bnSubtract;
      BigInteger.prototype.multiply = bnMultiply;
      BigInteger.prototype.divide = bnDivide;
      BigInteger.prototype.remainder = bnRemainder;
      BigInteger.prototype.divideAndRemainder = bnDivideAndRemainder;
      BigInteger.prototype.modPow = bnModPow;
      BigInteger.prototype.modInverse = bnModInverse;
      BigInteger.prototype.pow = bnPow;
      BigInteger.prototype.gcd = bnGCD;
      BigInteger.prototype.isProbablePrime = bnIsProbablePrime;
      BigInteger.prototype.square = bnSquare;
      BigInteger.prototype.Barrett = Barrett;
      var rng_state;
      var rng_pool;
      var rng_pptr;
      function rng_seed_int(x2) {
        rng_pool[rng_pptr++] ^= x2 & 255;
        rng_pool[rng_pptr++] ^= x2 >> 8 & 255;
        rng_pool[rng_pptr++] ^= x2 >> 16 & 255;
        rng_pool[rng_pptr++] ^= x2 >> 24 & 255;
        if (rng_pptr >= rng_psize)
          rng_pptr -= rng_psize;
      }
      function rng_seed_time() {
        rng_seed_int((/* @__PURE__ */ new Date()).getTime());
      }
      if (rng_pool == null) {
        rng_pool = new Array();
        rng_pptr = 0;
        var t;
        if (typeof window !== "undefined" && window.crypto) {
          if (window.crypto.getRandomValues) {
            var ua = new Uint8Array(32);
            window.crypto.getRandomValues(ua);
            for (t = 0; t < 32; ++t)
              rng_pool[rng_pptr++] = ua[t];
          } else if (navigator.appName == "Netscape" && navigator.appVersion < "5") {
            var z = window.crypto.random(32);
            for (t = 0; t < z.length; ++t)
              rng_pool[rng_pptr++] = z.charCodeAt(t) & 255;
          }
        }
        while (rng_pptr < rng_psize) {
          t = Math.floor(65536 * Math.random());
          rng_pool[rng_pptr++] = t >>> 8;
          rng_pool[rng_pptr++] = t & 255;
        }
        rng_pptr = 0;
        rng_seed_time();
      }
      function rng_get_byte() {
        if (rng_state == null) {
          rng_seed_time();
          rng_state = prng_newstate();
          rng_state.init(rng_pool);
          for (rng_pptr = 0; rng_pptr < rng_pool.length; ++rng_pptr)
            rng_pool[rng_pptr] = 0;
          rng_pptr = 0;
        }
        return rng_state.next();
      }
      function rng_get_bytes(ba) {
        var i;
        for (i = 0; i < ba.length; ++i)
          ba[i] = rng_get_byte();
      }
      function SecureRandom2() {
      }
      SecureRandom2.prototype.nextBytes = rng_get_bytes;
      function Arcfour() {
        this.i = 0;
        this.j = 0;
        this.S = new Array();
      }
      function ARC4init(key) {
        var i, j, t2;
        for (i = 0; i < 256; ++i)
          this.S[i] = i;
        j = 0;
        for (i = 0; i < 256; ++i) {
          j = j + this.S[i] + key[i % key.length] & 255;
          t2 = this.S[i];
          this.S[i] = this.S[j];
          this.S[j] = t2;
        }
        this.i = 0;
        this.j = 0;
      }
      function ARC4next() {
        var t2;
        this.i = this.i + 1 & 255;
        this.j = this.j + this.S[this.i] & 255;
        t2 = this.S[this.i];
        this.S[this.i] = this.S[this.j];
        this.S[this.j] = t2;
        return this.S[t2 + this.S[this.i] & 255];
      }
      Arcfour.prototype.init = ARC4init;
      Arcfour.prototype.next = ARC4next;
      function prng_newstate() {
        return new Arcfour();
      }
      var rng_psize = 256;
      BigInteger.SecureRandom = SecureRandom2;
      BigInteger.BigInteger = BigInteger;
      if (typeof exports2 !== "undefined") {
        exports2 = module2.exports = BigInteger;
      } else {
        this.BigInteger = BigInteger;
        this.SecureRandom = SecureRandom2;
      }
    }).call(exports2);
  }
});

// node_modules/ecc-jsbn/lib/ec.js
var require_ec = __commonJS({
  "node_modules/ecc-jsbn/lib/ec.js"(exports2, module2) {
    var BigInteger = require_jsbn().BigInteger;
    var Barrett = BigInteger.prototype.Barrett;
    function ECFieldElementFp(q2, x2) {
      this.x = x2;
      this.q = q2;
    }
    function feFpEquals(other) {
      if (other == this)
        return true;
      return this.q.equals(other.q) && this.x.equals(other.x);
    }
    function feFpToBigInteger() {
      return this.x;
    }
    function feFpNegate() {
      return new ECFieldElementFp(this.q, this.x.negate().mod(this.q));
    }
    function feFpAdd(b) {
      return new ECFieldElementFp(this.q, this.x.add(b.toBigInteger()).mod(this.q));
    }
    function feFpSubtract(b) {
      return new ECFieldElementFp(this.q, this.x.subtract(b.toBigInteger()).mod(this.q));
    }
    function feFpMultiply(b) {
      return new ECFieldElementFp(this.q, this.x.multiply(b.toBigInteger()).mod(this.q));
    }
    function feFpSquare() {
      return new ECFieldElementFp(this.q, this.x.square().mod(this.q));
    }
    function feFpDivide(b) {
      return new ECFieldElementFp(this.q, this.x.multiply(b.toBigInteger().modInverse(this.q)).mod(this.q));
    }
    ECFieldElementFp.prototype.equals = feFpEquals;
    ECFieldElementFp.prototype.toBigInteger = feFpToBigInteger;
    ECFieldElementFp.prototype.negate = feFpNegate;
    ECFieldElementFp.prototype.add = feFpAdd;
    ECFieldElementFp.prototype.subtract = feFpSubtract;
    ECFieldElementFp.prototype.multiply = feFpMultiply;
    ECFieldElementFp.prototype.square = feFpSquare;
    ECFieldElementFp.prototype.divide = feFpDivide;
    function ECPointFp(curve, x2, y, z) {
      this.curve = curve;
      this.x = x2;
      this.y = y;
      if (z == null) {
        this.z = BigInteger.ONE;
      } else {
        this.z = z;
      }
      this.zinv = null;
    }
    function pointFpGetX() {
      if (this.zinv == null) {
        this.zinv = this.z.modInverse(this.curve.q);
      }
      var r = this.x.toBigInteger().multiply(this.zinv);
      this.curve.reduce(r);
      return this.curve.fromBigInteger(r);
    }
    function pointFpGetY() {
      if (this.zinv == null) {
        this.zinv = this.z.modInverse(this.curve.q);
      }
      var r = this.y.toBigInteger().multiply(this.zinv);
      this.curve.reduce(r);
      return this.curve.fromBigInteger(r);
    }
    function pointFpEquals(other) {
      if (other == this)
        return true;
      if (this.isInfinity())
        return other.isInfinity();
      if (other.isInfinity())
        return this.isInfinity();
      var u2, v;
      u2 = other.y.toBigInteger().multiply(this.z).subtract(this.y.toBigInteger().multiply(other.z)).mod(this.curve.q);
      if (!u2.equals(BigInteger.ZERO))
        return false;
      v = other.x.toBigInteger().multiply(this.z).subtract(this.x.toBigInteger().multiply(other.z)).mod(this.curve.q);
      return v.equals(BigInteger.ZERO);
    }
    function pointFpIsInfinity() {
      if (this.x == null && this.y == null)
        return true;
      return this.z.equals(BigInteger.ZERO) && !this.y.toBigInteger().equals(BigInteger.ZERO);
    }
    function pointFpNegate() {
      return new ECPointFp(this.curve, this.x, this.y.negate(), this.z);
    }
    function pointFpAdd(b) {
      if (this.isInfinity())
        return b;
      if (b.isInfinity())
        return this;
      var u2 = b.y.toBigInteger().multiply(this.z).subtract(this.y.toBigInteger().multiply(b.z)).mod(this.curve.q);
      var v = b.x.toBigInteger().multiply(this.z).subtract(this.x.toBigInteger().multiply(b.z)).mod(this.curve.q);
      if (BigInteger.ZERO.equals(v)) {
        if (BigInteger.ZERO.equals(u2)) {
          return this.twice();
        }
        return this.curve.getInfinity();
      }
      var THREE = new BigInteger("3");
      var x1 = this.x.toBigInteger();
      var y1 = this.y.toBigInteger();
      var x2 = b.x.toBigInteger();
      var y2 = b.y.toBigInteger();
      var v2 = v.square();
      var v3 = v2.multiply(v);
      var x1v2 = x1.multiply(v2);
      var zu2 = u2.square().multiply(this.z);
      var x3 = zu2.subtract(x1v2.shiftLeft(1)).multiply(b.z).subtract(v3).multiply(v).mod(this.curve.q);
      var y3 = x1v2.multiply(THREE).multiply(u2).subtract(y1.multiply(v3)).subtract(zu2.multiply(u2)).multiply(b.z).add(u2.multiply(v3)).mod(this.curve.q);
      var z3 = v3.multiply(this.z).multiply(b.z).mod(this.curve.q);
      return new ECPointFp(this.curve, this.curve.fromBigInteger(x3), this.curve.fromBigInteger(y3), z3);
    }
    function pointFpTwice() {
      if (this.isInfinity())
        return this;
      if (this.y.toBigInteger().signum() == 0)
        return this.curve.getInfinity();
      var THREE = new BigInteger("3");
      var x1 = this.x.toBigInteger();
      var y1 = this.y.toBigInteger();
      var y1z1 = y1.multiply(this.z);
      var y1sqz1 = y1z1.multiply(y1).mod(this.curve.q);
      var a = this.curve.a.toBigInteger();
      var w = x1.square().multiply(THREE);
      if (!BigInteger.ZERO.equals(a)) {
        w = w.add(this.z.square().multiply(a));
      }
      w = w.mod(this.curve.q);
      var x3 = w.square().subtract(x1.shiftLeft(3).multiply(y1sqz1)).shiftLeft(1).multiply(y1z1).mod(this.curve.q);
      var y3 = w.multiply(THREE).multiply(x1).subtract(y1sqz1.shiftLeft(1)).shiftLeft(2).multiply(y1sqz1).subtract(w.square().multiply(w)).mod(this.curve.q);
      var z3 = y1z1.square().multiply(y1z1).shiftLeft(3).mod(this.curve.q);
      return new ECPointFp(this.curve, this.curve.fromBigInteger(x3), this.curve.fromBigInteger(y3), z3);
    }
    function pointFpMultiply(k) {
      if (this.isInfinity())
        return this;
      if (k.signum() == 0)
        return this.curve.getInfinity();
      var e = k;
      var h = e.multiply(new BigInteger("3"));
      var neg = this.negate();
      var R2 = this;
      var i;
      for (i = h.bitLength() - 2; i > 0; --i) {
        R2 = R2.twice();
        var hBit = h.testBit(i);
        var eBit = e.testBit(i);
        if (hBit != eBit) {
          R2 = R2.add(hBit ? this : neg);
        }
      }
      return R2;
    }
    function pointFpMultiplyTwo(j, x2, k) {
      var i;
      if (j.bitLength() > k.bitLength())
        i = j.bitLength() - 1;
      else
        i = k.bitLength() - 1;
      var R2 = this.curve.getInfinity();
      var both = this.add(x2);
      while (i >= 0) {
        R2 = R2.twice();
        if (j.testBit(i)) {
          if (k.testBit(i)) {
            R2 = R2.add(both);
          } else {
            R2 = R2.add(this);
          }
        } else {
          if (k.testBit(i)) {
            R2 = R2.add(x2);
          }
        }
        --i;
      }
      return R2;
    }
    ECPointFp.prototype.getX = pointFpGetX;
    ECPointFp.prototype.getY = pointFpGetY;
    ECPointFp.prototype.equals = pointFpEquals;
    ECPointFp.prototype.isInfinity = pointFpIsInfinity;
    ECPointFp.prototype.negate = pointFpNegate;
    ECPointFp.prototype.add = pointFpAdd;
    ECPointFp.prototype.twice = pointFpTwice;
    ECPointFp.prototype.multiply = pointFpMultiply;
    ECPointFp.prototype.multiplyTwo = pointFpMultiplyTwo;
    function ECCurveFp(q2, a, b) {
      this.q = q2;
      this.a = this.fromBigInteger(a);
      this.b = this.fromBigInteger(b);
      this.infinity = new ECPointFp(this, null, null);
      this.reducer = new Barrett(this.q);
    }
    function curveFpGetQ() {
      return this.q;
    }
    function curveFpGetA() {
      return this.a;
    }
    function curveFpGetB() {
      return this.b;
    }
    function curveFpEquals(other) {
      if (other == this)
        return true;
      return this.q.equals(other.q) && this.a.equals(other.a) && this.b.equals(other.b);
    }
    function curveFpGetInfinity() {
      return this.infinity;
    }
    function curveFpFromBigInteger(x2) {
      return new ECFieldElementFp(this.q, x2);
    }
    function curveReduce(x2) {
      this.reducer.reduce(x2);
    }
    function curveFpEncodePointHex(p3) {
      if (p3.isInfinity())
        return "00";
      var xHex = p3.getX().toBigInteger().toString(16);
      var yHex = p3.getY().toBigInteger().toString(16);
      var oLen = this.getQ().toString(16).length;
      if (oLen % 2 != 0)
        oLen++;
      while (xHex.length < oLen) {
        xHex = "0" + xHex;
      }
      while (yHex.length < oLen) {
        yHex = "0" + yHex;
      }
      return "04" + xHex + yHex;
    }
    ECCurveFp.prototype.getQ = curveFpGetQ;
    ECCurveFp.prototype.getA = curveFpGetA;
    ECCurveFp.prototype.getB = curveFpGetB;
    ECCurveFp.prototype.equals = curveFpEquals;
    ECCurveFp.prototype.getInfinity = curveFpGetInfinity;
    ECCurveFp.prototype.fromBigInteger = curveFpFromBigInteger;
    ECCurveFp.prototype.reduce = curveReduce;
    ECCurveFp.prototype.encodePointHex = curveFpEncodePointHex;
    ECCurveFp.prototype.decodePointHex = function(s) {
      var yIsEven;
      switch (parseInt(s.substr(0, 2), 16)) {
        case 0:
          return this.infinity;
        case 2:
          yIsEven = false;
        case 3:
          if (yIsEven == void 0)
            yIsEven = true;
          var len = s.length - 2;
          var xHex = s.substr(2, len);
          var x2 = this.fromBigInteger(new BigInteger(xHex, 16));
          var alpha = x2.multiply(x2.square().add(this.getA())).add(this.getB());
          var beta = alpha.sqrt();
          if (beta == null)
            throw "Invalid point compression";
          var betaValue = beta.toBigInteger();
          if (betaValue.testBit(0) != yIsEven) {
            beta = this.fromBigInteger(this.getQ().subtract(betaValue));
          }
          return new ECPointFp(this, x2, beta);
        case 4:
        case 6:
        case 7:
          var len = (s.length - 2) / 2;
          var xHex = s.substr(2, len);
          var yHex = s.substr(len + 2, len);
          return new ECPointFp(
            this,
            this.fromBigInteger(new BigInteger(xHex, 16)),
            this.fromBigInteger(new BigInteger(yHex, 16))
          );
        default:
          return null;
      }
    };
    ECCurveFp.prototype.encodeCompressedPointHex = function(p3) {
      if (p3.isInfinity())
        return "00";
      var xHex = p3.getX().toBigInteger().toString(16);
      var oLen = this.getQ().toString(16).length;
      if (oLen % 2 != 0)
        oLen++;
      while (xHex.length < oLen)
        xHex = "0" + xHex;
      var yPrefix;
      if (p3.getY().toBigInteger().isEven())
        yPrefix = "02";
      else
        yPrefix = "03";
      return yPrefix + xHex;
    };
    ECFieldElementFp.prototype.getR = function() {
      if (this.r != void 0)
        return this.r;
      this.r = null;
      var bitLength = this.q.bitLength();
      if (bitLength > 128) {
        var firstWord = this.q.shiftRight(bitLength - 64);
        if (firstWord.intValue() == -1) {
          this.r = BigInteger.ONE.shiftLeft(bitLength).subtract(this.q);
        }
      }
      return this.r;
    };
    ECFieldElementFp.prototype.modMult = function(x1, x2) {
      return this.modReduce(x1.multiply(x2));
    };
    ECFieldElementFp.prototype.modReduce = function(x2) {
      if (this.getR() != null) {
        var qLen = q.bitLength();
        while (x2.bitLength() > qLen + 1) {
          var u2 = x2.shiftRight(qLen);
          var v = x2.subtract(u2.shiftLeft(qLen));
          if (!this.getR().equals(BigInteger.ONE)) {
            u2 = u2.multiply(this.getR());
          }
          x2 = u2.add(v);
        }
        while (x2.compareTo(q) >= 0) {
          x2 = x2.subtract(q);
        }
      } else {
        x2 = x2.mod(q);
      }
      return x2;
    };
    ECFieldElementFp.prototype.sqrt = function() {
      if (!this.q.testBit(0))
        throw "unsupported";
      if (this.q.testBit(1)) {
        var z = new ECFieldElementFp(this.q, this.x.modPow(this.q.shiftRight(2).add(BigInteger.ONE), this.q));
        return z.square().equals(this) ? z : null;
      }
      var qMinusOne = this.q.subtract(BigInteger.ONE);
      var legendreExponent = qMinusOne.shiftRight(1);
      if (!this.x.modPow(legendreExponent, this.q).equals(BigInteger.ONE)) {
        return null;
      }
      var u2 = qMinusOne.shiftRight(2);
      var k = u2.shiftLeft(1).add(BigInteger.ONE);
      var Q = this.x;
      var fourQ = modDouble(modDouble(Q));
      var U, V;
      do {
        var P;
        do {
          P = new BigInteger(this.q.bitLength(), new SecureRandom());
        } while (P.compareTo(this.q) >= 0 || !P.multiply(P).subtract(fourQ).modPow(legendreExponent, this.q).equals(qMinusOne));
        var result2 = this.lucasSequence(P, Q, k);
        U = result2[0];
        V = result2[1];
        if (this.modMult(V, V).equals(fourQ)) {
          if (V.testBit(0)) {
            V = V.add(q);
          }
          V = V.shiftRight(1);
          return new ECFieldElementFp(q, V);
        }
      } while (U.equals(BigInteger.ONE) || U.equals(qMinusOne));
      return null;
    };
    ECFieldElementFp.prototype.lucasSequence = function(P, Q, k) {
      var n = k.bitLength();
      var s = k.getLowestSetBit();
      var Uh = BigInteger.ONE;
      var Vl = BigInteger.TWO;
      var Vh = P;
      var Ql = BigInteger.ONE;
      var Qh = BigInteger.ONE;
      for (var j = n - 1; j >= s + 1; --j) {
        Ql = this.modMult(Ql, Qh);
        if (k.testBit(j)) {
          Qh = this.modMult(Ql, Q);
          Uh = this.modMult(Uh, Vh);
          Vl = this.modReduce(Vh.multiply(Vl).subtract(P.multiply(Ql)));
          Vh = this.modReduce(Vh.multiply(Vh).subtract(Qh.shiftLeft(1)));
        } else {
          Qh = Ql;
          Uh = this.modReduce(Uh.multiply(Vl).subtract(Ql));
          Vh = this.modReduce(Vh.multiply(Vl).subtract(P.multiply(Ql)));
          Vl = this.modReduce(Vl.multiply(Vl).subtract(Ql.shiftLeft(1)));
        }
      }
      Ql = this.modMult(Ql, Qh);
      Qh = this.modMult(Ql, Q);
      Uh = this.modReduce(Uh.multiply(Vl).subtract(Ql));
      Vl = this.modReduce(Vh.multiply(Vl).subtract(P.multiply(Ql)));
      Ql = this.modMult(Ql, Qh);
      for (var j = 1; j <= s; ++j) {
        Uh = this.modMult(Uh, Vl);
        Vl = this.modReduce(Vl.multiply(Vl).subtract(Ql.shiftLeft(1)));
        Ql = this.modMult(Ql, Ql);
      }
      return [Uh, Vl];
    };
    var exports2 = {
      ECCurveFp,
      ECPointFp,
      ECFieldElementFp
    };
    module2.exports = exports2;
  }
});

// node_modules/sshpk/node_modules/jsbn/index.js
var require_jsbn2 = __commonJS({
  "node_modules/sshpk/node_modules/jsbn/index.js"(exports2, module2) {
    (function() {
      var dbits;
      var canary = 244837814094590;
      var j_lm = (canary & 16777215) == 15715070;
      function BigInteger(a, b, c2) {
        if (a != null)
          if ("number" == typeof a)
            this.fromNumber(a, b, c2);
          else if (b == null && "string" != typeof a)
            this.fromString(a, 256);
          else
            this.fromString(a, b);
      }
      function nbi() {
        return new BigInteger(null);
      }
      function am1(i, x2, w, j, c2, n) {
        while (--n >= 0) {
          var v = x2 * this[i++] + w[j] + c2;
          c2 = Math.floor(v / 67108864);
          w[j++] = v & 67108863;
        }
        return c2;
      }
      function am2(i, x2, w, j, c2, n) {
        var xl = x2 & 32767, xh = x2 >> 15;
        while (--n >= 0) {
          var l2 = this[i] & 32767;
          var h = this[i++] >> 15;
          var m2 = xh * l2 + h * xl;
          l2 = xl * l2 + ((m2 & 32767) << 15) + w[j] + (c2 & 1073741823);
          c2 = (l2 >>> 30) + (m2 >>> 15) + xh * h + (c2 >>> 30);
          w[j++] = l2 & 1073741823;
        }
        return c2;
      }
      function am3(i, x2, w, j, c2, n) {
        var xl = x2 & 16383, xh = x2 >> 14;
        while (--n >= 0) {
          var l2 = this[i] & 16383;
          var h = this[i++] >> 14;
          var m2 = xh * l2 + h * xl;
          l2 = xl * l2 + ((m2 & 16383) << 14) + w[j] + c2;
          c2 = (l2 >> 28) + (m2 >> 14) + xh * h;
          w[j++] = l2 & 268435455;
        }
        return c2;
      }
      var inBrowser = typeof navigator !== "undefined";
      if (inBrowser && j_lm && navigator.appName == "Microsoft Internet Explorer") {
        BigInteger.prototype.am = am2;
        dbits = 30;
      } else if (inBrowser && j_lm && navigator.appName != "Netscape") {
        BigInteger.prototype.am = am1;
        dbits = 26;
      } else {
        BigInteger.prototype.am = am3;
        dbits = 28;
      }
      BigInteger.prototype.DB = dbits;
      BigInteger.prototype.DM = (1 << dbits) - 1;
      BigInteger.prototype.DV = 1 << dbits;
      var BI_FP = 52;
      BigInteger.prototype.FV = Math.pow(2, BI_FP);
      BigInteger.prototype.F1 = BI_FP - dbits;
      BigInteger.prototype.F2 = 2 * dbits - BI_FP;
      var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
      var BI_RC = new Array();
      var rr, vv;
      rr = "0".charCodeAt(0);
      for (vv = 0; vv <= 9; ++vv)
        BI_RC[rr++] = vv;
      rr = "a".charCodeAt(0);
      for (vv = 10; vv < 36; ++vv)
        BI_RC[rr++] = vv;
      rr = "A".charCodeAt(0);
      for (vv = 10; vv < 36; ++vv)
        BI_RC[rr++] = vv;
      function int2char(n) {
        return BI_RM.charAt(n);
      }
      function intAt(s, i) {
        var c2 = BI_RC[s.charCodeAt(i)];
        return c2 == null ? -1 : c2;
      }
      function bnpCopyTo(r) {
        for (var i = this.t - 1; i >= 0; --i)
          r[i] = this[i];
        r.t = this.t;
        r.s = this.s;
      }
      function bnpFromInt(x2) {
        this.t = 1;
        this.s = x2 < 0 ? -1 : 0;
        if (x2 > 0)
          this[0] = x2;
        else if (x2 < -1)
          this[0] = x2 + this.DV;
        else
          this.t = 0;
      }
      function nbv(i) {
        var r = nbi();
        r.fromInt(i);
        return r;
      }
      function bnpFromString(s, b) {
        var k;
        if (b == 16)
          k = 4;
        else if (b == 8)
          k = 3;
        else if (b == 256)
          k = 8;
        else if (b == 2)
          k = 1;
        else if (b == 32)
          k = 5;
        else if (b == 4)
          k = 2;
        else {
          this.fromRadix(s, b);
          return;
        }
        this.t = 0;
        this.s = 0;
        var i = s.length, mi = false, sh = 0;
        while (--i >= 0) {
          var x2 = k == 8 ? s[i] & 255 : intAt(s, i);
          if (x2 < 0) {
            if (s.charAt(i) == "-")
              mi = true;
            continue;
          }
          mi = false;
          if (sh == 0)
            this[this.t++] = x2;
          else if (sh + k > this.DB) {
            this[this.t - 1] |= (x2 & (1 << this.DB - sh) - 1) << sh;
            this[this.t++] = x2 >> this.DB - sh;
          } else
            this[this.t - 1] |= x2 << sh;
          sh += k;
          if (sh >= this.DB)
            sh -= this.DB;
        }
        if (k == 8 && (s[0] & 128) != 0) {
          this.s = -1;
          if (sh > 0)
            this[this.t - 1] |= (1 << this.DB - sh) - 1 << sh;
        }
        this.clamp();
        if (mi)
          BigInteger.ZERO.subTo(this, this);
      }
      function bnpClamp() {
        var c2 = this.s & this.DM;
        while (this.t > 0 && this[this.t - 1] == c2)
          --this.t;
      }
      function bnToString(b) {
        if (this.s < 0)
          return "-" + this.negate().toString(b);
        var k;
        if (b == 16)
          k = 4;
        else if (b == 8)
          k = 3;
        else if (b == 2)
          k = 1;
        else if (b == 32)
          k = 5;
        else if (b == 4)
          k = 2;
        else
          return this.toRadix(b);
        var km = (1 << k) - 1, d2, m2 = false, r = "", i = this.t;
        var p3 = this.DB - i * this.DB % k;
        if (i-- > 0) {
          if (p3 < this.DB && (d2 = this[i] >> p3) > 0) {
            m2 = true;
            r = int2char(d2);
          }
          while (i >= 0) {
            if (p3 < k) {
              d2 = (this[i] & (1 << p3) - 1) << k - p3;
              d2 |= this[--i] >> (p3 += this.DB - k);
            } else {
              d2 = this[i] >> (p3 -= k) & km;
              if (p3 <= 0) {
                p3 += this.DB;
                --i;
              }
            }
            if (d2 > 0)
              m2 = true;
            if (m2)
              r += int2char(d2);
          }
        }
        return m2 ? r : "0";
      }
      function bnNegate() {
        var r = nbi();
        BigInteger.ZERO.subTo(this, r);
        return r;
      }
      function bnAbs() {
        return this.s < 0 ? this.negate() : this;
      }
      function bnCompareTo(a) {
        var r = this.s - a.s;
        if (r != 0)
          return r;
        var i = this.t;
        r = i - a.t;
        if (r != 0)
          return this.s < 0 ? -r : r;
        while (--i >= 0)
          if ((r = this[i] - a[i]) != 0)
            return r;
        return 0;
      }
      function nbits(x2) {
        var r = 1, t2;
        if ((t2 = x2 >>> 16) != 0) {
          x2 = t2;
          r += 16;
        }
        if ((t2 = x2 >> 8) != 0) {
          x2 = t2;
          r += 8;
        }
        if ((t2 = x2 >> 4) != 0) {
          x2 = t2;
          r += 4;
        }
        if ((t2 = x2 >> 2) != 0) {
          x2 = t2;
          r += 2;
        }
        if ((t2 = x2 >> 1) != 0) {
          x2 = t2;
          r += 1;
        }
        return r;
      }
      function bnBitLength() {
        if (this.t <= 0)
          return 0;
        return this.DB * (this.t - 1) + nbits(this[this.t - 1] ^ this.s & this.DM);
      }
      function bnpDLShiftTo(n, r) {
        var i;
        for (i = this.t - 1; i >= 0; --i)
          r[i + n] = this[i];
        for (i = n - 1; i >= 0; --i)
          r[i] = 0;
        r.t = this.t + n;
        r.s = this.s;
      }
      function bnpDRShiftTo(n, r) {
        for (var i = n; i < this.t; ++i)
          r[i - n] = this[i];
        r.t = Math.max(this.t - n, 0);
        r.s = this.s;
      }
      function bnpLShiftTo(n, r) {
        var bs = n % this.DB;
        var cbs = this.DB - bs;
        var bm = (1 << cbs) - 1;
        var ds = Math.floor(n / this.DB), c2 = this.s << bs & this.DM, i;
        for (i = this.t - 1; i >= 0; --i) {
          r[i + ds + 1] = this[i] >> cbs | c2;
          c2 = (this[i] & bm) << bs;
        }
        for (i = ds - 1; i >= 0; --i)
          r[i] = 0;
        r[ds] = c2;
        r.t = this.t + ds + 1;
        r.s = this.s;
        r.clamp();
      }
      function bnpRShiftTo(n, r) {
        r.s = this.s;
        var ds = Math.floor(n / this.DB);
        if (ds >= this.t) {
          r.t = 0;
          return;
        }
        var bs = n % this.DB;
        var cbs = this.DB - bs;
        var bm = (1 << bs) - 1;
        r[0] = this[ds] >> bs;
        for (var i = ds + 1; i < this.t; ++i) {
          r[i - ds - 1] |= (this[i] & bm) << cbs;
          r[i - ds] = this[i] >> bs;
        }
        if (bs > 0)
          r[this.t - ds - 1] |= (this.s & bm) << cbs;
        r.t = this.t - ds;
        r.clamp();
      }
      function bnpSubTo(a, r) {
        var i = 0, c2 = 0, m2 = Math.min(a.t, this.t);
        while (i < m2) {
          c2 += this[i] - a[i];
          r[i++] = c2 & this.DM;
          c2 >>= this.DB;
        }
        if (a.t < this.t) {
          c2 -= a.s;
          while (i < this.t) {
            c2 += this[i];
            r[i++] = c2 & this.DM;
            c2 >>= this.DB;
          }
          c2 += this.s;
        } else {
          c2 += this.s;
          while (i < a.t) {
            c2 -= a[i];
            r[i++] = c2 & this.DM;
            c2 >>= this.DB;
          }
          c2 -= a.s;
        }
        r.s = c2 < 0 ? -1 : 0;
        if (c2 < -1)
          r[i++] = this.DV + c2;
        else if (c2 > 0)
          r[i++] = c2;
        r.t = i;
        r.clamp();
      }
      function bnpMultiplyTo(a, r) {
        var x2 = this.abs(), y = a.abs();
        var i = x2.t;
        r.t = i + y.t;
        while (--i >= 0)
          r[i] = 0;
        for (i = 0; i < y.t; ++i)
          r[i + x2.t] = x2.am(0, y[i], r, i, 0, x2.t);
        r.s = 0;
        r.clamp();
        if (this.s != a.s)
          BigInteger.ZERO.subTo(r, r);
      }
      function bnpSquareTo(r) {
        var x2 = this.abs();
        var i = r.t = 2 * x2.t;
        while (--i >= 0)
          r[i] = 0;
        for (i = 0; i < x2.t - 1; ++i) {
          var c2 = x2.am(i, x2[i], r, 2 * i, 0, 1);
          if ((r[i + x2.t] += x2.am(i + 1, 2 * x2[i], r, 2 * i + 1, c2, x2.t - i - 1)) >= x2.DV) {
            r[i + x2.t] -= x2.DV;
            r[i + x2.t + 1] = 1;
          }
        }
        if (r.t > 0)
          r[r.t - 1] += x2.am(i, x2[i], r, 2 * i, 0, 1);
        r.s = 0;
        r.clamp();
      }
      function bnpDivRemTo(m2, q2, r) {
        var pm = m2.abs();
        if (pm.t <= 0)
          return;
        var pt = this.abs();
        if (pt.t < pm.t) {
          if (q2 != null)
            q2.fromInt(0);
          if (r != null)
            this.copyTo(r);
          return;
        }
        if (r == null)
          r = nbi();
        var y = nbi(), ts = this.s, ms = m2.s;
        var nsh = this.DB - nbits(pm[pm.t - 1]);
        if (nsh > 0) {
          pm.lShiftTo(nsh, y);
          pt.lShiftTo(nsh, r);
        } else {
          pm.copyTo(y);
          pt.copyTo(r);
        }
        var ys = y.t;
        var y0 = y[ys - 1];
        if (y0 == 0)
          return;
        var yt = y0 * (1 << this.F1) + (ys > 1 ? y[ys - 2] >> this.F2 : 0);
        var d1 = this.FV / yt, d2 = (1 << this.F1) / yt, e = 1 << this.F2;
        var i = r.t, j = i - ys, t2 = q2 == null ? nbi() : q2;
        y.dlShiftTo(j, t2);
        if (r.compareTo(t2) >= 0) {
          r[r.t++] = 1;
          r.subTo(t2, r);
        }
        BigInteger.ONE.dlShiftTo(ys, t2);
        t2.subTo(y, y);
        while (y.t < ys)
          y[y.t++] = 0;
        while (--j >= 0) {
          var qd = r[--i] == y0 ? this.DM : Math.floor(r[i] * d1 + (r[i - 1] + e) * d2);
          if ((r[i] += y.am(0, qd, r, j, 0, ys)) < qd) {
            y.dlShiftTo(j, t2);
            r.subTo(t2, r);
            while (r[i] < --qd)
              r.subTo(t2, r);
          }
        }
        if (q2 != null) {
          r.drShiftTo(ys, q2);
          if (ts != ms)
            BigInteger.ZERO.subTo(q2, q2);
        }
        r.t = ys;
        r.clamp();
        if (nsh > 0)
          r.rShiftTo(nsh, r);
        if (ts < 0)
          BigInteger.ZERO.subTo(r, r);
      }
      function bnMod(a) {
        var r = nbi();
        this.abs().divRemTo(a, null, r);
        if (this.s < 0 && r.compareTo(BigInteger.ZERO) > 0)
          a.subTo(r, r);
        return r;
      }
      function Classic(m2) {
        this.m = m2;
      }
      function cConvert(x2) {
        if (x2.s < 0 || x2.compareTo(this.m) >= 0)
          return x2.mod(this.m);
        else
          return x2;
      }
      function cRevert(x2) {
        return x2;
      }
      function cReduce(x2) {
        x2.divRemTo(this.m, null, x2);
      }
      function cMulTo(x2, y, r) {
        x2.multiplyTo(y, r);
        this.reduce(r);
      }
      function cSqrTo(x2, r) {
        x2.squareTo(r);
        this.reduce(r);
      }
      Classic.prototype.convert = cConvert;
      Classic.prototype.revert = cRevert;
      Classic.prototype.reduce = cReduce;
      Classic.prototype.mulTo = cMulTo;
      Classic.prototype.sqrTo = cSqrTo;
      function bnpInvDigit() {
        if (this.t < 1)
          return 0;
        var x2 = this[0];
        if ((x2 & 1) == 0)
          return 0;
        var y = x2 & 3;
        y = y * (2 - (x2 & 15) * y) & 15;
        y = y * (2 - (x2 & 255) * y) & 255;
        y = y * (2 - ((x2 & 65535) * y & 65535)) & 65535;
        y = y * (2 - x2 * y % this.DV) % this.DV;
        return y > 0 ? this.DV - y : -y;
      }
      function Montgomery(m2) {
        this.m = m2;
        this.mp = m2.invDigit();
        this.mpl = this.mp & 32767;
        this.mph = this.mp >> 15;
        this.um = (1 << m2.DB - 15) - 1;
        this.mt2 = 2 * m2.t;
      }
      function montConvert(x2) {
        var r = nbi();
        x2.abs().dlShiftTo(this.m.t, r);
        r.divRemTo(this.m, null, r);
        if (x2.s < 0 && r.compareTo(BigInteger.ZERO) > 0)
          this.m.subTo(r, r);
        return r;
      }
      function montRevert(x2) {
        var r = nbi();
        x2.copyTo(r);
        this.reduce(r);
        return r;
      }
      function montReduce(x2) {
        while (x2.t <= this.mt2)
          x2[x2.t++] = 0;
        for (var i = 0; i < this.m.t; ++i) {
          var j = x2[i] & 32767;
          var u0 = j * this.mpl + ((j * this.mph + (x2[i] >> 15) * this.mpl & this.um) << 15) & x2.DM;
          j = i + this.m.t;
          x2[j] += this.m.am(0, u0, x2, i, 0, this.m.t);
          while (x2[j] >= x2.DV) {
            x2[j] -= x2.DV;
            x2[++j]++;
          }
        }
        x2.clamp();
        x2.drShiftTo(this.m.t, x2);
        if (x2.compareTo(this.m) >= 0)
          x2.subTo(this.m, x2);
      }
      function montSqrTo(x2, r) {
        x2.squareTo(r);
        this.reduce(r);
      }
      function montMulTo(x2, y, r) {
        x2.multiplyTo(y, r);
        this.reduce(r);
      }
      Montgomery.prototype.convert = montConvert;
      Montgomery.prototype.revert = montRevert;
      Montgomery.prototype.reduce = montReduce;
      Montgomery.prototype.mulTo = montMulTo;
      Montgomery.prototype.sqrTo = montSqrTo;
      function bnpIsEven() {
        return (this.t > 0 ? this[0] & 1 : this.s) == 0;
      }
      function bnpExp(e, z2) {
        if (e > 4294967295 || e < 1)
          return BigInteger.ONE;
        var r = nbi(), r2 = nbi(), g2 = z2.convert(this), i = nbits(e) - 1;
        g2.copyTo(r);
        while (--i >= 0) {
          z2.sqrTo(r, r2);
          if ((e & 1 << i) > 0)
            z2.mulTo(r2, g2, r);
          else {
            var t2 = r;
            r = r2;
            r2 = t2;
          }
        }
        return z2.revert(r);
      }
      function bnModPowInt(e, m2) {
        var z2;
        if (e < 256 || m2.isEven())
          z2 = new Classic(m2);
        else
          z2 = new Montgomery(m2);
        return this.exp(e, z2);
      }
      BigInteger.prototype.copyTo = bnpCopyTo;
      BigInteger.prototype.fromInt = bnpFromInt;
      BigInteger.prototype.fromString = bnpFromString;
      BigInteger.prototype.clamp = bnpClamp;
      BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
      BigInteger.prototype.drShiftTo = bnpDRShiftTo;
      BigInteger.prototype.lShiftTo = bnpLShiftTo;
      BigInteger.prototype.rShiftTo = bnpRShiftTo;
      BigInteger.prototype.subTo = bnpSubTo;
      BigInteger.prototype.multiplyTo = bnpMultiplyTo;
      BigInteger.prototype.squareTo = bnpSquareTo;
      BigInteger.prototype.divRemTo = bnpDivRemTo;
      BigInteger.prototype.invDigit = bnpInvDigit;
      BigInteger.prototype.isEven = bnpIsEven;
      BigInteger.prototype.exp = bnpExp;
      BigInteger.prototype.toString = bnToString;
      BigInteger.prototype.negate = bnNegate;
      BigInteger.prototype.abs = bnAbs;
      BigInteger.prototype.compareTo = bnCompareTo;
      BigInteger.prototype.bitLength = bnBitLength;
      BigInteger.prototype.mod = bnMod;
      BigInteger.prototype.modPowInt = bnModPowInt;
      BigInteger.ZERO = nbv(0);
      BigInteger.ONE = nbv(1);
      function bnClone() {
        var r = nbi();
        this.copyTo(r);
        return r;
      }
      function bnIntValue() {
        if (this.s < 0) {
          if (this.t == 1)
            return this[0] - this.DV;
          else if (this.t == 0)
            return -1;
        } else if (this.t == 1)
          return this[0];
        else if (this.t == 0)
          return 0;
        return (this[1] & (1 << 32 - this.DB) - 1) << this.DB | this[0];
      }
      function bnByteValue() {
        return this.t == 0 ? this.s : this[0] << 24 >> 24;
      }
      function bnShortValue() {
        return this.t == 0 ? this.s : this[0] << 16 >> 16;
      }
      function bnpChunkSize(r) {
        return Math.floor(Math.LN2 * this.DB / Math.log(r));
      }
      function bnSigNum() {
        if (this.s < 0)
          return -1;
        else if (this.t <= 0 || this.t == 1 && this[0] <= 0)
          return 0;
        else
          return 1;
      }
      function bnpToRadix(b) {
        if (b == null)
          b = 10;
        if (this.signum() == 0 || b < 2 || b > 36)
          return "0";
        var cs = this.chunkSize(b);
        var a = Math.pow(b, cs);
        var d2 = nbv(a), y = nbi(), z2 = nbi(), r = "";
        this.divRemTo(d2, y, z2);
        while (y.signum() > 0) {
          r = (a + z2.intValue()).toString(b).substr(1) + r;
          y.divRemTo(d2, y, z2);
        }
        return z2.intValue().toString(b) + r;
      }
      function bnpFromRadix(s, b) {
        this.fromInt(0);
        if (b == null)
          b = 10;
        var cs = this.chunkSize(b);
        var d2 = Math.pow(b, cs), mi = false, j = 0, w = 0;
        for (var i = 0; i < s.length; ++i) {
          var x2 = intAt(s, i);
          if (x2 < 0) {
            if (s.charAt(i) == "-" && this.signum() == 0)
              mi = true;
            continue;
          }
          w = b * w + x2;
          if (++j >= cs) {
            this.dMultiply(d2);
            this.dAddOffset(w, 0);
            j = 0;
            w = 0;
          }
        }
        if (j > 0) {
          this.dMultiply(Math.pow(b, j));
          this.dAddOffset(w, 0);
        }
        if (mi)
          BigInteger.ZERO.subTo(this, this);
      }
      function bnpFromNumber(a, b, c2) {
        if ("number" == typeof b) {
          if (a < 2)
            this.fromInt(1);
          else {
            this.fromNumber(a, c2);
            if (!this.testBit(a - 1))
              this.bitwiseTo(BigInteger.ONE.shiftLeft(a - 1), op_or, this);
            if (this.isEven())
              this.dAddOffset(1, 0);
            while (!this.isProbablePrime(b)) {
              this.dAddOffset(2, 0);
              if (this.bitLength() > a)
                this.subTo(BigInteger.ONE.shiftLeft(a - 1), this);
            }
          }
        } else {
          var x2 = new Array(), t2 = a & 7;
          x2.length = (a >> 3) + 1;
          b.nextBytes(x2);
          if (t2 > 0)
            x2[0] &= (1 << t2) - 1;
          else
            x2[0] = 0;
          this.fromString(x2, 256);
        }
      }
      function bnToByteArray() {
        var i = this.t, r = new Array();
        r[0] = this.s;
        var p3 = this.DB - i * this.DB % 8, d2, k = 0;
        if (i-- > 0) {
          if (p3 < this.DB && (d2 = this[i] >> p3) != (this.s & this.DM) >> p3)
            r[k++] = d2 | this.s << this.DB - p3;
          while (i >= 0) {
            if (p3 < 8) {
              d2 = (this[i] & (1 << p3) - 1) << 8 - p3;
              d2 |= this[--i] >> (p3 += this.DB - 8);
            } else {
              d2 = this[i] >> (p3 -= 8) & 255;
              if (p3 <= 0) {
                p3 += this.DB;
                --i;
              }
            }
            if ((d2 & 128) != 0)
              d2 |= -256;
            if (k == 0 && (this.s & 128) != (d2 & 128))
              ++k;
            if (k > 0 || d2 != this.s)
              r[k++] = d2;
          }
        }
        return r;
      }
      function bnEquals(a) {
        return this.compareTo(a) == 0;
      }
      function bnMin(a) {
        return this.compareTo(a) < 0 ? this : a;
      }
      function bnMax(a) {
        return this.compareTo(a) > 0 ? this : a;
      }
      function bnpBitwiseTo(a, op, r) {
        var i, f2, m2 = Math.min(a.t, this.t);
        for (i = 0; i < m2; ++i)
          r[i] = op(this[i], a[i]);
        if (a.t < this.t) {
          f2 = a.s & this.DM;
          for (i = m2; i < this.t; ++i)
            r[i] = op(this[i], f2);
          r.t = this.t;
        } else {
          f2 = this.s & this.DM;
          for (i = m2; i < a.t; ++i)
            r[i] = op(f2, a[i]);
          r.t = a.t;
        }
        r.s = op(this.s, a.s);
        r.clamp();
      }
      function op_and(x2, y) {
        return x2 & y;
      }
      function bnAnd(a) {
        var r = nbi();
        this.bitwiseTo(a, op_and, r);
        return r;
      }
      function op_or(x2, y) {
        return x2 | y;
      }
      function bnOr(a) {
        var r = nbi();
        this.bitwiseTo(a, op_or, r);
        return r;
      }
      function op_xor(x2, y) {
        return x2 ^ y;
      }
      function bnXor(a) {
        var r = nbi();
        this.bitwiseTo(a, op_xor, r);
        return r;
      }
      function op_andnot(x2, y) {
        return x2 & ~y;
      }
      function bnAndNot(a) {
        var r = nbi();
        this.bitwiseTo(a, op_andnot, r);
        return r;
      }
      function bnNot() {
        var r = nbi();
        for (var i = 0; i < this.t; ++i)
          r[i] = this.DM & ~this[i];
        r.t = this.t;
        r.s = ~this.s;
        return r;
      }
      function bnShiftLeft(n) {
        var r = nbi();
        if (n < 0)
          this.rShiftTo(-n, r);
        else
          this.lShiftTo(n, r);
        return r;
      }
      function bnShiftRight(n) {
        var r = nbi();
        if (n < 0)
          this.lShiftTo(-n, r);
        else
          this.rShiftTo(n, r);
        return r;
      }
      function lbit(x2) {
        if (x2 == 0)
          return -1;
        var r = 0;
        if ((x2 & 65535) == 0) {
          x2 >>= 16;
          r += 16;
        }
        if ((x2 & 255) == 0) {
          x2 >>= 8;
          r += 8;
        }
        if ((x2 & 15) == 0) {
          x2 >>= 4;
          r += 4;
        }
        if ((x2 & 3) == 0) {
          x2 >>= 2;
          r += 2;
        }
        if ((x2 & 1) == 0)
          ++r;
        return r;
      }
      function bnGetLowestSetBit() {
        for (var i = 0; i < this.t; ++i)
          if (this[i] != 0)
            return i * this.DB + lbit(this[i]);
        if (this.s < 0)
          return this.t * this.DB;
        return -1;
      }
      function cbit(x2) {
        var r = 0;
        while (x2 != 0) {
          x2 &= x2 - 1;
          ++r;
        }
        return r;
      }
      function bnBitCount() {
        var r = 0, x2 = this.s & this.DM;
        for (var i = 0; i < this.t; ++i)
          r += cbit(this[i] ^ x2);
        return r;
      }
      function bnTestBit(n) {
        var j = Math.floor(n / this.DB);
        if (j >= this.t)
          return this.s != 0;
        return (this[j] & 1 << n % this.DB) != 0;
      }
      function bnpChangeBit(n, op) {
        var r = BigInteger.ONE.shiftLeft(n);
        this.bitwiseTo(r, op, r);
        return r;
      }
      function bnSetBit(n) {
        return this.changeBit(n, op_or);
      }
      function bnClearBit(n) {
        return this.changeBit(n, op_andnot);
      }
      function bnFlipBit(n) {
        return this.changeBit(n, op_xor);
      }
      function bnpAddTo(a, r) {
        var i = 0, c2 = 0, m2 = Math.min(a.t, this.t);
        while (i < m2) {
          c2 += this[i] + a[i];
          r[i++] = c2 & this.DM;
          c2 >>= this.DB;
        }
        if (a.t < this.t) {
          c2 += a.s;
          while (i < this.t) {
            c2 += this[i];
            r[i++] = c2 & this.DM;
            c2 >>= this.DB;
          }
          c2 += this.s;
        } else {
          c2 += this.s;
          while (i < a.t) {
            c2 += a[i];
            r[i++] = c2 & this.DM;
            c2 >>= this.DB;
          }
          c2 += a.s;
        }
        r.s = c2 < 0 ? -1 : 0;
        if (c2 > 0)
          r[i++] = c2;
        else if (c2 < -1)
          r[i++] = this.DV + c2;
        r.t = i;
        r.clamp();
      }
      function bnAdd(a) {
        var r = nbi();
        this.addTo(a, r);
        return r;
      }
      function bnSubtract(a) {
        var r = nbi();
        this.subTo(a, r);
        return r;
      }
      function bnMultiply(a) {
        var r = nbi();
        this.multiplyTo(a, r);
        return r;
      }
      function bnSquare() {
        var r = nbi();
        this.squareTo(r);
        return r;
      }
      function bnDivide(a) {
        var r = nbi();
        this.divRemTo(a, r, null);
        return r;
      }
      function bnRemainder(a) {
        var r = nbi();
        this.divRemTo(a, null, r);
        return r;
      }
      function bnDivideAndRemainder(a) {
        var q2 = nbi(), r = nbi();
        this.divRemTo(a, q2, r);
        return new Array(q2, r);
      }
      function bnpDMultiply(n) {
        this[this.t] = this.am(0, n - 1, this, 0, 0, this.t);
        ++this.t;
        this.clamp();
      }
      function bnpDAddOffset(n, w) {
        if (n == 0)
          return;
        while (this.t <= w)
          this[this.t++] = 0;
        this[w] += n;
        while (this[w] >= this.DV) {
          this[w] -= this.DV;
          if (++w >= this.t)
            this[this.t++] = 0;
          ++this[w];
        }
      }
      function NullExp() {
      }
      function nNop(x2) {
        return x2;
      }
      function nMulTo(x2, y, r) {
        x2.multiplyTo(y, r);
      }
      function nSqrTo(x2, r) {
        x2.squareTo(r);
      }
      NullExp.prototype.convert = nNop;
      NullExp.prototype.revert = nNop;
      NullExp.prototype.mulTo = nMulTo;
      NullExp.prototype.sqrTo = nSqrTo;
      function bnPow(e) {
        return this.exp(e, new NullExp());
      }
      function bnpMultiplyLowerTo(a, n, r) {
        var i = Math.min(this.t + a.t, n);
        r.s = 0;
        r.t = i;
        while (i > 0)
          r[--i] = 0;
        var j;
        for (j = r.t - this.t; i < j; ++i)
          r[i + this.t] = this.am(0, a[i], r, i, 0, this.t);
        for (j = Math.min(a.t, n); i < j; ++i)
          this.am(0, a[i], r, i, 0, n - i);
        r.clamp();
      }
      function bnpMultiplyUpperTo(a, n, r) {
        --n;
        var i = r.t = this.t + a.t - n;
        r.s = 0;
        while (--i >= 0)
          r[i] = 0;
        for (i = Math.max(n - this.t, 0); i < a.t; ++i)
          r[this.t + i - n] = this.am(n - i, a[i], r, 0, 0, this.t + i - n);
        r.clamp();
        r.drShiftTo(1, r);
      }
      function Barrett(m2) {
        this.r2 = nbi();
        this.q3 = nbi();
        BigInteger.ONE.dlShiftTo(2 * m2.t, this.r2);
        this.mu = this.r2.divide(m2);
        this.m = m2;
      }
      function barrettConvert(x2) {
        if (x2.s < 0 || x2.t > 2 * this.m.t)
          return x2.mod(this.m);
        else if (x2.compareTo(this.m) < 0)
          return x2;
        else {
          var r = nbi();
          x2.copyTo(r);
          this.reduce(r);
          return r;
        }
      }
      function barrettRevert(x2) {
        return x2;
      }
      function barrettReduce(x2) {
        x2.drShiftTo(this.m.t - 1, this.r2);
        if (x2.t > this.m.t + 1) {
          x2.t = this.m.t + 1;
          x2.clamp();
        }
        this.mu.multiplyUpperTo(this.r2, this.m.t + 1, this.q3);
        this.m.multiplyLowerTo(this.q3, this.m.t + 1, this.r2);
        while (x2.compareTo(this.r2) < 0)
          x2.dAddOffset(1, this.m.t + 1);
        x2.subTo(this.r2, x2);
        while (x2.compareTo(this.m) >= 0)
          x2.subTo(this.m, x2);
      }
      function barrettSqrTo(x2, r) {
        x2.squareTo(r);
        this.reduce(r);
      }
      function barrettMulTo(x2, y, r) {
        x2.multiplyTo(y, r);
        this.reduce(r);
      }
      Barrett.prototype.convert = barrettConvert;
      Barrett.prototype.revert = barrettRevert;
      Barrett.prototype.reduce = barrettReduce;
      Barrett.prototype.mulTo = barrettMulTo;
      Barrett.prototype.sqrTo = barrettSqrTo;
      function bnModPow(e, m2) {
        var i = e.bitLength(), k, r = nbv(1), z2;
        if (i <= 0)
          return r;
        else if (i < 18)
          k = 1;
        else if (i < 48)
          k = 3;
        else if (i < 144)
          k = 4;
        else if (i < 768)
          k = 5;
        else
          k = 6;
        if (i < 8)
          z2 = new Classic(m2);
        else if (m2.isEven())
          z2 = new Barrett(m2);
        else
          z2 = new Montgomery(m2);
        var g2 = new Array(), n = 3, k1 = k - 1, km = (1 << k) - 1;
        g2[1] = z2.convert(this);
        if (k > 1) {
          var g22 = nbi();
          z2.sqrTo(g2[1], g22);
          while (n <= km) {
            g2[n] = nbi();
            z2.mulTo(g22, g2[n - 2], g2[n]);
            n += 2;
          }
        }
        var j = e.t - 1, w, is1 = true, r2 = nbi(), t2;
        i = nbits(e[j]) - 1;
        while (j >= 0) {
          if (i >= k1)
            w = e[j] >> i - k1 & km;
          else {
            w = (e[j] & (1 << i + 1) - 1) << k1 - i;
            if (j > 0)
              w |= e[j - 1] >> this.DB + i - k1;
          }
          n = k;
          while ((w & 1) == 0) {
            w >>= 1;
            --n;
          }
          if ((i -= n) < 0) {
            i += this.DB;
            --j;
          }
          if (is1) {
            g2[w].copyTo(r);
            is1 = false;
          } else {
            while (n > 1) {
              z2.sqrTo(r, r2);
              z2.sqrTo(r2, r);
              n -= 2;
            }
            if (n > 0)
              z2.sqrTo(r, r2);
            else {
              t2 = r;
              r = r2;
              r2 = t2;
            }
            z2.mulTo(r2, g2[w], r);
          }
          while (j >= 0 && (e[j] & 1 << i) == 0) {
            z2.sqrTo(r, r2);
            t2 = r;
            r = r2;
            r2 = t2;
            if (--i < 0) {
              i = this.DB - 1;
              --j;
            }
          }
        }
        return z2.revert(r);
      }
      function bnGCD(a) {
        var x2 = this.s < 0 ? this.negate() : this.clone();
        var y = a.s < 0 ? a.negate() : a.clone();
        if (x2.compareTo(y) < 0) {
          var t2 = x2;
          x2 = y;
          y = t2;
        }
        var i = x2.getLowestSetBit(), g2 = y.getLowestSetBit();
        if (g2 < 0)
          return x2;
        if (i < g2)
          g2 = i;
        if (g2 > 0) {
          x2.rShiftTo(g2, x2);
          y.rShiftTo(g2, y);
        }
        while (x2.signum() > 0) {
          if ((i = x2.getLowestSetBit()) > 0)
            x2.rShiftTo(i, x2);
          if ((i = y.getLowestSetBit()) > 0)
            y.rShiftTo(i, y);
          if (x2.compareTo(y) >= 0) {
            x2.subTo(y, x2);
            x2.rShiftTo(1, x2);
          } else {
            y.subTo(x2, y);
            y.rShiftTo(1, y);
          }
        }
        if (g2 > 0)
          y.lShiftTo(g2, y);
        return y;
      }
      function bnpModInt(n) {
        if (n <= 0)
          return 0;
        var d2 = this.DV % n, r = this.s < 0 ? n - 1 : 0;
        if (this.t > 0)
          if (d2 == 0)
            r = this[0] % n;
          else
            for (var i = this.t - 1; i >= 0; --i)
              r = (d2 * r + this[i]) % n;
        return r;
      }
      function bnModInverse(m2) {
        var ac = m2.isEven();
        if (this.isEven() && ac || m2.signum() == 0)
          return BigInteger.ZERO;
        var u2 = m2.clone(), v = this.clone();
        var a = nbv(1), b = nbv(0), c2 = nbv(0), d2 = nbv(1);
        while (u2.signum() != 0) {
          while (u2.isEven()) {
            u2.rShiftTo(1, u2);
            if (ac) {
              if (!a.isEven() || !b.isEven()) {
                a.addTo(this, a);
                b.subTo(m2, b);
              }
              a.rShiftTo(1, a);
            } else if (!b.isEven())
              b.subTo(m2, b);
            b.rShiftTo(1, b);
          }
          while (v.isEven()) {
            v.rShiftTo(1, v);
            if (ac) {
              if (!c2.isEven() || !d2.isEven()) {
                c2.addTo(this, c2);
                d2.subTo(m2, d2);
              }
              c2.rShiftTo(1, c2);
            } else if (!d2.isEven())
              d2.subTo(m2, d2);
            d2.rShiftTo(1, d2);
          }
          if (u2.compareTo(v) >= 0) {
            u2.subTo(v, u2);
            if (ac)
              a.subTo(c2, a);
            b.subTo(d2, b);
          } else {
            v.subTo(u2, v);
            if (ac)
              c2.subTo(a, c2);
            d2.subTo(b, d2);
          }
        }
        if (v.compareTo(BigInteger.ONE) != 0)
          return BigInteger.ZERO;
        if (d2.compareTo(m2) >= 0)
          return d2.subtract(m2);
        if (d2.signum() < 0)
          d2.addTo(m2, d2);
        else
          return d2;
        if (d2.signum() < 0)
          return d2.add(m2);
        else
          return d2;
      }
      var lowprimes = [2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101, 103, 107, 109, 113, 127, 131, 137, 139, 149, 151, 157, 163, 167, 173, 179, 181, 191, 193, 197, 199, 211, 223, 227, 229, 233, 239, 241, 251, 257, 263, 269, 271, 277, 281, 283, 293, 307, 311, 313, 317, 331, 337, 347, 349, 353, 359, 367, 373, 379, 383, 389, 397, 401, 409, 419, 421, 431, 433, 439, 443, 449, 457, 461, 463, 467, 479, 487, 491, 499, 503, 509, 521, 523, 541, 547, 557, 563, 569, 571, 577, 587, 593, 599, 601, 607, 613, 617, 619, 631, 641, 643, 647, 653, 659, 661, 673, 677, 683, 691, 701, 709, 719, 727, 733, 739, 743, 751, 757, 761, 769, 773, 787, 797, 809, 811, 821, 823, 827, 829, 839, 853, 857, 859, 863, 877, 881, 883, 887, 907, 911, 919, 929, 937, 941, 947, 953, 967, 971, 977, 983, 991, 997];
      var lplim = (1 << 26) / lowprimes[lowprimes.length - 1];
      function bnIsProbablePrime(t2) {
        var i, x2 = this.abs();
        if (x2.t == 1 && x2[0] <= lowprimes[lowprimes.length - 1]) {
          for (i = 0; i < lowprimes.length; ++i)
            if (x2[0] == lowprimes[i])
              return true;
          return false;
        }
        if (x2.isEven())
          return false;
        i = 1;
        while (i < lowprimes.length) {
          var m2 = lowprimes[i], j = i + 1;
          while (j < lowprimes.length && m2 < lplim)
            m2 *= lowprimes[j++];
          m2 = x2.modInt(m2);
          while (i < j)
            if (m2 % lowprimes[i++] == 0)
              return false;
        }
        return x2.millerRabin(t2);
      }
      function bnpMillerRabin(t2) {
        var n1 = this.subtract(BigInteger.ONE);
        var k = n1.getLowestSetBit();
        if (k <= 0)
          return false;
        var r = n1.shiftRight(k);
        t2 = t2 + 1 >> 1;
        if (t2 > lowprimes.length)
          t2 = lowprimes.length;
        var a = nbi();
        for (var i = 0; i < t2; ++i) {
          a.fromInt(lowprimes[Math.floor(Math.random() * lowprimes.length)]);
          var y = a.modPow(r, this);
          if (y.compareTo(BigInteger.ONE) != 0 && y.compareTo(n1) != 0) {
            var j = 1;
            while (j++ < k && y.compareTo(n1) != 0) {
              y = y.modPowInt(2, this);
              if (y.compareTo(BigInteger.ONE) == 0)
                return false;
            }
            if (y.compareTo(n1) != 0)
              return false;
          }
        }
        return true;
      }
      BigInteger.prototype.chunkSize = bnpChunkSize;
      BigInteger.prototype.toRadix = bnpToRadix;
      BigInteger.prototype.fromRadix = bnpFromRadix;
      BigInteger.prototype.fromNumber = bnpFromNumber;
      BigInteger.prototype.bitwiseTo = bnpBitwiseTo;
      BigInteger.prototype.changeBit = bnpChangeBit;
      BigInteger.prototype.addTo = bnpAddTo;
      BigInteger.prototype.dMultiply = bnpDMultiply;
      BigInteger.prototype.dAddOffset = bnpDAddOffset;
      BigInteger.prototype.multiplyLowerTo = bnpMultiplyLowerTo;
      BigInteger.prototype.multiplyUpperTo = bnpMultiplyUpperTo;
      BigInteger.prototype.modInt = bnpModInt;
      BigInteger.prototype.millerRabin = bnpMillerRabin;
      BigInteger.prototype.clone = bnClone;
      BigInteger.prototype.intValue = bnIntValue;
      BigInteger.prototype.byteValue = bnByteValue;
      BigInteger.prototype.shortValue = bnShortValue;
      BigInteger.prototype.signum = bnSigNum;
      BigInteger.prototype.toByteArray = bnToByteArray;
      BigInteger.prototype.equals = bnEquals;
      BigInteger.prototype.min = bnMin;
      BigInteger.prototype.max = bnMax;
      BigInteger.prototype.and = bnAnd;
      BigInteger.prototype.or = bnOr;
      BigInteger.prototype.xor = bnXor;
      BigInteger.prototype.andNot = bnAndNot;
      BigInteger.prototype.not = bnNot;
      BigInteger.prototype.shiftLeft = bnShiftLeft;
      BigInteger.prototype.shiftRight = bnShiftRight;
      BigInteger.prototype.getLowestSetBit = bnGetLowestSetBit;
      BigInteger.prototype.bitCount = bnBitCount;
      BigInteger.prototype.testBit = bnTestBit;
      BigInteger.prototype.setBit = bnSetBit;
      BigInteger.prototype.clearBit = bnClearBit;
      BigInteger.prototype.flipBit = bnFlipBit;
      BigInteger.prototype.add = bnAdd;
      BigInteger.prototype.subtract = bnSubtract;
      BigInteger.prototype.multiply = bnMultiply;
      BigInteger.prototype.divide = bnDivide;
      BigInteger.prototype.remainder = bnRemainder;
      BigInteger.prototype.divideAndRemainder = bnDivideAndRemainder;
      BigInteger.prototype.modPow = bnModPow;
      BigInteger.prototype.modInverse = bnModInverse;
      BigInteger.prototype.pow = bnPow;
      BigInteger.prototype.gcd = bnGCD;
      BigInteger.prototype.isProbablePrime = bnIsProbablePrime;
      BigInteger.prototype.square = bnSquare;
      BigInteger.prototype.Barrett = Barrett;
      var rng_state;
      var rng_pool;
      var rng_pptr;
      function rng_seed_int(x2) {
        rng_pool[rng_pptr++] ^= x2 & 255;
        rng_pool[rng_pptr++] ^= x2 >> 8 & 255;
        rng_pool[rng_pptr++] ^= x2 >> 16 & 255;
        rng_pool[rng_pptr++] ^= x2 >> 24 & 255;
        if (rng_pptr >= rng_psize)
          rng_pptr -= rng_psize;
      }
      function rng_seed_time() {
        rng_seed_int((/* @__PURE__ */ new Date()).getTime());
      }
      if (rng_pool == null) {
        rng_pool = new Array();
        rng_pptr = 0;
        var t;
        if (typeof window !== "undefined" && window.crypto) {
          if (window.crypto.getRandomValues) {
            var ua = new Uint8Array(32);
            window.crypto.getRandomValues(ua);
            for (t = 0; t < 32; ++t)
              rng_pool[rng_pptr++] = ua[t];
          } else if (navigator.appName == "Netscape" && navigator.appVersion < "5") {
            var z = window.crypto.random(32);
            for (t = 0; t < z.length; ++t)
              rng_pool[rng_pptr++] = z.charCodeAt(t) & 255;
          }
        }
        while (rng_pptr < rng_psize) {
          t = Math.floor(65536 * Math.random());
          rng_pool[rng_pptr++] = t >>> 8;
          rng_pool[rng_pptr++] = t & 255;
        }
        rng_pptr = 0;
        rng_seed_time();
      }
      function rng_get_byte() {
        if (rng_state == null) {
          rng_seed_time();
          rng_state = prng_newstate();
          rng_state.init(rng_pool);
          for (rng_pptr = 0; rng_pptr < rng_pool.length; ++rng_pptr)
            rng_pool[rng_pptr] = 0;
          rng_pptr = 0;
        }
        return rng_state.next();
      }
      function rng_get_bytes(ba) {
        var i;
        for (i = 0; i < ba.length; ++i)
          ba[i] = rng_get_byte();
      }
      function SecureRandom2() {
      }
      SecureRandom2.prototype.nextBytes = rng_get_bytes;
      function Arcfour() {
        this.i = 0;
        this.j = 0;
        this.S = new Array();
      }
      function ARC4init(key) {
        var i, j, t2;
        for (i = 0; i < 256; ++i)
          this.S[i] = i;
        j = 0;
        for (i = 0; i < 256; ++i) {
          j = j + this.S[i] + key[i % key.length] & 255;
          t2 = this.S[i];
          this.S[i] = this.S[j];
          this.S[j] = t2;
        }
        this.i = 0;
        this.j = 0;
      }
      function ARC4next() {
        var t2;
        this.i = this.i + 1 & 255;
        this.j = this.j + this.S[this.i] & 255;
        t2 = this.S[this.i];
        this.S[this.i] = this.S[this.j];
        this.S[this.j] = t2;
        return this.S[t2 + this.S[this.i] & 255];
      }
      Arcfour.prototype.init = ARC4init;
      Arcfour.prototype.next = ARC4next;
      function prng_newstate() {
        return new Arcfour();
      }
      var rng_psize = 256;
      BigInteger.SecureRandom = SecureRandom2;
      BigInteger.BigInteger = BigInteger;
      if (typeof exports2 !== "undefined") {
        exports2 = module2.exports = BigInteger;
      } else {
        this.BigInteger = BigInteger;
        this.SecureRandom = SecureRandom2;
      }
    }).call(exports2);
  }
});

// node_modules/tweetnacl/nacl-fast.js
var require_nacl_fast = __commonJS({
  "node_modules/tweetnacl/nacl-fast.js"(exports2, module2) {
    (function(nacl) {
      "use strict";
      var gf = function(init2) {
        var i, r = new Float64Array(16);
        if (init2)
          for (i = 0; i < init2.length; i++)
            r[i] = init2[i];
        return r;
      };
      var randombytes = function() {
        throw new Error("no PRNG");
      };
      var _0 = new Uint8Array(16);
      var _9 = new Uint8Array(32);
      _9[0] = 9;
      var gf0 = gf(), gf1 = gf([1]), _121665 = gf([56129, 1]), D = gf([30883, 4953, 19914, 30187, 55467, 16705, 2637, 112, 59544, 30585, 16505, 36039, 65139, 11119, 27886, 20995]), D2 = gf([61785, 9906, 39828, 60374, 45398, 33411, 5274, 224, 53552, 61171, 33010, 6542, 64743, 22239, 55772, 9222]), X = gf([54554, 36645, 11616, 51542, 42930, 38181, 51040, 26924, 56412, 64982, 57905, 49316, 21502, 52590, 14035, 8553]), Y = gf([26200, 26214, 26214, 26214, 26214, 26214, 26214, 26214, 26214, 26214, 26214, 26214, 26214, 26214, 26214, 26214]), I = gf([41136, 18958, 6951, 50414, 58488, 44335, 6150, 12099, 55207, 15867, 153, 11085, 57099, 20417, 9344, 11139]);
      function ts64(x2, i, h, l2) {
        x2[i] = h >> 24 & 255;
        x2[i + 1] = h >> 16 & 255;
        x2[i + 2] = h >> 8 & 255;
        x2[i + 3] = h & 255;
        x2[i + 4] = l2 >> 24 & 255;
        x2[i + 5] = l2 >> 16 & 255;
        x2[i + 6] = l2 >> 8 & 255;
        x2[i + 7] = l2 & 255;
      }
      function vn(x2, xi, y, yi, n) {
        var i, d2 = 0;
        for (i = 0; i < n; i++)
          d2 |= x2[xi + i] ^ y[yi + i];
        return (1 & d2 - 1 >>> 8) - 1;
      }
      function crypto_verify_16(x2, xi, y, yi) {
        return vn(x2, xi, y, yi, 16);
      }
      function crypto_verify_32(x2, xi, y, yi) {
        return vn(x2, xi, y, yi, 32);
      }
      function core_salsa20(o2, p3, k, c2) {
        var j0 = c2[0] & 255 | (c2[1] & 255) << 8 | (c2[2] & 255) << 16 | (c2[3] & 255) << 24, j1 = k[0] & 255 | (k[1] & 255) << 8 | (k[2] & 255) << 16 | (k[3] & 255) << 24, j2 = k[4] & 255 | (k[5] & 255) << 8 | (k[6] & 255) << 16 | (k[7] & 255) << 24, j3 = k[8] & 255 | (k[9] & 255) << 8 | (k[10] & 255) << 16 | (k[11] & 255) << 24, j4 = k[12] & 255 | (k[13] & 255) << 8 | (k[14] & 255) << 16 | (k[15] & 255) << 24, j5 = c2[4] & 255 | (c2[5] & 255) << 8 | (c2[6] & 255) << 16 | (c2[7] & 255) << 24, j6 = p3[0] & 255 | (p3[1] & 255) << 8 | (p3[2] & 255) << 16 | (p3[3] & 255) << 24, j7 = p3[4] & 255 | (p3[5] & 255) << 8 | (p3[6] & 255) << 16 | (p3[7] & 255) << 24, j8 = p3[8] & 255 | (p3[9] & 255) << 8 | (p3[10] & 255) << 16 | (p3[11] & 255) << 24, j9 = p3[12] & 255 | (p3[13] & 255) << 8 | (p3[14] & 255) << 16 | (p3[15] & 255) << 24, j10 = c2[8] & 255 | (c2[9] & 255) << 8 | (c2[10] & 255) << 16 | (c2[11] & 255) << 24, j11 = k[16] & 255 | (k[17] & 255) << 8 | (k[18] & 255) << 16 | (k[19] & 255) << 24, j12 = k[20] & 255 | (k[21] & 255) << 8 | (k[22] & 255) << 16 | (k[23] & 255) << 24, j13 = k[24] & 255 | (k[25] & 255) << 8 | (k[26] & 255) << 16 | (k[27] & 255) << 24, j14 = k[28] & 255 | (k[29] & 255) << 8 | (k[30] & 255) << 16 | (k[31] & 255) << 24, j15 = c2[12] & 255 | (c2[13] & 255) << 8 | (c2[14] & 255) << 16 | (c2[15] & 255) << 24;
        var x0 = j0, x1 = j1, x2 = j2, x3 = j3, x4 = j4, x5 = j5, x6 = j6, x7 = j7, x8 = j8, x9 = j9, x10 = j10, x11 = j11, x12 = j12, x13 = j13, x14 = j14, x15 = j15, u2;
        for (var i = 0; i < 20; i += 2) {
          u2 = x0 + x12 | 0;
          x4 ^= u2 << 7 | u2 >>> 32 - 7;
          u2 = x4 + x0 | 0;
          x8 ^= u2 << 9 | u2 >>> 32 - 9;
          u2 = x8 + x4 | 0;
          x12 ^= u2 << 13 | u2 >>> 32 - 13;
          u2 = x12 + x8 | 0;
          x0 ^= u2 << 18 | u2 >>> 32 - 18;
          u2 = x5 + x1 | 0;
          x9 ^= u2 << 7 | u2 >>> 32 - 7;
          u2 = x9 + x5 | 0;
          x13 ^= u2 << 9 | u2 >>> 32 - 9;
          u2 = x13 + x9 | 0;
          x1 ^= u2 << 13 | u2 >>> 32 - 13;
          u2 = x1 + x13 | 0;
          x5 ^= u2 << 18 | u2 >>> 32 - 18;
          u2 = x10 + x6 | 0;
          x14 ^= u2 << 7 | u2 >>> 32 - 7;
          u2 = x14 + x10 | 0;
          x2 ^= u2 << 9 | u2 >>> 32 - 9;
          u2 = x2 + x14 | 0;
          x6 ^= u2 << 13 | u2 >>> 32 - 13;
          u2 = x6 + x2 | 0;
          x10 ^= u2 << 18 | u2 >>> 32 - 18;
          u2 = x15 + x11 | 0;
          x3 ^= u2 << 7 | u2 >>> 32 - 7;
          u2 = x3 + x15 | 0;
          x7 ^= u2 << 9 | u2 >>> 32 - 9;
          u2 = x7 + x3 | 0;
          x11 ^= u2 << 13 | u2 >>> 32 - 13;
          u2 = x11 + x7 | 0;
          x15 ^= u2 << 18 | u2 >>> 32 - 18;
          u2 = x0 + x3 | 0;
          x1 ^= u2 << 7 | u2 >>> 32 - 7;
          u2 = x1 + x0 | 0;
          x2 ^= u2 << 9 | u2 >>> 32 - 9;
          u2 = x2 + x1 | 0;
          x3 ^= u2 << 13 | u2 >>> 32 - 13;
          u2 = x3 + x2 | 0;
          x0 ^= u2 << 18 | u2 >>> 32 - 18;
          u2 = x5 + x4 | 0;
          x6 ^= u2 << 7 | u2 >>> 32 - 7;
          u2 = x6 + x5 | 0;
          x7 ^= u2 << 9 | u2 >>> 32 - 9;
          u2 = x7 + x6 | 0;
          x4 ^= u2 << 13 | u2 >>> 32 - 13;
          u2 = x4 + x7 | 0;
          x5 ^= u2 << 18 | u2 >>> 32 - 18;
          u2 = x10 + x9 | 0;
          x11 ^= u2 << 7 | u2 >>> 32 - 7;
          u2 = x11 + x10 | 0;
          x8 ^= u2 << 9 | u2 >>> 32 - 9;
          u2 = x8 + x11 | 0;
          x9 ^= u2 << 13 | u2 >>> 32 - 13;
          u2 = x9 + x8 | 0;
          x10 ^= u2 << 18 | u2 >>> 32 - 18;
          u2 = x15 + x14 | 0;
          x12 ^= u2 << 7 | u2 >>> 32 - 7;
          u2 = x12 + x15 | 0;
          x13 ^= u2 << 9 | u2 >>> 32 - 9;
          u2 = x13 + x12 | 0;
          x14 ^= u2 << 13 | u2 >>> 32 - 13;
          u2 = x14 + x13 | 0;
          x15 ^= u2 << 18 | u2 >>> 32 - 18;
        }
        x0 = x0 + j0 | 0;
        x1 = x1 + j1 | 0;
        x2 = x2 + j2 | 0;
        x3 = x3 + j3 | 0;
        x4 = x4 + j4 | 0;
        x5 = x5 + j5 | 0;
        x6 = x6 + j6 | 0;
        x7 = x7 + j7 | 0;
        x8 = x8 + j8 | 0;
        x9 = x9 + j9 | 0;
        x10 = x10 + j10 | 0;
        x11 = x11 + j11 | 0;
        x12 = x12 + j12 | 0;
        x13 = x13 + j13 | 0;
        x14 = x14 + j14 | 0;
        x15 = x15 + j15 | 0;
        o2[0] = x0 >>> 0 & 255;
        o2[1] = x0 >>> 8 & 255;
        o2[2] = x0 >>> 16 & 255;
        o2[3] = x0 >>> 24 & 255;
        o2[4] = x1 >>> 0 & 255;
        o2[5] = x1 >>> 8 & 255;
        o2[6] = x1 >>> 16 & 255;
        o2[7] = x1 >>> 24 & 255;
        o2[8] = x2 >>> 0 & 255;
        o2[9] = x2 >>> 8 & 255;
        o2[10] = x2 >>> 16 & 255;
        o2[11] = x2 >>> 24 & 255;
        o2[12] = x3 >>> 0 & 255;
        o2[13] = x3 >>> 8 & 255;
        o2[14] = x3 >>> 16 & 255;
        o2[15] = x3 >>> 24 & 255;
        o2[16] = x4 >>> 0 & 255;
        o2[17] = x4 >>> 8 & 255;
        o2[18] = x4 >>> 16 & 255;
        o2[19] = x4 >>> 24 & 255;
        o2[20] = x5 >>> 0 & 255;
        o2[21] = x5 >>> 8 & 255;
        o2[22] = x5 >>> 16 & 255;
        o2[23] = x5 >>> 24 & 255;
        o2[24] = x6 >>> 0 & 255;
        o2[25] = x6 >>> 8 & 255;
        o2[26] = x6 >>> 16 & 255;
        o2[27] = x6 >>> 24 & 255;
        o2[28] = x7 >>> 0 & 255;
        o2[29] = x7 >>> 8 & 255;
        o2[30] = x7 >>> 16 & 255;
        o2[31] = x7 >>> 24 & 255;
        o2[32] = x8 >>> 0 & 255;
        o2[33] = x8 >>> 8 & 255;
        o2[34] = x8 >>> 16 & 255;
        o2[35] = x8 >>> 24 & 255;
        o2[36] = x9 >>> 0 & 255;
        o2[37] = x9 >>> 8 & 255;
        o2[38] = x9 >>> 16 & 255;
        o2[39] = x9 >>> 24 & 255;
        o2[40] = x10 >>> 0 & 255;
        o2[41] = x10 >>> 8 & 255;
        o2[42] = x10 >>> 16 & 255;
        o2[43] = x10 >>> 24 & 255;
        o2[44] = x11 >>> 0 & 255;
        o2[45] = x11 >>> 8 & 255;
        o2[46] = x11 >>> 16 & 255;
        o2[47] = x11 >>> 24 & 255;
        o2[48] = x12 >>> 0 & 255;
        o2[49] = x12 >>> 8 & 255;
        o2[50] = x12 >>> 16 & 255;
        o2[51] = x12 >>> 24 & 255;
        o2[52] = x13 >>> 0 & 255;
        o2[53] = x13 >>> 8 & 255;
        o2[54] = x13 >>> 16 & 255;
        o2[55] = x13 >>> 24 & 255;
        o2[56] = x14 >>> 0 & 255;
        o2[57] = x14 >>> 8 & 255;
        o2[58] = x14 >>> 16 & 255;
        o2[59] = x14 >>> 24 & 255;
        o2[60] = x15 >>> 0 & 255;
        o2[61] = x15 >>> 8 & 255;
        o2[62] = x15 >>> 16 & 255;
        o2[63] = x15 >>> 24 & 255;
      }
      function core_hsalsa20(o2, p3, k, c2) {
        var j0 = c2[0] & 255 | (c2[1] & 255) << 8 | (c2[2] & 255) << 16 | (c2[3] & 255) << 24, j1 = k[0] & 255 | (k[1] & 255) << 8 | (k[2] & 255) << 16 | (k[3] & 255) << 24, j2 = k[4] & 255 | (k[5] & 255) << 8 | (k[6] & 255) << 16 | (k[7] & 255) << 24, j3 = k[8] & 255 | (k[9] & 255) << 8 | (k[10] & 255) << 16 | (k[11] & 255) << 24, j4 = k[12] & 255 | (k[13] & 255) << 8 | (k[14] & 255) << 16 | (k[15] & 255) << 24, j5 = c2[4] & 255 | (c2[5] & 255) << 8 | (c2[6] & 255) << 16 | (c2[7] & 255) << 24, j6 = p3[0] & 255 | (p3[1] & 255) << 8 | (p3[2] & 255) << 16 | (p3[3] & 255) << 24, j7 = p3[4] & 255 | (p3[5] & 255) << 8 | (p3[6] & 255) << 16 | (p3[7] & 255) << 24, j8 = p3[8] & 255 | (p3[9] & 255) << 8 | (p3[10] & 255) << 16 | (p3[11] & 255) << 24, j9 = p3[12] & 255 | (p3[13] & 255) << 8 | (p3[14] & 255) << 16 | (p3[15] & 255) << 24, j10 = c2[8] & 255 | (c2[9] & 255) << 8 | (c2[10] & 255) << 16 | (c2[11] & 255) << 24, j11 = k[16] & 255 | (k[17] & 255) << 8 | (k[18] & 255) << 16 | (k[19] & 255) << 24, j12 = k[20] & 255 | (k[21] & 255) << 8 | (k[22] & 255) << 16 | (k[23] & 255) << 24, j13 = k[24] & 255 | (k[25] & 255) << 8 | (k[26] & 255) << 16 | (k[27] & 255) << 24, j14 = k[28] & 255 | (k[29] & 255) << 8 | (k[30] & 255) << 16 | (k[31] & 255) << 24, j15 = c2[12] & 255 | (c2[13] & 255) << 8 | (c2[14] & 255) << 16 | (c2[15] & 255) << 24;
        var x0 = j0, x1 = j1, x2 = j2, x3 = j3, x4 = j4, x5 = j5, x6 = j6, x7 = j7, x8 = j8, x9 = j9, x10 = j10, x11 = j11, x12 = j12, x13 = j13, x14 = j14, x15 = j15, u2;
        for (var i = 0; i < 20; i += 2) {
          u2 = x0 + x12 | 0;
          x4 ^= u2 << 7 | u2 >>> 32 - 7;
          u2 = x4 + x0 | 0;
          x8 ^= u2 << 9 | u2 >>> 32 - 9;
          u2 = x8 + x4 | 0;
          x12 ^= u2 << 13 | u2 >>> 32 - 13;
          u2 = x12 + x8 | 0;
          x0 ^= u2 << 18 | u2 >>> 32 - 18;
          u2 = x5 + x1 | 0;
          x9 ^= u2 << 7 | u2 >>> 32 - 7;
          u2 = x9 + x5 | 0;
          x13 ^= u2 << 9 | u2 >>> 32 - 9;
          u2 = x13 + x9 | 0;
          x1 ^= u2 << 13 | u2 >>> 32 - 13;
          u2 = x1 + x13 | 0;
          x5 ^= u2 << 18 | u2 >>> 32 - 18;
          u2 = x10 + x6 | 0;
          x14 ^= u2 << 7 | u2 >>> 32 - 7;
          u2 = x14 + x10 | 0;
          x2 ^= u2 << 9 | u2 >>> 32 - 9;
          u2 = x2 + x14 | 0;
          x6 ^= u2 << 13 | u2 >>> 32 - 13;
          u2 = x6 + x2 | 0;
          x10 ^= u2 << 18 | u2 >>> 32 - 18;
          u2 = x15 + x11 | 0;
          x3 ^= u2 << 7 | u2 >>> 32 - 7;
          u2 = x3 + x15 | 0;
          x7 ^= u2 << 9 | u2 >>> 32 - 9;
          u2 = x7 + x3 | 0;
          x11 ^= u2 << 13 | u2 >>> 32 - 13;
          u2 = x11 + x7 | 0;
          x15 ^= u2 << 18 | u2 >>> 32 - 18;
          u2 = x0 + x3 | 0;
          x1 ^= u2 << 7 | u2 >>> 32 - 7;
          u2 = x1 + x0 | 0;
          x2 ^= u2 << 9 | u2 >>> 32 - 9;
          u2 = x2 + x1 | 0;
          x3 ^= u2 << 13 | u2 >>> 32 - 13;
          u2 = x3 + x2 | 0;
          x0 ^= u2 << 18 | u2 >>> 32 - 18;
          u2 = x5 + x4 | 0;
          x6 ^= u2 << 7 | u2 >>> 32 - 7;
          u2 = x6 + x5 | 0;
          x7 ^= u2 << 9 | u2 >>> 32 - 9;
          u2 = x7 + x6 | 0;
          x4 ^= u2 << 13 | u2 >>> 32 - 13;
          u2 = x4 + x7 | 0;
          x5 ^= u2 << 18 | u2 >>> 32 - 18;
          u2 = x10 + x9 | 0;
          x11 ^= u2 << 7 | u2 >>> 32 - 7;
          u2 = x11 + x10 | 0;
          x8 ^= u2 << 9 | u2 >>> 32 - 9;
          u2 = x8 + x11 | 0;
          x9 ^= u2 << 13 | u2 >>> 32 - 13;
          u2 = x9 + x8 | 0;
          x10 ^= u2 << 18 | u2 >>> 32 - 18;
          u2 = x15 + x14 | 0;
          x12 ^= u2 << 7 | u2 >>> 32 - 7;
          u2 = x12 + x15 | 0;
          x13 ^= u2 << 9 | u2 >>> 32 - 9;
          u2 = x13 + x12 | 0;
          x14 ^= u2 << 13 | u2 >>> 32 - 13;
          u2 = x14 + x13 | 0;
          x15 ^= u2 << 18 | u2 >>> 32 - 18;
        }
        o2[0] = x0 >>> 0 & 255;
        o2[1] = x0 >>> 8 & 255;
        o2[2] = x0 >>> 16 & 255;
        o2[3] = x0 >>> 24 & 255;
        o2[4] = x5 >>> 0 & 255;
        o2[5] = x5 >>> 8 & 255;
        o2[6] = x5 >>> 16 & 255;
        o2[7] = x5 >>> 24 & 255;
        o2[8] = x10 >>> 0 & 255;
        o2[9] = x10 >>> 8 & 255;
        o2[10] = x10 >>> 16 & 255;
        o2[11] = x10 >>> 24 & 255;
        o2[12] = x15 >>> 0 & 255;
        o2[13] = x15 >>> 8 & 255;
        o2[14] = x15 >>> 16 & 255;
        o2[15] = x15 >>> 24 & 255;
        o2[16] = x6 >>> 0 & 255;
        o2[17] = x6 >>> 8 & 255;
        o2[18] = x6 >>> 16 & 255;
        o2[19] = x6 >>> 24 & 255;
        o2[20] = x7 >>> 0 & 255;
        o2[21] = x7 >>> 8 & 255;
        o2[22] = x7 >>> 16 & 255;
        o2[23] = x7 >>> 24 & 255;
        o2[24] = x8 >>> 0 & 255;
        o2[25] = x8 >>> 8 & 255;
        o2[26] = x8 >>> 16 & 255;
        o2[27] = x8 >>> 24 & 255;
        o2[28] = x9 >>> 0 & 255;
        o2[29] = x9 >>> 8 & 255;
        o2[30] = x9 >>> 16 & 255;
        o2[31] = x9 >>> 24 & 255;
      }
      function crypto_core_salsa20(out, inp, k, c2) {
        core_salsa20(out, inp, k, c2);
      }
      function crypto_core_hsalsa20(out, inp, k, c2) {
        core_hsalsa20(out, inp, k, c2);
      }
      var sigma = new Uint8Array([101, 120, 112, 97, 110, 100, 32, 51, 50, 45, 98, 121, 116, 101, 32, 107]);
      function crypto_stream_salsa20_xor(c2, cpos, m2, mpos, b, n, k) {
        var z = new Uint8Array(16), x2 = new Uint8Array(64);
        var u2, i;
        for (i = 0; i < 16; i++)
          z[i] = 0;
        for (i = 0; i < 8; i++)
          z[i] = n[i];
        while (b >= 64) {
          crypto_core_salsa20(x2, z, k, sigma);
          for (i = 0; i < 64; i++)
            c2[cpos + i] = m2[mpos + i] ^ x2[i];
          u2 = 1;
          for (i = 8; i < 16; i++) {
            u2 = u2 + (z[i] & 255) | 0;
            z[i] = u2 & 255;
            u2 >>>= 8;
          }
          b -= 64;
          cpos += 64;
          mpos += 64;
        }
        if (b > 0) {
          crypto_core_salsa20(x2, z, k, sigma);
          for (i = 0; i < b; i++)
            c2[cpos + i] = m2[mpos + i] ^ x2[i];
        }
        return 0;
      }
      function crypto_stream_salsa20(c2, cpos, b, n, k) {
        var z = new Uint8Array(16), x2 = new Uint8Array(64);
        var u2, i;
        for (i = 0; i < 16; i++)
          z[i] = 0;
        for (i = 0; i < 8; i++)
          z[i] = n[i];
        while (b >= 64) {
          crypto_core_salsa20(x2, z, k, sigma);
          for (i = 0; i < 64; i++)
            c2[cpos + i] = x2[i];
          u2 = 1;
          for (i = 8; i < 16; i++) {
            u2 = u2 + (z[i] & 255) | 0;
            z[i] = u2 & 255;
            u2 >>>= 8;
          }
          b -= 64;
          cpos += 64;
        }
        if (b > 0) {
          crypto_core_salsa20(x2, z, k, sigma);
          for (i = 0; i < b; i++)
            c2[cpos + i] = x2[i];
        }
        return 0;
      }
      function crypto_stream(c2, cpos, d2, n, k) {
        var s = new Uint8Array(32);
        crypto_core_hsalsa20(s, n, k, sigma);
        var sn = new Uint8Array(8);
        for (var i = 0; i < 8; i++)
          sn[i] = n[i + 16];
        return crypto_stream_salsa20(c2, cpos, d2, sn, s);
      }
      function crypto_stream_xor(c2, cpos, m2, mpos, d2, n, k) {
        var s = new Uint8Array(32);
        crypto_core_hsalsa20(s, n, k, sigma);
        var sn = new Uint8Array(8);
        for (var i = 0; i < 8; i++)
          sn[i] = n[i + 16];
        return crypto_stream_salsa20_xor(c2, cpos, m2, mpos, d2, sn, s);
      }
      var poly1305 = function(key) {
        this.buffer = new Uint8Array(16);
        this.r = new Uint16Array(10);
        this.h = new Uint16Array(10);
        this.pad = new Uint16Array(8);
        this.leftover = 0;
        this.fin = 0;
        var t0, t1, t2, t3, t4, t5, t6, t7;
        t0 = key[0] & 255 | (key[1] & 255) << 8;
        this.r[0] = t0 & 8191;
        t1 = key[2] & 255 | (key[3] & 255) << 8;
        this.r[1] = (t0 >>> 13 | t1 << 3) & 8191;
        t2 = key[4] & 255 | (key[5] & 255) << 8;
        this.r[2] = (t1 >>> 10 | t2 << 6) & 7939;
        t3 = key[6] & 255 | (key[7] & 255) << 8;
        this.r[3] = (t2 >>> 7 | t3 << 9) & 8191;
        t4 = key[8] & 255 | (key[9] & 255) << 8;
        this.r[4] = (t3 >>> 4 | t4 << 12) & 255;
        this.r[5] = t4 >>> 1 & 8190;
        t5 = key[10] & 255 | (key[11] & 255) << 8;
        this.r[6] = (t4 >>> 14 | t5 << 2) & 8191;
        t6 = key[12] & 255 | (key[13] & 255) << 8;
        this.r[7] = (t5 >>> 11 | t6 << 5) & 8065;
        t7 = key[14] & 255 | (key[15] & 255) << 8;
        this.r[8] = (t6 >>> 8 | t7 << 8) & 8191;
        this.r[9] = t7 >>> 5 & 127;
        this.pad[0] = key[16] & 255 | (key[17] & 255) << 8;
        this.pad[1] = key[18] & 255 | (key[19] & 255) << 8;
        this.pad[2] = key[20] & 255 | (key[21] & 255) << 8;
        this.pad[3] = key[22] & 255 | (key[23] & 255) << 8;
        this.pad[4] = key[24] & 255 | (key[25] & 255) << 8;
        this.pad[5] = key[26] & 255 | (key[27] & 255) << 8;
        this.pad[6] = key[28] & 255 | (key[29] & 255) << 8;
        this.pad[7] = key[30] & 255 | (key[31] & 255) << 8;
      };
      poly1305.prototype.blocks = function(m2, mpos, bytes) {
        var hibit = this.fin ? 0 : 1 << 11;
        var t0, t1, t2, t3, t4, t5, t6, t7, c2;
        var d0, d1, d2, d3, d4, d5, d6, d7, d8, d9;
        var h0 = this.h[0], h1 = this.h[1], h2 = this.h[2], h3 = this.h[3], h4 = this.h[4], h5 = this.h[5], h6 = this.h[6], h7 = this.h[7], h8 = this.h[8], h9 = this.h[9];
        var r0 = this.r[0], r1 = this.r[1], r2 = this.r[2], r3 = this.r[3], r4 = this.r[4], r5 = this.r[5], r6 = this.r[6], r7 = this.r[7], r8 = this.r[8], r9 = this.r[9];
        while (bytes >= 16) {
          t0 = m2[mpos + 0] & 255 | (m2[mpos + 1] & 255) << 8;
          h0 += t0 & 8191;
          t1 = m2[mpos + 2] & 255 | (m2[mpos + 3] & 255) << 8;
          h1 += (t0 >>> 13 | t1 << 3) & 8191;
          t2 = m2[mpos + 4] & 255 | (m2[mpos + 5] & 255) << 8;
          h2 += (t1 >>> 10 | t2 << 6) & 8191;
          t3 = m2[mpos + 6] & 255 | (m2[mpos + 7] & 255) << 8;
          h3 += (t2 >>> 7 | t3 << 9) & 8191;
          t4 = m2[mpos + 8] & 255 | (m2[mpos + 9] & 255) << 8;
          h4 += (t3 >>> 4 | t4 << 12) & 8191;
          h5 += t4 >>> 1 & 8191;
          t5 = m2[mpos + 10] & 255 | (m2[mpos + 11] & 255) << 8;
          h6 += (t4 >>> 14 | t5 << 2) & 8191;
          t6 = m2[mpos + 12] & 255 | (m2[mpos + 13] & 255) << 8;
          h7 += (t5 >>> 11 | t6 << 5) & 8191;
          t7 = m2[mpos + 14] & 255 | (m2[mpos + 15] & 255) << 8;
          h8 += (t6 >>> 8 | t7 << 8) & 8191;
          h9 += t7 >>> 5 | hibit;
          c2 = 0;
          d0 = c2;
          d0 += h0 * r0;
          d0 += h1 * (5 * r9);
          d0 += h2 * (5 * r8);
          d0 += h3 * (5 * r7);
          d0 += h4 * (5 * r6);
          c2 = d0 >>> 13;
          d0 &= 8191;
          d0 += h5 * (5 * r5);
          d0 += h6 * (5 * r4);
          d0 += h7 * (5 * r3);
          d0 += h8 * (5 * r2);
          d0 += h9 * (5 * r1);
          c2 += d0 >>> 13;
          d0 &= 8191;
          d1 = c2;
          d1 += h0 * r1;
          d1 += h1 * r0;
          d1 += h2 * (5 * r9);
          d1 += h3 * (5 * r8);
          d1 += h4 * (5 * r7);
          c2 = d1 >>> 13;
          d1 &= 8191;
          d1 += h5 * (5 * r6);
          d1 += h6 * (5 * r5);
          d1 += h7 * (5 * r4);
          d1 += h8 * (5 * r3);
          d1 += h9 * (5 * r2);
          c2 += d1 >>> 13;
          d1 &= 8191;
          d2 = c2;
          d2 += h0 * r2;
          d2 += h1 * r1;
          d2 += h2 * r0;
          d2 += h3 * (5 * r9);
          d2 += h4 * (5 * r8);
          c2 = d2 >>> 13;
          d2 &= 8191;
          d2 += h5 * (5 * r7);
          d2 += h6 * (5 * r6);
          d2 += h7 * (5 * r5);
          d2 += h8 * (5 * r4);
          d2 += h9 * (5 * r3);
          c2 += d2 >>> 13;
          d2 &= 8191;
          d3 = c2;
          d3 += h0 * r3;
          d3 += h1 * r2;
          d3 += h2 * r1;
          d3 += h3 * r0;
          d3 += h4 * (5 * r9);
          c2 = d3 >>> 13;
          d3 &= 8191;
          d3 += h5 * (5 * r8);
          d3 += h6 * (5 * r7);
          d3 += h7 * (5 * r6);
          d3 += h8 * (5 * r5);
          d3 += h9 * (5 * r4);
          c2 += d3 >>> 13;
          d3 &= 8191;
          d4 = c2;
          d4 += h0 * r4;
          d4 += h1 * r3;
          d4 += h2 * r2;
          d4 += h3 * r1;
          d4 += h4 * r0;
          c2 = d4 >>> 13;
          d4 &= 8191;
          d4 += h5 * (5 * r9);
          d4 += h6 * (5 * r8);
          d4 += h7 * (5 * r7);
          d4 += h8 * (5 * r6);
          d4 += h9 * (5 * r5);
          c2 += d4 >>> 13;
          d4 &= 8191;
          d5 = c2;
          d5 += h0 * r5;
          d5 += h1 * r4;
          d5 += h2 * r3;
          d5 += h3 * r2;
          d5 += h4 * r1;
          c2 = d5 >>> 13;
          d5 &= 8191;
          d5 += h5 * r0;
          d5 += h6 * (5 * r9);
          d5 += h7 * (5 * r8);
          d5 += h8 * (5 * r7);
          d5 += h9 * (5 * r6);
          c2 += d5 >>> 13;
          d5 &= 8191;
          d6 = c2;
          d6 += h0 * r6;
          d6 += h1 * r5;
          d6 += h2 * r4;
          d6 += h3 * r3;
          d6 += h4 * r2;
          c2 = d6 >>> 13;
          d6 &= 8191;
          d6 += h5 * r1;
          d6 += h6 * r0;
          d6 += h7 * (5 * r9);
          d6 += h8 * (5 * r8);
          d6 += h9 * (5 * r7);
          c2 += d6 >>> 13;
          d6 &= 8191;
          d7 = c2;
          d7 += h0 * r7;
          d7 += h1 * r6;
          d7 += h2 * r5;
          d7 += h3 * r4;
          d7 += h4 * r3;
          c2 = d7 >>> 13;
          d7 &= 8191;
          d7 += h5 * r2;
          d7 += h6 * r1;
          d7 += h7 * r0;
          d7 += h8 * (5 * r9);
          d7 += h9 * (5 * r8);
          c2 += d7 >>> 13;
          d7 &= 8191;
          d8 = c2;
          d8 += h0 * r8;
          d8 += h1 * r7;
          d8 += h2 * r6;
          d8 += h3 * r5;
          d8 += h4 * r4;
          c2 = d8 >>> 13;
          d8 &= 8191;
          d8 += h5 * r3;
          d8 += h6 * r2;
          d8 += h7 * r1;
          d8 += h8 * r0;
          d8 += h9 * (5 * r9);
          c2 += d8 >>> 13;
          d8 &= 8191;
          d9 = c2;
          d9 += h0 * r9;
          d9 += h1 * r8;
          d9 += h2 * r7;
          d9 += h3 * r6;
          d9 += h4 * r5;
          c2 = d9 >>> 13;
          d9 &= 8191;
          d9 += h5 * r4;
          d9 += h6 * r3;
          d9 += h7 * r2;
          d9 += h8 * r1;
          d9 += h9 * r0;
          c2 += d9 >>> 13;
          d9 &= 8191;
          c2 = (c2 << 2) + c2 | 0;
          c2 = c2 + d0 | 0;
          d0 = c2 & 8191;
          c2 = c2 >>> 13;
          d1 += c2;
          h0 = d0;
          h1 = d1;
          h2 = d2;
          h3 = d3;
          h4 = d4;
          h5 = d5;
          h6 = d6;
          h7 = d7;
          h8 = d8;
          h9 = d9;
          mpos += 16;
          bytes -= 16;
        }
        this.h[0] = h0;
        this.h[1] = h1;
        this.h[2] = h2;
        this.h[3] = h3;
        this.h[4] = h4;
        this.h[5] = h5;
        this.h[6] = h6;
        this.h[7] = h7;
        this.h[8] = h8;
        this.h[9] = h9;
      };
      poly1305.prototype.finish = function(mac, macpos) {
        var g2 = new Uint16Array(10);
        var c2, mask, f2, i;
        if (this.leftover) {
          i = this.leftover;
          this.buffer[i++] = 1;
          for (; i < 16; i++)
            this.buffer[i] = 0;
          this.fin = 1;
          this.blocks(this.buffer, 0, 16);
        }
        c2 = this.h[1] >>> 13;
        this.h[1] &= 8191;
        for (i = 2; i < 10; i++) {
          this.h[i] += c2;
          c2 = this.h[i] >>> 13;
          this.h[i] &= 8191;
        }
        this.h[0] += c2 * 5;
        c2 = this.h[0] >>> 13;
        this.h[0] &= 8191;
        this.h[1] += c2;
        c2 = this.h[1] >>> 13;
        this.h[1] &= 8191;
        this.h[2] += c2;
        g2[0] = this.h[0] + 5;
        c2 = g2[0] >>> 13;
        g2[0] &= 8191;
        for (i = 1; i < 10; i++) {
          g2[i] = this.h[i] + c2;
          c2 = g2[i] >>> 13;
          g2[i] &= 8191;
        }
        g2[9] -= 1 << 13;
        mask = (c2 ^ 1) - 1;
        for (i = 0; i < 10; i++)
          g2[i] &= mask;
        mask = ~mask;
        for (i = 0; i < 10; i++)
          this.h[i] = this.h[i] & mask | g2[i];
        this.h[0] = (this.h[0] | this.h[1] << 13) & 65535;
        this.h[1] = (this.h[1] >>> 3 | this.h[2] << 10) & 65535;
        this.h[2] = (this.h[2] >>> 6 | this.h[3] << 7) & 65535;
        this.h[3] = (this.h[3] >>> 9 | this.h[4] << 4) & 65535;
        this.h[4] = (this.h[4] >>> 12 | this.h[5] << 1 | this.h[6] << 14) & 65535;
        this.h[5] = (this.h[6] >>> 2 | this.h[7] << 11) & 65535;
        this.h[6] = (this.h[7] >>> 5 | this.h[8] << 8) & 65535;
        this.h[7] = (this.h[8] >>> 8 | this.h[9] << 5) & 65535;
        f2 = this.h[0] + this.pad[0];
        this.h[0] = f2 & 65535;
        for (i = 1; i < 8; i++) {
          f2 = (this.h[i] + this.pad[i] | 0) + (f2 >>> 16) | 0;
          this.h[i] = f2 & 65535;
        }
        mac[macpos + 0] = this.h[0] >>> 0 & 255;
        mac[macpos + 1] = this.h[0] >>> 8 & 255;
        mac[macpos + 2] = this.h[1] >>> 0 & 255;
        mac[macpos + 3] = this.h[1] >>> 8 & 255;
        mac[macpos + 4] = this.h[2] >>> 0 & 255;
        mac[macpos + 5] = this.h[2] >>> 8 & 255;
        mac[macpos + 6] = this.h[3] >>> 0 & 255;
        mac[macpos + 7] = this.h[3] >>> 8 & 255;
        mac[macpos + 8] = this.h[4] >>> 0 & 255;
        mac[macpos + 9] = this.h[4] >>> 8 & 255;
        mac[macpos + 10] = this.h[5] >>> 0 & 255;
        mac[macpos + 11] = this.h[5] >>> 8 & 255;
        mac[macpos + 12] = this.h[6] >>> 0 & 255;
        mac[macpos + 13] = this.h[6] >>> 8 & 255;
        mac[macpos + 14] = this.h[7] >>> 0 & 255;
        mac[macpos + 15] = this.h[7] >>> 8 & 255;
      };
      poly1305.prototype.update = function(m2, mpos, bytes) {
        var i, want;
        if (this.leftover) {
          want = 16 - this.leftover;
          if (want > bytes)
            want = bytes;
          for (i = 0; i < want; i++)
            this.buffer[this.leftover + i] = m2[mpos + i];
          bytes -= want;
          mpos += want;
          this.leftover += want;
          if (this.leftover < 16)
            return;
          this.blocks(this.buffer, 0, 16);
          this.leftover = 0;
        }
        if (bytes >= 16) {
          want = bytes - bytes % 16;
          this.blocks(m2, mpos, want);
          mpos += want;
          bytes -= want;
        }
        if (bytes) {
          for (i = 0; i < bytes; i++)
            this.buffer[this.leftover + i] = m2[mpos + i];
          this.leftover += bytes;
        }
      };
      function crypto_onetimeauth(out, outpos, m2, mpos, n, k) {
        var s = new poly1305(k);
        s.update(m2, mpos, n);
        s.finish(out, outpos);
        return 0;
      }
      function crypto_onetimeauth_verify(h, hpos, m2, mpos, n, k) {
        var x2 = new Uint8Array(16);
        crypto_onetimeauth(x2, 0, m2, mpos, n, k);
        return crypto_verify_16(h, hpos, x2, 0);
      }
      function crypto_secretbox(c2, m2, d2, n, k) {
        var i;
        if (d2 < 32)
          return -1;
        crypto_stream_xor(c2, 0, m2, 0, d2, n, k);
        crypto_onetimeauth(c2, 16, c2, 32, d2 - 32, c2);
        for (i = 0; i < 16; i++)
          c2[i] = 0;
        return 0;
      }
      function crypto_secretbox_open(m2, c2, d2, n, k) {
        var i;
        var x2 = new Uint8Array(32);
        if (d2 < 32)
          return -1;
        crypto_stream(x2, 0, 32, n, k);
        if (crypto_onetimeauth_verify(c2, 16, c2, 32, d2 - 32, x2) !== 0)
          return -1;
        crypto_stream_xor(m2, 0, c2, 0, d2, n, k);
        for (i = 0; i < 32; i++)
          m2[i] = 0;
        return 0;
      }
      function set25519(r, a) {
        var i;
        for (i = 0; i < 16; i++)
          r[i] = a[i] | 0;
      }
      function car25519(o2) {
        var i, v, c2 = 1;
        for (i = 0; i < 16; i++) {
          v = o2[i] + c2 + 65535;
          c2 = Math.floor(v / 65536);
          o2[i] = v - c2 * 65536;
        }
        o2[0] += c2 - 1 + 37 * (c2 - 1);
      }
      function sel25519(p3, q2, b) {
        var t, c2 = ~(b - 1);
        for (var i = 0; i < 16; i++) {
          t = c2 & (p3[i] ^ q2[i]);
          p3[i] ^= t;
          q2[i] ^= t;
        }
      }
      function pack25519(o2, n) {
        var i, j, b;
        var m2 = gf(), t = gf();
        for (i = 0; i < 16; i++)
          t[i] = n[i];
        car25519(t);
        car25519(t);
        car25519(t);
        for (j = 0; j < 2; j++) {
          m2[0] = t[0] - 65517;
          for (i = 1; i < 15; i++) {
            m2[i] = t[i] - 65535 - (m2[i - 1] >> 16 & 1);
            m2[i - 1] &= 65535;
          }
          m2[15] = t[15] - 32767 - (m2[14] >> 16 & 1);
          b = m2[15] >> 16 & 1;
          m2[14] &= 65535;
          sel25519(t, m2, 1 - b);
        }
        for (i = 0; i < 16; i++) {
          o2[2 * i] = t[i] & 255;
          o2[2 * i + 1] = t[i] >> 8;
        }
      }
      function neq25519(a, b) {
        var c2 = new Uint8Array(32), d2 = new Uint8Array(32);
        pack25519(c2, a);
        pack25519(d2, b);
        return crypto_verify_32(c2, 0, d2, 0);
      }
      function par25519(a) {
        var d2 = new Uint8Array(32);
        pack25519(d2, a);
        return d2[0] & 1;
      }
      function unpack25519(o2, n) {
        var i;
        for (i = 0; i < 16; i++)
          o2[i] = n[2 * i] + (n[2 * i + 1] << 8);
        o2[15] &= 32767;
      }
      function A(o2, a, b) {
        for (var i = 0; i < 16; i++)
          o2[i] = a[i] + b[i];
      }
      function Z(o2, a, b) {
        for (var i = 0; i < 16; i++)
          o2[i] = a[i] - b[i];
      }
      function M(o2, a, b) {
        var v, c2, t0 = 0, t1 = 0, t2 = 0, t3 = 0, t4 = 0, t5 = 0, t6 = 0, t7 = 0, t8 = 0, t9 = 0, t10 = 0, t11 = 0, t12 = 0, t13 = 0, t14 = 0, t15 = 0, t16 = 0, t17 = 0, t18 = 0, t19 = 0, t20 = 0, t21 = 0, t22 = 0, t23 = 0, t24 = 0, t25 = 0, t26 = 0, t27 = 0, t28 = 0, t29 = 0, t30 = 0, b0 = b[0], b1 = b[1], b2 = b[2], b3 = b[3], b4 = b[4], b5 = b[5], b6 = b[6], b7 = b[7], b8 = b[8], b9 = b[9], b10 = b[10], b11 = b[11], b12 = b[12], b13 = b[13], b14 = b[14], b15 = b[15];
        v = a[0];
        t0 += v * b0;
        t1 += v * b1;
        t2 += v * b2;
        t3 += v * b3;
        t4 += v * b4;
        t5 += v * b5;
        t6 += v * b6;
        t7 += v * b7;
        t8 += v * b8;
        t9 += v * b9;
        t10 += v * b10;
        t11 += v * b11;
        t12 += v * b12;
        t13 += v * b13;
        t14 += v * b14;
        t15 += v * b15;
        v = a[1];
        t1 += v * b0;
        t2 += v * b1;
        t3 += v * b2;
        t4 += v * b3;
        t5 += v * b4;
        t6 += v * b5;
        t7 += v * b6;
        t8 += v * b7;
        t9 += v * b8;
        t10 += v * b9;
        t11 += v * b10;
        t12 += v * b11;
        t13 += v * b12;
        t14 += v * b13;
        t15 += v * b14;
        t16 += v * b15;
        v = a[2];
        t2 += v * b0;
        t3 += v * b1;
        t4 += v * b2;
        t5 += v * b3;
        t6 += v * b4;
        t7 += v * b5;
        t8 += v * b6;
        t9 += v * b7;
        t10 += v * b8;
        t11 += v * b9;
        t12 += v * b10;
        t13 += v * b11;
        t14 += v * b12;
        t15 += v * b13;
        t16 += v * b14;
        t17 += v * b15;
        v = a[3];
        t3 += v * b0;
        t4 += v * b1;
        t5 += v * b2;
        t6 += v * b3;
        t7 += v * b4;
        t8 += v * b5;
        t9 += v * b6;
        t10 += v * b7;
        t11 += v * b8;
        t12 += v * b9;
        t13 += v * b10;
        t14 += v * b11;
        t15 += v * b12;
        t16 += v * b13;
        t17 += v * b14;
        t18 += v * b15;
        v = a[4];
        t4 += v * b0;
        t5 += v * b1;
        t6 += v * b2;
        t7 += v * b3;
        t8 += v * b4;
        t9 += v * b5;
        t10 += v * b6;
        t11 += v * b7;
        t12 += v * b8;
        t13 += v * b9;
        t14 += v * b10;
        t15 += v * b11;
        t16 += v * b12;
        t17 += v * b13;
        t18 += v * b14;
        t19 += v * b15;
        v = a[5];
        t5 += v * b0;
        t6 += v * b1;
        t7 += v * b2;
        t8 += v * b3;
        t9 += v * b4;
        t10 += v * b5;
        t11 += v * b6;
        t12 += v * b7;
        t13 += v * b8;
        t14 += v * b9;
        t15 += v * b10;
        t16 += v * b11;
        t17 += v * b12;
        t18 += v * b13;
        t19 += v * b14;
        t20 += v * b15;
        v = a[6];
        t6 += v * b0;
        t7 += v * b1;
        t8 += v * b2;
        t9 += v * b3;
        t10 += v * b4;
        t11 += v * b5;
        t12 += v * b6;
        t13 += v * b7;
        t14 += v * b8;
        t15 += v * b9;
        t16 += v * b10;
        t17 += v * b11;
        t18 += v * b12;
        t19 += v * b13;
        t20 += v * b14;
        t21 += v * b15;
        v = a[7];
        t7 += v * b0;
        t8 += v * b1;
        t9 += v * b2;
        t10 += v * b3;
        t11 += v * b4;
        t12 += v * b5;
        t13 += v * b6;
        t14 += v * b7;
        t15 += v * b8;
        t16 += v * b9;
        t17 += v * b10;
        t18 += v * b11;
        t19 += v * b12;
        t20 += v * b13;
        t21 += v * b14;
        t22 += v * b15;
        v = a[8];
        t8 += v * b0;
        t9 += v * b1;
        t10 += v * b2;
        t11 += v * b3;
        t12 += v * b4;
        t13 += v * b5;
        t14 += v * b6;
        t15 += v * b7;
        t16 += v * b8;
        t17 += v * b9;
        t18 += v * b10;
        t19 += v * b11;
        t20 += v * b12;
        t21 += v * b13;
        t22 += v * b14;
        t23 += v * b15;
        v = a[9];
        t9 += v * b0;
        t10 += v * b1;
        t11 += v * b2;
        t12 += v * b3;
        t13 += v * b4;
        t14 += v * b5;
        t15 += v * b6;
        t16 += v * b7;
        t17 += v * b8;
        t18 += v * b9;
        t19 += v * b10;
        t20 += v * b11;
        t21 += v * b12;
        t22 += v * b13;
        t23 += v * b14;
        t24 += v * b15;
        v = a[10];
        t10 += v * b0;
        t11 += v * b1;
        t12 += v * b2;
        t13 += v * b3;
        t14 += v * b4;
        t15 += v * b5;
        t16 += v * b6;
        t17 += v * b7;
        t18 += v * b8;
        t19 += v * b9;
        t20 += v * b10;
        t21 += v * b11;
        t22 += v * b12;
        t23 += v * b13;
        t24 += v * b14;
        t25 += v * b15;
        v = a[11];
        t11 += v * b0;
        t12 += v * b1;
        t13 += v * b2;
        t14 += v * b3;
        t15 += v * b4;
        t16 += v * b5;
        t17 += v * b6;
        t18 += v * b7;
        t19 += v * b8;
        t20 += v * b9;
        t21 += v * b10;
        t22 += v * b11;
        t23 += v * b12;
        t24 += v * b13;
        t25 += v * b14;
        t26 += v * b15;
        v = a[12];
        t12 += v * b0;
        t13 += v * b1;
        t14 += v * b2;
        t15 += v * b3;
        t16 += v * b4;
        t17 += v * b5;
        t18 += v * b6;
        t19 += v * b7;
        t20 += v * b8;
        t21 += v * b9;
        t22 += v * b10;
        t23 += v * b11;
        t24 += v * b12;
        t25 += v * b13;
        t26 += v * b14;
        t27 += v * b15;
        v = a[13];
        t13 += v * b0;
        t14 += v * b1;
        t15 += v * b2;
        t16 += v * b3;
        t17 += v * b4;
        t18 += v * b5;
        t19 += v * b6;
        t20 += v * b7;
        t21 += v * b8;
        t22 += v * b9;
        t23 += v * b10;
        t24 += v * b11;
        t25 += v * b12;
        t26 += v * b13;
        t27 += v * b14;
        t28 += v * b15;
        v = a[14];
        t14 += v * b0;
        t15 += v * b1;
        t16 += v * b2;
        t17 += v * b3;
        t18 += v * b4;
        t19 += v * b5;
        t20 += v * b6;
        t21 += v * b7;
        t22 += v * b8;
        t23 += v * b9;
        t24 += v * b10;
        t25 += v * b11;
        t26 += v * b12;
        t27 += v * b13;
        t28 += v * b14;
        t29 += v * b15;
        v = a[15];
        t15 += v * b0;
        t16 += v * b1;
        t17 += v * b2;
        t18 += v * b3;
        t19 += v * b4;
        t20 += v * b5;
        t21 += v * b6;
        t22 += v * b7;
        t23 += v * b8;
        t24 += v * b9;
        t25 += v * b10;
        t26 += v * b11;
        t27 += v * b12;
        t28 += v * b13;
        t29 += v * b14;
        t30 += v * b15;
        t0 += 38 * t16;
        t1 += 38 * t17;
        t2 += 38 * t18;
        t3 += 38 * t19;
        t4 += 38 * t20;
        t5 += 38 * t21;
        t6 += 38 * t22;
        t7 += 38 * t23;
        t8 += 38 * t24;
        t9 += 38 * t25;
        t10 += 38 * t26;
        t11 += 38 * t27;
        t12 += 38 * t28;
        t13 += 38 * t29;
        t14 += 38 * t30;
        c2 = 1;
        v = t0 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t0 = v - c2 * 65536;
        v = t1 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t1 = v - c2 * 65536;
        v = t2 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t2 = v - c2 * 65536;
        v = t3 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t3 = v - c2 * 65536;
        v = t4 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t4 = v - c2 * 65536;
        v = t5 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t5 = v - c2 * 65536;
        v = t6 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t6 = v - c2 * 65536;
        v = t7 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t7 = v - c2 * 65536;
        v = t8 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t8 = v - c2 * 65536;
        v = t9 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t9 = v - c2 * 65536;
        v = t10 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t10 = v - c2 * 65536;
        v = t11 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t11 = v - c2 * 65536;
        v = t12 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t12 = v - c2 * 65536;
        v = t13 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t13 = v - c2 * 65536;
        v = t14 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t14 = v - c2 * 65536;
        v = t15 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t15 = v - c2 * 65536;
        t0 += c2 - 1 + 37 * (c2 - 1);
        c2 = 1;
        v = t0 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t0 = v - c2 * 65536;
        v = t1 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t1 = v - c2 * 65536;
        v = t2 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t2 = v - c2 * 65536;
        v = t3 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t3 = v - c2 * 65536;
        v = t4 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t4 = v - c2 * 65536;
        v = t5 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t5 = v - c2 * 65536;
        v = t6 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t6 = v - c2 * 65536;
        v = t7 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t7 = v - c2 * 65536;
        v = t8 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t8 = v - c2 * 65536;
        v = t9 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t9 = v - c2 * 65536;
        v = t10 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t10 = v - c2 * 65536;
        v = t11 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t11 = v - c2 * 65536;
        v = t12 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t12 = v - c2 * 65536;
        v = t13 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t13 = v - c2 * 65536;
        v = t14 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t14 = v - c2 * 65536;
        v = t15 + c2 + 65535;
        c2 = Math.floor(v / 65536);
        t15 = v - c2 * 65536;
        t0 += c2 - 1 + 37 * (c2 - 1);
        o2[0] = t0;
        o2[1] = t1;
        o2[2] = t2;
        o2[3] = t3;
        o2[4] = t4;
        o2[5] = t5;
        o2[6] = t6;
        o2[7] = t7;
        o2[8] = t8;
        o2[9] = t9;
        o2[10] = t10;
        o2[11] = t11;
        o2[12] = t12;
        o2[13] = t13;
        o2[14] = t14;
        o2[15] = t15;
      }
      function S(o2, a) {
        M(o2, a, a);
      }
      function inv25519(o2, i) {
        var c2 = gf();
        var a;
        for (a = 0; a < 16; a++)
          c2[a] = i[a];
        for (a = 253; a >= 0; a--) {
          S(c2, c2);
          if (a !== 2 && a !== 4)
            M(c2, c2, i);
        }
        for (a = 0; a < 16; a++)
          o2[a] = c2[a];
      }
      function pow2523(o2, i) {
        var c2 = gf();
        var a;
        for (a = 0; a < 16; a++)
          c2[a] = i[a];
        for (a = 250; a >= 0; a--) {
          S(c2, c2);
          if (a !== 1)
            M(c2, c2, i);
        }
        for (a = 0; a < 16; a++)
          o2[a] = c2[a];
      }
      function crypto_scalarmult(q2, n, p3) {
        var z = new Uint8Array(32);
        var x2 = new Float64Array(80), r, i;
        var a = gf(), b = gf(), c2 = gf(), d2 = gf(), e = gf(), f2 = gf();
        for (i = 0; i < 31; i++)
          z[i] = n[i];
        z[31] = n[31] & 127 | 64;
        z[0] &= 248;
        unpack25519(x2, p3);
        for (i = 0; i < 16; i++) {
          b[i] = x2[i];
          d2[i] = a[i] = c2[i] = 0;
        }
        a[0] = d2[0] = 1;
        for (i = 254; i >= 0; --i) {
          r = z[i >>> 3] >>> (i & 7) & 1;
          sel25519(a, b, r);
          sel25519(c2, d2, r);
          A(e, a, c2);
          Z(a, a, c2);
          A(c2, b, d2);
          Z(b, b, d2);
          S(d2, e);
          S(f2, a);
          M(a, c2, a);
          M(c2, b, e);
          A(e, a, c2);
          Z(a, a, c2);
          S(b, a);
          Z(c2, d2, f2);
          M(a, c2, _121665);
          A(a, a, d2);
          M(c2, c2, a);
          M(a, d2, f2);
          M(d2, b, x2);
          S(b, e);
          sel25519(a, b, r);
          sel25519(c2, d2, r);
        }
        for (i = 0; i < 16; i++) {
          x2[i + 16] = a[i];
          x2[i + 32] = c2[i];
          x2[i + 48] = b[i];
          x2[i + 64] = d2[i];
        }
        var x32 = x2.subarray(32);
        var x16 = x2.subarray(16);
        inv25519(x32, x32);
        M(x16, x16, x32);
        pack25519(q2, x16);
        return 0;
      }
      function crypto_scalarmult_base(q2, n) {
        return crypto_scalarmult(q2, n, _9);
      }
      function crypto_box_keypair(y, x2) {
        randombytes(x2, 32);
        return crypto_scalarmult_base(y, x2);
      }
      function crypto_box_beforenm(k, y, x2) {
        var s = new Uint8Array(32);
        crypto_scalarmult(s, x2, y);
        return crypto_core_hsalsa20(k, _0, s, sigma);
      }
      var crypto_box_afternm = crypto_secretbox;
      var crypto_box_open_afternm = crypto_secretbox_open;
      function crypto_box(c2, m2, d2, n, y, x2) {
        var k = new Uint8Array(32);
        crypto_box_beforenm(k, y, x2);
        return crypto_box_afternm(c2, m2, d2, n, k);
      }
      function crypto_box_open(m2, c2, d2, n, y, x2) {
        var k = new Uint8Array(32);
        crypto_box_beforenm(k, y, x2);
        return crypto_box_open_afternm(m2, c2, d2, n, k);
      }
      var K = [
        1116352408,
        3609767458,
        1899447441,
        602891725,
        3049323471,
        3964484399,
        3921009573,
        2173295548,
        961987163,
        4081628472,
        1508970993,
        3053834265,
        2453635748,
        2937671579,
        2870763221,
        3664609560,
        3624381080,
        2734883394,
        310598401,
        1164996542,
        607225278,
        1323610764,
        1426881987,
        3590304994,
        1925078388,
        4068182383,
        2162078206,
        991336113,
        2614888103,
        633803317,
        3248222580,
        3479774868,
        3835390401,
        2666613458,
        4022224774,
        944711139,
        264347078,
        2341262773,
        604807628,
        2007800933,
        770255983,
        1495990901,
        1249150122,
        1856431235,
        1555081692,
        3175218132,
        1996064986,
        2198950837,
        2554220882,
        3999719339,
        2821834349,
        766784016,
        2952996808,
        2566594879,
        3210313671,
        3203337956,
        3336571891,
        1034457026,
        3584528711,
        2466948901,
        113926993,
        3758326383,
        338241895,
        168717936,
        666307205,
        1188179964,
        773529912,
        1546045734,
        1294757372,
        1522805485,
        1396182291,
        2643833823,
        1695183700,
        2343527390,
        1986661051,
        1014477480,
        2177026350,
        1206759142,
        2456956037,
        344077627,
        2730485921,
        1290863460,
        2820302411,
        3158454273,
        3259730800,
        3505952657,
        3345764771,
        106217008,
        3516065817,
        3606008344,
        3600352804,
        1432725776,
        4094571909,
        1467031594,
        275423344,
        851169720,
        430227734,
        3100823752,
        506948616,
        1363258195,
        659060556,
        3750685593,
        883997877,
        3785050280,
        958139571,
        3318307427,
        1322822218,
        3812723403,
        1537002063,
        2003034995,
        1747873779,
        3602036899,
        1955562222,
        1575990012,
        2024104815,
        1125592928,
        2227730452,
        2716904306,
        2361852424,
        442776044,
        2428436474,
        593698344,
        2756734187,
        3733110249,
        3204031479,
        2999351573,
        3329325298,
        3815920427,
        3391569614,
        3928383900,
        3515267271,
        566280711,
        3940187606,
        3454069534,
        4118630271,
        4000239992,
        116418474,
        1914138554,
        174292421,
        2731055270,
        289380356,
        3203993006,
        460393269,
        320620315,
        685471733,
        587496836,
        852142971,
        1086792851,
        1017036298,
        365543100,
        1126000580,
        2618297676,
        1288033470,
        3409855158,
        1501505948,
        4234509866,
        1607167915,
        987167468,
        1816402316,
        1246189591
      ];
      function crypto_hashblocks_hl(hh, hl, m2, n) {
        var wh = new Int32Array(16), wl = new Int32Array(16), bh0, bh1, bh2, bh3, bh4, bh5, bh6, bh7, bl0, bl1, bl2, bl3, bl4, bl5, bl6, bl7, th, tl, i, j, h, l2, a, b, c2, d2;
        var ah0 = hh[0], ah1 = hh[1], ah2 = hh[2], ah3 = hh[3], ah4 = hh[4], ah5 = hh[5], ah6 = hh[6], ah7 = hh[7], al0 = hl[0], al1 = hl[1], al2 = hl[2], al3 = hl[3], al4 = hl[4], al5 = hl[5], al6 = hl[6], al7 = hl[7];
        var pos = 0;
        while (n >= 128) {
          for (i = 0; i < 16; i++) {
            j = 8 * i + pos;
            wh[i] = m2[j + 0] << 24 | m2[j + 1] << 16 | m2[j + 2] << 8 | m2[j + 3];
            wl[i] = m2[j + 4] << 24 | m2[j + 5] << 16 | m2[j + 6] << 8 | m2[j + 7];
          }
          for (i = 0; i < 80; i++) {
            bh0 = ah0;
            bh1 = ah1;
            bh2 = ah2;
            bh3 = ah3;
            bh4 = ah4;
            bh5 = ah5;
            bh6 = ah6;
            bh7 = ah7;
            bl0 = al0;
            bl1 = al1;
            bl2 = al2;
            bl3 = al3;
            bl4 = al4;
            bl5 = al5;
            bl6 = al6;
            bl7 = al7;
            h = ah7;
            l2 = al7;
            a = l2 & 65535;
            b = l2 >>> 16;
            c2 = h & 65535;
            d2 = h >>> 16;
            h = (ah4 >>> 14 | al4 << 32 - 14) ^ (ah4 >>> 18 | al4 << 32 - 18) ^ (al4 >>> 41 - 32 | ah4 << 32 - (41 - 32));
            l2 = (al4 >>> 14 | ah4 << 32 - 14) ^ (al4 >>> 18 | ah4 << 32 - 18) ^ (ah4 >>> 41 - 32 | al4 << 32 - (41 - 32));
            a += l2 & 65535;
            b += l2 >>> 16;
            c2 += h & 65535;
            d2 += h >>> 16;
            h = ah4 & ah5 ^ ~ah4 & ah6;
            l2 = al4 & al5 ^ ~al4 & al6;
            a += l2 & 65535;
            b += l2 >>> 16;
            c2 += h & 65535;
            d2 += h >>> 16;
            h = K[i * 2];
            l2 = K[i * 2 + 1];
            a += l2 & 65535;
            b += l2 >>> 16;
            c2 += h & 65535;
            d2 += h >>> 16;
            h = wh[i % 16];
            l2 = wl[i % 16];
            a += l2 & 65535;
            b += l2 >>> 16;
            c2 += h & 65535;
            d2 += h >>> 16;
            b += a >>> 16;
            c2 += b >>> 16;
            d2 += c2 >>> 16;
            th = c2 & 65535 | d2 << 16;
            tl = a & 65535 | b << 16;
            h = th;
            l2 = tl;
            a = l2 & 65535;
            b = l2 >>> 16;
            c2 = h & 65535;
            d2 = h >>> 16;
            h = (ah0 >>> 28 | al0 << 32 - 28) ^ (al0 >>> 34 - 32 | ah0 << 32 - (34 - 32)) ^ (al0 >>> 39 - 32 | ah0 << 32 - (39 - 32));
            l2 = (al0 >>> 28 | ah0 << 32 - 28) ^ (ah0 >>> 34 - 32 | al0 << 32 - (34 - 32)) ^ (ah0 >>> 39 - 32 | al0 << 32 - (39 - 32));
            a += l2 & 65535;
            b += l2 >>> 16;
            c2 += h & 65535;
            d2 += h >>> 16;
            h = ah0 & ah1 ^ ah0 & ah2 ^ ah1 & ah2;
            l2 = al0 & al1 ^ al0 & al2 ^ al1 & al2;
            a += l2 & 65535;
            b += l2 >>> 16;
            c2 += h & 65535;
            d2 += h >>> 16;
            b += a >>> 16;
            c2 += b >>> 16;
            d2 += c2 >>> 16;
            bh7 = c2 & 65535 | d2 << 16;
            bl7 = a & 65535 | b << 16;
            h = bh3;
            l2 = bl3;
            a = l2 & 65535;
            b = l2 >>> 16;
            c2 = h & 65535;
            d2 = h >>> 16;
            h = th;
            l2 = tl;
            a += l2 & 65535;
            b += l2 >>> 16;
            c2 += h & 65535;
            d2 += h >>> 16;
            b += a >>> 16;
            c2 += b >>> 16;
            d2 += c2 >>> 16;
            bh3 = c2 & 65535 | d2 << 16;
            bl3 = a & 65535 | b << 16;
            ah1 = bh0;
            ah2 = bh1;
            ah3 = bh2;
            ah4 = bh3;
            ah5 = bh4;
            ah6 = bh5;
            ah7 = bh6;
            ah0 = bh7;
            al1 = bl0;
            al2 = bl1;
            al3 = bl2;
            al4 = bl3;
            al5 = bl4;
            al6 = bl5;
            al7 = bl6;
            al0 = bl7;
            if (i % 16 === 15) {
              for (j = 0; j < 16; j++) {
                h = wh[j];
                l2 = wl[j];
                a = l2 & 65535;
                b = l2 >>> 16;
                c2 = h & 65535;
                d2 = h >>> 16;
                h = wh[(j + 9) % 16];
                l2 = wl[(j + 9) % 16];
                a += l2 & 65535;
                b += l2 >>> 16;
                c2 += h & 65535;
                d2 += h >>> 16;
                th = wh[(j + 1) % 16];
                tl = wl[(j + 1) % 16];
                h = (th >>> 1 | tl << 32 - 1) ^ (th >>> 8 | tl << 32 - 8) ^ th >>> 7;
                l2 = (tl >>> 1 | th << 32 - 1) ^ (tl >>> 8 | th << 32 - 8) ^ (tl >>> 7 | th << 32 - 7);
                a += l2 & 65535;
                b += l2 >>> 16;
                c2 += h & 65535;
                d2 += h >>> 16;
                th = wh[(j + 14) % 16];
                tl = wl[(j + 14) % 16];
                h = (th >>> 19 | tl << 32 - 19) ^ (tl >>> 61 - 32 | th << 32 - (61 - 32)) ^ th >>> 6;
                l2 = (tl >>> 19 | th << 32 - 19) ^ (th >>> 61 - 32 | tl << 32 - (61 - 32)) ^ (tl >>> 6 | th << 32 - 6);
                a += l2 & 65535;
                b += l2 >>> 16;
                c2 += h & 65535;
                d2 += h >>> 16;
                b += a >>> 16;
                c2 += b >>> 16;
                d2 += c2 >>> 16;
                wh[j] = c2 & 65535 | d2 << 16;
                wl[j] = a & 65535 | b << 16;
              }
            }
          }
          h = ah0;
          l2 = al0;
          a = l2 & 65535;
          b = l2 >>> 16;
          c2 = h & 65535;
          d2 = h >>> 16;
          h = hh[0];
          l2 = hl[0];
          a += l2 & 65535;
          b += l2 >>> 16;
          c2 += h & 65535;
          d2 += h >>> 16;
          b += a >>> 16;
          c2 += b >>> 16;
          d2 += c2 >>> 16;
          hh[0] = ah0 = c2 & 65535 | d2 << 16;
          hl[0] = al0 = a & 65535 | b << 16;
          h = ah1;
          l2 = al1;
          a = l2 & 65535;
          b = l2 >>> 16;
          c2 = h & 65535;
          d2 = h >>> 16;
          h = hh[1];
          l2 = hl[1];
          a += l2 & 65535;
          b += l2 >>> 16;
          c2 += h & 65535;
          d2 += h >>> 16;
          b += a >>> 16;
          c2 += b >>> 16;
          d2 += c2 >>> 16;
          hh[1] = ah1 = c2 & 65535 | d2 << 16;
          hl[1] = al1 = a & 65535 | b << 16;
          h = ah2;
          l2 = al2;
          a = l2 & 65535;
          b = l2 >>> 16;
          c2 = h & 65535;
          d2 = h >>> 16;
          h = hh[2];
          l2 = hl[2];
          a += l2 & 65535;
          b += l2 >>> 16;
          c2 += h & 65535;
          d2 += h >>> 16;
          b += a >>> 16;
          c2 += b >>> 16;
          d2 += c2 >>> 16;
          hh[2] = ah2 = c2 & 65535 | d2 << 16;
          hl[2] = al2 = a & 65535 | b << 16;
          h = ah3;
          l2 = al3;
          a = l2 & 65535;
          b = l2 >>> 16;
          c2 = h & 65535;
          d2 = h >>> 16;
          h = hh[3];
          l2 = hl[3];
          a += l2 & 65535;
          b += l2 >>> 16;
          c2 += h & 65535;
          d2 += h >>> 16;
          b += a >>> 16;
          c2 += b >>> 16;
          d2 += c2 >>> 16;
          hh[3] = ah3 = c2 & 65535 | d2 << 16;
          hl[3] = al3 = a & 65535 | b << 16;
          h = ah4;
          l2 = al4;
          a = l2 & 65535;
          b = l2 >>> 16;
          c2 = h & 65535;
          d2 = h >>> 16;
          h = hh[4];
          l2 = hl[4];
          a += l2 & 65535;
          b += l2 >>> 16;
          c2 += h & 65535;
          d2 += h >>> 16;
          b += a >>> 16;
          c2 += b >>> 16;
          d2 += c2 >>> 16;
          hh[4] = ah4 = c2 & 65535 | d2 << 16;
          hl[4] = al4 = a & 65535 | b << 16;
          h = ah5;
          l2 = al5;
          a = l2 & 65535;
          b = l2 >>> 16;
          c2 = h & 65535;
          d2 = h >>> 16;
          h = hh[5];
          l2 = hl[5];
          a += l2 & 65535;
          b += l2 >>> 16;
          c2 += h & 65535;
          d2 += h >>> 16;
          b += a >>> 16;
          c2 += b >>> 16;
          d2 += c2 >>> 16;
          hh[5] = ah5 = c2 & 65535 | d2 << 16;
          hl[5] = al5 = a & 65535 | b << 16;
          h = ah6;
          l2 = al6;
          a = l2 & 65535;
          b = l2 >>> 16;
          c2 = h & 65535;
          d2 = h >>> 16;
          h = hh[6];
          l2 = hl[6];
          a += l2 & 65535;
          b += l2 >>> 16;
          c2 += h & 65535;
          d2 += h >>> 16;
          b += a >>> 16;
          c2 += b >>> 16;
          d2 += c2 >>> 16;
          hh[6] = ah6 = c2 & 65535 | d2 << 16;
          hl[6] = al6 = a & 65535 | b << 16;
          h = ah7;
          l2 = al7;
          a = l2 & 65535;
          b = l2 >>> 16;
          c2 = h & 65535;
          d2 = h >>> 16;
          h = hh[7];
          l2 = hl[7];
          a += l2 & 65535;
          b += l2 >>> 16;
          c2 += h & 65535;
          d2 += h >>> 16;
          b += a >>> 16;
          c2 += b >>> 16;
          d2 += c2 >>> 16;
          hh[7] = ah7 = c2 & 65535 | d2 << 16;
          hl[7] = al7 = a & 65535 | b << 16;
          pos += 128;
          n -= 128;
        }
        return n;
      }
      function crypto_hash(out, m2, n) {
        var hh = new Int32Array(8), hl = new Int32Array(8), x2 = new Uint8Array(256), i, b = n;
        hh[0] = 1779033703;
        hh[1] = 3144134277;
        hh[2] = 1013904242;
        hh[3] = 2773480762;
        hh[4] = 1359893119;
        hh[5] = 2600822924;
        hh[6] = 528734635;
        hh[7] = 1541459225;
        hl[0] = 4089235720;
        hl[1] = 2227873595;
        hl[2] = 4271175723;
        hl[3] = 1595750129;
        hl[4] = 2917565137;
        hl[5] = 725511199;
        hl[6] = 4215389547;
        hl[7] = 327033209;
        crypto_hashblocks_hl(hh, hl, m2, n);
        n %= 128;
        for (i = 0; i < n; i++)
          x2[i] = m2[b - n + i];
        x2[n] = 128;
        n = 256 - 128 * (n < 112 ? 1 : 0);
        x2[n - 9] = 0;
        ts64(x2, n - 8, b / 536870912 | 0, b << 3);
        crypto_hashblocks_hl(hh, hl, x2, n);
        for (i = 0; i < 8; i++)
          ts64(out, 8 * i, hh[i], hl[i]);
        return 0;
      }
      function add(p3, q2) {
        var a = gf(), b = gf(), c2 = gf(), d2 = gf(), e = gf(), f2 = gf(), g2 = gf(), h = gf(), t = gf();
        Z(a, p3[1], p3[0]);
        Z(t, q2[1], q2[0]);
        M(a, a, t);
        A(b, p3[0], p3[1]);
        A(t, q2[0], q2[1]);
        M(b, b, t);
        M(c2, p3[3], q2[3]);
        M(c2, c2, D2);
        M(d2, p3[2], q2[2]);
        A(d2, d2, d2);
        Z(e, b, a);
        Z(f2, d2, c2);
        A(g2, d2, c2);
        A(h, b, a);
        M(p3[0], e, f2);
        M(p3[1], h, g2);
        M(p3[2], g2, f2);
        M(p3[3], e, h);
      }
      function cswap(p3, q2, b) {
        var i;
        for (i = 0; i < 4; i++) {
          sel25519(p3[i], q2[i], b);
        }
      }
      function pack(r, p3) {
        var tx = gf(), ty = gf(), zi = gf();
        inv25519(zi, p3[2]);
        M(tx, p3[0], zi);
        M(ty, p3[1], zi);
        pack25519(r, ty);
        r[31] ^= par25519(tx) << 7;
      }
      function scalarmult(p3, q2, s) {
        var b, i;
        set25519(p3[0], gf0);
        set25519(p3[1], gf1);
        set25519(p3[2], gf1);
        set25519(p3[3], gf0);
        for (i = 255; i >= 0; --i) {
          b = s[i / 8 | 0] >> (i & 7) & 1;
          cswap(p3, q2, b);
          add(q2, p3);
          add(p3, p3);
          cswap(p3, q2, b);
        }
      }
      function scalarbase(p3, s) {
        var q2 = [gf(), gf(), gf(), gf()];
        set25519(q2[0], X);
        set25519(q2[1], Y);
        set25519(q2[2], gf1);
        M(q2[3], X, Y);
        scalarmult(p3, q2, s);
      }
      function crypto_sign_keypair(pk, sk, seeded) {
        var d2 = new Uint8Array(64);
        var p3 = [gf(), gf(), gf(), gf()];
        var i;
        if (!seeded)
          randombytes(sk, 32);
        crypto_hash(d2, sk, 32);
        d2[0] &= 248;
        d2[31] &= 127;
        d2[31] |= 64;
        scalarbase(p3, d2);
        pack(pk, p3);
        for (i = 0; i < 32; i++)
          sk[i + 32] = pk[i];
        return 0;
      }
      var L = new Float64Array([237, 211, 245, 92, 26, 99, 18, 88, 214, 156, 247, 162, 222, 249, 222, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16]);
      function modL(r, x2) {
        var carry, i, j, k;
        for (i = 63; i >= 32; --i) {
          carry = 0;
          for (j = i - 32, k = i - 12; j < k; ++j) {
            x2[j] += carry - 16 * x2[i] * L[j - (i - 32)];
            carry = x2[j] + 128 >> 8;
            x2[j] -= carry * 256;
          }
          x2[j] += carry;
          x2[i] = 0;
        }
        carry = 0;
        for (j = 0; j < 32; j++) {
          x2[j] += carry - (x2[31] >> 4) * L[j];
          carry = x2[j] >> 8;
          x2[j] &= 255;
        }
        for (j = 0; j < 32; j++)
          x2[j] -= carry * L[j];
        for (i = 0; i < 32; i++) {
          x2[i + 1] += x2[i] >> 8;
          r[i] = x2[i] & 255;
        }
      }
      function reduce(r) {
        var x2 = new Float64Array(64), i;
        for (i = 0; i < 64; i++)
          x2[i] = r[i];
        for (i = 0; i < 64; i++)
          r[i] = 0;
        modL(r, x2);
      }
      function crypto_sign(sm, m2, n, sk) {
        var d2 = new Uint8Array(64), h = new Uint8Array(64), r = new Uint8Array(64);
        var i, j, x2 = new Float64Array(64);
        var p3 = [gf(), gf(), gf(), gf()];
        crypto_hash(d2, sk, 32);
        d2[0] &= 248;
        d2[31] &= 127;
        d2[31] |= 64;
        var smlen = n + 64;
        for (i = 0; i < n; i++)
          sm[64 + i] = m2[i];
        for (i = 0; i < 32; i++)
          sm[32 + i] = d2[32 + i];
        crypto_hash(r, sm.subarray(32), n + 32);
        reduce(r);
        scalarbase(p3, r);
        pack(sm, p3);
        for (i = 32; i < 64; i++)
          sm[i] = sk[i];
        crypto_hash(h, sm, n + 64);
        reduce(h);
        for (i = 0; i < 64; i++)
          x2[i] = 0;
        for (i = 0; i < 32; i++)
          x2[i] = r[i];
        for (i = 0; i < 32; i++) {
          for (j = 0; j < 32; j++) {
            x2[i + j] += h[i] * d2[j];
          }
        }
        modL(sm.subarray(32), x2);
        return smlen;
      }
      function unpackneg(r, p3) {
        var t = gf(), chk = gf(), num = gf(), den = gf(), den2 = gf(), den4 = gf(), den6 = gf();
        set25519(r[2], gf1);
        unpack25519(r[1], p3);
        S(num, r[1]);
        M(den, num, D);
        Z(num, num, r[2]);
        A(den, r[2], den);
        S(den2, den);
        S(den4, den2);
        M(den6, den4, den2);
        M(t, den6, num);
        M(t, t, den);
        pow2523(t, t);
        M(t, t, num);
        M(t, t, den);
        M(t, t, den);
        M(r[0], t, den);
        S(chk, r[0]);
        M(chk, chk, den);
        if (neq25519(chk, num))
          M(r[0], r[0], I);
        S(chk, r[0]);
        M(chk, chk, den);
        if (neq25519(chk, num))
          return -1;
        if (par25519(r[0]) === p3[31] >> 7)
          Z(r[0], gf0, r[0]);
        M(r[3], r[0], r[1]);
        return 0;
      }
      function crypto_sign_open(m2, sm, n, pk) {
        var i, mlen;
        var t = new Uint8Array(32), h = new Uint8Array(64);
        var p3 = [gf(), gf(), gf(), gf()], q2 = [gf(), gf(), gf(), gf()];
        mlen = -1;
        if (n < 64)
          return -1;
        if (unpackneg(q2, pk))
          return -1;
        for (i = 0; i < n; i++)
          m2[i] = sm[i];
        for (i = 0; i < 32; i++)
          m2[i + 32] = pk[i];
        crypto_hash(h, m2, n);
        reduce(h);
        scalarmult(p3, q2, h);
        scalarbase(q2, sm.subarray(32));
        add(p3, q2);
        pack(t, p3);
        n -= 64;
        if (crypto_verify_32(sm, 0, t, 0)) {
          for (i = 0; i < n; i++)
            m2[i] = 0;
          return -1;
        }
        for (i = 0; i < n; i++)
          m2[i] = sm[i + 64];
        mlen = n;
        return mlen;
      }
      var crypto_secretbox_KEYBYTES = 32, crypto_secretbox_NONCEBYTES = 24, crypto_secretbox_ZEROBYTES = 32, crypto_secretbox_BOXZEROBYTES = 16, crypto_scalarmult_BYTES = 32, crypto_scalarmult_SCALARBYTES = 32, crypto_box_PUBLICKEYBYTES = 32, crypto_box_SECRETKEYBYTES = 32, crypto_box_BEFORENMBYTES = 32, crypto_box_NONCEBYTES = crypto_secretbox_NONCEBYTES, crypto_box_ZEROBYTES = crypto_secretbox_ZEROBYTES, crypto_box_BOXZEROBYTES = crypto_secretbox_BOXZEROBYTES, crypto_sign_BYTES = 64, crypto_sign_PUBLICKEYBYTES = 32, crypto_sign_SECRETKEYBYTES = 64, crypto_sign_SEEDBYTES = 32, crypto_hash_BYTES = 64;
      nacl.lowlevel = {
        crypto_core_hsalsa20,
        crypto_stream_xor,
        crypto_stream,
        crypto_stream_salsa20_xor,
        crypto_stream_salsa20,
        crypto_onetimeauth,
        crypto_onetimeauth_verify,
        crypto_verify_16,
        crypto_verify_32,
        crypto_secretbox,
        crypto_secretbox_open,
        crypto_scalarmult,
        crypto_scalarmult_base,
        crypto_box_beforenm,
        crypto_box_afternm,
        crypto_box,
        crypto_box_open,
        crypto_box_keypair,
        crypto_hash,
        crypto_sign,
        crypto_sign_keypair,
        crypto_sign_open,
        crypto_secretbox_KEYBYTES,
        crypto_secretbox_NONCEBYTES,
        crypto_secretbox_ZEROBYTES,
        crypto_secretbox_BOXZEROBYTES,
        crypto_scalarmult_BYTES,
        crypto_scalarmult_SCALARBYTES,
        crypto_box_PUBLICKEYBYTES,
        crypto_box_SECRETKEYBYTES,
        crypto_box_BEFORENMBYTES,
        crypto_box_NONCEBYTES,
        crypto_box_ZEROBYTES,
        crypto_box_BOXZEROBYTES,
        crypto_sign_BYTES,
        crypto_sign_PUBLICKEYBYTES,
        crypto_sign_SECRETKEYBYTES,
        crypto_sign_SEEDBYTES,
        crypto_hash_BYTES
      };
      function checkLengths(k, n) {
        if (k.length !== crypto_secretbox_KEYBYTES)
          throw new Error("bad key size");
        if (n.length !== crypto_secretbox_NONCEBYTES)
          throw new Error("bad nonce size");
      }
      function checkBoxLengths(pk, sk) {
        if (pk.length !== crypto_box_PUBLICKEYBYTES)
          throw new Error("bad public key size");
        if (sk.length !== crypto_box_SECRETKEYBYTES)
          throw new Error("bad secret key size");
      }
      function checkArrayTypes() {
        var t, i;
        for (i = 0; i < arguments.length; i++) {
          if ((t = Object.prototype.toString.call(arguments[i])) !== "[object Uint8Array]")
            throw new TypeError("unexpected type " + t + ", use Uint8Array");
        }
      }
      function cleanup(arr) {
        for (var i = 0; i < arr.length; i++)
          arr[i] = 0;
      }
      if (!nacl.util) {
        nacl.util = {};
        nacl.util.decodeUTF8 = nacl.util.encodeUTF8 = nacl.util.encodeBase64 = nacl.util.decodeBase64 = function() {
          throw new Error("nacl.util moved into separate package: https://github.com/dchest/tweetnacl-util-js");
        };
      }
      nacl.randomBytes = function(n) {
        var b = new Uint8Array(n);
        randombytes(b, n);
        return b;
      };
      nacl.secretbox = function(msg, nonce, key) {
        checkArrayTypes(msg, nonce, key);
        checkLengths(key, nonce);
        var m2 = new Uint8Array(crypto_secretbox_ZEROBYTES + msg.length);
        var c2 = new Uint8Array(m2.length);
        for (var i = 0; i < msg.length; i++)
          m2[i + crypto_secretbox_ZEROBYTES] = msg[i];
        crypto_secretbox(c2, m2, m2.length, nonce, key);
        return c2.subarray(crypto_secretbox_BOXZEROBYTES);
      };
      nacl.secretbox.open = function(box, nonce, key) {
        checkArrayTypes(box, nonce, key);
        checkLengths(key, nonce);
        var c2 = new Uint8Array(crypto_secretbox_BOXZEROBYTES + box.length);
        var m2 = new Uint8Array(c2.length);
        for (var i = 0; i < box.length; i++)
          c2[i + crypto_secretbox_BOXZEROBYTES] = box[i];
        if (c2.length < 32)
          return false;
        if (crypto_secretbox_open(m2, c2, c2.length, nonce, key) !== 0)
          return false;
        return m2.subarray(crypto_secretbox_ZEROBYTES);
      };
      nacl.secretbox.keyLength = crypto_secretbox_KEYBYTES;
      nacl.secretbox.nonceLength = crypto_secretbox_NONCEBYTES;
      nacl.secretbox.overheadLength = crypto_secretbox_BOXZEROBYTES;
      nacl.scalarMult = function(n, p3) {
        checkArrayTypes(n, p3);
        if (n.length !== crypto_scalarmult_SCALARBYTES)
          throw new Error("bad n size");
        if (p3.length !== crypto_scalarmult_BYTES)
          throw new Error("bad p size");
        var q2 = new Uint8Array(crypto_scalarmult_BYTES);
        crypto_scalarmult(q2, n, p3);
        return q2;
      };
      nacl.scalarMult.base = function(n) {
        checkArrayTypes(n);
        if (n.length !== crypto_scalarmult_SCALARBYTES)
          throw new Error("bad n size");
        var q2 = new Uint8Array(crypto_scalarmult_BYTES);
        crypto_scalarmult_base(q2, n);
        return q2;
      };
      nacl.scalarMult.scalarLength = crypto_scalarmult_SCALARBYTES;
      nacl.scalarMult.groupElementLength = crypto_scalarmult_BYTES;
      nacl.box = function(msg, nonce, publicKey, secretKey) {
        var k = nacl.box.before(publicKey, secretKey);
        return nacl.secretbox(msg, nonce, k);
      };
      nacl.box.before = function(publicKey, secretKey) {
        checkArrayTypes(publicKey, secretKey);
        checkBoxLengths(publicKey, secretKey);
        var k = new Uint8Array(crypto_box_BEFORENMBYTES);
        crypto_box_beforenm(k, publicKey, secretKey);
        return k;
      };
      nacl.box.after = nacl.secretbox;
      nacl.box.open = function(msg, nonce, publicKey, secretKey) {
        var k = nacl.box.before(publicKey, secretKey);
        return nacl.secretbox.open(msg, nonce, k);
      };
      nacl.box.open.after = nacl.secretbox.open;
      nacl.box.keyPair = function() {
        var pk = new Uint8Array(crypto_box_PUBLICKEYBYTES);
        var sk = new Uint8Array(crypto_box_SECRETKEYBYTES);
        crypto_box_keypair(pk, sk);
        return { publicKey: pk, secretKey: sk };
      };
      nacl.box.keyPair.fromSecretKey = function(secretKey) {
        checkArrayTypes(secretKey);
        if (secretKey.length !== crypto_box_SECRETKEYBYTES)
          throw new Error("bad secret key size");
        var pk = new Uint8Array(crypto_box_PUBLICKEYBYTES);
        crypto_scalarmult_base(pk, secretKey);
        return { publicKey: pk, secretKey: new Uint8Array(secretKey) };
      };
      nacl.box.publicKeyLength = crypto_box_PUBLICKEYBYTES;
      nacl.box.secretKeyLength = crypto_box_SECRETKEYBYTES;
      nacl.box.sharedKeyLength = crypto_box_BEFORENMBYTES;
      nacl.box.nonceLength = crypto_box_NONCEBYTES;
      nacl.box.overheadLength = nacl.secretbox.overheadLength;
      nacl.sign = function(msg, secretKey) {
        checkArrayTypes(msg, secretKey);
        if (secretKey.length !== crypto_sign_SECRETKEYBYTES)
          throw new Error("bad secret key size");
        var signedMsg = new Uint8Array(crypto_sign_BYTES + msg.length);
        crypto_sign(signedMsg, msg, msg.length, secretKey);
        return signedMsg;
      };
      nacl.sign.open = function(signedMsg, publicKey) {
        if (arguments.length !== 2)
          throw new Error("nacl.sign.open accepts 2 arguments; did you mean to use nacl.sign.detached.verify?");
        checkArrayTypes(signedMsg, publicKey);
        if (publicKey.length !== crypto_sign_PUBLICKEYBYTES)
          throw new Error("bad public key size");
        var tmp = new Uint8Array(signedMsg.length);
        var mlen = crypto_sign_open(tmp, signedMsg, signedMsg.length, publicKey);
        if (mlen < 0)
          return null;
        var m2 = new Uint8Array(mlen);
        for (var i = 0; i < m2.length; i++)
          m2[i] = tmp[i];
        return m2;
      };
      nacl.sign.detached = function(msg, secretKey) {
        var signedMsg = nacl.sign(msg, secretKey);
        var sig = new Uint8Array(crypto_sign_BYTES);
        for (var i = 0; i < sig.length; i++)
          sig[i] = signedMsg[i];
        return sig;
      };
      nacl.sign.detached.verify = function(msg, sig, publicKey) {
        checkArrayTypes(msg, sig, publicKey);
        if (sig.length !== crypto_sign_BYTES)
          throw new Error("bad signature size");
        if (publicKey.length !== crypto_sign_PUBLICKEYBYTES)
          throw new Error("bad public key size");
        var sm = new Uint8Array(crypto_sign_BYTES + msg.length);
        var m2 = new Uint8Array(crypto_sign_BYTES + msg.length);
        var i;
        for (i = 0; i < crypto_sign_BYTES; i++)
          sm[i] = sig[i];
        for (i = 0; i < msg.length; i++)
          sm[i + crypto_sign_BYTES] = msg[i];
        return crypto_sign_open(m2, sm, sm.length, publicKey) >= 0;
      };
      nacl.sign.keyPair = function() {
        var pk = new Uint8Array(crypto_sign_PUBLICKEYBYTES);
        var sk = new Uint8Array(crypto_sign_SECRETKEYBYTES);
        crypto_sign_keypair(pk, sk);
        return { publicKey: pk, secretKey: sk };
      };
      nacl.sign.keyPair.fromSecretKey = function(secretKey) {
        checkArrayTypes(secretKey);
        if (secretKey.length !== crypto_sign_SECRETKEYBYTES)
          throw new Error("bad secret key size");
        var pk = new Uint8Array(crypto_sign_PUBLICKEYBYTES);
        for (var i = 0; i < pk.length; i++)
          pk[i] = secretKey[32 + i];
        return { publicKey: pk, secretKey: new Uint8Array(secretKey) };
      };
      nacl.sign.keyPair.fromSeed = function(seed) {
        checkArrayTypes(seed);
        if (seed.length !== crypto_sign_SEEDBYTES)
          throw new Error("bad seed size");
        var pk = new Uint8Array(crypto_sign_PUBLICKEYBYTES);
        var sk = new Uint8Array(crypto_sign_SECRETKEYBYTES);
        for (var i = 0; i < 32; i++)
          sk[i] = seed[i];
        crypto_sign_keypair(pk, sk, true);
        return { publicKey: pk, secretKey: sk };
      };
      nacl.sign.publicKeyLength = crypto_sign_PUBLICKEYBYTES;
      nacl.sign.secretKeyLength = crypto_sign_SECRETKEYBYTES;
      nacl.sign.seedLength = crypto_sign_SEEDBYTES;
      nacl.sign.signatureLength = crypto_sign_BYTES;
      nacl.hash = function(msg) {
        checkArrayTypes(msg);
        var h = new Uint8Array(crypto_hash_BYTES);
        crypto_hash(h, msg, msg.length);
        return h;
      };
      nacl.hash.hashLength = crypto_hash_BYTES;
      nacl.verify = function(x2, y) {
        checkArrayTypes(x2, y);
        if (x2.length === 0 || y.length === 0)
          return false;
        if (x2.length !== y.length)
          return false;
        return vn(x2, 0, y, 0, x2.length) === 0 ? true : false;
      };
      nacl.setPRNG = function(fn) {
        randombytes = fn;
      };
      (function() {
        var crypto2 = typeof self !== "undefined" ? self.crypto || self.msCrypto : null;
        if (crypto2 && crypto2.getRandomValues) {
          var QUOTA = 65536;
          nacl.setPRNG(function(x2, n) {
            var i, v = new Uint8Array(n);
            for (i = 0; i < n; i += QUOTA) {
              crypto2.getRandomValues(v.subarray(i, i + Math.min(n - i, QUOTA)));
            }
            for (i = 0; i < n; i++)
              x2[i] = v[i];
            cleanup(v);
          });
        } else if (typeof require !== "undefined") {
          crypto2 = require("crypto");
          if (crypto2 && crypto2.randomBytes) {
            nacl.setPRNG(function(x2, n) {
              var i, v = crypto2.randomBytes(n);
              for (i = 0; i < n; i++)
                x2[i] = v[i];
              cleanup(v);
            });
          }
        }
      })();
    })(typeof module2 !== "undefined" && module2.exports ? module2.exports : self.nacl = self.nacl || {});
  }
});

// node_modules/sshpk/lib/utils.js
var require_utils5 = __commonJS({
  "node_modules/sshpk/lib/utils.js"(exports2, module2) {
    module2.exports = {
      bufferSplit,
      addRSAMissing,
      calculateDSAPublic,
      calculateED25519Public,
      calculateX25519Public,
      mpNormalize,
      mpDenormalize,
      ecNormalize,
      countZeros,
      assertCompatible,
      isCompatible,
      opensslKeyDeriv,
      opensshCipherInfo,
      publicFromPrivateECDSA,
      zeroPadToLength,
      writeBitString,
      readBitString,
      pbkdf2
    };
    var assert = require_assert();
    var Buffer2 = require_safer().Buffer;
    var PrivateKey = require_private_key();
    var Key = require_key();
    var crypto2 = require("crypto");
    var algs = require_algs();
    var asn1 = require_lib14();
    var ec = require_ec();
    var jsbn = require_jsbn2().BigInteger;
    var nacl = require_nacl_fast();
    var MAX_CLASS_DEPTH = 3;
    function isCompatible(obj, klass, needVer) {
      if (obj === null || typeof obj !== "object")
        return false;
      if (needVer === void 0)
        needVer = klass.prototype._sshpkApiVersion;
      if (obj instanceof klass && klass.prototype._sshpkApiVersion[0] == needVer[0])
        return true;
      var proto = Object.getPrototypeOf(obj);
      var depth = 0;
      while (proto.constructor.name !== klass.name) {
        proto = Object.getPrototypeOf(proto);
        if (!proto || ++depth > MAX_CLASS_DEPTH)
          return false;
      }
      if (proto.constructor.name !== klass.name)
        return false;
      var ver = proto._sshpkApiVersion;
      if (ver === void 0)
        ver = klass._oldVersionDetect(obj);
      if (ver[0] != needVer[0] || ver[1] < needVer[1])
        return false;
      return true;
    }
    function assertCompatible(obj, klass, needVer, name) {
      if (name === void 0)
        name = "object";
      assert.ok(obj, name + " must not be null");
      assert.object(obj, name + " must be an object");
      if (needVer === void 0)
        needVer = klass.prototype._sshpkApiVersion;
      if (obj instanceof klass && klass.prototype._sshpkApiVersion[0] == needVer[0])
        return;
      var proto = Object.getPrototypeOf(obj);
      var depth = 0;
      while (proto.constructor.name !== klass.name) {
        proto = Object.getPrototypeOf(proto);
        assert.ok(
          proto && ++depth <= MAX_CLASS_DEPTH,
          name + " must be a " + klass.name + " instance"
        );
      }
      assert.strictEqual(
        proto.constructor.name,
        klass.name,
        name + " must be a " + klass.name + " instance"
      );
      var ver = proto._sshpkApiVersion;
      if (ver === void 0)
        ver = klass._oldVersionDetect(obj);
      assert.ok(
        ver[0] == needVer[0] && ver[1] >= needVer[1],
        name + " must be compatible with " + klass.name + " klass version " + needVer[0] + "." + needVer[1]
      );
    }
    var CIPHER_LEN = {
      "des-ede3-cbc": { key: 24, iv: 8 },
      "aes-128-cbc": { key: 16, iv: 16 },
      "aes-256-cbc": { key: 32, iv: 16 }
    };
    var PKCS5_SALT_LEN = 8;
    function opensslKeyDeriv(cipher, salt, passphrase, count) {
      assert.buffer(salt, "salt");
      assert.buffer(passphrase, "passphrase");
      assert.number(count, "iteration count");
      var clen = CIPHER_LEN[cipher];
      assert.object(clen, "supported cipher");
      salt = salt.slice(0, PKCS5_SALT_LEN);
      var D, D_prev, bufs;
      var material = Buffer2.alloc(0);
      while (material.length < clen.key + clen.iv) {
        bufs = [];
        if (D_prev)
          bufs.push(D_prev);
        bufs.push(passphrase);
        bufs.push(salt);
        D = Buffer2.concat(bufs);
        for (var j = 0; j < count; ++j)
          D = crypto2.createHash("md5").update(D).digest();
        material = Buffer2.concat([material, D]);
        D_prev = D;
      }
      return {
        key: material.slice(0, clen.key),
        iv: material.slice(clen.key, clen.key + clen.iv)
      };
    }
    function pbkdf2(hashAlg, salt, iterations, size, passphrase) {
      var hkey = Buffer2.alloc(salt.length + 4);
      salt.copy(hkey);
      var gen = 0, ts = [];
      var i = 1;
      while (gen < size) {
        var t = T(i++);
        gen += t.length;
        ts.push(t);
      }
      return Buffer2.concat(ts).slice(0, size);
      function T(I) {
        hkey.writeUInt32BE(I, hkey.length - 4);
        var hmac = crypto2.createHmac(hashAlg, passphrase);
        hmac.update(hkey);
        var Ti = hmac.digest();
        var Uc = Ti;
        var c2 = 1;
        while (c2++ < iterations) {
          hmac = crypto2.createHmac(hashAlg, passphrase);
          hmac.update(Uc);
          Uc = hmac.digest();
          for (var x2 = 0; x2 < Ti.length; ++x2)
            Ti[x2] ^= Uc[x2];
        }
        return Ti;
      }
    }
    function countZeros(buf) {
      var o2 = 0, obit = 8;
      while (o2 < buf.length) {
        var mask = 1 << obit;
        if ((buf[o2] & mask) === mask)
          break;
        obit--;
        if (obit < 0) {
          o2++;
          obit = 8;
        }
      }
      return o2 * 8 + (8 - obit) - 1;
    }
    function bufferSplit(buf, chr) {
      assert.buffer(buf);
      assert.string(chr);
      var parts = [];
      var lastPart = 0;
      var matches = 0;
      for (var i = 0; i < buf.length; ++i) {
        if (buf[i] === chr.charCodeAt(matches))
          ++matches;
        else if (buf[i] === chr.charCodeAt(0))
          matches = 1;
        else
          matches = 0;
        if (matches >= chr.length) {
          var newPart = i + 1;
          parts.push(buf.slice(lastPart, newPart - matches));
          lastPart = newPart;
          matches = 0;
        }
      }
      if (lastPart <= buf.length)
        parts.push(buf.slice(lastPart, buf.length));
      return parts;
    }
    function ecNormalize(buf, addZero) {
      assert.buffer(buf);
      if (buf[0] === 0 && buf[1] === 4) {
        if (addZero)
          return buf;
        return buf.slice(1);
      } else if (buf[0] === 4) {
        if (!addZero)
          return buf;
      } else {
        while (buf[0] === 0)
          buf = buf.slice(1);
        if (buf[0] === 2 || buf[0] === 3)
          throw new Error("Compressed elliptic curve points are not supported");
        if (buf[0] !== 4)
          throw new Error("Not a valid elliptic curve point");
        if (!addZero)
          return buf;
      }
      var b = Buffer2.alloc(buf.length + 1);
      b[0] = 0;
      buf.copy(b, 1);
      return b;
    }
    function readBitString(der, tag) {
      if (tag === void 0)
        tag = asn1.Ber.BitString;
      var buf = der.readString(tag, true);
      assert.strictEqual(buf[0], 0, "bit strings with unused bits are not supported (0x" + buf[0].toString(16) + ")");
      return buf.slice(1);
    }
    function writeBitString(der, buf, tag) {
      if (tag === void 0)
        tag = asn1.Ber.BitString;
      var b = Buffer2.alloc(buf.length + 1);
      b[0] = 0;
      buf.copy(b, 1);
      der.writeBuffer(b, tag);
    }
    function mpNormalize(buf) {
      assert.buffer(buf);
      while (buf.length > 1 && buf[0] === 0 && (buf[1] & 128) === 0)
        buf = buf.slice(1);
      if ((buf[0] & 128) === 128) {
        var b = Buffer2.alloc(buf.length + 1);
        b[0] = 0;
        buf.copy(b, 1);
        buf = b;
      }
      return buf;
    }
    function mpDenormalize(buf) {
      assert.buffer(buf);
      while (buf.length > 1 && buf[0] === 0)
        buf = buf.slice(1);
      return buf;
    }
    function zeroPadToLength(buf, len) {
      assert.buffer(buf);
      assert.number(len);
      while (buf.length > len) {
        assert.equal(buf[0], 0);
        buf = buf.slice(1);
      }
      while (buf.length < len) {
        var b = Buffer2.alloc(buf.length + 1);
        b[0] = 0;
        buf.copy(b, 1);
        buf = b;
      }
      return buf;
    }
    function bigintToMpBuf(bigint) {
      var buf = Buffer2.from(bigint.toByteArray());
      buf = mpNormalize(buf);
      return buf;
    }
    function calculateDSAPublic(g2, p3, x2) {
      assert.buffer(g2);
      assert.buffer(p3);
      assert.buffer(x2);
      g2 = new jsbn(g2);
      p3 = new jsbn(p3);
      x2 = new jsbn(x2);
      var y = g2.modPow(x2, p3);
      var ybuf = bigintToMpBuf(y);
      return ybuf;
    }
    function calculateED25519Public(k) {
      assert.buffer(k);
      var kp = nacl.sign.keyPair.fromSeed(new Uint8Array(k));
      return Buffer2.from(kp.publicKey);
    }
    function calculateX25519Public(k) {
      assert.buffer(k);
      var kp = nacl.box.keyPair.fromSeed(new Uint8Array(k));
      return Buffer2.from(kp.publicKey);
    }
    function addRSAMissing(key) {
      assert.object(key);
      assertCompatible(key, PrivateKey, [1, 1]);
      var d2 = new jsbn(key.part.d.data);
      var buf;
      if (!key.part.dmodp) {
        var p3 = new jsbn(key.part.p.data);
        var dmodp = d2.mod(p3.subtract(1));
        buf = bigintToMpBuf(dmodp);
        key.part.dmodp = { name: "dmodp", data: buf };
        key.parts.push(key.part.dmodp);
      }
      if (!key.part.dmodq) {
        var q2 = new jsbn(key.part.q.data);
        var dmodq = d2.mod(q2.subtract(1));
        buf = bigintToMpBuf(dmodq);
        key.part.dmodq = { name: "dmodq", data: buf };
        key.parts.push(key.part.dmodq);
      }
    }
    function publicFromPrivateECDSA(curveName, priv) {
      assert.string(curveName, "curveName");
      assert.buffer(priv);
      var params = algs.curves[curveName];
      var p3 = new jsbn(params.p);
      var a = new jsbn(params.a);
      var b = new jsbn(params.b);
      var curve = new ec.ECCurveFp(p3, a, b);
      var G = curve.decodePointHex(params.G.toString("hex"));
      var d2 = new jsbn(mpNormalize(priv));
      var pub = G.multiply(d2);
      pub = Buffer2.from(curve.encodePointHex(pub), "hex");
      var parts = [];
      parts.push({ name: "curve", data: Buffer2.from(curveName) });
      parts.push({ name: "Q", data: pub });
      var key = new Key({ type: "ecdsa", curve, parts });
      return key;
    }
    function opensshCipherInfo(cipher) {
      var inf = {};
      switch (cipher) {
        case "3des-cbc":
          inf.keySize = 24;
          inf.blockSize = 8;
          inf.opensslName = "des-ede3-cbc";
          break;
        case "blowfish-cbc":
          inf.keySize = 16;
          inf.blockSize = 8;
          inf.opensslName = "bf-cbc";
          break;
        case "aes128-cbc":
        case "aes128-ctr":
        case "aes128-gcm@openssh.com":
          inf.keySize = 16;
          inf.blockSize = 16;
          inf.opensslName = "aes-128-" + cipher.slice(7, 10);
          break;
        case "aes192-cbc":
        case "aes192-ctr":
        case "aes192-gcm@openssh.com":
          inf.keySize = 24;
          inf.blockSize = 16;
          inf.opensslName = "aes-192-" + cipher.slice(7, 10);
          break;
        case "aes256-cbc":
        case "aes256-ctr":
        case "aes256-gcm@openssh.com":
          inf.keySize = 32;
          inf.blockSize = 16;
          inf.opensslName = "aes-256-" + cipher.slice(7, 10);
          break;
        default:
          throw new Error(
            'Unsupported openssl cipher "' + cipher + '"'
          );
      }
      return inf;
    }
  }
});

// node_modules/sshpk/lib/ssh-buffer.js
var require_ssh_buffer = __commonJS({
  "node_modules/sshpk/lib/ssh-buffer.js"(exports2, module2) {
    module2.exports = SSHBuffer;
    var assert = require_assert();
    var Buffer2 = require_safer().Buffer;
    function SSHBuffer(opts) {
      assert.object(opts, "options");
      if (opts.buffer !== void 0)
        assert.buffer(opts.buffer, "options.buffer");
      this._size = opts.buffer ? opts.buffer.length : 1024;
      this._buffer = opts.buffer || Buffer2.alloc(this._size);
      this._offset = 0;
    }
    SSHBuffer.prototype.toBuffer = function() {
      return this._buffer.slice(0, this._offset);
    };
    SSHBuffer.prototype.atEnd = function() {
      return this._offset >= this._buffer.length;
    };
    SSHBuffer.prototype.remainder = function() {
      return this._buffer.slice(this._offset);
    };
    SSHBuffer.prototype.skip = function(n) {
      this._offset += n;
    };
    SSHBuffer.prototype.expand = function() {
      this._size *= 2;
      var buf = Buffer2.alloc(this._size);
      this._buffer.copy(buf, 0);
      this._buffer = buf;
    };
    SSHBuffer.prototype.readPart = function() {
      return { data: this.readBuffer() };
    };
    SSHBuffer.prototype.readBuffer = function() {
      var len = this._buffer.readUInt32BE(this._offset);
      this._offset += 4;
      assert.ok(
        this._offset + len <= this._buffer.length,
        "length out of bounds at +0x" + this._offset.toString(16) + " (data truncated?)"
      );
      var buf = this._buffer.slice(this._offset, this._offset + len);
      this._offset += len;
      return buf;
    };
    SSHBuffer.prototype.readString = function() {
      return this.readBuffer().toString();
    };
    SSHBuffer.prototype.readCString = function() {
      var offset = this._offset;
      while (offset < this._buffer.length && this._buffer[offset] !== 0)
        offset++;
      assert.ok(offset < this._buffer.length, "c string does not terminate");
      var str = this._buffer.slice(this._offset, offset).toString();
      this._offset = offset + 1;
      return str;
    };
    SSHBuffer.prototype.readInt = function() {
      var v = this._buffer.readUInt32BE(this._offset);
      this._offset += 4;
      return v;
    };
    SSHBuffer.prototype.readInt64 = function() {
      assert.ok(
        this._offset + 8 < this._buffer.length,
        "buffer not long enough to read Int64"
      );
      var v = this._buffer.slice(this._offset, this._offset + 8);
      this._offset += 8;
      return v;
    };
    SSHBuffer.prototype.readChar = function() {
      var v = this._buffer[this._offset++];
      return v;
    };
    SSHBuffer.prototype.writeBuffer = function(buf) {
      while (this._offset + 4 + buf.length > this._size)
        this.expand();
      this._buffer.writeUInt32BE(buf.length, this._offset);
      this._offset += 4;
      buf.copy(this._buffer, this._offset);
      this._offset += buf.length;
    };
    SSHBuffer.prototype.writeString = function(str) {
      this.writeBuffer(Buffer2.from(str, "utf8"));
    };
    SSHBuffer.prototype.writeCString = function(str) {
      while (this._offset + 1 + str.length > this._size)
        this.expand();
      this._buffer.write(str, this._offset);
      this._offset += str.length;
      this._buffer[this._offset++] = 0;
    };
    SSHBuffer.prototype.writeInt = function(v) {
      while (this._offset + 4 > this._size)
        this.expand();
      this._buffer.writeUInt32BE(v, this._offset);
      this._offset += 4;
    };
    SSHBuffer.prototype.writeInt64 = function(v) {
      assert.buffer(v, "value");
      if (v.length > 8) {
        var lead2 = v.slice(0, v.length - 8);
        for (var i = 0; i < lead2.length; ++i) {
          assert.strictEqual(
            lead2[i],
            0,
            "must fit in 64 bits of precision"
          );
        }
        v = v.slice(v.length - 8, v.length);
      }
      while (this._offset + 8 > this._size)
        this.expand();
      v.copy(this._buffer, this._offset);
      this._offset += 8;
    };
    SSHBuffer.prototype.writeChar = function(v) {
      while (this._offset + 1 > this._size)
        this.expand();
      this._buffer[this._offset++] = v;
    };
    SSHBuffer.prototype.writePart = function(p3) {
      this.writeBuffer(p3.data);
    };
    SSHBuffer.prototype.write = function(buf) {
      while (this._offset + buf.length > this._size)
        this.expand();
      buf.copy(this._buffer, this._offset);
      this._offset += buf.length;
    };
  }
});

// node_modules/sshpk/lib/signature.js
var require_signature = __commonJS({
  "node_modules/sshpk/lib/signature.js"(exports2, module2) {
    module2.exports = Signature;
    var assert = require_assert();
    var Buffer2 = require_safer().Buffer;
    var algs = require_algs();
    var crypto2 = require("crypto");
    var errs = require_errors3();
    var utils = require_utils5();
    var asn1 = require_lib14();
    var SSHBuffer = require_ssh_buffer();
    var InvalidAlgorithmError = errs.InvalidAlgorithmError;
    var SignatureParseError = errs.SignatureParseError;
    function Signature(opts) {
      assert.object(opts, "options");
      assert.arrayOfObject(opts.parts, "options.parts");
      assert.string(opts.type, "options.type");
      var partLookup = {};
      for (var i = 0; i < opts.parts.length; ++i) {
        var part = opts.parts[i];
        partLookup[part.name] = part;
      }
      this.type = opts.type;
      this.hashAlgorithm = opts.hashAlgo;
      this.curve = opts.curve;
      this.parts = opts.parts;
      this.part = partLookup;
    }
    Signature.prototype.toBuffer = function(format3) {
      if (format3 === void 0)
        format3 = "asn1";
      assert.string(format3, "format");
      var buf;
      var stype = "ssh-" + this.type;
      switch (this.type) {
        case "rsa":
          switch (this.hashAlgorithm) {
            case "sha256":
              stype = "rsa-sha2-256";
              break;
            case "sha512":
              stype = "rsa-sha2-512";
              break;
            case "sha1":
            case void 0:
              break;
            default:
              throw new Error("SSH signature format does not support hash algorithm " + this.hashAlgorithm);
          }
          if (format3 === "ssh") {
            buf = new SSHBuffer({});
            buf.writeString(stype);
            buf.writePart(this.part.sig);
            return buf.toBuffer();
          } else {
            return this.part.sig.data;
          }
          break;
        case "ed25519":
          if (format3 === "ssh") {
            buf = new SSHBuffer({});
            buf.writeString(stype);
            buf.writePart(this.part.sig);
            return buf.toBuffer();
          } else {
            return this.part.sig.data;
          }
          break;
        case "dsa":
        case "ecdsa":
          var r, s;
          if (format3 === "asn1") {
            var der = new asn1.BerWriter();
            der.startSequence();
            r = utils.mpNormalize(this.part.r.data);
            s = utils.mpNormalize(this.part.s.data);
            der.writeBuffer(r, asn1.Ber.Integer);
            der.writeBuffer(s, asn1.Ber.Integer);
            der.endSequence();
            return der.buffer;
          } else if (format3 === "ssh" && this.type === "dsa") {
            buf = new SSHBuffer({});
            buf.writeString("ssh-dss");
            r = this.part.r.data;
            if (r.length > 20 && r[0] === 0)
              r = r.slice(1);
            s = this.part.s.data;
            if (s.length > 20 && s[0] === 0)
              s = s.slice(1);
            if (this.hashAlgorithm && this.hashAlgorithm !== "sha1" || r.length + s.length !== 40) {
              throw new Error("OpenSSH only supports DSA signatures with SHA1 hash");
            }
            buf.writeBuffer(Buffer2.concat([r, s]));
            return buf.toBuffer();
          } else if (format3 === "ssh" && this.type === "ecdsa") {
            var inner = new SSHBuffer({});
            r = this.part.r.data;
            inner.writeBuffer(r);
            inner.writePart(this.part.s);
            buf = new SSHBuffer({});
            var curve;
            if (r[0] === 0)
              r = r.slice(1);
            var sz = r.length * 8;
            if (sz === 256)
              curve = "nistp256";
            else if (sz === 384)
              curve = "nistp384";
            else if (sz === 528)
              curve = "nistp521";
            buf.writeString("ecdsa-sha2-" + curve);
            buf.writeBuffer(inner.toBuffer());
            return buf.toBuffer();
          }
          throw new Error("Invalid signature format");
        default:
          throw new Error("Invalid signature data");
      }
    };
    Signature.prototype.toString = function(format3) {
      assert.optionalString(format3, "format");
      return this.toBuffer(format3).toString("base64");
    };
    Signature.parse = function(data, type, format3) {
      if (typeof data === "string")
        data = Buffer2.from(data, "base64");
      assert.buffer(data, "data");
      assert.string(format3, "format");
      assert.string(type, "type");
      var opts = {};
      opts.type = type.toLowerCase();
      opts.parts = [];
      try {
        assert.ok(data.length > 0, "signature must not be empty");
        switch (opts.type) {
          case "rsa":
            return parseOneNum(data, type, format3, opts);
          case "ed25519":
            return parseOneNum(data, type, format3, opts);
          case "dsa":
          case "ecdsa":
            if (format3 === "asn1")
              return parseDSAasn1(data, type, format3, opts);
            else if (opts.type === "dsa")
              return parseDSA(data, type, format3, opts);
            else
              return parseECDSA(data, type, format3, opts);
          default:
            throw new InvalidAlgorithmError(type);
        }
      } catch (e) {
        if (e instanceof InvalidAlgorithmError)
          throw e;
        throw new SignatureParseError(type, format3, e);
      }
    };
    function parseOneNum(data, type, format3, opts) {
      if (format3 === "ssh") {
        try {
          var buf = new SSHBuffer({ buffer: data });
          var head = buf.readString();
        } catch (e) {
        }
        if (buf !== void 0) {
          var msg = "SSH signature does not match expected type (expected " + type + ", got " + head + ")";
          switch (head) {
            case "ssh-rsa":
              assert.strictEqual(type, "rsa", msg);
              opts.hashAlgo = "sha1";
              break;
            case "rsa-sha2-256":
              assert.strictEqual(type, "rsa", msg);
              opts.hashAlgo = "sha256";
              break;
            case "rsa-sha2-512":
              assert.strictEqual(type, "rsa", msg);
              opts.hashAlgo = "sha512";
              break;
            case "ssh-ed25519":
              assert.strictEqual(type, "ed25519", msg);
              opts.hashAlgo = "sha512";
              break;
            default:
              throw new Error("Unknown SSH signature type: " + head);
          }
          var sig = buf.readPart();
          assert.ok(buf.atEnd(), "extra trailing bytes");
          sig.name = "sig";
          opts.parts.push(sig);
          return new Signature(opts);
        }
      }
      opts.parts.push({ name: "sig", data });
      return new Signature(opts);
    }
    function parseDSAasn1(data, type, format3, opts) {
      var der = new asn1.BerReader(data);
      der.readSequence();
      var r = der.readString(asn1.Ber.Integer, true);
      var s = der.readString(asn1.Ber.Integer, true);
      opts.parts.push({ name: "r", data: utils.mpNormalize(r) });
      opts.parts.push({ name: "s", data: utils.mpNormalize(s) });
      return new Signature(opts);
    }
    function parseDSA(data, type, format3, opts) {
      if (data.length != 40) {
        var buf = new SSHBuffer({ buffer: data });
        var d2 = buf.readBuffer();
        if (d2.toString("ascii") === "ssh-dss")
          d2 = buf.readBuffer();
        assert.ok(buf.atEnd(), "extra trailing bytes");
        assert.strictEqual(d2.length, 40, "invalid inner length");
        data = d2;
      }
      opts.parts.push({ name: "r", data: data.slice(0, 20) });
      opts.parts.push({ name: "s", data: data.slice(20, 40) });
      return new Signature(opts);
    }
    function parseECDSA(data, type, format3, opts) {
      var buf = new SSHBuffer({ buffer: data });
      var r, s;
      var inner = buf.readBuffer();
      var stype = inner.toString("ascii");
      if (stype.slice(0, 6) === "ecdsa-") {
        var parts = stype.split("-");
        assert.strictEqual(parts[0], "ecdsa");
        assert.strictEqual(parts[1], "sha2");
        opts.curve = parts[2];
        switch (opts.curve) {
          case "nistp256":
            opts.hashAlgo = "sha256";
            break;
          case "nistp384":
            opts.hashAlgo = "sha384";
            break;
          case "nistp521":
            opts.hashAlgo = "sha512";
            break;
          default:
            throw new Error("Unsupported ECDSA curve: " + opts.curve);
        }
        inner = buf.readBuffer();
        assert.ok(buf.atEnd(), "extra trailing bytes on outer");
        buf = new SSHBuffer({ buffer: inner });
        r = buf.readPart();
      } else {
        r = { data: inner };
      }
      s = buf.readPart();
      assert.ok(buf.atEnd(), "extra trailing bytes");
      r.name = "r";
      s.name = "s";
      opts.parts.push(r);
      opts.parts.push(s);
      return new Signature(opts);
    }
    Signature.isSignature = function(obj, ver) {
      return utils.isCompatible(obj, Signature, ver);
    };
    Signature.prototype._sshpkApiVersion = [2, 1];
    Signature._oldVersionDetect = function(obj) {
      assert.func(obj.toBuffer);
      if (obj.hasOwnProperty("hashAlgorithm"))
        return [2, 0];
      return [1, 0];
    };
  }
});

// node_modules/ecc-jsbn/lib/sec.js
var require_sec = __commonJS({
  "node_modules/ecc-jsbn/lib/sec.js"(exports2, module2) {
    var BigInteger = require_jsbn().BigInteger;
    var ECCurveFp = require_ec().ECCurveFp;
    function X9ECParameters(curve, g2, n, h) {
      this.curve = curve;
      this.g = g2;
      this.n = n;
      this.h = h;
    }
    function x9getCurve() {
      return this.curve;
    }
    function x9getG() {
      return this.g;
    }
    function x9getN() {
      return this.n;
    }
    function x9getH() {
      return this.h;
    }
    X9ECParameters.prototype.getCurve = x9getCurve;
    X9ECParameters.prototype.getG = x9getG;
    X9ECParameters.prototype.getN = x9getN;
    X9ECParameters.prototype.getH = x9getH;
    function fromHex(s) {
      return new BigInteger(s, 16);
    }
    function secp128r1() {
      var p3 = fromHex("FFFFFFFDFFFFFFFFFFFFFFFFFFFFFFFF");
      var a = fromHex("FFFFFFFDFFFFFFFFFFFFFFFFFFFFFFFC");
      var b = fromHex("E87579C11079F43DD824993C2CEE5ED3");
      var n = fromHex("FFFFFFFE0000000075A30D1B9038A115");
      var h = BigInteger.ONE;
      var curve = new ECCurveFp(p3, a, b);
      var G = curve.decodePointHex("04161FF7528B899B2D0C28607CA52C5B86CF5AC8395BAFEB13C02DA292DDED7A83");
      return new X9ECParameters(curve, G, n, h);
    }
    function secp160k1() {
      var p3 = fromHex("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFAC73");
      var a = BigInteger.ZERO;
      var b = fromHex("7");
      var n = fromHex("0100000000000000000001B8FA16DFAB9ACA16B6B3");
      var h = BigInteger.ONE;
      var curve = new ECCurveFp(p3, a, b);
      var G = curve.decodePointHex("043B4C382CE37AA192A4019E763036F4F5DD4D7EBB938CF935318FDCED6BC28286531733C3F03C4FEE");
      return new X9ECParameters(curve, G, n, h);
    }
    function secp160r1() {
      var p3 = fromHex("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFF");
      var a = fromHex("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFC");
      var b = fromHex("1C97BEFC54BD7A8B65ACF89F81D4D4ADC565FA45");
      var n = fromHex("0100000000000000000001F4C8F927AED3CA752257");
      var h = BigInteger.ONE;
      var curve = new ECCurveFp(p3, a, b);
      var G = curve.decodePointHex("044A96B5688EF573284664698968C38BB913CBFC8223A628553168947D59DCC912042351377AC5FB32");
      return new X9ECParameters(curve, G, n, h);
    }
    function secp192k1() {
      var p3 = fromHex("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFEE37");
      var a = BigInteger.ZERO;
      var b = fromHex("3");
      var n = fromHex("FFFFFFFFFFFFFFFFFFFFFFFE26F2FC170F69466A74DEFD8D");
      var h = BigInteger.ONE;
      var curve = new ECCurveFp(p3, a, b);
      var G = curve.decodePointHex("04DB4FF10EC057E9AE26B07D0280B7F4341DA5D1B1EAE06C7D9B2F2F6D9C5628A7844163D015BE86344082AA88D95E2F9D");
      return new X9ECParameters(curve, G, n, h);
    }
    function secp192r1() {
      var p3 = fromHex("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFFFFFFFF");
      var a = fromHex("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFFFFFFFC");
      var b = fromHex("64210519E59C80E70FA7E9AB72243049FEB8DEECC146B9B1");
      var n = fromHex("FFFFFFFFFFFFFFFFFFFFFFFF99DEF836146BC9B1B4D22831");
      var h = BigInteger.ONE;
      var curve = new ECCurveFp(p3, a, b);
      var G = curve.decodePointHex("04188DA80EB03090F67CBF20EB43A18800F4FF0AFD82FF101207192B95FFC8DA78631011ED6B24CDD573F977A11E794811");
      return new X9ECParameters(curve, G, n, h);
    }
    function secp224r1() {
      var p3 = fromHex("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000000000000000000001");
      var a = fromHex("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFE");
      var b = fromHex("B4050A850C04B3ABF54132565044B0B7D7BFD8BA270B39432355FFB4");
      var n = fromHex("FFFFFFFFFFFFFFFFFFFFFFFFFFFF16A2E0B8F03E13DD29455C5C2A3D");
      var h = BigInteger.ONE;
      var curve = new ECCurveFp(p3, a, b);
      var G = curve.decodePointHex("04B70E0CBD6BB4BF7F321390B94A03C1D356C21122343280D6115C1D21BD376388B5F723FB4C22DFE6CD4375A05A07476444D5819985007E34");
      return new X9ECParameters(curve, G, n, h);
    }
    function secp256r1() {
      var p3 = fromHex("FFFFFFFF00000001000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFF");
      var a = fromHex("FFFFFFFF00000001000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFC");
      var b = fromHex("5AC635D8AA3A93E7B3EBBD55769886BC651D06B0CC53B0F63BCE3C3E27D2604B");
      var n = fromHex("FFFFFFFF00000000FFFFFFFFFFFFFFFFBCE6FAADA7179E84F3B9CAC2FC632551");
      var h = BigInteger.ONE;
      var curve = new ECCurveFp(p3, a, b);
      var G = curve.decodePointHex("046B17D1F2E12C4247F8BCE6E563A440F277037D812DEB33A0F4A13945D898C2964FE342E2FE1A7F9B8EE7EB4A7C0F9E162BCE33576B315ECECBB6406837BF51F5");
      return new X9ECParameters(curve, G, n, h);
    }
    module2.exports = {
      "secp128r1": secp128r1,
      "secp160k1": secp160k1,
      "secp160r1": secp160r1,
      "secp192k1": secp192k1,
      "secp192r1": secp192r1,
      "secp224r1": secp224r1,
      "secp256r1": secp256r1
    };
  }
});

// node_modules/ecc-jsbn/index.js
var require_ecc_jsbn = __commonJS({
  "node_modules/ecc-jsbn/index.js"(exports2) {
    var crypto2 = require("crypto");
    var BigInteger = require_jsbn().BigInteger;
    var ECPointFp = require_ec().ECPointFp;
    var Buffer2 = require_safer().Buffer;
    exports2.ECCurves = require_sec();
    function unstupid(hex, len) {
      return hex.length >= len ? hex : unstupid("0" + hex, len);
    }
    exports2.ECKey = function(curve, key, isPublic) {
      var priv;
      var c2 = curve();
      var n = c2.getN();
      var bytes = Math.floor(n.bitLength() / 8);
      if (key) {
        if (isPublic) {
          var curve = c2.getCurve();
          this.P = curve.decodePointHex(key.toString("hex"));
        } else {
          if (key.length != bytes)
            return false;
          priv = new BigInteger(key.toString("hex"), 16);
        }
      } else {
        var n1 = n.subtract(BigInteger.ONE);
        var r = new BigInteger(crypto2.randomBytes(n.bitLength()));
        priv = r.mod(n1).add(BigInteger.ONE);
        this.P = c2.getG().multiply(priv);
      }
      if (this.P) {
        this.PublicKey = Buffer2.from(c2.getCurve().encodeCompressedPointHex(this.P), "hex");
      }
      if (priv) {
        this.PrivateKey = Buffer2.from(unstupid(priv.toString(16), bytes * 2), "hex");
        this.deriveSharedSecret = function(key2) {
          if (!key2 || !key2.P)
            return false;
          var S = key2.P.multiply(priv);
          return Buffer2.from(unstupid(S.getX().toBigInteger().toString(16), bytes * 2), "hex");
        };
      }
    };
  }
});

// node_modules/sshpk/lib/dhe.js
var require_dhe = __commonJS({
  "node_modules/sshpk/lib/dhe.js"(exports2, module2) {
    module2.exports = {
      DiffieHellman,
      generateECDSA,
      generateED25519
    };
    var assert = require_assert();
    var crypto2 = require("crypto");
    var Buffer2 = require_safer().Buffer;
    var algs = require_algs();
    var utils = require_utils5();
    var nacl = require_nacl_fast();
    var Key = require_key();
    var PrivateKey = require_private_key();
    var CRYPTO_HAVE_ECDH = crypto2.createECDH !== void 0;
    var ecdh = require_ecc_jsbn();
    var ec = require_ec();
    var jsbn = require_jsbn2().BigInteger;
    function DiffieHellman(key) {
      utils.assertCompatible(key, Key, [1, 4], "key");
      this._isPriv = PrivateKey.isPrivateKey(key, [1, 3]);
      this._algo = key.type;
      this._curve = key.curve;
      this._key = key;
      if (key.type === "dsa") {
        if (!CRYPTO_HAVE_ECDH) {
          throw new Error("Due to bugs in the node 0.10 crypto API, node 0.12.x or later is required to use DH");
        }
        this._dh = crypto2.createDiffieHellman(
          key.part.p.data,
          void 0,
          key.part.g.data,
          void 0
        );
        this._p = key.part.p;
        this._g = key.part.g;
        if (this._isPriv)
          this._dh.setPrivateKey(key.part.x.data);
        this._dh.setPublicKey(key.part.y.data);
      } else if (key.type === "ecdsa") {
        if (!CRYPTO_HAVE_ECDH) {
          this._ecParams = new X9ECParameters(this._curve);
          if (this._isPriv) {
            this._priv = new ECPrivate(
              this._ecParams,
              key.part.d.data
            );
          }
          return;
        }
        var curve = {
          "nistp256": "prime256v1",
          "nistp384": "secp384r1",
          "nistp521": "secp521r1"
        }[key.curve];
        this._dh = crypto2.createECDH(curve);
        if (typeof this._dh !== "object" || typeof this._dh.setPrivateKey !== "function") {
          CRYPTO_HAVE_ECDH = false;
          DiffieHellman.call(this, key);
          return;
        }
        if (this._isPriv)
          this._dh.setPrivateKey(key.part.d.data);
        this._dh.setPublicKey(key.part.Q.data);
      } else if (key.type === "curve25519") {
        if (this._isPriv) {
          utils.assertCompatible(key, PrivateKey, [1, 5], "key");
          this._priv = key.part.k.data;
        }
      } else {
        throw new Error("DH not supported for " + key.type + " keys");
      }
    }
    DiffieHellman.prototype.getPublicKey = function() {
      if (this._isPriv)
        return this._key.toPublic();
      return this._key;
    };
    DiffieHellman.prototype.getPrivateKey = function() {
      if (this._isPriv)
        return this._key;
      else
        return void 0;
    };
    DiffieHellman.prototype.getKey = DiffieHellman.prototype.getPrivateKey;
    DiffieHellman.prototype._keyCheck = function(pk, isPub) {
      assert.object(pk, "key");
      if (!isPub)
        utils.assertCompatible(pk, PrivateKey, [1, 3], "key");
      utils.assertCompatible(pk, Key, [1, 4], "key");
      if (pk.type !== this._algo) {
        throw new Error("A " + pk.type + " key cannot be used in " + this._algo + " Diffie-Hellman");
      }
      if (pk.curve !== this._curve) {
        throw new Error("A key from the " + pk.curve + " curve cannot be used with a " + this._curve + " Diffie-Hellman");
      }
      if (pk.type === "dsa") {
        assert.deepEqual(
          pk.part.p,
          this._p,
          "DSA key prime does not match"
        );
        assert.deepEqual(
          pk.part.g,
          this._g,
          "DSA key generator does not match"
        );
      }
    };
    DiffieHellman.prototype.setKey = function(pk) {
      this._keyCheck(pk);
      if (pk.type === "dsa") {
        this._dh.setPrivateKey(pk.part.x.data);
        this._dh.setPublicKey(pk.part.y.data);
      } else if (pk.type === "ecdsa") {
        if (CRYPTO_HAVE_ECDH) {
          this._dh.setPrivateKey(pk.part.d.data);
          this._dh.setPublicKey(pk.part.Q.data);
        } else {
          this._priv = new ECPrivate(
            this._ecParams,
            pk.part.d.data
          );
        }
      } else if (pk.type === "curve25519") {
        var k = pk.part.k;
        if (!pk.part.k)
          k = pk.part.r;
        this._priv = k.data;
        if (this._priv[0] === 0)
          this._priv = this._priv.slice(1);
        this._priv = this._priv.slice(0, 32);
      }
      this._key = pk;
      this._isPriv = true;
    };
    DiffieHellman.prototype.setPrivateKey = DiffieHellman.prototype.setKey;
    DiffieHellman.prototype.computeSecret = function(otherpk) {
      this._keyCheck(otherpk, true);
      if (!this._isPriv)
        throw new Error("DH exchange has not been initialized with a private key yet");
      var pub;
      if (this._algo === "dsa") {
        return this._dh.computeSecret(
          otherpk.part.y.data
        );
      } else if (this._algo === "ecdsa") {
        if (CRYPTO_HAVE_ECDH) {
          return this._dh.computeSecret(
            otherpk.part.Q.data
          );
        } else {
          pub = new ECPublic(
            this._ecParams,
            otherpk.part.Q.data
          );
          return this._priv.deriveSharedSecret(pub);
        }
      } else if (this._algo === "curve25519") {
        pub = otherpk.part.A.data;
        while (pub[0] === 0 && pub.length > 32)
          pub = pub.slice(1);
        var priv = this._priv;
        assert.strictEqual(pub.length, 32);
        assert.strictEqual(priv.length, 32);
        var secret = nacl.box.before(
          new Uint8Array(pub),
          new Uint8Array(priv)
        );
        return Buffer2.from(secret);
      }
      throw new Error("Invalid algorithm: " + this._algo);
    };
    DiffieHellman.prototype.generateKey = function() {
      var parts = [];
      var priv, pub;
      if (this._algo === "dsa") {
        this._dh.generateKeys();
        parts.push({ name: "p", data: this._p.data });
        parts.push({ name: "q", data: this._key.part.q.data });
        parts.push({ name: "g", data: this._g.data });
        parts.push({ name: "y", data: this._dh.getPublicKey() });
        parts.push({ name: "x", data: this._dh.getPrivateKey() });
        this._key = new PrivateKey({
          type: "dsa",
          parts
        });
        this._isPriv = true;
        return this._key;
      } else if (this._algo === "ecdsa") {
        if (CRYPTO_HAVE_ECDH) {
          this._dh.generateKeys();
          parts.push({
            name: "curve",
            data: Buffer2.from(this._curve)
          });
          parts.push({ name: "Q", data: this._dh.getPublicKey() });
          parts.push({ name: "d", data: this._dh.getPrivateKey() });
          this._key = new PrivateKey({
            type: "ecdsa",
            curve: this._curve,
            parts
          });
          this._isPriv = true;
          return this._key;
        } else {
          var n = this._ecParams.getN();
          var r = new jsbn(crypto2.randomBytes(n.bitLength()));
          var n1 = n.subtract(jsbn.ONE);
          priv = r.mod(n1).add(jsbn.ONE);
          pub = this._ecParams.getG().multiply(priv);
          priv = Buffer2.from(priv.toByteArray());
          pub = Buffer2.from(this._ecParams.getCurve().encodePointHex(pub), "hex");
          this._priv = new ECPrivate(this._ecParams, priv);
          parts.push({
            name: "curve",
            data: Buffer2.from(this._curve)
          });
          parts.push({ name: "Q", data: pub });
          parts.push({ name: "d", data: priv });
          this._key = new PrivateKey({
            type: "ecdsa",
            curve: this._curve,
            parts
          });
          this._isPriv = true;
          return this._key;
        }
      } else if (this._algo === "curve25519") {
        var pair = nacl.box.keyPair();
        priv = Buffer2.from(pair.secretKey);
        pub = Buffer2.from(pair.publicKey);
        priv = Buffer2.concat([priv, pub]);
        assert.strictEqual(priv.length, 64);
        assert.strictEqual(pub.length, 32);
        parts.push({ name: "A", data: pub });
        parts.push({ name: "k", data: priv });
        this._key = new PrivateKey({
          type: "curve25519",
          parts
        });
        this._isPriv = true;
        return this._key;
      }
      throw new Error("Invalid algorithm: " + this._algo);
    };
    DiffieHellman.prototype.generateKeys = DiffieHellman.prototype.generateKey;
    function X9ECParameters(name) {
      var params = algs.curves[name];
      assert.object(params);
      var p3 = new jsbn(params.p);
      var a = new jsbn(params.a);
      var b = new jsbn(params.b);
      var n = new jsbn(params.n);
      var h = jsbn.ONE;
      var curve = new ec.ECCurveFp(p3, a, b);
      var G = curve.decodePointHex(params.G.toString("hex"));
      this.curve = curve;
      this.g = G;
      this.n = n;
      this.h = h;
    }
    X9ECParameters.prototype.getCurve = function() {
      return this.curve;
    };
    X9ECParameters.prototype.getG = function() {
      return this.g;
    };
    X9ECParameters.prototype.getN = function() {
      return this.n;
    };
    X9ECParameters.prototype.getH = function() {
      return this.h;
    };
    function ECPublic(params, buffer) {
      this._params = params;
      if (buffer[0] === 0)
        buffer = buffer.slice(1);
      this._pub = params.getCurve().decodePointHex(buffer.toString("hex"));
    }
    function ECPrivate(params, buffer) {
      this._params = params;
      this._priv = new jsbn(utils.mpNormalize(buffer));
    }
    ECPrivate.prototype.deriveSharedSecret = function(pubKey) {
      assert.ok(pubKey instanceof ECPublic);
      var S = pubKey._pub.multiply(this._priv);
      return Buffer2.from(S.getX().toBigInteger().toByteArray());
    };
    function generateED25519() {
      var pair = nacl.sign.keyPair();
      var priv = Buffer2.from(pair.secretKey);
      var pub = Buffer2.from(pair.publicKey);
      assert.strictEqual(priv.length, 64);
      assert.strictEqual(pub.length, 32);
      var parts = [];
      parts.push({ name: "A", data: pub });
      parts.push({ name: "k", data: priv.slice(0, 32) });
      var key = new PrivateKey({
        type: "ed25519",
        parts
      });
      return key;
    }
    function generateECDSA(curve) {
      var parts = [];
      var key;
      if (CRYPTO_HAVE_ECDH) {
        var osCurve = {
          "nistp256": "prime256v1",
          "nistp384": "secp384r1",
          "nistp521": "secp521r1"
        }[curve];
        var dh = crypto2.createECDH(osCurve);
        dh.generateKeys();
        parts.push({
          name: "curve",
          data: Buffer2.from(curve)
        });
        parts.push({ name: "Q", data: dh.getPublicKey() });
        parts.push({ name: "d", data: dh.getPrivateKey() });
        key = new PrivateKey({
          type: "ecdsa",
          curve,
          parts
        });
        return key;
      } else {
        var ecParams = new X9ECParameters(curve);
        var n = ecParams.getN();
        var cByteLen = Math.ceil((n.bitLength() + 64) / 8);
        var c2 = new jsbn(crypto2.randomBytes(cByteLen));
        var n1 = n.subtract(jsbn.ONE);
        var priv = c2.mod(n1).add(jsbn.ONE);
        var pub = ecParams.getG().multiply(priv);
        priv = Buffer2.from(priv.toByteArray());
        pub = Buffer2.from(ecParams.getCurve().encodePointHex(pub), "hex");
        parts.push({ name: "curve", data: Buffer2.from(curve) });
        parts.push({ name: "Q", data: pub });
        parts.push({ name: "d", data: priv });
        key = new PrivateKey({
          type: "ecdsa",
          curve,
          parts
        });
        return key;
      }
    }
  }
});

// node_modules/sshpk/lib/ed-compat.js
var require_ed_compat = __commonJS({
  "node_modules/sshpk/lib/ed-compat.js"(exports2, module2) {
    module2.exports = {
      Verifier,
      Signer
    };
    var nacl = require_nacl_fast();
    var stream = require("stream");
    var util = require("util");
    var assert = require_assert();
    var Buffer2 = require_safer().Buffer;
    var Signature = require_signature();
    function Verifier(key, hashAlgo) {
      if (hashAlgo.toLowerCase() !== "sha512")
        throw new Error("ED25519 only supports the use of SHA-512 hashes");
      this.key = key;
      this.chunks = [];
      stream.Writable.call(this, {});
    }
    util.inherits(Verifier, stream.Writable);
    Verifier.prototype._write = function(chunk, enc, cb) {
      this.chunks.push(chunk);
      cb();
    };
    Verifier.prototype.update = function(chunk) {
      if (typeof chunk === "string")
        chunk = Buffer2.from(chunk, "binary");
      this.chunks.push(chunk);
    };
    Verifier.prototype.verify = function(signature, fmt) {
      var sig;
      if (Signature.isSignature(signature, [2, 0])) {
        if (signature.type !== "ed25519")
          return false;
        sig = signature.toBuffer("raw");
      } else if (typeof signature === "string") {
        sig = Buffer2.from(signature, "base64");
      } else if (Signature.isSignature(signature, [1, 0])) {
        throw new Error("signature was created by too old a version of sshpk and cannot be verified");
      }
      assert.buffer(sig);
      return nacl.sign.detached.verify(
        new Uint8Array(Buffer2.concat(this.chunks)),
        new Uint8Array(sig),
        new Uint8Array(this.key.part.A.data)
      );
    };
    function Signer(key, hashAlgo) {
      if (hashAlgo.toLowerCase() !== "sha512")
        throw new Error("ED25519 only supports the use of SHA-512 hashes");
      this.key = key;
      this.chunks = [];
      stream.Writable.call(this, {});
    }
    util.inherits(Signer, stream.Writable);
    Signer.prototype._write = function(chunk, enc, cb) {
      this.chunks.push(chunk);
      cb();
    };
    Signer.prototype.update = function(chunk) {
      if (typeof chunk === "string")
        chunk = Buffer2.from(chunk, "binary");
      this.chunks.push(chunk);
    };
    Signer.prototype.sign = function() {
      var sig = nacl.sign.detached(
        new Uint8Array(Buffer2.concat(this.chunks)),
        new Uint8Array(Buffer2.concat([
          this.key.part.k.data,
          this.key.part.A.data
        ]))
      );
      var sigBuf = Buffer2.from(sig);
      var sigObj = Signature.parse(sigBuf, "ed25519", "raw");
      sigObj.hashAlgorithm = "sha512";
      return sigObj;
    };
  }
});

// node_modules/sshpk/lib/formats/pkcs8.js
var require_pkcs8 = __commonJS({
  "node_modules/sshpk/lib/formats/pkcs8.js"(exports2, module2) {
    module2.exports = {
      read,
      readPkcs8,
      write,
      writePkcs8,
      pkcs8ToBuffer,
      readECDSACurve,
      writeECDSACurve
    };
    var assert = require_assert();
    var asn1 = require_lib14();
    var Buffer2 = require_safer().Buffer;
    var algs = require_algs();
    var utils = require_utils5();
    var Key = require_key();
    var PrivateKey = require_private_key();
    var pem = require_pem();
    function read(buf, options) {
      return pem.read(buf, options, "pkcs8");
    }
    function write(key, options) {
      return pem.write(key, options, "pkcs8");
    }
    function readMPInt(der, nm) {
      assert.strictEqual(
        der.peek(),
        asn1.Ber.Integer,
        nm + " is not an Integer"
      );
      return utils.mpNormalize(der.readString(asn1.Ber.Integer, true));
    }
    function readPkcs8(alg, type, der) {
      if (der.peek() === asn1.Ber.Integer) {
        assert.strictEqual(
          type,
          "private",
          "unexpected Integer at start of public key"
        );
        der.readString(asn1.Ber.Integer, true);
      }
      der.readSequence();
      var next = der.offset + der.length;
      var oid = der.readOID();
      switch (oid) {
        case "1.2.840.113549.1.1.1":
          der._offset = next;
          if (type === "public")
            return readPkcs8RSAPublic(der);
          else
            return readPkcs8RSAPrivate(der);
        case "1.2.840.10040.4.1":
          if (type === "public")
            return readPkcs8DSAPublic(der);
          else
            return readPkcs8DSAPrivate(der);
        case "1.2.840.10045.2.1":
          if (type === "public")
            return readPkcs8ECDSAPublic(der);
          else
            return readPkcs8ECDSAPrivate(der);
        case "1.3.101.112":
          if (type === "public") {
            return readPkcs8EdDSAPublic(der);
          } else {
            return readPkcs8EdDSAPrivate(der);
          }
        case "1.3.101.110":
          if (type === "public") {
            return readPkcs8X25519Public(der);
          } else {
            return readPkcs8X25519Private(der);
          }
        default:
          throw new Error("Unknown key type OID " + oid);
      }
    }
    function readPkcs8RSAPublic(der) {
      der.readSequence(asn1.Ber.BitString);
      der.readByte();
      der.readSequence();
      var n = readMPInt(der, "modulus");
      var e = readMPInt(der, "exponent");
      var key = {
        type: "rsa",
        source: der.originalInput,
        parts: [
          { name: "e", data: e },
          { name: "n", data: n }
        ]
      };
      return new Key(key);
    }
    function readPkcs8RSAPrivate(der) {
      der.readSequence(asn1.Ber.OctetString);
      der.readSequence();
      var ver = readMPInt(der, "version");
      assert.equal(ver[0], 0, "unknown RSA private key version");
      var n = readMPInt(der, "modulus");
      var e = readMPInt(der, "public exponent");
      var d2 = readMPInt(der, "private exponent");
      var p3 = readMPInt(der, "prime1");
      var q2 = readMPInt(der, "prime2");
      var dmodp = readMPInt(der, "exponent1");
      var dmodq = readMPInt(der, "exponent2");
      var iqmp = readMPInt(der, "iqmp");
      var key = {
        type: "rsa",
        parts: [
          { name: "n", data: n },
          { name: "e", data: e },
          { name: "d", data: d2 },
          { name: "iqmp", data: iqmp },
          { name: "p", data: p3 },
          { name: "q", data: q2 },
          { name: "dmodp", data: dmodp },
          { name: "dmodq", data: dmodq }
        ]
      };
      return new PrivateKey(key);
    }
    function readPkcs8DSAPublic(der) {
      der.readSequence();
      var p3 = readMPInt(der, "p");
      var q2 = readMPInt(der, "q");
      var g2 = readMPInt(der, "g");
      der.readSequence(asn1.Ber.BitString);
      der.readByte();
      var y = readMPInt(der, "y");
      var key = {
        type: "dsa",
        parts: [
          { name: "p", data: p3 },
          { name: "q", data: q2 },
          { name: "g", data: g2 },
          { name: "y", data: y }
        ]
      };
      return new Key(key);
    }
    function readPkcs8DSAPrivate(der) {
      der.readSequence();
      var p3 = readMPInt(der, "p");
      var q2 = readMPInt(der, "q");
      var g2 = readMPInt(der, "g");
      der.readSequence(asn1.Ber.OctetString);
      var x2 = readMPInt(der, "x");
      var y = utils.calculateDSAPublic(g2, p3, x2);
      var key = {
        type: "dsa",
        parts: [
          { name: "p", data: p3 },
          { name: "q", data: q2 },
          { name: "g", data: g2 },
          { name: "y", data: y },
          { name: "x", data: x2 }
        ]
      };
      return new PrivateKey(key);
    }
    function readECDSACurve(der) {
      var curveName, curveNames;
      var j, c2, cd;
      if (der.peek() === asn1.Ber.OID) {
        var oid = der.readOID();
        curveNames = Object.keys(algs.curves);
        for (j = 0; j < curveNames.length; ++j) {
          c2 = curveNames[j];
          cd = algs.curves[c2];
          if (cd.pkcs8oid === oid) {
            curveName = c2;
            break;
          }
        }
      } else {
        der.readSequence();
        var version = der.readString(asn1.Ber.Integer, true);
        assert.strictEqual(version[0], 1, "ECDSA key not version 1");
        var curve = {};
        der.readSequence();
        var fieldTypeOid = der.readOID();
        assert.strictEqual(
          fieldTypeOid,
          "1.2.840.10045.1.1",
          "ECDSA key is not from a prime-field"
        );
        var p3 = curve.p = utils.mpNormalize(
          der.readString(asn1.Ber.Integer, true)
        );
        curve.size = p3.length * 8 - utils.countZeros(p3);
        der.readSequence();
        curve.a = utils.mpNormalize(
          der.readString(asn1.Ber.OctetString, true)
        );
        curve.b = utils.mpNormalize(
          der.readString(asn1.Ber.OctetString, true)
        );
        if (der.peek() === asn1.Ber.BitString)
          curve.s = der.readString(asn1.Ber.BitString, true);
        curve.G = der.readString(asn1.Ber.OctetString, true);
        assert.strictEqual(
          curve.G[0],
          4,
          "uncompressed G is required"
        );
        curve.n = utils.mpNormalize(
          der.readString(asn1.Ber.Integer, true)
        );
        curve.h = utils.mpNormalize(
          der.readString(asn1.Ber.Integer, true)
        );
        assert.strictEqual(curve.h[0], 1, "a cofactor=1 curve is required");
        curveNames = Object.keys(algs.curves);
        var ks = Object.keys(curve);
        for (j = 0; j < curveNames.length; ++j) {
          c2 = curveNames[j];
          cd = algs.curves[c2];
          var equal = true;
          for (var i = 0; i < ks.length; ++i) {
            var k = ks[i];
            if (cd[k] === void 0)
              continue;
            if (typeof cd[k] === "object" && cd[k].equals !== void 0) {
              if (!cd[k].equals(curve[k])) {
                equal = false;
                break;
              }
            } else if (Buffer2.isBuffer(cd[k])) {
              if (cd[k].toString("binary") !== curve[k].toString("binary")) {
                equal = false;
                break;
              }
            } else {
              if (cd[k] !== curve[k]) {
                equal = false;
                break;
              }
            }
          }
          if (equal) {
            curveName = c2;
            break;
          }
        }
      }
      return curveName;
    }
    function readPkcs8ECDSAPrivate(der) {
      var curveName = readECDSACurve(der);
      assert.string(curveName, "a known elliptic curve");
      der.readSequence(asn1.Ber.OctetString);
      der.readSequence();
      var version = readMPInt(der, "version");
      assert.equal(version[0], 1, "unknown version of ECDSA key");
      var d2 = der.readString(asn1.Ber.OctetString, true);
      var Q;
      if (der.peek() == 160) {
        der.readSequence(160);
        der._offset += der.length;
      }
      if (der.peek() == 161) {
        der.readSequence(161);
        Q = der.readString(asn1.Ber.BitString, true);
        Q = utils.ecNormalize(Q);
      }
      if (Q === void 0) {
        var pub = utils.publicFromPrivateECDSA(curveName, d2);
        Q = pub.part.Q.data;
      }
      var key = {
        type: "ecdsa",
        parts: [
          { name: "curve", data: Buffer2.from(curveName) },
          { name: "Q", data: Q },
          { name: "d", data: d2 }
        ]
      };
      return new PrivateKey(key);
    }
    function readPkcs8ECDSAPublic(der) {
      var curveName = readECDSACurve(der);
      assert.string(curveName, "a known elliptic curve");
      var Q = der.readString(asn1.Ber.BitString, true);
      Q = utils.ecNormalize(Q);
      var key = {
        type: "ecdsa",
        parts: [
          { name: "curve", data: Buffer2.from(curveName) },
          { name: "Q", data: Q }
        ]
      };
      return new Key(key);
    }
    function readPkcs8EdDSAPublic(der) {
      if (der.peek() === 0)
        der.readByte();
      var A = utils.readBitString(der);
      var key = {
        type: "ed25519",
        parts: [
          { name: "A", data: utils.zeroPadToLength(A, 32) }
        ]
      };
      return new Key(key);
    }
    function readPkcs8X25519Public(der) {
      var A = utils.readBitString(der);
      var key = {
        type: "curve25519",
        parts: [
          { name: "A", data: utils.zeroPadToLength(A, 32) }
        ]
      };
      return new Key(key);
    }
    function readPkcs8EdDSAPrivate(der) {
      if (der.peek() === 0)
        der.readByte();
      der.readSequence(asn1.Ber.OctetString);
      var k = der.readString(asn1.Ber.OctetString, true);
      k = utils.zeroPadToLength(k, 32);
      var A, tag;
      while ((tag = der.peek()) !== null) {
        if (tag === (asn1.Ber.Context | 1)) {
          A = utils.readBitString(der, tag);
        } else {
          der.readSequence(tag);
          der._offset += der.length;
        }
      }
      if (A === void 0)
        A = utils.calculateED25519Public(k);
      var key = {
        type: "ed25519",
        parts: [
          { name: "A", data: utils.zeroPadToLength(A, 32) },
          { name: "k", data: utils.zeroPadToLength(k, 32) }
        ]
      };
      return new PrivateKey(key);
    }
    function readPkcs8X25519Private(der) {
      if (der.peek() === 0)
        der.readByte();
      der.readSequence(asn1.Ber.OctetString);
      var k = der.readString(asn1.Ber.OctetString, true);
      k = utils.zeroPadToLength(k, 32);
      var A = utils.calculateX25519Public(k);
      var key = {
        type: "curve25519",
        parts: [
          { name: "A", data: utils.zeroPadToLength(A, 32) },
          { name: "k", data: utils.zeroPadToLength(k, 32) }
        ]
      };
      return new PrivateKey(key);
    }
    function pkcs8ToBuffer(key) {
      var der = new asn1.BerWriter();
      writePkcs8(der, key);
      return der.buffer;
    }
    function writePkcs8(der, key) {
      der.startSequence();
      if (PrivateKey.isPrivateKey(key)) {
        var version = 0;
        if (key.type === "ed25519")
          version = 1;
        var vbuf = Buffer2.from([version]);
        der.writeBuffer(vbuf, asn1.Ber.Integer);
      }
      der.startSequence();
      switch (key.type) {
        case "rsa":
          der.writeOID("1.2.840.113549.1.1.1");
          if (PrivateKey.isPrivateKey(key))
            writePkcs8RSAPrivate(key, der);
          else
            writePkcs8RSAPublic(key, der);
          break;
        case "dsa":
          der.writeOID("1.2.840.10040.4.1");
          if (PrivateKey.isPrivateKey(key))
            writePkcs8DSAPrivate(key, der);
          else
            writePkcs8DSAPublic(key, der);
          break;
        case "ecdsa":
          der.writeOID("1.2.840.10045.2.1");
          if (PrivateKey.isPrivateKey(key))
            writePkcs8ECDSAPrivate(key, der);
          else
            writePkcs8ECDSAPublic(key, der);
          break;
        case "ed25519":
          der.writeOID("1.3.101.112");
          if (PrivateKey.isPrivateKey(key))
            writePkcs8EdDSAPrivate(key, der);
          else
            writePkcs8EdDSAPublic(key, der);
          break;
        default:
          throw new Error("Unsupported key type: " + key.type);
      }
      der.endSequence();
    }
    function writePkcs8RSAPrivate(key, der) {
      der.writeNull();
      der.endSequence();
      der.startSequence(asn1.Ber.OctetString);
      der.startSequence();
      var version = Buffer2.from([0]);
      der.writeBuffer(version, asn1.Ber.Integer);
      der.writeBuffer(key.part.n.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.e.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.d.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.p.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.q.data, asn1.Ber.Integer);
      if (!key.part.dmodp || !key.part.dmodq)
        utils.addRSAMissing(key);
      der.writeBuffer(key.part.dmodp.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.dmodq.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.iqmp.data, asn1.Ber.Integer);
      der.endSequence();
      der.endSequence();
    }
    function writePkcs8RSAPublic(key, der) {
      der.writeNull();
      der.endSequence();
      der.startSequence(asn1.Ber.BitString);
      der.writeByte(0);
      der.startSequence();
      der.writeBuffer(key.part.n.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.e.data, asn1.Ber.Integer);
      der.endSequence();
      der.endSequence();
    }
    function writePkcs8DSAPrivate(key, der) {
      der.startSequence();
      der.writeBuffer(key.part.p.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.q.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.g.data, asn1.Ber.Integer);
      der.endSequence();
      der.endSequence();
      der.startSequence(asn1.Ber.OctetString);
      der.writeBuffer(key.part.x.data, asn1.Ber.Integer);
      der.endSequence();
    }
    function writePkcs8DSAPublic(key, der) {
      der.startSequence();
      der.writeBuffer(key.part.p.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.q.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.g.data, asn1.Ber.Integer);
      der.endSequence();
      der.endSequence();
      der.startSequence(asn1.Ber.BitString);
      der.writeByte(0);
      der.writeBuffer(key.part.y.data, asn1.Ber.Integer);
      der.endSequence();
    }
    function writeECDSACurve(key, der) {
      var curve = algs.curves[key.curve];
      if (curve.pkcs8oid) {
        der.writeOID(curve.pkcs8oid);
      } else {
        der.startSequence();
        var version = Buffer2.from([1]);
        der.writeBuffer(version, asn1.Ber.Integer);
        der.startSequence();
        der.writeOID("1.2.840.10045.1.1");
        der.writeBuffer(curve.p, asn1.Ber.Integer);
        der.endSequence();
        der.startSequence();
        var a = curve.p;
        if (a[0] === 0)
          a = a.slice(1);
        der.writeBuffer(a, asn1.Ber.OctetString);
        der.writeBuffer(curve.b, asn1.Ber.OctetString);
        der.writeBuffer(curve.s, asn1.Ber.BitString);
        der.endSequence();
        der.writeBuffer(curve.G, asn1.Ber.OctetString);
        der.writeBuffer(curve.n, asn1.Ber.Integer);
        var h = curve.h;
        if (!h) {
          h = Buffer2.from([1]);
        }
        der.writeBuffer(h, asn1.Ber.Integer);
        der.endSequence();
      }
    }
    function writePkcs8ECDSAPublic(key, der) {
      writeECDSACurve(key, der);
      der.endSequence();
      var Q = utils.ecNormalize(key.part.Q.data, true);
      der.writeBuffer(Q, asn1.Ber.BitString);
    }
    function writePkcs8ECDSAPrivate(key, der) {
      writeECDSACurve(key, der);
      der.endSequence();
      der.startSequence(asn1.Ber.OctetString);
      der.startSequence();
      var version = Buffer2.from([1]);
      der.writeBuffer(version, asn1.Ber.Integer);
      der.writeBuffer(key.part.d.data, asn1.Ber.OctetString);
      der.startSequence(161);
      var Q = utils.ecNormalize(key.part.Q.data, true);
      der.writeBuffer(Q, asn1.Ber.BitString);
      der.endSequence();
      der.endSequence();
      der.endSequence();
    }
    function writePkcs8EdDSAPublic(key, der) {
      der.endSequence();
      utils.writeBitString(der, key.part.A.data);
    }
    function writePkcs8EdDSAPrivate(key, der) {
      der.endSequence();
      der.startSequence(asn1.Ber.OctetString);
      var k = utils.mpNormalize(key.part.k.data);
      while (k.length > 32 && k[0] === 0)
        k = k.slice(1);
      der.writeBuffer(k, asn1.Ber.OctetString);
      der.endSequence();
      utils.writeBitString(der, key.part.A.data, asn1.Ber.Context | 1);
    }
  }
});

// node_modules/sshpk/lib/formats/pkcs1.js
var require_pkcs1 = __commonJS({
  "node_modules/sshpk/lib/formats/pkcs1.js"(exports2, module2) {
    module2.exports = {
      read,
      readPkcs1,
      write,
      writePkcs1
    };
    var assert = require_assert();
    var asn1 = require_lib14();
    var Buffer2 = require_safer().Buffer;
    var algs = require_algs();
    var utils = require_utils5();
    var Key = require_key();
    var PrivateKey = require_private_key();
    var pem = require_pem();
    var pkcs8 = require_pkcs8();
    var readECDSACurve = pkcs8.readECDSACurve;
    function read(buf, options) {
      return pem.read(buf, options, "pkcs1");
    }
    function write(key, options) {
      return pem.write(key, options, "pkcs1");
    }
    function readMPInt(der, nm) {
      assert.strictEqual(
        der.peek(),
        asn1.Ber.Integer,
        nm + " is not an Integer"
      );
      return utils.mpNormalize(der.readString(asn1.Ber.Integer, true));
    }
    function readPkcs1(alg, type, der) {
      switch (alg) {
        case "RSA":
          if (type === "public")
            return readPkcs1RSAPublic(der);
          else if (type === "private")
            return readPkcs1RSAPrivate(der);
          throw new Error("Unknown key type: " + type);
        case "DSA":
          if (type === "public")
            return readPkcs1DSAPublic(der);
          else if (type === "private")
            return readPkcs1DSAPrivate(der);
          throw new Error("Unknown key type: " + type);
        case "EC":
        case "ECDSA":
          if (type === "private")
            return readPkcs1ECDSAPrivate(der);
          else if (type === "public")
            return readPkcs1ECDSAPublic(der);
          throw new Error("Unknown key type: " + type);
        case "EDDSA":
        case "EdDSA":
          if (type === "private")
            return readPkcs1EdDSAPrivate(der);
          throw new Error(type + " keys not supported with EdDSA");
        default:
          throw new Error("Unknown key algo: " + alg);
      }
    }
    function readPkcs1RSAPublic(der) {
      var n = readMPInt(der, "modulus");
      var e = readMPInt(der, "exponent");
      var key = {
        type: "rsa",
        parts: [
          { name: "e", data: e },
          { name: "n", data: n }
        ]
      };
      return new Key(key);
    }
    function readPkcs1RSAPrivate(der) {
      var version = readMPInt(der, "version");
      assert.strictEqual(version[0], 0);
      var n = readMPInt(der, "modulus");
      var e = readMPInt(der, "public exponent");
      var d2 = readMPInt(der, "private exponent");
      var p3 = readMPInt(der, "prime1");
      var q2 = readMPInt(der, "prime2");
      var dmodp = readMPInt(der, "exponent1");
      var dmodq = readMPInt(der, "exponent2");
      var iqmp = readMPInt(der, "iqmp");
      var key = {
        type: "rsa",
        parts: [
          { name: "n", data: n },
          { name: "e", data: e },
          { name: "d", data: d2 },
          { name: "iqmp", data: iqmp },
          { name: "p", data: p3 },
          { name: "q", data: q2 },
          { name: "dmodp", data: dmodp },
          { name: "dmodq", data: dmodq }
        ]
      };
      return new PrivateKey(key);
    }
    function readPkcs1DSAPrivate(der) {
      var version = readMPInt(der, "version");
      assert.strictEqual(version.readUInt8(0), 0);
      var p3 = readMPInt(der, "p");
      var q2 = readMPInt(der, "q");
      var g2 = readMPInt(der, "g");
      var y = readMPInt(der, "y");
      var x2 = readMPInt(der, "x");
      var key = {
        type: "dsa",
        parts: [
          { name: "p", data: p3 },
          { name: "q", data: q2 },
          { name: "g", data: g2 },
          { name: "y", data: y },
          { name: "x", data: x2 }
        ]
      };
      return new PrivateKey(key);
    }
    function readPkcs1EdDSAPrivate(der) {
      var version = readMPInt(der, "version");
      assert.strictEqual(version.readUInt8(0), 1);
      var k = der.readString(asn1.Ber.OctetString, true);
      der.readSequence(160);
      var oid = der.readOID();
      assert.strictEqual(oid, "1.3.101.112", "the ed25519 curve identifier");
      der.readSequence(161);
      var A = utils.readBitString(der);
      var key = {
        type: "ed25519",
        parts: [
          { name: "A", data: utils.zeroPadToLength(A, 32) },
          { name: "k", data: k }
        ]
      };
      return new PrivateKey(key);
    }
    function readPkcs1DSAPublic(der) {
      var y = readMPInt(der, "y");
      var p3 = readMPInt(der, "p");
      var q2 = readMPInt(der, "q");
      var g2 = readMPInt(der, "g");
      var key = {
        type: "dsa",
        parts: [
          { name: "y", data: y },
          { name: "p", data: p3 },
          { name: "q", data: q2 },
          { name: "g", data: g2 }
        ]
      };
      return new Key(key);
    }
    function readPkcs1ECDSAPublic(der) {
      der.readSequence();
      var oid = der.readOID();
      assert.strictEqual(oid, "1.2.840.10045.2.1", "must be ecPublicKey");
      var curveOid = der.readOID();
      var curve;
      var curves = Object.keys(algs.curves);
      for (var j = 0; j < curves.length; ++j) {
        var c2 = curves[j];
        var cd = algs.curves[c2];
        if (cd.pkcs8oid === curveOid) {
          curve = c2;
          break;
        }
      }
      assert.string(curve, "a known ECDSA named curve");
      var Q = der.readString(asn1.Ber.BitString, true);
      Q = utils.ecNormalize(Q);
      var key = {
        type: "ecdsa",
        parts: [
          { name: "curve", data: Buffer2.from(curve) },
          { name: "Q", data: Q }
        ]
      };
      return new Key(key);
    }
    function readPkcs1ECDSAPrivate(der) {
      var version = readMPInt(der, "version");
      assert.strictEqual(version.readUInt8(0), 1);
      var d2 = der.readString(asn1.Ber.OctetString, true);
      der.readSequence(160);
      var curve = readECDSACurve(der);
      assert.string(curve, "a known elliptic curve");
      der.readSequence(161);
      var Q = der.readString(asn1.Ber.BitString, true);
      Q = utils.ecNormalize(Q);
      var key = {
        type: "ecdsa",
        parts: [
          { name: "curve", data: Buffer2.from(curve) },
          { name: "Q", data: Q },
          { name: "d", data: d2 }
        ]
      };
      return new PrivateKey(key);
    }
    function writePkcs1(der, key) {
      der.startSequence();
      switch (key.type) {
        case "rsa":
          if (PrivateKey.isPrivateKey(key))
            writePkcs1RSAPrivate(der, key);
          else
            writePkcs1RSAPublic(der, key);
          break;
        case "dsa":
          if (PrivateKey.isPrivateKey(key))
            writePkcs1DSAPrivate(der, key);
          else
            writePkcs1DSAPublic(der, key);
          break;
        case "ecdsa":
          if (PrivateKey.isPrivateKey(key))
            writePkcs1ECDSAPrivate(der, key);
          else
            writePkcs1ECDSAPublic(der, key);
          break;
        case "ed25519":
          if (PrivateKey.isPrivateKey(key))
            writePkcs1EdDSAPrivate(der, key);
          else
            writePkcs1EdDSAPublic(der, key);
          break;
        default:
          throw new Error("Unknown key algo: " + key.type);
      }
      der.endSequence();
    }
    function writePkcs1RSAPublic(der, key) {
      der.writeBuffer(key.part.n.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.e.data, asn1.Ber.Integer);
    }
    function writePkcs1RSAPrivate(der, key) {
      var ver = Buffer2.from([0]);
      der.writeBuffer(ver, asn1.Ber.Integer);
      der.writeBuffer(key.part.n.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.e.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.d.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.p.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.q.data, asn1.Ber.Integer);
      if (!key.part.dmodp || !key.part.dmodq)
        utils.addRSAMissing(key);
      der.writeBuffer(key.part.dmodp.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.dmodq.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.iqmp.data, asn1.Ber.Integer);
    }
    function writePkcs1DSAPrivate(der, key) {
      var ver = Buffer2.from([0]);
      der.writeBuffer(ver, asn1.Ber.Integer);
      der.writeBuffer(key.part.p.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.q.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.g.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.y.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.x.data, asn1.Ber.Integer);
    }
    function writePkcs1DSAPublic(der, key) {
      der.writeBuffer(key.part.y.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.p.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.q.data, asn1.Ber.Integer);
      der.writeBuffer(key.part.g.data, asn1.Ber.Integer);
    }
    function writePkcs1ECDSAPublic(der, key) {
      der.startSequence();
      der.writeOID("1.2.840.10045.2.1");
      var curve = key.part.curve.data.toString();
      var curveOid = algs.curves[curve].pkcs8oid;
      assert.string(curveOid, "a known ECDSA named curve");
      der.writeOID(curveOid);
      der.endSequence();
      var Q = utils.ecNormalize(key.part.Q.data, true);
      der.writeBuffer(Q, asn1.Ber.BitString);
    }
    function writePkcs1ECDSAPrivate(der, key) {
      var ver = Buffer2.from([1]);
      der.writeBuffer(ver, asn1.Ber.Integer);
      der.writeBuffer(key.part.d.data, asn1.Ber.OctetString);
      der.startSequence(160);
      var curve = key.part.curve.data.toString();
      var curveOid = algs.curves[curve].pkcs8oid;
      assert.string(curveOid, "a known ECDSA named curve");
      der.writeOID(curveOid);
      der.endSequence();
      der.startSequence(161);
      var Q = utils.ecNormalize(key.part.Q.data, true);
      der.writeBuffer(Q, asn1.Ber.BitString);
      der.endSequence();
    }
    function writePkcs1EdDSAPrivate(der, key) {
      var ver = Buffer2.from([1]);
      der.writeBuffer(ver, asn1.Ber.Integer);
      der.writeBuffer(key.part.k.data, asn1.Ber.OctetString);
      der.startSequence(160);
      der.writeOID("1.3.101.112");
      der.endSequence();
      der.startSequence(161);
      utils.writeBitString(der, key.part.A.data);
      der.endSequence();
    }
    function writePkcs1EdDSAPublic(der, key) {
      throw new Error("Public keys are not supported for EdDSA PKCS#1");
    }
  }
});

// node_modules/sshpk/lib/formats/rfc4253.js
var require_rfc4253 = __commonJS({
  "node_modules/sshpk/lib/formats/rfc4253.js"(exports2, module2) {
    module2.exports = {
      read: read.bind(void 0, false, void 0),
      readType: read.bind(void 0, false),
      write,
      /* semi-private api, used by sshpk-agent */
      readPartial: read.bind(void 0, true),
      /* shared with ssh format */
      readInternal: read,
      keyTypeToAlg,
      algToKeyType
    };
    var assert = require_assert();
    var Buffer2 = require_safer().Buffer;
    var algs = require_algs();
    var utils = require_utils5();
    var Key = require_key();
    var PrivateKey = require_private_key();
    var SSHBuffer = require_ssh_buffer();
    function algToKeyType(alg) {
      assert.string(alg);
      if (alg === "ssh-dss")
        return "dsa";
      else if (alg === "ssh-rsa")
        return "rsa";
      else if (alg === "ssh-ed25519")
        return "ed25519";
      else if (alg === "ssh-curve25519")
        return "curve25519";
      else if (alg.match(/^ecdsa-sha2-/))
        return "ecdsa";
      else
        throw new Error("Unknown algorithm " + alg);
    }
    function keyTypeToAlg(key) {
      assert.object(key);
      if (key.type === "dsa")
        return "ssh-dss";
      else if (key.type === "rsa")
        return "ssh-rsa";
      else if (key.type === "ed25519")
        return "ssh-ed25519";
      else if (key.type === "curve25519")
        return "ssh-curve25519";
      else if (key.type === "ecdsa")
        return "ecdsa-sha2-" + key.part.curve.data.toString();
      else
        throw new Error("Unknown key type " + key.type);
    }
    function read(partial, type, buf, options) {
      if (typeof buf === "string")
        buf = Buffer2.from(buf);
      assert.buffer(buf, "buf");
      var key = {};
      var parts = key.parts = [];
      var sshbuf = new SSHBuffer({ buffer: buf });
      var alg = sshbuf.readString();
      assert.ok(!sshbuf.atEnd(), "key must have at least one part");
      key.type = algToKeyType(alg);
      var partCount = algs.info[key.type].parts.length;
      if (type && type === "private")
        partCount = algs.privInfo[key.type].parts.length;
      while (!sshbuf.atEnd() && parts.length < partCount)
        parts.push(sshbuf.readPart());
      while (!partial && !sshbuf.atEnd())
        parts.push(sshbuf.readPart());
      assert.ok(
        parts.length >= 1,
        "key must have at least one part"
      );
      assert.ok(
        partial || sshbuf.atEnd(),
        "leftover bytes at end of key"
      );
      var Constructor = Key;
      var algInfo = algs.info[key.type];
      if (type === "private" || algInfo.parts.length !== parts.length) {
        algInfo = algs.privInfo[key.type];
        Constructor = PrivateKey;
      }
      assert.strictEqual(algInfo.parts.length, parts.length);
      if (key.type === "ecdsa") {
        var res = /^ecdsa-sha2-(.+)$/.exec(alg);
        assert.ok(res !== null);
        assert.strictEqual(res[1], parts[0].data.toString());
      }
      var normalized = true;
      for (var i = 0; i < algInfo.parts.length; ++i) {
        var p3 = parts[i];
        p3.name = algInfo.parts[i];
        if (key.type === "ed25519" && p3.name === "k")
          p3.data = p3.data.slice(0, 32);
        if (p3.name !== "curve" && algInfo.normalize !== false) {
          var nd;
          if (key.type === "ed25519") {
            nd = utils.zeroPadToLength(p3.data, 32);
          } else {
            nd = utils.mpNormalize(p3.data);
          }
          if (nd.toString("binary") !== p3.data.toString("binary")) {
            p3.data = nd;
            normalized = false;
          }
        }
      }
      if (normalized)
        key._rfc4253Cache = sshbuf.toBuffer();
      if (partial && typeof partial === "object") {
        partial.remainder = sshbuf.remainder();
        partial.consumed = sshbuf._offset;
      }
      return new Constructor(key);
    }
    function write(key, options) {
      assert.object(key);
      var alg = keyTypeToAlg(key);
      var i;
      var algInfo = algs.info[key.type];
      if (PrivateKey.isPrivateKey(key))
        algInfo = algs.privInfo[key.type];
      var parts = algInfo.parts;
      var buf = new SSHBuffer({});
      buf.writeString(alg);
      for (i = 0; i < parts.length; ++i) {
        var data = key.part[parts[i]].data;
        if (algInfo.normalize !== false) {
          if (key.type === "ed25519")
            data = utils.zeroPadToLength(data, 32);
          else
            data = utils.mpNormalize(data);
        }
        if (key.type === "ed25519" && parts[i] === "k")
          data = Buffer2.concat([data, key.part.A.data]);
        buf.writeBuffer(data);
      }
      return buf.toBuffer();
    }
  }
});

// node_modules/bcrypt-pbkdf/index.js
var require_bcrypt_pbkdf = __commonJS({
  "node_modules/bcrypt-pbkdf/index.js"(exports2, module2) {
    "use strict";
    var crypto_hash_sha512 = require_nacl_fast().lowlevel.crypto_hash;
    var BLF_J = 0;
    var Blowfish = function() {
      this.S = [
        new Uint32Array([
          3509652390,
          2564797868,
          805139163,
          3491422135,
          3101798381,
          1780907670,
          3128725573,
          4046225305,
          614570311,
          3012652279,
          134345442,
          2240740374,
          1667834072,
          1901547113,
          2757295779,
          4103290238,
          227898511,
          1921955416,
          1904987480,
          2182433518,
          2069144605,
          3260701109,
          2620446009,
          720527379,
          3318853667,
          677414384,
          3393288472,
          3101374703,
          2390351024,
          1614419982,
          1822297739,
          2954791486,
          3608508353,
          3174124327,
          2024746970,
          1432378464,
          3864339955,
          2857741204,
          1464375394,
          1676153920,
          1439316330,
          715854006,
          3033291828,
          289532110,
          2706671279,
          2087905683,
          3018724369,
          1668267050,
          732546397,
          1947742710,
          3462151702,
          2609353502,
          2950085171,
          1814351708,
          2050118529,
          680887927,
          999245976,
          1800124847,
          3300911131,
          1713906067,
          1641548236,
          4213287313,
          1216130144,
          1575780402,
          4018429277,
          3917837745,
          3693486850,
          3949271944,
          596196993,
          3549867205,
          258830323,
          2213823033,
          772490370,
          2760122372,
          1774776394,
          2652871518,
          566650946,
          4142492826,
          1728879713,
          2882767088,
          1783734482,
          3629395816,
          2517608232,
          2874225571,
          1861159788,
          326777828,
          3124490320,
          2130389656,
          2716951837,
          967770486,
          1724537150,
          2185432712,
          2364442137,
          1164943284,
          2105845187,
          998989502,
          3765401048,
          2244026483,
          1075463327,
          1455516326,
          1322494562,
          910128902,
          469688178,
          1117454909,
          936433444,
          3490320968,
          3675253459,
          1240580251,
          122909385,
          2157517691,
          634681816,
          4142456567,
          3825094682,
          3061402683,
          2540495037,
          79693498,
          3249098678,
          1084186820,
          1583128258,
          426386531,
          1761308591,
          1047286709,
          322548459,
          995290223,
          1845252383,
          2603652396,
          3431023940,
          2942221577,
          3202600964,
          3727903485,
          1712269319,
          422464435,
          3234572375,
          1170764815,
          3523960633,
          3117677531,
          1434042557,
          442511882,
          3600875718,
          1076654713,
          1738483198,
          4213154764,
          2393238008,
          3677496056,
          1014306527,
          4251020053,
          793779912,
          2902807211,
          842905082,
          4246964064,
          1395751752,
          1040244610,
          2656851899,
          3396308128,
          445077038,
          3742853595,
          3577915638,
          679411651,
          2892444358,
          2354009459,
          1767581616,
          3150600392,
          3791627101,
          3102740896,
          284835224,
          4246832056,
          1258075500,
          768725851,
          2589189241,
          3069724005,
          3532540348,
          1274779536,
          3789419226,
          2764799539,
          1660621633,
          3471099624,
          4011903706,
          913787905,
          3497959166,
          737222580,
          2514213453,
          2928710040,
          3937242737,
          1804850592,
          3499020752,
          2949064160,
          2386320175,
          2390070455,
          2415321851,
          4061277028,
          2290661394,
          2416832540,
          1336762016,
          1754252060,
          3520065937,
          3014181293,
          791618072,
          3188594551,
          3933548030,
          2332172193,
          3852520463,
          3043980520,
          413987798,
          3465142937,
          3030929376,
          4245938359,
          2093235073,
          3534596313,
          375366246,
          2157278981,
          2479649556,
          555357303,
          3870105701,
          2008414854,
          3344188149,
          4221384143,
          3956125452,
          2067696032,
          3594591187,
          2921233993,
          2428461,
          544322398,
          577241275,
          1471733935,
          610547355,
          4027169054,
          1432588573,
          1507829418,
          2025931657,
          3646575487,
          545086370,
          48609733,
          2200306550,
          1653985193,
          298326376,
          1316178497,
          3007786442,
          2064951626,
          458293330,
          2589141269,
          3591329599,
          3164325604,
          727753846,
          2179363840,
          146436021,
          1461446943,
          4069977195,
          705550613,
          3059967265,
          3887724982,
          4281599278,
          3313849956,
          1404054877,
          2845806497,
          146425753,
          1854211946
        ]),
        new Uint32Array([
          1266315497,
          3048417604,
          3681880366,
          3289982499,
          290971e4,
          1235738493,
          2632868024,
          2414719590,
          3970600049,
          1771706367,
          1449415276,
          3266420449,
          422970021,
          1963543593,
          2690192192,
          3826793022,
          1062508698,
          1531092325,
          1804592342,
          2583117782,
          2714934279,
          4024971509,
          1294809318,
          4028980673,
          1289560198,
          2221992742,
          1669523910,
          35572830,
          157838143,
          1052438473,
          1016535060,
          1802137761,
          1753167236,
          1386275462,
          3080475397,
          2857371447,
          1040679964,
          2145300060,
          2390574316,
          1461121720,
          2956646967,
          4031777805,
          4028374788,
          33600511,
          2920084762,
          1018524850,
          629373528,
          3691585981,
          3515945977,
          2091462646,
          2486323059,
          586499841,
          988145025,
          935516892,
          3367335476,
          2599673255,
          2839830854,
          265290510,
          3972581182,
          2759138881,
          3795373465,
          1005194799,
          847297441,
          406762289,
          1314163512,
          1332590856,
          1866599683,
          4127851711,
          750260880,
          613907577,
          1450815602,
          3165620655,
          3734664991,
          3650291728,
          3012275730,
          3704569646,
          1427272223,
          778793252,
          1343938022,
          2676280711,
          2052605720,
          1946737175,
          3164576444,
          3914038668,
          3967478842,
          3682934266,
          1661551462,
          3294938066,
          4011595847,
          840292616,
          3712170807,
          616741398,
          312560963,
          711312465,
          1351876610,
          322626781,
          1910503582,
          271666773,
          2175563734,
          1594956187,
          70604529,
          3617834859,
          1007753275,
          1495573769,
          4069517037,
          2549218298,
          2663038764,
          504708206,
          2263041392,
          3941167025,
          2249088522,
          1514023603,
          1998579484,
          1312622330,
          694541497,
          2582060303,
          2151582166,
          1382467621,
          776784248,
          2618340202,
          3323268794,
          2497899128,
          2784771155,
          503983604,
          4076293799,
          907881277,
          423175695,
          432175456,
          1378068232,
          4145222326,
          3954048622,
          3938656102,
          3820766613,
          2793130115,
          2977904593,
          26017576,
          3274890735,
          3194772133,
          1700274565,
          1756076034,
          4006520079,
          3677328699,
          720338349,
          1533947780,
          354530856,
          688349552,
          3973924725,
          1637815568,
          332179504,
          3949051286,
          53804574,
          2852348879,
          3044236432,
          1282449977,
          3583942155,
          3416972820,
          4006381244,
          1617046695,
          2628476075,
          3002303598,
          1686838959,
          431878346,
          2686675385,
          1700445008,
          1080580658,
          1009431731,
          832498133,
          3223435511,
          2605976345,
          2271191193,
          2516031870,
          1648197032,
          4164389018,
          2548247927,
          300782431,
          375919233,
          238389289,
          3353747414,
          2531188641,
          2019080857,
          1475708069,
          455242339,
          2609103871,
          448939670,
          3451063019,
          1395535956,
          2413381860,
          1841049896,
          1491858159,
          885456874,
          4264095073,
          4001119347,
          1565136089,
          3898914787,
          1108368660,
          540939232,
          1173283510,
          2745871338,
          3681308437,
          4207628240,
          3343053890,
          4016749493,
          1699691293,
          1103962373,
          3625875870,
          2256883143,
          3830138730,
          1031889488,
          3479347698,
          1535977030,
          4236805024,
          3251091107,
          2132092099,
          1774941330,
          1199868427,
          1452454533,
          157007616,
          2904115357,
          342012276,
          595725824,
          1480756522,
          206960106,
          497939518,
          591360097,
          863170706,
          2375253569,
          3596610801,
          1814182875,
          2094937945,
          3421402208,
          1082520231,
          3463918190,
          2785509508,
          435703966,
          3908032597,
          1641649973,
          2842273706,
          3305899714,
          1510255612,
          2148256476,
          2655287854,
          3276092548,
          4258621189,
          236887753,
          3681803219,
          274041037,
          1734335097,
          3815195456,
          3317970021,
          1899903192,
          1026095262,
          4050517792,
          356393447,
          2410691914,
          3873677099,
          3682840055
        ]),
        new Uint32Array([
          3913112168,
          2491498743,
          4132185628,
          2489919796,
          1091903735,
          1979897079,
          3170134830,
          3567386728,
          3557303409,
          857797738,
          1136121015,
          1342202287,
          507115054,
          2535736646,
          337727348,
          3213592640,
          1301675037,
          2528481711,
          1895095763,
          1721773893,
          3216771564,
          62756741,
          2142006736,
          835421444,
          2531993523,
          1442658625,
          3659876326,
          2882144922,
          676362277,
          1392781812,
          170690266,
          3921047035,
          1759253602,
          3611846912,
          1745797284,
          664899054,
          1329594018,
          3901205900,
          3045908486,
          2062866102,
          2865634940,
          3543621612,
          3464012697,
          1080764994,
          553557557,
          3656615353,
          3996768171,
          991055499,
          499776247,
          1265440854,
          648242737,
          3940784050,
          980351604,
          3713745714,
          1749149687,
          3396870395,
          4211799374,
          3640570775,
          1161844396,
          3125318951,
          1431517754,
          545492359,
          4268468663,
          3499529547,
          1437099964,
          2702547544,
          3433638243,
          2581715763,
          2787789398,
          1060185593,
          1593081372,
          2418618748,
          4260947970,
          69676912,
          2159744348,
          86519011,
          2512459080,
          3838209314,
          1220612927,
          3339683548,
          133810670,
          1090789135,
          1078426020,
          1569222167,
          845107691,
          3583754449,
          4072456591,
          1091646820,
          628848692,
          1613405280,
          3757631651,
          526609435,
          236106946,
          48312990,
          2942717905,
          3402727701,
          1797494240,
          859738849,
          992217954,
          4005476642,
          2243076622,
          3870952857,
          3732016268,
          765654824,
          3490871365,
          2511836413,
          1685915746,
          3888969200,
          1414112111,
          2273134842,
          3281911079,
          4080962846,
          172450625,
          2569994100,
          980381355,
          4109958455,
          2819808352,
          2716589560,
          2568741196,
          3681446669,
          3329971472,
          1835478071,
          660984891,
          3704678404,
          4045999559,
          3422617507,
          3040415634,
          1762651403,
          1719377915,
          3470491036,
          2693910283,
          3642056355,
          3138596744,
          1364962596,
          2073328063,
          1983633131,
          926494387,
          3423689081,
          2150032023,
          4096667949,
          1749200295,
          3328846651,
          309677260,
          2016342300,
          1779581495,
          3079819751,
          111262694,
          1274766160,
          443224088,
          298511866,
          1025883608,
          3806446537,
          1145181785,
          168956806,
          3641502830,
          3584813610,
          1689216846,
          3666258015,
          3200248200,
          1692713982,
          2646376535,
          4042768518,
          1618508792,
          1610833997,
          3523052358,
          4130873264,
          2001055236,
          3610705100,
          2202168115,
          4028541809,
          2961195399,
          1006657119,
          2006996926,
          3186142756,
          1430667929,
          3210227297,
          1314452623,
          4074634658,
          4101304120,
          2273951170,
          1399257539,
          3367210612,
          3027628629,
          1190975929,
          2062231137,
          2333990788,
          2221543033,
          2438960610,
          1181637006,
          548689776,
          2362791313,
          3372408396,
          3104550113,
          3145860560,
          296247880,
          1970579870,
          3078560182,
          3769228297,
          1714227617,
          3291629107,
          3898220290,
          166772364,
          1251581989,
          493813264,
          448347421,
          195405023,
          2709975567,
          677966185,
          3703036547,
          1463355134,
          2715995803,
          1338867538,
          1343315457,
          2802222074,
          2684532164,
          233230375,
          2599980071,
          2000651841,
          3277868038,
          1638401717,
          4028070440,
          3237316320,
          6314154,
          819756386,
          300326615,
          590932579,
          1405279636,
          3267499572,
          3150704214,
          2428286686,
          3959192993,
          3461946742,
          1862657033,
          1266418056,
          963775037,
          2089974820,
          2263052895,
          1917689273,
          448879540,
          3550394620,
          3981727096,
          150775221,
          3627908307,
          1303187396,
          508620638,
          2975983352,
          2726630617,
          1817252668,
          1876281319,
          1457606340,
          908771278,
          3720792119,
          3617206836,
          2455994898,
          1729034894,
          1080033504
        ]),
        new Uint32Array([
          976866871,
          3556439503,
          2881648439,
          1522871579,
          1555064734,
          1336096578,
          3548522304,
          2579274686,
          3574697629,
          3205460757,
          3593280638,
          3338716283,
          3079412587,
          564236357,
          2993598910,
          1781952180,
          1464380207,
          3163844217,
          3332601554,
          1699332808,
          1393555694,
          1183702653,
          3581086237,
          1288719814,
          691649499,
          2847557200,
          2895455976,
          3193889540,
          2717570544,
          1781354906,
          1676643554,
          2592534050,
          3230253752,
          1126444790,
          2770207658,
          2633158820,
          2210423226,
          2615765581,
          2414155088,
          3127139286,
          673620729,
          2805611233,
          1269405062,
          4015350505,
          3341807571,
          4149409754,
          1057255273,
          2012875353,
          2162469141,
          2276492801,
          2601117357,
          993977747,
          3918593370,
          2654263191,
          753973209,
          36408145,
          2530585658,
          25011837,
          3520020182,
          2088578344,
          530523599,
          2918365339,
          1524020338,
          1518925132,
          3760827505,
          3759777254,
          1202760957,
          3985898139,
          3906192525,
          674977740,
          4174734889,
          2031300136,
          2019492241,
          3983892565,
          4153806404,
          3822280332,
          352677332,
          2297720250,
          60907813,
          90501309,
          3286998549,
          1016092578,
          2535922412,
          2839152426,
          457141659,
          509813237,
          4120667899,
          652014361,
          1966332200,
          2975202805,
          55981186,
          2327461051,
          676427537,
          3255491064,
          2882294119,
          3433927263,
          1307055953,
          942726286,
          933058658,
          2468411793,
          3933900994,
          4215176142,
          1361170020,
          2001714738,
          2830558078,
          3274259782,
          1222529897,
          1679025792,
          2729314320,
          3714953764,
          1770335741,
          151462246,
          3013232138,
          1682292957,
          1483529935,
          471910574,
          1539241949,
          458788160,
          3436315007,
          1807016891,
          3718408830,
          978976581,
          1043663428,
          3165965781,
          1927990952,
          4200891579,
          2372276910,
          3208408903,
          3533431907,
          1412390302,
          2931980059,
          4132332400,
          1947078029,
          3881505623,
          4168226417,
          2941484381,
          1077988104,
          1320477388,
          886195818,
          18198404,
          3786409e3,
          2509781533,
          112762804,
          3463356488,
          1866414978,
          891333506,
          18488651,
          661792760,
          1628790961,
          3885187036,
          3141171499,
          876946877,
          2693282273,
          1372485963,
          791857591,
          2686433993,
          3759982718,
          3167212022,
          3472953795,
          2716379847,
          445679433,
          3561995674,
          3504004811,
          3574258232,
          54117162,
          3331405415,
          2381918588,
          3769707343,
          4154350007,
          1140177722,
          4074052095,
          668550556,
          3214352940,
          367459370,
          261225585,
          2610173221,
          4209349473,
          3468074219,
          3265815641,
          314222801,
          3066103646,
          3808782860,
          282218597,
          3406013506,
          3773591054,
          379116347,
          1285071038,
          846784868,
          2669647154,
          3771962079,
          3550491691,
          2305946142,
          453669953,
          1268987020,
          3317592352,
          3279303384,
          3744833421,
          2610507566,
          3859509063,
          266596637,
          3847019092,
          517658769,
          3462560207,
          3443424879,
          370717030,
          4247526661,
          2224018117,
          4143653529,
          4112773975,
          2788324899,
          2477274417,
          1456262402,
          2901442914,
          1517677493,
          1846949527,
          2295493580,
          3734397586,
          2176403920,
          1280348187,
          1908823572,
          3871786941,
          846861322,
          1172426758,
          3287448474,
          3383383037,
          1655181056,
          3139813346,
          901632758,
          1897031941,
          2986607138,
          3066810236,
          3447102507,
          1393639104,
          373351379,
          950779232,
          625454576,
          3124240540,
          4148612726,
          2007998917,
          544563296,
          2244738638,
          2330496472,
          2058025392,
          1291430526,
          424198748,
          50039436,
          29584100,
          3605783033,
          2429876329,
          2791104160,
          1057563949,
          3255363231,
          3075367218,
          3463963227,
          1469046755,
          985887462
        ])
      ];
      this.P = new Uint32Array([
        608135816,
        2242054355,
        320440878,
        57701188,
        2752067618,
        698298832,
        137296536,
        3964562569,
        1160258022,
        953160567,
        3193202383,
        887688300,
        3232508343,
        3380367581,
        1065670069,
        3041331479,
        2450970073,
        2306472731
      ]);
    };
    function F(S, x8, i) {
      return (S[0][x8[i + 3]] + S[1][x8[i + 2]] ^ S[2][x8[i + 1]]) + S[3][x8[i]];
    }
    Blowfish.prototype.encipher = function(x2, x8) {
      if (x8 === void 0) {
        x8 = new Uint8Array(x2.buffer);
        if (x2.byteOffset !== 0)
          x8 = x8.subarray(x2.byteOffset);
      }
      x2[0] ^= this.P[0];
      for (var i = 1; i < 16; i += 2) {
        x2[1] ^= F(this.S, x8, 0) ^ this.P[i];
        x2[0] ^= F(this.S, x8, 4) ^ this.P[i + 1];
      }
      var t = x2[0];
      x2[0] = x2[1] ^ this.P[17];
      x2[1] = t;
    };
    Blowfish.prototype.decipher = function(x2) {
      var x8 = new Uint8Array(x2.buffer);
      if (x2.byteOffset !== 0)
        x8 = x8.subarray(x2.byteOffset);
      x2[0] ^= this.P[17];
      for (var i = 16; i > 0; i -= 2) {
        x2[1] ^= F(this.S, x8, 0) ^ this.P[i];
        x2[0] ^= F(this.S, x8, 4) ^ this.P[i - 1];
      }
      var t = x2[0];
      x2[0] = x2[1] ^ this.P[0];
      x2[1] = t;
    };
    function stream2word(data, databytes) {
      var i, temp = 0;
      for (i = 0; i < 4; i++, BLF_J++) {
        if (BLF_J >= databytes)
          BLF_J = 0;
        temp = temp << 8 | data[BLF_J];
      }
      return temp;
    }
    Blowfish.prototype.expand0state = function(key, keybytes) {
      var d2 = new Uint32Array(2), i, k;
      var d8 = new Uint8Array(d2.buffer);
      for (i = 0, BLF_J = 0; i < 18; i++) {
        this.P[i] ^= stream2word(key, keybytes);
      }
      BLF_J = 0;
      for (i = 0; i < 18; i += 2) {
        this.encipher(d2, d8);
        this.P[i] = d2[0];
        this.P[i + 1] = d2[1];
      }
      for (i = 0; i < 4; i++) {
        for (k = 0; k < 256; k += 2) {
          this.encipher(d2, d8);
          this.S[i][k] = d2[0];
          this.S[i][k + 1] = d2[1];
        }
      }
    };
    Blowfish.prototype.expandstate = function(data, databytes, key, keybytes) {
      var d2 = new Uint32Array(2), i, k;
      for (i = 0, BLF_J = 0; i < 18; i++) {
        this.P[i] ^= stream2word(key, keybytes);
      }
      for (i = 0, BLF_J = 0; i < 18; i += 2) {
        d2[0] ^= stream2word(data, databytes);
        d2[1] ^= stream2word(data, databytes);
        this.encipher(d2);
        this.P[i] = d2[0];
        this.P[i + 1] = d2[1];
      }
      for (i = 0; i < 4; i++) {
        for (k = 0; k < 256; k += 2) {
          d2[0] ^= stream2word(data, databytes);
          d2[1] ^= stream2word(data, databytes);
          this.encipher(d2);
          this.S[i][k] = d2[0];
          this.S[i][k + 1] = d2[1];
        }
      }
      BLF_J = 0;
    };
    Blowfish.prototype.enc = function(data, blocks) {
      for (var i = 0; i < blocks; i++) {
        this.encipher(data.subarray(i * 2));
      }
    };
    Blowfish.prototype.dec = function(data, blocks) {
      for (var i = 0; i < blocks; i++) {
        this.decipher(data.subarray(i * 2));
      }
    };
    var BCRYPT_BLOCKS = 8;
    var BCRYPT_HASHSIZE = 32;
    function bcrypt_hash(sha2pass, sha2salt, out) {
      var state = new Blowfish(), cdata = new Uint32Array(BCRYPT_BLOCKS), i, ciphertext = new Uint8Array([
        79,
        120,
        121,
        99,
        104,
        114,
        111,
        109,
        97,
        116,
        105,
        99,
        66,
        108,
        111,
        119,
        102,
        105,
        115,
        104,
        83,
        119,
        97,
        116,
        68,
        121,
        110,
        97,
        109,
        105,
        116,
        101
      ]);
      state.expandstate(sha2salt, 64, sha2pass, 64);
      for (i = 0; i < 64; i++) {
        state.expand0state(sha2salt, 64);
        state.expand0state(sha2pass, 64);
      }
      for (i = 0; i < BCRYPT_BLOCKS; i++)
        cdata[i] = stream2word(ciphertext, ciphertext.byteLength);
      for (i = 0; i < 64; i++)
        state.enc(cdata, cdata.byteLength / 8);
      for (i = 0; i < BCRYPT_BLOCKS; i++) {
        out[4 * i + 3] = cdata[i] >>> 24;
        out[4 * i + 2] = cdata[i] >>> 16;
        out[4 * i + 1] = cdata[i] >>> 8;
        out[4 * i + 0] = cdata[i];
      }
    }
    function bcrypt_pbkdf(pass, passlen, salt, saltlen, key, keylen, rounds) {
      var sha2pass = new Uint8Array(64), sha2salt = new Uint8Array(64), out = new Uint8Array(BCRYPT_HASHSIZE), tmpout = new Uint8Array(BCRYPT_HASHSIZE), countsalt = new Uint8Array(saltlen + 4), i, j, amt, stride, dest, count, origkeylen = keylen;
      if (rounds < 1)
        return -1;
      if (passlen === 0 || saltlen === 0 || keylen === 0 || keylen > out.byteLength * out.byteLength || saltlen > 1 << 20)
        return -1;
      stride = Math.floor((keylen + out.byteLength - 1) / out.byteLength);
      amt = Math.floor((keylen + stride - 1) / stride);
      for (i = 0; i < saltlen; i++)
        countsalt[i] = salt[i];
      crypto_hash_sha512(sha2pass, pass, passlen);
      for (count = 1; keylen > 0; count++) {
        countsalt[saltlen + 0] = count >>> 24;
        countsalt[saltlen + 1] = count >>> 16;
        countsalt[saltlen + 2] = count >>> 8;
        countsalt[saltlen + 3] = count;
        crypto_hash_sha512(sha2salt, countsalt, saltlen + 4);
        bcrypt_hash(sha2pass, sha2salt, tmpout);
        for (i = out.byteLength; i--; )
          out[i] = tmpout[i];
        for (i = 1; i < rounds; i++) {
          crypto_hash_sha512(sha2salt, tmpout, tmpout.byteLength);
          bcrypt_hash(sha2pass, sha2salt, tmpout);
          for (j = 0; j < out.byteLength; j++)
            out[j] ^= tmpout[j];
        }
        amt = Math.min(amt, keylen);
        for (i = 0; i < amt; i++) {
          dest = i * stride + (count - 1);
          if (dest >= origkeylen)
            break;
          key[dest] = out[i];
        }
        keylen -= i;
      }
      return 0;
    }
    module2.exports = {
      BLOCKS: BCRYPT_BLOCKS,
      HASHSIZE: BCRYPT_HASHSIZE,
      hash: bcrypt_hash,
      pbkdf: bcrypt_pbkdf
    };
  }
});

// node_modules/sshpk/lib/formats/ssh-private.js
var require_ssh_private = __commonJS({
  "node_modules/sshpk/lib/formats/ssh-private.js"(exports2, module2) {
    module2.exports = {
      read,
      readSSHPrivate,
      write
    };
    var assert = require_assert();
    var asn1 = require_lib14();
    var Buffer2 = require_safer().Buffer;
    var algs = require_algs();
    var utils = require_utils5();
    var crypto2 = require("crypto");
    var Key = require_key();
    var PrivateKey = require_private_key();
    var pem = require_pem();
    var rfc4253 = require_rfc4253();
    var SSHBuffer = require_ssh_buffer();
    var errors = require_errors3();
    var bcrypt;
    function read(buf, options) {
      return pem.read(buf, options);
    }
    var MAGIC = "openssh-key-v1";
    function readSSHPrivate(type, buf, options) {
      buf = new SSHBuffer({ buffer: buf });
      var magic = buf.readCString();
      assert.strictEqual(magic, MAGIC, "bad magic string");
      var cipher = buf.readString();
      var kdf = buf.readString();
      var kdfOpts = buf.readBuffer();
      var nkeys = buf.readInt();
      if (nkeys !== 1) {
        throw new Error("OpenSSH-format key file contains multiple keys: this is unsupported.");
      }
      var pubKey = buf.readBuffer();
      if (type === "public") {
        assert.ok(buf.atEnd(), "excess bytes left after key");
        return rfc4253.read(pubKey);
      }
      var privKeyBlob = buf.readBuffer();
      assert.ok(buf.atEnd(), "excess bytes left after key");
      var kdfOptsBuf = new SSHBuffer({ buffer: kdfOpts });
      switch (kdf) {
        case "none":
          if (cipher !== "none") {
            throw new Error('OpenSSH-format key uses KDF "none" but specifies a cipher other than "none"');
          }
          break;
        case "bcrypt":
          var salt = kdfOptsBuf.readBuffer();
          var rounds = kdfOptsBuf.readInt();
          var cinf = utils.opensshCipherInfo(cipher);
          if (bcrypt === void 0) {
            bcrypt = require_bcrypt_pbkdf();
          }
          if (typeof options.passphrase === "string") {
            options.passphrase = Buffer2.from(
              options.passphrase,
              "utf-8"
            );
          }
          if (!Buffer2.isBuffer(options.passphrase)) {
            throw new errors.KeyEncryptedError(
              options.filename,
              "OpenSSH"
            );
          }
          var pass = new Uint8Array(options.passphrase);
          var salti = new Uint8Array(salt);
          var out = new Uint8Array(cinf.keySize + cinf.blockSize);
          var res = bcrypt.pbkdf(
            pass,
            pass.length,
            salti,
            salti.length,
            out,
            out.length,
            rounds
          );
          if (res !== 0) {
            throw new Error("bcrypt_pbkdf function returned failure, parameters invalid");
          }
          out = Buffer2.from(out);
          var ckey = out.slice(0, cinf.keySize);
          var iv = out.slice(cinf.keySize, cinf.keySize + cinf.blockSize);
          var cipherStream = crypto2.createDecipheriv(
            cinf.opensslName,
            ckey,
            iv
          );
          cipherStream.setAutoPadding(false);
          var chunk, chunks = [];
          cipherStream.once("error", function(e) {
            if (e.toString().indexOf("bad decrypt") !== -1) {
              throw new Error("Incorrect passphrase supplied, could not decrypt key");
            }
            throw e;
          });
          cipherStream.write(privKeyBlob);
          cipherStream.end();
          while ((chunk = cipherStream.read()) !== null)
            chunks.push(chunk);
          privKeyBlob = Buffer2.concat(chunks);
          break;
        default:
          throw new Error(
            'OpenSSH-format key uses unknown KDF "' + kdf + '"'
          );
      }
      buf = new SSHBuffer({ buffer: privKeyBlob });
      var checkInt1 = buf.readInt();
      var checkInt2 = buf.readInt();
      if (checkInt1 !== checkInt2) {
        throw new Error("Incorrect passphrase supplied, could not decrypt key");
      }
      var ret = {};
      var key = rfc4253.readInternal(ret, "private", buf.remainder());
      buf.skip(ret.consumed);
      var comment = buf.readString();
      key.comment = comment;
      return key;
    }
    function write(key, options) {
      var pubKey;
      if (PrivateKey.isPrivateKey(key))
        pubKey = key.toPublic();
      else
        pubKey = key;
      var cipher = "none";
      var kdf = "none";
      var kdfopts = Buffer2.alloc(0);
      var cinf = { blockSize: 8 };
      var passphrase;
      if (options !== void 0) {
        passphrase = options.passphrase;
        if (typeof passphrase === "string")
          passphrase = Buffer2.from(passphrase, "utf-8");
        if (passphrase !== void 0) {
          assert.buffer(passphrase, "options.passphrase");
          assert.optionalString(options.cipher, "options.cipher");
          cipher = options.cipher;
          if (cipher === void 0)
            cipher = "aes128-ctr";
          cinf = utils.opensshCipherInfo(cipher);
          kdf = "bcrypt";
        }
      }
      var privBuf;
      if (PrivateKey.isPrivateKey(key)) {
        privBuf = new SSHBuffer({});
        var checkInt = crypto2.randomBytes(4).readUInt32BE(0);
        privBuf.writeInt(checkInt);
        privBuf.writeInt(checkInt);
        privBuf.write(key.toBuffer("rfc4253"));
        privBuf.writeString(key.comment || "");
        var n = 1;
        while (privBuf._offset % cinf.blockSize !== 0)
          privBuf.writeChar(n++);
        privBuf = privBuf.toBuffer();
      }
      switch (kdf) {
        case "none":
          break;
        case "bcrypt":
          var salt = crypto2.randomBytes(16);
          var rounds = 16;
          var kdfssh = new SSHBuffer({});
          kdfssh.writeBuffer(salt);
          kdfssh.writeInt(rounds);
          kdfopts = kdfssh.toBuffer();
          if (bcrypt === void 0) {
            bcrypt = require_bcrypt_pbkdf();
          }
          var pass = new Uint8Array(passphrase);
          var salti = new Uint8Array(salt);
          var out = new Uint8Array(cinf.keySize + cinf.blockSize);
          var res = bcrypt.pbkdf(
            pass,
            pass.length,
            salti,
            salti.length,
            out,
            out.length,
            rounds
          );
          if (res !== 0) {
            throw new Error("bcrypt_pbkdf function returned failure, parameters invalid");
          }
          out = Buffer2.from(out);
          var ckey = out.slice(0, cinf.keySize);
          var iv = out.slice(cinf.keySize, cinf.keySize + cinf.blockSize);
          var cipherStream = crypto2.createCipheriv(
            cinf.opensslName,
            ckey,
            iv
          );
          cipherStream.setAutoPadding(false);
          var chunk, chunks = [];
          cipherStream.once("error", function(e) {
            throw e;
          });
          cipherStream.write(privBuf);
          cipherStream.end();
          while ((chunk = cipherStream.read()) !== null)
            chunks.push(chunk);
          privBuf = Buffer2.concat(chunks);
          break;
        default:
          throw new Error("Unsupported kdf " + kdf);
      }
      var buf = new SSHBuffer({});
      buf.writeCString(MAGIC);
      buf.writeString(cipher);
      buf.writeString(kdf);
      buf.writeBuffer(kdfopts);
      buf.writeInt(1);
      buf.writeBuffer(pubKey.toBuffer("rfc4253"));
      if (privBuf)
        buf.writeBuffer(privBuf);
      buf = buf.toBuffer();
      var header;
      if (PrivateKey.isPrivateKey(key))
        header = "OPENSSH PRIVATE KEY";
      else
        header = "OPENSSH PUBLIC KEY";
      var tmp = buf.toString("base64");
      var len = tmp.length + tmp.length / 70 + 18 + 16 + header.length * 2 + 10;
      buf = Buffer2.alloc(len);
      var o2 = 0;
      o2 += buf.write("-----BEGIN " + header + "-----\n", o2);
      for (var i = 0; i < tmp.length; ) {
        var limit = i + 70;
        if (limit > tmp.length)
          limit = tmp.length;
        o2 += buf.write(tmp.slice(i, limit), o2);
        buf[o2++] = 10;
        i = limit;
      }
      o2 += buf.write("-----END " + header + "-----\n", o2);
      return buf.slice(0, o2);
    }
  }
});

// node_modules/sshpk/lib/formats/pem.js
var require_pem = __commonJS({
  "node_modules/sshpk/lib/formats/pem.js"(exports2, module2) {
    module2.exports = {
      read,
      write
    };
    var assert = require_assert();
    var asn1 = require_lib14();
    var crypto2 = require("crypto");
    var Buffer2 = require_safer().Buffer;
    var algs = require_algs();
    var utils = require_utils5();
    var Key = require_key();
    var PrivateKey = require_private_key();
    var pkcs1 = require_pkcs1();
    var pkcs8 = require_pkcs8();
    var sshpriv = require_ssh_private();
    var rfc4253 = require_rfc4253();
    var errors = require_errors3();
    var OID_PBES2 = "1.2.840.113549.1.5.13";
    var OID_PBKDF2 = "1.2.840.113549.1.5.12";
    var OID_TO_CIPHER = {
      "1.2.840.113549.3.7": "3des-cbc",
      "2.16.840.1.101.3.4.1.2": "aes128-cbc",
      "2.16.840.1.101.3.4.1.42": "aes256-cbc"
    };
    var CIPHER_TO_OID = {};
    Object.keys(OID_TO_CIPHER).forEach(function(k) {
      CIPHER_TO_OID[OID_TO_CIPHER[k]] = k;
    });
    var OID_TO_HASH = {
      "1.2.840.113549.2.7": "sha1",
      "1.2.840.113549.2.9": "sha256",
      "1.2.840.113549.2.11": "sha512"
    };
    var HASH_TO_OID = {};
    Object.keys(OID_TO_HASH).forEach(function(k) {
      HASH_TO_OID[OID_TO_HASH[k]] = k;
    });
    function read(buf, options, forceType) {
      var input = buf;
      if (typeof buf !== "string") {
        assert.buffer(buf, "buf");
        buf = buf.toString("ascii");
      }
      var lines = buf.trim().split(/[\r\n]+/g);
      var m2;
      var si = -1;
      while (!m2 && si < lines.length) {
        m2 = lines[++si].match(
          /*JSSTYLED*/
          /[-]+[ ]*BEGIN ([A-Z0-9][A-Za-z0-9]+ )?(PUBLIC|PRIVATE) KEY[ ]*[-]+/
        );
      }
      assert.ok(m2, "invalid PEM header");
      var m22;
      var ei = lines.length;
      while (!m22 && ei > 0) {
        m22 = lines[--ei].match(
          /*JSSTYLED*/
          /[-]+[ ]*END ([A-Z0-9][A-Za-z0-9]+ )?(PUBLIC|PRIVATE) KEY[ ]*[-]+/
        );
      }
      assert.ok(m22, "invalid PEM footer");
      assert.equal(m2[2], m22[2]);
      var type = m2[2].toLowerCase();
      var alg;
      if (m2[1]) {
        assert.equal(m2[1], m22[1], "PEM header and footer mismatch");
        alg = m2[1].trim();
      }
      lines = lines.slice(si, ei + 1);
      var headers = {};
      while (true) {
        lines = lines.slice(1);
        m2 = lines[0].match(
          /*JSSTYLED*/
          /^([A-Za-z0-9-]+): (.+)$/
        );
        if (!m2)
          break;
        headers[m2[1].toLowerCase()] = m2[2];
      }
      lines = lines.slice(0, -1).join("");
      buf = Buffer2.from(lines, "base64");
      var cipher, key, iv;
      if (headers["proc-type"]) {
        var parts = headers["proc-type"].split(",");
        if (parts[0] === "4" && parts[1] === "ENCRYPTED") {
          if (typeof options.passphrase === "string") {
            options.passphrase = Buffer2.from(
              options.passphrase,
              "utf-8"
            );
          }
          if (!Buffer2.isBuffer(options.passphrase)) {
            throw new errors.KeyEncryptedError(
              options.filename,
              "PEM"
            );
          } else {
            parts = headers["dek-info"].split(",");
            assert.ok(parts.length === 2);
            cipher = parts[0].toLowerCase();
            iv = Buffer2.from(parts[1], "hex");
            key = utils.opensslKeyDeriv(
              cipher,
              iv,
              options.passphrase,
              1
            ).key;
          }
        }
      }
      if (alg && alg.toLowerCase() === "encrypted") {
        var eder = new asn1.BerReader(buf);
        var pbesEnd;
        eder.readSequence();
        eder.readSequence();
        pbesEnd = eder.offset + eder.length;
        var method = eder.readOID();
        if (method !== OID_PBES2) {
          throw new Error("Unsupported PEM/PKCS8 encryption scheme: " + method);
        }
        eder.readSequence();
        eder.readSequence();
        var kdfEnd = eder.offset + eder.length;
        var kdfOid = eder.readOID();
        if (kdfOid !== OID_PBKDF2)
          throw new Error("Unsupported PBES2 KDF: " + kdfOid);
        eder.readSequence();
        var salt = eder.readString(asn1.Ber.OctetString, true);
        var iterations = eder.readInt();
        var hashAlg = "sha1";
        if (eder.offset < kdfEnd) {
          eder.readSequence();
          var hashAlgOid = eder.readOID();
          hashAlg = OID_TO_HASH[hashAlgOid];
          if (hashAlg === void 0) {
            throw new Error("Unsupported PBKDF2 hash: " + hashAlgOid);
          }
        }
        eder._offset = kdfEnd;
        eder.readSequence();
        var cipherOid = eder.readOID();
        cipher = OID_TO_CIPHER[cipherOid];
        if (cipher === void 0) {
          throw new Error("Unsupported PBES2 cipher: " + cipherOid);
        }
        iv = eder.readString(asn1.Ber.OctetString, true);
        eder._offset = pbesEnd;
        buf = eder.readString(asn1.Ber.OctetString, true);
        if (typeof options.passphrase === "string") {
          options.passphrase = Buffer2.from(
            options.passphrase,
            "utf-8"
          );
        }
        if (!Buffer2.isBuffer(options.passphrase)) {
          throw new errors.KeyEncryptedError(
            options.filename,
            "PEM"
          );
        }
        var cinfo = utils.opensshCipherInfo(cipher);
        cipher = cinfo.opensslName;
        key = utils.pbkdf2(
          hashAlg,
          salt,
          iterations,
          cinfo.keySize,
          options.passphrase
        );
        alg = void 0;
      }
      if (cipher && key && iv) {
        var cipherStream = crypto2.createDecipheriv(cipher, key, iv);
        var chunk, chunks = [];
        cipherStream.once("error", function(e) {
          if (e.toString().indexOf("bad decrypt") !== -1) {
            throw new Error("Incorrect passphrase supplied, could not decrypt key");
          }
          throw e;
        });
        cipherStream.write(buf);
        cipherStream.end();
        while ((chunk = cipherStream.read()) !== null)
          chunks.push(chunk);
        buf = Buffer2.concat(chunks);
      }
      if (alg && alg.toLowerCase() === "openssh")
        return sshpriv.readSSHPrivate(type, buf, options);
      if (alg && alg.toLowerCase() === "ssh2")
        return rfc4253.readType(type, buf, options);
      var der = new asn1.BerReader(buf);
      der.originalInput = input;
      der.readSequence();
      if (alg) {
        if (forceType)
          assert.strictEqual(forceType, "pkcs1");
        return pkcs1.readPkcs1(alg, type, der);
      } else {
        if (forceType)
          assert.strictEqual(forceType, "pkcs8");
        return pkcs8.readPkcs8(alg, type, der);
      }
    }
    function write(key, options, type) {
      assert.object(key);
      var alg = {
        "ecdsa": "EC",
        "rsa": "RSA",
        "dsa": "DSA",
        "ed25519": "EdDSA"
      }[key.type];
      var header;
      var der = new asn1.BerWriter();
      if (PrivateKey.isPrivateKey(key)) {
        if (type && type === "pkcs8") {
          header = "PRIVATE KEY";
          pkcs8.writePkcs8(der, key);
        } else {
          if (type)
            assert.strictEqual(type, "pkcs1");
          header = alg + " PRIVATE KEY";
          pkcs1.writePkcs1(der, key);
        }
      } else if (Key.isKey(key)) {
        if (type && type === "pkcs1") {
          header = alg + " PUBLIC KEY";
          pkcs1.writePkcs1(der, key);
        } else {
          if (type)
            assert.strictEqual(type, "pkcs8");
          header = "PUBLIC KEY";
          pkcs8.writePkcs8(der, key);
        }
      } else {
        throw new Error("key is not a Key or PrivateKey");
      }
      var tmp = der.buffer.toString("base64");
      var len = tmp.length + tmp.length / 64 + 18 + 16 + header.length * 2 + 10;
      var buf = Buffer2.alloc(len);
      var o2 = 0;
      o2 += buf.write("-----BEGIN " + header + "-----\n", o2);
      for (var i = 0; i < tmp.length; ) {
        var limit = i + 64;
        if (limit > tmp.length)
          limit = tmp.length;
        o2 += buf.write(tmp.slice(i, limit), o2);
        buf[o2++] = 10;
        i = limit;
      }
      o2 += buf.write("-----END " + header + "-----\n", o2);
      return buf.slice(0, o2);
    }
  }
});

// node_modules/sshpk/lib/formats/ssh.js
var require_ssh = __commonJS({
  "node_modules/sshpk/lib/formats/ssh.js"(exports2, module2) {
    module2.exports = {
      read,
      write
    };
    var assert = require_assert();
    var Buffer2 = require_safer().Buffer;
    var rfc4253 = require_rfc4253();
    var utils = require_utils5();
    var Key = require_key();
    var PrivateKey = require_private_key();
    var sshpriv = require_ssh_private();
    var SSHKEY_RE = /^([a-z0-9-]+)[ \t]+([a-zA-Z0-9+\/]+[=]*)([ \t]+([^ \t][^\n]*[\n]*)?)?$/;
    var SSHKEY_RE2 = /^([a-z0-9-]+)[ \t\n]+([a-zA-Z0-9+\/][a-zA-Z0-9+\/ \t\n=]*)([^a-zA-Z0-9+\/ \t\n=].*)?$/;
    function read(buf, options) {
      if (typeof buf !== "string") {
        assert.buffer(buf, "buf");
        buf = buf.toString("ascii");
      }
      var trimmed = buf.trim().replace(/[\\\r]/g, "");
      var m2 = trimmed.match(SSHKEY_RE);
      if (!m2)
        m2 = trimmed.match(SSHKEY_RE2);
      assert.ok(m2, "key must match regex");
      var type = rfc4253.algToKeyType(m2[1]);
      var kbuf = Buffer2.from(m2[2], "base64");
      var key;
      var ret = {};
      if (m2[4]) {
        try {
          key = rfc4253.read(kbuf);
        } catch (e) {
          m2 = trimmed.match(SSHKEY_RE2);
          assert.ok(m2, "key must match regex");
          kbuf = Buffer2.from(m2[2], "base64");
          key = rfc4253.readInternal(ret, "public", kbuf);
        }
      } else {
        key = rfc4253.readInternal(ret, "public", kbuf);
      }
      assert.strictEqual(type, key.type);
      if (m2[4] && m2[4].length > 0) {
        key.comment = m2[4];
      } else if (ret.consumed) {
        var data = m2[2] + (m2[3] ? m2[3] : "");
        var realOffset = Math.ceil(ret.consumed / 3) * 4;
        data = data.slice(0, realOffset - 2).replace(/[^a-zA-Z0-9+\/=]/g, "") + data.slice(realOffset - 2);
        var padding = ret.consumed % 3;
        if (padding > 0 && data.slice(realOffset - 1, realOffset) !== "=")
          realOffset--;
        while (data.slice(realOffset, realOffset + 1) === "=")
          realOffset++;
        var trailer = data.slice(realOffset);
        trailer = trailer.replace(/[\r\n]/g, " ").replace(/^\s+/, "");
        if (trailer.match(/^[a-zA-Z0-9]/))
          key.comment = trailer;
      }
      return key;
    }
    function write(key, options) {
      assert.object(key);
      if (!Key.isKey(key))
        throw new Error("Must be a public key");
      var parts = [];
      var alg = rfc4253.keyTypeToAlg(key);
      parts.push(alg);
      var buf = rfc4253.write(key);
      parts.push(buf.toString("base64"));
      if (key.comment)
        parts.push(key.comment);
      return Buffer2.from(parts.join(" "));
    }
  }
});

// node_modules/sshpk/lib/formats/dnssec.js
var require_dnssec = __commonJS({
  "node_modules/sshpk/lib/formats/dnssec.js"(exports2, module2) {
    module2.exports = {
      read,
      write
    };
    var assert = require_assert();
    var Buffer2 = require_safer().Buffer;
    var Key = require_key();
    var PrivateKey = require_private_key();
    var utils = require_utils5();
    var SSHBuffer = require_ssh_buffer();
    var Dhe = require_dhe();
    var supportedAlgos = {
      "rsa-sha1": 5,
      "rsa-sha256": 8,
      "rsa-sha512": 10,
      "ecdsa-p256-sha256": 13,
      "ecdsa-p384-sha384": 14
      /*
       * ed25519 is hypothetically supported with id 15
       * but the common tools available don't appear to be
       * capable of generating/using ed25519 keys
       */
    };
    var supportedAlgosById = {};
    Object.keys(supportedAlgos).forEach(function(k) {
      supportedAlgosById[supportedAlgos[k]] = k.toUpperCase();
    });
    function read(buf, options) {
      if (typeof buf !== "string") {
        assert.buffer(buf, "buf");
        buf = buf.toString("ascii");
      }
      var lines = buf.split("\n");
      if (lines[0].match(/^Private-key-format\: v1/)) {
        var algElems = lines[1].split(" ");
        var algoNum = parseInt(algElems[1], 10);
        var algoName = algElems[2];
        if (!supportedAlgosById[algoNum])
          throw new Error("Unsupported algorithm: " + algoName);
        return readDNSSECPrivateKey(algoNum, lines.slice(2));
      }
      var line = 0;
      while (lines[line].match(/^\;/))
        line++;
      if ((lines[line].match(/\. IN KEY /) || lines[line].match(/\. IN DNSKEY /)) && lines[line + 1].length === 0) {
        return readRFC3110(lines[line]);
      }
      throw new Error("Cannot parse dnssec key");
    }
    function readRFC3110(keyString) {
      var elems = keyString.split(" ");
      var algorithm = parseInt(elems[5], 10);
      if (!supportedAlgosById[algorithm])
        throw new Error("Unsupported algorithm: " + algorithm);
      var base64key = elems.slice(6, elems.length).join();
      var keyBuffer = Buffer2.from(base64key, "base64");
      if (supportedAlgosById[algorithm].match(/^RSA-/)) {
        var publicExponentLen = keyBuffer.readUInt8(0);
        if (publicExponentLen != 3 && publicExponentLen != 1)
          throw new Error("Cannot parse dnssec key: unsupported exponent length");
        var publicExponent = keyBuffer.slice(1, publicExponentLen + 1);
        publicExponent = utils.mpNormalize(publicExponent);
        var modulus = keyBuffer.slice(1 + publicExponentLen);
        modulus = utils.mpNormalize(modulus);
        var rsaKey = {
          type: "rsa",
          parts: []
        };
        rsaKey.parts.push({ name: "e", data: publicExponent });
        rsaKey.parts.push({ name: "n", data: modulus });
        return new Key(rsaKey);
      }
      if (supportedAlgosById[algorithm] === "ECDSA-P384-SHA384" || supportedAlgosById[algorithm] === "ECDSA-P256-SHA256") {
        var curve = "nistp384";
        var size = 384;
        if (supportedAlgosById[algorithm].match(/^ECDSA-P256-SHA256/)) {
          curve = "nistp256";
          size = 256;
        }
        var ecdsaKey = {
          type: "ecdsa",
          curve,
          size,
          parts: [
            { name: "curve", data: Buffer2.from(curve) },
            { name: "Q", data: utils.ecNormalize(keyBuffer) }
          ]
        };
        return new Key(ecdsaKey);
      }
      throw new Error("Unsupported algorithm: " + supportedAlgosById[algorithm]);
    }
    function elementToBuf(e) {
      return Buffer2.from(e.split(" ")[1], "base64");
    }
    function readDNSSECRSAPrivateKey(elements) {
      var rsaParams = {};
      elements.forEach(function(element) {
        if (element.split(" ")[0] === "Modulus:")
          rsaParams["n"] = elementToBuf(element);
        else if (element.split(" ")[0] === "PublicExponent:")
          rsaParams["e"] = elementToBuf(element);
        else if (element.split(" ")[0] === "PrivateExponent:")
          rsaParams["d"] = elementToBuf(element);
        else if (element.split(" ")[0] === "Prime1:")
          rsaParams["p"] = elementToBuf(element);
        else if (element.split(" ")[0] === "Prime2:")
          rsaParams["q"] = elementToBuf(element);
        else if (element.split(" ")[0] === "Exponent1:")
          rsaParams["dmodp"] = elementToBuf(element);
        else if (element.split(" ")[0] === "Exponent2:")
          rsaParams["dmodq"] = elementToBuf(element);
        else if (element.split(" ")[0] === "Coefficient:")
          rsaParams["iqmp"] = elementToBuf(element);
      });
      var key = {
        type: "rsa",
        parts: [
          { name: "e", data: utils.mpNormalize(rsaParams["e"]) },
          { name: "n", data: utils.mpNormalize(rsaParams["n"]) },
          { name: "d", data: utils.mpNormalize(rsaParams["d"]) },
          { name: "p", data: utils.mpNormalize(rsaParams["p"]) },
          { name: "q", data: utils.mpNormalize(rsaParams["q"]) },
          {
            name: "dmodp",
            data: utils.mpNormalize(rsaParams["dmodp"])
          },
          {
            name: "dmodq",
            data: utils.mpNormalize(rsaParams["dmodq"])
          },
          {
            name: "iqmp",
            data: utils.mpNormalize(rsaParams["iqmp"])
          }
        ]
      };
      return new PrivateKey(key);
    }
    function readDNSSECPrivateKey(alg, elements) {
      if (supportedAlgosById[alg].match(/^RSA-/)) {
        return readDNSSECRSAPrivateKey(elements);
      }
      if (supportedAlgosById[alg] === "ECDSA-P384-SHA384" || supportedAlgosById[alg] === "ECDSA-P256-SHA256") {
        var d2 = Buffer2.from(elements[0].split(" ")[1], "base64");
        var curve = "nistp384";
        var size = 384;
        if (supportedAlgosById[alg] === "ECDSA-P256-SHA256") {
          curve = "nistp256";
          size = 256;
        }
        var publicKey = utils.publicFromPrivateECDSA(curve, d2);
        var Q = publicKey.part["Q"].data;
        var ecdsaKey = {
          type: "ecdsa",
          curve,
          size,
          parts: [
            { name: "curve", data: Buffer2.from(curve) },
            { name: "d", data: d2 },
            { name: "Q", data: Q }
          ]
        };
        return new PrivateKey(ecdsaKey);
      }
      throw new Error("Unsupported algorithm: " + supportedAlgosById[alg]);
    }
    function dnssecTimestamp(date) {
      var year = date.getFullYear() + "";
      var month = date.getMonth() + 1;
      var timestampStr = year + month + date.getUTCDate();
      timestampStr += "" + date.getUTCHours() + date.getUTCMinutes();
      timestampStr += date.getUTCSeconds();
      return timestampStr;
    }
    function rsaAlgFromOptions(opts) {
      if (!opts || !opts.hashAlgo || opts.hashAlgo === "sha1")
        return "5 (RSASHA1)";
      else if (opts.hashAlgo === "sha256")
        return "8 (RSASHA256)";
      else if (opts.hashAlgo === "sha512")
        return "10 (RSASHA512)";
      else
        throw new Error("Unknown or unsupported hash: " + opts.hashAlgo);
    }
    function writeRSA(key, options) {
      if (!key.part.dmodp || !key.part.dmodq) {
        utils.addRSAMissing(key);
      }
      var out = "";
      out += "Private-key-format: v1.3\n";
      out += "Algorithm: " + rsaAlgFromOptions(options) + "\n";
      var n = utils.mpDenormalize(key.part["n"].data);
      out += "Modulus: " + n.toString("base64") + "\n";
      var e = utils.mpDenormalize(key.part["e"].data);
      out += "PublicExponent: " + e.toString("base64") + "\n";
      var d2 = utils.mpDenormalize(key.part["d"].data);
      out += "PrivateExponent: " + d2.toString("base64") + "\n";
      var p3 = utils.mpDenormalize(key.part["p"].data);
      out += "Prime1: " + p3.toString("base64") + "\n";
      var q2 = utils.mpDenormalize(key.part["q"].data);
      out += "Prime2: " + q2.toString("base64") + "\n";
      var dmodp = utils.mpDenormalize(key.part["dmodp"].data);
      out += "Exponent1: " + dmodp.toString("base64") + "\n";
      var dmodq = utils.mpDenormalize(key.part["dmodq"].data);
      out += "Exponent2: " + dmodq.toString("base64") + "\n";
      var iqmp = utils.mpDenormalize(key.part["iqmp"].data);
      out += "Coefficient: " + iqmp.toString("base64") + "\n";
      var timestamp = /* @__PURE__ */ new Date();
      out += "Created: " + dnssecTimestamp(timestamp) + "\n";
      out += "Publish: " + dnssecTimestamp(timestamp) + "\n";
      out += "Activate: " + dnssecTimestamp(timestamp) + "\n";
      return Buffer2.from(out, "ascii");
    }
    function writeECDSA(key, options) {
      var out = "";
      out += "Private-key-format: v1.3\n";
      if (key.curve === "nistp256") {
        out += "Algorithm: 13 (ECDSAP256SHA256)\n";
      } else if (key.curve === "nistp384") {
        out += "Algorithm: 14 (ECDSAP384SHA384)\n";
      } else {
        throw new Error("Unsupported curve");
      }
      var base64Key = key.part["d"].data.toString("base64");
      out += "PrivateKey: " + base64Key + "\n";
      var timestamp = /* @__PURE__ */ new Date();
      out += "Created: " + dnssecTimestamp(timestamp) + "\n";
      out += "Publish: " + dnssecTimestamp(timestamp) + "\n";
      out += "Activate: " + dnssecTimestamp(timestamp) + "\n";
      return Buffer2.from(out, "ascii");
    }
    function write(key, options) {
      if (PrivateKey.isPrivateKey(key)) {
        if (key.type === "rsa") {
          return writeRSA(key, options);
        } else if (key.type === "ecdsa") {
          return writeECDSA(key, options);
        } else {
          throw new Error("Unsupported algorithm: " + key.type);
        }
      } else if (Key.isKey(key)) {
        throw new Error('Format "dnssec" only supports writing private keys');
      } else {
        throw new Error("key is not a Key or PrivateKey");
      }
    }
  }
});

// node_modules/sshpk/lib/formats/putty.js
var require_putty = __commonJS({
  "node_modules/sshpk/lib/formats/putty.js"(exports2, module2) {
    module2.exports = {
      read,
      write
    };
    var assert = require_assert();
    var Buffer2 = require_safer().Buffer;
    var rfc4253 = require_rfc4253();
    var Key = require_key();
    var SSHBuffer = require_ssh_buffer();
    var crypto2 = require("crypto");
    var PrivateKey = require_private_key();
    var errors = require_errors3();
    function read(buf, options) {
      var lines = buf.toString("ascii").split(/[\r\n]+/);
      var found = false;
      var parts;
      var si = 0;
      var formatVersion;
      while (si < lines.length) {
        parts = splitHeader(lines[si++]);
        if (parts) {
          formatVersion = {
            "putty-user-key-file-2": 2,
            "putty-user-key-file-3": 3
          }[parts[0].toLowerCase()];
          if (formatVersion) {
            found = true;
            break;
          }
        }
      }
      if (!found) {
        throw new Error("No PuTTY format first line found");
      }
      var alg = parts[1];
      parts = splitHeader(lines[si++]);
      assert.equal(parts[0].toLowerCase(), "encryption");
      var encryption = parts[1];
      parts = splitHeader(lines[si++]);
      assert.equal(parts[0].toLowerCase(), "comment");
      var comment = parts[1];
      parts = splitHeader(lines[si++]);
      assert.equal(parts[0].toLowerCase(), "public-lines");
      var publicLines = parseInt(parts[1], 10);
      if (!isFinite(publicLines) || publicLines < 0 || publicLines > lines.length) {
        throw new Error("Invalid public-lines count");
      }
      var publicBuf = Buffer2.from(
        lines.slice(si, si + publicLines).join(""),
        "base64"
      );
      var keyType = rfc4253.algToKeyType(alg);
      var key = rfc4253.read(publicBuf);
      if (key.type !== keyType) {
        throw new Error("Outer key algorithm mismatch");
      }
      si += publicLines;
      if (lines[si]) {
        parts = splitHeader(lines[si++]);
        assert.equal(parts[0].toLowerCase(), "private-lines");
        var privateLines = parseInt(parts[1], 10);
        if (!isFinite(privateLines) || privateLines < 0 || privateLines > lines.length) {
          throw new Error("Invalid private-lines count");
        }
        var privateBuf = Buffer2.from(
          lines.slice(si, si + privateLines).join(""),
          "base64"
        );
        if (encryption !== "none" && formatVersion === 3) {
          throw new Error("Encrypted keys arenot supported for PuTTY format version 3");
        }
        if (encryption === "aes256-cbc") {
          if (!options.passphrase) {
            throw new errors.KeyEncryptedError(
              options.filename,
              "PEM"
            );
          }
          var iv = Buffer2.alloc(16, 0);
          var decipher = crypto2.createDecipheriv(
            "aes-256-cbc",
            derivePPK2EncryptionKey(options.passphrase),
            iv
          );
          decipher.setAutoPadding(false);
          privateBuf = Buffer2.concat([
            decipher.update(privateBuf),
            decipher.final()
          ]);
        }
        key = new PrivateKey(key);
        if (key.type !== keyType) {
          throw new Error("Outer key algorithm mismatch");
        }
        var sshbuf = new SSHBuffer({ buffer: privateBuf });
        var privateKeyParts;
        if (alg === "ssh-dss") {
          privateKeyParts = [{
            name: "x",
            data: sshbuf.readBuffer()
          }];
        } else if (alg === "ssh-rsa") {
          privateKeyParts = [
            { name: "d", data: sshbuf.readBuffer() },
            { name: "p", data: sshbuf.readBuffer() },
            { name: "q", data: sshbuf.readBuffer() },
            { name: "iqmp", data: sshbuf.readBuffer() }
          ];
        } else if (alg.match(/^ecdsa-sha2-nistp/)) {
          privateKeyParts = [{
            name: "d",
            data: sshbuf.readBuffer()
          }];
        } else if (alg === "ssh-ed25519") {
          privateKeyParts = [{
            name: "k",
            data: sshbuf.readBuffer()
          }];
        } else {
          throw new Error("Unsupported PPK key type: " + alg);
        }
        key = new PrivateKey({
          type: key.type,
          parts: key.parts.concat(privateKeyParts)
        });
      }
      key.comment = comment;
      return key;
    }
    function derivePPK2EncryptionKey(passphrase) {
      var hash1 = crypto2.createHash("sha1").update(Buffer2.concat([
        Buffer2.from([0, 0, 0, 0]),
        Buffer2.from(passphrase)
      ])).digest();
      var hash2 = crypto2.createHash("sha1").update(Buffer2.concat([
        Buffer2.from([0, 0, 0, 1]),
        Buffer2.from(passphrase)
      ])).digest();
      return Buffer2.concat([hash1, hash2]).slice(0, 32);
    }
    function splitHeader(line) {
      var idx = line.indexOf(":");
      if (idx === -1)
        return null;
      var header = line.slice(0, idx);
      ++idx;
      while (line[idx] === " ")
        ++idx;
      var rest = line.slice(idx);
      return [header, rest];
    }
    function write(key, options) {
      assert.object(key);
      if (!Key.isKey(key))
        throw new Error("Must be a public key");
      var alg = rfc4253.keyTypeToAlg(key);
      var buf = rfc4253.write(key);
      var comment = key.comment || "";
      var b64 = buf.toString("base64");
      var lines = wrap(b64, 64);
      lines.unshift("Public-Lines: " + lines.length);
      lines.unshift("Comment: " + comment);
      lines.unshift("Encryption: none");
      lines.unshift("PuTTY-User-Key-File-2: " + alg);
      return Buffer2.from(lines.join("\n") + "\n");
    }
    function wrap(txt, len) {
      var lines = [];
      var pos = 0;
      while (pos < txt.length) {
        lines.push(txt.slice(pos, pos + 64));
        pos += 64;
      }
      return lines;
    }
  }
});

// node_modules/sshpk/lib/formats/auto.js
var require_auto = __commonJS({
  "node_modules/sshpk/lib/formats/auto.js"(exports2, module2) {
    module2.exports = {
      read,
      write
    };
    var assert = require_assert();
    var Buffer2 = require_safer().Buffer;
    var utils = require_utils5();
    var Key = require_key();
    var PrivateKey = require_private_key();
    var pem = require_pem();
    var ssh = require_ssh();
    var rfc4253 = require_rfc4253();
    var dnssec = require_dnssec();
    var putty = require_putty();
    var DNSSEC_PRIVKEY_HEADER_PREFIX = "Private-key-format: v1";
    function read(buf, options) {
      if (typeof buf === "string") {
        if (buf.trim().match(/^[-]+[ ]*BEGIN/))
          return pem.read(buf, options);
        if (buf.match(/^\s*ssh-[a-z]/))
          return ssh.read(buf, options);
        if (buf.match(/^\s*ecdsa-/))
          return ssh.read(buf, options);
        if (buf.match(/^putty-user-key-file-2:/i))
          return putty.read(buf, options);
        if (findDNSSECHeader(buf))
          return dnssec.read(buf, options);
        buf = Buffer2.from(buf, "binary");
      } else {
        assert.buffer(buf);
        if (findPEMHeader(buf))
          return pem.read(buf, options);
        if (findSSHHeader(buf))
          return ssh.read(buf, options);
        if (findPuTTYHeader(buf))
          return putty.read(buf, options);
        if (findDNSSECHeader(buf))
          return dnssec.read(buf, options);
      }
      if (buf.readUInt32BE(0) < buf.length)
        return rfc4253.read(buf, options);
      throw new Error("Failed to auto-detect format of key");
    }
    function findPuTTYHeader(buf) {
      var offset = 0;
      while (offset < buf.length && (buf[offset] === 32 || buf[offset] === 10 || buf[offset] === 9))
        ++offset;
      if (offset + 22 <= buf.length && buf.slice(offset, offset + 22).toString("ascii").toLowerCase() === "putty-user-key-file-2:")
        return true;
      return false;
    }
    function findSSHHeader(buf) {
      var offset = 0;
      while (offset < buf.length && (buf[offset] === 32 || buf[offset] === 10 || buf[offset] === 9))
        ++offset;
      if (offset + 4 <= buf.length && buf.slice(offset, offset + 4).toString("ascii") === "ssh-")
        return true;
      if (offset + 6 <= buf.length && buf.slice(offset, offset + 6).toString("ascii") === "ecdsa-")
        return true;
      return false;
    }
    function findPEMHeader(buf) {
      var offset = 0;
      while (offset < buf.length && (buf[offset] === 32 || buf[offset] === 10))
        ++offset;
      if (buf[offset] !== 45)
        return false;
      while (offset < buf.length && buf[offset] === 45)
        ++offset;
      while (offset < buf.length && buf[offset] === 32)
        ++offset;
      if (offset + 5 > buf.length || buf.slice(offset, offset + 5).toString("ascii") !== "BEGIN")
        return false;
      return true;
    }
    function findDNSSECHeader(buf) {
      if (buf.length <= DNSSEC_PRIVKEY_HEADER_PREFIX.length)
        return false;
      var headerCheck = buf.slice(0, DNSSEC_PRIVKEY_HEADER_PREFIX.length);
      if (headerCheck.toString("ascii") === DNSSEC_PRIVKEY_HEADER_PREFIX)
        return true;
      if (typeof buf !== "string") {
        buf = buf.toString("ascii");
      }
      var lines = buf.split("\n");
      var line = 0;
      while (lines[line].match(/^\;/))
        line++;
      if (lines[line].toString("ascii").match(/\. IN KEY /))
        return true;
      if (lines[line].toString("ascii").match(/\. IN DNSKEY /))
        return true;
      return false;
    }
    function write(key, options) {
      throw new Error('"auto" format cannot be used for writing');
    }
  }
});

// node_modules/sshpk/lib/private-key.js
var require_private_key = __commonJS({
  "node_modules/sshpk/lib/private-key.js"(exports2, module2) {
    module2.exports = PrivateKey;
    var assert = require_assert();
    var Buffer2 = require_safer().Buffer;
    var algs = require_algs();
    var crypto2 = require("crypto");
    var Fingerprint = require_fingerprint();
    var Signature = require_signature();
    var errs = require_errors3();
    var util = require("util");
    var utils = require_utils5();
    var dhe = require_dhe();
    var generateECDSA = dhe.generateECDSA;
    var generateED25519 = dhe.generateED25519;
    var edCompat = require_ed_compat();
    var nacl = require_nacl_fast();
    var Key = require_key();
    var InvalidAlgorithmError = errs.InvalidAlgorithmError;
    var KeyParseError = errs.KeyParseError;
    var KeyEncryptedError = errs.KeyEncryptedError;
    var formats = {};
    formats["auto"] = require_auto();
    formats["pem"] = require_pem();
    formats["pkcs1"] = require_pkcs1();
    formats["pkcs8"] = require_pkcs8();
    formats["rfc4253"] = require_rfc4253();
    formats["ssh-private"] = require_ssh_private();
    formats["openssh"] = formats["ssh-private"];
    formats["ssh"] = formats["ssh-private"];
    formats["dnssec"] = require_dnssec();
    formats["putty"] = require_putty();
    function PrivateKey(opts) {
      assert.object(opts, "options");
      Key.call(this, opts);
      this._pubCache = void 0;
    }
    util.inherits(PrivateKey, Key);
    PrivateKey.formats = formats;
    PrivateKey.prototype.toBuffer = function(format3, options) {
      if (format3 === void 0)
        format3 = "pkcs1";
      assert.string(format3, "format");
      assert.object(formats[format3], "formats[format]");
      assert.optionalObject(options, "options");
      return formats[format3].write(this, options);
    };
    PrivateKey.prototype.hash = function(algo, type) {
      return this.toPublic().hash(algo, type);
    };
    PrivateKey.prototype.fingerprint = function(algo, type) {
      return this.toPublic().fingerprint(algo, type);
    };
    PrivateKey.prototype.toPublic = function() {
      if (this._pubCache)
        return this._pubCache;
      var algInfo = algs.info[this.type];
      var pubParts = [];
      for (var i = 0; i < algInfo.parts.length; ++i) {
        var p3 = algInfo.parts[i];
        pubParts.push(this.part[p3]);
      }
      this._pubCache = new Key({
        type: this.type,
        source: this,
        parts: pubParts
      });
      if (this.comment)
        this._pubCache.comment = this.comment;
      return this._pubCache;
    };
    PrivateKey.prototype.derive = function(newType) {
      assert.string(newType, "type");
      var priv, pub, pair;
      if (this.type === "ed25519" && newType === "curve25519") {
        priv = this.part.k.data;
        if (priv[0] === 0)
          priv = priv.slice(1);
        pair = nacl.box.keyPair.fromSecretKey(new Uint8Array(priv));
        pub = Buffer2.from(pair.publicKey);
        return new PrivateKey({
          type: "curve25519",
          parts: [
            { name: "A", data: utils.mpNormalize(pub) },
            { name: "k", data: utils.mpNormalize(priv) }
          ]
        });
      } else if (this.type === "curve25519" && newType === "ed25519") {
        priv = this.part.k.data;
        if (priv[0] === 0)
          priv = priv.slice(1);
        pair = nacl.sign.keyPair.fromSeed(new Uint8Array(priv));
        pub = Buffer2.from(pair.publicKey);
        return new PrivateKey({
          type: "ed25519",
          parts: [
            { name: "A", data: utils.mpNormalize(pub) },
            { name: "k", data: utils.mpNormalize(priv) }
          ]
        });
      }
      throw new Error("Key derivation not supported from " + this.type + " to " + newType);
    };
    PrivateKey.prototype.createVerify = function(hashAlgo) {
      return this.toPublic().createVerify(hashAlgo);
    };
    PrivateKey.prototype.createSign = function(hashAlgo) {
      if (hashAlgo === void 0)
        hashAlgo = this.defaultHashAlgorithm();
      assert.string(hashAlgo, "hash algorithm");
      if (this.type === "ed25519" && edCompat !== void 0)
        return new edCompat.Signer(this, hashAlgo);
      if (this.type === "curve25519")
        throw new Error("Curve25519 keys are not suitable for signing or verification");
      var v, nm, err;
      try {
        nm = hashAlgo.toUpperCase();
        v = crypto2.createSign(nm);
      } catch (e) {
        err = e;
      }
      if (v === void 0 || err instanceof Error && err.message.match(/Unknown message digest/)) {
        nm = "RSA-";
        nm += hashAlgo.toUpperCase();
        v = crypto2.createSign(nm);
      }
      assert.ok(v, "failed to create verifier");
      var oldSign = v.sign.bind(v);
      var key = this.toBuffer("pkcs1");
      var type = this.type;
      var curve = this.curve;
      v.sign = function() {
        var sig = oldSign(key);
        if (typeof sig === "string")
          sig = Buffer2.from(sig, "binary");
        sig = Signature.parse(sig, type, "asn1");
        sig.hashAlgorithm = hashAlgo;
        sig.curve = curve;
        return sig;
      };
      return v;
    };
    PrivateKey.parse = function(data, format3, options) {
      if (typeof data !== "string")
        assert.buffer(data, "data");
      if (format3 === void 0)
        format3 = "auto";
      assert.string(format3, "format");
      if (typeof options === "string")
        options = { filename: options };
      assert.optionalObject(options, "options");
      if (options === void 0)
        options = {};
      assert.optionalString(options.filename, "options.filename");
      if (options.filename === void 0)
        options.filename = "(unnamed)";
      assert.object(formats[format3], "formats[format]");
      try {
        var k = formats[format3].read(data, options);
        assert.ok(k instanceof PrivateKey, "key is not a private key");
        if (!k.comment)
          k.comment = options.filename;
        return k;
      } catch (e) {
        if (e.name === "KeyEncryptedError")
          throw e;
        throw new KeyParseError(options.filename, format3, e);
      }
    };
    PrivateKey.isPrivateKey = function(obj, ver) {
      return utils.isCompatible(obj, PrivateKey, ver);
    };
    PrivateKey.generate = function(type, options) {
      if (options === void 0)
        options = {};
      assert.object(options, "options");
      switch (type) {
        case "ecdsa":
          if (options.curve === void 0)
            options.curve = "nistp256";
          assert.string(options.curve, "options.curve");
          return generateECDSA(options.curve);
        case "ed25519":
          return generateED25519();
        default:
          throw new Error('Key generation not supported with key type "' + type + '"');
      }
    };
    PrivateKey.prototype._sshpkApiVersion = [1, 6];
    PrivateKey._oldVersionDetect = function(obj) {
      assert.func(obj.toPublic);
      assert.func(obj.createSign);
      if (obj.derive)
        return [1, 3];
      if (obj.defaultHashAlgorithm)
        return [1, 2];
      if (obj.formats["auto"])
        return [1, 1];
      return [1, 0];
    };
  }
});

// node_modules/sshpk/lib/identity.js
var require_identity = __commonJS({
  "node_modules/sshpk/lib/identity.js"(exports2, module2) {
    module2.exports = Identity;
    var assert = require_assert();
    var algs = require_algs();
    var crypto2 = require("crypto");
    var Fingerprint = require_fingerprint();
    var Signature = require_signature();
    var errs = require_errors3();
    var util = require("util");
    var utils = require_utils5();
    var asn1 = require_lib14();
    var Buffer2 = require_safer().Buffer;
    var DNS_NAME_RE = /^([*]|[a-z0-9][a-z0-9\-]{0,62})(?:\.([*]|[a-z0-9][a-z0-9\-]{0,62}))*$/i;
    var oids = {};
    oids.cn = "2.5.4.3";
    oids.o = "2.5.4.10";
    oids.ou = "2.5.4.11";
    oids.l = "2.5.4.7";
    oids.s = "2.5.4.8";
    oids.c = "2.5.4.6";
    oids.sn = "2.5.4.4";
    oids.postalCode = "2.5.4.17";
    oids.serialNumber = "2.5.4.5";
    oids.street = "2.5.4.9";
    oids.x500UniqueIdentifier = "2.5.4.45";
    oids.role = "2.5.4.72";
    oids.telephoneNumber = "2.5.4.20";
    oids.description = "2.5.4.13";
    oids.dc = "0.9.2342.19200300.100.1.25";
    oids.uid = "0.9.2342.19200300.100.1.1";
    oids.mail = "0.9.2342.19200300.100.1.3";
    oids.title = "2.5.4.12";
    oids.gn = "2.5.4.42";
    oids.initials = "2.5.4.43";
    oids.pseudonym = "2.5.4.65";
    oids.emailAddress = "1.2.840.113549.1.9.1";
    var unoids = {};
    Object.keys(oids).forEach(function(k) {
      unoids[oids[k]] = k;
    });
    function Identity(opts) {
      var self2 = this;
      assert.object(opts, "options");
      assert.arrayOfObject(opts.components, "options.components");
      this.components = opts.components;
      this.componentLookup = {};
      this.components.forEach(function(c2) {
        if (c2.name && !c2.oid)
          c2.oid = oids[c2.name];
        if (c2.oid && !c2.name)
          c2.name = unoids[c2.oid];
        if (self2.componentLookup[c2.name] === void 0)
          self2.componentLookup[c2.name] = [];
        self2.componentLookup[c2.name].push(c2);
      });
      if (this.componentLookup.cn && this.componentLookup.cn.length > 0) {
        this.cn = this.componentLookup.cn[0].value;
      }
      assert.optionalString(opts.type, "options.type");
      if (opts.type === void 0) {
        if (this.components.length === 1 && this.componentLookup.cn && this.componentLookup.cn.length === 1 && this.componentLookup.cn[0].value.match(DNS_NAME_RE)) {
          this.type = "host";
          this.hostname = this.componentLookup.cn[0].value;
        } else if (this.componentLookup.dc && this.components.length === this.componentLookup.dc.length) {
          this.type = "host";
          this.hostname = this.componentLookup.dc.map(
            function(c2) {
              return c2.value;
            }
          ).join(".");
        } else if (this.componentLookup.uid && this.components.length === this.componentLookup.uid.length) {
          this.type = "user";
          this.uid = this.componentLookup.uid[0].value;
        } else if (this.componentLookup.cn && this.componentLookup.cn.length === 1 && this.componentLookup.cn[0].value.match(DNS_NAME_RE)) {
          this.type = "host";
          this.hostname = this.componentLookup.cn[0].value;
        } else if (this.componentLookup.uid && this.componentLookup.uid.length === 1) {
          this.type = "user";
          this.uid = this.componentLookup.uid[0].value;
        } else if (this.componentLookup.mail && this.componentLookup.mail.length === 1) {
          this.type = "email";
          this.email = this.componentLookup.mail[0].value;
        } else if (this.componentLookup.cn && this.componentLookup.cn.length === 1) {
          this.type = "user";
          this.uid = this.componentLookup.cn[0].value;
        } else {
          this.type = "unknown";
        }
      } else {
        this.type = opts.type;
        if (this.type === "host")
          this.hostname = opts.hostname;
        else if (this.type === "user")
          this.uid = opts.uid;
        else if (this.type === "email")
          this.email = opts.email;
        else
          throw new Error("Unknown type " + this.type);
      }
    }
    Identity.prototype.toString = function() {
      return this.components.map(function(c2) {
        var n = c2.name.toUpperCase();
        n = n.replace(/=/g, "\\=");
        var v = c2.value;
        v = v.replace(/,/g, "\\,");
        return n + "=" + v;
      }).join(", ");
    };
    Identity.prototype.get = function(name, asArray) {
      assert.string(name, "name");
      var arr = this.componentLookup[name];
      if (arr === void 0 || arr.length === 0)
        return void 0;
      if (!asArray && arr.length > 1)
        throw new Error("Multiple values for attribute " + name);
      if (!asArray)
        return arr[0].value;
      return arr.map(function(c2) {
        return c2.value;
      });
    };
    Identity.prototype.toArray = function(idx) {
      return this.components.map(function(c2) {
        return {
          name: c2.name,
          value: c2.value
        };
      });
    };
    var NOT_PRINTABLE = /[^a-zA-Z0-9 '(),+.\/:=?-]/;
    var NOT_IA5 = /[^\x00-\x7f]/;
    Identity.prototype.toAsn1 = function(der, tag) {
      der.startSequence(tag);
      this.components.forEach(function(c2) {
        der.startSequence(asn1.Ber.Constructor | asn1.Ber.Set);
        der.startSequence();
        der.writeOID(c2.oid);
        if (c2.asn1type === asn1.Ber.Utf8String || c2.value.match(NOT_IA5)) {
          var v = Buffer2.from(c2.value, "utf8");
          der.writeBuffer(v, asn1.Ber.Utf8String);
        } else if (c2.asn1type === asn1.Ber.IA5String || c2.value.match(NOT_PRINTABLE)) {
          der.writeString(c2.value, asn1.Ber.IA5String);
        } else {
          var type = asn1.Ber.PrintableString;
          if (c2.asn1type !== void 0)
            type = c2.asn1type;
          der.writeString(c2.value, type);
        }
        der.endSequence();
        der.endSequence();
      });
      der.endSequence();
    };
    function globMatch(a, b) {
      if (a === "**" || b === "**")
        return true;
      var aParts = a.split(".");
      var bParts = b.split(".");
      if (aParts.length !== bParts.length)
        return false;
      for (var i = 0; i < aParts.length; ++i) {
        if (aParts[i] === "*" || bParts[i] === "*")
          continue;
        if (aParts[i] !== bParts[i])
          return false;
      }
      return true;
    }
    Identity.prototype.equals = function(other) {
      if (!Identity.isIdentity(other, [1, 0]))
        return false;
      if (other.components.length !== this.components.length)
        return false;
      for (var i = 0; i < this.components.length; ++i) {
        if (this.components[i].oid !== other.components[i].oid)
          return false;
        if (!globMatch(
          this.components[i].value,
          other.components[i].value
        )) {
          return false;
        }
      }
      return true;
    };
    Identity.forHost = function(hostname2) {
      assert.string(hostname2, "hostname");
      return new Identity({
        type: "host",
        hostname: hostname2,
        components: [{ name: "cn", value: hostname2 }]
      });
    };
    Identity.forUser = function(uid) {
      assert.string(uid, "uid");
      return new Identity({
        type: "user",
        uid,
        components: [{ name: "uid", value: uid }]
      });
    };
    Identity.forEmail = function(email) {
      assert.string(email, "email");
      return new Identity({
        type: "email",
        email,
        components: [{ name: "mail", value: email }]
      });
    };
    Identity.parseDN = function(dn) {
      assert.string(dn, "dn");
      var parts = [""];
      var idx = 0;
      var rem = dn;
      while (rem.length > 0) {
        var m2;
        if ((m2 = /^,/.exec(rem)) !== null) {
          parts[++idx] = "";
          rem = rem.slice(m2[0].length);
        } else if ((m2 = /^\\,/.exec(rem)) !== null) {
          parts[idx] += ",";
          rem = rem.slice(m2[0].length);
        } else if ((m2 = /^\\./.exec(rem)) !== null) {
          parts[idx] += m2[0];
          rem = rem.slice(m2[0].length);
        } else if ((m2 = /^[^\\,]+/.exec(rem)) !== null) {
          parts[idx] += m2[0];
          rem = rem.slice(m2[0].length);
        } else {
          throw new Error("Failed to parse DN");
        }
      }
      var cmps = parts.map(function(c2) {
        c2 = c2.trim();
        var eqPos = c2.indexOf("=");
        while (eqPos > 0 && c2.charAt(eqPos - 1) === "\\")
          eqPos = c2.indexOf("=", eqPos + 1);
        if (eqPos === -1) {
          throw new Error("Failed to parse DN");
        }
        var name = c2.slice(0, eqPos).toLowerCase().replace(/\\=/g, "=");
        var value = c2.slice(eqPos + 1);
        return { name, value };
      });
      return new Identity({ components: cmps });
    };
    Identity.fromArray = function(components) {
      assert.arrayOfObject(components, "components");
      components.forEach(function(cmp) {
        assert.object(cmp, "component");
        assert.string(cmp.name, "component.name");
        if (!Buffer2.isBuffer(cmp.value) && !(typeof cmp.value === "string")) {
          throw new Error("Invalid component value");
        }
      });
      return new Identity({ components });
    };
    Identity.parseAsn1 = function(der, top) {
      var components = [];
      der.readSequence(top);
      var end = der.offset + der.length;
      while (der.offset < end) {
        der.readSequence(asn1.Ber.Constructor | asn1.Ber.Set);
        var after = der.offset + der.length;
        der.readSequence();
        var oid = der.readOID();
        var type = der.peek();
        var value;
        switch (type) {
          case asn1.Ber.PrintableString:
          case asn1.Ber.IA5String:
          case asn1.Ber.OctetString:
          case asn1.Ber.T61String:
            value = der.readString(type);
            break;
          case asn1.Ber.Utf8String:
            value = der.readString(type, true);
            value = value.toString("utf8");
            break;
          case asn1.Ber.CharacterString:
          case asn1.Ber.BMPString:
            value = der.readString(type, true);
            value = value.toString("utf16le");
            break;
          default:
            throw new Error("Unknown asn1 type " + type);
        }
        components.push({ oid, asn1type: type, value });
        der._offset = after;
      }
      der._offset = end;
      return new Identity({
        components
      });
    };
    Identity.isIdentity = function(obj, ver) {
      return utils.isCompatible(obj, Identity, ver);
    };
    Identity.prototype._sshpkApiVersion = [1, 0];
    Identity._oldVersionDetect = function(obj) {
      return [1, 0];
    };
  }
});

// node_modules/sshpk/lib/formats/openssh-cert.js
var require_openssh_cert = __commonJS({
  "node_modules/sshpk/lib/formats/openssh-cert.js"(exports2, module2) {
    module2.exports = {
      read,
      verify,
      sign: sign2,
      signAsync,
      write,
      /* Internal private API */
      fromBuffer,
      toBuffer
    };
    var assert = require_assert();
    var SSHBuffer = require_ssh_buffer();
    var crypto2 = require("crypto");
    var Buffer2 = require_safer().Buffer;
    var algs = require_algs();
    var Key = require_key();
    var PrivateKey = require_private_key();
    var Identity = require_identity();
    var rfc4253 = require_rfc4253();
    var Signature = require_signature();
    var utils = require_utils5();
    var Certificate = require_certificate2();
    function verify(cert, key) {
      return false;
    }
    var TYPES = {
      "user": 1,
      "host": 2
    };
    Object.keys(TYPES).forEach(function(k) {
      TYPES[TYPES[k]] = k;
    });
    var ECDSA_ALGO = /^ecdsa-sha2-([^@-]+)-cert-v01@openssh.com$/;
    function read(buf, options) {
      if (Buffer2.isBuffer(buf))
        buf = buf.toString("ascii");
      var parts = buf.trim().split(/[ \t\n]+/g);
      if (parts.length < 2 || parts.length > 3)
        throw new Error("Not a valid SSH certificate line");
      var algo = parts[0];
      var data = parts[1];
      data = Buffer2.from(data, "base64");
      return fromBuffer(data, algo);
    }
    function fromBuffer(data, algo, partial) {
      var sshbuf = new SSHBuffer({ buffer: data });
      var innerAlgo = sshbuf.readString();
      if (algo !== void 0 && innerAlgo !== algo)
        throw new Error("SSH certificate algorithm mismatch");
      if (algo === void 0)
        algo = innerAlgo;
      var cert = {};
      cert.signatures = {};
      cert.signatures.openssh = {};
      cert.signatures.openssh.nonce = sshbuf.readBuffer();
      var key = {};
      var parts = key.parts = [];
      key.type = getAlg(algo);
      var partCount = algs.info[key.type].parts.length;
      while (parts.length < partCount)
        parts.push(sshbuf.readPart());
      assert.ok(parts.length >= 1, "key must have at least one part");
      var algInfo = algs.info[key.type];
      if (key.type === "ecdsa") {
        var res = ECDSA_ALGO.exec(algo);
        assert.ok(res !== null);
        assert.strictEqual(res[1], parts[0].data.toString());
      }
      for (var i = 0; i < algInfo.parts.length; ++i) {
        parts[i].name = algInfo.parts[i];
        if (parts[i].name !== "curve" && algInfo.normalize !== false) {
          var p3 = parts[i];
          p3.data = utils.mpNormalize(p3.data);
        }
      }
      cert.subjectKey = new Key(key);
      cert.serial = sshbuf.readInt64();
      var type = TYPES[sshbuf.readInt()];
      assert.string(type, "valid cert type");
      cert.signatures.openssh.keyId = sshbuf.readString();
      var principals = [];
      var pbuf = sshbuf.readBuffer();
      var psshbuf = new SSHBuffer({ buffer: pbuf });
      while (!psshbuf.atEnd())
        principals.push(psshbuf.readString());
      if (principals.length === 0)
        principals = ["*"];
      cert.subjects = principals.map(function(pr) {
        if (type === "user")
          return Identity.forUser(pr);
        else if (type === "host")
          return Identity.forHost(pr);
        throw new Error("Unknown identity type " + type);
      });
      cert.validFrom = int64ToDate(sshbuf.readInt64());
      cert.validUntil = int64ToDate(sshbuf.readInt64());
      var exts = [];
      var extbuf = new SSHBuffer({ buffer: sshbuf.readBuffer() });
      var ext;
      while (!extbuf.atEnd()) {
        ext = { critical: true };
        ext.name = extbuf.readString();
        ext.data = extbuf.readBuffer();
        exts.push(ext);
      }
      extbuf = new SSHBuffer({ buffer: sshbuf.readBuffer() });
      while (!extbuf.atEnd()) {
        ext = { critical: false };
        ext.name = extbuf.readString();
        ext.data = extbuf.readBuffer();
        exts.push(ext);
      }
      cert.signatures.openssh.exts = exts;
      sshbuf.readBuffer();
      var signingKeyBuf = sshbuf.readBuffer();
      cert.issuerKey = rfc4253.read(signingKeyBuf);
      cert.issuer = Identity.forHost("**");
      var sigBuf = sshbuf.readBuffer();
      cert.signatures.openssh.signature = Signature.parse(sigBuf, cert.issuerKey.type, "ssh");
      if (partial !== void 0) {
        partial.remainder = sshbuf.remainder();
        partial.consumed = sshbuf._offset;
      }
      return new Certificate(cert);
    }
    function int64ToDate(buf) {
      var i = buf.readUInt32BE(0) * 4294967296;
      i += buf.readUInt32BE(4);
      var d2 = /* @__PURE__ */ new Date();
      d2.setTime(i * 1e3);
      d2.sourceInt64 = buf;
      return d2;
    }
    function dateToInt64(date) {
      if (date.sourceInt64 !== void 0)
        return date.sourceInt64;
      var i = Math.round(date.getTime() / 1e3);
      var upper = Math.floor(i / 4294967296);
      var lower = Math.floor(i % 4294967296);
      var buf = Buffer2.alloc(8);
      buf.writeUInt32BE(upper, 0);
      buf.writeUInt32BE(lower, 4);
      return buf;
    }
    function sign2(cert, key) {
      if (cert.signatures.openssh === void 0)
        cert.signatures.openssh = {};
      try {
        var blob = toBuffer(cert, true);
      } catch (e) {
        delete cert.signatures.openssh;
        return false;
      }
      var sig = cert.signatures.openssh;
      var hashAlgo = void 0;
      if (key.type === "rsa" || key.type === "dsa")
        hashAlgo = "sha1";
      var signer = key.createSign(hashAlgo);
      signer.write(blob);
      sig.signature = signer.sign();
      return true;
    }
    function signAsync(cert, signer, done) {
      if (cert.signatures.openssh === void 0)
        cert.signatures.openssh = {};
      try {
        var blob = toBuffer(cert, true);
      } catch (e) {
        delete cert.signatures.openssh;
        done(e);
        return;
      }
      var sig = cert.signatures.openssh;
      signer(blob, function(err, signature) {
        if (err) {
          done(err);
          return;
        }
        try {
          signature.toBuffer("ssh");
        } catch (e) {
          done(e);
          return;
        }
        sig.signature = signature;
        done();
      });
    }
    function write(cert, options) {
      if (options === void 0)
        options = {};
      var blob = toBuffer(cert);
      var out = getCertType(cert.subjectKey) + " " + blob.toString("base64");
      if (options.comment)
        out = out + " " + options.comment;
      return out;
    }
    function toBuffer(cert, noSig) {
      assert.object(cert.signatures.openssh, "signature for openssh format");
      var sig = cert.signatures.openssh;
      if (sig.nonce === void 0)
        sig.nonce = crypto2.randomBytes(16);
      var buf = new SSHBuffer({});
      buf.writeString(getCertType(cert.subjectKey));
      buf.writeBuffer(sig.nonce);
      var key = cert.subjectKey;
      var algInfo = algs.info[key.type];
      algInfo.parts.forEach(function(part) {
        buf.writePart(key.part[part]);
      });
      buf.writeInt64(cert.serial);
      var type = cert.subjects[0].type;
      assert.notStrictEqual(type, "unknown");
      cert.subjects.forEach(function(id) {
        assert.strictEqual(id.type, type);
      });
      type = TYPES[type];
      buf.writeInt(type);
      if (sig.keyId === void 0) {
        sig.keyId = cert.subjects[0].type + "_" + (cert.subjects[0].uid || cert.subjects[0].hostname);
      }
      buf.writeString(sig.keyId);
      var sub = new SSHBuffer({});
      cert.subjects.forEach(function(id) {
        if (type === TYPES.host)
          sub.writeString(id.hostname);
        else if (type === TYPES.user)
          sub.writeString(id.uid);
      });
      buf.writeBuffer(sub.toBuffer());
      buf.writeInt64(dateToInt64(cert.validFrom));
      buf.writeInt64(dateToInt64(cert.validUntil));
      var exts = sig.exts;
      if (exts === void 0)
        exts = [];
      var extbuf = new SSHBuffer({});
      exts.forEach(function(ext) {
        if (ext.critical !== true)
          return;
        extbuf.writeString(ext.name);
        extbuf.writeBuffer(ext.data);
      });
      buf.writeBuffer(extbuf.toBuffer());
      extbuf = new SSHBuffer({});
      exts.forEach(function(ext) {
        if (ext.critical === true)
          return;
        extbuf.writeString(ext.name);
        extbuf.writeBuffer(ext.data);
      });
      buf.writeBuffer(extbuf.toBuffer());
      buf.writeBuffer(Buffer2.alloc(0));
      sub = rfc4253.write(cert.issuerKey);
      buf.writeBuffer(sub);
      if (!noSig)
        buf.writeBuffer(sig.signature.toBuffer("ssh"));
      return buf.toBuffer();
    }
    function getAlg(certType) {
      if (certType === "ssh-rsa-cert-v01@openssh.com")
        return "rsa";
      if (certType === "ssh-dss-cert-v01@openssh.com")
        return "dsa";
      if (certType.match(ECDSA_ALGO))
        return "ecdsa";
      if (certType === "ssh-ed25519-cert-v01@openssh.com")
        return "ed25519";
      throw new Error("Unsupported cert type " + certType);
    }
    function getCertType(key) {
      if (key.type === "rsa")
        return "ssh-rsa-cert-v01@openssh.com";
      if (key.type === "dsa")
        return "ssh-dss-cert-v01@openssh.com";
      if (key.type === "ecdsa")
        return "ecdsa-sha2-" + key.curve + "-cert-v01@openssh.com";
      if (key.type === "ed25519")
        return "ssh-ed25519-cert-v01@openssh.com";
      throw new Error("Unsupported key type " + key.type);
    }
  }
});

// node_modules/sshpk/lib/formats/x509.js
var require_x509 = __commonJS({
  "node_modules/sshpk/lib/formats/x509.js"(exports2, module2) {
    module2.exports = {
      read,
      verify,
      sign: sign2,
      signAsync,
      write
    };
    var assert = require_assert();
    var asn1 = require_lib14();
    var Buffer2 = require_safer().Buffer;
    var algs = require_algs();
    var utils = require_utils5();
    var Key = require_key();
    var PrivateKey = require_private_key();
    var pem = require_pem();
    var Identity = require_identity();
    var Signature = require_signature();
    var Certificate = require_certificate2();
    var pkcs8 = require_pkcs8();
    function readMPInt(der, nm) {
      assert.strictEqual(
        der.peek(),
        asn1.Ber.Integer,
        nm + " is not an Integer"
      );
      return utils.mpNormalize(der.readString(asn1.Ber.Integer, true));
    }
    function verify(cert, key) {
      var sig = cert.signatures.x509;
      assert.object(sig, "x509 signature");
      var algParts = sig.algo.split("-");
      if (algParts[0] !== key.type)
        return false;
      var blob = sig.cache;
      if (blob === void 0) {
        var der = new asn1.BerWriter();
        writeTBSCert(cert, der);
        blob = der.buffer;
      }
      var verifier = key.createVerify(algParts[1]);
      verifier.write(blob);
      return verifier.verify(sig.signature);
    }
    function Local(i) {
      return asn1.Ber.Context | asn1.Ber.Constructor | i;
    }
    function Context(i) {
      return asn1.Ber.Context | i;
    }
    var SIGN_ALGS = {
      "rsa-md5": "1.2.840.113549.1.1.4",
      "rsa-sha1": "1.2.840.113549.1.1.5",
      "rsa-sha256": "1.2.840.113549.1.1.11",
      "rsa-sha384": "1.2.840.113549.1.1.12",
      "rsa-sha512": "1.2.840.113549.1.1.13",
      "dsa-sha1": "1.2.840.10040.4.3",
      "dsa-sha256": "2.16.840.1.101.3.4.3.2",
      "ecdsa-sha1": "1.2.840.10045.4.1",
      "ecdsa-sha256": "1.2.840.10045.4.3.2",
      "ecdsa-sha384": "1.2.840.10045.4.3.3",
      "ecdsa-sha512": "1.2.840.10045.4.3.4",
      "ed25519-sha512": "1.3.101.112"
    };
    Object.keys(SIGN_ALGS).forEach(function(k) {
      SIGN_ALGS[SIGN_ALGS[k]] = k;
    });
    SIGN_ALGS["1.3.14.3.2.3"] = "rsa-md5";
    SIGN_ALGS["1.3.14.3.2.29"] = "rsa-sha1";
    var EXTS = {
      "issuerKeyId": "2.5.29.35",
      "altName": "2.5.29.17",
      "basicConstraints": "2.5.29.19",
      "keyUsage": "2.5.29.15",
      "extKeyUsage": "2.5.29.37"
    };
    function read(buf, options) {
      if (typeof buf === "string") {
        buf = Buffer2.from(buf, "binary");
      }
      assert.buffer(buf, "buf");
      var der = new asn1.BerReader(buf);
      der.readSequence();
      if (Math.abs(der.length - der.remain) > 1) {
        throw new Error("DER sequence does not contain whole byte stream");
      }
      var tbsStart = der.offset;
      der.readSequence();
      var sigOffset = der.offset + der.length;
      var tbsEnd = sigOffset;
      if (der.peek() === Local(0)) {
        der.readSequence(Local(0));
        var version = der.readInt();
        assert.ok(
          version <= 3,
          "only x.509 versions up to v3 supported"
        );
      }
      var cert = {};
      cert.signatures = {};
      var sig = cert.signatures.x509 = {};
      sig.extras = {};
      cert.serial = readMPInt(der, "serial");
      der.readSequence();
      var after = der.offset + der.length;
      var certAlgOid = der.readOID();
      var certAlg = SIGN_ALGS[certAlgOid];
      if (certAlg === void 0)
        throw new Error("unknown signature algorithm " + certAlgOid);
      der._offset = after;
      cert.issuer = Identity.parseAsn1(der);
      der.readSequence();
      cert.validFrom = readDate(der);
      cert.validUntil = readDate(der);
      cert.subjects = [Identity.parseAsn1(der)];
      der.readSequence();
      after = der.offset + der.length;
      cert.subjectKey = pkcs8.readPkcs8(void 0, "public", der);
      der._offset = after;
      if (der.peek() === Local(1)) {
        der.readSequence(Local(1));
        sig.extras.issuerUniqueID = buf.slice(der.offset, der.offset + der.length);
        der._offset += der.length;
      }
      if (der.peek() === Local(2)) {
        der.readSequence(Local(2));
        sig.extras.subjectUniqueID = buf.slice(der.offset, der.offset + der.length);
        der._offset += der.length;
      }
      if (der.peek() === Local(3)) {
        der.readSequence(Local(3));
        var extEnd = der.offset + der.length;
        der.readSequence();
        while (der.offset < extEnd)
          readExtension(cert, buf, der);
        assert.strictEqual(der.offset, extEnd);
      }
      assert.strictEqual(der.offset, sigOffset);
      der.readSequence();
      after = der.offset + der.length;
      var sigAlgOid = der.readOID();
      var sigAlg = SIGN_ALGS[sigAlgOid];
      if (sigAlg === void 0)
        throw new Error("unknown signature algorithm " + sigAlgOid);
      der._offset = after;
      var sigData = der.readString(asn1.Ber.BitString, true);
      if (sigData[0] === 0)
        sigData = sigData.slice(1);
      var algParts = sigAlg.split("-");
      sig.signature = Signature.parse(sigData, algParts[0], "asn1");
      sig.signature.hashAlgorithm = algParts[1];
      sig.algo = sigAlg;
      sig.cache = buf.slice(tbsStart, tbsEnd);
      return new Certificate(cert);
    }
    function readDate(der) {
      if (der.peek() === asn1.Ber.UTCTime) {
        return utcTimeToDate(der.readString(asn1.Ber.UTCTime));
      } else if (der.peek() === asn1.Ber.GeneralizedTime) {
        return gTimeToDate(der.readString(asn1.Ber.GeneralizedTime));
      } else {
        throw new Error("Unsupported date format");
      }
    }
    function writeDate(der, date) {
      if (date.getUTCFullYear() >= 2050 || date.getUTCFullYear() < 1950) {
        der.writeString(dateToGTime(date), asn1.Ber.GeneralizedTime);
      } else {
        der.writeString(dateToUTCTime(date), asn1.Ber.UTCTime);
      }
    }
    var ALTNAME = {
      OtherName: Local(0),
      RFC822Name: Context(1),
      DNSName: Context(2),
      X400Address: Local(3),
      DirectoryName: Local(4),
      EDIPartyName: Local(5),
      URI: Context(6),
      IPAddress: Context(7),
      OID: Context(8)
    };
    var EXTPURPOSE = {
      "serverAuth": "1.3.6.1.5.5.7.3.1",
      "clientAuth": "1.3.6.1.5.5.7.3.2",
      "codeSigning": "1.3.6.1.5.5.7.3.3",
      /* See https://github.com/joyent/oid-docs/blob/master/root.md */
      "joyentDocker": "1.3.6.1.4.1.38678.1.4.1",
      "joyentCmon": "1.3.6.1.4.1.38678.1.4.2"
    };
    var EXTPURPOSE_REV = {};
    Object.keys(EXTPURPOSE).forEach(function(k) {
      EXTPURPOSE_REV[EXTPURPOSE[k]] = k;
    });
    var KEYUSEBITS = [
      "signature",
      "identity",
      "keyEncryption",
      "encryption",
      "keyAgreement",
      "ca",
      "crl"
    ];
    function readExtension(cert, buf, der) {
      der.readSequence();
      var after = der.offset + der.length;
      var extId = der.readOID();
      var id;
      var sig = cert.signatures.x509;
      if (!sig.extras.exts)
        sig.extras.exts = [];
      var critical;
      if (der.peek() === asn1.Ber.Boolean)
        critical = der.readBoolean();
      switch (extId) {
        case EXTS.basicConstraints:
          der.readSequence(asn1.Ber.OctetString);
          der.readSequence();
          var bcEnd = der.offset + der.length;
          var ca = false;
          if (der.peek() === asn1.Ber.Boolean)
            ca = der.readBoolean();
          if (cert.purposes === void 0)
            cert.purposes = [];
          if (ca === true)
            cert.purposes.push("ca");
          var bc = { oid: extId, critical };
          if (der.offset < bcEnd && der.peek() === asn1.Ber.Integer)
            bc.pathLen = der.readInt();
          sig.extras.exts.push(bc);
          break;
        case EXTS.extKeyUsage:
          der.readSequence(asn1.Ber.OctetString);
          der.readSequence();
          if (cert.purposes === void 0)
            cert.purposes = [];
          var ekEnd = der.offset + der.length;
          while (der.offset < ekEnd) {
            var oid = der.readOID();
            cert.purposes.push(EXTPURPOSE_REV[oid] || oid);
          }
          if (cert.purposes.indexOf("serverAuth") !== -1 && cert.purposes.indexOf("clientAuth") === -1) {
            cert.subjects.forEach(function(ide) {
              if (ide.type !== "host") {
                ide.type = "host";
                ide.hostname = ide.uid || ide.email || ide.components[0].value;
              }
            });
          } else if (cert.purposes.indexOf("clientAuth") !== -1 && cert.purposes.indexOf("serverAuth") === -1) {
            cert.subjects.forEach(function(ide) {
              if (ide.type !== "user") {
                ide.type = "user";
                ide.uid = ide.hostname || ide.email || ide.components[0].value;
              }
            });
          }
          sig.extras.exts.push({ oid: extId, critical });
          break;
        case EXTS.keyUsage:
          der.readSequence(asn1.Ber.OctetString);
          var bits = der.readString(asn1.Ber.BitString, true);
          var setBits = readBitField(bits, KEYUSEBITS);
          setBits.forEach(function(bit) {
            if (cert.purposes === void 0)
              cert.purposes = [];
            if (cert.purposes.indexOf(bit) === -1)
              cert.purposes.push(bit);
          });
          sig.extras.exts.push({
            oid: extId,
            critical,
            bits
          });
          break;
        case EXTS.altName:
          der.readSequence(asn1.Ber.OctetString);
          der.readSequence();
          var aeEnd = der.offset + der.length;
          while (der.offset < aeEnd) {
            switch (der.peek()) {
              case ALTNAME.OtherName:
              case ALTNAME.EDIPartyName:
                der.readSequence();
                der._offset += der.length;
                break;
              case ALTNAME.OID:
                der.readOID(ALTNAME.OID);
                break;
              case ALTNAME.RFC822Name:
                var email = der.readString(ALTNAME.RFC822Name);
                id = Identity.forEmail(email);
                if (!cert.subjects[0].equals(id))
                  cert.subjects.push(id);
                break;
              case ALTNAME.DirectoryName:
                der.readSequence(ALTNAME.DirectoryName);
                id = Identity.parseAsn1(der);
                if (!cert.subjects[0].equals(id))
                  cert.subjects.push(id);
                break;
              case ALTNAME.DNSName:
                var host = der.readString(
                  ALTNAME.DNSName
                );
                id = Identity.forHost(host);
                if (!cert.subjects[0].equals(id))
                  cert.subjects.push(id);
                break;
              default:
                der.readString(der.peek());
                break;
            }
          }
          sig.extras.exts.push({ oid: extId, critical });
          break;
        default:
          sig.extras.exts.push({
            oid: extId,
            critical,
            data: der.readString(asn1.Ber.OctetString, true)
          });
          break;
      }
      der._offset = after;
    }
    var UTCTIME_RE = /^([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})?Z$/;
    function utcTimeToDate(t) {
      var m2 = t.match(UTCTIME_RE);
      assert.ok(m2, "timestamps must be in UTC");
      var d2 = /* @__PURE__ */ new Date();
      var thisYear = d2.getUTCFullYear();
      var century = Math.floor(thisYear / 100) * 100;
      var year = parseInt(m2[1], 10);
      if (thisYear % 100 < 50 && year >= 60)
        year += century - 1;
      else
        year += century;
      d2.setUTCFullYear(year, parseInt(m2[2], 10) - 1, parseInt(m2[3], 10));
      d2.setUTCHours(parseInt(m2[4], 10), parseInt(m2[5], 10));
      if (m2[6] && m2[6].length > 0)
        d2.setUTCSeconds(parseInt(m2[6], 10));
      return d2;
    }
    var GTIME_RE = /^([0-9]{4})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})?Z$/;
    function gTimeToDate(t) {
      var m2 = t.match(GTIME_RE);
      assert.ok(m2);
      var d2 = /* @__PURE__ */ new Date();
      d2.setUTCFullYear(
        parseInt(m2[1], 10),
        parseInt(m2[2], 10) - 1,
        parseInt(m2[3], 10)
      );
      d2.setUTCHours(parseInt(m2[4], 10), parseInt(m2[5], 10));
      if (m2[6] && m2[6].length > 0)
        d2.setUTCSeconds(parseInt(m2[6], 10));
      return d2;
    }
    function zeroPad(n, m2) {
      if (m2 === void 0)
        m2 = 2;
      var s = "" + n;
      while (s.length < m2)
        s = "0" + s;
      return s;
    }
    function dateToUTCTime(d2) {
      var s = "";
      s += zeroPad(d2.getUTCFullYear() % 100);
      s += zeroPad(d2.getUTCMonth() + 1);
      s += zeroPad(d2.getUTCDate());
      s += zeroPad(d2.getUTCHours());
      s += zeroPad(d2.getUTCMinutes());
      s += zeroPad(d2.getUTCSeconds());
      s += "Z";
      return s;
    }
    function dateToGTime(d2) {
      var s = "";
      s += zeroPad(d2.getUTCFullYear(), 4);
      s += zeroPad(d2.getUTCMonth() + 1);
      s += zeroPad(d2.getUTCDate());
      s += zeroPad(d2.getUTCHours());
      s += zeroPad(d2.getUTCMinutes());
      s += zeroPad(d2.getUTCSeconds());
      s += "Z";
      return s;
    }
    function sign2(cert, key) {
      if (cert.signatures.x509 === void 0)
        cert.signatures.x509 = {};
      var sig = cert.signatures.x509;
      sig.algo = key.type + "-" + key.defaultHashAlgorithm();
      if (SIGN_ALGS[sig.algo] === void 0)
        return false;
      var der = new asn1.BerWriter();
      writeTBSCert(cert, der);
      var blob = der.buffer;
      sig.cache = blob;
      var signer = key.createSign();
      signer.write(blob);
      cert.signatures.x509.signature = signer.sign();
      return true;
    }
    function signAsync(cert, signer, done) {
      if (cert.signatures.x509 === void 0)
        cert.signatures.x509 = {};
      var sig = cert.signatures.x509;
      var der = new asn1.BerWriter();
      writeTBSCert(cert, der);
      var blob = der.buffer;
      sig.cache = blob;
      signer(blob, function(err, signature) {
        if (err) {
          done(err);
          return;
        }
        sig.algo = signature.type + "-" + signature.hashAlgorithm;
        if (SIGN_ALGS[sig.algo] === void 0) {
          done(new Error('Invalid signing algorithm "' + sig.algo + '"'));
          return;
        }
        sig.signature = signature;
        done();
      });
    }
    function write(cert, options) {
      var sig = cert.signatures.x509;
      assert.object(sig, "x509 signature");
      var der = new asn1.BerWriter();
      der.startSequence();
      if (sig.cache) {
        der._ensure(sig.cache.length);
        sig.cache.copy(der._buf, der._offset);
        der._offset += sig.cache.length;
      } else {
        writeTBSCert(cert, der);
      }
      der.startSequence();
      der.writeOID(SIGN_ALGS[sig.algo]);
      if (sig.algo.match(/^rsa-/))
        der.writeNull();
      der.endSequence();
      var sigData = sig.signature.toBuffer("asn1");
      var data = Buffer2.alloc(sigData.length + 1);
      data[0] = 0;
      sigData.copy(data, 1);
      der.writeBuffer(data, asn1.Ber.BitString);
      der.endSequence();
      return der.buffer;
    }
    function writeTBSCert(cert, der) {
      var sig = cert.signatures.x509;
      assert.object(sig, "x509 signature");
      der.startSequence();
      der.startSequence(Local(0));
      der.writeInt(2);
      der.endSequence();
      der.writeBuffer(utils.mpNormalize(cert.serial), asn1.Ber.Integer);
      der.startSequence();
      der.writeOID(SIGN_ALGS[sig.algo]);
      if (sig.algo.match(/^rsa-/))
        der.writeNull();
      der.endSequence();
      cert.issuer.toAsn1(der);
      der.startSequence();
      writeDate(der, cert.validFrom);
      writeDate(der, cert.validUntil);
      der.endSequence();
      var subject = cert.subjects[0];
      var altNames = cert.subjects.slice(1);
      subject.toAsn1(der);
      pkcs8.writePkcs8(der, cert.subjectKey);
      if (sig.extras && sig.extras.issuerUniqueID) {
        der.writeBuffer(sig.extras.issuerUniqueID, Local(1));
      }
      if (sig.extras && sig.extras.subjectUniqueID) {
        der.writeBuffer(sig.extras.subjectUniqueID, Local(2));
      }
      if (altNames.length > 0 || subject.type === "host" || cert.purposes !== void 0 && cert.purposes.length > 0 || sig.extras && sig.extras.exts) {
        der.startSequence(Local(3));
        der.startSequence();
        var exts = [];
        if (cert.purposes !== void 0 && cert.purposes.length > 0) {
          exts.push({
            oid: EXTS.basicConstraints,
            critical: true
          });
          exts.push({
            oid: EXTS.keyUsage,
            critical: true
          });
          exts.push({
            oid: EXTS.extKeyUsage,
            critical: true
          });
        }
        exts.push({ oid: EXTS.altName });
        if (sig.extras && sig.extras.exts)
          exts = sig.extras.exts;
        for (var i = 0; i < exts.length; ++i) {
          der.startSequence();
          der.writeOID(exts[i].oid);
          if (exts[i].critical !== void 0)
            der.writeBoolean(exts[i].critical);
          if (exts[i].oid === EXTS.altName) {
            der.startSequence(asn1.Ber.OctetString);
            der.startSequence();
            if (subject.type === "host") {
              der.writeString(
                subject.hostname,
                Context(2)
              );
            }
            for (var j = 0; j < altNames.length; ++j) {
              if (altNames[j].type === "host") {
                der.writeString(
                  altNames[j].hostname,
                  ALTNAME.DNSName
                );
              } else if (altNames[j].type === "email") {
                der.writeString(
                  altNames[j].email,
                  ALTNAME.RFC822Name
                );
              } else {
                der.startSequence(
                  ALTNAME.DirectoryName
                );
                altNames[j].toAsn1(der);
                der.endSequence();
              }
            }
            der.endSequence();
            der.endSequence();
          } else if (exts[i].oid === EXTS.basicConstraints) {
            der.startSequence(asn1.Ber.OctetString);
            der.startSequence();
            var ca = cert.purposes.indexOf("ca") !== -1;
            var pathLen = exts[i].pathLen;
            der.writeBoolean(ca);
            if (pathLen !== void 0)
              der.writeInt(pathLen);
            der.endSequence();
            der.endSequence();
          } else if (exts[i].oid === EXTS.extKeyUsage) {
            der.startSequence(asn1.Ber.OctetString);
            der.startSequence();
            cert.purposes.forEach(function(purpose) {
              if (purpose === "ca")
                return;
              if (KEYUSEBITS.indexOf(purpose) !== -1)
                return;
              var oid = purpose;
              if (EXTPURPOSE[purpose] !== void 0)
                oid = EXTPURPOSE[purpose];
              der.writeOID(oid);
            });
            der.endSequence();
            der.endSequence();
          } else if (exts[i].oid === EXTS.keyUsage) {
            der.startSequence(asn1.Ber.OctetString);
            if (exts[i].bits !== void 0) {
              der.writeBuffer(
                exts[i].bits,
                asn1.Ber.BitString
              );
            } else {
              var bits = writeBitField(
                cert.purposes,
                KEYUSEBITS
              );
              der.writeBuffer(
                bits,
                asn1.Ber.BitString
              );
            }
            der.endSequence();
          } else {
            der.writeBuffer(
              exts[i].data,
              asn1.Ber.OctetString
            );
          }
          der.endSequence();
        }
        der.endSequence();
        der.endSequence();
      }
      der.endSequence();
    }
    function readBitField(bits, bitIndex) {
      var bitLen = 8 * (bits.length - 1) - bits[0];
      var setBits = {};
      for (var i = 0; i < bitLen; ++i) {
        var byteN = 1 + Math.floor(i / 8);
        var bit = 7 - i % 8;
        var mask = 1 << bit;
        var bitVal = (bits[byteN] & mask) !== 0;
        var name = bitIndex[i];
        if (bitVal && typeof name === "string") {
          setBits[name] = true;
        }
      }
      return Object.keys(setBits);
    }
    function writeBitField(setBits, bitIndex) {
      var bitLen = bitIndex.length;
      var blen = Math.ceil(bitLen / 8);
      var unused = blen * 8 - bitLen;
      var bits = Buffer2.alloc(1 + blen);
      bits[0] = unused;
      for (var i = 0; i < bitLen; ++i) {
        var byteN = 1 + Math.floor(i / 8);
        var bit = 7 - i % 8;
        var mask = 1 << bit;
        var name = bitIndex[i];
        if (name === void 0)
          continue;
        var bitVal = setBits.indexOf(name) !== -1;
        if (bitVal) {
          bits[byteN] |= mask;
        }
      }
      return bits;
    }
  }
});

// node_modules/sshpk/lib/formats/x509-pem.js
var require_x509_pem = __commonJS({
  "node_modules/sshpk/lib/formats/x509-pem.js"(exports2, module2) {
    var x509 = require_x509();
    module2.exports = {
      read,
      verify: x509.verify,
      sign: x509.sign,
      write
    };
    var assert = require_assert();
    var asn1 = require_lib14();
    var Buffer2 = require_safer().Buffer;
    var algs = require_algs();
    var utils = require_utils5();
    var Key = require_key();
    var PrivateKey = require_private_key();
    var pem = require_pem();
    var Identity = require_identity();
    var Signature = require_signature();
    var Certificate = require_certificate2();
    function read(buf, options) {
      if (typeof buf !== "string") {
        assert.buffer(buf, "buf");
        buf = buf.toString("ascii");
      }
      var lines = buf.trim().split(/[\r\n]+/g);
      var m2;
      var si = -1;
      while (!m2 && si < lines.length) {
        m2 = lines[++si].match(
          /*JSSTYLED*/
          /[-]+[ ]*BEGIN CERTIFICATE[ ]*[-]+/
        );
      }
      assert.ok(m2, "invalid PEM header");
      var m22;
      var ei = lines.length;
      while (!m22 && ei > 0) {
        m22 = lines[--ei].match(
          /*JSSTYLED*/
          /[-]+[ ]*END CERTIFICATE[ ]*[-]+/
        );
      }
      assert.ok(m22, "invalid PEM footer");
      lines = lines.slice(si, ei + 1);
      var headers = {};
      while (true) {
        lines = lines.slice(1);
        m2 = lines[0].match(
          /*JSSTYLED*/
          /^([A-Za-z0-9-]+): (.+)$/
        );
        if (!m2)
          break;
        headers[m2[1].toLowerCase()] = m2[2];
      }
      lines = lines.slice(0, -1).join("");
      buf = Buffer2.from(lines, "base64");
      return x509.read(buf, options);
    }
    function write(cert, options) {
      var dbuf = x509.write(cert, options);
      var header = "CERTIFICATE";
      var tmp = dbuf.toString("base64");
      var len = tmp.length + tmp.length / 64 + 18 + 16 + header.length * 2 + 10;
      var buf = Buffer2.alloc(len);
      var o2 = 0;
      o2 += buf.write("-----BEGIN " + header + "-----\n", o2);
      for (var i = 0; i < tmp.length; ) {
        var limit = i + 64;
        if (limit > tmp.length)
          limit = tmp.length;
        o2 += buf.write(tmp.slice(i, limit), o2);
        buf[o2++] = 10;
        i = limit;
      }
      o2 += buf.write("-----END " + header + "-----\n", o2);
      return buf.slice(0, o2);
    }
  }
});

// node_modules/sshpk/lib/certificate.js
var require_certificate2 = __commonJS({
  "node_modules/sshpk/lib/certificate.js"(exports2, module2) {
    module2.exports = Certificate;
    var assert = require_assert();
    var Buffer2 = require_safer().Buffer;
    var algs = require_algs();
    var crypto2 = require("crypto");
    var Fingerprint = require_fingerprint();
    var Signature = require_signature();
    var errs = require_errors3();
    var util = require("util");
    var utils = require_utils5();
    var Key = require_key();
    var PrivateKey = require_private_key();
    var Identity = require_identity();
    var formats = {};
    formats["openssh"] = require_openssh_cert();
    formats["x509"] = require_x509();
    formats["pem"] = require_x509_pem();
    var CertificateParseError = errs.CertificateParseError;
    var InvalidAlgorithmError = errs.InvalidAlgorithmError;
    function Certificate(opts) {
      assert.object(opts, "options");
      assert.arrayOfObject(opts.subjects, "options.subjects");
      utils.assertCompatible(
        opts.subjects[0],
        Identity,
        [1, 0],
        "options.subjects"
      );
      utils.assertCompatible(
        opts.subjectKey,
        Key,
        [1, 0],
        "options.subjectKey"
      );
      utils.assertCompatible(opts.issuer, Identity, [1, 0], "options.issuer");
      if (opts.issuerKey !== void 0) {
        utils.assertCompatible(
          opts.issuerKey,
          Key,
          [1, 0],
          "options.issuerKey"
        );
      }
      assert.object(opts.signatures, "options.signatures");
      assert.buffer(opts.serial, "options.serial");
      assert.date(opts.validFrom, "options.validFrom");
      assert.date(opts.validUntil, "optons.validUntil");
      assert.optionalArrayOfString(opts.purposes, "options.purposes");
      this._hashCache = {};
      this.subjects = opts.subjects;
      this.issuer = opts.issuer;
      this.subjectKey = opts.subjectKey;
      this.issuerKey = opts.issuerKey;
      this.signatures = opts.signatures;
      this.serial = opts.serial;
      this.validFrom = opts.validFrom;
      this.validUntil = opts.validUntil;
      this.purposes = opts.purposes;
    }
    Certificate.formats = formats;
    Certificate.prototype.toBuffer = function(format3, options) {
      if (format3 === void 0)
        format3 = "x509";
      assert.string(format3, "format");
      assert.object(formats[format3], "formats[format]");
      assert.optionalObject(options, "options");
      return formats[format3].write(this, options);
    };
    Certificate.prototype.toString = function(format3, options) {
      if (format3 === void 0)
        format3 = "pem";
      return this.toBuffer(format3, options).toString();
    };
    Certificate.prototype.fingerprint = function(algo) {
      if (algo === void 0)
        algo = "sha256";
      assert.string(algo, "algorithm");
      var opts = {
        type: "certificate",
        hash: this.hash(algo),
        algorithm: algo
      };
      return new Fingerprint(opts);
    };
    Certificate.prototype.hash = function(algo) {
      assert.string(algo, "algorithm");
      algo = algo.toLowerCase();
      if (algs.hashAlgs[algo] === void 0)
        throw new InvalidAlgorithmError(algo);
      if (this._hashCache[algo])
        return this._hashCache[algo];
      var hash = crypto2.createHash(algo).update(this.toBuffer("x509")).digest();
      this._hashCache[algo] = hash;
      return hash;
    };
    Certificate.prototype.isExpired = function(when) {
      if (when === void 0)
        when = /* @__PURE__ */ new Date();
      return !(when.getTime() >= this.validFrom.getTime() && when.getTime() < this.validUntil.getTime());
    };
    Certificate.prototype.isSignedBy = function(issuerCert) {
      utils.assertCompatible(issuerCert, Certificate, [1, 0], "issuer");
      if (!this.issuer.equals(issuerCert.subjects[0]))
        return false;
      if (this.issuer.purposes && this.issuer.purposes.length > 0 && this.issuer.purposes.indexOf("ca") === -1) {
        return false;
      }
      return this.isSignedByKey(issuerCert.subjectKey);
    };
    Certificate.prototype.getExtension = function(keyOrOid) {
      assert.string(keyOrOid, "keyOrOid");
      var ext = this.getExtensions().filter(function(maybeExt) {
        if (maybeExt.format === "x509")
          return maybeExt.oid === keyOrOid;
        if (maybeExt.format === "openssh")
          return maybeExt.name === keyOrOid;
        return false;
      })[0];
      return ext;
    };
    Certificate.prototype.getExtensions = function() {
      var exts = [];
      var x509 = this.signatures.x509;
      if (x509 && x509.extras && x509.extras.exts) {
        x509.extras.exts.forEach(function(ext) {
          ext.format = "x509";
          exts.push(ext);
        });
      }
      var openssh = this.signatures.openssh;
      if (openssh && openssh.exts) {
        openssh.exts.forEach(function(ext) {
          ext.format = "openssh";
          exts.push(ext);
        });
      }
      return exts;
    };
    Certificate.prototype.isSignedByKey = function(issuerKey) {
      utils.assertCompatible(issuerKey, Key, [1, 2], "issuerKey");
      if (this.issuerKey !== void 0) {
        return this.issuerKey.fingerprint("sha512").matches(issuerKey);
      }
      var fmt = Object.keys(this.signatures)[0];
      var valid = formats[fmt].verify(this, issuerKey);
      if (valid)
        this.issuerKey = issuerKey;
      return valid;
    };
    Certificate.prototype.signWith = function(key) {
      utils.assertCompatible(key, PrivateKey, [1, 2], "key");
      var fmts = Object.keys(formats);
      var didOne = false;
      for (var i = 0; i < fmts.length; ++i) {
        if (fmts[i] !== "pem") {
          var ret = formats[fmts[i]].sign(this, key);
          if (ret === true)
            didOne = true;
        }
      }
      if (!didOne) {
        throw new Error("Failed to sign the certificate for any available certificate formats");
      }
    };
    Certificate.createSelfSigned = function(subjectOrSubjects, key, options) {
      var subjects;
      if (Array.isArray(subjectOrSubjects))
        subjects = subjectOrSubjects;
      else
        subjects = [subjectOrSubjects];
      assert.arrayOfObject(subjects);
      subjects.forEach(function(subject) {
        utils.assertCompatible(subject, Identity, [1, 0], "subject");
      });
      utils.assertCompatible(key, PrivateKey, [1, 2], "private key");
      assert.optionalObject(options, "options");
      if (options === void 0)
        options = {};
      assert.optionalObject(options.validFrom, "options.validFrom");
      assert.optionalObject(options.validUntil, "options.validUntil");
      var validFrom = options.validFrom;
      var validUntil = options.validUntil;
      if (validFrom === void 0)
        validFrom = /* @__PURE__ */ new Date();
      if (validUntil === void 0) {
        assert.optionalNumber(options.lifetime, "options.lifetime");
        var lifetime = options.lifetime;
        if (lifetime === void 0)
          lifetime = 10 * 365 * 24 * 3600;
        validUntil = /* @__PURE__ */ new Date();
        validUntil.setTime(validUntil.getTime() + lifetime * 1e3);
      }
      assert.optionalBuffer(options.serial, "options.serial");
      var serial = options.serial;
      if (serial === void 0)
        serial = Buffer2.from("0000000000000001", "hex");
      var purposes = options.purposes;
      if (purposes === void 0)
        purposes = [];
      if (purposes.indexOf("signature") === -1)
        purposes.push("signature");
      if (purposes.indexOf("ca") === -1)
        purposes.push("ca");
      if (purposes.indexOf("crl") === -1)
        purposes.push("crl");
      if (purposes.length <= 3) {
        var hostSubjects = subjects.filter(function(subject) {
          return subject.type === "host";
        });
        var userSubjects = subjects.filter(function(subject) {
          return subject.type === "user";
        });
        if (hostSubjects.length > 0) {
          if (purposes.indexOf("serverAuth") === -1)
            purposes.push("serverAuth");
        }
        if (userSubjects.length > 0) {
          if (purposes.indexOf("clientAuth") === -1)
            purposes.push("clientAuth");
        }
        if (userSubjects.length > 0 || hostSubjects.length > 0) {
          if (purposes.indexOf("keyAgreement") === -1)
            purposes.push("keyAgreement");
          if (key.type === "rsa" && purposes.indexOf("encryption") === -1)
            purposes.push("encryption");
        }
      }
      var cert = new Certificate({
        subjects,
        issuer: subjects[0],
        subjectKey: key.toPublic(),
        issuerKey: key.toPublic(),
        signatures: {},
        serial,
        validFrom,
        validUntil,
        purposes
      });
      cert.signWith(key);
      return cert;
    };
    Certificate.create = function(subjectOrSubjects, key, issuer, issuerKey, options) {
      var subjects;
      if (Array.isArray(subjectOrSubjects))
        subjects = subjectOrSubjects;
      else
        subjects = [subjectOrSubjects];
      assert.arrayOfObject(subjects);
      subjects.forEach(function(subject) {
        utils.assertCompatible(subject, Identity, [1, 0], "subject");
      });
      utils.assertCompatible(key, Key, [1, 0], "key");
      if (PrivateKey.isPrivateKey(key))
        key = key.toPublic();
      utils.assertCompatible(issuer, Identity, [1, 0], "issuer");
      utils.assertCompatible(issuerKey, PrivateKey, [1, 2], "issuer key");
      assert.optionalObject(options, "options");
      if (options === void 0)
        options = {};
      assert.optionalObject(options.validFrom, "options.validFrom");
      assert.optionalObject(options.validUntil, "options.validUntil");
      var validFrom = options.validFrom;
      var validUntil = options.validUntil;
      if (validFrom === void 0)
        validFrom = /* @__PURE__ */ new Date();
      if (validUntil === void 0) {
        assert.optionalNumber(options.lifetime, "options.lifetime");
        var lifetime = options.lifetime;
        if (lifetime === void 0)
          lifetime = 10 * 365 * 24 * 3600;
        validUntil = /* @__PURE__ */ new Date();
        validUntil.setTime(validUntil.getTime() + lifetime * 1e3);
      }
      assert.optionalBuffer(options.serial, "options.serial");
      var serial = options.serial;
      if (serial === void 0)
        serial = Buffer2.from("0000000000000001", "hex");
      var purposes = options.purposes;
      if (purposes === void 0)
        purposes = [];
      if (purposes.indexOf("signature") === -1)
        purposes.push("signature");
      if (options.ca === true) {
        if (purposes.indexOf("ca") === -1)
          purposes.push("ca");
        if (purposes.indexOf("crl") === -1)
          purposes.push("crl");
      }
      var hostSubjects = subjects.filter(function(subject) {
        return subject.type === "host";
      });
      var userSubjects = subjects.filter(function(subject) {
        return subject.type === "user";
      });
      if (hostSubjects.length > 0) {
        if (purposes.indexOf("serverAuth") === -1)
          purposes.push("serverAuth");
      }
      if (userSubjects.length > 0) {
        if (purposes.indexOf("clientAuth") === -1)
          purposes.push("clientAuth");
      }
      if (userSubjects.length > 0 || hostSubjects.length > 0) {
        if (purposes.indexOf("keyAgreement") === -1)
          purposes.push("keyAgreement");
        if (key.type === "rsa" && purposes.indexOf("encryption") === -1)
          purposes.push("encryption");
      }
      var cert = new Certificate({
        subjects,
        issuer,
        subjectKey: key,
        issuerKey: issuerKey.toPublic(),
        signatures: {},
        serial,
        validFrom,
        validUntil,
        purposes
      });
      cert.signWith(issuerKey);
      return cert;
    };
    Certificate.parse = function(data, format3, options) {
      if (typeof data !== "string")
        assert.buffer(data, "data");
      if (format3 === void 0)
        format3 = "auto";
      assert.string(format3, "format");
      if (typeof options === "string")
        options = { filename: options };
      assert.optionalObject(options, "options");
      if (options === void 0)
        options = {};
      assert.optionalString(options.filename, "options.filename");
      if (options.filename === void 0)
        options.filename = "(unnamed)";
      assert.object(formats[format3], "formats[format]");
      try {
        var k = formats[format3].read(data, options);
        return k;
      } catch (e) {
        throw new CertificateParseError(options.filename, format3, e);
      }
    };
    Certificate.isCertificate = function(obj, ver) {
      return utils.isCompatible(obj, Certificate, ver);
    };
    Certificate.prototype._sshpkApiVersion = [1, 1];
    Certificate._oldVersionDetect = function(obj) {
      return [1, 0];
    };
  }
});

// node_modules/sshpk/lib/fingerprint.js
var require_fingerprint = __commonJS({
  "node_modules/sshpk/lib/fingerprint.js"(exports2, module2) {
    module2.exports = Fingerprint;
    var assert = require_assert();
    var Buffer2 = require_safer().Buffer;
    var algs = require_algs();
    var crypto2 = require("crypto");
    var errs = require_errors3();
    var Key = require_key();
    var PrivateKey = require_private_key();
    var Certificate = require_certificate2();
    var utils = require_utils5();
    var FingerprintFormatError = errs.FingerprintFormatError;
    var InvalidAlgorithmError = errs.InvalidAlgorithmError;
    function Fingerprint(opts) {
      assert.object(opts, "options");
      assert.string(opts.type, "options.type");
      assert.buffer(opts.hash, "options.hash");
      assert.string(opts.algorithm, "options.algorithm");
      this.algorithm = opts.algorithm.toLowerCase();
      if (algs.hashAlgs[this.algorithm] !== true)
        throw new InvalidAlgorithmError(this.algorithm);
      this.hash = opts.hash;
      this.type = opts.type;
      this.hashType = opts.hashType;
    }
    Fingerprint.prototype.toString = function(format3) {
      if (format3 === void 0) {
        if (this.algorithm === "md5" || this.hashType === "spki")
          format3 = "hex";
        else
          format3 = "base64";
      }
      assert.string(format3);
      switch (format3) {
        case "hex":
          if (this.hashType === "spki")
            return this.hash.toString("hex");
          return addColons(this.hash.toString("hex"));
        case "base64":
          if (this.hashType === "spki")
            return this.hash.toString("base64");
          return sshBase64Format(
            this.algorithm,
            this.hash.toString("base64")
          );
        default:
          throw new FingerprintFormatError(void 0, format3);
      }
    };
    Fingerprint.prototype.matches = function(other) {
      assert.object(other, "key or certificate");
      if (this.type === "key" && this.hashType !== "ssh") {
        utils.assertCompatible(other, Key, [1, 7], "key with spki");
        if (PrivateKey.isPrivateKey(other)) {
          utils.assertCompatible(
            other,
            PrivateKey,
            [1, 6],
            "privatekey with spki support"
          );
        }
      } else if (this.type === "key") {
        utils.assertCompatible(other, Key, [1, 0], "key");
      } else {
        utils.assertCompatible(
          other,
          Certificate,
          [1, 0],
          "certificate"
        );
      }
      var theirHash = other.hash(this.algorithm, this.hashType);
      var theirHash2 = crypto2.createHash(this.algorithm).update(theirHash).digest("base64");
      if (this.hash2 === void 0)
        this.hash2 = crypto2.createHash(this.algorithm).update(this.hash).digest("base64");
      return this.hash2 === theirHash2;
    };
    var base64RE = /^[A-Za-z0-9+\/=]+$/;
    var hexRE = /^[a-fA-F0-9]+$/;
    Fingerprint.parse = function(fp, options) {
      assert.string(fp, "fingerprint");
      var alg, hash, enAlgs;
      if (Array.isArray(options)) {
        enAlgs = options;
        options = {};
      }
      assert.optionalObject(options, "options");
      if (options === void 0)
        options = {};
      if (options.enAlgs !== void 0)
        enAlgs = options.enAlgs;
      if (options.algorithms !== void 0)
        enAlgs = options.algorithms;
      assert.optionalArrayOfString(enAlgs, "algorithms");
      var hashType = "ssh";
      if (options.hashType !== void 0)
        hashType = options.hashType;
      assert.string(hashType, "options.hashType");
      var parts = fp.split(":");
      if (parts.length == 2) {
        alg = parts[0].toLowerCase();
        if (!base64RE.test(parts[1]))
          throw new FingerprintFormatError(fp);
        try {
          hash = Buffer2.from(parts[1], "base64");
        } catch (e) {
          throw new FingerprintFormatError(fp);
        }
      } else if (parts.length > 2) {
        alg = "md5";
        if (parts[0].toLowerCase() === "md5")
          parts = parts.slice(1);
        parts = parts.map(function(p3) {
          while (p3.length < 2)
            p3 = "0" + p3;
          if (p3.length > 2)
            throw new FingerprintFormatError(fp);
          return p3;
        });
        parts = parts.join("");
        if (!hexRE.test(parts) || parts.length % 2 !== 0)
          throw new FingerprintFormatError(fp);
        try {
          hash = Buffer2.from(parts, "hex");
        } catch (e) {
          throw new FingerprintFormatError(fp);
        }
      } else {
        if (hexRE.test(fp)) {
          hash = Buffer2.from(fp, "hex");
        } else if (base64RE.test(fp)) {
          hash = Buffer2.from(fp, "base64");
        } else {
          throw new FingerprintFormatError(fp);
        }
        switch (hash.length) {
          case 32:
            alg = "sha256";
            break;
          case 16:
            alg = "md5";
            break;
          case 20:
            alg = "sha1";
            break;
          case 64:
            alg = "sha512";
            break;
          default:
            throw new FingerprintFormatError(fp);
        }
        if (options.hashType === void 0)
          hashType = "spki";
      }
      if (alg === void 0)
        throw new FingerprintFormatError(fp);
      if (algs.hashAlgs[alg] === void 0)
        throw new InvalidAlgorithmError(alg);
      if (enAlgs !== void 0) {
        enAlgs = enAlgs.map(function(a) {
          return a.toLowerCase();
        });
        if (enAlgs.indexOf(alg) === -1)
          throw new InvalidAlgorithmError(alg);
      }
      return new Fingerprint({
        algorithm: alg,
        hash,
        type: options.type || "key",
        hashType
      });
    };
    function addColons(s) {
      return s.replace(/(.{2})(?=.)/g, "$1:");
    }
    function base64Strip(s) {
      return s.replace(/=*$/, "");
    }
    function sshBase64Format(alg, h) {
      return alg.toUpperCase() + ":" + base64Strip(h);
    }
    Fingerprint.isFingerprint = function(obj, ver) {
      return utils.isCompatible(obj, Fingerprint, ver);
    };
    Fingerprint.prototype._sshpkApiVersion = [1, 2];
    Fingerprint._oldVersionDetect = function(obj) {
      assert.func(obj.toString);
      assert.func(obj.matches);
      return [1, 0];
    };
  }
});

// node_modules/sshpk/lib/key.js
var require_key = __commonJS({
  "node_modules/sshpk/lib/key.js"(exports2, module2) {
    module2.exports = Key;
    var assert = require_assert();
    var algs = require_algs();
    var crypto2 = require("crypto");
    var Fingerprint = require_fingerprint();
    var Signature = require_signature();
    var DiffieHellman = require_dhe().DiffieHellman;
    var errs = require_errors3();
    var utils = require_utils5();
    var PrivateKey = require_private_key();
    var edCompat;
    try {
      edCompat = require_ed_compat();
    } catch (e) {
    }
    var InvalidAlgorithmError = errs.InvalidAlgorithmError;
    var KeyParseError = errs.KeyParseError;
    var formats = {};
    formats["auto"] = require_auto();
    formats["pem"] = require_pem();
    formats["pkcs1"] = require_pkcs1();
    formats["pkcs8"] = require_pkcs8();
    formats["rfc4253"] = require_rfc4253();
    formats["ssh"] = require_ssh();
    formats["ssh-private"] = require_ssh_private();
    formats["openssh"] = formats["ssh-private"];
    formats["dnssec"] = require_dnssec();
    formats["putty"] = require_putty();
    formats["ppk"] = formats["putty"];
    function Key(opts) {
      assert.object(opts, "options");
      assert.arrayOfObject(opts.parts, "options.parts");
      assert.string(opts.type, "options.type");
      assert.optionalString(opts.comment, "options.comment");
      var algInfo = algs.info[opts.type];
      if (typeof algInfo !== "object")
        throw new InvalidAlgorithmError(opts.type);
      var partLookup = {};
      for (var i = 0; i < opts.parts.length; ++i) {
        var part = opts.parts[i];
        partLookup[part.name] = part;
      }
      this.type = opts.type;
      this.parts = opts.parts;
      this.part = partLookup;
      this.comment = void 0;
      this.source = opts.source;
      this._rfc4253Cache = opts._rfc4253Cache;
      this._hashCache = {};
      var sz;
      this.curve = void 0;
      if (this.type === "ecdsa") {
        var curve = this.part.curve.data.toString();
        this.curve = curve;
        sz = algs.curves[curve].size;
      } else if (this.type === "ed25519" || this.type === "curve25519") {
        sz = 256;
        this.curve = "curve25519";
      } else {
        var szPart = this.part[algInfo.sizePart];
        sz = szPart.data.length;
        sz = sz * 8 - utils.countZeros(szPart.data);
      }
      this.size = sz;
    }
    Key.formats = formats;
    Key.prototype.toBuffer = function(format3, options) {
      if (format3 === void 0)
        format3 = "ssh";
      assert.string(format3, "format");
      assert.object(formats[format3], "formats[format]");
      assert.optionalObject(options, "options");
      if (format3 === "rfc4253") {
        if (this._rfc4253Cache === void 0)
          this._rfc4253Cache = formats["rfc4253"].write(this);
        return this._rfc4253Cache;
      }
      return formats[format3].write(this, options);
    };
    Key.prototype.toString = function(format3, options) {
      return this.toBuffer(format3, options).toString();
    };
    Key.prototype.hash = function(algo, type) {
      assert.string(algo, "algorithm");
      assert.optionalString(type, "type");
      if (type === void 0)
        type = "ssh";
      algo = algo.toLowerCase();
      if (algs.hashAlgs[algo] === void 0)
        throw new InvalidAlgorithmError(algo);
      var cacheKey = algo + "||" + type;
      if (this._hashCache[cacheKey])
        return this._hashCache[cacheKey];
      var buf;
      if (type === "ssh") {
        buf = this.toBuffer("rfc4253");
      } else if (type === "spki") {
        buf = formats.pkcs8.pkcs8ToBuffer(this);
      } else {
        throw new Error("Hash type " + type + " not supported");
      }
      var hash = crypto2.createHash(algo).update(buf).digest();
      this._hashCache[cacheKey] = hash;
      return hash;
    };
    Key.prototype.fingerprint = function(algo, type) {
      if (algo === void 0)
        algo = "sha256";
      if (type === void 0)
        type = "ssh";
      assert.string(algo, "algorithm");
      assert.string(type, "type");
      var opts = {
        type: "key",
        hash: this.hash(algo, type),
        algorithm: algo,
        hashType: type
      };
      return new Fingerprint(opts);
    };
    Key.prototype.defaultHashAlgorithm = function() {
      var hashAlgo = "sha1";
      if (this.type === "rsa")
        hashAlgo = "sha256";
      if (this.type === "dsa" && this.size > 1024)
        hashAlgo = "sha256";
      if (this.type === "ed25519")
        hashAlgo = "sha512";
      if (this.type === "ecdsa") {
        if (this.size <= 256)
          hashAlgo = "sha256";
        else if (this.size <= 384)
          hashAlgo = "sha384";
        else
          hashAlgo = "sha512";
      }
      return hashAlgo;
    };
    Key.prototype.createVerify = function(hashAlgo) {
      if (hashAlgo === void 0)
        hashAlgo = this.defaultHashAlgorithm();
      assert.string(hashAlgo, "hash algorithm");
      if (this.type === "ed25519" && edCompat !== void 0)
        return new edCompat.Verifier(this, hashAlgo);
      if (this.type === "curve25519")
        throw new Error("Curve25519 keys are not suitable for signing or verification");
      var v, nm, err;
      try {
        nm = hashAlgo.toUpperCase();
        v = crypto2.createVerify(nm);
      } catch (e) {
        err = e;
      }
      if (v === void 0 || err instanceof Error && err.message.match(/Unknown message digest/)) {
        nm = "RSA-";
        nm += hashAlgo.toUpperCase();
        v = crypto2.createVerify(nm);
      }
      assert.ok(v, "failed to create verifier");
      var oldVerify = v.verify.bind(v);
      var key = this.toBuffer("pkcs8");
      var curve = this.curve;
      var self2 = this;
      v.verify = function(signature, fmt) {
        if (Signature.isSignature(signature, [2, 0])) {
          if (signature.type !== self2.type)
            return false;
          if (signature.hashAlgorithm && signature.hashAlgorithm !== hashAlgo)
            return false;
          if (signature.curve && self2.type === "ecdsa" && signature.curve !== curve)
            return false;
          return oldVerify(key, signature.toBuffer("asn1"));
        } else if (typeof signature === "string" || Buffer.isBuffer(signature)) {
          return oldVerify(key, signature, fmt);
        } else if (Signature.isSignature(signature, [1, 0])) {
          throw new Error("signature was created by too old a version of sshpk and cannot be verified");
        } else {
          throw new TypeError("signature must be a string, Buffer, or Signature object");
        }
      };
      return v;
    };
    Key.prototype.createDiffieHellman = function() {
      if (this.type === "rsa")
        throw new Error("RSA keys do not support Diffie-Hellman");
      return new DiffieHellman(this);
    };
    Key.prototype.createDH = Key.prototype.createDiffieHellman;
    Key.parse = function(data, format3, options) {
      if (typeof data !== "string")
        assert.buffer(data, "data");
      if (format3 === void 0)
        format3 = "auto";
      assert.string(format3, "format");
      if (typeof options === "string")
        options = { filename: options };
      assert.optionalObject(options, "options");
      if (options === void 0)
        options = {};
      assert.optionalString(options.filename, "options.filename");
      if (options.filename === void 0)
        options.filename = "(unnamed)";
      assert.object(formats[format3], "formats[format]");
      try {
        var k = formats[format3].read(data, options);
        if (k instanceof PrivateKey)
          k = k.toPublic();
        if (!k.comment)
          k.comment = options.filename;
        return k;
      } catch (e) {
        if (e.name === "KeyEncryptedError")
          throw e;
        throw new KeyParseError(options.filename, format3, e);
      }
    };
    Key.isKey = function(obj, ver) {
      return utils.isCompatible(obj, Key, ver);
    };
    Key.prototype._sshpkApiVersion = [1, 7];
    Key._oldVersionDetect = function(obj) {
      assert.func(obj.toBuffer);
      assert.func(obj.fingerprint);
      if (obj.createDH)
        return [1, 4];
      if (obj.defaultHashAlgorithm)
        return [1, 3];
      if (obj.formats["auto"])
        return [1, 2];
      if (obj.formats["pkcs1"])
        return [1, 1];
      return [1, 0];
    };
  }
});

// node_modules/sshpk/lib/index.js
var require_lib15 = __commonJS({
  "node_modules/sshpk/lib/index.js"(exports2, module2) {
    var Key = require_key();
    var Fingerprint = require_fingerprint();
    var Signature = require_signature();
    var PrivateKey = require_private_key();
    var Certificate = require_certificate2();
    var Identity = require_identity();
    var errs = require_errors3();
    module2.exports = {
      /* top-level classes */
      Key,
      parseKey: Key.parse,
      Fingerprint,
      parseFingerprint: Fingerprint.parse,
      Signature,
      parseSignature: Signature.parse,
      PrivateKey,
      parsePrivateKey: PrivateKey.parse,
      generatePrivateKey: PrivateKey.generate,
      Certificate,
      parseCertificate: Certificate.parse,
      createSelfSignedCertificate: Certificate.createSelfSigned,
      createCertificate: Certificate.create,
      Identity,
      identityFromDN: Identity.parseDN,
      identityForHost: Identity.forHost,
      identityForUser: Identity.forUser,
      identityForEmail: Identity.forEmail,
      identityFromArray: Identity.fromArray,
      /* errors */
      FingerprintFormatError: errs.FingerprintFormatError,
      InvalidAlgorithmError: errs.InvalidAlgorithmError,
      KeyParseError: errs.KeyParseError,
      SignatureParseError: errs.SignatureParseError,
      KeyEncryptedError: errs.KeyEncryptedError,
      CertificateParseError: errs.CertificateParseError
    };
  }
});

// node_modules/node-opcua-crypto/dist/index.js
var require_dist33 = __commonJS({
  "node_modules/node-opcua-crypto/dist/index.js"(exports2, module2) {
    "use strict";
    var __create2 = Object.create;
    var __defProp2 = Object.defineProperty;
    var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
    var __getOwnPropNames2 = Object.getOwnPropertyNames;
    var __getProtoOf2 = Object.getPrototypeOf;
    var __hasOwnProp2 = Object.prototype.hasOwnProperty;
    var __export2 = (target, all) => {
      for (var name in all)
        __defProp2(target, name, { get: all[name], enumerable: true });
    };
    var __copyProps2 = (to, from, except, desc) => {
      if (from && typeof from === "object" || typeof from === "function") {
        for (let key of __getOwnPropNames2(from))
          if (!__hasOwnProp2.call(to, key) && key !== except)
            __defProp2(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc2(from, key)) || desc.enumerable });
      }
      return to;
    };
    var __toESM2 = (mod, isNodeMode, target) => (target = mod != null ? __create2(__getProtoOf2(mod)) : {}, __copyProps2(
      // If the importer is in node compatibility mode or this is not an ESM
      // file that has been converted to a CommonJS file using a Babel-
      // compatible transform (i.e. "__esModule" has not been set), then set
      // "default" to the CommonJS "module.exports" for node compatibility.
      isNodeMode || !mod || !mod.__esModule ? __defProp2(target, "default", { value: mod, enumerable: true }) : target,
      mod
    ));
    var __toCommonJS2 = (mod) => __copyProps2(__defProp2({}, "__esModule", { value: true }), mod);
    var node_opcua_crypto_exports = {};
    __export2(node_opcua_crypto_exports, {
      CertificatePurpose: () => CertificatePurpose,
      PaddingAlgorithm: () => PaddingAlgorithm,
      RSA_PKCS1_OAEP_PADDING: () => RSA_PKCS1_OAEP_PADDING,
      RSA_PKCS1_PADDING: () => RSA_PKCS1_PADDING,
      Subject: () => Subject,
      TagType: () => TagType,
      _coercePrivateKey: () => _coercePrivateKey,
      _findBlockAtIndex: () => _findBlockAtIndex,
      _getBlock: () => _getBlock,
      _readAlgorithmIdentifier: () => _readAlgorithmIdentifier,
      _readBitString: () => _readBitString,
      _readBooleanValue: () => _readBooleanValue,
      _readDirectoryName: () => _readDirectoryName,
      _readECCAlgorithmIdentifier: () => _readECCAlgorithmIdentifier,
      _readExtension: () => _readExtension,
      _readIntegerAsByteString: () => _readIntegerAsByteString,
      _readIntegerValue: () => _readIntegerValue,
      _readListOfInteger: () => _readListOfInteger,
      _readLongIntegerValue: () => _readLongIntegerValue,
      _readObjectIdentifier: () => _readObjectIdentifier,
      _readOctetString: () => _readOctetString,
      _readSignatureValue: () => _readSignatureValue,
      _readSignatureValueBin: () => _readSignatureValueBin,
      _readStruct: () => _readStruct,
      _readTime: () => _readTime,
      _readValue: () => _readValue,
      _readVersionValue: () => _readVersionValue,
      certificateMatchesPrivateKey: () => certificateMatchesPrivateKey,
      coerceCertificate: () => coerceCertificate,
      coerceCertificatePem: () => coerceCertificatePem,
      coercePEMorDerToPrivateKey: () => coercePEMorDerToPrivateKey,
      coercePrivateKeyPem: () => coercePrivateKeyPem,
      coercePublicKeyPem: () => coercePublicKeyPem,
      coerceRsaPublicKeyPem: () => coerceRsaPublicKeyPem,
      combine_der: () => combine_der,
      compactDirectoryName: () => compactDirectoryName,
      computeDerivedKeys: () => computeDerivedKeys,
      computePaddingFooter: () => computePaddingFooter,
      convertPEMtoDER: () => convertPEMtoDER,
      createCertificateSigningRequest: () => createCertificateSigningRequest,
      createPrivateKeyFromNodeJSCrypto: () => createPrivateKeyFromNodeJSCrypto,
      createSelfSignedCertificate: () => createSelfSignedCertificate,
      decryptBufferWithDerivedKeys: () => decryptBufferWithDerivedKeys,
      derToPrivateKey: () => derToPrivateKey,
      encryptBufferWithDerivedKeys: () => encryptBufferWithDerivedKeys,
      exploreCertificate: () => exploreCertificate,
      exploreCertificateInfo: () => exploreCertificateInfo,
      exploreCertificateRevocationList: () => exploreCertificateRevocationList,
      exploreCertificateSigningRequest: () => exploreCertificateSigningRequest,
      explorePrivateKey: () => explorePrivateKey,
      extractPublicKeyFromCertificate: () => extractPublicKeyFromCertificate,
      extractPublicKeyFromCertificateSync: () => extractPublicKeyFromCertificateSync,
      formatBuffer2DigitHexWithColum: () => formatBuffer2DigitHexWithColum,
      generateKeyPair: () => generateKeyPair,
      generatePrivateKey: () => generatePrivateKey,
      generatePrivateKeyFile: () => generatePrivateKeyFile,
      generatePrivateKeyFileAlternate: () => generatePrivateKeyFileAlternate,
      getCertificateStore: () => getCertificateStore,
      hexDump: () => hexDump,
      identifyPemType: () => identifyPemType,
      isKeyObject: () => isKeyObject,
      makeMessageChunkSignature: () => makeMessageChunkSignature,
      makeMessageChunkSignatureWithDerivedKeys: () => makeMessageChunkSignatureWithDerivedKeys,
      makePrivateKeyFromPem: () => makePrivateKeyFromPem,
      makePrivateKeyThumbPrint: () => makePrivateKeyThumbPrint,
      makePseudoRandomBuffer: () => makePseudoRandomBuffer,
      makeSHA1Thumbprint: () => makeSHA1Thumbprint,
      parseBitString: () => parseBitString,
      pemToPrivateKey: () => pemToPrivateKey,
      privateDecrypt: () => privateDecrypt,
      privateDecrypt_long: () => privateDecrypt_long,
      privateDecrypt_native: () => privateDecrypt_native,
      privateKeyToPEM: () => privateKeyToPEM,
      publicEncrypt: () => publicEncrypt,
      publicEncrypt_long: () => publicEncrypt_long,
      publicEncrypt_native: () => publicEncrypt_native,
      publicKeyAndPrivateKeyMatches: () => publicKeyAndPrivateKeyMatches,
      readCertificate: () => readCertificate,
      readCertificatePEM: () => readCertificatePEM,
      readCertificateRevocationList: () => readCertificateRevocationList,
      readCertificateSigningRequest: () => readCertificateSigningRequest,
      readCertificationRequestInfo: () => readCertificationRequestInfo,
      readNameForCrl: () => readNameForCrl,
      readPrivateKey: () => readPrivateKey,
      readPrivateKeyPEM: () => readPrivateKeyPEM,
      readPrivateRsaKey: () => readPrivateRsaKey,
      readPublicKey: () => readPublicKey,
      readPublicKeyPEM: () => readPublicKeyPEM,
      readPublicRsaKey: () => readPublicRsaKey,
      readTag: () => readTag,
      readTbsCertificate: () => readTbsCertificate,
      reduceLength: () => reduceLength,
      removePadding: () => removePadding,
      removeTrailingLF: () => removeTrailingLF,
      rsaLengthPrivateKey: () => rsaLengthPrivateKey,
      rsaLengthPublicKey: () => rsaLengthPublicKey,
      rsaLengthRsaPublicKey: () => rsaLengthRsaPublicKey,
      setCertificateStore: () => setCertificateStore,
      split_der: () => split_der,
      toPem: () => toPem,
      toPem2: () => toPem2,
      verifyCertificateChain: () => verifyCertificateChain,
      verifyCertificateOrClrSignature: () => verifyCertificateOrClrSignature,
      verifyCertificateRevocationListSignature: () => verifyCertificateRevocationListSignature,
      verifyCertificateSignature: () => verifyCertificateSignature,
      verifyChunkSignature: () => verifyChunkSignature,
      verifyChunkSignatureWithDerivedKeys: () => verifyChunkSignatureWithDerivedKeys,
      verifyMessageChunkSignature: () => verifyMessageChunkSignature
    });
    module2.exports = __toCommonJS2(node_opcua_crypto_exports);
    var import_crypto3 = __toESM2(require("crypto"));
    var KeyObjectOrig = import_crypto3.default.KeyObject;
    var { createPrivateKey: createPrivateKeyFromNodeJSCrypto } = import_crypto3.default;
    function isKeyObject(mayBeKeyObject) {
      if (KeyObjectOrig) {
        return mayBeKeyObject instanceof KeyObjectOrig;
      }
      return typeof mayBeKeyObject === "object" && typeof mayBeKeyObject.type === "string";
    }
    var CertificatePurpose = /* @__PURE__ */ ((CertificatePurpose2) => {
      CertificatePurpose2[CertificatePurpose2["NotSpecified"] = 0] = "NotSpecified";
      CertificatePurpose2[CertificatePurpose2["ForCertificateAuthority"] = 1] = "ForCertificateAuthority";
      CertificatePurpose2[CertificatePurpose2["ForApplication"] = 2] = "ForApplication";
      CertificatePurpose2[CertificatePurpose2["ForUserAuthentication"] = 3] = "ForUserAuthentication";
      return CertificatePurpose2;
    })(CertificatePurpose || {});
    var import_assert5 = __toESM2(require("assert"));
    var import_crypto32 = require("crypto");
    var createFastUninitializedBuffer = Buffer.allocUnsafe ? Buffer.allocUnsafe : (size) => {
      return new Buffer(size);
    };
    var import_constants = __toESM2(require("constants"));
    var import_assert3 = __toESM2(require("assert"));
    var import_crypto22 = require("crypto");
    var import_hexy = __toESM2(require_hexy());
    var import_assert2 = __toESM2(require("assert"));
    var import_assert = __toESM2(require("assert"));
    var oid_map = {
      "0.9.2342.19200300.100.1.1": { d: "userID", c: "Some oddball X.500 attribute collection" },
      "0.9.2342.19200300.100.1.3": { d: "rfc822Mailbox", c: "Some oddball X.500 attribute collection" },
      "0.9.2342.19200300.100.1.25": { d: "domainComponent", c: "Men are from Mars, this OID is from Pluto" },
      "1.2.840.10045.2": { d: "publicKeyType", c: "ANSI X9.62" },
      "1.2.840.10045.2.1": { d: "ecPublicKey", c: "ANSI X9.62 public key type" },
      "1.2.840.10045.3.0.1": { d: "c2pnb163v1", c: "ANSI X9.62 named elliptic curve" },
      "1.2.840.10045.3.0.2": { d: "c2pnb163v2", c: "ANSI X9.62 named elliptic curve" },
      "1.2.840.10045.3.0.3": { d: "c2pnb163v3", c: "ANSI X9.62 named elliptic curve" },
      "1.2.840.10045.3.0.5": { d: "c2tnb191v1", c: "ANSI X9.62 named elliptic curve" },
      "1.2.840.10045.3.0.6": { d: "c2tnb191v2", c: "ANSI X9.62 named elliptic curve" },
      "1.2.840.10045.3.0.7": { d: "c2tnb191v3", c: "ANSI X9.62 named elliptic curve" },
      "1.2.840.10045.3.0.10": { d: "c2pnb208w1", c: "ANSI X9.62 named elliptic curve" },
      "1.2.840.10045.3.0.11": { d: "c2tnb239v1", c: "ANSI X9.62 named elliptic curve" },
      "1.2.840.10045.3.0.12": { d: "c2tnb239v2", c: "ANSI X9.62 named elliptic curve" },
      "1.2.840.10045.3.0.13": { d: "c2tnb239v3", c: "ANSI X9.62 named elliptic curve" },
      "1.2.840.10045.3.0.16": { d: "c2pnb272w1", c: "ANSI X9.62 named elliptic curve" },
      "1.2.840.10045.3.0.18": { d: "c2tnb359v1", c: "ANSI X9.62 named elliptic curve" },
      "1.2.840.10045.3.0.19": { d: "c2pnb368w1", c: "ANSI X9.62 named elliptic curve" },
      "1.2.840.10045.3.0.20": { d: "c2tnb431r1", c: "ANSI X9.62 named elliptic curve" },
      "1.2.840.10045.3.1.1": { d: "prime192v1", c: "ANSI X9.62 named elliptic curve" },
      "1.2.840.10045.3.1.2": { d: "prime192v2", c: "ANSI X9.62 named elliptic curve" },
      "1.2.840.10045.3.1.3": { d: "prime192v3", c: "ANSI X9.62 named elliptic curve" },
      "1.2.840.10045.3.1.4": { d: "prime239v1", c: "ANSI X9.62 named elliptic curve" },
      "1.2.840.10045.3.1.5": { d: "prime239v2", c: "ANSI X9.62 named elliptic curve" },
      "1.2.840.10045.3.1.6": { d: "prime239v3", c: "ANSI X9.62 named elliptic curve" },
      "1.2.840.10045.3.1.7": { d: "prime256v1", c: "ANSI X9.62 named elliptic curve" },
      "1.2.840.113549.1.1": { d: "pkcs-1", c: "", w: false },
      "1.2.840.113549.1.1.1": { d: "rsaEncryption", c: "PKCS #1", w: false },
      "1.2.840.113549.1.1.2": { d: "md2WithRSAEncryption", c: "PKCS #1", w: false },
      "1.2.840.113549.1.1.3": { d: "md4WithRSAEncryption", c: "PKCS #1", w: false },
      "1.2.840.113549.1.1.4": { d: "md5WithRSAEncryption", c: "PKCS #1", w: false },
      "1.2.840.113549.1.1.5": { d: "sha1WithRSAEncryption", c: "PKCS #1", w: false },
      "1.2.840.113549.1.1.7": { d: "rsaOAEP", c: "PKCS #1", w: false },
      "1.2.840.113549.1.1.8": { d: "pkcs1-MGF", c: "PKCS #1", w: false },
      "1.2.840.113549.1.1.9": { d: "rsaOAEP-pSpecified", c: "PKCS #1", w: false },
      "1.2.840.113549.1.1.10": { d: "rsaPSS", c: "PKCS #1", w: false },
      "1.2.840.113549.1.1.11": { d: "sha256WithRSAEncryption", c: "PKCS #1", w: false },
      "1.2.840.113549.1.1.12": { d: "sha384WithRSAEncryption", c: "PKCS #1", w: false },
      "1.2.840.113549.1.1.13": { d: "sha512WithRSAEncryption", c: "PKCS #1", w: false },
      "1.2.840.113549.1.1.14": { d: "sha224WithRSAEncryption", c: "PKCS #1", w: false },
      "1.2.840.113549.1.9.1": {
        d: "emailAddress",
        c: "PKCS #9. Deprecated, use an altName extension instead",
        w: false
      },
      "1.2.840.113549.1.9.2": { d: "unstructuredName", c: "PKCS #9", w: false },
      "1.2.840.113549.1.9.3": { d: "contentType", c: "PKCS #9", w: false },
      "1.2.840.113549.1.9.4": { d: "messageDigest", c: "PKCS #9", w: false },
      "1.2.840.113549.1.9.5": { d: "signingTime", c: "PKCS #9", w: false },
      "1.2.840.113549.1.9.6": { d: "countersignature", c: "PKCS #9", w: false },
      "1.2.840.113549.1.9.7": { d: "challengePassword", c: "PKCS #9", w: false },
      "1.2.840.113549.1.9.8": { d: "unstructuredAddress", c: "PKCS #9", w: false },
      "1.2.840.113549.1.9.9": { d: "extendedCertificateAttributes", c: "PKCS #9", w: false },
      "1.2.840.113549.1.9.10": { d: "issuerAndSerialNumber", c: "PKCS #9 experimental", w: true },
      "1.2.840.113549.1.9.11": { d: "passwordCheck", c: "PKCS #9 experimental", w: true },
      "1.2.840.113549.1.9.12": { d: "publicKey", c: "PKCS #9 experimental", w: true },
      "1.2.840.113549.1.9.13": { d: "signingDescription", c: "PKCS #9", w: false },
      "1.2.840.113549.1.9.14": { d: "extensionRequest", c: "PKCS #9 via CRMF", w: false },
      "1.3.6.1.4.1.311.2.1.21": { d: "1.3.6.1.4.1.311.2.1.21", c: "SPC_INDIVIDUAL_SP_KEY_PURPOSE_OBJID" },
      "1.3.6.1.4.1.311.2.1.22": { d: "1.3.6.1.4.1.311.2.1.22", c: "SPC_COMMERCIAL_SP_KEY_PURPOSE_OBJID" },
      "1.3.6.1.4.1.311.10.3.1": { d: "1.3.6.1.4.1.311.10.3.1", c: "Signer of CTLs -- szOID_KP_CTL_USAGE_SIGNING" },
      "1.3.6.1.4.1.311.10.3.4": { d: "1.3.6.1.4.1.311.10.3.4", c: "szOID_EFS_RECOVERY (Encryption File System)" },
      "1.3.6.1.5.5.7.3.17": { d: "1.3.6.1.5.5.7.3.17", c: "Internet Key Exchange (IKE)" },
      "1.3.6.1.5.5.7.3.1": { d: "serverAuth", c: "PKIX key purpose" },
      "1.3.6.1.5.5.7.3.2": { d: "clientAuth", c: "PKIX key purpose" },
      "1.3.6.1.5.5.7.3.3": { d: "codeSigning", c: "PKIX key purpose" },
      "1.3.6.1.5.5.7.3.4": { d: "emailProtection", c: "PKIX key purpose" },
      "1.3.6.1.5.5.7.3.5": { d: "ipsecEndSystem", c: "PKIX key purpose" },
      "1.3.6.1.5.5.7.3.6": { d: "ipsecTunnel", c: "PKIX key purpose" },
      "1.3.6.1.5.5.7.3.7": { d: "ipsecUser", c: "PKIX key purpose" },
      "1.3.6.1.5.5.7.3.8": { d: "timeStamping", c: "PKIX key purpose" },
      "1.3.6.1.5.5.7.3.9": { d: "ocspSigning", c: "PKIX key purpose" },
      "1.3.6.1.5.5.7.3.10": { d: "dvcs", c: "PKIX key purpose" },
      "1.3.6.1.5.5.7.3.11": { d: "sbgpCertAAServerAuth", c: "PKIX key purpose" },
      "1.3.6.1.5.5.7.3.13": { d: "eapOverPPP", c: "PKIX key purpose" },
      "1.3.6.1.5.5.7.3.14": { d: "eapOverLAN", c: "PKIX key purpose" },
      "1.3.36.3.3.2.8.1.1.1": { d: "brainpoolP160r1", c: "ECC Brainpool Standard Curves and Curve Generation" },
      "1.3.36.3.3.2.8.1.1.2": { d: "brainpoolP160t1", c: "ECC Brainpool Standard Curves and Curve Generation" },
      "1.3.36.3.3.2.8.1.1.3": { d: "brainpoolP192r1", c: "ECC Brainpool Standard Curves and Curve Generation" },
      "1.3.36.3.3.2.8.1.1.4": { d: "brainpoolP192t1", c: "ECC Brainpool Standard Curves and Curve Generation" },
      "1.3.36.3.3.2.8.1.1.5": { d: "brainpoolP224r1", c: "ECC Brainpool Standard Curves and Curve Generation" },
      "1.3.36.3.3.2.8.1.1.6": { d: "brainpoolP224t1", c: "ECC Brainpool Standard Curves and Curve Generation" },
      "1.3.36.3.3.2.8.1.1.7": { d: "brainpoolP256r1", c: "ECC Brainpool Standard Curves and Curve Generation" },
      "1.3.36.3.3.2.8.1.1.8": { d: "brainpoolP256t1", c: "ECC Brainpool Standard Curves and Curve Generation" },
      "1.3.36.3.3.2.8.1.1.9": { d: "brainpoolP320r1", c: "ECC Brainpool Standard Curves and Curve Generation" },
      "1.3.36.3.3.2.8.1.1.10": { d: "brainpoolP320t1", c: "ECC Brainpool Standard Curves and Curve Generation" },
      "1.3.36.3.3.2.8.1.1.11": { d: "brainpoolP384r1", c: "ECC Brainpool Standard Curves and Curve Generation" },
      "1.3.36.3.3.2.8.1.1.12": { d: "brainpoolP384t1", c: "ECC Brainpool Standard Curves and Curve Generation" },
      "1.3.36.3.3.2.8.1.1.13": { d: "brainpoolP512r1", c: "ECC Brainpool Standard Curves and Curve Generation" },
      "1.3.36.3.3.2.8.1.1.14": { d: "brainpoolP512t1", c: "ECC Brainpool Standard Curves and Curve Generation" },
      "2.5.4.0": { d: "objectClass", c: "X.520 DN component", w: false },
      "2.5.4.1": { d: "aliasedEntryName", c: "X.520 DN component", w: false },
      "2.5.4.2": { d: "knowledgeInformation", c: "X.520 DN component", w: false },
      "2.5.4.3": { d: "commonName", c: "X.520 DN component", w: false },
      "2.5.4.4": { d: "surname", c: "X.520 DN component", w: false },
      "2.5.4.5": { d: "serialNumber", c: "X.520 DN component", w: false },
      "2.5.4.6": { d: "countryName", c: "X.520 DN component", w: false },
      "2.5.4.7": { d: "localityName", c: "X.520 DN component", w: false },
      "2.5.4.7.1": { d: "collectiveLocalityName", c: "X.520 DN component", w: false },
      "2.5.4.8": { d: "stateOrProvinceName", c: "X.520 DN component", w: false },
      "2.5.4.8.1": { d: "collectiveStateOrProvinceName", c: "X.520 DN component", w: false },
      "2.5.4.9": { d: "streetAddress", c: "X.520 DN component", w: false },
      "2.5.4.9.1": { d: "collectiveStreetAddress", c: "X.520 DN component", w: false },
      "2.5.4.10": { d: "organizationName", c: "X.520 DN component", w: false },
      "2.5.4.10.1": { d: "collectiveOrganizationName", c: "X.520 DN component", w: false },
      "2.5.4.11": { d: "organizationalUnitName", c: "X.520 DN component", w: false },
      "2.5.4.11.1": { d: "collectiveOrganizationalUnitName", c: "X.520 DN component", w: false },
      "2.5.4.12": { d: "title", c: "X.520 DN component", w: false },
      "2.5.4.13": { d: "description", c: "X.520 DN component", w: false },
      "2.5.4.14": { d: "searchGuide", c: "X.520 DN component", w: false },
      "2.5.4.15": { d: "businessCategory", c: "X.520 DN component", w: false },
      "2.5.4.16": { d: "postalAddress", c: "X.520 DN component", w: false },
      "2.5.4.16.1": { d: "collectivePostalAddress", c: "X.520 DN component", w: false },
      "2.5.4.17": { d: "postalCode", c: "X.520 DN component", w: false },
      "2.5.4.17.1": { d: "collectivePostalCode", c: "X.520 DN component", w: false },
      "2.5.4.18": { d: "postOfficeBox", c: "X.520 DN component", w: false },
      "2.5.4.18.1": { d: "collectivePostOfficeBox", c: "X.520 DN component", w: false },
      "2.5.4.19": { d: "physicalDeliveryOfficeName", c: "X.520 DN component", w: false },
      "2.5.4.19.1": { d: "collectivePhysicalDeliveryOfficeName", c: "X.520 DN component", w: false },
      "2.5.4.20": { d: "telephoneNumber", c: "X.520 DN component", w: false },
      "2.5.4.20.1": { d: "collectiveTelephoneNumber", c: "X.520 DN component", w: false },
      "2.5.4.21": { d: "telexNumber", c: "X.520 DN component", w: false },
      "2.5.4.21.1": { d: "collectiveTelexNumber", c: "X.520 DN component", w: false },
      "2.5.4.22": { d: "teletexTerminalIdentifier", c: "X.520 DN component", w: false },
      "2.5.4.22.1": { d: "collectiveTeletexTerminalIdentifier", c: "X.520 DN component", w: false },
      "2.5.4.23": { d: "facsimileTelephoneNumber", c: "X.520 DN component", w: false },
      "2.5.4.23.1": { d: "collectiveFacsimileTelephoneNumber", c: "X.520 DN component", w: false },
      "2.5.4.24": { d: "x121Address", c: "X.520 DN component", w: false },
      "2.5.4.25": { d: "internationalISDNNumber", c: "X.520 DN component", w: false },
      "2.5.4.25.1": { d: "collectiveInternationalISDNNumber", c: "X.520 DN component", w: false },
      "2.5.4.26": { d: "registeredAddress", c: "X.520 DN component", w: false },
      "2.5.4.27": { d: "destinationIndicator", c: "X.520 DN component", w: false },
      "2.5.4.28": { d: "preferredDeliveryMehtod", c: "X.520 DN component", w: false },
      "2.5.4.29": { d: "presentationAddress", c: "X.520 DN component", w: false },
      "2.5.4.30": { d: "supportedApplicationContext", c: "X.520 DN component", w: false },
      "2.5.4.31": { d: "member", c: "X.520 DN component", w: false },
      "2.5.4.32": { d: "owner", c: "X.520 DN component", w: false },
      "2.5.4.33": { d: "roleOccupant", c: "X.520 DN component", w: false },
      "2.5.4.34": { d: "seeAlso", c: "X.520 DN component", w: false },
      "2.5.4.35": { d: "userPassword", c: "X.520 DN component", w: false },
      "2.5.4.36": { d: "userCertificate", c: "X.520 DN component", w: false },
      "2.5.4.37": { d: "caCertificate", c: "X.520 DN component", w: false },
      "2.5.4.38": { d: "authorityRevocationList", c: "X.520 DN component", w: false },
      "2.5.4.39": { d: "certificateRevocationList", c: "X.520 DN component", w: false },
      "2.5.4.40": { d: "crossCertificatePair", c: "X.520 DN component", w: false },
      "2.5.4.41": { d: "name", c: "X.520 DN component", w: false },
      "2.5.4.42": { d: "givenName", c: "X.520 DN component", w: false },
      "2.5.4.43": { d: "initials", c: "X.520 DN component", w: false },
      "2.5.4.44": { d: "generationQualifier", c: "X.520 DN component", w: false },
      "2.5.4.45": { d: "uniqueIdentifier", c: "X.520 DN component", w: false },
      "2.5.4.46": { d: "dnQualifier", c: "X.520 DN component", w: false },
      "2.5.4.47": { d: "enhancedSearchGuide", c: "X.520 DN component", w: false },
      "2.5.4.48": { d: "protocolInformation", c: "X.520 DN component", w: false },
      "2.5.4.49": { d: "distinguishedName", c: "X.520 DN component", w: false },
      "2.5.4.50": { d: "uniqueMember", c: "X.520 DN component", w: false },
      "2.5.4.51": { d: "houseIdentifier", c: "X.520 DN component", w: false },
      "2.5.4.52": { d: "supportedAlgorithms", c: "X.520 DN component", w: false },
      "2.5.4.53": { d: "deltaRevocationList", c: "X.520 DN component", w: false },
      "2.5.4.54": { d: "dmdName", c: "X.520 DN component", w: false },
      "2.5.4.55": { d: "clearance", c: "X.520 DN component", w: false },
      "2.5.4.56": { d: "defaultDirQop", c: "X.520 DN component", w: false },
      "2.5.4.57": { d: "attributeIntegrityInfo", c: "X.520 DN component", w: false },
      "2.5.4.58": { d: "attributeCertificate", c: "X.520 DN component", w: false },
      "2.5.4.59": { d: "attributeCertificateRevocationList", c: "X.520 DN component", w: false },
      "2.5.4.60": { d: "confKeyInfo", c: "X.520 DN component", w: false },
      "2.5.4.61": { d: "aACertificate", c: "X.520 DN component", w: false },
      "2.5.4.62": { d: "attributeDescriptorCertificate", c: "X.520 DN component", w: false },
      "2.5.4.63": { d: "attributeAuthorityRevocationList", c: "X.520 DN component", w: false },
      "2.5.4.64": { d: "familyInformation", c: "X.520 DN component", w: false },
      "2.5.4.65": { d: "pseudonym", c: "X.520 DN component", w: false },
      "2.5.4.66": { d: "communicationsService", c: "X.520 DN component", w: false },
      "2.5.4.67": { d: "communicationsNetwork", c: "X.520 DN component", w: false },
      "2.5.4.68": { d: "certificationPracticeStmt", c: "X.520 DN component", w: false },
      "2.5.4.69": { d: "certificatePolicy", c: "X.520 DN component", w: false },
      "2.5.4.70": { d: "pkiPath", c: "X.520 DN component", w: false },
      "2.5.4.71": { d: "privPolicy", c: "X.520 DN component", w: false },
      "2.5.4.72": { d: "role", c: "X.520 DN component", w: false },
      "2.5.4.73": { d: "delegationPath", c: "X.520 DN component", w: false },
      "2.5.4.74": { d: "protPrivPolicy", c: "X.520 DN component", w: false },
      "2.5.4.75": { d: "xMLPrivilegeInfo", c: "X.520 DN component", w: false },
      "2.5.4.76": { d: "xmlPrivPolicy", c: "X.520 DN component", w: false },
      "2.5.4.82": { d: "permission", c: "X.520 DN component", w: false },
      "2.5.6.0": { d: "top", c: "X.520 objectClass", w: false },
      "2.5.6.1": { d: "alias", c: "X.520 objectClass", w: false },
      "2.5.6.2": { d: "country", c: "X.520 objectClass", w: false },
      "2.5.6.3": { d: "locality", c: "X.520 objectClass", w: false },
      "2.5.6.4": { d: "organization", c: "X.520 objectClass", w: false },
      "2.5.6.5": { d: "organizationalUnit", c: "X.520 objectClass", w: false },
      "2.5.6.6": { d: "person", c: "X.520 objectClass", w: false },
      "2.5.6.7": { d: "organizationalPerson", c: "X.520 objectClass", w: false },
      "2.5.6.8": { d: "organizationalRole", c: "X.520 objectClass", w: false },
      "2.5.6.9": { d: "groupOfNames", c: "X.520 objectClass", w: false },
      "2.5.6.10": { d: "residentialPerson", c: "X.520 objectClass", w: false },
      "2.5.6.11": { d: "applicationProcess", c: "X.520 objectClass", w: false },
      "2.5.6.12": { d: "applicationEntity", c: "X.520 objectClass", w: false },
      "2.5.6.13": { d: "dSA", c: "X.520 objectClass", w: false },
      "2.5.6.14": { d: "device", c: "X.520 objectClass", w: false },
      "2.5.6.15": { d: "strongAuthenticationUser", c: "X.520 objectClass", w: false },
      "2.5.6.16": { d: "certificateAuthority", c: "X.520 objectClass", w: false },
      "2.5.6.17": { d: "groupOfUniqueNames", c: "X.520 objectClass", w: false },
      "2.5.6.21": { d: "pkiUser", c: "X.520 objectClass", w: false },
      "2.5.6.22": { d: "pkiCA", c: "X.520 objectClass", w: false },
      "2.5.29.1": { d: "authorityKeyIdentifier", c: "X.509 extension. Deprecated, use 2 5 29 35 instead", w: true },
      "2.5.29.2": { d: "keyAttributes", c: "X.509 extension. Obsolete, use keyUsage/extKeyUsage instead", w: true },
      "2.5.29.3": { d: "certificatePolicies", c: "X.509 extension. Deprecated, use 2 5 29 32 instead", w: true },
      "2.5.29.4": {
        d: "keyUsageRestriction",
        c: "X.509 extension. Obsolete, use keyUsage/extKeyUsage instead",
        w: true
      },
      "2.5.29.5": { d: "policyMapping", c: "X.509 extension. Deprecated, use 2 5 29 33 instead", w: true },
      "2.5.29.6": { d: "subtreesConstraint", c: "X.509 extension. Obsolete, use nameConstraints instead", w: true },
      "2.5.29.7": { d: "subjectAltName", c: "X.509 extension. Deprecated, use 2 5 29 17 instead", w: true },
      "2.5.29.8": { d: "issuerAltName", c: "X.509 extension. Deprecated, use 2 5 29 18 instead", w: true },
      "2.5.29.9": { d: "subjectDirectoryAttributes", c: "X.509 extension", w: false },
      "2.5.29.10": { d: "basicConstraints", c: "X.509 extension. Deprecated, use 2 5 29 19 instead", w: true },
      "2.5.29.11": { d: "nameConstraints", c: "X.509 extension. Deprecated, use 2 5 29 30 instead", w: true },
      "2.5.29.12": { d: "policyConstraints", c: "X.509 extension. Deprecated, use 2 5 29 36 instead", w: true },
      "2.5.29.13": { d: "basicConstraints", c: "X.509 extension. Deprecated, use 2 5 29 19 instead", w: true },
      "2.5.29.14": { d: "subjectKeyIdentifier", c: "X.509 extension", w: false },
      "2.5.29.15": { d: "keyUsage", c: "X.509 extension", w: false },
      "2.5.29.16": { d: "privateKeyUsagePeriod", c: "X.509 extension", w: false },
      "2.5.29.17": { d: "subjectAltName", c: "X.509 extension", w: false },
      "2.5.29.18": { d: "issuerAltName", c: "X.509 extension", w: false },
      "2.5.29.19": { d: "basicConstraints", c: "X.509 extension", w: false },
      "2.5.29.20": { d: "cRLNumber", c: "X.509 extension", w: false },
      "2.5.29.21": { d: "cRLReason", c: "X.509 extension", w: false },
      "2.5.29.22": { d: "expirationDate", c: "X.509 extension. Deprecated, alternative OID uncertain", w: true },
      "2.5.29.23": { d: "instructionCode", c: "X.509 extension", w: false },
      "2.5.29.24": { d: "invalidityDate", c: "X.509 extension", w: false },
      "2.5.29.25": { d: "cRLDistributionPoints", c: "X.509 extension. Deprecated, use 2 5 29 31 instead", w: true },
      "2.5.29.26": {
        d: "issuingDistributionPoint",
        c: "X.509 extension. Deprecated, use 2 5 29 28 instead",
        w: true
      },
      "2.5.29.27": { d: "deltaCRLIndicator", c: "X.509 extension", w: false },
      "2.5.29.28": { d: "issuingDistributionPoint", c: "X.509 extension", w: false },
      "2.5.29.29": { d: "certificateIssuer", c: "X.509 extension", w: false },
      "2.5.29.30": { d: "nameConstraints", c: "X.509 extension", w: false },
      "2.5.29.31": { d: "cRLDistributionPoints", c: "X.509 extension", w: false },
      "2.5.29.32": { d: "certificatePolicies", c: "X.509 extension", w: false },
      "2.5.29.32.0": { d: "anyPolicy", c: "X.509 certificate policy", w: false },
      "2.5.29.33": { d: "policyMappings", c: "X.509 extension", w: false },
      "2.5.29.34": { d: "policyConstraints", c: "X.509 extension. Deprecated, use 2 5 29 36 instead", w: true },
      "2.5.29.35": { d: "authorityKeyIdentifier", c: "X.509 extension", w: false },
      "2.5.29.36": { d: "policyConstraints", c: "X.509 extension", w: false },
      "2.5.29.37": { d: "extKeyUsage", c: "X.509 extension", w: false },
      "2.5.29.37.0": { d: "anyExtendedKeyUsage", c: "X.509 extended key usage", w: false },
      "2.5.29.38": { d: "authorityAttributeIdentifier", c: "X.509 extension", w: false },
      "2.5.29.39": { d: "roleSpecCertIdentifier", c: "X.509 extension", w: false },
      "2.5.29.40": { d: "cRLStreamIdentifier", c: "X.509 extension", w: false },
      "2.5.29.41": { d: "basicAttConstraints", c: "X.509 extension", w: false },
      "2.5.29.42": { d: "delegatedNameConstraints", c: "X.509 extension", w: false },
      "2.5.29.43": { d: "timeSpecification", c: "X.509 extension", w: false },
      "2.5.29.44": { d: "cRLScope", c: "X.509 extension", w: false },
      "2.5.29.45": { d: "statusReferrals", c: "X.509 extension", w: false },
      "2.5.29.46": { d: "freshestCRL", c: "X.509 extension", w: false },
      "2.5.29.47": { d: "orderedList", c: "X.509 extension", w: false },
      "2.5.29.48": { d: "attributeDescriptor", c: "X.509 extension", w: false },
      "2.5.29.49": { d: "userNotice", c: "X.509 extension", w: false },
      "2.5.29.50": { d: "sOAIdentifier", c: "X.509 extension", w: false },
      "2.5.29.51": { d: "baseUpdateTime", c: "X.509 extension", w: false },
      "2.5.29.52": { d: "acceptableCertPolicies", c: "X.509 extension", w: false },
      "2.5.29.53": { d: "deltaInfo", c: "X.509 extension", w: false },
      "2.5.29.54": { d: "inhibitAnyPolicy", c: "X.509 extension", w: false },
      "2.5.29.55": { d: "targetInformation", c: "X.509 extension", w: false },
      "2.5.29.56": { d: "noRevAvail", c: "X.509 extension", w: false },
      "2.5.29.57": { d: "acceptablePrivilegePolicies", c: "X.509 extension", w: false },
      "2.5.29.58": { d: "toBeRevoked", c: "X.509 extension", w: false },
      "2.5.29.59": { d: "revokedGroups", c: "X.509 extension", w: false },
      "2.5.29.60": { d: "expiredCertsOnCRL", c: "X.509 extension", w: false },
      "2.5.29.61": { d: "indirectIssuer", c: "X.509 extension", w: false },
      "2.5.29.62": { d: "noAssertion", c: "X.509 extension", w: false },
      "2.5.29.63": { d: "aAissuingDistributionPoint", c: "X.509 extension", w: false },
      "2.5.29.64": { d: "issuedOnBehalfOf", c: "X.509 extension", w: false },
      "2.5.29.65": { d: "singleUse", c: "X.509 extension", w: false },
      "2.5.29.66": { d: "groupAC", c: "X.509 extension", w: false },
      "2.5.29.67": { d: "allowedAttAss", c: "X.509 extension", w: false },
      "2.5.29.68": { d: "attributeMappings", c: "X.509 extension", w: false },
      "2.5.29.69": { d: "holderNameConstraints", c: "X.509 extension", w: false },
      // Netscape certificate type
      // An X.509 v3 certificate extension used to identify whether
      // the certificate subject is an SSL client, …
      "2.16.840.1.113730.1": { d: "certExtension", c: "Netscape" },
      "2.16.840.1.113730.1.1": { d: "netscapeCertType", c: "Netscape certificate extension" },
      "2.16.840.1.113730.1.2": { d: "netscapeBaseUrl", c: "Netscape certificate extension" },
      "2.16.840.1.113730.1.3": { d: "netscapeRevocationUrl", c: "Netscape certificate extension" },
      "2.16.840.1.113730.1.4": { d: "netscapeCaRevocationUrl", c: "Netscape certificate extension" },
      "2.16.840.1.113730.1.7": { d: "netscapeCertRenewalUrl", c: "Netscape certificate extension" },
      "2.16.840.1.113730.1.8": { d: "netscapeCaPolicyUrl", c: "Netscape certificate extension" },
      "2.16.840.1.113730.1.9": { d: "HomePageUrl", c: "Netscape certificate extension" },
      "2.16.840.1.113730.1.10": { d: "EntityLogo", c: "Netscape certificate extension" },
      "2.16.840.1.113730.1.11": { d: "UserPicture", c: "Netscape certificate extension" },
      "2.16.840.1.113730.1.12": { d: "netscapeSslServerName", c: "Netscape certificate extension" },
      "2.16.840.1.113730.1.13": { d: "netscapeComment", c: "Netscape certificate extension" },
      done: { d: "", c: "" }
    };
    var TagType = /* @__PURE__ */ ((TagType3) => {
      TagType3[TagType3["BOOLEAN"] = 1] = "BOOLEAN";
      TagType3[TagType3["INTEGER"] = 2] = "INTEGER";
      TagType3[TagType3["BIT_STRING"] = 3] = "BIT_STRING";
      TagType3[TagType3["OCTET_STRING"] = 4] = "OCTET_STRING";
      TagType3[TagType3["NULL"] = 5] = "NULL";
      TagType3[TagType3["OBJECT_IDENTIFIER"] = 6] = "OBJECT_IDENTIFIER";
      TagType3[TagType3["UTF8String"] = 12] = "UTF8String";
      TagType3[TagType3["NumericString"] = 18] = "NumericString";
      TagType3[TagType3["PrintableString"] = 19] = "PrintableString";
      TagType3[TagType3["TeletexString"] = 20] = "TeletexString";
      TagType3[TagType3["IA5String"] = 22] = "IA5String";
      TagType3[TagType3["UTCTime"] = 23] = "UTCTime";
      TagType3[TagType3["GeneralizedTime"] = 24] = "GeneralizedTime";
      TagType3[TagType3["GraphicString"] = 25] = "GraphicString";
      TagType3[TagType3["VisibleString"] = 26] = "VisibleString";
      TagType3[TagType3["GeneralString"] = 27] = "GeneralString";
      TagType3[TagType3["UniversalString"] = 28] = "UniversalString";
      TagType3[TagType3["BMPString"] = 30] = "BMPString";
      TagType3[TagType3["SEQUENCE"] = 48] = "SEQUENCE";
      TagType3[TagType3["SET"] = 49] = "SET";
      TagType3[TagType3["A3"] = 163] = "A3";
      return TagType3;
    })(TagType || {});
    function readTag(buf, pos) {
      (0, import_assert.default)(buf instanceof Buffer);
      (0, import_assert.default)(Number.isFinite(pos) && pos >= 0);
      if (buf.length <= pos) {
        throw new Error("Invalid position : buf.length=" + buf.length + " pos =" + pos);
      }
      const tag = buf.readUInt8(pos);
      pos += 1;
      let length = buf.readUInt8(pos);
      pos += 1;
      if (length > 127) {
        const nbBytes = length & 127;
        length = 0;
        for (let i = 0; i < nbBytes; i++) {
          length = length * 256 + buf.readUInt8(pos);
          pos += 1;
        }
      }
      return { tag, position: pos, length };
    }
    function _readStruct(buf, blockInfo) {
      const length = blockInfo.length;
      let cursor = blockInfo.position;
      const end = blockInfo.position + length;
      const blocks = [];
      while (cursor < end) {
        const inner = readTag(buf, cursor);
        cursor = inner.position + inner.length;
        blocks.push(inner);
      }
      return blocks;
    }
    function parseBitString(buffer, start, end, maxLength) {
      const unusedBit = buffer.readUInt8(start), lenBit = (end - start - 1 << 3) - unusedBit, intro = "(" + lenBit + " bit)\n";
      let s = "", skip = unusedBit;
      for (let i = end - 1; i > start; --i) {
        const b = buffer.readUInt8(i);
        for (let j = skip; j < 8; ++j) {
          s += b >> j & 1 ? "1" : "0";
        }
        skip = 0;
        (0, import_assert.default)(s.length <= maxLength);
      }
      return intro + s;
    }
    function _readBitString(buffer, block) {
      (0, import_assert.default)(
        block.tag === 3
        /* BIT_STRING */
      );
      const data = _getBlock(buffer, block);
      const ignore_bits = data.readUInt8(0);
      return {
        lengthInBits: data.length * 8 - ignore_bits,
        lengthInBytes: data.length - 1,
        data: data.subarray(1),
        debug: parseBitString(buffer, block.position, block.length + block.position, 4 * 16 * 1024)
      };
    }
    function formatBuffer2DigitHexWithColum(buffer) {
      const value = [];
      for (let i = 0; i < buffer.length; i++) {
        value.push(("00" + buffer.readUInt8(i).toString(16)).substr(-2, 2));
      }
      return value.join(":").toUpperCase().replace(/^(00:)*/, "");
    }
    function _readOctetString(buffer, block) {
      (0, import_assert.default)(
        block.tag === 4
        /* OCTET_STRING */
      );
      const tag = readTag(buffer, block.position);
      (0, import_assert.default)(
        tag.tag === 4
        /* OCTET_STRING */
      );
      const nbBytes = tag.length;
      const pos = tag.position;
      const b = buffer.subarray(pos, pos + nbBytes);
      return b;
    }
    function _getBlock(buffer, block) {
      const start = block.position;
      const end = block.position + block.length;
      return buffer.subarray(start, end);
    }
    function _readIntegerAsByteString(buffer, block) {
      return _getBlock(buffer, block);
    }
    function _readListOfInteger(buffer) {
      const block = readTag(buffer, 0);
      const inner_blocks = _readStruct(buffer, block);
      return inner_blocks.map((bblock) => {
        return _readIntegerAsByteString(buffer, bblock);
      });
    }
    function parseOID(buffer, start, end) {
      let s = "", n = 0, bits = 0;
      for (let i = start; i < end; ++i) {
        const v = buffer.readUInt8(i);
        n = n * 128 + (v & 127);
        bits += 7;
        if (!(v & 128)) {
          if (s === "") {
            const m2 = n < 80 ? n < 40 ? 0 : 1 : 2;
            s = m2 + "." + (n - m2 * 40);
          } else {
            s += "." + n.toString();
          }
          n = 0;
          bits = 0;
        }
      }
      (0, import_assert.default)(bits === 0);
      return s;
    }
    function _readObjectIdentifier(buffer, block) {
      (0, import_assert.default)(
        block.tag === 6
        /* OBJECT_IDENTIFIER */
      );
      const b = buffer.subarray(block.position, block.position + block.length);
      const oid = parseOID(b, 0, block.length);
      return {
        oid,
        name: oid_map[oid] ? oid_map[oid].d : oid
      };
    }
    function _readAlgorithmIdentifier(buffer, block) {
      const inner_blocks = _readStruct(buffer, block);
      return {
        identifier: _readObjectIdentifier(buffer, inner_blocks[0]).name
      };
    }
    function _readECCAlgorithmIdentifier(buffer, block) {
      const inner_blocks = _readStruct(buffer, block);
      return {
        identifier: _readObjectIdentifier(buffer, inner_blocks[1]).name
        // difference with RSA as algorithm is second element of nested block
      };
    }
    function _readSignatureValueBin(buffer, block) {
      return _readBitString(buffer, block).data;
    }
    function _readSignatureValue(buffer, block) {
      return _readSignatureValueBin(buffer, block).toString("hex");
    }
    function _readLongIntegerValue(buffer, block) {
      (0, import_assert.default)(block.tag === 2, "expecting a INTEGER tag");
      const pos = block.position;
      const nbBytes = block.length;
      const buf = buffer.subarray(pos, pos + nbBytes);
      return buf;
    }
    function _readIntegerValue(buffer, block) {
      (0, import_assert.default)(block.tag === 2, "expecting a INTEGER tag");
      let pos = block.position;
      const nbBytes = block.length;
      (0, import_assert.default)(nbBytes < 4);
      let value = 0;
      for (let i = 0; i < nbBytes; i++) {
        value = value * 256 + buffer.readUInt8(pos);
        pos += 1;
      }
      return value;
    }
    function _readBooleanValue(buffer, block) {
      (0, import_assert.default)(block.tag === 1, "expecting a BOOLEAN tag. got " + TagType[block.tag]);
      const pos = block.position;
      const nbBytes = block.length;
      (0, import_assert.default)(nbBytes < 4);
      const value = buffer.readUInt8(pos) ? true : false;
      return value;
    }
    function _readVersionValue(buffer, block) {
      block = readTag(buffer, block.position);
      return _readIntegerValue(buffer, block);
    }
    function convertGeneralizedTime(str) {
      const year = parseInt(str.substr(0, 4), 10);
      const month = parseInt(str.substr(4, 2), 10) - 1;
      const day = parseInt(str.substr(6, 2), 10);
      const hours = parseInt(str.substr(8, 2), 10);
      const mins = parseInt(str.substr(10, 2), 10);
      const secs = parseInt(str.substr(12, 2), 10);
      return new Date(Date.UTC(year, month, day, hours, mins, secs));
    }
    function _readBMPString(buffer, block) {
      const strBuff = _getBlock(buffer, block);
      let str = "";
      for (let i = 0; i < strBuff.length; i += 2) {
        const word = strBuff.readUInt16BE(i);
        str += String.fromCharCode(word);
      }
      return str;
    }
    function convertUTCTime(str) {
      let year = parseInt(str.substr(0, 2), 10);
      const month = parseInt(str.substr(2, 2), 10) - 1;
      const day = parseInt(str.substr(4, 2), 10);
      const hours = parseInt(str.substr(6, 2), 10);
      const mins = parseInt(str.substr(8, 2), 10);
      const secs = parseInt(str.substr(10, 2), 10);
      year += year >= 50 ? 1900 : 2e3;
      return new Date(Date.UTC(year, month, day, hours, mins, secs));
    }
    function _readValue(buffer, block) {
      switch (block.tag) {
        case 1:
          return _readBooleanValue(buffer, block);
        case 30:
          return _readBMPString(buffer, block);
        case 19:
        case 20:
        case 12:
        case 18:
        case 22:
          return _getBlock(buffer, block).toString("ascii");
        case 23:
          return convertUTCTime(_getBlock(buffer, block).toString("ascii"));
        case 24:
          return convertGeneralizedTime(_getBlock(buffer, block).toString("ascii"));
        default:
          throw new Error("Invalid tag 0x" + block.tag.toString(16));
      }
    }
    function compactDirectoryName(d2) {
      return JSON.stringify(d2);
    }
    function _readDirectoryName(buffer, block) {
      const set_blocks = _readStruct(buffer, block);
      const names = {};
      for (const set_block of set_blocks) {
        (0, import_assert.default)(set_block.tag === 49);
        const blocks = _readStruct(buffer, set_block);
        (0, import_assert.default)(blocks.length === 1);
        (0, import_assert.default)(blocks[0].tag === 48);
        const sequenceBlock = _readStruct(buffer, blocks[0]);
        (0, import_assert.default)(sequenceBlock.length === 2);
        const type = _readObjectIdentifier(buffer, sequenceBlock[0]);
        names[type.name] = _readValue(buffer, sequenceBlock[1]);
      }
      return names;
    }
    function _findBlockAtIndex(blocks, index) {
      const tmp = blocks.filter((b) => b.tag === 160 + index || b.tag === 128 + index);
      if (tmp.length === 0) {
        return null;
      }
      return tmp[0];
    }
    function _readTime(buffer, block) {
      return _readValue(buffer, block);
    }
    var doDebug = false;
    function _readAttributeTypeAndValue(buffer, block) {
      let inner_blocks = _readStruct(buffer, block);
      inner_blocks = _readStruct(buffer, inner_blocks[0]);
      const data = {
        identifier: _readObjectIdentifier(buffer, inner_blocks[0]).name,
        value: _readValue(buffer, inner_blocks[1])
      };
      const result2 = {};
      for (const [key, value] of Object.entries(data)) {
        result2[key] = value;
      }
      return result2;
    }
    function _readRelativeDistinguishedName(buffer, block) {
      const inner_blocks = _readStruct(buffer, block);
      const data = inner_blocks.map((block2) => _readAttributeTypeAndValue(buffer, block2));
      const result2 = {};
      for (const e of data) {
        result2[e.identifier] = e.value;
      }
      return result2;
    }
    function _readName(buffer, block) {
      return _readRelativeDistinguishedName(buffer, block);
    }
    function _readValidity(buffer, block) {
      const inner_blocks = _readStruct(buffer, block);
      return {
        notBefore: _readTime(buffer, inner_blocks[0]),
        notAfter: _readTime(buffer, inner_blocks[1])
      };
    }
    function _readAuthorityKeyIdentifier(buffer) {
      const block_info = readTag(buffer, 0);
      const blocks = _readStruct(buffer, block_info);
      const keyIdentifier_block = _findBlockAtIndex(blocks, 0);
      const authorityCertIssuer_block = _findBlockAtIndex(blocks, 1);
      const authorityCertSerialNumber_block = _findBlockAtIndex(blocks, 2);
      function _readAuthorityCertIssuer(block) {
        const inner_blocks = _readStruct(buffer, block);
        const directoryName_block = _findBlockAtIndex(inner_blocks, 4);
        if (directoryName_block) {
          const a = _readStruct(buffer, directoryName_block);
          return _readDirectoryName(buffer, a[0]);
        } else {
          throw new Error("Invalid _readAuthorityCertIssuer");
        }
      }
      function _readAuthorityCertIssuerFingerPrint(block) {
        const inner_blocks = _readStruct(buffer, block);
        const directoryName_block = _findBlockAtIndex(inner_blocks, 4);
        if (!directoryName_block) {
          return "";
        }
        const a = _readStruct(buffer, directoryName_block);
        if (a.length < 1) {
          return "";
        }
        return directoryName_block ? formatBuffer2DigitHexWithColum(makeSHA1Thumbprint(_getBlock(buffer, a[0]))) : "";
      }
      const authorityCertIssuer = authorityCertIssuer_block ? _readAuthorityCertIssuer(authorityCertIssuer_block) : null;
      const authorityCertIssuerFingerPrint = authorityCertIssuer_block ? _readAuthorityCertIssuerFingerPrint(authorityCertIssuer_block) : "";
      return {
        authorityCertIssuer,
        authorityCertIssuerFingerPrint,
        serial: authorityCertSerialNumber_block ? formatBuffer2DigitHexWithColum(_getBlock(buffer, authorityCertSerialNumber_block)) : null,
        // can be null for self-signed cert
        keyIdentifier: keyIdentifier_block ? formatBuffer2DigitHexWithColum(_getBlock(buffer, keyIdentifier_block)) : null
        // can be null for self-signed certf
      };
    }
    function readBasicConstraint2_5_29_19(buffer, block) {
      const block_info = readTag(buffer, 0);
      const inner_blocks = _readStruct(buffer, block_info).slice(0, 2);
      let cA = false;
      let pathLengthConstraint = 0;
      let breakControl = 0;
      for (const inner_block of inner_blocks) {
        switch (inner_block.tag) {
          case 1:
            cA = _readBooleanValue(buffer, inner_block);
            break;
          case 2:
            pathLengthConstraint = _readIntegerValue(buffer, inner_block);
            breakControl = 1;
            break;
        }
        if (breakControl) {
          break;
        }
      }
      return { critical: true, cA, pathLengthConstraint };
    }
    function _readGeneralNames(buffer, block) {
      const _data = {
        1: { name: "rfc822Name", type: "IA5String" },
        2: { name: "dNSName", type: "IA5String" },
        3: { name: "x400Address", type: "ORAddress" },
        4: { name: "directoryName", type: "Name" },
        5: { name: "ediPartyName", type: "EDIPartyName" },
        6: { name: "uniformResourceIdentifier", type: "IA5String" },
        7: { name: "iPAddress", type: "OCTET_STRING" },
        8: { name: "registeredID", type: "OBJECT_IDENTIFIER" }
      };
      const blocks = _readStruct(buffer, block);
      function _readFromType(buffer2, block2, type) {
        switch (type) {
          case "IA5String":
            return buffer2.subarray(block2.position, block2.position + block2.length).toString("ascii");
          default:
            return buffer2.subarray(block2.position, block2.position + block2.length).toString("hex");
        }
      }
      const n = {};
      for (const block2 of blocks) {
        (0, import_assert2.default)((block2.tag & 128) === 128);
        const t = block2.tag & 127;
        const type = _data[t];
        if (!type) {
          throw new Error(" INVALID TYPE => " + t + "0x" + t.toString(16));
        }
        n[type.name] = n[type.name] || [];
        n[type.name].push(_readFromType(buffer, block2, type.type));
      }
      return n;
    }
    function _readSubjectAltNames(buffer) {
      const block_info = readTag(buffer, 0);
      return _readGeneralNames(buffer, block_info);
    }
    function readKeyUsage(oid, buffer) {
      const block_info = readTag(buffer, 0);
      let b2 = 0;
      let b3 = 0;
      if (block_info.length > 1) {
        b2 = buffer[block_info.position + 1];
        b3 = block_info.length > 2 ? buffer[block_info.position + 2] : 0;
      }
      return {
        // tslint:disable-next-line: no-bitwise
        digitalSignature: (b2 & 128) === 128,
        // tslint:disable-next-line: no-bitwise
        nonRepudiation: (b2 & 64) === 64,
        // tslint:disable-next-line: no-bitwise
        keyEncipherment: (b2 & 32) === 32,
        // tslint:disable-next-line: no-bitwise
        dataEncipherment: (b2 & 16) === 16,
        // tslint:disable-next-line: no-bitwise
        keyAgreement: (b2 & 8) === 8,
        // tslint:disable-next-line: no-bitwise
        keyCertSign: (b2 & 4) === 4,
        // tslint:disable-next-line: no-bitwise
        cRLSign: (b2 & 2) === 2,
        // tslint:disable-next-line: no-bitwise
        encipherOnly: (b2 & 1) === 1,
        // tslint:disable-next-line: no-bitwise
        decipherOnly: (b3 & 128) === 128
      };
    }
    function readExtKeyUsage(oid, buffer) {
      (0, import_assert2.default)(oid === "2.5.29.37");
      const block_info = readTag(buffer, 0);
      const inner_blocks = _readStruct(buffer, block_info);
      const extKeyUsage = {
        serverAuth: false,
        clientAuth: false,
        codeSigning: false,
        emailProtection: false,
        timeStamping: false,
        ipsecEndSystem: false,
        ipsecTunnel: false,
        ipsecUser: false,
        ocspSigning: false
      };
      for (const block of inner_blocks) {
        const identifier = _readObjectIdentifier(buffer, block);
        extKeyUsage[identifier.name] = true;
      }
      return extKeyUsage;
    }
    function _readSubjectPublicKey(buffer) {
      const block_info = readTag(buffer, 0);
      const blocks = _readStruct(buffer, block_info);
      return {
        modulus: buffer.subarray(blocks[0].position + 1, blocks[0].position + blocks[0].length)
      };
    }
    function _readExtension(buffer, block) {
      const inner_blocks = _readStruct(buffer, block);
      if (inner_blocks.length === 3) {
        (0, import_assert2.default)(
          inner_blocks[1].tag === 1
          /* BOOLEAN */
        );
        inner_blocks[1] = inner_blocks[2];
      }
      const identifier = _readObjectIdentifier(buffer, inner_blocks[0]);
      const buf = _getBlock(buffer, inner_blocks[1]);
      let value = null;
      switch (identifier.name) {
        case "subjectKeyIdentifier":
          value = formatBuffer2DigitHexWithColum(_readOctetString(buffer, inner_blocks[1]));
          break;
        case "subjectAltName":
          value = _readSubjectAltNames(buf);
          break;
        case "authorityKeyIdentifier":
          value = _readAuthorityKeyIdentifier(buf);
          break;
        case "basicConstraints":
          value = readBasicConstraint2_5_29_19(buf, inner_blocks[1]);
          break;
        case "certExtension":
          value = "basicConstraints ( not implemented yet) " + buf.toString("hex");
          break;
        case "extKeyUsage":
          value = readExtKeyUsage(identifier.oid, buf);
          break;
        case "keyUsage":
          value = readKeyUsage(identifier.oid, buf);
          break;
        default:
          value = "Unknown " + identifier.name + buf.toString("hex");
      }
      return {
        identifier,
        value
      };
    }
    function _readExtensions(buffer, block) {
      (0, import_assert2.default)(block.tag === 163);
      let inner_blocks = _readStruct(buffer, block);
      inner_blocks = _readStruct(buffer, inner_blocks[0]);
      const extensions2 = inner_blocks.map((block2) => _readExtension(buffer, block2));
      const result2 = {};
      for (const e of extensions2) {
        result2[e.identifier.name] = e.value;
      }
      return result2;
    }
    function _readSubjectPublicKeyInfo(buffer, block) {
      const inner_blocks = _readStruct(buffer, block);
      const algorithm = _readAlgorithmIdentifier(buffer, inner_blocks[0]);
      const subjectPublicKey = _readBitString(buffer, inner_blocks[1]);
      const data = subjectPublicKey.data;
      const values = _readListOfInteger(data);
      return {
        algorithm: algorithm.identifier,
        keyLength: values[0].length - 1,
        subjectPublicKey: _readSubjectPublicKey(subjectPublicKey.data)
        //xx values: values,
        //xx values_length : values.map(function (a){ return a.length; })
      };
    }
    function _readSubjectECCPublicKeyInfo(buffer, block) {
      const inner_blocks = _readStruct(buffer, block);
      const algorithm = _readECCAlgorithmIdentifier(buffer, inner_blocks[0]);
      const subjectPublicKey = _readBitString(buffer, inner_blocks[1]);
      const data = subjectPublicKey.data;
      return {
        algorithm: algorithm.identifier,
        keyLength: data.length - 1,
        subjectPublicKey: {
          modulus: data
        }
      };
    }
    function readTbsCertificate(buffer, block) {
      const blocks = _readStruct(buffer, block);
      let version, serialNumber, signature, issuer, validity, subject, subjectFingerPrint, extensions2;
      let subjectPublicKeyInfo;
      if (blocks.length === 6) {
        version = 1;
        serialNumber = formatBuffer2DigitHexWithColum(_readLongIntegerValue(buffer, blocks[0]));
        signature = _readAlgorithmIdentifier(buffer, blocks[1]);
        issuer = _readName(buffer, blocks[2]);
        validity = _readValidity(buffer, blocks[3]);
        subject = _readName(buffer, blocks[4]);
        subjectFingerPrint = formatBuffer2DigitHexWithColum(makeSHA1Thumbprint(_getBlock(buffer, blocks[4])));
        subjectPublicKeyInfo = _readSubjectPublicKeyInfo(buffer, blocks[5]);
        extensions2 = null;
      } else {
        const version_block = _findBlockAtIndex(blocks, 0);
        if (!version_block) {
          throw new Error("cannot find version block");
        }
        version = _readVersionValue(buffer, version_block) + 1;
        serialNumber = formatBuffer2DigitHexWithColum(_readLongIntegerValue(buffer, blocks[1]));
        signature = _readAlgorithmIdentifier(buffer, blocks[2]);
        issuer = _readName(buffer, blocks[3]);
        validity = _readValidity(buffer, blocks[4]);
        subject = _readName(buffer, blocks[5]);
        subjectFingerPrint = formatBuffer2DigitHexWithColum(makeSHA1Thumbprint(_getBlock(buffer, blocks[5])));
        const inner_block = _readStruct(buffer, blocks[6]);
        const what_type = _readAlgorithmIdentifier(buffer, inner_block[0]).identifier;
        switch (what_type) {
          case "rsaEncryption": {
            subjectPublicKeyInfo = _readSubjectPublicKeyInfo(buffer, blocks[6]);
            break;
          }
          case "ecPublicKey":
          default: {
            subjectPublicKeyInfo = _readSubjectECCPublicKeyInfo(buffer, blocks[6]);
            break;
          }
        }
        const extensionBlock = _findBlockAtIndex(blocks, 3);
        if (!extensionBlock) {
          doDebug && console.log("X509 certificate is invalid : cannot find extension block version =" + version_block);
          extensions2 = null;
        } else {
          extensions2 = _readExtensions(buffer, extensionBlock);
        }
      }
      return {
        version,
        serialNumber,
        signature,
        issuer,
        validity,
        subject,
        subjectFingerPrint,
        subjectPublicKeyInfo,
        extensions: extensions2
      };
    }
    function exploreCertificate(certificate) {
      (0, import_assert2.default)(certificate instanceof Buffer);
      if (!certificate._exploreCertificate_cache) {
        const block_info = readTag(certificate, 0);
        const blocks = _readStruct(certificate, block_info);
        certificate._exploreCertificate_cache = {
          tbsCertificate: readTbsCertificate(certificate, blocks[0]),
          signatureAlgorithm: _readAlgorithmIdentifier(certificate, blocks[1]),
          signatureValue: _readSignatureValue(certificate, blocks[2])
        };
      }
      return certificate._exploreCertificate_cache;
    }
    function split_der(certificateChain) {
      const certificate_chain = [];
      do {
        const block_info = readTag(certificateChain, 0);
        const length = block_info.position + block_info.length;
        const der_certificate = certificateChain.subarray(0, length);
        certificate_chain.push(der_certificate);
        certificateChain = certificateChain.subarray(length);
      } while (certificateChain.length > 0);
      return certificate_chain;
    }
    function combine_der(certificates) {
      for (const cert of certificates) {
        const b = split_der(cert);
        let sum = 0;
        b.forEach((block) => {
          const block_info = readTag(block, 0);
          (0, import_assert2.default)(block_info.position + block_info.length === block.length);
          sum += block.length;
        });
        (0, import_assert2.default)(sum === cert.length);
      }
      return Buffer.concat(certificates);
    }
    var import_jsrsasign = __toESM2(require_jsrsasign());
    var { hexy } = import_hexy.default;
    var PEM_REGEX = /^(-----BEGIN (.*)-----\r?\n([/+=a-zA-Z0-9\r\n]*)\r?\n-----END \2-----\r?\n?)/gm;
    var PEM_TYPE_REGEX = /^(-----BEGIN (.*)-----)/m;
    function identifyPemType(rawKey) {
      if (rawKey instanceof Buffer) {
        rawKey = rawKey.toString("utf8");
      }
      const match = PEM_TYPE_REGEX.exec(rawKey);
      return !match ? void 0 : match[2];
    }
    function removeTrailingLF(str) {
      const tmp = str.replace(/(\r|\n)+$/m, "").replace(/\r\n/gm, "\n");
      return tmp;
    }
    function toPem(raw_key, pem) {
      (0, import_assert3.default)(raw_key, "expecting a key");
      (0, import_assert3.default)(typeof pem === "string");
      let pemType = identifyPemType(raw_key);
      if (pemType) {
        return raw_key instanceof Buffer ? removeTrailingLF(raw_key.toString("utf8")) : removeTrailingLF(raw_key);
      } else {
        pemType = pem;
        (0, import_assert3.default)(["CERTIFICATE REQUEST", "CERTIFICATE", "RSA PRIVATE KEY", "PUBLIC KEY", "X509 CRL"].indexOf(pemType) >= 0);
        let b = raw_key.toString("base64");
        let str = "-----BEGIN " + pemType + "-----\n";
        while (b.length) {
          str += b.substring(0, 64) + "\n";
          b = b.substring(64);
        }
        str += "-----END " + pemType + "-----";
        return str;
      }
    }
    function convertPEMtoDER(raw_key) {
      let match;
      let pemType;
      let base64str;
      const parts = [];
      PEM_REGEX.lastIndex = 0;
      while ((match = PEM_REGEX.exec(raw_key)) !== null) {
        pemType = match[2];
        base64str = match[3];
        base64str = base64str.replace(/\r?\n/g, "");
        parts.push(Buffer.from(base64str, "base64"));
      }
      return combine_der(parts);
    }
    function hexDump(buffer, width) {
      if (!buffer) {
        return "<>";
      }
      width = width || 32;
      if (buffer.length > 1024) {
        return hexy(buffer.subarray(0, 1024), { width, format: "twos" }) + "\n .... ( " + buffer.length + ")";
      } else {
        return hexy(buffer, { width, format: "twos" });
      }
    }
    function makeMessageChunkSignature(chunk, options) {
      const signer = (0, import_crypto22.createSign)(options.algorithm);
      signer.update(chunk);
      const signature = signer.sign(options.privateKey.hidden);
      (0, import_assert3.default)(!options.signatureLength || signature.length === options.signatureLength);
      return signature;
    }
    function verifyMessageChunkSignature(blockToVerify, signature, options) {
      const verify = (0, import_crypto22.createVerify)(options.algorithm);
      verify.update(blockToVerify);
      return verify.verify(options.publicKey, signature);
    }
    function makeSHA1Thumbprint(buffer) {
      return (0, import_crypto22.createHash)("sha1").update(buffer).digest();
    }
    var RSA_PKCS1_OAEP_PADDING = import_constants.default.RSA_PKCS1_OAEP_PADDING;
    var RSA_PKCS1_PADDING = import_constants.default.RSA_PKCS1_PADDING;
    var PaddingAlgorithm = /* @__PURE__ */ ((PaddingAlgorithm2) => {
      PaddingAlgorithm2[PaddingAlgorithm2["RSA_PKCS1_OAEP_PADDING"] = 4] = "RSA_PKCS1_OAEP_PADDING";
      PaddingAlgorithm2[PaddingAlgorithm2["RSA_PKCS1_PADDING"] = 1] = "RSA_PKCS1_PADDING";
      return PaddingAlgorithm2;
    })(PaddingAlgorithm || {});
    (0, import_assert3.default)(4 === import_constants.default.RSA_PKCS1_OAEP_PADDING);
    (0, import_assert3.default)(1 === import_constants.default.RSA_PKCS1_PADDING);
    function publicEncrypt_native(buffer, publicKey, algorithm) {
      if (algorithm === void 0) {
        algorithm = 4;
      }
      return (0, import_crypto22.publicEncrypt)(
        {
          key: publicKey,
          padding: algorithm
        },
        buffer
      );
    }
    function privateDecrypt_native(buffer, privateKey, algorithm) {
      if (algorithm === void 0) {
        algorithm = 4;
      }
      try {
        return (0, import_crypto22.privateDecrypt)(
          {
            key: privateKey.hidden,
            padding: algorithm
          },
          buffer
        );
      } catch (err) {
        return Buffer.alloc(1);
      }
    }
    var publicEncrypt = publicEncrypt_native;
    var privateDecrypt = privateDecrypt_native;
    function publicEncrypt_long(buffer, publicKey, blockSize, padding, paddingAlgorithm) {
      if (paddingAlgorithm === void 0) {
        paddingAlgorithm = 4;
      }
      if (paddingAlgorithm === RSA_PKCS1_PADDING) {
        padding = padding || 11;
        if (padding !== 11)
          throw new Error("padding should be 11");
      } else if (paddingAlgorithm === RSA_PKCS1_OAEP_PADDING) {
        padding = padding || 42;
        if (padding !== 42)
          throw new Error("padding should be 42");
      } else {
        throw new Error("Invalid padding algorithm " + paddingAlgorithm);
      }
      const chunk_size = blockSize - padding;
      const nbBlocks = Math.ceil(buffer.length / chunk_size);
      const outputBuffer = createFastUninitializedBuffer(nbBlocks * blockSize);
      for (let i = 0; i < nbBlocks; i++) {
        const currentBlock = buffer.subarray(chunk_size * i, chunk_size * (i + 1));
        const encrypted_chunk = publicEncrypt(currentBlock, publicKey, paddingAlgorithm);
        if (encrypted_chunk.length !== blockSize) {
          throw new Error(`publicEncrypt_long unexpected chunk length ${encrypted_chunk.length}  expecting ${blockSize}`);
        }
        encrypted_chunk.copy(outputBuffer, i * blockSize);
      }
      return outputBuffer;
    }
    function privateDecrypt_long(buffer, privateKey, blockSize, paddingAlgorithm) {
      paddingAlgorithm = paddingAlgorithm || RSA_PKCS1_OAEP_PADDING;
      if (paddingAlgorithm !== RSA_PKCS1_PADDING && paddingAlgorithm !== RSA_PKCS1_OAEP_PADDING) {
        throw new Error("Invalid padding algorithm " + paddingAlgorithm);
      }
      const nbBlocks = Math.ceil(buffer.length / blockSize);
      const outputBuffer = createFastUninitializedBuffer(nbBlocks * blockSize);
      let total_length = 0;
      for (let i = 0; i < nbBlocks; i++) {
        const currentBlock = buffer.subarray(blockSize * i, Math.min(blockSize * (i + 1), buffer.length));
        const decrypted_buf = privateDecrypt(currentBlock, privateKey, paddingAlgorithm);
        decrypted_buf.copy(outputBuffer, total_length);
        total_length += decrypted_buf.length;
      }
      return outputBuffer.subarray(0, total_length);
    }
    function coerceCertificatePem(certificate) {
      if (certificate instanceof Buffer) {
        certificate = toPem(certificate, "CERTIFICATE");
      }
      (0, import_assert3.default)(typeof certificate === "string");
      return certificate;
    }
    function extractPublicKeyFromCertificateSync(certificate) {
      certificate = coerceCertificatePem(certificate);
      const key = import_jsrsasign.default.KEYUTIL.getKey(certificate);
      const publicKeyAsPem = import_jsrsasign.default.KEYUTIL.getPEM(key);
      (0, import_assert3.default)(typeof publicKeyAsPem === "string");
      return publicKeyAsPem;
    }
    function extractPublicKeyFromCertificate(certificate, callback) {
      let err1 = null;
      let keyPem;
      try {
        keyPem = extractPublicKeyFromCertificateSync(certificate);
      } catch (err) {
        err1 = err;
      }
      setImmediate(() => {
        callback(err1, keyPem);
      });
    }
    var import_assert4 = __toESM2(require("assert"));
    function coerceCertificate(certificate) {
      if (typeof certificate === "string") {
        certificate = convertPEMtoDER(certificate);
      }
      (0, import_assert4.default)(certificate instanceof Buffer);
      return certificate;
    }
    function exploreCertificateInfo(certificate) {
      certificate = coerceCertificate(certificate);
      const certInfo = exploreCertificate(certificate);
      const data = {
        publicKeyLength: certInfo.tbsCertificate.subjectPublicKeyInfo.keyLength,
        notBefore: certInfo.tbsCertificate.validity.notBefore,
        notAfter: certInfo.tbsCertificate.validity.notAfter,
        publicKey: certInfo.tbsCertificate.subjectPublicKeyInfo.subjectPublicKey,
        subject: certInfo.tbsCertificate.subject
      };
      if (!(data.publicKeyLength === 512 || data.publicKeyLength === 384 || data.publicKeyLength === 256 || data.publicKeyLength === 128)) {
        throw new Error("Invalid public key length (expecting 128,256,384 or 512)" + data.publicKeyLength);
      }
      return data;
    }
    function HMAC_HASH(sha1or256, secret, message) {
      return (0, import_crypto32.createHmac)(sha1or256, secret).update(message).digest();
    }
    function plus(buf1, buf2) {
      return Buffer.concat([buf1, buf2]);
    }
    function makePseudoRandomBuffer(secret, seed, minLength, sha1or256) {
      (0, import_assert5.default)(seed instanceof Buffer);
      (0, import_assert5.default)(sha1or256 === "SHA1" || sha1or256 === "SHA256");
      const a = [];
      a[0] = seed;
      let index = 1;
      let p_hash = createFastUninitializedBuffer(0);
      while (p_hash.length <= minLength) {
        a[index] = HMAC_HASH(sha1or256, secret, a[index - 1]);
        p_hash = plus(p_hash, HMAC_HASH(sha1or256, secret, plus(a[index], seed)));
        index += 1;
      }
      return p_hash.subarray(0, minLength);
    }
    function computeDerivedKeys(secret, seed, options) {
      (0, import_assert5.default)(Number.isFinite(options.signatureLength));
      (0, import_assert5.default)(Number.isFinite(options.encryptingKeyLength));
      (0, import_assert5.default)(Number.isFinite(options.encryptingBlockSize));
      (0, import_assert5.default)(typeof options.algorithm === "string");
      options.sha1or256 = options.sha1or256 || "SHA1";
      (0, import_assert5.default)(typeof options.sha1or256 === "string");
      const offset1 = options.signingKeyLength;
      const offset2 = offset1 + options.encryptingKeyLength;
      const minLength = offset2 + options.encryptingBlockSize;
      const buf = makePseudoRandomBuffer(secret, seed, minLength, options.sha1or256);
      return {
        signatureLength: options.signatureLength,
        signingKeyLength: options.signingKeyLength,
        encryptingKeyLength: options.encryptingKeyLength,
        encryptingBlockSize: options.encryptingBlockSize,
        algorithm: options.algorithm,
        sha1or256: options.sha1or256,
        signingKey: buf.subarray(0, offset1),
        encryptingKey: buf.subarray(offset1, offset2),
        initializationVector: buf.subarray(offset2, minLength)
      };
    }
    function reduceLength(buffer, byteToRemove) {
      return buffer.subarray(0, buffer.length - byteToRemove);
    }
    function removePadding(buffer) {
      const nbPaddingBytes = buffer.readUInt8(buffer.length - 1) + 1;
      return reduceLength(buffer, nbPaddingBytes);
    }
    function verifyChunkSignature(chunk, options) {
      (0, import_assert5.default)(chunk instanceof Buffer);
      let signatureLength = options.signatureLength || 0;
      if (signatureLength === 0) {
        const cert = exploreCertificateInfo(options.publicKey);
        signatureLength = cert.publicKeyLength || 0;
      }
      const block_to_verify = chunk.subarray(0, chunk.length - signatureLength);
      const signature = chunk.subarray(chunk.length - signatureLength);
      return verifyMessageChunkSignature(block_to_verify, signature, options);
    }
    function computePaddingFooter(buffer, derivedKeys) {
      (0, import_assert5.default)(Object.prototype.hasOwnProperty.call(derivedKeys, "encryptingBlockSize"));
      const paddingSize = derivedKeys.encryptingBlockSize - (buffer.length + 1) % derivedKeys.encryptingBlockSize;
      const padding = createFastUninitializedBuffer(paddingSize + 1);
      padding.fill(paddingSize);
      return padding;
    }
    function derivedKeys_algorithm(derivedKeys) {
      (0, import_assert5.default)(Object.prototype.hasOwnProperty.call(derivedKeys, "algorithm"));
      const algorithm = derivedKeys.algorithm || "aes-128-cbc";
      (0, import_assert5.default)(algorithm === "aes-128-cbc" || algorithm === "aes-256-cbc");
      return algorithm;
    }
    function encryptBufferWithDerivedKeys(buffer, derivedKeys) {
      const algorithm = derivedKeys_algorithm(derivedKeys);
      const key = derivedKeys.encryptingKey;
      const initVector = derivedKeys.initializationVector;
      const cipher = (0, import_crypto32.createCipheriv)(algorithm, key, initVector);
      cipher.setAutoPadding(false);
      const encrypted_chunks = [];
      encrypted_chunks.push(cipher.update(buffer));
      encrypted_chunks.push(cipher.final());
      return Buffer.concat(encrypted_chunks);
    }
    function decryptBufferWithDerivedKeys(buffer, derivedKeys) {
      const algorithm = derivedKeys_algorithm(derivedKeys);
      const key = derivedKeys.encryptingKey;
      const initVector = derivedKeys.initializationVector;
      const cipher = (0, import_crypto32.createDecipheriv)(algorithm, key, initVector);
      cipher.setAutoPadding(false);
      const decrypted_chunks = [];
      decrypted_chunks.push(cipher.update(buffer));
      decrypted_chunks.push(cipher.final());
      return Buffer.concat(decrypted_chunks);
    }
    function makeMessageChunkSignatureWithDerivedKeys(message, derivedKeys) {
      (0, import_assert5.default)(message instanceof Buffer);
      (0, import_assert5.default)(derivedKeys.signingKey instanceof Buffer);
      (0, import_assert5.default)(typeof derivedKeys.sha1or256 === "string");
      (0, import_assert5.default)(derivedKeys.sha1or256 === "SHA1" || derivedKeys.sha1or256 === "SHA256");
      const signature = (0, import_crypto32.createHmac)(derivedKeys.sha1or256, derivedKeys.signingKey).update(message).digest();
      (0, import_assert5.default)(signature.length === derivedKeys.signatureLength);
      return signature;
    }
    function verifyChunkSignatureWithDerivedKeys(chunk, derivedKeys) {
      const message = chunk.subarray(0, chunk.length - derivedKeys.signatureLength);
      const expectedSignature = chunk.subarray(chunk.length - derivedKeys.signatureLength);
      const computedSignature = makeMessageChunkSignatureWithDerivedKeys(message, derivedKeys);
      return computedSignature.toString("hex") === expectedSignature.toString("hex");
    }
    var import_assert6 = __toESM2(require("assert"));
    var import_jsrsasign2 = __toESM2(require_jsrsasign());
    function rsaLengthPrivateKey(key) {
      const keyPem = typeof key.hidden === "string" ? key.hidden : key.hidden.export({ type: "pkcs1", format: "pem" }).toString();
      const a = import_jsrsasign2.default.KEYUTIL.getKey(keyPem);
      return a.n.toString(16).length / 2;
    }
    function toPem2(raw_key, pem) {
      if (raw_key.hidden) {
        return toPem2(raw_key.hidden, pem);
      }
      (0, import_assert6.default)(raw_key, "expecting a key");
      (0, import_assert6.default)(typeof pem === "string");
      if (isKeyObject(raw_key)) {
        const _raw_key = raw_key;
        if (pem === "RSA PRIVATE KEY") {
          return removeTrailingLF(_raw_key.export({ format: "pem", type: "pkcs1" }).toString());
        } else if (pem === "PRIVATE KEY") {
          return removeTrailingLF(_raw_key.export({ format: "pem", type: "pkcs8" }).toString());
        } else {
          throw new Error("Unsupported case!");
        }
      }
      return toPem(raw_key, pem);
    }
    function coercePrivateKeyPem(privateKey) {
      return toPem2(privateKey, "PRIVATE KEY");
    }
    function coercePublicKeyPem(publicKey) {
      if (isKeyObject(publicKey)) {
        return publicKey.export({ format: "pem", type: "spki" }).toString();
      }
      (0, import_assert6.default)(typeof publicKey === "string");
      return publicKey;
    }
    function coerceRsaPublicKeyPem(publicKey) {
      if (isKeyObject(publicKey)) {
        return publicKey.export({ format: "pem", type: "spki" }).toString();
      }
      (0, import_assert6.default)(typeof publicKey === "string");
      return publicKey;
    }
    function rsaLengthPublicKey(key) {
      key = coercePublicKeyPem(key);
      (0, import_assert6.default)(typeof key === "string");
      const a = import_jsrsasign2.default.KEYUTIL.getKey(key);
      return a.n.toString(16).length / 2;
    }
    function rsaLengthRsaPublicKey(key) {
      key = coerceRsaPublicKeyPem(key);
      (0, import_assert6.default)(typeof key === "string");
      const a = import_jsrsasign2.default.KEYUTIL.getKey(key);
      return a.n.toString(16).length / 2;
    }
    var import_crypto4 = require("crypto");
    function verifyCertificateOrClrSignature(certificateOrCrl, parentCertificate) {
      const block_info = readTag(certificateOrCrl, 0);
      const blocks = _readStruct(certificateOrCrl, block_info);
      const bufferToBeSigned = certificateOrCrl.subarray(block_info.position, blocks[1].position - 2);
      const signatureAlgorithm = _readAlgorithmIdentifier(certificateOrCrl, blocks[1]);
      const signatureValue = _readSignatureValueBin(certificateOrCrl, blocks[2]);
      const p3 = split_der(parentCertificate)[0];
      const certPem = toPem(p3, "CERTIFICATE");
      const verify = (0, import_crypto4.createVerify)(signatureAlgorithm.identifier);
      verify.update(bufferToBeSigned);
      verify.end();
      return verify.verify(certPem, signatureValue);
    }
    function verifyCertificateSignature(certificate, parentCertificate) {
      return verifyCertificateOrClrSignature(certificate, parentCertificate);
    }
    function verifyCertificateRevocationListSignature(certificateRevocationList, parentCertificate) {
      return verifyCertificateOrClrSignature(certificateRevocationList, parentCertificate);
    }
    async function verifyCertificateChain(certificateChain) {
      for (let index = 1; index < certificateChain.length; index++) {
        const cert = certificateChain[index - 1];
        const certParent = certificateChain[index];
        const certParentInfo = exploreCertificate(certParent);
        const keyUsage = certParentInfo.tbsCertificate.extensions.keyUsage;
        if (!keyUsage.keyCertSign) {
          return {
            status: "BadCertificateIssuerUseNotAllowed",
            reason: "One of the certificate in the chain has not keyUsage set for Certificate Signing"
          };
        }
        const parentSignChild = verifyCertificateSignature(cert, certParent);
        if (!parentSignChild) {
          return {
            status: "BadCertificateInvalid",
            reason: "One of the certificate in the chain is not signing the previous certificate"
          };
        }
        const certInfo = exploreCertificate(cert);
        if (!certInfo.tbsCertificate.extensions) {
          return {
            status: "BadCertificateInvalid",
            reason: "Cannot find X409 Extension 3 in certificate"
          };
        }
        if (!certParentInfo.tbsCertificate.extensions || !certInfo.tbsCertificate.extensions.authorityKeyIdentifier) {
          return {
            status: "BadCertificateInvalid",
            reason: "Cannot find X409 Extension 3 in certificate (parent)"
          };
        }
        if (certParentInfo.tbsCertificate.extensions.subjectKeyIdentifier !== certInfo.tbsCertificate.extensions.authorityKeyIdentifier.keyIdentifier) {
          return {
            status: "BadCertificateInvalid",
            reason: "subjectKeyIdentifier authorityKeyIdentifier in child certificate do not match subjectKeyIdentifier of parent certificate"
          };
        }
      }
      return {
        status: "Good",
        reason: `certificate chain is valid(length = ${certificateChain.length})`
      };
    }
    function readNameForCrl(buffer, block) {
      return _readDirectoryName(buffer, block);
    }
    function _readTbsCertList(buffer, blockInfo) {
      const blocks = _readStruct(buffer, blockInfo);
      const hasOptionalVersion = blocks[0].tag === 2;
      if (hasOptionalVersion) {
        const version = _readIntegerValue(buffer, blocks[0]);
        const signature = _readAlgorithmIdentifier(buffer, blocks[1]);
        const issuer = readNameForCrl(buffer, blocks[2]);
        const issuerFingerprint = formatBuffer2DigitHexWithColum(makeSHA1Thumbprint(_getBlock(buffer, blocks[2])));
        const thisUpdate = _readTime(buffer, blocks[3]);
        const nextUpdate = _readTime(buffer, blocks[4]);
        const revokedCertificates = [];
        if (blocks[5] && blocks[5].tag < 128) {
          const list = _readStruct(buffer, blocks[5]);
          for (const r of list) {
            const rr = _readStruct(buffer, r);
            const userCertificate = formatBuffer2DigitHexWithColum(_readLongIntegerValue(buffer, rr[0]));
            const revocationDate = _readTime(buffer, rr[1]);
            revokedCertificates.push({
              revocationDate,
              userCertificate
            });
          }
        }
        const ext0 = _findBlockAtIndex(blocks, 0);
        return { issuer, issuerFingerprint, thisUpdate, nextUpdate, signature, revokedCertificates };
      } else {
        const signature = _readAlgorithmIdentifier(buffer, blocks[0]);
        const issuer = readNameForCrl(buffer, blocks[1]);
        const issuerFingerprint = formatBuffer2DigitHexWithColum(makeSHA1Thumbprint(_getBlock(buffer, blocks[1])));
        const thisUpdate = _readTime(buffer, blocks[2]);
        const nextUpdate = _readTime(buffer, blocks[3]);
        const revokedCertificates = [];
        if (blocks[4] && blocks[4].tag < 128) {
          const list = _readStruct(buffer, blocks[4]);
          for (const r of list) {
            const rr = _readStruct(buffer, r);
            const userCertificate = formatBuffer2DigitHexWithColum(_readLongIntegerValue(buffer, rr[0]));
            const revocationDate = _readTime(buffer, rr[1]);
            revokedCertificates.push({
              revocationDate,
              userCertificate
            });
          }
        }
        return { issuer, issuerFingerprint, thisUpdate, nextUpdate, signature, revokedCertificates };
      }
    }
    function exploreCertificateRevocationList(crl) {
      const blockInfo = readTag(crl, 0);
      const blocks = _readStruct(crl, blockInfo);
      const tbsCertList = _readTbsCertList(crl, blocks[0]);
      const signatureAlgorithm = _readAlgorithmIdentifier(crl, blocks[1]);
      const signatureValue = _readSignatureValueBin(crl, blocks[2]);
      return { tbsCertList, signatureAlgorithm, signatureValue };
    }
    function _readExtensionRequest(buffer) {
      const block = readTag(buffer, 0);
      const inner_blocks = _readStruct(buffer, block);
      const extensions2 = inner_blocks.map((block1) => _readExtension(buffer, block1));
      const result2 = {};
      for (const e of extensions2) {
        result2[e.identifier.name] = e.value;
      }
      const { basicConstraints, keyUsage, subjectAltName } = result2;
      return { basicConstraints, keyUsage, subjectAltName };
    }
    function readCertificationRequestInfo(buffer, block) {
      const blocks = _readStruct(buffer, block);
      if (blocks.length === 4) {
        const extensionRequestBlock = _findBlockAtIndex(blocks, 0);
        if (!extensionRequestBlock) {
          throw new Error("cannot find extensionRequest block");
        }
        const blocks1 = _readStruct(buffer, extensionRequestBlock);
        const blocks2 = _readStruct(buffer, blocks1[0]);
        const identifier = _readObjectIdentifier(buffer, blocks2[0]);
        if (identifier.name !== "extensionRequest") {
          throw new Error(" Cannot find extension Request in ASN1 block");
        }
        const buf = _getBlock(buffer, blocks2[1]);
        const extensionRequest = _readExtensionRequest(buf);
        return { extensionRequest };
      }
      throw new Error("Invalid CSR or ");
    }
    function exploreCertificateSigningRequest(crl) {
      const blockInfo = readTag(crl, 0);
      const blocks = _readStruct(crl, blockInfo);
      const csrInfo = readCertificationRequestInfo(crl, blocks[0]);
      return csrInfo;
    }
    function f2(buffer, b) {
      return buffer.subarray(b.position + 1, b.position + b.length);
    }
    var doDebug2 = !!process.env.DEBUG;
    function explorePrivateKey(privateKey2) {
      const privateKey1 = privateKey2.hidden;
      const privateKey = typeof privateKey1 === "string" ? convertPEMtoDER(privateKey1) : privateKey1.export({ format: "der", type: "pkcs1" });
      const block_info = readTag(privateKey, 0);
      const blocks = _readStruct(privateKey, block_info);
      if (blocks.length === 9) {
        const version2 = f2(privateKey, blocks[0]);
        const modulus2 = f2(privateKey, blocks[1]);
        const publicExponent2 = f2(privateKey, blocks[2]);
        const privateExponent2 = f2(privateKey, blocks[3]);
        const prime12 = f2(privateKey, blocks[4]);
        const prime22 = f2(privateKey, blocks[5]);
        const exponent12 = f2(privateKey, blocks[6]);
        const exponent22 = f2(privateKey, blocks[7]);
        return {
          version: version2,
          modulus: modulus2,
          publicExponent: publicExponent2,
          privateExponent: privateExponent2,
          prime1: prime12,
          prime2: prime22,
          exponent1: exponent12,
          exponent2: exponent22
        };
      }
      if (doDebug2) {
        console.log("-------------------- private key:");
        console.log(block_info);
        console.log(
          blocks.map((b2) => ({
            tag: TagType[b2.tag] + " 0x" + b2.tag.toString(16),
            l: b2.length,
            p: b2.position,
            buff: privateKey.subarray(b2.position, b2.position + b2.length).toString("hex")
          }))
        );
      }
      const b = blocks[2];
      const bb = privateKey.subarray(b.position, b.position + b.length);
      const block_info1 = readTag(bb, 0);
      const blocks1 = _readStruct(bb, block_info1);
      if (doDebug2) {
        console.log(
          blocks1.map((b2) => ({
            tag: TagType[b2.tag] + " 0x" + b2.tag.toString(16),
            l: b2.length,
            p: b2.position,
            buff: bb.subarray(b2.position, b2.position + b2.length).toString("hex")
          }))
        );
      }
      const version = f2(bb, blocks1[0]);
      const modulus = f2(bb, blocks1[1]);
      const publicExponent = f2(bb, blocks1[2]);
      const privateExponent = f2(bb, blocks1[3]);
      const prime1 = f2(bb, blocks1[4]);
      const prime2 = f2(bb, blocks1[5]);
      const exponent1 = f2(bb, blocks1[6]);
      const exponent2 = f2(bb, blocks1[7]);
      return {
        version,
        modulus,
        publicExponent,
        privateExponent,
        prime1,
        prime2,
        exponent1,
        exponent2
      };
    }
    function publicKeyAndPrivateKeyMatches(certificate, privateKey) {
      const i = exploreCertificate(certificate);
      const j = explorePrivateKey(privateKey);
      const modulus1 = i.tbsCertificate.subjectPublicKeyInfo.subjectPublicKey.modulus;
      const modulus2 = j.modulus;
      if (modulus1.length != modulus2.length) {
        return false;
      }
      return modulus1.toString("hex") === modulus2.toString("hex");
    }
    function certificateMatchesPrivateKeyPEM(certificate, privateKey, blockSize) {
      const initialBuffer = Buffer.from("Lorem Ipsum");
      const encryptedBuffer = publicEncrypt_long(initialBuffer, certificate, blockSize);
      const decryptedBuffer = privateDecrypt_long(encryptedBuffer, privateKey, blockSize);
      const finalString = decryptedBuffer.toString("utf-8");
      return initialBuffer.toString("utf-8") === finalString;
    }
    function certificateMatchesPrivateKey(certificate, privateKey) {
      const e = explorePrivateKey(privateKey);
      const blockSize = e.modulus.length;
      const certificatePEM = toPem(certificate, "CERTIFICATE");
      return certificateMatchesPrivateKeyPEM(certificatePEM, privateKey, blockSize);
    }
    var x509 = __toESM2(require_x509_cjs());
    var import_webcrypto = require_webcrypto();
    var import_crypto5 = __toESM2(require("crypto"));
    var x5092 = __toESM2(require_x509_cjs());
    var _crypto;
    var ignoreCrypto = process.env.IGNORE_SUBTLE_FROM_CRYPTO;
    if (typeof window === "undefined") {
      _crypto = import_crypto5.default;
      if (!_crypto?.subtle || ignoreCrypto) {
        _crypto = new import_webcrypto.Crypto();
        console.warn("using @peculiar/webcrypto");
      } else {
        console.warn("using nodejs crypto (native)");
      }
      x509.cryptoProvider.set(_crypto);
    } else {
      console.warn("using browser crypto (native)");
      _crypto = crypto;
      x509.cryptoProvider.set(crypto);
    }
    function getCrypto() {
      return _crypto || crypto || require("crypto");
    }
    async function generateKeyPair(modulusLength = 2048) {
      const crypto3 = getCrypto();
      const alg = {
        name: "RSASSA-PKCS1-v1_5",
        hash: { name: "SHA-256" },
        publicExponent: new Uint8Array([1, 0, 1]),
        modulusLength
      };
      const keys = await crypto3.subtle.generateKey(alg, true, ["sign", "verify"]);
      return keys;
    }
    async function generatePrivateKey(modulusLength = 2048) {
      return (await generateKeyPair(modulusLength)).privateKey;
    }
    async function privateKeyToPEM(privateKey) {
      const crypto3 = getCrypto();
      const privDer = await crypto3.subtle.exportKey("pkcs8", privateKey);
      const privPem = x5092.PemConverter.encode(privDer, "PRIVATE KEY");
      return { privPem, privDer };
    }
    async function derToPrivateKey(privDer) {
      const crypto3 = getCrypto();
      return await crypto3.subtle.importKey(
        "pkcs8",
        privDer,
        {
          name: "RSASSA-PKCS1-v1_5",
          hash: { name: "SHA-256" }
        },
        true,
        [
          "sign"
          // "encrypt",
          // "decrypt",
          // "verify",
          //    "wrapKey",
          //    "unwrapKey",
          //    "deriveKey",
          //    "deriveBits"
        ]
      );
    }
    async function pemToPrivateKey(pem) {
      const privDer = x5092.PemConverter.decode(pem);
      return derToPrivateKey(privDer[0]);
    }
    var _keys = {
      C: "country",
      CN: "commonName",
      DC: "domainComponent",
      L: "locality",
      O: "organization",
      OU: "organizationalUnit",
      ST: "state"
    };
    var enquoteIfNecessary = (str) => {
      str = str.replace(/"/g, "\u201D");
      return str.match(/\/|=/) ? `"${str}"` : str;
    };
    var unquote = (str) => str.replace(/"/gm, "");
    var unquote2 = (str) => {
      if (!str)
        return str;
      const m2 = str.match(/^"(.*)"$/);
      return m2 ? m2[1] : str;
    };
    var Subject = class _Subject {
      constructor(options) {
        if (typeof options === "string") {
          options = _Subject.parse(options);
        }
        this.commonName = unquote2(options.commonName);
        this.organization = unquote2(options.organization);
        this.organizationalUnit = unquote2(options.organizationalUnit);
        this.locality = unquote2(options.locality);
        this.state = unquote2(options.state);
        this.country = unquote2(options.country);
        this.domainComponent = unquote2(options.domainComponent);
      }
      static parse(str) {
        const elements = str.split(/\/(?=[^/]*?=)/);
        const options = {};
        elements.forEach((element) => {
          if (element.length === 0) {
            return;
          }
          const s = element.split("=");
          if (s.length !== 2) {
            throw new Error("invalid format for " + element);
          }
          const longName = _keys[s[0]];
          if (!longName) {
            throw new Error("Invalid field found in subject name " + s[0]);
          }
          const value = s[1];
          options[longName] = unquote(Buffer.from(value, "ascii").toString("utf8"));
        });
        return options;
      }
      toStringInternal(sep) {
        const tmp = [];
        if (this.country) {
          tmp.push("C=" + enquoteIfNecessary(this.country));
        }
        if (this.state) {
          tmp.push("ST=" + enquoteIfNecessary(this.state));
        }
        if (this.locality) {
          tmp.push("L=" + enquoteIfNecessary(this.locality));
        }
        if (this.organization) {
          tmp.push("O=" + enquoteIfNecessary(this.organization));
        }
        if (this.organizationalUnit) {
          tmp.push("OU=" + enquoteIfNecessary(this.organizationalUnit));
        }
        if (this.commonName) {
          tmp.push("CN=" + enquoteIfNecessary(this.commonName));
        }
        if (this.domainComponent) {
          tmp.push("DC=" + enquoteIfNecessary(this.domainComponent));
        }
        return tmp.join(sep);
      }
      toStringForOPCUA() {
        return this.toStringInternal("/");
      }
      toString() {
        const t = this.toStringForOPCUA();
        return t ? "/" + t : t;
      }
    };
    var keyUsageApplication = x5092.KeyUsageFlags.keyEncipherment | x5092.KeyUsageFlags.nonRepudiation | x5092.KeyUsageFlags.dataEncipherment | x5092.KeyUsageFlags.keyCertSign | x5092.KeyUsageFlags.digitalSignature;
    var keyUsageCA = x5092.KeyUsageFlags.keyCertSign | x5092.KeyUsageFlags.cRLSign;
    function getAttributes(purpose) {
      let basicConstraints;
      let keyUsageExtension = [];
      let usages;
      let nsComment;
      let extension;
      switch (purpose) {
        case 1:
          extension = "v3_ca";
          basicConstraints = new x5092.BasicConstraintsExtension(true, void 0, false);
          usages = keyUsageCA;
          keyUsageExtension = [];
          nsComment = "Self-signed certificate for CA generated by Node-OPCUA Certificate utility V2";
          break;
        case 2:
        case 3:
        default:
          extension = "v3_selfsigned";
          basicConstraints = new x5092.BasicConstraintsExtension(false, void 0, true);
          usages = keyUsageApplication;
          keyUsageExtension = [x5092.ExtendedKeyUsage.serverAuth, x5092.ExtendedKeyUsage.clientAuth];
          nsComment = "Self-signed certificate generated by Node-OPCUA Certificate utility V2";
          break;
      }
      return { nsComment, basicConstraints, keyUsageExtension, usages };
    }
    async function buildPublicKey(privateKey) {
      const crypto3 = getCrypto();
      const jwk = await crypto3.subtle.exportKey("jwk", privateKey);
      delete jwk.d;
      delete jwk.dp;
      delete jwk.dq;
      delete jwk.q;
      delete jwk.qi;
      jwk.key_ops = [
        "encrypt",
        "sign"
        // "wrapKey"
      ];
      const publicKey = await crypto3.subtle.importKey("jwk", jwk, { name: "RSASSA-PKCS1-v1_5", hash: { name: "SHA-256" } }, true, [
        //   "encrypt",
        //     "sign",
        // "wrapKey",
      ]);
      return publicKey;
    }
    async function createCertificateSigningRequest({
      privateKey,
      subject,
      dns,
      ip,
      applicationUri,
      purpose
    }) {
      const crypto3 = getCrypto();
      const modulusLength = 2048;
      const alg = {
        name: "RSASSA-PKCS1-v1_5",
        hash: { name: "SHA-256" },
        publicExponent: new Uint8Array([1, 0, 1]),
        modulusLength
      };
      const publicKey = await buildPublicKey(privateKey);
      const keys = {
        privateKey,
        publicKey
      };
      const alternativeNameExtensions = [];
      dns && dns.forEach((d2) => alternativeNameExtensions.push({ type: "dns", value: d2 }));
      ip && ip.forEach((d2) => alternativeNameExtensions.push({ type: "ip", value: d2 }));
      applicationUri && alternativeNameExtensions.push({ type: "url", value: applicationUri });
      const { basicConstraints, usages } = getAttributes(purpose);
      const s = new Subject(subject || "");
      const s1 = s.toStringInternal(", ");
      const name = s1;
      const csr = await x5092.Pkcs10CertificateRequestGenerator.create(
        {
          name,
          keys,
          signingAlgorithm: alg,
          extensions: [
            basicConstraints,
            new x5092.KeyUsagesExtension(usages, true),
            new x5092.SubjectAlternativeNameExtension(alternativeNameExtensions)
          ]
        },
        crypto3
      );
      return { csr: csr.toString("pem"), der: csr };
    }
    var index_es_exports = {};
    __export2(index_es_exports, {
      Any: () => Any,
      BaseBlock: () => BaseBlock,
      BaseStringBlock: () => BaseStringBlock,
      BitString: () => BitString,
      BmpString: () => BmpString,
      Boolean: () => Boolean2,
      CharacterString: () => CharacterString,
      Choice: () => Choice,
      Constructed: () => Constructed,
      DATE: () => DATE,
      DateTime: () => DateTime,
      Duration: () => Duration,
      EndOfContent: () => EndOfContent,
      Enumerated: () => Enumerated,
      GeneralString: () => GeneralString,
      GeneralizedTime: () => GeneralizedTime,
      GraphicString: () => GraphicString,
      HexBlock: () => HexBlock,
      IA5String: () => IA5String,
      Integer: () => Integer,
      Null: () => Null,
      NumericString: () => NumericString,
      ObjectIdentifier: () => ObjectIdentifier,
      OctetString: () => OctetString,
      Primitive: () => Primitive,
      PrintableString: () => PrintableString,
      RawData: () => RawData,
      RelativeObjectIdentifier: () => RelativeObjectIdentifier,
      Repeated: () => Repeated,
      Sequence: () => Sequence,
      Set: () => Set2,
      TIME: () => TIME,
      TeletexString: () => TeletexString,
      TimeOfDay: () => TimeOfDay,
      UTCTime: () => UTCTime,
      UniversalString: () => UniversalString,
      Utf8String: () => Utf8String,
      ValueBlock: () => ValueBlock,
      VideotexString: () => VideotexString,
      ViewWriter: () => ViewWriter,
      VisibleString: () => VisibleString,
      compareSchema: () => compareSchema,
      fromBER: () => fromBER,
      verifySchema: () => verifySchema
    });
    var ARRAY_BUFFER_NAME = "[object ArrayBuffer]";
    var BufferSourceConverter = class _BufferSourceConverter {
      static isArrayBuffer(data) {
        return Object.prototype.toString.call(data) === ARRAY_BUFFER_NAME;
      }
      static toArrayBuffer(data) {
        if (this.isArrayBuffer(data)) {
          return data;
        }
        if (data.byteLength === data.buffer.byteLength) {
          return data.buffer;
        }
        if (data.byteOffset === 0 && data.byteLength === data.buffer.byteLength) {
          return data.buffer;
        }
        return this.toUint8Array(data.buffer).slice(data.byteOffset, data.byteOffset + data.byteLength).buffer;
      }
      static toUint8Array(data) {
        return this.toView(data, Uint8Array);
      }
      static toView(data, type) {
        if (data.constructor === type) {
          return data;
        }
        if (this.isArrayBuffer(data)) {
          return new type(data);
        }
        if (this.isArrayBufferView(data)) {
          return new type(data.buffer, data.byteOffset, data.byteLength);
        }
        throw new TypeError("The provided value is not of type '(ArrayBuffer or ArrayBufferView)'");
      }
      static isBufferSource(data) {
        return this.isArrayBufferView(data) || this.isArrayBuffer(data);
      }
      static isArrayBufferView(data) {
        return ArrayBuffer.isView(data) || data && this.isArrayBuffer(data.buffer);
      }
      static isEqual(a, b) {
        const aView = _BufferSourceConverter.toUint8Array(a);
        const bView = _BufferSourceConverter.toUint8Array(b);
        if (aView.length !== bView.byteLength) {
          return false;
        }
        for (let i = 0; i < aView.length; i++) {
          if (aView[i] !== bView[i]) {
            return false;
          }
        }
        return true;
      }
      static concat(...args) {
        let buffers;
        if (Array.isArray(args[0]) && !(args[1] instanceof Function)) {
          buffers = args[0];
        } else if (Array.isArray(args[0]) && args[1] instanceof Function) {
          buffers = args[0];
        } else {
          if (args[args.length - 1] instanceof Function) {
            buffers = args.slice(0, args.length - 1);
          } else {
            buffers = args;
          }
        }
        let size = 0;
        for (const buffer of buffers) {
          size += buffer.byteLength;
        }
        const res = new Uint8Array(size);
        let offset = 0;
        for (const buffer of buffers) {
          const view = this.toUint8Array(buffer);
          res.set(view, offset);
          offset += view.length;
        }
        if (args[args.length - 1] instanceof Function) {
          return this.toView(res, args[args.length - 1]);
        }
        return res.buffer;
      }
    };
    var STRING_TYPE = "string";
    var HEX_REGEX = /^[0-9a-f]+$/i;
    var BASE64_REGEX = /^(?:[A-Za-z0-9+/]{4})*(?:[A-Za-z0-9+/]{2}==|[A-Za-z0-9+/]{3}=)?$/;
    var BASE64URL_REGEX = /^[a-zA-Z0-9-_]+$/;
    var Utf8Converter = class {
      static fromString(text2) {
        const s = unescape(encodeURIComponent(text2));
        const uintArray = new Uint8Array(s.length);
        for (let i = 0; i < s.length; i++) {
          uintArray[i] = s.charCodeAt(i);
        }
        return uintArray.buffer;
      }
      static toString(buffer) {
        const buf = BufferSourceConverter.toUint8Array(buffer);
        let encodedString = "";
        for (let i = 0; i < buf.length; i++) {
          encodedString += String.fromCharCode(buf[i]);
        }
        const decodedString = decodeURIComponent(escape(encodedString));
        return decodedString;
      }
    };
    var Utf16Converter = class {
      static toString(buffer, littleEndian = false) {
        const arrayBuffer = BufferSourceConverter.toArrayBuffer(buffer);
        const dataView = new DataView(arrayBuffer);
        let res = "";
        for (let i = 0; i < arrayBuffer.byteLength; i += 2) {
          const code = dataView.getUint16(i, littleEndian);
          res += String.fromCharCode(code);
        }
        return res;
      }
      static fromString(text2, littleEndian = false) {
        const res = new ArrayBuffer(text2.length * 2);
        const dataView = new DataView(res);
        for (let i = 0; i < text2.length; i++) {
          dataView.setUint16(i * 2, text2.charCodeAt(i), littleEndian);
        }
        return res;
      }
    };
    var Convert = class _Convert {
      static isHex(data) {
        return typeof data === STRING_TYPE && HEX_REGEX.test(data);
      }
      static isBase64(data) {
        return typeof data === STRING_TYPE && BASE64_REGEX.test(data);
      }
      static isBase64Url(data) {
        return typeof data === STRING_TYPE && BASE64URL_REGEX.test(data);
      }
      static ToString(buffer, enc = "utf8") {
        const buf = BufferSourceConverter.toUint8Array(buffer);
        switch (enc.toLowerCase()) {
          case "utf8":
            return this.ToUtf8String(buf);
          case "binary":
            return this.ToBinary(buf);
          case "hex":
            return this.ToHex(buf);
          case "base64":
            return this.ToBase64(buf);
          case "base64url":
            return this.ToBase64Url(buf);
          case "utf16le":
            return Utf16Converter.toString(buf, true);
          case "utf16":
          case "utf16be":
            return Utf16Converter.toString(buf);
          default:
            throw new Error(`Unknown type of encoding '${enc}'`);
        }
      }
      static FromString(str, enc = "utf8") {
        if (!str) {
          return new ArrayBuffer(0);
        }
        switch (enc.toLowerCase()) {
          case "utf8":
            return this.FromUtf8String(str);
          case "binary":
            return this.FromBinary(str);
          case "hex":
            return this.FromHex(str);
          case "base64":
            return this.FromBase64(str);
          case "base64url":
            return this.FromBase64Url(str);
          case "utf16le":
            return Utf16Converter.fromString(str, true);
          case "utf16":
          case "utf16be":
            return Utf16Converter.fromString(str);
          default:
            throw new Error(`Unknown type of encoding '${enc}'`);
        }
      }
      static ToBase64(buffer) {
        const buf = BufferSourceConverter.toUint8Array(buffer);
        if (typeof btoa !== "undefined") {
          const binary = this.ToString(buf, "binary");
          return btoa(binary);
        } else {
          return Buffer.from(buf).toString("base64");
        }
      }
      static FromBase64(base64) {
        const formatted = this.formatString(base64);
        if (!formatted) {
          return new ArrayBuffer(0);
        }
        if (!_Convert.isBase64(formatted)) {
          throw new TypeError("Argument 'base64Text' is not Base64 encoded");
        }
        if (typeof atob !== "undefined") {
          return this.FromBinary(atob(formatted));
        } else {
          return new Uint8Array(Buffer.from(formatted, "base64")).buffer;
        }
      }
      static FromBase64Url(base64url) {
        const formatted = this.formatString(base64url);
        if (!formatted) {
          return new ArrayBuffer(0);
        }
        if (!_Convert.isBase64Url(formatted)) {
          throw new TypeError("Argument 'base64url' is not Base64Url encoded");
        }
        return this.FromBase64(this.Base64Padding(formatted.replace(/\-/g, "+").replace(/\_/g, "/")));
      }
      static ToBase64Url(data) {
        return this.ToBase64(data).replace(/\+/g, "-").replace(/\//g, "_").replace(/\=/g, "");
      }
      static FromUtf8String(text2, encoding = _Convert.DEFAULT_UTF8_ENCODING) {
        switch (encoding) {
          case "ascii":
            return this.FromBinary(text2);
          case "utf8":
            return Utf8Converter.fromString(text2);
          case "utf16":
          case "utf16be":
            return Utf16Converter.fromString(text2);
          case "utf16le":
          case "usc2":
            return Utf16Converter.fromString(text2, true);
          default:
            throw new Error(`Unknown type of encoding '${encoding}'`);
        }
      }
      static ToUtf8String(buffer, encoding = _Convert.DEFAULT_UTF8_ENCODING) {
        switch (encoding) {
          case "ascii":
            return this.ToBinary(buffer);
          case "utf8":
            return Utf8Converter.toString(buffer);
          case "utf16":
          case "utf16be":
            return Utf16Converter.toString(buffer);
          case "utf16le":
          case "usc2":
            return Utf16Converter.toString(buffer, true);
          default:
            throw new Error(`Unknown type of encoding '${encoding}'`);
        }
      }
      static FromBinary(text2) {
        const stringLength = text2.length;
        const resultView = new Uint8Array(stringLength);
        for (let i = 0; i < stringLength; i++) {
          resultView[i] = text2.charCodeAt(i);
        }
        return resultView.buffer;
      }
      static ToBinary(buffer) {
        const buf = BufferSourceConverter.toUint8Array(buffer);
        let res = "";
        for (let i = 0; i < buf.length; i++) {
          res += String.fromCharCode(buf[i]);
        }
        return res;
      }
      static ToHex(buffer) {
        const buf = BufferSourceConverter.toUint8Array(buffer);
        let result2 = "";
        const len = buf.length;
        for (let i = 0; i < len; i++) {
          const byte = buf[i];
          if (byte < 16) {
            result2 += "0";
          }
          result2 += byte.toString(16);
        }
        return result2;
      }
      static FromHex(hexString) {
        let formatted = this.formatString(hexString);
        if (!formatted) {
          return new ArrayBuffer(0);
        }
        if (!_Convert.isHex(formatted)) {
          throw new TypeError("Argument 'hexString' is not HEX encoded");
        }
        if (formatted.length % 2) {
          formatted = `0${formatted}`;
        }
        const res = new Uint8Array(formatted.length / 2);
        for (let i = 0; i < formatted.length; i = i + 2) {
          const c2 = formatted.slice(i, i + 2);
          res[i / 2] = parseInt(c2, 16);
        }
        return res.buffer;
      }
      static ToUtf16String(buffer, littleEndian = false) {
        return Utf16Converter.toString(buffer, littleEndian);
      }
      static FromUtf16String(text2, littleEndian = false) {
        return Utf16Converter.fromString(text2, littleEndian);
      }
      static Base64Padding(base64) {
        const padCount = 4 - base64.length % 4;
        if (padCount < 4) {
          for (let i = 0; i < padCount; i++) {
            base64 += "=";
          }
        }
        return base64;
      }
      static formatString(data) {
        return (data === null || data === void 0 ? void 0 : data.replace(/[\n\r\t ]/g, "")) || "";
      }
    };
    Convert.DEFAULT_UTF8_ENCODING = "utf8";
    function utilFromBase(inputBuffer, inputBase) {
      let result2 = 0;
      if (inputBuffer.length === 1) {
        return inputBuffer[0];
      }
      for (let i = inputBuffer.length - 1; i >= 0; i--) {
        result2 += inputBuffer[inputBuffer.length - 1 - i] * Math.pow(2, inputBase * i);
      }
      return result2;
    }
    function utilToBase(value, base, reserved = -1) {
      const internalReserved = reserved;
      let internalValue = value;
      let result2 = 0;
      let biggest = Math.pow(2, base);
      for (let i = 1; i < 8; i++) {
        if (value < biggest) {
          let retBuf;
          if (internalReserved < 0) {
            retBuf = new ArrayBuffer(i);
            result2 = i;
          } else {
            if (internalReserved < i) {
              return new ArrayBuffer(0);
            }
            retBuf = new ArrayBuffer(internalReserved);
            result2 = internalReserved;
          }
          const retView = new Uint8Array(retBuf);
          for (let j = i - 1; j >= 0; j--) {
            const basis = Math.pow(2, j * base);
            retView[result2 - j - 1] = Math.floor(internalValue / basis);
            internalValue -= retView[result2 - j - 1] * basis;
          }
          return retBuf;
        }
        biggest *= Math.pow(2, base);
      }
      return new ArrayBuffer(0);
    }
    function utilConcatView(...views) {
      let outputLength = 0;
      let prevLength = 0;
      for (const view of views) {
        outputLength += view.length;
      }
      const retBuf = new ArrayBuffer(outputLength);
      const retView = new Uint8Array(retBuf);
      for (const view of views) {
        retView.set(view, prevLength);
        prevLength += view.length;
      }
      return retView;
    }
    function utilDecodeTC() {
      const buf = new Uint8Array(this.valueHex);
      if (this.valueHex.byteLength >= 2) {
        const condition1 = buf[0] === 255 && buf[1] & 128;
        const condition2 = buf[0] === 0 && (buf[1] & 128) === 0;
        if (condition1 || condition2) {
          this.warnings.push("Needlessly long format");
        }
      }
      const bigIntBuffer = new ArrayBuffer(this.valueHex.byteLength);
      const bigIntView = new Uint8Array(bigIntBuffer);
      for (let i = 0; i < this.valueHex.byteLength; i++) {
        bigIntView[i] = 0;
      }
      bigIntView[0] = buf[0] & 128;
      const bigInt = utilFromBase(bigIntView, 8);
      const smallIntBuffer = new ArrayBuffer(this.valueHex.byteLength);
      const smallIntView = new Uint8Array(smallIntBuffer);
      for (let j = 0; j < this.valueHex.byteLength; j++) {
        smallIntView[j] = buf[j];
      }
      smallIntView[0] &= 127;
      const smallInt = utilFromBase(smallIntView, 8);
      return smallInt - bigInt;
    }
    function utilEncodeTC(value) {
      const modValue = value < 0 ? value * -1 : value;
      let bigInt = 128;
      for (let i = 1; i < 8; i++) {
        if (modValue <= bigInt) {
          if (value < 0) {
            const smallInt = bigInt - modValue;
            const retBuf2 = utilToBase(smallInt, 8, i);
            const retView2 = new Uint8Array(retBuf2);
            retView2[0] |= 128;
            return retBuf2;
          }
          let retBuf = utilToBase(modValue, 8, i);
          let retView = new Uint8Array(retBuf);
          if (retView[0] & 128) {
            const tempBuf = retBuf.slice(0);
            const tempView = new Uint8Array(tempBuf);
            retBuf = new ArrayBuffer(retBuf.byteLength + 1);
            retView = new Uint8Array(retBuf);
            for (let k = 0; k < tempBuf.byteLength; k++) {
              retView[k + 1] = tempView[k];
            }
            retView[0] = 0;
          }
          return retBuf;
        }
        bigInt *= Math.pow(2, 8);
      }
      return new ArrayBuffer(0);
    }
    function isEqualBuffer(inputBuffer1, inputBuffer2) {
      if (inputBuffer1.byteLength !== inputBuffer2.byteLength) {
        return false;
      }
      const view1 = new Uint8Array(inputBuffer1);
      const view2 = new Uint8Array(inputBuffer2);
      for (let i = 0; i < view1.length; i++) {
        if (view1[i] !== view2[i]) {
          return false;
        }
      }
      return true;
    }
    function padNumber(inputNumber, fullLength) {
      const str = inputNumber.toString(10);
      if (fullLength < str.length) {
        return "";
      }
      const dif = fullLength - str.length;
      const padding = new Array(dif);
      for (let i = 0; i < dif; i++) {
        padding[i] = "0";
      }
      const paddingString = padding.join("");
      return paddingString.concat(str);
    }
    var log2 = Math.log(2);
    function assertBigInt() {
      if (typeof BigInt === "undefined") {
        throw new Error("BigInt is not defined. Your environment doesn't implement BigInt.");
      }
    }
    function concat(buffers) {
      let outputLength = 0;
      let prevLength = 0;
      for (let i = 0; i < buffers.length; i++) {
        const buffer = buffers[i];
        outputLength += buffer.byteLength;
      }
      const retView = new Uint8Array(outputLength);
      for (let i = 0; i < buffers.length; i++) {
        const buffer = buffers[i];
        retView.set(new Uint8Array(buffer), prevLength);
        prevLength += buffer.byteLength;
      }
      return retView.buffer;
    }
    function checkBufferParams(baseBlock, inputBuffer, inputOffset, inputLength) {
      if (!(inputBuffer instanceof Uint8Array)) {
        baseBlock.error = "Wrong parameter: inputBuffer must be 'Uint8Array'";
        return false;
      }
      if (!inputBuffer.byteLength) {
        baseBlock.error = "Wrong parameter: inputBuffer has zero length";
        return false;
      }
      if (inputOffset < 0) {
        baseBlock.error = "Wrong parameter: inputOffset less than zero";
        return false;
      }
      if (inputLength < 0) {
        baseBlock.error = "Wrong parameter: inputLength less than zero";
        return false;
      }
      if (inputBuffer.byteLength - inputOffset - inputLength < 0) {
        baseBlock.error = "End of input reached before message was fully decoded (inconsistent offset and length values)";
        return false;
      }
      return true;
    }
    var ViewWriter = class {
      constructor() {
        this.items = [];
      }
      write(buf) {
        this.items.push(buf);
      }
      final() {
        return concat(this.items);
      }
    };
    var powers2 = [new Uint8Array([1])];
    var digitsString = "0123456789";
    var NAME = "name";
    var VALUE_HEX_VIEW = "valueHexView";
    var IS_HEX_ONLY = "isHexOnly";
    var ID_BLOCK = "idBlock";
    var TAG_CLASS = "tagClass";
    var TAG_NUMBER = "tagNumber";
    var IS_CONSTRUCTED = "isConstructed";
    var FROM_BER = "fromBER";
    var TO_BER = "toBER";
    var LOCAL = "local";
    var EMPTY_STRING = "";
    var EMPTY_BUFFER = new ArrayBuffer(0);
    var EMPTY_VIEW = new Uint8Array(0);
    var END_OF_CONTENT_NAME = "EndOfContent";
    var OCTET_STRING_NAME = "OCTET STRING";
    var BIT_STRING_NAME = "BIT STRING";
    function HexBlock(BaseClass) {
      var _a2;
      return _a2 = class Some extends BaseClass {
        constructor(...args) {
          var _a3;
          super(...args);
          const params = args[0] || {};
          this.isHexOnly = (_a3 = params.isHexOnly) !== null && _a3 !== void 0 ? _a3 : false;
          this.valueHexView = params.valueHex ? BufferSourceConverter.toUint8Array(params.valueHex) : EMPTY_VIEW;
        }
        get valueHex() {
          return this.valueHexView.slice().buffer;
        }
        set valueHex(value) {
          this.valueHexView = new Uint8Array(value);
        }
        fromBER(inputBuffer, inputOffset, inputLength) {
          const view = inputBuffer instanceof ArrayBuffer ? new Uint8Array(inputBuffer) : inputBuffer;
          if (!checkBufferParams(this, view, inputOffset, inputLength)) {
            return -1;
          }
          const endLength = inputOffset + inputLength;
          this.valueHexView = view.subarray(inputOffset, endLength);
          if (!this.valueHexView.length) {
            this.warnings.push("Zero buffer length");
            return inputOffset;
          }
          this.blockLength = inputLength;
          return endLength;
        }
        toBER(sizeOnly = false) {
          if (!this.isHexOnly) {
            this.error = "Flag 'isHexOnly' is not set, abort";
            return EMPTY_BUFFER;
          }
          if (sizeOnly) {
            return new ArrayBuffer(this.valueHexView.byteLength);
          }
          return this.valueHexView.byteLength === this.valueHexView.buffer.byteLength ? this.valueHexView.buffer : this.valueHexView.slice().buffer;
        }
        toJSON() {
          return {
            ...super.toJSON(),
            isHexOnly: this.isHexOnly,
            valueHex: Convert.ToHex(this.valueHexView)
          };
        }
      }, _a2.NAME = "hexBlock", _a2;
    }
    var LocalBaseBlock = class {
      constructor({ blockLength = 0, error = EMPTY_STRING, warnings = [], valueBeforeDecode = EMPTY_VIEW } = {}) {
        this.blockLength = blockLength;
        this.error = error;
        this.warnings = warnings;
        this.valueBeforeDecodeView = BufferSourceConverter.toUint8Array(valueBeforeDecode);
      }
      static blockName() {
        return this.NAME;
      }
      get valueBeforeDecode() {
        return this.valueBeforeDecodeView.slice().buffer;
      }
      set valueBeforeDecode(value) {
        this.valueBeforeDecodeView = new Uint8Array(value);
      }
      toJSON() {
        return {
          blockName: this.constructor.NAME,
          blockLength: this.blockLength,
          error: this.error,
          warnings: this.warnings,
          valueBeforeDecode: Convert.ToHex(this.valueBeforeDecodeView)
        };
      }
    };
    LocalBaseBlock.NAME = "baseBlock";
    var ValueBlock = class extends LocalBaseBlock {
      fromBER(inputBuffer, inputOffset, inputLength) {
        throw TypeError("User need to make a specific function in a class which extends 'ValueBlock'");
      }
      toBER(sizeOnly, writer) {
        throw TypeError("User need to make a specific function in a class which extends 'ValueBlock'");
      }
    };
    ValueBlock.NAME = "valueBlock";
    var LocalIdentificationBlock = class extends HexBlock(LocalBaseBlock) {
      constructor({ idBlock = {} } = {}) {
        var _a2, _b, _c, _d;
        super();
        if (idBlock) {
          this.isHexOnly = (_a2 = idBlock.isHexOnly) !== null && _a2 !== void 0 ? _a2 : false;
          this.valueHexView = idBlock.valueHex ? BufferSourceConverter.toUint8Array(idBlock.valueHex) : EMPTY_VIEW;
          this.tagClass = (_b = idBlock.tagClass) !== null && _b !== void 0 ? _b : -1;
          this.tagNumber = (_c = idBlock.tagNumber) !== null && _c !== void 0 ? _c : -1;
          this.isConstructed = (_d = idBlock.isConstructed) !== null && _d !== void 0 ? _d : false;
        } else {
          this.tagClass = -1;
          this.tagNumber = -1;
          this.isConstructed = false;
        }
      }
      toBER(sizeOnly = false) {
        let firstOctet = 0;
        switch (this.tagClass) {
          case 1:
            firstOctet |= 0;
            break;
          case 2:
            firstOctet |= 64;
            break;
          case 3:
            firstOctet |= 128;
            break;
          case 4:
            firstOctet |= 192;
            break;
          default:
            this.error = "Unknown tag class";
            return EMPTY_BUFFER;
        }
        if (this.isConstructed)
          firstOctet |= 32;
        if (this.tagNumber < 31 && !this.isHexOnly) {
          const retView2 = new Uint8Array(1);
          if (!sizeOnly) {
            let number = this.tagNumber;
            number &= 31;
            firstOctet |= number;
            retView2[0] = firstOctet;
          }
          return retView2.buffer;
        }
        if (!this.isHexOnly) {
          const encodedBuf = utilToBase(this.tagNumber, 7);
          const encodedView = new Uint8Array(encodedBuf);
          const size = encodedBuf.byteLength;
          const retView2 = new Uint8Array(size + 1);
          retView2[0] = firstOctet | 31;
          if (!sizeOnly) {
            for (let i = 0; i < size - 1; i++)
              retView2[i + 1] = encodedView[i] | 128;
            retView2[size] = encodedView[size - 1];
          }
          return retView2.buffer;
        }
        const retView = new Uint8Array(this.valueHexView.byteLength + 1);
        retView[0] = firstOctet | 31;
        if (!sizeOnly) {
          const curView = this.valueHexView;
          for (let i = 0; i < curView.length - 1; i++)
            retView[i + 1] = curView[i] | 128;
          retView[this.valueHexView.byteLength] = curView[curView.length - 1];
        }
        return retView.buffer;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        const inputView = BufferSourceConverter.toUint8Array(inputBuffer);
        if (!checkBufferParams(this, inputView, inputOffset, inputLength)) {
          return -1;
        }
        const intBuffer = inputView.subarray(inputOffset, inputOffset + inputLength);
        if (intBuffer.length === 0) {
          this.error = "Zero buffer length";
          return -1;
        }
        const tagClassMask = intBuffer[0] & 192;
        switch (tagClassMask) {
          case 0:
            this.tagClass = 1;
            break;
          case 64:
            this.tagClass = 2;
            break;
          case 128:
            this.tagClass = 3;
            break;
          case 192:
            this.tagClass = 4;
            break;
          default:
            this.error = "Unknown tag class";
            return -1;
        }
        this.isConstructed = (intBuffer[0] & 32) === 32;
        this.isHexOnly = false;
        const tagNumberMask = intBuffer[0] & 31;
        if (tagNumberMask !== 31) {
          this.tagNumber = tagNumberMask;
          this.blockLength = 1;
        } else {
          let count = 1;
          let intTagNumberBuffer = this.valueHexView = new Uint8Array(255);
          let tagNumberBufferMaxLength = 255;
          while (intBuffer[count] & 128) {
            intTagNumberBuffer[count - 1] = intBuffer[count] & 127;
            count++;
            if (count >= intBuffer.length) {
              this.error = "End of input reached before message was fully decoded";
              return -1;
            }
            if (count === tagNumberBufferMaxLength) {
              tagNumberBufferMaxLength += 255;
              const tempBufferView2 = new Uint8Array(tagNumberBufferMaxLength);
              for (let i = 0; i < intTagNumberBuffer.length; i++)
                tempBufferView2[i] = intTagNumberBuffer[i];
              intTagNumberBuffer = this.valueHexView = new Uint8Array(tagNumberBufferMaxLength);
            }
          }
          this.blockLength = count + 1;
          intTagNumberBuffer[count - 1] = intBuffer[count] & 127;
          const tempBufferView = new Uint8Array(count);
          for (let i = 0; i < count; i++)
            tempBufferView[i] = intTagNumberBuffer[i];
          intTagNumberBuffer = this.valueHexView = new Uint8Array(count);
          intTagNumberBuffer.set(tempBufferView);
          if (this.blockLength <= 9)
            this.tagNumber = utilFromBase(intTagNumberBuffer, 7);
          else {
            this.isHexOnly = true;
            this.warnings.push("Tag too long, represented as hex-coded");
          }
        }
        if (this.tagClass === 1 && this.isConstructed) {
          switch (this.tagNumber) {
            case 1:
            case 2:
            case 5:
            case 6:
            case 9:
            case 13:
            case 14:
            case 23:
            case 24:
            case 31:
            case 32:
            case 33:
            case 34:
              this.error = "Constructed encoding used for primitive type";
              return -1;
          }
        }
        return inputOffset + this.blockLength;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          tagClass: this.tagClass,
          tagNumber: this.tagNumber,
          isConstructed: this.isConstructed
        };
      }
    };
    LocalIdentificationBlock.NAME = "identificationBlock";
    var LocalLengthBlock = class extends LocalBaseBlock {
      constructor({ lenBlock = {} } = {}) {
        var _a2, _b, _c;
        super();
        this.isIndefiniteForm = (_a2 = lenBlock.isIndefiniteForm) !== null && _a2 !== void 0 ? _a2 : false;
        this.longFormUsed = (_b = lenBlock.longFormUsed) !== null && _b !== void 0 ? _b : false;
        this.length = (_c = lenBlock.length) !== null && _c !== void 0 ? _c : 0;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        const view = BufferSourceConverter.toUint8Array(inputBuffer);
        if (!checkBufferParams(this, view, inputOffset, inputLength)) {
          return -1;
        }
        const intBuffer = view.subarray(inputOffset, inputOffset + inputLength);
        if (intBuffer.length === 0) {
          this.error = "Zero buffer length";
          return -1;
        }
        if (intBuffer[0] === 255) {
          this.error = "Length block 0xFF is reserved by standard";
          return -1;
        }
        this.isIndefiniteForm = intBuffer[0] === 128;
        if (this.isIndefiniteForm) {
          this.blockLength = 1;
          return inputOffset + this.blockLength;
        }
        this.longFormUsed = !!(intBuffer[0] & 128);
        if (this.longFormUsed === false) {
          this.length = intBuffer[0];
          this.blockLength = 1;
          return inputOffset + this.blockLength;
        }
        const count = intBuffer[0] & 127;
        if (count > 8) {
          this.error = "Too big integer";
          return -1;
        }
        if (count + 1 > intBuffer.length) {
          this.error = "End of input reached before message was fully decoded";
          return -1;
        }
        const lenOffset = inputOffset + 1;
        const lengthBufferView = view.subarray(lenOffset, lenOffset + count);
        if (lengthBufferView[count - 1] === 0)
          this.warnings.push("Needlessly long encoded length");
        this.length = utilFromBase(lengthBufferView, 8);
        if (this.longFormUsed && this.length <= 127)
          this.warnings.push("Unnecessary usage of long length form");
        this.blockLength = count + 1;
        return inputOffset + this.blockLength;
      }
      toBER(sizeOnly = false) {
        let retBuf;
        let retView;
        if (this.length > 127)
          this.longFormUsed = true;
        if (this.isIndefiniteForm) {
          retBuf = new ArrayBuffer(1);
          if (sizeOnly === false) {
            retView = new Uint8Array(retBuf);
            retView[0] = 128;
          }
          return retBuf;
        }
        if (this.longFormUsed) {
          const encodedBuf = utilToBase(this.length, 8);
          if (encodedBuf.byteLength > 127) {
            this.error = "Too big length";
            return EMPTY_BUFFER;
          }
          retBuf = new ArrayBuffer(encodedBuf.byteLength + 1);
          if (sizeOnly)
            return retBuf;
          const encodedView = new Uint8Array(encodedBuf);
          retView = new Uint8Array(retBuf);
          retView[0] = encodedBuf.byteLength | 128;
          for (let i = 0; i < encodedBuf.byteLength; i++)
            retView[i + 1] = encodedView[i];
          return retBuf;
        }
        retBuf = new ArrayBuffer(1);
        if (sizeOnly === false) {
          retView = new Uint8Array(retBuf);
          retView[0] = this.length;
        }
        return retBuf;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          isIndefiniteForm: this.isIndefiniteForm,
          longFormUsed: this.longFormUsed,
          length: this.length
        };
      }
    };
    LocalLengthBlock.NAME = "lengthBlock";
    var typeStore = {};
    var BaseBlock = class extends LocalBaseBlock {
      constructor({ name = EMPTY_STRING, optional = false, primitiveSchema, ...parameters } = {}, valueBlockType) {
        super(parameters);
        this.name = name;
        this.optional = optional;
        if (primitiveSchema) {
          this.primitiveSchema = primitiveSchema;
        }
        this.idBlock = new LocalIdentificationBlock(parameters);
        this.lenBlock = new LocalLengthBlock(parameters);
        this.valueBlock = valueBlockType ? new valueBlockType(parameters) : new ValueBlock(parameters);
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        const resultOffset = this.valueBlock.fromBER(inputBuffer, inputOffset, this.lenBlock.isIndefiniteForm ? inputLength : this.lenBlock.length);
        if (resultOffset === -1) {
          this.error = this.valueBlock.error;
          return resultOffset;
        }
        if (!this.idBlock.error.length)
          this.blockLength += this.idBlock.blockLength;
        if (!this.lenBlock.error.length)
          this.blockLength += this.lenBlock.blockLength;
        if (!this.valueBlock.error.length)
          this.blockLength += this.valueBlock.blockLength;
        return resultOffset;
      }
      toBER(sizeOnly, writer) {
        const _writer = writer || new ViewWriter();
        if (!writer) {
          prepareIndefiniteForm(this);
        }
        const idBlockBuf = this.idBlock.toBER(sizeOnly);
        _writer.write(idBlockBuf);
        if (this.lenBlock.isIndefiniteForm) {
          _writer.write(new Uint8Array([128]).buffer);
          this.valueBlock.toBER(sizeOnly, _writer);
          _writer.write(new ArrayBuffer(2));
        } else {
          const valueBlockBuf = this.valueBlock.toBER(sizeOnly);
          this.lenBlock.length = valueBlockBuf.byteLength;
          const lenBlockBuf = this.lenBlock.toBER(sizeOnly);
          _writer.write(lenBlockBuf);
          _writer.write(valueBlockBuf);
        }
        if (!writer) {
          return _writer.final();
        }
        return EMPTY_BUFFER;
      }
      toJSON() {
        const object = {
          ...super.toJSON(),
          idBlock: this.idBlock.toJSON(),
          lenBlock: this.lenBlock.toJSON(),
          valueBlock: this.valueBlock.toJSON(),
          name: this.name,
          optional: this.optional
        };
        if (this.primitiveSchema)
          object.primitiveSchema = this.primitiveSchema.toJSON();
        return object;
      }
      toString(encoding = "ascii") {
        if (encoding === "ascii") {
          return this.onAsciiEncoding();
        }
        return Convert.ToHex(this.toBER());
      }
      onAsciiEncoding() {
        return `${this.constructor.NAME} : ${Convert.ToHex(this.valueBlock.valueBeforeDecodeView)}`;
      }
      isEqual(other) {
        if (this === other) {
          return true;
        }
        if (!(other instanceof this.constructor)) {
          return false;
        }
        const thisRaw = this.toBER();
        const otherRaw = other.toBER();
        return isEqualBuffer(thisRaw, otherRaw);
      }
    };
    BaseBlock.NAME = "BaseBlock";
    function prepareIndefiniteForm(baseBlock) {
      if (baseBlock instanceof typeStore.Constructed) {
        for (const value of baseBlock.valueBlock.value) {
          if (prepareIndefiniteForm(value)) {
            baseBlock.lenBlock.isIndefiniteForm = true;
          }
        }
      }
      return !!baseBlock.lenBlock.isIndefiniteForm;
    }
    var BaseStringBlock = class extends BaseBlock {
      constructor({ value = EMPTY_STRING, ...parameters } = {}, stringValueBlockType) {
        super(parameters, stringValueBlockType);
        if (value) {
          this.fromString(value);
        }
      }
      getValue() {
        return this.valueBlock.value;
      }
      setValue(value) {
        this.valueBlock.value = value;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        const resultOffset = this.valueBlock.fromBER(inputBuffer, inputOffset, this.lenBlock.isIndefiniteForm ? inputLength : this.lenBlock.length);
        if (resultOffset === -1) {
          this.error = this.valueBlock.error;
          return resultOffset;
        }
        this.fromBuffer(this.valueBlock.valueHexView);
        if (!this.idBlock.error.length)
          this.blockLength += this.idBlock.blockLength;
        if (!this.lenBlock.error.length)
          this.blockLength += this.lenBlock.blockLength;
        if (!this.valueBlock.error.length)
          this.blockLength += this.valueBlock.blockLength;
        return resultOffset;
      }
      onAsciiEncoding() {
        return `${this.constructor.NAME} : '${this.valueBlock.value}'`;
      }
    };
    BaseStringBlock.NAME = "BaseStringBlock";
    var LocalPrimitiveValueBlock = class extends HexBlock(ValueBlock) {
      constructor({ isHexOnly = true, ...parameters } = {}) {
        super(parameters);
        this.isHexOnly = isHexOnly;
      }
    };
    LocalPrimitiveValueBlock.NAME = "PrimitiveValueBlock";
    var _a$w;
    var Primitive = class extends BaseBlock {
      constructor(parameters = {}) {
        super(parameters, LocalPrimitiveValueBlock);
        this.idBlock.isConstructed = false;
      }
    };
    _a$w = Primitive;
    (() => {
      typeStore.Primitive = _a$w;
    })();
    Primitive.NAME = "PRIMITIVE";
    function localChangeType(inputObject, newType) {
      if (inputObject instanceof newType) {
        return inputObject;
      }
      const newObject = new newType();
      newObject.idBlock = inputObject.idBlock;
      newObject.lenBlock = inputObject.lenBlock;
      newObject.warnings = inputObject.warnings;
      newObject.valueBeforeDecodeView = inputObject.valueBeforeDecodeView;
      return newObject;
    }
    function localFromBER(inputBuffer, inputOffset = 0, inputLength = inputBuffer.length) {
      const incomingOffset = inputOffset;
      let returnObject = new BaseBlock({}, ValueBlock);
      const baseBlock = new LocalBaseBlock();
      if (!checkBufferParams(baseBlock, inputBuffer, inputOffset, inputLength)) {
        returnObject.error = baseBlock.error;
        return {
          offset: -1,
          result: returnObject
        };
      }
      const intBuffer = inputBuffer.subarray(inputOffset, inputOffset + inputLength);
      if (!intBuffer.length) {
        returnObject.error = "Zero buffer length";
        return {
          offset: -1,
          result: returnObject
        };
      }
      let resultOffset = returnObject.idBlock.fromBER(inputBuffer, inputOffset, inputLength);
      if (returnObject.idBlock.warnings.length) {
        returnObject.warnings.concat(returnObject.idBlock.warnings);
      }
      if (resultOffset === -1) {
        returnObject.error = returnObject.idBlock.error;
        return {
          offset: -1,
          result: returnObject
        };
      }
      inputOffset = resultOffset;
      inputLength -= returnObject.idBlock.blockLength;
      resultOffset = returnObject.lenBlock.fromBER(inputBuffer, inputOffset, inputLength);
      if (returnObject.lenBlock.warnings.length) {
        returnObject.warnings.concat(returnObject.lenBlock.warnings);
      }
      if (resultOffset === -1) {
        returnObject.error = returnObject.lenBlock.error;
        return {
          offset: -1,
          result: returnObject
        };
      }
      inputOffset = resultOffset;
      inputLength -= returnObject.lenBlock.blockLength;
      if (!returnObject.idBlock.isConstructed && returnObject.lenBlock.isIndefiniteForm) {
        returnObject.error = "Indefinite length form used for primitive encoding form";
        return {
          offset: -1,
          result: returnObject
        };
      }
      let newASN1Type = BaseBlock;
      switch (returnObject.idBlock.tagClass) {
        case 1:
          if (returnObject.idBlock.tagNumber >= 37 && returnObject.idBlock.isHexOnly === false) {
            returnObject.error = "UNIVERSAL 37 and upper tags are reserved by ASN.1 standard";
            return {
              offset: -1,
              result: returnObject
            };
          }
          switch (returnObject.idBlock.tagNumber) {
            case 0:
              if (returnObject.idBlock.isConstructed && returnObject.lenBlock.length > 0) {
                returnObject.error = "Type [UNIVERSAL 0] is reserved";
                return {
                  offset: -1,
                  result: returnObject
                };
              }
              newASN1Type = typeStore.EndOfContent;
              break;
            case 1:
              newASN1Type = typeStore.Boolean;
              break;
            case 2:
              newASN1Type = typeStore.Integer;
              break;
            case 3:
              newASN1Type = typeStore.BitString;
              break;
            case 4:
              newASN1Type = typeStore.OctetString;
              break;
            case 5:
              newASN1Type = typeStore.Null;
              break;
            case 6:
              newASN1Type = typeStore.ObjectIdentifier;
              break;
            case 10:
              newASN1Type = typeStore.Enumerated;
              break;
            case 12:
              newASN1Type = typeStore.Utf8String;
              break;
            case 13:
              newASN1Type = typeStore.RelativeObjectIdentifier;
              break;
            case 14:
              newASN1Type = typeStore.TIME;
              break;
            case 15:
              returnObject.error = "[UNIVERSAL 15] is reserved by ASN.1 standard";
              return {
                offset: -1,
                result: returnObject
              };
            case 16:
              newASN1Type = typeStore.Sequence;
              break;
            case 17:
              newASN1Type = typeStore.Set;
              break;
            case 18:
              newASN1Type = typeStore.NumericString;
              break;
            case 19:
              newASN1Type = typeStore.PrintableString;
              break;
            case 20:
              newASN1Type = typeStore.TeletexString;
              break;
            case 21:
              newASN1Type = typeStore.VideotexString;
              break;
            case 22:
              newASN1Type = typeStore.IA5String;
              break;
            case 23:
              newASN1Type = typeStore.UTCTime;
              break;
            case 24:
              newASN1Type = typeStore.GeneralizedTime;
              break;
            case 25:
              newASN1Type = typeStore.GraphicString;
              break;
            case 26:
              newASN1Type = typeStore.VisibleString;
              break;
            case 27:
              newASN1Type = typeStore.GeneralString;
              break;
            case 28:
              newASN1Type = typeStore.UniversalString;
              break;
            case 29:
              newASN1Type = typeStore.CharacterString;
              break;
            case 30:
              newASN1Type = typeStore.BmpString;
              break;
            case 31:
              newASN1Type = typeStore.DATE;
              break;
            case 32:
              newASN1Type = typeStore.TimeOfDay;
              break;
            case 33:
              newASN1Type = typeStore.DateTime;
              break;
            case 34:
              newASN1Type = typeStore.Duration;
              break;
            default: {
              const newObject = returnObject.idBlock.isConstructed ? new typeStore.Constructed() : new typeStore.Primitive();
              newObject.idBlock = returnObject.idBlock;
              newObject.lenBlock = returnObject.lenBlock;
              newObject.warnings = returnObject.warnings;
              returnObject = newObject;
            }
          }
          break;
        case 2:
        case 3:
        case 4:
        default: {
          newASN1Type = returnObject.idBlock.isConstructed ? typeStore.Constructed : typeStore.Primitive;
        }
      }
      returnObject = localChangeType(returnObject, newASN1Type);
      resultOffset = returnObject.fromBER(inputBuffer, inputOffset, returnObject.lenBlock.isIndefiniteForm ? inputLength : returnObject.lenBlock.length);
      returnObject.valueBeforeDecodeView = inputBuffer.subarray(incomingOffset, incomingOffset + returnObject.blockLength);
      return {
        offset: resultOffset,
        result: returnObject
      };
    }
    function fromBER(inputBuffer) {
      if (!inputBuffer.byteLength) {
        const result2 = new BaseBlock({}, ValueBlock);
        result2.error = "Input buffer has zero length";
        return {
          offset: -1,
          result: result2
        };
      }
      return localFromBER(BufferSourceConverter.toUint8Array(inputBuffer).slice(), 0, inputBuffer.byteLength);
    }
    function checkLen(indefiniteLength, length) {
      if (indefiniteLength) {
        return 1;
      }
      return length;
    }
    var LocalConstructedValueBlock = class extends ValueBlock {
      constructor({ value = [], isIndefiniteForm = false, ...parameters } = {}) {
        super(parameters);
        this.value = value;
        this.isIndefiniteForm = isIndefiniteForm;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        const view = BufferSourceConverter.toUint8Array(inputBuffer);
        if (!checkBufferParams(this, view, inputOffset, inputLength)) {
          return -1;
        }
        this.valueBeforeDecodeView = view.subarray(inputOffset, inputOffset + inputLength);
        if (this.valueBeforeDecodeView.length === 0) {
          this.warnings.push("Zero buffer length");
          return inputOffset;
        }
        let currentOffset = inputOffset;
        while (checkLen(this.isIndefiniteForm, inputLength) > 0) {
          const returnObject = localFromBER(view, currentOffset, inputLength);
          if (returnObject.offset === -1) {
            this.error = returnObject.result.error;
            this.warnings.concat(returnObject.result.warnings);
            return -1;
          }
          currentOffset = returnObject.offset;
          this.blockLength += returnObject.result.blockLength;
          inputLength -= returnObject.result.blockLength;
          this.value.push(returnObject.result);
          if (this.isIndefiniteForm && returnObject.result.constructor.NAME === END_OF_CONTENT_NAME) {
            break;
          }
        }
        if (this.isIndefiniteForm) {
          if (this.value[this.value.length - 1].constructor.NAME === END_OF_CONTENT_NAME) {
            this.value.pop();
          } else {
            this.warnings.push("No EndOfContent block encoded");
          }
        }
        return currentOffset;
      }
      toBER(sizeOnly, writer) {
        const _writer = writer || new ViewWriter();
        for (let i = 0; i < this.value.length; i++) {
          this.value[i].toBER(sizeOnly, _writer);
        }
        if (!writer) {
          return _writer.final();
        }
        return EMPTY_BUFFER;
      }
      toJSON() {
        const object = {
          ...super.toJSON(),
          isIndefiniteForm: this.isIndefiniteForm,
          value: []
        };
        for (const value of this.value) {
          object.value.push(value.toJSON());
        }
        return object;
      }
    };
    LocalConstructedValueBlock.NAME = "ConstructedValueBlock";
    var _a$v;
    var Constructed = class extends BaseBlock {
      constructor(parameters = {}) {
        super(parameters, LocalConstructedValueBlock);
        this.idBlock.isConstructed = true;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        this.valueBlock.isIndefiniteForm = this.lenBlock.isIndefiniteForm;
        const resultOffset = this.valueBlock.fromBER(inputBuffer, inputOffset, this.lenBlock.isIndefiniteForm ? inputLength : this.lenBlock.length);
        if (resultOffset === -1) {
          this.error = this.valueBlock.error;
          return resultOffset;
        }
        if (!this.idBlock.error.length)
          this.blockLength += this.idBlock.blockLength;
        if (!this.lenBlock.error.length)
          this.blockLength += this.lenBlock.blockLength;
        if (!this.valueBlock.error.length)
          this.blockLength += this.valueBlock.blockLength;
        return resultOffset;
      }
      onAsciiEncoding() {
        const values = [];
        for (const value of this.valueBlock.value) {
          values.push(value.toString("ascii").split("\n").map((o2) => `  ${o2}`).join("\n"));
        }
        const blockName = this.idBlock.tagClass === 3 ? `[${this.idBlock.tagNumber}]` : this.constructor.NAME;
        return values.length ? `${blockName} :
${values.join("\n")}` : `${blockName} :`;
      }
    };
    _a$v = Constructed;
    (() => {
      typeStore.Constructed = _a$v;
    })();
    Constructed.NAME = "CONSTRUCTED";
    var LocalEndOfContentValueBlock = class extends ValueBlock {
      fromBER(inputBuffer, inputOffset, inputLength) {
        return inputOffset;
      }
      toBER(sizeOnly) {
        return EMPTY_BUFFER;
      }
    };
    LocalEndOfContentValueBlock.override = "EndOfContentValueBlock";
    var _a$u;
    var EndOfContent = class extends BaseBlock {
      constructor(parameters = {}) {
        super(parameters, LocalEndOfContentValueBlock);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 0;
      }
    };
    _a$u = EndOfContent;
    (() => {
      typeStore.EndOfContent = _a$u;
    })();
    EndOfContent.NAME = END_OF_CONTENT_NAME;
    var _a$t;
    var Null = class extends BaseBlock {
      constructor(parameters = {}) {
        super(parameters, ValueBlock);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 5;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        if (this.lenBlock.length > 0)
          this.warnings.push("Non-zero length of value block for Null type");
        if (!this.idBlock.error.length)
          this.blockLength += this.idBlock.blockLength;
        if (!this.lenBlock.error.length)
          this.blockLength += this.lenBlock.blockLength;
        this.blockLength += inputLength;
        if (inputOffset + inputLength > inputBuffer.byteLength) {
          this.error = "End of input reached before message was fully decoded (inconsistent offset and length values)";
          return -1;
        }
        return inputOffset + inputLength;
      }
      toBER(sizeOnly, writer) {
        const retBuf = new ArrayBuffer(2);
        if (!sizeOnly) {
          const retView = new Uint8Array(retBuf);
          retView[0] = 5;
          retView[1] = 0;
        }
        if (writer) {
          writer.write(retBuf);
        }
        return retBuf;
      }
      onAsciiEncoding() {
        return `${this.constructor.NAME}`;
      }
    };
    _a$t = Null;
    (() => {
      typeStore.Null = _a$t;
    })();
    Null.NAME = "NULL";
    var LocalBooleanValueBlock = class extends HexBlock(ValueBlock) {
      constructor({ value, ...parameters } = {}) {
        super(parameters);
        if (parameters.valueHex) {
          this.valueHexView = BufferSourceConverter.toUint8Array(parameters.valueHex);
        } else {
          this.valueHexView = new Uint8Array(1);
        }
        if (value) {
          this.value = value;
        }
      }
      get value() {
        for (const octet of this.valueHexView) {
          if (octet > 0) {
            return true;
          }
        }
        return false;
      }
      set value(value) {
        this.valueHexView[0] = value ? 255 : 0;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        const inputView = BufferSourceConverter.toUint8Array(inputBuffer);
        if (!checkBufferParams(this, inputView, inputOffset, inputLength)) {
          return -1;
        }
        this.valueHexView = inputView.subarray(inputOffset, inputOffset + inputLength);
        if (inputLength > 1)
          this.warnings.push("Boolean value encoded in more then 1 octet");
        this.isHexOnly = true;
        utilDecodeTC.call(this);
        this.blockLength = inputLength;
        return inputOffset + inputLength;
      }
      toBER() {
        return this.valueHexView.slice();
      }
      toJSON() {
        return {
          ...super.toJSON(),
          value: this.value
        };
      }
    };
    LocalBooleanValueBlock.NAME = "BooleanValueBlock";
    var _a$s;
    var Boolean2 = class extends BaseBlock {
      constructor(parameters = {}) {
        super(parameters, LocalBooleanValueBlock);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 1;
      }
      getValue() {
        return this.valueBlock.value;
      }
      setValue(value) {
        this.valueBlock.value = value;
      }
      onAsciiEncoding() {
        return `${this.constructor.NAME} : ${this.getValue}`;
      }
    };
    _a$s = Boolean2;
    (() => {
      typeStore.Boolean = _a$s;
    })();
    Boolean2.NAME = "BOOLEAN";
    var LocalOctetStringValueBlock = class extends HexBlock(LocalConstructedValueBlock) {
      constructor({ isConstructed = false, ...parameters } = {}) {
        super(parameters);
        this.isConstructed = isConstructed;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        let resultOffset = 0;
        if (this.isConstructed) {
          this.isHexOnly = false;
          resultOffset = LocalConstructedValueBlock.prototype.fromBER.call(this, inputBuffer, inputOffset, inputLength);
          if (resultOffset === -1)
            return resultOffset;
          for (let i = 0; i < this.value.length; i++) {
            const currentBlockName = this.value[i].constructor.NAME;
            if (currentBlockName === END_OF_CONTENT_NAME) {
              if (this.isIndefiniteForm)
                break;
              else {
                this.error = "EndOfContent is unexpected, OCTET STRING may consists of OCTET STRINGs only";
                return -1;
              }
            }
            if (currentBlockName !== OCTET_STRING_NAME) {
              this.error = "OCTET STRING may consists of OCTET STRINGs only";
              return -1;
            }
          }
        } else {
          this.isHexOnly = true;
          resultOffset = super.fromBER(inputBuffer, inputOffset, inputLength);
          this.blockLength = inputLength;
        }
        return resultOffset;
      }
      toBER(sizeOnly, writer) {
        if (this.isConstructed)
          return LocalConstructedValueBlock.prototype.toBER.call(this, sizeOnly, writer);
        return sizeOnly ? new ArrayBuffer(this.valueHexView.byteLength) : this.valueHexView.slice().buffer;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          isConstructed: this.isConstructed
        };
      }
    };
    LocalOctetStringValueBlock.NAME = "OctetStringValueBlock";
    var _a$r;
    var OctetString = class _OctetString extends BaseBlock {
      constructor({ idBlock = {}, lenBlock = {}, ...parameters } = {}) {
        var _b, _c;
        (_b = parameters.isConstructed) !== null && _b !== void 0 ? _b : parameters.isConstructed = !!((_c = parameters.value) === null || _c === void 0 ? void 0 : _c.length);
        super({
          idBlock: {
            isConstructed: parameters.isConstructed,
            ...idBlock
          },
          lenBlock: {
            ...lenBlock,
            isIndefiniteForm: !!parameters.isIndefiniteForm
          },
          ...parameters
        }, LocalOctetStringValueBlock);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 4;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        this.valueBlock.isConstructed = this.idBlock.isConstructed;
        this.valueBlock.isIndefiniteForm = this.lenBlock.isIndefiniteForm;
        if (inputLength === 0) {
          if (this.idBlock.error.length === 0)
            this.blockLength += this.idBlock.blockLength;
          if (this.lenBlock.error.length === 0)
            this.blockLength += this.lenBlock.blockLength;
          return inputOffset;
        }
        if (!this.valueBlock.isConstructed) {
          const view = inputBuffer instanceof ArrayBuffer ? new Uint8Array(inputBuffer) : inputBuffer;
          const buf = view.subarray(inputOffset, inputOffset + inputLength);
          try {
            if (buf.byteLength) {
              const asn = localFromBER(buf, 0, buf.byteLength);
              if (asn.offset !== -1 && asn.offset === inputLength) {
                this.valueBlock.value = [asn.result];
              }
            }
          } catch (e) {
          }
        }
        return super.fromBER(inputBuffer, inputOffset, inputLength);
      }
      onAsciiEncoding() {
        if (this.valueBlock.isConstructed || this.valueBlock.value && this.valueBlock.value.length) {
          return Constructed.prototype.onAsciiEncoding.call(this);
        }
        return `${this.constructor.NAME} : ${Convert.ToHex(this.valueBlock.valueHexView)}`;
      }
      getValue() {
        if (!this.idBlock.isConstructed) {
          return this.valueBlock.valueHexView.slice().buffer;
        }
        const array = [];
        for (const content of this.valueBlock.value) {
          if (content instanceof _OctetString) {
            array.push(content.valueBlock.valueHexView);
          }
        }
        return BufferSourceConverter.concat(array);
      }
    };
    _a$r = OctetString;
    (() => {
      typeStore.OctetString = _a$r;
    })();
    OctetString.NAME = OCTET_STRING_NAME;
    var LocalBitStringValueBlock = class extends HexBlock(LocalConstructedValueBlock) {
      constructor({ unusedBits = 0, isConstructed = false, ...parameters } = {}) {
        super(parameters);
        this.unusedBits = unusedBits;
        this.isConstructed = isConstructed;
        this.blockLength = this.valueHexView.byteLength;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        if (!inputLength) {
          return inputOffset;
        }
        let resultOffset = -1;
        if (this.isConstructed) {
          resultOffset = LocalConstructedValueBlock.prototype.fromBER.call(this, inputBuffer, inputOffset, inputLength);
          if (resultOffset === -1)
            return resultOffset;
          for (const value of this.value) {
            const currentBlockName = value.constructor.NAME;
            if (currentBlockName === END_OF_CONTENT_NAME) {
              if (this.isIndefiniteForm)
                break;
              else {
                this.error = "EndOfContent is unexpected, BIT STRING may consists of BIT STRINGs only";
                return -1;
              }
            }
            if (currentBlockName !== BIT_STRING_NAME) {
              this.error = "BIT STRING may consists of BIT STRINGs only";
              return -1;
            }
            const valueBlock = value.valueBlock;
            if (this.unusedBits > 0 && valueBlock.unusedBits > 0) {
              this.error = 'Using of "unused bits" inside constructive BIT STRING allowed for least one only';
              return -1;
            }
            this.unusedBits = valueBlock.unusedBits;
          }
          return resultOffset;
        }
        const inputView = BufferSourceConverter.toUint8Array(inputBuffer);
        if (!checkBufferParams(this, inputView, inputOffset, inputLength)) {
          return -1;
        }
        const intBuffer = inputView.subarray(inputOffset, inputOffset + inputLength);
        this.unusedBits = intBuffer[0];
        if (this.unusedBits > 7) {
          this.error = "Unused bits for BitString must be in range 0-7";
          return -1;
        }
        if (!this.unusedBits) {
          const buf = intBuffer.subarray(1);
          try {
            if (buf.byteLength) {
              const asn = localFromBER(buf, 0, buf.byteLength);
              if (asn.offset !== -1 && asn.offset === inputLength - 1) {
                this.value = [asn.result];
              }
            }
          } catch (e) {
          }
        }
        this.valueHexView = intBuffer.subarray(1);
        this.blockLength = intBuffer.length;
        return inputOffset + inputLength;
      }
      toBER(sizeOnly, writer) {
        if (this.isConstructed) {
          return LocalConstructedValueBlock.prototype.toBER.call(this, sizeOnly, writer);
        }
        if (sizeOnly) {
          return new ArrayBuffer(this.valueHexView.byteLength + 1);
        }
        if (!this.valueHexView.byteLength) {
          return EMPTY_BUFFER;
        }
        const retView = new Uint8Array(this.valueHexView.length + 1);
        retView[0] = this.unusedBits;
        retView.set(this.valueHexView, 1);
        return retView.buffer;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          unusedBits: this.unusedBits,
          isConstructed: this.isConstructed
        };
      }
    };
    LocalBitStringValueBlock.NAME = "BitStringValueBlock";
    var _a$q;
    var BitString = class extends BaseBlock {
      constructor({ idBlock = {}, lenBlock = {}, ...parameters } = {}) {
        var _b, _c;
        (_b = parameters.isConstructed) !== null && _b !== void 0 ? _b : parameters.isConstructed = !!((_c = parameters.value) === null || _c === void 0 ? void 0 : _c.length);
        super({
          idBlock: {
            isConstructed: parameters.isConstructed,
            ...idBlock
          },
          lenBlock: {
            ...lenBlock,
            isIndefiniteForm: !!parameters.isIndefiniteForm
          },
          ...parameters
        }, LocalBitStringValueBlock);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 3;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        this.valueBlock.isConstructed = this.idBlock.isConstructed;
        this.valueBlock.isIndefiniteForm = this.lenBlock.isIndefiniteForm;
        return super.fromBER(inputBuffer, inputOffset, inputLength);
      }
      onAsciiEncoding() {
        if (this.valueBlock.isConstructed || this.valueBlock.value && this.valueBlock.value.length) {
          return Constructed.prototype.onAsciiEncoding.call(this);
        } else {
          const bits = [];
          const valueHex = this.valueBlock.valueHexView;
          for (const byte of valueHex) {
            bits.push(byte.toString(2).padStart(8, "0"));
          }
          const bitsStr = bits.join("");
          return `${this.constructor.NAME} : ${bitsStr.substring(0, bitsStr.length - this.valueBlock.unusedBits)}`;
        }
      }
    };
    _a$q = BitString;
    (() => {
      typeStore.BitString = _a$q;
    })();
    BitString.NAME = BIT_STRING_NAME;
    var _a$p;
    function viewAdd(first, second) {
      const c2 = new Uint8Array([0]);
      const firstView = new Uint8Array(first);
      const secondView = new Uint8Array(second);
      let firstViewCopy = firstView.slice(0);
      const firstViewCopyLength = firstViewCopy.length - 1;
      const secondViewCopy = secondView.slice(0);
      const secondViewCopyLength = secondViewCopy.length - 1;
      let value = 0;
      const max = secondViewCopyLength < firstViewCopyLength ? firstViewCopyLength : secondViewCopyLength;
      let counter = 0;
      for (let i = max; i >= 0; i--, counter++) {
        switch (true) {
          case counter < secondViewCopy.length:
            value = firstViewCopy[firstViewCopyLength - counter] + secondViewCopy[secondViewCopyLength - counter] + c2[0];
            break;
          default:
            value = firstViewCopy[firstViewCopyLength - counter] + c2[0];
        }
        c2[0] = value / 10;
        switch (true) {
          case counter >= firstViewCopy.length:
            firstViewCopy = utilConcatView(new Uint8Array([value % 10]), firstViewCopy);
            break;
          default:
            firstViewCopy[firstViewCopyLength - counter] = value % 10;
        }
      }
      if (c2[0] > 0)
        firstViewCopy = utilConcatView(c2, firstViewCopy);
      return firstViewCopy;
    }
    function power2(n) {
      if (n >= powers2.length) {
        for (let p3 = powers2.length; p3 <= n; p3++) {
          const c2 = new Uint8Array([0]);
          let digits = powers2[p3 - 1].slice(0);
          for (let i = digits.length - 1; i >= 0; i--) {
            const newValue = new Uint8Array([(digits[i] << 1) + c2[0]]);
            c2[0] = newValue[0] / 10;
            digits[i] = newValue[0] % 10;
          }
          if (c2[0] > 0)
            digits = utilConcatView(c2, digits);
          powers2.push(digits);
        }
      }
      return powers2[n];
    }
    function viewSub(first, second) {
      let b = 0;
      const firstView = new Uint8Array(first);
      const secondView = new Uint8Array(second);
      const firstViewCopy = firstView.slice(0);
      const firstViewCopyLength = firstViewCopy.length - 1;
      const secondViewCopy = secondView.slice(0);
      const secondViewCopyLength = secondViewCopy.length - 1;
      let value;
      let counter = 0;
      for (let i = secondViewCopyLength; i >= 0; i--, counter++) {
        value = firstViewCopy[firstViewCopyLength - counter] - secondViewCopy[secondViewCopyLength - counter] - b;
        switch (true) {
          case value < 0:
            b = 1;
            firstViewCopy[firstViewCopyLength - counter] = value + 10;
            break;
          default:
            b = 0;
            firstViewCopy[firstViewCopyLength - counter] = value;
        }
      }
      if (b > 0) {
        for (let i = firstViewCopyLength - secondViewCopyLength + 1; i >= 0; i--, counter++) {
          value = firstViewCopy[firstViewCopyLength - counter] - b;
          if (value < 0) {
            b = 1;
            firstViewCopy[firstViewCopyLength - counter] = value + 10;
          } else {
            b = 0;
            firstViewCopy[firstViewCopyLength - counter] = value;
            break;
          }
        }
      }
      return firstViewCopy.slice();
    }
    var LocalIntegerValueBlock = class extends HexBlock(ValueBlock) {
      constructor({ value, ...parameters } = {}) {
        super(parameters);
        this._valueDec = 0;
        if (parameters.valueHex) {
          this.setValueHex();
        }
        if (value !== void 0) {
          this.valueDec = value;
        }
      }
      setValueHex() {
        if (this.valueHexView.length >= 4) {
          this.warnings.push("Too big Integer for decoding, hex only");
          this.isHexOnly = true;
          this._valueDec = 0;
        } else {
          this.isHexOnly = false;
          if (this.valueHexView.length > 0) {
            this._valueDec = utilDecodeTC.call(this);
          }
        }
      }
      set valueDec(v) {
        this._valueDec = v;
        this.isHexOnly = false;
        this.valueHexView = new Uint8Array(utilEncodeTC(v));
      }
      get valueDec() {
        return this._valueDec;
      }
      fromDER(inputBuffer, inputOffset, inputLength, expectedLength = 0) {
        const offset = this.fromBER(inputBuffer, inputOffset, inputLength);
        if (offset === -1)
          return offset;
        const view = this.valueHexView;
        if (view[0] === 0 && (view[1] & 128) !== 0) {
          this.valueHexView = view.subarray(1);
        } else {
          if (expectedLength !== 0) {
            if (view.length < expectedLength) {
              if (expectedLength - view.length > 1)
                expectedLength = view.length + 1;
              this.valueHexView = view.subarray(expectedLength - view.length);
            }
          }
        }
        return offset;
      }
      toDER(sizeOnly = false) {
        const view = this.valueHexView;
        switch (true) {
          case (view[0] & 128) !== 0:
            {
              const updatedView = new Uint8Array(this.valueHexView.length + 1);
              updatedView[0] = 0;
              updatedView.set(view, 1);
              this.valueHexView = updatedView;
            }
            break;
          case (view[0] === 0 && (view[1] & 128) === 0):
            {
              this.valueHexView = this.valueHexView.subarray(1);
            }
            break;
        }
        return this.toBER(sizeOnly);
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        const resultOffset = super.fromBER(inputBuffer, inputOffset, inputLength);
        if (resultOffset === -1) {
          return resultOffset;
        }
        this.setValueHex();
        return resultOffset;
      }
      toBER(sizeOnly) {
        return sizeOnly ? new ArrayBuffer(this.valueHexView.length) : this.valueHexView.slice().buffer;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          valueDec: this.valueDec
        };
      }
      toString() {
        const firstBit = this.valueHexView.length * 8 - 1;
        let digits = new Uint8Array(this.valueHexView.length * 8 / 3);
        let bitNumber = 0;
        let currentByte;
        const asn1View = this.valueHexView;
        let result2 = "";
        let flag = false;
        for (let byteNumber = asn1View.byteLength - 1; byteNumber >= 0; byteNumber--) {
          currentByte = asn1View[byteNumber];
          for (let i = 0; i < 8; i++) {
            if ((currentByte & 1) === 1) {
              switch (bitNumber) {
                case firstBit:
                  digits = viewSub(power2(bitNumber), digits);
                  result2 = "-";
                  break;
                default:
                  digits = viewAdd(digits, power2(bitNumber));
              }
            }
            bitNumber++;
            currentByte >>= 1;
          }
        }
        for (let i = 0; i < digits.length; i++) {
          if (digits[i])
            flag = true;
          if (flag)
            result2 += digitsString.charAt(digits[i]);
        }
        if (flag === false)
          result2 += digitsString.charAt(0);
        return result2;
      }
    };
    _a$p = LocalIntegerValueBlock;
    LocalIntegerValueBlock.NAME = "IntegerValueBlock";
    (() => {
      Object.defineProperty(_a$p.prototype, "valueHex", {
        set: function(v) {
          this.valueHexView = new Uint8Array(v);
          this.setValueHex();
        },
        get: function() {
          return this.valueHexView.slice().buffer;
        }
      });
    })();
    var _a$o;
    var Integer = class _Integer extends BaseBlock {
      constructor(parameters = {}) {
        super(parameters, LocalIntegerValueBlock);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 2;
      }
      toBigInt() {
        assertBigInt();
        return BigInt(this.valueBlock.toString());
      }
      static fromBigInt(value) {
        assertBigInt();
        const bigIntValue = BigInt(value);
        const writer = new ViewWriter();
        const hex = bigIntValue.toString(16).replace(/^-/, "");
        const view = new Uint8Array(Convert.FromHex(hex));
        if (bigIntValue < 0) {
          const first = new Uint8Array(view.length + (view[0] & 128 ? 1 : 0));
          first[0] |= 128;
          const firstInt = BigInt(`0x${Convert.ToHex(first)}`);
          const secondInt = firstInt + bigIntValue;
          const second = BufferSourceConverter.toUint8Array(Convert.FromHex(secondInt.toString(16)));
          second[0] |= 128;
          writer.write(second);
        } else {
          if (view[0] & 128) {
            writer.write(new Uint8Array([0]));
          }
          writer.write(view);
        }
        const res = new _Integer({
          valueHex: writer.final()
        });
        return res;
      }
      convertToDER() {
        const integer = new _Integer({ valueHex: this.valueBlock.valueHexView });
        integer.valueBlock.toDER();
        return integer;
      }
      convertFromDER() {
        return new _Integer({
          valueHex: this.valueBlock.valueHexView[0] === 0 ? this.valueBlock.valueHexView.subarray(1) : this.valueBlock.valueHexView
        });
      }
      onAsciiEncoding() {
        return `${this.constructor.NAME} : ${this.valueBlock.toString()}`;
      }
    };
    _a$o = Integer;
    (() => {
      typeStore.Integer = _a$o;
    })();
    Integer.NAME = "INTEGER";
    var _a$n;
    var Enumerated = class extends Integer {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 10;
      }
    };
    _a$n = Enumerated;
    (() => {
      typeStore.Enumerated = _a$n;
    })();
    Enumerated.NAME = "ENUMERATED";
    var LocalSidValueBlock = class extends HexBlock(ValueBlock) {
      constructor({ valueDec = -1, isFirstSid = false, ...parameters } = {}) {
        super(parameters);
        this.valueDec = valueDec;
        this.isFirstSid = isFirstSid;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        if (!inputLength) {
          return inputOffset;
        }
        const inputView = BufferSourceConverter.toUint8Array(inputBuffer);
        if (!checkBufferParams(this, inputView, inputOffset, inputLength)) {
          return -1;
        }
        const intBuffer = inputView.subarray(inputOffset, inputOffset + inputLength);
        this.valueHexView = new Uint8Array(inputLength);
        for (let i = 0; i < inputLength; i++) {
          this.valueHexView[i] = intBuffer[i] & 127;
          this.blockLength++;
          if ((intBuffer[i] & 128) === 0)
            break;
        }
        const tempView = new Uint8Array(this.blockLength);
        for (let i = 0; i < this.blockLength; i++) {
          tempView[i] = this.valueHexView[i];
        }
        this.valueHexView = tempView;
        if ((intBuffer[this.blockLength - 1] & 128) !== 0) {
          this.error = "End of input reached before message was fully decoded";
          return -1;
        }
        if (this.valueHexView[0] === 0)
          this.warnings.push("Needlessly long format of SID encoding");
        if (this.blockLength <= 8)
          this.valueDec = utilFromBase(this.valueHexView, 7);
        else {
          this.isHexOnly = true;
          this.warnings.push("Too big SID for decoding, hex only");
        }
        return inputOffset + this.blockLength;
      }
      set valueBigInt(value) {
        assertBigInt();
        let bits = BigInt(value).toString(2);
        while (bits.length % 7) {
          bits = "0" + bits;
        }
        const bytes = new Uint8Array(bits.length / 7);
        for (let i = 0; i < bytes.length; i++) {
          bytes[i] = parseInt(bits.slice(i * 7, i * 7 + 7), 2) + (i + 1 < bytes.length ? 128 : 0);
        }
        this.fromBER(bytes.buffer, 0, bytes.length);
      }
      toBER(sizeOnly) {
        if (this.isHexOnly) {
          if (sizeOnly)
            return new ArrayBuffer(this.valueHexView.byteLength);
          const curView = this.valueHexView;
          const retView2 = new Uint8Array(this.blockLength);
          for (let i = 0; i < this.blockLength - 1; i++)
            retView2[i] = curView[i] | 128;
          retView2[this.blockLength - 1] = curView[this.blockLength - 1];
          return retView2.buffer;
        }
        const encodedBuf = utilToBase(this.valueDec, 7);
        if (encodedBuf.byteLength === 0) {
          this.error = "Error during encoding SID value";
          return EMPTY_BUFFER;
        }
        const retView = new Uint8Array(encodedBuf.byteLength);
        if (!sizeOnly) {
          const encodedView = new Uint8Array(encodedBuf);
          const len = encodedBuf.byteLength - 1;
          for (let i = 0; i < len; i++)
            retView[i] = encodedView[i] | 128;
          retView[len] = encodedView[len];
        }
        return retView;
      }
      toString() {
        let result2 = "";
        if (this.isHexOnly)
          result2 = Convert.ToHex(this.valueHexView);
        else {
          if (this.isFirstSid) {
            let sidValue = this.valueDec;
            if (this.valueDec <= 39)
              result2 = "0.";
            else {
              if (this.valueDec <= 79) {
                result2 = "1.";
                sidValue -= 40;
              } else {
                result2 = "2.";
                sidValue -= 80;
              }
            }
            result2 += sidValue.toString();
          } else
            result2 = this.valueDec.toString();
        }
        return result2;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          valueDec: this.valueDec,
          isFirstSid: this.isFirstSid
        };
      }
    };
    LocalSidValueBlock.NAME = "sidBlock";
    var LocalObjectIdentifierValueBlock = class extends ValueBlock {
      constructor({ value = EMPTY_STRING, ...parameters } = {}) {
        super(parameters);
        this.value = [];
        if (value) {
          this.fromString(value);
        }
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        let resultOffset = inputOffset;
        while (inputLength > 0) {
          const sidBlock = new LocalSidValueBlock();
          resultOffset = sidBlock.fromBER(inputBuffer, resultOffset, inputLength);
          if (resultOffset === -1) {
            this.blockLength = 0;
            this.error = sidBlock.error;
            return resultOffset;
          }
          if (this.value.length === 0)
            sidBlock.isFirstSid = true;
          this.blockLength += sidBlock.blockLength;
          inputLength -= sidBlock.blockLength;
          this.value.push(sidBlock);
        }
        return resultOffset;
      }
      toBER(sizeOnly) {
        const retBuffers = [];
        for (let i = 0; i < this.value.length; i++) {
          const valueBuf = this.value[i].toBER(sizeOnly);
          if (valueBuf.byteLength === 0) {
            this.error = this.value[i].error;
            return EMPTY_BUFFER;
          }
          retBuffers.push(valueBuf);
        }
        return concat(retBuffers);
      }
      fromString(string) {
        this.value = [];
        let pos1 = 0;
        let pos2 = 0;
        let sid = "";
        let flag = false;
        do {
          pos2 = string.indexOf(".", pos1);
          if (pos2 === -1)
            sid = string.substring(pos1);
          else
            sid = string.substring(pos1, pos2);
          pos1 = pos2 + 1;
          if (flag) {
            const sidBlock = this.value[0];
            let plus2 = 0;
            switch (sidBlock.valueDec) {
              case 0:
                break;
              case 1:
                plus2 = 40;
                break;
              case 2:
                plus2 = 80;
                break;
              default:
                this.value = [];
                return;
            }
            const parsedSID = parseInt(sid, 10);
            if (isNaN(parsedSID))
              return;
            sidBlock.valueDec = parsedSID + plus2;
            flag = false;
          } else {
            const sidBlock = new LocalSidValueBlock();
            if (sid > Number.MAX_SAFE_INTEGER) {
              assertBigInt();
              const sidValue = BigInt(sid);
              sidBlock.valueBigInt = sidValue;
            } else {
              sidBlock.valueDec = parseInt(sid, 10);
              if (isNaN(sidBlock.valueDec))
                return;
            }
            if (!this.value.length) {
              sidBlock.isFirstSid = true;
              flag = true;
            }
            this.value.push(sidBlock);
          }
        } while (pos2 !== -1);
      }
      toString() {
        let result2 = "";
        let isHexOnly = false;
        for (let i = 0; i < this.value.length; i++) {
          isHexOnly = this.value[i].isHexOnly;
          let sidStr = this.value[i].toString();
          if (i !== 0)
            result2 = `${result2}.`;
          if (isHexOnly) {
            sidStr = `{${sidStr}}`;
            if (this.value[i].isFirstSid)
              result2 = `2.{${sidStr} - 80}`;
            else
              result2 += sidStr;
          } else
            result2 += sidStr;
        }
        return result2;
      }
      toJSON() {
        const object = {
          ...super.toJSON(),
          value: this.toString(),
          sidArray: []
        };
        for (let i = 0; i < this.value.length; i++) {
          object.sidArray.push(this.value[i].toJSON());
        }
        return object;
      }
    };
    LocalObjectIdentifierValueBlock.NAME = "ObjectIdentifierValueBlock";
    var _a$m;
    var ObjectIdentifier = class extends BaseBlock {
      constructor(parameters = {}) {
        super(parameters, LocalObjectIdentifierValueBlock);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 6;
      }
      getValue() {
        return this.valueBlock.toString();
      }
      setValue(value) {
        this.valueBlock.fromString(value);
      }
      onAsciiEncoding() {
        return `${this.constructor.NAME} : ${this.valueBlock.toString() || "empty"}`;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          value: this.getValue()
        };
      }
    };
    _a$m = ObjectIdentifier;
    (() => {
      typeStore.ObjectIdentifier = _a$m;
    })();
    ObjectIdentifier.NAME = "OBJECT IDENTIFIER";
    var LocalRelativeSidValueBlock = class extends HexBlock(LocalBaseBlock) {
      constructor({ valueDec = 0, ...parameters } = {}) {
        super(parameters);
        this.valueDec = valueDec;
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        if (inputLength === 0)
          return inputOffset;
        const inputView = BufferSourceConverter.toUint8Array(inputBuffer);
        if (!checkBufferParams(this, inputView, inputOffset, inputLength))
          return -1;
        const intBuffer = inputView.subarray(inputOffset, inputOffset + inputLength);
        this.valueHexView = new Uint8Array(inputLength);
        for (let i = 0; i < inputLength; i++) {
          this.valueHexView[i] = intBuffer[i] & 127;
          this.blockLength++;
          if ((intBuffer[i] & 128) === 0)
            break;
        }
        const tempView = new Uint8Array(this.blockLength);
        for (let i = 0; i < this.blockLength; i++)
          tempView[i] = this.valueHexView[i];
        this.valueHexView = tempView;
        if ((intBuffer[this.blockLength - 1] & 128) !== 0) {
          this.error = "End of input reached before message was fully decoded";
          return -1;
        }
        if (this.valueHexView[0] === 0)
          this.warnings.push("Needlessly long format of SID encoding");
        if (this.blockLength <= 8)
          this.valueDec = utilFromBase(this.valueHexView, 7);
        else {
          this.isHexOnly = true;
          this.warnings.push("Too big SID for decoding, hex only");
        }
        return inputOffset + this.blockLength;
      }
      toBER(sizeOnly) {
        if (this.isHexOnly) {
          if (sizeOnly)
            return new ArrayBuffer(this.valueHexView.byteLength);
          const curView = this.valueHexView;
          const retView2 = new Uint8Array(this.blockLength);
          for (let i = 0; i < this.blockLength - 1; i++)
            retView2[i] = curView[i] | 128;
          retView2[this.blockLength - 1] = curView[this.blockLength - 1];
          return retView2.buffer;
        }
        const encodedBuf = utilToBase(this.valueDec, 7);
        if (encodedBuf.byteLength === 0) {
          this.error = "Error during encoding SID value";
          return EMPTY_BUFFER;
        }
        const retView = new Uint8Array(encodedBuf.byteLength);
        if (!sizeOnly) {
          const encodedView = new Uint8Array(encodedBuf);
          const len = encodedBuf.byteLength - 1;
          for (let i = 0; i < len; i++)
            retView[i] = encodedView[i] | 128;
          retView[len] = encodedView[len];
        }
        return retView.buffer;
      }
      toString() {
        let result2 = "";
        if (this.isHexOnly)
          result2 = Convert.ToHex(this.valueHexView);
        else {
          result2 = this.valueDec.toString();
        }
        return result2;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          valueDec: this.valueDec
        };
      }
    };
    LocalRelativeSidValueBlock.NAME = "relativeSidBlock";
    var LocalRelativeObjectIdentifierValueBlock = class extends ValueBlock {
      constructor({ value = EMPTY_STRING, ...parameters } = {}) {
        super(parameters);
        this.value = [];
        if (value) {
          this.fromString(value);
        }
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        let resultOffset = inputOffset;
        while (inputLength > 0) {
          const sidBlock = new LocalRelativeSidValueBlock();
          resultOffset = sidBlock.fromBER(inputBuffer, resultOffset, inputLength);
          if (resultOffset === -1) {
            this.blockLength = 0;
            this.error = sidBlock.error;
            return resultOffset;
          }
          this.blockLength += sidBlock.blockLength;
          inputLength -= sidBlock.blockLength;
          this.value.push(sidBlock);
        }
        return resultOffset;
      }
      toBER(sizeOnly, writer) {
        const retBuffers = [];
        for (let i = 0; i < this.value.length; i++) {
          const valueBuf = this.value[i].toBER(sizeOnly);
          if (valueBuf.byteLength === 0) {
            this.error = this.value[i].error;
            return EMPTY_BUFFER;
          }
          retBuffers.push(valueBuf);
        }
        return concat(retBuffers);
      }
      fromString(string) {
        this.value = [];
        let pos1 = 0;
        let pos2 = 0;
        let sid = "";
        do {
          pos2 = string.indexOf(".", pos1);
          if (pos2 === -1)
            sid = string.substring(pos1);
          else
            sid = string.substring(pos1, pos2);
          pos1 = pos2 + 1;
          const sidBlock = new LocalRelativeSidValueBlock();
          sidBlock.valueDec = parseInt(sid, 10);
          if (isNaN(sidBlock.valueDec))
            return true;
          this.value.push(sidBlock);
        } while (pos2 !== -1);
        return true;
      }
      toString() {
        let result2 = "";
        let isHexOnly = false;
        for (let i = 0; i < this.value.length; i++) {
          isHexOnly = this.value[i].isHexOnly;
          let sidStr = this.value[i].toString();
          if (i !== 0)
            result2 = `${result2}.`;
          if (isHexOnly) {
            sidStr = `{${sidStr}}`;
            result2 += sidStr;
          } else
            result2 += sidStr;
        }
        return result2;
      }
      toJSON() {
        const object = {
          ...super.toJSON(),
          value: this.toString(),
          sidArray: []
        };
        for (let i = 0; i < this.value.length; i++)
          object.sidArray.push(this.value[i].toJSON());
        return object;
      }
    };
    LocalRelativeObjectIdentifierValueBlock.NAME = "RelativeObjectIdentifierValueBlock";
    var _a$l;
    var RelativeObjectIdentifier = class extends BaseBlock {
      constructor(parameters = {}) {
        super(parameters, LocalRelativeObjectIdentifierValueBlock);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 13;
      }
      getValue() {
        return this.valueBlock.toString();
      }
      setValue(value) {
        this.valueBlock.fromString(value);
      }
      onAsciiEncoding() {
        return `${this.constructor.NAME} : ${this.valueBlock.toString() || "empty"}`;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          value: this.getValue()
        };
      }
    };
    _a$l = RelativeObjectIdentifier;
    (() => {
      typeStore.RelativeObjectIdentifier = _a$l;
    })();
    RelativeObjectIdentifier.NAME = "RelativeObjectIdentifier";
    var _a$k;
    var Sequence = class extends Constructed {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 16;
      }
    };
    _a$k = Sequence;
    (() => {
      typeStore.Sequence = _a$k;
    })();
    Sequence.NAME = "SEQUENCE";
    var _a$j;
    var Set2 = class extends Constructed {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 17;
      }
    };
    _a$j = Set2;
    (() => {
      typeStore.Set = _a$j;
    })();
    Set2.NAME = "SET";
    var LocalStringValueBlock = class extends HexBlock(ValueBlock) {
      constructor({ ...parameters } = {}) {
        super(parameters);
        this.isHexOnly = true;
        this.value = EMPTY_STRING;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          value: this.value
        };
      }
    };
    LocalStringValueBlock.NAME = "StringValueBlock";
    var LocalSimpleStringValueBlock = class extends LocalStringValueBlock {
    };
    LocalSimpleStringValueBlock.NAME = "SimpleStringValueBlock";
    var LocalSimpleStringBlock = class extends BaseStringBlock {
      constructor({ ...parameters } = {}) {
        super(parameters, LocalSimpleStringValueBlock);
      }
      fromBuffer(inputBuffer) {
        this.valueBlock.value = String.fromCharCode.apply(null, BufferSourceConverter.toUint8Array(inputBuffer));
      }
      fromString(inputString) {
        const strLen = inputString.length;
        const view = this.valueBlock.valueHexView = new Uint8Array(strLen);
        for (let i = 0; i < strLen; i++)
          view[i] = inputString.charCodeAt(i);
        this.valueBlock.value = inputString;
      }
    };
    LocalSimpleStringBlock.NAME = "SIMPLE STRING";
    var LocalUtf8StringValueBlock = class extends LocalSimpleStringBlock {
      fromBuffer(inputBuffer) {
        this.valueBlock.valueHexView = BufferSourceConverter.toUint8Array(inputBuffer);
        try {
          this.valueBlock.value = Convert.ToUtf8String(inputBuffer);
        } catch (ex) {
          this.warnings.push(`Error during "decodeURIComponent": ${ex}, using raw string`);
          this.valueBlock.value = Convert.ToBinary(inputBuffer);
        }
      }
      fromString(inputString) {
        this.valueBlock.valueHexView = new Uint8Array(Convert.FromUtf8String(inputString));
        this.valueBlock.value = inputString;
      }
    };
    LocalUtf8StringValueBlock.NAME = "Utf8StringValueBlock";
    var _a$i;
    var Utf8String = class extends LocalUtf8StringValueBlock {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 12;
      }
    };
    _a$i = Utf8String;
    (() => {
      typeStore.Utf8String = _a$i;
    })();
    Utf8String.NAME = "UTF8String";
    var LocalBmpStringValueBlock = class extends LocalSimpleStringBlock {
      fromBuffer(inputBuffer) {
        this.valueBlock.value = Convert.ToUtf16String(inputBuffer);
        this.valueBlock.valueHexView = BufferSourceConverter.toUint8Array(inputBuffer);
      }
      fromString(inputString) {
        this.valueBlock.value = inputString;
        this.valueBlock.valueHexView = new Uint8Array(Convert.FromUtf16String(inputString));
      }
    };
    LocalBmpStringValueBlock.NAME = "BmpStringValueBlock";
    var _a$h;
    var BmpString = class extends LocalBmpStringValueBlock {
      constructor({ ...parameters } = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 30;
      }
    };
    _a$h = BmpString;
    (() => {
      typeStore.BmpString = _a$h;
    })();
    BmpString.NAME = "BMPString";
    var LocalUniversalStringValueBlock = class extends LocalSimpleStringBlock {
      fromBuffer(inputBuffer) {
        const copyBuffer = ArrayBuffer.isView(inputBuffer) ? inputBuffer.slice().buffer : inputBuffer.slice(0);
        const valueView = new Uint8Array(copyBuffer);
        for (let i = 0; i < valueView.length; i += 4) {
          valueView[i] = valueView[i + 3];
          valueView[i + 1] = valueView[i + 2];
          valueView[i + 2] = 0;
          valueView[i + 3] = 0;
        }
        this.valueBlock.value = String.fromCharCode.apply(null, new Uint32Array(copyBuffer));
      }
      fromString(inputString) {
        const strLength = inputString.length;
        const valueHexView = this.valueBlock.valueHexView = new Uint8Array(strLength * 4);
        for (let i = 0; i < strLength; i++) {
          const codeBuf = utilToBase(inputString.charCodeAt(i), 8);
          const codeView = new Uint8Array(codeBuf);
          if (codeView.length > 4)
            continue;
          const dif = 4 - codeView.length;
          for (let j = codeView.length - 1; j >= 0; j--)
            valueHexView[i * 4 + j + dif] = codeView[j];
        }
        this.valueBlock.value = inputString;
      }
    };
    LocalUniversalStringValueBlock.NAME = "UniversalStringValueBlock";
    var _a$g;
    var UniversalString = class extends LocalUniversalStringValueBlock {
      constructor({ ...parameters } = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 28;
      }
    };
    _a$g = UniversalString;
    (() => {
      typeStore.UniversalString = _a$g;
    })();
    UniversalString.NAME = "UniversalString";
    var _a$f;
    var NumericString = class extends LocalSimpleStringBlock {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 18;
      }
    };
    _a$f = NumericString;
    (() => {
      typeStore.NumericString = _a$f;
    })();
    NumericString.NAME = "NumericString";
    var _a$e;
    var PrintableString = class extends LocalSimpleStringBlock {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 19;
      }
    };
    _a$e = PrintableString;
    (() => {
      typeStore.PrintableString = _a$e;
    })();
    PrintableString.NAME = "PrintableString";
    var _a$d;
    var TeletexString = class extends LocalSimpleStringBlock {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 20;
      }
    };
    _a$d = TeletexString;
    (() => {
      typeStore.TeletexString = _a$d;
    })();
    TeletexString.NAME = "TeletexString";
    var _a$c;
    var VideotexString = class extends LocalSimpleStringBlock {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 21;
      }
    };
    _a$c = VideotexString;
    (() => {
      typeStore.VideotexString = _a$c;
    })();
    VideotexString.NAME = "VideotexString";
    var _a$b;
    var IA5String = class extends LocalSimpleStringBlock {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 22;
      }
    };
    _a$b = IA5String;
    (() => {
      typeStore.IA5String = _a$b;
    })();
    IA5String.NAME = "IA5String";
    var _a$a;
    var GraphicString = class extends LocalSimpleStringBlock {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 25;
      }
    };
    _a$a = GraphicString;
    (() => {
      typeStore.GraphicString = _a$a;
    })();
    GraphicString.NAME = "GraphicString";
    var _a$9;
    var VisibleString = class extends LocalSimpleStringBlock {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 26;
      }
    };
    _a$9 = VisibleString;
    (() => {
      typeStore.VisibleString = _a$9;
    })();
    VisibleString.NAME = "VisibleString";
    var _a$8;
    var GeneralString = class extends LocalSimpleStringBlock {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 27;
      }
    };
    _a$8 = GeneralString;
    (() => {
      typeStore.GeneralString = _a$8;
    })();
    GeneralString.NAME = "GeneralString";
    var _a$7;
    var CharacterString = class extends LocalSimpleStringBlock {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 29;
      }
    };
    _a$7 = CharacterString;
    (() => {
      typeStore.CharacterString = _a$7;
    })();
    CharacterString.NAME = "CharacterString";
    var _a$6;
    var UTCTime = class extends VisibleString {
      constructor({ value, valueDate, ...parameters } = {}) {
        super(parameters);
        this.year = 0;
        this.month = 0;
        this.day = 0;
        this.hour = 0;
        this.minute = 0;
        this.second = 0;
        if (value) {
          this.fromString(value);
          this.valueBlock.valueHexView = new Uint8Array(value.length);
          for (let i = 0; i < value.length; i++)
            this.valueBlock.valueHexView[i] = value.charCodeAt(i);
        }
        if (valueDate) {
          this.fromDate(valueDate);
          this.valueBlock.valueHexView = new Uint8Array(this.toBuffer());
        }
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 23;
      }
      fromBuffer(inputBuffer) {
        this.fromString(String.fromCharCode.apply(null, BufferSourceConverter.toUint8Array(inputBuffer)));
      }
      toBuffer() {
        const str = this.toString();
        const buffer = new ArrayBuffer(str.length);
        const view = new Uint8Array(buffer);
        for (let i = 0; i < str.length; i++)
          view[i] = str.charCodeAt(i);
        return buffer;
      }
      fromDate(inputDate) {
        this.year = inputDate.getUTCFullYear();
        this.month = inputDate.getUTCMonth() + 1;
        this.day = inputDate.getUTCDate();
        this.hour = inputDate.getUTCHours();
        this.minute = inputDate.getUTCMinutes();
        this.second = inputDate.getUTCSeconds();
      }
      toDate() {
        return new Date(Date.UTC(this.year, this.month - 1, this.day, this.hour, this.minute, this.second));
      }
      fromString(inputString) {
        const parser = /(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})Z/ig;
        const parserArray = parser.exec(inputString);
        if (parserArray === null) {
          this.error = "Wrong input string for conversion";
          return;
        }
        const year = parseInt(parserArray[1], 10);
        if (year >= 50)
          this.year = 1900 + year;
        else
          this.year = 2e3 + year;
        this.month = parseInt(parserArray[2], 10);
        this.day = parseInt(parserArray[3], 10);
        this.hour = parseInt(parserArray[4], 10);
        this.minute = parseInt(parserArray[5], 10);
        this.second = parseInt(parserArray[6], 10);
      }
      toString(encoding = "iso") {
        if (encoding === "iso") {
          const outputArray = new Array(7);
          outputArray[0] = padNumber(this.year < 2e3 ? this.year - 1900 : this.year - 2e3, 2);
          outputArray[1] = padNumber(this.month, 2);
          outputArray[2] = padNumber(this.day, 2);
          outputArray[3] = padNumber(this.hour, 2);
          outputArray[4] = padNumber(this.minute, 2);
          outputArray[5] = padNumber(this.second, 2);
          outputArray[6] = "Z";
          return outputArray.join("");
        }
        return super.toString(encoding);
      }
      onAsciiEncoding() {
        return `${this.constructor.NAME} : ${this.toDate().toISOString()}`;
      }
      toJSON() {
        return {
          ...super.toJSON(),
          year: this.year,
          month: this.month,
          day: this.day,
          hour: this.hour,
          minute: this.minute,
          second: this.second
        };
      }
    };
    _a$6 = UTCTime;
    (() => {
      typeStore.UTCTime = _a$6;
    })();
    UTCTime.NAME = "UTCTime";
    var _a$5;
    var GeneralizedTime = class extends UTCTime {
      constructor(parameters = {}) {
        var _b;
        super(parameters);
        (_b = this.millisecond) !== null && _b !== void 0 ? _b : this.millisecond = 0;
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 24;
      }
      fromDate(inputDate) {
        super.fromDate(inputDate);
        this.millisecond = inputDate.getUTCMilliseconds();
      }
      toDate() {
        return new Date(Date.UTC(this.year, this.month - 1, this.day, this.hour, this.minute, this.second, this.millisecond));
      }
      fromString(inputString) {
        let isUTC = false;
        let timeString = "";
        let dateTimeString = "";
        let fractionPart = 0;
        let parser;
        let hourDifference = 0;
        let minuteDifference = 0;
        if (inputString[inputString.length - 1] === "Z") {
          timeString = inputString.substring(0, inputString.length - 1);
          isUTC = true;
        } else {
          const number = new Number(inputString[inputString.length - 1]);
          if (isNaN(number.valueOf()))
            throw new Error("Wrong input string for conversion");
          timeString = inputString;
        }
        if (isUTC) {
          if (timeString.indexOf("+") !== -1)
            throw new Error("Wrong input string for conversion");
          if (timeString.indexOf("-") !== -1)
            throw new Error("Wrong input string for conversion");
        } else {
          let multiplier = 1;
          let differencePosition = timeString.indexOf("+");
          let differenceString = "";
          if (differencePosition === -1) {
            differencePosition = timeString.indexOf("-");
            multiplier = -1;
          }
          if (differencePosition !== -1) {
            differenceString = timeString.substring(differencePosition + 1);
            timeString = timeString.substring(0, differencePosition);
            if (differenceString.length !== 2 && differenceString.length !== 4)
              throw new Error("Wrong input string for conversion");
            let number = parseInt(differenceString.substring(0, 2), 10);
            if (isNaN(number.valueOf()))
              throw new Error("Wrong input string for conversion");
            hourDifference = multiplier * number;
            if (differenceString.length === 4) {
              number = parseInt(differenceString.substring(2, 4), 10);
              if (isNaN(number.valueOf()))
                throw new Error("Wrong input string for conversion");
              minuteDifference = multiplier * number;
            }
          }
        }
        let fractionPointPosition = timeString.indexOf(".");
        if (fractionPointPosition === -1)
          fractionPointPosition = timeString.indexOf(",");
        if (fractionPointPosition !== -1) {
          const fractionPartCheck = new Number(`0${timeString.substring(fractionPointPosition)}`);
          if (isNaN(fractionPartCheck.valueOf()))
            throw new Error("Wrong input string for conversion");
          fractionPart = fractionPartCheck.valueOf();
          dateTimeString = timeString.substring(0, fractionPointPosition);
        } else
          dateTimeString = timeString;
        switch (true) {
          case dateTimeString.length === 8:
            parser = /(\d{4})(\d{2})(\d{2})/ig;
            if (fractionPointPosition !== -1)
              throw new Error("Wrong input string for conversion");
            break;
          case dateTimeString.length === 10:
            parser = /(\d{4})(\d{2})(\d{2})(\d{2})/ig;
            if (fractionPointPosition !== -1) {
              let fractionResult = 60 * fractionPart;
              this.minute = Math.floor(fractionResult);
              fractionResult = 60 * (fractionResult - this.minute);
              this.second = Math.floor(fractionResult);
              fractionResult = 1e3 * (fractionResult - this.second);
              this.millisecond = Math.floor(fractionResult);
            }
            break;
          case dateTimeString.length === 12:
            parser = /(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})/ig;
            if (fractionPointPosition !== -1) {
              let fractionResult = 60 * fractionPart;
              this.second = Math.floor(fractionResult);
              fractionResult = 1e3 * (fractionResult - this.second);
              this.millisecond = Math.floor(fractionResult);
            }
            break;
          case dateTimeString.length === 14:
            parser = /(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})/ig;
            if (fractionPointPosition !== -1) {
              const fractionResult = 1e3 * fractionPart;
              this.millisecond = Math.floor(fractionResult);
            }
            break;
          default:
            throw new Error("Wrong input string for conversion");
        }
        const parserArray = parser.exec(dateTimeString);
        if (parserArray === null)
          throw new Error("Wrong input string for conversion");
        for (let j = 1; j < parserArray.length; j++) {
          switch (j) {
            case 1:
              this.year = parseInt(parserArray[j], 10);
              break;
            case 2:
              this.month = parseInt(parserArray[j], 10);
              break;
            case 3:
              this.day = parseInt(parserArray[j], 10);
              break;
            case 4:
              this.hour = parseInt(parserArray[j], 10) + hourDifference;
              break;
            case 5:
              this.minute = parseInt(parserArray[j], 10) + minuteDifference;
              break;
            case 6:
              this.second = parseInt(parserArray[j], 10);
              break;
            default:
              throw new Error("Wrong input string for conversion");
          }
        }
        if (isUTC === false) {
          const tempDate = new Date(this.year, this.month, this.day, this.hour, this.minute, this.second, this.millisecond);
          this.year = tempDate.getUTCFullYear();
          this.month = tempDate.getUTCMonth();
          this.day = tempDate.getUTCDay();
          this.hour = tempDate.getUTCHours();
          this.minute = tempDate.getUTCMinutes();
          this.second = tempDate.getUTCSeconds();
          this.millisecond = tempDate.getUTCMilliseconds();
        }
      }
      toString(encoding = "iso") {
        if (encoding === "iso") {
          const outputArray = [];
          outputArray.push(padNumber(this.year, 4));
          outputArray.push(padNumber(this.month, 2));
          outputArray.push(padNumber(this.day, 2));
          outputArray.push(padNumber(this.hour, 2));
          outputArray.push(padNumber(this.minute, 2));
          outputArray.push(padNumber(this.second, 2));
          if (this.millisecond !== 0) {
            outputArray.push(".");
            outputArray.push(padNumber(this.millisecond, 3));
          }
          outputArray.push("Z");
          return outputArray.join("");
        }
        return super.toString(encoding);
      }
      toJSON() {
        return {
          ...super.toJSON(),
          millisecond: this.millisecond
        };
      }
    };
    _a$5 = GeneralizedTime;
    (() => {
      typeStore.GeneralizedTime = _a$5;
    })();
    GeneralizedTime.NAME = "GeneralizedTime";
    var _a$4;
    var DATE = class extends Utf8String {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 31;
      }
    };
    _a$4 = DATE;
    (() => {
      typeStore.DATE = _a$4;
    })();
    DATE.NAME = "DATE";
    var _a$3;
    var TimeOfDay = class extends Utf8String {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 32;
      }
    };
    _a$3 = TimeOfDay;
    (() => {
      typeStore.TimeOfDay = _a$3;
    })();
    TimeOfDay.NAME = "TimeOfDay";
    var _a$2;
    var DateTime = class extends Utf8String {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 33;
      }
    };
    _a$2 = DateTime;
    (() => {
      typeStore.DateTime = _a$2;
    })();
    DateTime.NAME = "DateTime";
    var _a$1;
    var Duration = class extends Utf8String {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 34;
      }
    };
    _a$1 = Duration;
    (() => {
      typeStore.Duration = _a$1;
    })();
    Duration.NAME = "Duration";
    var _a;
    var TIME = class extends Utf8String {
      constructor(parameters = {}) {
        super(parameters);
        this.idBlock.tagClass = 1;
        this.idBlock.tagNumber = 14;
      }
    };
    _a = TIME;
    (() => {
      typeStore.TIME = _a;
    })();
    TIME.NAME = "TIME";
    var Any = class {
      constructor({ name = EMPTY_STRING, optional = false } = {}) {
        this.name = name;
        this.optional = optional;
      }
    };
    var Choice = class extends Any {
      constructor({ value = [], ...parameters } = {}) {
        super(parameters);
        this.value = value;
      }
    };
    var Repeated = class extends Any {
      constructor({ value = new Any(), local = false, ...parameters } = {}) {
        super(parameters);
        this.value = value;
        this.local = local;
      }
    };
    var RawData = class {
      constructor({ data = EMPTY_VIEW } = {}) {
        this.dataView = BufferSourceConverter.toUint8Array(data);
      }
      get data() {
        return this.dataView.slice().buffer;
      }
      set data(value) {
        this.dataView = BufferSourceConverter.toUint8Array(value);
      }
      fromBER(inputBuffer, inputOffset, inputLength) {
        const endLength = inputOffset + inputLength;
        this.dataView = BufferSourceConverter.toUint8Array(inputBuffer).subarray(inputOffset, endLength);
        return endLength;
      }
      toBER(sizeOnly) {
        return this.dataView.slice().buffer;
      }
    };
    function compareSchema(root, inputData, inputSchema) {
      if (inputSchema instanceof Choice) {
        for (let j = 0; j < inputSchema.value.length; j++) {
          const result2 = compareSchema(root, inputData, inputSchema.value[j]);
          if (result2.verified) {
            return {
              verified: true,
              result: root
            };
          }
        }
        {
          const _result = {
            verified: false,
            result: {
              error: "Wrong values for Choice type"
            }
          };
          if (inputSchema.hasOwnProperty(NAME))
            _result.name = inputSchema.name;
          return _result;
        }
      }
      if (inputSchema instanceof Any) {
        if (inputSchema.hasOwnProperty(NAME))
          root[inputSchema.name] = inputData;
        return {
          verified: true,
          result: root
        };
      }
      if (root instanceof Object === false) {
        return {
          verified: false,
          result: { error: "Wrong root object" }
        };
      }
      if (inputData instanceof Object === false) {
        return {
          verified: false,
          result: { error: "Wrong ASN.1 data" }
        };
      }
      if (inputSchema instanceof Object === false) {
        return {
          verified: false,
          result: { error: "Wrong ASN.1 schema" }
        };
      }
      if (ID_BLOCK in inputSchema === false) {
        return {
          verified: false,
          result: { error: "Wrong ASN.1 schema" }
        };
      }
      if (FROM_BER in inputSchema.idBlock === false) {
        return {
          verified: false,
          result: { error: "Wrong ASN.1 schema" }
        };
      }
      if (TO_BER in inputSchema.idBlock === false) {
        return {
          verified: false,
          result: { error: "Wrong ASN.1 schema" }
        };
      }
      const encodedId = inputSchema.idBlock.toBER(false);
      if (encodedId.byteLength === 0) {
        return {
          verified: false,
          result: { error: "Error encoding idBlock for ASN.1 schema" }
        };
      }
      const decodedOffset = inputSchema.idBlock.fromBER(encodedId, 0, encodedId.byteLength);
      if (decodedOffset === -1) {
        return {
          verified: false,
          result: { error: "Error decoding idBlock for ASN.1 schema" }
        };
      }
      if (inputSchema.idBlock.hasOwnProperty(TAG_CLASS) === false) {
        return {
          verified: false,
          result: { error: "Wrong ASN.1 schema" }
        };
      }
      if (inputSchema.idBlock.tagClass !== inputData.idBlock.tagClass) {
        return {
          verified: false,
          result: root
        };
      }
      if (inputSchema.idBlock.hasOwnProperty(TAG_NUMBER) === false) {
        return {
          verified: false,
          result: { error: "Wrong ASN.1 schema" }
        };
      }
      if (inputSchema.idBlock.tagNumber !== inputData.idBlock.tagNumber) {
        return {
          verified: false,
          result: root
        };
      }
      if (inputSchema.idBlock.hasOwnProperty(IS_CONSTRUCTED) === false) {
        return {
          verified: false,
          result: { error: "Wrong ASN.1 schema" }
        };
      }
      if (inputSchema.idBlock.isConstructed !== inputData.idBlock.isConstructed) {
        return {
          verified: false,
          result: root
        };
      }
      if (!(IS_HEX_ONLY in inputSchema.idBlock)) {
        return {
          verified: false,
          result: { error: "Wrong ASN.1 schema" }
        };
      }
      if (inputSchema.idBlock.isHexOnly !== inputData.idBlock.isHexOnly) {
        return {
          verified: false,
          result: root
        };
      }
      if (inputSchema.idBlock.isHexOnly) {
        if (VALUE_HEX_VIEW in inputSchema.idBlock === false) {
          return {
            verified: false,
            result: { error: "Wrong ASN.1 schema" }
          };
        }
        const schemaView = inputSchema.idBlock.valueHexView;
        const asn1View = inputData.idBlock.valueHexView;
        if (schemaView.length !== asn1View.length) {
          return {
            verified: false,
            result: root
          };
        }
        for (let i = 0; i < schemaView.length; i++) {
          if (schemaView[i] !== asn1View[1]) {
            return {
              verified: false,
              result: root
            };
          }
        }
      }
      if (inputSchema.name) {
        inputSchema.name = inputSchema.name.replace(/^\s+|\s+$/g, EMPTY_STRING);
        if (inputSchema.name)
          root[inputSchema.name] = inputData;
      }
      if (inputSchema instanceof typeStore.Constructed) {
        let admission = 0;
        let result2 = {
          verified: false,
          result: {
            error: "Unknown error"
          }
        };
        let maxLength = inputSchema.valueBlock.value.length;
        if (maxLength > 0) {
          if (inputSchema.valueBlock.value[0] instanceof Repeated) {
            maxLength = inputData.valueBlock.value.length;
          }
        }
        if (maxLength === 0) {
          return {
            verified: true,
            result: root
          };
        }
        if (inputData.valueBlock.value.length === 0 && inputSchema.valueBlock.value.length !== 0) {
          let _optional = true;
          for (let i = 0; i < inputSchema.valueBlock.value.length; i++)
            _optional = _optional && (inputSchema.valueBlock.value[i].optional || false);
          if (_optional) {
            return {
              verified: true,
              result: root
            };
          }
          if (inputSchema.name) {
            inputSchema.name = inputSchema.name.replace(/^\s+|\s+$/g, EMPTY_STRING);
            if (inputSchema.name)
              delete root[inputSchema.name];
          }
          root.error = "Inconsistent object length";
          return {
            verified: false,
            result: root
          };
        }
        for (let i = 0; i < maxLength; i++) {
          if (i - admission >= inputData.valueBlock.value.length) {
            if (inputSchema.valueBlock.value[i].optional === false) {
              const _result = {
                verified: false,
                result: root
              };
              root.error = "Inconsistent length between ASN.1 data and schema";
              if (inputSchema.name) {
                inputSchema.name = inputSchema.name.replace(/^\s+|\s+$/g, EMPTY_STRING);
                if (inputSchema.name) {
                  delete root[inputSchema.name];
                  _result.name = inputSchema.name;
                }
              }
              return _result;
            }
          } else {
            if (inputSchema.valueBlock.value[0] instanceof Repeated) {
              result2 = compareSchema(root, inputData.valueBlock.value[i], inputSchema.valueBlock.value[0].value);
              if (result2.verified === false) {
                if (inputSchema.valueBlock.value[0].optional)
                  admission++;
                else {
                  if (inputSchema.name) {
                    inputSchema.name = inputSchema.name.replace(/^\s+|\s+$/g, EMPTY_STRING);
                    if (inputSchema.name)
                      delete root[inputSchema.name];
                  }
                  return result2;
                }
              }
              if (NAME in inputSchema.valueBlock.value[0] && inputSchema.valueBlock.value[0].name.length > 0) {
                let arrayRoot = {};
                if (LOCAL in inputSchema.valueBlock.value[0] && inputSchema.valueBlock.value[0].local)
                  arrayRoot = inputData;
                else
                  arrayRoot = root;
                if (typeof arrayRoot[inputSchema.valueBlock.value[0].name] === "undefined")
                  arrayRoot[inputSchema.valueBlock.value[0].name] = [];
                arrayRoot[inputSchema.valueBlock.value[0].name].push(inputData.valueBlock.value[i]);
              }
            } else {
              result2 = compareSchema(root, inputData.valueBlock.value[i - admission], inputSchema.valueBlock.value[i]);
              if (result2.verified === false) {
                if (inputSchema.valueBlock.value[i].optional)
                  admission++;
                else {
                  if (inputSchema.name) {
                    inputSchema.name = inputSchema.name.replace(/^\s+|\s+$/g, EMPTY_STRING);
                    if (inputSchema.name)
                      delete root[inputSchema.name];
                  }
                  return result2;
                }
              }
            }
          }
        }
        if (result2.verified === false) {
          const _result = {
            verified: false,
            result: root
          };
          if (inputSchema.name) {
            inputSchema.name = inputSchema.name.replace(/^\s+|\s+$/g, EMPTY_STRING);
            if (inputSchema.name) {
              delete root[inputSchema.name];
              _result.name = inputSchema.name;
            }
          }
          return _result;
        }
        return {
          verified: true,
          result: root
        };
      }
      if (inputSchema.primitiveSchema && VALUE_HEX_VIEW in inputData.valueBlock) {
        const asn1 = localFromBER(inputData.valueBlock.valueHexView);
        if (asn1.offset === -1) {
          const _result = {
            verified: false,
            result: asn1.result
          };
          if (inputSchema.name) {
            inputSchema.name = inputSchema.name.replace(/^\s+|\s+$/g, EMPTY_STRING);
            if (inputSchema.name) {
              delete root[inputSchema.name];
              _result.name = inputSchema.name;
            }
          }
          return _result;
        }
        return compareSchema(root, asn1.result, inputSchema.primitiveSchema);
      }
      return {
        verified: true,
        result: root
      };
    }
    function verifySchema(inputBuffer, inputSchema) {
      if (inputSchema instanceof Object === false) {
        return {
          verified: false,
          result: { error: "Wrong ASN.1 schema type" }
        };
      }
      const asn1 = localFromBER(BufferSourceConverter.toUint8Array(inputBuffer));
      if (asn1.offset === -1) {
        return {
          verified: false,
          result: asn1.result
        };
      }
      return compareSchema(asn1.result, asn1.result, inputSchema);
    }
    var AsnTypeTypes;
    (function(AsnTypeTypes2) {
      AsnTypeTypes2[AsnTypeTypes2["Sequence"] = 0] = "Sequence";
      AsnTypeTypes2[AsnTypeTypes2["Set"] = 1] = "Set";
      AsnTypeTypes2[AsnTypeTypes2["Choice"] = 2] = "Choice";
    })(AsnTypeTypes || (AsnTypeTypes = {}));
    var AsnPropTypes;
    (function(AsnPropTypes2) {
      AsnPropTypes2[AsnPropTypes2["Any"] = 1] = "Any";
      AsnPropTypes2[AsnPropTypes2["Boolean"] = 2] = "Boolean";
      AsnPropTypes2[AsnPropTypes2["OctetString"] = 3] = "OctetString";
      AsnPropTypes2[AsnPropTypes2["BitString"] = 4] = "BitString";
      AsnPropTypes2[AsnPropTypes2["Integer"] = 5] = "Integer";
      AsnPropTypes2[AsnPropTypes2["Enumerated"] = 6] = "Enumerated";
      AsnPropTypes2[AsnPropTypes2["ObjectIdentifier"] = 7] = "ObjectIdentifier";
      AsnPropTypes2[AsnPropTypes2["Utf8String"] = 8] = "Utf8String";
      AsnPropTypes2[AsnPropTypes2["BmpString"] = 9] = "BmpString";
      AsnPropTypes2[AsnPropTypes2["UniversalString"] = 10] = "UniversalString";
      AsnPropTypes2[AsnPropTypes2["NumericString"] = 11] = "NumericString";
      AsnPropTypes2[AsnPropTypes2["PrintableString"] = 12] = "PrintableString";
      AsnPropTypes2[AsnPropTypes2["TeletexString"] = 13] = "TeletexString";
      AsnPropTypes2[AsnPropTypes2["VideotexString"] = 14] = "VideotexString";
      AsnPropTypes2[AsnPropTypes2["IA5String"] = 15] = "IA5String";
      AsnPropTypes2[AsnPropTypes2["GraphicString"] = 16] = "GraphicString";
      AsnPropTypes2[AsnPropTypes2["VisibleString"] = 17] = "VisibleString";
      AsnPropTypes2[AsnPropTypes2["GeneralString"] = 18] = "GeneralString";
      AsnPropTypes2[AsnPropTypes2["CharacterString"] = 19] = "CharacterString";
      AsnPropTypes2[AsnPropTypes2["UTCTime"] = 20] = "UTCTime";
      AsnPropTypes2[AsnPropTypes2["GeneralizedTime"] = 21] = "GeneralizedTime";
      AsnPropTypes2[AsnPropTypes2["DATE"] = 22] = "DATE";
      AsnPropTypes2[AsnPropTypes2["TimeOfDay"] = 23] = "TimeOfDay";
      AsnPropTypes2[AsnPropTypes2["DateTime"] = 24] = "DateTime";
      AsnPropTypes2[AsnPropTypes2["Duration"] = 25] = "Duration";
      AsnPropTypes2[AsnPropTypes2["TIME"] = 26] = "TIME";
      AsnPropTypes2[AsnPropTypes2["Null"] = 27] = "Null";
    })(AsnPropTypes || (AsnPropTypes = {}));
    var AsnAnyConverter = {
      fromASN: (value) => value instanceof Null ? null : value.valueBeforeDecodeView,
      toASN: (value) => {
        if (value === null) {
          return new Null();
        }
        const schema = fromBER(value);
        if (schema.result.error) {
          throw new Error(schema.result.error);
        }
        return schema.result;
      }
    };
    var AsnIntegerConverter = {
      fromASN: (value) => value.valueBlock.valueHexView.byteLength >= 4 ? value.valueBlock.toString() : value.valueBlock.valueDec,
      toASN: (value) => new Integer({ value: +value })
    };
    var AsnEnumeratedConverter = {
      fromASN: (value) => value.valueBlock.valueDec,
      toASN: (value) => new Enumerated({ value })
    };
    var AsnBitStringConverter = {
      fromASN: (value) => value.valueBlock.valueHexView,
      toASN: (value) => new BitString({ valueHex: value })
    };
    var AsnObjectIdentifierConverter = {
      fromASN: (value) => value.valueBlock.toString(),
      toASN: (value) => new ObjectIdentifier({ value })
    };
    var AsnBooleanConverter = {
      fromASN: (value) => value.valueBlock.value,
      toASN: (value) => new Boolean2({ value })
    };
    var AsnOctetStringConverter = {
      fromASN: (value) => value.valueBlock.valueHexView,
      toASN: (value) => new OctetString({ valueHex: value })
    };
    function createStringConverter(Asn1Type) {
      return {
        fromASN: (value) => value.valueBlock.value,
        toASN: (value) => new Asn1Type({ value })
      };
    }
    var AsnUtf8StringConverter = createStringConverter(Utf8String);
    var AsnBmpStringConverter = createStringConverter(BmpString);
    var AsnUniversalStringConverter = createStringConverter(UniversalString);
    var AsnNumericStringConverter = createStringConverter(NumericString);
    var AsnPrintableStringConverter = createStringConverter(PrintableString);
    var AsnTeletexStringConverter = createStringConverter(TeletexString);
    var AsnVideotexStringConverter = createStringConverter(VideotexString);
    var AsnIA5StringConverter = createStringConverter(IA5String);
    var AsnGraphicStringConverter = createStringConverter(GraphicString);
    var AsnVisibleStringConverter = createStringConverter(VisibleString);
    var AsnGeneralStringConverter = createStringConverter(GeneralString);
    var AsnCharacterStringConverter = createStringConverter(CharacterString);
    var AsnUTCTimeConverter = {
      fromASN: (value) => value.toDate(),
      toASN: (value) => new UTCTime({ valueDate: value })
    };
    var AsnGeneralizedTimeConverter = {
      fromASN: (value) => value.toDate(),
      toASN: (value) => new GeneralizedTime({ valueDate: value })
    };
    var AsnNullConverter = {
      fromASN: () => null,
      toASN: () => {
        return new Null();
      }
    };
    function defaultConverter(type) {
      switch (type) {
        case AsnPropTypes.Any:
          return AsnAnyConverter;
        case AsnPropTypes.BitString:
          return AsnBitStringConverter;
        case AsnPropTypes.BmpString:
          return AsnBmpStringConverter;
        case AsnPropTypes.Boolean:
          return AsnBooleanConverter;
        case AsnPropTypes.CharacterString:
          return AsnCharacterStringConverter;
        case AsnPropTypes.Enumerated:
          return AsnEnumeratedConverter;
        case AsnPropTypes.GeneralString:
          return AsnGeneralStringConverter;
        case AsnPropTypes.GeneralizedTime:
          return AsnGeneralizedTimeConverter;
        case AsnPropTypes.GraphicString:
          return AsnGraphicStringConverter;
        case AsnPropTypes.IA5String:
          return AsnIA5StringConverter;
        case AsnPropTypes.Integer:
          return AsnIntegerConverter;
        case AsnPropTypes.Null:
          return AsnNullConverter;
        case AsnPropTypes.NumericString:
          return AsnNumericStringConverter;
        case AsnPropTypes.ObjectIdentifier:
          return AsnObjectIdentifierConverter;
        case AsnPropTypes.OctetString:
          return AsnOctetStringConverter;
        case AsnPropTypes.PrintableString:
          return AsnPrintableStringConverter;
        case AsnPropTypes.TeletexString:
          return AsnTeletexStringConverter;
        case AsnPropTypes.UTCTime:
          return AsnUTCTimeConverter;
        case AsnPropTypes.UniversalString:
          return AsnUniversalStringConverter;
        case AsnPropTypes.Utf8String:
          return AsnUtf8StringConverter;
        case AsnPropTypes.VideotexString:
          return AsnVideotexStringConverter;
        case AsnPropTypes.VisibleString:
          return AsnVisibleStringConverter;
        default:
          return null;
      }
    }
    function isConvertible(target) {
      if (typeof target === "function" && target.prototype) {
        if (target.prototype.toASN && target.prototype.fromASN) {
          return true;
        } else {
          return isConvertible(target.prototype);
        }
      } else {
        return !!(target && typeof target === "object" && "toASN" in target && "fromASN" in target);
      }
    }
    function isTypeOfArray(target) {
      var _a2;
      if (target) {
        const proto = Object.getPrototypeOf(target);
        if (((_a2 = proto === null || proto === void 0 ? void 0 : proto.prototype) === null || _a2 === void 0 ? void 0 : _a2.constructor) === Array) {
          return true;
        }
        return isTypeOfArray(proto);
      }
      return false;
    }
    function isArrayEqual(bytes1, bytes2) {
      if (!(bytes1 && bytes2)) {
        return false;
      }
      if (bytes1.byteLength !== bytes2.byteLength) {
        return false;
      }
      const b1 = new Uint8Array(bytes1);
      const b2 = new Uint8Array(bytes2);
      for (let i = 0; i < bytes1.byteLength; i++) {
        if (b1[i] !== b2[i]) {
          return false;
        }
      }
      return true;
    }
    var AsnSchemaStorage = class {
      constructor() {
        this.items = /* @__PURE__ */ new WeakMap();
      }
      has(target) {
        return this.items.has(target);
      }
      get(target, checkSchema = false) {
        const schema = this.items.get(target);
        if (!schema) {
          throw new Error(`Cannot get schema for '${target.prototype.constructor.name}' target`);
        }
        if (checkSchema && !schema.schema) {
          throw new Error(`Schema '${target.prototype.constructor.name}' doesn't contain ASN.1 schema. Call 'AsnSchemaStorage.cache'.`);
        }
        return schema;
      }
      cache(target) {
        const schema = this.get(target);
        if (!schema.schema) {
          schema.schema = this.create(target, true);
        }
      }
      createDefault(target) {
        const schema = {
          type: AsnTypeTypes.Sequence,
          items: {}
        };
        const parentSchema = this.findParentSchema(target);
        if (parentSchema) {
          Object.assign(schema, parentSchema);
          schema.items = Object.assign({}, schema.items, parentSchema.items);
        }
        return schema;
      }
      create(target, useNames) {
        const schema = this.items.get(target) || this.createDefault(target);
        const asn1Value = [];
        for (const key in schema.items) {
          const item = schema.items[key];
          const name = useNames ? key : "";
          let asn1Item;
          if (typeof item.type === "number") {
            const Asn1TypeName = AsnPropTypes[item.type];
            const Asn1Type = index_es_exports[Asn1TypeName];
            if (!Asn1Type) {
              throw new Error(`Cannot get ASN1 class by name '${Asn1TypeName}'`);
            }
            asn1Item = new Asn1Type({ name });
          } else if (isConvertible(item.type)) {
            const instance = new item.type();
            asn1Item = instance.toSchema(name);
          } else if (item.optional) {
            const itemSchema = this.get(item.type);
            if (itemSchema.type === AsnTypeTypes.Choice) {
              asn1Item = new Any({ name });
            } else {
              asn1Item = this.create(item.type, false);
              asn1Item.name = name;
            }
          } else {
            asn1Item = new Any({ name });
          }
          const optional = !!item.optional || item.defaultValue !== void 0;
          if (item.repeated) {
            asn1Item.name = "";
            const Container = item.repeated === "set" ? Set2 : Sequence;
            asn1Item = new Container({
              name: "",
              value: [
                new Repeated({
                  name,
                  value: asn1Item
                })
              ]
            });
          }
          if (item.context !== null && item.context !== void 0) {
            if (item.implicit) {
              if (typeof item.type === "number" || isConvertible(item.type)) {
                const Container = item.repeated ? Constructed : Primitive;
                asn1Value.push(new Container({
                  name,
                  optional,
                  idBlock: {
                    tagClass: 3,
                    tagNumber: item.context
                  }
                }));
              } else {
                this.cache(item.type);
                const isRepeated = !!item.repeated;
                let value = !isRepeated ? this.get(item.type, true).schema : asn1Item;
                value = "valueBlock" in value ? value.valueBlock.value : value.value;
                asn1Value.push(new Constructed({
                  name: !isRepeated ? name : "",
                  optional,
                  idBlock: {
                    tagClass: 3,
                    tagNumber: item.context
                  },
                  value
                }));
              }
            } else {
              asn1Value.push(new Constructed({
                optional,
                idBlock: {
                  tagClass: 3,
                  tagNumber: item.context
                },
                value: [asn1Item]
              }));
            }
          } else {
            asn1Item.optional = optional;
            asn1Value.push(asn1Item);
          }
        }
        switch (schema.type) {
          case AsnTypeTypes.Sequence:
            return new Sequence({ value: asn1Value, name: "" });
          case AsnTypeTypes.Set:
            return new Set2({ value: asn1Value, name: "" });
          case AsnTypeTypes.Choice:
            return new Choice({ value: asn1Value, name: "" });
          default:
            throw new Error(`Unsupported ASN1 type in use`);
        }
      }
      set(target, schema) {
        this.items.set(target, schema);
        return this;
      }
      findParentSchema(target) {
        const parent = Object.getPrototypeOf(target);
        if (parent) {
          const schema = this.items.get(parent);
          return schema || this.findParentSchema(parent);
        }
        return null;
      }
    };
    var schemaStorage = new AsnSchemaStorage();
    var AsnSchemaValidationError = class extends Error {
      constructor() {
        super(...arguments);
        this.schemas = [];
      }
    };
    var AsnParser = class {
      static parse(data, target) {
        const asn1Parsed = fromBER(data);
        if (asn1Parsed.result.error) {
          throw new Error(asn1Parsed.result.error);
        }
        const res = this.fromASN(asn1Parsed.result, target);
        return res;
      }
      static fromASN(asn1Schema, target) {
        var _a2;
        try {
          if (isConvertible(target)) {
            const value = new target();
            return value.fromASN(asn1Schema);
          }
          const schema = schemaStorage.get(target);
          schemaStorage.cache(target);
          let targetSchema = schema.schema;
          if (asn1Schema.constructor === Constructed && schema.type !== AsnTypeTypes.Choice) {
            targetSchema = new Constructed({
              idBlock: {
                tagClass: 3,
                tagNumber: asn1Schema.idBlock.tagNumber
              },
              value: schema.schema.valueBlock.value
            });
            for (const key in schema.items) {
              delete asn1Schema[key];
            }
          }
          const asn1ComparedSchema = compareSchema({}, asn1Schema, targetSchema);
          if (!asn1ComparedSchema.verified) {
            throw new AsnSchemaValidationError(`Data does not match to ${target.name} ASN1 schema. ${asn1ComparedSchema.result.error}`);
          }
          const res = new target();
          if (isTypeOfArray(target)) {
            if (!("value" in asn1Schema.valueBlock && Array.isArray(asn1Schema.valueBlock.value))) {
              throw new Error(`Cannot get items from the ASN.1 parsed value. ASN.1 object is not constructed.`);
            }
            const itemType = schema.itemType;
            if (typeof itemType === "number") {
              const converter = defaultConverter(itemType);
              if (!converter) {
                throw new Error(`Cannot get default converter for array item of ${target.name} ASN1 schema`);
              }
              return target.from(asn1Schema.valueBlock.value, (element) => converter.fromASN(element));
            } else {
              return target.from(asn1Schema.valueBlock.value, (element) => this.fromASN(element, itemType));
            }
          }
          for (const key in schema.items) {
            const asn1SchemaValue = asn1ComparedSchema.result[key];
            if (!asn1SchemaValue) {
              continue;
            }
            const schemaItem = schema.items[key];
            const schemaItemType = schemaItem.type;
            if (typeof schemaItemType === "number" || isConvertible(schemaItemType)) {
              const converter = (_a2 = schemaItem.converter) !== null && _a2 !== void 0 ? _a2 : isConvertible(schemaItemType) ? new schemaItemType() : null;
              if (!converter) {
                throw new Error("Converter is empty");
              }
              if (schemaItem.repeated) {
                if (schemaItem.implicit) {
                  const Container = schemaItem.repeated === "sequence" ? Sequence : Set2;
                  const newItem = new Container();
                  newItem.valueBlock = asn1SchemaValue.valueBlock;
                  const newItemAsn = fromBER(newItem.toBER(false));
                  if (newItemAsn.offset === -1) {
                    throw new Error(`Cannot parse the child item. ${newItemAsn.result.error}`);
                  }
                  if (!("value" in newItemAsn.result.valueBlock && Array.isArray(newItemAsn.result.valueBlock.value))) {
                    throw new Error("Cannot get items from the ASN.1 parsed value. ASN.1 object is not constructed.");
                  }
                  const value = newItemAsn.result.valueBlock.value;
                  res[key] = Array.from(value, (element) => converter.fromASN(element));
                } else {
                  res[key] = Array.from(asn1SchemaValue, (element) => converter.fromASN(element));
                }
              } else {
                let value = asn1SchemaValue;
                if (schemaItem.implicit) {
                  let newItem;
                  if (isConvertible(schemaItemType)) {
                    newItem = new schemaItemType().toSchema("");
                  } else {
                    const Asn1TypeName = AsnPropTypes[schemaItemType];
                    const Asn1Type = index_es_exports[Asn1TypeName];
                    if (!Asn1Type) {
                      throw new Error(`Cannot get '${Asn1TypeName}' class from asn1js module`);
                    }
                    newItem = new Asn1Type();
                  }
                  newItem.valueBlock = value.valueBlock;
                  value = fromBER(newItem.toBER(false)).result;
                }
                res[key] = converter.fromASN(value);
              }
            } else {
              if (schemaItem.repeated) {
                if (!Array.isArray(asn1SchemaValue)) {
                  throw new Error("Cannot get list of items from the ASN.1 parsed value. ASN.1 value should be iterable.");
                }
                res[key] = Array.from(asn1SchemaValue, (element) => this.fromASN(element, schemaItemType));
              } else {
                res[key] = this.fromASN(asn1SchemaValue, schemaItemType);
              }
            }
          }
          return res;
        } catch (error) {
          if (error instanceof AsnSchemaValidationError) {
            error.schemas.push(target.name);
          }
          throw error;
        }
      }
    };
    var AsnSerializer = class _AsnSerializer {
      static serialize(obj) {
        if (obj instanceof BaseBlock) {
          return obj.toBER(false);
        }
        return this.toASN(obj).toBER(false);
      }
      static toASN(obj) {
        if (obj && typeof obj === "object" && isConvertible(obj)) {
          return obj.toASN();
        }
        if (!(obj && typeof obj === "object")) {
          throw new TypeError("Parameter 1 should be type of Object.");
        }
        const target = obj.constructor;
        const schema = schemaStorage.get(target);
        schemaStorage.cache(target);
        let asn1Value = [];
        if (schema.itemType) {
          if (!Array.isArray(obj)) {
            throw new TypeError("Parameter 1 should be type of Array.");
          }
          if (typeof schema.itemType === "number") {
            const converter = defaultConverter(schema.itemType);
            if (!converter) {
              throw new Error(`Cannot get default converter for array item of ${target.name} ASN1 schema`);
            }
            asn1Value = obj.map((o2) => converter.toASN(o2));
          } else {
            asn1Value = obj.map((o2) => this.toAsnItem({ type: schema.itemType }, "[]", target, o2));
          }
        } else {
          for (const key in schema.items) {
            const schemaItem = schema.items[key];
            const objProp = obj[key];
            if (objProp === void 0 || schemaItem.defaultValue === objProp || typeof schemaItem.defaultValue === "object" && typeof objProp === "object" && isArrayEqual(this.serialize(schemaItem.defaultValue), this.serialize(objProp))) {
              continue;
            }
            const asn1Item = _AsnSerializer.toAsnItem(schemaItem, key, target, objProp);
            if (typeof schemaItem.context === "number") {
              if (schemaItem.implicit) {
                if (!schemaItem.repeated && (typeof schemaItem.type === "number" || isConvertible(schemaItem.type))) {
                  const value = {};
                  value.valueHex = asn1Item instanceof Null ? asn1Item.valueBeforeDecodeView : asn1Item.valueBlock.toBER();
                  asn1Value.push(new Primitive({
                    optional: schemaItem.optional,
                    idBlock: {
                      tagClass: 3,
                      tagNumber: schemaItem.context
                    },
                    ...value
                  }));
                } else {
                  asn1Value.push(new Constructed({
                    optional: schemaItem.optional,
                    idBlock: {
                      tagClass: 3,
                      tagNumber: schemaItem.context
                    },
                    value: asn1Item.valueBlock.value
                  }));
                }
              } else {
                asn1Value.push(new Constructed({
                  optional: schemaItem.optional,
                  idBlock: {
                    tagClass: 3,
                    tagNumber: schemaItem.context
                  },
                  value: [asn1Item]
                }));
              }
            } else if (schemaItem.repeated) {
              asn1Value = asn1Value.concat(asn1Item);
            } else {
              asn1Value.push(asn1Item);
            }
          }
        }
        let asnSchema;
        switch (schema.type) {
          case AsnTypeTypes.Sequence:
            asnSchema = new Sequence({ value: asn1Value });
            break;
          case AsnTypeTypes.Set:
            asnSchema = new Set2({ value: asn1Value });
            break;
          case AsnTypeTypes.Choice:
            if (!asn1Value[0]) {
              throw new Error(`Schema '${target.name}' has wrong data. Choice cannot be empty.`);
            }
            asnSchema = asn1Value[0];
            break;
        }
        return asnSchema;
      }
      static toAsnItem(schemaItem, key, target, objProp) {
        let asn1Item;
        if (typeof schemaItem.type === "number") {
          const converter = schemaItem.converter;
          if (!converter) {
            throw new Error(`Property '${key}' doesn't have converter for type ${AsnPropTypes[schemaItem.type]} in schema '${target.name}'`);
          }
          if (schemaItem.repeated) {
            if (!Array.isArray(objProp)) {
              throw new TypeError("Parameter 'objProp' should be type of Array.");
            }
            const items = Array.from(objProp, (element) => converter.toASN(element));
            const Container = schemaItem.repeated === "sequence" ? Sequence : Set2;
            asn1Item = new Container({
              value: items
            });
          } else {
            asn1Item = converter.toASN(objProp);
          }
        } else {
          if (schemaItem.repeated) {
            if (!Array.isArray(objProp)) {
              throw new TypeError("Parameter 'objProp' should be type of Array.");
            }
            const items = Array.from(objProp, (element) => this.toASN(element));
            const Container = schemaItem.repeated === "sequence" ? Sequence : Set2;
            asn1Item = new Container({
              value: items
            });
          } else {
            asn1Item = this.toASN(objProp);
          }
        }
        return asn1Item;
      }
    };
    var AsnConvert = class _AsnConvert {
      static serialize(obj) {
        return AsnSerializer.serialize(obj);
      }
      static parse(data, target) {
        return AsnParser.parse(data, target);
      }
      static toString(data) {
        const buf = BufferSourceConverter.isBufferSource(data) ? BufferSourceConverter.toArrayBuffer(data) : _AsnConvert.serialize(data);
        const asn = fromBER(buf);
        if (asn.offset === -1) {
          throw new Error(`Cannot decode ASN.1 data. ${asn.result.error}`);
        }
        return asn.result.toString();
      }
    };
    async function createSelfSignedCertificate({
      privateKey,
      notAfter,
      notBefore,
      validity,
      subject,
      dns,
      ip,
      applicationUri,
      purpose
    }) {
      const crypto3 = getCrypto();
      const publicKey = await buildPublicKey(privateKey);
      const keys = {
        privateKey,
        publicKey
      };
      const { nsComment, basicConstraints, keyUsageExtension, usages } = getAttributes(purpose);
      notBefore = notBefore || /* @__PURE__ */ new Date();
      validity = validity || 0;
      if (!notAfter) {
        validity = validity || 365;
      }
      notAfter = notAfter || new Date(notBefore.getTime() + validity * 24 * 60 * 60 * 1e3);
      const alternativeNameExtensions = [];
      dns && dns.forEach((d2) => alternativeNameExtensions.push({ type: "dns", value: d2 }));
      ip && ip.forEach((d2) => alternativeNameExtensions.push({ type: "ip", value: d2 }));
      applicationUri && alternativeNameExtensions.push({ type: "url", value: applicationUri });
      const ID_NETSCAPE_COMMENT = "2.16.840.1.113730.1.13";
      const s = new Subject(subject || "");
      const s1 = s.toStringInternal(", ");
      const name = s1;
      const cert = await x5092.X509CertificateGenerator.createSelfSigned(
        {
          serialNumber: Date.now().toString(),
          name,
          notBefore,
          notAfter,
          signingAlgorithm: { name: "RSASSA-PKCS1-v1_5", hash: { name: "SHA-256" } },
          keys,
          extensions: [
            new x5092.Extension(ID_NETSCAPE_COMMENT, false, AsnConvert.serialize(AsnUtf8StringConverter.toASN(nsComment))),
            // new x509.BasicConstraintsExtension(true, 2, true),
            basicConstraints,
            new x5092.ExtendedKeyUsageExtension(keyUsageExtension, true),
            new x5092.KeyUsagesExtension(usages, true),
            await x5092.SubjectKeyIdentifierExtension.create(keys.publicKey),
            await x5092.AuthorityKeyIdentifierExtension.create(keys.publicKey),
            new x5092.SubjectAlternativeNameExtension(alternativeNameExtensions)
          ]
        },
        crypto3
      );
      return { cert: cert.toString("pem"), der: cert };
    }
    var crypto2 = getCrypto();
    var doDebug3 = false;
    function coercePEMorDerToPrivateKey(privateKeyInDerOrPem) {
      if (typeof privateKeyInDerOrPem === "string") {
        const hidden = createPrivateKeyFromNodeJSCrypto(privateKeyInDerOrPem);
        return { hidden };
      }
      throw new Error("not implemented");
    }
    async function _coercePrivateKey(privateKey) {
      const KeyObject4 = crypto2.KeyObject;
      if (privateKey instanceof Buffer) {
        const privateKey1 = await derToPrivateKey(privateKey);
        return KeyObject4.from(privateKey1);
      } else if (typeof privateKey === "string") {
        try {
          const privateKey1 = await pemToPrivateKey(privateKey);
          return KeyObject4.from(privateKey1);
        } catch (err) {
          doDebug3 && console.log(privateKey);
          throw err;
        }
      } else if (privateKey instanceof KeyObject4) {
        return privateKey;
      }
      throw new Error("Invalid privateKey");
    }
    function makePrivateKeyFromPem(privateKeyInPem) {
      return { hidden: privateKeyInPem };
    }
    var import_assert7 = __toESM2(require("assert"));
    var import_fs3 = __toESM2(require("fs"));
    var import_path5 = __toESM2(require("path"));
    var import_crypto13 = require("crypto");
    var import_sshpk = __toESM2(require_lib15());
    function _readPemFile(filename) {
      (0, import_assert7.default)(typeof filename === "string");
      return removeTrailingLF(import_fs3.default.readFileSync(filename, "utf-8"));
    }
    function _readPemOrDerFileAsDER(filename) {
      if (filename.match(/.*\.der/)) {
        return import_fs3.default.readFileSync(filename);
      }
      const raw_key = _readPemFile(filename);
      return convertPEMtoDER(raw_key);
    }
    function readCertificate(filename) {
      return _readPemOrDerFileAsDER(filename);
    }
    function readPublicKey(filename) {
      if (filename.match(/.*\.der/)) {
        const der = import_fs3.default.readFileSync(filename);
        return (0, import_crypto13.createPublicKey)(der);
      } else {
        const raw_key = _readPemFile(filename);
        return (0, import_crypto13.createPublicKey)(raw_key);
      }
    }
    function myCreatePrivateKey(rawKey) {
      if (!import_crypto13.createPrivateKey || process.env.NO_CREATE_PRIVATEKEY) {
        if (rawKey instanceof Buffer) {
          const pemKey = toPem(rawKey, "PRIVATE KEY");
          (0, import_assert7.default)(["RSA PRIVATE KEY", "PRIVATE KEY"].indexOf(identifyPemType(pemKey)) >= 0);
          return { hidden: pemKey };
        }
        return { hidden: ensureTrailingLF(rawKey) };
      }
      const backup = process.env.OPENSSL_CONF;
      process.env.OPENSSL_CONF = "/dev/null";
      const retValue = (0, import_crypto13.createPrivateKey)(rawKey);
      process.env.OPENSSL_CONF = backup;
      return { hidden: retValue };
    }
    function makePrivateKeyThumbPrint(privateKey) {
      return Buffer.alloc(0);
    }
    function ensureTrailingLF(str) {
      return str.match(/\n$/) ? str : str + "\n";
    }
    function readPrivateKey(filename) {
      if (filename.match(/.*\.der/)) {
        const der = import_fs3.default.readFileSync(filename);
        return myCreatePrivateKey(der);
      } else {
        const raw_key = _readPemFile(filename);
        return myCreatePrivateKey(raw_key);
      }
    }
    function readCertificatePEM(filename) {
      return _readPemFile(filename);
    }
    function readPublicKeyPEM(filename) {
      return _readPemFile(filename);
    }
    function readPrivateKeyPEM(filename) {
      return _readPemFile(filename);
    }
    var _g_certificate_store = "";
    function setCertificateStore(store) {
      const old_store = _g_certificate_store;
      _g_certificate_store = store;
      return old_store;
    }
    function getCertificateStore() {
      if (!_g_certificate_store) {
        _g_certificate_store = import_path5.default.join(__dirname, "../../certificates/");
      }
      return _g_certificate_store;
    }
    function readPrivateRsaKey(filename) {
      if (!import_crypto13.createPrivateKey) {
        throw new Error("createPrivateKey is not supported in this environment");
      }
      if (filename.substring(0, 1) !== "." && !import_fs3.default.existsSync(filename)) {
        filename = import_path5.default.join(getCertificateStore(), filename);
      }
      const content = import_fs3.default.readFileSync(filename, "utf8");
      const sshKey = import_sshpk.default.parsePrivateKey(content, "auto");
      const key = sshKey.toString("pkcs1");
      const hidden = (0, import_crypto13.createPrivateKey)({ format: "pem", type: "pkcs1", key });
      return { hidden };
    }
    function readPublicRsaKey(filename) {
      if (filename.substring(0, 1) !== "." && !import_fs3.default.existsSync(filename)) {
        filename = import_path5.default.join(getCertificateStore(), filename);
      }
      const content = import_fs3.default.readFileSync(filename, "utf-8");
      const sshKey = import_sshpk.default.parseKey(content, "ssh");
      const key = sshKey.toString("pkcs1");
      return (0, import_crypto13.createPublicKey)({ format: "pem", type: "pkcs1", key });
    }
    var import_fs22 = __toESM2(require("fs"));
    var import_util = require("util");
    async function readCertificateRevocationList(filename) {
      const crl = await (0, import_util.promisify)(import_fs22.default.readFile)(filename);
      if (crl[0] === 48 && crl[1] === 130) {
        return crl;
      }
      const raw_crl = crl.toString();
      return convertPEMtoDER(raw_crl);
    }
    var import_fs32 = __toESM2(require("fs"));
    var import_util2 = require("util");
    async function readCertificateSigningRequest(filename) {
      const csr = await (0, import_util2.promisify)(import_fs32.default.readFile)(filename);
      if (csr[0] === 48 && csr[1] === 130) {
        return csr;
      }
      const raw_crl = csr.toString();
      return convertPEMtoDER(raw_crl);
    }
    var import_fs4 = __toESM2(require("fs"));
    var import_jsrsasign3 = __toESM2(require_jsrsasign());
    async function generatePrivateKeyFile(privateKeyFilename, modulusLength) {
      const keys = await generateKeyPair(modulusLength);
      const privateKeyPem = await privateKeyToPEM(keys.privateKey);
      await import_fs4.default.promises.writeFile(privateKeyFilename, privateKeyPem.privPem, "utf-8");
      privateKeyPem.privPem = "";
      privateKeyPem.privDer = new Uint8Array(0);
    }
    async function generatePrivateKeyFileAlternate(privateKeyFilename, modulusLength) {
      const kp = import_jsrsasign3.default.KEYUTIL.generateKeypair("RSA", modulusLength);
      const prv = kp.prvKeyObj;
      const pub = kp.pubKeyObj;
      const prvpem = import_jsrsasign3.default.KEYUTIL.getPEM(prv, "PKCS8PRV");
      await import_fs4.default.promises.writeFile(privateKeyFilename, prvpem, "utf-8");
    }
  }
});

// node_modules/node-opcua-common/dist/opcua_secure_object.js
var require_opcua_secure_object = __commonJS({
  "node_modules/node-opcua-common/dist/opcua_secure_object.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OPCUASecureObject = void 0;
    var events_1 = require("events");
    var fs_1 = __importDefault3(require("fs"));
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_crypto_1 = require_dist33();
    function _load_certificate(certificateFilename) {
      const der = (0, node_opcua_crypto_1.readCertificate)(certificateFilename);
      return der;
    }
    function _load_private_key(privateKeyFilename) {
      return (0, node_opcua_crypto_1.readPrivateKey)(privateKeyFilename);
    }
    var OPCUASecureObject = class extends events_1.EventEmitter {
      constructor(options) {
        super();
        (0, node_opcua_assert_1.assert)(typeof options.certificateFile === "string");
        (0, node_opcua_assert_1.assert)(typeof options.privateKeyFile === "string");
        this.certificateFile = options.certificateFile || "invalid certificate file";
        this.privateKeyFile = options.privateKeyFile || "invalid private key file";
      }
      getCertificate() {
        const priv = this;
        if (!priv.$$certificate) {
          const certChain = this.getCertificateChain();
          priv.$$certificate = (0, node_opcua_crypto_1.split_der)(certChain)[0];
        }
        return priv.$$certificate;
      }
      getCertificateChain() {
        const priv = this;
        if (!priv.$$certificateChain) {
          (0, node_opcua_assert_1.assert)(fs_1.default.existsSync(this.certificateFile), "Certificate file must exist :" + this.certificateFile);
          priv.$$certificateChain = _load_certificate(this.certificateFile);
          if (priv.$$certificateChain && priv.$$certificateChain.length === 0) {
            priv.$$certificateChain = _load_certificate(this.certificateFile);
            throw new Error("Invalid certificate length = 0 " + this.certificateFile);
          }
        }
        return priv.$$certificateChain;
      }
      getPrivateKey() {
        const priv = this;
        if (!priv.$$privateKey) {
          (0, node_opcua_assert_1.assert)(fs_1.default.existsSync(this.privateKeyFile), "private file must exist :" + this.privateKeyFile);
          priv.$$privateKey = _load_private_key(this.privateKeyFile);
        }
        (0, node_opcua_assert_1.assert)(!(priv.$$privateKey instanceof Buffer), "should not be a buffer");
        return priv.$$privateKey;
      }
    };
    exports2.OPCUASecureObject = OPCUASecureObject;
  }
});

// node_modules/node-opcua-common/dist/index.js
var require_dist34 = __commonJS({
  "node_modules/node-opcua-common/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.TimeZoneDataType = exports2.EnumValueType = exports2.DataTypeDefinition = exports2.BuildInfo = exports2.SessionDiagnosticsDataType = exports2.ServiceCounterDataType = exports2.SessionSecurityDiagnosticsDataType = exports2.ServerDiagnosticsSummaryDataType = exports2.SemanticChangeStructureDataType = exports2.SamplingIntervalDiagnosticsDataType = exports2.SubscriptionDiagnosticsDataType = exports2.ModelChangeStructureDataType = exports2.RedundantServerDataType = exports2.ServerStatusDataType = exports2.ServerState = void 0;
    var node_opcua_types_1 = require_dist32();
    Object.defineProperty(exports2, "ServerState", { enumerable: true, get: function() {
      return node_opcua_types_1.ServerState;
    } });
    Object.defineProperty(exports2, "ServerStatusDataType", { enumerable: true, get: function() {
      return node_opcua_types_1.ServerStatusDataType;
    } });
    Object.defineProperty(exports2, "RedundantServerDataType", { enumerable: true, get: function() {
      return node_opcua_types_1.RedundantServerDataType;
    } });
    Object.defineProperty(exports2, "ModelChangeStructureDataType", { enumerable: true, get: function() {
      return node_opcua_types_1.ModelChangeStructureDataType;
    } });
    Object.defineProperty(exports2, "SubscriptionDiagnosticsDataType", { enumerable: true, get: function() {
      return node_opcua_types_1.SubscriptionDiagnosticsDataType;
    } });
    Object.defineProperty(exports2, "SamplingIntervalDiagnosticsDataType", { enumerable: true, get: function() {
      return node_opcua_types_1.SamplingIntervalDiagnosticsDataType;
    } });
    Object.defineProperty(exports2, "SemanticChangeStructureDataType", { enumerable: true, get: function() {
      return node_opcua_types_1.SemanticChangeStructureDataType;
    } });
    Object.defineProperty(exports2, "ServerDiagnosticsSummaryDataType", { enumerable: true, get: function() {
      return node_opcua_types_1.ServerDiagnosticsSummaryDataType;
    } });
    Object.defineProperty(exports2, "SessionSecurityDiagnosticsDataType", { enumerable: true, get: function() {
      return node_opcua_types_1.SessionSecurityDiagnosticsDataType;
    } });
    Object.defineProperty(exports2, "ServiceCounterDataType", { enumerable: true, get: function() {
      return node_opcua_types_1.ServiceCounterDataType;
    } });
    Object.defineProperty(exports2, "SessionDiagnosticsDataType", { enumerable: true, get: function() {
      return node_opcua_types_1.SessionDiagnosticsDataType;
    } });
    Object.defineProperty(exports2, "BuildInfo", { enumerable: true, get: function() {
      return node_opcua_types_1.BuildInfo;
    } });
    Object.defineProperty(exports2, "DataTypeDefinition", { enumerable: true, get: function() {
      return node_opcua_types_1.DataTypeDefinition;
    } });
    Object.defineProperty(exports2, "EnumValueType", { enumerable: true, get: function() {
      return node_opcua_types_1.EnumValueType;
    } });
    Object.defineProperty(exports2, "TimeZoneDataType", { enumerable: true, get: function() {
      return node_opcua_types_1.TimeZoneDataType;
    } });
    __exportStar3(require_applicationurn(), exports2);
    __exportStar3(require_opcua_secure_object(), exports2);
  }
});

// node_modules/node-opcua-data-access/dist/Range.js
var require_Range = __commonJS({
  "node_modules/node-opcua-data-access/dist/Range.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Range = void 0;
    var node_opcua_types_1 = require_dist32();
    Object.defineProperty(exports2, "Range", { enumerable: true, get: function() {
      return node_opcua_types_1.Range;
    } });
  }
});

// node_modules/node-opcua-data-access/dist/EUInformation.js
var require_EUInformation = __commonJS({
  "node_modules/node-opcua-data-access/dist/EUInformation.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.standardUnits = exports2.makeEUInformation = exports2.commonCodeToUInt = exports2.EUInformation = void 0;
    var node_opcua_types_1 = require_dist32();
    Object.defineProperty(exports2, "EUInformation", { enumerable: true, get: function() {
      return node_opcua_types_1.EUInformation;
    } });
    var node_opcua_types_2 = require_dist32();
    var defaultUri = "http://www.opcfoundation.org/UA/units/un/cefact";
    var schemaEUInformation = node_opcua_types_2.EUInformation.schema;
    schemaEUInformation.fields[0].defaultValue = defaultUri;
    schemaEUInformation.fields[0].documentation = "Identifies the organization (company, standards organization) that defines the EUInformation.";
    schemaEUInformation.fields[1].documentation = "Identifier for programmatic evaluation. \u22121 is used if a unitId is not available.";
    schemaEUInformation.fields[2].documentation = "The displayName of the engineering  ( for instance 'm/s' )";
    schemaEUInformation.fields[3].documentation = "Contains the full name of the engineering unit such as \u201Dhour\u201D or \u201Dmeter per second";
    function commonCodeToUInt(code) {
      let unitId = 0;
      let c2;
      const m2 = Math.min(4, code.length);
      for (let i = 0; i < m2; i++) {
        c2 = code.charCodeAt(i);
        if (c2 === 0) {
          return unitId;
        }
        unitId *= 256;
        unitId |= c2;
      }
      return unitId;
    }
    exports2.commonCodeToUInt = commonCodeToUInt;
    function makeEUInformation(symbol, shortName, longName) {
      return new node_opcua_types_2.EUInformation({
        description: { text: longName },
        displayName: { text: shortName },
        unitId: commonCodeToUInt(symbol)
      });
    }
    exports2.makeEUInformation = makeEUInformation;
    exports2.standardUnits = {
      // pressure
      bar: makeEUInformation("BAR", "bar", "bar [unit of pressure] = 1E5 Pa"),
      hectopascal: makeEUInformation("A97", "hPa", "hectopascal [unit of pressure] = 1E2 Pa"),
      millibar: makeEUInformation("MBR", "mbar", "millibar [unit of pressure] = 1E2 Pa"),
      pascal: makeEUInformation("PAL", "Pa", "pascal [unit of pressure]"),
      kilogram_per_squared_centimeter: makeEUInformation("D5", "kg/cm\xB2", "kilogram per square centimetre"),
      megapascal: makeEUInformation("MPA", "MPa", "1 megapascal =  10\u2076 pascal [unit of pressure]"),
      // time/duration
      microsecond: makeEUInformation("B98", "\u03BCs", "microsecond =1E-6 second"),
      millisecond: makeEUInformation("C26", "ms", "millisecond =1E-3 second"),
      second: makeEUInformation("SEC", "s", "second"),
      // distance
      centimetre: makeEUInformation("CMT", "cm", "centimetre = 1E-2 m"),
      metre: makeEUInformation("MTR", "m", "metre"),
      millimetre: makeEUInformation("MMT", "mm", "millimetre = 1E-3 metre"),
      // volume
      cubic_centimetre: makeEUInformation("CMQ", "cm\xB3", "Cubic centimetre = 1E-6 m\xB3"),
      cubic_metre: makeEUInformation("MTQ", "m\xB3", "Cubic metre"),
      // temperature
      degree_celsius: makeEUInformation("CEL", "\xB0C", "degree Celsius"),
      degree_fahrenheit: makeEUInformation("FAH", "\xB0F", "degree Fahrenheit 9/5(\xB0C) + 32\xB0"),
      kelvin: makeEUInformation("KEL", "K", "degree Kelvin"),
      // weight
      gram: makeEUInformation("GRM", "g", "gramme 1E-3 kg"),
      kilogram: makeEUInformation("KGM", "kg", "A unit of mass equal to one thousand grams"),
      // speed
      metre_per_second: makeEUInformation("MTS", "m/s", "meter per second"),
      mile_per_hour: makeEUInformation("HM", "mile/h", "mile per hour = 2 0,447 04 m/s"),
      kilometre_per_hour: makeEUInformation("KMH", "km/h", "kilometre per hour = 0,277 778 m/s"),
      // acceleration
      metre_per_second_squared: makeEUInformation("MSK", "m/s\xB2", "meter per second square"),
      // frequency
      kilohertz: makeEUInformation("KHZ", "kHz", "kilo hertz = 1E3 Hertz"),
      hertz: makeEUInformation("HTZ", "Hz", "Hertz"),
      megahertz: makeEUInformation("MHZ", "MHz", "megahertz"),
      revolutions_per_minute: makeEUInformation("RPM", "r/min", "revolutions per minute 1,047198 rad/(60 x s)"),
      revolutions_per_second: makeEUInformation("RPS", "r/s", "revolutions per minute 1,047198 rad/s"),
      // force
      newton: makeEUInformation("NEW", "N", "Newton (kg x m)/s\xB2 "),
      kilogram_force: makeEUInformation("B37", "kgf", "kilogram-force 1 kgf = 9.80665 N"),
      // power
      kilowatt: makeEUInformation("KWT", "kW", "kilowatt  1kW = 10\xB3 W"),
      megawatt: makeEUInformation("MAW", "MW", "Mega Watt"),
      watt: makeEUInformation("WTT", "W", "Watt"),
      // rate of flow
      cubic_centimetre_per_second: makeEUInformation("2J", "cm\xB3/s", "Cubic centimetre per second"),
      cubic_metre_per_hour: makeEUInformation("MQH", "m\xB3/h", "Cubic metre per hours = 2,777 78 x 10\u207B\u2074 m\xB3/s"),
      cubic_meter_per_minute: makeEUInformation("G53", "m\xB3/min", "m\xB3/min	cubic metre per minute"),
      // angle
      degree: makeEUInformation("DD", "\xB0", "degree [unit of angle]"),
      //
      ampere: makeEUInformation("AMP", "A", "ampere"),
      becquerel: makeEUInformation("BQL", "Bq", "becquerel = 27,027E-12 Ci"),
      curie: makeEUInformation("CUR", "Ci", "Curie = 3,7E-10 Bq"),
      curie_per_kilogram: makeEUInformation("A42", "Ci/kg", "Curie per kilogram = 3,7E-10 Bq/kg"),
      dots_per_inch: makeEUInformation("E39", "dpi", "dot per inch"),
      electron_volt: makeEUInformation("A53", "eV", "electron volt"),
      farad: makeEUInformation("FAR", "F", "Farad = kg\u207B\xB9 x m\u207B\xB2 x s\u2074 x     A\xB2"),
      gigabecquerel: makeEUInformation("GBQ", "GBq", "Giga becquerel = 1E9 Bq"),
      joule: makeEUInformation("JOU", "J", "Joule"),
      kilo_electron_volt: makeEUInformation("B29", "keV", "kilo electron volt"),
      kilogram_per_second: makeEUInformation("KGS", "kg/s", "kilogram per second"),
      kilopascal: makeEUInformation("KPA", "kPa", "1 kilopascal = 10\xB3 Pa"),
      millipascal: makeEUInformation("74", "mPa", "1 millipascal = 10\u207B\xB3 Pa"),
      kilobecquerel: makeEUInformation("2Q", "kBq", "kilo becquerel = 1E3 Bq"),
      mega_electron_volt: makeEUInformation("B71", "MeV", "mega electron volt"),
      megawatt_per_minute: makeEUInformation("Q35", "MW/min", "A unit of power defining the total amount of bulk energy transferred or consumer per minute."),
      percent: makeEUInformation("P1", "%", "Percent, a unit of proportion equal to 0.01. "),
      pixel: makeEUInformation("E37", "", "pixel:  unit of count defining the number of pixels (pixel: picture element)"),
      volt: makeEUInformation("VLT", "V", "Volt"),
      byte: makeEUInformation("AD", "byte", "byte = A unit of information equal to 8 bits."),
      kilobyte: makeEUInformation("2P", "kbyte", "kilobyte = A unit of information equal to 10\xB3 (1000) bytes."),
      megabyte: makeEUInformation("4L", "Mbyte", "megabyte = A unit of information equal to 10\u2076 (1000000) bytes."),
      gigabyte: makeEUInformation("E34", "Gbyte", "gigabyte = A unit of information equal to 10\u2079 bytes."),
      terabyte: makeEUInformation("E35", "Tbyte", "terabyte = A unit of information equal to 10\xB9\xB2 bytes."),
      minute: makeEUInformation("MIN", "min", " minute (unit of time) 1min = 60 s"),
      minute_angle: makeEUInformation("D61", "'", "minute [unit of angle]"),
      part_per_million: makeEUInformation("59", "ppm", "A unit of proportion equal to 10\u207B\u2076.")
      // to be continued
    };
  }
});

// node_modules/node-opcua-data-access/dist/index.js
var require_dist35 = __commonJS({
  "node_modules/node-opcua-data-access/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AxisScaleEnumeration = exports2.AxisInformation = void 0;
    __exportStar3(require_Range(), exports2);
    __exportStar3(require_EUInformation(), exports2);
    var node_opcua_types_1 = require_dist32();
    Object.defineProperty(exports2, "AxisInformation", { enumerable: true, get: function() {
      return node_opcua_types_1.AxisInformation;
    } });
    Object.defineProperty(exports2, "AxisScaleEnumeration", { enumerable: true, get: function() {
      return node_opcua_types_1.AxisScaleEnumeration;
    } });
  }
});

// node_modules/node-opcua-hostname/dist/hostname.js
var require_hostname = __commonJS({
  "node_modules/node-opcua-hostname/dist/hostname.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.resolveFullyQualifiedDomainName = exports2.getHostname = exports2.getFullyQualifiedDomainName = exports2.prepareFQDN = exports2.extractFullyQualifiedDomainName = void 0;
    var dns_1 = __importDefault3(require("dns"));
    var os_1 = __importDefault3(require("os"));
    var util_1 = require("util");
    function trim(str, length) {
      if (!length) {
        return str;
      }
      return str.substring(0, Math.min(str.length, length));
    }
    function fqdn(callback) {
      const uqdn = os_1.default.hostname();
      dns_1.default.lookup(uqdn, { hints: dns_1.default.ADDRCONFIG }, (err1, ip) => {
        if (err1) {
          return callback(err1);
        }
        dns_1.default.lookupService(ip, 0, (err2, _fqdn) => {
          if (err2) {
            return callback(err2);
          }
          _fqdn = _fqdn.replace(".localdomain", "");
          callback(null, _fqdn);
        });
      });
    }
    var _fullyQualifiedDomainNameInCache;
    async function extractFullyQualifiedDomainName() {
      if (_fullyQualifiedDomainNameInCache) {
        return _fullyQualifiedDomainNameInCache;
      }
      if (process.platform === "win32") {
        const env = process.env;
        _fullyQualifiedDomainNameInCache = env.COMPUTERNAME + (env.USERDNSDOMAIN && env.USERDNSDOMAIN.length > 0 ? "." + env.USERDNSDOMAIN : "");
      } else {
        try {
          _fullyQualifiedDomainNameInCache = await (0, util_1.promisify)(fqdn)();
          if (_fullyQualifiedDomainNameInCache === "localhost") {
            throw new Error("localhost not expected");
          }
          if (/sethostname/.test(_fullyQualifiedDomainNameInCache)) {
            throw new Error("Detecting fqdn  on windows !!!");
          }
        } catch (err) {
          _fullyQualifiedDomainNameInCache = os_1.default.hostname();
        }
      }
      return _fullyQualifiedDomainNameInCache;
    }
    exports2.extractFullyQualifiedDomainName = extractFullyQualifiedDomainName;
    async function prepareFQDN() {
      _fullyQualifiedDomainNameInCache = await extractFullyQualifiedDomainName();
    }
    exports2.prepareFQDN = prepareFQDN;
    function getFullyQualifiedDomainName(optional_max_length) {
      if (!_fullyQualifiedDomainNameInCache) {
        throw new Error("FullyQualifiedDomainName computation is not completed yet");
      }
      return _fullyQualifiedDomainNameInCache ? trim(_fullyQualifiedDomainNameInCache, optional_max_length) : "%FQDN%";
    }
    exports2.getFullyQualifiedDomainName = getFullyQualifiedDomainName;
    function getHostname2() {
      return os_1.default.hostname();
    }
    exports2.getHostname = getHostname2;
    function resolveFullyQualifiedDomainName(str) {
      if (!_fullyQualifiedDomainNameInCache) {
        throw new Error("FullyQualifiedDomainName computation is not completed yet");
      }
      str = str.replace("%FQDN%", _fullyQualifiedDomainNameInCache);
      str = str.replace("{FQDN}", _fullyQualifiedDomainNameInCache);
      str = str.replace("{hostname}", getHostname2());
      return str;
    }
    exports2.resolveFullyQualifiedDomainName = resolveFullyQualifiedDomainName;
    prepareFQDN();
  }
});

// node_modules/node-opcua-hostname/dist/index.js
var require_dist36 = __commonJS({
  "node_modules/node-opcua-hostname/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_hostname(), exports2);
  }
});

// node_modules/node-opcua-service-browse/dist/index.js
var require_dist37 = __commonJS({
  "node_modules/node-opcua-service-browse/dist/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.BrowseResponse = exports2.BrowseRequest = exports2.ViewDescription = exports2.BrowseNextResponse = exports2.BrowseNextRequest = exports2.BrowseDescription = exports2.BrowseResult = exports2.ReferenceDescription = exports2.BrowseDirection = void 0;
    var node_opcua_types_1 = require_dist32();
    var node_opcua_data_model_1 = require_dist27();
    Object.defineProperty(exports2, "BrowseDirection", { enumerable: true, get: function() {
      return node_opcua_data_model_1.BrowseDirection;
    } });
    var node_opcua_types_2 = require_dist32();
    Object.defineProperty(exports2, "ReferenceDescription", { enumerable: true, get: function() {
      return node_opcua_types_2.ReferenceDescription;
    } });
    Object.defineProperty(exports2, "BrowseResult", { enumerable: true, get: function() {
      return node_opcua_types_2.BrowseResult;
    } });
    Object.defineProperty(exports2, "BrowseDescription", { enumerable: true, get: function() {
      return node_opcua_types_2.BrowseDescription;
    } });
    Object.defineProperty(exports2, "BrowseNextRequest", { enumerable: true, get: function() {
      return node_opcua_types_2.BrowseNextRequest;
    } });
    Object.defineProperty(exports2, "BrowseNextResponse", { enumerable: true, get: function() {
      return node_opcua_types_2.BrowseNextResponse;
    } });
    Object.defineProperty(exports2, "ViewDescription", { enumerable: true, get: function() {
      return node_opcua_types_2.ViewDescription;
    } });
    Object.defineProperty(exports2, "BrowseRequest", { enumerable: true, get: function() {
      return node_opcua_types_2.BrowseRequest;
    } });
    Object.defineProperty(exports2, "BrowseResponse", { enumerable: true, get: function() {
      return node_opcua_types_2.BrowseResponse;
    } });
    node_opcua_types_1.BrowseResult.schema.fields[1].defaultValue = null;
    node_opcua_types_1.BrowseDescription.schema.fields[0].documentation = "The id of the node to browse.";
    node_opcua_types_1.BrowseDescription.schema.fields[1].documentation = "The direction of the references to return.";
    node_opcua_types_1.BrowseDescription.schema.fields[2].documentation = "The type of references to return.Specifies the NodeId of the ReferenceType to follow. Only instances of this ReferenceType or its subtype are returned. If not specified then all ReferenceTypes are returned and includeSubtypes is ignored.";
    node_opcua_types_1.BrowseDescription.schema.fields[3].documentation = "Includes subtypes of the reference type.";
    node_opcua_types_1.BrowseDescription.schema.fields[4].documentation = "A mask indicating which node classes to return. 0 means return all nodes.";
    node_opcua_types_1.BrowseDescription.schema.fields[5].documentation = "A mask indicating which fields in the ReferenceDescription should be returned in the results.";
    node_opcua_types_1.BrowseNextRequest.schema.fields[0].documentation = "A standard header included in all requests sent to a server.";
    node_opcua_types_1.BrowseNextRequest.schema.fields[1].documentation = "If TRUE the continuation points are released and no results are returned.";
    node_opcua_types_1.BrowseNextRequest.schema.fields[2].documentation = "The maximum number of references to return in the response.";
    node_opcua_types_1.BrowseNextResponse.schema.documentation = "Browse the references for one or more nodes from the server address space.";
    node_opcua_types_1.BrowseNextResponse.schema.fields[0].documentation = "A standard header included in all responses returned by servers.";
    node_opcua_types_1.BrowseNextResponse.schema.fields[1].documentation = "The results for the browse operations.";
    node_opcua_types_1.BrowseNextResponse.schema.fields[2].documentation = "The diagnostics associated with the results.";
    node_opcua_types_1.BrowseRequest.schema.documentation = "Browse the references for one or more nodes from the server address space.";
    node_opcua_types_1.BrowseRequest.schema.fields[0].documentation = "A standard header included in all requests sent to a server.";
    node_opcua_types_1.BrowseRequest.schema.fields[1].documentation = "The view to browse.";
    node_opcua_types_1.BrowseRequest.schema.fields[2].documentation = "The maximum number of references to return in the response.";
    node_opcua_types_1.BrowseRequest.schema.fields[3].documentation = "The list of nodes to browse.";
    node_opcua_types_1.BrowseResponse.schema.documentation = "Browse the references for one or more nodes from the server address space.";
    node_opcua_types_1.BrowseResponse.schema.fields[0].documentation = "A standard header included in all responses returned by servers.";
    node_opcua_types_1.BrowseResponse.schema.fields[1].documentation = "The results for the browse operations.";
    node_opcua_types_1.BrowseResponse.schema.fields[2].documentation = "The diagnostics associated with the results.";
    node_opcua_types_1.BrowseResult.schema.documentation = "The result of a browse operation.";
    node_opcua_types_1.BrowseResult.schema.fields[0].documentation = "A code indicating any error during the operation.";
    node_opcua_types_1.BrowseResult.schema.fields[1].documentation = "A value that indicates the operation is incomplete and can be continued by calling BrowseNext.";
    node_opcua_types_1.BrowseResult.schema.fields[2].documentation = "A list of references that meet the criteria specified in the request.";
    node_opcua_types_1.ReferenceDescription.schema.documentation = "The description of a reference.";
    node_opcua_types_1.ReferenceDescription.schema.fields[0].documentation = "The type of references.";
    node_opcua_types_1.ReferenceDescription.schema.fields[1].documentation = "TRUE if the reference is a forward reference.";
    node_opcua_types_1.ReferenceDescription.schema.fields[2].documentation = "The id of the target node.";
    node_opcua_types_1.ReferenceDescription.schema.fields[3].documentation = "The browse name of the target node.";
    node_opcua_types_1.ReferenceDescription.schema.fields[4].documentation = "The display name of the target node.";
    node_opcua_types_1.ReferenceDescription.schema.fields[5].documentation = "The node class of the target node.";
    node_opcua_types_1.ReferenceDescription.schema.fields[6].documentation = "The type definition of the target node.";
    node_opcua_types_1.ViewDescription.schema.documentation = "the view to browse.";
    node_opcua_types_1.ViewDescription.schema.fields[0].documentation = "The node id of the view.";
    node_opcua_types_1.ViewDescription.schema.fields[1].documentation = "Browses the view at or before this time.";
    node_opcua_types_1.ViewDescription.schema.fields[2].documentation = "Browses a specific version of the view .";
  }
});

// node_modules/node-opcua-service-secure-channel/dist/AsymmetricAlgorithmSecurityHeader.js
var require_AsymmetricAlgorithmSecurityHeader = __commonJS({
  "node_modules/node-opcua-service-secure-channel/dist/AsymmetricAlgorithmSecurityHeader.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AsymmetricAlgorithmSecurityHeader = void 0;
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_factory_1 = require_dist26();
    var schemaAsymmetricAlgorithmSecurityHeader = (0, node_opcua_factory_1.buildStructuredType)({
      name: "AsymmetricAlgorithmSecurityHeader",
      baseType: "BaseUAObject",
      fields: [
        // length shall not exceed 256
        // The URI of the security policy used to secure the message.
        // This field is encoded as a UTF8 string without a null terminator
        { name: "SecurityPolicyUri", fieldType: "String" },
        // The X509v3 certificate assigned to the sending application instance.
        // This is a DER encoded blob.
        // This indicates what private key was used to sign the MessageChunk.
        // This field shall be null if the message is not signed.
        // The structure of an X509 Certificate is defined in X509.
        // The DER format for a Certificate is defined in X690
        // The Stack shall close the channel and report an error to the Application if the SenderCertificate
        // is too large for the buffer size supported by the transport layer.
        // If the Certificate is signed by a CA the DER encoded CA Certificate may be appended after the Certificate
        // in the byte array. If the CA Certificate is also signed by another CA this process is repeated until
        // the entire Certificate chain is in the buffer or if MaxSenderCertificateSize limit is reached
        // (the process stops after the last whole Certificate that can be added without exceeding the
        // MaxSenderCertificateSize limit).
        // Receivers can extract the Certificates from the byte array by using the Certificate size contained
        // in DER header (see X509).
        // Receivers that do not handle Certificate chains shall ignore the extra bytes.
        { name: "SenderCertificate", fieldType: "ByteString", defaultValue: null },
        // The thumbprint of the X509v3 certificate assigned to the receiving application
        // The thumbprint is the SHA1 digest of the DER encoded form of the certificate.
        // This indicates what public key was used to encrypt the MessageChunk
        // This field shall be null if the message is not encrypted.
        { name: "ReceiverCertificateThumbprint", fieldType: "ByteString", defaultValue: null }
      ]
    });
    var AsymmetricAlgorithmSecurityHeader = class extends node_opcua_factory_1.BaseUAObject {
      constructor(options) {
        options = options || {};
        super();
        const schema = schemaAsymmetricAlgorithmSecurityHeader;
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.securityPolicyUri = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options.securityPolicyUri);
        this.senderCertificate = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options.senderCertificate);
        this.receiverCertificateThumbprint = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options.receiverCertificateThumbprint);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeString)(this.securityPolicyUri, stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.senderCertificate, stream);
        (0, node_opcua_basic_types_1.encodeByteString)(this.receiverCertificateThumbprint, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.securityPolicyUri = (0, node_opcua_basic_types_1.decodeString)(stream);
        this.senderCertificate = (0, node_opcua_basic_types_1.decodeByteString)(stream);
        this.receiverCertificateThumbprint = (0, node_opcua_basic_types_1.decodeByteString)(stream);
      }
    };
    exports2.AsymmetricAlgorithmSecurityHeader = AsymmetricAlgorithmSecurityHeader;
    AsymmetricAlgorithmSecurityHeader.possibleFields = [
      "securityPolicyUri",
      "senderCertificate",
      "receiverCertificateThumbprint"
    ];
    AsymmetricAlgorithmSecurityHeader.schema = schemaAsymmetricAlgorithmSecurityHeader;
    AsymmetricAlgorithmSecurityHeader.prototype.schema = AsymmetricAlgorithmSecurityHeader.schema;
  }
});

// node_modules/node-opcua-service-secure-channel/dist/SymmetricAlgorithmSecurityHeader.js
var require_SymmetricAlgorithmSecurityHeader = __commonJS({
  "node_modules/node-opcua-service-secure-channel/dist/SymmetricAlgorithmSecurityHeader.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SymmetricAlgorithmSecurityHeader = void 0;
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_factory_1 = require_dist26();
    var schemaSymmetricAlgorithmSecurityHeader = (0, node_opcua_factory_1.buildStructuredType)({
      name: "SymmetricAlgorithmSecurityHeader",
      baseType: "BaseUAObject",
      fields: [
        // A unique identifier for the ClientSecureChannelLayer token used to secure the message
        // This identifier is returned by the server in an OpenSecureChannel response message. If a
        // Server receives a TokenId which it does not recognize it shall return an appropriate
        // transport layer error.
        { name: "TokenId", fieldType: "UInt32", defaultValue: 3735928559 }
      ]
    });
    var SymmetricAlgorithmSecurityHeader = class extends node_opcua_factory_1.BaseUAObject {
      constructor(options) {
        options = options || {};
        super();
        const schema = schemaSymmetricAlgorithmSecurityHeader;
        this.tokenId = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options.tokenId);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.tokenId, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.tokenId = (0, node_opcua_basic_types_1.decodeUInt32)(stream);
      }
    };
    exports2.SymmetricAlgorithmSecurityHeader = SymmetricAlgorithmSecurityHeader;
    SymmetricAlgorithmSecurityHeader.possibleFields = ["tokenId"];
    SymmetricAlgorithmSecurityHeader.schema = schemaSymmetricAlgorithmSecurityHeader;
    SymmetricAlgorithmSecurityHeader.prototype.schema = SymmetricAlgorithmSecurityHeader.schema;
  }
});

// node_modules/node-opcua-service-secure-channel/dist/message_security_mode.js
var require_message_security_mode = __commonJS({
  "node_modules/node-opcua-service-secure-channel/dist/message_security_mode.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.coerceMessageSecurityMode = void 0;
    var node_opcua_types_1 = require_dist32();
    function coerceMessageSecurityMode(value) {
      if (value === void 0) {
        return node_opcua_types_1.MessageSecurityMode.None;
      }
      if (typeof value === "string") {
        const e = node_opcua_types_1._enumerationMessageSecurityMode.get(value);
        if (!e) {
          return node_opcua_types_1.MessageSecurityMode.Invalid;
        }
        return e.value;
      }
      return value;
    }
    exports2.coerceMessageSecurityMode = coerceMessageSecurityMode;
  }
});

// node_modules/node-opcua-service-secure-channel/dist/index.js
var require_dist38 = __commonJS({
  "node_modules/node-opcua-service-secure-channel/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.hasTokenExpired = exports2.SymmetricAlgorithmSecurityHeader = exports2.AsymmetricAlgorithmSecurityHeader = exports2.UserTokenPolicy = exports2._enumerationMessageSecurityMode = exports2.MessageSecurityMode = exports2.SignatureData = exports2.RequestHeader = exports2.ResponseHeader = exports2.SecurityTokenRequestType = exports2.ServiceFault = exports2.CloseSecureChannelResponse = exports2.CloseSecureChannelRequest = exports2.OpenSecureChannelResponse = exports2.OpenSecureChannelRequest = exports2.ChannelSecurityToken = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_types_2 = require_dist32();
    Object.defineProperty(exports2, "ChannelSecurityToken", { enumerable: true, get: function() {
      return node_opcua_types_2.ChannelSecurityToken;
    } });
    Object.defineProperty(exports2, "OpenSecureChannelRequest", { enumerable: true, get: function() {
      return node_opcua_types_2.OpenSecureChannelRequest;
    } });
    Object.defineProperty(exports2, "OpenSecureChannelResponse", { enumerable: true, get: function() {
      return node_opcua_types_2.OpenSecureChannelResponse;
    } });
    Object.defineProperty(exports2, "CloseSecureChannelRequest", { enumerable: true, get: function() {
      return node_opcua_types_2.CloseSecureChannelRequest;
    } });
    Object.defineProperty(exports2, "CloseSecureChannelResponse", { enumerable: true, get: function() {
      return node_opcua_types_2.CloseSecureChannelResponse;
    } });
    Object.defineProperty(exports2, "ServiceFault", { enumerable: true, get: function() {
      return node_opcua_types_2.ServiceFault;
    } });
    Object.defineProperty(exports2, "SecurityTokenRequestType", { enumerable: true, get: function() {
      return node_opcua_types_2.SecurityTokenRequestType;
    } });
    Object.defineProperty(exports2, "ResponseHeader", { enumerable: true, get: function() {
      return node_opcua_types_2.ResponseHeader;
    } });
    Object.defineProperty(exports2, "RequestHeader", { enumerable: true, get: function() {
      return node_opcua_types_2.RequestHeader;
    } });
    Object.defineProperty(exports2, "SignatureData", { enumerable: true, get: function() {
      return node_opcua_types_2.SignatureData;
    } });
    Object.defineProperty(exports2, "MessageSecurityMode", { enumerable: true, get: function() {
      return node_opcua_types_2.MessageSecurityMode;
    } });
    Object.defineProperty(exports2, "_enumerationMessageSecurityMode", { enumerable: true, get: function() {
      return node_opcua_types_2._enumerationMessageSecurityMode;
    } });
    Object.defineProperty(exports2, "UserTokenPolicy", { enumerable: true, get: function() {
      return node_opcua_types_2.UserTokenPolicy;
    } });
    var AsymmetricAlgorithmSecurityHeader_1 = require_AsymmetricAlgorithmSecurityHeader();
    Object.defineProperty(exports2, "AsymmetricAlgorithmSecurityHeader", { enumerable: true, get: function() {
      return AsymmetricAlgorithmSecurityHeader_1.AsymmetricAlgorithmSecurityHeader;
    } });
    var SymmetricAlgorithmSecurityHeader_1 = require_SymmetricAlgorithmSecurityHeader();
    Object.defineProperty(exports2, "SymmetricAlgorithmSecurityHeader", { enumerable: true, get: function() {
      return SymmetricAlgorithmSecurityHeader_1.SymmetricAlgorithmSecurityHeader;
    } });
    __exportStar3(require_message_security_mode(), exports2);
    node_opcua_types_1.ChannelSecurityToken.schema.fields[2].defaultValue = () => /* @__PURE__ */ new Date();
    node_opcua_types_1.ChannelSecurityToken.schema.fields[3].defaultValue = () => 3e4;
    function hasTokenExpired(token) {
      return token.createdAt !== null && token.createdAt.getTime() + token.revisedLifetime < Date.now();
    }
    exports2.hasTokenExpired = hasTokenExpired;
    Object.defineProperty(node_opcua_types_1.ChannelSecurityToken.prototype, "expired", {
      get() {
        return hasTokenExpired(this);
      },
      configurable: true,
      enumerable: true
    });
    (0, node_opcua_assert_1.assert)(node_opcua_types_1.RequestHeader.schema.fields[1].name === "timestamp");
    node_opcua_types_1.RequestHeader.schema.fields[1].defaultValue = () => /* @__PURE__ */ new Date();
    (0, node_opcua_assert_1.assert)(node_opcua_types_1.RequestHeader.schema.fields[2].name === "requestHandle");
    node_opcua_types_1.RequestHeader.schema.fields[2].defaultValue = 3735928559;
    (0, node_opcua_assert_1.assert)(node_opcua_types_1.RequestHeader.schema.fields[6].name === "additionalHeader");
    node_opcua_types_1.RequestHeader.schema.fields[6].defaultValue = () => null;
    (0, node_opcua_assert_1.assert)(node_opcua_types_1.ResponseHeader.schema.fields[0].name === "timestamp");
    node_opcua_types_1.ResponseHeader.schema.fields[0].defaultValue = () => /* @__PURE__ */ new Date();
    (0, node_opcua_assert_1.assert)(node_opcua_types_1.SignatureData.schema.fields[0].name === "algorithm");
    node_opcua_types_1.SignatureData.schema.fields[0].defaultValue = () => null;
    (0, node_opcua_assert_1.assert)(node_opcua_types_1.SignatureData.schema.fields[1].name === "signature");
    node_opcua_types_1.SignatureData.schema.fields[1].defaultValue = () => null;
  }
});

// node_modules/node-opcua-service-read/dist/index.js
var require_dist39 = __commonJS({
  "node_modules/node-opcua-service-read/dist/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.TimestampsToReturn = exports2.AttributeIds = exports2.attributeNameById = exports2.ReadResponse = exports2.ReadRequest = exports2.ReadValueId = exports2.ResponseHeader = exports2.RequestHeader = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_data_value_1 = require_dist29();
    (0, node_opcua_assert_1.assert)(node_opcua_types_1.ReadRequest.schema.fields[2].name === "timestampsToReturn");
    node_opcua_types_1.ReadRequest.schema.fields[2].defaultValue = () => node_opcua_data_value_1.TimestampsToReturn.Both;
    (0, node_opcua_assert_1.assert)(node_opcua_types_1.ReadValueId.schema.fields[1].name === "attributeId");
    node_opcua_types_1.ReadValueId.schema.fields[1].defaultValue = () => node_opcua_data_model_1.AttributeIds.Value;
    node_opcua_types_1.ReadValueId.schema.fields[1].validate = (value) => {
      return (0, node_opcua_data_model_1.isValidAttributeId)(value) || value === node_opcua_data_model_1.AttributeIds.INVALID;
    };
    var node_opcua_service_secure_channel_1 = require_dist38();
    Object.defineProperty(exports2, "RequestHeader", { enumerable: true, get: function() {
      return node_opcua_service_secure_channel_1.RequestHeader;
    } });
    Object.defineProperty(exports2, "ResponseHeader", { enumerable: true, get: function() {
      return node_opcua_service_secure_channel_1.ResponseHeader;
    } });
    var node_opcua_types_2 = require_dist32();
    Object.defineProperty(exports2, "ReadValueId", { enumerable: true, get: function() {
      return node_opcua_types_2.ReadValueId;
    } });
    Object.defineProperty(exports2, "ReadRequest", { enumerable: true, get: function() {
      return node_opcua_types_2.ReadRequest;
    } });
    Object.defineProperty(exports2, "ReadResponse", { enumerable: true, get: function() {
      return node_opcua_types_2.ReadResponse;
    } });
    var node_opcua_data_model_2 = require_dist27();
    Object.defineProperty(exports2, "attributeNameById", { enumerable: true, get: function() {
      return node_opcua_data_model_2.attributeNameById;
    } });
    Object.defineProperty(exports2, "AttributeIds", { enumerable: true, get: function() {
      return node_opcua_data_model_2.AttributeIds;
    } });
    var node_opcua_data_value_2 = require_dist29();
    Object.defineProperty(exports2, "TimestampsToReturn", { enumerable: true, get: function() {
      return node_opcua_data_value_2.TimestampsToReturn;
    } });
  }
});

// node_modules/node-opcua-service-write/dist/index.js
var require_dist40 = __commonJS({
  "node_modules/node-opcua-service-write/dist/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.WriteResponse = exports2.WriteRequest = exports2.WriteValue = void 0;
    var node_opcua_types_1 = require_dist32();
    Object.defineProperty(exports2, "WriteValue", { enumerable: true, get: function() {
      return node_opcua_types_1.WriteValue;
    } });
    Object.defineProperty(exports2, "WriteRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.WriteRequest;
    } });
    Object.defineProperty(exports2, "WriteResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.WriteResponse;
    } });
  }
});

// node_modules/node-opcua-service-call/dist/imports.js
var require_imports = __commonJS({
  "node_modules/node-opcua-service-call/dist/imports.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.CallResponse = exports2.CallMethodResult = exports2.CallRequest = exports2.CallMethodRequest = exports2.Argument = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_types_2 = require_dist32();
    Object.defineProperty(exports2, "Argument", { enumerable: true, get: function() {
      return node_opcua_types_2.Argument;
    } });
    Object.defineProperty(exports2, "CallMethodRequest", { enumerable: true, get: function() {
      return node_opcua_types_2.CallMethodRequest;
    } });
    Object.defineProperty(exports2, "CallRequest", { enumerable: true, get: function() {
      return node_opcua_types_2.CallRequest;
    } });
    Object.defineProperty(exports2, "CallMethodResult", { enumerable: true, get: function() {
      return node_opcua_types_2.CallMethodResult;
    } });
    Object.defineProperty(exports2, "CallResponse", { enumerable: true, get: function() {
      return node_opcua_types_2.CallResponse;
    } });
    function _coerceToNodeId(n) {
      const dataType = n;
      if (!dataType) {
        return new node_opcua_nodeid_1.NodeId();
      }
      if (typeof dataType === "string") {
        return (0, node_opcua_nodeid_1.resolveNodeId)(dataType);
      }
      if (dataType instanceof node_opcua_nodeid_1.NodeId) {
        return dataType;
      }
      if (Object.prototype.hasOwnProperty.call(dataType, "value")) {
        const a = dataType;
        return (0, node_opcua_nodeid_1.coerceNodeId)(a.value, a.namespace);
      }
      (0, node_opcua_assert_1.assert)(typeof dataType === "number");
      return (0, node_opcua_nodeid_1.coerceNodeId)(dataType);
    }
    function constructHookArgument(_options) {
      const options = _options || { valueRank: -1, dataType: node_opcua_variant_1.DataType.Null };
      const dataType = _coerceToNodeId(options.dataType || node_opcua_variant_1.DataType.Null);
      (0, node_opcua_variant_1.verifyRankAndDimensions)(options);
      return { ...options, dataType };
    }
    node_opcua_types_1.Argument.schema.constructHook = constructHookArgument;
  }
});

// node_modules/node-opcua-service-call/dist/index.js
var require_dist41 = __commonJS({
  "node_modules/node-opcua-service-call/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_imports(), exports2);
  }
});

// node_modules/node-opcua-service-session/dist/SessionAuthenticationToken.js
var require_SessionAuthenticationToken = __commonJS({
  "node_modules/node-opcua-service-session/dist/SessionAuthenticationToken.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.schemaSessionAuthenticationToken = void 0;
    var node_opcua_factory_1 = require_dist26();
    exports2.schemaSessionAuthenticationToken = {
      name: "SessionAuthenticationToken",
      subType: "NodeId"
    };
    (0, node_opcua_factory_1.registerBasicType)(exports2.schemaSessionAuthenticationToken);
  }
});

// node_modules/node-opcua-service-session/dist/index.js
var require_dist42 = __commonJS({
  "node_modules/node-opcua-service-session/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SignedSoftwareCertificate = exports2.IssuedIdentityToken = exports2.X509IdentityToken = exports2.UserNameIdentityToken = exports2.AnonymousIdentityToken = exports2.CancelResponse = exports2.CancelRequest = exports2.CloseSessionResponse = exports2.CloseSessionRequest = exports2.ActivateSessionResponse = exports2.ActivateSessionRequest = exports2.CreateSessionResponse = exports2.CreateSessionRequest = void 0;
    var node_opcua_types_1 = require_dist32();
    Object.defineProperty(exports2, "CreateSessionRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.CreateSessionRequest;
    } });
    Object.defineProperty(exports2, "CreateSessionResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.CreateSessionResponse;
    } });
    Object.defineProperty(exports2, "ActivateSessionRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.ActivateSessionRequest;
    } });
    Object.defineProperty(exports2, "ActivateSessionResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.ActivateSessionResponse;
    } });
    Object.defineProperty(exports2, "CloseSessionRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.CloseSessionRequest;
    } });
    Object.defineProperty(exports2, "CloseSessionResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.CloseSessionResponse;
    } });
    Object.defineProperty(exports2, "CancelRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.CancelRequest;
    } });
    Object.defineProperty(exports2, "CancelResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.CancelResponse;
    } });
    Object.defineProperty(exports2, "AnonymousIdentityToken", { enumerable: true, get: function() {
      return node_opcua_types_1.AnonymousIdentityToken;
    } });
    Object.defineProperty(exports2, "UserNameIdentityToken", { enumerable: true, get: function() {
      return node_opcua_types_1.UserNameIdentityToken;
    } });
    Object.defineProperty(exports2, "X509IdentityToken", { enumerable: true, get: function() {
      return node_opcua_types_1.X509IdentityToken;
    } });
    Object.defineProperty(exports2, "IssuedIdentityToken", { enumerable: true, get: function() {
      return node_opcua_types_1.IssuedIdentityToken;
    } });
    Object.defineProperty(exports2, "SignedSoftwareCertificate", { enumerable: true, get: function() {
      return node_opcua_types_1.SignedSoftwareCertificate;
    } });
    __exportStar3(require_SessionAuthenticationToken(), exports2);
  }
});

// node_modules/node-opcua-service-register-node/dist/index.js
var require_dist43 = __commonJS({
  "node_modules/node-opcua-service-register-node/dist/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UnregisterNodesResponse = exports2.UnregisterNodesRequest = exports2.RegisterNodesResponse = exports2.RegisterNodesRequest = void 0;
    var node_opcua_types_1 = require_dist32();
    Object.defineProperty(exports2, "RegisterNodesRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.RegisterNodesRequest;
    } });
    Object.defineProperty(exports2, "RegisterNodesResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.RegisterNodesResponse;
    } });
    Object.defineProperty(exports2, "UnregisterNodesRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.UnregisterNodesRequest;
    } });
    Object.defineProperty(exports2, "UnregisterNodesResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.UnregisterNodesResponse;
    } });
  }
});

// node_modules/node-opcua-service-endpoints/dist/index.js
var require_dist44 = __commonJS({
  "node_modules/node-opcua-service-endpoints/dist/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UserTokenType = exports2.GetEndpointsResponse = exports2.GetEndpointsRequest = exports2.UserIdentityToken = exports2.EndpointDescription = exports2.UserTokenPolicy = exports2.ApplicationDescription = exports2.ApplicationType = void 0;
    var node_opcua_types_1 = require_dist32();
    Object.defineProperty(exports2, "ApplicationType", { enumerable: true, get: function() {
      return node_opcua_types_1.ApplicationType;
    } });
    Object.defineProperty(exports2, "ApplicationDescription", { enumerable: true, get: function() {
      return node_opcua_types_1.ApplicationDescription;
    } });
    Object.defineProperty(exports2, "UserTokenPolicy", { enumerable: true, get: function() {
      return node_opcua_types_1.UserTokenPolicy;
    } });
    Object.defineProperty(exports2, "EndpointDescription", { enumerable: true, get: function() {
      return node_opcua_types_1.EndpointDescription;
    } });
    Object.defineProperty(exports2, "UserIdentityToken", { enumerable: true, get: function() {
      return node_opcua_types_1.UserIdentityToken;
    } });
    Object.defineProperty(exports2, "GetEndpointsRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.GetEndpointsRequest;
    } });
    Object.defineProperty(exports2, "GetEndpointsResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.GetEndpointsResponse;
    } });
    Object.defineProperty(exports2, "UserTokenType", { enumerable: true, get: function() {
      return node_opcua_types_1.UserTokenType;
    } });
  }
});

// node_modules/node-opcua-service-subscription/dist/deadband_checker.js
var require_deadband_checker = __commonJS({
  "node_modules/node-opcua-service-subscription/dist/deadband_checker.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isOutsideDeadbandPercent = exports2.isOutsideDeadbandAbsolute = exports2.isOutsideDeadbandNone = exports2.DeadbandType = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_variant_1 = require_dist28();
    var DeadbandType;
    (function(DeadbandType2) {
      DeadbandType2[DeadbandType2["None"] = 0] = "None";
      DeadbandType2[DeadbandType2["Absolute"] = 1] = "Absolute";
      DeadbandType2[DeadbandType2["Percent"] = 2] = "Percent";
      DeadbandType2[DeadbandType2["Invalid"] = 4096] = "Invalid";
    })(DeadbandType || (exports2.DeadbandType = DeadbandType = {}));
    function _isOutsideDeadbandScalar(value1, value2, dataType, absoluteDeadband) {
      let diff;
      if (dataType === node_opcua_variant_1.DataType.UInt64 || dataType === node_opcua_variant_1.DataType.Int64) {
        if (!(value1 instanceof Array && value2 instanceof Array)) {
          throw new Error("Invalid");
        }
        const h1 = value1[0];
        const h2 = value2[0];
        if (h1 !== h2) {
          diff = (h1 - h2) * 4294967295;
          if (Math.abs(diff) > absoluteDeadband) {
            return true;
          }
        }
        diff = value1[1] - value2[1];
        (0, node_opcua_assert_1.assert)(typeof diff === "number" && isFinite(diff));
        return Math.abs(diff) > absoluteDeadband;
      }
      if (!(typeof value1 === "number" && typeof value2 === "number")) {
        throw new Error("Invalid value in _isOutsideDeadbandScalar > expecting number only but got " + typeof value1 + " " + typeof value2);
      }
      diff = value2 - value1;
      (0, node_opcua_assert_1.assert)(typeof diff === "number" && isFinite(diff));
      return Math.abs(diff) > absoluteDeadband;
    }
    function isOutsideDeadbandVariant(v1, v2, absoluteDeadBand) {
      (0, node_opcua_assert_1.assert)(isFinite(absoluteDeadBand));
      if (v1.arrayType === node_opcua_variant_1.VariantArrayType.Array || v1.arrayType === node_opcua_variant_1.VariantArrayType.Matrix) {
        if (v1.dataType !== v2.dataType) {
          return true;
        }
        if (v1.value.length !== v2.value.length) {
          return true;
        }
        const n = v1.value.length;
        let i = 0;
        for (i = 0; i < n; i++) {
          if (_isOutsideDeadbandScalar(v1.value[i], v2.value[i], v1.dataType, absoluteDeadBand)) {
            return true;
          }
        }
        return false;
      } else {
        (0, node_opcua_assert_1.assert)(v1.arrayType === node_opcua_variant_1.VariantArrayType.Scalar);
        if (v1.dataType !== v2.dataType) {
          return true;
        }
        return _isOutsideDeadbandScalar(v1.value, v2.value, v1.dataType, absoluteDeadBand);
      }
    }
    function isOutsideDeadbandNone(variant1, variant2) {
      return variant1.value !== variant2.value;
    }
    exports2.isOutsideDeadbandNone = isOutsideDeadbandNone;
    function isOutsideDeadbandAbsolute(variant1, variant2, deadbandValue) {
      return isOutsideDeadbandVariant(variant1, variant2, deadbandValue);
    }
    exports2.isOutsideDeadbandAbsolute = isOutsideDeadbandAbsolute;
    function isOutsideDeadbandPercent(variant1, variant2, deadbandValuePercent, range) {
      (0, node_opcua_assert_1.assert)(deadbandValuePercent >= 0 && deadbandValuePercent <= 100);
      const valueRange = Math.abs(range.high - range.low);
      const deadBandValueAbsolute = deadbandValuePercent / 100 * valueRange;
      return isOutsideDeadbandAbsolute(variant1, variant2, deadBandValueAbsolute);
    }
    exports2.isOutsideDeadbandPercent = isOutsideDeadbandPercent;
  }
});

// node_modules/node-opcua-service-subscription/dist/index.js
var require_dist45 = __commonJS({
  "node_modules/node-opcua-service-subscription/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.TransferSubscriptionsResponse = exports2.TransferSubscriptionsRequest = exports2.TransferResult = exports2.SetTriggeringResponse = exports2.SetTriggeringRequest = exports2.AggregateFilter = exports2.DataChangeFilter = exports2.EventFieldList = exports2.ContentFilterElementResult = exports2.ContentFilterResult = exports2.EventFilterResult = exports2.SetMonitoringModeResponse = exports2.SetMonitoringModeRequest = exports2.ModifyMonitoredItemsResponse = exports2.ModifyMonitoredItemsRequest = exports2.MonitoredItemModifyResult = exports2.MonitoredItemModifyRequest = exports2.MonitoredItemNotification = exports2.DeleteSubscriptionsResponse = exports2.DeleteSubscriptionsRequest = exports2.SetPublishingModeResponse = exports2.SetPublishingModeRequest = exports2.DeleteMonitoredItemsResponse = exports2.DeleteMonitoredItemsRequest = exports2.RepublishResponse = exports2.RepublishRequest = exports2.PublishResponse = exports2.EventNotificationList = exports2.StatusChangeNotification = exports2.DataChangeNotification = exports2.NotificationMessage = exports2.PublishRequest = exports2.SubscriptionAcknowledgement = exports2.CreateMonitoredItemsResponse = exports2.CreateMonitoredItemsRequest = exports2.MonitoredItemCreateResult = exports2.MonitoredItemCreateRequest = exports2.MonitoringParameters = exports2.ModifySubscriptionResponse = exports2.ModifySubscriptionRequest = exports2.CreateSubscriptionResponse = exports2.CreateSubscriptionRequest = exports2.DataChangeTrigger = exports2.MonitoringMode = exports2.NotificationData = void 0;
    var node_opcua_types_1 = require_dist32();
    Object.defineProperty(exports2, "NotificationData", { enumerable: true, get: function() {
      return node_opcua_types_1.NotificationData;
    } });
    Object.defineProperty(exports2, "MonitoringMode", { enumerable: true, get: function() {
      return node_opcua_types_1.MonitoringMode;
    } });
    Object.defineProperty(exports2, "DataChangeTrigger", { enumerable: true, get: function() {
      return node_opcua_types_1.DataChangeTrigger;
    } });
    Object.defineProperty(exports2, "CreateSubscriptionRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.CreateSubscriptionRequest;
    } });
    Object.defineProperty(exports2, "CreateSubscriptionResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.CreateSubscriptionResponse;
    } });
    Object.defineProperty(exports2, "ModifySubscriptionRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.ModifySubscriptionRequest;
    } });
    Object.defineProperty(exports2, "ModifySubscriptionResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.ModifySubscriptionResponse;
    } });
    Object.defineProperty(exports2, "MonitoringParameters", { enumerable: true, get: function() {
      return node_opcua_types_1.MonitoringParameters;
    } });
    Object.defineProperty(exports2, "MonitoredItemCreateRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.MonitoredItemCreateRequest;
    } });
    Object.defineProperty(exports2, "MonitoredItemCreateResult", { enumerable: true, get: function() {
      return node_opcua_types_1.MonitoredItemCreateResult;
    } });
    Object.defineProperty(exports2, "CreateMonitoredItemsRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.CreateMonitoredItemsRequest;
    } });
    Object.defineProperty(exports2, "CreateMonitoredItemsResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.CreateMonitoredItemsResponse;
    } });
    Object.defineProperty(exports2, "SubscriptionAcknowledgement", { enumerable: true, get: function() {
      return node_opcua_types_1.SubscriptionAcknowledgement;
    } });
    Object.defineProperty(exports2, "PublishRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.PublishRequest;
    } });
    Object.defineProperty(exports2, "NotificationMessage", { enumerable: true, get: function() {
      return node_opcua_types_1.NotificationMessage;
    } });
    Object.defineProperty(exports2, "DataChangeNotification", { enumerable: true, get: function() {
      return node_opcua_types_1.DataChangeNotification;
    } });
    Object.defineProperty(exports2, "StatusChangeNotification", { enumerable: true, get: function() {
      return node_opcua_types_1.StatusChangeNotification;
    } });
    Object.defineProperty(exports2, "EventNotificationList", { enumerable: true, get: function() {
      return node_opcua_types_1.EventNotificationList;
    } });
    Object.defineProperty(exports2, "PublishResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.PublishResponse;
    } });
    Object.defineProperty(exports2, "RepublishRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.RepublishRequest;
    } });
    Object.defineProperty(exports2, "RepublishResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.RepublishResponse;
    } });
    Object.defineProperty(exports2, "DeleteMonitoredItemsRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.DeleteMonitoredItemsRequest;
    } });
    Object.defineProperty(exports2, "DeleteMonitoredItemsResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.DeleteMonitoredItemsResponse;
    } });
    Object.defineProperty(exports2, "SetPublishingModeRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.SetPublishingModeRequest;
    } });
    Object.defineProperty(exports2, "SetPublishingModeResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.SetPublishingModeResponse;
    } });
    Object.defineProperty(exports2, "DeleteSubscriptionsRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.DeleteSubscriptionsRequest;
    } });
    Object.defineProperty(exports2, "DeleteSubscriptionsResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.DeleteSubscriptionsResponse;
    } });
    Object.defineProperty(exports2, "MonitoredItemNotification", { enumerable: true, get: function() {
      return node_opcua_types_1.MonitoredItemNotification;
    } });
    Object.defineProperty(exports2, "MonitoredItemModifyRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.MonitoredItemModifyRequest;
    } });
    Object.defineProperty(exports2, "MonitoredItemModifyResult", { enumerable: true, get: function() {
      return node_opcua_types_1.MonitoredItemModifyResult;
    } });
    Object.defineProperty(exports2, "ModifyMonitoredItemsRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.ModifyMonitoredItemsRequest;
    } });
    Object.defineProperty(exports2, "ModifyMonitoredItemsResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.ModifyMonitoredItemsResponse;
    } });
    Object.defineProperty(exports2, "SetMonitoringModeRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.SetMonitoringModeRequest;
    } });
    Object.defineProperty(exports2, "SetMonitoringModeResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.SetMonitoringModeResponse;
    } });
    Object.defineProperty(exports2, "EventFilterResult", { enumerable: true, get: function() {
      return node_opcua_types_1.EventFilterResult;
    } });
    Object.defineProperty(exports2, "ContentFilterResult", { enumerable: true, get: function() {
      return node_opcua_types_1.ContentFilterResult;
    } });
    Object.defineProperty(exports2, "ContentFilterElementResult", { enumerable: true, get: function() {
      return node_opcua_types_1.ContentFilterElementResult;
    } });
    Object.defineProperty(exports2, "EventFieldList", { enumerable: true, get: function() {
      return node_opcua_types_1.EventFieldList;
    } });
    Object.defineProperty(exports2, "DataChangeFilter", { enumerable: true, get: function() {
      return node_opcua_types_1.DataChangeFilter;
    } });
    Object.defineProperty(exports2, "AggregateFilter", { enumerable: true, get: function() {
      return node_opcua_types_1.AggregateFilter;
    } });
    Object.defineProperty(exports2, "SetTriggeringRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.SetTriggeringRequest;
    } });
    Object.defineProperty(exports2, "SetTriggeringResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.SetTriggeringResponse;
    } });
    Object.defineProperty(exports2, "TransferResult", { enumerable: true, get: function() {
      return node_opcua_types_1.TransferResult;
    } });
    Object.defineProperty(exports2, "TransferSubscriptionsRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.TransferSubscriptionsRequest;
    } });
    Object.defineProperty(exports2, "TransferSubscriptionsResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.TransferSubscriptionsResponse;
    } });
    __exportStar3(require_deadband_checker(), exports2);
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_types_2 = require_dist32();
    (0, node_opcua_assert_1.assert)(node_opcua_types_2.PublishResponse.schema.fields[1].name === "subscriptionId");
    node_opcua_types_2.PublishResponse.schema.fields[1].defaultValue = 4294967295;
    (0, node_opcua_assert_1.assert)(node_opcua_types_2.MonitoringParameters.schema.fields[0].name === "clientHandle");
    node_opcua_types_2.MonitoringParameters.schema.fields[0].defaultValue = 4294967295;
  }
});

// node_modules/node-opcua-service-discovery/dist/server_capabilities.js
var require_server_capabilities = __commonJS({
  "node_modules/node-opcua-service-discovery/dist/server_capabilities.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.serverCapabilities = void 0;
    exports2.serverCapabilities = [
      "NA",
      // No capability information is available. Cannot be used in combination with any other capability.
      "DA",
      // Provides current data.
      "HD",
      // Provides historical data.
      "AC",
      // Provides alarms and conditions that may require operator interaction.
      "HE",
      // Provides historical alarms and events.
      "GDS",
      // Supports the Global Discovery Server information model.
      "LDS",
      // Only supports the Discovery Services. Cannot be used in combination with any other capability.
      "DI",
      // Supports the Device Integration (DI) information model (see DI).
      "ADI",
      // Supports the Analyser Device Integration (ADI) information model (see ADI).
      "FDI",
      // Supports the Field Device Integration (FDI) information model (see FDI).
      "FDIC",
      // Supports the Field Device Integration (FDI) Communication Server information model (see FDI).
      "PLC",
      // Supports the PLCopen information model (see PLCopen).
      "S95",
      // Supports the ISA95 information model (see ISA-95).
      // new in 1.04
      "RCP",
      // Supports the reverse connect capabilities defined in Part 6.
      "PUB",
      // Supports the Publisher capabilities defined in Part 14.
      "SUB"
      // Supports the Publisher capabilities defined in Part 14.
    ];
  }
});

// node_modules/node-opcua-object-registry/dist/objectRegistry.js
var require_objectRegistry = __commonJS({
  "node_modules/node-opcua-object-registry/dist/objectRegistry.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ObjectRegistry = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_debug_1 = require_dist24();
    var gRegistries = [];
    var hashCounter = 1;
    var ObjectRegistry = class _ObjectRegistry {
      constructor() {
        this._cache = {};
        gRegistries.push(this);
      }
      getClassName() {
        return this._objectTypeName ? this._objectTypeName : "<???>";
      }
      register(obj) {
        if (!this._objectTypeName) {
          this._objectTypeName = obj.constructor.name;
        }
        if (!obj._____hash) {
          obj._____hash = hashCounter;
          hashCounter += 1;
          this._cache[obj._____hash] = obj;
        }
        if (_ObjectRegistry.doDebug) {
          obj._____trace = (0, node_opcua_debug_1.traceFromThisProjectOnly)();
        }
      }
      unregister(obj) {
        this._cache[obj._____hash] = null;
        obj._____trace = null;
        delete this._cache[obj._____hash];
      }
      count() {
        return Object.keys(this._cache).length;
      }
      toString() {
        const className = this.getClassName();
        let str = " className :" + className + " found => " + this.count() + " object leaking\n";
        for (const obj of Object.values(this._cache)) {
          str += obj.constructor.name + " " + obj.toString() + "\n";
        }
        if (_ObjectRegistry.doDebug) {
          for (const [key, cachedObject] of Object.entries(this._cache)) {
            (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(cachedObject, "_____trace"));
            str += "   " + key + cachedObject._____trace + "\n";
          }
        }
        return str;
      }
    };
    exports2.ObjectRegistry = ObjectRegistry;
    ObjectRegistry.doDebug = false;
    ObjectRegistry.registries = gRegistries;
    ObjectRegistry.doDebug = typeof process === "object" ? process?.env?.NODEOPCUA_REGISTRY?.match(/DEBUG/) ? true : false : false;
    if (ObjectRegistry.doDebug) {
      console.log("ObjectRegistry.doDebug = ", ObjectRegistry.doDebug);
    }
  }
});

// node_modules/node-opcua-object-registry/dist/index.js
var require_dist46 = __commonJS({
  "node_modules/node-opcua-object-registry/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_objectRegistry(), exports2);
  }
});

// node_modules/array-flatten/array-flatten.js
var require_array_flatten = __commonJS({
  "node_modules/array-flatten/array-flatten.js"(exports2, module2) {
    "use strict";
    module2.exports = flatten;
    module2.exports.from = flattenFrom;
    module2.exports.depth = flattenDepth;
    module2.exports.fromDepth = flattenFromDepth;
    function flatten(array) {
      if (!Array.isArray(array)) {
        throw new TypeError("Expected value to be an array");
      }
      return flattenFrom(array);
    }
    function flattenFrom(array) {
      return flattenDown(array, []);
    }
    function flattenDepth(array, depth) {
      if (!Array.isArray(array)) {
        throw new TypeError("Expected value to be an array");
      }
      return flattenFromDepth(array, depth);
    }
    function flattenFromDepth(array, depth) {
      if (typeof depth !== "number") {
        throw new TypeError("Expected the depth to be a number");
      }
      return flattenDownDepth(array, [], depth);
    }
    function flattenDown(array, result2) {
      for (var i = 0; i < array.length; i++) {
        var value = array[i];
        if (Array.isArray(value)) {
          flattenDown(value, result2);
        } else {
          result2.push(value);
        }
      }
      return result2;
    }
    function flattenDownDepth(array, result2, depth) {
      depth--;
      for (var i = 0; i < array.length; i++) {
        var value = array[i];
        if (depth > -1 && Array.isArray(value)) {
          flattenDownDepth(value, result2, depth);
        } else {
          result2.push(value);
        }
      }
      return result2;
    }
  }
});

// node_modules/dns-equal/index.js
var require_dns_equal = __commonJS({
  "node_modules/dns-equal/index.js"(exports2, module2) {
    "use strict";
    var r = /[A-Z]/g;
    module2.exports = function(a, b) {
      a = a.replace(r, replacer);
      b = b.replace(r, replacer);
      return a === b;
    };
    function replacer(m2) {
      return m2.toLowerCase();
    }
  }
});

// node_modules/sterfive-bonjour-service/dist/lib/service-types.js
var require_service_types = __commonJS({
  "node_modules/sterfive-bonjour-service/dist/lib/service-types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.toType = exports2.toString = void 0;
    var Prefix = (name) => {
      return "_" + name;
    };
    var AllowedProp = (key) => {
      let keys = ["name", "protocol", "subtypes"];
      return keys.includes(key);
    };
    var toString = (data) => {
      let formatted = {
        name: data.name,
        protocol: data.protocol,
        subtypes: data.subtypes
      };
      let entries = Object.entries(formatted);
      return entries.filter(([key, val]) => AllowedProp(key) && val !== void 0).reduce((prev, [key, val]) => {
        switch (typeof val) {
          case "object":
            val.map((i) => prev.push(Prefix(i)));
            break;
          default:
            prev.push(Prefix(val));
            break;
        }
        return prev;
      }, []).join(".");
    };
    exports2.toString = toString;
    var toType = (string) => {
      const parts = string.split(".");
      for (let i in parts) {
        if (parts[i][0] !== "_")
          continue;
        parts[i] = parts[i].slice(1);
      }
      return {
        name: parts.shift(),
        protocol: parts.shift() || null,
        subtypes: parts
      };
    };
    exports2.toType = toType;
  }
});

// node_modules/sterfive-bonjour-service/dist/lib/dns-txt.js
var require_dns_txt = __commonJS({
  "node_modules/sterfive-bonjour-service/dist/lib/dns-txt.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.DnsTxt = void 0;
    var DnsTxt = class {
      constructor(opts = {}) {
        this.binary = opts ? opts.binary : false;
      }
      /**
       * Encode the KeyValue to buffer
       * @param data
       * @returns
       */
      encode(data = {}) {
        return Object.entries(data).map(([key, value]) => {
          let item = `${key}=${value}`;
          return Buffer.from(item);
        });
      }
      /**
       * Decode the buffer to KeyValue
       * @param buffer
       * @returns
       */
      decode(buffer) {
        const data = {};
        try {
          let format3 = buffer.toString();
          let parts = format3.split(/=(.+)/);
          let key = parts[0];
          let value = parts[1];
          data[key] = value;
        } catch (_) {
        }
        return data;
      }
      /**
       * Decode all buffer items to KeyValye
       * @param buffers
       * @returns
       */
      decodeAll(buffers) {
        return buffers.filter((i) => i.length > 1).map((i) => this.decode(i)).reduce((prev, curr) => {
          const obj = prev;
          let [key] = Object.keys(curr);
          let [value] = Object.values(curr);
          obj[key] = value;
          return obj;
        }, {});
      }
    };
    exports2.DnsTxt = DnsTxt;
    exports2.default = DnsTxt;
  }
});

// node_modules/sterfive-bonjour-service/dist/lib/service.js
var require_service = __commonJS({
  "node_modules/sterfive-bonjour-service/dist/lib/service.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Service = void 0;
    var os_1 = require("os");
    var events_1 = require("events");
    var service_types_1 = require_service_types();
    var dns_txt_1 = __importDefault3(require_dns_txt());
    var TLD = ".local";
    function RecordPTR(service) {
      return {
        name: `${service.type}${TLD}`,
        type: "PTR",
        ttl: 28800,
        data: service.fqdn
      };
    }
    function RecordSRV(service) {
      return {
        name: service.fqdn,
        type: "SRV",
        ttl: 120,
        data: {
          port: service.port,
          target: service.host
        }
      };
    }
    function RecordTXT(service) {
      const txtService = new dns_txt_1.default();
      return {
        name: service.fqdn,
        type: "TXT",
        ttl: 4500,
        data: txtService.encode(service.txt)
      };
    }
    function RecordA(service, ip) {
      return {
        name: service.host,
        type: "A",
        ttl: 120,
        data: ip
      };
    }
    function RecordAAAA(service, ip) {
      return {
        name: service.host,
        type: "AAAA",
        ttl: 120,
        data: ip
      };
    }
    var Service = class extends events_1.EventEmitter {
      constructor(config) {
        super();
        this.probe = true;
        this.published = false;
        this.activated = false;
        this.destroyed = false;
        if (!config.name)
          throw new Error("Required name not given");
        if (!config.type)
          throw new Error("Required type not given");
        if (!config.port)
          throw new Error("Required port not given");
        this.name = config.name;
        this.protocol = config.protocol || "tcp";
        this.type = (0, service_types_1.toString)({ name: config.type, protocol: this.protocol });
        this.port = config.port;
        this.host = config.host || (0, os_1.hostname)();
        this.fqdn = `${this.name}.${this.type}${TLD}`;
        this.txt = config.txt;
        this.subtypes = config.subtypes;
      }
      records() {
        const records = [RecordPTR(this), RecordSRV(this), RecordTXT(this)];
        const ifaces = Object.values((0, os_1.networkInterfaces)());
        for (let iface of ifaces) {
          let addrs = iface;
          for (let addr of addrs) {
            if (addr.internal || addr.mac === "00:00:00:00:00:00")
              continue;
            switch (addr.family) {
              case "IPv4":
                records.push(RecordA(this, addr.address));
                break;
              case "IPv6":
                records.push(RecordAAAA(this, addr.address));
                break;
            }
          }
        }
        return records;
      }
    };
    exports2.Service = Service;
    exports2.default = Service;
  }
});

// node_modules/sterfive-bonjour-service/dist/lib/registry.js
var require_registry3 = __commonJS({
  "node_modules/sterfive-bonjour-service/dist/lib/registry.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Registry = void 0;
    var timers_1 = require("timers");
    var array_flatten_1 = __importDefault3(require_array_flatten());
    var dns_equal_1 = __importDefault3(require_dns_equal());
    var service_1 = __importDefault3(require_service());
    var REANNOUNCE_MAX_MS = 60 * 60 * 1e3;
    var REANNOUNCE_FACTOR = 3;
    var Registry = class {
      constructor(server) {
        this.services = [];
        this.server = server;
      }
      publish(config) {
        function start(service2, registry, opts) {
          if (service2.activated)
            return;
          service2.activated = true;
          registry.services.push(service2);
          if (!(service2 instanceof service_1.default))
            return;
          if (opts.probe) {
            registry.probe(registry.server.mdns, service2, (exists) => {
              if (exists) {
                service2.stop();
                console.log(new Error("Service name is already in use on the network"));
                return;
              }
              registry.announce(registry.server, service2);
            });
          } else {
            registry.announce(registry.server, service2);
          }
        }
        function stop(service2, registry, callback) {
          if (!service2.activated)
            return;
          if (!(service2 instanceof service_1.default))
            return;
          registry.teardown(registry.server, service2, callback);
          const index = registry.services.indexOf(service2);
          if (index !== -1)
            registry.services.splice(index, 1);
        }
        let service = new service_1.default(config);
        service.start = start.bind(null, service, this);
        service.stop = stop.bind(null, service, this);
        service.start({ probe: config.probe !== false });
        return service;
      }
      unpublishAll(callback) {
        this.teardown(this.server, this.services, callback);
        this.services = [];
      }
      destroy() {
        this.services.map((service) => {
          if (service._broadCastTimeout) {
            clearTimeout(service._broadCastTimeout);
            service._broadCastTimeout = void 0;
          }
          service.destroyed = true;
        });
      }
      /**
       * Check if a service name is already in use on the network.
       *
       * Used before announcing the new service.
       *
       * To guard against race conditions where multiple services are started
       * simultaneously on the network, wait a random amount of time (between
       * 0 and 250 ms) before probing.
       *
       */
      probe(mdns, service, callback) {
        let sent = false;
        let retries = 0;
        let timer;
        const send2 = () => {
          if (!service.activated || service.destroyed)
            return;
          mdns.query(service.fqdn, "ANY", function() {
            sent = true;
            timer = (0, timers_1.setTimeout)(++retries < 3 ? send2 : done, 250);
            timer.unref();
          });
        };
        const matchRR = (rr) => {
          return (0, dns_equal_1.default)(rr.name, service.fqdn);
        };
        const onresponse = (packet) => {
          if (!sent)
            return;
          if (packet.answers.some(matchRR) || packet.additionals.some(matchRR))
            done(true);
        };
        const done = (exists) => {
          mdns.removeListener("response", onresponse);
          clearTimeout(timer);
          callback(!!exists);
        };
        mdns.on("response", onresponse);
        (0, timers_1.setTimeout)(send2, Math.random() * 250);
      }
      /**
       * Initial service announcement
       *
       * Used to announce new services when they are first registered.
       *
       * Broadcasts right away, then after 3 seconds, 9 seconds, 27 seconds,
       * and so on, up to a maximum interval of one hour.
       */
      announce(server, service) {
        let delay = 1e3;
        const packet = service.records();
        server.register(packet);
        const broadcast = () => {
          if (!service.activated || service.destroyed)
            return;
          service._broadCastTimeout = void 0;
          server.mdns.respond({ answers: packet }, () => {
            if (!service.published) {
              service.activated = true;
              service.published = true;
              service.emit("up");
            }
            delay = delay * REANNOUNCE_FACTOR;
            if (delay < REANNOUNCE_MAX_MS && !service.destroyed) {
              service._broadCastTimeout = (0, timers_1.setTimeout)(broadcast, delay);
            }
          });
        };
        service._broadCastTimeout = (0, timers_1.setTimeout)(broadcast, 1);
      }
      /**
       * Stop the given services
       *
       * Besides removing a service from the mDNS registry, a "goodbye"
       * message is sent for each service to let the network know about the
       * shutdown.
       */
      teardown(server, serviceOrServices, callback) {
        let services = Array.isArray(serviceOrServices) ? serviceOrServices : [serviceOrServices];
        services = services.filter((service) => service.activated);
        const records = array_flatten_1.default.depth(services.map((service) => {
          service.activated = false;
          const records2 = service.records();
          records2.forEach((record) => {
            record.ttl = 0;
          });
          return records2;
        }), 1);
        if (records.length === 0)
          return callback && callback();
        server.unregister(records);
        server.mdns.respond(records, function() {
          ;
          services.forEach(function(service) {
            service.published = false;
          });
          if (typeof callback === "function") {
            callback.apply(null, arguments);
          }
        });
      }
    };
    exports2.Registry = Registry;
    exports2.default = Registry;
  }
});

// node_modules/fast-deep-equal/es6/index.js
var require_es6 = __commonJS({
  "node_modules/fast-deep-equal/es6/index.js"(exports2, module2) {
    "use strict";
    module2.exports = function equal(a, b) {
      if (a === b)
        return true;
      if (a && b && typeof a == "object" && typeof b == "object") {
        if (a.constructor !== b.constructor)
          return false;
        var length, i, keys;
        if (Array.isArray(a)) {
          length = a.length;
          if (length != b.length)
            return false;
          for (i = length; i-- !== 0; )
            if (!equal(a[i], b[i]))
              return false;
          return true;
        }
        if (a instanceof Map && b instanceof Map) {
          if (a.size !== b.size)
            return false;
          for (i of a.entries())
            if (!b.has(i[0]))
              return false;
          for (i of a.entries())
            if (!equal(i[1], b.get(i[0])))
              return false;
          return true;
        }
        if (a instanceof Set && b instanceof Set) {
          if (a.size !== b.size)
            return false;
          for (i of a.entries())
            if (!b.has(i[0]))
              return false;
          return true;
        }
        if (ArrayBuffer.isView(a) && ArrayBuffer.isView(b)) {
          length = a.length;
          if (length != b.length)
            return false;
          for (i = length; i-- !== 0; )
            if (a[i] !== b[i])
              return false;
          return true;
        }
        if (a.constructor === RegExp)
          return a.source === b.source && a.flags === b.flags;
        if (a.valueOf !== Object.prototype.valueOf)
          return a.valueOf() === b.valueOf();
        if (a.toString !== Object.prototype.toString)
          return a.toString() === b.toString();
        keys = Object.keys(a);
        length = keys.length;
        if (length !== Object.keys(b).length)
          return false;
        for (i = length; i-- !== 0; )
          if (!Object.prototype.hasOwnProperty.call(b, keys[i]))
            return false;
        for (i = length; i-- !== 0; ) {
          var key = keys[i];
          if (!equal(a[key], b[key]))
            return false;
        }
        return true;
      }
      return a !== a && b !== b;
    };
  }
});

// node_modules/dns-packet/types.js
var require_types8 = __commonJS({
  "node_modules/dns-packet/types.js"(exports2) {
    "use strict";
    exports2.toString = function(type) {
      switch (type) {
        case 1:
          return "A";
        case 10:
          return "NULL";
        case 28:
          return "AAAA";
        case 18:
          return "AFSDB";
        case 42:
          return "APL";
        case 257:
          return "CAA";
        case 60:
          return "CDNSKEY";
        case 59:
          return "CDS";
        case 37:
          return "CERT";
        case 5:
          return "CNAME";
        case 49:
          return "DHCID";
        case 32769:
          return "DLV";
        case 39:
          return "DNAME";
        case 48:
          return "DNSKEY";
        case 43:
          return "DS";
        case 55:
          return "HIP";
        case 13:
          return "HINFO";
        case 45:
          return "IPSECKEY";
        case 25:
          return "KEY";
        case 36:
          return "KX";
        case 29:
          return "LOC";
        case 15:
          return "MX";
        case 35:
          return "NAPTR";
        case 2:
          return "NS";
        case 47:
          return "NSEC";
        case 50:
          return "NSEC3";
        case 51:
          return "NSEC3PARAM";
        case 12:
          return "PTR";
        case 46:
          return "RRSIG";
        case 17:
          return "RP";
        case 24:
          return "SIG";
        case 6:
          return "SOA";
        case 99:
          return "SPF";
        case 33:
          return "SRV";
        case 44:
          return "SSHFP";
        case 32768:
          return "TA";
        case 249:
          return "TKEY";
        case 52:
          return "TLSA";
        case 250:
          return "TSIG";
        case 16:
          return "TXT";
        case 252:
          return "AXFR";
        case 251:
          return "IXFR";
        case 41:
          return "OPT";
        case 255:
          return "ANY";
      }
      return "UNKNOWN_" + type;
    };
    exports2.toType = function(name) {
      switch (name.toUpperCase()) {
        case "A":
          return 1;
        case "NULL":
          return 10;
        case "AAAA":
          return 28;
        case "AFSDB":
          return 18;
        case "APL":
          return 42;
        case "CAA":
          return 257;
        case "CDNSKEY":
          return 60;
        case "CDS":
          return 59;
        case "CERT":
          return 37;
        case "CNAME":
          return 5;
        case "DHCID":
          return 49;
        case "DLV":
          return 32769;
        case "DNAME":
          return 39;
        case "DNSKEY":
          return 48;
        case "DS":
          return 43;
        case "HIP":
          return 55;
        case "HINFO":
          return 13;
        case "IPSECKEY":
          return 45;
        case "KEY":
          return 25;
        case "KX":
          return 36;
        case "LOC":
          return 29;
        case "MX":
          return 15;
        case "NAPTR":
          return 35;
        case "NS":
          return 2;
        case "NSEC":
          return 47;
        case "NSEC3":
          return 50;
        case "NSEC3PARAM":
          return 51;
        case "PTR":
          return 12;
        case "RRSIG":
          return 46;
        case "RP":
          return 17;
        case "SIG":
          return 24;
        case "SOA":
          return 6;
        case "SPF":
          return 99;
        case "SRV":
          return 33;
        case "SSHFP":
          return 44;
        case "TA":
          return 32768;
        case "TKEY":
          return 249;
        case "TLSA":
          return 52;
        case "TSIG":
          return 250;
        case "TXT":
          return 16;
        case "AXFR":
          return 252;
        case "IXFR":
          return 251;
        case "OPT":
          return 41;
        case "ANY":
          return 255;
        case "*":
          return 255;
      }
      if (name.toUpperCase().startsWith("UNKNOWN_"))
        return parseInt(name.slice(8));
      return 0;
    };
  }
});

// node_modules/dns-packet/rcodes.js
var require_rcodes = __commonJS({
  "node_modules/dns-packet/rcodes.js"(exports2) {
    "use strict";
    exports2.toString = function(rcode) {
      switch (rcode) {
        case 0:
          return "NOERROR";
        case 1:
          return "FORMERR";
        case 2:
          return "SERVFAIL";
        case 3:
          return "NXDOMAIN";
        case 4:
          return "NOTIMP";
        case 5:
          return "REFUSED";
        case 6:
          return "YXDOMAIN";
        case 7:
          return "YXRRSET";
        case 8:
          return "NXRRSET";
        case 9:
          return "NOTAUTH";
        case 10:
          return "NOTZONE";
        case 11:
          return "RCODE_11";
        case 12:
          return "RCODE_12";
        case 13:
          return "RCODE_13";
        case 14:
          return "RCODE_14";
        case 15:
          return "RCODE_15";
      }
      return "RCODE_" + rcode;
    };
    exports2.toRcode = function(code) {
      switch (code.toUpperCase()) {
        case "NOERROR":
          return 0;
        case "FORMERR":
          return 1;
        case "SERVFAIL":
          return 2;
        case "NXDOMAIN":
          return 3;
        case "NOTIMP":
          return 4;
        case "REFUSED":
          return 5;
        case "YXDOMAIN":
          return 6;
        case "YXRRSET":
          return 7;
        case "NXRRSET":
          return 8;
        case "NOTAUTH":
          return 9;
        case "NOTZONE":
          return 10;
        case "RCODE_11":
          return 11;
        case "RCODE_12":
          return 12;
        case "RCODE_13":
          return 13;
        case "RCODE_14":
          return 14;
        case "RCODE_15":
          return 15;
      }
      return 0;
    };
  }
});

// node_modules/dns-packet/opcodes.js
var require_opcodes = __commonJS({
  "node_modules/dns-packet/opcodes.js"(exports2) {
    "use strict";
    exports2.toString = function(opcode) {
      switch (opcode) {
        case 0:
          return "QUERY";
        case 1:
          return "IQUERY";
        case 2:
          return "STATUS";
        case 3:
          return "OPCODE_3";
        case 4:
          return "NOTIFY";
        case 5:
          return "UPDATE";
        case 6:
          return "OPCODE_6";
        case 7:
          return "OPCODE_7";
        case 8:
          return "OPCODE_8";
        case 9:
          return "OPCODE_9";
        case 10:
          return "OPCODE_10";
        case 11:
          return "OPCODE_11";
        case 12:
          return "OPCODE_12";
        case 13:
          return "OPCODE_13";
        case 14:
          return "OPCODE_14";
        case 15:
          return "OPCODE_15";
      }
      return "OPCODE_" + opcode;
    };
    exports2.toOpcode = function(code) {
      switch (code.toUpperCase()) {
        case "QUERY":
          return 0;
        case "IQUERY":
          return 1;
        case "STATUS":
          return 2;
        case "OPCODE_3":
          return 3;
        case "NOTIFY":
          return 4;
        case "UPDATE":
          return 5;
        case "OPCODE_6":
          return 6;
        case "OPCODE_7":
          return 7;
        case "OPCODE_8":
          return 8;
        case "OPCODE_9":
          return 9;
        case "OPCODE_10":
          return 10;
        case "OPCODE_11":
          return 11;
        case "OPCODE_12":
          return 12;
        case "OPCODE_13":
          return 13;
        case "OPCODE_14":
          return 14;
        case "OPCODE_15":
          return 15;
      }
      return 0;
    };
  }
});

// node_modules/dns-packet/classes.js
var require_classes = __commonJS({
  "node_modules/dns-packet/classes.js"(exports2) {
    "use strict";
    exports2.toString = function(klass) {
      switch (klass) {
        case 1:
          return "IN";
        case 2:
          return "CS";
        case 3:
          return "CH";
        case 4:
          return "HS";
        case 255:
          return "ANY";
      }
      return "UNKNOWN_" + klass;
    };
    exports2.toClass = function(name) {
      switch (name.toUpperCase()) {
        case "IN":
          return 1;
        case "CS":
          return 2;
        case "CH":
          return 3;
        case "HS":
          return 4;
        case "ANY":
          return 255;
      }
      return 0;
    };
  }
});

// node_modules/dns-packet/optioncodes.js
var require_optioncodes = __commonJS({
  "node_modules/dns-packet/optioncodes.js"(exports2) {
    "use strict";
    exports2.toString = function(type) {
      switch (type) {
        case 1:
          return "LLQ";
        case 2:
          return "UL";
        case 3:
          return "NSID";
        case 5:
          return "DAU";
        case 6:
          return "DHU";
        case 7:
          return "N3U";
        case 8:
          return "CLIENT_SUBNET";
        case 9:
          return "EXPIRE";
        case 10:
          return "COOKIE";
        case 11:
          return "TCP_KEEPALIVE";
        case 12:
          return "PADDING";
        case 13:
          return "CHAIN";
        case 14:
          return "KEY_TAG";
        case 26946:
          return "DEVICEID";
      }
      if (type < 0) {
        return null;
      }
      return `OPTION_${type}`;
    };
    exports2.toCode = function(name) {
      if (typeof name === "number") {
        return name;
      }
      if (!name) {
        return -1;
      }
      switch (name.toUpperCase()) {
        case "OPTION_0":
          return 0;
        case "LLQ":
          return 1;
        case "UL":
          return 2;
        case "NSID":
          return 3;
        case "OPTION_4":
          return 4;
        case "DAU":
          return 5;
        case "DHU":
          return 6;
        case "N3U":
          return 7;
        case "CLIENT_SUBNET":
          return 8;
        case "EXPIRE":
          return 9;
        case "COOKIE":
          return 10;
        case "TCP_KEEPALIVE":
          return 11;
        case "PADDING":
          return 12;
        case "CHAIN":
          return 13;
        case "KEY_TAG":
          return 14;
        case "DEVICEID":
          return 26946;
        case "OPTION_65535":
          return 65535;
      }
      const m2 = name.match(/_(\d+)$/);
      if (m2) {
        return parseInt(m2[1], 10);
      }
      return -1;
    };
  }
});

// node_modules/@leichtgewicht/ip-codec/index.cjs
var require_ip_codec = __commonJS({
  "node_modules/@leichtgewicht/ip-codec/index.cjs"(exports2, module2) {
    var ipCodec = function(exports3) {
      "use strict";
      Object.defineProperty(exports3, "__esModule", {
        value: true
      });
      exports3.decode = decode;
      exports3.encode = encode;
      exports3.familyOf = familyOf;
      exports3.name = void 0;
      exports3.sizeOf = sizeOf;
      exports3.v6 = exports3.v4 = void 0;
      const v4Regex = /^(\d{1,3}\.){3,3}\d{1,3}$/;
      const v4Size = 4;
      const v6Regex = /^(::)?(((\d{1,3}\.){3}(\d{1,3}){1})?([0-9a-f]){0,4}:{0,2}){1,8}(::)?$/i;
      const v6Size = 16;
      const v4 = {
        name: "v4",
        size: v4Size,
        isFormat: (ip) => v4Regex.test(ip),
        encode(ip, buff, offset) {
          offset = ~~offset;
          buff = buff || new Uint8Array(offset + v4Size);
          const max = ip.length;
          let n = 0;
          for (let i = 0; i < max; ) {
            const c2 = ip.charCodeAt(i++);
            if (c2 === 46) {
              buff[offset++] = n;
              n = 0;
            } else {
              n = n * 10 + (c2 - 48);
            }
          }
          buff[offset] = n;
          return buff;
        },
        decode(buff, offset) {
          offset = ~~offset;
          return `${buff[offset++]}.${buff[offset++]}.${buff[offset++]}.${buff[offset]}`;
        }
      };
      exports3.v4 = v4;
      const v6 = {
        name: "v6",
        size: v6Size,
        isFormat: (ip) => ip.length > 0 && v6Regex.test(ip),
        encode(ip, buff, offset) {
          offset = ~~offset;
          let end = offset + v6Size;
          let fill = -1;
          let hexN = 0;
          let decN = 0;
          let prevColon = true;
          let useDec = false;
          buff = buff || new Uint8Array(offset + v6Size);
          for (let i = 0; i < ip.length; i++) {
            let c2 = ip.charCodeAt(i);
            if (c2 === 58) {
              if (prevColon) {
                if (fill !== -1) {
                  if (offset < end)
                    buff[offset] = 0;
                  if (offset < end - 1)
                    buff[offset + 1] = 0;
                  offset += 2;
                } else if (offset < end) {
                  fill = offset;
                }
              } else {
                if (useDec === true) {
                  if (offset < end)
                    buff[offset] = decN;
                  offset++;
                } else {
                  if (offset < end)
                    buff[offset] = hexN >> 8;
                  if (offset < end - 1)
                    buff[offset + 1] = hexN & 255;
                  offset += 2;
                }
                hexN = 0;
                decN = 0;
              }
              prevColon = true;
              useDec = false;
            } else if (c2 === 46) {
              if (offset < end)
                buff[offset] = decN;
              offset++;
              decN = 0;
              hexN = 0;
              prevColon = false;
              useDec = true;
            } else {
              prevColon = false;
              if (c2 >= 97) {
                c2 -= 87;
              } else if (c2 >= 65) {
                c2 -= 55;
              } else {
                c2 -= 48;
                decN = decN * 10 + c2;
              }
              hexN = (hexN << 4) + c2;
            }
          }
          if (prevColon === false) {
            if (useDec === true) {
              if (offset < end)
                buff[offset] = decN;
              offset++;
            } else {
              if (offset < end)
                buff[offset] = hexN >> 8;
              if (offset < end - 1)
                buff[offset + 1] = hexN & 255;
              offset += 2;
            }
          } else if (fill === 0) {
            if (offset < end)
              buff[offset] = 0;
            if (offset < end - 1)
              buff[offset + 1] = 0;
            offset += 2;
          } else if (fill !== -1) {
            offset += 2;
            for (let i = Math.min(offset - 1, end - 1); i >= fill + 2; i--) {
              buff[i] = buff[i - 2];
            }
            buff[fill] = 0;
            buff[fill + 1] = 0;
            fill = offset;
          }
          if (fill !== offset && fill !== -1) {
            if (offset > end - 2) {
              offset = end - 2;
            }
            while (end > fill) {
              buff[--end] = offset < end && offset > fill ? buff[--offset] : 0;
            }
          } else {
            while (offset < end) {
              buff[offset++] = 0;
            }
          }
          return buff;
        },
        decode(buff, offset) {
          offset = ~~offset;
          let result2 = "";
          for (let i = 0; i < v6Size; i += 2) {
            if (i !== 0) {
              result2 += ":";
            }
            result2 += (buff[offset + i] << 8 | buff[offset + i + 1]).toString(16);
          }
          return result2.replace(/(^|:)0(:0)*:0(:|$)/, "$1::$3").replace(/:{3,4}/, "::");
        }
      };
      exports3.v6 = v6;
      const name = "ip";
      exports3.name = name;
      function sizeOf(ip) {
        if (v4.isFormat(ip))
          return v4.size;
        if (v6.isFormat(ip))
          return v6.size;
        throw Error(`Invalid ip address: ${ip}`);
      }
      function familyOf(string) {
        return sizeOf(string) === v4.size ? 1 : 2;
      }
      function encode(ip, buff, offset) {
        offset = ~~offset;
        const size = sizeOf(ip);
        if (typeof buff === "function") {
          buff = buff(offset + size);
        }
        if (size === v4.size) {
          return v4.encode(ip, buff, offset);
        }
        return v6.encode(ip, buff, offset);
      }
      function decode(buff, offset, length) {
        offset = ~~offset;
        length = length || buff.length - offset;
        if (length === v4.size) {
          return v4.decode(buff, offset, length);
        }
        if (length === v6.size) {
          return v6.decode(buff, offset, length);
        }
        throw Error(`Invalid buffer size needs to be ${v4.size} for v4 or ${v6.size} for v6.`);
      }
      return "default" in exports3 ? exports3.default : exports3;
    }({});
    if (typeof define === "function" && define.amd)
      define([], function() {
        return ipCodec;
      });
    else if (typeof module2 === "object" && typeof exports2 === "object")
      module2.exports = ipCodec;
  }
});

// node_modules/dns-packet/index.js
var require_dns_packet = __commonJS({
  "node_modules/dns-packet/index.js"(exports2) {
    "use strict";
    var Buffer2 = require("buffer").Buffer;
    var types2 = require_types8();
    var rcodes = require_rcodes();
    var opcodes = require_opcodes();
    var classes = require_classes();
    var optioncodes = require_optioncodes();
    var ip = require_ip_codec();
    var QUERY_FLAG = 0;
    var RESPONSE_FLAG = 1 << 15;
    var FLUSH_MASK = 1 << 15;
    var NOT_FLUSH_MASK = ~FLUSH_MASK;
    var QU_MASK = 1 << 15;
    var NOT_QU_MASK = ~QU_MASK;
    var name = exports2.name = {};
    name.encode = function(str, buf, offset, { mail = false } = {}) {
      if (!buf)
        buf = Buffer2.alloc(name.encodingLength(str));
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      const n = str.replace(/^\.|\.$/gm, "");
      if (n.length) {
        let list = [];
        if (mail) {
          let localPart = "";
          n.split(".").forEach((label) => {
            if (label.endsWith("\\")) {
              localPart += (localPart.length ? "." : "") + label.slice(0, -1);
            } else {
              if (list.length === 0 && localPart.length) {
                list.push(localPart + "." + label);
              } else {
                list.push(label);
              }
            }
          });
        } else {
          list = n.split(".");
        }
        for (let i = 0; i < list.length; i++) {
          const len = buf.write(list[i], offset + 1);
          buf[offset] = len;
          offset += len + 1;
        }
      }
      buf[offset++] = 0;
      name.encode.bytes = offset - oldOffset;
      return buf;
    };
    name.encode.bytes = 0;
    name.decode = function(buf, offset, { mail = false } = {}) {
      if (!offset)
        offset = 0;
      const list = [];
      let oldOffset = offset;
      let totalLength = 0;
      let consumedBytes = 0;
      let jumped = false;
      while (true) {
        if (offset >= buf.length) {
          throw new Error("Cannot decode name (buffer overflow)");
        }
        const len = buf[offset++];
        consumedBytes += jumped ? 0 : 1;
        if (len === 0) {
          break;
        } else if ((len & 192) === 0) {
          if (offset + len > buf.length) {
            throw new Error("Cannot decode name (buffer overflow)");
          }
          totalLength += len + 1;
          if (totalLength > 254) {
            throw new Error("Cannot decode name (name too long)");
          }
          let label = buf.toString("utf-8", offset, offset + len);
          if (mail) {
            label = label.replace(/\./g, "\\.");
          }
          list.push(label);
          offset += len;
          consumedBytes += jumped ? 0 : len;
        } else if ((len & 192) === 192) {
          if (offset + 1 > buf.length) {
            throw new Error("Cannot decode name (buffer overflow)");
          }
          const jumpOffset = buf.readUInt16BE(offset - 1) - 49152;
          if (jumpOffset >= oldOffset) {
            throw new Error("Cannot decode name (bad pointer)");
          }
          offset = jumpOffset;
          oldOffset = jumpOffset;
          consumedBytes += jumped ? 0 : 1;
          jumped = true;
        } else {
          throw new Error("Cannot decode name (bad label)");
        }
      }
      name.decode.bytes = consumedBytes;
      return list.length === 0 ? "." : list.join(".");
    };
    name.decode.bytes = 0;
    name.encodingLength = function(n) {
      if (n === "." || n === "..")
        return 1;
      return Buffer2.byteLength(n.replace(/^\.|\.$/gm, "")) + 2;
    };
    var string = {};
    string.encode = function(s, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(string.encodingLength(s));
      if (!offset)
        offset = 0;
      const len = buf.write(s, offset + 1);
      buf[offset] = len;
      string.encode.bytes = len + 1;
      return buf;
    };
    string.encode.bytes = 0;
    string.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const len = buf[offset];
      const s = buf.toString("utf-8", offset + 1, offset + 1 + len);
      string.decode.bytes = len + 1;
      return s;
    };
    string.decode.bytes = 0;
    string.encodingLength = function(s) {
      return Buffer2.byteLength(s) + 1;
    };
    var header = {};
    header.encode = function(h, buf, offset) {
      if (!buf)
        buf = header.encodingLength(h);
      if (!offset)
        offset = 0;
      const flags = (h.flags || 0) & 32767;
      const type = h.type === "response" ? RESPONSE_FLAG : QUERY_FLAG;
      buf.writeUInt16BE(h.id || 0, offset);
      buf.writeUInt16BE(flags | type, offset + 2);
      buf.writeUInt16BE(h.questions.length, offset + 4);
      buf.writeUInt16BE(h.answers.length, offset + 6);
      buf.writeUInt16BE(h.authorities.length, offset + 8);
      buf.writeUInt16BE(h.additionals.length, offset + 10);
      return buf;
    };
    header.encode.bytes = 12;
    header.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      if (buf.length < 12)
        throw new Error("Header must be 12 bytes");
      const flags = buf.readUInt16BE(offset + 2);
      return {
        id: buf.readUInt16BE(offset),
        type: flags & RESPONSE_FLAG ? "response" : "query",
        flags: flags & 32767,
        flag_qr: (flags >> 15 & 1) === 1,
        opcode: opcodes.toString(flags >> 11 & 15),
        flag_aa: (flags >> 10 & 1) === 1,
        flag_tc: (flags >> 9 & 1) === 1,
        flag_rd: (flags >> 8 & 1) === 1,
        flag_ra: (flags >> 7 & 1) === 1,
        flag_z: (flags >> 6 & 1) === 1,
        flag_ad: (flags >> 5 & 1) === 1,
        flag_cd: (flags >> 4 & 1) === 1,
        rcode: rcodes.toString(flags & 15),
        questions: new Array(buf.readUInt16BE(offset + 4)),
        answers: new Array(buf.readUInt16BE(offset + 6)),
        authorities: new Array(buf.readUInt16BE(offset + 8)),
        additionals: new Array(buf.readUInt16BE(offset + 10))
      };
    };
    header.decode.bytes = 12;
    header.encodingLength = function() {
      return 12;
    };
    var runknown = exports2.unknown = {};
    runknown.encode = function(data, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(runknown.encodingLength(data));
      if (!offset)
        offset = 0;
      buf.writeUInt16BE(data.length, offset);
      data.copy(buf, offset + 2);
      runknown.encode.bytes = data.length + 2;
      return buf;
    };
    runknown.encode.bytes = 0;
    runknown.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const len = buf.readUInt16BE(offset);
      const data = buf.slice(offset + 2, offset + 2 + len);
      runknown.decode.bytes = len + 2;
      return data;
    };
    runknown.decode.bytes = 0;
    runknown.encodingLength = function(data) {
      return data.length + 2;
    };
    var rns = exports2.ns = {};
    rns.encode = function(data, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(rns.encodingLength(data));
      if (!offset)
        offset = 0;
      name.encode(data, buf, offset + 2);
      buf.writeUInt16BE(name.encode.bytes, offset);
      rns.encode.bytes = name.encode.bytes + 2;
      return buf;
    };
    rns.encode.bytes = 0;
    rns.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const len = buf.readUInt16BE(offset);
      const dd = name.decode(buf, offset + 2);
      rns.decode.bytes = len + 2;
      return dd;
    };
    rns.decode.bytes = 0;
    rns.encodingLength = function(data) {
      return name.encodingLength(data) + 2;
    };
    var rsoa = exports2.soa = {};
    rsoa.encode = function(data, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(rsoa.encodingLength(data));
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      offset += 2;
      name.encode(data.mname, buf, offset);
      offset += name.encode.bytes;
      name.encode(data.rname, buf, offset, { mail: true });
      offset += name.encode.bytes;
      buf.writeUInt32BE(data.serial || 0, offset);
      offset += 4;
      buf.writeUInt32BE(data.refresh || 0, offset);
      offset += 4;
      buf.writeUInt32BE(data.retry || 0, offset);
      offset += 4;
      buf.writeUInt32BE(data.expire || 0, offset);
      offset += 4;
      buf.writeUInt32BE(data.minimum || 0, offset);
      offset += 4;
      buf.writeUInt16BE(offset - oldOffset - 2, oldOffset);
      rsoa.encode.bytes = offset - oldOffset;
      return buf;
    };
    rsoa.encode.bytes = 0;
    rsoa.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      const data = {};
      offset += 2;
      data.mname = name.decode(buf, offset);
      offset += name.decode.bytes;
      data.rname = name.decode(buf, offset, { mail: true });
      offset += name.decode.bytes;
      data.serial = buf.readUInt32BE(offset);
      offset += 4;
      data.refresh = buf.readUInt32BE(offset);
      offset += 4;
      data.retry = buf.readUInt32BE(offset);
      offset += 4;
      data.expire = buf.readUInt32BE(offset);
      offset += 4;
      data.minimum = buf.readUInt32BE(offset);
      offset += 4;
      rsoa.decode.bytes = offset - oldOffset;
      return data;
    };
    rsoa.decode.bytes = 0;
    rsoa.encodingLength = function(data) {
      return 22 + name.encodingLength(data.mname) + name.encodingLength(data.rname);
    };
    var rtxt = exports2.txt = {};
    rtxt.encode = function(data, buf, offset) {
      if (!Array.isArray(data))
        data = [data];
      for (let i = 0; i < data.length; i++) {
        if (typeof data[i] === "string") {
          data[i] = Buffer2.from(data[i]);
        }
        if (!Buffer2.isBuffer(data[i])) {
          throw new Error("Must be a Buffer");
        }
      }
      if (!buf)
        buf = Buffer2.alloc(rtxt.encodingLength(data));
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      offset += 2;
      data.forEach(function(d2) {
        buf[offset++] = d2.length;
        d2.copy(buf, offset, 0, d2.length);
        offset += d2.length;
      });
      buf.writeUInt16BE(offset - oldOffset - 2, oldOffset);
      rtxt.encode.bytes = offset - oldOffset;
      return buf;
    };
    rtxt.encode.bytes = 0;
    rtxt.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      let remaining = buf.readUInt16BE(offset);
      offset += 2;
      let data = [];
      while (remaining > 0) {
        const len = buf[offset++];
        --remaining;
        if (remaining < len) {
          throw new Error("Buffer overflow");
        }
        data.push(buf.slice(offset, offset + len));
        offset += len;
        remaining -= len;
      }
      rtxt.decode.bytes = offset - oldOffset;
      return data;
    };
    rtxt.decode.bytes = 0;
    rtxt.encodingLength = function(data) {
      if (!Array.isArray(data))
        data = [data];
      let length = 2;
      data.forEach(function(buf) {
        if (typeof buf === "string") {
          length += Buffer2.byteLength(buf) + 1;
        } else {
          length += buf.length + 1;
        }
      });
      return length;
    };
    var rnull = exports2.null = {};
    rnull.encode = function(data, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(rnull.encodingLength(data));
      if (!offset)
        offset = 0;
      if (typeof data === "string")
        data = Buffer2.from(data);
      if (!data)
        data = Buffer2.alloc(0);
      const oldOffset = offset;
      offset += 2;
      const len = data.length;
      data.copy(buf, offset, 0, len);
      offset += len;
      buf.writeUInt16BE(offset - oldOffset - 2, oldOffset);
      rnull.encode.bytes = offset - oldOffset;
      return buf;
    };
    rnull.encode.bytes = 0;
    rnull.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      const len = buf.readUInt16BE(offset);
      offset += 2;
      const data = buf.slice(offset, offset + len);
      offset += len;
      rnull.decode.bytes = offset - oldOffset;
      return data;
    };
    rnull.decode.bytes = 0;
    rnull.encodingLength = function(data) {
      if (!data)
        return 2;
      return (Buffer2.isBuffer(data) ? data.length : Buffer2.byteLength(data)) + 2;
    };
    var rhinfo = exports2.hinfo = {};
    rhinfo.encode = function(data, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(rhinfo.encodingLength(data));
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      offset += 2;
      string.encode(data.cpu, buf, offset);
      offset += string.encode.bytes;
      string.encode(data.os, buf, offset);
      offset += string.encode.bytes;
      buf.writeUInt16BE(offset - oldOffset - 2, oldOffset);
      rhinfo.encode.bytes = offset - oldOffset;
      return buf;
    };
    rhinfo.encode.bytes = 0;
    rhinfo.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      const data = {};
      offset += 2;
      data.cpu = string.decode(buf, offset);
      offset += string.decode.bytes;
      data.os = string.decode(buf, offset);
      offset += string.decode.bytes;
      rhinfo.decode.bytes = offset - oldOffset;
      return data;
    };
    rhinfo.decode.bytes = 0;
    rhinfo.encodingLength = function(data) {
      return string.encodingLength(data.cpu) + string.encodingLength(data.os) + 2;
    };
    var rptr = exports2.ptr = {};
    var rcname = exports2.cname = rptr;
    var rdname = exports2.dname = rptr;
    rptr.encode = function(data, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(rptr.encodingLength(data));
      if (!offset)
        offset = 0;
      name.encode(data, buf, offset + 2);
      buf.writeUInt16BE(name.encode.bytes, offset);
      rptr.encode.bytes = name.encode.bytes + 2;
      return buf;
    };
    rptr.encode.bytes = 0;
    rptr.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const data = name.decode(buf, offset + 2);
      rptr.decode.bytes = name.decode.bytes + 2;
      return data;
    };
    rptr.decode.bytes = 0;
    rptr.encodingLength = function(data) {
      return name.encodingLength(data) + 2;
    };
    var rsrv = exports2.srv = {};
    rsrv.encode = function(data, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(rsrv.encodingLength(data));
      if (!offset)
        offset = 0;
      buf.writeUInt16BE(data.priority || 0, offset + 2);
      buf.writeUInt16BE(data.weight || 0, offset + 4);
      buf.writeUInt16BE(data.port || 0, offset + 6);
      name.encode(data.target, buf, offset + 8);
      const len = name.encode.bytes + 6;
      buf.writeUInt16BE(len, offset);
      rsrv.encode.bytes = len + 2;
      return buf;
    };
    rsrv.encode.bytes = 0;
    rsrv.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const len = buf.readUInt16BE(offset);
      const data = {};
      data.priority = buf.readUInt16BE(offset + 2);
      data.weight = buf.readUInt16BE(offset + 4);
      data.port = buf.readUInt16BE(offset + 6);
      data.target = name.decode(buf, offset + 8);
      rsrv.decode.bytes = len + 2;
      return data;
    };
    rsrv.decode.bytes = 0;
    rsrv.encodingLength = function(data) {
      return 8 + name.encodingLength(data.target);
    };
    var rcaa = exports2.caa = {};
    rcaa.ISSUER_CRITICAL = 1 << 7;
    rcaa.encode = function(data, buf, offset) {
      const len = rcaa.encodingLength(data);
      if (!buf)
        buf = Buffer2.alloc(rcaa.encodingLength(data));
      if (!offset)
        offset = 0;
      if (data.issuerCritical) {
        data.flags = rcaa.ISSUER_CRITICAL;
      }
      buf.writeUInt16BE(len - 2, offset);
      offset += 2;
      buf.writeUInt8(data.flags || 0, offset);
      offset += 1;
      string.encode(data.tag, buf, offset);
      offset += string.encode.bytes;
      buf.write(data.value, offset);
      offset += Buffer2.byteLength(data.value);
      rcaa.encode.bytes = len;
      return buf;
    };
    rcaa.encode.bytes = 0;
    rcaa.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const len = buf.readUInt16BE(offset);
      offset += 2;
      const oldOffset = offset;
      const data = {};
      data.flags = buf.readUInt8(offset);
      offset += 1;
      data.tag = string.decode(buf, offset);
      offset += string.decode.bytes;
      data.value = buf.toString("utf-8", offset, oldOffset + len);
      data.issuerCritical = !!(data.flags & rcaa.ISSUER_CRITICAL);
      rcaa.decode.bytes = len + 2;
      return data;
    };
    rcaa.decode.bytes = 0;
    rcaa.encodingLength = function(data) {
      return string.encodingLength(data.tag) + string.encodingLength(data.value) + 2;
    };
    var rmx = exports2.mx = {};
    rmx.encode = function(data, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(rmx.encodingLength(data));
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      offset += 2;
      buf.writeUInt16BE(data.preference || 0, offset);
      offset += 2;
      name.encode(data.exchange, buf, offset);
      offset += name.encode.bytes;
      buf.writeUInt16BE(offset - oldOffset - 2, oldOffset);
      rmx.encode.bytes = offset - oldOffset;
      return buf;
    };
    rmx.encode.bytes = 0;
    rmx.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      const data = {};
      offset += 2;
      data.preference = buf.readUInt16BE(offset);
      offset += 2;
      data.exchange = name.decode(buf, offset);
      offset += name.decode.bytes;
      rmx.decode.bytes = offset - oldOffset;
      return data;
    };
    rmx.encodingLength = function(data) {
      return 4 + name.encodingLength(data.exchange);
    };
    var ra = exports2.a = {};
    ra.encode = function(host, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(ra.encodingLength(host));
      if (!offset)
        offset = 0;
      buf.writeUInt16BE(4, offset);
      offset += 2;
      ip.v4.encode(host, buf, offset);
      ra.encode.bytes = 6;
      return buf;
    };
    ra.encode.bytes = 0;
    ra.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      offset += 2;
      const host = ip.v4.decode(buf, offset);
      ra.decode.bytes = 6;
      return host;
    };
    ra.decode.bytes = 0;
    ra.encodingLength = function() {
      return 6;
    };
    var raaaa = exports2.aaaa = {};
    raaaa.encode = function(host, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(raaaa.encodingLength(host));
      if (!offset)
        offset = 0;
      buf.writeUInt16BE(16, offset);
      offset += 2;
      ip.v6.encode(host, buf, offset);
      raaaa.encode.bytes = 18;
      return buf;
    };
    raaaa.encode.bytes = 0;
    raaaa.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      offset += 2;
      const host = ip.v6.decode(buf, offset);
      raaaa.decode.bytes = 18;
      return host;
    };
    raaaa.decode.bytes = 0;
    raaaa.encodingLength = function() {
      return 18;
    };
    var roption = exports2.option = {};
    roption.encode = function(option, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(roption.encodingLength(option));
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      const code = optioncodes.toCode(option.code);
      buf.writeUInt16BE(code, offset);
      offset += 2;
      if (option.data) {
        buf.writeUInt16BE(option.data.length, offset);
        offset += 2;
        option.data.copy(buf, offset);
        offset += option.data.length;
      } else {
        switch (code) {
          case 8:
            const spl = option.sourcePrefixLength || 0;
            const fam = option.family || ip.familyOf(option.ip);
            const ipBuf = ip.encode(option.ip, Buffer2.alloc);
            const ipLen = Math.ceil(spl / 8);
            buf.writeUInt16BE(ipLen + 4, offset);
            offset += 2;
            buf.writeUInt16BE(fam, offset);
            offset += 2;
            buf.writeUInt8(spl, offset++);
            buf.writeUInt8(option.scopePrefixLength || 0, offset++);
            ipBuf.copy(buf, offset, 0, ipLen);
            offset += ipLen;
            break;
          case 11:
            if (option.timeout) {
              buf.writeUInt16BE(2, offset);
              offset += 2;
              buf.writeUInt16BE(option.timeout, offset);
              offset += 2;
            } else {
              buf.writeUInt16BE(0, offset);
              offset += 2;
            }
            break;
          case 12:
            const len = option.length || 0;
            buf.writeUInt16BE(len, offset);
            offset += 2;
            buf.fill(0, offset, offset + len);
            offset += len;
            break;
          case 14:
            const tagsLen = option.tags.length * 2;
            buf.writeUInt16BE(tagsLen, offset);
            offset += 2;
            for (const tag of option.tags) {
              buf.writeUInt16BE(tag, offset);
              offset += 2;
            }
            break;
          default:
            throw new Error(`Unknown roption code: ${option.code}`);
        }
      }
      roption.encode.bytes = offset - oldOffset;
      return buf;
    };
    roption.encode.bytes = 0;
    roption.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const option = {};
      option.code = buf.readUInt16BE(offset);
      option.type = optioncodes.toString(option.code);
      offset += 2;
      const len = buf.readUInt16BE(offset);
      offset += 2;
      option.data = buf.slice(offset, offset + len);
      switch (option.code) {
        case 8:
          option.family = buf.readUInt16BE(offset);
          offset += 2;
          option.sourcePrefixLength = buf.readUInt8(offset++);
          option.scopePrefixLength = buf.readUInt8(offset++);
          const padded = Buffer2.alloc(option.family === 1 ? 4 : 16);
          buf.copy(padded, 0, offset, offset + len - 4);
          option.ip = ip.decode(padded);
          break;
        case 11:
          if (len > 0) {
            option.timeout = buf.readUInt16BE(offset);
            offset += 2;
          }
          break;
        case 14:
          option.tags = [];
          for (let i = 0; i < len; i += 2) {
            option.tags.push(buf.readUInt16BE(offset));
            offset += 2;
          }
      }
      roption.decode.bytes = len + 4;
      return option;
    };
    roption.decode.bytes = 0;
    roption.encodingLength = function(option) {
      if (option.data) {
        return option.data.length + 4;
      }
      const code = optioncodes.toCode(option.code);
      switch (code) {
        case 8:
          const spl = option.sourcePrefixLength || 0;
          return Math.ceil(spl / 8) + 8;
        case 11:
          return typeof option.timeout === "number" ? 6 : 4;
        case 12:
          return option.length + 4;
        case 14:
          return 4 + option.tags.length * 2;
      }
      throw new Error(`Unknown roption code: ${option.code}`);
    };
    var ropt = exports2.opt = {};
    ropt.encode = function(options, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(ropt.encodingLength(options));
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      const rdlen = encodingLengthList(options, roption);
      buf.writeUInt16BE(rdlen, offset);
      offset = encodeList(options, roption, buf, offset + 2);
      ropt.encode.bytes = offset - oldOffset;
      return buf;
    };
    ropt.encode.bytes = 0;
    ropt.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      const options = [];
      let rdlen = buf.readUInt16BE(offset);
      offset += 2;
      let o2 = 0;
      while (rdlen > 0) {
        options[o2++] = roption.decode(buf, offset);
        offset += roption.decode.bytes;
        rdlen -= roption.decode.bytes;
      }
      ropt.decode.bytes = offset - oldOffset;
      return options;
    };
    ropt.decode.bytes = 0;
    ropt.encodingLength = function(options) {
      return 2 + encodingLengthList(options || [], roption);
    };
    var rdnskey = exports2.dnskey = {};
    rdnskey.PROTOCOL_DNSSEC = 3;
    rdnskey.ZONE_KEY = 128;
    rdnskey.SECURE_ENTRYPOINT = 32768;
    rdnskey.encode = function(key, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(rdnskey.encodingLength(key));
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      const keydata = key.key;
      if (!Buffer2.isBuffer(keydata)) {
        throw new Error("Key must be a Buffer");
      }
      offset += 2;
      buf.writeUInt16BE(key.flags, offset);
      offset += 2;
      buf.writeUInt8(rdnskey.PROTOCOL_DNSSEC, offset);
      offset += 1;
      buf.writeUInt8(key.algorithm, offset);
      offset += 1;
      keydata.copy(buf, offset, 0, keydata.length);
      offset += keydata.length;
      rdnskey.encode.bytes = offset - oldOffset;
      buf.writeUInt16BE(rdnskey.encode.bytes - 2, oldOffset);
      return buf;
    };
    rdnskey.encode.bytes = 0;
    rdnskey.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      var key = {};
      var length = buf.readUInt16BE(offset);
      offset += 2;
      key.flags = buf.readUInt16BE(offset);
      offset += 2;
      if (buf.readUInt8(offset) !== rdnskey.PROTOCOL_DNSSEC) {
        throw new Error("Protocol must be 3");
      }
      offset += 1;
      key.algorithm = buf.readUInt8(offset);
      offset += 1;
      key.key = buf.slice(offset, oldOffset + length + 2);
      offset += key.key.length;
      rdnskey.decode.bytes = offset - oldOffset;
      return key;
    };
    rdnskey.decode.bytes = 0;
    rdnskey.encodingLength = function(key) {
      return 6 + Buffer2.byteLength(key.key);
    };
    var rrrsig = exports2.rrsig = {};
    rrrsig.encode = function(sig, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(rrrsig.encodingLength(sig));
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      const signature = sig.signature;
      if (!Buffer2.isBuffer(signature)) {
        throw new Error("Signature must be a Buffer");
      }
      offset += 2;
      buf.writeUInt16BE(types2.toType(sig.typeCovered), offset);
      offset += 2;
      buf.writeUInt8(sig.algorithm, offset);
      offset += 1;
      buf.writeUInt8(sig.labels, offset);
      offset += 1;
      buf.writeUInt32BE(sig.originalTTL, offset);
      offset += 4;
      buf.writeUInt32BE(sig.expiration, offset);
      offset += 4;
      buf.writeUInt32BE(sig.inception, offset);
      offset += 4;
      buf.writeUInt16BE(sig.keyTag, offset);
      offset += 2;
      name.encode(sig.signersName, buf, offset);
      offset += name.encode.bytes;
      signature.copy(buf, offset, 0, signature.length);
      offset += signature.length;
      rrrsig.encode.bytes = offset - oldOffset;
      buf.writeUInt16BE(rrrsig.encode.bytes - 2, oldOffset);
      return buf;
    };
    rrrsig.encode.bytes = 0;
    rrrsig.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      var sig = {};
      var length = buf.readUInt16BE(offset);
      offset += 2;
      sig.typeCovered = types2.toString(buf.readUInt16BE(offset));
      offset += 2;
      sig.algorithm = buf.readUInt8(offset);
      offset += 1;
      sig.labels = buf.readUInt8(offset);
      offset += 1;
      sig.originalTTL = buf.readUInt32BE(offset);
      offset += 4;
      sig.expiration = buf.readUInt32BE(offset);
      offset += 4;
      sig.inception = buf.readUInt32BE(offset);
      offset += 4;
      sig.keyTag = buf.readUInt16BE(offset);
      offset += 2;
      sig.signersName = name.decode(buf, offset);
      offset += name.decode.bytes;
      sig.signature = buf.slice(offset, oldOffset + length + 2);
      offset += sig.signature.length;
      rrrsig.decode.bytes = offset - oldOffset;
      return sig;
    };
    rrrsig.decode.bytes = 0;
    rrrsig.encodingLength = function(sig) {
      return 20 + name.encodingLength(sig.signersName) + Buffer2.byteLength(sig.signature);
    };
    var rrp = exports2.rp = {};
    rrp.encode = function(data, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(rrp.encodingLength(data));
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      offset += 2;
      name.encode(data.mbox || ".", buf, offset, { mail: true });
      offset += name.encode.bytes;
      name.encode(data.txt || ".", buf, offset);
      offset += name.encode.bytes;
      rrp.encode.bytes = offset - oldOffset;
      buf.writeUInt16BE(rrp.encode.bytes - 2, oldOffset);
      return buf;
    };
    rrp.encode.bytes = 0;
    rrp.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      const data = {};
      offset += 2;
      data.mbox = name.decode(buf, offset, { mail: true }) || ".";
      offset += name.decode.bytes;
      data.txt = name.decode(buf, offset) || ".";
      offset += name.decode.bytes;
      rrp.decode.bytes = offset - oldOffset;
      return data;
    };
    rrp.decode.bytes = 0;
    rrp.encodingLength = function(data) {
      return 2 + name.encodingLength(data.mbox || ".") + name.encodingLength(data.txt || ".");
    };
    var typebitmap = {};
    typebitmap.encode = function(typelist, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(typebitmap.encodingLength(typelist));
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      var typesByWindow = [];
      for (var i = 0; i < typelist.length; i++) {
        var typeid = types2.toType(typelist[i]);
        if (typesByWindow[typeid >> 8] === void 0) {
          typesByWindow[typeid >> 8] = [];
        }
        typesByWindow[typeid >> 8][typeid >> 3 & 31] |= 1 << 7 - (typeid & 7);
      }
      for (i = 0; i < typesByWindow.length; i++) {
        if (typesByWindow[i] !== void 0) {
          var windowBuf = Buffer2.from(typesByWindow[i]);
          buf.writeUInt8(i, offset);
          offset += 1;
          buf.writeUInt8(windowBuf.length, offset);
          offset += 1;
          windowBuf.copy(buf, offset);
          offset += windowBuf.length;
        }
      }
      typebitmap.encode.bytes = offset - oldOffset;
      return buf;
    };
    typebitmap.encode.bytes = 0;
    typebitmap.decode = function(buf, offset, length) {
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      var typelist = [];
      while (offset - oldOffset < length) {
        var window2 = buf.readUInt8(offset);
        offset += 1;
        var windowLength = buf.readUInt8(offset);
        offset += 1;
        for (var i = 0; i < windowLength; i++) {
          var b = buf.readUInt8(offset + i);
          for (var j = 0; j < 8; j++) {
            if (b & 1 << 7 - j) {
              var typeid = types2.toString(window2 << 8 | i << 3 | j);
              typelist.push(typeid);
            }
          }
        }
        offset += windowLength;
      }
      typebitmap.decode.bytes = offset - oldOffset;
      return typelist;
    };
    typebitmap.decode.bytes = 0;
    typebitmap.encodingLength = function(typelist) {
      var extents = [];
      for (var i = 0; i < typelist.length; i++) {
        var typeid = types2.toType(typelist[i]);
        extents[typeid >> 8] = Math.max(extents[typeid >> 8] || 0, typeid & 255);
      }
      var len = 0;
      for (i = 0; i < extents.length; i++) {
        if (extents[i] !== void 0) {
          len += 2 + Math.ceil((extents[i] + 1) / 8);
        }
      }
      return len;
    };
    var rnsec = exports2.nsec = {};
    rnsec.encode = function(record, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(rnsec.encodingLength(record));
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      offset += 2;
      name.encode(record.nextDomain, buf, offset);
      offset += name.encode.bytes;
      typebitmap.encode(record.rrtypes, buf, offset);
      offset += typebitmap.encode.bytes;
      rnsec.encode.bytes = offset - oldOffset;
      buf.writeUInt16BE(rnsec.encode.bytes - 2, oldOffset);
      return buf;
    };
    rnsec.encode.bytes = 0;
    rnsec.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      var record = {};
      var length = buf.readUInt16BE(offset);
      offset += 2;
      record.nextDomain = name.decode(buf, offset);
      offset += name.decode.bytes;
      record.rrtypes = typebitmap.decode(buf, offset, length - (offset - oldOffset));
      offset += typebitmap.decode.bytes;
      rnsec.decode.bytes = offset - oldOffset;
      return record;
    };
    rnsec.decode.bytes = 0;
    rnsec.encodingLength = function(record) {
      return 2 + name.encodingLength(record.nextDomain) + typebitmap.encodingLength(record.rrtypes);
    };
    var rnsec3 = exports2.nsec3 = {};
    rnsec3.encode = function(record, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(rnsec3.encodingLength(record));
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      const salt = record.salt;
      if (!Buffer2.isBuffer(salt)) {
        throw new Error("salt must be a Buffer");
      }
      const nextDomain = record.nextDomain;
      if (!Buffer2.isBuffer(nextDomain)) {
        throw new Error("nextDomain must be a Buffer");
      }
      offset += 2;
      buf.writeUInt8(record.algorithm, offset);
      offset += 1;
      buf.writeUInt8(record.flags, offset);
      offset += 1;
      buf.writeUInt16BE(record.iterations, offset);
      offset += 2;
      buf.writeUInt8(salt.length, offset);
      offset += 1;
      salt.copy(buf, offset, 0, salt.length);
      offset += salt.length;
      buf.writeUInt8(nextDomain.length, offset);
      offset += 1;
      nextDomain.copy(buf, offset, 0, nextDomain.length);
      offset += nextDomain.length;
      typebitmap.encode(record.rrtypes, buf, offset);
      offset += typebitmap.encode.bytes;
      rnsec3.encode.bytes = offset - oldOffset;
      buf.writeUInt16BE(rnsec3.encode.bytes - 2, oldOffset);
      return buf;
    };
    rnsec3.encode.bytes = 0;
    rnsec3.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      var record = {};
      var length = buf.readUInt16BE(offset);
      offset += 2;
      record.algorithm = buf.readUInt8(offset);
      offset += 1;
      record.flags = buf.readUInt8(offset);
      offset += 1;
      record.iterations = buf.readUInt16BE(offset);
      offset += 2;
      const saltLength = buf.readUInt8(offset);
      offset += 1;
      record.salt = buf.slice(offset, offset + saltLength);
      offset += saltLength;
      const hashLength = buf.readUInt8(offset);
      offset += 1;
      record.nextDomain = buf.slice(offset, offset + hashLength);
      offset += hashLength;
      record.rrtypes = typebitmap.decode(buf, offset, length - (offset - oldOffset));
      offset += typebitmap.decode.bytes;
      rnsec3.decode.bytes = offset - oldOffset;
      return record;
    };
    rnsec3.decode.bytes = 0;
    rnsec3.encodingLength = function(record) {
      return 8 + record.salt.length + record.nextDomain.length + typebitmap.encodingLength(record.rrtypes);
    };
    var rds = exports2.ds = {};
    rds.encode = function(digest, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(rds.encodingLength(digest));
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      const digestdata = digest.digest;
      if (!Buffer2.isBuffer(digestdata)) {
        throw new Error("Digest must be a Buffer");
      }
      offset += 2;
      buf.writeUInt16BE(digest.keyTag, offset);
      offset += 2;
      buf.writeUInt8(digest.algorithm, offset);
      offset += 1;
      buf.writeUInt8(digest.digestType, offset);
      offset += 1;
      digestdata.copy(buf, offset, 0, digestdata.length);
      offset += digestdata.length;
      rds.encode.bytes = offset - oldOffset;
      buf.writeUInt16BE(rds.encode.bytes - 2, oldOffset);
      return buf;
    };
    rds.encode.bytes = 0;
    rds.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      var digest = {};
      var length = buf.readUInt16BE(offset);
      offset += 2;
      digest.keyTag = buf.readUInt16BE(offset);
      offset += 2;
      digest.algorithm = buf.readUInt8(offset);
      offset += 1;
      digest.digestType = buf.readUInt8(offset);
      offset += 1;
      digest.digest = buf.slice(offset, oldOffset + length + 2);
      offset += digest.digest.length;
      rds.decode.bytes = offset - oldOffset;
      return digest;
    };
    rds.decode.bytes = 0;
    rds.encodingLength = function(digest) {
      return 6 + Buffer2.byteLength(digest.digest);
    };
    var rsshfp = exports2.sshfp = {};
    rsshfp.getFingerprintLengthForHashType = function getFingerprintLengthForHashType(hashType) {
      switch (hashType) {
        case 1:
          return 20;
        case 2:
          return 32;
      }
    };
    rsshfp.encode = function encode(record, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(rsshfp.encodingLength(record));
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      offset += 2;
      buf[offset] = record.algorithm;
      offset += 1;
      buf[offset] = record.hash;
      offset += 1;
      const fingerprintBuf = Buffer2.from(record.fingerprint.toUpperCase(), "hex");
      if (fingerprintBuf.length !== rsshfp.getFingerprintLengthForHashType(record.hash)) {
        throw new Error("Invalid fingerprint length");
      }
      fingerprintBuf.copy(buf, offset);
      offset += fingerprintBuf.byteLength;
      rsshfp.encode.bytes = offset - oldOffset;
      buf.writeUInt16BE(rsshfp.encode.bytes - 2, oldOffset);
      return buf;
    };
    rsshfp.encode.bytes = 0;
    rsshfp.decode = function decode(buf, offset) {
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      const record = {};
      offset += 2;
      record.algorithm = buf[offset];
      offset += 1;
      record.hash = buf[offset];
      offset += 1;
      const fingerprintLength = rsshfp.getFingerprintLengthForHashType(record.hash);
      record.fingerprint = buf.slice(offset, offset + fingerprintLength).toString("hex").toUpperCase();
      offset += fingerprintLength;
      rsshfp.decode.bytes = offset - oldOffset;
      return record;
    };
    rsshfp.decode.bytes = 0;
    rsshfp.encodingLength = function(record) {
      return 4 + Buffer2.from(record.fingerprint, "hex").byteLength;
    };
    var rnaptr = exports2.naptr = {};
    rnaptr.encode = function(data, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(rnaptr.encodingLength(data));
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      offset += 2;
      buf.writeUInt16BE(data.order || 0, offset);
      offset += 2;
      buf.writeUInt16BE(data.preference || 0, offset);
      offset += 2;
      string.encode(data.flags, buf, offset);
      offset += string.encode.bytes;
      string.encode(data.services, buf, offset);
      offset += string.encode.bytes;
      string.encode(data.regexp, buf, offset);
      offset += string.encode.bytes;
      name.encode(data.replacement, buf, offset);
      offset += name.encode.bytes;
      rnaptr.encode.bytes = offset - oldOffset;
      buf.writeUInt16BE(rnaptr.encode.bytes - 2, oldOffset);
      return buf;
    };
    rnaptr.encode.bytes = 0;
    rnaptr.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      const data = {};
      offset += 2;
      data.order = buf.readUInt16BE(offset);
      offset += 2;
      data.preference = buf.readUInt16BE(offset);
      offset += 2;
      data.flags = string.decode(buf, offset);
      offset += string.decode.bytes;
      data.services = string.decode(buf, offset);
      offset += string.decode.bytes;
      data.regexp = string.decode(buf, offset);
      offset += string.decode.bytes;
      data.replacement = name.decode(buf, offset);
      offset += name.decode.bytes;
      rnaptr.decode.bytes = offset - oldOffset;
      return data;
    };
    rnaptr.decode.bytes = 0;
    rnaptr.encodingLength = function(data) {
      return string.encodingLength(data.flags) + string.encodingLength(data.services) + string.encodingLength(data.regexp) + name.encodingLength(data.replacement) + 6;
    };
    var rtlsa = exports2.tlsa = {};
    rtlsa.encode = function(cert, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(rtlsa.encodingLength(cert));
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      const certdata = cert.certificate;
      if (!Buffer2.isBuffer(certdata)) {
        throw new Error("Certificate must be a Buffer");
      }
      offset += 2;
      buf.writeUInt8(cert.usage, offset);
      offset += 1;
      buf.writeUInt8(cert.selector, offset);
      offset += 1;
      buf.writeUInt8(cert.matchingType, offset);
      offset += 1;
      certdata.copy(buf, offset, 0, certdata.length);
      offset += certdata.length;
      rtlsa.encode.bytes = offset - oldOffset;
      buf.writeUInt16BE(rtlsa.encode.bytes - 2, oldOffset);
      return buf;
    };
    rtlsa.encode.bytes = 0;
    rtlsa.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      const cert = {};
      const length = buf.readUInt16BE(offset);
      offset += 2;
      cert.usage = buf.readUInt8(offset);
      offset += 1;
      cert.selector = buf.readUInt8(offset);
      offset += 1;
      cert.matchingType = buf.readUInt8(offset);
      offset += 1;
      cert.certificate = buf.slice(offset, oldOffset + length + 2);
      offset += cert.certificate.length;
      rtlsa.decode.bytes = offset - oldOffset;
      return cert;
    };
    rtlsa.decode.bytes = 0;
    rtlsa.encodingLength = function(cert) {
      return 5 + Buffer2.byteLength(cert.certificate);
    };
    var renc = exports2.record = function(type) {
      switch (type.toUpperCase()) {
        case "A":
          return ra;
        case "PTR":
          return rptr;
        case "CNAME":
          return rcname;
        case "DNAME":
          return rdname;
        case "TXT":
          return rtxt;
        case "NULL":
          return rnull;
        case "AAAA":
          return raaaa;
        case "SRV":
          return rsrv;
        case "HINFO":
          return rhinfo;
        case "CAA":
          return rcaa;
        case "NS":
          return rns;
        case "SOA":
          return rsoa;
        case "MX":
          return rmx;
        case "OPT":
          return ropt;
        case "DNSKEY":
          return rdnskey;
        case "RRSIG":
          return rrrsig;
        case "RP":
          return rrp;
        case "NSEC":
          return rnsec;
        case "NSEC3":
          return rnsec3;
        case "SSHFP":
          return rsshfp;
        case "DS":
          return rds;
        case "NAPTR":
          return rnaptr;
        case "TLSA":
          return rtlsa;
      }
      return runknown;
    };
    var answer = exports2.answer = {};
    answer.encode = function(a, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(answer.encodingLength(a));
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      name.encode(a.name, buf, offset);
      offset += name.encode.bytes;
      buf.writeUInt16BE(types2.toType(a.type), offset);
      if (a.type.toUpperCase() === "OPT") {
        if (a.name !== ".") {
          throw new Error("OPT name must be root.");
        }
        buf.writeUInt16BE(a.udpPayloadSize || 4096, offset + 2);
        buf.writeUInt8(a.extendedRcode || 0, offset + 4);
        buf.writeUInt8(a.ednsVersion || 0, offset + 5);
        buf.writeUInt16BE(a.flags || 0, offset + 6);
        offset += 8;
        ropt.encode(a.options || [], buf, offset);
        offset += ropt.encode.bytes;
      } else {
        let klass = classes.toClass(a.class === void 0 ? "IN" : a.class);
        if (a.flush)
          klass |= FLUSH_MASK;
        buf.writeUInt16BE(klass, offset + 2);
        buf.writeUInt32BE(a.ttl || 0, offset + 4);
        offset += 8;
        const enc = renc(a.type);
        enc.encode(a.data, buf, offset);
        offset += enc.encode.bytes;
      }
      answer.encode.bytes = offset - oldOffset;
      return buf;
    };
    answer.encode.bytes = 0;
    answer.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const a = {};
      const oldOffset = offset;
      a.name = name.decode(buf, offset);
      offset += name.decode.bytes;
      a.type = types2.toString(buf.readUInt16BE(offset));
      if (a.type === "OPT") {
        a.udpPayloadSize = buf.readUInt16BE(offset + 2);
        a.extendedRcode = buf.readUInt8(offset + 4);
        a.ednsVersion = buf.readUInt8(offset + 5);
        a.flags = buf.readUInt16BE(offset + 6);
        a.flag_do = (a.flags >> 15 & 1) === 1;
        a.options = ropt.decode(buf, offset + 8);
        offset += 8 + ropt.decode.bytes;
      } else {
        const klass = buf.readUInt16BE(offset + 2);
        a.ttl = buf.readUInt32BE(offset + 4);
        a.class = classes.toString(klass & NOT_FLUSH_MASK);
        a.flush = !!(klass & FLUSH_MASK);
        const enc = renc(a.type);
        a.data = enc.decode(buf, offset + 8);
        offset += 8 + enc.decode.bytes;
      }
      answer.decode.bytes = offset - oldOffset;
      return a;
    };
    answer.decode.bytes = 0;
    answer.encodingLength = function(a) {
      const data = a.data !== null && a.data !== void 0 ? a.data : a.options;
      return name.encodingLength(a.name) + 8 + renc(a.type).encodingLength(data);
    };
    var question = exports2.question = {};
    question.encode = function(q2, buf, offset) {
      if (!buf)
        buf = Buffer2.alloc(question.encodingLength(q2));
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      name.encode(q2.name, buf, offset);
      offset += name.encode.bytes;
      buf.writeUInt16BE(types2.toType(q2.type), offset);
      offset += 2;
      buf.writeUInt16BE(classes.toClass(q2.class === void 0 ? "IN" : q2.class), offset);
      offset += 2;
      question.encode.bytes = offset - oldOffset;
      return q2;
    };
    question.encode.bytes = 0;
    question.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      const q2 = {};
      q2.name = name.decode(buf, offset);
      offset += name.decode.bytes;
      q2.type = types2.toString(buf.readUInt16BE(offset));
      offset += 2;
      q2.class = classes.toString(buf.readUInt16BE(offset));
      offset += 2;
      const qu = !!(q2.class & QU_MASK);
      if (qu)
        q2.class &= NOT_QU_MASK;
      question.decode.bytes = offset - oldOffset;
      return q2;
    };
    question.decode.bytes = 0;
    question.encodingLength = function(q2) {
      return name.encodingLength(q2.name) + 4;
    };
    exports2.AUTHORITATIVE_ANSWER = 1 << 10;
    exports2.TRUNCATED_RESPONSE = 1 << 9;
    exports2.RECURSION_DESIRED = 1 << 8;
    exports2.RECURSION_AVAILABLE = 1 << 7;
    exports2.AUTHENTIC_DATA = 1 << 5;
    exports2.CHECKING_DISABLED = 1 << 4;
    exports2.DNSSEC_OK = 1 << 15;
    exports2.encode = function(result2, buf, offset) {
      const allocing = !buf;
      if (allocing)
        buf = Buffer2.alloc(exports2.encodingLength(result2));
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      if (!result2.questions)
        result2.questions = [];
      if (!result2.answers)
        result2.answers = [];
      if (!result2.authorities)
        result2.authorities = [];
      if (!result2.additionals)
        result2.additionals = [];
      header.encode(result2, buf, offset);
      offset += header.encode.bytes;
      offset = encodeList(result2.questions, question, buf, offset);
      offset = encodeList(result2.answers, answer, buf, offset);
      offset = encodeList(result2.authorities, answer, buf, offset);
      offset = encodeList(result2.additionals, answer, buf, offset);
      exports2.encode.bytes = offset - oldOffset;
      if (allocing && exports2.encode.bytes !== buf.length) {
        return buf.slice(0, exports2.encode.bytes);
      }
      return buf;
    };
    exports2.encode.bytes = 0;
    exports2.decode = function(buf, offset) {
      if (!offset)
        offset = 0;
      const oldOffset = offset;
      const result2 = header.decode(buf, offset);
      offset += header.decode.bytes;
      offset = decodeList(result2.questions, question, buf, offset);
      offset = decodeList(result2.answers, answer, buf, offset);
      offset = decodeList(result2.authorities, answer, buf, offset);
      offset = decodeList(result2.additionals, answer, buf, offset);
      exports2.decode.bytes = offset - oldOffset;
      return result2;
    };
    exports2.decode.bytes = 0;
    exports2.encodingLength = function(result2) {
      return header.encodingLength(result2) + encodingLengthList(result2.questions || [], question) + encodingLengthList(result2.answers || [], answer) + encodingLengthList(result2.authorities || [], answer) + encodingLengthList(result2.additionals || [], answer);
    };
    exports2.streamEncode = function(result2) {
      const buf = exports2.encode(result2);
      const sbuf = Buffer2.alloc(2);
      sbuf.writeUInt16BE(buf.byteLength);
      const combine = Buffer2.concat([sbuf, buf]);
      exports2.streamEncode.bytes = combine.byteLength;
      return combine;
    };
    exports2.streamEncode.bytes = 0;
    exports2.streamDecode = function(sbuf) {
      const len = sbuf.readUInt16BE(0);
      if (sbuf.byteLength < len + 2) {
        return null;
      }
      const result2 = exports2.decode(sbuf.slice(2));
      exports2.streamDecode.bytes = exports2.decode.bytes;
      return result2;
    };
    exports2.streamDecode.bytes = 0;
    function encodingLengthList(list, enc) {
      let len = 0;
      for (let i = 0; i < list.length; i++)
        len += enc.encodingLength(list[i]);
      return len;
    }
    function encodeList(list, enc, buf, offset) {
      for (let i = 0; i < list.length; i++) {
        enc.encode(list[i], buf, offset);
        offset += enc.encode.bytes;
      }
      return offset;
    }
    function decodeList(list, enc, buf, offset) {
      for (let i = 0; i < list.length; i++) {
        list[i] = enc.decode(buf, offset);
        offset += enc.decode.bytes;
      }
      return offset;
    }
  }
});

// node_modules/thunky/index.js
var require_thunky = __commonJS({
  "node_modules/thunky/index.js"(exports2, module2) {
    "use strict";
    var nextTick = nextTickArgs;
    process.nextTick(upgrade, 42);
    module2.exports = thunky;
    function thunky(fn) {
      var state = run;
      return thunk;
      function thunk(callback) {
        state(callback || noop);
      }
      function run(callback) {
        var stack = [callback];
        state = wait;
        fn(done);
        function wait(callback2) {
          stack.push(callback2);
        }
        function done(err) {
          var args = arguments;
          state = isError(err) ? run : finished;
          while (stack.length)
            finished(stack.shift());
          function finished(callback2) {
            nextTick(apply, callback2, args);
          }
        }
      }
    }
    function isError(err) {
      return Object.prototype.toString.call(err) === "[object Error]";
    }
    function noop() {
    }
    function apply(callback, args) {
      callback.apply(null, args);
    }
    function upgrade(val) {
      if (val === 42)
        nextTick = process.nextTick;
    }
    function nextTickArgs(fn, a, b) {
      process.nextTick(function() {
        fn(a, b);
      });
    }
  }
});

// node_modules/multicast-dns/index.js
var require_multicast_dns = __commonJS({
  "node_modules/multicast-dns/index.js"(exports2, module2) {
    var packet = require_dns_packet();
    var dgram = require("dgram");
    var thunky = require_thunky();
    var events = require("events");
    var os2 = require("os");
    var noop = function() {
    };
    module2.exports = function(opts) {
      if (!opts)
        opts = {};
      var that = new events.EventEmitter();
      var port2 = typeof opts.port === "number" ? opts.port : 5353;
      var type = opts.type || "udp4";
      var ip = opts.ip || opts.host || (type === "udp4" ? "224.0.0.251" : null);
      var me = { address: ip, port: port2 };
      var memberships = {};
      var destroyed = false;
      var interval = null;
      if (type === "udp6" && (!ip || !opts.interface)) {
        throw new Error("For IPv6 multicast you must specify `ip` and `interface`");
      }
      var socket = opts.socket || dgram.createSocket({
        type,
        reuseAddr: opts.reuseAddr !== false,
        toString: function() {
          return type;
        }
      });
      socket.on("error", function(err) {
        if (err.code === "EACCES" || err.code === "EADDRINUSE")
          that.emit("error", err);
        else
          that.emit("warning", err);
      });
      socket.on("message", function(message, rinfo) {
        try {
          message = packet.decode(message);
        } catch (err) {
          that.emit("warning", err);
          return;
        }
        that.emit("packet", message, rinfo);
        if (message.type === "query")
          that.emit("query", message, rinfo);
        if (message.type === "response")
          that.emit("response", message, rinfo);
      });
      socket.on("listening", function() {
        if (!port2)
          port2 = me.port = socket.address().port;
        if (opts.multicast !== false) {
          that.update();
          interval = setInterval(that.update, 5e3);
          socket.setMulticastTTL(opts.ttl || 255);
          socket.setMulticastLoopback(opts.loopback !== false);
        }
      });
      var bind = thunky(function(cb) {
        if (!port2 || opts.bind === false)
          return cb(null);
        socket.once("error", cb);
        socket.bind(port2, opts.bind || opts.interface, function() {
          socket.removeListener("error", cb);
          cb(null);
        });
      });
      bind(function(err) {
        if (err)
          return that.emit("error", err);
        that.emit("ready");
      });
      that.send = function(value, rinfo, cb) {
        if (typeof rinfo === "function")
          return that.send(value, null, rinfo);
        if (!cb)
          cb = noop;
        if (!rinfo)
          rinfo = me;
        else if (!rinfo.host && !rinfo.address)
          rinfo.address = me.address;
        bind(onbind);
        function onbind(err) {
          if (destroyed)
            return cb();
          if (err)
            return cb(err);
          var message = packet.encode(value);
          socket.send(message, 0, message.length, rinfo.port, rinfo.address || rinfo.host, cb);
        }
      };
      that.response = that.respond = function(res, rinfo, cb) {
        if (Array.isArray(res))
          res = { answers: res };
        res.type = "response";
        res.flags = (res.flags || 0) | packet.AUTHORITATIVE_ANSWER;
        that.send(res, rinfo, cb);
      };
      that.query = function(q2, type2, rinfo, cb) {
        if (typeof type2 === "function")
          return that.query(q2, null, null, type2);
        if (typeof type2 === "object" && type2 && type2.port)
          return that.query(q2, null, type2, rinfo);
        if (typeof rinfo === "function")
          return that.query(q2, type2, null, rinfo);
        if (!cb)
          cb = noop;
        if (typeof q2 === "string")
          q2 = [{ name: q2, type: type2 || "ANY" }];
        if (Array.isArray(q2))
          q2 = { type: "query", questions: q2 };
        q2.type = "query";
        that.send(q2, rinfo, cb);
      };
      that.destroy = function(cb) {
        if (!cb)
          cb = noop;
        if (destroyed)
          return process.nextTick(cb);
        destroyed = true;
        clearInterval(interval);
        for (var iface in memberships) {
          try {
            socket.dropMembership(ip, iface);
          } catch (e) {
          }
        }
        memberships = {};
        socket.close(cb);
      };
      that.update = function() {
        var ifaces = opts.interface ? [].concat(opts.interface) : allInterfaces();
        var updated = false;
        for (var i = 0; i < ifaces.length; i++) {
          var addr = ifaces[i];
          if (memberships[addr])
            continue;
          try {
            socket.addMembership(ip, addr);
            memberships[addr] = true;
            updated = true;
          } catch (err) {
            that.emit("warning", err);
          }
        }
        if (updated) {
          if (socket.setMulticastInterface) {
            try {
              socket.setMulticastInterface(opts.interface || defaultInterface());
            } catch (err) {
              that.emit("warning", err);
            }
          }
          that.emit("networkInterface");
        }
      };
      return that;
    };
    function defaultInterface() {
      var networks = os2.networkInterfaces();
      var names = Object.keys(networks);
      for (var i = 0; i < names.length; i++) {
        var net = networks[names[i]];
        for (var j = 0; j < net.length; j++) {
          var iface = net[j];
          if (isIPv4(iface.family) && !iface.internal) {
            if (os2.platform() === "darwin" && names[i] === "en0")
              return iface.address;
            return "0.0.0.0";
          }
        }
      }
      return "127.0.0.1";
    }
    function allInterfaces() {
      var networks = os2.networkInterfaces();
      var names = Object.keys(networks);
      var res = [];
      for (var i = 0; i < names.length; i++) {
        var net = networks[names[i]];
        for (var j = 0; j < net.length; j++) {
          var iface = net[j];
          if (isIPv4(iface.family)) {
            res.push(iface.address);
            break;
          }
        }
      }
      return res;
    }
    function isIPv4(family) {
      return family === 4 || family === "IPv4";
    }
  }
});

// node_modules/sterfive-bonjour-service/dist/lib/mdns-server.js
var require_mdns_server = __commonJS({
  "node_modules/sterfive-bonjour-service/dist/lib/mdns-server.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Server = void 0;
    var array_flatten_1 = __importDefault3(require_array_flatten());
    var es6_1 = __importDefault3(require_es6());
    var dns_equal_1 = __importDefault3(require_dns_equal());
    var multicast_dns_1 = __importDefault3(require_multicast_dns());
    function makeIsDuplicateRecord(a) {
      return (b) => {
        return a.type === b.type && a.name === b.name && (0, es6_1.default)(a.data, b.data);
      };
    }
    function makeUnique() {
      const set = [];
      return (obj) => {
        if (~set.indexOf(obj))
          return false;
        set.push(obj);
        return true;
      };
    }
    var Server = class {
      constructor(opts, errorCallback) {
        this.registry = {};
        this.mdns = (0, multicast_dns_1.default)(opts);
        this.mdns.setMaxListeners(0);
        this.mdns.on("query", this.respondToQuery.bind(this));
        this.errorCallback = errorCallback !== null && errorCallback !== void 0 ? errorCallback : function(err) {
          throw err;
        };
      }
      register(records) {
        const shouldRegister = (record) => {
          let subRegistry = this.registry[record.type];
          if (!subRegistry) {
            subRegistry = this.registry[record.type] = [];
          } else if (subRegistry.some(makeIsDuplicateRecord(record))) {
            return;
          }
          subRegistry.push(record);
        };
        if (Array.isArray(records)) {
          records.forEach(shouldRegister);
        } else {
          shouldRegister(records);
        }
      }
      unregister(records) {
        const shouldUnregister = (record) => {
          let type = record.type;
          if (!(type in this.registry)) {
            return;
          }
          this.registry[type] = this.registry[type].filter((i) => i.name !== record.name);
        };
        if (Array.isArray(records)) {
          records.forEach(shouldUnregister);
        } else {
          shouldUnregister(records);
        }
      }
      respondToQuery(query) {
        let self2 = this;
        query.questions.forEach((question) => {
          const type = question.type;
          const name = question.name;
          const answers = type === "ANY" ? array_flatten_1.default.depth(Object.keys(self2.registry).map(self2.recordsFor.bind(self2, name)), 1) : self2.recordsFor(name, type);
          if (answers.length === 0)
            return;
          let additionals = [];
          if (type !== "ANY") {
            answers.forEach((answer) => {
              if (answer.type !== "PTR")
                return;
              additionals = additionals.concat(self2.recordsFor(answer.data, "SRV")).concat(self2.recordsFor(answer.data, "TXT"));
            });
            additionals.filter(function(record) {
              return record.type === "SRV";
            }).map(function(record) {
              return record.data.target;
            }).filter(makeUnique()).forEach(function(target) {
              additionals = additionals.concat(self2.recordsFor(target, "A")).concat(self2.recordsFor(target, "AAAA"));
            });
          }
          self2.mdns.respond({ answers, additionals }, (err) => {
            if (err) {
              this.errorCallback(err);
            }
          });
        });
      }
      recordsFor(name, type) {
        if (!(type in this.registry)) {
          return [];
        }
        return this.registry[type].filter((record) => {
          const _name = ~name.indexOf(".") ? record.name : record.name.split(".")[0];
          return (0, dns_equal_1.default)(_name, name);
        });
      }
    };
    exports2.Server = Server;
    exports2.default = Server;
  }
});

// node_modules/sterfive-bonjour-service/dist/lib/browser.js
var require_browser2 = __commonJS({
  "node_modules/sterfive-bonjour-service/dist/lib/browser.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Browser = void 0;
    var events_1 = require("events");
    var service_types_1 = require_service_types();
    var dns_txt_1 = __importDefault3(require_dns_txt());
    var dnsEqual = require_dns_equal();
    var TLD = ".local";
    var WILDCARD = "_services._dns-sd._udp" + TLD;
    var Browser = class _Browser extends events_1.EventEmitter {
      constructor(mdns, opts, onup) {
        super();
        this.serviceMap = {};
        this.wildcard = false;
        this._services = [];
        if (typeof opts === "function")
          return new _Browser(mdns, null, opts);
        this.mdns = mdns;
        if (opts != null && opts.txt != null) {
          this.txt = new dns_txt_1.default(opts.txt);
        } else {
          this.txt = new dns_txt_1.default();
        }
        if (!opts || !opts.type) {
          this.name = WILDCARD;
          this.wildcard = true;
        } else {
          this.name = (0, service_types_1.toString)({ name: opts.type, protocol: opts.protocol || "tcp" }) + TLD;
          if (opts.name)
            this.name = opts.name + "." + this.name;
          this.wildcard = false;
        }
        if (onup)
          this.on("up", onup);
        this.start();
      }
      start() {
        var _a;
        if (this.onresponse || this.name === void 0)
          return;
        const self2 = this;
        const nameMap = {};
        if (!this.wildcard)
          nameMap[this.name] = true;
        this.onresponse = (packet, rinfo) => {
          if (self2.wildcard) {
            packet.answers.forEach((answer) => {
              var _a2;
              if (answer.type !== "PTR" || answer.name !== self2.name || answer.name in nameMap)
                return;
              nameMap[answer.data] = true;
              (_a2 = self2.mdns) === null || _a2 === void 0 ? void 0 : _a2.query(answer.data, "PTR");
            });
          }
          Object.keys(nameMap).forEach((name) => {
            self2.goodbyes(name, packet).forEach(self2.removeService.bind(self2));
            const matches = self2.buildServicesFor(name, packet, self2.txt, rinfo);
            if (matches.length === 0)
              return;
            matches.forEach((service) => {
              if (self2.serviceMap[service.fqdn])
                return;
              self2.addService(service);
            });
          });
        };
        (_a = this.mdns) === null || _a === void 0 ? void 0 : _a.on("response", this.onresponse);
        this.update();
      }
      stop() {
        var _a;
        if (!this.onresponse)
          return;
        (_a = this.mdns) === null || _a === void 0 ? void 0 : _a.removeListener("response", this.onresponse);
        this.onresponse = void 0;
      }
      update() {
        var _a;
        (_a = this.mdns) === null || _a === void 0 ? void 0 : _a.query(this.name || "", "PTR");
      }
      get services() {
        return this._services;
      }
      addService(service) {
        this._services.push(service);
        this.serviceMap[service.fqdn] = true;
        this.emit("up", service);
      }
      removeService(fqdn) {
        let service, index;
        this._services.some(function(s, i) {
          if (dnsEqual(s.fqdn, fqdn)) {
            service = s;
            index = i;
            return true;
          }
        });
        if (!service || index === void 0)
          return;
        this._services.splice(index, 1);
        delete this.serviceMap[fqdn];
        this.emit("down", service);
      }
      // PTR records with a TTL of 0 is considered a "goodbye" announcement. I.e. a
      // DNS response broadcasted when a service shuts down in order to let the
      // network know that the service is no longer going to be available.
      //
      // For more info see:
      // https://tools.ietf.org/html/rfc6762#section-8.4
      //
      // This function returns an array of all resource records considered a goodbye
      // record
      goodbyes(name, packet) {
        return packet.answers.concat(packet.additionals).filter((rr) => rr.type === "PTR" && rr.ttl === 0 && dnsEqual(rr.name, name)).map((rr) => rr.data);
      }
      buildServicesFor(name, packet, txt, referer) {
        const records = packet.answers.concat(packet.additionals).filter((rr) => rr.ttl > 0);
        return records.filter((rr) => rr.type === "PTR" && dnsEqual(rr.name, name)).map((ptr) => {
          const service = {
            addresses: []
          };
          records.filter((rr) => {
            return (rr.type === "SRV" || rr.type === "TXT") && dnsEqual(rr.name, ptr.data);
          }).forEach((rr) => {
            var _a;
            if (rr.type === "SRV") {
              const parts = rr.name.split(".");
              const name2 = parts[0];
              const types2 = (0, service_types_1.toType)(parts.slice(1, -1).join("."));
              service.name = name2;
              service.fqdn = rr.name;
              service.host = rr.data.target;
              service.referer = referer;
              service.port = rr.data.port;
              service.type = types2.name;
              service.protocol = types2.protocol;
              service.subtypes = types2.subtypes;
            } else if (rr.type === "TXT") {
              service.rawTxt = rr.data;
              service.txt = (_a = this.txt) === null || _a === void 0 ? void 0 : _a.decodeAll(rr.data);
            }
          });
          if (!service.name)
            return;
          records.filter((rr) => (rr.type === "A" || rr.type === "AAAA") && dnsEqual(rr.name, service.host)).forEach((rr) => service.addresses.push(rr.data));
          return service;
        }).filter((rr) => !!rr);
      }
    };
    exports2.Browser = Browser;
    exports2.default = Browser;
  }
});

// node_modules/sterfive-bonjour-service/dist/index.js
var require_dist47 = __commonJS({
  "node_modules/sterfive-bonjour-service/dist/index.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Browser = exports2.Service = exports2.Bonjour = void 0;
    var registry_1 = __importDefault3(require_registry3());
    var mdns_server_1 = __importDefault3(require_mdns_server());
    var browser_1 = __importDefault3(require_browser2());
    exports2.Browser = browser_1.default;
    var service_1 = __importDefault3(require_service());
    exports2.Service = service_1.default;
    var Bonjour = class {
      /**
       * Setup bonjour service with optional config
       * @param opts ServiceConfig | undefined
       * @param errorCallback Function | undefined
       */
      constructor(opts, errorCallback) {
        this.server = new mdns_server_1.default(opts, errorCallback);
        this.registry = new registry_1.default(this.server);
      }
      /**
       * Publish a service for the device with options
       * @param opts
       * @returns
       */
      publish(opts) {
        return this.registry.publish(opts);
      }
      /**
       * Unpublish all services for the device
       * @param callback
       * @returns
       */
      unpublishAll(callback) {
        return this.registry.unpublishAll(callback);
      }
      /**
       * Find services on the network with options
       * @param opts BrowserConfig
       * @param onup Callback when up event received
       * @returns
       */
      find(opts = void 0, onup) {
        return new browser_1.default(this.server.mdns, opts, onup);
      }
      /**
       * Find a single device and close browser
       * @param opts BrowserConfig
       * @param timeout Timeout (ms) if not device is found, default 10s
       * @param callback Callback when device found
       * @returns
       */
      findOne(opts = void 0, timeout = 1e4, callback) {
        if (this.timerId) {
          clearTimeout(this.timerId);
          this.timerId = void 0;
        }
        const browser = new browser_1.default(this.server.mdns, opts);
        browser.once("up", (service) => {
          if (this.timerId !== void 0) {
            clearTimeout(this.timerId);
            this.timerId = void 0;
          }
          browser.stop();
          if (callback)
            callback(service);
        });
        this.timerId = setTimeout(() => {
          browser.stop();
          if (callback)
            callback(null);
        }, timeout);
        return browser;
      }
      /**
       * Destroy the class
       */
      destroy(callback) {
        if (this.timerId) {
          clearTimeout(this.timerId);
          this.timerId = void 0;
        }
        this.registry.destroy();
        this.server.mdns.destroy(callback);
      }
    };
    exports2.Bonjour = Bonjour;
    exports2.default = Bonjour;
  }
});

// node_modules/node-opcua-service-discovery/dist/bonjour.js
var require_bonjour = __commonJS({
  "node_modules/node-opcua-service-discovery/dist/bonjour.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.BonjourHolder = exports2._announceServerOnMulticastSubnet = exports2.serviceToString = exports2.isSameService = exports2.announcementToServiceConfig = exports2.releaseBonjour2 = exports2.acquireBonjour2 = exports2.releaseBonjour = exports2.acquireBonjour = void 0;
    var util_1 = require("util");
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_object_registry_1 = require_dist46();
    var sterfive_bonjour_service_1 = require_dist47();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var gBonjour;
    var gBonjourRefCount = 0;
    var registry = new node_opcua_object_registry_1.ObjectRegistry();
    function errorCallback(err) {
      errorLog(" ERROR received from Bonjour", err.message);
    }
    function acquireBonjour() {
      const bonjour = new sterfive_bonjour_service_1.Bonjour();
      registry.unregister(bonjour);
      return bonjour;
    }
    exports2.acquireBonjour = acquireBonjour;
    function releaseBonjour(bonjour, callback) {
      bonjour.unpublishAll(() => {
        bonjour.destroy(callback);
        registry.unregister(bonjour);
      });
    }
    exports2.releaseBonjour = releaseBonjour;
    function acquireBonjour2() {
      if (gBonjourRefCount === 0) {
        debugLog("Starting Bonjour");
        gBonjour = new sterfive_bonjour_service_1.Bonjour(void 0, errorCallback);
        registry.register(gBonjour);
      }
      gBonjourRefCount++;
      return gBonjour;
    }
    exports2.acquireBonjour2 = acquireBonjour2;
    function releaseBonjour2(bonjour) {
      gBonjourRefCount--;
      (0, node_opcua_assert_1.assert)(gBonjourRefCount >= 0);
      if (gBonjourRefCount === 0) {
        if (!gBonjour) {
          throw new Error("internal error");
        }
        const tmp = gBonjour;
        gBonjour = void 0;
        tmp.unpublishAll(() => {
          tmp.destroy();
          registry.unregister(tmp);
          debugLog("Releasing Bonjour");
        });
      }
    }
    exports2.releaseBonjour2 = releaseBonjour2;
    function announcementToServiceConfig(announcement) {
      const serviceConfig = {
        name: announcement.name,
        port: announcement.port,
        protocol: "tcp",
        host: announcement.host,
        txt: {
          caps: announcement.capabilities.sort().join(","),
          path: announcement.path
        },
        type: "opcua-tcp"
      };
      return serviceConfig;
    }
    exports2.announcementToServiceConfig = announcementToServiceConfig;
    function isSameService(a, b) {
      if (!a && !b) {
        return true;
      }
      if (!a || !b) {
        return false;
      }
      return a.port === b.port && a.txt?.path === b.txt?.path && a.name === b.name && a.txt?.caps === b.txt?.caps;
    }
    exports2.isSameService = isSameService;
    var serviceToString = (service) => {
      return "host" + service.host + " type=" + service.type + service.name + " on port " + service.port + " txt " + JSON.stringify(service.txt);
    };
    exports2.serviceToString = serviceToString;
    async function _announceServerOnMulticastSubnet(multicastDNS, serviceConfig) {
      return new Promise((resolve2, reject) => {
        const port2 = serviceConfig.port;
        (0, node_opcua_assert_1.assert)(typeof port2 === "number");
        (0, node_opcua_assert_1.assert)(multicastDNS, "bonjour must have been initialized?");
        debugLog(chalk_1.default.cyan("  announceServerOnMulticastSubnet", (0, exports2.serviceToString)(serviceConfig)));
        const service = multicastDNS.publish({ ...serviceConfig, probe: false });
        service.on("error", (err) => {
          debugLog("bonjour ERROR received ! ", err.message);
          debugLog("params = ", serviceConfig);
        });
        service.on("up", () => {
          debugLog("_announceServerOnMulticastSubnet: bonjour UP received ! ", (0, exports2.serviceToString)(serviceConfig));
          resolve2(service);
        });
        service.start();
      });
    }
    exports2._announceServerOnMulticastSubnet = _announceServerOnMulticastSubnet;
    var BonjourHolder = class {
      constructor() {
        this.pendingAnnouncement = false;
      }
      /**
       *
       * @param announcement
       * @returns
       */
      async announcedOnMulticastSubnet(announcement) {
        debugLog(chalk_1.default.yellow("\n\nentering announcedOnMulticastSubnet"));
        const serviceConfig = announcementToServiceConfig(announcement);
        if (this._service && this.serviceConfig) {
          if (isSameService(serviceConfig, this.serviceConfig)) {
            debugLog(" Announcement ignored as it has been already made", announcement.name);
            debugLog("exiting announcedOnMulticastSubnet-2", false);
            return false;
          }
        }
        (0, node_opcua_assert_1.assert)(!this._multicastDNS, "already called ?");
        this._multicastDNS = acquireBonjour();
        this.pendingAnnouncement = true;
        this.serviceConfig = serviceConfig;
        this._service = await _announceServerOnMulticastSubnet(this._multicastDNS, serviceConfig);
        this.pendingAnnouncement = false;
        debugLog(chalk_1.default.yellow("exiting announcedOnMulticastSubnet-3", true));
        return true;
      }
      isStarted() {
        return !!this._multicastDNS;
      }
      /**
       *
       * @param announcement
       * @param callback
       * @private
       */
      announcedOnMulticastSubnetWithCallback(announcement, callback) {
        callback(new Error("Internal Error"));
      }
      /**
       * @private
       */
      async stopAnnouncedOnMulticastSubnet() {
        if (this.pendingAnnouncement) {
          debugLog(chalk_1.default.bgWhite.redBright("stopAnnnouncedOnMulticastSubnet is pending : let's wait a little bit and try again"));
          await new Promise((resolve2) => setTimeout(resolve2, 500));
          return this.stopAnnouncedOnMulticastSubnet();
        }
        debugLog(chalk_1.default.green("\n\nentering stop_announcedOnMulticastSubnet = ", this.serviceConfig ? (0, exports2.serviceToString)(this.serviceConfig) : "<null>"));
        if (!this._service) {
          debugLog(chalk_1.default.green("leaving stop_announcedOnMulticastSubnet = no service"));
          return;
        }
        const that_service = this._service;
        const that_multicastDNS = this._multicastDNS;
        this._service = void 0;
        this._multicastDNS = void 0;
        this.serviceConfig = void 0;
        const proxy = (callback) => {
          if (that_multicastDNS && that_service.stop) {
            that_service.stop((err) => {
              debugLog(chalk_1.default.green("service stopped err=", err));
              that_multicastDNS.unpublishAll(() => {
                releaseBonjour(that_multicastDNS, () => {
                  callback();
                });
              });
            });
            return;
          } else {
            callback();
          }
        };
        const stop = (0, util_1.promisify)(proxy);
        await stop.call(this);
        debugLog(chalk_1.default.green("leaving stop_announcedOnMulticastSubnet = done"));
        debugLog(chalk_1.default.green("leaving stop_announcedOnMulticastSubnet stop announcement completed"));
      }
      stopAnnouncedOnMulticastSubnetWithCallback(callback) {
        callback(new Error("Internal Error"));
      }
    };
    exports2.BonjourHolder = BonjourHolder;
    BonjourHolder.prototype.announcedOnMulticastSubnetWithCallback = (0, util_1.callbackify)(BonjourHolder.prototype.announcedOnMulticastSubnet);
    BonjourHolder.prototype.stopAnnouncedOnMulticastSubnetWithCallback = (0, util_1.callbackify)(BonjourHolder.prototype.stopAnnouncedOnMulticastSubnet);
  }
});

// node_modules/node-opcua-service-discovery/dist/index.js
var require_dist48 = __commonJS({
  "node_modules/node-opcua-service-discovery/dist/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.serviceToString = exports2.announcementToServiceConfig = exports2._announceServerOnMulticastSubnet = exports2.sameService = exports2.BonjourHolder = exports2.serverCapabilities = exports2.ServerOnNetwork = exports2.FindServersOnNetworkResponse = exports2.FindServersOnNetworkRequest = exports2.FindServersResponse = exports2.FindServersRequest = exports2.RegisterServer2Response = exports2.RegisterServer2Request = exports2.MdnsDiscoveryConfiguration = exports2.RegisterServerResponse = exports2.RegisterServerRequest = exports2.RegisteredServer = void 0;
    var node_opcua_types_1 = require_dist32();
    Object.defineProperty(exports2, "RegisteredServer", { enumerable: true, get: function() {
      return node_opcua_types_1.RegisteredServer;
    } });
    Object.defineProperty(exports2, "RegisterServerRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.RegisterServerRequest;
    } });
    Object.defineProperty(exports2, "RegisterServerResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.RegisterServerResponse;
    } });
    Object.defineProperty(exports2, "MdnsDiscoveryConfiguration", { enumerable: true, get: function() {
      return node_opcua_types_1.MdnsDiscoveryConfiguration;
    } });
    Object.defineProperty(exports2, "RegisterServer2Request", { enumerable: true, get: function() {
      return node_opcua_types_1.RegisterServer2Request;
    } });
    Object.defineProperty(exports2, "RegisterServer2Response", { enumerable: true, get: function() {
      return node_opcua_types_1.RegisterServer2Response;
    } });
    Object.defineProperty(exports2, "FindServersRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.FindServersRequest;
    } });
    Object.defineProperty(exports2, "FindServersResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.FindServersResponse;
    } });
    Object.defineProperty(exports2, "FindServersOnNetworkRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.FindServersOnNetworkRequest;
    } });
    Object.defineProperty(exports2, "FindServersOnNetworkResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.FindServersOnNetworkResponse;
    } });
    Object.defineProperty(exports2, "ServerOnNetwork", { enumerable: true, get: function() {
      return node_opcua_types_1.ServerOnNetwork;
    } });
    var server_capabilities_1 = require_server_capabilities();
    Object.defineProperty(exports2, "serverCapabilities", { enumerable: true, get: function() {
      return server_capabilities_1.serverCapabilities;
    } });
    var bonjour_1 = require_bonjour();
    Object.defineProperty(exports2, "BonjourHolder", { enumerable: true, get: function() {
      return bonjour_1.BonjourHolder;
    } });
    Object.defineProperty(exports2, "sameService", { enumerable: true, get: function() {
      return bonjour_1.isSameService;
    } });
    Object.defineProperty(exports2, "_announceServerOnMulticastSubnet", { enumerable: true, get: function() {
      return bonjour_1._announceServerOnMulticastSubnet;
    } });
    Object.defineProperty(exports2, "announcementToServiceConfig", { enumerable: true, get: function() {
      return bonjour_1.announcementToServiceConfig;
    } });
    Object.defineProperty(exports2, "serviceToString", { enumerable: true, get: function() {
      return bonjour_1.serviceToString;
    } });
  }
});

// node_modules/node-opcua-service-translate-browse-path/dist/imports.js
var require_imports2 = __commonJS({
  "node_modules/node-opcua-service-translate-browse-path/dist/imports.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.TranslateBrowsePathsToNodeIdsResponse = exports2.BrowsePathResult = exports2.BrowsePathTarget = exports2.TranslateBrowsePathsToNodeIdsRequest = exports2.BrowsePath = exports2.RelativePath = exports2.RelativePathElement = void 0;
    var node_opcua_types_1 = require_dist32();
    Object.defineProperty(exports2, "RelativePathElement", { enumerable: true, get: function() {
      return node_opcua_types_1.RelativePathElement;
    } });
    Object.defineProperty(exports2, "RelativePath", { enumerable: true, get: function() {
      return node_opcua_types_1.RelativePath;
    } });
    Object.defineProperty(exports2, "BrowsePath", { enumerable: true, get: function() {
      return node_opcua_types_1.BrowsePath;
    } });
    Object.defineProperty(exports2, "TranslateBrowsePathsToNodeIdsRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.TranslateBrowsePathsToNodeIdsRequest;
    } });
    Object.defineProperty(exports2, "BrowsePathTarget", { enumerable: true, get: function() {
      return node_opcua_types_1.BrowsePathTarget;
    } });
    Object.defineProperty(exports2, "BrowsePathResult", { enumerable: true, get: function() {
      return node_opcua_types_1.BrowsePathResult;
    } });
    Object.defineProperty(exports2, "TranslateBrowsePathsToNodeIdsResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.TranslateBrowsePathsToNodeIdsResponse;
    } });
  }
});

// node_modules/node-opcua-service-translate-browse-path/dist/make_relative_path.js
var require_make_relative_path = __commonJS({
  "node_modules/node-opcua-service-translate-browse-path/dist/make_relative_path.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.makeRelativePath = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_types_1 = require_dist32();
    var hierarchicalReferenceTypeNodeId = (0, node_opcua_nodeid_1.resolveNodeId)("HierarchicalReferences");
    var aggregatesReferenceTypeNodeId = (0, node_opcua_nodeid_1.resolveNodeId)("Aggregates");
    var regCharacters = /[^/.<>:#!&]/;
    var regReservedCharacters = /[/.<>:#!&]/;
    var regName = new RegExp("(" + regCharacters.source + "|(&" + regReservedCharacters.source + "))+");
    var regNamespaceIndex = /[0-9]+/;
    var regBrowseName = new RegExp("(" + regNamespaceIndex.source + ":)?(" + regName.source + ")");
    var regReferenceType = new RegExp("/|\\.|(<(#)?(!)?(" + regBrowseName.source + ")>)");
    var regRelativePath = new RegExp("(" + regReferenceType.source + ")(" + regBrowseName.source + ")?");
    function unescape2(str) {
      return str.replace(/&/g, "");
    }
    function makeQualifiedName(mm) {
      const strName = mm[10];
      if (!strName || strName.length === 0) {
        return new node_opcua_data_model_1.QualifiedName({});
      }
      const namespaceIndex = mm[11] ? parseInt(mm[11], 10) : 0;
      const name = unescape2(mm[12]);
      return new node_opcua_data_model_1.QualifiedName({ namespaceIndex, name });
    }
    function makeRelativePath(str, addressSpace) {
      let r = {
        elements: []
      };
      const originalStr = str;
      while (str.length > 0) {
        const matches = str.match(regRelativePath);
        if (!matches) {
          throw new Error("Malformed relative path  :'" + str + "' in " + originalStr);
        }
        let referenceTypeId;
        let includeSubtypes;
        let isInverse;
        const refStr = matches[1];
        if (refStr === "/") {
          referenceTypeId = hierarchicalReferenceTypeNodeId;
          isInverse = false;
          includeSubtypes = true;
        } else if (refStr === ".") {
          referenceTypeId = aggregatesReferenceTypeNodeId;
          isInverse = false;
          includeSubtypes = true;
        } else {
          includeSubtypes = matches[3] !== "#";
          isInverse = matches[4] === "!";
          const ns = matches[6] ? parseInt(matches[6], 10) : 0;
          const name = matches[7];
          if (!matches[6]) {
            referenceTypeId = (0, node_opcua_nodeid_1.resolveNodeId)(name);
          } else {
            referenceTypeId = addressSpace.findReferenceType(name, ns);
          }
          (0, node_opcua_assert_1.assert)(referenceTypeId && !referenceTypeId.isEmpty());
        }
        const targetName = makeQualifiedName(matches);
        r.elements.push({ referenceTypeId, isInverse, includeSubtypes, targetName });
        str = str.substring(matches[0].length);
      }
      r = new node_opcua_types_1.RelativePath(r);
      return r;
    }
    exports2.makeRelativePath = makeRelativePath;
  }
});

// node_modules/node-opcua-service-translate-browse-path/dist/make_browse_path.js
var require_make_browse_path = __commonJS({
  "node_modules/node-opcua-service-translate-browse-path/dist/make_browse_path.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.makeBrowsePath = void 0;
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_types_1 = require_dist32();
    var make_relative_path_1 = require_make_relative_path();
    function _get_nodeId(node) {
      if (Object.prototype.hasOwnProperty.call(node, "nodeId")) {
        return node.nodeId;
      }
      return (0, node_opcua_nodeid_1.resolveNodeId)(node);
    }
    function makeBrowsePath(rootNode, relativePathBNF) {
      return new node_opcua_types_1.BrowsePath({
        startingNode: _get_nodeId(rootNode),
        relativePath: (0, make_relative_path_1.makeRelativePath)(relativePathBNF)
      });
    }
    exports2.makeBrowsePath = makeBrowsePath;
  }
});

// node_modules/node-opcua-service-translate-browse-path/dist/tools_browse_path.js
var require_tools_browse_path = __commonJS({
  "node_modules/node-opcua-service-translate-browse-path/dist/tools_browse_path.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.constructBrowsePathFromQualifiedName = exports2.stringToQualifiedName = void 0;
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_nodeid_1 = require_dist21();
    var imports_1 = require_imports2();
    var aggregatesReferencesId = (0, node_opcua_nodeid_1.makeNodeId)(node_opcua_constants_1.ReferenceTypeIds.Aggregates);
    var node_opcua_data_model_1 = require_dist27();
    Object.defineProperty(exports2, "stringToQualifiedName", { enumerable: true, get: function() {
      return node_opcua_data_model_1.stringToQualifiedName;
    } });
    function constructBrowsePathFromQualifiedName(startingNode, targetNames) {
      targetNames = targetNames || [];
      const elements = targetNames.map((targetName) => {
        return {
          isInverse: false,
          includeSubtypes: true,
          referenceTypeId: aggregatesReferencesId,
          targetName
        };
      });
      const browsePath = new imports_1.BrowsePath({
        relativePath: { elements },
        startingNode: startingNode.nodeId
        // ROOT
      });
      return browsePath;
    }
    exports2.constructBrowsePathFromQualifiedName = constructBrowsePathFromQualifiedName;
  }
});

// node_modules/node-opcua-service-translate-browse-path/dist/index.js
var require_dist49 = __commonJS({
  "node_modules/node-opcua-service-translate-browse-path/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_imports2(), exports2);
    __exportStar3(require_make_browse_path(), exports2);
    __exportStar3(require_make_relative_path(), exports2);
    __exportStar3(require_tools_browse_path(), exports2);
  }
});

// node_modules/node-opcua-service-query/dist/index.js
var require_dist50 = __commonJS({
  "node_modules/node-opcua-service-query/dist/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.QueryNextResponse = exports2.QueryNextRequest = exports2.QueryFirstResponse = exports2.QueryFirstRequest = exports2.QueryDataSet = exports2.QueryDataDescription = exports2.ParsingResult = exports2.NodeTypeDescription = void 0;
    var node_opcua_types_1 = require_dist32();
    Object.defineProperty(exports2, "NodeTypeDescription", { enumerable: true, get: function() {
      return node_opcua_types_1.NodeTypeDescription;
    } });
    Object.defineProperty(exports2, "ParsingResult", { enumerable: true, get: function() {
      return node_opcua_types_1.ParsingResult;
    } });
    Object.defineProperty(exports2, "QueryDataDescription", { enumerable: true, get: function() {
      return node_opcua_types_1.QueryDataDescription;
    } });
    Object.defineProperty(exports2, "QueryDataSet", { enumerable: true, get: function() {
      return node_opcua_types_1.QueryDataSet;
    } });
    Object.defineProperty(exports2, "QueryFirstRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.QueryFirstRequest;
    } });
    Object.defineProperty(exports2, "QueryFirstResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.QueryFirstResponse;
    } });
    Object.defineProperty(exports2, "QueryNextRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.QueryNextRequest;
    } });
    Object.defineProperty(exports2, "QueryNextResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.QueryNextResponse;
    } });
  }
});

// node_modules/node-opcua-service-node-management/dist/index.js
var require_dist51 = __commonJS({
  "node_modules/node-opcua-service-node-management/dist/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.DeleteReferencesResponse = exports2.DeleteReferencesRequest = exports2.DeleteNodesResponse = exports2.DeleteNodesRequest = exports2.AddReferencesResponse = exports2.AddReferencesRequest = exports2.AddNodesResponse = exports2.AddNodesRequest = void 0;
    var node_opcua_types_1 = require_dist32();
    Object.defineProperty(exports2, "AddNodesRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.AddNodesRequest;
    } });
    Object.defineProperty(exports2, "AddNodesResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.AddNodesResponse;
    } });
    Object.defineProperty(exports2, "AddReferencesRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.AddReferencesRequest;
    } });
    Object.defineProperty(exports2, "AddReferencesResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.AddReferencesResponse;
    } });
    Object.defineProperty(exports2, "DeleteNodesRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.DeleteNodesRequest;
    } });
    Object.defineProperty(exports2, "DeleteNodesResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.DeleteNodesResponse;
    } });
    Object.defineProperty(exports2, "DeleteReferencesRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.DeleteReferencesRequest;
    } });
    Object.defineProperty(exports2, "DeleteReferencesResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.DeleteReferencesResponse;
    } });
  }
});

// node_modules/node-opcua-nodesets/dist/nodeset_catalog.js
var require_nodeset_catalog = __commonJS({
  "node_modules/node-opcua-nodesets/dist/nodeset_catalog.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.nodesetCatalog = void 0;
    exports2.nodesetCatalog = [
      ["standard", "ua", "http://opcfoundation.org/UA/", "Opc.Ua.NodeSet2.xml", []],
      ["di", "di", "http://opcfoundation.org/UA/DI/", "Opc.Ua.Di.NodeSet2.xml", []],
      ["adi", "adi", "http://opcfoundation.org/UA/ADI/", "Opc.Ua.Adi.NodeSet2.xml", ["di"]],
      ["autoId", "auto-id", "http://opcfoundation.org/UA/AutoID/", "Opc.Ua.AutoID.NodeSet2.xml", ["di"]],
      ["machineVision", "machine-vision", "http://opcfoundation.org/UA/MachineVision", "Opc.Ua.MachineVision.NodeSet2.xml", []],
      [
        "commercialKitchenEquipment",
        "commercial-kitchen-equipment",
        "http://opcfoundation.org/UA/CommercialKitchenEquipment/",
        "Opc.Ua.CommercialKitchenEquipment.NodeSet2.xml",
        ["di"]
      ],
      ["gds", "gds", "http://opcfoundation.org/UA/GDS/", "Opc.Ua.Gds.NodeSet2.xml", []],
      ["robotics", "robotics", "http://opcfoundation.org/UA/Robotics/", "Opc.Ua.Robotics.NodeSet2.xml", ["di"]],
      ["machinery", "machinery", "http://opcfoundation.org/UA/Machinery/", "Opc.Ua.Machinery.NodeSet2.xml", []],
      ["ia", "ia", "http://opcfoundation.org/UA/IA/", "Opc.Ua.IA.NodeSet2.xml", ["di"]],
      [
        "machineTool",
        "machine-tool",
        "http://opcfoundation.org/UA/MachineTool/",
        "Opc.Ua.MachineTool.NodeSet2.xml",
        ["di", "machinery", "ia"]
      ],
      ["cnc", "cnc", "http://opcfoundation.org/UA/CNC", "Opc.Ua.CNC.NodeSet.xml", []],
      [
        "woodWorking",
        "woodworking",
        "http://opcfoundation.org/UA/Woodworking/",
        "Opc.Ua.Woodworking.NodeSet2.xml",
        ["di", "machinery"]
      ],
      ["glass", "glass-flat", "http://opcfoundation.org/UA/Glass/Flat/", "Opc.Ua.Glass.NodeSet2.xml", ["di", "machinery"]],
      ["tightening", "ijt", "http://opcfoundation.org/UA/IJT/", "Opc.Ua.Ijt.Tightening.NodeSet2.xml", ["di", "machinery"]],
      ["packML", "pack-ml", "http://opcfoundation.org/UA/PackML/", "Opc.Ua.PackML.NodeSet2.xml", []],
      ["iolink", "io-link", "http://opcfoundation.org/UA/IOLink/", "Opc.Ua.IOLink.NodeSet2.xml", ["di"]],
      ["iolinkIODD", "io-link-iodd", "http://opcfoundation.org/UA/IOLink/IODD/", "Opc.Ua.IOLinkIODD.NodeSet2.xml", []],
      ["irdi", "irdi", "http://opcfoundation.org/UA/Dictionary/IRDI", "Opc.Ua.IRDI.NodeSet2.xml", []],
      ["padim", "padim", "http://opcfoundation.org/UA/PADIM/", "Opc.Ua.PADIM.NodeSet2.xml", ["irdi", "di"]],
      [
        "machineryProcessValues",
        "machinery-process-values",
        "http://opcfoundation.org/UA/Machinery/ProcessValues/",
        "Opc.Ua.Machinery.ProcessValues.NodeSet2.xml",
        ["di", "irdi", "padim"]
      ],
      [
        "machineryResult",
        "machinery-result",
        "http://opcfoundation.org/UA/Machinery/Result/",
        "Opc.Ua.Machinery.Result.NodeSet2.xml",
        []
      ]
    ];
  }
});

// node_modules/node-opcua-nodesets/dist/nodeset_nodejs.js
var require_nodeset_nodejs = __commonJS({
  "node_modules/node-opcua-nodesets/dist/nodeset_nodejs.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.nodesets = exports2.allNodesetMeta = exports2.constructNodesetFilename = void 0;
    var fs_1 = __importDefault3(require("fs"));
    var path_1 = __importDefault3(require("path"));
    var nodeset_catalog_1 = require_nodeset_catalog();
    function constructNodesetFilename(filename) {
      const dirname = __dirname;
      let file = path_1.default.join(dirname, "../nodesets", filename);
      if (!fs_1.default.existsSync(file)) {
        if (!process.argv[1]) {
          throw new Error(`cannot find file ${file}
Please make sure that nodeset can be found in ${path_1.default.join(dirname, "../nodesets")}`);
        }
        let appFolder = path_1.default.dirname(process.argv[1]);
        file = path_1.default.join(appFolder, "nodesets", filename);
        if (!fs_1.default.existsSync(file)) {
          appFolder = process.cwd();
          file = path_1.default.join(appFolder, "nodesets", filename);
        }
      }
      return file;
    }
    exports2.constructNodesetFilename = constructNodesetFilename;
    exports2.allNodesetMeta = nodeset_catalog_1.nodesetCatalog.map(([name, packageSuffix, uri, xmlFileName, _requiredModels]) => ({
      name,
      packageName: `node-opcua-nodeset-${packageSuffix}`,
      uri,
      xmlFile: constructNodesetFilename(xmlFileName)
    }));
    exports2.nodesets = exports2.allNodesetMeta.reduce((nodesetMap, meta) => {
      nodesetMap[meta.name] = meta.xmlFile;
      return nodesetMap;
    }, {});
  }
});

// node_modules/node-opcua-nodesets/dist/index.js
var require_dist52 = __commonJS({
  "node_modules/node-opcua-nodesets/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_nodeset_catalog(), exports2);
    __exportStar3(require_nodeset_nodejs(), exports2);
  }
});

// node_modules/node-opcua-address-space/distHelpers/add_event_generator_object.js
var require_add_event_generator_object = __commonJS({
  "node_modules/node-opcua-address-space/distHelpers/add_event_generator_object.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.add_eventGeneratorObject = void 0;
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_variant_1 = require_dist28();
    function add_eventGeneratorObject(namespace, parentFolder) {
      const myEvtType = namespace.addEventType({
        browseName: "MyEventType",
        subtypeOf: "BaseEventType"
        // should be implicit
      });
      const myObject = namespace.addObject({
        browseName: "EventGeneratorObject",
        eventNotifier: 1,
        organizedBy: parentFolder
      });
      myObject.addReference({
        nodeId: myEvtType,
        referenceType: "AlwaysGeneratesEvent"
      });
      const method = namespace.addMethod(myObject, {
        browseName: "EventGeneratorMethod",
        inputArguments: [
          {
            dataType: node_opcua_variant_1.DataType.String,
            description: { text: "Event Message" },
            name: "message"
          },
          {
            dataType: node_opcua_variant_1.DataType.UInt32,
            description: { text: "Event Severity" },
            name: "severity"
          }
        ],
        outputArguments: []
      });
      method.bindMethod((inputArguments, context, callback) => {
        const message = inputArguments[0].value || "Hello from Event Generator Object";
        const severity = inputArguments[1].value || 0;
        const myEventType = namespace.addressSpace.findEventType("MyEventType", namespace.index);
        context.object.raiseEvent(myEventType, {
          message: {
            dataType: node_opcua_variant_1.DataType.LocalizedText,
            value: { text: message }
          },
          severity: {
            dataType: node_opcua_variant_1.DataType.UInt32,
            value: severity
          }
        });
        const callMethodResult = {
          outputArguments: [],
          statusCode: node_opcua_status_code_1.StatusCodes.Good
        };
        callback(null, callMethodResult);
      });
    }
    exports2.add_eventGeneratorObject = add_eventGeneratorObject;
  }
});

// node_modules/node-opcua-address-space/distHelpers/alarms_and_conditions_demo.js
var require_alarms_and_conditions_demo = __commonJS({
  "node_modules/node-opcua-address-space/distHelpers/alarms_and_conditions_demo.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.construct_demo_alarm_in_address_space = void 0;
    var node_opcua_assert_1 = require_dist14();
    function construct_demo_alarm_in_address_space(test, addressSpace) {
      const a = addressSpace;
      if (a.construct_demo_alarm_in_address_space_called) {
        return;
      }
      a.construct_demo_alarm_in_address_space_called = true;
      addressSpace.installAlarmsAndConditionsService();
      const namespace = addressSpace.getOwnNamespace();
      const tank = namespace.addObject({
        browseName: "Tank",
        description: "The Object representing the Tank",
        eventNotifier: 1,
        notifierOf: addressSpace.rootFolder.objects.server,
        organizedBy: addressSpace.rootFolder.objects
      });
      (0, node_opcua_assert_1.assert)(tank.getNotifiers().length === 0, "expecting a notifier now");
      const tankLevel = namespace.addVariable({
        browseName: "TankLevel",
        componentOf: tank,
        dataType: "Double",
        description: "Fill level in percentage (0% to 100%) of the water tank",
        eventSourceOf: tank,
        value: { dataType: "Double", value: 0.5 }
      });
      const exclusiveLimitAlarmType = addressSpace.findEventType("ExclusiveLimitAlarmType");
      if (!exclusiveLimitAlarmType) {
        throw new Error("cannot find ExclusiveLimitAlarmType in namespace 0");
      }
      const tankLevelCondition = namespace.instantiateExclusiveLimitAlarm(exclusiveLimitAlarmType, {
        browseName: "TankLevelCondition",
        componentOf: tank,
        conditionName: "TankLevelCondition",
        conditionSource: tankLevel,
        highHighLimit: 0.9,
        highLimit: 0.8,
        inputNode: tankLevel,
        // the variable that will be monitored for change
        lowLimit: 0.2,
        optionals: [
          "ConfirmedState",
          "Confirm"
          // confirm state and confirm Method
        ],
        setpointNode: null
      });
      (0, node_opcua_assert_1.assert)(tankLevelCondition.browseName.toString() === "1:TankLevelCondition");
      (0, node_opcua_assert_1.assert)(tankLevel.findReferences("HasCondition").length === 1);
      (0, node_opcua_assert_1.assert)(tankLevel.findReferencesAsObject("HasCondition", true).length === 1);
      const conditionName = tankLevel.findReferencesAsObject("HasCondition", true)[0].browseName.toString();
      const conditionTypeDefinition = tankLevel.findReferencesAsObject("HasCondition", true)[0].typeDefinitionObj.browseName.toString();
      const conditionJavascriptClass = tankLevel.findReferencesAsObject("HasCondition", true)[0].constructor.name.toString();
      if (false) {
        console.log(conditionName, conditionTypeDefinition, conditionJavascriptClass);
      }
      (0, node_opcua_assert_1.assert)("1:TankLevelCondition" === conditionName);
      (0, node_opcua_assert_1.assert)("ExclusiveLimitAlarmType" === conditionTypeDefinition);
      (0, node_opcua_assert_1.assert)("UAExclusiveLimitAlarmImpl" === conditionJavascriptClass);
      const tripAlarmType = addressSpace.findEventType("TripAlarmType");
      const tankTripCondition = null;
      const tankLevel2 = namespace.addVariable({
        browseName: "tankLevel2",
        componentOf: tank,
        dataType: "Double",
        description: "Fill level in percentage (0% to 100%) of the water tank",
        eventSourceOf: tank,
        value: { dataType: "Double", value: 0.5 }
      });
      const nonExclusiveLimitAlarmType = addressSpace.findEventType("NonExclusiveLimitAlarmType");
      if (!nonExclusiveLimitAlarmType) {
        throw new Error("!!");
      }
      const tankLevelCondition2 = namespace.instantiateNonExclusiveLimitAlarm(nonExclusiveLimitAlarmType, {
        browseName: "TankLevelCondition2",
        componentOf: tank,
        conditionName: "TankLevel2",
        conditionSource: tankLevel2,
        highHighLimit: 0.9,
        highLimit: 0.8,
        inputNode: tankLevel2,
        // the variable that will be monitored for change
        lowLimit: 0.2,
        optionals: [
          "ConfirmedState",
          "Confirm"
          // confirm state and confirm Method
        ]
      });
      (0, node_opcua_assert_1.assert)(tankLevel2.findReferences("HasCondition").length === 1);
      (0, node_opcua_assert_1.assert)(tankLevel2.findReferencesAsObject("HasCondition", true).length === 1);
      test.tankLevel = tankLevel;
      test.tankLevelCondition = tankLevelCondition;
      test.tankLevel2 = tankLevel2;
      test.tankLevelCondition2 = tankLevelCondition2;
      test.tankTripCondition = tankTripCondition;
    }
    exports2.construct_demo_alarm_in_address_space = construct_demo_alarm_in_address_space;
  }
});

// node_modules/node-opcua-address-space/distHelpers/assertHasMatchingReference.js
var require_assertHasMatchingReference = __commonJS({
  "node_modules/node-opcua-address-space/distHelpers/assertHasMatchingReference.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.assertHasMatchingReference = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_nodeid_1 = require_dist21();
    function assertHasMatchingReference(node, reference) {
      const addressSpace = node.addressSpace;
      const normalizedReference = addressSpace.normalizeReferenceType(reference);
      (0, node_opcua_assert_1.assert)(normalizedReference.referenceType instanceof node_opcua_nodeid_1.NodeId);
      let refs = node.findReferences(normalizedReference.referenceType, normalizedReference.isForward);
      refs = refs.filter((ref) => {
        return (0, node_opcua_nodeid_1.sameNodeId)(ref.nodeId, normalizedReference.nodeId);
      });
      const dispOpts = { addressSpace };
      if (refs.length !== 1) {
        throw new Error(" Cannot find reference " + JSON.stringify(normalizedReference));
      }
      (0, node_opcua_assert_1.assert)(refs.length === 1);
    }
    exports2.assertHasMatchingReference = assertHasMatchingReference;
  }
});

// node_modules/node-opcua-address-space/distHelpers/create_minimalist_address_space_nodeset.js
var require_create_minimalist_address_space_nodeset = __commonJS({
  "node_modules/node-opcua-address-space/distHelpers/create_minimalist_address_space_nodeset.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.create_minimalist_address_space_nodeset = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var doDebug = false;
    function dumpReferencesHierarchy(_addressSpace) {
      const addressSpace = _addressSpace;
      function _dump(referenceType, level) {
        console.log(level, referenceType.browseName.toString(), "(", chalk_1.default.green(referenceType.getAllSubtypes().map((x2) => x2.browseName.toString()).join(" ")), ")");
        const subTypes = referenceType.findReferencesExAsObject("HasSubtype");
        for (const subType of subTypes) {
          _dump(subType, "     " + level);
        }
      }
      const references = addressSpace.findReferenceType(node_opcua_constants_1.ReferenceTypeIds.References);
      _dump(references, " ");
    }
    function create_minimalist_address_space_nodeset(addressSpace) {
      const _addressSpace = addressSpace;
      const namespace0 = addressSpace.registerNamespace("http://opcfoundation.org/UA/");
      (0, node_opcua_assert_1.assert)(namespace0.index === 0);
      function addReferenceType(browseName_, isAbstract, subtypeOf) {
        const tmp = browseName_.split("/");
        const inverseName = tmp[1];
        const browseName = tmp[0];
        const options = {
          browseName,
          inverseName,
          isAbstract,
          nodeClass: node_opcua_data_model_1.NodeClass.ReferenceType,
          nodeId: (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_constants_1.ReferenceTypeIds[browseName]),
          references: [],
          subtypeOf
        };
        const hasSubType = (0, node_opcua_nodeid_1.resolveNodeId)("HasSubtype");
        if (subtypeOf) {
          options.references.push({
            isForward: false,
            nodeId: subtypeOf.nodeId,
            referenceType: hasSubType
          });
        }
        const node = namespace0.internalCreateNode(options);
        node.propagate_back_references();
        return node;
      }
      {
        const hasSubtype = addReferenceType("HasSubtype/HasSupertype");
        const references = addReferenceType("References", true);
        {
          const nonHierarchicalReferences = addReferenceType("NonHierarchicalReferences", true, references);
          {
            const hasTypeDefinition = addReferenceType("HasTypeDefinition/TypeDefinitionOf", false, nonHierarchicalReferences);
            const hasModellingRule = addReferenceType("HasModellingRule/ModellingRuleOf", false, nonHierarchicalReferences);
            const hasEncoding = addReferenceType("HasEncoding/EncodingOf", false, nonHierarchicalReferences);
          }
        }
        {
          const hierarchicalReferences = addReferenceType("HierarchicalReferences", true, references);
          {
            const hasChild = addReferenceType("HasChild/ChildOf", true, hierarchicalReferences);
            {
              const aggregates = addReferenceType("Aggregates/AggregatedBy", true, hasChild);
              {
                const hasComponent = addReferenceType("HasComponent/ComponentOf", false, aggregates);
                const hasProperty = addReferenceType("HasProperty/PropertyOf", false, aggregates);
                const hasHistoricalConfiguration = addReferenceType("HasHistoricalConfiguration/HistoricalConfigurationOf", false, aggregates);
              }
            }
            {
              hasSubtype.addReference({
                isForward: false,
                nodeId: hasChild,
                referenceType: hasSubtype
              });
            }
          }
          {
            const organizes = addReferenceType("Organizes/OrganizedBy", false, hierarchicalReferences);
          }
          {
            const hasEventSource = addReferenceType("HasEventSource/EventSourceOf", false, hierarchicalReferences);
          }
        }
      }
      if (doDebug) {
        dumpReferencesHierarchy(addressSpace);
      }
      const baseObjectType = namespace0.internalCreateNode({
        browseName: "BaseObjectType",
        isAbstract: true,
        nodeClass: node_opcua_data_model_1.NodeClass.ObjectType,
        nodeId: (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_constants_1.ObjectTypeIds.BaseObjectType)
      });
      const baseVariableType = namespace0.internalCreateNode({
        browseName: "BaseVariableType",
        isAbstract: true,
        nodeClass: node_opcua_data_model_1.NodeClass.VariableType,
        nodeId: (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_constants_1.VariableTypeIds.BaseVariableType)
      });
      const propertyType = namespace0.addVariableType({
        browseName: "PropertyType",
        subtypeOf: baseVariableType
      });
      const baseDataVariableType = namespace0.internalCreateNode({
        browseName: "BaseDataVariableType",
        isAbstract: true,
        nodeClass: node_opcua_data_model_1.NodeClass.VariableType,
        nodeId: (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_constants_1.VariableTypeIds.BaseDataVariableType),
        subtypeOf: baseVariableType.nodeId
      });
      const modellingRule_Optional = namespace0.internalCreateNode({
        browseName: "Optional",
        nodeClass: node_opcua_data_model_1.NodeClass.Object,
        nodeId: (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_constants_1.ObjectIds.ModellingRule_Optional)
      });
      const modellingRule_Mandatory = namespace0.internalCreateNode({
        browseName: "Mandatory",
        nodeClass: node_opcua_data_model_1.NodeClass.Object,
        nodeId: (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_constants_1.ObjectIds.ModellingRule_Mandatory)
      });
      {
        const rootFolder = namespace0.internalCreateNode({
          browseName: "RootFolder",
          nodeClass: node_opcua_data_model_1.NodeClass.Object,
          nodeId: (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_constants_1.ObjectIds.RootFolder)
        });
        {
          const objectsFolder = namespace0.addObject({
            browseName: "Objects",
            nodeId: (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_constants_1.ObjectIds.ObjectsFolder),
            organizedBy: rootFolder
          });
          (0, node_opcua_assert_1.assert)(rootFolder.getFolderElementByName("Objects").browseName.toString() === "Objects");
        }
        {
          const dataTypeFolder = namespace0.addObject({
            browseName: "DataType",
            nodeId: (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_constants_1.ObjectIds.DataTypesFolder),
            organizedBy: rootFolder
          });
          {
            const doubleDataType = namespace0.internalCreateNode({
              browseName: "Double",
              nodeClass: node_opcua_data_model_1.NodeClass.DataType,
              nodeId: (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_constants_1.DataTypeIds.Double),
              organizedBy: dataTypeFolder
            });
          }
        }
      }
    }
    exports2.create_minimalist_address_space_nodeset = create_minimalist_address_space_nodeset;
  }
});

// node_modules/node-opcua-address-space/distHelpers/get_address_space_fixture.js
var require_get_address_space_fixture = __commonJS({
  "node_modules/node-opcua-address-space/distHelpers/get_address_space_fixture.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getAddressSpaceFixture = void 0;
    var fs_1 = __importDefault3(require("fs"));
    var path_1 = __importDefault3(require("path"));
    function getAddressSpaceFixture(pathname) {
      const folder1 = path_1.default.join(__dirname, "../nodesets");
      if (fs_1.default.existsSync(folder1)) {
        const filename2 = path_1.default.join(folder1, pathname);
        if (fs_1.default.existsSync(filename2)) {
          return filename2;
        }
      }
      let folder = path_1.default.join(__dirname, "./test_fixtures");
      if (!fs_1.default.existsSync(folder)) {
        folder = path_1.default.join(__dirname, "../test_helpers/test_fixtures");
        if (!fs_1.default.existsSync(folder)) {
          folder = path_1.default.join(__dirname, "../../test_helpers/test_fixtures");
          if (!fs_1.default.existsSync(folder)) {
            console.log(" cannot find test_fixtures folder ");
          }
        }
      }
      const filename = path_1.default.join(folder, pathname);
      if (!fs_1.default.existsSync(filename)) {
        throw new Error(" cannot find fixture with name " + pathname);
      }
      return filename;
    }
    exports2.getAddressSpaceFixture = getAddressSpaceFixture;
  }
});

// node_modules/node-opcua-address-space/dist/source/helpers/adjust_browse_direction.js
var require_adjust_browse_direction = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/helpers/adjust_browse_direction.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.adjustBrowseDirection = void 0;
    function adjustBrowseDirection(browseDirection, defaultValue) {
      if (browseDirection === null || browseDirection === void 0) {
        return defaultValue;
      }
      return browseDirection;
    }
    exports2.adjustBrowseDirection = adjustBrowseDirection;
  }
});

// node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/condition_info_impl.js
var require_condition_info_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/condition_info_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ConditionInfoImpl = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var ConditionInfoImpl = class {
      constructor(options) {
        this.message = null;
        this.quality = null;
        this.severity = 0;
        this.retain = false;
        this.severity = null;
        this.quality = null;
        this.message = null;
        this.retain = null;
        if (Object.prototype.hasOwnProperty.call(options, "message") && options.message) {
          this.message = node_opcua_data_model_1.LocalizedText.coerce(options.message);
        }
        if (Object.prototype.hasOwnProperty.call(options, "quality") && options.quality !== null) {
          this.quality = options.quality;
        }
        if (Object.prototype.hasOwnProperty.call(options, "severity") && options.severity !== null) {
          (0, node_opcua_assert_1.assert)(typeof options.severity === "number");
          this.severity = options.severity;
        }
        if (Object.prototype.hasOwnProperty.call(options, "retain") && options.retain !== null) {
          (0, node_opcua_assert_1.assert)(typeof options.retain === "boolean");
          this.retain = options.retain;
        }
      }
      /**
       * @method isDifferentFrom
       * @param otherConditionInfo {ConditionInfo}
       * @return {Boolean}
       */
      isDifferentFrom(otherConditionInfo) {
        return this.severity !== otherConditionInfo.severity || this.quality !== otherConditionInfo.quality || this.message !== otherConditionInfo.message;
      }
    };
    exports2.ConditionInfoImpl = ConditionInfoImpl;
  }
});

// node_modules/node-opcua-address-space/dist/src/event_data.js
var require_event_data = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/event_data.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EventData = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_utils_1 = require_dist16();
    var EventData = class {
      constructor(eventTypeNode) {
        this.$cache = {
          __values: {},
          __nodeIdToNode: {},
          __pathToNodeId: {},
          __nodeIdToFullPath: {}
        };
        this.eventId = new node_opcua_nodeid_1.NodeId();
        this.$eventDataSource = eventTypeNode;
      }
      _createValue(fullBrowsePath, node, variant) {
        const eventData = this;
        (0, node_opcua_assert_1.assert)(!eventData[fullBrowsePath], "already exists " + fullBrowsePath);
        const lowerName = fullBrowsePath.split(".").map(node_opcua_utils_1.lowerFirstLetter).join(".");
        eventData[lowerName] = node_opcua_variant_1.Variant.coerce(variant);
        this.$cache.__pathToNodeId[fullBrowsePath] = node.nodeId;
        this.$cache.__nodeIdToNode[node.nodeId.toString()] = node;
        this.$cache.__nodeIdToFullPath[node.nodeId.toString()] = fullBrowsePath;
        this.$cache.__values[node.nodeId.toString()] = eventData[lowerName];
      }
      _browse(browsePath) {
        if (!(0, node_opcua_nodeid_1.sameNodeId)(browsePath.startingNode, this.$eventDataSource.nodeId)) {
          return null;
        }
        const fullBrowsePath = (browsePath.relativePath.elements || []).map((b) => b.targetName.toString()).join(".");
        const nodeId = this.$cache.__pathToNodeId[fullBrowsePath];
        if (!nodeId)
          return null;
        return new node_opcua_types_1.BrowsePathResult({
          statusCode: node_opcua_status_code_1.StatusCodes.Good,
          targets: [{
            remainingPathIndex: 0,
            targetId: (0, node_opcua_nodeid_1.coerceExpandedNodeId)(nodeId)
          }]
        });
      }
      _readValue(nodeId) {
        const key = nodeId.toString();
        const cached_value = this.$cache.__values[key];
        if (cached_value) {
          return cached_value;
        }
        return null;
      }
    };
    exports2.EventData = EventData;
  }
});

// node_modules/node-opcua-address-space/dist/source/loader/namespace_post_step.js
var require_namespace_post_step = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/loader/namespace_post_step.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.promoteObjectsAndVariables = exports2.promoteObjectAndVariablesInNamespace = exports2.g_promotableObject = void 0;
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_debug_1 = require_dist24();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    exports2.g_promotableObject = {};
    function parentIsObjectOrVariableType(node) {
      if (node.parent && (node.parent.nodeClass === node_opcua_data_model_1.NodeClass.VariableType || node.parent?.nodeClass === node_opcua_data_model_1.NodeClass.ObjectType)) {
        return true;
      }
      if (!node.parent) {
        return false;
      }
      return parentIsObjectOrVariableType(node.parent);
    }
    async function promoteObjectAndVariablesInNamespace(namespace) {
      const namespaceP = namespace;
      for (const a of namespaceP.nodeIterator()) {
        if (a.nodeClass === node_opcua_data_model_1.NodeClass.Object || a.nodeClass === node_opcua_data_model_1.NodeClass.Variable) {
          const aa = a;
          if (aa.typeDefinition) {
            const promoter = exports2.g_promotableObject[aa.typeDefinition.toString()];
            if (promoter) {
              if (promoter.onInstanceOnly && parentIsObjectOrVariableType(aa)) {
                continue;
              }
              const before = a.constructor.name;
              promoter.promoter(a);
              const after = a.constructor.name;
              if (doDebug) {
                debugLog(`promoting ${a.browseName.toString()} from ${before} to ${after}`);
              }
            }
          }
        }
      }
    }
    exports2.promoteObjectAndVariablesInNamespace = promoteObjectAndVariablesInNamespace;
    async function promoteObjectsAndVariables(addressSpace) {
      for (const namespace of addressSpace.getNamespaceArray()) {
        promoteObjectAndVariablesInNamespace(namespace);
      }
    }
    exports2.promoteObjectsAndVariables = promoteObjectsAndVariables;
  }
});

// node_modules/node-opcua-address-space/dist/source/loader/register_node_promoter.js
var require_register_node_promoter = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/loader/register_node_promoter.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.registerNodePromoter = void 0;
    var node_opcua_nodeid_1 = require_dist21();
    var namespace_post_step_1 = require_namespace_post_step();
    function registerNodePromoter(standardNodeId, promoter, onInstanceOnly = false) {
      namespace_post_step_1.g_promotableObject[(0, node_opcua_nodeid_1.resolveNodeId)(standardNodeId).toString()] = { promoter, onInstanceOnly };
    }
    exports2.registerNodePromoter = registerNodePromoter;
  }
});

// node_modules/node-opcua-address-space-base/dist/address_space.js
var require_address_space = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/address_space.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space-base/dist/base_node.js
var require_base_node = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/base_node.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var events_1 = require("events");
  }
});

// node_modules/node-opcua-address-space-base/dist/bind_variable.js
var require_bind_variable = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/bind_variable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space-base/dist/clone_helper.js
var require_clone_helper = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/clone_helper.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.reconstructFunctionalGroupType = exports2.reconstructNonHierarchicalReferences = exports2.CloneHelper = exports2.exploreNode = exports2.fullPath2 = exports2.fullPath = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_constants_1 = require_dist20();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)("CLONE");
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var doTrace = (0, node_opcua_debug_1.checkDebugFlag)("INSTANTIATE");
    var traceLog = errorLog;
    function fullPath(node) {
      const browseName = node.browseName.toString();
      const parent = node.findReferencesExAsObject("Aggregates", node_opcua_data_model_1.BrowseDirection.Inverse)[0];
      if (parent) {
        return fullPath(parent) + "/" + browseName;
      }
      const containingFolder = node.findReferencesExAsObject("Organizes", node_opcua_data_model_1.BrowseDirection.Inverse)[0];
      if (containingFolder) {
        return fullPath(containingFolder) + "@" + browseName;
      }
      return browseName;
    }
    exports2.fullPath = fullPath;
    function fullPath2(node) {
      return fullPath(node) + " (" + node.nodeId.toString() + ")";
    }
    exports2.fullPath2 = fullPath2;
    function exploreNode(node) {
      const f2 = (n) => {
        return `${n.browseName.toString()} (${n.nodeId.toString()})${n.modellingRule ? " - " + n.modellingRule : ""}`;
      };
      const r = (r2) => {
        const ref = node.addressSpace.findNode(r2);
        if (!ref)
          return `${r2.nodeId.toString()} (unknown)`;
        return ref?.browseName.toString() + " " + ref.nodeId.toString();
      };
      const map = /* @__PURE__ */ new Set();
      const _explore = (node2, pad) => {
        const a = node2.findReferencesEx("Aggregates", node_opcua_data_model_1.BrowseDirection.Forward);
        const b = node2.findReferencesEx("Organizes", node_opcua_data_model_1.BrowseDirection.Forward);
        for (const ref of [...a, ...b]) {
          const alreadyVisited = map.has(ref.nodeId.toString());
          traceLog(pad, "  +-- ", r(ref.referenceType).padEnd(20), "-->", f2(ref.node).padEnd(10), alreadyVisited ? " (already visited)" : "");
          if (alreadyVisited) {
            continue;
          }
          map.add(ref.nodeId.toString());
          _explore(ref.node, pad + "   ");
        }
      };
      traceLog("exploring ", f2(node));
      _explore(node, "   ");
    }
    exports2.exploreNode = exploreNode;
    function _get_parent_type_and_path(originalObject) {
      if (originalObject.nodeClass === node_opcua_data_model_1.NodeClass.Method) {
        return { parentType: null, path: [] };
      }
      const addressSpace = originalObject.addressSpace;
      const parents = originalObject.findReferencesEx("HasChild", node_opcua_data_model_1.BrowseDirection.Inverse);
      if (parents.length > 1) {
        warningLog(" object ", originalObject.browseName.toString(), " has more than one parent !");
        warningLog(originalObject.toString());
        warningLog(" parents : ");
        for (const parent of parents) {
          warningLog("     ", parent.toString(), addressSpace.findNode(parent.nodeId).browseName.toString());
        }
        return { parentType: null, path: [] };
      }
      (0, node_opcua_assert_1.assert)(parents.length === 0 || parents.length === 1);
      if (parents.length === 0) {
        return { parentType: null, path: [] };
      }
      const theParent = addressSpace.findNode(parents[0].nodeId);
      if (theParent && (theParent.nodeClass === node_opcua_data_model_1.NodeClass.VariableType || theParent.nodeClass === node_opcua_data_model_1.NodeClass.ObjectType)) {
        return { parentType: theParent, path: [originalObject.browseName] };
      }
      const { parentType, path: path3 } = _get_parent_type_and_path(theParent);
      return { parentType, path: [...path3, originalObject.browseName] };
    }
    function followPath(node, path3) {
      let current = node;
      for (const qn of path3) {
        const ref = current.findReferencesExAsObject("HierarchicalReferences", node_opcua_data_model_1.BrowseDirection.Forward).find((r) => r.browseName.toString() === qn.toString());
        if (!ref) {
          return null;
        }
        current = ref;
      }
      return current;
    }
    var CloneHelper = class {
      constructor() {
        this.level = 0;
        this._context = null;
        this._contextStack = [];
        this.mapTypeInstanceChildren = /* @__PURE__ */ new Map();
      }
      pad() {
        return " ".padEnd(this.level * 2, " ");
      }
      getClonedArray() {
        const result2 = [];
        for (const map of this.mapTypeInstanceChildren.values()) {
          for (const cloneInfo of map.values()) {
            result2.push(cloneInfo);
          }
        }
        return result2;
      }
      pushContext({ clonedParent, originalParent }) {
        doTrace && traceLog("push context: ", "original parent = ", fullPath2(originalParent), "cloned parent =", fullPath2(clonedParent));
        const typeInstance = originalParent.nodeId.toString() + clonedParent.nodeId.toString();
        doTrace && traceLog("typeInstance (1) = ", typeInstance, fullPath2(originalParent), fullPath2(clonedParent));
        let a = this.mapTypeInstanceChildren.get(typeInstance);
        if (a) {
          throw new Error("Internal Error");
        }
        a = /* @__PURE__ */ new Map();
        this.mapTypeInstanceChildren.set(typeInstance, a);
        if (this._context) {
          this._contextStack.push(this._context);
        }
        this._context = a;
      }
      popContext() {
        (0, node_opcua_assert_1.assert)(this._contextStack.length > 0);
        this._context = this._contextStack.pop();
      }
      registerClonedObject({ clonedNode, originalNode }) {
        if (!this._context) {
          this.pushContext({ clonedParent: clonedNode, originalParent: originalNode });
        }
        doTrace && traceLog("registerClonedObject", "originalNode = ", fullPath2(originalNode), "clonedNode =", fullPath2(clonedNode));
        const insertShadow = (map) => {
          const { parentType, path: path3 } = _get_parent_type_and_path(originalNode);
          if (parentType) {
            let base = parentType.subtypeOfObj;
            while (base) {
              const shadowChild = followPath(base, path3);
              if (shadowChild) {
                doTrace && traceLog("shadowChild = ", fullPath2(shadowChild));
                map.set(shadowChild.nodeId.toString(), {
                  cloned: clonedNode,
                  original: shadowChild
                });
              }
              base = base.subtypeOfObj;
            }
          }
        };
        if (!this._context) {
          throw new Error("internal error: Cannot find context");
        }
        this._context.set(originalNode.nodeId.toString(), {
          cloned: clonedNode,
          original: originalNode
        });
        insertShadow(this._context);
      }
      getCloned({ originalParent, clonedParent, originalNode }) {
        doTrace && traceLog("typeInstance (3) = originalParent", fullPath2(originalParent), "originalNode=", fullPath2(originalNode), "clonedParent", fullPath2(clonedParent));
        const info = this._context.get(originalNode.nodeId.toString());
        if (info) {
          return info.cloned;
        }
        return null;
      }
    };
    exports2.CloneHelper = CloneHelper;
    var hasTypeDefinitionNodeId = (0, node_opcua_nodeid_1.makeNodeId)(node_opcua_constants_1.ReferenceTypeIds.HasTypeDefinition);
    var hasModellingRuleNodeId = (0, node_opcua_nodeid_1.makeNodeId)(node_opcua_constants_1.ReferenceTypeIds.HasModellingRule);
    function _remove_unwanted_ref(references) {
      references = references.filter((reference) => !(0, node_opcua_nodeid_1.sameNodeId)(reference.referenceType, hasTypeDefinitionNodeId) && !(0, node_opcua_nodeid_1.sameNodeId)(reference.referenceType, hasModellingRuleNodeId));
      return references;
    }
    function findNonHierarchicalReferences(originalObject) {
      const addressSpace = originalObject.addressSpace;
      let references = originalObject.findReferencesEx("NonHierarchicalReferences", node_opcua_data_model_1.BrowseDirection.Inverse);
      references = [].concat(references, originalObject.findReferencesEx("HasEventSource", node_opcua_data_model_1.BrowseDirection.Inverse));
      const { parentType, path: path3 } = _get_parent_type_and_path(originalObject);
      if (parentType && parentType.subtypeOfObj) {
        (0, node_opcua_assert_1.assert)(parentType.nodeClass === node_opcua_data_model_1.NodeClass.VariableType || parentType.nodeClass === node_opcua_data_model_1.NodeClass.ObjectType);
        const child = followPath(parentType.subtypeOfObj, path3);
        if (child) {
          const baseRef = findNonHierarchicalReferences(child);
          references = [].concat(references, baseRef);
        }
      }
      references = _remove_unwanted_ref(references);
      return references;
    }
    var findImplementedObject = (cloneInfoArray, ref) => {
      const a = cloneInfoArray.filter((x2) => x2.original.nodeId.toString() === ref.nodeId.toString());
      if (a.length === 0)
        return null;
      const info = a[0];
      return info;
    };
    function reconstructNonHierarchicalReferences(extraInfo) {
      const cloneInfoArray = extraInfo.getClonedArray();
      doTrace && traceLog("reconstructNonHierarchicalReferences");
      for (const { original, cloned } of cloneInfoArray) {
        apply(original, cloned);
      }
      function apply(original, cloned) {
        const addressSpace = original.addressSpace;
        const originalNonHierarchical = findNonHierarchicalReferences(original);
        if (originalNonHierarchical.length === 0) {
          return;
        }
        doTrace && traceLog(" investigation ", "original", fullPath2(original), node_opcua_data_model_1.NodeClass[cloned.nodeClass], fullPath2(cloned));
        for (const ref of originalNonHierarchical) {
          const info = findImplementedObject(cloneInfoArray, ref);
          if (!info)
            continue;
          const originalDest = info.original;
          const cloneDest = info.cloned;
          doTrace && traceLog("   adding reference ", fullPath2(addressSpace.findNode(ref.referenceType)), " from cloned ", fullPath2(cloned), " to cloned ", fullPath2(cloneDest));
          cloned.addReference({
            isForward: false,
            nodeId: cloneDest.nodeId,
            referenceType: ref.referenceType
          });
        }
      }
    }
    exports2.reconstructNonHierarchicalReferences = reconstructNonHierarchicalReferences;
    function reconstructFunctionalGroupType(extraInfo) {
      const cloneInfoArray = extraInfo.getClonedArray();
      for (const { original, cloned } of cloneInfoArray) {
        const organizedByArray = original.findReferencesEx("Organizes", node_opcua_data_model_1.BrowseDirection.Inverse);
        for (const ref of organizedByArray) {
          const info = findImplementedObject(cloneInfoArray, ref);
          if (!info)
            continue;
          const folder = info.original;
          if (folder.nodeClass !== node_opcua_data_model_1.NodeClass.Object)
            continue;
          if (!folder.typeDefinitionObj)
            continue;
          if (folder.typeDefinitionObj.browseName.name.toString() !== "FunctionalGroupType") {
            continue;
          }
          const destFolder = info.cloned;
          (0, node_opcua_assert_1.assert)(ref.referenceType);
          const alreadyExist = destFolder.findReferences(ref.referenceType, !ref.isForward).find((r) => r.nodeId === cloned.nodeId);
          if (alreadyExist) {
            continue;
          }
          destFolder.addReference({
            isForward: !ref.isForward,
            nodeId: cloned.nodeId,
            referenceType: ref.referenceType
          });
        }
      }
    }
    exports2.reconstructFunctionalGroupType = reconstructFunctionalGroupType;
  }
});

// node_modules/node-opcua-address-space-base/dist/clone_options.js
var require_clone_options = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/clone_options.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.makeDefaultCloneExtraInfo = exports2.defaultCloneFilter = void 0;
    var clone_helper_1 = require_clone_helper();
    exports2.defaultCloneFilter = {
      shouldKeep: (node) => {
        if (node.modellingRule === "OptionalPlaceholder" || node.modellingRule === "MandatoryPlaceholder") {
          return false;
        }
        return true;
      },
      filterFor(node) {
        return this;
      }
    };
    var makeDefaultCloneExtraInfo = (node) => {
      const extraInfo = new clone_helper_1.CloneHelper();
      extraInfo.pushContext({ originalParent: node, clonedParent: node });
      return extraInfo;
    };
    exports2.makeDefaultCloneExtraInfo = makeDefaultCloneExtraInfo;
  }
});

// node_modules/node-opcua-address-space-base/dist/continuation_point.js
var require_continuation_point = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/continuation_point.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space-base/dist/event_notifier_flags.js
var require_event_notifier_flags = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/event_notifier_flags.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EventNotifierFlags = void 0;
    var EventNotifierFlags;
    (function(EventNotifierFlags2) {
      EventNotifierFlags2[EventNotifierFlags2["SubscribeToEvents"] = 1] = "SubscribeToEvents";
      EventNotifierFlags2[EventNotifierFlags2["Reserved"] = 2] = "Reserved";
      EventNotifierFlags2[EventNotifierFlags2["HistoryRead"] = 4] = "HistoryRead";
      EventNotifierFlags2[EventNotifierFlags2["HistoryWrite"] = 8] = "HistoryWrite";
      EventNotifierFlags2[EventNotifierFlags2["None"] = 0] = "None";
    })(EventNotifierFlags || (exports2.EventNotifierFlags = EventNotifierFlags = {}));
  }
});

// node_modules/node-opcua-address-space-base/dist/i_event_data.js
var require_i_event_data = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/i_event_data.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space-base/dist/modelling_rule_type.js
var require_modelling_rule_type = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/modelling_rule_type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space-base/dist/namespace.js
var require_namespace = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/namespace.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space-base/dist/session_context.js
var require_session_context = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/session_context.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getContextMaxMessageSize = void 0;
    function getContextMaxMessageSize(context) {
      if (!context.session?.channel?.getTransportSettings)
        return 0;
      const f2 = context.session?.channel?.getTransportSettings();
      return f2 ? f2.maxMessageSize : 0;
    }
    exports2.getContextMaxMessageSize = getContextMaxMessageSize;
  }
});

// node_modules/node-opcua-address-space-base/dist/ua_data_type.js
var require_ua_data_type = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/ua_data_type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space-base/dist/ua_dynamic_variable_array.js
var require_ua_dynamic_variable_array = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/ua_dynamic_variable_array.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space-base/dist/ua_event_type.js
var require_ua_event_type = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/ua_event_type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space-base/dist/ua_method.js
var require_ua_method = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/ua_method.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var base_node_1 = require_base_node();
  }
});

// node_modules/node-opcua-address-space-base/dist/ua_object_type.js
var require_ua_object_type = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/ua_object_type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space-base/dist/ua_object.js
var require_ua_object = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/ua_object.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space-base/dist/ua_property.js
var require_ua_property = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/ua_property.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space-base/dist/ua_reference_type.js
var require_ua_reference_type = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/ua_reference_type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var base_node_1 = require_base_node();
  }
});

// node_modules/node-opcua-address-space-base/dist/ua_reference.js
var require_ua_reference = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/ua_reference.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space-base/dist/ua_variable_t.js
var require_ua_variable_t = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/ua_variable_t.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space-base/dist/ua_variable_type.js
var require_ua_variable_type = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/ua_variable_type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var base_node_1 = require_base_node();
  }
});

// node_modules/node-opcua-address-space-base/dist/ua_variable.js
var require_ua_variable = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/ua_variable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space-base/dist/ua_view.js
var require_ua_view = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/ua_view.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space-base/dist/index.js
var require_dist53 = __commonJS({
  "node_modules/node-opcua-address-space-base/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_address_space(), exports2);
    __exportStar3(require_base_node(), exports2);
    __exportStar3(require_bind_variable(), exports2);
    __exportStar3(require_clone_helper(), exports2);
    __exportStar3(require_clone_options(), exports2);
    __exportStar3(require_continuation_point(), exports2);
    __exportStar3(require_event_notifier_flags(), exports2);
    __exportStar3(require_i_event_data(), exports2);
    __exportStar3(require_modelling_rule_type(), exports2);
    __exportStar3(require_namespace(), exports2);
    __exportStar3(require_session_context(), exports2);
    __exportStar3(require_ua_data_type(), exports2);
    __exportStar3(require_ua_dynamic_variable_array(), exports2);
    __exportStar3(require_ua_event_type(), exports2);
    __exportStar3(require_ua_method(), exports2);
    __exportStar3(require_ua_object_type(), exports2);
    __exportStar3(require_ua_object(), exports2);
    __exportStar3(require_ua_property(), exports2);
    __exportStar3(require_ua_reference_type(), exports2);
    __exportStar3(require_ua_reference(), exports2);
    __exportStar3(require_ua_variable_t(), exports2);
    __exportStar3(require_ua_variable_type(), exports2);
    __exportStar3(require_ua_variable(), exports2);
    __exportStar3(require_ua_view(), exports2);
  }
});

// node_modules/node-opcua-address-space/dist/source/session_context.js
var require_session_context2 = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/session_context.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SessionContext = exports2.makeRoles = exports2.WellKnownRolesNodeId = exports2.WellKnownRoles = exports2.PermissionType = exports2.RolePermissionType = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_crypto_1 = require_dist33();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_types_2 = require_dist32();
    Object.defineProperty(exports2, "RolePermissionType", { enumerable: true, get: function() {
      return node_opcua_types_2.RolePermissionType;
    } });
    Object.defineProperty(exports2, "PermissionType", { enumerable: true, get: function() {
      return node_opcua_types_2.PermissionType;
    } });
    function getUserName(userIdentityToken) {
      if (userIdentityToken instanceof node_opcua_types_1.AnonymousIdentityToken) {
        return "anonymous";
      }
      if (userIdentityToken instanceof node_opcua_types_1.X509IdentityToken) {
        const certInfo = (0, node_opcua_crypto_1.exploreCertificate)(userIdentityToken.certificateData);
        const userName = certInfo.tbsCertificate.subject.commonName || "";
        if (typeof userName !== "string") {
          throw new Error("Invalid username");
        }
        return userName;
      }
      if (userIdentityToken instanceof node_opcua_types_1.UserNameIdentityToken) {
        if (userIdentityToken.policyId === "anonymous") {
          return "anonymous";
        }
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(userIdentityToken, "userName"));
        return userIdentityToken.userName;
      }
      throw new Error("Invalid user identity token");
    }
    var WellKnownRoles;
    (function(WellKnownRoles2) {
      WellKnownRoles2[WellKnownRoles2["Anonymous"] = 15644] = "Anonymous";
      WellKnownRoles2[WellKnownRoles2["AuthenticatedUser"] = 15656] = "AuthenticatedUser";
      WellKnownRoles2[WellKnownRoles2["ConfigureAdmin"] = 15716] = "ConfigureAdmin";
      WellKnownRoles2[WellKnownRoles2["Engineer"] = 16036] = "Engineer";
      WellKnownRoles2[WellKnownRoles2["Observer"] = 15668] = "Observer";
      WellKnownRoles2[WellKnownRoles2["Operator"] = 15680] = "Operator";
      WellKnownRoles2[WellKnownRoles2["SecurityAdmin"] = 15704] = "SecurityAdmin";
      WellKnownRoles2[WellKnownRoles2["Supervisor"] = 15692] = "Supervisor";
    })(WellKnownRoles || (exports2.WellKnownRoles = WellKnownRoles = {}));
    var WellKnownRolesNodeId;
    (function(WellKnownRolesNodeId2) {
      WellKnownRolesNodeId2[WellKnownRolesNodeId2["Anonymous"] = 15644] = "Anonymous";
      WellKnownRolesNodeId2[WellKnownRolesNodeId2["AuthenticatedUser"] = 15656] = "AuthenticatedUser";
      WellKnownRolesNodeId2[WellKnownRolesNodeId2["ConfigureAdmin"] = 15716] = "ConfigureAdmin";
      WellKnownRolesNodeId2[WellKnownRolesNodeId2["Engineer"] = 16036] = "Engineer";
      WellKnownRolesNodeId2[WellKnownRolesNodeId2["Observer"] = 15668] = "Observer";
      WellKnownRolesNodeId2[WellKnownRolesNodeId2["Operator"] = 15680] = "Operator";
      WellKnownRolesNodeId2[WellKnownRolesNodeId2["SecurityAdmin"] = 15704] = "SecurityAdmin";
      WellKnownRolesNodeId2[WellKnownRolesNodeId2["Supervisor"] = 15692] = "Supervisor";
    })(WellKnownRolesNodeId || (exports2.WellKnownRolesNodeId = WellKnownRolesNodeId = {}));
    function getPermissionForRole(rolePermissions, role) {
      if (rolePermissions === null) {
        return node_opcua_data_model_1.allPermissions;
      }
      const a = rolePermissions.find((r) => {
        return (0, node_opcua_nodeid_1.sameNodeId)((0, node_opcua_nodeid_1.resolveNodeId)(r.roleId), role);
      });
      return a !== void 0 ? a.permissions | node_opcua_data_model_1.PermissionFlag.None : node_opcua_data_model_1.PermissionFlag.None;
    }
    function isDefaultContext(context) {
      return context === SessionContext.defaultContext;
    }
    function getAccessRestrictionsOnNamespace(namespace, context) {
      if (isDefaultContext(context)) {
        return node_opcua_data_model_1.AccessRestrictionsFlag.None;
      }
      const namespaces = namespace.addressSpace.rootFolder?.objects?.server?.namespaces;
      if (!namespaces) {
        return node_opcua_data_model_1.AccessRestrictionsFlag.None;
      }
      const namespaceObject = namespaces.getChildByName(namespace.namespaceUri);
      if (!namespaceObject) {
        return node_opcua_data_model_1.AccessRestrictionsFlag.None;
      }
      const defaultAccessRestriction = namespaceObject.getChildByName("defaultAccessRestriction");
      if (defaultAccessRestriction) {
        const dataValue = defaultAccessRestriction.readAttribute(null, node_opcua_data_model_1.AttributeIds.Value);
        if (dataValue && dataValue.statusCode.isGood()) {
          return dataValue.value.value;
        }
      }
      return node_opcua_data_model_1.AccessRestrictionsFlag.None;
    }
    function getDefaultUserRolePermissionsOnNamespace(namespace, context) {
      if (isDefaultContext(context)) {
        return null;
      }
      const namespaces = namespace.addressSpace.rootFolder?.objects?.server?.namespaces;
      if (!namespaces) {
        return null;
      }
      const uaNamespaceObject = namespaces.getChildByName(namespace.namespaceUri);
      if (!uaNamespaceObject) {
        return null;
      }
      const defaultUserRolePermissions = uaNamespaceObject.getChildByName("DefaultUserRolePermissions");
      if (defaultUserRolePermissions) {
        const dataValue = defaultUserRolePermissions.readValue();
        if (dataValue && dataValue.statusCode.isGood() && dataValue.value.value && dataValue.value.value.length > 0) {
          return dataValue.value.value;
        }
      }
      const defaultRolePermissions = uaNamespaceObject.getChildByName("DefaultRolePermissions");
      if (defaultRolePermissions) {
        const dataValue = defaultRolePermissions.readValue();
        if (dataValue && dataValue.statusCode.isGood()) {
          return dataValue.value.value;
        }
      }
      return null;
    }
    function makeRoles(roleIds) {
      if (typeof roleIds === "number") {
        roleIds = [roleIds];
      }
      if (typeof roleIds === "string") {
        roleIds = roleIds.split(";").map((r) => (0, node_opcua_nodeid_1.resolveNodeId)("WellKnownRole_" + r));
      }
      return roleIds.map((r) => (0, node_opcua_nodeid_1.resolveNodeId)(r));
    }
    exports2.makeRoles = makeRoles;
    var SessionContext = class {
      constructor(options) {
        this.continuationPoints = {};
        options = options || {};
        this.session = options.session;
        this.object = options.object;
        this.server = options.server;
        this.currentTime = void 0;
      }
      /**
       * getCurrentUserRoles
       *
       * guest   => anonymous user (unauthenticated)
       * default => default authenticated user
       *
       */
      getCurrentUserRoles() {
        if (!this.session) {
          return [];
        }
        (0, node_opcua_assert_1.assert)(this.session != null, "expecting a session");
        const userIdentityToken = this.session.userIdentityToken;
        if (!userIdentityToken) {
          return [];
        }
        const anonymous = makeRoles([WellKnownRoles.Anonymous]);
        const username = getUserName(userIdentityToken);
        if (username === "anonymous") {
          return anonymous;
        }
        if (!this.server || !this.server.userManager) {
          return anonymous;
        }
        (0, node_opcua_assert_1.assert)(this.server != null, "expecting a server");
        if (typeof this.server.userManager.getUserRoles !== "function") {
          return anonymous;
        }
        const rolesNodeId = this.server.userManager.getUserRoles(username);
        if (rolesNodeId.findIndex((r) => r.namespace === 0 && r.value === WellKnownRoles.AuthenticatedUser) < 0) {
          rolesNodeId.push((0, node_opcua_nodeid_1.resolveNodeId)(WellKnownRoles.AuthenticatedUser));
        }
        return rolesNodeId;
      }
      getApplicableRolePermissions(node) {
        if (!node.rolePermissions) {
          const namespace = node.namespace;
          const defaultUserRolePermissions = getDefaultUserRolePermissionsOnNamespace(namespace, this);
          return defaultUserRolePermissions;
        }
        return node.rolePermissions;
      }
      getPermissions(node) {
        const applicableRolePermissions = this.getApplicableRolePermissions(node);
        const roles = this.getCurrentUserRoles();
        if (roles.length === 0) {
          return node_opcua_data_model_1.allPermissions;
        }
        let orFlags = 0;
        for (const role of roles) {
          orFlags = orFlags | getPermissionForRole(applicableRolePermissions, role);
        }
        return orFlags;
      }
      getAccessRestrictions(node) {
        if (node.accessRestrictions === void 0) {
          const namespace = node.namespace;
          const accessRestrictions = getAccessRestrictionsOnNamespace(namespace, this);
          return accessRestrictions;
        }
        return node.accessRestrictions;
      }
      /**
       *
       * @param node
       * @returns true if the browse is denied (access is restricted)
       */
      isBrowseAccessRestricted(node) {
        if (this.checkPermission(node, node_opcua_types_1.PermissionType.Browse)) {
          return false;
        }
        return true;
      }
      /**
       *
       * @param node
       * @returns true  if the context is access restricted
       */
      isAccessRestricted(node) {
        const accessRestrictions = this.getAccessRestrictions(node);
        if (accessRestrictions === node_opcua_data_model_1.AccessRestrictionsFlag.None) {
          return false;
        }
        if (accessRestrictions & node_opcua_data_model_1.AccessRestrictionsFlag.SessionRequired) {
          if (!this.session) {
            return true;
          }
        }
        if (!this.session) {
          return false;
        }
        const securityMode = this.session?.channel?.securityMode;
        if (accessRestrictions & node_opcua_data_model_1.AccessRestrictionsFlag.SigningRequired) {
          if (securityMode !== node_opcua_types_1.MessageSecurityMode.Sign && securityMode !== node_opcua_types_1.MessageSecurityMode.SignAndEncrypt) {
            return true;
          }
        }
        if (accessRestrictions & node_opcua_data_model_1.AccessRestrictionsFlag.EncryptionRequired) {
          if (securityMode !== node_opcua_types_1.MessageSecurityMode.SignAndEncrypt) {
            return true;
          }
        }
        return false;
      }
      /**
       * @method checkPermission
       * @param node
       * @param requestedPermission
       * @return {Boolean} returns true of the current user is granted the requested Permission
       */
      checkPermission(node, requestedPermission) {
        const permissions = this.getPermissions(node);
        return (permissions & requestedPermission) === requestedPermission;
      }
      currentUserHasRole(role) {
        const currentUserRole = this.getCurrentUserRoles();
        const n = (0, node_opcua_nodeid_1.resolveNodeId)(role);
        return currentUserRole.findIndex((r) => (0, node_opcua_nodeid_1.sameNodeId)(r, n)) >= 0;
      }
    };
    exports2.SessionContext = SessionContext;
    SessionContext.defaultContext = new SessionContext({});
  }
});

// node_modules/node-opcua-address-space/dist/source/helpers/multiform_func.js
var require_multiform_func = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/helpers/multiform_func.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.convertToCallbackFunction1 = exports2.convertToCallbackFunction = void 0;
    var node_opcua_debug_1 = require_dist24();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    function convertToCallbackFunction(func) {
      if (func.length === 0) {
        return function(callback) {
          let valueOrPromise;
          try {
            valueOrPromise = func.call(this);
          } catch (err) {
            return callback(err);
          }
          if (valueOrPromise instanceof Promise) {
            valueOrPromise.then((value) => callback(null, value)).catch((err) => callback(err));
          } else {
            return callback(null, valueOrPromise);
          }
        };
      } else {
        if (func.length !== 1) {
          throw new Error("convertToCallbackFunction: invalid function");
        }
        return function(callback) {
          try {
            func.call(this, callback);
          } catch (err) {
            warningLog("internal error", err.message);
            callback(err);
          }
        };
      }
    }
    exports2.convertToCallbackFunction = convertToCallbackFunction;
    function convertToCallbackFunction1(func) {
      if (func.length === 1) {
        return function(param, callback) {
          let valueOrPromise;
          try {
            valueOrPromise = func.call(this, param);
          } catch (err) {
            return callback(err);
          }
          if (valueOrPromise instanceof Promise) {
            valueOrPromise.then((value) => callback(null, value)).catch((err) => callback(err));
          } else {
            return callback(null, valueOrPromise);
          }
        };
      } else {
        if (func.length !== 2) {
          throw new Error("convertToCallbackFunction: invalid function");
        }
        return function(param, callback) {
          try {
            func.call(this, param, callback);
          } catch (err) {
            warningLog("internal error", err.message);
            callback(err);
          }
        };
      }
    }
    exports2.convertToCallbackFunction1 = convertToCallbackFunction1;
  }
});

// node_modules/lodash/lodash.js
var require_lodash2 = __commonJS({
  "node_modules/lodash/lodash.js"(exports2, module2) {
    (function() {
      var undefined2;
      var VERSION2 = "4.17.21";
      var LARGE_ARRAY_SIZE = 200;
      var CORE_ERROR_TEXT = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", FUNC_ERROR_TEXT = "Expected a function", INVALID_TEMPL_VAR_ERROR_TEXT = "Invalid `variable` option passed into `_.template`";
      var HASH_UNDEFINED = "__lodash_hash_undefined__";
      var MAX_MEMOIZE_SIZE = 500;
      var PLACEHOLDER = "__lodash_placeholder__";
      var CLONE_DEEP_FLAG = 1, CLONE_FLAT_FLAG = 2, CLONE_SYMBOLS_FLAG = 4;
      var COMPARE_PARTIAL_FLAG = 1, COMPARE_UNORDERED_FLAG = 2;
      var WRAP_BIND_FLAG = 1, WRAP_BIND_KEY_FLAG = 2, WRAP_CURRY_BOUND_FLAG = 4, WRAP_CURRY_FLAG = 8, WRAP_CURRY_RIGHT_FLAG = 16, WRAP_PARTIAL_FLAG = 32, WRAP_PARTIAL_RIGHT_FLAG = 64, WRAP_ARY_FLAG = 128, WRAP_REARG_FLAG = 256, WRAP_FLIP_FLAG = 512;
      var DEFAULT_TRUNC_LENGTH = 30, DEFAULT_TRUNC_OMISSION = "...";
      var HOT_COUNT = 800, HOT_SPAN = 16;
      var LAZY_FILTER_FLAG = 1, LAZY_MAP_FLAG = 2, LAZY_WHILE_FLAG = 3;
      var INFINITY = 1 / 0, MAX_SAFE_INTEGER = 9007199254740991, MAX_INTEGER = 17976931348623157e292, NAN = 0 / 0;
      var MAX_ARRAY_LENGTH = 4294967295, MAX_ARRAY_INDEX = MAX_ARRAY_LENGTH - 1, HALF_MAX_ARRAY_LENGTH = MAX_ARRAY_LENGTH >>> 1;
      var wrapFlags = [
        ["ary", WRAP_ARY_FLAG],
        ["bind", WRAP_BIND_FLAG],
        ["bindKey", WRAP_BIND_KEY_FLAG],
        ["curry", WRAP_CURRY_FLAG],
        ["curryRight", WRAP_CURRY_RIGHT_FLAG],
        ["flip", WRAP_FLIP_FLAG],
        ["partial", WRAP_PARTIAL_FLAG],
        ["partialRight", WRAP_PARTIAL_RIGHT_FLAG],
        ["rearg", WRAP_REARG_FLAG]
      ];
      var argsTag = "[object Arguments]", arrayTag = "[object Array]", asyncTag = "[object AsyncFunction]", boolTag = "[object Boolean]", dateTag = "[object Date]", domExcTag = "[object DOMException]", errorTag = "[object Error]", funcTag = "[object Function]", genTag = "[object GeneratorFunction]", mapTag = "[object Map]", numberTag = "[object Number]", nullTag = "[object Null]", objectTag = "[object Object]", promiseTag = "[object Promise]", proxyTag = "[object Proxy]", regexpTag = "[object RegExp]", setTag = "[object Set]", stringTag = "[object String]", symbolTag = "[object Symbol]", undefinedTag = "[object Undefined]", weakMapTag = "[object WeakMap]", weakSetTag = "[object WeakSet]";
      var arrayBufferTag = "[object ArrayBuffer]", dataViewTag = "[object DataView]", float32Tag = "[object Float32Array]", float64Tag = "[object Float64Array]", int8Tag = "[object Int8Array]", int16Tag = "[object Int16Array]", int32Tag = "[object Int32Array]", uint8Tag = "[object Uint8Array]", uint8ClampedTag = "[object Uint8ClampedArray]", uint16Tag = "[object Uint16Array]", uint32Tag = "[object Uint32Array]";
      var reEmptyStringLeading = /\b__p \+= '';/g, reEmptyStringMiddle = /\b(__p \+=) '' \+/g, reEmptyStringTrailing = /(__e\(.*?\)|\b__t\)) \+\n'';/g;
      var reEscapedHtml = /&(?:amp|lt|gt|quot|#39);/g, reUnescapedHtml = /[&<>"']/g, reHasEscapedHtml = RegExp(reEscapedHtml.source), reHasUnescapedHtml = RegExp(reUnescapedHtml.source);
      var reEscape = /<%-([\s\S]+?)%>/g, reEvaluate = /<%([\s\S]+?)%>/g, reInterpolate = /<%=([\s\S]+?)%>/g;
      var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, reIsPlainProp = /^\w*$/, rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
      var reRegExpChar = /[\\^$.*+?()[\]{}|]/g, reHasRegExpChar = RegExp(reRegExpChar.source);
      var reTrimStart = /^\s+/;
      var reWhitespace = /\s/;
      var reWrapComment = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, reWrapDetails = /\{\n\/\* \[wrapped with (.+)\] \*/, reSplitDetails = /,? & /;
      var reAsciiWord = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
      var reForbiddenIdentifierChars = /[()=,{}\[\]\/\s]/;
      var reEscapeChar = /\\(\\)?/g;
      var reEsTemplate = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g;
      var reFlags = /\w*$/;
      var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
      var reIsBinary = /^0b[01]+$/i;
      var reIsHostCtor = /^\[object .+?Constructor\]$/;
      var reIsOctal = /^0o[0-7]+$/i;
      var reIsUint = /^(?:0|[1-9]\d*)$/;
      var reLatin = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;
      var reNoMatch = /($^)/;
      var reUnescapedString = /['\n\r\u2028\u2029\\]/g;
      var rsAstralRange = "\\ud800-\\udfff", rsComboMarksRange = "\\u0300-\\u036f", reComboHalfMarksRange = "\\ufe20-\\ufe2f", rsComboSymbolsRange = "\\u20d0-\\u20ff", rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange, rsDingbatRange = "\\u2700-\\u27bf", rsLowerRange = "a-z\\xdf-\\xf6\\xf8-\\xff", rsMathOpRange = "\\xac\\xb1\\xd7\\xf7", rsNonCharRange = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", rsPunctuationRange = "\\u2000-\\u206f", rsSpaceRange = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", rsUpperRange = "A-Z\\xc0-\\xd6\\xd8-\\xde", rsVarRange = "\\ufe0e\\ufe0f", rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange;
      var rsApos = "['\u2019]", rsAstral = "[" + rsAstralRange + "]", rsBreak = "[" + rsBreakRange + "]", rsCombo = "[" + rsComboRange + "]", rsDigits = "\\d+", rsDingbat = "[" + rsDingbatRange + "]", rsLower = "[" + rsLowerRange + "]", rsMisc = "[^" + rsAstralRange + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + "]", rsFitz = "\\ud83c[\\udffb-\\udfff]", rsModifier = "(?:" + rsCombo + "|" + rsFitz + ")", rsNonAstral = "[^" + rsAstralRange + "]", rsRegional = "(?:\\ud83c[\\udde6-\\uddff]){2}", rsSurrPair = "[\\ud800-\\udbff][\\udc00-\\udfff]", rsUpper = "[" + rsUpperRange + "]", rsZWJ = "\\u200d";
      var rsMiscLower = "(?:" + rsLower + "|" + rsMisc + ")", rsMiscUpper = "(?:" + rsUpper + "|" + rsMisc + ")", rsOptContrLower = "(?:" + rsApos + "(?:d|ll|m|re|s|t|ve))?", rsOptContrUpper = "(?:" + rsApos + "(?:D|LL|M|RE|S|T|VE))?", reOptMod = rsModifier + "?", rsOptVar = "[" + rsVarRange + "]?", rsOptJoin = "(?:" + rsZWJ + "(?:" + [rsNonAstral, rsRegional, rsSurrPair].join("|") + ")" + rsOptVar + reOptMod + ")*", rsOrdLower = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", rsOrdUpper = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", rsSeq = rsOptVar + reOptMod + rsOptJoin, rsEmoji = "(?:" + [rsDingbat, rsRegional, rsSurrPair].join("|") + ")" + rsSeq, rsSymbol = "(?:" + [rsNonAstral + rsCombo + "?", rsCombo, rsRegional, rsSurrPair, rsAstral].join("|") + ")";
      var reApos = RegExp(rsApos, "g");
      var reComboMark = RegExp(rsCombo, "g");
      var reUnicode = RegExp(rsFitz + "(?=" + rsFitz + ")|" + rsSymbol + rsSeq, "g");
      var reUnicodeWord = RegExp([
        rsUpper + "?" + rsLower + "+" + rsOptContrLower + "(?=" + [rsBreak, rsUpper, "$"].join("|") + ")",
        rsMiscUpper + "+" + rsOptContrUpper + "(?=" + [rsBreak, rsUpper + rsMiscLower, "$"].join("|") + ")",
        rsUpper + "?" + rsMiscLower + "+" + rsOptContrLower,
        rsUpper + "+" + rsOptContrUpper,
        rsOrdUpper,
        rsOrdLower,
        rsDigits,
        rsEmoji
      ].join("|"), "g");
      var reHasUnicode = RegExp("[" + rsZWJ + rsAstralRange + rsComboRange + rsVarRange + "]");
      var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
      var contextProps = [
        "Array",
        "Buffer",
        "DataView",
        "Date",
        "Error",
        "Float32Array",
        "Float64Array",
        "Function",
        "Int8Array",
        "Int16Array",
        "Int32Array",
        "Map",
        "Math",
        "Object",
        "Promise",
        "RegExp",
        "Set",
        "String",
        "Symbol",
        "TypeError",
        "Uint8Array",
        "Uint8ClampedArray",
        "Uint16Array",
        "Uint32Array",
        "WeakMap",
        "_",
        "clearTimeout",
        "isFinite",
        "parseInt",
        "setTimeout"
      ];
      var templateCounter = -1;
      var typedArrayTags = {};
      typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
      typedArrayTags[argsTag] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = false;
      var cloneableTags = {};
      cloneableTags[argsTag] = cloneableTags[arrayTag] = cloneableTags[arrayBufferTag] = cloneableTags[dataViewTag] = cloneableTags[boolTag] = cloneableTags[dateTag] = cloneableTags[float32Tag] = cloneableTags[float64Tag] = cloneableTags[int8Tag] = cloneableTags[int16Tag] = cloneableTags[int32Tag] = cloneableTags[mapTag] = cloneableTags[numberTag] = cloneableTags[objectTag] = cloneableTags[regexpTag] = cloneableTags[setTag] = cloneableTags[stringTag] = cloneableTags[symbolTag] = cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] = cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
      cloneableTags[errorTag] = cloneableTags[funcTag] = cloneableTags[weakMapTag] = false;
      var deburredLetters = {
        // Latin-1 Supplement block.
        "\xC0": "A",
        "\xC1": "A",
        "\xC2": "A",
        "\xC3": "A",
        "\xC4": "A",
        "\xC5": "A",
        "\xE0": "a",
        "\xE1": "a",
        "\xE2": "a",
        "\xE3": "a",
        "\xE4": "a",
        "\xE5": "a",
        "\xC7": "C",
        "\xE7": "c",
        "\xD0": "D",
        "\xF0": "d",
        "\xC8": "E",
        "\xC9": "E",
        "\xCA": "E",
        "\xCB": "E",
        "\xE8": "e",
        "\xE9": "e",
        "\xEA": "e",
        "\xEB": "e",
        "\xCC": "I",
        "\xCD": "I",
        "\xCE": "I",
        "\xCF": "I",
        "\xEC": "i",
        "\xED": "i",
        "\xEE": "i",
        "\xEF": "i",
        "\xD1": "N",
        "\xF1": "n",
        "\xD2": "O",
        "\xD3": "O",
        "\xD4": "O",
        "\xD5": "O",
        "\xD6": "O",
        "\xD8": "O",
        "\xF2": "o",
        "\xF3": "o",
        "\xF4": "o",
        "\xF5": "o",
        "\xF6": "o",
        "\xF8": "o",
        "\xD9": "U",
        "\xDA": "U",
        "\xDB": "U",
        "\xDC": "U",
        "\xF9": "u",
        "\xFA": "u",
        "\xFB": "u",
        "\xFC": "u",
        "\xDD": "Y",
        "\xFD": "y",
        "\xFF": "y",
        "\xC6": "Ae",
        "\xE6": "ae",
        "\xDE": "Th",
        "\xFE": "th",
        "\xDF": "ss",
        // Latin Extended-A block.
        "\u0100": "A",
        "\u0102": "A",
        "\u0104": "A",
        "\u0101": "a",
        "\u0103": "a",
        "\u0105": "a",
        "\u0106": "C",
        "\u0108": "C",
        "\u010A": "C",
        "\u010C": "C",
        "\u0107": "c",
        "\u0109": "c",
        "\u010B": "c",
        "\u010D": "c",
        "\u010E": "D",
        "\u0110": "D",
        "\u010F": "d",
        "\u0111": "d",
        "\u0112": "E",
        "\u0114": "E",
        "\u0116": "E",
        "\u0118": "E",
        "\u011A": "E",
        "\u0113": "e",
        "\u0115": "e",
        "\u0117": "e",
        "\u0119": "e",
        "\u011B": "e",
        "\u011C": "G",
        "\u011E": "G",
        "\u0120": "G",
        "\u0122": "G",
        "\u011D": "g",
        "\u011F": "g",
        "\u0121": "g",
        "\u0123": "g",
        "\u0124": "H",
        "\u0126": "H",
        "\u0125": "h",
        "\u0127": "h",
        "\u0128": "I",
        "\u012A": "I",
        "\u012C": "I",
        "\u012E": "I",
        "\u0130": "I",
        "\u0129": "i",
        "\u012B": "i",
        "\u012D": "i",
        "\u012F": "i",
        "\u0131": "i",
        "\u0134": "J",
        "\u0135": "j",
        "\u0136": "K",
        "\u0137": "k",
        "\u0138": "k",
        "\u0139": "L",
        "\u013B": "L",
        "\u013D": "L",
        "\u013F": "L",
        "\u0141": "L",
        "\u013A": "l",
        "\u013C": "l",
        "\u013E": "l",
        "\u0140": "l",
        "\u0142": "l",
        "\u0143": "N",
        "\u0145": "N",
        "\u0147": "N",
        "\u014A": "N",
        "\u0144": "n",
        "\u0146": "n",
        "\u0148": "n",
        "\u014B": "n",
        "\u014C": "O",
        "\u014E": "O",
        "\u0150": "O",
        "\u014D": "o",
        "\u014F": "o",
        "\u0151": "o",
        "\u0154": "R",
        "\u0156": "R",
        "\u0158": "R",
        "\u0155": "r",
        "\u0157": "r",
        "\u0159": "r",
        "\u015A": "S",
        "\u015C": "S",
        "\u015E": "S",
        "\u0160": "S",
        "\u015B": "s",
        "\u015D": "s",
        "\u015F": "s",
        "\u0161": "s",
        "\u0162": "T",
        "\u0164": "T",
        "\u0166": "T",
        "\u0163": "t",
        "\u0165": "t",
        "\u0167": "t",
        "\u0168": "U",
        "\u016A": "U",
        "\u016C": "U",
        "\u016E": "U",
        "\u0170": "U",
        "\u0172": "U",
        "\u0169": "u",
        "\u016B": "u",
        "\u016D": "u",
        "\u016F": "u",
        "\u0171": "u",
        "\u0173": "u",
        "\u0174": "W",
        "\u0175": "w",
        "\u0176": "Y",
        "\u0177": "y",
        "\u0178": "Y",
        "\u0179": "Z",
        "\u017B": "Z",
        "\u017D": "Z",
        "\u017A": "z",
        "\u017C": "z",
        "\u017E": "z",
        "\u0132": "IJ",
        "\u0133": "ij",
        "\u0152": "Oe",
        "\u0153": "oe",
        "\u0149": "'n",
        "\u017F": "s"
      };
      var htmlEscapes = {
        "&": "&amp;",
        "<": "&lt;",
        ">": "&gt;",
        '"': "&quot;",
        "'": "&#39;"
      };
      var htmlUnescapes = {
        "&amp;": "&",
        "&lt;": "<",
        "&gt;": ">",
        "&quot;": '"',
        "&#39;": "'"
      };
      var stringEscapes = {
        "\\": "\\",
        "'": "'",
        "\n": "n",
        "\r": "r",
        "\u2028": "u2028",
        "\u2029": "u2029"
      };
      var freeParseFloat = parseFloat, freeParseInt = parseInt;
      var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
      var freeSelf = typeof self == "object" && self && self.Object === Object && self;
      var root = freeGlobal || freeSelf || Function("return this")();
      var freeExports = typeof exports2 == "object" && exports2 && !exports2.nodeType && exports2;
      var freeModule = freeExports && typeof module2 == "object" && module2 && !module2.nodeType && module2;
      var moduleExports = freeModule && freeModule.exports === freeExports;
      var freeProcess = moduleExports && freeGlobal.process;
      var nodeUtil = function() {
        try {
          var types2 = freeModule && freeModule.require && freeModule.require("util").types;
          if (types2) {
            return types2;
          }
          return freeProcess && freeProcess.binding && freeProcess.binding("util");
        } catch (e) {
        }
      }();
      var nodeIsArrayBuffer = nodeUtil && nodeUtil.isArrayBuffer, nodeIsDate = nodeUtil && nodeUtil.isDate, nodeIsMap = nodeUtil && nodeUtil.isMap, nodeIsRegExp = nodeUtil && nodeUtil.isRegExp, nodeIsSet = nodeUtil && nodeUtil.isSet, nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
      function apply(func, thisArg, args) {
        switch (args.length) {
          case 0:
            return func.call(thisArg);
          case 1:
            return func.call(thisArg, args[0]);
          case 2:
            return func.call(thisArg, args[0], args[1]);
          case 3:
            return func.call(thisArg, args[0], args[1], args[2]);
        }
        return func.apply(thisArg, args);
      }
      function arrayAggregator(array, setter, iteratee, accumulator) {
        var index = -1, length = array == null ? 0 : array.length;
        while (++index < length) {
          var value = array[index];
          setter(accumulator, value, iteratee(value), array);
        }
        return accumulator;
      }
      function arrayEach(array, iteratee) {
        var index = -1, length = array == null ? 0 : array.length;
        while (++index < length) {
          if (iteratee(array[index], index, array) === false) {
            break;
          }
        }
        return array;
      }
      function arrayEachRight(array, iteratee) {
        var length = array == null ? 0 : array.length;
        while (length--) {
          if (iteratee(array[length], length, array) === false) {
            break;
          }
        }
        return array;
      }
      function arrayEvery(array, predicate) {
        var index = -1, length = array == null ? 0 : array.length;
        while (++index < length) {
          if (!predicate(array[index], index, array)) {
            return false;
          }
        }
        return true;
      }
      function arrayFilter(array, predicate) {
        var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result2 = [];
        while (++index < length) {
          var value = array[index];
          if (predicate(value, index, array)) {
            result2[resIndex++] = value;
          }
        }
        return result2;
      }
      function arrayIncludes(array, value) {
        var length = array == null ? 0 : array.length;
        return !!length && baseIndexOf(array, value, 0) > -1;
      }
      function arrayIncludesWith(array, value, comparator) {
        var index = -1, length = array == null ? 0 : array.length;
        while (++index < length) {
          if (comparator(value, array[index])) {
            return true;
          }
        }
        return false;
      }
      function arrayMap(array, iteratee) {
        var index = -1, length = array == null ? 0 : array.length, result2 = Array(length);
        while (++index < length) {
          result2[index] = iteratee(array[index], index, array);
        }
        return result2;
      }
      function arrayPush(array, values) {
        var index = -1, length = values.length, offset = array.length;
        while (++index < length) {
          array[offset + index] = values[index];
        }
        return array;
      }
      function arrayReduce(array, iteratee, accumulator, initAccum) {
        var index = -1, length = array == null ? 0 : array.length;
        if (initAccum && length) {
          accumulator = array[++index];
        }
        while (++index < length) {
          accumulator = iteratee(accumulator, array[index], index, array);
        }
        return accumulator;
      }
      function arrayReduceRight(array, iteratee, accumulator, initAccum) {
        var length = array == null ? 0 : array.length;
        if (initAccum && length) {
          accumulator = array[--length];
        }
        while (length--) {
          accumulator = iteratee(accumulator, array[length], length, array);
        }
        return accumulator;
      }
      function arraySome(array, predicate) {
        var index = -1, length = array == null ? 0 : array.length;
        while (++index < length) {
          if (predicate(array[index], index, array)) {
            return true;
          }
        }
        return false;
      }
      var asciiSize = baseProperty("length");
      function asciiToArray(string) {
        return string.split("");
      }
      function asciiWords(string) {
        return string.match(reAsciiWord) || [];
      }
      function baseFindKey(collection, predicate, eachFunc) {
        var result2;
        eachFunc(collection, function(value, key, collection2) {
          if (predicate(value, key, collection2)) {
            result2 = key;
            return false;
          }
        });
        return result2;
      }
      function baseFindIndex(array, predicate, fromIndex, fromRight) {
        var length = array.length, index = fromIndex + (fromRight ? 1 : -1);
        while (fromRight ? index-- : ++index < length) {
          if (predicate(array[index], index, array)) {
            return index;
          }
        }
        return -1;
      }
      function baseIndexOf(array, value, fromIndex) {
        return value === value ? strictIndexOf(array, value, fromIndex) : baseFindIndex(array, baseIsNaN, fromIndex);
      }
      function baseIndexOfWith(array, value, fromIndex, comparator) {
        var index = fromIndex - 1, length = array.length;
        while (++index < length) {
          if (comparator(array[index], value)) {
            return index;
          }
        }
        return -1;
      }
      function baseIsNaN(value) {
        return value !== value;
      }
      function baseMean(array, iteratee) {
        var length = array == null ? 0 : array.length;
        return length ? baseSum(array, iteratee) / length : NAN;
      }
      function baseProperty(key) {
        return function(object) {
          return object == null ? undefined2 : object[key];
        };
      }
      function basePropertyOf(object) {
        return function(key) {
          return object == null ? undefined2 : object[key];
        };
      }
      function baseReduce(collection, iteratee, accumulator, initAccum, eachFunc) {
        eachFunc(collection, function(value, index, collection2) {
          accumulator = initAccum ? (initAccum = false, value) : iteratee(accumulator, value, index, collection2);
        });
        return accumulator;
      }
      function baseSortBy(array, comparer) {
        var length = array.length;
        array.sort(comparer);
        while (length--) {
          array[length] = array[length].value;
        }
        return array;
      }
      function baseSum(array, iteratee) {
        var result2, index = -1, length = array.length;
        while (++index < length) {
          var current = iteratee(array[index]);
          if (current !== undefined2) {
            result2 = result2 === undefined2 ? current : result2 + current;
          }
        }
        return result2;
      }
      function baseTimes(n, iteratee) {
        var index = -1, result2 = Array(n);
        while (++index < n) {
          result2[index] = iteratee(index);
        }
        return result2;
      }
      function baseToPairs(object, props) {
        return arrayMap(props, function(key) {
          return [key, object[key]];
        });
      }
      function baseTrim(string) {
        return string ? string.slice(0, trimmedEndIndex(string) + 1).replace(reTrimStart, "") : string;
      }
      function baseUnary(func) {
        return function(value) {
          return func(value);
        };
      }
      function baseValues(object, props) {
        return arrayMap(props, function(key) {
          return object[key];
        });
      }
      function cacheHas(cache, key) {
        return cache.has(key);
      }
      function charsStartIndex(strSymbols, chrSymbols) {
        var index = -1, length = strSymbols.length;
        while (++index < length && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {
        }
        return index;
      }
      function charsEndIndex(strSymbols, chrSymbols) {
        var index = strSymbols.length;
        while (index-- && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {
        }
        return index;
      }
      function countHolders(array, placeholder) {
        var length = array.length, result2 = 0;
        while (length--) {
          if (array[length] === placeholder) {
            ++result2;
          }
        }
        return result2;
      }
      var deburrLetter = basePropertyOf(deburredLetters);
      var escapeHtmlChar = basePropertyOf(htmlEscapes);
      function escapeStringChar(chr) {
        return "\\" + stringEscapes[chr];
      }
      function getValue(object, key) {
        return object == null ? undefined2 : object[key];
      }
      function hasUnicode(string) {
        return reHasUnicode.test(string);
      }
      function hasUnicodeWord(string) {
        return reHasUnicodeWord.test(string);
      }
      function iteratorToArray(iterator) {
        var data, result2 = [];
        while (!(data = iterator.next()).done) {
          result2.push(data.value);
        }
        return result2;
      }
      function mapToArray(map) {
        var index = -1, result2 = Array(map.size);
        map.forEach(function(value, key) {
          result2[++index] = [key, value];
        });
        return result2;
      }
      function overArg(func, transform) {
        return function(arg) {
          return func(transform(arg));
        };
      }
      function replaceHolders(array, placeholder) {
        var index = -1, length = array.length, resIndex = 0, result2 = [];
        while (++index < length) {
          var value = array[index];
          if (value === placeholder || value === PLACEHOLDER) {
            array[index] = PLACEHOLDER;
            result2[resIndex++] = index;
          }
        }
        return result2;
      }
      function setToArray(set) {
        var index = -1, result2 = Array(set.size);
        set.forEach(function(value) {
          result2[++index] = value;
        });
        return result2;
      }
      function setToPairs(set) {
        var index = -1, result2 = Array(set.size);
        set.forEach(function(value) {
          result2[++index] = [value, value];
        });
        return result2;
      }
      function strictIndexOf(array, value, fromIndex) {
        var index = fromIndex - 1, length = array.length;
        while (++index < length) {
          if (array[index] === value) {
            return index;
          }
        }
        return -1;
      }
      function strictLastIndexOf(array, value, fromIndex) {
        var index = fromIndex + 1;
        while (index--) {
          if (array[index] === value) {
            return index;
          }
        }
        return index;
      }
      function stringSize(string) {
        return hasUnicode(string) ? unicodeSize(string) : asciiSize(string);
      }
      function stringToArray(string) {
        return hasUnicode(string) ? unicodeToArray(string) : asciiToArray(string);
      }
      function trimmedEndIndex(string) {
        var index = string.length;
        while (index-- && reWhitespace.test(string.charAt(index))) {
        }
        return index;
      }
      var unescapeHtmlChar = basePropertyOf(htmlUnescapes);
      function unicodeSize(string) {
        var result2 = reUnicode.lastIndex = 0;
        while (reUnicode.test(string)) {
          ++result2;
        }
        return result2;
      }
      function unicodeToArray(string) {
        return string.match(reUnicode) || [];
      }
      function unicodeWords(string) {
        return string.match(reUnicodeWord) || [];
      }
      var runInContext = function runInContext2(context) {
        context = context == null ? root : _.defaults(root.Object(), context, _.pick(root, contextProps));
        var Array2 = context.Array, Date2 = context.Date, Error2 = context.Error, Function2 = context.Function, Math2 = context.Math, Object2 = context.Object, RegExp2 = context.RegExp, String2 = context.String, TypeError2 = context.TypeError;
        var arrayProto = Array2.prototype, funcProto = Function2.prototype, objectProto = Object2.prototype;
        var coreJsData = context["__core-js_shared__"];
        var funcToString = funcProto.toString;
        var hasOwnProperty = objectProto.hasOwnProperty;
        var idCounter = 0;
        var maskSrcKey = function() {
          var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
          return uid ? "Symbol(src)_1." + uid : "";
        }();
        var nativeObjectToString = objectProto.toString;
        var objectCtorString = funcToString.call(Object2);
        var oldDash = root._;
        var reIsNative = RegExp2(
          "^" + funcToString.call(hasOwnProperty).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
        );
        var Buffer2 = moduleExports ? context.Buffer : undefined2, Symbol2 = context.Symbol, Uint8Array2 = context.Uint8Array, allocUnsafe = Buffer2 ? Buffer2.allocUnsafe : undefined2, getPrototype = overArg(Object2.getPrototypeOf, Object2), objectCreate = Object2.create, propertyIsEnumerable = objectProto.propertyIsEnumerable, splice = arrayProto.splice, spreadableSymbol = Symbol2 ? Symbol2.isConcatSpreadable : undefined2, symIterator = Symbol2 ? Symbol2.iterator : undefined2, symToStringTag = Symbol2 ? Symbol2.toStringTag : undefined2;
        var defineProperty = function() {
          try {
            var func = getNative(Object2, "defineProperty");
            func({}, "", {});
            return func;
          } catch (e) {
          }
        }();
        var ctxClearTimeout = context.clearTimeout !== root.clearTimeout && context.clearTimeout, ctxNow = Date2 && Date2.now !== root.Date.now && Date2.now, ctxSetTimeout = context.setTimeout !== root.setTimeout && context.setTimeout;
        var nativeCeil = Math2.ceil, nativeFloor = Math2.floor, nativeGetSymbols = Object2.getOwnPropertySymbols, nativeIsBuffer = Buffer2 ? Buffer2.isBuffer : undefined2, nativeIsFinite = context.isFinite, nativeJoin = arrayProto.join, nativeKeys = overArg(Object2.keys, Object2), nativeMax = Math2.max, nativeMin = Math2.min, nativeNow = Date2.now, nativeParseInt = context.parseInt, nativeRandom = Math2.random, nativeReverse = arrayProto.reverse;
        var DataView2 = getNative(context, "DataView"), Map2 = getNative(context, "Map"), Promise2 = getNative(context, "Promise"), Set2 = getNative(context, "Set"), WeakMap2 = getNative(context, "WeakMap"), nativeCreate = getNative(Object2, "create");
        var metaMap = WeakMap2 && new WeakMap2();
        var realNames = {};
        var dataViewCtorString = toSource(DataView2), mapCtorString = toSource(Map2), promiseCtorString = toSource(Promise2), setCtorString = toSource(Set2), weakMapCtorString = toSource(WeakMap2);
        var symbolProto = Symbol2 ? Symbol2.prototype : undefined2, symbolValueOf = symbolProto ? symbolProto.valueOf : undefined2, symbolToString = symbolProto ? symbolProto.toString : undefined2;
        function lodash(value) {
          if (isObjectLike(value) && !isArray(value) && !(value instanceof LazyWrapper)) {
            if (value instanceof LodashWrapper) {
              return value;
            }
            if (hasOwnProperty.call(value, "__wrapped__")) {
              return wrapperClone(value);
            }
          }
          return new LodashWrapper(value);
        }
        var baseCreate = /* @__PURE__ */ function() {
          function object() {
          }
          return function(proto) {
            if (!isObject(proto)) {
              return {};
            }
            if (objectCreate) {
              return objectCreate(proto);
            }
            object.prototype = proto;
            var result3 = new object();
            object.prototype = undefined2;
            return result3;
          };
        }();
        function baseLodash() {
        }
        function LodashWrapper(value, chainAll) {
          this.__wrapped__ = value;
          this.__actions__ = [];
          this.__chain__ = !!chainAll;
          this.__index__ = 0;
          this.__values__ = undefined2;
        }
        lodash.templateSettings = {
          /**
           * Used to detect `data` property values to be HTML-escaped.
           *
           * @memberOf _.templateSettings
           * @type {RegExp}
           */
          "escape": reEscape,
          /**
           * Used to detect code to be evaluated.
           *
           * @memberOf _.templateSettings
           * @type {RegExp}
           */
          "evaluate": reEvaluate,
          /**
           * Used to detect `data` property values to inject.
           *
           * @memberOf _.templateSettings
           * @type {RegExp}
           */
          "interpolate": reInterpolate,
          /**
           * Used to reference the data object in the template text.
           *
           * @memberOf _.templateSettings
           * @type {string}
           */
          "variable": "",
          /**
           * Used to import variables into the compiled template.
           *
           * @memberOf _.templateSettings
           * @type {Object}
           */
          "imports": {
            /**
             * A reference to the `lodash` function.
             *
             * @memberOf _.templateSettings.imports
             * @type {Function}
             */
            "_": lodash
          }
        };
        lodash.prototype = baseLodash.prototype;
        lodash.prototype.constructor = lodash;
        LodashWrapper.prototype = baseCreate(baseLodash.prototype);
        LodashWrapper.prototype.constructor = LodashWrapper;
        function LazyWrapper(value) {
          this.__wrapped__ = value;
          this.__actions__ = [];
          this.__dir__ = 1;
          this.__filtered__ = false;
          this.__iteratees__ = [];
          this.__takeCount__ = MAX_ARRAY_LENGTH;
          this.__views__ = [];
        }
        function lazyClone() {
          var result3 = new LazyWrapper(this.__wrapped__);
          result3.__actions__ = copyArray(this.__actions__);
          result3.__dir__ = this.__dir__;
          result3.__filtered__ = this.__filtered__;
          result3.__iteratees__ = copyArray(this.__iteratees__);
          result3.__takeCount__ = this.__takeCount__;
          result3.__views__ = copyArray(this.__views__);
          return result3;
        }
        function lazyReverse() {
          if (this.__filtered__) {
            var result3 = new LazyWrapper(this);
            result3.__dir__ = -1;
            result3.__filtered__ = true;
          } else {
            result3 = this.clone();
            result3.__dir__ *= -1;
          }
          return result3;
        }
        function lazyValue() {
          var array = this.__wrapped__.value(), dir = this.__dir__, isArr = isArray(array), isRight = dir < 0, arrLength = isArr ? array.length : 0, view = getView(0, arrLength, this.__views__), start = view.start, end = view.end, length = end - start, index = isRight ? end : start - 1, iteratees = this.__iteratees__, iterLength = iteratees.length, resIndex = 0, takeCount = nativeMin(length, this.__takeCount__);
          if (!isArr || !isRight && arrLength == length && takeCount == length) {
            return baseWrapperValue(array, this.__actions__);
          }
          var result3 = [];
          outer:
            while (length-- && resIndex < takeCount) {
              index += dir;
              var iterIndex = -1, value = array[index];
              while (++iterIndex < iterLength) {
                var data = iteratees[iterIndex], iteratee2 = data.iteratee, type = data.type, computed = iteratee2(value);
                if (type == LAZY_MAP_FLAG) {
                  value = computed;
                } else if (!computed) {
                  if (type == LAZY_FILTER_FLAG) {
                    continue outer;
                  } else {
                    break outer;
                  }
                }
              }
              result3[resIndex++] = value;
            }
          return result3;
        }
        LazyWrapper.prototype = baseCreate(baseLodash.prototype);
        LazyWrapper.prototype.constructor = LazyWrapper;
        function Hash(entries) {
          var index = -1, length = entries == null ? 0 : entries.length;
          this.clear();
          while (++index < length) {
            var entry = entries[index];
            this.set(entry[0], entry[1]);
          }
        }
        function hashClear() {
          this.__data__ = nativeCreate ? nativeCreate(null) : {};
          this.size = 0;
        }
        function hashDelete(key) {
          var result3 = this.has(key) && delete this.__data__[key];
          this.size -= result3 ? 1 : 0;
          return result3;
        }
        function hashGet(key) {
          var data = this.__data__;
          if (nativeCreate) {
            var result3 = data[key];
            return result3 === HASH_UNDEFINED ? undefined2 : result3;
          }
          return hasOwnProperty.call(data, key) ? data[key] : undefined2;
        }
        function hashHas(key) {
          var data = this.__data__;
          return nativeCreate ? data[key] !== undefined2 : hasOwnProperty.call(data, key);
        }
        function hashSet(key, value) {
          var data = this.__data__;
          this.size += this.has(key) ? 0 : 1;
          data[key] = nativeCreate && value === undefined2 ? HASH_UNDEFINED : value;
          return this;
        }
        Hash.prototype.clear = hashClear;
        Hash.prototype["delete"] = hashDelete;
        Hash.prototype.get = hashGet;
        Hash.prototype.has = hashHas;
        Hash.prototype.set = hashSet;
        function ListCache(entries) {
          var index = -1, length = entries == null ? 0 : entries.length;
          this.clear();
          while (++index < length) {
            var entry = entries[index];
            this.set(entry[0], entry[1]);
          }
        }
        function listCacheClear() {
          this.__data__ = [];
          this.size = 0;
        }
        function listCacheDelete(key) {
          var data = this.__data__, index = assocIndexOf(data, key);
          if (index < 0) {
            return false;
          }
          var lastIndex = data.length - 1;
          if (index == lastIndex) {
            data.pop();
          } else {
            splice.call(data, index, 1);
          }
          --this.size;
          return true;
        }
        function listCacheGet(key) {
          var data = this.__data__, index = assocIndexOf(data, key);
          return index < 0 ? undefined2 : data[index][1];
        }
        function listCacheHas(key) {
          return assocIndexOf(this.__data__, key) > -1;
        }
        function listCacheSet(key, value) {
          var data = this.__data__, index = assocIndexOf(data, key);
          if (index < 0) {
            ++this.size;
            data.push([key, value]);
          } else {
            data[index][1] = value;
          }
          return this;
        }
        ListCache.prototype.clear = listCacheClear;
        ListCache.prototype["delete"] = listCacheDelete;
        ListCache.prototype.get = listCacheGet;
        ListCache.prototype.has = listCacheHas;
        ListCache.prototype.set = listCacheSet;
        function MapCache(entries) {
          var index = -1, length = entries == null ? 0 : entries.length;
          this.clear();
          while (++index < length) {
            var entry = entries[index];
            this.set(entry[0], entry[1]);
          }
        }
        function mapCacheClear() {
          this.size = 0;
          this.__data__ = {
            "hash": new Hash(),
            "map": new (Map2 || ListCache)(),
            "string": new Hash()
          };
        }
        function mapCacheDelete(key) {
          var result3 = getMapData(this, key)["delete"](key);
          this.size -= result3 ? 1 : 0;
          return result3;
        }
        function mapCacheGet(key) {
          return getMapData(this, key).get(key);
        }
        function mapCacheHas(key) {
          return getMapData(this, key).has(key);
        }
        function mapCacheSet(key, value) {
          var data = getMapData(this, key), size2 = data.size;
          data.set(key, value);
          this.size += data.size == size2 ? 0 : 1;
          return this;
        }
        MapCache.prototype.clear = mapCacheClear;
        MapCache.prototype["delete"] = mapCacheDelete;
        MapCache.prototype.get = mapCacheGet;
        MapCache.prototype.has = mapCacheHas;
        MapCache.prototype.set = mapCacheSet;
        function SetCache(values2) {
          var index = -1, length = values2 == null ? 0 : values2.length;
          this.__data__ = new MapCache();
          while (++index < length) {
            this.add(values2[index]);
          }
        }
        function setCacheAdd(value) {
          this.__data__.set(value, HASH_UNDEFINED);
          return this;
        }
        function setCacheHas(value) {
          return this.__data__.has(value);
        }
        SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
        SetCache.prototype.has = setCacheHas;
        function Stack(entries) {
          var data = this.__data__ = new ListCache(entries);
          this.size = data.size;
        }
        function stackClear() {
          this.__data__ = new ListCache();
          this.size = 0;
        }
        function stackDelete(key) {
          var data = this.__data__, result3 = data["delete"](key);
          this.size = data.size;
          return result3;
        }
        function stackGet(key) {
          return this.__data__.get(key);
        }
        function stackHas(key) {
          return this.__data__.has(key);
        }
        function stackSet(key, value) {
          var data = this.__data__;
          if (data instanceof ListCache) {
            var pairs = data.__data__;
            if (!Map2 || pairs.length < LARGE_ARRAY_SIZE - 1) {
              pairs.push([key, value]);
              this.size = ++data.size;
              return this;
            }
            data = this.__data__ = new MapCache(pairs);
          }
          data.set(key, value);
          this.size = data.size;
          return this;
        }
        Stack.prototype.clear = stackClear;
        Stack.prototype["delete"] = stackDelete;
        Stack.prototype.get = stackGet;
        Stack.prototype.has = stackHas;
        Stack.prototype.set = stackSet;
        function arrayLikeKeys(value, inherited) {
          var isArr = isArray(value), isArg = !isArr && isArguments(value), isBuff = !isArr && !isArg && isBuffer(value), isType = !isArr && !isArg && !isBuff && isTypedArray(value), skipIndexes = isArr || isArg || isBuff || isType, result3 = skipIndexes ? baseTimes(value.length, String2) : [], length = result3.length;
          for (var key in value) {
            if ((inherited || hasOwnProperty.call(value, key)) && !(skipIndexes && // Safari 9 has enumerable `arguments.length` in strict mode.
            (key == "length" || // Node.js 0.10 has enumerable non-index properties on buffers.
            isBuff && (key == "offset" || key == "parent") || // PhantomJS 2 has enumerable non-index properties on typed arrays.
            isType && (key == "buffer" || key == "byteLength" || key == "byteOffset") || // Skip index properties.
            isIndex(key, length)))) {
              result3.push(key);
            }
          }
          return result3;
        }
        function arraySample(array) {
          var length = array.length;
          return length ? array[baseRandom(0, length - 1)] : undefined2;
        }
        function arraySampleSize(array, n) {
          return shuffleSelf(copyArray(array), baseClamp(n, 0, array.length));
        }
        function arrayShuffle(array) {
          return shuffleSelf(copyArray(array));
        }
        function assignMergeValue(object, key, value) {
          if (value !== undefined2 && !eq(object[key], value) || value === undefined2 && !(key in object)) {
            baseAssignValue(object, key, value);
          }
        }
        function assignValue(object, key, value) {
          var objValue = object[key];
          if (!(hasOwnProperty.call(object, key) && eq(objValue, value)) || value === undefined2 && !(key in object)) {
            baseAssignValue(object, key, value);
          }
        }
        function assocIndexOf(array, key) {
          var length = array.length;
          while (length--) {
            if (eq(array[length][0], key)) {
              return length;
            }
          }
          return -1;
        }
        function baseAggregator(collection, setter, iteratee2, accumulator) {
          baseEach(collection, function(value, key, collection2) {
            setter(accumulator, value, iteratee2(value), collection2);
          });
          return accumulator;
        }
        function baseAssign(object, source) {
          return object && copyObject(source, keys(source), object);
        }
        function baseAssignIn(object, source) {
          return object && copyObject(source, keysIn(source), object);
        }
        function baseAssignValue(object, key, value) {
          if (key == "__proto__" && defineProperty) {
            defineProperty(object, key, {
              "configurable": true,
              "enumerable": true,
              "value": value,
              "writable": true
            });
          } else {
            object[key] = value;
          }
        }
        function baseAt(object, paths) {
          var index = -1, length = paths.length, result3 = Array2(length), skip = object == null;
          while (++index < length) {
            result3[index] = skip ? undefined2 : get(object, paths[index]);
          }
          return result3;
        }
        function baseClamp(number, lower, upper) {
          if (number === number) {
            if (upper !== undefined2) {
              number = number <= upper ? number : upper;
            }
            if (lower !== undefined2) {
              number = number >= lower ? number : lower;
            }
          }
          return number;
        }
        function baseClone(value, bitmask, customizer, key, object, stack) {
          var result3, isDeep = bitmask & CLONE_DEEP_FLAG, isFlat = bitmask & CLONE_FLAT_FLAG, isFull = bitmask & CLONE_SYMBOLS_FLAG;
          if (customizer) {
            result3 = object ? customizer(value, key, object, stack) : customizer(value);
          }
          if (result3 !== undefined2) {
            return result3;
          }
          if (!isObject(value)) {
            return value;
          }
          var isArr = isArray(value);
          if (isArr) {
            result3 = initCloneArray(value);
            if (!isDeep) {
              return copyArray(value, result3);
            }
          } else {
            var tag = getTag(value), isFunc = tag == funcTag || tag == genTag;
            if (isBuffer(value)) {
              return cloneBuffer(value, isDeep);
            }
            if (tag == objectTag || tag == argsTag || isFunc && !object) {
              result3 = isFlat || isFunc ? {} : initCloneObject(value);
              if (!isDeep) {
                return isFlat ? copySymbolsIn(value, baseAssignIn(result3, value)) : copySymbols(value, baseAssign(result3, value));
              }
            } else {
              if (!cloneableTags[tag]) {
                return object ? value : {};
              }
              result3 = initCloneByTag(value, tag, isDeep);
            }
          }
          stack || (stack = new Stack());
          var stacked = stack.get(value);
          if (stacked) {
            return stacked;
          }
          stack.set(value, result3);
          if (isSet(value)) {
            value.forEach(function(subValue) {
              result3.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));
            });
          } else if (isMap(value)) {
            value.forEach(function(subValue, key2) {
              result3.set(key2, baseClone(subValue, bitmask, customizer, key2, value, stack));
            });
          }
          var keysFunc = isFull ? isFlat ? getAllKeysIn : getAllKeys : isFlat ? keysIn : keys;
          var props = isArr ? undefined2 : keysFunc(value);
          arrayEach(props || value, function(subValue, key2) {
            if (props) {
              key2 = subValue;
              subValue = value[key2];
            }
            assignValue(result3, key2, baseClone(subValue, bitmask, customizer, key2, value, stack));
          });
          return result3;
        }
        function baseConforms(source) {
          var props = keys(source);
          return function(object) {
            return baseConformsTo(object, source, props);
          };
        }
        function baseConformsTo(object, source, props) {
          var length = props.length;
          if (object == null) {
            return !length;
          }
          object = Object2(object);
          while (length--) {
            var key = props[length], predicate = source[key], value = object[key];
            if (value === undefined2 && !(key in object) || !predicate(value)) {
              return false;
            }
          }
          return true;
        }
        function baseDelay(func, wait, args) {
          if (typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          return setTimeout2(function() {
            func.apply(undefined2, args);
          }, wait);
        }
        function baseDifference(array, values2, iteratee2, comparator) {
          var index = -1, includes2 = arrayIncludes, isCommon = true, length = array.length, result3 = [], valuesLength = values2.length;
          if (!length) {
            return result3;
          }
          if (iteratee2) {
            values2 = arrayMap(values2, baseUnary(iteratee2));
          }
          if (comparator) {
            includes2 = arrayIncludesWith;
            isCommon = false;
          } else if (values2.length >= LARGE_ARRAY_SIZE) {
            includes2 = cacheHas;
            isCommon = false;
            values2 = new SetCache(values2);
          }
          outer:
            while (++index < length) {
              var value = array[index], computed = iteratee2 == null ? value : iteratee2(value);
              value = comparator || value !== 0 ? value : 0;
              if (isCommon && computed === computed) {
                var valuesIndex = valuesLength;
                while (valuesIndex--) {
                  if (values2[valuesIndex] === computed) {
                    continue outer;
                  }
                }
                result3.push(value);
              } else if (!includes2(values2, computed, comparator)) {
                result3.push(value);
              }
            }
          return result3;
        }
        var baseEach = createBaseEach(baseForOwn);
        var baseEachRight = createBaseEach(baseForOwnRight, true);
        function baseEvery(collection, predicate) {
          var result3 = true;
          baseEach(collection, function(value, index, collection2) {
            result3 = !!predicate(value, index, collection2);
            return result3;
          });
          return result3;
        }
        function baseExtremum(array, iteratee2, comparator) {
          var index = -1, length = array.length;
          while (++index < length) {
            var value = array[index], current = iteratee2(value);
            if (current != null && (computed === undefined2 ? current === current && !isSymbol(current) : comparator(current, computed))) {
              var computed = current, result3 = value;
            }
          }
          return result3;
        }
        function baseFill(array, value, start, end) {
          var length = array.length;
          start = toInteger(start);
          if (start < 0) {
            start = -start > length ? 0 : length + start;
          }
          end = end === undefined2 || end > length ? length : toInteger(end);
          if (end < 0) {
            end += length;
          }
          end = start > end ? 0 : toLength(end);
          while (start < end) {
            array[start++] = value;
          }
          return array;
        }
        function baseFilter(collection, predicate) {
          var result3 = [];
          baseEach(collection, function(value, index, collection2) {
            if (predicate(value, index, collection2)) {
              result3.push(value);
            }
          });
          return result3;
        }
        function baseFlatten(array, depth, predicate, isStrict, result3) {
          var index = -1, length = array.length;
          predicate || (predicate = isFlattenable);
          result3 || (result3 = []);
          while (++index < length) {
            var value = array[index];
            if (depth > 0 && predicate(value)) {
              if (depth > 1) {
                baseFlatten(value, depth - 1, predicate, isStrict, result3);
              } else {
                arrayPush(result3, value);
              }
            } else if (!isStrict) {
              result3[result3.length] = value;
            }
          }
          return result3;
        }
        var baseFor = createBaseFor();
        var baseForRight = createBaseFor(true);
        function baseForOwn(object, iteratee2) {
          return object && baseFor(object, iteratee2, keys);
        }
        function baseForOwnRight(object, iteratee2) {
          return object && baseForRight(object, iteratee2, keys);
        }
        function baseFunctions(object, props) {
          return arrayFilter(props, function(key) {
            return isFunction(object[key]);
          });
        }
        function baseGet(object, path3) {
          path3 = castPath(path3, object);
          var index = 0, length = path3.length;
          while (object != null && index < length) {
            object = object[toKey(path3[index++])];
          }
          return index && index == length ? object : undefined2;
        }
        function baseGetAllKeys(object, keysFunc, symbolsFunc) {
          var result3 = keysFunc(object);
          return isArray(object) ? result3 : arrayPush(result3, symbolsFunc(object));
        }
        function baseGetTag(value) {
          if (value == null) {
            return value === undefined2 ? undefinedTag : nullTag;
          }
          return symToStringTag && symToStringTag in Object2(value) ? getRawTag(value) : objectToString(value);
        }
        function baseGt(value, other) {
          return value > other;
        }
        function baseHas(object, key) {
          return object != null && hasOwnProperty.call(object, key);
        }
        function baseHasIn(object, key) {
          return object != null && key in Object2(object);
        }
        function baseInRange(number, start, end) {
          return number >= nativeMin(start, end) && number < nativeMax(start, end);
        }
        function baseIntersection(arrays, iteratee2, comparator) {
          var includes2 = comparator ? arrayIncludesWith : arrayIncludes, length = arrays[0].length, othLength = arrays.length, othIndex = othLength, caches = Array2(othLength), maxLength = Infinity, result3 = [];
          while (othIndex--) {
            var array = arrays[othIndex];
            if (othIndex && iteratee2) {
              array = arrayMap(array, baseUnary(iteratee2));
            }
            maxLength = nativeMin(array.length, maxLength);
            caches[othIndex] = !comparator && (iteratee2 || length >= 120 && array.length >= 120) ? new SetCache(othIndex && array) : undefined2;
          }
          array = arrays[0];
          var index = -1, seen = caches[0];
          outer:
            while (++index < length && result3.length < maxLength) {
              var value = array[index], computed = iteratee2 ? iteratee2(value) : value;
              value = comparator || value !== 0 ? value : 0;
              if (!(seen ? cacheHas(seen, computed) : includes2(result3, computed, comparator))) {
                othIndex = othLength;
                while (--othIndex) {
                  var cache = caches[othIndex];
                  if (!(cache ? cacheHas(cache, computed) : includes2(arrays[othIndex], computed, comparator))) {
                    continue outer;
                  }
                }
                if (seen) {
                  seen.push(computed);
                }
                result3.push(value);
              }
            }
          return result3;
        }
        function baseInverter(object, setter, iteratee2, accumulator) {
          baseForOwn(object, function(value, key, object2) {
            setter(accumulator, iteratee2(value), key, object2);
          });
          return accumulator;
        }
        function baseInvoke(object, path3, args) {
          path3 = castPath(path3, object);
          object = parent(object, path3);
          var func = object == null ? object : object[toKey(last(path3))];
          return func == null ? undefined2 : apply(func, object, args);
        }
        function baseIsArguments(value) {
          return isObjectLike(value) && baseGetTag(value) == argsTag;
        }
        function baseIsArrayBuffer(value) {
          return isObjectLike(value) && baseGetTag(value) == arrayBufferTag;
        }
        function baseIsDate(value) {
          return isObjectLike(value) && baseGetTag(value) == dateTag;
        }
        function baseIsEqual(value, other, bitmask, customizer, stack) {
          if (value === other) {
            return true;
          }
          if (value == null || other == null || !isObjectLike(value) && !isObjectLike(other)) {
            return value !== value && other !== other;
          }
          return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
        }
        function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {
          var objIsArr = isArray(object), othIsArr = isArray(other), objTag = objIsArr ? arrayTag : getTag(object), othTag = othIsArr ? arrayTag : getTag(other);
          objTag = objTag == argsTag ? objectTag : objTag;
          othTag = othTag == argsTag ? objectTag : othTag;
          var objIsObj = objTag == objectTag, othIsObj = othTag == objectTag, isSameTag = objTag == othTag;
          if (isSameTag && isBuffer(object)) {
            if (!isBuffer(other)) {
              return false;
            }
            objIsArr = true;
            objIsObj = false;
          }
          if (isSameTag && !objIsObj) {
            stack || (stack = new Stack());
            return objIsArr || isTypedArray(object) ? equalArrays(object, other, bitmask, customizer, equalFunc, stack) : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
          }
          if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
            var objIsWrapped = objIsObj && hasOwnProperty.call(object, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty.call(other, "__wrapped__");
            if (objIsWrapped || othIsWrapped) {
              var objUnwrapped = objIsWrapped ? object.value() : object, othUnwrapped = othIsWrapped ? other.value() : other;
              stack || (stack = new Stack());
              return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
            }
          }
          if (!isSameTag) {
            return false;
          }
          stack || (stack = new Stack());
          return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
        }
        function baseIsMap(value) {
          return isObjectLike(value) && getTag(value) == mapTag;
        }
        function baseIsMatch(object, source, matchData, customizer) {
          var index = matchData.length, length = index, noCustomizer = !customizer;
          if (object == null) {
            return !length;
          }
          object = Object2(object);
          while (index--) {
            var data = matchData[index];
            if (noCustomizer && data[2] ? data[1] !== object[data[0]] : !(data[0] in object)) {
              return false;
            }
          }
          while (++index < length) {
            data = matchData[index];
            var key = data[0], objValue = object[key], srcValue = data[1];
            if (noCustomizer && data[2]) {
              if (objValue === undefined2 && !(key in object)) {
                return false;
              }
            } else {
              var stack = new Stack();
              if (customizer) {
                var result3 = customizer(objValue, srcValue, key, object, source, stack);
              }
              if (!(result3 === undefined2 ? baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG, customizer, stack) : result3)) {
                return false;
              }
            }
          }
          return true;
        }
        function baseIsNative(value) {
          if (!isObject(value) || isMasked(value)) {
            return false;
          }
          var pattern = isFunction(value) ? reIsNative : reIsHostCtor;
          return pattern.test(toSource(value));
        }
        function baseIsRegExp(value) {
          return isObjectLike(value) && baseGetTag(value) == regexpTag;
        }
        function baseIsSet(value) {
          return isObjectLike(value) && getTag(value) == setTag;
        }
        function baseIsTypedArray(value) {
          return isObjectLike(value) && isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
        }
        function baseIteratee(value) {
          if (typeof value == "function") {
            return value;
          }
          if (value == null) {
            return identity;
          }
          if (typeof value == "object") {
            return isArray(value) ? baseMatchesProperty(value[0], value[1]) : baseMatches(value);
          }
          return property(value);
        }
        function baseKeys(object) {
          if (!isPrototype(object)) {
            return nativeKeys(object);
          }
          var result3 = [];
          for (var key in Object2(object)) {
            if (hasOwnProperty.call(object, key) && key != "constructor") {
              result3.push(key);
            }
          }
          return result3;
        }
        function baseKeysIn(object) {
          if (!isObject(object)) {
            return nativeKeysIn(object);
          }
          var isProto = isPrototype(object), result3 = [];
          for (var key in object) {
            if (!(key == "constructor" && (isProto || !hasOwnProperty.call(object, key)))) {
              result3.push(key);
            }
          }
          return result3;
        }
        function baseLt(value, other) {
          return value < other;
        }
        function baseMap(collection, iteratee2) {
          var index = -1, result3 = isArrayLike(collection) ? Array2(collection.length) : [];
          baseEach(collection, function(value, key, collection2) {
            result3[++index] = iteratee2(value, key, collection2);
          });
          return result3;
        }
        function baseMatches(source) {
          var matchData = getMatchData(source);
          if (matchData.length == 1 && matchData[0][2]) {
            return matchesStrictComparable(matchData[0][0], matchData[0][1]);
          }
          return function(object) {
            return object === source || baseIsMatch(object, source, matchData);
          };
        }
        function baseMatchesProperty(path3, srcValue) {
          if (isKey(path3) && isStrictComparable(srcValue)) {
            return matchesStrictComparable(toKey(path3), srcValue);
          }
          return function(object) {
            var objValue = get(object, path3);
            return objValue === undefined2 && objValue === srcValue ? hasIn(object, path3) : baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
          };
        }
        function baseMerge(object, source, srcIndex, customizer, stack) {
          if (object === source) {
            return;
          }
          baseFor(source, function(srcValue, key) {
            stack || (stack = new Stack());
            if (isObject(srcValue)) {
              baseMergeDeep(object, source, key, srcIndex, baseMerge, customizer, stack);
            } else {
              var newValue = customizer ? customizer(safeGet(object, key), srcValue, key + "", object, source, stack) : undefined2;
              if (newValue === undefined2) {
                newValue = srcValue;
              }
              assignMergeValue(object, key, newValue);
            }
          }, keysIn);
        }
        function baseMergeDeep(object, source, key, srcIndex, mergeFunc, customizer, stack) {
          var objValue = safeGet(object, key), srcValue = safeGet(source, key), stacked = stack.get(srcValue);
          if (stacked) {
            assignMergeValue(object, key, stacked);
            return;
          }
          var newValue = customizer ? customizer(objValue, srcValue, key + "", object, source, stack) : undefined2;
          var isCommon = newValue === undefined2;
          if (isCommon) {
            var isArr = isArray(srcValue), isBuff = !isArr && isBuffer(srcValue), isTyped = !isArr && !isBuff && isTypedArray(srcValue);
            newValue = srcValue;
            if (isArr || isBuff || isTyped) {
              if (isArray(objValue)) {
                newValue = objValue;
              } else if (isArrayLikeObject(objValue)) {
                newValue = copyArray(objValue);
              } else if (isBuff) {
                isCommon = false;
                newValue = cloneBuffer(srcValue, true);
              } else if (isTyped) {
                isCommon = false;
                newValue = cloneTypedArray(srcValue, true);
              } else {
                newValue = [];
              }
            } else if (isPlainObject(srcValue) || isArguments(srcValue)) {
              newValue = objValue;
              if (isArguments(objValue)) {
                newValue = toPlainObject(objValue);
              } else if (!isObject(objValue) || isFunction(objValue)) {
                newValue = initCloneObject(srcValue);
              }
            } else {
              isCommon = false;
            }
          }
          if (isCommon) {
            stack.set(srcValue, newValue);
            mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
            stack["delete"](srcValue);
          }
          assignMergeValue(object, key, newValue);
        }
        function baseNth(array, n) {
          var length = array.length;
          if (!length) {
            return;
          }
          n += n < 0 ? length : 0;
          return isIndex(n, length) ? array[n] : undefined2;
        }
        function baseOrderBy(collection, iteratees, orders) {
          if (iteratees.length) {
            iteratees = arrayMap(iteratees, function(iteratee2) {
              if (isArray(iteratee2)) {
                return function(value) {
                  return baseGet(value, iteratee2.length === 1 ? iteratee2[0] : iteratee2);
                };
              }
              return iteratee2;
            });
          } else {
            iteratees = [identity];
          }
          var index = -1;
          iteratees = arrayMap(iteratees, baseUnary(getIteratee()));
          var result3 = baseMap(collection, function(value, key, collection2) {
            var criteria = arrayMap(iteratees, function(iteratee2) {
              return iteratee2(value);
            });
            return { "criteria": criteria, "index": ++index, "value": value };
          });
          return baseSortBy(result3, function(object, other) {
            return compareMultiple(object, other, orders);
          });
        }
        function basePick(object, paths) {
          return basePickBy(object, paths, function(value, path3) {
            return hasIn(object, path3);
          });
        }
        function basePickBy(object, paths, predicate) {
          var index = -1, length = paths.length, result3 = {};
          while (++index < length) {
            var path3 = paths[index], value = baseGet(object, path3);
            if (predicate(value, path3)) {
              baseSet(result3, castPath(path3, object), value);
            }
          }
          return result3;
        }
        function basePropertyDeep(path3) {
          return function(object) {
            return baseGet(object, path3);
          };
        }
        function basePullAll(array, values2, iteratee2, comparator) {
          var indexOf2 = comparator ? baseIndexOfWith : baseIndexOf, index = -1, length = values2.length, seen = array;
          if (array === values2) {
            values2 = copyArray(values2);
          }
          if (iteratee2) {
            seen = arrayMap(array, baseUnary(iteratee2));
          }
          while (++index < length) {
            var fromIndex = 0, value = values2[index], computed = iteratee2 ? iteratee2(value) : value;
            while ((fromIndex = indexOf2(seen, computed, fromIndex, comparator)) > -1) {
              if (seen !== array) {
                splice.call(seen, fromIndex, 1);
              }
              splice.call(array, fromIndex, 1);
            }
          }
          return array;
        }
        function basePullAt(array, indexes) {
          var length = array ? indexes.length : 0, lastIndex = length - 1;
          while (length--) {
            var index = indexes[length];
            if (length == lastIndex || index !== previous) {
              var previous = index;
              if (isIndex(index)) {
                splice.call(array, index, 1);
              } else {
                baseUnset(array, index);
              }
            }
          }
          return array;
        }
        function baseRandom(lower, upper) {
          return lower + nativeFloor(nativeRandom() * (upper - lower + 1));
        }
        function baseRange(start, end, step, fromRight) {
          var index = -1, length = nativeMax(nativeCeil((end - start) / (step || 1)), 0), result3 = Array2(length);
          while (length--) {
            result3[fromRight ? length : ++index] = start;
            start += step;
          }
          return result3;
        }
        function baseRepeat(string, n) {
          var result3 = "";
          if (!string || n < 1 || n > MAX_SAFE_INTEGER) {
            return result3;
          }
          do {
            if (n % 2) {
              result3 += string;
            }
            n = nativeFloor(n / 2);
            if (n) {
              string += string;
            }
          } while (n);
          return result3;
        }
        function baseRest(func, start) {
          return setToString(overRest(func, start, identity), func + "");
        }
        function baseSample(collection) {
          return arraySample(values(collection));
        }
        function baseSampleSize(collection, n) {
          var array = values(collection);
          return shuffleSelf(array, baseClamp(n, 0, array.length));
        }
        function baseSet(object, path3, value, customizer) {
          if (!isObject(object)) {
            return object;
          }
          path3 = castPath(path3, object);
          var index = -1, length = path3.length, lastIndex = length - 1, nested = object;
          while (nested != null && ++index < length) {
            var key = toKey(path3[index]), newValue = value;
            if (key === "__proto__" || key === "constructor" || key === "prototype") {
              return object;
            }
            if (index != lastIndex) {
              var objValue = nested[key];
              newValue = customizer ? customizer(objValue, key, nested) : undefined2;
              if (newValue === undefined2) {
                newValue = isObject(objValue) ? objValue : isIndex(path3[index + 1]) ? [] : {};
              }
            }
            assignValue(nested, key, newValue);
            nested = nested[key];
          }
          return object;
        }
        var baseSetData = !metaMap ? identity : function(func, data) {
          metaMap.set(func, data);
          return func;
        };
        var baseSetToString = !defineProperty ? identity : function(func, string) {
          return defineProperty(func, "toString", {
            "configurable": true,
            "enumerable": false,
            "value": constant(string),
            "writable": true
          });
        };
        function baseShuffle(collection) {
          return shuffleSelf(values(collection));
        }
        function baseSlice(array, start, end) {
          var index = -1, length = array.length;
          if (start < 0) {
            start = -start > length ? 0 : length + start;
          }
          end = end > length ? length : end;
          if (end < 0) {
            end += length;
          }
          length = start > end ? 0 : end - start >>> 0;
          start >>>= 0;
          var result3 = Array2(length);
          while (++index < length) {
            result3[index] = array[index + start];
          }
          return result3;
        }
        function baseSome(collection, predicate) {
          var result3;
          baseEach(collection, function(value, index, collection2) {
            result3 = predicate(value, index, collection2);
            return !result3;
          });
          return !!result3;
        }
        function baseSortedIndex(array, value, retHighest) {
          var low = 0, high = array == null ? low : array.length;
          if (typeof value == "number" && value === value && high <= HALF_MAX_ARRAY_LENGTH) {
            while (low < high) {
              var mid = low + high >>> 1, computed = array[mid];
              if (computed !== null && !isSymbol(computed) && (retHighest ? computed <= value : computed < value)) {
                low = mid + 1;
              } else {
                high = mid;
              }
            }
            return high;
          }
          return baseSortedIndexBy(array, value, identity, retHighest);
        }
        function baseSortedIndexBy(array, value, iteratee2, retHighest) {
          var low = 0, high = array == null ? 0 : array.length;
          if (high === 0) {
            return 0;
          }
          value = iteratee2(value);
          var valIsNaN = value !== value, valIsNull = value === null, valIsSymbol = isSymbol(value), valIsUndefined = value === undefined2;
          while (low < high) {
            var mid = nativeFloor((low + high) / 2), computed = iteratee2(array[mid]), othIsDefined = computed !== undefined2, othIsNull = computed === null, othIsReflexive = computed === computed, othIsSymbol = isSymbol(computed);
            if (valIsNaN) {
              var setLow = retHighest || othIsReflexive;
            } else if (valIsUndefined) {
              setLow = othIsReflexive && (retHighest || othIsDefined);
            } else if (valIsNull) {
              setLow = othIsReflexive && othIsDefined && (retHighest || !othIsNull);
            } else if (valIsSymbol) {
              setLow = othIsReflexive && othIsDefined && !othIsNull && (retHighest || !othIsSymbol);
            } else if (othIsNull || othIsSymbol) {
              setLow = false;
            } else {
              setLow = retHighest ? computed <= value : computed < value;
            }
            if (setLow) {
              low = mid + 1;
            } else {
              high = mid;
            }
          }
          return nativeMin(high, MAX_ARRAY_INDEX);
        }
        function baseSortedUniq(array, iteratee2) {
          var index = -1, length = array.length, resIndex = 0, result3 = [];
          while (++index < length) {
            var value = array[index], computed = iteratee2 ? iteratee2(value) : value;
            if (!index || !eq(computed, seen)) {
              var seen = computed;
              result3[resIndex++] = value === 0 ? 0 : value;
            }
          }
          return result3;
        }
        function baseToNumber(value) {
          if (typeof value == "number") {
            return value;
          }
          if (isSymbol(value)) {
            return NAN;
          }
          return +value;
        }
        function baseToString(value) {
          if (typeof value == "string") {
            return value;
          }
          if (isArray(value)) {
            return arrayMap(value, baseToString) + "";
          }
          if (isSymbol(value)) {
            return symbolToString ? symbolToString.call(value) : "";
          }
          var result3 = value + "";
          return result3 == "0" && 1 / value == -INFINITY ? "-0" : result3;
        }
        function baseUniq(array, iteratee2, comparator) {
          var index = -1, includes2 = arrayIncludes, length = array.length, isCommon = true, result3 = [], seen = result3;
          if (comparator) {
            isCommon = false;
            includes2 = arrayIncludesWith;
          } else if (length >= LARGE_ARRAY_SIZE) {
            var set2 = iteratee2 ? null : createSet(array);
            if (set2) {
              return setToArray(set2);
            }
            isCommon = false;
            includes2 = cacheHas;
            seen = new SetCache();
          } else {
            seen = iteratee2 ? [] : result3;
          }
          outer:
            while (++index < length) {
              var value = array[index], computed = iteratee2 ? iteratee2(value) : value;
              value = comparator || value !== 0 ? value : 0;
              if (isCommon && computed === computed) {
                var seenIndex = seen.length;
                while (seenIndex--) {
                  if (seen[seenIndex] === computed) {
                    continue outer;
                  }
                }
                if (iteratee2) {
                  seen.push(computed);
                }
                result3.push(value);
              } else if (!includes2(seen, computed, comparator)) {
                if (seen !== result3) {
                  seen.push(computed);
                }
                result3.push(value);
              }
            }
          return result3;
        }
        function baseUnset(object, path3) {
          path3 = castPath(path3, object);
          object = parent(object, path3);
          return object == null || delete object[toKey(last(path3))];
        }
        function baseUpdate(object, path3, updater, customizer) {
          return baseSet(object, path3, updater(baseGet(object, path3)), customizer);
        }
        function baseWhile(array, predicate, isDrop, fromRight) {
          var length = array.length, index = fromRight ? length : -1;
          while ((fromRight ? index-- : ++index < length) && predicate(array[index], index, array)) {
          }
          return isDrop ? baseSlice(array, fromRight ? 0 : index, fromRight ? index + 1 : length) : baseSlice(array, fromRight ? index + 1 : 0, fromRight ? length : index);
        }
        function baseWrapperValue(value, actions) {
          var result3 = value;
          if (result3 instanceof LazyWrapper) {
            result3 = result3.value();
          }
          return arrayReduce(actions, function(result4, action) {
            return action.func.apply(action.thisArg, arrayPush([result4], action.args));
          }, result3);
        }
        function baseXor(arrays, iteratee2, comparator) {
          var length = arrays.length;
          if (length < 2) {
            return length ? baseUniq(arrays[0]) : [];
          }
          var index = -1, result3 = Array2(length);
          while (++index < length) {
            var array = arrays[index], othIndex = -1;
            while (++othIndex < length) {
              if (othIndex != index) {
                result3[index] = baseDifference(result3[index] || array, arrays[othIndex], iteratee2, comparator);
              }
            }
          }
          return baseUniq(baseFlatten(result3, 1), iteratee2, comparator);
        }
        function baseZipObject(props, values2, assignFunc) {
          var index = -1, length = props.length, valsLength = values2.length, result3 = {};
          while (++index < length) {
            var value = index < valsLength ? values2[index] : undefined2;
            assignFunc(result3, props[index], value);
          }
          return result3;
        }
        function castArrayLikeObject(value) {
          return isArrayLikeObject(value) ? value : [];
        }
        function castFunction(value) {
          return typeof value == "function" ? value : identity;
        }
        function castPath(value, object) {
          if (isArray(value)) {
            return value;
          }
          return isKey(value, object) ? [value] : stringToPath(toString(value));
        }
        var castRest = baseRest;
        function castSlice(array, start, end) {
          var length = array.length;
          end = end === undefined2 ? length : end;
          return !start && end >= length ? array : baseSlice(array, start, end);
        }
        var clearTimeout2 = ctxClearTimeout || function(id) {
          return root.clearTimeout(id);
        };
        function cloneBuffer(buffer, isDeep) {
          if (isDeep) {
            return buffer.slice();
          }
          var length = buffer.length, result3 = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);
          buffer.copy(result3);
          return result3;
        }
        function cloneArrayBuffer(arrayBuffer) {
          var result3 = new arrayBuffer.constructor(arrayBuffer.byteLength);
          new Uint8Array2(result3).set(new Uint8Array2(arrayBuffer));
          return result3;
        }
        function cloneDataView(dataView, isDeep) {
          var buffer = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
          return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
        }
        function cloneRegExp(regexp) {
          var result3 = new regexp.constructor(regexp.source, reFlags.exec(regexp));
          result3.lastIndex = regexp.lastIndex;
          return result3;
        }
        function cloneSymbol(symbol) {
          return symbolValueOf ? Object2(symbolValueOf.call(symbol)) : {};
        }
        function cloneTypedArray(typedArray, isDeep) {
          var buffer = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
          return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
        }
        function compareAscending(value, other) {
          if (value !== other) {
            var valIsDefined = value !== undefined2, valIsNull = value === null, valIsReflexive = value === value, valIsSymbol = isSymbol(value);
            var othIsDefined = other !== undefined2, othIsNull = other === null, othIsReflexive = other === other, othIsSymbol = isSymbol(other);
            if (!othIsNull && !othIsSymbol && !valIsSymbol && value > other || valIsSymbol && othIsDefined && othIsReflexive && !othIsNull && !othIsSymbol || valIsNull && othIsDefined && othIsReflexive || !valIsDefined && othIsReflexive || !valIsReflexive) {
              return 1;
            }
            if (!valIsNull && !valIsSymbol && !othIsSymbol && value < other || othIsSymbol && valIsDefined && valIsReflexive && !valIsNull && !valIsSymbol || othIsNull && valIsDefined && valIsReflexive || !othIsDefined && valIsReflexive || !othIsReflexive) {
              return -1;
            }
          }
          return 0;
        }
        function compareMultiple(object, other, orders) {
          var index = -1, objCriteria = object.criteria, othCriteria = other.criteria, length = objCriteria.length, ordersLength = orders.length;
          while (++index < length) {
            var result3 = compareAscending(objCriteria[index], othCriteria[index]);
            if (result3) {
              if (index >= ordersLength) {
                return result3;
              }
              var order = orders[index];
              return result3 * (order == "desc" ? -1 : 1);
            }
          }
          return object.index - other.index;
        }
        function composeArgs(args, partials, holders, isCurried) {
          var argsIndex = -1, argsLength = args.length, holdersLength = holders.length, leftIndex = -1, leftLength = partials.length, rangeLength = nativeMax(argsLength - holdersLength, 0), result3 = Array2(leftLength + rangeLength), isUncurried = !isCurried;
          while (++leftIndex < leftLength) {
            result3[leftIndex] = partials[leftIndex];
          }
          while (++argsIndex < holdersLength) {
            if (isUncurried || argsIndex < argsLength) {
              result3[holders[argsIndex]] = args[argsIndex];
            }
          }
          while (rangeLength--) {
            result3[leftIndex++] = args[argsIndex++];
          }
          return result3;
        }
        function composeArgsRight(args, partials, holders, isCurried) {
          var argsIndex = -1, argsLength = args.length, holdersIndex = -1, holdersLength = holders.length, rightIndex = -1, rightLength = partials.length, rangeLength = nativeMax(argsLength - holdersLength, 0), result3 = Array2(rangeLength + rightLength), isUncurried = !isCurried;
          while (++argsIndex < rangeLength) {
            result3[argsIndex] = args[argsIndex];
          }
          var offset = argsIndex;
          while (++rightIndex < rightLength) {
            result3[offset + rightIndex] = partials[rightIndex];
          }
          while (++holdersIndex < holdersLength) {
            if (isUncurried || argsIndex < argsLength) {
              result3[offset + holders[holdersIndex]] = args[argsIndex++];
            }
          }
          return result3;
        }
        function copyArray(source, array) {
          var index = -1, length = source.length;
          array || (array = Array2(length));
          while (++index < length) {
            array[index] = source[index];
          }
          return array;
        }
        function copyObject(source, props, object, customizer) {
          var isNew = !object;
          object || (object = {});
          var index = -1, length = props.length;
          while (++index < length) {
            var key = props[index];
            var newValue = customizer ? customizer(object[key], source[key], key, object, source) : undefined2;
            if (newValue === undefined2) {
              newValue = source[key];
            }
            if (isNew) {
              baseAssignValue(object, key, newValue);
            } else {
              assignValue(object, key, newValue);
            }
          }
          return object;
        }
        function copySymbols(source, object) {
          return copyObject(source, getSymbols(source), object);
        }
        function copySymbolsIn(source, object) {
          return copyObject(source, getSymbolsIn(source), object);
        }
        function createAggregator(setter, initializer) {
          return function(collection, iteratee2) {
            var func = isArray(collection) ? arrayAggregator : baseAggregator, accumulator = initializer ? initializer() : {};
            return func(collection, setter, getIteratee(iteratee2, 2), accumulator);
          };
        }
        function createAssigner(assigner) {
          return baseRest(function(object, sources) {
            var index = -1, length = sources.length, customizer = length > 1 ? sources[length - 1] : undefined2, guard = length > 2 ? sources[2] : undefined2;
            customizer = assigner.length > 3 && typeof customizer == "function" ? (length--, customizer) : undefined2;
            if (guard && isIterateeCall(sources[0], sources[1], guard)) {
              customizer = length < 3 ? undefined2 : customizer;
              length = 1;
            }
            object = Object2(object);
            while (++index < length) {
              var source = sources[index];
              if (source) {
                assigner(object, source, index, customizer);
              }
            }
            return object;
          });
        }
        function createBaseEach(eachFunc, fromRight) {
          return function(collection, iteratee2) {
            if (collection == null) {
              return collection;
            }
            if (!isArrayLike(collection)) {
              return eachFunc(collection, iteratee2);
            }
            var length = collection.length, index = fromRight ? length : -1, iterable = Object2(collection);
            while (fromRight ? index-- : ++index < length) {
              if (iteratee2(iterable[index], index, iterable) === false) {
                break;
              }
            }
            return collection;
          };
        }
        function createBaseFor(fromRight) {
          return function(object, iteratee2, keysFunc) {
            var index = -1, iterable = Object2(object), props = keysFunc(object), length = props.length;
            while (length--) {
              var key = props[fromRight ? length : ++index];
              if (iteratee2(iterable[key], key, iterable) === false) {
                break;
              }
            }
            return object;
          };
        }
        function createBind(func, bitmask, thisArg) {
          var isBind = bitmask & WRAP_BIND_FLAG, Ctor = createCtor(func);
          function wrapper() {
            var fn = this && this !== root && this instanceof wrapper ? Ctor : func;
            return fn.apply(isBind ? thisArg : this, arguments);
          }
          return wrapper;
        }
        function createCaseFirst(methodName) {
          return function(string) {
            string = toString(string);
            var strSymbols = hasUnicode(string) ? stringToArray(string) : undefined2;
            var chr = strSymbols ? strSymbols[0] : string.charAt(0);
            var trailing = strSymbols ? castSlice(strSymbols, 1).join("") : string.slice(1);
            return chr[methodName]() + trailing;
          };
        }
        function createCompounder(callback) {
          return function(string) {
            return arrayReduce(words(deburr(string).replace(reApos, "")), callback, "");
          };
        }
        function createCtor(Ctor) {
          return function() {
            var args = arguments;
            switch (args.length) {
              case 0:
                return new Ctor();
              case 1:
                return new Ctor(args[0]);
              case 2:
                return new Ctor(args[0], args[1]);
              case 3:
                return new Ctor(args[0], args[1], args[2]);
              case 4:
                return new Ctor(args[0], args[1], args[2], args[3]);
              case 5:
                return new Ctor(args[0], args[1], args[2], args[3], args[4]);
              case 6:
                return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5]);
              case 7:
                return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5], args[6]);
            }
            var thisBinding = baseCreate(Ctor.prototype), result3 = Ctor.apply(thisBinding, args);
            return isObject(result3) ? result3 : thisBinding;
          };
        }
        function createCurry(func, bitmask, arity) {
          var Ctor = createCtor(func);
          function wrapper() {
            var length = arguments.length, args = Array2(length), index = length, placeholder = getHolder(wrapper);
            while (index--) {
              args[index] = arguments[index];
            }
            var holders = length < 3 && args[0] !== placeholder && args[length - 1] !== placeholder ? [] : replaceHolders(args, placeholder);
            length -= holders.length;
            if (length < arity) {
              return createRecurry(
                func,
                bitmask,
                createHybrid,
                wrapper.placeholder,
                undefined2,
                args,
                holders,
                undefined2,
                undefined2,
                arity - length
              );
            }
            var fn = this && this !== root && this instanceof wrapper ? Ctor : func;
            return apply(fn, this, args);
          }
          return wrapper;
        }
        function createFind(findIndexFunc) {
          return function(collection, predicate, fromIndex) {
            var iterable = Object2(collection);
            if (!isArrayLike(collection)) {
              var iteratee2 = getIteratee(predicate, 3);
              collection = keys(collection);
              predicate = function(key) {
                return iteratee2(iterable[key], key, iterable);
              };
            }
            var index = findIndexFunc(collection, predicate, fromIndex);
            return index > -1 ? iterable[iteratee2 ? collection[index] : index] : undefined2;
          };
        }
        function createFlow(fromRight) {
          return flatRest(function(funcs) {
            var length = funcs.length, index = length, prereq = LodashWrapper.prototype.thru;
            if (fromRight) {
              funcs.reverse();
            }
            while (index--) {
              var func = funcs[index];
              if (typeof func != "function") {
                throw new TypeError2(FUNC_ERROR_TEXT);
              }
              if (prereq && !wrapper && getFuncName(func) == "wrapper") {
                var wrapper = new LodashWrapper([], true);
              }
            }
            index = wrapper ? index : length;
            while (++index < length) {
              func = funcs[index];
              var funcName = getFuncName(func), data = funcName == "wrapper" ? getData(func) : undefined2;
              if (data && isLaziable(data[0]) && data[1] == (WRAP_ARY_FLAG | WRAP_CURRY_FLAG | WRAP_PARTIAL_FLAG | WRAP_REARG_FLAG) && !data[4].length && data[9] == 1) {
                wrapper = wrapper[getFuncName(data[0])].apply(wrapper, data[3]);
              } else {
                wrapper = func.length == 1 && isLaziable(func) ? wrapper[funcName]() : wrapper.thru(func);
              }
            }
            return function() {
              var args = arguments, value = args[0];
              if (wrapper && args.length == 1 && isArray(value)) {
                return wrapper.plant(value).value();
              }
              var index2 = 0, result3 = length ? funcs[index2].apply(this, args) : value;
              while (++index2 < length) {
                result3 = funcs[index2].call(this, result3);
              }
              return result3;
            };
          });
        }
        function createHybrid(func, bitmask, thisArg, partials, holders, partialsRight, holdersRight, argPos, ary2, arity) {
          var isAry = bitmask & WRAP_ARY_FLAG, isBind = bitmask & WRAP_BIND_FLAG, isBindKey = bitmask & WRAP_BIND_KEY_FLAG, isCurried = bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG), isFlip = bitmask & WRAP_FLIP_FLAG, Ctor = isBindKey ? undefined2 : createCtor(func);
          function wrapper() {
            var length = arguments.length, args = Array2(length), index = length;
            while (index--) {
              args[index] = arguments[index];
            }
            if (isCurried) {
              var placeholder = getHolder(wrapper), holdersCount = countHolders(args, placeholder);
            }
            if (partials) {
              args = composeArgs(args, partials, holders, isCurried);
            }
            if (partialsRight) {
              args = composeArgsRight(args, partialsRight, holdersRight, isCurried);
            }
            length -= holdersCount;
            if (isCurried && length < arity) {
              var newHolders = replaceHolders(args, placeholder);
              return createRecurry(
                func,
                bitmask,
                createHybrid,
                wrapper.placeholder,
                thisArg,
                args,
                newHolders,
                argPos,
                ary2,
                arity - length
              );
            }
            var thisBinding = isBind ? thisArg : this, fn = isBindKey ? thisBinding[func] : func;
            length = args.length;
            if (argPos) {
              args = reorder(args, argPos);
            } else if (isFlip && length > 1) {
              args.reverse();
            }
            if (isAry && ary2 < length) {
              args.length = ary2;
            }
            if (this && this !== root && this instanceof wrapper) {
              fn = Ctor || createCtor(fn);
            }
            return fn.apply(thisBinding, args);
          }
          return wrapper;
        }
        function createInverter(setter, toIteratee) {
          return function(object, iteratee2) {
            return baseInverter(object, setter, toIteratee(iteratee2), {});
          };
        }
        function createMathOperation(operator, defaultValue) {
          return function(value, other) {
            var result3;
            if (value === undefined2 && other === undefined2) {
              return defaultValue;
            }
            if (value !== undefined2) {
              result3 = value;
            }
            if (other !== undefined2) {
              if (result3 === undefined2) {
                return other;
              }
              if (typeof value == "string" || typeof other == "string") {
                value = baseToString(value);
                other = baseToString(other);
              } else {
                value = baseToNumber(value);
                other = baseToNumber(other);
              }
              result3 = operator(value, other);
            }
            return result3;
          };
        }
        function createOver(arrayFunc) {
          return flatRest(function(iteratees) {
            iteratees = arrayMap(iteratees, baseUnary(getIteratee()));
            return baseRest(function(args) {
              var thisArg = this;
              return arrayFunc(iteratees, function(iteratee2) {
                return apply(iteratee2, thisArg, args);
              });
            });
          });
        }
        function createPadding(length, chars) {
          chars = chars === undefined2 ? " " : baseToString(chars);
          var charsLength = chars.length;
          if (charsLength < 2) {
            return charsLength ? baseRepeat(chars, length) : chars;
          }
          var result3 = baseRepeat(chars, nativeCeil(length / stringSize(chars)));
          return hasUnicode(chars) ? castSlice(stringToArray(result3), 0, length).join("") : result3.slice(0, length);
        }
        function createPartial(func, bitmask, thisArg, partials) {
          var isBind = bitmask & WRAP_BIND_FLAG, Ctor = createCtor(func);
          function wrapper() {
            var argsIndex = -1, argsLength = arguments.length, leftIndex = -1, leftLength = partials.length, args = Array2(leftLength + argsLength), fn = this && this !== root && this instanceof wrapper ? Ctor : func;
            while (++leftIndex < leftLength) {
              args[leftIndex] = partials[leftIndex];
            }
            while (argsLength--) {
              args[leftIndex++] = arguments[++argsIndex];
            }
            return apply(fn, isBind ? thisArg : this, args);
          }
          return wrapper;
        }
        function createRange(fromRight) {
          return function(start, end, step) {
            if (step && typeof step != "number" && isIterateeCall(start, end, step)) {
              end = step = undefined2;
            }
            start = toFinite(start);
            if (end === undefined2) {
              end = start;
              start = 0;
            } else {
              end = toFinite(end);
            }
            step = step === undefined2 ? start < end ? 1 : -1 : toFinite(step);
            return baseRange(start, end, step, fromRight);
          };
        }
        function createRelationalOperation(operator) {
          return function(value, other) {
            if (!(typeof value == "string" && typeof other == "string")) {
              value = toNumber(value);
              other = toNumber(other);
            }
            return operator(value, other);
          };
        }
        function createRecurry(func, bitmask, wrapFunc, placeholder, thisArg, partials, holders, argPos, ary2, arity) {
          var isCurry = bitmask & WRAP_CURRY_FLAG, newHolders = isCurry ? holders : undefined2, newHoldersRight = isCurry ? undefined2 : holders, newPartials = isCurry ? partials : undefined2, newPartialsRight = isCurry ? undefined2 : partials;
          bitmask |= isCurry ? WRAP_PARTIAL_FLAG : WRAP_PARTIAL_RIGHT_FLAG;
          bitmask &= ~(isCurry ? WRAP_PARTIAL_RIGHT_FLAG : WRAP_PARTIAL_FLAG);
          if (!(bitmask & WRAP_CURRY_BOUND_FLAG)) {
            bitmask &= ~(WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG);
          }
          var newData = [
            func,
            bitmask,
            thisArg,
            newPartials,
            newHolders,
            newPartialsRight,
            newHoldersRight,
            argPos,
            ary2,
            arity
          ];
          var result3 = wrapFunc.apply(undefined2, newData);
          if (isLaziable(func)) {
            setData(result3, newData);
          }
          result3.placeholder = placeholder;
          return setWrapToString(result3, func, bitmask);
        }
        function createRound(methodName) {
          var func = Math2[methodName];
          return function(number, precision) {
            number = toNumber(number);
            precision = precision == null ? 0 : nativeMin(toInteger(precision), 292);
            if (precision && nativeIsFinite(number)) {
              var pair = (toString(number) + "e").split("e"), value = func(pair[0] + "e" + (+pair[1] + precision));
              pair = (toString(value) + "e").split("e");
              return +(pair[0] + "e" + (+pair[1] - precision));
            }
            return func(number);
          };
        }
        var createSet = !(Set2 && 1 / setToArray(new Set2([, -0]))[1] == INFINITY) ? noop : function(values2) {
          return new Set2(values2);
        };
        function createToPairs(keysFunc) {
          return function(object) {
            var tag = getTag(object);
            if (tag == mapTag) {
              return mapToArray(object);
            }
            if (tag == setTag) {
              return setToPairs(object);
            }
            return baseToPairs(object, keysFunc(object));
          };
        }
        function createWrap(func, bitmask, thisArg, partials, holders, argPos, ary2, arity) {
          var isBindKey = bitmask & WRAP_BIND_KEY_FLAG;
          if (!isBindKey && typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          var length = partials ? partials.length : 0;
          if (!length) {
            bitmask &= ~(WRAP_PARTIAL_FLAG | WRAP_PARTIAL_RIGHT_FLAG);
            partials = holders = undefined2;
          }
          ary2 = ary2 === undefined2 ? ary2 : nativeMax(toInteger(ary2), 0);
          arity = arity === undefined2 ? arity : toInteger(arity);
          length -= holders ? holders.length : 0;
          if (bitmask & WRAP_PARTIAL_RIGHT_FLAG) {
            var partialsRight = partials, holdersRight = holders;
            partials = holders = undefined2;
          }
          var data = isBindKey ? undefined2 : getData(func);
          var newData = [
            func,
            bitmask,
            thisArg,
            partials,
            holders,
            partialsRight,
            holdersRight,
            argPos,
            ary2,
            arity
          ];
          if (data) {
            mergeData(newData, data);
          }
          func = newData[0];
          bitmask = newData[1];
          thisArg = newData[2];
          partials = newData[3];
          holders = newData[4];
          arity = newData[9] = newData[9] === undefined2 ? isBindKey ? 0 : func.length : nativeMax(newData[9] - length, 0);
          if (!arity && bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG)) {
            bitmask &= ~(WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG);
          }
          if (!bitmask || bitmask == WRAP_BIND_FLAG) {
            var result3 = createBind(func, bitmask, thisArg);
          } else if (bitmask == WRAP_CURRY_FLAG || bitmask == WRAP_CURRY_RIGHT_FLAG) {
            result3 = createCurry(func, bitmask, arity);
          } else if ((bitmask == WRAP_PARTIAL_FLAG || bitmask == (WRAP_BIND_FLAG | WRAP_PARTIAL_FLAG)) && !holders.length) {
            result3 = createPartial(func, bitmask, thisArg, partials);
          } else {
            result3 = createHybrid.apply(undefined2, newData);
          }
          var setter = data ? baseSetData : setData;
          return setWrapToString(setter(result3, newData), func, bitmask);
        }
        function customDefaultsAssignIn(objValue, srcValue, key, object) {
          if (objValue === undefined2 || eq(objValue, objectProto[key]) && !hasOwnProperty.call(object, key)) {
            return srcValue;
          }
          return objValue;
        }
        function customDefaultsMerge(objValue, srcValue, key, object, source, stack) {
          if (isObject(objValue) && isObject(srcValue)) {
            stack.set(srcValue, objValue);
            baseMerge(objValue, srcValue, undefined2, customDefaultsMerge, stack);
            stack["delete"](srcValue);
          }
          return objValue;
        }
        function customOmitClone(value) {
          return isPlainObject(value) ? undefined2 : value;
        }
        function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
          var isPartial = bitmask & COMPARE_PARTIAL_FLAG, arrLength = array.length, othLength = other.length;
          if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
            return false;
          }
          var arrStacked = stack.get(array);
          var othStacked = stack.get(other);
          if (arrStacked && othStacked) {
            return arrStacked == other && othStacked == array;
          }
          var index = -1, result3 = true, seen = bitmask & COMPARE_UNORDERED_FLAG ? new SetCache() : undefined2;
          stack.set(array, other);
          stack.set(other, array);
          while (++index < arrLength) {
            var arrValue = array[index], othValue = other[index];
            if (customizer) {
              var compared = isPartial ? customizer(othValue, arrValue, index, other, array, stack) : customizer(arrValue, othValue, index, array, other, stack);
            }
            if (compared !== undefined2) {
              if (compared) {
                continue;
              }
              result3 = false;
              break;
            }
            if (seen) {
              if (!arraySome(other, function(othValue2, othIndex) {
                if (!cacheHas(seen, othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, bitmask, customizer, stack))) {
                  return seen.push(othIndex);
                }
              })) {
                result3 = false;
                break;
              }
            } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
              result3 = false;
              break;
            }
          }
          stack["delete"](array);
          stack["delete"](other);
          return result3;
        }
        function equalByTag(object, other, tag, bitmask, customizer, equalFunc, stack) {
          switch (tag) {
            case dataViewTag:
              if (object.byteLength != other.byteLength || object.byteOffset != other.byteOffset) {
                return false;
              }
              object = object.buffer;
              other = other.buffer;
            case arrayBufferTag:
              if (object.byteLength != other.byteLength || !equalFunc(new Uint8Array2(object), new Uint8Array2(other))) {
                return false;
              }
              return true;
            case boolTag:
            case dateTag:
            case numberTag:
              return eq(+object, +other);
            case errorTag:
              return object.name == other.name && object.message == other.message;
            case regexpTag:
            case stringTag:
              return object == other + "";
            case mapTag:
              var convert = mapToArray;
            case setTag:
              var isPartial = bitmask & COMPARE_PARTIAL_FLAG;
              convert || (convert = setToArray);
              if (object.size != other.size && !isPartial) {
                return false;
              }
              var stacked = stack.get(object);
              if (stacked) {
                return stacked == other;
              }
              bitmask |= COMPARE_UNORDERED_FLAG;
              stack.set(object, other);
              var result3 = equalArrays(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
              stack["delete"](object);
              return result3;
            case symbolTag:
              if (symbolValueOf) {
                return symbolValueOf.call(object) == symbolValueOf.call(other);
              }
          }
          return false;
        }
        function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {
          var isPartial = bitmask & COMPARE_PARTIAL_FLAG, objProps = getAllKeys(object), objLength = objProps.length, othProps = getAllKeys(other), othLength = othProps.length;
          if (objLength != othLength && !isPartial) {
            return false;
          }
          var index = objLength;
          while (index--) {
            var key = objProps[index];
            if (!(isPartial ? key in other : hasOwnProperty.call(other, key))) {
              return false;
            }
          }
          var objStacked = stack.get(object);
          var othStacked = stack.get(other);
          if (objStacked && othStacked) {
            return objStacked == other && othStacked == object;
          }
          var result3 = true;
          stack.set(object, other);
          stack.set(other, object);
          var skipCtor = isPartial;
          while (++index < objLength) {
            key = objProps[index];
            var objValue = object[key], othValue = other[key];
            if (customizer) {
              var compared = isPartial ? customizer(othValue, objValue, key, other, object, stack) : customizer(objValue, othValue, key, object, other, stack);
            }
            if (!(compared === undefined2 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
              result3 = false;
              break;
            }
            skipCtor || (skipCtor = key == "constructor");
          }
          if (result3 && !skipCtor) {
            var objCtor = object.constructor, othCtor = other.constructor;
            if (objCtor != othCtor && ("constructor" in object && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
              result3 = false;
            }
          }
          stack["delete"](object);
          stack["delete"](other);
          return result3;
        }
        function flatRest(func) {
          return setToString(overRest(func, undefined2, flatten), func + "");
        }
        function getAllKeys(object) {
          return baseGetAllKeys(object, keys, getSymbols);
        }
        function getAllKeysIn(object) {
          return baseGetAllKeys(object, keysIn, getSymbolsIn);
        }
        var getData = !metaMap ? noop : function(func) {
          return metaMap.get(func);
        };
        function getFuncName(func) {
          var result3 = func.name + "", array = realNames[result3], length = hasOwnProperty.call(realNames, result3) ? array.length : 0;
          while (length--) {
            var data = array[length], otherFunc = data.func;
            if (otherFunc == null || otherFunc == func) {
              return data.name;
            }
          }
          return result3;
        }
        function getHolder(func) {
          var object = hasOwnProperty.call(lodash, "placeholder") ? lodash : func;
          return object.placeholder;
        }
        function getIteratee() {
          var result3 = lodash.iteratee || iteratee;
          result3 = result3 === iteratee ? baseIteratee : result3;
          return arguments.length ? result3(arguments[0], arguments[1]) : result3;
        }
        function getMapData(map2, key) {
          var data = map2.__data__;
          return isKeyable(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
        }
        function getMatchData(object) {
          var result3 = keys(object), length = result3.length;
          while (length--) {
            var key = result3[length], value = object[key];
            result3[length] = [key, value, isStrictComparable(value)];
          }
          return result3;
        }
        function getNative(object, key) {
          var value = getValue(object, key);
          return baseIsNative(value) ? value : undefined2;
        }
        function getRawTag(value) {
          var isOwn = hasOwnProperty.call(value, symToStringTag), tag = value[symToStringTag];
          try {
            value[symToStringTag] = undefined2;
            var unmasked = true;
          } catch (e) {
          }
          var result3 = nativeObjectToString.call(value);
          if (unmasked) {
            if (isOwn) {
              value[symToStringTag] = tag;
            } else {
              delete value[symToStringTag];
            }
          }
          return result3;
        }
        var getSymbols = !nativeGetSymbols ? stubArray : function(object) {
          if (object == null) {
            return [];
          }
          object = Object2(object);
          return arrayFilter(nativeGetSymbols(object), function(symbol) {
            return propertyIsEnumerable.call(object, symbol);
          });
        };
        var getSymbolsIn = !nativeGetSymbols ? stubArray : function(object) {
          var result3 = [];
          while (object) {
            arrayPush(result3, getSymbols(object));
            object = getPrototype(object);
          }
          return result3;
        };
        var getTag = baseGetTag;
        if (DataView2 && getTag(new DataView2(new ArrayBuffer(1))) != dataViewTag || Map2 && getTag(new Map2()) != mapTag || Promise2 && getTag(Promise2.resolve()) != promiseTag || Set2 && getTag(new Set2()) != setTag || WeakMap2 && getTag(new WeakMap2()) != weakMapTag) {
          getTag = function(value) {
            var result3 = baseGetTag(value), Ctor = result3 == objectTag ? value.constructor : undefined2, ctorString = Ctor ? toSource(Ctor) : "";
            if (ctorString) {
              switch (ctorString) {
                case dataViewCtorString:
                  return dataViewTag;
                case mapCtorString:
                  return mapTag;
                case promiseCtorString:
                  return promiseTag;
                case setCtorString:
                  return setTag;
                case weakMapCtorString:
                  return weakMapTag;
              }
            }
            return result3;
          };
        }
        function getView(start, end, transforms) {
          var index = -1, length = transforms.length;
          while (++index < length) {
            var data = transforms[index], size2 = data.size;
            switch (data.type) {
              case "drop":
                start += size2;
                break;
              case "dropRight":
                end -= size2;
                break;
              case "take":
                end = nativeMin(end, start + size2);
                break;
              case "takeRight":
                start = nativeMax(start, end - size2);
                break;
            }
          }
          return { "start": start, "end": end };
        }
        function getWrapDetails(source) {
          var match = source.match(reWrapDetails);
          return match ? match[1].split(reSplitDetails) : [];
        }
        function hasPath(object, path3, hasFunc) {
          path3 = castPath(path3, object);
          var index = -1, length = path3.length, result3 = false;
          while (++index < length) {
            var key = toKey(path3[index]);
            if (!(result3 = object != null && hasFunc(object, key))) {
              break;
            }
            object = object[key];
          }
          if (result3 || ++index != length) {
            return result3;
          }
          length = object == null ? 0 : object.length;
          return !!length && isLength(length) && isIndex(key, length) && (isArray(object) || isArguments(object));
        }
        function initCloneArray(array) {
          var length = array.length, result3 = new array.constructor(length);
          if (length && typeof array[0] == "string" && hasOwnProperty.call(array, "index")) {
            result3.index = array.index;
            result3.input = array.input;
          }
          return result3;
        }
        function initCloneObject(object) {
          return typeof object.constructor == "function" && !isPrototype(object) ? baseCreate(getPrototype(object)) : {};
        }
        function initCloneByTag(object, tag, isDeep) {
          var Ctor = object.constructor;
          switch (tag) {
            case arrayBufferTag:
              return cloneArrayBuffer(object);
            case boolTag:
            case dateTag:
              return new Ctor(+object);
            case dataViewTag:
              return cloneDataView(object, isDeep);
            case float32Tag:
            case float64Tag:
            case int8Tag:
            case int16Tag:
            case int32Tag:
            case uint8Tag:
            case uint8ClampedTag:
            case uint16Tag:
            case uint32Tag:
              return cloneTypedArray(object, isDeep);
            case mapTag:
              return new Ctor();
            case numberTag:
            case stringTag:
              return new Ctor(object);
            case regexpTag:
              return cloneRegExp(object);
            case setTag:
              return new Ctor();
            case symbolTag:
              return cloneSymbol(object);
          }
        }
        function insertWrapDetails(source, details) {
          var length = details.length;
          if (!length) {
            return source;
          }
          var lastIndex = length - 1;
          details[lastIndex] = (length > 1 ? "& " : "") + details[lastIndex];
          details = details.join(length > 2 ? ", " : " ");
          return source.replace(reWrapComment, "{\n/* [wrapped with " + details + "] */\n");
        }
        function isFlattenable(value) {
          return isArray(value) || isArguments(value) || !!(spreadableSymbol && value && value[spreadableSymbol]);
        }
        function isIndex(value, length) {
          var type = typeof value;
          length = length == null ? MAX_SAFE_INTEGER : length;
          return !!length && (type == "number" || type != "symbol" && reIsUint.test(value)) && (value > -1 && value % 1 == 0 && value < length);
        }
        function isIterateeCall(value, index, object) {
          if (!isObject(object)) {
            return false;
          }
          var type = typeof index;
          if (type == "number" ? isArrayLike(object) && isIndex(index, object.length) : type == "string" && index in object) {
            return eq(object[index], value);
          }
          return false;
        }
        function isKey(value, object) {
          if (isArray(value)) {
            return false;
          }
          var type = typeof value;
          if (type == "number" || type == "symbol" || type == "boolean" || value == null || isSymbol(value)) {
            return true;
          }
          return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object != null && value in Object2(object);
        }
        function isKeyable(value) {
          var type = typeof value;
          return type == "string" || type == "number" || type == "symbol" || type == "boolean" ? value !== "__proto__" : value === null;
        }
        function isLaziable(func) {
          var funcName = getFuncName(func), other = lodash[funcName];
          if (typeof other != "function" || !(funcName in LazyWrapper.prototype)) {
            return false;
          }
          if (func === other) {
            return true;
          }
          var data = getData(other);
          return !!data && func === data[0];
        }
        function isMasked(func) {
          return !!maskSrcKey && maskSrcKey in func;
        }
        var isMaskable = coreJsData ? isFunction : stubFalse;
        function isPrototype(value) {
          var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto;
          return value === proto;
        }
        function isStrictComparable(value) {
          return value === value && !isObject(value);
        }
        function matchesStrictComparable(key, srcValue) {
          return function(object) {
            if (object == null) {
              return false;
            }
            return object[key] === srcValue && (srcValue !== undefined2 || key in Object2(object));
          };
        }
        function memoizeCapped(func) {
          var result3 = memoize(func, function(key) {
            if (cache.size === MAX_MEMOIZE_SIZE) {
              cache.clear();
            }
            return key;
          });
          var cache = result3.cache;
          return result3;
        }
        function mergeData(data, source) {
          var bitmask = data[1], srcBitmask = source[1], newBitmask = bitmask | srcBitmask, isCommon = newBitmask < (WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG | WRAP_ARY_FLAG);
          var isCombo = srcBitmask == WRAP_ARY_FLAG && bitmask == WRAP_CURRY_FLAG || srcBitmask == WRAP_ARY_FLAG && bitmask == WRAP_REARG_FLAG && data[7].length <= source[8] || srcBitmask == (WRAP_ARY_FLAG | WRAP_REARG_FLAG) && source[7].length <= source[8] && bitmask == WRAP_CURRY_FLAG;
          if (!(isCommon || isCombo)) {
            return data;
          }
          if (srcBitmask & WRAP_BIND_FLAG) {
            data[2] = source[2];
            newBitmask |= bitmask & WRAP_BIND_FLAG ? 0 : WRAP_CURRY_BOUND_FLAG;
          }
          var value = source[3];
          if (value) {
            var partials = data[3];
            data[3] = partials ? composeArgs(partials, value, source[4]) : value;
            data[4] = partials ? replaceHolders(data[3], PLACEHOLDER) : source[4];
          }
          value = source[5];
          if (value) {
            partials = data[5];
            data[5] = partials ? composeArgsRight(partials, value, source[6]) : value;
            data[6] = partials ? replaceHolders(data[5], PLACEHOLDER) : source[6];
          }
          value = source[7];
          if (value) {
            data[7] = value;
          }
          if (srcBitmask & WRAP_ARY_FLAG) {
            data[8] = data[8] == null ? source[8] : nativeMin(data[8], source[8]);
          }
          if (data[9] == null) {
            data[9] = source[9];
          }
          data[0] = source[0];
          data[1] = newBitmask;
          return data;
        }
        function nativeKeysIn(object) {
          var result3 = [];
          if (object != null) {
            for (var key in Object2(object)) {
              result3.push(key);
            }
          }
          return result3;
        }
        function objectToString(value) {
          return nativeObjectToString.call(value);
        }
        function overRest(func, start, transform2) {
          start = nativeMax(start === undefined2 ? func.length - 1 : start, 0);
          return function() {
            var args = arguments, index = -1, length = nativeMax(args.length - start, 0), array = Array2(length);
            while (++index < length) {
              array[index] = args[start + index];
            }
            index = -1;
            var otherArgs = Array2(start + 1);
            while (++index < start) {
              otherArgs[index] = args[index];
            }
            otherArgs[start] = transform2(array);
            return apply(func, this, otherArgs);
          };
        }
        function parent(object, path3) {
          return path3.length < 2 ? object : baseGet(object, baseSlice(path3, 0, -1));
        }
        function reorder(array, indexes) {
          var arrLength = array.length, length = nativeMin(indexes.length, arrLength), oldArray = copyArray(array);
          while (length--) {
            var index = indexes[length];
            array[length] = isIndex(index, arrLength) ? oldArray[index] : undefined2;
          }
          return array;
        }
        function safeGet(object, key) {
          if (key === "constructor" && typeof object[key] === "function") {
            return;
          }
          if (key == "__proto__") {
            return;
          }
          return object[key];
        }
        var setData = shortOut(baseSetData);
        var setTimeout2 = ctxSetTimeout || function(func, wait) {
          return root.setTimeout(func, wait);
        };
        var setToString = shortOut(baseSetToString);
        function setWrapToString(wrapper, reference, bitmask) {
          var source = reference + "";
          return setToString(wrapper, insertWrapDetails(source, updateWrapDetails(getWrapDetails(source), bitmask)));
        }
        function shortOut(func) {
          var count = 0, lastCalled = 0;
          return function() {
            var stamp = nativeNow(), remaining = HOT_SPAN - (stamp - lastCalled);
            lastCalled = stamp;
            if (remaining > 0) {
              if (++count >= HOT_COUNT) {
                return arguments[0];
              }
            } else {
              count = 0;
            }
            return func.apply(undefined2, arguments);
          };
        }
        function shuffleSelf(array, size2) {
          var index = -1, length = array.length, lastIndex = length - 1;
          size2 = size2 === undefined2 ? length : size2;
          while (++index < size2) {
            var rand = baseRandom(index, lastIndex), value = array[rand];
            array[rand] = array[index];
            array[index] = value;
          }
          array.length = size2;
          return array;
        }
        var stringToPath = memoizeCapped(function(string) {
          var result3 = [];
          if (string.charCodeAt(0) === 46) {
            result3.push("");
          }
          string.replace(rePropName, function(match, number, quote, subString) {
            result3.push(quote ? subString.replace(reEscapeChar, "$1") : number || match);
          });
          return result3;
        });
        function toKey(value) {
          if (typeof value == "string" || isSymbol(value)) {
            return value;
          }
          var result3 = value + "";
          return result3 == "0" && 1 / value == -INFINITY ? "-0" : result3;
        }
        function toSource(func) {
          if (func != null) {
            try {
              return funcToString.call(func);
            } catch (e) {
            }
            try {
              return func + "";
            } catch (e) {
            }
          }
          return "";
        }
        function updateWrapDetails(details, bitmask) {
          arrayEach(wrapFlags, function(pair) {
            var value = "_." + pair[0];
            if (bitmask & pair[1] && !arrayIncludes(details, value)) {
              details.push(value);
            }
          });
          return details.sort();
        }
        function wrapperClone(wrapper) {
          if (wrapper instanceof LazyWrapper) {
            return wrapper.clone();
          }
          var result3 = new LodashWrapper(wrapper.__wrapped__, wrapper.__chain__);
          result3.__actions__ = copyArray(wrapper.__actions__);
          result3.__index__ = wrapper.__index__;
          result3.__values__ = wrapper.__values__;
          return result3;
        }
        function chunk(array, size2, guard) {
          if (guard ? isIterateeCall(array, size2, guard) : size2 === undefined2) {
            size2 = 1;
          } else {
            size2 = nativeMax(toInteger(size2), 0);
          }
          var length = array == null ? 0 : array.length;
          if (!length || size2 < 1) {
            return [];
          }
          var index = 0, resIndex = 0, result3 = Array2(nativeCeil(length / size2));
          while (index < length) {
            result3[resIndex++] = baseSlice(array, index, index += size2);
          }
          return result3;
        }
        function compact(array) {
          var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result3 = [];
          while (++index < length) {
            var value = array[index];
            if (value) {
              result3[resIndex++] = value;
            }
          }
          return result3;
        }
        function concat() {
          var length = arguments.length;
          if (!length) {
            return [];
          }
          var args = Array2(length - 1), array = arguments[0], index = length;
          while (index--) {
            args[index - 1] = arguments[index];
          }
          return arrayPush(isArray(array) ? copyArray(array) : [array], baseFlatten(args, 1));
        }
        var difference = baseRest(function(array, values2) {
          return isArrayLikeObject(array) ? baseDifference(array, baseFlatten(values2, 1, isArrayLikeObject, true)) : [];
        });
        var differenceBy = baseRest(function(array, values2) {
          var iteratee2 = last(values2);
          if (isArrayLikeObject(iteratee2)) {
            iteratee2 = undefined2;
          }
          return isArrayLikeObject(array) ? baseDifference(array, baseFlatten(values2, 1, isArrayLikeObject, true), getIteratee(iteratee2, 2)) : [];
        });
        var differenceWith = baseRest(function(array, values2) {
          var comparator = last(values2);
          if (isArrayLikeObject(comparator)) {
            comparator = undefined2;
          }
          return isArrayLikeObject(array) ? baseDifference(array, baseFlatten(values2, 1, isArrayLikeObject, true), undefined2, comparator) : [];
        });
        function drop(array, n, guard) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          n = guard || n === undefined2 ? 1 : toInteger(n);
          return baseSlice(array, n < 0 ? 0 : n, length);
        }
        function dropRight(array, n, guard) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          n = guard || n === undefined2 ? 1 : toInteger(n);
          n = length - n;
          return baseSlice(array, 0, n < 0 ? 0 : n);
        }
        function dropRightWhile(array, predicate) {
          return array && array.length ? baseWhile(array, getIteratee(predicate, 3), true, true) : [];
        }
        function dropWhile(array, predicate) {
          return array && array.length ? baseWhile(array, getIteratee(predicate, 3), true) : [];
        }
        function fill(array, value, start, end) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          if (start && typeof start != "number" && isIterateeCall(array, value, start)) {
            start = 0;
            end = length;
          }
          return baseFill(array, value, start, end);
        }
        function findIndex(array, predicate, fromIndex) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return -1;
          }
          var index = fromIndex == null ? 0 : toInteger(fromIndex);
          if (index < 0) {
            index = nativeMax(length + index, 0);
          }
          return baseFindIndex(array, getIteratee(predicate, 3), index);
        }
        function findLastIndex(array, predicate, fromIndex) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return -1;
          }
          var index = length - 1;
          if (fromIndex !== undefined2) {
            index = toInteger(fromIndex);
            index = fromIndex < 0 ? nativeMax(length + index, 0) : nativeMin(index, length - 1);
          }
          return baseFindIndex(array, getIteratee(predicate, 3), index, true);
        }
        function flatten(array) {
          var length = array == null ? 0 : array.length;
          return length ? baseFlatten(array, 1) : [];
        }
        function flattenDeep(array) {
          var length = array == null ? 0 : array.length;
          return length ? baseFlatten(array, INFINITY) : [];
        }
        function flattenDepth(array, depth) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          depth = depth === undefined2 ? 1 : toInteger(depth);
          return baseFlatten(array, depth);
        }
        function fromPairs(pairs) {
          var index = -1, length = pairs == null ? 0 : pairs.length, result3 = {};
          while (++index < length) {
            var pair = pairs[index];
            result3[pair[0]] = pair[1];
          }
          return result3;
        }
        function head(array) {
          return array && array.length ? array[0] : undefined2;
        }
        function indexOf(array, value, fromIndex) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return -1;
          }
          var index = fromIndex == null ? 0 : toInteger(fromIndex);
          if (index < 0) {
            index = nativeMax(length + index, 0);
          }
          return baseIndexOf(array, value, index);
        }
        function initial(array) {
          var length = array == null ? 0 : array.length;
          return length ? baseSlice(array, 0, -1) : [];
        }
        var intersection = baseRest(function(arrays) {
          var mapped = arrayMap(arrays, castArrayLikeObject);
          return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped) : [];
        });
        var intersectionBy = baseRest(function(arrays) {
          var iteratee2 = last(arrays), mapped = arrayMap(arrays, castArrayLikeObject);
          if (iteratee2 === last(mapped)) {
            iteratee2 = undefined2;
          } else {
            mapped.pop();
          }
          return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped, getIteratee(iteratee2, 2)) : [];
        });
        var intersectionWith = baseRest(function(arrays) {
          var comparator = last(arrays), mapped = arrayMap(arrays, castArrayLikeObject);
          comparator = typeof comparator == "function" ? comparator : undefined2;
          if (comparator) {
            mapped.pop();
          }
          return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped, undefined2, comparator) : [];
        });
        function join2(array, separator) {
          return array == null ? "" : nativeJoin.call(array, separator);
        }
        function last(array) {
          var length = array == null ? 0 : array.length;
          return length ? array[length - 1] : undefined2;
        }
        function lastIndexOf(array, value, fromIndex) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return -1;
          }
          var index = length;
          if (fromIndex !== undefined2) {
            index = toInteger(fromIndex);
            index = index < 0 ? nativeMax(length + index, 0) : nativeMin(index, length - 1);
          }
          return value === value ? strictLastIndexOf(array, value, index) : baseFindIndex(array, baseIsNaN, index, true);
        }
        function nth(array, n) {
          return array && array.length ? baseNth(array, toInteger(n)) : undefined2;
        }
        var pull = baseRest(pullAll);
        function pullAll(array, values2) {
          return array && array.length && values2 && values2.length ? basePullAll(array, values2) : array;
        }
        function pullAllBy(array, values2, iteratee2) {
          return array && array.length && values2 && values2.length ? basePullAll(array, values2, getIteratee(iteratee2, 2)) : array;
        }
        function pullAllWith(array, values2, comparator) {
          return array && array.length && values2 && values2.length ? basePullAll(array, values2, undefined2, comparator) : array;
        }
        var pullAt = flatRest(function(array, indexes) {
          var length = array == null ? 0 : array.length, result3 = baseAt(array, indexes);
          basePullAt(array, arrayMap(indexes, function(index) {
            return isIndex(index, length) ? +index : index;
          }).sort(compareAscending));
          return result3;
        });
        function remove(array, predicate) {
          var result3 = [];
          if (!(array && array.length)) {
            return result3;
          }
          var index = -1, indexes = [], length = array.length;
          predicate = getIteratee(predicate, 3);
          while (++index < length) {
            var value = array[index];
            if (predicate(value, index, array)) {
              result3.push(value);
              indexes.push(index);
            }
          }
          basePullAt(array, indexes);
          return result3;
        }
        function reverse(array) {
          return array == null ? array : nativeReverse.call(array);
        }
        function slice(array, start, end) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          if (end && typeof end != "number" && isIterateeCall(array, start, end)) {
            start = 0;
            end = length;
          } else {
            start = start == null ? 0 : toInteger(start);
            end = end === undefined2 ? length : toInteger(end);
          }
          return baseSlice(array, start, end);
        }
        function sortedIndex(array, value) {
          return baseSortedIndex(array, value);
        }
        function sortedIndexBy(array, value, iteratee2) {
          return baseSortedIndexBy(array, value, getIteratee(iteratee2, 2));
        }
        function sortedIndexOf(array, value) {
          var length = array == null ? 0 : array.length;
          if (length) {
            var index = baseSortedIndex(array, value);
            if (index < length && eq(array[index], value)) {
              return index;
            }
          }
          return -1;
        }
        function sortedLastIndex(array, value) {
          return baseSortedIndex(array, value, true);
        }
        function sortedLastIndexBy(array, value, iteratee2) {
          return baseSortedIndexBy(array, value, getIteratee(iteratee2, 2), true);
        }
        function sortedLastIndexOf(array, value) {
          var length = array == null ? 0 : array.length;
          if (length) {
            var index = baseSortedIndex(array, value, true) - 1;
            if (eq(array[index], value)) {
              return index;
            }
          }
          return -1;
        }
        function sortedUniq(array) {
          return array && array.length ? baseSortedUniq(array) : [];
        }
        function sortedUniqBy(array, iteratee2) {
          return array && array.length ? baseSortedUniq(array, getIteratee(iteratee2, 2)) : [];
        }
        function tail(array) {
          var length = array == null ? 0 : array.length;
          return length ? baseSlice(array, 1, length) : [];
        }
        function take(array, n, guard) {
          if (!(array && array.length)) {
            return [];
          }
          n = guard || n === undefined2 ? 1 : toInteger(n);
          return baseSlice(array, 0, n < 0 ? 0 : n);
        }
        function takeRight(array, n, guard) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          n = guard || n === undefined2 ? 1 : toInteger(n);
          n = length - n;
          return baseSlice(array, n < 0 ? 0 : n, length);
        }
        function takeRightWhile(array, predicate) {
          return array && array.length ? baseWhile(array, getIteratee(predicate, 3), false, true) : [];
        }
        function takeWhile(array, predicate) {
          return array && array.length ? baseWhile(array, getIteratee(predicate, 3)) : [];
        }
        var union = baseRest(function(arrays) {
          return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true));
        });
        var unionBy = baseRest(function(arrays) {
          var iteratee2 = last(arrays);
          if (isArrayLikeObject(iteratee2)) {
            iteratee2 = undefined2;
          }
          return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), getIteratee(iteratee2, 2));
        });
        var unionWith = baseRest(function(arrays) {
          var comparator = last(arrays);
          comparator = typeof comparator == "function" ? comparator : undefined2;
          return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), undefined2, comparator);
        });
        function uniq(array) {
          return array && array.length ? baseUniq(array) : [];
        }
        function uniqBy(array, iteratee2) {
          return array && array.length ? baseUniq(array, getIteratee(iteratee2, 2)) : [];
        }
        function uniqWith(array, comparator) {
          comparator = typeof comparator == "function" ? comparator : undefined2;
          return array && array.length ? baseUniq(array, undefined2, comparator) : [];
        }
        function unzip(array) {
          if (!(array && array.length)) {
            return [];
          }
          var length = 0;
          array = arrayFilter(array, function(group) {
            if (isArrayLikeObject(group)) {
              length = nativeMax(group.length, length);
              return true;
            }
          });
          return baseTimes(length, function(index) {
            return arrayMap(array, baseProperty(index));
          });
        }
        function unzipWith(array, iteratee2) {
          if (!(array && array.length)) {
            return [];
          }
          var result3 = unzip(array);
          if (iteratee2 == null) {
            return result3;
          }
          return arrayMap(result3, function(group) {
            return apply(iteratee2, undefined2, group);
          });
        }
        var without = baseRest(function(array, values2) {
          return isArrayLikeObject(array) ? baseDifference(array, values2) : [];
        });
        var xor = baseRest(function(arrays) {
          return baseXor(arrayFilter(arrays, isArrayLikeObject));
        });
        var xorBy = baseRest(function(arrays) {
          var iteratee2 = last(arrays);
          if (isArrayLikeObject(iteratee2)) {
            iteratee2 = undefined2;
          }
          return baseXor(arrayFilter(arrays, isArrayLikeObject), getIteratee(iteratee2, 2));
        });
        var xorWith = baseRest(function(arrays) {
          var comparator = last(arrays);
          comparator = typeof comparator == "function" ? comparator : undefined2;
          return baseXor(arrayFilter(arrays, isArrayLikeObject), undefined2, comparator);
        });
        var zip = baseRest(unzip);
        function zipObject(props, values2) {
          return baseZipObject(props || [], values2 || [], assignValue);
        }
        function zipObjectDeep(props, values2) {
          return baseZipObject(props || [], values2 || [], baseSet);
        }
        var zipWith = baseRest(function(arrays) {
          var length = arrays.length, iteratee2 = length > 1 ? arrays[length - 1] : undefined2;
          iteratee2 = typeof iteratee2 == "function" ? (arrays.pop(), iteratee2) : undefined2;
          return unzipWith(arrays, iteratee2);
        });
        function chain(value) {
          var result3 = lodash(value);
          result3.__chain__ = true;
          return result3;
        }
        function tap(value, interceptor) {
          interceptor(value);
          return value;
        }
        function thru(value, interceptor) {
          return interceptor(value);
        }
        var wrapperAt = flatRest(function(paths) {
          var length = paths.length, start = length ? paths[0] : 0, value = this.__wrapped__, interceptor = function(object) {
            return baseAt(object, paths);
          };
          if (length > 1 || this.__actions__.length || !(value instanceof LazyWrapper) || !isIndex(start)) {
            return this.thru(interceptor);
          }
          value = value.slice(start, +start + (length ? 1 : 0));
          value.__actions__.push({
            "func": thru,
            "args": [interceptor],
            "thisArg": undefined2
          });
          return new LodashWrapper(value, this.__chain__).thru(function(array) {
            if (length && !array.length) {
              array.push(undefined2);
            }
            return array;
          });
        });
        function wrapperChain() {
          return chain(this);
        }
        function wrapperCommit() {
          return new LodashWrapper(this.value(), this.__chain__);
        }
        function wrapperNext() {
          if (this.__values__ === undefined2) {
            this.__values__ = toArray(this.value());
          }
          var done = this.__index__ >= this.__values__.length, value = done ? undefined2 : this.__values__[this.__index__++];
          return { "done": done, "value": value };
        }
        function wrapperToIterator() {
          return this;
        }
        function wrapperPlant(value) {
          var result3, parent2 = this;
          while (parent2 instanceof baseLodash) {
            var clone2 = wrapperClone(parent2);
            clone2.__index__ = 0;
            clone2.__values__ = undefined2;
            if (result3) {
              previous.__wrapped__ = clone2;
            } else {
              result3 = clone2;
            }
            var previous = clone2;
            parent2 = parent2.__wrapped__;
          }
          previous.__wrapped__ = value;
          return result3;
        }
        function wrapperReverse() {
          var value = this.__wrapped__;
          if (value instanceof LazyWrapper) {
            var wrapped = value;
            if (this.__actions__.length) {
              wrapped = new LazyWrapper(this);
            }
            wrapped = wrapped.reverse();
            wrapped.__actions__.push({
              "func": thru,
              "args": [reverse],
              "thisArg": undefined2
            });
            return new LodashWrapper(wrapped, this.__chain__);
          }
          return this.thru(reverse);
        }
        function wrapperValue() {
          return baseWrapperValue(this.__wrapped__, this.__actions__);
        }
        var countBy = createAggregator(function(result3, value, key) {
          if (hasOwnProperty.call(result3, key)) {
            ++result3[key];
          } else {
            baseAssignValue(result3, key, 1);
          }
        });
        function every(collection, predicate, guard) {
          var func = isArray(collection) ? arrayEvery : baseEvery;
          if (guard && isIterateeCall(collection, predicate, guard)) {
            predicate = undefined2;
          }
          return func(collection, getIteratee(predicate, 3));
        }
        function filter(collection, predicate) {
          var func = isArray(collection) ? arrayFilter : baseFilter;
          return func(collection, getIteratee(predicate, 3));
        }
        var find = createFind(findIndex);
        var findLast = createFind(findLastIndex);
        function flatMap(collection, iteratee2) {
          return baseFlatten(map(collection, iteratee2), 1);
        }
        function flatMapDeep(collection, iteratee2) {
          return baseFlatten(map(collection, iteratee2), INFINITY);
        }
        function flatMapDepth(collection, iteratee2, depth) {
          depth = depth === undefined2 ? 1 : toInteger(depth);
          return baseFlatten(map(collection, iteratee2), depth);
        }
        function forEach(collection, iteratee2) {
          var func = isArray(collection) ? arrayEach : baseEach;
          return func(collection, getIteratee(iteratee2, 3));
        }
        function forEachRight(collection, iteratee2) {
          var func = isArray(collection) ? arrayEachRight : baseEachRight;
          return func(collection, getIteratee(iteratee2, 3));
        }
        var groupBy = createAggregator(function(result3, value, key) {
          if (hasOwnProperty.call(result3, key)) {
            result3[key].push(value);
          } else {
            baseAssignValue(result3, key, [value]);
          }
        });
        function includes(collection, value, fromIndex, guard) {
          collection = isArrayLike(collection) ? collection : values(collection);
          fromIndex = fromIndex && !guard ? toInteger(fromIndex) : 0;
          var length = collection.length;
          if (fromIndex < 0) {
            fromIndex = nativeMax(length + fromIndex, 0);
          }
          return isString(collection) ? fromIndex <= length && collection.indexOf(value, fromIndex) > -1 : !!length && baseIndexOf(collection, value, fromIndex) > -1;
        }
        var invokeMap = baseRest(function(collection, path3, args) {
          var index = -1, isFunc = typeof path3 == "function", result3 = isArrayLike(collection) ? Array2(collection.length) : [];
          baseEach(collection, function(value) {
            result3[++index] = isFunc ? apply(path3, value, args) : baseInvoke(value, path3, args);
          });
          return result3;
        });
        var keyBy = createAggregator(function(result3, value, key) {
          baseAssignValue(result3, key, value);
        });
        function map(collection, iteratee2) {
          var func = isArray(collection) ? arrayMap : baseMap;
          return func(collection, getIteratee(iteratee2, 3));
        }
        function orderBy(collection, iteratees, orders, guard) {
          if (collection == null) {
            return [];
          }
          if (!isArray(iteratees)) {
            iteratees = iteratees == null ? [] : [iteratees];
          }
          orders = guard ? undefined2 : orders;
          if (!isArray(orders)) {
            orders = orders == null ? [] : [orders];
          }
          return baseOrderBy(collection, iteratees, orders);
        }
        var partition = createAggregator(function(result3, value, key) {
          result3[key ? 0 : 1].push(value);
        }, function() {
          return [[], []];
        });
        function reduce(collection, iteratee2, accumulator) {
          var func = isArray(collection) ? arrayReduce : baseReduce, initAccum = arguments.length < 3;
          return func(collection, getIteratee(iteratee2, 4), accumulator, initAccum, baseEach);
        }
        function reduceRight(collection, iteratee2, accumulator) {
          var func = isArray(collection) ? arrayReduceRight : baseReduce, initAccum = arguments.length < 3;
          return func(collection, getIteratee(iteratee2, 4), accumulator, initAccum, baseEachRight);
        }
        function reject(collection, predicate) {
          var func = isArray(collection) ? arrayFilter : baseFilter;
          return func(collection, negate(getIteratee(predicate, 3)));
        }
        function sample(collection) {
          var func = isArray(collection) ? arraySample : baseSample;
          return func(collection);
        }
        function sampleSize(collection, n, guard) {
          if (guard ? isIterateeCall(collection, n, guard) : n === undefined2) {
            n = 1;
          } else {
            n = toInteger(n);
          }
          var func = isArray(collection) ? arraySampleSize : baseSampleSize;
          return func(collection, n);
        }
        function shuffle(collection) {
          var func = isArray(collection) ? arrayShuffle : baseShuffle;
          return func(collection);
        }
        function size(collection) {
          if (collection == null) {
            return 0;
          }
          if (isArrayLike(collection)) {
            return isString(collection) ? stringSize(collection) : collection.length;
          }
          var tag = getTag(collection);
          if (tag == mapTag || tag == setTag) {
            return collection.size;
          }
          return baseKeys(collection).length;
        }
        function some(collection, predicate, guard) {
          var func = isArray(collection) ? arraySome : baseSome;
          if (guard && isIterateeCall(collection, predicate, guard)) {
            predicate = undefined2;
          }
          return func(collection, getIteratee(predicate, 3));
        }
        var sortBy = baseRest(function(collection, iteratees) {
          if (collection == null) {
            return [];
          }
          var length = iteratees.length;
          if (length > 1 && isIterateeCall(collection, iteratees[0], iteratees[1])) {
            iteratees = [];
          } else if (length > 2 && isIterateeCall(iteratees[0], iteratees[1], iteratees[2])) {
            iteratees = [iteratees[0]];
          }
          return baseOrderBy(collection, baseFlatten(iteratees, 1), []);
        });
        var now = ctxNow || function() {
          return root.Date.now();
        };
        function after(n, func) {
          if (typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          n = toInteger(n);
          return function() {
            if (--n < 1) {
              return func.apply(this, arguments);
            }
          };
        }
        function ary(func, n, guard) {
          n = guard ? undefined2 : n;
          n = func && n == null ? func.length : n;
          return createWrap(func, WRAP_ARY_FLAG, undefined2, undefined2, undefined2, undefined2, n);
        }
        function before(n, func) {
          var result3;
          if (typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          n = toInteger(n);
          return function() {
            if (--n > 0) {
              result3 = func.apply(this, arguments);
            }
            if (n <= 1) {
              func = undefined2;
            }
            return result3;
          };
        }
        var bind = baseRest(function(func, thisArg, partials) {
          var bitmask = WRAP_BIND_FLAG;
          if (partials.length) {
            var holders = replaceHolders(partials, getHolder(bind));
            bitmask |= WRAP_PARTIAL_FLAG;
          }
          return createWrap(func, bitmask, thisArg, partials, holders);
        });
        var bindKey = baseRest(function(object, key, partials) {
          var bitmask = WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG;
          if (partials.length) {
            var holders = replaceHolders(partials, getHolder(bindKey));
            bitmask |= WRAP_PARTIAL_FLAG;
          }
          return createWrap(key, bitmask, object, partials, holders);
        });
        function curry(func, arity, guard) {
          arity = guard ? undefined2 : arity;
          var result3 = createWrap(func, WRAP_CURRY_FLAG, undefined2, undefined2, undefined2, undefined2, undefined2, arity);
          result3.placeholder = curry.placeholder;
          return result3;
        }
        function curryRight(func, arity, guard) {
          arity = guard ? undefined2 : arity;
          var result3 = createWrap(func, WRAP_CURRY_RIGHT_FLAG, undefined2, undefined2, undefined2, undefined2, undefined2, arity);
          result3.placeholder = curryRight.placeholder;
          return result3;
        }
        function debounce(func, wait, options) {
          var lastArgs, lastThis, maxWait, result3, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
          if (typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          wait = toNumber(wait) || 0;
          if (isObject(options)) {
            leading = !!options.leading;
            maxing = "maxWait" in options;
            maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
            trailing = "trailing" in options ? !!options.trailing : trailing;
          }
          function invokeFunc(time) {
            var args = lastArgs, thisArg = lastThis;
            lastArgs = lastThis = undefined2;
            lastInvokeTime = time;
            result3 = func.apply(thisArg, args);
            return result3;
          }
          function leadingEdge(time) {
            lastInvokeTime = time;
            timerId = setTimeout2(timerExpired, wait);
            return leading ? invokeFunc(time) : result3;
          }
          function remainingWait(time) {
            var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, timeWaiting = wait - timeSinceLastCall;
            return maxing ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke) : timeWaiting;
          }
          function shouldInvoke(time) {
            var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
            return lastCallTime === undefined2 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
          }
          function timerExpired() {
            var time = now();
            if (shouldInvoke(time)) {
              return trailingEdge(time);
            }
            timerId = setTimeout2(timerExpired, remainingWait(time));
          }
          function trailingEdge(time) {
            timerId = undefined2;
            if (trailing && lastArgs) {
              return invokeFunc(time);
            }
            lastArgs = lastThis = undefined2;
            return result3;
          }
          function cancel() {
            if (timerId !== undefined2) {
              clearTimeout2(timerId);
            }
            lastInvokeTime = 0;
            lastArgs = lastCallTime = lastThis = timerId = undefined2;
          }
          function flush() {
            return timerId === undefined2 ? result3 : trailingEdge(now());
          }
          function debounced() {
            var time = now(), isInvoking = shouldInvoke(time);
            lastArgs = arguments;
            lastThis = this;
            lastCallTime = time;
            if (isInvoking) {
              if (timerId === undefined2) {
                return leadingEdge(lastCallTime);
              }
              if (maxing) {
                clearTimeout2(timerId);
                timerId = setTimeout2(timerExpired, wait);
                return invokeFunc(lastCallTime);
              }
            }
            if (timerId === undefined2) {
              timerId = setTimeout2(timerExpired, wait);
            }
            return result3;
          }
          debounced.cancel = cancel;
          debounced.flush = flush;
          return debounced;
        }
        var defer = baseRest(function(func, args) {
          return baseDelay(func, 1, args);
        });
        var delay = baseRest(function(func, wait, args) {
          return baseDelay(func, toNumber(wait) || 0, args);
        });
        function flip(func) {
          return createWrap(func, WRAP_FLIP_FLAG);
        }
        function memoize(func, resolver) {
          if (typeof func != "function" || resolver != null && typeof resolver != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          var memoized = function() {
            var args = arguments, key = resolver ? resolver.apply(this, args) : args[0], cache = memoized.cache;
            if (cache.has(key)) {
              return cache.get(key);
            }
            var result3 = func.apply(this, args);
            memoized.cache = cache.set(key, result3) || cache;
            return result3;
          };
          memoized.cache = new (memoize.Cache || MapCache)();
          return memoized;
        }
        memoize.Cache = MapCache;
        function negate(predicate) {
          if (typeof predicate != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          return function() {
            var args = arguments;
            switch (args.length) {
              case 0:
                return !predicate.call(this);
              case 1:
                return !predicate.call(this, args[0]);
              case 2:
                return !predicate.call(this, args[0], args[1]);
              case 3:
                return !predicate.call(this, args[0], args[1], args[2]);
            }
            return !predicate.apply(this, args);
          };
        }
        function once(func) {
          return before(2, func);
        }
        var overArgs = castRest(function(func, transforms) {
          transforms = transforms.length == 1 && isArray(transforms[0]) ? arrayMap(transforms[0], baseUnary(getIteratee())) : arrayMap(baseFlatten(transforms, 1), baseUnary(getIteratee()));
          var funcsLength = transforms.length;
          return baseRest(function(args) {
            var index = -1, length = nativeMin(args.length, funcsLength);
            while (++index < length) {
              args[index] = transforms[index].call(this, args[index]);
            }
            return apply(func, this, args);
          });
        });
        var partial = baseRest(function(func, partials) {
          var holders = replaceHolders(partials, getHolder(partial));
          return createWrap(func, WRAP_PARTIAL_FLAG, undefined2, partials, holders);
        });
        var partialRight = baseRest(function(func, partials) {
          var holders = replaceHolders(partials, getHolder(partialRight));
          return createWrap(func, WRAP_PARTIAL_RIGHT_FLAG, undefined2, partials, holders);
        });
        var rearg = flatRest(function(func, indexes) {
          return createWrap(func, WRAP_REARG_FLAG, undefined2, undefined2, undefined2, indexes);
        });
        function rest(func, start) {
          if (typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          start = start === undefined2 ? start : toInteger(start);
          return baseRest(func, start);
        }
        function spread(func, start) {
          if (typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          start = start == null ? 0 : nativeMax(toInteger(start), 0);
          return baseRest(function(args) {
            var array = args[start], otherArgs = castSlice(args, 0, start);
            if (array) {
              arrayPush(otherArgs, array);
            }
            return apply(func, this, otherArgs);
          });
        }
        function throttle(func, wait, options) {
          var leading = true, trailing = true;
          if (typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          if (isObject(options)) {
            leading = "leading" in options ? !!options.leading : leading;
            trailing = "trailing" in options ? !!options.trailing : trailing;
          }
          return debounce(func, wait, {
            "leading": leading,
            "maxWait": wait,
            "trailing": trailing
          });
        }
        function unary(func) {
          return ary(func, 1);
        }
        function wrap(value, wrapper) {
          return partial(castFunction(wrapper), value);
        }
        function castArray() {
          if (!arguments.length) {
            return [];
          }
          var value = arguments[0];
          return isArray(value) ? value : [value];
        }
        function clone(value) {
          return baseClone(value, CLONE_SYMBOLS_FLAG);
        }
        function cloneWith(value, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          return baseClone(value, CLONE_SYMBOLS_FLAG, customizer);
        }
        function cloneDeep(value) {
          return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG);
        }
        function cloneDeepWith(value, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG, customizer);
        }
        function conformsTo(object, source) {
          return source == null || baseConformsTo(object, source, keys(source));
        }
        function eq(value, other) {
          return value === other || value !== value && other !== other;
        }
        var gt = createRelationalOperation(baseGt);
        var gte = createRelationalOperation(function(value, other) {
          return value >= other;
        });
        var isArguments = baseIsArguments(/* @__PURE__ */ function() {
          return arguments;
        }()) ? baseIsArguments : function(value) {
          return isObjectLike(value) && hasOwnProperty.call(value, "callee") && !propertyIsEnumerable.call(value, "callee");
        };
        var isArray = Array2.isArray;
        var isArrayBuffer = nodeIsArrayBuffer ? baseUnary(nodeIsArrayBuffer) : baseIsArrayBuffer;
        function isArrayLike(value) {
          return value != null && isLength(value.length) && !isFunction(value);
        }
        function isArrayLikeObject(value) {
          return isObjectLike(value) && isArrayLike(value);
        }
        function isBoolean(value) {
          return value === true || value === false || isObjectLike(value) && baseGetTag(value) == boolTag;
        }
        var isBuffer = nativeIsBuffer || stubFalse;
        var isDate = nodeIsDate ? baseUnary(nodeIsDate) : baseIsDate;
        function isElement(value) {
          return isObjectLike(value) && value.nodeType === 1 && !isPlainObject(value);
        }
        function isEmpty(value) {
          if (value == null) {
            return true;
          }
          if (isArrayLike(value) && (isArray(value) || typeof value == "string" || typeof value.splice == "function" || isBuffer(value) || isTypedArray(value) || isArguments(value))) {
            return !value.length;
          }
          var tag = getTag(value);
          if (tag == mapTag || tag == setTag) {
            return !value.size;
          }
          if (isPrototype(value)) {
            return !baseKeys(value).length;
          }
          for (var key in value) {
            if (hasOwnProperty.call(value, key)) {
              return false;
            }
          }
          return true;
        }
        function isEqual(value, other) {
          return baseIsEqual(value, other);
        }
        function isEqualWith(value, other, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          var result3 = customizer ? customizer(value, other) : undefined2;
          return result3 === undefined2 ? baseIsEqual(value, other, undefined2, customizer) : !!result3;
        }
        function isError(value) {
          if (!isObjectLike(value)) {
            return false;
          }
          var tag = baseGetTag(value);
          return tag == errorTag || tag == domExcTag || typeof value.message == "string" && typeof value.name == "string" && !isPlainObject(value);
        }
        function isFinite2(value) {
          return typeof value == "number" && nativeIsFinite(value);
        }
        function isFunction(value) {
          if (!isObject(value)) {
            return false;
          }
          var tag = baseGetTag(value);
          return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
        }
        function isInteger(value) {
          return typeof value == "number" && value == toInteger(value);
        }
        function isLength(value) {
          return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
        }
        function isObject(value) {
          var type = typeof value;
          return value != null && (type == "object" || type == "function");
        }
        function isObjectLike(value) {
          return value != null && typeof value == "object";
        }
        var isMap = nodeIsMap ? baseUnary(nodeIsMap) : baseIsMap;
        function isMatch(object, source) {
          return object === source || baseIsMatch(object, source, getMatchData(source));
        }
        function isMatchWith(object, source, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          return baseIsMatch(object, source, getMatchData(source), customizer);
        }
        function isNaN2(value) {
          return isNumber(value) && value != +value;
        }
        function isNative(value) {
          if (isMaskable(value)) {
            throw new Error2(CORE_ERROR_TEXT);
          }
          return baseIsNative(value);
        }
        function isNull(value) {
          return value === null;
        }
        function isNil(value) {
          return value == null;
        }
        function isNumber(value) {
          return typeof value == "number" || isObjectLike(value) && baseGetTag(value) == numberTag;
        }
        function isPlainObject(value) {
          if (!isObjectLike(value) || baseGetTag(value) != objectTag) {
            return false;
          }
          var proto = getPrototype(value);
          if (proto === null) {
            return true;
          }
          var Ctor = hasOwnProperty.call(proto, "constructor") && proto.constructor;
          return typeof Ctor == "function" && Ctor instanceof Ctor && funcToString.call(Ctor) == objectCtorString;
        }
        var isRegExp = nodeIsRegExp ? baseUnary(nodeIsRegExp) : baseIsRegExp;
        function isSafeInteger(value) {
          return isInteger(value) && value >= -MAX_SAFE_INTEGER && value <= MAX_SAFE_INTEGER;
        }
        var isSet = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;
        function isString(value) {
          return typeof value == "string" || !isArray(value) && isObjectLike(value) && baseGetTag(value) == stringTag;
        }
        function isSymbol(value) {
          return typeof value == "symbol" || isObjectLike(value) && baseGetTag(value) == symbolTag;
        }
        var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
        function isUndefined(value) {
          return value === undefined2;
        }
        function isWeakMap(value) {
          return isObjectLike(value) && getTag(value) == weakMapTag;
        }
        function isWeakSet(value) {
          return isObjectLike(value) && baseGetTag(value) == weakSetTag;
        }
        var lt = createRelationalOperation(baseLt);
        var lte = createRelationalOperation(function(value, other) {
          return value <= other;
        });
        function toArray(value) {
          if (!value) {
            return [];
          }
          if (isArrayLike(value)) {
            return isString(value) ? stringToArray(value) : copyArray(value);
          }
          if (symIterator && value[symIterator]) {
            return iteratorToArray(value[symIterator]());
          }
          var tag = getTag(value), func = tag == mapTag ? mapToArray : tag == setTag ? setToArray : values;
          return func(value);
        }
        function toFinite(value) {
          if (!value) {
            return value === 0 ? value : 0;
          }
          value = toNumber(value);
          if (value === INFINITY || value === -INFINITY) {
            var sign2 = value < 0 ? -1 : 1;
            return sign2 * MAX_INTEGER;
          }
          return value === value ? value : 0;
        }
        function toInteger(value) {
          var result3 = toFinite(value), remainder = result3 % 1;
          return result3 === result3 ? remainder ? result3 - remainder : result3 : 0;
        }
        function toLength(value) {
          return value ? baseClamp(toInteger(value), 0, MAX_ARRAY_LENGTH) : 0;
        }
        function toNumber(value) {
          if (typeof value == "number") {
            return value;
          }
          if (isSymbol(value)) {
            return NAN;
          }
          if (isObject(value)) {
            var other = typeof value.valueOf == "function" ? value.valueOf() : value;
            value = isObject(other) ? other + "" : other;
          }
          if (typeof value != "string") {
            return value === 0 ? value : +value;
          }
          value = baseTrim(value);
          var isBinary = reIsBinary.test(value);
          return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
        }
        function toPlainObject(value) {
          return copyObject(value, keysIn(value));
        }
        function toSafeInteger(value) {
          return value ? baseClamp(toInteger(value), -MAX_SAFE_INTEGER, MAX_SAFE_INTEGER) : value === 0 ? value : 0;
        }
        function toString(value) {
          return value == null ? "" : baseToString(value);
        }
        var assign = createAssigner(function(object, source) {
          if (isPrototype(source) || isArrayLike(source)) {
            copyObject(source, keys(source), object);
            return;
          }
          for (var key in source) {
            if (hasOwnProperty.call(source, key)) {
              assignValue(object, key, source[key]);
            }
          }
        });
        var assignIn = createAssigner(function(object, source) {
          copyObject(source, keysIn(source), object);
        });
        var assignInWith = createAssigner(function(object, source, srcIndex, customizer) {
          copyObject(source, keysIn(source), object, customizer);
        });
        var assignWith = createAssigner(function(object, source, srcIndex, customizer) {
          copyObject(source, keys(source), object, customizer);
        });
        var at = flatRest(baseAt);
        function create(prototype, properties) {
          var result3 = baseCreate(prototype);
          return properties == null ? result3 : baseAssign(result3, properties);
        }
        var defaults = baseRest(function(object, sources) {
          object = Object2(object);
          var index = -1;
          var length = sources.length;
          var guard = length > 2 ? sources[2] : undefined2;
          if (guard && isIterateeCall(sources[0], sources[1], guard)) {
            length = 1;
          }
          while (++index < length) {
            var source = sources[index];
            var props = keysIn(source);
            var propsIndex = -1;
            var propsLength = props.length;
            while (++propsIndex < propsLength) {
              var key = props[propsIndex];
              var value = object[key];
              if (value === undefined2 || eq(value, objectProto[key]) && !hasOwnProperty.call(object, key)) {
                object[key] = source[key];
              }
            }
          }
          return object;
        });
        var defaultsDeep = baseRest(function(args) {
          args.push(undefined2, customDefaultsMerge);
          return apply(mergeWith, undefined2, args);
        });
        function findKey(object, predicate) {
          return baseFindKey(object, getIteratee(predicate, 3), baseForOwn);
        }
        function findLastKey(object, predicate) {
          return baseFindKey(object, getIteratee(predicate, 3), baseForOwnRight);
        }
        function forIn(object, iteratee2) {
          return object == null ? object : baseFor(object, getIteratee(iteratee2, 3), keysIn);
        }
        function forInRight(object, iteratee2) {
          return object == null ? object : baseForRight(object, getIteratee(iteratee2, 3), keysIn);
        }
        function forOwn(object, iteratee2) {
          return object && baseForOwn(object, getIteratee(iteratee2, 3));
        }
        function forOwnRight(object, iteratee2) {
          return object && baseForOwnRight(object, getIteratee(iteratee2, 3));
        }
        function functions(object) {
          return object == null ? [] : baseFunctions(object, keys(object));
        }
        function functionsIn(object) {
          return object == null ? [] : baseFunctions(object, keysIn(object));
        }
        function get(object, path3, defaultValue) {
          var result3 = object == null ? undefined2 : baseGet(object, path3);
          return result3 === undefined2 ? defaultValue : result3;
        }
        function has(object, path3) {
          return object != null && hasPath(object, path3, baseHas);
        }
        function hasIn(object, path3) {
          return object != null && hasPath(object, path3, baseHasIn);
        }
        var invert = createInverter(function(result3, value, key) {
          if (value != null && typeof value.toString != "function") {
            value = nativeObjectToString.call(value);
          }
          result3[value] = key;
        }, constant(identity));
        var invertBy = createInverter(function(result3, value, key) {
          if (value != null && typeof value.toString != "function") {
            value = nativeObjectToString.call(value);
          }
          if (hasOwnProperty.call(result3, value)) {
            result3[value].push(key);
          } else {
            result3[value] = [key];
          }
        }, getIteratee);
        var invoke = baseRest(baseInvoke);
        function keys(object) {
          return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
        }
        function keysIn(object) {
          return isArrayLike(object) ? arrayLikeKeys(object, true) : baseKeysIn(object);
        }
        function mapKeys(object, iteratee2) {
          var result3 = {};
          iteratee2 = getIteratee(iteratee2, 3);
          baseForOwn(object, function(value, key, object2) {
            baseAssignValue(result3, iteratee2(value, key, object2), value);
          });
          return result3;
        }
        function mapValues(object, iteratee2) {
          var result3 = {};
          iteratee2 = getIteratee(iteratee2, 3);
          baseForOwn(object, function(value, key, object2) {
            baseAssignValue(result3, key, iteratee2(value, key, object2));
          });
          return result3;
        }
        var merge = createAssigner(function(object, source, srcIndex) {
          baseMerge(object, source, srcIndex);
        });
        var mergeWith = createAssigner(function(object, source, srcIndex, customizer) {
          baseMerge(object, source, srcIndex, customizer);
        });
        var omit = flatRest(function(object, paths) {
          var result3 = {};
          if (object == null) {
            return result3;
          }
          var isDeep = false;
          paths = arrayMap(paths, function(path3) {
            path3 = castPath(path3, object);
            isDeep || (isDeep = path3.length > 1);
            return path3;
          });
          copyObject(object, getAllKeysIn(object), result3);
          if (isDeep) {
            result3 = baseClone(result3, CLONE_DEEP_FLAG | CLONE_FLAT_FLAG | CLONE_SYMBOLS_FLAG, customOmitClone);
          }
          var length = paths.length;
          while (length--) {
            baseUnset(result3, paths[length]);
          }
          return result3;
        });
        function omitBy(object, predicate) {
          return pickBy(object, negate(getIteratee(predicate)));
        }
        var pick = flatRest(function(object, paths) {
          return object == null ? {} : basePick(object, paths);
        });
        function pickBy(object, predicate) {
          if (object == null) {
            return {};
          }
          var props = arrayMap(getAllKeysIn(object), function(prop) {
            return [prop];
          });
          predicate = getIteratee(predicate);
          return basePickBy(object, props, function(value, path3) {
            return predicate(value, path3[0]);
          });
        }
        function result2(object, path3, defaultValue) {
          path3 = castPath(path3, object);
          var index = -1, length = path3.length;
          if (!length) {
            length = 1;
            object = undefined2;
          }
          while (++index < length) {
            var value = object == null ? undefined2 : object[toKey(path3[index])];
            if (value === undefined2) {
              index = length;
              value = defaultValue;
            }
            object = isFunction(value) ? value.call(object) : value;
          }
          return object;
        }
        function set(object, path3, value) {
          return object == null ? object : baseSet(object, path3, value);
        }
        function setWith(object, path3, value, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          return object == null ? object : baseSet(object, path3, value, customizer);
        }
        var toPairs = createToPairs(keys);
        var toPairsIn = createToPairs(keysIn);
        function transform(object, iteratee2, accumulator) {
          var isArr = isArray(object), isArrLike = isArr || isBuffer(object) || isTypedArray(object);
          iteratee2 = getIteratee(iteratee2, 4);
          if (accumulator == null) {
            var Ctor = object && object.constructor;
            if (isArrLike) {
              accumulator = isArr ? new Ctor() : [];
            } else if (isObject(object)) {
              accumulator = isFunction(Ctor) ? baseCreate(getPrototype(object)) : {};
            } else {
              accumulator = {};
            }
          }
          (isArrLike ? arrayEach : baseForOwn)(object, function(value, index, object2) {
            return iteratee2(accumulator, value, index, object2);
          });
          return accumulator;
        }
        function unset(object, path3) {
          return object == null ? true : baseUnset(object, path3);
        }
        function update(object, path3, updater) {
          return object == null ? object : baseUpdate(object, path3, castFunction(updater));
        }
        function updateWith(object, path3, updater, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          return object == null ? object : baseUpdate(object, path3, castFunction(updater), customizer);
        }
        function values(object) {
          return object == null ? [] : baseValues(object, keys(object));
        }
        function valuesIn(object) {
          return object == null ? [] : baseValues(object, keysIn(object));
        }
        function clamp(number, lower, upper) {
          if (upper === undefined2) {
            upper = lower;
            lower = undefined2;
          }
          if (upper !== undefined2) {
            upper = toNumber(upper);
            upper = upper === upper ? upper : 0;
          }
          if (lower !== undefined2) {
            lower = toNumber(lower);
            lower = lower === lower ? lower : 0;
          }
          return baseClamp(toNumber(number), lower, upper);
        }
        function inRange(number, start, end) {
          start = toFinite(start);
          if (end === undefined2) {
            end = start;
            start = 0;
          } else {
            end = toFinite(end);
          }
          number = toNumber(number);
          return baseInRange(number, start, end);
        }
        function random(lower, upper, floating) {
          if (floating && typeof floating != "boolean" && isIterateeCall(lower, upper, floating)) {
            upper = floating = undefined2;
          }
          if (floating === undefined2) {
            if (typeof upper == "boolean") {
              floating = upper;
              upper = undefined2;
            } else if (typeof lower == "boolean") {
              floating = lower;
              lower = undefined2;
            }
          }
          if (lower === undefined2 && upper === undefined2) {
            lower = 0;
            upper = 1;
          } else {
            lower = toFinite(lower);
            if (upper === undefined2) {
              upper = lower;
              lower = 0;
            } else {
              upper = toFinite(upper);
            }
          }
          if (lower > upper) {
            var temp = lower;
            lower = upper;
            upper = temp;
          }
          if (floating || lower % 1 || upper % 1) {
            var rand = nativeRandom();
            return nativeMin(lower + rand * (upper - lower + freeParseFloat("1e-" + ((rand + "").length - 1))), upper);
          }
          return baseRandom(lower, upper);
        }
        var camelCase = createCompounder(function(result3, word, index) {
          word = word.toLowerCase();
          return result3 + (index ? capitalize(word) : word);
        });
        function capitalize(string) {
          return upperFirst(toString(string).toLowerCase());
        }
        function deburr(string) {
          string = toString(string);
          return string && string.replace(reLatin, deburrLetter).replace(reComboMark, "");
        }
        function endsWith(string, target, position) {
          string = toString(string);
          target = baseToString(target);
          var length = string.length;
          position = position === undefined2 ? length : baseClamp(toInteger(position), 0, length);
          var end = position;
          position -= target.length;
          return position >= 0 && string.slice(position, end) == target;
        }
        function escape2(string) {
          string = toString(string);
          return string && reHasUnescapedHtml.test(string) ? string.replace(reUnescapedHtml, escapeHtmlChar) : string;
        }
        function escapeRegExp(string) {
          string = toString(string);
          return string && reHasRegExpChar.test(string) ? string.replace(reRegExpChar, "\\$&") : string;
        }
        var kebabCase = createCompounder(function(result3, word, index) {
          return result3 + (index ? "-" : "") + word.toLowerCase();
        });
        var lowerCase = createCompounder(function(result3, word, index) {
          return result3 + (index ? " " : "") + word.toLowerCase();
        });
        var lowerFirst = createCaseFirst("toLowerCase");
        function pad(string, length, chars) {
          string = toString(string);
          length = toInteger(length);
          var strLength = length ? stringSize(string) : 0;
          if (!length || strLength >= length) {
            return string;
          }
          var mid = (length - strLength) / 2;
          return createPadding(nativeFloor(mid), chars) + string + createPadding(nativeCeil(mid), chars);
        }
        function padEnd(string, length, chars) {
          string = toString(string);
          length = toInteger(length);
          var strLength = length ? stringSize(string) : 0;
          return length && strLength < length ? string + createPadding(length - strLength, chars) : string;
        }
        function padStart(string, length, chars) {
          string = toString(string);
          length = toInteger(length);
          var strLength = length ? stringSize(string) : 0;
          return length && strLength < length ? createPadding(length - strLength, chars) + string : string;
        }
        function parseInt2(string, radix, guard) {
          if (guard || radix == null) {
            radix = 0;
          } else if (radix) {
            radix = +radix;
          }
          return nativeParseInt(toString(string).replace(reTrimStart, ""), radix || 0);
        }
        function repeat(string, n, guard) {
          if (guard ? isIterateeCall(string, n, guard) : n === undefined2) {
            n = 1;
          } else {
            n = toInteger(n);
          }
          return baseRepeat(toString(string), n);
        }
        function replace() {
          var args = arguments, string = toString(args[0]);
          return args.length < 3 ? string : string.replace(args[1], args[2]);
        }
        var snakeCase = createCompounder(function(result3, word, index) {
          return result3 + (index ? "_" : "") + word.toLowerCase();
        });
        function split(string, separator, limit) {
          if (limit && typeof limit != "number" && isIterateeCall(string, separator, limit)) {
            separator = limit = undefined2;
          }
          limit = limit === undefined2 ? MAX_ARRAY_LENGTH : limit >>> 0;
          if (!limit) {
            return [];
          }
          string = toString(string);
          if (string && (typeof separator == "string" || separator != null && !isRegExp(separator))) {
            separator = baseToString(separator);
            if (!separator && hasUnicode(string)) {
              return castSlice(stringToArray(string), 0, limit);
            }
          }
          return string.split(separator, limit);
        }
        var startCase = createCompounder(function(result3, word, index) {
          return result3 + (index ? " " : "") + upperFirst(word);
        });
        function startsWith(string, target, position) {
          string = toString(string);
          position = position == null ? 0 : baseClamp(toInteger(position), 0, string.length);
          target = baseToString(target);
          return string.slice(position, position + target.length) == target;
        }
        function template(string, options, guard) {
          var settings = lodash.templateSettings;
          if (guard && isIterateeCall(string, options, guard)) {
            options = undefined2;
          }
          string = toString(string);
          options = assignInWith({}, options, settings, customDefaultsAssignIn);
          var imports = assignInWith({}, options.imports, settings.imports, customDefaultsAssignIn), importsKeys = keys(imports), importsValues = baseValues(imports, importsKeys);
          var isEscaping, isEvaluating, index = 0, interpolate = options.interpolate || reNoMatch, source = "__p += '";
          var reDelimiters = RegExp2(
            (options.escape || reNoMatch).source + "|" + interpolate.source + "|" + (interpolate === reInterpolate ? reEsTemplate : reNoMatch).source + "|" + (options.evaluate || reNoMatch).source + "|$",
            "g"
          );
          var sourceURL = "//# sourceURL=" + (hasOwnProperty.call(options, "sourceURL") ? (options.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++templateCounter + "]") + "\n";
          string.replace(reDelimiters, function(match, escapeValue, interpolateValue, esTemplateValue, evaluateValue, offset) {
            interpolateValue || (interpolateValue = esTemplateValue);
            source += string.slice(index, offset).replace(reUnescapedString, escapeStringChar);
            if (escapeValue) {
              isEscaping = true;
              source += "' +\n__e(" + escapeValue + ") +\n'";
            }
            if (evaluateValue) {
              isEvaluating = true;
              source += "';\n" + evaluateValue + ";\n__p += '";
            }
            if (interpolateValue) {
              source += "' +\n((__t = (" + interpolateValue + ")) == null ? '' : __t) +\n'";
            }
            index = offset + match.length;
            return match;
          });
          source += "';\n";
          var variable = hasOwnProperty.call(options, "variable") && options.variable;
          if (!variable) {
            source = "with (obj) {\n" + source + "\n}\n";
          } else if (reForbiddenIdentifierChars.test(variable)) {
            throw new Error2(INVALID_TEMPL_VAR_ERROR_TEXT);
          }
          source = (isEvaluating ? source.replace(reEmptyStringLeading, "") : source).replace(reEmptyStringMiddle, "$1").replace(reEmptyStringTrailing, "$1;");
          source = "function(" + (variable || "obj") + ") {\n" + (variable ? "" : "obj || (obj = {});\n") + "var __t, __p = ''" + (isEscaping ? ", __e = _.escape" : "") + (isEvaluating ? ", __j = Array.prototype.join;\nfunction print() { __p += __j.call(arguments, '') }\n" : ";\n") + source + "return __p\n}";
          var result3 = attempt(function() {
            return Function2(importsKeys, sourceURL + "return " + source).apply(undefined2, importsValues);
          });
          result3.source = source;
          if (isError(result3)) {
            throw result3;
          }
          return result3;
        }
        function toLower(value) {
          return toString(value).toLowerCase();
        }
        function toUpper(value) {
          return toString(value).toUpperCase();
        }
        function trim(string, chars, guard) {
          string = toString(string);
          if (string && (guard || chars === undefined2)) {
            return baseTrim(string);
          }
          if (!string || !(chars = baseToString(chars))) {
            return string;
          }
          var strSymbols = stringToArray(string), chrSymbols = stringToArray(chars), start = charsStartIndex(strSymbols, chrSymbols), end = charsEndIndex(strSymbols, chrSymbols) + 1;
          return castSlice(strSymbols, start, end).join("");
        }
        function trimEnd(string, chars, guard) {
          string = toString(string);
          if (string && (guard || chars === undefined2)) {
            return string.slice(0, trimmedEndIndex(string) + 1);
          }
          if (!string || !(chars = baseToString(chars))) {
            return string;
          }
          var strSymbols = stringToArray(string), end = charsEndIndex(strSymbols, stringToArray(chars)) + 1;
          return castSlice(strSymbols, 0, end).join("");
        }
        function trimStart(string, chars, guard) {
          string = toString(string);
          if (string && (guard || chars === undefined2)) {
            return string.replace(reTrimStart, "");
          }
          if (!string || !(chars = baseToString(chars))) {
            return string;
          }
          var strSymbols = stringToArray(string), start = charsStartIndex(strSymbols, stringToArray(chars));
          return castSlice(strSymbols, start).join("");
        }
        function truncate(string, options) {
          var length = DEFAULT_TRUNC_LENGTH, omission = DEFAULT_TRUNC_OMISSION;
          if (isObject(options)) {
            var separator = "separator" in options ? options.separator : separator;
            length = "length" in options ? toInteger(options.length) : length;
            omission = "omission" in options ? baseToString(options.omission) : omission;
          }
          string = toString(string);
          var strLength = string.length;
          if (hasUnicode(string)) {
            var strSymbols = stringToArray(string);
            strLength = strSymbols.length;
          }
          if (length >= strLength) {
            return string;
          }
          var end = length - stringSize(omission);
          if (end < 1) {
            return omission;
          }
          var result3 = strSymbols ? castSlice(strSymbols, 0, end).join("") : string.slice(0, end);
          if (separator === undefined2) {
            return result3 + omission;
          }
          if (strSymbols) {
            end += result3.length - end;
          }
          if (isRegExp(separator)) {
            if (string.slice(end).search(separator)) {
              var match, substring = result3;
              if (!separator.global) {
                separator = RegExp2(separator.source, toString(reFlags.exec(separator)) + "g");
              }
              separator.lastIndex = 0;
              while (match = separator.exec(substring)) {
                var newEnd = match.index;
              }
              result3 = result3.slice(0, newEnd === undefined2 ? end : newEnd);
            }
          } else if (string.indexOf(baseToString(separator), end) != end) {
            var index = result3.lastIndexOf(separator);
            if (index > -1) {
              result3 = result3.slice(0, index);
            }
          }
          return result3 + omission;
        }
        function unescape2(string) {
          string = toString(string);
          return string && reHasEscapedHtml.test(string) ? string.replace(reEscapedHtml, unescapeHtmlChar) : string;
        }
        var upperCase = createCompounder(function(result3, word, index) {
          return result3 + (index ? " " : "") + word.toUpperCase();
        });
        var upperFirst = createCaseFirst("toUpperCase");
        function words(string, pattern, guard) {
          string = toString(string);
          pattern = guard ? undefined2 : pattern;
          if (pattern === undefined2) {
            return hasUnicodeWord(string) ? unicodeWords(string) : asciiWords(string);
          }
          return string.match(pattern) || [];
        }
        var attempt = baseRest(function(func, args) {
          try {
            return apply(func, undefined2, args);
          } catch (e) {
            return isError(e) ? e : new Error2(e);
          }
        });
        var bindAll = flatRest(function(object, methodNames) {
          arrayEach(methodNames, function(key) {
            key = toKey(key);
            baseAssignValue(object, key, bind(object[key], object));
          });
          return object;
        });
        function cond(pairs) {
          var length = pairs == null ? 0 : pairs.length, toIteratee = getIteratee();
          pairs = !length ? [] : arrayMap(pairs, function(pair) {
            if (typeof pair[1] != "function") {
              throw new TypeError2(FUNC_ERROR_TEXT);
            }
            return [toIteratee(pair[0]), pair[1]];
          });
          return baseRest(function(args) {
            var index = -1;
            while (++index < length) {
              var pair = pairs[index];
              if (apply(pair[0], this, args)) {
                return apply(pair[1], this, args);
              }
            }
          });
        }
        function conforms(source) {
          return baseConforms(baseClone(source, CLONE_DEEP_FLAG));
        }
        function constant(value) {
          return function() {
            return value;
          };
        }
        function defaultTo(value, defaultValue) {
          return value == null || value !== value ? defaultValue : value;
        }
        var flow = createFlow();
        var flowRight = createFlow(true);
        function identity(value) {
          return value;
        }
        function iteratee(func) {
          return baseIteratee(typeof func == "function" ? func : baseClone(func, CLONE_DEEP_FLAG));
        }
        function matches(source) {
          return baseMatches(baseClone(source, CLONE_DEEP_FLAG));
        }
        function matchesProperty(path3, srcValue) {
          return baseMatchesProperty(path3, baseClone(srcValue, CLONE_DEEP_FLAG));
        }
        var method = baseRest(function(path3, args) {
          return function(object) {
            return baseInvoke(object, path3, args);
          };
        });
        var methodOf = baseRest(function(object, args) {
          return function(path3) {
            return baseInvoke(object, path3, args);
          };
        });
        function mixin(object, source, options) {
          var props = keys(source), methodNames = baseFunctions(source, props);
          if (options == null && !(isObject(source) && (methodNames.length || !props.length))) {
            options = source;
            source = object;
            object = this;
            methodNames = baseFunctions(source, keys(source));
          }
          var chain2 = !(isObject(options) && "chain" in options) || !!options.chain, isFunc = isFunction(object);
          arrayEach(methodNames, function(methodName) {
            var func = source[methodName];
            object[methodName] = func;
            if (isFunc) {
              object.prototype[methodName] = function() {
                var chainAll = this.__chain__;
                if (chain2 || chainAll) {
                  var result3 = object(this.__wrapped__), actions = result3.__actions__ = copyArray(this.__actions__);
                  actions.push({ "func": func, "args": arguments, "thisArg": object });
                  result3.__chain__ = chainAll;
                  return result3;
                }
                return func.apply(object, arrayPush([this.value()], arguments));
              };
            }
          });
          return object;
        }
        function noConflict() {
          if (root._ === this) {
            root._ = oldDash;
          }
          return this;
        }
        function noop() {
        }
        function nthArg(n) {
          n = toInteger(n);
          return baseRest(function(args) {
            return baseNth(args, n);
          });
        }
        var over = createOver(arrayMap);
        var overEvery = createOver(arrayEvery);
        var overSome = createOver(arraySome);
        function property(path3) {
          return isKey(path3) ? baseProperty(toKey(path3)) : basePropertyDeep(path3);
        }
        function propertyOf(object) {
          return function(path3) {
            return object == null ? undefined2 : baseGet(object, path3);
          };
        }
        var range = createRange();
        var rangeRight = createRange(true);
        function stubArray() {
          return [];
        }
        function stubFalse() {
          return false;
        }
        function stubObject() {
          return {};
        }
        function stubString() {
          return "";
        }
        function stubTrue() {
          return true;
        }
        function times(n, iteratee2) {
          n = toInteger(n);
          if (n < 1 || n > MAX_SAFE_INTEGER) {
            return [];
          }
          var index = MAX_ARRAY_LENGTH, length = nativeMin(n, MAX_ARRAY_LENGTH);
          iteratee2 = getIteratee(iteratee2);
          n -= MAX_ARRAY_LENGTH;
          var result3 = baseTimes(length, iteratee2);
          while (++index < n) {
            iteratee2(index);
          }
          return result3;
        }
        function toPath(value) {
          if (isArray(value)) {
            return arrayMap(value, toKey);
          }
          return isSymbol(value) ? [value] : copyArray(stringToPath(toString(value)));
        }
        function uniqueId(prefix) {
          var id = ++idCounter;
          return toString(prefix) + id;
        }
        var add = createMathOperation(function(augend, addend) {
          return augend + addend;
        }, 0);
        var ceil = createRound("ceil");
        var divide = createMathOperation(function(dividend, divisor) {
          return dividend / divisor;
        }, 1);
        var floor = createRound("floor");
        function max(array) {
          return array && array.length ? baseExtremum(array, identity, baseGt) : undefined2;
        }
        function maxBy(array, iteratee2) {
          return array && array.length ? baseExtremum(array, getIteratee(iteratee2, 2), baseGt) : undefined2;
        }
        function mean(array) {
          return baseMean(array, identity);
        }
        function meanBy(array, iteratee2) {
          return baseMean(array, getIteratee(iteratee2, 2));
        }
        function min(array) {
          return array && array.length ? baseExtremum(array, identity, baseLt) : undefined2;
        }
        function minBy(array, iteratee2) {
          return array && array.length ? baseExtremum(array, getIteratee(iteratee2, 2), baseLt) : undefined2;
        }
        var multiply = createMathOperation(function(multiplier, multiplicand) {
          return multiplier * multiplicand;
        }, 1);
        var round = createRound("round");
        var subtract = createMathOperation(function(minuend, subtrahend) {
          return minuend - subtrahend;
        }, 0);
        function sum(array) {
          return array && array.length ? baseSum(array, identity) : 0;
        }
        function sumBy(array, iteratee2) {
          return array && array.length ? baseSum(array, getIteratee(iteratee2, 2)) : 0;
        }
        lodash.after = after;
        lodash.ary = ary;
        lodash.assign = assign;
        lodash.assignIn = assignIn;
        lodash.assignInWith = assignInWith;
        lodash.assignWith = assignWith;
        lodash.at = at;
        lodash.before = before;
        lodash.bind = bind;
        lodash.bindAll = bindAll;
        lodash.bindKey = bindKey;
        lodash.castArray = castArray;
        lodash.chain = chain;
        lodash.chunk = chunk;
        lodash.compact = compact;
        lodash.concat = concat;
        lodash.cond = cond;
        lodash.conforms = conforms;
        lodash.constant = constant;
        lodash.countBy = countBy;
        lodash.create = create;
        lodash.curry = curry;
        lodash.curryRight = curryRight;
        lodash.debounce = debounce;
        lodash.defaults = defaults;
        lodash.defaultsDeep = defaultsDeep;
        lodash.defer = defer;
        lodash.delay = delay;
        lodash.difference = difference;
        lodash.differenceBy = differenceBy;
        lodash.differenceWith = differenceWith;
        lodash.drop = drop;
        lodash.dropRight = dropRight;
        lodash.dropRightWhile = dropRightWhile;
        lodash.dropWhile = dropWhile;
        lodash.fill = fill;
        lodash.filter = filter;
        lodash.flatMap = flatMap;
        lodash.flatMapDeep = flatMapDeep;
        lodash.flatMapDepth = flatMapDepth;
        lodash.flatten = flatten;
        lodash.flattenDeep = flattenDeep;
        lodash.flattenDepth = flattenDepth;
        lodash.flip = flip;
        lodash.flow = flow;
        lodash.flowRight = flowRight;
        lodash.fromPairs = fromPairs;
        lodash.functions = functions;
        lodash.functionsIn = functionsIn;
        lodash.groupBy = groupBy;
        lodash.initial = initial;
        lodash.intersection = intersection;
        lodash.intersectionBy = intersectionBy;
        lodash.intersectionWith = intersectionWith;
        lodash.invert = invert;
        lodash.invertBy = invertBy;
        lodash.invokeMap = invokeMap;
        lodash.iteratee = iteratee;
        lodash.keyBy = keyBy;
        lodash.keys = keys;
        lodash.keysIn = keysIn;
        lodash.map = map;
        lodash.mapKeys = mapKeys;
        lodash.mapValues = mapValues;
        lodash.matches = matches;
        lodash.matchesProperty = matchesProperty;
        lodash.memoize = memoize;
        lodash.merge = merge;
        lodash.mergeWith = mergeWith;
        lodash.method = method;
        lodash.methodOf = methodOf;
        lodash.mixin = mixin;
        lodash.negate = negate;
        lodash.nthArg = nthArg;
        lodash.omit = omit;
        lodash.omitBy = omitBy;
        lodash.once = once;
        lodash.orderBy = orderBy;
        lodash.over = over;
        lodash.overArgs = overArgs;
        lodash.overEvery = overEvery;
        lodash.overSome = overSome;
        lodash.partial = partial;
        lodash.partialRight = partialRight;
        lodash.partition = partition;
        lodash.pick = pick;
        lodash.pickBy = pickBy;
        lodash.property = property;
        lodash.propertyOf = propertyOf;
        lodash.pull = pull;
        lodash.pullAll = pullAll;
        lodash.pullAllBy = pullAllBy;
        lodash.pullAllWith = pullAllWith;
        lodash.pullAt = pullAt;
        lodash.range = range;
        lodash.rangeRight = rangeRight;
        lodash.rearg = rearg;
        lodash.reject = reject;
        lodash.remove = remove;
        lodash.rest = rest;
        lodash.reverse = reverse;
        lodash.sampleSize = sampleSize;
        lodash.set = set;
        lodash.setWith = setWith;
        lodash.shuffle = shuffle;
        lodash.slice = slice;
        lodash.sortBy = sortBy;
        lodash.sortedUniq = sortedUniq;
        lodash.sortedUniqBy = sortedUniqBy;
        lodash.split = split;
        lodash.spread = spread;
        lodash.tail = tail;
        lodash.take = take;
        lodash.takeRight = takeRight;
        lodash.takeRightWhile = takeRightWhile;
        lodash.takeWhile = takeWhile;
        lodash.tap = tap;
        lodash.throttle = throttle;
        lodash.thru = thru;
        lodash.toArray = toArray;
        lodash.toPairs = toPairs;
        lodash.toPairsIn = toPairsIn;
        lodash.toPath = toPath;
        lodash.toPlainObject = toPlainObject;
        lodash.transform = transform;
        lodash.unary = unary;
        lodash.union = union;
        lodash.unionBy = unionBy;
        lodash.unionWith = unionWith;
        lodash.uniq = uniq;
        lodash.uniqBy = uniqBy;
        lodash.uniqWith = uniqWith;
        lodash.unset = unset;
        lodash.unzip = unzip;
        lodash.unzipWith = unzipWith;
        lodash.update = update;
        lodash.updateWith = updateWith;
        lodash.values = values;
        lodash.valuesIn = valuesIn;
        lodash.without = without;
        lodash.words = words;
        lodash.wrap = wrap;
        lodash.xor = xor;
        lodash.xorBy = xorBy;
        lodash.xorWith = xorWith;
        lodash.zip = zip;
        lodash.zipObject = zipObject;
        lodash.zipObjectDeep = zipObjectDeep;
        lodash.zipWith = zipWith;
        lodash.entries = toPairs;
        lodash.entriesIn = toPairsIn;
        lodash.extend = assignIn;
        lodash.extendWith = assignInWith;
        mixin(lodash, lodash);
        lodash.add = add;
        lodash.attempt = attempt;
        lodash.camelCase = camelCase;
        lodash.capitalize = capitalize;
        lodash.ceil = ceil;
        lodash.clamp = clamp;
        lodash.clone = clone;
        lodash.cloneDeep = cloneDeep;
        lodash.cloneDeepWith = cloneDeepWith;
        lodash.cloneWith = cloneWith;
        lodash.conformsTo = conformsTo;
        lodash.deburr = deburr;
        lodash.defaultTo = defaultTo;
        lodash.divide = divide;
        lodash.endsWith = endsWith;
        lodash.eq = eq;
        lodash.escape = escape2;
        lodash.escapeRegExp = escapeRegExp;
        lodash.every = every;
        lodash.find = find;
        lodash.findIndex = findIndex;
        lodash.findKey = findKey;
        lodash.findLast = findLast;
        lodash.findLastIndex = findLastIndex;
        lodash.findLastKey = findLastKey;
        lodash.floor = floor;
        lodash.forEach = forEach;
        lodash.forEachRight = forEachRight;
        lodash.forIn = forIn;
        lodash.forInRight = forInRight;
        lodash.forOwn = forOwn;
        lodash.forOwnRight = forOwnRight;
        lodash.get = get;
        lodash.gt = gt;
        lodash.gte = gte;
        lodash.has = has;
        lodash.hasIn = hasIn;
        lodash.head = head;
        lodash.identity = identity;
        lodash.includes = includes;
        lodash.indexOf = indexOf;
        lodash.inRange = inRange;
        lodash.invoke = invoke;
        lodash.isArguments = isArguments;
        lodash.isArray = isArray;
        lodash.isArrayBuffer = isArrayBuffer;
        lodash.isArrayLike = isArrayLike;
        lodash.isArrayLikeObject = isArrayLikeObject;
        lodash.isBoolean = isBoolean;
        lodash.isBuffer = isBuffer;
        lodash.isDate = isDate;
        lodash.isElement = isElement;
        lodash.isEmpty = isEmpty;
        lodash.isEqual = isEqual;
        lodash.isEqualWith = isEqualWith;
        lodash.isError = isError;
        lodash.isFinite = isFinite2;
        lodash.isFunction = isFunction;
        lodash.isInteger = isInteger;
        lodash.isLength = isLength;
        lodash.isMap = isMap;
        lodash.isMatch = isMatch;
        lodash.isMatchWith = isMatchWith;
        lodash.isNaN = isNaN2;
        lodash.isNative = isNative;
        lodash.isNil = isNil;
        lodash.isNull = isNull;
        lodash.isNumber = isNumber;
        lodash.isObject = isObject;
        lodash.isObjectLike = isObjectLike;
        lodash.isPlainObject = isPlainObject;
        lodash.isRegExp = isRegExp;
        lodash.isSafeInteger = isSafeInteger;
        lodash.isSet = isSet;
        lodash.isString = isString;
        lodash.isSymbol = isSymbol;
        lodash.isTypedArray = isTypedArray;
        lodash.isUndefined = isUndefined;
        lodash.isWeakMap = isWeakMap;
        lodash.isWeakSet = isWeakSet;
        lodash.join = join2;
        lodash.kebabCase = kebabCase;
        lodash.last = last;
        lodash.lastIndexOf = lastIndexOf;
        lodash.lowerCase = lowerCase;
        lodash.lowerFirst = lowerFirst;
        lodash.lt = lt;
        lodash.lte = lte;
        lodash.max = max;
        lodash.maxBy = maxBy;
        lodash.mean = mean;
        lodash.meanBy = meanBy;
        lodash.min = min;
        lodash.minBy = minBy;
        lodash.stubArray = stubArray;
        lodash.stubFalse = stubFalse;
        lodash.stubObject = stubObject;
        lodash.stubString = stubString;
        lodash.stubTrue = stubTrue;
        lodash.multiply = multiply;
        lodash.nth = nth;
        lodash.noConflict = noConflict;
        lodash.noop = noop;
        lodash.now = now;
        lodash.pad = pad;
        lodash.padEnd = padEnd;
        lodash.padStart = padStart;
        lodash.parseInt = parseInt2;
        lodash.random = random;
        lodash.reduce = reduce;
        lodash.reduceRight = reduceRight;
        lodash.repeat = repeat;
        lodash.replace = replace;
        lodash.result = result2;
        lodash.round = round;
        lodash.runInContext = runInContext2;
        lodash.sample = sample;
        lodash.size = size;
        lodash.snakeCase = snakeCase;
        lodash.some = some;
        lodash.sortedIndex = sortedIndex;
        lodash.sortedIndexBy = sortedIndexBy;
        lodash.sortedIndexOf = sortedIndexOf;
        lodash.sortedLastIndex = sortedLastIndex;
        lodash.sortedLastIndexBy = sortedLastIndexBy;
        lodash.sortedLastIndexOf = sortedLastIndexOf;
        lodash.startCase = startCase;
        lodash.startsWith = startsWith;
        lodash.subtract = subtract;
        lodash.sum = sum;
        lodash.sumBy = sumBy;
        lodash.template = template;
        lodash.times = times;
        lodash.toFinite = toFinite;
        lodash.toInteger = toInteger;
        lodash.toLength = toLength;
        lodash.toLower = toLower;
        lodash.toNumber = toNumber;
        lodash.toSafeInteger = toSafeInteger;
        lodash.toString = toString;
        lodash.toUpper = toUpper;
        lodash.trim = trim;
        lodash.trimEnd = trimEnd;
        lodash.trimStart = trimStart;
        lodash.truncate = truncate;
        lodash.unescape = unescape2;
        lodash.uniqueId = uniqueId;
        lodash.upperCase = upperCase;
        lodash.upperFirst = upperFirst;
        lodash.each = forEach;
        lodash.eachRight = forEachRight;
        lodash.first = head;
        mixin(lodash, function() {
          var source = {};
          baseForOwn(lodash, function(func, methodName) {
            if (!hasOwnProperty.call(lodash.prototype, methodName)) {
              source[methodName] = func;
            }
          });
          return source;
        }(), { "chain": false });
        lodash.VERSION = VERSION2;
        arrayEach(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(methodName) {
          lodash[methodName].placeholder = lodash;
        });
        arrayEach(["drop", "take"], function(methodName, index) {
          LazyWrapper.prototype[methodName] = function(n) {
            n = n === undefined2 ? 1 : nativeMax(toInteger(n), 0);
            var result3 = this.__filtered__ && !index ? new LazyWrapper(this) : this.clone();
            if (result3.__filtered__) {
              result3.__takeCount__ = nativeMin(n, result3.__takeCount__);
            } else {
              result3.__views__.push({
                "size": nativeMin(n, MAX_ARRAY_LENGTH),
                "type": methodName + (result3.__dir__ < 0 ? "Right" : "")
              });
            }
            return result3;
          };
          LazyWrapper.prototype[methodName + "Right"] = function(n) {
            return this.reverse()[methodName](n).reverse();
          };
        });
        arrayEach(["filter", "map", "takeWhile"], function(methodName, index) {
          var type = index + 1, isFilter = type == LAZY_FILTER_FLAG || type == LAZY_WHILE_FLAG;
          LazyWrapper.prototype[methodName] = function(iteratee2) {
            var result3 = this.clone();
            result3.__iteratees__.push({
              "iteratee": getIteratee(iteratee2, 3),
              "type": type
            });
            result3.__filtered__ = result3.__filtered__ || isFilter;
            return result3;
          };
        });
        arrayEach(["head", "last"], function(methodName, index) {
          var takeName = "take" + (index ? "Right" : "");
          LazyWrapper.prototype[methodName] = function() {
            return this[takeName](1).value()[0];
          };
        });
        arrayEach(["initial", "tail"], function(methodName, index) {
          var dropName = "drop" + (index ? "" : "Right");
          LazyWrapper.prototype[methodName] = function() {
            return this.__filtered__ ? new LazyWrapper(this) : this[dropName](1);
          };
        });
        LazyWrapper.prototype.compact = function() {
          return this.filter(identity);
        };
        LazyWrapper.prototype.find = function(predicate) {
          return this.filter(predicate).head();
        };
        LazyWrapper.prototype.findLast = function(predicate) {
          return this.reverse().find(predicate);
        };
        LazyWrapper.prototype.invokeMap = baseRest(function(path3, args) {
          if (typeof path3 == "function") {
            return new LazyWrapper(this);
          }
          return this.map(function(value) {
            return baseInvoke(value, path3, args);
          });
        });
        LazyWrapper.prototype.reject = function(predicate) {
          return this.filter(negate(getIteratee(predicate)));
        };
        LazyWrapper.prototype.slice = function(start, end) {
          start = toInteger(start);
          var result3 = this;
          if (result3.__filtered__ && (start > 0 || end < 0)) {
            return new LazyWrapper(result3);
          }
          if (start < 0) {
            result3 = result3.takeRight(-start);
          } else if (start) {
            result3 = result3.drop(start);
          }
          if (end !== undefined2) {
            end = toInteger(end);
            result3 = end < 0 ? result3.dropRight(-end) : result3.take(end - start);
          }
          return result3;
        };
        LazyWrapper.prototype.takeRightWhile = function(predicate) {
          return this.reverse().takeWhile(predicate).reverse();
        };
        LazyWrapper.prototype.toArray = function() {
          return this.take(MAX_ARRAY_LENGTH);
        };
        baseForOwn(LazyWrapper.prototype, function(func, methodName) {
          var checkIteratee = /^(?:filter|find|map|reject)|While$/.test(methodName), isTaker = /^(?:head|last)$/.test(methodName), lodashFunc = lodash[isTaker ? "take" + (methodName == "last" ? "Right" : "") : methodName], retUnwrapped = isTaker || /^find/.test(methodName);
          if (!lodashFunc) {
            return;
          }
          lodash.prototype[methodName] = function() {
            var value = this.__wrapped__, args = isTaker ? [1] : arguments, isLazy = value instanceof LazyWrapper, iteratee2 = args[0], useLazy = isLazy || isArray(value);
            var interceptor = function(value2) {
              var result4 = lodashFunc.apply(lodash, arrayPush([value2], args));
              return isTaker && chainAll ? result4[0] : result4;
            };
            if (useLazy && checkIteratee && typeof iteratee2 == "function" && iteratee2.length != 1) {
              isLazy = useLazy = false;
            }
            var chainAll = this.__chain__, isHybrid = !!this.__actions__.length, isUnwrapped = retUnwrapped && !chainAll, onlyLazy = isLazy && !isHybrid;
            if (!retUnwrapped && useLazy) {
              value = onlyLazy ? value : new LazyWrapper(this);
              var result3 = func.apply(value, args);
              result3.__actions__.push({ "func": thru, "args": [interceptor], "thisArg": undefined2 });
              return new LodashWrapper(result3, chainAll);
            }
            if (isUnwrapped && onlyLazy) {
              return func.apply(this, args);
            }
            result3 = this.thru(interceptor);
            return isUnwrapped ? isTaker ? result3.value()[0] : result3.value() : result3;
          };
        });
        arrayEach(["pop", "push", "shift", "sort", "splice", "unshift"], function(methodName) {
          var func = arrayProto[methodName], chainName = /^(?:push|sort|unshift)$/.test(methodName) ? "tap" : "thru", retUnwrapped = /^(?:pop|shift)$/.test(methodName);
          lodash.prototype[methodName] = function() {
            var args = arguments;
            if (retUnwrapped && !this.__chain__) {
              var value = this.value();
              return func.apply(isArray(value) ? value : [], args);
            }
            return this[chainName](function(value2) {
              return func.apply(isArray(value2) ? value2 : [], args);
            });
          };
        });
        baseForOwn(LazyWrapper.prototype, function(func, methodName) {
          var lodashFunc = lodash[methodName];
          if (lodashFunc) {
            var key = lodashFunc.name + "";
            if (!hasOwnProperty.call(realNames, key)) {
              realNames[key] = [];
            }
            realNames[key].push({ "name": methodName, "func": lodashFunc });
          }
        });
        realNames[createHybrid(undefined2, WRAP_BIND_KEY_FLAG).name] = [{
          "name": "wrapper",
          "func": undefined2
        }];
        LazyWrapper.prototype.clone = lazyClone;
        LazyWrapper.prototype.reverse = lazyReverse;
        LazyWrapper.prototype.value = lazyValue;
        lodash.prototype.at = wrapperAt;
        lodash.prototype.chain = wrapperChain;
        lodash.prototype.commit = wrapperCommit;
        lodash.prototype.next = wrapperNext;
        lodash.prototype.plant = wrapperPlant;
        lodash.prototype.reverse = wrapperReverse;
        lodash.prototype.toJSON = lodash.prototype.valueOf = lodash.prototype.value = wrapperValue;
        lodash.prototype.first = lodash.prototype.head;
        if (symIterator) {
          lodash.prototype[symIterator] = wrapperToIterator;
        }
        return lodash;
      };
      var _ = runInContext();
      if (typeof define == "function" && typeof define.amd == "object" && define.amd) {
        root._ = _;
        define(function() {
          return _;
        });
      } else if (freeModule) {
        (freeModule.exports = _)._ = _;
        freeExports._ = _;
      } else {
        root._ = _;
      }
    }).call(exports2);
  }
});

// node_modules/node-opcua-address-space/dist/src/reference_impl.js
var require_reference_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/reference_impl.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ReferenceImpl = exports2.resolveReferenceType = exports2.resolveReferenceNode = exports2.isNodeIdString = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_utils_1 = require_dist16();
    function isNodeIdString(str) {
      (0, node_opcua_assert_1.assert)(typeof str === "string");
      return str.substring(0, 2) === "i=" || str.substring(0, 3) === "ns=";
    }
    exports2.isNodeIdString = isNodeIdString;
    function is_valid_reference(ref) {
      const hasRequestedProperties = Object.prototype.hasOwnProperty.call(ref, "referenceType") && Object.prototype.hasOwnProperty.call(ref, "nodeId") && !(0, node_opcua_utils_1.isNullOrUndefined)(ref.isForward);
      if (!hasRequestedProperties) {
        return false;
      }
      (0, node_opcua_assert_1.assert)(ref.referenceType instanceof node_opcua_nodeid_1.NodeId);
      (0, node_opcua_assert_1.assert)(!ref.node || (0, node_opcua_nodeid_1.sameNodeId)(ref.node.nodeId, ref.nodeId));
      return true;
    }
    function _arrow(text2, length, isForward) {
      length = Math.max(length, text2.length + 8);
      const nb = Math.floor((length - text2.length - 2) / 2);
      const h = Array(nb).join("-");
      const extra = text2.length % 2 === 1 ? "-" : "";
      if (isForward) {
        return extra + h + " " + text2 + " " + h + "> ";
      }
      return "<" + h + " " + text2 + " " + h + extra + " ";
    }
    function _w(str, width) {
      return str.padEnd(width).substring(0, width);
    }
    function _localCoerceToNodeID(nodeIdLike) {
      if (Object.prototype.hasOwnProperty.call(nodeIdLike, "nodeId")) {
        return nodeIdLike.nodeId;
      }
      return (0, node_opcua_nodeid_1.coerceNodeId)(nodeIdLike);
    }
    function resolveReferenceNode(addressSpace, reference) {
      const _reference = reference;
      if (!_reference.node) {
        _reference.node = addressSpace.findNode(reference.nodeId);
      }
      return _reference.node;
    }
    exports2.resolveReferenceNode = resolveReferenceNode;
    function resolveReferenceType(addressSpace, reference) {
      const _reference = reference;
      if (!_reference._referenceType) {
        if (!_reference.referenceType) {
          errorLog(chalk_1.default.red("ERROR MISSING reference"), reference);
        }
        _reference._referenceType = addressSpace.findReferenceType(reference.referenceType);
      }
      return _reference._referenceType;
    }
    exports2.resolveReferenceType = resolveReferenceType;
    var ReferenceImpl = class {
      static resolveReferenceNode(addressSpace, reference) {
        return resolveReferenceNode(addressSpace, reference);
      }
      static resolveReferenceType(addressSpace, reference) {
        return resolveReferenceType(addressSpace, reference);
      }
      constructor(options) {
        (0, node_opcua_assert_1.assert)(options.referenceType instanceof node_opcua_nodeid_1.NodeId);
        (0, node_opcua_assert_1.assert)(options.nodeId instanceof node_opcua_nodeid_1.NodeId);
        this.referenceType = (0, node_opcua_nodeid_1.coerceNodeId)(options.referenceType);
        this.isForward = options.isForward === void 0 ? true : !!options.isForward;
        this.nodeId = _localCoerceToNodeID(options.nodeId);
        this._referenceType = options._referenceType;
        this.node = options.node;
        (0, node_opcua_assert_1.assert)(is_valid_reference(this));
      }
      /**
       * turn reference into a arrow :   ---- ReferenceType --> [NodeId]
       * @method toString
       * @return {String}
       */
      toString(options) {
        let infoNode = _w(this.nodeId.toString(), 24);
        let refType = this.referenceType.toString();
        if (options && options.addressSpace) {
          const node = options.addressSpace.findNode(this.nodeId);
          infoNode = "[" + infoNode + "]" + _w(node?.browseName.toString(), 40);
          const ref = options.addressSpace.findReferenceType(this.referenceType);
          const refNode = options.addressSpace.findNode(ref.nodeId);
          refType = refNode.browseName.toString() + " (" + ref.nodeId.toString() + ")";
        }
        return _arrow(refType, 40, this.isForward) + infoNode;
      }
      /**
       * @internal
       */
      get hash() {
        if (!this.__hash) {
          this.__hash = (this.isForward ? "" : "!") + this.referenceType.toString() + "-" + this.nodeId.toString();
        }
        return this.__hash;
      }
      /**
       * @internal
       */
      dispose() {
        this.__hash = void 0;
        this.node = void 0;
      }
    };
    exports2.ReferenceImpl = ReferenceImpl;
    function errorLog(arg0, reference) {
      throw new Error("Function not implemented.");
    }
  }
});

// node_modules/node-opcua-address-space/dist/source/helpers/dump_tools.js
var require_dump_tools = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/helpers/dump_tools.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.dumpReferences = exports2.dumpBrowseDescription = exports2.dumpReferenceDescriptions = exports2.dumpReferenceDescription = exports2.referenceTypeToString = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_types_1 = require_dist32();
    var reference_impl_1 = require_reference_impl();
    function referenceTypeToString(addressSpace, referenceTypeId) {
      if (!referenceTypeId) {
        return "<null> ";
      } else {
        const referenceType = addressSpace.findNode(referenceTypeId);
        return referenceTypeId.toString() + " " + referenceType.browseName.toString() + "/" + referenceType.inverseName.text;
      }
    }
    exports2.referenceTypeToString = referenceTypeToString;
    function nodeIdInfo(addressSpace, nodeId) {
      const obj = addressSpace.findNode(nodeId);
      const name = obj ? obj.browseName.toString() : " <????>";
      return nodeId.toString() + " [ " + name + " ]";
    }
    function dumpReferenceDescription(addressSpace, referenceDescription) {
      (0, node_opcua_assert_1.assert)(referenceDescription.referenceTypeId);
      console.log(chalk_1.default.red("referenceDescription"));
      console.log("    referenceTypeId : ", referenceTypeToString(addressSpace, referenceDescription.referenceTypeId));
      console.log("    isForward       : ", referenceDescription.isForward ? "true" : "false");
      console.log("    nodeId          : ", nodeIdInfo(addressSpace, referenceDescription.nodeId));
      console.log("    browseName      : ", referenceDescription.browseName.toString());
      console.log("    nodeClass       : ", referenceDescription.nodeClass.toString());
      console.log("    typeDefinition  : ", nodeIdInfo(addressSpace, referenceDescription.typeDefinition));
    }
    exports2.dumpReferenceDescription = dumpReferenceDescription;
    function dumpReferenceDescriptions(addressSpace, referenceDescriptions) {
      referenceDescriptions.forEach((r) => dumpReferenceDescription(addressSpace, r));
    }
    exports2.dumpReferenceDescriptions = dumpReferenceDescriptions;
    function dumpBrowseDescription(node, _browseDescription) {
      const browseDescription = new node_opcua_types_1.BrowseDescription(_browseDescription);
      const addressSpace = node.addressSpace;
      console.log(" Browse Node :");
      if (browseDescription.nodeId) {
        console.log(" nodeId : ", chalk_1.default.cyan(browseDescription.nodeId.toString()));
      }
      console.log(" nodeId : ", chalk_1.default.cyan(node.browseName.toString()), "(", node.nodeId.toString(), ")");
      console.log("   referenceTypeId :", referenceTypeToString(addressSpace, browseDescription.referenceTypeId));
      console.log("   browseDirection :", chalk_1.default.cyan(node_opcua_data_model_1.BrowseDirection[browseDescription.browseDirection]));
      console.log("   includeSubType  :", browseDescription.includeSubtypes ? "true" : "false");
      console.log("   nodeClassMask   :", browseDescription.nodeClassMask);
      console.log("   resultMask      :", browseDescription.resultMask);
    }
    exports2.dumpBrowseDescription = dumpBrowseDescription;
    function dumpReferences(addressSpace, references) {
      (0, node_opcua_assert_1.assert)(addressSpace);
      for (const reference of references) {
        const referenceType = (0, reference_impl_1.resolveReferenceType)(addressSpace, reference);
        if (!referenceType) {
          return;
        }
        const dir = reference.isForward ? "(=>)" : "(<-)";
        const objectName = nodeIdInfo(addressSpace, reference.nodeId);
        console.log(" referenceType : ", dir, referenceType ? referenceType.browseName.toString() : reference.referenceType.toString(), " ", objectName);
      }
    }
    exports2.dumpReferences = dumpReferences;
  }
});

// node_modules/node-opcua-address-space/dist/src/address_space_change_event_tools.js
var require_address_space_change_event_tools = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/address_space_change_event_tools.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2._handle_delete_node_model_change_event = exports2._handle_model_change_event = exports2._handle_add_reference_change_event = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_enum_1 = require_dist25();
    var node_opcua_types_1 = require_dist32();
    var verbFlags = new node_opcua_enum_1.Enum({
      //                         NodeAdded        0         Indicates the affected Node has been added.
      NodeAdded: 1,
      //                         NodeDeleted      1         Indicates the affected Node has been deleted.
      NodeDeleted: 2,
      //                         ReferenceAdded   2         Indicates a Reference has been added. The affected Node may
      ReferenceAdded: 4,
      //                                                    be either a SourceNode or TargetNode. Note that an added
      //                                                    bidirectional Reference is reflected by two ChangeStructures.
      //                         ReferenceDeleted 3         Indicates a Reference has been deleted. The affected Node may
      //                                                    be either a SourceNode or TargetNode. Note that a deleted
      //                                                    bidirectional Reference is reflected by two ChangeStructures.
      ReferenceDeleted: 8,
      //                         DataTypeChanged  4         This verb may be used only for affected Nodes that are
      //                                                    Variables or VariableTypes. It indicates that the DataType
      //                                                    Attribute has changed.
      DataTypeChanged: 16
    });
    function makeVerb(verbs) {
      const e = verbFlags.get(verbs);
      (0, node_opcua_assert_1.assert)(e !== null);
      return e.value;
    }
    function _handle_add_reference_change_event(node1, node2id) {
      const addressSpace = node1.addressSpace;
      const node2 = addressSpace.findNode(node2id);
      if (node1.nodeVersion || node2 && node2.nodeVersion) {
        addressSpace.modelChangeTransaction(() => {
          function _getTypeDef(node) {
            if (node.nodeClass === node_opcua_data_model_1.NodeClass.Object || node.nodeClass === node_opcua_data_model_1.NodeClass.Variable) {
              return node.typeDefinitionObj.nodeId;
            }
            return null;
          }
          let modelChangeTgt = new node_opcua_types_1.ModelChangeStructureDataType({
            affected: node1.nodeId,
            affectedType: _getTypeDef(node1),
            verb: makeVerb("ReferenceAdded")
          });
          addressSpace._collectModelChange(null, modelChangeTgt);
          modelChangeTgt = new node_opcua_types_1.ModelChangeStructureDataType({
            affected: node2.nodeId,
            affectedType: _getTypeDef(node2),
            verb: makeVerb("ReferenceAdded")
          });
          addressSpace._collectModelChange(null, modelChangeTgt);
        });
      }
    }
    exports2._handle_add_reference_change_event = _handle_add_reference_change_event;
    try {
      node_opcua_types_1.ModelChangeStructureDataType.prototype.toString = function(options) {
        if (!options) {
          return "";
        }
        const addressSpace = options.addressSpace;
        function n(nodeId) {
          if (!nodeId || nodeId.isEmpty()) {
            return "";
          }
          const node = addressSpace.findNode(nodeId);
          return '"' + nodeId.toString() + '"' + chalk_1.default.yellow(" /* " + (node ? node.browseName.toString() : "???") + " */");
        }
        let str = "{ verb:" + verbFlags.get(this.verb).key + ",";
        str += " affected: " + n(this.affected) + ",";
        str += " type: " + n(this.affectedType) + " }";
        return str;
      };
    } catch (err) {
    }
    function _handle_model_change_event(node) {
      const addressSpace = node.addressSpace;
      const parents = node.parent ? [node.parent] : [];
      const containingFolders = node.findReferencesExAsObject("Organizes", node_opcua_data_model_1.BrowseDirection.Inverse);
      let typeDefinitionNodeId = null;
      if (node.nodeClass === node_opcua_data_model_1.NodeClass.Object || node.nodeClass === node_opcua_data_model_1.NodeClass.Variable) {
        typeDefinitionNodeId = node.typeDefinitionObj.nodeId;
      }
      for (const parent of [...parents, ...containingFolders]) {
        if (parent && parent.nodeVersion) {
          addressSpace.modelChangeTransaction(() => {
            const modelChange1 = new node_opcua_types_1.ModelChangeStructureDataType({
              affected: node.nodeId,
              affectedType: typeDefinitionNodeId,
              verb: makeVerb("NodeAdded")
            });
            addressSpace._collectModelChange(null, modelChange1);
            const modelChangeSrc = new node_opcua_types_1.ModelChangeStructureDataType({
              affected: parent.nodeId,
              affectedType: null,
              verb: makeVerb("ReferenceAdded")
            });
            addressSpace._collectModelChange(null, modelChangeSrc);
            if (node.nodeVersion) {
              const modelChangeTgt = new node_opcua_types_1.ModelChangeStructureDataType({
                affected: node.nodeId,
                affectedType: typeDefinitionNodeId,
                verb: makeVerb("ReferenceAdded")
              });
              addressSpace._collectModelChange(null, modelChangeTgt);
            }
          });
        }
      }
    }
    exports2._handle_model_change_event = _handle_model_change_event;
    function _handle_delete_node_model_change_event(node) {
      const addressSpace = node.addressSpace;
      const references = node.findReferencesEx("HierarchicalReferences", node_opcua_data_model_1.BrowseDirection.Inverse);
      const parentNodes = references.map((r) => {
        return addressSpace.findNode(r.nodeId);
      });
      const versionableNodes = parentNodes.filter((n) => !!n?.nodeVersion);
      if (versionableNodes.length >= 1 || !!node.nodeVersion) {
        addressSpace.modelChangeTransaction(() => {
          for (const r of references) {
            const target = addressSpace.findNode(r.nodeId);
            const modelChangeSrc_l = new node_opcua_types_1.ModelChangeStructureDataType({
              affected: target.nodeId,
              affectedType: null,
              verb: makeVerb("ReferenceDeleted")
            });
            addressSpace._collectModelChange(null, modelChangeSrc_l);
          }
          const modelChangeSrc = new node_opcua_types_1.ModelChangeStructureDataType({
            affected: node.nodeId,
            affectedType: node.typeDefinition,
            verb: makeVerb("NodeDeleted")
          });
          addressSpace._collectModelChange(null, modelChangeSrc);
        });
      }
    }
    exports2._handle_delete_node_model_change_event = _handle_delete_node_model_change_event;
  }
});

// node_modules/node-opcua-address-space/dist/src/namespace_private.js
var require_namespace_private = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/namespace_private.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UANamespace_process_modelling_rule = void 0;
    var node_opcua_assert_1 = require_dist14();
    function isValidModellingRule(ruleName) {
      return ruleName === null || ruleName === "Mandatory" || ruleName === "Optional" || ruleName === "OptionalPlaceholder" || ruleName === "MandatoryPlaceholder" || ruleName === "ExposesItsArray";
    }
    function UANamespace_process_modelling_rule(references, modellingRule) {
      if (modellingRule) {
        (0, node_opcua_assert_1.assert)(isValidModellingRule(modellingRule), "expecting a valid modelling rule");
        const modellingRuleName = "ModellingRule_" + modellingRule;
        references.push({
          nodeId: modellingRuleName,
          referenceType: "HasModellingRule"
        });
      }
    }
    exports2.UANamespace_process_modelling_rule = UANamespace_process_modelling_rule;
  }
});

// node_modules/node-opcua-address-space/dist/src/tool_isSubtypeOf.js
var require_tool_isSubtypeOf = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/tool_isSubtypeOf.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.get_subtypeOfObj = exports2.get_subtypeOf = exports2.construct_slow_isSubtypeOf = exports2.construct_isSubtypeOf = exports2.wipeMemorizedStuff = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_nodeid_2 = require_dist21();
    var node_opcua_data_model_1 = require_dist27();
    var base_node_private_1 = require_base_node_private();
    var reference_impl_1 = require_reference_impl();
    var HasSubTypeNodeId = (0, node_opcua_nodeid_1.resolveNodeId)("HasSubtype");
    function _filterSubType(reference) {
      return (0, node_opcua_nodeid_2.sameNodeId)(reference.referenceType, HasSubTypeNodeId) && !reference.isForward;
    }
    function _slow_isSubtypeOf(Class, baseType) {
      if (!(baseType instanceof Class)) {
        const node = this.addressSpace.findNode(baseType);
        if (!node || !(node instanceof Class)) {
          throw new Error("Invalid argument");
        }
        return _slow_isSubtypeOf.call(this, Class, node);
      }
      (0, node_opcua_assert_1.assert)(this instanceof Class);
      (0, node_opcua_assert_1.assert)(baseType instanceof Class, " Object must have same type");
      (0, node_opcua_assert_1.assert)(this.addressSpace);
      if ((0, node_opcua_nodeid_2.sameNodeId)(this.nodeId, baseType.nodeId)) {
        return true;
      }
      const references = this.allReferences();
      const subTypes = references.filter(_filterSubType);
      (0, node_opcua_assert_1.assert)(subTypes.length <= 1, "should have zero or one subtype no more");
      for (const subType1 of subTypes) {
        const subTypeId = subType1.nodeId;
        const subTypeNode = this.addressSpace.findNode(subTypeId);
        if (!subTypeNode) {
          throw new Error("Cannot find object with nodeId " + subTypeId.toString());
        }
        if ((0, node_opcua_nodeid_2.sameNodeId)(subTypeNode.nodeId, baseType.nodeId)) {
          return true;
        } else {
          if (_slow_isSubtypeOf.call(subTypeNode, Class, baseType)) {
            return true;
          }
        }
      }
      return false;
    }
    function wipeMemorizedStuff(node) {
      if (!node.__cache) {
        node.__cache = void 0;
      }
    }
    exports2.wipeMemorizedStuff = wipeMemorizedStuff;
    function wrap_memoize(func, hashFunc) {
      if (void 0 === hashFunc) {
        hashFunc = (_p) => _p.toString();
      }
      return function memoize(param) {
        if (!this.__cache) {
          this.__cache = {};
        }
        const hash = hashFunc.call(this, param);
        let cache_value = this.__cache[hash];
        if (cache_value === void 0) {
          cache_value = func.call(this, param);
          this.__cache[hash] = cache_value;
        }
        return cache_value;
      };
    }
    function hashBaseNode(e) {
      return e.nodeId.value.toString();
    }
    function construct_isSubtypeOf(Class) {
      return wrap_memoize(function(baseType) {
        if (!(baseType instanceof Class)) {
          throw new Error("expecting baseType to be " + Class.name + " but got " + baseType.toString() + " " + node_opcua_data_model_1.NodeClass[baseType.nodeClass]);
        }
        if (!(this instanceof Class)) {
          throw new Error("expecting this to be " + Class.name + " but got " + baseType.toString());
        }
        return _slow_isSubtypeOf.call(this, Class, baseType);
      }, hashBaseNode);
    }
    exports2.construct_isSubtypeOf = construct_isSubtypeOf;
    function construct_slow_isSubtypeOf(Class) {
      return function(baseType) {
        return _slow_isSubtypeOf.call(this, Class, baseType);
      };
    }
    exports2.construct_slow_isSubtypeOf = construct_slow_isSubtypeOf;
    function get_subtypeOf() {
      const s = get_subtypeOfObj.call(this);
      return s ? s.nodeId : null;
    }
    exports2.get_subtypeOf = get_subtypeOf;
    function get_subtypeOfObj() {
      const _cache = (0, base_node_private_1.BaseNode_getCache)(this);
      if (!_cache._subtypeOfObj) {
        const is_subtype_of_ref = this.findReference("HasSubtype", false);
        if (is_subtype_of_ref) {
          _cache._subtypeOfObj = reference_impl_1.ReferenceImpl.resolveReferenceNode(this.addressSpace, is_subtype_of_ref);
        } else {
          _cache._subtypeOfObj = null;
        }
      }
      return _cache._subtypeOfObj;
    }
    exports2.get_subtypeOfObj = get_subtypeOfObj;
  }
});

// node_modules/node-opcua-address-space/dist/src/base_node_private.js
var require_base_node_private = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/base_node_private.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.BaseNode_add_backward_reference = exports2.BaseNode_remove_backward_reference = exports2._constructReferenceDescription = exports2._handle_HierarchicalReference = exports2._clone = exports2._clone_non_hierarchical_references = exports2._clone_hierarchical_references = exports2.VariableOrVariableType_toString = exports2.valueRankToString = exports2.UAObjectType_toString = exports2.UAObject_toString = exports2.UAVariable_toString = exports2.UAVariableType_toString = exports2.BaseNode_References_toString = exports2.BaseNode_toString = exports2.ToStringBuilder = exports2.BaseNode_clearCache = exports2.BaseNode_getCache = exports2.BaseNode_getPrivate = exports2.BaseNode_removePrivate = exports2.BaseNode_initPrivate = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_address_space_base_1 = require_dist53();
    var node_opcua_constants_1 = require_dist20();
    var namespace_private_1 = require_namespace_private();
    var reference_impl_1 = require_reference_impl();
    var base_node_impl_1 = require_base_node_impl();
    var tool_isSubtypeOf_1 = require_tool_isSubtypeOf();
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var doTrace = (0, node_opcua_debug_1.checkDebugFlag)("INSTANTIATE");
    var traceLog = errorLog;
    var g_weakMap = /* @__PURE__ */ new WeakMap();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    function BaseNode_initPrivate(self2) {
      const _private = {
        __address_space: null,
        _referenceIdx: {},
        _back_referenceIdx: {},
        _browseFilter: void 0,
        _cache: {},
        _description: void 0,
        _displayName: [],
        _parent: void 0,
        _subtype_idx: {},
        _subtype_idxVersion: 0
      };
      g_weakMap.set(self2, _private);
      return _private;
    }
    exports2.BaseNode_initPrivate = BaseNode_initPrivate;
    function BaseNode_removePrivate(self2) {
      const _private = BaseNode_getPrivate(self2);
      _private._cache = {};
      _private.__address_space = null;
      _private._back_referenceIdx = {};
      _private._referenceIdx = {};
      _private._description = void 0;
      _private._displayName = [];
    }
    exports2.BaseNode_removePrivate = BaseNode_removePrivate;
    function BaseNode_getPrivate(self2) {
      return g_weakMap.get(self2);
    }
    exports2.BaseNode_getPrivate = BaseNode_getPrivate;
    function BaseNode_getCache(node) {
      return BaseNode_getPrivate(node)._cache;
    }
    exports2.BaseNode_getCache = BaseNode_getCache;
    function BaseNode_clearCache(node) {
      const _private = BaseNode_getPrivate(node);
      if (_private && _private._cache) {
        _private._cache = {};
      }
      (0, tool_isSubtypeOf_1.wipeMemorizedStuff)(node);
    }
    exports2.BaseNode_clearCache = BaseNode_clearCache;
    var hasTypeDefinition_ReferenceTypeNodeId = (0, node_opcua_nodeid_1.resolveNodeId)("HasTypeDefinition");
    var ToStringBuilder = class {
      constructor() {
        this.level = 0;
        this.cycleDetector = {};
        this.padding = "";
        this.str = [];
        this.str = [];
      }
      add(line) {
        this.str.push(line);
      }
      toString() {
        return this.str.join("\n");
      }
      indent(str, padding) {
        padding = padding || "          ";
        return str.split("\n").map((r) => {
          return padding + r;
        }).join("\n");
      }
    };
    exports2.ToStringBuilder = ToStringBuilder;
    function set_as_processed(options, nodeId) {
      options.cycleDetector[nodeId.toString()] = nodeId;
    }
    function is_already_processed(options, nodeId) {
      return !!options.cycleDetector[nodeId.toString()];
    }
    function BaseNode_toString(options) {
      options.level = options.level || 1;
      set_as_processed(options, this.nodeId);
      options.add("");
      options.add(options.padding + chalk_1.default.yellow("          nodeId              : ") + this.nodeId.toString());
      options.add(options.padding + chalk_1.default.yellow("          nodeClass           : ") + node_opcua_data_model_1.NodeClass[this.nodeClass] + " (" + this.nodeClass + ")");
      options.add(options.padding + chalk_1.default.yellow("          browseName          : ") + this.browseName.toString());
      options.add(options.padding + chalk_1.default.yellow("          displayName         : ") + this.displayName.map((f2) => f2.locale + " " + f2.text).join(" | "));
      options.add(options.padding + chalk_1.default.yellow("          description         : ") + (this.description ? this.description.toString() : ""));
    }
    exports2.BaseNode_toString = BaseNode_toString;
    function BaseNode_References_toString(options) {
      const _private = BaseNode_getPrivate(this);
      const displayOptions = {
        addressSpace: this.addressSpace
      };
      const addressSpace = this.addressSpace;
      options.add(options.padding + chalk_1.default.yellow("    references                : ") + "  length =" + Object.keys(_private._referenceIdx).length);
      function dump_reference(follow, reference) {
        if (!reference) {
          return;
        }
        const o2 = reference_impl_1.ReferenceImpl.resolveReferenceNode(addressSpace, reference);
        if (!o2) {
          warningLog("cannot find reference", reference.toString());
          return;
        }
        const name = o2.browseName.toString();
        const modellingRule = o2.modellingRule || " ";
        const extra = modellingRule[0] + (() => {
          switch (o2.nodeClass) {
            case node_opcua_data_model_1.NodeClass.Object:
              return "[O] ";
            case node_opcua_data_model_1.NodeClass.Variable:
              return "[V] " + o2.dataType.toString(displayOptions).padEnd(10);
            case node_opcua_data_model_1.NodeClass.Method:
              return "[M] ";
            case node_opcua_data_model_1.NodeClass.DataType:
              return "[DT]";
            case node_opcua_data_model_1.NodeClass.ReferenceType:
              return "[RT]";
            case node_opcua_data_model_1.NodeClass.ObjectType:
              return "[OT]";
            case node_opcua_data_model_1.NodeClass.VariableType:
              return "[VT]";
            case node_opcua_data_model_1.NodeClass.View:
              return "[V] ";
          }
          return "";
        })();
        options.add(options.padding + chalk_1.default.yellow("      +-> ") + reference.toString(displayOptions) + " " + chalk_1.default.cyan(name.padEnd(25, " ")) + " " + chalk_1.default.magentaBright(extra));
        if ((0, node_opcua_nodeid_1.sameNodeId)(reference.referenceType, hasTypeDefinition_ReferenceTypeNodeId) && reference.nodeId.namespace === 0) {
          return;
        }
        if (o2) {
          if (!is_already_processed(options, o2.nodeId)) {
            set_as_processed(options, o2.nodeId);
            if (options.level > 1 && follow) {
              const rr = o2.toString({
                cycleDetector: options.cycleDetector,
                level: options.level - 1,
                padding: options.padding + "         "
              });
              options.add(rr);
            }
          }
        }
      }
      Object.values(_private._referenceIdx).forEach(dump_reference.bind(null, true));
      const br = Object.values(_private._back_referenceIdx).map((x2) => x2);
      options.add(options.padding + chalk_1.default.yellow("    back_references                 : ") + chalk_1.default.cyan("  length =") + br.length + chalk_1.default.grey(" ( references held by other nodes involving this node)"));
      br.forEach(dump_reference.bind(null, false));
    }
    exports2.BaseNode_References_toString = BaseNode_References_toString;
    function _UAType_toString(options) {
      if (this.subtypeOfObj) {
        options.add(options.padding + chalk_1.default.yellow("          subtypeOf           : ") + this.subtypeOfObj.browseName.toString() + " (" + this.subtypeOfObj.nodeId.toString() + ")");
      }
    }
    function _UAInstance_toString(options) {
      if (this.typeDefinitionObj) {
        options.add(options.padding + chalk_1.default.yellow("          typeDefinition      : ") + this.typeDefinitionObj.browseName.toString() + " (" + this.typeDefinitionObj.nodeId.toString() + ")");
      }
    }
    function UAVariableType_toString(options) {
      BaseNode_toString.call(this, options);
      _UAType_toString.call(this, options);
      VariableOrVariableType_toString.call(this, options);
      BaseNode_References_toString.call(this, options);
    }
    exports2.UAVariableType_toString = UAVariableType_toString;
    function UAVariable_toString(options) {
      BaseNode_toString.call(this, options);
      _UAInstance_toString.call(this, options);
      VariableOrVariableType_toString.call(this, options);
      AccessLevelFlags_toString.call(this, options);
      BaseNode_References_toString.call(this, options);
    }
    exports2.UAVariable_toString = UAVariable_toString;
    function UAObject_toString(options) {
      BaseNode_toString.call(this, options);
      _UAInstance_toString.call(this, options);
      BaseNode_References_toString.call(this, options);
    }
    exports2.UAObject_toString = UAObject_toString;
    function UAObjectType_toString(options) {
      BaseNode_toString.call(this, options);
      _UAType_toString.call(this, options);
      BaseNode_References_toString.call(this, options);
    }
    exports2.UAObjectType_toString = UAObjectType_toString;
    function valueRankToString(valueRank) {
      switch (valueRank) {
        case 1:
          return "OneDimension (1)";
        case 0:
          return "OneOrMoreDimensions (0)";
        case -1:
          return "Scalar (-1)";
        case -2:
          return "Any (-2)";
        case -3:
          return "ScalarOrOneDimension (2)";
        default:
          if (valueRank > 0) {
            return "" + valueRank + "-Dimensions";
          } else {
            return "Invalid (" + valueRank + ")";
          }
      }
    }
    exports2.valueRankToString = valueRankToString;
    function accessLevelFlagToString(flag) {
      const str = [];
      if (flag & node_opcua_data_model_1.AccessLevelFlag.CurrentRead) {
        str.push("CurrentRead");
      }
      if (flag & node_opcua_data_model_1.AccessLevelFlag.CurrentWrite) {
        str.push("CurrentWrite");
      }
      if (flag & node_opcua_data_model_1.AccessLevelFlag.HistoryRead) {
        str.push("HistoryRead");
      }
      if (flag & node_opcua_data_model_1.AccessLevelFlag.HistoryWrite) {
        str.push("HistoryWrite");
      }
      if (flag & node_opcua_data_model_1.AccessLevelFlag.SemanticChange) {
        str.push("SemanticChange");
      }
      if (flag & node_opcua_data_model_1.AccessLevelFlag.StatusWrite) {
        str.push("StatusWrite");
      }
      if (flag & node_opcua_data_model_1.AccessLevelFlag.TimestampWrite) {
        str.push("TimestampWrite");
      }
      return str.join(" | ");
    }
    function AccessLevelFlags_toString(options) {
      (0, node_opcua_assert_1.assert)(options);
      options.add(options.padding + chalk_1.default.yellow("          accessLevel         : ") + " " + accessLevelFlagToString(this.accessLevel));
      if (this.userAccessLevel !== void 0) {
        options.add(options.padding + chalk_1.default.yellow("          userAccessLevel     : ") + " " + accessLevelFlagToString(this.userAccessLevel));
      }
    }
    function VariableOrVariableType_toString(options) {
      (0, node_opcua_assert_1.assert)(options);
      if (this.dataType) {
        const addressSpace = this.addressSpace;
        const d2 = addressSpace.findNode(this.dataType);
        const n = d2 ? "(" + d2.browseName.toString() + ")" : " (???)";
        options.add(options.padding + chalk_1.default.yellow("          dataType            : ") + this.dataType + "  " + n);
      }
      if (this.nodeClass === node_opcua_data_model_1.NodeClass.Variable) {
        const _dataValue = this.$dataValue;
        if (_dataValue) {
          options.add(options.padding + chalk_1.default.yellow("          value               : ") + "\n" + options.indent(_dataValue.toString(), options.padding + "                        | "));
        }
      }
      if (Object.prototype.hasOwnProperty.call(this, "valueRank")) {
        if (this.valueRank !== void 0) {
          options.add(options.padding + chalk_1.default.yellow("          valueRank           : ") + " " + valueRankToString(this.valueRank));
        } else {
          options.add(options.padding + chalk_1.default.yellow("          valueRank           : ") + " undefined");
        }
      }
      if (this.minimumSamplingInterval !== void 0) {
        options.add(options.padding + chalk_1.default.yellow(" minimumSamplingInterval      : ") + " " + this.minimumSamplingInterval.toString() + " ms");
      }
      if (this.arrayDimensions) {
        options.add(options.padding + chalk_1.default.yellow(" arrayDimension               : ") + " [" + this.arrayDimensions.join(",").toString() + " ]");
      }
    }
    exports2.VariableOrVariableType_toString = VariableOrVariableType_toString;
    function _clone_children_on_template(nodeToClone, newParent, node, copyAlsoModellingRules, optionalFilter, extraInfo) {
      const nodeToCloneTypeDefinition = nodeToClone.nodeClass === node_opcua_data_model_1.NodeClass.ObjectType || nodeToClone.nodeClass === node_opcua_data_model_1.NodeClass.VariableType ? nodeToClone.subtypeOfObj : null;
      if (!nodeToCloneTypeDefinition)
        return;
      doTrace && traceLog(extraInfo?.pad(), chalk_1.default.gray("-------------------- now cloning children on template ", node.browseName.toString(), node.nodeId.toString(), nodeToCloneTypeDefinition.browseName.toString()));
      const namespace = newParent.namespace;
      const newParentChild = newParent.getChildByName(node.browseName);
      if (!newParentChild) {
        return;
      }
      let typeDefinitionNode = nodeToCloneTypeDefinition;
      while (typeDefinitionNode) {
        doTrace && traceLog(extraInfo?.pad(), chalk_1.default.green("-------------------- now cloning children on ", newParentChild.browseName.toString(), newParentChild.nodeId.toString(), " (child of ", node.browseName.toString(), node.nodeId.toString(), ") from ", typeDefinitionNode.browseName.toString()));
        const aggregates = typeDefinitionNode.getAggregates().filter((n) => n.browseName.equals(node.browseName));
        const typeDefinitionChild = aggregates.length > 0 ? aggregates[0] : null;
        if (typeDefinitionChild) {
          const references = typeDefinitionChild.findReferencesEx("Aggregates", node_opcua_data_model_1.BrowseDirection.Forward);
          for (const ref of references) {
            const grandChild = ref.node;
            if (grandChild.modellingRule === "MandatoryPlaceholder" || grandChild.modellingRule === "OptionalPlaceholder")
              continue;
            const hasAlready = newParentChild.getChildByName(grandChild.browseName) !== null;
            if (!hasAlready) {
              if (optionalFilter && node && !optionalFilter.shouldKeep(node)) {
                doTrace && traceLog(extraInfo.pad(), "skipping optional ", node.browseName.toString(), "that doesn't appear in the filter");
                continue;
              }
              const options = {
                namespace,
                references: [
                  new reference_impl_1.ReferenceImpl({
                    referenceType: ref.referenceType,
                    isForward: false,
                    nodeId: newParentChild.nodeId
                  })
                ],
                copyAlsoModellingRules
              };
              const alreadyCloned = extraInfo.getCloned({
                originalParent: nodeToClone,
                clonedParent: newParent,
                originalNode: grandChild
              });
              if (alreadyCloned) {
                alreadyCloned.addReference({
                  referenceType: ref.referenceType,
                  isForward: false,
                  nodeId: newParentChild.nodeId
                });
              } else {
                const clonedGrandChild = grandChild.clone(options, optionalFilter, extraInfo);
                extraInfo.registerClonedObject({
                  originalNode: grandChild,
                  clonedNode: clonedGrandChild
                });
              }
            }
          }
        }
        typeDefinitionNode = typeDefinitionNode.subtypeOfObj;
      }
    }
    function _clone_collection_new(nodeToClone, newParent, collectionRef, copyAlsoModellingRules, optionalFilter, extraInfo, browseNameMap) {
      const namespace = newParent.namespace;
      extraInfo = extraInfo || new node_opcua_address_space_base_1.CloneHelper();
      const addressSpace = newParent.addressSpace;
      (0, node_opcua_assert_1.assert)(!optionalFilter || typeof optionalFilter.shouldKeep === "function" && typeof optionalFilter.filterFor === "function");
      for (const reference of collectionRef) {
        const node = reference_impl_1.ReferenceImpl.resolveReferenceNode(addressSpace, reference);
        if (typeof node.clone !== "function") {
          warningLog(chalk_1.default.red("Warning : cannot clone node ") + (0, node_opcua_address_space_base_1.fullPath2)(node) + " of class " + node_opcua_data_model_1.NodeClass[node.nodeClass].toString() + " while cloning " + (0, node_opcua_address_space_base_1.fullPath2)(newParent));
          continue;
        }
        if (node && !node.modellingRule) {
          doTrace && traceLog(extraInfo.pad(), "skipping  with no modelling rule", (0, node_opcua_address_space_base_1.fullPath2)(node));
          continue;
        }
        if (optionalFilter && node && !optionalFilter.shouldKeep(node)) {
          doTrace && traceLog(extraInfo.pad(), "skipping optional that doesn't appear in the filter", (0, node_opcua_address_space_base_1.fullPath2)(node));
          continue;
        }
        const key = newParent.nodeId.toString() + "(" + newParent.browseName.toString() + ")/" + node.browseName.toString();
        if (browseNameMap?.has(key)) {
          _clone_children_on_template(nodeToClone, newParent, node, copyAlsoModellingRules, optionalFilter, extraInfo);
          doTrace && traceLog(extraInfo.pad(), "skipping required node with same browseName", (0, node_opcua_address_space_base_1.fullPath2)(node), "because it has already been cloned", "key=", key);
          continue;
        }
        browseNameMap?.add(key);
        const options = {
          namespace,
          references: [new reference_impl_1.ReferenceImpl({ referenceType: reference.referenceType, isForward: false, nodeId: newParent.nodeId })],
          copyAlsoModellingRules
        };
        const alreadyCloned = extraInfo.getCloned({ originalParent: nodeToClone, clonedParent: newParent, originalNode: node });
        if (alreadyCloned) {
          doTrace && traceLog(extraInfo.pad(), "node ", (0, node_opcua_address_space_base_1.fullPath2)(node), "already cloned as", (0, node_opcua_address_space_base_1.fullPath2)(alreadyCloned), "\nnode to clone =", (0, node_opcua_address_space_base_1.fullPath2)(nodeToClone), "\nnew parent   =", (0, node_opcua_address_space_base_1.fullPath2)(newParent));
          const hasReference = alreadyCloned.findReferencesExAsObject(reference.referenceType, node_opcua_data_model_1.BrowseDirection.Inverse).length > 0;
          if (!hasReference) {
            alreadyCloned.addReference({
              referenceType: reference.referenceType,
              isForward: false,
              nodeId: newParent.nodeId
            });
          } else {
            doTrace && traceLog(extraInfo.pad(), "reference to node  ", (0, node_opcua_address_space_base_1.fullPath2)(alreadyCloned), " already exists !");
          }
        } else {
          doTrace && traceLog(extraInfo.pad(), "cloning => ", reference.referenceType.toString({ addressSpace }), "=>", (0, node_opcua_address_space_base_1.fullPath2)(node), chalk_1.default.magentaBright(node.typeDefinitionObj?.browseName.toString()));
          extraInfo.level += 1;
          const clonedNode = node.clone(options, optionalFilter, extraInfo);
          extraInfo.level -= 1;
          doTrace && traceLog(extraInfo.pad(), "cloned => ", (0, node_opcua_address_space_base_1.fullPath2)(node), "", extraInfo.pad(), "    original nodeId", node.nodeId.toString(), "", extraInfo.pad(), "    cloned   nodeId", clonedNode.nodeId.toString(), (0, node_opcua_address_space_base_1.fullPath2)(clonedNode) + "");
          extraInfo.level++;
          _clone_children_on_template(nodeToClone, newParent, node, copyAlsoModellingRules, optionalFilter, extraInfo);
          extraInfo.level--;
          extraInfo.level++;
          _cloneInterface(nodeToClone, newParent, node, optionalFilter, extraInfo, browseNameMap);
          extraInfo.level--;
        }
      }
    }
    function _extractInterfaces2(typeDefinitionNode, extraInfo) {
      if (!typeDefinitionNode || typeDefinitionNode.nodeId.namespace === 0 && (typeDefinitionNode.nodeId.value === node_opcua_constants_1.ObjectTypeIds.BaseObjectType || typeDefinitionNode.nodeId.value === node_opcua_constants_1.VariableTypeIds.BaseVariableType)) {
        return [];
      }
      const addressSpace = typeDefinitionNode.addressSpace;
      const hasInterfaceReference = addressSpace.findReferenceType("HasInterface");
      if (!hasInterfaceReference) {
        return [];
      }
      const interfacesRef = typeDefinitionNode.findReferencesEx("HasInterface", node_opcua_data_model_1.BrowseDirection.Forward);
      const interfaces = interfacesRef.map((r) => addressSpace.findNode(r.nodeId));
      const baseInterfaces = [];
      for (const iface of interfaces) {
        doTrace && traceLog(extraInfo.pad(), typeDefinitionNode.browseName.toString(), " - has interface -> ", iface.browseName.toString());
        baseInterfaces.push(iface);
        if (iface.subtypeOfObj) {
          extraInfo.level++;
          baseInterfaces.push(..._extractInterfaces2(iface.subtypeOfObj, extraInfo));
          extraInfo.level--;
        }
      }
      interfaces.push(...baseInterfaces);
      if (typeDefinitionNode.subtypeOfObj) {
        doTrace && traceLog(extraInfo.pad(), typeDefinitionNode.browseName.toString(), " - subtypeOf  -> ", typeDefinitionNode.subtypeOfObj.browseName.toString());
        extraInfo.level++;
        interfaces.push(..._extractInterfaces2(typeDefinitionNode.subtypeOfObj, extraInfo));
        extraInfo.level--;
      }
      const deduplicatedInterfaces = [...new Set(interfaces)];
      doTrace && deduplicatedInterfaces.length && traceLog(extraInfo.pad(), chalk_1.default.yellow("Interface for ", typeDefinitionNode.browseName.toString()), "=", deduplicatedInterfaces.map((x2) => x2.browseName.toString()).join(" "));
      return deduplicatedInterfaces;
    }
    function _cloneInterface(nodeToClone, newParent, node, optionalFilter, extraInfo, browseNameMap) {
      doTrace && traceLog(extraInfo?.pad(), chalk_1.default.green("-------------------- now cloning interfaces of ", node.browseName.toString(), node.nodeId.toString()));
      extraInfo = extraInfo || new node_opcua_address_space_base_1.CloneHelper();
      const addressSpace = node.addressSpace;
      if (node.nodeClass !== node_opcua_data_model_1.NodeClass.Object && node.nodeClass !== node_opcua_data_model_1.NodeClass.Variable) {
        return;
      }
      const typeDefinitionNode = node.typeDefinitionObj;
      if (!typeDefinitionNode) {
        return;
      }
      const interfaces = _extractInterfaces2(typeDefinitionNode, extraInfo);
      if (interfaces.length === 0) {
        doTrace && false;
        return;
      }
      doTrace && traceLog(extraInfo?.pad(), chalk_1.default.green("-------------------- interfaces are  ", interfaces.length));
      const localFilter = optionalFilter.filterFor(node);
      for (const iface of interfaces) {
        const aggregates = iface.findReferencesEx("Aggregates", node_opcua_data_model_1.BrowseDirection.Forward);
        if (aggregates.length === 0)
          continue;
        doTrace && traceLog(extraInfo.pad(), chalk_1.default.magentaBright("   interface ", iface.browseName.toString()), "\n" + extraInfo?.pad(), aggregates.map((r) => r.toString({ addressSpace })).join("\n" + extraInfo?.pad()));
        _clone_collection_new(nodeToClone, node, aggregates, false, localFilter, extraInfo, browseNameMap);
      }
    }
    function __clone_organizes_references(nodeToClone, newParent, copyAlsoModellingRules, optionalFilter, extraInfo, browseNameMap) {
      const organizedRef = nodeToClone.findReferencesEx("Organizes", node_opcua_data_model_1.BrowseDirection.Forward);
      if (organizedRef.length === 0)
        return;
      _clone_collection_new(nodeToClone, newParent, organizedRef, copyAlsoModellingRules, optionalFilter, extraInfo, browseNameMap);
    }
    function __clone_children_references(nodeToClone, newParent, copyAlsoModellingRules, optionalFilter, extraInfo, browseNameMap) {
      const aggregatesRef = nodeToClone.findReferencesEx("Aggregates", node_opcua_data_model_1.BrowseDirection.Forward);
      if (aggregatesRef.length === 0)
        return;
      _clone_collection_new(nodeToClone, newParent, aggregatesRef, copyAlsoModellingRules, optionalFilter, extraInfo, browseNameMap);
    }
    function _clone_hierarchical_references(nodeToClone, newParent, copyAlsoModellingRules, optionalFilter, extraInfo, browseNameMap) {
      __clone_children_references(nodeToClone, newParent, copyAlsoModellingRules, optionalFilter, extraInfo, browseNameMap);
      __clone_organizes_references(nodeToClone, newParent, copyAlsoModellingRules, optionalFilter, extraInfo, browseNameMap);
    }
    exports2._clone_hierarchical_references = _clone_hierarchical_references;
    function _clone_non_hierarchical_references(nodeToClone, newParent, copyAlsoModellingRules, optionalFilter, extraInfo, browseNameMap) {
      (0, node_opcua_assert_1.assert)(newParent instanceof base_node_impl_1.BaseNodeImpl);
      const references = nodeToClone.findReferencesEx("HasSubStateMachine", node_opcua_data_model_1.BrowseDirection.Forward);
      if (references.length === 0)
        return;
      _clone_collection_new(nodeToClone, newParent, references, copyAlsoModellingRules, optionalFilter, extraInfo, browseNameMap);
    }
    exports2._clone_non_hierarchical_references = _clone_non_hierarchical_references;
    function _clone(originalNode, Constructor, options, optionalFilter, extraInfo) {
      (0, node_opcua_assert_1.assert)(typeof Constructor === "function");
      (0, node_opcua_assert_1.assert)(options !== null && typeof options === "object");
      (0, node_opcua_assert_1.assert)(!extraInfo || extraInfo !== null && typeof extraInfo === "object" && typeof extraInfo.registerClonedObject === "function");
      (0, node_opcua_assert_1.assert)(!originalNode.subtypeOf, "We do not do cloning of Type yet");
      const namespace = options.namespace;
      const constructorOptions = {
        ...options,
        addressSpace: namespace.addressSpace,
        browseName: originalNode.browseName,
        description: originalNode.description,
        displayName: originalNode.displayName,
        nodeClass: originalNode.nodeClass
      };
      constructorOptions.references = options.references || [];
      if (originalNode.nodeClass === node_opcua_data_model_1.NodeClass.Variable || originalNode.nodeClass === node_opcua_data_model_1.NodeClass.Object) {
        const voThis = originalNode;
        if (voThis.typeDefinition) {
          constructorOptions.references.push(new reference_impl_1.ReferenceImpl({
            isForward: true,
            nodeId: voThis.typeDefinition,
            referenceType: (0, node_opcua_nodeid_1.resolveNodeId)("HasTypeDefinition")
          }));
        }
      }
      if (!constructorOptions.modellingRule) {
        if (originalNode.modellingRule && options.copyAlsoModellingRules) {
          const modellingRuleNode = originalNode.findReferencesAsObject("HasModellingRule", true)[0];
          (0, node_opcua_assert_1.assert)(modellingRuleNode);
          constructorOptions.references.push(new reference_impl_1.ReferenceImpl({
            isForward: true,
            nodeId: modellingRuleNode.nodeId,
            referenceType: (0, node_opcua_nodeid_1.resolveNodeId)("HasModellingRule")
          }));
        }
      } else {
        (0, namespace_private_1.UANamespace_process_modelling_rule)(constructorOptions.references, constructorOptions.modellingRule);
      }
      constructorOptions.nodeId = namespace.constructNodeId(constructorOptions);
      (0, node_opcua_assert_1.assert)(constructorOptions.nodeId instanceof node_opcua_nodeid_1.NodeId);
      const clonedNode = new Constructor(constructorOptions);
      originalNode.addressSpace._register(clonedNode);
      extraInfo.registerClonedObject({
        originalNode,
        clonedNode
      });
      if (!options.ignoreChildren) {
        options.copyAlsoModellingRules = options.copyAlsoModellingRules || false;
        const newFilter = optionalFilter.filterFor(clonedNode);
        const browseNameMap = /* @__PURE__ */ new Set();
        _clone_hierarchical_references(originalNode, clonedNode, options.copyAlsoModellingRules, newFilter, extraInfo, browseNameMap);
        if (originalNode.nodeClass === node_opcua_data_model_1.NodeClass.Object || originalNode.nodeClass === node_opcua_data_model_1.NodeClass.Variable) {
          let typeDefinitionNode = originalNode.typeDefinitionObj;
          extraInfo.pushContext({
            clonedParent: clonedNode,
            originalParent: originalNode
          });
          while (typeDefinitionNode) {
            doTrace && traceLog(extraInfo?.pad(), chalk_1.default.blueBright(originalNode.browseName.toString(), "-----> Exploring ", typeDefinitionNode.browseName.toString()));
            _clone_hierarchical_references(typeDefinitionNode, clonedNode, options.copyAlsoModellingRules, newFilter, extraInfo, browseNameMap);
            typeDefinitionNode = typeDefinitionNode.subtypeOfObj;
          }
          extraInfo.popContext();
        }
        _clone_non_hierarchical_references(originalNode, clonedNode, options.copyAlsoModellingRules, newFilter, extraInfo, browseNameMap);
      }
      clonedNode.propagate_back_references();
      clonedNode.install_extra_properties();
      return clonedNode;
    }
    exports2._clone = _clone;
    function _handle_HierarchicalReference(node, reference) {
      const _cache = BaseNode_getCache(node);
      if (!reference.isForward)
        return;
      if (_cache._childByNameMap) {
        const addressSpace = node.addressSpace;
        const referenceType = reference_impl_1.ReferenceImpl.resolveReferenceType(addressSpace, reference);
        if (referenceType) {
          const HierarchicalReferencesType = addressSpace.findReferenceType("HierarchicalReferences");
          if (referenceType.isSubtypeOf(HierarchicalReferencesType)) {
            (0, node_opcua_assert_1.assert)(reference.isForward);
            const targetNode = reference_impl_1.ReferenceImpl.resolveReferenceNode(addressSpace, reference);
            _cache._childByNameMap[targetNode.browseName.name.toString()] = targetNode;
          }
        }
      }
    }
    exports2._handle_HierarchicalReference = _handle_HierarchicalReference;
    function _remove_HierarchicalReference(node, reference) {
      const _cache = BaseNode_getCache(node);
      if (_cache._childByNameMap) {
        const addressSpace = node.addressSpace;
        const referenceType = reference_impl_1.ReferenceImpl.resolveReferenceType(addressSpace, reference);
        if (referenceType) {
          const HierarchicalReferencesType = addressSpace.findReferenceType("HierarchicalReferences");
          if (referenceType.isSubtypeOf(HierarchicalReferencesType)) {
            (0, node_opcua_assert_1.assert)(reference.isForward);
            const targetNode = reference_impl_1.ReferenceImpl.resolveReferenceNode(addressSpace, reference);
            delete _cache._childByNameMap[targetNode.browseName.name.toString()];
          }
        }
      }
    }
    function _makeReferenceDescription(addressSpace, reference, resultMask) {
      const isForward = reference.isForward;
      const referenceTypeId = reference_impl_1.ReferenceImpl.resolveReferenceType(addressSpace, reference).nodeId;
      (0, node_opcua_assert_1.assert)(referenceTypeId instanceof node_opcua_nodeid_1.NodeId);
      const obj = reference_impl_1.ReferenceImpl.resolveReferenceNode(addressSpace, reference);
      let data = {};
      if (!obj) {
        data = {
          isForward,
          nodeId: reference.nodeId,
          referenceTypeId: resultMask & node_opcua_data_model_1.ResultMask.ReferenceType ? referenceTypeId : null,
          typeDefinition: null
        };
      } else {
        (0, node_opcua_assert_1.assert)(reference.nodeId, " obj.nodeId");
        data = {
          browseName: resultMask & node_opcua_data_model_1.ResultMask.BrowseName ? (0, node_opcua_data_model_1.coerceQualifiedName)(obj.browseName) : null,
          displayName: resultMask & node_opcua_data_model_1.ResultMask.DisplayName ? (0, node_opcua_data_model_1.coerceLocalizedText)(obj.displayName[0]) : null,
          isForward: resultMask & node_opcua_data_model_1.ResultMask.IsForward ? isForward : false,
          nodeClass: resultMask & node_opcua_data_model_1.ResultMask.NodeClass ? obj.nodeClass : node_opcua_data_model_1.NodeClass.Unspecified,
          nodeId: obj.nodeId,
          referenceTypeId: resultMask & node_opcua_data_model_1.ResultMask.ReferenceType ? referenceTypeId : null,
          typeDefinition: resultMask & node_opcua_data_model_1.ResultMask.TypeDefinition ? obj.typeDefinition : null
        };
      }
      if (data.typeDefinition === null) {
        data.typeDefinition = new node_opcua_nodeid_1.NodeId();
      }
      const referenceDescription = new node_opcua_types_1.ReferenceDescription(data);
      return referenceDescription;
    }
    function _constructReferenceDescription(addressSpace, references, resultMask) {
      (0, node_opcua_assert_1.assert)(Array.isArray(references));
      return references.map((reference) => _makeReferenceDescription(addressSpace, reference, resultMask));
    }
    exports2._constructReferenceDescription = _constructReferenceDescription;
    function BaseNode_remove_backward_reference(reference) {
      const _private = BaseNode_getPrivate(this);
      _remove_HierarchicalReference(this, reference);
      const h = reference.hash;
      if (_private._back_referenceIdx && _private._back_referenceIdx[h]) {
        _private._back_referenceIdx[h].dispose();
        delete _private._back_referenceIdx[h];
      }
      reference.dispose();
    }
    exports2.BaseNode_remove_backward_reference = BaseNode_remove_backward_reference;
    function BaseNode_add_backward_reference(reference) {
      const _private = BaseNode_getPrivate(this);
      const h = reference.hash;
      (0, node_opcua_assert_1.assert)(typeof h === "string");
      if (_private._referenceIdx[h]) {
        return;
      }
      if (_private._back_referenceIdx[h]) {
        const opts = { addressSpace: this.addressSpace };
        warningLog(" Warning !", this.browseName.toString());
        warningLog("    ", reference.toString(opts));
        warningLog(" already found in ===>");
        warningLog(Object.values(_private._back_referenceIdx).map((c2) => c2.toString(opts)).join("\n"));
        warningLog("===>");
        throw new Error("reference exists already in _back_references");
      }
      if (!(0, base_node_impl_1.getReferenceType)(reference)) {
        const stop_here = 1;
      }
      _private._back_referenceIdx[h] = reference;
      _handle_HierarchicalReference(this, reference);
      this._clear_caches();
    }
    exports2.BaseNode_add_backward_reference = BaseNode_add_backward_reference;
  }
});

// node_modules/node-opcua-address-space/dist/src/role_permissions.js
var require_role_permissions = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/role_permissions.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.coerceRolePermissions = void 0;
    var node_opcua_types_1 = require_dist32();
    function coerceRolePermissions(rolePermissions) {
      if (!rolePermissions)
        return void 0;
      return rolePermissions.map((rp) => new node_opcua_types_1.RolePermissionType(rp));
    }
    exports2.coerceRolePermissions = coerceRolePermissions;
  }
});

// node_modules/node-opcua-address-space/dist/src/base_node_impl.js
var require_base_node_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/base_node_impl.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getReferenceType = exports2.BaseNodeImpl = exports2.makeAttributeEventName = void 0;
    var events_1 = require("events");
    var chalk_1 = __importDefault3(require_source());
    var lodash_1 = require_lodash2();
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_constants_1 = require_dist20();
    var dump_tools_1 = require_dump_tools();
    var session_context_1 = require_session_context2();
    var address_space_change_event_tools_1 = require_address_space_change_event_tools();
    var base_node_private_1 = require_base_node_private();
    var reference_impl_1 = require_reference_impl();
    var role_permissions_1 = require_role_permissions();
    var doDebug = false;
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var HasEventSourceReferenceType = (0, node_opcua_nodeid_1.resolveNodeId)("HasEventSource");
    var HasNotifierReferenceType = (0, node_opcua_nodeid_1.resolveNodeId)("HasNotifier");
    function defaultBrowseFilterFunc(context) {
      return true;
    }
    function _get_QualifiedBrowseName(browseName) {
      return (0, node_opcua_data_model_1.coerceQualifiedName)(browseName);
    }
    function _is_valid_BrowseDirection(browseDirection) {
      return browseDirection === node_opcua_data_model_1.BrowseDirection.Forward || browseDirection === node_opcua_data_model_1.BrowseDirection.Inverse || browseDirection === node_opcua_data_model_1.BrowseDirection.Both;
    }
    function makeAttributeEventName(attributeId) {
      const attributeName = node_opcua_data_model_1.attributeNameById[attributeId];
      return attributeName + "_changed";
    }
    exports2.makeAttributeEventName = makeAttributeEventName;
    var BaseNodeImpl = class _BaseNodeImpl extends events_1.EventEmitter {
      static makeAttributeEventName(attributeId) {
        return makeAttributeEventName(attributeId);
      }
      get addressSpace() {
        const _private = (0, base_node_private_1.BaseNode_getPrivate)(this);
        if (!_private) {
          throw new Error("Internal error , cannot extract private data from " + this.browseName.toString());
        }
        return _private.__address_space;
      }
      get addressSpacePrivate() {
        const _private = (0, base_node_private_1.BaseNode_getPrivate)(this);
        if (!_private) {
          throw new Error("Internal error , cannot extract private data from " + this.browseName.toString());
        }
        return _private.__address_space;
      }
      get displayName() {
        const _private = (0, base_node_private_1.BaseNode_getPrivate)(this);
        return _private._displayName;
      }
      setDisplayName(value) {
        if (!Array.isArray(value)) {
          return this.setDisplayName([value]);
        }
        this._setDisplayName(value);
        this._notifyAttributeChange(node_opcua_data_model_1.AttributeIds.DisplayName);
      }
      get description() {
        const _private = (0, base_node_private_1.BaseNode_getPrivate)(this);
        return _private._description;
      }
      setDescription(value) {
        this._setDescription(value);
        this._notifyAttributeChange(node_opcua_data_model_1.AttributeIds.Description);
      }
      /**
       * returns the nodeId of this node's Type Definition
       */
      get typeDefinition() {
        const _cache = (0, base_node_private_1.BaseNode_getCache)(this);
        if (!_cache.typeDefinition) {
          const has_type_definition_ref = this.findReference("HasTypeDefinition", true);
          let nodeId = has_type_definition_ref ? has_type_definition_ref.nodeId : null;
          if (!nodeId) {
            switch (this.nodeClass) {
              case node_opcua_data_model_1.NodeClass.Object:
                nodeId = (0, node_opcua_nodeid_1.coerceNodeId)(node_opcua_constants_1.ObjectTypeIds.BaseObjectType);
                break;
              case node_opcua_data_model_1.NodeClass.Variable:
                nodeId = (0, node_opcua_nodeid_1.coerceNodeId)(node_opcua_constants_1.VariableTypeIds.BaseVariableType);
                break;
              default:
            }
          }
          _cache.typeDefinition = nodeId;
        }
        return _cache.typeDefinition;
      }
      /**
       * returns the nodeId of this node's Type Definition
       */
      get typeDefinitionObj() {
        const _cache = (0, base_node_private_1.BaseNode_getCache)(this);
        if (void 0 === _cache.typeDefinitionObj) {
          const nodeId = this.typeDefinition;
          _cache.typeDefinitionObj = nodeId ? this.addressSpace.findNode(nodeId) : null;
        }
        if (!_cache.typeDefinitionObj) {
          warningLog(this.nodeClass, "cannot find typeDefinitionObj ", this.browseName.toString(), this.nodeId.toString(), node_opcua_data_model_1.NodeClass[this.nodeClass]);
        }
        return _cache.typeDefinitionObj;
      }
      get parentNodeId() {
        const parent = this.parent;
        return parent ? parent.nodeId : void 0;
      }
      /**
       * namespace index
       */
      get namespaceIndex() {
        return this.nodeId.namespace;
      }
      /**
       * namespace uri
       */
      get namespaceUri() {
        return this.addressSpace.getNamespaceUri(this.namespaceIndex);
      }
      /**
       * the parent node
       */
      get parent() {
        const _private = (0, base_node_private_1.BaseNode_getPrivate)(this);
        if (_private._parent === void 0) {
          _private._parent = _setup_parent_item.call(this, _private._referenceIdx);
        }
        return _private._parent || null;
      }
      /**
       * @property modellingRule
       * @type {String|undefined}
       */
      get modellingRule() {
        const r = this.findReferencesAsObject("HasModellingRule");
        if (!r || r.length === 0) {
          return null;
        }
        const r0 = r[0];
        return r0.browseName.toString();
      }
      /**
       * @internal
       * @param options
       */
      constructor(options) {
        super();
        this.nodeClass = node_opcua_data_model_1.NodeClass.Unspecified;
        (0, node_opcua_assert_1.assert)(this.nodeClass === node_opcua_data_model_1.NodeClass.Unspecified, "must not be specify a nodeClass");
        (0, node_opcua_assert_1.assert)(options.addressSpace);
        (0, node_opcua_assert_1.assert)(options.browseName instanceof node_opcua_data_model_1.QualifiedName, "Expecting a valid QualifiedName");
        (0, node_opcua_assert_1.assert)(options.nodeId instanceof node_opcua_nodeid_1.NodeId, "Expecting a valid NodeId");
        options.references = options.references || [];
        const _private = (0, base_node_private_1.BaseNode_initPrivate)(this);
        _private.__address_space = options.addressSpace;
        this.nodeId = (0, node_opcua_nodeid_1.resolveNodeId)(options.nodeId);
        this.browseName = _get_QualifiedBrowseName(options.browseName);
        options.displayName = options.displayName || this.browseName.name.toString();
        if (options.description === void 0) {
          options.description = null;
        }
        this._setDisplayName(options.displayName);
        this._setDescription(options.description);
        const _browseFilter = options.browseFilter || defaultBrowseFilterFunc;
        (0, node_opcua_assert_1.assert)(typeof _browseFilter === "function");
        _private._browseFilter = _browseFilter;
        for (const reference of options.references) {
          this.__addReference(reference);
        }
        this._accessRestrictions = options.accessRestrictions;
        this._rolePermissions = (0, role_permissions_1.coerceRolePermissions)(options.rolePermissions);
      }
      getDisplayName(locale) {
        const _private = (0, base_node_private_1.BaseNode_getPrivate)(this);
        return _private._displayName[0].text;
      }
      get namespace() {
        return this.addressSpacePrivate.getNamespace(this.nodeId.namespace);
      }
      // ---------------------------------------------------------------------------------------------------
      // Finders
      // ---------------------------------------------------------------------------------------------------
      findReferencesEx(referenceType, browseDirection) {
        browseDirection = browseDirection !== void 0 ? browseDirection : node_opcua_data_model_1.BrowseDirection.Forward;
        (0, node_opcua_assert_1.assert)(_is_valid_BrowseDirection(browseDirection));
        (0, node_opcua_assert_1.assert)(browseDirection !== node_opcua_data_model_1.BrowseDirection.Both);
        const referenceTypeNode = this._coerceReferenceType(referenceType);
        if (!referenceTypeNode) {
          return [];
        }
        const isForward = browseDirection === node_opcua_data_model_1.BrowseDirection.Forward;
        const results = [];
        const process2 = (referenceIdx) => {
          const references = Object.values(referenceIdx);
          for (const ref of references) {
            if (ref.isForward === isForward && referenceTypeNode && referenceTypeNode.checkHasSubtype(ref.referenceType)) {
              results.push(ref);
            }
          }
        };
        const _private = (0, base_node_private_1.BaseNode_getPrivate)(this);
        process2(_private._referenceIdx);
        process2(_private._back_referenceIdx);
        return results;
      }
      findReferences_no_cache(referenceTypeNode, isForward = true) {
        const _private = (0, base_node_private_1.BaseNode_getPrivate)(this);
        const result2 = [];
        for (const ref of Object.values(_private._referenceIdx)) {
          if (ref.isForward === isForward) {
            if ((0, node_opcua_nodeid_1.sameNodeId)(ref.referenceType, referenceTypeNode.nodeId)) {
              result2.push(ref);
            }
          }
        }
        for (const ref of Object.values(_private._back_referenceIdx)) {
          if (ref.isForward === isForward) {
            if ((0, node_opcua_nodeid_1.sameNodeId)(ref.referenceType, referenceTypeNode.nodeId)) {
              result2.push(ref);
            }
          }
        }
        return result2;
      }
      findReferences(referenceType, isForward = true) {
        const _cache = (0, base_node_private_1.BaseNode_getCache)(this);
        const referenceTypeNode = this._coerceReferenceType(referenceType);
        if (!referenceTypeNode) {
          return [];
        }
        _cache._ref = _cache._ref || {};
        const hash = "_ref_" + referenceTypeNode.nodeId.toString() + isForward.toString();
        if (_cache._ref[hash]) {
          return _cache._ref[hash];
        }
        if (doDebug && !this.addressSpace.findReferenceType(referenceTypeNode.nodeId)) {
          throw new Error("expecting valid reference name " + referenceType);
        }
        const result2 = this.findReferences_no_cache(referenceTypeNode, isForward);
        _cache._ref[hash] = result2;
        return result2;
      }
      findReference(strReference, isForward) {
        const refs = this.findReferences(strReference, isForward);
        if (refs.length !== 1 && refs.length !== 0) {
          throw new Error("findReference: expecting only one or zero element here");
        }
        return refs[0] || null;
      }
      findReferencesExAsObject(referenceType, browseDirection) {
        const references = this.findReferencesEx(referenceType, browseDirection);
        return _asObject(references, this.addressSpace);
      }
      findReferencesAsObject(referenceType, isForward) {
        const references = this.findReferences(referenceType, isForward);
        return _asObject(references, this.addressSpace);
      }
      /**
       * return an array with the Aggregates of this object.
       */
      getAggregates() {
        return this.findReferencesExAsObject("Aggregates", node_opcua_data_model_1.BrowseDirection.Forward);
      }
      /**
       * return an array with the components of this object.
       */
      getComponents() {
        return this.findReferencesExAsObject("HasComponent", node_opcua_data_model_1.BrowseDirection.Forward);
      }
      /**
       *  return a array with the properties of this object.
       */
      getProperties() {
        return this.findReferencesExAsObject("HasProperty", node_opcua_data_model_1.BrowseDirection.Forward);
      }
      /**
       * return a array with the notifiers of this object.
       * only reference of exact type HasNotifier are returned.
       */
      getNotifiers() {
        return this.findReferencesAsObject(HasNotifierReferenceType, true);
      }
      /**
       * return a array with the event source of this object.
       *  only reference of exact type HasEventSource are returned.
       */
      getEventSources() {
        return this.findReferencesAsObject(HasEventSourceReferenceType, true);
      }
      /**
       * return a array of the objects for which this node is an EventSource
       */
      getEventSourceOfs() {
        return this.findReferencesAsObject(HasEventSourceReferenceType, false);
      }
      getComponentByName(browseName, namespaceIndex) {
        const components = this.getComponents();
        const select = _filter_by_browse_name(components, browseName, namespaceIndex);
        (0, node_opcua_assert_1.assert)(select.length <= 1, "BaseNode#getComponentByName found duplicated reference");
        if (select.length === 1) {
          const component = select[0];
          if (component.nodeClass === node_opcua_data_model_1.NodeClass.Method) {
            warningLog("please use getMethodByName to retrieve a method");
            return null;
          }
          (0, node_opcua_assert_1.assert)(component.nodeClass === node_opcua_data_model_1.NodeClass.Variable || component.nodeClass === node_opcua_data_model_1.NodeClass.Object);
          return component;
        } else {
          return null;
        }
      }
      getPropertyByName(browseName, namespaceIndex) {
        const properties = this.getProperties();
        const select = _filter_by_browse_name(properties, browseName, namespaceIndex);
        (0, node_opcua_assert_1.assert)(select.length <= 1, "BaseNode#getPropertyByName found duplicated reference");
        if (select.length === 1 && select[0].nodeClass !== node_opcua_data_model_1.NodeClass.Variable) {
          throw new Error("Expecting a property to be of nodeClass==NodeClass.Variable");
        }
        return select.length === 1 ? select[0] : null;
      }
      getFolderElementByName(browseName, namespaceIndex) {
        const elements = this.getFolderElements();
        const select = _filter_by_browse_name(elements, browseName, namespaceIndex);
        return select.length === 1 ? select[0] : null;
      }
      /**
       * returns the list of nodes that this folder object organizes
       */
      getFolderElements() {
        return this.findReferencesExAsObject("Organizes", node_opcua_data_model_1.BrowseDirection.Forward);
      }
      /**
       * returns the list of methods that this object provides
       * @method getMethods
       * @return an array with Method objects.
       *
       *
       * Note: internally, methods are special types of components
       */
      getMethods() {
        const components = this.getComponents();
        return components.filter((obj) => obj.nodeClass === node_opcua_data_model_1.NodeClass.Method);
      }
      /**
       * returns the method exposed by this object and with the given nodeId
       */
      getMethodById(nodeId) {
        const methods = this.getMethods();
        const found = methods.find((m2) => m2.nodeId.toString() === nodeId.toString());
        return found || null;
      }
      getMethodByName(methodName, namespaceIndex) {
        const methods = this.getMethods();
        const select = _filter_by_browse_name(methods, methodName, namespaceIndex);
        (0, node_opcua_assert_1.assert)(select.length <= 1, "BaseNode#getMethodByName found duplicated reference");
        return select.length === 1 ? select[0] : null;
      }
      getWriteMask() {
        return 0;
      }
      getUserWriteMask() {
        return 0;
      }
      readAttribute(context, attributeId, indexRange, dataEncoding) {
        indexRange;
        dataEncoding;
        (0, node_opcua_assert_1.assert)(!context || context instanceof session_context_1.SessionContext);
        const options = {};
        options.statusCode = node_opcua_status_code_1.StatusCodes.Good;
        switch (attributeId) {
          case node_opcua_data_model_1.AttributeIds.NodeId:
            options.value = { dataType: node_opcua_variant_1.DataType.NodeId, value: this.nodeId };
            break;
          case node_opcua_data_model_1.AttributeIds.NodeClass:
            (0, node_opcua_assert_1.assert)(isFinite(this.nodeClass));
            options.value = { dataType: node_opcua_variant_1.DataType.Int32, value: this.nodeClass };
            break;
          case node_opcua_data_model_1.AttributeIds.BrowseName:
            (0, node_opcua_assert_1.assert)(this.browseName instanceof node_opcua_data_model_1.QualifiedName);
            options.value = { dataType: node_opcua_variant_1.DataType.QualifiedName, value: this.browseName };
            break;
          case node_opcua_data_model_1.AttributeIds.DisplayName:
            options.value = { dataType: node_opcua_variant_1.DataType.LocalizedText, value: this.displayName[0] };
            break;
          case node_opcua_data_model_1.AttributeIds.Description:
            options.value = { dataType: node_opcua_variant_1.DataType.LocalizedText, value: this.description };
            break;
          case node_opcua_data_model_1.AttributeIds.WriteMask:
            options.value = { dataType: node_opcua_variant_1.DataType.UInt32, value: this.getWriteMask() };
            break;
          case node_opcua_data_model_1.AttributeIds.UserWriteMask:
            options.value = { dataType: node_opcua_variant_1.DataType.UInt32, value: this.getUserWriteMask() };
            break;
          case node_opcua_data_model_1.AttributeIds.AccessRestrictions:
            return this._readAccessRestrictions(context);
          case node_opcua_data_model_1.AttributeIds.RolePermissions:
            return this._readRolePermissions(context);
          case node_opcua_data_model_1.AttributeIds.UserRolePermissions:
            return this._readUserRolePermissions(context);
          default:
            options.value = null;
            options.statusCode = node_opcua_status_code_1.StatusCodes.BadAttributeIdInvalid;
            break;
        }
        return new node_opcua_data_value_1.DataValue(options);
      }
      writeAttribute(context, writeValue, callback) {
        context = context || session_context_1.SessionContext.defaultContext;
        (0, node_opcua_assert_1.assert)(context instanceof session_context_1.SessionContext);
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        if (writeValue.attributeId === void 0 || writeValue.attributeId <= 0 || writeValue.attributeId > node_opcua_data_model_1.AttributeIds.AccessLevelEx) {
          return callback(null, node_opcua_status_code_1.StatusCodes.BadAttributeIdInvalid);
        }
        if (!this.canUserWriteAttribute(context, writeValue.attributeId)) {
          return callback(null, node_opcua_status_code_1.StatusCodes.BadUserAccessDenied);
        }
        callback(null, node_opcua_status_code_1.StatusCodes.BadNotWritable);
      }
      fullName() {
        if (this.parentNodeId) {
          const parent = this.addressSpace.findNode(this.parentNodeId);
          if (parent) {
            return parent.fullName() + "." + this.browseName.toString();
          } else {
            return "NOT YET REGISTERED" + this.parentNodeId.toString() + "." + this.browseName.toString();
          }
        }
        return this.browseName.toString();
      }
      ownReferences() {
        const _private = (0, base_node_private_1.BaseNode_getPrivate)(this);
        return Object.values(_private._referenceIdx);
      }
      /**
       * @method browseNodeByTargetName
       *
       * @param relativePathElement
       * @param isLast
       * @return {NodeId[]}
       */
      browseNodeByTargetName(relativePathElement, isLast) {
        relativePathElement.targetName = relativePathElement.targetName || new node_opcua_data_model_1.QualifiedName({});
        (0, node_opcua_assert_1.assert)(relativePathElement.targetName instanceof node_opcua_data_model_1.QualifiedName);
        (0, node_opcua_assert_1.assert)(relativePathElement.targetName.namespaceIndex >= 0);
        (0, node_opcua_assert_1.assert)(relativePathElement.targetName.name.length > 0);
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(relativePathElement, "referenceTypeId"));
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(relativePathElement, "isInverse"));
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(relativePathElement, "includeSubtypes"));
        const references = this.allReferences();
        const _check_reference = (reference) => {
          if (relativePathElement.referenceTypeId.isEmpty()) {
            return true;
          }
          (0, node_opcua_assert_1.assert)(relativePathElement.referenceTypeId instanceof node_opcua_nodeid_1.NodeId);
          if (relativePathElement.isInverse && reference.isForward || !relativePathElement.isInverse && !reference.isForward) {
            return false;
          }
          (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(reference, "isForward"));
          const referenceType = resolveReferenceType(this.addressSpace, reference);
          const referenceTypeId = referenceType.nodeId;
          if ((0, node_opcua_nodeid_1.sameNodeId)(relativePathElement.referenceTypeId, referenceTypeId)) {
            return true;
          }
          if (relativePathElement.includeSubtypes) {
            const baseType = this.addressSpace.findReferenceType(relativePathElement.referenceTypeId);
            if (baseType && referenceType.isSubtypeOf(baseType)) {
              return true;
            }
          }
          return false;
        };
        const nodeIdsMap = {};
        let nodeIds = [];
        for (const reference of references) {
          if (!_check_reference(reference)) {
            continue;
          }
          const obj = resolveReferenceNode(this.addressSpace, reference);
          if (!obj) {
            throw new Error(" cannot find node with id " + reference.nodeId.toString());
          }
          if ((0, lodash_1.isEqual)(obj.browseName, relativePathElement.targetName)) {
            const key = obj.nodeId.toString();
            if (!Object.prototype.hasOwnProperty.call(nodeIdsMap, key)) {
              nodeIds.push(obj.nodeId);
              nodeIdsMap[key] = obj;
            }
          }
        }
        if (nodeIds.length === 0 && (this.nodeClass === node_opcua_data_model_1.NodeClass.ObjectType || this.nodeClass === node_opcua_data_model_1.NodeClass.VariableType)) {
          const nodeType = this;
          if (nodeType.subtypeOf) {
            const baseType = this.addressSpace.findNode(nodeType.subtypeOf);
            const n = baseType.browseNodeByTargetName(relativePathElement, isLast);
            nodeIds = [].concat(nodeIds, n);
          }
        }
        return nodeIds;
      }
      /**
       * browse the node to extract information requested in browseDescription
       * and returns an array with reference descriptions
       *
       *
       *
       */
      browseNode(browseDescription, context) {
        (0, node_opcua_assert_1.assert)(isFinite(browseDescription.nodeClassMask));
        const do_debug = false;
        const _private = (0, base_node_private_1.BaseNode_getPrivate)(this);
        const addressSpace = this.addressSpace;
        const referenceTypeId = normalize_referenceTypeId(addressSpace, browseDescription.referenceTypeId);
        (0, node_opcua_assert_1.assert)(referenceTypeId instanceof node_opcua_nodeid_1.NodeId);
        const browseDirection = browseDescription.browseDirection !== void 0 ? browseDescription.browseDirection : node_opcua_data_model_1.BrowseDirection.Both;
        let references = this.allReferences();
        if (do_debug) {
          debugLog("all references :", this.nodeId.toString(), this.browseName.toString());
          (0, dump_tools_1.dumpReferences)(addressSpace, Object.values(_private._referenceIdx));
        }
        references = _filter_by_referenceType.call(this, browseDescription, references, referenceTypeId);
        references = _filter_by_direction(references, browseDirection);
        references = _filter_by_nodeClass.call(this, references, browseDescription.nodeClassMask);
        references = _filter_by_userFilter.call(this, references, context);
        if (context) {
          references = _filter_by_context(this, references, context);
        }
        const referenceDescriptions = (0, base_node_private_1._constructReferenceDescription)(addressSpace, references, browseDescription.resultMask);
        if (do_debug) {
          (0, dump_tools_1.dumpReferenceDescriptions)(this.addressSpace, referenceDescriptions);
        }
        return referenceDescriptions;
      }
      allReferences() {
        const _private = (0, base_node_private_1.BaseNode_getPrivate)(this);
        return Object.values(_private._referenceIdx).concat(Object.values(_private._back_referenceIdx));
      }
      /**
       * @method addReference
       * @param reference
       * @param reference.referenceType {String}
       * @param [reference.isForward = true] {Boolean}
       * @param reference.nodeId {Node|NodeId|String}
       *
       * @example
       *
       *     view.addReference({ referenceType: "Organizes", nodeId: myDevice });
       *
       * or
       *
       *     myDevice1.addReference({ referenceType: "OrganizedBy", nodeId: view });
       */
      addReference(reference) {
        const referenceNode = this.__addReference(reference);
        const addressSpace = this.addressSpace;
        if (!resolveReferenceType(addressSpace, referenceNode)) {
          throw new Error("BaseNode#addReference : invalid reference  " + reference.toString());
        }
        this._clear_caches();
        _propagate_ref.call(this, addressSpace, referenceNode);
        this.install_extra_properties();
        (0, address_space_change_event_tools_1._handle_add_reference_change_event)(this, referenceNode.nodeId);
      }
      removeReference(referenceOpts) {
        const _private = (0, base_node_private_1.BaseNode_getPrivate)(this);
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(referenceOpts, "referenceType"));
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(referenceOpts, "nodeId"));
        const addressSpace = this.addressSpace;
        if (!addressSpace) {
          debugLog("Where is addressSpace ?");
        }
        const reference = addressSpace.normalizeReferenceTypes([referenceOpts])[0];
        const h = reference.hash;
        const relatedNode = addressSpace.findNode(reference.nodeId);
        const invReference = new reference_impl_1.ReferenceImpl({
          isForward: !reference.isForward,
          nodeId: this.nodeId,
          referenceType: reference.referenceType
        });
        if (_private._referenceIdx[h]) {
          delete _private._referenceIdx[h];
          base_node_private_1.BaseNode_remove_backward_reference.call(relatedNode, invReference);
        } else if (_private._back_referenceIdx[h]) {
          relatedNode.removeReference(invReference);
        } else {
        }
        (0, base_node_private_1._handle_HierarchicalReference)(this, reference);
        this.uninstall_extra_properties(reference);
        this._clear_caches();
      }
      /**
       *
       */
      resolveNodeId(nodeId) {
        return this.addressSpace.resolveNodeId(nodeId);
      }
      install_extra_properties() {
        const addressSpace = this.addressSpace;
        if (addressSpace.isFrugal) {
          return;
        }
        install_components_as_object_properties(this);
        function install_extra_properties_on_parent(ref) {
          const node = reference_impl_1.ReferenceImpl.resolveReferenceNode(addressSpace, ref);
          install_components_as_object_properties(node);
        }
        const parentComponents = this.findReferencesEx("HasComponent", node_opcua_data_model_1.BrowseDirection.Inverse);
        const parentSubfolders = this.findReferencesEx("Organizes", node_opcua_data_model_1.BrowseDirection.Inverse);
        const parentProperties = this.findReferencesEx("HasProperty", node_opcua_data_model_1.BrowseDirection.Inverse);
        for (const p3 of parentComponents) {
          install_extra_properties_on_parent(p3);
        }
        for (const p3 of parentSubfolders) {
          install_extra_properties_on_parent(p3);
        }
        for (const p3 of parentProperties) {
          install_extra_properties_on_parent(p3);
        }
      }
      uninstall_extra_properties(reference) {
        const addressSpace = this.addressSpace;
        if (addressSpace.isFrugal) {
          return;
        }
        const childNode = resolveReferenceNode(addressSpace, reference);
        const name = (0, node_opcua_utils_1.lowerFirstLetter)(childNode.browseName.name.toString());
        if (Object.prototype.hasOwnProperty.call(reservedNames, name)) {
          if (doDebug) {
            debugLog(chalk_1.default.bgWhite.red("Ignoring reserved keyword                                     " + name));
          }
          return;
        }
        if (!Object.prototype.hasOwnProperty.call(this, name)) {
          return;
        }
        Object.defineProperty(this, name, {
          value: void 0
        });
      }
      toString() {
        const options = new base_node_private_1.ToStringBuilder();
        base_node_private_1.BaseNode_toString.call(this, options);
        return options.toString();
      }
      /**
       * @property isFalseSubStateOf
       * @type {BaseNode|null}
       */
      get isFalseSubStateOf() {
        const r = this.findReferencesAsObject("HasFalseSubState", false);
        if (!r || r.length === 0) {
          return null;
        }
        (0, node_opcua_assert_1.assert)(r.length === 1);
        return r[0];
      }
      /**
       * @property isTrueSubStateOf
       * @type {BaseNode|null}
       */
      get isTrueSubStateOf() {
        const r = this.findReferencesAsObject("HasTrueSubState", false);
        if (!r || r.length === 0) {
          return null;
        }
        (0, node_opcua_assert_1.assert)(r.length === 1);
        return r[0];
      }
      /**
       * @method getFalseSubStates
       * @return {UAStateVariable[]} return an array with the SubStates of this object.
       */
      getFalseSubStates() {
        return this.findReferencesAsObject("HasFalseSubState");
      }
      /**
       * @method getTrueSubStates
       * @return {UAStateVariable[]} return an array with the SubStates of this object.
       */
      getTrueSubStates() {
        return this.findReferencesAsObject("HasTrueSubState");
      }
      findHierarchicalReferences() {
        return this.findReferencesEx("HierarchicalReferences", node_opcua_data_model_1.BrowseDirection.Forward);
      }
      getChildByName(browseName, namespaceIndex) {
        if (browseName instanceof node_opcua_data_model_1.QualifiedName) {
          browseName = browseName.name.toString();
        }
        (0, node_opcua_assert_1.assert)(typeof browseName === "string");
        const _cache = (0, base_node_private_1.BaseNode_getCache)(this);
        const addressSpace = this.addressSpace;
        if (!_cache._childByNameMap) {
          _cache._childByNameMap = {};
          const childReferenceTypes = this.findReferencesEx("HasChild");
          for (const r of childReferenceTypes) {
            const child = resolveReferenceNode(addressSpace, r);
            _cache._childByNameMap[child.browseName.name.toString()] = child;
          }
        }
        const ret = _cache._childByNameMap[browseName.toString()] || null;
        return ret;
      }
      get toStateNode() {
        const nodes = this.findReferencesAsObject("ToState", true);
        (0, node_opcua_assert_1.assert)(nodes.length <= 1);
        return nodes.length === 1 ? nodes[0] : null;
      }
      get fromStateNode() {
        const nodes = this.findReferencesAsObject("FromState", true);
        (0, node_opcua_assert_1.assert)(nodes.length <= 1);
        return nodes.length === 1 ? nodes[0] : null;
      }
      /**
       * this methods propagates the forward references to the pointed node
       * by inserting backward references to the counter part node
       */
      propagate_back_references() {
        const _private = (0, base_node_private_1.BaseNode_getPrivate)(this);
        if (this.addressSpace.suspendBackReference) {
          return;
        }
        const addressSpace = this.addressSpace;
        for (const reference of Object.values(_private._referenceIdx)) {
          _propagate_ref.call(this, addressSpace, reference);
        }
      }
      /**
       * the dispose method should be called when the node is no longer used, to release
       * back pointer to the address space and clear caches.
       *
       * @method dispose
       *
       */
      dispose() {
        this.emit("dispose");
        this.removeAllListeners();
        this._clear_caches();
        const _private = (0, base_node_private_1.BaseNode_getPrivate)(this);
        Object.values(_private._back_referenceIdx).forEach((ref) => ref.dispose());
        Object.values(_private._referenceIdx).forEach((ref) => ref.dispose());
        (0, base_node_private_1.BaseNode_removePrivate)(this);
      }
      isDisposed() {
        return !this.addressSpacePrivate;
      }
      // istanbul ignore next
      dumpXML(xmlWriter) {
        console.error(" This ", node_opcua_data_model_1.NodeClass[this.nodeClass]);
        (0, node_opcua_assert_1.assert)(false, "BaseNode#dumpXML NOT IMPLEMENTED !");
        (0, node_opcua_assert_1.assert)(xmlWriter);
      }
      /**
       * Undo the effect of propagate_back_references
       */
      unpropagate_back_references() {
        const _private = (0, base_node_private_1.BaseNode_getPrivate)(this);
        const addressSpace = this.addressSpace;
        for (const reference of Object.values(_private._referenceIdx)) {
          const referenceType = resolveReferenceType(addressSpace, reference);
          if (!referenceType) {
            console.error(chalk_1.default.red(" ERROR"), " cannot find reference ", reference.referenceType, reference.toString());
          }
          const related_node = resolveReferenceNode(addressSpace, reference);
          if (related_node) {
            (0, node_opcua_assert_1.assert)(reference.nodeId.toString() !== this.nodeId.toString());
            base_node_private_1.BaseNode_remove_backward_reference.call(related_node, new reference_impl_1.ReferenceImpl({
              isForward: !reference.isForward,
              nodeId: this.nodeId,
              referenceType: reference.referenceType
            }));
          }
        }
      }
      installPostInstallFunc(f2) {
        if (!f2) {
          return;
        }
        function chain(f1, f22) {
          return function chaiFunc(...args) {
            if (f1) {
              f1.apply(this, args);
            }
            if (f22) {
              f22.apply(this, args);
            }
          };
        }
        this._postInstantiateFunc = chain.call(this, this._postInstantiateFunc, f2);
      }
      _on_child_added() {
        this._clear_caches();
      }
      _on_child_removed(obj) {
        this._clear_caches();
      }
      /**
       * @private
       * @param reference
       */
      _add_backward_reference(reference) {
        base_node_private_1.BaseNode_add_backward_reference.call(this, reference);
      }
      _coerceReferenceType(referenceType) {
        let result2;
        if (typeof referenceType === "string") {
          result2 = this.addressSpace.findReferenceType(referenceType);
          if (!result2) {
            errorLog("referenceType ", referenceType, " cannot be found");
            throw new Error("Cannot coerce reference with name " + referenceType);
          }
        } else if (referenceType instanceof node_opcua_nodeid_1.NodeId) {
          result2 = this.addressSpace.findNode(referenceType);
          if (!result2) {
            return null;
          }
        } else {
          result2 = referenceType;
        }
        (0, node_opcua_assert_1.assert)(result2, "reference must exists");
        (0, node_opcua_assert_1.assert)(result2.nodeClass === node_opcua_data_model_1.NodeClass.ReferenceType);
        return result2;
      }
      __addReference(referenceOpts) {
        const _private = (0, base_node_private_1.BaseNode_getPrivate)(this);
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(referenceOpts, "referenceType"));
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(referenceOpts, "nodeId"));
        const addressSpace = this.addressSpace;
        const reference = addressSpace.normalizeReferenceTypes([referenceOpts])[0];
        (0, node_opcua_assert_1.assert)(reference instanceof reference_impl_1.ReferenceImpl);
        const h = reference.hash;
        (0, node_opcua_assert_1.assert)(!_private._back_referenceIdx[h], "reference exists already in _back_references");
        (0, node_opcua_assert_1.assert)(!_private._referenceIdx[h], "reference exists already in _references");
        _private._referenceIdx[h] = reference;
        (0, base_node_private_1._handle_HierarchicalReference)(this, reference);
        return reference;
      }
      _setDisplayName(displayName) {
        const displayNames = Array.isArray(displayName) ? displayName : [displayName];
        const _displayNames = displayNames.map(node_opcua_data_model_1.coerceLocalizedText);
        const _private = (0, base_node_private_1.BaseNode_getPrivate)(this);
        _private._displayName = _displayNames;
      }
      _setDescription(description) {
        const __description = (0, node_opcua_data_model_1.coerceLocalizedText)(description);
        const _private = (0, base_node_private_1.BaseNode_getPrivate)(this);
        _private._description = __description;
      }
      _notifyAttributeChange(attributeId) {
        const event_name = _BaseNodeImpl.makeAttributeEventName(attributeId);
        this.emit(event_name, this.readAttribute(session_context_1.SessionContext.defaultContext, attributeId));
      }
      _clear_caches() {
        (0, base_node_private_1.BaseNode_clearCache)(this);
      }
      canUserWriteAttribute(context, attributeId) {
        if (!context)
          return true;
        if (attributeId === node_opcua_data_model_1.AttributeIds.Historizing) {
          return context.checkPermission(this, node_opcua_types_1.PermissionType.WriteHistorizing);
        }
        if (attributeId === node_opcua_data_model_1.AttributeIds.RolePermissions) {
          return context.checkPermission(this, node_opcua_types_1.PermissionType.WriteRolePermissions);
        }
        if (attributeId === node_opcua_data_model_1.AttributeIds.Value) {
          return context.checkPermission(this, node_opcua_types_1.PermissionType.Write);
        }
        return context.checkPermission(this, node_opcua_types_1.PermissionType.WriteAttribute);
      }
      _readAccessRestrictions(context) {
        if (this.accessRestrictions === void 0) {
          return new node_opcua_data_value_1.DataValue({ statusCode: node_opcua_status_code_1.StatusCodes.BadAttributeIdInvalid });
        }
        return new node_opcua_data_value_1.DataValue({
          statusCode: node_opcua_status_code_1.StatusCodes.Good,
          value: {
            dataType: node_opcua_variant_1.DataType.UInt16,
            value: this.accessRestrictions
          }
        });
      }
      _readRolePermissions(context) {
        if (context && !context.checkPermission(this, node_opcua_types_1.PermissionType.ReadRolePermissions)) {
          return new node_opcua_data_value_1.DataValue({
            statusCode: node_opcua_status_code_1.StatusCodes.BadSecurityModeInsufficient
          });
        }
        if (this.rolePermissions === void 0) {
          return new node_opcua_data_value_1.DataValue({
            statusCode: node_opcua_status_code_1.StatusCodes.BadAttributeIdInvalid
          });
        }
        const rolePermissions = this.rolePermissions.map(({ roleId, permissions }) => {
          return new node_opcua_types_1.RolePermissionType({
            roleId: toRoleNodeId(roleId),
            permissions
          });
        });
        return new node_opcua_data_value_1.DataValue({
          statusCode: node_opcua_status_code_1.StatusCodes.Good,
          value: {
            dataType: node_opcua_variant_1.DataType.ExtensionObject,
            arrayType: node_opcua_variant_1.VariantArrayType.Array,
            value: rolePermissions
          }
        });
      }
      _readUserRolePermissions(context) {
        const allUserCanSeeTheirOwnRolePermissions = true;
        if (!allUserCanSeeTheirOwnRolePermissions) {
          if (context && !context.checkPermission(this, node_opcua_types_1.PermissionType.ReadRolePermissions)) {
            return new node_opcua_data_value_1.DataValue({
              statusCode: node_opcua_status_code_1.StatusCodes.BadSecurityModeInsufficient
            });
          }
        }
        if (this.rolePermissions === void 0) {
          return new node_opcua_data_value_1.DataValue({
            statusCode: node_opcua_status_code_1.StatusCodes.BadAttributeIdInvalid
          });
        }
        const context1 = context === null ? session_context_1.SessionContext.defaultContext : context;
        const rolePermissions = this.rolePermissions.map(({ roleId, permissions }) => {
          return new node_opcua_types_1.RolePermissionType({
            roleId: toRoleNodeId(roleId),
            permissions
          });
        }).filter(({ roleId }) => context1.currentUserHasRole(roleId));
        return new node_opcua_data_value_1.DataValue({
          statusCode: node_opcua_status_code_1.StatusCodes.Good,
          value: {
            dataType: node_opcua_variant_1.DataType.ExtensionObject,
            arrayType: node_opcua_variant_1.VariantArrayType.Array,
            value: rolePermissions
          }
        });
      }
      /**
       *
       * @param rolePermissions
       */
      setRolePermissions(rolePermissions) {
        this._rolePermissions = (0, role_permissions_1.coerceRolePermissions)(rolePermissions);
      }
      getRolePermissions(inherited) {
        if (this.rolePermissions === void 0 && inherited) {
          return this.namespace.getDefaultRolePermissions();
        }
        return this._rolePermissions || null;
      }
      get rolePermissions() {
        return this._rolePermissions || void 0;
      }
      setAccessRestrictions(accessRestrictions) {
        this._accessRestrictions = accessRestrictions;
      }
      get accessRestrictions() {
        return this._accessRestrictions;
      }
      getAccessRestrictions(inherited) {
        if (this._accessRestrictions === void 0 && inherited) {
          return this.namespace.getDefaultAccessRestrictions();
        }
        return this._accessRestrictions || node_opcua_data_model_1.AccessRestrictionsFlag.None;
      }
    };
    exports2.BaseNodeImpl = BaseNodeImpl;
    function toRoleNodeId(s) {
      if (typeof s === "string") {
        return (0, node_opcua_nodeid_1.resolveNodeId)(session_context_1.WellKnownRolesNodeId[s]);
      }
      return (0, node_opcua_nodeid_1.coerceNodeId)(s);
    }
    var displayWarning = true;
    function toString_ReferenceDescription(ref, options) {
      const addressSpace = options.addressSpace;
      const refNode = addressSpace.findNode(ref.referenceType);
      if (!refNode) {
        return "Unknown Ref : " + ref;
      }
      const r = new reference_impl_1.ReferenceImpl({
        isForward: ref.isForward,
        nodeId: ref.nodeId,
        referenceType: refNode.browseName.toString()
      });
      const str = r.toString(options);
      r.dispose();
      return str;
    }
    function _setup_parent_item(references) {
      references = Object.values(references);
      const _private = (0, base_node_private_1.BaseNode_getPrivate)(this);
      (0, node_opcua_assert_1.assert)(!_private._parent, "_setup_parent_item has been already called");
      const addressSpace = this.addressSpace;
      if (references.length > 0) {
        references = this.findReferencesEx("Aggregates", node_opcua_data_model_1.BrowseDirection.Inverse);
        if (references.length >= 1) {
          if (references.length > 1) {
            if (displayWarning) {
              const options = { addressSpace };
              console.warn("  More than one Aggregates reference have been found for parent of object");
              console.warn("    object node id:", this.nodeId.toString(), chalk_1.default.cyan(this.browseName.toString()));
              console.warn("    browseResults:");
              console.warn(references.map((f2) => toString_ReferenceDescription(f2, options)).join("\n"));
              console.warn("    first one will be used as parent");
              displayWarning = false;
            }
          }
          return reference_impl_1.ReferenceImpl.resolveReferenceNode(addressSpace, references[0]);
        }
      }
      return null;
    }
    function _asObject(references, addressSpace) {
      function toObject(reference) {
        const obj = resolveReferenceNode(addressSpace, reference);
        if (doDebug && !obj) {
          debugLog(chalk_1.default.red(" Warning :  object with nodeId ") + chalk_1.default.cyan(reference.nodeId.toString()) + chalk_1.default.red(" cannot be found in the address space !"));
        }
        return obj;
      }
      function remove_null(o2) {
        return !!o2;
      }
      return references.map(toObject).filter(remove_null);
    }
    function _filter_by_browse_name(components, browseName, namespaceIndex) {
      let select = [];
      if ((namespaceIndex === null || namespaceIndex === void 0) && typeof browseName === "string") {
        select = components.filter((c2) => c2.browseName.name.toString() === browseName);
        if (select && select.length > 1) {
          warningLog("Multiple children exist with name ", browseName, " please specify a namespace index");
        }
      } else {
        const _browseName = (0, node_opcua_data_model_1.coerceQualifiedName)(typeof browseName === "string" ? { name: browseName, namespaceIndex } : browseName);
        select = components.filter((c2) => c2.browseName.name === _browseName.name && c2.browseName.namespaceIndex === _browseName.namespaceIndex);
      }
      return select;
    }
    var displayWarningReferencePointingToItSelf = true;
    function _is_massively_used_reference(referenceType) {
      const name = referenceType.browseName.toString();
      return name === "HasTypeDefinition" || name === "HasModellingRule";
    }
    function _propagate_ref(addressSpace, reference) {
      const referenceType = reference_impl_1.ReferenceImpl.resolveReferenceType(addressSpace, reference);
      if (!referenceType) {
        console.error(chalk_1.default.red(" ERROR"), " cannot find reference ", reference.referenceType, reference.toString());
      }
      if (!referenceType || _is_massively_used_reference(referenceType)) {
        return;
      }
      const related_node = resolveReferenceNode(addressSpace, reference);
      if (related_node) {
        if ((0, node_opcua_nodeid_1.sameNodeId)(reference.nodeId, this.nodeId)) {
          if (displayWarningReferencePointingToItSelf) {
            console.warn("  Warning: a Reference is pointing to this ", this.nodeId.toString(), this.browseName.toString());
            displayWarningReferencePointingToItSelf = false;
          }
        }
        related_node._add_backward_reference(new reference_impl_1.ReferenceImpl({
          _referenceType: getReferenceType(reference),
          isForward: !reference.isForward,
          node: this,
          nodeId: this.nodeId,
          referenceType: reference.referenceType
        }));
      }
    }
    function nodeid_is_nothing(nodeid) {
      return nodeid.value === 0 && nodeid.namespace === 0;
    }
    function normalize_referenceTypeId(addressSpace, referenceTypeId) {
      if (!referenceTypeId) {
        return (0, node_opcua_nodeid_1.makeNodeId)(0);
      }
      if (typeof referenceTypeId === "string") {
        const ref = addressSpace.findReferenceType(referenceTypeId);
        if (ref) {
          return ref.nodeId;
        }
      }
      let nodeId;
      try {
        nodeId = addressSpace.resolveNodeId(referenceTypeId);
      } catch (err) {
        errorLog("cannot normalize_referenceTypeId", referenceTypeId);
        throw err;
      }
      (0, node_opcua_assert_1.assert)(nodeId);
      return nodeId;
    }
    var resolveReferenceNode = reference_impl_1.ReferenceImpl.resolveReferenceNode;
    var resolveReferenceType = reference_impl_1.ReferenceImpl.resolveReferenceType;
    function _filter_by_referenceType(browseDescription, references, referenceTypeId) {
      if (!nodeid_is_nothing(referenceTypeId)) {
        (0, node_opcua_assert_1.assert)(referenceTypeId instanceof node_opcua_nodeid_1.NodeId);
        const referenceType = this.addressSpace.findNode(referenceTypeId);
        (0, node_opcua_debug_1.dumpIf)(!referenceType, referenceTypeId);
        if (!referenceType || referenceType.nodeClass !== node_opcua_data_model_1.NodeClass.ReferenceType) {
          throw new Error("Cannot find reference type");
        }
        if (!browseDescription.includeSubtypes && referenceType.isAbstract) {
          warningLog("filter by reference will skip all reference as referenceType is abstract and includeSubtypes is false");
        }
        references = references.filter((reference) => {
          const ref = resolveReferenceType(this.addressSpace, reference);
          if (!ref) {
            throw new Error("Cannot find reference type " + reference.toString());
          }
          (0, node_opcua_assert_1.assert)(ref.nodeClass === node_opcua_data_model_1.NodeClass.ReferenceType);
          const isSameType = (0, node_opcua_nodeid_1.sameNodeId)(ref.nodeId, referenceType.nodeId);
          if (isSameType) {
            return true;
          }
          if (browseDescription.includeSubtypes) {
            return ref.isSubtypeOf(referenceType);
          } else {
            return false;
          }
        });
      }
      return references;
    }
    function forwardOnly(reference) {
      return reference.isForward;
    }
    function reverseOnly(reference) {
      return !reference.isForward;
    }
    function _filter_by_direction(references, browseDirection) {
      if (browseDirection === node_opcua_data_model_1.BrowseDirection.Both) {
        return references;
      }
      if (browseDirection === node_opcua_data_model_1.BrowseDirection.Forward) {
        return references.filter(forwardOnly);
      } else {
        return references.filter(reverseOnly);
      }
    }
    function _filter_by_context(node, references, context) {
      const addressSpace = node.addressSpace;
      return references.filter((reference) => !context.isBrowseAccessRestricted(resolveReferenceNode(addressSpace, reference)));
    }
    function _filter_by_nodeClass(references, nodeClassMask) {
      (0, node_opcua_assert_1.assert)(isFinite(nodeClassMask));
      if (nodeClassMask === 0) {
        return references;
      }
      const addressSpace = this.addressSpace;
      return references.filter((reference) => {
        const obj = resolveReferenceNode(addressSpace, reference);
        if (!obj) {
          return false;
        }
        const nodeClassName = node_opcua_data_model_1.NodeClass[obj.nodeClass];
        const value = (0, node_opcua_data_model_1.makeNodeClassMask)(nodeClassName);
        return (value & nodeClassMask) === value;
      });
    }
    function _filter_by_userFilter(references, context) {
      const addressSpace = this.addressSpace;
      return references.filter((reference) => {
        const obj = resolveReferenceNode(addressSpace, reference);
        if (!obj) {
          return false;
        }
        const _private = (0, base_node_private_1.BaseNode_getPrivate)(obj);
        if (!_private._browseFilter) {
          throw Error("Internal error : cannot find browseFilter");
        }
        const filter1 = _private._browseFilter.call(obj, context);
        return filter1;
      });
    }
    var reservedNames = {
      __description: 0,
      __displayName: 0,
      browseName: 0,
      description: 0,
      displayName: 0,
      nodeClass: 0,
      nodeId: 0,
      typeDefinition: 0
    };
    function install_components_as_object_properties(parentObj) {
      if (!parentObj) {
        return;
      }
      const addressSpace = parentObj.addressSpace;
      const hierarchicalRefs = parentObj.findHierarchicalReferences();
      const children = hierarchicalRefs.map((r) => reference_impl_1.ReferenceImpl.resolveReferenceNode(addressSpace, r));
      for (const child of children) {
        if (!child) {
          continue;
        }
        const name = (0, node_opcua_utils_1.lowerFirstLetter)(child.browseName.name.toString());
        if (Object.prototype.hasOwnProperty.call(reservedNames, name)) {
          if (doDebug) {
            debugLog(chalk_1.default.bgWhite.red("Ignoring reserved keyword                                               " + name));
          }
          continue;
        }
        if (doDebug) {
          debugLog("Installing property " + name, " on ", parentObj.browseName.toString());
        }
        if (Object.prototype.hasOwnProperty.call(parentObj, name)) {
          continue;
        }
        Object.defineProperty(parentObj, name, {
          configurable: true,
          // set to true, so we can undefine later
          enumerable: true,
          // xx writable: false,
          get() {
            return child;
          }
          // value: child
        });
      }
    }
    function getReferenceType(reference) {
      return reference._referenceType;
    }
    exports2.getReferenceType = getReferenceType;
  }
});

// node_modules/node-opcua-address-space/dist/src/ua_object_impl.js
var require_ua_object_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/ua_object_impl.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UAObjectImpl = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_data_model_2 = require_dist27();
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_date_time_1 = require_dist17();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_address_space_base_1 = require_dist53();
    var node_opcua_debug_1 = require_dist24();
    var base_node_impl_1 = require_base_node_impl();
    var base_node_private_1 = require_base_node_private();
    var apply_condition_refresh_1 = require_apply_condition_refresh();
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var UAObjectImpl = class _UAObjectImpl extends base_node_impl_1.BaseNodeImpl {
      get eventNotifier() {
        if (!this._eventNotifier) {
          const s = this.getEventSources();
          const n = this.getNotifiers();
          if (s.length > 0 || n.length > 0) {
            this._eventNotifier = this._eventNotifier | node_opcua_address_space_base_1.EventNotifierFlags.SubscribeToEvents;
          }
        }
        return this._eventNotifier;
      }
      get typeDefinitionObj() {
        if (super.typeDefinitionObj.nodeClass !== node_opcua_data_model_1.NodeClass.ObjectType) {
          const msg = `Invalid type definition node class , expecting a ObjectType got ${node_opcua_data_model_1.NodeClass[super.typeDefinitionObj.nodeClass]}
${this.browseName.toString()} ${this.nodeId.toString()}`;
          errorLog(msg);
          throw new Error(msg);
        }
        return super.typeDefinitionObj;
      }
      constructor(options) {
        super(options);
        this.nodeClass = node_opcua_data_model_1.NodeClass.Object;
        this._eventNotifier = options.eventNotifier || node_opcua_address_space_base_1.EventNotifierFlags.None;
        (0, node_opcua_assert_1.assert)(typeof this.eventNotifier === "number" && (0, node_opcua_basic_types_1.isValidByte)(this.eventNotifier));
        this.symbolicName = options.symbolicName || null;
      }
      readAttribute(context, attributeId, indexRange, dataEncoding) {
        indexRange;
        dataEncoding;
        const now = (0, node_opcua_date_time_1.getCurrentClock)();
        const options = {};
        switch (attributeId) {
          case node_opcua_data_model_2.AttributeIds.EventNotifier:
            (0, node_opcua_assert_1.assert)((0, node_opcua_basic_types_1.isValidByte)(this.eventNotifier));
            options.value = { dataType: node_opcua_variant_1.DataType.Byte, value: this.eventNotifier };
            options.serverTimestamp = now.timestamp;
            options.serverPicoseconds = now.picoseconds;
            options.statusCode = node_opcua_status_code_1.StatusCodes.Good;
            break;
          default:
            return base_node_impl_1.BaseNodeImpl.prototype.readAttribute.call(this, context, attributeId, indexRange, dataEncoding);
        }
        return new node_opcua_data_value_1.DataValue(options);
      }
      clone(options, optionalFilter, extraInfo) {
        options = {
          eventNotifier: this.eventNotifier,
          symbolicName: this.symbolicName || void 0,
          ...options
        };
        const cloneObject = (0, base_node_private_1._clone)(this, _UAObjectImpl, options, optionalFilter || node_opcua_address_space_base_1.defaultCloneFilter, extraInfo || (0, node_opcua_address_space_base_1.makeDefaultCloneExtraInfo)(this));
        return cloneObject;
      }
      /**
       * returns true if the object has some opcua methods
       */
      get hasMethods() {
        return this.getMethods().length > 0;
      }
      getMethodByName(methodName, namespaceIndex) {
        return super.getMethodByName(methodName, namespaceIndex);
      }
      getMethods() {
        return super.getMethods();
      }
      setEventNotifier(eventNotifierFlags) {
        this._eventNotifier = eventNotifierFlags;
      }
      /**
       * Raise a transient Event
       */
      raiseEvent(eventType, data) {
        const addressSpace = this.addressSpace;
        if (typeof eventType === "string") {
          const eventTypeFound = addressSpace.findEventType(eventType);
          if (!eventTypeFound) {
            throw new Error("raiseEvent: eventType cannot find event Type " + eventType.toString());
          }
          eventType = eventTypeFound;
          if (!eventType || eventType.nodeClass !== node_opcua_data_model_1.NodeClass.ObjectType) {
            throw new Error("eventType must exist and be an UAObjectType");
          }
        } else if (eventType instanceof node_opcua_nodeid_1.NodeId) {
          const eventTypeFound = addressSpace.findNode(eventType);
          if (!eventTypeFound) {
            throw new Error("raiseEvent: eventType cannot find event Type " + eventType.toString());
          }
          eventType = eventTypeFound;
          if (!eventType || eventType.nodeClass !== node_opcua_data_model_1.NodeClass.ObjectType) {
            throw new Error("eventType must exist and be an UAObjectType" + eventType.toString());
          }
        }
        eventType = eventType;
        let eventTypeNode = eventType;
        if (!eventTypeNode) {
          throw new Error("UAObject#raiseEventType : Cannot find event type :" + eventType.toString());
        }
        eventTypeNode = addressSpace.findEventType(eventType);
        const baseEventType = addressSpace.findEventType("BaseEventType");
        data.$eventDataSource = eventTypeNode;
        data.sourceNode = data.sourceNode || { dataType: node_opcua_variant_1.DataType.NodeId, value: this.nodeId };
        const eventData1 = addressSpace.constructEventData(eventTypeNode, data);
        this._bubble_up_event(eventData1);
      }
      _bubble_up_event(eventData) {
        const addressSpace = this.addressSpace;
        const queue = [];
        const m2 = {};
        const server = addressSpace.findNode("Server");
        if (server) {
          (0, node_opcua_assert_1.assert)(server.eventNotifier > 0, "Server must be an event notifier");
          server.emit("event", eventData);
          m2[server.nodeId.toString()] = server;
        } else {
          errorLog(chalk_1.default.yellow("Warning. ") + chalk_1.default.cyan("UAObject#raiseEvent") + chalk_1.default.red(" cannot find Server object on addressSpace"));
        }
        addInQueue(this);
        function addInQueue(obj) {
          const key = obj.nodeId.toString();
          if (!m2[key]) {
            m2[key] = obj;
            queue.push(obj);
          }
        }
        while (queue.length) {
          const obj = queue.pop();
          obj.emit("event", eventData);
          const elements1 = obj.findReferencesAsObject("HasNotifier", false);
          elements1.forEach(addInQueue);
          const elements2 = obj.findReferencesAsObject("HasEventSource", false);
          elements2.forEach(addInQueue);
        }
      }
      _conditionRefresh(_cache) {
        apply_condition_refresh_1.apply_condition_refresh.call(this, _cache);
      }
      toString() {
        const options = new base_node_private_1.ToStringBuilder();
        base_node_private_1.UAObject_toString.call(this, options);
        return options.toString();
      }
    };
    exports2.UAObjectImpl = UAObjectImpl;
  }
});

// node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_base_event_impl.js
var require_ua_base_event_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_base_event_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UABaseEventImpl = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_variant_1 = require_dist28();
    var ua_object_impl_1 = require_ua_object_impl();
    var UABaseEventImpl = class extends ua_object_impl_1.UAObjectImpl {
      /**
       * @method setSourceName
       * @param name
       */
      setSourceName(name) {
        (0, node_opcua_assert_1.assert)(typeof name === "string");
        this.sourceName.setValueFromSource(new node_opcua_variant_1.Variant({
          dataType: node_opcua_variant_1.DataType.String,
          value: name
        }));
      }
      /**
       * @method setSourceNode
       * @param node {NodeId|UAObject}
       */
      setSourceNode(node) {
        this.sourceNode.setValueFromSource(new node_opcua_variant_1.Variant({
          dataType: node_opcua_variant_1.DataType.NodeId,
          value: node.nodeId ? node.nodeId : node
        }));
      }
    };
    exports2.UABaseEventImpl = UABaseEventImpl;
  }
});

// node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_condition_impl.js
var require_ua_condition_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_condition_impl.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UAConditionImpl = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_basic_types_2 = require_dist23();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_address_space_base_1 = require_dist53();
    var ua_two_state_variable_1 = require_ua_two_state_variable();
    var ua_object_impl_1 = require_ua_object_impl();
    var ua_base_event_impl_1 = require_ua_base_event_impl();
    var condition_snapshot_impl_1 = require_condition_snapshot_impl();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var UAConditionImpl = class _UAConditionImpl extends ua_base_event_impl_1.UABaseEventImpl {
      constructor() {
        super(...arguments);
        this._branch0 = null;
        this._previousRetainFlag = false;
        this._branches = {};
      }
      static instantiate(namespace, conditionTypeId, options, data) {
        return UACondition_instantiate(namespace, conditionTypeId, options, data);
      }
      static install_condition_refresh_handle(addressSpace) {
        const conditionType = addressSpace.findEventType("ConditionType");
        (0, node_opcua_assert_1.assert)(conditionType !== null);
        conditionType.disable.bindMethod(_disable_method);
        conditionType.enable.bindMethod(_enable_method);
        conditionType.conditionRefresh.bindMethod(_condition_refresh_method);
        conditionType.conditionRefresh2.bindMethod(_condition_refresh2_method);
        conditionType.addComment.bindMethod(_add_comment_method);
      }
      /**
       *
       * Helper method to handle condition methods that takes a branchId and a comment
       *
       */
      static with_condition_method(inputArguments, context, callback, inner_func) {
        const conditionNode = context.object;
        if (!(conditionNode instanceof _UAConditionImpl)) {
          callback(null, {
            statusCode: node_opcua_status_code_1.StatusCodes.BadNodeIdInvalid
          });
          return;
        }
        if (!conditionNode.getEnabledState()) {
          callback(null, {
            statusCode: node_opcua_status_code_1.StatusCodes.BadConditionDisabled
          });
          return;
        }
        (0, node_opcua_assert_1.assert)(inputArguments.length === 2);
        (0, node_opcua_assert_1.assert)(inputArguments[0].dataType === node_opcua_variant_1.DataType.ByteString);
        (0, node_opcua_assert_1.assert)(inputArguments[1].dataType === node_opcua_variant_1.DataType.LocalizedText);
        const eventId = inputArguments[0].value;
        (0, node_opcua_assert_1.assert)(!eventId || eventId instanceof Buffer);
        const comment = inputArguments[1].value;
        (0, node_opcua_assert_1.assert)(comment instanceof node_opcua_data_model_1.LocalizedText);
        const branch = conditionNode._findBranchForEventId(eventId);
        if (!branch) {
          callback(null, {
            statusCode: node_opcua_status_code_1.StatusCodes.BadEventIdUnknown
          });
          return;
        }
        (0, node_opcua_assert_1.assert)(branch instanceof condition_snapshot_impl_1.ConditionSnapshotImpl);
        const statusCode = inner_func(eventId, comment, branch, conditionNode);
        branch.setClientUserId(context.userIdentity || "<unknown client user id>");
        callback(null, {
          statusCode
        });
      }
      /**
       * @method initialize
       * @private
       */
      initialize() {
        this._branches = {};
      }
      /**
       * @method post_initialize
       * @private
       */
      post_initialize() {
        (0, node_opcua_assert_1.assert)(!this._branch0);
        this._branch0 = new condition_snapshot_impl_1.ConditionSnapshotImpl(this, new node_opcua_nodeid_1.NodeId());
        this._branch0.on("valueChanged", (node, variant, options) => {
          node.setValueFromSource(variant, node_opcua_status_code_1.StatusCodes.Good, options.sourceTimestamp);
        });
      }
      getBranchCount() {
        return Object.keys(this._branches).length;
      }
      getBranches() {
        return Object.keys(this._branches).map((x2) => {
          return this._branches[x2];
        });
      }
      getBranchIds() {
        return this.getBranches().map((b) => b.getBranchId());
      }
      /**
       * @method createBranch
       * @return {ConditionSnapshot}
       */
      createBranch() {
        const branchId = _create_new_branch_id();
        const snapshot = new condition_snapshot_impl_1.ConditionSnapshotImpl(this, branchId);
        this._branches[branchId.toString()] = snapshot;
        return snapshot;
      }
      /**
       *  @method deleteBranch
       *  @param branch {ConditionSnapshot}
       */
      deleteBranch(branch) {
        const key = branch.getBranchId().toString();
        (0, node_opcua_assert_1.assert)(!(0, node_opcua_nodeid_1.sameNodeId)(branch.getBranchId(), node_opcua_nodeid_1.NodeId.nullNodeId), "cannot delete branch zero");
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(this._branches, key));
        delete this._branches[key];
        this.emit("branch_deleted", key);
      }
      /**
       * @method getEnabledState
       * @return {Boolean}
       */
      getEnabledState() {
        return this.enabledState.getValue();
      }
      /**
       * @method getEnabledStateAsString
       * @return {String}
       */
      getEnabledStateAsString() {
        return this.enabledState.getValueAsString();
      }
      /**
       * returns {StatusCode} StatusCodes.Good if successful or BadConditionAlreadyEnabled/BadConditionAlreadyDisabled
       * @private
       */
      _setEnabledState(requestedEnabledState, options) {
        (0, node_opcua_assert_1.assert)(typeof requestedEnabledState === "boolean");
        const enabledState = this.getEnabledState();
        if (enabledState && requestedEnabledState) {
          return node_opcua_status_code_1.StatusCodes.BadConditionAlreadyEnabled;
        }
        if (!enabledState && !requestedEnabledState) {
          return node_opcua_status_code_1.StatusCodes.BadConditionAlreadyDisabled;
        }
        this._branch0.setEnabledState(requestedEnabledState, options);
        if (!requestedEnabledState) {
          this._previousRetainFlag = this.currentBranch().getRetain();
          this.currentBranch().setRetain(false);
          const statusCode = node_opcua_status_code_1.StatusCodes.BadConditionDisabled;
          this.raiseConditionEvent(this.currentBranch(), true);
        } else {
          this.evaluateConditionsAfterEnabled();
          if (Object.prototype.hasOwnProperty.call(this, "_previousRetainFlag")) {
            this.currentBranch().setRetain(this._previousRetainFlag);
          }
          let nb_condition_resent = 0;
          if (this.currentBranch().getRetain()) {
            nb_condition_resent += this._resend_conditionEvents();
          }
          if (nb_condition_resent === 0) {
            this.raiseConditionEvent(this.currentBranch(), true);
          }
        }
        return node_opcua_status_code_1.StatusCodes.Good;
      }
      /**
       *
       * @method setEnabledState
       * @param requestedEnabledState {Boolean}
       * @private
       */
      setEnabledState(requestedEnabledState, options) {
        return this._setEnabledState(requestedEnabledState, options);
      }
      /**
       * @method setReceiveTime
       * @param time {Date}
       */
      setReceiveTime(time) {
        return this._branch0.setReceiveTime(time);
      }
      /**
       * @method setLocalTime (optional)
       * @param time
       */
      setLocalTime(time) {
        return this._branch0.setLocalTime(time);
      }
      /**
       * @method setTime
       * @param time {Date}
       */
      setTime(time) {
        return this._branch0.setTime(time);
      }
      _assert_valid() {
        (0, node_opcua_assert_1.assert)(this.receiveTime.readValue().value.dataType === node_opcua_variant_1.DataType.DateTime);
        (0, node_opcua_assert_1.assert)(this.receiveTime.readValue().value.value instanceof Date);
        (0, node_opcua_assert_1.assert)(this.message.readValue().value.dataType === node_opcua_variant_1.DataType.LocalizedText);
        (0, node_opcua_assert_1.assert)(this.severity.readValue().value.dataType === node_opcua_variant_1.DataType.UInt16);
        (0, node_opcua_assert_1.assert)(this.time.readValue().value.dataType === node_opcua_variant_1.DataType.DateTime);
        (0, node_opcua_assert_1.assert)(this.time.readValue().value.value instanceof Date);
        (0, node_opcua_assert_1.assert)(this.quality.readValue().value.dataType === node_opcua_variant_1.DataType.StatusCode);
        (0, node_opcua_assert_1.assert)(this.enabledState.readValue().value.dataType === node_opcua_variant_1.DataType.LocalizedText);
        (0, node_opcua_assert_1.assert)(this.branchId.readValue().value.dataType === node_opcua_variant_1.DataType.NodeId);
        (0, node_opcua_assert_1.assert)(!this.localTime || this.localTime.readValue().value.dataType === node_opcua_variant_1.DataType.ExtensionObject);
      }
      /**
       * @method conditionOfNode
       * @return {UAObject}
       */
      conditionOfNode() {
        const refs = this.findReferencesExAsObject("HasCondition", node_opcua_data_model_1.BrowseDirection.Inverse);
        if (refs.length === 0) {
          return null;
        }
        (0, node_opcua_assert_1.assert)(refs.length !== 0, "UACondition must be the condition of some node");
        (0, node_opcua_assert_1.assert)(refs.length === 1, "expecting only one ConditionOf");
        const node = refs[0];
        (0, node_opcua_assert_1.assert)(node.nodeClass === node_opcua_data_model_1.NodeClass.Object || node.nodeClass === node_opcua_data_model_1.NodeClass.Variable, "node for which we are the condition shall be an UAObject or UAVariable");
        return node;
      }
      /**
       * @method raiseConditionEvent
       * Raise a Instance Event
       * (see also UAObject#raiseEvent to raise a transient event)
       * @param branch the condition branch to raise
       * @param renewEventId true if event Id of the condition branch should be renewed
       */
      raiseConditionEvent(branch, renewEventId) {
        (0, node_opcua_assert_1.assert)(arguments.length === 2, "expecting 2 arguments");
        if (renewEventId) {
          branch.renewEventId();
        }
        (0, node_opcua_assert_1.assert)(branch instanceof condition_snapshot_impl_1.ConditionSnapshotImpl);
        this._assert_valid();
        const conditionOfNode = this.conditionOfNode();
        if (conditionOfNode) {
          const eventData = branch._constructEventData();
          this.emit("event", eventData);
          if (conditionOfNode instanceof ua_object_impl_1.UAObjectImpl) {
            conditionOfNode._bubble_up_event(eventData);
          } else {
            (0, node_opcua_assert_1.assert)(conditionOfNode.nodeClass === node_opcua_data_model_1.NodeClass.Variable);
            const eventOfs = conditionOfNode.getEventSourceOfs();
            (0, node_opcua_assert_1.assert)(eventOfs.length === 1);
            const node = eventOfs[0];
            if (node instanceof ua_object_impl_1.UAObjectImpl) {
              node._bubble_up_event(eventData);
            }
          }
        } else {
          warningLog("raiseConditionEvent: the condition ", (0, node_opcua_address_space_base_1.fullPath2)(this), "is not linked to a Object with a IsConditionOf(reversed(HasCondition)) reference", "therefore event cannot bubble-up to the server object");
        }
      }
      /**
       *
       * @method raiseNewCondition
       * @param conditionInfo {ConditionInfo}
       *
       */
      raiseNewCondition(conditionInfo) {
        if (!this.getEnabledState()) {
          throw new Error("UACondition#raiseNewCondition Condition is not enabled");
        }
        conditionInfo = conditionInfo || {};
        conditionInfo.severity = Object.prototype.hasOwnProperty.call(conditionInfo, "severity") ? conditionInfo.severity : _UAConditionImpl.defaultSeverity;
        const addressSpace = this.addressSpace;
        const selfConditionType = this.typeDefinitionObj;
        const conditionType = addressSpace.findObjectType("ConditionType");
        (0, node_opcua_assert_1.assert)(selfConditionType.isSubtypeOf(conditionType));
        const branch = this.currentBranch();
        const currentDefaultDate = /* @__PURE__ */ new Date();
        const time = conditionInfo.time || currentDefaultDate;
        const receiveTime = conditionInfo.receiveTime || currentDefaultDate;
        branch.setTime(time);
        branch.setReceiveTime(receiveTime);
        if (Object.prototype.hasOwnProperty.call(this, "localTime")) {
          branch.setLocalTime(new node_opcua_types_1.TimeZoneDataType({
            daylightSavingInOffset: false,
            offset: 0
          }));
        }
        if (Object.prototype.hasOwnProperty.call(conditionInfo, "message") && conditionInfo.message) {
          branch.setMessage(conditionInfo.message);
        }
        if (Object.prototype.hasOwnProperty.call(conditionInfo, "severity") && conditionInfo.severity !== null) {
          (0, node_opcua_assert_1.assert)(isFinite(conditionInfo.severity));
          branch.setSeverity(conditionInfo.severity, { sourceTimestamp: time });
        }
        if (Object.prototype.hasOwnProperty.call(conditionInfo, "quality") && conditionInfo.quality !== null) {
          (0, node_opcua_assert_1.assert)(conditionInfo.quality instanceof node_opcua_status_code_1.StatusCode);
          branch.setQuality(conditionInfo.quality, { sourceTimestamp: time });
        }
        if (Object.prototype.hasOwnProperty.call(conditionInfo, "retain") && conditionInfo.retain !== null) {
          (0, node_opcua_assert_1.assert)(typeof conditionInfo.retain === "boolean");
          branch.setRetain(!!conditionInfo.retain);
        }
        this.raiseConditionEvent(branch, true);
      }
      raiseNewBranchState(branch) {
        this.raiseConditionEvent(branch, true);
        if (!(0, node_opcua_nodeid_1.sameNodeId)(branch.getBranchId(), node_opcua_nodeid_1.NodeId.nullNodeId) && !branch.getRetain()) {
          this.deleteBranch(branch);
        }
      }
      /**
       * @method currentBranch
       * @return {ConditionSnapshot}
       */
      currentBranch() {
        return this._branch0;
      }
      _resend_conditionEvents() {
        const currentBranch = this.currentBranch();
        if (currentBranch.getRetain()) {
          debugLog(" resending condition event for " + this.browseName.toString());
          this.raiseConditionEvent(currentBranch, false);
          return 1;
        }
        return 0;
      }
      // ------------------------------------------------------------------------------------
      // Acknowledgeable
      // ------------------------------------------------------------------------------------
      /**
       * @method _raiseAuditConditionCommentEvent
       * @param sourceName {string}
       * @param conditionEventId    {Buffer}
       * @param comment    {LocalizedText}
       * @private
       */
      _raiseAuditConditionCommentEvent(sourceName, conditionEventId, comment) {
        (0, node_opcua_assert_1.assert)(conditionEventId === null || conditionEventId instanceof Buffer);
        (0, node_opcua_assert_1.assert)(comment instanceof node_opcua_data_model_1.LocalizedText);
        const server = this.addressSpace.rootFolder.objects.server;
        const now = /* @__PURE__ */ new Date();
        server.raiseEvent("AuditConditionCommentEventType", {
          // AuditEventType
          /* part 5 -  6.4.3 AuditEventType */
          actionTimeStamp: {
            dataType: "DateTime",
            value: now
          },
          status: {
            dataType: "Boolean",
            value: true
          },
          serverId: {
            dataType: "String",
            value: ""
          },
          // ClientAuditEntryId contains the human-readable AuditEntryId defined in Part 3.
          clientAuditEntryId: {
            dataType: "String",
            value: ""
          },
          // The ClientUserId identifies the user of the client requesting an action. The ClientUserId can be
          // obtained from the UserIdentityToken passed in the ActivateSession call.
          clientUserId: {
            dataType: "String",
            value: ""
          },
          sourceName: {
            dataType: "String",
            value: sourceName
          },
          // AuditUpdateMethodEventType
          methodId: {
            dataType: "Null"
          },
          inputArguments: {
            dataType: "Null"
          },
          // AuditConditionCommentEventType
          conditionEventId: {
            dataType: "ByteString",
            value: conditionEventId
          },
          comment: {
            dataType: "LocalizedText",
            value: comment
          }
        });
      }
      _findBranchForEventId(eventId) {
        if (sameBuffer(this.eventId.readValue().value.value, eventId)) {
          return this.currentBranch();
        }
        const e = Object.values(this._branches).filter((branch) => sameBuffer(branch.getEventId(), eventId));
        if (e.length === 1) {
          return e[0];
        }
        (0, node_opcua_assert_1.assert)(e.length === 0, "cannot have 2 branches with same eventId");
        return null;
      }
      evaluateConditionsAfterEnabled() {
        (0, node_opcua_assert_1.assert)(this.getEnabledState() === true);
        throw new Error("Unimplemented , please override");
      }
    };
    exports2.UAConditionImpl = UAConditionImpl;
    UAConditionImpl.defaultSeverity = 250;
    UAConditionImpl.typeDefinition = (0, node_opcua_nodeid_1.resolveNodeId)("ConditionType");
    function UACondition_instantiate(namespace, conditionTypeId, options, data) {
      const addressSpace = namespace.addressSpace;
      const conditionType = addressSpace.findEventType(conditionTypeId);
      if (!conditionType) {
        throw new Error(" cannot find Condition Type for " + conditionTypeId);
      }
      (0, node_opcua_assert_1.assert)(!conditionType.isAbstract, "Cannot instantiate abstract conditionType");
      const baseConditionEventType = addressSpace.findEventType("ConditionType");
      if (!baseConditionEventType) {
        throw new Error("cannot find  ConditionType");
      }
      (0, node_opcua_assert_1.assert)(conditionType.isSubtypeOf(baseConditionEventType));
      options.browseName = options.browseName || "??? instantiateCondition - missing browseName";
      options.optionals = options.optionals || [];
      options.optionals.push("EventType");
      options.optionals.push("BranchId");
      options.optionals.push("Comment");
      options.optionals.push("Comment.SourceTimestamp");
      options.optionals.push("EnabledState.TrueState");
      options.optionals.push("EnabledState.TrueState");
      options.optionals.push("EnabledState.FalseState");
      options.optionals.push("EnabledState.TransitionTime");
      options.optionals.push("EnabledState.EffectiveTransitionTime");
      options.optionals.push("EnabledState.EffectiveDisplayName");
      const conditionNode = conditionType.instantiate(options);
      Object.setPrototypeOf(conditionNode, UAConditionImpl.prototype);
      conditionNode.initialize();
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "conditionSource"), "must specify a condition source either as null or as a UAObject");
      if (!options.conditionOf) {
        options.conditionOf = options.conditionSource;
      }
      if (options.conditionOf) {
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "conditionOf"));
        options.conditionOf = addressSpace._coerceNode(options.conditionOf);
        (0, node_opcua_assert_1.assert)(options.conditionOf.nodeClass === node_opcua_data_model_1.NodeClass.Object || options.conditionOf.nodeClass === node_opcua_data_model_1.NodeClass.Variable);
        conditionNode.addReference({
          isForward: false,
          nodeId: options.conditionOf,
          referenceType: "HasCondition"
        });
        (0, node_opcua_assert_1.assert)(conditionNode.conditionOfNode().nodeId === options.conditionOf.nodeId);
      }
      conditionNode.eventType.setValueFromSource({
        dataType: node_opcua_variant_1.DataType.NodeId,
        value: conditionType.nodeId
      });
      data = data || {};
      conditionNode.branchId.setValueFromSource({
        dataType: node_opcua_variant_1.DataType.NodeId,
        value: new node_opcua_nodeid_1.NodeId()
      });
      _install_condition_variable_type(conditionNode.comment);
      _install_condition_variable_type(conditionNode.quality);
      _install_condition_variable_type(conditionNode.lastSeverity);
      if (!conditionNode.enabledState.effectiveDisplayName) {
        namespace.addVariable({
          browseName: new node_opcua_data_model_1.QualifiedName({ namespaceIndex: 0, name: "EffectiveDisplayName" }),
          dataType: "LocalizedText",
          propertyOf: conditionNode.enabledState
        });
      }
      (0, ua_two_state_variable_1._install_TwoStateVariable_machinery)(conditionNode.enabledState, {
        falseState: "Disabled",
        trueState: "Enabled"
      });
      conditionNode.enabledState.setValue(true);
      Object.entries(data).forEach(([key, value]) => {
        const varNode = _getCompositeKey(conditionNode, key);
        (0, node_opcua_assert_1.assert)(varNode.nodeClass === node_opcua_data_model_1.NodeClass.Variable);
        const variant = new node_opcua_variant_1.Variant(value);
        if (!varNode._validate_DataType(variant.dataType)) {
          throw new Error(" Invalid variant dataType " + variant + " " + varNode.browseName.toString());
        }
        varNode.setValueFromSource(variant);
      });
      conditionNode.enable.bindMethod(_enable_method);
      conditionNode.disable.bindMethod(_disable_method);
      conditionNode.addComment.bindMethod(_add_comment_method);
      (0, node_opcua_assert_1.assert)(conditionNode instanceof UAConditionImpl);
      if (options.conditionSource) {
        options.conditionSource = addressSpace._coerceNode(options.conditionSource);
        if (options.conditionSource.nodeClass !== node_opcua_data_model_1.NodeClass.Object && options.conditionSource.nodeClass !== node_opcua_data_model_1.NodeClass.Variable) {
          debugLog(options.conditionSource);
          throw new Error("Expecting condition source to be NodeClass.Object or Variable");
        }
        const conditionSourceNode = addressSpace.findNode(options.conditionSource.nodeId);
        if (conditionSourceNode) {
          conditionNode.sourceNode.setValueFromSource({
            dataType: node_opcua_variant_1.DataType.NodeId,
            value: conditionSourceNode.nodeId
          });
          if (!(0, node_opcua_nodeid_1.sameNodeId)(conditionSourceNode.nodeId, (0, node_opcua_nodeid_1.coerceNodeId)("ns=0;i=2253"))) {
            if (conditionSourceNode.getEventSourceOfs().length === 0) {
              errorLog("conditionSourceNode = ", conditionSourceNode.browseName.toString());
              errorLog("conditionSourceNode = ", conditionSourceNode.nodeId.toString());
              throw new Error("conditionSourceNode must be an event source " + conditionSourceNode.browseName.toString() + conditionSourceNode.nodeId.toString());
            }
          }
          conditionNode.sourceNode.setValueFromSource(conditionSourceNode.readAttribute(null, node_opcua_data_model_1.AttributeIds.NodeId).value);
          const displayName = conditionSourceNode.readAttribute(null, node_opcua_data_model_1.AttributeIds.DisplayName).value.value;
          conditionNode.sourceName.setValueFromSource({ dataType: node_opcua_variant_1.DataType.String, value: displayName.text });
        }
      }
      conditionNode.eventType.setValueFromSource({
        dataType: node_opcua_variant_1.DataType.NodeId,
        value: conditionType.nodeId
      });
      const baseConditionClassType = addressSpace.findObjectType("ProcessConditionClassType");
      let conditionClassId = baseConditionClassType ? baseConditionClassType.nodeId : new node_opcua_nodeid_1.NodeId();
      let conditionClassName = baseConditionClassType ? baseConditionClassType.displayName[0] : "";
      if (options.conditionClass) {
        if (typeof options.conditionClass === "string") {
          options.conditionClass = addressSpace.findObjectType(options.conditionClass);
          if (!options.conditionClass) {
            throw new Error("cannot find condition class " + options.conditionClass);
          }
        }
        const conditionClassNode = addressSpace._coerceNode(options.conditionClass);
        if (!conditionClassNode) {
          throw new Error("cannot find condition class " + options.conditionClass.toString());
        }
        conditionClassId = conditionClassNode.nodeId;
        conditionClassName = conditionClassNode.displayName[0];
      }
      conditionNode.conditionClassId.setValueFromSource({
        dataType: node_opcua_variant_1.DataType.NodeId,
        value: conditionClassId
      });
      conditionNode.conditionClassName.setValueFromSource({
        dataType: node_opcua_variant_1.DataType.LocalizedText,
        value: (0, node_opcua_data_model_1.coerceLocalizedText)(conditionClassName)
      });
      const conditionName = options.conditionName || "Unset Condition Name";
      (0, node_opcua_assert_1.assert)(typeof conditionName === "string");
      conditionNode.conditionName.setValueFromSource({
        dataType: node_opcua_variant_1.DataType.String,
        value: conditionName
      });
      const sourceNodes = conditionNode.findReferencesAsObject("HasCondition", false);
      if (sourceNodes.length) {
        (0, node_opcua_assert_1.assert)(sourceNodes.length === 1);
        conditionNode.setSourceNode(sourceNodes[0].nodeId);
        conditionNode.setSourceName(sourceNodes[0].browseName.toString());
      }
      conditionNode.post_initialize();
      const branch0 = conditionNode.currentBranch();
      branch0.setRetain(false);
      branch0.setComment("");
      branch0.setQuality(node_opcua_status_code_1.StatusCodes.Good);
      branch0.setSeverity(0);
      branch0.setLocalTime(new node_opcua_types_1.TimeZoneDataType({
        daylightSavingInOffset: false,
        offset: 0
      }));
      branch0.setMessage("");
      branch0.setReceiveTime(node_opcua_basic_types_2.minDate);
      branch0.setTime(node_opcua_basic_types_2.minDate);
      return conditionNode;
    }
    function _disable_method(inputArguments, context, callback) {
      (0, node_opcua_assert_1.assert)(inputArguments.length === 0);
      const conditionNode = context.object;
      (0, node_opcua_assert_1.assert)(conditionNode);
      if (!(conditionNode instanceof UAConditionImpl)) {
        debugLog("conditionNode is not a UACondition ", conditionNode?.toString());
        return callback(null, {
          statusCode: node_opcua_status_code_1.StatusCodes.BadNodeIdInvalid
        });
      }
      const statusCode = conditionNode._setEnabledState(false);
      return callback(null, {
        statusCode
      });
    }
    function _enable_method(inputArguments, context, callback) {
      (0, node_opcua_assert_1.assert)(inputArguments.length === 0);
      const conditionNode = context.object;
      (0, node_opcua_assert_1.assert)(conditionNode);
      if (!(conditionNode instanceof UAConditionImpl)) {
        return callback(null, {
          statusCode: node_opcua_status_code_1.StatusCodes.BadNodeIdInvalid
        });
      }
      const statusCode = conditionNode._setEnabledState(true);
      return callback(null, {
        statusCode
      });
    }
    function _condition_refresh_method(inputArguments, context, callback) {
      (0, node_opcua_assert_1.assert)(inputArguments.length === 1);
      const addressSpace = context.object.addressSpace;
      if (doDebug) {
        debugLog(chalk_1.default.red(" ConditionType.ConditionRefresh ! subscriptionId ="), inputArguments[0].toString());
      }
      const subscriptionId = inputArguments[0].value;
      let statusCode = _check_subscription_id_is_valid(subscriptionId, context);
      if (statusCode.isNotGood()) {
        return statusCode;
      }
      statusCode = _perform_condition_refresh(addressSpace, inputArguments, context);
      return callback(null, {
        statusCode
      });
    }
    function _perform_condition_refresh(addressSpace, inputArguments, context) {
      if (addressSpace._condition_refresh_in_progress) {
        return node_opcua_status_code_1.StatusCodes.BadRefreshInProgress;
      }
      addressSpace._condition_refresh_in_progress = true;
      const server = context.object.addressSpace.rootFolder.objects.server;
      const refreshStartEventType = addressSpace.findEventType("RefreshStartEventType");
      const refreshEndEventType = addressSpace.findEventType("RefreshEndEventType");
      server.raiseEvent(refreshStartEventType, {});
      const _server = server;
      _server._conditionRefresh();
      server.raiseEvent(refreshEndEventType, {});
      addressSpace._condition_refresh_in_progress = false;
      return node_opcua_status_code_1.StatusCodes.Good;
    }
    function _condition_refresh2_method(inputArguments, context, callback) {
      (0, node_opcua_assert_1.assert)(inputArguments.length === 2);
      if (!context.object) {
        throw new Error("Invalid context => missing Object");
      }
      const addressSpace = context.object.addressSpace;
      if (doDebug) {
        debugLog(chalk_1.default.cyan.bgWhite(" ConditionType.conditionRefresh2 !"));
      }
      const statusCode = _perform_condition_refresh(addressSpace, inputArguments, context);
      return callback(null, {
        statusCode
      });
    }
    function _add_comment_method(inputArguments, context, callback) {
      UAConditionImpl.with_condition_method(inputArguments, context, callback, (conditionEventId, comment, branch, conditionNode) => {
        (0, node_opcua_assert_1.assert)(inputArguments instanceof Array);
        (0, node_opcua_assert_1.assert)(conditionEventId instanceof Buffer || conditionEventId === null);
        (0, node_opcua_assert_1.assert)(branch instanceof condition_snapshot_impl_1.ConditionSnapshotImpl);
        branch.setComment(comment);
        const sourceName = "Method/AddComment";
        conditionNode._raiseAuditConditionCommentEvent(sourceName, conditionEventId, comment);
        conditionNode.raiseConditionEvent(branch, true);
        conditionNode.emit("addComment", conditionEventId, comment, branch);
        return node_opcua_status_code_1.StatusCodes.Good;
      });
    }
    function sameBuffer(b1, b2) {
      if (!b1 && !b2) {
        return true;
      }
      if (b1 && !b2) {
        return false;
      }
      if (!b1 && b2) {
        return false;
      }
      (0, node_opcua_assert_1.assert)(b1 instanceof Buffer);
      (0, node_opcua_assert_1.assert)(b2 instanceof Buffer);
      if (b1.length !== b2.length) {
        return false;
      }
      const n = b1.length;
      for (let i = 0; i < n; i++) {
        if (b1[i] !== b2[i]) {
          return false;
        }
      }
      return true;
    }
    function _create_new_branch_id() {
      return (0, node_opcua_nodeid_1.makeNodeId)((0, node_opcua_basic_types_1.randomGuid)(), 1);
    }
    function _install_condition_variable_type(node) {
      if (node.sourceTimestamp) {
        node.sourceTimestamp.accessLevel = (0, node_opcua_data_model_1.makeAccessLevelFlag)("CurrentRead");
      } else {
        console.warn("cannot find node.sourceTimestamp", node.browseName.toString());
      }
      node.accessLevel = (0, node_opcua_data_model_1.makeAccessLevelFlag)("CurrentRead");
    }
    function _getCompositeKey(node, key) {
      let cur = node;
      const elements = key.split(".");
      for (const e of elements) {
        if (!Object.prototype.hasOwnProperty.call(cur, e)) {
          throw new Error(" cannot extract '" + key + "' from " + node.browseName.toString());
        }
        cur = cur[e];
      }
      return cur;
    }
    function _check_subscription_id_is_valid(subscriptionId, context) {
      return node_opcua_status_code_1.StatusCodes.Good;
    }
  }
});

// node_modules/node-opcua-address-space/dist/src/apply_condition_refresh.js
var require_apply_condition_refresh = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/apply_condition_refresh.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.apply_condition_refresh = void 0;
    var ua_condition_impl_1 = require_ua_condition_impl();
    function apply_condition_refresh(cache) {
      cache = cache || {};
      const notifiers = this.getNotifiers();
      const eventSources = this.getEventSources();
      const conditions = this.findReferencesAsObject("HasCondition", true);
      for (const condition of conditions) {
        if (condition instanceof ua_condition_impl_1.UAConditionImpl) {
          condition._resend_conditionEvents();
        }
      }
      const arr = [].concat(notifiers, eventSources);
      for (const notifier of arr) {
        const key = notifier.nodeId.toString();
        if (!cache[key]) {
          cache[key] = notifier;
          if (notifier._conditionRefresh) {
            notifier._conditionRefresh(cache);
          }
        }
      }
    }
    exports2.apply_condition_refresh = apply_condition_refresh;
  }
});

// node_modules/node-opcua-address-space/dist/src/idx_iterator.js
var require_idx_iterator = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/idx_iterator.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.IndexIterator = void 0;
    var IndexIterator = class {
      constructor(limits) {
        this.limits = limits;
        this.current = null;
        this.reset();
      }
      reset() {
        this.current = [];
        for (let i = 0; i < this.limits.length; i++) {
          this.current[i] = 0;
        }
      }
      increment() {
        if (!this.current)
          return;
        const increase = (n2) => {
          if (n2 < 0) {
            return false;
          }
          if (!this.current)
            return false;
          if (this.current[n2] + 1 >= this.limits[n2]) {
            if (n2 == 0) {
              this.current = null;
              return false;
            }
            this.current[n2] = 0;
            return increase(n2 - 1);
          }
          this.current[n2] = this.current[n2] + 1;
          return true;
        };
        const n = this.limits.length - 1;
        if (!increase(n)) {
          this.current = null;
        }
      }
      next() {
        if (!this.current) {
          throw new Error("Outof bond");
        }
        const r = [...this.current];
        this.increment();
        return r;
      }
    };
    exports2.IndexIterator = IndexIterator;
  }
});

// node_modules/node-opcua-address-space/dist/src/ua_variable_impl_ext_obj.js
var require_ua_variable_impl_ext_obj = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/ua_variable_impl_ext_obj.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.propagateTouchValueDownwardArray = exports2.extractPartialData = exports2.incrementElement = exports2.setElement = exports2.getElement = exports2._bindExtensionObjectArrayOrMatrix = exports2._bindExtensionObject = exports2._installExtensionObjectBindingOnProperties = exports2.setExtensionObjectPartialValue = exports2.propagateTouchValueDownward = exports2.propagateTouchValueUpward = exports2._touchValue = exports2.getProxyTarget = void 0;
    var node_opcua_assert_1 = __importDefault3(require_dist14());
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_date_time_1 = require_dist17();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_extension_object_1 = require_dist30();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_variant_1 = require_dist28();
    var ua_variable_impl_1 = require_ua_variable_impl();
    var idx_iterator_1 = require_idx_iterator();
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    function isProxy(ext) {
      return ext.$isProxy ? true : false;
    }
    function getProxyVariable(ext) {
      (0, node_opcua_assert_1.default)(isProxy(ext));
      return ext.$variable;
    }
    function getProxyVariableForProp(ext, prop) {
      const uaVariable = getProxyVariable(ext);
      if (!uaVariable)
        return void 0;
      return uaVariable[prop];
    }
    function getProxyTarget(ext) {
      (0, node_opcua_assert_1.default)(isProxy(ext));
      const target = ext.$proxyTarget;
      if (target && isProxy(target)) {
        return getProxyTarget(target);
      }
      return target;
    }
    exports2.getProxyTarget = getProxyTarget;
    function unProxy(ext) {
      return isProxy(ext) ? getProxyTarget(ext) : ext;
    }
    function _extensionObjectFieldGetter(getVariable, target, key) {
      if (key === "$isProxy") {
        return true;
      }
      if (key === "$proxyTarget") {
        return target;
      }
      if (key === "$variable") {
        return getVariable();
      }
      if (target[key] === void 0) {
        return void 0;
      }
      return target[key];
    }
    function _extensionObjectFieldSetter(getVariable, target, key, value) {
      target[key] = value;
      if (isProxy(target)) {
        return true;
      }
      const uaVariable = getVariable();
      if (!uaVariable)
        return true;
      const child = uaVariable[key];
      if (child && child.touchValue) {
        child.touchValue();
      }
      return true;
    }
    function makeHandler(getVariable) {
      const handler = {
        get: _extensionObjectFieldGetter.bind(null, getVariable),
        set: _extensionObjectFieldSetter.bind(null, getVariable)
      };
      return handler;
    }
    function _touchValue(property, now) {
      property.$dataValue.sourceTimestamp = now.timestamp;
      property.$dataValue.sourcePicoseconds = now.picoseconds;
      property.$dataValue.serverTimestamp = now.timestamp;
      property.$dataValue.serverPicoseconds = now.picoseconds;
      property.$dataValue.statusCode = node_opcua_status_code_1.StatusCodes.Good;
      if (property.listenerCount("value_changed") > 0) {
        property.emit("value_changed", property.$dataValue.clone());
      }
    }
    exports2._touchValue = _touchValue;
    function propagateTouchValueUpward(self2, now, cache) {
      _touchValue(self2, now);
      if (self2.parent && self2.parent.nodeClass === node_opcua_data_model_1.NodeClass.Variable) {
        const parentVar = self2.parent;
        if (!parentVar.isExtensionObject())
          return;
        if (cache) {
          if (cache.has(parentVar))
            return;
          cache.add(parentVar);
        }
        propagateTouchValueUpward(parentVar, now, cache);
      }
    }
    exports2.propagateTouchValueUpward = propagateTouchValueUpward;
    function propagateTouchValueDownward(self2, now, cache) {
      if (!self2.isExtensionObject())
        return;
      const dataTypeNode = self2.getDataTypeNode();
      const definition = dataTypeNode.getStructureDefinition();
      for (const field of definition.fields || []) {
        const property = self2.getChildByName(field.name);
        if (property) {
          if (cache) {
            if (cache.has(property)) {
              continue;
            }
            cache.add(property);
          }
          _touchValue(property, now);
        }
      }
    }
    exports2.propagateTouchValueDownward = propagateTouchValueDownward;
    function setExtensionObjectPartialValue(node, partialObject, sourceTimestamp) {
      const variablesToUpdate = /* @__PURE__ */ new Set();
      const extensionObject = node.$extensionObject;
      if (!extensionObject) {
        throw new Error("setExtensionObjectValue node has no extension object " + node.browseName.toString());
      }
      function _update_extension_object(extObject, partialObject1) {
        const keys = Object.keys(partialObject1);
        for (const prop of keys) {
          if (extObject[prop] instanceof Object) {
            _update_extension_object(extObject[prop], partialObject1[prop]);
          } else {
            if (isProxy(extObject)) {
              const target = getProxyTarget(extObject);
              (0, node_opcua_assert_1.default)(!isProxy(target), "something wierd!");
              target[prop] = partialObject1[prop];
              const variable = getProxyVariableForProp(extObject, prop);
              variable && variablesToUpdate.add(variable);
            } else {
              extObject[prop] = partialObject1[prop];
            }
          }
        }
      }
      _update_extension_object(extensionObject, partialObject);
      const now = sourceTimestamp || (0, node_opcua_date_time_1.getCurrentClock)();
      const cache = /* @__PURE__ */ new Set();
      for (const c2 of variablesToUpdate) {
        if (cache.has(c2))
          continue;
        propagateTouchValueUpward(c2, now, cache);
        propagateTouchValueDownward(c2, now, cache);
        cache.add(c2);
      }
    }
    exports2.setExtensionObjectPartialValue = setExtensionObjectPartialValue;
    function getOrCreateProperty(variableNode, field, options) {
      const dt = variableNode.getDataTypeNode();
      const structureNamespace = dt.nodeId.namespace;
      const components = variableNode.getComponents();
      let property;
      const selectedComponents = components.filter((f2) => f2 instanceof ua_variable_impl_1.UAVariableImpl && f2.browseName.name.toString() === field.name);
      if (field.dataType.value === node_opcua_variant_1.DataType.Variant) {
        warningLog("Warning : variant is not supported in ExtensionObject");
      }
      if (selectedComponents.length === 1) {
        property = selectedComponents[0];
      } else {
        if (!options.createMissingProp) {
          return null;
        }
        debugLog("adding missing array variable", field.name, variableNode.browseName.toString(), variableNode.nodeId.toString());
        (0, node_opcua_assert_1.default)(selectedComponents.length === 0);
        property = variableNode.namespace.addVariable({
          browseName: { namespaceIndex: structureNamespace, name: field.name.toString() },
          componentOf: variableNode,
          dataType: field.dataType,
          minimumSamplingInterval: variableNode.minimumSamplingInterval,
          accessLevel: variableNode.accessLevel,
          accessRestrictions: variableNode.accessRestrictions,
          rolePermissions: variableNode.rolePermissions
        });
        (0, node_opcua_assert_1.default)(property.minimumSamplingInterval === variableNode.minimumSamplingInterval);
      }
      return property;
    }
    function installExt(uaVariable, ext) {
      ext = unProxy(ext);
      uaVariable.$extensionObject = new Proxy(ext, makeHandler(() => uaVariable));
      const addressSpace = uaVariable.addressSpace;
      const definition = uaVariable.dataTypeObj.getStructureDefinition();
      const structure = addressSpace.findDataType("Structure");
      for (const field of definition.fields || []) {
        if (field.dataType) {
          const dataTypeNode = addressSpace.findDataType(field.dataType);
          if (dataTypeNode && dataTypeNode.isSubtypeOf(structure)) {
            const camelCaseName = (0, node_opcua_utils_1.lowerFirstLetter)(field.name);
            const subExtObj = uaVariable.$extensionObject[camelCaseName];
            if (subExtObj) {
              uaVariable.$extensionObject[camelCaseName] = new Proxy(subExtObj, makeHandler(() => {
                return uaVariable.getComponentByName(field.name);
              }));
            } else {
              doDebug && warningLog("extension object is null");
            }
          }
        }
      }
    }
    function _installExtensionObjectBindingOnProperties(uaVariable, options) {
      if (uaVariable.$extensionObject) {
        const extObj2 = uaVariable.$extensionObject;
        uaVariable.bindExtensionObject(extObj2, { createMissingProp: true, force: true });
        return;
      }
      if (uaVariable.$$extensionObjectArray) {
        const extObj2 = uaVariable.$$extensionObjectArray;
        _bindExtensionObjectArrayOrMatrix(uaVariable, extObj2, { createMissingProp: true, force: true });
        return;
      }
      const dataValue = uaVariable.readValue();
      const extObj = dataValue.value.value;
      if (extObj instanceof node_opcua_extension_object_1.ExtensionObject) {
        uaVariable.bindExtensionObject(extObj, { createMissingProp: true, force: true });
      } else if (extObj instanceof Array) {
        if (dataValue.value.arrayType === node_opcua_variant_1.VariantArrayType.Array || dataValue.value.arrayType === node_opcua_variant_1.VariantArrayType.Matrix) {
          _bindExtensionObjectArrayOrMatrix(uaVariable, extObj, { createMissingProp: true, force: true });
        } else {
          throw new Error("Internal Error, unexpected case");
        }
      }
    }
    exports2._installExtensionObjectBindingOnProperties = _installExtensionObjectBindingOnProperties;
    function _installFields2(uaVariable, { get, set }, options) {
      options = options || { createMissingProp: false };
      const dt = uaVariable.getDataTypeNode();
      const definition = dt.getStructureDefinition();
      for (const field of definition.fields || []) {
        if (node_opcua_nodeid_1.NodeId.sameNodeId(node_opcua_nodeid_1.NodeId.nullNodeId, field.dataType)) {
          warningLog("field.dataType is null ! ", field.name, node_opcua_nodeid_1.NodeId.nullNodeId.toString());
          warningLog(field.toString());
          warningLog(" dataType replaced with BaseDataType ");
          warningLog(definition.toString());
          field.dataType = uaVariable.resolveNodeId("BaseDataType");
        }
        const propertyNode = getOrCreateProperty(uaVariable, field, options);
        if (!propertyNode) {
          continue;
        }
        propertyNode.$dataValue.statusCode = node_opcua_status_code_1.StatusCodes.Good;
        propertyNode.$dataValue.sourceTimestamp = uaVariable.$dataValue.sourceTimestamp;
        propertyNode.$dataValue.sourcePicoseconds = uaVariable.$dataValue.sourcePicoseconds;
        propertyNode.$dataValue.serverTimestamp = uaVariable.$dataValue.serverTimestamp;
        propertyNode.$dataValue.serverPicoseconds = uaVariable.$dataValue.serverPicoseconds;
        propertyNode.$dataValue.value.dataType = propertyNode.dataTypeObj.basicDataType;
        propertyNode.$dataValue.value.arrayType = propertyNode.valueRank === -1 ? node_opcua_variant_1.VariantArrayType.Scalar : propertyNode.valueRank === 1 ? node_opcua_variant_1.VariantArrayType.Array : node_opcua_variant_1.VariantArrayType.Matrix;
        propertyNode.$dataValue.value.dimensions = propertyNode.valueRank > 1 ? propertyNode.arrayDimensions : null;
        const fieldName = field.name;
        installDataValueGetter(propertyNode, () => get(fieldName));
        (0, node_opcua_assert_1.default)(propertyNode._inner_replace_dataValue);
        propertyNode._inner_replace_dataValue = (dataValue, indexRange) => {
          const sourceTime = (0, node_opcua_date_time_1.coerceClock)(dataValue.sourceTimestamp, dataValue.sourcePicoseconds);
          const value = dataValue.value.value;
          set(field.name, value, sourceTime);
          propertyNode.touchValue(sourceTime);
        };
        if (propertyNode.dataTypeObj.basicDataType === node_opcua_variant_1.DataType.ExtensionObject) {
          _installFields2(propertyNode, {
            get: (fieldName2) => {
              const mainFieldName = field.name;
              return get(mainFieldName)[(0, node_opcua_utils_1.lowerFirstLetter)(fieldName2)];
            },
            set: (fieldName2, value, sourceTime) => {
              const mainFieldName = field.name;
              get(mainFieldName)[(0, node_opcua_utils_1.lowerFirstLetter)(fieldName2)] = value;
            }
          }, options);
        }
      }
    }
    function installDataValueGetter(propertyNode, get) {
      Object.defineProperty(propertyNode.$dataValue.value, "value", { get });
      const $ = propertyNode.$dataValue;
      Object.defineProperty(propertyNode, "$dataValue", {
        get() {
          return $;
        },
        set: (value) => {
          throw new Error("$dataValue is now frozen and should not be modified this way !\n contact sterfive.com");
        }
      });
    }
    function isVariableContainingExtensionObject(uaVariable) {
      const addressSpace = uaVariable.addressSpace;
      const structure = addressSpace.findDataType("Structure");
      if (!structure) {
        return false;
      }
      (0, node_opcua_assert_1.default)(structure.browseName.toString() === "Structure", "expecting DataType Structure to be in IAddressSpace");
      const dt = uaVariable.getDataTypeNode();
      if (!dt.isSubtypeOf(structure)) {
        return false;
      }
      return true;
    }
    function _innerBindExtensionObjectScalar(uaVariable, { get, set, setField }, options) {
      uaVariable.$dataValue.statusCode = node_opcua_status_code_1.StatusCodes.Good;
      uaVariable.$dataValue.value.dataType = node_opcua_variant_1.DataType.ExtensionObject;
      uaVariable.$dataValue.value.arrayType = node_opcua_variant_1.VariantArrayType.Scalar;
      uaVariable.setValueFromSource = function(variant) {
        setExtensionObjectPartialValue(this, variant.value);
      };
      installDataValueGetter(uaVariable, get);
      uaVariable.$set_ExtensionObject = set;
      _installFields2(uaVariable, {
        get: (fieldName) => {
          const extObj = get();
          return extObj[(0, node_opcua_utils_1.lowerFirstLetter)(fieldName)];
        },
        set: (fieldName, value, sourceTime) => {
          setField(fieldName, value, sourceTime);
        }
      }, options);
    }
    function _bindExtensionObject(uaVariable, optionalExtensionObject, options) {
      options = options || { createMissingProp: false };
      if (!isVariableContainingExtensionObject(uaVariable)) {
        return null;
      }
      if (optionalExtensionObject && uaVariable.valueRank === 0) {
        warningLog(uaVariable.browseName.toString() + ": valueRank was zero but needed to be adjusted to -1 (Scalar) in bindExtensionObject");
        uaVariable.valueRank = -1;
      }
      const addressSpace = uaVariable.addressSpace;
      let extensionObject_;
      if (uaVariable.valueRank !== -1 && uaVariable.valueRank !== 1) {
        throw new Error("Cannot bind an extension object here, valueRank must be scalar (-1) or one-dimensional (1)");
      }
      doDebug && debugLog(" ------------------------------ binding ", uaVariable.browseName.toString(), uaVariable.nodeId.toString());
      if (!options.force && uaVariable.parent && (uaVariable.parent.nodeClass === node_opcua_data_model_1.NodeClass.Variable || uaVariable.parent.nodeClass === node_opcua_data_model_1.NodeClass.VariableType)) {
        const parentDataType = uaVariable.parent.dataType;
        const dataTypeNode = addressSpace.findNode(parentDataType);
        const structure = addressSpace.findDataType("Structure");
        if (dataTypeNode && dataTypeNode.isSubtypeOf(structure)) {
          return null;
        }
      }
      if (uaVariable.$extensionObject && !optionalExtensionObject) {
        if (!uaVariable.checkExtensionObjectIsCorrect(uaVariable.$extensionObject)) {
          warningLog("on node : ", uaVariable.browseName.toString(), uaVariable.nodeId.toString(), "dataType=", uaVariable.dataType.toString({ addressSpace: uaVariable.addressSpace }));
          warningLog(uaVariable.$extensionObject?.toString());
          throw new Error("bindExtensionObject: $extensionObject is incorrect: we are expecting a " + uaVariable.dataType.toString({ addressSpace: uaVariable.addressSpace }) + " but we got a " + uaVariable.$extensionObject?.schema.name);
        }
        return uaVariable.$extensionObject;
      }
      if (uaVariable.dataTypeObj.isAbstract) {
        if (!optionalExtensionObject) {
          warningLog("Warning the DataType associated with this Variable is abstract ", uaVariable.dataTypeObj.browseName.toString());
          warningLog("You need to provide a extension object yourself ");
          throw new Error("bindExtensionObject requires a extensionObject as associated dataType is only abstract");
        }
      }
      const s = uaVariable.readValue();
      if (s.value && s.value.dataType === node_opcua_variant_1.DataType.ExtensionObject && s.value.value && optionalExtensionObject) {
        s.value.value = null;
      }
      innerBindExtensionObject();
      (0, node_opcua_assert_1.default)(uaVariable.$extensionObject instanceof Object);
      return uaVariable.$extensionObject;
      function innerBindExtensionObject() {
        if (s.value && (s.value.dataType === node_opcua_variant_1.DataType.Null || s.value.dataType === node_opcua_variant_1.DataType.ExtensionObject && !s.value.value)) {
          if (uaVariable.valueRank === -1) {
            extensionObject_ = optionalExtensionObject || addressSpace.constructExtensionObject(uaVariable.dataType, {});
            installExt(uaVariable, extensionObject_);
            _innerBindExtensionObjectScalar(uaVariable, {
              get: () => uaVariable.$extensionObject,
              set: (value) => installExt(uaVariable, value),
              setField: (fieldName, value) => {
                const extObj = uaVariable.$extensionObject;
                getProxyTarget(extObj)[(0, node_opcua_utils_1.lowerFirstLetter)(fieldName)] = value;
              }
            }, options);
            return;
          } else if (uaVariable.valueRank === 1) {
            throw new Error("Should not get there ! Please fix me");
          } else {
            errorLog(uaVariable.toString());
            errorLog("Unsupported case ! valueRank= ", uaVariable.valueRank);
          }
        } else {
          (0, node_opcua_assert_1.default)(s.value.dataType === node_opcua_variant_1.DataType.ExtensionObject);
          installExt(uaVariable, s.value.value);
          _innerBindExtensionObjectScalar(uaVariable, {
            get: () => uaVariable.$extensionObject,
            set: (value) => installExt(uaVariable, value),
            setField: (fieldName, value) => {
              const extObj = uaVariable.$extensionObject;
              getProxyTarget(extObj)[(0, node_opcua_utils_1.lowerFirstLetter)(fieldName)] = value;
            }
          }, options);
        }
      }
    }
    exports2._bindExtensionObject = _bindExtensionObject;
    var getIndexAsText = (index) => {
      if (typeof index === "number")
        return `${index}`;
      return `${index.map((a) => a.toString()).join(",")}`;
    };
    var composeBrowseNameAndNodeId = (uaVariable, indexes) => {
      const iAsText = getIndexAsText(indexes);
      const browseName = (0, node_opcua_data_model_1.coerceQualifiedName)(iAsText);
      let nodeId;
      if (uaVariable.nodeId.identifierType === node_opcua_nodeid_1.NodeIdType.STRING) {
        nodeId = new node_opcua_nodeid_1.NodeId(node_opcua_nodeid_1.NodeIdType.STRING, uaVariable.nodeId.value + `[${iAsText}]`, uaVariable.nodeId.namespace);
      }
      return { browseName, nodeId };
    };
    function _bindExtensionObjectArrayOrMatrix(uaVariable, optionalExtensionObjectArray, options) {
      options = options || { createMissingProp: false };
      options.createMissingProp = options.createMissingProp || false;
      if (uaVariable.valueRank < 1) {
        throw new Error("Variable must be a MultiDimensional array");
      }
      const arrayDimensions = uaVariable.arrayDimensions || [];
      if (!isVariableContainingExtensionObject(uaVariable)) {
        return [];
      }
      if (!optionalExtensionObjectArray && uaVariable.$dataValue.value.value) {
        (0, node_opcua_assert_1.default)(Array.isArray(uaVariable.$dataValue.value.value));
        optionalExtensionObjectArray = uaVariable.$dataValue.value.value;
      }
      if ((arrayDimensions.length === 0 || arrayDimensions.length === 1 && arrayDimensions[0] === 0) && optionalExtensionObjectArray) {
        arrayDimensions[0] = optionalExtensionObjectArray.length;
      }
      const totalLength = arrayDimensions.reduce((p3, c2) => p3 * c2, 1);
      const addressSpace = uaVariable.addressSpace;
      if (optionalExtensionObjectArray) {
        if (optionalExtensionObjectArray.length !== totalLength) {
          throw new Error(`optionalExtensionObjectArray must have the expected number of element matching ${arrayDimensions} but was ${optionalExtensionObjectArray.length}`);
        }
      }
      if (!optionalExtensionObjectArray) {
        optionalExtensionObjectArray = [];
        for (let i = 0; i < totalLength; i++) {
          optionalExtensionObjectArray[i] = addressSpace.constructExtensionObject(uaVariable.dataType, {});
        }
      }
      uaVariable.$$extensionObjectArray = optionalExtensionObjectArray;
      uaVariable.$dataValue.value.arrayType = uaVariable.valueRank === 1 ? node_opcua_variant_1.VariantArrayType.Array : node_opcua_variant_1.VariantArrayType.Matrix;
      uaVariable.$dataValue.value.dimensions = uaVariable.valueRank === 1 ? null : uaVariable.arrayDimensions || [];
      uaVariable.$dataValue.value.dataType = node_opcua_variant_1.DataType.ExtensionObject;
      uaVariable.$dataValue.value.value = uaVariable.$$extensionObjectArray;
      const $dataValue = uaVariable.$dataValue;
      Object.defineProperty(uaVariable, "$dataValue", {
        get() {
          return $dataValue;
        },
        set() {
          throw new Error("$dataValue is now sealed , you should not change internal $dataValue!");
        },
        //    writable: true,
        enumerable: true,
        configurable: true
      });
      uaVariable.bindVariable({
        get: () => uaVariable.$dataValue.value
      }, true);
      const namespace = uaVariable.namespace;
      const indexIterator = new idx_iterator_1.IndexIterator(arrayDimensions);
      for (let i = 0; i < totalLength; i++) {
        const index = indexIterator.next();
        const { browseName, nodeId } = composeBrowseNameAndNodeId(uaVariable, index);
        let uaElement = uaVariable.getComponentByName(browseName);
        if (!uaElement) {
          if (!options.createMissingProp) {
            continue;
          }
          uaElement = namespace.addVariable({
            browseName,
            nodeId,
            componentOf: uaVariable,
            dataType: uaVariable.dataType,
            valueRank: -1,
            accessLevel: uaVariable.accessLevel
          });
        }
        uaElement.$dataValue.statusCode = node_opcua_status_code_1.StatusCodes.Good;
        uaElement.$dataValue.sourceTimestamp = uaVariable.$dataValue.sourceTimestamp;
        uaElement.$dataValue.sourcePicoseconds = uaVariable.$dataValue.sourcePicoseconds;
        uaElement.$dataValue.serverTimestamp = uaVariable.$dataValue.serverTimestamp;
        uaElement.$dataValue.serverPicoseconds = uaVariable.$dataValue.serverPicoseconds;
        uaElement.$dataValue.value.dataType = node_opcua_variant_1.DataType.ExtensionObject;
        uaElement.$dataValue.value.arrayType = node_opcua_variant_1.VariantArrayType.Scalar;
        {
          const capturedIndex = i;
          const capturedUaElement = uaElement;
          _innerBindExtensionObjectScalar(uaElement, {
            get: () => uaVariable.$$extensionObjectArray[capturedIndex],
            set: (newValue, sourceTimestamp, cache) => {
              (0, node_opcua_assert_1.default)(!isProxy(uaVariable.$$extensionObjectArray[capturedIndex]));
              uaVariable.$$extensionObjectArray[capturedIndex] = newValue;
              if (uaVariable.$$extensionObjectArray !== uaVariable.$dataValue.value.value) {
                warningLog("uaVariable", uaVariable.nodeId.toString());
                warningLog("Houston! We have a problem ");
              }
              propagateTouchValueDownward(capturedUaElement, sourceTimestamp, cache);
              propagateTouchValueUpward(capturedUaElement, sourceTimestamp, cache);
            },
            setField: (fieldName, newValue, sourceTimestamp, cache) => {
              const extObj = uaVariable.$$extensionObjectArray[capturedIndex];
              (isProxy(extObj) ? getProxyTarget(extObj) : extObj)[(0, node_opcua_utils_1.lowerFirstLetter)(fieldName)] = newValue;
              propagateTouchValueUpward(capturedUaElement, sourceTimestamp, cache);
            }
          }, { ...options, force: true });
        }
      }
      return uaVariable.$$extensionObjectArray;
    }
    exports2._bindExtensionObjectArrayOrMatrix = _bindExtensionObjectArrayOrMatrix;
    function getElement(path3, data) {
      if (typeof path3 === "string") {
        path3 = path3.split(".");
      }
      let a = data;
      for (const e of path3) {
        a = a[e];
      }
      return a;
    }
    exports2.getElement = getElement;
    function setElement(path3, data, value) {
      if (typeof path3 === "string") {
        path3 = path3.split(".");
      }
      const last = path3.pop();
      let a = data;
      for (const e of path3) {
        a = a[e];
      }
      a[last] = value;
    }
    exports2.setElement = setElement;
    function incrementElement(path3, data) {
      const value = getElement(path3, data);
      setElement(path3, data, value + 1);
    }
    exports2.incrementElement = incrementElement;
    function extractPartialData(path3, extensionObject) {
      let name;
      if (typeof path3 === "string") {
        path3 = path3.split(".");
      }
      (0, node_opcua_assert_1.default)(path3 instanceof Array);
      let i;
      const partialData = {};
      let p3 = partialData;
      for (i = 0; i < path3.length - 1; i++) {
        name = path3[i];
        p3[name] = {};
        p3 = p3[name];
      }
      name = path3[path3.length - 1];
      p3[name] = 0;
      let c1 = partialData;
      let c2 = extensionObject;
      for (i = 0; i < path3.length - 1; i++) {
        name = path3[i];
        c1 = partialData[name];
        c2 = extensionObject[name];
      }
      name = path3[path3.length - 1];
      c1[name] = c2[name];
      return partialData;
    }
    exports2.extractPartialData = extractPartialData;
    function propagateTouchValueDownwardArray(uaVariable, now, cache) {
      if (!uaVariable.$$extensionObjectArray)
        return;
      const arrayDimensions = uaVariable.arrayDimensions || [];
      const totalLength = uaVariable.$$extensionObjectArray.length;
      const indexIterator = new idx_iterator_1.IndexIterator(arrayDimensions);
      for (let i = 0; i < totalLength; i++) {
        const index = indexIterator.next();
        const { browseName, nodeId } = composeBrowseNameAndNodeId(uaVariable, index);
        const uaElement = uaVariable.getComponentByName(browseName);
        if (uaElement?.nodeClass === node_opcua_data_model_1.NodeClass.Variable) {
          uaElement.touchValue(now);
          propagateTouchValueDownward(uaElement, now, cache);
        }
      }
    }
    exports2.propagateTouchValueDownwardArray = propagateTouchValueDownwardArray;
  }
});

// node_modules/node-opcua-address-space/dist/src/data_access/adjust_datavalue_status_code.js
var require_adjust_datavalue_status_code = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/data_access/adjust_datavalue_status_code.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.adjustDataValueStatusCode = void 0;
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_data_model_1 = require_dist27();
    function validate_value_range(range, variant) {
      if (variant.value < range.low || variant.value > range.high) {
        return false;
      }
      return true;
    }
    function adjustDataValueStatusCode(variable, dataValue, acceptValueOutOfRange) {
      const instrumentRange = variable.getChildByName("InstrumentRange");
      if (instrumentRange && instrumentRange.nodeClass === node_opcua_data_model_1.NodeClass.Variable) {
        if (!validate_value_range(instrumentRange.readValue().value.value, dataValue.value)) {
          if (!acceptValueOutOfRange) {
            return node_opcua_status_code_1.StatusCodes.BadOutOfRange;
          } else {
            dataValue.statusCode = node_opcua_status_code_1.StatusCodes.BadOutOfRange;
          }
        }
      }
      return node_opcua_status_code_1.StatusCodes.Good;
    }
    exports2.adjustDataValueStatusCode = adjustDataValueStatusCode;
  }
});

// node_modules/node-opcua-address-space/dist/src/get_basic_datatype.js
var require_get_basic_datatype = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/get_basic_datatype.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2._getBasicDataType = exports2._getBasicDataTypeFromDataTypeNodeId = void 0;
    var node_opcua_basic_types_1 = require_dist23();
    function _getBasicDataTypeFromDataTypeNodeId(addressSpace, dataTypeNodeId) {
      const dataTypeNodeId_ = dataTypeNodeId.nodeId ? dataTypeNodeId.nodeId : dataTypeNodeId;
      const dataTypeNode = addressSpace.findDataType(dataTypeNodeId_);
      if (!dataTypeNode) {
        return node_opcua_basic_types_1.DataType.Null;
      }
      return dataTypeNode.getBasicDataType();
    }
    exports2._getBasicDataTypeFromDataTypeNodeId = _getBasicDataTypeFromDataTypeNodeId;
    function _getBasicDataType(uaNode) {
      const _uaNode = uaNode;
      if (_uaNode._basicDataType) {
        return _uaNode._basicDataType;
      }
      if (_uaNode.dataType.namespace === 0 && _uaNode.dataType.value === 0) {
        return node_opcua_basic_types_1.DataType.Null;
      }
      const addressSpace = _uaNode.addressSpace;
      if (!addressSpace) {
        return node_opcua_basic_types_1.DataType.Null;
      }
      _uaNode._basicDataType = _getBasicDataTypeFromDataTypeNodeId(addressSpace, _uaNode.dataType);
      return _uaNode._basicDataType;
    }
    exports2._getBasicDataType = _getBasicDataType;
  }
});

// node_modules/node-opcua-address-space/dist/src/validate_data_type_correctness.js
var require_validate_data_type_correctness = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/validate_data_type_correctness.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.validateDataTypeCorrectness = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_debug_1 = require_dist24();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    function _dataType_toUADataType(addressSpace, dataType) {
      (0, node_opcua_assert_1.assert)(addressSpace);
      (0, node_opcua_assert_1.assert)(dataType !== node_opcua_basic_types_1.DataType.Null);
      const dataTypeNode = addressSpace.findDataType(node_opcua_basic_types_1.DataType[dataType]);
      if (!dataTypeNode) {
        throw new Error(" Cannot find DataType " + node_opcua_basic_types_1.DataType[dataType] + " in address Space");
      }
      return dataTypeNode;
    }
    var validDataTypeForEnumValue = [node_opcua_basic_types_1.DataType.Int32];
    function validateDataTypeCorrectness(addressSpace, dataTypeNodeId, variantDataType, allowNulls, context) {
      if (variantDataType === node_opcua_basic_types_1.DataType.Null && allowNulls) {
        return true;
      }
      if (variantDataType === node_opcua_basic_types_1.DataType.Null && !allowNulls) {
        return false;
      }
      let builtInType;
      let builtInUADataType;
      const destUADataType = addressSpace.findDataType(dataTypeNodeId);
      if (!destUADataType) {
        throw new Error("Cannot find UADataType " + dataTypeNodeId.toString() + " in address Space");
      }
      if (variantDataType === node_opcua_basic_types_1.DataType.ExtensionObject) {
        const structure = addressSpace.findDataType("Structure");
        if (destUADataType.isSubtypeOf(structure)) {
          return true;
        }
        return false;
      }
      if (destUADataType.isAbstract) {
        builtInUADataType = destUADataType;
      } else {
        builtInType = addressSpace.findCorrespondingBasicDataType(destUADataType);
        if (builtInType === node_opcua_basic_types_1.DataType.ExtensionObject) {
          return false;
        }
        builtInUADataType = addressSpace.findDataType(builtInType);
      }
      const enumerationUADataType = addressSpace.findDataType("Enumeration");
      if (!enumerationUADataType) {
        throw new Error("cannot find Enumeration DataType node in standard address space");
      }
      if (destUADataType.isSubtypeOf(enumerationUADataType)) {
        if (doDebug) {
          debugLog("destUADataType.", destUADataType.browseName.toString(), destUADataType.nodeId.toString());
          debugLog("enumerationUADataType.", enumerationUADataType.browseName.toString(), enumerationUADataType.nodeId.toString());
        }
        return validDataTypeForEnumValue.indexOf(variantDataType) >= 0;
      }
      const variantUADataType = _dataType_toUADataType(addressSpace, variantDataType);
      const dest_isSubTypeOf_variant = variantUADataType.isSubtypeOf(builtInUADataType);
      if (doDebug) {
        if (dest_isSubTypeOf_variant) {
          debugLog(chalk_1.default.green(" ---------- Type match !!! "), " on ", context?.toString());
        } else {
          debugLog(chalk_1.default.red(" ---------- Type mismatch "), " on ", context?.toString());
        }
        debugLog(chalk_1.default.cyan(" Variable data Type is    = "), destUADataType.browseName.toString());
        debugLog(chalk_1.default.cyan(" which matches basic Type = "), builtInUADataType.browseName.toString());
        debugLog(chalk_1.default.yellow("        Actual   dataType = "), variantUADataType.browseName.toString());
      }
      return dest_isSubTypeOf_variant;
    }
    exports2.validateDataTypeCorrectness = validateDataTypeCorrectness;
  }
});

// node_modules/any-promise/loader.js
var require_loader = __commonJS({
  "node_modules/any-promise/loader.js"(exports2, module2) {
    "use strict";
    var REGISTRATION_KEY = "@@any-promise/REGISTRATION";
    var registered = null;
    module2.exports = function(root, loadImplementation) {
      return function register(implementation, opts) {
        implementation = implementation || null;
        opts = opts || {};
        var registerGlobal = opts.global !== false;
        if (registered === null && registerGlobal) {
          registered = root[REGISTRATION_KEY] || null;
        }
        if (registered !== null && implementation !== null && registered.implementation !== implementation) {
          throw new Error('any-promise already defined as "' + registered.implementation + '".  You can only register an implementation before the first  call to require("any-promise") and an implementation cannot be changed');
        }
        if (registered === null) {
          if (implementation !== null && typeof opts.Promise !== "undefined") {
            registered = {
              Promise: opts.Promise,
              implementation
            };
          } else {
            registered = loadImplementation(implementation);
          }
          if (registerGlobal) {
            root[REGISTRATION_KEY] = registered;
          }
        }
        return registered;
      };
    };
  }
});

// node_modules/any-promise/register.js
var require_register = __commonJS({
  "node_modules/any-promise/register.js"(exports2, module2) {
    "use strict";
    module2.exports = require_loader()(global, loadImplementation);
    function loadImplementation(implementation) {
      var impl = null;
      if (shouldPreferGlobalPromise(implementation)) {
        impl = {
          Promise: global.Promise,
          implementation: "global.Promise"
        };
      } else if (implementation) {
        var lib = require(implementation);
        impl = {
          Promise: lib.Promise || lib,
          implementation
        };
      } else {
        impl = tryAutoDetect();
      }
      if (impl === null) {
        throw new Error('Cannot find any-promise implementation nor global.Promise. You must install polyfill or call require("any-promise/register") with your preferred implementation, e.g. require("any-promise/register/bluebird") on application load prior to any require("any-promise").');
      }
      return impl;
    }
    function shouldPreferGlobalPromise(implementation) {
      if (implementation) {
        return implementation === "global.Promise";
      } else if (typeof global.Promise !== "undefined") {
        var version = /v(\d+)\.(\d+)\.(\d+)/.exec(process.version);
        return !(version && +version[1] == 0 && +version[2] < 12);
      }
      return false;
    }
    function tryAutoDetect() {
      var libs = [
        "es6-promise",
        "promise",
        "native-promise-only",
        "bluebird",
        "rsvp",
        "when",
        "q",
        "pinkie",
        "lie",
        "vow"
      ];
      var i = 0, len = libs.length;
      for (; i < len; i++) {
        try {
          return loadImplementation(libs[i]);
        } catch (e) {
        }
      }
      return null;
    }
  }
});

// node_modules/any-promise/index.js
var require_any_promise = __commonJS({
  "node_modules/any-promise/index.js"(exports2, module2) {
    module2.exports = require_register()().Promise;
  }
});

// node_modules/thenify/index.js
var require_thenify = __commonJS({
  "node_modules/thenify/index.js"(exports2, module2) {
    var Promise2 = require_any_promise();
    var assert = require("assert");
    module2.exports = thenify;
    function thenify(fn, options) {
      assert(typeof fn === "function");
      return createWrapper(fn, options);
    }
    thenify.withCallback = function(fn, options) {
      assert(typeof fn === "function");
      options = options || {};
      options.withCallback = true;
      return createWrapper(fn, options);
    };
    function createCallback(resolve2, reject, multiArgs) {
      if (multiArgs === void 0)
        multiArgs = true;
      return function(err, value) {
        if (err)
          return reject(err);
        var length = arguments.length;
        if (length <= 2 || !multiArgs)
          return resolve2(value);
        if (Array.isArray(multiArgs)) {
          var values = {};
          for (var i = 1; i < length; i++)
            values[multiArgs[i - 1]] = arguments[i];
          return resolve2(values);
        }
        var values = new Array(length - 1);
        for (var i = 1; i < length; ++i)
          values[i - 1] = arguments[i];
        resolve2(values);
      };
    }
    function createWrapper(fn, options) {
      options = options || {};
      var name = fn.name;
      name = (name || "").replace(/\s|bound(?!$)/g, "");
      var newFn = function() {
        var self2 = this;
        var len = arguments.length;
        if (options.withCallback) {
          var lastType = typeof arguments[len - 1];
          if (lastType === "function")
            return fn.apply(self2, arguments);
        }
        var args = new Array(len + 1);
        for (var i = 0; i < len; ++i)
          args[i] = arguments[i];
        var lastIndex = i;
        return new Promise2(function(resolve2, reject) {
          args[lastIndex] = createCallback(resolve2, reject, options.multiArgs);
          fn.apply(self2, args);
        });
      };
      Object.defineProperty(newFn, "name", { value: name });
      return newFn;
    }
  }
});

// node_modules/node-opcua-address-space/dist/src/ua_variable_impl.js
var require_ua_variable_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/ua_variable_impl.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UAVariableImplT = exports2.UAVariableImpl = exports2.adjust_userAccessLevel = exports2.adjust_accessLevel = void 0;
    var util_1 = require("util");
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_address_space_base_1 = require_dist53();
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_date_time_1 = require_dist17();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_extension_object_1 = require_dist30();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_numeric_range_1 = require_dist31();
    var node_opcua_service_write_1 = require_dist40();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_variant_1 = require_dist28();
    var session_context_1 = require_session_context2();
    var multiform_func_1 = require_multiform_func();
    var base_node_impl_1 = require_base_node_impl();
    var base_node_private_1 = require_base_node_private();
    var apply_condition_refresh_1 = require_apply_condition_refresh();
    var ua_variable_impl_ext_obj_1 = require_ua_variable_impl_ext_obj();
    var adjust_datavalue_status_code_1 = require_adjust_datavalue_status_code();
    var get_basic_datatype_1 = require_get_basic_datatype();
    var validate_data_type_correctness_1 = require_validate_data_type_correctness();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    function adjust_accessLevel(accessLevel) {
      accessLevel = (0, node_opcua_utils_1.isNullOrUndefined)(accessLevel) ? "CurrentRead | CurrentWrite" : accessLevel;
      accessLevel = (0, node_opcua_data_model_1.makeAccessLevelFlag)(accessLevel);
      (0, node_opcua_assert_1.assert)(isFinite(accessLevel));
      return accessLevel;
    }
    exports2.adjust_accessLevel = adjust_accessLevel;
    function adjust_userAccessLevel(userAccessLevel, accessLevel) {
      if (userAccessLevel === void 0) {
        return void 0;
      }
      userAccessLevel = adjust_accessLevel(userAccessLevel);
      accessLevel = adjust_accessLevel(accessLevel);
      return (0, node_opcua_data_model_1.makeAccessLevelFlag)(accessLevel & userAccessLevel);
    }
    exports2.adjust_userAccessLevel = adjust_userAccessLevel;
    function adjust_samplingInterval(minimumSamplingInterval) {
      (0, node_opcua_assert_1.assert)(isFinite(minimumSamplingInterval));
      if (minimumSamplingInterval < 0) {
        return -1;
      }
      return minimumSamplingInterval;
    }
    function is_Variant(v) {
      return v instanceof node_opcua_variant_1.Variant;
    }
    function is_StatusCode(v) {
      return v && v.constructor && (v instanceof node_opcua_status_code_1.StatusCode || v.constructor.name === "ConstantStatusCode" || v.constructor.name === "StatusCode" || v.constructor.name === "ModifiableStatusCode");
    }
    function is_Variant_or_StatusCode(v) {
      if (is_Variant(v)) {
      }
      return is_Variant(v) || is_StatusCode(v);
    }
    function default_func(dataValue1, callback1) {
      return _default_writable_timestamped_set_func.call(this, dataValue1, callback1);
    }
    var UAVariableImpl = class _UAVariableImpl extends base_node_impl_1.BaseNodeImpl {
      get typeDefinitionObj() {
        if (super.typeDefinitionObj && super.typeDefinitionObj.nodeClass !== node_opcua_data_model_1.NodeClass.VariableType) {
          warningLog(super.typeDefinitionObj.toString());
          return this.addressSpace.findVariableType("BaseVariableType");
        }
        return super.typeDefinitionObj;
      }
      get typeDefinition() {
        return super.typeDefinition;
      }
      constructor(options) {
        super(options);
        this.nodeClass = node_opcua_data_model_1.NodeClass.Variable;
        (0, node_opcua_variant_1.verifyRankAndDimensions)(options);
        this.valueRank = options.valueRank;
        this.arrayDimensions = options.arrayDimensions;
        this.dataType = this.resolveNodeId(options.dataType);
        this.accessLevel = adjust_accessLevel(options.accessLevel);
        this.userAccessLevel = adjust_userAccessLevel(options.userAccessLevel, this.accessLevel);
        this.minimumSamplingInterval = adjust_samplingInterval(options.minimumSamplingInterval || 0);
        this.historizing = !!options.historizing;
        this.$dataValue = new node_opcua_data_value_1.DataValue({ statusCode: node_opcua_status_code_1.StatusCodes.UncertainInitialValue, value: { dataType: node_opcua_variant_1.DataType.Null } });
        if (options.value) {
          this.bindVariable(options.value);
        }
        this.setMaxListeners(5e3);
        this.semantic_version = 0;
      }
      checkAccessLevelPrivate(_context, accessLevel) {
        if (this.userAccessLevel === void 0) {
          return true;
        }
        return (this.userAccessLevel & accessLevel) === accessLevel;
      }
      checkPermissionPrivate(context, permission) {
        if (!context)
          return true;
        (0, node_opcua_assert_1.assert)(context instanceof session_context_1.SessionContext);
        if (context.checkPermission) {
          if (!(context.checkPermission instanceof Function)) {
            errorLog("context checkPermission is not a function");
            return false;
          }
          if (!context.checkPermission(this, permission)) {
            return false;
          }
        }
        return true;
      }
      checkPermissionAndAccessLevelPrivate(context, permission, accessLevel) {
        if (!this.checkPermissionPrivate(context, permission)) {
          return false;
        }
        return this.checkAccessLevelPrivate(context, accessLevel);
      }
      isReadable(context) {
        return (this.accessLevel & node_opcua_data_model_1.AccessLevelFlag.CurrentRead) === node_opcua_data_model_1.AccessLevelFlag.CurrentRead;
      }
      isUserReadable(context) {
        if (!this.isReadable(context)) {
          return false;
        }
        if (!this.checkPermissionPrivate(context, node_opcua_types_1.PermissionType.Read)) {
          return false;
        }
        return this.checkAccessLevelPrivate(context, node_opcua_data_model_1.AccessLevelFlag.CurrentRead);
      }
      isWritable(context) {
        return (this.accessLevel & node_opcua_data_model_1.AccessLevelFlag.CurrentWrite) === node_opcua_data_model_1.AccessLevelFlag.CurrentWrite;
      }
      isUserWritable(context) {
        if (!this.isWritable(context)) {
          return false;
        }
        return this.checkPermissionAndAccessLevelPrivate(context, node_opcua_types_1.PermissionType.Write, node_opcua_data_model_1.AccessLevelFlag.CurrentWrite);
      }
      canUserReadHistory(context) {
        return this.checkPermissionAndAccessLevelPrivate(context, node_opcua_types_1.PermissionType.ReadHistory, node_opcua_data_model_1.AccessLevelFlag.HistoryRead);
      }
      canUserWriteHistorizingAttribute(context) {
        if (context && !context.checkPermission(this, node_opcua_types_1.PermissionType.WriteHistorizing)) {
          return false;
        }
        return true;
      }
      canUserInsertHistory(context) {
        return this.checkPermissionAndAccessLevelPrivate(context, node_opcua_types_1.PermissionType.InsertHistory, node_opcua_data_model_1.AccessLevelFlag.HistoryWrite);
      }
      canUserModifyHistory(context) {
        return this.checkPermissionAndAccessLevelPrivate(context, node_opcua_types_1.PermissionType.ModifyHistory, node_opcua_data_model_1.AccessLevelFlag.HistoryWrite);
      }
      canUserDeleteHistory(context) {
        return this.checkPermissionAndAccessLevelPrivate(context, node_opcua_types_1.PermissionType.DeleteHistory, node_opcua_data_model_1.AccessLevelFlag.HistoryWrite);
      }
      /**
       *
       *
       * from OPC.UA.Spec 1.02 part 4
       *  5.10.2.4 StatusCodes
       *  Table 51 defines values for the operation level statusCode contained in the DataValue structure of
       *  each values element. Common StatusCodes are defined in Table 166.
       *
       * Table 51 Read Operation Level Result Codes
       *
       * | Symbolic Id                 | Description
       * |-----------------------------|---------------------------------------------------------------------------------------------|
       * |BadNodeIdInvalid             | The syntax of the node id is not valid.|
       * |BadNodeIdUnknown            |The node id refers to a node that does not exist in the server address space.|
       * |BadAttributeIdInvalid      | BadAttributeIdInvalid The attribute is not supported for the specified node.|
       * |BadIndexRangeInvalid       | The syntax of the index range parameter is invalid.|
       * |BadIndexRangeNoData        | No data exists within the range of indexes specified.|
       * |BadDataEncodingInvalid     | The data encoding is invalid.|
       * |                           | This result is used if no dataEncoding can be applied because an Attribute other|
       * |                           | than Value was requested or the DataType of the Value Attribute is not a subtype|
       * |                           | of the Structure DataType.|
       * |BadDataEncodingUnsupported | The server does not support the requested data encoding for the node. |
       * |                           | This result is used if a dataEncoding can be applied but the passed data encoding |
       * |                           | is not known to the Server. |
       * |BadNotReadable             | The access level does not allow reading or subscribing to the Node.|
       * |BadUserAccessDenied        | User does not have permission to perform the requested operation. (table 165)|
       */
      readValue(context, indexRange, dataEncoding) {
        if (!context) {
          context = session_context_1.SessionContext.defaultContext;
        }
        if (context.isAccessRestricted(this)) {
          return new node_opcua_data_value_1.DataValue({ statusCode: node_opcua_status_code_1.StatusCodes.BadSecurityModeInsufficient });
        }
        if (!this.isReadable(context)) {
          return new node_opcua_data_value_1.DataValue({ statusCode: node_opcua_status_code_1.StatusCodes.BadNotReadable });
        }
        if (!this.checkPermissionPrivate(context, node_opcua_types_1.PermissionType.Read)) {
          return new node_opcua_data_value_1.DataValue({ statusCode: node_opcua_status_code_1.StatusCodes.BadUserAccessDenied });
        }
        if (!this.isUserReadable(context)) {
          return new node_opcua_data_value_1.DataValue({ statusCode: node_opcua_status_code_1.StatusCodes.BadNotReadable });
        }
        if (!(0, node_opcua_data_model_1.isValidDataEncoding)(dataEncoding)) {
          return new node_opcua_data_value_1.DataValue({ statusCode: node_opcua_status_code_1.StatusCodes.BadDataEncodingInvalid });
        }
        if (this._timestamped_get_func) {
          if (this._timestamped_get_func.length === 0) {
            const dataValueOrPromise = this._timestamped_get_func();
            if (!Object.prototype.hasOwnProperty.call(dataValueOrPromise, "then")) {
              if (dataValueOrPromise !== this.$dataValue) {
                this.$dataValue = dataValueOrPromise;
                this.verifyVariantCompatibility(this.$dataValue.value);
              }
            } else {
              errorLog("Unsupported: _timestamped_get_func returns a Promise !");
            }
          }
        }
        let dataValue = this.$dataValue;
        if (dataValue.statusCode.isGoodish()) {
          dataValue = (0, node_opcua_data_value_1.extractRange)(dataValue, indexRange);
        }
        if (dataValue.statusCode.equals(node_opcua_status_code_1.StatusCodes.BadWaitingForInitialData) || dataValue.statusCode.equals(node_opcua_status_code_1.StatusCodes.UncertainInitialValue)) {
          debugLog(chalk_1.default.red(" Warning:  UAVariable#readValue ") + chalk_1.default.cyan(this.browseName.toString()) + " (" + chalk_1.default.yellow(this.nodeId.toString()) + ") exists but dataValue has not been defined");
        }
        return dataValue;
      }
      isEnumeration() {
        return this.addressSpacePrivate.isEnumeration(this.dataType);
      }
      /**
       * return true if the DataType is of type Extension object
       * this is not taking into account the valueRank of the variable
       */
      isExtensionObject() {
        if (this.dataType.isEmpty())
          return false;
        const dataTypeNode = this.addressSpace.findDataType(this.dataType);
        if (!dataTypeNode) {
          throw new Error(" Cannot find  DataType  " + this.dataType.toString() + " in standard address Space");
        }
        const structureNode = this.addressSpace.findDataType("Structure");
        if (!structureNode) {
          throw new Error(" Cannot find 'Structure' DataType in standard address Space");
        }
        return dataTypeNode.isSubtypeOf(structureNode);
      }
      _getEnumerationInfo() {
        (0, node_opcua_assert_1.assert)(this.isEnumeration(), "Variable is not an enumeration");
        const dataTypeNode = this.addressSpace.findDataType(this.dataType);
        return dataTypeNode._getEnumerationInfo();
      }
      asyncRefresh(...args) {
        if (this.$dataValue.statusCode.isGoodish()) {
          this.verifyVariantCompatibility(this.$dataValue.value);
        }
        const oldestDate = args[0];
        const callback = args[1];
        const lessOrEqual = (a, b) => {
          return a.timestamp.getTime() < b.timestamp.getTime() || a.timestamp.getTime() === b.timestamp.getTime() && a.picoseconds <= b.picoseconds;
        };
        if (!this.refreshFunc) {
          const dataValue = this.readValue();
          dataValue.serverTimestamp = oldestDate.timestamp;
          dataValue.serverPicoseconds = oldestDate.picoseconds;
          const serverClock = (0, node_opcua_date_time_1.coerceClock)(dataValue.serverTimestamp, dataValue.serverPicoseconds);
          if (lessOrEqual(oldestDate, serverClock)) {
            return callback(null, dataValue);
          } else {
            return callback(null, dataValue);
          }
        }
        const c1 = this.$dataValue.serverTimestamp ? (0, node_opcua_date_time_1.coerceClock)(this.$dataValue.serverTimestamp, this.$dataValue.serverPicoseconds) : null;
        if (this.$dataValue.serverTimestamp && lessOrEqual(oldestDate, c1)) {
          const dataValue = this.readValue().clone();
          dataValue.serverTimestamp = oldestDate.timestamp;
          dataValue.serverPicoseconds = oldestDate.picoseconds;
          return callback(null, dataValue);
        }
        try {
          this.refreshFunc.call(this, (err, dataValue) => {
            if (err || !dataValue) {
              errorLog("-------------- refresh call failed", this.browseName.toString(), this.nodeId.toString(), err?.message);
              dataValue = { statusCode: node_opcua_status_code_1.StatusCodes.BadNoDataAvailable };
            }
            if (dataValue && dataValue !== this.$dataValue) {
              this._internal_set_dataValue(coerceDataValue(dataValue), null);
            }
            callback(err, this.$dataValue);
          });
        } catch (err) {
          errorLog("-------------- refresh call failed 2", this.browseName.toString(), this.nodeId.toString());
          errorLog(err);
          const dataValue = new node_opcua_data_value_1.DataValue({ statusCode: node_opcua_status_code_1.StatusCodes.BadInternalError });
          this._internal_set_dataValue(dataValue, null);
          callback(err, this.$dataValue);
        }
      }
      readEnumValue() {
        const value = this.readValue().value.value;
        const enumInfo = this._getEnumerationInfo();
        const enumV = enumInfo.valueIndex[value];
        return { value, name: enumV ? enumV.name : "?????" };
      }
      writeEnumValue(value) {
        const enumInfo = this._getEnumerationInfo();
        if (typeof value === "string") {
          if (!Object.prototype.hasOwnProperty.call(enumInfo.nameIndex, value)) {
            const possibleValues = Object.keys(enumInfo.nameIndex).join(",");
            throw new Error("UAVariable#writeEnumValue: cannot find value " + value + " in [" + possibleValues + "]");
          }
          const valueIndex = enumInfo.nameIndex[value].value;
          value = valueIndex;
        }
        if (isFinite(value)) {
          const possibleValues = Object.keys(enumInfo.nameIndex).join(",");
          if (!enumInfo.valueIndex[value]) {
            throw new Error("UAVariable#writeEnumValue : value out of range " + value + " in [" + possibleValues + "]");
          }
          this.setValueFromSource({
            dataType: node_opcua_variant_1.DataType.Int32,
            value
          });
        } else {
          throw new Error("UAVariable#writeEnumValue:  value type mismatch");
        }
      }
      readAttribute(context, attributeId, indexRange, dataEncoding) {
        context = context || session_context_1.SessionContext.defaultContext;
        (0, node_opcua_assert_1.assert)(context instanceof session_context_1.SessionContext);
        const options = {};
        if (attributeId !== node_opcua_data_model_1.AttributeIds.Value) {
          if (indexRange && indexRange.isDefined()) {
            options.statusCode = node_opcua_status_code_1.StatusCodes.BadIndexRangeNoData;
            return new node_opcua_data_value_1.DataValue(options);
          }
          if ((0, node_opcua_data_model_1.isDataEncoding)(dataEncoding)) {
            options.statusCode = node_opcua_status_code_1.StatusCodes.BadDataEncodingInvalid;
            return new node_opcua_data_value_1.DataValue(options);
          }
        }
        switch (attributeId) {
          case node_opcua_data_model_1.AttributeIds.Value:
            return this.readValue(context, indexRange, dataEncoding);
          case node_opcua_data_model_1.AttributeIds.DataType:
            return this._readDataType();
          case node_opcua_data_model_1.AttributeIds.ValueRank:
            return this._readValueRank();
          case node_opcua_data_model_1.AttributeIds.ArrayDimensions:
            return this._readArrayDimensions();
          case node_opcua_data_model_1.AttributeIds.AccessLevel:
            return this._readAccessLevel(context);
          case node_opcua_data_model_1.AttributeIds.UserAccessLevel:
            return this._readUserAccessLevel(context);
          case node_opcua_data_model_1.AttributeIds.MinimumSamplingInterval:
            return this._readMinimumSamplingInterval();
          case node_opcua_data_model_1.AttributeIds.Historizing:
            return this._readHistorizing();
          case node_opcua_data_model_1.AttributeIds.AccessLevelEx:
            return this._readAccessLevelEx(context);
          default:
            return base_node_impl_1.BaseNodeImpl.prototype.readAttribute.call(this, context, attributeId);
        }
      }
      getBasicDataType() {
        return (0, get_basic_datatype_1._getBasicDataType)(this);
      }
      adjustVariant(variant) {
        return (0, node_opcua_variant_1.adjustVariant)(variant, this.valueRank, this.getBasicDataType());
      }
      verifyVariantCompatibility(variant) {
        try {
          if (Object.prototype.hasOwnProperty.call(variant, "value")) {
            if (variant.dataType === null || variant.dataType === void 0) {
              throw new Error("Variant must provide a valid dataType : variant = " + variant.toString() + " this.dataType= " + this.dataType.toString());
            }
            if (variant.dataType === node_opcua_variant_1.DataType.Boolean && (this.dataType.namespace !== 0 || this.dataType.value !== node_opcua_variant_1.DataType.Boolean)) {
              throw new Error("Variant must provide a valid Boolean : variant = " + variant.toString() + " this.dataType= " + this.dataType.toString());
            }
            if (this.dataType.namespace === 0 && this.dataType.value === node_opcua_variant_1.DataType.LocalizedText && variant.dataType !== node_opcua_variant_1.DataType.LocalizedText && variant.dataType !== node_opcua_variant_1.DataType.Null) {
              throw new Error("Variant must provide a valid LocalizedText : variant = " + variant.toString() + " this.dataType= " + this.dataType.toString());
            }
          }
          const basicType = this.getBasicDataType();
          if (basicType === node_opcua_variant_1.DataType.String && variant.dataType === node_opcua_variant_1.DataType.ByteString) {
            return;
          }
          if (basicType === node_opcua_variant_1.DataType.ByteString && variant.dataType === node_opcua_variant_1.DataType.String) {
            return;
          }
          if (basicType !== node_opcua_variant_1.DataType.Null && basicType !== node_opcua_variant_1.DataType.Variant && variant.dataType !== node_opcua_variant_1.DataType.Null && variant.dataType !== basicType) {
            const message = "UAVariable.setValueFromSource " + this.browseName.toString() + " nodeId:" + this.nodeId.toString() + " dataType:" + this.dataType.toString() + ":\nthe provided variant must have the expected dataType!\n   - the expected dataType is " + chalk_1.default.cyan(node_opcua_variant_1.DataType[basicType]) + "\n   - the actual dataType   is " + chalk_1.default.magenta(node_opcua_variant_1.DataType[variant.dataType]) + "\n   - " + variant.toString();
            throw new Error(message);
          }
        } catch (err) {
          errorLog("UAVariable  ", err?.message, this.browseName.toString(), " nodeId=", this.nodeId.toString());
          errorLog(err.message);
          errorLog(err.stack);
          throw err;
        }
      }
      /**
           * setValueFromSource is used to let the device sets the variable values
           * this method also records the current time as sourceTimestamp and serverTimestamp.
      .     *
          * The method will raise an exception if the value is not compatible with the dataType and expected dimension
          *
          * @method setValueFromSource
          * @param variant  {Variant}
          * @param [statusCode  {StatusCode} = StatusCodes.Good]
          * @param [sourceTimestamp= Now]
          */
      setValueFromSource(variant, statusCode, sourceTimestamp) {
        try {
          statusCode = statusCode || node_opcua_status_code_1.StatusCodes.Good;
          const variant1 = node_opcua_variant_1.Variant.coerce(variant);
          this.verifyVariantCompatibility(variant1);
          const now = (0, node_opcua_date_time_1.coerceClock)(sourceTimestamp, 0);
          const dataValue = new node_opcua_data_value_1.DataValue(null);
          dataValue.serverPicoseconds = now.picoseconds;
          dataValue.serverTimestamp = now.timestamp;
          dataValue.sourcePicoseconds = now.picoseconds;
          dataValue.sourceTimestamp = now.timestamp;
          dataValue.statusCode = statusCode;
          dataValue.value = variant1;
          if (dataValue.value.dataType === node_opcua_variant_1.DataType.ExtensionObject) {
            const valueIsCorrect = this.checkExtensionObjectIsCorrect(dataValue.value.value);
            if (!valueIsCorrect) {
              errorLog("setValueFromSource Invalid value !");
              errorLog(this.toString());
              errorLog(dataValue.toString());
              this.checkExtensionObjectIsCorrect(dataValue.value.value);
            }
            if (this.$extensionObject || this.$$extensionObjectArray) {
              this._internal_set_dataValue(dataValue);
              return;
            } else {
              this.$dataValue = dataValue;
            }
          } else {
            this._internal_set_dataValue(dataValue);
          }
        } catch (err) {
          errorLog("UAVariable#setValueFromString Error : ", this.browseName.toString(), this.nodeId.toString());
          errorLog(err.message);
          errorLog(this.parent?.toString());
          throw err;
        }
      }
      adjustDataValueStatusCode(dataValue) {
        const statusCode = (0, adjust_datavalue_status_code_1.adjustDataValueStatusCode)(this, dataValue, this.acceptValueOutOfRange || false);
        return statusCode;
      }
      writeValue(context, dataValue, ...args) {
        context = context || session_context_1.SessionContext.defaultContext;
        (0, node_opcua_assert_1.assert)(context instanceof session_context_1.SessionContext);
        if (!dataValue.sourceTimestamp) {
          if (context.currentTime) {
            dataValue.sourceTimestamp = context.currentTime.timestamp;
            dataValue.sourcePicoseconds = context.currentTime.picoseconds;
          } else {
            const { timestamp, picoseconds } = (0, node_opcua_date_time_1.getCurrentClock)();
            dataValue.sourceTimestamp = timestamp;
            dataValue.sourcePicoseconds = picoseconds;
          }
        }
        if (context.currentTime && !dataValue.serverTimestamp) {
          dataValue.serverTimestamp = context.currentTime.timestamp;
          dataValue.serverPicoseconds = context.currentTime.picoseconds;
        }
        let indexRange = null;
        let callback;
        if (args.length === 1) {
          indexRange = new node_opcua_numeric_range_1.NumericRange();
          callback = args[0];
        } else if (args.length === 2) {
          indexRange = args[0];
          callback = args[1];
        } else {
          throw new Error("Invalid Number of args");
        }
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        (0, node_opcua_assert_1.assert)(dataValue instanceof node_opcua_data_value_1.DataValue);
        indexRange = node_opcua_numeric_range_1.NumericRange.coerce(indexRange);
        if (!this.isWritable(context)) {
          return callback(null, node_opcua_status_code_1.StatusCodes.BadNotWritable);
        }
        if (!this.checkPermissionPrivate(context, node_opcua_types_1.PermissionType.Write)) {
          return new node_opcua_data_value_1.DataValue({ statusCode: node_opcua_status_code_1.StatusCodes.BadUserAccessDenied });
        }
        if (!this.isUserWritable(context)) {
          return callback(null, node_opcua_status_code_1.StatusCodes.BadWriteNotSupported);
        }
        const variant = adjustVariant2.call(this, dataValue.value);
        const statusCode = this.checkVariantCompatibility(variant);
        if (statusCode.isNot(node_opcua_status_code_1.StatusCodes.Good)) {
          return callback(null, statusCode);
        }
        const statusCode2 = this.adjustDataValueStatusCode(dataValue);
        if (statusCode2.isNotGood()) {
          return callback(null, statusCode2);
        }
        const write_func = this._timestamped_set_func || default_func;
        if (!write_func) {
          warningLog(" warning " + this.nodeId.toString() + " " + this.browseName.toString() + " has no setter. \n");
          warningLog("Please make sure to bind the variable or to pass a valid value: new Variant({}) during construction time");
          return callback(null, node_opcua_status_code_1.StatusCodes.BadNotWritable);
        }
        (0, node_opcua_assert_1.assert)(write_func);
        write_func.call(this, dataValue, (err, statusCode1) => {
          if (!err) {
            dataValue && this.verifyVariantCompatibility(dataValue.value);
            if (indexRange && !indexRange.isEmpty()) {
              if (!indexRange.isValid()) {
                return callback(null, node_opcua_status_code_1.StatusCodes.BadIndexRangeInvalid);
              }
              const newArrayOrMatrix = dataValue.value.value;
              if (dataValue.value.arrayType === node_opcua_variant_1.VariantArrayType.Array) {
                if (this.$dataValue.value.arrayType !== node_opcua_variant_1.VariantArrayType.Array) {
                  return callback(null, node_opcua_status_code_1.StatusCodes.BadTypeMismatch);
                }
                (0, node_opcua_assert_1.assert)(check_valid_array(this.$dataValue.value.dataType, this.$dataValue.value.value));
                const destArr = this.$dataValue.value.value;
                const result2 = indexRange.set_values(destArr, newArrayOrMatrix);
                if (result2.statusCode.isNot(node_opcua_status_code_1.StatusCodes.Good)) {
                  return callback(null, result2.statusCode);
                }
                dataValue.value.value = result2.array;
                this.$dataValue.value.value = null;
              } else if (dataValue.value.arrayType === node_opcua_variant_1.VariantArrayType.Matrix) {
                const dimensions = this.$dataValue.value.dimensions;
                if (this.$dataValue.value.arrayType !== node_opcua_variant_1.VariantArrayType.Matrix || !dimensions) {
                  return callback(null, node_opcua_status_code_1.StatusCodes.BadTypeMismatch);
                }
                const matrix = this.$dataValue.value.value;
                const result2 = indexRange.set_values_matrix({
                  matrix,
                  dimensions
                }, newArrayOrMatrix);
                if (result2.statusCode.isNot(node_opcua_status_code_1.StatusCodes.Good)) {
                  return callback(null, result2.statusCode);
                }
                dataValue.value.dimensions = this.$dataValue.value.dimensions;
                dataValue.value.value = result2.matrix;
                this.$dataValue.value.value = null;
              } else {
                return callback(null, node_opcua_status_code_1.StatusCodes.BadTypeMismatch);
              }
            }
            try {
              this._internal_set_dataValue(dataValue, indexRange);
            } catch (err2) {
              if (util_1.types.isNativeError(err2)) {
                warningLog(err2.message);
              }
              return callback(null, node_opcua_status_code_1.StatusCodes.BadInternalError);
            }
          }
          callback(err || null, statusCode1);
        });
      }
      writeAttribute(context, writeValueOptions, callback) {
        if (!callback) {
          throw new Error("Internal error");
        }
        if (!this.canUserWriteAttribute(context, writeValueOptions.attributeId)) {
          return callback(null, node_opcua_status_code_1.StatusCodes.BadUserAccessDenied);
        }
        const writeValue = writeValueOptions instanceof node_opcua_service_write_1.WriteValue ? writeValueOptions : new node_opcua_service_write_1.WriteValue(writeValueOptions);
        context = context || session_context_1.SessionContext.defaultContext;
        (0, node_opcua_assert_1.assert)(context instanceof session_context_1.SessionContext);
        (0, node_opcua_assert_1.assert)(writeValue instanceof node_opcua_service_write_1.WriteValue);
        (0, node_opcua_assert_1.assert)(writeValue.value instanceof node_opcua_data_value_1.DataValue);
        (0, node_opcua_assert_1.assert)(writeValue.value.value instanceof node_opcua_variant_1.Variant);
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        switch (writeValue.attributeId) {
          case node_opcua_data_model_1.AttributeIds.Value:
            this.writeValue(context, writeValue.value, writeValue.indexRange, callback);
            break;
          case node_opcua_data_model_1.AttributeIds.Historizing:
            if (writeValue.value.value.dataType !== node_opcua_variant_1.DataType.Boolean) {
              return callback(null, node_opcua_status_code_1.StatusCodes.BadTypeMismatch);
            }
            if (!this.checkPermissionPrivate(context, node_opcua_types_1.PermissionType.WriteHistorizing)) {
              return callback(null, node_opcua_status_code_1.StatusCodes.BadUserAccessDenied);
            }
            if (!this.canUserWriteHistorizingAttribute(context)) {
              return callback(null, node_opcua_status_code_1.StatusCodes.BadHistoryOperationUnsupported);
            }
            if (!this.getChildByName("HA Configuration")) {
              return callback(null, node_opcua_status_code_1.StatusCodes.BadNotSupported);
            }
            this.historizing = !!writeValue.value.value.value;
            return callback(null, node_opcua_status_code_1.StatusCodes.Good);
          default:
            super.writeAttribute(context, writeValue, callback);
            break;
        }
      }
      /**
       * @method checkVariantCompatibility
       * note:
       *     this method is overridden in address-space-data-access
       * @return {StatusCode}
       */
      checkVariantCompatibility(value) {
        if (!this._validate_DataType(value.dataType)) {
          return node_opcua_status_code_1.StatusCodes.BadTypeMismatch;
        }
        try {
          this.verifyVariantCompatibility(value);
        } catch (err) {
          return node_opcua_status_code_1.StatusCodes.BadTypeMismatch;
        }
        return node_opcua_status_code_1.StatusCodes.Good;
      }
      /**
       * touch the source timestamp of a Variable and cascade up the change
       * to the parent variable if any.
       */
      touchValue(optionalNow) {
        const now = optionalNow || (0, node_opcua_date_time_1.getCurrentClock)();
        (0, ua_variable_impl_ext_obj_1.propagateTouchValueUpward)(this, now);
      }
      /**
       * bind a variable with a get and set functions.
       *
       *  properties:
       *    - value: a Variant or a status code
       *    - sourceTimestamp
       *    - sourcePicoseconds
       * @param [options.timestamped_set]
       * @param [options.refreshFunc]      the variable asynchronous getter function.
       * @param [overwrite {Boolean} = false] set overwrite to true to overwrite existing binding
       * @return void
       *
       *
       * ### Providing read access to the underlying value
       *
       * #### Variation 1
       *
       * In this variation, the user provides a function that returns a Variant with the current value.
       *
       * The sourceTimestamp will be set automatically.
       *
       * The get function is called synchronously.
       *
       * @example
       *
       *
       * ```javascript
       *     ...
       *     var options =  {
       *       get : () => {
       *          return new Variant({...});
       *       },
       *       set : function(variant) {
       *          // store the variant somewhere
       *          return StatusCodes.Good;
       *       }
       *    };
       *    ...
       *    engine.bindVariable(nodeId,options):
       *    ...
       * ```
       *
       *
       * #### Variation 2:
       *
       * This variation can be used when the user wants to specify a specific '''sourceTimestamp''' associated
       * with the current value of the UAVariable.
       *
       * The provided ```timestamped_get``` function should return an object with three properties:
       * * value: containing the variant value or a error StatusCode,
       * * sourceTimestamp
       * * sourcePicoseconds
       *
       * ```javascript
       * ...
       * var myDataValue = new DataValue({
       *   value: {dataType: DataType.Double , value: 10.0},
       *   sourceTimestamp : new Date(),
       *   sourcePicoseconds: 0
       * });
       * ...
       * var options =  {
       *   timestamped_get : () => { return myDataValue;  }
       * };
       * ...
       * engine.bindVariable(nodeId,options):
       * ...
       * // record a new value
       * myDataValue.value.value = 5.0;
       * myDataValue.sourceTimestamp = new Date();
       * ...
       * ```
       *
       *
       * #### Variation 3:
       *
       * This variation can be used when the value associated with the variables requires a asynchronous function call to be
       * extracted. In this case, the user should provide an async method ```refreshFunc```.
       *
       *
       * The ```refreshFunc``` shall do whatever is necessary to fetch the most up to date version of the variable value, and
       * call the ```callback``` function when the data is ready.
       *
       *
       * The ```callback``` function follow the standard callback function signature:
       * * the first argument shall be **null** or **Error**, depending of the outcome of the fetch operation,
       * * the second argument shall be a DataValue with the new UAVariable Value,  a StatusCode, and time stamps.
       *
       *
       * Optionally, it is possible to pass a sourceTimestamp and a sourcePicoseconds value as a third and fourth arguments
       * of the callback. When sourceTimestamp and sourcePicoseconds are missing, the system will set their default value
       * to the current time..
       *
       *
       * ```javascript
       * ...
       * var options =  {
       *    refreshFunc : function(callback) {
       *      ... do_some_async_stuff_to_get_the_new_variable_value
       *      var dataValue = new DataValue({
       *          value: new Variant({...}),
       *          statusCode: StatusCodes.Good,
       *          sourceTimestamp: new Date()
       *      });
       *      callback(null,dataValue);
       *    }
       * };
       * ...
       * variable.bindVariable(nodeId,options):
       * ...
       * ```
       *
       * ### Providing write access to the underlying value
       *
       * #### Variation1 - provide a simple synchronous set function
       *
       *
       * #### Notes
       *   to do : explain return StatusCodes.GoodCompletesAsynchronously;
       *
       */
      bindVariable(options, overwrite) {
        if (overwrite) {
          this._timestamped_set_func = null;
          this._timestamped_get_func = null;
          this._get_func = null;
          this._set_func = null;
          this.refreshFunc = void 0;
          this._historyRead = _UAVariableImpl.prototype._historyRead;
        }
        options = options || {};
        (0, node_opcua_assert_1.assert)(typeof this._timestamped_set_func !== "function", "UAVariable already bound");
        (0, node_opcua_assert_1.assert)(typeof this._timestamped_get_func !== "function", "UAVariable already bound");
        bind_getter.call(this, options);
        bind_setter.call(this, options);
        const _historyRead = options.historyRead;
        if (_historyRead) {
          (0, node_opcua_assert_1.assert)(typeof this._historyRead !== "function" || this._historyRead === _UAVariableImpl.prototype._historyRead);
          (0, node_opcua_assert_1.assert)(typeof _historyRead === "function");
          this._historyRead = _historyRead;
          (0, node_opcua_assert_1.assert)(this._historyRead.length === 6);
        }
        (0, node_opcua_assert_1.assert)(typeof this._timestamped_set_func === "function");
        (0, node_opcua_assert_1.assert)(this._timestamped_set_func.length === 2, "expecting 2 parameters");
      }
      readValueAsync(context, callback) {
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        context = context || session_context_1.SessionContext.defaultContext;
        this.__waiting_callbacks = this.__waiting_callbacks || [];
        this.__waiting_callbacks.push(callback);
        const _readValueAsync_in_progress = this.__waiting_callbacks.length >= 2;
        if (_readValueAsync_in_progress) {
          return;
        }
        if (this.isDisposed()) {
          return callback(null, new node_opcua_data_value_1.DataValue({ statusCode: node_opcua_status_code_1.StatusCodes.BadNodeIdUnknown }));
        }
        const readImmediate = (innerCallback) => {
          (0, node_opcua_assert_1.assert)(this.$dataValue instanceof node_opcua_data_value_1.DataValue);
          const dataValue = this.readValue(context);
          innerCallback(null, dataValue);
        };
        let func;
        if (!this.isReadable(context)) {
          func = (innerCallback) => {
            const dataValue = new node_opcua_data_value_1.DataValue({ statusCode: node_opcua_status_code_1.StatusCodes.BadNotReadable });
            innerCallback(null, dataValue);
          };
        } else if (!this.checkPermissionPrivate(context, node_opcua_types_1.PermissionType.Read)) {
          func = (innerCallback) => {
            const dataValue = new node_opcua_data_value_1.DataValue({ statusCode: node_opcua_status_code_1.StatusCodes.BadUserAccessDenied });
            innerCallback(null, dataValue);
          };
        } else if (!this.isUserReadable(context)) {
          func = (innerCallback) => {
            const dataValue = new node_opcua_data_value_1.DataValue({ statusCode: node_opcua_status_code_1.StatusCodes.BadNotReadable });
            innerCallback(null, dataValue);
          };
        } else {
          const clock = (0, node_opcua_date_time_1.getCurrentClock)();
          func = typeof this.refreshFunc === "function" ? this.asyncRefresh.bind(this, clock) : readImmediate;
        }
        const satisfy_callbacks = (err, dataValue) => {
          const callbacks = this.__waiting_callbacks || [];
          this.__waiting_callbacks = [];
          const n = callbacks.length;
          for (const callback1 of callbacks) {
            callback1.call(this, err, dataValue);
          }
        };
        try {
          func.call(this, satisfy_callbacks);
        } catch (err) {
          if (doDebug) {
            debugLog(chalk_1.default.red("func readValueAsync has failed "));
            if (util_1.types.isNativeError(err)) {
              debugLog(" stack", err.stack);
            }
          }
          satisfy_callbacks(err);
        }
      }
      getWriteMask() {
        return super.getWriteMask();
      }
      getUserWriteMask() {
        return super.getUserWriteMask();
      }
      clone(options, optionalFilter, extraInfo) {
        options = {
          ...options,
          // check this eventNotifier: this.eventNotifier,
          // check this symbolicName: this.symbolicName,
          accessLevel: this.accessLevel,
          arrayDimensions: this.arrayDimensions,
          dataType: this.dataType,
          historizing: this.historizing,
          minimumSamplingInterval: this.minimumSamplingInterval,
          userAccessLevel: this.userAccessLevel,
          valueRank: this.valueRank
        };
        const newVariable = (0, base_node_private_1._clone)(this, _UAVariableImpl, options, optionalFilter || node_opcua_address_space_base_1.defaultCloneFilter, extraInfo || (0, node_opcua_address_space_base_1.makeDefaultCloneExtraInfo)(this));
        newVariable.bindVariable();
        (0, node_opcua_assert_1.assert)(typeof newVariable._timestamped_set_func === "function");
        (0, node_opcua_assert_1.assert)(newVariable.dataType === this.dataType);
        newVariable.$dataValue = this.$dataValue.clone();
        const v = newVariable.$dataValue.value;
        if (v.dataType === node_opcua_variant_1.DataType.ExtensionObject && v.value && v.arrayType === node_opcua_variant_1.VariantArrayType.Scalar) {
          try {
            newVariable.bindExtensionObject(newVariable.$dataValue.value.value);
          } catch (err) {
            errorLog("Error binding extension objects");
            errorLog(err.message);
            errorLog(this.toString());
            errorLog("---------------------------------------");
            errorLog(this.$dataValue.toString());
            errorLog("---------------------------------------");
            errorLog(newVariable.$dataValue.toString());
            throw err;
          }
        }
        return newVariable;
      }
      getDataTypeNode() {
        const addressSpace = this.addressSpace;
        const dt = addressSpace.findNode(this.dataType);
        if (!dt) {
          throw new Error("getDataTypeNode: cannot find dataType " + this.dataType.toString());
        }
        return dt;
      }
      get dataTypeObj() {
        return this.getDataTypeNode();
      }
      checkExtensionObjectIsCorrect(extObj) {
        if (!extObj) {
          return true;
        }
        const addressSpace = this.addressSpace;
        const dataType = addressSpace.findDataType(this.dataType);
        if (!dataType) {
          return true;
        }
        if (dataType.nodeId.namespace === 0 && dataType.nodeId.value === node_opcua_variant_1.DataType.ExtensionObject) {
          return true;
        }
        const Constructor = addressSpace.getExtensionObjectConstructor(this.dataType);
        if (this.valueRank === -1) {
          if (extObj instanceof Array) {
            return false;
          }
          return checkExtensionObjectIsCorrectScalar.call(this, extObj);
        } else if (this.valueRank >= 1) {
          if (!(extObj instanceof Array)) {
            if (checkExtensionObjectIsCorrectScalar.call(this, extObj)) {
              warningLog(`warning: checkExtensionObjectIsCorrect : expecting a array but got a scalar (value rank of '${this.browseName.toString()}' is 1)
automatic conversion from scalar to array with 1 element is taking place.`);
              extObj = [extObj];
            } else {
              return false;
            }
          }
          return checkExtensionObjectIsCorrectArray.call(this, extObj);
        } else if (this.valueRank === 0) {
          const isCorrectScalar = !Array.isArray(extObj) && checkExtensionObjectIsCorrectScalar.call(this, extObj);
          const isCorrectArray = Array.isArray(extObj) && checkExtensionObjectIsCorrectArray.call(this, extObj);
          return isCorrectArray || isCorrectScalar;
        } else {
          throw new Error(`checkExtensionObjectIsCorrect: Not Implemented case, please contact sterfive : this.valueRank =${this.valueRank}`);
        }
        function checkExtensionObjectIsCorrectScalar(extObj2) {
          if (!(extObj2 && extObj2.constructor)) {
            errorLog(extObj2);
            throw new Error("expecting an valid extension object");
          }
          return extObj2.constructor.name === Constructor.name;
        }
        function checkExtensionObjectIsCorrectArray(extObjArray) {
          for (const extObj2 of extObjArray) {
            if (!(extObj2 && extObj2.constructor)) {
              errorLog(extObj2);
              throw new Error("expecting an valid extension object");
            }
          }
          try {
            for (const e of extObjArray) {
              if (!e) {
                continue;
              }
              if (e.constructor.name !== Constructor.name) {
                debugLog("extObj.constructor.name ", e.constructor.name, "expected", Constructor.name);
                return false;
              }
            }
            return true;
          } catch (err) {
            errorLog(err);
            return false;
          }
        }
      }
      /**
       * @private
       * install UAVariable to exposed th
       *
       * precondition:
       */
      installExtensionObjectVariables() {
        (0, ua_variable_impl_ext_obj_1._installExtensionObjectBindingOnProperties)(this, { createMissingProp: true });
      }
      /**
       * @method bindExtensionObject
       * @return {ExtensionObject}
       */
      bindExtensionObjectScalar(optionalExtensionObject, options) {
        (0, node_opcua_assert_1.assert)(this.valueRank === -1, "expecting an Scalar variable here");
        return (0, ua_variable_impl_ext_obj_1._bindExtensionObject)(this, optionalExtensionObject, options);
      }
      bindExtensionObjectArray(optionalExtensionObject, options) {
        (0, node_opcua_assert_1.assert)(this.valueRank >= 1, "expecting an Array or a Matrix variable here");
        return (0, ua_variable_impl_ext_obj_1._bindExtensionObjectArrayOrMatrix)(this, optionalExtensionObject, options);
      }
      bindExtensionObject(optionalExtensionObject, options) {
        if (optionalExtensionObject && this.valueRank === 1 && !Array.isArray(optionalExtensionObject) && optionalExtensionObject instanceof node_opcua_extension_object_1.ExtensionObject) {
          warningLog("bindExtensionObject: coerce to ExtensionObject[] when valueRank === 1 and value is a scalar extension object");
          optionalExtensionObject = [optionalExtensionObject];
        }
        if (optionalExtensionObject) {
          if (optionalExtensionObject instanceof Array) {
            (0, node_opcua_assert_1.assert)(this.valueRank >= 1, "bindExtensionObject: expecting an Array of Matrix variable here");
            return (0, ua_variable_impl_ext_obj_1._bindExtensionObjectArrayOrMatrix)(this, optionalExtensionObject, options);
          } else {
            if (this.valueRank !== -1 && this.valueRank !== 0) {
              throw new Error("bindExtensionObject: expecting an Scalar variable here but got value rank " + this.valueRank);
            }
            return (0, ua_variable_impl_ext_obj_1._bindExtensionObject)(this, optionalExtensionObject, options);
          }
        }
        (0, node_opcua_assert_1.assert)(optionalExtensionObject === void 0 || optionalExtensionObject === null);
        if (this.valueRank === -1) {
          return (0, ua_variable_impl_ext_obj_1._bindExtensionObject)(this, void 0, options);
        } else if (this.valueRank === 1) {
          return (0, ua_variable_impl_ext_obj_1._bindExtensionObjectArrayOrMatrix)(this, void 0, options);
        } else if (this.valueRank > 1) {
          return (0, ua_variable_impl_ext_obj_1._bindExtensionObjectArrayOrMatrix)(this, void 0, options);
        }
        return null;
      }
      updateExtensionObjectPartial(partialExtensionObject) {
        (0, ua_variable_impl_ext_obj_1.setExtensionObjectPartialValue)(this, partialExtensionObject);
        return this.$extensionObject;
      }
      incrementExtensionObjectPartial(path3) {
        const extensionObject = this.readValue().value.value;
        const partialData = (0, ua_variable_impl_ext_obj_1.extractPartialData)(path3, extensionObject);
        (0, ua_variable_impl_ext_obj_1.incrementElement)(path3, partialData);
        (0, ua_variable_impl_ext_obj_1.setExtensionObjectPartialValue)(this, partialData);
      }
      toString() {
        const options = new base_node_private_1.ToStringBuilder();
        base_node_private_1.UAVariable_toString.call(this, options);
        return options.toString();
      }
      historyRead(context, historyReadDetails, indexRange, dataEncoding, continuationData, callback) {
        (0, node_opcua_assert_1.assert)(context instanceof session_context_1.SessionContext);
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        if (typeof this._historyRead !== "function") {
          return callback(null, new node_opcua_types_1.HistoryReadResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadNotReadable }));
        }
        this._historyRead(context, historyReadDetails, indexRange, dataEncoding, continuationData, callback);
      }
      _historyReadRaw(context, historyReadRawModifiedDetails, indexRange, dataEncoding, continuationData, callback) {
        throw new Error("");
      }
      _historyReadRawModify(context, historyReadRawModifiedDetails, indexRange, dataEncoding, continuationData, callback) {
        throw new Error("");
      }
      _historyRead(context, historyReadDetails, indexRange, dataEncoding, continuationData, callback) {
        if (!this.checkPermissionPrivate(context, node_opcua_types_1.PermissionType.ReadHistory)) {
          const result3 = new node_opcua_types_1.HistoryReadResult({
            statusCode: node_opcua_status_code_1.StatusCodes.BadUserAccessDenied
          });
          callback(null, result3);
        }
        if (!this.canUserReadHistory(context)) {
          const result3 = new node_opcua_types_1.HistoryReadResult({
            statusCode: node_opcua_status_code_1.StatusCodes.BadHistoryOperationUnsupported
          });
          callback(null, result3);
        }
        const result2 = new node_opcua_types_1.HistoryReadResult({
          statusCode: node_opcua_status_code_1.StatusCodes.BadHistoryOperationUnsupported
        });
        callback(null, result2);
      }
      _historyPush(newDataValue) {
        throw new Error("");
      }
      _historyReadRawAsync(historyReadRawModifiedDetails, maxNumberToExtract, isReversed, reverseDataValue, callback) {
        throw new Error("");
      }
      _historyReadModify(context, historyReadRawModifiedDetails, indexRange, dataEncoding, continuationData, callback) {
        throw new Error("");
      }
      _update_startOfOnlineArchive(newDate) {
        throw new Error("");
      }
      _update_startOfArchive(newDate) {
        throw new Error("");
      }
      _validate_DataType(variantDataType) {
        return (0, validate_data_type_correctness_1.validateDataTypeCorrectness)(
          this.addressSpace,
          this.dataType,
          variantDataType,
          /* allow Nulls */
          false,
          this.nodeId
        );
      }
      _internal_set_value(value) {
        if (value.dataType !== node_opcua_variant_1.DataType.Null) {
          this.verifyVariantCompatibility(value);
        }
        this.$dataValue.value = value;
      }
      _internal_set_dataValue(dataValue, indexRange) {
        (0, node_opcua_assert_1.assert)(dataValue, "expecting a dataValue");
        (0, node_opcua_assert_1.assert)(dataValue instanceof node_opcua_data_value_1.DataValue, "expecting dataValue to be a DataValue");
        (0, node_opcua_assert_1.assert)(dataValue !== this.$dataValue, "expecting dataValue to be different from previous DataValue instance");
        const addressSpace = this.addressSpace;
        if (!addressSpace) {
          warningLog("UAVariable#_internal_set_dataValue : no addressSpace ! may be node has already been deleted ?");
          return;
        }
        if (dataValue.value.arrayType === node_opcua_variant_1.VariantArrayType.Matrix) {
          if (!dataValue.value.dimensions) {
            throw new Error("missing dimensions: a Matrix Variant needs a dimension");
          }
          const nbElements = dataValue.value.dimensions.reduce((acc, x2) => acc * x2, 1);
          if (dataValue.value.value.length !== 0 && dataValue.value.value.length !== nbElements) {
            throw new Error(`Internal Error: matrix dimension doesn't match the number of element in the array : ${dataValue.toString()} "
 expecting ${nbElements} elements but got ${dataValue.value.value.length}`);
          }
        }
        if (dataValue.value.dataType === node_opcua_variant_1.DataType.ExtensionObject) {
          if (!this.checkExtensionObjectIsCorrect(dataValue.value.value)) {
            warningLog(dataValue.toString());
            throw new Error("Invalid Extension Object on nodeId =" + this.nodeId.toString());
          }
        }
        this.verifyVariantCompatibility(dataValue.value);
        this._inner_replace_dataValue(dataValue, indexRange);
      }
      /**
       * @private
       */
      _inner_replace_dataValue(dataValue, indexRange) {
        (0, node_opcua_assert_1.assert)(this.$dataValue.value instanceof node_opcua_variant_1.Variant);
        const old_dataValue = this.$dataValue.clone();
        if (this.$$extensionObjectArray && dataValue.value.arrayType !== node_opcua_variant_1.VariantArrayType.Scalar) {
          (0, node_opcua_assert_1.assert)(Array.isArray(dataValue.value.value));
          if (this.$$extensionObjectArray !== this.$dataValue.value.value) {
            throw new Error("internal error");
          }
          this.$$extensionObjectArray = dataValue.value.value;
          this.$dataValue.value.value = dataValue.value.value;
          this.$dataValue.statusCode = dataValue.statusCode || node_opcua_status_code_1.StatusCodes.Good;
          this.$dataValue.serverTimestamp = dataValue.serverTimestamp;
          this.$dataValue.serverPicoseconds = dataValue.serverPicoseconds;
          this.$dataValue.sourceTimestamp = dataValue.sourceTimestamp;
          this.$dataValue.sourcePicoseconds = dataValue.sourcePicoseconds;
        } else if (this._basicDataType === node_opcua_variant_1.DataType.ExtensionObject && this.valueRank === -1 && this.$set_ExtensionObject && dataValue.value.arrayType === node_opcua_variant_1.VariantArrayType.Scalar) {
          this.$dataValue.statusCode = this.$dataValue.statusCode || node_opcua_status_code_1.StatusCodes.Good;
          const preciseClock = (0, node_opcua_date_time_1.coerceClock)(this.$dataValue.sourceTimestamp, this.$dataValue.sourcePicoseconds);
          this.$set_ExtensionObject(dataValue.value.value, preciseClock, /* @__PURE__ */ new Set());
        } else {
          this.$dataValue = dataValue;
          this.$dataValue.statusCode = this.$dataValue.statusCode || node_opcua_status_code_1.StatusCodes.Good;
        }
        const now = /* @__PURE__ */ new Date();
        if (!dataValue.serverTimestamp) {
          this.$dataValue.serverTimestamp = old_dataValue.serverTimestamp || now;
          this.$dataValue.serverPicoseconds = old_dataValue.serverPicoseconds || 0;
        }
        if (!dataValue.sourceTimestamp) {
          this.$dataValue.sourceTimestamp = old_dataValue.sourceTimestamp || now;
          this.$dataValue.sourcePicoseconds = old_dataValue.sourcePicoseconds || 0;
        }
        if (!(0, node_opcua_data_value_1.sameDataValue)(old_dataValue, dataValue)) {
          if (this.getBasicDataType() === node_opcua_variant_1.DataType.ExtensionObject) {
            const preciseClock = (0, node_opcua_date_time_1.coerceClock)(this.$dataValue.sourceTimestamp, this.$dataValue.sourcePicoseconds);
            const cache = /* @__PURE__ */ new Set();
            if (this.$$extensionObjectArray) {
              this.touchValue(preciseClock);
              (0, ua_variable_impl_ext_obj_1.propagateTouchValueDownwardArray)(this, preciseClock, cache);
            } else {
              this.touchValue(preciseClock);
              (0, ua_variable_impl_ext_obj_1.propagateTouchValueDownward)(this, preciseClock, cache);
            }
          } else {
            this.emit("value_changed", this.$dataValue.clone(), indexRange);
          }
        }
      }
      _conditionRefresh(_cache) {
        apply_condition_refresh_1.apply_condition_refresh.call(this, _cache);
      }
      handle_semantic_changed() {
        this.semantic_version = this.semantic_version + 1;
        this.emit("semantic_changed");
      }
      _readDataType() {
        (0, node_opcua_assert_1.assert)(this.dataType instanceof node_opcua_nodeid_1.NodeId);
        const options = {
          statusCode: node_opcua_status_code_1.StatusCodes.Good,
          value: {
            dataType: node_opcua_variant_1.DataType.NodeId,
            value: this.dataType
          }
        };
        return new node_opcua_data_value_1.DataValue(options);
      }
      _readValueRank() {
        (0, node_opcua_assert_1.assert)(typeof this.valueRank === "number");
        const options = {
          statusCode: node_opcua_status_code_1.StatusCodes.Good,
          value: { dataType: node_opcua_variant_1.DataType.Int32, value: this.valueRank }
        };
        return new node_opcua_data_value_1.DataValue(options);
      }
      _readArrayDimensions() {
        (0, node_opcua_assert_1.assert)(Array.isArray(this.arrayDimensions) || this.arrayDimensions === null);
        (0, node_opcua_assert_1.assert)(!this.arrayDimensions || this.valueRank > 0, "arrayDimension must be null if valueRank <0");
        const options = {
          statusCode: node_opcua_status_code_1.StatusCodes.Good,
          value: { dataType: node_opcua_variant_1.DataType.UInt32, arrayType: node_opcua_variant_1.VariantArrayType.Array, value: this.arrayDimensions }
        };
        return new node_opcua_data_value_1.DataValue(options);
      }
      _readAccessLevel(context) {
        (0, node_opcua_assert_1.assert)(context instanceof session_context_1.SessionContext);
        const options = {
          statusCode: node_opcua_status_code_1.StatusCodes.Good,
          value: { dataType: node_opcua_variant_1.DataType.Byte, value: (0, node_opcua_data_model_1.convertAccessLevelFlagToByte)(this.accessLevel) }
        };
        return new node_opcua_data_value_1.DataValue(options);
      }
      _readAccessLevelEx(context) {
        (0, node_opcua_assert_1.assert)(context instanceof session_context_1.SessionContext);
        const options = {
          statusCode: node_opcua_status_code_1.StatusCodes.Good,
          // Extra flags are not supported yet. to do:
          value: { dataType: node_opcua_variant_1.DataType.UInt32, value: (0, node_opcua_data_model_1.convertAccessLevelFlagToByte)(this.accessLevel) }
        };
        return new node_opcua_data_value_1.DataValue(options);
      }
      _readUserAccessLevel(context) {
        (0, node_opcua_assert_1.assert)(context instanceof session_context_1.SessionContext);
        const effectiveUserAccessLevel = _calculateEffectiveUserAccessLevelFromPermission(this, context, this.userAccessLevel);
        const options = {
          value: {
            dataType: node_opcua_variant_1.DataType.Byte,
            statusCode: node_opcua_status_code_1.StatusCodes.Good,
            value: (0, node_opcua_data_model_1.convertAccessLevelFlagToByte)(effectiveUserAccessLevel)
          }
        };
        return new node_opcua_data_value_1.DataValue(options);
      }
      _readMinimumSamplingInterval() {
        const options = {};
        if (this.minimumSamplingInterval === void 0) {
          options.statusCode = node_opcua_status_code_1.StatusCodes.BadAttributeIdInvalid;
        } else {
          options.value = { dataType: node_opcua_variant_1.DataType.Double, value: this.minimumSamplingInterval };
          options.statusCode = node_opcua_status_code_1.StatusCodes.Good;
        }
        return new node_opcua_data_value_1.DataValue(options);
      }
      _readHistorizing() {
        (0, node_opcua_assert_1.assert)(typeof this.historizing === "boolean");
        const options = {
          statusCode: node_opcua_status_code_1.StatusCodes.Good,
          value: { dataType: node_opcua_variant_1.DataType.Boolean, value: !!this.historizing }
        };
        return new node_opcua_data_value_1.DataValue(options);
      }
    };
    exports2.UAVariableImpl = UAVariableImpl;
    var thenify = require_thenify();
    UAVariableImpl.prototype.asyncRefresh = thenify.withCallback(UAVariableImpl.prototype.asyncRefresh);
    UAVariableImpl.prototype.writeValue = thenify.withCallback(UAVariableImpl.prototype.writeValue);
    UAVariableImpl.prototype.writeAttribute = thenify.withCallback(UAVariableImpl.prototype.writeAttribute);
    UAVariableImpl.prototype.historyRead = thenify.withCallback(UAVariableImpl.prototype.historyRead);
    UAVariableImpl.prototype.readValueAsync = thenify.withCallback(UAVariableImpl.prototype.readValueAsync);
    function check_valid_array(dataType, array) {
      if (Array.isArray(array)) {
        return true;
      }
      switch (dataType) {
        case node_opcua_variant_1.DataType.Double:
          return array instanceof Float64Array;
        case node_opcua_variant_1.DataType.Float:
          return array instanceof Float32Array;
        case node_opcua_variant_1.DataType.Int32:
          return array instanceof Int32Array;
        case node_opcua_variant_1.DataType.Int16:
          return array instanceof Int16Array;
        case node_opcua_variant_1.DataType.SByte:
          return array instanceof Int8Array;
        case node_opcua_variant_1.DataType.UInt32:
          return array instanceof Uint32Array;
        case node_opcua_variant_1.DataType.UInt16:
          return array instanceof Uint16Array;
        case node_opcua_variant_1.DataType.Byte:
          return array instanceof Uint8Array || array instanceof Buffer;
      }
      return false;
    }
    function unsetFlag(flags, mask) {
      return flags & ~mask;
    }
    function _calculateEffectiveUserAccessLevelFromPermission(node, context, userAccessLevel) {
      function __adjustFlag(permissionType, access, userAccessLevel1) {
        if ((node.accessLevel & access) === 0 || (userAccessLevel1 & access) === 0) {
          userAccessLevel1 = unsetFlag(userAccessLevel1, access);
        } else {
          if (!context.checkPermission(node, permissionType)) {
            userAccessLevel1 = unsetFlag(userAccessLevel1, access);
          }
        }
        return userAccessLevel1;
      }
      userAccessLevel = node.userAccessLevel === void 0 ? node.accessLevel : node.userAccessLevel & node.accessLevel;
      if (context.checkPermission) {
        (0, node_opcua_assert_1.assert)(context.checkPermission instanceof Function);
        userAccessLevel = __adjustFlag(node_opcua_types_1.PermissionType.Read, node_opcua_data_model_1.AccessLevelFlag.CurrentRead, userAccessLevel);
        userAccessLevel = __adjustFlag(node_opcua_types_1.PermissionType.Write, node_opcua_data_model_1.AccessLevelFlag.CurrentWrite, userAccessLevel);
        userAccessLevel = __adjustFlag(node_opcua_types_1.PermissionType.Write, node_opcua_data_model_1.AccessLevelFlag.StatusWrite, userAccessLevel);
        userAccessLevel = __adjustFlag(node_opcua_types_1.PermissionType.Write, node_opcua_data_model_1.AccessLevelFlag.TimestampWrite, userAccessLevel);
        userAccessLevel = __adjustFlag(node_opcua_types_1.PermissionType.ReadHistory, node_opcua_data_model_1.AccessLevelFlag.HistoryRead, userAccessLevel);
        userAccessLevel = __adjustFlag(node_opcua_types_1.PermissionType.DeleteHistory, node_opcua_data_model_1.AccessLevelFlag.HistoryWrite, userAccessLevel);
        return userAccessLevel;
      } else {
        return userAccessLevel;
      }
    }
    function adjustVariant2(variant) {
      const addressSpace = this.addressSpace;
      const basicType = this.getBasicDataType();
      variant = (0, node_opcua_variant_1.adjustVariant)(variant, this.valueRank, basicType);
      return variant;
    }
    function _not_writable_timestamped_set_func(dataValue, callback) {
      (0, node_opcua_assert_1.assert)(dataValue instanceof node_opcua_data_value_1.DataValue);
      callback(null, node_opcua_status_code_1.StatusCodes.BadNotWritable, null);
    }
    function _default_writable_timestamped_set_func(dataValue, callback) {
      (0, node_opcua_assert_1.assert)(dataValue instanceof node_opcua_data_value_1.DataValue);
      callback(null, node_opcua_status_code_1.StatusCodes.Good, dataValue);
    }
    function turn_sync_to_async(f2, numberOfArgs) {
      if (f2.length <= numberOfArgs) {
        return function(data, callback) {
          new Promise((resolve2, reject) => {
            try {
              const ff2 = f2;
              const r = ff2.call(this, data);
              if (r instanceof Promise) {
                r.then(resolve2, reject);
              } else {
                resolve2(r);
              }
            } catch (err) {
              reject(err);
            }
          }).then((r) => {
            callback(null, r);
          }).catch((err) => {
            callback(err);
          });
        };
      } else {
        (0, node_opcua_assert_1.assert)(f2.length === numberOfArgs + 1);
        return f2;
      }
    }
    function coerceDataValue(dataValue) {
      if (dataValue instanceof node_opcua_data_value_1.DataValue) {
        return dataValue;
      }
      return new node_opcua_data_value_1.DataValue(dataValue);
    }
    function _Variable_bind_with_async_refresh(options) {
      (0, node_opcua_assert_1.assert)(this instanceof UAVariableImpl);
      (0, node_opcua_assert_1.assert)(typeof options.refreshFunc === "function");
      (0, node_opcua_assert_1.assert)(!options.get, "a getter shall not be specified when refreshFunc is set");
      (0, node_opcua_assert_1.assert)(!options.timestamped_get, "a getter shall not be specified when refreshFunc is set");
      (0, node_opcua_assert_1.assert)(!this.refreshFunc);
      this.refreshFunc = options.refreshFunc;
      if (false) {
        this.minimumSamplingInterval = _default_minimumSamplingInterval;
        debugLog("adapting minimumSamplingInterval on " + this.browseName.toString() + " to " + this.minimumSamplingInterval);
      }
    }
    function _Variable_bind_with_timestamped_get(options) {
      (0, node_opcua_assert_1.assert)(this instanceof UAVariableImpl);
      (0, node_opcua_assert_1.assert)(typeof options.timestamped_get === "function");
      (0, node_opcua_assert_1.assert)(!options.get, "should not specify 'get' when 'timestamped_get' exists ");
      (0, node_opcua_assert_1.assert)(!this._timestamped_get_func);
      const async_refresh_func = (callback) => {
        Promise.resolve(this._timestamped_get_func.call(this)).then((dataValue) => callback(null, dataValue)).catch((err) => {
          errorLog("asyncRefresh error: Variable is  ", this.nodeId.toString(), this.browseName.toString());
          callback(err);
        });
      };
      const pThis = this;
      if (options.timestamped_get.length === 0) {
        const timestamped_get = options.timestamped_get;
        this._timestamped_get_func = timestamped_get;
        const dataValue_verify = timestamped_get.call(pThis);
        if (!(dataValue_verify instanceof node_opcua_data_value_1.DataValue) && typeof dataValue_verify.then !== "function") {
          errorLog(chalk_1.default.red(" Bind variable error: "), " the timestamped_get function must return a DataValue or a Promise<DataValue>\n value_check.constructor.name ", dataValue_verify ? dataValue_verify.constructor.name : "null");
          throw new Error(" Bind variable error:  the timestamped_get function must return a DataValue");
        }
        _Variable_bind_with_async_refresh.call(this, { refreshFunc: async_refresh_func });
      } else if (options.timestamped_get.length === 1) {
        _Variable_bind_with_async_refresh.call(this, { refreshFunc: options.timestamped_get });
      } else {
        errorLog("timestamped_get has a invalid number of argument , should be 0 or 1  ");
        throw new Error("timestamped_get has a invalid number of argument , should be 0 or 1  ");
      }
    }
    function _Variable_bind_with_simple_get(options) {
      (0, node_opcua_assert_1.assert)(this instanceof UAVariableImpl);
      (0, node_opcua_assert_1.assert)(typeof options.get === "function", "should specify get function");
      (0, node_opcua_assert_1.assert)(options.get.length === 0, "get function should not have arguments");
      (0, node_opcua_assert_1.assert)(!options.timestamped_get, "should not specify a timestamped_get function when get is specified");
      (0, node_opcua_assert_1.assert)(!this._timestamped_get_func);
      (0, node_opcua_assert_1.assert)(!this._get_func);
      this._get_func = options.get;
      const timestamped_get_func_from__Variable_bind_with_simple_get = () => {
        const value = this._get_func();
        if (!is_Variant_or_StatusCode(value)) {
          errorLog(chalk_1.default.red(" Bind variable error: "), " : the getter must return a Variant or a StatusCode\nvalue_check.constructor.name ", value ? value.constructor.name : "null");
          throw new Error(" bindVariable : the value getter function returns a invalid result ( expecting a Variant or a StatusCode !!!");
        }
        if (is_StatusCode(value)) {
          return new node_opcua_data_value_1.DataValue({ statusCode: value });
        } else {
          if (!this.$dataValue || !this.$dataValue.statusCode.isGoodish() || !(0, node_opcua_variant_1.sameVariant)(this.$dataValue.value, value)) {
            const { timestamp: sourceTimestamp, picoseconds: sourcePicoseconds } = (0, node_opcua_date_time_1.getCurrentClock)();
            const serverTimestamp = sourceTimestamp;
            const serverPicoseconds = sourcePicoseconds;
            this._inner_replace_dataValue(new node_opcua_data_value_1.DataValue({ value, sourceTimestamp, sourcePicoseconds, serverTimestamp, serverPicoseconds }));
          }
          return this.$dataValue;
        }
      };
      _Variable_bind_with_timestamped_get.call(this, {
        get: void 0,
        timestamped_get: timestamped_get_func_from__Variable_bind_with_simple_get
      });
    }
    function _Variable_bind_with_simple_set(options) {
      (0, node_opcua_assert_1.assert)(this instanceof UAVariableImpl);
      (0, node_opcua_assert_1.assert)(typeof options.set === "function", "should specify set function");
      (0, node_opcua_assert_1.assert)(!options.timestamped_set, "should not specify a timestamped_set function");
      (0, node_opcua_assert_1.assert)(!this._timestamped_set_func);
      (0, node_opcua_assert_1.assert)(!this._set_func);
      this._set_func = turn_sync_to_async(options.set, 1);
      (0, node_opcua_assert_1.assert)(this._set_func.length === 2, " set function must have 2 arguments ( variant, callback)");
      this._timestamped_set_func = (timestamped_value, callback) => {
        (0, node_opcua_assert_1.assert)(timestamped_value instanceof node_opcua_data_value_1.DataValue);
        this._set_func(timestamped_value.value, (err, statusCode) => {
          if (!err && !statusCode) {
            errorLog(chalk_1.default.red("UAVariable Binding Error _set_func must return a StatusCode, check the bindVariable parameters"));
            errorLog(chalk_1.default.yellow("StatusCode.Good is assumed"));
            return callback(err, node_opcua_status_code_1.StatusCodes.Good, timestamped_value);
          }
          if (statusCode && statusCode.isNotGood()) {
            timestamped_value.statusCode = statusCode;
          }
          callback(err, statusCode, timestamped_value);
        });
      };
    }
    function _Variable_bind_with_timestamped_set(options) {
      (0, node_opcua_assert_1.assert)(options.timestamped_set.length === 2 || options.timestamped_set.length === 1, "timestamped_set must have 2 parameters  timestamped_set: function(dataValue,callback){} or one paramater  timestamped_set: function(dataValue): Promise<StatusCode>{}");
      (0, node_opcua_assert_1.assert)(!options.set, "should not specify set when timestamped_set_func exists ");
      this._timestamped_set_func = (0, multiform_func_1.convertToCallbackFunction1)(options.timestamped_set);
    }
    function bind_setter(options) {
      if (options.set && typeof options.set === "function") {
        if (options.timestamped_set === void 0) {
          _Variable_bind_with_simple_set.call(this, options);
        } else {
          throw new Error("bind_setter : options should not specify both set and timestamped_set ");
        }
      } else if (typeof options.timestamped_set === "function") {
        (0, node_opcua_assert_1.assert)(typeof options.timestamped_get === "function", "timestamped_set must be used with timestamped_get ");
        _Variable_bind_with_timestamped_set.call(this, {
          set: void 0,
          timestamped_set: options.timestamped_set
        });
      } else if (typeof options.timestamped_get === "function") {
        _Variable_bind_with_timestamped_set.call(this, {
          set: void 0,
          timestamped_set: _not_writable_timestamped_set_func
        });
      } else {
        _Variable_bind_with_timestamped_set.call(this, {
          set: void 0,
          timestamped_set: _default_writable_timestamped_set_func
        });
      }
    }
    function bind_getter(options) {
      if (typeof options.get === "function") {
        _Variable_bind_with_simple_get.call(this, options);
      } else if (typeof options.timestamped_get === "function") {
        _Variable_bind_with_timestamped_get.call(this, {
          get: void 0,
          timestamped_get: options.timestamped_get
        });
      } else if (typeof options.refreshFunc === "function") {
        if (options.get !== void 0 || options.timestamped_get !== void 0) {
          throw new Error("bind_getter : options should not specify both get and timestamped_get ");
        }
        _Variable_bind_with_async_refresh.call(this, { refreshFunc: options.refreshFunc });
      } else {
        (0, node_opcua_assert_1.assert)(!Object.prototype.hasOwnProperty.call(options, "set"), "getter is missing : a getter must be provided if a setter is provided");
        if (options.dataType !== void 0) {
          this.setValueFromSource(options);
        }
      }
    }
    var UAVariableImplT = class extends UAVariableImpl {
    };
    exports2.UAVariableImplT = UAVariableImplT;
  }
});

// node_modules/node-opcua-address-space/dist/src/state_machine/ua_two_state_variable.js
var require_ua_two_state_variable = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/state_machine/ua_two_state_variable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2._addTwoStateVariable = exports2.UATwoStateVariableImpl = exports2.promoteToTwoStateVariable = exports2._install_TwoStateVariable_machinery = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_nodeid_2 = require_dist21();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_variant_2 = require_dist28();
    var register_node_promoter_1 = require_register_node_promoter();
    var ua_variable_impl_1 = require_ua_variable_impl();
    var hasTrueSubState_ReferenceTypeNodeId = (0, node_opcua_nodeid_1.resolveNodeId)("HasTrueSubState");
    var hasFalseSubState_ReferenceTypeNodeId = (0, node_opcua_nodeid_1.resolveNodeId)("HasFalseSubState");
    function _updateTransitionTime(node, _subState, options) {
      if (node.transitionTime) {
        const transitionTime = options?.transitionTime || /* @__PURE__ */ new Date();
        node.transitionTime.setValueFromSource({ dataType: node_opcua_variant_2.DataType.DateTime, value: transitionTime });
      }
    }
    function _updateEffectiveTransitionTime(node, options) {
      if (node.effectiveTransitionTime) {
        const effectiveTransitionTime = options?.effectiveTransitionTime || /* @__PURE__ */ new Date();
        node.effectiveTransitionTime.setValueFromSource({
          dataType: node_opcua_variant_2.DataType.DateTime,
          value: effectiveTransitionTime
        });
      }
    }
    function _getEffectiveDisplayName(node) {
      const humanReadableString = _getHumanReadableString(node);
      if (humanReadableString.statusCode.isNotGood()) {
        return humanReadableString;
      }
      const boolValue = node.getValue();
      let subStateNodes;
      if (boolValue) {
        subStateNodes = node.findReferencesExAsObject("HasTrueSubState", node_opcua_data_model_1.BrowseDirection.Forward);
      } else {
        subStateNodes = node.findReferencesExAsObject("HasFalseSubState", node_opcua_data_model_1.BrowseDirection.Forward);
      }
      const states = subStateNodes.forEach((n) => {
      });
      return humanReadableString;
    }
    function _getHumanReadableString(node) {
      const dataValue = node.id.readValue();
      if (dataValue.statusCode.isNotGood()) {
        const _c = dataValue.clone();
        _c.value = new node_opcua_variant_1.Variant({
          dataType: node_opcua_variant_2.DataType.LocalizedText,
          value: (0, node_opcua_data_model_1.coerceLocalizedText)("")
        });
        return _c;
      }
      (0, node_opcua_assert_1.assert)(dataValue.value.dataType === node_opcua_variant_2.DataType.Boolean);
      const boolValue = dataValue.value.value;
      const dataValue2 = dataValue.clone();
      dataValue2.value = new node_opcua_variant_1.Variant({
        dataType: node_opcua_variant_2.DataType.LocalizedText,
        value: boolValue ? node.getTrueState() : node.getFalseState()
      });
      return dataValue2;
    }
    function _install_TwoStateVariable_machinery(node, options) {
      (0, node_opcua_assert_1.assert)(node.dataTypeObj.browseName.toString() === "LocalizedText");
      (0, node_opcua_assert_1.assert)(node.minimumSamplingInterval === 0);
      (0, node_opcua_assert_1.assert)(node.typeDefinitionObj.browseName.toString() === "TwoStateVariableType");
      (0, node_opcua_assert_1.assert)(node.dataTypeObj.browseName.toString() === "LocalizedText");
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(node, "valueRank") && (node.valueRank === -1 || node.valueRank === 0));
      const _node = promoteToTwoStateVariable(node);
      node.initialize(options);
      return _node;
    }
    exports2._install_TwoStateVariable_machinery = _install_TwoStateVariable_machinery;
    function promoteToTwoStateVariable(node) {
      if (node instanceof UATwoStateVariableImpl) {
        return node;
      }
      if (!(node instanceof ua_variable_impl_1.UAVariableImpl)) {
        throw new Error("Trying to promote a invalid object");
      }
      Object.setPrototypeOf(node, UATwoStateVariableImpl.prototype);
      return node;
    }
    exports2.promoteToTwoStateVariable = promoteToTwoStateVariable;
    (0, register_node_promoter_1.registerNodePromoter)(node_opcua_constants_1.VariableTypeIds.TwoStateVariableType, promoteToTwoStateVariable);
    var UATwoStateVariableImpl = class extends ua_variable_impl_1.UAVariableImplT {
      constructor(opts) {
        super(opts);
      }
      get isFalseSubStateOf() {
        return super.isFalseSubStateOf;
      }
      get isTrueSubStateOf() {
        return super.isTrueSubStateOf;
      }
      initialize(options) {
        if (options.trueState) {
          (0, node_opcua_assert_1.assert)(!!options.falseState);
          (0, node_opcua_assert_1.assert)(typeof options.trueState === "string");
          (0, node_opcua_assert_1.assert)(typeof options.falseState === "string");
          if (this.falseState) {
            this.falseState.setValueFromSource({
              dataType: node_opcua_variant_2.DataType.LocalizedText,
              value: (0, node_opcua_data_model_1.coerceLocalizedText)(options.falseState)
            });
          } else {
            this._trueState = (0, node_opcua_data_model_1.coerceLocalizedText)(options.trueState).text;
          }
          if (this.trueState) {
            this.trueState.setValueFromSource({
              dataType: node_opcua_variant_2.DataType.LocalizedText,
              value: (0, node_opcua_data_model_1.coerceLocalizedText)(options.trueState)
            });
          } else {
            this._falseState = (0, node_opcua_data_model_1.coerceLocalizedText)(options.falseState).text;
          }
        }
        if (options.isTrueSubStateOf) {
          this.addReference({
            isForward: false,
            nodeId: options.isTrueSubStateOf,
            referenceType: "HasTrueSubState"
          });
        }
        if (options.isFalseSubStateOf) {
          this.addReference({
            isForward: false,
            nodeId: options.isFalseSubStateOf,
            referenceType: "HasFalseSubState"
          });
        }
        if (options.value === void 0) {
          this.id.setValueFromSource({
            dataType: "Boolean",
            value: false
          }, node_opcua_status_code_1.StatusCodes.UncertainInitialValue);
        } else if (typeof options.value === "boolean") {
          this.id.setValueFromSource({
            dataType: "Boolean",
            value: options.value
          }, node_opcua_status_code_1.StatusCodes.Good);
        } else if (Object.prototype.hasOwnProperty.call(options.value, "dataType")) {
          (0, node_opcua_assert_1.assert)(options.value.dataType === node_opcua_variant_2.DataType.Boolean);
          this.id.setValueFromSource(options.value, node_opcua_status_code_1.StatusCodes.Good);
        } else {
          this.id.bindVariable(options.value);
        }
        this._postInitialize();
      }
      _postInitialize() {
        if (this.effectiveTransitionTime) {
          const subStates = this.getTrueSubStates().concat(this.getFalseSubStates());
          for (const subState of subStates) {
            subState.on("value_changed", () => _updateEffectiveTransitionTime(this));
          }
        }
        this.id.on("value_changed", () => {
          this._internal_set_dataValue(_getHumanReadableString(this));
        });
        this._internal_set_dataValue(_getHumanReadableString(this));
        if (this.effectiveDisplayName) {
          this.id.on("value_changed", () => {
            this.effectiveDisplayName._internal_set_dataValue(_getEffectiveDisplayName(this));
          });
          this.effectiveDisplayName._internal_set_dataValue(_getEffectiveDisplayName(this));
        }
      }
      /**
       * @method setValue
       * @param boolValue {Boolean}
       */
      setValue(boolValue, options) {
        (0, node_opcua_assert_1.assert)(typeof boolValue === "boolean");
        const dataValue = this.id.readValue();
        const oldValue = dataValue.value.value;
        if (dataValue.statusCode.isGood() && boolValue === oldValue) {
          return;
        }
        this.id.setValueFromSource(new node_opcua_variant_1.Variant({ dataType: node_opcua_variant_2.DataType.Boolean, value: boolValue }));
        _updateTransitionTime(this, void 0, options);
        _updateEffectiveTransitionTime(this, options);
      }
      /**
       * @method getValue
       * @return {Boolean}
       */
      getValue() {
        const dataValue = this.id.readValue();
        (0, node_opcua_assert_1.assert)(dataValue.statusCode.isGood());
        (0, node_opcua_assert_1.assert)(dataValue.value.dataType === node_opcua_variant_2.DataType.Boolean);
        return dataValue.value.value;
      }
      /**
       * @method getValueAsString
       * @return {string}
       */
      getValueAsString() {
        const dataValue = this.readValue();
        (0, node_opcua_assert_1.assert)(dataValue.statusCode.isGood());
        (0, node_opcua_assert_1.assert)(dataValue.value.dataType === node_opcua_variant_2.DataType.LocalizedText);
        return dataValue.value.value.text?.toString() || "";
      }
      getTrueState() {
        return this.trueState ? this.trueState.readValue().value.value : (0, node_opcua_data_model_1.coerceLocalizedText)(this._trueState || "TRUE");
      }
      getFalseState() {
        return this.falseState ? this.falseState.readValue().value.value : (0, node_opcua_data_model_1.coerceLocalizedText)(this._falseState || "FALSE");
      }
      // TODO : shall we care about overloading the remove_backward_reference method ?
      // some TrueSubState and FalseSubState relationship may be added later
      // so we need a mechanism to keep adding the "value_changed" event handle on subStates that
      // will be defined later.
      // install change detection on sub State
      // this is useful to change the effective transitionTime
      // EffectiveTransitionTime specifies the time when the current state or one of its sub states was entered.
      // If, for example, a LevelAlarm is active and – while active – switches several times between High and
      // HighHigh, then the TransitionTime stays at the point in time where the Alarm became active whereas the
      // EffectiveTransitionTime changes with each shift of a sub state.
      _add_backward_reference(reference) {
        super._add_backward_reference(reference);
        if (reference.isForward && ((0, node_opcua_nodeid_2.sameNodeId)(reference.referenceType, hasTrueSubState_ReferenceTypeNodeId) || (0, node_opcua_nodeid_2.sameNodeId)(reference.referenceType, hasFalseSubState_ReferenceTypeNodeId))) {
          const addressSpace = this.addressSpace;
          const subState = addressSpace.findNode(reference.nodeId);
          subState.on("value_changed", _updateEffectiveTransitionTime.bind(null, this, void 0));
        }
      }
    };
    exports2.UATwoStateVariableImpl = UATwoStateVariableImpl;
    function _addTwoStateVariable(namespace, options) {
      const addressSpace = namespace.addressSpace;
      const twoStateVariableType = addressSpace.findVariableType("TwoStateVariableType");
      if (!twoStateVariableType) {
        throw new Error("cannot find TwoStateVariableType");
      }
      options.optionals = options.optionals || [];
      if (options.trueState) {
        options.optionals.push("TrueState");
      }
      if (options.falseState) {
        options.optionals.push("FalseState");
      }
      options.minimumSamplingInterval = 0;
      const node = twoStateVariableType.instantiate({
        browseName: options.browseName,
        nodeId: options.nodeId,
        description: options.description,
        componentOf: options.componentOf,
        organizedBy: options.organizedBy,
        modellingRule: options.modellingRule,
        dataType: (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_variant_2.DataType.LocalizedText),
        minimumSamplingInterval: options.minimumSamplingInterval,
        optionals: options.optionals
      });
      const _node = _install_TwoStateVariable_machinery(node, options);
      return _node;
    }
    exports2._addTwoStateVariable = _addTwoStateVariable;
  }
});

// node_modules/set-prototype-of/index.js
var require_set_prototype_of = __commonJS({
  "node_modules/set-prototype-of/index.js"(exports2, module2) {
    Object.setPrototypeOf = Object.setPrototypeOf || setPrototypeOf;
    function setPrototypeOf(obj, proto) {
      obj.__proto__ = proto;
      return obj;
    }
    module2.exports = setPrototypeOf.bind(Object);
  }
});

// node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/condition.js
var require_condition = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/condition.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2._setAckedState = void 0;
    require_set_prototype_of();
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_status_code_1 = require_dist22();
    var condition_snapshot_impl_1 = require_condition_snapshot_impl();
    function _setAckedState(self2, requestedAckedState, conditionEventId, comment, options) {
      (0, node_opcua_assert_1.assert)(self2 instanceof condition_snapshot_impl_1.ConditionSnapshotImpl);
      const ackedState = self2.getAckedState();
      if (ackedState && requestedAckedState) {
        return node_opcua_status_code_1.StatusCodes.BadConditionBranchAlreadyAcked;
      }
      self2._set_twoStateVariable("AckedState", requestedAckedState, options);
      return node_opcua_status_code_1.StatusCodes.Good;
    }
    exports2._setAckedState = _setAckedState;
  }
});

// node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/condition_snapshot_impl.js
var require_condition_snapshot_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/condition_snapshot_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ConditionSnapshotImpl = void 0;
    var events_1 = require("events");
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_variant_1 = require_dist28();
    var event_data_1 = require_event_data();
    var ua_two_state_variable_1 = require_ua_two_state_variable();
    var condition_1 = require_condition();
    var ua_condition_impl_1 = require_ua_condition_impl();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    function normalizeName(str) {
      return str;
    }
    function _visit(self2, node, prefix) {
      const aggregates = node.getAggregates();
      for (const aggregate of aggregates) {
        if (aggregate.nodeClass === node_opcua_data_model_1.NodeClass.Variable) {
          const name = aggregate.browseName.toString();
          const key = prefix + name;
          if (doDebug) {
            debugLog("adding key =", key);
          }
          const aggregateVariable = aggregate;
          self2._map[key] = aggregateVariable.readValue().value;
          self2._node_index[key] = aggregateVariable;
          _visit(self2, aggregate, prefix + name + ".");
        }
      }
    }
    function _record_condition_state(self2, condition) {
      self2._map = {};
      self2._node_index = {};
      (0, node_opcua_assert_1.assert)(condition instanceof ua_condition_impl_1.UAConditionImpl);
      _visit(self2, condition, "");
    }
    function _installOnChangeEventHandlers(self2, node, prefix) {
      const aggregates = node.getAggregates();
      for (const aggregate of aggregates) {
        if (aggregate.nodeClass === node_opcua_data_model_1.NodeClass.Variable) {
          const name = aggregate.browseName.toString();
          const key = prefix + name;
          if (doDebug) {
            debugLog("adding key =", key);
          }
          aggregate.on("value_changed", (newDataValue) => {
            self2._map[key] = newDataValue.value;
            self2._node_index[key] = aggregate;
          });
          _installOnChangeEventHandlers(self2, aggregate, prefix + name + ".");
        }
      }
    }
    function _ensure_condition_values_correctness(self2, node, prefix, error) {
      const displayError = !!error;
      error = error || [];
      const aggregates = node.getAggregates();
      for (const aggregate of aggregates) {
        if (aggregate.nodeClass === node_opcua_data_model_1.NodeClass.Variable) {
          const name = aggregate.browseName.toString();
          const key = prefix + name;
          const snapshot_value = self2._map[key].toString();
          const aggregateVariable = aggregate;
          const condition_value = aggregateVariable.readValue().value.toString();
          if (snapshot_value !== condition_value) {
            error.push(" Condition Branch0 is not in sync with node values for " + key + "\n v1= " + snapshot_value + "\n v2= " + condition_value);
          }
          self2._node_index[key] = aggregate;
          _ensure_condition_values_correctness(self2, aggregate, prefix + name + ".", error);
        }
      }
      if (displayError && error.length) {
        throw new Error(error.join("\n"));
      }
    }
    var disabledVar = new node_opcua_variant_1.Variant({
      dataType: "StatusCode",
      value: node_opcua_status_code_1.StatusCodes.BadConditionDisabled
    });
    var _varTable = {
      BranchId: 1,
      ConditionClassId: 1,
      ConditionClassName: 1,
      ConditionName: 1,
      EnabledState: 1,
      "EnabledState.EffectiveDisplayName": 1,
      "EnabledState.Id": 1,
      "EnabledState.TransitionTime": 1,
      "EnabledState.EffectiveTransitionTime": 1,
      EventId: 1,
      EventType: 1,
      LocalTime: 1,
      SourceName: 1,
      SourceNode: 1,
      Time: 1
    };
    var ConditionSnapshotImpl = class _ConditionSnapshotImpl extends events_1.EventEmitter {
      /**
       * @class ConditionSnapshot
       * @extends EventEmitter
       * @param condition
       * @param branchId
       * @constructor
       */
      constructor(condition, branchId) {
        super();
        this.eventData = null;
        this.branchId = null;
        this._map = {};
        this._node_index = {};
        (0, node_opcua_assert_1.assert)(branchId instanceof node_opcua_nodeid_1.NodeId);
        this.condition = condition;
        this.eventData = new event_data_1.EventData(condition);
        _record_condition_state(this, condition);
        if ((0, node_opcua_nodeid_1.sameNodeId)(branchId, node_opcua_nodeid_1.NodeId.nullNodeId)) {
          _installOnChangeEventHandlers(this, condition, "");
        }
        this._set_var("BranchId", node_opcua_variant_1.DataType.NodeId, branchId);
      }
      _constructEventData() {
        if (this.branchId && (0, node_opcua_nodeid_1.sameNodeId)(this.branchId, node_opcua_nodeid_1.NodeId.nullNodeId)) {
          _ensure_condition_values_correctness(this, this.condition, "", []);
        }
        const c2 = this.condition;
        const isDisabled = !c2.getEnabledState();
        const eventData = new event_data_1.EventData(this.condition);
        for (const fullBrowsePath of Object.keys(this._map)) {
          const node = this._node_index[fullBrowsePath];
          if (!node) {
            debugLog("cannot node for find key", fullBrowsePath);
            continue;
          }
          if (isDisabled && !Object.prototype.hasOwnProperty.call(_varTable, fullBrowsePath)) {
            eventData._createValue(fullBrowsePath, node, disabledVar);
          } else {
            eventData._createValue(fullBrowsePath, node, this._map[fullBrowsePath]);
          }
        }
        return eventData;
      }
      // /**
      //  *
      //  */
      // public readValue(sessionContext: ISessionContext, nodeId: NodeId, selectClause: SimpleAttributeOperand): Variant {
      //     const c = this.condition as UAConditionImpl;
      //     const isDisabled = !c.getEnabledState();
      //     if (isDisabled) {
      //         return disabledVar;
      //     }
      //     const key = nodeId.toString();
      //     const variant = this._map[key];
      //     if (!variant) {
      //         // the value is not handled by us .. let's delegate
      //         // to the eventData helper object
      //         return this.eventData?.readValue(sessionContext, nodeId, selectClause) || disabledVar;
      //     }
      //     return variant;
      // }
      _get_var(varName) {
        const c2 = this.condition;
        if (!c2.getEnabledState() && !Object.prototype.hasOwnProperty.call(_varTable, varName)) {
          return disabledVar;
        }
        const key = normalizeName(varName);
        const variant = this._map[key];
        if (!variant) {
          throw new Error("cannot find key " + key);
        }
        return variant.value;
      }
      _set_var(varName, dataType, value, options) {
        const key = normalizeName(varName);
        if (!Object.prototype.hasOwnProperty.call(this._map, key)) {
          if (doDebug) {
            debugLog(" cannot find node " + varName);
            debugLog("  map=", Object.keys(this._map).join(" "));
          }
        }
        this._map[key] = new node_opcua_variant_1.Variant({
          dataType,
          value
        });
        const sourceTimestamp = options?.sourceTimestamp || /* @__PURE__ */ new Date();
        const sourceTimestampKey = key + ".SourceTimestamp";
        if (this._map[sourceTimestampKey]) {
          const variant2 = new node_opcua_variant_1.Variant({
            dataType: node_opcua_variant_1.DataType.DateTime,
            value: sourceTimestamp
          });
          this._map[sourceTimestampKey] = variant2;
          const node2 = this._node_index[sourceTimestampKey];
          this.emit("valueChanged", node2, variant2, { sourceTimestamp });
        }
        const variant = this._map[key];
        const node = this._node_index[key];
        if (!node) {
          debugLog("Cannot serVar " + varName + " dataType " + node_opcua_variant_1.DataType[dataType]);
          return;
        }
        (0, node_opcua_assert_1.assert)(node.nodeClass === node_opcua_data_model_1.NodeClass.Variable);
        this.emit("valueChanged", node, variant, { sourceTimestamp });
      }
      /**
       * @method getBrandId
       * @return {NodeId}
       */
      getBranchId() {
        return this._get_var("BranchId");
      }
      /**
       * @method getEventId
       * @return {ByteString}
       */
      getEventId() {
        return this._get_var("EventId");
      }
      /**
       * @method getRetain
       * @return {Boolean}
       */
      getRetain() {
        return this._get_var("Retain");
      }
      /**
       *
       * @method setRetain
       * @param retainFlag {Boolean}
       */
      setRetain(retainFlag) {
        retainFlag = !!retainFlag;
        return this._set_var("Retain", node_opcua_variant_1.DataType.Boolean, retainFlag);
      }
      /**
       * @method renewEventId
       *
       */
      renewEventId() {
        const addressSpace = this.condition.addressSpace;
        const eventId = addressSpace.generateEventId();
        const ret = this._set_var("EventId", node_opcua_variant_1.DataType.ByteString, eventId.value);
        return ret;
      }
      /**
       * @method getEnabledState
       * @return {Boolean}
       */
      getEnabledState() {
        return this._get_twoStateVariable("EnabledState");
      }
      /**
       * @method setEnabledState
       * @param value {Boolean}
       * @return void
       */
      setEnabledState(value, options) {
        return this._set_twoStateVariable("EnabledState", value, options);
      }
      /**
       * @method getEnabledStateAsString
       * @return {String}
       */
      getEnabledStateAsString() {
        return this._get_var("EnabledState").text;
      }
      /**
       * @method getComment
       * @return {LocalizedText}
       */
      getComment() {
        return this._get_var("Comment");
      }
      /**
       * Set condition comment
       *
       * Comment contains the last comment provided for a certain state (ConditionBranch). It may
       * have been provided by an AddComment Method, some other Method or in some other
       * manner. The initial value of this Variable is null, unless it is provided in some other manner. If
       * a Method provides as an option the ability to set a Comment, then the value of this Variable is
       * reset to null if an optional comment is not provided.
       *
       * @method setComment
       * @param txtMessage {LocalizedText}
       */
      setComment(txtMessage, options) {
        const txtMessage1 = (0, node_opcua_data_model_1.coerceLocalizedText)(txtMessage);
        this._set_var("Comment", node_opcua_variant_1.DataType.LocalizedText, txtMessage1, options);
      }
      /**
       *
       * @method setMessage
       * @param txtMessage {LocalizedText}
       */
      setMessage(txtMessage) {
        const txtMessage1 = (0, node_opcua_data_model_1.coerceLocalizedText)(txtMessage);
        return this._set_var("Message", node_opcua_variant_1.DataType.LocalizedText, txtMessage1);
      }
      /**
       * @method setClientUserId
       * @param userIdentity {String}
       */
      setClientUserId(userIdentity) {
        return this._set_var("ClientUserId", node_opcua_variant_1.DataType.String, userIdentity.toString());
      }
      /*
       *
       *
       * as per spec 1.0.3 - Part 9
       *
       * Quality reveals the status of process values or other resources that this Condition instance is
       * based upon. If, for example, a process value is “Uncertain”, the associated “LevelAlarm”
       * Condition is also questionable. Values for the Quality can be any of the OPC StatusCodes
       * defined in Part 8 as well as Good, Uncertain and Bad as defined in Part 4. These
       * StatusCodes are similar to but slightly more generic than the description of data quality in the
       * various field bus specifications. It is the responsibility of the Server to map internal status
       * information to these codes. A Server which supports no quality information shall return Good.
       * This quality can also reflect the communication status associated with the system that this
       * value or resource is based on and from which this Alarm was received. For communication
       * errors to the underlying system, especially those that result in some unavailable Event fields,
       * the quality shall be BadNoCommunication error.
       *
       * Quality refers to the quality of the data value(s) upon which this Condition is based. Since a
       * Condition is usually based on one or more Variables, the Condition inherits the quality of
       * these Variables. E.g., if the process value is “Uncertain”, the “LevelAlarm” Condition is also
       * questionable. If more than one variable is represented by a given condition or if the condition
       * is from an underlining system and no direct mapping to a variable is available, it is up to the
       * application to determine what quality is displayed as part of the condition.
       */
      /**
       * set the condition quality
       * @method setQuality
       * @param quality {StatusCode}
       */
      setQuality(quality, options) {
        this._set_var("Quality", node_opcua_variant_1.DataType.StatusCode, quality, options);
      }
      /**
       * @method getQuality
       * @return {StatusCode}
       */
      getQuality() {
        return this._get_var("Quality");
      }
      /*
       * as per spec 1.0.3 - Part 9
       * The Severity of a Condition is inherited from the base Event model defined in Part 5. It
       * indicates the urgency of the Condition and is also commonly called ‘priority’, especially in
       * relation to Alarms in the ProcessConditionClass.
       *
       * as per spec 1.0.3 - PArt 5
       * Severity is an indication of the urgency of the Event. This is also commonly called “priority”.
       * Values will range from 1 to 1 000, with 1 being the lowest severity and 1 000 being the highest.
       * Typically, a severity of 1 would indicate an Event which is informational in nature, while a value
       * of 1 000 would indicate an Event of catastrophic nature, which could potentially result in severe
       * financial loss or loss of life.
       * It is expected that very few Server implementations will support 1 000 distinct severity levels.
       * Therefore, Server developers are responsible for distributing their severity levels across the
       * 1 to 1 000 range in such a manner that clients can assume a linear distribution. For example, a
       * client wishing to present five severity levels to a user should be able to do the following
       * mapping:
       *            Client Severity OPC Severity
       *                HIGH        801 – 1 000
       *                MEDIUM HIGH 601 – 800
       *                MEDIUM      401 – 600
       *                MEDIUM LOW  201 – 400
       *                LOW           1 – 200
       * In many cases a strict linear mapping of underlying source severities to the OPC Severity range
       * is not appropriate. The Server developer will instead intelligently map the underlying source
       * severities to the 1 to 1 000 OPC Severity range in some other fashion. In particular, it is
       * recommended that Server developers map Events of high urgency into the OPC severity range
       * of 667 to 1 000, Events of medium urgency into the OPC severity range of 334 to 666 and
       * Events of low urgency into OPC severities of 1 to 333.
       */
      /**
       * @method setSeverity
       * @param severity {UInt16}
       */
      setSeverity(severity, options) {
        (0, node_opcua_assert_1.assert)(isFinite(severity), "expecting a UInt16");
        const lastSeverity = this.getSeverity();
        const sourceTimestamp = this.getSeveritySourceTimestamp();
        this.setLastSeverity(lastSeverity, { sourceTimestamp });
        this._set_var("Severity", node_opcua_variant_1.DataType.UInt16, severity, options);
      }
      /**
       * @method getSeverity
       * @return {UInt16}
       */
      getSeverity() {
        const c2 = this.condition;
        (0, node_opcua_assert_1.assert)(c2.getEnabledState(), "condition must be enabled");
        const value = this._get_var("Severity");
        return +value;
      }
      getSeveritySourceTimestamp() {
        const c2 = this.condition;
        return c2.severity.readValue().sourceTimestamp || /* @__PURE__ */ new Date();
      }
      /*
       * as per spec 1.0.3 - part 9:
       *  LastSeverity provides the previous severity of the ConditionBranch. Initially this Variable
       *  contains a zero value; it will return a value only after a severity change. The new severity is
       *  supplied via the Severity Property which is inherited from the BaseEventType.
       *
       */
      /**
       * @method setLastSeverity
       * @param severity {UInt16}
       */
      setLastSeverity(severity, options) {
        severity = +severity;
        return this._set_var("LastSeverity", node_opcua_variant_1.DataType.UInt16, severity, options);
      }
      /**
       * @method getLastSeverity
       * @return {UInt16}
       */
      getLastSeverity() {
        const value = this._get_var("LastSeverity");
        return +value;
      }
      /**
       * setReceiveTime
       *
       * (as per OPCUA 1.0.3 part 5)
       *
       * ReceiveTime provides the time the OPC UA Server received the Event from the underlying
       * device of another Server.
       *
       * ReceiveTime is analogous to ServerTimestamp defined in Part 4, i.e.
       * in the case where the OPC UA Server gets an Event from another OPC UA Server, each Server
       * applies its own ReceiveTime. That implies that a Client may get the same Event, having the
       * same EventId, from different Servers having different values of the ReceiveTime.
       *
       * The ReceiveTime shall always be returned as value and the Server is not allowed to return a
       * StatusCode for the ReceiveTime indicating an error.
       *
       * @method setReceiveTime
       * @param time {Date} : UTCTime
       */
      setReceiveTime(time) {
        if (!(time instanceof Date)) {
          throw new Error("setReceiveTime expecting a Date");
        }
        ;
        return this._set_var("ReceiveTime", node_opcua_variant_1.DataType.DateTime, time, { sourceTimestamp: time });
      }
      /**
       * (as per OPCUA 1.0.3 part 5)
       * Time provides the time the Event occurred. This value is set as close to the event generator as
       * possible. It often comes from the underlying system or device. Once set, intermediate OPC UA
       * Servers shall not alter the value.
       *
       * @method setTime
       * @param time {Date}
       */
      setTime(time) {
        return this._set_var("Time", node_opcua_variant_1.DataType.DateTime, time, { sourceTimestamp: time });
      }
      /**
       * LocalTime is a structure containing the Offset and the DaylightSavingInOffset flag. The Offset
       * specifies the time difference (in minutes) between the Time Property and the time at the location
       * in which the event was issued. If DaylightSavingInOffset is TRUE, then Standard/Daylight
       * savings time (DST) at the originating location is in effect and Offset includes the DST c orrection.
       * If FALSE then the Offset does not include DST correction and DST may or may not have been
       * in effect.
       * @method setLocalTime
       * @param localTime {TimeZone}
       */
      setLocalTime(localTime) {
        (0, node_opcua_assert_1.assert)(localTime instanceof node_opcua_types_1.TimeZoneDataType);
        return this._set_var("LocalTime", node_opcua_variant_1.DataType.ExtensionObject, new node_opcua_types_1.TimeZoneDataType(localTime));
      }
      // read only !
      getSourceName() {
        return this._get_var("SourceName");
      }
      /**
       * @method getSourceNode
       * return {NodeId}
       */
      getSourceNode() {
        return this._get_var("SourceNode");
      }
      /**
       * @method getEventType
       * return {NodeId}
       */
      getEventType() {
        return this._get_var("EventType");
      }
      getMessage() {
        return this._get_var("Message");
      }
      isCurrentBranch() {
        return (0, node_opcua_nodeid_1.sameNodeId)(this._get_var("BranchId"), node_opcua_nodeid_1.NodeId.nullNodeId);
      }
      // -- ACKNOWLEDGEABLE -------------------------------------------------------------------
      getAckedState() {
        const acknowledgeableCondition = this.condition;
        if (!acknowledgeableCondition.ackedState) {
          throw new Error("Node " + acknowledgeableCondition.browseName.toString() + " of type " + acknowledgeableCondition.typeDefinitionObj.browseName.toString() + " has no AckedState");
        }
        return this._get_twoStateVariable("AckedState");
      }
      setAckedState(ackedState, options) {
        ackedState = !!ackedState;
        return (0, condition_1._setAckedState)(this, ackedState, void 0, void 0, options);
      }
      getConfirmedState() {
        const acknowledgeableCondition = this.condition;
        (0, node_opcua_assert_1.assert)(acknowledgeableCondition.confirmedState, "Must have a confirmed state");
        return this._get_twoStateVariable("ConfirmedState");
      }
      setConfirmedStateIfExists(confirmedState, options) {
        confirmedState = !!confirmedState;
        const acknowledgeableCondition = this.condition;
        if (!acknowledgeableCondition.confirmedState) {
          return;
        }
        return this._set_twoStateVariable("ConfirmedState", confirmedState, options);
      }
      setConfirmedState(confirmedState) {
        const acknowledgeableCondition = this.condition;
        (0, node_opcua_assert_1.assert)(acknowledgeableCondition.confirmedState, "Must have a confirmed state.  Add ConfirmedState to the optionals");
        return this.setConfirmedStateIfExists(confirmedState);
      }
      // ---- Shelving
      /**
       * @class ConditionSnapshot
       */
      /**
       * @method getSuppressedState
       * @return {Boolean}
       */
      getSuppressedState() {
        return this._get_twoStateVariable("SuppressedState");
      }
      /**
       * @method setSuppressedState
       * @param suppressed {Boolean}
       */
      setSuppressedState(suppressed, options) {
        suppressed = !!suppressed;
        this._set_twoStateVariable("SuppressedState", suppressed, options);
      }
      getActiveState() {
        return this._get_twoStateVariable("ActiveState");
      }
      setActiveState(newActiveState, options) {
        this._set_twoStateVariable("ActiveState", newActiveState, options);
        return node_opcua_status_code_1.StatusCodes.Good;
      }
      setLatchedState(newLatchedState, options) {
        this._set_twoStateVariable("LatchedState", newLatchedState, options);
        return node_opcua_status_code_1.StatusCodes.Good;
      }
      getLatchedState() {
        return this._get_twoStateVariable("LatchedState");
      }
      setOutOfServiceState(newOutOfServiceState, options) {
        this._set_twoStateVariable("OutOfServiceState", newOutOfServiceState, options);
        return node_opcua_status_code_1.StatusCodes.Good;
      }
      getOutOfServiceState() {
        return this._get_twoStateVariable("OutOfServiceState");
      }
      setSilentState(newSilentState, options) {
        this._set_twoStateVariable("SilentState", newSilentState, options);
        return node_opcua_status_code_1.StatusCodes.Good;
      }
      getSilentState() {
        return this._get_twoStateVariable("SilentState");
      }
      setShelvingState() {
        throw new Error("Method not implemented.");
      }
      toString() {
        const t = this.condition.addressSpace.findNode(this.condition.typeDefinition);
        return "condition: " + (this.condition.browseName.toString() + " " + this.condition.nodeId.toString()) + ", type: " + (t.browseName.toString() + " " + t.nodeId.toString()) + ", branchId: " + (this.branchId ? this.branchId.toString() : "<null>") + ", acked: " + this.getAckedState() + ", confirmed: " + this.getConfirmedState() + ", activeState: " + this.getActiveState() + // + ", suppressed: " + this.getSuppressedState()
        ", retain: " + this.getRetain() + ", message: " + this.getMessage() + ", comment: " + this.getComment();
      }
      /**
       * @class ConditionSnapshot
       * @param varName
       * @param value
       * @private
       */
      _set_twoStateVariable(varName, value, options) {
        value = !!value;
        const hrKey = _ConditionSnapshotImpl.normalizeName(varName);
        const idKey = _ConditionSnapshotImpl.normalizeName(varName + ".Id");
        const variant = new node_opcua_variant_1.Variant({ dataType: node_opcua_variant_1.DataType.Boolean, value });
        this._map[idKey] = variant;
        const twoStateNode = this._node_index[hrKey];
        if (!twoStateNode) {
          throw new Error("Cannot find twoState Variable with name " + varName);
        }
        if (!(twoStateNode instanceof ua_two_state_variable_1.UATwoStateVariableImpl)) {
          throw new Error("Cannot find twoState Variable with name " + varName + " " + twoStateNode);
        }
        const hrValue = new node_opcua_variant_1.Variant({
          dataType: node_opcua_variant_1.DataType.LocalizedText,
          value: value ? twoStateNode.getTrueState() : twoStateNode.getFalseState()
        });
        this._map[hrKey] = hrValue;
        const node = this._node_index[idKey];
        if (this.isCurrentBranch()) {
          (0, node_opcua_assert_1.assert)(twoStateNode instanceof ua_two_state_variable_1.UATwoStateVariableImpl);
          twoStateNode.setValue(value, options);
        }
        const sourceTimestamp = options?.effectiveTransitionTime || /* @__PURE__ */ new Date();
        this.emit("valueChanged", node, variant, { sourceTimestamp });
      }
      _get_twoStateVariable(varName) {
        const key = _ConditionSnapshotImpl.normalizeName(varName) + ".Id";
        const variant = this._map[key];
        if (!variant) {
          return "???";
        }
        return variant.value;
      }
    };
    exports2.ConditionSnapshotImpl = ConditionSnapshotImpl;
    ConditionSnapshotImpl.normalizeName = normalizeName;
  }
});

// node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_acknowledgeable_condition_impl.js
var require_ua_acknowledgeable_condition_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_acknowledgeable_condition_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UAAcknowledgeableConditionImpl = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_debug_1 = require_dist24();
    var ua_two_state_variable_1 = require_ua_two_state_variable();
    var condition_1 = require_condition();
    var condition_snapshot_impl_1 = require_condition_snapshot_impl();
    var ua_condition_impl_1 = require_ua_condition_impl();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = false;
    var UAAcknowledgeableConditionImpl = class _UAAcknowledgeableConditionImpl extends ua_condition_impl_1.UAConditionImpl {
      /**
       */
      static instantiate(namespace, conditionTypeId, options, data) {
        const conditionNode = ua_condition_impl_1.UAConditionImpl.instantiate(namespace, conditionTypeId, options, data);
        Object.setPrototypeOf(conditionNode, _UAAcknowledgeableConditionImpl.prototype);
        (0, ua_two_state_variable_1._install_TwoStateVariable_machinery)(conditionNode.ackedState, {
          falseState: "Unacknowledged",
          trueState: "Acknowledged"
        });
        conditionNode.acknowledge.bindMethod(_acknowledge_method);
        if (conditionNode.confirmedState) {
          (0, ua_two_state_variable_1._install_TwoStateVariable_machinery)(conditionNode.confirmedState, {
            falseState: "Unconfirmed",
            trueState: "Confirmed"
          });
        }
        if (conditionNode.confirm) {
          conditionNode.confirm.bindMethod(_confirm_method);
        }
        (0, node_opcua_assert_1.assert)(conditionNode instanceof _UAAcknowledgeableConditionImpl);
        return conditionNode;
      }
      static install_method_handle_on_type(addressSpace) {
        const acknowledgeableConditionType = addressSpace.findEventType("AcknowledgeableConditionType");
        (0, node_opcua_assert_1.assert)(acknowledgeableConditionType !== null);
        acknowledgeableConditionType.acknowledge.bindMethod(_acknowledge_method);
        acknowledgeableConditionType.confirm?.bindMethod(_confirm_method);
      }
      _raiseAuditConditionAcknowledgeEvent(branch) {
        const eventData = {
          actionTimeStamp: { dataType: node_opcua_variant_1.DataType.DateTime, value: /* @__PURE__ */ new Date() },
          // xx branchId: branch.branchId.readValue().value,
          // AuditEventType
          clientAuditEntryId: {
            dataType: node_opcua_variant_1.DataType.Null
          },
          clientUserId: {
            dataType: node_opcua_variant_1.DataType.Null
          },
          // The ConditionEventId field shall contain the id of the event for which the comment was added
          conditionEventId: { dataType: node_opcua_variant_1.DataType.ByteString, value: branch.getEventId() },
          // The Comment contains the actual comment that was added
          comment: { dataType: node_opcua_variant_1.DataType.LocalizedText, value: branch.getComment() },
          inputArguments: {
            dataType: node_opcua_variant_1.DataType.Null
          },
          methodId: {
            dataType: node_opcua_variant_1.DataType.Null
          },
          serverId: {
            dataType: node_opcua_variant_1.DataType.Null
          },
          status: {
            dataType: node_opcua_variant_1.DataType.StatusCode,
            value: node_opcua_status_code_1.StatusCodes.Good
          }
        };
        this.raiseEvent("AuditConditionAcknowledgeEventType", eventData);
      }
      _raiseAuditConditionConfirmEvent(branch) {
        const eventData = {
          actionTimeStamp: { dataType: node_opcua_variant_1.DataType.DateTime, value: /* @__PURE__ */ new Date() },
          // ConditionEventId The ConditionEventId field shall contain the id of the Event that was confirmed
          conditionEventId: { dataType: node_opcua_variant_1.DataType.ByteString, value: branch.getEventId() },
          // xx branchId: branch.branchId.readValue().value,
          // AuditEventType
          clientAuditEntryId: {
            dataType: node_opcua_variant_1.DataType.Null
          },
          clientUserId: {
            dataType: node_opcua_variant_1.DataType.Null
          },
          comment: { dataType: node_opcua_variant_1.DataType.LocalizedText, value: branch.getComment() },
          inputArguments: {
            dataType: node_opcua_variant_1.DataType.Null
          },
          methodId: {
            dataType: node_opcua_variant_1.DataType.Null
          },
          serverId: {
            dataType: node_opcua_variant_1.DataType.Null
          },
          status: {
            dataType: node_opcua_variant_1.DataType.StatusCode,
            value: node_opcua_status_code_1.StatusCodes.Good
          }
        };
        this.raiseEvent("AuditConditionConfirmEventType", eventData);
      }
      _acknowledge_branch(conditionEventId, comment, branch, message) {
        (0, node_opcua_assert_1.assert)(typeof message === "string");
        const statusCode = (0, condition_1._setAckedState)(branch, true, conditionEventId, comment);
        if (statusCode.isNotGood()) {
          return statusCode;
        }
        if (this.confirmedState) {
          branch.setConfirmedState(false);
          branch.setRetain(true);
        } else {
          branch.setRetain(false);
        }
        branch.setComment(comment);
        this.raiseNewBranchState(branch);
        this._raiseAuditConditionAcknowledgeEvent(branch);
        this.emit("acknowledged", conditionEventId, comment, branch);
        return node_opcua_status_code_1.StatusCodes.Good;
      }
      /**
       * @method _confirm_branch
       * @param conditionEventId The ConditionEventId field shall contain the id of the Event that was conformed
       * @param comment
       * @param branch
       * @param message
       * @private
       */
      _confirm_branch(conditionEventId, comment, branch, message) {
        (0, node_opcua_assert_1.assert)(typeof message === "string");
        (0, node_opcua_assert_1.assert)(comment instanceof node_opcua_data_model_1.LocalizedText);
        (0, node_opcua_assert_1.assert)(branch.getEventId().toString("hex") === conditionEventId.toString("hex"));
        branch.setConfirmedState(true);
        branch.setRetain(false);
        branch.setComment(comment);
        this._raiseAuditConditionCommentEvent(message, conditionEventId, comment);
        this._raiseAuditConditionConfirmEvent(branch);
        this.raiseNewBranchState(branch);
        this.emit("confirmed", conditionEventId, comment, branch);
      }
      /**
       * @method autoConfirmBranch
       * @param branch
       * @param comment
       */
      autoConfirmBranch(branch, comment) {
        (0, node_opcua_assert_1.assert)(branch instanceof condition_snapshot_impl_1.ConditionSnapshotImpl);
        if (!this.confirmedState) {
          return;
        }
        (0, node_opcua_assert_1.assert)(!branch.getConfirmedState(), "already confirmed ?");
        const conditionEventId = branch.getEventId();
        doDebug && debugLog("autoConfirmBranch getAckedState ", branch.getAckedState());
        this._confirm_branch(conditionEventId, comment, branch, "Server/Confirm");
      }
      /**
       * @method acknowledgeAndAutoConfirmBranch
       * @param branch {ConditionSnapshot}
       * @param comment {String|LocalizedText}
       */
      acknowledgeAndAutoConfirmBranch(branch, comment) {
        comment = node_opcua_data_model_1.LocalizedText.coerce(comment);
        const conditionEventId = branch.getEventId();
        branch.setRetain(false);
        this._acknowledge_branch(conditionEventId, comment, branch, "Server/Acknowledge");
        this.autoConfirmBranch(branch, comment);
      }
    };
    exports2.UAAcknowledgeableConditionImpl = UAAcknowledgeableConditionImpl;
    function _acknowledge_method(inputArguments, context, callback) {
      ua_condition_impl_1.UAConditionImpl.with_condition_method(inputArguments, context, callback, (conditionEventId, comment, branch, conditionNode) => {
        const ackConditionNode = conditionNode;
        (0, node_opcua_assert_1.assert)(!conditionEventId || conditionEventId instanceof Buffer, "must have a valid eventId or  null");
        (0, node_opcua_assert_1.assert)(comment instanceof node_opcua_data_model_1.LocalizedText, "expecting a comment as LocalizedText");
        (0, node_opcua_assert_1.assert)(conditionNode instanceof UAAcknowledgeableConditionImpl);
        ackConditionNode._acknowledge_branch(conditionEventId, comment, branch, "Method/Acknowledged");
        return node_opcua_status_code_1.StatusCodes.Good;
      });
    }
    function _confirm_method(inputArguments, context, callback) {
      ua_condition_impl_1.UAConditionImpl.with_condition_method(inputArguments, context, callback, (eventId, comment, branch, conditionNode) => {
        (0, node_opcua_assert_1.assert)(eventId instanceof Buffer);
        (0, node_opcua_assert_1.assert)(branch.getEventId() instanceof Buffer);
        (0, node_opcua_assert_1.assert)(branch.getEventId().toString("hex") === eventId.toString("hex"));
        const ackConditionNode = conditionNode;
        if (branch.getConfirmedState()) {
          return node_opcua_status_code_1.StatusCodes.BadConditionBranchAlreadyConfirmed;
        }
        ackConditionNode._confirm_branch(eventId, comment, branch, "Method/Confirm");
        return node_opcua_status_code_1.StatusCodes.Good;
      });
    }
  }
});

// node_modules/node-opcua-address-space/dist/source/helpers/make_optionals_map.js
var require_make_optionals_map = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/helpers/make_optionals_map.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.makeOptionalsMap = void 0;
    var node_opcua_assert_1 = require_dist14();
    function makeOptionalsMap(optionals) {
      const resultMap = {};
      if (!optionals) {
        return resultMap;
      }
      (0, node_opcua_assert_1.assert)(optionals instanceof Array);
      function insertInMap(map, s) {
        const key = s[0];
        if (!map[key]) {
          map[key] = {};
        }
        if (s.length > 1) {
          insertInMap(map[key], s.splice(1));
        }
      }
      for (const opt of optionals) {
        const s = opt.split(".");
        insertInMap(resultMap, s);
      }
      return resultMap;
    }
    exports2.makeOptionalsMap = makeOptionalsMap;
  }
});

// node_modules/node-opcua-address-space/dist/src/_mandatory_child_or_requested_optional_filter.js
var require_mandatory_child_or_requested_optional_filter = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/_mandatory_child_or_requested_optional_filter.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.MandatoryChildOrRequestedOptionalFilter = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_address_space_base_1 = require_dist53();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_data_model_1 = require_dist27();
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var doTrace = (0, node_opcua_debug_1.checkDebugFlag)("INSTANTIATE");
    var traceLog = errorLog;
    var MandatoryChildOrRequestedOptionalFilter = class _MandatoryChildOrRequestedOptionalFilter {
      constructor(instance, optionalsMap) {
        (0, node_opcua_assert_1.assert)(optionalsMap !== null && typeof optionalsMap === "object");
        (0, node_opcua_assert_1.assert)(null !== instance);
        this.optionalsMap = optionalsMap;
        this.instance = instance;
        this.references = instance.findReferencesEx("Aggregates", node_opcua_data_model_1.BrowseDirection.Forward);
      }
      shouldKeep(node) {
        const addressSpace = node.addressSpace;
        const alreadyIn = this.references.filter((r) => {
          const n = addressSpace.findNode(r.nodeId);
          if (!n) {
            warningLog(" cannot find node ", r.nodeId.toString());
            return false;
          }
          return n.browseName.name.toString() === node.browseName.name.toString();
        });
        if (alreadyIn.length > 0) {
          (0, node_opcua_assert_1.assert)(alreadyIn.length === 1, "Duplication found ?");
          return false;
        }
        const modellingRule = node.modellingRule;
        switch (modellingRule) {
          case null:
          case void 0:
            doTrace && traceLog("node ", (0, node_opcua_address_space_base_1.fullPath2)(node), " has no modellingRule ", node ? (0, node_opcua_address_space_base_1.fullPath2)(node) : "");
            return false;
          case "Mandatory":
            return true;
          case "Optional":
            return node.browseName.name in this.optionalsMap;
          case "OptionalPlaceholder":
            return false;
          default:
            return false;
        }
      }
      filterFor(childInstance) {
        const browseName = childInstance.browseName.name;
        let map = {};
        if (browseName in this.optionalsMap) {
          map = this.optionalsMap[browseName];
        }
        doTrace && traceLog("filterFor ", browseName, map);
        const newFilter = new _MandatoryChildOrRequestedOptionalFilter(childInstance, map);
        return newFilter;
      }
    };
    exports2.MandatoryChildOrRequestedOptionalFilter = MandatoryChildOrRequestedOptionalFilter;
  }
});

// node_modules/node-opcua-address-space/dist/src/_instantiate_helpers.js
var require_instantiate_helpers = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/_instantiate_helpers.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.initialize_properties_and_components = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_address_space_base_1 = require_dist53();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var make_optionals_map_1 = require_make_optionals_map();
    var base_node_private_1 = require_base_node_private();
    var _mandatory_child_or_requested_optional_filter_1 = require_mandatory_child_or_requested_optional_filter();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var doTrace = (0, node_opcua_debug_1.checkDebugFlag)("INSTANTIATE");
    var traceLog = errorLog;
    function _initialize_properties_and_components(instance, topMostType, typeDefinitionNode, copyAlsoModellingRules, optionalsMap, extraInfo, browseNameMap) {
      if (doTrace) {
        warningLog("instance browseName =", instance.browseName.toString());
        warningLog("typeNode            =", typeDefinitionNode.browseName.toString());
        warningLog("optionalsMap        =", Object.keys(optionalsMap).join(" "));
        const c2 = typeDefinitionNode.findReferencesEx("Aggregates");
        warningLog("typeDefinition aggregates      =", c2.map((x2) => x2.node.browseName.toString()).join(" "));
      }
      optionalsMap = optionalsMap || {};
      if ((0, node_opcua_nodeid_1.sameNodeId)(topMostType.nodeId, typeDefinitionNode.nodeId)) {
        return;
      }
      const filter = new _mandatory_child_or_requested_optional_filter_1.MandatoryChildOrRequestedOptionalFilter(instance, optionalsMap);
      doTrace && traceLog(chalk_1.default.cyan(extraInfo.pad(), "cloning relevant member of typeDefinition class"), typeDefinitionNode.browseName.toString());
      (0, base_node_private_1._clone_hierarchical_references)(typeDefinitionNode, instance, copyAlsoModellingRules, filter, extraInfo, browseNameMap);
      const baseTypeDefinitionNodeId = typeDefinitionNode.subtypeOf;
      const baseTypeDefinition = typeDefinitionNode.subtypeOfObj;
      doTrace && traceLog(chalk_1.default.cyan(extraInfo.pad(), "now apply recursion on baseTypeDefinition  to get properties and components from base class"), baseTypeDefinition.browseName.toString());
      if (!baseTypeDefinition) {
        throw new Error(chalk_1.default.red("Cannot find object with nodeId ") + baseTypeDefinitionNodeId);
      }
      extraInfo.level++;
      _initialize_properties_and_components(instance, topMostType, baseTypeDefinition, copyAlsoModellingRules, optionalsMap, extraInfo, browseNameMap);
      extraInfo.level--;
    }
    function initialize_properties_and_components(instance, topMostType, nodeType, copyAlsoModellingRules, optionals) {
      const extraInfo = new node_opcua_address_space_base_1.CloneHelper();
      extraInfo.pushContext({
        clonedParent: instance,
        originalParent: nodeType
      });
      extraInfo.registerClonedObject({
        clonedNode: instance,
        originalNode: nodeType
      });
      const optionalsMap = (0, make_optionals_map_1.makeOptionalsMap)(optionals);
      const browseNameMap = /* @__PURE__ */ new Set();
      _initialize_properties_and_components(instance, topMostType, nodeType, copyAlsoModellingRules, optionalsMap, extraInfo, browseNameMap);
      (0, node_opcua_address_space_base_1.reconstructFunctionalGroupType)(extraInfo);
      (0, node_opcua_address_space_base_1.reconstructNonHierarchicalReferences)(extraInfo);
    }
    exports2.initialize_properties_and_components = initialize_properties_and_components;
  }
});

// node_modules/node-opcua-address-space/dist/src/check_value_rank_compatibility.js
var require_check_value_rank_compatibility = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/check_value_rank_compatibility.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.checkValueRankCompatibility = void 0;
    function checkValueRankCompatibility(actualValueRank, baseTypeValueRank) {
      const ScalarOrOneDimension = -3;
      const OneOrMoreDimensions = 0;
      const AnyDimension = -2;
      const OneDimension = 1;
      const Scalar = -1;
      const t = (valueRank) => {
        switch (valueRank) {
          case ScalarOrOneDimension:
            return `ScalarOrOneDimension(${valueRank})`;
          case OneOrMoreDimensions:
            return `OneOrMoreDimensions(${valueRank})`;
          case AnyDimension:
            return `AnyDimension(${valueRank})`;
          case OneDimension:
            return `OneDimension(${valueRank})`;
          case Scalar:
            return `Scalar(${valueRank})`;
        }
        if (valueRank < 0) {
          return `InvalidValueRank(${valueRank})`;
        }
        return "" + valueRank;
      };
      if (actualValueRank < 0) {
        if (actualValueRank !== Scalar && actualValueRank !== AnyDimension && actualValueRank !== ScalarOrOneDimension) {
          return {
            result: false,
            errorMessage: `Invalid valueRank: ${t(actualValueRank)}  can only be ${t(ScalarOrOneDimension)} ${t(AnyDimension)}, ${t(Scalar)} ${t(OneOrMoreDimensions)} or a positive number`
          };
        }
      }
      if (baseTypeValueRank === AnyDimension) {
        return { result: true };
      }
      if (baseTypeValueRank === OneDimension || baseTypeValueRank > 1) {
        if (actualValueRank === baseTypeValueRank) {
          return { result: true };
        }
        ;
        return {
          result: false,
          errorMessage: `Invalid valueRank: ${t(actualValueRank)}:  valueRank can only be identical to base type ${t(baseTypeValueRank)}`
        };
      }
      if (baseTypeValueRank === Scalar) {
        if (actualValueRank === Scalar)
          return { result: true };
        return {
          result: false,
          errorMessage: `Invalid valueRank: ${t(actualValueRank)}: valueRank can only be identical to base type ${t(Scalar)}`
        };
      }
      if (baseTypeValueRank === OneOrMoreDimensions) {
        if (actualValueRank === OneOrMoreDimensions || actualValueRank >= 1)
          return { result: true };
        return {
          result: false,
          errorMessage: `Invalid valueRank: ${t(actualValueRank)}: valueRank can only be identical to base type ${t(OneOrMoreDimensions)} or be a positive number`
        };
      }
      if (baseTypeValueRank === ScalarOrOneDimension) {
        if (actualValueRank === OneDimension || actualValueRank === Scalar || actualValueRank === ScalarOrOneDimension)
          return { result: true };
        return {
          result: false,
          errorMessage: `Invalid valueRank: ${t(actualValueRank)}: valueRank can only be identical to base type ${t(ScalarOrOneDimension)} , ${t(Scalar)} or ${t(OneDimension)}.`
        };
      }
      return { result: false };
    }
    exports2.checkValueRankCompatibility = checkValueRankCompatibility;
  }
});

// node_modules/node-opcua-address-space/dist/src/ua_variable_type_impl.js
var require_ua_variable_type_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/ua_variable_type_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.assertUnusedChildBrowseName = exports2.UAVariableTypeImpl = exports2.topMostParentIsObjectTypeOrVariableType = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_variant_1 = require_dist28();
    var session_context_1 = require_session_context2();
    var _instantiate_helpers_1 = require_instantiate_helpers();
    var base_node_impl_1 = require_base_node_impl();
    var base_node_private_1 = require_base_node_private();
    var tool_isSubtypeOf_1 = require_tool_isSubtypeOf();
    var tool_isSubtypeOf_2 = require_tool_isSubtypeOf();
    var tool_isSubtypeOf_3 = require_tool_isSubtypeOf();
    var check_value_rank_compatibility_1 = require_check_value_rank_compatibility();
    var get_basic_datatype_1 = require_get_basic_datatype();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var doTrace = (0, node_opcua_debug_1.checkDebugFlag)("INSTANTIATE");
    function topMostParentIsObjectTypeOrVariableType(addressSpace, options) {
      if (options.modellingRule) {
        return true;
      }
      const parent = options.propertyOf || options.componentOf;
      if (!parent) {
        return false;
      }
      const parentNode = addressSpace._coerceNode(parent);
      if (!parentNode) {
        return false;
      }
      let currentNode = parentNode;
      while (currentNode) {
        const nodeClass = parentNode.nodeClass;
        if (nodeClass === node_opcua_data_model_1.NodeClass.ObjectType || nodeClass === node_opcua_data_model_1.NodeClass.VariableType) {
          return true;
        }
        if (nodeClass === node_opcua_data_model_1.NodeClass.Object || nodeClass === node_opcua_data_model_1.NodeClass.Variable || nodeClass === node_opcua_data_model_1.NodeClass.Method) {
        }
        currentNode = currentNode.findReferencesEx("HasChild", node_opcua_data_model_1.BrowseDirection.Inverse)[0]?.node;
      }
      return false;
    }
    exports2.topMostParentIsObjectTypeOrVariableType = topMostParentIsObjectTypeOrVariableType;
    function deprecate(func) {
      return func;
    }
    var UAVariableTypeImpl = class _UAVariableTypeImpl extends base_node_impl_1.BaseNodeImpl {
      get subtypeOf() {
        return tool_isSubtypeOf_3.get_subtypeOf.call(this);
      }
      get subtypeOfObj() {
        return tool_isSubtypeOf_2.get_subtypeOfObj.call(this);
      }
      constructor(options) {
        super(options);
        this.nodeClass = node_opcua_data_model_1.NodeClass.VariableType;
        this.isSubtypeOf = (0, tool_isSubtypeOf_1.construct_isSubtypeOf)(_UAVariableTypeImpl);
        this.isSupertypeOf = deprecate((0, tool_isSubtypeOf_1.construct_isSubtypeOf)(_UAVariableTypeImpl));
        (0, node_opcua_variant_1.verifyRankAndDimensions)(options);
        this.valueRank = options.valueRank || -1;
        this.arrayDimensions = options.arrayDimensions || null;
        this.minimumSamplingInterval = 0;
        this.historizing = (0, node_opcua_utils_1.isNullOrUndefined)(options.historizing) ? false : options.historizing;
        this.isAbstract = (0, node_opcua_utils_1.isNullOrUndefined)(options.isAbstract) ? false : options.isAbstract;
        this.value = options.value;
        this.dataType = (0, node_opcua_nodeid_1.coerceNodeId)(options.dataType);
        if (options.value) {
          this.value = new node_opcua_variant_1.Variant(options.value);
        }
      }
      readAttribute(context, attributeId) {
        (0, node_opcua_assert_1.assert)(!context || context instanceof session_context_1.SessionContext);
        const options = {};
        switch (attributeId) {
          case node_opcua_data_model_1.AttributeIds.IsAbstract:
            options.value = { dataType: node_opcua_variant_1.DataType.Boolean, value: this.isAbstract ? true : false };
            options.statusCode = node_opcua_status_code_1.StatusCodes.Good;
            break;
          case node_opcua_data_model_1.AttributeIds.Value:
            if (Object.prototype.hasOwnProperty.call(this, "value") && this.value !== void 0) {
              (0, node_opcua_assert_1.assert)(this.value.schema.name === "Variant");
              options.value = this.value;
              options.statusCode = node_opcua_status_code_1.StatusCodes.Good;
            } else {
              debugLog(" warning Value not implemented");
              options.value = { dataType: node_opcua_variant_1.DataType.Null };
              options.statusCode = node_opcua_status_code_1.StatusCodes.BadAttributeIdInvalid;
            }
            break;
          case node_opcua_data_model_1.AttributeIds.DataType:
            (0, node_opcua_assert_1.assert)(this.dataType instanceof node_opcua_nodeid_1.NodeId);
            options.value = { dataType: node_opcua_variant_1.DataType.NodeId, value: this.dataType };
            options.statusCode = node_opcua_status_code_1.StatusCodes.Good;
            break;
          case node_opcua_data_model_1.AttributeIds.ValueRank:
            options.value = { dataType: node_opcua_variant_1.DataType.Int32, value: this.valueRank };
            options.statusCode = node_opcua_status_code_1.StatusCodes.Good;
            break;
          case node_opcua_data_model_1.AttributeIds.ArrayDimensions:
            (0, node_opcua_assert_1.assert)(Array.isArray(this.arrayDimensions) || this.arrayDimensions === null);
            options.value = {
              arrayType: node_opcua_variant_1.VariantArrayType.Array,
              dataType: node_opcua_variant_1.DataType.UInt32,
              value: this.arrayDimensions
            };
            options.statusCode = node_opcua_status_code_1.StatusCodes.Good;
            break;
          default:
            return super.readAttribute(context, attributeId);
        }
        return new node_opcua_data_value_1.DataValue(options);
      }
      toString() {
        const options = new base_node_private_1.ToStringBuilder();
        base_node_private_1.UAVariableType_toString.call(this, options);
        return options.toString();
      }
      /**
        * instantiate an object of this UAVariableType
        * The instantiation takes care of object type inheritance when constructing inner properties
      
        * Note : HasComponent usage scope
        *
        * ```text
        *    Source          |     Destination
        * -------------------+---------------------------
        *  Object            | Object, Variable,Method
        *  ObjectType        |
        * -------------------+---------------------------
        *  DataVariable      | Variable
        *  DataVariableType  |
        * ```
        *
        *  see : OPCUA 1.03 page 44 $6.4 Instances of ObjectTypes and VariableTypes
        */
      instantiate(options) {
        const addressSpace = this.addressSpace;
        (0, node_opcua_assert_1.assert)(options, "missing option object");
        (0, node_opcua_assert_1.assert)(typeof options.browseName === "string" || options.browseName !== null && typeof options.browseName === "object", "expecting a browse name");
        (0, node_opcua_assert_1.assert)(!Object.prototype.hasOwnProperty.call(options, "propertyOf"), "Use addressSpace#addVariable({ propertyOf: xxx}); to add a property");
        assertUnusedChildBrowseName(addressSpace, options);
        const baseVariableType = addressSpace.findVariableType("BaseVariableType");
        (0, node_opcua_assert_1.assert)(baseVariableType, "BaseVariableType must be defined in the address space");
        let dataType = options.dataType !== void 0 ? options.dataType : this.dataType;
        dataType = this.resolveNodeId(dataType);
        (0, node_opcua_assert_1.assert)(dataType instanceof node_opcua_nodeid_1.NodeId);
        const valueRank = options.valueRank !== void 0 ? options.valueRank : this.valueRank;
        const { result: result2, errorMessage } = (0, check_value_rank_compatibility_1.checkValueRankCompatibility)(valueRank, this.valueRank);
        if (!result2) {
          errorLog(errorMessage);
          throw new Error(errorMessage);
        }
        const arrayDimensions = options.arrayDimensions !== void 0 ? options.arrayDimensions : this.arrayDimensions;
        if (!dataType || dataType.isEmpty()) {
          warningLog(" options.dataType", options.dataType ? options.dataType.toString() : "<null>");
          warningLog(" this.dataType", this.dataType ? this.dataType.toString() : "<null>");
          throw new Error(" A valid dataType must be specified");
        }
        const copyAlsoModellingRules = topMostParentIsObjectTypeOrVariableType(addressSpace, options);
        const defaultDataType = this.dataType;
        const defaultDataValue = this.readAttribute(null, node_opcua_data_model_1.AttributeIds.Value);
        const defaultValue = defaultDataType.namespace === 0 && defaultDataType.value == 0 || defaultDataValue.statusCode.isNotGood() ? void 0 : defaultDataValue.value;
        const opts = {
          arrayDimensions,
          browseName: options.browseName,
          componentOf: options.componentOf,
          dataType,
          description: options.description === void 0 ? this.description?.clone() : options.description,
          displayName: options.displayName || "",
          eventSourceOf: options.eventSourceOf,
          minimumSamplingInterval: options.minimumSamplingInterval,
          modellingRule: options.modellingRule,
          nodeId: options.nodeId,
          notifierOf: options.notifierOf,
          organizedBy: options.organizedBy,
          typeDefinition: this.nodeId,
          value: options.value || defaultValue,
          valueRank
        };
        const namespace = options.namespace || addressSpace.getOwnNamespace();
        const instance = namespace.addVariable(opts);
        (0, _instantiate_helpers_1.initialize_properties_and_components)(instance, baseVariableType, this, copyAlsoModellingRules, options.optionals);
        instance.bindExtensionObject(options.extensionObject, { createMissingProp: false });
        (0, node_opcua_assert_1.assert)(instance.typeDefinition.toString() === this.nodeId.toString());
        instance.install_extra_properties();
        if (this._postInstantiateFunc) {
          this._postInstantiateFunc(instance, this);
        }
        return instance;
      }
      getBasicDataType() {
        return (0, get_basic_datatype_1._getBasicDataType)(this);
      }
    };
    exports2.UAVariableTypeImpl = UAVariableTypeImpl;
    function hasChildWithBrowseName(parent, childBrowseName) {
      if (!parent) {
        throw Error("Internal error");
      }
      const children = parent.findReferencesAsObject("HasChild", true);
      return children.filter((child) => {
        return child.browseName.name?.toString() === childBrowseName.name?.toString();
      }).length > 0;
    }
    function getParent(addressSpace, options) {
      const parent = options.componentOf || options.organizedBy;
      if (parent instanceof node_opcua_nodeid_1.NodeId) {
        return addressSpace.findNode(parent);
      }
      return parent;
    }
    function assertUnusedChildBrowseName(addressSpace, options) {
      const resolveOptionalObject = (node) => node ? addressSpace._coerceNode(node) || void 0 : void 0;
      options.componentOf = resolveOptionalObject(options.componentOf);
      options.organizedBy = resolveOptionalObject(options.organizedBy);
      (0, node_opcua_assert_1.assert)(!(options.componentOf && options.organizedBy));
      const parent = getParent(addressSpace, options);
      if (!parent) {
        return;
      }
      (0, node_opcua_assert_1.assert)(parent !== null && typeof parent === "object");
      if (!(parent instanceof base_node_impl_1.BaseNodeImpl)) {
        throw new Error("Invalid parent  parent is " + parent.constructor.name);
      }
      if (parent && hasChildWithBrowseName(parent, (0, node_opcua_data_model_1.coerceQualifiedName)(options.browseName))) {
        throw new Error("object " + parent.browseName.name.toString() + " have already a child with browseName " + options.browseName.toString());
      }
    }
    exports2.assertUnusedChildBrowseName = assertUnusedChildBrowseName;
  }
});

// node_modules/node-opcua-address-space/dist/src/ua_object_type_impl.js
var require_ua_object_type_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/ua_object_type_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UAObjectTypeImpl = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_data_model_2 = require_dist27();
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_variant_1 = require_dist28();
    var session_context_1 = require_session_context2();
    var base_node_impl_1 = require_base_node_impl();
    var base_node_private_1 = require_base_node_private();
    var tool_isSubtypeOf_1 = require_tool_isSubtypeOf();
    var ua_variable_type_impl_1 = require_ua_variable_type_impl();
    var _instantiate_helpers_1 = require_instantiate_helpers();
    var UAObjectTypeImpl = class _UAObjectTypeImpl extends base_node_impl_1.BaseNodeImpl {
      /**
       * returns true if the object has some opcua methods
       */
      get hasMethods() {
        return this.getMethods().length > 0;
      }
      get subtypeOf() {
        return tool_isSubtypeOf_1.get_subtypeOf.call(this);
      }
      get subtypeOfObj() {
        return tool_isSubtypeOf_1.get_subtypeOfObj.call(this);
      }
      constructor(options) {
        super(options);
        this.nodeClass = node_opcua_data_model_1.NodeClass.ObjectType;
        this.isSubtypeOf = (0, tool_isSubtypeOf_1.construct_isSubtypeOf)(_UAObjectTypeImpl);
        this.isSupertypeOf = (0, tool_isSubtypeOf_1.construct_isSubtypeOf)(_UAObjectTypeImpl);
        this.isAbstract = (0, node_opcua_utils_1.isNullOrUndefined)(options.isAbstract) ? false : options.isAbstract;
      }
      readAttribute(context, attributeId) {
        (0, node_opcua_assert_1.assert)(context instanceof session_context_1.SessionContext);
        const options = {};
        switch (attributeId) {
          case node_opcua_data_model_2.AttributeIds.IsAbstract:
            options.value = {
              dataType: node_opcua_variant_1.DataType.Boolean,
              value: !!this.isAbstract
            };
            options.statusCode = node_opcua_status_code_1.StatusCodes.Good;
            break;
          default:
            return base_node_impl_1.BaseNodeImpl.prototype.readAttribute.call(this, context, attributeId);
        }
        return new node_opcua_data_value_1.DataValue(options);
      }
      /**
       * instantiate an object of this UAObjectType
       * The instantiation takes care of object type inheritance when constructing inner properties and components.
       * @method instantiate
       * @param options
       * @param options.browseName
       * @param [options.description]
       * @param [options.organizedBy] the parent Folder holding this object
       * @param [options.componentOf] the parent Object holding this object
       * @param [options.notifierOf]
       * @param [options.eventSourceOf]
       * @param [options.optionals = [] name of the optional child to create
       * @param [options.modellingRule]
       * @param [options.encodingOf]
       *
       *
       * Note : HasComponent usage scope
       *
       *    Source          |     Destination
       * -------------------+---------------------------
       *  Object            | Object, Variable,Method
       *  ObjectType        |
       * -------------------+---------------------------
       *  DataVariable      | Variable
       *  DataVariableType  |
       */
      instantiate(options) {
        const addressSpace = this.addressSpace;
        (0, node_opcua_assert_1.assert)(!this.isAbstract, "cannot instantiate abstract UAObjectType");
        (0, node_opcua_assert_1.assert)(options, "missing option object");
        (0, node_opcua_assert_1.assert)(typeof options.browseName === "string" || options.browseName !== null && typeof options.browseName === "object", "expecting a browse name");
        (0, node_opcua_assert_1.assert)(!Object.prototype.hasOwnProperty.call(options, "propertyOf"), "an Object shall not be a PropertyOf an other object");
        (0, node_opcua_assert_1.assert)(!Object.prototype.hasOwnProperty.call(options, "optional"), "do you mean optionals ?");
        (0, ua_variable_type_impl_1.assertUnusedChildBrowseName)(addressSpace, options);
        const baseObjectType = addressSpace.findObjectType("BaseObjectType");
        (0, node_opcua_assert_1.assert)(baseObjectType, "BaseObjectType must be defined in the address space");
        const references = [];
        const copyAlsoModellingRules = (0, ua_variable_type_impl_1.topMostParentIsObjectTypeOrVariableType)(addressSpace, options);
        const opts = {
          browseName: options.browseName,
          componentOf: options.componentOf,
          displayName: options.displayName || "",
          description: options.description === void 0 ? this.description?.clone() : options.description,
          encodingOf: options.encodingOf,
          eventSourceOf: options.eventSourceOf,
          notifierOf: options.notifierOf,
          organizedBy: options.organizedBy,
          references,
          typeDefinition: this.nodeId,
          nodeId: options.nodeId,
          eventNotifier: options.eventNotifier === void 0 ? 0 : options.eventNotifier,
          modellingRule: options.modellingRule
        };
        const namespace = options.namespace || this.addressSpace.getOwnNamespace();
        const instance = namespace.addObject(opts);
        (0, _instantiate_helpers_1.initialize_properties_and_components)(instance, baseObjectType, this, copyAlsoModellingRules, options.optionals);
        (0, node_opcua_assert_1.assert)(instance.typeDefinition.toString() === this.nodeId.toString());
        instance.install_extra_properties();
        if (this._postInstantiateFunc) {
          this._postInstantiateFunc(instance, this, options);
        }
        return instance;
      }
      toString() {
        const options = new base_node_private_1.ToStringBuilder();
        base_node_private_1.UAObjectType_toString.call(this, options);
        return options.toString();
      }
    };
    exports2.UAObjectTypeImpl = UAObjectTypeImpl;
  }
});

// node_modules/node-opcua-address-space/dist/src/state_machine/finite_state_machine.js
var require_finite_state_machine = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/state_machine/finite_state_machine.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.promoteToStateMachineType = exports2.UAStateMachineTypeImpl = exports2.promoteToStateMachine = exports2.UAStateMachineImpl = exports2.getFiniteStateMachineTypeStateByName = exports2.getFiniteStateMachineTypeTransitions = exports2.getFiniteStateMachineTypeStates = exports2.UATransitionImpl = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_data_model_2 = require_dist27();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_variant_1 = require_dist28();
    var register_node_promoter_1 = require_register_node_promoter();
    var ua_object_impl_1 = require_ua_object_impl();
    var base_node_impl_1 = require_base_node_impl();
    var ua_object_type_impl_1 = require_ua_object_type_impl();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var doDebug = false;
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var UATransitionImpl = class {
    };
    exports2.UATransitionImpl = UATransitionImpl;
    function getComponentOfType(typeDef, typedefinition) {
      const get = (typeDef2) => typeDef2.getComponents().filter((cc) => {
        const c2 = cc;
        if (c2.nodeClass !== node_opcua_data_model_1.NodeClass.Object)
          return false;
        if (!c2.typeDefinitionObj || c2.typeDefinitionObj.nodeClass !== node_opcua_data_model_1.NodeClass.ObjectType) {
          return false;
        }
        return c2.typeDefinitionObj.isSubtypeOf(typedefinition);
      });
      let components_parts = get(typeDef);
      while (components_parts.length === 0 && typeDef.subtypeOfObj) {
        typeDef = typeDef.subtypeOfObj;
        components_parts = get(typeDef);
      }
      return components_parts;
    }
    var defaultPredicate = (transitions, fromState, toState) => {
      if (transitions.length === 0) {
        return null;
      }
      if (transitions.length === 1) {
        return transitions[0];
      }
      warningLog(" FromState = ", fromState.browseName.toString());
      warningLog(" ToState   = ", toState.browseName.toString());
      for (const transition of transitions) {
        warningLog("  possible transition : ", transition.browseName.toString(), " ", transition.nodeId.toString());
      }
      warningLog("warning: a duplicated FromState Reference to the same target has been found.\nPlease check your model or provide a predicate method to select which one to use");
      warningLog("fromStateNode: ", fromState.toString());
      return transitions[0];
    };
    function getFiniteStateMachineTypeStates(uaFiniteStateMachineType) {
      const addressSpace = uaFiniteStateMachineType.addressSpace;
      const initialStateType = addressSpace.findObjectType("InitialStateType");
      if (!initialStateType) {
        throw new Error("cannot find InitialStateType");
      }
      const stateType = addressSpace.findObjectType("StateType");
      if (!stateType) {
        throw new Error("cannot find StateType");
      }
      (0, node_opcua_assert_1.assert)(initialStateType.isSubtypeOf(stateType));
      const comp = getComponentOfType(uaFiniteStateMachineType, stateType);
      return comp;
    }
    exports2.getFiniteStateMachineTypeStates = getFiniteStateMachineTypeStates;
    function getFiniteStateMachineTypeTransitions(uaFiniteStateMachineType) {
      const addressSpace = uaFiniteStateMachineType.addressSpace;
      const transitionType = addressSpace.findObjectType("TransitionType");
      if (!transitionType) {
        throw new Error("cannot find TransitionType");
      }
      const comp = getComponentOfType(uaFiniteStateMachineType, transitionType);
      return comp;
    }
    exports2.getFiniteStateMachineTypeTransitions = getFiniteStateMachineTypeTransitions;
    function getFiniteStateMachineTypeStateByName(uaFiniteStateMachineType, stateName) {
      let states = getFiniteStateMachineTypeStates(uaFiniteStateMachineType);
      states = states.filter((s) => {
        return s.browseName.name === stateName;
      });
      (0, node_opcua_assert_1.assert)(states.length <= 1);
      return states.length === 1 ? states[0] : null;
    }
    exports2.getFiniteStateMachineTypeStateByName = getFiniteStateMachineTypeStateByName;
    var UAStateMachineImpl = class extends ua_object_impl_1.UAObjectImpl {
      getStates() {
        const typeDef = this.typeDefinitionObj;
        return getFiniteStateMachineTypeStates(typeDef);
      }
      get states() {
        return this.getStates();
      }
      /**
       * @method getStateByName
       * @param name  the name of the state to get
       * @return the state with the given name
       */
      getStateByName(name) {
        return getFiniteStateMachineTypeStateByName(this.typeDefinitionObj, name);
      }
      getTransitions() {
        const typeDef = this.typeDefinitionObj;
        return getFiniteStateMachineTypeTransitions(typeDef);
      }
      get transitions() {
        return this.getTransitions();
      }
      /**
       * return the node InitialStateType
       * @property initialState
       */
      get initialState() {
        const addressSpace = this.addressSpace;
        const initialStateType = addressSpace.findObjectType("InitialStateType");
        const typeDef = this.typeDefinitionObj;
        const comp = getComponentOfType(typeDef, initialStateType);
        if (comp.length > 1) {
          throw new Error(" More than 1 initial state in stateMachine");
        }
        return comp.length === 0 ? null : comp[0];
      }
      /**
       *
       * @param node
       * @private
       */
      _coerceNode(node) {
        if (node instanceof base_node_impl_1.BaseNodeImpl) {
          return node;
        } else if (node instanceof node_opcua_nodeid_1.NodeId) {
          const addressSpace = this.addressSpace;
          return addressSpace.findNode(node);
        } else if (typeof node === "string") {
          return this.getStateByName(node);
        }
        return null;
      }
      /**
       * @method isValidTransition
       * @param toStateNode
       * @return {boolean}
       */
      isValidTransition(toStateNode, predicate) {
        if (!this.currentStateNode) {
          return true;
        }
        const n = this.currentState.readValue();
        const transition = this.findTransitionNode(this.currentStateNode, toStateNode, predicate);
        if (!transition) {
          if (doDebug) {
            debugLog(" No transition from ", this.currentStateNode.browseName.toString(), " to ", toStateNode.toString());
          }
          return false;
        }
        return true;
      }
      /**
       */
      findTransitionNode(fromStateNode, toStateNode, predicate) {
        const addressSpace = this.addressSpace;
        const _fromStateNode = this._coerceNode(fromStateNode);
        if (!_fromStateNode) {
          return null;
        }
        const _toStateNode = this._coerceNode(toStateNode);
        if (!_toStateNode) {
          return null;
        }
        if (_fromStateNode.nodeClass !== node_opcua_data_model_1.NodeClass.Object) {
          throw new Error("Internal Error");
        }
        if (_toStateNode && _toStateNode.nodeClass !== node_opcua_data_model_1.NodeClass.Object) {
          throw new Error("Internal Error");
        }
        const stateType = addressSpace.findObjectType("StateType");
        if (!stateType) {
          throw new Error("Cannot find StateType");
        }
        (0, node_opcua_assert_1.assert)(_fromStateNode.typeDefinitionObj.isSubtypeOf(stateType));
        (0, node_opcua_assert_1.assert)(_toStateNode.typeDefinitionObj.isSubtypeOf(stateType));
        let transitions = _fromStateNode.findReferencesAsObject("FromState", false);
        transitions = transitions.filter((transition) => {
          (0, node_opcua_assert_1.assert)(transition.toStateNode.nodeClass === node_opcua_data_model_1.NodeClass.Object);
          return transition.toStateNode === _toStateNode;
        });
        if (transitions.length === 0) {
          return null;
        }
        if (transitions.length > 1) {
          const selectedTransition = (predicate || defaultPredicate)(transitions, _fromStateNode, _toStateNode);
          return selectedTransition;
        }
        return transitions[0];
      }
      get currentStateNode() {
        return this._currentStateNode;
      }
      /**
       * @property currentStateNode
       * @type BaseNode
       */
      set currentStateNode(value) {
        this._currentStateNode = value;
      }
      /**
       */
      getCurrentState() {
        if (!this.currentStateNode) {
          return null;
        }
        return this.currentStateNode.browseName.toString();
      }
      /**
       * @method setState
       */
      setState(toStateNode, predicate) {
        if (!toStateNode) {
          this.currentStateNode = null;
          this.currentState.setValueFromSource({ dataType: node_opcua_variant_1.DataType.LocalizedText, value: null }, node_opcua_status_code_1.StatusCodes.BadStateNotActive);
          return;
        }
        if (typeof toStateNode === "string") {
          const state = this.getStateByName(toStateNode);
          if (!state) {
            throw new Error("Cannot find state with name " + toStateNode);
          }
          toStateNode = state;
        }
        const fromStateNode = this.currentStateNode;
        toStateNode = this._coerceNode(toStateNode);
        (0, node_opcua_assert_1.assert)(toStateNode.nodeClass === node_opcua_data_model_1.NodeClass.Object);
        this.currentState.setValueFromSource({
          dataType: node_opcua_variant_1.DataType.LocalizedText,
          value: (0, node_opcua_data_model_1.coerceLocalizedText)(toStateNode.displayName[0] || toStateNode.browseName.name)
        }, node_opcua_status_code_1.StatusCodes.Good);
        this.currentStateNode = toStateNode;
        const applyCurrentStateOptionalProps = () => {
          const uaId = this.currentState.getPropertyByName("Id");
          if (uaId) {
            uaId.setValueFromSource({
              dataType: node_opcua_variant_1.DataType.NodeId,
              value: this.currentStateNode ? this.currentStateNode.nodeId : node_opcua_nodeid_1.NodeId.nullNodeId
            });
          }
          const uaName = this.currentState.getPropertyByName("Name");
          if (uaName) {
            uaName.setValueFromSource({
              dataType: node_opcua_variant_1.DataType.QualifiedName,
              value: this.currentStateNode ? this.currentStateNode.browseName : (0, node_opcua_data_model_1.coerceQualifiedName)("")
            });
          }
          const uaNumber = this.currentState.getPropertyByName("Number");
          if (uaNumber) {
            if (!this.currentStateNode) {
              const n = uaNumber.setValueFromSource({
                dataType: node_opcua_variant_1.DataType.UInt32,
                value: 0
                // may be wrong !
              });
            } else {
              const n = uaNumber.setValueFromSource({
                dataType: node_opcua_variant_1.DataType.UInt32,
                value: this.currentStateNode.stateNumber.readValue().value.value
              });
            }
          }
          const uaEffectiveDisplayName = this.currentState.getPropertyByName("EffectiveDisplayName");
          if (uaEffectiveDisplayName) {
            uaEffectiveDisplayName.setValueFromSource({
              dataType: node_opcua_variant_1.DataType.LocalizedText,
              value: (0, node_opcua_data_model_1.coerceLocalizedText)(this.currentStateNode ? this.currentStateNode.displayName[0] || this.currentStateNode.browseName.name : "")
            });
          }
        };
        applyCurrentStateOptionalProps();
        const transitionTime = /* @__PURE__ */ new Date();
        const applyTransitionOptionalPropsPhase1 = () => {
          const ms = this.findReferencesExAsObject("Aggregates", node_opcua_data_model_1.BrowseDirection.Inverse)[0];
          if (!ms)
            return;
          if (ms.nodeClass !== node_opcua_data_model_1.NodeClass.Object)
            return;
          const stateMachineType = this.addressSpace.findObjectType("StateMachineType");
          if (!ms.typeDefinitionObj.isSubtypeOf(stateMachineType))
            return;
          const find = (node, browseName) => {
            const r = node.getAggregates().filter((x2) => x2.browseName.name === browseName.name && x2.namespaceIndex === browseName.namespaceIndex);
            if (r.length === 0) {
              const subType = node.subtypeOfObj;
              if (subType) {
                return find(subType, browseName);
              }
              return null;
            } else {
              const retVal = r[0];
              if (retVal.nodeClass !== node_opcua_data_model_1.NodeClass.Variable && retVal.nodeClass !== node_opcua_data_model_1.NodeClass.Object) {
                throw new Error("find: expecting only object and variable here");
              }
              return retVal;
            }
          };
          const stateMachineInType = find(ms.typeDefinitionObj, this.browseName);
          if (!stateMachineInType)
            return;
          const mainState = stateMachineInType.findReferencesAsObject("HasSubStateMachine", false)[0];
          if (mainState) {
            if (!ms.currentStateNode || !(0, node_opcua_nodeid_1.sameNodeId)(mainState.nodeId, ms.currentStateNode.nodeId)) {
              return;
            }
            const uaLastTransitionMain = ms.getComponentByName("LastTransition");
            if (uaLastTransitionMain) {
              const uaEffectiveTransitionTimeMain = uaLastTransitionMain.getPropertyByName("EffectiveTransitionTime");
              if (uaEffectiveTransitionTimeMain) {
                uaEffectiveTransitionTimeMain.setValueFromSource({
                  dataType: node_opcua_variant_1.DataType.DateTime,
                  value: transitionTime
                });
              }
            }
          }
        };
        applyTransitionOptionalPropsPhase1();
        const transitionNode = this.findTransitionNode(fromStateNode, toStateNode, predicate);
        if (transitionNode) {
          const applyLastTransitionOptionalProps = () => {
            const uaLastTransition = this.getComponentByName("LastTransition");
            if (uaLastTransition) {
              uaLastTransition.setValueFromSource({
                dataType: node_opcua_variant_1.DataType.LocalizedText,
                value: transitionNode.displayName[0] || transitionNode.browseName.name
              }, node_opcua_status_code_1.StatusCodes.Good, transitionTime);
              const uaId = uaLastTransition.getPropertyByName("Id");
              if (uaId) {
                uaId.setValueFromSource({
                  dataType: node_opcua_variant_1.DataType.NodeId,
                  value: transitionNode.nodeId
                });
              }
              const uaLastTransitionTime = uaLastTransition.getPropertyByName("TransitionTime");
              if (uaLastTransitionTime) {
                uaLastTransitionTime.setValueFromSource({
                  dataType: node_opcua_variant_1.DataType.DateTime,
                  value: transitionTime
                });
              }
              const uaEffectiveTransitionTime = uaLastTransition.getPropertyByName("EffectiveTransitionTime");
              if (uaEffectiveTransitionTime) {
                uaEffectiveTransitionTime.setValueFromSource({
                  dataType: node_opcua_variant_1.DataType.DateTime,
                  value: transitionTime
                });
              }
              const uaName = uaLastTransition.getPropertyByName("Name");
              if (uaName) {
                uaName.setValueFromSource({
                  dataType: node_opcua_variant_1.DataType.QualifiedName,
                  value: transitionNode.browseName
                });
              }
              const uaNumber = uaLastTransition.getPropertyByName("Number");
              if (uaNumber) {
                uaNumber.setValueFromSource({
                  dataType: node_opcua_variant_1.DataType.UInt32,
                  value: transitionNode.transitionNumber.readValue().value.value
                });
              }
            }
          };
          applyLastTransitionOptionalProps();
          this.raiseEvent("TransitionEventType", {
            // Base EventType
            // xx nodeId:      this.nodeId,
            // TransitionEventType
            // TransitionVariableType
            transition: {
              dataType: "LocalizedText",
              value: transitionNode.displayName[0]
            },
            "transition.id": transitionNode.transitionNumber.readValue().value,
            fromState: {
              dataType: "LocalizedText",
              value: fromStateNode ? fromStateNode.displayName[0] : ""
            },
            // StateVariableType
            "fromState.id": fromStateNode ? fromStateNode.stateNumber.readValue().value : {
              dataType: "Null"
            },
            toState: {
              dataType: "LocalizedText",
              value: toStateNode.displayName[0]
            },
            // StateVariableType
            "toState.id": toStateNode.stateNumber.readValue().value
          });
        } else {
          if (fromStateNode && fromStateNode !== toStateNode) {
            if (doDebug) {
              const f2 = fromStateNode.browseName.toString();
              const t = toStateNode.browseName.toString();
              warningLog(chalk_1.default.red("Warning"), " cannot raise event :  transition " + f2 + " to " + t + " is missing");
            }
          }
        }
        for (const method of this.getMethods()) {
          method._notifyAttributeChange(node_opcua_data_model_2.AttributeIds.Executable);
        }
      }
      /**
       * @internal
       * @private|
       */
      _post_initialize() {
        const addressSpace = this.addressSpace;
        const finiteStateMachineType = addressSpace.findObjectType("FiniteStateMachineType");
        if (!finiteStateMachineType) {
          throw new Error("cannot find FiniteStateMachineType");
        }
        const d2 = this.currentState.readValue();
        if (d2.statusCode.isNotGood()) {
          this.setState(null);
        } else {
          const txt = d2.value && d2.value.value ? d2.value.value.text ? d2.value.value.text.toString() : d2.value.value.toString() : "";
          this.currentStateNode = this.getStateByName(txt);
        }
        const uaAvailableStates = this.getComponentByName("AvailableStates", 0);
        if (uaAvailableStates) {
          uaAvailableStates.bindVariable({
            get: () => {
              return new node_opcua_variant_1.Variant({
                arrayType: node_opcua_variant_1.VariantArrayType.Array,
                dataType: node_opcua_variant_1.DataType.NodeId,
                value: this.getStates().map((state) => state.nodeId)
              });
            }
          }, true);
        }
        const uaAvailableTransitions = this.getComponentByName("AvailableTransitions", 0);
        if (uaAvailableTransitions) {
          uaAvailableTransitions.bindVariable({
            get: () => {
              return new node_opcua_variant_1.Variant({
                arrayType: node_opcua_variant_1.VariantArrayType.Array,
                dataType: node_opcua_variant_1.DataType.NodeId,
                value: this.getTransitions().map((state) => state.nodeId)
              });
            }
          }, true);
        }
      }
    };
    exports2.UAStateMachineImpl = UAStateMachineImpl;
    function promoteToStateMachine(node) {
      if (node instanceof UAStateMachineImpl) {
        return node;
      }
      Object.setPrototypeOf(node, UAStateMachineImpl.prototype);
      (0, node_opcua_assert_1.assert)(node instanceof UAStateMachineImpl, "should now  be a State Machine");
      const _node = node;
      _node._post_initialize();
      return _node;
    }
    exports2.promoteToStateMachine = promoteToStateMachine;
    (0, register_node_promoter_1.registerNodePromoter)(node_opcua_constants_1.ObjectTypeIds.FiniteStateMachineType, promoteToStateMachine);
    var UAStateMachineTypeImpl = class extends ua_object_type_impl_1.UAObjectTypeImpl {
      getStateByName(name) {
        return getFiniteStateMachineTypeStateByName(this, name);
      }
      getStates() {
        return getFiniteStateMachineTypeStates(this);
      }
      getTransitions() {
        return getFiniteStateMachineTypeTransitions(this);
      }
      _post_initialize() {
      }
    };
    exports2.UAStateMachineTypeImpl = UAStateMachineTypeImpl;
    function promoteToStateMachineType(node) {
      if (node instanceof UAStateMachineTypeImpl) {
        return node;
      }
      Object.setPrototypeOf(node, UAStateMachineTypeImpl.prototype);
      (0, node_opcua_assert_1.assert)(node instanceof UAStateMachineTypeImpl, "should now  be a State Machine");
      const _node = node;
      _node._post_initialize();
      return _node;
    }
    exports2.promoteToStateMachineType = promoteToStateMachineType;
  }
});

// node_modules/node-opcua-address-space/dist/src/state_machine/ua_shelving_state_machine_ex.js
var require_ua_shelving_state_machine_ex = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/state_machine/ua_shelving_state_machine_ex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2._clear_timer_if_any = exports2.UAShelvedStateMachineExImpl = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_data_value_1 = require_dist29();
    var ua_alarm_condition_impl_1 = require_ua_alarm_condition_impl();
    var finite_state_machine_1 = require_finite_state_machine();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var UAShelvedStateMachineExImpl = class _UAShelvedStateMachineExImpl extends finite_state_machine_1.UAStateMachineImpl {
      static promote(object) {
        const shelvingState = object;
        (0, finite_state_machine_1.promoteToStateMachine)(shelvingState);
        Object.setPrototypeOf(shelvingState, _UAShelvedStateMachineExImpl.prototype);
        shelvingState._timer = null;
        if (shelvingState.unshelve) {
          shelvingState.unshelve.bindMethod(_unshelve_method);
        }
        if (shelvingState.timedShelve) {
          shelvingState.timedShelve.bindMethod(_timedShelve_method);
        }
        if (shelvingState.oneShotShelve) {
          shelvingState.oneShotShelve.bindMethod(_oneShotShelve_method);
        }
        if (shelvingState.unshelveTime) {
          shelvingState.unshelveTime.minimumSamplingInterval = 500;
          shelvingState.unshelveTime.bindVariable({
            timestamped_get: _unShelveTimeFunc.bind(null, shelvingState)
          }, true);
        }
        (0, node_opcua_assert_1.assert)(shelvingState instanceof _UAShelvedStateMachineExImpl);
        return shelvingState;
      }
    };
    exports2.UAShelvedStateMachineExImpl = UAShelvedStateMachineExImpl;
    function _unshelve_method(inputArguments, context, callback) {
      (0, node_opcua_assert_1.assert)(inputArguments.length === 0);
      const shelvingState = context.object;
      (0, finite_state_machine_1.promoteToStateMachine)(shelvingState);
      if (shelvingState.getCurrentState() === "Unshelved") {
        return callback(null, {
          statusCode: node_opcua_status_code_1.StatusCodes.BadConditionNotShelved
        });
      }
      shelvingState.setState("Unshelved");
      shelvingState._unsheveldTime = /* @__PURE__ */ new Date();
      _clear_timer_if_any(shelvingState);
      (0, node_opcua_assert_1.assert)(!shelvingState._timer);
      return callback(null, {
        statusCode: node_opcua_status_code_1.StatusCodes.Good
      });
    }
    function _clear_timer_if_any(shelvingState) {
      if (shelvingState._timer) {
        clearTimeout(shelvingState._timer);
        shelvingState._timer = null;
      }
    }
    exports2._clear_timer_if_any = _clear_timer_if_any;
    function _automatically_unshelve(shelvingState) {
      (0, node_opcua_assert_1.assert)(shelvingState._timer, "expecting timerId to be set");
      shelvingState._timer = null;
      if (doDebug) {
        debugLog("Automatically unshelving variable ", shelvingState.browseName.toString());
      }
      if (shelvingState.getCurrentState() === "Unshelved") {
        return;
      }
      shelvingState.setState("Unshelved");
      shelvingState._unshelvedTime = /* @__PURE__ */ new Date();
      (0, node_opcua_assert_1.assert)(!shelvingState._timer);
    }
    function _start_timer_for_automatic_unshelve(shelvingState, duration) {
      if (duration < 10 || duration >= Math.pow(2, 31)) {
        throw new Error(" Invalid maxTimeShelved duration: " + duration + "  must be [10,2**31] ");
      }
      (0, node_opcua_assert_1.assert)(!shelvingState._timer);
      shelvingState._sheveldTime = /* @__PURE__ */ new Date();
      shelvingState._duration = duration;
      if (doDebug) {
        debugLog("shelvingState._duration", shelvingState._duration);
      }
      if (duration !== ua_alarm_condition_impl_1.UAAlarmConditionImpl.MaxDuration) {
        (0, node_opcua_assert_1.assert)(!shelvingState._timer);
        shelvingState._timer = setTimeout(_automatically_unshelve.bind(null, shelvingState), shelvingState._duration);
      }
    }
    function _timedShelve_method(inputArguments, context, callback) {
      (0, node_opcua_assert_1.assert)(inputArguments.length === 1);
      if (!context.object) {
        return;
      }
      const shelvingState = context.object;
      if (shelvingState.getCurrentState() !== "Unshelved") {
        return callback(null, {
          statusCode: node_opcua_status_code_1.StatusCodes.BadConditionAlreadyShelved
        });
      }
      const alarmNode = shelvingState.parent;
      if (!(alarmNode instanceof ua_alarm_condition_impl_1.UAAlarmConditionImpl)) {
        return callback(null, {
          statusCode: node_opcua_status_code_1.StatusCodes.BadNodeIdInvalid
        });
      }
      const maxTimeShelved = alarmNode.getMaxTimeShelved();
      (0, node_opcua_assert_1.assert)(isFinite(maxTimeShelved));
      (0, node_opcua_assert_1.assert)(inputArguments[0].dataType === node_opcua_variant_1.DataType.Double);
      (0, node_opcua_assert_1.assert)(inputArguments[0] instanceof node_opcua_variant_1.Variant);
      const proposedDuration = inputArguments[0].value;
      if (proposedDuration > maxTimeShelved) {
        return callback(null, {
          statusCode: node_opcua_status_code_1.StatusCodes.BadShelvingTimeOutOfRange
        });
      }
      if (proposedDuration < 0) {
        return callback(null, {
          statusCode: node_opcua_status_code_1.StatusCodes.BadShelvingTimeOutOfRange
        });
      }
      _clear_timer_if_any(shelvingState);
      shelvingState.setState("TimedShelved");
      _start_timer_for_automatic_unshelve(shelvingState, proposedDuration);
      return callback(null, {
        statusCode: node_opcua_status_code_1.StatusCodes.Good
      });
    }
    function _oneShotShelve_method(inputArguments, context, callback) {
      (0, node_opcua_assert_1.assert)(inputArguments.length === 0);
      const shelvingState = context.object;
      if (shelvingState.getCurrentState() === "OneShotShelved") {
        return callback(null, {
          statusCode: node_opcua_status_code_1.StatusCodes.BadConditionAlreadyShelved
        });
      }
      const alarmNode = shelvingState.parent;
      if (!(alarmNode instanceof ua_alarm_condition_impl_1.UAAlarmConditionImpl)) {
        return callback(null, {
          statusCode: node_opcua_status_code_1.StatusCodes.BadNodeIdInvalid
        });
      }
      const maxTimeShelved = alarmNode.getMaxTimeShelved();
      (0, node_opcua_assert_1.assert)(isFinite(maxTimeShelved));
      (0, node_opcua_assert_1.assert)(maxTimeShelved !== ua_alarm_condition_impl_1.UAAlarmConditionImpl.MaxDuration);
      _clear_timer_if_any(shelvingState);
      shelvingState.setState("OneShotShelved");
      _start_timer_for_automatic_unshelve(shelvingState, maxTimeShelved);
      return callback(null, {
        statusCode: node_opcua_status_code_1.StatusCodes.Good
      });
    }
    function _unShelveTimeFunc(shelvingState) {
      if (shelvingState.getCurrentState() === "Unshelved") {
        return new node_opcua_data_value_1.DataValue({
          statusCode: node_opcua_status_code_1.StatusCodes.BadConditionNotShelved,
          value: { dataType: node_opcua_variant_1.DataType.Double, value: 0 }
        });
      }
      if (!shelvingState._sheveldTime) {
        return new node_opcua_data_value_1.DataValue({
          statusCode: node_opcua_status_code_1.StatusCodes.BadConditionNotShelved,
          value: { dataType: node_opcua_variant_1.DataType.Double, value: 0 }
        });
      }
      if (shelvingState.getCurrentState() === "OneShotShelved" && shelvingState._duration === ua_alarm_condition_impl_1.UAAlarmConditionImpl.MaxDuration) {
        return new node_opcua_data_value_1.DataValue({
          statusCode: node_opcua_status_code_1.StatusCodes.Good,
          value: {
            dataType: node_opcua_variant_1.DataType.Double,
            value: ua_alarm_condition_impl_1.UAAlarmConditionImpl.MaxDuration
          }
        });
      }
      const now = /* @__PURE__ */ new Date();
      let timeToAutomaticUnshelvedState = shelvingState._duration - (now.getTime() - shelvingState._sheveldTime.getTime());
      timeToAutomaticUnshelvedState = Math.max(timeToAutomaticUnshelvedState, 0);
      return new node_opcua_data_value_1.DataValue({
        statusCode: node_opcua_status_code_1.StatusCodes.Good,
        value: {
          dataType: node_opcua_variant_1.DataType.Double,
          // duration
          value: timeToAutomaticUnshelvedState
        }
      });
    }
  }
});

// node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_alarm_condition_impl.js
var require_ua_alarm_condition_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_alarm_condition_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UAAlarmConditionImpl = void 0;
    var lodash_1 = require_lodash2();
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_debug_1 = require_dist24();
    var ua_two_state_variable_1 = require_ua_two_state_variable();
    var ua_shelving_state_machine_ex_1 = require_ua_shelving_state_machine_ex();
    var condition_info_impl_1 = require_condition_info_impl();
    var ua_acknowledgeable_condition_impl_1 = require_ua_acknowledgeable_condition_impl();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    function _update_suppressedOrShelved(alarmNode) {
      alarmNode.suppressedOrShelved.setValueFromSource({
        dataType: node_opcua_variant_1.DataType.Boolean,
        value: alarmNode.isSuppressedOrShelved()
      });
    }
    var UAAlarmConditionImpl = class _UAAlarmConditionImpl extends ua_acknowledgeable_condition_impl_1.UAAcknowledgeableConditionImpl {
      static instantiate(namespace, alarmConditionTypeId, options, data) {
        const addressSpace = namespace.addressSpace;
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "inputNode"));
        const alarmConditionType = addressSpace.findEventType(alarmConditionTypeId);
        if (!alarmConditionType) {
          throw new Error(" cannot find Alarm Condition Type for " + alarmConditionTypeId);
        }
        const alarmConditionTypeBase = addressSpace.findEventType("AlarmConditionType");
        if (!alarmConditionTypeBase) {
          throw new Error("cannot find AlarmConditionType");
        }
        options.optionals = options.optionals || [];
        if (Object.prototype.hasOwnProperty.call(options, "maxTimeShelved")) {
          options.optionals.push("MaxTimeShelved");
          (0, node_opcua_assert_1.assert)(isFinite(options.maxTimeShelved));
        }
        (0, node_opcua_assert_1.assert)(alarmConditionTypeBase === alarmConditionType || alarmConditionType.isSubtypeOf(alarmConditionTypeBase));
        const alarmNode = ua_acknowledgeable_condition_impl_1.UAAcknowledgeableConditionImpl.instantiate(namespace, alarmConditionTypeId, options, data);
        Object.setPrototypeOf(alarmNode, _UAAlarmConditionImpl.prototype);
        (0, ua_two_state_variable_1._install_TwoStateVariable_machinery)(alarmNode.activeState, {
          falseState: "Inactive",
          trueState: "Active"
        });
        alarmNode.currentBranch().setActiveState(false);
        if (alarmNode.suppressedState) {
          (0, ua_two_state_variable_1._install_TwoStateVariable_machinery)(alarmNode.suppressedState, {
            falseState: "Unsuppressed",
            trueState: "Suppressed"
          });
        }
        if (alarmNode.shelvingState) {
          ua_shelving_state_machine_ex_1.UAShelvedStateMachineExImpl.promote(alarmNode.shelvingState);
        }
        if (alarmNode.suppressedState) {
          alarmNode.suppressedState.on("value_changed", (newDataValue) => {
            _update_suppressedOrShelved(alarmNode);
          });
        }
        if (alarmNode.shelvingState) {
          alarmNode.shelvingState.currentState.on("value_changed", (newDataValue) => {
            _update_suppressedOrShelved(alarmNode);
          });
        }
        _update_suppressedOrShelved(alarmNode);
        if (alarmNode.maxTimeShelved) {
          options.maxTimeShelved = options.maxTimeShelved || 60 * 1e3;
          alarmNode.maxTimeShelved.setValueFromSource({
            dataType: "Duration",
            value: options.maxTimeShelved
          });
        }
        (0, node_opcua_assert_1.assert)(options.inputNode, " must provide options.inputNode (NodeId or BaseNode object)");
        alarmNode.installInputNodeMonitoring(options.inputNode);
        (0, node_opcua_assert_1.assert)(alarmNode instanceof ua_acknowledgeable_condition_impl_1.UAAcknowledgeableConditionImpl);
        (0, node_opcua_assert_1.assert)(alarmNode instanceof _UAAlarmConditionImpl);
        return alarmNode;
      }
      dispose() {
        if (this.shelvingState) {
          (0, ua_shelving_state_machine_ex_1._clear_timer_if_any)(this.shelvingState);
        }
        super.dispose();
      }
      activateAlarm() {
        const branch = this.currentBranch();
        if (!branch) {
          return;
        }
        branch.setRetain(true);
        branch.setActiveState(true);
        branch.setAckedState(false);
      }
      deactivateAlarm(retain) {
        const branch = this.currentBranch();
        if (!branch) {
          return;
        }
        branch.setRetain(retain === void 0 ? true : retain);
        branch.setActiveState(false);
      }
      /**
       * @deprecated use deactivateAlarm instead (with no s after de-activate)
       */
      desactivateAlarm() {
        this.deactivateAlarm();
      }
      isSuppressedOrShelved() {
        let suppressed = false;
        if (this.suppressedState) {
          suppressed = this.suppressedState.id.readValue().value.value;
        }
        let shelved = false;
        if (this.shelvingState) {
          const shelvedValue = this.shelvingState.currentState.readValue().value.value;
          if (shelvedValue && shelvedValue.text !== "Unshelved") {
            shelved = true;
          }
        }
        return suppressed || shelved;
      }
      getSuppressedOrShelved() {
        return this.suppressedOrShelved.readValue().value.value;
      }
      /**
       *
       * note: duration must be greater than 10ms and lesser than 2**31 ms
       */
      setMaxTimeShelved(duration) {
        if (duration < 10 || duration >= Math.pow(2, 31)) {
          throw new Error(" Invalid maxTimeShelved duration: " + duration + "  must be [10,2**31] ");
        }
        this.maxTimeShelved?.setValueFromSource({
          dataType: "Duration",
          // <= Duration is basic Type Double! ( milliseconds)
          value: duration
        });
      }
      /**
       * note: return a  Duration
       */
      getMaxTimeShelved() {
        if (!this.maxTimeShelved) {
          (0, node_opcua_assert_1.assert)(_UAAlarmConditionImpl.MaxDuration <= 2147483648, "MaxDuration cannot be greater than 2**31");
          return _UAAlarmConditionImpl.MaxDuration;
        }
        const dataValue = this.maxTimeShelved.readValue();
        (0, node_opcua_assert_1.assert)(dataValue.value.dataType === node_opcua_variant_1.DataType.Double);
        return dataValue.value.value;
      }
      /**
       * @method getInputNodeNode
       * @return {BaseNode} return the node in the address space pointed by the inputNode value
       *
       * Note: please note the difference between alarm.inputNode
       *    *  alarm.inputNode is a UAVariable property of the alarm object holding the nodeid of the input
       *       node in its value.
       *    *  getInputNodeNode() is the UAVariable that contains the value that affects the state of the alarm and
       *       whose node id is stored in alarm.inputNode
       */
      getInputNodeNode() {
        const nodeId = this.inputNode.readValue().value.value;
        (0, node_opcua_assert_1.assert)(nodeId instanceof node_opcua_nodeid_1.NodeId || nodeId === null);
        return this.addressSpace.findNode(nodeId);
      }
      /**
       * @method getInputNodeValue
       * @return {*}
       */
      getInputNodeValue() {
        const node = this.getInputNodeNode();
        if (!node) {
          return null;
        }
        (0, node_opcua_assert_1.assert)(node.nodeClass === node_opcua_data_model_1.NodeClass.Variable);
        return node.readValue().value.value;
      }
      updateState() {
        const node = this.getInputNodeNode();
        const dataValue = node.readValue();
        this._onInputDataValueChange(dataValue);
      }
      _onInputDataValueChange(newValue) {
      }
      /**
       * @method installInputNodeMonitoring
       * install mechanism that listen to input node datavalue changes so that alarm status
       * can be automatically updated appropriatly.
       * @param inputNode {BaseNode}
       * @return {void}
       * @protected
       */
      installInputNodeMonitoring(inputNode) {
        (0, node_opcua_assert_1.assert)(this.inputNode.nodeClass === node_opcua_data_model_1.NodeClass.Variable);
        const addressSpace = this.addressSpace;
        (0, node_opcua_assert_1.assert)(inputNode, " must provide options.inputNode (NodeId or BaseNode object)");
        if (inputNode instanceof node_opcua_nodeid_1.NodeId) {
          this.inputNode.setValueFromSource({
            dataType: node_opcua_variant_1.DataType.NodeId,
            value: inputNode
          });
        } else {
          this.inputNode.setValueFromSource({
            dataType: "NodeId",
            value: inputNode.nodeId
          });
          const _node = addressSpace._coerceNode(inputNode);
          if (_node === null) {
            debugLog(" cannot find nodeId ", inputNode);
          } else {
            (0, node_opcua_assert_1.assert)(_node, "Expecting a valid input node");
            this.inputNode.setValueFromSource({
              dataType: node_opcua_variant_1.DataType.NodeId,
              value: _node.nodeId
            });
          }
          const inputNode2 = this.getInputNodeNode();
          if (!inputNode2 || inputNode2 === null) {
            throw new Error("Invalid input node");
          }
          inputNode2.on("value_changed", (newDataValue) => {
            if (!this.getEnabledState()) {
              return;
            }
            this._onInputDataValueChange(newDataValue);
          });
        }
      }
      getCurrentConditionInfo() {
        const oldSeverity = this.currentBranch().getSeverity();
        const oldQuality = this.currentBranch().getQuality();
        const oldMessage = this.currentBranch().getMessage();
        const oldRetain = this.currentBranch().getRetain();
        const oldConditionInfo = new condition_info_impl_1.ConditionInfoImpl({
          message: oldMessage,
          quality: oldQuality,
          retain: oldRetain,
          severity: oldSeverity
        });
        return oldConditionInfo;
      }
      /***
       * @method  _calculateConditionInfo
       * @param stateData {Object}   the new calculated state of the alarm
       * @param isActive  {Boolean}
       * @param value     {Number}   the new value of the limit alarm
       * @param oldCondition  {ConditionInfo} given for information purpose
       * @param oldCondition.severity
       * @param oldCondition.quality
       * @param oldCondition.message
       * @param oldCondition.retain
       * @return {ConditionInfo} the new condition info
       *
       * this method need to be overridden by the instantiate to allow custom message and severity
       * to be set based on specific context of the alarm.
       *
       * @example
       *
       *
       *    var myAlarm = addressSpace.instantiateExclusiveLimitAlarm({...});
       *    myAlarm._calculateConditionInfo = function(stateName,value,oldCondition) {
       *       var percent = Math.ceil(value * 100);
       *       return new ConditionInfo({
       *            message: "Tank is almost " + percent + "% full",
       *            severity: 100,
       *            quality: StatusCodes.Good
       *      });
       *    };
       *
       */
      _calculateConditionInfo(stateData, isActive, value, oldCondition) {
        if (!stateData) {
          return new condition_info_impl_1.ConditionInfoImpl({
            message: "Back to normal",
            quality: node_opcua_status_code_1.StatusCodes.Good,
            retain: true,
            severity: 0
          });
        } else {
          return new condition_info_impl_1.ConditionInfoImpl({
            message: "Condition is " + value + " and state is " + stateData,
            quality: node_opcua_status_code_1.StatusCodes.Good,
            retain: true,
            severity: 150
          });
        }
      }
      _signalInitialCondition() {
        this.currentBranch().setActiveState(false);
        this.currentBranch().setAckedState(true);
      }
      _signalNewCondition(stateName, isActive, value) {
        (0, node_opcua_assert_1.assert)(this.getEnabledState() === true);
        const oldConditionInfo = this.getCurrentConditionInfo();
        const newConditionInfo = this._calculateConditionInfo(stateName, !!isActive, value, oldConditionInfo);
        if ((0, lodash_1.isEqual)(oldConditionInfo, newConditionInfo)) {
          debugLog("oldConditionInfo", oldConditionInfo);
          debugLog("oldConditionInfo", newConditionInfo);
          throw new Error("condition values have not change, shall we really raise an event ? alarm " + this.browseName.toString());
        }
        (0, node_opcua_assert_1.assert)(!(0, lodash_1.isEqual)(oldConditionInfo, newConditionInfo), "condition values have not change, shall we really raise an event ?");
        if (isActive) {
          this.currentBranch().setActiveState(true);
          this.currentBranch().setAckedState(false);
          this.raiseNewCondition(newConditionInfo);
        } else {
          if (this.currentBranch().getAckedState() === false) {
            if (this.currentBranch().getRetain()) {
              const newBranch = this.createBranch();
              (0, node_opcua_assert_1.assert)(!(0, node_opcua_nodeid_1.sameNodeId)(newBranch.getBranchId(), node_opcua_nodeid_1.NodeId.nullNodeId));
              this.raiseNewBranchState(newBranch);
            }
          }
          this.currentBranch().setActiveState(false);
          this.currentBranch().setAckedState(true);
          this.raiseNewCondition(newConditionInfo);
        }
      }
    };
    exports2.UAAlarmConditionImpl = UAAlarmConditionImpl;
    UAAlarmConditionImpl.MaxDuration = Math.pow(2, 31);
  }
});

// node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_discrete_alarm_impl.js
var require_ua_discrete_alarm_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_discrete_alarm_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UADiscreteAlarmImpl = void 0;
    var node_opcua_assert_1 = require_dist14();
    var ua_alarm_condition_impl_1 = require_ua_alarm_condition_impl();
    var UADiscreteAlarmImpl = class _UADiscreteAlarmImpl extends ua_alarm_condition_impl_1.UAAlarmConditionImpl {
      static instantiate(namespace, discreteAlarmTypeId, options, data) {
        const addressSpace = namespace.addressSpace;
        const discreteAlarmType = addressSpace.findEventType(discreteAlarmTypeId);
        if (!discreteAlarmType) {
          throw new Error(" cannot find Condition Type for " + discreteAlarmType);
        }
        const discreteAlarmTypeBase = addressSpace.findObjectType("DiscreteAlarmType");
        (0, node_opcua_assert_1.assert)(discreteAlarmTypeBase, "expecting DiscreteAlarmType - please check you nodeset xml file!");
        if (!discreteAlarmType.isSubtypeOf(discreteAlarmTypeBase)) {
          throw new Error("UADiscreteAlarm.instantiate : event found is not subType of DiscreteAlarmType");
        }
        const alarmNode = ua_alarm_condition_impl_1.UAAlarmConditionImpl.instantiate(namespace, discreteAlarmType.nodeId, options, data);
        Object.setPrototypeOf(alarmNode, _UADiscreteAlarmImpl.prototype);
        return alarmNode;
      }
    };
    exports2.UADiscreteAlarmImpl = UADiscreteAlarmImpl;
  }
});

// node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/deviation_alarm_helper.js
var require_deviation_alarm_helper = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/deviation_alarm_helper.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.DeviationAlarmHelper_install_setpoint = exports2.DeviationAlarmHelper_onSetpointDataValueChange = exports2.DeviationAlarmHelper_getSetpointValue = exports2.DeviationAlarmHelper_getSetpointNodeNode = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_nodeid_1 = require_dist21();
    function DeviationAlarmHelper_getSetpointNodeNode() {
      (0, node_opcua_assert_1.assert)(this.setpointNode.readValue().value.dataType === node_opcua_variant_1.DataType.NodeId);
      const nodeId = this.setpointNode.readValue().value.value;
      const node = this.addressSpace.findNode(nodeId);
      (0, node_opcua_assert_1.assert)(node === this.setpointNodeNode);
      if (!node) {
        return void 0;
      }
      return this.setpointNodeNode;
    }
    exports2.DeviationAlarmHelper_getSetpointNodeNode = DeviationAlarmHelper_getSetpointNodeNode;
    function DeviationAlarmHelper_getSetpointValue() {
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(this, "setpointNode"));
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(this, "setpointNodeNode"));
      if (!this.setpointNodeNode) {
        return null;
      }
      const setpointDataValue = this.setpointNodeNode.readValue();
      if (setpointDataValue.statusCode.isNotGood()) {
        return null;
      }
      const node = this.getSetpointNodeNode();
      if (!node) {
        return null;
      }
      return node.readValue().value.value;
    }
    exports2.DeviationAlarmHelper_getSetpointValue = DeviationAlarmHelper_getSetpointValue;
    function DeviationAlarmHelper_onSetpointDataValueChange(dataValue) {
      this._setStateBasedOnInputValue(this.getInputNodeValue());
    }
    exports2.DeviationAlarmHelper_onSetpointDataValueChange = DeviationAlarmHelper_onSetpointDataValueChange;
    function DeviationAlarmHelper_install_setpoint(options) {
      (0, node_opcua_assert_1.assert)(this.setpointNode.browseName.toString() === "SetpointNode");
      const addressSpace = this.addressSpace;
      if (options.setpointNode) {
        const setpointNodeNode = addressSpace._coerceNode(options.setpointNode);
        (0, node_opcua_assert_1.assert)(setpointNodeNode, "Expecting a valid setpoint node");
        this.setpointNodeNode = addressSpace._coerceNode(options.setpointNode);
        this.setpointNode.setValueFromSource({ dataType: "NodeId", value: this.setpointNodeNode.nodeId });
        this.setpointNodeNode.on("value_changed", (newDataValue) => {
          this._onSetpointDataValueChange(newDataValue);
        });
      } else {
        this.setpointNodeNode = void 0;
        this.setpointNode.setValueFromSource({ dataType: "NodeId", value: node_opcua_nodeid_1.NodeId.nullNodeId });
      }
    }
    exports2.DeviationAlarmHelper_install_setpoint = DeviationAlarmHelper_install_setpoint;
  }
});

// node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_limit_alarm_impl.js
var require_ua_limit_alarm_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_limit_alarm_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UALimitAlarmImpl = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_variant_1 = require_dist28();
    var ua_alarm_condition_impl_1 = require_ua_alarm_condition_impl();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)("AlarmsAndConditions");
    var uaLimitAlarmInputSupportedDataType = [
      node_opcua_variant_1.DataType.Double,
      node_opcua_variant_1.DataType.Float,
      node_opcua_variant_1.DataType.Byte,
      node_opcua_variant_1.DataType.SByte,
      node_opcua_variant_1.DataType.Int16,
      node_opcua_variant_1.DataType.Int32,
      node_opcua_variant_1.DataType.UInt16,
      node_opcua_variant_1.DataType.UInt32
    ];
    var UALimitAlarmImpl = class _UALimitAlarmImpl extends ua_alarm_condition_impl_1.UAAlarmConditionImpl {
      /**
       * @method (static)UALimitAlarm.instantiate
       * @param namespace {INamespace}
       * @param limitAlarmTypeId
       * @param options
       * @param options.inputNode
       * @param options.optionals
       * @param options.highHighLimit {Double}
       * @param options.highLimit     {Double}
       * @param options.lowLimit      {Double}
       * @param options.lowLowLimit   {Double}
       * @param data
       * @return {UALimitAlarm}
       */
      static instantiate(namespace, limitAlarmTypeId, options, data) {
        const addressSpace = namespace.addressSpace;
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "inputNode"), "UALimitAlarm.instantiate: options must provide the inputNode");
        options.optionals = options.optionals || [];
        let count = 0;
        if (Object.prototype.hasOwnProperty.call(options, "highHighLimit")) {
          options.optionals.push("HighHighLimit");
          options.optionals.push("HighHighState");
          count++;
        }
        if (Object.prototype.hasOwnProperty.call(options, "highLimit")) {
          options.optionals.push("HighLimit");
          options.optionals.push("HighState");
          count++;
        }
        if (Object.prototype.hasOwnProperty.call(options, "lowLimit")) {
          options.optionals.push("LowLimit");
          options.optionals.push("LowState");
          count++;
        }
        if (Object.prototype.hasOwnProperty.call(options, "lowLowLimit")) {
          options.optionals.push("LowLowLimit");
          options.optionals.push("LowLowState");
          count++;
        }
        const alarmNode = ua_alarm_condition_impl_1.UAAlarmConditionImpl.instantiate(namespace, limitAlarmTypeId, options, data);
        Object.setPrototypeOf(alarmNode, _UALimitAlarmImpl.prototype);
        (0, node_opcua_assert_1.assert)(alarmNode.conditionOfNode() !== null);
        const inputNode = addressSpace._coerceNode(options.inputNode);
        if (!inputNode) {
          throw new Error("Expecting a valid input node");
        }
        (0, node_opcua_assert_1.assert)(inputNode.nodeClass === node_opcua_data_model_1.NodeClass.Variable);
        if (count === 0) {
          throw new Error("at least one limit is required");
        }
        const dataType = addressSpace.findCorrespondingBasicDataType(options.inputNode.dataType);
        if (-1 === uaLimitAlarmInputSupportedDataType.indexOf(dataType)) {
          const message = `UALimitAlarm.instantiate: inputNode must be of type ${uaLimitAlarmInputSupportedDataType.map((a) => node_opcua_variant_1.DataType[a]).join("|")}, got ${node_opcua_variant_1.DataType[dataType]}`;
          warningLog(message);
          throw new Error(message);
        }
        if (Object.prototype.hasOwnProperty.call(options, "highHighLimit") && options.highHighLimit !== void 0) {
          alarmNode.setHighHighLimit(options.highHighLimit);
        }
        if (Object.prototype.hasOwnProperty.call(options, "highLimit")) {
          alarmNode.setHighLimit(options.highLimit);
        }
        if (Object.prototype.hasOwnProperty.call(options, "lowLimit")) {
          alarmNode.setLowLimit(options.lowLimit);
        }
        if (Object.prototype.hasOwnProperty.call(options, "lowLowLimit") && options.lowLowLimit != void 0) {
          alarmNode.setLowLowLimit(options.lowLowLimit);
        }
        (0, node_opcua_assert_1.assert)(alarmNode.inputNode.nodeClass === node_opcua_data_model_1.NodeClass.Variable);
        alarmNode.inputNode.setValueFromSource({ dataType: "NodeId", value: inputNode.nodeId });
        alarmNode.installInputNodeMonitoring(options.inputNode);
        alarmNode._watchLimits();
        return alarmNode;
      }
      /**
       * @method getHighHighLimit
       * @return {Number}
       */
      getHighHighLimit() {
        if (!this.highHighLimit) {
          throw new Error("Alarm do not expose highHighLimit");
        }
        return this.highHighLimit.readValue().value.value;
      }
      /**
       * @method getHighLimit
       * @return {Number}
       */
      getHighLimit() {
        if (!this.highLimit) {
          throw new Error("Alarm do not expose highLimit");
        }
        return this.highLimit.readValue().value.value;
      }
      /**
       * @method getLowLimit
       * @return {Float}
       */
      getLowLimit() {
        if (!this.lowLimit) {
          throw new Error("Alarm do not expose lowLimit");
        }
        return this.lowLimit.readValue().value.value;
      }
      /**
       * @method getLowLowLimit
       * @return {Float}
       */
      getLowLowLimit() {
        if (!this.lowLowLimit) {
          throw new Error("Alarm do not expose lowLowLimit");
        }
        return this.lowLowLimit.readValue().value.value;
      }
      /**
       * @method setHighHighLimit
       * @param value {Float}
       */
      setHighHighLimit(value) {
        if (!this.highHighLimit) {
          throw new Error("LimitAlarm instance must expose the optional HighHighLimit property");
        }
        this.highHighLimit.setValueFromSource({ dataType: node_opcua_variant_1.DataType.Double, value });
      }
      /**
       * @method setHighLimit
       * @param value {Float}
       */
      setHighLimit(value) {
        if (!this.highLimit) {
          throw new Error("LimitAlarm instance must expose the optional HighLimit property");
        }
        this.highLimit.setValueFromSource({ dataType: node_opcua_variant_1.DataType.Double, value });
      }
      /**
       * @method setLowLimit
       * @param value {Float}
       */
      setLowLimit(value) {
        if (!this.lowLimit) {
          throw new Error("LimitAlarm instance must expose the optional LowLimit property");
        }
        this.lowLimit.setValueFromSource({ dataType: node_opcua_variant_1.DataType.Double, value });
      }
      /**
       * @method setLowLowLimit
       * @param value {Float}
       */
      setLowLowLimit(value) {
        if (!this.lowLowLimit) {
          throw new Error("LimitAlarm instance must expose the optional LowLowLimit property");
        }
        this.lowLowLimit.setValueFromSource({ dataType: node_opcua_variant_1.DataType.Double, value });
      }
      _onInputDataValueChange(dataValue) {
        (0, node_opcua_assert_1.assert)(dataValue instanceof node_opcua_data_value_1.DataValue);
        if (dataValue.statusCode.equals(node_opcua_status_code_1.StatusCodes.BadWaitingForInitialData) && dataValue.statusCode.equals(node_opcua_status_code_1.StatusCodes.UncertainInitialValue)) {
          return;
        }
        if (dataValue.statusCode.isNotGood()) {
          this._signalNewCondition(null);
          return;
        }
        if (dataValue.value.dataType === node_opcua_variant_1.DataType.Null) {
          this._signalNewCondition(null);
          return;
        }
        const value = dataValue.value.value;
        this._setStateBasedOnInputValue(value);
      }
      _setStateBasedOnInputValue(value) {
        throw new Error("_setStateBasedOnInputValue must be overriden");
      }
      _watchLimits() {
        const _updateState = () => this.updateState();
        if (this.highHighLimit) {
          this.highHighLimit.on("value_changed", _updateState);
        }
        if (this.highLimit) {
          this.highLimit.on("value_changed", _updateState);
        }
        if (this.lowLimit) {
          this.lowLimit.on("value_changed", _updateState);
        }
        if (this.lowLowLimit) {
          this.lowLowLimit.on("value_changed", _updateState);
        }
      }
      evaluateConditionsAfterEnabled() {
        (0, node_opcua_assert_1.assert)(this.getEnabledState() === true);
        const input = this.getInputNodeNode();
        if (!input) {
          return;
        }
        const dataValue = input.readValue();
        this._onInputDataValueChange(dataValue);
      }
    };
    exports2.UALimitAlarmImpl = UALimitAlarmImpl;
  }
});

// node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_exclusive_limit_alarm_impl.js
var require_ua_exclusive_limit_alarm_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_exclusive_limit_alarm_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UAExclusiveLimitAlarmImpl = void 0;
    var node_opcua_assert_1 = require_dist14();
    var finite_state_machine_1 = require_finite_state_machine();
    var ua_limit_alarm_impl_1 = require_ua_limit_alarm_impl();
    var validState = ["HighHigh", "High", "Low", "LowLow", null];
    var UAExclusiveLimitAlarmImpl = class _UAExclusiveLimitAlarmImpl extends ua_limit_alarm_impl_1.UALimitAlarmImpl {
      /***
       *
       * @method (static)instantiate
       * @param namespace {INamespace}
       * @param type
       * @param options
       * @param data
       * @return {UAExclusiveLimitAlarm}
       */
      static instantiate(namespace, type, options, data) {
        const addressSpace = namespace.addressSpace;
        const exclusiveAlarmType = addressSpace.findEventType(type);
        if (!exclusiveAlarmType) {
          throw new Error(" cannot find Alarm Condition Type for " + type);
        }
        const exclusiveLimitAlarmType = addressSpace.findEventType("ExclusiveLimitAlarmType");
        if (!exclusiveLimitAlarmType) {
          throw new Error("cannot find ExclusiveLimitAlarmType");
        }
        const node = ua_limit_alarm_impl_1.UALimitAlarmImpl.instantiate(namespace, type, options, data);
        Object.setPrototypeOf(node, _UAExclusiveLimitAlarmImpl.prototype);
        const alarm = node;
        (0, node_opcua_assert_1.assert)(alarm instanceof _UAExclusiveLimitAlarmImpl);
        (0, node_opcua_assert_1.assert)(alarm instanceof ua_limit_alarm_impl_1.UALimitAlarmImpl);
        (0, node_opcua_assert_1.assert)(alarm.limitState, "limitState is mandatory");
        (0, finite_state_machine_1.promoteToStateMachine)(alarm.limitState);
        alarm.activeState.setValue(false);
        alarm.updateState();
        return alarm;
      }
      _signalNewCondition(stateName, isActive, value) {
        (0, node_opcua_assert_1.assert)(stateName === null || typeof isActive === "boolean");
        (0, node_opcua_assert_1.assert)(validState.indexOf(stateName) >= 0, "must have a valid state : " + stateName);
        const oldState = this.limitState.getCurrentState();
        const oldActive = this.activeState.getValue();
        if (stateName) {
          this.limitState.setState(stateName);
        } else {
          (0, node_opcua_assert_1.assert)(stateName === null);
          this.limitState.setState(stateName);
        }
        super._signalNewCondition(stateName, isActive, value);
      }
      _setStateBasedOnInputValue(value) {
        (0, node_opcua_assert_1.assert)(isFinite(value));
        let isActive = false;
        let state = null;
        const oldState = this.limitState.getCurrentState();
        if (this.highHighLimit && this.getHighHighLimit() < value) {
          state = "HighHigh";
          isActive = true;
        } else if (this.highLimit && this.getHighLimit() < value) {
          state = "High";
          isActive = true;
        } else if (this.lowLowLimit && this.getLowLowLimit() > value) {
          state = "LowLow";
          isActive = true;
        } else if (this.lowLimit && this.getLowLimit() > value) {
          state = "Low";
          isActive = true;
        }
        if (state !== oldState) {
          this._signalNewCondition(state, isActive, value.toFixed(3));
        }
      }
    };
    exports2.UAExclusiveLimitAlarmImpl = UAExclusiveLimitAlarmImpl;
  }
});

// node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_exclusive_deviation_alarm_impl.js
var require_ua_exclusive_deviation_alarm_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_exclusive_deviation_alarm_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UAExclusiveDeviationAlarmImpl = void 0;
    var node_opcua_assert_1 = require_dist14();
    var deviation_alarm_helper_1 = require_deviation_alarm_helper();
    var ua_exclusive_limit_alarm_impl_1 = require_ua_exclusive_limit_alarm_impl();
    var ua_limit_alarm_impl_1 = require_ua_limit_alarm_impl();
    var UAExclusiveDeviationAlarmImpl = class _UAExclusiveDeviationAlarmImpl extends ua_exclusive_limit_alarm_impl_1.UAExclusiveLimitAlarmImpl {
      static instantiate(namespace, type, options, data) {
        const addressSpace = namespace.addressSpace;
        const exclusiveDeviationAlarmType = addressSpace.findEventType("ExclusiveDeviationAlarmType");
        if (!exclusiveDeviationAlarmType) {
          throw new Error("cannot find ExclusiveDeviationAlarmType");
        }
        (0, node_opcua_assert_1.assert)(type === exclusiveDeviationAlarmType.browseName.toString());
        const alarm = ua_exclusive_limit_alarm_impl_1.UAExclusiveLimitAlarmImpl.instantiate(namespace, type, options, data);
        Object.setPrototypeOf(alarm, _UAExclusiveDeviationAlarmImpl.prototype);
        (0, node_opcua_assert_1.assert)(alarm instanceof _UAExclusiveDeviationAlarmImpl);
        (0, node_opcua_assert_1.assert)(alarm instanceof ua_exclusive_limit_alarm_impl_1.UAExclusiveLimitAlarmImpl);
        (0, node_opcua_assert_1.assert)(alarm instanceof ua_limit_alarm_impl_1.UALimitAlarmImpl);
        alarm._install_setpoint(options);
        return alarm;
      }
      getSetpointNodeNode() {
        return deviation_alarm_helper_1.DeviationAlarmHelper_getSetpointNodeNode.call(this);
      }
      getSetpointValue() {
        return deviation_alarm_helper_1.DeviationAlarmHelper_getSetpointValue.call(this);
      }
      _onSetpointDataValueChange(dataValue) {
        deviation_alarm_helper_1.DeviationAlarmHelper_onSetpointDataValueChange.call(this, dataValue);
      }
      _install_setpoint(options) {
        return deviation_alarm_helper_1.DeviationAlarmHelper_install_setpoint.call(this, options);
      }
      _setStateBasedOnInputValue(value) {
        const setpointValue = this.getSetpointValue();
        if (setpointValue === null) {
          return;
        }
        (0, node_opcua_assert_1.assert)(isFinite(setpointValue));
        ua_exclusive_limit_alarm_impl_1.UAExclusiveLimitAlarmImpl.prototype._setStateBasedOnInputValue.call(this, value - setpointValue);
      }
    };
    exports2.UAExclusiveDeviationAlarmImpl = UAExclusiveDeviationAlarmImpl;
  }
});

// node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_exclusive_level_alarm_impl.js
var require_ua_exclusive_level_alarm_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_exclusive_level_alarm_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UAExclusiveLevelAlarmImpl = void 0;
    var ua_exclusive_limit_alarm_impl_1 = require_ua_exclusive_limit_alarm_impl();
    var UAExclusiveLevelAlarmImpl = class extends ua_exclusive_limit_alarm_impl_1.UAExclusiveLimitAlarmImpl {
      static instantiate(namespace, type, options, data) {
        const addressSpace = namespace.addressSpace;
        return ua_exclusive_limit_alarm_impl_1.UAExclusiveLimitAlarmImpl.instantiate(namespace, type, options, data);
      }
    };
    exports2.UAExclusiveLevelAlarmImpl = UAExclusiveLevelAlarmImpl;
  }
});

// node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_non_exclusive_limit_alarm_impl.js
var require_ua_non_exclusive_limit_alarm_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_non_exclusive_limit_alarm_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UANonExclusiveLimitAlarmImpl = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_status_code_1 = require_dist22();
    var ua_two_state_variable_1 = require_ua_two_state_variable();
    var condition_info_impl_1 = require_condition_info_impl();
    var ua_limit_alarm_impl_1 = require_ua_limit_alarm_impl();
    var UANonExclusiveLimitAlarmImpl = class _UANonExclusiveLimitAlarmImpl extends ua_limit_alarm_impl_1.UALimitAlarmImpl {
      static instantiate(namespace, type, options, data) {
        const addressSpace = namespace.addressSpace;
        options.optionals = options.optionals || [];
        if (Object.prototype.hasOwnProperty.call(options, "lowLowLimit")) {
          options.optionals.push("LowLowLimit");
          options.optionals.push("LowLowState");
        }
        if (Object.prototype.hasOwnProperty.call(options, "lowLimit")) {
          options.optionals.push("LowLimit");
          options.optionals.push("LowState");
        }
        if (Object.prototype.hasOwnProperty.call(options, "highLimit")) {
          options.optionals.push("HighLimit");
          options.optionals.push("HighState");
        }
        if (Object.prototype.hasOwnProperty.call(options, "highHighLimit")) {
          options.optionals.push("HighHighLimit");
          options.optionals.push("HighHighState");
        }
        const nonExclusiveAlarmType = addressSpace.findEventType(type);
        if (!nonExclusiveAlarmType) {
          throw new Error(" cannot find Alarm Condition Type for " + type);
        }
        const nonExclusiveLimitAlarmType = addressSpace.findEventType("NonExclusiveLimitAlarmType");
        if (!nonExclusiveLimitAlarmType) {
          throw new Error("cannot find NonExclusiveLimitAlarmType");
        }
        const alarm = ua_limit_alarm_impl_1.UALimitAlarmImpl.instantiate(namespace, type, options, data);
        Object.setPrototypeOf(alarm, _UANonExclusiveLimitAlarmImpl.prototype);
        (0, node_opcua_assert_1.assert)(alarm instanceof ua_limit_alarm_impl_1.UALimitAlarmImpl);
        (0, node_opcua_assert_1.assert)(alarm instanceof _UANonExclusiveLimitAlarmImpl);
        if (alarm.lowLowState) {
          (0, ua_two_state_variable_1._install_TwoStateVariable_machinery)(alarm.lowLowState, {
            falseState: "LowLow inactive",
            trueState: "LowLow active"
          });
          alarm.lowLowState.setValue(false);
          (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(alarm, "lowLowLimit"));
        }
        if (alarm.lowState) {
          (0, ua_two_state_variable_1._install_TwoStateVariable_machinery)(alarm.lowState, {
            falseState: "Low inactive",
            trueState: "Low active"
          });
          alarm.lowState.setValue(false);
          (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(alarm, "lowLimit"));
        }
        if (alarm.highState) {
          (0, ua_two_state_variable_1._install_TwoStateVariable_machinery)(alarm.highState, {
            falseState: "High inactive",
            trueState: "High active"
          });
          alarm.highState.setValue(false);
          (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(alarm, "highLimit"));
        }
        if (alarm.highHighState) {
          (0, ua_two_state_variable_1._install_TwoStateVariable_machinery)(alarm.highHighState, {
            falseState: "HighHigh inactive",
            trueState: "HighHigh active"
          });
          alarm.highHighState.setValue(false);
          (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(alarm, "highHighLimit"));
        }
        alarm.activeState.setValue(false);
        alarm.updateState();
        return alarm;
      }
      _calculateConditionInfo(state, isActive, value, oldConditionInfo) {
        if (!isActive) {
          return new condition_info_impl_1.ConditionInfoImpl({
            message: "Back to normal",
            quality: node_opcua_status_code_1.StatusCodes.Good,
            retain: true,
            severity: 0
          });
        } else {
          return new condition_info_impl_1.ConditionInfoImpl({
            message: "Condition is " + value + " and state is " + state,
            quality: node_opcua_status_code_1.StatusCodes.Good,
            retain: true,
            severity: 150
          });
        }
      }
      _signalNewCondition2(states, isActive, value) {
        const alarm = this;
        if (typeof states === "string") {
          return;
        }
        function _install(name) {
          if (states[name] !== "unset") {
            alarm[name + "State"].setValue(states[name]);
          }
        }
        _install("highHigh");
        _install("high");
        _install("low");
        _install("lowLow");
        let state_str = Object.keys(states).map((s) => states[s] ? s : null).filter((a) => a !== null).join(";");
        state_str = JSON.stringify(states);
        ua_limit_alarm_impl_1.UALimitAlarmImpl.prototype._signalNewCondition.call(this, state_str, isActive, value);
      }
      _setStateBasedOnInputValue(value) {
        (0, node_opcua_assert_1.assert)(isFinite(value), "expecting a valid value here");
        let isActive = false;
        const states = {
          highHigh: this.highHighState ? this.highHighState.getValue() : "unset",
          high: this.highState ? this.highState.getValue() : "unset",
          low: this.lowState ? this.lowState.getValue() : "unset",
          lowLow: this.lowLowState ? this.lowLowState.getValue() : "unset"
        };
        let count = 0;
        function ___p(stateName, func_value) {
          if (states[stateName] !== "unset") {
            const val = func_value();
            isActive = isActive || val;
            if (states[stateName] !== val) {
              states[stateName] = val;
              count += 1;
            }
          }
        }
        ___p("highHigh", () => {
          return this.getHighHighLimit() < value;
        });
        ___p("high", () => {
          return this.getHighLimit() < value;
        });
        ___p("low", () => {
          return this.getLowLimit() > value;
        });
        ___p("lowLow", () => {
          return this.getLowLowLimit() > value;
        });
        if (count > 0) {
          this._signalNewCondition2(states, isActive, value.toFixed(3));
        }
      }
    };
    exports2.UANonExclusiveLimitAlarmImpl = UANonExclusiveLimitAlarmImpl;
  }
});

// node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_non_exclusive_deviation_alarm_impl.js
var require_ua_non_exclusive_deviation_alarm_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_non_exclusive_deviation_alarm_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UANonExclusiveDeviationAlarmImpl = void 0;
    var node_opcua_assert_1 = require_dist14();
    var deviation_alarm_helper_1 = require_deviation_alarm_helper();
    var ua_limit_alarm_impl_1 = require_ua_limit_alarm_impl();
    var ua_non_exclusive_limit_alarm_impl_1 = require_ua_non_exclusive_limit_alarm_impl();
    var UANonExclusiveDeviationAlarmImpl = class _UANonExclusiveDeviationAlarmImpl extends ua_non_exclusive_limit_alarm_impl_1.UANonExclusiveLimitAlarmImpl {
      static instantiate(namespace, type, options, data) {
        const addressSpace = namespace.addressSpace;
        const nonExclusiveDeviationAlarmType = addressSpace.findEventType("NonExclusiveDeviationAlarmType");
        if (!nonExclusiveDeviationAlarmType) {
          throw new Error("cannot find ExclusiveDeviationAlarmType");
        }
        (0, node_opcua_assert_1.assert)(type === nonExclusiveDeviationAlarmType.browseName.toString());
        const alarm = ua_non_exclusive_limit_alarm_impl_1.UANonExclusiveLimitAlarmImpl.instantiate(namespace, type, options, data);
        Object.setPrototypeOf(alarm, _UANonExclusiveDeviationAlarmImpl.prototype);
        (0, node_opcua_assert_1.assert)(alarm instanceof _UANonExclusiveDeviationAlarmImpl);
        (0, node_opcua_assert_1.assert)(alarm instanceof ua_non_exclusive_limit_alarm_impl_1.UANonExclusiveLimitAlarmImpl);
        (0, node_opcua_assert_1.assert)(alarm instanceof ua_limit_alarm_impl_1.UALimitAlarmImpl);
        alarm._install_setpoint(options);
        return alarm;
      }
      _setStateBasedOnInputValue(value) {
        const setpointValue = this.getSetpointValue();
        if (setpointValue === null) {
          throw new Error("Cannot access setpoint Value");
        }
        (0, node_opcua_assert_1.assert)(isFinite(setpointValue), "expecting a valid setpoint value");
        super._setStateBasedOnInputValue(value - setpointValue);
      }
      getSetpointNodeNode() {
        return deviation_alarm_helper_1.DeviationAlarmHelper_getSetpointNodeNode.call(this);
      }
      getSetpointValue() {
        return deviation_alarm_helper_1.DeviationAlarmHelper_getSetpointValue.call(this);
      }
      _onSetpointDataValueChange(dataValue) {
        deviation_alarm_helper_1.DeviationAlarmHelper_onSetpointDataValueChange.call(this, dataValue);
      }
      _install_setpoint(options) {
        return deviation_alarm_helper_1.DeviationAlarmHelper_install_setpoint.call(this, options);
      }
    };
    exports2.UANonExclusiveDeviationAlarmImpl = UANonExclusiveDeviationAlarmImpl;
  }
});

// node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_off_normal_alarm_impl.js
var require_ua_off_normal_alarm_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_off_normal_alarm_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UAOffNormalAlarmImpl = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_variant_1 = require_dist28();
    var ua_discrete_alarm_impl_1 = require_ua_discrete_alarm_impl();
    function isEqual(value1, value2) {
      return value1 === value2;
    }
    var UAOffNormalAlarmImpl = class _UAOffNormalAlarmImpl extends ua_discrete_alarm_impl_1.UADiscreteAlarmImpl {
      /**
       * When the value of inputNode doesn't match the normalState node value, then the alarm is raised.
       *
       */
      static instantiate(namespace, limitAlarmTypeId, options, data) {
        const addressSpace = namespace.addressSpace;
        const offNormalAlarmType = addressSpace.findEventType("OffNormalAlarmType");
        if (!offNormalAlarmType) {
          throw new Error("cannot find offNormalAlarmType");
        }
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "inputNode"), "must provide inputNode");
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "normalState"), "must provide a normalState Node");
        options.optionals = options.optionals || [];
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "inputNode"), "must provide inputNode");
        const alarmNode = ua_discrete_alarm_impl_1.UADiscreteAlarmImpl.instantiate(namespace, limitAlarmTypeId, options, data);
        Object.setPrototypeOf(alarmNode, _UAOffNormalAlarmImpl.prototype);
        const inputNode = addressSpace._coerceNode(options.inputNode);
        if (inputNode) {
          alarmNode.installInputNodeMonitoring(options.inputNode);
        }
        if (options.normalState) {
          const normalState = addressSpace._coerceNode(options.normalState);
          const normalStateNodeId = normalState ? normalState.nodeId : new node_opcua_nodeid_1.NodeId();
          alarmNode.normalState.setValueFromSource({ dataType: node_opcua_variant_1.DataType.NodeId, value: normalStateNodeId });
          alarmNode.normalState.on("value_changed", (newDataValue) => {
          });
          if (normalState) {
            normalState.on("value_changed", (newDataValue) => {
              alarmNode._onNormalStateDataValueChange(newDataValue);
            });
          }
        } else {
          alarmNode.normalState.setValueFromSource({ dataType: node_opcua_variant_1.DataType.NodeId, value: node_opcua_nodeid_1.NodeId.nullNodeId });
        }
        alarmNode._mayBe_updateAlarmState();
        return alarmNode;
      }
      // HasProperty Variable NormalState NodeId PropertyType Mandatory
      // The NormalState Property is a Property that points to a Variable which has a value that
      // corresponds to one of the possible values of the Variable pointed to by the InputNode
      // Property where the NormalState Property Variable value is the value that is considered to be
      // the normal state of the Variable pointed to by the InputNode Property. When the value of the
      // Variable referenced by the InputNode Property is not equal to the value of the NormalState
      // Property the Alarm is Active. If this Variable is not in the AddressSpace, a Null NodeId shall
      // be provided.
      getNormalStateNode() {
        const nodeId = this.normalState.readValue().value.value;
        const node = this.addressSpace.findNode(nodeId);
        if (!node) {
          return null;
        }
        return node;
      }
      /**
       * @method getNormalStateValue
       */
      getNormalStateValue() {
        const normalStateNode = this.getNormalStateNode();
        if (!normalStateNode) {
          return null;
        }
        return normalStateNode.readValue().value.value;
      }
      /**
       * @method setNormalStateValue
       * @param value
       */
      setNormalStateValue(value) {
        const normalStateNode = this.getNormalStateNode();
        throw new Error("Not Implemented yet");
      }
      updateAlarmState(isActive, message) {
        if (isActive === this.activeState.getValue()) {
          return;
        }
        const stateName = isActive ? "Active" : "Inactive";
        this._signalNewCondition(stateName, isActive, message);
        if (!isActive) {
          this.currentBranch().setRetain(false);
        }
      }
      _mayBe_updateAlarmState(normalStateValue, inputValue) {
        if ((0, node_opcua_utils_1.isNullOrUndefined)(normalStateValue) || (0, node_opcua_utils_1.isNullOrUndefined)(inputValue)) {
          this.activeState.setValue(false);
          return;
        }
        const isActive = !isEqual(normalStateValue, inputValue);
        this.updateAlarmState(isActive, "automatique update");
      }
      _onInputDataValueChange(dataValue) {
        if (dataValue.statusCode.isNotGood()) {
          return;
        }
        if (dataValue.value.dataType === node_opcua_variant_1.DataType.Null) {
          return;
        }
        const inputValue = dataValue.value.value;
        const normalStateValue = this.getNormalStateValue();
        this._mayBe_updateAlarmState(normalStateValue, inputValue);
      }
      _onNormalStateDataValueChange(dataValue) {
        if (dataValue.statusCode.isNotGood()) {
          return;
        }
        if (dataValue.value.dataType === node_opcua_variant_1.DataType.Null) {
          return;
        }
        const normalStateValue = dataValue.value.value;
        const inputValue = this.getInputNodeValue();
        this._mayBe_updateAlarmState(normalStateValue, inputValue);
      }
    };
    exports2.UAOffNormalAlarmImpl = UAOffNormalAlarmImpl;
  }
});

// node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_system_off_normal_alarm_impl.js
var require_ua_system_off_normal_alarm_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_system_off_normal_alarm_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UASystemOffNormalAlarmImpl = void 0;
    var ua_off_normal_alarm_impl_1 = require_ua_off_normal_alarm_impl();
    var UASystemOffNormalAlarmImpl = class extends ua_off_normal_alarm_impl_1.UAOffNormalAlarmImpl {
      static instantiate(namespace, limitAlarmTypeId, options, data) {
        return ua_off_normal_alarm_impl_1.UAOffNormalAlarmImpl.instantiate(namespace, limitAlarmTypeId, options, data);
      }
    };
    exports2.UASystemOffNormalAlarmImpl = UASystemOffNormalAlarmImpl;
  }
});

// node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_certificate_expiration_alarm_impl.js
var require_ua_certificate_expiration_alarm_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/ua_certificate_expiration_alarm_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.promoteToCertificateExpirationAlarm = exports2.TwoWeeksDuration = exports2.OneDayDuration = exports2.instantiateCertificateExpirationAlarm = void 0;
    var node_opcua_crypto_1 = require_dist33();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_data_model_1 = require_dist27();
    var register_node_promoter_1 = require_register_node_promoter();
    var ua_system_off_normal_alarm_impl_1 = require_ua_system_off_normal_alarm_impl();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)("AlarmsAndConditions");
    var ellipsis = (arg0, arg1 = 4) => {
      arg1 = Math.max(arg1, 4);
      return arg0.length <= arg1 ? arg0 : arg0.slice(0, arg1 / 2) + "..." + arg0.slice(arg0.length - arg1 / 2);
    };
    var d2 = (d3) => {
      return d3.toISOString();
    };
    function instantiateCertificateExpirationAlarm(namespace, alarmType, options) {
      return UACertificateExpirationAlarmImpl.instantiate(namespace, alarmType, options);
    }
    exports2.instantiateCertificateExpirationAlarm = instantiateCertificateExpirationAlarm;
    exports2.OneDayDuration = 1e3 * 60 * 60 * 24;
    exports2.TwoWeeksDuration = exports2.OneDayDuration * 2 * 7;
    var UACertificateExpirationAlarmImpl = class extends ua_system_off_normal_alarm_impl_1.UASystemOffNormalAlarmImpl {
      constructor() {
        super(...arguments);
        this.timer = null;
      }
      static instantiate(namespace, alarmType, options) {
        const alarm = ua_system_off_normal_alarm_impl_1.UASystemOffNormalAlarmImpl.instantiate(
          namespace,
          alarmType || "CertificateExpirationAlarmType",
          options
          // data
        );
        promoteToCertificateExpirationAlarm(alarm);
        return alarm;
      }
      getExpirationDate() {
        return this.expirationDate.readValue().value.value;
      }
      updateAlarmState2(isActive, severity, message) {
        isActive ? this.activateAlarm() : this.deactivateAlarm();
        this.raiseNewCondition({
          message,
          quality: node_opcua_basic_types_1.StatusCodes.Good,
          retain: isActive ? true : false,
          severity
        });
      }
      update() {
        this._updateAlarm();
      }
      _updateAlarm() {
        const expirationDate = this.getExpirationDate();
        const now = /* @__PURE__ */ new Date();
        const expirationLimit = this.getExpirationLimit();
        const checkDate = new Date(now.getTime() + +expirationLimit);
        const certificate = this.getCertificate();
        if (!expirationDate || expirationDate === node_opcua_basic_types_1.minOPCUADate && !certificate) {
          if (!this.currentBranch() || this.currentBranch().getActiveState()) {
            this.updateAlarmState2(true, 255, "certificate is missing");
          }
          return;
        }
        const thumbprint = ellipsis((0, node_opcua_crypto_1.makeSHA1Thumbprint)(this.getCertificate() || Buffer.alloc(0)).toString("hex"), 10);
        const info = `| end date: ${d2(expirationDate)} | expirationLimit=${expirationLimit}|`;
        if (expirationDate.getTime() <= checkDate.getTime()) {
          if (expirationDate.getTime() <= now.getTime()) {
            this.updateAlarmState2(true, 250, `certificate ${thumbprint} has expired ${info}`);
          } else {
            const t1 = checkDate.getTime() - now.getTime();
            const t2 = checkDate.getTime() - expirationDate.getTime();
            const severity = t1 === 0 ? 255 : Math.floor(t2 / t1 * 100) + 100;
            this.updateAlarmState2(true, severity, `certificate ${thumbprint} is about to expire ${info}`);
          }
        } else {
          this.updateAlarmState2(false, 0, `certificate ${thumbprint} is OK! ${info}`);
        }
      }
      setExpirationDate(expirationDate) {
        this.expirationDate.setValueFromSource({
          dataType: node_opcua_variant_1.DataType.DateTime,
          value: expirationDate
        });
        this._updateAlarm();
      }
      getExpirationLimit() {
        if (!this.expirationLimit) {
          return exports2.TwoWeeksDuration;
        }
        const dataValue = this.expirationLimit.readValue();
        if (dataValue.dataType === node_opcua_variant_1.DataType.Null) {
          return exports2.TwoWeeksDuration;
        }
        return this.expirationLimit?.readValue().value.value || 0;
      }
      setExpirationLimit(value) {
        this.expirationLimit?.setValueFromSource({
          dataType: node_opcua_variant_1.DataType.Double,
          value
        });
        this._updateAlarm();
      }
      getCertificate() {
        return this.certificate.readValue().value.value || null;
      }
      _extractAndSetExpiryDate(certificate) {
        if (certificate && certificate.length > 0) {
          const info = (0, node_opcua_crypto_1.exploreCertificate)(certificate);
          if (info.tbsCertificate.validity.notAfter instanceof Date) {
            this.setExpirationDate(info.tbsCertificate.validity.notAfter);
          } else {
            this.setExpirationDate(node_opcua_basic_types_1.minOPCUADate);
          }
        } else {
          this.setExpirationDate(node_opcua_basic_types_1.minOPCUADate);
        }
      }
      setCertificate(certificate) {
        this.certificate.setValueFromSource({
          dataType: node_opcua_variant_1.DataType.ByteString,
          value: certificate
        });
        this._extractAndSetExpiryDate(certificate);
      }
      stopTimer() {
        if (this.timer) {
          clearInterval(this.timer);
          this.timer = null;
        }
      }
      _post_initialize() {
        if (this.expirationLimit) {
          this.expirationLimit.accessLevel = (0, node_opcua_data_model_1.makeAccessLevelExFlag)("CurrentRead | CurrentWrite");
          this.expirationLimit.userAccessLevel = (0, node_opcua_data_model_1.makeAccessLevelExFlag)("CurrentRead | CurrentWrite");
          this.expirationLimit.on("value_changed", (dataValue) => {
            const certificate2 = this.getCertificate();
            this.setCertificate(certificate2);
          });
        }
        const certificate = this.getCertificate();
        this._extractAndSetExpiryDate(certificate);
        this.addressSpace.registerShutdownTask(() => {
          this.stopTimer();
        });
        this.timer = setInterval(() => this.update(), exports2.OneDayDuration / 48);
      }
    };
    function promoteToCertificateExpirationAlarm(node) {
      if (node instanceof UACertificateExpirationAlarmImpl) {
        return node;
      }
      Object.setPrototypeOf(node, UACertificateExpirationAlarmImpl.prototype);
      const _node = node;
      _node._post_initialize();
      return _node;
    }
    exports2.promoteToCertificateExpirationAlarm = promoteToCertificateExpirationAlarm;
    (0, register_node_promoter_1.registerNodePromoter)(node_opcua_constants_1.ObjectTypeIds.CertificateExpirationAlarmType, promoteToCertificateExpirationAlarm, true);
  }
});

// node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/index.js
var require_alarms_and_conditions = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/alarms_and_conditions/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_condition_info_impl(), exports2);
    __exportStar3(require_condition_snapshot_impl(), exports2);
    __exportStar3(require_ua_condition_impl(), exports2);
    __exportStar3(require_ua_acknowledgeable_condition_impl(), exports2);
    __exportStar3(require_ua_discrete_alarm_impl(), exports2);
    __exportStar3(require_ua_exclusive_deviation_alarm_impl(), exports2);
    __exportStar3(require_ua_exclusive_level_alarm_impl(), exports2);
    __exportStar3(require_ua_exclusive_limit_alarm_impl(), exports2);
    __exportStar3(require_ua_limit_alarm_impl(), exports2);
    __exportStar3(require_ua_non_exclusive_deviation_alarm_impl(), exports2);
    __exportStar3(require_ua_non_exclusive_limit_alarm_impl(), exports2);
    __exportStar3(require_ua_alarm_condition_impl(), exports2);
    __exportStar3(require_ua_certificate_expiration_alarm_impl(), exports2);
  }
});

// node_modules/node-opcua-service-history/dist/imports.js
var require_imports3 = __commonJS({
  "node_modules/node-opcua-service-history/dist/imports.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ReadEventDetails = exports2.ModificationInfo = exports2.HistoryUpdateType = exports2.ReadAtTimeDetails = exports2.ReadProcessedDetails = exports2.ReadRawModifiedDetails = exports2.HistoryUpdateResponse = exports2.HistoryUpdateRequest = exports2.HistoryReadResponse = exports2.HistoryReadRequest = exports2.HistoryUpdateResult = exports2.HistoryReadResult = exports2.HistoryReadValueId = exports2.HistoryReadDetails = exports2.HistoryModifiedData = exports2.HistoryData = exports2.AggregateConfiguration = void 0;
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_types_1 = require_dist32();
    Object.defineProperty(exports2, "AggregateConfiguration", { enumerable: true, get: function() {
      return node_opcua_types_1.AggregateConfiguration;
    } });
    Object.defineProperty(exports2, "HistoryData", { enumerable: true, get: function() {
      return node_opcua_types_1.HistoryData;
    } });
    Object.defineProperty(exports2, "HistoryModifiedData", { enumerable: true, get: function() {
      return node_opcua_types_1.HistoryModifiedData;
    } });
    Object.defineProperty(exports2, "HistoryReadDetails", { enumerable: true, get: function() {
      return node_opcua_types_1.HistoryReadDetails;
    } });
    Object.defineProperty(exports2, "HistoryReadValueId", { enumerable: true, get: function() {
      return node_opcua_types_1.HistoryReadValueId;
    } });
    Object.defineProperty(exports2, "HistoryReadResult", { enumerable: true, get: function() {
      return node_opcua_types_1.HistoryReadResult;
    } });
    Object.defineProperty(exports2, "HistoryUpdateResult", { enumerable: true, get: function() {
      return node_opcua_types_1.HistoryUpdateResult;
    } });
    Object.defineProperty(exports2, "HistoryReadRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.HistoryReadRequest;
    } });
    Object.defineProperty(exports2, "HistoryReadResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.HistoryReadResponse;
    } });
    Object.defineProperty(exports2, "HistoryUpdateRequest", { enumerable: true, get: function() {
      return node_opcua_types_1.HistoryUpdateRequest;
    } });
    Object.defineProperty(exports2, "HistoryUpdateResponse", { enumerable: true, get: function() {
      return node_opcua_types_1.HistoryUpdateResponse;
    } });
    Object.defineProperty(exports2, "ReadRawModifiedDetails", { enumerable: true, get: function() {
      return node_opcua_types_1.ReadRawModifiedDetails;
    } });
    Object.defineProperty(exports2, "ReadProcessedDetails", { enumerable: true, get: function() {
      return node_opcua_types_1.ReadProcessedDetails;
    } });
    Object.defineProperty(exports2, "ReadAtTimeDetails", { enumerable: true, get: function() {
      return node_opcua_types_1.ReadAtTimeDetails;
    } });
    Object.defineProperty(exports2, "HistoryUpdateType", { enumerable: true, get: function() {
      return node_opcua_types_1.HistoryUpdateType;
    } });
    Object.defineProperty(exports2, "ModificationInfo", { enumerable: true, get: function() {
      return node_opcua_types_1.ModificationInfo;
    } });
    Object.defineProperty(exports2, "ReadEventDetails", { enumerable: true, get: function() {
      return node_opcua_types_1.ReadEventDetails;
    } });
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_types_2 = require_dist32();
    (0, node_opcua_assert_1.assert)(node_opcua_types_2.HistoryReadRequest.schema.fields[2].name === "timestampsToReturn");
    node_opcua_types_2.HistoryReadRequest.schema.fields[2].defaultValue = node_opcua_data_value_1.TimestampsToReturn.Neither;
  }
});

// node_modules/node-opcua-service-history/dist/index.js
var require_dist54 = __commonJS({
  "node_modules/node-opcua-service-history/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_imports3(), exports2);
  }
});

// node_modules/node-opcua-address-space/dist/source/address_space_ts.js
var require_address_space_ts = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/address_space_ts.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AddressSpace = exports2.EUEngineeringUnit = void 0;
    var EUEngineeringUnit;
    (function(EUEngineeringUnit2) {
      EUEngineeringUnit2[EUEngineeringUnit2["degree_celsius"] = 0] = "degree_celsius";
    })(EUEngineeringUnit || (exports2.EUEngineeringUnit = EUEngineeringUnit = {}));
    var AddressSpace = class _AddressSpace {
      static create() {
        return new _AddressSpace();
      }
      constructor() {
      }
    };
    exports2.AddressSpace = AddressSpace;
  }
});

// node_modules/dequeue/lib/dequeue.js
var require_dequeue = __commonJS({
  "node_modules/dequeue/lib/dequeue.js"(exports2, module2) {
    var Dequeue = exports2 = module2.exports = function Dequeue2() {
      this.head = new Node();
      this.length = 0;
    };
    Dequeue.prototype.push = function(d2) {
      var n = new Node(d2);
      this.head.prepend(n);
      this.length += 1;
      return this;
    };
    Dequeue.prototype.unshift = function(d2) {
      var n = new Node(d2);
      this.head.append(n);
      this.length += 1;
      return this;
    };
    Dequeue.prototype.pop = function() {
      if (this.head.prev === this.head)
        return;
      var n = this.head.prev.remove();
      this.length -= 1;
      return n.data;
    };
    Dequeue.prototype.shift = function() {
      if (this.head.next === this.head)
        return;
      var n = this.head.next.remove();
      this.length -= 1;
      return n.data;
    };
    Dequeue.prototype.last = function() {
      if (this.head.prev === this.head)
        return;
      return this.head.prev.data;
    };
    Dequeue.prototype.first = function() {
      if (this.head.next === this.head)
        return;
      return this.head.next.data;
    };
    Dequeue.prototype.empty = function() {
      if (this.length === 0)
        return;
      this.head.next.prev = null;
      this.head.prev.next = null;
      this.head.next = this.head;
      this.head.prev = this.head;
      this.length = 0;
      return;
    };
    function Node(d2) {
      this.data = d2;
      this.next = this;
      this.prev = this;
    }
    Node.prototype.append = function(n) {
      n.next = this.next;
      n.prev = this;
      this.next.prev = n;
      this.next = n;
      return n;
    };
    Node.prototype.prepend = function(n) {
      n.prev = this.prev;
      n.next = this;
      this.prev.next = n;
      this.prev = n;
      return n;
    };
    Node.prototype.remove = function() {
      this.next.prev = this.prev;
      this.prev.next = this.next;
      return this;
    };
  }
});

// node_modules/dequeue/lib/index.js
var require_lib16 = __commonJS({
  "node_modules/dequeue/lib/index.js"(exports2, module2) {
    exports2 = module2.exports = require_dequeue();
  }
});

// node_modules/node-opcua-address-space/dist/src/historical_access/address_space_historical_data_node.js
var require_address_space_historical_data_node = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/historical_access/address_space_historical_data_node.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AddressSpace_installHistoricalDataNode = exports2.VariableHistorian = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_date_time_1 = require_dist17();
    var node_opcua_service_history_1 = require_dist54();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_debug_1 = require_dist24();
    var ua_variable_impl_1 = require_ua_variable_impl();
    var address_space_ts_1 = require_address_space_ts();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var Dequeue = require_lib16();
    function inInTimeRange(historyReadDetails, dataValue) {
      if (historyReadDetails.startTime && !(0, node_opcua_date_time_1.isMinDate)(historyReadDetails.startTime) && dataValue.sourceTimestamp < historyReadDetails.startTime) {
        return false;
      }
      if (historyReadDetails.endTime && !(0, node_opcua_date_time_1.isMinDate)(historyReadDetails.endTime) && dataValue.sourceTimestamp > historyReadDetails.endTime) {
        return false;
      }
      return true;
    }
    function inInTimeRange2(historyReadDetails, dataValue) {
      if (historyReadDetails.endTime && !(0, node_opcua_date_time_1.isMinDate)(historyReadDetails.endTime) && dataValue.sourceTimestamp > historyReadDetails.endTime) {
        return false;
      }
      return !(historyReadDetails.startTime && !(0, node_opcua_date_time_1.isMinDate)(historyReadDetails.startTime) && dataValue.sourceTimestamp < historyReadDetails.startTime);
    }
    function filter_dequeue(q2, historyReadRawModifiedDetails, onlyThisNumber, isReversed) {
      const r = [];
      const predicate = isReversed ? inInTimeRange2.bind(null, historyReadRawModifiedDetails) : inInTimeRange.bind(null, historyReadRawModifiedDetails);
      if (isReversed) {
        let c2 = q2.head.prev;
        while (c2.data) {
          if (predicate(c2.data)) {
            r.push(c2.data);
          }
          c2 = c2.prev;
          if (onlyThisNumber && r.length === onlyThisNumber) {
            return r;
          }
        }
      } else {
        let c2 = q2.head.next;
        while (c2.data) {
          if (predicate(c2.data)) {
            r.push(c2.data);
          }
          c2 = c2.next;
          if (onlyThisNumber && r.length === onlyThisNumber) {
            return r;
          }
        }
      }
      return r;
    }
    var VariableHistorian = class {
      constructor(node, options) {
        this._timeline = new Dequeue();
        this._maxOnlineValues = options.maxOnlineValues || 1e3;
        this.lastDate = new Date(1600, 0, 1, 0, 0, 0);
        this.lastDatePicoSeconds = 0;
        this.node = node;
      }
      /* public */
      async push(newDataValue) {
        this._timeline.push(newDataValue);
        const sourceTime = newDataValue.sourceTimestamp || /* @__PURE__ */ new Date();
        const sourcePicoSeconds = newDataValue.sourcePicoseconds || 0;
        if (sourceTime.getTime() <= this.lastDate.getTime()) {
          if (!(sourceTime.getTime() === this.lastDate.getTime() && sourcePicoSeconds > this.lastDatePicoSeconds)) {
            warningLog(chalk_1.default.red("Warning date not increasing "), chalk_1.default.cyan("\n node: ", this.node.browseName.toString(), this.node.nodeId.toString()), "\n new value       = ", newDataValue.toString(), "\n last known date = ", this.lastDate, "\n last known picoSeconds = ", this.lastDatePicoSeconds, "\n lastValue = ", this._timeline[this._timeline.length - 1]?.toString());
            newDataValue.sourcePicoseconds++;
          }
        }
        this.lastDate = sourceTime;
        this.lastDatePicoSeconds = newDataValue.sourcePicoseconds || 0;
        if (this._timeline.length > this._maxOnlineValues) {
          (0, node_opcua_assert_1.assert)(typeof this._maxOnlineValues === "number" && this._maxOnlineValues > 0);
          while (this._timeline.length > this._maxOnlineValues) {
            this._timeline.shift();
          }
        }
        if (this._timeline.length >= this._maxOnlineValues || this._timeline.length === 1) {
          const first = this._timeline.first();
          this.node._update_startOfOnlineArchive(first.sourceTimestamp);
        }
      }
      extractDataValues(historyReadRawModifiedDetails, maxNumberToExtract, isReversed, reverseDataValue, callback) {
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        let dataValues = filter_dequeue(this._timeline, historyReadRawModifiedDetails, maxNumberToExtract, isReversed);
        if (reverseDataValue) {
          dataValues = dataValues.reverse();
        }
        callback(null, dataValues);
      }
    };
    exports2.VariableHistorian = VariableHistorian;
    function _get_startOfOfflineArchive(node) {
      if (!node.$historicalDataConfiguration) {
        throw new Error("this variable has no HistoricalDataConfiguration");
      }
      return node.$historicalDataConfiguration.startOfArchive?.readValue();
    }
    function _update_startOfArchive(newDate) {
      if (!this.$historicalDataConfiguration) {
        throw new Error("this variable has no HistoricalDataConfiguration");
      }
      this.$historicalDataConfiguration.startOfArchive?.setValueFromSource({
        dataType: node_opcua_variant_1.DataType.DateTime,
        value: newDate
      });
    }
    function _update_startOfOnlineArchive(newDate) {
      if (!this.$historicalDataConfiguration) {
        throw new Error("this variable has no HistoricalDataConfiguration");
      }
      this.$historicalDataConfiguration.startOfOnlineArchive?.setValueFromSource({
        dataType: node_opcua_variant_1.DataType.DateTime,
        value: newDate
      });
      const startOfArchiveDataValue = _get_startOfOfflineArchive(this);
      if (startOfArchiveDataValue && (startOfArchiveDataValue.statusCode.isNotGood() || !startOfArchiveDataValue.value || !startOfArchiveDataValue.value.value || startOfArchiveDataValue.value.value.getTime() >= newDate.getTime())) {
        this._update_startOfArchive(newDate);
      }
    }
    ua_variable_impl_1.UAVariableImpl.prototype._update_startOfOnlineArchive = _update_startOfOnlineArchive;
    ua_variable_impl_1.UAVariableImpl.prototype._update_startOfArchive = _update_startOfArchive;
    function _historyPush(newDataValue) {
      if (!this.varHistorian) {
        throw new Error("this variable has no HistoricalDataConfiguration");
      }
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(this, "historizing"), "expecting a historizing attribute on node");
      if (!this.historizing) {
        return;
      }
      (0, node_opcua_assert_1.assert)(this.historizing === true);
      this.varHistorian.push(newDataValue);
    }
    function _historyReadModify(context, historyReadRawModifiedDetails, indexRange, dataEncoding, continuationData, callback) {
      const result2 = new node_opcua_service_history_1.HistoryReadResult({
        historyData: new node_opcua_service_history_1.HistoryData({ dataValues: [] }),
        statusCode: node_opcua_status_code_1.StatusCodes.BadUnexpectedError
      });
      return callback(null, result2);
    }
    function _historyReadRawAsync(historyReadRawModifiedDetails, maxNumberToExtract, isReversed, reverseDataValue, callback) {
      (0, node_opcua_assert_1.assert)(typeof callback === "function");
      this.varHistorian.extractDataValues(historyReadRawModifiedDetails, maxNumberToExtract, isReversed, reverseDataValue, callback);
    }
    function _historyReadRaw(context, historyReadRawModifiedDetails, indexRange, dataEncoding, continuationData, callback) {
      (0, node_opcua_assert_1.assert)(historyReadRawModifiedDetails instanceof node_opcua_service_history_1.ReadRawModifiedDetails);
      const session = context.session;
      if (!session) {
        throw new Error("Internal Error: context.session not defined");
      }
      if (!session.continuationPointManager) {
        throw new Error("Internal Error: context.session.continuationPointManager not defined");
      }
      if (continuationData.continuationPoint) {
        const cnt = session.continuationPointManager.getNextHistoryReadRaw(historyReadRawModifiedDetails.numValuesPerNode, continuationData);
        const { statusCode, values, continuationPoint } = cnt;
        const result2 = new node_opcua_service_history_1.HistoryReadResult({
          continuationPoint,
          historyData: new node_opcua_service_history_1.HistoryData({ dataValues: values }),
          statusCode
        });
        return callback(null, result2);
      }
      let maxNumberToExtract = 0;
      let isReversed = false;
      let reverseDataValue = false;
      if ((0, node_opcua_date_time_1.isMinDate)(historyReadRawModifiedDetails.endTime)) {
        maxNumberToExtract = historyReadRawModifiedDetails.numValuesPerNode;
        if ((0, node_opcua_date_time_1.isMinDate)(historyReadRawModifiedDetails.startTime)) {
          const result2 = new node_opcua_service_history_1.HistoryReadResult({
            statusCode: node_opcua_status_code_1.StatusCodes.BadHistoryOperationUnsupported
            // should be an error
          });
          return callback(null, result2);
        }
      } else if ((0, node_opcua_date_time_1.isMinDate)(historyReadRawModifiedDetails.startTime)) {
        maxNumberToExtract = historyReadRawModifiedDetails.numValuesPerNode;
        isReversed = true;
        reverseDataValue = false;
        if (historyReadRawModifiedDetails.numValuesPerNode === 0) {
          const result2 = new node_opcua_service_history_1.HistoryReadResult({
            statusCode: node_opcua_status_code_1.StatusCodes.BadHistoryOperationUnsupported
            // should be an error
          });
          return callback(null, result2);
        }
      } else {
        if (historyReadRawModifiedDetails.endTime.getTime() < historyReadRawModifiedDetails.startTime.getTime()) {
          reverseDataValue = true;
          const tmp = historyReadRawModifiedDetails.endTime;
          historyReadRawModifiedDetails.endTime = historyReadRawModifiedDetails.startTime;
          historyReadRawModifiedDetails.startTime = tmp;
        }
      }
      this._historyReadRawAsync(historyReadRawModifiedDetails, maxNumberToExtract, isReversed, reverseDataValue, (err, dataValues) => {
        if (err || !dataValues) {
          return callback(err);
        }
        const cnt = session.continuationPointManager.registerHistoryReadRaw(historyReadRawModifiedDetails.numValuesPerNode, dataValues, continuationData);
        const result2 = new node_opcua_service_history_1.HistoryReadResult({
          continuationPoint: cnt.continuationPoint,
          historyData: new node_opcua_service_history_1.HistoryData({ dataValues: cnt.values }),
          statusCode: cnt.statusCode
        });
        callback(null, result2);
      });
    }
    function _historyReadRawModify(context, historyReadRawModifiedDetails, indexRange, dataEncoding, continuationData, callback) {
      const node = this;
      (0, node_opcua_assert_1.assert)(historyReadRawModifiedDetails instanceof node_opcua_service_history_1.ReadRawModifiedDetails);
      if (!historyReadRawModifiedDetails.isReadModified) {
        return node._historyReadRaw(context, historyReadRawModifiedDetails, indexRange, dataEncoding, continuationData, callback);
      } else {
        return node._historyReadModify(context, historyReadRawModifiedDetails, indexRange, dataEncoding, continuationData, callback);
      }
    }
    function _historyRead(context, historyReadDetails, indexRange, dataEncoding, continuationData, callback) {
      if (!this.canUserReadHistory(context)) {
        const result2 = new node_opcua_service_history_1.HistoryReadResult({
          statusCode: node_opcua_status_code_1.StatusCodes.BadUserAccessDenied
        });
        callback(null, result2);
      }
      (0, node_opcua_assert_1.assert)(typeof callback === "function");
      if (historyReadDetails instanceof node_opcua_service_history_1.ReadRawModifiedDetails) {
        return this._historyReadRawModify(context, historyReadDetails, indexRange, dataEncoding, continuationData, callback);
      } else if (historyReadDetails instanceof node_opcua_service_history_1.ReadEventDetails) {
        const result2 = new node_opcua_service_history_1.HistoryReadResult({
          historyData: new node_opcua_service_history_1.HistoryData({ dataValues: [] }),
          statusCode: node_opcua_status_code_1.StatusCodes.BadHistoryOperationUnsupported
        });
        return callback(null, result2);
      } else if (historyReadDetails instanceof node_opcua_service_history_1.ReadProcessedDetails) {
        const addressSpace = this.addressSpace;
        if (!addressSpace._readProcessedDetails) {
          const result2 = new node_opcua_service_history_1.HistoryReadResult({
            historyData: new node_opcua_service_history_1.HistoryData({}),
            statusCode: node_opcua_status_code_1.StatusCodes.BadHistoryOperationUnsupported
          });
          return callback(null, result2);
        } else {
          return addressSpace._readProcessedDetails(this, context, historyReadDetails, indexRange, dataEncoding, continuationData, callback);
        }
      } else if (historyReadDetails instanceof node_opcua_service_history_1.ReadAtTimeDetails) {
        const result2 = new node_opcua_service_history_1.HistoryReadResult({
          historyData: new node_opcua_service_history_1.HistoryData({ dataValues: [] }),
          statusCode: node_opcua_status_code_1.StatusCodes.BadHistoryOperationUnsupported
        });
        return callback(null, result2);
      } else {
        const result2 = new node_opcua_service_history_1.HistoryReadResult({
          historyData: new node_opcua_service_history_1.HistoryData({ dataValues: [] }),
          statusCode: node_opcua_status_code_1.StatusCodes.BadHistoryOperationUnsupported
        });
        return callback(null, result2);
      }
    }
    function on_value_change(newDataValue) {
      this._historyPush.call(this, newDataValue);
    }
    function AddressSpace_installHistoricalDataNode(node, options) {
      address_space_ts_1.AddressSpace.historizerFactory = address_space_ts_1.AddressSpace.historizerFactory || {
        create(node1, options1) {
          return new VariableHistorian(node1, options1);
        }
      };
      (0, node_opcua_assert_1.assert)(node.nodeClass === node_opcua_data_model_1.NodeClass.Variable);
      options = options || {};
      const addressSpace = node.addressSpace;
      node._historyRead = _historyRead;
      node._historyPush = _historyPush;
      node._historyReadRawModify = _historyReadRawModify;
      node._historyReadModify = _historyReadModify;
      node._historyReadRaw = _historyReadRaw;
      node._historyReadRawAsync = _historyReadRawAsync;
      node.varHistorian = options.historian || address_space_ts_1.AddressSpace.historizerFactory.create(node, options);
      const historicalDataConfigurationType = addressSpace.findObjectType("HistoricalDataConfigurationType");
      if (!historicalDataConfigurationType) {
        throw new Error("cannot find HistoricalDataConfigurationType");
      }
      node.historizing = true;
      node.accessLevel = node.accessLevel | node_opcua_data_model_1.AccessLevelFlag.CurrentRead | node_opcua_data_model_1.AccessLevelFlag.HistoryRead;
      if (node.userAccessLevel !== void 0) {
        node.userAccessLevel = node.userAccessLevel | node_opcua_data_model_1.AccessLevelFlag.CurrentRead | node_opcua_data_model_1.AccessLevelFlag.HistoryRead;
      }
      const optionals = ["Stepped", "Definition", "MaxTimeInterval", "MinTimeInterval", "StartOfArchive", "StartOfOnlineArchive"];
      const historicalDataConfiguration = historicalDataConfigurationType.instantiate({
        browseName: { name: "HA Configuration", namespaceIndex: 0 },
        optionals
      });
      node.addReference({
        isForward: true,
        nodeId: historicalDataConfiguration.nodeId,
        referenceType: "HasHistoricalConfiguration"
      });
      historicalDataConfiguration.stepped.setValueFromSource({ dataType: "Boolean", value: false });
      historicalDataConfiguration.maxTimeInterval?.setValueFromSource({ dataType: "Duration", value: 10 * 1e3 });
      historicalDataConfiguration.minTimeInterval?.setValueFromSource({ dataType: "Duration", value: 0.1 * 1e3 });
      const startOfOnlineArchive = /* @__PURE__ */ new Date();
      historicalDataConfiguration.startOfOnlineArchive?.setValueFromSource({
        dataType: node_opcua_variant_1.DataType.DateTime,
        value: startOfOnlineArchive
      });
      historicalDataConfiguration.aggregateConfiguration.treatUncertainAsBad.setValueFromSource({
        dataType: "Boolean",
        value: true
      });
      historicalDataConfiguration.aggregateConfiguration.percentDataBad.setValueFromSource({
        dataType: "Byte",
        value: 100
      });
      historicalDataConfiguration.aggregateConfiguration.percentDataGood.setValueFromSource({
        dataType: "Byte",
        value: 100
      });
      node.$historicalDataConfiguration = historicalDataConfiguration;
      const dataValue = node.readValue();
      if (dataValue.statusCode.isNot(node_opcua_status_code_1.StatusCodes.BadWaitingForInitialData) && dataValue.statusCode.isNot(node_opcua_status_code_1.StatusCodes.UncertainInitialValue)) {
        on_value_change.call(node, dataValue);
      }
      node.on("value_changed", on_value_change);
      node.addressSpace.historizingNodes = node.addressSpace.historizingNodes || {};
      node.addressSpace.historizingNodes[node.nodeId.toString()] = node;
    }
    exports2.AddressSpace_installHistoricalDataNode = AddressSpace_installHistoricalDataNode;
  }
});

// node_modules/node-opcua-address-space/dist/src/data_access/add_dataItem_stuff.js
var require_add_dataItem_stuff = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/data_access/add_dataItem_stuff.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.add_dataItem_stuff = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_variant_1 = require_dist28();
    var definition_Description = "Definition  is a vendor - specific, human readable string that specifies how the value of this  DataItem  is calculated.";
    var valuePrecision_Description = "";
    function add_dataItem_stuff(variable, options) {
      const addressSpace = variable.addressSpace;
      const namespace = addressSpace.getNamespace(variable.nodeId.namespace);
      if (Object.prototype.hasOwnProperty.call(options, "definition") && options.definition !== void 0) {
        namespace.addVariable({
          browseName: { name: "Definition", namespaceIndex: 0 },
          dataType: "String",
          description: definition_Description,
          minimumSamplingInterval: 0,
          modellingRule: options.modellingRule ? "Mandatory" : void 0,
          propertyOf: variable,
          typeDefinition: "PropertyType",
          value: new node_opcua_variant_1.Variant({ dataType: node_opcua_variant_1.DataType.String, value: options.definition })
        });
      }
      if (Object.prototype.hasOwnProperty.call(options, "valuePrecision") && options.valuePrecision !== void 0) {
        (0, node_opcua_assert_1.assert)(typeof options.valuePrecision === "number");
        namespace.addVariable({
          browseName: { name: "ValuePrecision", namespaceIndex: 0 },
          dataType: "Double",
          description: valuePrecision_Description,
          minimumSamplingInterval: 0,
          modellingRule: options.modellingRule ? "Mandatory" : void 0,
          propertyOf: variable,
          typeDefinition: "PropertyType",
          value: new node_opcua_variant_1.Variant({ dataType: node_opcua_variant_1.DataType.Double, value: options.valuePrecision })
        });
      }
    }
    exports2.add_dataItem_stuff = add_dataItem_stuff;
  }
});

// node_modules/node-opcua-address-space/dist/src/data_access/ua_multistate_discrete_impl.js
var require_ua_multistate_discrete_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/data_access/ua_multistate_discrete_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2._addMultiStateDiscrete = exports2.promoteToMultiStateDiscrete = exports2.UAMultiStateDiscreteImpl = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_variant_1 = require_dist28();
    var register_node_promoter_1 = require_register_node_promoter();
    var ua_variable_impl_1 = require_ua_variable_impl();
    var add_dataItem_stuff_1 = require_add_dataItem_stuff();
    var UAMultiStateDiscreteImpl = class extends ua_variable_impl_1.UAVariableImpl {
      getValue() {
        return this.readValue().value.value;
      }
      getValueAsString() {
        const index = this.getValue();
        const arr = this.enumStrings.readValue().value.value;
        (0, node_opcua_assert_1.assert)(Array.isArray(arr));
        return arr[index].text ? arr[index].text.toString() : "????";
      }
      getIndex(value) {
        const arr = this.enumStrings.readValue().value.value;
        (0, node_opcua_assert_1.assert)(Array.isArray(arr));
        const index = arr.findIndex((a) => a.text === value);
        return index;
      }
      setValue(value, options) {
        if (typeof value === "string") {
          const index = this.getIndex(value);
          if (index < 0) {
            throw new Error("UAMultiStateDiscrete#setValue invalid multi state value provided : " + value);
          }
          return this.setValue(index, options);
        }
        const arrayEnumStrings = this.enumStrings.readValue().value.value;
        if (value >= arrayEnumStrings.length) {
          throw new Error("UAMultiStateDiscrete#setValue BadOutOfRange " + value);
        }
        (0, node_opcua_assert_1.assert)(isFinite(value));
        return this.setValueFromSource(new node_opcua_variant_1.Variant({ dataType: node_opcua_variant_1.DataType.UInt32, value }));
      }
      checkVariantCompatibility(value) {
        if (!this._validate_DataType(value.dataType)) {
          return node_opcua_status_code_1.StatusCodes.BadTypeMismatch;
        }
        if (this.enumStrings) {
          const arrayEnumStrings = this.enumStrings.readValue().value.value;
          (0, node_opcua_assert_1.assert)(value.dataType === node_opcua_variant_1.DataType.UInt32);
          if (value.value >= arrayEnumStrings.length) {
            return node_opcua_status_code_1.StatusCodes.BadOutOfRange;
          }
        }
        return node_opcua_status_code_1.StatusCodes.Good;
      }
      _post_initialize() {
      }
      clone(options1, optionalFilter, extraInfo) {
        const variable1 = ua_variable_impl_1.UAVariableImpl.prototype.clone.call(this, options1, optionalFilter, extraInfo);
        return promoteToMultiStateDiscrete(variable1);
      }
    };
    exports2.UAMultiStateDiscreteImpl = UAMultiStateDiscreteImpl;
    function promoteToMultiStateDiscrete(node) {
      if (node instanceof UAMultiStateDiscreteImpl) {
        return node;
      }
      Object.setPrototypeOf(node, UAMultiStateDiscreteImpl.prototype);
      (0, node_opcua_assert_1.assert)(node instanceof UAMultiStateDiscreteImpl, "should now  be a State Machine");
      const _node = node;
      _node._post_initialize();
      (0, node_opcua_assert_1.assert)(_node.enumStrings.browseName.toString() === "EnumStrings");
      const handler = _node.handle_semantic_changed.bind(_node);
      _node.enumStrings.on("value_changed", handler);
      _node.install_extra_properties();
      return node;
    }
    exports2.promoteToMultiStateDiscrete = promoteToMultiStateDiscrete;
    (0, register_node_promoter_1.registerNodePromoter)(node_opcua_constants_1.VariableTypeIds.MultiStateDiscreteType, promoteToMultiStateDiscrete);
    function _addMultiStateDiscrete(namespace, options) {
      const addressSpace = namespace.addressSpace;
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "enumStrings"));
      (0, node_opcua_assert_1.assert)(!Object.prototype.hasOwnProperty.call(options, "ValuePrecision"));
      const multiStateDiscreteType = addressSpace.findVariableType("MultiStateDiscreteType");
      if (!multiStateDiscreteType) {
        throw new Error("Cannot find MultiStateDiscreteType");
      }
      options.value = options.value === void 0 ? 0 : options.value;
      let value;
      if (typeof options.value === "number") {
        value = new node_opcua_variant_1.Variant({
          dataType: node_opcua_variant_1.DataType.UInt32,
          value: options.value
        });
      } else {
        value = options.value;
      }
      const variable = namespace.addVariable({
        ...options,
        dataType: "Number",
        typeDefinition: multiStateDiscreteType.nodeId,
        value,
        valueRank: -2
      });
      (0, add_dataItem_stuff_1.add_dataItem_stuff)(variable, options);
      const enumStrings = options.enumStrings.map((value2) => {
        return (0, node_opcua_data_model_1.coerceLocalizedText)(value2);
      });
      const enumStringsNode = namespace.addVariable({
        accessLevel: "CurrentRead",
        // | CurrentWrite",
        browseName: { name: "EnumStrings", namespaceIndex: 0 },
        dataType: "LocalizedText",
        minimumSamplingInterval: 0,
        modellingRule: options.modellingRule ? "Mandatory" : void 0,
        propertyOf: variable,
        typeDefinition: "PropertyType",
        userAccessLevel: "CurrentRead",
        // CurrentWrite",
        value: new node_opcua_variant_1.Variant({
          arrayType: node_opcua_variant_1.VariantArrayType.Array,
          dataType: node_opcua_variant_1.DataType.LocalizedText,
          value: enumStrings
        })
      });
      return promoteToMultiStateDiscrete(variable);
    }
    exports2._addMultiStateDiscrete = _addMultiStateDiscrete;
  }
});

// node_modules/node-opcua-address-space/dist/src/nodeid_manager.js
var require_nodeid_manager = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/nodeid_manager.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NodeIdManager = exports2.NamespaceOptions = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_debug_1 = require_dist24();
    var base_node_impl_1 = require_base_node_impl();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    exports2.NamespaceOptions = {
      nodeIdNameSeparator: "-"
    };
    var regExp1 = /^(s|i|b|g)=/;
    var regExp2 = /^ns=[0-9]+;(s|i|b|g)=/;
    var hasPropertyRefId = (0, node_opcua_nodeid_1.resolveNodeId)("HasProperty");
    var hasComponentRefId = (0, node_opcua_nodeid_1.resolveNodeId)("HasComponent");
    var hasOrderedComponentRefId = (0, node_opcua_nodeid_1.resolveNodeId)("HasOrderedComponent");
    var hasEncoding = (0, node_opcua_nodeid_1.resolveNodeId)("HasEncoding");
    function _identifyParentInReference(references) {
      const candidates = references.filter((r) => {
        return !r.isForward && ((0, node_opcua_nodeid_1.sameNodeId)(r.referenceType, hasComponentRefId) || (0, node_opcua_nodeid_1.sameNodeId)(r.referenceType, hasOrderedComponentRefId) || (0, node_opcua_nodeid_1.sameNodeId)(r.referenceType, hasPropertyRefId) || (0, node_opcua_nodeid_1.sameNodeId)(r.referenceType, hasEncoding));
      });
      (0, node_opcua_assert_1.assert)(candidates.length <= 1);
      if (candidates.length === 0) {
        return null;
      }
      const ref = candidates[0];
      if ((0, node_opcua_nodeid_1.sameNodeId)(ref.referenceType, hasEncoding)) {
        return [ref.nodeId, "_Encoding"];
      }
      return [ref.nodeId, ""];
    }
    function _findParentNodeId(addressSpace, options) {
      if (!options.references) {
        return null;
      }
      for (const ref of options.references) {
        ref._referenceType = addressSpace.findReferenceType(ref.referenceType);
        if (!(0, base_node_impl_1.getReferenceType)(ref)) {
          throw new Error("Cannot find referenceType " + JSON.stringify(ref));
        }
        ref.referenceType = ref._referenceType.nodeId;
      }
      return _identifyParentInReference(options.references);
    }
    function prepareName(browseName) {
      const m2 = browseName.name.toString().replace(/[ ]/g, "").replace(/(<|>)/g, "");
      return m2;
    }
    var NodeIdManager = class {
      constructor(namespaceIndex, addressSpace) {
        this._cacheSymbolicName = {};
        this._cacheSymbolicNameRev = /* @__PURE__ */ new Set();
        this._internal_id_counter = 1e3;
        this.namespaceIndex = namespaceIndex;
        this.addressSpace = addressSpace;
      }
      setSymbols(symbols) {
        function convertNodeClass(nodeClass) {
          return node_opcua_data_model_1.NodeClass[nodeClass];
        }
        const symbols2 = symbols.map((e) => [e[0], e[1], convertNodeClass(e[2])]);
        for (const [name, value, nodeClass] of symbols2) {
          this._cacheSymbolicName[name] = [value, nodeClass];
          this._cacheSymbolicNameRev.add(value);
        }
      }
      getSymbols() {
        const line = [];
        for (const [key, [value, nodeClass1]] of Object.entries(this._cacheSymbolicName)) {
          const node = this.addressSpace.findNode((0, node_opcua_nodeid_1.makeNodeId)(value, this.namespaceIndex));
          const nodeClass = node_opcua_data_model_1.NodeClass[nodeClass1 || node_opcua_data_model_1.NodeClass.Unspecified];
          line.push([key, value, nodeClass]);
        }
        return line;
      }
      getSymbolCSV() {
        const line = [];
        for (const [name, value, nodeClass] of this.getSymbols()) {
          line.push([name, value, nodeClass].join(";"));
        }
        return line.join("\n");
      }
      buildNewNodeId() {
        let nodeId;
        do {
          nodeId = (0, node_opcua_nodeid_1.makeNodeId)(this._internal_id_counter, this.namespaceIndex);
          this._internal_id_counter += 1;
        } while (this.addressSpace.findNode(nodeId) || this._isInCache(nodeId));
        return nodeId;
      }
      constructNodeId(options) {
        const compose = (left, right) => {
          return right ? left ? left + "_" + right : right : left;
        };
        const buildUpName2 = (nodeId, suffix) => {
          const namespaceIndex = nodeId.namespace;
          let name = "";
          let n = this.addressSpace.findNode(nodeId);
          while (n && n.nodeId.namespace === namespaceIndex) {
            const e = prepareName(n.browseName) + suffix;
            name = compose(e, name);
            n = n.parentNodeId ? this.addressSpace.findNode(n.parentNodeId) : null;
          }
          return name;
        };
        if (!options.nodeId && options.registerSymbolicNames) {
          const parentInfo = this.findParentNodeId(options);
          let fullParentName = "";
          if (parentInfo) {
            const [parentNodeId, suffix] = parentInfo;
            fullParentName = buildUpName2(parentNodeId, suffix);
          }
          const fullName = compose(fullParentName, prepareName(options.browseName));
          if (this._cacheSymbolicName[fullName]) {
            return (0, node_opcua_nodeid_1.makeNodeId)(this._cacheSymbolicName[fullName][0], this.namespaceIndex);
          }
          const nodeId = this._constructNodeId(options);
          if (nodeId.identifierType === node_opcua_nodeid_1.NodeIdType.NUMERIC) {
            this._cacheSymbolicName[fullName] = [nodeId.value, options.nodeClass];
            this._cacheSymbolicNameRev.add(nodeId.value);
          }
          return nodeId;
        }
        return this._constructNodeId(options);
      }
      _constructNodeId(options) {
        let nodeId = options.nodeId;
        if (!nodeId) {
          const parentInfo = this.findParentNodeId(options);
          if (parentInfo) {
            const [parentNodeId, linkName] = parentInfo;
            const name = prepareName(options.browseName);
            nodeId = null;
            if (parentNodeId.identifierType === node_opcua_nodeid_1.NodeId.NodeIdType.STRING) {
              const childName = parentNodeId.value + exports2.NamespaceOptions.nodeIdNameSeparator + name;
              nodeId = new node_opcua_nodeid_1.NodeId(node_opcua_nodeid_1.NodeId.NodeIdType.STRING, childName, parentNodeId.namespace);
              return nodeId;
            }
          }
        } else if (typeof nodeId === "string") {
          if (this.namespaceIndex !== 0) {
            if (nodeId.match(regExp2)) {
            } else if (nodeId.match(regExp1)) {
              nodeId = "ns=" + this.namespaceIndex + ";" + nodeId;
            }
          }
        }
        nodeId = nodeId || this.buildNewNodeId();
        if (nodeId instanceof node_opcua_nodeid_1.NodeId) {
          (0, node_opcua_assert_1.assert)(nodeId.namespace === this.namespaceIndex);
          return nodeId;
        }
        nodeId = (0, node_opcua_nodeid_1.resolveNodeId)(nodeId);
        (0, node_opcua_assert_1.assert)(nodeId.namespace === this.namespaceIndex);
        return nodeId;
      }
      findParentNodeId(options) {
        return _findParentNodeId(this.addressSpace, options);
      }
      _isInCache(nodeId) {
        if (nodeId.namespace !== this.namespaceIndex || nodeId.identifierType !== node_opcua_nodeid_1.NodeIdType.NUMERIC)
          return false;
        return this._cacheSymbolicNameRev.has(nodeId.value) ? true : false;
      }
    };
    exports2.NodeIdManager = NodeIdManager;
  }
});

// node_modules/node-opcua-address-space/dist/src/data_access/ua_two_state_discrete_impl.js
var require_ua_two_state_discrete_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/data_access/ua_two_state_discrete_impl.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2._addTwoStateDiscrete = exports2.promoteToTwoStateDiscrete = exports2.UATwoStateDiscreteImpl = void 0;
    var node_opcua_assert_1 = __importDefault3(require_dist14());
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_constants_1 = require_dist20();
    var ua_variable_impl_1 = require_ua_variable_impl();
    var register_node_promoter_1 = require_register_node_promoter();
    var add_dataItem_stuff_1 = require_add_dataItem_stuff();
    var UATwoStateDiscreteImpl = class extends ua_variable_impl_1.UAVariableImpl {
      /*
       * @private
       */
      _post_initialize() {
        const handler = this.handle_semantic_changed.bind(this);
        const falseState = this.getPropertyByName("FalseState");
        if (falseState) {
          falseState.on("value_changed", handler);
        } else {
          console.warn("warning: UATwoStateDiscrete -> a FalseState property is mandatory ", this.browseName.toString(), this.nodeId.toString());
        }
        const trueState = this.getPropertyByName("TrueState");
        if (trueState) {
          trueState.on("value_changed", handler);
        } else {
          console.warn("waring: UATwoStateDiscrete -> a TrueState property is mandatory", this.browseName.toString(), this.nodeId.toString());
        }
      }
      setValue(value, options) {
        if (typeof value === "boolean") {
          this.setValueFromSource({ dataType: node_opcua_variant_1.DataType.Boolean, value });
        } else {
          const text2 = (typeof value === "string" ? value : value.text) || "";
          if (text2 === this.getTrueStateAsString()) {
            this.setValue(true, options);
          } else if (text2 === this.getFalseStateAsString()) {
            this.setValue(false, options);
          } else {
            throw new Error("setValue invalid value " + value);
          }
        }
      }
      getValue() {
        return this.readValue().value.value;
      }
      getValueAsString() {
        if (this.getValue()) {
          return this.getTrueStateAsString();
        } else {
          return this.getFalseStateAsString();
        }
      }
      getTrueStateAsString() {
        return this.trueState.readValue().value.value.text || "";
      }
      getFalseStateAsString() {
        return this.falseState.readValue().value.value.text || "";
      }
      clone(options1, optionalFilter, extraInfo) {
        const variable1 = ua_variable_impl_1.UAVariableImpl.prototype.clone.call(this, options1, optionalFilter, extraInfo);
        promoteToTwoStateDiscrete(variable1);
        return variable1;
      }
    };
    exports2.UATwoStateDiscreteImpl = UATwoStateDiscreteImpl;
    function promoteToTwoStateDiscrete(node) {
      if (node instanceof UATwoStateDiscreteImpl) {
        return node;
      }
      Object.setPrototypeOf(node, UATwoStateDiscreteImpl.prototype);
      (0, node_opcua_assert_1.default)(node instanceof UATwoStateDiscreteImpl, "should now  be a UATwoStateDiscrete");
      const _node = node;
      _node._post_initialize();
      return _node;
    }
    exports2.promoteToTwoStateDiscrete = promoteToTwoStateDiscrete;
    (0, register_node_promoter_1.registerNodePromoter)(node_opcua_constants_1.VariableTypeIds.TwoStateDiscreteType, promoteToTwoStateDiscrete);
    function _addTwoStateDiscrete(namespace, options) {
      const addressSpace = namespace.addressSpace;
      (0, node_opcua_assert_1.default)(!Object.prototype.hasOwnProperty.call(options, "ValuePrecision"));
      const twoStateDiscreteType = addressSpace.findVariableType("TwoStateDiscreteType");
      if (!twoStateDiscreteType) {
        throw new Error("expecting TwoStateDiscreteType to be defined , check nodeset xml file");
      }
      let value;
      if (typeof options.value === "boolean") {
        value = new node_opcua_variant_1.Variant({ dataType: node_opcua_variant_1.DataType.Boolean, value: !!options.value });
      } else {
        value = options.value;
      }
      const variable = namespace.addVariable({
        accessLevel: options.accessLevel,
        browseName: options.browseName,
        displayName: options.displayName,
        componentOf: options.componentOf,
        propertyOf: options.propertyOf,
        dataType: node_opcua_variant_1.DataType.Boolean,
        nodeId: options.nodeId,
        typeDefinition: twoStateDiscreteType.nodeId,
        userAccessLevel: options.userAccessLevel,
        modellingRule: options.modellingRule,
        minimumSamplingInterval: options.minimumSamplingInterval,
        value
      });
      const handler = variable.handle_semantic_changed.bind(variable);
      (0, add_dataItem_stuff_1.add_dataItem_stuff)(variable, options);
      const trueStateNode = namespace.addVariable({
        browseName: { name: "TrueState", namespaceIndex: 0 },
        dataType: "LocalizedText",
        minimumSamplingInterval: 0,
        propertyOf: variable,
        typeDefinition: "PropertyType",
        modellingRule: options.modellingRule ? "Mandatory" : void 0,
        value: new node_opcua_variant_1.Variant({
          dataType: node_opcua_variant_1.DataType.LocalizedText,
          value: (0, node_opcua_data_model_1.coerceLocalizedText)(options.trueState || "ON")
        })
      });
      trueStateNode.on("value_changed", handler);
      const falseStateNode = namespace.addVariable({
        browseName: { name: "FalseState", namespaceIndex: 0 },
        dataType: "LocalizedText",
        minimumSamplingInterval: 0,
        propertyOf: variable,
        typeDefinition: "PropertyType",
        modellingRule: options.modellingRule ? "Mandatory" : void 0,
        value: new node_opcua_variant_1.Variant({
          dataType: node_opcua_variant_1.DataType.LocalizedText,
          value: (0, node_opcua_data_model_1.coerceLocalizedText)(options.falseState || "OFF")
        })
      });
      falseStateNode.on("value_changed", handler);
      variable.install_extra_properties();
      return promoteToTwoStateDiscrete(variable);
    }
    exports2._addTwoStateDiscrete = _addTwoStateDiscrete;
  }
});

// node_modules/node-opcua-address-space/dist/src/ua_data_type_impl.js
var require_ua_data_type_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/ua_data_type_impl.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.DataType_toString = exports2.UADataTypeImpl = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_data_model_2 = require_dist27();
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_numeric_range_1 = require_dist31();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_basic_types_1 = require_dist23();
    var session_context_1 = require_session_context2();
    var base_node_impl_1 = require_base_node_impl();
    var base_node_private_1 = require_base_node_private();
    var tool_isSubtypeOf_1 = require_tool_isSubtypeOf();
    var tool_isSubtypeOf_2 = require_tool_isSubtypeOf();
    var tool_isSubtypeOf_3 = require_tool_isSubtypeOf();
    var base_node_private_2 = require_base_node_private();
    var UADataTypeImpl = class _UADataTypeImpl extends base_node_impl_1.BaseNodeImpl {
      /**
       * returns true if this is a super type of baseType
       *
       * @example
       *
       *    var dataTypeDouble = addressSpace.findDataType("Double");
       *    var dataTypeNumber = addressSpace.findDataType("Number");
       *    assert(dataTypeDouble.isSubtypeOf(dataTypeNumber));
       *    assert(!dataTypeNumber.isSubtypeOf(dataTypeDouble));
       *
       */
      get subtypeOf() {
        return tool_isSubtypeOf_2.get_subtypeOf.call(this);
      }
      get subtypeOfObj() {
        return tool_isSubtypeOf_3.get_subtypeOfObj.call(this);
      }
      constructor(options) {
        super(options);
        this.nodeClass = node_opcua_data_model_1.NodeClass.DataType;
        this.definitionName = "";
        this.isSupertypeOf = (0, tool_isSubtypeOf_1.construct_isSubtypeOf)(_UADataTypeImpl);
        this.isSubtypeOf = (0, tool_isSubtypeOf_1.construct_isSubtypeOf)(_UADataTypeImpl);
        if (options.partialDefinition) {
          this.$partialDefinition = options.partialDefinition;
          this.$isUnion = options.isUnion;
        }
        this.isAbstract = options.isAbstract === void 0 || options.isAbstract === null ? false : options.isAbstract;
        this.symbolicName = options.symbolicName || this.browseName.name;
      }
      get basicDataType() {
        return this.getBasicDataType();
      }
      getBasicDataType() {
        return this.addressSpace.findCorrespondingBasicDataType(this);
      }
      readAttribute(context, attributeId, indexRange, dataEncoding) {
        (0, node_opcua_assert_1.assert)(!context || context instanceof session_context_1.SessionContext);
        const options = {};
        switch (attributeId) {
          case node_opcua_data_model_2.AttributeIds.IsAbstract:
            options.statusCode = node_opcua_status_code_1.StatusCodes.Good;
            options.value = { dataType: node_opcua_variant_1.DataType.Boolean, value: !!this.isAbstract };
            break;
          case node_opcua_data_model_2.AttributeIds.DataTypeDefinition:
            {
              const _definition = this._getDefinition()?.clone();
              if (_definition) {
                options.value = { dataType: node_opcua_variant_1.DataType.ExtensionObject, value: _definition };
              } else {
                options.statusCode = node_opcua_status_code_1.StatusCodes.BadAttributeIdInvalid;
              }
            }
            break;
          default:
            return super.readAttribute(context, attributeId, indexRange, dataEncoding);
        }
        return new node_opcua_data_value_1.DataValue(options);
      }
      getEncodingDefinition(encoding_name) {
        const encodingNode = this.getEncodingNode(encoding_name);
        if (!encodingNode) {
          throw new Error("Cannot find Encoding for " + encoding_name);
        }
        const indexRange = new node_opcua_numeric_range_1.NumericRange();
        const descriptionNodeRef = encodingNode.findReferences("HasDescription")[0];
        const descriptionNode = this.addressSpace.findNode(descriptionNodeRef.nodeId);
        if (!descriptionNode) {
          return null;
        }
        const dataValue = descriptionNode.readValue(session_context_1.SessionContext.defaultContext, indexRange);
        return dataValue.value.value.toString() || null;
      }
      getEncodingNode(encoding_name) {
        const _cache = (0, base_node_private_2.BaseNode_getCache)(this);
        _cache._encoding = _cache._encoding || {};
        const key = encoding_name + "Node";
        if (_cache._encoding[key] === void 0) {
          (0, node_opcua_assert_1.assert)(encoding_name === "Default Binary" || encoding_name === "Default XML" || encoding_name === "Default JSON");
          const refs = this.findReferences("HasEncoding", true);
          const addressSpace = this.addressSpace;
          const encoding = refs.map((ref) => addressSpace.findNode(ref.nodeId)).filter((obj) => obj !== null).filter((obj) => obj.browseName.toString() === encoding_name);
          const node = encoding.length === 0 ? null : encoding[0];
          _cache._encoding[key] = node;
        }
        return _cache._encoding[key];
      }
      getEncodingNodeId(encoding_name) {
        const encoding = this.getEncodingNode(encoding_name);
        if (!encoding) {
          return null;
        }
        const namespaceUri = this.addressSpace.getNamespaceUri(encoding.nodeId.namespace);
        return node_opcua_nodeid_1.ExpandedNodeId.fromNodeId(encoding.nodeId, namespaceUri);
      }
      /**
       * returns the encoding of this node's
       * TODO objects have 2 encodings : XML and Binaries
       */
      get binaryEncoding() {
        return this.getEncodingNode("Default Binary");
      }
      get binaryEncodingDefinition() {
        return this.getEncodingDefinition("Default Binary");
      }
      get binaryEncodingNodeId() {
        return this.getEncodingNodeId("Default Binary");
      }
      get xmlEncoding() {
        return this.getEncodingNode("Default XML");
      }
      get xmlEncodingNodeId() {
        return this.getEncodingNodeId("Default XML");
      }
      get xmlEncodingDefinition() {
        return this.getEncodingDefinition("Default XML");
      }
      get jsonEncoding() {
        return this.getEncodingNode("Default JSON");
      }
      get jsonEncodingNodeId() {
        return this.getEncodingNodeId("Default JSON");
      }
      //  public get jsonEncodingDefinition(): string | null {
      //      return this.getEncodingDefinition("Default JSON");
      //  }
      _getEnumerationInfo() {
        let definition = [];
        if (this.enumStrings) {
          const enumStrings = this.enumStrings.readValue().value.value;
          (0, node_opcua_assert_1.assert)(Array.isArray(enumStrings));
          definition = enumStrings.map((e, index) => {
            return {
              name: e.text,
              value: index
            };
          });
        } else if (this.enumValues) {
          (0, node_opcua_assert_1.assert)(this.enumValues, "must have a enumValues property");
          const enumValues = this.enumValues.readValue().value.value;
          (0, node_opcua_assert_1.assert)(Array.isArray(enumValues));
          definition = enumValues.map((e) => {
            return {
              name: e.displayName.text,
              value: (0, node_opcua_basic_types_1.coerceInt64toInt32)(e.value)
            };
          });
        }
        const indexes = {
          nameIndex: {},
          valueIndex: {}
        };
        for (const e of definition) {
          indexes.nameIndex[e.name] = e;
          indexes.valueIndex[e.value] = e;
        }
        return indexes;
      }
      isStructure() {
        const definition = this._getDefinition();
        return !!definition && definition instanceof node_opcua_types_1.StructureDefinition;
      }
      getStructureDefinition() {
        const definition = this._getDefinition();
        (0, node_opcua_assert_1.assert)(definition instanceof node_opcua_types_1.StructureDefinition);
        return definition;
      }
      isEnumeration() {
        const definition = this._getDefinition();
        return !!definition && definition instanceof node_opcua_types_1.EnumDefinition;
      }
      getEnumDefinition() {
        const definition = this._getDefinition();
        (0, node_opcua_assert_1.assert)(definition instanceof node_opcua_types_1.EnumDefinition);
        return definition;
      }
      // eslint-disable-next-line complexity
      _getDefinition() {
        if (this.$fullDefinition !== void 0) {
          return this.$fullDefinition;
        }
        const addressSpace = this.addressSpace;
        const enumeration = addressSpace.findDataType("Enumeration");
        const structure = addressSpace.findDataType("Structure");
        const union = addressSpace.findDataType("Union");
        const isEnumeration = enumeration && this.isSubtypeOf(enumeration);
        const isStructure = structure && this.isSubtypeOf(structure);
        const isUnion = !!(structure && union && this.isSubtypeOf(union));
        const isRootDataType = (n) => n.nodeId.namespace === 0 && n.nodeId.value === node_opcua_constants_1.DataTypeIds.BaseDataType;
        if (isStructure) {
          let dataTypeNode = this;
          const allPartialDefinitions = [];
          while (dataTypeNode && !isRootDataType(dataTypeNode)) {
            if (dataTypeNode.$partialDefinition) {
              allPartialDefinitions.push(dataTypeNode.$partialDefinition);
            }
            dataTypeNode = dataTypeNode.subtypeOfObj;
          }
          const definitionFields = [];
          for (const dd of allPartialDefinitions.reverse()) {
            definitionFields.push(...dd);
          }
          const basicDataType = this.subtypeOfObj?.nodeId || new node_opcua_nodeid_1.NodeId();
          const defaultEncodingId = this.binaryEncodingNodeId || this.xmlEncodingNodeId || new node_opcua_nodeid_1.NodeId();
          const definitionName = this.browseName.name;
          this.$fullDefinition = makeStructureDefinition(definitionName, basicDataType, defaultEncodingId, definitionFields, isUnion);
        } else if (isEnumeration) {
          const allPartialDefinitions = [];
          let dataTypeNode = this;
          while (dataTypeNode && !isRootDataType(dataTypeNode)) {
            if (dataTypeNode.$partialDefinition) {
              allPartialDefinitions.push(dataTypeNode.$partialDefinition);
            }
            dataTypeNode = dataTypeNode.subtypeOfObj;
          }
          const definitionFields = [];
          for (const dd of allPartialDefinitions.reverse()) {
            definitionFields.push(...dd);
          }
          this.$fullDefinition = makeEnumDefinition(definitionFields);
        }
        return this.$fullDefinition;
      }
      getDefinition() {
        const d2 = this._getDefinition();
        if (!d2) {
          throw new Error("DataType has no definition property");
        }
        return d2;
      }
      install_extra_properties() {
      }
      toString() {
        const options = new base_node_private_1.ToStringBuilder();
        DataType_toString.call(this, options);
        return options.toString();
      }
    };
    exports2.UADataTypeImpl = UADataTypeImpl;
    function dataTypeDefinition_toString(options) {
      const definition = this._getDefinition();
      if (!definition) {
        return;
      }
      const output = definition.toString();
      options.add(options.padding + chalk_1.default.yellow(" Definition                   :             "));
      for (const str of output.split("\n")) {
        options.add(options.padding + chalk_1.default.yellow("                              :   " + str));
      }
    }
    function DataType_toString(options) {
      base_node_private_1.BaseNode_toString.call(this, options);
      options.add(options.padding + chalk_1.default.yellow("          isAbstract          : " + this.isAbstract));
      options.add(options.padding + chalk_1.default.yellow("          definitionName      : " + this.definitionName));
      options.add(options.padding + chalk_1.default.yellow("          binaryEncodingNodeId: ") + (this.binaryEncodingNodeId ? this.binaryEncodingNodeId.toString() : "<none>"));
      options.add(options.padding + chalk_1.default.yellow("          xmlEncodingNodeId   : ") + (this.xmlEncodingNodeId ? this.xmlEncodingNodeId.toString() : "<none>"));
      options.add(options.padding + chalk_1.default.yellow("          jsonEncodingNodeId  : ") + (this.jsonEncodingNodeId ? this.jsonEncodingNodeId.toString() : "<none>"));
      if (this.subtypeOfObj) {
        options.add(options.padding + chalk_1.default.yellow("          subtypeOfObj        : ") + (this.subtypeOfObj ? this.subtypeOfObj.browseName.toString() : ""));
      }
      base_node_private_1.BaseNode_References_toString.call(this, options);
      dataTypeDefinition_toString.call(this, options);
    }
    exports2.DataType_toString = DataType_toString;
    var defaultEnumValue = (0, node_opcua_basic_types_1.coerceInt64)(-1);
    function makeEnumDefinition(definitionFields) {
      return new node_opcua_types_1.EnumDefinition({
        fields: definitionFields.map((x2) => ({
          description: x2.description,
          name: x2.name,
          value: x2.value === void 0 ? defaultEnumValue : (0, node_opcua_basic_types_1.coerceInt64)(x2.value)
        }))
      });
    }
    function makeStructureDefinition(name, baseDataType, defaultEncodingId, fields, isUnion) {
      const hasOptionalFields = fields.filter((field) => field.isOptional).length > 0;
      const structureType = isUnion ? node_opcua_types_1.StructureType.Union : hasOptionalFields ? node_opcua_types_1.StructureType.StructureWithOptionalFields : node_opcua_types_1.StructureType.Structure;
      const sd = new node_opcua_types_1.StructureDefinition({
        baseDataType,
        defaultEncodingId,
        fields,
        structureType
      });
      return sd;
    }
  }
});

// node_modules/node-opcua-address-space/dist/src/ua_method_impl.js
var require_ua_method_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/ua_method_impl.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UAMethodImpl = void 0;
    var util_1 = require("util");
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_data_model_2 = require_dist27();
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_service_call_1 = require_dist41();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_variant_2 = require_dist28();
    var node_opcua_address_space_base_1 = require_dist53();
    var base_node_private_1 = require_base_node_private();
    var namespace_impl_1 = require_namespace_impl();
    var base_node_impl_1 = require_base_node_impl();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    function default_check_valid_argument(arg) {
      return arg instanceof node_opcua_service_call_1.Argument;
    }
    var UAMethodImpl = class _UAMethodImpl extends base_node_impl_1.BaseNodeImpl {
      static checkValidArgument(args) {
        return default_check_valid_argument(args);
      }
      get typeDefinitionObj() {
        return super.typeDefinitionObj;
      }
      get parent() {
        return super.parent;
      }
      constructor(options) {
        super(options);
        this.nodeClass = node_opcua_data_model_2.NodeClass.Method;
        this.value = options.value;
        this.methodDeclarationId = options.methodDeclarationId;
      }
      /**
       *
       *
       */
      getExecutableFlag(context) {
        if (!this.isBound()) {
          return false;
        }
        if (this._getExecutableFlag) {
          return this._getExecutableFlag(context);
        }
        return true;
      }
      getUserExecutableFlag(context) {
        if (context && !context.checkPermission(this, node_opcua_types_1.PermissionType.Call)) {
          return false;
        }
        if (!this.getExecutableFlag(context))
          return false;
        return true;
      }
      /**
       *
       * @returns  true if the method is bound
       */
      isBound() {
        return typeof this._asyncExecutionFunction === "function";
      }
      readAttribute(context, attributeId, indexRange, dataEncoding) {
        const options = {};
        switch (attributeId) {
          case node_opcua_data_model_1.AttributeIds.Executable:
            options.value = { dataType: node_opcua_variant_2.DataType.Boolean, value: this.getExecutableFlag(context) };
            options.statusCode = node_opcua_status_code_1.StatusCodes.Good;
            break;
          case node_opcua_data_model_1.AttributeIds.UserExecutable:
            options.value = { dataType: node_opcua_variant_2.DataType.Boolean, value: this.getUserExecutableFlag(context) };
            options.statusCode = node_opcua_status_code_1.StatusCodes.Good;
            break;
          default:
            return base_node_impl_1.BaseNodeImpl.prototype.readAttribute.call(this, context, attributeId, indexRange, dataEncoding);
        }
        return new node_opcua_data_value_1.DataValue(options);
      }
      getInputArguments() {
        return this._getArguments("InputArguments");
      }
      getOutputArguments() {
        return this._getArguments("OutputArguments");
      }
      bindMethod(async_func) {
        (0, node_opcua_assert_1.assert)(typeof async_func === "function");
        if (async_func.length === 2) {
          async_func = (0, util_1.callbackify)(async_func);
        }
        (0, node_opcua_assert_1.assert)(async_func.length === 3, " a method with callback should have 3 arguments : got " + async_func.length);
        this._asyncExecutionFunction = async_func;
      }
      execute(object, inputArguments, context, callback) {
        if (!callback) {
          throw new Error("execute need to be promisified");
        }
        (0, node_opcua_assert_1.assert)(inputArguments === null || Array.isArray(inputArguments));
        inputArguments = inputArguments || [];
        inputArguments = inputArguments.map(node_opcua_variant_1.Variant.coerce);
        (0, node_opcua_assert_1.assert)(inputArguments.length === 0 || inputArguments[0] instanceof node_opcua_variant_1.Variant);
        (0, node_opcua_assert_1.assert)(context !== null && typeof context === "object");
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        object = object || this.parent;
        if (!object) {
          errorLog("UAMethod#execute expects a valid object");
          return callback(null, { statusCode: node_opcua_status_code_1.StatusCodes.BadInternalError });
        }
        if (object.nodeClass !== node_opcua_data_model_2.NodeClass.Object && object.nodeClass !== node_opcua_data_model_2.NodeClass.ObjectType) {
          warningLog("Method " + this.nodeId.toString() + " " + this.browseName.toString() + " called for a node that is not a Object/ObjectType but " + node_opcua_data_model_2.NodeClass[context.object.nodeClass]);
          return callback(null, { statusCode: node_opcua_status_code_1.StatusCodes.BadNodeIdInvalid });
        }
        if (!this._asyncExecutionFunction) {
          warningLog("Method " + this.nodeId.toString() + " " + this.browseName.toString() + " has not been bound");
          return callback(null, { statusCode: node_opcua_status_code_1.StatusCodes.BadInternalError });
        }
        if (!this.getExecutableFlag(context)) {
          warningLog("Method " + this.nodeId.toString() + " " + this.browseName.toString() + " is not executable");
          return callback(null, { statusCode: node_opcua_status_code_1.StatusCodes.BadNotExecutable });
        }
        if (context.isAccessRestricted(this)) {
          return callback(null, { statusCode: node_opcua_status_code_1.StatusCodes.BadSecurityModeInsufficient });
        }
        if (!context.checkPermission(this, node_opcua_types_1.PermissionType.Call)) {
          return callback(null, { statusCode: node_opcua_status_code_1.StatusCodes.BadUserAccessDenied });
        }
        const inputArgumentDiagnosticInfos = [];
        context.object = object;
        try {
          this._asyncExecutionFunction.call(this, inputArguments, context, (err, callMethodResult) => {
            if (err) {
              debugLog(err.message);
              debugLog(err);
            }
            callMethodResult = callMethodResult || {};
            callMethodResult.statusCode = callMethodResult.statusCode || node_opcua_status_code_1.StatusCodes.Good;
            callMethodResult.outputArguments = callMethodResult.outputArguments || [];
            callMethodResult.inputArgumentResults = callMethodResult.inputArgumentResults?.length === inputArguments?.length ? callMethodResult.inputArgumentResults : inputArguments?.map(() => node_opcua_status_code_1.StatusCodes.Good);
            callMethodResult.inputArgumentDiagnosticInfos = callMethodResult.inputArgumentDiagnosticInfos || inputArgumentDiagnosticInfos;
            callback(err, callMethodResult);
          });
        } catch (err) {
          if (util_1.types.isNativeError(err)) {
            warningLog(chalk_1.default.red("ERR in method  handler"), err.message);
            warningLog(err.stack);
          }
          const callMethodResponse = { statusCode: node_opcua_status_code_1.StatusCodes.BadInternalError };
          callback(err, callMethodResponse);
        }
      }
      clone(options, optionalFilter, extraInfo) {
        (0, node_opcua_assert_1.assert)(!options.componentOf || options.componentOf, "trying to create an orphan method ?");
        const addressSpace = this.addressSpace;
        options = {
          ...options,
          methodDeclarationId: this.nodeId
        };
        options.references = options.references || [];
        (0, namespace_impl_1._handle_hierarchy_parent)(addressSpace, options.references, options);
        if (!extraInfo) {
          extraInfo = (0, node_opcua_address_space_base_1.makeDefaultCloneExtraInfo)(this);
        }
        const clonedMethod = (0, base_node_private_1._clone)(this, _UAMethodImpl, options, optionalFilter || node_opcua_address_space_base_1.defaultCloneFilter, extraInfo);
        clonedMethod._asyncExecutionFunction = this._asyncExecutionFunction;
        clonedMethod._getExecutableFlag = this._getExecutableFlag;
        if (options.componentOf) {
          const m2 = options.componentOf.getMethodByName(clonedMethod.browseName.name);
          (0, node_opcua_assert_1.assert)(m2);
        }
        return clonedMethod;
      }
      _getArguments(name) {
        (0, node_opcua_assert_1.assert)(name === "InputArguments" || name === "OutputArguments");
        const argsVariable = this.getPropertyByName(name);
        if (!argsVariable) {
          return [];
        }
        (0, node_opcua_assert_1.assert)(argsVariable.nodeClass === node_opcua_data_model_2.NodeClass.Variable);
        const args = argsVariable.readValue().value.value;
        if (!args) {
          return [];
        }
        (0, node_opcua_assert_1.assert)(Array.isArray(args));
        (0, node_opcua_assert_1.assert)(args.length === 0 || _UAMethodImpl.checkValidArgument(args[0]));
        return args;
      }
    };
    exports2.UAMethodImpl = UAMethodImpl;
    var thenify = require_thenify();
    UAMethodImpl.prototype.execute = thenify.withCallback(UAMethodImpl.prototype.execute);
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/state_machine/ua_state_machine_type.js
var require_ua_state_machine_type = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/state_machine/ua_state_machine_type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/state_machine/ua_exclusive_limit_state_machine_type_ex.js
var require_ua_exclusive_limit_state_machine_type_ex = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/state_machine/ua_exclusive_limit_state_machine_type_ex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/state_machine/ua_finite_state_machine_type.js
var require_ua_finite_state_machine_type = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/state_machine/ua_finite_state_machine_type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/state_machine/ua_program_state_machine_type.js
var require_ua_program_state_machine_type = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/state_machine/ua_program_state_machine_type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/state_machine/ua_shelved_state_machine_ex.js
var require_ua_shelved_state_machine_ex = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/state_machine/ua_shelved_state_machine_ex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/state_machine/ua_transition_ex.js
var require_ua_transition_ex = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/state_machine/ua_transition_ex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/ua_subscription_diagnostics_variable_ex.js
var require_ua_subscription_diagnostics_variable_ex = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/ua_subscription_diagnostics_variable_ex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/data_access/ua_multistate_discrete_ex.js
var require_ua_multistate_discrete_ex = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/data_access/ua_multistate_discrete_ex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/data_access/ua_multistate_value_discrete_ex.js
var require_ua_multistate_value_discrete_ex = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/data_access/ua_multistate_value_discrete_ex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/data_access/ua_two_state_discrete_ex.js
var require_ua_two_state_discrete_ex = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/data_access/ua_two_state_discrete_ex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/data_access/ua_y_array_item_ex.js
var require_ua_y_array_item_ex = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/data_access/ua_y_array_item_ex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/extension_object_constructor.js
var require_extension_object_constructor = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/extension_object_constructor.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/condition_info_i.js
var require_condition_info_i = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/condition_info_i.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/condition_snapshot.js
var require_condition_snapshot = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/condition_snapshot.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/instantiate_alarm_condition_options.js
var require_instantiate_alarm_condition_options = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/instantiate_alarm_condition_options.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/instantiate_condition_options.js
var require_instantiate_condition_options = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/instantiate_condition_options.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/instantiate_exclusive_limit_alarm_options.js
var require_instantiate_exclusive_limit_alarm_options = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/instantiate_exclusive_limit_alarm_options.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/instantiate_limit_alarm_options.js
var require_instantiate_limit_alarm_options = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/instantiate_limit_alarm_options.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/instantiate_off_normal_alarm_options.js
var require_instantiate_off_normal_alarm_options = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/instantiate_off_normal_alarm_options.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/ua_acknowledgeable_condition_ex.js
var require_ua_acknowledgeable_condition_ex = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/ua_acknowledgeable_condition_ex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/ua_alarm_condition_ex.js
var require_ua_alarm_condition_ex = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/ua_alarm_condition_ex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/ua_certificate_expiration_alarm_ex.js
var require_ua_certificate_expiration_alarm_ex = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/ua_certificate_expiration_alarm_ex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/ua_condition_ex.js
var require_ua_condition_ex = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/ua_condition_ex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/ua_discrete_alarm_ex.js
var require_ua_discrete_alarm_ex = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/ua_discrete_alarm_ex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/ua_exclusive_deviation_alarm_ex.js
var require_ua_exclusive_deviation_alarm_ex = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/ua_exclusive_deviation_alarm_ex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/ua_exclusive_limit_alarm_ex.js
var require_ua_exclusive_limit_alarm_ex = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/ua_exclusive_limit_alarm_ex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/ua_limit_alarm_ex.js
var require_ua_limit_alarm_ex = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/ua_limit_alarm_ex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/ua_non_exclusive_deviation_alarm_ex.js
var require_ua_non_exclusive_deviation_alarm_ex = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/ua_non_exclusive_deviation_alarm_ex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/ua_non_exclusive_limit_alarm_ex.js
var require_ua_non_exclusive_limit_alarm_ex = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/interfaces/alarms_and_conditions/ua_non_exclusive_limit_alarm_ex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/helpers/coerce_enum_value.js
var require_coerce_enum_value = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/helpers/coerce_enum_value.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.coerceEnumValues = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_types_1 = require_dist32();
    function coerceEnumValues(enumValues) {
      if (Array.isArray(enumValues)) {
        return enumValues.map((en) => {
          (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(en, "value"));
          (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(en, "displayName"));
          return new node_opcua_types_1.EnumValueType({
            displayName: (0, node_opcua_data_model_1.coerceLocalizedText)(en.displayName),
            value: (0, node_opcua_basic_types_1.coerceInt64)(en.value || 0)
          });
        });
      } else {
        return coerceEnumValues(Object.entries(enumValues).map((entry) => {
          const [key, value] = entry;
          return new node_opcua_types_1.EnumValueType({
            description: (0, node_opcua_data_model_1.coerceLocalizedText)(key),
            displayName: (0, node_opcua_data_model_1.coerceLocalizedText)(key),
            value: (0, node_opcua_basic_types_1.coerceInt64)(value)
          });
        }));
      }
    }
    exports2.coerceEnumValues = coerceEnumValues;
  }
});

// node_modules/node-opcua-address-space/dist/src/data_access/ua_multistate_value_discrete_impl.js
var require_ua_multistate_value_discrete_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/data_access/ua_multistate_value_discrete_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.validateDataType = exports2.validateIsNumericDataType = exports2._addMultiStateValueDiscrete = exports2.promoteToMultiStateValueDiscrete = exports2.UAMultiStateValueDiscreteImpl = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_constants_1 = require_dist20();
    var get_basic_datatype_1 = require_get_basic_datatype();
    var register_node_promoter_1 = require_register_node_promoter();
    var coerce_enum_value_1 = require_coerce_enum_value();
    var ua_variable_impl_1 = require_ua_variable_impl();
    var add_dataItem_stuff_1 = require_add_dataItem_stuff();
    function convertToArray(array) {
      if (Array.isArray(array))
        return array;
      const result2 = [];
      for (let i = 0; i < array.length; i++) {
        result2[i] = array[i];
      }
      return result2;
    }
    var getCoerceToInt32 = (dataType) => {
      switch (dataType) {
        case node_opcua_variant_1.DataType.UInt64:
          return node_opcua_basic_types_1.coerceUInt64toInt32;
        case node_opcua_variant_1.DataType.Int64:
          return node_opcua_basic_types_1.coerceInt64toInt32;
        default:
          return node_opcua_basic_types_1.coerceInt32;
      }
    };
    function install_synchronization(variable) {
      const _variable = variable;
      _variable.on("value_changed", (dataValue2) => {
        const valueAsTextNode = variable.valueAsText || _variable.getComponentByName("ValueAsText");
        if (!valueAsTextNode) {
          return;
        }
        if (dataValue2.value.arrayType === node_opcua_variant_1.VariantArrayType.Array || dataValue2.value.arrayType === node_opcua_variant_1.VariantArrayType.Matrix) {
          const coerce = getCoerceToInt32(_variable.getBasicDataType());
          const values = convertToArray(dataValue2.value.value).map((a) => (0, node_opcua_basic_types_1.coerceInt32)(a));
          const variantArray = values.map((a) => _variable.findValueAsText(a));
          const localizedText = variantArray.map((a) => a.value);
          const valueAsText1 = new node_opcua_variant_1.Variant({
            arrayType: dataValue2.value.arrayType,
            dataType: node_opcua_variant_1.DataType.LocalizedText,
            value: localizedText,
            dimensions: dataValue2.value.dimensions
          });
          valueAsTextNode.setValueFromSource(valueAsText1);
        } else {
          const valueAsText1 = _variable.findValueAsText(dataValue2.value.value);
          valueAsTextNode.setValueFromSource(valueAsText1);
        }
      });
      const dataValue = _variable.readValue();
      _variable.emit("value_changed", dataValue);
    }
    var UAMultiStateValueDiscreteImpl = class extends ua_variable_impl_1.UAVariableImpl {
      setValue(value, options) {
        if (typeof value === "string") {
          const enumValues = this.enumValues.readValue().value.value;
          const selected = enumValues.filter((a) => a.displayName.text === value)[0];
          if (selected) {
            this._setValue(selected.value);
          } else {
            throw new Error("cannot find enum string " + value + " in " + enumValues.toString());
          }
        } else {
          this._setValue((0, node_opcua_basic_types_1.coerceUInt64)(value), options);
        }
      }
      getValueAsString() {
        const v = this.valueAsText.readValue().value.value;
        if (Array.isArray(v)) {
          return v.map((a) => a.text);
        }
        return v.text || "";
      }
      getValueAsNumber() {
        return this.readValue().value.value;
      }
      checkVariantCompatibility(value) {
        if (this.enumValues) {
          if (!this._isValueInRange((0, node_opcua_basic_types_1.coerceInt32)(value.value))) {
            return node_opcua_status_code_1.StatusCodes.BadOutOfRange;
          }
        }
        return node_opcua_status_code_1.StatusCodes.Good;
      }
      clone(options1, optionalFilter, extraInfo) {
        const variable1 = ua_variable_impl_1.UAVariableImpl.prototype.clone.call(this, options1, optionalFilter, extraInfo);
        return promoteToMultiStateValueDiscrete(variable1);
      }
      /**
       * @private
       */
      _isValueInRange(value) {
        const enumValues = this.enumValues.readValue().value.value;
        const e = enumValues.findIndex((x2) => (0, node_opcua_basic_types_1.coerceInt64toInt32)(x2.value) === value);
        return !(e === -1);
      }
      /**
       *
       * @private
       */
      _enumValueIndex() {
        const enumValues = this.enumValues.readValue().value.value;
        const enumValueIndex = {};
        if (!enumValues || !enumValues.forEach) {
          return enumValueIndex;
        }
        enumValues.forEach((e) => {
          const index = (0, node_opcua_basic_types_1.coerceInt64toInt32)(e.value);
          enumValueIndex[index] = e;
        });
        return enumValueIndex;
      }
      /**
       *
       * @private
       */
      _setValue(value, options) {
        const int32Value = (0, node_opcua_basic_types_1.coerceInt64toInt32)(value);
        if (!this._isValueInRange(int32Value)) {
          throw new Error("UAMultiStateValueDiscrete#_setValue out of range " + value);
        }
        const dataType = this._getDataType();
        if (dataType === node_opcua_variant_1.DataType.Int64 || dataType === node_opcua_variant_1.DataType.UInt64) {
          this.setValueFromSource({ dataType, arrayType: node_opcua_variant_1.VariantArrayType.Scalar, value });
        } else {
          this.setValueFromSource({ dataType, arrayType: node_opcua_variant_1.VariantArrayType.Scalar, value: int32Value });
        }
      }
      /**
       *
       * @private
       */
      findValueAsText(value) {
        const enumValueIndex = this._enumValueIndex();
        if (value === void 0) {
          throw new Error("Unexpected undefined value");
        }
        const valueAsInt32 = (0, node_opcua_basic_types_1.coerceInt64toInt32)(value);
        let valueAsText1 = "Invalid";
        if (enumValueIndex[valueAsInt32] !== void 0) {
          valueAsText1 = enumValueIndex[valueAsInt32].displayName.text || `Invalid:${value}`;
        }
        const result2 = new node_opcua_variant_1.Variant({
          dataType: node_opcua_variant_1.DataType.LocalizedText,
          value: (0, node_opcua_data_model_1.coerceLocalizedText)(valueAsText1)
        });
        return result2;
      }
      _getDataType() {
        if (this.dataType.value === 26) {
          return node_opcua_variant_1.DataType.UInt32;
        }
        const dataTypeStr = node_opcua_variant_1.DataType[this.dataType.value];
        return node_opcua_variant_1.DataType[dataTypeStr];
      }
      /**
       *
       * @private
       */
      _post_initialize() {
        validateIsNumericDataType(this.dataType.value);
        install_synchronization(this);
      }
    };
    exports2.UAMultiStateValueDiscreteImpl = UAMultiStateValueDiscreteImpl;
    function promoteToMultiStateValueDiscrete(node) {
      if (node instanceof UAMultiStateValueDiscreteImpl) {
        return node;
      }
      Object.setPrototypeOf(node, UAMultiStateValueDiscreteImpl.prototype);
      (0, node_opcua_assert_1.assert)(node instanceof UAMultiStateValueDiscreteImpl, "should now  be a State Machine");
      node._post_initialize();
      return node;
    }
    exports2.promoteToMultiStateValueDiscrete = promoteToMultiStateValueDiscrete;
    (0, register_node_promoter_1.registerNodePromoter)(node_opcua_constants_1.VariableTypeIds.MultiStateValueDiscreteType, promoteToMultiStateValueDiscrete);
    function _addMultiStateValueDiscrete(namespace, options) {
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "enumValues"));
      (0, node_opcua_assert_1.assert)(!Object.prototype.hasOwnProperty.call(options, "ValuePrecision"));
      const addressSpace = namespace.addressSpace;
      const multiStateValueDiscreteType = addressSpace.findVariableType("MultiStateValueDiscreteType");
      if (!multiStateValueDiscreteType) {
        throw new Error("expecting MultiStateValueDiscreteType to be defined , check nodeset xml file");
      }
      const enumValues = (0, coerce_enum_value_1.coerceEnumValues)(options.enumValues);
      if (options.value === void 0 && enumValues[0]) {
        options.value = enumValues[0].value;
      }
      const dataType = (0, get_basic_datatype_1._getBasicDataTypeFromDataTypeNodeId)(addressSpace, options.dataType || node_opcua_variant_1.DataType.UInt32);
      let value;
      if (typeof options.value === "number" || (0, node_opcua_basic_types_1.isValidUInt64)(options.value) || (0, node_opcua_basic_types_1.isValidInt64)(options.value)) {
        value = new node_opcua_variant_1.Variant({
          dataType,
          value: options.value
        });
      } else {
        value = options.value;
      }
      const cloned_options = {
        ...options,
        dataType,
        typeDefinition: multiStateValueDiscreteType.nodeId,
        // valueRank:
        // note : OPCUA Spec 1.03 specifies -1:Scalar (part 8 page 8) but nodeset file specifies -2:Any
        value,
        // limitation:  although the Specs specify -2:any, we only support -1(Scalar)
        valueRank: -1
        // -1 : Scalar
      };
      const variable = namespace.addVariable(cloned_options);
      (0, add_dataItem_stuff_1.add_dataItem_stuff)(variable, options);
      namespace.addVariable({
        accessLevel: "CurrentRead",
        browseName: { name: "EnumValues", namespaceIndex: 0 },
        dataType: "EnumValueType",
        valueRank: 1,
        minimumSamplingInterval: 0,
        modellingRule: options.modellingRule ? "Mandatory" : void 0,
        propertyOf: variable,
        typeDefinition: "PropertyType",
        userAccessLevel: "CurrentRead",
        value: new node_opcua_variant_1.Variant({
          arrayType: node_opcua_variant_1.VariantArrayType.Array,
          dataType: node_opcua_variant_1.DataType.ExtensionObject,
          value: enumValues
        })
      });
      namespace.addVariable({
        accessLevel: "CurrentRead",
        browseName: { name: "ValueAsText", namespaceIndex: 0 },
        dataType: node_opcua_variant_1.DataType.LocalizedText,
        minimumSamplingInterval: 0,
        modellingRule: options.modellingRule ? "Mandatory" : void 0,
        propertyOf: variable,
        arrayDimensions: options.arrayDimensions,
        valueRank: options.valueRank,
        typeDefinition: "PropertyType",
        userAccessLevel: "CurrentRead"
        // value: valueAsText
      });
      variable.install_extra_properties();
      promoteToMultiStateValueDiscrete(variable);
      (0, node_opcua_assert_1.assert)(variable.enumValues.browseName.toString() === "EnumValues");
      (0, node_opcua_assert_1.assert)(variable.valueAsText.browseName.toString() === "ValueAsText");
      return variable;
    }
    exports2._addMultiStateValueDiscrete = _addMultiStateValueDiscrete;
    var validBasicNumericDataTypes = [
      node_opcua_variant_1.DataType.UInt64,
      node_opcua_variant_1.DataType.Int64,
      node_opcua_variant_1.DataType.UInt32,
      node_opcua_variant_1.DataType.Int32,
      node_opcua_variant_1.DataType.UInt16,
      node_opcua_variant_1.DataType.Int16,
      node_opcua_variant_1.DataType.Byte,
      node_opcua_variant_1.DataType.Byte,
      node_opcua_variant_1.DataType.SByte,
      26
      /*Number*/
    ];
    function validateIsNumericDataType(dataTypeValue) {
      if (typeof dataTypeValue !== "number" || validBasicNumericDataTypes.indexOf(dataTypeValue) < 0) {
        throw new Error(`Invalid DataType in UAMultiStateValueDiscrete => ${dataTypeValue.toString()}`);
      }
    }
    exports2.validateIsNumericDataType = validateIsNumericDataType;
    exports2.validateDataType = validateIsNumericDataType;
  }
});

// node_modules/node-opcua-address-space/dist/source/ua_root_folder.js
var require_ua_root_folder = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/ua_root_folder.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/async/dist/async.js
var require_async = __commonJS({
  "node_modules/async/dist/async.js"(exports2, module2) {
    (function(global2, factory) {
      typeof exports2 === "object" && typeof module2 !== "undefined" ? factory(exports2) : typeof define === "function" && define.amd ? define(["exports"], factory) : (global2 = typeof globalThis !== "undefined" ? globalThis : global2 || self, factory(global2.async = {}));
    })(exports2, function(exports3) {
      "use strict";
      function apply(fn, ...args) {
        return (...callArgs) => fn(...args, ...callArgs);
      }
      function initialParams(fn) {
        return function(...args) {
          var callback = args.pop();
          return fn.call(this, args, callback);
        };
      }
      var hasQueueMicrotask = typeof queueMicrotask === "function" && queueMicrotask;
      var hasSetImmediate = typeof setImmediate === "function" && setImmediate;
      var hasNextTick = typeof process === "object" && typeof process.nextTick === "function";
      function fallback(fn) {
        setTimeout(fn, 0);
      }
      function wrap(defer) {
        return (fn, ...args) => defer(() => fn(...args));
      }
      var _defer$1;
      if (hasQueueMicrotask) {
        _defer$1 = queueMicrotask;
      } else if (hasSetImmediate) {
        _defer$1 = setImmediate;
      } else if (hasNextTick) {
        _defer$1 = process.nextTick;
      } else {
        _defer$1 = fallback;
      }
      var setImmediate$1 = wrap(_defer$1);
      function asyncify(func) {
        if (isAsync(func)) {
          return function(...args) {
            const callback = args.pop();
            const promise = func.apply(this, args);
            return handlePromise(promise, callback);
          };
        }
        return initialParams(function(args, callback) {
          var result2;
          try {
            result2 = func.apply(this, args);
          } catch (e) {
            return callback(e);
          }
          if (result2 && typeof result2.then === "function") {
            return handlePromise(result2, callback);
          } else {
            callback(null, result2);
          }
        });
      }
      function handlePromise(promise, callback) {
        return promise.then((value) => {
          invokeCallback(callback, null, value);
        }, (err) => {
          invokeCallback(callback, err && (err instanceof Error || err.message) ? err : new Error(err));
        });
      }
      function invokeCallback(callback, error, value) {
        try {
          callback(error, value);
        } catch (err) {
          setImmediate$1((e) => {
            throw e;
          }, err);
        }
      }
      function isAsync(fn) {
        return fn[Symbol.toStringTag] === "AsyncFunction";
      }
      function isAsyncGenerator(fn) {
        return fn[Symbol.toStringTag] === "AsyncGenerator";
      }
      function isAsyncIterable(obj) {
        return typeof obj[Symbol.asyncIterator] === "function";
      }
      function wrapAsync(asyncFn) {
        if (typeof asyncFn !== "function")
          throw new Error("expected a function");
        return isAsync(asyncFn) ? asyncify(asyncFn) : asyncFn;
      }
      function awaitify(asyncFn, arity) {
        if (!arity)
          arity = asyncFn.length;
        if (!arity)
          throw new Error("arity is undefined");
        function awaitable(...args) {
          if (typeof args[arity - 1] === "function") {
            return asyncFn.apply(this, args);
          }
          return new Promise((resolve2, reject2) => {
            args[arity - 1] = (err, ...cbArgs) => {
              if (err)
                return reject2(err);
              resolve2(cbArgs.length > 1 ? cbArgs : cbArgs[0]);
            };
            asyncFn.apply(this, args);
          });
        }
        return awaitable;
      }
      function applyEach$1(eachfn) {
        return function applyEach2(fns, ...callArgs) {
          const go = awaitify(function(callback) {
            var that = this;
            return eachfn(fns, (fn, cb) => {
              wrapAsync(fn).apply(that, callArgs.concat(cb));
            }, callback);
          });
          return go;
        };
      }
      function _asyncMap(eachfn, arr, iteratee, callback) {
        arr = arr || [];
        var results = [];
        var counter = 0;
        var _iteratee = wrapAsync(iteratee);
        return eachfn(arr, (value, _, iterCb) => {
          var index2 = counter++;
          _iteratee(value, (err, v) => {
            results[index2] = v;
            iterCb(err);
          });
        }, (err) => {
          callback(err, results);
        });
      }
      function isArrayLike(value) {
        return value && typeof value.length === "number" && value.length >= 0 && value.length % 1 === 0;
      }
      const breakLoop = {};
      var breakLoop$1 = breakLoop;
      function once(fn) {
        function wrapper(...args) {
          if (fn === null)
            return;
          var callFn = fn;
          fn = null;
          callFn.apply(this, args);
        }
        Object.assign(wrapper, fn);
        return wrapper;
      }
      function getIterator(coll) {
        return coll[Symbol.iterator] && coll[Symbol.iterator]();
      }
      function createArrayIterator(coll) {
        var i = -1;
        var len = coll.length;
        return function next() {
          return ++i < len ? { value: coll[i], key: i } : null;
        };
      }
      function createES2015Iterator(iterator) {
        var i = -1;
        return function next() {
          var item = iterator.next();
          if (item.done)
            return null;
          i++;
          return { value: item.value, key: i };
        };
      }
      function createObjectIterator(obj) {
        var okeys = obj ? Object.keys(obj) : [];
        var i = -1;
        var len = okeys.length;
        return function next() {
          var key = okeys[++i];
          if (key === "__proto__") {
            return next();
          }
          return i < len ? { value: obj[key], key } : null;
        };
      }
      function createIterator(coll) {
        if (isArrayLike(coll)) {
          return createArrayIterator(coll);
        }
        var iterator = getIterator(coll);
        return iterator ? createES2015Iterator(iterator) : createObjectIterator(coll);
      }
      function onlyOnce(fn) {
        return function(...args) {
          if (fn === null)
            throw new Error("Callback was already called.");
          var callFn = fn;
          fn = null;
          callFn.apply(this, args);
        };
      }
      function asyncEachOfLimit(generator, limit, iteratee, callback) {
        let done = false;
        let canceled = false;
        let awaiting = false;
        let running = 0;
        let idx = 0;
        function replenish() {
          if (running >= limit || awaiting || done)
            return;
          awaiting = true;
          generator.next().then(({ value, done: iterDone }) => {
            if (canceled || done)
              return;
            awaiting = false;
            if (iterDone) {
              done = true;
              if (running <= 0) {
                callback(null);
              }
              return;
            }
            running++;
            iteratee(value, idx, iterateeCallback);
            idx++;
            replenish();
          }).catch(handleError);
        }
        function iterateeCallback(err, result2) {
          running -= 1;
          if (canceled)
            return;
          if (err)
            return handleError(err);
          if (err === false) {
            done = true;
            canceled = true;
            return;
          }
          if (result2 === breakLoop$1 || done && running <= 0) {
            done = true;
            return callback(null);
          }
          replenish();
        }
        function handleError(err) {
          if (canceled)
            return;
          awaiting = false;
          done = true;
          callback(err);
        }
        replenish();
      }
      var eachOfLimit$2 = (limit) => {
        return (obj, iteratee, callback) => {
          callback = once(callback);
          if (limit <= 0) {
            throw new RangeError("concurrency limit cannot be less than 1");
          }
          if (!obj) {
            return callback(null);
          }
          if (isAsyncGenerator(obj)) {
            return asyncEachOfLimit(obj, limit, iteratee, callback);
          }
          if (isAsyncIterable(obj)) {
            return asyncEachOfLimit(obj[Symbol.asyncIterator](), limit, iteratee, callback);
          }
          var nextElem = createIterator(obj);
          var done = false;
          var canceled = false;
          var running = 0;
          var looping = false;
          function iterateeCallback(err, value) {
            if (canceled)
              return;
            running -= 1;
            if (err) {
              done = true;
              callback(err);
            } else if (err === false) {
              done = true;
              canceled = true;
            } else if (value === breakLoop$1 || done && running <= 0) {
              done = true;
              return callback(null);
            } else if (!looping) {
              replenish();
            }
          }
          function replenish() {
            looping = true;
            while (running < limit && !done) {
              var elem = nextElem();
              if (elem === null) {
                done = true;
                if (running <= 0) {
                  callback(null);
                }
                return;
              }
              running += 1;
              iteratee(elem.value, elem.key, onlyOnce(iterateeCallback));
            }
            looping = false;
          }
          replenish();
        };
      };
      function eachOfLimit(coll, limit, iteratee, callback) {
        return eachOfLimit$2(limit)(coll, wrapAsync(iteratee), callback);
      }
      var eachOfLimit$1 = awaitify(eachOfLimit, 4);
      function eachOfArrayLike(coll, iteratee, callback) {
        callback = once(callback);
        var index2 = 0, completed = 0, { length } = coll, canceled = false;
        if (length === 0) {
          callback(null);
        }
        function iteratorCallback(err, value) {
          if (err === false) {
            canceled = true;
          }
          if (canceled === true)
            return;
          if (err) {
            callback(err);
          } else if (++completed === length || value === breakLoop$1) {
            callback(null);
          }
        }
        for (; index2 < length; index2++) {
          iteratee(coll[index2], index2, onlyOnce(iteratorCallback));
        }
      }
      function eachOfGeneric(coll, iteratee, callback) {
        return eachOfLimit$1(coll, Infinity, iteratee, callback);
      }
      function eachOf(coll, iteratee, callback) {
        var eachOfImplementation = isArrayLike(coll) ? eachOfArrayLike : eachOfGeneric;
        return eachOfImplementation(coll, wrapAsync(iteratee), callback);
      }
      var eachOf$1 = awaitify(eachOf, 3);
      function map(coll, iteratee, callback) {
        return _asyncMap(eachOf$1, coll, iteratee, callback);
      }
      var map$1 = awaitify(map, 3);
      var applyEach = applyEach$1(map$1);
      function eachOfSeries(coll, iteratee, callback) {
        return eachOfLimit$1(coll, 1, iteratee, callback);
      }
      var eachOfSeries$1 = awaitify(eachOfSeries, 3);
      function mapSeries(coll, iteratee, callback) {
        return _asyncMap(eachOfSeries$1, coll, iteratee, callback);
      }
      var mapSeries$1 = awaitify(mapSeries, 3);
      var applyEachSeries = applyEach$1(mapSeries$1);
      const PROMISE_SYMBOL = Symbol("promiseCallback");
      function promiseCallback() {
        let resolve2, reject2;
        function callback(err, ...args) {
          if (err)
            return reject2(err);
          resolve2(args.length > 1 ? args : args[0]);
        }
        callback[PROMISE_SYMBOL] = new Promise((res, rej) => {
          resolve2 = res, reject2 = rej;
        });
        return callback;
      }
      function auto(tasks, concurrency, callback) {
        if (typeof concurrency !== "number") {
          callback = concurrency;
          concurrency = null;
        }
        callback = once(callback || promiseCallback());
        var numTasks = Object.keys(tasks).length;
        if (!numTasks) {
          return callback(null);
        }
        if (!concurrency) {
          concurrency = numTasks;
        }
        var results = {};
        var runningTasks = 0;
        var canceled = false;
        var hasError = false;
        var listeners = /* @__PURE__ */ Object.create(null);
        var readyTasks = [];
        var readyToCheck = [];
        var uncheckedDependencies = {};
        Object.keys(tasks).forEach((key) => {
          var task = tasks[key];
          if (!Array.isArray(task)) {
            enqueueTask(key, [task]);
            readyToCheck.push(key);
            return;
          }
          var dependencies = task.slice(0, task.length - 1);
          var remainingDependencies = dependencies.length;
          if (remainingDependencies === 0) {
            enqueueTask(key, task);
            readyToCheck.push(key);
            return;
          }
          uncheckedDependencies[key] = remainingDependencies;
          dependencies.forEach((dependencyName) => {
            if (!tasks[dependencyName]) {
              throw new Error("async.auto task `" + key + "` has a non-existent dependency `" + dependencyName + "` in " + dependencies.join(", "));
            }
            addListener(dependencyName, () => {
              remainingDependencies--;
              if (remainingDependencies === 0) {
                enqueueTask(key, task);
              }
            });
          });
        });
        checkForDeadlocks();
        processQueue();
        function enqueueTask(key, task) {
          readyTasks.push(() => runTask(key, task));
        }
        function processQueue() {
          if (canceled)
            return;
          if (readyTasks.length === 0 && runningTasks === 0) {
            return callback(null, results);
          }
          while (readyTasks.length && runningTasks < concurrency) {
            var run = readyTasks.shift();
            run();
          }
        }
        function addListener(taskName, fn) {
          var taskListeners = listeners[taskName];
          if (!taskListeners) {
            taskListeners = listeners[taskName] = [];
          }
          taskListeners.push(fn);
        }
        function taskComplete(taskName) {
          var taskListeners = listeners[taskName] || [];
          taskListeners.forEach((fn) => fn());
          processQueue();
        }
        function runTask(key, task) {
          if (hasError)
            return;
          var taskCallback = onlyOnce((err, ...result2) => {
            runningTasks--;
            if (err === false) {
              canceled = true;
              return;
            }
            if (result2.length < 2) {
              [result2] = result2;
            }
            if (err) {
              var safeResults = {};
              Object.keys(results).forEach((rkey) => {
                safeResults[rkey] = results[rkey];
              });
              safeResults[key] = result2;
              hasError = true;
              listeners = /* @__PURE__ */ Object.create(null);
              if (canceled)
                return;
              callback(err, safeResults);
            } else {
              results[key] = result2;
              taskComplete(key);
            }
          });
          runningTasks++;
          var taskFn = wrapAsync(task[task.length - 1]);
          if (task.length > 1) {
            taskFn(results, taskCallback);
          } else {
            taskFn(taskCallback);
          }
        }
        function checkForDeadlocks() {
          var currentTask;
          var counter = 0;
          while (readyToCheck.length) {
            currentTask = readyToCheck.pop();
            counter++;
            getDependents(currentTask).forEach((dependent) => {
              if (--uncheckedDependencies[dependent] === 0) {
                readyToCheck.push(dependent);
              }
            });
          }
          if (counter !== numTasks) {
            throw new Error(
              "async.auto cannot execute tasks due to a recursive dependency"
            );
          }
        }
        function getDependents(taskName) {
          var result2 = [];
          Object.keys(tasks).forEach((key) => {
            const task = tasks[key];
            if (Array.isArray(task) && task.indexOf(taskName) >= 0) {
              result2.push(key);
            }
          });
          return result2;
        }
        return callback[PROMISE_SYMBOL];
      }
      var FN_ARGS = /^(?:async\s+)?(?:function)?\s*\w*\s*\(\s*([^)]+)\s*\)(?:\s*{)/;
      var ARROW_FN_ARGS = /^(?:async\s+)?\(?\s*([^)=]+)\s*\)?(?:\s*=>)/;
      var FN_ARG_SPLIT = /,/;
      var FN_ARG = /(=.+)?(\s*)$/;
      function stripComments(string) {
        let stripped = "";
        let index2 = 0;
        let endBlockComment = string.indexOf("*/");
        while (index2 < string.length) {
          if (string[index2] === "/" && string[index2 + 1] === "/") {
            let endIndex = string.indexOf("\n", index2);
            index2 = endIndex === -1 ? string.length : endIndex;
          } else if (endBlockComment !== -1 && string[index2] === "/" && string[index2 + 1] === "*") {
            let endIndex = string.indexOf("*/", index2);
            if (endIndex !== -1) {
              index2 = endIndex + 2;
              endBlockComment = string.indexOf("*/", index2);
            } else {
              stripped += string[index2];
              index2++;
            }
          } else {
            stripped += string[index2];
            index2++;
          }
        }
        return stripped;
      }
      function parseParams(func) {
        const src = stripComments(func.toString());
        let match = src.match(FN_ARGS);
        if (!match) {
          match = src.match(ARROW_FN_ARGS);
        }
        if (!match)
          throw new Error("could not parse args in autoInject\nSource:\n" + src);
        let [, args] = match;
        return args.replace(/\s/g, "").split(FN_ARG_SPLIT).map((arg) => arg.replace(FN_ARG, "").trim());
      }
      function autoInject(tasks, callback) {
        var newTasks = {};
        Object.keys(tasks).forEach((key) => {
          var taskFn = tasks[key];
          var params;
          var fnIsAsync = isAsync(taskFn);
          var hasNoDeps = !fnIsAsync && taskFn.length === 1 || fnIsAsync && taskFn.length === 0;
          if (Array.isArray(taskFn)) {
            params = [...taskFn];
            taskFn = params.pop();
            newTasks[key] = params.concat(params.length > 0 ? newTask : taskFn);
          } else if (hasNoDeps) {
            newTasks[key] = taskFn;
          } else {
            params = parseParams(taskFn);
            if (taskFn.length === 0 && !fnIsAsync && params.length === 0) {
              throw new Error("autoInject task functions require explicit parameters.");
            }
            if (!fnIsAsync)
              params.pop();
            newTasks[key] = params.concat(newTask);
          }
          function newTask(results, taskCb) {
            var newArgs = params.map((name) => results[name]);
            newArgs.push(taskCb);
            wrapAsync(taskFn)(...newArgs);
          }
        });
        return auto(newTasks, callback);
      }
      class DLL {
        constructor() {
          this.head = this.tail = null;
          this.length = 0;
        }
        removeLink(node) {
          if (node.prev)
            node.prev.next = node.next;
          else
            this.head = node.next;
          if (node.next)
            node.next.prev = node.prev;
          else
            this.tail = node.prev;
          node.prev = node.next = null;
          this.length -= 1;
          return node;
        }
        empty() {
          while (this.head)
            this.shift();
          return this;
        }
        insertAfter(node, newNode) {
          newNode.prev = node;
          newNode.next = node.next;
          if (node.next)
            node.next.prev = newNode;
          else
            this.tail = newNode;
          node.next = newNode;
          this.length += 1;
        }
        insertBefore(node, newNode) {
          newNode.prev = node.prev;
          newNode.next = node;
          if (node.prev)
            node.prev.next = newNode;
          else
            this.head = newNode;
          node.prev = newNode;
          this.length += 1;
        }
        unshift(node) {
          if (this.head)
            this.insertBefore(this.head, node);
          else
            setInitial(this, node);
        }
        push(node) {
          if (this.tail)
            this.insertAfter(this.tail, node);
          else
            setInitial(this, node);
        }
        shift() {
          return this.head && this.removeLink(this.head);
        }
        pop() {
          return this.tail && this.removeLink(this.tail);
        }
        toArray() {
          return [...this];
        }
        *[Symbol.iterator]() {
          var cur = this.head;
          while (cur) {
            yield cur.data;
            cur = cur.next;
          }
        }
        remove(testFn) {
          var curr = this.head;
          while (curr) {
            var { next } = curr;
            if (testFn(curr)) {
              this.removeLink(curr);
            }
            curr = next;
          }
          return this;
        }
      }
      function setInitial(dll, node) {
        dll.length = 1;
        dll.head = dll.tail = node;
      }
      function queue$1(worker, concurrency, payload) {
        if (concurrency == null) {
          concurrency = 1;
        } else if (concurrency === 0) {
          throw new RangeError("Concurrency must not be zero");
        }
        var _worker = wrapAsync(worker);
        var numRunning = 0;
        var workersList = [];
        const events = {
          error: [],
          drain: [],
          saturated: [],
          unsaturated: [],
          empty: []
        };
        function on(event, handler) {
          events[event].push(handler);
        }
        function once2(event, handler) {
          const handleAndRemove = (...args) => {
            off(event, handleAndRemove);
            handler(...args);
          };
          events[event].push(handleAndRemove);
        }
        function off(event, handler) {
          if (!event)
            return Object.keys(events).forEach((ev) => events[ev] = []);
          if (!handler)
            return events[event] = [];
          events[event] = events[event].filter((ev) => ev !== handler);
        }
        function trigger(event, ...args) {
          events[event].forEach((handler) => handler(...args));
        }
        var processingScheduled = false;
        function _insert(data, insertAtFront, rejectOnError, callback) {
          if (callback != null && typeof callback !== "function") {
            throw new Error("task callback must be a function");
          }
          q2.started = true;
          var res, rej;
          function promiseCallback2(err, ...args) {
            if (err)
              return rejectOnError ? rej(err) : res();
            if (args.length <= 1)
              return res(args[0]);
            res(args);
          }
          var item = q2._createTaskItem(
            data,
            rejectOnError ? promiseCallback2 : callback || promiseCallback2
          );
          if (insertAtFront) {
            q2._tasks.unshift(item);
          } else {
            q2._tasks.push(item);
          }
          if (!processingScheduled) {
            processingScheduled = true;
            setImmediate$1(() => {
              processingScheduled = false;
              q2.process();
            });
          }
          if (rejectOnError || !callback) {
            return new Promise((resolve2, reject2) => {
              res = resolve2;
              rej = reject2;
            });
          }
        }
        function _createCB(tasks) {
          return function(err, ...args) {
            numRunning -= 1;
            for (var i = 0, l2 = tasks.length; i < l2; i++) {
              var task = tasks[i];
              var index2 = workersList.indexOf(task);
              if (index2 === 0) {
                workersList.shift();
              } else if (index2 > 0) {
                workersList.splice(index2, 1);
              }
              task.callback(err, ...args);
              if (err != null) {
                trigger("error", err, task.data);
              }
            }
            if (numRunning <= q2.concurrency - q2.buffer) {
              trigger("unsaturated");
            }
            if (q2.idle()) {
              trigger("drain");
            }
            q2.process();
          };
        }
        function _maybeDrain(data) {
          if (data.length === 0 && q2.idle()) {
            setImmediate$1(() => trigger("drain"));
            return true;
          }
          return false;
        }
        const eventMethod = (name) => (handler) => {
          if (!handler) {
            return new Promise((resolve2, reject2) => {
              once2(name, (err, data) => {
                if (err)
                  return reject2(err);
                resolve2(data);
              });
            });
          }
          off(name);
          on(name, handler);
        };
        var isProcessing = false;
        var q2 = {
          _tasks: new DLL(),
          _createTaskItem(data, callback) {
            return {
              data,
              callback
            };
          },
          *[Symbol.iterator]() {
            yield* q2._tasks[Symbol.iterator]();
          },
          concurrency,
          payload,
          buffer: concurrency / 4,
          started: false,
          paused: false,
          push(data, callback) {
            if (Array.isArray(data)) {
              if (_maybeDrain(data))
                return;
              return data.map((datum) => _insert(datum, false, false, callback));
            }
            return _insert(data, false, false, callback);
          },
          pushAsync(data, callback) {
            if (Array.isArray(data)) {
              if (_maybeDrain(data))
                return;
              return data.map((datum) => _insert(datum, false, true, callback));
            }
            return _insert(data, false, true, callback);
          },
          kill() {
            off();
            q2._tasks.empty();
          },
          unshift(data, callback) {
            if (Array.isArray(data)) {
              if (_maybeDrain(data))
                return;
              return data.map((datum) => _insert(datum, true, false, callback));
            }
            return _insert(data, true, false, callback);
          },
          unshiftAsync(data, callback) {
            if (Array.isArray(data)) {
              if (_maybeDrain(data))
                return;
              return data.map((datum) => _insert(datum, true, true, callback));
            }
            return _insert(data, true, true, callback);
          },
          remove(testFn) {
            q2._tasks.remove(testFn);
          },
          process() {
            if (isProcessing) {
              return;
            }
            isProcessing = true;
            while (!q2.paused && numRunning < q2.concurrency && q2._tasks.length) {
              var tasks = [], data = [];
              var l2 = q2._tasks.length;
              if (q2.payload)
                l2 = Math.min(l2, q2.payload);
              for (var i = 0; i < l2; i++) {
                var node = q2._tasks.shift();
                tasks.push(node);
                workersList.push(node);
                data.push(node.data);
              }
              numRunning += 1;
              if (q2._tasks.length === 0) {
                trigger("empty");
              }
              if (numRunning === q2.concurrency) {
                trigger("saturated");
              }
              var cb = onlyOnce(_createCB(tasks));
              _worker(data, cb);
            }
            isProcessing = false;
          },
          length() {
            return q2._tasks.length;
          },
          running() {
            return numRunning;
          },
          workersList() {
            return workersList;
          },
          idle() {
            return q2._tasks.length + numRunning === 0;
          },
          pause() {
            q2.paused = true;
          },
          resume() {
            if (q2.paused === false) {
              return;
            }
            q2.paused = false;
            setImmediate$1(q2.process);
          }
        };
        Object.defineProperties(q2, {
          saturated: {
            writable: false,
            value: eventMethod("saturated")
          },
          unsaturated: {
            writable: false,
            value: eventMethod("unsaturated")
          },
          empty: {
            writable: false,
            value: eventMethod("empty")
          },
          drain: {
            writable: false,
            value: eventMethod("drain")
          },
          error: {
            writable: false,
            value: eventMethod("error")
          }
        });
        return q2;
      }
      function cargo$1(worker, payload) {
        return queue$1(worker, 1, payload);
      }
      function cargo(worker, concurrency, payload) {
        return queue$1(worker, concurrency, payload);
      }
      function reduce(coll, memo, iteratee, callback) {
        callback = once(callback);
        var _iteratee = wrapAsync(iteratee);
        return eachOfSeries$1(coll, (x2, i, iterCb) => {
          _iteratee(memo, x2, (err, v) => {
            memo = v;
            iterCb(err);
          });
        }, (err) => callback(err, memo));
      }
      var reduce$1 = awaitify(reduce, 4);
      function seq(...functions) {
        var _functions = functions.map(wrapAsync);
        return function(...args) {
          var that = this;
          var cb = args[args.length - 1];
          if (typeof cb == "function") {
            args.pop();
          } else {
            cb = promiseCallback();
          }
          reduce$1(
            _functions,
            args,
            (newargs, fn, iterCb) => {
              fn.apply(that, newargs.concat((err, ...nextargs) => {
                iterCb(err, nextargs);
              }));
            },
            (err, results) => cb(err, ...results)
          );
          return cb[PROMISE_SYMBOL];
        };
      }
      function compose(...args) {
        return seq(...args.reverse());
      }
      function mapLimit(coll, limit, iteratee, callback) {
        return _asyncMap(eachOfLimit$2(limit), coll, iteratee, callback);
      }
      var mapLimit$1 = awaitify(mapLimit, 4);
      function concatLimit(coll, limit, iteratee, callback) {
        var _iteratee = wrapAsync(iteratee);
        return mapLimit$1(coll, limit, (val, iterCb) => {
          _iteratee(val, (err, ...args) => {
            if (err)
              return iterCb(err);
            return iterCb(err, args);
          });
        }, (err, mapResults) => {
          var result2 = [];
          for (var i = 0; i < mapResults.length; i++) {
            if (mapResults[i]) {
              result2 = result2.concat(...mapResults[i]);
            }
          }
          return callback(err, result2);
        });
      }
      var concatLimit$1 = awaitify(concatLimit, 4);
      function concat(coll, iteratee, callback) {
        return concatLimit$1(coll, Infinity, iteratee, callback);
      }
      var concat$1 = awaitify(concat, 3);
      function concatSeries(coll, iteratee, callback) {
        return concatLimit$1(coll, 1, iteratee, callback);
      }
      var concatSeries$1 = awaitify(concatSeries, 3);
      function constant$1(...args) {
        return function(...ignoredArgs) {
          var callback = ignoredArgs.pop();
          return callback(null, ...args);
        };
      }
      function _createTester(check, getResult) {
        return (eachfn, arr, _iteratee, cb) => {
          var testPassed = false;
          var testResult;
          const iteratee = wrapAsync(_iteratee);
          eachfn(arr, (value, _, callback) => {
            iteratee(value, (err, result2) => {
              if (err || err === false)
                return callback(err);
              if (check(result2) && !testResult) {
                testPassed = true;
                testResult = getResult(true, value);
                return callback(null, breakLoop$1);
              }
              callback();
            });
          }, (err) => {
            if (err)
              return cb(err);
            cb(null, testPassed ? testResult : getResult(false));
          });
        };
      }
      function detect(coll, iteratee, callback) {
        return _createTester((bool) => bool, (res, item) => item)(eachOf$1, coll, iteratee, callback);
      }
      var detect$1 = awaitify(detect, 3);
      function detectLimit(coll, limit, iteratee, callback) {
        return _createTester((bool) => bool, (res, item) => item)(eachOfLimit$2(limit), coll, iteratee, callback);
      }
      var detectLimit$1 = awaitify(detectLimit, 4);
      function detectSeries(coll, iteratee, callback) {
        return _createTester((bool) => bool, (res, item) => item)(eachOfLimit$2(1), coll, iteratee, callback);
      }
      var detectSeries$1 = awaitify(detectSeries, 3);
      function consoleFunc(name) {
        return (fn, ...args) => wrapAsync(fn)(...args, (err, ...resultArgs) => {
          if (typeof console === "object") {
            if (err) {
              if (console.error) {
                console.error(err);
              }
            } else if (console[name]) {
              resultArgs.forEach((x2) => console[name](x2));
            }
          }
        });
      }
      var dir = consoleFunc("dir");
      function doWhilst(iteratee, test, callback) {
        callback = onlyOnce(callback);
        var _fn = wrapAsync(iteratee);
        var _test = wrapAsync(test);
        var results;
        function next(err, ...args) {
          if (err)
            return callback(err);
          if (err === false)
            return;
          results = args;
          _test(...args, check);
        }
        function check(err, truth) {
          if (err)
            return callback(err);
          if (err === false)
            return;
          if (!truth)
            return callback(null, ...results);
          _fn(next);
        }
        return check(null, true);
      }
      var doWhilst$1 = awaitify(doWhilst, 3);
      function doUntil(iteratee, test, callback) {
        const _test = wrapAsync(test);
        return doWhilst$1(iteratee, (...args) => {
          const cb = args.pop();
          _test(...args, (err, truth) => cb(err, !truth));
        }, callback);
      }
      function _withoutIndex(iteratee) {
        return (value, index2, callback) => iteratee(value, callback);
      }
      function eachLimit$2(coll, iteratee, callback) {
        return eachOf$1(coll, _withoutIndex(wrapAsync(iteratee)), callback);
      }
      var each = awaitify(eachLimit$2, 3);
      function eachLimit(coll, limit, iteratee, callback) {
        return eachOfLimit$2(limit)(coll, _withoutIndex(wrapAsync(iteratee)), callback);
      }
      var eachLimit$1 = awaitify(eachLimit, 4);
      function eachSeries(coll, iteratee, callback) {
        return eachLimit$1(coll, 1, iteratee, callback);
      }
      var eachSeries$1 = awaitify(eachSeries, 3);
      function ensureAsync(fn) {
        if (isAsync(fn))
          return fn;
        return function(...args) {
          var callback = args.pop();
          var sync = true;
          args.push((...innerArgs) => {
            if (sync) {
              setImmediate$1(() => callback(...innerArgs));
            } else {
              callback(...innerArgs);
            }
          });
          fn.apply(this, args);
          sync = false;
        };
      }
      function every(coll, iteratee, callback) {
        return _createTester((bool) => !bool, (res) => !res)(eachOf$1, coll, iteratee, callback);
      }
      var every$1 = awaitify(every, 3);
      function everyLimit(coll, limit, iteratee, callback) {
        return _createTester((bool) => !bool, (res) => !res)(eachOfLimit$2(limit), coll, iteratee, callback);
      }
      var everyLimit$1 = awaitify(everyLimit, 4);
      function everySeries(coll, iteratee, callback) {
        return _createTester((bool) => !bool, (res) => !res)(eachOfSeries$1, coll, iteratee, callback);
      }
      var everySeries$1 = awaitify(everySeries, 3);
      function filterArray(eachfn, arr, iteratee, callback) {
        var truthValues = new Array(arr.length);
        eachfn(arr, (x2, index2, iterCb) => {
          iteratee(x2, (err, v) => {
            truthValues[index2] = !!v;
            iterCb(err);
          });
        }, (err) => {
          if (err)
            return callback(err);
          var results = [];
          for (var i = 0; i < arr.length; i++) {
            if (truthValues[i])
              results.push(arr[i]);
          }
          callback(null, results);
        });
      }
      function filterGeneric(eachfn, coll, iteratee, callback) {
        var results = [];
        eachfn(coll, (x2, index2, iterCb) => {
          iteratee(x2, (err, v) => {
            if (err)
              return iterCb(err);
            if (v) {
              results.push({ index: index2, value: x2 });
            }
            iterCb(err);
          });
        }, (err) => {
          if (err)
            return callback(err);
          callback(null, results.sort((a, b) => a.index - b.index).map((v) => v.value));
        });
      }
      function _filter(eachfn, coll, iteratee, callback) {
        var filter2 = isArrayLike(coll) ? filterArray : filterGeneric;
        return filter2(eachfn, coll, wrapAsync(iteratee), callback);
      }
      function filter(coll, iteratee, callback) {
        return _filter(eachOf$1, coll, iteratee, callback);
      }
      var filter$1 = awaitify(filter, 3);
      function filterLimit(coll, limit, iteratee, callback) {
        return _filter(eachOfLimit$2(limit), coll, iteratee, callback);
      }
      var filterLimit$1 = awaitify(filterLimit, 4);
      function filterSeries(coll, iteratee, callback) {
        return _filter(eachOfSeries$1, coll, iteratee, callback);
      }
      var filterSeries$1 = awaitify(filterSeries, 3);
      function forever(fn, errback) {
        var done = onlyOnce(errback);
        var task = wrapAsync(ensureAsync(fn));
        function next(err) {
          if (err)
            return done(err);
          if (err === false)
            return;
          task(next);
        }
        return next();
      }
      var forever$1 = awaitify(forever, 2);
      function groupByLimit(coll, limit, iteratee, callback) {
        var _iteratee = wrapAsync(iteratee);
        return mapLimit$1(coll, limit, (val, iterCb) => {
          _iteratee(val, (err, key) => {
            if (err)
              return iterCb(err);
            return iterCb(err, { key, val });
          });
        }, (err, mapResults) => {
          var result2 = {};
          var { hasOwnProperty } = Object.prototype;
          for (var i = 0; i < mapResults.length; i++) {
            if (mapResults[i]) {
              var { key } = mapResults[i];
              var { val } = mapResults[i];
              if (hasOwnProperty.call(result2, key)) {
                result2[key].push(val);
              } else {
                result2[key] = [val];
              }
            }
          }
          return callback(err, result2);
        });
      }
      var groupByLimit$1 = awaitify(groupByLimit, 4);
      function groupBy(coll, iteratee, callback) {
        return groupByLimit$1(coll, Infinity, iteratee, callback);
      }
      function groupBySeries(coll, iteratee, callback) {
        return groupByLimit$1(coll, 1, iteratee, callback);
      }
      var log = consoleFunc("log");
      function mapValuesLimit(obj, limit, iteratee, callback) {
        callback = once(callback);
        var newObj = {};
        var _iteratee = wrapAsync(iteratee);
        return eachOfLimit$2(limit)(obj, (val, key, next) => {
          _iteratee(val, key, (err, result2) => {
            if (err)
              return next(err);
            newObj[key] = result2;
            next(err);
          });
        }, (err) => callback(err, newObj));
      }
      var mapValuesLimit$1 = awaitify(mapValuesLimit, 4);
      function mapValues(obj, iteratee, callback) {
        return mapValuesLimit$1(obj, Infinity, iteratee, callback);
      }
      function mapValuesSeries(obj, iteratee, callback) {
        return mapValuesLimit$1(obj, 1, iteratee, callback);
      }
      function memoize(fn, hasher = (v) => v) {
        var memo = /* @__PURE__ */ Object.create(null);
        var queues = /* @__PURE__ */ Object.create(null);
        var _fn = wrapAsync(fn);
        var memoized = initialParams((args, callback) => {
          var key = hasher(...args);
          if (key in memo) {
            setImmediate$1(() => callback(null, ...memo[key]));
          } else if (key in queues) {
            queues[key].push(callback);
          } else {
            queues[key] = [callback];
            _fn(...args, (err, ...resultArgs) => {
              if (!err) {
                memo[key] = resultArgs;
              }
              var q2 = queues[key];
              delete queues[key];
              for (var i = 0, l2 = q2.length; i < l2; i++) {
                q2[i](err, ...resultArgs);
              }
            });
          }
        });
        memoized.memo = memo;
        memoized.unmemoized = fn;
        return memoized;
      }
      var _defer;
      if (hasNextTick) {
        _defer = process.nextTick;
      } else if (hasSetImmediate) {
        _defer = setImmediate;
      } else {
        _defer = fallback;
      }
      var nextTick = wrap(_defer);
      var _parallel = awaitify((eachfn, tasks, callback) => {
        var results = isArrayLike(tasks) ? [] : {};
        eachfn(tasks, (task, key, taskCb) => {
          wrapAsync(task)((err, ...result2) => {
            if (result2.length < 2) {
              [result2] = result2;
            }
            results[key] = result2;
            taskCb(err);
          });
        }, (err) => callback(err, results));
      }, 3);
      function parallel(tasks, callback) {
        return _parallel(eachOf$1, tasks, callback);
      }
      function parallelLimit(tasks, limit, callback) {
        return _parallel(eachOfLimit$2(limit), tasks, callback);
      }
      function queue(worker, concurrency) {
        var _worker = wrapAsync(worker);
        return queue$1((items, cb) => {
          _worker(items[0], cb);
        }, concurrency, 1);
      }
      class Heap {
        constructor() {
          this.heap = [];
          this.pushCount = Number.MIN_SAFE_INTEGER;
        }
        get length() {
          return this.heap.length;
        }
        empty() {
          this.heap = [];
          return this;
        }
        percUp(index2) {
          let p3;
          while (index2 > 0 && smaller(this.heap[index2], this.heap[p3 = parent(index2)])) {
            let t = this.heap[index2];
            this.heap[index2] = this.heap[p3];
            this.heap[p3] = t;
            index2 = p3;
          }
        }
        percDown(index2) {
          let l2;
          while ((l2 = leftChi(index2)) < this.heap.length) {
            if (l2 + 1 < this.heap.length && smaller(this.heap[l2 + 1], this.heap[l2])) {
              l2 = l2 + 1;
            }
            if (smaller(this.heap[index2], this.heap[l2])) {
              break;
            }
            let t = this.heap[index2];
            this.heap[index2] = this.heap[l2];
            this.heap[l2] = t;
            index2 = l2;
          }
        }
        push(node) {
          node.pushCount = ++this.pushCount;
          this.heap.push(node);
          this.percUp(this.heap.length - 1);
        }
        unshift(node) {
          return this.heap.push(node);
        }
        shift() {
          let [top] = this.heap;
          this.heap[0] = this.heap[this.heap.length - 1];
          this.heap.pop();
          this.percDown(0);
          return top;
        }
        toArray() {
          return [...this];
        }
        *[Symbol.iterator]() {
          for (let i = 0; i < this.heap.length; i++) {
            yield this.heap[i].data;
          }
        }
        remove(testFn) {
          let j = 0;
          for (let i = 0; i < this.heap.length; i++) {
            if (!testFn(this.heap[i])) {
              this.heap[j] = this.heap[i];
              j++;
            }
          }
          this.heap.splice(j);
          for (let i = parent(this.heap.length - 1); i >= 0; i--) {
            this.percDown(i);
          }
          return this;
        }
      }
      function leftChi(i) {
        return (i << 1) + 1;
      }
      function parent(i) {
        return (i + 1 >> 1) - 1;
      }
      function smaller(x2, y) {
        if (x2.priority !== y.priority) {
          return x2.priority < y.priority;
        } else {
          return x2.pushCount < y.pushCount;
        }
      }
      function priorityQueue(worker, concurrency) {
        var q2 = queue(worker, concurrency);
        var {
          push,
          pushAsync
        } = q2;
        q2._tasks = new Heap();
        q2._createTaskItem = ({ data, priority }, callback) => {
          return {
            data,
            priority,
            callback
          };
        };
        function createDataItems(tasks, priority) {
          if (!Array.isArray(tasks)) {
            return { data: tasks, priority };
          }
          return tasks.map((data) => {
            return { data, priority };
          });
        }
        q2.push = function(data, priority = 0, callback) {
          return push(createDataItems(data, priority), callback);
        };
        q2.pushAsync = function(data, priority = 0, callback) {
          return pushAsync(createDataItems(data, priority), callback);
        };
        delete q2.unshift;
        delete q2.unshiftAsync;
        return q2;
      }
      function race(tasks, callback) {
        callback = once(callback);
        if (!Array.isArray(tasks))
          return callback(new TypeError("First argument to race must be an array of functions"));
        if (!tasks.length)
          return callback();
        for (var i = 0, l2 = tasks.length; i < l2; i++) {
          wrapAsync(tasks[i])(callback);
        }
      }
      var race$1 = awaitify(race, 2);
      function reduceRight(array, memo, iteratee, callback) {
        var reversed = [...array].reverse();
        return reduce$1(reversed, memo, iteratee, callback);
      }
      function reflect(fn) {
        var _fn = wrapAsync(fn);
        return initialParams(function reflectOn(args, reflectCallback) {
          args.push((error, ...cbArgs) => {
            let retVal = {};
            if (error) {
              retVal.error = error;
            }
            if (cbArgs.length > 0) {
              var value = cbArgs;
              if (cbArgs.length <= 1) {
                [value] = cbArgs;
              }
              retVal.value = value;
            }
            reflectCallback(null, retVal);
          });
          return _fn.apply(this, args);
        });
      }
      function reflectAll(tasks) {
        var results;
        if (Array.isArray(tasks)) {
          results = tasks.map(reflect);
        } else {
          results = {};
          Object.keys(tasks).forEach((key) => {
            results[key] = reflect.call(this, tasks[key]);
          });
        }
        return results;
      }
      function reject$2(eachfn, arr, _iteratee, callback) {
        const iteratee = wrapAsync(_iteratee);
        return _filter(eachfn, arr, (value, cb) => {
          iteratee(value, (err, v) => {
            cb(err, !v);
          });
        }, callback);
      }
      function reject(coll, iteratee, callback) {
        return reject$2(eachOf$1, coll, iteratee, callback);
      }
      var reject$1 = awaitify(reject, 3);
      function rejectLimit(coll, limit, iteratee, callback) {
        return reject$2(eachOfLimit$2(limit), coll, iteratee, callback);
      }
      var rejectLimit$1 = awaitify(rejectLimit, 4);
      function rejectSeries(coll, iteratee, callback) {
        return reject$2(eachOfSeries$1, coll, iteratee, callback);
      }
      var rejectSeries$1 = awaitify(rejectSeries, 3);
      function constant(value) {
        return function() {
          return value;
        };
      }
      const DEFAULT_TIMES = 5;
      const DEFAULT_INTERVAL = 0;
      function retry(opts, task, callback) {
        var options = {
          times: DEFAULT_TIMES,
          intervalFunc: constant(DEFAULT_INTERVAL)
        };
        if (arguments.length < 3 && typeof opts === "function") {
          callback = task || promiseCallback();
          task = opts;
        } else {
          parseTimes(options, opts);
          callback = callback || promiseCallback();
        }
        if (typeof task !== "function") {
          throw new Error("Invalid arguments for async.retry");
        }
        var _task = wrapAsync(task);
        var attempt = 1;
        function retryAttempt() {
          _task((err, ...args) => {
            if (err === false)
              return;
            if (err && attempt++ < options.times && (typeof options.errorFilter != "function" || options.errorFilter(err))) {
              setTimeout(retryAttempt, options.intervalFunc(attempt - 1));
            } else {
              callback(err, ...args);
            }
          });
        }
        retryAttempt();
        return callback[PROMISE_SYMBOL];
      }
      function parseTimes(acc, t) {
        if (typeof t === "object") {
          acc.times = +t.times || DEFAULT_TIMES;
          acc.intervalFunc = typeof t.interval === "function" ? t.interval : constant(+t.interval || DEFAULT_INTERVAL);
          acc.errorFilter = t.errorFilter;
        } else if (typeof t === "number" || typeof t === "string") {
          acc.times = +t || DEFAULT_TIMES;
        } else {
          throw new Error("Invalid arguments for async.retry");
        }
      }
      function retryable(opts, task) {
        if (!task) {
          task = opts;
          opts = null;
        }
        let arity = opts && opts.arity || task.length;
        if (isAsync(task)) {
          arity += 1;
        }
        var _task = wrapAsync(task);
        return initialParams((args, callback) => {
          if (args.length < arity - 1 || callback == null) {
            args.push(callback);
            callback = promiseCallback();
          }
          function taskFn(cb) {
            _task(...args, cb);
          }
          if (opts)
            retry(opts, taskFn, callback);
          else
            retry(taskFn, callback);
          return callback[PROMISE_SYMBOL];
        });
      }
      function series(tasks, callback) {
        return _parallel(eachOfSeries$1, tasks, callback);
      }
      function some(coll, iteratee, callback) {
        return _createTester(Boolean, (res) => res)(eachOf$1, coll, iteratee, callback);
      }
      var some$1 = awaitify(some, 3);
      function someLimit(coll, limit, iteratee, callback) {
        return _createTester(Boolean, (res) => res)(eachOfLimit$2(limit), coll, iteratee, callback);
      }
      var someLimit$1 = awaitify(someLimit, 4);
      function someSeries(coll, iteratee, callback) {
        return _createTester(Boolean, (res) => res)(eachOfSeries$1, coll, iteratee, callback);
      }
      var someSeries$1 = awaitify(someSeries, 3);
      function sortBy(coll, iteratee, callback) {
        var _iteratee = wrapAsync(iteratee);
        return map$1(coll, (x2, iterCb) => {
          _iteratee(x2, (err, criteria) => {
            if (err)
              return iterCb(err);
            iterCb(err, { value: x2, criteria });
          });
        }, (err, results) => {
          if (err)
            return callback(err);
          callback(null, results.sort(comparator).map((v) => v.value));
        });
        function comparator(left, right) {
          var a = left.criteria, b = right.criteria;
          return a < b ? -1 : a > b ? 1 : 0;
        }
      }
      var sortBy$1 = awaitify(sortBy, 3);
      function timeout(asyncFn, milliseconds, info) {
        var fn = wrapAsync(asyncFn);
        return initialParams((args, callback) => {
          var timedOut = false;
          var timer;
          function timeoutCallback() {
            var name = asyncFn.name || "anonymous";
            var error = new Error('Callback function "' + name + '" timed out.');
            error.code = "ETIMEDOUT";
            if (info) {
              error.info = info;
            }
            timedOut = true;
            callback(error);
          }
          args.push((...cbArgs) => {
            if (!timedOut) {
              callback(...cbArgs);
              clearTimeout(timer);
            }
          });
          timer = setTimeout(timeoutCallback, milliseconds);
          fn(...args);
        });
      }
      function range(size) {
        var result2 = Array(size);
        while (size--) {
          result2[size] = size;
        }
        return result2;
      }
      function timesLimit(count, limit, iteratee, callback) {
        var _iteratee = wrapAsync(iteratee);
        return mapLimit$1(range(count), limit, _iteratee, callback);
      }
      function times(n, iteratee, callback) {
        return timesLimit(n, Infinity, iteratee, callback);
      }
      function timesSeries(n, iteratee, callback) {
        return timesLimit(n, 1, iteratee, callback);
      }
      function transform(coll, accumulator, iteratee, callback) {
        if (arguments.length <= 3 && typeof accumulator === "function") {
          callback = iteratee;
          iteratee = accumulator;
          accumulator = Array.isArray(coll) ? [] : {};
        }
        callback = once(callback || promiseCallback());
        var _iteratee = wrapAsync(iteratee);
        eachOf$1(coll, (v, k, cb) => {
          _iteratee(accumulator, v, k, cb);
        }, (err) => callback(err, accumulator));
        return callback[PROMISE_SYMBOL];
      }
      function tryEach(tasks, callback) {
        var error = null;
        var result2;
        return eachSeries$1(tasks, (task, taskCb) => {
          wrapAsync(task)((err, ...args) => {
            if (err === false)
              return taskCb(err);
            if (args.length < 2) {
              [result2] = args;
            } else {
              result2 = args;
            }
            error = err;
            taskCb(err ? null : {});
          });
        }, () => callback(error, result2));
      }
      var tryEach$1 = awaitify(tryEach);
      function unmemoize(fn) {
        return (...args) => {
          return (fn.unmemoized || fn)(...args);
        };
      }
      function whilst(test, iteratee, callback) {
        callback = onlyOnce(callback);
        var _fn = wrapAsync(iteratee);
        var _test = wrapAsync(test);
        var results = [];
        function next(err, ...rest) {
          if (err)
            return callback(err);
          results = rest;
          if (err === false)
            return;
          _test(check);
        }
        function check(err, truth) {
          if (err)
            return callback(err);
          if (err === false)
            return;
          if (!truth)
            return callback(null, ...results);
          _fn(next);
        }
        return _test(check);
      }
      var whilst$1 = awaitify(whilst, 3);
      function until(test, iteratee, callback) {
        const _test = wrapAsync(test);
        return whilst$1((cb) => _test((err, truth) => cb(err, !truth)), iteratee, callback);
      }
      function waterfall(tasks, callback) {
        callback = once(callback);
        if (!Array.isArray(tasks))
          return callback(new Error("First argument to waterfall must be an array of functions"));
        if (!tasks.length)
          return callback();
        var taskIndex = 0;
        function nextTask(args) {
          var task = wrapAsync(tasks[taskIndex++]);
          task(...args, onlyOnce(next));
        }
        function next(err, ...args) {
          if (err === false)
            return;
          if (err || taskIndex === tasks.length) {
            return callback(err, ...args);
          }
          nextTask(args);
        }
        nextTask([]);
      }
      var waterfall$1 = awaitify(waterfall);
      var index = {
        apply,
        applyEach,
        applyEachSeries,
        asyncify,
        auto,
        autoInject,
        cargo: cargo$1,
        cargoQueue: cargo,
        compose,
        concat: concat$1,
        concatLimit: concatLimit$1,
        concatSeries: concatSeries$1,
        constant: constant$1,
        detect: detect$1,
        detectLimit: detectLimit$1,
        detectSeries: detectSeries$1,
        dir,
        doUntil,
        doWhilst: doWhilst$1,
        each,
        eachLimit: eachLimit$1,
        eachOf: eachOf$1,
        eachOfLimit: eachOfLimit$1,
        eachOfSeries: eachOfSeries$1,
        eachSeries: eachSeries$1,
        ensureAsync,
        every: every$1,
        everyLimit: everyLimit$1,
        everySeries: everySeries$1,
        filter: filter$1,
        filterLimit: filterLimit$1,
        filterSeries: filterSeries$1,
        forever: forever$1,
        groupBy,
        groupByLimit: groupByLimit$1,
        groupBySeries,
        log,
        map: map$1,
        mapLimit: mapLimit$1,
        mapSeries: mapSeries$1,
        mapValues,
        mapValuesLimit: mapValuesLimit$1,
        mapValuesSeries,
        memoize,
        nextTick,
        parallel,
        parallelLimit,
        priorityQueue,
        queue,
        race: race$1,
        reduce: reduce$1,
        reduceRight,
        reflect,
        reflectAll,
        reject: reject$1,
        rejectLimit: rejectLimit$1,
        rejectSeries: rejectSeries$1,
        retry,
        retryable,
        seq,
        series,
        setImmediate: setImmediate$1,
        some: some$1,
        someLimit: someLimit$1,
        someSeries: someSeries$1,
        sortBy: sortBy$1,
        timeout,
        times,
        timesLimit,
        timesSeries,
        transform,
        tryEach: tryEach$1,
        unmemoize,
        until,
        waterfall: waterfall$1,
        whilst: whilst$1,
        // aliases
        all: every$1,
        allLimit: everyLimit$1,
        allSeries: everySeries$1,
        any: some$1,
        anyLimit: someLimit$1,
        anySeries: someSeries$1,
        find: detect$1,
        findLimit: detectLimit$1,
        findSeries: detectSeries$1,
        flatMap: concat$1,
        flatMapLimit: concatLimit$1,
        flatMapSeries: concatSeries$1,
        forEach: each,
        forEachSeries: eachSeries$1,
        forEachLimit: eachLimit$1,
        forEachOf: eachOf$1,
        forEachOfSeries: eachOfSeries$1,
        forEachOfLimit: eachOfLimit$1,
        inject: reduce$1,
        foldl: reduce$1,
        foldr: reduceRight,
        select: filter$1,
        selectLimit: filterLimit$1,
        selectSeries: filterSeries$1,
        wrapSync: asyncify,
        during: whilst$1,
        doDuring: doWhilst$1
      };
      exports3.all = every$1;
      exports3.allLimit = everyLimit$1;
      exports3.allSeries = everySeries$1;
      exports3.any = some$1;
      exports3.anyLimit = someLimit$1;
      exports3.anySeries = someSeries$1;
      exports3.apply = apply;
      exports3.applyEach = applyEach;
      exports3.applyEachSeries = applyEachSeries;
      exports3.asyncify = asyncify;
      exports3.auto = auto;
      exports3.autoInject = autoInject;
      exports3.cargo = cargo$1;
      exports3.cargoQueue = cargo;
      exports3.compose = compose;
      exports3.concat = concat$1;
      exports3.concatLimit = concatLimit$1;
      exports3.concatSeries = concatSeries$1;
      exports3.constant = constant$1;
      exports3.default = index;
      exports3.detect = detect$1;
      exports3.detectLimit = detectLimit$1;
      exports3.detectSeries = detectSeries$1;
      exports3.dir = dir;
      exports3.doDuring = doWhilst$1;
      exports3.doUntil = doUntil;
      exports3.doWhilst = doWhilst$1;
      exports3.during = whilst$1;
      exports3.each = each;
      exports3.eachLimit = eachLimit$1;
      exports3.eachOf = eachOf$1;
      exports3.eachOfLimit = eachOfLimit$1;
      exports3.eachOfSeries = eachOfSeries$1;
      exports3.eachSeries = eachSeries$1;
      exports3.ensureAsync = ensureAsync;
      exports3.every = every$1;
      exports3.everyLimit = everyLimit$1;
      exports3.everySeries = everySeries$1;
      exports3.filter = filter$1;
      exports3.filterLimit = filterLimit$1;
      exports3.filterSeries = filterSeries$1;
      exports3.find = detect$1;
      exports3.findLimit = detectLimit$1;
      exports3.findSeries = detectSeries$1;
      exports3.flatMap = concat$1;
      exports3.flatMapLimit = concatLimit$1;
      exports3.flatMapSeries = concatSeries$1;
      exports3.foldl = reduce$1;
      exports3.foldr = reduceRight;
      exports3.forEach = each;
      exports3.forEachLimit = eachLimit$1;
      exports3.forEachOf = eachOf$1;
      exports3.forEachOfLimit = eachOfLimit$1;
      exports3.forEachOfSeries = eachOfSeries$1;
      exports3.forEachSeries = eachSeries$1;
      exports3.forever = forever$1;
      exports3.groupBy = groupBy;
      exports3.groupByLimit = groupByLimit$1;
      exports3.groupBySeries = groupBySeries;
      exports3.inject = reduce$1;
      exports3.log = log;
      exports3.map = map$1;
      exports3.mapLimit = mapLimit$1;
      exports3.mapSeries = mapSeries$1;
      exports3.mapValues = mapValues;
      exports3.mapValuesLimit = mapValuesLimit$1;
      exports3.mapValuesSeries = mapValuesSeries;
      exports3.memoize = memoize;
      exports3.nextTick = nextTick;
      exports3.parallel = parallel;
      exports3.parallelLimit = parallelLimit;
      exports3.priorityQueue = priorityQueue;
      exports3.queue = queue;
      exports3.race = race$1;
      exports3.reduce = reduce$1;
      exports3.reduceRight = reduceRight;
      exports3.reflect = reflect;
      exports3.reflectAll = reflectAll;
      exports3.reject = reject$1;
      exports3.rejectLimit = rejectLimit$1;
      exports3.rejectSeries = rejectSeries$1;
      exports3.retry = retry;
      exports3.retryable = retryable;
      exports3.select = filter$1;
      exports3.selectLimit = filterLimit$1;
      exports3.selectSeries = filterSeries$1;
      exports3.seq = seq;
      exports3.series = series;
      exports3.setImmediate = setImmediate$1;
      exports3.some = some$1;
      exports3.someLimit = someLimit$1;
      exports3.someSeries = someSeries$1;
      exports3.sortBy = sortBy$1;
      exports3.timeout = timeout;
      exports3.times = times;
      exports3.timesLimit = timesLimit;
      exports3.timesSeries = timesSeries;
      exports3.transform = transform;
      exports3.tryEach = tryEach$1;
      exports3.unmemoize = unmemoize;
      exports3.until = until;
      exports3.waterfall = waterfall$1;
      exports3.whilst = whilst$1;
      exports3.wrapSync = asyncify;
      Object.defineProperty(exports3, "__esModule", { value: true });
    });
  }
});

// node_modules/node-opcua-pseudo-session/dist/basic_session_ex.js
var require_basic_session_ex = __commonJS({
  "node_modules/node-opcua-pseudo-session/dist/basic_session_ex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-pseudo-session/dist/basic_session_interface.js
var require_basic_session_interface = __commonJS({
  "node_modules/node-opcua-pseudo-session/dist/basic_session_interface.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.readNamespaceArray = exports2.getArgumentDefinitionHelper = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_service_browse_1 = require_dist37();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_constants_1 = require_dist20();
    function isValid(result2) {
      (0, node_opcua_assert_1.assert)(result2.statusCode.isGood());
      if (result2.value.dataType !== node_opcua_variant_1.DataType.Null) {
        (0, node_opcua_assert_1.assert)(result2.value.dataType === node_opcua_variant_1.DataType.ExtensionObject);
        (0, node_opcua_assert_1.assert)(result2.value.arrayType === node_opcua_variant_1.VariantArrayType.Array);
      }
      return true;
    }
    async function getArgumentDefinitionHelper(session, methodId) {
      const browseDescription = new node_opcua_service_browse_1.BrowseDescription({
        browseDirection: node_opcua_data_model_1.BrowseDirection.Forward,
        includeSubtypes: true,
        nodeClassMask: 0,
        // makeNodeClassMask("Variable"),
        nodeId: methodId,
        referenceTypeId: (0, node_opcua_nodeid_1.resolveNodeId)("HasProperty"),
        resultMask: (0, node_opcua_data_model_1.makeResultMask)("BrowseName")
      });
      const browseResult = await session.browse(browseDescription);
      browseResult.references = browseResult.references || [];
      const inputArgumentRefArray = browseResult.references.filter((r) => r.browseName.name === "InputArguments");
      const inputArgumentRef = inputArgumentRefArray.length === 1 ? inputArgumentRefArray[0] : null;
      const outputArgumentRefArray = browseResult.references.filter((r) => r.browseName.name === "OutputArguments");
      const outputArgumentRef = outputArgumentRefArray.length === 1 ? outputArgumentRefArray[0] : null;
      let inputArguments = [];
      let outputArguments = [];
      const nodesToRead = [];
      const actions = [];
      if (inputArgumentRef) {
        nodesToRead.push({
          attributeId: node_opcua_data_model_1.AttributeIds.Value,
          nodeId: inputArgumentRef.nodeId
        });
        actions.push((result2) => {
          if (isValid(result2)) {
            inputArguments = result2.value.value;
          }
        });
      }
      if (outputArgumentRef) {
        nodesToRead.push({
          attributeId: node_opcua_data_model_1.AttributeIds.Value,
          nodeId: outputArgumentRef.nodeId
        });
        actions.push((result2) => {
          (0, node_opcua_assert_1.assert)(result2.statusCode.isGood());
          if (isValid(result2)) {
            outputArguments = result2.value.value;
          }
        });
      }
      if (nodesToRead.length === 0) {
        return { inputArguments, outputArguments };
      }
      const dataValues = await session.read(nodesToRead);
      dataValues.forEach((dataValue, index) => {
        actions[index].call(null, dataValue);
      });
      return { inputArguments, outputArguments };
    }
    exports2.getArgumentDefinitionHelper = getArgumentDefinitionHelper;
    async function readNamespaceArray(session) {
      const nodeId = (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_constants_1.VariableIds.Server_NamespaceArray);
      const dataValue = await session.read({
        nodeId,
        attributeId: node_opcua_data_model_1.AttributeIds.Value
      });
      if (dataValue.statusCode.isNotGood()) {
        return [];
      }
      return dataValue.value.value;
    }
    exports2.readNamespaceArray = readNamespaceArray;
  }
});

// node_modules/node-opcua-pseudo-session/dist/basic_session_with_subscription.js
var require_basic_session_with_subscription = __commonJS({
  "node_modules/node-opcua-pseudo-session/dist/basic_session_with_subscription.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-pseudo-session/dist/browse_all.js
var require_browse_all = __commonJS({
  "node_modules/node-opcua-pseudo-session/dist/browse_all.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.browseAll2 = exports2.browseAll = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_status_code_1 = require_dist22();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    async function readLimits(session) {
      const dataValues = await session.read([
        { nodeId: node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxBrowseContinuationPoints, attributeId: node_opcua_basic_types_1.AttributeIds.Value },
        { nodeId: node_opcua_constants_1.VariableIds.Server_ServerCapabilities_OperationLimits_MaxNodesPerBrowse, attributeId: node_opcua_basic_types_1.AttributeIds.Value }
      ]);
      const maxBrowseContinuationPoints = dataValues[0].value.value || 10;
      const maxNodesPerBrowse = dataValues[1].value.value || 10;
      return { maxBrowseContinuationPoints, maxNodesPerBrowse };
    }
    function coerceToBrowseDescription(nodeToBrowse) {
      if (typeof nodeToBrowse === "string") {
        return {
          nodeId: (0, node_opcua_nodeid_1.resolveNodeId)(nodeToBrowse)
        };
      } else {
        return nodeToBrowse;
      }
    }
    async function browseAll(session, nodesToBrowse) {
      if (!(nodesToBrowse instanceof Array)) {
        return (await browseAll(session, [nodesToBrowse]))[0];
      }
      const { maxBrowseContinuationPoints, maxNodesPerBrowse } = await readLimits(session);
      const maxNodesToBrowse = Math.min(maxNodesPerBrowse, maxBrowseContinuationPoints);
      const tmp = nodesToBrowse.map(coerceToBrowseDescription);
      let nodesToBrowse1 = tmp.splice(0, maxNodesToBrowse);
      let browseResults = [];
      while (nodesToBrowse1.length) {
        const partialBrowseResult = await browseAll2(session, nodesToBrowse1);
        browseResults = [...browseResults, ...partialBrowseResult];
        nodesToBrowse1 = tmp.splice(0, maxNodesToBrowse);
      }
      (0, node_opcua_assert_1.assert)(browseResults.length === nodesToBrowse.length, "browseResults must have same length as nodesToBrowse");
      return browseResults;
    }
    exports2.browseAll = browseAll;
    async function browseAll2(session, nodesToBrowse) {
      if (nodesToBrowse.length === 0) {
        return [];
      }
      const browseResults = await session.browse(nodesToBrowse);
      const browseToRedo = [];
      const browseToContinue = [];
      for (let i = 0; i < browseResults.length; i++) {
        const result2 = browseResults[i];
        if (result2.statusCode.equals(node_opcua_status_code_1.StatusCodes.BadNoContinuationPoints) || result2.statusCode.equals(node_opcua_status_code_1.StatusCodes.BadContinuationPointInvalid)) {
          warningLog("There is not enough browse continuation points");
          browseToRedo.push({ index: i, nodeToBrowse: nodesToBrowse[i] });
          continue;
        }
        const continuationPoint = result2.continuationPoint;
        result2.continuationPoint = void 0;
        if (continuationPoint && continuationPoint.length > 0) {
          browseToContinue.push({ references: result2.references || [], continuationPoint });
        }
      }
      while (browseToContinue.length) {
        const tmp = [...browseToContinue];
        const continuationPoints = tmp.map((e) => e.continuationPoint);
        browseToContinue.splice(0);
        const browseNextResults = await session.browseNext(continuationPoints, false);
        (0, node_opcua_assert_1.assert)(continuationPoints.length === browseNextResults.length, "browseNextResults length should eql continuationPoints.length");
        for (let i = 0; i < browseNextResults.length; i++) {
          const browseResult = browseNextResults[i];
          const references = tmp[i].references || [];
          if (browseResult.references && browseResult.references.length) {
            references.push(...browseResult.references);
          }
          const continuationPoint = browseResult.continuationPoint;
          if (continuationPoint) {
            browseToContinue.push({ references, continuationPoint });
          }
        }
      }
      if (browseToRedo.length && nodesToBrowse.length !== browseToRedo.length) {
        const nodesToBrowse2 = browseToRedo.map((e) => e.nodeToBrowse);
        const results2 = await browseAll2(session, nodesToBrowse2);
        for (let i = 0; i < browseResults.length; i++) {
          browseResults[browseToRedo[i].index] = results2[i];
        }
        browseToRedo.splice(0);
      }
      browseResults.forEach((b) => b.continuationPoint = void 0);
      return browseResults;
    }
    exports2.browseAll2 = browseAll2;
  }
});

// node_modules/node-opcua-pseudo-session/dist/create_monitored_items_limit.js
var require_create_monitored_items_limit = __commonJS({
  "node_modules/node-opcua-pseudo-session/dist/create_monitored_items_limit.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.createMonitoredItemsLimit = void 0;
    var node_opcua_service_subscription_1 = require_dist45();
    var node_opcua_status_code_1 = require_dist22();
    async function createMonitoredItemsLimit(maxMonitoredItemsPerCall, session, createMonitoredItemsRequest) {
      const _session2 = session;
      if (!createMonitoredItemsRequest.itemsToCreate || createMonitoredItemsRequest.itemsToCreate.length === 0) {
        return new node_opcua_service_subscription_1.CreateMonitoredItemsResponse({
          responseHeader: {
            serviceResult: node_opcua_status_code_1.StatusCodes.Good
          },
          results: []
        });
      }
      if (maxMonitoredItemsPerCall <= 0 || !createMonitoredItemsRequest.itemsToCreate || createMonitoredItemsRequest.itemsToCreate.length <= maxMonitoredItemsPerCall) {
        return _session2.createMonitoredItems(createMonitoredItemsRequest);
      }
      const n = [...createMonitoredItemsRequest.itemsToCreate || []];
      const response = new node_opcua_service_subscription_1.CreateMonitoredItemsResponse({
        diagnosticInfos: null,
        results: []
      });
      do {
        const c2 = n.splice(0, maxMonitoredItemsPerCall);
        const cmi = new node_opcua_service_subscription_1.CreateMonitoredItemsRequest({
          subscriptionId: createMonitoredItemsRequest.subscriptionId,
          timestampsToReturn: createMonitoredItemsRequest.timestampsToReturn,
          itemsToCreate: c2
        });
        const r = await _session2.createMonitoredItems(cmi);
        for (const i of r.results) {
          response.results.push(i);
        }
      } while (n.length);
      return response;
    }
    exports2.createMonitoredItemsLimit = createMonitoredItemsLimit;
  }
});

// node_modules/node-opcua-pseudo-session/dist/extract_fields.js
var require_extract_fields = __commonJS({
  "node_modules/node-opcua-pseudo-session/dist/extract_fields.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.stringPathToSimpleBrowsePath = exports2.simpleBrowsePathsToString = exports2.simpleBrowsePathToString = exports2.extractFields = void 0;
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_debug_1 = require_dist24();
    var doDebug = false;
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    async function extractFields(session, nodeId) {
      const _duplicateMap = {};
      const fields1 = [];
      function addField(parent, browseName, nodeId2) {
        const e = [...parent, browseName];
        const key = simpleBrowsePathToString(e);
        doDebug && debugLog("adding field ", key);
        if (!_duplicateMap[key]) {
          fields1.push({ path: e, nodeId: nodeId2 });
          _duplicateMap[key] = e;
        }
      }
      const stack = [];
      function _pushInvestigation(parent, objectId) {
        stack.push({
          parent,
          nodeId: objectId
        });
      }
      async function _flushPendingInvestigations() {
        if (stack.length === 0) {
          return;
        }
        const extracted = stack.splice(0);
        const nodesToBrowse = extracted.map((e) => {
          const { parent, nodeId: nodeId2 } = e;
          const b = {
            browseDirection: node_opcua_data_model_1.BrowseDirection.Forward,
            includeSubtypes: true,
            nodeClassMask: node_opcua_data_model_1.NodeClassMask.Object | node_opcua_data_model_1.NodeClassMask.Variable,
            nodeId: nodeId2,
            referenceTypeId: "HasChild",
            resultMask: 63
          };
          return b;
        });
        const results = await session.browse(nodesToBrowse);
        for (let index = 0; index < results.length; index++) {
          const result2 = results[index];
          const parent = extracted[index].parent;
          if (!result2.references || result2.references.length === 0)
            continue;
          doDebug && debugLog("exploring", simpleBrowsePathToString(parent), result2.references.map((a) => a.browseName.toString()));
          for (const ref of result2.references) {
            if (ref.nodeClass === node_opcua_types_1.NodeClass.Variable) {
              addField(parent, ref.browseName, ref.nodeId);
            }
            _pushInvestigation([...parent, ref.browseName], ref.nodeId);
          }
        }
        await _flushPendingInvestigations();
      }
      async function _investigateTopLevel(parent, eventNodeId) {
        const browseDescriptionForInverseSubType = {
          browseDirection: node_opcua_data_model_1.BrowseDirection.Inverse,
          includeSubtypes: true,
          nodeClassMask: node_opcua_data_model_1.NodeClassMask.ObjectType,
          nodeId: eventNodeId,
          referenceTypeId: (0, node_opcua_nodeid_1.resolveNodeId)("HasSubtype"),
          resultMask: 63
        };
        const nodeToBrowse2 = {
          browseDirection: node_opcua_data_model_1.BrowseDirection.Forward,
          includeSubtypes: true,
          nodeClassMask: node_opcua_data_model_1.NodeClassMask.Object | node_opcua_data_model_1.NodeClassMask.Variable,
          nodeId: eventNodeId,
          referenceTypeId: (0, node_opcua_nodeid_1.resolveNodeId)("HasChild"),
          resultMask: 63
        };
        const nodesToBrowse = [browseDescriptionForInverseSubType, nodeToBrowse2];
        const browseResults = await session.browse(nodesToBrowse);
        const [browseResultForInverseSubType, browseResultForChildren] = browseResults;
        if (browseResultForChildren && browseResultForChildren.references) {
          for (const ref of browseResultForChildren.references) {
            if (ref.nodeClass === node_opcua_types_1.NodeClass.Variable) {
              addField(parent, ref.browseName, ref.nodeId);
            }
            _pushInvestigation([...parent, ref.browseName], ref.nodeId);
          }
        }
        await _flushPendingInvestigations();
        if (browseResultForInverseSubType && browseResultForInverseSubType.references) {
          const promises = [];
          for (const reference of browseResultForInverseSubType.references) {
            doDebug && debugLog(" investigating super-type", reference.browseName.toString());
            promises.push(_investigateTopLevel([], reference.nodeId));
          }
          await Promise.all(promises);
        }
      }
      doDebug && debugLog("investigating ", nodeId.toString(), (await session.read({ nodeId, attributeId: node_opcua_data_model_1.AttributeIds.BrowseName })).value.value.toString());
      await _investigateTopLevel([], nodeId);
      return fields1;
    }
    exports2.extractFields = extractFields;
    function simpleBrowsePathToString(bp) {
      return bp.map((qn) => qn.toString()).join(".");
    }
    exports2.simpleBrowsePathToString = simpleBrowsePathToString;
    function simpleBrowsePathsToString(simpleBrowsePathArray) {
      return simpleBrowsePathArray.map(simpleBrowsePathToString);
    }
    exports2.simpleBrowsePathsToString = simpleBrowsePathsToString;
    function stringPathToSimpleBrowsePath(bp) {
      return bp.split(".").map((s) => (0, node_opcua_data_model_1.stringToQualifiedName)(s));
    }
    exports2.stringPathToSimpleBrowsePath = stringPathToSimpleBrowsePath;
  }
});

// node_modules/node-opcua-pseudo-session/dist/find_basic_datatype.js
var require_find_basic_datatype = __commonJS({
  "node_modules/node-opcua-pseudo-session/dist/find_basic_datatype.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.findBasicDataType = exports2.findSuperType = void 0;
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_service_browse_1 = require_dist37();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_data_model_1 = require_dist27();
    var resultMask = (0, node_opcua_data_model_1.makeResultMask)("ReferenceType");
    var hasSubtypeNodeId = (0, node_opcua_nodeid_1.makeNodeId)(node_opcua_constants_1.ReferenceTypeIds.HasSubtype);
    async function findSuperType(session, dataTypeId) {
      const nodeToBrowse = new node_opcua_service_browse_1.BrowseDescription({
        browseDirection: node_opcua_service_browse_1.BrowseDirection.Inverse,
        includeSubtypes: false,
        nodeId: dataTypeId,
        referenceTypeId: hasSubtypeNodeId,
        resultMask
      });
      const browseResult = await session.browse(nodeToBrowse);
      browseResult.references = browseResult.references || /* istanbul ignore next */
      [];
      const baseDataType = browseResult.references[0].nodeId;
      return baseDataType;
    }
    exports2.findSuperType = findSuperType;
    async function findBasicDataType(session, dataTypeId) {
      if (dataTypeId.identifierType === node_opcua_nodeid_1.NodeIdType.NUMERIC && dataTypeId.value === node_opcua_constants_1.DataTypeIds.Enumeration) {
        return node_opcua_variant_1.DataType.Int32;
      }
      if (dataTypeId.identifierType === node_opcua_nodeid_1.NodeIdType.NUMERIC && dataTypeId.value <= node_opcua_variant_1.DataType.DiagnosticInfo) {
        const dataTypeName = node_opcua_variant_1.DataType[dataTypeId.value];
        return dataTypeId.value;
      } else {
        const baseDataTypeId = await findSuperType(session, dataTypeId);
        return await findBasicDataType(session, baseDataTypeId);
      }
    }
    exports2.findBasicDataType = findBasicDataType;
  }
});

// node_modules/node-opcua-pseudo-session/dist/find_structure_datatype.js
var require_find_structure_datatype = __commonJS({
  "node_modules/node-opcua-pseudo-session/dist/find_structure_datatype.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.findStructureDataType = void 0;
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    async function findStructureDataType(session, dataTypeName, namespaceIndex) {
      let results = await session.browse({
        browseDirection: node_opcua_data_model_1.BrowseDirection.Forward,
        includeSubtypes: true,
        nodeClassMask: node_opcua_data_model_1.NodeClassMask.DataType,
        referenceTypeId: "HasSubtype",
        resultMask: 255,
        nodeId: (0, node_opcua_nodeid_1.coerceNodeId)(node_opcua_constants_1.DataTypeIds.Structure)
      });
      if (results.statusCode.isNotGood() || !results.references) {
        return null;
      }
      const ref = results.references.find((r) => r.browseName.name === dataTypeName && r.browseName.namespaceIndex === namespaceIndex);
      if (ref) {
        return ref.nodeId;
      }
      while (results.continuationPoint) {
        results = await session.browseNext(results.continuationPoint, false);
        if (results.statusCode.isNotGood() || !results.references) {
          return null;
        }
        const ref2 = results.references.find((r) => r.browseName.name === dataTypeName && r.browseName.namespaceIndex === namespaceIndex);
        if (ref2) {
          if (results.continuationPoint) {
            await session.browseNext(results.continuationPoint, true);
          }
          return ref2.nodeId;
        }
      }
      return null;
    }
    exports2.findStructureDataType = findStructureDataType;
  }
});

// node_modules/node-opcua-pseudo-session/dist/get_builtin_datatype.js
var require_get_builtin_datatype = __commonJS({
  "node_modules/node-opcua-pseudo-session/dist/get_builtin_datatype.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getBuiltInDataType = void 0;
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_status_code_1 = require_dist22();
    var find_basic_datatype_1 = require_find_basic_datatype();
    async function getBuiltInDataType(session, variableNodeId) {
      let dataTypeId = null;
      const nodeToRead = {
        attributeId: node_opcua_data_model_1.AttributeIds.DataType,
        nodeId: variableNodeId
      };
      const dataValue = await session.read(nodeToRead);
      if (dataValue.statusCode.isNot(node_opcua_status_code_1.StatusCodes.Good)) {
        throw new Error("cannot read DataType Attribute " + dataValue.statusCode.toString() + " for nodeId " + variableNodeId.toString());
      }
      dataTypeId = dataValue.value.value;
      return await (0, find_basic_datatype_1.findBasicDataType)(session, dataTypeId);
    }
    exports2.getBuiltInDataType = getBuiltInDataType;
  }
});

// node_modules/node-opcua-pseudo-session/dist/get_child_by_browse_name.js
var require_get_child_by_browse_name = __commonJS({
  "node_modules/node-opcua-pseudo-session/dist/get_child_by_browse_name.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getChildByBrowseName = void 0;
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__dirname);
    async function getChildByBrowseName(session, nodeId, name) {
      const browseResult = await session.browse({
        browseDirection: node_opcua_data_model_1.BrowseDirection.Forward,
        includeSubtypes: true,
        nodeId,
        referenceTypeId: (0, node_opcua_nodeid_1.resolveNodeId)("HierarchicalReferences"),
        nodeClassMask: 0,
        resultMask: 63
      });
      if (!browseResult.references || browseResult.statusCode.isNotGood()) {
        throw new Error("Cannot browse node " + name + " " + browseResult.statusCode.toString() + " nodeId = " + nodeId.toString());
      }
      const selectedReference = browseResult.references.find((r) => r.browseName.name?.match(name) || r.displayName.text.match(name));
      if (!selectedReference) {
        warningLog("getChildByBrowseName error", browseResult.toString());
        throw new Error("Cannot find node " + name + " from " + nodeId.toString());
      }
      return selectedReference;
    }
    exports2.getChildByBrowseName = getChildByBrowseName;
  }
});

// node_modules/node-opcua-pseudo-session/dist/read_operational_limits.js
var require_read_operational_limits = __commonJS({
  "node_modules/node-opcua-pseudo-session/dist/read_operational_limits.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.readOperationLimits = exports2.serverCapabilitiesIds = void 0;
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_service_read_1 = require_dist39();
    var node_opcua_debug_1 = require_dist24();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    exports2.serverCapabilitiesIds = [
      node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxArrayLength,
      node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxStringLength,
      node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxByteStringLength,
      node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MinSupportedSampleRate,
      node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxBrowseContinuationPoints,
      node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxQueryContinuationPoints,
      node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxHistoryContinuationPoints,
      // new in 1.05
      node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxSessions,
      node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxSubscriptions,
      node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxMonitoredItems,
      node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxSubscriptionsPerSession,
      node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxSelectClauseParameters,
      node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxWhereClauseParameters,
      node_opcua_constants_1.VariableIds.Server_ServerCapabilities_ConformanceUnits,
      node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxMonitoredItemsPerSubscription
    ];
    async function readOperationLimits(session) {
      const ids = [
        node_opcua_constants_1.VariableIds.Server_ServerCapabilities_OperationLimits_MaxNodesPerRead,
        node_opcua_constants_1.VariableIds.Server_ServerCapabilities_OperationLimits_MaxNodesPerBrowse,
        node_opcua_constants_1.VariableIds.Server_ServerCapabilities_OperationLimits_MaxNodesPerWrite,
        node_opcua_constants_1.VariableIds.Server_ServerCapabilities_OperationLimits_MaxNodesPerMethodCall,
        node_opcua_constants_1.VariableIds.Server_ServerCapabilities_OperationLimits_MaxNodesPerRegisterNodes,
        node_opcua_constants_1.VariableIds.Server_ServerCapabilities_OperationLimits_MaxNodesPerNodeManagement,
        node_opcua_constants_1.VariableIds.Server_ServerCapabilities_OperationLimits_MaxMonitoredItemsPerCall,
        node_opcua_constants_1.VariableIds.Server_ServerCapabilities_OperationLimits_MaxNodesPerHistoryReadData,
        node_opcua_constants_1.VariableIds.Server_ServerCapabilities_OperationLimits_MaxNodesPerHistoryReadEvents,
        node_opcua_constants_1.VariableIds.Server_ServerCapabilities_OperationLimits_MaxNodesPerHistoryUpdateData,
        node_opcua_constants_1.VariableIds.Server_ServerCapabilities_OperationLimits_MaxNodesPerHistoryUpdateEvents,
        node_opcua_constants_1.VariableIds.Server_ServerCapabilities_OperationLimits_MaxNodesPerTranslateBrowsePathsToNodeIds
      ];
      const nodesToRead = ids.map((i) => ({ nodeId: (0, node_opcua_nodeid_1.makeNodeId)(i), attributeId: node_opcua_service_read_1.AttributeIds.Value }));
      const dataValues = await session.read(nodesToRead);
      function prepare(dataValue) {
        if (dataValue.statusCode.value === 0) {
          return dataValue.value.value;
        } else {
          warningLog("dataValue = ", dataValue.toString());
        }
        return 0;
      }
      const results = {
        maxNodesPerRead: prepare(dataValues[0]),
        maxNodesPerBrowse: prepare(dataValues[1]),
        maxNodesPerWrite: prepare(dataValues[2]),
        maxNodesPerMethodCall: prepare(dataValues[3]),
        maxNodesPerRegisterNodes: prepare(dataValues[4]),
        maxNodesPerNodeManagement: prepare(dataValues[5]),
        maxMonitoredItemsPerCall: prepare(dataValues[6]),
        maxNodesPerHistoryReadData: prepare(dataValues[7]),
        maxNodesPerHistoryReadEvents: prepare(dataValues[8]),
        maxNodesPerHistoryUpdateData: prepare(dataValues[9]),
        maxNodesPerHistoryUpdateEvents: prepare(dataValues[10]),
        maxNodesPerTranslateBrowsePathsToNodeIds: prepare(dataValues[11])
      };
      return results;
    }
    exports2.readOperationLimits = readOperationLimits;
  }
});

// node_modules/node-opcua-pseudo-session/dist/read_all_attributes.js
var require_read_all_attributes = __commonJS({
  "node_modules/node-opcua-pseudo-session/dist/read_all_attributes.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.readAllAttributes = void 0;
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_assert_1 = __importDefault3(require_dist14());
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_utils_1 = require_dist16();
    var keys = Object.keys(node_opcua_basic_types_1.AttributeIds).filter((k) => node_opcua_basic_types_1.AttributeIds[k] !== node_opcua_basic_types_1.AttributeIds.INVALID);
    var attributeNames = (() => {
      const r = [];
      for (let i = 1; i <= 22; i++) {
        r.push(node_opcua_basic_types_1.attributeNameById[i].toString());
      }
      return r;
    })();
    function composeResult(nodes, nodesToRead, dataValues) {
      (0, node_opcua_assert_1.default)(nodesToRead.length === dataValues.length);
      let c2 = 0;
      const results = [];
      let dataValue;
      let k;
      let nodeToRead;
      for (const node of nodes) {
        const data = {
          nodeId: (0, node_opcua_nodeid_1.resolveNodeId)(node),
          statusCode: node_opcua_status_code_1.StatusCodes.BadNodeIdUnknown
        };
        let addedProperty = 0;
        for (const key of attributeNames) {
          dataValue = dataValues[c2];
          nodeToRead = nodesToRead[c2];
          c2++;
          if (dataValue.statusCode.equals(node_opcua_status_code_1.StatusCodes.Good)) {
            k = (0, node_opcua_utils_1.lowerFirstLetter)(key);
            data[k] = dataValue.value ? dataValue.value.value : null;
            addedProperty += 1;
          }
        }
        if (addedProperty > 0) {
          data.statusCode = node_opcua_status_code_1.StatusCodes.Good;
        } else {
          data.statusCode = node_opcua_status_code_1.StatusCodes.BadNodeIdUnknown;
        }
        results.push(data);
      }
      return results;
    }
    async function readAllAttributes(session, arg1) {
      const isArray = Array.isArray(arg1);
      const nodes = isArray ? arg1 : [arg1];
      if (!isArray) {
        return (await readAllAttributes(session, nodes))[0];
      }
      const nodesToRead = [];
      for (const node of nodes) {
        const nodeId = (0, node_opcua_nodeid_1.resolveNodeId)(node);
        if (!nodeId) {
          throw new Error("cannot coerce " + node + " to a valid NodeId");
        }
        for (let attributeId = 1; attributeId <= 22; attributeId++) {
          nodesToRead.push({
            attributeId,
            dataEncoding: void 0,
            indexRange: void 0,
            nodeId
          });
        }
      }
      const dataValues = await session.read(nodesToRead);
      const results = composeResult(nodes, nodesToRead, dataValues);
      return results;
    }
    exports2.readAllAttributes = readAllAttributes;
  }
});

// node_modules/node-opcua-pseudo-session/dist/find_method_id.js
var require_find_method_id = __commonJS({
  "node_modules/node-opcua-pseudo-session/dist/find_method_id.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.findMethodId = exports2.findInTypeOrSuperType = void 0;
    var node_opcua_service_translate_browse_path_1 = require_dist49();
    var node_opcua_data_model_1 = require_dist27();
    async function findInTypeOrSuperType(session, browsePath) {
      const nodeId = browsePath.startingNode;
      const result2 = await session.translateBrowsePath(browsePath);
      if (result2.statusCode.isGood()) {
        return { nodeId: result2.targets[0].targetId };
      }
      const br = await session.browse({
        nodeId,
        referenceTypeId: "HasSubtype",
        browseDirection: node_opcua_data_model_1.BrowseDirection.Inverse,
        includeSubtypes: true,
        nodeClassMask: 0,
        resultMask: 0
      });
      if (br.statusCode.isNotGood()) {
        return { nodeId: null, err: new Error("cannot find typeDefinition") };
      }
      const typeDefinition = br.references[0].nodeId;
      browsePath = new node_opcua_service_translate_browse_path_1.BrowsePath({
        startingNode: typeDefinition,
        relativePath: browsePath.relativePath
      });
      return await findInTypeOrSuperType(session, browsePath);
    }
    exports2.findInTypeOrSuperType = findInTypeOrSuperType;
    async function findMethodId(session, nodeId, methodName) {
      const browsePath = (0, node_opcua_service_translate_browse_path_1.makeBrowsePath)(nodeId, "/" + (0, node_opcua_data_model_1.coerceQualifiedName)(methodName).toString());
      const result2 = await session.translateBrowsePath(browsePath);
      if (result2.statusCode.isNotGood()) {
        const br = await session.browse({
          nodeId,
          referenceTypeId: "HasTypeDefinition",
          browseDirection: node_opcua_data_model_1.BrowseDirection.Forward,
          includeSubtypes: true,
          nodeClassMask: 0,
          resultMask: 0
        });
        if (br.statusCode.isNotGood()) {
          return { methodId: null, err: new Error("cannot find typeDefinition") };
        }
        const typeDefinition = br.references[0].nodeId;
        const browsePath2 = (0, node_opcua_service_translate_browse_path_1.makeBrowsePath)(typeDefinition, "/" + methodName);
        const result3 = await findInTypeOrSuperType(session, browsePath2);
        if (!result3.nodeId) {
          return { err: result3.err, methodId: null };
        }
        return { methodId: result3.nodeId };
      }
      result2.targets = result2.targets || [];
      if (result2.targets.length > 0) {
        const methodId = result2.targets[0].targetId;
        return { methodId };
      } else {
        const err = new Error(" cannot find " + methodName + " Method");
        return { methodId: null, err };
      }
    }
    exports2.findMethodId = findMethodId;
  }
});

// node_modules/node-opcua-pseudo-session/dist/index.js
var require_dist55 = __commonJS({
  "node_modules/node-opcua-pseudo-session/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_basic_session_ex(), exports2);
    __exportStar3(require_basic_session_interface(), exports2);
    __exportStar3(require_basic_session_with_subscription(), exports2);
    __exportStar3(require_browse_all(), exports2);
    __exportStar3(require_create_monitored_items_limit(), exports2);
    __exportStar3(require_extract_fields(), exports2);
    __exportStar3(require_find_basic_datatype(), exports2);
    __exportStar3(require_find_structure_datatype(), exports2);
    __exportStar3(require_get_builtin_datatype(), exports2);
    __exportStar3(require_get_child_by_browse_name(), exports2);
    __exportStar3(require_read_operational_limits(), exports2);
    __exportStar3(require_read_all_attributes(), exports2);
    __exportStar3(require_find_method_id(), exports2);
  }
});

// node_modules/node-opcua-address-space/dist/source/continuation_points/continuation_point_manager.js
var require_continuation_point_manager = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/continuation_points/continuation_point_manager.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ContinuationPointManager = void 0;
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_debug_1 = require_dist24();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var counter = 0;
    function make_key() {
      counter += 1;
      return Buffer.from(counter.toString(), "utf-8");
    }
    var ContinuationPointManager = class {
      constructor() {
        this._map = /* @__PURE__ */ new Map();
      }
      /**
       * returns true if the current number of active continuation point has reached the limit
       * specified in maxContinuationPoint
       * @param maxBrowseContinuationPoint
       */
      hasReachedMaximum(maxContinuationPoint) {
        if (maxContinuationPoint === 0) {
          return false;
        }
        const nbContinuationPoints = this._map.size;
        return nbContinuationPoints >= maxContinuationPoint;
      }
      registerHistoryReadRaw(numValuesPerNode, dataValues, continuationData) {
        return this._register(numValuesPerNode, dataValues, continuationData);
      }
      getNextHistoryReadRaw(numValues, continuationData) {
        return this._getNext(numValues, continuationData);
      }
      registerReferences(maxElements, values, continuationData) {
        return this._register(maxElements, values, continuationData);
      }
      /**
       * - releaseContinuationPoints = TRUE
       *
       *  passed continuationPoints shall be reset to free resources in
       *  the Server. The continuation points are released and the results
       *  and diagnosticInfos arrays are empty.
       *
       * - releaseContinuationPoints = FALSE
       *
       *   passed continuationPoints shall be used to get the next set of
       *   browse information
       */
      getNextReferences(numValues, continuationData) {
        return this._getNext(numValues, continuationData);
      }
      clearContinuationPoint(continuationPoint) {
        const keyHash = continuationPoint.toString("utf-8");
        if (this._map.has(keyHash)) {
          this._map.delete(keyHash);
        }
      }
      clearContinuationPoints(continuationPoints) {
        for (const continuationPoint of continuationPoints) {
          this.clearContinuationPoint(continuationPoint);
        }
        return {
          continuationPoint: void 0,
          values: [],
          statusCode: node_opcua_status_code_1.StatusCodes.Good
        };
      }
      clear() {
        this._map.clear();
      }
      dispose() {
        this.clear();
      }
      _register(maxValues, values, continuationData) {
        if (continuationData.releaseContinuationPoints && !continuationData.continuationPoint) {
          return {
            continuationPoint: void 0,
            values: [],
            statusCode: node_opcua_status_code_1.StatusCodes.BadContinuationPointInvalid
          };
        }
        if (maxValues >= 1) {
          if (values.length === 0) {
            return {
              continuationPoint: void 0,
              values: null,
              statusCode: node_opcua_status_code_1.StatusCodes.GoodNoData
            };
          }
        }
        maxValues = maxValues || values.length;
        if (maxValues >= values.length) {
          return {
            continuationPoint: void 0,
            values,
            statusCode: node_opcua_status_code_1.StatusCodes.Good
          };
        }
        const current_block = values.splice(0, maxValues);
        const key = make_key();
        const keyHash = key.toString("utf-8");
        const result2 = {
          continuationPoint: key,
          values: current_block,
          statusCode: node_opcua_status_code_1.StatusCodes.Good
        };
        const data = {
          maxElements: maxValues,
          values
        };
        this._map.set(keyHash, data);
        return result2;
      }
      _getNext(numValues, continuationData) {
        if (!continuationData.continuationPoint) {
          return {
            continuationPoint: void 0,
            values: null,
            statusCode: node_opcua_status_code_1.StatusCodes.BadContinuationPointInvalid
          };
        }
        const keyHash = continuationData.continuationPoint.toString("utf-8");
        const data = this._map.get(keyHash);
        if (!data) {
          return {
            continuationPoint: void 0,
            values: null,
            statusCode: node_opcua_status_code_1.StatusCodes.BadContinuationPointInvalid
          };
        }
        if (continuationData.releaseContinuationPoints) {
          this._map.delete(keyHash);
          return {
            continuationPoint: void 0,
            values: [],
            statusCode: node_opcua_status_code_1.StatusCodes.Good
          };
        }
        const values = data.values.splice(0, numValues || data.maxElements);
        let continuationPoint = continuationData.continuationPoint;
        if (data.values.length === 0) {
          this._map.delete(keyHash);
          continuationPoint = void 0;
        }
        return {
          continuationPoint,
          values,
          statusCode: node_opcua_status_code_1.StatusCodes.Good
        };
      }
    };
    exports2.ContinuationPointManager = ContinuationPointManager;
  }
});

// node_modules/node-opcua-address-space/dist/source/helpers/argument_list.js
var require_argument_list = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/helpers/argument_list.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.verifyArguments_ArgumentList = exports2.isArgumentValid = exports2.getMethodDeclaration_ArgumentList = exports2.binaryStoreSize_ArgumentList = exports2.decode_ArgumentList = exports2.encode_ArgumentList = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_binary_stream_1 = require_dist18();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_factory_1 = require_dist26();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_variant_2 = require_dist28();
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_data_model_1 = require_dist27();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    function myfindBuiltInType(dataType) {
      return (0, node_opcua_factory_1.findBuiltInType)(node_opcua_variant_1.DataType[dataType]);
    }
    function encode_ArgumentList(definition, args, stream) {
      (0, node_opcua_assert_1.assert)(definition.length === args.length);
      (0, node_opcua_assert_1.assert)(Array.isArray(definition));
      (0, node_opcua_assert_1.assert)(Array.isArray(args));
      (0, node_opcua_assert_1.assert)(definition.length === args.length);
      (0, node_opcua_assert_1.assert)(definition.length >= 0);
      for (let i = 0; i < definition.length; i++) {
        const def = definition[i];
        const value = args[i];
        const encodeFunc = myfindBuiltInType(def.dataType).encode;
        const isArray = def.valueRank && (def.valueRank === 1 || def.valueRank !== -1);
        if (isArray) {
          (0, node_opcua_basic_types_1.encodeArray)(value, stream, encodeFunc);
        } else {
          encodeFunc(value, stream);
        }
      }
    }
    exports2.encode_ArgumentList = encode_ArgumentList;
    function decode_ArgumentList(definition, stream) {
      if (!Array.isArray(definition)) {
        throw new Error("This BaseDataType cannot be decoded because it has no definition.\nPlease construct a BaseDataType({definition : [{dataType: DataType.UInt32 }]});");
      }
      const args = [];
      let value;
      for (const def of definition) {
        const decodeFunc = myfindBuiltInType(def.dataType).decode;
        const isArray = def.valueRank === 1 || def.valueRank === -1;
        if (isArray) {
          value = (0, node_opcua_basic_types_1.decodeArray)(stream, decodeFunc);
        } else {
          value = decodeFunc(stream);
        }
        args.push(value);
      }
      return args;
    }
    exports2.decode_ArgumentList = decode_ArgumentList;
    function binaryStoreSize_ArgumentList(description, args) {
      (0, node_opcua_assert_1.assert)(Array.isArray(description));
      (0, node_opcua_assert_1.assert)(Array.isArray(args));
      (0, node_opcua_assert_1.assert)(args.length === description.length);
      const stream = new node_opcua_binary_stream_1.BinaryStreamSizeCalculator();
      encode_ArgumentList(description, args, stream);
      return stream.length;
    }
    exports2.binaryStoreSize_ArgumentList = binaryStoreSize_ArgumentList;
    function getMethodDeclaration_ArgumentList(addressSpace, objectId, methodId) {
      const obj = addressSpace.findNode(objectId);
      if (!obj) {
        doDebug && debugLog("cannot find node ", objectId.toString());
        return { statusCode: node_opcua_status_code_1.StatusCodes.BadNodeIdUnknown };
      }
      let objectMethod = obj.getMethodById(methodId);
      if (!objectMethod) {
        objectMethod = addressSpace.findNode(methodId);
        if (!objectMethod || objectMethod.nodeClass !== node_opcua_data_model_1.NodeClass.Method) {
          warningLog("cannot find method with id", methodId.toString(), "object Id = ", objectId.toString());
          return { statusCode: node_opcua_status_code_1.StatusCodes.BadMethodInvalid };
        }
      }
      const methodDeclarationId = objectMethod.methodDeclarationId;
      const methodDeclaration = addressSpace.findNode(methodDeclarationId);
      if (!methodDeclaration) {
        return { statusCode: node_opcua_status_code_1.StatusCodes.Good, methodDeclaration: objectMethod };
      }
      if (methodDeclaration.nodeClass !== node_opcua_data_model_1.NodeClass.Method) {
        throw new Error("Expecting a Method here");
      }
      return { statusCode: node_opcua_status_code_1.StatusCodes.Good, methodDeclaration };
    }
    exports2.getMethodDeclaration_ArgumentList = getMethodDeclaration_ArgumentList;
    function checkValueRank(argDefinition, arg) {
      const isArray = arg.arrayType === node_opcua_variant_2.VariantArrayType.Array;
      const isMatrix = arg.arrayType === node_opcua_variant_2.VariantArrayType.Matrix;
      if (argDefinition.valueRank > 0) {
        if (argDefinition.valueRank === 1) {
          if (!isArray) {
            return false;
          }
        } else {
          if (!isMatrix) {
            return false;
          }
        }
      } else if (argDefinition.valueRank === -1) {
        if (isArray || isMatrix) {
          return false;
        }
      } else if (argDefinition.valueRank === -2) {
      } else if (argDefinition.valueRank === -3) {
        if (isMatrix) {
          return false;
        }
      } else if (argDefinition.valueRank === 0) {
        if (!isArray && !isMatrix) {
          return false;
        }
      }
      return true;
    }
    function isArgumentValid(addressSpace, argDefinition, arg) {
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(argDefinition, "dataType"));
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(argDefinition, "valueRank"));
      const argDefDataType = addressSpace.findDataType(argDefinition.dataType);
      const argDataType = addressSpace.findDataType((0, node_opcua_nodeid_1.resolveNodeId)(arg.dataType));
      if (!argDefDataType) {
        debugLog("dataType ", argDefinition.dataType.toString(), "doesn't exist");
        return false;
      }
      if (argDefinition.valueRank >= 0 && arg.dataType === node_opcua_variant_1.DataType.Null) {
        return true;
      }
      if (!checkValueRank(argDefinition, arg)) {
        return false;
      }
      if (!argDataType) {
        doDebug && debugLog(" cannot find dataType ", arg.dataType, (0, node_opcua_nodeid_1.resolveNodeId)(arg.dataType));
        doDebug && debugLog(" arg = ", arg.toString());
        doDebug && debugLog(" def =", argDefinition.toString());
        return false;
      }
      if (doDebug) {
        doDebug && debugLog(" checking argDefDataType ", argDefDataType.toString());
        doDebug && debugLog(" checking argDataType ", argDataType.toString());
      }
      if (argDataType.nodeId.value === argDefDataType.nodeId.value) {
        return true;
      }
      if (argDefDataType.isSubtypeOf(argDataType)) {
        return true;
      }
      if (argDataType.isSubtypeOf(argDefDataType)) {
        return true;
      }
      if (arg.dataType === node_opcua_variant_1.DataType.Int32) {
        const enumDataType = addressSpace.findDataType((0, node_opcua_nodeid_1.coerceNodeId)(node_opcua_constants_1.DataTypeIds.Enumeration));
        if (argDefDataType.isSubtypeOf(enumDataType)) {
          return true;
        }
      }
      return false;
    }
    exports2.isArgumentValid = isArgumentValid;
    function verifyArguments_ArgumentList(addressSpace, methodInputArguments, inputArguments) {
      const inputArgumentResults = methodInputArguments.map((methodInputArgument, index) => {
        const argument = inputArguments[index];
        if (!argument) {
          return node_opcua_status_code_1.StatusCodes.BadNoData;
        } else if (!isArgumentValid(addressSpace, methodInputArgument, argument)) {
          return node_opcua_status_code_1.StatusCodes.BadTypeMismatch;
        } else {
          return node_opcua_status_code_1.StatusCodes.Good;
        }
      });
      if (methodInputArguments.length > inputArguments.length) {
        doDebug && debugLog("verifyArguments_ArgumentList \n       The client did  specify too many input arguments for the method.  \n        expected : " + methodInputArguments.length + "\n        actual   : " + inputArguments.length);
        return { inputArgumentResults, statusCode: node_opcua_status_code_1.StatusCodes.BadArgumentsMissing };
      }
      if (methodInputArguments.length < inputArguments.length) {
        doDebug && debugLog(" verifyArguments_ArgumentList \n        The client did not specify all of the input arguments for the method. \n        expected : " + methodInputArguments.length + "\n        actual   : " + inputArguments.length);
        return { inputArgumentResults, statusCode: node_opcua_status_code_1.StatusCodes.BadTooManyArguments };
      }
      const hasBadTypeMismatch = inputArgumentResults.includes(node_opcua_status_code_1.StatusCodes.BadTypeMismatch);
      const hasBadOutOfRange = inputArgumentResults.includes(node_opcua_status_code_1.StatusCodes.BadOutOfRange);
      const statusCode = hasBadTypeMismatch || hasBadOutOfRange ? hasBadTypeMismatch && !hasBadOutOfRange ? node_opcua_status_code_1.StatusCodes.BadTypeMismatch : node_opcua_status_code_1.StatusCodes.BadInvalidArgument : node_opcua_status_code_1.StatusCodes.Good;
      return {
        inputArgumentResults,
        statusCode
      };
    }
    exports2.verifyArguments_ArgumentList = verifyArguments_ArgumentList;
  }
});

// node_modules/ltx/lib/escape.js
var require_escape = __commonJS({
  "node_modules/ltx/lib/escape.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var escapeXMLTable = {
      "&": "&amp;",
      "<": "&lt;",
      ">": "&gt;",
      '"': "&quot;",
      "'": "&apos;"
    };
    function escapeXMLReplace(match) {
      return escapeXMLTable[match];
    }
    var unescapeXMLTable = {
      "&amp;": "&",
      "&lt;": "<",
      "&gt;": ">",
      "&quot;": '"',
      "&apos;": "'"
    };
    function unescapeXMLReplace(match) {
      if (match[1] === "#") {
        const num = match[2] === "x" ? parseInt(match.slice(3), 16) : parseInt(match.slice(2), 10);
        if (num === 9 || num === 10 || num === 13 || num >= 32 && num <= 55295 || num >= 57344 && num <= 65533 || num >= 65536 && num <= 1114111) {
          return String.fromCodePoint(num);
        }
        throw new Error("Illegal XML character 0x" + num.toString(16));
      }
      if (unescapeXMLTable[match]) {
        return unescapeXMLTable[match] || match;
      }
      throw new Error("Illegal XML entity " + match);
    }
    function escapeXML(s) {
      return s.replace(/["&'<>]/g, escapeXMLReplace);
    }
    function unescapeXML(s) {
      let result2 = "";
      let start = -1;
      let end = -1;
      let previous = 0;
      while ((start = s.indexOf("&", previous)) !== -1 && (end = s.indexOf(";", start + 1)) !== -1) {
        result2 = result2 + s.slice(previous, start) + unescapeXMLReplace(s.slice(start, end + 1));
        previous = end + 1;
      }
      if (previous === 0)
        return s;
      result2 = result2 + s.substring(previous);
      return result2;
    }
    function escapeXMLText(s) {
      return s.replace(/[&<>]/g, escapeXMLReplace);
    }
    function unescapeXMLText(s) {
      return s.replace(/&(amp|#38|lt|#60|gt|#62);/g, unescapeXMLReplace);
    }
    exports2.escapeXML = escapeXML;
    exports2.escapeXMLText = escapeXMLText;
    exports2.unescapeXML = unescapeXML;
    exports2.unescapeXMLText = unescapeXMLText;
  }
});

// node_modules/ltx/lib/parsers/ltx.js
var require_ltx = __commonJS({
  "node_modules/ltx/lib/parsers/ltx.js"(exports2, module2) {
    "use strict";
    var events = require("events");
    var _escape = require_escape();
    var STATE_TEXT = 0;
    var STATE_IGNORE_COMMENT = 1;
    var STATE_IGNORE_INSTRUCTION = 2;
    var STATE_TAG_NAME = 3;
    var STATE_TAG = 4;
    var STATE_ATTR_NAME = 5;
    var STATE_ATTR_EQ = 6;
    var STATE_ATTR_QUOT = 7;
    var STATE_ATTR_VALUE = 8;
    var STATE_CDATA = 9;
    var STATE_IGNORE_CDATA = 10;
    var SaxLtx = class extends events.EventEmitter {
      constructor() {
        super();
        let state = STATE_TEXT;
        let remainder;
        let parseRemainder;
        let tagName;
        let attrs;
        let endTag;
        let selfClosing;
        let attrQuote;
        let attrQuoteChar;
        let recordStart = 0;
        let attrName;
        this._handleTagOpening = function _handleTagOpening(endTag2, tagName2, attrs2) {
          if (!endTag2) {
            this.emit("startElement", tagName2, attrs2);
            if (selfClosing) {
              this.emit("endElement", tagName2);
            }
          } else {
            this.emit("endElement", tagName2);
          }
        };
        this.write = function write(data) {
          if (typeof data !== "string") {
            data = data.toString();
          }
          let pos = 0;
          if (remainder) {
            data = remainder + data;
            pos += !parseRemainder ? remainder.length : 0;
            parseRemainder = false;
            remainder = null;
          }
          function endRecording() {
            if (typeof recordStart === "number") {
              const recorded = data.slice(recordStart, pos);
              recordStart = void 0;
              return recorded;
            }
          }
          for (; pos < data.length; pos++) {
            switch (state) {
              case STATE_TEXT: {
                const lt = data.indexOf("<", pos);
                if (lt !== -1 && pos !== lt) {
                  pos = lt;
                }
                break;
              }
              case STATE_ATTR_VALUE: {
                const quot = data.indexOf(attrQuoteChar, pos);
                if (quot !== -1) {
                  pos = quot;
                }
                break;
              }
              case STATE_IGNORE_COMMENT: {
                const endcomment = data.indexOf("-->", pos);
                if (endcomment !== -1) {
                  pos = endcomment + 2;
                }
                break;
              }
              case STATE_IGNORE_CDATA: {
                const endCDATA = data.indexOf("]]>", pos);
                if (endCDATA !== -1) {
                  pos = endCDATA + 2;
                }
                break;
              }
            }
            const c2 = data.charCodeAt(pos);
            switch (state) {
              case STATE_TEXT:
                if (c2 === 60) {
                  const text2 = endRecording();
                  if (text2) {
                    this.emit("text", _escape.unescapeXML(text2));
                  }
                  state = STATE_TAG_NAME;
                  recordStart = pos + 1;
                  attrs = {};
                }
                break;
              case STATE_CDATA:
                if (c2 === 93) {
                  if (data.substr(pos + 1, 2) === "]>") {
                    const cData = endRecording();
                    if (cData) {
                      this.emit("text", cData);
                    }
                    state = STATE_TEXT;
                  } else if (data.length < pos + 2) {
                    parseRemainder = true;
                    pos = data.length;
                  }
                }
                break;
              case STATE_TAG_NAME:
                if (c2 === 47 && recordStart === pos) {
                  recordStart = pos + 1;
                  endTag = true;
                } else if (c2 === 33) {
                  if (data.substr(pos + 1, 7) === "[CDATA[") {
                    recordStart = pos + 8;
                    state = STATE_CDATA;
                  } else if (data.length < pos + 8 && "[CDATA[".startsWith(data.slice(pos + 1))) {
                    parseRemainder = true;
                    pos = data.length;
                  } else {
                    recordStart = void 0;
                    state = STATE_IGNORE_COMMENT;
                  }
                } else if (c2 === 63) {
                  recordStart = void 0;
                  state = STATE_IGNORE_INSTRUCTION;
                } else if (c2 <= 32 || c2 === 47 || c2 === 62) {
                  tagName = endRecording();
                  pos--;
                  state = STATE_TAG;
                }
                break;
              case STATE_IGNORE_COMMENT:
                if (c2 === 62) {
                  const prevFirst = data.charCodeAt(pos - 1);
                  const prevSecond = data.charCodeAt(pos - 2);
                  if (prevFirst === 45 && prevSecond === 45 || prevFirst === 93 && prevSecond === 93) {
                    state = STATE_TEXT;
                  }
                }
                break;
              case STATE_IGNORE_INSTRUCTION:
                if (c2 === 62) {
                  const prev = data.charCodeAt(pos - 1);
                  if (prev === 63) {
                    state = STATE_TEXT;
                  }
                }
                break;
              case STATE_TAG:
                if (c2 === 62) {
                  this._handleTagOpening(endTag, tagName, attrs);
                  tagName = void 0;
                  attrs = void 0;
                  endTag = void 0;
                  selfClosing = void 0;
                  state = STATE_TEXT;
                  recordStart = pos + 1;
                } else if (c2 === 47) {
                  selfClosing = true;
                } else if (c2 > 32) {
                  recordStart = pos;
                  state = STATE_ATTR_NAME;
                }
                break;
              case STATE_ATTR_NAME:
                if (c2 <= 32 || c2 === 61) {
                  attrName = endRecording();
                  pos--;
                  state = STATE_ATTR_EQ;
                }
                break;
              case STATE_ATTR_EQ:
                if (c2 === 61) {
                  state = STATE_ATTR_QUOT;
                }
                break;
              case STATE_ATTR_QUOT:
                if (c2 === 34 || c2 === 39) {
                  attrQuote = c2;
                  attrQuoteChar = c2 === 34 ? '"' : "'";
                  state = STATE_ATTR_VALUE;
                  recordStart = pos + 1;
                }
                break;
              case STATE_ATTR_VALUE:
                if (c2 === attrQuote) {
                  const value = _escape.unescapeXML(endRecording());
                  attrs[attrName] = value;
                  attrName = void 0;
                  state = STATE_TAG;
                }
                break;
            }
          }
          if (typeof recordStart === "number" && recordStart <= data.length) {
            remainder = data.slice(recordStart);
            recordStart = 0;
          }
        };
      }
      end(data) {
        if (data) {
          this.write(data);
        }
        this.write = function write() {
        };
      }
    };
    module2.exports = SaxLtx;
  }
});

// node_modules/node-opcua-xml2json/dist/source/xml2json.js
var require_xml2json = __commonJS({
  "node_modules/node-opcua-xml2json/dist/source/xml2json.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Xml2Json = exports2.ReaderState = exports2.ReaderStateBase = void 0;
    var node_opcua_assert_1 = require_dist14();
    var LtxParser = require_ltx();
    function _coerceParser(parser) {
      for (const name of Object.keys(parser)) {
        if (parser[name] && !(parser[name] instanceof ReaderState)) {
          const tmp = parser[name];
          delete parser[name];
          parser[name] = new ReaderState(tmp);
        }
      }
      return parser;
    }
    var ReaderStateBase = class {
    };
    exports2.ReaderStateBase = ReaderStateBase;
    var ReaderState = class extends ReaderStateBase {
      constructor(options) {
        super();
        this.chunks = [];
        this.text = "";
        this.name = "";
        this.level = -1;
        this.currentLevel = -1;
        options.parser = options.parser || {};
        if (!(options instanceof ReaderStateBase)) {
          this._init = options.init;
          this._finish = options.finish;
          this._startElement = options.startElement;
          this._endElement = options.endElement;
        }
        this.parser = _coerceParser(options.parser);
      }
      /**
       * @method _on_init
       * @param elementName  - the name of the element
       * @param attrs
       * @param parent
       * @param level
       * @param engine
       * @protected
       */
      _on_init(elementName, attrs, parent, level, engine) {
        this.name = elementName;
        this.parent = parent;
        this.engine = engine;
        this.data = {};
        this.level = level;
        this.currentLevel = this.level;
        this.attrs = attrs;
        (0, node_opcua_assert_1.assert)(this.attrs);
        if (this._init) {
          this._init(elementName, attrs, parent, engine);
        }
      }
      _on_finish() {
        if (this._finish) {
          this._finish();
        }
      }
      /**
       * @param level
       * @param elementName   - the name of the element
       * @param attrs
       * @protected
       */
      _on_startElement(level, elementName, attrs) {
        this.currentLevel = level;
        this.chunks = [];
        this.text = "";
        if (this._startElement) {
          this._startElement(elementName, attrs);
        }
        if (this.engine && Object.prototype.hasOwnProperty.call(this.parser, elementName)) {
          this.engine._promote(this.parser[elementName], level, elementName, attrs);
        }
      }
      _on_endElement2(level, elementName) {
        if (this._endElement) {
          this._endElement(elementName);
        }
      }
      /**
       * @method _on_endElement
       * @protected
       */
      _on_endElement(level, elementName) {
        (0, node_opcua_assert_1.assert)(this.attrs);
        this.chunks = this.chunks || [];
        if (this.level > level) {
          this._on_endElement2(level, elementName);
        } else if (this.level === level) {
          this.text = this.chunks.join("");
          this.chunks = [];
          this._on_finish();
          if (this.parent && this.parent.parser && Object.prototype.hasOwnProperty.call(this.parent.parser, elementName)) {
            this.engine._demote(this, level, elementName);
          }
        }
      }
      /**
       * @method _on_text
       * @param text {String} the text found inside the element
       * @protected
       */
      _on_text(text2) {
        this.chunks = this.chunks || [];
        text2 = text2.trim();
        if (text2.length === 0) {
          return;
        }
        this.chunks.push(text2);
      }
    };
    exports2.ReaderState = ReaderState;
    var regexp = /(([^:]+):)?(.*)/;
    function resolve_namespace(name) {
      const m2 = name.match(regexp);
      if (!m2) {
        throw new Error("Invalid match");
      }
      return {
        ns: m2[2],
        tag: m2[3]
      };
    }
    var Xml2Json = class {
      constructor(options) {
        this.currentLevel = 0;
        this.state_stack = [];
        this.current_state = null;
        const state = options instanceof ReaderStateBase ? options : new ReaderState(options);
        state.root = this;
        this.state_stack = [];
        this.current_state = null;
        this._promote(state, 0);
      }
      parseStringSync(xml_text) {
        let retValue = {};
        const parser = this._prepareParser((err, r) => retValue = r);
        parser.write(xml_text);
        parser.end();
        return retValue;
      }
      parseString(xml_text, callback) {
        const parser = this._prepareParser(callback);
        parser.write(xml_text);
        parser.end();
      }
      /**
       * @param new_state
       * @param name
       * @param attr
       * @private
       * @internal
       */
      _promote(new_state, level, name, attr) {
        attr = attr || {};
        this.state_stack.push({
          backup: {},
          state: this.current_state
        });
        const parent = this.current_state;
        this.current_state = new_state;
        this.current_state._on_init(name || "???", attr, parent, level, this);
      }
      /**
       *
       * @private
       * @internal
       */
      _demote(cur_state, level, elementName) {
        const { state, backup } = this.state_stack.pop();
        this.current_state = state;
        if (this.current_state) {
          this.current_state._on_endElement2(level, elementName);
        }
      }
      _prepareParser(callback) {
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        const parser = new LtxParser();
        this.currentLevel = 0;
        parser.on("startElement", (name, attrs) => {
          const tag_ns = resolve_namespace(name);
          this.currentLevel += 1;
          if (this.current_state) {
            this.current_state._on_startElement(this.currentLevel, tag_ns.tag, attrs);
          }
        });
        parser.on("endElement", (name) => {
          const tag_ns = resolve_namespace(name);
          if (this.current_state) {
            this.current_state._on_endElement(this.currentLevel, tag_ns.tag);
          }
          this.currentLevel -= 1;
          if (this.currentLevel === 0) {
            parser.emit("close");
          }
        });
        parser.on("text", (text2) => {
          text2 = text2.trim();
          if (text2.length === 0) {
            return;
          }
          if (this.current_state) {
            this.current_state._on_text(text2);
          }
        });
        parser.once("close", () => {
          if (callback) {
            callback(null, this.current_state._pojo);
          }
        });
        return parser;
      }
    };
    exports2.Xml2Json = Xml2Json;
    var thenify = require_thenify();
    var opts = { multiArgs: false };
    Xml2Json.prototype.parseString = thenify.withCallback(Xml2Json.prototype.parseString, opts);
  }
});

// node_modules/xml-writer/lib/xml-writer.js
var require_xml_writer = __commonJS({
  "node_modules/xml-writer/lib/xml-writer.js"(exports2, module2) {
    function isFalse(s) {
      return typeof s !== "number" && !s;
    }
    function strval(s) {
      if (typeof s == "string") {
        return s;
      } else if (typeof s == "number") {
        return s + "";
      } else if (typeof s == "function") {
        return s();
      } else if (s instanceof XMLWriter) {
        return s.toString();
      } else
        throw Error("Bad Parameter");
    }
    function XMLWriter(indent, callback) {
      if (!(this instanceof XMLWriter)) {
        return new XMLWriter();
      }
      this.name_regex = /[_:A-Za-z][-._:A-Za-z0-9]*/;
      this.indent = indent ? true : false;
      this.indentString = this.indent && typeof indent === "string" ? indent : "    ";
      this.output = "";
      this.stack = [];
      this.tags = 0;
      this.attributes = 0;
      this.attribute = 0;
      this.texts = 0;
      this.comment = 0;
      this.dtd = 0;
      this.root = "";
      this.pi = 0;
      this.cdata = 0;
      this.started_write = false;
      this.writer;
      this.writer_encoding = "UTF-8";
      if (typeof callback == "function") {
        this.writer = callback;
      } else {
        this.writer = function(s, e) {
          this.output += s;
        };
      }
    }
    XMLWriter.prototype = {
      toString: function() {
        this.flush();
        return this.output;
      },
      indenter: function() {
        if (this.indent) {
          this.write("\n");
          for (var i = 1; i < this.tags; i++) {
            this.write(this.indentString);
          }
        }
      },
      write: function() {
        for (var i = 0; i < arguments.length; i++) {
          this.writer(arguments[i], this.writer_encoding);
        }
      },
      flush: function() {
        for (var i = this.tags; i > 0; i--) {
          this.endElement();
        }
        this.tags = 0;
      },
      startDocument: function(version, encoding, standalone) {
        if (this.tags || this.attributes)
          return this;
        this.startPI("xml");
        this.startAttribute("version");
        this.text(typeof version == "string" ? version : "1.0");
        this.endAttribute();
        if (typeof encoding == "string") {
          this.startAttribute("encoding");
          this.text(encoding);
          this.endAttribute();
          this.writer_encoding = encoding;
        }
        if (standalone) {
          this.startAttribute("standalone");
          this.text("yes");
          this.endAttribute();
        }
        this.endPI();
        if (!this.indent) {
          this.write("\n");
        }
        return this;
      },
      endDocument: function() {
        if (this.attributes)
          this.endAttributes();
        return this;
      },
      writeElement: function(name, content) {
        return this.startElement(name).text(content).endElement();
      },
      writeElementNS: function(prefix, name, uri, content) {
        if (!content) {
          content = uri;
        }
        return this.startElementNS(prefix, name, uri).text(content).endElement();
      },
      startElement: function(name) {
        name = strval(name);
        if (!name.match(this.name_regex))
          throw Error("Invalid Parameter");
        if (this.tags === 0 && this.root && this.root !== name)
          throw Error("Invalid Parameter");
        if (this.attributes)
          this.endAttributes();
        ++this.tags;
        this.texts = 0;
        if (this.stack.length > 0)
          this.stack[this.stack.length - 1].containsTag = true;
        this.stack.push({
          name,
          tags: this.tags
        });
        if (this.started_write)
          this.indenter();
        this.write("<", name);
        this.startAttributes();
        this.started_write = true;
        return this;
      },
      startElementNS: function(prefix, name, uri) {
        prefix = strval(prefix);
        name = strval(name);
        if (!prefix.match(this.name_regex))
          throw Error("Invalid Parameter");
        if (!name.match(this.name_regex))
          throw Error("Invalid Parameter");
        if (this.attributes)
          this.endAttributes();
        ++this.tags;
        this.texts = 0;
        if (this.stack.length > 0)
          this.stack[this.stack.length - 1].containsTag = true;
        this.stack.push({
          name: prefix + ":" + name,
          tags: this.tags
        });
        if (this.started_write)
          this.indenter();
        this.write("<", prefix + ":" + name);
        this.startAttributes();
        this.started_write = true;
        return this;
      },
      endElement: function() {
        if (!this.tags)
          return this;
        var t = this.stack.pop();
        if (this.attributes > 0) {
          if (this.attribute) {
            if (this.texts)
              this.endAttribute();
            this.endAttribute();
          }
          this.write("/");
          this.endAttributes();
        } else {
          if (t.containsTag)
            this.indenter();
          this.write("</", t.name, ">");
        }
        --this.tags;
        this.texts = 0;
        return this;
      },
      writeAttribute: function(name, content) {
        if (typeof content == "function") {
          content = content();
        }
        if (isFalse(content)) {
          return this;
        }
        return this.startAttribute(name).text(content).endAttribute();
      },
      writeAttributeNS: function(prefix, name, uri, content) {
        if (!content) {
          content = uri;
        }
        if (typeof content == "function") {
          content = content();
        }
        if (isFalse(content)) {
          return this;
        }
        return this.startAttributeNS(prefix, name, uri).text(content).endAttribute();
      },
      startAttributes: function() {
        this.attributes = 1;
        return this;
      },
      endAttributes: function() {
        if (!this.attributes)
          return this;
        if (this.attribute)
          this.endAttribute();
        this.attributes = 0;
        this.attribute = 0;
        this.texts = 0;
        this.write(">");
        return this;
      },
      startAttribute: function(name) {
        name = strval(name);
        if (!name.match(this.name_regex))
          throw Error("Invalid Parameter");
        if (!this.attributes && !this.pi)
          return this;
        if (this.attribute)
          return this;
        this.attribute = 1;
        this.write(" ", name, '="');
        return this;
      },
      startAttributeNS: function(prefix, name, uri) {
        prefix = strval(prefix);
        name = strval(name);
        if (!prefix.match(this.name_regex))
          throw Error("Invalid Parameter");
        if (!name.match(this.name_regex))
          throw Error("Invalid Parameter");
        if (!this.attributes && !this.pi)
          return this;
        if (this.attribute)
          return this;
        this.attribute = 1;
        this.write(" ", prefix + ":" + name, '="');
        return this;
      },
      endAttribute: function() {
        if (!this.attribute)
          return this;
        this.attribute = 0;
        this.texts = 0;
        this.write('"');
        return this;
      },
      text: function(content) {
        content = strval(content);
        if (!this.tags && !this.comment && !this.pi && !this.cdata)
          return this;
        if (this.attributes && this.attribute) {
          ++this.texts;
          this.write(
            content.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/"/g, "&quot;").replace(/\t/g, "&#x9;").replace(/\n/g, "&#xA;").replace(/\r/g, "&#xD;")
          );
          return this;
        } else if (this.attributes && !this.attribute) {
          this.endAttributes();
        }
        if (this.comment || this.cdata) {
          this.write(content);
        } else {
          this.write(content.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;"));
        }
        ++this.texts;
        this.started_write = true;
        return this;
      },
      writeComment: function(content) {
        return this.startComment().text(content).endComment();
      },
      startComment: function() {
        if (this.comment)
          return this;
        if (this.attributes)
          this.endAttributes();
        this.indenter();
        this.write("<!--");
        this.comment = 1;
        this.started_write = true;
        return this;
      },
      endComment: function() {
        if (!this.comment)
          return this;
        this.write("-->");
        this.comment = 0;
        return this;
      },
      writeDocType: function(name, pubid, sysid, subset) {
        return this.startDocType(name, pubid, sysid, subset).endDocType();
      },
      startDocType: function(name, pubid, sysid, subset) {
        if (this.dtd || this.tags)
          return this;
        name = strval(name);
        pubid = pubid ? strval(pubid) : pubid;
        sysid = sysid ? strval(sysid) : sysid;
        subset = subset ? strval(subset) : subset;
        if (!name.match(this.name_regex))
          throw Error("Invalid Parameter");
        if (pubid && !pubid.match(/^[\w\-][\w\s\-\/\+\:\.]*/))
          throw Error("Invalid Parameter");
        if (sysid && !sysid.match(/^[\w\.][\w\-\/\\\:\.]*/))
          throw Error("Invalid Parameter");
        if (subset && !subset.match(/[\w\s\<\>\+\.\!\#\-\?\*\,\(\)\|]*/))
          throw Error("Invalid Parameter");
        pubid = pubid ? ' PUBLIC "' + pubid + '"' : sysid ? " SYSTEM" : "";
        sysid = sysid ? ' "' + sysid + '"' : "";
        subset = subset ? " [" + subset + "]" : "";
        if (this.started_write)
          this.indenter();
        this.write("<!DOCTYPE ", name, pubid, sysid, subset);
        this.root = name;
        this.dtd = 1;
        this.started_write = true;
        return this;
      },
      endDocType: function() {
        if (!this.dtd)
          return this;
        this.write(">");
        return this;
      },
      writePI: function(name, content) {
        return this.startPI(name).text(content).endPI();
      },
      startPI: function(name) {
        name = strval(name);
        if (!name.match(this.name_regex))
          throw Error("Invalid Parameter");
        if (this.pi)
          return this;
        if (this.attributes)
          this.endAttributes();
        if (this.started_write)
          this.indenter();
        this.write("<?", name);
        this.pi = 1;
        this.started_write = true;
        return this;
      },
      endPI: function() {
        if (!this.pi)
          return this;
        this.write("?>");
        this.pi = 0;
        return this;
      },
      writeCData: function(content) {
        return this.startCData().text(content).endCData();
      },
      startCData: function() {
        if (this.cdata)
          return this;
        if (this.attributes)
          this.endAttributes();
        this.indenter();
        this.write("<![CDATA[");
        this.cdata = 1;
        this.started_write = true;
        return this;
      },
      endCData: function() {
        if (!this.cdata)
          return this;
        this.write("]]>");
        this.cdata = 0;
        return this;
      },
      writeRaw: function(content) {
        content = strval(content);
        if (!this.tags && !this.comment && !this.pi && !this.cdata)
          return this;
        if (this.attributes && this.attribute) {
          ++this.texts;
          this.write(content.replace("&", "&amp;").replace('"', "&quot;"));
          return this;
        } else if (this.attributes && !this.attribute) {
          this.endAttributes();
        }
        ++this.texts;
        this.write(content);
        this.started_write = true;
        return this;
      }
    };
    module2.exports = XMLWriter;
  }
});

// node_modules/xml-writer/index.js
var require_xml_writer2 = __commonJS({
  "node_modules/xml-writer/index.js"(exports2, module2) {
    module2.exports = require_xml_writer();
  }
});

// node_modules/node-opcua-xml2json/dist/source/fragment_cloner.js
var require_fragment_cloner = __commonJS({
  "node_modules/node-opcua-xml2json/dist/source/fragment_cloner.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.InternalFragmentClonerReaderState = void 0;
    var XMLWriter = require_xml_writer2();
    var InternalFragmentClonerReaderState = class {
      constructor() {
        this._xw = new XMLWriter(true);
        this.initLevel = 0;
      }
      _on_startElement(level, elementName, attrs) {
        this._xw.startElement(elementName);
        for (const [attName, attValue] of Object.entries(attrs)) {
          this._xw.writeAttribute(attName, attValue);
        }
      }
      _on_endElement(level, elementName) {
        this._xw.endElement();
        if (this.initLevel === level) {
          this.value = this._xw.toString();
          this.engine._demote(this, this.engine.currentLevel, elementName);
          this.engine = void 0;
          this._on_finish();
        }
      }
      _on_init(elementName, attrs, parent, level, engine) {
        this.engine = engine;
        this.initLevel = level;
        this._xw = new XMLWriter(true);
        this._xw.startElement(elementName);
        for (const [attName, attValue] of Object.entries(attrs)) {
          this._xw.writeAttribute(attName, attValue);
        }
      }
      _on_finish() {
      }
      _on_endElement2(level, elementName) {
      }
      _on_text(text2) {
        this._xw.text(text2);
      }
    };
    exports2.InternalFragmentClonerReaderState = InternalFragmentClonerReaderState;
  }
});

// node_modules/node-opcua-xml2json/dist/source/xml2Json_pojo_tools.js
var require_xml2Json_pojo_tools = __commonJS({
  "node_modules/node-opcua-xml2json/dist/source/xml2Json_pojo_tools.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ReaderState2 = void 0;
    var node_opcua_utils_1 = require_dist16();
    var xml2json_1 = require_xml2json();
    var ReaderState2 = class extends xml2json_1.ReaderStateBase {
      constructor() {
        super();
        this.initLevel = 0;
        this._pojo = {};
        this._stack = [];
        this._element = {};
        this.text = "";
        this.parent = void 0;
        this._withPojo = (pojo) => {
        };
      }
      _on_init(elementName, attrs, parent, level, engine) {
        this.parent = parent;
        this.engine = engine;
        this.initLevel = level;
        if (this._stack.length === 0) {
          this._pojo = {};
          this._element = this._pojo;
        }
      }
      _on_finish() {
      }
      _on_startElement(level, elementName, attrs) {
        this._stack.push(this._element);
        if (elementName.match(/^ListOf/)) {
          elementName = elementName.substring(6);
          const elName = (0, node_opcua_utils_1.lowerFirstLetter)(elementName);
          if (this._element instanceof Array) {
            const array = [];
            this._element.push(array);
            this._element = array;
          } else {
            this._element[elName] = [];
            this._element = this._element[elName];
          }
        } else {
          const elName = (0, node_opcua_utils_1.lowerFirstLetter)(elementName);
          if (this._element instanceof Array) {
            const obj = {};
            this._element.push(obj);
            this._element = obj;
          } else {
            this._element[elName] = {};
            this._element = this._element[elName];
          }
        }
      }
      _on_endElement2(level, elementName) {
      }
      _on_endElement(level, elementName) {
        this._element = this._stack.pop();
        if (this.text.length > 0 && this._element) {
          const elName = (0, node_opcua_utils_1.lowerFirstLetter)(elementName);
          this._element[elName] = this.text;
        } else {
          const elName = (0, node_opcua_utils_1.lowerFirstLetter)(elementName);
          if (this.initLevel === level) {
            if (this._withPojo) {
              if (this.text.length) {
                this._withPojo.call(null, elName, this.text);
              } else {
                this._withPojo.call(null, elName, this._pojo);
              }
            }
          }
        }
        this.text = "";
      }
      _on_text(text2) {
        this.text = text2;
      }
    };
    exports2.ReaderState2 = ReaderState2;
  }
});

// node_modules/node-opcua-xml2json/dist/source/xml2json_pojo.js
var require_xml2json_pojo = __commonJS({
  "node_modules/node-opcua-xml2json/dist/source/xml2json_pojo.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Xml2JsonPojo = exports2.startPojo = exports2.json_parser = void 0;
    var xml2json_1 = require_xml2json();
    var xml2Json_pojo_tools_1 = require_xml2Json_pojo_tools();
    var json_extractor = new xml2Json_pojo_tools_1.ReaderState2();
    exports2.json_parser = {
      init(elementName, attrs, parent, engine) {
        json_extractor._on_init(elementName, attrs, parent, 0, engine);
      },
      finish() {
        this.parent._pojo = json_extractor._pojo;
      }
    };
    function startPojo(pThis, elementName, attrs, withPojo) {
      pThis.engine._promote(json_extractor, pThis.engine.currentLevel, elementName, attrs);
      json_extractor._withPojo = (name, pojo) => {
        withPojo(name, pojo);
        pThis.engine._demote(json_extractor, pThis.engine.currentLevel, elementName);
      };
    }
    exports2.startPojo = startPojo;
    var Xml2JsonPojo = class extends xml2json_1.Xml2Json {
      constructor() {
        super(json_extractor);
      }
    };
    exports2.Xml2JsonPojo = Xml2JsonPojo;
  }
});

// node_modules/node-opcua-xml2json/dist/source/fragment_cloner_parser.js
var require_fragment_cloner_parser = __commonJS({
  "node_modules/node-opcua-xml2json/dist/source/fragment_cloner_parser.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.FragmentClonerParser = void 0;
    var fragment_cloner_1 = require_fragment_cloner();
    var FragmentClonerParser = class {
      startElement(elementName, attrs) {
        this._cloneFragment = new fragment_cloner_1.InternalFragmentClonerReaderState();
        this.engine._promote(this._cloneFragment, this.engine.currentLevel, elementName, attrs);
      }
      finish() {
        this.value = this._cloneFragment.value;
        this._cloneFragment.value = null;
      }
    };
    exports2.FragmentClonerParser = FragmentClonerParser;
  }
});

// node_modules/node-opcua-xml2json/dist/source/extension_object_parser.js
var require_extension_object_parser = __commonJS({
  "node_modules/node-opcua-xml2json/dist/source/extension_object_parser.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.makeExtensionObjectReader = void 0;
    var node_opcua_utils_1 = require_dist16();
    var xml2json_1 = require_xml2json();
    function BasicType_parser(dataType, parseFunc) {
      const r = {
        init(elementName, attrs) {
          this.value = void 0;
        },
        finish() {
          this.value = parseFunc.call(this, this.text);
        }
      };
      const _parser = {};
      _parser[dataType] = r;
      return _parser;
    }
    function ListOf(dataType, parseFunc) {
      return {
        init() {
          this.value = [];
        },
        parser: BasicType_parser(dataType, parseFunc),
        finish() {
        },
        endElement(elementName) {
          this.value.push(this.parser[elementName].value);
        }
      };
    }
    var localizedTextReader = {
      init() {
        this.localizedText = {};
      },
      parser: {
        Locale: {
          finish() {
            this.parent.localizedText = this.parent.localizedText || {};
            this.parent.localizedText.locale = this.text.trim();
          }
        },
        Text: {
          finish() {
            this.parent.localizedText = this.parent.localizedText || {};
            this.parent.localizedText.text = this.text.trim();
          }
        }
      },
      finish() {
        this.value = this.localizedText;
      }
    };
    var partials = {
      LocalizedText: localizedTextReader,
      String: {
        finish() {
          this.value = this.text;
        }
      },
      Boolean: {
        finish() {
          this.value = this.text.toLowerCase() === "true";
        }
      },
      ByteString: {
        init() {
          this.value = null;
        },
        finish() {
          const base64text = this.text;
          const byteString = Buffer.from(base64text, "base64");
          this.value = byteString;
        }
      },
      Float: {
        finish() {
          this.value = parseFloat(this.text);
        }
      },
      Double: {
        finish() {
          this.value = parseFloat(this.text);
        }
      },
      Int8: {
        finish() {
          this.value = parseInt(this.text, 10);
        }
      },
      Int16: {
        finish() {
          this.value = parseInt(this.text, 10);
        }
      },
      Int32: {
        finish() {
          this.value = parseInt(this.text, 10);
        }
      },
      Int64: {
        finish() {
          this.value = parseInt(this.text, 10);
        }
      },
      UInt8: {
        finish() {
          this.value = parseInt(this.text, 10);
        }
      },
      UInt16: {
        finish() {
          this.value = parseInt(this.text, 10);
        }
      },
      UInt32: {
        finish() {
          this.value = parseInt(this.text, 10);
        }
      },
      UInt64: {
        finish() {
          this.value = parseInt(this.text, 10);
        }
      },
      ListOfLocalizedText: {
        init() {
          this.value = [];
        },
        parser: { LocalizedText: localizedTextReader },
        finish() {
        },
        endElement() {
          this.value.push(this.parser.LocalizedText.value);
        }
      },
      ListOfDouble: ListOf("Double", parseFloat),
      ListOfFloat: ListOf("Float", parseFloat),
      ListOfInt32: ListOf("Int32", parseInt),
      ListOfInt16: ListOf("Int16", parseInt),
      ListOfInt8: ListOf("Int8", parseInt),
      ListOfUint32: ListOf("Uint32", parseInt),
      ListOfUint16: ListOf("Uint16", parseInt),
      ListOfUint8: ListOf("Uint8", parseInt)
    };
    function _clone(a) {
      if (typeof a === "string" || typeof a === "number" || typeof a === "boolean") {
        return a;
      }
      if (a instanceof Buffer) {
        return Buffer.from(a);
      }
      if (a instanceof Array) {
        return a.map((x2) => _clone(x2));
      }
      return { ...a };
    }
    function _makeExtensionObjectReader(definitionName, definitionMap, readerMap) {
      if (Object.prototype.hasOwnProperty.call(partials, definitionName)) {
        return partials[definitionName];
      }
      let reader = readerMap[definitionName];
      if (reader) {
        return reader;
      }
      const definition = definitionMap.findDefinition(definitionName);
      if (!definition) {
        throw new Error("cannot find definition for " + definitionName);
      }
      reader = {
        finish() {
        },
        parser: {}
      };
      for (const field of definition.fields) {
        const fieldReader = _makeExtensionObjectReader(field.dataType, definitionMap, readerMap);
        if (!fieldReader) {
          throw new Error(" Cannot find reader for dataType " + field.dataType);
        }
        if (field.valueRank === void 0 || field.valueRank === -1) {
          const parser = fieldReader;
          if (!parser) {
            throw new Error("??? " + field.dataType + "  " + field.name);
          }
          reader.parser[field.name] = {
            parser: fieldReader.parser,
            // endElement: fieldReader.endElement,
            finish() {
              const elName = (0, node_opcua_utils_1.lowerFirstLetter)(field.name);
              fieldReader.finish.call(this);
              this.parent.value = this.parent.value || {};
              this.parent.value[elName] = _clone(this.value);
            }
          };
        } else if (field.valueRank === 1) {
          const listReader = {
            init() {
              this.value = [];
            },
            parser: {},
            finish() {
              const elName = (0, node_opcua_utils_1.lowerFirstLetter)(this.name);
              this.parent.value = this.parent.value || {};
              this.parent.value[elName] = this.value;
              this.value = void 0;
            },
            startElement(name, attrs) {
            },
            endElement(element) {
              this.value.push(_clone(this.parser[element].value));
            }
          };
          listReader.parser[field.dataType] = fieldReader;
          reader.parser[field.name] = listReader;
        } else {
          throw new Error("Unsupported ValueRank ! " + field.valueRank);
        }
      }
      readerMap[definitionName] = reader;
      return reader;
    }
    function makeExtensionObjectReader(definitionName, definitionMap, readerMap) {
      const reader1 = {
        parser: {},
        endElement() {
          this._pojo = this.parser[definitionName].value;
        }
      };
      reader1.parser[definitionName] = _makeExtensionObjectReader(definitionName, definitionMap, readerMap);
      return new xml2json_1.ReaderState(reader1);
    }
    exports2.makeExtensionObjectReader = makeExtensionObjectReader;
  }
});

// node_modules/node-opcua-xml2json/dist/source/definition_parser.js
var require_definition_parser = __commonJS({
  "node_modules/node-opcua-xml2json/dist/source/definition_parser.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.definitionReaderStateParser = exports2._definitionParser = void 0;
    var node_opcua_assert_1 = __importDefault3(require_dist14());
    exports2._definitionParser = {
      init(name, attrs) {
        (0, node_opcua_assert_1.default)(!this.parent.nFields || this.parent.definitionFields.length === 0);
        this.parent.definitionFields = [];
        this.parent.definitionName = attrs.SymbolicName || attrs.Name;
        this.array = this.parent.definitionFields;
        this.isUnion = attrs.IsUnion === "true" ? true : false;
      },
      parser: {
        Field: {
          init() {
            this.description = void 0;
          },
          parser: {
            Description: {
              finish() {
                this.parent.description = this.text;
              }
            }
          },
          finish() {
            const obj = {
              name: this.attrs.Name
            };
            if (this.attrs.AllowSubtype !== void 0) {
              obj.allowSubtype = this.attrs.AllowSubtype === "true";
            } else {
              obj.allowSubtype = false;
            }
            if (this.attrs.DataType !== void 0) {
              obj.dataType = this.attrs.DataType;
            }
            if (this.description) {
              obj.description = this.description;
            }
            if (this.attrs.Value !== void 0) {
              obj.value = parseInt(this.attrs.Value, 10);
            }
            if (this.attrs.ValueRank !== void 0) {
              obj.valueRank = parseInt(this.attrs.ValueRank, 10);
            } else {
              obj.valueRank = -1;
            }
            if (this.attrs.ArrayDimensions !== void 0) {
              obj.arrayDimensions = this.attrs.ArrayDimensions.split(",").map((e) => parseInt(e, 10));
            }
            if (this.attrs.IsOptional !== void 0) {
              obj.isOptional = this.attrs.IsOptional === "true" ? true : false;
            }
            if (this.attrs.SymbolicName !== void 0) {
              obj.symbolicName = this.attrs.SymbolicName;
            }
            this.parent.array.push(obj);
          }
        }
      }
    };
    exports2.definitionReaderStateParser = {
      parser: {
        Definition: exports2._definitionParser
      },
      endElement() {
        this._pojo = {
          name: this.definitionName,
          fields: this.definitionFields
        };
      }
    };
  }
});

// node_modules/node-opcua-xml2json/dist/source/index.js
var require_source2 = __commonJS({
  "node_modules/node-opcua-xml2json/dist/source/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_xml2json(), exports2);
    __exportStar3(require_fragment_cloner(), exports2);
    __exportStar3(require_xml2json_pojo(), exports2);
    __exportStar3(require_fragment_cloner_parser(), exports2);
    __exportStar3(require_extension_object_parser(), exports2);
    __exportStar3(require_definition_parser(), exports2);
  }
});

// node_modules/node-opcua-schemas/dist/source/dynamic_extension_object.js
var require_dynamic_extension_object = __commonJS({
  "node_modules/node-opcua-schemas/dist/source/dynamic_extension_object.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.createDynamicObjectConstructor = exports2.DynamicExtensionObject = exports2.getOrCreateConstructor = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_extension_object_1 = require_dist30();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_factory_1 = require_dist26();
    var node_opcua_nodeid_2 = require_dist21();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    function associateEncoding(dataTypeFactory, constructor, { encodingDefaultBinary, encodingDefaultXml }) {
      const schema = constructor.schema;
      const dataTypeName = schema.name;
      if (encodingDefaultBinary && encodingDefaultBinary.value !== 0) {
        schema.encodingDefaultBinary = encodingDefaultBinary;
        schema.encodingDefaultXml = encodingDefaultXml;
        constructor.encodingDefaultBinary = encodingDefaultBinary;
        constructor.encodingDefaultXml = encodingDefaultXml;
        dataTypeFactory.associateWithBinaryEncoding(dataTypeName, encodingDefaultBinary);
      }
    }
    function getOrCreateConstructor(dataTypeName, dataTypeFactory, encodingDefaultBinary, encodingDefaultXml) {
      if (dataTypeFactory.hasStructureByTypeName(dataTypeName)) {
        const structureInfo = dataTypeFactory.getStructureInfoByTypeName(dataTypeName);
        return structureInfo.constructor || node_opcua_extension_object_1.ExtensionObject;
      }
      const schema = dataTypeFactory.getStructuredTypeSchema(dataTypeName);
      if (!schema) {
        throw new Error("Unknown type in dictionary " + dataTypeName);
      }
      const constructor = createDynamicObjectConstructor(schema, dataTypeFactory);
      if (!constructor) {
        return node_opcua_extension_object_1.ExtensionObject;
      }
      if (!dataTypeFactory.hasStructureByTypeName(dataTypeName)) {
        dataTypeFactory.registerClassDefinition(schema.dataTypeNodeId, dataTypeName, constructor);
        return constructor;
      }
      associateEncoding(dataTypeFactory, constructor, { encodingDefaultBinary });
      return constructor;
    }
    exports2.getOrCreateConstructor = getOrCreateConstructor;
    function encodeElement(field, element, stream, encodeFunc) {
      if (encodeFunc) {
        encodeFunc(element, stream);
      } else {
        if (!element.encode) {
          throw new Error("encodeArrayOrElement: object field " + field.name + " has no encode method and encodeFunc is missing");
        }
        if (field.allowSubType) {
          (0, node_opcua_extension_object_1.encodeExtensionObject)(element, stream);
        } else {
          element.encode(stream);
        }
      }
    }
    function encodeArrayOrElement(field, obj, stream, encodeFunc) {
      if (field.isArray) {
        const array = obj[field.name];
        if (!array) {
          stream.writeUInt32(4294967295);
        } else {
          stream.writeUInt32(array.length);
          for (const e of array) {
            encodeElement(field, e, stream, encodeFunc);
          }
        }
      } else {
        encodeElement(field, obj[field.name], stream, encodeFunc);
      }
    }
    function decodeElement(dataTypeFactory, field, stream, decodeFunc) {
      if (decodeFunc) {
        return decodeFunc(stream);
      } else {
        if (field.allowSubType) {
          const element = (0, node_opcua_extension_object_1.decodeExtensionObject)(stream);
          return element;
        } else {
          const structureInfo = dataTypeFactory.getStructureInfoByTypeName(field.fieldType);
          if (!structureInfo.constructor) {
            throw new Error("Cannot instantiate an abstract dataStructure: " + field.fieldType);
          }
          const element = new structureInfo.constructor({});
          element.decode(stream);
          return element;
        }
      }
    }
    function decodeArrayOrElement(dataTypeFactory, field, obj, stream, decodeFunc) {
      if (field.isArray) {
        const array = [];
        const nbElements = stream.readUInt32();
        if (nbElements === 4294967295) {
          obj[field.name] = null;
        } else {
          for (let i = 0; i < nbElements; i++) {
            const element = decodeElement(dataTypeFactory, field, stream, decodeFunc);
            array.push(element);
          }
          obj[field.name] = array;
        }
      } else {
        obj[field.name] = decodeElement(dataTypeFactory, field, stream, decodeFunc);
      }
    }
    function isSubtype(dataTypeFactory, dataTypeNodeId, schema) {
      if ((0, node_opcua_nodeid_1.sameNodeId)(dataTypeNodeId, schema.dataTypeNodeId)) {
        return true;
      }
      const baseSchema = schema.getBaseSchema();
      if (!baseSchema || !baseSchema?.dataTypeNodeId)
        return false;
      const structureInfo = dataTypeFactory.getStructureInfoForDataType(baseSchema.dataTypeNodeId);
      if (!structureInfo) {
        return false;
      }
      return isSubtype(dataTypeFactory, dataTypeNodeId, structureInfo.schema);
    }
    function _validateSubType(dataTypeFactory, field, value) {
      (0, node_opcua_assert_1.assert)(field.allowSubType);
      if (!value) {
        value = { dataType: node_opcua_variant_1.DataType.Null, value: null };
        return;
      }
      if (field.category === "basic") {
        if (!Object.prototype.hasOwnProperty.call(value, "dataType")) {
          const msg2 = "initializeField: field that allow subtype must be a Variant like and have a dataType property";
          errorLog(msg2);
          throw new Error(msg2);
        }
        const c2 = dataTypeFactory.getBuiltInTypeByDataType((0, node_opcua_nodeid_2.coerceNodeId)(`i=${value.dataType}`, 0));
        const d2 = dataTypeFactory.getBuiltInType(field.fieldType);
        if (c2 && c2.isSubTypeOf(d2)) {
          return;
        }
        const msg = "initializeField: invalid subtype for field " + field.name + " expecting " + field.fieldType + " but got " + node_opcua_variant_1.DataType[value.dataType];
        errorLog(msg);
        throw new Error(msg);
      } else {
        if (value !== null && !(value instanceof node_opcua_extension_object_1.ExtensionObject)) {
          errorLog("initializeField: array element is not an ExtensionObject");
          throw new Error(`${field.name}: array element must be an ExtensionObject`);
        }
        const e = value;
        if (!isSubtype(dataTypeFactory, field.dataType, e.schema)) {
          const msg = "initializeField: invalid subtype for field " + field.name + " expecting " + field.fieldType + " but got " + e.schema.dataTypeNodeId.toString() + " " + e.schema.name;
          errorLog(msg);
          throw new Error(msg);
        }
      }
    }
    function validateSubTypeA(dataTypeFactory, field, value) {
      if (field.isArray) {
        const arr = value || [];
        for (const e of arr) {
          _validateSubType(dataTypeFactory, field, e);
        }
      } else {
        _validateSubType(dataTypeFactory, field, value);
      }
    }
    function initializeField(field, thisAny, options, schema, dataTypeFactory) {
      const name = field.name;
      const value = getFieldValue(field, options);
      switch (field.category) {
        case node_opcua_factory_1.FieldCategory.complex: {
          if (field.allowSubType) {
            validateSubTypeA(dataTypeFactory, field, value);
            if (field.isArray) {
              const arr = value || [];
              thisAny[name] = arr.map((x2) => x2.clone());
            } else {
              const e = value;
              if (e !== null && !(e instanceof node_opcua_extension_object_1.ExtensionObject)) {
                errorLog("initializeField: array element is not an ExtensionObject");
              }
              thisAny[name] = e.clone();
            }
          } else {
            const constructor = dataTypeFactory.getStructureInfoByTypeName(field.fieldType).constructor;
            if (!constructor) {
              throw new Error("Cannot instantiate an abstract dataType" + field.fieldType);
            }
            if (field.isArray) {
              const arr = value || [];
              thisAny[name] = arr.map((x2) => constructor ? new constructor(x2) : null);
            } else {
              thisAny[name] = constructor ? new constructor(value) : null;
            }
          }
          break;
        }
        case node_opcua_factory_1.FieldCategory.enumeration:
        case node_opcua_factory_1.FieldCategory.basic:
          if (field.allowSubType) {
            validateSubTypeA(dataTypeFactory, field, value);
          }
          if (field.isArray) {
            thisAny[name] = (0, node_opcua_factory_1.initialize_field_array)(field, value, dataTypeFactory);
          } else {
            thisAny[name] = (0, node_opcua_factory_1.initialize_field)(field, value, dataTypeFactory);
          }
          break;
      }
    }
    function getFieldValue(field, options) {
      return options[field.name] !== void 0 ? options[field.name] : options[field.originalName];
    }
    function initializeFields(thisAny, options, schema, dataTypeFactory, params) {
      const baseSchema = schema.getBaseSchema();
      if (baseSchema && baseSchema.fields.length) {
        initializeFields(thisAny, options, baseSchema, dataTypeFactory, params);
      }
      for (const field of schema.fields) {
        const name = field.name;
        const value = getFieldValue(field, options);
        if (field.switchBit !== void 0 && value === void 0) {
          thisAny[name] = void 0;
          continue;
        }
        initializeField(field, thisAny, options, schema, dataTypeFactory);
      }
    }
    function hasOptionalFieldsF(schema) {
      if (schema.bitFields && schema.bitFields.length > 0) {
        return true;
      }
      const baseSchema = schema.getBaseSchema();
      return baseSchema ? hasOptionalFieldsF(baseSchema) : false;
    }
    function _internal_encodeFields(thisAny, schema, stream) {
      const baseSchema = schema.getBaseSchema();
      if (baseSchema && baseSchema.fields.length) {
        _internal_encodeFields(thisAny, baseSchema, stream);
      }
      for (const field of schema.fields) {
        if (field.switchBit !== void 0 && thisAny[field.name] === void 0) {
          continue;
        }
        switch (field.category) {
          case node_opcua_factory_1.FieldCategory.complex:
            encodeArrayOrElement(field, thisAny, stream);
            break;
          case node_opcua_factory_1.FieldCategory.enumeration:
          case node_opcua_factory_1.FieldCategory.basic:
            encodeArrayOrElement(field, thisAny, stream, field.schema.encode);
            break;
          default:
            throw new Error("Invalid category " + field.category + " " + node_opcua_factory_1.FieldCategory[field.category]);
        }
      }
    }
    function makeBitField(thisAny, schema, bo) {
      const baseSchema = schema.getBaseSchema();
      const data = baseSchema ? makeBitField(thisAny, baseSchema, bo) : bo;
      let { bitField, allOptional } = data;
      const { offset } = data;
      let nbOptionalFields = 0;
      for (const field of schema.fields) {
        if (field.switchBit === void 0) {
          allOptional = false;
          continue;
        }
        nbOptionalFields += 1;
        if (thisAny[field.name] === void 0) {
          continue;
        }
        bitField |= 1 << field.switchBit + offset;
      }
      return { bitField, offset: nbOptionalFields + offset, allOptional };
    }
    function encodeFields(thisAny, schema, stream) {
      const hasOptionalFields = hasOptionalFieldsF(schema);
      if (hasOptionalFields) {
        const { bitField, allOptional } = makeBitField(thisAny, schema, { bitField: 0, offset: 0, allOptional: true });
        if (!(bitField === 0 && allOptional)) {
          stream.writeUInt32(bitField);
        }
      }
      _internal_encodeFields(thisAny, schema, stream);
    }
    function internal_decodeFields(thisAny, bitField, hasOptionalFields, schema, stream, dataTypeFactory) {
      const baseSchema = schema.getBaseSchema();
      if (baseSchema && baseSchema.fields.length) {
        internal_decodeFields(thisAny, bitField, hasOptionalFields, baseSchema, stream, dataTypeFactory);
      }
      for (const field of schema.fields) {
        if (hasOptionalFields && field.switchBit !== void 0) {
          if ((bitField & 1 << field.switchBit) === 0) {
            thisAny[field.name] = void 0;
            continue;
          } else {
            if (field.category === node_opcua_factory_1.FieldCategory.complex && thisAny[field.name] === void 0) {
              initializeField(field, thisAny, {}, schema, dataTypeFactory);
            }
          }
        }
        switch (field.category) {
          case node_opcua_factory_1.FieldCategory.complex:
            decodeArrayOrElement(dataTypeFactory, field, thisAny, stream);
            break;
          case node_opcua_factory_1.FieldCategory.enumeration:
          case node_opcua_factory_1.FieldCategory.basic:
            decodeArrayOrElement(dataTypeFactory, field, thisAny, stream, field.schema.decode);
            break;
          default:
            throw new Error("Invalid category " + field.category + " " + node_opcua_factory_1.FieldCategory[field.category]);
        }
      }
    }
    function decodeFields(thisAny, schema, stream, dataTypeFactory) {
      const hasOptionalFields = hasOptionalFieldsF(schema);
      let bitField = 0;
      if (hasOptionalFields && stream.buffer.length - stream.length > 0) {
        bitField = stream.readUInt32();
      }
      internal_decodeFields(thisAny, bitField, hasOptionalFields, schema, stream, dataTypeFactory);
    }
    function ___fieldToJson(field, value) {
      switch (field.category) {
        case node_opcua_factory_1.FieldCategory.complex:
          return value ? value?.toJSON() : null;
        case node_opcua_factory_1.FieldCategory.enumeration:
        case node_opcua_factory_1.FieldCategory.basic:
          return value instanceof Date ? new Date(value.getTime()) : value?.toJSON ? value?.toJSON() : value;
        default:
          throw new Error("Invalid category " + field.category + " " + node_opcua_factory_1.FieldCategory[field.category]);
      }
    }
    function fieldToJSON(field, value) {
      if (field.isArray) {
        if (value) {
          return value.map(___fieldToJson.bind(null, field));
        }
      } else {
        return ___fieldToJson(field, value);
      }
    }
    function encodeToJson(thisAny, schema, pojo) {
      const baseSchema = schema.getBaseSchema();
      if (baseSchema && baseSchema.fields.length) {
        encodeToJson(thisAny, baseSchema, pojo);
      }
      for (const field of schema.fields) {
        const value = thisAny[field.name];
        if (value === void 0) {
          continue;
        }
        pojo[field.name] = fieldToJSON(field, value);
      }
    }
    var _private = /* @__PURE__ */ new WeakMap();
    var DynamicExtensionObject = class extends node_opcua_extension_object_1.ExtensionObject {
      constructor(options, schema, dataTypeFactory) {
        (0, node_opcua_assert_1.assert)(schema, "expecting a schema here ");
        (0, node_opcua_assert_1.assert)(dataTypeFactory, "expecting a DataTypeFactory");
        super(options);
        options = options || {};
        _private.set(this, { schema, factory: dataTypeFactory });
        (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, this.schema, options);
        initializeFields(this, options, this.schema, dataTypeFactory, { caseInsensitive: true });
      }
      encode(stream) {
        super.encode(stream);
        encodeFields(this, this.schema, stream);
      }
      decode(stream) {
        super.decode(stream);
        decodeFields(this, this.schema, stream, _private.get(this).factory);
      }
      get schema() {
        const r = _private.get(this);
        return r.schema;
      }
      toJSON() {
        const pojo = {};
        encodeToJson(this, this.schema, pojo);
        return pojo;
      }
    };
    exports2.DynamicExtensionObject = DynamicExtensionObject;
    DynamicExtensionObject.schema = node_opcua_extension_object_1.ExtensionObject.schema;
    DynamicExtensionObject.possibleFields = [];
    var UnionBaseClass = class extends node_opcua_factory_1.BaseUAObject {
      // eslint-disable-next-line max-statements
      constructor(options, schema, dataTypeFactory) {
        super();
        (0, node_opcua_assert_1.assert)(schema, "expecting a schema here ");
        (0, node_opcua_assert_1.assert)(dataTypeFactory, "expecting a typeDic");
        options = options || {};
        _private.set(this, { schema });
        (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, this.schema, options);
        let uniqueFieldHasBeenFound = false;
        let switchFieldName = "";
        for (const field of this.schema.fields) {
          const name = field.name;
          if (field.switchValue === void 0) {
            switchFieldName = field.name;
            continue;
          }
          (0, node_opcua_assert_1.assert)(switchFieldName.length > 0, "It seems that there is no switch field in union schema");
          (0, node_opcua_assert_1.assert)(field.switchValue !== void 0, "union schema must only have one switched value field");
          const value = getFieldValue(field, options);
          if (uniqueFieldHasBeenFound && value !== void 0) {
            debugLog(this.schema);
            throw new Error("union must have only one choice in " + JSON.stringify(options) + "\n found while investigating " + field.name + "\n switchFieldName = " + switchFieldName);
          }
          if (options[switchFieldName] !== void 0) {
            if (options[switchFieldName] !== field.switchValue) {
              continue;
            }
          } else {
            if (value === void 0) {
              continue;
            }
          }
          uniqueFieldHasBeenFound = true;
          this[switchFieldName] = field.switchValue;
          switch (field.category) {
            case node_opcua_factory_1.FieldCategory.complex: {
              const Constructor = dataTypeFactory.getStructureInfoByTypeName(field.fieldType).constructor;
              if (!Constructor) {
                throw new Error("Cannot instantiate an abstract dataType" + field.fieldType);
              }
              if (field.isArray) {
                this[name] = (value || []).map((x2) => Constructor ? new Constructor(x2) : null);
              } else {
                this[name] = Constructor ? new Constructor(value) : null;
              }
              break;
            }
            case node_opcua_factory_1.FieldCategory.enumeration:
            case node_opcua_factory_1.FieldCategory.basic:
              if (field.isArray) {
                this[name] = (0, node_opcua_factory_1.initialize_field_array)(field, value);
              } else {
                this[name] = (0, node_opcua_factory_1.initialize_field)(field, value);
              }
              break;
          }
        }
        if (!uniqueFieldHasBeenFound) {
          if (Object.keys(options).length === 0) {
            this[switchFieldName] = 0;
            return;
          }
          const r = schema.fields.filter((f2) => f2.switchValue !== void 0).map((f2) => f2.name).join(" , ");
          const foundFieldForSwitchValue = schema.fields.findIndex((f2) => f2.switchValue !== void 0 && f2.switchValue === options[switchFieldName]);
          if (foundFieldForSwitchValue) {
          } else {
            debugLog(this.schema);
            throw new Error(this.schema.name + ": At least one of [ " + r + " ] must be specified in " + JSON.stringify(options));
          }
        }
      }
      encode(stream) {
        const switchFieldName = this.schema.fields[0].name;
        const switchValue = this[switchFieldName];
        if (typeof switchValue !== "number") {
          throw new Error("Invalid switchValue  " + switchFieldName + " value = " + switchValue);
        }
        stream.writeUInt32(switchValue);
        for (const field of this.schema.fields) {
          if (field.switchValue === void 0 || field.switchValue !== switchValue) {
            continue;
          }
          switch (field.category) {
            case node_opcua_factory_1.FieldCategory.complex:
              encodeArrayOrElement(field, this, stream);
              break;
            case node_opcua_factory_1.FieldCategory.enumeration:
            case node_opcua_factory_1.FieldCategory.basic:
              encodeArrayOrElement(field, this, stream, field.schema.encode);
              break;
            default:
              throw new Error("Invalid category " + field.category + " " + node_opcua_factory_1.FieldCategory[field.category]);
          }
          break;
        }
      }
      decode(stream) {
        const factory = this.schema.getDataTypeFactory();
        const switchValue = stream.readUInt32();
        const switchFieldName = this.schema.fields[0].name;
        this[switchFieldName] = switchValue;
        for (const field of this.schema.fields) {
          if (field.switchValue === void 0 || field.switchValue !== switchValue) {
            continue;
          }
          switch (field.category) {
            case node_opcua_factory_1.FieldCategory.complex:
              decodeArrayOrElement(factory, field, this, stream);
              break;
            case node_opcua_factory_1.FieldCategory.enumeration:
            case node_opcua_factory_1.FieldCategory.basic:
              decodeArrayOrElement(factory, field, this, stream, field.schema.decode);
              break;
            default:
              throw new Error("Invalid category " + field.category + " " + node_opcua_factory_1.FieldCategory[field.category]);
          }
          break;
        }
      }
      get schema() {
        return _private.get(this).schema;
      }
      toString() {
        return super.toString();
      }
      toJSON() {
        const pojo = {};
        const switchFieldName = this.schema.fields[0].name;
        const switchValue = this[switchFieldName];
        if (typeof switchValue !== "number") {
          throw new Error("Invalid switchValue  " + switchValue);
        }
        pojo[switchFieldName] = switchValue;
        for (const field of this.schema.fields) {
          if (field.switchValue === void 0 || field.switchValue !== switchValue) {
            continue;
          }
          const value = this[field.name];
          if (value === void 0) {
            continue;
          }
          pojo[field.originalName] = fieldToJSON(field, value);
          break;
        }
        return pojo;
      }
    };
    function _createDynamicUnionConstructor(schema, dataTypeFactory) {
      const possibleFields = schema.fields.map((x2) => x2.name);
      class UNION extends UnionBaseClass {
        constructor(options) {
          super(options, schema, dataTypeFactory);
          (0, node_opcua_assert_1.assert)(this.schema === schema);
        }
      }
      UNION.possibleFields = possibleFields;
      UNION.schema = schema;
      Object.defineProperty(UNION, "name", { value: schema.name });
      const schemaPriv = schema;
      (0, node_opcua_assert_1.assert)(!schemaPriv.$Constructor);
      schemaPriv.$Constructor = UNION;
      UNION.encodingDefaultBinary = schema.encodingDefaultBinary;
      return UNION;
    }
    function createDynamicObjectConstructor(schema, dataTypeFactory) {
      const schemaPriv = schema;
      if (schemaPriv.$Constructor) {
        return schemaPriv.$Constructor;
      }
      const dataTypeNodeId = schemaPriv.dataTypeNodeId;
      if (schema.baseType === "Union") {
        const UNIONConstructor = _createDynamicUnionConstructor(schema, dataTypeFactory);
        dataTypeFactory.registerClassDefinition(dataTypeNodeId, schema.name, UNIONConstructor);
        return UNIONConstructor;
      }
      let possibleFields = schema.fields.map((x2) => x2.name);
      let BaseClass = DynamicExtensionObject;
      if (schema.baseType !== "ExtensionObject" && schema.baseType !== "OptionSet" && schema.baseType !== "DataTypeDescription" && schema.baseType !== "DataTypeDefinition" && schema.baseType !== "EnumValueType" && schema.baseType !== "Structure") {
        try {
          const baseSchema = schema.getBaseSchema();
          if (!baseSchema || baseSchema.encodingDefaultBinary?.value === 0) {
          } else {
            if (!baseSchema.isAbstract) {
              BaseClass = getOrCreateConstructor(schema.baseType, dataTypeFactory);
              if (!BaseClass) {
                throw new Error("Cannot find base class : " + schema.baseType);
              }
              if (BaseClass.possibleFields) {
                possibleFields = BaseClass.possibleFields.concat(possibleFields);
              }
            }
          }
        } catch (err) {
          warningLog("createDynamicObjectConstructor err= ", err.message);
        }
      }
      class EXTENSION extends BaseClass {
        static get schema() {
          return schema;
        }
        constructor(options, schema2, factory2) {
          super(options, schema2 ? schema2 : EXTENSION.schema, factory2 ? factory2 : dataTypeFactory);
        }
        toString() {
          return super.toString();
        }
        toJSON() {
          const pojo = {};
          encodeToJson(this, this.schema, pojo);
          return pojo;
        }
        encode(stream) {
          super.encode(stream);
        }
        decode(stream) {
          super.decode(stream);
        }
      }
      EXTENSION.encodingDefaultXml = new node_opcua_nodeid_2.ExpandedNodeId(node_opcua_nodeid_2.NodeIdType.NUMERIC, 0, 0);
      EXTENSION.encodingDefaultBinary = new node_opcua_nodeid_2.ExpandedNodeId(node_opcua_nodeid_2.NodeIdType.NUMERIC, 0, 0);
      EXTENSION.possibleFields = possibleFields;
      Object.defineProperty(EXTENSION, "name", { value: schema.name });
      schemaPriv.$Constructor = EXTENSION;
      EXTENSION.encodingDefaultBinary = schema.encodingDefaultBinary;
      dataTypeFactory.registerClassDefinition(dataTypeNodeId, schema.name, EXTENSION);
      return EXTENSION;
    }
    exports2.createDynamicObjectConstructor = createDynamicObjectConstructor;
    function warningLog(arg0, message) {
      throw new Error("Function not implemented.");
    }
  }
});

// node_modules/node-opcua-schemas/dist/source/tools.js
var require_tools = __commonJS({
  "node_modules/node-opcua-schemas/dist/source/tools.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getOrCreateStructuredTypeSchema = void 0;
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_factory_1 = require_dist26();
    var node_opcua_nodeid_1 = require_dist21();
    var dynamic_extension_object_1 = require_dynamic_extension_object();
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    function _removeNamespacePart(str) {
      if (!str) {
        return str || "";
      }
      const data = str.split(":");
      return data.length > 1 ? data[1] : str;
    }
    function _getNamespacePart(str) {
      return str.split(":")[0];
    }
    function _adjustFieldTypeName(fieldTypeName) {
      if (fieldTypeName === "UAString" || fieldTypeName === "CharArray") {
        fieldTypeName = "String";
      }
      if (fieldTypeName === "UABoolean") {
        fieldTypeName = "Boolean";
      }
      return fieldTypeName;
    }
    function getOrCreateStructuredTypeSchema(name, typeDictionary, dataTypeFactory, idProvider) {
      function _getOrCreateStructuredTypeSchema(_name) {
        if (dataTypeFactory.hasStructureByTypeName(_name)) {
          return dataTypeFactory.getStructuredTypeSchema(_name);
        }
        if (dataTypeFactory.hasEnumeration(_name)) {
          return dataTypeFactory.getEnumeration(_name);
        }
        if (dataTypeFactory.hasBuiltInType(_name)) {
          return dataTypeFactory.getBuiltInType(_name);
        }
        const structuredType = typeDictionary.getStructuredTypesRawByName(_name);
        if (!structuredType) {
          throw new Error("Cannot find structuredType " + _name);
        }
        structuredType.baseType = _removeNamespacePart(structuredType.baseType);
        structuredType.baseType = structuredType.baseType ? structuredType.baseType : "ExtensionObject";
        const baseSchema = typeDictionary.getStructuredTypesRawByName(structuredType.baseType);
        if (baseSchema && baseSchema.fields && baseSchema.name !== "ExtensionObject") {
          structuredType.fields = structuredType.fields.filter((field) => {
            const name2 = field.name;
            const index = baseSchema.fields.findIndex((f2) => f2.name === name2);
            if (index >= 0) {
              errorLog("Warning : find duplicated field from base structure : field name ", name2, "baseSchema = ", baseSchema.name, "schema =", structuredType.name);
            }
            return index < 0;
          });
        }
        applyOnFields();
        const schema = new node_opcua_factory_1.StructuredTypeSchema({
          ...structuredType,
          dataTypeFactory
        });
        const ids = idProvider.getDataTypeAndEncodingId(schema.name);
        if (!ids) {
          const Constructor2 = (0, dynamic_extension_object_1.createDynamicObjectConstructor)(schema, dataTypeFactory);
          return schema;
        }
        schema.dataTypeNodeId = ids.dataTypeNodeId;
        if (schema.dataTypeNodeId.namespace === 0 && schema.dataTypeNodeId.value === 0) {
          return schema;
        }
        schema.encodingDefaultXml = node_opcua_nodeid_1.ExpandedNodeId.fromNodeId(ids.xmlEncodingNodeId);
        schema.encodingDefaultJson = node_opcua_nodeid_1.ExpandedNodeId.fromNodeId(ids.jsonEncodingNodeId);
        schema.encodingDefaultBinary = node_opcua_nodeid_1.ExpandedNodeId.fromNodeId(ids.binaryEncodingNodeId);
        const Constructor = (0, dynamic_extension_object_1.createDynamicObjectConstructor)(schema, dataTypeFactory);
        Constructor.encodingDefaultBinary = schema.encodingDefaultBinary;
        Constructor.encodingDefaultXml = schema.encodingDefaultXml;
        Constructor.encodingDefaultJson = schema.encodingDefaultJson;
        return schema;
        function applyOnFields() {
          for (const field of structuredType.fields) {
            const fieldType = field.fieldType;
            if (!field.schema) {
              const prefix = _getNamespacePart(fieldType);
              const fieldTypeName = _adjustFieldTypeName(_removeNamespacePart(fieldType));
              switch (prefix) {
                case "ua":
                  field.fieldType = fieldTypeName;
                  if ((0, node_opcua_factory_1.hasBuiltInType)(fieldTypeName)) {
                    field.category = node_opcua_factory_1.FieldCategory.basic;
                    field.schema = (0, node_opcua_factory_1.getBuiltInType)(fieldTypeName);
                  } else if (dataTypeFactory.hasStructureByTypeName(fieldTypeName)) {
                    field.category = node_opcua_factory_1.FieldCategory.complex;
                    field.schema = dataTypeFactory.getStructuredTypeSchema(fieldTypeName);
                  } else {
                    field.category = node_opcua_factory_1.FieldCategory.basic;
                    field.schema = _getOrCreateStructuredTypeSchema(fieldTypeName);
                    if (!field.schema) {
                      errorLog("What should I do ??", fieldTypeName, " ", dataTypeFactory.hasStructureByTypeName(fieldTypeName));
                    } else {
                      if ((0, node_opcua_factory_1.hasBuiltInType)(fieldTypeName)) {
                        field.category = node_opcua_factory_1.FieldCategory.basic;
                      } else {
                        field.category = node_opcua_factory_1.FieldCategory.complex;
                      }
                    }
                  }
                  break;
                case "opc":
                  if ((fieldTypeName === "UAString" || fieldTypeName === "String") && field.name === "IndexRange") {
                    field.fieldType = "NumericRange";
                  } else {
                    field.fieldType = fieldTypeName;
                  }
                  if (!(0, node_opcua_factory_1.hasBuiltInType)(fieldTypeName)) {
                    throw new Error("Unknown basic type " + fieldTypeName);
                  }
                  field.category = node_opcua_factory_1.FieldCategory.basic;
                  break;
                default:
                  field.fieldType = fieldTypeName;
                  if (dataTypeFactory.hasEnumeration(fieldTypeName)) {
                    field.category = node_opcua_factory_1.FieldCategory.enumeration;
                    const enumeratedType = dataTypeFactory.getEnumeration(fieldTypeName);
                    field.schema = enumeratedType;
                  } else if (dataTypeFactory.hasStructureByTypeName(fieldTypeName)) {
                    field.category = node_opcua_factory_1.FieldCategory.complex;
                    const schema1 = dataTypeFactory.getStructuredTypeSchema(fieldTypeName);
                    field.schema = schema1;
                  }
                  break;
              }
            }
          }
        }
      }
      return _getOrCreateStructuredTypeSchema(name);
    }
    exports2.getOrCreateStructuredTypeSchema = getOrCreateStructuredTypeSchema;
  }
});

// node_modules/node-opcua-schemas/dist/source/parse_binary_xsd.js
var require_parse_binary_xsd = __commonJS({
  "node_modules/node-opcua-schemas/dist/source/parse_binary_xsd.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.parseBinaryXSDAsync = exports2.parseBinaryXSD = exports2.InternalTypeDictionary = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = __importDefault3(require_dist14());
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_factory_1 = require_dist26();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_xml2json_1 = require_source2();
    var tools_1 = require_tools();
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    function w(s, l2) {
      return s.padEnd(l2).substring(0, l2);
    }
    var InternalTypeDictionary = class {
      constructor() {
        this.targetNamespace = "";
        this.defaultByteOrder = "";
        this.imports = [];
        this.structuredTypesRaw = {};
        this.enumeratedTypesRaw = {};
        this._namespaces = {};
      }
      addEnumeration(name, e) {
        this.enumeratedTypesRaw[name] = e;
      }
      getEnumerations() {
        return Object.values(this.enumeratedTypesRaw);
      }
      getStructures() {
        return Object.values(this.structuredTypesRaw);
      }
      addStructureRaw(structuredType) {
        this.structuredTypesRaw[structuredType.name] = structuredType;
      }
      getStructuredTypesRawByName(name) {
        name = name.split(":")[1] || name;
        return this.structuredTypesRaw[name];
      }
    };
    exports2.InternalTypeDictionary = InternalTypeDictionary;
    var state0 = {
      init: () => {
        const a = 1;
      },
      parser: {
        TypeDictionary: {
          init: function(name, attributes) {
            this.typeDictionary = this.engine.typeDictionary;
            this.typeDictionary.defaultByteOrder = attributes.DefaultByteOrder;
            this.typeDictionary.targetNamespace = attributes.TargetNamespace;
            for (const [k, v] of Object.entries(attributes)) {
              if (k.match(/xmlns:/)) {
                const ns = k.split(":")[1];
                this.typeDictionary._namespaces[ns] = v;
                this.typeDictionary._namespaces[v] = ns;
              }
            }
          },
          parser: {
            Import: {
              init: function(name, attributes) {
                this.parent.typeDictionary.imports.push(attributes.Namespace);
              },
              finish: function() {
                if (doDebug) {
                  debugLog("Import NameSpace = ", this.attrs.Namespace, " Location", this.attrs.Location);
                }
              }
            },
            EnumeratedType: {
              init: function() {
                this.typescriptDefinition = "";
                if (doDebug) {
                  debugLog(chalk_1.default.cyan("EnumeratedType Name="), w(this.attrs.Name, 40), "LengthInBits=", this.attrs.LengthInBits);
                }
                this.enumeratedType = {
                  enumeratedValues: {},
                  lengthInBits: parseInt(this.attrs.LengthInBits, 10),
                  name: this.attrs.Name
                };
                this.typescriptDefinition += `enum ${this.enumeratedType.name} {`;
              },
              parser: {
                Documentation: {
                  finish: function() {
                    this.parent.enumeratedType.documentation = this.text;
                  }
                },
                EnumeratedValue: {
                  finish: function() {
                    if (doDebug) {
                      debugLog(" EnumeratedValue Name=", w(this.attrs.Name, 40), " Value=", this.attrs.Value);
                    }
                    const key = this.attrs.Name;
                    const value = parseInt(this.attrs.Value, 10);
                    const _enum = this.parent.enumeratedType.enumeratedValues;
                    _enum[_enum[key] = value] = key;
                    this.parent.typescriptDefinition += `
  ${key} = ${value},`;
                  }
                }
              },
              finish: function() {
                this.typescriptDefinition += `
}`;
                this.parent.typeDictionary.addEnumeration(this.attrs.Name, this.enumeratedType);
                if (doDebug) {
                  debugLog(" this.typescriptDefinition  = ", this.typescriptDefinition);
                }
              }
            },
            StructuredType: {
              init: function() {
                if (doDebug) {
                  debugLog(chalk_1.default.cyan("StructureType Name="), chalk_1.default.green(this.attrs.Name), " BaseType=", this.attrs.BaseType);
                }
                const baseType = this.attrs.BaseType;
                const structuredType = {
                  name: this.attrs.Name,
                  baseType,
                  fields: []
                };
                this.structuredType = structuredType;
              },
              parser: {
                Field: {
                  finish: function() {
                    if (this.attrs.SourceType) {
                      return;
                    }
                    if (doDebug) {
                      debugLog(
                        chalk_1.default.yellow(" field Name="),
                        w(this.attrs.Name, 40),
                        chalk_1.default.yellow(" typeName="),
                        w(this.attrs.TypeName, 40),
                        this.attrs.LengthField ? chalk_1.default.yellow(" lengthField= ") + w(this.attrs.LengthField, 40) : "",
                        this.attrs.SwitchField ? chalk_1.default.yellow(" SwitchField= ") + w(this.attrs.SwitchField, 40) : "",
                        this.attrs.SwitchValue !== void 0 ? chalk_1.default.yellow(" SwitchValue= ") + w(this.attrs.SwitchValue, 40) : ""
                        // chalk.yellow(" lengthField="), w(this.attrs.LengthField, 40)
                      );
                    }
                    const field = {
                      name: this.attrs.Name,
                      fieldType: this.attrs.TypeName
                    };
                    const structuredType = this.parent.structuredType;
                    if (field.fieldType === "opc:Bit") {
                      structuredType.bitFields = structuredType.bitFields || [];
                      const length = this.attrs.Length || 1;
                      structuredType.bitFields.push({ name: field.name, length });
                      return;
                    }
                    if (this.attrs.LengthField) {
                      field.isArray = true;
                      const n = structuredType.fields.length - 1;
                      structuredType.fields[n] = field;
                    } else {
                      structuredType.fields.push(field);
                    }
                    if (this.attrs.SwitchField) {
                      const switchField = this.attrs.SwitchField;
                      if (this.attrs.SwitchValue) {
                        field.switchValue = parseInt(this.attrs.SwitchValue, 10);
                        if (doDebug) {
                          debugLog("field", field.name, " is part of a union  => ", switchField, " value #", field.switchValue);
                        }
                        if (!this.parent.attrs.baseType) {
                          this.parent.attrs.baseType = "Union";
                          this.parent.structuredType.baseType = "Union";
                        }
                      } else {
                        field.switchBit = structuredType.bitFields ? structuredType.bitFields.findIndex((x2) => x2.name === switchField) : -2;
                        if (doDebug) {
                          debugLog("field", field.name, " is optional => ", switchField, "bit #", field.switchBit);
                        }
                      }
                    }
                  }
                }
              },
              finish: function() {
                (0, node_opcua_assert_1.default)(this.attrs.Name === this.structuredType.name);
                this.parent.typeDictionary.addStructureRaw(this.structuredType);
              }
            }
          }
        }
      }
    };
    function parseBinaryXSD(xmlString, idProvider, dataTypeFactory, callback) {
      const parser = new node_opcua_xml2json_1.Xml2Json(state0);
      const typeDictionary = new InternalTypeDictionary();
      parser.typeDictionary = typeDictionary;
      if (!xmlString || xmlString.length === 0) {
        return callback();
      }
      parser.parseString(xmlString, (err) => {
        for (const enumeratedType of typeDictionary.getEnumerations()) {
          if (Object.keys(enumeratedType.enumeratedValues).length >= 1) {
            const e = new node_opcua_factory_1.EnumerationDefinitionSchema(node_opcua_nodeid_1.NodeId.nullNodeId, {
              lengthInBits: enumeratedType.lengthInBits || 32,
              enumValues: enumeratedType.enumeratedValues,
              name: enumeratedType.name
            });
            dataTypeFactory.registerEnumeration(e);
          }
        }
        if (doDebug) {
          debugLog("------------------------------- Resolving complex Type");
          typeDictionary.getStructures().map((x2) => debugLog(x2.name));
        }
        function createExplorationOrder() {
          const array = [];
          const _map = {};
          function alreadyVisited(name) {
            name = name.split(":")[1] || name;
            return !!_map[name];
          }
          function markAsVisited(name) {
            name = name.split(":")[1] || name;
            _map[name] = "1";
          }
          function visitStructure(structuredType) {
            if (!structuredType || structuredType.name === "ua:ExtensionObject") {
              return;
            }
            if (alreadyVisited(structuredType.name)) {
              return;
            }
            markAsVisited(structuredType.name);
            if (structuredType.baseType && structuredType.baseType !== "ua:ExtensionObject") {
              const base = typeDictionary.getStructuredTypesRawByName(structuredType.baseType);
              if (base && base.baseType) {
                doDebug && debugLog("  investigating  base", chalk_1.default.cyan(base.name));
                visitStructure(base);
              }
            }
            for (const f2 of structuredType.fields) {
              const s = typeDictionary.getStructuredTypesRawByName(f2.fieldType);
              if (s !== structuredType && s) {
                visitStructure(s);
              } else {
                markAsVisited(f2.fieldType);
              }
            }
            doDebug && debugLog("processing ", chalk_1.default.cyan(structuredType.name));
            array.push(structuredType);
          }
          for (const structuredType of typeDictionary.getStructures()) {
            visitStructure(structuredType);
          }
          return array;
        }
        const schemaInVisitingOrder = createExplorationOrder();
        for (const structuredType of schemaInVisitingOrder) {
          (0, tools_1.getOrCreateStructuredTypeSchema)(structuredType.name, typeDictionary, dataTypeFactory, idProvider);
        }
        callback(err);
      });
    }
    exports2.parseBinaryXSD = parseBinaryXSD;
    async function parseBinaryXSDAsync(xmlString, idProvider, dataTypeFactory) {
      debugLog("parseBinaryXSDAsync");
      return new Promise((resolve2, reject) => {
        parseBinaryXSD(xmlString, idProvider, dataTypeFactory, (err) => {
          if (err) {
            reject(err);
          } else {
            resolve2();
          }
        });
      });
    }
    exports2.parseBinaryXSDAsync = parseBinaryXSDAsync;
  }
});

// node_modules/node-opcua-schemas/dist/source/toTypeScript.js
var require_toTypeScript = __commonJS({
  "node_modules/node-opcua-schemas/dist/source/toTypeScript.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.toTypeScript = void 0;
    function toTypeScript(dataTypeFactory) {
      const enumeratedTypes = /* @__PURE__ */ new Map();
      for (const k of dataTypeFactory.enumerations()) {
        enumeratedTypes.set(k, dataTypeFactory.getEnumeration(k));
      }
      const structuredTypes = /* @__PURE__ */ new Map();
      for (const k of dataTypeFactory.structuredTypesNames()) {
        structuredTypes.set(k, dataTypeFactory.getStructureInfoByTypeName(k));
      }
      const declaration = /* @__PURE__ */ new Map();
      function adjustType(t) {
        if (t === "String") {
          t = "UAString";
        } else if (t === "Boolean") {
          t = "UABoolean";
        }
        if (!enumeratedTypes.has(t) && !structuredTypes.has(t)) {
          declaration.set(t, t);
        }
        return t;
      }
      const l2 = [];
      for (const e of enumeratedTypes.values()) {
        l2.push(`export enum ${e.name} {`);
        for (const v of Object.entries(e.enumValues)) {
          const vv = parseInt(v[0], 10);
          if (vv >= 0) {
            continue;
          }
          l2.push(`    ${v[0]} = ${v[1]},`);
        }
        l2.push(`}`);
      }
      const alreadyDone = /* @__PURE__ */ new Set();
      function dumpType(o2) {
        const bt = o2.getBaseSchema();
        if (bt && !alreadyDone.has(o2.baseType) && bt) {
          dumpType(bt);
        }
        alreadyDone.add(o2.name);
        const ex1 = bt ? `extends ${bt.name} ` : "";
        if (o2.baseType === "Union") {
          const p3 = [];
          let switchFieldName = "";
          for (const field of o2.fields) {
            if (field.switchValue === void 0) {
              switchFieldName = field.name;
              break;
            }
          }
          for (const field of o2.fields) {
            const name = field.name;
            if (field.switchValue === void 0) {
              continue;
            }
            const a = field.isArray ? "[]" : "";
            const fieldType = adjustType(field.schema.name);
            l2.push(`interface ${o2.name}${field.switchValue} ${ex1}{`);
            l2.push(`    ${switchFieldName}: ${field.switchValue};`);
            l2.push(`    ${field.name}: ${fieldType}${a};`);
            l2.push(`}`);
            p3.push(`${o2.name}${field.switchValue}`);
          }
          const pp = p3.join(" | ");
          l2.push(`type ${o2.name} = ${pp};`);
        } else {
          if (o2.fields.length === 0) {
            l2.push("// tslint:disable-next-line: no-empty-interface");
          }
          l2.push(`interface ${o2.name} ${ex1}{`);
          for (const f2 of o2.fields) {
            if (f2.documentation) {
              l2.push(`    // ${f2.documentation}`);
            }
            const isOpt = f2.switchBit !== void 0 ? "?" : "";
            const fieldType = adjustType(f2.schema.name);
            if (f2.isArray) {
              l2.push(`    ${f2.name}${isOpt}: ${fieldType}[];`);
            } else {
              l2.push(`    ${f2.name}${isOpt}: ${fieldType};`);
            }
          }
          l2.push(`}`);
        }
      }
      for (const o2 of structuredTypes.values()) {
        if (alreadyDone.has(o2.schema.name)) {
          continue;
        }
        dumpType(o2.schema);
      }
      const opcuaTypes = [...declaration.keys()].sort().join(",\n    ");
      l2.unshift(`import {
    ${opcuaTypes}
} from "node-opcua";`);
      return l2.join("\n");
    }
    exports2.toTypeScript = toTypeScript;
  }
});

// node_modules/node-opcua-schemas/dist/source/index.js
var require_source3 = __commonJS({
  "node_modules/node-opcua-schemas/dist/source/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_parse_binary_xsd(), exports2);
    __exportStar3(require_dynamic_extension_object(), exports2);
    __exportStar3(require_toTypeScript(), exports2);
    __exportStar3(require_tools(), exports2);
  }
});

// node_modules/node-opcua-client-dynamic-extension-object/dist/private/find_encodings.js
var require_find_encodings = __commonJS({
  "node_modules/node-opcua-client-dynamic-extension-object/dist/private/find_encodings.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2._findEncodings = void 0;
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_pseudo_session_1 = require_dist55();
    async function _findEncodings(session, dataTypeNodeId) {
      const nodeToBrowse = {
        browseDirection: node_opcua_data_model_1.BrowseDirection.Forward,
        includeSubtypes: true,
        // strictly speaking HasEncoding points to an Object of DataTypeEncodingType, but
        // in some buggy server implementations  ObjectType is used instead. (see #1232)
        nodeClassMask: (0, node_opcua_data_model_1.makeNodeClassMask)("Object | ObjectType"),
        nodeId: dataTypeNodeId,
        referenceTypeId: (0, node_opcua_nodeid_1.resolveNodeId)("HasEncoding"),
        resultMask: (0, node_opcua_data_model_1.makeResultMask)("ReferenceType | IsForward | BrowseName | NodeClass | TypeDefinition")
      };
      const result2 = await (0, node_opcua_pseudo_session_1.browseAll)(session, nodeToBrowse);
      const references = result2.references || [];
      if (references.length === 0) {
      }
      const encodings = {
        dataTypeNodeId,
        binaryEncodingNodeId: new node_opcua_nodeid_1.NodeId(),
        jsonEncodingNodeId: new node_opcua_nodeid_1.NodeId(),
        xmlEncodingNodeId: new node_opcua_nodeid_1.NodeId()
      };
      for (const ref of references) {
        switch (ref.browseName.name) {
          case "Default Binary":
            encodings.binaryEncodingNodeId = ref.nodeId;
            break;
          case "Default XML":
            encodings.xmlEncodingNodeId = ref.nodeId;
            break;
          case "Default JSON":
            encodings.jsonEncodingNodeId = ref.nodeId;
            break;
          default:
            break;
        }
      }
      return encodings;
    }
    exports2._findEncodings = _findEncodings;
  }
});

// node_modules/node-opcua-client-dynamic-extension-object/dist/convert_data_type_definition_to_structuretype_schema.js
var require_convert_data_type_definition_to_structuretype_schema = __commonJS({
  "node_modules/node-opcua-client-dynamic-extension-object/dist/convert_data_type_definition_to_structuretype_schema.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.convertDataTypeDefinitionToStructureTypeSchema = void 0;
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_factory_1 = require_dist26();
    var node_opcua_nodeid_2 = require_dist21();
    var node_opcua_pseudo_session_1 = require_dist55();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_extension_object_1 = require_dist30();
    var node_opcua_variant_1 = require_dist28();
    var find_encodings_1 = require_find_encodings();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    async function findSuperType(session, dataTypeNodeId) {
      if (dataTypeNodeId.namespace === 0 && dataTypeNodeId.value === 24) {
        return (0, node_opcua_nodeid_2.coerceNodeId)(0);
      }
      const nodeToBrowse3 = {
        browseDirection: node_opcua_data_model_1.BrowseDirection.Inverse,
        includeSubtypes: false,
        nodeClassMask: node_opcua_data_model_1.NodeClassMask.DataType,
        nodeId: dataTypeNodeId,
        referenceTypeId: (0, node_opcua_nodeid_2.resolveNodeId)("HasSubtype"),
        resultMask: (0, node_opcua_data_model_1.makeResultMask)("NodeId | ReferenceType | BrowseName | NodeClass")
      };
      const result3 = await (0, node_opcua_pseudo_session_1.browseAll)(session, nodeToBrowse3);
      if (result3.statusCode.isNotGood()) {
        throw new Error("Cannot find superType for " + dataTypeNodeId.toString());
      }
      result3.references = result3.references || [];
      if (result3.references.length !== 1) {
        errorLog("Invalid dataType with more than one (or 0) superType", result3.toString());
        throw new Error("Invalid dataType with more than one (or 0) superType " + dataTypeNodeId.toString() + " l=" + result3.references.length);
      }
      return result3.references[0].nodeId;
    }
    async function findDataTypeCategory(session, cache, dataTypeNodeId) {
      const subTypeNodeId = await findSuperType(session, dataTypeNodeId);
      debugLog("subTypeNodeId  of ", dataTypeNodeId.toString(), " is ", subTypeNodeId.toString());
      const key = subTypeNodeId.toString();
      if (cache[key]) {
        return cache[key].category;
      }
      let category;
      const n = subTypeNodeId;
      if (n.identifierType === node_opcua_nodeid_1.NodeIdType.NUMERIC && n.namespace === 0 && n.value <= 29) {
        switch (n.value) {
          case 22:
            category = node_opcua_factory_1.FieldCategory.complex;
            break;
          case 29:
            category = node_opcua_factory_1.FieldCategory.enumeration;
            break;
          default:
            category = node_opcua_factory_1.FieldCategory.basic;
            break;
        }
        return category;
      }
      return await findDataTypeCategory(session, cache, subTypeNodeId);
    }
    async function findDataTypeBasicType(session, cache, dataTypeNodeId) {
      const subTypeNodeId = await findSuperType(session, dataTypeNodeId);
      debugLog("subTypeNodeId  of ", dataTypeNodeId.toString(), " is ", subTypeNodeId.toString());
      const key = subTypeNodeId.toString();
      if (cache[key]) {
        return cache[key].schema;
      }
      const n = subTypeNodeId;
      if (n.identifierType === node_opcua_nodeid_1.NodeIdType.NUMERIC && n.namespace === 0 && n.value < 29) {
        switch (n.value) {
          case 22:
          case 29:
            throw new Error("Not expecting Structure or Enumeration");
          default:
            break;
        }
        const nameDataValue = await session.read({
          attributeId: node_opcua_data_model_1.AttributeIds.BrowseName,
          nodeId: subTypeNodeId
        });
        const name = nameDataValue.value.value.name;
        return (0, node_opcua_factory_1.getBuiltInType)(name);
      }
      return await findDataTypeBasicType(session, cache, subTypeNodeId);
    }
    async function readBrowseName(session, nodeId) {
      const dataValue = await session.read({ nodeId, attributeId: node_opcua_data_model_1.AttributeIds.BrowseName });
      if (dataValue.statusCode.isNotGood()) {
        const message = "cannot extract BrowseName of nodeId = " + nodeId.toString() + " statusCode = " + dataValue.statusCode.toString();
        debugLog(message);
        throw new Error(message);
      }
      return dataValue.value.value.name;
    }
    async function resolve2(session, dataTypeNodeId, dataTypeFactory, fieldTypeName, cache) {
      const category = await findDataTypeCategory(session, cache, dataTypeNodeId);
      debugLog(" type " + fieldTypeName + " has not been seen yet, let resolve it => (category = ", category, " )");
      let schema = void 0;
      switch (category) {
        case node_opcua_factory_1.FieldCategory.basic:
          schema = await findDataTypeBasicType(session, cache, dataTypeNodeId);
          if (!schema) {
            errorLog("Cannot find basic type " + fieldTypeName);
          }
          break;
        default:
        case node_opcua_factory_1.FieldCategory.complex:
          {
            const dataTypeDefinitionDataValue = await session.read({
              attributeId: node_opcua_data_model_1.AttributeIds.DataTypeDefinition,
              nodeId: dataTypeNodeId
            });
            if (dataTypeDefinitionDataValue.statusCode.isNotGood()) {
              throw new Error(" Cannot find dataType Definition ! with nodeId =" + dataTypeNodeId.toString());
            }
            const definition = dataTypeDefinitionDataValue.value.value;
            const convertIn64ToInteger = (a) => a[1];
            const convert = (fields) => {
              const retVal = {};
              fields && fields.forEach((field) => retVal[field.name || ""] = convertIn64ToInteger(field.value));
              return retVal;
            };
            if (category === node_opcua_factory_1.FieldCategory.enumeration) {
              if (definition instanceof node_opcua_types_1.EnumDefinition) {
                const e = new node_opcua_factory_1.EnumerationDefinitionSchema(dataTypeNodeId, {
                  enumValues: convert(definition.fields),
                  name: fieldTypeName
                });
                dataTypeFactory.registerEnumeration(e);
                schema = e;
              }
            } else {
              const isAbstract = false;
              schema = await convertDataTypeDefinitionToStructureTypeSchema(session, dataTypeNodeId, fieldTypeName, definition, null, dataTypeFactory, isAbstract, cache);
            }
          }
          break;
      }
      return { schema, category };
    }
    var isExtensionObject = async (session, dataTypeNodeId) => {
      if (dataTypeNodeId.namespace === 0 && dataTypeNodeId.value === node_opcua_variant_1.DataType.ExtensionObject) {
        return true;
      }
      const baseDataType = await findSuperType(session, dataTypeNodeId);
      const bn = baseDataType;
      if (bn.identifierType === node_opcua_nodeid_1.NodeIdType.NUMERIC) {
        if (bn.namespace === 0 && bn.value === node_opcua_variant_1.DataType.ExtensionObject) {
          return true;
        }
        if (bn.namespace === 0 && bn.value < node_opcua_variant_1.DataType.ExtensionObject) {
          return false;
        }
      }
      return await isExtensionObject(session, baseDataType);
    };
    async function resolveFieldType(session, dataTypeNodeId, dataTypeFactory, cache) {
      if (dataTypeNodeId.namespace === 0 && dataTypeNodeId.value === 22) {
        const category2 = node_opcua_factory_1.FieldCategory.complex;
        const fieldTypeName2 = "Structure";
        const schema2 = node_opcua_extension_object_1.ExtensionObject.schema;
        return {
          category: category2,
          fieldTypeName: fieldTypeName2,
          schema: schema2,
          allowSubType: true,
          dataType: (0, node_opcua_nodeid_2.coerceNodeId)(node_opcua_variant_1.DataType.ExtensionObject)
        };
      }
      const key = dataTypeNodeId.toString();
      const v = cache[key];
      if (v) {
        return v;
      }
      if (dataTypeNodeId.value === 0) {
        const v3 = {
          category: node_opcua_factory_1.FieldCategory.basic,
          fieldTypeName: "Variant",
          schema: dataTypeFactory.getBuiltInType("Variant")
        };
        cache[key] = v3;
        return v3;
      }
      const isAbstract = (await session.read({ nodeId: dataTypeNodeId, attributeId: node_opcua_data_model_1.AttributeIds.IsAbstract })).value.value;
      const fieldTypeName = await readBrowseName(session, dataTypeNodeId);
      if (isAbstract) {
        const _isExtensionObject = await isExtensionObject(session, dataTypeNodeId);
        debugLog(" dataType " + dataTypeNodeId.toString() + " " + fieldTypeName + " is abstract => extObj ?= " + _isExtensionObject);
        if (_isExtensionObject) {
          const v3 = {
            category: node_opcua_factory_1.FieldCategory.complex,
            fieldTypeName,
            schema: node_opcua_extension_object_1.ExtensionObject.schema,
            allowSubType: true,
            dataType: dataTypeNodeId
          };
          cache[key] = v3;
          return v3;
        } else {
          const v3 = {
            category: node_opcua_factory_1.FieldCategory.basic,
            fieldTypeName,
            schema: dataTypeFactory.getBuiltInType("Variant"),
            allowSubType: true,
            dataType: dataTypeNodeId
          };
          cache[key] = v3;
          return v3;
        }
      }
      let schema;
      let category = node_opcua_factory_1.FieldCategory.enumeration;
      if (dataTypeFactory.hasStructureByTypeName(fieldTypeName)) {
        schema = dataTypeFactory.getStructuredTypeSchema(fieldTypeName);
        category = node_opcua_factory_1.FieldCategory.complex;
      } else if (dataTypeFactory.hasBuiltInType(fieldTypeName)) {
        category = node_opcua_factory_1.FieldCategory.basic;
        schema = dataTypeFactory.getBuiltInType(fieldTypeName);
      } else if (dataTypeFactory.hasEnumeration(fieldTypeName)) {
        category = node_opcua_factory_1.FieldCategory.enumeration;
        schema = dataTypeFactory.getEnumeration(fieldTypeName);
      } else {
        debugLog(" type " + fieldTypeName + " has not been seen yet, let resolve it");
        const res = await resolve2(session, dataTypeNodeId, dataTypeFactory, fieldTypeName, cache);
        schema = res.schema;
        category = res.category;
      }
      if (!schema) {
        throw new Error("expecting a schema here fieldTypeName=" + fieldTypeName + " " + dataTypeNodeId.toString() + " category = " + category);
      }
      const v2 = {
        category,
        fieldTypeName,
        schema
      };
      cache[key] = v2;
      return v2;
    }
    async function _setupEncodings(session, dataTypeNodeId, dataTypeDescription, schema) {
      const isAbstractDV = await session.read({ nodeId: dataTypeNodeId, attributeId: node_opcua_data_model_1.AttributeIds.IsAbstract });
      schema.dataTypeNodeId = dataTypeNodeId;
      if (isAbstractDV.statusCode.isGood() && isAbstractDV.value.value === false) {
        const encodings = dataTypeDescription && dataTypeDescription.encodings || await (0, find_encodings_1._findEncodings)(session, dataTypeNodeId);
        schema.encodingDefaultBinary = (0, node_opcua_nodeid_2.makeExpandedNodeId)(encodings.binaryEncodingNodeId);
        schema.encodingDefaultXml = (0, node_opcua_nodeid_2.makeExpandedNodeId)(encodings.xmlEncodingNodeId);
        schema.encodingDefaultJson = (0, node_opcua_nodeid_2.makeExpandedNodeId)(encodings.jsonEncodingNodeId);
      } else {
        schema.isAbstract = true;
      }
      return schema;
    }
    async function convertDataTypeDefinitionToStructureTypeSchema(session, dataTypeNodeId, name, definition, dataTypeDescription, dataTypeFactory, isAbstract, cache) {
      if (definition instanceof node_opcua_types_1.StructureDefinition) {
        let fieldCountToIgnore = 0;
        const structureInfo = dataTypeFactory.getStructureInfoForDataType(definition.baseDataType);
        const baseSchema = structureInfo?.schema;
        if (baseSchema) {
          const possibleFields = (0, node_opcua_factory_1.extractAllPossibleFields)(baseSchema);
          fieldCountToIgnore += possibleFields.length;
        }
        const fields = [];
        const isUnion = definition.structureType === node_opcua_types_1.StructureType.Union;
        switch (definition.structureType) {
          case node_opcua_types_1.StructureType.Union:
            fields.push({
              fieldType: "UInt32",
              name: "SwitchField"
            });
            break;
          case node_opcua_types_1.StructureType.Structure:
          case node_opcua_types_1.StructureType.StructureWithOptionalFields:
            break;
        }
        let switchValue = 1;
        let switchBit = 0;
        const bitFields = isUnion ? void 0 : [];
        const postActions = [];
        if (definition.fields) {
          for (let i = fieldCountToIgnore; i < definition.fields.length; i++) {
            const fieldD = definition.fields[i];
            let field;
            ({ field, switchBit, switchValue } = createField(fieldD, switchBit, bitFields, isUnion, switchValue));
            if (fieldD.dataType.value === dataTypeNodeId.value && fieldD.dataType.namespace === dataTypeNodeId.namespace) {
              const fieldTypeName2 = await readBrowseName(session, dataTypeNodeId);
              field.fieldType = fieldTypeName2, field.category = node_opcua_factory_1.FieldCategory.complex;
              fields.push(field);
              const capturedField = field;
              postActions.push((schema2) => {
                capturedField.schema = schema2;
              });
              continue;
            }
            const rt = await resolveFieldType(session, fieldD.dataType, dataTypeFactory, cache);
            if (!rt) {
              errorLog("convertDataTypeDefinitionToStructureTypeSchema cannot handle field", fieldD.name, "in", name, "because " + fieldD.dataType.toString() + " cannot be resolved");
              continue;
            }
            const { schema, category, fieldTypeName, dataType, allowSubType } = rt;
            field.fieldType = fieldTypeName;
            field.category = category;
            field.schema = schema;
            field.dataType = dataType || fieldD.dataType;
            field.allowSubType = allowSubType || false;
            field.basicDataType = await (0, node_opcua_pseudo_session_1.findBasicDataType)(session, field.dataType);
            fields.push(field);
          }
        }
        if (isUnion && (0, node_opcua_nodeid_1.sameNodeId)(definition.baseDataType, (0, node_opcua_nodeid_2.coerceNodeId)("i=22"))) {
          definition.baseDataType = (0, node_opcua_nodeid_2.resolveNodeId)("i=1276");
        }
        const a = await resolveFieldType(session, definition.baseDataType, dataTypeFactory, cache);
        const baseType = a ? a.fieldTypeName : isUnion ? "Union" : "ExtensionObject";
        const os2 = new node_opcua_factory_1.StructuredTypeSchema({
          baseType,
          bitFields,
          fields,
          name,
          dataTypeFactory
        });
        const structuredTypeSchema = await _setupEncodings(session, dataTypeNodeId, dataTypeDescription, os2);
        postActions.forEach((action) => action(structuredTypeSchema));
        return structuredTypeSchema;
      }
      throw new Error("Not Implemented");
      function createField(fieldD, switchBit, bitFields, isUnion, switchValue) {
        const field = {
          fieldType: "",
          name: fieldD.name,
          schema: void 0
        };
        if (fieldD.isOptional) {
          field.switchBit = switchBit++;
          bitFields?.push({ name: fieldD.name + "Specified", length: 1 });
        }
        if (isUnion) {
          field.switchValue = switchValue;
          switchValue += 1;
        }
        if (fieldD.valueRank >= 1) {
          field.valueRank = fieldD.valueRank;
          field.isArray = true;
        } else {
          field.isArray = false;
        }
        return { field, switchBit, switchValue };
      }
    }
    exports2.convertDataTypeDefinitionToStructureTypeSchema = convertDataTypeDefinitionToStructureTypeSchema;
  }
});

// node_modules/node-opcua-client-dynamic-extension-object/dist/private/populate_data_type_manager_103.js
var require_populate_data_type_manager_103 = __commonJS({
  "node_modules/node-opcua-client-dynamic-extension-object/dist/private/populate_data_type_manager_103.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.populateDataTypeManager103 = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_factory_1 = require_dist26();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_pseudo_session_1 = require_dist55();
    var node_opcua_schemas_1 = require_source3();
    var node_opcua_service_browse_1 = require_dist37();
    var node_opcua_service_translate_browse_path_1 = require_dist49();
    var node_opcua_types_1 = require_dist32();
    var convert_data_type_definition_to_structuretype_schema_1 = require_convert_data_type_definition_to_structuretype_schema();
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    async function _readDeprecatedFlag(session, dataTypeDictionary) {
      const browsePath = (0, node_opcua_service_translate_browse_path_1.makeBrowsePath)(dataTypeDictionary, ".Deprecated");
      const a = await session.translateBrowsePath(browsePath);
      if (!a.targets || a.targets.length === 0) {
        debugLog("Cannot find Deprecated property for dataTypeDictionary " + dataTypeDictionary.toString());
        return false;
      }
      const deprecatedFlagNodeId = a.targets[0].targetId;
      const dataValue = await session.read({ nodeId: deprecatedFlagNodeId, attributeId: node_opcua_data_model_1.AttributeIds.Value });
      return dataValue.value.value;
    }
    async function _readNamespaceUriProperty(session, dataTypeDictionary) {
      const a = await session.translateBrowsePath((0, node_opcua_service_translate_browse_path_1.makeBrowsePath)(dataTypeDictionary, ".NamespaceUri"));
      if (!a.targets || a.targets.length === 0) {
        return "??dataTypeDictionary doesn't expose NamespaceUri property??";
      }
      const namespaceUriProp = a.targets[0].targetId;
      const dataValue = await session.read({ nodeId: namespaceUriProp, attributeId: node_opcua_data_model_1.AttributeIds.Value });
      return dataValue.value.value || "<not set>";
    }
    async function _getDataTypeDescriptions(session, dataTypeDictionaryNodeId) {
      const nodeToBrowse2 = {
        browseDirection: node_opcua_service_browse_1.BrowseDirection.Forward,
        includeSubtypes: false,
        nodeClassMask: (0, node_opcua_data_model_1.makeNodeClassMask)("Variable"),
        nodeId: dataTypeDictionaryNodeId,
        referenceTypeId: (0, node_opcua_nodeid_1.resolveNodeId)("HasComponent"),
        // resultMask: makeResultMask("NodeId | ReferenceType | BrowseName | NodeClass | TypeDefinition")
        resultMask: (0, node_opcua_data_model_1.makeResultMask)("NodeId | BrowseName")
      };
      const result2 = await (0, node_opcua_pseudo_session_1.browseAll)(session, nodeToBrowse2);
      result2.references = result2.references || [];
      return result2.references.map((r) => ({ nodeId: r.nodeId, browseName: r.browseName }));
    }
    async function _enrichWithDescriptionOf(session, dataTypeDescriptions) {
      const nodesToBrowse3 = [];
      for (const dataTypeDescription of dataTypeDescriptions) {
        nodesToBrowse3.push({
          browseDirection: node_opcua_service_browse_1.BrowseDirection.Inverse,
          includeSubtypes: false,
          nodeClassMask: (0, node_opcua_data_model_1.makeNodeClassMask)("Object"),
          nodeId: dataTypeDescription.nodeId.toString(),
          referenceTypeId: (0, node_opcua_nodeid_1.resolveNodeId)("HasDescription"),
          //            resultMask: makeResultMask("NodeId | ReferenceType | BrowseName | NodeClass | TypeDefinition")
          resultMask: (0, node_opcua_data_model_1.makeResultMask)("NodeId")
        });
      }
      if (nodesToBrowse3.length === 0) {
        return [];
      }
      const results3 = await (0, node_opcua_pseudo_session_1.browseAll)(session, nodesToBrowse3);
      const binaryEncodings = [];
      const nodesToBrowseDataType = [];
      for (let i = 0; i < results3.length; i++) {
        const result3 = results3[i];
        const dataTypeDescription = dataTypeDescriptions[i];
        result3.references = result3.references || [];
        if (result3.references.length === 0) {
          continue;
        }
        if (result3.references.length !== 1) {
          warningLog("_enrichWithDescriptionOf : expecting 1 reference for ", dataTypeDescription.browseName.toString());
          warningLog(result3.toString());
          continue;
        }
        for (const ref of result3.references) {
          const binaryEncodingNodeId = ref.nodeId;
          dataTypeDescription.encodings = dataTypeDescription.encodings || {
            binaryEncodingNodeId: node_opcua_nodeid_1.NodeId.nullNodeId,
            dataTypeNodeId: node_opcua_nodeid_1.NodeId.nullNodeId,
            jsonEncodingNodeId: node_opcua_nodeid_1.NodeId.nullNodeId,
            xmlEncodingNodeId: node_opcua_nodeid_1.NodeId.nullNodeId
          };
          dataTypeDescription.encodings.binaryEncodingNodeId = binaryEncodingNodeId;
          binaryEncodings.push(binaryEncodingNodeId);
          nodesToBrowseDataType.push({
            browseDirection: node_opcua_service_browse_1.BrowseDirection.Inverse,
            includeSubtypes: false,
            nodeClassMask: node_opcua_data_model_1.NodeClassMask.DataType,
            nodeId: ref.nodeId,
            referenceTypeId: (0, node_opcua_nodeid_1.resolveNodeId)("HasEncoding"),
            //            resultMask: makeResultMask("NodeId | ReferenceType | BrowseName | NodeClass | TypeDefinition")
            resultMask: (0, node_opcua_data_model_1.makeResultMask)("NodeId | BrowseName")
          });
        }
      }
      const dataTypeNodeIds = [];
      if (nodesToBrowseDataType.length > 0) {
        const results4 = await (0, node_opcua_pseudo_session_1.browseAll)(session, nodesToBrowseDataType);
        for (let i = 0; i < results4.length; i++) {
          const result4 = results4[i];
          result4.references = result4.references || [];
          if (result4.references.length !== 1) {
            errorLog("What's going on ?", result4.toString(), "result4.references.length = ", result4.references.length);
          }
          const ref = result4.references[0];
          const dataTypeNodeId = ref.nodeId;
          dataTypeNodeIds[i] = dataTypeNodeId;
          const dataTypeDescription = dataTypeDescriptions[i];
          dataTypeDescription.encodings.dataTypeNodeId = dataTypeNodeId;
        }
      }
      const otherEncodingBrowse = dataTypeNodeIds.map((dataTypeNodeId) => ({
        browseDirection: node_opcua_service_browse_1.BrowseDirection.Forward,
        includeSubtypes: false,
        nodeClassMask: node_opcua_data_model_1.NodeClassMask.Object,
        nodeId: dataTypeNodeId,
        referenceTypeId: (0, node_opcua_nodeid_1.resolveNodeId)("HasEncoding"),
        //            resultMask: makeResultMask("NodeId | ReferenceType | BrowseName | NodeClass | TypeDefinition")
        resultMask: (0, node_opcua_data_model_1.makeResultMask)("NodeId | BrowseName")
      }));
      const results5 = await (0, node_opcua_pseudo_session_1.browseAll)(session, otherEncodingBrowse);
      for (let i = 0; i < results5.length; i++) {
        const result5 = results5[i];
        const dataTypeDescription = dataTypeDescriptions[i];
        let encodingCounter = 0;
        for (const ref of result5.references || []) {
          switch (ref.browseName.name) {
            case "Default XML":
              dataTypeDescription.encodings.xmlEncodingNodeId = ref.nodeId;
              encodingCounter++;
              break;
            case "Default Binary":
              dataTypeDescription.encodings.binaryEncodingNodeId = ref.nodeId;
              encodingCounter++;
              break;
            case "Default JSON":
              dataTypeDescription.encodings.jsonEncodingNodeId = ref.nodeId;
              encodingCounter++;
              break;
            default:
              errorLog("Cannot handle unknown encoding", ref.browseName.name);
          }
        }
        if (encodingCounter === 0) {
          dataTypeDescription.isAbstract = true;
        }
      }
      return dataTypeNodeIds;
    }
    function sortStructure(dataTypeDefinitions) {
      const dataTypeDefinitionsSorted = [];
      const _visited = {};
      const _map = {};
      for (const d2 of dataTypeDefinitions) {
        _map[d2.dataTypeNodeId.toString()] = d2;
      }
      function _visit(d2) {
        const hash = d2.dataTypeNodeId.toString();
        if (_visited[hash]) {
          return;
        }
        _visited[hash] = d2;
        const bbb = _map[d2.dataTypeDefinition.baseDataType.toString()];
        if (bbb) {
          _visit(bbb);
        }
        for (const f2 of d2.dataTypeDefinition.fields || []) {
          const ddd = _map[f2.dataType.toString()];
          if (!ddd) {
            continue;
          }
          _visit(ddd);
        }
        dataTypeDefinitionsSorted.push(d2);
      }
      for (const d2 of dataTypeDefinitions) {
        _visit(d2);
      }
      return dataTypeDefinitionsSorted;
    }
    var readIsAbstract = async (session, nodeId) => {
      const dataValue = await session.read({ nodeId, attributeId: node_opcua_data_model_1.AttributeIds.IsAbstract });
      return dataValue.value.value;
    };
    async function _extractDataTypeDictionaryFromDefinition(session, dataTypeDictionaryNodeId, dataTypeFactory) {
      (0, node_opcua_assert_1.assert)(dataTypeFactory, "expecting a dataTypeFactory");
      const dataTypeDescriptions = await _getDataTypeDescriptions(session, dataTypeDictionaryNodeId);
      const dataTypeNodeIds = await _enrichWithDescriptionOf(session, dataTypeDescriptions);
      const nodesToRead = dataTypeNodeIds.map((nodeId) => ({
        attributeId: node_opcua_data_model_1.AttributeIds.DataTypeDefinition,
        nodeId
      }));
      const cache = {};
      const dataValuesWithDataTypeDefinition = nodesToRead.length > 0 ? await session.read(nodesToRead) : [];
      const dataTypeDefinitions = [];
      let index = 0;
      for (const dataValue of dataValuesWithDataTypeDefinition) {
        const dataTypeNodeId = dataTypeNodeIds[index];
        const dataTypeDescription = dataTypeDescriptions[index];
        if (dataValue.statusCode.isGood()) {
          const dataTypeDefinition = dataValue.value.value;
          if (dataTypeDefinition && dataTypeDefinition instanceof node_opcua_types_1.StructureDefinition) {
            const className = dataTypeDescription.browseName.name;
            const isAbstract = await readIsAbstract(session, dataTypeNodeId);
            dataTypeDefinitions.push({ className, dataTypeNodeId, dataTypeDefinition, isAbstract });
          }
        } else {
          debugLog("dataTypeNodeId ", dataTypeNodeId.toString(), " has no DataTypeDescription attribute", dataValue.statusCode.toString());
        }
        index++;
      }
      const dataTypeDefinitionsSorted = sortStructure(dataTypeDefinitions);
      if (doDebug) {
        debugLog("order ", dataTypeDefinitionsSorted.map((a) => a.className + " " + a.dataTypeNodeId).join(" ->  "));
      }
      for (const { className, dataTypeNodeId, dataTypeDefinition, isAbstract } of dataTypeDefinitionsSorted) {
        if (doDebug) {
          debugLog(chalk_1.default.yellow("--------------------------------------- "), className, dataTypeNodeId.toString());
        }
        if (dataTypeFactory.hasStructureByTypeName(className)) {
          continue;
        }
        try {
          const dataTypeDescription = dataTypeDescriptions.find((a) => a.nodeId.toString() === dataTypeNodeId.toString());
          if (!dataTypeDefinition) {
            throw new Error("cannot find dataTypeDefinition for " + dataTypeNodeId.toString());
          }
          const schema = await (0, convert_data_type_definition_to_structuretype_schema_1.convertDataTypeDefinitionToStructureTypeSchema)(
            session,
            dataTypeNodeId,
            className,
            dataTypeDefinition,
            dataTypeDescription,
            // for encodings
            dataTypeFactory,
            isAbstract,
            cache
          );
          if (doDebug) {
            debugLog(chalk_1.default.red("Registering "), chalk_1.default.cyan(className.padEnd(30, " ")), schema.dataTypeNodeId.toString());
          }
          if (!isAbstract) {
            const Constructor = (0, node_opcua_schemas_1.createDynamicObjectConstructor)(schema, dataTypeFactory);
            (0, node_opcua_assert_1.assert)(Constructor.schema === schema);
          } else {
            if (doDebug) {
              debugLog("Ignoring Abstract ", className);
            }
          }
        } catch (err) {
          errorLog("Constructor verification err: ", err.message);
          errorLog("For this reason class " + className + " has not been registered");
          errorLog(err);
        }
      }
    }
    async function _extractNodeIds(session, dataTypeDictionaryNodeId) {
      const map = {};
      const dataTypeDescriptions = await _getDataTypeDescriptions(session, dataTypeDictionaryNodeId);
      await _enrichWithDescriptionOf(session, dataTypeDescriptions);
      for (const dataTypeDescription of dataTypeDescriptions) {
        map[dataTypeDescription.browseName.name.toString()] = dataTypeDescription.encodings;
      }
      return {
        getDataTypeAndEncodingId(key) {
          return map[key] || null;
        }
      };
    }
    function _isOldDataTypeDictionary(d2) {
      const isDictionaryDeprecated = d2.isDictionaryDeprecated;
      const rawSchema = d2.rawSchema;
      return !isDictionaryDeprecated && rawSchema.length >= 0;
    }
    async function _extractDataTypeDictionary(session, d2, dataTypeManager) {
      const dataTypeDictionaryNodeId = d2.reference.nodeId;
      const name = await session.read({ nodeId: dataTypeDictionaryNodeId, attributeId: node_opcua_data_model_1.AttributeIds.BrowseName });
      const namespace = await _readNamespaceUriProperty(session, dataTypeDictionaryNodeId);
      if (!_isOldDataTypeDictionary(d2)) {
        debugLog("DataTypeDictionary is deprecated or BSD schema stored in dataValue is null !", chalk_1.default.cyan(name.value.value.toString()), "namespace =", namespace);
        debugLog("let's use the new way (1.04) and let's crawl all dataTypes exposed by this name space");
        const dataTypeFactory2 = dataTypeManager.getDataTypeFactory(dataTypeDictionaryNodeId.namespace);
        if (!dataTypeFactory2) {
          throw new Error("cannot find dataTypeFactory for namespace " + dataTypeDictionaryNodeId.namespace);
        }
        await _extractDataTypeDictionaryFromDefinition(session, dataTypeDictionaryNodeId, dataTypeFactory2);
      } else {
        const rawSchema = d2.rawSchema;
        debugLog(" ----- Using old method for extracting schema => with BSD files");
        if (doDebug) {
          debugLog("---------------------------------------------");
          debugLog(rawSchema.toString());
          debugLog("---------------------------------------------");
        }
        const idProvider = await _extractNodeIds(session, dataTypeDictionaryNodeId);
        const dataTypeFactory1 = dataTypeManager.getDataTypeFactory(dataTypeDictionaryNodeId.namespace);
        await (0, node_opcua_schemas_1.parseBinaryXSDAsync)(rawSchema, idProvider, dataTypeFactory1);
      }
    }
    async function _exploreDataTypeDefinition(session, dataTypeDictionaryTypeNode, dataTypeFactory, namespaces) {
      const nodeToBrowse = {
        browseDirection: node_opcua_service_browse_1.BrowseDirection.Forward,
        includeSubtypes: false,
        nodeClassMask: (0, node_opcua_data_model_1.makeNodeClassMask)("Variable"),
        nodeId: dataTypeDictionaryTypeNode,
        referenceTypeId: (0, node_opcua_nodeid_1.resolveNodeId)("HasComponent"),
        resultMask: (0, node_opcua_data_model_1.makeResultMask)("ReferenceType | IsForward | BrowseName | NodeClass | TypeDefinition")
      };
      const result2 = await (0, node_opcua_pseudo_session_1.browseAll)(session, nodeToBrowse);
      const references = result2.references || [];
      if (references.length === 0) {
        return;
      }
      const nodesToBrowse2 = references.map((ref) => {
        return {
          browseDirection: node_opcua_service_browse_1.BrowseDirection.Inverse,
          includeSubtypes: false,
          nodeClassMask: (0, node_opcua_data_model_1.makeNodeClassMask)("Object | Variable"),
          nodeId: ref.nodeId,
          referenceTypeId: (0, node_opcua_nodeid_1.resolveNodeId)("HasDescription"),
          resultMask: (0, node_opcua_data_model_1.makeResultMask)("NodeId | ReferenceType | BrowseName | NodeClass | TypeDefinition")
        };
      });
      const results2 = await (0, node_opcua_pseudo_session_1.browseAll)(session, nodesToBrowse2);
      const binaryEncodingNodeIds = results2.map((br) => {
        const defaultBin = br.references.filter((r) => r.browseName.toString() === "Default Binary");
        if (defaultBin.length < 1) {
          return node_opcua_nodeid_1.ExpandedNodeId;
        }
        return node_opcua_nodeid_1.ExpandedNodeId.fromNodeId(defaultBin[0].nodeId, namespaces[defaultBin[0].nodeId.namespace]);
      });
      if (doDebug) {
        debugLog(chalk_1.default.bgWhite.red("testing new constructors"));
        for (let i = 0; i < references.length; i++) {
          const ref = references[i];
          const binaryEncoding = binaryEncodingNodeIds[i];
          const name = ref.browseName.name.toString();
          debugLog("      type ", name.padEnd(30, " "), binaryEncoding.toString());
          try {
            const Constructor = dataTypeFactory.getStructureInfoByTypeName(name).constructor;
            if (!Constructor) {
              throw new Error(`Cannot instantiate abstract DataType(name=${name})`);
            }
            const testObject = new Constructor();
            debugLog(testObject.toString());
          } catch (err) {
            debugLog("         Error cannot construct Extension Object " + name);
            debugLog("         " + err.message);
          }
        }
      }
    }
    var regexTargetNamespaceAttribute = /TargetNamespace="([^"]+)"|TargetNamespace='([^']+)'/;
    function extractTargetNamespaceAttribute(xmlElement) {
      const c2 = xmlElement.match(regexTargetNamespaceAttribute);
      if (c2) {
        return c2[1] || c2[2];
      }
      return "";
    }
    var regexNamespaceRef = /xmlns:(.*)=(("([^"]+)")|('([^']+)'))/;
    function extraNamespaceRef(attribute) {
      const c2 = attribute.match(regexNamespaceRef);
      if (c2) {
        const xmlns = c2[1];
        const namespace = c2[4] || c2[5];
        return { xmlns, namespace };
      }
      return null;
    }
    async function populateDataTypeManager103(session, dataTypeManager) {
      debugLog("in ... populateDataTypeManager");
      const dataValueNamespaceArray = await session.read({
        attributeId: node_opcua_data_model_1.AttributeIds.Value,
        nodeId: (0, node_opcua_nodeid_1.resolveNodeId)("Server_NamespaceArray")
      });
      const namespaceArray = dataValueNamespaceArray.value.value;
      if (!namespaceArray) {
        debugLog("session: cannot read Server_NamespaceArray");
        return;
      }
      if (doDebug) {
        debugLog("namespaceArray ", namespaceArray.map((a, index) => " " + index.toString().padEnd(3) + ":" + a).join(" "));
      }
      if (dataValueNamespaceArray.statusCode.isGood() && namespaceArray && namespaceArray.length > 0) {
        dataTypeManager.setNamespaceArray(namespaceArray);
        for (let namespaceIndex = 1; namespaceIndex < namespaceArray.length; namespaceIndex++) {
          if (!dataTypeManager.hasDataTypeFactory(namespaceIndex)) {
            const dataTypeFactory1 = new node_opcua_factory_1.DataTypeFactory([(0, node_opcua_factory_1.getStandardDataTypeFactory)()]);
            dataTypeManager.registerDataTypeFactory(namespaceIndex, dataTypeFactory1);
          }
        }
      }
      if (!dataValueNamespaceArray.value.value && dataTypeManager.namespaceArray.length === 0) {
        dataTypeManager.setNamespaceArray([]);
      }
      const dataTypeDictionaryType = (0, node_opcua_nodeid_1.resolveNodeId)("DataTypeDictionaryType");
      const opcBinaryNodeId = (0, node_opcua_nodeid_1.resolveNodeId)("OPCBinarySchema_TypeSystem");
      const nodeToBrowse = {
        browseDirection: node_opcua_service_browse_1.BrowseDirection.Forward,
        includeSubtypes: false,
        nodeClassMask: (0, node_opcua_data_model_1.makeNodeClassMask)("Variable"),
        nodeId: opcBinaryNodeId,
        referenceTypeId: (0, node_opcua_nodeid_1.resolveNodeId)("HasComponent"),
        resultMask: (0, node_opcua_data_model_1.makeResultMask)("ReferenceType | IsForward | BrowseName | NodeClass | TypeDefinition")
      };
      const result2 = await (0, node_opcua_pseudo_session_1.browseAll)(session, nodeToBrowse);
      if (doDebug) {
        debugLog(result2.statusCode.toString());
        debugLog(result2.references?.map((r) => r.browseName?.toString()).join(" "));
      }
      const references = result2.references.filter((e) => e.nodeId.namespace !== 0 && (0, node_opcua_nodeid_1.sameNodeId)(e.typeDefinition, dataTypeDictionaryType));
      debugLog(`found ${references.length} dictionary`);
      async function putInCorrectOrder() {
        const infos = [];
        const innerMap = {};
        for (const reference of references) {
          const dataTypeDictionaryNodeId = reference.nodeId;
          const isDictionaryDeprecated = await _readDeprecatedFlag(session, dataTypeDictionaryNodeId);
          const rawSchemaDataValue = await session.read({
            attributeId: node_opcua_data_model_1.AttributeIds.Value,
            nodeId: dataTypeDictionaryNodeId
          });
          const rawSchema = rawSchemaDataValue.value.value ? rawSchemaDataValue.value.value.toString() : "";
          const info = {
            dataTypeDictionaryNodeId,
            dependencies: {},
            isDictionaryDeprecated,
            rawSchema,
            reference,
            targetNamespace: ""
          };
          infos.push(info);
          if (!isDictionaryDeprecated && rawSchema.length > 0) {
            if (doDebug) {
              debugLog("schema", rawSchema);
            }
            const matches = rawSchema.match(/<opc:TypeDictionary([^>]+)>/);
            if (matches) {
              const typeDictionaryElementAttributes = matches[1];
              info.targetNamespace = extractTargetNamespaceAttribute(typeDictionaryElementAttributes);
              const nsKeyNamespace = {};
              for (const attribute of typeDictionaryElementAttributes.split(" ")) {
                const r = extraNamespaceRef(attribute);
                if (r) {
                  const { xmlns, namespace } = r;
                  nsKeyNamespace[xmlns] = namespace;
                  debugLog("xxxx ns= ", xmlns, "=>", namespace);
                }
              }
              info.dependencies = nsKeyNamespace;
              debugLog("xxx targetNamespace = ", info.targetNamespace);
              innerMap[info.targetNamespace] = info;
            }
          } else {
            info.targetNamespace = namespaceArray[dataTypeDictionaryNodeId.namespace];
            debugLog("xxx targetNamespace = ", info.targetNamespace);
            innerMap[info.targetNamespace] = info;
          }
        }
        const orderedList = [];
        const visited = {};
        function explore(d2) {
          if (visited[d2.targetNamespace]) {
            return;
          }
          visited[d2.targetNamespace] = 1;
          for (const [xmlns, namespace] of Object.entries(d2.dependencies)) {
            if (!innerMap[namespace] || namespace === d2.targetNamespace) {
              continue;
            }
            explore(innerMap[namespace]);
          }
          orderedList.push(d2);
        }
        for (const d2 of infos) {
          explore(d2);
        }
        debugLog(" Ordered List = ", orderedList.map((a) => a.targetNamespace).join("  "));
        return orderedList;
      }
      const dataTypeDictionaryInfo = await putInCorrectOrder();
      const map = {};
      for (const d2 of dataTypeDictionaryInfo) {
        map[d2.targetNamespace] = d2;
        debugLog(" fixing based dataTypeFactory dependencies for  ", d2.targetNamespace, "index = ", d2.dataTypeDictionaryNodeId.namespace);
        const baseDataFactories = [(0, node_opcua_factory_1.getStandardDataTypeFactory)()];
        for (const namespace of Object.values(d2.dependencies)) {
          if (namespace === d2.targetNamespace) {
            continue;
          }
          const baseDataFactory = map[namespace];
          if (!baseDataFactory) {
            continue;
          }
          const namespaceIndex = baseDataFactory.dataTypeDictionaryNodeId.namespace;
          if (dataTypeManager.hasDataTypeFactory(namespaceIndex)) {
            const dep = dataTypeManager.getDataTypeFactory(namespaceIndex);
            baseDataFactories.push(dep);
            debugLog("   considering , ", baseDataFactory.targetNamespace, "index = ", baseDataFactory.dataTypeDictionaryNodeId.namespace);
          }
        }
        const dataTypeFactory = dataTypeManager.getDataTypeFactory(d2.dataTypeDictionaryNodeId.namespace);
        if (dataTypeFactory) {
          dataTypeFactory.repairBaseDataFactories(baseDataFactories);
        }
      }
      async function processReferenceOnDataTypeDictionaryType(d2) {
        debugLog(chalk_1.default.cyan("processReferenceOnDataTypeDictionaryType on  "), d2.targetNamespace);
        const ref = d2.reference;
        const dataTypeDictionaryNodeId = d2.reference.nodeId;
        await _extractDataTypeDictionary(session, d2, dataTypeManager);
        if (doDebug) {
          debugLog(chalk_1.default.bgWhite("                                         => "), ref.browseName.toString(), ref.nodeId.toString());
        }
        const dataTypeFactory = dataTypeManager.getDataTypeFactoryForNamespace(dataTypeDictionaryNodeId.namespace);
        await _exploreDataTypeDefinition(session, dataTypeDictionaryNodeId, dataTypeFactory, dataTypeManager.namespaceArray);
      }
      for (const d2 of dataTypeDictionaryInfo) {
        try {
          await processReferenceOnDataTypeDictionaryType(d2).catch((e) => {
            debugLog("processReferenceOnDataTypeDictionaryType has failed ");
            debugLog("Error", e.message);
            debugLog(e);
            return e;
          });
        } catch (err) {
          debugLog(chalk_1.default.red("xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx "), err);
        }
      }
      debugLog("out ... populateDataTypeManager");
    }
    exports2.populateDataTypeManager103 = populateDataTypeManager103;
  }
});

// node_modules/node-opcua-client-dynamic-extension-object/dist/private/populate_data_type_manager_104.js
var require_populate_data_type_manager_104 = __commonJS({
  "node_modules/node-opcua-client-dynamic-extension-object/dist/private/populate_data_type_manager_104.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.populateDataTypeManager104 = exports2.readDataTypeDefinitionAndBuildType = void 0;
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_factory_1 = require_dist26();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_pseudo_session_1 = require_dist55();
    var node_opcua_schemas_1 = require_source3();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_types_1 = require_dist32();
    var convert_data_type_definition_to_structuretype_schema_1 = require_convert_data_type_definition_to_structuretype_schema();
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    async function readDataTypeDefinitionAndBuildType(session, dataTypeNodeId, name, dataTypeFactory, cache) {
      try {
        if (dataTypeFactory.getStructureInfoForDataType(dataTypeNodeId)) {
          return;
        }
        const [isAbstractDataValue, dataTypeDefinitionDataValue] = await session.read([
          {
            attributeId: node_opcua_data_model_1.AttributeIds.IsAbstract,
            nodeId: dataTypeNodeId
          },
          {
            attributeId: node_opcua_data_model_1.AttributeIds.DataTypeDefinition,
            nodeId: dataTypeNodeId
          }
        ]);
        if (isAbstractDataValue.statusCode.isNotGood()) {
          throw new Error(" Cannot find dataType isAbstract ! with nodeId =" + dataTypeNodeId.toString());
        }
        const isAbstract = isAbstractDataValue.value.value;
        let dataTypeDefinition = dataTypeDefinitionDataValue.value.value;
        if (dataTypeDefinitionDataValue.statusCode.isNotGood()) {
          if (!isAbstract) {
            warningLog(" Cannot find dataType Definition ! with nodeId =" + dataTypeNodeId.toString());
            return;
          }
          dataTypeDefinition = new node_opcua_types_1.StructureDefinition();
        }
        const schema = await (0, convert_data_type_definition_to_structuretype_schema_1.convertDataTypeDefinitionToStructureTypeSchema)(session, dataTypeNodeId, name, dataTypeDefinition, null, dataTypeFactory, isAbstract, cache);
        if (isAbstract) {
          dataTypeFactory.registerAbstractStructure(dataTypeNodeId, name, schema);
        } else {
          const Constructor = (0, node_opcua_schemas_1.createDynamicObjectConstructor)(schema, dataTypeFactory);
        }
      } catch (err) {
        errorLog("Error", err);
      }
    }
    exports2.readDataTypeDefinitionAndBuildType = readDataTypeDefinitionAndBuildType;
    var TaskMan = class {
      constructor() {
        this.taskList = [];
        this._runningTask = false;
        this._resolve = void 0;
      }
      async flushTaskList() {
        const firstTask = this.taskList.shift();
        this._runningTask = true;
        await firstTask();
        this._runningTask = false;
        if (this.taskList.length > 0) {
          setImmediate(async () => {
            await this.flushTaskList();
          });
        } else {
          if (this._resolve) {
            const tmpResolve = this._resolve;
            this._resolve = void 0;
            tmpResolve();
          }
        }
      }
      /**
       *
       * a little async task queue that gets executed sequentially
       * outside the main loop
       */
      registerTask(taskFunc) {
        this.taskList.push(taskFunc);
        if (this.taskList.length === 1 && !this._runningTask) {
          this.flushTaskList();
        }
      }
      async waitForCompletion() {
        if (this._resolve !== void 0) {
          throw new Error("already waiting");
        }
        await new Promise((resolve2) => {
          this._resolve = resolve2;
        });
      }
    };
    async function applyOnReferenceRecursively(session, nodeId, browseDescriptionTemplate, action) {
      const taskManager = new TaskMan();
      let pendingNodesToBrowse = [];
      function processBrowseResults(nodesToBrowse, browseResults) {
        for (let i = 0; i < browseResults.length; i++) {
          const result2 = browseResults[i];
          const nodeToBrowse = nodesToBrowse[i];
          if (result2.statusCode.equals(node_opcua_status_code_1.StatusCodes.BadNoContinuationPoints) || result2.statusCode.equals(node_opcua_status_code_1.StatusCodes.BadContinuationPointInvalid)) {
            pendingNodesToBrowse.push(nodeToBrowse);
          } else if (result2.statusCode.isGood()) {
            for (const r of result2.references || []) {
              browseSubDataTypeRecursively(r.nodeId);
              taskManager.registerTask(async () => await action(r));
            }
          } else {
            errorLog("Unexpected status code", i, new node_opcua_types_1.BrowseDescription(nodesToBrowse[i] || {})?.toString(), result2.statusCode.toString());
          }
        }
      }
      async function flushBrowse() {
        if (pendingNodesToBrowse.length) {
          const nodesToBrowse = pendingNodesToBrowse;
          pendingNodesToBrowse = [];
          taskManager.registerTask(async () => {
            try {
              const browseResults = await (0, node_opcua_pseudo_session_1.browseAll)(session, nodesToBrowse);
              processBrowseResults(nodesToBrowse, browseResults);
            } catch (err) {
              errorLog("err", err.message);
              errorLog(nodesToBrowse.toString());
            }
          });
        }
      }
      function browseSubDataTypeRecursively(nodeId2) {
        const nodeToBrowse = {
          ...browseDescriptionTemplate,
          nodeId: nodeId2
        };
        pendingNodesToBrowse.push(nodeToBrowse);
        taskManager.registerTask(async () => flushBrowse());
      }
      browseSubDataTypeRecursively(nodeId);
      await taskManager.waitForCompletion();
    }
    async function populateDataTypeManager104(session, dataTypeManager) {
      const cache = {};
      async function withDataType(r) {
        const dataTypeNodeId = r.nodeId;
        try {
          if (dataTypeNodeId.namespace === 0) {
            return;
          }
          let dataTypeFactory = dataTypeManager.getDataTypeFactory(dataTypeNodeId.namespace);
          if (!dataTypeFactory) {
            dataTypeFactory = new node_opcua_factory_1.DataTypeFactory([]);
            dataTypeManager.registerDataTypeFactory(dataTypeNodeId.namespace, dataTypeFactory);
          }
          if (dataTypeFactory.getStructureInfoForDataType(dataTypeNodeId)) {
            return;
          }
          debugLog(" DataType => ", r.browseName.toString(), dataTypeNodeId.toString());
          await readDataTypeDefinitionAndBuildType(session, dataTypeNodeId, r.browseName.name, dataTypeFactory, cache);
        } catch (err) {
          errorLog("err=", err);
        }
      }
      const nodeToBrowse = {
        nodeId: node_opcua_nodeid_1.NodeId.nullNodeId,
        // to be replaced
        includeSubtypes: true,
        browseDirection: node_opcua_data_model_1.BrowseDirection.Forward,
        nodeClassMask: 255,
        referenceTypeId: (0, node_opcua_nodeid_1.resolveNodeId)("HasSubtype"),
        resultMask: 255
      };
      await applyOnReferenceRecursively(session, (0, node_opcua_nodeid_1.resolveNodeId)("Structure"), nodeToBrowse, withDataType);
    }
    exports2.populateDataTypeManager104 = populateDataTypeManager104;
  }
});

// node_modules/node-opcua-client-dynamic-extension-object/dist/populate_data_type_manager.js
var require_populate_data_type_manager = __commonJS({
  "node_modules/node-opcua-client-dynamic-extension-object/dist/populate_data_type_manager.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.populateDataTypeManager = exports2.serverImplementsDataTypeDefinition = void 0;
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_pseudo_session_1 = require_dist55();
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_service_translate_browse_path_1 = require_dist49();
    var populate_data_type_manager_103_1 = require_populate_data_type_manager_103();
    var populate_data_type_manager_104_1 = require_populate_data_type_manager_104();
    async function serverImplementsDataTypeDefinition(session) {
      const browseResult1 = await (0, node_opcua_pseudo_session_1.browseAll)(session, {
        browseDirection: node_opcua_data_model_1.BrowseDirection.Forward,
        includeSubtypes: true,
        nodeClassMask: node_opcua_data_model_1.NodeClassMask.Variable,
        nodeId: (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_constants_1.ObjectIds.OPCBinarySchema_TypeSystem),
        resultMask: node_opcua_data_model_1.ResultMask.TypeDefinition
      });
      let count103DataType = 0;
      for (const ref of browseResult1.references || []) {
        const td = ref.typeDefinition;
        if (!(td.namespace === 0 && td.value === node_opcua_constants_1.VariableTypeIds.DataTypeDictionaryType))
          continue;
        const p3 = await session.translateBrowsePath((0, node_opcua_service_translate_browse_path_1.makeBrowsePath)(ref.nodeId, "/Deprecated"));
        if (!p3.statusCode.isGood() || !p3.targets || p3.targets.length === 0) {
          count103DataType++;
          continue;
        }
        const deprecatedNodeId = p3.targets[0].targetId;
        const dataValue = await session.read({ nodeId: deprecatedNodeId, attributeId: node_opcua_data_model_1.AttributeIds.Value });
        if (dataValue.statusCode.isGood() && dataValue.value.value === false) {
          count103DataType++;
          continue;
        }
      }
      if (count103DataType >= 1) {
        return false;
      }
      const browseResult = await (0, node_opcua_pseudo_session_1.browseAll)(session, {
        browseDirection: node_opcua_data_model_1.BrowseDirection.Forward,
        includeSubtypes: true,
        nodeClassMask: node_opcua_data_model_1.NodeClassMask.DataType,
        nodeId: (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_variant_1.DataType.ExtensionObject),
        referenceTypeId: "HasSubtype",
        resultMask: 63
      });
      const browseResult2 = await (0, node_opcua_pseudo_session_1.browseAll)(session, {
        browseDirection: node_opcua_data_model_1.BrowseDirection.Forward,
        includeSubtypes: true,
        nodeClassMask: node_opcua_data_model_1.NodeClassMask.DataType,
        nodeId: (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_constants_1.DataTypeIds.Union),
        referenceTypeId: "HasSubtype",
        resultMask: 63
      });
      let references = [];
      if (browseResult && browseResult.references)
        references = references.concat(browseResult.references);
      if (browseResult2 && browseResult2.references)
        references = references.concat(browseResult2.references);
      if (references.length === 0)
        return false;
      references = references.filter((a, index) => a.nodeId.namespace !== 0);
      if (references.length === 0)
        return false;
      let nodesToRead = references.map((r) => ({
        nodeId: r.nodeId,
        attributeId: node_opcua_data_model_1.AttributeIds.DataTypeDefinition
      }));
      const nodesToRead2 = nodesToRead.map((r) => ({ nodeId: r.nodeId, attributeId: node_opcua_data_model_1.AttributeIds.IsAbstract }));
      const abstractFlags = (await session.read(nodesToRead2)).map((d2) => d2.value.value);
      nodesToRead = nodesToRead.filter((_nodesToRead, index) => !abstractFlags[index]);
      if (nodesToRead.length === 0)
        return false;
      const dataValues = await session.read(nodesToRead);
      const countOK = dataValues.reduce((prev, a) => prev + (a.statusCode.isGood() ? 1 : 0), 0);
      if (countOK === dataValues.length) {
        return true;
      }
      return false;
    }
    exports2.serverImplementsDataTypeDefinition = serverImplementsDataTypeDefinition;
    async function populateDataTypeManager(session, dataTypeManager) {
      const force104 = await serverImplementsDataTypeDefinition(session);
      if (force104) {
        await (0, populate_data_type_manager_104_1.populateDataTypeManager104)(session, dataTypeManager);
        return;
      }
      await (0, populate_data_type_manager_103_1.populateDataTypeManager103)(session, dataTypeManager);
      await (0, populate_data_type_manager_104_1.populateDataTypeManager104)(session, dataTypeManager);
    }
    exports2.populateDataTypeManager = populateDataTypeManager;
  }
});

// node_modules/node-opcua-client-dynamic-extension-object/dist/extra_data_type_manager.js
var require_extra_data_type_manager = __commonJS({
  "node_modules/node-opcua-client-dynamic-extension-object/dist/extra_data_type_manager.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ExtraDataTypeManager = void 0;
    var util_1 = require("util");
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_factory_1 = require_dist26();
    var ExtraDataTypeManager = class {
      constructor() {
        this.namespaceArray = [];
        this.dataTypeFactoryMapByNamespace = {};
      }
      setNamespaceArray(namespaceArray) {
        this.namespaceArray = namespaceArray;
      }
      hasDataTypeFactory(namespaceIndex) {
        return !!Object.prototype.hasOwnProperty.call(this.dataTypeFactoryMapByNamespace, namespaceIndex);
      }
      registerDataTypeFactory(namespaceIndex, dataTypeFactory) {
        (0, node_opcua_assert_1.assert)(namespaceIndex !== 0, "registerTypeDictionary cannot be used for namespace 0");
        if (this.hasDataTypeFactory(namespaceIndex)) {
          throw new Error("Dictionary already registered");
        }
        this.dataTypeFactoryMapByNamespace[namespaceIndex] = dataTypeFactory;
      }
      getDataTypeFactoryForNamespace(namespaceIndex) {
        (0, node_opcua_assert_1.assert)(namespaceIndex !== 0, "getTypeDictionaryForNamespace cannot be used for namespace 0");
        return this.dataTypeFactoryMapByNamespace[namespaceIndex];
      }
      getDataTypeFactory(namespaceIndex) {
        if (namespaceIndex === 0) {
          return (0, node_opcua_factory_1.getStandardDataTypeFactory)();
        }
        return this.dataTypeFactoryMapByNamespace[namespaceIndex];
      }
      getExtensionObjectConstructorFromDataType(dataTypeNodeId) {
        const dataTypeFactory = this.getDataTypeFactory(dataTypeNodeId.namespace);
        if (!dataTypeFactory) {
          throw new Error("cannot find dataFactory for namespace=" + dataTypeNodeId.namespace + " when requested for " + dataTypeNodeId.toString());
        }
        const Constructor = dataTypeFactory.findStructureInfoForDataType(dataTypeNodeId).constructor;
        if (!Constructor) {
          throw new Error("Cannot find Extension Object Constructor for Abstract dataType");
        }
        return Constructor;
      }
      getExtensionObjectConstructorFromBinaryEncoding(binaryEncodingNodeId) {
        const dataTypeFactory = this.getDataTypeFactoryForNamespace(binaryEncodingNodeId.namespace);
        const Constructor = dataTypeFactory.getConstructor(binaryEncodingNodeId);
        if (!Constructor) {
          throw new Error("getExtensionObjectConstructorFromBinaryEncoding cannot find constructor for binaryEncoding " + binaryEncodingNodeId.toString());
        }
        return Constructor;
      }
      toString() {
        const l2 = [];
        function write(...args) {
          l2.push(util_1.format.apply(util_1.format, args));
        }
        write("ExtraDataTypeManager");
        for (let n = 0; n < this.namespaceArray.length; n++) {
          write("------------- namespace:", this.namespaceArray[n]);
          const dataFactory = this.dataTypeFactoryMapByNamespace[n];
          if (!dataFactory) {
            continue;
          }
          write(dataFactory.toString());
        }
        return l2.join("\n");
      }
    };
    exports2.ExtraDataTypeManager = ExtraDataTypeManager;
  }
});

// node_modules/node-opcua-client-dynamic-extension-object/dist/resolve_dynamic_extension_object.js
var require_resolve_dynamic_extension_object = __commonJS({
  "node_modules/node-opcua-client-dynamic-extension-object/dist/resolve_dynamic_extension_object.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.resolveDynamicExtensionObject = exports2.resolveOpaqueStructureInExtensionObject = void 0;
    var node_opcua_binary_stream_1 = require_dist18();
    var node_opcua_extension_object_1 = require_dist30();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_data_model_1 = require_dist27();
    var populate_data_type_manager_104_1 = require_populate_data_type_manager_104();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    async function getOrExtractConstructor(session, binaryEncodingNodeId, dataTypeManager) {
      const dataTypeFactory = dataTypeManager.getDataTypeFactoryForNamespace(binaryEncodingNodeId.namespace);
      const Constructor = dataTypeFactory.getConstructor(binaryEncodingNodeId);
      if (Constructor) {
        return Constructor;
      }
      if (binaryEncodingNodeId.namespace === 0) {
        throw new Error("Internal Error");
      }
      const browseResult = await session.browse({
        nodeId: binaryEncodingNodeId,
        referenceTypeId: "HasEncoding",
        browseDirection: node_opcua_data_model_1.BrowseDirection.Inverse,
        includeSubtypes: false,
        nodeClassMask: node_opcua_data_model_1.NodeClassMask.DataType,
        resultMask: node_opcua_data_model_1.ResultMask.BrowseName
      });
      if (browseResult.statusCode.isNotGood() || browseResult.references.length !== 1) {
        throw new Error("browse failed");
      }
      const r = browseResult.references[0];
      const dataTypeNodeId = r.nodeId;
      if (dataTypeFactory.getStructureInfoForDataType(dataTypeNodeId)) {
        throw new Error("Internal Error: we are not expecting this dataType to be processed already " + dataTypeNodeId.toString());
      }
      await (0, populate_data_type_manager_104_1.readDataTypeDefinitionAndBuildType)(session, dataTypeNodeId, r.browseName.name, dataTypeFactory, {});
      const structureInfo = dataTypeFactory.getStructureInfoForDataType(dataTypeNodeId);
      if (!structureInfo.constructor) {
        throw new Error("Cannot find constructor for abstract DataType");
      }
      return structureInfo.constructor;
    }
    async function resolveOpaqueStructureInExtensionObject(session, dataTypeManager, object) {
      const schema = object.schema;
      async function fixOpaqueStructureOnElement(element, field, data, args) {
        if (element instanceof node_opcua_variant_1.Variant) {
          await resolveDynamicExtensionObject(session, element, dataTypeManager);
          return element;
        }
        if (!(element instanceof node_opcua_extension_object_1.OpaqueStructure)) {
          return element;
        }
        const variant = new node_opcua_variant_1.Variant({ dataType: node_opcua_variant_1.DataType.ExtensionObject, value: element });
        await resolveDynamicExtensionObject(session, variant, dataTypeManager);
        return variant.value;
      }
      function fixOpaqueStructure(object2, field, data, args) {
        if (field.category === "complex" && !field.allowSubType) {
          return;
        }
        if (field.category === "basic" && field.fieldType !== "Variant") {
          return;
        }
        const a = object2[field.name];
        if (!a) {
          return;
        }
        if (field.isArray) {
          for (let i = 0; i < a.length; i++) {
            const x2 = a[i];
            promises.push((async () => {
              a[i] = await fixOpaqueStructureOnElement(x2, field, data, args);
            })());
          }
        } else {
          promises.push((async () => {
            object2[field.name] = await fixOpaqueStructureOnElement(a, field, data, args);
          })());
        }
      }
      const promises = [];
      object.applyOnAllFields(fixOpaqueStructure, { dataTypeManager, promises });
      await Promise.all(promises);
    }
    exports2.resolveOpaqueStructureInExtensionObject = resolveOpaqueStructureInExtensionObject;
    async function resolveDynamicExtensionObjectV(session, opaque, dataTypeManager) {
      try {
        const Constructor = await getOrExtractConstructor(session, opaque.nodeId, dataTypeManager);
        const object = new Constructor();
        const stream = new node_opcua_binary_stream_1.BinaryStream(opaque.buffer);
        try {
          object.decode(stream);
          await resolveOpaqueStructureInExtensionObject(session, dataTypeManager, object);
          return object;
        } catch (err) {
          warningLog("Constructor = ", Constructor.name);
          warningLog("opaqueStructure = ", opaque?.nodeId?.toString());
          warningLog("opaqueStructure = ", (0, node_opcua_debug_1.hexDump)(opaque.buffer, 132, 100));
          warningLog((0, node_opcua_debug_1.hexDump)(opaque.buffer));
          warningLog("resolveDynamicExtensionObjectV err = ", err);
          object.decode(stream);
          return opaque;
        }
      } catch (err) {
        warningLog("err", err);
        warningLog("opaqueStructure = ", opaque.nodeId.toString());
        warningLog("opaqueStructure = ", "0x" + (0, node_opcua_debug_1.hexDump)(opaque.buffer, 132, 100));
        warningLog((0, node_opcua_debug_1.hexDump)(opaque.buffer));
        warningLog(dataTypeManager.toString());
        throw err;
      }
    }
    async function resolveDynamicExtensionObject(session, variant, dataTypeManager) {
      if (variant.dataType !== node_opcua_variant_1.DataType.ExtensionObject) {
        return;
      }
      if (variant.arrayType !== node_opcua_variant_1.VariantArrayType.Scalar) {
        if (variant.value instanceof Array) {
          for (let i = 0; i < variant.value.length; i++) {
            if (variant.value[i] instanceof node_opcua_extension_object_1.OpaqueStructure) {
              variant.value[i] = await resolveDynamicExtensionObjectV(session, variant.value[i], dataTypeManager);
            }
          }
        }
        return;
      }
      if (!(variant.value instanceof node_opcua_extension_object_1.OpaqueStructure)) {
        return;
      }
      variant.value = await resolveDynamicExtensionObjectV(session, variant.value, dataTypeManager);
    }
    exports2.resolveDynamicExtensionObject = resolveDynamicExtensionObject;
  }
});

// node_modules/node-opcua-client-dynamic-extension-object/dist/get_extra_data_type_manager.js
var require_get_extra_data_type_manager = __commonJS({
  "node_modules/node-opcua-client-dynamic-extension-object/dist/get_extra_data_type_manager.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getExtraDataTypeManager = exports2.invalidateExtraDataTypeManager = void 0;
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_factory_1 = require_dist26();
    var node_opcua_pseudo_session_1 = require_dist55();
    var extra_data_type_manager_1 = require_extra_data_type_manager();
    var populate_data_type_manager_1 = require_populate_data_type_manager();
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var warningLog = errorLog;
    async function invalidateExtraDataTypeManager(session) {
      const sessionPriv = session;
      sessionPriv.$$extraDataTypeManager = void 0;
      if (sessionPriv.$$extraDataTypeManagerToResolve) {
        warningLog("Warning: invalidateExtraDataTypeManager is called while getExtraDataTypeManager is in progress");
      }
    }
    exports2.invalidateExtraDataTypeManager = invalidateExtraDataTypeManager;
    async function extractDataTypeManager(session) {
      const namespaceArray = await (0, node_opcua_pseudo_session_1.readNamespaceArray)(session);
      if (namespaceArray.length === 0) {
        errorLog("namespaceArray is not populated ! Your server must expose a list of namespace ");
      }
      if (doDebug) {
        debugLog("Namespace Array = ", namespaceArray.join("\n                   "));
      }
      const dataTypeManager = new extra_data_type_manager_1.ExtraDataTypeManager();
      dataTypeManager.setNamespaceArray(namespaceArray);
      for (let namespaceIndex = 1; namespaceIndex < namespaceArray.length; namespaceIndex++) {
        const dataTypeFactory1 = new node_opcua_factory_1.DataTypeFactory([(0, node_opcua_factory_1.getStandardDataTypeFactory)()]);
        dataTypeManager.registerDataTypeFactory(namespaceIndex, dataTypeFactory1);
      }
      await (0, populate_data_type_manager_1.populateDataTypeManager)(session, dataTypeManager);
      if (dataTypeManager.namespaceArray.length === 0) {
        throw new Error("namespaceArray is not populated ! Your server must expose a list of namespace ");
      }
      return dataTypeManager;
    }
    async function getExtraDataTypeManager(session) {
      const sessionPriv = session;
      if (sessionPriv.$$extraDataTypeManager) {
        return sessionPriv.$$extraDataTypeManager;
      }
      if (sessionPriv.$$extraDataTypeManagerToResolve) {
        doDebug && debugLog("getExtraDataTypeManager is re-entering !");
        return await new Promise((resolve2, reject) => {
          sessionPriv.$$extraDataTypeManagerToResolve?.push([resolve2, reject]);
        });
      }
      sessionPriv.$$extraDataTypeManagerToResolve = [];
      return await new Promise((_resolve, _reject) => {
        sessionPriv.$$extraDataTypeManagerToResolve.push([_resolve, _reject]);
        (async () => {
          try {
            const dataTypeManager = await extractDataTypeManager(session);
            const tmp = sessionPriv.$$extraDataTypeManagerToResolve;
            sessionPriv.$$extraDataTypeManagerToResolve = void 0;
            for (const [resolve2] of tmp) {
              resolve2(dataTypeManager);
            }
            sessionPriv.$$extraDataTypeManager = dataTypeManager;
          } catch (err) {
            const tmp = sessionPriv.$$extraDataTypeManagerToResolve;
            sessionPriv.$$extraDataTypeManagerToResolve = void 0;
            for (const [_resolve2, reject] of tmp) {
              reject(err);
            }
          }
        })();
      });
    }
    exports2.getExtraDataTypeManager = getExtraDataTypeManager;
  }
});

// node_modules/node-opcua-client-dynamic-extension-object/dist/promote_opaque_structure.js
var require_promote_opaque_structure = __commonJS({
  "node_modules/node-opcua-client-dynamic-extension-object/dist/promote_opaque_structure.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.promoteOpaqueStructure = exports2.extractDataValueToPromote = void 0;
    var node_opcua_extension_object_1 = require_dist30();
    var node_opcua_variant_1 = require_dist28();
    var get_extra_data_type_manager_1 = require_get_extra_data_type_manager();
    var resolve_dynamic_extension_object_1 = require_resolve_dynamic_extension_object();
    function extractDataValueToPromote(dataValues) {
      const dataValuesToFix = dataValues.filter((dataValue) => dataValue.value && dataValue.value.dataType === node_opcua_variant_1.DataType.ExtensionObject && (dataValue.value.arrayType === node_opcua_variant_1.VariantArrayType.Scalar && dataValue.value.value instanceof node_opcua_extension_object_1.OpaqueStructure || dataValue.value.arrayType !== node_opcua_variant_1.VariantArrayType.Scalar && dataValue.value.value && dataValue.value.value.length >= 0 && dataValue.value.value[0] instanceof node_opcua_extension_object_1.OpaqueStructure));
      return dataValuesToFix;
    }
    exports2.extractDataValueToPromote = extractDataValueToPromote;
    async function promoteOpaqueStructure(session, dataValues) {
      const dataValuesToFix = extractDataValueToPromote(dataValues);
      if (dataValuesToFix.length === 0) {
        return;
      }
      const extraDataTypeManager = await (0, get_extra_data_type_manager_1.getExtraDataTypeManager)(session);
      const promises = dataValuesToFix.map(async (dataValue) => {
        return await (0, resolve_dynamic_extension_object_1.resolveDynamicExtensionObject)(session, dataValue.value, extraDataTypeManager);
      });
      await Promise.all(promises.map((p3) => p3.catch((e) => e)));
    }
    exports2.promoteOpaqueStructure = promoteOpaqueStructure;
  }
});

// node_modules/node-opcua-client-dynamic-extension-object/dist/get_extension_object_constructor.js
var require_get_extension_object_constructor = __commonJS({
  "node_modules/node-opcua-client-dynamic-extension-object/dist/get_extension_object_constructor.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getExtensionObjectConstructor = void 0;
    var node_opcua_data_model_1 = require_dist27();
    var get_extra_data_type_manager_1 = require_get_extra_data_type_manager();
    var populate_data_type_manager_104_1 = require_populate_data_type_manager_104();
    async function getExtensionObjectConstructor(session, dataTypeNodeId) {
      const extraDataTypeManager = await (0, get_extra_data_type_manager_1.getExtraDataTypeManager)(session);
      const dataTypeFactory = extraDataTypeManager.getDataTypeFactory(dataTypeNodeId.namespace);
      const structureInfo = dataTypeFactory.getStructureInfoForDataType(dataTypeNodeId);
      if (structureInfo) {
        return structureInfo.constructor;
      }
      const dataValue = await session.read({
        nodeId: dataTypeNodeId,
        attributeId: node_opcua_data_model_1.AttributeIds.BrowseName
      });
      const browseName = dataValue.value.value;
      await (0, populate_data_type_manager_104_1.readDataTypeDefinitionAndBuildType)(session, dataTypeNodeId, browseName.name, dataTypeFactory, {});
      return await extraDataTypeManager.getExtensionObjectConstructorFromDataType(dataTypeNodeId);
    }
    exports2.getExtensionObjectConstructor = getExtensionObjectConstructor;
  }
});

// node_modules/node-opcua-client-dynamic-extension-object/dist/convert_structuretype_schema_to_structure_definition.js
var require_convert_structuretype_schema_to_structure_definition = __commonJS({
  "node_modules/node-opcua-client-dynamic-extension-object/dist/convert_structuretype_schema_to_structure_definition.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.convertStructureTypeSchemaToStructureDefinition = void 0;
    var node_opcua_factory_1 = require_dist26();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_nodeid_1 = require_dist21();
    function _getDataType(field) {
      switch (field.category) {
        case node_opcua_factory_1.FieldCategory.complex:
          return (0, node_opcua_nodeid_1.resolveNodeId)(field.schema.dataTypeNodeId);
        case node_opcua_factory_1.FieldCategory.basic:
          return (0, node_opcua_nodeid_1.resolveNodeId)(field.fieldType);
        case node_opcua_factory_1.FieldCategory.enumeration:
        default:
          return (0, node_opcua_nodeid_1.resolveNodeId)(field.dataType);
      }
    }
    function convertStructureTypeSchemaToStructureDefinition(st) {
      let structureType = node_opcua_types_1.StructureType.Invalid;
      let isUnion = false;
      if (st.baseType === "Union") {
        structureType = node_opcua_types_1.StructureType.Union;
        isUnion = true;
      } else {
        structureType = node_opcua_types_1.StructureType.Structure;
      }
      const structureDefinition = {
        fields: [],
        baseDataType: st.getBaseSchema()?.dataTypeNodeId,
        defaultEncodingId: st.encodingDefaultBinary,
        structureType
      };
      const fields = structureDefinition.fields || [];
      for (const f2 of st.fields) {
        const dataType = _getDataType(f2);
        if (isUnion && f2.originalName === "SwitchField") {
          continue;
        }
        fields.push({
          arrayDimensions: f2.isArray ? [] : void 0,
          valueRank: f2.isArray ? 1 : -1,
          dataType,
          isOptional: isUnion ? void 0 : f2.switchValue !== void 0,
          description: f2.documentation || void 0,
          name: f2.originalName
        });
      }
      return new node_opcua_types_1.StructureDefinition(structureDefinition);
    }
    exports2.convertStructureTypeSchemaToStructureDefinition = convertStructureTypeSchemaToStructureDefinition;
  }
});

// node_modules/node-opcua-client-dynamic-extension-object/dist/promote_opaque_structure_in_notification_data.js
var require_promote_opaque_structure_in_notification_data = __commonJS({
  "node_modules/node-opcua-client-dynamic-extension-object/dist/promote_opaque_structure_in_notification_data.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.promoteOpaqueStructureInNotificationData = void 0;
    var node_opcua_types_1 = require_dist32();
    var node_opcua_variant_1 = require_dist28();
    var promote_opaque_structure_1 = require_promote_opaque_structure();
    async function promoteOpaqueStructureInNotificationData(session, notificationData) {
      const dataValuesToPromote = [];
      for (const notification of notificationData) {
        if (!notification) {
          continue;
        }
        if (notification instanceof node_opcua_types_1.DataChangeNotification) {
          if (notification.monitoredItems) {
            for (const monitoredItem of notification.monitoredItems) {
              if (monitoredItem.value.value && monitoredItem.value.value.dataType === node_opcua_variant_1.DataType.ExtensionObject) {
                dataValuesToPromote.push(monitoredItem.value);
              }
            }
          }
        } else if (notification instanceof node_opcua_types_1.EventNotificationList) {
          if (notification.events) {
            for (const events of notification.events) {
              if (events.eventFields) {
                for (const eventField of events.eventFields) {
                  if (eventField.dataType === node_opcua_variant_1.DataType.ExtensionObject) {
                    dataValuesToPromote.push({ value: eventField });
                  }
                }
              }
            }
          }
        }
      }
      await (0, promote_opaque_structure_1.promoteOpaqueStructure)(session, dataValuesToPromote);
    }
    exports2.promoteOpaqueStructureInNotificationData = promoteOpaqueStructureInNotificationData;
  }
});

// node_modules/node-opcua-client-dynamic-extension-object/dist/index.js
var require_dist56 = __commonJS({
  "node_modules/node-opcua-client-dynamic-extension-object/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_populate_data_type_manager(), exports2);
    __exportStar3(require_extra_data_type_manager(), exports2);
    __exportStar3(require_resolve_dynamic_extension_object(), exports2);
    __exportStar3(require_promote_opaque_structure(), exports2);
    __exportStar3(require_get_extension_object_constructor(), exports2);
    __exportStar3(require_get_extra_data_type_manager(), exports2);
    __exportStar3(require_resolve_dynamic_extension_object(), exports2);
    __exportStar3(require_convert_data_type_definition_to_structuretype_schema(), exports2);
    __exportStar3(require_convert_structuretype_schema_to_structure_definition(), exports2);
    __exportStar3(require_promote_opaque_structure_in_notification_data(), exports2);
  }
});

// node_modules/node-opcua-address-space/dist/source/loader/ensure_datatype_extracted.js
var require_ensure_datatype_extracted = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/loader/ensure_datatype_extracted.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ensureDatatypeExtractedWithCallback = exports2.ensureDatatypeExtracted = void 0;
    var node_opcua_client_dynamic_extension_object_1 = require_dist56();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_factory_1 = require_dist26();
    var pseudo_session_1 = require_pseudo_session();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    function fixDefinition103(addressSpace, namespaceArray, dataTypeManager) {
      for (let namespaceIndex = 1; namespaceIndex < namespaceArray.length; namespaceIndex++) {
        const df = dataTypeManager.getDataTypeFactory(namespaceIndex);
        for (const s of df.getStructureIterator()) {
          const dataType = addressSpace.findDataType(s.schema.dataTypeNodeId);
          if (!s.constructor) {
            continue;
          }
          if (!dataType) {
            continue;
          }
          if (dataType.$partialDefinition && dataType.$partialDefinition.length) {
            continue;
          }
          if (!dataType.$partialDefinition || dataType.$partialDefinition.length === 0 && s.schema.fields.length > 0) {
            const sd = (0, node_opcua_client_dynamic_extension_object_1.convertStructureTypeSchemaToStructureDefinition)(s.schema);
            dataType.$partialDefinition = sd.fields || void 0;
          }
        }
      }
    }
    async function ensureDatatypeExtracted(addressSpace) {
      const addressSpacePriv = addressSpace;
      if (!addressSpacePriv.$$extraDataTypeManager) {
        const dataTypeManager = new node_opcua_client_dynamic_extension_object_1.ExtraDataTypeManager();
        const namespaceArray = addressSpace.getNamespaceArray().map((n) => n.namespaceUri);
        debugLog("INamespace Array = ", namespaceArray.join("\n                   "));
        dataTypeManager.setNamespaceArray(namespaceArray);
        addressSpacePriv.$$extraDataTypeManager = dataTypeManager;
        for (let namespaceIndex = 1; namespaceIndex < namespaceArray.length; namespaceIndex++) {
          const dataTypeFactory1 = new node_opcua_factory_1.DataTypeFactory([(0, node_opcua_factory_1.getStandardDataTypeFactory)()]);
          dataTypeManager.registerDataTypeFactory(namespaceIndex, dataTypeFactory1);
        }
        const session = new pseudo_session_1.PseudoSession(addressSpace);
        await (0, node_opcua_client_dynamic_extension_object_1.populateDataTypeManager)(session, dataTypeManager);
        fixDefinition103(addressSpace, namespaceArray, dataTypeManager);
      }
      return addressSpacePriv.$$extraDataTypeManager;
    }
    exports2.ensureDatatypeExtracted = ensureDatatypeExtracted;
    function ensureDatatypeExtractedWithCallback(addressSpace, callback) {
      ensureDatatypeExtracted(addressSpace).then((result2) => callback(null, result2)).catch((err) => callback(err));
    }
    exports2.ensureDatatypeExtractedWithCallback = ensureDatatypeExtractedWithCallback;
  }
});

// node_modules/node-opcua-address-space/dist/source/helpers/resolve_opaque_on_address_space.js
var require_resolve_opaque_on_address_space = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/helpers/resolve_opaque_on_address_space.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.resolveOpaqueOnAddressSpace = void 0;
    var node_opcua_client_dynamic_extension_object_1 = require_dist56();
    var node_opcua_variant_1 = require_dist28();
    var pseudo_session_1 = require_pseudo_session();
    var ensure_datatype_extracted_1 = require_ensure_datatype_extracted();
    async function resolveOpaqueOnAddressSpace(addressSpace, variants) {
      if (!variants) {
        return;
      }
      const session = new pseudo_session_1.PseudoSession(addressSpace);
      const extraDataTypeManager = await (0, ensure_datatype_extracted_1.ensureDatatypeExtracted)(addressSpace);
      if (variants instanceof node_opcua_variant_1.Variant) {
        await (0, node_opcua_client_dynamic_extension_object_1.resolveDynamicExtensionObject)(session, variants, extraDataTypeManager);
        return;
      }
      for (const variant of variants) {
        if (variant) {
          await (0, node_opcua_client_dynamic_extension_object_1.resolveDynamicExtensionObject)(session, variant, extraDataTypeManager);
        }
      }
    }
    exports2.resolveOpaqueOnAddressSpace = resolveOpaqueOnAddressSpace;
  }
});

// node_modules/node-opcua-address-space/dist/source/helpers/call_helpers.js
var require_call_helpers = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/helpers/call_helpers.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.callMethodHelper = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_status_code_1 = require_dist22();
    var argument_list_1 = require_argument_list();
    var resolve_opaque_on_address_space_1 = require_resolve_opaque_on_address_space();
    function callMethodHelper(context, addressSpace, callMethodRequest, callback) {
      const objectId = callMethodRequest.objectId;
      const methodId = callMethodRequest.methodId;
      const inputArguments = callMethodRequest.inputArguments || [];
      (0, node_opcua_assert_1.assert)(objectId instanceof node_opcua_nodeid_1.NodeId);
      (0, node_opcua_assert_1.assert)(methodId instanceof node_opcua_nodeid_1.NodeId);
      const object = addressSpace.findNode(objectId);
      if (!object) {
        return callback(null, { statusCode: node_opcua_status_code_1.StatusCodes.BadNodeIdUnknown });
      }
      if (object.nodeClass !== node_opcua_data_model_1.NodeClass.Object && object.nodeClass !== node_opcua_data_model_1.NodeClass.ObjectType) {
        return callback(null, { statusCode: node_opcua_status_code_1.StatusCodes.BadNodeIdInvalid });
      }
      const methodObj = addressSpace.findNode(methodId);
      if (!methodObj) {
        return callback(null, { statusCode: node_opcua_status_code_1.StatusCodes.BadMethodInvalid });
      }
      if (methodObj.nodeClass !== node_opcua_data_model_1.NodeClass.Method) {
        return callback(null, { statusCode: node_opcua_status_code_1.StatusCodes.BadMethodInvalid });
      }
      const response1 = (0, argument_list_1.getMethodDeclaration_ArgumentList)(addressSpace, objectId, methodId);
      if (response1.statusCode.isNotGood()) {
        return callback(null, { statusCode: response1.statusCode });
      }
      const methodDeclaration = response1.methodDeclaration;
      const methodInputArguments = methodDeclaration.getInputArguments();
      const response = (0, argument_list_1.verifyArguments_ArgumentList)(addressSpace, methodInputArguments, inputArguments);
      if (response.statusCode.isNotGood()) {
        return callback(null, response);
      }
      (0, resolve_opaque_on_address_space_1.resolveOpaqueOnAddressSpace)(addressSpace, inputArguments).then(() => {
        methodObj.execute(object, inputArguments, context, (err, callMethodResponse) => {
          if (err) {
            return callback(err);
          }
          if (!callMethodResponse) {
            return callback(new Error("internal Error"));
          }
          callMethodResponse.inputArgumentResults = callMethodResponse.inputArgumentResults || response.inputArgumentResults || [];
          (0, node_opcua_assert_1.assert)(callMethodResponse.statusCode);
          if (callMethodResponse.statusCode?.isGood()) {
            (0, node_opcua_assert_1.assert)(Array.isArray(callMethodResponse.outputArguments));
          }
          (0, node_opcua_assert_1.assert)(Array.isArray(callMethodResponse.inputArgumentResults));
          (0, node_opcua_assert_1.assert)(callMethodResponse.inputArgumentResults.length === methodInputArguments.length);
          const outputArguments = callMethodResponse.outputArguments || [];
          (0, resolve_opaque_on_address_space_1.resolveOpaqueOnAddressSpace)(addressSpace, outputArguments).then(() => callback(null, callMethodResponse)).catch(callback);
        });
      }).catch((err) => callback(err));
    }
    exports2.callMethodHelper = callMethodHelper;
  }
});

// node_modules/node-opcua-address-space/dist/source/pseudo_session.js
var require_pseudo_session = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/pseudo_session.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PseudoSession = exports2.innerBrowseNext = exports2.innerBrowse = void 0;
    var util_1 = require("util");
    var async_1 = __importDefault3(require_async());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_pseudo_session_1 = require_dist55();
    var node_opcua_service_browse_1 = require_dist37();
    var node_opcua_service_call_1 = require_dist41();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_basic_types_1 = require_dist23();
    var continuation_point_manager_1 = require_continuation_point_manager();
    var call_helpers_1 = require_call_helpers();
    var session_context_1 = require_session_context2();
    var errorLog = (0, node_opcua_debug_1.make_errorLog)("PseudoSession");
    function coerceBrowseDescription(browseDescription) {
      if (typeof browseDescription === "string") {
        return coerceBrowseDescription({
          nodeId: (0, node_opcua_nodeid_1.resolveNodeId)(browseDescription)
        });
      } else if (browseDescription instanceof node_opcua_service_browse_1.BrowseDescription) {
        return browseDescription;
      } else {
        return new node_opcua_service_browse_1.BrowseDescription(browseDescription);
      }
    }
    function innerBrowse(engine, nodesToBrowse, callback) {
      engine.browseAll(nodesToBrowse, (err, results) => {
        if (err || !results) {
          return callback(err);
        }
        results = results.map((result2, index) => {
          (0, node_opcua_assert_1.assert)(!result2.continuationPoint);
          if (!engine.continuationPointManager) {
            return new node_opcua_service_browse_1.BrowseResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadNoContinuationPoints });
          }
          if (engine.continuationPointManager.hasReachedMaximum(engine.maxBrowseContinuationPoints)) {
            return new node_opcua_service_browse_1.BrowseResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadNoContinuationPoints });
          }
          const truncatedResult = engine.continuationPointManager.registerReferences(engine.requestedMaxReferencesPerNode, result2.references || [], { continuationPoint: null });
          let { statusCode } = truncatedResult;
          const { continuationPoint, values } = truncatedResult;
          (0, node_opcua_assert_1.assert)(statusCode.isGood() || statusCode.equals(node_opcua_status_code_1.StatusCodes.GoodNoData));
          statusCode = result2.statusCode;
          return new node_opcua_service_browse_1.BrowseResult({
            statusCode,
            continuationPoint,
            references: values
          });
        });
        callback(null, results);
      });
    }
    exports2.innerBrowse = innerBrowse;
    function innerBrowseNext(engine, continuationPoints, releaseContinuationPoints, callback) {
      const results = continuationPoints.map((continuationPoint, index) => {
        return engine.continuationPointManager.getNextReferences(0, {
          continuationPoint,
          releaseContinuationPoints
        });
      }).map((r) => new node_opcua_service_browse_1.BrowseResult({
        statusCode: r.statusCode,
        continuationPoint: r.continuationPoint,
        references: r.values
      }));
      callback(null, results);
    }
    exports2.innerBrowseNext = innerBrowseNext;
    var $addressSpace = Symbol("addressSpace");
    var $context = Symbol("context");
    var PseudoSession = class {
      constructor(addressSpace, context) {
        this.requestedMaxReferencesPerNode = 0;
        this.maxBrowseContinuationPoints = 0;
        this._sessionId = new node_opcua_nodeid_1.NodeId(node_opcua_nodeid_1.NodeIdType.GUID, (0, node_opcua_basic_types_1.randomGuid)());
        this[$addressSpace] = addressSpace;
        this[$context] = context || session_context_1.SessionContext.defaultContext;
        this.continuationPointManager = new continuation_point_manager_1.ContinuationPointManager();
      }
      getSessionId() {
        return this._sessionId;
      }
      browse(nodesToBrowse, callback) {
        const isArray = Array.isArray(nodesToBrowse);
        if (!isArray) {
          return this.browse([nodesToBrowse], (err, results) => {
            return callback(err, results ? results[0] : void 0);
          });
        }
        const browseAll = (nodesToBrowse2, callack) => {
          const results = [];
          for (const browseDescription of nodesToBrowse2) {
            browseDescription.referenceTypeId = (0, node_opcua_nodeid_1.resolveNodeId)(browseDescription.referenceTypeId);
            const _browseDescription = coerceBrowseDescription(browseDescription);
            const nodeId = (0, node_opcua_nodeid_1.resolveNodeId)(_browseDescription.nodeId);
            const r = this[$addressSpace].browseSingleNode(nodeId, _browseDescription, this[$context]);
            results.push(r);
          }
          callack(null, results);
        };
        setImmediate(() => {
          innerBrowse({
            browseAll,
            context: this[$context],
            continuationPointManager: this.continuationPointManager,
            requestedMaxReferencesPerNode: this.requestedMaxReferencesPerNode,
            maxBrowseContinuationPoints: this.maxBrowseContinuationPoints
          }, nodesToBrowse, callback);
        });
      }
      read(nodesToRead, callback) {
        const isArray = Array.isArray(nodesToRead);
        if (!isArray) {
          nodesToRead = [nodesToRead];
        }
        const _nodesToRead = nodesToRead;
        const context = this[$context];
        setImmediate(() => {
          async_1.default.map(_nodesToRead, (nodeToRead, innerCallback) => {
            const obj = this[$addressSpace].findNode(nodeToRead.nodeId);
            if (!obj || obj.nodeClass !== node_opcua_data_model_1.NodeClass.Variable || nodeToRead.attributeId !== node_opcua_data_model_1.AttributeIds.Value) {
              return innerCallback();
            }
            obj.readValueAsync(context, innerCallback);
          }, (err) => {
            const dataValues = _nodesToRead.map((nodeToRead) => {
              (0, node_opcua_assert_1.assert)(!!nodeToRead.nodeId, "expecting a nodeId");
              (0, node_opcua_assert_1.assert)(!!nodeToRead.attributeId, "expecting a attributeId");
              const nodeId = nodeToRead.nodeId;
              const attributeId = nodeToRead.attributeId;
              const indexRange = nodeToRead.indexRange;
              const dataEncoding = nodeToRead.dataEncoding;
              const obj = this[$addressSpace].findNode(nodeId);
              if (!obj) {
                return new node_opcua_data_value_1.DataValue({ statusCode: node_opcua_status_code_1.StatusCodes.BadNodeIdUnknown });
              }
              const context2 = this[$context];
              const dataValue = obj.readAttribute(context2, attributeId, indexRange, dataEncoding);
              return dataValue;
            });
            callback(null, isArray ? dataValues : dataValues[0]);
          });
        });
      }
      browseNext(continuationPoints, releaseContinuationPoints, callback) {
        setImmediate(() => {
          if (continuationPoints instanceof Buffer) {
            return this.browseNext([continuationPoints], releaseContinuationPoints, (err, _results) => {
              if (err) {
                return callback(err);
              }
              callback(null, _results[0]);
            });
          }
          innerBrowseNext({ continuationPointManager: this.continuationPointManager }, continuationPoints, releaseContinuationPoints, callback);
        });
      }
      call(methodsToCall, callback) {
        const isArray = Array.isArray(methodsToCall);
        if (!isArray) {
          methodsToCall = [methodsToCall];
        }
        async_1.default.map(methodsToCall, (methodToCall, innerCallback) => {
          const callMethodRequest = new node_opcua_service_call_1.CallMethodRequest(methodToCall);
          (0, call_helpers_1.callMethodHelper)(this[$context], this[$addressSpace], callMethodRequest, (err, result2) => {
            let callMethodResult;
            if (err) {
              errorLog("Internal Error = ", err);
              callMethodResult = new node_opcua_service_call_1.CallMethodResult({
                statusCode: node_opcua_status_code_1.StatusCodes.BadInternalError
              });
            } else {
              callMethodResult = new node_opcua_service_call_1.CallMethodResult(result2);
            }
            innerCallback(null, callMethodResult);
          });
        }, (err, callMethodResults) => {
          callback(null, isArray ? callMethodResults : callMethodResults[0]);
        });
      }
      getArgumentDefinition(methodId, callback) {
        (0, node_opcua_pseudo_session_1.getArgumentDefinitionHelper)(this, methodId).then((result2) => {
          callback(null, result2);
        }).catch((err) => {
          callback(err);
        });
      }
      translateBrowsePath(browsePaths, callback) {
        const isArray = Array.isArray(browsePaths);
        if (!isArray) {
          browsePaths = [browsePaths];
        }
        const browsePathResults = browsePaths.map((browsePath) => {
          return this[$addressSpace].browsePath(browsePath);
        });
        callback(null, isArray ? browsePathResults : browsePathResults[0]);
      }
      write(nodesToWrite, callback) {
        const isArray = nodesToWrite instanceof Array;
        const _nodesToWrite = !isArray ? [nodesToWrite] : nodesToWrite;
        const context = this[$context];
        setImmediate(() => {
          const statusCodesPromises = _nodesToWrite.map((nodeToWrite) => {
            (0, node_opcua_assert_1.assert)(!!nodeToWrite.nodeId, "expecting a nodeId");
            (0, node_opcua_assert_1.assert)(!!nodeToWrite.attributeId, "expecting a attributeId");
            const nodeId = nodeToWrite.nodeId;
            const obj = this[$addressSpace].findNode(nodeId);
            if (!obj) {
              return node_opcua_status_code_1.StatusCodes.BadNodeIdUnknown;
            }
            try {
              return (0, util_1.promisify)(obj.writeAttribute).call(obj, context, nodeToWrite);
            } catch (err) {
              return node_opcua_status_code_1.StatusCodes.BadInternalError;
            }
          });
          Promise.all(statusCodesPromises).then((statusCodes) => {
            callback(null, isArray ? statusCodes : statusCodes[0]);
          }).catch((err) => {
            callback(err);
          });
        });
      }
    };
    exports2.PseudoSession = PseudoSession;
    var thenify = require_thenify();
    PseudoSession.prototype.read = thenify.withCallback(PseudoSession.prototype.read);
    PseudoSession.prototype.write = thenify.withCallback(PseudoSession.prototype.write);
    PseudoSession.prototype.browse = thenify.withCallback(PseudoSession.prototype.browse);
    PseudoSession.prototype.browseNext = thenify.withCallback(PseudoSession.prototype.browseNext);
    PseudoSession.prototype.getArgumentDefinition = thenify.withCallback(PseudoSession.prototype.getArgumentDefinition);
    PseudoSession.prototype.call = thenify.withCallback(PseudoSession.prototype.call);
    PseudoSession.prototype.translateBrowsePath = thenify.withCallback(PseudoSession.prototype.translateBrowsePath);
  }
});

// node_modules/node-opcua-address-space/dist/source/helpers/ensure_secure_access.js
var require_ensure_secure_access = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/helpers/ensure_secure_access.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ensureObjectIsSecure = void 0;
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_types_1 = require_dist32();
    var session_context_1 = require_session_context2();
    var restrictedPermissions = [
      { roleId: session_context_1.WellKnownRoles.SecurityAdmin, permissions: node_opcua_data_model_1.allPermissions },
      { roleId: session_context_1.WellKnownRoles.ConfigureAdmin, permissions: node_opcua_data_model_1.allPermissions },
      { roleId: session_context_1.WellKnownRoles.Supervisor, permissions: node_opcua_data_model_1.allPermissions },
      { roleId: session_context_1.WellKnownRoles.Operator, permissions: (0, node_opcua_data_model_1.makePermissionFlag)("Browse") },
      { roleId: session_context_1.WellKnownRoles.Engineer, permissions: (0, node_opcua_data_model_1.makePermissionFlag)("Browse") },
      { roleId: session_context_1.WellKnownRoles.Observer, permissions: (0, node_opcua_data_model_1.makePermissionFlag)("Browse") }
      /*
          { roleId: WellKnownRoles.Anonymous, permissions: makePermissionFlag("Browse") },
          { roleId: WellKnownRoles.AuthenticatedUser, permissions: makePermissionFlag("Browse") },
      */
    ];
    var restrictedAccessFlag = (0, node_opcua_data_model_1.makeAccessRestrictionsFlag)("SigningRequired | EncryptionRequired");
    function ensureObjectIsSecure(node) {
      node.setAccessRestrictions(restrictedAccessFlag);
      if (node.nodeClass === node_opcua_data_model_1.NodeClass.Variable) {
        const variable = node;
        variable.setRolePermissions(restrictedPermissions);
      }
      if (node.nodeClass === node_opcua_data_model_1.NodeClass.Method) {
        const method = node;
        method.setRolePermissions(restrictedPermissions);
      }
      if (node.nodeClass === node_opcua_data_model_1.NodeClass.Object) {
        const object = node;
        object.setRolePermissions(restrictedPermissions);
      }
      const children = node.findReferencesExAsObject("Aggregates", node_opcua_data_model_1.BrowseDirection.Forward);
      for (const child of children) {
        ensureObjectIsSecure(child);
      }
    }
    exports2.ensureObjectIsSecure = ensureObjectIsSecure;
  }
});

// node_modules/node-opcua-address-space/dist/src/nodeset_tools/adjust_namespace_array.js
var require_adjust_namespace_array = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/nodeset_tools/adjust_namespace_array.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.adjustNamespaceArray = void 0;
    function adjustNamespaceArray(addressSpace) {
      const namepsaceArrayVar = addressSpace.findNode("Server_NamespaceArray");
      if (namepsaceArrayVar) {
        namepsaceArrayVar.setValueFromSource({
          dataType: "String",
          value: addressSpace.getNamespaceArray().map((n) => n.namespaceUri)
        });
      }
    }
    exports2.adjustNamespaceArray = adjustNamespaceArray;
  }
});

// node_modules/node-opcua-address-space/dist/source/loader/make_xml_extension_object_parser.js
var require_make_xml_extension_object_parser = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/loader/make_xml_extension_object_parser.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.makeXmlExtensionObjectReader = void 0;
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_xml2json_1 = require_source2();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var qualifiedNameReader = {
      init() {
        this.qualifiedName = {};
        this.value = {};
      },
      parser: {
        Name: {
          finish() {
            this.parent.qualifiedName.name = this.text.trim();
          }
        },
        NamespaceIndex: {
          finish() {
            const ns = parseInt(this.text, 10);
            this.parent.qualifiedName.namespaceIndex = ns;
          }
        }
      },
      finish() {
        this.value = this.qualifiedName;
        this.value.name = "qdqsdqs";
      }
    };
    var localizedTextReader = {
      init() {
        this.localizedText = {};
      },
      parser: {
        Locale: {
          finish() {
            this.parent.localizedText = this.parent.localizedText || {};
            this.parent.localizedText.locale = this.text.trim();
          }
        },
        Text: {
          finish() {
            this.parent.localizedText = this.parent.localizedText || {};
            this.parent.localizedText.text = this.text.trim();
          }
        }
      },
      finish() {
        this.value = this.localizedText;
      }
    };
    function clamp(value, minValue, maxValue) {
      if (value < minValue) {
        warningLog(`invalid value range : ${value} < ${minValue} but should be [${minValue} , ${maxValue}]`);
        return minValue;
      }
      if (value > maxValue) {
        warningLog(`invalid value range : ${value} > ${maxValue} but should be [${minValue} , ${maxValue}]`);
        return maxValue;
      }
      return value;
    }
    var partials = {
      LocalizedText: localizedTextReader,
      QualifiedName: qualifiedNameReader,
      String: {
        finish() {
          this.value = this.text;
        }
      },
      Guid: {
        parser: {
          String: {
            finish() {
              this.parent.value = this.text;
            }
          }
        }
      },
      Boolean: {
        finish() {
          this.value = this.text.toLowerCase() === "true" ? true : false;
        }
      },
      ByteString: {
        init() {
          this.value = null;
        },
        finish() {
          const base64text = this.text;
          const byteString = Buffer.from(base64text, "base64");
          this.value = byteString;
        }
      },
      Float: {
        finish() {
          this.value = parseFloat(this.text);
        }
      },
      Double: {
        finish() {
          this.value = parseFloat(this.text);
        }
      },
      Byte: {
        finish() {
          this.value = clamp(parseInt(this.text, 10), 0, 255);
        }
      },
      SByte: {
        finish() {
          this.value = clamp(parseInt(this.text, 10), -128, 127);
        }
      },
      Int8: {
        finish() {
          this.value = clamp(parseInt(this.text, 10), -128, 127);
        }
      },
      Int16: {
        finish() {
          this.value = clamp(parseInt(this.text, 10), -32768, 32767);
        }
      },
      Int32: {
        finish() {
          this.value = clamp(parseInt(this.text, 10), -2147483648, 2147483647);
        }
      },
      Int64: {
        finish() {
          this.value = (0, node_opcua_basic_types_1.coerceInt64)(parseInt(this.text, 10));
        }
      },
      UInt8: {
        finish() {
          this.value = clamp(parseInt(this.text, 10), 0, 255);
        }
      },
      UInt16: {
        finish() {
          this.value = clamp(parseInt(this.text, 10), 0, 65535);
        }
      },
      UInt32: {
        finish() {
          this.value = clamp(parseInt(this.text, 10), 0, 4294967295);
        }
      },
      UInt64: {
        finish() {
          this.value = (0, node_opcua_basic_types_1.coerceUInt64)(parseInt(this.text, 10));
        }
      },
      DateTime: {
        finish() {
          this.value = new Date(this.text);
        }
      },
      Variant: {
        finish() {
          warningLog(" Missing  Implemntation contact sterfive.com!");
        }
      },
      NodeId: {
        finish() {
          this.value = (0, node_opcua_nodeid_1.coerceNodeId)(this.text);
        }
      }
    };
    function _clone(a) {
      if (typeof a === "string" || typeof a === "number" || typeof a === "boolean") {
        return a;
      }
      if (a instanceof Buffer) {
        return Buffer.from(a);
      }
      if (a instanceof Date) {
        return new Date(a);
      }
      if (a instanceof Array) {
        return a.map((x2) => _clone(x2));
      }
      return { ...a };
    }
    function _makeTypeReader(dataTypeNodeId1, definitionMap, readerMap) {
      const n = dataTypeNodeId1;
      if (n.identifierType === node_opcua_nodeid_1.NodeIdType.NUMERIC && n.namespace === 0 && n.value === 0) {
        return { name: "Variant", parser: partials["Variant"] };
      }
      if (n.namespace === 0 && n.identifierType === node_opcua_nodeid_1.NodeIdType.NUMERIC && n.value < node_opcua_variant_1.DataType.ExtensionObject) {
        const name2 = node_opcua_variant_1.DataType[n.value];
        const parser = partials[name2];
        return { name: name2, parser };
      }
      const { name, definition } = definitionMap.findDefinition(n);
      const dataTypeName = name;
      let reader = readerMap[dataTypeName];
      if (reader) {
        return { name, parser: reader.parser };
      }
      reader = {
        finish() {
        },
        parser: {}
      };
      if (definition instanceof node_opcua_types_1.StructureDefinition) {
        for (const field of definition.fields || []) {
          const typeReader = _makeTypeReader(field.dataType, definitionMap, readerMap);
          const fieldParser = typeReader.parser;
          const fieldTypename = typeReader.name;
          if (!fieldParser) {
            throw new Error(" Cannot find reader for dataType " + field.dataType + " fieldTypename=" + fieldTypename);
          }
          if (field.valueRank === void 0 || field.valueRank === -1) {
            const parser = fieldParser;
            if (!parser) {
              throw new Error("??? " + field.dataType + "  " + field.name);
            }
            reader.parser[field.name] = {
              parser: fieldParser.parser,
              // endElement: fieldReader.endElement,
              finish() {
                const elName = (0, node_opcua_utils_1.lowerFirstLetter)(field.name);
                if (fieldParser.finish) {
                  fieldParser.finish.call(this);
                } else {
                  debugLog("xxx check " + fieldTypename);
                }
                this.parent.value = this.parent.value || {};
                this.parent.value[elName] = _clone(this.value);
              }
            };
          } else if (field.valueRank === 1) {
            const listReader = {
              init() {
                this.value = [];
              },
              parser: {},
              finish() {
                const elName = (0, node_opcua_utils_1.lowerFirstLetter)(this.name);
                this.parent.value = this.parent.value || {};
                this.parent.value[elName] = this.value;
                this.value = void 0;
              },
              startElement(name2, attrs) {
              },
              endElement(element) {
                this.value.push(_clone(this.parser[element].value));
              }
            };
            listReader.parser[fieldTypename] = fieldParser;
            reader.parser[field.name] = listReader;
          } else {
            throw new Error("Unsupported ValueRank !");
          }
        }
        readerMap[dataTypeName] = reader;
        return { name, parser: reader };
      } else if (definition instanceof node_opcua_types_1.EnumDefinition) {
        const turnToInt = (value) => {
          return parseInt(value.split("_")[1], 10);
        };
        return {
          name,
          parser: {
            finish() {
              this.value = turnToInt(this.text);
            }
          }
        };
      } else {
        const typeName = node_opcua_variant_1.DataType[definition.dataType];
        const parser = partials[typeName];
        if (!parser) {
          throw new Error("missing parse for " + typeName);
        }
        return { name, parser };
      }
    }
    function makeXmlExtensionObjectReader(dataTypeNodeId, definitionMap, readerMap) {
      const { name, definition } = definitionMap.findDefinition(dataTypeNodeId);
      if (!(definition instanceof node_opcua_types_1.StructureDefinition)) {
        throw new Error("Expecting StructureDefinition");
      }
      const reader1 = {
        parser: {},
        endElement() {
          this._pojo = this.parser[name].value;
        }
      };
      const { parser } = _makeTypeReader(dataTypeNodeId, definitionMap, readerMap);
      reader1.parser[name] = parser;
      return new node_opcua_xml2json_1.ReaderState(reader1);
    }
    exports2.makeXmlExtensionObjectReader = makeXmlExtensionObjectReader;
  }
});

// node_modules/node-opcua-address-space/dist/source/loader/decode_xml_extension_object.js
var require_decode_xml_extension_object = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/loader/decode_xml_extension_object.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.decodeXmlExtensionObject = exports2.makeDefinitionMap = void 0;
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_xml2json_1 = require_source2();
    var make_xml_extension_object_parser_1 = require_make_xml_extension_object_parser();
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    function encodingNodeIdToDataTypeNode(addressSpace, encodingNodeId) {
      const encodingNode = addressSpace.findNode(encodingNodeId);
      if (!encodingNode) {
        throw new Error("findDataTypeNode:  Cannot find encoding NodeId" + encodingNodeId.toString());
      }
      const refs = encodingNode.findReferences("HasEncoding", false);
      const dataTypes = refs.map((ref) => addressSpace.findNode(ref.nodeId)).filter((obj) => obj !== null);
      if (dataTypes.length !== 1) {
        throw new Error("Internal Error");
      }
      const dataTypeNode = dataTypes[0];
      return dataTypeNode;
    }
    function makeDefinitionMap(addressSpace) {
      return {
        findDefinition(dataTypeNodeId) {
          const dataTypeNode = addressSpace.findDataType(dataTypeNodeId);
          if (!dataTypeNode) {
            throw new Error("findDefinition: cannot find dataType " + dataTypeNodeId.toString());
          }
          if (dataTypeNode.nodeClass !== node_opcua_types_1.NodeClass.DataType) {
            throw new Error("Expecting a DataType node here");
          }
          const name = dataTypeNode.browseName.name || "";
          if (dataTypeNode.isStructure()) {
            const definition = dataTypeNode.getStructureDefinition();
            return { name, definition };
          } else if (dataTypeNode.isEnumeration()) {
            const definition = dataTypeNode.getEnumDefinition();
            return { name, definition };
          } else {
            const dataType = dataTypeNode.getBasicDataType();
            return { name, definition: { dataType } };
          }
        }
      };
    }
    exports2.makeDefinitionMap = makeDefinitionMap;
    function decodeXmlExtensionObject(addressSpace, encodingNodeId, xmlBody) {
      const definitionMap = makeDefinitionMap(addressSpace);
      const dataType = encodingNodeIdToDataTypeNode(addressSpace, encodingNodeId);
      const reader = (0, make_xml_extension_object_parser_1.makeXmlExtensionObjectReader)(dataType.nodeId, definitionMap, {});
      const parser2 = new node_opcua_xml2json_1.Xml2Json(reader);
      const pojo = parser2.parseStringSync(xmlBody);
      const userDefinedExtensionObject = addressSpace.constructExtensionObject(dataType, pojo);
      if (doDebug) {
        debugLog("userDefinedExtensionObject", userDefinedExtensionObject.toString());
      }
      return userDefinedExtensionObject;
    }
    exports2.decodeXmlExtensionObject = decodeXmlExtensionObject;
  }
});

// node_modules/node-opcua-address-space/dist/source/loader/make_semver_compatible.js
var require_make_semver_compatible = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/loader/make_semver_compatible.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.makeSemverCompatible = void 0;
    function makeSemverCompatible(version) {
      version = version || "0.0.0";
      const matches = version.match(/[0-9]+(\.[0-9]+(\.[0-9]+)?)?/);
      if (!matches) {
        return "0.0.0";
      }
      version = matches[0];
      const version_array = version.split(".").map((a) => parseInt(a, 10));
      if (version_array.length === 1) {
        version_array.push(0);
      }
      if (version_array.length === 2) {
        version_array.push(0);
      }
      return version_array.map((a) => a.toString()).join(".");
    }
    exports2.makeSemverCompatible = makeSemverCompatible;
  }
});

// node_modules/node-opcua-address-space/dist/source/loader/load_nodeset2.js
var require_load_nodeset2 = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/loader/load_nodeset2.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NodeSetLoader = void 0;
    var util_1 = require("util");
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_basic_types_2 = require_dist23();
    var node_opcua_data_access_1 = require_dist35();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_extension_object_1 = require_dist30();
    var node_opcua_factory_1 = require_dist26();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_service_call_1 = require_dist41();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_xml2json_1 = require_source2();
    var semver_1 = __importDefault3(require_semver2());
    var namespace_post_step_1 = require_namespace_post_step();
    var ensure_datatype_extracted_1 = require_ensure_datatype_extracted();
    var decode_xml_extension_object_1 = require_decode_xml_extension_object();
    var make_semver_compatible_1 = require_make_semver_compatible();
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    function __make_back_references(namespace) {
      const namespaceP = namespace;
      for (const node of namespaceP.nodeIterator()) {
        node.propagate_back_references();
      }
      for (const node of namespaceP.nodeIterator()) {
        node.install_extra_properties();
      }
    }
    function make_back_references(addressSpace) {
      const addressSpacePrivate = addressSpace;
      addressSpacePrivate.suspendBackReference = false;
      addressSpace.getNamespaceArray().map(__make_back_references);
    }
    function stringToUInt32Array(str) {
      const array = str ? str.split(",").map((value) => parseInt(value, 10)) : null;
      return array;
    }
    function convertAccessLevel(accessLevel) {
      const accessLevelN = parseInt(accessLevel || "1", 10);
      return (0, node_opcua_data_model_1.makeAccessLevelFlag)(accessLevelN);
    }
    function makeDefaultVariant(addressSpace, dataTypeNode, valueRank, arrayDimensions) {
      let variant = { dataType: node_opcua_variant_1.DataType.Null };
      const nodeDataType = addressSpace.findNode(dataTypeNode);
      if (nodeDataType && nodeDataType.basicDataType) {
        const basicDataType = nodeDataType.basicDataType;
        if (basicDataType === node_opcua_variant_1.DataType.Variant) {
          return void 0;
        }
        if (basicDataType === node_opcua_variant_1.DataType.ExtensionObject) {
          return { dataType: node_opcua_variant_1.DataType.ExtensionObject, value: null };
        }
        const builtInType = (0, node_opcua_factory_1.getBuiltInType)(node_opcua_variant_1.DataType[basicDataType]);
        if (builtInType === void 0 || builtInType === null) {
          errorLog("Cannot find builtInType for ", basicDataType);
          return { dataType: node_opcua_variant_1.DataType.Null };
        }
        const dv = builtInType.defaultValue;
        const value = typeof dv === "function" ? dv() : dv;
        let arrayType;
        switch (valueRank) {
          case -3:
          case -2:
          case -1:
            arrayType = node_opcua_variant_1.VariantArrayType.Scalar;
            variant = { dataType: basicDataType, value, arrayType };
            break;
          case 0:
          case 1:
            arrayType = node_opcua_variant_1.VariantArrayType.Array;
            variant = { dataType: basicDataType, value: [], arrayType };
            break;
          default:
            arrayType = node_opcua_variant_1.VariantArrayType.Matrix;
            variant = { dataType: basicDataType, value: [], arrayType, dimensions: arrayDimensions };
            break;
        }
      }
      return variant;
    }
    function makeNodeSetParserEngine(addressSpace, options) {
      const addressSpace1 = addressSpace;
      addressSpace1.suspendBackReference = true;
      options.loadDeprecatedNodes = options.loadDeprecatedNodes === void 0 ? true : options.loadDeprecatedNodes;
      options.loadDraftNodes = options.loadDraftNodes || false;
      const postTasks = [];
      const postTasks0_InitializeVariable = [];
      const postTasks0_DecodePojoString = [];
      const postTasks1_InitializeVariable = [];
      const postTasks2_AssignedExtensionObjectToDataValue = [];
      let alias_map = {};
      function addAlias(aliasName, nodeIdInXmlContext) {
        (0, node_opcua_assert_1.assert)(typeof nodeIdInXmlContext === "string");
        const nodeId = _translateNodeId(nodeIdInXmlContext);
        (0, node_opcua_assert_1.assert)(nodeId instanceof node_opcua_nodeid_1.NodeId);
        alias_map[aliasName] = nodeId;
        addressSpace1.getNamespace(nodeId.namespace).addAlias(aliasName, nodeId);
      }
      let namespace_uri_translation = {};
      let namespaceCounter = 0;
      let found_namespace_in_uri = {};
      let models = [];
      let performedCalled = false;
      function _reset_namespace_translation() {
        debugLog("_reset_namespace_translation");
        namespace_uri_translation = {};
        found_namespace_in_uri = {};
        namespaceCounter = 0;
        alias_map = {};
        models = [];
        performedCalled = false;
      }
      function _translateNamespaceIndex(innerIndex) {
        const namespaceIndex = namespace_uri_translation[innerIndex];
        if (namespaceIndex === void 0) {
          errorLog("Warning: namespace_uri_translation = ", namespace_uri_translation);
          errorLog("Error; namespace_uri_translation", namespace_uri_translation);
          throw new Error("_translateNamespaceIndex() ! Cannot find namespace definition for index " + innerIndex);
        }
        return namespaceIndex;
      }
      function _internal_addReferenceType(params) {
        if (!(params.nodeId instanceof node_opcua_nodeid_1.NodeId)) {
          throw new Error("invalid param");
        }
        const namespace = addressSpace1.getNamespace(params.nodeId.namespace);
        namespace.addReferenceType(params);
      }
      function _internal_createNode(params) {
        if (!(params.nodeId instanceof node_opcua_nodeid_1.NodeId)) {
          throw new Error("invalid param expecting a valid nodeId");
        }
        const namespace = addressSpace1.getNamespace(params.nodeId.namespace);
        return namespace.internalCreateNode(params);
      }
      function _register_namespace_uri_in_translation_table(namespaceUri) {
        if (found_namespace_in_uri[namespaceUri]) {
          return;
        }
        const namespace = addressSpace1.getNamespace(namespaceUri);
        if (!namespace) {
          throw new Error("cannot find namespace for " + namespaceUri + "\nplease make sure to initialize your address space with the corresponding nodeset files");
        }
        found_namespace_in_uri[namespaceUri] = namespace;
        const index_in_xml = namespaceCounter;
        namespaceCounter++;
        namespace_uri_translation[index_in_xml] = namespace.index;
        doDebug && debugLog(" _register_namespace_uri = ", namespaceUri, "index in Xml=", index_in_xml, " index in addressSpace", namespace.index);
      }
      function _add_namespace(model) {
        if (model.requiredModels.length > 0) {
          for (const requiredModel of model.requiredModels) {
            const existingNamespace2 = addressSpace1.getNamespace(requiredModel.modelUri);
            if (!existingNamespace2) {
              errorLog("Please ensure that the required namespace", requiredModel.modelUri, "is loaded first when loading", model.modelUri);
              throw new Error("LoadNodeSet : Cannot find namespace for " + requiredModel.modelUri);
            }
            const isLowerVersion = (existingVersion, requiredVersion) => {
              const existingSemver = (0, make_semver_compatible_1.makeSemverCompatible)(existingVersion);
              const requiredSemver = (0, make_semver_compatible_1.makeSemverCompatible)(requiredVersion);
              return semver_1.default.lt(existingSemver, requiredSemver);
            };
            if (isLowerVersion(existingNamespace2.version, requiredModel.version)) {
              errorLog("Expecting ", requiredModel.modelUri, " with version to be at least", requiredModel.version, " but namespace version is ", existingNamespace2.version);
            }
            if (existingNamespace2.publicationDate.getTime() < requiredModel.publicationDate.getTime()) {
              errorLog("Expecting ", requiredModel.modelUri, " with publicationDate at least ", requiredModel.publicationDate.toUTCString(), " but namespace publicationDate is ", existingNamespace2.publicationDate.toUTCString());
            }
          }
        }
        let namespace;
        const existingNamespace = addressSpace1.getNamespace(model.modelUri);
        if (existingNamespace) {
          namespace = existingNamespace;
        } else {
          namespace = addressSpace1.registerNamespace(model.modelUri);
          namespace.setRequiredModels(model.requiredModels);
        }
        namespace.version = model.version;
        namespace.publicationDate = model.publicationDate || namespace.publicationDate;
        return namespace;
      }
      const reg = /ns=([0-9]+);(.*)/;
      function _translateNodeId(nodeId) {
        if (alias_map[nodeId]) {
          return alias_map[nodeId];
        }
        const m2 = nodeId.match(reg);
        if (m2) {
          const namespaceIndex = _translateNamespaceIndex(parseInt(m2[1], 10));
          nodeId = "ns=" + namespaceIndex + ";" + m2[2];
        }
        return (0, node_opcua_nodeid_1.resolveNodeId)(nodeId);
      }
      function _translateReferenceType(refType) {
        return _translateNodeId(refType);
      }
      function convertToNodeId(nodeIdLike) {
        if (!nodeIdLike) {
          return null;
        }
        const nodeId = _translateNodeId(nodeIdLike);
        return addressSpace1.resolveNodeId(nodeId);
      }
      function convertQualifiedName(qualifiedName) {
        const qn = (0, node_opcua_data_model_1.stringToQualifiedName)(qualifiedName);
        qn.namespaceIndex = _translateNamespaceIndex(qn.namespaceIndex);
        return qn;
      }
      const state_Alias = {
        finish() {
          addAlias(this.attrs.Alias, this.text);
        }
      };
      const references_parser = {
        init() {
          this.parent.obj.references = [];
          this.array = this.parent.obj.references;
        },
        parser: {
          Reference: {
            finish() {
              this.parent.array.push({
                isForward: this.attrs.IsForward === void 0 ? true : this.attrs.IsForward === "false" ? false : true,
                nodeId: convertToNodeId(this.text),
                referenceType: _translateReferenceType(this.attrs.ReferenceType)
              });
            }
          }
        }
      };
      const state_UAObject = {
        init(name, attrs) {
          _perform();
          this.obj = {};
          this.obj.nodeClass = node_opcua_data_model_1.NodeClass.Object;
          this.obj.isAbstract = (0, node_opcua_basic_types_1.coerceBoolean)(attrs.IsAbstract);
          this.obj.nodeId = convertToNodeId(attrs.NodeId) || null;
          this.obj.browseName = convertQualifiedName(attrs.BrowseName);
          this.obj.eventNotifier = (0, node_opcua_basic_types_1.coerceByte)(attrs.EventNotifier) || 0;
          this.obj.symbolicName = attrs.SymbolicName || null;
          this.isDraft = attrs.ReleaseStatus === "Draft";
          this.isDeprecated = attrs.ReleaseStatus === "Deprecated";
        },
        finish() {
          if (canIngore({ isDraft: this.isDraft, isDeprecated: this.isDeprecated }, this.obj)) {
            return;
          }
          _internal_createNode(this.obj);
        },
        parser: {
          DisplayName: {
            finish() {
              this.parent.obj.displayName = this.text;
            }
          },
          Description: {
            finish() {
              this.parent.obj.description = this.text;
            }
          },
          References: references_parser
        }
      };
      const state_UAObjectType = {
        init(name, attrs) {
          _perform();
          this.obj = {};
          this.obj.nodeClass = node_opcua_data_model_1.NodeClass.ObjectType;
          this.obj.isAbstract = (0, node_opcua_basic_types_1.coerceBoolean)(attrs.IsAbstract);
          this.obj.nodeId = convertToNodeId(attrs.NodeId) || null;
          this.obj.browseName = convertQualifiedName(attrs.BrowseName);
          this.obj.eventNotifier = (0, node_opcua_basic_types_1.coerceByte)(attrs.EventNotifier) || 0;
        },
        finish() {
          _internal_createNode(this.obj);
        },
        parser: {
          DisplayName: {
            finish() {
              this.parent.obj.displayName = this.text;
            }
          },
          Description: {
            finish() {
              this.parent.obj.description = this.text;
            }
          },
          References: references_parser
        }
      };
      const state_UAReferenceType = {
        init(name, attrs) {
          _perform();
          this.obj = {};
          this.obj.nodeClass = node_opcua_data_model_1.NodeClass.ReferenceType;
          this.obj.isAbstract = (0, node_opcua_basic_types_1.coerceBoolean)(attrs.IsAbstract);
          this.obj.nodeId = convertToNodeId(attrs.NodeId) || null;
          this.obj.browseName = convertQualifiedName(attrs.BrowseName);
        },
        finish() {
          _internal_addReferenceType(this.obj);
        },
        parser: {
          DisplayName: {
            finish() {
              this.parent.obj.displayName = this.text;
            }
          },
          Description: {
            finish() {
              this.parent.obj.description = this.text;
            }
          },
          InverseName: {
            finish() {
              this.parent.obj.inverseName = this.text;
            }
          },
          References: references_parser
        }
      };
      const pendingSimpleTypeToRegister = [];
      const state_UADataType = {
        init(name, attrs) {
          _perform();
          this.obj = {};
          this.obj.nodeClass = node_opcua_data_model_1.NodeClass.DataType;
          this.obj.isAbstract = (0, node_opcua_basic_types_1.coerceBoolean)(attrs.IsAbstract) || false;
          this.obj.nodeId = convertToNodeId(attrs.NodeId) || null;
          this.obj.browseName = convertQualifiedName(attrs.BrowseName);
          this.obj.displayName = "";
          this.obj.description = "";
          this.obj.symbolicName = attrs.SymbolicName;
          this.isDraft = attrs.ReleaseStatus === "Draft";
          this.isDeprecated = attrs.ReleaseStatus === "Deprecated";
          this.definitionFields = [];
        },
        finish() {
          if (canIngore({ isDraft: this.isDraft, isDeprecated: this.isDeprecated }, this.obj)) {
            return;
          }
          const definitionFields = this.definitionFields;
          definitionFields.map((x2) => {
            if (x2.description) {
              x2.description = { text: x2.description };
            }
            if (x2.displayName) {
              x2.displayName = { text: x2.displayName };
            }
            if (x2.dataType) {
              x2.dataType = convertToNodeId(x2.dataType);
            }
            return x2;
          });
          this.obj.partialDefinition = definitionFields;
          let capturedDataTypeNode = _internal_createNode(this.obj);
          const processBasicDataType = async (addressSpace2) => {
            const definitionName = capturedDataTypeNode.browseName.name;
            const isStructure = capturedDataTypeNode.isStructure();
            const isEnumeration = capturedDataTypeNode.isEnumeration();
            if (!isEnumeration && !isStructure && capturedDataTypeNode.nodeId.namespace !== 0) {
              pendingSimpleTypeToRegister.push({ name: definitionName, dataTypeNodeId: capturedDataTypeNode.nodeId });
            }
            capturedDataTypeNode = void 0;
          };
          postTasks.push(processBasicDataType);
        },
        parser: {
          DisplayName: {
            finish() {
              this.parent.obj.displayName = this.text;
            }
          },
          Description: {
            finish() {
              this.parent.obj.description = this.text;
            }
          },
          References: references_parser,
          Definition: node_opcua_xml2json_1._definitionParser
        }
      };
      const localizedText_parser = {
        LocalizedText: {
          init() {
            this.localizedText = {};
          },
          parser: {
            Locale: {
              finish() {
                this.parent.localizedText.locale = this.text.trim();
              }
            },
            Text: {
              finish() {
                this.parent.localizedText.text = this.text.trim();
              }
            }
          }
        }
      };
      const qualifiedName_parser = {
        QualifiedName: {
          init() {
            this.qualifiedName = {
              namespaceIndex: 0,
              name: null
            };
          },
          parser: {
            Name: {
              finish() {
                this.parent.qualifiedName.name = this.text.trim();
              }
            },
            NamespaceIndex: {
              finish() {
                const ns = parseInt(this.text, 10);
                const t = _translateNodeId((0, node_opcua_nodeid_1.resolveNodeId)(`ns=${ns};i=1`).toString());
                this.parent.qualifiedName.namespaceIndex = t.namespace;
              }
            }
          }
        }
      };
      const nodeId_parser = {
        NodeId: {
          init() {
            this.nodeId = "";
          },
          parser: {
            Identifier: {
              finish() {
                this.parent.nodeId = _translateNodeId((0, node_opcua_nodeid_1.resolveNodeId)(this.text.trim()).toString());
              }
            }
          }
        }
      };
      const enumValueType_parser = {
        EnumValueType: {
          init() {
            this.enumValueType = new node_opcua_types_1.EnumValueType({
              description: void 0,
              displayName: void 0,
              value: (0, node_opcua_basic_types_2.coerceInt64)(-1)
            });
          },
          parser: {
            Value: {
              // note: Value may be missing, in this case value shall be set to -1(64)
              finish() {
                this.parent.enumValueType.value = (0, node_opcua_basic_types_2.coerceInt64)(parseInt(this.text, 10));
              }
            },
            DisplayName: {
              ...localizedText_parser.LocalizedText,
              finish() {
                this.parent.enumValueType.displayName = { ...this.localizedText };
              }
            },
            Description: {
              ...localizedText_parser.LocalizedText,
              finish() {
                this.parent.enumValueType.description = { ...this.localizedText };
              }
            }
          },
          finish() {
            this.enumValueType = new node_opcua_types_1.EnumValueType(this.enumValueType);
          }
        }
      };
      const argument_parser = {
        Argument: {
          init() {
            this.argument = new node_opcua_service_call_1.Argument({});
          },
          parser: {
            Name: {
              finish() {
                this.parent.argument.name = this.text.trim();
              }
            },
            DataType: {
              parser: {
                Identifier: {
                  finish() {
                    this.parent.parent.argument.dataType = _translateNodeId((0, node_opcua_nodeid_1.resolveNodeId)(this.text.trim()).toString());
                  }
                }
              }
            },
            ValueRank: {
              finish() {
                this.parent.argument.valueRank = parseInt(this.text.trim(), 10);
              }
            },
            ArrayDimensions: {
              finish() {
              }
            },
            Description: {
              init() {
                this._text = "";
                this.locale = null;
                this.text = null;
              },
              parser: {
                Locale: {
                  init() {
                    this.text = "";
                  },
                  finish() {
                    this.parent.locale = this.text.trim();
                  }
                },
                Text: {
                  finish() {
                    this.text = this.text || "";
                    this.parent._text = this.text.trim();
                  }
                }
              },
              finish() {
                this.parent.argument.description = (0, node_opcua_data_model_1.coerceLocalizedText)(this._text);
              }
            }
          },
          finish() {
          }
        }
      };
      const Range_parser = {
        Range: {
          init() {
            this.range = new node_opcua_types_1.Range({});
          },
          parser: {
            Low: {
              finish() {
                this.parent.range.low = parseFloat(this.text);
              }
            },
            High: {
              finish() {
                this.parent.range.high = parseFloat(this.text);
              }
            }
          }
        }
      };
      const EUInformation_parser = {
        EUInformation: {
          init() {
            this.euInformation = new node_opcua_data_access_1.EUInformation({});
          },
          parser: {
            NamespaceUri: {
              finish() {
                this.parent.euInformation.namespaceUri = this.text;
              }
            },
            UnitId: {
              finish() {
                this.parent.euInformation.unitId = parseInt(this.text, 10);
              }
            },
            DisplayName: {
              ...localizedText_parser.LocalizedText,
              finish() {
                this.parent.euInformation.displayName = { ...this.localizedText };
              }
            },
            Description: {
              ...localizedText_parser.LocalizedText,
              finish() {
                this.parent.euInformation.description = { ...this.localizedText };
              }
            }
          },
          finish() {
            this.euInformation = new node_opcua_data_access_1.EUInformation(this.euInformation);
          }
        }
      };
      const _extensionObject_inner_parser = {
        TypeId: {
          parser: {
            Identifier: {
              finish() {
                const typeDefinitionId = this.text.trim();
                const self2 = this.parent.parent;
                self2.typeDefinitionId = (0, node_opcua_nodeid_1.resolveNodeId)(typeDefinitionId);
              }
            }
          }
        },
        Body2: new node_opcua_xml2json_1.FragmentClonerParser(),
        Body: {
          parser: {
            Argument: argument_parser.Argument,
            EUInformation: EUInformation_parser.EUInformation,
            EnumValueType: enumValueType_parser.EnumValueType,
            Range: Range_parser.Range
          },
          startElement(elementName, attrs) {
            const self2 = this.parent;
            self2.extensionObject = null;
            self2.extensionObjectPojo = null;
            if (!Object.prototype.hasOwnProperty.call(this.parser, elementName)) {
              this._cloneFragment = new node_opcua_xml2json_1.InternalFragmentClonerReaderState();
              this.engine._promote(this._cloneFragment, this.engine.currentLevel, elementName, attrs);
            }
          },
          finish() {
            const self2 = this.parent;
            switch (self2.typeDefinitionId.toString()) {
              case "i=7616":
              case "ns=0;i=7616":
                self2.extensionObject = self2.parser.Body.parser.EnumValueType.enumValueType;
                (0, node_opcua_assert_1.assert)(self2.extensionObject !== null && typeof self2.extensionObject === "object");
                (0, node_opcua_assert_1.assert)(self2.extensionObject instanceof node_opcua_extension_object_1.ExtensionObject);
                break;
              case "i=297":
              case "ns=0;i=297":
                self2.extensionObject = self2.parser.Body.parser.Argument.argument;
                (0, node_opcua_assert_1.assert)(self2.extensionObject !== null && typeof self2.extensionObject === "object");
                (0, node_opcua_assert_1.assert)(self2.extensionObject instanceof node_opcua_extension_object_1.ExtensionObject);
                break;
              case "i=888":
              case "ns=0;i=888":
                self2.extensionObject = self2.parser.Body.parser.EUInformation.euInformation;
                (0, node_opcua_assert_1.assert)(self2.extensionObject !== null && typeof self2.extensionObject === "object");
                (0, node_opcua_assert_1.assert)(self2.extensionObject instanceof node_opcua_extension_object_1.ExtensionObject);
                break;
              case "i=885":
              case "ns=0;i=885":
                self2.extensionObject = self2.parser.Body.parser.Range.range;
                (0, node_opcua_assert_1.assert)(self2.extensionObject !== null && typeof self2.extensionObject === "object");
                (0, node_opcua_assert_1.assert)(self2.extensionObject instanceof node_opcua_extension_object_1.ExtensionObject);
                break;
              default: {
                if (!this._cloneFragment) {
                  errorLog("[NODE-OPCUA-E12] standard OPCUA Extension object from (namespace=0) has a invalid TypeId", self2.typeDefinitionId.toString());
                  break;
                }
                this.bodyXML = this._cloneFragment.value;
                this._cloneFragment.value = null;
                const xmlEncodingNodeId = _translateNodeId(self2.typeDefinitionId.toString());
                if (xmlEncodingNodeId.isEmpty()) {
                  debugLog("xmlEncodingNodeId is empty for " + self2.typeDefinitionId.toString());
                  break;
                }
                let captureXmlBody = this.bodyXML;
                if (doDebug) {
                  debugLog("xxxx ", chalk_1.default.yellow(captureXmlBody));
                }
                debugLog("load nodeset2: typeDefinitionId in ExtensionObject Default XML = " + xmlEncodingNodeId.toString());
                let captured = self2.postTaskData;
                self2.extensionObjectPojo = null;
                const task = async (addressSpace2) => {
                  const extensionObject = await (0, decode_xml_extension_object_1.decodeXmlExtensionObject)(addressSpace2, xmlEncodingNodeId, captureXmlBody);
                  if (captured) {
                    captured.postponedExtensionObject = extensionObject;
                  }
                  captureXmlBody = void 0;
                  captured = void 0;
                };
                postTasks0_DecodePojoString.push(task);
                (0, node_opcua_assert_1.assert)(!self2.extensionObject || self2.extensionObject instanceof node_opcua_extension_object_1.ExtensionObject);
                break;
              }
            }
          }
        }
      };
      const extensionObject_parser = {
        ExtensionObject: {
          init() {
            this.typeDefinitionId = node_opcua_nodeid_1.NodeId.nullNodeId;
            this.extensionObject = null;
            this.extensionObjectPojo = null;
            this.postTaskData = { postponedExtensionObject: null };
          },
          parser: _extensionObject_inner_parser,
          finish() {
          }
        }
      };
      function BasicType_parser(dataType, parseFunc) {
        const _parser = {};
        const r = {
          init(name, attrs) {
            this.value = void 0;
          },
          finish() {
            this.value = parseFunc.call(this, this.text);
          }
        };
        _parser[dataType] = r;
        return _parser;
      }
      function ListOf(dataType, parseFunc) {
        return {
          init() {
            this.listData = [];
          },
          parser: BasicType_parser(dataType, parseFunc),
          finish() {
            this.parent.parent.obj.value = {
              arrayType: node_opcua_variant_1.VariantArrayType.Array,
              dataType: node_opcua_variant_1.DataType[dataType],
              value: this.listData
            };
          },
          endElement(element) {
            this.listData.push(this.parser[dataType].value);
          }
        };
      }
      function parser2(type, p3) {
        return {
          finish() {
            this.parent.parent.obj.value = {
              arrayType: node_opcua_variant_1.VariantArrayType.Scalar,
              dataType: node_opcua_variant_1.DataType[type],
              value: p3(this.text)
            };
          }
        };
      }
      const parseUInt64 = (str) => (0, node_opcua_basic_types_2.coerceUInt64)(str);
      const parseInt64 = (str) => (0, node_opcua_basic_types_2.coerceInt64)(str);
      const state_Variant = {
        init: () => {
        },
        parser: {
          QualifiedName: {
            ...qualifiedName_parser.QualifiedName,
            finish() {
              this.parent.parent.obj.value = {
                dataType: node_opcua_variant_1.DataType.QualifiedName,
                value: this.qualifiedName
              };
            }
          },
          LocalizedText: {
            ...localizedText_parser.LocalizedText,
            finish() {
              this.parent.parent.obj.value = {
                dataType: node_opcua_variant_1.DataType.LocalizedText,
                value: this.localizedText
              };
            }
          },
          XmlElement: {
            finish() {
              this.parent.parent.obj.value = {
                dataType: node_opcua_variant_1.DataType.XmlElement,
                value: this.text
              };
            }
          },
          String: {
            finish() {
              this.parent.parent.obj.value = {
                dataType: node_opcua_variant_1.DataType.String,
                value: this.text
              };
            }
          },
          Guid: {
            parser: {
              String: {
                finish() {
                  const guid = this.text;
                  if (!(0, node_opcua_basic_types_2.isValidGuid)(guid)) {
                  }
                  this.parent.parent.parent.obj.value = {
                    dataType: node_opcua_variant_1.DataType.Guid,
                    arrayType: node_opcua_variant_1.VariantArrayType.Scalar,
                    value: this.text
                  };
                }
              }
            }
          },
          NodeId: {
            parser: {
              Identifier: {
                finish() {
                  const nodeId = this.text;
                  this.parent.parent.parent.obj.value = {
                    dataType: node_opcua_variant_1.DataType.NodeId,
                    arrayType: node_opcua_variant_1.VariantArrayType.Scalar,
                    value: _translateNodeId((0, node_opcua_nodeid_1.resolveNodeId)(nodeId).toString())
                  };
                }
              }
            }
          },
          Boolean: parser2("Boolean", node_opcua_basic_types_1.coerceBoolean),
          Byte: parser2("Byte", parseInt),
          Int16: parser2("Int16", parseInt),
          Int32: parser2("Int32", parseInt),
          Int8: parser2("Int8", parseInt),
          SByte: parser2("SByte", parseInt),
          UInt16: parser2("UInt16", parseInt),
          UInt32: parser2("UInt32", parseInt),
          UInt8: parser2("UInt8", parseInt),
          UInt64: parser2("UInt64", parseUInt64),
          Int64: parser2("Int64", parseInt64),
          ByteString: {
            init() {
              this.value = null;
            },
            finish() {
              const base64text = this.text;
              const byteString = Buffer.from(base64text, "base64");
              this.parent.parent.obj.value = {
                arrayType: node_opcua_variant_1.VariantArrayType.Scalar,
                dataType: node_opcua_variant_1.DataType.ByteString,
                value: byteString
              };
            }
          },
          Float: {
            finish() {
              this.parent.parent.obj.value = {
                dataType: node_opcua_variant_1.DataType.Float,
                value: parseFloat(this.text)
              };
            }
          },
          Double: {
            finish() {
              this.parent.parent.obj.value = {
                dataType: node_opcua_variant_1.DataType.Double,
                value: parseFloat(this.text)
              };
            }
          },
          ListOfExtensionObject: {
            init() {
              this.listExtensionObject = [];
            },
            parser: extensionObject_parser,
            finish() {
              installExtensionObjectListInitializationPostTask(this);
            },
            startElement(elementName) {
              const extensionObjectParser = this.parser.ExtensionObject;
              extensionObjectParser.postTaskData = { postponedExtensionObject: null };
            },
            endElement(elementName) {
              const extensionObjectParser = this.parser.ExtensionObject;
              this.listExtensionObject.push(extensionObjectParser.extensionObject);
              if (this.parser.ExtensionObject.extensionObject === null) {
                const index = this.listExtensionObject.length - 1;
                let capturedData = extensionObjectParser.postTaskData;
                if (!capturedData) {
                  throw new Error("Internal Error : postponedExtensionObject not resolved");
                }
                let listExtensionObject = this.listExtensionObject;
                const task = async (addressSpace2) => {
                  if (!capturedData.postponedExtensionObject) {
                    throw new Error("Internal Error : postponedExtensionObject not resolved");
                  }
                  listExtensionObject[index] = capturedData.postponedExtensionObject;
                  capturedData = void 0;
                  listExtensionObject = void 0;
                };
                postTasks2_AssignedExtensionObjectToDataValue.push(task);
              }
            }
          },
          ListOfLocalizedText: {
            init() {
              this.listData = [];
            },
            parser: localizedText_parser,
            finish() {
              this.parent.parent.obj.value = {
                arrayType: node_opcua_variant_1.VariantArrayType.Array,
                dataType: node_opcua_variant_1.DataType.LocalizedText,
                value: this.listData
              };
            },
            endElement() {
              this.listData.push(this.parser.LocalizedText.localizedText);
            }
          },
          ListOfQualifiedName: {
            init() {
              this.listData = [];
            },
            parser: qualifiedName_parser,
            finish() {
              this.parent.parent.obj.value = {
                arrayType: node_opcua_variant_1.VariantArrayType.Array,
                dataType: node_opcua_variant_1.DataType.QualifiedName,
                value: this.listData
              };
            },
            endElement() {
              this.listData.push(this.parser.QualifiedName.qualifiedName);
            }
          },
          ListOfNodeId: {
            init() {
              this.listData = [];
            },
            parser: nodeId_parser,
            finish() {
              this.parent.parent.obj.value = {
                arrayType: node_opcua_variant_1.VariantArrayType.Array,
                dataType: node_opcua_variant_1.DataType.NodeId,
                value: this.listData
              };
            },
            endElement(elementName) {
              this.listData.push(this.parser.NodeId.nodeId);
            }
          },
          ListOfBoolean: ListOf("Boolean", node_opcua_basic_types_1.coerceBoolean),
          ListOfByte: ListOf("Byte", parseInt),
          ListOfDouble: ListOf("Double", parseFloat),
          ListOfFloat: ListOf("Float", parseFloat),
          ListOfInt32: ListOf("Int32", parseInt),
          ListOfInt16: ListOf("Int16", parseInt),
          ListOfInt8: ListOf("Int8", parseInt),
          ListOfUInt32: ListOf("UInt32", parseInt),
          ListOfUInt16: ListOf("UInt16", parseInt),
          ListOfUInt8: ListOf("UInt8", parseInt),
          ListOfString: ListOf("String", (value) => value),
          ListOfXmlElement: ListOf("XmlElement", (value) => value),
          ExtensionObject: {
            init() {
              this.typeDefinitionId = node_opcua_nodeid_1.NodeId.nullNodeId;
              this.extensionObject = null;
              this.postTaskData = { postponedExtensionObject: null };
            },
            parser: _extensionObject_inner_parser,
            finish() {
              if (this.extensionObject && !(this.extensionObject instanceof node_opcua_extension_object_1.ExtensionObject)) {
                throw new Error("expecting an extension object");
              }
              this.parent.parent.obj.value = {
                dataType: node_opcua_variant_1.DataType.ExtensionObject,
                value: this.extensionObject
              };
              if (!this.extensionObject) {
                installExtensionObjectInitializationPostTask(this);
              }
            }
          }
        }
      };
      function installExtensionObjectListInitializationPostTask(element) {
        let listExtensionObject = element.listExtensionObject;
        let nodeId = element.parent.parent.obj.nodeId;
        (0, node_opcua_assert_1.assert)(nodeId, "expecting a nodeid");
        const task = async (addressSpace2) => {
          const node = addressSpace2.findNode(nodeId);
          if (!node) {
            debugLog("Cannot find node with nodeId " + nodeId + ". may be the node was marked as deprecated");
          } else if (node.nodeClass === node_opcua_data_model_1.NodeClass.Variable) {
            const v = node;
            (0, node_opcua_assert_1.assert)(v.getBasicDataType() === node_opcua_variant_1.DataType.ExtensionObject, "expecting an extension object");
            v.bindExtensionObject(listExtensionObject, { createMissingProp: false });
          } else if (node.nodeClass === node_opcua_data_model_1.NodeClass.VariableType) {
            const v = node;
            v.value.value = listExtensionObject;
          }
          listExtensionObject.slice(0);
          listExtensionObject = void 0;
          nodeId = void 0;
        };
        postTasks2_AssignedExtensionObjectToDataValue.push(task);
      }
      function installExtensionObjectInitializationPostTask(element) {
        let data = element.postTaskData;
        let variant = element.parent.parent.obj.value;
        let nodeId = element.parent.parent.obj.nodeId;
        const task = async (addressSpace2) => {
          variant.value = data.postponedExtensionObject;
          (0, node_opcua_assert_1.assert)(nodeId, "expecting a nodeid");
          const node = addressSpace2.findNode(nodeId);
          if (node.nodeClass === node_opcua_data_model_1.NodeClass.Variable) {
            const v = node;
            (0, node_opcua_assert_1.assert)(v.getBasicDataType() === node_opcua_variant_1.DataType.ExtensionObject, "expecting an extension object");
            v.bindExtensionObject(variant.value, { createMissingProp: false });
          } else if (node.nodeClass === node_opcua_data_model_1.NodeClass.VariableType) {
            const v = node;
            v.value.value = variant.value;
          }
          data.postponedExtensionObject = null;
          data = void 0;
          variant = void 0;
          nodeId = void 0;
        };
        postTasks2_AssignedExtensionObjectToDataValue.push(task);
      }
      const canIngore = ({ isDraft, isDeprecated }, node) => {
        if (isDraft && !options.loadDraftNodes) {
          debugLog("Ignoring Draft            =", node_opcua_data_model_1.NodeClass[node.nodeClass], node.browseName.toString());
          return true;
        }
        if (isDeprecated && !options.loadDeprecatedNodes) {
          debugLog("Ignoring Deprecate        =", node_opcua_data_model_1.NodeClass[node.nodeClass], node.browseName.toString());
          return true;
        }
        return false;
      };
      const state_UAVariable = {
        init(name, attrs) {
          _perform();
          this.obj = {};
          this.obj.nodeClass = node_opcua_data_model_1.NodeClass.Variable;
          this.obj.browseName = convertQualifiedName(attrs.BrowseName);
          this.obj.parentNodeId = convertToNodeId(attrs.ParentNodeId);
          this.obj.dataType = convertToNodeId(attrs.DataType);
          this.obj.valueRank = attrs.ValueRank === void 0 ? -1 : (0, node_opcua_basic_types_1.coerceInt32)(attrs.ValueRank);
          this.obj.arrayDimensions = this.obj.valueRank <= 0 ? null : stringToUInt32Array(attrs.ArrayDimensions);
          this.obj.minimumSamplingInterval = attrs.MinimumSamplingInterval ? parseInt(attrs.MinimumSamplingInterval, 10) : 0;
          this.obj.minimumSamplingInterval = parseInt(this.obj.minimumSamplingInterval, 10);
          this.obj.historizing = false;
          this.obj.nodeId = convertToNodeId(attrs.NodeId) || null;
          this.obj.accessLevel = convertAccessLevel(attrs.AccessLevel);
          this.obj.userAccessLevel = this.obj.accessLevel;
          this.isDraft = attrs.ReleaseStatus === "Draft";
          this.isDeprecated = attrs.ReleaseStatus === "Deprecated";
        },
        finish() {
          if (canIngore({ isDraft: this.isDraft, isDeprecated: this.isDeprecated }, this.obj)) {
            return;
          }
          let capturedVariable;
          if (this.obj.value) {
            let capturedValue = this.obj.value;
            const task = async (addressSpace2) => {
              if (false) {
                debugLog("1 setting value to ", capturedVariable.nodeId.toString(), new node_opcua_variant_1.Variant(capturedValue).toString());
              }
              capturedVariable.setValueFromSource(capturedValue);
              capturedValue = void 0;
              capturedVariable = void 0;
            };
            if (capturedValue.dataType !== node_opcua_variant_1.DataType.ExtensionObject) {
              postTasks0_InitializeVariable.push(task);
            } else {
              postTasks1_InitializeVariable.push(task);
            }
          } else {
            const task = async (addressSpace2) => {
              const dataTypeNode = capturedVariable.dataType;
              const valueRank = capturedVariable.valueRank;
              const arrayDimensions = capturedVariable.arrayDimensions;
              const value = makeDefaultVariant(addressSpace, dataTypeNode, valueRank, arrayDimensions);
              if (value) {
                if (false) {
                  debugLog("2 setting value to ", capturedVariable.nodeId.toString(), value);
                }
                if (value.dataType === node_opcua_variant_1.DataType.Null) {
                  capturedVariable.setValueFromSource(value, node_opcua_basic_types_2.StatusCodes.BadWaitingForInitialData);
                } else {
                  capturedVariable.setValueFromSource(value, node_opcua_basic_types_2.StatusCodes.Good);
                }
              }
              capturedVariable = void 0;
            };
            postTasks0_InitializeVariable.push(task);
          }
          this.obj.value = void 0;
          capturedVariable = _internal_createNode(this.obj);
        },
        parser: {
          DisplayName: {
            finish() {
              this.parent.obj.displayName = this.text;
            }
          },
          Description: {
            finish() {
              this.parent.obj.description = this.text;
            }
          },
          References: references_parser,
          Value: state_Variant
        }
      };
      const state_UAVariableType = {
        init(name, attrs) {
          _perform();
          this.obj = {};
          this.obj.isAbstract = (0, node_opcua_basic_types_1.coerceBoolean)(attrs.IsAbstract);
          this.obj.nodeClass = node_opcua_data_model_1.NodeClass.VariableType;
          this.obj.browseName = convertQualifiedName(attrs.BrowseName);
          this.obj.parentNodeId = attrs.ParentNodeId || null;
          this.obj.dataType = convertToNodeId(attrs.DataType) || null;
          this.obj.valueRank = (0, node_opcua_basic_types_1.coerceInt32)(attrs.ValueRank) || -1;
          this.obj.arrayDimensions = this.obj.valueRank <= 0 ? null : stringToUInt32Array(attrs.ArrayDimensions);
          this.obj.minimumSamplingInterval = attrs.MinimumSamplingInterval ? parseInt(attrs.MinimumSamplingInterval, 10) : 0;
          this.obj.historizing = false;
          this.obj.nodeId = convertToNodeId(attrs.NodeId) || null;
          this.isDraft = attrs.ReleaseStatus === "Draft";
          this.isDeprecated = attrs.ReleaseStatus === "Deprecated";
        },
        finish() {
          if (canIngore({ isDraft: this.isDraft, isDeprecated: this.isDeprecated }, this.obj)) {
            return;
          }
          try {
            _internal_createNode(this.obj);
          } catch (err) {
            this.obj.addressSpace = null;
            console.warn(" Cannot create object", JSON.stringify(this.obj, null, " "));
            throw err;
          }
        },
        parser: {
          DisplayName: {
            finish() {
              this.parent.obj.displayName = this.text;
            }
          },
          Description: {
            finish() {
              this.parent.obj.description = this.text;
            }
          },
          References: references_parser,
          Value: state_Variant
        }
      };
      const state_UAMethod = {
        init(name, attrs) {
          _perform();
          this.obj = {};
          this.obj.nodeClass = node_opcua_data_model_1.NodeClass.Method;
          this.obj.browseName = convertQualifiedName(attrs.BrowseName);
          this.obj.parentNodeId = attrs.ParentNodeId || null;
          this.obj.nodeId = convertToNodeId(attrs.NodeId) || null;
          this.obj.methodDeclarationId = attrs.MethodDeclarationId ? _translateNodeId(attrs.MethodDeclarationId) : null;
          this.isDraft = attrs.ReleaseStatus === "Draft";
          this.isDeprecated = attrs.ReleaseStatus === "Deprecated";
        },
        finish() {
          if (canIngore({ isDraft: this.isDraft, isDeprecated: this.isDeprecated }, this.obj)) {
            return;
          }
          _internal_createNode(this.obj);
        },
        parser: {
          DisplayName: {
            finish() {
              this.parent.obj.displayName = this.text;
            }
          },
          References: references_parser
        }
      };
      const state_ModelTableEntry = new node_opcua_xml2json_1.ReaderState({
        // ModelTableEntry
        init() {
          this._requiredModels = [];
        },
        parser: {
          RequiredModel: {
            init(name, attrs) {
              const modelUri = attrs.ModelUri;
              const version = attrs.Version;
              const publicationDate = new Date(Date.parse(attrs.PublicationDate));
              this.parent._requiredModels.push({ modelUri, version, publicationDate });
            },
            finish() {
            }
          }
        },
        finish() {
          const modelUri = this.attrs.ModelUri;
          const version = this.attrs.Version;
          const publicationDate = this.attrs.PublicationDate ? new Date(Date.parse(this.attrs.PublicationDate)) : void 0;
          const symbolicName = this.attrs.SymbolicName;
          const accessRestrictions = this.attrs.AccessRestrictions;
          const model = {
            accessRestrictions,
            modelUri,
            publicationDate,
            requiredModels: this._requiredModels,
            symbolicName,
            version
          };
          const namespace = _add_namespace(model);
          models.push(model);
        }
      });
      function _updateTranslationTable() {
        _register_namespace_uri_in_translation_table("http://opcfoundation.org/UA/");
        for (const namespaceUri of _namespaceUris) {
          _register_namespace_uri_in_translation_table(namespaceUri);
        }
      }
      function _perform() {
        if (performedCalled)
          return;
        performedCalled = true;
        if (models.length === 0) {
          for (const namespaceuri of _namespaceUris) {
            const existingNamespace = addressSpace1.getNamespace(namespaceuri);
            if (existingNamespace) {
              continue;
            }
            _add_namespace({
              modelUri: namespaceuri,
              version: "1.0.0",
              requiredModels: []
            });
          }
        }
        _updateTranslationTable();
      }
      let _namespaceUris = [];
      const state_0 = {
        parser: {
          Aliases: {
            init() {
              _perform();
            },
            parser: { Alias: state_Alias }
          },
          NamespaceUris: {
            init() {
              _namespaceUris = [];
            },
            parser: {
              Uri: {
                finish() {
                  _namespaceUris.push(this.text);
                }
              }
            },
            finish() {
            }
          },
          Models: {
            // ModelTable
            init(name, attrs) {
            },
            parser: {
              Model: state_ModelTableEntry
            },
            finish() {
            }
          },
          UADataType: state_UADataType,
          UAMethod: state_UAMethod,
          UAObject: state_UAObject,
          UAObjectType: state_UAObjectType,
          UAReferenceType: state_UAReferenceType,
          UAVariable: state_UAVariable,
          UAVariableType: state_UAVariableType
        }
      };
      const parser = new node_opcua_xml2json_1.Xml2Json(state_0);
      function terminate(callback) {
        make_back_references(addressSpace1);
        if (addressSpace1.rootFolder?.objects?.server?.namespaceArray) {
          addressSpace1.rootFolder.objects.server.namespaceArray.setValueFromSource({
            arrayType: node_opcua_variant_1.VariantArrayType.Array,
            dataType: node_opcua_variant_1.DataType.String,
            value: addressSpace1.getNamespaceArray().map((ns) => ns.namespaceUri)
          });
          if (doDebug) {
            debugLog("addressSpace NS = ", addressSpace1.rootFolder.objects.server.namespaceArray.readValue().value.value.join(" "));
          }
        }
        doDebug && debugLog(chalk_1.default.bgGreenBright("Performing post loading tasks -------------------------------------------") + chalk_1.default.green("DONE"));
        async function performPostLoadingTasks(tasks) {
          for (const task of tasks) {
            try {
              await task(addressSpace1);
            } catch (err) {
              if (util_1.types.isNativeError(err)) {
                errorLog(" performPostLoadingTasks Err  => ", err.message, "\n", err);
              }
              await task(addressSpace1);
            }
          }
          tasks.splice(0);
        }
        async function finalSteps() {
          doDebug && debugLog(chalk_1.default.bgGreenBright("Performing post loading tasks -------------------------------------------"));
          await performPostLoadingTasks(postTasks);
          doDebug && debugLog(chalk_1.default.bgGreenBright("Performing post loading task: Initializing Simple Variables ---------------------"));
          await performPostLoadingTasks(postTasks0_InitializeVariable);
          doDebug && debugLog(chalk_1.default.bgGreenBright("Performing DataType extraction -------------------------------------------"));
          (0, node_opcua_assert_1.assert)(!addressSpace1.suspendBackReference);
          await (0, ensure_datatype_extracted_1.ensureDatatypeExtracted)(addressSpace);
          const dataTypeManager = addressSpace.getDataTypeManager();
          doDebug && debugLog(chalk_1.default.bgGreenBright("DataType extraction done ") + chalk_1.default.green("DONE"));
          for (const { name, dataTypeNodeId } of pendingSimpleTypeToRegister) {
            if (dataTypeNodeId.namespace === 0) {
              continue;
            }
            const dataTypeFactory = dataTypeManager.getDataTypeFactoryForNamespace(dataTypeNodeId.namespace);
          }
          pendingSimpleTypeToRegister.splice(0);
          doDebug && debugLog(chalk_1.default.bgGreenBright("Performing post loading task: Decoding Pojo String (parsing XML objects) -"));
          await performPostLoadingTasks(postTasks0_DecodePojoString);
          doDebug && debugLog(chalk_1.default.bgGreenBright("Performing post loading task: Initializing Complex Variables ---------------------"));
          await performPostLoadingTasks(postTasks1_InitializeVariable);
          doDebug && debugLog(chalk_1.default.bgGreenBright("Performing post loading tasks: (assigning Extension Object to Variables) -"));
          await performPostLoadingTasks(postTasks2_AssignedExtensionObjectToDataValue);
          doDebug && debugLog(chalk_1.default.bgGreenBright("Performing post variable initialization ---------------------"));
          (0, namespace_post_step_1.promoteObjectsAndVariables)(addressSpace);
        }
        finalSteps().then(() => callback()).catch((err1) => {
          errorLog("Error ", (0, node_opcua_assert_1.renderError)(err1));
          callback(err1);
        });
      }
      function addNodeSet(xmlData, callback1) {
        _reset_namespace_translation();
        parser.parseString(xmlData, callback1);
      }
      return {
        addNodeSet,
        terminate
      };
    }
    var NodeSetLoader = class {
      constructor(addressSpace, options) {
        this.options = options;
        this._s = makeNodeSetParserEngine(addressSpace, options || {});
      }
      addNodeSet(xmlData, callback) {
        if (!callback) {
          throw new Error("Expecting callback function");
        }
        return this._s.addNodeSet(xmlData, callback);
      }
      async addNodeSetAsync(xmlData) {
        return (0, util_1.promisify)(this.addNodeSet).call(this, xmlData);
      }
      terminate(callback) {
        this._s.terminate(callback);
      }
      async terminateAsync() {
        return (0, util_1.promisify)(this.terminate).call(this);
      }
    };
    exports2.NodeSetLoader = NodeSetLoader;
  }
});

// node_modules/node-opcua-address-space/dist/source/loader/generateAddressSpaceRaw.js
var require_generateAddressSpaceRaw = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/loader/generateAddressSpaceRaw.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.generateAddressSpaceRaw = exports2.findOrder = exports2.preLoad = void 0;
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_xml2json_1 = require_source2();
    var node_opcua_date_time_1 = require_dist17();
    var adjust_namespace_array_1 = require_adjust_namespace_array();
    var load_nodeset2_1 = require_load_nodeset2();
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    async function parseDependencies(xmlData) {
      const namespaceUris = [];
      const models = [];
      let currentModel = void 0;
      const state0 = {
        parser: {
          UANodeSet: {
            parser: {
              NamespaceUris: {
                parser: {
                  Uri: {
                    finish() {
                      namespaceUris.push(this.text);
                    }
                  }
                }
              },
              Models: {
                parser: {
                  Model: {
                    init(elementName, attrs) {
                      const modelUri = attrs.ModelUri;
                      const version = attrs.Version;
                      const publicationDate = new Date(Date.parse(attrs.PublicationDate));
                      currentModel = {
                        modelUri,
                        version,
                        publicationDate,
                        requiredModel: []
                      };
                      doDebug && console.log(`currentModel = ${JSON.stringify(currentModel)}`);
                      models.push(currentModel);
                    },
                    parser: {
                      RequiredModel: {
                        init(elementName, attrs) {
                          const modelUri = attrs.ModelUri;
                          const version = attrs.Version;
                          const publicationDate = new Date(Date.parse(attrs.PublicationDate));
                          if (!currentModel) {
                            throw new Error("Internal Error");
                          }
                          currentModel.requiredModel.push({
                            modelUri,
                            version,
                            publicationDate
                          });
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      };
      const parser = new node_opcua_xml2json_1.Xml2Json(state0);
      parser.parseStringSync(xmlData);
      if (models.length === 0 && namespaceUris.length >= 1) {
        models.push({
          modelUri: namespaceUris[0],
          version: "1",
          publicationDate: node_opcua_date_time_1.minDate,
          requiredModel: []
        });
      }
      return { models, namespaceUris };
    }
    async function preLoad(xmlFiles, xmlLoader) {
      const namespaceDesc = [];
      for (let index = 0; index < xmlFiles.length; index++) {
        doDebug && console.log("---------------------------------------------", xmlFiles[index]);
        const xmlData = await xmlLoader(xmlFiles[index]);
        const indexStart = xmlData.match(/<UANodeSet/m)?.index;
        const i1 = (xmlData.match(/<\/Models>/m)?.index || 0) + "</Models>".length;
        const i2 = (xmlData.match(/<\/NamespaceUris>/m)?.index || 0) + "</NamespaceUris>".length;
        const indexEnd = Math.max(i1, i2);
        if (indexStart === void 0 || indexEnd === void 0) {
          throw new Error("Internal Error");
        }
        const xmlData2 = xmlData.substring(indexStart, indexEnd);
        doDebug && console.log(xmlData2.split("\n").splice(0, 46).map((x2, i) => `${i + 0} ${x2}`).join("\n"));
        const namespaceModel = await parseDependencies(xmlData2);
        namespaceDesc.push({ xmlData, namespaceModel, index });
      }
      return namespaceDesc;
    }
    exports2.preLoad = preLoad;
    function findOrder(nodesetDescs) {
      const order = [];
      const visited = /* @__PURE__ */ new Set();
      const findNodesetIndex = (namespaceUri) => {
        const index = nodesetDescs.findIndex((x2) => x2.namespaceModel.models.findIndex((e) => e.modelUri === namespaceUri) !== -1);
        return index;
      };
      const visit = (model) => {
        const key = model.modelUri;
        if (visited.has(key)) {
          return;
        }
        visited.add(key);
        for (const requiredModel of model.requiredModel) {
          const requiredModelIndex = findNodesetIndex(requiredModel.modelUri);
          if (requiredModelIndex === -1) {
            throw new Error("Cannot find namespace for " + requiredModel.modelUri);
          }
          const nd = nodesetDescs[requiredModelIndex];
          for (const n of nd.namespaceModel.models) {
            visit(n);
          }
        }
        const nodesetIndex = findNodesetIndex(model.modelUri);
        const alreadyIn = order.findIndex((x2) => x2 === nodesetIndex) !== -1;
        if (!alreadyIn)
          order.push(nodesetIndex);
      };
      const visit2 = (nodesetDesc) => {
        for (const model of nodesetDesc.namespaceModel.models.values()) {
          visit(model);
        }
      };
      for (let index = 0; index < nodesetDescs.length; index++) {
        const nodesetDesc = nodesetDescs[index];
        visit2(nodesetDesc);
      }
      return order;
    }
    exports2.findOrder = findOrder;
    async function generateAddressSpaceRaw(addressSpace, xmlFiles, xmlLoader, options) {
      const nodesetLoader = new load_nodeset2_1.NodeSetLoader(addressSpace, options);
      if (!Array.isArray(xmlFiles)) {
        xmlFiles = [xmlFiles];
      }
      const nodesetDesc = await preLoad(xmlFiles, xmlLoader);
      const order = findOrder(nodesetDesc);
      for (let index = 0; index < order.length; index++) {
        const n = nodesetDesc[index];
        for (const model of n.namespaceModel.models) {
          const ns = addressSpace.registerNamespace(model.modelUri);
          ns.setRequiredModels(model.requiredModel);
        }
      }
      for (let index = 0; index < order.length; index++) {
        const nodesetIndex = order[index];
        const nodeset = nodesetDesc[nodesetIndex];
        debugLog(" loading ", nodesetIndex, nodeset.xmlData.length);
        try {
          await nodesetLoader.addNodeSetAsync(nodeset.xmlData);
        } catch (err) {
          errorLog("generateAddressSpace:  Loading xml file ", xmlFiles[index], " failed with error ", err.message);
          throw err;
        }
      }
      await nodesetLoader.terminateAsync();
      (0, adjust_namespace_array_1.adjustNamespaceArray)(addressSpace);
    }
    exports2.generateAddressSpaceRaw = generateAddressSpaceRaw;
  }
});

// node_modules/node-opcua-address-space/dist/source/namespace.js
var require_namespace2 = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/namespace.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/namespace_data_access.js
var require_namespace_data_access = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/namespace_data_access.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/src/private_namespace.js
var require_private_namespace = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/private_namespace.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getSymbols = exports2.setSymbols = exports2.getNodeIdManager = void 0;
    function getNodeIdManager(ns) {
      const nodeIdManager = ns._nodeIdManager;
      return nodeIdManager;
    }
    exports2.getNodeIdManager = getNodeIdManager;
    function setSymbols(ns, symbols) {
      const nodeIdManager = getNodeIdManager(ns);
      ns.addressSpace.getOwnNamespace().registerSymbolicNames = true;
      nodeIdManager.setSymbols(symbols);
    }
    exports2.setSymbols = setSymbols;
    function getSymbols(ns) {
      const nodeIdManager = getNodeIdManager(ns);
      return nodeIdManager?.getSymbols() || [];
    }
    exports2.getSymbols = getSymbols;
  }
});

// node_modules/node-opcua-address-space/dist/source/set_namespace_meta_data.js
var require_set_namespace_meta_data = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/set_namespace_meta_data.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.setNamespaceMetaData = void 0;
    var node_opcua_variant_1 = require_dist28();
    function specialEncode(namespaceUri) {
      return namespaceUri;
    }
    function setNamespaceMetaData(namespace) {
      const addressSpace = namespace.addressSpace;
      const namespaceMetadataType = addressSpace.findObjectType("NamespaceMetadataType");
      const namespaces = addressSpace.rootFolder.objects.server.getChildByName("Namespaces");
      if (!namespaces) {
        throw new Error("Cannot find namespacesType node under server object");
      }
      if (!namespaceMetadataType) {
        throw new Error("cannot find NamespaceMetadataType");
      }
      const deriveName = specialEncode(namespace.namespaceUri);
      const existingMetaData = namespaces.getComponentByName(deriveName, namespace.index);
      if (existingMetaData) {
        throw new Error("INamespace meta data already exists for " + deriveName);
      }
      const metaData = namespaceMetadataType.instantiate({
        browseName: deriveName,
        componentOf: namespaces,
        optionals: [
          "DefaultRolePermissions",
          "DefaultAccessRestrictions",
          "DefaultUserRolePermissions"
          // "NamespaceFile"
        ]
      });
      const namespaceUri = metaData.getChildByName("NamespaceUri");
      namespaceUri.setValueFromSource({ dataType: node_opcua_variant_1.DataType.String, value: namespace.namespaceUri });
      const namespacePublicationDate = metaData.namespacePublicationDate;
      namespacePublicationDate.setValueFromSource({ dataType: node_opcua_variant_1.DataType.DateTime, value: /* @__PURE__ */ new Date() });
      const namespaceVersion = metaData.namespaceVersion;
      namespaceVersion.setValueFromSource({ dataType: node_opcua_variant_1.DataType.String, value: "1.0.0" });
      metaData.defaultAccessRestrictions?.bindVariable({
        get: () => new node_opcua_variant_1.Variant({
          dataType: node_opcua_variant_1.DataType.UInt16,
          value: namespace.getDefaultAccessRestrictions()
        })
      }, true);
      metaData.defaultRolePermissions?.bindVariable({
        get: () => new node_opcua_variant_1.Variant({
          dataType: node_opcua_variant_1.DataType.ExtensionObject,
          arrayType: node_opcua_variant_1.VariantArrayType.Array,
          value: namespace.getDefaultRolePermissions()
        })
      }, true);
    }
    exports2.setNamespaceMetaData = setNamespaceMetaData;
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_3_d_cartesian_coordinates.js
var require_dt_3_d_cartesian_coordinates = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_3_d_cartesian_coordinates.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_3_d_frame.js
var require_dt_3_d_frame = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_3_d_frame.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_3_d_orientation.js
var require_dt_3_d_orientation = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_3_d_orientation.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_3_d_vector.js
var require_dt_3_d_vector = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_3_d_vector.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_add_nodes_item.js
var require_dt_add_nodes_item = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_add_nodes_item.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_add_references_item.js
var require_dt_add_references_item = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_add_references_item.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_additional_parameters.js
var require_dt_additional_parameters = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_additional_parameters.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_aggregate_configuration.js
var require_dt_aggregate_configuration = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_aggregate_configuration.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_alias_name.js
var require_dt_alias_name = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_alias_name.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_annotation.js
var require_dt_annotation = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_annotation.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_anonymous_identity_token.js
var require_dt_anonymous_identity_token = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_anonymous_identity_token.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_application_description.js
var require_dt_application_description = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_application_description.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_argument.js
var require_dt_argument = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_argument.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_attribute_operand.js
var require_dt_attribute_operand = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_attribute_operand.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_axis_information.js
var require_dt_axis_information = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_axis_information.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_bit_field_definition.js
var require_dt_bit_field_definition = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_bit_field_definition.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_broker_connection_transport.js
var require_dt_broker_connection_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_broker_connection_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_broker_data_set_reader_transport.js
var require_dt_broker_data_set_reader_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_broker_data_set_reader_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_broker_data_set_writer_transport.js
var require_dt_broker_data_set_writer_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_broker_data_set_writer_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_broker_writer_group_transport.js
var require_dt_broker_writer_group_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_broker_writer_group_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_build_info.js
var require_dt_build_info = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_build_info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_cartesian_coordinates.js
var require_dt_cartesian_coordinates = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_cartesian_coordinates.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_complex_number.js
var require_dt_complex_number = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_complex_number.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_configuration_version.js
var require_dt_configuration_version = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_configuration_version.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_connection_transport.js
var require_dt_connection_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_connection_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_content_filter.js
var require_dt_content_filter = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_content_filter.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_content_filter_element.js
var require_dt_content_filter_element = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_content_filter_element.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_currency_unit.js
var require_dt_currency_unit = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_currency_unit.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_data_set_meta.js
var require_dt_data_set_meta = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_data_set_meta.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_data_set_reader.js
var require_dt_data_set_reader = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_data_set_reader.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_data_set_reader_message.js
var require_dt_data_set_reader_message = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_data_set_reader_message.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_data_set_reader_transport.js
var require_dt_data_set_reader_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_data_set_reader_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_data_set_writer.js
var require_dt_data_set_writer = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_data_set_writer.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_data_set_writer_message.js
var require_dt_data_set_writer_message = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_data_set_writer_message.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_data_set_writer_transport.js
var require_dt_data_set_writer_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_data_set_writer_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_data_type_definition.js
var require_dt_data_type_definition = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_data_type_definition.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_data_type_description.js
var require_dt_data_type_description = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_data_type_description.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_data_type_schema_header.js
var require_dt_data_type_schema_header = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_data_type_schema_header.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_datagram_connection_transport.js
var require_dt_datagram_connection_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_datagram_connection_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_datagram_connection_transport_2.js
var require_dt_datagram_connection_transport_2 = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_datagram_connection_transport_2.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_datagram_data_set_reader_transport.js
var require_dt_datagram_data_set_reader_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_datagram_data_set_reader_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_datagram_writer_group_transport.js
var require_dt_datagram_writer_group_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_datagram_writer_group_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_datagram_writer_group_transport_2.js
var require_dt_datagram_writer_group_transport_2 = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_datagram_writer_group_transport_2.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_delete_nodes_item.js
var require_dt_delete_nodes_item = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_delete_nodes_item.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_delete_references_item.js
var require_dt_delete_references_item = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_delete_references_item.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_discovery_configuration.js
var require_dt_discovery_configuration = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_discovery_configuration.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_double_complex_number.js
var require_dt_double_complex_number = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_double_complex_number.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_element_operand.js
var require_dt_element_operand = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_element_operand.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_endpoint.js
var require_dt_endpoint = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_endpoint.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_endpoint_configuration.js
var require_dt_endpoint_configuration = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_endpoint_configuration.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_endpoint_description.js
var require_dt_endpoint_description = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_endpoint_description.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_endpoint_url_list.js
var require_dt_endpoint_url_list = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_endpoint_url_list.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_enum_definition.js
var require_dt_enum_definition = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_enum_definition.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_enum_description.js
var require_dt_enum_description = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_enum_description.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_enum_field.js
var require_dt_enum_field = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_enum_field.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_enum_value.js
var require_dt_enum_value = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_enum_value.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_ephemeral_key.js
var require_dt_ephemeral_key = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_ephemeral_key.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_event_filter.js
var require_dt_event_filter = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_event_filter.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_field_meta_data.js
var require_dt_field_meta_data = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_field_meta_data.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_field_target.js
var require_dt_field_target = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_field_target.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_filter_operand.js
var require_dt_filter_operand = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_filter_operand.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_frame.js
var require_dt_frame = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_frame.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_history_event.js
var require_dt_history_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_history_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_history_event_field_list.js
var require_dt_history_event_field_list = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_history_event_field_list.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_history_modified_event.js
var require_dt_history_modified_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_history_modified_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_identity_mapping_rule.js
var require_dt_identity_mapping_rule = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_identity_mapping_rule.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_issued_identity_token.js
var require_dt_issued_identity_token = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_issued_identity_token.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_json_data_set_reader_message.js
var require_dt_json_data_set_reader_message = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_json_data_set_reader_message.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_json_data_set_writer_message.js
var require_dt_json_data_set_writer_message = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_json_data_set_writer_message.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_json_writer_group_message.js
var require_dt_json_writer_group_message = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_json_writer_group_message.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_key_value_pair.js
var require_dt_key_value_pair = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_key_value_pair.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_linear_conversion.js
var require_dt_linear_conversion = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_linear_conversion.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_literal_operand.js
var require_dt_literal_operand = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_literal_operand.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_mdns_discovery_configuration.js
var require_dt_mdns_discovery_configuration = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_mdns_discovery_configuration.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_model_change_structure.js
var require_dt_model_change_structure = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_model_change_structure.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_modification_info.js
var require_dt_modification_info = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_modification_info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_monitoring_filter.js
var require_dt_monitoring_filter = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_monitoring_filter.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_network_address.js
var require_dt_network_address = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_network_address.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_network_address_url.js
var require_dt_network_address_url = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_network_address_url.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_network_group.js
var require_dt_network_group = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_network_group.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_option_set.js
var require_dt_option_set = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_option_set.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_orientation.js
var require_dt_orientation = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_orientation.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_portable_node_id.js
var require_dt_portable_node_id = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_portable_node_id.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_portable_qualified_name.js
var require_dt_portable_qualified_name = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_portable_qualified_name.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_priority_mapping_entry.js
var require_dt_priority_mapping_entry = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_priority_mapping_entry.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_program_diagnostic.js
var require_dt_program_diagnostic = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_program_diagnostic.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_program_diagnostic_2.js
var require_dt_program_diagnostic_2 = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_program_diagnostic_2.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_pub_sub_configuration.js
var require_dt_pub_sub_configuration = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_pub_sub_configuration.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_pub_sub_configuration_2.js
var require_dt_pub_sub_configuration_2 = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_pub_sub_configuration_2.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_pub_sub_configuration_ref.js
var require_dt_pub_sub_configuration_ref = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_pub_sub_configuration_ref.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_pub_sub_configuration_value.js
var require_dt_pub_sub_configuration_value = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_pub_sub_configuration_value.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_pub_sub_connection.js
var require_dt_pub_sub_connection = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_pub_sub_connection.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_pub_sub_group.js
var require_dt_pub_sub_group = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_pub_sub_group.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_pub_sub_key_push_target.js
var require_dt_pub_sub_key_push_target = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_pub_sub_key_push_target.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_published_data_items.js
var require_dt_published_data_items = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_published_data_items.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_published_data_set.js
var require_dt_published_data_set = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_published_data_set.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_published_data_set_custom_source.js
var require_dt_published_data_set_custom_source = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_published_data_set_custom_source.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_published_data_set_source.js
var require_dt_published_data_set_source = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_published_data_set_source.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_published_events.js
var require_dt_published_events = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_published_events.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_published_variable.js
var require_dt_published_variable = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_published_variable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_qos.js
var require_dt_qos = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_qos.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_quantity_dimension.js
var require_dt_quantity_dimension = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_quantity_dimension.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_range.js
var require_dt_range = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_range.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_rational_number.js
var require_dt_rational_number = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_rational_number.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_reader_group.js
var require_dt_reader_group = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_reader_group.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_reader_group_message.js
var require_dt_reader_group_message = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_reader_group_message.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_reader_group_transport.js
var require_dt_reader_group_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_reader_group_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_receive_qos.js
var require_dt_receive_qos = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_receive_qos.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_receive_qos_priority.js
var require_dt_receive_qos_priority = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_receive_qos_priority.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_redundant_server.js
var require_dt_redundant_server = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_redundant_server.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_reference_description.js
var require_dt_reference_description = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_reference_description.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_reference_list_entry.js
var require_dt_reference_list_entry = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_reference_list_entry.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_registered_server.js
var require_dt_registered_server = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_registered_server.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_relative_path.js
var require_dt_relative_path = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_relative_path.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_relative_path_element.js
var require_dt_relative_path_element = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_relative_path_element.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_role_permission.js
var require_dt_role_permission = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_role_permission.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_sampling_interval_diagnostics.js
var require_dt_sampling_interval_diagnostics = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_sampling_interval_diagnostics.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_security_group.js
var require_dt_security_group = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_security_group.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_semantic_change_structure.js
var require_dt_semantic_change_structure = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_semantic_change_structure.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_server_diagnostics_summary.js
var require_dt_server_diagnostics_summary = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_server_diagnostics_summary.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_server_on_network.js
var require_dt_server_on_network = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_server_on_network.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_server_status.js
var require_dt_server_status = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_server_status.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_service_counter.js
var require_dt_service_counter = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_service_counter.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_session_diagnostics.js
var require_dt_session_diagnostics = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_session_diagnostics.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_session_security_diagnostics.js
var require_dt_session_security_diagnostics = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_session_security_diagnostics.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_signed_software_certificate.js
var require_dt_signed_software_certificate = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_signed_software_certificate.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_simple_attribute_operand.js
var require_dt_simple_attribute_operand = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_simple_attribute_operand.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_simple_type_description.js
var require_dt_simple_type_description = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_simple_type_description.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_standalone_subscribed_data_set.js
var require_dt_standalone_subscribed_data_set = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_standalone_subscribed_data_set.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_standalone_subscribed_data_set_ref.js
var require_dt_standalone_subscribed_data_set_ref = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_standalone_subscribed_data_set_ref.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_status_result.js
var require_dt_status_result = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_status_result.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_structure.js
var require_dt_structure = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_structure.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_structure_definition.js
var require_dt_structure_definition = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_structure_definition.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_structure_description.js
var require_dt_structure_description = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_structure_description.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_structure_field.js
var require_dt_structure_field = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_structure_field.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_subscribed_data_set.js
var require_dt_subscribed_data_set = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_subscribed_data_set.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_subscribed_data_set_mirror.js
var require_dt_subscribed_data_set_mirror = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_subscribed_data_set_mirror.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_subscription_diagnostics.js
var require_dt_subscription_diagnostics = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_subscription_diagnostics.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_target_variables.js
var require_dt_target_variables = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_target_variables.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_time_zone.js
var require_dt_time_zone = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_time_zone.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_transaction_error.js
var require_dt_transaction_error = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_transaction_error.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_transmit_qos.js
var require_dt_transmit_qos = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_transmit_qos.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_transmit_qos_priority.js
var require_dt_transmit_qos_priority = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_transmit_qos_priority.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_trust_list.js
var require_dt_trust_list = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_trust_list.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_ua_binary_file.js
var require_dt_ua_binary_file = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_ua_binary_file.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_uadp_data_set_reader_message.js
var require_dt_uadp_data_set_reader_message = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_uadp_data_set_reader_message.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_uadp_data_set_writer_message.js
var require_dt_uadp_data_set_writer_message = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_uadp_data_set_writer_message.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_uadp_writer_group_message.js
var require_dt_uadp_writer_group_message = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_uadp_writer_group_message.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_union.js
var require_dt_union = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_union.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_unsigned_rational_number.js
var require_dt_unsigned_rational_number = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_unsigned_rational_number.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_user_identity_token.js
var require_dt_user_identity_token = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_user_identity_token.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_user_management.js
var require_dt_user_management = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_user_management.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_user_name_identity_token.js
var require_dt_user_name_identity_token = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_user_name_identity_token.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_user_token_policy.js
var require_dt_user_token_policy = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_user_token_policy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_vector.js
var require_dt_vector = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_vector.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_writer_group.js
var require_dt_writer_group = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_writer_group.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_writer_group_message.js
var require_dt_writer_group_message = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_writer_group_message.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_writer_group_transport.js
var require_dt_writer_group_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_writer_group_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_x_509_identity_token.js
var require_dt_x_509_identity_token = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_x_509_identity_token.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/dt_xv.js
var require_dt_xv = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/dt_xv.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_application.js
var require_enum_application = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_application.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumApplication = void 0;
    var EnumApplication;
    (function(EnumApplication2) {
      EnumApplication2[EnumApplication2["Server"] = 0] = "Server";
      EnumApplication2[EnumApplication2["Client"] = 1] = "Client";
      EnumApplication2[EnumApplication2["ClientAndServer"] = 2] = "ClientAndServer";
      EnumApplication2[EnumApplication2["DiscoveryServer"] = 3] = "DiscoveryServer";
    })(EnumApplication || (exports2.EnumApplication = EnumApplication = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_axis_scale.js
var require_enum_axis_scale = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_axis_scale.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumAxisScale = void 0;
    var EnumAxisScale;
    (function(EnumAxisScale2) {
      EnumAxisScale2[EnumAxisScale2["Linear"] = 0] = "Linear";
      EnumAxisScale2[EnumAxisScale2["Log"] = 1] = "Log";
      EnumAxisScale2[EnumAxisScale2["Ln"] = 2] = "Ln";
    })(EnumAxisScale || (exports2.EnumAxisScale = EnumAxisScale = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_broker_transport_quality_of_service.js
var require_enum_broker_transport_quality_of_service = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_broker_transport_quality_of_service.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumBrokerTransportQualityOfService = void 0;
    var EnumBrokerTransportQualityOfService;
    (function(EnumBrokerTransportQualityOfService2) {
      EnumBrokerTransportQualityOfService2[EnumBrokerTransportQualityOfService2["NotSpecified"] = 0] = "NotSpecified";
      EnumBrokerTransportQualityOfService2[EnumBrokerTransportQualityOfService2["BestEffort"] = 1] = "BestEffort";
      EnumBrokerTransportQualityOfService2[EnumBrokerTransportQualityOfService2["AtLeastOnce"] = 2] = "AtLeastOnce";
      EnumBrokerTransportQualityOfService2[EnumBrokerTransportQualityOfService2["AtMostOnce"] = 3] = "AtMostOnce";
      EnumBrokerTransportQualityOfService2[EnumBrokerTransportQualityOfService2["ExactlyOnce"] = 4] = "ExactlyOnce";
    })(EnumBrokerTransportQualityOfService || (exports2.EnumBrokerTransportQualityOfService = EnumBrokerTransportQualityOfService = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_conversion_limit_enum.js
var require_enum_conversion_limit_enum = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_conversion_limit_enum.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumConversionLimitEnum = void 0;
    var EnumConversionLimitEnum;
    (function(EnumConversionLimitEnum2) {
      EnumConversionLimitEnum2[EnumConversionLimitEnum2["NoConversion"] = 0] = "NoConversion";
      EnumConversionLimitEnum2[EnumConversionLimitEnum2["Limited"] = 1] = "Limited";
      EnumConversionLimitEnum2[EnumConversionLimitEnum2["Unlimited"] = 2] = "Unlimited";
    })(EnumConversionLimitEnum || (exports2.EnumConversionLimitEnum = EnumConversionLimitEnum = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_data_set_ordering.js
var require_enum_data_set_ordering = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_data_set_ordering.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumDataSetOrdering = void 0;
    var EnumDataSetOrdering;
    (function(EnumDataSetOrdering2) {
      EnumDataSetOrdering2[EnumDataSetOrdering2["Undefined"] = 0] = "Undefined";
      EnumDataSetOrdering2[EnumDataSetOrdering2["AscendingWriterId"] = 1] = "AscendingWriterId";
      EnumDataSetOrdering2[EnumDataSetOrdering2["AscendingWriterIdSingle"] = 2] = "AscendingWriterIdSingle";
    })(EnumDataSetOrdering || (exports2.EnumDataSetOrdering = EnumDataSetOrdering = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_diagnostics_level.js
var require_enum_diagnostics_level = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_diagnostics_level.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumDiagnosticsLevel = void 0;
    var EnumDiagnosticsLevel;
    (function(EnumDiagnosticsLevel2) {
      EnumDiagnosticsLevel2[EnumDiagnosticsLevel2["Basic"] = 0] = "Basic";
      EnumDiagnosticsLevel2[EnumDiagnosticsLevel2["Advanced"] = 1] = "Advanced";
      EnumDiagnosticsLevel2[EnumDiagnosticsLevel2["Info"] = 2] = "Info";
      EnumDiagnosticsLevel2[EnumDiagnosticsLevel2["Log"] = 3] = "Log";
      EnumDiagnosticsLevel2[EnumDiagnosticsLevel2["Debug"] = 4] = "Debug";
    })(EnumDiagnosticsLevel || (exports2.EnumDiagnosticsLevel = EnumDiagnosticsLevel = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_duplex.js
var require_enum_duplex = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_duplex.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumDuplex = void 0;
    var EnumDuplex;
    (function(EnumDuplex2) {
      EnumDuplex2[EnumDuplex2["Full"] = 0] = "Full";
      EnumDuplex2[EnumDuplex2["Half"] = 1] = "Half";
      EnumDuplex2[EnumDuplex2["Unknown"] = 2] = "Unknown";
    })(EnumDuplex || (exports2.EnumDuplex = EnumDuplex = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_exception_deviation_format.js
var require_enum_exception_deviation_format = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_exception_deviation_format.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumExceptionDeviationFormat = void 0;
    var EnumExceptionDeviationFormat;
    (function(EnumExceptionDeviationFormat2) {
      EnumExceptionDeviationFormat2[EnumExceptionDeviationFormat2["AbsoluteValue"] = 0] = "AbsoluteValue";
      EnumExceptionDeviationFormat2[EnumExceptionDeviationFormat2["PercentOfValue"] = 1] = "PercentOfValue";
      EnumExceptionDeviationFormat2[EnumExceptionDeviationFormat2["PercentOfRange"] = 2] = "PercentOfRange";
      EnumExceptionDeviationFormat2[EnumExceptionDeviationFormat2["PercentOfEURange"] = 3] = "PercentOfEURange";
      EnumExceptionDeviationFormat2[EnumExceptionDeviationFormat2["Unknown"] = 4] = "Unknown";
    })(EnumExceptionDeviationFormat || (exports2.EnumExceptionDeviationFormat = EnumExceptionDeviationFormat = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_filter_operator.js
var require_enum_filter_operator = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_filter_operator.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumFilterOperator = void 0;
    var EnumFilterOperator;
    (function(EnumFilterOperator2) {
      EnumFilterOperator2[EnumFilterOperator2["Equals"] = 0] = "Equals";
      EnumFilterOperator2[EnumFilterOperator2["IsNull"] = 1] = "IsNull";
      EnumFilterOperator2[EnumFilterOperator2["GreaterThan"] = 2] = "GreaterThan";
      EnumFilterOperator2[EnumFilterOperator2["LessThan"] = 3] = "LessThan";
      EnumFilterOperator2[EnumFilterOperator2["GreaterThanOrEqual"] = 4] = "GreaterThanOrEqual";
      EnumFilterOperator2[EnumFilterOperator2["LessThanOrEqual"] = 5] = "LessThanOrEqual";
      EnumFilterOperator2[EnumFilterOperator2["Like"] = 6] = "Like";
      EnumFilterOperator2[EnumFilterOperator2["Not"] = 7] = "Not";
      EnumFilterOperator2[EnumFilterOperator2["Between"] = 8] = "Between";
      EnumFilterOperator2[EnumFilterOperator2["InList"] = 9] = "InList";
      EnumFilterOperator2[EnumFilterOperator2["And"] = 10] = "And";
      EnumFilterOperator2[EnumFilterOperator2["Or"] = 11] = "Or";
      EnumFilterOperator2[EnumFilterOperator2["Cast"] = 12] = "Cast";
      EnumFilterOperator2[EnumFilterOperator2["InView"] = 13] = "InView";
      EnumFilterOperator2[EnumFilterOperator2["OfType"] = 14] = "OfType";
      EnumFilterOperator2[EnumFilterOperator2["RelatedTo"] = 15] = "RelatedTo";
      EnumFilterOperator2[EnumFilterOperator2["BitwiseAnd"] = 16] = "BitwiseAnd";
      EnumFilterOperator2[EnumFilterOperator2["BitwiseOr"] = 17] = "BitwiseOr";
    })(EnumFilterOperator || (exports2.EnumFilterOperator = EnumFilterOperator = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_history_update.js
var require_enum_history_update = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_history_update.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumHistoryUpdate = void 0;
    var EnumHistoryUpdate;
    (function(EnumHistoryUpdate2) {
      EnumHistoryUpdate2[EnumHistoryUpdate2["Insert"] = 1] = "Insert";
      EnumHistoryUpdate2[EnumHistoryUpdate2["Replace"] = 2] = "Replace";
      EnumHistoryUpdate2[EnumHistoryUpdate2["Update"] = 3] = "Update";
      EnumHistoryUpdate2[EnumHistoryUpdate2["Delete"] = 4] = "Delete";
    })(EnumHistoryUpdate || (exports2.EnumHistoryUpdate = EnumHistoryUpdate = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_id.js
var require_enum_id = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_id.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumId = void 0;
    var EnumId;
    (function(EnumId2) {
      EnumId2[EnumId2["Numeric"] = 0] = "Numeric";
      EnumId2[EnumId2["String"] = 1] = "String";
      EnumId2[EnumId2["Guid"] = 2] = "Guid";
      EnumId2[EnumId2["Opaque"] = 3] = "Opaque";
    })(EnumId || (exports2.EnumId = EnumId = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_identity_criteria.js
var require_enum_identity_criteria = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_identity_criteria.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumIdentityCriteria = void 0;
    var EnumIdentityCriteria;
    (function(EnumIdentityCriteria2) {
      EnumIdentityCriteria2[EnumIdentityCriteria2["UserName"] = 1] = "UserName";
      EnumIdentityCriteria2[EnumIdentityCriteria2["Thumbprint"] = 2] = "Thumbprint";
      EnumIdentityCriteria2[EnumIdentityCriteria2["Role"] = 3] = "Role";
      EnumIdentityCriteria2[EnumIdentityCriteria2["GroupId"] = 4] = "GroupId";
      EnumIdentityCriteria2[EnumIdentityCriteria2["Anonymous"] = 5] = "Anonymous";
      EnumIdentityCriteria2[EnumIdentityCriteria2["AuthenticatedUser"] = 6] = "AuthenticatedUser";
      EnumIdentityCriteria2[EnumIdentityCriteria2["Application"] = 7] = "Application";
      EnumIdentityCriteria2[EnumIdentityCriteria2["X509Subject"] = 8] = "X509Subject";
    })(EnumIdentityCriteria || (exports2.EnumIdentityCriteria = EnumIdentityCriteria = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_interface_admin_status.js
var require_enum_interface_admin_status = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_interface_admin_status.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumInterfaceAdminStatus = void 0;
    var EnumInterfaceAdminStatus;
    (function(EnumInterfaceAdminStatus2) {
      EnumInterfaceAdminStatus2[EnumInterfaceAdminStatus2["Up"] = 0] = "Up";
      EnumInterfaceAdminStatus2[EnumInterfaceAdminStatus2["Down"] = 1] = "Down";
      EnumInterfaceAdminStatus2[EnumInterfaceAdminStatus2["Testing"] = 2] = "Testing";
    })(EnumInterfaceAdminStatus || (exports2.EnumInterfaceAdminStatus = EnumInterfaceAdminStatus = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_interface_oper_status.js
var require_enum_interface_oper_status = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_interface_oper_status.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumInterfaceOperStatus = void 0;
    var EnumInterfaceOperStatus;
    (function(EnumInterfaceOperStatus2) {
      EnumInterfaceOperStatus2[EnumInterfaceOperStatus2["Up"] = 0] = "Up";
      EnumInterfaceOperStatus2[EnumInterfaceOperStatus2["Down"] = 1] = "Down";
      EnumInterfaceOperStatus2[EnumInterfaceOperStatus2["Testing"] = 2] = "Testing";
      EnumInterfaceOperStatus2[EnumInterfaceOperStatus2["Unknown"] = 3] = "Unknown";
      EnumInterfaceOperStatus2[EnumInterfaceOperStatus2["Dormant"] = 4] = "Dormant";
      EnumInterfaceOperStatus2[EnumInterfaceOperStatus2["NotPresent"] = 5] = "NotPresent";
      EnumInterfaceOperStatus2[EnumInterfaceOperStatus2["LowerLayerDown"] = 6] = "LowerLayerDown";
    })(EnumInterfaceOperStatus || (exports2.EnumInterfaceOperStatus = EnumInterfaceOperStatus = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_message_security_mode.js
var require_enum_message_security_mode = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_message_security_mode.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumMessageSecurityMode = void 0;
    var EnumMessageSecurityMode;
    (function(EnumMessageSecurityMode2) {
      EnumMessageSecurityMode2[EnumMessageSecurityMode2["Invalid"] = 0] = "Invalid";
      EnumMessageSecurityMode2[EnumMessageSecurityMode2["None"] = 1] = "None";
      EnumMessageSecurityMode2[EnumMessageSecurityMode2["Sign"] = 2] = "Sign";
      EnumMessageSecurityMode2[EnumMessageSecurityMode2["SignAndEncrypt"] = 3] = "SignAndEncrypt";
    })(EnumMessageSecurityMode || (exports2.EnumMessageSecurityMode = EnumMessageSecurityMode = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_naming_rule.js
var require_enum_naming_rule = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_naming_rule.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumNamingRule = void 0;
    var EnumNamingRule;
    (function(EnumNamingRule2) {
      EnumNamingRule2[EnumNamingRule2["Mandatory"] = 1] = "Mandatory";
      EnumNamingRule2[EnumNamingRule2["Optional"] = 2] = "Optional";
      EnumNamingRule2[EnumNamingRule2["Constraint"] = 3] = "Constraint";
    })(EnumNamingRule || (exports2.EnumNamingRule = EnumNamingRule = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_negotiation_status.js
var require_enum_negotiation_status = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_negotiation_status.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumNegotiationStatus = void 0;
    var EnumNegotiationStatus;
    (function(EnumNegotiationStatus2) {
      EnumNegotiationStatus2[EnumNegotiationStatus2["InProgress"] = 0] = "InProgress";
      EnumNegotiationStatus2[EnumNegotiationStatus2["Complete"] = 1] = "Complete";
      EnumNegotiationStatus2[EnumNegotiationStatus2["Failed"] = 2] = "Failed";
      EnumNegotiationStatus2[EnumNegotiationStatus2["Unknown"] = 3] = "Unknown";
      EnumNegotiationStatus2[EnumNegotiationStatus2["NoNegotiation"] = 4] = "NoNegotiation";
    })(EnumNegotiationStatus || (exports2.EnumNegotiationStatus = EnumNegotiationStatus = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_node_attributes_mask.js
var require_enum_node_attributes_mask = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_node_attributes_mask.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumNodeAttributesMask = void 0;
    var EnumNodeAttributesMask;
    (function(EnumNodeAttributesMask2) {
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["None"] = 0] = "None";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["AccessLevel"] = 1] = "AccessLevel";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["ArrayDimensions"] = 2] = "ArrayDimensions";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["BrowseName"] = 4] = "BrowseName";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["ContainsNoLoops"] = 8] = "ContainsNoLoops";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["DataType"] = 16] = "DataType";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["Description"] = 32] = "Description";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["DisplayName"] = 64] = "DisplayName";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["EventNotifier"] = 128] = "EventNotifier";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["Executable"] = 256] = "Executable";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["Historizing"] = 512] = "Historizing";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["InverseName"] = 1024] = "InverseName";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["IsAbstract"] = 2048] = "IsAbstract";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["MinimumSamplingInterval"] = 4096] = "MinimumSamplingInterval";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["NodeClass"] = 8192] = "NodeClass";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["NodeId"] = 16384] = "NodeId";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["Symmetric"] = 32768] = "Symmetric";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["UserAccessLevel"] = 65536] = "UserAccessLevel";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["UserExecutable"] = 131072] = "UserExecutable";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["UserWriteMask"] = 262144] = "UserWriteMask";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["ValueRank"] = 524288] = "ValueRank";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["WriteMask"] = 1048576] = "WriteMask";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["Value"] = 2097152] = "Value";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["DataTypeDefinition"] = 4194304] = "DataTypeDefinition";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["RolePermissions"] = 8388608] = "RolePermissions";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["AccessRestrictions"] = 16777216] = "AccessRestrictions";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["All"] = 33554431] = "All";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["BaseNode"] = 26501220] = "BaseNode";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["Object"] = 26501348] = "Object";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["ObjectType"] = 26503268] = "ObjectType";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["Variable"] = 26571383] = "Variable";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["VariableType"] = 28600438] = "VariableType";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["Method"] = 26632548] = "Method";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["ReferenceType"] = 26537060] = "ReferenceType";
      EnumNodeAttributesMask2[EnumNodeAttributesMask2["View"] = 26501356] = "View";
    })(EnumNodeAttributesMask || (exports2.EnumNodeAttributesMask = EnumNodeAttributesMask = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_node_class.js
var require_enum_node_class = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_node_class.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumNodeClass = void 0;
    var EnumNodeClass;
    (function(EnumNodeClass2) {
      EnumNodeClass2[EnumNodeClass2["Unspecified"] = 0] = "Unspecified";
      EnumNodeClass2[EnumNodeClass2["Object"] = 1] = "Object";
      EnumNodeClass2[EnumNodeClass2["Variable"] = 2] = "Variable";
      EnumNodeClass2[EnumNodeClass2["Method"] = 4] = "Method";
      EnumNodeClass2[EnumNodeClass2["ObjectType"] = 8] = "ObjectType";
      EnumNodeClass2[EnumNodeClass2["VariableType"] = 16] = "VariableType";
      EnumNodeClass2[EnumNodeClass2["ReferenceType"] = 32] = "ReferenceType";
      EnumNodeClass2[EnumNodeClass2["DataType"] = 64] = "DataType";
      EnumNodeClass2[EnumNodeClass2["View"] = 128] = "View";
    })(EnumNodeClass || (exports2.EnumNodeClass = EnumNodeClass = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_open_file_mode.js
var require_enum_open_file_mode = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_open_file_mode.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumOpenFileMode = void 0;
    var EnumOpenFileMode;
    (function(EnumOpenFileMode2) {
      EnumOpenFileMode2[EnumOpenFileMode2["Read"] = 1] = "Read";
      EnumOpenFileMode2[EnumOpenFileMode2["Write"] = 2] = "Write";
      EnumOpenFileMode2[EnumOpenFileMode2["EraseExisting"] = 4] = "EraseExisting";
      EnumOpenFileMode2[EnumOpenFileMode2["Append"] = 8] = "Append";
    })(EnumOpenFileMode || (exports2.EnumOpenFileMode = EnumOpenFileMode = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_override_value_handling.js
var require_enum_override_value_handling = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_override_value_handling.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumOverrideValueHandling = void 0;
    var EnumOverrideValueHandling;
    (function(EnumOverrideValueHandling2) {
      EnumOverrideValueHandling2[EnumOverrideValueHandling2["Disabled"] = 0] = "Disabled";
      EnumOverrideValueHandling2[EnumOverrideValueHandling2["LastUsableValue"] = 1] = "LastUsableValue";
      EnumOverrideValueHandling2[EnumOverrideValueHandling2["OverrideValue"] = 2] = "OverrideValue";
    })(EnumOverrideValueHandling || (exports2.EnumOverrideValueHandling = EnumOverrideValueHandling = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_perform_update.js
var require_enum_perform_update = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_perform_update.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumPerformUpdate = void 0;
    var EnumPerformUpdate;
    (function(EnumPerformUpdate2) {
      EnumPerformUpdate2[EnumPerformUpdate2["Insert"] = 1] = "Insert";
      EnumPerformUpdate2[EnumPerformUpdate2["Replace"] = 2] = "Replace";
      EnumPerformUpdate2[EnumPerformUpdate2["Update"] = 3] = "Update";
      EnumPerformUpdate2[EnumPerformUpdate2["Remove"] = 4] = "Remove";
    })(EnumPerformUpdate || (exports2.EnumPerformUpdate = EnumPerformUpdate = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_pub_sub_diagnostics_counter_classification.js
var require_enum_pub_sub_diagnostics_counter_classification = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_pub_sub_diagnostics_counter_classification.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumPubSubDiagnosticsCounterClassification = void 0;
    var EnumPubSubDiagnosticsCounterClassification;
    (function(EnumPubSubDiagnosticsCounterClassification2) {
      EnumPubSubDiagnosticsCounterClassification2[EnumPubSubDiagnosticsCounterClassification2["Information"] = 0] = "Information";
      EnumPubSubDiagnosticsCounterClassification2[EnumPubSubDiagnosticsCounterClassification2["Error"] = 1] = "Error";
    })(EnumPubSubDiagnosticsCounterClassification || (exports2.EnumPubSubDiagnosticsCounterClassification = EnumPubSubDiagnosticsCounterClassification = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_pub_sub_state.js
var require_enum_pub_sub_state = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_pub_sub_state.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumPubSubState = void 0;
    var EnumPubSubState;
    (function(EnumPubSubState2) {
      EnumPubSubState2[EnumPubSubState2["Disabled"] = 0] = "Disabled";
      EnumPubSubState2[EnumPubSubState2["Paused"] = 1] = "Paused";
      EnumPubSubState2[EnumPubSubState2["Operational"] = 2] = "Operational";
      EnumPubSubState2[EnumPubSubState2["Error"] = 3] = "Error";
      EnumPubSubState2[EnumPubSubState2["PreOperational"] = 4] = "PreOperational";
    })(EnumPubSubState || (exports2.EnumPubSubState = EnumPubSubState = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_redundancy_support.js
var require_enum_redundancy_support = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_redundancy_support.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumRedundancySupport = void 0;
    var EnumRedundancySupport;
    (function(EnumRedundancySupport2) {
      EnumRedundancySupport2[EnumRedundancySupport2["None"] = 0] = "None";
      EnumRedundancySupport2[EnumRedundancySupport2["Cold"] = 1] = "Cold";
      EnumRedundancySupport2[EnumRedundancySupport2["Warm"] = 2] = "Warm";
      EnumRedundancySupport2[EnumRedundancySupport2["Hot"] = 3] = "Hot";
      EnumRedundancySupport2[EnumRedundancySupport2["Transparent"] = 4] = "Transparent";
      EnumRedundancySupport2[EnumRedundancySupport2["HotAndMirrored"] = 5] = "HotAndMirrored";
    })(EnumRedundancySupport || (exports2.EnumRedundancySupport = EnumRedundancySupport = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_redundant_server_mode.js
var require_enum_redundant_server_mode = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_redundant_server_mode.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumRedundantServerMode = void 0;
    var EnumRedundantServerMode;
    (function(EnumRedundantServerMode2) {
      EnumRedundantServerMode2[EnumRedundantServerMode2["PrimaryWithBackup"] = 0] = "PrimaryWithBackup";
      EnumRedundantServerMode2[EnumRedundantServerMode2["PrimaryOnly"] = 1] = "PrimaryOnly";
      EnumRedundantServerMode2[EnumRedundantServerMode2["BackupReady"] = 2] = "BackupReady";
      EnumRedundantServerMode2[EnumRedundantServerMode2["BackupNotReady"] = 3] = "BackupNotReady";
    })(EnumRedundantServerMode || (exports2.EnumRedundantServerMode = EnumRedundantServerMode = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_security_token_request.js
var require_enum_security_token_request = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_security_token_request.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumSecurityTokenRequest = void 0;
    var EnumSecurityTokenRequest;
    (function(EnumSecurityTokenRequest2) {
      EnumSecurityTokenRequest2[EnumSecurityTokenRequest2["Issue"] = 0] = "Issue";
      EnumSecurityTokenRequest2[EnumSecurityTokenRequest2["Renew"] = 1] = "Renew";
    })(EnumSecurityTokenRequest || (exports2.EnumSecurityTokenRequest = EnumSecurityTokenRequest = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_server_state.js
var require_enum_server_state = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_server_state.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumServerState = void 0;
    var EnumServerState;
    (function(EnumServerState2) {
      EnumServerState2[EnumServerState2["Running"] = 0] = "Running";
      EnumServerState2[EnumServerState2["Failed"] = 1] = "Failed";
      EnumServerState2[EnumServerState2["NoConfiguration"] = 2] = "NoConfiguration";
      EnumServerState2[EnumServerState2["Suspended"] = 3] = "Suspended";
      EnumServerState2[EnumServerState2["Shutdown"] = 4] = "Shutdown";
      EnumServerState2[EnumServerState2["Test"] = 5] = "Test";
      EnumServerState2[EnumServerState2["CommunicationFault"] = 6] = "CommunicationFault";
      EnumServerState2[EnumServerState2["Unknown"] = 7] = "Unknown";
    })(EnumServerState || (exports2.EnumServerState = EnumServerState = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_structure.js
var require_enum_structure = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_structure.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumStructure = void 0;
    var EnumStructure;
    (function(EnumStructure2) {
      EnumStructure2[EnumStructure2["Structure"] = 0] = "Structure";
      EnumStructure2[EnumStructure2["StructureWithOptionalFields"] = 1] = "StructureWithOptionalFields";
      EnumStructure2[EnumStructure2["Union"] = 2] = "Union";
      EnumStructure2[EnumStructure2["StructureWithSubtypedValues"] = 3] = "StructureWithSubtypedValues";
      EnumStructure2[EnumStructure2["UnionWithSubtypedValues"] = 4] = "UnionWithSubtypedValues";
    })(EnumStructure || (exports2.EnumStructure = EnumStructure = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_trust_list_masks.js
var require_enum_trust_list_masks = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_trust_list_masks.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumTrustListMasks = void 0;
    var EnumTrustListMasks;
    (function(EnumTrustListMasks2) {
      EnumTrustListMasks2[EnumTrustListMasks2["None"] = 0] = "None";
      EnumTrustListMasks2[EnumTrustListMasks2["TrustedCertificates"] = 1] = "TrustedCertificates";
      EnumTrustListMasks2[EnumTrustListMasks2["TrustedCrls"] = 2] = "TrustedCrls";
      EnumTrustListMasks2[EnumTrustListMasks2["IssuerCertificates"] = 4] = "IssuerCertificates";
      EnumTrustListMasks2[EnumTrustListMasks2["IssuerCrls"] = 8] = "IssuerCrls";
      EnumTrustListMasks2[EnumTrustListMasks2["All"] = 15] = "All";
    })(EnumTrustListMasks || (exports2.EnumTrustListMasks = EnumTrustListMasks = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_tsn_failure_code.js
var require_enum_tsn_failure_code = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_tsn_failure_code.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumTsnFailureCode = void 0;
    var EnumTsnFailureCode;
    (function(EnumTsnFailureCode2) {
      EnumTsnFailureCode2[EnumTsnFailureCode2["NoFailure"] = 0] = "NoFailure";
      EnumTsnFailureCode2[EnumTsnFailureCode2["InsufficientBandwidth"] = 1] = "InsufficientBandwidth";
      EnumTsnFailureCode2[EnumTsnFailureCode2["InsufficientResources"] = 2] = "InsufficientResources";
      EnumTsnFailureCode2[EnumTsnFailureCode2["InsufficientTrafficClassBandwidth"] = 3] = "InsufficientTrafficClassBandwidth";
      EnumTsnFailureCode2[EnumTsnFailureCode2["StreamIdInUse"] = 4] = "StreamIdInUse";
      EnumTsnFailureCode2[EnumTsnFailureCode2["StreamDestinationAddressInUse"] = 5] = "StreamDestinationAddressInUse";
      EnumTsnFailureCode2[EnumTsnFailureCode2["StreamPreemptedByHigherRank"] = 6] = "StreamPreemptedByHigherRank";
      EnumTsnFailureCode2[EnumTsnFailureCode2["LatencyHasChanged"] = 7] = "LatencyHasChanged";
      EnumTsnFailureCode2[EnumTsnFailureCode2["EgressPortNotAvbCapable"] = 8] = "EgressPortNotAvbCapable";
      EnumTsnFailureCode2[EnumTsnFailureCode2["UseDifferentDestinationAddress"] = 9] = "UseDifferentDestinationAddress";
      EnumTsnFailureCode2[EnumTsnFailureCode2["OutOfMsrpResources"] = 10] = "OutOfMsrpResources";
      EnumTsnFailureCode2[EnumTsnFailureCode2["OutOfMmrpResources"] = 11] = "OutOfMmrpResources";
      EnumTsnFailureCode2[EnumTsnFailureCode2["CannotStoreDestinationAddress"] = 12] = "CannotStoreDestinationAddress";
      EnumTsnFailureCode2[EnumTsnFailureCode2["PriorityIsNotAnSrcClass"] = 13] = "PriorityIsNotAnSrcClass";
      EnumTsnFailureCode2[EnumTsnFailureCode2["MaxFrameSizeTooLarge"] = 14] = "MaxFrameSizeTooLarge";
      EnumTsnFailureCode2[EnumTsnFailureCode2["MaxFanInPortsLimitReached"] = 15] = "MaxFanInPortsLimitReached";
      EnumTsnFailureCode2[EnumTsnFailureCode2["FirstValueChangedForStreamId"] = 16] = "FirstValueChangedForStreamId";
      EnumTsnFailureCode2[EnumTsnFailureCode2["VlanBlockedOnEgress"] = 17] = "VlanBlockedOnEgress";
      EnumTsnFailureCode2[EnumTsnFailureCode2["VlanTaggingDisabledOnEgress"] = 18] = "VlanTaggingDisabledOnEgress";
      EnumTsnFailureCode2[EnumTsnFailureCode2["SrClassPriorityMismatch"] = 19] = "SrClassPriorityMismatch";
      EnumTsnFailureCode2[EnumTsnFailureCode2["FeatureNotPropagated"] = 20] = "FeatureNotPropagated";
      EnumTsnFailureCode2[EnumTsnFailureCode2["MaxLatencyExceeded"] = 21] = "MaxLatencyExceeded";
      EnumTsnFailureCode2[EnumTsnFailureCode2["BridgeDoesNotProvideNetworkId"] = 22] = "BridgeDoesNotProvideNetworkId";
      EnumTsnFailureCode2[EnumTsnFailureCode2["StreamTransformNotSupported"] = 23] = "StreamTransformNotSupported";
      EnumTsnFailureCode2[EnumTsnFailureCode2["StreamIdTypeNotSupported"] = 24] = "StreamIdTypeNotSupported";
      EnumTsnFailureCode2[EnumTsnFailureCode2["FeatureNotSupported"] = 25] = "FeatureNotSupported";
    })(EnumTsnFailureCode || (exports2.EnumTsnFailureCode = EnumTsnFailureCode = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_tsn_listener_status.js
var require_enum_tsn_listener_status = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_tsn_listener_status.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumTsnListenerStatus = void 0;
    var EnumTsnListenerStatus;
    (function(EnumTsnListenerStatus2) {
      EnumTsnListenerStatus2[EnumTsnListenerStatus2["None"] = 0] = "None";
      EnumTsnListenerStatus2[EnumTsnListenerStatus2["Ready"] = 1] = "Ready";
      EnumTsnListenerStatus2[EnumTsnListenerStatus2["PartialFailed"] = 2] = "PartialFailed";
      EnumTsnListenerStatus2[EnumTsnListenerStatus2["Failed"] = 3] = "Failed";
    })(EnumTsnListenerStatus || (exports2.EnumTsnListenerStatus = EnumTsnListenerStatus = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_tsn_stream_state.js
var require_enum_tsn_stream_state = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_tsn_stream_state.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumTsnStreamState = void 0;
    var EnumTsnStreamState;
    (function(EnumTsnStreamState2) {
      EnumTsnStreamState2[EnumTsnStreamState2["Disabled"] = 0] = "Disabled";
      EnumTsnStreamState2[EnumTsnStreamState2["Configuring"] = 1] = "Configuring";
      EnumTsnStreamState2[EnumTsnStreamState2["Ready"] = 2] = "Ready";
      EnumTsnStreamState2[EnumTsnStreamState2["Operational"] = 3] = "Operational";
      EnumTsnStreamState2[EnumTsnStreamState2["Error"] = 4] = "Error";
    })(EnumTsnStreamState || (exports2.EnumTsnStreamState = EnumTsnStreamState = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_tsn_talker_status.js
var require_enum_tsn_talker_status = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_tsn_talker_status.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumTsnTalkerStatus = void 0;
    var EnumTsnTalkerStatus;
    (function(EnumTsnTalkerStatus2) {
      EnumTsnTalkerStatus2[EnumTsnTalkerStatus2["None"] = 0] = "None";
      EnumTsnTalkerStatus2[EnumTsnTalkerStatus2["Ready"] = 1] = "Ready";
      EnumTsnTalkerStatus2[EnumTsnTalkerStatus2["Failed"] = 2] = "Failed";
    })(EnumTsnTalkerStatus || (exports2.EnumTsnTalkerStatus = EnumTsnTalkerStatus = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/enum_user_token.js
var require_enum_user_token = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/enum_user_token.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.EnumUserToken = void 0;
    var EnumUserToken;
    (function(EnumUserToken2) {
      EnumUserToken2[EnumUserToken2["Anonymous"] = 0] = "Anonymous";
      EnumUserToken2[EnumUserToken2["UserName"] = 1] = "UserName";
      EnumUserToken2[EnumUserToken2["Certificate"] = 2] = "Certificate";
      EnumUserToken2[EnumUserToken2["IssuedToken"] = 3] = "IssuedToken";
    })(EnumUserToken || (exports2.EnumUserToken = EnumUserToken = {}));
  }
});

// node_modules/node-opcua-nodeset-ua/dist/eu_information.js
var require_eu_information = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/eu_information.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_3_d_cartesian_coordinates.js
var require_ua_3_d_cartesian_coordinates = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_3_d_cartesian_coordinates.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_3_d_frame.js
var require_ua_3_d_frame = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_3_d_frame.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_3_d_orientation.js
var require_ua_3_d_orientation = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_3_d_orientation.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_3_d_vector.js
var require_ua_3_d_vector = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_3_d_vector.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_acknowledgeable_condition.js
var require_ua_acknowledgeable_condition = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_acknowledgeable_condition.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_address_space_file.js
var require_ua_address_space_file = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_address_space_file.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_aggregate_configuration.js
var require_ua_aggregate_configuration = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_aggregate_configuration.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_aggregate_function.js
var require_ua_aggregate_function = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_aggregate_function.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_alarm_condition.js
var require_ua_alarm_condition = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_alarm_condition.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_alarm_group.js
var require_ua_alarm_group = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_alarm_group.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_alarm_metrics.js
var require_ua_alarm_metrics = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_alarm_metrics.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_alarm_rate_variable.js
var require_ua_alarm_rate_variable = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_alarm_rate_variable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_alarm_state_variable.js
var require_ua_alarm_state_variable = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_alarm_state_variable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_alarm_suppression_group.js
var require_ua_alarm_suppression_group = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_alarm_suppression_group.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_alias_name.js
var require_ua_alias_name = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_alias_name.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_alias_name_category.js
var require_ua_alias_name_category = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_alias_name_category.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_alternative_unit.js
var require_ua_alternative_unit = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_alternative_unit.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_analog_item.js
var require_ua_analog_item = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_analog_item.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_analog_unit.js
var require_ua_analog_unit = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_analog_unit.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_analog_unit_range.js
var require_ua_analog_unit_range = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_analog_unit_range.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_application_certificate.js
var require_ua_application_certificate = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_application_certificate.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_application_configuration.js
var require_ua_application_configuration = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_application_configuration.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_array_item.js
var require_ua_array_item = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_array_item.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audio_variable.js
var require_ua_audio_variable = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audio_variable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_activate_session_event.js
var require_ua_audit_activate_session_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_activate_session_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_add_nodes_event.js
var require_ua_audit_add_nodes_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_add_nodes_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_add_references_event.js
var require_ua_audit_add_references_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_add_references_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_cancel_event.js
var require_ua_audit_cancel_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_cancel_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_certificate_data_mismatch_event.js
var require_ua_audit_certificate_data_mismatch_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_certificate_data_mismatch_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_certificate_event.js
var require_ua_audit_certificate_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_certificate_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_certificate_expired_event.js
var require_ua_audit_certificate_expired_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_certificate_expired_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_certificate_invalid_event.js
var require_ua_audit_certificate_invalid_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_certificate_invalid_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_certificate_mismatch_event.js
var require_ua_audit_certificate_mismatch_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_certificate_mismatch_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_certificate_revoked_event.js
var require_ua_audit_certificate_revoked_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_certificate_revoked_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_certificate_untrusted_event.js
var require_ua_audit_certificate_untrusted_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_certificate_untrusted_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_channel_event.js
var require_ua_audit_channel_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_channel_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_client_event.js
var require_ua_audit_client_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_client_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_client_update_method_result_event.js
var require_ua_audit_client_update_method_result_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_client_update_method_result_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_acknowledge_event.js
var require_ua_audit_condition_acknowledge_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_acknowledge_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_comment_event.js
var require_ua_audit_condition_comment_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_comment_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_confirm_event.js
var require_ua_audit_condition_confirm_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_confirm_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_enable_event.js
var require_ua_audit_condition_enable_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_enable_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_event.js
var require_ua_audit_condition_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_out_of_service_event.js
var require_ua_audit_condition_out_of_service_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_out_of_service_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_reset_event.js
var require_ua_audit_condition_reset_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_reset_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_respond_event.js
var require_ua_audit_condition_respond_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_respond_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_shelving_event.js
var require_ua_audit_condition_shelving_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_shelving_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_silence_event.js
var require_ua_audit_condition_silence_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_silence_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_suppression_event.js
var require_ua_audit_condition_suppression_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_condition_suppression_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_create_session_event.js
var require_ua_audit_create_session_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_create_session_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_delete_nodes_event.js
var require_ua_audit_delete_nodes_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_delete_nodes_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_delete_references_event.js
var require_ua_audit_delete_references_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_delete_references_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_event.js
var require_ua_audit_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_history_annotation_update_event.js
var require_ua_audit_history_annotation_update_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_history_annotation_update_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_history_at_time_delete_event.js
var require_ua_audit_history_at_time_delete_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_history_at_time_delete_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_history_bulk_insert_event.js
var require_ua_audit_history_bulk_insert_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_history_bulk_insert_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_history_configuration_change_event.js
var require_ua_audit_history_configuration_change_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_history_configuration_change_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_history_delete_event.js
var require_ua_audit_history_delete_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_history_delete_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_history_event_delete_event.js
var require_ua_audit_history_event_delete_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_history_event_delete_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_history_event_update_event.js
var require_ua_audit_history_event_update_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_history_event_update_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_history_raw_modify_delete_event.js
var require_ua_audit_history_raw_modify_delete_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_history_raw_modify_delete_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_history_update_event.js
var require_ua_audit_history_update_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_history_update_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_history_value_update_event.js
var require_ua_audit_history_value_update_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_history_value_update_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_node_management_event.js
var require_ua_audit_node_management_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_node_management_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_open_secure_channel_event.js
var require_ua_audit_open_secure_channel_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_open_secure_channel_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_program_transition_event.js
var require_ua_audit_program_transition_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_program_transition_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_security_event.js
var require_ua_audit_security_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_security_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_session_event.js
var require_ua_audit_session_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_session_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_update_event.js
var require_ua_audit_update_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_update_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_update_method_event.js
var require_ua_audit_update_method_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_update_method_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_update_state_event.js
var require_ua_audit_update_state_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_update_state_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_url_mismatch_event.js
var require_ua_audit_url_mismatch_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_url_mismatch_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_audit_write_update_event.js
var require_ua_audit_write_update_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_audit_write_update_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_authorization_service_configuration.js
var require_ua_authorization_service_configuration = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_authorization_service_configuration.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_authorization_services_configuration_folder.js
var require_ua_authorization_services_configuration_folder = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_authorization_services_configuration_folder.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_base_analog.js
var require_ua_base_analog = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_base_analog.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_base_condition_class.js
var require_ua_base_condition_class = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_base_condition_class.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_base_data_variable.js
var require_ua_base_data_variable = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_base_data_variable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_base_event.js
var require_ua_base_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_base_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_base_interface.js
var require_ua_base_interface = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_base_interface.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_base_model_change_event.js
var require_ua_base_model_change_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_base_model_change_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_bit_field.js
var require_ua_bit_field = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_bit_field.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_broker_connection_transport.js
var require_ua_broker_connection_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_broker_connection_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_broker_data_set_reader_transport.js
var require_ua_broker_data_set_reader_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_broker_data_set_reader_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_broker_data_set_writer_transport.js
var require_ua_broker_data_set_writer_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_broker_data_set_writer_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_broker_writer_group_transport.js
var require_ua_broker_writer_group_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_broker_writer_group_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_build_info.js
var require_ua_build_info = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_build_info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_cartesian_coordinates.js
var require_ua_cartesian_coordinates = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_cartesian_coordinates.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_certificate.js
var require_ua_certificate = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_certificate.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_certificate_expiration_alarm.js
var require_ua_certificate_expiration_alarm = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_certificate_expiration_alarm.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_certificate_group.js
var require_ua_certificate_group = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_certificate_group.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_certificate_group_folder.js
var require_ua_certificate_group_folder = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_certificate_group_folder.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_certificate_update_requested_audit_event.js
var require_ua_certificate_update_requested_audit_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_certificate_update_requested_audit_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_certificate_updated_audit_event.js
var require_ua_certificate_updated_audit_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_certificate_updated_audit_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_choice_state.js
var require_ua_choice_state = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_choice_state.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_condition.js
var require_ua_condition = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_condition.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_condition_variable.js
var require_ua_condition_variable = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_condition_variable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_connection_transport.js
var require_ua_connection_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_connection_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_cube_item.js
var require_ua_cube_item = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_cube_item.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_data_item.js
var require_ua_data_item = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_data_item.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_data_set_folder.js
var require_ua_data_set_folder = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_data_set_folder.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_data_set_reader.js
var require_ua_data_set_reader = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_data_set_reader.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_data_set_reader_message.js
var require_ua_data_set_reader_message = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_data_set_reader_message.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_data_set_reader_transport.js
var require_ua_data_set_reader_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_data_set_reader_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_data_set_writer.js
var require_ua_data_set_writer = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_data_set_writer.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_data_set_writer_message.js
var require_ua_data_set_writer_message = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_data_set_writer_message.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_data_set_writer_transport.js
var require_ua_data_set_writer_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_data_set_writer_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_data_type_description.js
var require_ua_data_type_description = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_data_type_description.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_data_type_dictionary.js
var require_ua_data_type_dictionary = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_data_type_dictionary.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_data_type_encoding.js
var require_ua_data_type_encoding = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_data_type_encoding.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_data_type_system.js
var require_ua_data_type_system = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_data_type_system.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_datagram_connection_transport.js
var require_ua_datagram_connection_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_datagram_connection_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_datagram_data_set_reader_transport.js
var require_ua_datagram_data_set_reader_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_datagram_data_set_reader_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_datagram_writer_group_transport.js
var require_ua_datagram_writer_group_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_datagram_writer_group_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_device_failure_event.js
var require_ua_device_failure_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_device_failure_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_dialog_condition.js
var require_ua_dialog_condition = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_dialog_condition.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_dictionary_entry.js
var require_ua_dictionary_entry = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_dictionary_entry.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_dictionary_folder.js
var require_ua_dictionary_folder = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_dictionary_folder.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_discrepancy_alarm.js
var require_ua_discrepancy_alarm = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_discrepancy_alarm.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_discrete_alarm.js
var require_ua_discrete_alarm = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_discrete_alarm.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_discrete_item.js
var require_ua_discrete_item = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_discrete_item.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_ecc_application_certificate.js
var require_ua_ecc_application_certificate = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_ecc_application_certificate.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_ecc_brainpool_p_256_r_1_application_certificate.js
var require_ua_ecc_brainpool_p_256_r_1_application_certificate = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_ecc_brainpool_p_256_r_1_application_certificate.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_ecc_brainpool_p_384_r_1_application_certificate.js
var require_ua_ecc_brainpool_p_384_r_1_application_certificate = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_ecc_brainpool_p_384_r_1_application_certificate.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_ecc_curve_25519_application_certificate.js
var require_ua_ecc_curve_25519_application_certificate = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_ecc_curve_25519_application_certificate.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_ecc_curve_448_application_certificate.js
var require_ua_ecc_curve_448_application_certificate = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_ecc_curve_448_application_certificate.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_ecc_nist_p_256_application_certificate.js
var require_ua_ecc_nist_p_256_application_certificate = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_ecc_nist_p_256_application_certificate.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_ecc_nist_p_384_application_certificate.js
var require_ua_ecc_nist_p_384_application_certificate = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_ecc_nist_p_384_application_certificate.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_else_guard_variable.js
var require_ua_else_guard_variable = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_else_guard_variable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_event_queue_overflow_event.js
var require_ua_event_queue_overflow_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_event_queue_overflow_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_exclusive_deviation_alarm.js
var require_ua_exclusive_deviation_alarm = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_exclusive_deviation_alarm.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_exclusive_level_alarm.js
var require_ua_exclusive_level_alarm = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_exclusive_level_alarm.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_exclusive_limit_alarm.js
var require_ua_exclusive_limit_alarm = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_exclusive_limit_alarm.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_exclusive_limit_state_machine.js
var require_ua_exclusive_limit_state_machine = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_exclusive_limit_state_machine.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_exclusive_rate_of_change_alarm.js
var require_ua_exclusive_rate_of_change_alarm = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_exclusive_rate_of_change_alarm.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_expression_guard_variable.js
var require_ua_expression_guard_variable = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_expression_guard_variable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_extension_fields.js
var require_ua_extension_fields = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_extension_fields.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_file.js
var require_ua_file = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_file.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_file_directory.js
var require_ua_file_directory = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_file_directory.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_file_transfer_state_machine.js
var require_ua_file_transfer_state_machine = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_file_transfer_state_machine.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_finite_state_machine.js
var require_ua_finite_state_machine = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_finite_state_machine.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_finite_state_variable.js
var require_ua_finite_state_variable = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_finite_state_variable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_finite_transition_variable.js
var require_ua_finite_transition_variable = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_finite_transition_variable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_folder.js
var require_ua_folder = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_folder.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_frame.js
var require_ua_frame = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_frame.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_general_model_change_event.js
var require_ua_general_model_change_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_general_model_change_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_guard_variable.js
var require_ua_guard_variable = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_guard_variable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_highly_managed_alarm_condition_class.js
var require_ua_highly_managed_alarm_condition_class = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_highly_managed_alarm_condition_class.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_historical_data_configuration.js
var require_ua_historical_data_configuration = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_historical_data_configuration.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_historical_event_configuration.js
var require_ua_historical_event_configuration = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_historical_event_configuration.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_historical_external_event_source.js
var require_ua_historical_external_event_source = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_historical_external_event_source.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_history_server_capabilities.js
var require_ua_history_server_capabilities = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_history_server_capabilities.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_https_certificate.js
var require_ua_https_certificate = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_https_certificate.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_i_base_ethernet_capabilities.js
var require_ua_i_base_ethernet_capabilities = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_i_base_ethernet_capabilities.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_i_ieee_auto_negotiation_status.js
var require_ua_i_ieee_auto_negotiation_status = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_i_ieee_auto_negotiation_status.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_i_ieee_base_ethernet_port.js
var require_ua_i_ieee_base_ethernet_port = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_i_ieee_base_ethernet_port.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_i_ieee_base_tsn_status_stream.js
var require_ua_i_ieee_base_tsn_status_stream = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_i_ieee_base_tsn_status_stream.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_i_ieee_base_tsn_stream.js
var require_ua_i_ieee_base_tsn_stream = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_i_ieee_base_tsn_stream.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_i_ieee_base_tsn_traffic_specification.js
var require_ua_i_ieee_base_tsn_traffic_specification = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_i_ieee_base_tsn_traffic_specification.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_i_ieee_tsn_interface_configuration.js
var require_ua_i_ieee_tsn_interface_configuration = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_i_ieee_tsn_interface_configuration.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_i_ieee_tsn_interface_configuration_listener.js
var require_ua_i_ieee_tsn_interface_configuration_listener = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_i_ieee_tsn_interface_configuration_listener.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_i_ieee_tsn_interface_configuration_talker.js
var require_ua_i_ieee_tsn_interface_configuration_talker = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_i_ieee_tsn_interface_configuration_talker.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_i_ieee_tsn_mac_address.js
var require_ua_i_ieee_tsn_mac_address = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_i_ieee_tsn_mac_address.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_i_ieee_tsn_vlan_tag.js
var require_ua_i_ieee_tsn_vlan_tag = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_i_ieee_tsn_vlan_tag.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_i_ietf_base_network_interface.js
var require_ua_i_ietf_base_network_interface = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_i_ietf_base_network_interface.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_i_ordered_object.js
var require_ua_i_ordered_object = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_i_ordered_object.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_i_priority_mapping_entry.js
var require_ua_i_priority_mapping_entry = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_i_priority_mapping_entry.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_i_sr_class.js
var require_ua_i_sr_class = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_i_sr_class.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_i_vlan_id.js
var require_ua_i_vlan_id = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_i_vlan_id.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_ietf_base_network_interface.js
var require_ua_ietf_base_network_interface = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_ietf_base_network_interface.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_image_item.js
var require_ua_image_item = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_image_item.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_initial_state.js
var require_ua_initial_state = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_initial_state.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_instrument_diagnostic_alarm.js
var require_ua_instrument_diagnostic_alarm = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_instrument_diagnostic_alarm.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_irdi_dictionary_entry.js
var require_ua_irdi_dictionary_entry = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_irdi_dictionary_entry.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_json_data_set_reader_message.js
var require_ua_json_data_set_reader_message = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_json_data_set_reader_message.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_json_data_set_writer_message.js
var require_ua_json_data_set_writer_message = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_json_data_set_writer_message.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_json_writer_group_message.js
var require_ua_json_writer_group_message = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_json_writer_group_message.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_key_credential_audit_event.js
var require_ua_key_credential_audit_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_key_credential_audit_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_key_credential_configuration.js
var require_ua_key_credential_configuration = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_key_credential_configuration.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_key_credential_configuration_folder.js
var require_ua_key_credential_configuration_folder = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_key_credential_configuration_folder.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_key_credential_deleted_audit_event.js
var require_ua_key_credential_deleted_audit_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_key_credential_deleted_audit_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_key_credential_updated_audit_event.js
var require_ua_key_credential_updated_audit_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_key_credential_updated_audit_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_limit_alarm.js
var require_ua_limit_alarm = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_limit_alarm.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_maintenance_condition_class.js
var require_ua_maintenance_condition_class = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_maintenance_condition_class.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_modelling_rule.js
var require_ua_modelling_rule = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_modelling_rule.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_multi_state_dictionary_entry_discrete.js
var require_ua_multi_state_dictionary_entry_discrete = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_multi_state_dictionary_entry_discrete.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_multi_state_dictionary_entry_discrete_base.js
var require_ua_multi_state_dictionary_entry_discrete_base = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_multi_state_dictionary_entry_discrete_base.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_multi_state_discrete.js
var require_ua_multi_state_discrete = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_multi_state_discrete.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_multi_state_value_discrete.js
var require_ua_multi_state_value_discrete = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_multi_state_value_discrete.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_n_dimension_array_item.js
var require_ua_n_dimension_array_item = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_n_dimension_array_item.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_namespace_metadata.js
var require_ua_namespace_metadata = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_namespace_metadata.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_namespaces.js
var require_ua_namespaces = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_namespaces.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_network_address.js
var require_ua_network_address = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_network_address.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_network_address_url.js
var require_ua_network_address_url = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_network_address_url.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_non_exclusive_deviation_alarm.js
var require_ua_non_exclusive_deviation_alarm = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_non_exclusive_deviation_alarm.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_non_exclusive_level_alarm.js
var require_ua_non_exclusive_level_alarm = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_non_exclusive_level_alarm.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_non_exclusive_limit_alarm.js
var require_ua_non_exclusive_limit_alarm = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_non_exclusive_limit_alarm.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_non_exclusive_rate_of_change_alarm.js
var require_ua_non_exclusive_rate_of_change_alarm = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_non_exclusive_rate_of_change_alarm.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_non_transparent_backup_redundancy.js
var require_ua_non_transparent_backup_redundancy = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_non_transparent_backup_redundancy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_non_transparent_network_redundancy.js
var require_ua_non_transparent_network_redundancy = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_non_transparent_network_redundancy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_non_transparent_redundancy.js
var require_ua_non_transparent_redundancy = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_non_transparent_redundancy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_off_normal_alarm.js
var require_ua_off_normal_alarm = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_off_normal_alarm.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_operation_limits.js
var require_ua_operation_limits = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_operation_limits.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_option_set.js
var require_ua_option_set = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_option_set.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_ordered_list.js
var require_ua_ordered_list = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_ordered_list.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_orientation.js
var require_ua_orientation = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_orientation.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_priority_mapping_table.js
var require_ua_priority_mapping_table = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_priority_mapping_table.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_process_condition_class.js
var require_ua_process_condition_class = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_process_condition_class.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_program_diagnostic.js
var require_ua_program_diagnostic = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_program_diagnostic.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_program_diagnostic_2.js
var require_ua_program_diagnostic_2 = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_program_diagnostic_2.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_program_state_machine.js
var require_ua_program_state_machine = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_program_state_machine.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_program_transition_audit_event.js
var require_ua_program_transition_audit_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_program_transition_audit_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_program_transition_event.js
var require_ua_program_transition_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_program_transition_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_progress_event.js
var require_ua_progress_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_progress_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_provisionable_device.js
var require_ua_provisionable_device = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_provisionable_device.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_capabilities.js
var require_ua_pub_sub_capabilities = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_capabilities.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_communication_failure_event.js
var require_ua_pub_sub_communication_failure_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_communication_failure_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_configuration.js
var require_ua_pub_sub_configuration = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_configuration.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_connection.js
var require_ua_pub_sub_connection = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_connection.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_diagnostics.js
var require_ua_pub_sub_diagnostics = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_diagnostics.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_diagnostics_connection.js
var require_ua_pub_sub_diagnostics_connection = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_diagnostics_connection.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_diagnostics_counter.js
var require_ua_pub_sub_diagnostics_counter = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_diagnostics_counter.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_diagnostics_data_set_reader.js
var require_ua_pub_sub_diagnostics_data_set_reader = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_diagnostics_data_set_reader.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_diagnostics_data_set_writer.js
var require_ua_pub_sub_diagnostics_data_set_writer = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_diagnostics_data_set_writer.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_diagnostics_reader_group.js
var require_ua_pub_sub_diagnostics_reader_group = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_diagnostics_reader_group.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_diagnostics_root.js
var require_ua_pub_sub_diagnostics_root = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_diagnostics_root.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_diagnostics_writer_group.js
var require_ua_pub_sub_diagnostics_writer_group = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_diagnostics_writer_group.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_group.js
var require_ua_pub_sub_group = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_group.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_key_push_target.js
var require_ua_pub_sub_key_push_target = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_key_push_target.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_key_push_target_folder.js
var require_ua_pub_sub_key_push_target_folder = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_key_push_target_folder.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_key_service.js
var require_ua_pub_sub_key_service = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_key_service.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_status.js
var require_ua_pub_sub_status = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_status.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_status_event.js
var require_ua_pub_sub_status_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_status_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_transport_limits_exceed_event.js
var require_ua_pub_sub_transport_limits_exceed_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_pub_sub_transport_limits_exceed_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_publish_subscribe.js
var require_ua_publish_subscribe = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_publish_subscribe.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_published_data_items.js
var require_ua_published_data_items = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_published_data_items.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_published_data_set.js
var require_ua_published_data_set = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_published_data_set.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_published_events.js
var require_ua_published_events = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_published_events.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_quantities_folder.js
var require_ua_quantities_folder = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_quantities_folder.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_quantity.js
var require_ua_quantity = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_quantity.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_rational_number.js
var require_ua_rational_number = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_rational_number.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_reader_group.js
var require_ua_reader_group = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_reader_group.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_reader_group_message.js
var require_ua_reader_group_message = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_reader_group_message.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_reader_group_transport.js
var require_ua_reader_group_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_reader_group_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_reference_description_variable.js
var require_ua_reference_description_variable = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_reference_description_variable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_refresh_end_event.js
var require_ua_refresh_end_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_refresh_end_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_refresh_required_event.js
var require_ua_refresh_required_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_refresh_required_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_refresh_start_event.js
var require_ua_refresh_start_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_refresh_start_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_role.js
var require_ua_role = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_role.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_role_mapping_rule_changed_audit_event.js
var require_ua_role_mapping_rule_changed_audit_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_role_mapping_rule_changed_audit_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_role_set.js
var require_ua_role_set = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_role_set.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_rsa_min_application_certificate.js
var require_ua_rsa_min_application_certificate = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_rsa_min_application_certificate.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_rsa_sha_256_application_certificate.js
var require_ua_rsa_sha_256_application_certificate = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_rsa_sha_256_application_certificate.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_safety_condition_class.js
var require_ua_safety_condition_class = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_safety_condition_class.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_sampling_interval_diagnostics.js
var require_ua_sampling_interval_diagnostics = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_sampling_interval_diagnostics.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_sampling_interval_diagnostics_array.js
var require_ua_sampling_interval_diagnostics_array = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_sampling_interval_diagnostics_array.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_security_group.js
var require_ua_security_group = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_security_group.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_security_group_folder.js
var require_ua_security_group_folder = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_security_group_folder.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_selection_list.js
var require_ua_selection_list = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_selection_list.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_semantic_change_event.js
var require_ua_semantic_change_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_semantic_change_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_server.js
var require_ua_server = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_server.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_server_capabilities.js
var require_ua_server_capabilities = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_server_capabilities.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_server_configuration.js
var require_ua_server_configuration = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_server_configuration.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_server_diagnostics.js
var require_ua_server_diagnostics = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_server_diagnostics.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_server_diagnostics_summary.js
var require_ua_server_diagnostics_summary = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_server_diagnostics_summary.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_server_redundancy.js
var require_ua_server_redundancy = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_server_redundancy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_server_status.js
var require_ua_server_status = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_server_status.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_server_unit.js
var require_ua_server_unit = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_server_unit.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_server_vendor_capability.js
var require_ua_server_vendor_capability = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_server_vendor_capability.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_session_diagnostics_array.js
var require_ua_session_diagnostics_array = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_session_diagnostics_array.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_session_diagnostics_object.js
var require_ua_session_diagnostics_object = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_session_diagnostics_object.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_session_diagnostics_variable.js
var require_ua_session_diagnostics_variable = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_session_diagnostics_variable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_session_security_diagnostics.js
var require_ua_session_security_diagnostics = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_session_security_diagnostics.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_session_security_diagnostics_array.js
var require_ua_session_security_diagnostics_array = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_session_security_diagnostics_array.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_sessions_diagnostics_summary.js
var require_ua_sessions_diagnostics_summary = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_sessions_diagnostics_summary.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_shelved_state_machine.js
var require_ua_shelved_state_machine = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_shelved_state_machine.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_standalone_subscribed_data_set.js
var require_ua_standalone_subscribed_data_set = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_standalone_subscribed_data_set.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_state.js
var require_ua_state = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_state.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_state_machine.js
var require_ua_state_machine = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_state_machine.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_state_variable.js
var require_ua_state_variable = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_state_variable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_statistical_condition_class.js
var require_ua_statistical_condition_class = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_statistical_condition_class.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_subscribed_data_set.js
var require_ua_subscribed_data_set = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_subscribed_data_set.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_subscribed_data_set_folder.js
var require_ua_subscribed_data_set_folder = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_subscribed_data_set_folder.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_subscribed_data_set_mirror.js
var require_ua_subscribed_data_set_mirror = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_subscribed_data_set_mirror.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_subscription_diagnostics.js
var require_ua_subscription_diagnostics = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_subscription_diagnostics.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_subscription_diagnostics_array.js
var require_ua_subscription_diagnostics_array = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_subscription_diagnostics_array.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_syntax_reference_entry.js
var require_ua_syntax_reference_entry = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_syntax_reference_entry.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_system_condition_class.js
var require_ua_system_condition_class = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_system_condition_class.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_system_diagnostic_alarm.js
var require_ua_system_diagnostic_alarm = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_system_diagnostic_alarm.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_system_event.js
var require_ua_system_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_system_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_system_off_normal_alarm.js
var require_ua_system_off_normal_alarm = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_system_off_normal_alarm.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_system_status_change_event.js
var require_ua_system_status_change_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_system_status_change_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_target_variables.js
var require_ua_target_variables = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_target_variables.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_temporary_file_transfer.js
var require_ua_temporary_file_transfer = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_temporary_file_transfer.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_testing_condition_class.js
var require_ua_testing_condition_class = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_testing_condition_class.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_training_condition_class.js
var require_ua_training_condition_class = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_training_condition_class.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_transaction_diagnostics.js
var require_ua_transaction_diagnostics = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_transaction_diagnostics.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_transition.js
var require_ua_transition = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_transition.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_transition_event.js
var require_ua_transition_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_transition_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_transition_variable.js
var require_ua_transition_variable = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_transition_variable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_transparent_redundancy.js
var require_ua_transparent_redundancy = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_transparent_redundancy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_trip_alarm.js
var require_ua_trip_alarm = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_trip_alarm.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_trust_list.js
var require_ua_trust_list = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_trust_list.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_trust_list_out_of_date_alarm.js
var require_ua_trust_list_out_of_date_alarm = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_trust_list_out_of_date_alarm.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_trust_list_update_requested_audit_event.js
var require_ua_trust_list_update_requested_audit_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_trust_list_update_requested_audit_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_trust_list_updated_audit_event.js
var require_ua_trust_list_updated_audit_event = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_trust_list_updated_audit_event.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_two_state_discrete.js
var require_ua_two_state_discrete = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_two_state_discrete.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_two_state_variable.js
var require_ua_two_state_variable2 = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_two_state_variable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_uadp_data_set_reader_message.js
var require_ua_uadp_data_set_reader_message = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_uadp_data_set_reader_message.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_uadp_data_set_writer_message.js
var require_ua_uadp_data_set_writer_message = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_uadp_data_set_writer_message.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_uadp_writer_group_message.js
var require_ua_uadp_writer_group_message = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_uadp_writer_group_message.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_unit.js
var require_ua_unit = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_unit.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_uri_dictionary_entry.js
var require_ua_uri_dictionary_entry = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_uri_dictionary_entry.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_user_credential_certificate.js
var require_ua_user_credential_certificate = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_user_credential_certificate.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_user_management.js
var require_ua_user_management = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_user_management.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_vector.js
var require_ua_vector = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_vector.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_vendor_server_info.js
var require_ua_vendor_server_info = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_vendor_server_info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_writer_group.js
var require_ua_writer_group = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_writer_group.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_writer_group_message.js
var require_ua_writer_group_message = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_writer_group_message.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_writer_group_transport.js
var require_ua_writer_group_transport = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_writer_group_transport.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_xy_array_item.js
var require_ua_xy_array_item = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_xy_array_item.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/ua_y_array_item.js
var require_ua_y_array_item = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/ua_y_array_item.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-nodeset-ua/dist/index.js
var require_dist57 = __commonJS({
  "node_modules/node-opcua-nodeset-ua/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_dt_3_d_cartesian_coordinates(), exports2);
    __exportStar3(require_dt_3_d_frame(), exports2);
    __exportStar3(require_dt_3_d_orientation(), exports2);
    __exportStar3(require_dt_3_d_vector(), exports2);
    __exportStar3(require_dt_add_nodes_item(), exports2);
    __exportStar3(require_dt_add_references_item(), exports2);
    __exportStar3(require_dt_additional_parameters(), exports2);
    __exportStar3(require_dt_aggregate_configuration(), exports2);
    __exportStar3(require_dt_alias_name(), exports2);
    __exportStar3(require_dt_annotation(), exports2);
    __exportStar3(require_dt_annotation(), exports2);
    __exportStar3(require_dt_anonymous_identity_token(), exports2);
    __exportStar3(require_dt_application_description(), exports2);
    __exportStar3(require_dt_argument(), exports2);
    __exportStar3(require_dt_attribute_operand(), exports2);
    __exportStar3(require_dt_axis_information(), exports2);
    __exportStar3(require_dt_bit_field_definition(), exports2);
    __exportStar3(require_dt_broker_connection_transport(), exports2);
    __exportStar3(require_dt_broker_data_set_reader_transport(), exports2);
    __exportStar3(require_dt_broker_data_set_writer_transport(), exports2);
    __exportStar3(require_dt_broker_writer_group_transport(), exports2);
    __exportStar3(require_dt_build_info(), exports2);
    __exportStar3(require_dt_cartesian_coordinates(), exports2);
    __exportStar3(require_dt_complex_number(), exports2);
    __exportStar3(require_dt_configuration_version(), exports2);
    __exportStar3(require_dt_connection_transport(), exports2);
    __exportStar3(require_dt_content_filter(), exports2);
    __exportStar3(require_dt_content_filter_element(), exports2);
    __exportStar3(require_dt_currency_unit(), exports2);
    __exportStar3(require_dt_data_set_meta(), exports2);
    __exportStar3(require_dt_data_set_reader(), exports2);
    __exportStar3(require_dt_data_set_reader_message(), exports2);
    __exportStar3(require_dt_data_set_reader_transport(), exports2);
    __exportStar3(require_dt_data_set_writer(), exports2);
    __exportStar3(require_dt_data_set_writer_message(), exports2);
    __exportStar3(require_dt_data_set_writer_transport(), exports2);
    __exportStar3(require_dt_data_type_definition(), exports2);
    __exportStar3(require_dt_data_type_description(), exports2);
    __exportStar3(require_dt_data_type_schema_header(), exports2);
    __exportStar3(require_dt_datagram_connection_transport(), exports2);
    __exportStar3(require_dt_datagram_connection_transport_2(), exports2);
    __exportStar3(require_dt_datagram_data_set_reader_transport(), exports2);
    __exportStar3(require_dt_datagram_writer_group_transport(), exports2);
    __exportStar3(require_dt_datagram_writer_group_transport_2(), exports2);
    __exportStar3(require_dt_delete_nodes_item(), exports2);
    __exportStar3(require_dt_delete_references_item(), exports2);
    __exportStar3(require_dt_discovery_configuration(), exports2);
    __exportStar3(require_dt_double_complex_number(), exports2);
    __exportStar3(require_dt_element_operand(), exports2);
    __exportStar3(require_dt_endpoint(), exports2);
    __exportStar3(require_dt_endpoint_configuration(), exports2);
    __exportStar3(require_dt_endpoint_description(), exports2);
    __exportStar3(require_dt_endpoint_url_list(), exports2);
    __exportStar3(require_dt_enum_definition(), exports2);
    __exportStar3(require_dt_enum_description(), exports2);
    __exportStar3(require_dt_enum_field(), exports2);
    __exportStar3(require_dt_enum_value(), exports2);
    __exportStar3(require_dt_ephemeral_key(), exports2);
    __exportStar3(require_dt_event_filter(), exports2);
    __exportStar3(require_dt_field_meta_data(), exports2);
    __exportStar3(require_dt_field_target(), exports2);
    __exportStar3(require_dt_filter_operand(), exports2);
    __exportStar3(require_dt_frame(), exports2);
    __exportStar3(require_dt_history_event(), exports2);
    __exportStar3(require_dt_history_event_field_list(), exports2);
    __exportStar3(require_dt_history_modified_event(), exports2);
    __exportStar3(require_dt_identity_mapping_rule(), exports2);
    __exportStar3(require_dt_issued_identity_token(), exports2);
    __exportStar3(require_dt_json_data_set_reader_message(), exports2);
    __exportStar3(require_dt_json_data_set_writer_message(), exports2);
    __exportStar3(require_dt_json_writer_group_message(), exports2);
    __exportStar3(require_dt_key_value_pair(), exports2);
    __exportStar3(require_dt_linear_conversion(), exports2);
    __exportStar3(require_dt_literal_operand(), exports2);
    __exportStar3(require_dt_mdns_discovery_configuration(), exports2);
    __exportStar3(require_dt_model_change_structure(), exports2);
    __exportStar3(require_dt_modification_info(), exports2);
    __exportStar3(require_dt_monitoring_filter(), exports2);
    __exportStar3(require_dt_network_address(), exports2);
    __exportStar3(require_dt_network_address_url(), exports2);
    __exportStar3(require_dt_network_group(), exports2);
    __exportStar3(require_dt_option_set(), exports2);
    __exportStar3(require_dt_orientation(), exports2);
    __exportStar3(require_dt_portable_node_id(), exports2);
    __exportStar3(require_dt_portable_qualified_name(), exports2);
    __exportStar3(require_dt_priority_mapping_entry(), exports2);
    __exportStar3(require_dt_program_diagnostic(), exports2);
    __exportStar3(require_dt_program_diagnostic_2(), exports2);
    __exportStar3(require_dt_pub_sub_configuration(), exports2);
    __exportStar3(require_dt_pub_sub_configuration_2(), exports2);
    __exportStar3(require_dt_pub_sub_configuration_ref(), exports2);
    __exportStar3(require_dt_pub_sub_configuration_value(), exports2);
    __exportStar3(require_dt_pub_sub_connection(), exports2);
    __exportStar3(require_dt_pub_sub_group(), exports2);
    __exportStar3(require_dt_pub_sub_key_push_target(), exports2);
    __exportStar3(require_dt_published_data_items(), exports2);
    __exportStar3(require_dt_published_data_set(), exports2);
    __exportStar3(require_dt_published_data_set_custom_source(), exports2);
    __exportStar3(require_dt_published_data_set_source(), exports2);
    __exportStar3(require_dt_published_events(), exports2);
    __exportStar3(require_dt_published_variable(), exports2);
    __exportStar3(require_dt_qos(), exports2);
    __exportStar3(require_dt_quantity_dimension(), exports2);
    __exportStar3(require_dt_range(), exports2);
    __exportStar3(require_dt_rational_number(), exports2);
    __exportStar3(require_dt_reader_group(), exports2);
    __exportStar3(require_dt_reader_group_message(), exports2);
    __exportStar3(require_dt_reader_group_transport(), exports2);
    __exportStar3(require_dt_receive_qos(), exports2);
    __exportStar3(require_dt_receive_qos_priority(), exports2);
    __exportStar3(require_dt_redundant_server(), exports2);
    __exportStar3(require_dt_reference_description(), exports2);
    __exportStar3(require_dt_reference_list_entry(), exports2);
    __exportStar3(require_dt_registered_server(), exports2);
    __exportStar3(require_dt_relative_path(), exports2);
    __exportStar3(require_dt_relative_path_element(), exports2);
    __exportStar3(require_dt_role_permission(), exports2);
    __exportStar3(require_dt_sampling_interval_diagnostics(), exports2);
    __exportStar3(require_dt_security_group(), exports2);
    __exportStar3(require_dt_semantic_change_structure(), exports2);
    __exportStar3(require_dt_server_diagnostics_summary(), exports2);
    __exportStar3(require_dt_server_on_network(), exports2);
    __exportStar3(require_dt_server_status(), exports2);
    __exportStar3(require_dt_service_counter(), exports2);
    __exportStar3(require_dt_session_diagnostics(), exports2);
    __exportStar3(require_dt_session_security_diagnostics(), exports2);
    __exportStar3(require_dt_signed_software_certificate(), exports2);
    __exportStar3(require_dt_simple_attribute_operand(), exports2);
    __exportStar3(require_dt_simple_type_description(), exports2);
    __exportStar3(require_dt_standalone_subscribed_data_set(), exports2);
    __exportStar3(require_dt_standalone_subscribed_data_set_ref(), exports2);
    __exportStar3(require_dt_status_result(), exports2);
    __exportStar3(require_dt_structure(), exports2);
    __exportStar3(require_dt_structure_definition(), exports2);
    __exportStar3(require_dt_structure_description(), exports2);
    __exportStar3(require_dt_structure_field(), exports2);
    __exportStar3(require_dt_subscribed_data_set(), exports2);
    __exportStar3(require_dt_subscribed_data_set_mirror(), exports2);
    __exportStar3(require_dt_subscription_diagnostics(), exports2);
    __exportStar3(require_dt_target_variables(), exports2);
    __exportStar3(require_dt_time_zone(), exports2);
    __exportStar3(require_dt_transaction_error(), exports2);
    __exportStar3(require_dt_transmit_qos(), exports2);
    __exportStar3(require_dt_transmit_qos_priority(), exports2);
    __exportStar3(require_dt_trust_list(), exports2);
    __exportStar3(require_dt_ua_binary_file(), exports2);
    __exportStar3(require_dt_uadp_data_set_reader_message(), exports2);
    __exportStar3(require_dt_uadp_data_set_writer_message(), exports2);
    __exportStar3(require_dt_uadp_writer_group_message(), exports2);
    __exportStar3(require_dt_union(), exports2);
    __exportStar3(require_dt_unsigned_rational_number(), exports2);
    __exportStar3(require_dt_user_identity_token(), exports2);
    __exportStar3(require_dt_user_management(), exports2);
    __exportStar3(require_dt_user_name_identity_token(), exports2);
    __exportStar3(require_dt_user_token_policy(), exports2);
    __exportStar3(require_dt_vector(), exports2);
    __exportStar3(require_dt_writer_group(), exports2);
    __exportStar3(require_dt_writer_group_message(), exports2);
    __exportStar3(require_dt_writer_group_transport(), exports2);
    __exportStar3(require_dt_x_509_identity_token(), exports2);
    __exportStar3(require_dt_xv(), exports2);
    __exportStar3(require_enum_application(), exports2);
    __exportStar3(require_enum_axis_scale(), exports2);
    __exportStar3(require_enum_broker_transport_quality_of_service(), exports2);
    __exportStar3(require_enum_conversion_limit_enum(), exports2);
    __exportStar3(require_enum_data_set_ordering(), exports2);
    __exportStar3(require_enum_diagnostics_level(), exports2);
    __exportStar3(require_enum_duplex(), exports2);
    __exportStar3(require_enum_exception_deviation_format(), exports2);
    __exportStar3(require_enum_filter_operator(), exports2);
    __exportStar3(require_enum_history_update(), exports2);
    __exportStar3(require_enum_id(), exports2);
    __exportStar3(require_enum_identity_criteria(), exports2);
    __exportStar3(require_enum_interface_admin_status(), exports2);
    __exportStar3(require_enum_interface_oper_status(), exports2);
    __exportStar3(require_enum_message_security_mode(), exports2);
    __exportStar3(require_enum_naming_rule(), exports2);
    __exportStar3(require_enum_negotiation_status(), exports2);
    __exportStar3(require_enum_node_attributes_mask(), exports2);
    __exportStar3(require_enum_node_class(), exports2);
    __exportStar3(require_enum_open_file_mode(), exports2);
    __exportStar3(require_enum_override_value_handling(), exports2);
    __exportStar3(require_enum_perform_update(), exports2);
    __exportStar3(require_enum_pub_sub_diagnostics_counter_classification(), exports2);
    __exportStar3(require_enum_pub_sub_state(), exports2);
    __exportStar3(require_enum_redundancy_support(), exports2);
    __exportStar3(require_enum_redundant_server_mode(), exports2);
    __exportStar3(require_enum_security_token_request(), exports2);
    __exportStar3(require_enum_server_state(), exports2);
    __exportStar3(require_enum_structure(), exports2);
    __exportStar3(require_enum_trust_list_masks(), exports2);
    __exportStar3(require_enum_tsn_failure_code(), exports2);
    __exportStar3(require_enum_tsn_listener_status(), exports2);
    __exportStar3(require_enum_tsn_stream_state(), exports2);
    __exportStar3(require_enum_tsn_talker_status(), exports2);
    __exportStar3(require_enum_user_token(), exports2);
    __exportStar3(require_eu_information(), exports2);
    __exportStar3(require_ua_3_d_cartesian_coordinates(), exports2);
    __exportStar3(require_ua_3_d_frame(), exports2);
    __exportStar3(require_ua_3_d_orientation(), exports2);
    __exportStar3(require_ua_3_d_vector(), exports2);
    __exportStar3(require_ua_acknowledgeable_condition(), exports2);
    __exportStar3(require_ua_address_space_file(), exports2);
    __exportStar3(require_ua_aggregate_configuration(), exports2);
    __exportStar3(require_ua_aggregate_function(), exports2);
    __exportStar3(require_ua_alarm_condition(), exports2);
    __exportStar3(require_ua_alarm_group(), exports2);
    __exportStar3(require_ua_alarm_metrics(), exports2);
    __exportStar3(require_ua_alarm_rate_variable(), exports2);
    __exportStar3(require_ua_alarm_state_variable(), exports2);
    __exportStar3(require_ua_alarm_suppression_group(), exports2);
    __exportStar3(require_ua_alias_name(), exports2);
    __exportStar3(require_ua_alias_name_category(), exports2);
    __exportStar3(require_ua_alternative_unit(), exports2);
    __exportStar3(require_ua_analog_item(), exports2);
    __exportStar3(require_ua_analog_unit(), exports2);
    __exportStar3(require_ua_analog_unit_range(), exports2);
    __exportStar3(require_ua_application_certificate(), exports2);
    __exportStar3(require_ua_application_configuration(), exports2);
    __exportStar3(require_ua_array_item(), exports2);
    __exportStar3(require_ua_audio_variable(), exports2);
    __exportStar3(require_ua_audit_activate_session_event(), exports2);
    __exportStar3(require_ua_audit_add_nodes_event(), exports2);
    __exportStar3(require_ua_audit_add_references_event(), exports2);
    __exportStar3(require_ua_audit_cancel_event(), exports2);
    __exportStar3(require_ua_audit_certificate_data_mismatch_event(), exports2);
    __exportStar3(require_ua_audit_certificate_event(), exports2);
    __exportStar3(require_ua_audit_certificate_expired_event(), exports2);
    __exportStar3(require_ua_audit_certificate_invalid_event(), exports2);
    __exportStar3(require_ua_audit_certificate_mismatch_event(), exports2);
    __exportStar3(require_ua_audit_certificate_revoked_event(), exports2);
    __exportStar3(require_ua_audit_certificate_untrusted_event(), exports2);
    __exportStar3(require_ua_audit_channel_event(), exports2);
    __exportStar3(require_ua_audit_client_event(), exports2);
    __exportStar3(require_ua_audit_client_update_method_result_event(), exports2);
    __exportStar3(require_ua_audit_condition_acknowledge_event(), exports2);
    __exportStar3(require_ua_audit_condition_comment_event(), exports2);
    __exportStar3(require_ua_audit_condition_confirm_event(), exports2);
    __exportStar3(require_ua_audit_condition_enable_event(), exports2);
    __exportStar3(require_ua_audit_condition_event(), exports2);
    __exportStar3(require_ua_audit_condition_out_of_service_event(), exports2);
    __exportStar3(require_ua_audit_condition_reset_event(), exports2);
    __exportStar3(require_ua_audit_condition_respond_event(), exports2);
    __exportStar3(require_ua_audit_condition_shelving_event(), exports2);
    __exportStar3(require_ua_audit_condition_silence_event(), exports2);
    __exportStar3(require_ua_audit_condition_suppression_event(), exports2);
    __exportStar3(require_ua_audit_create_session_event(), exports2);
    __exportStar3(require_ua_audit_delete_nodes_event(), exports2);
    __exportStar3(require_ua_audit_delete_references_event(), exports2);
    __exportStar3(require_ua_audit_event(), exports2);
    __exportStar3(require_ua_audit_history_annotation_update_event(), exports2);
    __exportStar3(require_ua_audit_history_at_time_delete_event(), exports2);
    __exportStar3(require_ua_audit_history_bulk_insert_event(), exports2);
    __exportStar3(require_ua_audit_history_configuration_change_event(), exports2);
    __exportStar3(require_ua_audit_history_delete_event(), exports2);
    __exportStar3(require_ua_audit_history_event_delete_event(), exports2);
    __exportStar3(require_ua_audit_history_event_update_event(), exports2);
    __exportStar3(require_ua_audit_history_raw_modify_delete_event(), exports2);
    __exportStar3(require_ua_audit_history_update_event(), exports2);
    __exportStar3(require_ua_audit_history_value_update_event(), exports2);
    __exportStar3(require_ua_audit_node_management_event(), exports2);
    __exportStar3(require_ua_audit_open_secure_channel_event(), exports2);
    __exportStar3(require_ua_audit_program_transition_event(), exports2);
    __exportStar3(require_ua_audit_security_event(), exports2);
    __exportStar3(require_ua_audit_session_event(), exports2);
    __exportStar3(require_ua_audit_update_event(), exports2);
    __exportStar3(require_ua_audit_update_method_event(), exports2);
    __exportStar3(require_ua_audit_update_state_event(), exports2);
    __exportStar3(require_ua_audit_url_mismatch_event(), exports2);
    __exportStar3(require_ua_audit_write_update_event(), exports2);
    __exportStar3(require_ua_authorization_service_configuration(), exports2);
    __exportStar3(require_ua_authorization_services_configuration_folder(), exports2);
    __exportStar3(require_ua_base_analog(), exports2);
    __exportStar3(require_ua_base_condition_class(), exports2);
    __exportStar3(require_ua_base_data_variable(), exports2);
    __exportStar3(require_ua_base_event(), exports2);
    __exportStar3(require_ua_base_interface(), exports2);
    __exportStar3(require_ua_base_model_change_event(), exports2);
    __exportStar3(require_ua_bit_field(), exports2);
    __exportStar3(require_ua_broker_connection_transport(), exports2);
    __exportStar3(require_ua_broker_data_set_reader_transport(), exports2);
    __exportStar3(require_ua_broker_data_set_writer_transport(), exports2);
    __exportStar3(require_ua_broker_writer_group_transport(), exports2);
    __exportStar3(require_ua_build_info(), exports2);
    __exportStar3(require_ua_cartesian_coordinates(), exports2);
    __exportStar3(require_ua_certificate(), exports2);
    __exportStar3(require_ua_certificate_expiration_alarm(), exports2);
    __exportStar3(require_ua_certificate_group(), exports2);
    __exportStar3(require_ua_certificate_group_folder(), exports2);
    __exportStar3(require_ua_certificate_update_requested_audit_event(), exports2);
    __exportStar3(require_ua_certificate_updated_audit_event(), exports2);
    __exportStar3(require_ua_choice_state(), exports2);
    __exportStar3(require_ua_condition(), exports2);
    __exportStar3(require_ua_condition_variable(), exports2);
    __exportStar3(require_ua_connection_transport(), exports2);
    __exportStar3(require_ua_cube_item(), exports2);
    __exportStar3(require_ua_data_item(), exports2);
    __exportStar3(require_ua_data_set_folder(), exports2);
    __exportStar3(require_ua_data_set_reader(), exports2);
    __exportStar3(require_ua_data_set_reader_message(), exports2);
    __exportStar3(require_ua_data_set_reader_transport(), exports2);
    __exportStar3(require_ua_data_set_writer(), exports2);
    __exportStar3(require_ua_data_set_writer_message(), exports2);
    __exportStar3(require_ua_data_set_writer_transport(), exports2);
    __exportStar3(require_ua_data_type_description(), exports2);
    __exportStar3(require_ua_data_type_dictionary(), exports2);
    __exportStar3(require_ua_data_type_encoding(), exports2);
    __exportStar3(require_ua_data_type_system(), exports2);
    __exportStar3(require_ua_datagram_connection_transport(), exports2);
    __exportStar3(require_ua_datagram_data_set_reader_transport(), exports2);
    __exportStar3(require_ua_datagram_writer_group_transport(), exports2);
    __exportStar3(require_ua_device_failure_event(), exports2);
    __exportStar3(require_ua_dialog_condition(), exports2);
    __exportStar3(require_ua_dictionary_entry(), exports2);
    __exportStar3(require_ua_dictionary_folder(), exports2);
    __exportStar3(require_ua_discrepancy_alarm(), exports2);
    __exportStar3(require_ua_discrete_alarm(), exports2);
    __exportStar3(require_ua_discrete_item(), exports2);
    __exportStar3(require_ua_ecc_application_certificate(), exports2);
    __exportStar3(require_ua_ecc_brainpool_p_256_r_1_application_certificate(), exports2);
    __exportStar3(require_ua_ecc_brainpool_p_384_r_1_application_certificate(), exports2);
    __exportStar3(require_ua_ecc_curve_25519_application_certificate(), exports2);
    __exportStar3(require_ua_ecc_curve_448_application_certificate(), exports2);
    __exportStar3(require_ua_ecc_nist_p_256_application_certificate(), exports2);
    __exportStar3(require_ua_ecc_nist_p_384_application_certificate(), exports2);
    __exportStar3(require_ua_else_guard_variable(), exports2);
    __exportStar3(require_ua_event_queue_overflow_event(), exports2);
    __exportStar3(require_ua_exclusive_deviation_alarm(), exports2);
    __exportStar3(require_ua_exclusive_level_alarm(), exports2);
    __exportStar3(require_ua_exclusive_limit_alarm(), exports2);
    __exportStar3(require_ua_exclusive_limit_state_machine(), exports2);
    __exportStar3(require_ua_exclusive_rate_of_change_alarm(), exports2);
    __exportStar3(require_ua_expression_guard_variable(), exports2);
    __exportStar3(require_ua_extension_fields(), exports2);
    __exportStar3(require_ua_file(), exports2);
    __exportStar3(require_ua_file_directory(), exports2);
    __exportStar3(require_ua_file_transfer_state_machine(), exports2);
    __exportStar3(require_ua_finite_state_machine(), exports2);
    __exportStar3(require_ua_finite_state_variable(), exports2);
    __exportStar3(require_ua_finite_transition_variable(), exports2);
    __exportStar3(require_ua_folder(), exports2);
    __exportStar3(require_ua_frame(), exports2);
    __exportStar3(require_ua_general_model_change_event(), exports2);
    __exportStar3(require_ua_guard_variable(), exports2);
    __exportStar3(require_ua_highly_managed_alarm_condition_class(), exports2);
    __exportStar3(require_ua_historical_data_configuration(), exports2);
    __exportStar3(require_ua_historical_event_configuration(), exports2);
    __exportStar3(require_ua_historical_external_event_source(), exports2);
    __exportStar3(require_ua_history_server_capabilities(), exports2);
    __exportStar3(require_ua_https_certificate(), exports2);
    __exportStar3(require_ua_i_base_ethernet_capabilities(), exports2);
    __exportStar3(require_ua_i_ieee_auto_negotiation_status(), exports2);
    __exportStar3(require_ua_i_ieee_base_ethernet_port(), exports2);
    __exportStar3(require_ua_i_ieee_base_tsn_status_stream(), exports2);
    __exportStar3(require_ua_i_ieee_base_tsn_stream(), exports2);
    __exportStar3(require_ua_i_ieee_base_tsn_traffic_specification(), exports2);
    __exportStar3(require_ua_i_ieee_tsn_interface_configuration(), exports2);
    __exportStar3(require_ua_i_ieee_tsn_interface_configuration_listener(), exports2);
    __exportStar3(require_ua_i_ieee_tsn_interface_configuration_talker(), exports2);
    __exportStar3(require_ua_i_ieee_tsn_mac_address(), exports2);
    __exportStar3(require_ua_i_ieee_tsn_vlan_tag(), exports2);
    __exportStar3(require_ua_i_ietf_base_network_interface(), exports2);
    __exportStar3(require_ua_i_ordered_object(), exports2);
    __exportStar3(require_ua_i_priority_mapping_entry(), exports2);
    __exportStar3(require_ua_i_sr_class(), exports2);
    __exportStar3(require_ua_i_vlan_id(), exports2);
    __exportStar3(require_ua_ietf_base_network_interface(), exports2);
    __exportStar3(require_ua_image_item(), exports2);
    __exportStar3(require_ua_initial_state(), exports2);
    __exportStar3(require_ua_instrument_diagnostic_alarm(), exports2);
    __exportStar3(require_ua_irdi_dictionary_entry(), exports2);
    __exportStar3(require_ua_json_data_set_reader_message(), exports2);
    __exportStar3(require_ua_json_data_set_writer_message(), exports2);
    __exportStar3(require_ua_json_writer_group_message(), exports2);
    __exportStar3(require_ua_key_credential_audit_event(), exports2);
    __exportStar3(require_ua_key_credential_configuration(), exports2);
    __exportStar3(require_ua_key_credential_configuration_folder(), exports2);
    __exportStar3(require_ua_key_credential_deleted_audit_event(), exports2);
    __exportStar3(require_ua_key_credential_updated_audit_event(), exports2);
    __exportStar3(require_ua_limit_alarm(), exports2);
    __exportStar3(require_ua_maintenance_condition_class(), exports2);
    __exportStar3(require_ua_modelling_rule(), exports2);
    __exportStar3(require_ua_multi_state_dictionary_entry_discrete(), exports2);
    __exportStar3(require_ua_multi_state_dictionary_entry_discrete_base(), exports2);
    __exportStar3(require_ua_multi_state_discrete(), exports2);
    __exportStar3(require_ua_multi_state_value_discrete(), exports2);
    __exportStar3(require_ua_n_dimension_array_item(), exports2);
    __exportStar3(require_ua_namespace_metadata(), exports2);
    __exportStar3(require_ua_namespaces(), exports2);
    __exportStar3(require_ua_network_address(), exports2);
    __exportStar3(require_ua_network_address_url(), exports2);
    __exportStar3(require_ua_non_exclusive_deviation_alarm(), exports2);
    __exportStar3(require_ua_non_exclusive_level_alarm(), exports2);
    __exportStar3(require_ua_non_exclusive_limit_alarm(), exports2);
    __exportStar3(require_ua_non_exclusive_rate_of_change_alarm(), exports2);
    __exportStar3(require_ua_non_transparent_backup_redundancy(), exports2);
    __exportStar3(require_ua_non_transparent_network_redundancy(), exports2);
    __exportStar3(require_ua_non_transparent_redundancy(), exports2);
    __exportStar3(require_ua_off_normal_alarm(), exports2);
    __exportStar3(require_ua_operation_limits(), exports2);
    __exportStar3(require_ua_option_set(), exports2);
    __exportStar3(require_ua_ordered_list(), exports2);
    __exportStar3(require_ua_orientation(), exports2);
    __exportStar3(require_ua_priority_mapping_table(), exports2);
    __exportStar3(require_ua_process_condition_class(), exports2);
    __exportStar3(require_ua_program_diagnostic(), exports2);
    __exportStar3(require_ua_program_diagnostic_2(), exports2);
    __exportStar3(require_ua_program_state_machine(), exports2);
    __exportStar3(require_ua_program_transition_audit_event(), exports2);
    __exportStar3(require_ua_program_transition_event(), exports2);
    __exportStar3(require_ua_progress_event(), exports2);
    __exportStar3(require_ua_provisionable_device(), exports2);
    __exportStar3(require_ua_pub_sub_capabilities(), exports2);
    __exportStar3(require_ua_pub_sub_communication_failure_event(), exports2);
    __exportStar3(require_ua_pub_sub_configuration(), exports2);
    __exportStar3(require_ua_pub_sub_connection(), exports2);
    __exportStar3(require_ua_pub_sub_diagnostics(), exports2);
    __exportStar3(require_ua_pub_sub_diagnostics_connection(), exports2);
    __exportStar3(require_ua_pub_sub_diagnostics_counter(), exports2);
    __exportStar3(require_ua_pub_sub_diagnostics_data_set_reader(), exports2);
    __exportStar3(require_ua_pub_sub_diagnostics_data_set_writer(), exports2);
    __exportStar3(require_ua_pub_sub_diagnostics_reader_group(), exports2);
    __exportStar3(require_ua_pub_sub_diagnostics_root(), exports2);
    __exportStar3(require_ua_pub_sub_diagnostics_writer_group(), exports2);
    __exportStar3(require_ua_pub_sub_group(), exports2);
    __exportStar3(require_ua_pub_sub_key_push_target(), exports2);
    __exportStar3(require_ua_pub_sub_key_push_target_folder(), exports2);
    __exportStar3(require_ua_pub_sub_key_service(), exports2);
    __exportStar3(require_ua_pub_sub_status(), exports2);
    __exportStar3(require_ua_pub_sub_status_event(), exports2);
    __exportStar3(require_ua_pub_sub_transport_limits_exceed_event(), exports2);
    __exportStar3(require_ua_publish_subscribe(), exports2);
    __exportStar3(require_ua_published_data_items(), exports2);
    __exportStar3(require_ua_published_data_set(), exports2);
    __exportStar3(require_ua_published_events(), exports2);
    __exportStar3(require_ua_quantities_folder(), exports2);
    __exportStar3(require_ua_quantity(), exports2);
    __exportStar3(require_ua_rational_number(), exports2);
    __exportStar3(require_ua_reader_group(), exports2);
    __exportStar3(require_ua_reader_group_message(), exports2);
    __exportStar3(require_ua_reader_group_transport(), exports2);
    __exportStar3(require_ua_reference_description_variable(), exports2);
    __exportStar3(require_ua_refresh_end_event(), exports2);
    __exportStar3(require_ua_refresh_required_event(), exports2);
    __exportStar3(require_ua_refresh_start_event(), exports2);
    __exportStar3(require_ua_role(), exports2);
    __exportStar3(require_ua_role_mapping_rule_changed_audit_event(), exports2);
    __exportStar3(require_ua_role_set(), exports2);
    __exportStar3(require_ua_rsa_min_application_certificate(), exports2);
    __exportStar3(require_ua_rsa_sha_256_application_certificate(), exports2);
    __exportStar3(require_ua_safety_condition_class(), exports2);
    __exportStar3(require_ua_sampling_interval_diagnostics(), exports2);
    __exportStar3(require_ua_sampling_interval_diagnostics_array(), exports2);
    __exportStar3(require_ua_security_group(), exports2);
    __exportStar3(require_ua_security_group_folder(), exports2);
    __exportStar3(require_ua_selection_list(), exports2);
    __exportStar3(require_ua_semantic_change_event(), exports2);
    __exportStar3(require_ua_server(), exports2);
    __exportStar3(require_ua_server_capabilities(), exports2);
    __exportStar3(require_ua_server_configuration(), exports2);
    __exportStar3(require_ua_server_diagnostics(), exports2);
    __exportStar3(require_ua_server_diagnostics_summary(), exports2);
    __exportStar3(require_ua_server_redundancy(), exports2);
    __exportStar3(require_ua_server_status(), exports2);
    __exportStar3(require_ua_server_unit(), exports2);
    __exportStar3(require_ua_server_vendor_capability(), exports2);
    __exportStar3(require_ua_session_diagnostics_array(), exports2);
    __exportStar3(require_ua_session_diagnostics_object(), exports2);
    __exportStar3(require_ua_session_diagnostics_variable(), exports2);
    __exportStar3(require_ua_session_security_diagnostics(), exports2);
    __exportStar3(require_ua_session_security_diagnostics_array(), exports2);
    __exportStar3(require_ua_sessions_diagnostics_summary(), exports2);
    __exportStar3(require_ua_shelved_state_machine(), exports2);
    __exportStar3(require_ua_standalone_subscribed_data_set(), exports2);
    __exportStar3(require_ua_state(), exports2);
    __exportStar3(require_ua_state_machine(), exports2);
    __exportStar3(require_ua_state_variable(), exports2);
    __exportStar3(require_ua_statistical_condition_class(), exports2);
    __exportStar3(require_ua_subscribed_data_set(), exports2);
    __exportStar3(require_ua_subscribed_data_set_folder(), exports2);
    __exportStar3(require_ua_subscribed_data_set_mirror(), exports2);
    __exportStar3(require_ua_subscription_diagnostics(), exports2);
    __exportStar3(require_ua_subscription_diagnostics_array(), exports2);
    __exportStar3(require_ua_syntax_reference_entry(), exports2);
    __exportStar3(require_ua_system_condition_class(), exports2);
    __exportStar3(require_ua_system_diagnostic_alarm(), exports2);
    __exportStar3(require_ua_system_event(), exports2);
    __exportStar3(require_ua_system_off_normal_alarm(), exports2);
    __exportStar3(require_ua_system_status_change_event(), exports2);
    __exportStar3(require_ua_target_variables(), exports2);
    __exportStar3(require_ua_temporary_file_transfer(), exports2);
    __exportStar3(require_ua_testing_condition_class(), exports2);
    __exportStar3(require_ua_training_condition_class(), exports2);
    __exportStar3(require_ua_transaction_diagnostics(), exports2);
    __exportStar3(require_ua_transition(), exports2);
    __exportStar3(require_ua_transition_event(), exports2);
    __exportStar3(require_ua_transition_variable(), exports2);
    __exportStar3(require_ua_transparent_redundancy(), exports2);
    __exportStar3(require_ua_trip_alarm(), exports2);
    __exportStar3(require_ua_trust_list(), exports2);
    __exportStar3(require_ua_trust_list_out_of_date_alarm(), exports2);
    __exportStar3(require_ua_trust_list_update_requested_audit_event(), exports2);
    __exportStar3(require_ua_trust_list_updated_audit_event(), exports2);
    __exportStar3(require_ua_two_state_discrete(), exports2);
    __exportStar3(require_ua_two_state_variable2(), exports2);
    __exportStar3(require_ua_uadp_data_set_reader_message(), exports2);
    __exportStar3(require_ua_uadp_data_set_writer_message(), exports2);
    __exportStar3(require_ua_uadp_writer_group_message(), exports2);
    __exportStar3(require_ua_unit(), exports2);
    __exportStar3(require_ua_uri_dictionary_entry(), exports2);
    __exportStar3(require_ua_user_credential_certificate(), exports2);
    __exportStar3(require_ua_user_management(), exports2);
    __exportStar3(require_ua_vector(), exports2);
    __exportStar3(require_ua_vendor_server_info(), exports2);
    __exportStar3(require_ua_writer_group(), exports2);
    __exportStar3(require_ua_writer_group_message(), exports2);
    __exportStar3(require_ua_writer_group_transport(), exports2);
    __exportStar3(require_ua_xy_array_item(), exports2);
    __exportStar3(require_ua_y_array_item(), exports2);
  }
});

// node_modules/node-opcua-address-space/dist/src/nodeset_tools/construct_namespace_dependency.js
var require_construct_namespace_dependency = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/nodeset_tools/construct_namespace_dependency.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2._constructNamespaceTranslationTable = exports2.constructNamespaceDependency = exports2.constructNamespacePriorityTable = exports2._getCompleteRequiredModelsFromValuesAndReferences = exports2._recomputeRequiredModelsFromTypes2 = exports2._recomputeRequiredModelsFromTypes = void 0;
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_assert_1 = __importDefault3(require_dist14());
    var node_opcua_debug_1 = require_dist24();
    var base_node_impl_1 = require_base_node_impl();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    function _recomputeRequiredModelsFromTypes(namespace, cache) {
      if (namespace.index === 0) {
        return { requiredNamespaceIndexes: [], nbTypes: 1 };
      }
      if (cache) {
        if (cache.has(namespace.index)) {
          return cache.get(namespace.index);
        }
      }
      const requiredNamespaceIndexes = [0];
      const requiredModelsSet = /* @__PURE__ */ new Set();
      requiredModelsSet.add(0);
      const namespace_ = namespace;
      let nbTypes = 0;
      const addressSpace = namespace.addressSpace;
      const types2 = [node_opcua_data_model_1.NodeClass.VariableType, node_opcua_data_model_1.NodeClass.ObjectType, node_opcua_data_model_1.NodeClass.ReferenceType, node_opcua_data_model_1.NodeClass.DataType];
      const instances = [node_opcua_data_model_1.NodeClass.Variable, node_opcua_data_model_1.NodeClass.Object, node_opcua_data_model_1.NodeClass.Method];
      const consider = (requiredModel) => {
        if (requiredModel !== namespace.index && !requiredModelsSet.has(requiredModel)) {
          requiredModelsSet.add(requiredModel);
          requiredNamespaceIndexes.push(requiredModel);
        }
      };
      const _visitedDataType = /* @__PURE__ */ new Set();
      function exploreDataTypeField(field) {
        const dataType = field.dataType;
        const namespaceIndex = dataType.namespace;
        consider(namespaceIndex);
        const dataTypeNode = addressSpace.findDataType(field.dataType);
        if (dataTypeNode) {
          exploreDataTypes(dataTypeNode);
        }
      }
      function exploreDataTypes(dataTypeNode) {
        if (!dataTypeNode) {
          return;
        }
        const dataType = dataTypeNode.nodeId;
        if (_visitedDataType.has(dataType.toString())) {
          return;
        }
        if (dataTypeNode.nodeClass !== node_opcua_data_model_1.NodeClass.DataType) {
          warningLog("exploreDataTypes! ignoring ", dataTypeNode.toString());
          return;
        }
        const namespaceIndex = dataType.namespace;
        consider(namespaceIndex);
        if (dataTypeNode.isStructure()) {
          const definition = dataTypeNode.getStructureDefinition();
          for (const field of definition.fields || []) {
            exploreDataTypeField(field);
          }
        }
        _visitedDataType.add(dataType.toString());
      }
      function exploreExtensionObject(e) {
        (0, node_opcua_assert_1.default)(!(e instanceof node_opcua_variant_1.Variant));
        const nodeId = e.schema.encodingDefaultXml || e.schema.dataTypeNodeId || e.schema.dataTypeNodeId;
        consider(nodeId.namespace);
        if (e.schema.dataTypeNodeId.isEmpty()) {
          warningLog("Cannot find dataTypeNodeId for ", e.schema.name);
        }
        const d2 = addressSpace.findNode(e.schema.dataTypeNodeId);
        if (!d2)
          return;
        exploreDataTypes(d2);
      }
      function exploreDataValue(uaVariable) {
        if (uaVariable.getBasicDataType() !== node_opcua_basic_types_1.DataType.ExtensionObject) {
          return;
        }
        if (!uaVariable.$dataValue)
          return;
        const variant = uaVariable.$dataValue.value;
        if (!variant)
          return;
        const value = variant.value;
        if (!value)
          return;
        if (Array.isArray(value)) {
          value.forEach(exploreExtensionObject);
        } else {
          exploreExtensionObject(value);
        }
      }
      for (const node of namespace_.nodeIterator()) {
        const isType = types2.indexOf(node.nodeClass);
        const isInstance = instances.indexOf(node.nodeClass);
        if (isType !== -1) {
          nbTypes++;
          const superTypes = node.findReferencesAsObject("HasSubtype", false);
          if (superTypes.length === 0) {
            continue;
          }
          if (superTypes.length !== 1) {
            continue;
          }
          const superType = superTypes[0];
          if (superType.nodeId.namespace === 0) {
            continue;
          }
          const requiredModel = superType.nodeId.namespace;
          consider(requiredModel);
        } else if (isInstance !== -1) {
          if (node.nodeClass === node_opcua_data_model_1.NodeClass.Variable || node.nodeClass === node_opcua_data_model_1.NodeClass.VariableType) {
            const dataTypeNodeId = node.dataType;
            const dataTypeNode = addressSpace.findDataType(dataTypeNodeId);
            if (dataTypeNode) {
              consider(dataTypeNode.nodeId.namespace);
            } else {
              if (dataTypeNodeId.value != 0) {
                warningLog("Warning: Cannot find dataType", dataTypeNodeId.toString());
              }
            }
            const nodeV = node;
            exploreDataValue(nodeV);
          }
          const typeDefinitions = node.findReferencesAsObject("HasTypeDefinition", true);
          if (typeDefinitions.length === 0) {
            continue;
          }
          if (typeDefinitions.length !== 1) {
            continue;
          }
          const typeDefinition = typeDefinitions[0];
          const requiredModel = typeDefinition.nodeId.namespace;
          consider(requiredModel);
        }
      }
      const result2 = { requiredNamespaceIndexes, nbTypes };
      if (cache) {
        cache.set(namespace.index, result2);
      }
      return result2;
    }
    exports2._recomputeRequiredModelsFromTypes = _recomputeRequiredModelsFromTypes;
    function _recomputeRequiredModelsFromTypes2(namespace, cache) {
      const addressSpace = namespace.addressSpace;
      const { requiredNamespaceIndexes } = _recomputeRequiredModelsFromTypes(namespace, cache);
      const set = new Set(requiredNamespaceIndexes);
      const pass2 = [];
      for (const r of requiredNamespaceIndexes) {
        if (r === 0) {
          pass2.push(0);
          continue;
        }
        const namespaces = _recomputeRequiredModelsFromTypes(addressSpace.getNamespace(r), cache);
        for (const nIndex of namespaces.requiredNamespaceIndexes) {
          if (!set.has(nIndex)) {
            set.add(nIndex);
            pass2.push(nIndex);
          }
        }
        pass2.push(r);
      }
      return { requiredNamespaceIndexes: pass2 };
    }
    exports2._recomputeRequiredModelsFromTypes2 = _recomputeRequiredModelsFromTypes2;
    function _getCompleteRequiredModelsFromValuesAndReferences(namespace, priorityList, cache) {
      const namespace_ = namespace;
      const thisPriority = priorityList[namespace.index];
      const requiredNamespaceIndexes = _recomputeRequiredModelsFromTypes2(namespace, cache).requiredNamespaceIndexes;
      const requiredModelsSet = /* @__PURE__ */ new Set([...requiredNamespaceIndexes]);
      const consider = (requiredModel) => {
        if (requiredModel !== namespace.index && !requiredModelsSet.has(requiredModel)) {
          requiredModelsSet.add(requiredModel);
          requiredNamespaceIndexes.push(requiredModel);
        }
      };
      for (const node of namespace_.nodeIterator()) {
        const references = node.allReferences();
        for (const reference of references) {
          const namespaceIndexOfReferenceType = (0, base_node_impl_1.getReferenceType)(reference).nodeId.namespace;
          if (namespaceIndexOfReferenceType !== 0 && namespaceIndexOfReferenceType !== namespace.index) {
            const refPriority = priorityList[namespaceIndexOfReferenceType];
            if (refPriority <= thisPriority) {
              consider(namespaceIndexOfReferenceType);
            }
          }
          const namespaceIndexOfTargetNode = reference.nodeId.namespace;
          if (namespaceIndexOfTargetNode !== 0 && namespaceIndexOfTargetNode !== namespace.index) {
            const refPriority = priorityList[namespaceIndexOfTargetNode];
            if (refPriority <= thisPriority) {
              consider(namespaceIndexOfTargetNode);
            }
          }
        }
      }
      return requiredNamespaceIndexes;
    }
    exports2._getCompleteRequiredModelsFromValuesAndReferences = _getCompleteRequiredModelsFromValuesAndReferences;
    function constructNamespacePriorityTable(addressSpace) {
      const namespaces = addressSpace.getNamespaceArray();
      const loadingOrder = [0];
      const map = /* @__PURE__ */ new Map();
      for (let i = 0; i < namespaces.length; i++) {
        const { nbTypes, requiredNamespaceIndexes } = _recomputeRequiredModelsFromTypes(namespaces[i], map);
        map.set(namespaces[i].index, { nbTypes, requiredNamespaceIndexes, namespace: namespaces[i] });
      }
      const visited = /* @__PURE__ */ new Set();
      visited.add(0);
      const h = (n) => {
        if (visited.has(n.index)) {
          return;
        }
        visited.add(n.index);
        const data = map.get(n.index);
        if (!data)
          return;
        const { requiredNamespaceIndexes } = data;
        for (const r of requiredNamespaceIndexes || []) {
          h(namespaces[r]);
        }
        loadingOrder.push(n.index);
      };
      for (let i = 0; i < namespaces.length; i++) {
        const { nbTypes } = map.get(i);
        if (nbTypes) {
          h(namespaces[i]);
        }
      }
      for (let i = 0; i < namespaces.length; i++) {
        const { nbTypes } = map.get(i);
        if (!nbTypes) {
          h(namespaces[i]);
        }
      }
      const priorityTable = [];
      for (let i = 0; i < loadingOrder.length; i++) {
        const namespaceIndex = loadingOrder[i];
        (0, node_opcua_assert_1.default)(namespaceIndex !== -1);
        priorityTable[namespaceIndex] = i;
      }
      return { loadingOrder, priorityTable };
    }
    exports2.constructNamespacePriorityTable = constructNamespacePriorityTable;
    function constructNamespaceDependency(namespace, priorityTable) {
      const addressSpace = namespace.addressSpace;
      priorityTable = priorityTable || constructNamespacePriorityTable(addressSpace).priorityTable;
      const requiredNamespaceIndexes = _getCompleteRequiredModelsFromValuesAndReferences(namespace, priorityTable);
      return [...requiredNamespaceIndexes.map((r) => addressSpace.getNamespace(r)), namespace];
    }
    exports2.constructNamespaceDependency = constructNamespaceDependency;
    function _constructNamespaceTranslationTable(dependency, exportedNamespace) {
      if (!dependency || dependency.length === 0) {
        return { 0: 0 };
      }
      const translationTable = {};
      (0, node_opcua_assert_1.default)(dependency[0].namespaceUri === "http://opcfoundation.org/UA/");
      let counter = 0;
      translationTable[dependency[0].index] = counter++;
      if (exportedNamespace) {
        translationTable[exportedNamespace.index] = counter++;
      }
      for (let i = 1; i < dependency.length; i++) {
        const dep = dependency[i];
        if (exportedNamespace && exportedNamespace === dep) {
          continue;
        }
        translationTable[dep.index] = counter++;
      }
      return translationTable;
    }
    exports2._constructNamespaceTranslationTable = _constructNamespaceTranslationTable;
  }
});

// node_modules/node-opcua-address-space/dist/source/index.js
var require_source4 = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NodeIdManager = exports2.instantiateCertificateExpirationAlarm = exports2.ensureDatatypeExtractedWithCallback = exports2.ensureDatatypeExtracted = exports2.ContinuationPointManager = exports2.resolveOpaqueOnAddressSpace = exports2.adjustBrowseDirection = exports2.validateDataTypeCorrectness = exports2.validateDataType = exports2.validateIsNumericDataType = exports2.promoteToTwoStateDiscrete = exports2.promoteToMultiStateValueDiscrete = exports2.promoteToMultiStateDiscrete = void 0;
    __exportStar3(require_address_space_ts(), exports2);
    __exportStar3(require_ua_state_machine_type(), exports2);
    __exportStar3(require_ua_exclusive_limit_state_machine_type_ex(), exports2);
    __exportStar3(require_ua_finite_state_machine_type(), exports2);
    __exportStar3(require_ua_program_state_machine_type(), exports2);
    __exportStar3(require_ua_shelved_state_machine_ex(), exports2);
    __exportStar3(require_ua_transition_ex(), exports2);
    __exportStar3(require_ua_subscription_diagnostics_variable_ex(), exports2);
    __exportStar3(require_ua_multistate_discrete_ex(), exports2);
    __exportStar3(require_ua_multistate_value_discrete_ex(), exports2);
    __exportStar3(require_ua_two_state_discrete_ex(), exports2);
    __exportStar3(require_ua_y_array_item_ex(), exports2);
    __exportStar3(require_extension_object_constructor(), exports2);
    __exportStar3(require_condition_info_i(), exports2);
    __exportStar3(require_condition_snapshot(), exports2);
    __exportStar3(require_instantiate_alarm_condition_options(), exports2);
    __exportStar3(require_instantiate_condition_options(), exports2);
    __exportStar3(require_instantiate_exclusive_limit_alarm_options(), exports2);
    __exportStar3(require_instantiate_limit_alarm_options(), exports2);
    __exportStar3(require_instantiate_off_normal_alarm_options(), exports2);
    __exportStar3(require_ua_acknowledgeable_condition_ex(), exports2);
    __exportStar3(require_ua_alarm_condition_ex(), exports2);
    __exportStar3(require_ua_certificate_expiration_alarm_ex(), exports2);
    __exportStar3(require_ua_condition_ex(), exports2);
    __exportStar3(require_ua_discrete_alarm_ex(), exports2);
    __exportStar3(require_ua_exclusive_deviation_alarm_ex(), exports2);
    __exportStar3(require_ua_exclusive_limit_alarm_ex(), exports2);
    __exportStar3(require_ua_limit_alarm_ex(), exports2);
    __exportStar3(require_ua_non_exclusive_deviation_alarm_ex(), exports2);
    __exportStar3(require_ua_non_exclusive_limit_alarm_ex(), exports2);
    var ua_multistate_discrete_impl_1 = require_ua_multistate_discrete_impl();
    Object.defineProperty(exports2, "promoteToMultiStateDiscrete", { enumerable: true, get: function() {
      return ua_multistate_discrete_impl_1.promoteToMultiStateDiscrete;
    } });
    var ua_multistate_value_discrete_impl_1 = require_ua_multistate_value_discrete_impl();
    Object.defineProperty(exports2, "promoteToMultiStateValueDiscrete", { enumerable: true, get: function() {
      return ua_multistate_value_discrete_impl_1.promoteToMultiStateValueDiscrete;
    } });
    var ua_two_state_discrete_impl_1 = require_ua_two_state_discrete_impl();
    Object.defineProperty(exports2, "promoteToTwoStateDiscrete", { enumerable: true, get: function() {
      return ua_two_state_discrete_impl_1.promoteToTwoStateDiscrete;
    } });
    var ua_multistate_value_discrete_impl_2 = require_ua_multistate_value_discrete_impl();
    Object.defineProperty(exports2, "validateIsNumericDataType", { enumerable: true, get: function() {
      return ua_multistate_value_discrete_impl_2.validateIsNumericDataType;
    } });
    var ua_multistate_value_discrete_impl_3 = require_ua_multistate_value_discrete_impl();
    Object.defineProperty(exports2, "validateDataType", { enumerable: true, get: function() {
      return ua_multistate_value_discrete_impl_3.validateDataType;
    } });
    var validate_data_type_correctness_1 = require_validate_data_type_correctness();
    Object.defineProperty(exports2, "validateDataTypeCorrectness", { enumerable: true, get: function() {
      return validate_data_type_correctness_1.validateDataTypeCorrectness;
    } });
    __exportStar3(require_ua_root_folder(), exports2);
    __exportStar3(require_session_context2(), exports2);
    __exportStar3(require_pseudo_session(), exports2);
    __exportStar3(require_dump_tools(), exports2);
    __exportStar3(require_make_optionals_map(), exports2);
    __exportStar3(require_argument_list(), exports2);
    __exportStar3(require_call_helpers(), exports2);
    __exportStar3(require_ensure_secure_access(), exports2);
    var adjust_browse_direction_1 = require_adjust_browse_direction();
    Object.defineProperty(exports2, "adjustBrowseDirection", { enumerable: true, get: function() {
      return adjust_browse_direction_1.adjustBrowseDirection;
    } });
    var resolve_opaque_on_address_space_1 = require_resolve_opaque_on_address_space();
    Object.defineProperty(exports2, "resolveOpaqueOnAddressSpace", { enumerable: true, get: function() {
      return resolve_opaque_on_address_space_1.resolveOpaqueOnAddressSpace;
    } });
    var continuation_point_manager_1 = require_continuation_point_manager();
    Object.defineProperty(exports2, "ContinuationPointManager", { enumerable: true, get: function() {
      return continuation_point_manager_1.ContinuationPointManager;
    } });
    var ensure_datatype_extracted_1 = require_ensure_datatype_extracted();
    Object.defineProperty(exports2, "ensureDatatypeExtracted", { enumerable: true, get: function() {
      return ensure_datatype_extracted_1.ensureDatatypeExtracted;
    } });
    Object.defineProperty(exports2, "ensureDatatypeExtractedWithCallback", { enumerable: true, get: function() {
      return ensure_datatype_extracted_1.ensureDatatypeExtractedWithCallback;
    } });
    __exportStar3(require_generateAddressSpaceRaw(), exports2);
    __exportStar3(require_register_node_promoter(), exports2);
    __exportStar3(require_namespace2(), exports2);
    __exportStar3(require_namespace_data_access(), exports2);
    __exportStar3(require_private_namespace(), exports2);
    var ua_certificate_expiration_alarm_impl_1 = require_ua_certificate_expiration_alarm_impl();
    Object.defineProperty(exports2, "instantiateCertificateExpirationAlarm", { enumerable: true, get: function() {
      return ua_certificate_expiration_alarm_impl_1.instantiateCertificateExpirationAlarm;
    } });
    var nodeid_manager_1 = require_nodeid_manager();
    Object.defineProperty(exports2, "NodeIdManager", { enumerable: true, get: function() {
      return nodeid_manager_1.NodeIdManager;
    } });
    __exportStar3(require_event_data(), exports2);
    __exportStar3(require_set_namespace_meta_data(), exports2);
    __exportStar3(require_dist53(), exports2);
    __exportStar3(require_dist57(), exports2);
    __exportStar3(require_construct_namespace_dependency(), exports2);
  }
});

// node_modules/node-opcua-address-space/dist/src/ua_reference_type_impl.js
var require_ua_reference_type_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/ua_reference_type_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UAReferenceTypeImpl = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_data_model_2 = require_dist27();
    var node_opcua_data_model_3 = require_dist27();
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_variant_1 = require_dist28();
    var source_1 = require_source4();
    var base_node_impl_1 = require_base_node_impl();
    var tool_isSubtypeOf_1 = require_tool_isSubtypeOf();
    var tool_isSubtypeOf_2 = require_tool_isSubtypeOf();
    var reference_impl_1 = require_reference_impl();
    var base_node_private_1 = require_base_node_private();
    var ReferenceTypeCounter = { count: 0 };
    function _internal_getAllSubtypes(referenceType) {
      const addressSpace = referenceType.addressSpace;
      const possibleReferenceTypes = [];
      const hasSubtypeReferenceType = addressSpace.findReferenceType("HasSubtype");
      function _findAllSubType(referenceTypeInner) {
        possibleReferenceTypes.push(referenceTypeInner);
        (0, node_opcua_assert_1.assert)(referenceTypeInner.nodeClass === node_opcua_data_model_2.NodeClass.ReferenceType);
        const references = referenceTypeInner.findReferences(hasSubtypeReferenceType, true);
        for (const _r of references) {
          const subType = addressSpace.findReferenceType(_r.nodeId);
          _findAllSubType(subType);
        }
      }
      _findAllSubType(referenceType);
      return possibleReferenceTypes;
    }
    function _getAllSubtypes(ref) {
      const _cache = (0, base_node_private_1.BaseNode_getCache)(ref);
      if (!_cache._allSubTypesVersion || _cache._allSubTypesVersion < ReferenceTypeCounter.count) {
        _cache._allSubTypes = null;
      }
      if (!_cache._allSubTypes) {
        _cache._allSubTypes = _internal_getAllSubtypes(ref);
        _cache._allSubTypesVersion = ReferenceTypeCounter.count;
      }
      return _cache._allSubTypes;
    }
    function _internal_getSubtypeIndex(referenceType) {
      const possibleReferenceTypes = _getAllSubtypes(referenceType);
      const keys = {};
      for (const refType of possibleReferenceTypes) {
        keys[refType.nodeId.toString()] = refType;
      }
      return keys;
    }
    function _getSubtypeIndex(referenceType) {
      const _cache = (0, base_node_private_1.BaseNode_getCache)(referenceType);
      if (!_cache._subtype_idx || _cache._subtype_idxVersion && _cache._subtype_idxVersion < ReferenceTypeCounter.count) {
        _cache._subtype_idx = null;
      }
      if (!_cache._subtype_idx) {
        _cache._subtype_idx = _internal_getSubtypeIndex(referenceType);
        _cache._subtype_idxVersion = ReferenceTypeCounter.count;
      }
      return _cache._subtype_idx;
    }
    var UAReferenceTypeImpl = class _UAReferenceTypeImpl extends base_node_impl_1.BaseNodeImpl {
      get subtypeOfObj() {
        return tool_isSubtypeOf_2.get_subtypeOfObj.call(this);
      }
      get subtypeOf() {
        return tool_isSubtypeOf_2.get_subtypeOf.call(this);
      }
      constructor(options) {
        super(options);
        this.nodeClass = node_opcua_data_model_2.NodeClass.ReferenceType;
        this.isSubtypeOf = (0, tool_isSubtypeOf_1.construct_isSubtypeOf)(_UAReferenceTypeImpl);
        this.isSupertypeOf = (0, tool_isSubtypeOf_1.construct_isSubtypeOf)(_UAReferenceTypeImpl);
        this._slow_isSubtypeOf = (0, tool_isSubtypeOf_1.construct_slow_isSubtypeOf)(_UAReferenceTypeImpl);
        this.isAbstract = options.isAbstract === void 0 ? false : !!options.isAbstract;
        this.symmetric = options.symmetric === void 0 ? false : !!options.symmetric;
        this.inverseName = (0, node_opcua_data_model_1.coerceLocalizedText)(options.inverseName || this.browseName.name);
        ReferenceTypeCounter.count += 1;
      }
      readAttribute(context, attributeId) {
        (0, node_opcua_assert_1.assert)(!context || context instanceof source_1.SessionContext);
        const options = {};
        switch (attributeId) {
          case node_opcua_data_model_3.AttributeIds.IsAbstract:
            options.value = { dataType: node_opcua_variant_1.DataType.Boolean, value: !!this.isAbstract };
            options.statusCode = node_opcua_status_code_1.StatusCodes.Good;
            break;
          case node_opcua_data_model_3.AttributeIds.Symmetric:
            options.value = { dataType: node_opcua_variant_1.DataType.Boolean, value: !!this.symmetric };
            options.statusCode = node_opcua_status_code_1.StatusCodes.Good;
            break;
          case node_opcua_data_model_3.AttributeIds.InverseName:
            options.value = { dataType: node_opcua_variant_1.DataType.LocalizedText, value: this.inverseName };
            options.statusCode = node_opcua_status_code_1.StatusCodes.Good;
            break;
          default:
            return super.readAttribute(context, attributeId);
        }
        return new node_opcua_data_value_1.DataValue(options);
      }
      toString() {
        let str = "";
        str += this.isAbstract ? "A" : " ";
        str += this.symmetric ? "S" : " ";
        str += " " + this.browseName.toString() + "/" + this.inverseName.text + " ";
        str += this.nodeId.toString();
        return str;
      }
      install_extra_properties() {
      }
      /**
       * returns a array of all ReferenceTypes in the addressSpace that are self or a subType of self
       * recursively
       */
      getAllSubtypes() {
        return _getAllSubtypes(this);
      }
      checkHasSubtype(ref) {
        const _index = _getSubtypeIndex(this);
        const referenceTypeNodeId = ref instanceof reference_impl_1.ReferenceImpl ? ref.nodeId : ref;
        const _key = referenceTypeNodeId.toString();
        return !!_index[_key];
      }
    };
    exports2.UAReferenceTypeImpl = UAReferenceTypeImpl;
  }
});

// node_modules/node-opcua-address-space/dist/src/ua_view_impl.js
var require_ua_view_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/ua_view_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UAViewImpl = void 0;
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_data_model_2 = require_dist27();
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_address_space_base_1 = require_dist53();
    var session_context_1 = require_session_context2();
    var base_node_impl_1 = require_base_node_impl();
    var UAViewImpl = class extends base_node_impl_1.BaseNodeImpl {
      get eventNotifier() {
        return this._eventNotifier;
      }
      constructor(options) {
        super(options);
        this.nodeClass = node_opcua_data_model_1.NodeClass.View;
        this.containsNoLoops = !!options.containsNoLoops;
        this._eventNotifier = node_opcua_address_space_base_1.EventNotifierFlags.None;
      }
      readAttribute(context, attributeId) {
        context = context || session_context_1.SessionContext.defaultContext;
        const options = {};
        switch (attributeId) {
          case node_opcua_data_model_2.AttributeIds.EventNotifier:
            options.value = { dataType: node_opcua_variant_1.DataType.Byte, value: this.eventNotifier };
            options.statusCode = node_opcua_status_code_1.StatusCodes.Good;
            break;
          case node_opcua_data_model_2.AttributeIds.ContainsNoLoops:
            options.value = { dataType: node_opcua_variant_1.DataType.Boolean, value: this.containsNoLoops };
            options.statusCode = node_opcua_status_code_1.StatusCodes.Good;
            break;
          default:
            return super.readAttribute(context, attributeId);
        }
        return new node_opcua_data_value_1.DataValue(options);
      }
    };
    exports2.UAViewImpl = UAViewImpl;
  }
});

// node_modules/node-opcua-address-space/dist/src/namespace_impl.js
var require_namespace_impl = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/namespace_impl.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isNonEmptyQualifiedName = exports2._handle_hierarchy_parent = exports2.NamespaceImpl = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_data_access_1 = require_dist35();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_data_model_2 = require_dist27();
    var node_opcua_data_model_3 = require_dist27();
    var node_opcua_data_model_4 = require_dist27();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_nodeid_2 = require_dist21();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_variant_1 = require_dist28();
    var address_space_change_event_tools_1 = require_address_space_change_event_tools();
    var ua_condition_impl_1 = require_ua_condition_impl();
    var ua_discrete_alarm_impl_1 = require_ua_discrete_alarm_impl();
    var ua_exclusive_deviation_alarm_impl_1 = require_ua_exclusive_deviation_alarm_impl();
    var ua_exclusive_limit_alarm_impl_1 = require_ua_exclusive_limit_alarm_impl();
    var ua_limit_alarm_impl_1 = require_ua_limit_alarm_impl();
    var ua_non_exclusive_deviation_alarm_impl_1 = require_ua_non_exclusive_deviation_alarm_impl();
    var ua_non_exclusive_limit_alarm_impl_1 = require_ua_non_exclusive_limit_alarm_impl();
    var alarms_and_conditions_1 = require_alarms_and_conditions();
    var ua_off_normal_alarm_impl_1 = require_ua_off_normal_alarm_impl();
    var add_dataItem_stuff_1 = require_add_dataItem_stuff();
    var ua_multistate_discrete_impl_1 = require_ua_multistate_discrete_impl();
    var ua_two_state_variable_1 = require_ua_two_state_variable();
    var namespace_private_1 = require_namespace_private();
    var base_node_impl_1 = require_base_node_impl();
    var ua_variable_impl_1 = require_ua_variable_impl();
    var nodeid_manager_1 = require_nodeid_manager();
    var ua_two_state_discrete_impl_1 = require_ua_two_state_discrete_impl();
    var role_permissions_1 = require_role_permissions();
    var ua_object_impl_1 = require_ua_object_impl();
    var ua_data_type_impl_1 = require_ua_data_type_impl();
    var ua_object_type_impl_1 = require_ua_object_type_impl();
    var ua_method_impl_1 = require_ua_method_impl();
    var ua_variable_type_impl_1 = require_ua_variable_type_impl();
    var ua_reference_type_impl_1 = require_ua_reference_type_impl();
    var ua_view_impl_1 = require_ua_view_impl();
    var ua_multistate_value_discrete_impl_1 = require_ua_multistate_value_discrete_impl();
    function _makeHashKey(nodeId) {
      switch (nodeId.identifierType) {
        case node_opcua_nodeid_1.NodeIdType.STRING:
        case node_opcua_nodeid_1.NodeIdType.GUID:
          return nodeId.value;
        case node_opcua_nodeid_1.NodeIdType.NUMERIC:
          return nodeId.value;
        default:
          if (nodeId.identifierType !== node_opcua_nodeid_1.NodeIdType.BYTESTRING) {
            throw new Error("invalid nodeIdType");
          }
          return nodeId.value ? nodeId.value.toString() : "OPAQUE:0";
      }
    }
    var doDebug = false;
    var errorLog = (0, node_opcua_debug_1.make_errorLog)("AddressSpace");
    var warningLog = (0, node_opcua_debug_1.make_warningLog)("AddressSpace");
    var regExp1 = /^(s|i|b|g)=/;
    var regExpNamespaceDotBrowseName = /^[0-9]+:(.*)/;
    function detachNode(node) {
      const addressSpace = node.addressSpace;
      const nonHierarchicalReferences = node.findReferencesEx("NonHierarchicalReferences", node_opcua_data_model_3.BrowseDirection.Inverse);
      for (const ref of nonHierarchicalReferences) {
        (0, node_opcua_assert_1.assert)(!ref.isForward);
        ref.node.removeReference({
          isForward: !ref.isForward,
          nodeId: node.nodeId,
          referenceType: ref.referenceType
        });
      }
      const nonHierarchicalReferencesF = node.findReferencesEx("NonHierarchicalReferences", node_opcua_data_model_3.BrowseDirection.Forward);
      for (const ref of nonHierarchicalReferencesF) {
        if (!ref.node) {
          continue;
        }
        (0, node_opcua_assert_1.assert)(ref.isForward);
        ref.node.removeReference({
          isForward: !ref.isForward,
          nodeId: node.nodeId,
          referenceType: ref.referenceType
        });
      }
      const hierarchicalReferences = node.findReferencesEx("HierarchicalReferences", node_opcua_data_model_3.BrowseDirection.Inverse);
      for (const ref of hierarchicalReferences) {
        (0, node_opcua_assert_1.assert)(!ref.isForward);
        const parent = addressSpace.findNode(ref.nodeId);
        parent.removeReference({
          isForward: !ref.isForward,
          nodeId: node.nodeId,
          referenceType: ref.referenceType
        });
      }
      node.unpropagate_back_references();
    }
    var NamespaceImpl = class {
      constructor(options) {
        this.emulateVersion103 = false;
        this.version = "0.0.0";
        this.publicationDate = new Date(Date.UTC(1900, 0, 1));
        this.registerSymbolicNames = false;
        if (!(typeof options.namespaceUri === "string")) {
          throw new Error("NamespaceImpl constructor: namespaceUri must exists and be a string : got " + options.namespaceUri);
        }
        if (typeof options.index !== "number") {
          throw new Error("NamespaceImpl constructor: index must be a number");
        }
        if (!options.addressSpace) {
          throw new Error("NamespaceImpl constructor: Must specify a valid address space");
        }
        this.namespaceUri = options.namespaceUri;
        this.addressSpace = options.addressSpace;
        this.index = options.index;
        this._nodeid_index = /* @__PURE__ */ new Map();
        this._aliases = /* @__PURE__ */ new Map();
        this._objectTypeMap = /* @__PURE__ */ new Map();
        this._variableTypeMap = /* @__PURE__ */ new Map();
        this._referenceTypeMap = /* @__PURE__ */ new Map();
        this._referenceTypeMapInv = /* @__PURE__ */ new Map();
        this._dataTypeMap = /* @__PURE__ */ new Map();
        this._nodeIdManager = new nodeid_manager_1.NodeIdManager(this.index, this.addressSpace);
      }
      getDefaultNamespace() {
        return this.index === 0 ? this : this.addressSpace.getDefaultNamespace();
      }
      dispose() {
        for (const node of this.nodeIterator()) {
          node.dispose();
        }
        this._nodeid_index = /* @__PURE__ */ new Map();
        this._aliases = /* @__PURE__ */ new Map();
        this.addressSpace = {};
        this._objectTypeMap = /* @__PURE__ */ new Map();
        this._variableTypeMap = /* @__PURE__ */ new Map();
        this._referenceTypeMap = /* @__PURE__ */ new Map();
        this._referenceTypeMapInv = /* @__PURE__ */ new Map();
        this._dataTypeMap = /* @__PURE__ */ new Map();
      }
      nodeIterator() {
        return this._nodeid_index.values();
      }
      _objectTypeIterator() {
        return this._objectTypeMap.values();
      }
      _objectTypeCount() {
        return this._objectTypeMap.size;
      }
      _variableTypeIterator() {
        return this._variableTypeMap.values();
      }
      _variableTypeCount() {
        return this._variableTypeMap.size;
      }
      _dataTypeIterator() {
        return this._dataTypeMap.values();
      }
      _dataTypeCount() {
        return this._dataTypeMap.size;
      }
      _referenceTypeIterator() {
        return this._referenceTypeMap.values();
      }
      _referenceTypeCount() {
        return this._referenceTypeMap.size;
      }
      _aliasCount() {
        return this._aliases.size;
      }
      findNode2(nodeId) {
        (0, node_opcua_assert_1.assert)(nodeId.namespace === this.index);
        return this._nodeid_index.get(_makeHashKey(nodeId)) || null;
      }
      findNode(nodeId) {
        if (typeof nodeId === "string") {
          if (nodeId.match(regExp1)) {
            nodeId = "ns=" + this.index + ";" + nodeId;
          }
        }
        nodeId = (0, node_opcua_nodeid_1.resolveNodeId)(nodeId);
        return this.findNode2(nodeId);
      }
      /**
       *
       * @param objectTypeName {String}
       * @return {UAObjectType|null}
       */
      findObjectType(objectTypeName) {
        return this._objectTypeMap.get(objectTypeName) || null;
      }
      /**
       *
       * @param variableTypeName {String}
       * @returns {UAVariableType|null}
       */
      findVariableType(variableTypeName) {
        return this._variableTypeMap.get(variableTypeName) || null;
      }
      /**
       *
       * @param dataTypeName {String}
       * @returns {UADataType|null}
       */
      findDataType(dataTypeName) {
        return this._dataTypeMap.get(dataTypeName) || null;
      }
      /**
       *
       * @param referenceTypeName {String}
       * @returns  {ReferenceType|null}
       */
      findReferenceType(referenceTypeName) {
        return this._referenceTypeMap.get(referenceTypeName) || null;
      }
      /**
       * find a ReferenceType by its inverse name.
       * @method findReferenceTypeFromInverseName
       * @param inverseName {String} the inverse name of the ReferenceType to find
       * @return {ReferenceType}
       */
      findReferenceTypeFromInverseName(inverseName) {
        (0, node_opcua_assert_1.assert)(typeof inverseName === "string");
        const node = this._referenceTypeMapInv.get(inverseName);
        (0, node_opcua_assert_1.assert)(!node || node.nodeClass === node_opcua_data_model_4.NodeClass.ReferenceType && node.inverseName.text === inverseName);
        return node ? node : null;
      }
      /**
       *
       * @method addAlias
       * @param alias_name {String} the alias name
       * @param nodeId {NodeId} NodeId must belong to this namespace
       */
      addAlias(alias_name, nodeId) {
        (0, node_opcua_assert_1.assert)(typeof alias_name === "string");
        (0, node_opcua_assert_1.assert)(nodeId instanceof node_opcua_nodeid_2.NodeId);
        (0, node_opcua_assert_1.assert)(nodeId.namespace === this.index);
        this._aliases.set(alias_name, nodeId);
      }
      resolveAlias(name) {
        return this._aliases.get(name) || null;
      }
      /**
       * add a new Object type to the address space
       * @method addObjectType
       * @param options
       * @param options.browseName {String} the object type name
       * @param [options.displayName] {String|LocalizedText} the display name
       * @param [options.subtypeOf="BaseObjectType"] {String|NodeId|BaseNode} the base class
       * @param [options.nodeId] {String|NodeId} an optional nodeId for this objectType,
       *                                         if not provided a new nodeId will be created
       * @param [options.isAbstract = false] {Boolean}
       * @param [options.eventNotifier = 0] {Integer}
       * @param [options.postInstantiateFunc = null] {Function}
       *
       */
      addObjectType(options) {
        (0, node_opcua_assert_1.assert)(!Object.prototype.hasOwnProperty.call(options, "dataType"), "an objectType should not have a dataType");
        (0, node_opcua_assert_1.assert)(!Object.prototype.hasOwnProperty.call(options, "valueRank"), "an objectType should not have a valueRank");
        (0, node_opcua_assert_1.assert)(!Object.prototype.hasOwnProperty.call(options, "arrayDimensions"), "an objectType should not have a arrayDimensions");
        return this._addObjectOrVariableType(options, "BaseObjectType", node_opcua_data_model_4.NodeClass.ObjectType);
      }
      /**
       * add a new Variable type to the address space
       * @method addVariableType
       * @param options
       * @param options.browseName {String} the object type name
       * @param [options.displayName] {String|LocalizedText} the display name
       * @param [options.subtypeOf="BaseVariableType"] {String|NodeId|BaseNode} the base class
       * @param [options.nodeId] {String|NodeId} an optional nodeId for this objectType,
       *                                             if not provided a new nodeId will be created
       * @param [options.isAbstract = false] {Boolean}
       * @param options.dataType {String|NodeId} the variable DataType
       * @param [options.valueRank = -1]
       * @param [options.arrayDimensions = null] { Array<Int>>
       *
       */
      addVariableType(options) {
        (0, node_opcua_assert_1.assert)(!Object.prototype.hasOwnProperty.call(options, "arrayDimension"), "Do you mean ArrayDimensions ?");
        options.dataType = options.dataType || "Int32";
        options.dataType = this.addressSpace._coerce_DataType(options.dataType);
        (0, node_opcua_variant_1.verifyRankAndDimensions)(options);
        const variableType = this._addObjectOrVariableType(options, "BaseVariableType", node_opcua_data_model_4.NodeClass.VariableType);
        variableType.dataType = options.dataType;
        variableType.valueRank = options.valueRank || 0;
        variableType.arrayDimensions = options.arrayDimensions;
        return variableType;
      }
      /**
       * add a variable as a component of the parent node
       */
      addVariable(options) {
        (0, node_opcua_assert_1.assert)(arguments.length === 1, "Invalid arguments IAddressSpace#addVariable now takes only one argument.");
        if (Object.prototype.hasOwnProperty.call(options, "propertyOf") && options.propertyOf) {
          (0, node_opcua_assert_1.assert)(!options.typeDefinition || options.typeDefinition === "PropertyType");
          options.typeDefinition = options.typeDefinition || "PropertyType";
        } else {
          (0, node_opcua_assert_1.assert)(!options.typeDefinition || options.typeDefinition !== "PropertyType");
        }
        return this._addVariable(options);
      }
      addView(options) {
        (0, node_opcua_assert_1.assert)(arguments.length === 1, "Namespace#addView expecting a single argument");
        (0, node_opcua_assert_1.assert)(options);
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "browseName"));
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "organizedBy"));
        const browseName = options.browseName;
        (0, node_opcua_assert_1.assert)(typeof browseName === "string");
        const addressSpace = this.addressSpace;
        const baseDataVariableTypeId = addressSpace.findVariableType("BaseDataVariableType").nodeId;
        const typeDefinition = options.typeDefinition || baseDataVariableTypeId;
        options.references = options.references || [];
        options.references.push({
          isForward: true,
          nodeId: typeDefinition,
          referenceType: "HasTypeDefinition"
        });
        const createOptions = options;
        (0, node_opcua_assert_1.assert)(!createOptions.nodeClass);
        createOptions.nodeClass = node_opcua_data_model_4.NodeClass.View;
        const view = this.createNode(createOptions);
        (0, node_opcua_assert_1.assert)(view.nodeId instanceof node_opcua_nodeid_2.NodeId);
        (0, node_opcua_assert_1.assert)(view.nodeClass === node_opcua_data_model_4.NodeClass.View);
        return view;
      }
      addObject(options1) {
        const options = options1;
        (0, node_opcua_assert_1.assert)(!options.nodeClass || options.nodeClass === node_opcua_data_model_4.NodeClass.Object);
        options.nodeClass = node_opcua_data_model_4.NodeClass.Object;
        const typeDefinition = options.typeDefinition || "BaseObjectType";
        options.references = options.references || [];
        options.references.push({ referenceType: "HasTypeDefinition", isForward: true, nodeId: typeDefinition });
        options.eventNotifier = +options.eventNotifier;
        const obj = this.createNode(options);
        (0, node_opcua_assert_1.assert)(obj instanceof ua_object_impl_1.UAObjectImpl);
        (0, node_opcua_assert_1.assert)(obj.nodeClass === node_opcua_data_model_4.NodeClass.Object);
        return obj;
      }
      /**
       *
       * @method addFolder
       * @param parentFolder
       * @param options {String|Object}
       * @param options.browseName {String} the name of the folder
       * @param [options.nodeId] {NodeId}. An optional nodeId for this object
       *
       * @return {BaseNode}
       */
      addFolder(parentFolder, options) {
        if (typeof options === "string") {
          options = { browseName: options };
        }
        const addressSpace = this.addressSpace;
        (0, node_opcua_assert_1.assert)(!options.typeDefinition, "addFolder does not expect typeDefinition to be defined ");
        const typeDefinition = addressSpace._coerceTypeDefinition("FolderType");
        parentFolder = addressSpace._coerceFolder(parentFolder);
        options.nodeClass = node_opcua_data_model_4.NodeClass.Object;
        options.references = [
          { referenceType: "HasTypeDefinition", isForward: true, nodeId: typeDefinition },
          { referenceType: "Organizes", isForward: false, nodeId: parentFolder.nodeId }
        ];
        const node = this.createNode(options);
        return node;
      }
      /**
       * @method addReferenceType
       * @param options
       * @param options.isAbstract
       * @param options.browseName
       * @param options.inverseName
       */
      addReferenceType(options) {
        const addressSpace = this.addressSpace;
        const options1 = options;
        options1.nodeClass = node_opcua_data_model_4.NodeClass.ReferenceType;
        options1.references = options.references || [];
        options1.nodeId = options.nodeId;
        if (options.subtypeOf) {
          const subtypeOfNodeId = addressSpace._coerceType(options.subtypeOf, "References", node_opcua_data_model_4.NodeClass.ReferenceType);
          (0, node_opcua_assert_1.assert)(subtypeOfNodeId);
          options1.references.push({
            isForward: false,
            nodeId: subtypeOfNodeId,
            referenceType: "HasSubtype"
          });
        }
        const node = this.internalCreateNode(options1);
        node.propagate_back_references();
        return node;
      }
      /**
       */
      addMultiStateDiscrete(options) {
        return (0, ua_multistate_discrete_impl_1._addMultiStateDiscrete)(this, options);
      }
      /**
       * @method createDataType
       */
      createDataType(options) {
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "isAbstract"), "must provide isAbstract");
        (0, node_opcua_assert_1.assert)(!Object.prototype.hasOwnProperty.call(options, "nodeClass"));
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "browseName"), "must provide a browseName");
        const options1 = options;
        options1.nodeClass = node_opcua_data_model_4.NodeClass.DataType;
        options1.references = options.references || [];
        if (options1.references.length === 0) {
          if (!options1.subtypeOf) {
            throw new Error("must provide a subtypeOf");
          }
        }
        if (options1.subtypeOf) {
          if (!(options1.subtypeOf instanceof ua_data_type_impl_1.UADataTypeImpl)) {
            options1.subtypeOf = this.addressSpace.findDataType(options1.subtypeOf);
          }
          if (!options1.subtypeOf) {
            throw new Error("cannot find subtypeOf ");
          }
          options1.references.push({
            isForward: false,
            nodeId: options1.subtypeOf.nodeId,
            referenceType: "HasSubtype"
          });
        }
        const node = this.internalCreateNode(options);
        node.propagate_back_references();
        return node;
      }
      /**
       * @method createNode
       * @param options
       * @param options.nodeClass
       * @param [options.nodeVersion {String} = "0" ] install nodeVersion
       * @param [options.modellingRule {String} = null]
       * @internal
       */
      createNode(options) {
        let node = null;
        const addressSpace = this.addressSpace;
        addressSpace.modelChangeTransaction(() => {
          (0, node_opcua_assert_1.assert)(isNonEmptyQualifiedName(options.browseName));
          (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "nodeClass"));
          options.references = addressSpace.normalizeReferenceTypes(options.references);
          const references = _copy_references(options.references);
          _handle_hierarchy_parent(addressSpace, references, options);
          _handle_event_hierarchy_parent(addressSpace, references, options);
          (0, namespace_private_1.UANamespace_process_modelling_rule)(references, options.modellingRule);
          options.references = references;
          node = this.internalCreateNode(options);
          (0, node_opcua_assert_1.assert)(node.nodeId instanceof node_opcua_nodeid_2.NodeId);
          node.propagate_back_references();
          node.install_extra_properties();
          _create_node_version_if_needed(node, options);
          (0, address_space_change_event_tools_1._handle_model_change_event)(node);
        });
        return node;
      }
      /**
       * remove the specified Node from the address space
       *
       * @method deleteNode
       * @param  nodeOrNodeId
       *
       *
       */
      deleteNode(nodeOrNodeId) {
        let node = null;
        let nodeId = new node_opcua_nodeid_2.NodeId();
        if (nodeOrNodeId instanceof node_opcua_nodeid_2.NodeId) {
          nodeId = nodeOrNodeId;
          node = this.findNode(nodeId);
          if (!node) {
            throw new Error(" deleteNode : cannot find node with nodeId" + nodeId.toString());
          }
        } else if (nodeOrNodeId instanceof base_node_impl_1.BaseNodeImpl) {
          node = nodeOrNodeId;
          nodeId = node.nodeId;
        }
        if (nodeId.namespace !== this.index) {
          throw new Error("this node doesn't belong to this namespace");
        }
        const addressSpace = this.addressSpace;
        addressSpace.modelChangeTransaction(() => {
          if (!node) {
            throw new Error("this node doesn't belong to this namespace");
          }
          const hierarchicalReferences = node.findReferencesEx("HierarchicalReferences", node_opcua_data_model_3.BrowseDirection.Inverse);
          for (const ref of hierarchicalReferences) {
            (0, node_opcua_assert_1.assert)(!ref.isForward);
            const parent = addressSpace.findNode(ref.nodeId);
            (0, node_opcua_assert_1.assert)(parent);
            parent._on_child_removed(node);
          }
          function deleteNodePointedByReference(ref) {
            const o2 = addressSpace.findNode(ref.nodeId);
            addressSpace.deleteNode(o2.nodeId);
          }
          const components = node.findReferencesEx("HasComponent", node_opcua_data_model_3.BrowseDirection.Forward);
          const properties = node.findReferencesEx("HasProperty", node_opcua_data_model_3.BrowseDirection.Forward);
          const subFolders = node.findReferencesEx("Organizes", node_opcua_data_model_3.BrowseDirection.Forward);
          for (const r of components) {
            deleteNodePointedByReference(r);
          }
          for (const r of properties) {
            deleteNodePointedByReference(r);
          }
          for (const r of subFolders) {
            deleteNodePointedByReference(r);
          }
          (0, address_space_change_event_tools_1._handle_delete_node_model_change_event)(node);
          detachNode(node);
          const namespace = addressSpace.getNamespace(node.nodeId.namespace);
          namespace._deleteNode(node);
        });
      }
      /**
       * @internals
       */
      getStandardsNodeIds() {
        const standardNodeIds = {
          objectTypeIds: {},
          referenceTypeIds: {}
        };
        for (const referenceType of this._referenceTypeMap.values()) {
          standardNodeIds.referenceTypeIds[referenceType.browseName.name] = referenceType.nodeId.toString();
        }
        for (const objectType of this._objectTypeMap.values()) {
          standardNodeIds.objectTypeIds[objectType.browseName.name] = objectType.nodeId.toString();
        }
        return standardNodeIds;
      }
      // - Events --------------------------------------------------------------------------------------
      /**
       * add a new event type to the address space
       * @method addEventType
       * @param options
       * @param options.browseName {String} the eventType name
       * @param [options.subtypeOf ="BaseEventType"]
       * @param [options.isAbstract = true]
       * @return {UAObjectType} : the object type
       *
       * @example
       *
       *      var evtType = namespace.addEventType({
       *          browseName: "MyAuditEventType",
       *          subtypeOf:  "AuditEventType"
       *      });
       *      var myConditionType = namespace.addEventType({
       *          browseName: "MyConditionType",
       *          subtypeOf:  "ConditionType",
       *          isAbstract: false
       *      });
       *
       */
      addEventType(options) {
        options.subtypeOf = options.subtypeOf || "BaseEventType";
        options.isAbstract = Object.prototype.hasOwnProperty.call(options, "isAbstract") ? !!options.isAbstract : true;
        return this.addObjectType(options);
      }
      // ---------------------------------------------------------------------------------------------------
      /**
       * @method addDataItem
       * @param options
       * @param options.browseName {String}
       * @param options.definition {String}
       * @param [options.valuePrecision {Double |null} =null]
       * @param options.dataType {NodeId} // todo :check
       * @param options.value
       * @param options.componentOf
       * @return {UAVariable}
       */
      addDataItem(options) {
        const addressSpace = this.addressSpace;
        const dataType = options.dataType || "Number";
        const dataItemType = addressSpace.findVariableType("DataItemType");
        if (!dataItemType) {
          throw new Error("Cannot find DataItemType");
        }
        const variable = this.addVariable({
          ...options,
          dataType,
          typeDefinition: dataItemType.nodeId
        });
        (0, add_dataItem_stuff_1.add_dataItem_stuff)(variable, options);
        variable.install_extra_properties();
        return variable;
      }
      /**
         *
         * @method addAnalogDataItem
         *
         * AnalogDataItem DataItems that represent continuously-variable physical quantities ( e.g., length, temperature),
         * in contrast to the digital representation of data in discrete  items
         * NOTE Typical examples are the values provided by temperature sensors or pressure sensors. OPC UA defines a
         * specific UAVariableType to identify an AnalogItem. Properties describe the possible ranges of  AnalogItems.
         *
         *
         * @example:
         *
         *
         *   namespace.add_analog_dataItem({
         *      componentOf: parentObject,
         *      browseName: "TemperatureSensor",
         *
         *      definition: "(tempA -25) + tempB",
         *      valuePrecision: 0.5,
         *      //-
         *      instrumentRange: { low: 100 , high: 200}, // optional
         *      engineeringUnitsRange: { low: 100 , high: 200}, // mandatory
         *      engineeringUnits: standardUnits.degree_celsius,, // optional
         *
         *      // access level
         *      accessLevel: 1
         *      minimumSamplingInterval: 10,
         *
         *   });
         *
      
         * @return {UAVariable}
         */
      addAnalogDataItem(options) {
        const addressSpace = this.addressSpace;
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "engineeringUnitsRange"), "expecting engineeringUnitsRange");
        const dataType = options.dataType || "Number";
        const analogItemType = addressSpace.findVariableType("AnalogItemType");
        if (!analogItemType) {
          throw new Error("expecting AnalogItemType to be defined , check nodeset xml file");
        }
        const clone_options = { ...options, dataType, typeDefinition: analogItemType.nodeId };
        const variable = this.addVariable(clone_options);
        (0, add_dataItem_stuff_1.add_dataItem_stuff)(variable, options);
        const euRange = this.addVariable({
          browseName: { name: "EURange", namespaceIndex: 0 },
          dataType: "Range",
          minimumSamplingInterval: 0,
          modellingRule: options.modellingRule,
          propertyOf: variable,
          typeDefinition: "PropertyType",
          value: new node_opcua_variant_1.Variant({
            dataType: node_opcua_variant_1.DataType.ExtensionObject,
            value: new node_opcua_types_1.Range(options.engineeringUnitsRange)
          })
        });
        (0, node_opcua_assert_1.assert)(euRange.readValue().value.value instanceof node_opcua_types_1.Range);
        const handler = variable.handle_semantic_changed.bind(variable);
        euRange.on("value_changed", handler);
        if (Object.prototype.hasOwnProperty.call(options, "instrumentRange")) {
          const instrumentRange = this.addVariable({
            accessLevel: "CurrentRead | CurrentWrite",
            browseName: { name: "InstrumentRange", namespaceIndex: 0 },
            dataType: "Range",
            minimumSamplingInterval: 0,
            modellingRule: options.modellingRule ? "Mandatory" : void 0,
            propertyOf: variable,
            typeDefinition: "PropertyType",
            value: new node_opcua_variant_1.Variant({
              dataType: node_opcua_variant_1.DataType.ExtensionObject,
              value: new node_opcua_types_1.Range(options.instrumentRange)
            })
          });
          instrumentRange.on("value_changed", handler);
        }
        variable.acceptValueOutOfRange = options.acceptValueOutOfRange;
        if (Object.prototype.hasOwnProperty.call(options, "engineeringUnits")) {
          const engineeringUnits = new node_opcua_types_1.EUInformation(options.engineeringUnits);
          (0, node_opcua_assert_1.assert)(engineeringUnits instanceof node_opcua_types_1.EUInformation, "expecting engineering units");
          const eu = this.addVariable({
            accessLevel: "CurrentRead",
            browseName: { name: "EngineeringUnits", namespaceIndex: 0 },
            dataType: "EUInformation",
            minimumSamplingInterval: 0,
            modellingRule: options.modellingRule ? "Mandatory" : void 0,
            propertyOf: variable,
            typeDefinition: "PropertyType",
            value: new node_opcua_variant_1.Variant({
              dataType: node_opcua_variant_1.DataType.ExtensionObject,
              value: engineeringUnits
            })
          });
          eu.on("value_changed", handler);
        }
        variable.install_extra_properties();
        return variable;
      }
      /**
       *
       * @method addMultiStateValueDiscrete
       * @param options {Object}
       * @param options.browseName {String}
       * @param [options.nodeId  {NodeId}]
       * @param [options.value {UInt32} = 0 }
       * @param options.enumValues { EnumValueType[]| {Key,Value} }
       * @return {Object|UAVariable}
       *
       * @example
       *
       *
       *      namespace.addMultiStateValueDiscrete({
       *          componentOf:parentObj,
       *          browseName: "myVar",
       *          enumValues: {
       *              "Red":    0xFF0000,
       *              "Green":  0x00FF00,
       *              "Blue":   0x0000FF
       *          }
       *      });
       *      addMultiStateValueDiscrete(parentObj,{
       *          browseName: "myVar",
       *          enumValues: [
       *              {
       *                 value: 0xFF0000,
       *                 displayName: "Red",
       *                 description: " The color Red"
       *              },
       *              {
       *                 value: 0x00FF000,
       *                 displayName: "Green",
       *                 description: " The color Green"
       *              },
       *              {
       *                 value: 0x0000FF,
       *                 displayName: "Blue",
       *                 description: " The color Blue"
       *              }
       *
       *          ]
       *      });
       */
      addMultiStateValueDiscrete(options) {
        return (0, ua_multistate_value_discrete_impl_1._addMultiStateValueDiscrete)(this, options);
      }
      // -
      /**
       *
       * @method addYArrayItem
       * @param options
       * @param options.componentOf {NodeId}
       * @param options.browseName {String}
       * @param options.title {String}
       * @param [options.instrumentRange]
       * @param [options.instrumentRange.low] {Double}
       * @param [options.instrumentRange.high] {Double}
       * @param options.engineeringUnitsRange.low {Double}
       * @param options.engineeringUnitsRange.high {Double}
       * @param options.engineeringUnits {String}
       * @param [options.nodeId = {NodeId}]
       * @param options.accessLevel
       * @param options.userAccessLevel
       * @param options.title {String}
       * @param options.axisScaleType {AxisScaleEnumeration}
       *
       * @param options.xAxisDefinition {AxisInformation}
       * @param options.xAxisDefinition.engineeringUnits  EURange
       * @param options.xAxisDefinition.range
       * @param options.xAxisDefinition.range.low
       * @param options.xAxisDefinition.range.high
       * @param options.xAxisDefinition.title  {LocalizedText}
       * @param options.xAxisDefinition.axisScaleType {AxisScaleEnumeration}
       * @param options.xAxisDefinition.axisSteps = <null>  {Array<Double>}
       * @param options.value
       */
      addYArrayItem(options) {
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "engineeringUnitsRange"), "expecting engineeringUnitsRange");
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "axisScaleType"), "expecting axisScaleType");
        (0, node_opcua_assert_1.assert)(options.xAxisDefinition !== null && typeof options.xAxisDefinition === "object", "expecting a xAxisDefinition");
        const addressSpace = this.addressSpace;
        const YArrayItemType = addressSpace.findVariableType("YArrayItemType");
        if (!YArrayItemType) {
          throw new Error("expecting YArrayItemType to be defined , check nodeset xml file");
        }
        function toNodeId(options2) {
          if (!options2) {
            return (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_variant_1.DataType.Float);
          }
          if (Object.prototype.hasOwnProperty.call(options2, "nodeId") || options2 instanceof base_node_impl_1.BaseNodeImpl) {
            return options2.nodeId;
          }
          return (0, node_opcua_nodeid_1.resolveNodeId)(options2);
        }
        const dataType = toNodeId(options.dataType);
        const optionals = [];
        if (Object.prototype.hasOwnProperty.call(options, "instrumentRange")) {
          optionals.push("InstrumentRange");
        }
        const variable = YArrayItemType.instantiate({
          browseName: options.browseName,
          componentOf: options.componentOf,
          dataType,
          optionals
        });
        function coerceAxisScale(value) {
          const ret = node_opcua_data_access_1.AxisScaleEnumeration[value];
          (0, node_opcua_assert_1.assert)(!(0, node_opcua_utils_1.isNullOrUndefined)(ret));
          return ret;
        }
        variable.setValueFromSource(options.value, node_opcua_status_code_1.StatusCodes.Good);
        variable.euRange.setValueFromSource(new node_opcua_variant_1.Variant({
          dataType: node_opcua_variant_1.DataType.ExtensionObject,
          value: new node_opcua_types_1.Range(options.engineeringUnitsRange)
        }));
        if (Object.prototype.hasOwnProperty.call(options, "instrumentRange") && variable.instrumentRange) {
          variable.instrumentRange.setValueFromSource(new node_opcua_variant_1.Variant({
            dataType: node_opcua_variant_1.DataType.ExtensionObject,
            value: new node_opcua_types_1.Range(options.instrumentRange)
          }));
        }
        variable.title.setValueFromSource(new node_opcua_variant_1.Variant({
          dataType: node_opcua_variant_1.DataType.LocalizedText,
          value: (0, node_opcua_data_model_1.coerceLocalizedText)(options.title || "")
        }));
        variable.axisScaleType.setValueFromSource(new node_opcua_variant_1.Variant({
          dataType: node_opcua_variant_1.DataType.Int32,
          value: coerceAxisScale(options.axisScaleType)
        }));
        variable.xAxisDefinition.setValueFromSource(new node_opcua_variant_1.Variant({
          dataType: node_opcua_variant_1.DataType.ExtensionObject,
          value: new node_opcua_types_1.AxisInformation(options.xAxisDefinition)
        }));
        return variable;
      }
      // - Methods ----------------------------------------------------------------------------------------------------
      /**
       * @method addMethod
       * @param parentObject {Object}
       * @param options {Object}
       * @param [options.nodeId=null] {NodeId} the object nodeid.
       * @param [options.browseName=""] {String} the object browse name.
       * @param [options.description=""] {String} the object description.
       * @param options.inputArguments  {Array<Argument>}
       * @param options.outputArguments {Array<Argument>}
       * @return {Object}
       */
      addMethod(parentObject, options) {
        const addressSpace = this.addressSpace;
        (0, node_opcua_assert_1.assert)(parentObject !== null && typeof parentObject === "object" && parentObject instanceof base_node_impl_1.BaseNodeImpl, "expecting a valid parent object");
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "browseName"));
        options.componentOf = parentObject;
        const method = this._addMethod(options);
        const propertyTypeId = addressSpace._coerce_VariableTypeIds("PropertyType");
        const nodeId_ArgumentDataType = "Argument";
        if (options.inputArguments) {
          const _inputArgs = new node_opcua_variant_1.Variant({
            arrayType: node_opcua_variant_1.VariantArrayType.Array,
            dataType: node_opcua_variant_1.DataType.ExtensionObject,
            value: options.inputArguments.map((opt) => new node_opcua_types_1.Argument(opt))
          });
          const inputArguments = this.addVariable({
            accessLevel: "CurrentRead",
            arrayDimensions: [_inputArgs.value.length],
            browseName: { name: "InputArguments", namespaceIndex: 0 },
            dataType: nodeId_ArgumentDataType,
            description: "the definition of the input argument of method " + parentObject.browseName.toString() + "." + method.browseName.toString(),
            minimumSamplingInterval: -1,
            modellingRule: "Mandatory",
            propertyOf: method,
            typeDefinition: "PropertyType",
            value: _inputArgs,
            valueRank: 1
          });
          inputArguments.setValueFromSource(_inputArgs);
          (0, node_opcua_assert_1.assert)(inputArguments.typeDefinition.toString() === propertyTypeId.toString());
          (0, node_opcua_assert_1.assert)(Array.isArray(inputArguments.arrayDimensions));
        }
        if (options.outputArguments) {
          const _outputArgs = new node_opcua_variant_1.Variant({
            arrayType: node_opcua_variant_1.VariantArrayType.Array,
            dataType: node_opcua_variant_1.DataType.ExtensionObject,
            value: options.outputArguments.map((opts) => new node_opcua_types_1.Argument(opts))
          });
          const outputArguments = this.addVariable({
            accessLevel: "CurrentRead",
            arrayDimensions: [_outputArgs.value.length],
            browseName: { name: "OutputArguments", namespaceIndex: 0 },
            dataType: nodeId_ArgumentDataType,
            description: "the definition of the output arguments of method " + parentObject.browseName.toString() + "." + method.browseName.toString(),
            minimumSamplingInterval: -1,
            modellingRule: "Mandatory",
            propertyOf: method,
            typeDefinition: "PropertyType",
            value: _outputArgs,
            valueRank: 1
          });
          outputArguments.setValueFromSource(_outputArgs);
          (0, node_opcua_assert_1.assert)(outputArguments.typeDefinition.toString() === propertyTypeId.toString());
          (0, node_opcua_assert_1.assert)(Array.isArray(outputArguments.arrayDimensions));
        }
        parentObject.install_extra_properties();
        return method;
      }
      // - Enumeration ------------------------------------------------------------------------------------------------
      /**
       *
       * @method addEnumerationType
       * @param options
       * @param options.browseName  {String}
       * @param options.enumeration {Array}
       * @param options.enumeration[].displayName {String|LocalizedText}
       * @param options.enumeration[].value       {Number}
       * @param options.enumeration[].description {String|LocalizedText|null}
       */
      addEnumerationType(options) {
        (0, node_opcua_assert_1.assert)(typeof options.browseName === "string");
        (0, node_opcua_assert_1.assert)(Array.isArray(options.enumeration));
        const addressSpace = this.addressSpace;
        let definition;
        const enumerationType = addressSpace.findDataType("Enumeration");
        (0, node_opcua_assert_1.assert)(enumerationType.nodeId instanceof node_opcua_nodeid_2.NodeId);
        (0, node_opcua_assert_1.assert)(enumerationType instanceof ua_data_type_impl_1.UADataTypeImpl);
        const references = [{ referenceType: "HasSubtype", isForward: false, nodeId: enumerationType.nodeId }];
        const opts = {
          browseName: options.browseName,
          definition,
          description: (0, node_opcua_data_model_1.coerceLocalizedText)(options.description) || null,
          displayName: options.displayName || null,
          isAbstract: false,
          nodeClass: node_opcua_data_model_4.NodeClass.DataType,
          references
        };
        const enumType = this.internalCreateNode(opts);
        enumType.propagate_back_references();
        if (typeof options.enumeration[0] === "string") {
          const enumeration = options.enumeration;
          definition = enumeration.map((str, index) => (0, node_opcua_data_model_1.coerceLocalizedText)(str));
          const value = new node_opcua_variant_1.Variant({
            arrayType: node_opcua_variant_1.VariantArrayType.Array,
            dataType: node_opcua_variant_1.DataType.LocalizedText,
            value: definition
          });
          const enumStrings = this.addVariable({
            browseName: { name: "EnumStrings", namespaceIndex: 0 },
            dataType: "LocalizedText",
            description: "",
            modellingRule: "Mandatory",
            propertyOf: enumType,
            value,
            valueRank: 1
          });
          (0, node_opcua_assert_1.assert)(enumStrings.browseName.toString() === "EnumStrings");
          enumType.$fullDefinition = new node_opcua_types_1.EnumDefinition({
            fields: enumeration.map((x2, index) => new node_opcua_types_1.EnumField({
              name: x2,
              description: (0, node_opcua_data_model_1.coerceLocalizedText)(x2),
              value: (0, node_opcua_basic_types_1.coerceInt64)(index)
            }))
          });
        } else {
          const enumeration = options.enumeration;
          definition = enumeration.map((enumItem) => {
            return new node_opcua_types_1.EnumValueType({
              description: (0, node_opcua_data_model_1.coerceLocalizedText)(enumItem.description),
              displayName: (0, node_opcua_data_model_1.coerceLocalizedText)(enumItem.displayName),
              value: (0, node_opcua_basic_types_1.coerceInt64)(enumItem.value)
            });
          });
          const value = new node_opcua_variant_1.Variant({
            arrayType: node_opcua_variant_1.VariantArrayType.Array,
            dataType: node_opcua_variant_1.DataType.ExtensionObject,
            value: definition
          });
          const enumValues = this.addVariable({
            browseName: { name: "EnumValues", namespaceIndex: 0 },
            dataType: "EnumValueType",
            description: void 0,
            modellingRule: "Mandatory",
            propertyOf: enumType,
            value,
            valueRank: 1
          });
          (0, node_opcua_assert_1.assert)(enumValues.browseName.toString() === "EnumValues");
          enumType.$fullDefinition = new node_opcua_types_1.EnumDefinition({
            fields: enumeration.map((x2, index) => new node_opcua_types_1.EnumField({
              name: x2.displayName.toString(),
              description: x2.description || "",
              value: (0, node_opcua_basic_types_1.coerceInt64)(x2.value)
            }))
          });
        }
        return enumType;
      }
      // -------------------------------------------------------------------------
      // State and Transition
      // -------------------------------------------------------------------------
      toNodeset2XML() {
        return "<toNodeset2XML>has not be installed</toNodeset2XML>!";
      }
      setRequiredModels(requiredModels) {
        this._requiredModels = requiredModels;
      }
      getRequiredModels() {
        return this._requiredModels;
      }
      // -------------------------------------------------------------------------
      // State and Transition
      // -------------------------------------------------------------------------
      /**
       * @class IAddressSpace
       * @method addState
       * @param component
       * @param stateName   {string}
       * @param stateNumber {number}
       * @param isInitialState {boolean}
       * @return {UAObject} {StateType|InitialStateType}
       */
      addState(component, stateName, stateNumber, isInitialState) {
        const addressSpace = this.addressSpace;
        isInitialState = !!isInitialState;
        const _component = component;
        (0, node_opcua_assert_1.assert)(_component.nodeClass === node_opcua_data_model_4.NodeClass.Object || _component.nodeClass === node_opcua_data_model_4.NodeClass.ObjectType);
        const initialStateType = addressSpace.findObjectType("InitialStateType");
        const stateType = addressSpace.findObjectType("StateType");
        let state;
        if (isInitialState) {
          state = initialStateType.instantiate({
            browseName: stateName,
            componentOf: _component
          });
        } else {
          state = stateType.instantiate({
            browseName: stateName,
            componentOf: _component
          });
        }
        state.stateNumber.setValueFromSource({
          dataType: node_opcua_variant_1.DataType.UInt32,
          value: stateNumber
        });
        return state;
      }
      /**
       */
      addTransition(component, fromState, toState, transitionNumber, browseName) {
        const addressSpace = this.addressSpace;
        const _component = component;
        (0, node_opcua_assert_1.assert)(_component.nodeClass === node_opcua_data_model_4.NodeClass.Object || _component.nodeClass === node_opcua_data_model_4.NodeClass.ObjectType);
        (0, node_opcua_assert_1.assert)(typeof fromState === "string");
        (0, node_opcua_assert_1.assert)(typeof toState === "string");
        (0, node_opcua_assert_1.assert)(isFinite(transitionNumber));
        const fromStateNode = _component.getComponentByName(fromState);
        if (!fromStateNode) {
          throw new Error("Cannot find state with name " + fromState);
        }
        (0, node_opcua_assert_1.assert)(fromStateNode.browseName.name.toString() === fromState);
        const toStateNode = _component.getComponentByName(toState);
        if (!toStateNode) {
          throw new Error("Cannot find state with name " + toState);
        }
        (0, node_opcua_assert_1.assert)(toStateNode.browseName.name.toString() === toState);
        const transitionType = addressSpace.findObjectType("TransitionType");
        if (!transitionType) {
          throw new Error("Cannot find TransitionType");
        }
        browseName = browseName || fromState + "To" + toState;
        const transition = transitionType.instantiate({
          browseName,
          componentOf: _component
        });
        transition.addReference({
          isForward: true,
          nodeId: toStateNode.nodeId,
          referenceType: "ToState"
        });
        transition.addReference({
          isForward: true,
          nodeId: fromStateNode.nodeId,
          referenceType: "FromState"
        });
        transition.transitionNumber.setValueFromSource({
          dataType: node_opcua_variant_1.DataType.UInt32,
          value: transitionNumber
        });
        return transition;
      }
      /**
       * @method addTwoStateVariable
       *
       * @return {UATwoStateVariable}
       */
      addTwoStateVariable(options) {
        return (0, ua_two_state_variable_1._addTwoStateVariable)(this, options);
      }
      /**
       * @method addTwoStateDiscrete
       *
       * Add a TwoStateDiscrete Variable
       * @return {UATwoStateDiscrete}
       */
      addTwoStateDiscrete(options) {
        return (0, ua_two_state_discrete_impl_1._addTwoStateDiscrete)(this, options);
      }
      // --- Alarms & Conditions -------------------------------------------------
      instantiateCondition(conditionTypeId, options, data) {
        return ua_condition_impl_1.UAConditionImpl.instantiate(this, conditionTypeId, options, data);
      }
      instantiateAcknowledgeableCondition(conditionTypeId, options, data) {
        return alarms_and_conditions_1.UAAcknowledgeableConditionImpl.instantiate(this, conditionTypeId, options, data);
      }
      instantiateAlarmCondition(alarmConditionTypeId, options, data) {
        return alarms_and_conditions_1.UAAlarmConditionImpl.instantiate(this, alarmConditionTypeId, options, data);
      }
      instantiateLimitAlarm(limitAlarmTypeId, options, data) {
        return ua_limit_alarm_impl_1.UALimitAlarmImpl.instantiate(this, limitAlarmTypeId, options, data);
      }
      instantiateExclusiveLimitAlarm(exclusiveLimitAlarmTypeId, options, data) {
        return ua_exclusive_limit_alarm_impl_1.UAExclusiveLimitAlarmImpl.instantiate(this, exclusiveLimitAlarmTypeId, options, data);
      }
      instantiateExclusiveDeviationAlarm(options, data) {
        return ua_exclusive_deviation_alarm_impl_1.UAExclusiveDeviationAlarmImpl.instantiate(this, "ExclusiveDeviationAlarmType", options, data);
      }
      instantiateNonExclusiveLimitAlarm(nonExclusiveLimitAlarmTypeId, options, data) {
        return ua_non_exclusive_limit_alarm_impl_1.UANonExclusiveLimitAlarmImpl.instantiate(this, nonExclusiveLimitAlarmTypeId, options, data);
      }
      instantiateNonExclusiveDeviationAlarm(options, data) {
        return ua_non_exclusive_deviation_alarm_impl_1.UANonExclusiveDeviationAlarmImpl.instantiate(this, "NonExclusiveDeviationAlarmType", options, data);
      }
      instantiateDiscreteAlarm(discreteAlarmType, options, data) {
        return ua_discrete_alarm_impl_1.UADiscreteAlarmImpl.instantiate(this, discreteAlarmType, options, data);
      }
      instantiateOffNormalAlarm(options, data) {
        return ua_off_normal_alarm_impl_1.UAOffNormalAlarmImpl.instantiate(this, "OffNormalAlarmType", options, data);
      }
      // default roles and permissions
      setDefaultRolePermissions(rolePermissions) {
        this.defaultRolePermissions = rolePermissions ? (0, role_permissions_1.coerceRolePermissions)(rolePermissions) : void 0;
      }
      getDefaultRolePermissions() {
        return this.defaultRolePermissions || null;
      }
      setDefaultAccessRestrictions(accessRestrictions) {
        this.defaultAccessRestrictions = accessRestrictions;
      }
      getDefaultAccessRestrictions() {
        return this.defaultAccessRestrictions || node_opcua_data_model_1.AccessRestrictionsFlag.None;
      }
      // --- internal stuff
      constructNodeId(options) {
        return this._nodeIdManager.constructNodeId({
          registerSymbolicNames: this.registerSymbolicNames,
          ...options
        });
      }
      _register(node) {
        (0, node_opcua_assert_1.assert)(node instanceof base_node_impl_1.BaseNodeImpl, "Expecting a instance of BaseNode in _register");
        (0, node_opcua_assert_1.assert)(node.nodeId instanceof node_opcua_nodeid_2.NodeId, "Expecting a NodeId");
        if (node.nodeId.namespace !== this.index) {
          throw new Error("node must belongs to this namespace");
        }
        (0, node_opcua_assert_1.assert)(node.nodeId.namespace === this.index, "node must belongs to this namespace");
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(node, "browseName"), "Node must have a browseName");
        const hashKey = _makeHashKey(node.nodeId);
        if (this._nodeid_index.has(hashKey)) {
          const existingNode = this.findNode(node.nodeId);
          throw new Error("node " + node.browseName.toString() + " nodeId = " + node.nodeId.displayText() + " already registered " + node.nodeId.toString() + "\n in namespace " + this.namespaceUri + " index = " + this.index + "\nexisting node = " + existingNode.toString() + "this parent : " + node.parentNodeId?.toString());
        }
        this._nodeid_index.set(hashKey, node);
        switch (node.nodeClass) {
          case node_opcua_data_model_4.NodeClass.ObjectType:
            this._registerObjectType(node);
            break;
          case node_opcua_data_model_4.NodeClass.VariableType:
            this._registerVariableType(node);
            break;
          case node_opcua_data_model_4.NodeClass.ReferenceType:
            this._registerReferenceType(node);
            break;
          case node_opcua_data_model_4.NodeClass.DataType:
            this._registerDataType(node);
            break;
          case node_opcua_data_model_4.NodeClass.Object:
          case node_opcua_data_model_4.NodeClass.Variable:
          case node_opcua_data_model_4.NodeClass.Method:
          case node_opcua_data_model_4.NodeClass.View:
            break;
          default:
            errorLog("Invalid class Name", node.nodeClass);
            throw new Error("Invalid class name specified");
        }
      }
      /**
       * @method internalCreateNode
       * @internal
       */
      internalCreateNode(options) {
        (0, node_opcua_assert_1.assert)(options.nodeClass !== void 0, " options.nodeClass must be specified");
        (0, node_opcua_assert_1.assert)(options.browseName, "options.browseName must be specified");
        options.description = (0, node_opcua_data_model_1.coerceLocalizedText)(options.description);
        if (typeof options.browseName === "string") {
          const match = options.browseName.match(regExpNamespaceDotBrowseName);
          if (match) {
            const correctedName = match[1];
            warningLog(chalk_1.default.green("Warning : since node-opcua 0.4.2 namespace index should not be prepended to the browse name anymore"));
            warningLog("   ", options.browseName, " will be replaced with ", correctedName);
            warningLog(" Please update your code");
            const indexVerify = parseInt(match[0], 10);
            if (indexVerify !== this.index) {
              errorLog(chalk_1.default.red.bold("Error: namespace index used at the front of the browseName " + indexVerify + " do not match the index of the current namespace (" + this.index + ")"));
              errorLog(" Please fix your code so that the created node is inserted in the correct namespace, please refer to the NodeOPCUA documentation");
            }
          }
          options.browseName = new node_opcua_data_model_2.QualifiedName({ name: options.browseName, namespaceIndex: this.index });
        } else if (!(options.browseName instanceof node_opcua_data_model_2.QualifiedName)) {
          options.browseName = new node_opcua_data_model_2.QualifiedName(options.browseName);
        }
        (0, node_opcua_assert_1.assert)(options.browseName instanceof node_opcua_data_model_2.QualifiedName, "Expecting options.browseName to be instanceof  QualifiedName ");
        if (!options.displayName) {
          (0, node_opcua_assert_1.assert)(typeof options.browseName.name === "string");
          options.displayName = options.browseName.name;
        }
        options.nodeId = this.constructNodeId(options);
        (0, node_opcua_debug_1.dumpIf)(!options.nodeId, options);
        (0, node_opcua_assert_1.assert)(options.nodeId instanceof node_opcua_nodeid_2.NodeId);
        const Constructor = _constructors_map[node_opcua_data_model_4.NodeClass[options.nodeClass]];
        if (!Constructor) {
          throw new Error(" missing constructor for NodeClass " + node_opcua_data_model_4.NodeClass[options.nodeClass]);
        }
        options.addressSpace = this.addressSpace;
        const node = new Constructor(options);
        this._register(node);
        if (doDebug) {
          (0, node_opcua_assert_1.assert)(this.findNode(node.nodeId) !== null && typeof this.findNode(node.nodeId) === "object");
        }
        return node;
      }
      _deleteNode(node) {
        (0, node_opcua_assert_1.assert)(node instanceof base_node_impl_1.BaseNodeImpl);
        const hashKey = _makeHashKey(node.nodeId);
        if (!this._nodeid_index.has(hashKey)) {
          throw new Error("deleteNode : nodeId " + node.nodeId.displayText() + " is not registered " + node.nodeId.toString());
        }
        switch (node.nodeClass) {
          case node_opcua_data_model_4.NodeClass.ObjectType:
            this._unregisterObjectType(node);
            break;
          case node_opcua_data_model_4.NodeClass.VariableType:
            this._unregisterVariableType(node);
            break;
          case node_opcua_data_model_4.NodeClass.Object:
          case node_opcua_data_model_4.NodeClass.Variable:
          case node_opcua_data_model_4.NodeClass.Method:
          case node_opcua_data_model_4.NodeClass.View:
            break;
          default:
            warningLog("Invalid class Name", node.nodeClass);
            throw new Error("Invalid class name specified");
        }
        const deleted = this._nodeid_index.delete(hashKey);
        (0, node_opcua_assert_1.assert)(deleted);
        node.dispose();
      }
      // --- Private stuff
      _addObjectOrVariableType(options1, topMostBaseType, nodeClass) {
        const addressSpace = this.addressSpace;
        (0, node_opcua_assert_1.assert)(typeof topMostBaseType === "string");
        (0, node_opcua_assert_1.assert)(nodeClass === node_opcua_data_model_4.NodeClass.ObjectType || nodeClass === node_opcua_data_model_4.NodeClass.VariableType);
        const options = options1;
        (0, node_opcua_assert_1.assert)(!options.nodeClass);
        (0, node_opcua_assert_1.assert)(options.browseName);
        (0, node_opcua_assert_1.assert)(typeof options.browseName === "string");
        if (Object.prototype.hasOwnProperty.call(options, "references")) {
          throw new Error("options.references should not be provided, use options.subtypeOf instead");
        }
        const references = [];
        function process_subtypeOf_options(options2, references1) {
          (0, node_opcua_assert_1.assert)(!options2.subTypeOf, "misspell error : it should be 'subtypeOf' instead");
          if (Object.prototype.hasOwnProperty.call(options2, "hasTypeDefinition")) {
            throw new Error("hasTypeDefinition option is invalid. Do you mean typeDefinition instead ?");
          }
          (0, node_opcua_assert_1.assert)(!options2.typeDefinition, " do you mean subtypeOf ?");
          const subtypeOfNodeId = addressSpace._coerceType(options2.subtypeOf, topMostBaseType, nodeClass);
          (0, node_opcua_assert_1.assert)(subtypeOfNodeId);
          references1.push({
            isForward: false,
            nodeId: subtypeOfNodeId,
            referenceType: "HasSubtype"
          });
        }
        process_subtypeOf_options.call(this, options, references);
        const objectType = this.internalCreateNode({
          browseName: options.browseName,
          displayName: options.displayName,
          description: options.description,
          eventNotifier: +options.eventNotifier,
          isAbstract: !!options.isAbstract,
          nodeClass,
          nodeId: options.nodeId,
          references
        });
        objectType.propagate_back_references();
        objectType.install_extra_properties();
        objectType.installPostInstallFunc(options.postInstantiateFunc);
        return objectType;
      }
      // private  _adjust_options(options: any) {
      //     const ns = this.addressSpace.getNamespaceIndex(this.namespaceUri);
      //     if (!options.nodeId) {
      //         const id = this._getNextAvailableId();
      //         options.nodeId = new NodeId(NodeId.NodeIdType.NUMERIC, id, ns);
      //     }
      //     options.nodeId = NodeId.coerce(options.nodeId);
      //     if (typeof options.browseName === "string") {
      //         options.browseName = new QualifiedName({
      //             name: options.browseName,
      //             namespaceIndex: ns
      //         });
      //     }
      //     return options;
      // }
      _registerObjectType(node) {
        (0, node_opcua_assert_1.assert)(this.index === node.nodeId.namespace);
        const key = node.browseName.name;
        if (this._objectTypeMap.has(key)) {
          throw new Error(" UAObjectType already declared " + node.browseName.toString() + "  " + node.nodeId.toString());
        }
        this._objectTypeMap.set(key, node);
      }
      _registerVariableType(node) {
        (0, node_opcua_assert_1.assert)(this.index === node.nodeId.namespace);
        const key = node.browseName.name;
        (0, node_opcua_assert_1.assert)(!this._variableTypeMap.has(key), " UAVariableType already declared");
        this._variableTypeMap.set(key, node);
      }
      _registerReferenceType(node) {
        (0, node_opcua_assert_1.assert)(this.index === node.nodeId.namespace);
        (0, node_opcua_assert_1.assert)(node.browseName instanceof node_opcua_data_model_2.QualifiedName);
        const key = node.browseName.name;
        this._referenceTypeMap.set(key, node);
        this._referenceTypeMapInv.set(node.inverseName.text, node);
      }
      _registerDataType(node) {
        (0, node_opcua_assert_1.assert)(this.index === node.nodeId.namespace);
        const key = node.browseName.name;
        (0, node_opcua_assert_1.assert)(node.browseName instanceof node_opcua_data_model_2.QualifiedName);
        (0, node_opcua_assert_1.assert)(!this._dataTypeMap.has(key), " DataType already declared");
        this._dataTypeMap.set(key, node);
      }
      _unregisterObjectType(node) {
        const key = node.browseName.name;
        this._objectTypeMap.delete(key);
      }
      _unregisterVariableType(node) {
        const key = node.browseName.name;
        this._variableTypeMap.delete(key);
      }
      /**
       * @private
       */
      _addVariable(options) {
        const addressSpace = this.addressSpace;
        const baseDataVariableType = addressSpace.findVariableType("BaseDataVariableType");
        if (!baseDataVariableType) {
          throw new Error("cannot find BaseDataVariableType");
        }
        const baseDataVariableTypeId = baseDataVariableType.nodeId;
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "browseName"), "options.browseName must be provided");
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "dataType"), "options.dataType must be provided");
        options.historizing = !!options.historizing;
        if (Object.prototype.hasOwnProperty.call(options, "hasTypeDefinition")) {
          throw new Error("hasTypeDefinition option is invalid. Do you mean typeDefinition instead ?");
        }
        let typeDefinition = options.typeDefinition || baseDataVariableTypeId;
        if (typeDefinition instanceof base_node_impl_1.BaseNodeImpl) {
          if (typeDefinition.nodeClass !== node_opcua_data_model_4.NodeClass.VariableType) {
            const message = `invalid typeDefinition expecting a VariableType got ${node_opcua_data_model_4.NodeClass[typeDefinition.nodeClass]}`;
            errorLog(message);
            throw new Error(message);
          }
        }
        typeDefinition = addressSpace._coerce_VariableTypeIds(typeDefinition);
        (0, node_opcua_assert_1.assert)(typeDefinition instanceof node_opcua_nodeid_2.NodeId);
        options.dataType = addressSpace._coerce_DataType(options.dataType);
        options.valueRank = (0, node_opcua_utils_1.isNullOrUndefined)(options.valueRank) ? options.arrayDimensions ? options.arrayDimensions.length : -1 : options.valueRank;
        (0, node_opcua_assert_1.assert)(typeof options.valueRank === "number" && isFinite(options.valueRank));
        options.arrayDimensions = options.arrayDimensions || null;
        (0, node_opcua_assert_1.assert)(Array.isArray(options.arrayDimensions) || options.arrayDimensions === null);
        const hasGetter = (options2) => {
          return typeof options2.value?.get === "function" || typeof options2.value?.timestamped_get === "function";
        };
        if (options.minimumSamplingInterval === void 0 && hasGetter(options)) {
          warningLog("[NODE-OPCUA-W30", "namespace#addVariable a getter has been specified and minimumSamplingInterval is missing.\nMinimumSamplingInterval has been adjusted to 1000 ms\nvariable = " + options?.browseName?.toString());
          options.minimumSamplingInterval = 1e3;
        }
        options.minimumSamplingInterval = options.minimumSamplingInterval !== void 0 ? +options.minimumSamplingInterval : 0;
        if (options.minimumSamplingInterval === 0 && hasGetter(options)) {
          warningLog("[NODE-OPCUA-W31", "namespace#addVariable a getter has been specified and minimumSamplingInterval is 0.\nThis may conduct to an unpredictable behavior.\nPlease specify a non zero minimum sampling interval");
        }
        let references = options.references || [];
        references = [].concat(references, [
          {
            isForward: true,
            nodeId: typeDefinition,
            referenceType: "HasTypeDefinition"
          }
        ]);
        (0, node_opcua_assert_1.assert)(!options.nodeClass || options.nodeClass === node_opcua_data_model_4.NodeClass.Variable);
        options.nodeClass = node_opcua_data_model_4.NodeClass.Variable;
        options.references = references;
        const variable = this.createNode(options);
        return variable;
      }
      /**
       * @private
       */
      _addMethod(options) {
        const addressSpace = this.addressSpace;
        (0, node_opcua_assert_1.assert)(isNonEmptyQualifiedName(options.browseName));
        const references = [];
        (0, node_opcua_assert_1.assert)(isNonEmptyQualifiedName(options.browseName));
        _handle_hierarchy_parent(addressSpace, references, options);
        (0, namespace_private_1.UANamespace_process_modelling_rule)(references, options.modellingRule);
        const method = this.internalCreateNode({
          browseName: options.browseName,
          description: options.description || "",
          displayName: options.displayName,
          eventNotifier: +options.eventNotifier,
          isAbstract: false,
          nodeClass: node_opcua_data_model_4.NodeClass.Method,
          nodeId: options.nodeId,
          references,
          rolePermissions: options.rolePermissions
        });
        (0, node_opcua_assert_1.assert)(method.nodeId !== null);
        method.propagate_back_references();
        (0, node_opcua_assert_1.assert)(!method.typeDefinition);
        return method;
      }
    };
    exports2.NamespaceImpl = NamespaceImpl;
    NamespaceImpl._handle_hierarchy_parent = _handle_hierarchy_parent;
    NamespaceImpl.isNonEmptyQualifiedName = isNonEmptyQualifiedName;
    var _constructors_map = {
      DataType: ua_data_type_impl_1.UADataTypeImpl,
      Method: ua_method_impl_1.UAMethodImpl,
      Object: ua_object_impl_1.UAObjectImpl,
      ObjectType: ua_object_type_impl_1.UAObjectTypeImpl,
      ReferenceType: ua_reference_type_impl_1.UAReferenceTypeImpl,
      Variable: ua_variable_impl_1.UAVariableImpl,
      VariableType: ua_variable_type_impl_1.UAVariableTypeImpl,
      View: ua_view_impl_1.UAViewImpl
    };
    function _coerce_parent(addressSpace, value, coerceFunc) {
      (0, node_opcua_assert_1.assert)(typeof coerceFunc === "function");
      if (value) {
        if (typeof value === "string") {
          value = coerceFunc.call(addressSpace, value);
        }
        if (value instanceof node_opcua_nodeid_2.NodeId) {
          value = addressSpace.findNode(value);
        }
      }
      (0, node_opcua_assert_1.assert)(!value || value instanceof base_node_impl_1.BaseNodeImpl);
      return value;
    }
    function _handle_event_hierarchy_parent(addressSpace, references, options) {
      options.eventSourceOf = _coerce_parent(addressSpace, options.eventSourceOf, addressSpace._coerceNode);
      options.notifierOf = _coerce_parent(addressSpace, options.notifierOf, addressSpace._coerceNode);
      if (options.eventSourceOf) {
        (0, node_opcua_assert_1.assert)(!options.notifierOf, "notifierOf shall not be provided with eventSourceOf ");
        references.push({
          isForward: false,
          nodeId: options.eventSourceOf.nodeId,
          referenceType: "HasEventSource"
        });
        options.eventNotifier = options.eventNotifier || 1;
      } else if (options.notifierOf) {
        (0, node_opcua_assert_1.assert)(!options.eventSourceOf, "eventSourceOf shall not be provided with notifierOf ");
        references.push({
          isForward: false,
          nodeId: options.notifierOf.nodeId,
          referenceType: "HasNotifier"
        });
      }
    }
    function _handle_hierarchy_parent(addressSpace, references, options) {
      options.componentOf = _coerce_parent(addressSpace, options.componentOf, addressSpace._coerceNode);
      options.propertyOf = _coerce_parent(addressSpace, options.propertyOf, addressSpace._coerceNode);
      options.organizedBy = _coerce_parent(addressSpace, options.organizedBy, addressSpace._coerceFolder);
      options.encodingOf = _coerce_parent(addressSpace, options.encodingOf, addressSpace._coerceNode);
      if (options.componentOf) {
        (0, node_opcua_assert_1.assert)(!options.propertyOf);
        (0, node_opcua_assert_1.assert)(!options.organizedBy);
        (0, node_opcua_assert_1.assert)(addressSpace.rootFolder.objects, "addressSpace must have a rootFolder.objects folder");
        (0, node_opcua_assert_1.assert)(options.componentOf.nodeId !== addressSpace.rootFolder.objects.nodeId, "Only Organizes References are used to relate Objects to the 'Objects' standard Object.");
        references.push({
          isForward: false,
          nodeId: options.componentOf.nodeId,
          referenceType: "HasComponent"
        });
      }
      if (options.propertyOf) {
        (0, node_opcua_assert_1.assert)(!options.componentOf);
        (0, node_opcua_assert_1.assert)(!options.organizedBy);
        (0, node_opcua_assert_1.assert)(options.propertyOf.nodeId !== addressSpace.rootFolder.objects.nodeId, "Only Organizes References are used to relate Objects to the 'Objects' standard Object.");
        references.push({
          isForward: false,
          nodeId: options.propertyOf.nodeId,
          referenceType: "HasProperty"
        });
      }
      if (options.organizedBy) {
        (0, node_opcua_assert_1.assert)(!options.propertyOf);
        (0, node_opcua_assert_1.assert)(!options.componentOf);
        references.push({
          isForward: false,
          nodeId: options.organizedBy.nodeId,
          referenceType: "Organizes"
        });
      }
      if (options.encodingOf) {
        (0, node_opcua_assert_1.assert)(options.encodingOf.nodeClass === node_opcua_data_model_4.NodeClass.DataType, "encodingOf must be toward a DataType");
        references.push({
          isForward: false,
          nodeId: options.encodingOf.nodeId,
          referenceType: "HasEncoding"
        });
      }
    }
    exports2._handle_hierarchy_parent = _handle_hierarchy_parent;
    function _copy_reference(reference) {
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(reference, "referenceType"));
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(reference, "isForward"));
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(reference, "nodeId"));
      (0, node_opcua_assert_1.assert)(reference.nodeId instanceof node_opcua_nodeid_2.NodeId);
      return {
        isForward: reference.isForward,
        nodeId: reference.nodeId,
        referenceType: reference.referenceType
      };
    }
    function _copy_references(references) {
      references = references || [];
      return references.map(_copy_reference);
    }
    function isNonEmptyQualifiedName(browseName) {
      if (!browseName) {
        return false;
      }
      if (typeof browseName === "string") {
        return browseName.length >= 0;
      }
      if (!(browseName instanceof node_opcua_data_model_2.QualifiedName)) {
        browseName = new node_opcua_data_model_2.QualifiedName(browseName);
      }
      (0, node_opcua_assert_1.assert)(browseName instanceof node_opcua_data_model_2.QualifiedName);
      return browseName.name.length > 0;
    }
    exports2.isNonEmptyQualifiedName = isNonEmptyQualifiedName;
    function _create_node_version_if_needed(node, options) {
      (0, node_opcua_assert_1.assert)(options);
      if (options.nodeVersion) {
        (0, node_opcua_assert_1.assert)(node.nodeClass === node_opcua_data_model_4.NodeClass.Variable || node.nodeClass === node_opcua_data_model_4.NodeClass.Object);
        if (node.getChildByName("NodeVersion")) {
          return;
        }
        const namespace = node.addressSpace.getOwnNamespace();
        const nodeVersion = namespace.addVariable({
          browseName: "NodeVersion",
          dataType: "String",
          propertyOf: node
        });
        const initialValue = typeof options.nodeVersion === "string" ? options.nodeVersion : "0";
        nodeVersion.setValueFromSource({ dataType: "String", value: initialValue });
      }
    }
  }
});

// node_modules/node-opcua-address-space/dist/src/address_space.js
var require_address_space2 = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/address_space.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AddressSpace = void 0;
    var crypto_1 = require("crypto");
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_object_registry_1 = require_dist46();
    var node_opcua_service_browse_1 = require_dist37();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_utils_2 = require_dist16();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_debug_1 = require_dist24();
    var adjust_browse_direction_1 = require_adjust_browse_direction();
    var alarms_and_conditions_1 = require_alarms_and_conditions();
    var event_data_1 = require_event_data();
    var address_space_historical_data_node_1 = require_address_space_historical_data_node();
    var namespace_impl_1 = require_namespace_impl();
    var namespace_impl_2 = require_namespace_impl();
    var ua_data_type_impl_1 = require_ua_data_type_impl();
    var ua_object_type_impl_1 = require_ua_object_type_impl();
    var ua_object_impl_1 = require_ua_object_impl();
    var reference_impl_1 = require_reference_impl();
    var ua_reference_type_impl_1 = require_ua_reference_type_impl();
    var base_node_impl_1 = require_base_node_impl();
    var doDebug = false;
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var Dequeue = require_lib16();
    var regexNumberColumnString = /^([0-9]+):(.*)/;
    var enumerationTypeNodeId = (0, node_opcua_nodeid_1.coerceNodeId)(node_opcua_constants_1.DataTypeIds.Enumeration);
    function _extract_namespace_and_browse_name_as_string(addressSpace, browseName, namespaceIndex) {
      (0, node_opcua_assert_1.assert)(!namespaceIndex || namespaceIndex >= 0);
      let result2;
      if (namespaceIndex !== void 0 && namespaceIndex > 0) {
        (0, node_opcua_assert_1.assert)(typeof browseName === "string", "expecting a string when namespaceIndex is specified");
        result2 = [addressSpace.getNamespace(namespaceIndex), browseName];
      } else if (typeof browseName === "string") {
        if (browseName.indexOf(":") >= 0) {
          const a = browseName.split(":");
          namespaceIndex = a.length === 2 ? parseInt(a[0], 10) : namespaceIndex;
          browseName = a.length === 2 ? a[1] : browseName;
        }
        result2 = [addressSpace.getNamespace(namespaceIndex || 0), browseName];
      } else if (browseName instanceof node_opcua_data_model_1.QualifiedName) {
        namespaceIndex = browseName.namespaceIndex;
        result2 = [addressSpace.getNamespace(namespaceIndex), browseName.name];
      } else if (typeof browseName === "number") {
        result2 = [addressSpace.getDefaultNamespace(), node_opcua_variant_1.DataType[browseName]];
      }
      if (!result2 || !result2[0]) {
        throw new Error(` Cannot find namespace associated with ${browseName} ${namespaceIndex}`);
      }
      return result2;
    }
    function isNodeIdString(str) {
      if (typeof str !== "string") {
        return false;
      }
      return str.substring(0, 2) === "i=" || str.substring(0, 3) === "ns=";
    }
    var AddressSpace = class _AddressSpace {
      get rootFolder() {
        const rootFolder = this.findNode(this.resolveNodeId("RootFolder"));
        if (!rootFolder) {
          return null;
        }
        return rootFolder;
      }
      static create() {
        return new _AddressSpace();
      }
      constructor() {
        this.suspendBackReference = false;
        this.isFrugal = false;
        this.historizingNodes = {};
        this._condition_refresh_in_progress = false;
        this.isNodeIdString = isNodeIdString;
        this._modelChangeTransactionCounter = 0;
        this._modelChanges = [];
        this._private_namespaceIndex = 1;
        this._namespaceArray = [];
        this.registerNamespace("http://opcfoundation.org/UA/");
        _AddressSpace.registry.register(this);
      }
      /**
       * @internal
       */
      getDataTypeManager() {
        const addressSpacePriv = this;
        (0, node_opcua_assert_1.assert)(addressSpacePriv.$$extraDataTypeManager, "expecting a $$extraDataTypeManager please make sure ensureDatatypeExtracted is called");
        return addressSpacePriv.$$extraDataTypeManager;
      }
      getNamespaceUri(namespaceIndex) {
        (0, node_opcua_assert_1.assert)(namespaceIndex >= 0 && namespaceIndex < this._namespaceArray.length);
        return this._namespaceArray[namespaceIndex].namespaceUri;
      }
      /***
       * @method getNamespace
       * @param {string|number} namespace index or namespace uri.
       * @return {NameSpace} the namespace
       */
      getNamespace(namespaceIndexOrName) {
        if (typeof namespaceIndexOrName === "number") {
          const namespaceIndex = namespaceIndexOrName;
          (0, node_opcua_assert_1.assert)(namespaceIndex >= 0 && namespaceIndex < this._namespaceArray.length, "invalid namespace index ( out of bound)");
          return this._namespaceArray[namespaceIndex];
        } else {
          const namespaceUri = namespaceIndexOrName;
          (0, node_opcua_assert_1.assert)(typeof namespaceUri === "string");
          const index = this.getNamespaceIndex(namespaceUri);
          return this._namespaceArray[index];
        }
      }
      /***
       * @method getDefaultNamespace
       * @return  the  default namespace (standard OPCUA namespace)
       */
      getDefaultNamespace() {
        return this.getNamespace(0);
      }
      /***
       * @method getOwnNamespace
       *
       * objects instances managed by the server will be created in this namespace.
       *
       * @return  address space own namespace
       */
      getOwnNamespace() {
        if (this._private_namespaceIndex >= this._namespaceArray.length) {
          throw new Error("please create the private namespace");
        }
        return this.getNamespace(this._private_namespaceIndex);
      }
      /**
       * @method getNamespaceIndex
       * @param namespaceUri
       * @return the namespace index of a namespace given by its namespace uri
       *
       */
      getNamespaceIndex(namespaceUri) {
        (0, node_opcua_assert_1.assert)(typeof namespaceUri === "string");
        return this._namespaceArray.findIndex((ns) => ns.namespaceUri === namespaceUri);
      }
      /**
       * @method registerNamespace
       *
       * register a new namespace,
       * it is OK to call registerNamespace even if namespace has already been registered;
       * in this case the registerNamespace has no effect and returns the existing namespace.
       *
       * @param namespaceUri {string}
       * @returns {Namespace}
       */
      registerNamespace(namespaceUri) {
        let index = this._namespaceArray.findIndex((ns) => ns.namespaceUri === namespaceUri);
        if (index !== -1) {
          (0, node_opcua_assert_1.assert)(this._namespaceArray[index].addressSpace === this);
          return this._namespaceArray[index];
        }
        index = this._namespaceArray.length;
        this._namespaceArray.push(new namespace_impl_1.NamespaceImpl({
          addressSpace: this,
          index,
          namespaceUri,
          publicationDate: /* @__PURE__ */ new Date(),
          version: "undefined"
        }));
        return this._namespaceArray[index];
      }
      /***
       * @method getNamespaceArray
       * @return {Namespace[]} the namespace array
       */
      getNamespaceArray() {
        return this._namespaceArray;
      }
      /**
       *
       * @method addAlias
       * @param alias {String} the alias name
       * @param nodeId {NodeId}
       * @internal
       */
      addAlias(alias, nodeId) {
        (0, node_opcua_assert_1.assert)(typeof alias === "string");
        (0, node_opcua_assert_1.assert)(nodeId instanceof node_opcua_nodeid_1.NodeId);
        this.getNamespace(nodeId.namespace).addAlias(alias, nodeId);
      }
      /**
       * find an node by node Id
       * @method findNode
       * @param nodeId   a nodeId or a string coerce-able to nodeID, representing the object to find.
       * @return {BaseNode|null}
       */
      findNode(nodeId) {
        if (!(nodeId instanceof node_opcua_nodeid_1.NodeId)) {
          nodeId = this.resolveNodeId(nodeId);
        }
        if (nodeId.namespace < 0 || nodeId.namespace >= this._namespaceArray.length) {
          return null;
        }
        const namespace = this._namespaceArray[nodeId.namespace];
        return namespace.findNode2(nodeId);
      }
      findMethod(nodeId) {
        const node = this.findNode(nodeId);
        if (!node || node.nodeClass !== node_opcua_data_model_1.NodeClass.Method) {
          return null;
        }
        return node;
      }
      /**
       * resolved a string or a nodeId to a nodeID
       */
      resolveNodeId(nodeId) {
        if (typeof nodeId === "string") {
          const m2 = nodeId.match(regexNumberColumnString);
          if (m2 && m2.length === 3) {
            const namespaceIndex = parseInt(m2[1], 10);
            const aliasName = m2[2];
            const namespace = this.getNamespace(namespaceIndex);
            const aliasNodeId = namespace.resolveAlias(aliasName);
            if (aliasNodeId !== null) {
              return aliasNodeId;
            }
          }
        }
        return (0, node_opcua_nodeid_1.resolveNodeId)(nodeId);
      }
      /**
       *
       * @method findObjectType
       * @param objectType  {String|NodeId|QualifiedName}
       * @param [namespaceIndex=0 {Number}] an optional namespace index
       * @return {UAObjectType|null}
       *
       * @example
       *
       * ```javascript
       *     const objectType = addressSpace.findObjectType("ns=0;i=58");
       *     objectType.browseName.toString().should.eql("BaseObjectType");
       *
       *     const objectType = addressSpace.findObjectType("BaseObjectType");
       *     objectType.browseName.toString().should.eql("BaseObjectType");
       *
       *     const objectType = addressSpace.findObjectType(resolveNodeId("ns=0;i=58"));
       *     objectType.browseName.toString().should.eql("BaseObjectType");
       *
       *     const objectType = addressSpace.findObjectType("CustomObjectType",36);
       *     objectType.nodeId.namespace.should.eql(36);
       *     objectType.browseName.toString().should.eql("BaseObjectType");
       *
       *     const objectType = addressSpace.findObjectType("36:CustomObjectType");
       *     objectType.nodeId.namespace.should.eql(36);
       *     objectType.browseName.toString().should.eql("BaseObjectType");
       * ```
       */
      findObjectType(objectType, namespaceIndex) {
        if (objectType instanceof node_opcua_nodeid_1.NodeId) {
          return _find_by_node_id(this, objectType, namespaceIndex);
        }
        const [namespace, browseName] = _extract_namespace_and_browse_name_as_string(this, objectType, namespaceIndex);
        return namespace.findObjectType(browseName);
      }
      /**
       * @method findVariableType
       * @param variableType  {String|NodeId}
       * @param [namespaceIndex=0 {Number}] an optional namespace index
       * @return {UAObjectType|null}
       *
       * @example
       *
       * ```javascript
       *     const objectType = addressSpace.findVariableType("ns=0;i=62");
       *     objectType.browseName.toString().should.eql("BaseVariableType");
       *
       *     const objectType = addressSpace.findVariableType("BaseVariableType");
       *     objectType.browseName.toString().should.eql("BaseVariableType");
       *
       *     const objectType = addressSpace.findVariableType(resolveNodeId("ns=0;i=62"));
       *     objectType.browseName.toString().should.eql("BaseVariableType");
       * ```
       */
      findVariableType(variableType, namespaceIndex) {
        if (variableType instanceof node_opcua_nodeid_1.NodeId) {
          return _find_by_node_id(this, variableType, namespaceIndex);
        }
        const [namespace, browseName] = _extract_namespace_and_browse_name_as_string(this, variableType, namespaceIndex);
        return namespace.findVariableType(browseName);
      }
      /**
       * Find the DataType node from a NodeId or a browseName
       * @method findDataType
       * @param dataType {String|NodeId}
       * @param [namespaceIndex=0 {Number}] an optional namespace index
       * @return {DataType|null}
       *
       *
       * @example
       *
       * ```javascript
       *      const dataDouble = addressSpace.findDataType("Double");
       *      const dataDouble = addressSpace.findDataType(resolveNodeId("ns=0;i=3"));
       * ```
       */
      findDataType(dataType, namespaceIndex) {
        if (dataType instanceof ua_data_type_impl_1.UADataTypeImpl) {
          return this.findDataType(dataType.nodeId);
        } else if (dataType instanceof node_opcua_nodeid_1.NodeId) {
          return _find_by_node_id(this, dataType, namespaceIndex);
        }
        if (typeof dataType === "number") {
          if (node_opcua_variant_1.DataType[dataType] !== void 0) {
            dataType = node_opcua_variant_1.DataType[dataType];
          } else {
            return this.findDataType((0, node_opcua_nodeid_1.resolveNodeId)(dataType));
          }
        }
        const res = _extract_namespace_and_browse_name_as_string(this, dataType, namespaceIndex);
        const namespace = res[0];
        const browseName = res[1];
        return namespace.findDataType(browseName);
      }
      /**
       * @method findCorrespondingBasicDataType
       *
       * @example
       *
       *     const dataType = addressSpace.findDataType("ns=0;i=12");
       *     addressSpace.findCorrespondingBasicDataType(dataType).should.eql(DataType.String);
       *
       *     const dataType = addressSpace.findDataType("ServerStatusDataType"); // ServerStatus
       *     addressSpace.findCorrespondingBasicDataType(dataType).should.eql(DataType.ExtensionObject);
       *
       */
      findCorrespondingBasicDataType(dataTypeNode) {
        const _orig_dataTypeNode = dataTypeNode;
        if (typeof dataTypeNode === "string") {
          const resolvedDataType = this.resolveNodeId(dataTypeNode);
          if (!resolvedDataType) {
            throw new Error("Cannot resolve " + _orig_dataTypeNode.toString());
          }
          dataTypeNode = resolvedDataType;
        }
        if (dataTypeNode instanceof node_opcua_nodeid_1.NodeId) {
          dataTypeNode = this.findDataType(dataTypeNode);
          if (!dataTypeNode) {
            throw Error("cannot find dataTypeNode " + _orig_dataTypeNode.toString());
          }
        }
        if (!(dataTypeNode instanceof ua_data_type_impl_1.UADataTypeImpl)) {
          throw new Error("we are expecting an UADataType here :  " + _orig_dataTypeNode.toString() + " should not refer to a  " + dataTypeNode.browseName.name);
        }
        if ((0, node_opcua_nodeid_1.sameNodeId)(enumerationTypeNodeId, dataTypeNode.nodeId)) {
          return node_opcua_variant_1.DataType.Int32;
        }
        const n = dataTypeNode.nodeId;
        if (n.namespace === 0 && n.value === 29) {
          return node_opcua_variant_1.DataType.Null;
        }
        if (n.namespace === 0 && n.value === 0) {
          return node_opcua_variant_1.DataType.Null;
        }
        if (n.identifierType === node_opcua_nodeid_1.NodeIdType.NUMERIC && n.namespace === 0 && n.value <= 25) {
          return n.value;
        }
        const result2 = this.findCorrespondingBasicDataType(dataTypeNode.subtypeOfObj);
        return result2;
      }
      /**
       * find a ReferenceType by its inverse name.
       * @method findReferenceTypeFromInverseName
       * @param inverseName  the inverse name of the ReferenceType to find
       * @deprecated
       */
      findReferenceTypeFromInverseName(inverseName) {
        return this.getDefaultNamespace().findReferenceTypeFromInverseName(inverseName);
      }
      /**
       * @method findReferenceType
       * @param refType {String|NodeId}
       * @param [namespaceIndex=0 {Number}] an optional namespace index
       * @return {ReferenceType|null}
       *
       * refType could be
       *   - a string representing a nodeid       : e.g.    `i=9004` or ns=1;i=6030
       *   - a string representing a browse name  : e.g     `"HasTypeDefinition"`.
       *     In this case it should be in the alias list.
       *
       */
      findReferenceType(refType, namespaceIndex) {
        let node;
        if (isNodeIdString(refType) || typeof refType === "number") {
          refType = (0, node_opcua_nodeid_1.resolveNodeId)(refType);
        }
        if (refType instanceof node_opcua_nodeid_1.NodeId) {
          node = this.findNode(refType);
          if (!(node && node.nodeClass === node_opcua_data_model_1.NodeClass.ReferenceType)) {
            return null;
          }
        } else {
          (0, node_opcua_assert_1.assert)(typeof refType === "string");
          node = this._findReferenceType(refType, namespaceIndex);
        }
        return node;
      }
      /**
       * returns the inverse name of the referenceType.
       *
       * @method inverseReferenceType
       * @param referenceType {String} : the reference type name
       * @return {String} the name of the inverse reference type.
       *
       * @example
       *
       *    ```javascript
       *    addressSpace.inverseReferenceType("OrganizedBy").should.eql("Organizes");
       *    addressSpace.inverseReferenceType("Organizes").should.eql("OrganizedBy");
       *    ```
       *
       */
      inverseReferenceType(referenceType) {
        (0, node_opcua_assert_1.assert)(typeof referenceType === "string");
        const n1 = this.findReferenceType(referenceType);
        const n2 = this.findReferenceTypeFromInverseName(referenceType);
        if (n1) {
          (0, node_opcua_assert_1.assert)(!n2);
          return n1.inverseName.text;
        } else {
          (0, node_opcua_assert_1.assert)(n2);
          return n2.browseName.toString();
        }
      }
      /**
       * find an EventType node in the address space
       * @method findEventType
       * @param eventTypeId {String|NodeId|UAObjectType} the eventType to find
       * @param namespaceIndex the namespace index of the event to find
       * @return {UAObjectType|null} the EventType found or null.
       *
       * note:
       *    - the method with throw an exception if a node is found
       *      that is not a BaseEventType or a subtype of it.
       *
       * @example
       *
       *     var evtType = addressSpace.findEventType("AuditEventType");
       *
       */
      findEventType(eventTypeId, namespaceIndex) {
        let eventType;
        if (eventTypeId instanceof base_node_impl_1.BaseNodeImpl) {
          eventType = eventTypeId;
        } else {
          eventType = this.findObjectType(eventTypeId, namespaceIndex);
        }
        if (!eventType) {
          return null;
        }
        const baseEventType = this.findObjectType("BaseEventType");
        if (!baseEventType) {
          throw new Error("expecting BaseEventType - please check you nodeset xml file!");
        }
        if ((0, node_opcua_nodeid_1.sameNodeId)(eventType.nodeId, baseEventType.nodeId)) {
          return eventType;
        }
        if (!eventType.isSubtypeOf(baseEventType)) {
          throw new Error("findEventType: event found is not subType of BaseEventType");
        }
        return eventType;
      }
      /**
       * EventId is generated by the Server to uniquely identify a particular Event Notification.
       * @method generateEventId
       * @return {Variant}  dataType: "ByteString"
       */
      generateEventId() {
        const offset = 16;
        const self2 = this;
        if (!self2._eventIdCounter) {
          self2._eventIdCounter = (0, crypto_1.randomBytes)(20);
          self2._eventIdCounter.writeInt32BE(0, offset);
        }
        self2._eventIdCounter.writeInt32BE(self2._eventIdCounter.readInt32BE(offset) + 1, offset);
        return new node_opcua_variant_1.Variant({
          dataType: node_opcua_variant_1.DataType.ByteString,
          value: Buffer.from(self2._eventIdCounter)
        });
      }
      /*=
       * construct a simple javascript object with all the default properties of the event
       * @method constructEventData
       *
       * @return result.$eventDataSource {BaseNode} the event type node
       * @return result.eventId {NodeId} the
       * ...
       *
       *
       * eventTypeId can be a UAEventType
       *
       * @private
       */
      constructEventData(eventTypeId, data) {
        data = data || {};
        let eventTypeNode = eventTypeId;
        if (eventTypeId instanceof ua_object_type_impl_1.UAObjectTypeImpl) {
          eventTypeNode = this.findEventType(eventTypeId);
        }
        if (!eventTypeNode) {
          throw new Error(" cannot find EvenType for " + eventTypeId);
        }
        (0, node_opcua_assert_1.assert)(eventTypeNode instanceof ua_object_type_impl_1.UAObjectTypeImpl, "eventTypeId must represent a UAObjectType");
        (0, node_opcua_assert_1.assert)(!Object.prototype.hasOwnProperty.call(data, "eventId"), "eventId constructEventData : options object should not have eventId property");
        data.eventId = data.eventId || this.generateEventId();
        data.eventType = { dataType: node_opcua_variant_1.DataType.NodeId, value: eventTypeNode.nodeId };
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(data, "sourceNode"), "expecting a source node to be defined");
        data.sourceNode = new node_opcua_variant_1.Variant(data.sourceNode);
        (0, node_opcua_assert_1.assert)(data.sourceNode.dataType === node_opcua_variant_1.DataType.NodeId);
        const sourceNode = this.findNode(data.sourceNode.value);
        data.sourceName = data.sourceName || {
          dataType: node_opcua_variant_1.DataType.String,
          value: sourceNode.getDisplayName("en")
        };
        const nowUTC = /* @__PURE__ */ new Date();
        data.time = data.time || { dataType: node_opcua_variant_1.DataType.DateTime, value: nowUTC };
        data.receiveTime = data.receiveTime || { dataType: node_opcua_variant_1.DataType.DateTime, value: nowUTC };
        data.localTime = data.localTime || { dataType: node_opcua_variant_1.DataType.DateTime, value: nowUTC };
        data.message = data.message || { dataType: node_opcua_variant_1.DataType.LocalizedText, value: { text: "" } };
        data.severity = data.severity || { dataType: node_opcua_variant_1.DataType.UInt16, value: 0 };
        const baseObjectType = this.findObjectType("BaseObjectType");
        if (!baseObjectType) {
          throw new Error("BaseObjectType must be defined in the address space");
        }
        const hasProperty = (data2, propertyName) => Object.prototype.hasOwnProperty.call(data2, propertyName);
        const visitedProperties = {};
        const alreadyVisited = (key) => Object.prototype.hasOwnProperty.call(visitedProperties, key);
        const markAsVisited = (key) => visitedProperties[key] = 1;
        function _process_var(self2, prefixLower, prefixStandard, node) {
          const lowerName = prefixLower + (0, node_opcua_utils_2.lowerFirstLetter)(node.browseName.name);
          const fullBrowsePath = prefixStandard + node.browseName.toString();
          if (alreadyVisited(lowerName)) {
            return;
          }
          markAsVisited(lowerName);
          if (hasProperty(data, lowerName)) {
            eventData._createValue(fullBrowsePath, node, data[lowerName]);
          } else {
            eventData._createValue(fullBrowsePath, node, { dataType: node_opcua_variant_1.DataType.Null });
            if (doDebug) {
              if (node.modellingRule === "Mandatory") {
                errorLog(chalk_1.default.red("ERROR : AddressSpace#constructEventData(eventType,options) cannot find property ") + self2.browseName.toString() + " => " + chalk_1.default.cyan(lowerName));
              } else {
                errorLog(chalk_1.default.yellow("Warning : AddressSpace#constructEventData(eventType,options) cannot find property ") + self2.browseName.toString() + " => " + chalk_1.default.cyan(lowerName));
              }
            }
          }
        }
        function verify_data_is_valid(data1) {
          Object.keys(data1).map((k) => {
            if (k === "$eventDataSource") {
              return;
            }
            if (!alreadyVisited(k)) {
              warningLog("constructEventData:  cannot find property '" + k + "' in [ " + Object.keys(visitedProperties).join(", ") + "] when filling " + eventTypeNode.browseName.toString());
            }
          });
        }
        const populate_data = (self2, eventData1) => {
          if ((0, node_opcua_nodeid_1.sameNodeId)(baseObjectType.nodeId, self2.nodeId)) {
            return;
          }
          const baseTypeNodeId = self2.subtypeOf;
          if (!baseTypeNodeId) {
            throw new Error("Object " + self2.browseName.toString() + " with nodeId " + self2.nodeId + " has no Type");
          }
          const baseType = this.findNode(baseTypeNodeId);
          if (!baseType) {
            throw new Error(chalk_1.default.red("Cannot find object with nodeId ") + baseTypeNodeId);
          }
          populate_data(baseType, eventData1);
          const properties = self2.getProperties();
          const components = self2.getComponents();
          const children = [].concat(properties, components);
          if (doDebug) {
            debugLog(" " + chalk_1.default.bgWhite.cyan(self2.browseName.toString()));
          }
          for (const node of children) {
            if (!node.modellingRule) {
              continue;
            }
            if (node.nodeClass === node_opcua_data_model_1.NodeClass.Method) {
              continue;
            }
            _process_var(self2, "", "", node);
            const children2 = node.getAggregates();
            if (children2.length > 0) {
              const lowerName = (0, node_opcua_utils_2.lowerFirstLetter)(node.browseName.name);
              const standardName = node.browseName.toString();
              for (const child2 of children2) {
                _process_var(self2, lowerName + ".", standardName + ".", child2);
              }
            }
          }
        };
        const eventData = new event_data_1.EventData(eventTypeNode);
        populate_data(eventTypeNode, eventData);
        verify_data_is_valid(data);
        return eventData;
      }
      // - Browse --------------------------------------------------------------------------------------------------------
      /**
       * browse some path.
       *
       * @method browsePath
       * @param  {BrowsePath} browsePath
       * @return {BrowsePathResult}
       *
       * This service can be used translates one or more browse paths into NodeIds.
       * A browse path is constructed of a starting Node and a RelativePath. The specified starting Node
       * identifies the Node from which the RelativePath is based. The RelativePath contains a sequence of
       * ReferenceTypes and BrowseNames.
       *
       *   |StatusCode                    |                                                            |
       *   |------------------------------|:-----------------------------------------------------------|
       *   |BadNodeIdUnknown              |                                                            |
       *   |BadNodeIdInvalid              |                                                            |
       *   |BadNothingToDo                | - the relative path contains an empty list )               |
       *   |BadBrowseNameInvalid          | - target name is missing in relative path                  |
       *   |UncertainReferenceOutOfServer | - The path element has targets which are in another server.|
       *   |BadTooManyMatches             |                                                            |
       *   |BadQueryTooComplex            |                                                            |
       *   |BadNoMatch                    |                                                            |
       *
       *
       *
       */
      browsePath(browsePath) {
        (0, node_opcua_assert_1.assert)(browsePath instanceof node_opcua_types_1.BrowsePath);
        const startingNode = this.findNode(browsePath.startingNode);
        if (!startingNode) {
          return new node_opcua_types_1.BrowsePathResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadNodeIdUnknown });
        }
        if (!browsePath.relativePath.elements || browsePath.relativePath.elements.length === 0) {
          return new node_opcua_types_1.BrowsePathResult({
            statusCode: node_opcua_status_code_1.StatusCodes.BadNothingToDo,
            targets: []
          });
        }
        const elements_length = browsePath.relativePath.elements.length;
        const empty_targetName_not_in_lastPos = browsePath.relativePath.elements.reduce((prev, e, index) => {
          const is_last = index + 1 === elements_length;
          const isBad = !is_last && (!e.targetName || e.targetName.isEmpty());
          return prev + (!is_last && (!e.targetName || e.targetName.isEmpty()) ? 1 : 0);
        }, 0);
        if (empty_targetName_not_in_lastPos) {
          return new node_opcua_types_1.BrowsePathResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadBrowseNameInvalid });
        }
        const last_el = browsePath.relativePath.elements[elements_length - 1];
        if (!last_el.targetName || !last_el.targetName.name || last_el.targetName.name.length === 0) {
          return new node_opcua_types_1.BrowsePathResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadBrowseNameInvalid });
        }
        const res = [];
        const explore_element = (curNodeObject, elements, index) => {
          const element = elements[index];
          (0, node_opcua_assert_1.assert)(element instanceof node_opcua_types_1.RelativePathElement);
          const is_last = index + 1 === elements.length;
          const nodeIds = curNodeObject.browseNodeByTargetName(element, is_last);
          const targets = nodeIds.map((nodeId) => {
            return {
              remainingPathIndex: elements.length - index,
              targetId: nodeId
            };
          });
          if (!is_last) {
            for (const target of targets) {
              const node = this.findNode(target.targetId);
              if (!node) {
                continue;
              }
              explore_element(node, elements, index + 1);
            }
          } else {
            for (const target of targets) {
              res.push({
                remainingPathIndex: 4294967295,
                targetId: (0, node_opcua_nodeid_1.coerceExpandedNodeId)(target.targetId)
              });
            }
          }
        };
        explore_element(startingNode, browsePath.relativePath.elements, 0);
        if (res.length === 0) {
          return new node_opcua_types_1.BrowsePathResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadNoMatch });
        }
        return new node_opcua_types_1.BrowsePathResult({
          statusCode: node_opcua_status_code_1.StatusCodes.Good,
          targets: res
        });
      }
      // - Extension Object ----------------------------------------------------------------------------------------------
      getExtensionObjectConstructor(dataType) {
        (0, node_opcua_assert_1.assert)(dataType, "expecting a dataType");
        if (dataType instanceof node_opcua_nodeid_1.NodeId) {
          const tmp = this.findNode(dataType);
          if (!tmp) {
            throw new Error("getExtensionObjectConstructor: cannot resolve dataType " + dataType);
          }
          dataType = tmp;
        }
        if (!(dataType instanceof ua_data_type_impl_1.UADataTypeImpl)) {
          throw new Error("getExtensionObjectConstructor: dataType has unexpected type" + dataType);
        }
        const _dataType = dataType;
        if (!_dataType.isSubtypeOf(this.findDataType("Structure"))) {
          debugLog(_dataType.toString());
        }
        (0, node_opcua_assert_1.assert)(_dataType.isSubtypeOf(this.findDataType("Structure")));
        if (!_dataType._extensionObjectConstructor) {
          const dataTypeManager = this.$$extraDataTypeManager;
          _dataType._extensionObjectConstructor = dataTypeManager.getExtensionObjectConstructorFromDataType(_dataType.nodeId);
        }
        (0, node_opcua_assert_1.assert)(_dataType._extensionObjectConstructor, "dataType must have a constructor");
        const Constructor = _dataType._extensionObjectConstructor;
        return Constructor;
      }
      /**
       * @param dataType
       * @param [options]
       * @return the constructed extension object
       *
       *
       * @example
       *
       *             // example 1
       *             var extObj = addressSpace.constructExtensionObject("BuildInfo",{ productName: "PRODUCT_NAME"});
       *
       *             // example 2
       *             serverStatusDataType.nodeClass.should.eql(NodeClass.DataType);
       *             serverStatusDataType.browseName.toString().should.eql("ServerStatusDataType");
       *             var serverStatus  = addressSpace.constructExtensionObject(serverStatusDataType);
       *             serverStatus.should.be.instanceof(ServerStatusDataType);
       */
      constructExtensionObject(dataType, options) {
        const Constructor = this.getExtensionObjectConstructor(dataType);
        return new Constructor(options);
      }
      /**
       * cleanup all resources maintained by this addressSpace.
       * @method dispose
       */
      dispose() {
        this._namespaceArray.map((namespace) => namespace.dispose());
        _AddressSpace.registry.unregister(this);
        if (this._shutdownTask && this._shutdownTask.length > 0) {
          throw new Error("AddressSpace#dispose : shutdown has not been called");
        }
      }
      /**
       * register a function that will be called when the server will perform its shut down.
       * @method registerShutdownTask
       */
      registerShutdownTask(task) {
        this._shutdownTask = this._shutdownTask || [];
        (0, node_opcua_assert_1.assert)(typeof task === "function");
        this._shutdownTask.push(task);
      }
      async shutdown() {
        const performTasks = async (tasks) => {
          for (const task of tasks) {
            await task.call(this);
          }
        };
        if (this._shutdownTask) {
          const tasks = this._shutdownTask;
          this._shutdownTask = [];
          await performTasks(tasks);
        }
      }
      browseSingleNode(nodeId, browseDescription, context) {
        const browseResult = {
          continuationPoint: void 0,
          references: null,
          statusCode: node_opcua_status_code_1.StatusCodes.Good
        };
        if (!browseDescription || browseDescription.browseDirection === node_opcua_data_model_1.BrowseDirection.Invalid) {
          browseResult.statusCode = node_opcua_status_code_1.StatusCodes.BadBrowseDirectionInvalid;
          return new node_opcua_service_browse_1.BrowseResult(browseResult);
        }
        browseDescription.browseDirection = (0, adjust_browse_direction_1.adjustBrowseDirection)(browseDescription.browseDirection, node_opcua_data_model_1.BrowseDirection.Forward);
        if (typeof nodeId === "number") {
          throw new Error("Not Implemented");
        }
        if (typeof nodeId === "string") {
          const node = this.findNode(this.resolveNodeId(nodeId));
          if (node) {
            nodeId = node.nodeId;
          }
        }
        if (browseDescription.referenceTypeId instanceof node_opcua_nodeid_1.NodeId) {
          if (browseDescription.referenceTypeId.value === 0) {
            browseDescription.referenceTypeId = null;
          } else {
            const rf = this.findNode(browseDescription.referenceTypeId);
            if (!rf || !(rf instanceof ua_reference_type_impl_1.UAReferenceTypeImpl)) {
              browseResult.statusCode = node_opcua_status_code_1.StatusCodes.BadReferenceTypeIdInvalid;
              return new node_opcua_service_browse_1.BrowseResult(browseResult);
            }
          }
        }
        const obj = this.findNode(nodeId);
        if (!obj) {
          browseResult.statusCode = node_opcua_status_code_1.StatusCodes.BadNodeIdUnknown;
        } else {
          browseResult.statusCode = node_opcua_status_code_1.StatusCodes.Good;
          browseResult.references = obj.browseNode(browseDescription, context);
        }
        return new node_opcua_service_browse_1.BrowseResult(browseResult);
      }
      /**
       * @param folder
       * @private
       */
      _coerceFolder(folder) {
        folder = this._coerceNode(folder);
        if (folder && !_isFolder(this, folder)) {
          throw new Error("Parent folder must be of FolderType " + folder.typeDefinition.toString());
        }
        return folder;
      }
      /**
       *
       * @param view
       * @param modelChange
       * @private
       */
      _collectModelChange(view, modelChange) {
        this._modelChanges.push(modelChange);
      }
      /**
       *
       * walk up the hierarchy of objects until a view is found
       * objects may belong to multiples views.
       * Note: this method doesn't return the main view => Server object.
       * @method extractRootViews
       * @param node {BaseNode}
       * @return {BaseNode[]}
       */
      /**
       *
       * @param node
       * @private
       */
      extractRootViews(node) {
        (0, node_opcua_assert_1.assert)(node.nodeClass === node_opcua_data_model_1.NodeClass.Object || node.nodeClass === node_opcua_data_model_1.NodeClass.Variable);
        const visitedMap = {};
        const q2 = new Dequeue();
        q2.push(node);
        const objectsFolder = this.rootFolder.objects;
        (0, node_opcua_assert_1.assert)(objectsFolder instanceof ua_object_impl_1.UAObjectImpl);
        const results = [];
        while (q2.length) {
          node = q2.shift();
          const references = node.findReferencesEx("HierarchicalReferences", node_opcua_data_model_1.BrowseDirection.Inverse);
          const parentNodes = references.map((r) => reference_impl_1.ReferenceImpl.resolveReferenceNode(this, r));
          for (const parent of parentNodes) {
            if ((0, node_opcua_nodeid_1.sameNodeId)(parent.nodeId, objectsFolder.nodeId)) {
              continue;
            }
            if (parent.nodeClass === node_opcua_data_model_1.NodeClass.View) {
              results.push(parent);
            } else {
              const key = parent.nodeId.toString();
              if (Object.prototype.hasOwnProperty.call(visitedMap, key)) {
                continue;
              }
              visitedMap[key] = parent;
              q2.push(parent);
            }
          }
        }
        return results;
      }
      /**
       *
       * @param func
       * @private
       */
      modelChangeTransaction(func) {
        this._modelChangeTransactionCounter = this._modelChangeTransactionCounter || 0;
        function beginModelChange() {
          (0, node_opcua_assert_1.assert)(this);
          this._modelChanges = this._modelChanges || [];
          (0, node_opcua_assert_1.assert)(this._modelChangeTransactionCounter >= 0);
          this._modelChangeTransactionCounter += 1;
        }
        function endModelChange() {
          this._modelChangeTransactionCounter -= 1;
          if (this._modelChangeTransactionCounter === 0) {
            if (this._modelChanges.length === 0) {
              return;
            }
            const nodeIds = [...new Set(this._modelChanges.map((c2) => c2.affected))];
            const nodes = nodeIds.map((nodeId) => this.findNode(nodeId));
            nodes.forEach(_increase_version_number);
            if (this.rootFolder.objects.server) {
              const eventTypeNode = this.findEventType("GeneralModelChangeEventType");
              if (eventTypeNode) {
                this.rootFolder.objects.server.raiseEvent(eventTypeNode, {
                  // Part 5 - 6.4.32 GeneralModelChangeEventType
                  changes: {
                    dataType: node_opcua_variant_1.DataType.ExtensionObject,
                    arrayType: node_opcua_variant_1.VariantArrayType.Array,
                    value: this._modelChanges
                  }
                });
              }
            }
            this._modelChanges = [];
          }
        }
        beginModelChange.call(this);
        try {
          func();
        } catch (err) {
          errorLog("modelChangeTransaction", err?.message);
          throw err;
        } finally {
          endModelChange.call(this);
        }
      }
      /**
       * normalize the ReferenceType field of the Reference Object
       * @param params.referenceType  {String|nodeId}
       * @param params.isForward  {Boolean} default value: true;
       * @return {Object} a new reference object  with the normalized name { referenceType: <value>, isForward: <flag>}
       */
      normalizeReferenceType(params) {
        if (params instanceof reference_impl_1.ReferenceImpl) {
          return params;
        }
        (0, node_opcua_assert_1.assert)(params.isForward === void 0 || typeof params.isForward === "boolean");
        params.isForward = (0, node_opcua_utils_1.isNullOrUndefined)(params.isForward) ? true : !!params.isForward;
        if (params.referenceType instanceof ua_reference_type_impl_1.UAReferenceTypeImpl) {
          params.referenceType = params.referenceType;
          params.referenceType = params.referenceType.nodeId;
        } else if (typeof params.referenceType === "string") {
          const inv = this.findReferenceTypeFromInverseName(params.referenceType);
          if (inv) {
            params.referenceType = inv.nodeId;
            params._referenceType = inv;
            params.isForward = !params.isForward;
          } else {
            params.referenceType = (0, node_opcua_nodeid_1.resolveNodeId)(params.referenceType);
            const refType = this.findReferenceType(params.referenceType);
            if (refType) {
              params._referenceType = refType;
            }
          }
        }
        (0, node_opcua_assert_1.assert)(params.referenceType instanceof node_opcua_nodeid_1.NodeId);
        if (params.nodeId instanceof base_node_impl_1.BaseNodeImpl) {
          (0, node_opcua_assert_1.assert)(!Object.prototype.hasOwnProperty.call(params, "node"));
          params.node = params.nodeId;
          params.nodeId = params.node.nodeId;
        } else {
          let _nodeId = params.nodeId;
          (0, node_opcua_assert_1.assert)(!!_nodeId, "missing 'nodeId' in reference");
          if (_nodeId && _nodeId.nodeId) {
            _nodeId = _nodeId.nodeId;
          }
          _nodeId = (0, node_opcua_nodeid_1.resolveNodeId)(_nodeId);
          params.nodeId = _nodeId;
        }
        return new reference_impl_1.ReferenceImpl(params);
      }
      normalizeReferenceTypes(references) {
        if (!references || references.length === 0) {
          return [];
        }
        return references.map((el) => this.normalizeReferenceType(el));
      }
      // -- Historical Node  -----------------------------------------------------------------------------------------
      /**
       *
       * @param node
       * @param options
       */
      installHistoricalDataNode(node, options) {
        address_space_historical_data_node_1.AddressSpace_installHistoricalDataNode.call(this, node, options);
      }
      // -- Alarms & Conditions  -----------------------------------------------------------------------------------------
      /**
       *
       */
      installAlarmsAndConditionsService() {
        alarms_and_conditions_1.UAConditionImpl.install_condition_refresh_handle(this);
        alarms_and_conditions_1.UAAcknowledgeableConditionImpl.install_method_handle_on_type(this);
      }
      // -- internal stuff -----------------------------------------------------------------------------------------------
      _coerceNode(node) {
        function hasTypeDefinition(node1) {
          return node1.nodeClass === node_opcua_data_model_1.NodeClass.Variable || node1.nodeClass === node_opcua_data_model_1.NodeClass.Object || node1.nodeClass === node_opcua_data_model_1.NodeClass.Method;
        }
        if (node instanceof base_node_impl_1.BaseNodeImpl) {
          return node;
        }
        const returnValue = this.findNode((0, node_opcua_nodeid_1.resolveNodeId)(node));
        return returnValue;
      }
      _coerce_DataType(dataType) {
        if (dataType instanceof node_opcua_nodeid_1.NodeId) {
          return dataType;
        }
        return this._coerce_Type(dataType, node_opcua_constants_1.DataTypeIds, "DataTypeIds", _AddressSpace.prototype.findDataType);
      }
      _coerceTypeDefinition(typeDefinition) {
        if (typeof typeDefinition === "string") {
          const typeDefinitionNode = this.findNode(typeDefinition);
          typeDefinition = typeDefinitionNode.nodeId;
        }
        (0, node_opcua_assert_1.assert)(typeDefinition instanceof node_opcua_nodeid_1.NodeId);
        return typeDefinition;
      }
      _coerceType(baseType, topMostBaseType, nodeClass) {
        (0, node_opcua_assert_1.assert)(typeof topMostBaseType === "string");
        const topMostBaseTypeNode = this.findNode(topMostBaseType);
        if (!topMostBaseTypeNode) {
          throw new Error("Cannot find topMostBaseTypeNode " + topMostBaseType.toString());
        }
        (0, node_opcua_assert_1.assert)(topMostBaseTypeNode instanceof base_node_impl_1.BaseNodeImpl);
        (0, node_opcua_assert_1.assert)(topMostBaseTypeNode.nodeClass === nodeClass);
        if (!baseType) {
          return topMostBaseTypeNode;
        }
        (0, node_opcua_assert_1.assert)(typeof baseType === "string" || baseType instanceof base_node_impl_1.BaseNodeImpl || baseType instanceof node_opcua_nodeid_1.NodeId);
        let baseTypeNode;
        if (baseType instanceof base_node_impl_1.BaseNodeImpl) {
          baseTypeNode = baseType;
        } else {
          baseTypeNode = this.findNode(baseType);
        }
        if (!baseTypeNode) {
          throw new Error("Cannot find ObjectType or VariableType for " + baseType.toString());
        }
        if (!baseTypeNode.isSubtypeOf) {
          throw new Error("Cannot find ObjectType or VariableType for " + baseType.toString());
        }
        if (!baseTypeNode.isSubtypeOf(topMostBaseTypeNode)) {
          throw new Error("wrong type ");
        }
        return baseTypeNode;
      }
      _coerce_VariableTypeIds(dataType) {
        return this._coerce_Type(dataType, node_opcua_constants_1.VariableTypeIds, "VariableTypeIds", _AddressSpace.prototype.findVariableType);
      }
      _register(node) {
        (0, node_opcua_assert_1.assert)(node.nodeId instanceof node_opcua_nodeid_1.NodeId);
        const namespace = this.getNamespace(node.nodeId.namespace);
        namespace._register(node);
      }
      deleteNode(nodeOrNodeId) {
        _getNamespace(this, nodeOrNodeId).deleteNode(nodeOrNodeId);
      }
      isEnumeration(dataType) {
        const dataTypeNode = this.findDataType(dataType);
        if (!dataTypeNode) {
          throw new Error(" Cannot find  DataType  " + dataType.toString() + " in standard address Space");
        }
        const enumerationNode = this.findDataType("Enumeration");
        if (!enumerationNode) {
          throw new Error(" Cannot find 'Enumeration' DataType in standard address Space");
        }
        return dataTypeNode.isSubtypeOf(enumerationNode);
      }
      _coerce_Type(dataType, typeMap, typeMapName, finderMethod) {
        if (dataType instanceof base_node_impl_1.BaseNodeImpl) {
          dataType = dataType.nodeId;
        }
        (0, node_opcua_assert_1.assert)(typeMap !== null && typeof typeMap === "object");
        let nodeId;
        if (typeof dataType === "string") {
          const namespace0 = this.getDefaultNamespace();
          nodeId = namespace0.resolveAlias(dataType);
          if (!nodeId) {
            if (typeMap[dataType]) {
              nodeId = (0, node_opcua_nodeid_1.makeNodeId)(typeMap[dataType], 0);
              return nodeId;
            } else {
              nodeId = (0, node_opcua_nodeid_1.resolveNodeId)(dataType);
            }
          }
        } else if (typeof dataType === "number") {
          nodeId = (0, node_opcua_nodeid_1.makeNodeId)(dataType, 0);
        } else {
          nodeId = (0, node_opcua_nodeid_1.resolveNodeId)(dataType);
        }
        if (nodeId == null || !(nodeId instanceof node_opcua_nodeid_1.NodeId)) {
          throw new Error("Expecting valid nodeId ");
        }
        const el = finderMethod.call(this, nodeId);
        if (!el) {
          const find = Object.values(typeMap).filter((a) => a === nodeId.value);
          if (find.length !== 1) {
            throw new Error(" cannot find " + dataType.toString() + " in typeMap " + typeMapName + " L = " + find.length);
          }
        }
        return nodeId;
      }
      _findReferenceType(refType, namespaceIndex) {
        if (refType instanceof node_opcua_nodeid_1.NodeId) {
          return _find_by_node_id(this, refType, namespaceIndex);
        }
        const [namespace, browseName] = _extract_namespace_and_browse_name_as_string(this, refType, namespaceIndex);
        return namespace.findReferenceType(browseName);
      }
    };
    exports2.AddressSpace = AddressSpace;
    AddressSpace.isNonEmptyQualifiedName = namespace_impl_2.isNonEmptyQualifiedName;
    AddressSpace.registry = new node_opcua_object_registry_1.ObjectRegistry();
    function _getNamespace(addressSpace, nodeOrNodId) {
      const nodeId = nodeOrNodId instanceof base_node_impl_1.BaseNodeImpl ? nodeOrNodId.nodeId : nodeOrNodId;
      return addressSpace.getNamespace(nodeId.namespace);
    }
    function _find_by_node_id(addressSpace, nodeId, namespaceIndex) {
      const obj = addressSpace.findNode(nodeId);
      return obj;
    }
    function _isFolder(addressSpace, folder) {
      const folderType = addressSpace.findObjectType("FolderType");
      (0, node_opcua_assert_1.assert)(folder instanceof base_node_impl_1.BaseNodeImpl);
      (0, node_opcua_assert_1.assert)(folder.typeDefinitionObj);
      return folder.typeDefinitionObj.isSubtypeOf(folderType);
    }
    function _increase_version_number(node) {
      if (node && node.nodeVersion) {
        const previousValue = parseInt(node.nodeVersion.readValue().value.value, 10);
        node.nodeVersion.setValueFromSource({
          dataType: node_opcua_variant_1.DataType.String,
          value: (previousValue + 1).toString()
        });
      }
    }
  }
});

// node_modules/node-opcua-address-space/dist/source/namespace_machine_state.js
var require_namespace_machine_state = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/namespace_machine_state.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/source/namespace_alarm_and_condition.js
var require_namespace_alarm_and_condition = __commonJS({
  "node_modules/node-opcua-address-space/dist/source/namespace_alarm_and_condition.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-address-space/dist/src/extension_object_array_node.js
var require_extension_object_array_node = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/extension_object_array_node.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.removeElement = exports2.addElement = exports2.bindExtObjArrayNode = exports2.createExtObjArrayNode = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_variant_2 = require_dist28();
    var node_opcua_variant_3 = require_dist28();
    var node_opcua_extension_object_1 = require_dist30();
    var ua_variable_impl_1 = require_ua_variable_impl();
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    function getExtObjArrayNodeValue() {
      return new node_opcua_variant_1.Variant({
        arrayType: node_opcua_variant_3.VariantArrayType.Array,
        dataType: node_opcua_variant_2.DataType.ExtensionObject,
        value: this.$$extensionObjectArray
      });
    }
    function removeElementByIndex(uaArrayVariableNode, elementIndex) {
      const _array = uaArrayVariableNode.$$extensionObjectArray;
      (0, node_opcua_assert_1.assert)(typeof elementIndex === "number");
      const addressSpace = uaArrayVariableNode.addressSpace;
      const extObj = _array[elementIndex];
      const browseName = uaArrayVariableNode.$$getElementBrowseName(extObj, elementIndex);
      uaArrayVariableNode.$$extensionObjectArray.splice(elementIndex, 1);
      if (uaArrayVariableNode.$$extensionObjectArray !== uaArrayVariableNode.$dataValue.value.value) {
      }
      uaArrayVariableNode.touchValue();
      const node = uaArrayVariableNode.getComponentByName(browseName);
      if (!node) {
        throw new Error(" cannot find component ");
      }
      const hasComponent = uaArrayVariableNode.addressSpace.findReferenceType("HasComponent");
      uaArrayVariableNode.removeReference({
        isForward: true,
        nodeId: node.nodeId,
        referenceType: hasComponent.nodeId
      });
      const parents = node.findReferencesEx("HasChild", node_opcua_data_model_1.BrowseDirection.Inverse);
      if (parents.length === 0) {
        addressSpace.deleteNode(node.nodeId);
      }
    }
    function createExtObjArrayNode(parentFolder, options) {
      (0, node_opcua_assert_1.assert)(typeof options.variableType === "string");
      (0, node_opcua_assert_1.assert)(typeof options.indexPropertyName === "string");
      const addressSpace = parentFolder.addressSpace;
      const namespace = parentFolder.namespace;
      const complexVariableType = addressSpace.findVariableType(options.complexVariableType);
      if (!complexVariableType) {
        throw new Error("cannot find complex variable type");
      }
      (0, node_opcua_assert_1.assert)(!complexVariableType.nodeId.isEmpty());
      const variableType = addressSpace.findVariableType(options.variableType);
      if (!variableType) {
        throw new Error("cannot find variable Type");
      }
      (0, node_opcua_assert_1.assert)(!variableType.nodeId.isEmpty());
      const structure = addressSpace.findDataType("Structure");
      (0, node_opcua_assert_1.assert)(structure, "Structure Type not found: please check your nodeset file");
      const dataType = addressSpace.findDataType(variableType.dataType);
      if (!dataType) {
        errorLog(variableType.toString());
        throw new Error("cannot find Data Type");
      }
      (0, node_opcua_assert_1.assert)(dataType.isSubtypeOf(structure), "expecting a structure (= ExtensionObject) here ");
      const inner_options = {
        componentOf: parentFolder,
        browseName: options.browseName,
        dataType: dataType.nodeId,
        typeDefinition: complexVariableType.nodeId,
        value: { dataType: node_opcua_variant_2.DataType.ExtensionObject, value: [], arrayType: node_opcua_variant_3.VariantArrayType.Array },
        valueRank: 1
      };
      const uaArrayVariableNode = namespace.addVariable(inner_options);
      bindExtObjArrayNode(uaArrayVariableNode, options.variableType, options.indexPropertyName);
      return uaArrayVariableNode;
    }
    exports2.createExtObjArrayNode = createExtObjArrayNode;
    function _getElementBrowseName(extObj, index) {
      const indexPropertyName1 = this.$$indexPropertyName;
      if (!Object.prototype.hasOwnProperty.call(extObj, indexPropertyName1)) {
        warningLog(" extension object does not have ", indexPropertyName1, extObj);
      }
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(extObj, indexPropertyName1));
      const browseName = extObj[indexPropertyName1].toString();
      return browseName;
    }
    function bindExtObjArrayNode(uaArrayVariableNode, variableTypeNodeId, indexPropertyName) {
      (0, node_opcua_assert_1.assert)(uaArrayVariableNode.valueRank === 1, "expecting a one dimension array");
      const addressSpace = uaArrayVariableNode.addressSpace;
      const variableType = addressSpace.findVariableType(variableTypeNodeId);
      if (!variableType || variableType.nodeId.isEmpty()) {
        throw new Error("Cannot find VariableType " + variableTypeNodeId.toString());
      }
      const structure = addressSpace.findDataType("Structure");
      if (!structure) {
        throw new Error("Structure Type not found: please check your nodeset file");
      }
      let dataType = addressSpace.findDataType(variableType.dataType);
      if (!dataType) {
        throw new Error("Cannot find DataType " + variableType.dataType.toString());
      }
      (0, node_opcua_assert_1.assert)(dataType.isSubtypeOf(structure), "expecting a structure (= ExtensionObject) here ");
      (0, node_opcua_assert_1.assert)(!uaArrayVariableNode.$$variableType, "uaArrayVariableNode has already been bound !");
      uaArrayVariableNode.$$variableType = variableType;
      dataType = addressSpace.findDataType(variableType.dataType);
      (0, node_opcua_assert_1.assert)(dataType.isSubtypeOf(structure), "expecting a structure (= ExtensionObject) here ");
      (0, node_opcua_assert_1.assert)(!uaArrayVariableNode.$$extensionObjectArray, "UAVariable ExtensionObject array already bounded");
      uaArrayVariableNode.$$dataType = dataType;
      uaArrayVariableNode.$$extensionObjectArray = [];
      uaArrayVariableNode.$$indexPropertyName = indexPropertyName;
      uaArrayVariableNode.$$getElementBrowseName = _getElementBrowseName;
      uaArrayVariableNode.$dataValue.value.value = uaArrayVariableNode.$$extensionObjectArray;
      uaArrayVariableNode.$dataValue.value.arrayType = node_opcua_variant_3.VariantArrayType.Array;
      const bindOptions = {
        get: getExtObjArrayNodeValue,
        set: void 0
        // readonly
      };
      uaArrayVariableNode.bindVariable(bindOptions, true);
      return uaArrayVariableNode;
    }
    exports2.bindExtObjArrayNode = bindExtObjArrayNode;
    function addElement(options, uaArrayVariableNode) {
      (0, node_opcua_assert_1.assert)(uaArrayVariableNode, " must provide an UAVariable containing the array");
      (0, node_opcua_assert_1.assert)(!!uaArrayVariableNode.$$variableType && !!uaArrayVariableNode.$$dataType, "did you create the array Node with createExtObjArrayNode ?");
      (0, node_opcua_assert_1.assert)(uaArrayVariableNode.$$dataType.nodeClass === node_opcua_data_model_1.NodeClass.DataType);
      const addressSpace = uaArrayVariableNode.addressSpace;
      const Constructor = addressSpace.getExtensionObjectConstructor(uaArrayVariableNode.$$dataType);
      (0, node_opcua_assert_1.assert)(Constructor instanceof Function);
      let extensionObject;
      let elVar = null;
      let browseName;
      if (options instanceof ua_variable_impl_1.UAVariableImpl) {
        elVar = options;
        extensionObject = elVar.$extensionObject;
        (0, node_opcua_assert_1.assert)(extensionObject instanceof Constructor, "the provided variable must expose a Extension Object of the expected type ");
        uaArrayVariableNode.addReference({
          isForward: true,
          nodeId: elVar.nodeId,
          referenceType: "HasComponent"
        });
      } else {
        if (options instanceof node_opcua_extension_object_1.ExtensionObject) {
          extensionObject = options;
        } else {
          extensionObject = addressSpace.constructExtensionObject(uaArrayVariableNode.$$dataType, options);
        }
        const index = uaArrayVariableNode.$$extensionObjectArray?.length || 0;
        browseName = uaArrayVariableNode.$$getElementBrowseName(extensionObject, index);
        elVar = uaArrayVariableNode.$$variableType.instantiate({
          browseName,
          componentOf: uaArrayVariableNode.nodeId,
          value: { dataType: node_opcua_variant_2.DataType.ExtensionObject, value: extensionObject }
        });
        elVar.bindExtensionObject(extensionObject, { force: true });
      }
      if (uaArrayVariableNode.$$extensionObjectArray !== uaArrayVariableNode.$dataValue.value.value) {
      }
      uaArrayVariableNode.$$extensionObjectArray.push(elVar.$extensionObject);
      uaArrayVariableNode.touchValue();
      return elVar;
    }
    exports2.addElement = addElement;
    function removeElement(uaArrayVariableNode, element) {
      (0, node_opcua_assert_1.assert)(element, "removeElement: element must exist");
      const _array = uaArrayVariableNode.$$extensionObjectArray;
      if (_array.length === 0) {
        throw new Error(" cannot remove an element from an empty array ");
      }
      let elementIndex = -1;
      if (typeof element === "number") {
        elementIndex = element;
        (0, node_opcua_assert_1.assert)(elementIndex >= 0 && elementIndex < _array.length);
      } else if (typeof element === "function") {
        elementIndex = _array.findIndex(element);
      } else if (element && element.nodeClass) {
        const browseNameToFind = element.browseName.name.toString();
        elementIndex = _array.findIndex((obj, i) => {
          const browseName = uaArrayVariableNode.$$getElementBrowseName(obj, elementIndex).toString();
          return browseName === browseNameToFind;
        });
      } else {
        throw new Error("Unsupported anymore!!! please use a functor instead");
      }
      if (elementIndex < 0) {
        throw new Error("removeElement: cannot find element matching " + element.toString());
      }
      return removeElementByIndex(uaArrayVariableNode, elementIndex);
    }
    exports2.removeElement = removeElement;
  }
});

// node_modules/node-opcua-address-space/dist/src/nodeset_tools/nodeset_to_xml.js
var require_nodeset_to_xml = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/nodeset_tools/nodeset_to_xml.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.sortByBrowseName = void 0;
    var util_1 = require("util");
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_types_1 = require_dist32();
    var reference_impl_1 = require_reference_impl();
    var base_node_impl_1 = require_base_node_impl();
    var ua_reference_type_impl_1 = require_ua_reference_type_impl();
    var ua_object_type_impl_1 = require_ua_object_type_impl();
    var ua_variable_impl_1 = require_ua_variable_impl();
    var ua_object_impl_1 = require_ua_object_impl();
    var namespace_impl_1 = require_namespace_impl();
    var ua_method_impl_1 = require_ua_method_impl();
    var ua_data_type_impl_1 = require_ua_data_type_impl();
    var ua_variable_type_impl_1 = require_ua_variable_type_impl();
    var index_current_1 = require_index_current();
    var ua_view_impl_1 = require_ua_view_impl();
    var decode_xml_extension_object_1 = require_decode_xml_extension_object();
    var construct_namespace_dependency_1 = require_construct_namespace_dependency();
    var XMLWriter = require_xml_writer2();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var doDebug = false;
    function _hash(node) {
      return node.nodeId.toString();
    }
    function _dumpDisplayName(xw, node) {
      if (node.displayName && node.displayName[0]) {
        xw.startElement("DisplayName").text(node.displayName[0].text).endElement();
      }
    }
    function _dumpDescription(xw, node) {
      if (node.description && node.description.text && node.description.text.length) {
        let desc = node.description.text;
        desc = desc || "";
        xw.startElement("Description").text(desc).endElement();
      }
    }
    function translateNodeId(xw, nodeId) {
      (0, node_opcua_assert_1.assert)(nodeId instanceof node_opcua_nodeid_1.NodeId);
      const nn = xw.translationTable[nodeId.namespace];
      const translatedNode = new node_opcua_nodeid_1.NodeId(nodeId.identifierType, nodeId.value, nn);
      return translatedNode;
    }
    function n(xw, nodeId) {
      return translateNodeId(xw, nodeId).toString().replace("ns=0;", "");
    }
    function translateBrowseName(xw, browseName) {
      (0, node_opcua_assert_1.assert)(browseName instanceof node_opcua_data_model_1.QualifiedName);
      const nn = xw.translationTable[browseName.namespaceIndex];
      const translatedBrowseName = new node_opcua_data_model_1.QualifiedName({ namespaceIndex: nn, name: browseName.name });
      return translatedBrowseName;
    }
    function b(xw, browseName) {
      return translateBrowseName(xw, browseName).toString().replace("ns=0;", "");
    }
    function hasHigherPriorityThan(namespaceIndex1, namespaceIndex2, priorityTable) {
      const order1 = priorityTable[namespaceIndex1];
      const order2 = priorityTable[namespaceIndex2];
      return order1 > order2;
    }
    function _hasHigherPriorityThan(xw, namespaceIndex1, namespaceIndex2) {
      (0, node_opcua_assert_1.assert)(xw.priorityTable, "expecting a priorityTable");
      (0, node_opcua_assert_1.assert)(namespaceIndex1 < xw.priorityTable.length);
      (0, node_opcua_assert_1.assert)(namespaceIndex2 < xw.priorityTable.length);
      return hasHigherPriorityThan(namespaceIndex1, namespaceIndex2, xw.priorityTable);
    }
    function _dumpReferences(xw, node) {
      xw.startElement("References");
      const addressSpace = node.addressSpace;
      const aggregateReferenceType = addressSpace.findReferenceType("Aggregates");
      const hasSubtypeReferenceType = addressSpace.findReferenceType("HasSubtype");
      const hasTypeDefinitionReferenceType = addressSpace.findReferenceType("HasTypeDefinition");
      const nonHierarchicalReferencesType = addressSpace.findReferenceType("NonHierarchicalReferences");
      const organizesReferencesType = addressSpace.findReferenceType("Organizes");
      const connectsToReferenceType = addressSpace.findReferenceType("ConnectsTo");
      const hasEventSourceReferenceType = addressSpace.findReferenceType("HasEventSource");
      function referenceToKeep(reference) {
        const referenceType = reference._referenceType;
        const targetedNamespaceIndex = reference.nodeId.namespace;
        if (_hasHigherPriorityThan(xw, targetedNamespaceIndex, node.nodeId.namespace)) {
          return false;
        }
        if (referenceType.isSubtypeOf(aggregateReferenceType) && !reference.isForward) {
          if (reference.nodeId.namespace !== node.nodeId.namespace) {
            return true;
          }
        }
        if (referenceType.isSubtypeOf(hasSubtypeReferenceType) && reference.isForward) {
        }
        if (referenceType.isSubtypeOf(aggregateReferenceType) && reference.isForward) {
          return true;
        } else if (referenceType.isSubtypeOf(hasSubtypeReferenceType) && !reference.isForward) {
          return true;
        } else if (referenceType.isSubtypeOf(hasTypeDefinitionReferenceType) && reference.isForward) {
          return true;
        } else if (referenceType.isSubtypeOf(nonHierarchicalReferencesType) && reference.isForward) {
          return true;
        } else if (referenceType.isSubtypeOf(organizesReferencesType) && !reference.isForward) {
          return true;
        } else if (connectsToReferenceType && referenceType.isSubtypeOf(connectsToReferenceType) && reference.isForward) {
          return true;
        } else if (referenceType.isSubtypeOf(hasEventSourceReferenceType) && reference.isForward) {
          return true;
        }
        return false;
      }
      const allReferences = node.allReferences();
      const references = allReferences.filter(referenceToKeep);
      for (const reference of references.sort(sortByNodeId)) {
        if ((0, base_node_impl_1.getReferenceType)(reference).browseName.toString() === "HasSubtype" && reference.isForward) {
          continue;
        }
        xw.startElement("Reference");
        xw.writeAttribute("ReferenceType", b(xw, (0, base_node_impl_1.getReferenceType)(reference).browseName));
        if (!reference.isForward) {
          xw.writeAttribute("IsForward", reference.isForward ? "true" : "false");
        }
        xw.text(n(xw, reference.nodeId));
        xw.endElement();
      }
      xw.endElement();
    }
    function _dumpLocalizedText(xw, v) {
      if (v.locale && v.locale.length) {
        xw.startElement("Locale");
        xw.text(v.locale);
        xw.endElement();
      }
      xw.startElement("Text");
      if (v.text) {
        xw.text(v.text);
      }
      xw.endElement();
    }
    function _dumpQualifiedName(xw, v) {
      const t = translateBrowseName(xw, v);
      if (t.name) {
        xw.startElement("Name");
        xw.text(t.name);
        xw.endElement();
      }
      if (t.namespaceIndex) {
        xw.startElement("NamespaceIndex");
        xw.text(t.namespaceIndex.toString());
        xw.endElement();
      }
    }
    function _dumpXmlElement(xw, v) {
      xw.text(v);
    }
    function initXmlWriterEx(xw, map, namespaceArray) {
      const xwe = xw;
      xwe.map = map;
      xwe.stackMap = [];
      xwe.namespaceArray = namespaceArray;
    }
    function findXsdNamespaceUri(xw, nodeId) {
      const xwe = xw;
      if (!xwe.namespaceArray) {
        return "";
      }
      const namespace = xwe.namespaceArray[nodeId.namespace];
      if (namespace === "http://opcfoundation.org/UA/") {
        return "http://opcfoundation.org/UA/2008/02/Types.xsd";
      }
      if (!namespace) {
        return "";
      }
      return namespace.replace(/\/$/, "") + "/Types.xsd";
    }
    function getPrefix(xw, namespace) {
      const xwe = xw;
      if (!xwe.map)
        return "";
      const p3 = xwe.map[namespace] || "";
      return p3 ? p3 + ":" : "";
    }
    function restoreDefaultNamespace(xw) {
      const xwe = xw;
      if (!xwe.map)
        return;
      xwe.map = xwe.stackMap.pop();
    }
    function setDefaultNamespace(xw, namespace) {
      const xwe = xw;
      if (!xwe.map)
        return;
      if (xwe.map[namespace] !== "") {
        xw.writeAttribute("xmlns", namespace);
      }
      xwe.stackMap.push({
        ...xwe.map
      });
      xwe.map[namespace] = "";
    }
    function startElementEx(xw, ns, name, defaultNamespace) {
      const xwe = xw;
      xw.startElement(name);
      setDefaultNamespace(xw, defaultNamespace);
    }
    function _dumpNodeId(xw, v) {
      const xmlns = getPrefix(xw, "http://opcfoundation.org/UA/2008/02/Types.xsd");
      xw.startElement(`${xmlns}Identifier`);
      xw.text(n(xw, v));
      xw.endElement();
    }
    function _dumpVariantValue(xw, dataType, node, value) {
      const dataTypeNode = node.addressSpace.findDataType(node.dataType);
      if (value === void 0 || value === null) {
        return;
      }
      if (dataType === node_opcua_variant_1.DataType.Null) {
        return;
      }
      const uax = getPrefix(xw, "http://opcfoundation.org/UA/2008/02/Types.xsd");
      xw.startElement(`${uax}${node_opcua_variant_1.DataType[dataType]}`);
      const definitionMap = (0, decode_xml_extension_object_1.makeDefinitionMap)(node.addressSpace);
      _dumpVariantInnerValue(xw, dataType, dataTypeNode.nodeId, definitionMap, value);
      xw.endElement();
    }
    function _dumpVariantInnerExtensionObject(xw, definitionMap, definition, value) {
      const namespaceUri = findXsdNamespaceUri(xw, definition.defaultEncodingId);
      const ns = getPrefix(xw, namespaceUri);
      for (const field of definition.fields || []) {
        const dataTypeNodeId = field.dataType;
        const fieldName = field.name;
        const lowerFieldName = (0, node_opcua_utils_1.lowerFirstLetter)(fieldName);
        const v = value[lowerFieldName];
        if (v !== null && v !== void 0) {
          if (dataTypeNodeId.namespace === 0 && dataTypeNodeId.value === 0 && dataTypeNodeId.identifierType === node_opcua_nodeid_1.NodeIdType.NUMERIC) {
            continue;
          }
          const { name, definition: definition2 } = definitionMap.findDefinition(dataTypeNodeId);
          startElementEx(xw, ns, fieldName, namespaceUri);
          let fun = (value2) => {
          };
          if (definition2 instanceof node_opcua_types_1.StructureDefinition) {
            fun = _dumpVariantInnerExtensionObject.bind(null, xw, definitionMap, definition2);
          } else if (definition2 instanceof node_opcua_types_1.EnumDefinition) {
            fun = _dumpVariantInnerValueEnum.bind(null, xw, definition2);
          } else {
            const baseType = definition2.dataType;
            fun = _dumpVariantInnerValue.bind(null, xw, baseType, dataTypeNodeId, definitionMap);
          }
          try {
            if (field.valueRank === -1) {
              fun(v);
            } else {
              for (const arrayItem of v) {
                xw.startElement(name);
                fun(arrayItem);
                xw.endElement();
              }
            }
          } catch (err) {
            if (util_1.types.isNativeError(err)) {
              errorLog("Error in _dumpVariantExtensionObjectValue_Body !!!", err.message);
            }
            debugLog(name);
            debugLog(field);
          }
          restoreDefaultNamespace(xw);
          xw.endElement();
        }
      }
    }
    function _dumpVariantInnerValueEnum(xw, definition, value) {
      if (!definition.fields) {
        return;
      }
      const field = definition.fields.find((f2) => f2.value[1] === value || f2.name === value);
      xw.text(`${field?.name}_${field?.value[1]}`);
    }
    function _dumpVariantInnerValue(xw, dataType, dataTypeNodeId, definitionMap, value) {
      const uax = getPrefix(xw, "http://opcfoundation.org/UA/2008/02/Types.xsd");
      switch (dataType) {
        case null:
        case node_opcua_variant_1.DataType.Null:
          break;
        case node_opcua_variant_1.DataType.LocalizedText:
          _dumpLocalizedText(xw, value);
          break;
        case node_opcua_variant_1.DataType.QualifiedName:
          _dumpQualifiedName(xw, value);
          break;
        case node_opcua_variant_1.DataType.NodeId:
          _dumpNodeId(xw, value);
          break;
        case node_opcua_variant_1.DataType.DateTime:
          xw.text(value.toISOString());
          break;
        case node_opcua_variant_1.DataType.Int64:
        case node_opcua_variant_1.DataType.UInt64:
          xw.text(value[1].toString());
          break;
        case node_opcua_variant_1.DataType.Boolean:
        case node_opcua_variant_1.DataType.SByte:
        case node_opcua_variant_1.DataType.Byte:
        case node_opcua_variant_1.DataType.Float:
        case node_opcua_variant_1.DataType.Double:
        case node_opcua_variant_1.DataType.Int16:
        case node_opcua_variant_1.DataType.Int32:
        case node_opcua_variant_1.DataType.UInt16:
        case node_opcua_variant_1.DataType.UInt32:
        case node_opcua_variant_1.DataType.String:
          xw.text(value.toString());
          break;
        case node_opcua_variant_1.DataType.ByteString:
          {
            const base64 = value.toString("base64");
            xw.text(base64.length > 80 ? base64.match(/.{0,80}/g).join("\n") : base64);
          }
          break;
        case node_opcua_variant_1.DataType.Guid:
          if (value !== void 0 && value !== null) {
            xw.startElement(`${uax}String`);
            xw.text(value.toString());
            xw.endElement();
          }
          break;
        case node_opcua_variant_1.DataType.ExtensionObject:
          _dumpVariantExtensionObjectValue(xw, dataTypeNodeId, definitionMap, value);
          break;
        case node_opcua_variant_1.DataType.XmlElement:
          _dumpXmlElement(xw, value);
          break;
        case node_opcua_variant_1.DataType.StatusCode:
          xw.text(value.value.toString());
          break;
        default:
          errorLog("_dumpVariantInnerValue incomplete " + value + " DataType=" + dataType + "=" + node_opcua_variant_1.DataType[dataType]);
      }
    }
    function _dumpVariantExtensionObjectValue_Body(xw, definitionMap, name, definition, value) {
      if (value) {
        const namespaceUri = findXsdNamespaceUri(xw, definition.defaultEncodingId);
        const ns = getPrefix(xw, namespaceUri);
        startElementEx(xw, ns, `${name}`, namespaceUri);
        if (value) {
          _dumpVariantInnerExtensionObject(xw, definitionMap, definition, value);
        }
        restoreDefaultNamespace(xw);
        xw.endElement();
      }
    }
    function _dumpVariantExtensionObjectValue(xw, dataTypeNodeId, definitionMap, value) {
      const { name, definition } = definitionMap.findDefinition(dataTypeNodeId);
      const encodingDefaultXml = value.schema.encodingDefaultXml;
      if (!encodingDefaultXml || encodingDefaultXml.isEmpty()) {
        warningLog("dataType Name ", name, "with ", dataTypeNodeId.toString(), " does not have xml encoding");
        return;
      }
      const uax = getPrefix(xw, "http://opcfoundation.org/UA/2008/02/Types.xsd");
      startElementEx(xw, uax, `ExtensionObject`, "http://opcfoundation.org/UA/2008/02/Types.xsd");
      {
        const uax2 = getPrefix(xw, "http://opcfoundation.org/UA/2008/02/Types.xsd");
        xw.startElement(`${uax2}TypeId`);
        {
          xw.startElement(`${uax2}Identifier`);
          xw.text(n(xw, encodingDefaultXml));
          xw.endElement();
        }
        xw.endElement();
        startElementEx(xw, uax2, "Body", "http://opcfoundation.org/UA/2008/02/Types.xsd");
        _dumpVariantExtensionObjectValue_Body(xw, definitionMap, name, definition, value);
        restoreDefaultNamespace(xw);
        xw.endElement();
      }
      restoreDefaultNamespace(xw);
      xw.endElement();
    }
    function _dumpVariantExtensionObjectValue2(xw, addressSpace, value) {
      const dataTypeNodeId = value.schema.dataTypeNodeId;
      const definitionMap = (0, decode_xml_extension_object_1.makeDefinitionMap)(addressSpace);
      const dataTypeNode = addressSpace.findDataType(dataTypeNodeId);
      if (!dataTypeNode) {
        warningLog("_dumpVariantExtensionObjectValue2: Cannot find dataType for  ", dataTypeNodeId.toString());
        return;
      }
      _dumpVariantExtensionObjectValue(xw, dataTypeNode.nodeId, definitionMap, value);
    }
    function _isDefaultValue(value) {
      if (value.arrayType === node_opcua_variant_1.VariantArrayType.Scalar) {
        switch (value.dataType) {
          case node_opcua_variant_1.DataType.ExtensionObject:
            if (!value.value) {
              return true;
            }
            break;
          case node_opcua_variant_1.DataType.DateTime:
            if (!value.value || value.value.getTime() === node_opcua_basic_types_1.minOPCUADate) {
              return true;
            }
            break;
          case node_opcua_variant_1.DataType.ByteString:
            if (!value.value || value.value.length === 0) {
              return true;
            }
            break;
          case node_opcua_variant_1.DataType.Boolean:
            return false;
          case node_opcua_variant_1.DataType.SByte:
          case node_opcua_variant_1.DataType.Byte:
          case node_opcua_variant_1.DataType.UInt16:
          case node_opcua_variant_1.DataType.UInt32:
          case node_opcua_variant_1.DataType.Int16:
          case node_opcua_variant_1.DataType.Int32:
          case node_opcua_variant_1.DataType.Double:
          case node_opcua_variant_1.DataType.Float:
            if (value.value === 0 || value.value === null) {
              return true;
            }
            break;
          case node_opcua_variant_1.DataType.String:
            if (value.value === null || value.value === "") {
              return true;
            }
            break;
          case node_opcua_variant_1.DataType.Int64:
          case node_opcua_variant_1.DataType.UInt64:
            if (0 === coerceInt64ToInt32(value.value)) {
              return true;
            }
            break;
          case node_opcua_variant_1.DataType.LocalizedText:
            if (!value.value) {
              return true;
            }
            {
              const l2 = value.value;
              if (!l2.locale && !l2.text) {
                return true;
              }
            }
            break;
        }
        return false;
      } else {
        if (!value.value || value.value.length === 0) {
          return true;
        }
        return false;
      }
    }
    function _dumpValue(xw, node, variant) {
      const addressSpace = node.addressSpace;
      if (variant === null || variant === void 0) {
        return;
      }
      (0, node_opcua_assert_1.assert)(variant instanceof node_opcua_variant_1.Variant);
      const dataTypeNode = addressSpace.findDataType(node.dataType);
      if (!dataTypeNode) {
        debugLog("Cannot find dataType:", node.dataType.toString());
        return;
      }
      const dataTypeName = dataTypeNode.browseName.name.toString();
      const baseDataTypeName = node_opcua_variant_1.DataType[variant.dataType];
      if (baseDataTypeName === "Null") {
        return;
      }
      (0, node_opcua_assert_1.assert)(typeof baseDataTypeName === "string");
      const isExtensionObject = variant.dataType === node_opcua_variant_1.DataType.ExtensionObject;
      if (_isDefaultValue(variant)) {
        return;
      }
      xw.startElement("Value");
      const uax = getPrefix(xw, "http://opcfoundation.org/UA/2008/02/Types.xsd");
      if (isExtensionObject) {
        const encodeXml = _dumpVariantExtensionObjectValue2.bind(null, xw, node.addressSpace);
        switch (variant.arrayType) {
          case node_opcua_variant_1.VariantArrayType.Matrix:
          case node_opcua_variant_1.VariantArrayType.Array:
            startElementEx(xw, uax, `ListOf${baseDataTypeName}`, "http://opcfoundation.org/UA/2008/02/Types.xsd");
            variant.value.forEach(encodeXml);
            restoreDefaultNamespace(xw);
            xw.endElement();
            break;
          case node_opcua_variant_1.VariantArrayType.Scalar:
            encodeXml(variant.value);
            break;
          default:
            errorLog(node.toString());
            errorLog("_dumpValue : unsupported arrayType: ", variant.arrayType);
        }
      } else {
        const encodeXml = _dumpVariantValue.bind(null, xw, variant.dataType, node);
        switch (variant.arrayType) {
          case node_opcua_variant_1.VariantArrayType.Matrix:
          case node_opcua_variant_1.VariantArrayType.Array:
            startElementEx(xw, uax, `ListOf${dataTypeName}`, "http://opcfoundation.org/UA/2008/02/Types.xsd");
            variant.value.forEach(encodeXml);
            restoreDefaultNamespace(xw);
            xw.endElement();
            break;
          case node_opcua_variant_1.VariantArrayType.Scalar:
            encodeXml(variant.value);
            break;
          default:
            errorLog(node.toString());
            errorLog("_dumpValue : unsupported arrayType: ", variant.arrayType);
        }
      }
      xw.endElement();
    }
    function _dumpArrayDimensionsAttribute(xw, node) {
      if (node.arrayDimensions) {
        if (node.valueRank === -1 || node.arrayDimensions.length === 1 && node.arrayDimensions[0] === 0) {
          return;
        }
        xw.writeAttribute("ArrayDimensions", node.arrayDimensions.join(","));
      }
    }
    function dumpNodeInXml(xw, node) {
      return node.dumpXML(xw);
    }
    function dumpReferencedNodes(xw, node, forward) {
      const addressSpace = node.addressSpace;
      if (!forward) {
        {
          const r = node.findReferencesEx("HasTypeDefinition");
          if (r && r.length) {
            (0, node_opcua_assert_1.assert)(r.length === 1);
            const typeDefinitionObj = reference_impl_1.ReferenceImpl.resolveReferenceNode(addressSpace, r[0]);
            if (!typeDefinitionObj) {
              warningLog(node.toString());
              warningLog("dumpReferencedNodes: Warning : " + node.browseName.toString() + " unknown typeDefinition, ", r[0].toString());
            } else {
              (0, node_opcua_assert_1.assert)(typeDefinitionObj instanceof base_node_impl_1.BaseNodeImpl);
              if (typeDefinitionObj.nodeId.namespace === node.nodeId.namespace) {
                if (!xw.visitedNode[_hash(typeDefinitionObj)]) {
                  dumpNodeInXml(xw, typeDefinitionObj);
                }
              }
            }
          }
        }
        {
          const r = node.findReferencesEx("HasSubtype", node_opcua_data_model_1.BrowseDirection.Inverse);
          if (r && r.length) {
            const subTypeOf = reference_impl_1.ReferenceImpl.resolveReferenceNode(addressSpace, r[0]);
            (0, node_opcua_assert_1.assert)(r.length === 1);
            if (subTypeOf.nodeId.namespace === node.nodeId.namespace) {
              if (!xw.visitedNode[_hash(subTypeOf)]) {
                dumpNodeInXml(xw, subTypeOf);
              }
            }
          }
        }
      } else {
        const r = node.findReferencesEx("Aggregates", node_opcua_data_model_1.BrowseDirection.Forward);
        for (const reference of r) {
          const nodeChild = reference_impl_1.ReferenceImpl.resolveReferenceNode(addressSpace, reference);
          (0, node_opcua_assert_1.assert)(nodeChild instanceof base_node_impl_1.BaseNodeImpl);
          if (nodeChild.nodeId.namespace === node.nodeId.namespace) {
            if (!xw.visitedNode[_hash(nodeChild)]) {
              debugLog(node.nodeId.toString(), " dumping child ", nodeChild.browseName.toString(), nodeChild.nodeId.toString());
              dumpNodeInXml(xw, nodeChild);
            }
          }
        }
      }
    }
    function getParent(node) {
      if (node instanceof ua_variable_impl_1.UAVariableImpl || node instanceof ua_method_impl_1.UAMethodImpl || node instanceof ua_object_impl_1.UAObjectImpl) {
        return node.parent;
      }
      return null;
    }
    var currentReadFlag = (0, node_opcua_data_model_1.makeAccessLevelFlag)("CurrentRead");
    function dumpCommonAttributes(xw, node) {
      xw.writeAttribute("NodeId", n(xw, node.nodeId));
      xw.writeAttribute("BrowseName", b(xw, node.browseName));
      const parentNode = getParent(node);
      if (parentNode) {
        if (parentNode.nodeId.namespace <= node.nodeId.namespace) {
          xw.writeAttribute("ParentNodeId", n(xw, parentNode.nodeId));
        }
      }
      if (Object.prototype.hasOwnProperty.call(node, "symbolicName")) {
        xw.writeAttribute("SymbolicName", node.symbolicName);
      }
      if (Object.prototype.hasOwnProperty.call(node, "isAbstract")) {
        if (node.isAbstract) {
          xw.writeAttribute("IsAbstract", node.isAbstract ? "true" : "false");
        }
      }
      if (Object.prototype.hasOwnProperty.call(node, "accessLevel")) {
        if (node.accessLevel !== currentReadFlag) {
          xw.writeAttribute("AccessLevel", node.accessLevel.toString());
        }
      }
      if (Object.prototype.hasOwnProperty.call(node, "minimumSamplingInterval")) {
        const minimumSamplingInterval = node.minimumSamplingInterval;
        if (minimumSamplingInterval > 0) {
          xw.writeAttribute("MinimumSamplingInterval", minimumSamplingInterval);
        }
      }
    }
    function dumpCommonElements(xw, node) {
      _dumpDisplayName(xw, node);
      _dumpDescription(xw, node);
      _dumpReferences(xw, node);
    }
    function coerceInt64ToInt32(int64) {
      if (typeof int64 === "number") {
        return int64;
      }
      if (int64[0] === 4294967295 && int64[1] === 4294967295) {
        return 4294967295;
      }
      if (int64[0] !== 0) {
        warningLog("coerceInt64ToInt32 , loosing high word in conversion");
      }
      return int64[1];
    }
    function _dumpEnumDefinition(xw, enumDefinition) {
      enumDefinition.fields = enumDefinition.fields || [];
      for (const defItem of enumDefinition.fields) {
        xw.startElement("Field");
        xw.writeAttribute("Name", defItem.name);
        if (!(0, node_opcua_utils_1.isNullOrUndefined)(defItem.value)) {
          xw.writeAttribute("Value", coerceInt64ToInt32(defItem.value));
        }
        _dumpDescription(xw, defItem);
        xw.endElement();
      }
    }
    function _dumpStructureDefinition(xw, structureDefinition, baseStructureDefinition) {
      const fields = structureDefinition.fields || [];
      const nbFieldsInBase = baseStructureDefinition ? baseStructureDefinition.fields?.length || 0 : 0;
      for (let index = nbFieldsInBase; index < fields.length; index++) {
        const defItem = fields[index];
        xw.startElement("Field");
        xw.writeAttribute("Name", defItem.name);
        if (defItem.arrayDimensions) {
          xw.writeAttribute("ArrayDimensions", defItem.arrayDimensions.map((x2) => x2.toString()).join(","));
        }
        if (defItem.valueRank !== void 0 && defItem.valueRank !== -1) {
          xw.writeAttribute("ValueRank", defItem.valueRank);
        }
        if (defItem.isOptional) {
          xw.writeAttribute("IsOptional", defItem.isOptional.toString());
        }
        if (defItem.maxStringLength !== void 0 && defItem.maxStringLength !== 0) {
          xw.writeAttribute("MaxStringLength", defItem.maxStringLength);
        }
        if (defItem.dataType) {
          xw.writeAttribute("DataType", n(xw, defItem.dataType));
        }
        _dumpDescription(xw, defItem);
        xw.endElement();
      }
    }
    function _dumpEncoding(xw, uaEncoding) {
      const uaDescription = uaEncoding.findReferencesAsObject("HasDescription")[0];
      if (uaDescription) {
        dumpUAVariable(xw, uaDescription);
      }
      _dumpUAObject(xw, uaEncoding);
    }
    function _dumpEncodings(xw, uaDataType) {
      const encodings = uaDataType.findReferencesExAsObject("HasEncoding", node_opcua_data_model_1.BrowseDirection.Forward);
      for (const uaEncoding of encodings) {
        if (uaEncoding.nodeClass !== node_opcua_data_model_1.NodeClass.Object) {
          continue;
        }
        _dumpEncoding(xw, uaEncoding);
      }
    }
    function _dumpUADataTypeDefinition(xw, uaDataType) {
      const uaDataTypeBase = uaDataType.subtypeOfObj;
      if (uaDataType.isEnumeration()) {
        xw.startElement("Definition");
        xw.writeAttribute("Name", b(xw, uaDataType.browseName));
        _dumpEnumDefinition(xw, uaDataType.getEnumDefinition());
        xw.endElement();
        return;
      }
      if (uaDataType.isStructure()) {
        const dataValue = uaDataType.readAttribute(index_current_1.SessionContext.defaultContext, node_opcua_basic_types_1.AttributeIds.DataTypeDefinition);
        if (true) {
          const definition = uaDataType.getStructureDefinition();
          const baseDefinition = uaDataTypeBase ? uaDataTypeBase.getStructureDefinition() : null;
          xw.startElement("Definition");
          xw.writeAttribute("Name", b(xw, uaDataType.browseName));
          if (definition.structureType === node_opcua_types_1.StructureType.Union) {
            xw.writeAttribute("IsUnion", "true");
          }
          _dumpStructureDefinition(xw, definition, baseDefinition);
          xw.endElement();
        }
        return;
      }
    }
    function dumpUAView(xw, node) {
      _markAsVisited(xw, node);
      xw.startElement("UAView");
      xw.writeAttribute("NodeId", n(xw, node.nodeId));
      xw.writeAttribute("BrowseName", b(xw, node.browseName));
      dumpCommonElements(xw, node);
      xw.endElement();
      dumpAggregates(xw, node);
    }
    function dumpUADataType(xw, node) {
      _markAsVisited(xw, node);
      xw.startElement("UADataType");
      xw.writeAttribute("NodeId", n(xw, node.nodeId));
      xw.writeAttribute("BrowseName", b(xw, node.browseName));
      if (node.symbolicName !== node.browseName.name) {
        xw.writeAttribute("SymbolicName", node.symbolicName);
      }
      if (node.isAbstract) {
        xw.writeAttribute("IsAbstract", node.isAbstract ? "true" : "false");
      }
      dumpCommonElements(xw, node);
      _dumpUADataTypeDefinition(xw, node);
      xw.endElement();
      _dumpEncodings(xw, node);
      dumpAggregates(xw, node);
    }
    function _markAsVisited(xw, node) {
      xw.visitedNode = xw.visitedNode || {};
      (0, node_opcua_assert_1.assert)(!xw.visitedNode[_hash(node)]);
      xw.visitedNode[_hash(node)] = 1;
    }
    function dumpUAVariable(xw, node) {
      (0, node_opcua_assert_1.assert)(node.nodeClass === node_opcua_data_model_1.NodeClass.Variable);
      if (xw.visitedNode[_hash(node)]) {
        return;
      }
      _markAsVisited(xw, node);
      dumpReferencedNodes(xw, node, false);
      const addressSpace = node.addressSpace;
      xw.startElement("UAVariable");
      {
        dumpCommonAttributes(xw, node);
        if (node.valueRank !== -1) {
          xw.writeAttribute("ValueRank", node.valueRank);
        }
        _dumpArrayDimensionsAttribute(xw, node);
        const dataTypeNode = addressSpace.findNode(node.dataType);
        if (dataTypeNode) {
          const dataTypeName = b(xw, resolveDataTypeName(addressSpace, dataTypeNode.nodeId));
          xw.writeAttribute("DataType", dataTypeName);
        }
      }
      {
        dumpCommonElements(xw, node);
        const value = node.$dataValue.value;
        if (value) {
          _dumpValue(xw, node, value);
        }
      }
      xw.endElement();
      dumpAggregates(xw, node);
    }
    function dumpUAVariableType(xw, node) {
      (0, node_opcua_assert_1.assert)(node.nodeClass === node_opcua_data_model_1.NodeClass.VariableType);
      xw.visitedNode = xw.visitedNode || {};
      (0, node_opcua_assert_1.assert)(!xw.visitedNode[_hash(node)]);
      xw.visitedNode[_hash(node)] = 1;
      dumpReferencedNodes(xw, node, false);
      const addressSpace = node.addressSpace;
      xw.startElement("UAVariableType");
      {
        dumpCommonAttributes(xw, node);
        if (node.valueRank !== -1) {
          xw.writeAttribute("ValueRank", node.valueRank);
        }
        const dataTypeNode = addressSpace.findNode(node.dataType);
        if (!dataTypeNode) {
          debugLog(" cannot find datatype " + node.dataType + " for node " + node.browseName.toString() + " id =" + node.nodeId.toString());
        } else {
          const dataTypeName = b(xw, resolveDataTypeName(addressSpace, dataTypeNode.nodeId));
          xw.writeAttribute("DataType", dataTypeName);
        }
      }
      {
        _dumpArrayDimensionsAttribute(xw, node);
        dumpCommonElements(xw, node);
        const value = node.value;
        if (value) {
          _dumpValue(xw, node, value);
        }
      }
      xw.endElement();
      dumpAggregates(xw, node);
    }
    function dumpUAObject(xw, node) {
      xw.writeComment("Object - " + b(xw, node.browseName) + " {{{{ ");
      _dumpUAObject(xw, node);
      xw.writeComment("Object - " + b(xw, node.browseName) + " }}}} ");
    }
    function _dumpUAObject(xw, node) {
      (0, node_opcua_assert_1.assert)(node.nodeClass === node_opcua_data_model_1.NodeClass.Object);
      xw.visitedNode = xw.visitedNode || {};
      (0, node_opcua_assert_1.assert)(!xw.visitedNode[_hash(node)]);
      xw.visitedNode[_hash(node)] = 1;
      dumpReferencedNodes(xw, node, false);
      xw.startElement("UAObject");
      dumpCommonAttributes(xw, node);
      dumpCommonElements(xw, node);
      xw.endElement();
      dumpAggregates(xw, node);
      dumpElementInFolder(xw, node);
    }
    function dumpElementInFolder(xw, node) {
      const aggregates = node.getFolderElements().sort((x2, y) => x2.browseName.name.toString() > y.browseName.name.toString() ? 1 : -1);
      for (const aggregate of aggregates.sort(sortByNodeId)) {
        if (node.nodeId.namespace !== aggregate.nodeId.namespace) {
          return;
        }
        if (!xw.visitedNode[_hash(aggregate)]) {
          aggregate.dumpXML(xw);
        }
      }
    }
    function dumpAggregates(xw, node) {
      const aggregates = node.getAggregates().sort(sortByBrowseName);
      for (const aggregate of aggregates.sort(sortByNodeId)) {
        if (node.nodeId.namespace !== aggregate.nodeId.namespace) {
          continue;
        }
        if (_hasHigherPriorityThan(xw, aggregate.nodeId.namespace, node.nodeId.namespace)) {
          continue;
        }
        if (!xw.visitedNode[_hash(aggregate)]) {
          aggregate.dumpXML(xw);
        }
      }
    }
    function dumpUAObjectType(xw, node) {
      (0, node_opcua_assert_1.assert)(node.nodeClass === node_opcua_data_model_1.NodeClass.ObjectType);
      (0, node_opcua_assert_1.assert)(node instanceof ua_object_type_impl_1.UAObjectTypeImpl);
      xw.writeComment("ObjectType - " + b(xw, node.browseName) + " {{{{ ");
      _markAsVisited(xw, node);
      dumpReferencedNodes(xw, node, false);
      xw.startElement("UAObjectType");
      dumpCommonAttributes(xw, node);
      dumpCommonElements(xw, node);
      xw.endElement();
      dumpAggregates(xw, node);
      xw.writeComment("ObjectType - " + b(xw, node.browseName) + " }}}}");
    }
    function dumpUAMethod(xw, node) {
      (0, node_opcua_assert_1.assert)(node.nodeClass === node_opcua_data_model_1.NodeClass.Method);
      _markAsVisited(xw, node);
      dumpReferencedNodes(xw, node, false);
      xw.startElement("UAMethod");
      dumpCommonAttributes(xw, node);
      if (node.methodDeclarationId) {
        xw.writeAttribute("MethodDeclarationId", n(xw, node.methodDeclarationId));
      }
      dumpCommonElements(xw, node);
      xw.endElement();
      dumpAggregates(xw, node);
    }
    function resolveDataTypeName(addressSpace, dataType) {
      let dataTypeNode = null;
      if (typeof dataType === "string") {
        dataTypeNode = addressSpace.findDataType(dataType);
      } else {
        (0, node_opcua_assert_1.assert)(dataType instanceof node_opcua_nodeid_1.NodeId);
        const o2 = addressSpace.findNode(dataType.toString());
        dataTypeNode = o2 ? o2 : null;
      }
      if (!dataTypeNode) {
        errorLog("resolveDataTypeName: warning cannot find DataType " + dataType.toString());
        return new node_opcua_data_model_1.QualifiedName({ name: "", namespaceIndex: 0 });
      }
      return dataTypeNode.browseName;
    }
    function buildUpAliases(node, xw, data) {
      const addressSpace = node.addressSpace;
      if (!data.aliases_visited)
        data.aliases_visited = {};
      const k = _hash(node);
      if (data.aliases_visited[k]) {
        return;
      }
      data.aliases_visited[k] = 1;
      if (node.nodeClass === node_opcua_data_model_1.NodeClass.Variable || node.nodeClass === node_opcua_data_model_1.NodeClass.VariableType) {
        const nodeV = node;
        if (nodeV.dataType && nodeV.dataType.namespace === 0 && nodeV.dataType.value !== 0) {
          const dataTypeName = b(xw, resolveDataTypeName(addressSpace, nodeV.dataType));
          if (dataTypeName) {
            if (!data.aliases[dataTypeName]) {
              data.aliases[dataTypeName] = n(xw, nodeV.dataType);
            }
          }
        }
        if (nodeV.dataType && nodeV.dataType.namespace !== 0 && nodeV.dataType.value !== 0) {
          const dataTypeName = b(xw, resolveDataTypeName(addressSpace, nodeV.dataType));
          if (dataTypeName) {
            if (!data.aliases[dataTypeName]) {
              data.aliases[dataTypeName] = n(xw, nodeV.dataType);
            }
          }
        }
      }
      function collectReferenceNameInAlias(reference) {
        const key = b(xw, (0, base_node_impl_1.getReferenceType)(reference).browseName);
        if (!data.aliases.key) {
          if (reference.referenceType.namespace === 0) {
            data.aliases[key] = reference.referenceType.toString().replace("ns=0;", "");
          } else {
            data.aliases[key] = n(xw, reference.referenceType);
          }
        }
      }
      node.allReferences().forEach(collectReferenceNameInAlias);
    }
    function writeAliases(xw, aliases) {
      xw.startElement("Aliases");
      if (aliases) {
        const keys = Object.keys(aliases).sort();
        for (const key of keys) {
          xw.startElement("Alias");
          xw.writeAttribute("Alias", key);
          xw.text(aliases[key].toString().replace(/ns=0;/, ""));
          xw.endElement();
        }
      }
      xw.endElement();
    }
    function dumpReferenceType(xw, referenceType) {
      _markAsVisited(xw, referenceType);
      xw.startElement("UAReferenceType");
      dumpCommonAttributes(xw, referenceType);
      const isSymmetric = !referenceType.inverseName || referenceType.inverseName?.text === referenceType.browseName?.name;
      if (isSymmetric) {
        xw.writeAttribute("Symmetric", "true");
      }
      dumpCommonElements(xw, referenceType);
      if (!isSymmetric) {
        xw.startElement("InverseName");
        xw.text(referenceType.inverseName.text || "");
        xw.endElement();
      }
      xw.endElement();
    }
    function sortByBrowseName(x2, y) {
      const x_str = x2.browseName.toString();
      const y_str = y.browseName.toString();
      if (x_str > y_str) {
        return -1;
      } else if (x_str < y_str) {
        return 1;
      }
      return 0;
    }
    exports2.sortByBrowseName = sortByBrowseName;
    function sortByNodeId(a, b2) {
      return a.nodeId.toString() < b2.nodeId.toString() ? -1 : 1;
    }
    ua_method_impl_1.UAMethodImpl.prototype.dumpXML = function(xw) {
      dumpUAMethod(xw, this);
    };
    ua_object_impl_1.UAObjectImpl.prototype.dumpXML = function(xw) {
      dumpUAObject(xw, this);
    };
    ua_variable_impl_1.UAVariableImpl.prototype.dumpXML = function(xw) {
      dumpUAVariable(xw, this);
    };
    ua_variable_type_impl_1.UAVariableTypeImpl.prototype.dumpXML = function(xw) {
      dumpUAVariableType(xw, this);
    };
    ua_reference_type_impl_1.UAReferenceTypeImpl.prototype.dumpXML = function(xw) {
      dumpReferenceType(xw, this);
    };
    ua_object_type_impl_1.UAObjectTypeImpl.prototype.dumpXML = function(xw) {
      dumpUAObjectType(xw, this);
    };
    ua_data_type_impl_1.UADataTypeImpl.prototype.dumpXML = function(xw) {
      dumpUADataType(xw, this);
    };
    ua_view_impl_1.UAViewImpl.prototype.dumpXML = function(xw) {
      dumpUAView(xw, this);
    };
    function makeTypeXsd(namespaceUri) {
      return namespaceUri.replace(/\/$/, "") + "/Type.xsd";
    }
    namespace_impl_1.NamespaceImpl.prototype.toNodeset2XML = function() {
      const namespaceArrayNode = this.addressSpace.findNode(node_opcua_constants_1.VariableIds.Server_NamespaceArray);
      const namespaceArray = namespaceArrayNode ? namespaceArrayNode.readAttribute(null, node_opcua_basic_types_1.AttributeIds.Value).value.value : [];
      const xw = new XMLWriter(true);
      xw.priorityTable = (0, construct_namespace_dependency_1.constructNamespacePriorityTable)(this.addressSpace).priorityTable;
      const dependency = (0, construct_namespace_dependency_1.constructNamespaceDependency)(this, xw.priorityTable);
      const translationTable = (0, construct_namespace_dependency_1._constructNamespaceTranslationTable)(dependency, this);
      xw.translationTable = translationTable;
      xw.startDocument({ encoding: "utf-8", version: "1.0" });
      xw.startElement("UANodeSet");
      xw.writeAttribute("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
      xw.writeAttribute("xmlns:uax", "http://opcfoundation.org/UA/2008/02/Types.xsd");
      xw.writeAttribute("xmlns", "http://opcfoundation.org/UA/2011/03/UANodeSet.xsd");
      const namespacesMap = {
        "http://opcfoundation.org/UA/2011/03/UANodeSet.xsd": "",
        "http://opcfoundation.org/UA/2008/02/Types.xsd": "uax",
        "http://www.w3.org/2001/XMLSchema-instance": "xsi"
      };
      for (const namespace of dependency) {
        if (namespace.index === 0) {
          continue;
        }
        const translatedIndex = translationTable[namespace.index];
        const smallName = `ns${translatedIndex}`;
        xw.writeAttribute(`xmlns:${smallName}`, makeTypeXsd(namespace.namespaceUri));
        namespacesMap[namespace.namespaceUri] = smallName;
      }
      initXmlWriterEx(xw, namespacesMap, namespaceArray);
      xw.startElement("NamespaceUris");
      const sortedDependencies = dependency.sort((a, b2) => translationTable[a.index] > translationTable[b2.index] ? 1 : -1);
      doDebug && debugLog(sortedDependencies.map((a) => a.index + " + " + a.namespaceUri).join("\n"));
      doDebug && debugLog("translation table ", translationTable);
      for (const depend of sortedDependencies) {
        if (depend.index === 0) {
          continue;
        }
        xw.startElement("Uri");
        xw.text(depend.namespaceUri);
        xw.endElement();
      }
      xw.endElement();
      xw.startElement("Models");
      {
        xw.startElement("Model");
        xw.writeAttribute("ModelUri", this.namespaceUri);
        xw.writeAttribute("Version", this.version);
        xw.writeAttribute("PublicationDate", this.publicationDate.toISOString());
        for (const depend of sortedDependencies) {
          if (depend.index === this.index) {
            continue;
          }
          xw.startElement("RequiredModel");
          xw.writeAttribute("ModelUri", depend.namespaceUri);
          xw.writeAttribute("Version", depend.version);
          xw.writeAttribute("PublicationDate", depend.publicationDate.toISOString());
          xw.endElement();
        }
        xw.endElement();
      }
      xw.endElement();
      const data = { aliases: {} };
      for (const node of this.nodeIterator()) {
        buildUpAliases(node, xw, data);
      }
      writeAliases(xw, data.aliases);
      xw.visitedNode = {};
      xw.writeComment("ReferenceTypes");
      const referenceTypes = [...this._referenceTypeIterator()].sort(sortByBrowseName);
      for (const referenceType of referenceTypes) {
        dumpReferenceType(xw, referenceType);
      }
      const addressSpace = this.addressSpace;
      const getDataTypeDescription = (opcBinaryTypeSystem) => {
        const nodeToBrowse = new node_opcua_types_1.BrowseDescription({
          browseDirection: node_opcua_data_model_1.BrowseDirection.Forward,
          includeSubtypes: false,
          nodeClassMask: (0, node_opcua_data_model_1.makeNodeClassMask)("Variable"),
          nodeId: opcBinaryTypeSystem.nodeId,
          referenceTypeId: (0, node_opcua_nodeid_1.resolveNodeId)("HasComponent"),
          resultMask: (0, node_opcua_data_model_1.makeResultMask)("ReferenceType | IsForward | BrowseName | NodeClass | TypeDefinition")
        });
        const result2 = opcBinaryTypeSystem.browseNode(nodeToBrowse).filter((r) => r.nodeId.namespace === this.index);
        (0, node_opcua_assert_1.assert)(result2.length <= 1);
        return result2;
      };
      const dataTypes = [...this._dataTypeIterator()].sort(sortByBrowseName);
      if (dataTypes.length) {
        xw.writeComment("DataTypes");
        for (const dataType of dataTypes.sort(sortByNodeId)) {
          if (!xw.visitedNode[_hash(dataType)]) {
            dumpNodeInXml(xw, dataType);
          }
        }
        const opcBinaryTypeSystem = addressSpace.findNode(node_opcua_constants_1.ObjectIds.OPCBinarySchema_TypeSystem);
        const opcXmlSchemaTypeSystem = addressSpace.findNode(node_opcua_constants_1.ObjectIds.XmlSchema_TypeSystem);
        if (opcBinaryTypeSystem) {
          const result2 = getDataTypeDescription(opcBinaryTypeSystem);
          if (result2.length === 1) {
            xw.writeComment("DataSystem - Binary");
            const dataSystemType = addressSpace.findNode(result2[0].nodeId);
            const types2 = dataSystemType.getComponents();
            for (const f2 of types2) {
              dumpNodeInXml(xw, f2);
            }
            dumpNodeInXml(xw, dataSystemType);
          }
        }
        if (opcXmlSchemaTypeSystem) {
          const result2 = getDataTypeDescription(opcXmlSchemaTypeSystem);
          if (result2.length === 1) {
            xw.writeComment("DataSystem - Xml");
            const dataSystemType = addressSpace.findNode(result2[0].nodeId);
            const types2 = dataSystemType.getComponents();
            for (const f2 of types2) {
              dumpNodeInXml(xw, f2);
            }
            dumpNodeInXml(xw, dataSystemType);
          }
        }
      }
      xw.writeComment("ObjectTypes");
      const objectTypes = [...this._objectTypeIterator()].sort(sortByBrowseName);
      for (const objectType of objectTypes.sort(sortByNodeId)) {
        if (!xw.visitedNode[_hash(objectType)]) {
          dumpNodeInXml(xw, objectType);
        }
      }
      xw.writeComment("VariableTypes");
      const variableTypes = [...this._variableTypeIterator()].sort(sortByBrowseName);
      for (const variableType of variableTypes.sort(sortByNodeId)) {
        if (!xw.visitedNode[_hash(variableType)]) {
          dumpNodeInXml(xw, variableType);
        }
      }
      xw.writeComment("Other Nodes");
      const nodes = [...this.nodeIterator()].sort(sortByBrowseName);
      for (const node of nodes.sort(sortByNodeId)) {
        if (!xw.visitedNode[_hash(node)]) {
          dumpNodeInXml(xw, node);
        }
      }
      xw.endElement();
      xw.endDocument();
      return xw.toString();
    };
  }
});

// node_modules/node-opcua-address-space/dist/src/nodeset_tools/dump_to_bsd.js
var require_dump_to_bsd = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/nodeset_tools/dump_to_bsd.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.dumpToBSD = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_nodeid_1 = require_dist21();
    var construct_namespace_dependency_1 = require_construct_namespace_dependency();
    var XMLWriter = require_xml_writer2();
    function dumpEnumeratedType(xw, e, name) {
      xw.startElement("opc:EnumeratedType");
      xw.writeAttribute("Name", name);
      xw.writeAttribute("LengthInBits", "32");
      for (const f2 of e.fields || []) {
        xw.startElement("opc:EnumeratedValue");
        xw.writeAttribute("Name", f2.name);
        (0, node_opcua_assert_1.assert)(f2.value[0] === 0, "unsupported 64 bit value !");
        xw.writeAttribute("Value", f2.value[1].toString());
        xw.endElement();
      }
      xw.endElement();
    }
    function buildXmlName(addressSpace, map, nodeId) {
      if (node_opcua_nodeid_1.NodeId.sameNodeId(nodeId, node_opcua_nodeid_1.NodeId.nullNodeId)) {
        return "ua:ExtensionObject";
      }
      const node = addressSpace.findNode(nodeId);
      if (!node) {
        throw new Error("Cannot find Node for" + nodeId?.toString());
      }
      const typeName = node.browseName.name;
      const n = node.nodeId;
      const prefix = n.identifierType === node_opcua_nodeid_1.NodeIdType.NUMERIC && n.namespace === 0 ? n.value <= 15 ? "opc" : "ua" : map[node.nodeId.namespace];
      return prefix + ":" + (typeName === "Structure" && prefix === "ua" ? "ExtensionObject" : typeName);
    }
    function dumpDataTypeStructure(xw, addressSpace, map, structureDefinition, structureDefinitionBase, name, doc) {
      xw.startElement("opc:StructuredType");
      xw.writeAttribute("Name", name);
      xw.writeAttribute("BaseType", buildXmlName(addressSpace, map, structureDefinition.baseDataType));
      if (doc) {
        xw.startElement("opc:Documentation");
        xw.text(doc);
        xw.endElement();
      }
      const fields = structureDefinition.fields || [];
      const nbFieldsInBase = structureDefinitionBase ? structureDefinitionBase.fields?.length || 0 : 0;
      let optionalsCount = 0;
      for (let index = nbFieldsInBase; index < fields.length; index++) {
        const f2 = fields[index];
        if (f2.isOptional) {
          xw.startElement("opc:Field");
          xw.writeAttribute("Name", f2.name + "Specified");
          xw.writeAttribute("TypeName", "opc:Bit");
          xw.endElement();
          optionalsCount++;
        }
      }
      if (optionalsCount >= 32) {
        throw new Error("Too many optionals fields");
      }
      if (optionalsCount) {
        const padding = 32 - optionalsCount;
        if (padding !== 0) {
          xw.startElement("opc:Field");
          xw.writeAttribute("Name", "Reserved1");
          xw.writeAttribute("TypeName", "opc:Bit");
          xw.writeAttribute("Length", padding.toString());
          xw.endElement();
        }
      }
      for (let index = nbFieldsInBase; index < fields.length; index++) {
        const f2 = fields[index];
        const isArray = f2.valueRank > 0 && f2.arrayDimensions?.length;
        if (isArray) {
          xw.startElement("opc:Field");
          xw.writeAttribute("Name", "NoOf" + f2.name);
          xw.writeAttribute("TypeName", "opc:Int32");
          if (f2.isOptional) {
            xw.writeAttribute("SwitchField", f2.name + "Specified");
          }
          xw.endElement();
        }
        xw.startElement("opc:Field");
        xw.writeAttribute("Name", f2.name);
        const typeName = buildXmlName(addressSpace, map, f2.dataType);
        xw.writeAttribute("TypeName", typeName);
        if (isArray) {
          xw.writeAttribute("LengthField", "NoOf" + f2.name);
        }
        if (f2.isOptional) {
          xw.writeAttribute("SwitchField", f2.name + "Specified");
        }
        xw.endElement();
      }
      xw.endElement();
    }
    function dumpDataTypeToBSD(xw, dataType, map) {
      const addressSpace = dataType.addressSpace;
      const name = dataType.browseName.name;
      const definition = dataType.getDefinition();
      if (definition instanceof node_opcua_types_1.StructureDefinition) {
        const structureDefinitionBase = dataType.subtypeOfObj?.getStructureDefinition();
        dumpDataTypeStructure(xw, addressSpace, map, definition, structureDefinitionBase, name);
      }
      if (definition instanceof node_opcua_types_1.EnumDefinition) {
        dumpEnumeratedType(xw, definition, name);
      }
    }
    function shortcut(namespace) {
      return "n" + namespace.index;
    }
    function dumpToBSD(namespace) {
      const dependency = (0, construct_namespace_dependency_1.constructNamespaceDependency)(namespace);
      const addressSpace = namespace.addressSpace;
      const xw = new XMLWriter(true);
      xw.startElement("opc:TypeDictionary");
      xw.writeAttribute("xmlns:opc", "http://opcfoundation.org/BinarySchema/");
      xw.writeAttribute("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
      xw.writeAttribute("xmlns:ua", "http://opcfoundation.org/UA/");
      xw.writeAttribute("xmlns:tns", namespace.namespaceUri);
      const map = {};
      map[namespace.index] = "tns";
      for (const dependantNamespace of dependency) {
        const namespaceIndex = dependantNamespace.index;
        if (namespaceIndex === 0 || namespaceIndex === namespace.index) {
          continue;
        }
        const ns = shortcut(dependantNamespace);
        map[namespaceIndex] = ns;
        xw.writeAttribute(`xmlns:${ns}`, dependantNamespace.namespaceUri);
      }
      xw.writeAttribute("DefaultByteOrder", "LittleEndian");
      xw.writeAttribute("TargetNamespace", namespace.namespaceUri);
      for (const dependantNamespace of dependency) {
        if (dependantNamespace.index === namespace.index) {
          continue;
        }
        xw.startElement("opc:Import").writeAttribute("Namespace", dependantNamespace.namespaceUri).endElement();
      }
      for (const dataType of namespace._dataTypeIterator()) {
        dumpDataTypeToBSD(xw, dataType, map);
      }
      xw.endElement();
      return xw.toString();
    }
    exports2.dumpToBSD = dumpToBSD;
  }
});

// node_modules/node-opcua-address-space/dist/src/index_current.js
var require_index_current = __commonJS({
  "node_modules/node-opcua-address-space/dist/src/index_current.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NodeIdManager = exports2.VariableHistorian = exports2.resolveReferenceType = exports2.resolveReferenceNode = exports2.makeAttributeEventName = exports2.adjustNamespaceArray = exports2.dumpToBSD = exports2.NamespaceOptions = exports2.promoteToStateMachineType = exports2.promoteToStateMachine = exports2.ContinuationPointManager = exports2.ensureDatatypeExtractedWithCallback = exports2.ensureDatatypeExtracted = exports2.AddressSpace = void 0;
    var address_space_1 = require_address_space2();
    Object.defineProperty(exports2, "AddressSpace", { enumerable: true, get: function() {
      return address_space_1.AddressSpace;
    } });
    __exportStar3(require_session_context2(), exports2);
    __exportStar3(require_dump_tools(), exports2);
    __exportStar3(require_adjust_browse_direction(), exports2);
    __exportStar3(require_pseudo_session(), exports2);
    __exportStar3(require_make_optionals_map(), exports2);
    __exportStar3(require_argument_list(), exports2);
    __exportStar3(require_call_helpers(), exports2);
    __exportStar3(require_ensure_secure_access(), exports2);
    __exportStar3(require_resolve_opaque_on_address_space(), exports2);
    __exportStar3(require_condition_info_i(), exports2);
    __exportStar3(require_construct_namespace_dependency(), exports2);
    __exportStar3(require_validate_data_type_correctness(), exports2);
    __exportStar3(require_set_namespace_meta_data(), exports2);
    __exportStar3(require_namespace2(), exports2);
    __exportStar3(require_namespace_data_access(), exports2);
    __exportStar3(require_namespace_machine_state(), exports2);
    __exportStar3(require_namespace_alarm_and_condition(), exports2);
    var ensure_datatype_extracted_1 = require_ensure_datatype_extracted();
    Object.defineProperty(exports2, "ensureDatatypeExtracted", { enumerable: true, get: function() {
      return ensure_datatype_extracted_1.ensureDatatypeExtracted;
    } });
    Object.defineProperty(exports2, "ensureDatatypeExtractedWithCallback", { enumerable: true, get: function() {
      return ensure_datatype_extracted_1.ensureDatatypeExtractedWithCallback;
    } });
    __exportStar3(require_generateAddressSpaceRaw(), exports2);
    __exportStar3(require_register_node_promoter(), exports2);
    var continuation_point_manager_1 = require_continuation_point_manager();
    Object.defineProperty(exports2, "ContinuationPointManager", { enumerable: true, get: function() {
      return continuation_point_manager_1.ContinuationPointManager;
    } });
    var finite_state_machine_1 = require_finite_state_machine();
    Object.defineProperty(exports2, "promoteToStateMachine", { enumerable: true, get: function() {
      return finite_state_machine_1.promoteToStateMachine;
    } });
    Object.defineProperty(exports2, "promoteToStateMachineType", { enumerable: true, get: function() {
      return finite_state_machine_1.promoteToStateMachineType;
    } });
    __exportStar3(require_ua_transition_ex(), exports2);
    __exportStar3(require_namespace_impl(), exports2);
    __exportStar3(require_extension_object_array_node(), exports2);
    __exportStar3(require_event_data(), exports2);
    var nodeid_manager_1 = require_nodeid_manager();
    Object.defineProperty(exports2, "NamespaceOptions", { enumerable: true, get: function() {
      return nodeid_manager_1.NamespaceOptions;
    } });
    __exportStar3(require_nodeset_to_xml(), exports2);
    var dump_to_bsd_1 = require_dump_to_bsd();
    Object.defineProperty(exports2, "dumpToBSD", { enumerable: true, get: function() {
      return dump_to_bsd_1.dumpToBSD;
    } });
    var adjust_namespace_array_1 = require_adjust_namespace_array();
    Object.defineProperty(exports2, "adjustNamespaceArray", { enumerable: true, get: function() {
      return adjust_namespace_array_1.adjustNamespaceArray;
    } });
    var base_node_impl_1 = require_base_node_impl();
    Object.defineProperty(exports2, "makeAttributeEventName", { enumerable: true, get: function() {
      return base_node_impl_1.makeAttributeEventName;
    } });
    var reference_impl_1 = require_reference_impl();
    Object.defineProperty(exports2, "resolveReferenceNode", { enumerable: true, get: function() {
      return reference_impl_1.resolveReferenceNode;
    } });
    Object.defineProperty(exports2, "resolveReferenceType", { enumerable: true, get: function() {
      return reference_impl_1.resolveReferenceType;
    } });
    __exportStar3(require_adjust_datavalue_status_code(), exports2);
    __exportStar3(require_add_dataItem_stuff(), exports2);
    __exportStar3(require_ua_multistate_discrete_impl(), exports2);
    __exportStar3(require_ua_multistate_value_discrete_impl(), exports2);
    __exportStar3(require_ua_two_state_discrete_impl(), exports2);
    var address_space_historical_data_node_1 = require_address_space_historical_data_node();
    Object.defineProperty(exports2, "VariableHistorian", { enumerable: true, get: function() {
      return address_space_historical_data_node_1.VariableHistorian;
    } });
    var nodeid_manager_2 = require_nodeid_manager();
    Object.defineProperty(exports2, "NodeIdManager", { enumerable: true, get: function() {
      return nodeid_manager_2.NodeIdManager;
    } });
    __exportStar3(require_private_namespace(), exports2);
    __exportStar3(require_alarms_and_conditions(), exports2);
    __exportStar3(require_event_data(), exports2);
    __exportStar3(require_dist57(), exports2);
  }
});

// node_modules/node-opcua-address-space/distNodeJS/generate_address_space.js
var require_generate_address_space = __commonJS({
  "node_modules/node-opcua-address-space/distNodeJS/generate_address_space.js"(exports2, module2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.generateAddressSpace = exports2.readNodeSet2XmlFile = void 0;
    var fs_1 = __importDefault3(require("fs"));
    var util_1 = require("util");
    var node_opcua_debug_1 = require_dist24();
    var __1 = require_index_current();
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    async function readNodeSet2XmlFile(xmlFile) {
      if (!fs_1.default.existsSync(xmlFile)) {
        const msg = "[NODE-OPCUA-E02] generateAddressSpace : cannot find nodeset2 xml file at " + xmlFile;
        errorLog(msg);
        throw new Error(msg);
      }
      debugLog(" parsing ", xmlFile);
      const xmlData = await fs_1.default.promises.readFile(xmlFile, "utf-8");
      return xmlData;
    }
    exports2.readNodeSet2XmlFile = readNodeSet2XmlFile;
    function generateAddressSpace(...args) {
      const addressSpace = args[0];
      const xmlFiles = args[1];
      if (args.length === 4) {
        const options = args[2];
        const callback = args[3];
        (0, util_1.callbackify)(__1.generateAddressSpaceRaw)(addressSpace, xmlFiles, readNodeSet2XmlFile, options || {}, callback);
      } else {
        const options = {};
        const callback = args[2];
        (0, util_1.callbackify)(__1.generateAddressSpaceRaw)(addressSpace, xmlFiles, readNodeSet2XmlFile, options, callback);
      }
    }
    exports2.generateAddressSpace = generateAddressSpace;
    var thenify = require_thenify();
    module2.exports.generateAddressSpace = thenify.withCallback(module2.exports.generateAddressSpace);
  }
});

// node_modules/node-opcua-address-space/distNodeJS/index.js
var require_distNodeJS = __commonJS({
  "node_modules/node-opcua-address-space/distNodeJS/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_generate_address_space(), exports2);
  }
});

// node_modules/node-opcua-address-space/nodeJS.js
var require_nodeJS = __commonJS({
  "node_modules/node-opcua-address-space/nodeJS.js"(exports2, module2) {
    module2.exports = require_distNodeJS();
  }
});

// node_modules/node-opcua-address-space/distHelpers/get_mini_address_space.js
var require_get_mini_address_space = __commonJS({
  "node_modules/node-opcua-address-space/distHelpers/get_mini_address_space.js"(exports2, module2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getMiniAddressSpace = exports2.get_empty_nodeset_filename = exports2.get_mini_nodeset_filename = exports2.empty_nodeset = exports2.mini_nodeset = void 0;
    var node_opcua_assert_1 = require_dist14();
    var __1 = require_index_current();
    var nodeJS_1 = require_nodeJS();
    var get_address_space_fixture_1 = require_get_address_space_fixture();
    exports2.mini_nodeset = "mini.Nodeset2.xml";
    exports2.empty_nodeset = "fixture_empty_nodeset2.xml";
    var get_mini_nodeset_filename = () => (0, get_address_space_fixture_1.getAddressSpaceFixture)(exports2.mini_nodeset);
    exports2.get_mini_nodeset_filename = get_mini_nodeset_filename;
    var get_empty_nodeset_filename = () => (0, get_address_space_fixture_1.getAddressSpaceFixture)(exports2.empty_nodeset);
    exports2.get_empty_nodeset_filename = get_empty_nodeset_filename;
    var thenify = require_thenify();
    function getMiniAddressSpace(...args) {
      const callback = args[0];
      const addressSpace = __1.AddressSpace.create();
      const serverNamespace = addressSpace.registerNamespace("http://MYNAMESPACE");
      (0, node_opcua_assert_1.assert)(serverNamespace.index === 1);
      (0, nodeJS_1.generateAddressSpace)(addressSpace, (0, exports2.get_mini_nodeset_filename)(), {}, (err) => {
        if (err) {
          console.log("err =", err);
        }
        callback(err || null, addressSpace);
      });
    }
    exports2.getMiniAddressSpace = getMiniAddressSpace;
    module2.exports.getMiniAddressSpace = thenify.withCallback(module2.exports.getMiniAddressSpace);
  }
});

// node_modules/node-opcua-address-space/distHelpers/boiler_system.js
var require_boiler_system = __commonJS({
  "node_modules/node-opcua-address-space/distHelpers/boiler_system.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.makeBoiler = exports2.createBoilerType = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_address_space_base_1 = require_dist53();
    var __1 = require_index_current();
    function myGetExecutableFlag(method, toState, methodName) {
      const stateMachineW = (0, __1.promoteToStateMachine)(method.parent);
      return stateMachineW.isValidTransition(toState);
    }
    function implementProgramStateMachine(programStateMachine) {
      function installMethod(methodName, toState) {
        let method = programStateMachine.getMethodByName(methodName);
        if (!method) {
          let methodToClone = programStateMachine.typeDefinitionObj.getMethodByName(methodName);
          if (!methodToClone) {
            methodToClone = programStateMachine.typeDefinitionObj.subtypeOfObj.getMethodByName(methodName);
          }
          methodToClone.clone({
            namespace: programStateMachine.namespace,
            componentOf: programStateMachine
          });
          method = programStateMachine.getMethodByName(methodName);
          (0, node_opcua_assert_1.assert)(method !== null, "Method clone should cause parent object to be extended");
        }
        (0, node_opcua_assert_1.assert)(method.nodeClass === node_opcua_data_model_1.NodeClass.Method);
        method._getExecutableFlag = function() {
          return myGetExecutableFlag(this, toState, methodName);
        };
        method.bindMethod(function(inputArguments, context, callback) {
          const stateMachineW = this.parent;
          stateMachineW.setState(toState);
          callback(null, {
            outputArguments: [],
            statusCode: node_opcua_status_code_1.StatusCodes.Good
          });
        });
        (0, node_opcua_assert_1.assert)(programStateMachine.getMethodByName(methodName) !== null, "Method " + methodName + " should be added to parent object (checked with getMethodByName)");
        const lc_name = (0, node_opcua_utils_1.lowerFirstLetter)(methodName);
      }
      installMethod("Halt", "Halted");
      installMethod("Reset", "Ready");
      installMethod("Start", "Running");
      installMethod("Suspend", "Suspended");
      installMethod("Resume", "Running");
    }
    function addRelation(srcNode, referenceType, targetNode) {
      (0, node_opcua_assert_1.assert)(srcNode, "expecting srcNode !== null");
      (0, node_opcua_assert_1.assert)(targetNode, "expecting targetNode !== null");
      if (typeof referenceType === "string") {
        const nodes = srcNode.findReferencesAsObject(referenceType, true);
        (0, node_opcua_assert_1.assert)(nodes.length === 1);
        referenceType = nodes[0];
      }
      srcNode.addReference({ referenceType: referenceType.nodeId, nodeId: targetNode });
    }
    function createBoilerType(namespace) {
      if (namespace.findObjectType("BoilerType")) {
        console.warn("createBoilerType has already been called");
        return namespace.findObjectType("BoilerType");
      }
      const flowTo = namespace.addReferenceType({
        browseName: "FlowTo",
        description: "a reference that indicates a flow between two objects",
        inverseName: "FlowFrom",
        subtypeOf: "NonHierarchicalReferences"
      });
      const hotFlowTo = namespace.addReferenceType({
        browseName: "HotFlowTo",
        description: "a reference that indicates a high temperature flow between two objects",
        inverseName: "HotFlowFrom",
        subtypeOf: flowTo
      });
      const signalTo = namespace.addReferenceType({
        browseName: "SignalTo",
        description: "a reference that indicates an electrical signal between two variables",
        inverseName: "SignalFrom",
        subtypeOf: "NonHierarchicalReferences"
      });
      const addressSpace = namespace.addressSpace;
      flowTo.isSubtypeOf(addressSpace.findReferenceType("References"));
      flowTo.isSubtypeOf(addressSpace.findReferenceType("NonHierarchicalReferences"));
      hotFlowTo.isSubtypeOf(addressSpace.findReferenceType("References"));
      hotFlowTo.isSubtypeOf(addressSpace.findReferenceType("NonHierarchicalReferences"));
      hotFlowTo.isSubtypeOf(addressSpace.findReferenceType("FlowTo", namespace.index));
      const NonHierarchicalReferences = addressSpace.findReferenceType("NonHierarchicalReferences");
      const boilerHaltedEventType = namespace.addEventType({
        browseName: "BoilerHaltedEventType",
        subtypeOf: "TransitionEventType"
      });
      const customControllerType = namespace.addObjectType({
        browseName: "CustomControllerType",
        description: "a custom PID controller with 3 inputs"
      });
      const input1 = namespace.addVariable({
        browseName: "Input1",
        dataType: "Double",
        description: "a reference that indicates an electrical signal between two variables",
        modellingRule: "Mandatory",
        propertyOf: customControllerType
      });
      const input2 = namespace.addVariable({
        browseName: "Input2",
        dataType: "Double",
        modellingRule: "Mandatory",
        propertyOf: customControllerType
      });
      const input3 = namespace.addVariable({
        browseName: "Input3",
        dataType: "Double",
        modellingRule: "Mandatory",
        propertyOf: customControllerType
      });
      const controlOut = namespace.addVariable({
        browseName: "ControlOut",
        dataType: "Double",
        modellingRule: "Mandatory",
        propertyOf: customControllerType
      });
      const description = namespace.addVariable({
        browseName: "Description",
        dataType: "LocalizedText",
        modellingRule: "Mandatory",
        propertyOf: customControllerType
      });
      const genericSensorType = namespace.addObjectType({
        browseName: "GenericSensorType"
      });
      namespace.addAnalogDataItem({
        browseName: "Output",
        componentOf: genericSensorType,
        dataType: "Double",
        engineeringUnitsRange: { low: -100, high: 200 },
        modellingRule: "Mandatory"
      });
      genericSensorType.install_extra_properties();
      genericSensorType.getComponentByName("Output");
      (0, node_opcua_assert_1.assert)(genericSensorType.getComponentByName("Output").modellingRule === "Mandatory");
      const genericControllerType = namespace.addObjectType({
        browseName: "GenericControllerType"
      });
      namespace.addVariable({
        browseName: "ControlOut",
        dataType: "Double",
        modellingRule: "Mandatory",
        propertyOf: genericControllerType
      });
      namespace.addVariable({
        browseName: "Measurement",
        dataType: "Double",
        modellingRule: "Mandatory",
        propertyOf: genericControllerType
      });
      namespace.addVariable({
        browseName: "SetPoint",
        dataType: "Double",
        modellingRule: "Mandatory",
        propertyOf: genericControllerType
      });
      const flowControllerType = namespace.addObjectType({
        browseName: "FlowControllerType",
        subtypeOf: genericControllerType
      });
      const levelControllerType = namespace.addObjectType({
        browseName: "LevelControllerType",
        subtypeOf: genericControllerType
      });
      const flowTransmitterType = namespace.addObjectType({
        browseName: "FlowTransmitterType",
        subtypeOf: genericSensorType
      });
      const levelIndicatorType = namespace.addObjectType({
        browseName: "LevelIndicatorType",
        subtypeOf: genericSensorType
      });
      const genericActuatorType = namespace.addObjectType({
        browseName: "GenericActuatorType"
      });
      namespace.addAnalogDataItem({
        browseName: "Input",
        componentOf: genericActuatorType,
        dataType: "Double",
        engineeringUnitsRange: { low: -100, high: 200 },
        modellingRule: "Mandatory"
      });
      const valveType = namespace.addObjectType({
        browseName: "ValveType",
        subtypeOf: genericActuatorType
      });
      const boilerInputPipeType = namespace.addObjectType({
        browseName: "BoilerInputPipeType",
        subtypeOf: "FolderType"
      });
      const ftx1 = flowTransmitterType.instantiate({
        browseName: "FlowTransmitter",
        componentOf: boilerInputPipeType,
        modellingRule: "Mandatory",
        notifierOf: boilerInputPipeType,
        eventNotifier: node_opcua_address_space_base_1.EventNotifierFlags.SubscribeToEvents
      });
      (0, node_opcua_assert_1.assert)(ftx1.eventNotifier === node_opcua_address_space_base_1.EventNotifierFlags.SubscribeToEvents);
      (0, node_opcua_assert_1.assert)(ftx1.output.browseName.toString() === `${namespace.index}:Output`);
      const valve1 = valveType.instantiate({
        browseName: "Valve",
        componentOf: boilerInputPipeType,
        modellingRule: "Mandatory"
      });
      const boilerOutputPipeType = namespace.addObjectType({
        browseName: "BoilerOutputPipeType",
        subtypeOf: "FolderType"
      });
      const ftx2 = flowTransmitterType.instantiate({
        browseName: "FlowTransmitter",
        componentOf: boilerOutputPipeType,
        modellingRule: "Mandatory",
        notifierOf: boilerOutputPipeType,
        eventNotifier: node_opcua_address_space_base_1.EventNotifierFlags.SubscribeToEvents
      });
      ftx2.getComponentByName("Output").browseName.toString();
      const boilerDrumType = namespace.addObjectType({
        browseName: "BoilerDrumType",
        subtypeOf: "FolderType"
      });
      const levelIndicator = levelIndicatorType.instantiate({
        browseName: "LevelIndicator",
        componentOf: boilerDrumType,
        modellingRule: "Mandatory",
        notifierOf: boilerDrumType,
        eventNotifier: node_opcua_address_space_base_1.EventNotifierFlags.SubscribeToEvents
      });
      (0, node_opcua_assert_1.assert)(levelIndicator.eventNotifier === node_opcua_address_space_base_1.EventNotifierFlags.SubscribeToEvents);
      const programFiniteStateMachineType = addressSpace.findObjectType("ProgramStateMachineType");
      const boilerStateMachineType = namespace.addObjectType({
        browseName: "BoilerStateMachineType",
        postInstantiateFunc: implementProgramStateMachine,
        subtypeOf: programFiniteStateMachineType
      });
      function addMethod(baseType, objectType, methodName) {
        (0, node_opcua_assert_1.assert)(!objectType.getMethodByName(methodName));
        const method = baseType.getMethodByName(methodName);
        const m2 = method.clone({
          namespace,
          componentOf: objectType,
          modellingRule: "Mandatory"
        });
        (0, node_opcua_assert_1.assert)(objectType.getMethodByName(methodName));
        (0, node_opcua_assert_1.assert)(objectType.getMethodByName(methodName).modellingRule === "Mandatory");
      }
      addMethod(programFiniteStateMachineType, boilerStateMachineType, "Halt");
      addMethod(programFiniteStateMachineType, boilerStateMachineType, "Reset");
      addMethod(programFiniteStateMachineType, boilerStateMachineType, "Start");
      addMethod(programFiniteStateMachineType, boilerStateMachineType, "Suspend");
      addMethod(programFiniteStateMachineType, boilerStateMachineType, "Resume");
      const boilerType = namespace.addObjectType({
        browseName: "BoilerType",
        eventNotifier: 1
      });
      const customController = customControllerType.instantiate({
        browseName: "CustomController",
        componentOf: boilerType,
        modellingRule: "Mandatory"
      });
      const flowController = flowControllerType.instantiate({
        browseName: "FlowController",
        componentOf: boilerType,
        modellingRule: "Mandatory"
      });
      const levelController = levelControllerType.instantiate({
        browseName: "LevelController",
        componentOf: boilerType,
        modellingRule: "Mandatory"
      });
      const inputPipe = boilerInputPipeType.instantiate({
        browseName: "InputPipe",
        componentOf: boilerType,
        modellingRule: "Mandatory",
        notifierOf: boilerType,
        eventNotifier: node_opcua_address_space_base_1.EventNotifierFlags.SubscribeToEvents
      });
      (0, node_opcua_assert_1.assert)(inputPipe.eventNotifier === node_opcua_address_space_base_1.EventNotifierFlags.SubscribeToEvents);
      const boilerDrum = boilerDrumType.instantiate({
        browseName: "BoilerDrum",
        componentOf: boilerType,
        modellingRule: "Mandatory",
        notifierOf: boilerType,
        eventNotifier: node_opcua_address_space_base_1.EventNotifierFlags.SubscribeToEvents
      });
      const outputPipe = boilerOutputPipeType.instantiate({
        browseName: "OutputPipe",
        componentOf: boilerType,
        modellingRule: "Mandatory",
        notifierOf: boilerType,
        eventNotifier: node_opcua_address_space_base_1.EventNotifierFlags.SubscribeToEvents
      });
      const simulation = boilerStateMachineType.instantiate({
        browseName: "Simulation",
        componentOf: boilerType,
        eventSourceOf: boilerType,
        modellingRule: "Mandatory"
      });
      addRelation(inputPipe, flowTo, boilerDrum);
      addRelation(boilerDrum, hotFlowTo, outputPipe);
      (0, node_opcua_assert_1.assert)(boilerType.inputPipe.flowTransmitter);
      (0, node_opcua_assert_1.assert)(boilerType.inputPipe.flowTransmitter.output);
      (0, node_opcua_assert_1.assert)(boilerType.flowController.measurement);
      addRelation(boilerType.inputPipe.flowTransmitter.output, signalTo, boilerType.flowController.measurement);
      addRelation(boilerType.inputPipe.flowTransmitter.output, signalTo, boilerType.customController.input2);
      addRelation(boilerType.flowController.controlOut, signalTo, boilerType.inputPipe.valve.input);
      addRelation(boilerType.boilerDrum.levelIndicator.output, signalTo, boilerType.levelController.measurement);
      addRelation(boilerType.outputPipe.flowTransmitter.output, signalTo, boilerType.customController.input3);
      addRelation(boilerType.levelController.controlOut, signalTo, boilerType.customController.input1);
      addRelation(boilerType.customController.controlOut, signalTo, boilerType.flowController.setPoint);
      return boilerType;
    }
    exports2.createBoilerType = createBoilerType;
    function makeBoiler(addressSpace, options) {
      const namespace = addressSpace.getOwnNamespace();
      (0, node_opcua_assert_1.assert)(options);
      let boilerType;
      boilerType = namespace.findObjectType("BoilerType");
      if (!boilerType) {
        createBoilerType(namespace);
        boilerType = namespace.findObjectType("BoilerType");
      }
      const boiler1 = boilerType.instantiate({
        browseName: options.browseName,
        organizedBy: addressSpace.rootFolder.objects
      });
      (0, __1.promoteToStateMachine)(boiler1.simulation);
      const boilerStateMachine = boiler1.simulation;
      const readyState = boilerStateMachine.getStateByName("Ready");
      boilerStateMachine.setState(readyState);
      return boiler1;
    }
    exports2.makeBoiler = makeBoiler;
  }
});

// node_modules/node-opcua-address-space/distHelpers/mock_session.js
var require_mock_session = __commonJS({
  "node_modules/node-opcua-address-space/distHelpers/mock_session.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.mockSession = exports2.MockContinuationPointManager = void 0;
    var node_opcua_nodeid_1 = require_dist21();
    var MockContinuationPointManager = class {
      registerHistoryReadRaw(maxElements, dataValues, cnt) {
        throw new Error("Method not implemented.");
      }
      getNextHistoryReadRaw(numValues, cnt) {
        throw new Error("Method not implemented.");
      }
      registerReferences(maxElements, values, cnt) {
        throw new Error("Method not implemented.");
      }
      getNextReferences(numValue, cnt) {
        throw new Error("Method not implemented.");
      }
    };
    exports2.MockContinuationPointManager = MockContinuationPointManager;
    exports2.mockSession = {
      getSessionId() {
        return new node_opcua_nodeid_1.NodeId();
      },
      continuationPointManager: new MockContinuationPointManager()
    };
  }
});

// node_modules/node-opcua-address-space/distHelpers/date_utils.js
var require_date_utils = __commonJS({
  "node_modules/node-opcua-address-space/distHelpers/date_utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.date_add = void 0;
    function date_add(date, options) {
      const date1 = new Date(date.getTime() + options.seconds * 1e3);
      date1.picoseconds = 0;
      return date1;
    }
    exports2.date_add = date_add;
  }
});

// node_modules/node-opcua-address-space/distHelpers/index.js
var require_distHelpers = __commonJS({
  "node_modules/node-opcua-address-space/distHelpers/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_add_event_generator_object(), exports2);
    __exportStar3(require_alarms_and_conditions_demo(), exports2);
    __exportStar3(require_assertHasMatchingReference(), exports2);
    __exportStar3(require_create_minimalist_address_space_nodeset(), exports2);
    __exportStar3(require_get_address_space_fixture(), exports2);
    __exportStar3(require_get_mini_address_space(), exports2);
    __exportStar3(require_boiler_system(), exports2);
    __exportStar3(require_mock_session(), exports2);
    __exportStar3(require_date_utils(), exports2);
  }
});

// node_modules/node-opcua-address-space/testHelpers.js
var require_testHelpers = __commonJS({
  "node_modules/node-opcua-address-space/testHelpers.js"(exports2, module2) {
    module2.exports = require_distHelpers();
  }
});

// node_modules/node-opcua-client/dist/client_base.js
var require_client_base = __commonJS({
  "node_modules/node-opcua-client/dist/client_base.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OPCUAClientBase = void 0;
    var node_opcua_object_registry_1 = require_dist46();
    var OPCUAClientBase = class {
      static create(options) {
        options;
        throw new Error("Not Implemented");
      }
    };
    exports2.OPCUAClientBase = OPCUAClientBase;
    OPCUAClientBase.registry = new node_opcua_object_registry_1.ObjectRegistry();
    OPCUAClientBase.retryDelay = 1e3 * 5;
  }
});

// node_modules/node-opcua-transport/dist/source/AcknowledgeMessage.js
var require_AcknowledgeMessage = __commonJS({
  "node_modules/node-opcua-transport/dist/source/AcknowledgeMessage.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AcknowledgeMessage = void 0;
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_factory_1 = require_dist26();
    var schemaAcknowledgeMessage = (0, node_opcua_factory_1.buildStructuredType)({
      name: "AcknowledgeMessage",
      baseType: "BaseObjectType",
      fields: [
        {
          name: "ProtocolVersion",
          fieldType: "UInt32",
          documentation: "The latest version of the OPC UA TCP protocol supported by the Server."
        },
        { name: "ReceiveBufferSize", fieldType: "UInt32" },
        { name: "SendBufferSize", fieldType: "UInt32" },
        { name: "MaxMessageSize", fieldType: "UInt32", documentation: "The maximum size for any request message." },
        {
          name: "MaxChunkCount",
          fieldType: "UInt32",
          documentation: "The maximum number of chunks in any request message."
        }
      ]
    });
    var AcknowledgeMessage = class extends node_opcua_factory_1.BaseUAObject {
      constructor(options) {
        options = options || {};
        super();
        const schema = schemaAcknowledgeMessage;
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.protocolVersion = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options.protocolVersion);
        this.receiveBufferSize = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options.receiveBufferSize);
        this.sendBufferSize = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options.sendBufferSize);
        this.maxMessageSize = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options.maxMessageSize);
        this.maxChunkCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options.maxChunkCount);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.protocolVersion, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.receiveBufferSize, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.sendBufferSize, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.maxMessageSize, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.maxChunkCount, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.protocolVersion = (0, node_opcua_basic_types_1.decodeUInt32)(stream);
        this.receiveBufferSize = (0, node_opcua_basic_types_1.decodeUInt32)(stream);
        this.sendBufferSize = (0, node_opcua_basic_types_1.decodeUInt32)(stream);
        this.maxMessageSize = (0, node_opcua_basic_types_1.decodeUInt32)(stream);
        this.maxChunkCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream);
      }
      toString() {
        let str = "";
        str += "protocolVersion   = " + this.protocolVersion + "\n";
        str += "receiveBufferSize = " + this.receiveBufferSize + "\n";
        str += "sendBufferSize    = " + this.sendBufferSize + "\n";
        str += "maxMessageSize    = " + this.maxMessageSize + "\n";
        str += "maxChunkCount     = " + this.maxChunkCount + "\n";
        return str;
      }
    };
    exports2.AcknowledgeMessage = AcknowledgeMessage;
    AcknowledgeMessage.possibleFields = [
      "protocolVersion",
      "receiveBufferSize",
      "sendBufferSize",
      "maxMessageSize",
      "maxChunkCount"
    ];
    AcknowledgeMessage.schema = schemaAcknowledgeMessage;
  }
});

// node_modules/node-opcua-chunkmanager/dist/read_message_header.js
var require_read_message_header = __commonJS({
  "node_modules/node-opcua-chunkmanager/dist/read_message_header.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.readMessageHeader = void 0;
    function readMessageHeader(stream) {
      const msgType = String.fromCharCode(stream.readUInt8()) + String.fromCharCode(stream.readUInt8()) + String.fromCharCode(stream.readUInt8());
      const isFinal = String.fromCharCode(stream.readUInt8());
      const length = stream.readUInt32();
      return { msgType, isFinal, length };
    }
    exports2.readMessageHeader = readMessageHeader;
  }
});

// node_modules/node-opcua-chunkmanager/dist/chunk_manager.js
var require_chunk_manager = __commonJS({
  "node_modules/node-opcua-chunkmanager/dist/chunk_manager.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ChunkManager = exports2.verify_message_chunk = void 0;
    var events_1 = require("events");
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_binary_stream_1 = require_dist18();
    var node_opcua_buffer_utils_1 = require_dist15();
    var read_message_header_1 = require_read_message_header();
    function verify_message_chunk(messageChunk) {
      (0, node_opcua_assert_1.assert)(messageChunk);
      (0, node_opcua_assert_1.assert)(messageChunk instanceof Buffer);
      const header = (0, read_message_header_1.readMessageHeader)(new node_opcua_binary_stream_1.BinaryStream(messageChunk));
      if (messageChunk.length !== header.length) {
        throw new Error(" chunk length = " + messageChunk.length + " message  length " + header.length);
      }
    }
    exports2.verify_message_chunk = verify_message_chunk;
    var ChunkManager = class extends events_1.EventEmitter {
      constructor(options) {
        super();
        this.chunkSize = options.chunkSize;
        this.headerSize = options.headerSize || 0;
        if (this.headerSize) {
          this.writeHeaderFunc = options.writeHeaderFunc;
          (0, node_opcua_assert_1.assert)(typeof this.writeHeaderFunc === "function");
        }
        this.sequenceHeaderSize = options.sequenceHeaderSize === void 0 ? 8 : options.sequenceHeaderSize;
        if (this.sequenceHeaderSize > 0) {
          this.writeSequenceHeaderFunc = options.writeSequenceHeaderFunc;
          (0, node_opcua_assert_1.assert)(typeof this.writeSequenceHeaderFunc === "function");
        }
        this.signatureLength = options.signatureLength || 0;
        this.signBufferFunc = options.signBufferFunc;
        this.plainBlockSize = options.plainBlockSize || 0;
        this.cipherBlockSize = options.cipherBlockSize || 0;
        this.dataEnd = 0;
        if (this.cipherBlockSize === 0) {
          (0, node_opcua_assert_1.assert)(this.plainBlockSize === 0);
          this.maxBodySize = this.chunkSize - this.headerSize - this.signatureLength - this.sequenceHeaderSize;
          this.encryptBufferFunc = void 0;
        } else {
          (0, node_opcua_assert_1.assert)(this.plainBlockSize !== 0);
          this.encryptBufferFunc = options.encryptBufferFunc;
          (0, node_opcua_assert_1.assert)(typeof this.encryptBufferFunc === "function", "an encryptBufferFunc is required");
          this.maxBodySize = this.plainBlockSize * Math.floor((this.chunkSize - this.headerSize - this.signatureLength - 1) / this.cipherBlockSize) - this.sequenceHeaderSize;
          this.maxBlock = Math.floor((this.chunkSize - this.headerSize) / this.cipherBlockSize);
          this.maxBodySize = this.plainBlockSize * this.maxBlock - this.sequenceHeaderSize - this.signatureLength - 1;
          if (this.plainBlockSize > 256) {
            this.maxBodySize -= 1;
          }
        }
        (0, node_opcua_assert_1.assert)(this.maxBodySize > 0);
        this.dataOffset = this.headerSize + this.sequenceHeaderSize;
        this.chunk = null;
        this.cursor = 0;
        this.pendingChunk = null;
      }
      evaluateTotalLengthAndChunks(bodySize) {
        const chunkCount = Math.ceil(bodySize / this.maxBodySize);
        const totalLength = this.chunkSize * chunkCount;
        return { totalLength, chunkCount };
      }
      write(buffer, length) {
        length = length || buffer.length;
        (0, node_opcua_assert_1.assert)(buffer instanceof Buffer || buffer === null);
        (0, node_opcua_assert_1.assert)(length > 0);
        let l2 = length;
        let inputCursor = 0;
        while (l2 > 0) {
          (0, node_opcua_assert_1.assert)(length - inputCursor !== 0);
          if (this.cursor === 0) {
            this._push_pending_chunk(false);
          }
          const spaceLeft = this.maxBodySize - this.cursor;
          const nbToWrite = Math.min(length - inputCursor, spaceLeft);
          this.chunk = this.chunk || (0, node_opcua_buffer_utils_1.createFastUninitializedBuffer)(this.chunkSize);
          if (buffer) {
            buffer.copy(this.chunk, this.cursor + this.dataOffset, inputCursor, inputCursor + nbToWrite);
          }
          inputCursor += nbToWrite;
          this.cursor += nbToWrite;
          if (this.cursor >= this.maxBodySize) {
            this._post_process_current_chunk();
          }
          l2 -= nbToWrite;
        }
      }
      end() {
        if (this.cursor > 0) {
          this._post_process_current_chunk();
        }
        this._push_pending_chunk(true);
      }
      /**
       * compute the signature of the chunk and append it at the end
       * of the data block.
       *
       * @method _write_signature
       * @private
       */
      _write_signature(chunk) {
        if (this.signBufferFunc) {
          (0, node_opcua_assert_1.assert)(typeof this.signBufferFunc === "function");
          (0, node_opcua_assert_1.assert)(this.signatureLength !== 0);
          const signatureStart = this.dataEnd;
          const sectionToSign = chunk.subarray(0, signatureStart);
          const signature = this.signBufferFunc(sectionToSign);
          (0, node_opcua_assert_1.assert)(signature.length === this.signatureLength, "expecting signature length to match");
          signature.copy(chunk, signatureStart);
        } else {
          (0, node_opcua_assert_1.assert)(this.signatureLength === 0, "expecting NO SIGN");
        }
      }
      _encrypt(chunk) {
        if (this.plainBlockSize > 0) {
          (0, node_opcua_assert_1.assert)(this.dataEnd !== void 0);
          const startEncryptionPos = this.headerSize;
          const endEncryptionPos = this.dataEnd + this.signatureLength;
          const areaToEncrypt = chunk.subarray(startEncryptionPos, endEncryptionPos);
          (0, node_opcua_assert_1.assert)(areaToEncrypt.length % this.plainBlockSize === 0);
          const nbBlock = areaToEncrypt.length / this.plainBlockSize;
          const encryptedBuffer = this.encryptBufferFunc(areaToEncrypt);
          (0, node_opcua_assert_1.assert)(encryptedBuffer.length % this.cipherBlockSize === 0);
          (0, node_opcua_assert_1.assert)(encryptedBuffer.length === nbBlock * this.cipherBlockSize);
          encryptedBuffer.copy(chunk, this.headerSize, 0);
        }
      }
      _push_pending_chunk(isLast) {
        if (this.pendingChunk) {
          const expectedLength = this.pendingChunk.length;
          if (this.headerSize > 0) {
            this.writeHeaderFunc(this.pendingChunk.subarray(0, this.headerSize), isLast, expectedLength);
          }
          if (this.sequenceHeaderSize > 0) {
            this.writeSequenceHeaderFunc(this.pendingChunk.subarray(this.headerSize, this.headerSize + this.sequenceHeaderSize));
          }
          this._write_signature(this.pendingChunk);
          this._encrypt(this.pendingChunk);
          this.emit("chunk", this.pendingChunk, isLast);
          this.pendingChunk = null;
        }
      }
      _write_padding_bytes(nbPaddingByteTotal) {
        const nbPaddingByte = nbPaddingByteTotal % 256;
        const extraNbPaddingByte = Math.floor(nbPaddingByteTotal / 256);
        (0, node_opcua_assert_1.assert)(extraNbPaddingByte === 0 || this.plainBlockSize > 256, "extraNbPaddingByte only requested when key size > 2048");
        this.chunk.writeUInt8(nbPaddingByte, this.cursor + this.dataOffset);
        this.cursor += 1;
        for (let i = 0; i < nbPaddingByteTotal; i++) {
          this.chunk.writeUInt8(nbPaddingByte, this.cursor + this.dataOffset + i);
        }
        this.cursor += nbPaddingByteTotal;
        if (this.plainBlockSize > 256) {
          this.chunk.writeUInt8(extraNbPaddingByte, this.cursor + this.dataOffset);
          this.cursor += 1;
        }
      }
      _post_process_current_chunk() {
        let extraEncryptionBytes = 0;
        if (this.plainBlockSize > 0) {
          let curLength = this.sequenceHeaderSize + this.cursor + this.signatureLength;
          if (this.plainBlockSize > 256) {
            curLength += 2;
          } else {
            curLength += 1;
          }
          const n = curLength % this.plainBlockSize;
          const nbPaddingByteTotal = (this.plainBlockSize - n) % this.plainBlockSize;
          this._write_padding_bytes(nbPaddingByteTotal);
          const adjustedLength = this.sequenceHeaderSize + this.cursor + this.signatureLength;
          (0, node_opcua_assert_1.assert)(adjustedLength % this.plainBlockSize === 0);
          const nbBlock = adjustedLength / this.plainBlockSize;
          extraEncryptionBytes = nbBlock * (this.cipherBlockSize - this.plainBlockSize);
        }
        this.dataEnd = this.dataOffset + this.cursor;
        const expectedLength = this.dataEnd + this.signatureLength + extraEncryptionBytes;
        this.pendingChunk = this.chunk.subarray(0, expectedLength);
        this.chunk = null;
        this.cursor = 0;
      }
    };
    exports2.ChunkManager = ChunkManager;
  }
});

// node_modules/node-opcua-chunkmanager/dist/SequenceHeader.js
var require_SequenceHeader = __commonJS({
  "node_modules/node-opcua-chunkmanager/dist/SequenceHeader.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SequenceHeader = void 0;
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_factory_1 = require_dist26();
    var schemaSequenceHeader = (0, node_opcua_factory_1.buildStructuredType)({
      baseType: "BaseUAObject",
      fields: [
        // A monotonically increasing sequence number assigned by the sender to each
        // MessageChunk sent over the ClientSecureChannelLayer.
        { name: "SequenceNumber", fieldType: "UInt32" },
        // An identifier assigned by the client to OPC UA request Message. All MessageChunks for
        // the request and the associated response use the same identifier.
        { name: "RequestId", fieldType: "UInt32" }
      ],
      name: "SequenceHeader"
    });
    var SequenceHeader = class extends node_opcua_factory_1.BaseUAObject {
      constructor(options) {
        options = options || {};
        super();
        const schema = schemaSequenceHeader;
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.sequenceNumber = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options.sequenceNumber);
        this.requestId = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options.requestId);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.sequenceNumber, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.requestId, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.sequenceNumber = (0, node_opcua_basic_types_1.decodeUInt32)(stream);
        this.requestId = (0, node_opcua_basic_types_1.decodeUInt32)(stream);
      }
    };
    exports2.SequenceHeader = SequenceHeader;
    SequenceHeader.possibleFields = ["sequenceNumber", "requestId"];
    SequenceHeader.schema = schemaSequenceHeader;
    SequenceHeader.prototype.schema = SequenceHeader.schema;
  }
});

// node_modules/node-opcua-chunkmanager/dist/index.js
var require_dist58 = __commonJS({
  "node_modules/node-opcua-chunkmanager/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_chunk_manager(), exports2);
    __exportStar3(require_read_message_header(), exports2);
    __exportStar3(require_SequenceHeader(), exports2);
  }
});

// node_modules/node-opcua-packet-assembler/dist/packet_assembler.js
var require_packet_assembler = __commonJS({
  "node_modules/node-opcua-packet-assembler/dist/packet_assembler.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PacketAssembler = exports2.PacketAssemblerErrorCode = void 0;
    var events_1 = require("events");
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_debug_1 = require_dist24();
    var doDebug = false;
    var warningLog = (0, node_opcua_debug_1.make_warningLog)("PacketAssembler");
    var PacketAssemblerErrorCode;
    (function(PacketAssemblerErrorCode2) {
      PacketAssemblerErrorCode2[PacketAssemblerErrorCode2["ChunkSizeExceeded"] = 1] = "ChunkSizeExceeded";
      PacketAssemblerErrorCode2[PacketAssemblerErrorCode2["ChunkTooSmall"] = 2] = "ChunkTooSmall";
    })(PacketAssemblerErrorCode || (exports2.PacketAssemblerErrorCode = PacketAssemblerErrorCode = {}));
    var PacketAssembler = class _PacketAssembler extends events_1.EventEmitter {
      constructor(options) {
        super();
        this._stack = [];
        this.expectedLength = 0;
        this.currentLength = 0;
        this.readChunkFunc = options.readChunkFunc;
        this.minimumSizeInBytes = options.minimumSizeInBytes || 8;
        (0, node_opcua_assert_1.assert)(typeof this.readChunkFunc === "function", "packet assembler requires a readChunkFunc");
        (0, node_opcua_assert_1.assert)(options.maxChunkSize === void 0 || options.maxChunkSize !== 0);
        this.maxChunkSize = options.maxChunkSize || _PacketAssembler.defaultMaxMessageSize;
        (0, node_opcua_assert_1.assert)(this.maxChunkSize >= this.minimumSizeInBytes);
      }
      feed(data) {
        let messageChunk;
        if (this.expectedLength === 0 && this.currentLength + data.length >= this.minimumSizeInBytes) {
          if (this._stack.length > 0) {
            data = this._buildData(data);
            this.currentLength = 0;
          }
          this.packetInfo = this._readPacketInfo(data);
          (0, node_opcua_assert_1.assert)(this.currentLength === 0);
          if (this.packetInfo.length < this.minimumSizeInBytes) {
            this.emit("error", new Error("chunk is too small "), PacketAssemblerErrorCode.ChunkTooSmall);
            return;
          }
          if (this.packetInfo.length > this.maxChunkSize) {
            const message = `maximum chunk size exceeded (maxChunkSize=${this.maxChunkSize} current chunk size = ${this.packetInfo.length})`;
            warningLog(message);
            this.emit("error", new Error(message), PacketAssemblerErrorCode.ChunkSizeExceeded);
            return;
          }
          this.emit("startChunk", this.packetInfo, data);
          this.expectedLength = this.packetInfo.length;
        }
        if (this.expectedLength === 0 || this.currentLength + data.length < this.expectedLength) {
          this._stack.push(data);
          this.currentLength += data.length;
        } else if (this.currentLength + data.length === this.expectedLength) {
          this.currentLength += data.length;
          messageChunk = this._buildData(data);
          if (doDebug) {
            const packetInfo = this._readPacketInfo(messageChunk);
            (0, node_opcua_assert_1.assert)(this.packetInfo && this.packetInfo.length === packetInfo.length);
            (0, node_opcua_assert_1.assert)(messageChunk.length === packetInfo.length);
          }
          this.currentLength = 0;
          this.expectedLength = 0;
          this.emit("chunk", messageChunk);
        } else {
          const size1 = this.expectedLength - this.currentLength;
          if (size1 > 0) {
            const chunk1 = data.subarray(0, size1);
            this.feed(chunk1);
          }
          const chunk2 = data.subarray(size1);
          if (chunk2.length > 0) {
            this.feed(chunk2);
          }
        }
      }
      _readPacketInfo(data) {
        return this.readChunkFunc(data);
      }
      _buildData(data) {
        if (data && this._stack.length === 0) {
          return data;
        }
        if (!data && this._stack.length === 1) {
          data = this._stack[0];
          this._stack.length = 0;
          return data;
        }
        this._stack.push(data);
        data = Buffer.concat(this._stack);
        this._stack.length = 0;
        return data;
      }
    };
    exports2.PacketAssembler = PacketAssembler;
    PacketAssembler.defaultMaxChunkCount = 777;
    PacketAssembler.defaultMaxMessageSize = 1024 * 64 - 7;
  }
});

// node_modules/node-opcua-packet-assembler/dist/index.js
var require_dist59 = __commonJS({
  "node_modules/node-opcua-packet-assembler/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_packet_assembler(), exports2);
  }
});

// node_modules/node-opcua-transport/dist/source/status_codes.js
var require_status_codes = __commonJS({
  "node_modules/node-opcua-transport/dist/source/status_codes.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.StatusCodes2 = void 0;
    var node_opcua_status_code_1 = require_dist22();
    exports2.StatusCodes2 = {
      /**
       * The Server cannot process the request because it is too busy.
       *
       * It is up to the Server to determine when it needs to return this Message.
       *
       * A Server can control the how frequently a Client reconnects by waiting to return this error.
       */
      BadTcpServerTooBusy: node_opcua_status_code_1.StatusCodes.BadTcpServerTooBusy,
      /**
       * The type of the Message specified in the header invalid.
       * Each Message starts with a 4-byte sequence of ASCII values that identifies the Message type.
       * The Server returns this error if the Message type is not accepted.
       * Some of the Message types are defined by the SecureChannel layer.
       */
      BadTcpMessageTypeInvalid: node_opcua_status_code_1.StatusCodes.BadTcpMessageTypeInvalid,
      /**
       * The SecureChannelId and/or TokenId are not currently in use.
       * This error is reported by the SecureChannel layer.
       */
      BadTcpSecureChannelUnknown: node_opcua_status_code_1.StatusCodes.BadTcpSecureChannelUnknown,
      /**
       * The size of the Message specified in the header is too large.
       * The Server returns this error if the Message size exceeds its maximum buffer size
       * or the receive buffer size negotiated during the Hello/Acknowledge exchange.
       */
      BadTcpMessageTooLarge: node_opcua_status_code_1.StatusCodes.BadTcpMessageTooLarge,
      /**
       * A timeout occurred while accessing a resource.
       * It is up to the Server to determine when a timeout occurs.
       */
      BadTimeout: node_opcua_status_code_1.StatusCodes.BadTimeout,
      /**
       * There are not enough resources to process the request.
       * The Server returns this error when it runs out of memory or encounters similar resource problems.
       * A Server can control the how frequently a Client reconnects by waiting to return this error.
       */
      BadTcpNotEnoughResources: node_opcua_status_code_1.StatusCodes.BadTcpNotEnoughResources,
      /**
       * An internal error occurred.
       * This should only be returned if an unexpected configuration or programming error occurs.
       */
      BadTcpInternalError: node_opcua_status_code_1.StatusCodes.BadTcpInternalError,
      /**
       * The Server does not recognize the EndpointUrl specified.
       */
      BadTcpEndpointUrlInvalid: node_opcua_status_code_1.StatusCodes.BadTcpEndpointUrlInvalid,
      /**
       * The Message was rejected because it could not be verified.
       */
      BadSecurityChecksFailed: node_opcua_status_code_1.StatusCodes.BadSecurityChecksFailed,
      /**
       * The request could not be sent because of a network interruption.
       */
      BadRequestInterrupted: node_opcua_status_code_1.StatusCodes.BadRequestInterrupted,
      /**
       * Timeout occurred while processing the request.
       */
      BadRequestTimeout: node_opcua_status_code_1.StatusCodes.BadRequestTimeout,
      /**
       * The secure channel has been closed.
       */
      BadSecureChannelClosed: node_opcua_status_code_1.StatusCodes.BadSecureChannelClosed,
      /**
       * The SecurityToken has expired or is not recognized. BadSecureChannelTokenUnknown
       */
      BadSecureChannelTokenUnknown: node_opcua_status_code_1.StatusCodes.BadSecureChannelTokenUnknown,
      /**
       * The sender Certificate is not trusted by the receiver.
       */
      BadCertificateUntrusted: node_opcua_status_code_1.StatusCodes.BadCertificateUntrusted,
      /**
       * The sender Certificate has expired or is not yet valid.
       */
      BadCertificateTimeInvalid: node_opcua_status_code_1.StatusCodes.BadCertificateTimeInvalid,
      /**
       * The issuer for the sender Certificate has expired or is not yet valid.
       */
      BadCertificateIssuerTimeInvalid: node_opcua_status_code_1.StatusCodes.BadCertificateIssuerTimeInvalid,
      /**
       * The sender’s Certificate may not be used for establishing a secure channel.
       */
      BadCertificateUseNotAllowed: node_opcua_status_code_1.StatusCodes.BadCertificateUseNotAllowed,
      /**
       * The issuer Certificate may not be used as a Certificate Authority.
       */
      BadCertificateIssuerUseNotAllowed: node_opcua_status_code_1.StatusCodes.BadCertificateIssuerUseNotAllowed,
      /**
       * Could not verify the revocation status of the sender’s Certificate.
       */
      BadCertificateRevocationUnknown: node_opcua_status_code_1.StatusCodes.BadCertificateRevocationUnknown,
      /**
       * Could not verify the revocation status of the issuer Certificate.
       */
      BadCertificateIssuerRevocationUnknown: node_opcua_status_code_1.StatusCodes.BadCertificateIssuerRevocationUnknown,
      /**
       * The sender Certificate has been revoked by the issuer.
       */
      BadCertificateRevoked: node_opcua_status_code_1.StatusCodes.BadCertificateRevoked
      /**The issuer Certificate has been revoked by its issuer.
       */
      // todo  BadIssuerCertificateRevoked: StatusCodes.BadIssuerCertificateRevoked,
      /** The receiver Certificate thumbprint is not recognized by the receiver.
       */
      // todo .. BadCertificateUnknown: StatusCodes.BadCertificateUnknown
    };
  }
});

// node_modules/node-opcua-transport/dist/source/message_builder_base.js
var require_message_builder_base = __commonJS({
  "node_modules/node-opcua-transport/dist/source/message_builder_base.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.MessageBuilderBase = exports2.readRawMessageHeader = void 0;
    var events_1 = require("events");
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_binary_stream_1 = require_dist18();
    var node_opcua_buffer_utils_1 = require_dist15();
    var node_opcua_chunkmanager_1 = require_dist58();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_packet_assembler_1 = require_dist59();
    var node_opcua_utils_1 = require_dist16();
    var status_codes_1 = require_status_codes();
    var doPerfMonitoring = process.env.NODEOPCUADEBUG && process.env.NODEOPCUADEBUG.indexOf("PERF") >= 0;
    var errorLog = (0, node_opcua_debug_1.make_errorLog)("MessageBuilder");
    var debugLog = (0, node_opcua_debug_1.make_debugLog)("MessageBuilder");
    var warningLog = (0, node_opcua_debug_1.make_warningLog)("MessageBuilder");
    function readRawMessageHeader(data) {
      const messageHeader = (0, node_opcua_chunkmanager_1.readMessageHeader)(new node_opcua_binary_stream_1.BinaryStream(data));
      return {
        extra: "",
        length: messageHeader.length,
        messageHeader
      };
    }
    exports2.readRawMessageHeader = readRawMessageHeader;
    var MessageBuilderBase = class _MessageBuilderBase extends events_1.EventEmitter {
      constructor(options) {
        super();
        this.id = "";
        this._tick0 = 0;
        this._tick1 = 0;
        this._hasReceivedError = false;
        this.blocks = [];
        this.messageChunks = [];
        this._expectedChannelId = 0;
        options = options || {
          maxMessageSize: 0,
          maxChunkCount: 0,
          maxChunkSize: 0
        };
        this.signatureLength = options.signatureLength || 0;
        this.maxMessageSize = options.maxMessageSize || _MessageBuilderBase.defaultMaxMessageSize;
        this.maxChunkCount = options.maxChunkCount || _MessageBuilderBase.defaultMaxChunkCount;
        this.maxChunkSize = options.maxChunkSize || _MessageBuilderBase.defaultMaxChunkSize;
        this.options = options;
        this._packetAssembler = new node_opcua_packet_assembler_1.PacketAssembler({
          minimumSizeInBytes: 8,
          maxChunkSize: this.maxChunkSize,
          readChunkFunc: readRawMessageHeader
        });
        this._packetAssembler.on("chunk", (messageChunk) => this._feed_messageChunk(messageChunk));
        this._packetAssembler.on("startChunk", (info, data) => {
          if (doPerfMonitoring) {
            this._tick0 = (0, node_opcua_utils_1.get_clock_tick)();
          }
          this.emit("startChunk", info, data);
        });
        this._packetAssembler.on("error", (err) => {
          warningLog("packet assembler ", err.message);
          return this._report_error(status_codes_1.StatusCodes2.BadTcpMessageTooLarge, "packet assembler: " + err.message);
        });
        this._securityDefeated = false;
        this.totalBodySize = 0;
        this.totalMessageSize = 0;
        this.channelId = 0;
        this.offsetBodyStart = 0;
        this.sequenceHeader = null;
        this._init_new();
      }
      dispose() {
        this.removeAllListeners();
      }
      /**
       * Feed message builder with some data
       * @method feed
       * @param data
       */
      feed(data) {
        if (!this._securityDefeated && !this._hasReceivedError) {
          this._packetAssembler.feed(data);
        }
      }
      _decodeMessageBody(fullMessageBody) {
        return true;
      }
      _read_headers(binaryStream) {
        try {
          this.messageHeader = (0, node_opcua_chunkmanager_1.readMessageHeader)(binaryStream);
          (0, node_opcua_assert_1.assert)(binaryStream.length === 8, "expecting message header to be 8 bytes");
          this.channelId = binaryStream.readUInt32();
          (0, node_opcua_assert_1.assert)(binaryStream.length === 12);
          if (this._expectedChannelId && this.channelId !== this._expectedChannelId) {
            return this._report_error(status_codes_1.StatusCodes2.BadTcpSecureChannelUnknown, "Invalid secure channel Id");
          }
          return true;
        } catch (err) {
          return this._report_error(status_codes_1.StatusCodes2.BadTcpInternalError, "_read_headers error " + err.message);
        }
      }
      _report_abandon(channelId, tokenId, sequenceHeader) {
        this._hasReceivedError = false;
        this.emit("abandon", sequenceHeader.requestId);
        return false;
      }
      _report_error(statusCode, errorMessage) {
        this._hasReceivedError = true;
        debugLog("Error  ", this.id, errorMessage);
        this.emit("error", new Error(errorMessage), statusCode, this.sequenceHeader?.requestId || null);
        return false;
      }
      _init_new() {
        this._securityDefeated = false;
        this._hasReceivedError = false;
        this.totalBodySize = 0;
        this.totalMessageSize = 0;
        this.blocks = [];
        this.messageChunks = [];
      }
      /**
       * append a message chunk
       * @method _append
       * @param chunk
       * @private
       */
      _append(chunk) {
        if (this._hasReceivedError) {
          return false;
        }
        if (this.messageChunks.length + 1 > this.maxChunkCount) {
          return this._report_error(status_codes_1.StatusCodes2.BadTcpMessageTooLarge, `max chunk count exceeded: ${this.maxChunkCount}`);
        }
        this.messageChunks.push(chunk);
        this.totalMessageSize += chunk.length;
        if (this.totalMessageSize > this.maxMessageSize) {
          return this._report_error(status_codes_1.StatusCodes2.BadTcpMessageTooLarge, `max message size exceeded: ${this.maxMessageSize} : total message size ${this.totalMessageSize}`);
        }
        const binaryStream = new node_opcua_binary_stream_1.BinaryStream(chunk);
        if (!this._read_headers(binaryStream)) {
          return this._report_error(status_codes_1.StatusCodes2.BadTcpInternalError, `Invalid message header detected`);
        }
        (0, node_opcua_assert_1.assert)(binaryStream.length >= 12);
        if (this.messageHeader.length !== chunk.length) {
          return this._report_error(status_codes_1.StatusCodes2.BadTcpInternalError, `Invalid messageChunk size: the provided chunk is ${chunk.length} bytes long but header specifies ${this.messageHeader.length}`);
        }
        const offsetBodyStart = binaryStream.length;
        const offsetBodyEnd = binaryStream.buffer.length;
        this.totalBodySize += offsetBodyEnd - offsetBodyStart;
        this.offsetBodyStart = offsetBodyStart;
        const sharedBuffer = chunk.subarray(this.offsetBodyStart, offsetBodyEnd);
        const clonedBuffer = (0, node_opcua_buffer_utils_1.createFastUninitializedBuffer)(sharedBuffer.length);
        sharedBuffer.copy(clonedBuffer, 0, 0);
        this.blocks.push(clonedBuffer);
        return true;
      }
      _feed_messageChunk(chunk) {
        (0, node_opcua_assert_1.assert)(chunk);
        const messageHeader = (0, node_opcua_chunkmanager_1.readMessageHeader)(new node_opcua_binary_stream_1.BinaryStream(chunk));
        this.emit("chunk", chunk);
        if (messageHeader.isFinal === "F") {
          if (messageHeader.msgType === "ERR") {
            const binaryStream = new node_opcua_binary_stream_1.BinaryStream(chunk);
            binaryStream.length = 8;
            const errorCode = (0, node_opcua_basic_types_1.decodeStatusCode)(binaryStream);
            const message = (0, node_opcua_basic_types_1.decodeString)(binaryStream);
            this._report_error(errorCode, message || "Error message not specified");
            return true;
          } else {
            this._append(chunk);
            if (this._hasReceivedError) {
              return false;
            }
            const fullMessageBody = this.blocks.length === 1 ? this.blocks[0] : Buffer.concat(this.blocks);
            if (doPerfMonitoring) {
              this._tick1 = (0, node_opcua_utils_1.get_clock_tick)();
            }
            this.emit("full_message_body", fullMessageBody);
            const messageOk = this._decodeMessageBody(fullMessageBody);
            this._init_new();
            return messageOk;
          }
        } else if (messageHeader.isFinal === "A") {
          try {
            const stream = new node_opcua_binary_stream_1.BinaryStream(chunk);
            (0, node_opcua_chunkmanager_1.readMessageHeader)(stream);
            (0, node_opcua_assert_1.assert)(stream.length === 8);
            const channelId = stream.readUInt32();
            const tokenId = (0, node_opcua_basic_types_1.decodeUInt32)(stream);
            const sequenceHeader = new node_opcua_chunkmanager_1.SequenceHeader();
            sequenceHeader.decode(stream);
            return this._report_abandon(channelId, tokenId, sequenceHeader);
          } catch (err) {
            warningLog((0, node_opcua_debug_1.hexDump)(chunk));
            warningLog("Cannot interpret message chunk: ", err.message);
            return this._report_error(status_codes_1.StatusCodes2.BadTcpInternalError, "Error decoding message header " + err.message);
          }
        } else if (messageHeader.isFinal === "C") {
          return this._append(chunk);
        }
        return false;
      }
    };
    exports2.MessageBuilderBase = MessageBuilderBase;
    MessageBuilderBase.defaultMaxChunkCount = 1e3;
    MessageBuilderBase.defaultMaxMessageSize = 1024 * 64 * 1024;
    MessageBuilderBase.defaultMaxChunkSize = 1024 * 8;
  }
});

// node_modules/node-opcua-transport/dist/source/utils.js
var require_utils6 = __commonJS({
  "node_modules/node-opcua-transport/dist/source/utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.doTraceIncomingChunk = exports2.doTraceChunk = exports2.doTraceHelloAck = void 0;
    var transportFlag = (process.env?.NODEOPCUADEBUG?.match(/TRANSPORT{([^}]*)}/) || [])[1] || "";
    exports2.doTraceHelloAck = !!transportFlag.match(/HELACK/);
    exports2.doTraceChunk = !!transportFlag.match(/CHUNK/);
    exports2.doTraceIncomingChunk = !!transportFlag.match(/FLOW/);
  }
});

// node_modules/node-opcua-transport/dist/source/TCPErrorMessage.js
var require_TCPErrorMessage = __commonJS({
  "node_modules/node-opcua-transport/dist/source/TCPErrorMessage.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.TCPErrorMessage = void 0;
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_factory_1 = require_dist26();
    var node_opcua_status_code_1 = require_dist22();
    var schemaTCPErrorMessage = (0, node_opcua_factory_1.buildStructuredType)({
      name: "TCPErrorMessage",
      baseType: "BaseUAObject",
      fields: [
        { name: "StatusCode", fieldType: "StatusCode" },
        { name: "Reason", fieldType: "String" }
        // A more verbose description of the error.
      ]
    });
    var TCPErrorMessage = class extends node_opcua_factory_1.BaseUAObject {
      constructor(options) {
        options = options || {};
        const schema = schemaTCPErrorMessage;
        super();
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.statusCode = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options.statusCode);
        this.reason = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options.reason);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_status_code_1.encodeStatusCode)(this.statusCode, stream);
        (0, node_opcua_basic_types_1.encodeString)(this.reason, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.statusCode = (0, node_opcua_status_code_1.decodeStatusCode)(stream);
        this.reason = (0, node_opcua_basic_types_1.decodeString)(stream);
      }
    };
    exports2.TCPErrorMessage = TCPErrorMessage;
    TCPErrorMessage.possibleFields = ["statusCode", "reason"];
  }
});

// node_modules/node-opcua-transport/dist/source/tools.js
var require_tools2 = __commonJS({
  "node_modules/node-opcua-transport/dist/source/tools.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.writeTCPMessageHeader = exports2.is_valid_endpointUrl = exports2.parseEndpointUrl = exports2.packTcpMessage = exports2.decodeMessage = void 0;
    var url_1 = __importDefault3(require("url"));
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_binary_stream_1 = require_dist18();
    var node_opcua_buffer_utils_1 = require_dist15();
    var node_opcua_chunkmanager_1 = require_dist58();
    var TCPErrorMessage_1 = require_TCPErrorMessage();
    function is_valid_msg_type(msgType) {
      (0, node_opcua_assert_1.assert)([
        "HEL",
        "ACK",
        "ERR",
        // Connection Layer
        "OPN",
        "MSG",
        "CLO"
        // OPC Unified Architecture, Part 6 page 36
      ].indexOf(msgType) >= 0, "invalid message type  " + msgType);
      return true;
    }
    function decodeMessage(stream, classNameConstructor) {
      (0, node_opcua_assert_1.assert)(stream instanceof node_opcua_binary_stream_1.BinaryStream);
      (0, node_opcua_assert_1.assert)(classNameConstructor instanceof Function, " expecting a function for " + classNameConstructor);
      const header = (0, node_opcua_chunkmanager_1.readMessageHeader)(stream);
      (0, node_opcua_assert_1.assert)(stream.length === 8);
      let obj;
      if (header.msgType === "ERR") {
        obj = new TCPErrorMessage_1.TCPErrorMessage();
        obj.decode(stream);
        return obj;
      } else {
        obj = new classNameConstructor();
        obj.decode(stream);
        return obj;
      }
    }
    exports2.decodeMessage = decodeMessage;
    function packTcpMessage(msgType, encodableObject) {
      (0, node_opcua_assert_1.assert)(is_valid_msg_type(msgType));
      const messageChunk = (0, node_opcua_buffer_utils_1.createFastUninitializedBuffer)(encodableObject.binaryStoreSize() + 8);
      const stream = new node_opcua_binary_stream_1.BinaryStream(messageChunk);
      encodeMessage(msgType, encodableObject, stream);
      return messageChunk;
    }
    exports2.packTcpMessage = packTcpMessage;
    function parseEndpointUrl(endpointUrl) {
      const _url = url_1.default.parse(endpointUrl);
      if (!_url.protocol || !_url.hostname) {
        throw new Error("Invalid endpoint url " + endpointUrl);
      }
      return _url;
    }
    exports2.parseEndpointUrl = parseEndpointUrl;
    function is_valid_endpointUrl(endpointUrl) {
      const e = parseEndpointUrl(endpointUrl);
      return Object.prototype.hasOwnProperty.call(e, "hostname");
    }
    exports2.is_valid_endpointUrl = is_valid_endpointUrl;
    function writeTCPMessageHeader(msgType, chunkType, totalLength, stream) {
      if (stream instanceof Buffer) {
        stream = new node_opcua_binary_stream_1.BinaryStream(stream);
      }
      (0, node_opcua_assert_1.assert)(is_valid_msg_type(msgType));
      (0, node_opcua_assert_1.assert)(["A", "F", "C"].indexOf(chunkType) !== -1);
      stream.writeUInt8(msgType.charCodeAt(0));
      stream.writeUInt8(msgType.charCodeAt(1));
      stream.writeUInt8(msgType.charCodeAt(2));
      stream.writeUInt8(chunkType.charCodeAt(0));
      stream.writeUInt32(totalLength);
    }
    exports2.writeTCPMessageHeader = writeTCPMessageHeader;
    function encodeMessage(msgType, messageContent, stream) {
      const totalLength = messageContent.binaryStoreSize() + 8;
      writeTCPMessageHeader(msgType, "F", totalLength, stream);
      messageContent.encode(stream);
      (0, node_opcua_assert_1.assert)(totalLength === stream.length, "invalid message size");
    }
  }
});

// node_modules/node-opcua-transport/dist/source/tcp_transport.js
var require_tcp_transport = __commonJS({
  "node_modules/node-opcua-transport/dist/source/tcp_transport.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.TCP_transport = exports2.getFakeTransport = exports2.setFakeTransport = void 0;
    var events_1 = require("events");
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_object_registry_1 = require_dist46();
    var node_opcua_packet_assembler_1 = require_dist59();
    var status_codes_1 = require_status_codes();
    var message_builder_base_1 = require_message_builder_base();
    var utils_1 = require_utils6();
    var TCPErrorMessage_1 = require_TCPErrorMessage();
    var tools_1 = require_tools2();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)("TRANSPORT");
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)("TRANSPORT");
    var errorLog = (0, node_opcua_debug_1.make_errorLog)("TRANSPORT");
    var warningLog = (0, node_opcua_debug_1.make_warningLog)("TRANSPORT");
    var doDebugFlow = false;
    var defaultFakeSocket = {
      invalid: true,
      destroyed: false,
      destroy(err) {
        this.destroyed = true;
        errorLog("MockSocket.destroy");
      },
      end() {
        errorLog("MockSocket.end");
      },
      write(data, callback) {
        if (callback) {
          callback();
        }
      },
      setKeepAlive(enable, initialDelay) {
        return this;
      },
      setNoDelay(noDelay) {
        return this;
      },
      setTimeout(timeout, callback) {
        return this;
      }
    };
    var fakeSocket = defaultFakeSocket;
    function setFakeTransport(mockSocket) {
      fakeSocket = mockSocket;
    }
    exports2.setFakeTransport = setFakeTransport;
    function getFakeTransport() {
      if (fakeSocket.invalid) {
        throw new Error("getFakeTransport: setFakeTransport must be called first  - BadProtocolVersionUnsupported");
      }
      process.nextTick(() => fakeSocket.emit("connect"));
      return fakeSocket;
    }
    exports2.getFakeTransport = getFakeTransport;
    var counter = 0;
    var TCP_transport = class _TCP_transport extends events_1.EventEmitter {
      constructor() {
        super();
        this._closedEmitted = void 0;
        this._isDisconnecting = false;
        this._theCloseError = null;
        this.name = this.constructor.name + counter;
        counter += 1;
        this._timerId = null;
        this._timeout = 5e3;
        this._socket = null;
        this.headerSize = 8;
        this.maxMessageSize = 0;
        this.maxChunkCount = 0;
        this.receiveBufferSize = 0;
        this.sendBufferSize = 0;
        this.protocolVersion = 0;
        this.bytesWritten = 0;
        this.bytesRead = 0;
        this._theCallback = void 0;
        this.chunkWrittenCount = 0;
        this.chunkReadCount = 0;
        _TCP_transport.registry.register(this);
      }
      toString() {
        let str = "\n";
        str += " name.............. = " + this.name + "\n";
        str += " protocolVersion... = " + this.protocolVersion + "\n";
        str += " maxMessageSize.... = " + this.maxMessageSize + "\n";
        str += " maxChunkCount..... = " + this.maxChunkCount + "\n";
        str += " receiveBufferSize. = " + this.receiveBufferSize + "\n";
        str += " sendBufferSize.... = " + this.sendBufferSize + "\n";
        str += " bytesRead......... = " + this.bytesRead + "\n";
        str += " bytesWritten...... = " + this.bytesWritten + "\n";
        str += " chunkWrittenCount. = " + this.chunkWrittenCount + "\n";
        str += " chunkReadCount.... = " + this.chunkReadCount + "\n";
        str += " closeEmitted ? ....= " + this._closedEmitted + "\n";
        return str;
      }
      setLimits({ receiveBufferSize, sendBufferSize, maxMessageSize, maxChunkCount }) {
        this.receiveBufferSize = receiveBufferSize;
        this.sendBufferSize = sendBufferSize;
        this.maxMessageSize = maxMessageSize;
        this.maxChunkCount = maxChunkCount;
        if (maxChunkCount !== 0) {
          if (maxMessageSize / sendBufferSize > maxChunkCount) {
            const expectedMaxChunkCount = Math.ceil(maxMessageSize / sendBufferSize);
            warningLog(`Warning: maxChunkCount is not big enough : maxMessageSize / sendBufferSize ${expectedMaxChunkCount} > maxChunkCount ${maxChunkCount}`);
          }
          if (maxMessageSize / receiveBufferSize > maxChunkCount) {
            const expectedMaxChunkCount = Math.ceil(maxMessageSize / receiveBufferSize);
            warningLog(`Warning: maxChunkCount is not big enough :maxMessageSize / sendBufferSize ${expectedMaxChunkCount} > maxChunkCount ${maxChunkCount}`);
          }
        }
        this._install_packetAssembler();
      }
      get timeout() {
        return this._timeout;
      }
      set timeout(value) {
        (0, node_opcua_assert_1.assert)(!this._timerId);
        debugLog("Setting socket " + this.name + " timeout = ", value);
        this._timeout = value;
      }
      dispose() {
        this._cleanup_timers();
        (0, node_opcua_assert_1.assert)(!this._timerId);
        if (this._socket) {
          this._socket.destroy();
          this._socket = null;
        }
        _TCP_transport.registry.unregister(this);
      }
      /**
       * write the message_chunk on the socket.
       * @method write
       * @param messageChunk
       */
      write(messageChunk, callback) {
        const header = (0, message_builder_base_1.readRawMessageHeader)(messageChunk);
        (0, node_opcua_assert_1.assert)(header.length === messageChunk.length);
        const c2 = header.messageHeader.isFinal;
        (0, node_opcua_assert_1.assert)(c2 === "F" || c2 === "C" || c2 === "A");
        this._write_chunk(messageChunk, (err) => {
          callback && callback(err);
        });
      }
      isDisconnecting() {
        return !this._socket || this._isDisconnecting;
      }
      /**
       * disconnect the TCP layer and close the underlying socket.
       * The ```"close"``` event will be emitted to the observers with err=null.
       *
       * @method disconnect
       * @async
       * @param callback
       */
      disconnect(callback) {
        (0, node_opcua_assert_1.assert)(typeof callback === "function", "expecting a callback function, but got " + callback);
        if (!this._socket || this._isDisconnecting) {
          if (!this._isDisconnecting) {
            this.dispose();
          }
          callback();
          return;
        }
        this._isDisconnecting = true;
        this._cleanup_timers();
        this._socket.prependOnceListener("close", () => {
          this._emitClose(null);
          setImmediate(() => {
            callback();
          });
        });
        this._socket.end();
        this._socket && this._socket.destroy();
        this._socket = null;
      }
      isValid() {
        return this._socket !== null && !this._socket.destroyed;
      }
      _write_chunk(messageChunk, callback) {
        if (this._socket !== null) {
          this.bytesWritten += messageChunk.length;
          this.chunkWrittenCount++;
          this._socket.write(messageChunk, callback);
        } else {
          if (callback) {
            callback();
          }
        }
      }
      _install_packetAssembler() {
        if (this.packetAssembler) {
          this.packetAssembler.removeAllListeners();
          this.packetAssembler = void 0;
        }
        this.packetAssembler = new node_opcua_packet_assembler_1.PacketAssembler({
          readChunkFunc: message_builder_base_1.readRawMessageHeader,
          minimumSizeInBytes: this.headerSize,
          maxChunkSize: this.receiveBufferSize
          //Math.max(this.receiveBufferSize, this.sendBufferSize)
        });
        this.packetAssembler.on("chunk", (chunk) => this._on_message_chunk_received(chunk));
        this.packetAssembler.on("error", (err, code) => {
          let statusCode = status_codes_1.StatusCodes2.BadTcpMessageTooLarge;
          switch (code) {
            case node_opcua_packet_assembler_1.PacketAssemblerErrorCode.ChunkSizeExceeded:
              statusCode = status_codes_1.StatusCodes2.BadTcpMessageTooLarge;
              break;
            default:
              statusCode = status_codes_1.StatusCodes2.BadTcpInternalError;
          }
          this.sendErrorMessage(statusCode, err.message);
          this.prematureTerminate(new Error("Packet Assembler : " + err.message), statusCode);
        });
      }
      _install_socket(socket) {
        (0, node_opcua_assert_1.assert)(socket);
        (0, node_opcua_assert_1.assert)(!this._socket, "already have a socket");
        this._socket = socket;
        this._closedEmitted = void 0;
        this._theCloseError = null;
        (0, node_opcua_assert_1.assert)(this._closedEmitted === void 0, "TCP Transport has already been closed !");
        this._socket.setKeepAlive(true);
        this._socket.setNoDelay(true);
        debugLog("  TCP_transport#install => setting " + this.name + " _socket.setTimeout to ", this.timeout);
        this._socket.setTimeout(this.timeout);
        doDebug && debugLog("  TCP_transport#_install_socket ", this.name);
        this._install_packetAssembler();
        this._socket.on("data", (data) => this._on_socket_data(data)).on("close", (hadError) => this._on_socket_close(hadError)).on("end", () => this._on_socket_end()).on("error", (err) => this._on_socket_error(err)).on("timeout", () => this._on_socket_timeout());
      }
      sendErrorMessage(statusCode, extraErrorDescription) {
        if (doDebug) {
          debugLog(chalk_1.default.red(" sendErrorMessage        ") + chalk_1.default.cyan(statusCode.toString()));
          debugLog(chalk_1.default.red(" extraErrorDescription   ") + chalk_1.default.cyan(extraErrorDescription));
        }
        const reason = `${statusCode.toString()}:${extraErrorDescription || ""}`;
        const errorResponse = new TCPErrorMessage_1.TCPErrorMessage({
          statusCode,
          reason
        });
        const messageChunk = (0, tools_1.packTcpMessage)("ERR", errorResponse);
        this.write(messageChunk);
      }
      prematureTerminate(err, statusCode) {
        debugLog("prematureTerminate", err ? err.message : "", statusCode.toString(), "has socket = ", !!this._socket);
        doDebugFlow && errorLog("prematureTerminate from", "has socket = ", !!this._socket, new Error().stack);
        if (this._socket) {
          err.message = "premature socket termination " + err.message;
          const _s = this._socket;
          this._socket = null;
          _s.destroy(err);
          this.dispose();
        }
      }
      /**
       * @method _install_one_time_message_receiver
       *
       * install a one time message receiver callback
       *
       * Rules:
       * * TCP_transport will not emit the ```message``` event, while the "one time message receiver" is in operation.
       * * the TCP_transport will wait for the next complete message chunk and call the provided callback func
       *   ```callback(null,messageChunk);```
       *
       * if a messageChunk is not received within ```TCP_transport.timeout``` or if the underlying socket reports
       * an error, the callback function will be called with an Error.
       *
       */
      _install_one_time_message_receiver(callback) {
        (0, node_opcua_assert_1.assert)(!this._theCallback, "callback already set");
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        this._start_one_time_message_receiver(callback);
      }
      _fulfill_pending_promises(err, data) {
        if (!this._theCallback)
          return false;
        doDebugFlow && errorLog("_fulfill_pending_promises from", new Error().stack);
        const callback = this._theCallback;
        this._theCallback = void 0;
        callback(err, data);
        return true;
      }
      _on_message_chunk_received(messageChunk) {
        if (utils_1.doTraceIncomingChunk) {
          warningLog("Transport", this.name);
          warningLog((0, node_opcua_debug_1.hexDump)(messageChunk));
        }
        const hadCallback = this._fulfill_pending_promises(null, messageChunk);
        this.chunkReadCount++;
        if (!hadCallback) {
          this.emit("chunk", messageChunk);
        }
      }
      _cleanup_timers() {
        if (this._timerId) {
          clearTimeout(this._timerId);
          this._timerId = null;
        }
      }
      _start_one_time_message_receiver(callback) {
        (0, node_opcua_assert_1.assert)(!this._timerId && !this._on_error_during_one_time_message_receiver, "timer already started");
        const _cleanUp = () => {
          this._cleanup_timers();
          if (this._on_error_during_one_time_message_receiver) {
            this._socket?.removeListener("close", this._on_error_during_one_time_message_receiver);
            this._on_error_during_one_time_message_receiver = void 0;
          }
        };
        const onTimeout = () => {
          _cleanUp();
          this._fulfill_pending_promises(new Error(`Timeout(A) in waiting for data on socket ( timeout was = ${this.timeout} ms)`));
          this.dispose();
        };
        this._timerId = setTimeout(() => {
          this._timerId = null;
          onTimeout();
        }, this.timeout);
        if (this._socket) {
          this._on_error_during_one_time_message_receiver = (hadError) => {
            const err = new Error(`ERROR in waiting for data on socket ( timeout was = ${this.timeout} ms) hadError` + hadError);
            this._emitClose(err);
            this._fulfill_pending_promises(err);
          };
          this._socket.prependOnceListener("close", this._on_error_during_one_time_message_receiver);
        }
        const _callback = callback;
        this._theCallback = (err, data) => {
          _cleanUp();
          this._theCallback = void 0;
          _callback(err, data);
        };
      }
      _on_socket_data(data) {
        if (!this.packetAssembler) {
          throw new Error("internal Error");
        }
        this.bytesRead += data.length;
        if (data.length > 0) {
          this.packetAssembler.feed(data);
        }
      }
      _on_socket_close(hadError) {
        if (doDebug) {
          debugLog(chalk_1.default.red(` SOCKET CLOSE ${this.name}: `), chalk_1.default.yellow("had_error ="), chalk_1.default.cyan(hadError.toString()));
        }
        this.dispose();
        if (this._theCallback)
          return;
        this._emitClose();
      }
      _emitClose(err) {
        err = err || this._theCloseError;
        doDebugFlow && warningLog("_emitClose ", err?.message || "", "from", new Error().stack);
        if (!this._closedEmitted) {
          this._closedEmitted = err || "noError";
          this.emit("close", err || null);
        } else {
          debugLog("Already emitted close event", this._closedEmitted.message);
          debugLog("err = ", err?.message);
          debugLog("");
          debugLog("Already emitted close event", this._closedEmitted);
          debugLog("err = ", err?.message, err);
        }
      }
      _on_socket_end() {
        doDebug && debugLog(chalk_1.default.red(` SOCKET END : ${this.name}`), "is disconnecting  ", this.isDisconnecting());
        if (this.isDisconnecting()) {
          return;
        }
        debugLog(chalk_1.default.red(" Transport Connection ended") + " " + this.name);
        const err = new Error(this.name + ": socket has been disconnected by third party");
        debugLog(" bytesRead    = ", this.bytesRead);
        debugLog(" bytesWritten = ", this.bytesWritten);
        this._theCloseError = err;
        this._fulfill_pending_promises(new Error("Connection aborted - ended by server : " + (err ? err.message : "")));
      }
      _on_socket_error(err) {
        debugLog(chalk_1.default.red(` _on_socket_error:  ${this.name}`), chalk_1.default.yellow(err.message));
      }
      _on_socket_timeout() {
        const msg = `socket timeout : timeout=${this.timeout}  ${this.name}`;
        doDebug && debugLog(msg);
        this.prematureTerminate(new Error(msg), status_codes_1.StatusCodes2.BadTimeout);
      }
    };
    exports2.TCP_transport = TCP_transport;
    TCP_transport.registry = new node_opcua_object_registry_1.ObjectRegistry();
  }
});

// node_modules/node-opcua-transport/dist/source/HelloMessage.js
var require_HelloMessage = __commonJS({
  "node_modules/node-opcua-transport/dist/source/HelloMessage.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.HelloMessage = void 0;
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_factory_1 = require_dist26();
    var schemaHelloMessage = (0, node_opcua_factory_1.buildStructuredType)({
      name: "HelloMessage",
      baseType: "BaseUAObject",
      fields: [
        {
          name: "ProtocolVersion",
          fieldType: "UInt32",
          documentation: "The latest version of the OPC UA TCP protocol supported by the Client"
        },
        {
          name: "ReceiveBufferSize",
          fieldType: "UInt32",
          documentation: "The largest message that the sender can receive."
        },
        {
          name: "SendBufferSize",
          fieldType: "UInt32",
          documentation: "The largest message that the sender will send."
        },
        { name: "MaxMessageSize", fieldType: "UInt32", documentation: "The maximum size for any response message." },
        {
          name: "maxChunkCount",
          fieldType: "UInt32",
          documentation: "The maximum number of chunks in any response message"
        },
        {
          name: "EndpointUrl",
          fieldType: "String",
          documentation: "The URL of the Endpoint which the Client wished to connect to."
        }
      ]
    });
    var HelloMessage = class extends node_opcua_factory_1.BaseUAObject {
      constructor(options) {
        options = options || {};
        super();
        const schema = schemaHelloMessage;
        if (node_opcua_factory_1.parameters.debugSchemaHelper) {
          (0, node_opcua_factory_1.check_options_correctness_against_schema)(this, schema, options);
        }
        this.protocolVersion = (0, node_opcua_factory_1.initialize_field)(schema.fields[0], options.protocolVersion);
        this.receiveBufferSize = (0, node_opcua_factory_1.initialize_field)(schema.fields[1], options.receiveBufferSize);
        this.sendBufferSize = (0, node_opcua_factory_1.initialize_field)(schema.fields[2], options.sendBufferSize);
        this.maxMessageSize = (0, node_opcua_factory_1.initialize_field)(schema.fields[3], options.maxMessageSize);
        this.maxChunkCount = (0, node_opcua_factory_1.initialize_field)(schema.fields[4], options.maxChunkCount);
        this.endpointUrl = (0, node_opcua_factory_1.initialize_field)(schema.fields[5], options.endpointUrl);
      }
      encode(stream) {
        super.encode(stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.protocolVersion, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.receiveBufferSize, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.sendBufferSize, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.maxMessageSize, stream);
        (0, node_opcua_basic_types_1.encodeUInt32)(this.maxChunkCount, stream);
        (0, node_opcua_basic_types_1.encodeUAString)(this.endpointUrl, stream);
      }
      decode(stream) {
        super.decode(stream);
        this.protocolVersion = (0, node_opcua_basic_types_1.decodeUInt32)(stream);
        this.receiveBufferSize = (0, node_opcua_basic_types_1.decodeUInt32)(stream);
        this.sendBufferSize = (0, node_opcua_basic_types_1.decodeUInt32)(stream);
        this.maxMessageSize = (0, node_opcua_basic_types_1.decodeUInt32)(stream);
        this.maxChunkCount = (0, node_opcua_basic_types_1.decodeUInt32)(stream);
        this.endpointUrl = (0, node_opcua_basic_types_1.decodeUAString)(stream);
      }
      toString() {
        let str = "";
        str += "protocolVersion   = " + this.protocolVersion + "\n";
        str += "receiveBufferSize = " + this.receiveBufferSize + "\n";
        str += "sendBufferSize    = " + this.sendBufferSize + "\n";
        str += "maxMessageSize    = " + this.maxMessageSize + "\n";
        str += "maxChunkCount     = " + this.maxChunkCount + "\n";
        str += "endpointUrl       = " + this.endpointUrl + "\n";
        return str;
      }
    };
    exports2.HelloMessage = HelloMessage;
    HelloMessage.possibleFields = [
      "protocolVersion",
      "receiveBufferSize",
      "sendBufferSize",
      "maxMessageSize",
      "maxChunkCount",
      "endpointUrl"
    ];
  }
});

// node_modules/node-opcua-transport/dist/source/client_tcp_transport.js
var require_client_tcp_transport = __commonJS({
  "node_modules/node-opcua-transport/dist/source/client_tcp_transport.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ClientTCP_transport = void 0;
    var os_1 = __importDefault3(require("os"));
    var net_1 = require("net");
    var util_1 = require("util");
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_binary_stream_1 = require_dist18();
    var node_opcua_chunkmanager_1 = require_dist58();
    var node_opcua_debug_1 = require_dist24();
    var tcp_transport_1 = require_tcp_transport();
    var tools_1 = require_tools2();
    var AcknowledgeMessage_1 = require_AcknowledgeMessage();
    var HelloMessage_1 = require_HelloMessage();
    var TCPErrorMessage_1 = require_TCPErrorMessage();
    var utils_1 = require_utils6();
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var gHostname = os_1.default.hostname();
    function createClientSocket(endpointUrl, timeout) {
      const ep = (0, tools_1.parseEndpointUrl)(endpointUrl);
      const port2 = parseInt(ep.port, 10);
      const hostname2 = ep.hostname;
      let socket;
      switch (ep.protocol) {
        case "opc.tcp:":
          socket = (0, net_1.createConnection)({ host: hostname2, port: port2, timeout }, () => {
            doDebug && debugLog(`connected to server! ${hostname2}:${port2} timeout:${timeout} `);
          });
          return socket;
        case "fake:":
          (0, node_opcua_assert_1.assert)(ep.protocol === "fake:", " Unsupported transport protocol");
          socket = (0, tcp_transport_1.getFakeTransport)();
          return socket;
        case "websocket:":
        case "http:":
        case "https:":
        default: {
          const msg = "[NODE-OPCUA-E05] this transport protocol is not supported :" + ep.protocol;
          errorLog(msg);
          throw new Error(msg);
        }
      }
    }
    var ClientTCP_transport = class _ClientTCP_transport extends tcp_transport_1.TCP_transport {
      constructor(transportSettings) {
        super();
        this.endpointUrl = "";
        this.serverUri = "";
        this._counter = 0;
        this.numberOfRetry = 0;
        this.maxChunkCount = 1;
        this.maxMessageSize = 4 * 1024;
        this.receiveBufferSize = 4 * 1024;
        transportSettings = transportSettings || {};
        this._helloSettings = {
          maxChunkCount: transportSettings.maxChunkCount || _ClientTCP_transport.defaultMaxChunk,
          maxMessageSize: transportSettings.maxMessageSize || _ClientTCP_transport.defaultMaxMessageSize,
          receiveBufferSize: transportSettings.receiveBufferSize || _ClientTCP_transport.defaultReceiveBufferSize,
          sendBufferSize: transportSettings.sendBufferSize || _ClientTCP_transport.defaultSendBufferSize
        };
      }
      getTransportSettings() {
        return this._helloSettings;
      }
      dispose() {
        doDebug && debugLog(" ClientTCP_transport disposed");
        super.dispose();
      }
      connect(endpointUrl, callback) {
        (0, node_opcua_assert_1.assert)(arguments.length === 2);
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        const ep = (0, tools_1.parseEndpointUrl)(endpointUrl);
        this.endpointUrl = endpointUrl;
        this.serverUri = "urn:" + gHostname + ":Sample";
        doDebug && debugLog(chalk_1.default.cyan("ClientTCP_transport#connect(endpointUrl = " + endpointUrl + ")"));
        let socket = null;
        try {
          socket = createClientSocket(endpointUrl, this.timeout);
        } catch (err) {
          doDebug && debugLog("CreateClientSocket has failed");
          return callback(err);
        }
        const _on_socket_error_after_connection = (err) => {
          doDebug && debugLog(" _on_socket_error_after_connection ClientTCP_transport Socket Error", err.message);
          if (err.message.match(/ECONNRESET|EPIPE|premature socket termination/)) {
            this.emit("connection_break");
          }
        };
        const _on_socket_connect = () => {
          doDebug && debugLog("entering _on_socket_connect");
          _remove_connect_listeners();
          this._perform_HEL_ACK_transaction((err) => {
            if (!err) {
              if (!this._socket) {
                throw new Error("internal error");
              }
              this._socket.on("error", _on_socket_error_after_connection);
              this.emit("connect");
            } else {
              debugLog("_perform_HEL_ACK_transaction has failed with err=", err.message);
            }
            callback(err);
          });
        };
        const _on_socket_error_for_connect = (err) => {
          doDebug && debugLog(chalk_1.default.cyan("ClientTCP_transport#connect - _on_socket_error_for_connect"), err.message);
          (0, node_opcua_assert_1.assert)(util_1.types.isNativeError(err));
          _remove_connect_listeners();
          callback(err);
        };
        const _on_socket_end_for_connect = () => {
          doDebug && debugLog(chalk_1.default.cyan("ClientTCP_transport#connect -> _on_socket_end_for_connect Socket has been closed by server"));
        };
        const _remove_connect_listeners = () => {
          if (!this._socket) {
            return;
          }
          this._socket.removeListener("error", _on_socket_error_for_connect);
          this._socket.removeListener("end", _on_socket_end_for_connect);
        };
        this._install_socket(socket);
        this._socket.once("error", _on_socket_error_for_connect);
        this._socket.once("end", _on_socket_end_for_connect);
        this._socket.once("connect", _on_socket_connect);
      }
      _handle_ACK_response(messageChunk, callback) {
        const _stream = new node_opcua_binary_stream_1.BinaryStream(messageChunk);
        const messageHeader = (0, node_opcua_chunkmanager_1.readMessageHeader)(_stream);
        let err;
        if (messageHeader.isFinal !== "F") {
          err = new Error(" invalid ACK message");
          return callback(err);
        }
        let responseClass;
        let response;
        if (messageHeader.msgType === "ERR") {
          responseClass = TCPErrorMessage_1.TCPErrorMessage;
          _stream.rewind();
          response = (0, tools_1.decodeMessage)(_stream, responseClass);
          err = new Error("ACK: ERR received " + response.statusCode.toString() + " : " + response.reason);
          err.statusCode = response.statusCode;
          utils_1.doTraceHelloAck && warningLog("receiving ERR instead of Ack", response.toString());
          callback(err);
        } else {
          responseClass = AcknowledgeMessage_1.AcknowledgeMessage;
          _stream.rewind();
          response = (0, tools_1.decodeMessage)(_stream, responseClass);
          this.parameters = response;
          this.setLimits(response);
          utils_1.doTraceHelloAck && warningLog("receiving Ack\n", response.toString());
          callback();
        }
      }
      _send_HELLO_request() {
        doDebug && debugLog("entering _send_HELLO_request");
        (0, node_opcua_assert_1.assert)(this._socket);
        (0, node_opcua_assert_1.assert)(isFinite(this.protocolVersion));
        (0, node_opcua_assert_1.assert)(this.endpointUrl.length > 0, " expecting a valid endpoint url");
        const { maxChunkCount, maxMessageSize, receiveBufferSize, sendBufferSize } = this._helloSettings;
        const helloMessage = new HelloMessage_1.HelloMessage({
          endpointUrl: this.endpointUrl,
          protocolVersion: this.protocolVersion,
          maxChunkCount,
          maxMessageSize,
          receiveBufferSize,
          sendBufferSize
        });
        utils_1.doTraceHelloAck && warningLog(`sending Hello
 ${helloMessage.toString()} `);
        const messageChunk = (0, tools_1.packTcpMessage)("HEL", helloMessage);
        this._write_chunk(messageChunk);
      }
      _on_ACK_response(externalCallback, err, data) {
        doDebug && debugLog("entering _on_ACK_response");
        (0, node_opcua_assert_1.assert)(typeof externalCallback === "function");
        (0, node_opcua_assert_1.assert)(this._counter === 0, "Ack response should only be received once !");
        this._counter += 1;
        if (err || !data) {
          externalCallback(err || new Error("no data"));
          if (this._socket) {
            this._socket.end();
          }
        } else {
          this._handle_ACK_response(data, externalCallback);
        }
      }
      _perform_HEL_ACK_transaction(callback) {
        if (!this._socket) {
          return callback(new Error("No socket available to perform HEL/ACK transaction"));
        }
        (0, node_opcua_assert_1.assert)(this._socket, "expecting a valid socket to send a message");
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        this._counter = 0;
        doDebug && debugLog("entering _perform_HEL_ACK_transaction");
        this._install_one_time_message_receiver((err, data) => {
          doDebug && debugLog("before  _on_ACK_response ", err ? err.message : "");
          this._on_ACK_response(callback, err, data);
        });
        this._send_HELLO_request();
      }
    };
    exports2.ClientTCP_transport = ClientTCP_transport;
    ClientTCP_transport.defaultMaxChunk = 0;
    ClientTCP_transport.defaultMaxMessageSize = 0;
    ClientTCP_transport.defaultReceiveBufferSize = 1024 * 64 * 10;
    ClientTCP_transport.defaultSendBufferSize = 1024 * 64 * 10;
  }
});

// node_modules/node-opcua-transport/dist/source/server_tcp_transport.js
var require_server_tcp_transport = __commonJS({
  "node_modules/node-opcua-transport/dist/source/server_tcp_transport.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ServerTCP_transport = exports2.adjustLimitsWithParameters = void 0;
    var util_1 = require("util");
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_binary_stream_1 = require_dist18();
    var node_opcua_chunkmanager_1 = require_dist58();
    var node_opcua_status_code_1 = require_dist22();
    var AcknowledgeMessage_1 = require_AcknowledgeMessage();
    var HelloMessage_1 = require_HelloMessage();
    var tcp_transport_1 = require_tcp_transport();
    var tools_1 = require_tools2();
    var utils_1 = require_utils6();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)("TRANSPORT");
    var errorLog = (0, node_opcua_debug_1.make_errorLog)("TRANSPORT");
    var warningLog = (0, node_opcua_debug_1.make_warningLog)("TRANSPORT");
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)("TRANSPORT");
    function clamp_value(value, minVal, maxVal) {
      (0, node_opcua_assert_1.assert)(minVal <= maxVal);
      if (value === 0) {
        return maxVal;
      }
      if (value < minVal) {
        return minVal;
      }
      if (value >= maxVal) {
        return maxVal;
      }
      return value;
    }
    var minimumBufferSize = 8192;
    var defaultTransportParameters = {
      minBufferSize: 8192,
      maxBufferSize: 8 * 64 * 1024,
      minMaxMessageSize: 128 * 1024,
      defaultMaxMessageSize: 16 * 1024 * 1024,
      maxMaxMessageSize: 128 * 1024 * 1024,
      minMaxChunkCount: 1,
      defaultMaxChunkCount: Math.ceil(128 * 1024 * 1024 / (8 * 64 * 1024)),
      maxMaxChunkCount: 9e3
    };
    function adjustLimitsWithParameters(helloMessage, params) {
      const defaultReceiveBufferSize = 64 * 1024;
      const defaultSendBufferSize = 64 * 1024;
      const receiveBufferSize = clamp_value(helloMessage.receiveBufferSize || defaultReceiveBufferSize, params.minBufferSize, params.maxBufferSize);
      const sendBufferSize = clamp_value(helloMessage.sendBufferSize || defaultSendBufferSize, params.minBufferSize, params.maxBufferSize);
      const maxMessageSize = clamp_value(helloMessage.maxMessageSize || params.defaultMaxMessageSize, params.minMaxMessageSize, params.maxMaxMessageSize);
      if (!helloMessage.maxChunkCount && sendBufferSize) {
        helloMessage.maxChunkCount = Math.ceil(helloMessage.maxMessageSize / Math.min(sendBufferSize, receiveBufferSize));
      }
      const maxChunkCount = clamp_value(helloMessage.maxChunkCount || params.defaultMaxChunkCount, params.minMaxChunkCount, params.maxMaxChunkCount);
      return {
        receiveBufferSize,
        sendBufferSize,
        maxMessageSize,
        maxChunkCount
      };
    }
    exports2.adjustLimitsWithParameters = adjustLimitsWithParameters;
    var defaultAdjustLimits = (hello) => adjustLimitsWithParameters(hello, defaultTransportParameters);
    var ServerTCP_transport = class _ServerTCP_transport extends tcp_transport_1.TCP_transport {
      constructor(options) {
        super();
        this._aborted = 0;
        this._helloReceived = false;
        this.maxChunkCount = 1;
        this.maxMessageSize = 4 * 1024;
        this.receiveBufferSize = 4 * 1024;
        this.adjustLimits = options?.adjustLimits || defaultAdjustLimits;
      }
      toString() {
        let str = super.toString();
        str += "helloReceived...... = " + this._helloReceived + "\n";
        str += "aborted............ = " + this._aborted + "\n";
        return str;
      }
      _write_chunk(messageChunk) {
        if (this.sendBufferSize > 0 && messageChunk.length > this.sendBufferSize) {
          errorLog("write chunk exceed sendBufferSize messageChunk length = ", messageChunk.length, "sendBufferSize = ", this.sendBufferSize);
        }
        super._write_chunk(messageChunk);
      }
      /**
       * Initialize the server transport.
       *
       *
       *  The ServerTCP_transport initialization process starts by waiting for the client to send a "HEL" message.
       *
       *  The  ServerTCP_transport replies with a "ACK" message and then start waiting for further messages of any size.
       *
       *  The callback function received an error:
       *   - if no message from the client is received within the ```self.timeout``` period,
       *   - or, if the connection has dropped within the same interval.
       *   - if the protocol version specified within the HEL message is invalid or is greater
       *     than ```self.protocolVersion```
       *
       *
       */
      init(socket, callback) {
        debugLog && debugLog(chalk_1.default.cyan("init socket"));
        (0, node_opcua_assert_1.assert)(!this._socket, "init already called!");
        this._install_socket(socket);
        this._install_HEL_message_receiver(callback);
      }
      _abortWithError(statusCode, extraErrorDescription, callback) {
        doDebug && debugLog(this.name, chalk_1.default.cyan("_abortWithError", statusCode.toString(), extraErrorDescription));
        if (this._aborted) {
          errorLog("Internal Er!ror: _abortWithError already called! Should not happen here");
          return callback(new Error(statusCode.name));
        }
        this._aborted = 1;
        this._socket?.setTimeout(0);
        const err = new Error(extraErrorDescription + " StatusCode = " + statusCode.name);
        this._theCloseError = err;
        setTimeout(() => {
          this.sendErrorMessage(statusCode, statusCode.description);
          this.prematureTerminate(err, statusCode);
          this._emitClose(err);
          callback(err);
        }, _ServerTCP_transport.throttleTime);
      }
      _send_ACK_response(helloMessage) {
        (0, node_opcua_assert_1.assert)(helloMessage.receiveBufferSize >= minimumBufferSize);
        (0, node_opcua_assert_1.assert)(helloMessage.sendBufferSize >= minimumBufferSize);
        const limits = this.adjustLimits(helloMessage);
        this.setLimits(limits);
        if (utils_1.doTraceHelloAck) {
          warningLog(`received Hello 
${helloMessage.toString()}`);
          warningLog("Client accepts only message of size => ", this.maxMessageSize);
        }
        doDebug && debugLog("Client accepts only message of size => ", this.maxMessageSize);
        const acknowledgeMessage = new AcknowledgeMessage_1.AcknowledgeMessage({
          maxChunkCount: this.maxChunkCount,
          maxMessageSize: this.maxMessageSize,
          protocolVersion: this.protocolVersion,
          receiveBufferSize: this.receiveBufferSize,
          sendBufferSize: this.sendBufferSize
        });
        utils_1.doTraceHelloAck && warningLog(`sending Ack 
${acknowledgeMessage.toString()}`);
        const messageChunk = (0, tools_1.packTcpMessage)("ACK", acknowledgeMessage);
        if (doDebug) {
          (0, node_opcua_chunkmanager_1.verify_message_chunk)(messageChunk);
          debugLog("server send: " + chalk_1.default.yellow("ACK"));
          debugLog("server send: " + (0, node_opcua_debug_1.hexDump)(messageChunk));
          debugLog("acknowledgeMessage=", acknowledgeMessage);
        }
        this.write(messageChunk);
      }
      _install_HEL_message_receiver(callback) {
        doDebug && debugLog(chalk_1.default.cyan("_install_HEL_message_receiver "));
        this._install_one_time_message_receiver((err, data) => {
          if (err) {
            callback(err);
          } else {
            this._on_HEL_message(data, callback);
          }
        });
      }
      _on_HEL_message(data, callback) {
        doDebug && debugLog(chalk_1.default.cyan("_on_HEL_message"));
        (0, node_opcua_assert_1.assert)(!this._helloReceived);
        const stream = new node_opcua_binary_stream_1.BinaryStream(data);
        const msgType = data.subarray(0, 3).toString("utf-8");
        if (doDebug) {
          debugLog("SERVER received " + chalk_1.default.yellow(msgType));
          debugLog("SERVER received " + (0, node_opcua_debug_1.hexDump)(data));
        }
        if (msgType === "HEL") {
          try {
            (0, node_opcua_assert_1.assert)(data.length >= 24);
            const helloMessage = (0, tools_1.decodeMessage)(stream, HelloMessage_1.HelloMessage);
            if (helloMessage.protocolVersion !== this.protocolVersion) {
              doDebug && debugLog(`warning ! client sent helloMessage.protocolVersion =  0x${helloMessage.protocolVersion.toString(16)} whereas server protocolVersion is 0x${this.protocolVersion.toString(16)}`);
            }
            if (helloMessage.protocolVersion === 3735928559 || helloMessage.protocolVersion < this.protocolVersion) {
              return this._abortWithError(node_opcua_status_code_1.StatusCodes.BadProtocolVersionUnsupported, "Protocol Version Error" + this.protocolVersion, callback);
            }
            if (helloMessage.receiveBufferSize < minimumBufferSize || helloMessage.sendBufferSize < minimumBufferSize) {
              return this._abortWithError(node_opcua_status_code_1.StatusCodes.BadConnectionRejected, "Buffer size too small (should be at least " + minimumBufferSize, callback);
            }
            this._helloReceived = true;
            this._send_ACK_response(helloMessage);
            callback();
          } catch (err) {
            return this._abortWithError(node_opcua_status_code_1.StatusCodes.BadConnectionRejected, util_1.types.isNativeError(err) ? err.message : "", callback);
          }
        } else {
          doDebug && debugLog(chalk_1.default.red("BadCommunicationError ") + "Expecting 'HEL' message to initiate communication");
          this._abortWithError(node_opcua_status_code_1.StatusCodes.BadCommunicationError, "Expecting 'HEL' message to initiate communication", callback);
        }
      }
    };
    exports2.ServerTCP_transport = ServerTCP_transport;
    ServerTCP_transport.throttleTime = 1e3;
  }
});

// node_modules/node-opcua-transport/dist/source/i_hello_ack_limits.js
var require_i_hello_ack_limits = __commonJS({
  "node_modules/node-opcua-transport/dist/source/i_hello_ack_limits.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-transport/dist/source/index.js
var require_source5 = __commonJS({
  "node_modules/node-opcua-transport/dist/source/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_AcknowledgeMessage(), exports2);
    __exportStar3(require_client_tcp_transport(), exports2);
    __exportStar3(require_HelloMessage(), exports2);
    __exportStar3(require_message_builder_base(), exports2);
    __exportStar3(require_server_tcp_transport(), exports2);
    __exportStar3(require_status_codes(), exports2);
    __exportStar3(require_tcp_transport(), exports2);
    __exportStar3(require_TCPErrorMessage(), exports2);
    __exportStar3(require_tools2(), exports2);
    __exportStar3(require_utils6(), exports2);
    __exportStar3(require_i_hello_ack_limits(), exports2);
  }
});

// node_modules/node-opcua-secure-channel/dist/source/services.js
var require_services = __commonJS({
  "node_modules/node-opcua-secure-channel/dist/source/services.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AcknowledgeMessage = exports2.SignatureData = exports2.RequestHeader = exports2.ResponseHeader = exports2.SecurityTokenRequestType = exports2.MessageSecurityMode = exports2.AsymmetricAlgorithmSecurityHeader = exports2.ServiceFault = exports2.CloseSecureChannelResponse = exports2.CloseSecureChannelRequest = exports2.OpenSecureChannelResponse = exports2.OpenSecureChannelRequest = void 0;
    var node_opcua_service_secure_channel_1 = require_dist38();
    Object.defineProperty(exports2, "OpenSecureChannelRequest", { enumerable: true, get: function() {
      return node_opcua_service_secure_channel_1.OpenSecureChannelRequest;
    } });
    Object.defineProperty(exports2, "OpenSecureChannelResponse", { enumerable: true, get: function() {
      return node_opcua_service_secure_channel_1.OpenSecureChannelResponse;
    } });
    Object.defineProperty(exports2, "CloseSecureChannelRequest", { enumerable: true, get: function() {
      return node_opcua_service_secure_channel_1.CloseSecureChannelRequest;
    } });
    Object.defineProperty(exports2, "CloseSecureChannelResponse", { enumerable: true, get: function() {
      return node_opcua_service_secure_channel_1.CloseSecureChannelResponse;
    } });
    Object.defineProperty(exports2, "ServiceFault", { enumerable: true, get: function() {
      return node_opcua_service_secure_channel_1.ServiceFault;
    } });
    Object.defineProperty(exports2, "AsymmetricAlgorithmSecurityHeader", { enumerable: true, get: function() {
      return node_opcua_service_secure_channel_1.AsymmetricAlgorithmSecurityHeader;
    } });
    Object.defineProperty(exports2, "MessageSecurityMode", { enumerable: true, get: function() {
      return node_opcua_service_secure_channel_1.MessageSecurityMode;
    } });
    Object.defineProperty(exports2, "SecurityTokenRequestType", { enumerable: true, get: function() {
      return node_opcua_service_secure_channel_1.SecurityTokenRequestType;
    } });
    Object.defineProperty(exports2, "ResponseHeader", { enumerable: true, get: function() {
      return node_opcua_service_secure_channel_1.ResponseHeader;
    } });
    Object.defineProperty(exports2, "RequestHeader", { enumerable: true, get: function() {
      return node_opcua_service_secure_channel_1.RequestHeader;
    } });
    Object.defineProperty(exports2, "SignatureData", { enumerable: true, get: function() {
      return node_opcua_service_secure_channel_1.SignatureData;
    } });
    var node_opcua_transport_1 = require_source5();
    Object.defineProperty(exports2, "AcknowledgeMessage", { enumerable: true, get: function() {
      return node_opcua_transport_1.AcknowledgeMessage;
    } });
  }
});

// node_modules/node-opcua-secure-channel/dist/source/secure_message_chunk_manager.js
var require_secure_message_chunk_manager = __commonJS({
  "node_modules/node-opcua-secure-channel/dist/source/secure_message_chunk_manager.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SecureMessageChunkManager = exports2.chooseSecurityHeader = void 0;
    var events_1 = require("events");
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_binary_stream_1 = require_dist18();
    var node_opcua_chunkmanager_1 = require_dist58();
    var node_opcua_service_secure_channel_1 = require_dist38();
    function chooseSecurityHeader(msgType) {
      return msgType === "OPN" ? new node_opcua_service_secure_channel_1.AsymmetricAlgorithmSecurityHeader() : new node_opcua_service_secure_channel_1.SymmetricAlgorithmSecurityHeader();
    }
    exports2.chooseSecurityHeader = chooseSecurityHeader;
    var SecureMessageChunkManager = class extends events_1.EventEmitter {
      constructor(msgType, options, securityHeader, sequenceNumberGenerator) {
        super();
        this.aborted = false;
        msgType = msgType || "OPN";
        this.securityHeader = securityHeader || chooseSecurityHeader(msgType);
        (0, node_opcua_assert_1.assert)(this.securityHeader !== null && typeof this.securityHeader === "object");
        this.chunkSize = options.chunkSize || 1024 * 128;
        this.msgType = msgType;
        options.channelId = options.channelId || 0;
        (0, node_opcua_assert_1.assert)(isFinite(options.channelId));
        this.channelId = options.channelId;
        const requestId = options.requestId;
        this.sequenceNumberGenerator = sequenceNumberGenerator;
        (0, node_opcua_assert_1.assert)(requestId > 0, "expecting a valid request ID");
        this.sequenceHeader = new node_opcua_chunkmanager_1.SequenceHeader({ requestId, sequenceNumber: -1 });
        const securityHeaderSize = this.securityHeader.binaryStoreSize();
        const sequenceHeaderSize = this.sequenceHeader.binaryStoreSize();
        (0, node_opcua_assert_1.assert)(sequenceHeaderSize === 8);
        this.headerSize = 12 + securityHeaderSize;
        const params = {
          chunkSize: this.chunkSize,
          headerSize: this.headerSize,
          writeHeaderFunc: (buffer, isLast, totalLength) => {
            let finalC = isLast ? "F" : "C";
            finalC = this.aborted ? "A" : finalC;
            this.write_header(finalC, buffer, totalLength);
          },
          sequenceHeaderSize,
          writeSequenceHeaderFunc: (buffer) => {
            this.writeSequenceHeader(buffer);
          },
          // ---------------------------------------- Signing stuff
          signBufferFunc: options.signBufferFunc,
          signatureLength: options.signatureLength,
          // ---------------------------------------- Encrypting stuff
          cipherBlockSize: options.cipherBlockSize,
          encryptBufferFunc: options.encryptBufferFunc,
          plainBlockSize: options.plainBlockSize
        };
        this.chunkManager = new node_opcua_chunkmanager_1.ChunkManager(params);
        this.chunkManager.on("chunk", (chunk, isLast) => {
          this.emit("chunk", chunk, isLast || this.aborted);
        });
      }
      evaluateTotalLengthAndChunks(bodySize) {
        return this.chunkManager.evaluateTotalLengthAndChunks(bodySize);
      }
      write_header(finalC, buffer, length) {
        (0, node_opcua_assert_1.assert)(buffer.length > 12);
        (0, node_opcua_assert_1.assert)(finalC.length === 1);
        (0, node_opcua_assert_1.assert)(buffer instanceof Buffer);
        const stream = new node_opcua_binary_stream_1.BinaryStream(buffer);
        stream.writeUInt8(this.msgType.charCodeAt(0));
        stream.writeUInt8(this.msgType.charCodeAt(1));
        stream.writeUInt8(this.msgType.charCodeAt(2));
        stream.writeUInt8(finalC.charCodeAt(0));
        stream.writeUInt32(length);
        stream.writeUInt32(this.channelId);
        (0, node_opcua_assert_1.assert)(stream.length === 12);
        this.securityHeader.encode(stream);
        (0, node_opcua_assert_1.assert)(stream.length === this.headerSize);
      }
      writeSequenceHeader(buffer) {
        const stream = new node_opcua_binary_stream_1.BinaryStream(buffer);
        this.sequenceHeader.sequenceNumber = this.sequenceNumberGenerator.next();
        this.sequenceHeader.encode(stream);
        (0, node_opcua_assert_1.assert)(stream.length === 8);
      }
      write(buffer, length) {
        length = length || buffer.length;
        this.chunkManager.write(buffer, length);
      }
      abort() {
        this.aborted = true;
        this.end();
      }
      end() {
        this.chunkManager.end();
        this.emit("finished");
      }
    };
    exports2.SecureMessageChunkManager = SecureMessageChunkManager;
  }
});

// node_modules/node-opcua-secure-channel/dist/source/sequence_number_generator.js
var require_sequence_number_generator = __commonJS({
  "node_modules/node-opcua-secure-channel/dist/source/sequence_number_generator.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SequenceNumberGenerator = void 0;
    var SequenceNumberGenerator = class _SequenceNumberGenerator {
      constructor() {
        this._counter = 0;
        this._set(1);
      }
      next() {
        const current = this._counter;
        this._counter += 1;
        if (this._counter > _SequenceNumberGenerator.MAXVALUE) {
          this._set(1);
        }
        return current;
      }
      future() {
        return this._counter;
      }
      _set(value) {
        this._counter = value;
      }
    };
    exports2.SequenceNumberGenerator = SequenceNumberGenerator;
    SequenceNumberGenerator.MAXVALUE = 4294966271;
  }
});

// node_modules/node-opcua-secure-channel/dist/source/message_chunker.js
var require_message_chunker = __commonJS({
  "node_modules/node-opcua-secure-channel/dist/source/message_chunker.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.MessageChunker = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_binary_stream_1 = require_dist18();
    var node_opcua_service_secure_channel_1 = require_dist38();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_chunkmanager_1 = require_dist58();
    var secure_message_chunk_manager_1 = require_secure_message_chunk_manager();
    var sequence_number_generator_1 = require_sequence_number_generator();
    var doTraceChunk = process.env.NODEOPCUADEBUG && process.env.NODEOPCUADEBUG.indexOf("CHUNK") >= 0;
    var errorLog = (0, node_opcua_debug_1.make_errorLog)("secure_channel");
    var warningLog = (0, node_opcua_debug_1.make_warningLog)("secure_channel");
    var MessageChunker = class _MessageChunker {
      constructor(options) {
        options = options || {};
        this.sequenceNumberGenerator = new sequence_number_generator_1.SequenceNumberGenerator();
        this.maxMessageSize = options.maxMessageSize || _MessageChunker.defaultMaxMessageSize;
        this.maxChunkCount = options.maxChunkCount === void 0 ? _MessageChunker.defaultChunkCount : options.maxChunkCount;
        this.update(options);
      }
      dispose() {
        this.securityHeader = null;
      }
      /***
       * update security information
       */
      update(options) {
        options = options || {};
        options.securityHeader = options.securityHeader || new node_opcua_service_secure_channel_1.AsymmetricAlgorithmSecurityHeader({
          securityPolicyUri: "http://opcfoundation.org/UA/SecurityPolicy#None"
        });
        (0, node_opcua_assert_1.assert)(options !== null && typeof options === "object");
        (0, node_opcua_assert_1.assert)(options.securityHeader !== null && typeof options.securityHeader === "object");
        this.securityHeader = options.securityHeader;
      }
      chunkSecureMessage(msgType, options, message, messageChunkCallback) {
        (0, node_opcua_assert_1.assert)(typeof messageChunkCallback === "function");
        const makeAbandonChunk = () => {
          const finalC = "A";
          const msgType2 = "MSG";
          const buffer = Buffer.alloc(
            // MSGA
            4 + // length
            4 + // secureChannelId
            4 + // tokenId
            4 + 2 * 4
          );
          const stream2 = new node_opcua_binary_stream_1.BinaryStream(buffer);
          stream2.writeUInt8(msgType2.charCodeAt(0));
          stream2.writeUInt8(msgType2.charCodeAt(1));
          stream2.writeUInt8(msgType2.charCodeAt(2));
          stream2.writeUInt8(finalC.charCodeAt(0));
          stream2.writeUInt32(0);
          stream2.writeUInt32(options.channelId || 0);
          const securityHeader2 = new node_opcua_service_secure_channel_1.SymmetricAlgorithmSecurityHeader({
            tokenId: options.tokenId
          });
          securityHeader2.encode(stream2);
          const sequenceHeader = new node_opcua_chunkmanager_1.SequenceHeader({
            sequenceNumber: this.sequenceNumberGenerator.next(),
            requestId: options.requestId
            /// fix me
          });
          sequenceHeader.encode(stream2);
          const length = stream2.length;
          stream2.length = 4;
          stream2.writeUInt32(length);
          stream2.length = length;
          return buffer;
        };
        const binSize = message.binaryStoreSize() + 4;
        const stream = new node_opcua_binary_stream_1.BinaryStream(binSize);
        (0, node_opcua_basic_types_1.encodeExpandedNodeId)(message.schema.encodingDefaultBinary, stream);
        message.encode(stream);
        let securityHeader;
        if (msgType === "OPN") {
          securityHeader = this.securityHeader;
        } else {
          securityHeader = new node_opcua_service_secure_channel_1.SymmetricAlgorithmSecurityHeader({ tokenId: options.tokenId });
        }
        const chunkManager = new secure_message_chunk_manager_1.SecureMessageChunkManager(msgType, options, securityHeader || null, this.sequenceNumberGenerator);
        const { chunkCount, totalLength } = chunkManager.evaluateTotalLengthAndChunks(stream.buffer.length);
        if (this.maxChunkCount > 0 && chunkCount > this.maxChunkCount) {
          errorLog(`[NODE-OPCUA-E10] message chunkCount ${chunkCount} exceeds the negotiated maximum chunk count ${this.maxChunkCount}, message current size is ${totalLength}`);
          errorLog(`[NODE-OPCUA-E10] ${stream.buffer.length} totalLength = ${totalLength} chunkManager.maxBodySize = ${this.maxMessageSize}`);
          return messageChunkCallback(new Error("message chunkCount exceeds the negotiated maximum message count"), makeAbandonChunk());
        }
        if (this.maxMessageSize > 0 && totalLength > this.maxMessageSize) {
          errorLog(`[NODE-OPCUA-E11] message size ${totalLength} exceeds the negotiated message size ${this.maxMessageSize} nb chunks ${chunkCount}`);
          return messageChunkCallback(new Error("message size exceeds the negotiated message size"), makeAbandonChunk());
        }
        let nbChunks = 0;
        let totalSize = 0;
        chunkManager.on("chunk", (messageChunk) => {
          nbChunks++;
          totalSize += messageChunk.length;
          if (this.maxChunkCount && nbChunks > this.maxChunkCount) {
            errorLog(`[NODE-OPCUA-E09] message chunkCount ${nbChunks} exceeds the negotiated maximum message count ${this.maxChunkCount}, message current size is ${totalSize}`);
          }
          messageChunkCallback(null, messageChunk);
        }).on("finished", () => {
          if (doTraceChunk) {
            console.log((0, node_opcua_utils_1.timestamp)(), "   <$$ ", msgType, "nbChunk = " + nbChunks.toString().padStart(3), "totalLength = " + totalSize.toString().padStart(8), "l=", binSize.toString().padStart(6), "maxChunkCount=", this.maxChunkCount, "maxMessageSize=", this.maxMessageSize);
          }
          if (this.maxMessageSize !== 0 && totalSize > this.maxMessageSize) {
            errorLog(`[NODE-OPCUA-E07] message size ${totalSize} exceeds the negotiated message size ${this.maxMessageSize} nb chunks ${nbChunks}`);
          }
          messageChunkCallback(null, null);
        });
        chunkManager.write(stream.buffer, stream.buffer.length);
        chunkManager.end();
      }
    };
    exports2.MessageChunker = MessageChunker;
    MessageChunker.defaultMaxMessageSize = 16 * 1024 * 1024;
    MessageChunker.defaultChunkCount = 0;
  }
});

// node_modules/node-opcua-secure-channel/dist/source/secure_channel_service.js
var require_secure_channel_service = __commonJS({
  "node_modules/node-opcua-secure-channel/dist/source/secure_channel_service.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.chooseSecurityHeader = exports2.MessageChunker = exports2.ServiceFault = exports2.CloseSecureChannelResponse = exports2.CloseSecureChannelRequest = exports2.OpenSecureChannelResponse = exports2.OpenSecureChannelRequest = exports2.HelloMessage = exports2.AcknowledgeMessage = exports2.SymmetricAlgorithmSecurityHeader = exports2.AsymmetricAlgorithmSecurityHeader = void 0;
    var node_opcua_service_secure_channel_1 = require_dist38();
    Object.defineProperty(exports2, "AsymmetricAlgorithmSecurityHeader", { enumerable: true, get: function() {
      return node_opcua_service_secure_channel_1.AsymmetricAlgorithmSecurityHeader;
    } });
    Object.defineProperty(exports2, "SymmetricAlgorithmSecurityHeader", { enumerable: true, get: function() {
      return node_opcua_service_secure_channel_1.SymmetricAlgorithmSecurityHeader;
    } });
    var node_opcua_transport_1 = require_source5();
    Object.defineProperty(exports2, "AcknowledgeMessage", { enumerable: true, get: function() {
      return node_opcua_transport_1.AcknowledgeMessage;
    } });
    Object.defineProperty(exports2, "HelloMessage", { enumerable: true, get: function() {
      return node_opcua_transport_1.HelloMessage;
    } });
    var node_opcua_service_secure_channel_2 = require_dist38();
    Object.defineProperty(exports2, "OpenSecureChannelRequest", { enumerable: true, get: function() {
      return node_opcua_service_secure_channel_2.OpenSecureChannelRequest;
    } });
    Object.defineProperty(exports2, "OpenSecureChannelResponse", { enumerable: true, get: function() {
      return node_opcua_service_secure_channel_2.OpenSecureChannelResponse;
    } });
    Object.defineProperty(exports2, "CloseSecureChannelRequest", { enumerable: true, get: function() {
      return node_opcua_service_secure_channel_2.CloseSecureChannelRequest;
    } });
    Object.defineProperty(exports2, "CloseSecureChannelResponse", { enumerable: true, get: function() {
      return node_opcua_service_secure_channel_2.CloseSecureChannelResponse;
    } });
    Object.defineProperty(exports2, "ServiceFault", { enumerable: true, get: function() {
      return node_opcua_service_secure_channel_2.ServiceFault;
    } });
    var message_chunker_1 = require_message_chunker();
    Object.defineProperty(exports2, "MessageChunker", { enumerable: true, get: function() {
      return message_chunker_1.MessageChunker;
    } });
    var secure_message_chunk_manager_1 = require_secure_message_chunk_manager();
    Object.defineProperty(exports2, "chooseSecurityHeader", { enumerable: true, get: function() {
      return secure_message_chunk_manager_1.chooseSecurityHeader;
    } });
  }
});

// node_modules/node-opcua-secure-channel/dist/source/security_policy.js
var require_security_policy = __commonJS({
  "node_modules/node-opcua-secure-channel/dist/source/security_policy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getOptionsForSymmetricSignAndEncrypt = exports2.verifySignature = exports2.computeSignature = exports2.getCryptoFactory = exports2.computeDerivedKeys = exports2.RSAPKCS1V15_Encrypt = exports2.asymmetricVerifyChunk = exports2.RSAPKCS1V15_Decrypt = exports2.coerceSecurityPolicy = exports2.toURI = exports2.fromURI = exports2.SecurityPolicy = void 0;
    var crypto_1 = require("crypto");
    var crypto_2 = require("crypto");
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_service_secure_channel_1 = require_dist38();
    var node_opcua_crypto_1 = require_dist33();
    var node_opcua_debug_1 = require_dist24();
    function errorLog(...args) {
    }
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var SecurityPolicy;
    (function(SecurityPolicy2) {
      SecurityPolicy2["Invalid"] = "invalid";
      SecurityPolicy2["None"] = "http://opcfoundation.org/UA/SecurityPolicy#None";
      SecurityPolicy2["Basic128"] = "http://opcfoundation.org/UA/SecurityPolicy#Basic128";
      SecurityPolicy2["Basic192"] = "http://opcfoundation.org/UA/SecurityPolicy#Basic192";
      SecurityPolicy2["Basic192Rsa15"] = "http://opcfoundation.org/UA/SecurityPolicy#Basic192Rsa15";
      SecurityPolicy2["Basic256Rsa15"] = "http://opcfoundation.org/UA/SecurityPolicy#Basic256Rsa15";
      SecurityPolicy2["Basic256Sha256"] = "http://opcfoundation.org/UA/SecurityPolicy#Basic256Sha256";
      SecurityPolicy2["Aes128_Sha256_RsaOaep"] = "http://opcfoundation.org/UA/SecurityPolicy#Aes128_Sha256_RsaOaep";
      SecurityPolicy2["Aes256_Sha256_RsaPss"] = "http://opcfoundation.org/UA/SecurityPolicy#Aes256_Sha256_RsaPss";
      SecurityPolicy2["PubSub_Aes128_CTR"] = "http://opcfoundation.org/UA/SecurityPolicy#PubSub_Aes128_CTR";
      SecurityPolicy2["PubSub_Aes256_CTR"] = "http://opcfoundation.org/UA/SecurityPolicy#PubSub_Aes256_CTR";
      SecurityPolicy2["Basic128Rsa15"] = "http://opcfoundation.org/UA/SecurityPolicy#Basic128Rsa15";
      SecurityPolicy2["Basic256"] = "http://opcfoundation.org/UA/SecurityPolicy#Basic256";
    })(SecurityPolicy || (exports2.SecurityPolicy = SecurityPolicy = {}));
    function fromURI(uri) {
      if (typeof uri !== "string") {
        return SecurityPolicy.Invalid;
      }
      const a = uri.split("#");
      if (a.length < 2) {
        return SecurityPolicy.Invalid;
      }
      const v = SecurityPolicy[a[1]];
      return v || SecurityPolicy.Invalid;
    }
    exports2.fromURI = fromURI;
    function toURI(value) {
      if (typeof value === "string") {
        const a = value.split("#");
        if (a.length < 2) {
          return SecurityPolicy[value];
        }
        return value;
      }
      const securityPolicy = value || SecurityPolicy.Invalid;
      if (securityPolicy === SecurityPolicy.Invalid) {
        throw new Error("trying to convert an invalid Security Policy into a URI: " + value);
      }
      return SecurityPolicy[securityPolicy];
    }
    exports2.toURI = toURI;
    function coerceSecurityPolicy(value) {
      if (value === void 0 || value === null) {
        return SecurityPolicy.None;
      }
      if (value === "Basic128Rsa15" || value === "Basic256" || value === "Basic192Rsa15" || value === "None" || value === "Basic256Sha256" || value === "Aes128_Sha256_RsaOaep" || value === "Aes256_Sha256_RsaPss" || value === "Basic256Rsa15") {
        return SecurityPolicy[value];
      }
      if (!(value === SecurityPolicy.Basic128Rsa15 || value === SecurityPolicy.Basic256 || value === SecurityPolicy.Basic192Rsa15 || value === SecurityPolicy.Basic256Rsa15 || value === SecurityPolicy.Basic256Sha256 || value === SecurityPolicy.Aes128_Sha256_RsaOaep || value === SecurityPolicy.Aes256_Sha256_RsaPss || value === SecurityPolicy.None)) {
        errorLog("coerceSecurityPolicy: invalid security policy ", value, SecurityPolicy);
      }
      return value;
    }
    exports2.coerceSecurityPolicy = coerceSecurityPolicy;
    function RSAPKCS1V15_Decrypt(buffer, privateKey) {
      try {
        const blockSize = (0, node_opcua_crypto_1.rsaLengthPrivateKey)(privateKey);
        return (0, node_opcua_crypto_1.privateDecrypt_long)(buffer, privateKey, blockSize, node_opcua_crypto_1.PaddingAlgorithm.RSA_PKCS1_PADDING);
      } catch (err) {
        console.log("err = ", err);
        throw err;
      }
    }
    exports2.RSAPKCS1V15_Decrypt = RSAPKCS1V15_Decrypt;
    function RSAOAEP_Decrypt(buffer, privateKey) {
      const blockSize = (0, node_opcua_crypto_1.rsaLengthPrivateKey)(privateKey);
      return (0, node_opcua_crypto_1.privateDecrypt_long)(buffer, privateKey, blockSize, node_opcua_crypto_1.PaddingAlgorithm.RSA_PKCS1_OAEP_PADDING);
    }
    function asymmetricVerifyChunk(self2, chunk, certificate) {
      (0, node_opcua_assert_1.assert)(chunk instanceof Buffer);
      (0, node_opcua_assert_1.assert)(certificate instanceof Buffer);
      const cert = (0, node_opcua_crypto_1.exploreCertificateInfo)(certificate);
      const signatureLength = cert.publicKeyLength;
      const blockToVerify = chunk.subarray(0, chunk.length - signatureLength);
      const signature = chunk.subarray(chunk.length - signatureLength);
      return self2.asymmetricVerify(blockToVerify, signature, certificate);
    }
    exports2.asymmetricVerifyChunk = asymmetricVerifyChunk;
    function RSA_PKCS1V15_SHA1_Verify(buffer, signature, certificate) {
      (0, node_opcua_assert_1.assert)(certificate instanceof Buffer);
      (0, node_opcua_assert_1.assert)(signature instanceof Buffer);
      const options = {
        algorithm: "RSA-SHA1",
        publicKey: (0, node_opcua_crypto_1.toPem)(certificate, "CERTIFICATE"),
        signatureLength: 0
      };
      return (0, node_opcua_crypto_1.verifyMessageChunkSignature)(buffer, signature, options);
    }
    var RSA_PKCS1_OAEP_SHA1_Verify = RSA_PKCS1V15_SHA1_Verify;
    function RSA_PKCS1_OAEP_SHA256_Verify(buffer, signature, certificate) {
      const options = {
        algorithm: "RSA-SHA256",
        publicKey: (0, node_opcua_crypto_1.toPem)(certificate, "CERTIFICATE"),
        signatureLength: 0
      };
      return (0, node_opcua_crypto_1.verifyMessageChunkSignature)(buffer, signature, options);
    }
    function RSA_PKCS1V15_SHA1_Sign(buffer, privateKey) {
      const params = {
        algorithm: "RSA-SHA1",
        privateKey,
        signatureLength: (0, node_opcua_crypto_1.rsaLengthPrivateKey)(privateKey)
      };
      return (0, node_opcua_crypto_1.makeMessageChunkSignature)(buffer, params);
    }
    function RSA_PKCS1V15_SHA256_Sign(buffer, privateKey) {
      const params = {
        algorithm: "RSA-SHA256",
        privateKey,
        signatureLength: (0, node_opcua_crypto_1.rsaLengthPrivateKey)(privateKey)
      };
      return (0, node_opcua_crypto_1.makeMessageChunkSignature)(buffer, params);
    }
    var RSA_PKCS1_OAEP_SHA1_Sign = RSA_PKCS1V15_SHA1_Sign;
    function RSAPKCS1V15_Encrypt(buffer, publicKey) {
      try {
        const keyLength = (0, node_opcua_crypto_1.rsaLengthPublicKey)(publicKey);
        return (0, node_opcua_crypto_1.publicEncrypt_long)(buffer, publicKey, keyLength, 11, node_opcua_crypto_1.PaddingAlgorithm.RSA_PKCS1_PADDING);
      } catch (err) {
        console.log(err);
        throw err;
      }
    }
    exports2.RSAPKCS1V15_Encrypt = RSAPKCS1V15_Encrypt;
    function RSAOAEP_Encrypt(buffer, publicKey) {
      const keyLength = (0, node_opcua_crypto_1.rsaLengthPublicKey)(publicKey);
      return (0, node_opcua_crypto_1.publicEncrypt_long)(buffer, publicKey, keyLength, 42, node_opcua_crypto_1.PaddingAlgorithm.RSA_PKCS1_OAEP_PADDING);
    }
    function RSA_PSS_SHA2_256_Sign(buffer, privateKey) {
      const key = privateKey.hidden instanceof crypto_1.KeyObject ? privateKey.hidden : (0, crypto_1.createPrivateKey)({
        key: privateKey.hidden,
        format: "pem"
      });
      const signer = (0, crypto_1.createSign)("RSA-SHA256");
      signer.update(buffer);
      const signature = signer.sign({
        key,
        padding: crypto_2.constants.RSA_PKCS1_PSS_PADDING,
        saltLength: crypto_2.constants.RSA_PSS_SALTLEN_DIGEST
      });
      return signature;
    }
    function RSA_PSS_SHA2_256_Verify(buffer, signature, certificate) {
      const verify = (0, crypto_1.createVerify)("RSA-SHA256");
      verify.update(buffer);
      return verify.verify({
        key: (0, node_opcua_crypto_1.toPem)(certificate, "CERTIFICATE"),
        padding: crypto_2.constants.RSA_PKCS1_PSS_PADDING,
        saltLength: crypto_2.constants.RSA_PSS_SALTLEN_DIGEST
      }, signature);
    }
    function RSA_OAEP_SHA2_256_Encrypt(buffer, publicKey) {
      const blockSize = (0, node_opcua_crypto_1.rsaLengthPublicKey)(publicKey);
      const padding = _Aes256_Sha256_RsaPss.blockPaddingSize;
      const chunk_size = blockSize - padding;
      const nbBlocks = Math.ceil(buffer.length / chunk_size);
      const options = {
        key: publicKey,
        oaepHash: "sha256",
        padding: crypto_2.constants.RSA_PKCS1_OAEP_PADDING
      };
      const outputBuffer = Buffer.alloc(nbBlocks * blockSize);
      for (let i = 0; i < nbBlocks; i++) {
        const currentBlock = buffer.subarray(chunk_size * i, chunk_size * (i + 1));
        const encrypted_chunk = (0, crypto_2.publicEncrypt)(options, currentBlock);
        if (encrypted_chunk.length !== blockSize) {
          throw new Error(`publicEncrypt_long unexpected chunk length ${encrypted_chunk.length}  expecting ${blockSize}`);
        }
        encrypted_chunk.copy(outputBuffer, i * blockSize);
      }
      return outputBuffer;
    }
    function RSA_OAEP_SHA2_256_Decrypt(buffer, privateKey) {
      const blockSize = (0, node_opcua_crypto_1.rsaLengthPrivateKey)(privateKey);
      const nbBlocks = Math.ceil(buffer.length / blockSize);
      const key = privateKey.hidden instanceof crypto_1.KeyObject ? privateKey.hidden : (0, crypto_1.createPrivateKey)({
        key: privateKey.hidden,
        format: "pem"
      });
      const outputBuffer = Buffer.alloc(nbBlocks * blockSize);
      const options = {
        key,
        oaepHash: "sha256",
        padding: crypto_2.constants.RSA_PKCS1_OAEP_PADDING
      };
      let total_length = 0;
      for (let i = 0; i < nbBlocks; i++) {
        const currentBlock = buffer.subarray(blockSize * i, Math.min(blockSize * (i + 1), buffer.length));
        const decrypted_buf = (0, crypto_2.privateDecrypt)(options, currentBlock);
        decrypted_buf.copy(outputBuffer, total_length);
        total_length += decrypted_buf.length;
      }
      return outputBuffer.subarray(0, total_length);
    }
    function computeDerivedKeys(cryptoFactory, serverNonce, clientNonce) {
      if (clientNonce && serverNonce) {
        const options = {
          algorithm: cryptoFactory.symmetricEncryptionAlgorithm,
          encryptingBlockSize: cryptoFactory.encryptingBlockSize,
          encryptingKeyLength: cryptoFactory.derivedEncryptionKeyLength,
          sha1or256: cryptoFactory.sha1or256,
          signatureLength: cryptoFactory.signatureLength,
          signingKeyLength: cryptoFactory.derivedSignatureKeyLength
        };
        return {
          algorithm: null,
          derivedClientKeys: (0, node_opcua_crypto_1.computeDerivedKeys)(serverNonce, clientNonce, options),
          derivedServerKeys: (0, node_opcua_crypto_1.computeDerivedKeys)(clientNonce, serverNonce, options)
        };
      } else {
        return { derivedClientKeys: null, derivedServerKeys: null, algorithm: null };
      }
    }
    exports2.computeDerivedKeys = computeDerivedKeys;
    var factoryBasic128Rsa15 = {
      derivedEncryptionKeyLength: 16,
      derivedSignatureKeyLength: 16,
      encryptingBlockSize: 16,
      securityPolicy: SecurityPolicy.Basic128Rsa15,
      signatureLength: 20,
      symmetricKeyLength: 16,
      maximumAsymmetricKeyLength: 512,
      minimumAsymmetricKeyLength: 128,
      /* asymmetric signature algorithm */
      asymmetricVerifyChunk,
      asymmetricSign: RSA_PKCS1V15_SHA1_Sign,
      asymmetricVerify: RSA_PKCS1V15_SHA1_Verify,
      asymmetricSignatureAlgorithm: "http://www.w3.org/2000/09/xmldsig#rsa-sha1",
      /* asymmetric encryption algorithm */
      asymmetricEncrypt: RSAPKCS1V15_Encrypt,
      asymmetricDecrypt: RSAPKCS1V15_Decrypt,
      asymmetricEncryptionAlgorithm: "http://www.w3.org/2001/04/xmlenc#rsa-1_5",
      blockPaddingSize: 11,
      symmetricEncryptionAlgorithm: "aes-128-cbc",
      sha1or256: "SHA1"
    };
    var _Basic256 = {
      securityPolicy: SecurityPolicy.Basic256,
      derivedEncryptionKeyLength: 32,
      derivedSignatureKeyLength: 24,
      encryptingBlockSize: 16,
      signatureLength: 20,
      symmetricKeyLength: 32,
      maximumAsymmetricKeyLength: 512,
      minimumAsymmetricKeyLength: 128,
      asymmetricVerifyChunk,
      asymmetricSign: RSA_PKCS1_OAEP_SHA1_Sign,
      asymmetricVerify: RSA_PKCS1_OAEP_SHA1_Verify,
      asymmetricSignatureAlgorithm: "http://www.w3.org/2000/09/xmldsig#rsa-sha1",
      /* asymmetric encryption algorithm */
      asymmetricEncrypt: RSAOAEP_Encrypt,
      asymmetricDecrypt: RSAOAEP_Decrypt,
      asymmetricEncryptionAlgorithm: "http://www.w3.org/2001/04/xmlenc#rsa-oaep",
      blockPaddingSize: 42,
      // "aes-256-cbc"
      symmetricEncryptionAlgorithm: "aes-256-cbc",
      sha1or256: "SHA1"
    };
    var _Basic256Sha256 = {
      securityPolicy: SecurityPolicy.Basic256Sha256,
      derivedEncryptionKeyLength: 32,
      derivedSignatureKeyLength: 32,
      encryptingBlockSize: 16,
      signatureLength: 32,
      symmetricKeyLength: 32,
      maximumAsymmetricKeyLength: 4096,
      minimumAsymmetricKeyLength: 2048,
      asymmetricVerifyChunk,
      asymmetricSign: RSA_PKCS1V15_SHA256_Sign,
      asymmetricVerify: RSA_PKCS1_OAEP_SHA256_Verify,
      asymmetricSignatureAlgorithm: "http://www.w3.org/2001/04/xmldsig-more#rsa-sha256",
      /* asymmetric encryption algorithm */
      asymmetricEncrypt: RSAOAEP_Encrypt,
      asymmetricDecrypt: RSAOAEP_Decrypt,
      asymmetricEncryptionAlgorithm: "http://www.w3.org/2001/04/xmlenc#rsa-oaep",
      blockPaddingSize: 42,
      // "aes-256-cbc"
      symmetricEncryptionAlgorithm: "aes-256-cbc",
      sha1or256: "SHA256"
    };
    var _Aes128_Sha256_RsaOaep = {
      securityPolicy: SecurityPolicy.Aes128_Sha256_RsaOaep,
      derivedEncryptionKeyLength: 16,
      derivedSignatureKeyLength: 32,
      encryptingBlockSize: 16,
      signatureLength: 32,
      symmetricKeyLength: 32,
      maximumAsymmetricKeyLength: 4096,
      minimumAsymmetricKeyLength: 2048,
      asymmetricVerifyChunk,
      asymmetricSign: RSA_PKCS1V15_SHA256_Sign,
      asymmetricVerify: RSA_PKCS1_OAEP_SHA256_Verify,
      asymmetricSignatureAlgorithm: "http://www.w3.org/2001/04/xmldsig-more#rsa-sha256",
      /* asymmetric encryption algorithm */
      asymmetricEncrypt: RSAOAEP_Encrypt,
      asymmetricDecrypt: RSAOAEP_Decrypt,
      asymmetricEncryptionAlgorithm: "http://www.w3.org/2001/04/xmlenc#rsa-oaep",
      blockPaddingSize: 42,
      // "aes-128-cbc" : 128 bits : 16 bytes
      symmetricEncryptionAlgorithm: "aes-128-cbc",
      sha1or256: "SHA256"
    };
    var _Aes256_Sha256_RsaPss = {
      securityPolicy: SecurityPolicy.Aes256_Sha256_RsaPss,
      derivedEncryptionKeyLength: 32,
      derivedSignatureKeyLength: 32,
      encryptingBlockSize: 16,
      signatureLength: 32,
      symmetricKeyLength: 32,
      maximumAsymmetricKeyLength: 4096,
      minimumAsymmetricKeyLength: 2048,
      asymmetricVerifyChunk,
      asymmetricSign: RSA_PSS_SHA2_256_Sign,
      asymmetricVerify: RSA_PSS_SHA2_256_Verify,
      asymmetricSignatureAlgorithm: "http://www.w3.org/2001/04/xmldsig-more#rsa-pss-sha256",
      /* asymmetric encryption algorithm */
      asymmetricEncrypt: RSA_OAEP_SHA2_256_Encrypt,
      asymmetricDecrypt: RSA_OAEP_SHA2_256_Decrypt,
      asymmetricEncryptionAlgorithm: "http://opcfoundation.org/UA/security/rsa-oaep-sha2-256",
      blockPaddingSize: 66,
      // "aes-256-cbc"
      symmetricEncryptionAlgorithm: "aes-256-cbc",
      sha1or256: "SHA256"
    };
    function getCryptoFactory(securityPolicy) {
      switch (securityPolicy) {
        case SecurityPolicy.None:
          return null;
        case SecurityPolicy.Basic128Rsa15:
          return factoryBasic128Rsa15;
        case SecurityPolicy.Basic256:
          return _Basic256;
        case SecurityPolicy.Basic256Sha256:
          return _Basic256Sha256;
        case SecurityPolicy.Aes128_Sha256_RsaOaep:
          return _Aes128_Sha256_RsaOaep;
        case SecurityPolicy.Aes256_Sha256_RsaPss:
          return _Aes256_Sha256_RsaPss;
        default: {
          errorLog(" Security policy ", securityPolicy, "is not supported");
          return null;
        }
      }
    }
    exports2.getCryptoFactory = getCryptoFactory;
    function computeSignature(senderCertificate, senderNonce, receiverPrivateKey, securityPolicy) {
      if (!senderNonce || !senderCertificate || senderCertificate.length === 0 || !receiverPrivateKey) {
        return void 0;
      }
      const chain = (0, node_opcua_crypto_1.split_der)(senderCertificate);
      const cryptoFactory = getCryptoFactory(securityPolicy);
      if (!cryptoFactory) {
        return void 0;
      }
      const dataToSign = Buffer.concat([chain[0], senderNonce]);
      const signature = cryptoFactory.asymmetricSign(dataToSign, receiverPrivateKey);
      return new node_opcua_service_secure_channel_1.SignatureData({
        // A string containing the URI of the algorithm.
        // The URI string values are defined as part of the security profiles specified in Part 7.
        // (The SignatureAlgorithm shall be the AsymmetricSignatureAlgorithm specified in the
        // SecurityPolicy for the Endpoint)
        // for instance "http://www.w3.org/2000/09/xmldsig#rsa-sha1"
        algorithm: cryptoFactory.asymmetricSignatureAlgorithm,
        // This is a signature generated with the private key associated with a Certificate
        signature
      });
    }
    exports2.computeSignature = computeSignature;
    function verifySignature(receiverCertificate, receiverNonce, signature, senderCertificate, securityPolicy) {
      if (securityPolicy === SecurityPolicy.None) {
        return true;
      }
      const cryptoFactory = getCryptoFactory(securityPolicy);
      if (!cryptoFactory) {
        return false;
      }
      if (!(signature.signature instanceof Buffer)) {
        return false;
      }
      const chain = (0, node_opcua_crypto_1.split_der)(receiverCertificate);
      (0, node_opcua_assert_1.assert)(signature.signature instanceof Buffer);
      const dataToVerify = Buffer.concat([chain[0], receiverNonce]);
      try {
        return cryptoFactory.asymmetricVerify(dataToVerify, signature.signature, senderCertificate);
      } catch (e) {
        warningLog(`Error when verifying signature of certificate: ${e}`);
        return false;
      }
    }
    exports2.verifySignature = verifySignature;
    function getOptionsForSymmetricSignAndEncrypt(securityMode, derivedKeys) {
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(derivedKeys, "signatureLength"));
      (0, node_opcua_assert_1.assert)(securityMode !== node_opcua_service_secure_channel_1.MessageSecurityMode.None && securityMode !== node_opcua_service_secure_channel_1.MessageSecurityMode.Invalid);
      let options = {
        signBufferFunc: (chunk) => (0, node_opcua_crypto_1.makeMessageChunkSignatureWithDerivedKeys)(chunk, derivedKeys),
        signatureLength: derivedKeys.signatureLength
      };
      if (securityMode === node_opcua_service_secure_channel_1.MessageSecurityMode.SignAndEncrypt) {
        options = {
          ...options,
          cipherBlockSize: derivedKeys.encryptingBlockSize,
          encryptBufferFunc: (chunk) => (0, node_opcua_crypto_1.encryptBufferWithDerivedKeys)(chunk, derivedKeys),
          plainBlockSize: derivedKeys.encryptingBlockSize
        };
      }
      return options;
    }
    exports2.getOptionsForSymmetricSignAndEncrypt = getOptionsForSymmetricSignAndEncrypt;
  }
});

// node_modules/node-opcua-packet-analyzer/dist/source/packet_analyzer/packet_analyzer.js
var require_packet_analyzer = __commonJS({
  "node_modules/node-opcua-packet-analyzer/dist/source/packet_analyzer/packet_analyzer.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.analyze_object_binary_encoding = exports2.analyseExtensionObject = exports2.analyzePacket = void 0;
    var util_1 = require("util");
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_binary_stream_1 = require_dist18();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_factory_1 = require_dist26();
    var node_opcua_utils_1 = require_dist16();
    var spaces = "                                                                                                                                                                             ";
    function f2(n, width) {
      const s = n.toString();
      return (s + "      ").substring(0, Math.max(s.length, width));
    }
    function display_encoding_mask(padding, encodingMask, encodingInfo) {
      for (const v in encodingInfo) {
        if (!Object.prototype.hasOwnProperty.call(encodingInfo, v)) {
          continue;
        }
        const enumKey = encodingInfo[v];
        if (typeof enumKey === "number") {
          continue;
        }
        const mask = encodingInfo[enumKey];
        const bit = Math.log(mask) / Math.log(2);
        const bits = [".", ".", ".", ".", ".", ".", ".", ".", "."];
        bits[bit] = (encodingMask & mask) === mask ? "Y" : "n";
        console.log(padding + " ", bits.join(""), " <- has " + enumKey + " 0x" + mask.toString(16));
      }
    }
    function hex_block(start, end, buffer) {
      const n = end - start;
      const strBuf = (0, node_opcua_utils_1.buffer_ellipsis)(buffer);
      return chalk_1.default.cyan("s:") + f2(start, 4) + chalk_1.default.cyan(" e:") + f2(end, 4) + chalk_1.default.cyan(" n:") + f2(n, 4) + " " + chalk_1.default.yellow(strBuf);
    }
    function make_tracer(buffer, padding, offset) {
      padding = !padding ? 0 : padding;
      offset = offset || 0;
      const pad = () => "                                                       ".substring(0, padding);
      function _display(str, hexInfo) {
        hexInfo = hexInfo || "";
        const nbColorAttributes = [...str.split("")].filter((c2) => c2 === "\x1B").length;
        const extra = nbColorAttributes * 5;
        console.log((pad() + str + spaces).substring(0, 132 + extra) + "|" + hexInfo);
      }
      function display(str, hexInfo) {
        const lines = str.split("\n");
        for (const line of lines) {
          _display(line, hexInfo);
        }
      }
      function display_encodeable(value, buffer1, start, end) {
        const bufferExtract = buffer1.subarray(start, end);
        const stream = new node_opcua_binary_stream_1.BinaryStream(bufferExtract);
        const nodeId = (0, node_opcua_basic_types_1.decodeNodeId)(stream);
        const encodingMask = (0, node_opcua_basic_types_1.decodeByte)(stream);
        const length = (0, node_opcua_basic_types_1.decodeUInt32)(stream);
        display(chalk_1.default.green("     ExpandedNodId =") + " " + nodeId);
        display(chalk_1.default.green("     encoding mask =") + " " + encodingMask);
        display(chalk_1.default.green("            length =") + " " + length);
        analyzePacket(bufferExtract.subarray(stream.length), value.encodingDefaultBinary, padding + 2, start + stream.length);
      }
      return {
        tracer: {
          dump: (title, value) => display(title + "  " + chalk_1.default.green(value.toString())),
          encoding_byte: (encodingMask, valueEnum, start, end) => {
            (0, node_opcua_assert_1.assert)(valueEnum);
            const b = buffer.subarray(start, end);
            display("  012345678", hex_block(start, end, b));
            display_encoding_mask(pad(), encodingMask, valueEnum);
          },
          trace: (operation, name, value, start, end, fieldType) => {
            const b = buffer.subarray(start, end);
            let _hexDump = "";
            switch (operation) {
              case "start":
                padding += 2;
                display(name.toString());
                break;
              case "end":
                padding -= 2;
                break;
              case "start_array":
                display("." + name + " (length = " + value + ") [", hex_block(start, end, b));
                padding += 2;
                break;
              case "end_array":
                padding -= 2;
                display("] // " + name);
                break;
              case "start_element":
                display(" #" + value + " {");
                padding += 2;
                break;
              case "end_element":
                padding -= 2;
                display(" } // # " + value);
                break;
              case "member":
                display("." + name + " : " + fieldType);
                _hexDump = "";
                if (value instanceof Buffer) {
                  _hexDump = (0, node_opcua_debug_1.hexDump)(value);
                  console.log(_hexDump);
                  value = "<BUFFER>";
                }
                if (value && value.encode) {
                  if (fieldType === "ExtensionObject") {
                    display_encodeable(value, buffer, start, end);
                  } else {
                    const str = value.toString() || "<empty>";
                    display(str);
                  }
                } else {
                  display(" " + value, hex_block(start, end, b));
                }
                break;
            }
          }
        }
      };
    }
    function analyzePacket(buffer, objMessage, padding, offset, customOptions) {
      const stream = new node_opcua_binary_stream_1.BinaryStream(buffer);
      _internalAnalyzePacket(buffer, stream, objMessage, padding, customOptions, offset);
    }
    exports2.analyzePacket = analyzePacket;
    function analyseExtensionObject(buffer, padding, offset, customOptions) {
      const stream = new node_opcua_binary_stream_1.BinaryStream(buffer);
      let id;
      let objMessage;
      try {
        id = (0, node_opcua_basic_types_1.decodeExpandedNodeId)(stream);
        objMessage = (0, node_opcua_factory_1.getStandardDataTypeFactory)().constructObject(id);
      } catch (err) {
        console.log(id);
        console.log(err);
        console.log("Cannot read decodeExpandedNodeId  on stream " + stream.buffer.toString("hex"));
      }
      _internalAnalyzePacket(buffer, stream, objMessage, padding, customOptions, offset);
    }
    exports2.analyseExtensionObject = analyseExtensionObject;
    function _internalAnalyzePacket(buffer, stream, objMessage, padding, customOptions, offset) {
      let options = make_tracer(buffer, padding, offset);
      options.name = "message";
      if (customOptions)
        options = { ...options, ...customOptions };
      try {
        if (objMessage) {
          objMessage.decodeDebug(stream, options);
        } else {
          console.log(" Invalid object", objMessage);
        }
      } catch (err) {
        console.log(" Error in ", err);
        if (util_1.types.isNativeError(err)) {
          console.log(" Error in ", err.stack);
        }
        console.log(" objMessage ", (0, util_1.inspect)(objMessage, { colors: true }));
      }
    }
    function analyze_object_binary_encoding(obj) {
      (0, node_opcua_assert_1.assert)(obj);
      const size = obj.binaryStoreSize();
      console.log("-------------------------------------------------");
      console.log(" size = ", size);
      const stream = new node_opcua_binary_stream_1.BinaryStream(size);
      obj.encode(stream);
      stream.rewind();
      console.log("-------------------------------------------------");
      if (stream.buffer.length < 256) {
        console.log((0, node_opcua_debug_1.hexDump)(stream.buffer));
        console.log("-------------------------------------------------");
      }
      const reloadedObject = new obj.constructor();
      analyzePacket(stream.buffer, reloadedObject, 0);
    }
    exports2.analyze_object_binary_encoding = analyze_object_binary_encoding;
  }
});

// node_modules/node-opcua-packet-analyzer/dist/source/index.js
var require_source6 = __commonJS({
  "node_modules/node-opcua-packet-analyzer/dist/source/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.analyze_object_binary_encoding = exports2.analyseExtensionObject = exports2.analyzePacket = void 0;
    var packet_analyzer_1 = require_packet_analyzer();
    Object.defineProperty(exports2, "analyzePacket", { enumerable: true, get: function() {
      return packet_analyzer_1.analyzePacket;
    } });
    Object.defineProperty(exports2, "analyseExtensionObject", { enumerable: true, get: function() {
      return packet_analyzer_1.analyseExtensionObject;
    } });
    Object.defineProperty(exports2, "analyze_object_binary_encoding", { enumerable: true, get: function() {
      return packet_analyzer_1.analyze_object_binary_encoding;
    } });
  }
});

// node_modules/node-opcua-secure-channel/dist/source/message_builder.js
var require_message_builder = __commonJS({
  "node_modules/node-opcua-secure-channel/dist/source/message_builder.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.MessageBuilder = exports2.invalidPrivateKey = void 0;
    var util_1 = require("util");
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_binary_stream_1 = require_dist18();
    var node_opcua_crypto_1 = require_dist33();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_factory_1 = require_dist26();
    var node_opcua_packet_analyzer_1 = require_source6();
    var node_opcua_service_secure_channel_1 = require_dist38();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_transport_1 = require_source5();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_chunkmanager_1 = require_dist58();
    var node_opcua_transport_2 = require_source5();
    var secure_channel_service_1 = require_secure_channel_service();
    var security_policy_1 = require_security_policy();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var defaultObjectFactory = {
      constructObject(binaryEncodingNodeId) {
        return (0, node_opcua_factory_1.getStandardDataTypeFactory)().constructObject(binaryEncodingNodeId);
      },
      hasConstructor(binaryEncodingNodeId) {
        return (0, node_opcua_factory_1.getStandardDataTypeFactory)().hasConstructor(binaryEncodingNodeId);
      }
    };
    exports2.invalidPrivateKey = null;
    var counter = 0;
    var MessageBuilder = class extends node_opcua_transport_1.MessageBuilderBase {
      constructor(options) {
        super(options);
        options = options || {};
        this.id = (options.name ? options.name : "Id") + counter++;
        this.privateKey = options.privateKey || exports2.invalidPrivateKey;
        this.cryptoFactory = null;
        this.securityPolicy = security_policy_1.SecurityPolicy.Invalid;
        this.securityMode = options.securityMode || node_opcua_service_secure_channel_1.MessageSecurityMode.Invalid;
        this.objectFactory = options.objectFactory || defaultObjectFactory;
        (0, node_opcua_assert_1.assert)(typeof this.objectFactory.constructObject === "function", " the objectFactory must provide a constructObject method");
        this._previousSequenceNumber = -1;
        (0, node_opcua_assert_1.assert)(isFinite(this._previousSequenceNumber));
        this._tokenStack = [];
      }
      setSecurity(securityMode, securityPolicy) {
        (0, node_opcua_assert_1.assert)(this.securityMode === node_opcua_service_secure_channel_1.MessageSecurityMode.Invalid, "security already set");
        this.securityPolicy = (0, security_policy_1.coerceSecurityPolicy)(securityPolicy);
        this.securityMode = (0, node_opcua_service_secure_channel_1.coerceMessageSecurityMode)(securityMode);
        (0, node_opcua_assert_1.assert)(this.securityPolicy !== security_policy_1.SecurityPolicy.Invalid);
        (0, node_opcua_assert_1.assert)(this.securityMode !== node_opcua_service_secure_channel_1.MessageSecurityMode.Invalid);
      }
      dispose() {
        super.dispose();
        this.cryptoFactory = null;
        this.securityHeader = void 0;
        this._tokenStack = [];
        this.privateKey = exports2.invalidPrivateKey;
      }
      pushNewToken(securityToken, derivedKeys) {
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(securityToken, "tokenId"));
        this._tokenStack = this._tokenStack || [];
        (0, node_opcua_assert_1.assert)(this._tokenStack.length === 0 || this._tokenStack[0].securityToken.tokenId !== securityToken.tokenId);
        this._tokenStack.push({
          derivedKeys,
          securityToken
        });
        if (doDebug) {
          debugLog("id=", this.id, chalk_1.default.cyan("Pushing new token with id "), securityToken.tokenId, this.tokenIds());
        }
      }
      _read_headers(binaryStream) {
        if (!super._read_headers(binaryStream)) {
          return false;
        }
        if (!this.messageHeader) {
          throw new Error("internal error");
        }
        try {
          (0, node_opcua_assert_1.assert)(binaryStream.length === 12);
          const msgType = this.messageHeader.msgType;
          if (msgType === "HEL" || msgType === "ACK") {
            this.securityPolicy = security_policy_1.SecurityPolicy.None;
          } else if (msgType === "ERR") {
            binaryStream.length = 8;
            const errorCode = (0, node_opcua_status_code_1.decodeStatusCode)(binaryStream);
            const message = (0, node_opcua_basic_types_1.decodeString)(binaryStream);
            if (doDebug) {
              debugLog(chalk_1.default.red.bold(" ERROR RECEIVED FROM SENDER"), chalk_1.default.cyan(errorCode.toString()), message);
              debugLog((0, node_opcua_debug_1.hexDump)(binaryStream.buffer));
            }
            if (node_opcua_transport_2.doTraceChunk) {
              warningLog((0, node_opcua_utils_1.timestamp)(), chalk_1.default.red("   >$$ "), chalk_1.default.red(this.messageHeader.msgType), chalk_1.default.red("nbChunk = " + this.messageChunks.length.toString().padStart(3)), chalk_1.default.red("totalLength = " + this.totalMessageSize.toString().padStart(8)), "l=", this.messageHeader.length.toString().padStart(6), errorCode.toString(), message);
            }
            return true;
          } else {
            this.securityHeader = (0, secure_channel_service_1.chooseSecurityHeader)(msgType);
            this.securityHeader.decode(binaryStream);
            if (msgType === "OPN") {
              const asymmetricAlgorithmSecurityHeader = this.securityHeader;
              this.securityPolicy = (0, security_policy_1.fromURI)(asymmetricAlgorithmSecurityHeader.securityPolicyUri);
              this.cryptoFactory = (0, security_policy_1.getCryptoFactory)(this.securityPolicy);
            }
            if (!this._decrypt(binaryStream)) {
              return false;
            }
            this.sequenceHeader = new node_opcua_chunkmanager_1.SequenceHeader();
            this.sequenceHeader.decode(binaryStream);
            if (doDebug) {
              debugLog(" Sequence Header", this.sequenceHeader);
            }
            if (node_opcua_transport_2.doTraceChunk) {
              console.log(chalk_1.default.cyan((0, node_opcua_utils_1.timestamp)()), chalk_1.default.green("   >$$ "), chalk_1.default.green(this.messageHeader.msgType), chalk_1.default.green("nbChunk = " + this.messageChunks.length.toString().padStart(3)), chalk_1.default.green("totalLength = " + this.totalMessageSize.toString().padStart(8)), "l=", this.messageHeader.length.toString().padStart(6), "s=", this.sequenceHeader.sequenceNumber.toString().padEnd(4), "r=", this.sequenceHeader.requestId.toString().padEnd(4));
            }
            this._validateSequenceNumber(this.sequenceHeader.sequenceNumber);
          }
          return true;
        } catch (err) {
          warningLog(chalk_1.default.red("Error"), err.message);
          return false;
        }
      }
      _decodeMessageBody(fullMessageBody) {
        if (!this.messageHeader || !this.securityHeader) {
          return this._report_error(node_opcua_transport_1.StatusCodes2.BadTcpInternalError, "internal error");
        }
        const msgType = this.messageHeader.msgType;
        if (msgType === "HEL" || msgType === "ACK" || msgType === "ERR") {
          return this._report_error(node_opcua_transport_1.StatusCodes2.BadTcpMessageTypeInvalid, "Invalid message type ( HEL/ACK/ERR )");
        }
        if (msgType === "CLO" && fullMessageBody.length === 0 && this.sequenceHeader) {
          const objMessage1 = new node_opcua_service_secure_channel_1.CloseSecureChannelRequest();
          this.emit("message", objMessage1, msgType, this.sequenceHeader.requestId, this.channelId);
          return true;
        }
        const binaryStream = new node_opcua_binary_stream_1.BinaryStream(fullMessageBody);
        let id;
        try {
          id = (0, node_opcua_basic_types_1.decodeExpandedNodeId)(binaryStream);
        } catch (err) {
          return this._report_error(node_opcua_transport_1.StatusCodes2.BadTcpInternalError, "decodeExpandedNodeId " + (util_1.types.isNativeError(err) ? err.message : ""));
        }
        if (!this.objectFactory.hasConstructor(id)) {
          return this._report_error(node_opcua_status_code_1.StatusCodes.BadNotSupported, "cannot construct object with nodeID " + id.toString());
        }
        const objMessage = this.objectFactory.constructObject(id);
        if (!objMessage) {
          return this._report_error(node_opcua_status_code_1.StatusCodes.BadNotSupported, "cannot construct object with nodeID " + id);
        } else {
          if (this._safe_decode_message_body(fullMessageBody, objMessage, binaryStream)) {
            if (doDebug) {
              const o2 = objMessage;
              const requestHandle = o2.responseHeader ? o2.responseHeader.requestHandle : o2.requestHeader ? o2.requestHeader.requestHandle : "";
              debugLog(this.id, "message size =", ("" + this.totalMessageSize).padEnd(8), " body size   =", ("" + this.totalBodySize).padEnd(8), " requestHandle = ", requestHandle, objMessage.constructor.name);
            }
            try {
              this.emit("message", objMessage, msgType, this.sequenceHeader.requestId, this.channelId);
            } catch (err) {
              if (doDebug) {
                debugLog(err);
              }
              warningLog(chalk_1.default.red("MessageBuilder : ERROR DETECTED IN 'message' event handler"));
              if (util_1.types.isNativeError(err)) {
                warningLog(err.message);
              }
            }
          } else {
            warningLog("cannot decode message  for valid object of type " + id.toString() + " " + objMessage.constructor.name);
            this.emit("invalid_message", objMessage);
            debugLog(this.id, "message size =", ("" + this.totalMessageSize).padEnd(8), " body size   =", ("" + this.totalBodySize).padEnd(8), objMessage.constructor.name);
            warningLog(objMessage.toString());
            return false;
          }
        }
        return true;
      }
      _validateSequenceNumber(sequenceNumber) {
        (0, node_opcua_assert_1.assert)(isFinite(this._previousSequenceNumber));
        (0, node_opcua_assert_1.assert)(isFinite(sequenceNumber) && sequenceNumber >= 0);
        let expectedSequenceNumber;
        if (this._previousSequenceNumber !== -1) {
          expectedSequenceNumber = this._previousSequenceNumber + 1;
          if (expectedSequenceNumber !== sequenceNumber) {
            const errMessage = "Invalid Sequence Number found ( expected " + expectedSequenceNumber + ", got " + sequenceNumber + ")";
            debugLog(chalk_1.default.red.bold(errMessage));
            this.emit("invalid_sequence_number", expectedSequenceNumber, sequenceNumber);
          }
        }
        if (doDebug) {
          debugLog(chalk_1.default.yellow.bold("" + this.id + " Sequence Number = "), sequenceNumber);
        }
        this._previousSequenceNumber = sequenceNumber;
      }
      // eslint-disable-next-line max-statements
      _decrypt_OPN(binaryStream) {
        (0, node_opcua_assert_1.assert)(this.securityPolicy !== security_policy_1.SecurityPolicy.None);
        (0, node_opcua_assert_1.assert)(this.securityPolicy !== security_policy_1.SecurityPolicy.Invalid);
        (0, node_opcua_assert_1.assert)(this.securityMode !== node_opcua_service_secure_channel_1.MessageSecurityMode.None);
        (0, node_opcua_assert_1.assert)(this.securityHeader instanceof node_opcua_service_secure_channel_1.AsymmetricAlgorithmSecurityHeader);
        const asymmetricAlgorithmSecurityHeader = this.securityHeader;
        if (doDebug) {
          debugLog("securityHeader = {");
          debugLog("             securityPolicyId: ", asymmetricAlgorithmSecurityHeader.securityPolicyUri);
          debugLog("             senderCertificate: ", (0, node_opcua_crypto_1.makeSHA1Thumbprint)(asymmetricAlgorithmSecurityHeader.senderCertificate).toString("hex"));
          debugLog("};");
        }
        if (doDebug) {
          debugLog(chalk_1.default.cyan("EN------------------------------"));
          debugLog("---------------------- SENDER CERTIFICATE");
          debugLog("thumbprint ", (0, node_opcua_crypto_1.makeSHA1Thumbprint)(asymmetricAlgorithmSecurityHeader.senderCertificate).toString("hex"));
        }
        if (node_opcua_transport_2.doTraceChunk) {
          const thumb = (0, node_opcua_crypto_1.makeSHA1Thumbprint)(asymmetricAlgorithmSecurityHeader.senderCertificate).toString("hex");
          warningLog((0, node_opcua_utils_1.timestamp)(), ` >$$ securityPolicyId:  ${asymmetricAlgorithmSecurityHeader.securityPolicyUri} ${thumb} `);
        }
        if (!this.cryptoFactory) {
          warningLog(" Security Policy " + this.securityPolicy + " is not implemented yet");
          return false;
        }
        const buf = binaryStream.buffer.subarray(binaryStream.length);
        if (asymmetricAlgorithmSecurityHeader.receiverCertificateThumbprint) {
          (0, node_opcua_assert_1.assert)(this.privateKey !== exports2.invalidPrivateKey, "expecting a valid private key");
          try {
            const decryptedBuffer = this.cryptoFactory.asymmetricDecrypt(buf, this.privateKey);
            decryptedBuffer.copy(binaryStream.buffer, binaryStream.length);
            binaryStream.buffer = binaryStream.buffer.subarray(0, binaryStream.length + decryptedBuffer.length);
          } catch (err) {
            warningLog("Cannot decrypt OPN package");
            return false;
          }
          if (doDebug) {
            debugLog(chalk_1.default.cyan("DE-----------------------------"));
            debugLog(chalk_1.default.cyan("-------------------------------"));
            const thumbprint = (0, node_opcua_crypto_1.makeSHA1Thumbprint)(asymmetricAlgorithmSecurityHeader.senderCertificate);
            debugLog("Certificate thumbprint:", thumbprint.toString("hex"));
          }
        }
        const cert = (0, node_opcua_crypto_1.exploreCertificateInfo)(asymmetricAlgorithmSecurityHeader.senderCertificate);
        const signatureLength = cert.publicKeyLength;
        (0, node_opcua_assert_1.assert)(signatureLength === 128 || signatureLength === 256 || signatureLength === 384 || signatureLength === 512);
        const chunk = binaryStream.buffer;
        const signatureIsOK = (0, security_policy_1.asymmetricVerifyChunk)(this.cryptoFactory, chunk, asymmetricAlgorithmSecurityHeader.senderCertificate);
        if (!signatureIsOK) {
          if (doDebug) {
            debugLog((0, node_opcua_debug_1.hexDump)(binaryStream.buffer));
            warningLog("Sign and Encrypt asymmetricVerify : Invalid packet signature");
          }
          return false;
        }
        binaryStream.buffer = (0, node_opcua_crypto_1.reduceLength)(binaryStream.buffer, signatureLength);
        if (asymmetricAlgorithmSecurityHeader.receiverCertificateThumbprint) {
          binaryStream.buffer = (0, node_opcua_crypto_1.removePadding)(binaryStream.buffer);
        }
        return true;
      }
      tokenIds() {
        return this._tokenStack.map((a) => a.securityToken.tokenId);
      }
      _select_matching_token(tokenId) {
        if (doDebug) {
          debugLog("id=", this.id, " ", chalk_1.default.yellow("_select_matching_token : searching token "), tokenId, "length = ", this._tokenStack.length, this.tokenIds());
        }
        let gotNewToken = false;
        while (this._tokenStack.length) {
          const firstToken = this._tokenStack[0];
          if (firstToken.securityToken.tokenId === tokenId) {
            if (gotNewToken) {
              this.emit("new_token", tokenId);
            }
            if (doDebug) {
              debugLog("id=", this.id, chalk_1.default.red(" found token"), gotNewToken, firstToken.securityToken.tokenId, this.tokenIds());
            }
            return firstToken;
          }
          this._tokenStack.shift();
          if (doDebug) {
            debugLog("id=", this.id, "Remove first token ", firstToken.securityToken.tokenId, this.tokenIds());
          }
          gotNewToken = true;
        }
        if (doDebug) {
          debugLog("id=", this.id, " Cannot find token ", tokenId);
        }
        return null;
      }
      _decrypt_MSG(binaryStream) {
        if (!(this.securityHeader instanceof secure_channel_service_1.SymmetricAlgorithmSecurityHeader)) {
          throw new Error("Internal error : expecting a SymmetricAlgorithmSecurityHeader");
        }
        (0, node_opcua_assert_1.assert)(this.securityMode !== node_opcua_service_secure_channel_1.MessageSecurityMode.None);
        (0, node_opcua_assert_1.assert)(this.securityMode !== node_opcua_service_secure_channel_1.MessageSecurityMode.Invalid);
        (0, node_opcua_assert_1.assert)(this.securityPolicy !== security_policy_1.SecurityPolicy.None);
        (0, node_opcua_assert_1.assert)(this.securityPolicy !== security_policy_1.SecurityPolicy.Invalid);
        const symmetricAlgorithmSecurityHeader = this.securityHeader;
        const securityTokenData = this._select_matching_token(symmetricAlgorithmSecurityHeader.tokenId);
        if (!securityTokenData) {
          if (doDebug) {
            debugLog("Security token data for token " + symmetricAlgorithmSecurityHeader.tokenId + " doesn't exist");
          }
          return false;
        }
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(securityTokenData, "derivedKeys"));
        if (securityTokenData.securityToken.expired) {
          debugLog("Security token has expired : tokenId " + securityTokenData.securityToken.tokenId);
          return false;
        }
        const buf = binaryStream.buffer.subarray(binaryStream.length);
        const derivedKeys = securityTokenData.derivedKeys;
        if (!derivedKeys || derivedKeys.signatureLength === 0) {
          return false;
        }
        if (this.securityMode === node_opcua_service_secure_channel_1.MessageSecurityMode.SignAndEncrypt) {
          const decryptedBuffer = (0, node_opcua_crypto_1.decryptBufferWithDerivedKeys)(buf, derivedKeys);
          decryptedBuffer.copy(binaryStream.buffer, binaryStream.length);
          binaryStream.buffer = binaryStream.buffer.subarray(0, binaryStream.length + decryptedBuffer.length);
          if (doDebug) {
            debugLog(chalk_1.default.cyan("DE-----------------------------"));
            debugLog((0, node_opcua_debug_1.hexDump)(binaryStream.buffer));
            debugLog(chalk_1.default.cyan("-------------------------------"));
          }
        }
        const chunk = binaryStream.buffer;
        const signatureIsOK = (0, node_opcua_crypto_1.verifyChunkSignatureWithDerivedKeys)(chunk, derivedKeys);
        if (!signatureIsOK) {
          debugLog("_decrypt_MSG : Sign and Encrypt : Invalid packet signature");
          return false;
        }
        binaryStream.buffer = (0, node_opcua_crypto_1.reduceLength)(binaryStream.buffer, derivedKeys.signatureLength);
        if (this.securityMode === node_opcua_service_secure_channel_1.MessageSecurityMode.SignAndEncrypt) {
          binaryStream.buffer = (0, node_opcua_crypto_1.removePadding)(binaryStream.buffer);
        }
        return true;
      }
      _decrypt(binaryStream) {
        if (!this.messageHeader) {
          throw new Error("internal error");
        }
        if (this.securityPolicy === security_policy_1.SecurityPolicy.Invalid) {
          return true;
        }
        const msgType = this.messageHeader.msgType;
        if (this.securityPolicy === security_policy_1.SecurityPolicy.None) {
          this.securityMode = node_opcua_service_secure_channel_1.MessageSecurityMode.None;
          (0, node_opcua_assert_1.assert)(this.securityMode === node_opcua_service_secure_channel_1.MessageSecurityMode.None, "expecting securityMode = None when securityPolicy is None");
          return true;
        }
        (0, node_opcua_assert_1.assert)(this.securityMode !== node_opcua_service_secure_channel_1.MessageSecurityMode.None);
        if (msgType === "OPN") {
          return this._decrypt_OPN(binaryStream);
        } else {
          return this._decrypt_MSG(binaryStream);
        }
      }
      _safe_decode_message_body(fullMessageBody, objMessage, binaryStream) {
        try {
          const options = this.objectFactory;
          objMessage.decode(binaryStream, options);
        } catch (err) {
          if (util_1.types.isNativeError(err)) {
            warningLog("Decode message error : ", err.message);
            if (doDebug) {
              debugLog(err.stack);
              debugLog((0, node_opcua_debug_1.hexDump)(fullMessageBody));
              (0, node_opcua_packet_analyzer_1.analyseExtensionObject)(fullMessageBody, 0, 0);
              debugLog(" ---------------- block");
              let i = 0;
              this.messageChunks.forEach((messageChunk) => {
                debugLog(" ---------------- chunk i=", i++);
                debugLog((0, node_opcua_debug_1.hexDump)(messageChunk));
              });
            }
          }
          return false;
        }
        return true;
      }
    };
    exports2.MessageBuilder = MessageBuilder;
  }
});

// node_modules/node-opcua-secure-channel/dist/source/message_header_to_string.js
var require_message_header_to_string = __commonJS({
  "node_modules/node-opcua-secure-channel/dist/source/message_header_to_string.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.messageHeaderToString = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_binary_stream_1 = require_dist18();
    var node_opcua_chunkmanager_1 = require_dist58();
    var node_opcua_debug_1 = require_dist24();
    var secure_message_chunk_manager_1 = require_secure_message_chunk_manager();
    function messageHeaderToString(messageChunk) {
      const stream = new node_opcua_binary_stream_1.BinaryStream(messageChunk);
      const messageHeader = (0, node_opcua_chunkmanager_1.readMessageHeader)(stream);
      if (messageHeader.msgType === "ERR" || messageHeader.msgType === "HEL") {
        return messageHeader.msgType + " " + messageHeader.isFinal + " length   = " + messageHeader.length;
      }
      const securityHeader = (0, secure_message_chunk_manager_1.chooseSecurityHeader)(messageHeader.msgType);
      const sequenceHeader = new node_opcua_chunkmanager_1.SequenceHeader();
      (0, node_opcua_assert_1.assert)(stream.length === 8);
      const channelId = stream.readUInt32();
      securityHeader.decode(stream);
      sequenceHeader.decode(stream);
      const slice = messageChunk.subarray(0, stream.length);
      return messageHeader.msgType + " " + messageHeader.isFinal + " length   = " + messageHeader.length + " channel  = " + channelId + " seqNum   = " + sequenceHeader.sequenceNumber + " req ID   = " + sequenceHeader.requestId + " security   = " + securityHeader.toString() + "\n\n" + (0, node_opcua_debug_1.hexDump)(slice);
    }
    exports2.messageHeaderToString = messageHeaderToString;
  }
});

// node_modules/node-opcua-secure-channel/dist/source/common.js
var require_common2 = __commonJS({
  "node_modules/node-opcua-secure-channel/dist/source/common.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getThumbprint = exports2.extractFirstCertificateInChain = void 0;
    var node_opcua_crypto_1 = require_dist33();
    function extractFirstCertificateInChain(certificateChain) {
      if (!certificateChain || certificateChain.length === 0) {
        return null;
      }
      const c2 = (0, node_opcua_crypto_1.split_der)(certificateChain);
      return c2[0];
    }
    exports2.extractFirstCertificateInChain = extractFirstCertificateInChain;
    function getThumbprint(certificateChain) {
      if (!certificateChain) {
        return null;
      }
      return (0, node_opcua_crypto_1.makeSHA1Thumbprint)(extractFirstCertificateInChain(certificateChain));
    }
    exports2.getThumbprint = getThumbprint;
  }
});

// node_modules/node-opcua-secure-channel/dist/source/utils.js
var require_utils7 = __commonJS({
  "node_modules/node-opcua-secure-channel/dist/source/utils.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.traceClientResponseMessage = exports2.traceClientRequestMessage = exports2.traceClientResponseContent = exports2.traceClientRequestContent = exports2.traceResponseMessage = exports2.traceRequestMessage = exports2._dump_client_transaction_statistics = exports2._dump_transaction_statistics = exports2.dumpSecurityHeader = exports2.doTraceStatistics = exports2.doTraceClientResponseContent = exports2.doTraceClientRequestContent = exports2.doTraceClientMessage = exports2.doPerfMonitoring = exports2.doTraceResponse = exports2.doTraceRequest = exports2.doTraceServerMessage = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_status_code_1 = require_dist22();
    var traceLog = (0, node_opcua_debug_1.make_traceLog)(__filename);
    var clientFlag = (process.env?.NODEOPCUADEBUG?.match(/CLIENT{([^}]*)}/) || [])[1] || "";
    var serverFlag = (process.env?.NODEOPCUADEBUG?.match(/SERVER{([^}]*)}/) || [])[1] || "";
    var filter = new RegExp((process.env?.NODEOPCUADEBUG?.match(/FILTER{([^}]*)}/) || [])[1] || ".*");
    exports2.doTraceServerMessage = serverFlag.match(/TRACE/);
    exports2.doTraceRequest = serverFlag.match(/REQUEST/);
    exports2.doTraceResponse = serverFlag.match(/RESPONSE/);
    exports2.doPerfMonitoring = serverFlag.match(/PERF/);
    exports2.doTraceClientMessage = clientFlag.match(/TRACE/);
    exports2.doTraceClientRequestContent = clientFlag.match(/REQUEST/);
    exports2.doTraceClientResponseContent = clientFlag.match(/RESPONSE/);
    exports2.doTraceStatistics = process.env.NODEOPCUADEBUG && !!process.env.NODEOPCUADEBUG.match("STATS");
    exports2.dumpSecurityHeader = process.env.NODEOPCUADEBUG && !!process.env.NODEOPCUADEBUG.match("SECURITY");
    function _dump_transaction_statistics(stats) {
      if (stats) {
        console.log("                Bytes Read : ", stats.bytesRead);
        console.log("             Bytes Written : ", stats.bytesWritten);
        if (exports2.doPerfMonitoring) {
          console.log("   time to receive request : ", (stats.lap_reception / 1e3).toFixed(3), " sec");
          console.log("   time to process request : ", (stats.lap_processing / 1e3).toFixed(3), " sec");
          console.log("   time to send response   : ", (stats.lap_emission / 1e3).toFixed(3), " sec");
        }
      }
    }
    exports2._dump_transaction_statistics = _dump_transaction_statistics;
    function _dump_client_transaction_statistics(stats) {
      function w(str) {
        return str.toString().padStart(12, " ").substring(0, 12);
      }
      console.log(chalk_1.default.green.bold("--------------------------------------------------------------------->> Stats"));
      console.log("   request                   : ", chalk_1.default.yellow(stats.request.schema.name.toString()), " / ", chalk_1.default.yellow(stats.response.schema.name.toString()), " - ", stats.request.requestHeader.requestHandle, "/", stats.response.responseHeader.requestHandle, stats.response.responseHeader.serviceResult.toString());
      console.log("   Bytes Read                : ", w(stats.bytesRead), " bytes");
      console.log("   Bytes Written             : ", w(stats.bytesWritten), " bytes");
      if (exports2.doPerfMonitoring) {
        console.log("   transaction duration      : ", w(stats.lap_transaction.toFixed(3)), " milliseconds");
        console.log("   time to send request      : ", w(stats.lap_sending_request.toFixed(3)), " milliseconds");
        console.log("   time waiting for response : ", w(stats.lap_waiting_response.toFixed(3)), " milliseconds");
        console.log("   time to receive response  : ", w(stats.lap_receiving_response.toFixed(3)), " milliseconds");
        console.log("   time processing response  : ", w(stats.lap_processing_response.toFixed(3)), " milliseconds");
      }
      console.log(chalk_1.default.green.bold("---------------------------------------------------------------------<< Stats"));
    }
    exports2._dump_client_transaction_statistics = _dump_client_transaction_statistics;
    var nameLength = "TranslateBrowsePathsToNodeIdsResponse".length + 2;
    function __get_extraInfo(req) {
      if (req instanceof node_opcua_types_1.ReadRequest) {
        return " nodesToRead.length    =" + req.nodesToRead?.length;
      }
      if (req instanceof node_opcua_types_1.ReadResponse) {
        return " results.length        =" + req.results?.length;
      }
      if (req instanceof node_opcua_types_1.WriteRequest) {
        return " nodesToWrite.length   =" + req.nodesToWrite?.length;
      }
      if (req instanceof node_opcua_types_1.WriteResponse) {
        return " results.length        =" + req.results?.length;
      }
      if (req instanceof node_opcua_types_1.BrowseRequest) {
        return " nodesToBrowse.length  =" + req.nodesToBrowse?.length;
      }
      if (req instanceof node_opcua_types_1.BrowseResponse) {
        return " results.length        =" + req.results?.length;
      }
      if (req instanceof node_opcua_types_1.BrowseNextRequest) {
        return "                        ";
      }
      if (req instanceof node_opcua_types_1.BrowseNextResponse) {
        return " results.length        =" + req.results?.length;
      }
      if (req instanceof node_opcua_types_1.CreateSessionRequest) {
        return " " + req.sessionName + " to:" + req.requestedSessionTimeout + "ms";
      }
      if (req instanceof node_opcua_types_1.CreateSessionResponse) {
        return " " + req.sessionId + " to:" + req.revisedSessionTimeout + "ms";
      }
      if (req instanceof node_opcua_types_1.ActivateSessionRequest) {
        if (req.userIdentityToken instanceof node_opcua_types_1.AnonymousIdentityToken) {
          return " Anonymous";
        } else if (req.userIdentityToken instanceof node_opcua_types_1.UserNameIdentityToken) {
          return " UserName";
        } else if (req.userIdentityToken instanceof node_opcua_types_1.X509IdentityToken) {
          return " X509";
        }
      }
      if (req instanceof node_opcua_types_1.ActivateSessionResponse) {
        return (req.results || []).map((p3) => p3.toString()).join(" ");
      }
      if (req instanceof node_opcua_types_1.CreateMonitoredItemsRequest) {
        return " itemsToCreate.length  =" + req.itemsToCreate?.length;
      }
      if (req instanceof node_opcua_types_1.CreateMonitoredItemsResponse) {
        return " results.length        =" + req.results?.length;
      }
      if (req instanceof node_opcua_types_1.TranslateBrowsePathsToNodeIdsRequest) {
        return " browsePaths.length    =" + req.browsePaths?.length;
      }
      if (req instanceof node_opcua_types_1.TranslateBrowsePathsToNodeIdsResponse) {
        return " results.length        =" + req.results?.length;
      }
      if (req instanceof node_opcua_types_1.RegisterNodesRequest) {
        return " nodesToRegister.length=" + req.nodesToRegister?.length;
      }
      if (req instanceof node_opcua_types_1.OpenSecureChannelRequest) {
        return " " + node_opcua_types_1.SecurityTokenRequestType[req.requestType] + " " + node_opcua_types_1.MessageSecurityMode[req.securityMode] + " lt:" + req.requestedLifetime + "ms";
      }
      if (req instanceof node_opcua_types_1.RegisterNodesResponse) {
        return " nodesToRegister.length=" + req.registeredNodeIds?.length;
      }
      if (req instanceof node_opcua_types_1.PublishRequest) {
        return " " + req.requestHeader.timeoutHint + "ms";
      }
      if (req instanceof node_opcua_types_1.PublishResponse) {
        let t = "";
        if (req.notificationMessage.notificationData) {
          for (const n of req.notificationMessage.notificationData) {
            t += n?.constructor?.name + " ";
            if (n instanceof node_opcua_types_1.DataChangeNotification) {
              t += n.monitoredItems?.length;
            }
            if (n instanceof node_opcua_types_1.EventNotificationList) {
              t += n.events?.length;
            }
            if (n instanceof node_opcua_types_1.StatusChangeNotification) {
              t += n.status.toString();
            }
            t += " ";
            t = t.replace(/Notification/g, "Nt\xB0");
          }
        }
        return " " + t + " seq#=" + req.notificationMessage.sequenceNumber;
      }
      return "";
    }
    function _get_extraInfo(req) {
      return __get_extraInfo(req).padEnd(30);
    }
    function evaluateBinarySize(r) {
      const e = r;
      const size = e.binaryStoreSize();
      return "s=" + ("" + size).padStart(6) + " ";
    }
    function statusCodeToString(s) {
      if (s === node_opcua_status_code_1.StatusCodes.Good) {
        return chalk_1.default.green(s.toString());
      } else if (s.isGoodish()) {
        return chalk_1.default.yellow(s.toString());
      } else {
        return chalk_1.default.red(s.toString());
      }
    }
    function traceRequestMessage(request, channelId, instance) {
      if (exports2.doTraceServerMessage) {
        const extra = _get_extraInfo(request);
        const size = evaluateBinarySize(request);
        const requestId = request.requestHeader.requestHandle;
        console.log(chalk_1.default.green((0, node_opcua_utils_1.timestamp)(), "   >>>>> ------ S"), instance.toString().padStart(3), channelId.toString().padStart(3), requestId.toString().padStart(8), chalk_1.default.yellow(request.schema.name.padEnd(nameLength)), extra, size);
        if (exports2.doTraceRequest && filter && request.constructor.name.match(filter)) {
          console.log(request.toString());
          console.log(chalk_1.default.cyan("   >>>>> ------ \n"));
        }
      }
    }
    exports2.traceRequestMessage = traceRequestMessage;
    function traceResponseMessage(response, channelId, instance) {
      (0, node_opcua_assert_1.assert)(response.responseHeader.requestHandle >= 0);
      if (exports2.doTraceServerMessage) {
        const extra = _get_extraInfo(response);
        const size = evaluateBinarySize(response);
        const requestId = response.responseHeader.requestHandle;
        console.log(chalk_1.default.green.bold((0, node_opcua_utils_1.timestamp)(), "   <<<<< ------ S"), instance.toString().padStart(3), channelId.toString().padStart(3), requestId.toString().padStart(8), chalk_1.default.green.bold(response.schema.name.padEnd(nameLength)), extra, size, statusCodeToString(response.responseHeader.serviceResult));
        if (exports2.doTraceResponse && filter && response.constructor.name.match(filter)) {
          console.log(response.toString());
          console.log(chalk_1.default.cyan.bold("       <<<<< ------n"));
        }
      }
    }
    exports2.traceResponseMessage = traceResponseMessage;
    function traceClientRequestContent(request, channelId, securityToken) {
      traceLog(chalk_1.default.yellow.bold("------------------------------------- Client Sending a request  "), request.constructor.name, "h=", request.requestHeader.requestHandle, " channel id ", channelId, " securityToken=", securityToken ? securityToken.tokenId : "x");
      if (exports2.doTraceClientRequestContent) {
        traceLog(request.toString());
      }
    }
    exports2.traceClientRequestContent = traceClientRequestContent;
    function traceClientResponseContent(response, channelId) {
      if (exports2.doTraceClientResponseContent) {
        traceLog(response.toString());
      }
    }
    exports2.traceClientResponseContent = traceClientResponseContent;
    function traceClientRequestMessage(request, channelId, instance) {
      const extra = _get_extraInfo(request);
      const size = evaluateBinarySize(request);
      const requestId = request.requestHeader.requestHandle;
      console.log(chalk_1.default.cyan((0, node_opcua_utils_1.timestamp)(), "  >>>>>> ------ C"), instance.toString().padStart(3), channelId.toString().padStart(3), requestId.toString().padStart(8), request.schema.name.padEnd(nameLength), extra, size);
    }
    exports2.traceClientRequestMessage = traceClientRequestMessage;
    function additionalInfo(response) {
      if (response instanceof node_opcua_types_1.BrowseNextResponse || response instanceof node_opcua_types_1.BrowseResponse) {
        const results = response.results;
        if (!results)
          return "";
        const someBad = results.find((r) => r.statusCode.isNotGood());
        if (!someBad) {
          return "";
        }
        return "!!" + someBad.toString();
      }
      return "";
    }
    function traceClientResponseMessage(response, channelId, instance) {
      const extra = _get_extraInfo(response);
      const size = evaluateBinarySize(response);
      const requestId = response.responseHeader.requestHandle;
      console.log(chalk_1.default.cyan.bold((0, node_opcua_utils_1.timestamp)(), "  <<<<<< ------ C"), instance.toString().padStart(3), channelId.toString().padStart(3), requestId.toString().padStart(8), response.schema.name.padEnd(nameLength), extra, size, statusCodeToString(response.responseHeader.serviceResult), additionalInfo(response));
    }
    exports2.traceClientResponseMessage = traceClientResponseMessage;
  }
});

// node_modules/node-opcua-secure-channel/dist/source/client/duration_to_string.js
var require_duration_to_string = __commonJS({
  "node_modules/node-opcua-secure-channel/dist/source/client/duration_to_string.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.durationToString = exports2.absoluteDurationToString = void 0;
    var secondsInAMinute = 60;
    var secondsInAnHour = secondsInAMinute * 60;
    var secondsInADay = secondsInAnHour * 24;
    var secondsInAYear = 365 * secondsInADay;
    function absoluteDurationToString(durationInMilliseconds) {
      const seconds = Math.abs(durationInMilliseconds / 1e3);
      const numYears = Math.floor(seconds / secondsInAYear);
      const numDays = Math.floor(seconds % secondsInAYear / secondsInADay);
      const numHours = Math.floor(seconds % secondsInAYear % secondsInADay / secondsInAnHour);
      const numMinutes = Math.floor(seconds % secondsInAYear % secondsInADay % secondsInAnHour / secondsInAMinute);
      const numSeconds = (seconds % secondsInAYear % secondsInADay % secondsInAnHour % secondsInAMinute).toFixed(3);
      const str = [];
      if (numYears !== 0) {
        return `${numYears} years ${numDays} days ${numHours} hours ${numMinutes} minutes ${numSeconds} seconds`;
      }
      if (numDays !== 0) {
        return `${numDays} days ${numHours} hours ${numMinutes} minutes ${numSeconds} seconds`;
      }
      if (numHours !== 0) {
        return `${numHours} hours ${numMinutes} minutes ${numSeconds} seconds`;
      }
      if (numMinutes !== 0) {
        return `${numMinutes} minutes ${numSeconds} seconds`;
      }
      return `${numSeconds} seconds`;
    }
    exports2.absoluteDurationToString = absoluteDurationToString;
    function durationToString(durationInMilliseconds) {
      if (durationInMilliseconds < 0) {
        return `late by ${absoluteDurationToString(-durationInMilliseconds)}`;
      }
      return `early by ${absoluteDurationToString(durationInMilliseconds)}`;
    }
    exports2.durationToString = durationToString;
  }
});

// node_modules/precond/lib/errors.js
var require_errors5 = __commonJS({
  "node_modules/precond/lib/errors.js"(exports2, module2) {
    var util = require("util");
    function IllegalArgumentError(message) {
      Error.call(this, message);
      this.message = message;
    }
    util.inherits(IllegalArgumentError, Error);
    IllegalArgumentError.prototype.name = "IllegalArgumentError";
    function IllegalStateError(message) {
      Error.call(this, message);
      this.message = message;
    }
    util.inherits(IllegalStateError, Error);
    IllegalStateError.prototype.name = "IllegalStateError";
    module2.exports.IllegalStateError = IllegalStateError;
    module2.exports.IllegalArgumentError = IllegalArgumentError;
  }
});

// node_modules/precond/lib/checks.js
var require_checks = __commonJS({
  "node_modules/precond/lib/checks.js"(exports2, module2) {
    var util = require("util");
    var errors = module2.exports = require_errors5();
    function failCheck(ExceptionConstructor, callee, messageFormat, formatArgs) {
      messageFormat = messageFormat || "";
      var message = util.format.apply(this, [messageFormat].concat(formatArgs));
      var error = new ExceptionConstructor(message);
      Error.captureStackTrace(error, callee);
      throw error;
    }
    function failArgumentCheck(callee, message, formatArgs) {
      failCheck(errors.IllegalArgumentError, callee, message, formatArgs);
    }
    function failStateCheck(callee, message, formatArgs) {
      failCheck(errors.IllegalStateError, callee, message, formatArgs);
    }
    module2.exports.checkArgument = function(value, message) {
      if (!value) {
        failArgumentCheck(
          arguments.callee,
          message,
          Array.prototype.slice.call(arguments, 2)
        );
      }
    };
    module2.exports.checkState = function(value, message) {
      if (!value) {
        failStateCheck(
          arguments.callee,
          message,
          Array.prototype.slice.call(arguments, 2)
        );
      }
    };
    module2.exports.checkIsDef = function(value, message) {
      if (value !== void 0) {
        return value;
      }
      failArgumentCheck(
        arguments.callee,
        message || "Expected value to be defined but was undefined.",
        Array.prototype.slice.call(arguments, 2)
      );
    };
    module2.exports.checkIsDefAndNotNull = function(value, message) {
      if (value != null) {
        return value;
      }
      failArgumentCheck(arguments.callee, message || 'Expected value to be defined and not null but got "' + typeOf(value) + '".', Array.prototype.slice.call(arguments, 2));
    };
    function typeOf(value) {
      var s = typeof value;
      if (s == "object") {
        if (!value) {
          return "null";
        } else if (value instanceof Array) {
          return "array";
        }
      }
      return s;
    }
    function typeCheck(expect) {
      return function(value, message) {
        var type = typeOf(value);
        if (type == expect) {
          return value;
        }
        failArgumentCheck(
          arguments.callee,
          message || 'Expected "' + expect + '" but got "' + type + '".',
          Array.prototype.slice.call(arguments, 2)
        );
      };
    }
    module2.exports.checkIsString = typeCheck("string");
    module2.exports.checkIsArray = typeCheck("array");
    module2.exports.checkIsNumber = typeCheck("number");
    module2.exports.checkIsBoolean = typeCheck("boolean");
    module2.exports.checkIsFunction = typeCheck("function");
    module2.exports.checkIsObject = typeCheck("object");
  }
});

// node_modules/precond/index.js
var require_precond = __commonJS({
  "node_modules/precond/index.js"(exports2, module2) {
    module2.exports = require_checks();
  }
});

// node_modules/backoff/lib/backoff.js
var require_backoff = __commonJS({
  "node_modules/backoff/lib/backoff.js"(exports2, module2) {
    var events = require("events");
    var precond = require_precond();
    var util = require("util");
    function Backoff(backoffStrategy) {
      events.EventEmitter.call(this);
      this.backoffStrategy_ = backoffStrategy;
      this.maxNumberOfRetry_ = -1;
      this.backoffNumber_ = 0;
      this.backoffDelay_ = 0;
      this.timeoutID_ = -1;
      this.handlers = {
        backoff: this.onBackoff_.bind(this)
      };
    }
    util.inherits(Backoff, events.EventEmitter);
    Backoff.prototype.failAfter = function(maxNumberOfRetry) {
      precond.checkArgument(
        maxNumberOfRetry > 0,
        "Expected a maximum number of retry greater than 0 but got %s.",
        maxNumberOfRetry
      );
      this.maxNumberOfRetry_ = maxNumberOfRetry;
    };
    Backoff.prototype.backoff = function(err) {
      precond.checkState(this.timeoutID_ === -1, "Backoff in progress.");
      if (this.backoffNumber_ === this.maxNumberOfRetry_) {
        this.emit("fail", err);
        this.reset();
      } else {
        this.backoffDelay_ = this.backoffStrategy_.next();
        this.timeoutID_ = setTimeout(this.handlers.backoff, this.backoffDelay_);
        this.emit("backoff", this.backoffNumber_, this.backoffDelay_, err);
      }
    };
    Backoff.prototype.onBackoff_ = function() {
      this.timeoutID_ = -1;
      this.emit("ready", this.backoffNumber_, this.backoffDelay_);
      this.backoffNumber_++;
    };
    Backoff.prototype.reset = function() {
      this.backoffNumber_ = 0;
      this.backoffStrategy_.reset();
      clearTimeout(this.timeoutID_);
      this.timeoutID_ = -1;
    };
    module2.exports = Backoff;
  }
});

// node_modules/backoff/lib/strategy/strategy.js
var require_strategy = __commonJS({
  "node_modules/backoff/lib/strategy/strategy.js"(exports2, module2) {
    var events = require("events");
    var util = require("util");
    function isDef(value) {
      return value !== void 0 && value !== null;
    }
    function BackoffStrategy(options) {
      options = options || {};
      if (isDef(options.initialDelay) && options.initialDelay < 1) {
        throw new Error("The initial timeout must be greater than 0.");
      } else if (isDef(options.maxDelay) && options.maxDelay < 1) {
        throw new Error("The maximal timeout must be greater than 0.");
      }
      this.initialDelay_ = options.initialDelay || 100;
      this.maxDelay_ = options.maxDelay || 1e4;
      if (this.maxDelay_ <= this.initialDelay_) {
        throw new Error("The maximal backoff delay must be greater than the initial backoff delay.");
      }
      if (isDef(options.randomisationFactor) && (options.randomisationFactor < 0 || options.randomisationFactor > 1)) {
        throw new Error("The randomisation factor must be between 0 and 1.");
      }
      this.randomisationFactor_ = options.randomisationFactor || 0;
    }
    BackoffStrategy.prototype.getMaxDelay = function() {
      return this.maxDelay_;
    };
    BackoffStrategy.prototype.getInitialDelay = function() {
      return this.initialDelay_;
    };
    BackoffStrategy.prototype.next = function() {
      var backoffDelay = this.next_();
      var randomisationMultiple = 1 + Math.random() * this.randomisationFactor_;
      var randomizedDelay = Math.round(backoffDelay * randomisationMultiple);
      return randomizedDelay;
    };
    BackoffStrategy.prototype.next_ = function() {
      throw new Error("BackoffStrategy.next_() unimplemented.");
    };
    BackoffStrategy.prototype.reset = function() {
      this.reset_();
    };
    BackoffStrategy.prototype.reset_ = function() {
      throw new Error("BackoffStrategy.reset_() unimplemented.");
    };
    module2.exports = BackoffStrategy;
  }
});

// node_modules/backoff/lib/strategy/exponential.js
var require_exponential = __commonJS({
  "node_modules/backoff/lib/strategy/exponential.js"(exports2, module2) {
    var util = require("util");
    var precond = require_precond();
    var BackoffStrategy = require_strategy();
    function ExponentialBackoffStrategy(options) {
      BackoffStrategy.call(this, options);
      this.backoffDelay_ = 0;
      this.nextBackoffDelay_ = this.getInitialDelay();
      this.factor_ = ExponentialBackoffStrategy.DEFAULT_FACTOR;
      if (options && options.factor !== void 0) {
        precond.checkArgument(
          options.factor > 1,
          "Exponential factor should be greater than 1 but got %s.",
          options.factor
        );
        this.factor_ = options.factor;
      }
    }
    util.inherits(ExponentialBackoffStrategy, BackoffStrategy);
    ExponentialBackoffStrategy.DEFAULT_FACTOR = 2;
    ExponentialBackoffStrategy.prototype.next_ = function() {
      this.backoffDelay_ = Math.min(this.nextBackoffDelay_, this.getMaxDelay());
      this.nextBackoffDelay_ = this.backoffDelay_ * this.factor_;
      return this.backoffDelay_;
    };
    ExponentialBackoffStrategy.prototype.reset_ = function() {
      this.backoffDelay_ = 0;
      this.nextBackoffDelay_ = this.getInitialDelay();
    };
    module2.exports = ExponentialBackoffStrategy;
  }
});

// node_modules/backoff/lib/strategy/fibonacci.js
var require_fibonacci = __commonJS({
  "node_modules/backoff/lib/strategy/fibonacci.js"(exports2, module2) {
    var util = require("util");
    var BackoffStrategy = require_strategy();
    function FibonacciBackoffStrategy(options) {
      BackoffStrategy.call(this, options);
      this.backoffDelay_ = 0;
      this.nextBackoffDelay_ = this.getInitialDelay();
    }
    util.inherits(FibonacciBackoffStrategy, BackoffStrategy);
    FibonacciBackoffStrategy.prototype.next_ = function() {
      var backoffDelay = Math.min(this.nextBackoffDelay_, this.getMaxDelay());
      this.nextBackoffDelay_ += this.backoffDelay_;
      this.backoffDelay_ = backoffDelay;
      return backoffDelay;
    };
    FibonacciBackoffStrategy.prototype.reset_ = function() {
      this.nextBackoffDelay_ = this.getInitialDelay();
      this.backoffDelay_ = 0;
    };
    module2.exports = FibonacciBackoffStrategy;
  }
});

// node_modules/backoff/lib/function_call.js
var require_function_call = __commonJS({
  "node_modules/backoff/lib/function_call.js"(exports2, module2) {
    var events = require("events");
    var precond = require_precond();
    var util = require("util");
    var Backoff = require_backoff();
    var FibonacciBackoffStrategy = require_fibonacci();
    function FunctionCall(fn, args, callback) {
      events.EventEmitter.call(this);
      precond.checkIsFunction(fn, "Expected fn to be a function.");
      precond.checkIsArray(args, "Expected args to be an array.");
      precond.checkIsFunction(callback, "Expected callback to be a function.");
      this.function_ = fn;
      this.arguments_ = args;
      this.callback_ = callback;
      this.lastResult_ = [];
      this.numRetries_ = 0;
      this.backoff_ = null;
      this.strategy_ = null;
      this.failAfter_ = -1;
      this.retryPredicate_ = FunctionCall.DEFAULT_RETRY_PREDICATE_;
      this.state_ = FunctionCall.State_.PENDING;
    }
    util.inherits(FunctionCall, events.EventEmitter);
    FunctionCall.State_ = {
      // Call isn't started yet.
      PENDING: 0,
      // Call is in progress.
      RUNNING: 1,
      // Call completed successfully which means that either the wrapped function
      // returned successfully or the maximal number of backoffs was reached.
      COMPLETED: 2,
      // The call was aborted.
      ABORTED: 3
    };
    FunctionCall.DEFAULT_RETRY_PREDICATE_ = function(err) {
      return true;
    };
    FunctionCall.prototype.isPending = function() {
      return this.state_ == FunctionCall.State_.PENDING;
    };
    FunctionCall.prototype.isRunning = function() {
      return this.state_ == FunctionCall.State_.RUNNING;
    };
    FunctionCall.prototype.isCompleted = function() {
      return this.state_ == FunctionCall.State_.COMPLETED;
    };
    FunctionCall.prototype.isAborted = function() {
      return this.state_ == FunctionCall.State_.ABORTED;
    };
    FunctionCall.prototype.setStrategy = function(strategy) {
      precond.checkState(this.isPending(), "FunctionCall in progress.");
      this.strategy_ = strategy;
      return this;
    };
    FunctionCall.prototype.retryIf = function(retryPredicate) {
      precond.checkState(this.isPending(), "FunctionCall in progress.");
      this.retryPredicate_ = retryPredicate;
      return this;
    };
    FunctionCall.prototype.getLastResult = function() {
      return this.lastResult_.concat();
    };
    FunctionCall.prototype.getNumRetries = function() {
      return this.numRetries_;
    };
    FunctionCall.prototype.failAfter = function(maxNumberOfRetry) {
      precond.checkState(this.isPending(), "FunctionCall in progress.");
      this.failAfter_ = maxNumberOfRetry;
      return this;
    };
    FunctionCall.prototype.abort = function() {
      if (this.isCompleted() || this.isAborted()) {
        return;
      }
      if (this.isRunning()) {
        this.backoff_.reset();
      }
      this.state_ = FunctionCall.State_.ABORTED;
      this.lastResult_ = [new Error("Backoff aborted.")];
      this.emit("abort");
      this.doCallback_();
    };
    FunctionCall.prototype.start = function(backoffFactory) {
      precond.checkState(!this.isAborted(), "FunctionCall is aborted.");
      precond.checkState(this.isPending(), "FunctionCall already started.");
      var strategy = this.strategy_ || new FibonacciBackoffStrategy();
      this.backoff_ = backoffFactory ? backoffFactory(strategy) : new Backoff(strategy);
      this.backoff_.on("ready", this.doCall_.bind(
        this,
        true
        /* isRetry */
      ));
      this.backoff_.on("fail", this.doCallback_.bind(this));
      this.backoff_.on("backoff", this.handleBackoff_.bind(this));
      if (this.failAfter_ > 0) {
        this.backoff_.failAfter(this.failAfter_);
      }
      this.state_ = FunctionCall.State_.RUNNING;
      this.doCall_(
        false
        /* isRetry */
      );
    };
    FunctionCall.prototype.doCall_ = function(isRetry) {
      if (isRetry) {
        this.numRetries_++;
      }
      var eventArgs = ["call"].concat(this.arguments_);
      events.EventEmitter.prototype.emit.apply(this, eventArgs);
      var callback = this.handleFunctionCallback_.bind(this);
      this.function_.apply(null, this.arguments_.concat(callback));
    };
    FunctionCall.prototype.doCallback_ = function() {
      this.callback_.apply(null, this.lastResult_);
    };
    FunctionCall.prototype.handleFunctionCallback_ = function() {
      if (this.isAborted()) {
        return;
      }
      var args = Array.prototype.slice.call(arguments);
      this.lastResult_ = args;
      events.EventEmitter.prototype.emit.apply(this, ["callback"].concat(args));
      var err = args[0];
      if (err && this.retryPredicate_(err)) {
        this.backoff_.backoff(err);
      } else {
        this.state_ = FunctionCall.State_.COMPLETED;
        this.doCallback_();
      }
    };
    FunctionCall.prototype.handleBackoff_ = function(number, delay, err) {
      this.emit("backoff", number, delay, err);
    };
    module2.exports = FunctionCall;
  }
});

// node_modules/backoff/index.js
var require_backoff2 = __commonJS({
  "node_modules/backoff/index.js"(exports2, module2) {
    var Backoff = require_backoff();
    var ExponentialBackoffStrategy = require_exponential();
    var FibonacciBackoffStrategy = require_fibonacci();
    var FunctionCall = require_function_call();
    module2.exports.Backoff = Backoff;
    module2.exports.FunctionCall = FunctionCall;
    module2.exports.FibonacciStrategy = FibonacciBackoffStrategy;
    module2.exports.ExponentialStrategy = ExponentialBackoffStrategy;
    module2.exports.fibonacci = function(options) {
      return new Backoff(new FibonacciBackoffStrategy(options));
    };
    module2.exports.exponential = function(options) {
      return new Backoff(new ExponentialBackoffStrategy(options));
    };
    module2.exports.call = function(fn, vargs, callback) {
      var args = Array.prototype.slice.call(arguments);
      fn = args[0];
      vargs = args.slice(1, args.length - 1);
      callback = args[args.length - 1];
      return new FunctionCall(fn, vargs, callback);
    };
  }
});

// node_modules/node-opcua-secure-channel/dist/source/client/client_secure_channel_layer.js
var require_client_secure_channel_layer = __commonJS({
  "node_modules/node-opcua-secure-channel/dist/source/client/client_secure_channel_layer.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ClientSecureChannelLayer = exports2.coerceConnectionStrategy = exports2.requestHandleNotSetValue = void 0;
    var crypto_1 = require("crypto");
    var events_1 = require("events");
    var util_1 = require("util");
    var chalk_1 = __importDefault3(require_source());
    var async_1 = __importDefault3(require_async());
    var node_opcua_crypto_1 = require_dist33();
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_binary_stream_1 = require_dist18();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_chunkmanager_1 = require_dist58();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_service_secure_channel_1 = require_dist38();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_transport_1 = require_source5();
    var node_opcua_transport_2 = require_source5();
    var message_builder_1 = require_message_builder();
    var message_chunker_1 = require_message_chunker();
    var message_header_to_string_1 = require_message_header_to_string();
    var security_policy_1 = require_security_policy();
    var services_1 = require_services();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var checkChunks = doDebug && false;
    var doDebug1 = false;
    var checkTimeout = !!process.env.NODEOPCUACHECKTIMEOUT || false;
    var common_1 = require_common2();
    var utils_1 = require_utils7();
    var duration_to_string_1 = require_duration_to_string();
    var backoff = require_backoff2();
    exports2.requestHandleNotSetValue = 3735928559;
    function process_request_callback(requestData, err, response) {
      (0, node_opcua_assert_1.assert)(typeof requestData.callback === "function");
      const request = requestData.request;
      if (!response && !err && requestData.msgType !== "CLO") {
        err = new Error(" Connection has been closed by client , but this transaction cannot be honored");
      }
      if (response && response instanceof services_1.ServiceFault) {
        response.responseHeader.stringTable = [...response.responseHeader.stringTable || []];
        err = new Error(" serviceResult = " + response.responseHeader.serviceResult.toString());
        err.response = response;
        err.request = request;
        response = void 0;
      }
      const theCallbackFunction = requestData.callback;
      if (!theCallbackFunction) {
        throw new Error("Internal error");
      }
      (0, node_opcua_assert_1.assert)(requestData.msgType === "CLO" || err && !response || !err && response);
      requestData.callback = void 0;
      theCallbackFunction(err || null, !err && response !== null ? response : void 0);
    }
    function coerceConnectionStrategy(options) {
      options = options || {};
      const maxRetry = options.maxRetry === void 0 ? 10 : options.maxRetry;
      const initialDelay = options.initialDelay || 10;
      const maxDelay = options.maxDelay || 1e4;
      const randomisationFactor = options.randomisationFactor === void 0 ? 0 : options.randomisationFactor;
      return {
        initialDelay,
        maxDelay,
        maxRetry,
        randomisationFactor
      };
    }
    exports2.coerceConnectionStrategy = coerceConnectionStrategy;
    var ClientSecureChannelLayer = class _ClientSecureChannelLayer extends events_1.EventEmitter {
      /**
       * true if the secure channel is trying to establish the connection with the server. In this case, the client
       * may be in the middle of the backoff connection process.
       *
       */
      get isConnecting() {
        return !!this.__call;
      }
      get bytesRead() {
        return this._bytesRead + (this._transport ? this._transport.bytesRead : 0);
      }
      get bytesWritten() {
        return this._bytesWritten + (this._transport ? this._transport.bytesWritten : 0);
      }
      get transactionsPerformed() {
        return this._lastRequestId;
      }
      get timedOutRequestCount() {
        return this._timeout_request_count;
      }
      constructor(options) {
        super();
        this._counter = _ClientSecureChannelLayer.g_counter++;
        this._bytesRead = 0;
        this._bytesWritten = 0;
        this._timeDrift = 0;
        this._tick2 = 0;
        this._isDisconnecting = false;
        this.securityHeader = null;
        this.receiverCertificate = null;
        this.securityToken = null;
        this.serverNonce = null;
        this.derivedKeys = null;
        this.receiverPublicKey = null;
        this.endpointUrl = "";
        if (global.hasResourceLeakDetector && !global.ResourceLeakDetectorStarted) {
          throw new Error("ClientSecureChannelLayer not in ResourceLeakDetectorStarted");
        }
        (0, node_opcua_assert_1.assert)(this instanceof _ClientSecureChannelLayer);
        this._isOpened = false;
        this._transport = void 0;
        this._lastRequestId = 0;
        this.parent = options.parent;
        this.clientNonce = null;
        this.protocolVersion = 0;
        this.messageChunker = new message_chunker_1.MessageChunker({
          derivedKeys: null
          // note maxMessageSize cannot be set at this stage, transport is not known
        });
        this.defaultSecureTokenLifetime = options.defaultSecureTokenLifetime || 3e4;
        this.tokenRenewalInterval = options.tokenRenewalInterval || 0;
        this.securityMode = (0, node_opcua_service_secure_channel_1.coerceMessageSecurityMode)(options.securityMode);
        this.securityPolicy = (0, security_policy_1.coerceSecurityPolicy)(options.securityPolicy);
        this.serverCertificate = (0, common_1.extractFirstCertificateInChain)(options.serverCertificate);
        if (this.securityMode !== node_opcua_service_secure_channel_1.MessageSecurityMode.None) {
          (0, node_opcua_assert_1.assert)(this.serverCertificate instanceof Buffer, "Expecting a valid certificate when security mode is not None");
          (0, node_opcua_assert_1.assert)(this.securityPolicy !== security_policy_1.SecurityPolicy.None, "Security Policy None is not a valid choice");
        }
        this._requests = {};
        this.__in_normal_close_operation = false;
        this._timeout_request_count = 0;
        this._securityTokenTimeoutId = null;
        this.transportTimeout = options.transportTimeout || _ClientSecureChannelLayer.defaultTransportTimeout;
        this.requestedTransportSettings = options.transportSettings || {};
        this.channelId = 0;
        this.connectionStrategy = coerceConnectionStrategy(options.connectionStrategy);
      }
      getTransportSettings() {
        const { maxMessageSize } = this._transport ? this._transport.getTransportSettings() : { maxMessageSize: 2048 };
        return { maxMessageSize: maxMessageSize || 0 };
      }
      _install_message_builder() {
        if (!this._transport || !this._transport.parameters) {
          throw new Error("internal error");
        }
        this.messageBuilder = new message_builder_1.MessageBuilder({
          name: "client",
          privateKey: this.getPrivateKey() || void 0,
          securityMode: this.securityMode,
          maxChunkSize: this._transport.receiveBufferSize || 0,
          maxChunkCount: this._transport.maxChunkCount || 0,
          maxMessageSize: this._transport.maxMessageSize || 0
        });
        if (node_opcua_transport_2.doTraceChunk) {
          console.log(chalk_1.default.cyan((0, node_opcua_utils_1.timestamp)()), "   MESSAGE BUILDER LIMITS", "maxMessageSize = ", this.messageBuilder.maxMessageSize, "maxChunkCount = ", this.messageBuilder.maxChunkCount, "maxChunkSize = ", this.messageBuilder.maxChunkSize, "(", this.messageBuilder.maxChunkSize * this.messageBuilder.maxChunkCount, ")");
        }
        this.messageBuilder.on("message", (response, msgType, requestId, channelId) => {
          this._on_message_received(response, msgType, requestId);
        }).on("startChunk", () => {
          if (utils_1.doPerfMonitoring) {
            this._tick2 = (0, node_opcua_utils_1.get_clock_tick)();
          }
        }).on("abandon", (requestId) => {
          const requestData = this._requests[requestId];
          if (doDebug) {
            debugLog("request id = ", requestId, "message was ", requestData);
          }
          const err = new services_1.ServiceFault({
            responseHeader: {
              requestHandle: requestId,
              serviceResult: node_opcua_status_code_1.StatusCodes.BadOperationAbandoned
            }
          });
          const callback = requestData.callback;
          delete this._requests[requestId];
          callback && callback(null, err);
        }).on("error", (err, statusCode, requestId) => {
          if (!requestId) {
            return;
          }
          const requestData = this._requests[requestId];
          doDebug && debugLog("request id = ", requestId, err, "message was ", requestData);
          if (utils_1.doTraceClientRequestContent) {
            errorLog(" message was 2:", requestData?.request?.toString() || "<null>");
          }
          if (!requestData) {
            warningLog("requestData not found for requestId = ", requestId);
            warningLog("err = ", err);
            return;
          }
          const callback = requestData.callback;
          delete this._requests[requestId];
          callback && callback(err, void 0);
          this._closeWithError(err, statusCode);
          return;
        });
      }
      getPrivateKey() {
        return this.parent ? this.parent.getPrivateKey() : null;
      }
      getCertificateChain() {
        return this.parent ? this.parent.getCertificateChain() : null;
      }
      getCertificate() {
        return this.parent ? this.parent.getCertificate() : null;
      }
      toString() {
        let str = "";
        str += "\n securityMode ............. : " + node_opcua_service_secure_channel_1.MessageSecurityMode[this.securityMode];
        str += "\n securityPolicy............ : " + this.securityPolicy;
        str += "\n securityToken ............ : " + (this.securityToken ? this.securityToken.toString() : "null");
        str += "\n serverNonce  ............. : " + (this.serverNonce ? this.serverNonce.toString("hex") : "null");
        str += "\n clientNonce  ............. : " + (this.clientNonce ? this.clientNonce.toString("hex") : "null");
        str += "\n timedOutRequestCount.....  : " + this.timedOutRequestCount;
        str += "\n transportTimeout ......... : " + this.transportTimeout;
        str += "\n is transaction in progress : " + this.isTransactionInProgress();
        str += "\n is connecting ............ : " + this.isConnecting;
        str += "\n is disconnecting ......... : " + this._isDisconnecting;
        str += "\n is opened ................ : " + this.isOpened();
        str += "\n is valid ................. : " + this.isValid();
        str += "\n channelId ................ : " + this.channelId;
        str += "\n transportParameters: ..... : ";
        str += "\n   maxMessageSize (to send) : " + (this._transport?.parameters?.maxMessageSize || "<not set>");
        str += "\n   maxChunkCount  (to send) : " + (this._transport?.parameters?.maxChunkCount || "<not set>");
        str += "\n   receiveBufferSize(server): " + (this._transport?.parameters?.receiveBufferSize || "<not set>");
        str += "\n   sendBufferSize (to send) : " + (this._transport?.parameters?.sendBufferSize || "<not set>");
        str += "\ntime drift with server      : " + (0, duration_to_string_1.durationToString)(this._timeDrift);
        str += "\n";
        return str;
      }
      isTransactionInProgress() {
        return Object.keys(this._requests).length > 0;
      }
      getClientNonce() {
        return this.clientNonce;
      }
      /**
       * establish a secure channel with the provided server end point.
       *
       * @method create
       * @async
       * @param endpointUrl
       * @param callback the async callback function
       *
       *
       * @example
       *
       *    ```javascript
       *
       *    const secureChannel  = new ClientSecureChannelLayer({});
       *
       *    secureChannel.on("end", function(err) {
       *         console.log("secure channel has ended",err);
       *         if(err) {
       *            console.log(" the connection was closed by an external cause such as server shutdown");
       *        }
       *    });
       *    secureChannel.create("opc.tcp://localhost:1234/UA/Sample", (err) => {
       *         if(err) {
       *              console.log(" cannot establish secure channel" , err);
       *         } else {
       *              console.log("secure channel has been established");
       *         }
       *    });
       *
       *    ```
       */
      create(endpointUrl, callback) {
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        if (this.securityMode !== node_opcua_service_secure_channel_1.MessageSecurityMode.None) {
          if (!this.serverCertificate) {
            return callback(new Error("ClientSecureChannelLayer#create : expecting a server certificate when securityMode is not None"));
          }
          if (!this.receiverPublicKey) {
            (0, node_opcua_crypto_1.extractPublicKeyFromCertificate)(this.serverCertificate, (err, publicKey) => {
              if (err) {
                return callback(err);
              }
              if (!publicKey) {
                throw new Error("Internal Error");
              }
              this.receiverPublicKey = (0, crypto_1.createPublicKey)(publicKey);
              this.create(endpointUrl, callback);
            });
            return;
          }
        }
        this.endpointUrl = endpointUrl;
        const transport = new node_opcua_transport_1.ClientTCP_transport(this.requestedTransportSettings);
        transport.timeout = this.transportTimeout;
        doDebug && debugLog("ClientSecureChannelLayer#create creating ClientTCP_transport with  transport.timeout = ", transport.timeout);
        (0, node_opcua_assert_1.assert)(!this._pending_transport);
        this._pending_transport = transport;
        this._establish_connection(transport, endpointUrl, (err) => {
          if (err) {
            doDebug && debugLog(chalk_1.default.red("cannot connect to server"));
            this._pending_transport = void 0;
            transport.dispose();
            return callback(err);
          }
          this._on_connection(transport, callback);
        });
      }
      _dispose_transports() {
        if (this._transport) {
          this._bytesRead += this._transport.bytesRead || 0;
          this._bytesWritten += this._transport.bytesWritten || 0;
          this._transport.dispose();
          this._transport = void 0;
        }
        if (this._pending_transport) {
          this._bytesRead += this._pending_transport.bytesRead || 0;
          this._bytesWritten += this._pending_transport.bytesWritten || 0;
          this._pending_transport.dispose();
          this._pending_transport = void 0;
        }
      }
      dispose() {
        this._dispose_transports();
        this.abortConnection(() => {
        });
        this._cancel_security_token_watchdog();
      }
      abortConnection(callback) {
        if (this._isDisconnecting) {
          doDebug && debugLog("abortConnection already aborting!");
          return callback();
        }
        this._isDisconnecting = true;
        doDebug && debugLog("abortConnection ", !!this.__call);
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        async_1.default.series([
          (inner_callback) => {
            if (this.__call) {
              this.__call.once("abort", () => inner_callback());
              this.__call._cancelBackoff = true;
              this.__call.abort();
              this.__call = null;
            } else {
              inner_callback();
            }
          },
          (inner_callback) => {
            if (!this._pending_transport) {
              return inner_callback();
            }
            this._pending_transport.disconnect(() => {
              inner_callback();
            });
          },
          (inner_callback) => {
            if (!this._transport) {
              return inner_callback();
            }
            this._transport.disconnect(() => {
              inner_callback();
            });
          }
        ], () => {
          callback();
        });
      }
      /**
       * perform a OPC-UA message transaction, asynchronously.
       * During a transaction, the client sends a request to the server. The provided callback will be invoked
       * at a later stage with the reply from the server, or the error.
       *
       * preconditions:
       *   - the channel must be opened
       *
       * @example
       *
       *    ```javascript
       *    let secure_channel ; // get a  ClientSecureChannelLayer somehow
       *
       *    const request = new BrowseRequest({...});
       *    secure_channel.performMessageTransaction(request, (err,response) => {
       *       if (err) {
       *         // an error has occurred
       *       } else {
       *          assert(response instanceof BrowseResponse);
       *         // do something with response.
       *       }
       *    });
       *    ```
       *
       */
      performMessageTransaction(request, callback) {
        this._performMessageTransaction("MSG", request, callback);
      }
      isValid() {
        if (!this._transport) {
          return false;
        }
        return this._transport.isValid();
      }
      isOpened() {
        return this.isValid() && this._isOpened;
      }
      getDisplayName() {
        if (!this.parent) {
          return "";
        }
        return (this.parent.applicationName ? this.parent.applicationName + " " : "") + this.parent.clientName;
      }
      cancelPendingTransactions(callback) {
        (0, node_opcua_assert_1.assert)(typeof callback === "function", "expecting a callback function, but got " + callback);
        if (doDebug) {
          debugLog("cancelPendingTransactions ", this.getDisplayName(), " = ", Object.keys(this._requests).map((k) => this._requests[k].request.constructor.name).join(" "));
        }
        for (const key of Object.keys(this._requests)) {
          const transaction = this._requests[key];
          if (transaction.callback) {
            transaction.callback(new Error("Transaction has been canceled because client channel  is being closed"));
          }
        }
        callback();
      }
      /**
       * Close a client SecureChannel ,by sending a CloseSecureChannelRequest to the server.
       *
       *
       * After this call, the connection is closed and no further transaction can be made.
       *
       * @method close
       * @async
       * @param callback
       */
      close(callback) {
        (0, node_opcua_assert_1.assert)(typeof callback === "function", "expecting a callback function, but got " + callback);
        this.cancelPendingTransactions(() => {
          this._cancel_security_token_watchdog();
          doDebug && debugLog("Sending CloseSecureChannelRequest to server");
          const request = new services_1.CloseSecureChannelRequest({
            requestHeader: {
              timeoutHint: 1e3
              // 1 second !
            }
          });
          this.__in_normal_close_operation = true;
          if (!this._transport || this._transport.isDisconnecting()) {
            this.dispose();
            return callback(new Error("Transport disconnected"));
          }
          this._performMessageTransaction("CLO", request, (err) => {
            if (err) {
              warningLog("CLO transaction terminated with error: ", err.message);
            }
            this.dispose();
            callback();
          });
        });
      }
      _closeWithError(err, statusCode) {
        if (this._transport) {
          this._transport.prematureTerminate(err, statusCode);
        }
        this.dispose();
      }
      on_transaction_completed(transactionStatistics) {
        if (utils_1.doTraceStatistics) {
          (0, utils_1._dump_client_transaction_statistics)(transactionStatistics);
        }
        this.emit("end_transaction", transactionStatistics);
      }
      _on_message_received(response, msgType, requestId) {
        if (response.responseHeader.requestHandle !== requestId) {
          warningLog(response.toString());
          errorLog(chalk_1.default.red.bgWhite.bold("xxxxx  <<<<<< _on_message_received  ERROR"), "requestId=", requestId, this._requests[requestId]?.constructor.name, "response.responseHeader.requestHandle=", response.responseHeader.requestHandle, response.schema.name.padStart(30));
        }
        if (utils_1.doTraceClientMessage) {
          (0, utils_1.traceClientResponseMessage)(response, this.channelId, this._counter);
        }
        const requestData = this._requests[requestId];
        if (!requestData) {
          if (this.__in_normal_close_operation) {
            return;
          }
          errorLog(chalk_1.default.cyan.bold("xxxxx  <<<<<< _on_message_received for unknown or timeout request "), requestId, response.schema.name.padStart(30), response.responseHeader.serviceResult.toString(), this.channelId);
          throw new Error(" =>  invalid requestId =" + requestId);
        }
        const request = requestData.request;
        if (utils_1.doPerfMonitoring) {
          requestData._tick2 = this._tick2;
        }
        delete this._requests[requestId];
        if (response.responseHeader.requestHandle !== request.requestHeader.requestHandle) {
          const expected = request.requestHeader.requestHandle;
          const actual = response.responseHeader.requestHandle;
          if (actual !== 0) {
            const moreInfo = "Request= " + request.schema.name + " Response = " + response.schema.name;
            const message = " WARNING SERVER responseHeader.requestHandle is invalid: expecting 0x" + expected.toString(16) + "(" + expected + ")  but got 0x" + actual.toString(16) + "(" + actual + ") ";
            debugLog(chalk_1.default.red.bold(message), chalk_1.default.yellow(moreInfo));
            warningLog(chalk_1.default.red.bold(message), chalk_1.default.yellow(moreInfo));
            warningLog(request.toString());
          }
        }
        requestData.response = response;
        if (utils_1.doPerfMonitoring) {
          requestData._tick2 = this.messageBuilder._tick1;
        }
        requestData.bytesRead = this.messageBuilder.totalMessageSize;
        if (utils_1.doPerfMonitoring) {
          requestData._tick3 = (0, node_opcua_utils_1.get_clock_tick)();
        }
        process_request_callback(requestData, null, response);
        if (utils_1.doPerfMonitoring) {
          requestData._tick4 = (0, node_opcua_utils_1.get_clock_tick)();
        }
        this._record_transaction_statistics(requestData);
        this.on_transaction_completed(this.last_transaction_stats);
      }
      _record_transaction_statistics(requestData) {
        const request = requestData.request;
        const response = requestData.response;
        this.last_transaction_stats = {
          bytesRead: requestData.bytesRead,
          bytesWritten: requestData.bytesWritten_after - requestData.bytesWritten_before,
          lap_processing_response: requestData._tick4 - requestData._tick3,
          lap_receiving_response: requestData._tick3 - requestData._tick2,
          lap_sending_request: requestData._tick1 - requestData._tick0,
          lap_transaction: requestData._tick4 - requestData._tick0,
          lap_waiting_response: requestData._tick2 - requestData._tick1,
          request,
          response
        };
        if (utils_1.doTraceStatistics) {
          (0, utils_1._dump_client_transaction_statistics)(this.last_transaction_stats);
        }
      }
      _cancel_pending_transactions(err) {
        if (doDebug && this._requests) {
          debugLog("_cancel_pending_transactions  ", Object.keys(this._requests), this._transport ? this._transport.name : "no transport");
        }
        if (this._requests) {
          for (const requestData of Object.values(this._requests)) {
            if (requestData) {
              const request = requestData.request;
              doDebug && debugLog("Cancelling pending transaction ", requestData.key, requestData.msgType, request?.schema.name);
              process_request_callback(requestData, err);
            }
          }
        }
        this._requests = {};
      }
      _on_transport_closed(err) {
        doDebug && debugLog(" =>ClientSecureChannelLayer#_on_transport_closed  err=", err ? err.message : "null");
        if (this.__in_normal_close_operation) {
          err = void 0;
        }
        this.emit("close", err);
        this._dispose_transports();
        this._cancel_pending_transactions(err);
        this._cancel_security_token_watchdog();
        this.dispose();
      }
      _on_security_token_about_to_expire() {
        if (!this.securityToken) {
          return;
        }
        doDebug && debugLog(" client: Security Token ", this.securityToken.tokenId, " is about to expired, let's raise lifetime_75 event ");
        this.emit("lifetime_75", this.securityToken);
        this._renew_security_token();
      }
      _cancel_security_token_watchdog() {
        if (this._securityTokenTimeoutId) {
          clearTimeout(this._securityTokenTimeoutId);
          this._securityTokenTimeoutId = null;
        }
      }
      _install_security_token_watchdog() {
        if (!this.securityToken) {
          errorLog("Failed to install security token watch dog before securityToken is null!");
          return;
        }
        const lifeTime = this.securityToken.revisedLifetime;
        (0, node_opcua_assert_1.assert)(lifeTime !== 0 && lifeTime > 20);
        const percent = 75 / 100;
        let timeout = this.tokenRenewalInterval || lifeTime * percent;
        timeout = Math.min(timeout, lifeTime * 75 / 100);
        timeout = Math.max(timeout, 50);
        if (doDebug) {
          debugLog(chalk_1.default.red.bold(" time until next security token renewal = "), timeout, "( lifetime = ", lifeTime + " -  tokenRenewalInterval =" + this.tokenRenewalInterval);
        }
        (0, node_opcua_assert_1.assert)(this._securityTokenTimeoutId === null);
        this._securityTokenTimeoutId = setTimeout(() => {
          this._securityTokenTimeoutId = null;
          this._on_security_token_about_to_expire();
        }, timeout);
      }
      _build_client_nonce() {
        if (this.securityMode === node_opcua_service_secure_channel_1.MessageSecurityMode.None) {
          return null;
        }
        const cryptoFactory = (0, security_policy_1.getCryptoFactory)(this.securityPolicy);
        if (!cryptoFactory) {
          return null;
        }
        (0, node_opcua_assert_1.assert)(cryptoFactory !== null && typeof cryptoFactory === "object");
        return (0, crypto_1.randomBytes)(cryptoFactory.symmetricKeyLength);
      }
      _open_secure_channel_request(isInitial, callback) {
        (0, node_opcua_assert_1.assert)(this.securityMode !== node_opcua_service_secure_channel_1.MessageSecurityMode.Invalid, "invalid security mode");
        const msgType = "OPN";
        const requestType = isInitial ? services_1.SecurityTokenRequestType.Issue : services_1.SecurityTokenRequestType.Renew;
        this.clientNonce = this._build_client_nonce();
        this._isOpened = !isInitial;
        const msg = new services_1.OpenSecureChannelRequest({
          clientNonce: this.clientNonce,
          //
          clientProtocolVersion: this.protocolVersion,
          requestHeader: {
            auditEntryId: null
          },
          requestType,
          requestedLifetime: this.defaultSecureTokenLifetime,
          securityMode: this.securityMode
        });
        const startDate = /* @__PURE__ */ new Date();
        this._performMessageTransaction(msgType, msg, (err, response) => {
          if (response && response.responseHeader && response.responseHeader.serviceResult !== node_opcua_status_code_1.StatusCodes.Good) {
            warningLog("OpenSecureChannelRequest Error: response.responseHeader.serviceResult ", response.constructor.name, response.responseHeader.serviceResult.toString());
            err = new Error(response.responseHeader.serviceResult.toString());
          }
          if (!err && response) {
            const openSecureChannelResponse = response;
            this.channelId = openSecureChannelResponse.securityToken.channelId;
            (0, node_opcua_assert_1.assert)(openSecureChannelResponse.securityToken.tokenId > 0 || msgType === "OPN", "_sendSecureOpcUARequest: invalid token Id ");
            (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(openSecureChannelResponse, "serverNonce"));
            this.securityToken = openSecureChannelResponse.securityToken;
            const endDate = /* @__PURE__ */ new Date();
            const midDate = new Date((startDate.getTime() + endDate.getTime()) / 2);
            if (this.securityToken.createdAt) {
              const delta = this.securityToken.createdAt.getTime() - midDate.getTime();
              this._timeDrift = delta;
              if (Math.abs(delta) > 1e3 * 5) {
                warningLog(`[NODE-OPCUA-W33]  client : server token creation date exposes a time discrepancy ${(0, duration_to_string_1.durationToString)(delta)}
remote server clock doesn't match this computer date !
 please check both server and client clocks are properly set !
 server time :${chalk_1.default.cyan(this.securityToken.createdAt?.toISOString())}
 client time :${chalk_1.default.cyan(midDate.toISOString())}
 transaction duration = ${(0, duration_to_string_1.durationToString)(endDate.getTime() - startDate.getTime())}
 server URL = ${this.endpointUrl} 
 token.createdAt  has been updated to reflect client time`);
              }
            }
            this.securityToken.createdAt = midDate;
            this.serverNonce = openSecureChannelResponse.serverNonce;
            if (this.securityMode !== node_opcua_service_secure_channel_1.MessageSecurityMode.None) {
              if (!openSecureChannelResponse.serverNonce) {
                warningLog(" client : server nonce is missing !");
                return callback(new Error(" Invalid server nonce"));
              }
              if (openSecureChannelResponse.serverNonce.length !== this.clientNonce.length) {
                warningLog(" client : server nonce is invalid  (invalid length)!");
                return callback(new Error(" Invalid server nonce length"));
              }
            }
            const cryptoFactory = this.messageBuilder.cryptoFactory;
            if (cryptoFactory) {
              (0, node_opcua_assert_1.assert)(this.serverNonce instanceof Buffer);
              if (!this.serverNonce) {
                throw new Error("internal error");
              }
              this.derivedKeys = (0, security_policy_1.computeDerivedKeys)(cryptoFactory, this.serverNonce, this.clientNonce);
            }
            const derivedServerKeys = this.derivedKeys ? this.derivedKeys.derivedServerKeys : null;
            if (doDebug) {
              debugLog("Server has send a new security Token");
            }
            this.messageBuilder.pushNewToken(this.securityToken, derivedServerKeys);
            this._install_security_token_watchdog();
            this._isOpened = true;
          }
          callback(err || void 0);
        });
      }
      _on_connection(transport, callback) {
        (0, node_opcua_assert_1.assert)(this._pending_transport === transport);
        this._pending_transport = void 0;
        this._transport = transport;
        this.messageChunker.maxMessageSize = this._transport?.maxMessageSize || 0;
        this.messageChunker.maxChunkCount = this._transport?.maxChunkCount || 0;
        this._install_message_builder();
        this._transport.on("chunk", (messageChunk) => {
          this.emit("receive_chunk", messageChunk);
          this._on_receive_message_chunk(messageChunk);
        });
        this._transport.on("close", (err) => this._on_transport_closed(err));
        this._transport.on("connection_break", () => {
          doDebug && debugLog(chalk_1.default.red("Client => CONNECTION BREAK  <="));
          this._on_transport_closed(new Error("Connection Break"));
        });
        setImmediate(() => {
          doDebug && debugLog(chalk_1.default.red("Client now sending OpenSecureChannel"));
          const isInitial = true;
          this._open_secure_channel_request(isInitial, callback);
        });
      }
      _backoff_completion(err, lastError, transport, callback) {
        const fixError = (err2) => {
          if (!err2)
            return err2;
          if (err2.errors) {
            const _err = err2;
            err2.message = _err.errors.map((e) => e.message).join("\n");
          }
          return err2;
        };
        if (this.__call) {
          transport.numberOfRetry = transport.numberOfRetry || 0;
          transport.numberOfRetry += this.__call.getNumRetries();
          this.__call.removeAllListeners();
          this.__call = null;
          if (err) {
            const err_ = fixError(lastError || err);
            callback(err_);
          } else {
            callback();
          }
        }
      }
      _connect(transport, endpointUrl, _i_callback) {
        const on_connect = (err) => {
          doDebug && debugLog("Connection => err", err ? err.message : "null");
          if (err) {
            let should_abort = this._isDisconnecting;
            if (err.message.match(/ECONNRESET/)) {
              should_abort = true;
            }
            if (err.message.match(/BadProtocolVersionUnsupported/)) {
              should_abort = true;
            }
            if (err.message.match(/BadTcpInternalError/)) {
              should_abort = true;
            }
            if (err.message.match(/BadTcpMessageTooLarge/)) {
              should_abort = true;
            }
            if (err.message.match(/BadTcpEndpointUriInvalid/)) {
              should_abort = true;
            }
            if (err.message.match(/BadTcpMessageTypeInvalid/)) {
              should_abort = true;
            }
            this.lastError = err;
            if (this.__call) {
              if (should_abort) {
                doDebug && debugLog(" Aborting backoff process prematurely - err = ", err.message);
                this.__call.abort();
              } else {
                doDebug && debugLog(" backoff - keep trying - err = ", err.message);
              }
            }
          }
          _i_callback(err);
        };
        transport.connect(endpointUrl, on_connect);
      }
      _establish_connection(transport, endpointUrl, callback) {
        transport.protocolVersion = this.protocolVersion;
        this.lastError = void 0;
        if (this.connectionStrategy.maxRetry === 0) {
          doDebug && debugLog(chalk_1.default.cyan("max Retry === 0 =>  No backoff required -> call the _connect function directly"));
          this.__call = 0;
          return this._connect(transport, endpointUrl, callback);
        }
        const connectFunc = (callback2) => {
          return this._connect(transport, endpointUrl, callback2);
        };
        const completionFunc = (err) => {
          return this._backoff_completion(err, this.lastError, transport, callback);
        };
        this.__call = backoff.call(connectFunc, completionFunc);
        if (this.connectionStrategy.maxRetry >= 0) {
          const maxRetry = Math.max(this.connectionStrategy.maxRetry, 1);
          doDebug && debugLog(chalk_1.default.cyan("backoff will failed after "), maxRetry);
          this.__call.failAfter(maxRetry);
        } else {
          doDebug && debugLog(chalk_1.default.cyan("backoff => starting a infinite retry"));
        }
        const onBackoffFunc = (retryCount, delay) => {
          doDebug && debugLog(chalk_1.default.bgWhite.cyan(" Backoff #"), retryCount, "delay = ", delay, " ms", " maxRetry ", this.connectionStrategy.maxRetry);
          this.emit("backoff", retryCount, delay);
        };
        this.__call.on("backoff", onBackoffFunc);
        this.__call.on("abort", () => {
          doDebug && debugLog(chalk_1.default.bgWhite.cyan(` abort #   after ${this.__call.getNumRetries()} retries.`));
          this.emit("abort");
          setImmediate(() => {
            this._backoff_completion(void 0, new Error("Connection abandoned"), transport, callback);
          });
        });
        this.__call.setStrategy(new backoff.ExponentialStrategy(this.connectionStrategy));
        this.__call.start();
      }
      _renew_security_token() {
        doDebug && debugLog("ClientSecureChannelLayer#_renew_security_token");
        if (!this.isValid()) {
          warningLog("Invalid socket => Communication has been lost, cannot renew token");
          return;
        }
        const isInitial = false;
        this._open_secure_channel_request(isInitial, (err) => {
          if (!err) {
            doDebug && debugLog(" token renewed");
            this.emit("security_token_renewed");
          } else {
            errorLog("ClientSecureChannelLayer: Warning: securityToken hasn't been renewed -> err ", err.message);
          }
        });
      }
      _on_receive_message_chunk(messageChunk) {
        if (doDebug1) {
          const _stream = new node_opcua_binary_stream_1.BinaryStream(messageChunk);
          const messageHeader = (0, node_opcua_chunkmanager_1.readMessageHeader)(_stream);
          debugLog("CLIENT RECEIVED " + chalk_1.default.yellow(JSON.stringify(messageHeader) + ""));
          debugLog("\n" + (0, node_opcua_debug_1.hexDump)(messageChunk));
          debugLog((0, message_header_to_string_1.messageHeaderToString)(messageChunk));
        }
        this.messageBuilder.feed(messageChunk);
      }
      /**
       * @method makeRequestId
       * @return  newly generated request id
       * @private
       */
      makeRequestId() {
        this._lastRequestId += 1;
        return this._lastRequestId;
      }
      /**
       * internal version of _performMessageTransaction.
       *
       * @method _performMessageTransaction
       * @private
       *
       * - this method takes a extra parameter : msgType
       * TODO:
       * - this method can be re-entrant, meaning that a new transaction can be started before any pending transaction
       *   is fully completed.
       * - Any error on transport will cause all pending transactions to be cancelled
       *
       * - the method returns a timeout Error if the server fails to return a response within the timeoutHint interval.
       *
       *
       */
      _performMessageTransaction(msgType, request, callback) {
        if (!this.isValid()) {
          return callback(new Error("ClientSecureChannelLayer => Socket is closed ! while processing " + request.constructor.name));
        }
        let localCallback = callback;
        let timeout = request.requestHeader.timeoutHint || _ClientSecureChannelLayer.defaultTransactionTimeout;
        timeout = Math.max(_ClientSecureChannelLayer.minTransactionTimeout, timeout);
        request.requestHeader.timeoutHint = timeout;
        if (doDebug) {
          debugLog("Adjusted timeout = ", request.requestHeader.timeoutHint);
        }
        let timerId = null;
        let hasTimedOut = false;
        const modified_callback = (err, response) => {
          if (doDebug) {
            debugLog(chalk_1.default.cyan("------------------------------------- Client receiving response "), request.constructor.name, request.requestHeader.requestHandle, response ? response.constructor.name : "null", "err=", err ? err.message : "null", "securityTokenId=", this.securityToken ? this.securityToken.tokenId : "x");
          }
          if (response && utils_1.doTraceClientResponseContent) {
            (0, utils_1.traceClientResponseContent)(response, this.channelId);
          }
          if (!localCallback) {
            return;
          }
          if (!hasTimedOut && timerId) {
            clearTimeout(timerId);
          }
          timerId = null;
          if (!err && response) {
            this.emit("receive_response", response);
          }
          (0, node_opcua_assert_1.assert)(!err || util_1.types.isNativeError(err));
          delete this._requests[request.requestHeader.requestHandle];
          try {
            localCallback.call(this, err || null, response);
          } catch (err1) {
            errorLog("ERROR !!! callback has thrown en error ", err1);
            callback(err || null);
          } finally {
            localCallback = null;
          }
        };
        const optionalTrace = !checkTimeout || new Error().stack;
        timerId = setTimeout(() => {
          timerId = null;
          hasTimedOut = true;
          if (checkTimeout) {
            warningLog(" Timeout .... waiting for response for ", request.constructor.name, request.requestHeader.toString());
            warningLog(" Timeout was ", timeout, "ms");
            warningLog(request.toString());
            warningLog(optionalTrace);
          }
          modified_callback(new Error("Transaction has timed out ( timeout = " + timeout + " ms , request = " + request.constructor.name + ")"));
          this._timeout_request_count += 1;
          this.emit("timed_out_request", request);
        }, timeout);
        const transaction_data = {
          callback: modified_callback,
          msgType,
          request,
          timerId
        };
        this._internal_perform_transaction(transaction_data);
      }
      /**
       *
       * @param transactionData
       * @param transactionData.msgType
       * @param transactionData.request
       * @param transactionData.callback
       * @private
       */
      _internal_perform_transaction(transactionData) {
        (0, node_opcua_assert_1.assert)(typeof transactionData.callback === "function");
        if (!this._transport) {
          setTimeout(() => {
            transactionData.callback(new Error("Client not connected"));
          }, 100);
          return;
        }
        (0, node_opcua_assert_1.assert)(this._transport, " must have a valid transport");
        const msgType = transactionData.msgType;
        const request = transactionData.request;
        (0, node_opcua_assert_1.assert)(msgType.length === 3);
        const requestHandle = this.makeRequestId();
        if (request.requestHeader.requestHandle !== exports2.requestHandleNotSetValue) {
          errorLog(chalk_1.default.bgRed.white("xxxxx   >>>>>> request has already been set with a requestHandle"), requestHandle, request.requestHeader.requestHandle, request.constructor.name);
          errorLog(Object.keys(this._requests).join(" "));
          errorLog(new Error("Investigate me"));
        }
        request.requestHeader.requestHandle = requestHandle;
        if (utils_1.doTraceClientMessage) {
          (0, utils_1.traceClientRequestMessage)(request, this.channelId, this._counter);
        }
        const requestData = {
          callback: transactionData.callback,
          msgType,
          request,
          bytesRead: 0,
          bytesWritten_after: 0,
          bytesWritten_before: this.bytesWritten,
          _tick0: 0,
          _tick1: 0,
          _tick2: 0,
          _tick3: 0,
          _tick4: 0,
          key: "",
          chunk_count: 0
        };
        this._requests[requestHandle] = requestData;
        if (utils_1.doPerfMonitoring) {
          const stats = requestData;
          stats._tick0 = (0, node_opcua_utils_1.get_clock_tick)();
        }
        this._sendSecureOpcUARequest(msgType, request, requestHandle);
      }
      _send_chunk(requestId, chunk) {
        const requestData = this._requests[requestId];
        if (chunk) {
          this.emit("send_chunk", chunk);
          if (checkChunks) {
            (0, node_opcua_chunkmanager_1.verify_message_chunk)(chunk);
            debugLog(chalk_1.default.yellow("CLIENT SEND chunk "));
            debugLog(chalk_1.default.yellow((0, message_header_to_string_1.messageHeaderToString)(chunk)));
            debugLog(chalk_1.default.red((0, node_opcua_debug_1.hexDump)(chunk)));
          }
          (0, node_opcua_assert_1.assert)(this._transport);
          this._transport?.write(chunk);
          requestData.chunk_count += 1;
        } else {
          if (checkChunks) {
            debugLog(chalk_1.default.yellow("CLIENT SEND done."));
          }
          if (requestData) {
            if (utils_1.doPerfMonitoring) {
              requestData._tick1 = (0, node_opcua_utils_1.get_clock_tick)();
            }
            requestData.bytesWritten_after = this.bytesWritten;
          }
        }
      }
      _construct_security_header() {
        this.receiverCertificate = this.serverCertificate ? Buffer.from(this.serverCertificate) : null;
        let securityHeader = null;
        switch (this.securityMode) {
          case node_opcua_service_secure_channel_1.MessageSecurityMode.Sign:
          case node_opcua_service_secure_channel_1.MessageSecurityMode.SignAndEncrypt: {
            (0, node_opcua_assert_1.assert)(this.securityPolicy !== security_policy_1.SecurityPolicy.None);
            const receiverCertificateThumbprint = (0, common_1.getThumbprint)(this.receiverCertificate);
            securityHeader = new services_1.AsymmetricAlgorithmSecurityHeader({
              receiverCertificateThumbprint,
              // thumbprint of the public key used to encrypt the message
              securityPolicyUri: (0, security_policy_1.toURI)(this.securityPolicy),
              /**
               * The X.509 v3 Certificate assigned to the sending application Instance.
               *  This is a DER encoded blob.
               * The structure of an X.509 v3 Certificate is defined in X.509 v3.
               * The DER format for a Certificate is defined in X690
               * This indicates what Private Key was used to sign the MessageChunk.
               * The Stack shall close the channel and report an error to the application if the SenderCertificate is too large for the buffer size supported by the transport layer.
               * This field shall be null if the Message is not signed.
               * If the Certificate is signed by a CA, the DER encoded CA Certificate may be
               * appended after the Certificate in the byte array. If the CA Certificate is also
               * signed by another CA this process is repeated until the entire Certificate chain
               *  is in the buffer or if MaxSenderCertificateSize limit is reached (the process
               * stops after the last whole Certificate that can be added without exceeding
               * the MaxSenderCertificateSize limit).
               * Receivers can extract the Certificates from the byte array by using the Certificate
               *  size contained in DER header (see X.509 v3).
               */
              senderCertificate: this.getCertificateChain()
              // certificate of the private key used to sign the message
            });
            if (utils_1.dumpSecurityHeader) {
              warningLog("HEADER !!!! ", securityHeader.toString());
            }
            break;
          }
          default:
            (0, node_opcua_assert_1.assert)(false, "invalid security mode");
        }
        this.securityHeader = securityHeader;
      }
      _get_security_options_for_OPN() {
        if (this.securityMode === node_opcua_service_secure_channel_1.MessageSecurityMode.None) {
          return null;
        }
        this._construct_security_header();
        this.messageChunker.securityHeader = this.securityHeader;
        const senderPrivateKey = this.getPrivateKey();
        if (!senderPrivateKey) {
          throw new Error("invalid senderPrivateKey");
        }
        const cryptoFactory = (0, security_policy_1.getCryptoFactory)(this.securityPolicy);
        if (!cryptoFactory) {
          return null;
        }
        (0, node_opcua_assert_1.assert)(cryptoFactory, "expecting a cryptoFactory");
        (0, node_opcua_assert_1.assert)(typeof cryptoFactory.asymmetricSign === "function");
        const options = {};
        options.signatureLength = (0, node_opcua_crypto_1.rsaLengthPrivateKey)(senderPrivateKey);
        options.signBufferFunc = (chunk) => {
          const s = cryptoFactory.asymmetricSign(chunk, senderPrivateKey);
          (0, node_opcua_assert_1.assert)(s.length === options.signatureLength);
          return s;
        };
        if (!this.receiverPublicKey) {
          throw new Error(" invalid receiverPublicKey");
        }
        const keyLength = (0, node_opcua_crypto_1.rsaLengthPublicKey)(this.receiverPublicKey);
        options.plainBlockSize = keyLength - cryptoFactory.blockPaddingSize;
        options.cipherBlockSize = keyLength;
        const receiverPublicKey = this.receiverPublicKey;
        options.encryptBufferFunc = (chunk) => {
          return cryptoFactory.asymmetricEncrypt(chunk, receiverPublicKey);
        };
        return options;
      }
      _get_security_options_for_MSG() {
        if (this.securityMode === node_opcua_service_secure_channel_1.MessageSecurityMode.None) {
          return null;
        }
        if (!this.derivedKeys || !this.derivedKeys.derivedClientKeys) {
          errorLog("derivedKeys not set but security mode = ", node_opcua_service_secure_channel_1.MessageSecurityMode[this.securityMode]);
          return null;
        }
        const derivedClientKeys = this.derivedKeys.derivedClientKeys;
        (0, node_opcua_assert_1.assert)(derivedClientKeys, "expecting valid derivedClientKeys");
        return (0, security_policy_1.getOptionsForSymmetricSignAndEncrypt)(this.securityMode, derivedClientKeys);
      }
      _sendSecureOpcUARequest(msgType, request, requestId) {
        const tokenId = this.securityToken ? this.securityToken.tokenId : 0;
        let options = {
          channelId: this.channelId,
          chunkSize: 0,
          requestId,
          tokenId,
          cipherBlockSize: 0,
          plainBlockSize: 0,
          sequenceHeaderSize: 0,
          signatureLength: 0
        };
        if (this._transport?.parameters && this._transport?.parameters.sendBufferSize) {
          options.chunkSize = this._transport.parameters.sendBufferSize;
        }
        if (request.requestHeader.requestHandle !== options.requestId) {
          doDebug && debugLog(chalk_1.default.red.bold("------------------------------------- Invalid request id"), request.requestHeader.requestHandle, options.requestId);
        }
        request.requestHeader.returnDiagnostics = 0;
        if (utils_1.doTraceClientRequestContent) {
          (0, utils_1.traceClientRequestContent)(request, this.channelId, this.securityToken);
        }
        const security_options = msgType === "OPN" ? this._get_security_options_for_OPN() : this._get_security_options_for_MSG();
        if (security_options) {
          options = {
            ...options,
            ...security_options
          };
        }
        this.emit("send_request", request);
        this.messageChunker.chunkSecureMessage(msgType, options, request, (err, chunk) => {
          if (err) {
            const response = new services_1.ServiceFault({
              responseHeader: {
                serviceResult: node_opcua_status_code_1.StatusCodes.BadInternalError,
                stringTable: [err.message]
              }
            });
            this._send_chunk(requestId, null);
            this._on_message_received(response, "ERR", request.requestHeader.requestHandle);
          } else {
            this._send_chunk(requestId, chunk);
          }
        });
      }
    };
    exports2.ClientSecureChannelLayer = ClientSecureChannelLayer;
    ClientSecureChannelLayer.g_counter = 0;
    ClientSecureChannelLayer.minTransactionTimeout = 5 * 1e3;
    ClientSecureChannelLayer.defaultTransactionTimeout = 15 * 1e3;
    ClientSecureChannelLayer.defaultTransportTimeout = 60 * 1e3;
  }
});

// node_modules/node-opcua-secure-channel/dist/source/server/server_secure_channel_layer.js
var require_server_secure_channel_layer = __commonJS({
  "node_modules/node-opcua-secure-channel/dist/source/server/server_secure_channel_layer.js"(exports2) {
    "use strict";
    var __classPrivateFieldGet3 = exports2 && exports2.__classPrivateFieldGet || function(receiver, state, kind, f2) {
      if (kind === "a" && !f2)
        throw new TypeError("Private accessor was defined without a getter");
      if (typeof state === "function" ? receiver !== state || !f2 : !state.has(receiver))
        throw new TypeError("Cannot read private member from an object whose class did not declare it");
      return kind === "m" ? f2 : kind === "a" ? f2.call(receiver) : f2 ? f2.value : state.get(receiver);
    };
    var __classPrivateFieldSet3 = exports2 && exports2.__classPrivateFieldSet || function(receiver, state, value, kind, f2) {
      if (kind === "m")
        throw new TypeError("Private method is not writable");
      if (kind === "a" && !f2)
        throw new TypeError("Private accessor was defined without a setter");
      if (typeof state === "function" ? receiver !== state || !f2 : !state.has(receiver))
        throw new TypeError("Cannot write private member to an object whose class did not declare it");
      return kind === "a" ? f2.call(receiver, value) : f2 ? f2.value = value : state.set(receiver, value), value;
    };
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    var _a;
    var _ServerSecureChannelLayer_counter;
    var _ServerSecureChannelLayer_status;
    var _ServerSecureChannelLayer_open_secure_channel_onceClose;
    var _ServerSecureChannelLayer_abort_has_been_called;
    var _ServerSecureChannelLayer_idVerification;
    var _ServerSecureChannelLayer_transport_socket_close_listener;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ServerSecureChannelLayer = exports2.nonceAlreadyBeenUsed = exports2.isEmptyNonce = void 0;
    var crypto_1 = require("crypto");
    var events_1 = require("events");
    var util_1 = require("util");
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_crypto_1 = require_dist33();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_packet_analyzer_1 = require_source6();
    var node_opcua_service_secure_channel_1 = require_dist38();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_transport_1 = require_source5();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_object_registry_1 = require_dist46();
    var node_opcua_transport_2 = require_source5();
    var common_1 = require_common2();
    var message_builder_1 = require_message_builder();
    var message_chunker_1 = require_message_chunker();
    var security_policy_1 = require_security_policy();
    var services_1 = require_services();
    var utils_1 = require_utils7();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var allowNullRequestId = true;
    var gLastChannelId = 0;
    function getNextChannelId() {
      gLastChannelId += 1;
      return gLastChannelId;
    }
    function isValidSecurityPolicy(securityPolicy) {
      switch (securityPolicy) {
        case security_policy_1.SecurityPolicy.None:
        case security_policy_1.SecurityPolicy.Basic128Rsa15:
        case security_policy_1.SecurityPolicy.Basic256:
        case security_policy_1.SecurityPolicy.Basic256Sha256:
        case security_policy_1.SecurityPolicy.Aes128_Sha256_RsaOaep:
        case security_policy_1.SecurityPolicy.Aes256_Sha256_RsaPss:
          return node_opcua_status_code_1.StatusCodes.Good;
        default:
          return node_opcua_status_code_1.StatusCodes.BadSecurityPolicyRejected;
      }
    }
    function isEmptyNonce(nonce) {
      const countZero = nonce.reduce((accumulator, currentValue) => accumulator + (currentValue === 0 ? 1 : 0), 0);
      return countZero === nonce.length;
    }
    exports2.isEmptyNonce = isEmptyNonce;
    var g_alreadyUsedNonce = {};
    function nonceAlreadyBeenUsed(nonce) {
      if (!nonce || isEmptyNonce(nonce)) {
        return false;
      }
      const hash = nonce.toString("base64");
      if (Object.prototype.hasOwnProperty.call(g_alreadyUsedNonce, hash)) {
        return true;
      }
      g_alreadyUsedNonce[hash] = {
        time: /* @__PURE__ */ new Date()
      };
      return false;
    }
    exports2.nonceAlreadyBeenUsed = nonceAlreadyBeenUsed;
    var ServerSecureChannelLayer = class extends events_1.EventEmitter {
      get securityTokenCount() {
        (0, node_opcua_assert_1.assert)(typeof this.lastTokenId === "number");
        return this.lastTokenId;
      }
      get remoteAddress() {
        return this._remoteAddress;
      }
      get remotePort() {
        return this._remotePort;
      }
      /**
       *
       */
      get aborted() {
        return __classPrivateFieldGet3(this, _ServerSecureChannelLayer_abort_has_been_called, "f");
      }
      /**
       * the number of bytes read so far by this channel
       */
      get bytesRead() {
        return this.transport ? this.transport.bytesRead : 0;
      }
      /**
       * the number of bytes written so far by this channel
       */
      get bytesWritten() {
        return this.transport ? this.transport.bytesWritten : 0;
      }
      get transactionsCount() {
        return this._transactionsCount;
      }
      /**
       * true when the secure channel has been opened successfully
       *
       */
      get isOpened() {
        return __classPrivateFieldGet3(this, _ServerSecureChannelLayer_status, "f") === "open";
      }
      /**
       * true when the secure channel is assigned to a active session
       */
      get hasSession() {
        return Object.keys(this.sessionTokens).length > 0;
      }
      get certificateManager() {
        return this.parent.certificateManager;
      }
      /**
       * The unique hash key to identify this secure channel
       * @property hashKey
       */
      get hashKey() {
        return this.__hash;
      }
      get status() {
        return __classPrivateFieldGet3(this, _ServerSecureChannelLayer_status, "f");
      }
      constructor(options) {
        super();
        _ServerSecureChannelLayer_counter.set(this, _a.g_counter++);
        _ServerSecureChannelLayer_status.set(this, "new");
        this.securityPolicy = security_policy_1.SecurityPolicy.Invalid;
        _ServerSecureChannelLayer_open_secure_channel_onceClose.set(this, null);
        _ServerSecureChannelLayer_abort_has_been_called.set(this, void 0);
        _ServerSecureChannelLayer_idVerification.set(this, void 0);
        _ServerSecureChannelLayer_transport_socket_close_listener.set(this, void 0);
        this._on_response = null;
        __classPrivateFieldSet3(this, _ServerSecureChannelLayer_idVerification, {}, "f");
        __classPrivateFieldSet3(this, _ServerSecureChannelLayer_abort_has_been_called, false, "f");
        this._remoteAddress = "";
        this._remotePort = 0;
        this.receiverCertificate = null;
        this.receiverPublicKey = null;
        this.receiverPublicKeyLength = 0;
        this.clientCertificate = null;
        this.clientNonce = null;
        this.transport = new node_opcua_transport_1.ServerTCP_transport({ adjustLimits: options.adjustTransportLimits });
        this.__hash = getNextChannelId();
        (0, node_opcua_assert_1.assert)(this.__hash > 0);
        this.channelId = null;
        this.revisedLifetime = 0;
        this.parent = options.parent;
        this.protocolVersion = 0;
        this.lastTokenId = 0;
        this.timeout = options.timeout || 3e4;
        this.defaultSecureTokenLifetime = options.defaultSecureTokenLifetime || 6e5;
        debugLog("server secure channel layer timeout = ", this.timeout, "defaultSecureTokenLifetime = ", this.defaultSecureTokenLifetime);
        this.securityToken = new node_opcua_service_secure_channel_1.ChannelSecurityToken({
          channelId: this.__hash,
          revisedLifetime: 0,
          tokenId: 0
        });
        (0, node_opcua_assert_1.assert)(this.securityToken.channelId > 0);
        this.serverNonce = null;
        this.securityHeader = new services_1.AsymmetricAlgorithmSecurityHeader({
          receiverCertificateThumbprint: null,
          securityPolicyUri: "http://opcfoundation.org/UA/SecurityPolicy#None",
          senderCertificate: null
        });
        this.messageChunker = new message_chunker_1.MessageChunker({
          securityHeader: this.securityHeader,
          // for OPN
          maxMessageSize: this.transport.maxMessageSize,
          maxChunkCount: this.transport.maxChunkCount
        });
        this._tick0 = 0;
        this._tick1 = 0;
        this._tick2 = 0;
        this._tick3 = 0;
        this._bytesRead_before = 0;
        this._bytesWritten_before = 0;
        this.securityMode = node_opcua_service_secure_channel_1.MessageSecurityMode.Invalid;
        this.timeoutId = null;
        this._securityTokenTimeout = null;
        this._transactionsCount = 0;
        this.sessionTokens = {};
        this.objectFactory = options.objectFactory;
      }
      getTransportSettings() {
        return { maxMessageSize: this.transport.maxMessageSize };
      }
      _build_message_builder() {
        this.messageBuilder = new message_builder_1.MessageBuilder({
          name: "server",
          objectFactory: this.objectFactory,
          privateKey: this.getPrivateKey(),
          maxChunkSize: this.transport.receiveBufferSize,
          maxChunkCount: this.transport.maxChunkCount,
          maxMessageSize: this.transport.maxMessageSize
        });
        debugLog(" this.transport.maxChunkCount", this.transport.maxChunkCount);
        debugLog(" this.transport.maxMessageSize", this.transport.maxMessageSize);
        this.messageBuilder.on("error", (err, statusCode) => {
          warningLog("ServerSecureChannel:MessageBuilder: ", err.message, statusCode.toString());
          if (doDebug) {
            debugLog(chalk_1.default.red("Error "), err.message, err.stack);
            debugLog(chalk_1.default.red("Server is now closing socket, without further notice"));
          }
          this.transport.sendErrorMessage(statusCode, err.message);
          this.close(() => {
          });
        });
      }
      dispose() {
        debugLog("ServerSecureChannelLayer#dispose");
        this._stop_open_channel_watch_dog();
        (0, node_opcua_assert_1.assert)(!this.timeoutId, "timeout must have been cleared");
        (0, node_opcua_assert_1.assert)(!this._securityTokenTimeout, "_securityTokenTimeout must have been cleared");
        this.parent = null;
        this.serverNonce = null;
        this.objectFactory = void 0;
        if (this.messageBuilder) {
          this.messageBuilder.dispose();
          this.messageBuilder = void 0;
        }
        this.securityHeader = null;
        if (this.messageChunker) {
          this.messageChunker.dispose();
        }
        if (this.transport) {
          this.transport.dispose();
          this.transport = void 0;
        }
        this.channelId = 3735928559;
        this.timeoutId = null;
        this.sessionTokens = {};
        this.removeAllListeners();
      }
      abruptlyInterrupt() {
        const clientSocket = this.transport._socket;
        if (clientSocket) {
          clientSocket.end();
          clientSocket.destroy();
        }
      }
      /**
       * the endpoint associated with this secure channel
       *
       */
      getEndpointDescription(securityMode, securityPolicy, endpointUri) {
        if (!this.parent) {
          return null;
        }
        return this.parent.getEndpointDescription(this.securityMode, securityPolicy, endpointUri);
      }
      setSecurity(securityMode, securityPolicy) {
        if (!this.messageBuilder) {
          this._build_message_builder();
        }
        (0, node_opcua_assert_1.assert)(this.messageBuilder);
        this.messageBuilder.setSecurity(securityMode, securityPolicy);
      }
      /**
       * @method getCertificateChain
       * @return the X509 DER form certificate
       */
      getCertificateChain() {
        if (!this.parent) {
          throw new Error("expecting a valid parent");
        }
        return this.parent.getCertificateChain();
      }
      /**
       * @method getCertificate
       * @return  the X509 DER form certificate
       */
      getCertificate() {
        if (!this.parent) {
          throw new Error("expecting a valid parent");
        }
        return this.parent.getCertificate();
      }
      getSignatureLength() {
        const firstCertificateInChain = this.getCertificate();
        const cert = (0, node_opcua_crypto_1.exploreCertificateInfo)(firstCertificateInChain);
        return cert.publicKeyLength;
      }
      /**
       * @method getPrivateKey
       * @return the privateKey
       */
      getPrivateKey() {
        if (!this.parent) {
          return message_builder_1.invalidPrivateKey;
        }
        return this.parent.getPrivateKey();
      }
      /**
       * @method init
       * @async
       * @param socket
       * @param callback
       */
      init(socket, callback) {
        this.transport.timeout = this.timeout;
        debugLog("Setting socket timeout to ", this.transport.timeout);
        this.transport.init(socket, (err) => {
          if (err) {
            callback(err);
          } else {
            this._build_message_builder();
            this._rememberClientAddressAndPort();
            this.messageChunker.maxMessageSize = this.transport.maxMessageSize;
            this.messageChunker.maxChunkCount = this.transport.maxChunkCount;
            this.transport.on("chunk", (messageChunk) => {
              if (node_opcua_transport_2.doTraceIncomingChunk) {
                console.log((0, node_opcua_crypto_1.hexDump)(messageChunk));
              }
              this.messageBuilder.feed(messageChunk);
            });
            debugLog("ServerSecureChannelLayer : Transport layer has been initialized");
            debugLog("... now waiting for OpenSecureChannelRequest...");
            _a.registry.register(this);
            this._wait_for_open_secure_channel_request(callback, this.timeout);
          }
        });
        __classPrivateFieldSet3(this, _ServerSecureChannelLayer_transport_socket_close_listener, (err) => {
          debugLog("transport has send 'close' event " + (err ? err.message : "null"));
          this._abort();
        }, "f");
        this.transport.on("close", __classPrivateFieldGet3(this, _ServerSecureChannelLayer_transport_socket_close_listener, "f"));
      }
      /**
       * @method send_response
       * @async
       * @param msgType
       * @param response
       * @param message
       * @param callback
       */
      send_response(msgType, response, message, callback) {
        const request = message.request;
        const requestId = message.requestId;
        (0, node_opcua_assert_1.assert)(allowNullRequestId || requestId !== 0);
        if (this.aborted) {
          debugLog("channel has been terminated , cannot send responses");
          return callback && callback(new Error("Aborted"));
        }
        if (doDebug) {
          (0, node_opcua_assert_1.assert)(request.schema);
          (0, node_opcua_assert_1.assert)(allowNullRequestId || requestId > 0);
          if (!__classPrivateFieldGet3(this, _ServerSecureChannelLayer_idVerification, "f")) {
            __classPrivateFieldSet3(this, _ServerSecureChannelLayer_idVerification, {}, "f");
          }
          (0, node_opcua_assert_1.assert)(!__classPrivateFieldGet3(this, _ServerSecureChannelLayer_idVerification, "f")[requestId], " response for requestId has already been sent !! - Internal Error");
          __classPrivateFieldGet3(this, _ServerSecureChannelLayer_idVerification, "f")[requestId] = requestId;
        }
        if (utils_1.doPerfMonitoring) {
          this._tick2 = (0, node_opcua_utils_1.get_clock_tick)();
        }
        if (!this.securityToken) {
          throw new Error("Internal error");
        }
        let options = {
          channelId: this.securityToken.channelId,
          chunkSize: this.transport.receiveBufferSize,
          requestId,
          tokenId: this.securityToken.tokenId,
          // to be adjusted
          signatureLength: 0,
          plainBlockSize: 0,
          cipherBlockSize: 0,
          sequenceHeaderSize: 0
        };
        const securityOptions = msgType === "OPN" ? this._get_security_options_for_OPN() : this._get_security_options_for_MSG();
        if (securityOptions) {
          options = {
            ...options,
            ...securityOptions
          };
        }
        response.responseHeader.requestHandle = request.requestHeader.requestHandle;
        if (message.request.requestHeader.returnDiagnostics === 0) {
          response.responseHeader.serviceDiagnostics = null;
        } else {
        }
        if (0) {
          debugLog(" options ", options);
          (0, node_opcua_packet_analyzer_1.analyze_object_binary_encoding)(response);
        }
        if (utils_1.doTraceServerMessage) {
          (0, utils_1.traceResponseMessage)(response, this.securityToken.channelId, __classPrivateFieldGet3(this, _ServerSecureChannelLayer_counter, "f"));
        }
        if (this._on_response) {
          this._on_response(msgType, response, message);
        }
        this._transactionsCount += 1;
        this.messageChunker.chunkSecureMessage(msgType, options, response, (err, messageChunk) => {
          if (err) {
            warningLog("Error while chunking response message : ", err.message);
            this._send_chunk(callback, messageChunk);
          } else {
            this._send_chunk(callback, messageChunk);
          }
        });
      }
      _sendFatalErrorAndAbort(statusCode, description, message, callback) {
        this.transport.sendErrorMessage(statusCode, description);
        if (!this.transport) {
          return callback(new Error("Transport has been closed"));
        }
        __classPrivateFieldSet3(this, _ServerSecureChannelLayer_status, "closing", "f");
        this.transport.disconnect(() => {
          this.close(() => {
            __classPrivateFieldSet3(this, _ServerSecureChannelLayer_status, "closed", "f");
            callback(new Error(description + " statusCode = " + statusCode.toString()));
          });
        });
      }
      getRemoteIPAddress() {
        return this.transport?._socket?.remoteAddress || "";
      }
      getRemotePort() {
        return this.transport?._socket?.remotePort || 0;
      }
      getRemoteFamily() {
        return this.transport?._socket?.remoteFamily || "";
      }
      /**
       * Abruptly close a Server SecureChannel ,by terminating the underlying transport.
       *
       *
       * @method close
       * @async
       * @param callback
       */
      close(callback) {
        callback = callback || (() => {
        });
        if (!this.transport) {
          if (typeof callback === "function") {
            callback();
          }
          return;
        }
        debugLog("ServerSecureChannelLayer#close");
        __classPrivateFieldSet3(this, _ServerSecureChannelLayer_status, "closing", "f");
        this.transport.disconnect(() => {
          __classPrivateFieldSet3(this, _ServerSecureChannelLayer_status, "closed", "f");
          this._abort();
          if (typeof callback === "function") {
            callback();
          }
        });
      }
      has_endpoint_for_security_mode_and_policy(securityMode, securityPolicy) {
        if (!this.parent) {
          return true;
        }
        const endpoint_desc = this.getEndpointDescription(securityMode, securityPolicy, null);
        return endpoint_desc !== null;
      }
      _rememberClientAddressAndPort() {
        if (this.transport && this.transport._socket) {
          this._remoteAddress = this.transport._socket.remoteAddress || "";
          this._remotePort = this.transport._socket.remotePort || 0;
        }
      }
      _stop_security_token_watch_dog() {
        if (this._securityTokenTimeout) {
          clearTimeout(this._securityTokenTimeout);
          this._securityTokenTimeout = null;
        }
      }
      _start_security_token_watch_dog() {
        this._securityTokenTimeout = setTimeout(() => {
          warningLog(" Security token has really expired and shall be discarded !!!! (lifetime is = ", this.securityToken.revisedLifetime, ")");
          warningLog(" Server will now refuse message with token ", this.securityToken.tokenId);
          this._securityTokenTimeout = null;
        }, this.securityToken.revisedLifetime * 120 / 100);
      }
      _add_new_security_token() {
        this._stop_security_token_watch_dog();
        this.lastTokenId += 1;
        this.channelId = this.__hash;
        (0, node_opcua_assert_1.assert)(this.channelId > 0);
        const securityToken = new node_opcua_service_secure_channel_1.ChannelSecurityToken({
          channelId: this.channelId,
          createdAt: /* @__PURE__ */ new Date(),
          // now
          revisedLifetime: this.revisedLifetime,
          tokenId: this.lastTokenId
          // todo ?
        });
        (0, node_opcua_assert_1.assert)(!(0, node_opcua_service_secure_channel_1.hasTokenExpired)(securityToken));
        (0, node_opcua_assert_1.assert)(isFinite(securityToken.revisedLifetime));
        this.securityToken = securityToken;
        debugLog("SecurityToken", securityToken.tokenId);
        this._start_security_token_watch_dog();
      }
      _prepare_security_token(openSecureChannelRequest) {
        this.securityToken = null;
        if (openSecureChannelRequest.requestType === services_1.SecurityTokenRequestType.Renew) {
          this._stop_security_token_watch_dog();
        } else if (openSecureChannelRequest.requestType === services_1.SecurityTokenRequestType.Issue) {
        } else {
        }
        this._add_new_security_token();
      }
      _set_lifetime(requestedLifetime) {
        (0, node_opcua_assert_1.assert)(isFinite(requestedLifetime));
        this.revisedLifetime = requestedLifetime;
        if (this.revisedLifetime === 0) {
          this.revisedLifetime = this.defaultSecureTokenLifetime;
        } else {
          this.revisedLifetime = Math.min(this.defaultSecureTokenLifetime, this.revisedLifetime);
          this.revisedLifetime = Math.max(_a.g_MinimumSecureTokenLifetime, this.revisedLifetime);
        }
      }
      _stop_open_channel_watch_dog() {
        if (this.timeoutId) {
          clearTimeout(this.timeoutId);
          this.timeoutId = null;
        }
        if (__classPrivateFieldGet3(this, _ServerSecureChannelLayer_open_secure_channel_onceClose, "f")) {
          this.transport.removeListener("close", __classPrivateFieldGet3(this, _ServerSecureChannelLayer_open_secure_channel_onceClose, "f"));
          __classPrivateFieldSet3(this, _ServerSecureChannelLayer_open_secure_channel_onceClose, null, "f");
        }
      }
      _cleanup_pending_timers() {
        this._stop_security_token_watch_dog();
        this._stop_open_channel_watch_dog();
      }
      _cancel_wait_for_open_secure_channel_request_timeout() {
        this._stop_open_channel_watch_dog();
      }
      _install_wait_for_open_secure_channel_request_timeout(callback, timeout) {
        (0, node_opcua_assert_1.assert)(isFinite(timeout));
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        __classPrivateFieldSet3(this, _ServerSecureChannelLayer_open_secure_channel_onceClose, (err) => {
          __classPrivateFieldSet3(this, _ServerSecureChannelLayer_open_secure_channel_onceClose, null, "f");
          this._stop_open_channel_watch_dog();
          this.close(() => {
            const err2 = new Error("Timeout waiting for OpenChannelRequest (A) (timeout was " + timeout + " ms)");
            callback(err2);
          });
        }, "f");
        this.transport.prependOnceListener("close", __classPrivateFieldGet3(this, _ServerSecureChannelLayer_open_secure_channel_onceClose, "f"));
        this.timeoutId = setTimeout(() => {
          this.timeoutId = null;
          this._stop_open_channel_watch_dog();
          const err = new Error("Timeout waiting for OpenChannelRequest (B) (timeout was " + timeout + " ms)");
          debugLog(err.message);
          this.close(() => {
            callback(err);
          });
        }, timeout);
      }
      _on_initial_open_secure_channel_request(callback, request, msgType, requestId, channelId) {
        __classPrivateFieldSet3(this, _ServerSecureChannelLayer_status, "connecting", "f");
        if (utils_1.doTraceServerMessage) {
          (0, utils_1.traceRequestMessage)(request, channelId, __classPrivateFieldGet3(this, _ServerSecureChannelLayer_counter, "f"));
        }
        if (!(this.messageBuilder && this.messageBuilder.sequenceHeader && this.messageBuilder.securityHeader)) {
          return this._on_OpenSecureChannelRequestError(node_opcua_status_code_1.StatusCodes.BadCommunicationError, "internal error", { request, requestId }, callback);
        }
        const message = {
          request,
          requestId,
          securityHeader: this.messageBuilder.securityHeader
        };
        requestId = this.messageBuilder.sequenceHeader.requestId;
        if (requestId < 0) {
          return this._on_OpenSecureChannelRequestError(node_opcua_status_code_1.StatusCodes.BadCommunicationError, "Invalid requestId", message, callback);
        }
        this.clientSecurityHeader = message.securityHeader;
        let description;
        if (!(request instanceof services_1.OpenSecureChannelRequest)) {
          description = "Expecting OpenSecureChannelRequest";
          warningLog(chalk_1.default.red("ERROR"), "BadCommunicationError: expecting a OpenChannelRequest as first communication message");
          return this._on_OpenSecureChannelRequestError(node_opcua_status_code_1.StatusCodes.BadCommunicationError, description, message, callback);
        }
        if (doDebug) {
          debugLog(this.messageBuilder.sequenceHeader.toString());
          debugLog(this.messageBuilder.securityHeader.toString());
        }
        const asymmetricSecurityHeader = this.messageBuilder.securityHeader;
        const securityPolicy = message.securityHeader ? (0, security_policy_1.fromURI)(asymmetricSecurityHeader.securityPolicyUri) : security_policy_1.SecurityPolicy.Invalid;
        const securityPolicyStatus = isValidSecurityPolicy(securityPolicy);
        if (securityPolicyStatus !== node_opcua_status_code_1.StatusCodes.Good) {
          description = " Unsupported securityPolicyUri " + asymmetricSecurityHeader.securityPolicyUri;
          warningLog("BadSecurityPolicyRejected: Unsupported securityPolicyUri", securityPolicy);
          return this._on_OpenSecureChannelRequestError(securityPolicyStatus, description, message, callback);
        }
        this.securityMode = request.securityMode;
        this.securityPolicy = securityPolicy;
        this.messageBuilder.securityMode = this.securityMode;
        const hasEndpoint = this.has_endpoint_for_security_mode_and_policy(this.securityMode, securityPolicy);
        if (!hasEndpoint) {
          description = " This server doesn't not support  " + securityPolicy.toString() + " " + this.securityMode.toString();
          return this._on_OpenSecureChannelRequestError(node_opcua_status_code_1.StatusCodes.BadSecurityPolicyRejected, description, message, callback);
        }
        this.messageBuilder.on("message", (request2, msgType2, requestId2, channelId2) => {
          this._on_common_message(request2, msgType2, requestId2, channelId2);
        }).on("error", (err, statusCode, requestId2) => {
          this.transport.sendErrorMessage(statusCode, err.message);
          this.close(() => {
          });
        }).on("startChunk", () => {
          if (utils_1.doPerfMonitoring) {
            this._tick0 = (0, node_opcua_utils_1.get_clock_tick)();
          }
        });
        this._process_certificates(message, (err, statusCode) => {
          if (err || !statusCode) {
            description = "Internal Error " + err?.message;
            return this._on_OpenSecureChannelRequestError(node_opcua_status_code_1.StatusCodes.BadInternalError, description, message, callback);
          }
          if (statusCode.isNotGood()) {
            const description2 = "Sender Certificate Error " + statusCode.toString();
            debugLog(chalk_1.default.cyan(description2), chalk_1.default.bgCyan.yellow(statusCode.toString()));
            if (statusCode.isNot(node_opcua_status_code_1.StatusCodes.BadCertificateIssuerRevocationUnknown) && statusCode.isNot(node_opcua_status_code_1.StatusCodes.BadCertificateRevocationUnknown) && statusCode.isNot(node_opcua_status_code_1.StatusCodes.BadCertificateTimeInvalid) && statusCode.isNot(node_opcua_status_code_1.StatusCodes.BadCertificateUseNotAllowed)) {
              statusCode = node_opcua_status_code_1.StatusCodes.BadSecurityChecksFailed;
            }
            return this._handle_OpenSecureChannelRequest(statusCode, message, callback);
          }
          this._handle_OpenSecureChannelRequest(statusCode, message, callback);
        });
      }
      _wait_for_open_secure_channel_request(callback, timeout) {
        this._install_wait_for_open_secure_channel_request_timeout(callback, timeout);
        const errorHandler = (err) => {
          this._cancel_wait_for_open_secure_channel_request_timeout();
          if (this.messageBuilder) {
            this.messageBuilder.removeListener("message", messageHandler);
            this.close(() => {
              callback(new Error("/Expecting OpenSecureChannelRequest to be valid " + err.message));
            });
          }
        };
        const messageHandler = (request, msgType, requestId, channelId) => {
          this._cancel_wait_for_open_secure_channel_request_timeout();
          this.messageBuilder.removeListener("error", errorHandler);
          this._on_initial_open_secure_channel_request(callback, request, msgType, requestId, channelId);
        };
        this.messageBuilder.prependOnceListener("error", errorHandler);
        this.messageBuilder.once("message", messageHandler);
      }
      _send_chunk(callback, messageChunk) {
        if (messageChunk) {
          this.transport.write(messageChunk);
        } else {
          if (utils_1.doPerfMonitoring) {
            this._tick3 = (0, node_opcua_utils_1.get_clock_tick)();
          }
          if (callback) {
            callback();
          }
          if (utils_1.doPerfMonitoring) {
            this._record_transaction_statistics();
            (0, utils_1._dump_transaction_statistics)(this.last_transaction_stats);
          }
          this.emit("transaction_done");
        }
      }
      _get_security_options_for_OPN() {
        if (this.securityMode === node_opcua_service_secure_channel_1.MessageSecurityMode.Sign || this.securityMode === node_opcua_service_secure_channel_1.MessageSecurityMode.SignAndEncrypt) {
          const cryptoFactory = this.messageBuilder.cryptoFactory;
          if (!cryptoFactory) {
            throw new Error("Internal Error");
          }
          (0, node_opcua_assert_1.assert)(cryptoFactory, "ServerSecureChannelLayer must have a crypto strategy");
          (0, node_opcua_assert_1.assert)(this.receiverPublicKeyLength >= 0);
          const receiverPublicKey = this.receiverPublicKey;
          if (!receiverPublicKey) {
            return null;
          }
          const options = {
            cipherBlockSize: this.receiverPublicKeyLength,
            plainBlockSize: this.receiverPublicKeyLength - cryptoFactory.blockPaddingSize,
            signatureLength: this.getSignatureLength(),
            encryptBufferFunc: (chunk) => {
              return cryptoFactory.asymmetricEncrypt(chunk, receiverPublicKey);
            },
            signBufferFunc: (chunk) => {
              const signed = cryptoFactory.asymmetricSign(chunk, this.getPrivateKey());
              (0, node_opcua_assert_1.assert)(signed.length === options.signatureLength);
              return signed;
            }
          };
          return options;
        }
        return null;
      }
      _get_security_options_for_MSG() {
        if (this.securityMode === node_opcua_service_secure_channel_1.MessageSecurityMode.None) {
          return null;
        }
        const cryptoFactory = this.messageBuilder.cryptoFactory;
        if (!cryptoFactory || !this.derivedKeys) {
          return null;
        }
        (0, node_opcua_assert_1.assert)(cryptoFactory, "ServerSecureChannelLayer must have a crypto strategy");
        (0, node_opcua_assert_1.assert)(this.derivedKeys.derivedServerKeys);
        const derivedServerKeys = this.derivedKeys.derivedServerKeys;
        if (!derivedServerKeys) {
          return null;
        }
        return (0, security_policy_1.getOptionsForSymmetricSignAndEncrypt)(this.securityMode, derivedServerKeys);
      }
      /**
       * _process_certificates extracts client public keys from client certificate
       *  and store them in self.receiverPublicKey and self.receiverCertificate
       *  it also caches self.receiverPublicKeyLength.
       *
       *  so they can be used by security channel.
       *
       * @method _process_certificates
       * @param message the message coming from the client
       * @param callback
       * @private
       * @async
       */
      _process_certificates(message, callback) {
        const asymmSecurityHeader = message.securityHeader;
        const certificate = asymmSecurityHeader ? asymmSecurityHeader.senderCertificate : null;
        this.checkCertificateCallback(certificate, (err, statusCode) => {
          if (err) {
            return callback(err);
          }
          this.receiverPublicKey = null;
          this.receiverPublicKeyLength = 0;
          this.receiverCertificate = asymmSecurityHeader ? asymmSecurityHeader.senderCertificate : null;
          this.clientCertificate = this.receiverCertificate;
          if (this.receiverCertificate && this.receiverCertificate.length === 0) {
            this.receiverCertificate = null;
          }
          if (this.receiverCertificate) {
            (0, node_opcua_crypto_1.extractPublicKeyFromCertificate)(this.receiverCertificate, (err2, keyPem) => {
              if (!err2) {
                if (keyPem) {
                  this.receiverPublicKey = (0, crypto_1.createPublicKey)(keyPem);
                  this.receiverPublicKeyLength = (0, node_opcua_crypto_1.rsaLengthPublicKey)(keyPem);
                }
                callback(null, statusCode);
              } else {
                callback(err2);
              }
            });
          } else {
            this.receiverPublicKey = null;
            callback(null, statusCode);
          }
        });
      }
      _prepare_security_header(request, message) {
        let securityHeader;
        switch (request.securityMode) {
          case node_opcua_service_secure_channel_1.MessageSecurityMode.None:
            securityHeader = new services_1.AsymmetricAlgorithmSecurityHeader({
              receiverCertificateThumbprint: null,
              // message not encrypted
              securityPolicyUri: "http://opcfoundation.org/UA/SecurityPolicy#None",
              senderCertificate: null
              // message not signed
            });
            break;
          case node_opcua_service_secure_channel_1.MessageSecurityMode.Sign:
          case node_opcua_service_secure_channel_1.MessageSecurityMode.SignAndEncrypt:
          default: {
            if (!this.parent) {
              warningLog("Cannot find parent of SecureChannel !!!!!!!! ");
              return null;
            }
            const receiverCertificateThumbprint = (0, common_1.getThumbprint)(this.receiverCertificate);
            const asymmClientSecurityHeader = this.clientSecurityHeader;
            securityHeader = new services_1.AsymmetricAlgorithmSecurityHeader({
              receiverCertificateThumbprint,
              // message not encrypted (????)
              securityPolicyUri: asymmClientSecurityHeader.securityPolicyUri,
              /**
               * The X.509 v3 Certificate assigned to the sending application Instance.
               *  This is a DER encoded blob.
               * The structure of an X.509 v3 Certificate is defined in X.509 v3.
               * The DER format for a Certificate is defined in X690
               * This indicates what Private Key was used to sign the MessageChunk.
               * The Stack shall close the channel and report an error to the application if the SenderCertificate is too large for the buffer size supported by the transport layer.
               * This field shall be null if the Message is not signed.
               * If the Certificate is signed by a CA, the DER encoded CA Certificate may be
               * appended after the Certificate in the byte array. If the CA Certificate is also
               * signed by another CA this process is repeated until the entire Certificate chain
               *  is in the buffer or if MaxSenderCertificateSize limit is reached (the process
               * stops after the last whole Certificate that can be added without exceeding
               * the MaxSenderCertificateSize limit).
               * Receivers can extract the Certificates from the byte array by using the Certificate
               *  size contained in DER header (see X.509 v3).
               */
              senderCertificate: this.getCertificateChain()
              // certificate of the private key used to sign the message
            });
          }
        }
        return securityHeader;
      }
      checkCertificateCallback(certificate, callback) {
      }
      async checkCertificate(certificate) {
        if (!certificate) {
          return node_opcua_status_code_1.StatusCodes.Good;
        }
        if (!this.certificateManager) {
          return node_opcua_status_code_1.StatusCodes.BadInternalError;
        }
        const statusCode = await this.certificateManager.checkCertificate(certificate);
        if (statusCode.isGood()) {
          const certInfo = (0, node_opcua_crypto_1.exploreCertificate)(certificate);
          if (!certInfo.tbsCertificate.extensions?.keyUsage?.dataEncipherment) {
            return node_opcua_status_code_1.StatusCodes.BadCertificateUseNotAllowed;
          }
          if (!certInfo.tbsCertificate.extensions?.keyUsage?.digitalSignature) {
            return node_opcua_status_code_1.StatusCodes.BadCertificateUseNotAllowed;
          }
        }
        return statusCode;
      }
      _handle_OpenSecureChannelRequest(serviceResult, message, callback) {
        const request = message.request;
        const requestId = message.requestId;
        if (!(requestId !== 0 && requestId > 0)) {
          warningLog("OpenSecureChannelRequest: requestId");
          return this._sendFatalErrorAndAbort(node_opcua_transport_1.StatusCodes2.BadTcpInternalError, "invalid request", message, callback);
        }
        this.securityHeader = this._prepare_security_header(request, message);
        if (!this.securityHeader) {
          warningLog("Cannot find SecurityHeader !!!!!!!! ");
          return this._sendFatalErrorAndAbort(node_opcua_transport_1.StatusCodes2.BadSecurityChecksFailed, "invalid request", message, callback);
        }
        this.clientNonce = request.clientNonce;
        if (nonceAlreadyBeenUsed(this.clientNonce)) {
          warningLog(chalk_1.default.red("SERVER with secure connection: Nonce has already been used"), this.clientNonce.toString("hex"));
          serviceResult = node_opcua_status_code_1.StatusCodes.BadNonceInvalid;
        }
        this._set_lifetime(request.requestedLifetime);
        this._prepare_security_token(request);
        const cryptoFactory = this.messageBuilder.cryptoFactory;
        if (cryptoFactory) {
          this.serverNonce = (0, crypto_1.randomBytes)(cryptoFactory.symmetricKeyLength);
          if (this.clientNonce.length !== this.serverNonce.length) {
            warningLog(chalk_1.default.red("warning client Nonce length doesn't match server nonce length"), this.clientNonce.length, " !== ", this.serverNonce.length);
            serviceResult = node_opcua_status_code_1.StatusCodes.BadSecurityModeRejected;
          }
          this.derivedKeys = (0, security_policy_1.computeDerivedKeys)(cryptoFactory, this.serverNonce, this.clientNonce);
        }
        const derivedClientKeys = this.derivedKeys ? this.derivedKeys.derivedClientKeys : null;
        this.messageBuilder.pushNewToken(this.securityToken, derivedClientKeys);
        const derivedServerKeys = this.derivedKeys ? this.derivedKeys.derivedServerKeys : void 0;
        this.messageChunker.update({
          // for OPN
          securityHeader: this.securityHeader,
          // derived keys for symmetric encryption of standard MSG
          // to sign and encrypt MSG sent to client
          derivedKeys: derivedServerKeys
        });
        let description;
        if (this.securityMode !== node_opcua_service_secure_channel_1.MessageSecurityMode.None) {
          if (!this.clientSecurityHeader) {
            throw new Error("Internal Error");
          }
          if (!this._check_receiverCertificateThumbprint(this.clientSecurityHeader)) {
            description = "Server#OpenSecureChannelRequest : Invalid receiver certificate thumbprint : the thumbprint doesn't match server certificate !";
            warningLog(chalk_1.default.cyan(description));
            serviceResult = node_opcua_status_code_1.StatusCodes.BadCertificateInvalid;
          }
        }
        const response = serviceResult.isGood() ? new services_1.OpenSecureChannelResponse({
          responseHeader: { serviceResult },
          securityToken: this.securityToken,
          serverNonce: this.serverNonce || void 0,
          serverProtocolVersion: this.protocolVersion
        }) : new services_1.ServiceFault({ responseHeader: { serviceResult } });
        if (utils_1.doTraceServerMessage) {
          console.log("Transport maxMessageSize = ", this.transport.maxMessageSize);
          console.log("Transport maxChunkCount = ", this.transport.maxChunkCount);
        }
        this.send_response("OPN", response, message, () => {
          const responseHeader = response.responseHeader;
          if (responseHeader.serviceResult !== node_opcua_status_code_1.StatusCodes.Good) {
            warningLog("OpenSecureChannelRequest Closing communication ", responseHeader.serviceResult.toString());
            __classPrivateFieldSet3(this, _ServerSecureChannelLayer_status, "closing", "f");
            this.close(callback);
          } else {
            __classPrivateFieldSet3(this, _ServerSecureChannelLayer_status, "open", "f");
            callback();
          }
        });
      }
      _abort() {
        __classPrivateFieldSet3(this, _ServerSecureChannelLayer_status, "closed", "f");
        debugLog("ServerSecureChannelLayer#_abort");
        if (__classPrivateFieldGet3(this, _ServerSecureChannelLayer_abort_has_been_called, "f")) {
          debugLog("Warning => ServerSecureChannelLayer#_abort has already been called");
          return;
        }
        _a.registry.unregister(this);
        __classPrivateFieldSet3(this, _ServerSecureChannelLayer_abort_has_been_called, true, "f");
        this._cleanup_pending_timers();
        this.emit("abort");
        debugLog("ServerSecureChannelLayer emitted abort event");
      }
      _record_transaction_statistics() {
        this._bytesRead_before = this._bytesRead_before || 0;
        this._bytesWritten_before = this._bytesWritten_before || 0;
        this.last_transaction_stats = {
          bytesRead: this.bytesRead - this._bytesRead_before,
          bytesWritten: this.bytesWritten - this._bytesWritten_before,
          lap_reception: this._tick1 - this._tick0,
          lap_processing: this._tick2 - this._tick1,
          lap_emission: this._tick3 - this._tick2
        };
        this._bytesRead_before = this.bytesRead;
        this._bytesWritten_before = this.bytesWritten;
      }
      _on_common_message(request, msgType, requestId, channelId) {
        if (utils_1.doTraceServerMessage) {
          (0, utils_1.traceRequestMessage)(request, channelId, __classPrivateFieldGet3(this, _ServerSecureChannelLayer_counter, "f"));
        }
        if (this.messageBuilder.sequenceHeader === null) {
          throw new Error("Internal Error");
        }
        requestId = this.messageBuilder.sequenceHeader.requestId;
        const message = {
          channel: this,
          request,
          requestId
        };
        const dummyCallback = () => {
        };
        if (msgType === "CLO") {
          this.close(dummyCallback);
        } else if (msgType === "OPN" && request.schema.name === "OpenSecureChannelRequest") {
          this._handle_OpenSecureChannelRequest(node_opcua_status_code_1.StatusCodes.Good, message, () => {
          });
        } else {
          if (request.schema.name === "CloseSecureChannelRequest") {
            warningLog("WARNING : RECEIVED a CloseSecureChannelRequest with msgType=", msgType);
            this.close(dummyCallback);
          } else {
            if (utils_1.doPerfMonitoring) {
              this._tick1 = (0, node_opcua_utils_1.get_clock_tick)();
            }
            if (this.securityToken && channelId !== this.securityToken.channelId) {
              debugLog("Invalid channelId detected =", channelId, " <> ", this.securityToken.channelId);
              return this._sendFatalErrorAndAbort(node_opcua_status_code_1.StatusCodes.BadCommunicationError, "Invalid Channel Id specified " + this.securityToken.channelId, message, () => {
              });
            }
            this.emit("message", message);
          }
        }
      }
      /**
       * @method _check_receiverCertificateThumbprint
       * verify that the receiverCertificateThumbprint send by the client
       * matching the CertificateThumbPrint of the server
       * @param clientSecurityHeader
       * @return true if the receiver certificate thumbprint matches the server certificate
       * @private
       */
      _check_receiverCertificateThumbprint(clientSecurityHeader) {
        if (clientSecurityHeader instanceof node_opcua_service_secure_channel_1.SymmetricAlgorithmSecurityHeader) {
          return true;
        }
        if (clientSecurityHeader.receiverCertificateThumbprint) {
          const serverCertificate = this.getCertificate();
          const myCertificateThumbPrint = (0, node_opcua_crypto_1.makeSHA1Thumbprint)(serverCertificate);
          const thisIsMyCertificate = myCertificateThumbPrint.toString("hex") === clientSecurityHeader.receiverCertificateThumbprint.toString("hex");
          if (doDebug && !thisIsMyCertificate) {
            debugLog("receiverCertificateThumbprint do not match server certificate", myCertificateThumbPrint.toString("hex") + " <> " + clientSecurityHeader.receiverCertificateThumbprint.toString("hex"));
          }
          return thisIsMyCertificate;
        }
        return true;
      }
      // Bad_CertificateHostNameInvalid            The HostName used to connect to a Server does not match a HostName in the
      //                                           Certificate.
      // Bad_CertificateIssuerRevocationUnknown    It was not possible to determine if the Issuer Certificate has been revoked.
      // Bad_CertificateIssuerUseNotAllowed        The Issuer Certificate may not be used for the requested operation.
      // Bad_CertificateIssuerTimeInvalid          An Issuer Certificate has expired or is not yet valid.
      // Bad_CertificateIssuerRevoked              The Issuer Certificate has been revoked.
      // Bad_CertificateInvalid                    The certificate provided as a parameter is not valid.
      // Bad_CertificateRevocationUnknown          It was not possible to determine if the Certificate has been revoked.
      // Bad_CertificateRevoked                    The Certificate has been revoked.
      // Bad_CertificateTimeInvalid                The Certificate has expired or is not yet valid.
      // Bad_CertificateUriInvalid                 The URI specified in the ApplicationDescription does not match the URI in the Certificate.
      // Bad_CertificateUntrusted                  The Certificate is not trusted.
      // Bad_CertificateUseNotAllowed              The Certificate may not be used for the requested operation.
      // Bad_RequestTypeInvalid     The security token request type is not valid.
      // Bad_SecurityModeRejected   The security mode does not meet the requirements set by the Server.
      // Bad_SecurityPolicyRejected The security policy does not meet the requirements set by the Server.
      // Bad_SecureChannelIdInvalid
      // Bad_NonceInvalid
      _on_OpenSecureChannelRequestError(serviceResult, description, message, callback) {
        debugLog("ServerSecureChannel sendError: ", serviceResult.toString(), description, message.request.constructor.name);
        this.securityMode = node_opcua_service_secure_channel_1.MessageSecurityMode.None;
        setTimeout(() => {
          this.send_response("ERR", new services_1.ServiceFault({
            responseHeader: {
              serviceResult,
              timestamp: /* @__PURE__ */ new Date(),
              stringTable: [description, serviceResult.toString()]
            }
          }), message, () => {
            callback(new Error(description + " statusCode = " + serviceResult.toString()));
          });
        }, _a.throttleTime);
      }
    };
    exports2.ServerSecureChannelLayer = ServerSecureChannelLayer;
    _a = ServerSecureChannelLayer, _ServerSecureChannelLayer_counter = /* @__PURE__ */ new WeakMap(), _ServerSecureChannelLayer_status = /* @__PURE__ */ new WeakMap(), _ServerSecureChannelLayer_open_secure_channel_onceClose = /* @__PURE__ */ new WeakMap(), _ServerSecureChannelLayer_abort_has_been_called = /* @__PURE__ */ new WeakMap(), _ServerSecureChannelLayer_idVerification = /* @__PURE__ */ new WeakMap(), _ServerSecureChannelLayer_transport_socket_close_listener = /* @__PURE__ */ new WeakMap();
    ServerSecureChannelLayer.throttleTime = 100;
    ServerSecureChannelLayer.g_MinimumSecureTokenLifetime = 2500;
    ServerSecureChannelLayer.g_counter = 0;
    ServerSecureChannelLayer.registry = new node_opcua_object_registry_1.ObjectRegistry();
    ServerSecureChannelLayer.prototype.checkCertificateCallback = (0, util_1.callbackify)(ServerSecureChannelLayer.prototype.checkCertificate);
  }
});

// node_modules/node-opcua-secure-channel/dist/source/verify_pcks1.js
var require_verify_pcks1 = __commonJS({
  "node_modules/node-opcua-secure-channel/dist/source/verify_pcks1.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.testRSAPKCS1V15_EncryptDecrypt = void 0;
    var crypto_1 = require("crypto");
    var node_opcua_crypto_1 = require_dist33();
    var node_opcua_debug_1 = require_dist24();
    var security_policy_1 = require_security_policy();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)("NODE-OPCUA-W27");
    function myCreatePrivateKey(rawKey) {
      const retValue = (0, crypto_1.createPrivateKey)(rawKey);
      return { hidden: retValue };
    }
    async function testRSAPKCS1V15_EncryptDecrypt() {
      const version = process.version.match(/v([0-9]+)\.([0-9]+)\.([0-9]+)/);
      if (!version) {
        throw new Error("Invalid version");
      }
      const major = parseInt(version[1], 10);
      const minor = parseInt(version[2], 10);
      const patch = parseInt(version[3], 10);
      if (major < 20) {
        return;
      }
      const keyPair = await crypto_1.subtle.generateKey({
        name: "RSA-OAEP",
        modulusLength: 4096,
        publicExponent: new Uint8Array([1, 0, 1]),
        hash: "SHA-512"
      }, true, ["encrypt", "decrypt"]);
      const exportedPublicKey = await crypto_1.subtle.exportKey("spki", keyPair.publicKey);
      const publicKey = Buffer.from(exportedPublicKey).toString("base64");
      const privateKeyPem = await (0, node_opcua_crypto_1.privateKeyToPEM)(keyPair.privateKey);
      const privateKey = myCreatePrivateKey(privateKeyPem.privPem);
      const buffer = Buffer.from("buffer");
      let decrypted;
      try {
        const encrypted = (0, security_policy_1.RSAPKCS1V15_Encrypt)(buffer, crypto_1.KeyObject.from(keyPair.publicKey));
        decrypted = (0, security_policy_1.RSAPKCS1V15_Decrypt)(encrypted, privateKey);
      } catch (err) {
      }
      if (!decrypted || decrypted.toString("ascii") !== "buffer") {
        warningLog("[NODE-OPCUA-W27]", "node version", process.version);
        warningLog("  you need to use node flag --security-revert=CVE-2023-46809 if you have issue with RSA PKCS#1 v1.5");
      }
    }
    exports2.testRSAPKCS1V15_EncryptDecrypt = testRSAPKCS1V15_EncryptDecrypt;
  }
});

// node_modules/node-opcua-secure-channel/dist/source/index.js
var require_source7 = __commonJS({
  "node_modules/node-opcua-secure-channel/dist/source/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_services(), exports2);
    __exportStar3(require_secure_channel_service(), exports2);
    __exportStar3(require_secure_message_chunk_manager(), exports2);
    __exportStar3(require_security_policy(), exports2);
    __exportStar3(require_sequence_number_generator(), exports2);
    __exportStar3(require_message_builder(), exports2);
    __exportStar3(require_message_header_to_string(), exports2);
    __exportStar3(require_client_secure_channel_layer(), exports2);
    __exportStar3(require_server_secure_channel_layer(), exports2);
    __exportStar3(require_common2(), exports2);
    var verify_pcks1_1 = require_verify_pcks1();
    (0, verify_pcks1_1.testRSAPKCS1V15_EncryptDecrypt)();
  }
});

// node_modules/node-opcua-client/dist/reconnection.js
var require_reconnection = __commonJS({
  "node_modules/node-opcua-client/dist/reconnection.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __setModuleDefault2 = exports2 && exports2.__setModuleDefault || (Object.create ? function(o2, v) {
      Object.defineProperty(o2, "default", { enumerable: true, value: v });
    } : function(o2, v) {
      o2["default"] = v;
    });
    var __importStar3 = exports2 && exports2.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result2 = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
            __createBinding3(result2, mod, k);
      }
      __setModuleDefault2(result2, mod);
      return result2;
    };
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.repair_client_sessions = exports2.repair_client_session = void 0;
    var async = __importStar3(require_async());
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_service_subscription_1 = require_dist45();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_client_dynamic_extension_object_1 = require_dist56();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)("RECONNECTION");
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)("RECONNECTION");
    var errorLog = (0, node_opcua_debug_1.make_errorLog)("RECONNECTION");
    var warningLog = (0, node_opcua_debug_1.make_warningLog)("RECONNECTION");
    function _ask_for_subscription_republish(session, callback) {
      if (session.hasBeenClosed()) {
        doDebug && debugLog("_ask_for_subscription_republish :  session is closed");
        return callback(new Error("askForSubscriptionRepublish => canceled because session is closed"));
      }
      doDebug && debugLog(chalk_1.default.bgCyan.yellow.bold("_ask_for_subscription_republish "));
      session.getPublishEngine().republish((err) => {
        doDebug && debugLog("_ask_for_subscription_republish :  republish sent");
        if (session.hasBeenClosed()) {
          return callback(new Error("Cannot complete subscription republish due to session termination"));
        }
        doDebug && debugLog(chalk_1.default.bgCyan.green.bold("_ask_for_subscription_republish done "), err ? err.message : "OK");
        if (err) {
          warningLog("republish has failed with error :", err.message);
          doDebug && debugLog("_ask_for_subscription_republish has :  recreating subscription");
          return repair_client_session_by_recreating_a_new_session(session._client, session, callback);
        }
        session.resumePublishEngine();
        callback(err);
      });
    }
    function create_session_and_repeat_if_failed(client2, session, callback) {
      if (session.hasBeenClosed()) {
        doDebug && debugLog("Cannot complete subscription republish due to session termination");
        return callback(new Error("Cannot complete subscription republish due to session termination"));
      }
      doDebug && debugLog(chalk_1.default.bgWhite.red("    => creating a new session ...."));
      client2.__createSession_step2(session, (err, session1) => {
        if (err && session.hasBeenClosed()) {
          doDebug && debugLog("Cannot complete subscription republish due to session termination");
          return callback(new Error("Cannot complete subscription republish due to session termination"));
        }
        if (!err && session1) {
          (0, node_opcua_assert_1.assert)(session === session1, "session should have been recycled");
          callback(err, session);
          return;
        } else {
          doDebug && debugLog("Cannot complete subscription republish err = ", err?.message);
          callback(err);
        }
      });
    }
    function repair_client_session_by_recreating_a_new_session(client2, session, callback) {
      if (session._client && session._client.isUnusable()) {
        return callback(new Error("Client is unusable"));
      }
      (0, node_opcua_client_dynamic_extension_object_1.invalidateExtraDataTypeManager)(session);
      if (doDebug) {
        debugLog(" repairing client session by_recreating a new session for old session ", session.sessionId.toString());
      }
      if (session.hasBeenClosed()) {
        doDebug && debugLog(chalk_1.default.bgWhite.red("Aborting reactivation of old session because user requested session to be closed"));
        return callback(new Error("reconnection cancelled due to session termination"));
      }
      let newSession;
      const listenerCountBefore = session.listenerCount("");
      function recreateSubscription(subscriptionsToRecreate, innerCallback) {
        async.forEach(subscriptionsToRecreate, (subscriptionId, next) => {
          if (!session.getPublishEngine().hasSubscription(subscriptionId)) {
            doDebug && debugLog(chalk_1.default.red("          => CANNOT RECREATE SUBSCRIPTION  "), subscriptionId);
            return next();
          }
          const subscription = session.getPublishEngine().getSubscription(subscriptionId);
          (0, node_opcua_assert_1.assert)(subscription.constructor.name === "ClientSubscriptionImpl");
          doDebug && debugLog(chalk_1.default.red("          => RECREATING SUBSCRIPTION  "), subscriptionId);
          (0, node_opcua_assert_1.assert)(subscription.session === newSession, "must have the session");
          subscription.recreateSubscriptionAndMonitoredItem((err1) => {
            if (err1) {
              doDebug && debugLog("_recreateSubscription failed !" + err1.message);
            }
            doDebug && debugLog(chalk_1.default.cyan("          => RECREATING SUBSCRIPTION  AND MONITORED ITEM DONE "), subscriptionId);
            next();
          });
        }, (err1) => {
          innerCallback(err1);
        });
      }
      async.series([
        function suspend_old_session_publish_engine(innerCallback) {
          if (session.hasBeenClosed()) {
            return innerCallback(new Error("Cannot complete subscription republish due to session termination"));
          }
          doDebug && debugLog(chalk_1.default.bgWhite.red("    => suspend old session publish engine...."));
          session.getPublishEngine().suspend(true);
          innerCallback();
        },
        function create_new_session(innerCallback) {
          create_session_and_repeat_if_failed(client2, session, (err, _newSession) => {
            if (_newSession) {
              newSession = _newSession;
            }
            innerCallback(err || void 0);
          });
        },
        function activate_new_session(innerCallback) {
          if (session.hasBeenClosed()) {
            return innerCallback(new Error("Cannot complete subscription republish due to session termination"));
          }
          doDebug && debugLog(chalk_1.default.bgWhite.red("    => activating a new session ...."));
          client2._activateSession(newSession, newSession.userIdentityInfo, (err, session1) => {
            doDebug && debugLog("    =>  activating a new session .... Done err=", err ? err.message : "null");
            if (err) {
              doDebug && debugLog("reactivation of the new session has failed: let be smart and close it before failing this repair attempt");
              const closeSessionRequest = new node_opcua_types_1.CloseSessionRequest({
                requestHeader: {
                  authenticationToken: newSession.authenticationToken
                },
                deleteSubscriptions: true
              });
              newSession._client.performMessageTransaction(closeSessionRequest, (err2) => {
                if (err2) {
                  warningLog("closing session", err2.message);
                }
                doDebug && debugLog("the temporary replacement session is now closed");
                doDebug && debugLog(" err ", err.message, "propagated upwards");
                innerCallback(err);
              });
            } else {
              innerCallback(err ? err : void 0);
            }
          });
        },
        function attempt_subscription_transfer(innerCallback) {
          if (session.hasBeenClosed()) {
            return innerCallback(new Error("Cannot complete subscription republish due to session termination"));
          }
          const subscriptionsIds = session.getPublishEngine().getSubscriptionIds();
          doDebug && debugLog("  session subscriptionCount = ", newSession.getPublishEngine().subscriptionCount);
          if (subscriptionsIds.length === 0) {
            doDebug && debugLog(" No subscriptions => skipping transfer subscriptions");
            return innerCallback();
          }
          doDebug && debugLog("    => asking server to transfer subscriptions = [", subscriptionsIds.join(", "), "]");
          const subscriptionsToTransfer = new node_opcua_service_subscription_1.TransferSubscriptionsRequest({
            sendInitialValues: true,
            subscriptionIds: subscriptionsIds
          });
          if (newSession.getPublishEngine().nbPendingPublishRequests !== 0) {
            warningLog("Warning : we should not be publishing here");
          }
          newSession.transferSubscriptions(subscriptionsToTransfer, (err, transferSubscriptionsResponse) => {
            if (err || !transferSubscriptionsResponse) {
              warningLog(chalk_1.default.bgCyan("Warning TransferSubscription has failed " + err?.message));
              warningLog(chalk_1.default.bgCyan("May be the server is not supporting this feature"));
              const subscriptionsToRecreate2 = [...subscriptionsToTransfer.subscriptionIds || []];
              warningLog(chalk_1.default.bgCyan("We need to recreate entirely the subscription"));
              recreateSubscription(subscriptionsToRecreate2, innerCallback);
              return;
            }
            const results = transferSubscriptionsResponse.results || [];
            if (doDebug) {
              debugLog(chalk_1.default.cyan("    =>  transfer subscriptions  done"), results.map((x2) => x2.statusCode.toString()).join(" "));
            }
            const subscriptionsToRecreate = [];
            for (let i = 0; i < results.length; i++) {
              const statusCode = results[i].statusCode;
              if (statusCode.equals(node_opcua_status_code_1.StatusCodes.BadSubscriptionIdInvalid)) {
                doDebug && debugLog(chalk_1.default.red("         WARNING SUBSCRIPTION  "), subscriptionsIds[i], chalk_1.default.red(" SHOULD BE RECREATED"));
                subscriptionsToRecreate.push(subscriptionsIds[i]);
              } else {
                const availableSequenceNumbers = results[i].availableSequenceNumbers;
                doDebug && debugLog(chalk_1.default.green("         SUBSCRIPTION "), subscriptionsIds[i], chalk_1.default.green(" CAN BE REPAIRED AND AVAILABLE "), availableSequenceNumbers);
              }
            }
            doDebug && debugLog("  new session subscriptionCount = ", newSession.getPublishEngine().subscriptionCount);
            recreateSubscription(subscriptionsToRecreate, innerCallback);
          });
        },
        function ask_for_subscription_republish(innerCallback) {
          if (session.hasBeenClosed()) {
            return innerCallback(new Error("Cannot complete subscription republish due to session termination"));
          }
          return _ask_for_subscription_republish(newSession, (err) => {
            if (err) {
              warningLog("warning: Subscription republished has failed ", err.message);
            }
            innerCallback(err);
          });
        },
        function start_publishing_as_normal(innerCallback) {
          if (session.hasBeenClosed()) {
            return innerCallback(new Error("Cannot complete subscription republish due to session termination"));
          }
          newSession.getPublishEngine().suspend(false);
          const listenerCountAfter = session.listenerCount("");
          (0, node_opcua_assert_1.assert)(newSession === session);
          doDebug && debugLog("listenerCountBefore =", listenerCountBefore, "listenerCountAfter = ", listenerCountAfter);
          innerCallback();
        }
      ], (err) => {
        doDebug && err && debugLog("repair_client_session_by_recreating_a_new_session failed with ", err.message);
        callback(err);
      });
    }
    function _repair_client_session(client2, session, callback) {
      const callback2 = (err2) => {
        doDebug && debugLog("Session repair completed with err: ", err2 ? err2.message : "<no error>", session.sessionId.toString());
        if (!err2) {
          session.emit("session_repaired");
        }
        callback(err2);
      };
      if (doDebug) {
        doDebug && debugLog(chalk_1.default.yellow("  TRYING TO REACTIVATE EXISTING SESSION"), session.sessionId.toString());
        doDebug && debugLog("   SubscriptionIds :", session.getPublishEngine().getSubscriptionIds());
      }
      client2._activateSession(session, session.userIdentityInfo, (err, session2) => {
        doDebug && debugLog("   ActivateSession : ", err ? chalk_1.default.red(err.message) : chalk_1.default.green(" SUCCESS !!! "));
        if (err) {
          return repair_client_session_by_recreating_a_new_session(client2, session, callback2);
        } else {
          return _ask_for_subscription_republish(session, callback2);
        }
      });
    }
    function repair_client_session(client2, session, callback) {
      if (!client2) {
        doDebug && debugLog("Aborting reactivation of old session because user requested session to be close");
        return callback();
      }
      doDebug && debugLog(chalk_1.default.yellow("Starting client session repair"));
      const privateSession = session;
      privateSession._reconnecting = privateSession._reconnecting || { reconnecting: false, pendingCallbacks: [] };
      if (privateSession._reconnecting.reconnecting) {
        doDebug && debugLog(chalk_1.default.bgCyan("Reconnecting already happening for session"), session.sessionId.toString());
        privateSession._reconnecting.pendingCallbacks.push(callback);
        return;
      }
      privateSession._reconnecting.reconnecting = true;
      const transactionQueue = privateSession.pendingTransactions ? privateSession.pendingTransactions.splice(0) : [];
      const repeatedAction = (callback2) => {
        _repair_client_session(client2, session, (err) => {
          if (err) {
            errorLog(chalk_1.default.red("session restoration has failed! err ="), err.message, session.sessionId.toString(), " => Let's retry");
            if (!session.hasBeenClosed()) {
              const delay = 2e3;
              errorLog(chalk_1.default.red(`... will retry session repair... in ${delay} ms`));
              setTimeout(() => {
                errorLog(chalk_1.default.red("Retrying session repair..."));
                repeatedAction(callback2);
              }, delay);
              return;
            } else {
              errorLog(chalk_1.default.red("session restoration should be interrupted because session has been closed forcefully"));
              callback2();
            }
            return;
          }
          privateSession._reconnecting.reconnecting = false;
          doDebug && debugLog(chalk_1.default.yellow("session has been restored"), session.sessionId.toString());
          session.emit("session_restored");
          const otherCallbacks = privateSession._reconnecting.pendingCallbacks;
          privateSession._reconnecting.pendingCallbacks = [];
          doDebug && debugLog(chalk_1.default.yellow("re-injecting transaction queue"), transactionQueue.length);
          transactionQueue.forEach((e) => privateSession.pendingTransactions.push(e));
          otherCallbacks.forEach((c2) => c2(err));
          callback2(err);
        });
      };
      repeatedAction(callback);
    }
    exports2.repair_client_session = repair_client_session;
    function repair_client_sessions(client2, callback) {
      const sessions = client2.getSessions();
      doDebug && debugLog(chalk_1.default.red.bgWhite(" Starting sessions reactivation", sessions.length));
      async.map(sessions, (session, next) => {
        repair_client_session(client2, session, (err) => {
          next(null, err);
        });
      }, (err, allErrors) => {
        err && errorLog("sessions reactivation completed with err: err ", err ? err.message : "null");
        return callback(err);
      });
    }
    exports2.repair_client_sessions = repair_client_sessions;
  }
});

// node_modules/graceful-fs/polyfills.js
var require_polyfills = __commonJS({
  "node_modules/graceful-fs/polyfills.js"(exports2, module2) {
    var constants = require("constants");
    var origCwd = process.cwd;
    var cwd = null;
    var platform = process.env.GRACEFUL_FS_PLATFORM || process.platform;
    process.cwd = function() {
      if (!cwd)
        cwd = origCwd.call(process);
      return cwd;
    };
    try {
      process.cwd();
    } catch (er) {
    }
    if (typeof process.chdir === "function") {
      chdir = process.chdir;
      process.chdir = function(d2) {
        cwd = null;
        chdir.call(process, d2);
      };
      if (Object.setPrototypeOf)
        Object.setPrototypeOf(process.chdir, chdir);
    }
    var chdir;
    module2.exports = patch;
    function patch(fs2) {
      if (constants.hasOwnProperty("O_SYMLINK") && process.version.match(/^v0\.6\.[0-2]|^v0\.5\./)) {
        patchLchmod(fs2);
      }
      if (!fs2.lutimes) {
        patchLutimes(fs2);
      }
      fs2.chown = chownFix(fs2.chown);
      fs2.fchown = chownFix(fs2.fchown);
      fs2.lchown = chownFix(fs2.lchown);
      fs2.chmod = chmodFix(fs2.chmod);
      fs2.fchmod = chmodFix(fs2.fchmod);
      fs2.lchmod = chmodFix(fs2.lchmod);
      fs2.chownSync = chownFixSync(fs2.chownSync);
      fs2.fchownSync = chownFixSync(fs2.fchownSync);
      fs2.lchownSync = chownFixSync(fs2.lchownSync);
      fs2.chmodSync = chmodFixSync(fs2.chmodSync);
      fs2.fchmodSync = chmodFixSync(fs2.fchmodSync);
      fs2.lchmodSync = chmodFixSync(fs2.lchmodSync);
      fs2.stat = statFix(fs2.stat);
      fs2.fstat = statFix(fs2.fstat);
      fs2.lstat = statFix(fs2.lstat);
      fs2.statSync = statFixSync(fs2.statSync);
      fs2.fstatSync = statFixSync(fs2.fstatSync);
      fs2.lstatSync = statFixSync(fs2.lstatSync);
      if (fs2.chmod && !fs2.lchmod) {
        fs2.lchmod = function(path3, mode, cb) {
          if (cb)
            process.nextTick(cb);
        };
        fs2.lchmodSync = function() {
        };
      }
      if (fs2.chown && !fs2.lchown) {
        fs2.lchown = function(path3, uid, gid, cb) {
          if (cb)
            process.nextTick(cb);
        };
        fs2.lchownSync = function() {
        };
      }
      if (platform === "win32") {
        fs2.rename = typeof fs2.rename !== "function" ? fs2.rename : function(fs$rename) {
          function rename(from, to, cb) {
            var start = Date.now();
            var backoff = 0;
            fs$rename(from, to, function CB(er) {
              if (er && (er.code === "EACCES" || er.code === "EPERM" || er.code === "EBUSY") && Date.now() - start < 6e4) {
                setTimeout(function() {
                  fs2.stat(to, function(stater, st) {
                    if (stater && stater.code === "ENOENT")
                      fs$rename(from, to, CB);
                    else
                      cb(er);
                  });
                }, backoff);
                if (backoff < 100)
                  backoff += 10;
                return;
              }
              if (cb)
                cb(er);
            });
          }
          if (Object.setPrototypeOf)
            Object.setPrototypeOf(rename, fs$rename);
          return rename;
        }(fs2.rename);
      }
      fs2.read = typeof fs2.read !== "function" ? fs2.read : function(fs$read) {
        function read(fd, buffer, offset, length, position, callback_) {
          var callback;
          if (callback_ && typeof callback_ === "function") {
            var eagCounter = 0;
            callback = function(er, _, __) {
              if (er && er.code === "EAGAIN" && eagCounter < 10) {
                eagCounter++;
                return fs$read.call(fs2, fd, buffer, offset, length, position, callback);
              }
              callback_.apply(this, arguments);
            };
          }
          return fs$read.call(fs2, fd, buffer, offset, length, position, callback);
        }
        if (Object.setPrototypeOf)
          Object.setPrototypeOf(read, fs$read);
        return read;
      }(fs2.read);
      fs2.readSync = typeof fs2.readSync !== "function" ? fs2.readSync : /* @__PURE__ */ function(fs$readSync) {
        return function(fd, buffer, offset, length, position) {
          var eagCounter = 0;
          while (true) {
            try {
              return fs$readSync.call(fs2, fd, buffer, offset, length, position);
            } catch (er) {
              if (er.code === "EAGAIN" && eagCounter < 10) {
                eagCounter++;
                continue;
              }
              throw er;
            }
          }
        };
      }(fs2.readSync);
      function patchLchmod(fs3) {
        fs3.lchmod = function(path3, mode, callback) {
          fs3.open(
            path3,
            constants.O_WRONLY | constants.O_SYMLINK,
            mode,
            function(err, fd) {
              if (err) {
                if (callback)
                  callback(err);
                return;
              }
              fs3.fchmod(fd, mode, function(err2) {
                fs3.close(fd, function(err22) {
                  if (callback)
                    callback(err2 || err22);
                });
              });
            }
          );
        };
        fs3.lchmodSync = function(path3, mode) {
          var fd = fs3.openSync(path3, constants.O_WRONLY | constants.O_SYMLINK, mode);
          var threw = true;
          var ret;
          try {
            ret = fs3.fchmodSync(fd, mode);
            threw = false;
          } finally {
            if (threw) {
              try {
                fs3.closeSync(fd);
              } catch (er) {
              }
            } else {
              fs3.closeSync(fd);
            }
          }
          return ret;
        };
      }
      function patchLutimes(fs3) {
        if (constants.hasOwnProperty("O_SYMLINK") && fs3.futimes) {
          fs3.lutimes = function(path3, at, mt, cb) {
            fs3.open(path3, constants.O_SYMLINK, function(er, fd) {
              if (er) {
                if (cb)
                  cb(er);
                return;
              }
              fs3.futimes(fd, at, mt, function(er2) {
                fs3.close(fd, function(er22) {
                  if (cb)
                    cb(er2 || er22);
                });
              });
            });
          };
          fs3.lutimesSync = function(path3, at, mt) {
            var fd = fs3.openSync(path3, constants.O_SYMLINK);
            var ret;
            var threw = true;
            try {
              ret = fs3.futimesSync(fd, at, mt);
              threw = false;
            } finally {
              if (threw) {
                try {
                  fs3.closeSync(fd);
                } catch (er) {
                }
              } else {
                fs3.closeSync(fd);
              }
            }
            return ret;
          };
        } else if (fs3.futimes) {
          fs3.lutimes = function(_a, _b, _c, cb) {
            if (cb)
              process.nextTick(cb);
          };
          fs3.lutimesSync = function() {
          };
        }
      }
      function chmodFix(orig) {
        if (!orig)
          return orig;
        return function(target, mode, cb) {
          return orig.call(fs2, target, mode, function(er) {
            if (chownErOk(er))
              er = null;
            if (cb)
              cb.apply(this, arguments);
          });
        };
      }
      function chmodFixSync(orig) {
        if (!orig)
          return orig;
        return function(target, mode) {
          try {
            return orig.call(fs2, target, mode);
          } catch (er) {
            if (!chownErOk(er))
              throw er;
          }
        };
      }
      function chownFix(orig) {
        if (!orig)
          return orig;
        return function(target, uid, gid, cb) {
          return orig.call(fs2, target, uid, gid, function(er) {
            if (chownErOk(er))
              er = null;
            if (cb)
              cb.apply(this, arguments);
          });
        };
      }
      function chownFixSync(orig) {
        if (!orig)
          return orig;
        return function(target, uid, gid) {
          try {
            return orig.call(fs2, target, uid, gid);
          } catch (er) {
            if (!chownErOk(er))
              throw er;
          }
        };
      }
      function statFix(orig) {
        if (!orig)
          return orig;
        return function(target, options, cb) {
          if (typeof options === "function") {
            cb = options;
            options = null;
          }
          function callback(er, stats) {
            if (stats) {
              if (stats.uid < 0)
                stats.uid += 4294967296;
              if (stats.gid < 0)
                stats.gid += 4294967296;
            }
            if (cb)
              cb.apply(this, arguments);
          }
          return options ? orig.call(fs2, target, options, callback) : orig.call(fs2, target, callback);
        };
      }
      function statFixSync(orig) {
        if (!orig)
          return orig;
        return function(target, options) {
          var stats = options ? orig.call(fs2, target, options) : orig.call(fs2, target);
          if (stats) {
            if (stats.uid < 0)
              stats.uid += 4294967296;
            if (stats.gid < 0)
              stats.gid += 4294967296;
          }
          return stats;
        };
      }
      function chownErOk(er) {
        if (!er)
          return true;
        if (er.code === "ENOSYS")
          return true;
        var nonroot = !process.getuid || process.getuid() !== 0;
        if (nonroot) {
          if (er.code === "EINVAL" || er.code === "EPERM")
            return true;
        }
        return false;
      }
    }
  }
});

// node_modules/graceful-fs/legacy-streams.js
var require_legacy_streams = __commonJS({
  "node_modules/graceful-fs/legacy-streams.js"(exports2, module2) {
    var Stream = require("stream").Stream;
    module2.exports = legacy;
    function legacy(fs2) {
      return {
        ReadStream,
        WriteStream
      };
      function ReadStream(path3, options) {
        if (!(this instanceof ReadStream))
          return new ReadStream(path3, options);
        Stream.call(this);
        var self2 = this;
        this.path = path3;
        this.fd = null;
        this.readable = true;
        this.paused = false;
        this.flags = "r";
        this.mode = 438;
        this.bufferSize = 64 * 1024;
        options = options || {};
        var keys = Object.keys(options);
        for (var index = 0, length = keys.length; index < length; index++) {
          var key = keys[index];
          this[key] = options[key];
        }
        if (this.encoding)
          this.setEncoding(this.encoding);
        if (this.start !== void 0) {
          if ("number" !== typeof this.start) {
            throw TypeError("start must be a Number");
          }
          if (this.end === void 0) {
            this.end = Infinity;
          } else if ("number" !== typeof this.end) {
            throw TypeError("end must be a Number");
          }
          if (this.start > this.end) {
            throw new Error("start must be <= end");
          }
          this.pos = this.start;
        }
        if (this.fd !== null) {
          process.nextTick(function() {
            self2._read();
          });
          return;
        }
        fs2.open(this.path, this.flags, this.mode, function(err, fd) {
          if (err) {
            self2.emit("error", err);
            self2.readable = false;
            return;
          }
          self2.fd = fd;
          self2.emit("open", fd);
          self2._read();
        });
      }
      function WriteStream(path3, options) {
        if (!(this instanceof WriteStream))
          return new WriteStream(path3, options);
        Stream.call(this);
        this.path = path3;
        this.fd = null;
        this.writable = true;
        this.flags = "w";
        this.encoding = "binary";
        this.mode = 438;
        this.bytesWritten = 0;
        options = options || {};
        var keys = Object.keys(options);
        for (var index = 0, length = keys.length; index < length; index++) {
          var key = keys[index];
          this[key] = options[key];
        }
        if (this.start !== void 0) {
          if ("number" !== typeof this.start) {
            throw TypeError("start must be a Number");
          }
          if (this.start < 0) {
            throw new Error("start must be >= zero");
          }
          this.pos = this.start;
        }
        this.busy = false;
        this._queue = [];
        if (this.fd === null) {
          this._open = fs2.open;
          this._queue.push([this._open, this.path, this.flags, this.mode, void 0]);
          this.flush();
        }
      }
    }
  }
});

// node_modules/graceful-fs/clone.js
var require_clone = __commonJS({
  "node_modules/graceful-fs/clone.js"(exports2, module2) {
    "use strict";
    module2.exports = clone;
    var getPrototypeOf = Object.getPrototypeOf || function(obj) {
      return obj.__proto__;
    };
    function clone(obj) {
      if (obj === null || typeof obj !== "object")
        return obj;
      if (obj instanceof Object)
        var copy = { __proto__: getPrototypeOf(obj) };
      else
        var copy = /* @__PURE__ */ Object.create(null);
      Object.getOwnPropertyNames(obj).forEach(function(key) {
        Object.defineProperty(copy, key, Object.getOwnPropertyDescriptor(obj, key));
      });
      return copy;
    }
  }
});

// node_modules/graceful-fs/graceful-fs.js
var require_graceful_fs = __commonJS({
  "node_modules/graceful-fs/graceful-fs.js"(exports2, module2) {
    var fs2 = require("fs");
    var polyfills = require_polyfills();
    var legacy = require_legacy_streams();
    var clone = require_clone();
    var util = require("util");
    var gracefulQueue;
    var previousSymbol;
    if (typeof Symbol === "function" && typeof Symbol.for === "function") {
      gracefulQueue = Symbol.for("graceful-fs.queue");
      previousSymbol = Symbol.for("graceful-fs.previous");
    } else {
      gracefulQueue = "___graceful-fs.queue";
      previousSymbol = "___graceful-fs.previous";
    }
    function noop() {
    }
    function publishQueue(context, queue2) {
      Object.defineProperty(context, gracefulQueue, {
        get: function() {
          return queue2;
        }
      });
    }
    var debug = noop;
    if (util.debuglog)
      debug = util.debuglog("gfs4");
    else if (/\bgfs4\b/i.test(process.env.NODE_DEBUG || ""))
      debug = function() {
        var m2 = util.format.apply(util, arguments);
        m2 = "GFS4: " + m2.split(/\n/).join("\nGFS4: ");
        console.error(m2);
      };
    if (!fs2[gracefulQueue]) {
      queue = global[gracefulQueue] || [];
      publishQueue(fs2, queue);
      fs2.close = function(fs$close) {
        function close(fd, cb) {
          return fs$close.call(fs2, fd, function(err) {
            if (!err) {
              resetQueue();
            }
            if (typeof cb === "function")
              cb.apply(this, arguments);
          });
        }
        Object.defineProperty(close, previousSymbol, {
          value: fs$close
        });
        return close;
      }(fs2.close);
      fs2.closeSync = function(fs$closeSync) {
        function closeSync(fd) {
          fs$closeSync.apply(fs2, arguments);
          resetQueue();
        }
        Object.defineProperty(closeSync, previousSymbol, {
          value: fs$closeSync
        });
        return closeSync;
      }(fs2.closeSync);
      if (/\bgfs4\b/i.test(process.env.NODE_DEBUG || "")) {
        process.on("exit", function() {
          debug(fs2[gracefulQueue]);
          require("assert").equal(fs2[gracefulQueue].length, 0);
        });
      }
    }
    var queue;
    if (!global[gracefulQueue]) {
      publishQueue(global, fs2[gracefulQueue]);
    }
    module2.exports = patch(clone(fs2));
    if (process.env.TEST_GRACEFUL_FS_GLOBAL_PATCH && !fs2.__patched) {
      module2.exports = patch(fs2);
      fs2.__patched = true;
    }
    function patch(fs3) {
      polyfills(fs3);
      fs3.gracefulify = patch;
      fs3.createReadStream = createReadStream2;
      fs3.createWriteStream = createWriteStream;
      var fs$readFile = fs3.readFile;
      fs3.readFile = readFile;
      function readFile(path3, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        return go$readFile(path3, options, cb);
        function go$readFile(path4, options2, cb2, startTime) {
          return fs$readFile(path4, options2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$readFile, [path4, options2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      var fs$writeFile = fs3.writeFile;
      fs3.writeFile = writeFile;
      function writeFile(path3, data, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        return go$writeFile(path3, data, options, cb);
        function go$writeFile(path4, data2, options2, cb2, startTime) {
          return fs$writeFile(path4, data2, options2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$writeFile, [path4, data2, options2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      var fs$appendFile = fs3.appendFile;
      if (fs$appendFile)
        fs3.appendFile = appendFile;
      function appendFile(path3, data, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        return go$appendFile(path3, data, options, cb);
        function go$appendFile(path4, data2, options2, cb2, startTime) {
          return fs$appendFile(path4, data2, options2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$appendFile, [path4, data2, options2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      var fs$copyFile = fs3.copyFile;
      if (fs$copyFile)
        fs3.copyFile = copyFile;
      function copyFile(src, dest, flags, cb) {
        if (typeof flags === "function") {
          cb = flags;
          flags = 0;
        }
        return go$copyFile(src, dest, flags, cb);
        function go$copyFile(src2, dest2, flags2, cb2, startTime) {
          return fs$copyFile(src2, dest2, flags2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$copyFile, [src2, dest2, flags2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      var fs$readdir = fs3.readdir;
      fs3.readdir = readdir;
      var noReaddirOptionVersions = /^v[0-5]\./;
      function readdir(path3, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        var go$readdir = noReaddirOptionVersions.test(process.version) ? function go$readdir2(path4, options2, cb2, startTime) {
          return fs$readdir(path4, fs$readdirCallback(
            path4,
            options2,
            cb2,
            startTime
          ));
        } : function go$readdir2(path4, options2, cb2, startTime) {
          return fs$readdir(path4, options2, fs$readdirCallback(
            path4,
            options2,
            cb2,
            startTime
          ));
        };
        return go$readdir(path3, options, cb);
        function fs$readdirCallback(path4, options2, cb2, startTime) {
          return function(err, files) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([
                go$readdir,
                [path4, options2, cb2],
                err,
                startTime || Date.now(),
                Date.now()
              ]);
            else {
              if (files && files.sort)
                files.sort();
              if (typeof cb2 === "function")
                cb2.call(this, err, files);
            }
          };
        }
      }
      if (process.version.substr(0, 4) === "v0.8") {
        var legStreams = legacy(fs3);
        ReadStream = legStreams.ReadStream;
        WriteStream = legStreams.WriteStream;
      }
      var fs$ReadStream = fs3.ReadStream;
      if (fs$ReadStream) {
        ReadStream.prototype = Object.create(fs$ReadStream.prototype);
        ReadStream.prototype.open = ReadStream$open;
      }
      var fs$WriteStream = fs3.WriteStream;
      if (fs$WriteStream) {
        WriteStream.prototype = Object.create(fs$WriteStream.prototype);
        WriteStream.prototype.open = WriteStream$open;
      }
      Object.defineProperty(fs3, "ReadStream", {
        get: function() {
          return ReadStream;
        },
        set: function(val) {
          ReadStream = val;
        },
        enumerable: true,
        configurable: true
      });
      Object.defineProperty(fs3, "WriteStream", {
        get: function() {
          return WriteStream;
        },
        set: function(val) {
          WriteStream = val;
        },
        enumerable: true,
        configurable: true
      });
      var FileReadStream = ReadStream;
      Object.defineProperty(fs3, "FileReadStream", {
        get: function() {
          return FileReadStream;
        },
        set: function(val) {
          FileReadStream = val;
        },
        enumerable: true,
        configurable: true
      });
      var FileWriteStream = WriteStream;
      Object.defineProperty(fs3, "FileWriteStream", {
        get: function() {
          return FileWriteStream;
        },
        set: function(val) {
          FileWriteStream = val;
        },
        enumerable: true,
        configurable: true
      });
      function ReadStream(path3, options) {
        if (this instanceof ReadStream)
          return fs$ReadStream.apply(this, arguments), this;
        else
          return ReadStream.apply(Object.create(ReadStream.prototype), arguments);
      }
      function ReadStream$open() {
        var that = this;
        open(that.path, that.flags, that.mode, function(err, fd) {
          if (err) {
            if (that.autoClose)
              that.destroy();
            that.emit("error", err);
          } else {
            that.fd = fd;
            that.emit("open", fd);
            that.read();
          }
        });
      }
      function WriteStream(path3, options) {
        if (this instanceof WriteStream)
          return fs$WriteStream.apply(this, arguments), this;
        else
          return WriteStream.apply(Object.create(WriteStream.prototype), arguments);
      }
      function WriteStream$open() {
        var that = this;
        open(that.path, that.flags, that.mode, function(err, fd) {
          if (err) {
            that.destroy();
            that.emit("error", err);
          } else {
            that.fd = fd;
            that.emit("open", fd);
          }
        });
      }
      function createReadStream2(path3, options) {
        return new fs3.ReadStream(path3, options);
      }
      function createWriteStream(path3, options) {
        return new fs3.WriteStream(path3, options);
      }
      var fs$open = fs3.open;
      fs3.open = open;
      function open(path3, flags, mode, cb) {
        if (typeof mode === "function")
          cb = mode, mode = null;
        return go$open(path3, flags, mode, cb);
        function go$open(path4, flags2, mode2, cb2, startTime) {
          return fs$open(path4, flags2, mode2, function(err, fd) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$open, [path4, flags2, mode2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      return fs3;
    }
    function enqueue(elem) {
      debug("ENQUEUE", elem[0].name, elem[1]);
      fs2[gracefulQueue].push(elem);
      retry();
    }
    var retryTimer;
    function resetQueue() {
      var now = Date.now();
      for (var i = 0; i < fs2[gracefulQueue].length; ++i) {
        if (fs2[gracefulQueue][i].length > 2) {
          fs2[gracefulQueue][i][3] = now;
          fs2[gracefulQueue][i][4] = now;
        }
      }
      retry();
    }
    function retry() {
      clearTimeout(retryTimer);
      retryTimer = void 0;
      if (fs2[gracefulQueue].length === 0)
        return;
      var elem = fs2[gracefulQueue].shift();
      var fn = elem[0];
      var args = elem[1];
      var err = elem[2];
      var startTime = elem[3];
      var lastTime = elem[4];
      if (startTime === void 0) {
        debug("RETRY", fn.name, args);
        fn.apply(null, args);
      } else if (Date.now() - startTime >= 6e4) {
        debug("TIMEOUT", fn.name, args);
        var cb = args.pop();
        if (typeof cb === "function")
          cb.call(null, err);
      } else {
        var sinceAttempt = Date.now() - lastTime;
        var sinceStart = Math.max(lastTime - startTime, 1);
        var desiredDelay = Math.min(sinceStart * 1.2, 100);
        if (sinceAttempt >= desiredDelay) {
          debug("RETRY", fn.name, args);
          fn.apply(null, args.concat([startTime]));
        } else {
          fs2[gracefulQueue].push(elem);
        }
      }
      if (retryTimer === void 0) {
        retryTimer = setTimeout(retry, 0);
      }
    }
  }
});

// node_modules/retry/lib/retry_operation.js
var require_retry_operation = __commonJS({
  "node_modules/retry/lib/retry_operation.js"(exports2, module2) {
    function RetryOperation(timeouts, options) {
      if (typeof options === "boolean") {
        options = { forever: options };
      }
      this._originalTimeouts = JSON.parse(JSON.stringify(timeouts));
      this._timeouts = timeouts;
      this._options = options || {};
      this._maxRetryTime = options && options.maxRetryTime || Infinity;
      this._fn = null;
      this._errors = [];
      this._attempts = 1;
      this._operationTimeout = null;
      this._operationTimeoutCb = null;
      this._timeout = null;
      this._operationStart = null;
      if (this._options.forever) {
        this._cachedTimeouts = this._timeouts.slice(0);
      }
    }
    module2.exports = RetryOperation;
    RetryOperation.prototype.reset = function() {
      this._attempts = 1;
      this._timeouts = this._originalTimeouts;
    };
    RetryOperation.prototype.stop = function() {
      if (this._timeout) {
        clearTimeout(this._timeout);
      }
      this._timeouts = [];
      this._cachedTimeouts = null;
    };
    RetryOperation.prototype.retry = function(err) {
      if (this._timeout) {
        clearTimeout(this._timeout);
      }
      if (!err) {
        return false;
      }
      var currentTime = (/* @__PURE__ */ new Date()).getTime();
      if (err && currentTime - this._operationStart >= this._maxRetryTime) {
        this._errors.unshift(new Error("RetryOperation timeout occurred"));
        return false;
      }
      this._errors.push(err);
      var timeout = this._timeouts.shift();
      if (timeout === void 0) {
        if (this._cachedTimeouts) {
          this._errors.splice(this._errors.length - 1, this._errors.length);
          this._timeouts = this._cachedTimeouts.slice(0);
          timeout = this._timeouts.shift();
        } else {
          return false;
        }
      }
      var self2 = this;
      var timer = setTimeout(function() {
        self2._attempts++;
        if (self2._operationTimeoutCb) {
          self2._timeout = setTimeout(function() {
            self2._operationTimeoutCb(self2._attempts);
          }, self2._operationTimeout);
          if (self2._options.unref) {
            self2._timeout.unref();
          }
        }
        self2._fn(self2._attempts);
      }, timeout);
      if (this._options.unref) {
        timer.unref();
      }
      return true;
    };
    RetryOperation.prototype.attempt = function(fn, timeoutOps) {
      this._fn = fn;
      if (timeoutOps) {
        if (timeoutOps.timeout) {
          this._operationTimeout = timeoutOps.timeout;
        }
        if (timeoutOps.cb) {
          this._operationTimeoutCb = timeoutOps.cb;
        }
      }
      var self2 = this;
      if (this._operationTimeoutCb) {
        this._timeout = setTimeout(function() {
          self2._operationTimeoutCb();
        }, self2._operationTimeout);
      }
      this._operationStart = (/* @__PURE__ */ new Date()).getTime();
      this._fn(this._attempts);
    };
    RetryOperation.prototype.try = function(fn) {
      console.log("Using RetryOperation.try() is deprecated");
      this.attempt(fn);
    };
    RetryOperation.prototype.start = function(fn) {
      console.log("Using RetryOperation.start() is deprecated");
      this.attempt(fn);
    };
    RetryOperation.prototype.start = RetryOperation.prototype.try;
    RetryOperation.prototype.errors = function() {
      return this._errors;
    };
    RetryOperation.prototype.attempts = function() {
      return this._attempts;
    };
    RetryOperation.prototype.mainError = function() {
      if (this._errors.length === 0) {
        return null;
      }
      var counts = {};
      var mainError = null;
      var mainErrorCount = 0;
      for (var i = 0; i < this._errors.length; i++) {
        var error = this._errors[i];
        var message = error.message;
        var count = (counts[message] || 0) + 1;
        counts[message] = count;
        if (count >= mainErrorCount) {
          mainError = error;
          mainErrorCount = count;
        }
      }
      return mainError;
    };
  }
});

// node_modules/retry/lib/retry.js
var require_retry = __commonJS({
  "node_modules/retry/lib/retry.js"(exports2) {
    var RetryOperation = require_retry_operation();
    exports2.operation = function(options) {
      var timeouts = exports2.timeouts(options);
      return new RetryOperation(timeouts, {
        forever: options && options.forever,
        unref: options && options.unref,
        maxRetryTime: options && options.maxRetryTime
      });
    };
    exports2.timeouts = function(options) {
      if (options instanceof Array) {
        return [].concat(options);
      }
      var opts = {
        retries: 10,
        factor: 2,
        minTimeout: 1 * 1e3,
        maxTimeout: Infinity,
        randomize: false
      };
      for (var key in options) {
        opts[key] = options[key];
      }
      if (opts.minTimeout > opts.maxTimeout) {
        throw new Error("minTimeout is greater than maxTimeout");
      }
      var timeouts = [];
      for (var i = 0; i < opts.retries; i++) {
        timeouts.push(this.createTimeout(i, opts));
      }
      if (options && options.forever && !timeouts.length) {
        timeouts.push(this.createTimeout(i, opts));
      }
      timeouts.sort(function(a, b) {
        return a - b;
      });
      return timeouts;
    };
    exports2.createTimeout = function(attempt, opts) {
      var random = opts.randomize ? Math.random() + 1 : 1;
      var timeout = Math.round(random * opts.minTimeout * Math.pow(opts.factor, attempt));
      timeout = Math.min(timeout, opts.maxTimeout);
      return timeout;
    };
    exports2.wrap = function(obj, options, methods) {
      if (options instanceof Array) {
        methods = options;
        options = null;
      }
      if (!methods) {
        methods = [];
        for (var key in obj) {
          if (typeof obj[key] === "function") {
            methods.push(key);
          }
        }
      }
      for (var i = 0; i < methods.length; i++) {
        var method = methods[i];
        var original = obj[method];
        obj[method] = function retryWrapper(original2) {
          var op = exports2.operation(options);
          var args = Array.prototype.slice.call(arguments, 1);
          var callback = args.pop();
          args.push(function(err) {
            if (op.retry(err)) {
              return;
            }
            if (err) {
              arguments[0] = op.mainError();
            }
            callback.apply(this, arguments);
          });
          op.attempt(function() {
            original2.apply(obj, args);
          });
        }.bind(obj, original);
        obj[method].options = options;
      }
    };
  }
});

// node_modules/retry/index.js
var require_retry2 = __commonJS({
  "node_modules/retry/index.js"(exports2, module2) {
    module2.exports = require_retry();
  }
});

// node_modules/signal-exit/signals.js
var require_signals = __commonJS({
  "node_modules/signal-exit/signals.js"(exports2, module2) {
    module2.exports = [
      "SIGABRT",
      "SIGALRM",
      "SIGHUP",
      "SIGINT",
      "SIGTERM"
    ];
    if (process.platform !== "win32") {
      module2.exports.push(
        "SIGVTALRM",
        "SIGXCPU",
        "SIGXFSZ",
        "SIGUSR2",
        "SIGTRAP",
        "SIGSYS",
        "SIGQUIT",
        "SIGIOT"
        // should detect profiler and enable/disable accordingly.
        // see #21
        // 'SIGPROF'
      );
    }
    if (process.platform === "linux") {
      module2.exports.push(
        "SIGIO",
        "SIGPOLL",
        "SIGPWR",
        "SIGSTKFLT",
        "SIGUNUSED"
      );
    }
  }
});

// node_modules/signal-exit/index.js
var require_signal_exit = __commonJS({
  "node_modules/signal-exit/index.js"(exports2, module2) {
    var process2 = global.process;
    var processOk = function(process3) {
      return process3 && typeof process3 === "object" && typeof process3.removeListener === "function" && typeof process3.emit === "function" && typeof process3.reallyExit === "function" && typeof process3.listeners === "function" && typeof process3.kill === "function" && typeof process3.pid === "number" && typeof process3.on === "function";
    };
    if (!processOk(process2)) {
      module2.exports = function() {
        return function() {
        };
      };
    } else {
      assert = require("assert");
      signals = require_signals();
      isWin = /^win/i.test(process2.platform);
      EE = require("events");
      if (typeof EE !== "function") {
        EE = EE.EventEmitter;
      }
      if (process2.__signal_exit_emitter__) {
        emitter = process2.__signal_exit_emitter__;
      } else {
        emitter = process2.__signal_exit_emitter__ = new EE();
        emitter.count = 0;
        emitter.emitted = {};
      }
      if (!emitter.infinite) {
        emitter.setMaxListeners(Infinity);
        emitter.infinite = true;
      }
      module2.exports = function(cb, opts) {
        if (!processOk(global.process)) {
          return function() {
          };
        }
        assert.equal(typeof cb, "function", "a callback must be provided for exit handler");
        if (loaded === false) {
          load();
        }
        var ev = "exit";
        if (opts && opts.alwaysLast) {
          ev = "afterexit";
        }
        var remove = function() {
          emitter.removeListener(ev, cb);
          if (emitter.listeners("exit").length === 0 && emitter.listeners("afterexit").length === 0) {
            unload();
          }
        };
        emitter.on(ev, cb);
        return remove;
      };
      unload = function unload2() {
        if (!loaded || !processOk(global.process)) {
          return;
        }
        loaded = false;
        signals.forEach(function(sig) {
          try {
            process2.removeListener(sig, sigListeners[sig]);
          } catch (er) {
          }
        });
        process2.emit = originalProcessEmit;
        process2.reallyExit = originalProcessReallyExit;
        emitter.count -= 1;
      };
      module2.exports.unload = unload;
      emit = function emit2(event, code, signal) {
        if (emitter.emitted[event]) {
          return;
        }
        emitter.emitted[event] = true;
        emitter.emit(event, code, signal);
      };
      sigListeners = {};
      signals.forEach(function(sig) {
        sigListeners[sig] = function listener() {
          if (!processOk(global.process)) {
            return;
          }
          var listeners = process2.listeners(sig);
          if (listeners.length === emitter.count) {
            unload();
            emit("exit", null, sig);
            emit("afterexit", null, sig);
            if (isWin && sig === "SIGHUP") {
              sig = "SIGINT";
            }
            process2.kill(process2.pid, sig);
          }
        };
      });
      module2.exports.signals = function() {
        return signals;
      };
      loaded = false;
      load = function load2() {
        if (loaded || !processOk(global.process)) {
          return;
        }
        loaded = true;
        emitter.count += 1;
        signals = signals.filter(function(sig) {
          try {
            process2.on(sig, sigListeners[sig]);
            return true;
          } catch (er) {
            return false;
          }
        });
        process2.emit = processEmit;
        process2.reallyExit = processReallyExit;
      };
      module2.exports.load = load;
      originalProcessReallyExit = process2.reallyExit;
      processReallyExit = function processReallyExit2(code) {
        if (!processOk(global.process)) {
          return;
        }
        process2.exitCode = code || /* istanbul ignore next */
        0;
        emit("exit", process2.exitCode, null);
        emit("afterexit", process2.exitCode, null);
        originalProcessReallyExit.call(process2, process2.exitCode);
      };
      originalProcessEmit = process2.emit;
      processEmit = function processEmit2(ev, arg) {
        if (ev === "exit" && processOk(global.process)) {
          if (arg !== void 0) {
            process2.exitCode = arg;
          }
          var ret = originalProcessEmit.apply(this, arguments);
          emit("exit", process2.exitCode, null);
          emit("afterexit", process2.exitCode, null);
          return ret;
        } else {
          return originalProcessEmit.apply(this, arguments);
        }
      };
    }
    var assert;
    var signals;
    var isWin;
    var EE;
    var emitter;
    var unload;
    var emit;
    var sigListeners;
    var loaded;
    var load;
    var originalProcessReallyExit;
    var processReallyExit;
    var originalProcessEmit;
    var processEmit;
  }
});

// node_modules/proper-lockfile/lib/mtime-precision.js
var require_mtime_precision = __commonJS({
  "node_modules/proper-lockfile/lib/mtime-precision.js"(exports2, module2) {
    "use strict";
    var cacheSymbol = Symbol();
    function probe(file, fs2, callback) {
      const cachedPrecision = fs2[cacheSymbol];
      if (cachedPrecision) {
        return fs2.stat(file, (err, stat) => {
          if (err) {
            return callback(err);
          }
          callback(null, stat.mtime, cachedPrecision);
        });
      }
      const mtime = new Date(Math.ceil(Date.now() / 1e3) * 1e3 + 5);
      fs2.utimes(file, mtime, mtime, (err) => {
        if (err) {
          return callback(err);
        }
        fs2.stat(file, (err2, stat) => {
          if (err2) {
            return callback(err2);
          }
          const precision = stat.mtime.getTime() % 1e3 === 0 ? "s" : "ms";
          Object.defineProperty(fs2, cacheSymbol, { value: precision });
          callback(null, stat.mtime, precision);
        });
      });
    }
    function getMtime(precision) {
      let now = Date.now();
      if (precision === "s") {
        now = Math.ceil(now / 1e3) * 1e3;
      }
      return new Date(now);
    }
    module2.exports.probe = probe;
    module2.exports.getMtime = getMtime;
  }
});

// node_modules/proper-lockfile/lib/lockfile.js
var require_lockfile = __commonJS({
  "node_modules/proper-lockfile/lib/lockfile.js"(exports2, module2) {
    "use strict";
    var path3 = require("path");
    var fs2 = require_graceful_fs();
    var retry = require_retry2();
    var onExit = require_signal_exit();
    var mtimePrecision = require_mtime_precision();
    var locks = {};
    function getLockFile(file, options) {
      return options.lockfilePath || `${file}.lock`;
    }
    function resolveCanonicalPath(file, options, callback) {
      if (!options.realpath) {
        return callback(null, path3.resolve(file));
      }
      options.fs.realpath(file, callback);
    }
    function acquireLock(file, options, callback) {
      const lockfilePath = getLockFile(file, options);
      options.fs.mkdir(lockfilePath, (err) => {
        if (!err) {
          return mtimePrecision.probe(lockfilePath, options.fs, (err2, mtime, mtimePrecision2) => {
            if (err2) {
              options.fs.rmdir(lockfilePath, () => {
              });
              return callback(err2);
            }
            callback(null, mtime, mtimePrecision2);
          });
        }
        if (err.code !== "EEXIST") {
          return callback(err);
        }
        if (options.stale <= 0) {
          return callback(Object.assign(new Error("Lock file is already being held"), { code: "ELOCKED", file }));
        }
        options.fs.stat(lockfilePath, (err2, stat) => {
          if (err2) {
            if (err2.code === "ENOENT") {
              return acquireLock(file, { ...options, stale: 0 }, callback);
            }
            return callback(err2);
          }
          if (!isLockStale(stat, options)) {
            return callback(Object.assign(new Error("Lock file is already being held"), { code: "ELOCKED", file }));
          }
          removeLock(file, options, (err3) => {
            if (err3) {
              return callback(err3);
            }
            acquireLock(file, { ...options, stale: 0 }, callback);
          });
        });
      });
    }
    function isLockStale(stat, options) {
      return stat.mtime.getTime() < Date.now() - options.stale;
    }
    function removeLock(file, options, callback) {
      options.fs.rmdir(getLockFile(file, options), (err) => {
        if (err && err.code !== "ENOENT") {
          return callback(err);
        }
        callback();
      });
    }
    function updateLock(file, options) {
      const lock2 = locks[file];
      if (lock2.updateTimeout) {
        return;
      }
      lock2.updateDelay = lock2.updateDelay || options.update;
      lock2.updateTimeout = setTimeout(() => {
        lock2.updateTimeout = null;
        options.fs.stat(lock2.lockfilePath, (err, stat) => {
          const isOverThreshold = lock2.lastUpdate + options.stale < Date.now();
          if (err) {
            if (err.code === "ENOENT" || isOverThreshold) {
              return setLockAsCompromised(file, lock2, Object.assign(err, { code: "ECOMPROMISED" }));
            }
            lock2.updateDelay = 1e3;
            return updateLock(file, options);
          }
          const isMtimeOurs = lock2.mtime.getTime() === stat.mtime.getTime();
          if (!isMtimeOurs) {
            return setLockAsCompromised(
              file,
              lock2,
              Object.assign(
                new Error("Unable to update lock within the stale threshold"),
                { code: "ECOMPROMISED" }
              )
            );
          }
          const mtime = mtimePrecision.getMtime(lock2.mtimePrecision);
          options.fs.utimes(lock2.lockfilePath, mtime, mtime, (err2) => {
            const isOverThreshold2 = lock2.lastUpdate + options.stale < Date.now();
            if (lock2.released) {
              return;
            }
            if (err2) {
              if (err2.code === "ENOENT" || isOverThreshold2) {
                return setLockAsCompromised(file, lock2, Object.assign(err2, { code: "ECOMPROMISED" }));
              }
              lock2.updateDelay = 1e3;
              return updateLock(file, options);
            }
            lock2.mtime = mtime;
            lock2.lastUpdate = Date.now();
            lock2.updateDelay = null;
            updateLock(file, options);
          });
        });
      }, lock2.updateDelay);
      if (lock2.updateTimeout.unref) {
        lock2.updateTimeout.unref();
      }
    }
    function setLockAsCompromised(file, lock2, err) {
      lock2.released = true;
      if (lock2.updateTimeout) {
        clearTimeout(lock2.updateTimeout);
      }
      if (locks[file] === lock2) {
        delete locks[file];
      }
      lock2.options.onCompromised(err);
    }
    function lock(file, options, callback) {
      options = {
        stale: 1e4,
        update: null,
        realpath: true,
        retries: 0,
        fs: fs2,
        onCompromised: (err) => {
          throw err;
        },
        ...options
      };
      options.retries = options.retries || 0;
      options.retries = typeof options.retries === "number" ? { retries: options.retries } : options.retries;
      options.stale = Math.max(options.stale || 0, 2e3);
      options.update = options.update == null ? options.stale / 2 : options.update || 0;
      options.update = Math.max(Math.min(options.update, options.stale / 2), 1e3);
      resolveCanonicalPath(file, options, (err, file2) => {
        if (err) {
          return callback(err);
        }
        const operation = retry.operation(options.retries);
        operation.attempt(() => {
          acquireLock(file2, options, (err2, mtime, mtimePrecision2) => {
            if (operation.retry(err2)) {
              return;
            }
            if (err2) {
              return callback(operation.mainError());
            }
            const lock2 = locks[file2] = {
              lockfilePath: getLockFile(file2, options),
              mtime,
              mtimePrecision: mtimePrecision2,
              options,
              lastUpdate: Date.now()
            };
            updateLock(file2, options);
            callback(null, (releasedCallback) => {
              if (lock2.released) {
                return releasedCallback && releasedCallback(Object.assign(new Error("Lock is already released"), { code: "ERELEASED" }));
              }
              unlock(file2, { ...options, realpath: false }, releasedCallback);
            });
          });
        });
      });
    }
    function unlock(file, options, callback) {
      options = {
        fs: fs2,
        realpath: true,
        ...options
      };
      resolveCanonicalPath(file, options, (err, file2) => {
        if (err) {
          return callback(err);
        }
        const lock2 = locks[file2];
        if (!lock2) {
          return callback(Object.assign(new Error("Lock is not acquired/owned by you"), { code: "ENOTACQUIRED" }));
        }
        lock2.updateTimeout && clearTimeout(lock2.updateTimeout);
        lock2.released = true;
        delete locks[file2];
        removeLock(file2, options, callback);
      });
    }
    function check(file, options, callback) {
      options = {
        stale: 1e4,
        realpath: true,
        fs: fs2,
        ...options
      };
      options.stale = Math.max(options.stale || 0, 2e3);
      resolveCanonicalPath(file, options, (err, file2) => {
        if (err) {
          return callback(err);
        }
        options.fs.stat(getLockFile(file2, options), (err2, stat) => {
          if (err2) {
            return err2.code === "ENOENT" ? callback(null, false) : callback(err2);
          }
          return callback(null, !isLockStale(stat, options));
        });
      });
    }
    function getLocks() {
      return locks;
    }
    onExit(() => {
      for (const file in locks) {
        const options = locks[file].options;
        try {
          options.fs.rmdirSync(getLockFile(file, options));
        } catch (e) {
        }
      }
    });
    module2.exports.lock = lock;
    module2.exports.unlock = unlock;
    module2.exports.check = check;
    module2.exports.getLocks = getLocks;
  }
});

// node_modules/proper-lockfile/lib/adapter.js
var require_adapter = __commonJS({
  "node_modules/proper-lockfile/lib/adapter.js"(exports2, module2) {
    "use strict";
    var fs2 = require_graceful_fs();
    function createSyncFs(fs3) {
      const methods = ["mkdir", "realpath", "stat", "rmdir", "utimes"];
      const newFs = { ...fs3 };
      methods.forEach((method) => {
        newFs[method] = (...args) => {
          const callback = args.pop();
          let ret;
          try {
            ret = fs3[`${method}Sync`](...args);
          } catch (err) {
            return callback(err);
          }
          callback(null, ret);
        };
      });
      return newFs;
    }
    function toPromise(method) {
      return (...args) => new Promise((resolve2, reject) => {
        args.push((err, result2) => {
          if (err) {
            reject(err);
          } else {
            resolve2(result2);
          }
        });
        method(...args);
      });
    }
    function toSync(method) {
      return (...args) => {
        let err;
        let result2;
        args.push((_err, _result) => {
          err = _err;
          result2 = _result;
        });
        method(...args);
        if (err) {
          throw err;
        }
        return result2;
      };
    }
    function toSyncOptions(options) {
      options = { ...options };
      options.fs = createSyncFs(options.fs || fs2);
      if (typeof options.retries === "number" && options.retries > 0 || options.retries && typeof options.retries.retries === "number" && options.retries.retries > 0) {
        throw Object.assign(new Error("Cannot use retries with the sync api"), { code: "ESYNC" });
      }
      return options;
    }
    module2.exports = {
      toPromise,
      toSync,
      toSyncOptions
    };
  }
});

// node_modules/proper-lockfile/index.js
var require_proper_lockfile = __commonJS({
  "node_modules/proper-lockfile/index.js"(exports2, module2) {
    "use strict";
    var lockfile = require_lockfile();
    var { toPromise, toSync, toSyncOptions } = require_adapter();
    async function lock(file, options) {
      const release = await toPromise(lockfile.lock)(file, options);
      return toPromise(release);
    }
    function lockSync(file, options) {
      const release = toSync(lockfile.lock)(file, toSyncOptions(options));
      return toSync(release);
    }
    function unlock(file, options) {
      return toPromise(lockfile.unlock)(file, options);
    }
    function unlockSync(file, options) {
      return toSync(lockfile.unlock)(file, toSyncOptions(options));
    }
    function check(file, options) {
      return toPromise(lockfile.check)(file, options);
    }
    function checkSync(file, options) {
      return toSync(lockfile.check)(file, toSyncOptions(options));
    }
    module2.exports = lock;
    module2.exports.lock = lock;
    module2.exports.unlock = unlock;
    module2.exports.lockSync = lockSync;
    module2.exports.unlockSync = unlockSync;
    module2.exports.check = check;
    module2.exports.checkSync = checkSync;
  }
});

// node_modules/@ster5/global-mutex/dist/source/index.js
var require_source8 = __commonJS({
  "node_modules/@ster5/global-mutex/dist/source/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __setModuleDefault2 = exports2 && exports2.__setModuleDefault || (Object.create ? function(o2, v) {
      Object.defineProperty(o2, "default", { enumerable: true, value: v });
    } : function(o2, v) {
      o2["default"] = v;
    });
    var __importStar3 = exports2 && exports2.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result2 = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
            __createBinding3(result2, mod, k);
      }
      __setModuleDefault2(result2, mod);
      return result2;
    };
    var __awaiter3 = exports2 && exports2.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve2) {
          resolve2(value);
        });
      }
      return new (P || (P = Promise))(function(resolve2, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result2) {
          result2.done ? resolve2(result2.value) : adopt(result2.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isLocked = exports2.withLock = exports2.defaultStaleDuration = void 0;
    var proper_lockfile_1 = require_proper_lockfile();
    var fs2 = __importStar3(require("fs"));
    var path3 = __importStar3(require("path"));
    exports2.defaultStaleDuration = 2 * 60 * 1e3;
    function withLock(options, action) {
      return __awaiter3(this, void 0, void 0, function* () {
        options.stale = options.stale || exports2.defaultStaleDuration;
        const { fileToLock } = options;
        const _fs = options.fs || fs2;
        if (!_fs.existsSync(path3.dirname(fileToLock))) {
          throw new Error("Invalid lockfile: " + fileToLock);
        }
        if (!_fs.existsSync(fileToLock)) {
          _fs.writeFileSync(fileToLock, "");
        }
        options.stale = options.stale || exports2.defaultStaleDuration;
        if (options.retries === void 0) {
          options.retries = { forever: true, minTimeout: 100, maxTimeout: 2e3, randomize: true };
        }
        yield (0, proper_lockfile_1.lock)(fileToLock, options);
        try {
          return yield action();
        } finally {
          try {
            yield (0, proper_lockfile_1.unlock)(fileToLock, options);
          } catch (err) {
            console.log("Error in Unlock !!!", err.message);
          }
        }
      });
    }
    exports2.withLock = withLock;
    function isLocked(fileToLock, options) {
      return __awaiter3(this, void 0, void 0, function* () {
        return yield (0, proper_lockfile_1.check)(fileToLock, options);
      });
    }
    exports2.isLocked = isLocked;
  }
});

// node_modules/mkdirp/lib/opts-arg.js
var require_opts_arg = __commonJS({
  "node_modules/mkdirp/lib/opts-arg.js"(exports2, module2) {
    var { promisify } = require("util");
    var fs2 = require("fs");
    var optsArg = (opts) => {
      if (!opts)
        opts = { mode: 511, fs: fs2 };
      else if (typeof opts === "object")
        opts = { mode: 511, fs: fs2, ...opts };
      else if (typeof opts === "number")
        opts = { mode: opts, fs: fs2 };
      else if (typeof opts === "string")
        opts = { mode: parseInt(opts, 8), fs: fs2 };
      else
        throw new TypeError("invalid options argument");
      opts.mkdir = opts.mkdir || opts.fs.mkdir || fs2.mkdir;
      opts.mkdirAsync = promisify(opts.mkdir);
      opts.stat = opts.stat || opts.fs.stat || fs2.stat;
      opts.statAsync = promisify(opts.stat);
      opts.statSync = opts.statSync || opts.fs.statSync || fs2.statSync;
      opts.mkdirSync = opts.mkdirSync || opts.fs.mkdirSync || fs2.mkdirSync;
      return opts;
    };
    module2.exports = optsArg;
  }
});

// node_modules/mkdirp/lib/path-arg.js
var require_path_arg = __commonJS({
  "node_modules/mkdirp/lib/path-arg.js"(exports2, module2) {
    var platform = process.env.__TESTING_MKDIRP_PLATFORM__ || process.platform;
    var { resolve: resolve2, parse: parse6 } = require("path");
    var pathArg = (path3) => {
      if (/\0/.test(path3)) {
        throw Object.assign(
          new TypeError("path must be a string without null bytes"),
          {
            path: path3,
            code: "ERR_INVALID_ARG_VALUE"
          }
        );
      }
      path3 = resolve2(path3);
      if (platform === "win32") {
        const badWinChars = /[*|"<>?:]/;
        const { root } = parse6(path3);
        if (badWinChars.test(path3.substr(root.length))) {
          throw Object.assign(new Error("Illegal characters in path."), {
            path: path3,
            code: "EINVAL"
          });
        }
      }
      return path3;
    };
    module2.exports = pathArg;
  }
});

// node_modules/mkdirp/lib/find-made.js
var require_find_made = __commonJS({
  "node_modules/mkdirp/lib/find-made.js"(exports2, module2) {
    var { dirname } = require("path");
    var findMade = (opts, parent, path3 = void 0) => {
      if (path3 === parent)
        return Promise.resolve();
      return opts.statAsync(parent).then(
        (st) => st.isDirectory() ? path3 : void 0,
        // will fail later
        (er) => er.code === "ENOENT" ? findMade(opts, dirname(parent), parent) : void 0
      );
    };
    var findMadeSync = (opts, parent, path3 = void 0) => {
      if (path3 === parent)
        return void 0;
      try {
        return opts.statSync(parent).isDirectory() ? path3 : void 0;
      } catch (er) {
        return er.code === "ENOENT" ? findMadeSync(opts, dirname(parent), parent) : void 0;
      }
    };
    module2.exports = { findMade, findMadeSync };
  }
});

// node_modules/mkdirp/lib/mkdirp-manual.js
var require_mkdirp_manual = __commonJS({
  "node_modules/mkdirp/lib/mkdirp-manual.js"(exports2, module2) {
    var { dirname } = require("path");
    var mkdirpManual = (path3, opts, made) => {
      opts.recursive = false;
      const parent = dirname(path3);
      if (parent === path3) {
        return opts.mkdirAsync(path3, opts).catch((er) => {
          if (er.code !== "EISDIR")
            throw er;
        });
      }
      return opts.mkdirAsync(path3, opts).then(() => made || path3, (er) => {
        if (er.code === "ENOENT")
          return mkdirpManual(parent, opts).then((made2) => mkdirpManual(path3, opts, made2));
        if (er.code !== "EEXIST" && er.code !== "EROFS")
          throw er;
        return opts.statAsync(path3).then((st) => {
          if (st.isDirectory())
            return made;
          else
            throw er;
        }, () => {
          throw er;
        });
      });
    };
    var mkdirpManualSync = (path3, opts, made) => {
      const parent = dirname(path3);
      opts.recursive = false;
      if (parent === path3) {
        try {
          return opts.mkdirSync(path3, opts);
        } catch (er) {
          if (er.code !== "EISDIR")
            throw er;
          else
            return;
        }
      }
      try {
        opts.mkdirSync(path3, opts);
        return made || path3;
      } catch (er) {
        if (er.code === "ENOENT")
          return mkdirpManualSync(path3, opts, mkdirpManualSync(parent, opts, made));
        if (er.code !== "EEXIST" && er.code !== "EROFS")
          throw er;
        try {
          if (!opts.statSync(path3).isDirectory())
            throw er;
        } catch (_) {
          throw er;
        }
      }
    };
    module2.exports = { mkdirpManual, mkdirpManualSync };
  }
});

// node_modules/mkdirp/lib/mkdirp-native.js
var require_mkdirp_native = __commonJS({
  "node_modules/mkdirp/lib/mkdirp-native.js"(exports2, module2) {
    var { dirname } = require("path");
    var { findMade, findMadeSync } = require_find_made();
    var { mkdirpManual, mkdirpManualSync } = require_mkdirp_manual();
    var mkdirpNative = (path3, opts) => {
      opts.recursive = true;
      const parent = dirname(path3);
      if (parent === path3)
        return opts.mkdirAsync(path3, opts);
      return findMade(opts, path3).then((made) => opts.mkdirAsync(path3, opts).then(() => made).catch((er) => {
        if (er.code === "ENOENT")
          return mkdirpManual(path3, opts);
        else
          throw er;
      }));
    };
    var mkdirpNativeSync = (path3, opts) => {
      opts.recursive = true;
      const parent = dirname(path3);
      if (parent === path3)
        return opts.mkdirSync(path3, opts);
      const made = findMadeSync(opts, path3);
      try {
        opts.mkdirSync(path3, opts);
        return made;
      } catch (er) {
        if (er.code === "ENOENT")
          return mkdirpManualSync(path3, opts);
        else
          throw er;
      }
    };
    module2.exports = { mkdirpNative, mkdirpNativeSync };
  }
});

// node_modules/mkdirp/lib/use-native.js
var require_use_native = __commonJS({
  "node_modules/mkdirp/lib/use-native.js"(exports2, module2) {
    var fs2 = require("fs");
    var version = process.env.__TESTING_MKDIRP_NODE_VERSION__ || process.version;
    var versArr = version.replace(/^v/, "").split(".");
    var hasNative = +versArr[0] > 10 || +versArr[0] === 10 && +versArr[1] >= 12;
    var useNative = !hasNative ? () => false : (opts) => opts.mkdir === fs2.mkdir;
    var useNativeSync = !hasNative ? () => false : (opts) => opts.mkdirSync === fs2.mkdirSync;
    module2.exports = { useNative, useNativeSync };
  }
});

// node_modules/mkdirp/index.js
var require_mkdirp = __commonJS({
  "node_modules/mkdirp/index.js"(exports2, module2) {
    var optsArg = require_opts_arg();
    var pathArg = require_path_arg();
    var { mkdirpNative, mkdirpNativeSync } = require_mkdirp_native();
    var { mkdirpManual, mkdirpManualSync } = require_mkdirp_manual();
    var { useNative, useNativeSync } = require_use_native();
    var mkdirp = (path3, opts) => {
      path3 = pathArg(path3);
      opts = optsArg(opts);
      return useNative(opts) ? mkdirpNative(path3, opts) : mkdirpManual(path3, opts);
    };
    var mkdirpSync = (path3, opts) => {
      path3 = pathArg(path3);
      opts = optsArg(opts);
      return useNativeSync(opts) ? mkdirpNativeSync(path3, opts) : mkdirpManualSync(path3, opts);
    };
    mkdirp.sync = mkdirpSync;
    mkdirp.native = (path3, opts) => mkdirpNative(pathArg(path3), optsArg(opts));
    mkdirp.manual = (path3, opts) => mkdirpManual(pathArg(path3), optsArg(opts));
    mkdirp.nativeSync = (path3, opts) => mkdirpNativeSync(pathArg(path3), optsArg(opts));
    mkdirp.manualSync = (path3, opts) => mkdirpManualSync(pathArg(path3), optsArg(opts));
    module2.exports = mkdirp;
  }
});

// node_modules/env-paths/index.js
var require_env_paths = __commonJS({
  "node_modules/env-paths/index.js"(exports2, module2) {
    "use strict";
    var path3 = require("path");
    var os2 = require("os");
    var homedir = os2.homedir();
    var tmpdir = os2.tmpdir();
    var { env } = process;
    var macos = (name) => {
      const library = path3.join(homedir, "Library");
      return {
        data: path3.join(library, "Application Support", name),
        config: path3.join(library, "Preferences", name),
        cache: path3.join(library, "Caches", name),
        log: path3.join(library, "Logs", name),
        temp: path3.join(tmpdir, name)
      };
    };
    var windows = (name) => {
      const appData = env.APPDATA || path3.join(homedir, "AppData", "Roaming");
      const localAppData = env.LOCALAPPDATA || path3.join(homedir, "AppData", "Local");
      return {
        // Data/config/cache/log are invented by me as Windows isn't opinionated about this
        data: path3.join(localAppData, name, "Data"),
        config: path3.join(appData, name, "Config"),
        cache: path3.join(localAppData, name, "Cache"),
        log: path3.join(localAppData, name, "Log"),
        temp: path3.join(tmpdir, name)
      };
    };
    var linux = (name) => {
      const username = path3.basename(homedir);
      return {
        data: path3.join(env.XDG_DATA_HOME || path3.join(homedir, ".local", "share"), name),
        config: path3.join(env.XDG_CONFIG_HOME || path3.join(homedir, ".config"), name),
        cache: path3.join(env.XDG_CACHE_HOME || path3.join(homedir, ".cache"), name),
        // https://wiki.debian.org/XDGBaseDirectorySpecification#state
        log: path3.join(env.XDG_STATE_HOME || path3.join(homedir, ".local", "state"), name),
        temp: path3.join(tmpdir, username, name)
      };
    };
    var envPaths = (name, options) => {
      if (typeof name !== "string") {
        throw new TypeError(`Expected string, got ${typeof name}`);
      }
      options = Object.assign({ suffix: "nodejs" }, options);
      if (options.suffix) {
        name += `-${options.suffix}`;
      }
      if (process.platform === "darwin") {
        return macos(name);
      }
      if (process.platform === "win32") {
        return windows(name);
      }
      return linux(name);
    };
    module2.exports = envPaths;
    module2.exports.default = envPaths;
  }
});

// node_modules/node-opcua-pki/dist/lib/toolbox/common.js
var require_common3 = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/toolbox/common.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.adjustApplicationUri = exports2.adjustDate = exports2.quote = void 0;
    var assert = require("assert");
    function quote(str) {
      return '"' + (str || "") + '"';
    }
    exports2.quote = quote;
    function adjustDate(params) {
      assert(params instanceof Object);
      params.startDate = params.startDate || /* @__PURE__ */ new Date();
      assert(params.startDate instanceof Date);
      params.validity = params.validity || 365;
      params.endDate = new Date(params.startDate.getTime());
      params.endDate.setDate(params.startDate.getDate() + params.validity);
      assert(params.endDate instanceof Date);
      assert(params.startDate instanceof Date);
    }
    exports2.adjustDate = adjustDate;
    function adjustApplicationUri(params) {
      const applicationUri = params.applicationUri || "";
      if (applicationUri.length > 200) {
        throw new Error("Openssl doesn't support urn with length greater than 200" + applicationUri);
      }
    }
    exports2.adjustApplicationUri = adjustApplicationUri;
  }
});

// node_modules/node-opcua-pki/dist/lib/toolbox/config.js
var require_config = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/toolbox/config.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.g_config = void 0;
    exports2.g_config = {
      opensslVersion: "unset",
      silent: process.env.VERBOSE ? !process.env.VERBOSE : true,
      force: false
    };
  }
});

// node_modules/node-opcua-pki/dist/lib/toolbox/debug.js
var require_debug3 = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/toolbox/debug.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.warningLog = exports2.debugLog = exports2.displayDebug = exports2.displayError = exports2.doDebug = void 0;
    exports2.doDebug = process.env.NODEOPCUAPKIDEBUG || false;
    exports2.displayError = true;
    exports2.displayDebug = !!process.env.NODEOPCUAPKIDEBUG || false;
    function debugLog(...args) {
      if (exports2.displayDebug) {
        console.log.apply(null, args);
      }
    }
    exports2.debugLog = debugLog;
    function warningLog(...args) {
      console.log.apply(null, args);
    }
    exports2.warningLog = warningLog;
  }
});

// node_modules/node-opcua-pki/dist/lib/toolbox/common2.js
var require_common22 = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/toolbox/common2.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.make_path = exports2.mkdir = exports2.certificateFileExist = void 0;
    var fs_1 = __importDefault3(require("fs"));
    var path_1 = __importDefault3(require("path"));
    var chalk_1 = __importDefault3(require_source());
    var config_1 = require_config();
    var assert = require("assert");
    var debug_1 = require_debug3();
    function certificateFileExist(certificateFile) {
      if (fs_1.default.existsSync(certificateFile) && !config_1.g_config.force) {
        (0, debug_1.warningLog)(chalk_1.default.yellow("        certificate ") + chalk_1.default.cyan(certificateFile) + chalk_1.default.yellow(" already exists => do not overwrite"));
        return false;
      }
      return true;
    }
    exports2.certificateFileExist = certificateFileExist;
    function mkdir(folder) {
      if (!fs_1.default.existsSync(folder)) {
        (0, debug_1.debugLog)(chalk_1.default.white(" .. constructing "), folder);
        fs_1.default.mkdirSync(folder);
      }
    }
    exports2.mkdir = mkdir;
    function make_path(folderName, filename) {
      let s;
      if (filename) {
        s = path_1.default.join(path_1.default.normalize(folderName), filename);
      } else {
        assert(folderName);
        s = folderName;
      }
      s = s.replace(/\\/g, "/");
      return s;
    }
    exports2.make_path = make_path;
  }
});

// node_modules/node-opcua-pki/dist/lib/toolbox/display.js
var require_display = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/toolbox/display.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.display = exports2.displaySubtitle = exports2.displayTitle = exports2.displayChapter = void 0;
    var chalk_1 = __importDefault3(require_source());
    var config_1 = require_config();
    var debug_1 = require_debug3();
    function displayChapter(str, callback) {
      const l2 = "                                                                                               ";
      (0, debug_1.warningLog)(chalk_1.default.bgWhite(l2) + " ");
      str = ("        " + str + l2).substring(0, l2.length);
      (0, debug_1.warningLog)(chalk_1.default.bgWhite.cyan(str));
      (0, debug_1.warningLog)(chalk_1.default.bgWhite(l2) + " ");
      if (callback) {
        callback();
      }
    }
    exports2.displayChapter = displayChapter;
    function displayTitle(str, callback) {
      if (!config_1.g_config.silent) {
        (0, debug_1.warningLog)("");
        (0, debug_1.warningLog)(chalk_1.default.yellowBright(str));
        (0, debug_1.warningLog)(chalk_1.default.yellow(new Array(str.length + 1).join("=")), "\n");
      }
      if (callback) {
        callback();
      }
    }
    exports2.displayTitle = displayTitle;
    function displaySubtitle(str, callback) {
      if (!config_1.g_config.silent) {
        (0, debug_1.warningLog)("");
        (0, debug_1.warningLog)("    " + chalk_1.default.yellowBright(str));
        (0, debug_1.warningLog)("    " + chalk_1.default.white(new Array(str.length + 1).join("-")), "\n");
      }
      if (callback) {
        callback();
      }
    }
    exports2.displaySubtitle = displaySubtitle;
    function display(str, callback) {
      if (!config_1.g_config.silent) {
        (0, debug_1.warningLog)("       " + str);
      }
      if (callback) {
        callback();
      }
    }
    exports2.display = display;
  }
});

// node_modules/node-opcua-pki/dist/lib/toolbox/index.js
var require_toolbox = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/toolbox/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_common3(), exports2);
    __exportStar3(require_common22(), exports2);
    __exportStar3(require_debug3(), exports2);
    __exportStar3(require_display(), exports2);
    __exportStar3(require_config(), exports2);
  }
});

// node_modules/node-opcua-pki/dist/lib/toolbox/without_openssl/create_private_key.js
var require_create_private_key = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/toolbox/without_openssl/create_private_key.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.generatePrivateKeyFileCallback = void 0;
    var node_opcua_crypto_1 = require_dist33();
    function generatePrivateKeyFileCallback(filename, length, callback) {
      (0, node_opcua_crypto_1.generatePrivateKeyFile)(filename, length).then(() => callback()).catch((err) => callback(err));
    }
    exports2.generatePrivateKeyFileCallback = generatePrivateKeyFileCallback;
  }
});

// node_modules/picomatch/lib/constants.js
var require_constants5 = __commonJS({
  "node_modules/picomatch/lib/constants.js"(exports2, module2) {
    "use strict";
    var path3 = require("path");
    var WIN_SLASH = "\\\\/";
    var WIN_NO_SLASH = `[^${WIN_SLASH}]`;
    var DOT_LITERAL = "\\.";
    var PLUS_LITERAL = "\\+";
    var QMARK_LITERAL = "\\?";
    var SLASH_LITERAL = "\\/";
    var ONE_CHAR = "(?=.)";
    var QMARK = "[^/]";
    var END_ANCHOR = `(?:${SLASH_LITERAL}|$)`;
    var START_ANCHOR = `(?:^|${SLASH_LITERAL})`;
    var DOTS_SLASH = `${DOT_LITERAL}{1,2}${END_ANCHOR}`;
    var NO_DOT = `(?!${DOT_LITERAL})`;
    var NO_DOTS = `(?!${START_ANCHOR}${DOTS_SLASH})`;
    var NO_DOT_SLASH = `(?!${DOT_LITERAL}{0,1}${END_ANCHOR})`;
    var NO_DOTS_SLASH = `(?!${DOTS_SLASH})`;
    var QMARK_NO_DOT = `[^.${SLASH_LITERAL}]`;
    var STAR = `${QMARK}*?`;
    var POSIX_CHARS = {
      DOT_LITERAL,
      PLUS_LITERAL,
      QMARK_LITERAL,
      SLASH_LITERAL,
      ONE_CHAR,
      QMARK,
      END_ANCHOR,
      DOTS_SLASH,
      NO_DOT,
      NO_DOTS,
      NO_DOT_SLASH,
      NO_DOTS_SLASH,
      QMARK_NO_DOT,
      STAR,
      START_ANCHOR
    };
    var WINDOWS_CHARS = {
      ...POSIX_CHARS,
      SLASH_LITERAL: `[${WIN_SLASH}]`,
      QMARK: WIN_NO_SLASH,
      STAR: `${WIN_NO_SLASH}*?`,
      DOTS_SLASH: `${DOT_LITERAL}{1,2}(?:[${WIN_SLASH}]|$)`,
      NO_DOT: `(?!${DOT_LITERAL})`,
      NO_DOTS: `(?!(?:^|[${WIN_SLASH}])${DOT_LITERAL}{1,2}(?:[${WIN_SLASH}]|$))`,
      NO_DOT_SLASH: `(?!${DOT_LITERAL}{0,1}(?:[${WIN_SLASH}]|$))`,
      NO_DOTS_SLASH: `(?!${DOT_LITERAL}{1,2}(?:[${WIN_SLASH}]|$))`,
      QMARK_NO_DOT: `[^.${WIN_SLASH}]`,
      START_ANCHOR: `(?:^|[${WIN_SLASH}])`,
      END_ANCHOR: `(?:[${WIN_SLASH}]|$)`
    };
    var POSIX_REGEX_SOURCE = {
      alnum: "a-zA-Z0-9",
      alpha: "a-zA-Z",
      ascii: "\\x00-\\x7F",
      blank: " \\t",
      cntrl: "\\x00-\\x1F\\x7F",
      digit: "0-9",
      graph: "\\x21-\\x7E",
      lower: "a-z",
      print: "\\x20-\\x7E ",
      punct: "\\-!\"#$%&'()\\*+,./:;<=>?@[\\]^_`{|}~",
      space: " \\t\\r\\n\\v\\f",
      upper: "A-Z",
      word: "A-Za-z0-9_",
      xdigit: "A-Fa-f0-9"
    };
    module2.exports = {
      MAX_LENGTH: 1024 * 64,
      POSIX_REGEX_SOURCE,
      // regular expressions
      REGEX_BACKSLASH: /\\(?![*+?^${}(|)[\]])/g,
      REGEX_NON_SPECIAL_CHARS: /^[^@![\].,$*+?^{}()|\\/]+/,
      REGEX_SPECIAL_CHARS: /[-*+?.^${}(|)[\]]/,
      REGEX_SPECIAL_CHARS_BACKREF: /(\\?)((\W)(\3*))/g,
      REGEX_SPECIAL_CHARS_GLOBAL: /([-*+?.^${}(|)[\]])/g,
      REGEX_REMOVE_BACKSLASH: /(?:\[.*?[^\\]\]|\\(?=.))/g,
      // Replace globs with equivalent patterns to reduce parsing time.
      REPLACEMENTS: {
        "***": "*",
        "**/**": "**",
        "**/**/**": "**"
      },
      // Digits
      CHAR_0: 48,
      /* 0 */
      CHAR_9: 57,
      /* 9 */
      // Alphabet chars.
      CHAR_UPPERCASE_A: 65,
      /* A */
      CHAR_LOWERCASE_A: 97,
      /* a */
      CHAR_UPPERCASE_Z: 90,
      /* Z */
      CHAR_LOWERCASE_Z: 122,
      /* z */
      CHAR_LEFT_PARENTHESES: 40,
      /* ( */
      CHAR_RIGHT_PARENTHESES: 41,
      /* ) */
      CHAR_ASTERISK: 42,
      /* * */
      // Non-alphabetic chars.
      CHAR_AMPERSAND: 38,
      /* & */
      CHAR_AT: 64,
      /* @ */
      CHAR_BACKWARD_SLASH: 92,
      /* \ */
      CHAR_CARRIAGE_RETURN: 13,
      /* \r */
      CHAR_CIRCUMFLEX_ACCENT: 94,
      /* ^ */
      CHAR_COLON: 58,
      /* : */
      CHAR_COMMA: 44,
      /* , */
      CHAR_DOT: 46,
      /* . */
      CHAR_DOUBLE_QUOTE: 34,
      /* " */
      CHAR_EQUAL: 61,
      /* = */
      CHAR_EXCLAMATION_MARK: 33,
      /* ! */
      CHAR_FORM_FEED: 12,
      /* \f */
      CHAR_FORWARD_SLASH: 47,
      /* / */
      CHAR_GRAVE_ACCENT: 96,
      /* ` */
      CHAR_HASH: 35,
      /* # */
      CHAR_HYPHEN_MINUS: 45,
      /* - */
      CHAR_LEFT_ANGLE_BRACKET: 60,
      /* < */
      CHAR_LEFT_CURLY_BRACE: 123,
      /* { */
      CHAR_LEFT_SQUARE_BRACKET: 91,
      /* [ */
      CHAR_LINE_FEED: 10,
      /* \n */
      CHAR_NO_BREAK_SPACE: 160,
      /* \u00A0 */
      CHAR_PERCENT: 37,
      /* % */
      CHAR_PLUS: 43,
      /* + */
      CHAR_QUESTION_MARK: 63,
      /* ? */
      CHAR_RIGHT_ANGLE_BRACKET: 62,
      /* > */
      CHAR_RIGHT_CURLY_BRACE: 125,
      /* } */
      CHAR_RIGHT_SQUARE_BRACKET: 93,
      /* ] */
      CHAR_SEMICOLON: 59,
      /* ; */
      CHAR_SINGLE_QUOTE: 39,
      /* ' */
      CHAR_SPACE: 32,
      /*   */
      CHAR_TAB: 9,
      /* \t */
      CHAR_UNDERSCORE: 95,
      /* _ */
      CHAR_VERTICAL_LINE: 124,
      /* | */
      CHAR_ZERO_WIDTH_NOBREAK_SPACE: 65279,
      /* \uFEFF */
      SEP: path3.sep,
      /**
       * Create EXTGLOB_CHARS
       */
      extglobChars(chars) {
        return {
          "!": { type: "negate", open: "(?:(?!(?:", close: `))${chars.STAR})` },
          "?": { type: "qmark", open: "(?:", close: ")?" },
          "+": { type: "plus", open: "(?:", close: ")+" },
          "*": { type: "star", open: "(?:", close: ")*" },
          "@": { type: "at", open: "(?:", close: ")" }
        };
      },
      /**
       * Create GLOB_CHARS
       */
      globChars(win32) {
        return win32 === true ? WINDOWS_CHARS : POSIX_CHARS;
      }
    };
  }
});

// node_modules/picomatch/lib/utils.js
var require_utils8 = __commonJS({
  "node_modules/picomatch/lib/utils.js"(exports2) {
    "use strict";
    var path3 = require("path");
    var win32 = process.platform === "win32";
    var {
      REGEX_BACKSLASH,
      REGEX_REMOVE_BACKSLASH,
      REGEX_SPECIAL_CHARS,
      REGEX_SPECIAL_CHARS_GLOBAL
    } = require_constants5();
    exports2.isObject = (val) => val !== null && typeof val === "object" && !Array.isArray(val);
    exports2.hasRegexChars = (str) => REGEX_SPECIAL_CHARS.test(str);
    exports2.isRegexChar = (str) => str.length === 1 && exports2.hasRegexChars(str);
    exports2.escapeRegex = (str) => str.replace(REGEX_SPECIAL_CHARS_GLOBAL, "\\$1");
    exports2.toPosixSlashes = (str) => str.replace(REGEX_BACKSLASH, "/");
    exports2.removeBackslashes = (str) => {
      return str.replace(REGEX_REMOVE_BACKSLASH, (match) => {
        return match === "\\" ? "" : match;
      });
    };
    exports2.supportsLookbehinds = () => {
      const segs = process.version.slice(1).split(".").map(Number);
      if (segs.length === 3 && segs[0] >= 9 || segs[0] === 8 && segs[1] >= 10) {
        return true;
      }
      return false;
    };
    exports2.isWindows = (options) => {
      if (options && typeof options.windows === "boolean") {
        return options.windows;
      }
      return win32 === true || path3.sep === "\\";
    };
    exports2.escapeLast = (input, char, lastIdx) => {
      const idx = input.lastIndexOf(char, lastIdx);
      if (idx === -1)
        return input;
      if (input[idx - 1] === "\\")
        return exports2.escapeLast(input, char, idx - 1);
      return `${input.slice(0, idx)}\\${input.slice(idx)}`;
    };
    exports2.removePrefix = (input, state = {}) => {
      let output = input;
      if (output.startsWith("./")) {
        output = output.slice(2);
        state.prefix = "./";
      }
      return output;
    };
    exports2.wrapOutput = (input, state = {}, options = {}) => {
      const prepend = options.contains ? "" : "^";
      const append3 = options.contains ? "" : "$";
      let output = `${prepend}(?:${input})${append3}`;
      if (state.negated === true) {
        output = `(?:^(?!${output}).*$)`;
      }
      return output;
    };
  }
});

// node_modules/picomatch/lib/scan.js
var require_scan = __commonJS({
  "node_modules/picomatch/lib/scan.js"(exports2, module2) {
    "use strict";
    var utils = require_utils8();
    var {
      CHAR_ASTERISK,
      /* * */
      CHAR_AT,
      /* @ */
      CHAR_BACKWARD_SLASH,
      /* \ */
      CHAR_COMMA,
      /* , */
      CHAR_DOT,
      /* . */
      CHAR_EXCLAMATION_MARK,
      /* ! */
      CHAR_FORWARD_SLASH,
      /* / */
      CHAR_LEFT_CURLY_BRACE,
      /* { */
      CHAR_LEFT_PARENTHESES,
      /* ( */
      CHAR_LEFT_SQUARE_BRACKET,
      /* [ */
      CHAR_PLUS,
      /* + */
      CHAR_QUESTION_MARK,
      /* ? */
      CHAR_RIGHT_CURLY_BRACE,
      /* } */
      CHAR_RIGHT_PARENTHESES,
      /* ) */
      CHAR_RIGHT_SQUARE_BRACKET
      /* ] */
    } = require_constants5();
    var isPathSeparator = (code) => {
      return code === CHAR_FORWARD_SLASH || code === CHAR_BACKWARD_SLASH;
    };
    var depth = (token) => {
      if (token.isPrefix !== true) {
        token.depth = token.isGlobstar ? Infinity : 1;
      }
    };
    var scan = (input, options) => {
      const opts = options || {};
      const length = input.length - 1;
      const scanToEnd = opts.parts === true || opts.scanToEnd === true;
      const slashes = [];
      const tokens = [];
      const parts = [];
      let str = input;
      let index = -1;
      let start = 0;
      let lastIndex = 0;
      let isBrace = false;
      let isBracket = false;
      let isGlob = false;
      let isExtglob = false;
      let isGlobstar = false;
      let braceEscaped = false;
      let backslashes = false;
      let negated = false;
      let negatedExtglob = false;
      let finished = false;
      let braces = 0;
      let prev;
      let code;
      let token = { value: "", depth: 0, isGlob: false };
      const eos = () => index >= length;
      const peek = () => str.charCodeAt(index + 1);
      const advance = () => {
        prev = code;
        return str.charCodeAt(++index);
      };
      while (index < length) {
        code = advance();
        let next;
        if (code === CHAR_BACKWARD_SLASH) {
          backslashes = token.backslashes = true;
          code = advance();
          if (code === CHAR_LEFT_CURLY_BRACE) {
            braceEscaped = true;
          }
          continue;
        }
        if (braceEscaped === true || code === CHAR_LEFT_CURLY_BRACE) {
          braces++;
          while (eos() !== true && (code = advance())) {
            if (code === CHAR_BACKWARD_SLASH) {
              backslashes = token.backslashes = true;
              advance();
              continue;
            }
            if (code === CHAR_LEFT_CURLY_BRACE) {
              braces++;
              continue;
            }
            if (braceEscaped !== true && code === CHAR_DOT && (code = advance()) === CHAR_DOT) {
              isBrace = token.isBrace = true;
              isGlob = token.isGlob = true;
              finished = true;
              if (scanToEnd === true) {
                continue;
              }
              break;
            }
            if (braceEscaped !== true && code === CHAR_COMMA) {
              isBrace = token.isBrace = true;
              isGlob = token.isGlob = true;
              finished = true;
              if (scanToEnd === true) {
                continue;
              }
              break;
            }
            if (code === CHAR_RIGHT_CURLY_BRACE) {
              braces--;
              if (braces === 0) {
                braceEscaped = false;
                isBrace = token.isBrace = true;
                finished = true;
                break;
              }
            }
          }
          if (scanToEnd === true) {
            continue;
          }
          break;
        }
        if (code === CHAR_FORWARD_SLASH) {
          slashes.push(index);
          tokens.push(token);
          token = { value: "", depth: 0, isGlob: false };
          if (finished === true)
            continue;
          if (prev === CHAR_DOT && index === start + 1) {
            start += 2;
            continue;
          }
          lastIndex = index + 1;
          continue;
        }
        if (opts.noext !== true) {
          const isExtglobChar = code === CHAR_PLUS || code === CHAR_AT || code === CHAR_ASTERISK || code === CHAR_QUESTION_MARK || code === CHAR_EXCLAMATION_MARK;
          if (isExtglobChar === true && peek() === CHAR_LEFT_PARENTHESES) {
            isGlob = token.isGlob = true;
            isExtglob = token.isExtglob = true;
            finished = true;
            if (code === CHAR_EXCLAMATION_MARK && index === start) {
              negatedExtglob = true;
            }
            if (scanToEnd === true) {
              while (eos() !== true && (code = advance())) {
                if (code === CHAR_BACKWARD_SLASH) {
                  backslashes = token.backslashes = true;
                  code = advance();
                  continue;
                }
                if (code === CHAR_RIGHT_PARENTHESES) {
                  isGlob = token.isGlob = true;
                  finished = true;
                  break;
                }
              }
              continue;
            }
            break;
          }
        }
        if (code === CHAR_ASTERISK) {
          if (prev === CHAR_ASTERISK)
            isGlobstar = token.isGlobstar = true;
          isGlob = token.isGlob = true;
          finished = true;
          if (scanToEnd === true) {
            continue;
          }
          break;
        }
        if (code === CHAR_QUESTION_MARK) {
          isGlob = token.isGlob = true;
          finished = true;
          if (scanToEnd === true) {
            continue;
          }
          break;
        }
        if (code === CHAR_LEFT_SQUARE_BRACKET) {
          while (eos() !== true && (next = advance())) {
            if (next === CHAR_BACKWARD_SLASH) {
              backslashes = token.backslashes = true;
              advance();
              continue;
            }
            if (next === CHAR_RIGHT_SQUARE_BRACKET) {
              isBracket = token.isBracket = true;
              isGlob = token.isGlob = true;
              finished = true;
              break;
            }
          }
          if (scanToEnd === true) {
            continue;
          }
          break;
        }
        if (opts.nonegate !== true && code === CHAR_EXCLAMATION_MARK && index === start) {
          negated = token.negated = true;
          start++;
          continue;
        }
        if (opts.noparen !== true && code === CHAR_LEFT_PARENTHESES) {
          isGlob = token.isGlob = true;
          if (scanToEnd === true) {
            while (eos() !== true && (code = advance())) {
              if (code === CHAR_LEFT_PARENTHESES) {
                backslashes = token.backslashes = true;
                code = advance();
                continue;
              }
              if (code === CHAR_RIGHT_PARENTHESES) {
                finished = true;
                break;
              }
            }
            continue;
          }
          break;
        }
        if (isGlob === true) {
          finished = true;
          if (scanToEnd === true) {
            continue;
          }
          break;
        }
      }
      if (opts.noext === true) {
        isExtglob = false;
        isGlob = false;
      }
      let base = str;
      let prefix = "";
      let glob = "";
      if (start > 0) {
        prefix = str.slice(0, start);
        str = str.slice(start);
        lastIndex -= start;
      }
      if (base && isGlob === true && lastIndex > 0) {
        base = str.slice(0, lastIndex);
        glob = str.slice(lastIndex);
      } else if (isGlob === true) {
        base = "";
        glob = str;
      } else {
        base = str;
      }
      if (base && base !== "" && base !== "/" && base !== str) {
        if (isPathSeparator(base.charCodeAt(base.length - 1))) {
          base = base.slice(0, -1);
        }
      }
      if (opts.unescape === true) {
        if (glob)
          glob = utils.removeBackslashes(glob);
        if (base && backslashes === true) {
          base = utils.removeBackslashes(base);
        }
      }
      const state = {
        prefix,
        input,
        start,
        base,
        glob,
        isBrace,
        isBracket,
        isGlob,
        isExtglob,
        isGlobstar,
        negated,
        negatedExtglob
      };
      if (opts.tokens === true) {
        state.maxDepth = 0;
        if (!isPathSeparator(code)) {
          tokens.push(token);
        }
        state.tokens = tokens;
      }
      if (opts.parts === true || opts.tokens === true) {
        let prevIndex;
        for (let idx = 0; idx < slashes.length; idx++) {
          const n = prevIndex ? prevIndex + 1 : start;
          const i = slashes[idx];
          const value = input.slice(n, i);
          if (opts.tokens) {
            if (idx === 0 && start !== 0) {
              tokens[idx].isPrefix = true;
              tokens[idx].value = prefix;
            } else {
              tokens[idx].value = value;
            }
            depth(tokens[idx]);
            state.maxDepth += tokens[idx].depth;
          }
          if (idx !== 0 || value !== "") {
            parts.push(value);
          }
          prevIndex = i;
        }
        if (prevIndex && prevIndex + 1 < input.length) {
          const value = input.slice(prevIndex + 1);
          parts.push(value);
          if (opts.tokens) {
            tokens[tokens.length - 1].value = value;
            depth(tokens[tokens.length - 1]);
            state.maxDepth += tokens[tokens.length - 1].depth;
          }
        }
        state.slashes = slashes;
        state.parts = parts;
      }
      return state;
    };
    module2.exports = scan;
  }
});

// node_modules/picomatch/lib/parse.js
var require_parse2 = __commonJS({
  "node_modules/picomatch/lib/parse.js"(exports2, module2) {
    "use strict";
    var constants = require_constants5();
    var utils = require_utils8();
    var {
      MAX_LENGTH,
      POSIX_REGEX_SOURCE,
      REGEX_NON_SPECIAL_CHARS,
      REGEX_SPECIAL_CHARS_BACKREF,
      REPLACEMENTS
    } = constants;
    var expandRange = (args, options) => {
      if (typeof options.expandRange === "function") {
        return options.expandRange(...args, options);
      }
      args.sort();
      const value = `[${args.join("-")}]`;
      try {
        new RegExp(value);
      } catch (ex) {
        return args.map((v) => utils.escapeRegex(v)).join("..");
      }
      return value;
    };
    var syntaxError = (type, char) => {
      return `Missing ${type}: "${char}" - use "\\\\${char}" to match literal characters`;
    };
    var parse6 = (input, options) => {
      if (typeof input !== "string") {
        throw new TypeError("Expected a string");
      }
      input = REPLACEMENTS[input] || input;
      const opts = { ...options };
      const max = typeof opts.maxLength === "number" ? Math.min(MAX_LENGTH, opts.maxLength) : MAX_LENGTH;
      let len = input.length;
      if (len > max) {
        throw new SyntaxError(`Input length: ${len}, exceeds maximum allowed length: ${max}`);
      }
      const bos = { type: "bos", value: "", output: opts.prepend || "" };
      const tokens = [bos];
      const capture = opts.capture ? "" : "?:";
      const win32 = utils.isWindows(options);
      const PLATFORM_CHARS = constants.globChars(win32);
      const EXTGLOB_CHARS = constants.extglobChars(PLATFORM_CHARS);
      const {
        DOT_LITERAL,
        PLUS_LITERAL,
        SLASH_LITERAL,
        ONE_CHAR,
        DOTS_SLASH,
        NO_DOT,
        NO_DOT_SLASH,
        NO_DOTS_SLASH,
        QMARK,
        QMARK_NO_DOT,
        STAR,
        START_ANCHOR
      } = PLATFORM_CHARS;
      const globstar = (opts2) => {
        return `(${capture}(?:(?!${START_ANCHOR}${opts2.dot ? DOTS_SLASH : DOT_LITERAL}).)*?)`;
      };
      const nodot = opts.dot ? "" : NO_DOT;
      const qmarkNoDot = opts.dot ? QMARK : QMARK_NO_DOT;
      let star = opts.bash === true ? globstar(opts) : STAR;
      if (opts.capture) {
        star = `(${star})`;
      }
      if (typeof opts.noext === "boolean") {
        opts.noextglob = opts.noext;
      }
      const state = {
        input,
        index: -1,
        start: 0,
        dot: opts.dot === true,
        consumed: "",
        output: "",
        prefix: "",
        backtrack: false,
        negated: false,
        brackets: 0,
        braces: 0,
        parens: 0,
        quotes: 0,
        globstar: false,
        tokens
      };
      input = utils.removePrefix(input, state);
      len = input.length;
      const extglobs = [];
      const braces = [];
      const stack = [];
      let prev = bos;
      let value;
      const eos = () => state.index === len - 1;
      const peek = state.peek = (n = 1) => input[state.index + n];
      const advance = state.advance = () => input[++state.index] || "";
      const remaining = () => input.slice(state.index + 1);
      const consume = (value2 = "", num = 0) => {
        state.consumed += value2;
        state.index += num;
      };
      const append3 = (token) => {
        state.output += token.output != null ? token.output : token.value;
        consume(token.value);
      };
      const negate = () => {
        let count = 1;
        while (peek() === "!" && (peek(2) !== "(" || peek(3) === "?")) {
          advance();
          state.start++;
          count++;
        }
        if (count % 2 === 0) {
          return false;
        }
        state.negated = true;
        state.start++;
        return true;
      };
      const increment = (type) => {
        state[type]++;
        stack.push(type);
      };
      const decrement = (type) => {
        state[type]--;
        stack.pop();
      };
      const push = (tok) => {
        if (prev.type === "globstar") {
          const isBrace = state.braces > 0 && (tok.type === "comma" || tok.type === "brace");
          const isExtglob = tok.extglob === true || extglobs.length && (tok.type === "pipe" || tok.type === "paren");
          if (tok.type !== "slash" && tok.type !== "paren" && !isBrace && !isExtglob) {
            state.output = state.output.slice(0, -prev.output.length);
            prev.type = "star";
            prev.value = "*";
            prev.output = star;
            state.output += prev.output;
          }
        }
        if (extglobs.length && tok.type !== "paren") {
          extglobs[extglobs.length - 1].inner += tok.value;
        }
        if (tok.value || tok.output)
          append3(tok);
        if (prev && prev.type === "text" && tok.type === "text") {
          prev.value += tok.value;
          prev.output = (prev.output || "") + tok.value;
          return;
        }
        tok.prev = prev;
        tokens.push(tok);
        prev = tok;
      };
      const extglobOpen = (type, value2) => {
        const token = { ...EXTGLOB_CHARS[value2], conditions: 1, inner: "" };
        token.prev = prev;
        token.parens = state.parens;
        token.output = state.output;
        const output = (opts.capture ? "(" : "") + token.open;
        increment("parens");
        push({ type, value: value2, output: state.output ? "" : ONE_CHAR });
        push({ type: "paren", extglob: true, value: advance(), output });
        extglobs.push(token);
      };
      const extglobClose = (token) => {
        let output = token.close + (opts.capture ? ")" : "");
        let rest;
        if (token.type === "negate") {
          let extglobStar = star;
          if (token.inner && token.inner.length > 1 && token.inner.includes("/")) {
            extglobStar = globstar(opts);
          }
          if (extglobStar !== star || eos() || /^\)+$/.test(remaining())) {
            output = token.close = `)$))${extglobStar}`;
          }
          if (token.inner.includes("*") && (rest = remaining()) && /^\.[^\\/.]+$/.test(rest)) {
            const expression = parse6(rest, { ...options, fastpaths: false }).output;
            output = token.close = `)${expression})${extglobStar})`;
          }
          if (token.prev.type === "bos") {
            state.negatedExtglob = true;
          }
        }
        push({ type: "paren", extglob: true, value, output });
        decrement("parens");
      };
      if (opts.fastpaths !== false && !/(^[*!]|[/()[\]{}"])/.test(input)) {
        let backslashes = false;
        let output = input.replace(REGEX_SPECIAL_CHARS_BACKREF, (m2, esc, chars, first, rest, index) => {
          if (first === "\\") {
            backslashes = true;
            return m2;
          }
          if (first === "?") {
            if (esc) {
              return esc + first + (rest ? QMARK.repeat(rest.length) : "");
            }
            if (index === 0) {
              return qmarkNoDot + (rest ? QMARK.repeat(rest.length) : "");
            }
            return QMARK.repeat(chars.length);
          }
          if (first === ".") {
            return DOT_LITERAL.repeat(chars.length);
          }
          if (first === "*") {
            if (esc) {
              return esc + first + (rest ? star : "");
            }
            return star;
          }
          return esc ? m2 : `\\${m2}`;
        });
        if (backslashes === true) {
          if (opts.unescape === true) {
            output = output.replace(/\\/g, "");
          } else {
            output = output.replace(/\\+/g, (m2) => {
              return m2.length % 2 === 0 ? "\\\\" : m2 ? "\\" : "";
            });
          }
        }
        if (output === input && opts.contains === true) {
          state.output = input;
          return state;
        }
        state.output = utils.wrapOutput(output, state, options);
        return state;
      }
      while (!eos()) {
        value = advance();
        if (value === "\0") {
          continue;
        }
        if (value === "\\") {
          const next = peek();
          if (next === "/" && opts.bash !== true) {
            continue;
          }
          if (next === "." || next === ";") {
            continue;
          }
          if (!next) {
            value += "\\";
            push({ type: "text", value });
            continue;
          }
          const match = /^\\+/.exec(remaining());
          let slashes = 0;
          if (match && match[0].length > 2) {
            slashes = match[0].length;
            state.index += slashes;
            if (slashes % 2 !== 0) {
              value += "\\";
            }
          }
          if (opts.unescape === true) {
            value = advance();
          } else {
            value += advance();
          }
          if (state.brackets === 0) {
            push({ type: "text", value });
            continue;
          }
        }
        if (state.brackets > 0 && (value !== "]" || prev.value === "[" || prev.value === "[^")) {
          if (opts.posix !== false && value === ":") {
            const inner = prev.value.slice(1);
            if (inner.includes("[")) {
              prev.posix = true;
              if (inner.includes(":")) {
                const idx = prev.value.lastIndexOf("[");
                const pre = prev.value.slice(0, idx);
                const rest2 = prev.value.slice(idx + 2);
                const posix = POSIX_REGEX_SOURCE[rest2];
                if (posix) {
                  prev.value = pre + posix;
                  state.backtrack = true;
                  advance();
                  if (!bos.output && tokens.indexOf(prev) === 1) {
                    bos.output = ONE_CHAR;
                  }
                  continue;
                }
              }
            }
          }
          if (value === "[" && peek() !== ":" || value === "-" && peek() === "]") {
            value = `\\${value}`;
          }
          if (value === "]" && (prev.value === "[" || prev.value === "[^")) {
            value = `\\${value}`;
          }
          if (opts.posix === true && value === "!" && prev.value === "[") {
            value = "^";
          }
          prev.value += value;
          append3({ value });
          continue;
        }
        if (state.quotes === 1 && value !== '"') {
          value = utils.escapeRegex(value);
          prev.value += value;
          append3({ value });
          continue;
        }
        if (value === '"') {
          state.quotes = state.quotes === 1 ? 0 : 1;
          if (opts.keepQuotes === true) {
            push({ type: "text", value });
          }
          continue;
        }
        if (value === "(") {
          increment("parens");
          push({ type: "paren", value });
          continue;
        }
        if (value === ")") {
          if (state.parens === 0 && opts.strictBrackets === true) {
            throw new SyntaxError(syntaxError("opening", "("));
          }
          const extglob = extglobs[extglobs.length - 1];
          if (extglob && state.parens === extglob.parens + 1) {
            extglobClose(extglobs.pop());
            continue;
          }
          push({ type: "paren", value, output: state.parens ? ")" : "\\)" });
          decrement("parens");
          continue;
        }
        if (value === "[") {
          if (opts.nobracket === true || !remaining().includes("]")) {
            if (opts.nobracket !== true && opts.strictBrackets === true) {
              throw new SyntaxError(syntaxError("closing", "]"));
            }
            value = `\\${value}`;
          } else {
            increment("brackets");
          }
          push({ type: "bracket", value });
          continue;
        }
        if (value === "]") {
          if (opts.nobracket === true || prev && prev.type === "bracket" && prev.value.length === 1) {
            push({ type: "text", value, output: `\\${value}` });
            continue;
          }
          if (state.brackets === 0) {
            if (opts.strictBrackets === true) {
              throw new SyntaxError(syntaxError("opening", "["));
            }
            push({ type: "text", value, output: `\\${value}` });
            continue;
          }
          decrement("brackets");
          const prevValue = prev.value.slice(1);
          if (prev.posix !== true && prevValue[0] === "^" && !prevValue.includes("/")) {
            value = `/${value}`;
          }
          prev.value += value;
          append3({ value });
          if (opts.literalBrackets === false || utils.hasRegexChars(prevValue)) {
            continue;
          }
          const escaped = utils.escapeRegex(prev.value);
          state.output = state.output.slice(0, -prev.value.length);
          if (opts.literalBrackets === true) {
            state.output += escaped;
            prev.value = escaped;
            continue;
          }
          prev.value = `(${capture}${escaped}|${prev.value})`;
          state.output += prev.value;
          continue;
        }
        if (value === "{" && opts.nobrace !== true) {
          increment("braces");
          const open = {
            type: "brace",
            value,
            output: "(",
            outputIndex: state.output.length,
            tokensIndex: state.tokens.length
          };
          braces.push(open);
          push(open);
          continue;
        }
        if (value === "}") {
          const brace = braces[braces.length - 1];
          if (opts.nobrace === true || !brace) {
            push({ type: "text", value, output: value });
            continue;
          }
          let output = ")";
          if (brace.dots === true) {
            const arr = tokens.slice();
            const range = [];
            for (let i = arr.length - 1; i >= 0; i--) {
              tokens.pop();
              if (arr[i].type === "brace") {
                break;
              }
              if (arr[i].type !== "dots") {
                range.unshift(arr[i].value);
              }
            }
            output = expandRange(range, opts);
            state.backtrack = true;
          }
          if (brace.comma !== true && brace.dots !== true) {
            const out = state.output.slice(0, brace.outputIndex);
            const toks = state.tokens.slice(brace.tokensIndex);
            brace.value = brace.output = "\\{";
            value = output = "\\}";
            state.output = out;
            for (const t of toks) {
              state.output += t.output || t.value;
            }
          }
          push({ type: "brace", value, output });
          decrement("braces");
          braces.pop();
          continue;
        }
        if (value === "|") {
          if (extglobs.length > 0) {
            extglobs[extglobs.length - 1].conditions++;
          }
          push({ type: "text", value });
          continue;
        }
        if (value === ",") {
          let output = value;
          const brace = braces[braces.length - 1];
          if (brace && stack[stack.length - 1] === "braces") {
            brace.comma = true;
            output = "|";
          }
          push({ type: "comma", value, output });
          continue;
        }
        if (value === "/") {
          if (prev.type === "dot" && state.index === state.start + 1) {
            state.start = state.index + 1;
            state.consumed = "";
            state.output = "";
            tokens.pop();
            prev = bos;
            continue;
          }
          push({ type: "slash", value, output: SLASH_LITERAL });
          continue;
        }
        if (value === ".") {
          if (state.braces > 0 && prev.type === "dot") {
            if (prev.value === ".")
              prev.output = DOT_LITERAL;
            const brace = braces[braces.length - 1];
            prev.type = "dots";
            prev.output += value;
            prev.value += value;
            brace.dots = true;
            continue;
          }
          if (state.braces + state.parens === 0 && prev.type !== "bos" && prev.type !== "slash") {
            push({ type: "text", value, output: DOT_LITERAL });
            continue;
          }
          push({ type: "dot", value, output: DOT_LITERAL });
          continue;
        }
        if (value === "?") {
          const isGroup = prev && prev.value === "(";
          if (!isGroup && opts.noextglob !== true && peek() === "(" && peek(2) !== "?") {
            extglobOpen("qmark", value);
            continue;
          }
          if (prev && prev.type === "paren") {
            const next = peek();
            let output = value;
            if (next === "<" && !utils.supportsLookbehinds()) {
              throw new Error("Node.js v10 or higher is required for regex lookbehinds");
            }
            if (prev.value === "(" && !/[!=<:]/.test(next) || next === "<" && !/<([!=]|\w+>)/.test(remaining())) {
              output = `\\${value}`;
            }
            push({ type: "text", value, output });
            continue;
          }
          if (opts.dot !== true && (prev.type === "slash" || prev.type === "bos")) {
            push({ type: "qmark", value, output: QMARK_NO_DOT });
            continue;
          }
          push({ type: "qmark", value, output: QMARK });
          continue;
        }
        if (value === "!") {
          if (opts.noextglob !== true && peek() === "(") {
            if (peek(2) !== "?" || !/[!=<:]/.test(peek(3))) {
              extglobOpen("negate", value);
              continue;
            }
          }
          if (opts.nonegate !== true && state.index === 0) {
            negate();
            continue;
          }
        }
        if (value === "+") {
          if (opts.noextglob !== true && peek() === "(" && peek(2) !== "?") {
            extglobOpen("plus", value);
            continue;
          }
          if (prev && prev.value === "(" || opts.regex === false) {
            push({ type: "plus", value, output: PLUS_LITERAL });
            continue;
          }
          if (prev && (prev.type === "bracket" || prev.type === "paren" || prev.type === "brace") || state.parens > 0) {
            push({ type: "plus", value });
            continue;
          }
          push({ type: "plus", value: PLUS_LITERAL });
          continue;
        }
        if (value === "@") {
          if (opts.noextglob !== true && peek() === "(" && peek(2) !== "?") {
            push({ type: "at", extglob: true, value, output: "" });
            continue;
          }
          push({ type: "text", value });
          continue;
        }
        if (value !== "*") {
          if (value === "$" || value === "^") {
            value = `\\${value}`;
          }
          const match = REGEX_NON_SPECIAL_CHARS.exec(remaining());
          if (match) {
            value += match[0];
            state.index += match[0].length;
          }
          push({ type: "text", value });
          continue;
        }
        if (prev && (prev.type === "globstar" || prev.star === true)) {
          prev.type = "star";
          prev.star = true;
          prev.value += value;
          prev.output = star;
          state.backtrack = true;
          state.globstar = true;
          consume(value);
          continue;
        }
        let rest = remaining();
        if (opts.noextglob !== true && /^\([^?]/.test(rest)) {
          extglobOpen("star", value);
          continue;
        }
        if (prev.type === "star") {
          if (opts.noglobstar === true) {
            consume(value);
            continue;
          }
          const prior = prev.prev;
          const before = prior.prev;
          const isStart = prior.type === "slash" || prior.type === "bos";
          const afterStar = before && (before.type === "star" || before.type === "globstar");
          if (opts.bash === true && (!isStart || rest[0] && rest[0] !== "/")) {
            push({ type: "star", value, output: "" });
            continue;
          }
          const isBrace = state.braces > 0 && (prior.type === "comma" || prior.type === "brace");
          const isExtglob = extglobs.length && (prior.type === "pipe" || prior.type === "paren");
          if (!isStart && prior.type !== "paren" && !isBrace && !isExtglob) {
            push({ type: "star", value, output: "" });
            continue;
          }
          while (rest.slice(0, 3) === "/**") {
            const after = input[state.index + 4];
            if (after && after !== "/") {
              break;
            }
            rest = rest.slice(3);
            consume("/**", 3);
          }
          if (prior.type === "bos" && eos()) {
            prev.type = "globstar";
            prev.value += value;
            prev.output = globstar(opts);
            state.output = prev.output;
            state.globstar = true;
            consume(value);
            continue;
          }
          if (prior.type === "slash" && prior.prev.type !== "bos" && !afterStar && eos()) {
            state.output = state.output.slice(0, -(prior.output + prev.output).length);
            prior.output = `(?:${prior.output}`;
            prev.type = "globstar";
            prev.output = globstar(opts) + (opts.strictSlashes ? ")" : "|$)");
            prev.value += value;
            state.globstar = true;
            state.output += prior.output + prev.output;
            consume(value);
            continue;
          }
          if (prior.type === "slash" && prior.prev.type !== "bos" && rest[0] === "/") {
            const end = rest[1] !== void 0 ? "|$" : "";
            state.output = state.output.slice(0, -(prior.output + prev.output).length);
            prior.output = `(?:${prior.output}`;
            prev.type = "globstar";
            prev.output = `${globstar(opts)}${SLASH_LITERAL}|${SLASH_LITERAL}${end})`;
            prev.value += value;
            state.output += prior.output + prev.output;
            state.globstar = true;
            consume(value + advance());
            push({ type: "slash", value: "/", output: "" });
            continue;
          }
          if (prior.type === "bos" && rest[0] === "/") {
            prev.type = "globstar";
            prev.value += value;
            prev.output = `(?:^|${SLASH_LITERAL}|${globstar(opts)}${SLASH_LITERAL})`;
            state.output = prev.output;
            state.globstar = true;
            consume(value + advance());
            push({ type: "slash", value: "/", output: "" });
            continue;
          }
          state.output = state.output.slice(0, -prev.output.length);
          prev.type = "globstar";
          prev.output = globstar(opts);
          prev.value += value;
          state.output += prev.output;
          state.globstar = true;
          consume(value);
          continue;
        }
        const token = { type: "star", value, output: star };
        if (opts.bash === true) {
          token.output = ".*?";
          if (prev.type === "bos" || prev.type === "slash") {
            token.output = nodot + token.output;
          }
          push(token);
          continue;
        }
        if (prev && (prev.type === "bracket" || prev.type === "paren") && opts.regex === true) {
          token.output = value;
          push(token);
          continue;
        }
        if (state.index === state.start || prev.type === "slash" || prev.type === "dot") {
          if (prev.type === "dot") {
            state.output += NO_DOT_SLASH;
            prev.output += NO_DOT_SLASH;
          } else if (opts.dot === true) {
            state.output += NO_DOTS_SLASH;
            prev.output += NO_DOTS_SLASH;
          } else {
            state.output += nodot;
            prev.output += nodot;
          }
          if (peek() !== "*") {
            state.output += ONE_CHAR;
            prev.output += ONE_CHAR;
          }
        }
        push(token);
      }
      while (state.brackets > 0) {
        if (opts.strictBrackets === true)
          throw new SyntaxError(syntaxError("closing", "]"));
        state.output = utils.escapeLast(state.output, "[");
        decrement("brackets");
      }
      while (state.parens > 0) {
        if (opts.strictBrackets === true)
          throw new SyntaxError(syntaxError("closing", ")"));
        state.output = utils.escapeLast(state.output, "(");
        decrement("parens");
      }
      while (state.braces > 0) {
        if (opts.strictBrackets === true)
          throw new SyntaxError(syntaxError("closing", "}"));
        state.output = utils.escapeLast(state.output, "{");
        decrement("braces");
      }
      if (opts.strictSlashes !== true && (prev.type === "star" || prev.type === "bracket")) {
        push({ type: "maybe_slash", value: "", output: `${SLASH_LITERAL}?` });
      }
      if (state.backtrack === true) {
        state.output = "";
        for (const token of state.tokens) {
          state.output += token.output != null ? token.output : token.value;
          if (token.suffix) {
            state.output += token.suffix;
          }
        }
      }
      return state;
    };
    parse6.fastpaths = (input, options) => {
      const opts = { ...options };
      const max = typeof opts.maxLength === "number" ? Math.min(MAX_LENGTH, opts.maxLength) : MAX_LENGTH;
      const len = input.length;
      if (len > max) {
        throw new SyntaxError(`Input length: ${len}, exceeds maximum allowed length: ${max}`);
      }
      input = REPLACEMENTS[input] || input;
      const win32 = utils.isWindows(options);
      const {
        DOT_LITERAL,
        SLASH_LITERAL,
        ONE_CHAR,
        DOTS_SLASH,
        NO_DOT,
        NO_DOTS,
        NO_DOTS_SLASH,
        STAR,
        START_ANCHOR
      } = constants.globChars(win32);
      const nodot = opts.dot ? NO_DOTS : NO_DOT;
      const slashDot = opts.dot ? NO_DOTS_SLASH : NO_DOT;
      const capture = opts.capture ? "" : "?:";
      const state = { negated: false, prefix: "" };
      let star = opts.bash === true ? ".*?" : STAR;
      if (opts.capture) {
        star = `(${star})`;
      }
      const globstar = (opts2) => {
        if (opts2.noglobstar === true)
          return star;
        return `(${capture}(?:(?!${START_ANCHOR}${opts2.dot ? DOTS_SLASH : DOT_LITERAL}).)*?)`;
      };
      const create = (str) => {
        switch (str) {
          case "*":
            return `${nodot}${ONE_CHAR}${star}`;
          case ".*":
            return `${DOT_LITERAL}${ONE_CHAR}${star}`;
          case "*.*":
            return `${nodot}${star}${DOT_LITERAL}${ONE_CHAR}${star}`;
          case "*/*":
            return `${nodot}${star}${SLASH_LITERAL}${ONE_CHAR}${slashDot}${star}`;
          case "**":
            return nodot + globstar(opts);
          case "**/*":
            return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL})?${slashDot}${ONE_CHAR}${star}`;
          case "**/*.*":
            return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL})?${slashDot}${star}${DOT_LITERAL}${ONE_CHAR}${star}`;
          case "**/.*":
            return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL})?${DOT_LITERAL}${ONE_CHAR}${star}`;
          default: {
            const match = /^(.*?)\.(\w+)$/.exec(str);
            if (!match)
              return;
            const source2 = create(match[1]);
            if (!source2)
              return;
            return source2 + DOT_LITERAL + match[2];
          }
        }
      };
      const output = utils.removePrefix(input, state);
      let source = create(output);
      if (source && opts.strictSlashes !== true) {
        source += `${SLASH_LITERAL}?`;
      }
      return source;
    };
    module2.exports = parse6;
  }
});

// node_modules/picomatch/lib/picomatch.js
var require_picomatch = __commonJS({
  "node_modules/picomatch/lib/picomatch.js"(exports2, module2) {
    "use strict";
    var path3 = require("path");
    var scan = require_scan();
    var parse6 = require_parse2();
    var utils = require_utils8();
    var constants = require_constants5();
    var isObject = (val) => val && typeof val === "object" && !Array.isArray(val);
    var picomatch = (glob, options, returnState = false) => {
      if (Array.isArray(glob)) {
        const fns = glob.map((input) => picomatch(input, options, returnState));
        const arrayMatcher = (str) => {
          for (const isMatch of fns) {
            const state2 = isMatch(str);
            if (state2)
              return state2;
          }
          return false;
        };
        return arrayMatcher;
      }
      const isState = isObject(glob) && glob.tokens && glob.input;
      if (glob === "" || typeof glob !== "string" && !isState) {
        throw new TypeError("Expected pattern to be a non-empty string");
      }
      const opts = options || {};
      const posix = utils.isWindows(options);
      const regex = isState ? picomatch.compileRe(glob, options) : picomatch.makeRe(glob, options, false, true);
      const state = regex.state;
      delete regex.state;
      let isIgnored = () => false;
      if (opts.ignore) {
        const ignoreOpts = { ...options, ignore: null, onMatch: null, onResult: null };
        isIgnored = picomatch(opts.ignore, ignoreOpts, returnState);
      }
      const matcher = (input, returnObject = false) => {
        const { isMatch, match, output } = picomatch.test(input, regex, options, { glob, posix });
        const result2 = { glob, state, regex, posix, input, output, match, isMatch };
        if (typeof opts.onResult === "function") {
          opts.onResult(result2);
        }
        if (isMatch === false) {
          result2.isMatch = false;
          return returnObject ? result2 : false;
        }
        if (isIgnored(input)) {
          if (typeof opts.onIgnore === "function") {
            opts.onIgnore(result2);
          }
          result2.isMatch = false;
          return returnObject ? result2 : false;
        }
        if (typeof opts.onMatch === "function") {
          opts.onMatch(result2);
        }
        return returnObject ? result2 : true;
      };
      if (returnState) {
        matcher.state = state;
      }
      return matcher;
    };
    picomatch.test = (input, regex, options, { glob, posix } = {}) => {
      if (typeof input !== "string") {
        throw new TypeError("Expected input to be a string");
      }
      if (input === "") {
        return { isMatch: false, output: "" };
      }
      const opts = options || {};
      const format3 = opts.format || (posix ? utils.toPosixSlashes : null);
      let match = input === glob;
      let output = match && format3 ? format3(input) : input;
      if (match === false) {
        output = format3 ? format3(input) : input;
        match = output === glob;
      }
      if (match === false || opts.capture === true) {
        if (opts.matchBase === true || opts.basename === true) {
          match = picomatch.matchBase(input, regex, options, posix);
        } else {
          match = regex.exec(output);
        }
      }
      return { isMatch: Boolean(match), match, output };
    };
    picomatch.matchBase = (input, glob, options, posix = utils.isWindows(options)) => {
      const regex = glob instanceof RegExp ? glob : picomatch.makeRe(glob, options);
      return regex.test(path3.basename(input));
    };
    picomatch.isMatch = (str, patterns, options) => picomatch(patterns, options)(str);
    picomatch.parse = (pattern, options) => {
      if (Array.isArray(pattern))
        return pattern.map((p3) => picomatch.parse(p3, options));
      return parse6(pattern, { ...options, fastpaths: false });
    };
    picomatch.scan = (input, options) => scan(input, options);
    picomatch.compileRe = (state, options, returnOutput = false, returnState = false) => {
      if (returnOutput === true) {
        return state.output;
      }
      const opts = options || {};
      const prepend = opts.contains ? "" : "^";
      const append3 = opts.contains ? "" : "$";
      let source = `${prepend}(?:${state.output})${append3}`;
      if (state && state.negated === true) {
        source = `^(?!${source}).*$`;
      }
      const regex = picomatch.toRegex(source, options);
      if (returnState === true) {
        regex.state = state;
      }
      return regex;
    };
    picomatch.makeRe = (input, options = {}, returnOutput = false, returnState = false) => {
      if (!input || typeof input !== "string") {
        throw new TypeError("Expected a non-empty string");
      }
      let parsed = { negated: false, fastpaths: true };
      if (options.fastpaths !== false && (input[0] === "." || input[0] === "*")) {
        parsed.output = parse6.fastpaths(input, options);
      }
      if (!parsed.output) {
        parsed = parse6(input, options);
      }
      return picomatch.compileRe(parsed, options, returnOutput, returnState);
    };
    picomatch.toRegex = (source, options) => {
      try {
        const opts = options || {};
        return new RegExp(source, opts.flags || (opts.nocase ? "i" : ""));
      } catch (err) {
        if (options && options.debug === true)
          throw err;
        return /$^/;
      }
    };
    picomatch.constants = constants;
    module2.exports = picomatch;
  }
});

// node_modules/picomatch/index.js
var require_picomatch2 = __commonJS({
  "node_modules/picomatch/index.js"(exports2, module2) {
    "use strict";
    module2.exports = require_picomatch();
  }
});

// node_modules/readdirp/index.js
var require_readdirp = __commonJS({
  "node_modules/readdirp/index.js"(exports2, module2) {
    "use strict";
    var fs2 = require("fs");
    var { Readable } = require("stream");
    var sysPath = require("path");
    var { promisify } = require("util");
    var picomatch = require_picomatch2();
    var readdir = promisify(fs2.readdir);
    var stat = promisify(fs2.stat);
    var lstat = promisify(fs2.lstat);
    var realpath = promisify(fs2.realpath);
    var BANG = "!";
    var RECURSIVE_ERROR_CODE = "READDIRP_RECURSIVE_ERROR";
    var NORMAL_FLOW_ERRORS = /* @__PURE__ */ new Set(["ENOENT", "EPERM", "EACCES", "ELOOP", RECURSIVE_ERROR_CODE]);
    var FILE_TYPE = "files";
    var DIR_TYPE = "directories";
    var FILE_DIR_TYPE = "files_directories";
    var EVERYTHING_TYPE = "all";
    var ALL_TYPES = [FILE_TYPE, DIR_TYPE, FILE_DIR_TYPE, EVERYTHING_TYPE];
    var isNormalFlowError = (error) => NORMAL_FLOW_ERRORS.has(error.code);
    var [maj, min] = process.versions.node.split(".").slice(0, 2).map((n) => Number.parseInt(n, 10));
    var wantBigintFsStats = process.platform === "win32" && (maj > 10 || maj === 10 && min >= 5);
    var normalizeFilter = (filter) => {
      if (filter === void 0)
        return;
      if (typeof filter === "function")
        return filter;
      if (typeof filter === "string") {
        const glob = picomatch(filter.trim());
        return (entry) => glob(entry.basename);
      }
      if (Array.isArray(filter)) {
        const positive = [];
        const negative = [];
        for (const item of filter) {
          const trimmed = item.trim();
          if (trimmed.charAt(0) === BANG) {
            negative.push(picomatch(trimmed.slice(1)));
          } else {
            positive.push(picomatch(trimmed));
          }
        }
        if (negative.length > 0) {
          if (positive.length > 0) {
            return (entry) => positive.some((f2) => f2(entry.basename)) && !negative.some((f2) => f2(entry.basename));
          }
          return (entry) => !negative.some((f2) => f2(entry.basename));
        }
        return (entry) => positive.some((f2) => f2(entry.basename));
      }
    };
    var ReaddirpStream = class _ReaddirpStream extends Readable {
      static get defaultOptions() {
        return {
          root: ".",
          /* eslint-disable no-unused-vars */
          fileFilter: (path3) => true,
          directoryFilter: (path3) => true,
          /* eslint-enable no-unused-vars */
          type: FILE_TYPE,
          lstat: false,
          depth: 2147483648,
          alwaysStat: false
        };
      }
      constructor(options = {}) {
        super({
          objectMode: true,
          autoDestroy: true,
          highWaterMark: options.highWaterMark || 4096
        });
        const opts = { ..._ReaddirpStream.defaultOptions, ...options };
        const { root, type } = opts;
        this._fileFilter = normalizeFilter(opts.fileFilter);
        this._directoryFilter = normalizeFilter(opts.directoryFilter);
        const statMethod = opts.lstat ? lstat : stat;
        if (wantBigintFsStats) {
          this._stat = (path3) => statMethod(path3, { bigint: true });
        } else {
          this._stat = statMethod;
        }
        this._maxDepth = opts.depth;
        this._wantsDir = [DIR_TYPE, FILE_DIR_TYPE, EVERYTHING_TYPE].includes(type);
        this._wantsFile = [FILE_TYPE, FILE_DIR_TYPE, EVERYTHING_TYPE].includes(type);
        this._wantsEverything = type === EVERYTHING_TYPE;
        this._root = sysPath.resolve(root);
        this._isDirent = "Dirent" in fs2 && !opts.alwaysStat;
        this._statsProp = this._isDirent ? "dirent" : "stats";
        this._rdOptions = { encoding: "utf8", withFileTypes: this._isDirent };
        this.parents = [this._exploreDir(root, 1)];
        this.reading = false;
        this.parent = void 0;
      }
      async _read(batch) {
        if (this.reading)
          return;
        this.reading = true;
        try {
          while (!this.destroyed && batch > 0) {
            const { path: path3, depth, files = [] } = this.parent || {};
            if (files.length > 0) {
              const slice = files.splice(0, batch).map((dirent) => this._formatEntry(dirent, path3));
              for (const entry of await Promise.all(slice)) {
                if (this.destroyed)
                  return;
                const entryType = await this._getEntryType(entry);
                if (entryType === "directory" && this._directoryFilter(entry)) {
                  if (depth <= this._maxDepth) {
                    this.parents.push(this._exploreDir(entry.fullPath, depth + 1));
                  }
                  if (this._wantsDir) {
                    this.push(entry);
                    batch--;
                  }
                } else if ((entryType === "file" || this._includeAsFile(entry)) && this._fileFilter(entry)) {
                  if (this._wantsFile) {
                    this.push(entry);
                    batch--;
                  }
                }
              }
            } else {
              const parent = this.parents.pop();
              if (!parent) {
                this.push(null);
                break;
              }
              this.parent = await parent;
              if (this.destroyed)
                return;
            }
          }
        } catch (error) {
          this.destroy(error);
        } finally {
          this.reading = false;
        }
      }
      async _exploreDir(path3, depth) {
        let files;
        try {
          files = await readdir(path3, this._rdOptions);
        } catch (error) {
          this._onError(error);
        }
        return { files, depth, path: path3 };
      }
      async _formatEntry(dirent, path3) {
        let entry;
        try {
          const basename2 = this._isDirent ? dirent.name : dirent;
          const fullPath = sysPath.resolve(sysPath.join(path3, basename2));
          entry = { path: sysPath.relative(this._root, fullPath), fullPath, basename: basename2 };
          entry[this._statsProp] = this._isDirent ? dirent : await this._stat(fullPath);
        } catch (err) {
          this._onError(err);
        }
        return entry;
      }
      _onError(err) {
        if (isNormalFlowError(err) && !this.destroyed) {
          this.emit("warn", err);
        } else {
          this.destroy(err);
        }
      }
      async _getEntryType(entry) {
        const stats = entry && entry[this._statsProp];
        if (!stats) {
          return;
        }
        if (stats.isFile()) {
          return "file";
        }
        if (stats.isDirectory()) {
          return "directory";
        }
        if (stats && stats.isSymbolicLink()) {
          const full = entry.fullPath;
          try {
            const entryRealPath = await realpath(full);
            const entryRealPathStats = await lstat(entryRealPath);
            if (entryRealPathStats.isFile()) {
              return "file";
            }
            if (entryRealPathStats.isDirectory()) {
              const len = entryRealPath.length;
              if (full.startsWith(entryRealPath) && full.substr(len, 1) === sysPath.sep) {
                const recursiveError = new Error(
                  `Circular symlink detected: "${full}" points to "${entryRealPath}"`
                );
                recursiveError.code = RECURSIVE_ERROR_CODE;
                return this._onError(recursiveError);
              }
              return "directory";
            }
          } catch (error) {
            this._onError(error);
          }
        }
      }
      _includeAsFile(entry) {
        const stats = entry && entry[this._statsProp];
        return stats && this._wantsEverything && !stats.isDirectory();
      }
    };
    var readdirp = (root, options = {}) => {
      let type = options.entryType || options.type;
      if (type === "both")
        type = FILE_DIR_TYPE;
      if (type)
        options.type = type;
      if (!root) {
        throw new Error("readdirp: root argument is required. Usage: readdirp(root, options)");
      } else if (typeof root !== "string") {
        throw new TypeError("readdirp: root argument must be a string. Usage: readdirp(root, options)");
      } else if (type && !ALL_TYPES.includes(type)) {
        throw new Error(`readdirp: Invalid type passed. Use one of ${ALL_TYPES.join(", ")}`);
      }
      options.root = root;
      return new ReaddirpStream(options);
    };
    var readdirpPromise = (root, options = {}) => {
      return new Promise((resolve2, reject) => {
        const files = [];
        readdirp(root, options).on("data", (entry) => files.push(entry)).on("end", () => resolve2(files)).on("error", (error) => reject(error));
      });
    };
    readdirp.promise = readdirpPromise;
    readdirp.ReaddirpStream = ReaddirpStream;
    readdirp.default = readdirp;
    module2.exports = readdirp;
  }
});

// node_modules/normalize-path/index.js
var require_normalize_path = __commonJS({
  "node_modules/normalize-path/index.js"(exports2, module2) {
    module2.exports = function(path3, stripTrailing) {
      if (typeof path3 !== "string") {
        throw new TypeError("expected path to be a string");
      }
      if (path3 === "\\" || path3 === "/")
        return "/";
      var len = path3.length;
      if (len <= 1)
        return path3;
      var prefix = "";
      if (len > 4 && path3[3] === "\\") {
        var ch = path3[2];
        if ((ch === "?" || ch === ".") && path3.slice(0, 2) === "\\\\") {
          path3 = path3.slice(2);
          prefix = "//";
        }
      }
      var segs = path3.split(/[/\\]+/);
      if (stripTrailing !== false && segs[segs.length - 1] === "") {
        segs.pop();
      }
      return prefix + segs.join("/");
    };
  }
});

// node_modules/anymatch/index.js
var require_anymatch = __commonJS({
  "node_modules/anymatch/index.js"(exports2, module2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var picomatch = require_picomatch2();
    var normalizePath = require_normalize_path();
    var BANG = "!";
    var DEFAULT_OPTIONS = { returnIndex: false };
    var arrify = (item) => Array.isArray(item) ? item : [item];
    var createPattern = (matcher, options) => {
      if (typeof matcher === "function") {
        return matcher;
      }
      if (typeof matcher === "string") {
        const glob = picomatch(matcher, options);
        return (string) => matcher === string || glob(string);
      }
      if (matcher instanceof RegExp) {
        return (string) => matcher.test(string);
      }
      return (string) => false;
    };
    var matchPatterns = (patterns, negPatterns, args, returnIndex) => {
      const isList = Array.isArray(args);
      const _path = isList ? args[0] : args;
      if (!isList && typeof _path !== "string") {
        throw new TypeError("anymatch: second argument must be a string: got " + Object.prototype.toString.call(_path));
      }
      const path3 = normalizePath(_path, false);
      for (let index = 0; index < negPatterns.length; index++) {
        const nglob = negPatterns[index];
        if (nglob(path3)) {
          return returnIndex ? -1 : false;
        }
      }
      const applied = isList && [path3].concat(args.slice(1));
      for (let index = 0; index < patterns.length; index++) {
        const pattern = patterns[index];
        if (isList ? pattern(...applied) : pattern(path3)) {
          return returnIndex ? index : true;
        }
      }
      return returnIndex ? -1 : false;
    };
    var anymatch = (matchers, testString, options = DEFAULT_OPTIONS) => {
      if (matchers == null) {
        throw new TypeError("anymatch: specify first argument");
      }
      const opts = typeof options === "boolean" ? { returnIndex: options } : options;
      const returnIndex = opts.returnIndex || false;
      const mtchers = arrify(matchers);
      const negatedGlobs = mtchers.filter((item) => typeof item === "string" && item.charAt(0) === BANG).map((item) => item.slice(1)).map((item) => picomatch(item, opts));
      const patterns = mtchers.filter((item) => typeof item !== "string" || typeof item === "string" && item.charAt(0) !== BANG).map((matcher) => createPattern(matcher, opts));
      if (testString == null) {
        return (testString2, ri = false) => {
          const returnIndex2 = typeof ri === "boolean" ? ri : false;
          return matchPatterns(patterns, negatedGlobs, testString2, returnIndex2);
        };
      }
      return matchPatterns(patterns, negatedGlobs, testString, returnIndex);
    };
    anymatch.default = anymatch;
    module2.exports = anymatch;
  }
});

// node_modules/is-extglob/index.js
var require_is_extglob = __commonJS({
  "node_modules/is-extglob/index.js"(exports2, module2) {
    module2.exports = function isExtglob(str) {
      if (typeof str !== "string" || str === "") {
        return false;
      }
      var match;
      while (match = /(\\).|([@?!+*]\(.*\))/g.exec(str)) {
        if (match[2])
          return true;
        str = str.slice(match.index + match[0].length);
      }
      return false;
    };
  }
});

// node_modules/is-glob/index.js
var require_is_glob = __commonJS({
  "node_modules/is-glob/index.js"(exports2, module2) {
    var isExtglob = require_is_extglob();
    var chars = { "{": "}", "(": ")", "[": "]" };
    var strictCheck = function(str) {
      if (str[0] === "!") {
        return true;
      }
      var index = 0;
      var pipeIndex = -2;
      var closeSquareIndex = -2;
      var closeCurlyIndex = -2;
      var closeParenIndex = -2;
      var backSlashIndex = -2;
      while (index < str.length) {
        if (str[index] === "*") {
          return true;
        }
        if (str[index + 1] === "?" && /[\].+)]/.test(str[index])) {
          return true;
        }
        if (closeSquareIndex !== -1 && str[index] === "[" && str[index + 1] !== "]") {
          if (closeSquareIndex < index) {
            closeSquareIndex = str.indexOf("]", index);
          }
          if (closeSquareIndex > index) {
            if (backSlashIndex === -1 || backSlashIndex > closeSquareIndex) {
              return true;
            }
            backSlashIndex = str.indexOf("\\", index);
            if (backSlashIndex === -1 || backSlashIndex > closeSquareIndex) {
              return true;
            }
          }
        }
        if (closeCurlyIndex !== -1 && str[index] === "{" && str[index + 1] !== "}") {
          closeCurlyIndex = str.indexOf("}", index);
          if (closeCurlyIndex > index) {
            backSlashIndex = str.indexOf("\\", index);
            if (backSlashIndex === -1 || backSlashIndex > closeCurlyIndex) {
              return true;
            }
          }
        }
        if (closeParenIndex !== -1 && str[index] === "(" && str[index + 1] === "?" && /[:!=]/.test(str[index + 2]) && str[index + 3] !== ")") {
          closeParenIndex = str.indexOf(")", index);
          if (closeParenIndex > index) {
            backSlashIndex = str.indexOf("\\", index);
            if (backSlashIndex === -1 || backSlashIndex > closeParenIndex) {
              return true;
            }
          }
        }
        if (pipeIndex !== -1 && str[index] === "(" && str[index + 1] !== "|") {
          if (pipeIndex < index) {
            pipeIndex = str.indexOf("|", index);
          }
          if (pipeIndex !== -1 && str[pipeIndex + 1] !== ")") {
            closeParenIndex = str.indexOf(")", pipeIndex);
            if (closeParenIndex > pipeIndex) {
              backSlashIndex = str.indexOf("\\", pipeIndex);
              if (backSlashIndex === -1 || backSlashIndex > closeParenIndex) {
                return true;
              }
            }
          }
        }
        if (str[index] === "\\") {
          var open = str[index + 1];
          index += 2;
          var close = chars[open];
          if (close) {
            var n = str.indexOf(close, index);
            if (n !== -1) {
              index = n + 1;
            }
          }
          if (str[index] === "!") {
            return true;
          }
        } else {
          index++;
        }
      }
      return false;
    };
    var relaxedCheck = function(str) {
      if (str[0] === "!") {
        return true;
      }
      var index = 0;
      while (index < str.length) {
        if (/[*?{}()[\]]/.test(str[index])) {
          return true;
        }
        if (str[index] === "\\") {
          var open = str[index + 1];
          index += 2;
          var close = chars[open];
          if (close) {
            var n = str.indexOf(close, index);
            if (n !== -1) {
              index = n + 1;
            }
          }
          if (str[index] === "!") {
            return true;
          }
        } else {
          index++;
        }
      }
      return false;
    };
    module2.exports = function isGlob(str, options) {
      if (typeof str !== "string" || str === "") {
        return false;
      }
      if (isExtglob(str)) {
        return true;
      }
      var check = strictCheck;
      if (options && options.strict === false) {
        check = relaxedCheck;
      }
      return check(str);
    };
  }
});

// node_modules/glob-parent/index.js
var require_glob_parent = __commonJS({
  "node_modules/glob-parent/index.js"(exports2, module2) {
    "use strict";
    var isGlob = require_is_glob();
    var pathPosixDirname = require("path").posix.dirname;
    var isWin32 = require("os").platform() === "win32";
    var slash = "/";
    var backslash = /\\/g;
    var enclosure = /[\{\[].*[\}\]]$/;
    var globby = /(^|[^\\])([\{\[]|\([^\)]+$)/;
    var escaped = /\\([\!\*\?\|\[\]\(\)\{\}])/g;
    module2.exports = function globParent(str, opts) {
      var options = Object.assign({ flipBackslashes: true }, opts);
      if (options.flipBackslashes && isWin32 && str.indexOf(slash) < 0) {
        str = str.replace(backslash, slash);
      }
      if (enclosure.test(str)) {
        str += slash;
      }
      str += "a";
      do {
        str = pathPosixDirname(str);
      } while (isGlob(str) || globby.test(str));
      return str.replace(escaped, "$1");
    };
  }
});

// node_modules/braces/lib/utils.js
var require_utils9 = __commonJS({
  "node_modules/braces/lib/utils.js"(exports2) {
    "use strict";
    exports2.isInteger = (num) => {
      if (typeof num === "number") {
        return Number.isInteger(num);
      }
      if (typeof num === "string" && num.trim() !== "") {
        return Number.isInteger(Number(num));
      }
      return false;
    };
    exports2.find = (node, type) => node.nodes.find((node2) => node2.type === type);
    exports2.exceedsLimit = (min, max, step = 1, limit) => {
      if (limit === false)
        return false;
      if (!exports2.isInteger(min) || !exports2.isInteger(max))
        return false;
      return (Number(max) - Number(min)) / Number(step) >= limit;
    };
    exports2.escapeNode = (block, n = 0, type) => {
      let node = block.nodes[n];
      if (!node)
        return;
      if (type && node.type === type || node.type === "open" || node.type === "close") {
        if (node.escaped !== true) {
          node.value = "\\" + node.value;
          node.escaped = true;
        }
      }
    };
    exports2.encloseBrace = (node) => {
      if (node.type !== "brace")
        return false;
      if (node.commas >> 0 + node.ranges >> 0 === 0) {
        node.invalid = true;
        return true;
      }
      return false;
    };
    exports2.isInvalidBrace = (block) => {
      if (block.type !== "brace")
        return false;
      if (block.invalid === true || block.dollar)
        return true;
      if (block.commas >> 0 + block.ranges >> 0 === 0) {
        block.invalid = true;
        return true;
      }
      if (block.open !== true || block.close !== true) {
        block.invalid = true;
        return true;
      }
      return false;
    };
    exports2.isOpenOrClose = (node) => {
      if (node.type === "open" || node.type === "close") {
        return true;
      }
      return node.open === true || node.close === true;
    };
    exports2.reduce = (nodes) => nodes.reduce((acc, node) => {
      if (node.type === "text")
        acc.push(node.value);
      if (node.type === "range")
        node.type = "text";
      return acc;
    }, []);
    exports2.flatten = (...args) => {
      const result2 = [];
      const flat = (arr) => {
        for (let i = 0; i < arr.length; i++) {
          let ele = arr[i];
          Array.isArray(ele) ? flat(ele, result2) : ele !== void 0 && result2.push(ele);
        }
        return result2;
      };
      flat(args);
      return result2;
    };
  }
});

// node_modules/braces/lib/stringify.js
var require_stringify = __commonJS({
  "node_modules/braces/lib/stringify.js"(exports2, module2) {
    "use strict";
    var utils = require_utils9();
    module2.exports = (ast, options = {}) => {
      let stringify = (node, parent = {}) => {
        let invalidBlock = options.escapeInvalid && utils.isInvalidBrace(parent);
        let invalidNode = node.invalid === true && options.escapeInvalid === true;
        let output = "";
        if (node.value) {
          if ((invalidBlock || invalidNode) && utils.isOpenOrClose(node)) {
            return "\\" + node.value;
          }
          return node.value;
        }
        if (node.value) {
          return node.value;
        }
        if (node.nodes) {
          for (let child of node.nodes) {
            output += stringify(child);
          }
        }
        return output;
      };
      return stringify(ast);
    };
  }
});

// node_modules/is-number/index.js
var require_is_number = __commonJS({
  "node_modules/is-number/index.js"(exports2, module2) {
    "use strict";
    module2.exports = function(num) {
      if (typeof num === "number") {
        return num - num === 0;
      }
      if (typeof num === "string" && num.trim() !== "") {
        return Number.isFinite ? Number.isFinite(+num) : isFinite(+num);
      }
      return false;
    };
  }
});

// node_modules/to-regex-range/index.js
var require_to_regex_range = __commonJS({
  "node_modules/to-regex-range/index.js"(exports2, module2) {
    "use strict";
    var isNumber = require_is_number();
    var toRegexRange = (min, max, options) => {
      if (isNumber(min) === false) {
        throw new TypeError("toRegexRange: expected the first argument to be a number");
      }
      if (max === void 0 || min === max) {
        return String(min);
      }
      if (isNumber(max) === false) {
        throw new TypeError("toRegexRange: expected the second argument to be a number.");
      }
      let opts = { relaxZeros: true, ...options };
      if (typeof opts.strictZeros === "boolean") {
        opts.relaxZeros = opts.strictZeros === false;
      }
      let relax = String(opts.relaxZeros);
      let shorthand = String(opts.shorthand);
      let capture = String(opts.capture);
      let wrap = String(opts.wrap);
      let cacheKey = min + ":" + max + "=" + relax + shorthand + capture + wrap;
      if (toRegexRange.cache.hasOwnProperty(cacheKey)) {
        return toRegexRange.cache[cacheKey].result;
      }
      let a = Math.min(min, max);
      let b = Math.max(min, max);
      if (Math.abs(a - b) === 1) {
        let result2 = min + "|" + max;
        if (opts.capture) {
          return `(${result2})`;
        }
        if (opts.wrap === false) {
          return result2;
        }
        return `(?:${result2})`;
      }
      let isPadded = hasPadding(min) || hasPadding(max);
      let state = { min, max, a, b };
      let positives = [];
      let negatives = [];
      if (isPadded) {
        state.isPadded = isPadded;
        state.maxLen = String(state.max).length;
      }
      if (a < 0) {
        let newMin = b < 0 ? Math.abs(b) : 1;
        negatives = splitToPatterns(newMin, Math.abs(a), state, opts);
        a = state.a = 0;
      }
      if (b >= 0) {
        positives = splitToPatterns(a, b, state, opts);
      }
      state.negatives = negatives;
      state.positives = positives;
      state.result = collatePatterns(negatives, positives, opts);
      if (opts.capture === true) {
        state.result = `(${state.result})`;
      } else if (opts.wrap !== false && positives.length + negatives.length > 1) {
        state.result = `(?:${state.result})`;
      }
      toRegexRange.cache[cacheKey] = state;
      return state.result;
    };
    function collatePatterns(neg, pos, options) {
      let onlyNegative = filterPatterns(neg, pos, "-", false, options) || [];
      let onlyPositive = filterPatterns(pos, neg, "", false, options) || [];
      let intersected = filterPatterns(neg, pos, "-?", true, options) || [];
      let subpatterns = onlyNegative.concat(intersected).concat(onlyPositive);
      return subpatterns.join("|");
    }
    function splitToRanges(min, max) {
      let nines = 1;
      let zeros = 1;
      let stop = countNines(min, nines);
      let stops = /* @__PURE__ */ new Set([max]);
      while (min <= stop && stop <= max) {
        stops.add(stop);
        nines += 1;
        stop = countNines(min, nines);
      }
      stop = countZeros(max + 1, zeros) - 1;
      while (min < stop && stop <= max) {
        stops.add(stop);
        zeros += 1;
        stop = countZeros(max + 1, zeros) - 1;
      }
      stops = [...stops];
      stops.sort(compare);
      return stops;
    }
    function rangeToPattern(start, stop, options) {
      if (start === stop) {
        return { pattern: start, count: [], digits: 0 };
      }
      let zipped = zip(start, stop);
      let digits = zipped.length;
      let pattern = "";
      let count = 0;
      for (let i = 0; i < digits; i++) {
        let [startDigit, stopDigit] = zipped[i];
        if (startDigit === stopDigit) {
          pattern += startDigit;
        } else if (startDigit !== "0" || stopDigit !== "9") {
          pattern += toCharacterClass(startDigit, stopDigit, options);
        } else {
          count++;
        }
      }
      if (count) {
        pattern += options.shorthand === true ? "\\d" : "[0-9]";
      }
      return { pattern, count: [count], digits };
    }
    function splitToPatterns(min, max, tok, options) {
      let ranges = splitToRanges(min, max);
      let tokens = [];
      let start = min;
      let prev;
      for (let i = 0; i < ranges.length; i++) {
        let max2 = ranges[i];
        let obj = rangeToPattern(String(start), String(max2), options);
        let zeros = "";
        if (!tok.isPadded && prev && prev.pattern === obj.pattern) {
          if (prev.count.length > 1) {
            prev.count.pop();
          }
          prev.count.push(obj.count[0]);
          prev.string = prev.pattern + toQuantifier(prev.count);
          start = max2 + 1;
          continue;
        }
        if (tok.isPadded) {
          zeros = padZeros(max2, tok, options);
        }
        obj.string = zeros + obj.pattern + toQuantifier(obj.count);
        tokens.push(obj);
        start = max2 + 1;
        prev = obj;
      }
      return tokens;
    }
    function filterPatterns(arr, comparison, prefix, intersection, options) {
      let result2 = [];
      for (let ele of arr) {
        let { string } = ele;
        if (!intersection && !contains(comparison, "string", string)) {
          result2.push(prefix + string);
        }
        if (intersection && contains(comparison, "string", string)) {
          result2.push(prefix + string);
        }
      }
      return result2;
    }
    function zip(a, b) {
      let arr = [];
      for (let i = 0; i < a.length; i++)
        arr.push([a[i], b[i]]);
      return arr;
    }
    function compare(a, b) {
      return a > b ? 1 : b > a ? -1 : 0;
    }
    function contains(arr, key, val) {
      return arr.some((ele) => ele[key] === val);
    }
    function countNines(min, len) {
      return Number(String(min).slice(0, -len) + "9".repeat(len));
    }
    function countZeros(integer, zeros) {
      return integer - integer % Math.pow(10, zeros);
    }
    function toQuantifier(digits) {
      let [start = 0, stop = ""] = digits;
      if (stop || start > 1) {
        return `{${start + (stop ? "," + stop : "")}}`;
      }
      return "";
    }
    function toCharacterClass(a, b, options) {
      return `[${a}${b - a === 1 ? "" : "-"}${b}]`;
    }
    function hasPadding(str) {
      return /^-?(0+)\d/.test(str);
    }
    function padZeros(value, tok, options) {
      if (!tok.isPadded) {
        return value;
      }
      let diff = Math.abs(tok.maxLen - String(value).length);
      let relax = options.relaxZeros !== false;
      switch (diff) {
        case 0:
          return "";
        case 1:
          return relax ? "0?" : "0";
        case 2:
          return relax ? "0{0,2}" : "00";
        default: {
          return relax ? `0{0,${diff}}` : `0{${diff}}`;
        }
      }
    }
    toRegexRange.cache = {};
    toRegexRange.clearCache = () => toRegexRange.cache = {};
    module2.exports = toRegexRange;
  }
});

// node_modules/fill-range/index.js
var require_fill_range = __commonJS({
  "node_modules/fill-range/index.js"(exports2, module2) {
    "use strict";
    var util = require("util");
    var toRegexRange = require_to_regex_range();
    var isObject = (val) => val !== null && typeof val === "object" && !Array.isArray(val);
    var transform = (toNumber) => {
      return (value) => toNumber === true ? Number(value) : String(value);
    };
    var isValidValue = (value) => {
      return typeof value === "number" || typeof value === "string" && value !== "";
    };
    var isNumber = (num) => Number.isInteger(+num);
    var zeros = (input) => {
      let value = `${input}`;
      let index = -1;
      if (value[0] === "-")
        value = value.slice(1);
      if (value === "0")
        return false;
      while (value[++index] === "0")
        ;
      return index > 0;
    };
    var stringify = (start, end, options) => {
      if (typeof start === "string" || typeof end === "string") {
        return true;
      }
      return options.stringify === true;
    };
    var pad = (input, maxLength, toNumber) => {
      if (maxLength > 0) {
        let dash = input[0] === "-" ? "-" : "";
        if (dash)
          input = input.slice(1);
        input = dash + input.padStart(dash ? maxLength - 1 : maxLength, "0");
      }
      if (toNumber === false) {
        return String(input);
      }
      return input;
    };
    var toMaxLen = (input, maxLength) => {
      let negative = input[0] === "-" ? "-" : "";
      if (negative) {
        input = input.slice(1);
        maxLength--;
      }
      while (input.length < maxLength)
        input = "0" + input;
      return negative ? "-" + input : input;
    };
    var toSequence = (parts, options) => {
      parts.negatives.sort((a, b) => a < b ? -1 : a > b ? 1 : 0);
      parts.positives.sort((a, b) => a < b ? -1 : a > b ? 1 : 0);
      let prefix = options.capture ? "" : "?:";
      let positives = "";
      let negatives = "";
      let result2;
      if (parts.positives.length) {
        positives = parts.positives.join("|");
      }
      if (parts.negatives.length) {
        negatives = `-(${prefix}${parts.negatives.join("|")})`;
      }
      if (positives && negatives) {
        result2 = `${positives}|${negatives}`;
      } else {
        result2 = positives || negatives;
      }
      if (options.wrap) {
        return `(${prefix}${result2})`;
      }
      return result2;
    };
    var toRange = (a, b, isNumbers, options) => {
      if (isNumbers) {
        return toRegexRange(a, b, { wrap: false, ...options });
      }
      let start = String.fromCharCode(a);
      if (a === b)
        return start;
      let stop = String.fromCharCode(b);
      return `[${start}-${stop}]`;
    };
    var toRegex = (start, end, options) => {
      if (Array.isArray(start)) {
        let wrap = options.wrap === true;
        let prefix = options.capture ? "" : "?:";
        return wrap ? `(${prefix}${start.join("|")})` : start.join("|");
      }
      return toRegexRange(start, end, options);
    };
    var rangeError = (...args) => {
      return new RangeError("Invalid range arguments: " + util.inspect(...args));
    };
    var invalidRange = (start, end, options) => {
      if (options.strictRanges === true)
        throw rangeError([start, end]);
      return [];
    };
    var invalidStep = (step, options) => {
      if (options.strictRanges === true) {
        throw new TypeError(`Expected step "${step}" to be a number`);
      }
      return [];
    };
    var fillNumbers = (start, end, step = 1, options = {}) => {
      let a = Number(start);
      let b = Number(end);
      if (!Number.isInteger(a) || !Number.isInteger(b)) {
        if (options.strictRanges === true)
          throw rangeError([start, end]);
        return [];
      }
      if (a === 0)
        a = 0;
      if (b === 0)
        b = 0;
      let descending = a > b;
      let startString = String(start);
      let endString = String(end);
      let stepString = String(step);
      step = Math.max(Math.abs(step), 1);
      let padded = zeros(startString) || zeros(endString) || zeros(stepString);
      let maxLen = padded ? Math.max(startString.length, endString.length, stepString.length) : 0;
      let toNumber = padded === false && stringify(start, end, options) === false;
      let format3 = options.transform || transform(toNumber);
      if (options.toRegex && step === 1) {
        return toRange(toMaxLen(start, maxLen), toMaxLen(end, maxLen), true, options);
      }
      let parts = { negatives: [], positives: [] };
      let push = (num) => parts[num < 0 ? "negatives" : "positives"].push(Math.abs(num));
      let range = [];
      let index = 0;
      while (descending ? a >= b : a <= b) {
        if (options.toRegex === true && step > 1) {
          push(a);
        } else {
          range.push(pad(format3(a, index), maxLen, toNumber));
        }
        a = descending ? a - step : a + step;
        index++;
      }
      if (options.toRegex === true) {
        return step > 1 ? toSequence(parts, options) : toRegex(range, null, { wrap: false, ...options });
      }
      return range;
    };
    var fillLetters = (start, end, step = 1, options = {}) => {
      if (!isNumber(start) && start.length > 1 || !isNumber(end) && end.length > 1) {
        return invalidRange(start, end, options);
      }
      let format3 = options.transform || ((val) => String.fromCharCode(val));
      let a = `${start}`.charCodeAt(0);
      let b = `${end}`.charCodeAt(0);
      let descending = a > b;
      let min = Math.min(a, b);
      let max = Math.max(a, b);
      if (options.toRegex && step === 1) {
        return toRange(min, max, false, options);
      }
      let range = [];
      let index = 0;
      while (descending ? a >= b : a <= b) {
        range.push(format3(a, index));
        a = descending ? a - step : a + step;
        index++;
      }
      if (options.toRegex === true) {
        return toRegex(range, null, { wrap: false, options });
      }
      return range;
    };
    var fill = (start, end, step, options = {}) => {
      if (end == null && isValidValue(start)) {
        return [start];
      }
      if (!isValidValue(start) || !isValidValue(end)) {
        return invalidRange(start, end, options);
      }
      if (typeof step === "function") {
        return fill(start, end, 1, { transform: step });
      }
      if (isObject(step)) {
        return fill(start, end, 0, step);
      }
      let opts = { ...options };
      if (opts.capture === true)
        opts.wrap = true;
      step = step || opts.step || 1;
      if (!isNumber(step)) {
        if (step != null && !isObject(step))
          return invalidStep(step, opts);
        return fill(start, end, 1, step);
      }
      if (isNumber(start) && isNumber(end)) {
        return fillNumbers(start, end, step, opts);
      }
      return fillLetters(start, end, Math.max(Math.abs(step), 1), opts);
    };
    module2.exports = fill;
  }
});

// node_modules/braces/lib/compile.js
var require_compile = __commonJS({
  "node_modules/braces/lib/compile.js"(exports2, module2) {
    "use strict";
    var fill = require_fill_range();
    var utils = require_utils9();
    var compile2 = (ast, options = {}) => {
      let walk = (node, parent = {}) => {
        let invalidBlock = utils.isInvalidBrace(parent);
        let invalidNode = node.invalid === true && options.escapeInvalid === true;
        let invalid = invalidBlock === true || invalidNode === true;
        let prefix = options.escapeInvalid === true ? "\\" : "";
        let output = "";
        if (node.isOpen === true) {
          return prefix + node.value;
        }
        if (node.isClose === true) {
          return prefix + node.value;
        }
        if (node.type === "open") {
          return invalid ? prefix + node.value : "(";
        }
        if (node.type === "close") {
          return invalid ? prefix + node.value : ")";
        }
        if (node.type === "comma") {
          return node.prev.type === "comma" ? "" : invalid ? node.value : "|";
        }
        if (node.value) {
          return node.value;
        }
        if (node.nodes && node.ranges > 0) {
          let args = utils.reduce(node.nodes);
          let range = fill(...args, { ...options, wrap: false, toRegex: true });
          if (range.length !== 0) {
            return args.length > 1 && range.length > 1 ? `(${range})` : range;
          }
        }
        if (node.nodes) {
          for (let child of node.nodes) {
            output += walk(child, node);
          }
        }
        return output;
      };
      return walk(ast);
    };
    module2.exports = compile2;
  }
});

// node_modules/braces/lib/expand.js
var require_expand = __commonJS({
  "node_modules/braces/lib/expand.js"(exports2, module2) {
    "use strict";
    var fill = require_fill_range();
    var stringify = require_stringify();
    var utils = require_utils9();
    var append3 = (queue = "", stash = "", enclose = false) => {
      let result2 = [];
      queue = [].concat(queue);
      stash = [].concat(stash);
      if (!stash.length)
        return queue;
      if (!queue.length) {
        return enclose ? utils.flatten(stash).map((ele) => `{${ele}}`) : stash;
      }
      for (let item of queue) {
        if (Array.isArray(item)) {
          for (let value of item) {
            result2.push(append3(value, stash, enclose));
          }
        } else {
          for (let ele of stash) {
            if (enclose === true && typeof ele === "string")
              ele = `{${ele}}`;
            result2.push(Array.isArray(ele) ? append3(item, ele, enclose) : item + ele);
          }
        }
      }
      return utils.flatten(result2);
    };
    var expand = (ast, options = {}) => {
      let rangeLimit = options.rangeLimit === void 0 ? 1e3 : options.rangeLimit;
      let walk = (node, parent = {}) => {
        node.queue = [];
        let p3 = parent;
        let q2 = parent.queue;
        while (p3.type !== "brace" && p3.type !== "root" && p3.parent) {
          p3 = p3.parent;
          q2 = p3.queue;
        }
        if (node.invalid || node.dollar) {
          q2.push(append3(q2.pop(), stringify(node, options)));
          return;
        }
        if (node.type === "brace" && node.invalid !== true && node.nodes.length === 2) {
          q2.push(append3(q2.pop(), ["{}"]));
          return;
        }
        if (node.nodes && node.ranges > 0) {
          let args = utils.reduce(node.nodes);
          if (utils.exceedsLimit(...args, options.step, rangeLimit)) {
            throw new RangeError("expanded array length exceeds range limit. Use options.rangeLimit to increase or disable the limit.");
          }
          let range = fill(...args, options);
          if (range.length === 0) {
            range = stringify(node, options);
          }
          q2.push(append3(q2.pop(), range));
          node.nodes = [];
          return;
        }
        let enclose = utils.encloseBrace(node);
        let queue = node.queue;
        let block = node;
        while (block.type !== "brace" && block.type !== "root" && block.parent) {
          block = block.parent;
          queue = block.queue;
        }
        for (let i = 0; i < node.nodes.length; i++) {
          let child = node.nodes[i];
          if (child.type === "comma" && node.type === "brace") {
            if (i === 1)
              queue.push("");
            queue.push("");
            continue;
          }
          if (child.type === "close") {
            q2.push(append3(q2.pop(), queue, enclose));
            continue;
          }
          if (child.value && child.type !== "open") {
            queue.push(append3(queue.pop(), child.value));
            continue;
          }
          if (child.nodes) {
            walk(child, node);
          }
        }
        return queue;
      };
      return utils.flatten(walk(ast));
    };
    module2.exports = expand;
  }
});

// node_modules/braces/lib/constants.js
var require_constants6 = __commonJS({
  "node_modules/braces/lib/constants.js"(exports2, module2) {
    "use strict";
    module2.exports = {
      MAX_LENGTH: 1024 * 64,
      // Digits
      CHAR_0: "0",
      /* 0 */
      CHAR_9: "9",
      /* 9 */
      // Alphabet chars.
      CHAR_UPPERCASE_A: "A",
      /* A */
      CHAR_LOWERCASE_A: "a",
      /* a */
      CHAR_UPPERCASE_Z: "Z",
      /* Z */
      CHAR_LOWERCASE_Z: "z",
      /* z */
      CHAR_LEFT_PARENTHESES: "(",
      /* ( */
      CHAR_RIGHT_PARENTHESES: ")",
      /* ) */
      CHAR_ASTERISK: "*",
      /* * */
      // Non-alphabetic chars.
      CHAR_AMPERSAND: "&",
      /* & */
      CHAR_AT: "@",
      /* @ */
      CHAR_BACKSLASH: "\\",
      /* \ */
      CHAR_BACKTICK: "`",
      /* ` */
      CHAR_CARRIAGE_RETURN: "\r",
      /* \r */
      CHAR_CIRCUMFLEX_ACCENT: "^",
      /* ^ */
      CHAR_COLON: ":",
      /* : */
      CHAR_COMMA: ",",
      /* , */
      CHAR_DOLLAR: "$",
      /* . */
      CHAR_DOT: ".",
      /* . */
      CHAR_DOUBLE_QUOTE: '"',
      /* " */
      CHAR_EQUAL: "=",
      /* = */
      CHAR_EXCLAMATION_MARK: "!",
      /* ! */
      CHAR_FORM_FEED: "\f",
      /* \f */
      CHAR_FORWARD_SLASH: "/",
      /* / */
      CHAR_HASH: "#",
      /* # */
      CHAR_HYPHEN_MINUS: "-",
      /* - */
      CHAR_LEFT_ANGLE_BRACKET: "<",
      /* < */
      CHAR_LEFT_CURLY_BRACE: "{",
      /* { */
      CHAR_LEFT_SQUARE_BRACKET: "[",
      /* [ */
      CHAR_LINE_FEED: "\n",
      /* \n */
      CHAR_NO_BREAK_SPACE: "\xA0",
      /* \u00A0 */
      CHAR_PERCENT: "%",
      /* % */
      CHAR_PLUS: "+",
      /* + */
      CHAR_QUESTION_MARK: "?",
      /* ? */
      CHAR_RIGHT_ANGLE_BRACKET: ">",
      /* > */
      CHAR_RIGHT_CURLY_BRACE: "}",
      /* } */
      CHAR_RIGHT_SQUARE_BRACKET: "]",
      /* ] */
      CHAR_SEMICOLON: ";",
      /* ; */
      CHAR_SINGLE_QUOTE: "'",
      /* ' */
      CHAR_SPACE: " ",
      /*   */
      CHAR_TAB: "	",
      /* \t */
      CHAR_UNDERSCORE: "_",
      /* _ */
      CHAR_VERTICAL_LINE: "|",
      /* | */
      CHAR_ZERO_WIDTH_NOBREAK_SPACE: "\uFEFF"
      /* \uFEFF */
    };
  }
});

// node_modules/braces/lib/parse.js
var require_parse3 = __commonJS({
  "node_modules/braces/lib/parse.js"(exports2, module2) {
    "use strict";
    var stringify = require_stringify();
    var {
      MAX_LENGTH,
      CHAR_BACKSLASH,
      /* \ */
      CHAR_BACKTICK,
      /* ` */
      CHAR_COMMA,
      /* , */
      CHAR_DOT,
      /* . */
      CHAR_LEFT_PARENTHESES,
      /* ( */
      CHAR_RIGHT_PARENTHESES,
      /* ) */
      CHAR_LEFT_CURLY_BRACE,
      /* { */
      CHAR_RIGHT_CURLY_BRACE,
      /* } */
      CHAR_LEFT_SQUARE_BRACKET,
      /* [ */
      CHAR_RIGHT_SQUARE_BRACKET,
      /* ] */
      CHAR_DOUBLE_QUOTE,
      /* " */
      CHAR_SINGLE_QUOTE,
      /* ' */
      CHAR_NO_BREAK_SPACE,
      CHAR_ZERO_WIDTH_NOBREAK_SPACE
    } = require_constants6();
    var parse6 = (input, options = {}) => {
      if (typeof input !== "string") {
        throw new TypeError("Expected a string");
      }
      let opts = options || {};
      let max = typeof opts.maxLength === "number" ? Math.min(MAX_LENGTH, opts.maxLength) : MAX_LENGTH;
      if (input.length > max) {
        throw new SyntaxError(`Input length (${input.length}), exceeds max characters (${max})`);
      }
      let ast = { type: "root", input, nodes: [] };
      let stack = [ast];
      let block = ast;
      let prev = ast;
      let brackets = 0;
      let length = input.length;
      let index = 0;
      let depth = 0;
      let value;
      let memo = {};
      const advance = () => input[index++];
      const push = (node) => {
        if (node.type === "text" && prev.type === "dot") {
          prev.type = "text";
        }
        if (prev && prev.type === "text" && node.type === "text") {
          prev.value += node.value;
          return;
        }
        block.nodes.push(node);
        node.parent = block;
        node.prev = prev;
        prev = node;
        return node;
      };
      push({ type: "bos" });
      while (index < length) {
        block = stack[stack.length - 1];
        value = advance();
        if (value === CHAR_ZERO_WIDTH_NOBREAK_SPACE || value === CHAR_NO_BREAK_SPACE) {
          continue;
        }
        if (value === CHAR_BACKSLASH) {
          push({ type: "text", value: (options.keepEscaping ? value : "") + advance() });
          continue;
        }
        if (value === CHAR_RIGHT_SQUARE_BRACKET) {
          push({ type: "text", value: "\\" + value });
          continue;
        }
        if (value === CHAR_LEFT_SQUARE_BRACKET) {
          brackets++;
          let closed = true;
          let next;
          while (index < length && (next = advance())) {
            value += next;
            if (next === CHAR_LEFT_SQUARE_BRACKET) {
              brackets++;
              continue;
            }
            if (next === CHAR_BACKSLASH) {
              value += advance();
              continue;
            }
            if (next === CHAR_RIGHT_SQUARE_BRACKET) {
              brackets--;
              if (brackets === 0) {
                break;
              }
            }
          }
          push({ type: "text", value });
          continue;
        }
        if (value === CHAR_LEFT_PARENTHESES) {
          block = push({ type: "paren", nodes: [] });
          stack.push(block);
          push({ type: "text", value });
          continue;
        }
        if (value === CHAR_RIGHT_PARENTHESES) {
          if (block.type !== "paren") {
            push({ type: "text", value });
            continue;
          }
          block = stack.pop();
          push({ type: "text", value });
          block = stack[stack.length - 1];
          continue;
        }
        if (value === CHAR_DOUBLE_QUOTE || value === CHAR_SINGLE_QUOTE || value === CHAR_BACKTICK) {
          let open = value;
          let next;
          if (options.keepQuotes !== true) {
            value = "";
          }
          while (index < length && (next = advance())) {
            if (next === CHAR_BACKSLASH) {
              value += next + advance();
              continue;
            }
            if (next === open) {
              if (options.keepQuotes === true)
                value += next;
              break;
            }
            value += next;
          }
          push({ type: "text", value });
          continue;
        }
        if (value === CHAR_LEFT_CURLY_BRACE) {
          depth++;
          let dollar = prev.value && prev.value.slice(-1) === "$" || block.dollar === true;
          let brace = {
            type: "brace",
            open: true,
            close: false,
            dollar,
            depth,
            commas: 0,
            ranges: 0,
            nodes: []
          };
          block = push(brace);
          stack.push(block);
          push({ type: "open", value });
          continue;
        }
        if (value === CHAR_RIGHT_CURLY_BRACE) {
          if (block.type !== "brace") {
            push({ type: "text", value });
            continue;
          }
          let type = "close";
          block = stack.pop();
          block.close = true;
          push({ type, value });
          depth--;
          block = stack[stack.length - 1];
          continue;
        }
        if (value === CHAR_COMMA && depth > 0) {
          if (block.ranges > 0) {
            block.ranges = 0;
            let open = block.nodes.shift();
            block.nodes = [open, { type: "text", value: stringify(block) }];
          }
          push({ type: "comma", value });
          block.commas++;
          continue;
        }
        if (value === CHAR_DOT && depth > 0 && block.commas === 0) {
          let siblings = block.nodes;
          if (depth === 0 || siblings.length === 0) {
            push({ type: "text", value });
            continue;
          }
          if (prev.type === "dot") {
            block.range = [];
            prev.value += value;
            prev.type = "range";
            if (block.nodes.length !== 3 && block.nodes.length !== 5) {
              block.invalid = true;
              block.ranges = 0;
              prev.type = "text";
              continue;
            }
            block.ranges++;
            block.args = [];
            continue;
          }
          if (prev.type === "range") {
            siblings.pop();
            let before = siblings[siblings.length - 1];
            before.value += prev.value + value;
            prev = before;
            block.ranges--;
            continue;
          }
          push({ type: "dot", value });
          continue;
        }
        push({ type: "text", value });
      }
      do {
        block = stack.pop();
        if (block.type !== "root") {
          block.nodes.forEach((node) => {
            if (!node.nodes) {
              if (node.type === "open")
                node.isOpen = true;
              if (node.type === "close")
                node.isClose = true;
              if (!node.nodes)
                node.type = "text";
              node.invalid = true;
            }
          });
          let parent = stack[stack.length - 1];
          let index2 = parent.nodes.indexOf(block);
          parent.nodes.splice(index2, 1, ...block.nodes);
        }
      } while (stack.length > 0);
      push({ type: "eos" });
      return ast;
    };
    module2.exports = parse6;
  }
});

// node_modules/braces/index.js
var require_braces = __commonJS({
  "node_modules/braces/index.js"(exports2, module2) {
    "use strict";
    var stringify = require_stringify();
    var compile2 = require_compile();
    var expand = require_expand();
    var parse6 = require_parse3();
    var braces = (input, options = {}) => {
      let output = [];
      if (Array.isArray(input)) {
        for (let pattern of input) {
          let result2 = braces.create(pattern, options);
          if (Array.isArray(result2)) {
            output.push(...result2);
          } else {
            output.push(result2);
          }
        }
      } else {
        output = [].concat(braces.create(input, options));
      }
      if (options && options.expand === true && options.nodupes === true) {
        output = [...new Set(output)];
      }
      return output;
    };
    braces.parse = (input, options = {}) => parse6(input, options);
    braces.stringify = (input, options = {}) => {
      if (typeof input === "string") {
        return stringify(braces.parse(input, options), options);
      }
      return stringify(input, options);
    };
    braces.compile = (input, options = {}) => {
      if (typeof input === "string") {
        input = braces.parse(input, options);
      }
      return compile2(input, options);
    };
    braces.expand = (input, options = {}) => {
      if (typeof input === "string") {
        input = braces.parse(input, options);
      }
      let result2 = expand(input, options);
      if (options.noempty === true) {
        result2 = result2.filter(Boolean);
      }
      if (options.nodupes === true) {
        result2 = [...new Set(result2)];
      }
      return result2;
    };
    braces.create = (input, options = {}) => {
      if (input === "" || input.length < 3) {
        return [input];
      }
      return options.expand !== true ? braces.compile(input, options) : braces.expand(input, options);
    };
    module2.exports = braces;
  }
});

// node_modules/binary-extensions/binary-extensions.json
var require_binary_extensions = __commonJS({
  "node_modules/binary-extensions/binary-extensions.json"(exports2, module2) {
    module2.exports = [
      "3dm",
      "3ds",
      "3g2",
      "3gp",
      "7z",
      "a",
      "aac",
      "adp",
      "ai",
      "aif",
      "aiff",
      "alz",
      "ape",
      "apk",
      "appimage",
      "ar",
      "arj",
      "asf",
      "au",
      "avi",
      "bak",
      "baml",
      "bh",
      "bin",
      "bk",
      "bmp",
      "btif",
      "bz2",
      "bzip2",
      "cab",
      "caf",
      "cgm",
      "class",
      "cmx",
      "cpio",
      "cr2",
      "cur",
      "dat",
      "dcm",
      "deb",
      "dex",
      "djvu",
      "dll",
      "dmg",
      "dng",
      "doc",
      "docm",
      "docx",
      "dot",
      "dotm",
      "dra",
      "DS_Store",
      "dsk",
      "dts",
      "dtshd",
      "dvb",
      "dwg",
      "dxf",
      "ecelp4800",
      "ecelp7470",
      "ecelp9600",
      "egg",
      "eol",
      "eot",
      "epub",
      "exe",
      "f4v",
      "fbs",
      "fh",
      "fla",
      "flac",
      "flatpak",
      "fli",
      "flv",
      "fpx",
      "fst",
      "fvt",
      "g3",
      "gh",
      "gif",
      "graffle",
      "gz",
      "gzip",
      "h261",
      "h263",
      "h264",
      "icns",
      "ico",
      "ief",
      "img",
      "ipa",
      "iso",
      "jar",
      "jpeg",
      "jpg",
      "jpgv",
      "jpm",
      "jxr",
      "key",
      "ktx",
      "lha",
      "lib",
      "lvp",
      "lz",
      "lzh",
      "lzma",
      "lzo",
      "m3u",
      "m4a",
      "m4v",
      "mar",
      "mdi",
      "mht",
      "mid",
      "midi",
      "mj2",
      "mka",
      "mkv",
      "mmr",
      "mng",
      "mobi",
      "mov",
      "movie",
      "mp3",
      "mp4",
      "mp4a",
      "mpeg",
      "mpg",
      "mpga",
      "mxu",
      "nef",
      "npx",
      "numbers",
      "nupkg",
      "o",
      "odp",
      "ods",
      "odt",
      "oga",
      "ogg",
      "ogv",
      "otf",
      "ott",
      "pages",
      "pbm",
      "pcx",
      "pdb",
      "pdf",
      "pea",
      "pgm",
      "pic",
      "png",
      "pnm",
      "pot",
      "potm",
      "potx",
      "ppa",
      "ppam",
      "ppm",
      "pps",
      "ppsm",
      "ppsx",
      "ppt",
      "pptm",
      "pptx",
      "psd",
      "pya",
      "pyc",
      "pyo",
      "pyv",
      "qt",
      "rar",
      "ras",
      "raw",
      "resources",
      "rgb",
      "rip",
      "rlc",
      "rmf",
      "rmvb",
      "rpm",
      "rtf",
      "rz",
      "s3m",
      "s7z",
      "scpt",
      "sgi",
      "shar",
      "snap",
      "sil",
      "sketch",
      "slk",
      "smv",
      "snk",
      "so",
      "stl",
      "suo",
      "sub",
      "swf",
      "tar",
      "tbz",
      "tbz2",
      "tga",
      "tgz",
      "thmx",
      "tif",
      "tiff",
      "tlz",
      "ttc",
      "ttf",
      "txz",
      "udf",
      "uvh",
      "uvi",
      "uvm",
      "uvp",
      "uvs",
      "uvu",
      "viv",
      "vob",
      "war",
      "wav",
      "wax",
      "wbmp",
      "wdp",
      "weba",
      "webm",
      "webp",
      "whl",
      "wim",
      "wm",
      "wma",
      "wmv",
      "wmx",
      "woff",
      "woff2",
      "wrm",
      "wvx",
      "xbm",
      "xif",
      "xla",
      "xlam",
      "xls",
      "xlsb",
      "xlsm",
      "xlsx",
      "xlt",
      "xltm",
      "xltx",
      "xm",
      "xmind",
      "xpi",
      "xpm",
      "xwd",
      "xz",
      "z",
      "zip",
      "zipx"
    ];
  }
});

// node_modules/binary-extensions/index.js
var require_binary_extensions2 = __commonJS({
  "node_modules/binary-extensions/index.js"(exports2, module2) {
    module2.exports = require_binary_extensions();
  }
});

// node_modules/is-binary-path/index.js
var require_is_binary_path = __commonJS({
  "node_modules/is-binary-path/index.js"(exports2, module2) {
    "use strict";
    var path3 = require("path");
    var binaryExtensions = require_binary_extensions2();
    var extensions2 = new Set(binaryExtensions);
    module2.exports = (filePath) => extensions2.has(path3.extname(filePath).slice(1).toLowerCase());
  }
});

// node_modules/chokidar/lib/constants.js
var require_constants7 = __commonJS({
  "node_modules/chokidar/lib/constants.js"(exports2) {
    "use strict";
    var { sep } = require("path");
    var { platform } = process;
    var os2 = require("os");
    exports2.EV_ALL = "all";
    exports2.EV_READY = "ready";
    exports2.EV_ADD = "add";
    exports2.EV_CHANGE = "change";
    exports2.EV_ADD_DIR = "addDir";
    exports2.EV_UNLINK = "unlink";
    exports2.EV_UNLINK_DIR = "unlinkDir";
    exports2.EV_RAW = "raw";
    exports2.EV_ERROR = "error";
    exports2.STR_DATA = "data";
    exports2.STR_END = "end";
    exports2.STR_CLOSE = "close";
    exports2.FSEVENT_CREATED = "created";
    exports2.FSEVENT_MODIFIED = "modified";
    exports2.FSEVENT_DELETED = "deleted";
    exports2.FSEVENT_MOVED = "moved";
    exports2.FSEVENT_CLONED = "cloned";
    exports2.FSEVENT_UNKNOWN = "unknown";
    exports2.FSEVENT_FLAG_MUST_SCAN_SUBDIRS = 1;
    exports2.FSEVENT_TYPE_FILE = "file";
    exports2.FSEVENT_TYPE_DIRECTORY = "directory";
    exports2.FSEVENT_TYPE_SYMLINK = "symlink";
    exports2.KEY_LISTENERS = "listeners";
    exports2.KEY_ERR = "errHandlers";
    exports2.KEY_RAW = "rawEmitters";
    exports2.HANDLER_KEYS = [exports2.KEY_LISTENERS, exports2.KEY_ERR, exports2.KEY_RAW];
    exports2.DOT_SLASH = `.${sep}`;
    exports2.BACK_SLASH_RE = /\\/g;
    exports2.DOUBLE_SLASH_RE = /\/\//;
    exports2.SLASH_OR_BACK_SLASH_RE = /[/\\]/;
    exports2.DOT_RE = /\..*\.(sw[px])$|~$|\.subl.*\.tmp/;
    exports2.REPLACER_RE = /^\.[/\\]/;
    exports2.SLASH = "/";
    exports2.SLASH_SLASH = "//";
    exports2.BRACE_START = "{";
    exports2.BANG = "!";
    exports2.ONE_DOT = ".";
    exports2.TWO_DOTS = "..";
    exports2.STAR = "*";
    exports2.GLOBSTAR = "**";
    exports2.ROOT_GLOBSTAR = "/**/*";
    exports2.SLASH_GLOBSTAR = "/**";
    exports2.DIR_SUFFIX = "Dir";
    exports2.ANYMATCH_OPTS = { dot: true };
    exports2.STRING_TYPE = "string";
    exports2.FUNCTION_TYPE = "function";
    exports2.EMPTY_STR = "";
    exports2.EMPTY_FN = () => {
    };
    exports2.IDENTITY_FN = (val) => val;
    exports2.isWindows = platform === "win32";
    exports2.isMacos = platform === "darwin";
    exports2.isLinux = platform === "linux";
    exports2.isIBMi = os2.type() === "OS400";
  }
});

// node_modules/chokidar/lib/nodefs-handler.js
var require_nodefs_handler = __commonJS({
  "node_modules/chokidar/lib/nodefs-handler.js"(exports2, module2) {
    "use strict";
    var fs2 = require("fs");
    var sysPath = require("path");
    var { promisify } = require("util");
    var isBinaryPath = require_is_binary_path();
    var {
      isWindows,
      isLinux,
      EMPTY_FN,
      EMPTY_STR,
      KEY_LISTENERS,
      KEY_ERR,
      KEY_RAW,
      HANDLER_KEYS,
      EV_CHANGE,
      EV_ADD,
      EV_ADD_DIR,
      EV_ERROR,
      STR_DATA,
      STR_END,
      BRACE_START,
      STAR
    } = require_constants7();
    var THROTTLE_MODE_WATCH = "watch";
    var open = promisify(fs2.open);
    var stat = promisify(fs2.stat);
    var lstat = promisify(fs2.lstat);
    var close = promisify(fs2.close);
    var fsrealpath = promisify(fs2.realpath);
    var statMethods = { lstat, stat };
    var foreach = (val, fn) => {
      if (val instanceof Set) {
        val.forEach(fn);
      } else {
        fn(val);
      }
    };
    var addAndConvert = (main, prop, item) => {
      let container = main[prop];
      if (!(container instanceof Set)) {
        main[prop] = container = /* @__PURE__ */ new Set([container]);
      }
      container.add(item);
    };
    var clearItem = (cont) => (key) => {
      const set = cont[key];
      if (set instanceof Set) {
        set.clear();
      } else {
        delete cont[key];
      }
    };
    var delFromSet = (main, prop, item) => {
      const container = main[prop];
      if (container instanceof Set) {
        container.delete(item);
      } else if (container === item) {
        delete main[prop];
      }
    };
    var isEmptySet = (val) => val instanceof Set ? val.size === 0 : !val;
    var FsWatchInstances = /* @__PURE__ */ new Map();
    function createFsWatchInstance(path3, options, listener, errHandler, emitRaw) {
      const handleEvent = (rawEvent, evPath) => {
        listener(path3);
        emitRaw(rawEvent, evPath, { watchedPath: path3 });
        if (evPath && path3 !== evPath) {
          fsWatchBroadcast(
            sysPath.resolve(path3, evPath),
            KEY_LISTENERS,
            sysPath.join(path3, evPath)
          );
        }
      };
      try {
        return fs2.watch(path3, options, handleEvent);
      } catch (error) {
        errHandler(error);
      }
    }
    var fsWatchBroadcast = (fullPath, type, val1, val2, val3) => {
      const cont = FsWatchInstances.get(fullPath);
      if (!cont)
        return;
      foreach(cont[type], (listener) => {
        listener(val1, val2, val3);
      });
    };
    var setFsWatchListener = (path3, fullPath, options, handlers) => {
      const { listener, errHandler, rawEmitter } = handlers;
      let cont = FsWatchInstances.get(fullPath);
      let watcher;
      if (!options.persistent) {
        watcher = createFsWatchInstance(
          path3,
          options,
          listener,
          errHandler,
          rawEmitter
        );
        return watcher.close.bind(watcher);
      }
      if (cont) {
        addAndConvert(cont, KEY_LISTENERS, listener);
        addAndConvert(cont, KEY_ERR, errHandler);
        addAndConvert(cont, KEY_RAW, rawEmitter);
      } else {
        watcher = createFsWatchInstance(
          path3,
          options,
          fsWatchBroadcast.bind(null, fullPath, KEY_LISTENERS),
          errHandler,
          // no need to use broadcast here
          fsWatchBroadcast.bind(null, fullPath, KEY_RAW)
        );
        if (!watcher)
          return;
        watcher.on(EV_ERROR, async (error) => {
          const broadcastErr = fsWatchBroadcast.bind(null, fullPath, KEY_ERR);
          cont.watcherUnusable = true;
          if (isWindows && error.code === "EPERM") {
            try {
              const fd = await open(path3, "r");
              await close(fd);
              broadcastErr(error);
            } catch (err) {
            }
          } else {
            broadcastErr(error);
          }
        });
        cont = {
          listeners: listener,
          errHandlers: errHandler,
          rawEmitters: rawEmitter,
          watcher
        };
        FsWatchInstances.set(fullPath, cont);
      }
      return () => {
        delFromSet(cont, KEY_LISTENERS, listener);
        delFromSet(cont, KEY_ERR, errHandler);
        delFromSet(cont, KEY_RAW, rawEmitter);
        if (isEmptySet(cont.listeners)) {
          cont.watcher.close();
          FsWatchInstances.delete(fullPath);
          HANDLER_KEYS.forEach(clearItem(cont));
          cont.watcher = void 0;
          Object.freeze(cont);
        }
      };
    };
    var FsWatchFileInstances = /* @__PURE__ */ new Map();
    var setFsWatchFileListener = (path3, fullPath, options, handlers) => {
      const { listener, rawEmitter } = handlers;
      let cont = FsWatchFileInstances.get(fullPath);
      let listeners = /* @__PURE__ */ new Set();
      let rawEmitters = /* @__PURE__ */ new Set();
      const copts = cont && cont.options;
      if (copts && (copts.persistent < options.persistent || copts.interval > options.interval)) {
        listeners = cont.listeners;
        rawEmitters = cont.rawEmitters;
        fs2.unwatchFile(fullPath);
        cont = void 0;
      }
      if (cont) {
        addAndConvert(cont, KEY_LISTENERS, listener);
        addAndConvert(cont, KEY_RAW, rawEmitter);
      } else {
        cont = {
          listeners: listener,
          rawEmitters: rawEmitter,
          options,
          watcher: fs2.watchFile(fullPath, options, (curr, prev) => {
            foreach(cont.rawEmitters, (rawEmitter2) => {
              rawEmitter2(EV_CHANGE, fullPath, { curr, prev });
            });
            const currmtime = curr.mtimeMs;
            if (curr.size !== prev.size || currmtime > prev.mtimeMs || currmtime === 0) {
              foreach(cont.listeners, (listener2) => listener2(path3, curr));
            }
          })
        };
        FsWatchFileInstances.set(fullPath, cont);
      }
      return () => {
        delFromSet(cont, KEY_LISTENERS, listener);
        delFromSet(cont, KEY_RAW, rawEmitter);
        if (isEmptySet(cont.listeners)) {
          FsWatchFileInstances.delete(fullPath);
          fs2.unwatchFile(fullPath);
          cont.options = cont.watcher = void 0;
          Object.freeze(cont);
        }
      };
    };
    var NodeFsHandler = class {
      /**
       * @param {import("../index").FSWatcher} fsW
       */
      constructor(fsW) {
        this.fsw = fsW;
        this._boundHandleError = (error) => fsW._handleError(error);
      }
      /**
       * Watch file for changes with fs_watchFile or fs_watch.
       * @param {String} path to file or dir
       * @param {Function} listener on fs change
       * @returns {Function} closer for the watcher instance
       */
      _watchWithNodeFs(path3, listener) {
        const opts = this.fsw.options;
        const directory = sysPath.dirname(path3);
        const basename2 = sysPath.basename(path3);
        const parent = this.fsw._getWatchedDir(directory);
        parent.add(basename2);
        const absolutePath = sysPath.resolve(path3);
        const options = { persistent: opts.persistent };
        if (!listener)
          listener = EMPTY_FN;
        let closer;
        if (opts.usePolling) {
          options.interval = opts.enableBinaryInterval && isBinaryPath(basename2) ? opts.binaryInterval : opts.interval;
          closer = setFsWatchFileListener(path3, absolutePath, options, {
            listener,
            rawEmitter: this.fsw._emitRaw
          });
        } else {
          closer = setFsWatchListener(path3, absolutePath, options, {
            listener,
            errHandler: this._boundHandleError,
            rawEmitter: this.fsw._emitRaw
          });
        }
        return closer;
      }
      /**
       * Watch a file and emit add event if warranted.
       * @param {Path} file Path
       * @param {fs.Stats} stats result of fs_stat
       * @param {Boolean} initialAdd was the file added at watch instantiation?
       * @returns {Function} closer for the watcher instance
       */
      _handleFile(file, stats, initialAdd) {
        if (this.fsw.closed) {
          return;
        }
        const dirname = sysPath.dirname(file);
        const basename2 = sysPath.basename(file);
        const parent = this.fsw._getWatchedDir(dirname);
        let prevStats = stats;
        if (parent.has(basename2))
          return;
        const listener = async (path3, newStats) => {
          if (!this.fsw._throttle(THROTTLE_MODE_WATCH, file, 5))
            return;
          if (!newStats || newStats.mtimeMs === 0) {
            try {
              const newStats2 = await stat(file);
              if (this.fsw.closed)
                return;
              const at = newStats2.atimeMs;
              const mt = newStats2.mtimeMs;
              if (!at || at <= mt || mt !== prevStats.mtimeMs) {
                this.fsw._emit(EV_CHANGE, file, newStats2);
              }
              if (isLinux && prevStats.ino !== newStats2.ino) {
                this.fsw._closeFile(path3);
                prevStats = newStats2;
                this.fsw._addPathCloser(path3, this._watchWithNodeFs(file, listener));
              } else {
                prevStats = newStats2;
              }
            } catch (error) {
              this.fsw._remove(dirname, basename2);
            }
          } else if (parent.has(basename2)) {
            const at = newStats.atimeMs;
            const mt = newStats.mtimeMs;
            if (!at || at <= mt || mt !== prevStats.mtimeMs) {
              this.fsw._emit(EV_CHANGE, file, newStats);
            }
            prevStats = newStats;
          }
        };
        const closer = this._watchWithNodeFs(file, listener);
        if (!(initialAdd && this.fsw.options.ignoreInitial) && this.fsw._isntIgnored(file)) {
          if (!this.fsw._throttle(EV_ADD, file, 0))
            return;
          this.fsw._emit(EV_ADD, file, stats);
        }
        return closer;
      }
      /**
       * Handle symlinks encountered while reading a dir.
       * @param {Object} entry returned by readdirp
       * @param {String} directory path of dir being read
       * @param {String} path of this item
       * @param {String} item basename of this item
       * @returns {Promise<Boolean>} true if no more processing is needed for this entry.
       */
      async _handleSymlink(entry, directory, path3, item) {
        if (this.fsw.closed) {
          return;
        }
        const full = entry.fullPath;
        const dir = this.fsw._getWatchedDir(directory);
        if (!this.fsw.options.followSymlinks) {
          this.fsw._incrReadyCount();
          let linkPath;
          try {
            linkPath = await fsrealpath(path3);
          } catch (e) {
            this.fsw._emitReady();
            return true;
          }
          if (this.fsw.closed)
            return;
          if (dir.has(item)) {
            if (this.fsw._symlinkPaths.get(full) !== linkPath) {
              this.fsw._symlinkPaths.set(full, linkPath);
              this.fsw._emit(EV_CHANGE, path3, entry.stats);
            }
          } else {
            dir.add(item);
            this.fsw._symlinkPaths.set(full, linkPath);
            this.fsw._emit(EV_ADD, path3, entry.stats);
          }
          this.fsw._emitReady();
          return true;
        }
        if (this.fsw._symlinkPaths.has(full)) {
          return true;
        }
        this.fsw._symlinkPaths.set(full, true);
      }
      _handleRead(directory, initialAdd, wh, target, dir, depth, throttler) {
        directory = sysPath.join(directory, EMPTY_STR);
        if (!wh.hasGlob) {
          throttler = this.fsw._throttle("readdir", directory, 1e3);
          if (!throttler)
            return;
        }
        const previous = this.fsw._getWatchedDir(wh.path);
        const current = /* @__PURE__ */ new Set();
        let stream = this.fsw._readdirp(directory, {
          fileFilter: (entry) => wh.filterPath(entry),
          directoryFilter: (entry) => wh.filterDir(entry),
          depth: 0
        }).on(STR_DATA, async (entry) => {
          if (this.fsw.closed) {
            stream = void 0;
            return;
          }
          const item = entry.path;
          let path3 = sysPath.join(directory, item);
          current.add(item);
          if (entry.stats.isSymbolicLink() && await this._handleSymlink(entry, directory, path3, item)) {
            return;
          }
          if (this.fsw.closed) {
            stream = void 0;
            return;
          }
          if (item === target || !target && !previous.has(item)) {
            this.fsw._incrReadyCount();
            path3 = sysPath.join(dir, sysPath.relative(dir, path3));
            this._addToNodeFs(path3, initialAdd, wh, depth + 1);
          }
        }).on(EV_ERROR, this._boundHandleError);
        return new Promise(
          (resolve2) => stream.once(STR_END, () => {
            if (this.fsw.closed) {
              stream = void 0;
              return;
            }
            const wasThrottled = throttler ? throttler.clear() : false;
            resolve2();
            previous.getChildren().filter((item) => {
              return item !== directory && !current.has(item) && // in case of intersecting globs;
              // a path may have been filtered out of this readdir, but
              // shouldn't be removed because it matches a different glob
              (!wh.hasGlob || wh.filterPath({
                fullPath: sysPath.resolve(directory, item)
              }));
            }).forEach((item) => {
              this.fsw._remove(directory, item);
            });
            stream = void 0;
            if (wasThrottled)
              this._handleRead(directory, false, wh, target, dir, depth, throttler);
          })
        );
      }
      /**
       * Read directory to add / remove files from `@watched` list and re-read it on change.
       * @param {String} dir fs path
       * @param {fs.Stats} stats
       * @param {Boolean} initialAdd
       * @param {Number} depth relative to user-supplied path
       * @param {String} target child path targeted for watch
       * @param {Object} wh Common watch helpers for this path
       * @param {String} realpath
       * @returns {Promise<Function>} closer for the watcher instance.
       */
      async _handleDir(dir, stats, initialAdd, depth, target, wh, realpath) {
        const parentDir = this.fsw._getWatchedDir(sysPath.dirname(dir));
        const tracked = parentDir.has(sysPath.basename(dir));
        if (!(initialAdd && this.fsw.options.ignoreInitial) && !target && !tracked) {
          if (!wh.hasGlob || wh.globFilter(dir))
            this.fsw._emit(EV_ADD_DIR, dir, stats);
        }
        parentDir.add(sysPath.basename(dir));
        this.fsw._getWatchedDir(dir);
        let throttler;
        let closer;
        const oDepth = this.fsw.options.depth;
        if ((oDepth == null || depth <= oDepth) && !this.fsw._symlinkPaths.has(realpath)) {
          if (!target) {
            await this._handleRead(dir, initialAdd, wh, target, dir, depth, throttler);
            if (this.fsw.closed)
              return;
          }
          closer = this._watchWithNodeFs(dir, (dirPath, stats2) => {
            if (stats2 && stats2.mtimeMs === 0)
              return;
            this._handleRead(dirPath, false, wh, target, dir, depth, throttler);
          });
        }
        return closer;
      }
      /**
       * Handle added file, directory, or glob pattern.
       * Delegates call to _handleFile / _handleDir after checks.
       * @param {String} path to file or ir
       * @param {Boolean} initialAdd was the file added at watch instantiation?
       * @param {Object} priorWh depth relative to user-supplied path
       * @param {Number} depth Child path actually targeted for watch
       * @param {String=} target Child path actually targeted for watch
       * @returns {Promise}
       */
      async _addToNodeFs(path3, initialAdd, priorWh, depth, target) {
        const ready = this.fsw._emitReady;
        if (this.fsw._isIgnored(path3) || this.fsw.closed) {
          ready();
          return false;
        }
        const wh = this.fsw._getWatchHelpers(path3, depth);
        if (!wh.hasGlob && priorWh) {
          wh.hasGlob = priorWh.hasGlob;
          wh.globFilter = priorWh.globFilter;
          wh.filterPath = (entry) => priorWh.filterPath(entry);
          wh.filterDir = (entry) => priorWh.filterDir(entry);
        }
        try {
          const stats = await statMethods[wh.statMethod](wh.watchPath);
          if (this.fsw.closed)
            return;
          if (this.fsw._isIgnored(wh.watchPath, stats)) {
            ready();
            return false;
          }
          const follow = this.fsw.options.followSymlinks && !path3.includes(STAR) && !path3.includes(BRACE_START);
          let closer;
          if (stats.isDirectory()) {
            const absPath = sysPath.resolve(path3);
            const targetPath = follow ? await fsrealpath(path3) : path3;
            if (this.fsw.closed)
              return;
            closer = await this._handleDir(wh.watchPath, stats, initialAdd, depth, target, wh, targetPath);
            if (this.fsw.closed)
              return;
            if (absPath !== targetPath && targetPath !== void 0) {
              this.fsw._symlinkPaths.set(absPath, targetPath);
            }
          } else if (stats.isSymbolicLink()) {
            const targetPath = follow ? await fsrealpath(path3) : path3;
            if (this.fsw.closed)
              return;
            const parent = sysPath.dirname(wh.watchPath);
            this.fsw._getWatchedDir(parent).add(wh.watchPath);
            this.fsw._emit(EV_ADD, wh.watchPath, stats);
            closer = await this._handleDir(parent, stats, initialAdd, depth, path3, wh, targetPath);
            if (this.fsw.closed)
              return;
            if (targetPath !== void 0) {
              this.fsw._symlinkPaths.set(sysPath.resolve(path3), targetPath);
            }
          } else {
            closer = this._handleFile(wh.watchPath, stats, initialAdd);
          }
          ready();
          this.fsw._addPathCloser(path3, closer);
          return false;
        } catch (error) {
          if (this.fsw._handleError(error)) {
            ready();
            return path3;
          }
        }
      }
    };
    module2.exports = NodeFsHandler;
  }
});

// node_modules/chokidar/lib/fsevents-handler.js
var require_fsevents_handler = __commonJS({
  "node_modules/chokidar/lib/fsevents-handler.js"(exports2, module2) {
    "use strict";
    var fs2 = require("fs");
    var sysPath = require("path");
    var { promisify } = require("util");
    var fsevents;
    try {
      fsevents = require("fsevents");
    } catch (error) {
      if (process.env.CHOKIDAR_PRINT_FSEVENTS_REQUIRE_ERROR)
        console.error(error);
    }
    if (fsevents) {
      const mtch = process.version.match(/v(\d+)\.(\d+)/);
      if (mtch && mtch[1] && mtch[2]) {
        const maj = Number.parseInt(mtch[1], 10);
        const min = Number.parseInt(mtch[2], 10);
        if (maj === 8 && min < 16) {
          fsevents = void 0;
        }
      }
    }
    var {
      EV_ADD,
      EV_CHANGE,
      EV_ADD_DIR,
      EV_UNLINK,
      EV_ERROR,
      STR_DATA,
      STR_END,
      FSEVENT_CREATED,
      FSEVENT_MODIFIED,
      FSEVENT_DELETED,
      FSEVENT_MOVED,
      // FSEVENT_CLONED,
      FSEVENT_UNKNOWN,
      FSEVENT_FLAG_MUST_SCAN_SUBDIRS,
      FSEVENT_TYPE_FILE,
      FSEVENT_TYPE_DIRECTORY,
      FSEVENT_TYPE_SYMLINK,
      ROOT_GLOBSTAR,
      DIR_SUFFIX,
      DOT_SLASH,
      FUNCTION_TYPE,
      EMPTY_FN,
      IDENTITY_FN
    } = require_constants7();
    var Depth = (value) => isNaN(value) ? {} : { depth: value };
    var stat = promisify(fs2.stat);
    var lstat = promisify(fs2.lstat);
    var realpath = promisify(fs2.realpath);
    var statMethods = { stat, lstat };
    var FSEventsWatchers = /* @__PURE__ */ new Map();
    var consolidateThreshhold = 10;
    var wrongEventFlags = /* @__PURE__ */ new Set([
      69888,
      70400,
      71424,
      72704,
      73472,
      131328,
      131840,
      262912
    ]);
    var createFSEventsInstance = (path3, callback) => {
      const stop = fsevents.watch(path3, callback);
      return { stop };
    };
    function setFSEventsListener(path3, realPath, listener, rawEmitter) {
      let watchPath = sysPath.extname(realPath) ? sysPath.dirname(realPath) : realPath;
      const parentPath = sysPath.dirname(watchPath);
      let cont = FSEventsWatchers.get(watchPath);
      if (couldConsolidate(parentPath)) {
        watchPath = parentPath;
      }
      const resolvedPath = sysPath.resolve(path3);
      const hasSymlink = resolvedPath !== realPath;
      const filteredListener = (fullPath, flags, info) => {
        if (hasSymlink)
          fullPath = fullPath.replace(realPath, resolvedPath);
        if (fullPath === resolvedPath || !fullPath.indexOf(resolvedPath + sysPath.sep))
          listener(fullPath, flags, info);
      };
      let watchedParent = false;
      for (const watchedPath of FSEventsWatchers.keys()) {
        if (realPath.indexOf(sysPath.resolve(watchedPath) + sysPath.sep) === 0) {
          watchPath = watchedPath;
          cont = FSEventsWatchers.get(watchPath);
          watchedParent = true;
          break;
        }
      }
      if (cont || watchedParent) {
        cont.listeners.add(filteredListener);
      } else {
        cont = {
          listeners: /* @__PURE__ */ new Set([filteredListener]),
          rawEmitter,
          watcher: createFSEventsInstance(watchPath, (fullPath, flags) => {
            if (!cont.listeners.size)
              return;
            if (flags & FSEVENT_FLAG_MUST_SCAN_SUBDIRS)
              return;
            const info = fsevents.getInfo(fullPath, flags);
            cont.listeners.forEach((list) => {
              list(fullPath, flags, info);
            });
            cont.rawEmitter(info.event, fullPath, info);
          })
        };
        FSEventsWatchers.set(watchPath, cont);
      }
      return () => {
        const lst = cont.listeners;
        lst.delete(filteredListener);
        if (!lst.size) {
          FSEventsWatchers.delete(watchPath);
          if (cont.watcher)
            return cont.watcher.stop().then(() => {
              cont.rawEmitter = cont.watcher = void 0;
              Object.freeze(cont);
            });
        }
      };
    }
    var couldConsolidate = (path3) => {
      let count = 0;
      for (const watchPath of FSEventsWatchers.keys()) {
        if (watchPath.indexOf(path3) === 0) {
          count++;
          if (count >= consolidateThreshhold) {
            return true;
          }
        }
      }
      return false;
    };
    var canUse = () => fsevents && FSEventsWatchers.size < 128;
    var calcDepth = (path3, root) => {
      let i = 0;
      while (!path3.indexOf(root) && (path3 = sysPath.dirname(path3)) !== root)
        i++;
      return i;
    };
    var sameTypes = (info, stats) => info.type === FSEVENT_TYPE_DIRECTORY && stats.isDirectory() || info.type === FSEVENT_TYPE_SYMLINK && stats.isSymbolicLink() || info.type === FSEVENT_TYPE_FILE && stats.isFile();
    var FsEventsHandler = class {
      /**
       * @param {import('../index').FSWatcher} fsw
       */
      constructor(fsw) {
        this.fsw = fsw;
      }
      checkIgnored(path3, stats) {
        const ipaths = this.fsw._ignoredPaths;
        if (this.fsw._isIgnored(path3, stats)) {
          ipaths.add(path3);
          if (stats && stats.isDirectory()) {
            ipaths.add(path3 + ROOT_GLOBSTAR);
          }
          return true;
        }
        ipaths.delete(path3);
        ipaths.delete(path3 + ROOT_GLOBSTAR);
      }
      addOrChange(path3, fullPath, realPath, parent, watchedDir, item, info, opts) {
        const event = watchedDir.has(item) ? EV_CHANGE : EV_ADD;
        this.handleEvent(event, path3, fullPath, realPath, parent, watchedDir, item, info, opts);
      }
      async checkExists(path3, fullPath, realPath, parent, watchedDir, item, info, opts) {
        try {
          const stats = await stat(path3);
          if (this.fsw.closed)
            return;
          if (sameTypes(info, stats)) {
            this.addOrChange(path3, fullPath, realPath, parent, watchedDir, item, info, opts);
          } else {
            this.handleEvent(EV_UNLINK, path3, fullPath, realPath, parent, watchedDir, item, info, opts);
          }
        } catch (error) {
          if (error.code === "EACCES") {
            this.addOrChange(path3, fullPath, realPath, parent, watchedDir, item, info, opts);
          } else {
            this.handleEvent(EV_UNLINK, path3, fullPath, realPath, parent, watchedDir, item, info, opts);
          }
        }
      }
      handleEvent(event, path3, fullPath, realPath, parent, watchedDir, item, info, opts) {
        if (this.fsw.closed || this.checkIgnored(path3))
          return;
        if (event === EV_UNLINK) {
          const isDirectory = info.type === FSEVENT_TYPE_DIRECTORY;
          if (isDirectory || watchedDir.has(item)) {
            this.fsw._remove(parent, item, isDirectory);
          }
        } else {
          if (event === EV_ADD) {
            if (info.type === FSEVENT_TYPE_DIRECTORY)
              this.fsw._getWatchedDir(path3);
            if (info.type === FSEVENT_TYPE_SYMLINK && opts.followSymlinks) {
              const curDepth = opts.depth === void 0 ? void 0 : calcDepth(fullPath, realPath) + 1;
              return this._addToFsEvents(path3, false, true, curDepth);
            }
            this.fsw._getWatchedDir(parent).add(item);
          }
          const eventName = info.type === FSEVENT_TYPE_DIRECTORY ? event + DIR_SUFFIX : event;
          this.fsw._emit(eventName, path3);
          if (eventName === EV_ADD_DIR)
            this._addToFsEvents(path3, false, true);
        }
      }
      /**
       * Handle symlinks encountered during directory scan
       * @param {String} watchPath  - file/dir path to be watched with fsevents
       * @param {String} realPath   - real path (in case of symlinks)
       * @param {Function} transform  - path transformer
       * @param {Function} globFilter - path filter in case a glob pattern was provided
       * @returns {Function} closer for the watcher instance
      */
      _watchWithFsEvents(watchPath, realPath, transform, globFilter) {
        if (this.fsw.closed || this.fsw._isIgnored(watchPath))
          return;
        const opts = this.fsw.options;
        const watchCallback = async (fullPath, flags, info) => {
          if (this.fsw.closed)
            return;
          if (opts.depth !== void 0 && calcDepth(fullPath, realPath) > opts.depth)
            return;
          const path3 = transform(sysPath.join(
            watchPath,
            sysPath.relative(watchPath, fullPath)
          ));
          if (globFilter && !globFilter(path3))
            return;
          const parent = sysPath.dirname(path3);
          const item = sysPath.basename(path3);
          const watchedDir = this.fsw._getWatchedDir(
            info.type === FSEVENT_TYPE_DIRECTORY ? path3 : parent
          );
          if (wrongEventFlags.has(flags) || info.event === FSEVENT_UNKNOWN) {
            if (typeof opts.ignored === FUNCTION_TYPE) {
              let stats;
              try {
                stats = await stat(path3);
              } catch (error) {
              }
              if (this.fsw.closed)
                return;
              if (this.checkIgnored(path3, stats))
                return;
              if (sameTypes(info, stats)) {
                this.addOrChange(path3, fullPath, realPath, parent, watchedDir, item, info, opts);
              } else {
                this.handleEvent(EV_UNLINK, path3, fullPath, realPath, parent, watchedDir, item, info, opts);
              }
            } else {
              this.checkExists(path3, fullPath, realPath, parent, watchedDir, item, info, opts);
            }
          } else {
            switch (info.event) {
              case FSEVENT_CREATED:
              case FSEVENT_MODIFIED:
                return this.addOrChange(path3, fullPath, realPath, parent, watchedDir, item, info, opts);
              case FSEVENT_DELETED:
              case FSEVENT_MOVED:
                return this.checkExists(path3, fullPath, realPath, parent, watchedDir, item, info, opts);
            }
          }
        };
        const closer = setFSEventsListener(
          watchPath,
          realPath,
          watchCallback,
          this.fsw._emitRaw
        );
        this.fsw._emitReady();
        return closer;
      }
      /**
       * Handle symlinks encountered during directory scan
       * @param {String} linkPath path to symlink
       * @param {String} fullPath absolute path to the symlink
       * @param {Function} transform pre-existing path transformer
       * @param {Number} curDepth level of subdirectories traversed to where symlink is
       * @returns {Promise<void>}
       */
      async _handleFsEventsSymlink(linkPath, fullPath, transform, curDepth) {
        if (this.fsw.closed || this.fsw._symlinkPaths.has(fullPath))
          return;
        this.fsw._symlinkPaths.set(fullPath, true);
        this.fsw._incrReadyCount();
        try {
          const linkTarget = await realpath(linkPath);
          if (this.fsw.closed)
            return;
          if (this.fsw._isIgnored(linkTarget)) {
            return this.fsw._emitReady();
          }
          this.fsw._incrReadyCount();
          this._addToFsEvents(linkTarget || linkPath, (path3) => {
            let aliasedPath = linkPath;
            if (linkTarget && linkTarget !== DOT_SLASH) {
              aliasedPath = path3.replace(linkTarget, linkPath);
            } else if (path3 !== DOT_SLASH) {
              aliasedPath = sysPath.join(linkPath, path3);
            }
            return transform(aliasedPath);
          }, false, curDepth);
        } catch (error) {
          if (this.fsw._handleError(error)) {
            return this.fsw._emitReady();
          }
        }
      }
      /**
       *
       * @param {Path} newPath
       * @param {fs.Stats} stats
       */
      emitAdd(newPath, stats, processPath, opts, forceAdd) {
        const pp = processPath(newPath);
        const isDir = stats.isDirectory();
        const dirObj = this.fsw._getWatchedDir(sysPath.dirname(pp));
        const base = sysPath.basename(pp);
        if (isDir)
          this.fsw._getWatchedDir(pp);
        if (dirObj.has(base))
          return;
        dirObj.add(base);
        if (!opts.ignoreInitial || forceAdd === true) {
          this.fsw._emit(isDir ? EV_ADD_DIR : EV_ADD, pp, stats);
        }
      }
      initWatch(realPath, path3, wh, processPath) {
        if (this.fsw.closed)
          return;
        const closer = this._watchWithFsEvents(
          wh.watchPath,
          sysPath.resolve(realPath || wh.watchPath),
          processPath,
          wh.globFilter
        );
        this.fsw._addPathCloser(path3, closer);
      }
      /**
       * Handle added path with fsevents
       * @param {String} path file/dir path or glob pattern
       * @param {Function|Boolean=} transform converts working path to what the user expects
       * @param {Boolean=} forceAdd ensure add is emitted
       * @param {Number=} priorDepth Level of subdirectories already traversed.
       * @returns {Promise<void>}
       */
      async _addToFsEvents(path3, transform, forceAdd, priorDepth) {
        if (this.fsw.closed) {
          return;
        }
        const opts = this.fsw.options;
        const processPath = typeof transform === FUNCTION_TYPE ? transform : IDENTITY_FN;
        const wh = this.fsw._getWatchHelpers(path3);
        try {
          const stats = await statMethods[wh.statMethod](wh.watchPath);
          if (this.fsw.closed)
            return;
          if (this.fsw._isIgnored(wh.watchPath, stats)) {
            throw null;
          }
          if (stats.isDirectory()) {
            if (!wh.globFilter)
              this.emitAdd(processPath(path3), stats, processPath, opts, forceAdd);
            if (priorDepth && priorDepth > opts.depth)
              return;
            this.fsw._readdirp(wh.watchPath, {
              fileFilter: (entry) => wh.filterPath(entry),
              directoryFilter: (entry) => wh.filterDir(entry),
              ...Depth(opts.depth - (priorDepth || 0))
            }).on(STR_DATA, (entry) => {
              if (this.fsw.closed) {
                return;
              }
              if (entry.stats.isDirectory() && !wh.filterPath(entry))
                return;
              const joinedPath = sysPath.join(wh.watchPath, entry.path);
              const { fullPath } = entry;
              if (wh.followSymlinks && entry.stats.isSymbolicLink()) {
                const curDepth = opts.depth === void 0 ? void 0 : calcDepth(joinedPath, sysPath.resolve(wh.watchPath)) + 1;
                this._handleFsEventsSymlink(joinedPath, fullPath, processPath, curDepth);
              } else {
                this.emitAdd(joinedPath, entry.stats, processPath, opts, forceAdd);
              }
            }).on(EV_ERROR, EMPTY_FN).on(STR_END, () => {
              this.fsw._emitReady();
            });
          } else {
            this.emitAdd(wh.watchPath, stats, processPath, opts, forceAdd);
            this.fsw._emitReady();
          }
        } catch (error) {
          if (!error || this.fsw._handleError(error)) {
            this.fsw._emitReady();
            this.fsw._emitReady();
          }
        }
        if (opts.persistent && forceAdd !== true) {
          if (typeof transform === FUNCTION_TYPE) {
            this.initWatch(void 0, path3, wh, processPath);
          } else {
            let realPath;
            try {
              realPath = await realpath(wh.watchPath);
            } catch (e) {
            }
            this.initWatch(realPath, path3, wh, processPath);
          }
        }
      }
    };
    module2.exports = FsEventsHandler;
    module2.exports.canUse = canUse;
  }
});

// node_modules/chokidar/index.js
var require_chokidar = __commonJS({
  "node_modules/chokidar/index.js"(exports2) {
    "use strict";
    var { EventEmitter } = require("events");
    var fs2 = require("fs");
    var sysPath = require("path");
    var { promisify } = require("util");
    var readdirp = require_readdirp();
    var anymatch = require_anymatch().default;
    var globParent = require_glob_parent();
    var isGlob = require_is_glob();
    var braces = require_braces();
    var normalizePath = require_normalize_path();
    var NodeFsHandler = require_nodefs_handler();
    var FsEventsHandler = require_fsevents_handler();
    var {
      EV_ALL,
      EV_READY,
      EV_ADD,
      EV_CHANGE,
      EV_UNLINK,
      EV_ADD_DIR,
      EV_UNLINK_DIR,
      EV_RAW,
      EV_ERROR,
      STR_CLOSE,
      STR_END,
      BACK_SLASH_RE,
      DOUBLE_SLASH_RE,
      SLASH_OR_BACK_SLASH_RE,
      DOT_RE,
      REPLACER_RE,
      SLASH,
      SLASH_SLASH,
      BRACE_START,
      BANG,
      ONE_DOT,
      TWO_DOTS,
      GLOBSTAR,
      SLASH_GLOBSTAR,
      ANYMATCH_OPTS,
      STRING_TYPE,
      FUNCTION_TYPE,
      EMPTY_STR,
      EMPTY_FN,
      isWindows,
      isMacos,
      isIBMi
    } = require_constants7();
    var stat = promisify(fs2.stat);
    var readdir = promisify(fs2.readdir);
    var arrify = (value = []) => Array.isArray(value) ? value : [value];
    var flatten = (list, result2 = []) => {
      list.forEach((item) => {
        if (Array.isArray(item)) {
          flatten(item, result2);
        } else {
          result2.push(item);
        }
      });
      return result2;
    };
    var unifyPaths = (paths_) => {
      const paths = flatten(arrify(paths_));
      if (!paths.every((p3) => typeof p3 === STRING_TYPE)) {
        throw new TypeError(`Non-string provided as watch path: ${paths}`);
      }
      return paths.map(normalizePathToUnix);
    };
    var toUnix = (string) => {
      let str = string.replace(BACK_SLASH_RE, SLASH);
      let prepend = false;
      if (str.startsWith(SLASH_SLASH)) {
        prepend = true;
      }
      while (str.match(DOUBLE_SLASH_RE)) {
        str = str.replace(DOUBLE_SLASH_RE, SLASH);
      }
      if (prepend) {
        str = SLASH + str;
      }
      return str;
    };
    var normalizePathToUnix = (path3) => toUnix(sysPath.normalize(toUnix(path3)));
    var normalizeIgnored = (cwd = EMPTY_STR) => (path3) => {
      if (typeof path3 !== STRING_TYPE)
        return path3;
      return normalizePathToUnix(sysPath.isAbsolute(path3) ? path3 : sysPath.join(cwd, path3));
    };
    var getAbsolutePath = (path3, cwd) => {
      if (sysPath.isAbsolute(path3)) {
        return path3;
      }
      if (path3.startsWith(BANG)) {
        return BANG + sysPath.join(cwd, path3.slice(1));
      }
      return sysPath.join(cwd, path3);
    };
    var undef = (opts, key) => opts[key] === void 0;
    var DirEntry = class {
      /**
       * @param {Path} dir
       * @param {Function} removeWatcher
       */
      constructor(dir, removeWatcher) {
        this.path = dir;
        this._removeWatcher = removeWatcher;
        this.items = /* @__PURE__ */ new Set();
      }
      add(item) {
        const { items } = this;
        if (!items)
          return;
        if (item !== ONE_DOT && item !== TWO_DOTS)
          items.add(item);
      }
      async remove(item) {
        const { items } = this;
        if (!items)
          return;
        items.delete(item);
        if (items.size > 0)
          return;
        const dir = this.path;
        try {
          await readdir(dir);
        } catch (err) {
          if (this._removeWatcher) {
            this._removeWatcher(sysPath.dirname(dir), sysPath.basename(dir));
          }
        }
      }
      has(item) {
        const { items } = this;
        if (!items)
          return;
        return items.has(item);
      }
      /**
       * @returns {Array<String>}
       */
      getChildren() {
        const { items } = this;
        if (!items)
          return;
        return [...items.values()];
      }
      dispose() {
        this.items.clear();
        delete this.path;
        delete this._removeWatcher;
        delete this.items;
        Object.freeze(this);
      }
    };
    var STAT_METHOD_F = "stat";
    var STAT_METHOD_L = "lstat";
    var WatchHelper = class {
      constructor(path3, watchPath, follow, fsw) {
        this.fsw = fsw;
        this.path = path3 = path3.replace(REPLACER_RE, EMPTY_STR);
        this.watchPath = watchPath;
        this.fullWatchPath = sysPath.resolve(watchPath);
        this.hasGlob = watchPath !== path3;
        if (path3 === EMPTY_STR)
          this.hasGlob = false;
        this.globSymlink = this.hasGlob && follow ? void 0 : false;
        this.globFilter = this.hasGlob ? anymatch(path3, void 0, ANYMATCH_OPTS) : false;
        this.dirParts = this.getDirParts(path3);
        this.dirParts.forEach((parts) => {
          if (parts.length > 1)
            parts.pop();
        });
        this.followSymlinks = follow;
        this.statMethod = follow ? STAT_METHOD_F : STAT_METHOD_L;
      }
      checkGlobSymlink(entry) {
        if (this.globSymlink === void 0) {
          this.globSymlink = entry.fullParentDir === this.fullWatchPath ? false : { realPath: entry.fullParentDir, linkPath: this.fullWatchPath };
        }
        if (this.globSymlink) {
          return entry.fullPath.replace(this.globSymlink.realPath, this.globSymlink.linkPath);
        }
        return entry.fullPath;
      }
      entryPath(entry) {
        return sysPath.join(
          this.watchPath,
          sysPath.relative(this.watchPath, this.checkGlobSymlink(entry))
        );
      }
      filterPath(entry) {
        const { stats } = entry;
        if (stats && stats.isSymbolicLink())
          return this.filterDir(entry);
        const resolvedPath = this.entryPath(entry);
        const matchesGlob = this.hasGlob && typeof this.globFilter === FUNCTION_TYPE ? this.globFilter(resolvedPath) : true;
        return matchesGlob && this.fsw._isntIgnored(resolvedPath, stats) && this.fsw._hasReadPermissions(stats);
      }
      getDirParts(path3) {
        if (!this.hasGlob)
          return [];
        const parts = [];
        const expandedPath = path3.includes(BRACE_START) ? braces.expand(path3) : [path3];
        expandedPath.forEach((path4) => {
          parts.push(sysPath.relative(this.watchPath, path4).split(SLASH_OR_BACK_SLASH_RE));
        });
        return parts;
      }
      filterDir(entry) {
        if (this.hasGlob) {
          const entryParts = this.getDirParts(this.checkGlobSymlink(entry));
          let globstar = false;
          this.unmatchedGlob = !this.dirParts.some((parts) => {
            return parts.every((part, i) => {
              if (part === GLOBSTAR)
                globstar = true;
              return globstar || !entryParts[0][i] || anymatch(part, entryParts[0][i], ANYMATCH_OPTS);
            });
          });
        }
        return !this.unmatchedGlob && this.fsw._isntIgnored(this.entryPath(entry), entry.stats);
      }
    };
    var FSWatcher = class extends EventEmitter {
      // Not indenting methods for history sake; for now.
      constructor(_opts) {
        super();
        const opts = {};
        if (_opts)
          Object.assign(opts, _opts);
        this._watched = /* @__PURE__ */ new Map();
        this._closers = /* @__PURE__ */ new Map();
        this._ignoredPaths = /* @__PURE__ */ new Set();
        this._throttled = /* @__PURE__ */ new Map();
        this._symlinkPaths = /* @__PURE__ */ new Map();
        this._streams = /* @__PURE__ */ new Set();
        this.closed = false;
        if (undef(opts, "persistent"))
          opts.persistent = true;
        if (undef(opts, "ignoreInitial"))
          opts.ignoreInitial = false;
        if (undef(opts, "ignorePermissionErrors"))
          opts.ignorePermissionErrors = false;
        if (undef(opts, "interval"))
          opts.interval = 100;
        if (undef(opts, "binaryInterval"))
          opts.binaryInterval = 300;
        if (undef(opts, "disableGlobbing"))
          opts.disableGlobbing = false;
        opts.enableBinaryInterval = opts.binaryInterval !== opts.interval;
        if (undef(opts, "useFsEvents"))
          opts.useFsEvents = !opts.usePolling;
        const canUseFsEvents = FsEventsHandler.canUse();
        if (!canUseFsEvents)
          opts.useFsEvents = false;
        if (undef(opts, "usePolling") && !opts.useFsEvents) {
          opts.usePolling = isMacos;
        }
        if (isIBMi) {
          opts.usePolling = true;
        }
        const envPoll = process.env.CHOKIDAR_USEPOLLING;
        if (envPoll !== void 0) {
          const envLower = envPoll.toLowerCase();
          if (envLower === "false" || envLower === "0") {
            opts.usePolling = false;
          } else if (envLower === "true" || envLower === "1") {
            opts.usePolling = true;
          } else {
            opts.usePolling = !!envLower;
          }
        }
        const envInterval = process.env.CHOKIDAR_INTERVAL;
        if (envInterval) {
          opts.interval = Number.parseInt(envInterval, 10);
        }
        if (undef(opts, "atomic"))
          opts.atomic = !opts.usePolling && !opts.useFsEvents;
        if (opts.atomic)
          this._pendingUnlinks = /* @__PURE__ */ new Map();
        if (undef(opts, "followSymlinks"))
          opts.followSymlinks = true;
        if (undef(opts, "awaitWriteFinish"))
          opts.awaitWriteFinish = false;
        if (opts.awaitWriteFinish === true)
          opts.awaitWriteFinish = {};
        const awf = opts.awaitWriteFinish;
        if (awf) {
          if (!awf.stabilityThreshold)
            awf.stabilityThreshold = 2e3;
          if (!awf.pollInterval)
            awf.pollInterval = 100;
          this._pendingWrites = /* @__PURE__ */ new Map();
        }
        if (opts.ignored)
          opts.ignored = arrify(opts.ignored);
        let readyCalls = 0;
        this._emitReady = () => {
          readyCalls++;
          if (readyCalls >= this._readyCount) {
            this._emitReady = EMPTY_FN;
            this._readyEmitted = true;
            process.nextTick(() => this.emit(EV_READY));
          }
        };
        this._emitRaw = (...args) => this.emit(EV_RAW, ...args);
        this._readyEmitted = false;
        this.options = opts;
        if (opts.useFsEvents) {
          this._fsEventsHandler = new FsEventsHandler(this);
        } else {
          this._nodeFsHandler = new NodeFsHandler(this);
        }
        Object.freeze(opts);
      }
      // Public methods
      /**
       * Adds paths to be watched on an existing FSWatcher instance
       * @param {Path|Array<Path>} paths_
       * @param {String=} _origAdd private; for handling non-existent paths to be watched
       * @param {Boolean=} _internal private; indicates a non-user add
       * @returns {FSWatcher} for chaining
       */
      add(paths_, _origAdd, _internal) {
        const { cwd, disableGlobbing } = this.options;
        this.closed = false;
        let paths = unifyPaths(paths_);
        if (cwd) {
          paths = paths.map((path3) => {
            const absPath = getAbsolutePath(path3, cwd);
            if (disableGlobbing || !isGlob(path3)) {
              return absPath;
            }
            return normalizePath(absPath);
          });
        }
        paths = paths.filter((path3) => {
          if (path3.startsWith(BANG)) {
            this._ignoredPaths.add(path3.slice(1));
            return false;
          }
          this._ignoredPaths.delete(path3);
          this._ignoredPaths.delete(path3 + SLASH_GLOBSTAR);
          this._userIgnored = void 0;
          return true;
        });
        if (this.options.useFsEvents && this._fsEventsHandler) {
          if (!this._readyCount)
            this._readyCount = paths.length;
          if (this.options.persistent)
            this._readyCount += paths.length;
          paths.forEach((path3) => this._fsEventsHandler._addToFsEvents(path3));
        } else {
          if (!this._readyCount)
            this._readyCount = 0;
          this._readyCount += paths.length;
          Promise.all(
            paths.map(async (path3) => {
              const res = await this._nodeFsHandler._addToNodeFs(path3, !_internal, 0, 0, _origAdd);
              if (res)
                this._emitReady();
              return res;
            })
          ).then((results) => {
            if (this.closed)
              return;
            results.filter((item) => item).forEach((item) => {
              this.add(sysPath.dirname(item), sysPath.basename(_origAdd || item));
            });
          });
        }
        return this;
      }
      /**
       * Close watchers or start ignoring events from specified paths.
       * @param {Path|Array<Path>} paths_ - string or array of strings, file/directory paths and/or globs
       * @returns {FSWatcher} for chaining
      */
      unwatch(paths_) {
        if (this.closed)
          return this;
        const paths = unifyPaths(paths_);
        const { cwd } = this.options;
        paths.forEach((path3) => {
          if (!sysPath.isAbsolute(path3) && !this._closers.has(path3)) {
            if (cwd)
              path3 = sysPath.join(cwd, path3);
            path3 = sysPath.resolve(path3);
          }
          this._closePath(path3);
          this._ignoredPaths.add(path3);
          if (this._watched.has(path3)) {
            this._ignoredPaths.add(path3 + SLASH_GLOBSTAR);
          }
          this._userIgnored = void 0;
        });
        return this;
      }
      /**
       * Close watchers and remove all listeners from watched paths.
       * @returns {Promise<void>}.
      */
      close() {
        if (this.closed)
          return this._closePromise;
        this.closed = true;
        this.removeAllListeners();
        const closers = [];
        this._closers.forEach((closerList) => closerList.forEach((closer) => {
          const promise = closer();
          if (promise instanceof Promise)
            closers.push(promise);
        }));
        this._streams.forEach((stream) => stream.destroy());
        this._userIgnored = void 0;
        this._readyCount = 0;
        this._readyEmitted = false;
        this._watched.forEach((dirent) => dirent.dispose());
        ["closers", "watched", "streams", "symlinkPaths", "throttled"].forEach((key) => {
          this[`_${key}`].clear();
        });
        this._closePromise = closers.length ? Promise.all(closers).then(() => void 0) : Promise.resolve();
        return this._closePromise;
      }
      /**
       * Expose list of watched paths
       * @returns {Object} for chaining
      */
      getWatched() {
        const watchList = {};
        this._watched.forEach((entry, dir) => {
          const key = this.options.cwd ? sysPath.relative(this.options.cwd, dir) : dir;
          watchList[key || ONE_DOT] = entry.getChildren().sort();
        });
        return watchList;
      }
      emitWithAll(event, args) {
        this.emit(...args);
        if (event !== EV_ERROR)
          this.emit(EV_ALL, ...args);
      }
      // Common helpers
      // --------------
      /**
       * Normalize and emit events.
       * Calling _emit DOES NOT MEAN emit() would be called!
       * @param {EventName} event Type of event
       * @param {Path} path File or directory path
       * @param {*=} val1 arguments to be passed with event
       * @param {*=} val2
       * @param {*=} val3
       * @returns the error if defined, otherwise the value of the FSWatcher instance's `closed` flag
       */
      async _emit(event, path3, val1, val2, val3) {
        if (this.closed)
          return;
        const opts = this.options;
        if (isWindows)
          path3 = sysPath.normalize(path3);
        if (opts.cwd)
          path3 = sysPath.relative(opts.cwd, path3);
        const args = [event, path3];
        if (val3 !== void 0)
          args.push(val1, val2, val3);
        else if (val2 !== void 0)
          args.push(val1, val2);
        else if (val1 !== void 0)
          args.push(val1);
        const awf = opts.awaitWriteFinish;
        let pw;
        if (awf && (pw = this._pendingWrites.get(path3))) {
          pw.lastChange = /* @__PURE__ */ new Date();
          return this;
        }
        if (opts.atomic) {
          if (event === EV_UNLINK) {
            this._pendingUnlinks.set(path3, args);
            setTimeout(() => {
              this._pendingUnlinks.forEach((entry, path4) => {
                this.emit(...entry);
                this.emit(EV_ALL, ...entry);
                this._pendingUnlinks.delete(path4);
              });
            }, typeof opts.atomic === "number" ? opts.atomic : 100);
            return this;
          }
          if (event === EV_ADD && this._pendingUnlinks.has(path3)) {
            event = args[0] = EV_CHANGE;
            this._pendingUnlinks.delete(path3);
          }
        }
        if (awf && (event === EV_ADD || event === EV_CHANGE) && this._readyEmitted) {
          const awfEmit = (err, stats) => {
            if (err) {
              event = args[0] = EV_ERROR;
              args[1] = err;
              this.emitWithAll(event, args);
            } else if (stats) {
              if (args.length > 2) {
                args[2] = stats;
              } else {
                args.push(stats);
              }
              this.emitWithAll(event, args);
            }
          };
          this._awaitWriteFinish(path3, awf.stabilityThreshold, event, awfEmit);
          return this;
        }
        if (event === EV_CHANGE) {
          const isThrottled = !this._throttle(EV_CHANGE, path3, 50);
          if (isThrottled)
            return this;
        }
        if (opts.alwaysStat && val1 === void 0 && (event === EV_ADD || event === EV_ADD_DIR || event === EV_CHANGE)) {
          const fullPath = opts.cwd ? sysPath.join(opts.cwd, path3) : path3;
          let stats;
          try {
            stats = await stat(fullPath);
          } catch (err) {
          }
          if (!stats || this.closed)
            return;
          args.push(stats);
        }
        this.emitWithAll(event, args);
        return this;
      }
      /**
       * Common handler for errors
       * @param {Error} error
       * @returns {Error|Boolean} The error if defined, otherwise the value of the FSWatcher instance's `closed` flag
       */
      _handleError(error) {
        const code = error && error.code;
        if (error && code !== "ENOENT" && code !== "ENOTDIR" && (!this.options.ignorePermissionErrors || code !== "EPERM" && code !== "EACCES")) {
          this.emit(EV_ERROR, error);
        }
        return error || this.closed;
      }
      /**
       * Helper utility for throttling
       * @param {ThrottleType} actionType type being throttled
       * @param {Path} path being acted upon
       * @param {Number} timeout duration of time to suppress duplicate actions
       * @returns {Object|false} tracking object or false if action should be suppressed
       */
      _throttle(actionType, path3, timeout) {
        if (!this._throttled.has(actionType)) {
          this._throttled.set(actionType, /* @__PURE__ */ new Map());
        }
        const action = this._throttled.get(actionType);
        const actionPath = action.get(path3);
        if (actionPath) {
          actionPath.count++;
          return false;
        }
        let timeoutObject;
        const clear = () => {
          const item = action.get(path3);
          const count = item ? item.count : 0;
          action.delete(path3);
          clearTimeout(timeoutObject);
          if (item)
            clearTimeout(item.timeoutObject);
          return count;
        };
        timeoutObject = setTimeout(clear, timeout);
        const thr = { timeoutObject, clear, count: 0 };
        action.set(path3, thr);
        return thr;
      }
      _incrReadyCount() {
        return this._readyCount++;
      }
      /**
       * Awaits write operation to finish.
       * Polls a newly created file for size variations. When files size does not change for 'threshold' milliseconds calls callback.
       * @param {Path} path being acted upon
       * @param {Number} threshold Time in milliseconds a file size must be fixed before acknowledging write OP is finished
       * @param {EventName} event
       * @param {Function} awfEmit Callback to be called when ready for event to be emitted.
       */
      _awaitWriteFinish(path3, threshold, event, awfEmit) {
        let timeoutHandler;
        let fullPath = path3;
        if (this.options.cwd && !sysPath.isAbsolute(path3)) {
          fullPath = sysPath.join(this.options.cwd, path3);
        }
        const now = /* @__PURE__ */ new Date();
        const awaitWriteFinish = (prevStat) => {
          fs2.stat(fullPath, (err, curStat) => {
            if (err || !this._pendingWrites.has(path3)) {
              if (err && err.code !== "ENOENT")
                awfEmit(err);
              return;
            }
            const now2 = Number(/* @__PURE__ */ new Date());
            if (prevStat && curStat.size !== prevStat.size) {
              this._pendingWrites.get(path3).lastChange = now2;
            }
            const pw = this._pendingWrites.get(path3);
            const df = now2 - pw.lastChange;
            if (df >= threshold) {
              this._pendingWrites.delete(path3);
              awfEmit(void 0, curStat);
            } else {
              timeoutHandler = setTimeout(
                awaitWriteFinish,
                this.options.awaitWriteFinish.pollInterval,
                curStat
              );
            }
          });
        };
        if (!this._pendingWrites.has(path3)) {
          this._pendingWrites.set(path3, {
            lastChange: now,
            cancelWait: () => {
              this._pendingWrites.delete(path3);
              clearTimeout(timeoutHandler);
              return event;
            }
          });
          timeoutHandler = setTimeout(
            awaitWriteFinish,
            this.options.awaitWriteFinish.pollInterval
          );
        }
      }
      _getGlobIgnored() {
        return [...this._ignoredPaths.values()];
      }
      /**
       * Determines whether user has asked to ignore this path.
       * @param {Path} path filepath or dir
       * @param {fs.Stats=} stats result of fs.stat
       * @returns {Boolean}
       */
      _isIgnored(path3, stats) {
        if (this.options.atomic && DOT_RE.test(path3))
          return true;
        if (!this._userIgnored) {
          const { cwd } = this.options;
          const ign = this.options.ignored;
          const ignored = ign && ign.map(normalizeIgnored(cwd));
          const paths = arrify(ignored).filter((path4) => typeof path4 === STRING_TYPE && !isGlob(path4)).map((path4) => path4 + SLASH_GLOBSTAR);
          const list = this._getGlobIgnored().map(normalizeIgnored(cwd)).concat(ignored, paths);
          this._userIgnored = anymatch(list, void 0, ANYMATCH_OPTS);
        }
        return this._userIgnored([path3, stats]);
      }
      _isntIgnored(path3, stat2) {
        return !this._isIgnored(path3, stat2);
      }
      /**
       * Provides a set of common helpers and properties relating to symlink and glob handling.
       * @param {Path} path file, directory, or glob pattern being watched
       * @param {Number=} depth at any depth > 0, this isn't a glob
       * @returns {WatchHelper} object containing helpers for this path
       */
      _getWatchHelpers(path3, depth) {
        const watchPath = depth || this.options.disableGlobbing || !isGlob(path3) ? path3 : globParent(path3);
        const follow = this.options.followSymlinks;
        return new WatchHelper(path3, watchPath, follow, this);
      }
      // Directory helpers
      // -----------------
      /**
       * Provides directory tracking objects
       * @param {String} directory path of the directory
       * @returns {DirEntry} the directory's tracking object
       */
      _getWatchedDir(directory) {
        if (!this._boundRemove)
          this._boundRemove = this._remove.bind(this);
        const dir = sysPath.resolve(directory);
        if (!this._watched.has(dir))
          this._watched.set(dir, new DirEntry(dir, this._boundRemove));
        return this._watched.get(dir);
      }
      // File helpers
      // ------------
      /**
       * Check for read permissions.
       * Based on this answer on SO: https://stackoverflow.com/a/11781404/1358405
       * @param {fs.Stats} stats - object, result of fs_stat
       * @returns {Boolean} indicates whether the file can be read
      */
      _hasReadPermissions(stats) {
        if (this.options.ignorePermissionErrors)
          return true;
        const md = stats && Number.parseInt(stats.mode, 10);
        const st = md & 511;
        const it = Number.parseInt(st.toString(8)[0], 10);
        return Boolean(4 & it);
      }
      /**
       * Handles emitting unlink events for
       * files and directories, and via recursion, for
       * files and directories within directories that are unlinked
       * @param {String} directory within which the following item is located
       * @param {String} item      base path of item/directory
       * @returns {void}
      */
      _remove(directory, item, isDirectory) {
        const path3 = sysPath.join(directory, item);
        const fullPath = sysPath.resolve(path3);
        isDirectory = isDirectory != null ? isDirectory : this._watched.has(path3) || this._watched.has(fullPath);
        if (!this._throttle("remove", path3, 100))
          return;
        if (!isDirectory && !this.options.useFsEvents && this._watched.size === 1) {
          this.add(directory, item, true);
        }
        const wp = this._getWatchedDir(path3);
        const nestedDirectoryChildren = wp.getChildren();
        nestedDirectoryChildren.forEach((nested) => this._remove(path3, nested));
        const parent = this._getWatchedDir(directory);
        const wasTracked = parent.has(item);
        parent.remove(item);
        if (this._symlinkPaths.has(fullPath)) {
          this._symlinkPaths.delete(fullPath);
        }
        let relPath = path3;
        if (this.options.cwd)
          relPath = sysPath.relative(this.options.cwd, path3);
        if (this.options.awaitWriteFinish && this._pendingWrites.has(relPath)) {
          const event = this._pendingWrites.get(relPath).cancelWait();
          if (event === EV_ADD)
            return;
        }
        this._watched.delete(path3);
        this._watched.delete(fullPath);
        const eventName = isDirectory ? EV_UNLINK_DIR : EV_UNLINK;
        if (wasTracked && !this._isIgnored(path3))
          this._emit(eventName, path3);
        if (!this.options.useFsEvents) {
          this._closePath(path3);
        }
      }
      /**
       * Closes all watchers for a path
       * @param {Path} path
       */
      _closePath(path3) {
        this._closeFile(path3);
        const dir = sysPath.dirname(path3);
        this._getWatchedDir(dir).remove(sysPath.basename(path3));
      }
      /**
       * Closes only file-specific watchers
       * @param {Path} path
       */
      _closeFile(path3) {
        const closers = this._closers.get(path3);
        if (!closers)
          return;
        closers.forEach((closer) => closer());
        this._closers.delete(path3);
      }
      /**
       *
       * @param {Path} path
       * @param {Function} closer
       */
      _addPathCloser(path3, closer) {
        if (!closer)
          return;
        let list = this._closers.get(path3);
        if (!list) {
          list = [];
          this._closers.set(path3, list);
        }
        list.push(closer);
      }
      _readdirp(root, opts) {
        if (this.closed)
          return;
        const options = { type: EV_ALL, alwaysStat: true, lstat: true, ...opts };
        let stream = readdirp(root, options);
        this._streams.add(stream);
        stream.once(STR_CLOSE, () => {
          stream = void 0;
        });
        stream.once(STR_END, () => {
          if (stream) {
            this._streams.delete(stream);
            stream = void 0;
          }
        });
        return stream;
      }
    };
    exports2.FSWatcher = FSWatcher;
    var watch = (paths, options) => {
      const watcher = new FSWatcher(options);
      watcher.add(paths);
      return watcher;
    };
    exports2.watch = watch;
  }
});

// node_modules/byline/lib/byline.js
var require_byline = __commonJS({
  "node_modules/byline/lib/byline.js"(exports2, module2) {
    var stream = require("stream");
    var util = require("util");
    var timers = require("timers");
    module2.exports = function(readStream, options) {
      return module2.exports.createStream(readStream, options);
    };
    module2.exports.createStream = function(readStream, options) {
      if (readStream) {
        return createLineStream(readStream, options);
      } else {
        return new LineStream(options);
      }
    };
    module2.exports.createLineStream = function(readStream) {
      console.log("WARNING: byline#createLineStream is deprecated and will be removed soon");
      return createLineStream(readStream);
    };
    function createLineStream(readStream, options) {
      if (!readStream) {
        throw new Error("expected readStream");
      }
      if (!readStream.readable) {
        throw new Error("readStream must be readable");
      }
      var ls = new LineStream(options);
      readStream.pipe(ls);
      return ls;
    }
    module2.exports.LineStream = LineStream;
    function LineStream(options) {
      stream.Transform.call(this, options);
      options = options || {};
      this._readableState.objectMode = true;
      this._lineBuffer = [];
      this._keepEmptyLines = options.keepEmptyLines || false;
      this._lastChunkEndedWithCR = false;
      var self2 = this;
      this.on("pipe", function(src) {
        if (!self2.encoding) {
          if (src instanceof stream.Readable) {
            self2.encoding = src._readableState.encoding;
          }
        }
      });
    }
    util.inherits(LineStream, stream.Transform);
    LineStream.prototype._transform = function(chunk, encoding, done) {
      encoding = encoding || "utf8";
      if (Buffer.isBuffer(chunk)) {
        if (encoding == "buffer") {
          chunk = chunk.toString();
          encoding = "utf8";
        } else {
          chunk = chunk.toString(encoding);
        }
      }
      this._chunkEncoding = encoding;
      var lines = chunk.split(/\r\n|[\n\v\f\r\x85\u2028\u2029]/g);
      if (this._lastChunkEndedWithCR && chunk[0] == "\n") {
        lines.shift();
      }
      if (this._lineBuffer.length > 0) {
        this._lineBuffer[this._lineBuffer.length - 1] += lines[0];
        lines.shift();
      }
      this._lastChunkEndedWithCR = chunk[chunk.length - 1] == "\r";
      this._lineBuffer = this._lineBuffer.concat(lines);
      this._pushBuffer(encoding, 1, done);
    };
    LineStream.prototype._pushBuffer = function(encoding, keep, done) {
      while (this._lineBuffer.length > keep) {
        var line = this._lineBuffer.shift();
        if (this._keepEmptyLines || line.length > 0) {
          if (!this.push(this._reencode(line, encoding))) {
            var self2 = this;
            timers.setImmediate(function() {
              self2._pushBuffer(encoding, keep, done);
            });
            return;
          }
        }
      }
      done();
    };
    LineStream.prototype._flush = function(done) {
      this._pushBuffer(this._chunkEncoding, 0, done);
    };
    LineStream.prototype._reencode = function(line, chunkEncoding) {
      if (this.encoding && this.encoding != chunkEncoding) {
        return new Buffer(line, chunkEncoding).toString(this.encoding);
      } else if (this.encoding) {
        return line;
      } else {
        return new Buffer(line, chunkEncoding);
      }
    };
  }
});

// node_modules/progress/lib/node-progress.js
var require_node_progress = __commonJS({
  "node_modules/progress/lib/node-progress.js"(exports2, module2) {
    exports2 = module2.exports = ProgressBar;
    function ProgressBar(fmt, options) {
      this.stream = options.stream || process.stderr;
      if (typeof options == "number") {
        var total = options;
        options = {};
        options.total = total;
      } else {
        options = options || {};
        if ("string" != typeof fmt)
          throw new Error("format required");
        if ("number" != typeof options.total)
          throw new Error("total required");
      }
      this.fmt = fmt;
      this.curr = options.curr || 0;
      this.total = options.total;
      this.width = options.width || this.total;
      this.clear = options.clear;
      this.chars = {
        complete: options.complete || "=",
        incomplete: options.incomplete || "-",
        head: options.head || (options.complete || "=")
      };
      this.renderThrottle = options.renderThrottle !== 0 ? options.renderThrottle || 16 : 0;
      this.lastRender = -Infinity;
      this.callback = options.callback || function() {
      };
      this.tokens = {};
      this.lastDraw = "";
    }
    ProgressBar.prototype.tick = function(len, tokens) {
      if (len !== 0)
        len = len || 1;
      if ("object" == typeof len)
        tokens = len, len = 1;
      if (tokens)
        this.tokens = tokens;
      if (0 == this.curr)
        this.start = /* @__PURE__ */ new Date();
      this.curr += len;
      this.render();
      if (this.curr >= this.total) {
        this.render(void 0, true);
        this.complete = true;
        this.terminate();
        this.callback(this);
        return;
      }
    };
    ProgressBar.prototype.render = function(tokens, force) {
      force = force !== void 0 ? force : false;
      if (tokens)
        this.tokens = tokens;
      if (!this.stream.isTTY)
        return;
      var now = Date.now();
      var delta = now - this.lastRender;
      if (!force && delta < this.renderThrottle) {
        return;
      } else {
        this.lastRender = now;
      }
      var ratio = this.curr / this.total;
      ratio = Math.min(Math.max(ratio, 0), 1);
      var percent = Math.floor(ratio * 100);
      var incomplete, complete, completeLength;
      var elapsed = /* @__PURE__ */ new Date() - this.start;
      var eta = percent == 100 ? 0 : elapsed * (this.total / this.curr - 1);
      var rate = this.curr / (elapsed / 1e3);
      var str = this.fmt.replace(":current", this.curr).replace(":total", this.total).replace(":elapsed", isNaN(elapsed) ? "0.0" : (elapsed / 1e3).toFixed(1)).replace(":eta", isNaN(eta) || !isFinite(eta) ? "0.0" : (eta / 1e3).toFixed(1)).replace(":percent", percent.toFixed(0) + "%").replace(":rate", Math.round(rate));
      var availableSpace = Math.max(0, this.stream.columns - str.replace(":bar", "").length);
      if (availableSpace && process.platform === "win32") {
        availableSpace = availableSpace - 1;
      }
      var width = Math.min(this.width, availableSpace);
      completeLength = Math.round(width * ratio);
      complete = Array(Math.max(0, completeLength + 1)).join(this.chars.complete);
      incomplete = Array(Math.max(0, width - completeLength + 1)).join(this.chars.incomplete);
      if (completeLength > 0)
        complete = complete.slice(0, -1) + this.chars.head;
      str = str.replace(":bar", complete + incomplete);
      if (this.tokens)
        for (var key in this.tokens)
          str = str.replace(":" + key, this.tokens[key]);
      if (this.lastDraw !== str) {
        this.stream.cursorTo(0);
        this.stream.write(str);
        this.stream.clearLine(1);
        this.lastDraw = str;
      }
    };
    ProgressBar.prototype.update = function(ratio, tokens) {
      var goal = Math.floor(ratio * this.total);
      var delta = goal - this.curr;
      this.tick(delta, tokens);
    };
    ProgressBar.prototype.interrupt = function(message) {
      this.stream.clearLine();
      this.stream.cursorTo(0);
      this.stream.write(message);
      this.stream.write("\n");
      this.stream.write(this.lastDraw);
    };
    ProgressBar.prototype.terminate = function() {
      if (this.clear) {
        if (this.stream.clearLine) {
          this.stream.clearLine();
          this.stream.cursorTo(0);
        }
      } else {
        this.stream.write("\n");
      }
    };
  }
});

// node_modules/progress/index.js
var require_progress = __commonJS({
  "node_modules/progress/index.js"(exports2, module2) {
    module2.exports = require_node_progress();
  }
});

// node_modules/pend/index.js
var require_pend = __commonJS({
  "node_modules/pend/index.js"(exports2, module2) {
    module2.exports = Pend;
    function Pend() {
      this.pending = 0;
      this.max = Infinity;
      this.listeners = [];
      this.waiting = [];
      this.error = null;
    }
    Pend.prototype.go = function(fn) {
      if (this.pending < this.max) {
        pendGo(this, fn);
      } else {
        this.waiting.push(fn);
      }
    };
    Pend.prototype.wait = function(cb) {
      if (this.pending === 0) {
        cb(this.error);
      } else {
        this.listeners.push(cb);
      }
    };
    Pend.prototype.hold = function() {
      return pendHold(this);
    };
    function pendHold(self2) {
      self2.pending += 1;
      var called = false;
      return onCb;
      function onCb(err) {
        if (called)
          throw new Error("callback called twice");
        called = true;
        self2.error = self2.error || err;
        self2.pending -= 1;
        if (self2.waiting.length > 0 && self2.pending < self2.max) {
          pendGo(self2, self2.waiting.shift());
        } else if (self2.pending === 0) {
          var listeners = self2.listeners;
          self2.listeners = [];
          listeners.forEach(cbListener);
        }
      }
      function cbListener(listener) {
        listener(self2.error);
      }
    }
    function pendGo(self2, fn) {
      fn(pendHold(self2));
    }
  }
});

// node_modules/yauzl/fd-slicer.js
var require_fd_slicer = __commonJS({
  "node_modules/yauzl/fd-slicer.js"(exports2) {
    var fs2 = require("fs");
    var util = require("util");
    var stream = require("stream");
    var Readable = stream.Readable;
    var Writable = stream.Writable;
    var PassThrough = stream.PassThrough;
    var Pend = require_pend();
    var EventEmitter = require("events").EventEmitter;
    exports2.createFromBuffer = createFromBuffer;
    exports2.createFromFd = createFromFd;
    exports2.BufferSlicer = BufferSlicer;
    exports2.FdSlicer = FdSlicer;
    util.inherits(FdSlicer, EventEmitter);
    function FdSlicer(fd, options) {
      options = options || {};
      EventEmitter.call(this);
      this.fd = fd;
      this.pend = new Pend();
      this.pend.max = 1;
      this.refCount = 0;
      this.autoClose = !!options.autoClose;
    }
    FdSlicer.prototype.read = function(buffer, offset, length, position, callback) {
      var self2 = this;
      self2.pend.go(function(cb) {
        fs2.read(self2.fd, buffer, offset, length, position, function(err, bytesRead, buffer2) {
          cb();
          callback(err, bytesRead, buffer2);
        });
      });
    };
    FdSlicer.prototype.write = function(buffer, offset, length, position, callback) {
      var self2 = this;
      self2.pend.go(function(cb) {
        fs2.write(self2.fd, buffer, offset, length, position, function(err, written, buffer2) {
          cb();
          callback(err, written, buffer2);
        });
      });
    };
    FdSlicer.prototype.createReadStream = function(options) {
      return new ReadStream(this, options);
    };
    FdSlicer.prototype.createWriteStream = function(options) {
      return new WriteStream(this, options);
    };
    FdSlicer.prototype.ref = function() {
      this.refCount += 1;
    };
    FdSlicer.prototype.unref = function() {
      var self2 = this;
      self2.refCount -= 1;
      if (self2.refCount > 0)
        return;
      if (self2.refCount < 0)
        throw new Error("invalid unref");
      if (self2.autoClose) {
        fs2.close(self2.fd, onCloseDone);
      }
      function onCloseDone(err) {
        if (err) {
          self2.emit("error", err);
        } else {
          self2.emit("close");
        }
      }
    };
    util.inherits(ReadStream, Readable);
    function ReadStream(context, options) {
      options = options || {};
      Readable.call(this, options);
      this.context = context;
      this.context.ref();
      this.start = options.start || 0;
      this.endOffset = options.end;
      this.pos = this.start;
      this.destroyed = false;
    }
    ReadStream.prototype._read = function(n) {
      var self2 = this;
      if (self2.destroyed)
        return;
      var toRead = Math.min(self2._readableState.highWaterMark, n);
      if (self2.endOffset != null) {
        toRead = Math.min(toRead, self2.endOffset - self2.pos);
      }
      if (toRead <= 0) {
        self2.destroyed = true;
        self2.push(null);
        self2.context.unref();
        return;
      }
      self2.context.pend.go(function(cb) {
        if (self2.destroyed)
          return cb();
        var buffer = Buffer.allocUnsafe(toRead);
        fs2.read(self2.context.fd, buffer, 0, toRead, self2.pos, function(err, bytesRead) {
          if (err) {
            self2.destroy(err);
          } else if (bytesRead === 0) {
            self2.destroyed = true;
            self2.push(null);
            self2.context.unref();
          } else {
            self2.pos += bytesRead;
            self2.push(buffer.slice(0, bytesRead));
          }
          cb();
        });
      });
    };
    ReadStream.prototype.destroy = function(err) {
      if (this.destroyed)
        return;
      err = err || new Error("stream destroyed");
      this.destroyed = true;
      this.emit("error", err);
      this.context.unref();
    };
    util.inherits(WriteStream, Writable);
    function WriteStream(context, options) {
      options = options || {};
      Writable.call(this, options);
      this.context = context;
      this.context.ref();
      this.start = options.start || 0;
      this.endOffset = options.end == null ? Infinity : +options.end;
      this.bytesWritten = 0;
      this.pos = this.start;
      this.destroyed = false;
      this.on("finish", this.destroy.bind(this));
    }
    WriteStream.prototype._write = function(buffer, encoding, callback) {
      var self2 = this;
      if (self2.destroyed)
        return;
      if (self2.pos + buffer.length > self2.endOffset) {
        var err = new Error("maximum file length exceeded");
        err.code = "ETOOBIG";
        self2.destroy();
        callback(err);
        return;
      }
      self2.context.pend.go(function(cb) {
        if (self2.destroyed)
          return cb();
        fs2.write(self2.context.fd, buffer, 0, buffer.length, self2.pos, function(err2, bytes) {
          if (err2) {
            self2.destroy();
            cb();
            callback(err2);
          } else {
            self2.bytesWritten += bytes;
            self2.pos += bytes;
            self2.emit("progress");
            cb();
            callback();
          }
        });
      });
    };
    WriteStream.prototype.destroy = function() {
      if (this.destroyed)
        return;
      this.destroyed = true;
      this.context.unref();
    };
    util.inherits(BufferSlicer, EventEmitter);
    function BufferSlicer(buffer, options) {
      EventEmitter.call(this);
      options = options || {};
      this.refCount = 0;
      this.buffer = buffer;
      this.maxChunkSize = options.maxChunkSize || Number.MAX_SAFE_INTEGER;
    }
    BufferSlicer.prototype.read = function(buffer, offset, length, position, callback) {
      var end = position + length;
      var delta = end - this.buffer.length;
      var written = delta > 0 ? delta : length;
      this.buffer.copy(buffer, offset, position, end);
      setImmediate(function() {
        callback(null, written);
      });
    };
    BufferSlicer.prototype.write = function(buffer, offset, length, position, callback) {
      buffer.copy(this.buffer, position, offset, offset + length);
      setImmediate(function() {
        callback(null, length, buffer);
      });
    };
    BufferSlicer.prototype.createReadStream = function(options) {
      options = options || {};
      var readStream = new PassThrough(options);
      readStream.destroyed = false;
      readStream.start = options.start || 0;
      readStream.endOffset = options.end;
      readStream.pos = readStream.endOffset || this.buffer.length;
      var entireSlice = this.buffer.slice(readStream.start, readStream.pos);
      var offset = 0;
      while (true) {
        var nextOffset = offset + this.maxChunkSize;
        if (nextOffset >= entireSlice.length) {
          if (offset < entireSlice.length) {
            readStream.write(entireSlice.slice(offset, entireSlice.length));
          }
          break;
        }
        readStream.write(entireSlice.slice(offset, nextOffset));
        offset = nextOffset;
      }
      readStream.end();
      readStream.destroy = function() {
        readStream.destroyed = true;
      };
      return readStream;
    };
    BufferSlicer.prototype.createWriteStream = function(options) {
      var bufferSlicer = this;
      options = options || {};
      var writeStream = new Writable(options);
      writeStream.start = options.start || 0;
      writeStream.endOffset = options.end == null ? this.buffer.length : +options.end;
      writeStream.bytesWritten = 0;
      writeStream.pos = writeStream.start;
      writeStream.destroyed = false;
      writeStream._write = function(buffer, encoding, callback) {
        if (writeStream.destroyed)
          return;
        var end = writeStream.pos + buffer.length;
        if (end > writeStream.endOffset) {
          var err = new Error("maximum file length exceeded");
          err.code = "ETOOBIG";
          writeStream.destroyed = true;
          callback(err);
          return;
        }
        buffer.copy(bufferSlicer.buffer, writeStream.pos, 0, buffer.length);
        writeStream.bytesWritten += buffer.length;
        writeStream.pos = end;
        writeStream.emit("progress");
        callback();
      };
      writeStream.destroy = function() {
        writeStream.destroyed = true;
      };
      return writeStream;
    };
    BufferSlicer.prototype.ref = function() {
      this.refCount += 1;
    };
    BufferSlicer.prototype.unref = function() {
      this.refCount -= 1;
      if (this.refCount < 0) {
        throw new Error("invalid unref");
      }
    };
    function createFromBuffer(buffer, options) {
      return new BufferSlicer(buffer, options);
    }
    function createFromFd(fd, options) {
      return new FdSlicer(fd, options);
    }
  }
});

// node_modules/buffer-crc32/index.js
var require_buffer_crc32 = __commonJS({
  "node_modules/buffer-crc32/index.js"(exports2, module2) {
    var Buffer2 = require("buffer").Buffer;
    var CRC_TABLE = [
      0,
      1996959894,
      3993919788,
      2567524794,
      124634137,
      1886057615,
      3915621685,
      2657392035,
      249268274,
      2044508324,
      3772115230,
      2547177864,
      162941995,
      2125561021,
      3887607047,
      2428444049,
      498536548,
      1789927666,
      4089016648,
      2227061214,
      450548861,
      1843258603,
      4107580753,
      2211677639,
      325883990,
      1684777152,
      4251122042,
      2321926636,
      335633487,
      1661365465,
      4195302755,
      2366115317,
      997073096,
      1281953886,
      3579855332,
      2724688242,
      1006888145,
      1258607687,
      3524101629,
      2768942443,
      901097722,
      1119000684,
      3686517206,
      2898065728,
      853044451,
      1172266101,
      3705015759,
      2882616665,
      651767980,
      1373503546,
      3369554304,
      3218104598,
      565507253,
      1454621731,
      3485111705,
      3099436303,
      671266974,
      1594198024,
      3322730930,
      2970347812,
      795835527,
      1483230225,
      3244367275,
      3060149565,
      1994146192,
      31158534,
      2563907772,
      4023717930,
      1907459465,
      112637215,
      2680153253,
      3904427059,
      2013776290,
      251722036,
      2517215374,
      3775830040,
      2137656763,
      141376813,
      2439277719,
      3865271297,
      1802195444,
      476864866,
      2238001368,
      4066508878,
      1812370925,
      453092731,
      2181625025,
      4111451223,
      1706088902,
      314042704,
      2344532202,
      4240017532,
      1658658271,
      366619977,
      2362670323,
      4224994405,
      1303535960,
      984961486,
      2747007092,
      3569037538,
      1256170817,
      1037604311,
      2765210733,
      3554079995,
      1131014506,
      879679996,
      2909243462,
      3663771856,
      1141124467,
      855842277,
      2852801631,
      3708648649,
      1342533948,
      654459306,
      3188396048,
      3373015174,
      1466479909,
      544179635,
      3110523913,
      3462522015,
      1591671054,
      702138776,
      2966460450,
      3352799412,
      1504918807,
      783551873,
      3082640443,
      3233442989,
      3988292384,
      2596254646,
      62317068,
      1957810842,
      3939845945,
      2647816111,
      81470997,
      1943803523,
      3814918930,
      2489596804,
      225274430,
      2053790376,
      3826175755,
      2466906013,
      167816743,
      2097651377,
      4027552580,
      2265490386,
      503444072,
      1762050814,
      4150417245,
      2154129355,
      426522225,
      1852507879,
      4275313526,
      2312317920,
      282753626,
      1742555852,
      4189708143,
      2394877945,
      397917763,
      1622183637,
      3604390888,
      2714866558,
      953729732,
      1340076626,
      3518719985,
      2797360999,
      1068828381,
      1219638859,
      3624741850,
      2936675148,
      906185462,
      1090812512,
      3747672003,
      2825379669,
      829329135,
      1181335161,
      3412177804,
      3160834842,
      628085408,
      1382605366,
      3423369109,
      3138078467,
      570562233,
      1426400815,
      3317316542,
      2998733608,
      733239954,
      1555261956,
      3268935591,
      3050360625,
      752459403,
      1541320221,
      2607071920,
      3965973030,
      1969922972,
      40735498,
      2617837225,
      3943577151,
      1913087877,
      83908371,
      2512341634,
      3803740692,
      2075208622,
      213261112,
      2463272603,
      3855990285,
      2094854071,
      198958881,
      2262029012,
      4057260610,
      1759359992,
      534414190,
      2176718541,
      4139329115,
      1873836001,
      414664567,
      2282248934,
      4279200368,
      1711684554,
      285281116,
      2405801727,
      4167216745,
      1634467795,
      376229701,
      2685067896,
      3608007406,
      1308918612,
      956543938,
      2808555105,
      3495958263,
      1231636301,
      1047427035,
      2932959818,
      3654703836,
      1088359270,
      936918e3,
      2847714899,
      3736837829,
      1202900863,
      817233897,
      3183342108,
      3401237130,
      1404277552,
      615818150,
      3134207493,
      3453421203,
      1423857449,
      601450431,
      3009837614,
      3294710456,
      1567103746,
      711928724,
      3020668471,
      3272380065,
      1510334235,
      755167117
    ];
    if (typeof Int32Array !== "undefined") {
      CRC_TABLE = new Int32Array(CRC_TABLE);
    }
    function ensureBuffer(input) {
      if (Buffer2.isBuffer(input)) {
        return input;
      }
      var hasNewBufferAPI = typeof Buffer2.alloc === "function" && typeof Buffer2.from === "function";
      if (typeof input === "number") {
        return hasNewBufferAPI ? Buffer2.alloc(input) : new Buffer2(input);
      } else if (typeof input === "string") {
        return hasNewBufferAPI ? Buffer2.from(input) : new Buffer2(input);
      } else {
        throw new Error("input must be buffer, number, or string, received " + typeof input);
      }
    }
    function bufferizeInt(num) {
      var tmp = ensureBuffer(4);
      tmp.writeInt32BE(num, 0);
      return tmp;
    }
    function _crc32(buf, previous) {
      buf = ensureBuffer(buf);
      if (Buffer2.isBuffer(previous)) {
        previous = previous.readUInt32BE(0);
      }
      var crc = ~~previous ^ -1;
      for (var n = 0; n < buf.length; n++) {
        crc = CRC_TABLE[(crc ^ buf[n]) & 255] ^ crc >>> 8;
      }
      return crc ^ -1;
    }
    function crc32() {
      return bufferizeInt(_crc32.apply(null, arguments));
    }
    crc32.signed = function() {
      return _crc32.apply(null, arguments);
    };
    crc32.unsigned = function() {
      return _crc32.apply(null, arguments) >>> 0;
    };
    module2.exports = crc32;
  }
});

// node_modules/yauzl/index.js
var require_yauzl = __commonJS({
  "node_modules/yauzl/index.js"(exports2) {
    var fs2 = require("fs");
    var zlib = require("zlib");
    var fd_slicer = require_fd_slicer();
    var crc32 = require_buffer_crc32();
    var util = require("util");
    var EventEmitter = require("events").EventEmitter;
    var Transform = require("stream").Transform;
    var PassThrough = require("stream").PassThrough;
    var Writable = require("stream").Writable;
    exports2.open = open;
    exports2.fromFd = fromFd;
    exports2.fromBuffer = fromBuffer;
    exports2.fromRandomAccessReader = fromRandomAccessReader;
    exports2.dosDateTimeToDate = dosDateTimeToDate;
    exports2.getFileNameLowLevel = getFileNameLowLevel;
    exports2.validateFileName = validateFileName;
    exports2.parseExtraFields = parseExtraFields;
    exports2.ZipFile = ZipFile;
    exports2.Entry = Entry;
    exports2.LocalFileHeader = LocalFileHeader;
    exports2.RandomAccessReader = RandomAccessReader;
    function open(path3, options, callback) {
      if (typeof options === "function") {
        callback = options;
        options = null;
      }
      if (options == null)
        options = {};
      if (options.autoClose == null)
        options.autoClose = true;
      if (options.lazyEntries == null)
        options.lazyEntries = false;
      if (options.decodeStrings == null)
        options.decodeStrings = true;
      if (options.validateEntrySizes == null)
        options.validateEntrySizes = true;
      if (options.strictFileNames == null)
        options.strictFileNames = false;
      if (callback == null)
        callback = defaultCallback;
      fs2.open(path3, "r", function(err, fd) {
        if (err)
          return callback(err);
        fromFd(fd, options, function(err2, zipfile) {
          if (err2)
            fs2.close(fd, defaultCallback);
          callback(err2, zipfile);
        });
      });
    }
    function fromFd(fd, options, callback) {
      if (typeof options === "function") {
        callback = options;
        options = null;
      }
      if (options == null)
        options = {};
      if (options.autoClose == null)
        options.autoClose = false;
      if (options.lazyEntries == null)
        options.lazyEntries = false;
      if (options.decodeStrings == null)
        options.decodeStrings = true;
      if (options.validateEntrySizes == null)
        options.validateEntrySizes = true;
      if (options.strictFileNames == null)
        options.strictFileNames = false;
      if (callback == null)
        callback = defaultCallback;
      fs2.fstat(fd, function(err, stats) {
        if (err)
          return callback(err);
        var reader = fd_slicer.createFromFd(fd, { autoClose: true });
        fromRandomAccessReader(reader, stats.size, options, callback);
      });
    }
    function fromBuffer(buffer, options, callback) {
      if (typeof options === "function") {
        callback = options;
        options = null;
      }
      if (options == null)
        options = {};
      options.autoClose = false;
      if (options.lazyEntries == null)
        options.lazyEntries = false;
      if (options.decodeStrings == null)
        options.decodeStrings = true;
      if (options.validateEntrySizes == null)
        options.validateEntrySizes = true;
      if (options.strictFileNames == null)
        options.strictFileNames = false;
      var reader = fd_slicer.createFromBuffer(buffer, { maxChunkSize: 65536 });
      fromRandomAccessReader(reader, buffer.length, options, callback);
    }
    function fromRandomAccessReader(reader, totalSize, options, callback) {
      if (typeof options === "function") {
        callback = options;
        options = null;
      }
      if (options == null)
        options = {};
      if (options.autoClose == null)
        options.autoClose = true;
      if (options.lazyEntries == null)
        options.lazyEntries = false;
      if (options.decodeStrings == null)
        options.decodeStrings = true;
      var decodeStrings = !!options.decodeStrings;
      if (options.validateEntrySizes == null)
        options.validateEntrySizes = true;
      if (options.strictFileNames == null)
        options.strictFileNames = false;
      if (callback == null)
        callback = defaultCallback;
      if (typeof totalSize !== "number")
        throw new Error("expected totalSize parameter to be a number");
      if (totalSize > Number.MAX_SAFE_INTEGER) {
        throw new Error("zip file too large. only file sizes up to 2^52 are supported due to JavaScript's Number type being an IEEE 754 double.");
      }
      reader.ref();
      var eocdrWithoutCommentSize = 22;
      var zip64EocdlSize = 20;
      var maxCommentSize = 65535;
      var bufferSize = Math.min(zip64EocdlSize + eocdrWithoutCommentSize + maxCommentSize, totalSize);
      var buffer = newBuffer(bufferSize);
      var bufferReadStart = totalSize - buffer.length;
      readAndAssertNoEof(reader, buffer, 0, bufferSize, bufferReadStart, function(err) {
        if (err)
          return callback(err);
        for (var i = bufferSize - eocdrWithoutCommentSize; i >= 0; i -= 1) {
          if (buffer.readUInt32LE(i) !== 101010256)
            continue;
          var eocdrBuffer = buffer.subarray(i);
          var diskNumber = eocdrBuffer.readUInt16LE(4);
          var entryCount = eocdrBuffer.readUInt16LE(10);
          var centralDirectoryOffset = eocdrBuffer.readUInt32LE(16);
          var commentLength = eocdrBuffer.readUInt16LE(20);
          var expectedCommentLength = eocdrBuffer.length - eocdrWithoutCommentSize;
          if (commentLength !== expectedCommentLength) {
            return callback(new Error("Invalid comment length. Expected: " + expectedCommentLength + ". Found: " + commentLength + ". Are there extra bytes at the end of the file? Or is the end of central dir signature `PK\u263A\u263B` in the comment?"));
          }
          var comment = decodeStrings ? decodeBuffer(eocdrBuffer.subarray(22), false) : eocdrBuffer.subarray(22);
          if (i - zip64EocdlSize >= 0 && buffer.readUInt32LE(i - zip64EocdlSize) === 117853008) {
            var zip64EocdlBuffer = buffer.subarray(i - zip64EocdlSize, i - zip64EocdlSize + zip64EocdlSize);
            var zip64EocdrOffset = readUInt64LE(zip64EocdlBuffer, 8);
            var zip64EocdrBuffer = newBuffer(56);
            return readAndAssertNoEof(reader, zip64EocdrBuffer, 0, zip64EocdrBuffer.length, zip64EocdrOffset, function(err2) {
              if (err2)
                return callback(err2);
              if (zip64EocdrBuffer.readUInt32LE(0) !== 101075792) {
                return callback(new Error("invalid zip64 end of central directory record signature"));
              }
              diskNumber = zip64EocdrBuffer.readUInt32LE(16);
              if (diskNumber !== 0) {
                return callback(new Error("multi-disk zip files are not supported: found disk number: " + diskNumber));
              }
              entryCount = readUInt64LE(zip64EocdrBuffer, 32);
              centralDirectoryOffset = readUInt64LE(zip64EocdrBuffer, 48);
              return callback(null, new ZipFile(reader, centralDirectoryOffset, totalSize, entryCount, comment, options.autoClose, options.lazyEntries, decodeStrings, options.validateEntrySizes, options.strictFileNames));
            });
          }
          if (diskNumber !== 0) {
            return callback(new Error("multi-disk zip files are not supported: found disk number: " + diskNumber));
          }
          return callback(null, new ZipFile(reader, centralDirectoryOffset, totalSize, entryCount, comment, options.autoClose, options.lazyEntries, decodeStrings, options.validateEntrySizes, options.strictFileNames));
        }
        callback(new Error("End of central directory record signature not found. Either not a zip file, or file is truncated."));
      });
    }
    util.inherits(ZipFile, EventEmitter);
    function ZipFile(reader, centralDirectoryOffset, fileSize, entryCount, comment, autoClose, lazyEntries, decodeStrings, validateEntrySizes, strictFileNames) {
      var self2 = this;
      EventEmitter.call(self2);
      self2.reader = reader;
      self2.reader.on("error", function(err) {
        emitError(self2, err);
      });
      self2.reader.once("close", function() {
        self2.emit("close");
      });
      self2.readEntryCursor = centralDirectoryOffset;
      self2.fileSize = fileSize;
      self2.entryCount = entryCount;
      self2.comment = comment;
      self2.entriesRead = 0;
      self2.autoClose = !!autoClose;
      self2.lazyEntries = !!lazyEntries;
      self2.decodeStrings = !!decodeStrings;
      self2.validateEntrySizes = !!validateEntrySizes;
      self2.strictFileNames = !!strictFileNames;
      self2.isOpen = true;
      self2.emittedError = false;
      if (!self2.lazyEntries)
        self2._readEntry();
    }
    ZipFile.prototype.close = function() {
      if (!this.isOpen)
        return;
      this.isOpen = false;
      this.reader.unref();
    };
    function emitErrorAndAutoClose(self2, err) {
      if (self2.autoClose)
        self2.close();
      emitError(self2, err);
    }
    function emitError(self2, err) {
      if (self2.emittedError)
        return;
      self2.emittedError = true;
      self2.emit("error", err);
    }
    ZipFile.prototype.readEntry = function() {
      if (!this.lazyEntries)
        throw new Error("readEntry() called without lazyEntries:true");
      this._readEntry();
    };
    ZipFile.prototype._readEntry = function() {
      var self2 = this;
      if (self2.entryCount === self2.entriesRead) {
        setImmediate(function() {
          if (self2.autoClose)
            self2.close();
          if (self2.emittedError)
            return;
          self2.emit("end");
        });
        return;
      }
      if (self2.emittedError)
        return;
      var buffer = newBuffer(46);
      readAndAssertNoEof(self2.reader, buffer, 0, buffer.length, self2.readEntryCursor, function(err) {
        if (err)
          return emitErrorAndAutoClose(self2, err);
        if (self2.emittedError)
          return;
        var entry = new Entry();
        var signature = buffer.readUInt32LE(0);
        if (signature !== 33639248)
          return emitErrorAndAutoClose(self2, new Error("invalid central directory file header signature: 0x" + signature.toString(16)));
        entry.versionMadeBy = buffer.readUInt16LE(4);
        entry.versionNeededToExtract = buffer.readUInt16LE(6);
        entry.generalPurposeBitFlag = buffer.readUInt16LE(8);
        entry.compressionMethod = buffer.readUInt16LE(10);
        entry.lastModFileTime = buffer.readUInt16LE(12);
        entry.lastModFileDate = buffer.readUInt16LE(14);
        entry.crc32 = buffer.readUInt32LE(16);
        entry.compressedSize = buffer.readUInt32LE(20);
        entry.uncompressedSize = buffer.readUInt32LE(24);
        entry.fileNameLength = buffer.readUInt16LE(28);
        entry.extraFieldLength = buffer.readUInt16LE(30);
        entry.fileCommentLength = buffer.readUInt16LE(32);
        entry.internalFileAttributes = buffer.readUInt16LE(36);
        entry.externalFileAttributes = buffer.readUInt32LE(38);
        entry.relativeOffsetOfLocalHeader = buffer.readUInt32LE(42);
        if (entry.generalPurposeBitFlag & 64)
          return emitErrorAndAutoClose(self2, new Error("strong encryption is not supported"));
        self2.readEntryCursor += 46;
        buffer = newBuffer(entry.fileNameLength + entry.extraFieldLength + entry.fileCommentLength);
        readAndAssertNoEof(self2.reader, buffer, 0, buffer.length, self2.readEntryCursor, function(err2) {
          if (err2)
            return emitErrorAndAutoClose(self2, err2);
          if (self2.emittedError)
            return;
          entry.fileNameRaw = buffer.subarray(0, entry.fileNameLength);
          var fileCommentStart = entry.fileNameLength + entry.extraFieldLength;
          entry.extraFieldRaw = buffer.subarray(entry.fileNameLength, fileCommentStart);
          entry.fileCommentRaw = buffer.subarray(fileCommentStart, fileCommentStart + entry.fileCommentLength);
          try {
            entry.extraFields = parseExtraFields(entry.extraFieldRaw);
          } catch (err3) {
            return emitErrorAndAutoClose(self2, err3);
          }
          if (self2.decodeStrings) {
            var isUtf8 = (entry.generalPurposeBitFlag & 2048) !== 0;
            entry.fileComment = decodeBuffer(entry.fileCommentRaw, isUtf8);
            entry.fileName = getFileNameLowLevel(entry.generalPurposeBitFlag, entry.fileNameRaw, entry.extraFields, self2.strictFileNames);
            var errorMessage = validateFileName(entry.fileName);
            if (errorMessage != null)
              return emitErrorAndAutoClose(self2, new Error(errorMessage));
          } else {
            entry.fileComment = entry.fileCommentRaw;
            entry.fileName = entry.fileNameRaw;
          }
          entry.comment = entry.fileComment;
          self2.readEntryCursor += buffer.length;
          self2.entriesRead += 1;
          for (var i = 0; i < entry.extraFields.length; i++) {
            var extraField = entry.extraFields[i];
            if (extraField.id !== 1)
              continue;
            var zip64EiefBuffer = extraField.data;
            var index = 0;
            if (entry.uncompressedSize === 4294967295) {
              if (index + 8 > zip64EiefBuffer.length) {
                return emitErrorAndAutoClose(self2, new Error("zip64 extended information extra field does not include uncompressed size"));
              }
              entry.uncompressedSize = readUInt64LE(zip64EiefBuffer, index);
              index += 8;
            }
            if (entry.compressedSize === 4294967295) {
              if (index + 8 > zip64EiefBuffer.length) {
                return emitErrorAndAutoClose(self2, new Error("zip64 extended information extra field does not include compressed size"));
              }
              entry.compressedSize = readUInt64LE(zip64EiefBuffer, index);
              index += 8;
            }
            if (entry.relativeOffsetOfLocalHeader === 4294967295) {
              if (index + 8 > zip64EiefBuffer.length) {
                return emitErrorAndAutoClose(self2, new Error("zip64 extended information extra field does not include relative header offset"));
              }
              entry.relativeOffsetOfLocalHeader = readUInt64LE(zip64EiefBuffer, index);
              index += 8;
            }
            break;
          }
          if (self2.validateEntrySizes && entry.compressionMethod === 0) {
            var expectedCompressedSize = entry.uncompressedSize;
            if (entry.isEncrypted()) {
              expectedCompressedSize += 12;
            }
            if (entry.compressedSize !== expectedCompressedSize) {
              var msg = "compressed/uncompressed size mismatch for stored file: " + entry.compressedSize + " != " + entry.uncompressedSize;
              return emitErrorAndAutoClose(self2, new Error(msg));
            }
          }
          self2.emit("entry", entry);
          if (!self2.lazyEntries)
            self2._readEntry();
        });
      });
    };
    ZipFile.prototype.openReadStream = function(entry, options, callback) {
      var self2 = this;
      var relativeStart = 0;
      var relativeEnd = entry.compressedSize;
      if (callback == null) {
        callback = options;
        options = null;
      }
      if (options == null) {
        options = {};
      } else {
        if (options.decrypt != null) {
          if (!entry.isEncrypted()) {
            throw new Error("options.decrypt can only be specified for encrypted entries");
          }
          if (options.decrypt !== false)
            throw new Error("invalid options.decrypt value: " + options.decrypt);
          if (entry.isCompressed()) {
            if (options.decompress !== false)
              throw new Error("entry is encrypted and compressed, and options.decompress !== false");
          }
        }
        if (options.decompress != null) {
          if (!entry.isCompressed()) {
            throw new Error("options.decompress can only be specified for compressed entries");
          }
          if (!(options.decompress === false || options.decompress === true)) {
            throw new Error("invalid options.decompress value: " + options.decompress);
          }
        }
        if (options.start != null || options.end != null) {
          if (entry.isCompressed() && options.decompress !== false) {
            throw new Error("start/end range not allowed for compressed entry without options.decompress === false");
          }
          if (entry.isEncrypted() && options.decrypt !== false) {
            throw new Error("start/end range not allowed for encrypted entry without options.decrypt === false");
          }
        }
        if (options.start != null) {
          relativeStart = options.start;
          if (relativeStart < 0)
            throw new Error("options.start < 0");
          if (relativeStart > entry.compressedSize)
            throw new Error("options.start > entry.compressedSize");
        }
        if (options.end != null) {
          relativeEnd = options.end;
          if (relativeEnd < 0)
            throw new Error("options.end < 0");
          if (relativeEnd > entry.compressedSize)
            throw new Error("options.end > entry.compressedSize");
          if (relativeEnd < relativeStart)
            throw new Error("options.end < options.start");
        }
      }
      if (!self2.isOpen)
        return callback(new Error("closed"));
      if (entry.isEncrypted()) {
        if (options.decrypt !== false)
          return callback(new Error("entry is encrypted, and options.decrypt !== false"));
      }
      var decompress;
      if (entry.compressionMethod === 0) {
        decompress = false;
      } else if (entry.compressionMethod === 8) {
        decompress = options.decompress != null ? options.decompress : true;
      } else {
        return callback(new Error("unsupported compression method: " + entry.compressionMethod));
      }
      self2.readLocalFileHeader(entry, { minimal: true }, function(err, localFileHeader) {
        if (err)
          return callback(err);
        self2.openReadStreamLowLevel(
          localFileHeader.fileDataStart,
          entry.compressedSize,
          relativeStart,
          relativeEnd,
          decompress,
          entry.uncompressedSize,
          callback
        );
      });
    };
    ZipFile.prototype.openReadStreamLowLevel = function(fileDataStart, compressedSize, relativeStart, relativeEnd, decompress, uncompressedSize, callback) {
      var self2 = this;
      var fileDataEnd = fileDataStart + compressedSize;
      var readStream = self2.reader.createReadStream({
        start: fileDataStart + relativeStart,
        end: fileDataStart + relativeEnd
      });
      var endpointStream = readStream;
      if (decompress) {
        var destroyed = false;
        var inflateFilter = zlib.createInflateRaw();
        readStream.on("error", function(err) {
          setImmediate(function() {
            if (!destroyed)
              inflateFilter.emit("error", err);
          });
        });
        readStream.pipe(inflateFilter);
        if (self2.validateEntrySizes) {
          endpointStream = new AssertByteCountStream(uncompressedSize);
          inflateFilter.on("error", function(err) {
            setImmediate(function() {
              if (!destroyed)
                endpointStream.emit("error", err);
            });
          });
          inflateFilter.pipe(endpointStream);
        } else {
          endpointStream = inflateFilter;
        }
        installDestroyFn(endpointStream, function() {
          destroyed = true;
          if (inflateFilter !== endpointStream)
            inflateFilter.unpipe(endpointStream);
          readStream.unpipe(inflateFilter);
          readStream.destroy();
        });
      }
      callback(null, endpointStream);
    };
    ZipFile.prototype.readLocalFileHeader = function(entry, options, callback) {
      var self2 = this;
      if (callback == null) {
        callback = options;
        options = null;
      }
      if (options == null)
        options = {};
      self2.reader.ref();
      var buffer = newBuffer(30);
      readAndAssertNoEof(self2.reader, buffer, 0, buffer.length, entry.relativeOffsetOfLocalHeader, function(err) {
        try {
          if (err)
            return callback(err);
          var signature = buffer.readUInt32LE(0);
          if (signature !== 67324752) {
            return callback(new Error("invalid local file header signature: 0x" + signature.toString(16)));
          }
          var fileNameLength = buffer.readUInt16LE(26);
          var extraFieldLength = buffer.readUInt16LE(28);
          var fileDataStart = entry.relativeOffsetOfLocalHeader + 30 + fileNameLength + extraFieldLength;
          if (fileDataStart + entry.compressedSize > self2.fileSize) {
            return callback(new Error("file data overflows file bounds: " + fileDataStart + " + " + entry.compressedSize + " > " + self2.fileSize));
          }
          if (options.minimal) {
            return callback(null, { fileDataStart });
          }
          var localFileHeader = new LocalFileHeader();
          localFileHeader.fileDataStart = fileDataStart;
          localFileHeader.versionNeededToExtract = buffer.readUInt16LE(4);
          localFileHeader.generalPurposeBitFlag = buffer.readUInt16LE(6);
          localFileHeader.compressionMethod = buffer.readUInt16LE(8);
          localFileHeader.lastModFileTime = buffer.readUInt16LE(10);
          localFileHeader.lastModFileDate = buffer.readUInt16LE(12);
          localFileHeader.crc32 = buffer.readUInt32LE(14);
          localFileHeader.compressedSize = buffer.readUInt32LE(18);
          localFileHeader.uncompressedSize = buffer.readUInt32LE(22);
          localFileHeader.fileNameLength = fileNameLength;
          localFileHeader.extraFieldLength = extraFieldLength;
          buffer = newBuffer(fileNameLength + extraFieldLength);
          self2.reader.ref();
          readAndAssertNoEof(self2.reader, buffer, 0, buffer.length, entry.relativeOffsetOfLocalHeader + 30, function(err2) {
            try {
              if (err2)
                return callback(err2);
              localFileHeader.fileName = buffer.subarray(0, fileNameLength);
              localFileHeader.extraField = buffer.subarray(fileNameLength);
              return callback(null, localFileHeader);
            } finally {
              self2.reader.unref();
            }
          });
        } finally {
          self2.reader.unref();
        }
      });
    };
    function Entry() {
    }
    Entry.prototype.getLastModDate = function() {
      return dosDateTimeToDate(this.lastModFileDate, this.lastModFileTime);
    };
    Entry.prototype.isEncrypted = function() {
      return (this.generalPurposeBitFlag & 1) !== 0;
    };
    Entry.prototype.isCompressed = function() {
      return this.compressionMethod === 8;
    };
    function LocalFileHeader() {
    }
    function dosDateTimeToDate(date, time) {
      var day = date & 31;
      var month = (date >> 5 & 15) - 1;
      var year = (date >> 9 & 127) + 1980;
      var millisecond = 0;
      var second = (time & 31) * 2;
      var minute = time >> 5 & 63;
      var hour = time >> 11 & 31;
      return new Date(year, month, day, hour, minute, second, millisecond);
    }
    function getFileNameLowLevel(generalPurposeBitFlag, fileNameBuffer, extraFields, strictFileNames) {
      var fileName = null;
      for (var i = 0; i < extraFields.length; i++) {
        var extraField = extraFields[i];
        if (extraField.id === 28789) {
          if (extraField.data.length < 6) {
            continue;
          }
          if (extraField.data.readUInt8(0) !== 1) {
            continue;
          }
          var oldNameCrc32 = extraField.data.readUInt32LE(1);
          if (crc32.unsigned(fileNameBuffer) !== oldNameCrc32) {
            continue;
          }
          fileName = decodeBuffer(extraField.data.subarray(5), true);
          break;
        }
      }
      if (fileName == null) {
        var isUtf8 = (generalPurposeBitFlag & 2048) !== 0;
        fileName = decodeBuffer(fileNameBuffer, isUtf8);
      }
      if (!strictFileNames) {
        fileName = fileName.replace(/\\/g, "/");
      }
      return fileName;
    }
    function validateFileName(fileName) {
      if (fileName.indexOf("\\") !== -1) {
        return "invalid characters in fileName: " + fileName;
      }
      if (/^[a-zA-Z]:/.test(fileName) || /^\//.test(fileName)) {
        return "absolute path: " + fileName;
      }
      if (fileName.split("/").indexOf("..") !== -1) {
        return "invalid relative path: " + fileName;
      }
      return null;
    }
    function parseExtraFields(extraFieldBuffer) {
      var extraFields = [];
      var i = 0;
      while (i < extraFieldBuffer.length - 3) {
        var headerId = extraFieldBuffer.readUInt16LE(i + 0);
        var dataSize = extraFieldBuffer.readUInt16LE(i + 2);
        var dataStart = i + 4;
        var dataEnd = dataStart + dataSize;
        if (dataEnd > extraFieldBuffer.length)
          throw new Error("extra field length exceeds extra field buffer size");
        var dataBuffer = extraFieldBuffer.subarray(dataStart, dataEnd);
        extraFields.push({
          id: headerId,
          data: dataBuffer
        });
        i = dataEnd;
      }
      return extraFields;
    }
    function readAndAssertNoEof(reader, buffer, offset, length, position, callback) {
      if (length === 0) {
        return setImmediate(function() {
          callback(null, newBuffer(0));
        });
      }
      reader.read(buffer, offset, length, position, function(err, bytesRead) {
        if (err)
          return callback(err);
        if (bytesRead < length) {
          return callback(new Error("unexpected EOF"));
        }
        callback();
      });
    }
    util.inherits(AssertByteCountStream, Transform);
    function AssertByteCountStream(byteCount) {
      Transform.call(this);
      this.actualByteCount = 0;
      this.expectedByteCount = byteCount;
    }
    AssertByteCountStream.prototype._transform = function(chunk, encoding, cb) {
      this.actualByteCount += chunk.length;
      if (this.actualByteCount > this.expectedByteCount) {
        var msg = "too many bytes in the stream. expected " + this.expectedByteCount + ". got at least " + this.actualByteCount;
        return cb(new Error(msg));
      }
      cb(null, chunk);
    };
    AssertByteCountStream.prototype._flush = function(cb) {
      if (this.actualByteCount < this.expectedByteCount) {
        var msg = "not enough bytes in the stream. expected " + this.expectedByteCount + ". got only " + this.actualByteCount;
        return cb(new Error(msg));
      }
      cb();
    };
    util.inherits(RandomAccessReader, EventEmitter);
    function RandomAccessReader() {
      EventEmitter.call(this);
      this.refCount = 0;
    }
    RandomAccessReader.prototype.ref = function() {
      this.refCount += 1;
    };
    RandomAccessReader.prototype.unref = function() {
      var self2 = this;
      self2.refCount -= 1;
      if (self2.refCount > 0)
        return;
      if (self2.refCount < 0)
        throw new Error("invalid unref");
      self2.close(onCloseDone);
      function onCloseDone(err) {
        if (err)
          return self2.emit("error", err);
        self2.emit("close");
      }
    };
    RandomAccessReader.prototype.createReadStream = function(options) {
      if (options == null)
        options = {};
      var start = options.start;
      var end = options.end;
      if (start === end) {
        var emptyStream = new PassThrough();
        setImmediate(function() {
          emptyStream.end();
        });
        return emptyStream;
      }
      var stream = this._readStreamForRange(start, end);
      var destroyed = false;
      var refUnrefFilter = new RefUnrefFilter(this);
      stream.on("error", function(err) {
        setImmediate(function() {
          if (!destroyed)
            refUnrefFilter.emit("error", err);
        });
      });
      installDestroyFn(refUnrefFilter, function() {
        stream.unpipe(refUnrefFilter);
        refUnrefFilter.unref();
        stream.destroy();
      });
      var byteCounter = new AssertByteCountStream(end - start);
      refUnrefFilter.on("error", function(err) {
        setImmediate(function() {
          if (!destroyed)
            byteCounter.emit("error", err);
        });
      });
      installDestroyFn(byteCounter, function() {
        destroyed = true;
        refUnrefFilter.unpipe(byteCounter);
        refUnrefFilter.destroy();
      });
      return stream.pipe(refUnrefFilter).pipe(byteCounter);
    };
    RandomAccessReader.prototype._readStreamForRange = function(start, end) {
      throw new Error("not implemented");
    };
    RandomAccessReader.prototype.read = function(buffer, offset, length, position, callback) {
      var readStream = this.createReadStream({ start: position, end: position + length });
      var writeStream = new Writable();
      var written = 0;
      writeStream._write = function(chunk, encoding, cb) {
        chunk.copy(buffer, offset + written, 0, chunk.length);
        written += chunk.length;
        cb();
      };
      writeStream.on("finish", callback);
      readStream.on("error", function(error) {
        callback(error);
      });
      readStream.pipe(writeStream);
    };
    RandomAccessReader.prototype.close = function(callback) {
      setImmediate(callback);
    };
    util.inherits(RefUnrefFilter, PassThrough);
    function RefUnrefFilter(context) {
      PassThrough.call(this);
      this.context = context;
      this.context.ref();
      this.unreffedYet = false;
    }
    RefUnrefFilter.prototype._flush = function(cb) {
      this.unref();
      cb();
    };
    RefUnrefFilter.prototype.unref = function(cb) {
      if (this.unreffedYet)
        return;
      this.unreffedYet = true;
      this.context.unref();
    };
    var cp437 = "\0\u263A\u263B\u2665\u2666\u2663\u2660\u2022\u25D8\u25CB\u25D9\u2642\u2640\u266A\u266B\u263C\u25BA\u25C4\u2195\u203C\xB6\xA7\u25AC\u21A8\u2191\u2193\u2192\u2190\u221F\u2194\u25B2\u25BC !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\u2302\xC7\xFC\xE9\xE2\xE4\xE0\xE5\xE7\xEA\xEB\xE8\xEF\xEE\xEC\xC4\xC5\xC9\xE6\xC6\xF4\xF6\xF2\xFB\xF9\xFF\xD6\xDC\xA2\xA3\xA5\u20A7\u0192\xE1\xED\xF3\xFA\xF1\xD1\xAA\xBA\xBF\u2310\xAC\xBD\xBC\xA1\xAB\xBB\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u03B1\xDF\u0393\u03C0\u03A3\u03C3\xB5\u03C4\u03A6\u0398\u03A9\u03B4\u221E\u03C6\u03B5\u2229\u2261\xB1\u2265\u2264\u2320\u2321\xF7\u2248\xB0\u2219\xB7\u221A\u207F\xB2\u25A0\xA0";
    function decodeBuffer(buffer, isUtf8) {
      if (isUtf8) {
        return buffer.toString("utf8");
      } else {
        var result2 = "";
        for (var i = 0; i < buffer.length; i++) {
          result2 += cp437[buffer[i]];
        }
        return result2;
      }
    }
    function readUInt64LE(buffer, offset) {
      var lower32 = buffer.readUInt32LE(offset);
      var upper32 = buffer.readUInt32LE(offset + 4);
      return upper32 * 4294967296 + lower32;
    }
    var newBuffer;
    if (typeof Buffer.allocUnsafe === "function") {
      newBuffer = function(len) {
        return Buffer.allocUnsafe(len);
      };
    } else {
      newBuffer = function(len) {
        return new Buffer(len);
      };
    }
    function installDestroyFn(stream, fn) {
      if (typeof stream.destroy === "function") {
        stream._destroy = function(err, cb) {
          fn();
          if (cb != null)
            cb(err);
        };
      } else {
        stream.destroy = fn;
      }
    }
    function defaultCallback(err) {
      if (err)
        throw err;
    }
  }
});

// node_modules/colors/lib/styles.js
var require_styles = __commonJS({
  "node_modules/colors/lib/styles.js"(exports2, module2) {
    var styles = {};
    module2["exports"] = styles;
    var codes = {
      reset: [0, 0],
      bold: [1, 22],
      dim: [2, 22],
      italic: [3, 23],
      underline: [4, 24],
      inverse: [7, 27],
      hidden: [8, 28],
      strikethrough: [9, 29],
      black: [30, 39],
      red: [31, 39],
      green: [32, 39],
      yellow: [33, 39],
      blue: [34, 39],
      magenta: [35, 39],
      cyan: [36, 39],
      white: [37, 39],
      gray: [90, 39],
      grey: [90, 39],
      bgBlack: [40, 49],
      bgRed: [41, 49],
      bgGreen: [42, 49],
      bgYellow: [43, 49],
      bgBlue: [44, 49],
      bgMagenta: [45, 49],
      bgCyan: [46, 49],
      bgWhite: [47, 49],
      // legacy styles for colors pre v1.0.0
      blackBG: [40, 49],
      redBG: [41, 49],
      greenBG: [42, 49],
      yellowBG: [43, 49],
      blueBG: [44, 49],
      magentaBG: [45, 49],
      cyanBG: [46, 49],
      whiteBG: [47, 49]
    };
    Object.keys(codes).forEach(function(key) {
      var val = codes[key];
      var style = styles[key] = [];
      style.open = "\x1B[" + val[0] + "m";
      style.close = "\x1B[" + val[1] + "m";
    });
  }
});

// node_modules/colors/lib/system/supports-colors.js
var require_supports_colors = __commonJS({
  "node_modules/colors/lib/system/supports-colors.js"(exports2, module2) {
    var argv = process.argv;
    module2.exports = function() {
      if (argv.indexOf("--no-color") !== -1 || argv.indexOf("--color=false") !== -1) {
        return false;
      }
      if (argv.indexOf("--color") !== -1 || argv.indexOf("--color=true") !== -1 || argv.indexOf("--color=always") !== -1) {
        return true;
      }
      if (process.stdout && !process.stdout.isTTY) {
        return false;
      }
      if (process.platform === "win32") {
        return true;
      }
      if ("COLORTERM" in process.env) {
        return true;
      }
      if (process.env.TERM === "dumb") {
        return false;
      }
      if (/^screen|^xterm|^vt100|color|ansi|cygwin|linux/i.test(process.env.TERM)) {
        return true;
      }
      return false;
    }();
  }
});

// node_modules/colors/lib/custom/trap.js
var require_trap = __commonJS({
  "node_modules/colors/lib/custom/trap.js"(exports2, module2) {
    module2["exports"] = function runTheTrap(text2, options) {
      var result2 = "";
      text2 = text2 || "Run the trap, drop the bass";
      text2 = text2.split("");
      var trap = {
        a: ["@", "\u0104", "\u023A", "\u0245", "\u0394", "\u039B", "\u0414"],
        b: ["\xDF", "\u0181", "\u0243", "\u026E", "\u03B2", "\u0E3F"],
        c: ["\xA9", "\u023B", "\u03FE"],
        d: ["\xD0", "\u018A", "\u0500", "\u0501", "\u0502", "\u0503"],
        e: ["\xCB", "\u0115", "\u018E", "\u0258", "\u03A3", "\u03BE", "\u04BC", "\u0A6C"],
        f: ["\u04FA"],
        g: ["\u0262"],
        h: ["\u0126", "\u0195", "\u04A2", "\u04BA", "\u04C7", "\u050A"],
        i: ["\u0F0F"],
        j: ["\u0134"],
        k: ["\u0138", "\u04A0", "\u04C3", "\u051E"],
        l: ["\u0139"],
        m: ["\u028D", "\u04CD", "\u04CE", "\u0520", "\u0521", "\u0D69"],
        n: ["\xD1", "\u014B", "\u019D", "\u0376", "\u03A0", "\u048A"],
        o: ["\xD8", "\xF5", "\xF8", "\u01FE", "\u0298", "\u047A", "\u05DD", "\u06DD", "\u0E4F"],
        p: ["\u01F7", "\u048E"],
        q: ["\u09CD"],
        r: ["\xAE", "\u01A6", "\u0210", "\u024C", "\u0280", "\u042F"],
        s: ["\xA7", "\u03DE", "\u03DF", "\u03E8"],
        t: ["\u0141", "\u0166", "\u0373"],
        u: ["\u01B1", "\u054D"],
        v: ["\u05D8"],
        w: ["\u0428", "\u0460", "\u047C", "\u0D70"],
        x: ["\u04B2", "\u04FE", "\u04FC", "\u04FD"],
        y: ["\xA5", "\u04B0", "\u04CB"],
        z: ["\u01B5", "\u0240"]
      };
      text2.forEach(function(c2) {
        c2 = c2.toLowerCase();
        var chars = trap[c2] || [" "];
        var rand = Math.floor(Math.random() * chars.length);
        if (typeof trap[c2] !== "undefined") {
          result2 += trap[c2][rand];
        } else {
          result2 += c2;
        }
      });
      return result2;
    };
  }
});

// node_modules/colors/lib/custom/zalgo.js
var require_zalgo = __commonJS({
  "node_modules/colors/lib/custom/zalgo.js"(exports2, module2) {
    module2["exports"] = function zalgo(text2, options) {
      text2 = text2 || "   he is here   ";
      var soul = {
        "up": [
          "\u030D",
          "\u030E",
          "\u0304",
          "\u0305",
          "\u033F",
          "\u0311",
          "\u0306",
          "\u0310",
          "\u0352",
          "\u0357",
          "\u0351",
          "\u0307",
          "\u0308",
          "\u030A",
          "\u0342",
          "\u0313",
          "\u0308",
          "\u034A",
          "\u034B",
          "\u034C",
          "\u0303",
          "\u0302",
          "\u030C",
          "\u0350",
          "\u0300",
          "\u0301",
          "\u030B",
          "\u030F",
          "\u0312",
          "\u0313",
          "\u0314",
          "\u033D",
          "\u0309",
          "\u0363",
          "\u0364",
          "\u0365",
          "\u0366",
          "\u0367",
          "\u0368",
          "\u0369",
          "\u036A",
          "\u036B",
          "\u036C",
          "\u036D",
          "\u036E",
          "\u036F",
          "\u033E",
          "\u035B",
          "\u0346",
          "\u031A"
        ],
        "down": [
          "\u0316",
          "\u0317",
          "\u0318",
          "\u0319",
          "\u031C",
          "\u031D",
          "\u031E",
          "\u031F",
          "\u0320",
          "\u0324",
          "\u0325",
          "\u0326",
          "\u0329",
          "\u032A",
          "\u032B",
          "\u032C",
          "\u032D",
          "\u032E",
          "\u032F",
          "\u0330",
          "\u0331",
          "\u0332",
          "\u0333",
          "\u0339",
          "\u033A",
          "\u033B",
          "\u033C",
          "\u0345",
          "\u0347",
          "\u0348",
          "\u0349",
          "\u034D",
          "\u034E",
          "\u0353",
          "\u0354",
          "\u0355",
          "\u0356",
          "\u0359",
          "\u035A",
          "\u0323"
        ],
        "mid": [
          "\u0315",
          "\u031B",
          "\u0300",
          "\u0301",
          "\u0358",
          "\u0321",
          "\u0322",
          "\u0327",
          "\u0328",
          "\u0334",
          "\u0335",
          "\u0336",
          "\u035C",
          "\u035D",
          "\u035E",
          "\u035F",
          "\u0360",
          "\u0362",
          "\u0338",
          "\u0337",
          "\u0361",
          " \u0489"
        ]
      }, all = [].concat(soul.up, soul.down, soul.mid), zalgo2 = {};
      function randomNumber(range) {
        var r = Math.floor(Math.random() * range);
        return r;
      }
      function is_char(character) {
        var bool = false;
        all.filter(function(i) {
          bool = i === character;
        });
        return bool;
      }
      function heComes(text3, options2) {
        var result2 = "", counts, l2;
        options2 = options2 || {};
        options2["up"] = options2["up"] || true;
        options2["mid"] = options2["mid"] || true;
        options2["down"] = options2["down"] || true;
        options2["size"] = options2["size"] || "maxi";
        text3 = text3.split("");
        for (l2 in text3) {
          if (is_char(l2)) {
            continue;
          }
          result2 = result2 + text3[l2];
          counts = { "up": 0, "down": 0, "mid": 0 };
          switch (options2.size) {
            case "mini":
              counts.up = randomNumber(8);
              counts.min = randomNumber(2);
              counts.down = randomNumber(8);
              break;
            case "maxi":
              counts.up = randomNumber(16) + 3;
              counts.min = randomNumber(4) + 1;
              counts.down = randomNumber(64) + 3;
              break;
            default:
              counts.up = randomNumber(8) + 1;
              counts.mid = randomNumber(6) / 2;
              counts.down = randomNumber(8) + 1;
              break;
          }
          var arr = ["up", "mid", "down"];
          for (var d2 in arr) {
            var index = arr[d2];
            for (var i = 0; i <= counts[index]; i++) {
              if (options2[index]) {
                result2 = result2 + soul[index][randomNumber(soul[index].length)];
              }
            }
          }
        }
        return result2;
      }
      return heComes(text2);
    };
  }
});

// node_modules/colors/lib/maps/america.js
var require_america = __commonJS({
  "node_modules/colors/lib/maps/america.js"(exports2, module2) {
    var colors = require_colors();
    module2["exports"] = /* @__PURE__ */ function() {
      return function(letter, i, exploded) {
        if (letter === " ")
          return letter;
        switch (i % 3) {
          case 0:
            return colors.red(letter);
          case 1:
            return colors.white(letter);
          case 2:
            return colors.blue(letter);
        }
      };
    }();
  }
});

// node_modules/colors/lib/maps/zebra.js
var require_zebra = __commonJS({
  "node_modules/colors/lib/maps/zebra.js"(exports2, module2) {
    var colors = require_colors();
    module2["exports"] = function(letter, i, exploded) {
      return i % 2 === 0 ? letter : colors.inverse(letter);
    };
  }
});

// node_modules/colors/lib/maps/rainbow.js
var require_rainbow = __commonJS({
  "node_modules/colors/lib/maps/rainbow.js"(exports2, module2) {
    var colors = require_colors();
    module2["exports"] = /* @__PURE__ */ function() {
      var rainbowColors = ["red", "yellow", "green", "blue", "magenta"];
      return function(letter, i, exploded) {
        if (letter === " ") {
          return letter;
        } else {
          return colors[rainbowColors[i++ % rainbowColors.length]](letter);
        }
      };
    }();
  }
});

// node_modules/colors/lib/maps/random.js
var require_random = __commonJS({
  "node_modules/colors/lib/maps/random.js"(exports2, module2) {
    var colors = require_colors();
    module2["exports"] = /* @__PURE__ */ function() {
      var available = ["underline", "inverse", "grey", "yellow", "red", "green", "blue", "white", "cyan", "magenta"];
      return function(letter, i, exploded) {
        return letter === " " ? letter : colors[available[Math.round(Math.random() * (available.length - 1))]](letter);
      };
    }();
  }
});

// node_modules/colors/lib/colors.js
var require_colors = __commonJS({
  "node_modules/colors/lib/colors.js"(exports2, module2) {
    var colors = {};
    module2["exports"] = colors;
    colors.themes = {};
    var ansiStyles = colors.styles = require_styles();
    var defineProps = Object.defineProperties;
    colors.supportsColor = require_supports_colors();
    if (typeof colors.enabled === "undefined") {
      colors.enabled = colors.supportsColor;
    }
    colors.stripColors = colors.strip = function(str) {
      return ("" + str).replace(/\x1B\[\d+m/g, "");
    };
    var stylize = colors.stylize = function stylize2(str, style) {
      return ansiStyles[style].open + str + ansiStyles[style].close;
    };
    var matchOperatorsRe = /[|\\{}()[\]^$+*?.]/g;
    var escapeStringRegexp = function(str) {
      if (typeof str !== "string") {
        throw new TypeError("Expected a string");
      }
      return str.replace(matchOperatorsRe, "\\$&");
    };
    function build(_styles) {
      var builder = function builder2() {
        return applyStyle.apply(builder2, arguments);
      };
      builder._styles = _styles;
      builder.__proto__ = proto;
      return builder;
    }
    var styles = function() {
      var ret = {};
      ansiStyles.grey = ansiStyles.gray;
      Object.keys(ansiStyles).forEach(function(key) {
        ansiStyles[key].closeRe = new RegExp(escapeStringRegexp(ansiStyles[key].close), "g");
        ret[key] = {
          get: function() {
            return build(this._styles.concat(key));
          }
        };
      });
      return ret;
    }();
    var proto = defineProps(function colors2() {
    }, styles);
    function applyStyle() {
      var args = arguments;
      var argsLen = args.length;
      var str = argsLen !== 0 && String(arguments[0]);
      if (argsLen > 1) {
        for (var a = 1; a < argsLen; a++) {
          str += " " + args[a];
        }
      }
      if (!colors.enabled || !str) {
        return str;
      }
      var nestedStyles = this._styles;
      var i = nestedStyles.length;
      while (i--) {
        var code = ansiStyles[nestedStyles[i]];
        str = code.open + str.replace(code.closeRe, code.open) + code.close;
      }
      return str;
    }
    function applyTheme(theme) {
      for (var style in theme) {
        (function(style2) {
          colors[style2] = function(str) {
            return colors[theme[style2]](str);
          };
        })(style);
      }
    }
    colors.setTheme = function(theme) {
      if (typeof theme === "string") {
        try {
          colors.themes[theme] = require(theme);
          applyTheme(colors.themes[theme]);
          return colors.themes[theme];
        } catch (err) {
          console.log(err);
          return err;
        }
      } else {
        applyTheme(theme);
      }
    };
    function init2() {
      var ret = {};
      Object.keys(styles).forEach(function(name) {
        ret[name] = {
          get: function() {
            return build([name]);
          }
        };
      });
      return ret;
    }
    var sequencer = function sequencer2(map2, str) {
      var exploded = str.split(""), i = 0;
      exploded = exploded.map(map2);
      return exploded.join("");
    };
    colors.trap = require_trap();
    colors.zalgo = require_zalgo();
    colors.maps = {};
    colors.maps.america = require_america();
    colors.maps.zebra = require_zebra();
    colors.maps.rainbow = require_rainbow();
    colors.maps.random = require_random();
    for (map in colors.maps) {
      (function(map2) {
        colors[map2] = function(str) {
          return sequencer(colors.maps[map2], str);
        };
      })(map);
    }
    var map;
    defineProps(colors, init2());
  }
});

// node_modules/colors/safe.js
var require_safe = __commonJS({
  "node_modules/colors/safe.js"(exports2, module2) {
    var colors = require_colors();
    module2["exports"] = colors;
  }
});

// node_modules/cli-table/lib/utils.js
var require_utils10 = __commonJS({
  "node_modules/cli-table/lib/utils.js"(exports2) {
    exports2.repeat = function(str, times) {
      return Array(times + 1).join(str);
    };
    exports2.pad = function(str, len, pad, dir) {
      if (len + 1 >= str.length)
        switch (dir) {
          case "left":
            str = Array(len + 1 - str.length).join(pad) + str;
            break;
          case "both":
            var right = Math.ceil((padlen = len - str.length) / 2);
            var left = padlen - right;
            str = Array(left + 1).join(pad) + str + Array(right + 1).join(pad);
            break;
          default:
            str = str + Array(len + 1 - str.length).join(pad);
        }
      ;
      return str;
    };
    exports2.truncate = function(str, length, chr) {
      chr = chr || "\u2026";
      return str.length >= length ? str.substr(0, length - chr.length) + chr : str;
    };
    function options(defaults, opts) {
      for (var p3 in opts) {
        if (p3 === "__proto__" || p3 === "constructor" || p3 === "prototype") {
          continue;
        }
        if (opts[p3] && opts[p3].constructor && opts[p3].constructor === Object) {
          defaults[p3] = defaults[p3] || {};
          options(defaults[p3], opts[p3]);
        } else {
          defaults[p3] = opts[p3];
        }
      }
      return defaults;
    }
    exports2.options = options;
    exports2.strlen = function(str) {
      var code = /\u001b\[(?:\d*;){0,5}\d*m/g;
      var stripped = ("" + str).replace(code, "");
      var split = stripped.split("\n");
      return split.reduce(function(memo, s) {
        return s.length > memo ? s.length : memo;
      }, 0);
    };
  }
});

// node_modules/cli-table/lib/index.js
var require_lib17 = __commonJS({
  "node_modules/cli-table/lib/index.js"(exports2, module2) {
    var colors = require_safe();
    var utils = require_utils10();
    var repeat = utils.repeat;
    var truncate = utils.truncate;
    var pad = utils.pad;
    function Table(options) {
      this.options = utils.options({
        chars: {
          "top": "\u2500",
          "top-mid": "\u252C",
          "top-left": "\u250C",
          "top-right": "\u2510",
          "bottom": "\u2500",
          "bottom-mid": "\u2534",
          "bottom-left": "\u2514",
          "bottom-right": "\u2518",
          "left": "\u2502",
          "left-mid": "\u251C",
          "mid": "\u2500",
          "mid-mid": "\u253C",
          "right": "\u2502",
          "right-mid": "\u2524",
          "middle": "\u2502"
        },
        truncate: "\u2026",
        colWidths: [],
        colAligns: [],
        style: {
          "padding-left": 1,
          "padding-right": 1,
          head: ["red"],
          border: ["grey"],
          compact: false
        },
        head: []
      }, options);
      if (options && options.rows) {
        for (var i = 0; i < options.rows.length; i++) {
          this.push(options.rows[i]);
        }
      }
    }
    Table.prototype.__proto__ = Array.prototype;
    Table.prototype.__defineGetter__("width", function() {
      var str = this.toString().split("\n");
      if (str.length)
        return str[0].length;
      return 0;
    });
    Table.prototype.render;
    Table.prototype.toString = function() {
      var ret = "", options = this.options, style = options.style, head = options.head, chars = options.chars, truncater = options.truncate, colWidths = options.colWidths || new Array(this.head.length), totalWidth = 0;
      if (!head.length && !this.length)
        return "";
      if (!colWidths.length) {
        var all_rows = this.slice(0);
        if (head.length) {
          all_rows = all_rows.concat([head]);
        }
        ;
        all_rows.forEach(function(cells) {
          if (typeof cells === "object" && cells.length) {
            extractColumnWidths(cells);
          } else {
            var header_cell = Object.keys(cells)[0], value_cell = cells[header_cell];
            colWidths[0] = Math.max(colWidths[0] || 0, get_width(header_cell) || 0);
            if (typeof value_cell === "object" && value_cell.length) {
              extractColumnWidths(value_cell, 1);
            } else {
              colWidths[1] = Math.max(colWidths[1] || 0, get_width(value_cell) || 0);
            }
          }
        });
      }
      ;
      totalWidth = (colWidths.length == 1 ? colWidths[0] : colWidths.reduce(
        function(a, b) {
          return a + b;
        }
      )) + colWidths.length + 1;
      function extractColumnWidths(arr, offset) {
        var offset = offset || 0;
        arr.forEach(function(cell, i) {
          colWidths[i + offset] = Math.max(colWidths[i + offset] || 0, get_width(cell) || 0);
        });
      }
      ;
      function get_width(obj) {
        return typeof obj == "object" && obj.width != void 0 ? obj.width : (typeof obj == "object" ? utils.strlen(obj.text) : utils.strlen(obj)) + (style["padding-left"] || 0) + (style["padding-right"] || 0);
      }
      function line(line2, left, right, intersection) {
        var width = 0, line2 = left + repeat(line2, totalWidth - 2) + right;
        colWidths.forEach(function(w, i) {
          if (i == colWidths.length - 1)
            return;
          width += w + 1;
          line2 = line2.substr(0, width) + intersection + line2.substr(width + 1);
        });
        return applyStyles(options.style.border, line2);
      }
      ;
      function lineTop() {
        var l3 = line(
          chars.top,
          chars["top-left"] || chars.top,
          chars["top-right"] || chars.top,
          chars["top-mid"]
        );
        if (l3)
          ret += l3 + "\n";
      }
      ;
      function generateRow(items, style2) {
        var cells = [], max_height = 0;
        if (!Array.isArray(items) && typeof items === "object") {
          var key = Object.keys(items)[0], value = items[key], first_cell_head = true;
          if (Array.isArray(value)) {
            items = value;
            items.unshift(key);
          } else {
            items = [key, value];
          }
        }
        items.forEach(function(item, i) {
          var contents = item.toString().split("\n").reduce(function(memo, l3) {
            memo.push(string(l3, i));
            return memo;
          }, []);
          var height = contents.length;
          if (height > max_height) {
            max_height = height;
          }
          ;
          cells.push({ contents, height });
        });
        var lines = new Array(max_height);
        cells.forEach(function(cell, i) {
          cell.contents.forEach(function(line2, j2) {
            if (!lines[j2]) {
              lines[j2] = [];
            }
            ;
            if (style2 || first_cell_head && i === 0 && options.style.head) {
              line2 = applyStyles(options.style.head, line2);
            }
            lines[j2].push(line2);
          });
          for (var j = cell.height, l3 = max_height; j < l3; j++) {
            if (!lines[j]) {
              lines[j] = [];
            }
            ;
            lines[j].push(string("", i));
          }
        });
        var ret2 = "";
        lines.forEach(function(line2, index) {
          if (ret2.length > 0) {
            ret2 += "\n" + applyStyles(options.style.border, chars.left);
          }
          ret2 += line2.join(applyStyles(options.style.border, chars.middle)) + applyStyles(options.style.border, chars.right);
        });
        return applyStyles(options.style.border, chars.left) + ret2;
      }
      ;
      function applyStyles(styles, subject) {
        if (!subject)
          return "";
        styles.forEach(function(style2) {
          subject = colors[style2](subject);
        });
        return subject;
      }
      ;
      function string(str, index) {
        var str = String(typeof str == "object" && str.text ? str.text : str), length = utils.strlen(str), width = colWidths[index] - (style["padding-left"] || 0) - (style["padding-right"] || 0), align = options.colAligns[index] || "left";
        return repeat(" ", style["padding-left"] || 0) + (length == width ? str : length < width ? pad(str, width + (str.length - length), " ", align == "left" ? "right" : align == "middle" ? "both" : "left") : truncater ? truncate(str, width, truncater) : str) + repeat(" ", style["padding-right"] || 0);
      }
      ;
      if (head.length) {
        lineTop();
        ret += generateRow(head, style.head) + "\n";
      }
      if (this.length)
        this.forEach(function(cells, i) {
          if (!head.length && i == 0)
            lineTop();
          else {
            if (!style.compact || i < !!head.length ? 1 : cells.length == 0) {
              var l3 = line(
                chars.mid,
                chars["left-mid"],
                chars["right-mid"],
                chars["mid-mid"]
              );
              if (l3)
                ret += l3 + "\n";
            }
          }
          if (cells.hasOwnProperty("length") && !cells.length) {
            return;
          } else {
            ret += generateRow(cells) + "\n";
          }
          ;
        });
      var l2 = line(
        chars.bottom,
        chars["bottom-left"] || chars.bottom,
        chars["bottom-right"] || chars.bottom,
        chars["bottom-mid"]
      );
      if (l2)
        ret += l2;
      else
        ret = ret.slice(0, -1);
      return ret;
    };
    module2.exports = Table;
    module2.exports.version = "0.0.1";
  }
});

// node_modules/tunnel/lib/tunnel.js
var require_tunnel = __commonJS({
  "node_modules/tunnel/lib/tunnel.js"(exports2) {
    "use strict";
    var net = require("net");
    var tls = require("tls");
    var http2 = require("http");
    var https = require("https");
    var events = require("events");
    var assert = require("assert");
    var util = require("util");
    exports2.httpOverHttp = httpOverHttp;
    exports2.httpsOverHttp = httpsOverHttp;
    exports2.httpOverHttps = httpOverHttps;
    exports2.httpsOverHttps = httpsOverHttps;
    function httpOverHttp(options) {
      var agent = new TunnelingAgent(options);
      agent.request = http2.request;
      return agent;
    }
    function httpsOverHttp(options) {
      var agent = new TunnelingAgent(options);
      agent.request = http2.request;
      agent.createSocket = createSecureSocket;
      agent.defaultPort = 443;
      return agent;
    }
    function httpOverHttps(options) {
      var agent = new TunnelingAgent(options);
      agent.request = https.request;
      return agent;
    }
    function httpsOverHttps(options) {
      var agent = new TunnelingAgent(options);
      agent.request = https.request;
      agent.createSocket = createSecureSocket;
      agent.defaultPort = 443;
      return agent;
    }
    function TunnelingAgent(options) {
      var self2 = this;
      self2.options = options || {};
      self2.proxyOptions = self2.options.proxy || {};
      self2.maxSockets = self2.options.maxSockets || http2.Agent.defaultMaxSockets;
      self2.requests = [];
      self2.sockets = [];
      self2.on("free", function onFree(socket, host, port2, localAddress) {
        var options2 = toOptions(host, port2, localAddress);
        for (var i = 0, len = self2.requests.length; i < len; ++i) {
          var pending = self2.requests[i];
          if (pending.host === options2.host && pending.port === options2.port) {
            self2.requests.splice(i, 1);
            pending.request.onSocket(socket);
            return;
          }
        }
        socket.destroy();
        self2.removeSocket(socket);
      });
    }
    util.inherits(TunnelingAgent, events.EventEmitter);
    TunnelingAgent.prototype.addRequest = function addRequest(req, host, port2, localAddress) {
      var self2 = this;
      var options = mergeOptions({ request: req }, self2.options, toOptions(host, port2, localAddress));
      if (self2.sockets.length >= this.maxSockets) {
        self2.requests.push(options);
        return;
      }
      self2.createSocket(options, function(socket) {
        socket.on("free", onFree);
        socket.on("close", onCloseOrRemove);
        socket.on("agentRemove", onCloseOrRemove);
        req.onSocket(socket);
        function onFree() {
          self2.emit("free", socket, options);
        }
        function onCloseOrRemove(err) {
          self2.removeSocket(socket);
          socket.removeListener("free", onFree);
          socket.removeListener("close", onCloseOrRemove);
          socket.removeListener("agentRemove", onCloseOrRemove);
        }
      });
    };
    TunnelingAgent.prototype.createSocket = function createSocket(options, cb) {
      var self2 = this;
      var placeholder = {};
      self2.sockets.push(placeholder);
      var connectOptions = mergeOptions({}, self2.proxyOptions, {
        method: "CONNECT",
        path: options.host + ":" + options.port,
        agent: false,
        headers: {
          host: options.host + ":" + options.port
        }
      });
      if (options.localAddress) {
        connectOptions.localAddress = options.localAddress;
      }
      if (connectOptions.proxyAuth) {
        connectOptions.headers = connectOptions.headers || {};
        connectOptions.headers["Proxy-Authorization"] = "Basic " + new Buffer(connectOptions.proxyAuth).toString("base64");
      }
      debug("making CONNECT request");
      var connectReq = self2.request(connectOptions);
      connectReq.useChunkedEncodingByDefault = false;
      connectReq.once("response", onResponse);
      connectReq.once("upgrade", onUpgrade);
      connectReq.once("connect", onConnect);
      connectReq.once("error", onError);
      connectReq.end();
      function onResponse(res) {
        res.upgrade = true;
      }
      function onUpgrade(res, socket, head) {
        process.nextTick(function() {
          onConnect(res, socket, head);
        });
      }
      function onConnect(res, socket, head) {
        connectReq.removeAllListeners();
        socket.removeAllListeners();
        if (res.statusCode !== 200) {
          debug(
            "tunneling socket could not be established, statusCode=%d",
            res.statusCode
          );
          socket.destroy();
          var error = new Error("tunneling socket could not be established, statusCode=" + res.statusCode);
          error.code = "ECONNRESET";
          options.request.emit("error", error);
          self2.removeSocket(placeholder);
          return;
        }
        if (head.length > 0) {
          debug("got illegal response body from proxy");
          socket.destroy();
          var error = new Error("got illegal response body from proxy");
          error.code = "ECONNRESET";
          options.request.emit("error", error);
          self2.removeSocket(placeholder);
          return;
        }
        debug("tunneling connection has established");
        self2.sockets[self2.sockets.indexOf(placeholder)] = socket;
        return cb(socket);
      }
      function onError(cause) {
        connectReq.removeAllListeners();
        debug(
          "tunneling socket could not be established, cause=%s\n",
          cause.message,
          cause.stack
        );
        var error = new Error("tunneling socket could not be established, cause=" + cause.message);
        error.code = "ECONNRESET";
        options.request.emit("error", error);
        self2.removeSocket(placeholder);
      }
    };
    TunnelingAgent.prototype.removeSocket = function removeSocket(socket) {
      var pos = this.sockets.indexOf(socket);
      if (pos === -1) {
        return;
      }
      this.sockets.splice(pos, 1);
      var pending = this.requests.shift();
      if (pending) {
        this.createSocket(pending, function(socket2) {
          pending.request.onSocket(socket2);
        });
      }
    };
    function createSecureSocket(options, cb) {
      var self2 = this;
      TunnelingAgent.prototype.createSocket.call(self2, options, function(socket) {
        var hostHeader = options.request.getHeader("host");
        var tlsOptions = mergeOptions({}, self2.options, {
          socket,
          servername: hostHeader ? hostHeader.replace(/:.*$/, "") : options.host
        });
        var secureSocket = tls.connect(0, tlsOptions);
        self2.sockets[self2.sockets.indexOf(socket)] = secureSocket;
        cb(secureSocket);
      });
    }
    function toOptions(host, port2, localAddress) {
      if (typeof host === "string") {
        return {
          host,
          port: port2,
          localAddress
        };
      }
      return host;
    }
    function mergeOptions(target) {
      for (var i = 1, len = arguments.length; i < len; ++i) {
        var overrides = arguments[i];
        if (typeof overrides === "object") {
          var keys = Object.keys(overrides);
          for (var j = 0, keyLen = keys.length; j < keyLen; ++j) {
            var k = keys[j];
            if (overrides[k] !== void 0) {
              target[k] = overrides[k];
            }
          }
        }
      }
      return target;
    }
    var debug;
    if (process.env.NODE_DEBUG && /\btunnel\b/.test(process.env.NODE_DEBUG)) {
      debug = function() {
        var args = Array.prototype.slice.call(arguments);
        if (typeof args[0] === "string") {
          args[0] = "TUNNEL: " + args[0];
        } else {
          args.unshift("TUNNEL:");
        }
        console.error.apply(console, args);
      };
    } else {
      debug = function() {
      };
    }
    exports2.debug = debug;
  }
});

// node_modules/tunnel/index.js
var require_tunnel2 = __commonJS({
  "node_modules/tunnel/index.js"(exports2, module2) {
    module2.exports = require_tunnel();
  }
});

// node_modules/wget-improved-2/lib/wget.js
var require_wget = __commonJS({
  "node_modules/wget-improved-2/lib/wget.js"(exports2) {
    "use strict";
    var http2 = require("http");
    var https = require("https");
    var tunnel = require_tunnel2();
    var url = require("url");
    var zlib = require("zlib");
    var fs2 = require("fs");
    var EventEmitter = require("events").EventEmitter;
    function download2(src, output, options, _parentEvent, redirects) {
      if (typeof redirects === "undefined") {
        redirects = 0;
      }
      let downloader = _parentEvent || new EventEmitter(), srcUrl, req;
      if (options) {
        options = parseOptions("download", options);
      } else {
        options = {
          gunzip: false
        };
      }
      srcUrl = url.parse(src);
      if (!srcUrl.protocol || srcUrl.prototype === null) {
        downloader.emit(
          "error",
          "Cannot parse url protocol for " + src + ", please specify either HTTP or HTTPS"
        );
        return false;
      }
      srcUrl.protocol = cleanProtocol(srcUrl.protocol);
      req = request(
        {
          protocol: srcUrl.protocol,
          host: srcUrl.hostname,
          port: srcUrl.port,
          path: srcUrl.pathname + (srcUrl.search || ""),
          proxy: options ? options.proxy : void 0,
          auth: options.auth ? options.auth : void 0,
          method: "GET"
        },
        function(res) {
          let fileSize, writeStream, downloadedSize;
          let gunzip = zlib.createGunzip();
          if (res.statusCode === 301 || res.statusCode === 302 || res.statusCode === 307) {
            var newLocation = res.headers.location;
            if (res.headers.location.indexOf("/") === 0) {
              newLocation = srcUrl.protocol + "://" + srcUrl.hostname + (srcUrl.port ? ":" + srcUrl.port : "") + res.headers.location;
            }
            redirects++;
            if (redirects >= 10) {
              downloader.emit("error", "Infinite redirect loop detected");
              return false;
            }
            download2(newLocation, output, options, downloader, redirects);
          }
          if (res.statusCode === 200) {
            downloadedSize = 0;
            fileSize = Number(res.headers["content-length"]);
            if (isNaN(fileSize) === true) {
              fileSize = null;
            }
            writeStream = fs2.createWriteStream(output, {
              flags: "w+",
              encoding: "binary"
            });
            res.on("error", function(err) {
              writeStream.end();
              downloader.emit("error", err);
            });
            var encoding = "";
            if (typeof res.headers["content-encoding"] === "string") {
              encoding = res.headers["content-encoding"];
            }
            if (options.gunzip === true && encoding === "gzip") {
              res.pipe(gunzip);
            } else {
              res.pipe(writeStream);
            }
            downloader.emit("start", fileSize);
            res.on("data", function(chunk) {
              downloadedSize += chunk.length;
              downloader.emit(
                "progress",
                calculateProgress(fileSize, downloadedSize)
              );
              downloader.emit("bytes", downloadedSize);
            });
            gunzip.on("data", function(chunk) {
              writeStream.write(chunk);
            });
            writeStream.on("finish", function() {
              writeStream.end();
              downloader.emit("progress", 1);
              downloader.emit("end", "Finished writing to disk");
              req.end("finished");
            });
          } else if (res.statusCode !== 200 && res.statusCode !== 301 && res.statusCode !== 302) {
            downloader.emit(
              "error",
              "Server responded with unhandled status: " + res.statusCode
            );
          }
        }
      );
      req.flushHeaders();
      req.on("error", function(err) {
        downloader.emit("error", err);
      });
      downloader.req = req;
      return downloader;
    }
    function request(options, callback) {
      var newOptions = {}, newProxy = {}, key;
      options = parseOptions("request", options);
      if (options.protocol === "http") {
        if (options.proxy) {
          for (key in options.proxy) {
            if (key !== "protocol") {
              newProxy[key] = options.proxy[key];
            }
          }
          if (options.proxy.protocol === "http") {
            options.agent = tunnel.httpOverHttp({ proxy: newProxy });
          } else if (options.proxy.protocol === "https") {
            options.agent = tunnel.httpOverHttps({ proxy: newProxy });
          } else {
            throw options.proxy.protocol + " proxy is not supported!";
          }
        }
        for (key in options) {
          if (key !== "protocol" && key !== "proxy") {
            newOptions[key] = options[key];
          }
        }
        return http2.request(newOptions, callback);
      }
      if (options.protocol === "https") {
        if (options.proxy) {
          for (key in options.proxy) {
            if (key !== "protocol") {
              newProxy[key] = options.proxy[key];
            }
          }
          if (options.proxy.protocol === "http") {
            options.agent = tunnel.httpsOverHttp({ proxy: newProxy });
          } else if (options.proxy.protocol === "https") {
            options.agent = tunnel.httpsOverHttps({ proxy: newProxy });
          } else {
            throw options.proxy.protocol + " proxy is not supported!";
          }
        }
        for (key in options) {
          if (key !== "protocol" && key !== "proxy") {
            newOptions[key] = options[key];
          }
        }
        return https.request(newOptions, callback);
      }
      throw "Your URL must use either HTTP or HTTPS.";
    }
    function parseOptions(type, options) {
      var proxy;
      if (type === "download") {
        if (options.proxy) {
          if (typeof options.proxy === "string") {
            proxy = url.parse(options.proxy);
            options.proxy = {};
            options.proxy.protocol = cleanProtocol(proxy.protocol);
            options.proxy.host = proxy.hostname;
            options.proxy.port = proxy.port;
            options.proxy.proxyAuth = proxy.auth;
            options.proxy.headers = { "User-Agent": "Node-Wget" };
          }
        }
        return options;
      }
      if (type === "request") {
        if (!options.protocol) {
          options.protocol = "http";
        }
        options.protocol = cleanProtocol(options.protocol);
        if (options.proxy) {
          if (typeof options.proxy === "string") {
            proxy = url.parse(options.proxy);
            options.proxy = {};
            options.proxy.protocol = cleanProtocol(proxy.protocol);
            options.proxy.host = proxy.hostname;
            options.proxy.port = proxy.port;
            options.proxy.proxyAuth = proxy.auth;
            options.proxy.headers = { "User-Agent": "Node-Wget" };
          }
        }
        options.gunzip = options.gunzip || false;
        return options;
      }
    }
    function cleanProtocol(str) {
      return str.trim().toLowerCase().replace(/:$/, "");
    }
    function calculateProgress(fileSize, totalDownloaded) {
      if (fileSize === null) {
        var length = String(totalDownloaded).length;
        fileSize = Math.pow(10, length) + 1;
      }
      return totalDownloaded / fileSize;
    }
    exports2.download = download2;
    exports2.request = request;
  }
});

// node_modules/wget-improved-2/index.js
var require_wget_improved_2 = __commonJS({
  "node_modules/wget-improved-2/index.js"(exports2) {
    exports2.download = require_wget().download;
    exports2.request = require_wget().request;
  }
});

// node_modules/node-opcua-pki/dist/lib/toolbox/with_openssl/install_prerequisite.js
var require_install_prerequisite = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/toolbox/with_openssl/install_prerequisite.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.get_openssl_exec_path = exports2.install_prerequisite = exports2.check_system_openssl_version = void 0;
    var fs_1 = __importDefault3(require("fs"));
    var os_1 = __importDefault3(require("os"));
    var path_1 = __importDefault3(require("path"));
    var url_1 = __importDefault3(require("url"));
    var assert_1 = __importDefault3(require("assert"));
    var byline_1 = __importDefault3(require_byline());
    var chalk_1 = __importDefault3(require_source());
    var child_process_1 = __importDefault3(require("child_process"));
    var progress_1 = __importDefault3(require_progress());
    var yauzl_1 = __importDefault3(require_yauzl());
    var Table = require_lib17();
    var debug_1 = require_debug3();
    var doDebug = process.env.NODEOPCUAPKIDEBUG || false;
    var wget = require_wget_improved_2();
    function makeOptions() {
      var _a;
      const proxy = process.env.HTTPS_PROXY || process.env.https_proxy || process.env.HTTP_PROXY || process.env.http_proxy || void 0;
      if (proxy) {
        const a = new url_1.default.URL(proxy);
        const auth = a.username ? a.username + ":" + a.password : void 0;
        const options = {
          proxy: {
            port: a.port ? parseInt(a.port, 10) : 80,
            protocol: a.protocol.replace(":", ""),
            host: (_a = a.hostname) !== null && _a !== void 0 ? _a : "",
            proxyAuth: auth
          }
        };
        (0, debug_1.warningLog)(chalk_1.default.green("- using proxy "), proxy);
        (0, debug_1.warningLog)(options);
        return options;
      }
      return {};
    }
    function execute(cmd, callback, cwd) {
      let output = "";
      const options = {
        cwd,
        windowsHide: true
      };
      const child = child_process_1.default.exec(cmd, options, (err) => {
        const exitCode = err === null ? 0 : err.code;
        callback(err ? err : null, { exitCode, output });
      });
      const stream1 = (0, byline_1.default)(child.stdout);
      stream1.on("data", (line) => {
        output += line + "\n";
        if (doDebug) {
          process.stdout.write("        stdout " + chalk_1.default.yellow(line) + "\n");
        }
      });
    }
    function quote(str) {
      return '"' + str.replace(/\\/g, "/") + '"';
    }
    function is_expected_openssl_version(strVersion) {
      return !!strVersion.match(/OpenSSL 1|3/);
    }
    function check_system_openssl_version(callback) {
      execute("which openssl", (err, result2) => {
        if (err) {
          (0, debug_1.warningLog)("warning: ", err.message);
          return callback(new Error("Cannot find openssl"));
        }
        const exitCode = result2.exitCode;
        const output = result2.output;
        if (exitCode !== 0) {
          (0, debug_1.warningLog)(chalk_1.default.yellow(" it seems that ") + chalk_1.default.cyan("openssl") + chalk_1.default.yellow(" is not installed on your computer "));
          (0, debug_1.warningLog)(chalk_1.default.yellow("Please install it before running this programs"));
          return callback(new Error("Cannot find openssl"));
        }
        const opensslExecPath = output.replace(/\n\r/g, "").trim();
        const q_opensslExecPath = quote(opensslExecPath);
        if (doDebug) {
          (0, debug_1.warningLog)("              OpenSSL found in : " + chalk_1.default.yellow(opensslExecPath));
        }
        execute(q_opensslExecPath + " version", (err2, result3) => {
          if (err2) {
            return callback(err2);
          }
          const exitCode2 = result3.exitCode;
          const output2 = result3.output;
          const version = output2.trim();
          const versionOK = exitCode2 === 0 && is_expected_openssl_version(version);
          if (!versionOK) {
            let message = chalk_1.default.whiteBright("Warning !!!!!!!!!!!! ") + "\nyour version of openssl is " + version + ". It doesn't match the expected version";
            if (process.platform === "darwin") {
              message += chalk_1.default.cyan("\nplease refer to :") + chalk_1.default.yellow(" https://github.com/node-opcua/node-opcua/wiki/installing-node-opcua-or-node-red-on-MacOS");
            }
            const table = new Table();
            table.push([message]);
            console.error(table.toString());
          }
          return callback(null, output2);
        });
      });
    }
    exports2.check_system_openssl_version = check_system_openssl_version;
    function install_and_check_win32_openssl_version(callback) {
      const downloadFolder = path_1.default.join(os_1.default.tmpdir(), ".");
      function get_openssl_folder_win32() {
        if (process.env.LOCALAPPDATA) {
          const userProgramFolder = path_1.default.join(process.env.LOCALAPPDATA, "Programs");
          if (fs_1.default.existsSync(userProgramFolder)) {
            return path_1.default.join(userProgramFolder, "openssl");
          }
        }
        return path_1.default.join(process.cwd(), "openssl");
      }
      function get_openssl_exec_path_win32() {
        const opensslFolder2 = get_openssl_folder_win32();
        return path_1.default.join(opensslFolder2, "openssl.exe");
      }
      function check_openssl_win32(callback2) {
        const opensslExecPath2 = get_openssl_exec_path_win32();
        const exists = fs_1.default.existsSync(opensslExecPath2);
        if (!exists) {
          (0, debug_1.warningLog)("checking presence of ", opensslExecPath2);
          (0, debug_1.warningLog)(chalk_1.default.red(" cannot find file ") + opensslExecPath2);
          return callback2(null, false, "cannot find file " + opensslExecPath2);
        } else {
          const q_openssl_exe_path = quote(opensslExecPath2);
          const cwd = ".";
          execute(q_openssl_exe_path + " version", (err, result2) => {
            if (err) {
              return callback2(err);
            }
            const exitCode = result2.exitCode;
            const output = result2.output;
            const version = output.trim();
            if (doDebug) {
              (0, debug_1.warningLog)(" Version = ", version);
            }
            callback2(null, exitCode === 0 && is_expected_openssl_version(version), version);
          }, cwd);
        }
      }
      function win32or64() {
        if (process.env.PROCESSOR_ARCHITECTURE === "x86" && process.env.PROCESSOR_ARCHITEW6432) {
          return 64;
        }
        if (process.env.PROCESSOR_ARCHITECTURE === "AMD64") {
          return 64;
        }
        if (process.env.CURRENT_CPU === "x64") {
          return 64;
        }
        return 32;
      }
      function download_openssl(callback2) {
        const url = win32or64() === 64 ? "https://github.com/node-opcua/node-opcua-pki/releases/download/2.14.2/openssl-1.0.2u-x64_86-win64.zip" : "https://github.com/node-opcua/node-opcua-pki/releases/download/2.14.2/openssl-1.0.2u-i386-win32.zip";
        const outputFilename = path_1.default.join(downloadFolder, path_1.default.basename(url));
        (0, debug_1.warningLog)("downloading " + chalk_1.default.yellow(url) + " to " + outputFilename);
        if (fs_1.default.existsSync(outputFilename)) {
          return callback2(null, outputFilename);
        }
        const options = makeOptions();
        const bar = new progress_1.default(chalk_1.default.cyan("[:bar]") + chalk_1.default.cyan(" :percent ") + chalk_1.default.white(":etas"), {
          complete: "=",
          incomplete: " ",
          total: 100,
          width: 100
        });
        const download2 = wget.download(url, outputFilename, options);
        download2.on("error", (err) => {
          (0, debug_1.warningLog)(err);
          setImmediate(() => {
            callback2(err);
          });
        });
        download2.on("end", (output) => {
          if (doDebug) {
            (0, debug_1.warningLog)(output);
          }
          setImmediate(() => {
            callback2(null, outputFilename);
          });
        });
        download2.on("progress", (progress) => {
          bar.update(progress);
        });
      }
      function unzip_openssl(zipFilename, callback2) {
        const opensslFolder2 = get_openssl_folder_win32();
        yauzl_1.default.open(zipFilename, { lazyEntries: true }, (err, zipFile) => {
          if (err) {
            return callback2(err);
          }
          if (!zipFile) {
            return callback2(new Error("Internal error"));
          }
          zipFile.readEntry();
          zipFile.on("end", (err2) => {
            setImmediate(() => {
              if (doDebug) {
                (0, debug_1.warningLog)("unzip done");
              }
              callback2(err2);
            });
          });
          zipFile.on("entry", (entry) => {
            zipFile.openReadStream(entry, (err2, readStream) => {
              if (err2) {
                return callback2(err2);
              }
              const file = path_1.default.join(opensslFolder2, entry.fileName);
              if (doDebug) {
                (0, debug_1.warningLog)(" unzipping :", file);
              }
              const writeStream = fs_1.default.createWriteStream(file, "binary");
              readStream.pipe(writeStream);
              writeStream.on("close", () => {
                zipFile.readEntry();
              });
            });
          });
        });
      }
      const opensslFolder = get_openssl_folder_win32();
      const opensslExecPath = get_openssl_exec_path_win32();
      if (!fs_1.default.existsSync(opensslFolder)) {
        if (doDebug) {
          (0, debug_1.warningLog)("creating openssl_folder", opensslFolder);
        }
        fs_1.default.mkdirSync(opensslFolder);
      }
      check_openssl_win32((err, opensslOK) => {
        if (err) {
          return callback(err);
        }
        if (!opensslOK) {
          (0, debug_1.warningLog)(chalk_1.default.yellow("openssl seems to be missing and need to be installed"));
          download_openssl((err2, filename) => {
            if (err2) {
              return callback(err2);
            }
            if (doDebug) {
              (0, debug_1.warningLog)("deflating ", chalk_1.default.yellow(filename));
            }
            unzip_openssl(filename, (err3) => {
              if (err3) {
                return callback(err3);
              }
              const opensslExists = !!fs_1.default.existsSync(opensslExecPath);
              if (doDebug) {
                (0, debug_1.warningLog)("verifying ", opensslExists, opensslExists ? chalk_1.default.green("OK ") : chalk_1.default.red(" Error"), opensslExecPath);
                (0, debug_1.warningLog)("done ", err3 ? err3 : "");
              }
              check_openssl_win32((err4) => {
                callback(err4, opensslExecPath);
              });
            });
          });
        } else {
          if (doDebug) {
            (0, debug_1.warningLog)(chalk_1.default.green("openssl is already installed and have the expected version."));
          }
          return callback(null, opensslExecPath);
        }
      });
    }
    function install_prerequisite(callback) {
      if (process.platform !== "win32") {
        return check_system_openssl_version(callback);
      } else {
        return install_and_check_win32_openssl_version(callback);
      }
    }
    exports2.install_prerequisite = install_prerequisite;
    function get_openssl_exec_path(callback) {
      (0, assert_1.default)(typeof callback === "function");
      if (process.platform === "win32") {
        install_prerequisite((err, opensslExecPath) => {
          if (err) {
            return callback(err);
          }
          if (!fs_1.default.existsSync(opensslExecPath)) {
            throw new Error("internal error cannot find " + opensslExecPath);
          }
          callback(err, opensslExecPath);
        });
      } else {
        setImmediate(() => {
          callback(null, "openssl");
        });
      }
    }
    exports2.get_openssl_exec_path = get_openssl_exec_path;
  }
});

// node_modules/node-opcua-pki/dist/lib/toolbox/with_openssl/_env.js
var require_env = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/toolbox/with_openssl/_env.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.processAltNames = exports2.getEnvironmentVarNames = exports2.getEnv = exports2.hasEnv = exports2.setEnv = exports2.exportedEnvVars = void 0;
    var config_1 = require_config();
    var debug_1 = require_debug3();
    exports2.exportedEnvVars = {};
    function setEnv(varName, value) {
      if (!config_1.g_config.silent) {
        (0, debug_1.warningLog)("          set " + varName + "=" + value);
      }
      exports2.exportedEnvVars[varName] = value;
      if (["OPENSSL_CONF"].indexOf(varName) >= 0) {
        process.env[varName] = value;
      }
      if (["RANDFILE"].indexOf(varName) >= 0) {
        process.env[varName] = value;
      }
    }
    exports2.setEnv = setEnv;
    function hasEnv(varName) {
      return Object.prototype.hasOwnProperty.call(exports2.exportedEnvVars, varName);
    }
    exports2.hasEnv = hasEnv;
    function getEnv(varName) {
      return exports2.exportedEnvVars[varName];
    }
    exports2.getEnv = getEnv;
    function getEnvironmentVarNames() {
      return Object.keys(exports2.exportedEnvVars).map((varName) => {
        return { key: varName, pattern: "\\$ENV\\:\\:" + varName };
      });
    }
    exports2.getEnvironmentVarNames = getEnvironmentVarNames;
    function processAltNames(params) {
      params.dns = params.dns || [];
      params.ip = params.ip || [];
      let subjectAltName = [];
      subjectAltName.push("URI:" + params.applicationUri);
      subjectAltName = [].concat(subjectAltName, params.dns.map((d2) => "DNS:" + d2));
      subjectAltName = [].concat(subjectAltName, params.ip.map((d2) => "IP:" + d2));
      const subjectAltNameString = subjectAltName.join(", ");
      setEnv("ALTNAME", subjectAltNameString);
    }
    exports2.processAltNames = processAltNames;
  }
});

// node_modules/node-opcua-pki/dist/lib/toolbox/with_openssl/execute_openssl.js
var require_execute_openssl = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/toolbox/with_openssl/execute_openssl.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.execute_openssl = exports2.execute_openssl_no_failure = exports2.executeOpensslAsync = exports2.ensure_openssl_installed = exports2.find_openssl = exports2.execute = void 0;
    var assert_1 = __importDefault3(require("assert"));
    var byline_1 = __importDefault3(require_byline());
    var chalk_1 = __importDefault3(require_source());
    var child_process_1 = __importDefault3(require("child_process"));
    var fs_1 = __importDefault3(require("fs"));
    var os_1 = __importDefault3(require("os"));
    var install_prerequisite_1 = require_install_prerequisite();
    var common_1 = require_common3();
    var config_1 = require_config();
    var debug_1 = require_debug3();
    var _env_1 = require_env();
    var common2_1 = require_common22();
    var opensslPath;
    var n = common2_1.make_path;
    function execute(cmd, options, callback) {
      (0, assert_1.default)(typeof callback === "function");
      const from = new Error();
      options.cwd = options.cwd || process.cwd();
      if (!config_1.g_config.silent) {
        (0, debug_1.warningLog)(chalk_1.default.cyan("                  CWD         "), options.cwd);
      }
      const outputs = [];
      const child = child_process_1.default.exec(cmd, {
        cwd: options.cwd,
        windowsHide: true
      }, (err) => {
        if (err) {
          if (!options.hideErrorMessage) {
            const fence = "###########################################";
            console.error(chalk_1.default.bgWhiteBright.redBright(`${fence} OPENSSL ERROR ${fence}`));
            console.error(chalk_1.default.bgWhiteBright.redBright("CWD = " + options.cwd));
            console.error(chalk_1.default.bgWhiteBright.redBright(err.message));
            console.error(chalk_1.default.bgWhiteBright.redBright(`${fence} OPENSSL ERROR ${fence}`));
            console.error(from.stack);
          }
          callback(new Error(err.message));
          return;
        }
        callback(null, outputs.join(""));
      });
      if (child.stdout) {
        const stream2 = (0, byline_1.default)(child.stdout);
        stream2.on("data", (line) => {
          outputs.push(line + "\n");
        });
        if (!config_1.g_config.silent) {
          stream2.on("data", (line) => {
            line = line.toString();
            if (debug_1.doDebug) {
              process.stdout.write(chalk_1.default.white("        stdout ") + chalk_1.default.whiteBright(line) + "\n");
            }
          });
        }
      }
      if (!config_1.g_config.silent) {
        if (child.stderr) {
          const stream1 = (0, byline_1.default)(child.stderr);
          stream1.on("data", (line) => {
            line = line.toString();
            if (debug_1.displayError) {
              process.stdout.write(chalk_1.default.white("        stderr ") + chalk_1.default.red(line) + "\n");
            }
          });
        }
      }
    }
    exports2.execute = execute;
    function find_openssl(callback) {
      (0, install_prerequisite_1.get_openssl_exec_path)((err, _opensslPath) => {
        opensslPath = _opensslPath;
        callback(err, opensslPath);
      });
    }
    exports2.find_openssl = find_openssl;
    function ensure_openssl_installed(callback) {
      (0, assert_1.default)(typeof callback === "function");
      if (!opensslPath) {
        return find_openssl((err) => {
          if (err) {
            return callback(err);
          }
          execute_openssl("version", { cwd: "." }, (err2, outputs) => {
            if (err2 || !outputs) {
              return callback(err2 || new Error("no outputs"));
            }
            config_1.g_config.opensslVersion = outputs.trim();
            if (debug_1.doDebug) {
              (0, debug_1.warningLog)("OpenSSL version : ", config_1.g_config.opensslVersion);
            }
            callback(err2 ? err2 : void 0);
          });
        });
      } else {
        return callback();
      }
    }
    exports2.ensure_openssl_installed = ensure_openssl_installed;
    function executeOpensslAsync(cmd, options) {
      return new Promise((resolve2, reject) => {
        execute_openssl(cmd, options, (err, output) => {
          if (err) {
            reject(err);
          } else {
            resolve2(output || "");
          }
        });
      });
    }
    exports2.executeOpensslAsync = executeOpensslAsync;
    function execute_openssl_no_failure(cmd, options, callback) {
      options = options || {};
      options.hideErrorMessage = true;
      execute_openssl(cmd, options, (err, output) => {
        if (err) {
          (0, debug_1.debugLog)(" (ignored error =  ERROR : )", err.message);
        }
        callback(null, output);
      });
    }
    exports2.execute_openssl_no_failure = execute_openssl_no_failure;
    function getTempFolder() {
      return os_1.default.tmpdir();
    }
    function execute_openssl(cmd, options, callback) {
      const empty_config_file = n(getTempFolder(), "empty_config.cnf");
      if (!fs_1.default.existsSync(empty_config_file)) {
        fs_1.default.writeFileSync(empty_config_file, "# empty config file");
      }
      (0, assert_1.default)(typeof callback === "function");
      options = options || {};
      options.openssl_conf = options.openssl_conf || empty_config_file;
      (0, assert_1.default)(options.openssl_conf);
      (0, _env_1.setEnv)("OPENSSL_CONF", options.openssl_conf);
      if (!config_1.g_config.silent) {
        (0, debug_1.warningLog)(chalk_1.default.cyan("                  OPENSSL_CONF"), process.env.OPENSSL_CONF);
        (0, debug_1.warningLog)(chalk_1.default.cyan("                  RANDFILE    "), process.env.RANDFILE);
        (0, debug_1.warningLog)(chalk_1.default.cyan("                  CMD         openssl "), chalk_1.default.cyanBright(cmd));
      }
      ensure_openssl_installed((err) => {
        if (err) {
          return callback(err);
        }
        execute((0, common_1.quote)(opensslPath) + " " + cmd, options, callback);
      });
    }
    exports2.execute_openssl = execute_openssl;
  }
});

// node_modules/node-opcua-pki/dist/lib/toolbox/with_openssl/toolbox.js
var require_toolbox2 = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/toolbox/with_openssl/toolbox.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.fingerprint = exports2.toDer = exports2.dumpCertificate = exports2.x509Date = exports2.getPublicKeyFromCertificate = exports2.getPublicKeyFromPrivateKey = exports2.generateStaticConfig = void 0;
    var assert_1 = __importDefault3(require("assert"));
    var fs_1 = __importDefault3(require("fs"));
    var path_1 = __importDefault3(require("path"));
    var common_1 = require_common3();
    var common2_1 = require_common22();
    var config_1 = require_config();
    var execute_openssl_1 = require_execute_openssl();
    var _env_1 = require_env();
    function openssl_require2DigitYearInDate() {
      if (!config_1.g_config.opensslVersion) {
        throw new Error("openssl_require2DigitYearInDate : openssl version is not known:  please call ensure_openssl_installed(callback)");
      }
      return config_1.g_config.opensslVersion.match(/OpenSSL 0\.9/);
    }
    config_1.g_config.opensslVersion = "";
    function generateStaticConfig(configPath, options) {
      const prePath = options && options.cwd || "";
      const staticConfigPath = configPath + ".tmp";
      let staticConfig = fs_1.default.readFileSync(path_1.default.join(prePath, configPath), { encoding: "utf8" });
      for (const envVar of (0, _env_1.getEnvironmentVarNames)()) {
        staticConfig = staticConfig.replace(new RegExp(envVar.pattern, "gi"), (0, _env_1.getEnv)(envVar.key));
      }
      fs_1.default.writeFileSync(path_1.default.join(prePath, staticConfigPath), staticConfig);
      return staticConfigPath;
    }
    exports2.generateStaticConfig = generateStaticConfig;
    var q2 = common_1.quote;
    var n = common2_1.make_path;
    function getPublicKeyFromPrivateKey(privateKeyFilename, publicKeyFilename, callback) {
      (0, assert_1.default)(fs_1.default.existsSync(privateKeyFilename));
      (0, execute_openssl_1.execute_openssl)("rsa -pubout -in " + q2(n(privateKeyFilename)) + " -out " + q2(n(publicKeyFilename)), {}, callback);
    }
    exports2.getPublicKeyFromPrivateKey = getPublicKeyFromPrivateKey;
    function getPublicKeyFromCertificate(certificateFilename, publicKeyFilename, callback) {
      (0, assert_1.default)(fs_1.default.existsSync(certificateFilename));
      (0, execute_openssl_1.execute_openssl)("x509 -pubkey -in " + q2(n(certificateFilename)) + " > " + q2(n(publicKeyFilename)), {}, callback);
    }
    exports2.getPublicKeyFromCertificate = getPublicKeyFromCertificate;
    function x509Date(date) {
      date = date || /* @__PURE__ */ new Date();
      const Y = date.getUTCFullYear();
      const M = date.getUTCMonth() + 1;
      const D = date.getUTCDate();
      const h = date.getUTCHours();
      const m2 = date.getUTCMinutes();
      const s = date.getUTCSeconds();
      function w(s2, l2) {
        return ("" + s2).padStart(l2, "0");
      }
      if (openssl_require2DigitYearInDate()) {
        return w(Y, 2) + w(M, 2) + w(D, 2) + w(h, 2) + w(m2, 2) + w(s, 2) + "Z";
      } else {
        return w(Y, 4) + w(M, 2) + w(D, 2) + w(h, 2) + w(m2, 2) + w(s, 2) + "Z";
      }
    }
    exports2.x509Date = x509Date;
    function dumpCertificate(certificate, callback) {
      (0, assert_1.default)(fs_1.default.existsSync(certificate));
      (0, assert_1.default)(typeof callback === "function");
      (0, execute_openssl_1.execute_openssl)("x509  -in " + q2(n(certificate)) + " -text  -noout", {}, callback);
    }
    exports2.dumpCertificate = dumpCertificate;
    function toDer(certificatePem, callback) {
      (0, assert_1.default)(fs_1.default.existsSync(certificatePem));
      const certificateDer = certificatePem.replace(".pem", ".der");
      (0, execute_openssl_1.execute_openssl)("x509   -outform der  -in " + certificatePem + " -out " + certificateDer, {}, callback);
    }
    exports2.toDer = toDer;
    function fingerprint(certificatePem, callback) {
      (0, assert_1.default)(fs_1.default.existsSync(certificatePem));
      (0, execute_openssl_1.execute_openssl)("x509   -fingerprint  -noout  -in " + certificatePem, {}, callback);
    }
    exports2.fingerprint = fingerprint;
  }
});

// node_modules/node-opcua-pki/dist/lib/misc/subject.js
var require_subject = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/misc/subject.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Subject = void 0;
    var node_opcua_crypto_1 = require_dist33();
    Object.defineProperty(exports2, "Subject", { enumerable: true, get: function() {
      return node_opcua_crypto_1.Subject;
    } });
  }
});

// node_modules/node-opcua-pki/dist/lib/toolbox/with_openssl/create_certificate_signing_request.js
var require_create_certificate_signing_request = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/toolbox/with_openssl/create_certificate_signing_request.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.createCertificateSigningRequestAsync = exports2.createCertificateSigningRequest = void 0;
    var assert_1 = __importDefault3(require("assert"));
    var async_1 = __importDefault3(require_async());
    var fs_1 = __importDefault3(require("fs"));
    var subject_1 = require_subject();
    var common_1 = require_common3();
    var common2_1 = require_common22();
    var display_1 = require_display();
    var execute_openssl_1 = require_execute_openssl();
    var _env_1 = require_env();
    var toolbox_1 = require_toolbox2();
    var util_1 = require("util");
    var q2 = common_1.quote;
    var n = common2_1.make_path;
    function createCertificateSigningRequest(certificateSigningRequestFilename, params, callback) {
      (0, assert_1.default)(params);
      (0, assert_1.default)(params.rootDir);
      (0, assert_1.default)(params.configFile);
      (0, assert_1.default)(params.privateKey);
      (0, assert_1.default)(typeof params.privateKey === "string");
      (0, assert_1.default)(fs_1.default.existsSync(params.configFile), "config file must exist " + params.configFile);
      (0, assert_1.default)(fs_1.default.existsSync(params.privateKey), "Private key must exist" + params.privateKey);
      (0, assert_1.default)(fs_1.default.existsSync(params.rootDir), "RootDir key must exist");
      (0, assert_1.default)(typeof certificateSigningRequestFilename === "string");
      (0, _env_1.processAltNames)(params);
      const configFile = (0, toolbox_1.generateStaticConfig)(params.configFile);
      const options = { cwd: params.rootDir, openssl_conf: configFile };
      const configOption = " -config " + q2(n(configFile));
      const subject = params.subject ? new subject_1.Subject(params.subject).toString() : void 0;
      const subjectOptions = subject ? ' -subj "' + subject + '"' : "";
      async_1.default.series([
        (callback2) => {
          (0, display_1.displaySubtitle)("- Creating a Certificate Signing Request with openssl", callback2);
        },
        (callback2) => {
          (0, execute_openssl_1.execute_openssl)("req -new  -sha256  -batch  -text " + configOption + " -key " + q2(n(params.privateKey)) + subjectOptions + " -out " + q2(n(certificateSigningRequestFilename)), options, (err) => {
            callback2(err ? err : void 0);
          });
        }
      ], (err) => callback(err));
    }
    exports2.createCertificateSigningRequest = createCertificateSigningRequest;
    exports2.createCertificateSigningRequestAsync = (0, util_1.promisify)(createCertificateSigningRequest);
  }
});

// node_modules/node-opcua-pki/dist/lib/toolbox/with_openssl/index.js
var require_with_openssl = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/toolbox/with_openssl/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_install_prerequisite(), exports2);
    __exportStar3(require_toolbox2(), exports2);
    __exportStar3(require_env(), exports2);
    __exportStar3(require_execute_openssl(), exports2);
    __exportStar3(require_create_certificate_signing_request(), exports2);
  }
});

// node_modules/node-opcua-pki/dist/lib/toolbox/without_openssl/create_self_signed_certificate.js
var require_create_self_signed_certificate = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/toolbox/without_openssl/create_self_signed_certificate.js"(exports2) {
    "use strict";
    var __awaiter3 = exports2 && exports2.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve2) {
          resolve2(value);
        });
      }
      return new (P || (P = Promise))(function(resolve2, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result2) {
          result2.done ? resolve2(result2.value) : adopt(result2.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.createSelfSignedCertificate = exports2.createSelfSignedCertificateAsync = void 0;
    var assert = require("assert");
    var fs2 = require("fs");
    var node_opcua_crypto_1 = require_dist33();
    var common_1 = require_common3();
    var subject_1 = require_subject();
    var display_1 = require_display();
    function createSelfSignedCertificateAsync(certificate, params) {
      return __awaiter3(this, void 0, void 0, function* () {
        params.purpose = params.purpose || node_opcua_crypto_1.CertificatePurpose.ForApplication;
        assert(params.purpose, "Please provide a Certificate Purpose");
        assert(fs2.existsSync(params.configFile));
        assert(fs2.existsSync(params.rootDir));
        assert(fs2.existsSync(params.privateKey));
        if (!params.subject) {
          throw Error("Missing subject");
        }
        assert(typeof params.applicationUri === "string");
        assert(params.dns instanceof Array);
        (0, common_1.adjustDate)(params);
        assert(Object.prototype.hasOwnProperty.call(params, "validity"));
        let subject = new subject_1.Subject(params.subject);
        subject = subject.toString();
        const purpose = params.purpose;
        (0, display_1.displayTitle)("Generate a certificate request");
        const privateKeyPem = yield fs2.promises.readFile(params.privateKey, "utf-8");
        const privateKey = yield (0, node_opcua_crypto_1.pemToPrivateKey)(privateKeyPem);
        const { cert } = yield (0, node_opcua_crypto_1.createSelfSignedCertificate)({
          privateKey,
          notBefore: params.startDate,
          notAfter: params.endDate,
          validity: params.validity,
          dns: params.dns,
          ip: params.ip,
          subject,
          applicationUri: params.applicationUri,
          purpose
        });
        yield fs2.promises.writeFile(certificate, cert, "utf-8");
      });
    }
    exports2.createSelfSignedCertificateAsync = createSelfSignedCertificateAsync;
    function createSelfSignedCertificate(certificate, params, callback) {
      createSelfSignedCertificateAsync(certificate, params).then(() => callback()).catch((err) => callback(err));
    }
    exports2.createSelfSignedCertificate = createSelfSignedCertificate;
  }
});

// node_modules/node-opcua-pki/dist/lib/toolbox/without_openssl/create_certificate_signing_request.js
var require_create_certificate_signing_request2 = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/toolbox/without_openssl/create_certificate_signing_request.js"(exports2) {
    "use strict";
    var __awaiter3 = exports2 && exports2.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve2) {
          resolve2(value);
        });
      }
      return new (P || (P = Promise))(function(resolve2, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result2) {
          result2.done ? resolve2(result2.value) : adopt(result2.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.createCertificateSigningRequest = exports2.createCertificateSigningRequestAsync = void 0;
    var assert_1 = __importDefault3(require("assert"));
    var fs_1 = __importDefault3(require("fs"));
    var node_opcua_crypto_1 = require_dist33();
    var display_1 = require_display();
    var node_opcua_crypto_2 = require_dist33();
    function createCertificateSigningRequestAsync(certificateSigningRequestFilename, params) {
      return __awaiter3(this, void 0, void 0, function* () {
        (0, assert_1.default)(params);
        (0, assert_1.default)(params.rootDir);
        (0, assert_1.default)(params.configFile);
        (0, assert_1.default)(params.privateKey);
        (0, assert_1.default)(typeof params.privateKey === "string");
        (0, assert_1.default)(fs_1.default.existsSync(params.privateKey), "Private key must exist" + params.privateKey);
        (0, assert_1.default)(fs_1.default.existsSync(params.rootDir), "RootDir key must exist");
        (0, assert_1.default)(typeof certificateSigningRequestFilename === "string");
        const subject = params.subject ? new node_opcua_crypto_1.Subject(params.subject).toString() : void 0;
        (0, display_1.displaySubtitle)("- Creating a Certificate Signing Request with subtile");
        const privateKeyPem = yield fs_1.default.promises.readFile(params.privateKey, "utf-8");
        const privateKey = yield (0, node_opcua_crypto_1.pemToPrivateKey)(privateKeyPem);
        const { csr } = yield (0, node_opcua_crypto_2.createCertificateSigningRequest)({
          privateKey,
          dns: params.dns,
          ip: params.ip,
          subject,
          applicationUri: params.applicationUri,
          purpose: params.purpose
        });
        yield fs_1.default.promises.writeFile(certificateSigningRequestFilename, csr, "utf-8");
        (0, display_1.display)("- privateKey " + params.privateKey);
        (0, display_1.display)("- certificateSigningRequestFilename " + certificateSigningRequestFilename);
      });
    }
    exports2.createCertificateSigningRequestAsync = createCertificateSigningRequestAsync;
    function createCertificateSigningRequest(certificateSigningRequestFilename, params, callback) {
      createCertificateSigningRequestAsync(certificateSigningRequestFilename, params).then(() => callback()).catch((err) => callback(err));
    }
    exports2.createCertificateSigningRequest = createCertificateSigningRequest;
  }
});

// node_modules/node-opcua-pki/dist/lib/toolbox/without_openssl/index.js
var require_without_openssl = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/toolbox/without_openssl/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_create_private_key(), exports2);
    __exportStar3(require_create_self_signed_certificate(), exports2);
    __exportStar3(require_create_certificate_signing_request2(), exports2);
  }
});

// node_modules/node-opcua-pki/dist/lib/pki/templates/simple_config_template.cnf.js
var require_simple_config_template_cnf = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/pki/templates/simple_config_template.cnf.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var config = '##################################################################################################\n## SIMPLE OPENSSL CONFIG FILE FOR SELF-SIGNED CERTIFICATE GENERATION\n################################################################################################################\n\ndistinguished_name       = req_distinguished_name\ndefault_md               = sha1\n\ndefault_md                = sha256                      # The default digest algorithm\n\n[ v3_ca ]\nsubjectKeyIdentifier        = hash\nauthorityKeyIdentifier      = keyid:always,issuer:always\n\n# authorityKeyIdentifier    = keyid\nbasicConstraints            = CA:TRUE\nkeyUsage                    = critical, cRLSign, keyCertSign\nnsComment                   = "Self-signed Certificate for CA generated by Node-OPCUA Certificate utility"\n#nsCertType                 = sslCA, emailCA\n#subjectAltName             = email:copy\n#issuerAltName              = issuer:copy\n#obj                        = DER:02:03\n# crlDistributionPoints       = @crl_info\n# [ crl_info ]\n# URI.0                     = http://localhost:8900/crl.pem\nsubjectAltName              = $ENV::ALTNAME\n\n[ req ]\ndays                      = 390\nreq_extensions            = v3_req\nx509_extensions           = v3_ca\n\n[v3_req]\nbasicConstraints       = CA:false\nkeyUsage               = critical, cRLSign, keyCertSign\nsubjectAltName         = $ENV::ALTNAME\n\n[ v3_ca_signed]\nsubjectKeyIdentifier      = hash\nauthorityKeyIdentifier    = keyid,issuer\nbasicConstraints          = critical, CA:FALSE\nkeyUsage                  = nonRepudiation, digitalSignature, keyEncipherment, dataEncipherment, keyCertSign\nextendedKeyUsage          = clientAuth,serverAuth \nnsComment                 = "certificate generated by Node-OPCUA Certificate utility and signed by a CA"\nsubjectAltName            = $ENV::ALTNAME\n[ v3_selfsigned]\nsubjectKeyIdentifier      = hash\nauthorityKeyIdentifier    = keyid,issuer\nbasicConstraints          = critical, CA:FALSE\nkeyUsage                  = nonRepudiation, digitalSignature, keyEncipherment, dataEncipherment, keyCertSign\nextendedKeyUsage          = clientAuth,serverAuth \nnsComment                 = "Self-signed certificate generated by Node-OPCUA Certificate utility"\nsubjectAltName            = $ENV::ALTNAME\n[ req_distinguished_name ]\ncountryName             = Country Name (2 letter code)\ncountryName_default     = FR\ncountryName_min         = 2\ncountryName_max         = 2\n# stateOrProvinceName     = State or Province Name (full name)\n# stateOrProvinceName_default = Ile de France\n# localityName            = Locality Name (city, district)\n# localityName_default    = Paris\norganizationName          = Organization Name (company)\norganizationName_default  = NodeOPCUA\n# organizationalUnitName  = Organizational Unit Name (department, division)\n# organizationalUnitName_default = R&D\ncommonName                = Common Name (hostname, FQDN, IP, or your name)\ncommonName_max            = 256\ncommonName_default        = NodeOPCUA\n# emailAddress            = Email Address\n# emailAddress_max        = 40\n# emailAddress_default    = node-opcua (at) node-opcua (dot) com\nsubjectAltName            = $ENV::ALTNAME';
    exports2.default = config;
  }
});

// node_modules/node-opcua-pki/dist/lib/pki/certificate_manager.js
var require_certificate_manager = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/pki/certificate_manager.js"(exports2) {
    "use strict";
    var __awaiter3 = exports2 && exports2.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve2) {
          resolve2(value);
        });
      }
      return new (P || (P = Promise))(function(resolve2, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result2) {
          result2.done ? resolve2(result2.value) : adopt(result2.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.CertificateManager = exports2.CertificateManagerState = exports2.findIssuerCertificateInChain = exports2.VerificationStatus = void 0;
    var assert_1 = __importDefault3(require("assert"));
    var async_1 = __importDefault3(require_async());
    var chalk_1 = __importDefault3(require_source());
    var chokidar_1 = __importDefault3(require_chokidar());
    var fs_1 = __importDefault3(require("fs"));
    var path_1 = __importDefault3(require("path"));
    var util_1 = require("util");
    var global_mutex_1 = require_source8();
    var node_opcua_crypto_1 = require_dist33();
    var debug_1 = require_debug3();
    var common2_1 = require_common22();
    var with_openssl_1 = require_with_openssl();
    var without_openssl_1 = require_without_openssl();
    var simple_config_template_cnf_1 = __importDefault3(require_simple_config_template_cnf());
    var configurationFileSimpleTemplate = simple_config_template_cnf_1.default;
    var thenify = require_thenify();
    var fsWriteFile = fs_1.default.promises.writeFile;
    var VerificationStatus;
    (function(VerificationStatus2) {
      VerificationStatus2["BadCertificateInvalid"] = "BadCertificateInvalid";
      VerificationStatus2["BadSecurityChecksFailed"] = "BadSecurityChecksFailed";
      VerificationStatus2["BadCertificatePolicyCheckFailed"] = "BadCertificatePolicyCheckFailed";
      VerificationStatus2["BadCertificateTimeInvalid"] = "BadCertificateTimeInvalid";
      VerificationStatus2["BadCertificateIssuerTimeInvalid"] = "BadCertificateIssuerTimeInvalid";
      VerificationStatus2["BadCertificateHostNameInvalid"] = "BadCertificateHostNameInvalid";
      VerificationStatus2["BadCertificateUriInvalid"] = "BadCertificateUriInvalid";
      VerificationStatus2["BadCertificateUseNotAllowed"] = "BadCertificateUseNotAllowed";
      VerificationStatus2["BadCertificateIssuerUseNotAllowed"] = "BadCertificateIssuerUseNotAllowed";
      VerificationStatus2["BadCertificateUntrusted"] = "BadCertificateUntrusted";
      VerificationStatus2["BadCertificateRevocationUnknown"] = "BadCertificateRevocationUnknown";
      VerificationStatus2["BadCertificateIssuerRevocationUnknown"] = "BadCertificateIssuerRevocationUnknown";
      VerificationStatus2["BadCertificateRevoked"] = "BadCertificateRevoked";
      VerificationStatus2["BadCertificateIssuerRevoked"] = "BadCertificateIssuerRevoked";
      VerificationStatus2["BadCertificateChainIncomplete"] = "BadCertificateChainIncomplete";
      VerificationStatus2["Good"] = "Good";
    })(VerificationStatus || (exports2.VerificationStatus = VerificationStatus = {}));
    function makeFingerprint(certificate) {
      return (0, node_opcua_crypto_1.makeSHA1Thumbprint)(certificate).toString("hex");
    }
    function short(stringToShorten) {
      return stringToShorten.substr(0, 10);
    }
    function buildIdealCertificateName(certificate) {
      const fingerprint = makeFingerprint(certificate);
      try {
        const commonName = (0, node_opcua_crypto_1.exploreCertificate)(certificate).tbsCertificate.subject.commonName || "";
        return commonName + "[" + fingerprint + "]";
      } catch (err) {
        return "invalid_certificate_[" + fingerprint + "]";
      }
    }
    function findMatchingIssuerKey(entries, wantedIssuerKey) {
      const selected = entries.filter(({ certificate }) => {
        const info = (0, node_opcua_crypto_1.exploreCertificate)(certificate);
        return info.tbsCertificate.extensions && info.tbsCertificate.extensions.subjectKeyIdentifier === wantedIssuerKey;
      });
      return selected;
    }
    function isSelfSigned2(info) {
      var _a, _b, _c;
      return ((_a = info.tbsCertificate.extensions) === null || _a === void 0 ? void 0 : _a.subjectKeyIdentifier) === ((_c = (_b = info.tbsCertificate.extensions) === null || _b === void 0 ? void 0 : _b.authorityKeyIdentifier) === null || _c === void 0 ? void 0 : _c.keyIdentifier);
    }
    function isSelfSigned3(certificate) {
      const info = (0, node_opcua_crypto_1.exploreCertificate)(certificate);
      return isSelfSigned2(info);
    }
    function findIssuerCertificateInChain(certificate, chain) {
      var _a, _b;
      if (!certificate) {
        return null;
      }
      const certInfo = (0, node_opcua_crypto_1.exploreCertificate)(certificate);
      if (isSelfSigned2(certInfo)) {
        return certificate;
      }
      const wantedIssuerKey = (_b = (_a = certInfo.tbsCertificate.extensions) === null || _a === void 0 ? void 0 : _a.authorityKeyIdentifier) === null || _b === void 0 ? void 0 : _b.keyIdentifier;
      if (!wantedIssuerKey) {
        (0, debug_1.debugLog)("Certificate has no extension 3");
        return null;
      }
      const potentialIssuers = chain.filter((c2) => {
        const info = (0, node_opcua_crypto_1.exploreCertificate)(c2);
        return info.tbsCertificate.extensions && info.tbsCertificate.extensions.subjectKeyIdentifier === wantedIssuerKey;
        return true;
      });
      if (potentialIssuers.length === 1) {
        return potentialIssuers[0];
      }
      if (potentialIssuers.length > 1) {
        (0, debug_1.debugLog)("findIssuerCertificateInChain: certificate is not self-signed but has several issuers");
        return potentialIssuers[0];
      }
      return null;
    }
    exports2.findIssuerCertificateInChain = findIssuerCertificateInChain;
    var CertificateManagerState;
    (function(CertificateManagerState2) {
      CertificateManagerState2[CertificateManagerState2["Uninitialized"] = 0] = "Uninitialized";
      CertificateManagerState2[CertificateManagerState2["Initializing"] = 1] = "Initializing";
      CertificateManagerState2[CertificateManagerState2["Initialized"] = 2] = "Initialized";
      CertificateManagerState2[CertificateManagerState2["Disposing"] = 3] = "Disposing";
      CertificateManagerState2[CertificateManagerState2["Disposed"] = 4] = "Disposed";
    })(CertificateManagerState || (exports2.CertificateManagerState = CertificateManagerState = {}));
    var CertificateManager = class {
      constructor(options) {
        this.untrustUnknownCertificate = true;
        this.state = CertificateManagerState.Uninitialized;
        this.folderPoolingInterval = 5e3;
        this._watchers = [];
        this._readCertificatesCalled = false;
        this._filenameToHash = {};
        this._thumbs = {
          rejected: {},
          trusted: {},
          issuers: {
            certs: {}
          },
          crl: {},
          issuersCrl: {}
        };
        this._pending_crl_to_process = 0;
        this.queue = [];
        options.keySize = options.keySize || 2048;
        (0, assert_1.default)(Object.prototype.hasOwnProperty.call(options, "location"));
        (0, assert_1.default)(Object.prototype.hasOwnProperty.call(options, "keySize"));
        (0, assert_1.default)(this.state === CertificateManagerState.Uninitialized);
        this.location = (0, common2_1.make_path)(options.location, "");
        this.keySize = options.keySize;
        (0, common2_1.mkdir)(options.location);
        if (!fs_1.default.existsSync(this.location)) {
          throw new Error("CertificateManager cannot access location " + this.location);
        }
      }
      get configFile() {
        return path_1.default.join(this.rootDir, "own/openssl.cnf");
      }
      get rootDir() {
        return this.location;
      }
      get privateKey() {
        return path_1.default.join(this.rootDir, "own/private/private_key.pem");
      }
      get randomFile() {
        return path_1.default.join(this.rootDir, "./random.rnd");
      }
      getCertificateStatus(certificate, ...args) {
        const callback = args[0];
        this.initialize(() => {
          this._checkRejectedOrTrusted(certificate, (err, status2) => {
            if (err) {
              return callback(err);
            }
            if (status2 === "unknown") {
              (0, assert_1.default)(certificate instanceof Buffer);
              const pem = (0, node_opcua_crypto_1.toPem)(certificate, "CERTIFICATE");
              const fingerprint = makeFingerprint(certificate);
              const filename = path_1.default.join(this.rejectedFolder, buildIdealCertificateName(certificate) + ".pem");
              fs_1.default.writeFile(filename, pem, (err2) => {
                this._thumbs.rejected[fingerprint] = {
                  certificate,
                  filename
                };
                if (err2) {
                  return callback(err2);
                }
                status2 = "rejected";
                return callback(null, status2);
              });
              return;
            } else {
              return callback(null, status2);
            }
          });
        });
      }
      rejectCertificate(certificate, ...args) {
        const callback = args[0];
        (0, assert_1.default)(callback && callback instanceof Function, "expecting callback");
        this._moveCertificate(certificate, "rejected", callback);
      }
      trustCertificate(certificate, ...args) {
        const callback = args[0];
        (0, assert_1.default)(callback && callback instanceof Function, "expecting callback");
        this._moveCertificate(certificate, "trusted", callback);
      }
      get rejectedFolder() {
        return path_1.default.join(this.rootDir, "rejected");
      }
      get trustedFolder() {
        return path_1.default.join(this.rootDir, "trusted/certs");
      }
      get crlFolder() {
        return path_1.default.join(this.rootDir, "trusted/crl");
      }
      get issuersCertFolder() {
        return path_1.default.join(this.rootDir, "issuers/certs");
      }
      get issuersCrlFolder() {
        return path_1.default.join(this.rootDir, "issuers/crl");
      }
      isCertificateTrusted(certificate) {
        var _a;
        return __awaiter3(this, void 0, void 0, function* () {
          const fingerprint = makeFingerprint(certificate);
          const certificateInTrust = (_a = this._thumbs.trusted[fingerprint]) === null || _a === void 0 ? void 0 : _a.certificate;
          if (certificateInTrust) {
            return "Good";
          } else {
            const certificateInRejected = this._thumbs.rejected[fingerprint];
            if (!certificateInRejected) {
              const certificateFilenameInRejected = path_1.default.join(this.rejectedFolder, buildIdealCertificateName(certificate) + ".pem");
              if (!this.untrustUnknownCertificate) {
                return "Good";
              }
              try {
                const certificateInfo = (0, node_opcua_crypto_1.exploreCertificateInfo)(certificate);
                certificateInfo;
              } catch (err) {
                return "BadCertificateInvalid";
              }
              (0, debug_1.debugLog)("certificate has never been seen before and is now rejected (untrusted) ", certificateFilenameInRejected);
              yield fsWriteFile(certificateFilenameInRejected, (0, node_opcua_crypto_1.toPem)(certificate, "CERTIFICATE"));
            }
            return "BadCertificateUntrusted";
          }
        });
      }
      _innerVerifyCertificateAsync(certificate, isIssuer, level, options) {
        var _a, _b, _c, _d, _e;
        return __awaiter3(this, void 0, void 0, function* () {
          if (level >= 5) {
            return VerificationStatus.BadSecurityChecksFailed;
          }
          const chain = (0, node_opcua_crypto_1.split_der)(certificate);
          (0, debug_1.debugLog)("NB CERTIFICATE IN CHAIN = ", chain.length);
          const info = (0, node_opcua_crypto_1.exploreCertificate)(chain[0]);
          let hasValidIssuer = false;
          let hasTrustedIssuer = false;
          const hasIssuerKey = (_b = (_a = info.tbsCertificate.extensions) === null || _a === void 0 ? void 0 : _a.authorityKeyIdentifier) === null || _b === void 0 ? void 0 : _b.keyIdentifier;
          (0, debug_1.debugLog)("Certificate as an Issuer Key", hasIssuerKey);
          if (hasIssuerKey) {
            const isSelfSigned = isSelfSigned2(info);
            (0, debug_1.debugLog)("Is the Certificate self-signed  ?", isSelfSigned);
            if (!isSelfSigned) {
              (0, debug_1.debugLog)("Is issuer found in the list of know issuers ?", "\n subjectKeyIdentifier   = ", (_c = info.tbsCertificate.extensions) === null || _c === void 0 ? void 0 : _c.subjectKeyIdentifier, "\n authorityKeyIdentifier = ", (_e = (_d = info.tbsCertificate.extensions) === null || _d === void 0 ? void 0 : _d.authorityKeyIdentifier) === null || _e === void 0 ? void 0 : _e.keyIdentifier);
              let issuerCertificate = yield this.findIssuerCertificate(chain[0]);
              if (!issuerCertificate) {
                issuerCertificate = findIssuerCertificateInChain(chain[0], chain);
                if (!issuerCertificate) {
                  (0, debug_1.debugLog)(" the issuer has not been found in the chain itself nor in the issuer.cert list => the chain is incomplete!");
                  return VerificationStatus.BadCertificateChainIncomplete;
                }
                (0, debug_1.debugLog)(" the issuer certificate has been found in the chain itself ! the chain is complete !");
              } else {
                (0, debug_1.debugLog)(" the issuer certificate has been found in the issuer.cert folder !");
              }
              const issuerStatus = yield this._innerVerifyCertificateAsync(issuerCertificate, true, level + 1, options);
              if (issuerStatus === VerificationStatus.BadCertificateRevocationUnknown) {
                return VerificationStatus.BadCertificateIssuerRevocationUnknown;
              }
              if (issuerStatus === VerificationStatus.BadCertificateIssuerRevocationUnknown) {
                return VerificationStatus.BadCertificateIssuerRevocationUnknown;
              }
              if (issuerStatus === VerificationStatus.BadCertificateTimeInvalid) {
                if (!options || !options.acceptOutDatedIssuerCertificate) {
                  return VerificationStatus.BadCertificateIssuerTimeInvalid;
                }
              }
              if (issuerStatus == VerificationStatus.BadCertificateUntrusted) {
                (0, debug_1.debugLog)("warning issuerStatus = ", issuerStatus.toString(), "the issuer certificate is not trusted");
              }
              if (issuerStatus !== VerificationStatus.Good && issuerStatus !== VerificationStatus.BadCertificateUntrusted) {
                return VerificationStatus.BadSecurityChecksFailed;
              }
              const isCertificateSignatureOK = (0, node_opcua_crypto_1.verifyCertificateSignature)(certificate, issuerCertificate);
              if (!isCertificateSignatureOK) {
                (0, debug_1.debugLog)(" the certificate was not signed by the issuer as it claim to be ! Danger");
                return VerificationStatus.BadSecurityChecksFailed;
              }
              hasValidIssuer = true;
              let revokedStatus = yield this.isCertificateRevoked(certificate);
              if (revokedStatus === VerificationStatus.BadCertificateRevocationUnknown) {
                if (options && options.ignoreMissingRevocationList) {
                  revokedStatus = VerificationStatus.Good;
                }
              }
              if (revokedStatus !== VerificationStatus.Good) {
                (0, debug_1.debugLog)("revokedStatus", revokedStatus);
                return revokedStatus;
              }
              const issuerTrustedStatus = yield this._checkRejectedOrTrusted(issuerCertificate);
              (0, debug_1.debugLog)("issuerTrustedStatus", issuerTrustedStatus);
              if (issuerTrustedStatus === "unknown") {
                hasTrustedIssuer = false;
              } else if (issuerTrustedStatus === "trusted") {
                hasTrustedIssuer = true;
              } else if (issuerTrustedStatus === "rejected") {
                return VerificationStatus.BadSecurityChecksFailed;
              }
            } else {
              const isCertificateSignatureOK = (0, node_opcua_crypto_1.verifyCertificateSignature)(certificate, certificate);
              if (!isCertificateSignatureOK) {
                (0, debug_1.debugLog)("Self-signed Certificate signature is not valid");
                return VerificationStatus.BadSecurityChecksFailed;
              }
              const revokedStatus = yield this.isCertificateRevoked(certificate);
              (0, debug_1.debugLog)("revokedStatus of self signed certificate:", revokedStatus);
            }
          }
          const status2 = yield this._checkRejectedOrTrusted(certificate);
          if (status2 === "rejected") {
            return VerificationStatus.BadCertificateUntrusted;
          }
          const c2 = chain[1] ? (0, node_opcua_crypto_1.exploreCertificateInfo)(chain[1]) : "non";
          c2;
          const certificateInfo = (0, node_opcua_crypto_1.exploreCertificateInfo)(certificate);
          const now = /* @__PURE__ */ new Date();
          let isTimeInvalid = false;
          if (certificateInfo.notBefore.getTime() > now.getTime()) {
            (0, debug_1.debugLog)(chalk_1.default.red("certificate is invalid : certificate is not active yet !") + "  not before date =" + certificateInfo.notBefore);
            if (!options.acceptPendingCertificate) {
              isTimeInvalid = true;
            }
          }
          if (certificateInfo.notAfter.getTime() <= now.getTime()) {
            (0, debug_1.debugLog)(chalk_1.default.red("certificate is invalid : certificate has expired !") + " not after date =" + certificateInfo.notAfter);
            if (!options.acceptOutdatedCertificate) {
              isTimeInvalid = true;
            }
          }
          if (status2 === "trusted") {
            return isTimeInvalid ? VerificationStatus.BadCertificateTimeInvalid : VerificationStatus.Good;
          }
          (0, assert_1.default)(status2 === "unknown");
          if (hasIssuerKey) {
            if (!hasTrustedIssuer) {
              return VerificationStatus.BadCertificateUntrusted;
            }
            if (!hasValidIssuer) {
              return VerificationStatus.BadCertificateUntrusted;
            }
            return isTimeInvalid ? VerificationStatus.BadCertificateTimeInvalid : VerificationStatus.Good;
          } else {
            return VerificationStatus.BadCertificateUntrusted;
          }
        });
      }
      verifyCertificateAsync(certificate, options) {
        return __awaiter3(this, void 0, void 0, function* () {
          const status1 = yield this._innerVerifyCertificateAsync(certificate, false, 0, options);
          return status1;
        });
      }
      verifyCertificate(certificate, ...args) {
        let options;
        let callback = void 0;
        if (args.length === 1) {
          callback = args[0];
        } else if (args.length === 2) {
          options = args[0];
          callback = args[1];
        }
        if (!callback || typeof callback !== "function")
          throw new Error("internal error");
        if (!certificate) {
          return callback(null, VerificationStatus.BadSecurityChecksFailed);
        }
        (0, util_1.callbackify)(this.verifyCertificateAsync).call(this, certificate, options || {}, callback);
      }
      initialize(...args) {
        const callback = args[0];
        (0, assert_1.default)(callback && callback instanceof Function);
        if (this.state !== CertificateManagerState.Uninitialized) {
          return callback();
        }
        this.state = CertificateManagerState.Initializing;
        return this._initialize((err) => {
          this.state = CertificateManagerState.Initialized;
          return callback(err);
        });
      }
      _initialize(callback) {
        (0, assert_1.default)(this.state = CertificateManagerState.Initializing);
        const pkiDir = this.location;
        (0, common2_1.mkdir)(pkiDir);
        (0, common2_1.mkdir)(path_1.default.join(pkiDir, "own"));
        (0, common2_1.mkdir)(path_1.default.join(pkiDir, "own/certs"));
        (0, common2_1.mkdir)(path_1.default.join(pkiDir, "own/private"));
        (0, common2_1.mkdir)(path_1.default.join(pkiDir, "rejected"));
        (0, common2_1.mkdir)(path_1.default.join(pkiDir, "trusted"));
        (0, common2_1.mkdir)(path_1.default.join(pkiDir, "trusted/certs"));
        (0, common2_1.mkdir)(path_1.default.join(pkiDir, "trusted/crl"));
        (0, common2_1.mkdir)(path_1.default.join(pkiDir, "issuers"));
        (0, common2_1.mkdir)(path_1.default.join(pkiDir, "issuers/certs"));
        (0, common2_1.mkdir)(path_1.default.join(pkiDir, "issuers/crl"));
        if (!fs_1.default.existsSync(this.configFile) || !fs_1.default.existsSync(this.privateKey)) {
          this.withLock((callback2) => {
            (0, assert_1.default)(this.state !== CertificateManagerState.Disposing);
            if (this.state === CertificateManagerState.Disposed) {
              return callback2();
            }
            (0, assert_1.default)(this.state === CertificateManagerState.Initializing);
            if (!fs_1.default.existsSync(this.configFile)) {
              fs_1.default.writeFileSync(this.configFile, configurationFileSimpleTemplate);
            }
            if (!fs_1.default.existsSync(this.privateKey)) {
              (0, debug_1.debugLog)("generating private key ...");
              (0, without_openssl_1.generatePrivateKeyFileCallback)(this.privateKey, this.keySize, (err) => {
                if (err) {
                  return callback2(err);
                }
                this._readCertificates(() => callback2());
              });
            } else {
              this._readCertificates(() => callback2());
            }
          }, callback);
        } else {
          this._readCertificates(() => callback());
        }
      }
      dispose() {
        return __awaiter3(this, void 0, void 0, function* () {
          if (this.state === CertificateManagerState.Disposing) {
            throw new Error("Already disposing");
          }
          if (this.state === CertificateManagerState.Uninitialized) {
            this.state = CertificateManagerState.Disposed;
            return;
          }
          if (this.state === CertificateManagerState.Initializing) {
            yield new Promise((resolve2) => setTimeout(resolve2, 100));
            return yield this.dispose();
          }
          try {
            this.state = CertificateManagerState.Disposing;
            yield Promise.all(this._watchers.map((w) => w.close()));
            this._watchers.forEach((w) => w.removeAllListeners());
            this._watchers.splice(0);
          } finally {
            this.state = CertificateManagerState.Disposed;
          }
        });
      }
      // eslint-disable-next-line @typescript-eslint/ban-types
      withLock(action, callback) {
        this.withLock2((0, util_1.promisify)(action)).then((t) => callback(null, t)).catch((err) => callback(err));
      }
      withLock2(action) {
        return __awaiter3(this, void 0, void 0, function* () {
          const lockFileName = path_1.default.join(this.rootDir, "mutex.lock");
          return (0, global_mutex_1.withLock)({ fileToLock: lockFileName }, () => __awaiter3(this, void 0, void 0, function* () {
            return yield action();
          }));
        });
      }
      createSelfSignedCertificate(params, ...args) {
        const callback = args[0];
        (0, assert_1.default)(typeof params.applicationUri === "string", "expecting applicationUri");
        if (!fs_1.default.existsSync(this.privateKey)) {
          return callback(new Error("Cannot find private key " + this.privateKey));
        }
        let certificateFilename = path_1.default.join(this.rootDir, "own/certs/self_signed_certificate.pem");
        certificateFilename = params.outputFile || certificateFilename;
        const _params = params;
        _params.rootDir = this.rootDir;
        _params.configFile = this.configFile;
        _params.privateKey = this.privateKey;
        _params.subject = params.subject || "CN=FIXME";
        this.withLock((callback2) => {
          (0, without_openssl_1.createSelfSignedCertificate)(certificateFilename, _params, callback2);
        }, callback);
      }
      createCertificateRequest(params, callback) {
        (0, assert_1.default)(params);
        const _params = params;
        if (Object.prototype.hasOwnProperty.call(_params, "rootDir")) {
          throw new Error("rootDir should not be specified ");
        }
        (0, assert_1.default)(typeof callback === "function");
        (0, assert_1.default)(!_params.rootDir);
        (0, assert_1.default)(!_params.configFile);
        (0, assert_1.default)(!_params.privateKey);
        _params.rootDir = this.rootDir;
        _params.configFile = this.configFile;
        _params.privateKey = this.privateKey;
        this.withLock((callback2) => {
          const now = /* @__PURE__ */ new Date();
          const today = now.toISOString().slice(0, 10) + "_" + now.getTime();
          const certificateSigningRequestFilename = path_1.default.join(this.rootDir, "own/certs", "certificate_" + today + ".csr");
          (0, with_openssl_1.createCertificateSigningRequest)(certificateSigningRequestFilename, _params, (err) => {
            if (err) {
              return callback2(err);
            }
            return callback2(null, certificateSigningRequestFilename);
          });
        }, callback);
      }
      addIssuer(certificate, validate = false, addInTrustList = false) {
        return __awaiter3(this, void 0, void 0, function* () {
          if (validate) {
            const status2 = yield this.verifyCertificate(certificate);
            if (status2 !== VerificationStatus.Good && status2 !== VerificationStatus.BadCertificateUntrusted) {
              return status2;
            }
          }
          const pemCertificate = (0, node_opcua_crypto_1.toPem)(certificate, "CERTIFICATE");
          const fingerprint = makeFingerprint(certificate);
          if (this._thumbs.issuers.certs[fingerprint]) {
            return VerificationStatus.Good;
          }
          const filename = path_1.default.join(this.issuersCertFolder, "issuer_" + buildIdealCertificateName(certificate) + ".pem");
          yield fs_1.default.promises.writeFile(filename, pemCertificate, "ascii");
          this._thumbs.issuers.certs[fingerprint] = { certificate, filename };
          if (addInTrustList) {
            yield this.trustCertificate(certificate);
          }
          return VerificationStatus.Good;
        });
      }
      addRevocationList(crl) {
        return __awaiter3(this, void 0, void 0, function* () {
          return this.withLock2(() => __awaiter3(this, void 0, void 0, function* () {
            try {
              const crlInfo = (0, node_opcua_crypto_1.exploreCertificateRevocationList)(crl);
              const key = crlInfo.tbsCertList.issuerFingerprint;
              if (!this._thumbs.issuersCrl[key]) {
                this._thumbs.issuersCrl[key] = { crls: [], serialNumbers: {} };
              }
              const pemCertificate = (0, node_opcua_crypto_1.toPem)(crl, "X509 CRL");
              const filename = path_1.default.join(this.issuersCrlFolder, "crl_" + buildIdealCertificateName(crl) + ".pem");
              yield fs_1.default.promises.writeFile(filename, pemCertificate, "ascii");
              yield this._on_crl_file_added(this._thumbs.issuersCrl, filename);
              yield this.waitAndCheckCRLProcessingStatus();
              return VerificationStatus.Good;
            } catch (err) {
              (0, debug_1.debugLog)(err);
              return VerificationStatus.BadSecurityChecksFailed;
            }
          }));
        });
      }
      /**
       *  find the issuer certificate among the trusted  issuer certificates.
       *
       *  The findIssuerCertificate method is an asynchronous method that attempts to find
       *  the issuer certificate for a given certificate from the list of issuer certificate declared in the PKI
       *
       *  - If the certificate is self-signed, it returns the certificate itself.
       *
       *  - If the certificate has no extension 3, it is assumed to be generated by an old system, and a null value is returned.
       *
       *  - the method checks both issuer and trusted certificates and returns the appropriate issuercertificate,
       *    if found. If multiple matching certificates are found, a warning is logged to the console.
       *
       */
      findIssuerCertificate(certificate) {
        var _a, _b;
        return __awaiter3(this, void 0, void 0, function* () {
          const certInfo = (0, node_opcua_crypto_1.exploreCertificate)(certificate);
          if (isSelfSigned2(certInfo)) {
            return certificate;
          }
          const wantedIssuerKey = (_b = (_a = certInfo.tbsCertificate.extensions) === null || _a === void 0 ? void 0 : _a.authorityKeyIdentifier) === null || _b === void 0 ? void 0 : _b.keyIdentifier;
          if (!wantedIssuerKey) {
            (0, debug_1.debugLog)("Certificate has no extension 3");
            return null;
          }
          const issuerCertificates = Object.values(this._thumbs.issuers.certs);
          const selectedIssuerCertificates = findMatchingIssuerKey(issuerCertificates, wantedIssuerKey);
          if (selectedIssuerCertificates.length > 0) {
            if (selectedIssuerCertificates.length > 1) {
              (0, debug_1.warningLog)("Warning more than one issuer certificate exists with subjectKeyIdentifier ", wantedIssuerKey);
            }
            return selectedIssuerCertificates[0].certificate || null;
          }
          const trustedCertificates = Object.values(this._thumbs.trusted);
          const selectedTrustedCertificates = findMatchingIssuerKey(trustedCertificates, wantedIssuerKey);
          if (selectedTrustedCertificates.length > 1) {
            (0, debug_1.warningLog)("Warning more than one certificate exists with subjectKeyIdentifier in trusted certificate list ", wantedIssuerKey, selectedTrustedCertificates.length);
            for (const entry of selectedTrustedCertificates) {
              (0, with_openssl_1.dumpCertificate)(entry.filename, (err, data) => {
                (0, debug_1.debugLog)("    ", entry.filename);
                (0, debug_1.debugLog)(data);
              });
            }
          }
          return selectedTrustedCertificates.length > 0 ? selectedTrustedCertificates[0].certificate : null;
        });
      }
      _checkRejectedOrTrusted(certificate, ...args) {
        const callback = args[0];
        (0, assert_1.default)(callback && callback instanceof Function);
        (0, assert_1.default)(certificate instanceof Buffer);
        const fingerprint = makeFingerprint(certificate);
        (0, debug_1.debugLog)("_checkRejectedOrTrusted fingerprint ", short(fingerprint));
        this._readCertificates((err) => {
          if (err) {
            return callback(err);
          }
          if (Object.prototype.hasOwnProperty.call(this._thumbs.rejected, fingerprint)) {
            return callback(null, "rejected");
          }
          if (Object.prototype.hasOwnProperty.call(this._thumbs.trusted, fingerprint)) {
            return callback(null, "trusted");
          }
          return callback(null, "unknown");
        });
      }
      _moveCertificate(certificate, newStatus, callback) {
        (0, assert_1.default)(certificate instanceof Buffer);
        const fingerprint = makeFingerprint(certificate);
        this.getCertificateStatus(certificate, (err, status2) => {
          var _a;
          if (err) {
            return callback(err);
          }
          (0, debug_1.debugLog)("_moveCertificate", fingerprint.substr(0, 10), "from", status2, "to", newStatus);
          (0, assert_1.default)(status2 === "rejected" || status2 === "trusted");
          if (status2 !== newStatus) {
            const certificateSrc = (_a = this._thumbs[status2][fingerprint]) === null || _a === void 0 ? void 0 : _a.filename;
            if (!certificateSrc) {
              (0, debug_1.debugLog)(" cannot find certificate ", fingerprint.substr(0, 10), " in", this._thumbs, [status2]);
              return callback(new Error("internal"));
            }
            const destFolder = newStatus === "rejected" ? this.rejectedFolder : newStatus === "trusted" ? this.trustedFolder : this.rejectedFolder;
            const certificateDest = path_1.default.join(destFolder, path_1.default.basename(certificateSrc));
            (0, debug_1.debugLog)("_moveCertificate1", fingerprint.substring(0, 10), "old name", certificateSrc);
            (0, debug_1.debugLog)("_moveCertificate1", fingerprint.substring(0, 10), "new name", certificateDest);
            fs_1.default.rename(certificateSrc, certificateDest, () => {
              delete this._thumbs[status2][fingerprint];
              this._thumbs[newStatus][fingerprint] = {
                certificate,
                filename: certificateDest
              };
              return callback(
                /*err*/
              );
            });
          } else {
            return callback();
          }
        });
      }
      _findAssociatedCRLs(issuerCertificate) {
        const issuerCertificateInfo = (0, node_opcua_crypto_1.exploreCertificate)(issuerCertificate);
        const key = issuerCertificateInfo.tbsCertificate.subjectFingerPrint;
        return this._thumbs.issuersCrl[key] ? this._thumbs.issuersCrl[key] : this._thumbs.crl[key] ? this._thumbs.crl[key] : null;
      }
      isCertificateRevoked(certificate, issuerCertificate) {
        var _a, _b, _c, _d;
        return __awaiter3(this, void 0, void 0, function* () {
          if (isSelfSigned3(certificate)) {
            return VerificationStatus.Good;
          }
          if (!issuerCertificate) {
            issuerCertificate = yield this.findIssuerCertificate(certificate);
          }
          if (!issuerCertificate) {
            return VerificationStatus.BadCertificateChainIncomplete;
          }
          const crls = this._findAssociatedCRLs(issuerCertificate);
          if (!crls) {
            return VerificationStatus.BadCertificateRevocationUnknown;
          }
          const certInfo = (0, node_opcua_crypto_1.exploreCertificate)(certificate);
          const serialNumber = certInfo.tbsCertificate.serialNumber || ((_b = (_a = certInfo.tbsCertificate.extensions) === null || _a === void 0 ? void 0 : _a.authorityKeyIdentifier) === null || _b === void 0 ? void 0 : _b.serial) || "";
          const key = ((_d = (_c = certInfo.tbsCertificate.extensions) === null || _c === void 0 ? void 0 : _c.authorityKeyIdentifier) === null || _d === void 0 ? void 0 : _d.authorityCertIssuerFingerPrint) || "<unknown>";
          const crl2 = this._thumbs.crl[key] || null;
          if (crls.serialNumbers[serialNumber] || crl2 && crl2.serialNumbers[serialNumber]) {
            return VerificationStatus.BadCertificateRevoked;
          }
          return VerificationStatus.Good;
        });
      }
      _on_crl_file_added(index, filename) {
        this.queue.push({ index, filename });
        this._pending_crl_to_process += 1;
        if (this._pending_crl_to_process === 1) {
          this._process_next_crl();
        }
      }
      _process_next_crl() {
        return __awaiter3(this, void 0, void 0, function* () {
          try {
            const { index, filename } = this.queue.shift();
            const crl = yield (0, node_opcua_crypto_1.readCertificateRevocationList)(filename);
            const crlInfo = (0, node_opcua_crypto_1.exploreCertificateRevocationList)(crl);
            (0, debug_1.debugLog)(chalk_1.default.cyan("add CRL in folder "), filename);
            const fingerprint = crlInfo.tbsCertList.issuerFingerprint;
            index[fingerprint] = index[fingerprint] || {
              crls: [],
              serialNumbers: {}
            };
            index[fingerprint].crls.push({ crlInfo, filename });
            const serialNumbers = index[fingerprint].serialNumbers;
            for (const revokedCertificate of crlInfo.tbsCertList.revokedCertificates) {
              const serialNumber = revokedCertificate.userCertificate;
              if (!serialNumbers[serialNumber]) {
                serialNumbers[serialNumber] = revokedCertificate.revocationDate;
              }
            }
            (0, debug_1.debugLog)(chalk_1.default.cyan("CRL"), fingerprint, "serial numbers = ", Object.keys(serialNumbers));
          } catch (err) {
            (0, debug_1.debugLog)("CRL filename error =");
            (0, debug_1.debugLog)(err);
          }
          this._pending_crl_to_process -= 1;
          if (this._pending_crl_to_process === 0) {
            if (this._on_crl_process) {
              this._on_crl_process();
              this._on_crl_process = void 0;
            }
          } else {
            this._process_next_crl();
          }
        });
      }
      _readCertificates(callback) {
        if (this._readCertificatesCalled) {
          return callback();
        }
        this._readCertificatesCalled = true;
        const options = {
          usePolling: true,
          interval: Math.min(10 * 60 * 1e3, Math.max(100, this.folderPoolingInterval)),
          persistent: false,
          awaitWriteFinish: {
            stabilityThreshold: 2e3,
            pollInterval: 600
          }
        };
        function _walkCRLFiles(folder, index, _innerCallback) {
          const w = chokidar_1.default.watch(folder, options);
          w.on("unlink", (filename, stat) => {
            filename;
            stat;
          });
          w.on("add", (filename, stat) => {
            stat;
            this._on_crl_file_added(index, filename);
          });
          w.on("change", (path3, stat) => {
            (0, debug_1.debugLog)("change in folder ", folder, path3, stat);
          });
          this._watchers.push(w);
          w.on("ready", () => {
            _innerCallback();
          });
        }
        function _walkAllFiles(folder, index, _innerCallback) {
          const w = chokidar_1.default.watch(folder, options);
          w.on("unlink", (filename, stat) => {
            stat;
            (0, debug_1.debugLog)(chalk_1.default.cyan("unlink in folder " + folder), filename);
            const h = this._filenameToHash[filename];
            if (h && index[h]) {
              delete index[h];
            }
          });
          w.on("add", (filename, stat) => {
            var _a, _b;
            stat;
            (0, debug_1.debugLog)(chalk_1.default.cyan("add in folder " + folder), filename);
            try {
              const certificate = (0, node_opcua_crypto_1.readCertificate)(filename);
              const info = (0, node_opcua_crypto_1.exploreCertificate)(certificate);
              const fingerprint = makeFingerprint(certificate);
              index[fingerprint] = {
                certificate,
                filename
              };
              this._filenameToHash[filename] = fingerprint;
              (0, debug_1.debugLog)(chalk_1.default.magenta("CERT"), info.tbsCertificate.subjectFingerPrint, info.tbsCertificate.serialNumber, (_b = (_a = info.tbsCertificate.extensions) === null || _a === void 0 ? void 0 : _a.authorityKeyIdentifier) === null || _b === void 0 ? void 0 : _b.authorityCertIssuerFingerPrint);
            } catch (err) {
              (0, debug_1.debugLog)("Walk files in folder " + folder + " with file " + filename);
              (0, debug_1.debugLog)(err);
            }
          });
          w.on("change", (path3, stat) => {
            stat;
            (0, debug_1.debugLog)("change in folder ", folder, path3);
          });
          this._watchers.push(w);
          w.on("ready", () => {
            _innerCallback();
            (0, debug_1.debugLog)("ready");
            (0, debug_1.debugLog)(Object.entries(index).map((kv) => kv[0].substr(0, 10)));
          });
        }
        async_1.default.parallelLimit([
          _walkAllFiles.bind(this, this.trustedFolder, this._thumbs.trusted),
          _walkAllFiles.bind(this, this.issuersCertFolder, this._thumbs.issuers.certs),
          _walkAllFiles.bind(this, this.rejectedFolder, this._thumbs.rejected),
          _walkCRLFiles.bind(this, this.crlFolder, this._thumbs.crl),
          _walkCRLFiles.bind(this, this.issuersCrlFolder, this._thumbs.issuersCrl)
        ], 2, (err) => {
          if (err) {
            (0, debug_1.debugLog)("Error=", err);
            return callback(err);
          }
          this.waitAndCheckCRLProcessingStatus().then(() => callback()).catch((err2) => callback(err2));
        });
      }
      // make sure that all crls have been processed.
      waitAndCheckCRLProcessingStatus() {
        return __awaiter3(this, void 0, void 0, function* () {
          return new Promise((resolve2, reject) => {
            if (this._pending_crl_to_process === 0) {
              setImmediate(resolve2);
              return;
            }
            if (this._on_crl_process) {
              return reject(new Error("Internal Error"));
            }
            this._on_crl_process = resolve2;
          });
        });
      }
    };
    exports2.CertificateManager = CertificateManager;
    var opts = { multiArgs: false };
    CertificateManager.prototype.rejectCertificate = thenify.withCallback(CertificateManager.prototype.rejectCertificate, opts);
    CertificateManager.prototype.trustCertificate = thenify.withCallback(CertificateManager.prototype.trustCertificate, opts);
    CertificateManager.prototype.createSelfSignedCertificate = thenify.withCallback(CertificateManager.prototype.createSelfSignedCertificate, opts);
    CertificateManager.prototype.createCertificateRequest = thenify.withCallback(CertificateManager.prototype.createCertificateRequest, opts);
    CertificateManager.prototype.initialize = thenify.withCallback(CertificateManager.prototype.initialize, opts);
    CertificateManager.prototype.getCertificateStatus = thenify.withCallback(CertificateManager.prototype.getCertificateStatus, opts);
    CertificateManager.prototype._checkRejectedOrTrusted = thenify.withCallback(CertificateManager.prototype._checkRejectedOrTrusted, opts);
    CertificateManager.prototype.verifyCertificate = thenify.withCallback(CertificateManager.prototype.verifyCertificate, opts);
    CertificateManager.prototype.isCertificateTrusted = thenify.withCallback((0, util_1.callbackify)(CertificateManager.prototype.isCertificateTrusted), opts);
  }
});

// node_modules/node-opcua-pki/dist/lib/ca/templates/ca_config_template.cnf.js
var require_ca_config_template_cnf = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/ca/templates/ca_config_template.cnf.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var config = `#.........DO NOT MODIFY BY HAND .........................
[ ca ]
default_ca               = CA_default
[ CA_default ]
dir                      = %%ROOT_FOLDER%%            # the main CA folder
certs                    = $dir/certs                 # where to store certificates
new_certs_dir            = $dir/certs                 #
database                 = $dir/index.txt             # the certificate database
serial                   = $dir/serial                # the serial number counter
certificate              = $dir/public/cacert.pem     # The root CA certificate
private_key              = $dir/private/cakey.pem     # the CA private key
x509_extensions          = usr_cert                   #
default_days             = 3650                       # default validity : 10 years

# default_md               = sha1

default_md                = sha256                      # The default digest algorithm

preserve                 = no
policy                   = policy_match
# randfile                 = $dir/random.rnd
# default_startdate        = YYMMDDHHMMSSZ
# default_enddate          = YYMMDDHHMMSSZ
crl_dir                  = $dir/crl
crl_extensions           = crl_ext
crl                      = $dir/revocation_list.crl # the Revocation list
crlnumber                = $dir/crlnumber           # CRL number file
default_crl_days         = 30
default_crl_hours        = 24
#msie_hack

[ policy_match ]
countryName              = optional
stateOrProvinceName      = optional
localityName             = optional
organizationName         = optional
organizationalUnitName   = optional
commonName               = optional
emailAddress             = optional

[ req ]
default_bits             = 4096                     # Size of keys
default_keyfile          = key.pem                  # name of generated keys
distinguished_name       = req_distinguished_name
attributes               = req_attributes
x509_extensions          = v3_ca
#input_password
#output_password
string_mask              = nombstr                  # permitted characters
req_extensions           = v3_req

[ req_distinguished_name ]

#0 countryName             = Country Name (2 letter code)
# countryName_default     = FR
# countryName_min         = 2
# countryName_max         = 2
# stateOrProvinceName     = State or Province Name (full name)
# stateOrProvinceName_default = Ile de France
# localityName            = Locality Name (city, district)
# localityName_default    = Paris
organizationName          = Organization Name (company)
organizationName_default  = NodeOPCUA
# organizationalUnitName  = Organizational Unit Name (department, division)
# organizationalUnitName_default = R&D
commonName                = Common Name (hostname, FQDN, IP, or your name)
commonName_max            = 256
commonName_default        = NodeOPCUA
# emailAddress            = Email Address
# emailAddress_max        = 40
# emailAddress_default    = node-opcua (at) node-opcua (dot) com

[ req_attributes ]
#challengePassword        = A challenge password
#challengePassword_min    = 4
#challengePassword_max    = 20
#unstructuredName         = An optional company name
[ usr_cert ]
basicConstraints          = critical, CA:FALSE
subjectKeyIdentifier      = hash
authorityKeyIdentifier    = keyid,issuer:always
#authorityKeyIdentifier    = keyid
subjectAltName            = $ENV::ALTNAME
# issuerAltName            = issuer:copy
nsComment                 = ''OpenSSL Generated Certificate''
#nsCertType               = client, email, objsign for ''everything including object signing''
#nsCaRevocationUrl        = http://www.domain.dom/ca-crl.pem
#nsBaseUrl                =
#nsRenewalUrl             =
#nsCaPolicyUrl            =
#nsSslServerName          =
keyUsage                  = critical, digitalSignature, nonRepudiation, keyEncipherment, dataEncipherment, keyAgreement, keyCertSign
extendedKeyUsage          = critical,serverAuth ,clientAuth

[ v3_req ]
basicConstraints          = critical, CA:FALSE
keyUsage                  = nonRepudiation, digitalSignature, keyEncipherment, dataEncipherment, keyAgreement
extendedKeyUsage          = critical,serverAuth ,clientAuth
subjectAltName            = $ENV::ALTNAME
nsComment                 = "CA Generated by Node-OPCUA Certificate utility using openssl"
[ v3_ca ]
subjectKeyIdentifier      = hash
authorityKeyIdentifier    = keyid:always,issuer:always
# authorityKeyIdentifier    = keyid
basicConstraints          = CA:TRUE
keyUsage                  = critical, cRLSign, keyCertSign
nsComment                 = "CA Certificate generated by Node-OPCUA Certificate utility using openssl"
#nsCertType                 = sslCA, emailCA
#subjectAltName             = email:copy
#issuerAltName              = issuer:copy
#obj                        = DER:02:03
crlDistributionPoints     = @crl_info
[ crl_info ]
URI.0                     = http://localhost:8900/crl.pem
[ v3_selfsigned]
basicConstraints          = critical, CA:FALSE
keyUsage                  = nonRepudiation, digitalSignature, keyEncipherment, dataEncipherment, keyAgreement
extendedKeyUsage          = critical,serverAuth ,clientAuth
nsComment                 = "Self-signed certificate, generated by NodeOPCUA"
subjectAltName            = $ENV::ALTNAME

[ crl_ext ]
#issuerAltName            = issuer:copy
authorityKeyIdentifier    = keyid:always,issuer:always
#authorityInfoAccess       = @issuer_info`;
    exports2.default = config;
  }
});

// node_modules/node-opcua-pki/dist/lib/ca/certificate_authority.js
var require_certificate_authority = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/ca/certificate_authority.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.CertificateAuthority = exports2.configurationFileTemplate = exports2.defaultSubject = void 0;
    var assert_1 = __importDefault3(require("assert"));
    var async_1 = __importDefault3(require_async());
    var chalk_1 = __importDefault3(require_source());
    var fs_1 = __importDefault3(require("fs"));
    var path_1 = __importDefault3(require("path"));
    var node_opcua_crypto_1 = require_dist33();
    var toolbox_1 = require_toolbox();
    var with_openssl_1 = require_with_openssl();
    var create_private_key_1 = require_create_private_key();
    exports2.defaultSubject = "/C=FR/ST=IDF/L=Paris/O=Local NODE-OPCUA Certificate Authority/CN=NodeOPCUA-CA";
    var ca_config_template_cnf_1 = __importDefault3(require_ca_config_template_cnf());
    exports2.configurationFileTemplate = ca_config_template_cnf_1.default;
    var config = {
      certificateDir: "INVALID",
      forceCA: false,
      pkiDir: "INVALID"
    };
    var n = toolbox_1.make_path;
    var q2 = toolbox_1.quote;
    function octetStringToIpAddress(a) {
      return parseInt(a.substring(0, 2), 16).toString() + "." + parseInt(a.substring(2, 4), 16).toString() + "." + parseInt(a.substring(4, 6), 16).toString() + "." + parseInt(a.substring(6, 8), 16).toString();
    }
    (0, assert_1.default)(octetStringToIpAddress("c07b9179") === "192.123.145.121");
    function construct_CertificateAuthority(certificateAuthority, callback) {
      const subject = certificateAuthority.subject;
      const caRootDir = certificateAuthority.rootDir;
      function make_folders() {
        (0, toolbox_1.mkdir)(caRootDir);
        (0, toolbox_1.mkdir)(path_1.default.join(caRootDir, "private"));
        (0, toolbox_1.mkdir)(path_1.default.join(caRootDir, "public"));
        (0, toolbox_1.mkdir)(path_1.default.join(caRootDir, "certs"));
        (0, toolbox_1.mkdir)(path_1.default.join(caRootDir, "crl"));
        (0, toolbox_1.mkdir)(path_1.default.join(caRootDir, "conf"));
      }
      make_folders();
      function construct_default_files() {
        const serial = path_1.default.join(caRootDir, "serial");
        if (!fs_1.default.existsSync(serial)) {
          fs_1.default.writeFileSync(serial, "1000");
        }
        const crlNumber = path_1.default.join(caRootDir, "crlnumber");
        if (!fs_1.default.existsSync(crlNumber)) {
          fs_1.default.writeFileSync(crlNumber, "1000");
        }
        const indexFile = path_1.default.join(caRootDir, "index.txt");
        if (!fs_1.default.existsSync(indexFile)) {
          fs_1.default.writeFileSync(indexFile, "");
        }
      }
      construct_default_files();
      if (fs_1.default.existsSync(path_1.default.join(caRootDir, "private/cakey.pem")) && !config.forceCA) {
        (0, toolbox_1.debugLog)("CA private key already exists ... skipping");
        return callback();
      }
      (0, toolbox_1.displayTitle)("Create Certificate Authority (CA)", (_err) => {
        _err;
      });
      const indexFileAttr = path_1.default.join(caRootDir, "index.txt.attr");
      if (!fs_1.default.existsSync(indexFileAttr)) {
        fs_1.default.writeFileSync(indexFileAttr, "unique_subject = no");
      }
      const caConfigFile = certificateAuthority.configFile;
      if (1) {
        let data = exports2.configurationFileTemplate;
        data = data.replace(/%%ROOT_FOLDER%%/, (0, toolbox_1.make_path)(caRootDir));
        fs_1.default.writeFileSync(caConfigFile, data);
      }
      const subjectOpt = ' -subj "' + subject.toString() + '" ';
      const options = { cwd: caRootDir };
      (0, with_openssl_1.processAltNames)({});
      const configFile = (0, with_openssl_1.generateStaticConfig)("conf/caconfig.cnf", options);
      const configOption = " -config " + q2(n(configFile));
      const keySize = certificateAuthority.keySize;
      const privateKeyFilename = path_1.default.join(caRootDir, "private/cakey.pem");
      const csrFilename = path_1.default.join(caRootDir, "private/cakey.csr");
      const tasks = [
        (callback2) => (0, toolbox_1.displayTitle)("Generate the CA private Key - " + keySize, callback2),
        // The first step is to create your RSA Private Key.
        // This key is a 1025,2048,3072 or 2038 bit RSA key which is encrypted using
        // Triple-DES and stored in a PEM format so that it is readable as ASCII text.
        (callback2) => (0, create_private_key_1.generatePrivateKeyFileCallback)(privateKeyFilename, keySize, callback2),
        (callback2) => (0, toolbox_1.displayTitle)("Generate a certificate request for the CA key", callback2),
        // Once the private key is generated a Certificate Signing Request can be generated.
        // The CSR is then used in one of two ways. Ideally, the CSR will be sent to a Certificate Authority, such as
        // Thawte or Verisign who will verify the identity of the requestor and issue a signed certificate.
        // The second option is to self-sign the CSR, which will be demonstrated in the next section
        (callback2) => (0, with_openssl_1.execute_openssl)("req -new -sha256  -text  -extensions v3_ca" + configOption + " -key " + q2(n(privateKeyFilename)) + " -out " + q2(n(csrFilename)) + " " + subjectOpt, options, callback2),
        // xx // Step 3: Remove Passphrase from Key
        // xx execute("cp private/cakey.pem private/cakey.pem.org");
        // xx execute(openssl_path + " rsa -in private/cakey.pem.org -out private/cakey.pem -passin pass:"+paraphrase);
        (callback2) => (0, toolbox_1.displayTitle)("Generate CA Certificate (self-signed)", callback2),
        (callback2) => (0, with_openssl_1.execute_openssl)(" x509 -sha256 -req -days 3650  -text  -extensions v3_ca -extfile " + q2(n(configFile)) + " -in private/cakey.csr  -signkey " + q2(n(privateKeyFilename)) + " -out public/cacert.pem", options, callback2),
        (callback2) => (0, toolbox_1.displaySubtitle)("generate initial CRL (Certificate Revocation List)", callback2),
        (callback2) => regenerateCrl(certificateAuthority.revocationList, configOption, options, callback2),
        (callback2) => (0, toolbox_1.displayTitle)("Create Certificate Authority (CA) ---> DONE", callback2)
      ];
      async_1.default.series(tasks, callback);
    }
    function regenerateCrl(revocationList, configOption, options, callback) {
      const tasks = [
        (callback2) => (0, toolbox_1.displaySubtitle)("regenerate CRL (Certificate Revocation List)", callback2),
        (callback2) => (
          // produce a CRL in PEM format
          (0, with_openssl_1.execute_openssl)("ca -gencrl " + configOption + " -out crl/revocation_list.crl", options, callback2)
        ),
        (callback2) => (0, with_openssl_1.execute_openssl)("crl  -in  crl/revocation_list.crl -out  crl/revocation_list.der  -outform der", options, callback2),
        (callback2) => (0, toolbox_1.displaySubtitle)("Display (Certificate Revocation List)", callback2),
        (callback2) => (0, with_openssl_1.execute_openssl)("crl  -in " + q2(n(revocationList)) + " -text  -noout", options, callback2)
      ];
      async_1.default.series(tasks, callback);
    }
    var CertificateAuthority = class {
      constructor(options) {
        (0, assert_1.default)(Object.prototype.hasOwnProperty.call(options, "location"));
        (0, assert_1.default)(Object.prototype.hasOwnProperty.call(options, "keySize"));
        this.location = options.location;
        this.keySize = options.keySize || 2048;
        this.subject = new node_opcua_crypto_1.Subject(options.subject || exports2.defaultSubject);
      }
      get rootDir() {
        return this.location;
      }
      get configFile() {
        return path_1.default.normalize(path_1.default.join(this.rootDir, "./conf/caconfig.cnf"));
      }
      get caCertificate() {
        return (0, toolbox_1.make_path)(this.rootDir, "./public/cacert.pem");
      }
      /**
       * the file name where  the current Certificate Revocation List is stored (in DER format)
       */
      get revocationListDER() {
        return (0, toolbox_1.make_path)(this.rootDir, "./crl/revocation_list.der");
      }
      /**
       * the file name where  the current Certificate Revocation List is stored (in PEM format)
       */
      get revocationList() {
        return (0, toolbox_1.make_path)(this.rootDir, "./crl/revocation_list.crl");
      }
      get caCertificateWithCrl() {
        return (0, toolbox_1.make_path)(this.rootDir, "./public/cacertificate_with_crl.pem");
      }
      initialize(callback) {
        (0, assert_1.default)(typeof callback === "function");
        construct_CertificateAuthority(this, callback);
      }
      constructCACertificateWithCRL(callback) {
        (0, assert_1.default)(typeof callback === "function");
        const cacertWithCRL = this.caCertificateWithCrl;
        if (fs_1.default.existsSync(this.revocationList)) {
          fs_1.default.writeFileSync(cacertWithCRL, fs_1.default.readFileSync(this.caCertificate, "utf8") + fs_1.default.readFileSync(this.revocationList, "utf8"));
        } else {
          fs_1.default.writeFileSync(cacertWithCRL, fs_1.default.readFileSync(this.caCertificate));
        }
        callback();
      }
      constructCertificateChain(certificate, callback) {
        (0, assert_1.default)(typeof callback === "function");
        (0, assert_1.default)(fs_1.default.existsSync(certificate));
        (0, assert_1.default)(fs_1.default.existsSync(this.caCertificate));
        (0, toolbox_1.debugLog)(chalk_1.default.yellow("        certificate file :"), chalk_1.default.cyan(certificate));
        fs_1.default.writeFileSync(
          certificate,
          fs_1.default.readFileSync(certificate, "utf8") + fs_1.default.readFileSync(this.caCertificate, "utf8")
          //   + fs.readFileSync(this.revocationList)
        );
        callback();
      }
      createSelfSignedCertificate(certificateFile, privateKey, params, callback) {
        (0, assert_1.default)(typeof privateKey === "string");
        (0, assert_1.default)(fs_1.default.existsSync(privateKey));
        (0, assert_1.default)(typeof callback === "function");
        if (!(0, toolbox_1.certificateFileExist)(certificateFile)) {
          return callback();
        }
        (0, toolbox_1.adjustDate)(params);
        (0, toolbox_1.adjustApplicationUri)(params);
        (0, with_openssl_1.processAltNames)(params);
        const csrFile = certificateFile + "_csr";
        (0, assert_1.default)(csrFile);
        const configFile = (0, with_openssl_1.generateStaticConfig)(this.configFile);
        const options = {
          cwd: this.rootDir,
          openssl_conf: (0, toolbox_1.make_path)(configFile)
        };
        const configOption = "";
        const subject = params.subject ? new node_opcua_crypto_1.Subject(params.subject).toString() : "";
        const subjectOptions = subject && subject.length > 1 ? " -subj " + subject + " " : "";
        const tasks = [];
        tasks.push((callback2) => (0, toolbox_1.displaySubtitle)("- the certificate signing request", callback2));
        tasks.push((callback2) => (0, with_openssl_1.execute_openssl)("req  -new -sha256 -text " + configOption + subjectOptions + " -batch -key " + q2(n(privateKey)) + " -out " + q2(n(csrFile)), options, callback2));
        tasks.push((callback2) => (0, toolbox_1.displaySubtitle)("- creating the self-signed certificate", callback2));
        tasks.push((callback2) => (0, with_openssl_1.execute_openssl)("ca  -selfsign  -keyfile " + q2(n(privateKey)) + " -startdate " + (0, with_openssl_1.x509Date)(params.startDate) + " -enddate " + (0, with_openssl_1.x509Date)(params.endDate) + " -batch -out " + q2(n(certificateFile)) + " -in " + q2(n(csrFile)), options, callback2));
        tasks.push((callback2) => (0, toolbox_1.displaySubtitle)("- dump the certificate for a check", callback2));
        tasks.push((callback2) => (0, with_openssl_1.execute_openssl)("x509 -in " + q2(n(certificateFile)) + "  -dates -fingerprint -purpose -noout", {}, callback2));
        tasks.push((callback2) => (0, toolbox_1.displaySubtitle)("- verify self-signed certificate", callback2));
        tasks.push((callback2) => (0, with_openssl_1.execute_openssl_no_failure)("verify -verbose -CAfile " + q2(n(certificateFile)) + " " + q2(n(certificateFile)), options, callback2));
        tasks.push((callback2) => fs_1.default.unlink(csrFile, callback2));
        async_1.default.series(tasks, (err) => {
          callback(err);
        });
      }
      revokeCertificate(certificate, params, callback) {
        (0, assert_1.default)(typeof callback === "function");
        const crlReasons = [
          "unspecified",
          "keyCompromise",
          "CACompromise",
          "affiliationChanged",
          "superseded",
          "cessationOfOperation",
          "certificateHold",
          "removeFromCRL"
        ];
        const configFile = (0, with_openssl_1.generateStaticConfig)("conf/caconfig.cnf", { cwd: this.rootDir });
        const options = {
          cwd: this.rootDir,
          openssl_conf: (0, toolbox_1.make_path)(configFile)
        };
        (0, with_openssl_1.setEnv)("ALTNAME", "");
        const randomFile = path_1.default.join(this.rootDir, "random.rnd");
        (0, with_openssl_1.setEnv)("RANDFILE", randomFile);
        const configOption = " -config " + q2(n(configFile));
        const reason = params.reason || "keyCompromise";
        (0, assert_1.default)(crlReasons.indexOf(reason) >= 0);
        const tasks = [
          (callback2) => (0, toolbox_1.displayTitle)("Revoking certificate  " + certificate, callback2),
          (callback2) => (0, toolbox_1.displaySubtitle)("Revoke certificate", callback2),
          (callback2) => {
            (0, with_openssl_1.execute_openssl_no_failure)("ca -verbose " + configOption + " -revoke " + q2(certificate) + " -crl_reason " + reason, options, callback2);
          },
          // regenerate CRL (Certificate Revocation List)
          (callback2) => regenerateCrl(this.revocationList, configOption, options, callback2),
          (callback2) => (0, toolbox_1.displaySubtitle)("Verify that certificate is revoked  ", callback2),
          (callback2) => {
            (0, with_openssl_1.execute_openssl_no_failure)("verify -verbose -CRLfile " + q2(n(this.revocationList)) + " -CAfile " + q2(n(this.caCertificate)) + " -crl_check " + q2(n(certificate)), options, (err, output) => {
              err;
              output;
              callback2();
            });
          },
          // produce CRL in DER format
          (callback2) => (0, toolbox_1.displaySubtitle)("Produce CRL in DER form ", callback2),
          (callback2) => (0, with_openssl_1.execute_openssl)("crl  -in " + q2(n(this.revocationList)) + " -out crl/revocation_list.der  -outform der", options, callback2),
          // produce CRL in PEM format with text
          (callback2) => (0, toolbox_1.displaySubtitle)("Produce CRL in PEM form ", callback2),
          (callback2) => (0, with_openssl_1.execute_openssl)("crl  -in " + q2(n(this.revocationList)) + " -out crl/revocation_list.pem  -outform pem -text ", options, callback2)
        ];
        async_1.default.series(tasks, callback);
      }
      signCertificateRequest(certificate, certificateSigningRequestFilename, params, callback) {
        if (!callback) {
          throw new Error("Internal Error");
        }
        (0, with_openssl_1.ensure_openssl_installed)(() => {
          try {
            (0, assert_1.default)(fs_1.default.existsSync(certificateSigningRequestFilename));
            (0, assert_1.default)(typeof callback === "function");
            if (!(0, toolbox_1.certificateFileExist)(certificate)) {
              return callback(null);
            }
            (0, toolbox_1.adjustDate)(params);
            (0, toolbox_1.adjustApplicationUri)(params);
            (0, with_openssl_1.processAltNames)(params);
            const options = { cwd: this.rootDir };
            let configFile;
            const tasks = [];
            let csrInfo;
            tasks.push((callback2) => {
              (0, node_opcua_crypto_1.readCertificateSigningRequest)(certificateSigningRequestFilename).then((csr) => {
                csrInfo = (0, node_opcua_crypto_1.exploreCertificateSigningRequest)(csr);
                callback2();
              }).catch((err) => callback2(err));
            });
            tasks.push((callback2) => {
              const applicationUri = csrInfo.extensionRequest.subjectAltName.uniformResourceIdentifier[0];
              if (typeof applicationUri !== "string") {
                return callback2(new Error("Cannot find applicationUri in CSR"));
              }
              const dns = csrInfo.extensionRequest.subjectAltName.dNSName || [];
              let ip = csrInfo.extensionRequest.subjectAltName.iPAddress || [];
              ip = ip.map(octetStringToIpAddress);
              const params2 = {
                applicationUri,
                dns,
                ip
              };
              (0, with_openssl_1.processAltNames)(params2);
              configFile = (0, with_openssl_1.generateStaticConfig)("conf/caconfig.cnf", options);
              callback2();
            });
            tasks.push((callback2) => (0, toolbox_1.displaySubtitle)("- then we ask the authority to sign the certificate signing request", callback2));
            tasks.push((callback2) => {
              const configOption = " -config " + configFile;
              (0, with_openssl_1.execute_openssl)("ca " + configOption + " -startdate " + (0, with_openssl_1.x509Date)(params.startDate) + " -enddate " + (0, with_openssl_1.x509Date)(params.endDate) + " -batch -out " + q2(n(certificate)) + " -in " + q2(n(certificateSigningRequestFilename)), options, callback2);
            });
            tasks.push((callback2) => (0, toolbox_1.displaySubtitle)("- dump the certificate for a check", callback2));
            tasks.push((callback2) => (0, with_openssl_1.execute_openssl)("x509 -in " + q2(n(certificate)) + "  -dates -fingerprint -purpose -noout", options, callback2));
            tasks.push((callback2) => (0, toolbox_1.displaySubtitle)("- construct CA certificate with CRL", callback2));
            tasks.push((callback2) => {
              this.constructCACertificateWithCRL(callback2);
            });
            tasks.push((callback2) => (0, toolbox_1.displaySubtitle)("- construct certificate chain", callback2));
            tasks.push((callback2) => {
              this.constructCertificateChain(certificate, callback2);
            });
            tasks.push((callback2) => (0, toolbox_1.displaySubtitle)("- verify certificate against the root CA", callback2));
            tasks.push((callback2) => {
              this.verifyCertificate(certificate, callback2);
            });
            async_1.default.series(tasks, (err) => {
              if (err) {
                return callback(err);
              }
              callback(null, certificate);
            });
          } catch (err) {
            callback(err);
          }
        });
      }
      verifyCertificate(certificate, callback) {
        const isImplemented = false;
        if (isImplemented) {
          const options = { cwd: this.rootDir };
          const configFile = (0, with_openssl_1.generateStaticConfig)("conf/caconfig.cnf", options);
          (0, with_openssl_1.setEnv)("OPENSSL_CONF", (0, toolbox_1.make_path)(configFile));
          const configOption = " -config " + configFile;
          configOption;
          (0, with_openssl_1.execute_openssl_no_failure)("verify -verbose  -CAfile " + q2(n(this.caCertificateWithCrl)) + " " + q2(n(certificate)), options, (err) => {
            callback(err ? err : void 0);
          });
        } else {
          return callback();
        }
      }
    };
    exports2.CertificateAuthority = CertificateAuthority;
    var thenify = require_thenify();
    var opts = { multiArgs: false };
    CertificateAuthority.prototype.initialize = thenify.withCallback(CertificateAuthority.prototype.initialize, opts);
    CertificateAuthority.prototype.constructCACertificateWithCRL = thenify.withCallback(CertificateAuthority.prototype.constructCACertificateWithCRL, opts);
    CertificateAuthority.prototype.constructCertificateChain = thenify.withCallback(CertificateAuthority.prototype.constructCertificateChain, opts);
    CertificateAuthority.prototype.createSelfSignedCertificate = thenify.withCallback(CertificateAuthority.prototype.createSelfSignedCertificate, opts);
    CertificateAuthority.prototype.revokeCertificate = thenify.withCallback(CertificateAuthority.prototype.revokeCertificate, opts);
    CertificateAuthority.prototype.verifyCertificate = thenify.withCallback(CertificateAuthority.prototype.verifyCertificate, opts);
    CertificateAuthority.prototype.signCertificateRequest = thenify.withCallback(CertificateAuthority.prototype.signCertificateRequest, opts);
  }
});

// node_modules/node-opcua-pki/dist/lib/index.js
var require_lib18 = __commonJS({
  "node_modules/node-opcua-pki/dist/lib/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.CertificateAuthority = void 0;
    __exportStar3(require_toolbox(), exports2);
    __exportStar3(require_create_private_key(), exports2);
    __exportStar3(require_certificate_manager(), exports2);
    __exportStar3(require_subject(), exports2);
    var certificate_authority_1 = require_certificate_authority();
    Object.defineProperty(exports2, "CertificateAuthority", { enumerable: true, get: function() {
      return certificate_authority_1.CertificateAuthority;
    } });
  }
});

// node_modules/node-opcua-certificate-manager/dist/certificate_manager.js
var require_certificate_manager2 = __commonJS({
  "node_modules/node-opcua-certificate-manager/dist/certificate_manager.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getDefaultCertificateManager = exports2.OPCUACertificateManager = void 0;
    var fs_1 = __importDefault3(require("fs"));
    var path_1 = __importDefault3(require("path"));
    var mkdirp_1 = __importDefault3(require_mkdirp());
    var env_paths_1 = __importDefault3(require_env_paths());
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_crypto_1 = require_dist33();
    var node_opcua_pki_1 = require_lib18();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_object_registry_1 = require_dist46();
    var paths = (0, env_paths_1.default)("node-opcua-default");
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var OPCUACertificateManager = class extends node_opcua_pki_1.CertificateManager {
      /* */
      constructor(options) {
        options = options || {};
        const location = options.rootFolder || paths.config;
        if (!fs_1.default.existsSync(location)) {
          try {
            mkdirp_1.default.sync(location);
          } catch (err) {
            errorLog(" cannot create folder ", location, fs_1.default.existsSync(location));
          }
        }
        const _options = {
          keySize: options.keySize || 2048,
          location
        };
        super(_options);
        this.referenceCounter = 0;
        this.automaticallyAcceptUnknownCertificate = !!options.automaticallyAcceptUnknownCertificate;
      }
      initialize(...args) {
        const callback = args[0];
        (0, node_opcua_assert_1.assert)(callback && typeof callback === "function");
        return super.initialize(callback);
      }
      async dispose() {
        if (this.referenceCounter === 0) {
          await super.dispose();
        } else {
          this.referenceCounter--;
        }
      }
      checkCertificate(certificateChain, callback) {
        if (!callback || typeof callback !== "function") {
          throw new Error("Internal error");
        }
        this.verifyCertificate(certificateChain, (err1, status2) => {
          if (err1) {
            return callback(err1);
          }
          const statusCode = node_opcua_status_code_1.StatusCodes[status2];
          const certificates = (0, node_opcua_crypto_1.split_der)(certificateChain);
          debugLog("checkCertificate => StatusCode = ", statusCode.toString());
          if (statusCode.equals(node_opcua_status_code_1.StatusCodes.BadCertificateUntrusted)) {
            const topCertificateInChain = certificates[0];
            const thumbprint = (0, node_opcua_crypto_1.makeSHA1Thumbprint)(topCertificateInChain).toString("hex");
            if (this.automaticallyAcceptUnknownCertificate) {
              debugLog("automaticallyAcceptUnknownCertificate = true");
              debugLog("certificate with thumbprint " + thumbprint + " is now trusted");
              return this.trustCertificate(topCertificateInChain, () => callback(null, node_opcua_status_code_1.StatusCodes.Good));
            } else {
              debugLog("automaticallyAcceptUnknownCertificate = false");
              debugLog("certificate with thumbprint " + thumbprint + " is now rejected");
              return this.rejectCertificate(topCertificateInChain, () => callback(null, node_opcua_status_code_1.StatusCodes.BadCertificateUntrusted));
            }
          } else if (statusCode.equals(node_opcua_status_code_1.StatusCodes.BadCertificateChainIncomplete)) {
            const rejectAll = async (certificates2) => {
              for (const certificate of certificates2) {
                await this.rejectCertificate(certificate);
              }
            };
            rejectAll(certificates).then(() => {
              callback(null, statusCode);
            }).catch((err) => {
              callback(err);
            });
            return;
          }
          callback(null, statusCode);
        });
      }
      getTrustStatus(certificate, callback) {
        this.isCertificateTrusted(certificate, (err, trustedStatus) => {
          callback(err, err ? void 0 : node_opcua_status_code_1.StatusCodes[trustedStatus]);
        });
      }
      async withLock2(action) {
        return await super.withLock2(action);
      }
    };
    exports2.OPCUACertificateManager = OPCUACertificateManager;
    OPCUACertificateManager.defaultCertificateSubject = "/O=Sterfive/L=Orleans/C=FR";
    OPCUACertificateManager.registry = new node_opcua_object_registry_1.ObjectRegistry();
    var thenify = require_thenify();
    var opts = { multiArgs: false };
    OPCUACertificateManager.prototype.checkCertificate = thenify.withCallback(OPCUACertificateManager.prototype.checkCertificate, opts);
    OPCUACertificateManager.prototype.getTrustStatus = thenify.withCallback(OPCUACertificateManager.prototype.getTrustStatus, opts);
    OPCUACertificateManager.prototype.initialize = thenify.withCallback(OPCUACertificateManager.prototype.initialize, opts);
    function getDefaultCertificateManager(name) {
      const config = (0, env_paths_1.default)("node-opcua-default").config;
      const pkiFolder = path_1.default.join(config, name);
      return new OPCUACertificateManager({
        name,
        rootFolder: pkiFolder,
        automaticallyAcceptUnknownCertificate: true
      });
    }
    exports2.getDefaultCertificateManager = getDefaultCertificateManager;
  }
});

// node_modules/node-opcua-certificate-manager/dist/make_subject.js
var require_make_subject = __commonJS({
  "node_modules/node-opcua-certificate-manager/dist/make_subject.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.makeSubject = void 0;
    var certificate_manager_1 = require_certificate_manager2();
    function makeSubject(applicationName, hostname2) {
      const commonName = `${applicationName}@${hostname2}`.substring(0, 63);
      const dc = `${hostname2}`.substring(63);
      return `/CN=${commonName}/DC=${dc}` + certificate_manager_1.OPCUACertificateManager.defaultCertificateSubject;
    }
    exports2.makeSubject = makeSubject;
  }
});

// node_modules/node-opcua-certificate-manager/dist/index.js
var require_dist60 = __commonJS({
  "node_modules/node-opcua-certificate-manager/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.CertificateManager = void 0;
    __exportStar3(require_certificate_manager2(), exports2);
    __exportStar3(require_make_subject(), exports2);
    var node_opcua_pki_1 = require_lib18();
    Object.defineProperty(exports2, "CertificateManager", { enumerable: true, get: function() {
      return node_opcua_pki_1.CertificateManager;
    } });
  }
});

// node_modules/node-opcua-client/dist/verify.js
var require_verify = __commonJS({
  "node_modules/node-opcua-client/dist/verify.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.performCertificateSanityCheck = exports2.verifyIsOPCUAValidCertificate = void 0;
    var node_opcua_crypto_1 = require_dist33();
    var node_opcua_debug_1 = require_dist24();
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    function verifyIsOPCUAValidCertificate(certificate, certificateFile, type, applicationUri) {
      const certificateInfo = (0, node_opcua_crypto_1.exploreCertificate)(certificate);
      const now = /* @__PURE__ */ new Date();
      if (certificateInfo.tbsCertificate.validity.notBefore.getTime() > now.getTime()) {
        warningLog(`[NODE-OPCUA-W02] The certificate is not active yet
notBefore       ${certificateInfo.tbsCertificate.validity.notBefore.toISOString()}
certificateFile ${certificateFile}`);
      }
      if (certificateInfo.tbsCertificate.validity.notAfter.getTime() <= now.getTime()) {
        warningLog(`[NODE-OPCUA-W03] The certificate has expired
Please regenerate a valid certificate
notAfter       = ${certificateInfo.tbsCertificate.validity.notAfter.toISOString()}
certificateFile= ${certificateFile}`);
      } else {
        const tenDays = 10 * 24 * 60 * 60 * 1e3;
        if (certificateInfo.tbsCertificate.validity.notAfter.getTime() <= now.getTime() + tenDays) {
          warningLog(`[NODE-OPCUA-W05] The certificate is about to expire in less than 10 days.
Please regenerate a valid certificate as soon as possible
notAfter       = ${certificateInfo.tbsCertificate.validity.notAfter.toISOString()}
certificateFile= ${certificateFile}
`);
        }
      }
      const uniformResourceIdentifier = certificateInfo?.tbsCertificate?.extensions?.subjectAltName?.uniformResourceIdentifier;
      if (!uniformResourceIdentifier) {
        warningLog(`[NODE-OPCUA-W14] The certificate subjectAltName uniformResourceIdentifier is missing.
Please regenerate a specific certificate with a uniformResourceIdentifier that matches your ${type} applicationUri
applicationUri  = ${applicationUri}
certificateFile = ${certificateFile}
`);
        return;
      } else if (uniformResourceIdentifier[0] !== applicationUri) {
        warningLog(`[NODE-OPCUA-W06] The certificate subjectAltName does not match the ${type} applicationUri
Please regenerate a specific certificate that matches your ${type} applicationUri
certificate subjectAltName  = ${uniformResourceIdentifier[0]}
${type} applicationUri  = ${applicationUri}
certificateFile         = ${certificateFile}
`);
      }
      const keyUsage = certificateInfo.tbsCertificate.extensions?.keyUsage;
      if (!keyUsage) {
        warningLog(`[NODE-OPCUA-W15] The certificate keyUsage is missing
certificateFile = ${certificateFile}`);
      } else {
        if (!keyUsage.digitalSignature || !keyUsage.nonRepudiation || !keyUsage.keyEncipherment || !keyUsage.dataEncipherment) {
          warningLog(`[NODE-OPCUA-W16] The certificate keyUsage must include digitalSignature, nonRepudiation, keyEncipherment and dataEncipherment.
see https://reference.opcfoundation.org/v104/Core/docs/Part6/6.2.2/
certificateFile = ${certificateFile}`);
          warningLog(`keyUsage = ${JSON.stringify(keyUsage, null, " ")}`);
        }
      }
      const extKeyUsage = certificateInfo.tbsCertificate.extensions?.extKeyUsage;
      if (!extKeyUsage) {
        warningLog(`[NODE-OPCUA-W17] The certificate extKeyUsage is missing
certificateFile = ${certificateFile}`);
      } else {
        if (!extKeyUsage.clientAuth && !extKeyUsage.serverAuth) {
          warningLog(`[NODE-OPCUA-W18] The certificate extKeyUsage must include clientAuth and/or serverAuth.
see https://reference.opcfoundation.org/v104/Core/docs/Part6/6.2.2/
certificateFile = ${certificateFile}`);
        }
      }
      const keyLengthInBits = certificateInfo.tbsCertificate.subjectPublicKeyInfo.keyLength * 8;
      if (keyLengthInBits < 1024) {
        errorLog(`[NODE-OPCUA-W19] The public key length shall be greater than or equal to 1024 bits. key length is ${keyLengthInBits}.
see https://reference.opcfoundation.org/v104/GDS/docs/7.6.3/
certificateFile = ${certificateFile}`);
      } else if (keyLengthInBits < 2048) {
        warningLog(`[NODE-OPCUA-W23] key lengths less than 2048 are considered insecure. key length is ${keyLengthInBits}
see https://reference.opcfoundation.org/v104/Core/docs/Part2/6.8/
certificateFile = ${certificateFile}`);
      }
    }
    exports2.verifyIsOPCUAValidCertificate = verifyIsOPCUAValidCertificate;
    async function performCertificateSanityCheck(secureObject, serverOrClient, certificateManager, applicationUri) {
      const certificate = secureObject.getCertificate();
      const privateKey = secureObject.getPrivateKey();
      if (!(0, node_opcua_crypto_1.publicKeyAndPrivateKeyMatches)(certificate, privateKey)) {
        errorLog("[NODE-OPCUA-E01] Configuration error : the certificate and the private key do not match !");
        errorLog("                  please check the configuration of the OPCUA Server");
        errorLog("                    privateKey= ", secureObject.privateKeyFile);
        errorLog(" certificateManager.privateKey= ", certificateManager.privateKey);
        errorLog("               certificateFile= ", secureObject.certificateFile);
        throw new Error("[NODE-OPCUA-E01] Configuration error : the certificate and the private key do not match ! please fix your configuration");
      }
      const privateKeyInfo = (0, node_opcua_crypto_1.explorePrivateKey)(privateKey);
      const keyLengthInBits = privateKeyInfo.modulus.length * 8;
      if (keyLengthInBits <= 1024) {
        warningLog(`[NODE-OPCUA-W04] The public/private key pair uses a key length which is equal or lower than 1024 bits. ( key length was ${keyLengthInBits} )
OPCUA version 1.04 requires that security key length are greater or equal to 2048 bits.
The ${serverOrClient} is operating at risk.                                             `);
      }
      const status1 = await certificateManager.trustCertificate(certificate);
      const options = {
        acceptOutdatedCertificate: false,
        acceptOutDatedIssuerCertificate: false,
        acceptPendingCertificate: false
      };
      const status2 = await certificateManager.verifyCertificate(certificate, options);
      if (status2 !== "Good") {
        warningLog("[NODE-OPCUA-W04] Warning: the certificate status is = ", status2, " file = ", secureObject.certificateFile);
      }
      verifyIsOPCUAValidCertificate(certificate, secureObject.certificateFile, serverOrClient, applicationUri);
    }
    exports2.performCertificateSanityCheck = performCertificateSanityCheck;
  }
});

// node_modules/node-opcua-client/dist/private/client_base_impl.js
var require_client_base_impl = __commonJS({
  "node_modules/node-opcua-client/dist/private/client_base_impl.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ClientBaseImpl = void 0;
    var fs_1 = __importDefault3(require("fs"));
    var path_1 = __importDefault3(require("path"));
    var async_1 = __importDefault3(require_async());
    var chalk_1 = __importDefault3(require_source());
    var global_mutex_1 = require_source8();
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_common_1 = require_dist34();
    var node_opcua_crypto_1 = require_dist33();
    var node_opcua_date_time_1 = require_dist17();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_common_2 = require_dist34();
    var node_opcua_hostname_1 = require_dist36();
    var node_opcua_secure_channel_1 = require_source7();
    var node_opcua_service_discovery_1 = require_dist48();
    var node_opcua_service_endpoints_1 = require_dist44();
    var node_opcua_service_secure_channel_1 = require_dist38();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_certificate_manager_1 = require_dist60();
    var node_opcua_service_session_1 = require_dist42();
    var client_base_1 = require_client_base();
    var verify_1 = require_verify();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var traceInternalState = false;
    var defaultConnectionStrategy = {
      initialDelay: 1e3,
      maxDelay: 20 * 1e3,
      // 20 seconds
      maxRetry: -1,
      // infinite
      randomisationFactor: 0.1
    };
    function __findEndpoint(endpointUrl, params, _callback) {
      const masterClient = this;
      debugLog("findEndpoint : endpointUrl = ", endpointUrl);
      debugLog(" params ", params);
      (0, node_opcua_assert_1.assert)(!masterClient._tmpClient);
      const callback = (err, result2) => {
        masterClient._tmpClient = void 0;
        _callback(err, result2);
      };
      const securityMode = params.securityMode;
      const securityPolicy = params.securityPolicy;
      const connectionStrategy = params.connectionStrategy;
      const options = {
        applicationName: params.applicationName,
        applicationUri: params.applicationUri,
        certificateFile: params.certificateFile,
        clientCertificateManager: params.clientCertificateManager,
        clientName: "EndpointFetcher",
        connectionStrategy: {
          maxRetry: 0,
          maxDelay: 2e3
        },
        privateKeyFile: params.privateKeyFile
      };
      const client2 = new TmpClient(options);
      masterClient._tmpClient = client2;
      let selectedEndpoint;
      const allEndpoints = [];
      const tasks = [
        (innerCallback) => {
          masterClient.listeners("backoff").forEach((handler) => client2.on("backoff", handler));
          if (doDebug) {
            client2.on("backoff", (retryCount, delay) => {
              debugLog("finding Endpoint => reconnecting ", " retry count", retryCount, " next attempt in ", delay / 1e3, "seconds");
            });
          }
          client2.connect(endpointUrl, (err) => {
            if (err) {
              err.message = "Fail to connect to server at " + endpointUrl + " to collect server's certificate (in findEndpoint) \n (err =" + err.message + ")";
              warningLog(err.message);
            }
            return innerCallback(err);
          });
        },
        (innerCallback) => {
          client2.getEndpoints((err, endpoints) => {
            if (err) {
              err.message = "error in getEndpoints \n" + err.message;
              return innerCallback(err);
            }
            if (!endpoints) {
              return innerCallback(new Error("Internal Error"));
            }
            for (const endpoint of endpoints) {
              if (endpoint.securityMode === securityMode && endpoint.securityPolicyUri === securityPolicy) {
                if (selectedEndpoint) {
                  errorLog("Warning more than one endpoint matching !", endpoint.endpointUrl, selectedEndpoint.endpointUrl);
                }
                selectedEndpoint = endpoint;
              }
            }
            innerCallback();
          });
        },
        (innerCallback) => {
          client2.disconnect(innerCallback);
        }
      ];
      async_1.default.series(tasks, (err) => {
        if (err) {
          client2.disconnect(() => {
            callback(err);
          });
          return;
        }
        if (!selectedEndpoint) {
          return callback(new Error("Cannot find an Endpoint matching  security mode: " + securityMode.toString() + " policy: " + securityPolicy.toString()));
        }
        if (doDebug) {
          debugLog(chalk_1.default.bgWhite.red("xxxxxxxxxxxxxxxxxxxxx => selected EndPoint = "), selectedEndpoint.toString());
        }
        const result2 = {
          endpoints: allEndpoints,
          selectedEndpoint
        };
        callback(null, result2);
      });
    }
    function _verify_serverCertificate(certificateManager, serverCertificate, callback) {
      certificateManager.checkCertificate(serverCertificate, (err, status2) => {
        if (err) {
          return callback(err);
        }
        if (status2 !== node_opcua_status_code_1.StatusCodes.Good) {
          if (doDebug) {
            certificateManager.verifyCertificate(serverCertificate, (err1, status1) => {
              debugLog(status1);
            });
          }
          warningLog("serverCertificate = ", (0, node_opcua_crypto_1.makeSHA1Thumbprint)(serverCertificate).toString("hex"));
          warningLog("serverCertificate = ", serverCertificate.toString("base64"));
          return callback(new Error("server Certificate verification failed with err " + status2?.toString()));
        }
        callback();
      });
    }
    var forceEndpointDiscoveryOnConnect = !!parseInt(process.env.NODEOPCUA_CLIENT_FORCE_ENDPOINT_DISCOVERY || "0", 10);
    debugLog("forceEndpointDiscoveryOnConnect = ", forceEndpointDiscoveryOnConnect);
    var ClockAdjustment = class {
      constructor() {
        debugLog("installPeriodicClockAdjustment ", node_opcua_date_time_1.periodicClockAdjustment.timerInstallationCount);
        (0, node_opcua_date_time_1.installPeriodicClockAdjustment)();
      }
      dispose() {
        (0, node_opcua_date_time_1.uninstallPeriodicClockAdjustment)();
        debugLog("uninstallPeriodicClockAdjustment ", node_opcua_date_time_1.periodicClockAdjustment.timerInstallationCount);
      }
    };
    var g_ClientCounter = 0;
    var ClientBaseImpl = class _ClientBaseImpl extends node_opcua_common_1.OPCUASecureObject {
      /**
       * total number of requests that been canceled due to timeout
       */
      get timedOutRequestCount() {
        return this._timedOutRequestCount + (this._secureChannel ? this._secureChannel.timedOutRequestCount : 0);
      }
      /**
        * total number of transactions performed by the client
      x  */
      get transactionsPerformed() {
        return this._transactionsPerformed + (this._secureChannel ? this._secureChannel.transactionsPerformed : 0);
      }
      /**
       * is true when the client has already requested the server end points.
       */
      get knowsServerEndpoint() {
        return this._serverEndpoints && this._serverEndpoints.length > 0;
      }
      /**
       * true if the client is trying to reconnect to the server after a connection break.
       */
      get isReconnecting() {
        return !!(this._secureChannel && this._secureChannel.isConnecting) || this._internalState !== "connected";
      }
      /**
       * true if the connection strategy is set to automatically try to reconnect in case of failure
       */
      get reconnectOnFailure() {
        return this.connectionStrategy.maxRetry > 0 || this.connectionStrategy.maxRetry === -1;
      }
      /**
       * total number of bytes read by the client
       */
      get bytesRead() {
        return this._byteRead + (this._secureChannel ? this._secureChannel.bytesRead : 0);
      }
      /**
       * total number of bytes written by the client
       */
      get bytesWritten() {
        return this._byteWritten + (this._secureChannel ? this._secureChannel.bytesWritten : 0);
      }
      isUnusable() {
        return this._internalState === "disconnected" || this._internalState === "disconnecting";
      }
      _setInternalState(internalState) {
        const previousState = this._internalState;
        if (doDebug || traceInternalState) {
          (traceInternalState ? warningLog : debugLog)(chalk_1.default.cyan(`  Client ${this._instanceNumber} ${this.clientName} : _internalState from    `), chalk_1.default.yellow(previousState), "to", chalk_1.default.yellow(internalState));
        }
        this._internalState = internalState;
      }
      emit(eventName, ...others) {
        if (doDebug) {
          debugLog(chalk_1.default.cyan(`  Client ${this._instanceNumber} ${this.clientName} emitting `), chalk_1.default.magentaBright(eventName));
        }
        return super.emit(eventName, ...others);
      }
      constructor(options) {
        options = options || {};
        if (!options.clientCertificateManager) {
          options.clientCertificateManager = (0, node_opcua_certificate_manager_1.getDefaultCertificateManager)("PKI");
        }
        options.privateKeyFile = options.privateKeyFile || options.clientCertificateManager.privateKey;
        options.certificateFile = options.certificateFile || path_1.default.join(options.clientCertificateManager.rootDir, "own/certs/client_certificate.pem");
        super(options);
        this._inside_repairConnection = false;
        this._instanceNumber = g_ClientCounter++;
        this._internalState = "uninitialized";
        this.applicationName = options.applicationName || "NodeOPCUA-Client";
        (0, node_opcua_assert_1.assert)(!this.applicationName.match(/^locale=/), "applicationName badly converted from LocalizedText");
        (0, node_opcua_assert_1.assert)(!this.applicationName.match(/urn:/), "applicationName should not be a URI");
        this._applicationUri = options.applicationUri || this._getBuiltApplicationUri();
        this.disconnecting = false;
        this.clientCertificateManager = options.clientCertificateManager;
        this._secureChannel = null;
        this._reconnectionIsCanceled = false;
        this.endpointUrl = "";
        this.clientName = options.clientName || "ClientSession";
        this.protocolVersion = 0;
        this._sessions = [];
        this._serverEndpoints = [];
        this.defaultSecureTokenLifetime = options.defaultSecureTokenLifetime || 6e5;
        this.tokenRenewalInterval = options.tokenRenewalInterval || 0;
        (0, node_opcua_assert_1.assert)(isFinite(this.tokenRenewalInterval) && this.tokenRenewalInterval >= 0);
        this.securityMode = (0, node_opcua_service_secure_channel_1.coerceMessageSecurityMode)(options.securityMode);
        this.securityPolicy = (0, node_opcua_secure_channel_1.coerceSecurityPolicy)(options.securityPolicy);
        this.serverCertificate = options.serverCertificate;
        this.keepSessionAlive = typeof options.keepSessionAlive === "boolean" ? options.keepSessionAlive : false;
        this.keepAliveInterval = options.keepAliveInterval;
        this._byteRead = 0;
        this._byteWritten = 0;
        this._transactionsPerformed = 0;
        this._timedOutRequestCount = 0;
        this.connectionStrategy = (0, node_opcua_secure_channel_1.coerceConnectionStrategy)(options.connectionStrategy || defaultConnectionStrategy);
        this.keepPendingSessionsOnDisconnect = options.keepPendingSessionsOnDisconnect || false;
        this.discoveryUrl = options.discoveryUrl || "";
        this._setInternalState("disconnected");
        this._transportSettings = options.transportSettings || {};
        this._transportTimeout = options.transportTimeout;
      }
      _cancel_reconnection(callback) {
        if (!this.isReconnecting) {
          warningLog("internal error: _cancel_reconnection should only be used when reconnecting is in progress");
        }
        debugLog("canceling reconnection");
        this._reconnectionIsCanceled = true;
        if (!this._secureChannel) {
          debugLog("_cancel_reconnection:  Nothing to do !");
          return callback();
        }
        this._secureChannel.abortConnection(() => {
          this._secureChannel = null;
          callback();
        });
        this.once("reconnection_canceled", () => {
        });
      }
      _recreate_secure_channel(callback) {
        debugLog("_recreate_secure_channel... while internalState is", this._internalState);
        if (!this.knowsServerEndpoint) {
          debugLog("Cannot reconnect , server endpoint is unknown");
          return callback(new Error("Cannot reconnect, server endpoint is unknown - this.knowsServerEndpoint = false"));
        }
        (0, node_opcua_assert_1.assert)(this.knowsServerEndpoint);
        this._setInternalState("reconnecting");
        this.emit("start_reconnection");
        const infiniteConnectionRetry = {
          initialDelay: this.connectionStrategy.initialDelay,
          maxDelay: this.connectionStrategy.maxDelay,
          maxRetry: -1
        };
        const _when_internal_error = (err, callback2) => {
          errorLog("INTERNAL ERROR", err.message);
          callback2(err);
        };
        const _when_reconnectionIsCanceled = (callback2) => {
          doDebug && debugLog("attempt to recreate a new secure channel : suspended because reconnection is canceled !");
          this.emit("reconnection_canceled");
          return callback2(new Error("Reconnection has been canceled - " + this.clientName));
        };
        const _failAndRetry = (err, message, callback2) => {
          debugLog("failAndRetry; ", message);
          if (this._reconnectionIsCanceled) {
            return _when_reconnectionIsCanceled(callback2);
          }
          this._destroy_secure_channel();
          warningLog("client = ", this.clientName, message, err.message);
          this.emit("reconnection_attempt_has_failed", err, message);
          setImmediate(_attempt_to_recreate_secure_channel, callback2);
        };
        const _when_connected = (callback2) => {
          this.emit("after_reconnection", null);
          (0, node_opcua_assert_1.assert)(this._secureChannel, "expecting a secureChannel here ");
          debugLog(chalk_1.default.bgWhite.red("ClientBaseImpl:  RECONNECTED                !!!"));
          this._setInternalState("reconnecting_newchannel_connected");
          return callback2();
        };
        const _attempt_to_recreate_secure_channel = (callback2) => {
          debugLog("attempt to recreate a new secure channel");
          if (this._reconnectionIsCanceled) {
            return _when_reconnectionIsCanceled(callback2);
          }
          (0, node_opcua_assert_1.assert)(!this._secureChannel, "_attempt_to_recreate_secure_channel,  expecting this._secureChannel not to exist");
          this._internal_create_secure_channel(infiniteConnectionRetry, (err) => {
            if (err) {
              if (this._secureChannel) {
                const err2 = new Error("_internal_create_secure_channel failed, expecting this._secureChannel not to exist");
                return _when_internal_error(err2, callback2);
              }
              if (err.message.match(/ECONNREFUSED|ECONNABORTED|ETIMEDOUT/)) {
                return _failAndRetry(err, "create secure channel failed with ECONNREFUSED|ECONNABORTED|ETIMEDOUT\n" + err.message, callback2);
              }
              if (err.message.match("Backoff aborted.")) {
                return _failAndRetry(err, "cannot create secure channel (backoff aborted)", callback2);
              }
              if (err.message.match("BadCertificateInvalid") || err.message.match(/socket has been disconnected by third party/)) {
                warningLog("the server certificate has changed,  we need to retrieve server certificate again: ", err.message);
                const oldServerCertificate = this.serverCertificate;
                warningLog("old server certificate ", oldServerCertificate ? (0, node_opcua_crypto_1.makeSHA1Thumbprint)(oldServerCertificate).toString("hex") : "undefined");
                return this.fetchServerCertificate(this.endpointUrl, (err1) => {
                  if (err1) {
                    return _failAndRetry(err1, "Failing to fetch new server certificate", callback2);
                  }
                  const newServerCertificate = this.serverCertificate;
                  warningLog("new server certificate ", (0, node_opcua_crypto_1.makeSHA1Thumbprint)(newServerCertificate).toString("hex"));
                  const sha1Old = (0, node_opcua_crypto_1.makeSHA1Thumbprint)(oldServerCertificate);
                  const sha1New = (0, node_opcua_crypto_1.makeSHA1Thumbprint)(newServerCertificate);
                  if (sha1Old === sha1New) {
                    warningLog("server certificate has not changed, but was expected to have changed");
                    return _failAndRetry(new Error("Server Certificate not changed"), "Failing to fetch new server certificate", callback2);
                  }
                  this._internal_create_secure_channel(infiniteConnectionRetry, (err3) => {
                    if (err3) {
                      return _failAndRetry(err3, "trying to create new channel with new certificate", callback2);
                    }
                    return _when_connected(callback2);
                  });
                });
              } else {
                return _failAndRetry(err, "cannot create secure channel", callback2);
              }
            } else {
              return _when_connected(callback2);
            }
          });
        };
        _attempt_to_recreate_secure_channel(callback);
      }
      _internal_create_secure_channel(connectionStrategy, callback) {
        (0, node_opcua_assert_1.assert)(this._secureChannel === null);
        (0, node_opcua_assert_1.assert)(typeof this.endpointUrl === "string");
        debugLog("_internal_create_secure_channel creating new ClientSecureChannelLayer _internalState =", this._internalState);
        const secureChannel = new node_opcua_secure_channel_1.ClientSecureChannelLayer({
          connectionStrategy,
          defaultSecureTokenLifetime: this.defaultSecureTokenLifetime,
          parent: this,
          securityMode: this.securityMode,
          securityPolicy: this.securityPolicy,
          serverCertificate: this.serverCertificate,
          tokenRenewalInterval: this.tokenRenewalInterval,
          transportSettings: this._transportSettings,
          transportTimeout: this._transportTimeout
        });
        secureChannel.on("backoff", (count, delay) => {
          this.emit("backoff", count, delay);
        });
        secureChannel.on("abort", () => {
          this.emit("abort");
        });
        secureChannel.protocolVersion = this.protocolVersion;
        this._secureChannel = secureChannel;
        async_1.default.series([
          // ------------------------------------------------- STEP 2 : OpenSecureChannel
          (innerCallback) => {
            debugLog("_internal_create_secure_channel before secureChannel.create");
            secureChannel.create(this.endpointUrl, (err) => {
              debugLog("_internal_create_secure_channel after secureChannel.create");
              if (!this._secureChannel) {
                debugLog("_secureChannel has been closed during the transaction !");
                (0, node_opcua_assert_1.assert)(this.disconnecting);
                return innerCallback(new Error("Secure Channel Closed"));
              }
              if (!err) {
                this._install_secure_channel_event_handlers(secureChannel);
              }
              innerCallback(err);
            });
          },
          // ------------------------------------------------- STEP 3 : GetEndpointsRequest
          (innerCallback) => {
            (0, node_opcua_assert_1.assert)(this._secureChannel !== null);
            if (!this.knowsServerEndpoint) {
              this.getEndpoints((err) => {
                if (!this._secureChannel) {
                  debugLog("_secureChannel has been closed during the transaction ! (while getEndpoints)");
                  (0, node_opcua_assert_1.assert)(this.disconnecting);
                  return innerCallback(new Error("Secure Channel Closed"));
                }
                innerCallback(err ? err : void 0);
              });
            } else {
              innerCallback();
            }
          }
        ], (err) => {
          if (err) {
            doDebug && debugLog("Inner create secure channel has failed", err.message);
            if (this._secureChannel) {
              this._secureChannel.abortConnection(() => {
                this._destroy_secure_channel();
                callback(err);
              });
            } else {
              callback(err);
            }
          } else {
            (0, node_opcua_assert_1.assert)(this._secureChannel !== null);
            callback(null, secureChannel);
          }
        });
      }
      static async createCertificate(clientCertificateManager, certificateFile, applicationName, applicationUri) {
        if (!fs_1.default.existsSync(certificateFile)) {
          const hostname2 = (0, node_opcua_hostname_1.getHostname)();
          await clientCertificateManager.createSelfSignedCertificate({
            applicationUri,
            dns: [hostname2],
            // ip: await getIpAddresses(),
            outputFile: certificateFile,
            subject: (0, node_opcua_certificate_manager_1.makeSubject)(applicationName, hostname2),
            startDate: /* @__PURE__ */ new Date(),
            validity: 365 * 10
            // 10 years
          });
        }
        if (!fs_1.default.existsSync(certificateFile)) {
          throw new Error(" cannot locate certificate file " + certificateFile);
        }
      }
      async createDefaultCertificate() {
        if (this._inCreateDefaultCertificate) {
          errorLog("Internal error : re-entrancy in createDefaultCertificate!");
        }
        this._inCreateDefaultCertificate = true;
        if (!fs_1.default.existsSync(this.certificateFile)) {
          await (0, global_mutex_1.withLock)({ fileToLock: this.certificateFile + ".mutex" }, async () => {
            if (fs_1.default.existsSync(this.certificateFile)) {
              return;
            }
            warningLog("Creating default certificate ... please wait");
            if (this.disconnecting)
              return;
            await _ClientBaseImpl.createCertificate(this.clientCertificateManager, this.certificateFile, this.applicationName, this._getBuiltApplicationUri());
            debugLog("privateKey      = ", this.privateKeyFile);
            debugLog("                = ", this.clientCertificateManager.privateKey);
            debugLog("certificateFile = ", this.certificateFile);
            const certificate = this.getCertificate();
            const privateKey = this.getPrivateKey();
          });
        }
        this._inCreateDefaultCertificate = false;
      }
      _getBuiltApplicationUri() {
        if (!this._applicationUri) {
          this._applicationUri = (0, node_opcua_common_2.makeApplicationUrn)((0, node_opcua_hostname_1.getHostname)(), this.applicationName);
        }
        return this._applicationUri;
      }
      async initializeCM() {
        if (!this.clientCertificateManager) {
          errorLog("[NODE-OPCUA-E08] initializeCM: clientCertificateManager is null\n                 This happen when you disconnected the client, to free resources.\n                 Please create a new OPCUAClient instance if you want to reconnect");
          return;
        }
        await this.clientCertificateManager.initialize();
        await this.createDefaultCertificate();
        if (!fs_1.default.existsSync(this.privateKeyFile)) {
          throw new Error(" cannot locate private key file " + this.privateKeyFile);
        }
        if (this.disconnecting)
          return;
        await this.clientCertificateManager.withLock2(async () => {
          await (0, verify_1.performCertificateSanityCheck)(this, "client", this.clientCertificateManager, this._getBuiltApplicationUri());
        });
      }
      _handleUnrecoverableConnectionFailure(err, callback) {
        debugLog(err.message);
        this.emit("connection_failed", err);
        this._setInternalState("disconnected");
        return callback(err);
      }
      _handleDisconnectionWhileConnecting(err, callback) {
        debugLog(err.message);
        this.emit("connection_failed", err);
        this._setInternalState("disconnected");
        return callback(err);
      }
      _handleSuccessfulConnection(callback) {
        debugLog(" Connected successfully  to ", this.endpointUrl);
        this.emit("connected");
        this._setInternalState("connected");
        callback();
      }
      connect(...args) {
        const endpointUrl = args[0];
        const callback = args[1];
        (0, node_opcua_assert_1.assert)(typeof callback === "function", "expecting a callback");
        if (typeof endpointUrl !== "string" || endpointUrl.length <= 0) {
          errorLog("[NODE-OPCUA-E03] OPCUAClient#connect expects a valid endpoint : " + endpointUrl);
          callback(new Error("Invalid endpoint"));
          return;
        }
        (0, node_opcua_assert_1.assert)(typeof endpointUrl === "string" && endpointUrl.length > 0);
        if (this._internalState !== "disconnected") {
          callback(new Error(`client#connect failed, as invalid internal state = ${this._internalState}`));
          return;
        }
        if (this._secureChannel !== null) {
          setImmediate(() => callback(new Error("connect already called")));
          return;
        }
        this._setInternalState("connecting");
        this.disconnecting = false;
        this.initializeCM().then(() => {
          debugLog("ClientBaseImpl#connect ", endpointUrl);
          if (this.disconnecting) {
            return this._handleDisconnectionWhileConnecting(new Error("premature disconnection 1"), callback);
          }
          if (!this.serverCertificate && (forceEndpointDiscoveryOnConnect || this.securityMode !== node_opcua_service_secure_channel_1.MessageSecurityMode.None)) {
            debugLog("Fetching certificates from endpoints");
            this.fetchServerCertificate(endpointUrl, (err, adjustedEndpointUrl) => {
              if (err) {
                return this._handleUnrecoverableConnectionFailure(err, callback);
              }
              if (this.disconnecting) {
                return this._handleDisconnectionWhileConnecting(new Error("premature disconnection 2"), callback);
              }
              if (forceEndpointDiscoveryOnConnect) {
                debugLog("connecting with adjusted endpoint : ", adjustedEndpointUrl, "  was =", endpointUrl);
                this._connectStep2(adjustedEndpointUrl, callback);
              } else {
                debugLog("connecting with endpoint : ", endpointUrl);
                this._connectStep2(endpointUrl, callback);
              }
            });
          } else {
            this._connectStep2(endpointUrl, callback);
          }
        }).catch((err) => {
          return this._handleUnrecoverableConnectionFailure(err, callback);
        });
      }
      /**
       * @private
       */
      _connectStep2(endpointUrl, callback) {
        (0, node_opcua_assert_1.assert)(this._secureChannel === null);
        this.endpointUrl = endpointUrl;
        this._clockAdjuster = this._clockAdjuster || new ClockAdjustment();
        client_base_1.OPCUAClientBase.registry.register(this);
        debugLog("__connectStep2");
        this._internal_create_secure_channel(this.connectionStrategy, (err) => {
          if (!err) {
            this._handleSuccessfulConnection(callback);
          } else {
            client_base_1.OPCUAClientBase.registry.unregister(this);
            if (this._clockAdjuster) {
              this._clockAdjuster.dispose();
              this._clockAdjuster = void 0;
            }
            debugLog(chalk_1.default.red("SecureChannel creation has failed with error :", err.message));
            if (err.message.match(/ECONNABORTED/)) {
              debugLog(chalk_1.default.yellow("- The client cannot to :" + endpointUrl + ". Connection has been aborted."));
              err = new Error("The connection has been aborted");
              this._handleUnrecoverableConnectionFailure(err, callback);
            } else if (err.message.match(/ECONNREF/)) {
              debugLog(chalk_1.default.yellow("- The client cannot to :" + endpointUrl + ". Server is not reachable."));
              err = new Error("The connection cannot be established with server " + endpointUrl + " .\nPlease check that the server is up and running or your network configuration.\nErr = (" + err.message + ")");
              this._handleUnrecoverableConnectionFailure(err, callback);
            } else if (err.message.match(/disconnecting/)) {
              this._handleDisconnectionWhileConnecting(err, callback);
            } else {
              err = new Error("The connection may have been rejected by server,\nErr = (" + err.message + ")");
              this._handleUnrecoverableConnectionFailure(err, callback);
            }
          }
        });
      }
      getClientNonce() {
        return this._secureChannel ? this._secureChannel.getClientNonce() : null;
      }
      requestReconnection() {
        if (this._secureChannel) {
          this._secureChannel.abortConnection(() => {
            errorLog("new connection requested");
          });
        }
      }
      performMessageTransaction(request, callback) {
        if (!this._secureChannel) {
          return callback(new Error("performMessageTransaction: No SecureChannel , connection may have been canceled abruptly by server"));
        }
        if (this._internalState !== "connected" && this._internalState !== "reconnecting_newchannel_connected" && this._internalState !== "connecting" && this._internalState !== "reconnecting") {
          return callback(new Error("performMessageTransaction: Invalid client state " + this._internalState + " while performing a transaction " + request.schema.name));
        }
        (0, node_opcua_assert_1.assert)(this._secureChannel);
        (0, node_opcua_assert_1.assert)(request);
        (0, node_opcua_assert_1.assert)(request.requestHeader);
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        this._secureChannel.performMessageTransaction(request, callback);
      }
      /**
       *
       * return the endpoint information matching  security mode and security policy.
       * @method findEndpoint
       */
      findEndpointForSecurity(securityMode, securityPolicy) {
        securityMode = (0, node_opcua_service_secure_channel_1.coerceMessageSecurityMode)(securityMode);
        securityPolicy = (0, node_opcua_secure_channel_1.coerceSecurityPolicy)(securityPolicy);
        (0, node_opcua_assert_1.assert)(this.knowsServerEndpoint, "Server end point are not known yet");
        return this._serverEndpoints.find((endpoint) => {
          return endpoint.securityMode === securityMode && endpoint.securityPolicyUri === securityPolicy;
        });
      }
      /**
       *
       * return the endpoint information matching the specified url , security mode and security policy.
       * @method findEndpoint
       */
      findEndpoint(endpointUrl, securityMode, securityPolicy) {
        (0, node_opcua_assert_1.assert)(this.knowsServerEndpoint, "Server end point are not known yet");
        if (!this._serverEndpoints || this._serverEndpoints.length === 0) {
          return void 0;
        }
        return this._serverEndpoints.find((endpoint) => {
          return (0, node_opcua_utils_1.matchUri)(endpoint.endpointUrl, endpointUrl) && endpoint.securityMode === securityMode && endpoint.securityPolicyUri === securityPolicy;
        });
      }
      getEndpoints(...args) {
        if (args.length === 1) {
          return this.getEndpoints({}, args[0]);
        }
        const options = args[0];
        const callback = args[1];
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        options.localeIds = options.localeIds || [];
        options.profileUris = options.profileUris || [];
        const request = new node_opcua_service_endpoints_1.GetEndpointsRequest({
          endpointUrl: options.endpointUrl || this.endpointUrl,
          localeIds: options.localeIds,
          profileUris: options.profileUris,
          requestHeader: {
            auditEntryId: null
          }
        });
        this.performMessageTransaction(request, (err, response) => {
          if (err) {
            return callback(err);
          }
          this._serverEndpoints = [];
          if (!response || !(response instanceof node_opcua_service_endpoints_1.GetEndpointsResponse)) {
            return callback(new Error("Internal Error"));
          }
          if (response && response.endpoints) {
            this._serverEndpoints = response.endpoints;
          }
          callback(null, this._serverEndpoints);
        });
      }
      /**
       * @deprecated
       */
      getEndpointsRequest(options, callback) {
        warningLog("note: ClientBaseImpl#getEndpointsRequest is deprecated, use ClientBaseImpl#getEndpoints instead");
        return this.getEndpoints(options, callback);
      }
      findServers(...args) {
        if (args.length === 1) {
          return this.findServers({}, args[0]);
        }
        const options = args[0];
        const callback = args[1];
        const request = new node_opcua_service_discovery_1.FindServersRequest({
          endpointUrl: options.endpointUrl || this.endpointUrl,
          localeIds: options.localeIds || [],
          serverUris: options.serverUris || []
        });
        this.performMessageTransaction(request, (err, response) => {
          if (err) {
            return callback(err);
          }
          if (!response || !(response instanceof node_opcua_service_discovery_1.FindServersResponse)) {
            return callback(new Error("Internal Error"));
          }
          response.servers = response.servers || [];
          callback(null, response.servers);
        });
      }
      findServersOnNetwork(...args) {
        if (args.length === 1) {
          return this.findServersOnNetwork({}, args[0]);
        }
        const options = args[0];
        const callback = args[1];
        const request = new node_opcua_service_discovery_1.FindServersOnNetworkRequest(options);
        this.performMessageTransaction(request, (err, response) => {
          if (err) {
            return callback(err);
          }
          if (!response || !(response instanceof node_opcua_service_discovery_1.FindServersOnNetworkResponse)) {
            return new Error("Internal Error");
          }
          response.servers = response.servers || [];
          callback(null, response.servers);
        });
      }
      _removeSession(session) {
        const index = this._sessions.indexOf(session);
        if (index >= 0) {
          const s = this._sessions.splice(index, 1)[0];
          (0, node_opcua_assert_1.assert)(s === session);
          (0, node_opcua_assert_1.assert)(session._client === this);
          session._client = null;
        }
        (0, node_opcua_assert_1.assert)(this._sessions.indexOf(session) === -1);
      }
      _closeSession(session, deleteSubscriptions, callback) {
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        (0, node_opcua_assert_1.assert)(typeof deleteSubscriptions === "boolean");
        if (!this._secureChannel) {
          return callback(null);
        }
        (0, node_opcua_assert_1.assert)(this._secureChannel);
        if (!this._secureChannel.isValid()) {
          return callback(null);
        }
        debugLog(chalk_1.default.bgWhite.green("_closeSession ") + this._secureChannel.channelId);
        if (this.isReconnecting) {
          errorLog("OPCUAClientImpl#_closeSession called while reconnection in progress ! What shall we do");
          return callback(null);
        }
        const request = new node_opcua_service_session_1.CloseSessionRequest({
          deleteSubscriptions
        });
        session.performMessageTransaction(request, (err, response) => {
          if (err) {
            callback(err);
          } else {
            callback(err, response);
          }
        });
      }
      closeSession(...args) {
        const session = args[0];
        const deleteSubscriptions = args[1];
        const callback = args[2];
        (0, node_opcua_assert_1.assert)(typeof deleteSubscriptions === "boolean");
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        (0, node_opcua_assert_1.assert)(session);
        (0, node_opcua_assert_1.assert)(session._client === this, "session must be attached to this");
        session._closed = true;
        this._closeSession(session, deleteSubscriptions, (err, response) => {
          session.emitCloseEvent(node_opcua_status_code_1.StatusCodes.Good);
          this._removeSession(session);
          session.dispose();
          (0, node_opcua_assert_1.assert)(this._sessions.indexOf(session) === -1);
          (0, node_opcua_assert_1.assert)(session._closed, "session must indicate it is closed");
          callback(err ? err : void 0);
        });
      }
      // eslint-disable-next-line max-statements
      disconnect(...args) {
        const callback = args[0];
        (0, node_opcua_assert_1.assert)(typeof callback === "function", "expecting a callback function here");
        if (this._internalState === "disconnected" || this._internalState === "disconnecting") {
          if (this._internalState === "disconnecting") {
            warningLog("[NODE-OPCUA-W26] OPCUAClient#disconnect called while already disconnecting");
          }
          return callback();
        }
        debugLog("disconnecting client! (will set reconnectionIsCanceled to true");
        this._reconnectionIsCanceled = true;
        this.disconnecting = true;
        if (this._tmpClient) {
          this._tmpClient.disconnect((err) => {
            this._tmpClient = void 0;
            (0, node_opcua_assert_1.assert)(!this._tmpClient);
            this.disconnect(callback);
          });
          return;
        }
        debugLog("ClientBaseImpl#disconnect", this.endpointUrl);
        if (this.isReconnecting && !this._reconnectionIsCanceled) {
          debugLog("ClientBaseImpl#disconnect called while reconnection is in progress");
          this._cancel_reconnection((err) => {
            debugLog("ClientBaseImpl#disconnect reconnection has been canceled", this.applicationName);
            (0, node_opcua_assert_1.assert)(!err, " why would this fail ?");
            this.disconnect(callback);
          });
          return;
        }
        if (this._sessions.length && !this.keepPendingSessionsOnDisconnect) {
          debugLog("warning : disconnection : closing pending sessions");
          this._close_pending_sessions(() => {
            this.disconnect(callback);
          });
          return;
        }
        debugLog("Disconnecting !");
        this._setInternalState("disconnecting");
        if (this.clientCertificateManager) {
          const tmp = this.clientCertificateManager;
          tmp.dispose();
        }
        if (this._sessions.length) {
          const tmp = [...this._sessions];
          for (const session of tmp) {
            this._removeSession(session);
          }
          this._sessions = [];
        }
        (0, node_opcua_assert_1.assert)(this._sessions.length === 0, " attempt to disconnect a client with live sessions ");
        client_base_1.OPCUAClientBase.registry.unregister(this);
        if (this._clockAdjuster) {
          this._clockAdjuster.dispose();
          this._clockAdjuster = void 0;
        }
        if (this._secureChannel) {
          let tmpChannel = this._secureChannel;
          this._secureChannel = null;
          debugLog("Closing channel");
          tmpChannel.close(() => {
            this._secureChannel = tmpChannel;
            tmpChannel = null;
            this._destroy_secure_channel();
            this._setInternalState("disconnected");
            callback();
          });
        } else {
          this._setInternalState("disconnected");
          callback();
        }
      }
      // override me !
      _on_connection_reestablished(callback) {
        callback();
      }
      toString() {
        let str = "\n";
        str += "  defaultSecureTokenLifetime.... " + this.defaultSecureTokenLifetime + "\n";
        str += "  securityMode.................. " + node_opcua_service_secure_channel_1.MessageSecurityMode[this.securityMode] + "\n";
        str += "  securityPolicy................ " + this.securityPolicy.toString() + "\n";
        str += "  certificate fingerprint....... " + (0, node_opcua_crypto_1.makeSHA1Thumbprint)(this.getCertificate()).toString("hex") + "\n";
        str += "  server certificate fingerprint " + (this.serverCertificate ? (0, node_opcua_crypto_1.makeSHA1Thumbprint)(this.serverCertificate).toString("hex") : "") + "\n";
        str += "  keepSessionAlive.............. " + this.keepSessionAlive + "\n";
        str += "  bytesRead..................... " + this.bytesRead + "\n";
        str += "  bytesWritten.................. " + this.bytesWritten + "\n";
        str += "  transactionsPerformed......... " + this.transactionsPerformed + "\n";
        str += "  timedOutRequestCount.......... " + this.timedOutRequestCount + "\n";
        str += "  connectionStrategy.\n";
        str += "        .maxRetry............... " + this.connectionStrategy.maxRetry + "\n";
        str += "        .initialDelay........... " + this.connectionStrategy.initialDelay + "\n";
        str += "        .maxDelay............... " + this.connectionStrategy.maxDelay + "\n";
        str += "        .randomisationFactor.... " + this.connectionStrategy.randomisationFactor + "\n";
        str += "  keepSessionAlive.............. " + this.keepSessionAlive + "\n";
        str += "  applicationName............... " + this.applicationName + "\n";
        str += "  applicationUri................ " + this._getBuiltApplicationUri() + "\n";
        str += "  clientName.................... " + this.clientName + "\n";
        str += "  reconnectOnFailure............ " + this.reconnectOnFailure + "\n";
        str += "  isReconnecting................ " + this.isReconnecting + "\n";
        str += "  (internal state).............. " + this._internalState + "\n";
        str += "  sessions count................ " + this.getSessions().length + "\n";
        if (this._secureChannel) {
          str += "secureChannel:\n" + this._secureChannel.toString();
        }
        return str;
      }
      getSessions() {
        return this._sessions;
      }
      getTransportSettings() {
        return this._secureChannel.getTransportSettings();
      }
      _addSession(session) {
        (0, node_opcua_assert_1.assert)(!session._client || session._client === this);
        (0, node_opcua_assert_1.assert)(this._sessions.indexOf(session) === -1, "session already added");
        session._client = this;
        this._sessions.push(session);
      }
      fetchServerCertificate(endpointUrl, callback) {
        const discoveryUrl = this.discoveryUrl.length > 0 ? this.discoveryUrl : endpointUrl;
        debugLog("OPCUAClientImpl : getting serverCertificate");
        const certificateFile = this.certificateFile;
        const privateKeyFile = this.privateKeyFile;
        const applicationName = this.applicationName;
        const applicationUri = this._applicationUri;
        const params = {
          connectionStrategy: this.connectionStrategy,
          endpointMustExist: false,
          securityMode: this.securityMode,
          securityPolicy: this.securityPolicy,
          applicationName,
          applicationUri,
          certificateFile,
          privateKeyFile,
          clientCertificateManager: this.clientCertificateManager
        };
        return __findEndpoint.call(this, discoveryUrl, params, (err, result2) => {
          if (err) {
            return callback(err);
          }
          if (!result2) {
            const err1 = new Error("internal error");
            return callback(err1);
          }
          const endpoint = result2.selectedEndpoint;
          if (!endpoint) {
            const err1 = new Error("cannot find endpoint for securityMode=" + node_opcua_service_secure_channel_1.MessageSecurityMode[this.securityMode] + " policy = " + this.securityPolicy);
            return callback(err1);
          }
          (0, node_opcua_assert_1.assert)(endpoint);
          _verify_serverCertificate(this.clientCertificateManager, endpoint.serverCertificate, (err1) => {
            if (err1) {
              warningLog("[NODE-OPCUA-W25] client's server certificate verification has failed ", err1.message);
              warningLog("                 clientCertificateManager.rootDir = ", this.clientCertificateManager.rootDir);
              const f2 = (b) => "                 " + b.toString("base64").replace(/(.{80})/g, "$1\n                 ");
              const chain = (0, node_opcua_crypto_1.split_der)(endpoint.serverCertificate);
              warningLog(`                  server certificate contains ${chain.length} elements`);
              for (let i = 0; i < chain.length; i++) {
                const c2 = chain[i];
                warningLog("certificate", i, "\n" + f2(c2));
              }
              if (chain.length > 1) {
                warningLog("                 verify also that the issuer certificate is trusted and the issuer's certificate is present in the issuer.cert folder\n                 of the client certificate manager located in ", this.clientCertificateManager.rootDir);
              } else {
                warningLog("                 verify that the server certificate is trusted or that server certificate issuer's certificate is present in the issuer folder");
              }
              return callback(err1);
            }
            this.serverCertificate = endpoint.serverCertificate;
            callback(null, endpoint.endpointUrl);
          });
        });
      }
      _accumulate_statistics() {
        if (this._secureChannel) {
          this._byteWritten += this._secureChannel.bytesWritten;
          this._byteRead += this._secureChannel.bytesRead;
          this._transactionsPerformed += this._secureChannel.transactionsPerformed;
          this._timedOutRequestCount += this._secureChannel.timedOutRequestCount;
          if (doDebug) {
            const h = `Client ${this._instanceNumber} ${this.clientName}`;
            debugLog(chalk_1.default.cyan(`${h} byteWritten          = `), this._byteWritten);
            debugLog(chalk_1.default.cyan(`${h} byteRead             = `), this._byteRead);
            debugLog(chalk_1.default.cyan(`${h} transactions         = `), this._transactionsPerformed);
            debugLog(chalk_1.default.cyan(`${h} timedOutRequestCount = `), this._timedOutRequestCount);
          }
        }
      }
      _destroy_secure_channel() {
        if (this._secureChannel) {
          if (doDebug) {
            debugLog(" DESTROYING SECURE CHANNEL (isTransactionInProgress ?", this._secureChannel.isTransactionInProgress(), ")");
          }
          this._accumulate_statistics();
          const secureChannel = this._secureChannel;
          this._secureChannel = null;
          secureChannel.dispose();
          secureChannel.removeAllListeners();
        }
      }
      _close_pending_sessions(callback) {
        const sessions = [...this._sessions];
        async_1.default.map(sessions, (session, next) => {
          (0, node_opcua_assert_1.assert)(session._client === this);
          let _next_already_call = false;
          session.close((err) => {
            if (_next_already_call) {
              return;
            }
            _next_already_call = true;
            if (err) {
              const msg = session.authenticationToken ? session.authenticationToken.toString() : "";
              debugLog(" failing to close session " + msg);
            }
            next();
          });
        }, (err) => {
          if (this._sessions.length > 0) {
            debugLog(this._sessions.map((s) => s.authenticationToken ? s.authenticationToken.toString() : "").join(" "));
          }
          (0, node_opcua_assert_1.assert)(this._sessions.length === 0, " failed to disconnect exiting sessions ");
          callback(err);
        });
      }
      _install_secure_channel_event_handlers(secureChannel) {
        (0, node_opcua_assert_1.assert)(this instanceof _ClientBaseImpl);
        secureChannel.on("send_chunk", (chunk) => {
          this.emit("send_chunk", chunk);
        });
        secureChannel.on("receive_chunk", (chunk) => {
          this.emit("receive_chunk", chunk);
        });
        secureChannel.on("send_request", (message) => {
          this.emit("send_request", message);
        });
        secureChannel.on("receive_response", (message) => {
          this.emit("receive_response", message);
        });
        secureChannel.on("lifetime_75", (token) => {
          debugLog("SecureChannel Security Token ", token.tokenId, "live time was =", token.revisedLifetime, " is about to expired , it's time to request a new token");
          this.emit("lifetime_75", token, secureChannel);
        });
        secureChannel.on("security_token_renewed", () => {
          this.emit("security_token_renewed", secureChannel);
        });
        secureChannel.on("close", (err) => {
          if (err) {
            this._setInternalState("panic");
          }
          debugLog(chalk_1.default.yellow.bold(" ClientBaseImpl emitting close"), err?.message);
          this._destroy_secure_channel();
          if (!err || !this.reconnectOnFailure) {
            if (err) {
              this.emit("connection_lost", err?.message);
            }
            this.emit("close", err);
          } else {
            if (this.reconnectOnFailure && this._internalState !== "reconnecting") {
              debugLog(" ClientBaseImpl emitting connection_lost");
              this.emit("connection_lost", err?.message);
              this._repairConnection();
            }
          }
        });
        secureChannel.on("timed_out_request", (request) => {
          this.emit("timed_out_request", request);
        });
      }
      _repairConnection() {
        if (this._inside_repairConnection) {
          errorLog("_repairConnection already in progress ", this._internalState);
          return;
        }
        this._inside_repairConnection = true;
        debugLog("recreating new secure channel ", this._internalState);
        this._recreate_secure_channel((err1) => {
          debugLog("secureChannel#on(close) => _recreate_secure_channel returns ", err1 ? err1.message : "OK");
          if (err1) {
            debugLog("_recreate_secure_channel has failed: err = ", err1.message);
            this.emit("close", err1);
            this._setInternalState("disconnected");
            this._inside_repairConnection = false;
            return;
          } else {
            this._finalReconnectionStep((err2) => {
              if (err2) {
                if (doDebug) {
                  debugLog("connection_reestablished has failed");
                  debugLog("err= ", err2.message);
                }
                debugLog("Disconnected following reconnection failure", err2.message);
                debugLog(`I will retry OPCUA client reconnection in ${client_base_1.OPCUAClientBase.retryDelay / 1e3} seconds`);
                this._inside_repairConnection = false;
                this._destroy_secure_channel();
                setTimeout(() => this._repairConnection(), client_base_1.OPCUAClientBase.retryDelay);
                return;
              } else {
                this._inside_repairConnection = false;
                this._setInternalState("connected");
                this.emit("connection_reestablished");
              }
            });
          }
        });
      }
      _finalReconnectionStep(callback) {
        if (this._on_connection_reestablished) {
          (0, node_opcua_assert_1.assert)(typeof this._on_connection_reestablished === "function");
          this._on_connection_reestablished((err2) => {
            callback(err2);
          });
        } else {
          callback();
        }
      }
      /**
       *
       * @internal
       * @private
       */
      __createSession_step2(session, callback) {
        throw new Error("Please override");
      }
      _activateSession(session, userIdentity, callback) {
        throw new Error("Please override");
      }
    };
    exports2.ClientBaseImpl = ClientBaseImpl;
    var TmpClient = class extends ClientBaseImpl {
      constructor(options) {
        options.clientName = (options.clientName || "") + "_TmpClient";
        super(options);
      }
      connect(endpoint, callback) {
        debugLog("connecting to TmpClient");
        if (this._internalState !== "disconnected") {
          callback(new Error("TmpClient#connect: invalid internal state = " + this._internalState));
          return;
        }
        if (this.disconnecting) {
          return this._handleUnrecoverableConnectionFailure(new Error("premature disconnection 3"), callback);
        }
        this._setInternalState("connecting");
        this._connectStep2(endpoint, (err) => {
          if (this.disconnecting) {
            return this._handleUnrecoverableConnectionFailure(new Error("premature disconnection 4"), callback);
          }
          callback(err);
        });
      }
    };
    var thenify = require_thenify();
    ClientBaseImpl.prototype.connect = thenify.withCallback(ClientBaseImpl.prototype.connect);
    ClientBaseImpl.prototype.disconnect = thenify.withCallback(ClientBaseImpl.prototype.disconnect);
    ClientBaseImpl.prototype.getEndpoints = thenify.withCallback(ClientBaseImpl.prototype.getEndpoints);
    ClientBaseImpl.prototype.findServers = thenify.withCallback(ClientBaseImpl.prototype.findServers);
    ClientBaseImpl.prototype.findServersOnNetwork = thenify.withCallback(ClientBaseImpl.prototype.findServersOnNetwork);
    client_base_1.OPCUAClientBase.create = (options) => {
      return new ClientBaseImpl(options);
    };
  }
});

// node_modules/node-opcua-client/dist/client_session_keepalive_manager.js
var require_client_session_keepalive_manager = __commonJS({
  "node_modules/node-opcua-client/dist/client_session_keepalive_manager.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ClientSessionKeepAliveManager = void 0;
    var events_1 = require("events");
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_common_1 = require_dist34();
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_secure_channel_1 = require_source7();
    var serverStatusStateNodeId = (0, node_opcua_nodeid_1.coerceNodeId)(node_opcua_constants_1.VariableIds.Server_ServerStatus_State);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var ClientSessionKeepAliveManager = class extends events_1.EventEmitter {
      constructor(session) {
        super();
        this.transactionInProgress = false;
        this.count = 0;
        this.session = session;
        this.timerId = void 0;
        this.pingTimeout = 0;
        this.checkInterval = 0;
        this.count = 0;
      }
      start(keepAliveInterval) {
        (0, node_opcua_assert_1.assert)(!this.timerId);
        if (this.session.timeout < 600) {
          warningLog(`[NODE-OPCUA-W13] ClientSessionKeepAliveManager detected that the session timeout (${this.session.timeout} ms) is really too small: please adjust it to a greater value ( at least 1000))`);
        }
        if (this.session.timeout < 100) {
          throw new Error(`ClientSessionKeepAliveManager detected that the session timeout (${this.session.timeout} ms) is really too small: please adjust it to a greater value ( at least 1000))`);
        }
        const selectedCheckInterval = keepAliveInterval || Math.min(Math.floor(Math.min(this.session.timeout * 2 / 3, 2e4)), node_opcua_secure_channel_1.ClientSecureChannelLayer.defaultTransportTimeout);
        this.checkInterval = selectedCheckInterval;
        this.pingTimeout = Math.floor(Math.min(Math.max(50, selectedCheckInterval / 2), 2e4));
        this.timerId = setTimeout(() => this.ping_server(), this.pingTimeout);
      }
      stop() {
        if (this.timerId) {
          debugLog("ClientSessionKeepAliveManager#stop");
          clearTimeout(this.timerId);
          this.timerId = void 0;
        } else {
          debugLog("warning ClientSessionKeepAliveManager#stop ignore (already stopped)");
        }
      }
      ping_server() {
        this._ping_server().then((delta) => {
          if (!this.session || this.session.hasBeenClosed()) {
            return;
          }
          if (this.timerId) {
            const timeout = Math.max(1, this.checkInterval - delta);
            this.timerId = setTimeout(() => this.ping_server(), timeout);
          }
        });
      }
      /**
       * @method ping_server
       * @internal
       * when a session is opened on a server, the client shall send request on a regular basis otherwise the server
       * session object might time out.
       * start_ping make sure that ping_server is called on a regular basis to prevent session to timeout.
       *
       * @param callback
       */
      async _ping_server() {
        const session = this.session;
        if (!session || session.isReconnecting) {
          debugLog("ClientSessionKeepAliveManager#ping_server => no session available");
          return 0;
        }
        if (!this.timerId) {
          return 0;
        }
        const now = Date.now();
        const timeSinceLastServerContact = now - session.lastResponseReceivedTime.getTime();
        if (timeSinceLastServerContact < this.pingTimeout) {
          debugLog("ClientSessionKeepAliveManager#ping_server skipped because last communication with server was not that long ago ping timeout=", Math.round(this.pingTimeout), "timeSinceLastServerContact  = ", timeSinceLastServerContact);
          return timeSinceLastServerContact - this.pingTimeout;
        }
        if (session.isReconnecting) {
          debugLog("ClientSessionKeepAliveManager#ping_server skipped because client is reconnecting");
          return 0;
        }
        if (session.hasBeenClosed()) {
          debugLog("ClientSessionKeepAliveManager#ping_server skipped because client is reconnecting");
          return 0;
        }
        debugLog("ClientSessionKeepAliveManager#ping_server timeSinceLastServerContact=", timeSinceLastServerContact, "timeout", this.session.timeout);
        if (this.transactionInProgress) {
          return 0;
        }
        this.transactionInProgress = true;
        return new Promise((resolve2) => {
          session.read({
            nodeId: serverStatusStateNodeId,
            attributeId: node_opcua_basic_types_1.AttributeIds.Value
          }, (err, dataValue) => {
            this.transactionInProgress = false;
            if (err || !dataValue || !dataValue.value) {
              if (err) {
                warningLog(chalk_1.default.cyan(" warning : ClientSessionKeepAliveManager#ping_server "), chalk_1.default.yellow(err.message));
              }
              this.emit("failure");
              resolve2(0);
              return;
            }
            if (dataValue.statusCode.isGood()) {
              const newState = dataValue.value.value;
              if (newState !== this.lastKnownState && this.lastKnownState) {
                warningLog("ClientSessionKeepAliveManager#Server state has changed = ", node_opcua_common_1.ServerState[newState], " was ", node_opcua_common_1.ServerState[this.lastKnownState]);
              }
              this.lastKnownState = newState;
              this.count++;
            }
            debugLog("emit keepalive");
            this.emit("keepalive", this.lastKnownState, this.count);
            resolve2(0);
          });
        });
      }
    };
    exports2.ClientSessionKeepAliveManager = ClientSessionKeepAliveManager;
  }
});

// node_modules/node-opcua-client/dist/private/client_publish_engine.js
var require_client_publish_engine = __commonJS({
  "node_modules/node-opcua-client/dist/private/client_publish_engine.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ClientSidePublishEngine = void 0;
    var util_1 = require("util");
    var async_1 = __importDefault3(require_async());
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_service_subscription_1 = require_dist45();
    var node_opcua_status_code_1 = require_dist22();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var ClientSidePublishEngine = class _ClientSidePublishEngine {
      constructor(session) {
        this.session = session;
        this.subscriptionAcknowledgements = [];
        this.subscriptionMap = {};
        this.timeoutHint = 1e4;
        this.activeSubscriptionCount = 0;
        this.nbPendingPublishRequests = 0;
        this.nbMaxPublishRequestsAcceptedByServer = 1e3;
        this.isSuspended = false;
        (0, node_opcua_assert_1.assert)(this.session, "Session must exist");
      }
      /**
       * the number of active subscriptions managed by this publish engine.
       * @property subscriptionCount
       * @type {Number}
       */
      get subscriptionCount() {
        return Object.keys(this.subscriptionMap).length;
      }
      suspend(suspendedState) {
        if (this.isSuspended === suspendedState) {
          return;
        }
        this.isSuspended = suspendedState;
        if (!this.isSuspended) {
          this.replenish_publish_request_queue();
        }
      }
      acknowledge_notification(subscriptionId, sequenceNumber) {
        this.subscriptionAcknowledgements.push({ subscriptionId, sequenceNumber });
      }
      cleanup_acknowledgment_for_subscription(subscriptionId) {
        this.subscriptionAcknowledgements = this.subscriptionAcknowledgements.filter((a) => a.subscriptionId !== subscriptionId);
      }
      /**
       * @method send_publish_request
       */
      send_publish_request() {
        if (this.isSuspended) {
          return;
        }
        if (this.nbPendingPublishRequests >= this.nbMaxPublishRequestsAcceptedByServer) {
          return;
        }
        const session = this.session;
        if (session && !session.isChannelValid()) {
          setTimeout(() => {
            if (this.subscriptionCount) {
              this.send_publish_request();
            }
          }, 100);
        } else {
          setImmediate(() => {
            if (!this.session || this.isSuspended) {
              return;
            }
            this.internalSendPublishRequest();
          });
        }
      }
      terminate() {
        debugLog("Terminated ClientPublishEngine ");
        this.session = null;
      }
      registerSubscription(subscription) {
        debugLog("ClientSidePublishEngine#registerSubscription ", subscription.subscriptionId);
        const _subscription = subscription;
        (0, node_opcua_assert_1.assert)(arguments.length === 1);
        (0, node_opcua_assert_1.assert)(isFinite(subscription.subscriptionId));
        (0, node_opcua_assert_1.assert)(!Object.prototype.hasOwnProperty.call(this.subscriptionMap, subscription.subscriptionId));
        (0, node_opcua_assert_1.assert)(typeof _subscription.onNotificationMessage === "function");
        (0, node_opcua_assert_1.assert)(isFinite(subscription.timeoutHint));
        this.activeSubscriptionCount += 1;
        this.subscriptionMap[subscription.subscriptionId] = _subscription;
        this.timeoutHint = Math.min(Math.max(this.timeoutHint, subscription.timeoutHint), 134217727);
        debugLog("                       setting timeoutHint = ", this.timeoutHint, subscription.timeoutHint);
        this.replenish_publish_request_queue();
      }
      replenish_publish_request_queue() {
        this.send_publish_request();
        for (let i = 0; i < _ClientSidePublishEngine.publishRequestCountInPipeline - 1; i++) {
          this.send_publish_request();
        }
      }
      /**
       * @method unregisterSubscription
       *
       * @param subscriptionId
       */
      unregisterSubscription(subscriptionId) {
        debugLog("ClientSidePublishEngine#unregisterSubscription ", subscriptionId);
        (0, node_opcua_assert_1.assert)(isFinite(subscriptionId) && subscriptionId > 0);
        this.activeSubscriptionCount -= 1;
        if (Object.prototype.hasOwnProperty.call(this.subscriptionMap, subscriptionId)) {
          delete this.subscriptionMap[subscriptionId];
        } else {
          debugLog("ClientSidePublishEngine#unregisterSubscription cannot find subscription  ", subscriptionId);
        }
      }
      getSubscriptionIds() {
        return Object.keys(this.subscriptionMap).map((a) => parseInt(a, 10));
      }
      /***
       * get the client subscription from Id
       */
      getSubscription(subscriptionId) {
        (0, node_opcua_assert_1.assert)(isFinite(subscriptionId) && subscriptionId > 0);
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(this.subscriptionMap, subscriptionId));
        return this.subscriptionMap[subscriptionId];
      }
      hasSubscription(subscriptionId) {
        (0, node_opcua_assert_1.assert)(isFinite(subscriptionId) && subscriptionId > 0);
        return Object.prototype.hasOwnProperty.call(this.subscriptionMap, subscriptionId);
      }
      republish(callback) {
        const repairSubscription = (subscription, subscriptionId, innerCallback) => {
          subscriptionId = parseInt(subscriptionId, 10);
          this.__repairSubscription(subscription, subscriptionId, innerCallback);
        };
        async_1.default.forEachOf(this.subscriptionMap, repairSubscription, callback);
      }
      internalSendPublishRequest() {
        (0, node_opcua_assert_1.assert)(this.session, "ClientSidePublishEngine terminated ?");
        this.nbPendingPublishRequests += 1;
        debugLog(chalk_1.default.yellow("sending publish request "), this.nbPendingPublishRequests);
        const subscriptionAcknowledgements = this.subscriptionAcknowledgements;
        this.subscriptionAcknowledgements = [];
        (0, node_opcua_assert_1.assert)(this.nbPendingPublishRequests > 0);
        const calculatedTimeout = Math.min(2147483647, this.nbPendingPublishRequests * this.timeoutHint);
        const publishRequest = new node_opcua_service_subscription_1.PublishRequest({
          requestHeader: { timeoutHint: calculatedTimeout },
          // see note
          subscriptionAcknowledgements
        });
        let active = true;
        const session = this.session;
        session.publish(publishRequest, (err, response) => {
          this.nbPendingPublishRequests -= 1;
          if (err) {
            debugLog(chalk_1.default.cyan("ClientSidePublishEngine.prototype.internalSendPublishRequest callback : "), chalk_1.default.yellow(err.message));
            debugLog("'" + err.message + "'");
            if (err.message.match("not connected")) {
              debugLog(chalk_1.default.bgWhite.red(" WARNING :  CLIENT IS NOT CONNECTED : MAY BE RECONNECTION IS IN PROGRESS"));
              debugLog("this.activeSubscriptionCount =", this.activeSubscriptionCount);
              active = false;
            }
            if (err.message.match(/BadNoSubscription/) && this.activeSubscriptionCount >= 1) {
              debugLog(chalk_1.default.bgWhite.red(" WARNING :   SERVER TELLS THAT IT HAS NO SUBSCRIPTION , BUT CLIENT DISAGREE"));
              debugLog("this.activeSubscriptionCount =", this.activeSubscriptionCount);
              active = false;
            }
            if (err.message.match(/BadSessionClosed|BadSessionIdInvalid/)) {
              debugLog(chalk_1.default.bgWhite.red(" WARNING : SERVER TELLS THAT THE SESSION HAS CLOSED ..."));
              debugLog("   the ClientSidePublishEngine shall now be disabled, as server will reject any further request");
              active = false;
            }
            if (err.message.match(/BadTooManyPublishRequests/)) {
              this.nbMaxPublishRequestsAcceptedByServer = Math.min(this.nbPendingPublishRequests, this.nbMaxPublishRequestsAcceptedByServer);
              active = false;
              warningLog(chalk_1.default.bgWhite.red(" WARNING : SERVER TELLS THAT TOO MANY PUBLISH REQUEST HAS BEEN SEND ..."));
              warningLog(" On our side nbPendingPublishRequests = ", this.nbPendingPublishRequests);
              warningLog(" => nbMaxPublishRequestsAcceptedByServer =", this.nbMaxPublishRequestsAcceptedByServer);
            }
          } else {
            if (doDebug) {
              debugLog(chalk_1.default.cyan("ClientSidePublishEngine.prototype.internalSendPublishRequest callback "));
            }
            this._receive_publish_response(response);
          }
          if (!this.isSuspended && active && this.activeSubscriptionCount > 0) {
            if (err && err.message.match(/Connection Break/)) {
            } else {
              this.send_publish_request();
            }
          }
        });
      }
      _receive_publish_response(response) {
        debugLog(chalk_1.default.yellow("receive publish response"));
        const subscriptionId = response.subscriptionId;
        const notificationMessage = response.notificationMessage;
        notificationMessage.notificationData = notificationMessage.notificationData || [];
        if (notificationMessage.notificationData.length !== 0) {
          this.acknowledge_notification(subscriptionId, notificationMessage.sequenceNumber);
        }
        const subscription = this.subscriptionMap[subscriptionId];
        if (subscription && this.session !== null) {
          try {
            subscription.onNotificationMessage(notificationMessage);
          } catch (err) {
            if (doDebug) {
              debugLog(err);
              debugLog("Exception in onNotificationMessage");
            }
          }
        } else {
          debugLog(" ignoring notificationMessage", notificationMessage, " for subscription", subscriptionId);
          debugLog(" because there is no subscription.");
          debugLog(" or because there is no session for the subscription (session terminated ?).");
        }
      }
      _republish(subscription, subscriptionId, callback) {
        (0, node_opcua_assert_1.assert)(subscription.subscriptionId === +subscriptionId);
        let isDone = false;
        const session = this.session;
        const sendRepublishFunc = (callback2) => {
          (0, node_opcua_assert_1.assert)(isFinite(subscription.lastSequenceNumber) && subscription.lastSequenceNumber + 1 >= 0);
          const request = new node_opcua_service_subscription_1.RepublishRequest({
            retransmitSequenceNumber: subscription.lastSequenceNumber + 1,
            subscriptionId: subscription.subscriptionId
          });
          if (doDebug) {
            debugLog(chalk_1.default.bgCyan.yellow.bold(" republish Request for subscription"), request.subscriptionId, " retransmitSequenceNumber=", request.retransmitSequenceNumber);
          }
          if (!session || session._closeEventHasBeenEmitted) {
            debugLog("ClientPublishEngine#_republish aborted ");
            isDone = true;
            return callback2();
          }
          session.republish(request, (err, response) => {
            const statusCode = err ? node_opcua_status_code_1.StatusCodes.Bad : response.responseHeader.serviceResult;
            if (!err && (statusCode.equals(node_opcua_status_code_1.StatusCodes.Good) || statusCode.equals(node_opcua_status_code_1.StatusCodes.BadMessageNotAvailable))) {
              if (statusCode.equals(node_opcua_status_code_1.StatusCodes.Good)) {
                subscription.onNotificationMessage(response.notificationMessage);
              }
            } else {
              if (!err) {
                err = new Error(response.responseHeader.serviceResult.toString());
              }
              debugLog(" _send_republish ends with ", err.message);
              isDone = true;
            }
            callback2(err ? err : void 0);
          });
        };
        setImmediate(() => {
          (0, node_opcua_assert_1.assert)(typeof callback === "function");
          async_1.default.whilst(
            (cb) => cb(null, !isDone),
            sendRepublishFunc,
            (err) => {
              debugLog("nbPendingPublishRequest = ", this.nbPendingPublishRequests);
              debugLog(" _republish ends with ", err ? err.message : "null");
              callback(err);
            }
            // Wait for @type/async bug to be fixed !
          );
        });
      }
      __repairSubscription(subscription, subscriptionId, callback) {
        debugLog("__repairSubscription  for SubscriptionId ", subscriptionId);
        this._republish(subscription, subscriptionId, (err) => {
          (0, node_opcua_assert_1.assert)(!err || util_1.types.isNativeError(err));
          debugLog("__repairSubscription--------------------- err =", err ? err.message : null);
          if (err && err.message.match(/BadSessionInvalid/)) {
            return callback(err);
          }
          if (err && err.message.match(/SubscriptionIdInvalid/)) {
            debugLog(chalk_1.default.bgWhite.red("_republish failed  subscriptionId is not valid anymore on server side."));
            const subscriptionI = subscription;
            return subscriptionI.recreateSubscriptionAndMonitoredItem(callback);
          }
          callback();
        });
      }
    };
    exports2.ClientSidePublishEngine = ClientSidePublishEngine;
    ClientSidePublishEngine.publishRequestCountInPipeline = 5;
  }
});

// node_modules/node-opcua-client/dist/client_subscription.js
var require_client_subscription = __commonJS({
  "node_modules/node-opcua-client/dist/client_subscription.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ClientSubscription = void 0;
    var ClientSubscription = class {
      static create(clientSession, options) {
        throw new Error("Not Implemented");
      }
    };
    exports2.ClientSubscription = ClientSubscription;
    ClientSubscription.ignoreNextWarning = false;
  }
});

// node_modules/node-opcua-client/dist/client_monitored_item_toolbox.js
var require_client_monitored_item_toolbox = __commonJS({
  "node_modules/node-opcua-client/dist/client_monitored_item_toolbox.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ClientMonitoredItemToolbox = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_service_subscription_1 = require_dist45();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var ClientMonitoredItemToolbox = class {
      static _toolbox_monitor(subscription, timestampsToReturn, monitoredItems, done) {
        (0, node_opcua_assert_1.assert)(typeof done === "function");
        const itemsToCreate = [];
        for (const monitoredItem of monitoredItems) {
          const monitoredItemI = monitoredItem;
          const itemToCreate = monitoredItemI._prepare_for_monitoring();
          if (typeof itemToCreate.error === "string") {
            return done(new Error(itemToCreate.error));
          }
          itemsToCreate.push(itemToCreate);
        }
        const createMonitorItemsRequest = new node_opcua_service_subscription_1.CreateMonitoredItemsRequest({
          itemsToCreate,
          subscriptionId: subscription.subscriptionId,
          timestampsToReturn
        });
        for (let i = 0; i < monitoredItems.length; i++) {
          const monitoredItem = monitoredItems[i];
          monitoredItem._before_create();
        }
        const session = subscription.session;
        (0, node_opcua_assert_1.assert)(session, "expecting a valid session attached to the subscription ");
        session.createMonitoredItems(createMonitorItemsRequest, (err, response) => {
          if (err) {
            debugLog(chalk_1.default.red("ClientMonitoredItemBase#_toolbox_monitor:  ERROR in createMonitoredItems ", err.message));
          } else {
            if (!response) {
              return done(new Error("Internal Error"));
            }
            response.results = response.results || [];
            for (let i = 0; i < response.results.length; i++) {
              const monitoredItemResult = response.results[i];
              const monitoredItem = monitoredItems[i];
              monitoredItem._after_create(monitoredItemResult);
            }
          }
          done(err ? err : void 0);
        });
      }
      static _toolbox_modify(subscription, monitoredItems, parameters, timestampsToReturn, callback) {
        (0, node_opcua_assert_1.assert)(callback === void 0 || typeof callback === "function");
        const itemsToModify = monitoredItems.map((monitoredItem) => {
          const clientHandle = monitoredItem.monitoringParameters.clientHandle;
          (0, node_opcua_assert_1.assert)(clientHandle !== 4294967295);
          return new node_opcua_service_subscription_1.MonitoredItemModifyRequest({
            monitoredItemId: monitoredItem.monitoredItemId,
            requestedParameters: {
              ...parameters,
              clientHandle
            }
          });
        });
        const modifyMonitoredItemsRequest = new node_opcua_service_subscription_1.ModifyMonitoredItemsRequest({
          itemsToModify,
          subscriptionId: subscription.subscriptionId,
          timestampsToReturn
        });
        const session = subscription.session;
        (0, node_opcua_assert_1.assert)(session, "expecting a valid session attached to the subscription ");
        session.modifyMonitoredItems(modifyMonitoredItemsRequest, (err, response) => {
          if (err) {
            return callback(err);
          }
          if (!response || !(response instanceof node_opcua_service_subscription_1.ModifyMonitoredItemsResponse)) {
            return callback(new Error("internal error"));
          }
          response.results = response.results || [];
          (0, node_opcua_assert_1.assert)(response.results.length === monitoredItems.length);
          const res = response.results[0];
          if (response.results.length === 1 && res.statusCode.isNotGood()) {
            return callback(new Error("Error" + res.statusCode.toString()));
          }
          callback(null, response.results);
        });
      }
      static _toolbox_setMonitoringMode(subscription, monitoredItems, monitoringMode, callback) {
        const monitoredItemIds = monitoredItems.map((monitoredItem) => monitoredItem.monitoredItemId);
        const setMonitoringModeRequest = {
          monitoredItemIds,
          monitoringMode,
          subscriptionId: subscription.subscriptionId
        };
        const session = subscription.session;
        (0, node_opcua_assert_1.assert)(session, "expecting a valid session attached to the subscription ");
        session.setMonitoringMode(setMonitoringModeRequest, (err, response) => {
          if (err) {
            return callback(err);
          }
          monitoredItems.forEach((monitoredItem) => {
            monitoredItem.monitoringMode = monitoringMode;
          });
          response = response;
          response.results = response.results || [];
          callback(null, response.results);
        });
      }
    };
    exports2.ClientMonitoredItemToolbox = ClientMonitoredItemToolbox;
  }
});

// node_modules/node-opcua-client/dist/client_monitored_item_group.js
var require_client_monitored_item_group = __commonJS({
  "node_modules/node-opcua-client/dist/client_monitored_item_group.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ClientMonitoredItemGroup = void 0;
    var ClientMonitoredItemGroup = class {
      static create(subscription, itemsToMonitor, monitoringParameters, timestampsToReturn) {
        throw new Error("Not implemented");
      }
    };
    exports2.ClientMonitoredItemGroup = ClientMonitoredItemGroup;
  }
});

// node_modules/node-opcua-service-filter/dist/check_event_clause.js
var require_check_event_clause = __commonJS({
  "node_modules/node-opcua-service-filter/dist/check_event_clause.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.checkSelectClauses = exports2.checkSelectClause = void 0;
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_service_translate_browse_path_1 = require_dist49();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_debug_1 = require_dist24();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    function checkSelectClause(parentNode, selectClause) {
      const addressSpace = parentNode.addressSpace;
      if (selectClause.typeDefinitionId.isEmpty()) {
        return node_opcua_status_code_1.StatusCodes.Good;
      }
      const eventTypeNode = addressSpace.findEventType(selectClause.typeDefinitionId);
      if (!eventTypeNode || !(eventTypeNode.nodeClass === node_opcua_data_model_1.NodeClass.ObjectType)) {
        if (eventTypeNode) {
          debugLog(" checkSelectClause", eventTypeNode.toString());
        }
      }
      if (eventTypeNode.nodeClass !== node_opcua_data_model_1.NodeClass.ObjectType) {
        return node_opcua_status_code_1.StatusCodes.BadTypeMismatch;
      }
      const browsePath = (0, node_opcua_service_translate_browse_path_1.constructBrowsePathFromQualifiedName)(eventTypeNode, selectClause.browsePath);
      const browsePathResult = addressSpace.browsePath(browsePath);
      return browsePathResult.statusCode;
    }
    exports2.checkSelectClause = checkSelectClause;
    function checkSelectClauses(eventTypeNode, selectClauses) {
      return selectClauses.map(checkSelectClause.bind(null, eventTypeNode));
    }
    exports2.checkSelectClauses = checkSelectClauses;
  }
});

// node_modules/node-opcua-service-filter/dist/resolve_operand.js
var require_resolve_operand = __commonJS({
  "node_modules/node-opcua-service-filter/dist/resolve_operand.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.resolveOperand = void 0;
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_service_translate_browse_path_1 = require_dist49();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_variant_1 = require_dist28();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)("FILTER");
    var debugLog = (0, node_opcua_debug_1.make_debugLog)("FILTER");
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)("FILTER");
    function resolveOperand(context, operand) {
      if (operand instanceof node_opcua_types_1.SimpleAttributeOperand) {
        const browsePath = (0, node_opcua_service_translate_browse_path_1.constructBrowsePathFromQualifiedName)({ nodeId: context.eventSource }, operand.browsePath);
        const target = context.browsePath(browsePath);
        if (!target) {
          return new node_opcua_variant_1.Variant({ dataType: node_opcua_variant_1.DataType.Null });
        }
        const nodeClass = context.getNodeClass(target);
        if (nodeClass !== node_opcua_data_model_1.NodeClass.Variable) {
          doDebug && debugLog("resolveOperand: cannot find variable here but got nodeClass", node_opcua_data_model_1.NodeClass[nodeClass], browsePath.toString());
          return new node_opcua_variant_1.Variant({ dataType: node_opcua_variant_1.DataType.StatusCode, value: node_opcua_status_code_1.StatusCodes.BadNodeClassInvalid });
        }
        const value = context.readNodeValue(target);
        return value;
      } else {
        if (!(operand instanceof node_opcua_types_1.AttributeOperand)) {
          throw new Error("expecting an AttributeOperand");
        }
        warningLog("AttributeOperand is not yet implemented");
        return new node_opcua_variant_1.Variant({ dataType: node_opcua_variant_1.DataType.Null });
      }
    }
    exports2.resolveOperand = resolveOperand;
  }
});

// node_modules/node-opcua-service-filter/dist/check_where_clause.js
var require_check_where_clause = __commonJS({
  "node_modules/node-opcua-service-filter/dist/check_where_clause.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.checkFilter = void 0;
    var node_opcua_types_1 = require_dist32();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_debug_1 = require_dist24();
    var resolve_operand_1 = require_resolve_operand();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)("Filter");
    function _coerceToBoolean(value) {
      if (value instanceof node_opcua_variant_1.Variant) {
        return _coerceToBoolean(value.value);
      }
      return !!value;
    }
    function _coerceToNumber(value) {
      if (value instanceof node_opcua_variant_1.Variant) {
        return _coerceToNumber(value.value);
      }
      if (typeof value === "string") {
        return parseInt(value, 10);
      }
      if (typeof value === "boolean") {
        return value ? 1 : 0;
      }
      if (typeof value === "number") {
        return value;
      }
      return 0;
    }
    function evaluateOperand(filterContext, filter, operand, coerce) {
      if (operand instanceof node_opcua_types_1.AttributeOperand) {
        return coerce((0, resolve_operand_1.resolveOperand)(filterContext, operand));
      } else if (operand instanceof node_opcua_types_1.SimpleAttributeOperand) {
        return coerce((0, resolve_operand_1.resolveOperand)(filterContext, operand));
      } else if (operand instanceof node_opcua_types_1.LiteralOperand) {
        return coerce(operand.value);
      } else if (operand instanceof node_opcua_types_1.ElementOperand) {
        const index = operand.index;
        return coerce(checkFilterAtIndex(filterContext, filter, index));
      }
      return coerce(null);
    }
    function checkOfType(filterContext, ofType) {
      if (!ofType || !(ofType instanceof node_opcua_types_1.LiteralOperand)) {
        warningLog("checkOfType : unsupported case ! ofType is not a LiteralOperand , ofType = ", ofType?.toString());
        return false;
      }
      if (ofType.value.dataType !== node_opcua_variant_1.DataType.NodeId) {
        warningLog("invalid operand type (expecting NodeId); got " + node_opcua_variant_1.DataType[ofType.value.dataType]);
        return false;
      }
      const ofTypeNode = ofType.value.value;
      if (!ofTypeNode) {
        return false;
      }
      const ofTypeNodeNodeClass = filterContext.getNodeClass(ofTypeNode);
      if (ofTypeNodeNodeClass !== node_opcua_data_model_1.NodeClass.ObjectType && ofTypeNodeNodeClass !== node_opcua_data_model_1.NodeClass.VariableType && ofTypeNodeNodeClass !== node_opcua_data_model_1.NodeClass.DataType && ofTypeNodeNodeClass !== node_opcua_data_model_1.NodeClass.ReferenceType) {
        warningLog("operand should be a ObjectType " + ofTypeNode.toString());
        return false;
      }
      if (!filterContext.eventSource || filterContext.eventSource.isEmpty()) {
        return false;
      }
      let sourceTypeDefinition = filterContext.eventSource;
      const sourceNodeClass = filterContext.getNodeClass(filterContext.eventSource);
      if (sourceNodeClass === node_opcua_data_model_1.NodeClass.Object || sourceNodeClass === node_opcua_data_model_1.NodeClass.Variable) {
        sourceTypeDefinition = filterContext.getTypeDefinition(filterContext.eventSource);
        if (!sourceTypeDefinition) {
          return false;
        }
      }
      return filterContext.isSubtypeOf(sourceTypeDefinition, ofTypeNode);
    }
    function checkNot(filterContext, filter, filteredOperands) {
      const operandA = evaluateOperand(filterContext, filter, filteredOperands[0], _coerceToBoolean);
      return !operandA;
    }
    function checkOr(filterContext, filter, filteredOperands) {
      const operandA = evaluateOperand(filterContext, filter, filteredOperands[0], _coerceToBoolean);
      const operandB = evaluateOperand(filterContext, filter, filteredOperands[1], _coerceToBoolean);
      return operandA || operandB;
    }
    function checkAnd(filterContext, filter, filteredOperands) {
      const operandA = evaluateOperand(filterContext, filter, filteredOperands[0], _coerceToBoolean);
      const operandB = evaluateOperand(filterContext, filter, filteredOperands[1], _coerceToBoolean);
      return operandA && operandB;
    }
    function checkLessThan(filterContext, filter, filteredOperands) {
      const operandA = evaluateOperand(filterContext, filter, filteredOperands[0], _coerceToNumber);
      const operandB = evaluateOperand(filterContext, filter, filteredOperands[1], _coerceToNumber);
      return operandA < operandB;
    }
    function checkLessThanOrEqual(filterContext, filter, filteredOperands) {
      const operandA = evaluateOperand(filterContext, filter, filteredOperands[0], _coerceToNumber);
      const operandB = evaluateOperand(filterContext, filter, filteredOperands[1], _coerceToNumber);
      return operandA <= operandB;
    }
    function checkGreaterThan(filterContext, filter, filteredOperands) {
      const operandA = evaluateOperand(filterContext, filter, filteredOperands[0], _coerceToNumber);
      const operandB = evaluateOperand(filterContext, filter, filteredOperands[1], _coerceToNumber);
      return operandA > operandB;
    }
    function checkGreaterThanOrEqual(filterContext, filter, filteredOperands) {
      const operandA = evaluateOperand(filterContext, filter, filteredOperands[0], _coerceToNumber);
      const operandB = evaluateOperand(filterContext, filter, filteredOperands[1], _coerceToNumber);
      return operandA >= operandB;
    }
    function checkEquals(filterContext, filter, filteredOperands) {
      const operandA = evaluateOperand(filterContext, filter, filteredOperands[0], _coerceToNumber);
      const operandB = evaluateOperand(filterContext, filter, filteredOperands[1], _coerceToNumber);
      return operandA === operandB;
    }
    function checkBetween(filterContext, filter, filteredOperands) {
      const operandA = evaluateOperand(filterContext, filter, filteredOperands[0], _coerceToNumber);
      const operandLow = evaluateOperand(filterContext, filter, filteredOperands[1], _coerceToNumber);
      const operandHigh = evaluateOperand(filterContext, filter, filteredOperands[2], _coerceToNumber);
      return operandA >= operandLow && operandA <= operandHigh;
    }
    function checkInList(context, filterOperands) {
      const operand0 = filterOperands[0];
      if (!(operand0 instanceof node_opcua_types_1.SimpleAttributeOperand)) {
        warningLog("FilterOperator.InList operand0 is not a SimpleAttributeOperand " + operand0.constructor.name);
        return false;
      }
      const value = (0, resolve_operand_1.resolveOperand)(context, operand0);
      if (value.dataType !== node_opcua_variant_1.DataType.NodeId) {
        return false;
      }
      const nodeId = value.value;
      if (!nodeId) {
        return false;
      }
      function _is(nodeId1, operandX) {
        if (operandX.value.dataType !== node_opcua_variant_1.DataType.NodeId) {
          return false;
        }
        const nodeId2 = operandX.value.value;
        const nodeClass = context.getNodeClass(nodeId2);
        if (nodeClass === node_opcua_data_model_1.NodeClass.Unspecified) {
          return false;
        }
        return (0, node_opcua_nodeid_1.sameNodeId)(nodeId1, nodeId2);
      }
      for (let i = 1; i < filterOperands.length; i++) {
        const filterOperand = filterOperands[i];
        if (filterOperand instanceof node_opcua_types_1.LiteralOperand && _is(nodeId, filterOperand)) {
          return true;
        }
      }
      return false;
    }
    function checkFilterAtIndex(filterContext, filter, index) {
      if (!filter.elements || filter.elements.length === 0) {
        return true;
      }
      const element = filter.elements[index];
      if (!element) {
        return true;
      }
      const filterOperands = element.filterOperands || [];
      switch (element.filterOperator) {
        case node_opcua_types_1.FilterOperator.Equals:
          return checkEquals(filterContext, filter, filterOperands);
        case node_opcua_types_1.FilterOperator.LessThan:
          return checkLessThan(filterContext, filter, filterOperands);
        case node_opcua_types_1.FilterOperator.LessThanOrEqual:
          return checkLessThanOrEqual(filterContext, filter, filterOperands);
        case node_opcua_types_1.FilterOperator.GreaterThan:
          return checkGreaterThan(filterContext, filter, filterOperands);
        case node_opcua_types_1.FilterOperator.GreaterThanOrEqual:
          return checkGreaterThanOrEqual(filterContext, filter, filterOperands);
        case node_opcua_types_1.FilterOperator.Between:
          return checkBetween(filterContext, filter, filterOperands);
        case node_opcua_types_1.FilterOperator.And:
          return checkAnd(filterContext, filter, filterOperands);
        case node_opcua_types_1.FilterOperator.Or:
          return checkOr(filterContext, filter, filterOperands);
        case node_opcua_types_1.FilterOperator.Not:
          return checkNot(filterContext, filter, filterOperands);
        case node_opcua_types_1.FilterOperator.OfType:
          return checkOfType(filterContext, element.filterOperands[0]);
        case node_opcua_types_1.FilterOperator.InList:
          return checkInList(filterContext, filterOperands);
        case node_opcua_types_1.FilterOperator.RelatedTo:
        case node_opcua_types_1.FilterOperator.Like:
        case node_opcua_types_1.FilterOperator.BitwiseAnd:
        case node_opcua_types_1.FilterOperator.BitwiseOr:
        case node_opcua_types_1.FilterOperator.Cast:
        case node_opcua_types_1.FilterOperator.InView:
        case node_opcua_types_1.FilterOperator.IsNull:
        default:
          warningLog(`checkFilter: operator ${node_opcua_types_1.FilterOperator[element.filterOperator]} is currently not supported in filter`);
          return false;
      }
    }
    function checkFilter(filterContext, contentFilter) {
      return checkFilterAtIndex(filterContext, contentFilter, 0);
    }
    exports2.checkFilter = checkFilter;
  }
});

// node_modules/node-opcua-service-filter/dist/extract_event_field.js
var require_extract_event_field = __commonJS({
  "node_modules/node-opcua-service-filter/dist/extract_event_field.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.extractEventFieldsBase = exports2.extractEventField = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_variant_1 = require_dist28();
    var resolve_operand_1 = require_resolve_operand();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)("FILTER");
    var conditionTypeNodeId = (0, node_opcua_nodeid_1.resolveNodeId)("ConditionType");
    function extractEventField(context, operand) {
      (0, node_opcua_assert_1.assert)(operand instanceof node_opcua_types_1.SimpleAttributeOperand);
      operand.browsePath = operand.browsePath || [];
      if (operand.browsePath.length === 0 && operand.attributeId === node_opcua_data_model_1.AttributeIds.NodeId) {
        if (!(0, node_opcua_nodeid_1.sameNodeId)(operand.typeDefinitionId, conditionTypeNodeId)) {
          if (!context.isSubtypeOf(operand.typeDefinitionId, conditionTypeNodeId)) {
            warningLog(" ", operand.typeDefinitionId.toString());
            warningLog("this case is not handled yet : selectClause.typeDefinitionId = " + operand.typeDefinitionId.toString());
            warningLog(operand.toString());
            return new node_opcua_variant_1.Variant({ dataType: node_opcua_variant_1.DataType.NodeId, value: context.eventSource });
          }
        }
        const eventSourceTypeDefinition = context.getTypeDefinition(context.eventSource);
        if (!eventSourceTypeDefinition) {
          return new node_opcua_variant_1.Variant();
        }
        if (!context.isSubtypeOf(eventSourceTypeDefinition, conditionTypeNodeId)) {
          return new node_opcua_variant_1.Variant();
        }
        return new node_opcua_variant_1.Variant({ dataType: node_opcua_variant_1.DataType.NodeId, value: context.eventSource });
      }
      return (0, resolve_operand_1.resolveOperand)(context, operand);
    }
    exports2.extractEventField = extractEventField;
    function extractEventFieldsBase(context, selectClauses) {
      (0, node_opcua_assert_1.assert)(Array.isArray(selectClauses));
      (0, node_opcua_assert_1.assert)(selectClauses.length === 0 || selectClauses[0] instanceof node_opcua_types_1.SimpleAttributeOperand);
      return selectClauses.map(extractEventField.bind(null, context));
    }
    exports2.extractEventFieldsBase = extractEventFieldsBase;
  }
});

// node_modules/node-opcua-service-filter/dist/filter_context.js
var require_filter_context = __commonJS({
  "node_modules/node-opcua-service-filter/dist/filter_context.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-service-filter/dist/imports.js
var require_imports4 = __commonJS({
  "node_modules/node-opcua-service-filter/dist/imports.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.DataChangeFilter = exports2.EventFilter = exports2.ContentFilter = exports2.ContentFilterElement = exports2.MonitoringFilter = exports2.SimpleAttributeOperand = exports2.LiteralOperand = exports2.FilterOperand = exports2.ElementOperand = exports2.AttributeOperand = exports2.FilterOperator = void 0;
    var node_opcua_types_1 = require_dist32();
    Object.defineProperty(exports2, "FilterOperator", { enumerable: true, get: function() {
      return node_opcua_types_1.FilterOperator;
    } });
    Object.defineProperty(exports2, "AttributeOperand", { enumerable: true, get: function() {
      return node_opcua_types_1.AttributeOperand;
    } });
    Object.defineProperty(exports2, "ElementOperand", { enumerable: true, get: function() {
      return node_opcua_types_1.ElementOperand;
    } });
    Object.defineProperty(exports2, "FilterOperand", { enumerable: true, get: function() {
      return node_opcua_types_1.FilterOperand;
    } });
    Object.defineProperty(exports2, "LiteralOperand", { enumerable: true, get: function() {
      return node_opcua_types_1.LiteralOperand;
    } });
    Object.defineProperty(exports2, "SimpleAttributeOperand", { enumerable: true, get: function() {
      return node_opcua_types_1.SimpleAttributeOperand;
    } });
    Object.defineProperty(exports2, "MonitoringFilter", { enumerable: true, get: function() {
      return node_opcua_types_1.MonitoringFilter;
    } });
    Object.defineProperty(exports2, "ContentFilterElement", { enumerable: true, get: function() {
      return node_opcua_types_1.ContentFilterElement;
    } });
    Object.defineProperty(exports2, "ContentFilter", { enumerable: true, get: function() {
      return node_opcua_types_1.ContentFilter;
    } });
    Object.defineProperty(exports2, "EventFilter", { enumerable: true, get: function() {
      return node_opcua_types_1.EventFilter;
    } });
    Object.defineProperty(exports2, "DataChangeFilter", { enumerable: true, get: function() {
      return node_opcua_types_1.DataChangeFilter;
    } });
  }
});

// node_modules/node-opcua-service-filter/dist/make_content_filter.js
var require_make_content_filter = __commonJS({
  "node_modules/node-opcua-service-filter/dist/make_content_filter.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.makeContentFilter = exports2.makeContentFilterElements = exports2.inList = exports2.greaterThan = exports2.greaterThanOrEqual = exports2.LessThanOrEqual = exports2.lessThan = exports2.and = exports2.or = exports2.s = exports2.n = exports2.l = exports2.ofType = void 0;
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_variant_1 = require_dist28();
    var imports_1 = require_imports4();
    function ofType(nodeId) {
      const element = new imports_1.ContentFilterElement({
        filterOperator: imports_1.FilterOperator.OfType,
        filterOperands: [
          new imports_1.LiteralOperand({
            value: {
              dataType: node_opcua_basic_types_1.DataType.NodeId,
              value: (0, node_opcua_nodeid_1.resolveNodeId)(nodeId)
            }
          })
        ]
      });
      return element;
    }
    exports2.ofType = ofType;
    function l2(dataType, value) {
      switch (dataType) {
        case node_opcua_basic_types_1.DataType.NodeId:
          value = (0, node_opcua_nodeid_1.resolveNodeId)(value);
      }
      return new imports_1.LiteralOperand({ value: new node_opcua_variant_1.Variant({ dataType, value }) });
    }
    exports2.l = l2;
    function n(n2) {
      return l2(node_opcua_basic_types_1.DataType.NodeId, n2);
    }
    exports2.n = n;
    function s(attributeId, path3) {
      return new imports_1.SimpleAttributeOperand({
        attributeId,
        browsePath: path3.split(".").map(node_opcua_data_model_1.coerceQualifiedName)
      });
    }
    exports2.s = s;
    function or(a, b) {
      return new imports_1.ContentFilterElement({
        filterOperands: [a, b],
        filterOperator: imports_1.FilterOperator.Or
      });
    }
    exports2.or = or;
    function and(a, b) {
      return new imports_1.ContentFilterElement({
        filterOperands: [a, b],
        filterOperator: imports_1.FilterOperator.And
      });
    }
    exports2.and = and;
    function lessThan(a, b) {
      return new imports_1.ContentFilterElement({
        filterOperands: [a, b],
        filterOperator: imports_1.FilterOperator.LessThan
      });
    }
    exports2.lessThan = lessThan;
    function LessThanOrEqual(a, b) {
      return new imports_1.ContentFilterElement({
        filterOperands: [a, b],
        filterOperator: imports_1.FilterOperator.LessThanOrEqual
      });
    }
    exports2.LessThanOrEqual = LessThanOrEqual;
    function greaterThanOrEqual(a, b) {
      return new imports_1.ContentFilterElement({
        filterOperands: [a, b],
        filterOperator: imports_1.FilterOperator.GreaterThanOrEqual
      });
    }
    exports2.greaterThanOrEqual = greaterThanOrEqual;
    function greaterThan(a, b) {
      return new imports_1.ContentFilterElement({
        filterOperands: [a, b],
        filterOperator: imports_1.FilterOperator.GreaterThan
      });
    }
    exports2.greaterThan = greaterThan;
    function inList(a, l3) {
      return new imports_1.ContentFilterElement({
        filterOperands: [a, ...l3],
        filterOperator: imports_1.FilterOperator.InList
      });
    }
    exports2.inList = inList;
    function makeContentFilterElements(o2) {
      const elements = [];
      function pushElement(element) {
        elements.push(element);
        const thisIndex = elements.length - 1;
        if (element.filterOperands) {
          for (let i = 0; i < element.filterOperands.length; i++) {
            const op = element.filterOperands[i];
            if (op instanceof imports_1.ContentFilterElement) {
              const index = pushElement(op);
              element.filterOperands[i] = new imports_1.ElementOperand({ index });
            }
          }
        }
        return thisIndex;
      }
      pushElement(o2);
      return elements;
    }
    exports2.makeContentFilterElements = makeContentFilterElements;
    function makeContentFilter(o2) {
      return new imports_1.ContentFilter({
        elements: makeContentFilterElements(o2 instanceof imports_1.ContentFilterElement ? o2 : new imports_1.ContentFilterElement(o2))
      });
    }
    exports2.makeContentFilter = makeContentFilter;
  }
});

// node_modules/node-opcua-service-filter/dist/on_address_space/filter_context_on_address_space.js
var require_filter_context_on_address_space = __commonJS({
  "node_modules/node-opcua-service-filter/dist/on_address_space/filter_context_on_address_space.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.FilterContextOnAddressSpace = void 0;
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_variant_1 = require_dist28();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)("Filter");
    var FilterContextOnAddressSpace = class {
      constructor(sessionContext, eventData) {
        this.sessionContext = sessionContext;
        this.eventData = eventData;
        this.eventSource = this.eventData.$eventDataSource?.nodeId || node_opcua_nodeid_1.NodeId.nullNodeId;
      }
      getNodeClass(nodeId) {
        const addressSpace = this.getAddressSpace();
        const node = addressSpace.findNode(nodeId);
        return node ? node.nodeClass : node_opcua_data_model_1.NodeClass.Unspecified;
      }
      isSubtypeOf(nodeId, baseType) {
        const addressSpace = this.getAddressSpace();
        const node = addressSpace.findNode(nodeId);
        const baseTypeNode = addressSpace.findNode(baseType);
        if (!node || !baseTypeNode) {
          warningLog("invalid node - must be specifed ");
          return false;
        }
        if (node.nodeClass === node_opcua_data_model_1.NodeClass.ObjectType && baseTypeNode.nodeClass === node_opcua_data_model_1.NodeClass.ObjectType) {
          return node.isSubtypeOf(baseTypeNode);
        }
        if (node.nodeClass === node_opcua_data_model_1.NodeClass.VariableType && baseTypeNode.nodeClass === node_opcua_data_model_1.NodeClass.VariableType) {
          return node.isSubtypeOf(baseTypeNode);
        }
        if (node.nodeClass === node_opcua_data_model_1.NodeClass.ReferenceType && baseTypeNode.nodeClass === node_opcua_data_model_1.NodeClass.ReferenceType) {
          return node.isSubtypeOf(baseTypeNode);
        }
        if (node.nodeClass === node_opcua_data_model_1.NodeClass.DataType && baseTypeNode.nodeClass === node_opcua_data_model_1.NodeClass.DataType) {
          return node.isSubtypeOf(baseTypeNode);
        }
        if (node.nodeClass === node_opcua_data_model_1.NodeClass.Object && baseTypeNode.nodeClass === node_opcua_data_model_1.NodeClass.ObjectType) {
          const obj = node;
          return obj.typeDefinitionObj.isSubtypeOf(baseTypeNode);
        }
        if (node.nodeClass === node_opcua_data_model_1.NodeClass.Variable && baseTypeNode.nodeClass !== node_opcua_data_model_1.NodeClass.VariableType) {
          const obj = node;
          return obj.typeDefinitionObj.isSubtypeOf(baseTypeNode);
        }
        return false;
      }
      getTypeDefinition(nodeId) {
        const addressSpace = this.getAddressSpace();
        const node = addressSpace.findNode(nodeId);
        if (!node)
          return null;
        if (node.nodeClass === node_opcua_data_model_1.NodeClass.Object || node.nodeClass === node_opcua_data_model_1.NodeClass.Variable) {
          return node.typeDefinition;
        }
        return null;
      }
      readNodeValue(nodeId) {
        nodeId = (0, node_opcua_nodeid_1.coerceNodeId)(nodeId);
        const value = this.eventData._readValue(nodeId);
        if (value) {
          return value;
        }
        const addressSpace = this.getAddressSpace();
        const node = addressSpace.findNode(nodeId);
        if (!node || node.nodeClass !== node_opcua_data_model_1.NodeClass.Variable) {
          return new node_opcua_variant_1.Variant();
        }
        return prepare(node.readValue(this.sessionContext));
      }
      getAddressSpace() {
        return this.eventData.$eventDataSource.addressSpace;
      }
      browsePath(browsePath) {
        if ((0, node_opcua_nodeid_1.sameNodeId)(browsePath.startingNode, this.eventSource)) {
          const browseResult2 = this.eventData._browse(browsePath);
          if (browseResult2 && browseResult2.statusCode.isGood() && browseResult2.targets && browseResult2.targets.length === 1) {
            return browseResult2.targets[0].targetId;
          }
        }
        const addressSpace = this.getAddressSpace();
        const browseResult = addressSpace.browsePath(browsePath);
        if (browseResult.statusCode.isNotGood() || !browseResult.targets || browseResult.targets.length !== 1) {
          return null;
        }
        return browseResult.targets[0].targetId;
      }
      setEventSource(eventSource) {
        this.eventSource = eventSource ? eventSource.nodeId : node_opcua_nodeid_1.NodeId.nullNodeId;
      }
    };
    exports2.FilterContextOnAddressSpace = FilterContextOnAddressSpace;
    function prepare(dataValue) {
      if (dataValue.statusCode.isGood()) {
        return dataValue.value;
      }
      return new node_opcua_variant_1.Variant({ dataType: node_opcua_variant_1.DataType.StatusCode, value: dataValue.statusCode });
    }
  }
});

// node_modules/node-opcua-service-filter/dist/on_address_space/extract_event_fields.js
var require_extract_event_fields = __commonJS({
  "node_modules/node-opcua-service-filter/dist/on_address_space/extract_event_fields.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.extractEventFields = void 0;
    var extract_event_field_1 = require_extract_event_field();
    var filter_context_on_address_space_1 = require_filter_context_on_address_space();
    function extractEventFields(sessionContext, selectClauses, eventData) {
      const context = new filter_context_on_address_space_1.FilterContextOnAddressSpace(sessionContext, eventData);
      return (0, extract_event_field_1.extractEventFieldsBase)(context, selectClauses);
    }
    exports2.extractEventFields = extractEventFields;
  }
});

// node_modules/node-opcua-service-filter/dist/tools_event_filter.js
var require_tools_event_filter = __commonJS({
  "node_modules/node-opcua-service-filter/dist/tools_event_filter.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.constructEventFilter = exports2.constructSelectClause = exports2.constructSimpleBrowsePath = void 0;
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_data_model_1 = require_dist27();
    var imports_1 = require_imports4();
    function coerceQualifiedName2(a) {
      if (typeof a === "string")
        return (0, node_opcua_data_model_1.coerceQualifiedName)(a);
      a.namespaceIndex = a.namespaceIndex || 0;
      return (0, node_opcua_data_model_1.coerceQualifiedName)(a);
    }
    function constructSimpleBrowsePath(a) {
      if (typeof a === "string") {
        return constructSimpleBrowsePath(a.split("."));
      }
      if (Array.isArray(a))
        return a.map(coerceQualifiedName2);
      return [coerceQualifiedName2(a)];
    }
    exports2.constructSimpleBrowsePath = constructSimpleBrowsePath;
    function constructSelectClause(arrayOfNames) {
      if (!Array.isArray(arrayOfNames)) {
        return constructSelectClause([arrayOfNames]);
      }
      const browsePaths = arrayOfNames.map(constructSimpleBrowsePath);
      const isBrowsePathForConditionId = (browsePath) => browsePath.length === 1 && browsePath[0] && browsePath[0].namespaceIndex === 0 && browsePath[0].name === "ConditionId";
      const selectClauses = browsePaths.map((browsePath) => {
        if (isBrowsePathForConditionId(browsePath)) {
          return new imports_1.SimpleAttributeOperand({
            attributeId: node_opcua_data_model_1.AttributeIds.NodeId,
            browsePath: null,
            indexRange: void 0,
            //  NumericRange
            typeDefinitionId: node_opcua_constants_1.ObjectTypeIds.ConditionType
            // i=2782
          });
        } else
          return new imports_1.SimpleAttributeOperand({
            attributeId: node_opcua_data_model_1.AttributeIds.Value,
            browsePath,
            indexRange: void 0,
            //  NumericRange
            typeDefinitionId: node_opcua_constants_1.ObjectTypeIds.BaseEventType
            // i=2041
          });
      });
      return selectClauses;
    }
    exports2.constructSelectClause = constructSelectClause;
    function constructEventFilter(arrayOfNames, whereClause) {
      const selectClauses = constructSelectClause(arrayOfNames);
      if (whereClause instanceof imports_1.ContentFilterElement) {
        whereClause = new imports_1.ContentFilter({ elements: [whereClause] });
      }
      const filter = new imports_1.EventFilter({
        selectClauses,
        whereClause
      });
      return filter;
    }
    exports2.constructEventFilter = constructEventFilter;
  }
});

// node_modules/node-opcua-service-filter/dist/index.js
var require_dist61 = __commonJS({
  "node_modules/node-opcua-service-filter/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_check_event_clause(), exports2);
    __exportStar3(require_check_where_clause(), exports2);
    __exportStar3(require_extract_event_field(), exports2);
    __exportStar3(require_filter_context(), exports2);
    __exportStar3(require_imports4(), exports2);
    __exportStar3(require_make_content_filter(), exports2);
    __exportStar3(require_extract_event_fields(), exports2);
    __exportStar3(require_resolve_operand(), exports2);
    __exportStar3(require_tools_event_filter(), exports2);
    __exportStar3(require_filter_context_on_address_space(), exports2);
  }
});

// node_modules/node-opcua-client/dist/client_monitored_item.js
var require_client_monitored_item = __commonJS({
  "node_modules/node-opcua-client/dist/client_monitored_item.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ClientMonitoredItem = void 0;
    var node_opcua_data_value_1 = require_dist29();
    var ClientMonitoredItem = class {
      static create(subscription, itemToMonitor, monitoringParameters, timestampsToReturn = node_opcua_data_value_1.TimestampsToReturn.Neither) {
        throw new Error("unimplemented");
      }
    };
    exports2.ClientMonitoredItem = ClientMonitoredItem;
  }
});

// node_modules/node-opcua-client/dist/private/client_monitored_item_impl.js
var require_client_monitored_item_impl = __commonJS({
  "node_modules/node-opcua-client/dist/private/client_monitored_item_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ClientMonitoredItemImpl = void 0;
    var events_1 = require("events");
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_service_filter_1 = require_dist61();
    var node_opcua_service_read_1 = require_dist39();
    var node_opcua_service_subscription_1 = require_dist45();
    var node_opcua_status_code_1 = require_dist22();
    var client_monitored_item_1 = require_client_monitored_item();
    var client_monitored_item_toolbox_1 = require_client_monitored_item_toolbox();
    var client_subscription_impl_1 = require_client_subscription_impl();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var ClientMonitoredItemImpl = class extends events_1.EventEmitter {
      constructor(subscription, itemToMonitor, monitoringParameters, timestampsToReturn, monitoringMode = node_opcua_service_subscription_1.MonitoringMode.Reporting) {
        super();
        this.statusCode = node_opcua_status_code_1.StatusCodes.BadDataUnavailable;
        (0, node_opcua_assert_1.assert)(subscription.constructor.name === "ClientSubscriptionImpl");
        this.subscription = subscription;
        this.itemToMonitor = new node_opcua_service_read_1.ReadValueId(itemToMonitor);
        this.monitoringParameters = new node_opcua_service_subscription_1.MonitoringParameters(monitoringParameters);
        this.monitoringMode = monitoringMode;
        (0, node_opcua_assert_1.assert)(this.monitoringParameters.clientHandle === 4294967295, "should not have a client handle yet");
        (0, node_opcua_assert_1.assert)(subscription.session, "expecting session");
        timestampsToReturn = (0, node_opcua_data_value_1.coerceTimestampsToReturn)(timestampsToReturn);
        (0, node_opcua_assert_1.assert)(subscription.constructor.name === "ClientSubscriptionImpl");
        this.timestampsToReturn = timestampsToReturn;
      }
      toString() {
        let ret = "";
        ret += "itemToMonitor:        " + this.itemToMonitor.toString() + "\n";
        ret += "monitoringParameters: " + this.monitoringParameters.toString() + "\n";
        ret += "timestampsToReturn:   " + this.timestampsToReturn.toString() + "\n";
        ret += "itemToMonitor         " + this.itemToMonitor.nodeId + "\n";
        ret += "statusCode            " + this.statusCode?.toString() + "\n";
        ret += "result =" + this.result?.toString() + "\n";
        return ret;
      }
      terminate(...args) {
        const done = args[0];
        (0, node_opcua_assert_1.assert)(typeof done === "function");
        const subscription = this.subscription;
        subscription._delete_monitored_items([this], (err) => {
          if (done) {
            done(err);
          }
        });
      }
      modify(...args) {
        if (args.length === 2) {
          return this.modify(args[0], null, args[1]);
        }
        const parameters = args[0];
        const timestampsToReturn = args[1];
        const callback = args[2];
        this.timestampsToReturn = timestampsToReturn || this.timestampsToReturn;
        client_monitored_item_toolbox_1.ClientMonitoredItemToolbox._toolbox_modify(this.subscription, [this], parameters, this.timestampsToReturn, (err, results) => {
          if (err) {
            return callback(err);
          }
          if (!results) {
            return callback(new Error("internal error"));
          }
          (0, node_opcua_assert_1.assert)(results.length === 1);
          callback(null, results[0]);
        });
      }
      setMonitoringMode(...args) {
        const monitoringMode = args[0];
        const callback = args[1];
        client_monitored_item_toolbox_1.ClientMonitoredItemToolbox._toolbox_setMonitoringMode(this.subscription, [this], monitoringMode, (err, statusCodes) => {
          callback(err ? err : null, statusCodes ? statusCodes[0] : void 0);
        });
      }
      /**
       * @internal
       * @param value
       * @private
       */
      _notify_value_change(value) {
        if (this.statusCode?.value === node_opcua_status_code_1.StatusCodes.BadDataUnavailable.value) {
          this._pendingDataValue = this._pendingDataValue || [];
          this._pendingDataValue.push(value);
          return;
        }
        try {
          this.emit("changed", value);
        } catch (err) {
          warningLog("[NODE-OPCUA-W28] Exception raised inside the event handler called by ClientMonitoredItem.on('change')", err);
          warningLog("                 Please verify the application using this node-opcua client");
        }
      }
      /**
       * @internal
       * @param eventFields
       * @private
       */
      _notify_event(eventFields) {
        if (this.statusCode?.value === node_opcua_status_code_1.StatusCodes.BadDataUnavailable.value) {
          this._pendingEvents = this._pendingEvents || [];
          this._pendingEvents.push(eventFields);
          return;
        }
        try {
          this.emit("changed", eventFields);
        } catch (err) {
          warningLog("[NODE-OPCUA-W29] Exception raised inside the event handler called by ClientMonitoredItem.on('change')", err);
          warningLog("                 Please verify the application using this node-opcua client");
        }
      }
      /**
       * @internal
       * @private
       */
      _prepare_for_monitoring() {
        (0, node_opcua_assert_1.assert)(this.monitoringParameters.clientHandle === 4294967295, "should not have a client handle yet");
        const subscription = this.subscription;
        this.monitoringParameters.clientHandle = subscription.nextClientHandle();
        (0, node_opcua_assert_1.assert)(this.monitoringParameters.clientHandle > 0 && this.monitoringParameters.clientHandle !== 4294967295);
        if (this.itemToMonitor.attributeId === node_opcua_data_model_1.AttributeIds.EventNotifier) {
          this.monitoringParameters.filter = this.monitoringParameters.filter || new node_opcua_service_filter_1.EventFilter({});
          const filter = this.monitoringParameters.filter;
          if (!filter) {
            return { error: "Internal Error" };
          }
          if (filter.schema.name !== "EventFilter") {
            return {
              error: "Mismatch between attributeId and filter in monitoring parameters : Got a " + filter.schema.name + " but a EventFilter object is required when itemToMonitor.attributeId== AttributeIds.EventNotifier"
            };
          }
        } else if (this.itemToMonitor.attributeId === node_opcua_data_model_1.AttributeIds.Value) {
        } else {
          if (this.monitoringParameters.filter) {
            return {
              error: "Mismatch between attributeId and filter in monitoring parameters : no filter expected when attributeId is not Value  or  EventNotifier"
            };
          }
        }
        return {
          itemToMonitor: this.itemToMonitor,
          monitoringMode: this.monitoringMode,
          requestedParameters: this.monitoringParameters
        };
      }
      /**
       * @internal
       * @param monitoredItemResult
       * @private
       */
      _applyResult(monitoredItemResult) {
        this.statusCode = monitoredItemResult.statusCode;
        if (monitoredItemResult.statusCode.isGood()) {
          this.result = monitoredItemResult;
          this.monitoredItemId = monitoredItemResult.monitoredItemId;
          this.monitoringParameters.samplingInterval = monitoredItemResult.revisedSamplingInterval;
          this.monitoringParameters.queueSize = monitoredItemResult.revisedQueueSize;
          this.filterResult = monitoredItemResult.filterResult || void 0;
        }
        if (this._pendingDataValue) {
          const dataValues = this._pendingDataValue;
          this._pendingDataValue = void 0;
          setImmediate(() => {
            dataValues.map((dataValue) => this._notify_value_change(dataValue));
          });
        }
        if (this._pendingEvents) {
          const events = this._pendingEvents;
          this._pendingEvents = void 0;
          setImmediate(() => {
            events.map((event) => this._notify_event(event));
          });
        }
      }
      _before_create() {
        const subscription = this.subscription;
        subscription._add_monitored_item(this.monitoringParameters.clientHandle, this);
      }
      /**
       * @internal
       * @param monitoredItemResult
       * @private
       */
      _after_create(monitoredItemResult) {
        this._applyResult(monitoredItemResult);
        if (this.statusCode.isGood()) {
          this.emit("initialized");
        } else {
          const err = new Error(monitoredItemResult.statusCode.toString());
          this._terminate_and_emit(err);
        }
      }
      _terminate_and_emit(err) {
        if (this._terminated) {
          return;
        }
        if (err) {
          this.emit("err", err.message);
        }
        (0, node_opcua_assert_1.assert)(!this._terminated);
        this._terminated = true;
        this.emit("terminated", err);
        this.removeAllListeners();
        const clientHandle = this.monitoringParameters.clientHandle;
        delete this.subscription.monitoredItems[clientHandle];
      }
    };
    exports2.ClientMonitoredItemImpl = ClientMonitoredItemImpl;
    var thenify = require_thenify();
    ClientMonitoredItemImpl.prototype.terminate = thenify.withCallback(ClientMonitoredItemImpl.prototype.terminate);
    ClientMonitoredItemImpl.prototype.setMonitoringMode = thenify.withCallback(ClientMonitoredItemImpl.prototype.setMonitoringMode);
    ClientMonitoredItemImpl.prototype.modify = thenify.withCallback(ClientMonitoredItemImpl.prototype.modify);
    client_monitored_item_1.ClientMonitoredItem.create = (subscription, itemToMonitor, monitoringParameters, timestampsToReturn, monitoringMode = node_opcua_service_subscription_1.MonitoringMode.Reporting) => {
      return (0, client_subscription_impl_1.ClientMonitoredItem_create)(subscription, itemToMonitor, monitoringParameters, timestampsToReturn, monitoringMode);
    };
  }
});

// node_modules/node-opcua-client/dist/private/client_monitored_item_group_impl.js
var require_client_monitored_item_group_impl = __commonJS({
  "node_modules/node-opcua-client/dist/private/client_monitored_item_group_impl.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ClientMonitoredItemGroupImpl = void 0;
    var events_1 = require("events");
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_service_subscription_1 = require_dist45();
    var node_opcua_nodeid_1 = require_dist21();
    var client_monitored_item_group_1 = require_client_monitored_item_group();
    var client_monitored_item_toolbox_1 = require_client_monitored_item_toolbox();
    var client_monitored_item_impl_1 = require_client_monitored_item_impl();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var ClientMonitoredItemGroupImpl = class extends events_1.EventEmitter {
      constructor(subscription, itemsToMonitor, monitoringParameters, timestampsToReturn, monitoringMode = node_opcua_service_subscription_1.MonitoringMode.Reporting) {
        super();
        (0, node_opcua_assert_1.assert)(Array.isArray(itemsToMonitor));
        itemsToMonitor.forEach((itemToMonitor) => {
          itemToMonitor.nodeId = (0, node_opcua_nodeid_1.resolveNodeId)(itemToMonitor.nodeId);
        });
        timestampsToReturn = (0, node_opcua_data_value_1.coerceTimestampsToReturn)(timestampsToReturn);
        (0, node_opcua_assert_1.assert)(subscription.constructor.name === "ClientSubscriptionImpl");
        this.subscription = subscription;
        this.timestampsToReturn = timestampsToReturn;
        this.monitoringMode = monitoringMode;
        this.monitoredItems = itemsToMonitor.map((itemToMonitor) => new client_monitored_item_impl_1.ClientMonitoredItemImpl(subscription, itemToMonitor, monitoringParameters, node_opcua_data_value_1.TimestampsToReturn.Both, this.monitoringMode));
      }
      toString() {
        let ret = "ClientMonitoredItemGroup : \n";
        ret += "itemsToMonitor:       = [\n " + this.monitoredItems.slice(0, 10).map((monitoredItem) => (
          //  monitoredItem.itemToMonitor.toString() +
          monitoredItem.toString()
        )).join("\n") + "\n];\n";
        ret += "timestampsToReturn:   " + node_opcua_data_value_1.TimestampsToReturn[this.timestampsToReturn] + "\n";
        ret += "monitoringMode        " + node_opcua_service_subscription_1.MonitoringMode[this.monitoringMode];
        return ret;
      }
      terminate(...args) {
        const done = args[0];
        (0, node_opcua_assert_1.assert)(!done || typeof done === "function");
        const subscription = this.subscription;
        subscription._delete_monitored_items(this.monitoredItems, (err) => {
          subscription._removeGroup(this);
          if (done) {
            done(err);
          }
        });
      }
      modify(...args) {
        if (args.length === 2) {
          return this.modify(args[0], null, args[1]);
        }
        const parameters = args[0];
        const timestampsToReturn = args[1];
        const callback = args[2];
        this.timestampsToReturn = timestampsToReturn || this.timestampsToReturn;
        client_monitored_item_toolbox_1.ClientMonitoredItemToolbox._toolbox_modify(this.subscription, this.monitoredItems, parameters, this.timestampsToReturn, (err) => {
          callback(err ? err : void 0);
        });
      }
      setMonitoringMode(...args) {
        const monitoringMode = args[0];
        const callback = args[1];
        client_monitored_item_toolbox_1.ClientMonitoredItemToolbox._toolbox_setMonitoringMode(this.subscription, this.monitoredItems, monitoringMode, (err, statusCode) => {
          callback(err, statusCode[0]);
        });
      }
      /**
       * @internal
       * @method _monitor
       * Creates the monitor item (monitoring mode = Reporting)
       * @private
       */
      _monitor(done) {
        (0, node_opcua_assert_1.assert)(done === void 0 || typeof done === "function");
        this.monitoredItems.forEach((monitoredItem, index) => {
          monitoredItem.on("changed", (dataValue) => {
            try {
              this.emit("changed", monitoredItem, dataValue, index);
            } catch (err) {
              warningLog(`[NODE-OPCUA-W20] the monitoredItem.on('changed') handler has raised an exception.
error message : ${err.message}
Please investigate the code of the event handler function to fix the error.`);
            }
          });
        });
        client_monitored_item_toolbox_1.ClientMonitoredItemToolbox._toolbox_monitor(this.subscription, this.timestampsToReturn, this.monitoredItems, (err) => {
          if (err) {
            this._terminate_and_emit(err);
          } else {
            this.emit("initialized");
            const priv_subscription = this.subscription;
            priv_subscription._add_monitored_items_group(this);
          }
          if (done) {
            done(err);
          }
        });
      }
      _terminate_and_emit(err) {
        (0, node_opcua_assert_1.assert)(!this._terminated);
        this._terminated = true;
        if (err) {
          this.emit("err", err.message);
        }
        this.emit("terminated", err);
      }
    };
    exports2.ClientMonitoredItemGroupImpl = ClientMonitoredItemGroupImpl;
    var thenify = require_thenify();
    ClientMonitoredItemGroupImpl.prototype.terminate = thenify.withCallback(ClientMonitoredItemGroupImpl.prototype.terminate);
    ClientMonitoredItemGroupImpl.prototype.setMonitoringMode = thenify.withCallback(ClientMonitoredItemGroupImpl.prototype.setMonitoringMode);
    ClientMonitoredItemGroupImpl.prototype.modify = thenify.withCallback(ClientMonitoredItemGroupImpl.prototype.modify);
    client_monitored_item_group_1.ClientMonitoredItemGroup.create = (subscription, itemsToMonitor, monitoringParameters, timestampsToReturn) => {
      const monitoredItemGroup = new ClientMonitoredItemGroupImpl(subscription, itemsToMonitor, monitoringParameters, timestampsToReturn);
      const priv_subscription = subscription;
      priv_subscription._wait_for_subscription_to_be_ready((err) => {
        if (err) {
          return;
        }
        monitoredItemGroup._monitor((err1) => {
        });
      });
      return monitoredItemGroup;
    };
  }
});

// node_modules/node-opcua-client/dist/private/performance.js
var require_performance = __commonJS({
  "node_modules/node-opcua-client/dist/private/performance.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.detectLongOperation = void 0;
    var LONG_EVENT_HANDLER = process.env.NODEOPCUA_LONG_EVENT_HANDLER ? parseFloat(process.env.NODEOPCUA_LONG_EVENT_HANDLER) : 100;
    var convertHrtimeToMilliseconds = (hrtime) => {
      const seconds = hrtime[0];
      const nanoseconds = hrtime[1];
      return seconds * 1e3 + nanoseconds * 1e-6;
    };
    function detectLongOperation(lambda, onLongOperation) {
      const start = process.hrtime();
      lambda();
      const duration = convertHrtimeToMilliseconds(process.hrtime(start));
      if (duration > LONG_EVENT_HANDLER) {
        onLongOperation(duration);
      }
    }
    exports2.detectLongOperation = detectLongOperation;
  }
});

// node_modules/node-opcua-client/dist/private/client_subscription_impl.js
var require_client_subscription_impl = __commonJS({
  "node_modules/node-opcua-client/dist/private/client_subscription_impl.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ClientMonitoredItem_create = exports2.ClientSubscriptionImpl = void 0;
    var events_1 = require("events");
    var async_1 = __importDefault3(require_async());
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_service_read_1 = require_dist39();
    var node_opcua_service_subscription_1 = require_dist45();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_client_dynamic_extension_object_1 = require_dist56();
    var node_opcua_pseudo_session_1 = require_dist55();
    var client_subscription_1 = require_client_subscription();
    var client_monitored_item_toolbox_1 = require_client_monitored_item_toolbox();
    var client_monitored_item_group_impl_1 = require_client_monitored_item_group_impl();
    var client_monitored_item_impl_1 = require_client_monitored_item_impl();
    var performance_1 = require_performance();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var PENDING_SUBSCRIPTION_ID = 3234512922;
    var TERMINATED_SUBSCRIPTION_ID = 3234512923;
    var TERMINATING_SUBSCRIPTION_ID = 3234512924;
    var minimumMaxKeepAliveCount = 3;
    function displayKeepAliveWarning(sessionTimeout, maxKeepAliveCount, publishingInterval) {
      const keepAliveInterval = maxKeepAliveCount * publishingInterval;
      if (sessionTimeout < keepAliveInterval) {
        warningLog(chalk_1.default.yellowBright(`[NODE-OPCUA-W09] The subscription parameters are not compatible with the session timeout !
                  session timeout    = ${sessionTimeout}  milliseconds
                  maxKeepAliveCount  = ${maxKeepAliveCount}
                  publishingInterval = ${publishingInterval} milliseconds"

                  It is important that the session timeout    ( ${chalk_1.default.red(sessionTimeout)} ms) is largely greater than :
                      (maxKeepAliveCount*publishingInterval  =  ${chalk_1.default.red(keepAliveInterval)} ms),
                  otherwise you may experience unexpected disconnection from the server if your monitored items are not
                  changing frequently.`));
        if (sessionTimeout < 3e3 && publishingInterval <= 1e3) {
          warningLog(`[NODE-OPCUA-W10] You'll need to increase your sessionTimeout significantly.`);
        }
        if (sessionTimeout >= 3e3 && sessionTimeout < publishingInterval * minimumMaxKeepAliveCount && maxKeepAliveCount <= minimumMaxKeepAliveCount + 2) {
          warningLog(`[NODE-OPCUA-W11] your publishingInterval interval is probably too large, consider reducing it.`);
        }
        const idealMaxKeepAliveCount = Math.max(4, Math.floor(sessionTimeout * 0.8 / publishingInterval - 0.5));
        const idealPublishingInternal = Math.min(publishingInterval, sessionTimeout / (idealMaxKeepAliveCount + 3));
        const idealKeepAliveInterval = idealMaxKeepAliveCount * publishingInterval;
        warningLog(`[NODE-OPCUA-W12]  An ideal value for maxKeepAliveCount could be ${idealMaxKeepAliveCount}.
                  An ideal value for publishingInterval could be ${idealPublishingInternal} ms.
                  This will make  your subscription emit a keep alive signal every ${idealKeepAliveInterval} ms
                  if no monitored items are generating notifications.
                  for instance:
                    const  client = OPCUAClient.create({
                        requestedSessionTimeout: 30* 60* 1000, // 30 minutes
                    });
`);
        if (!client_subscription_1.ClientSubscription.ignoreNextWarning) {
          throw new Error("[NODE-OPCUA-W09] The subscription parameters are not compatible with the session timeout ");
        }
        return true;
      }
      return false;
    }
    function createMonitoredItemsAndRespectOperationalLimits(session, createMonitorItemsRequest, callback) {
      (0, node_opcua_pseudo_session_1.readOperationLimits)(session).then((operationalLimits) => {
        (0, node_opcua_pseudo_session_1.createMonitoredItemsLimit)(operationalLimits.maxMonitoredItemsPerCall || 0, session, createMonitorItemsRequest).then((createMonitoredItemResponse) => callback(null, createMonitoredItemResponse)).catch(callback);
      }).catch(callback);
    }
    var ClientSubscriptionImpl = class extends events_1.EventEmitter {
      /**
       * the associated session
       * @property session
       * @type {ClientSession}
       */
      get session() {
        (0, node_opcua_assert_1.assert)(this.publishEngine.session, "expecting a valid session here");
        return this.publishEngine.session;
      }
      get hasSession() {
        return !!this.publishEngine.session;
      }
      get isActive() {
        return !(this.subscriptionId === PENDING_SUBSCRIPTION_ID || this.subscriptionId === TERMINATED_SUBSCRIPTION_ID || this.subscriptionId === TERMINATING_SUBSCRIPTION_ID);
      }
      constructor(session, options) {
        super();
        this.monitoredItemGroups = [];
        this.timeoutHint = 0;
        this._nextClientHandle = 0;
        const sessionImpl = session;
        this.publishEngine = sessionImpl.getPublishEngine();
        this.lastSequenceNumber = -1;
        options = options || {};
        options.requestedPublishingInterval = options.requestedPublishingInterval || 100;
        options.requestedLifetimeCount = options.requestedLifetimeCount || 60;
        options.requestedMaxKeepAliveCount = options.requestedMaxKeepAliveCount || 10;
        options.requestedMaxKeepAliveCount = Math.max(options.requestedMaxKeepAliveCount, minimumMaxKeepAliveCount);
        const warningEmitted = displayKeepAliveWarning(session.timeout, options.requestedMaxKeepAliveCount, options.requestedPublishingInterval);
        if (warningEmitted) {
          warningLog(JSON.stringify({
            ...options
          }, null, " "));
        }
        options.maxNotificationsPerPublish = (0, node_opcua_utils_1.isNullOrUndefined)(options.maxNotificationsPerPublish) ? 0 : options.maxNotificationsPerPublish;
        options.publishingEnabled = !!options.publishingEnabled;
        options.priority = options.priority || 1;
        this.publishingInterval = options.requestedPublishingInterval;
        this.lifetimeCount = options.requestedLifetimeCount;
        this.maxKeepAliveCount = options.requestedMaxKeepAliveCount;
        this.maxNotificationsPerPublish = options.maxNotificationsPerPublish || 0;
        this.publishingEnabled = options.publishingEnabled;
        this.priority = options.priority;
        this.subscriptionId = PENDING_SUBSCRIPTION_ID;
        this._nextClientHandle = 0;
        this.monitoredItems = {};
        this.lastRequestSentTime = new Date(1, 1, 1970);
        this.hasTimedOut = false;
        setImmediate(() => {
          this.__create_subscription((err) => {
            if (!err) {
              setImmediate(() => {
                this.emit("started", this.subscriptionId);
              });
            } else {
              setImmediate(() => {
                this.emit("error", err);
              });
            }
          });
        });
      }
      terminate(...args) {
        debugLog("Terminating client subscription ", this.subscriptionId);
        const callback = args[0];
        (0, node_opcua_assert_1.assert)(typeof callback === "function", "expecting a callback function");
        if (this.subscriptionId === TERMINATED_SUBSCRIPTION_ID || this.subscriptionId === TERMINATING_SUBSCRIPTION_ID) {
          return callback(new Error("Already Terminated"));
        }
        if (isFinite(this.subscriptionId)) {
          const subscriptionId = this.subscriptionId;
          this.subscriptionId = TERMINATING_SUBSCRIPTION_ID;
          this.publishEngine.unregisterSubscription(subscriptionId);
          if (!this.hasSession) {
            return this._terminate_step2(callback);
          }
          const session = this.session;
          if (!session) {
            return callback(new Error("no session"));
          }
          session.deleteSubscriptions({
            subscriptionIds: [subscriptionId]
          }, (err, response) => {
            if (response && response.results[0] !== node_opcua_status_code_1.StatusCodes.Good) {
              debugLog("warning: deleteSubscription returned ", response.results);
            }
            if (err) {
              this.emit("internal_error", err);
            }
            this._terminate_step2(callback);
          });
        } else {
          debugLog("subscriptionId is not value ", this.subscriptionId);
          (0, node_opcua_assert_1.assert)(this.subscriptionId === PENDING_SUBSCRIPTION_ID);
          this._terminate_step2(callback);
        }
      }
      /**
       * @method nextClientHandle
       */
      nextClientHandle() {
        this._nextClientHandle += 1;
        return this._nextClientHandle;
      }
      monitor(...args) {
        const itemToMonitor = args[0];
        const requestedParameters = args[1];
        const timestampsToReturn = args[2];
        const monitoringMode = typeof args[3] === "function" ? node_opcua_service_subscription_1.MonitoringMode.Reporting : args[3];
        const done = typeof args[3] === "function" ? args[3] : args[4];
        (0, node_opcua_assert_1.assert)(typeof done === "function", "expecting a function here");
        itemToMonitor.nodeId = (0, node_opcua_nodeid_1.resolveNodeId)(itemToMonitor.nodeId);
        const monitoredItem = ClientMonitoredItem_create(this, itemToMonitor, requestedParameters, timestampsToReturn, monitoringMode, (err1, monitoredItem2) => {
          if (err1) {
            return done && done(err1);
          }
          done(err1 || null, monitoredItem);
        });
      }
      monitorItems(...args) {
        const itemsToMonitor = args[0];
        const requestedParameters = args[1];
        const timestampsToReturn = args[2];
        const done = args[3];
        const monitoredItemGroup = new client_monitored_item_group_impl_1.ClientMonitoredItemGroupImpl(this, itemsToMonitor, requestedParameters, timestampsToReturn);
        this._wait_for_subscription_to_be_ready((err) => {
          if (err) {
            return done(err);
          }
          monitoredItemGroup._monitor((err1) => {
            if (err1) {
              return done && done(err1);
            }
            done(err1, monitoredItemGroup);
          });
        });
      }
      _delete_monitored_items(monitoredItems, callback) {
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        (0, node_opcua_assert_1.assert)(Array.isArray(monitoredItems));
        (0, node_opcua_assert_1.assert)(this.isActive);
        for (const monitoredItem of monitoredItems) {
          this._remove(monitoredItem);
        }
        const session = this.session;
        session.deleteMonitoredItems({
          monitoredItemIds: monitoredItems.map((monitoredItem) => monitoredItem.monitoredItemId),
          subscriptionId: this.subscriptionId
        }, (err, response) => {
          callback(err);
        });
      }
      setPublishingMode(...args) {
        const publishingEnabled = args[0];
        const callback = args[1];
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        const session = this.session;
        if (!session) {
          return callback(new Error("no session"));
        }
        const subscriptionId = this.subscriptionId;
        session.setPublishingMode(publishingEnabled, subscriptionId, (err, statusCode) => {
          if (err) {
            return callback(err);
          }
          if (!statusCode) {
            return callback(new Error("Internal Error"));
          }
          if (statusCode.isNotGood()) {
            return callback(null, statusCode);
          }
          callback(null, node_opcua_status_code_1.StatusCodes.Good);
        });
      }
      setTriggering(...args) {
        const triggeringItem = args[0];
        const linksToAdd = args[1];
        const linksToRemove = args[2];
        const callback = args[3];
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        const session = this.session;
        if (!session) {
          return callback(new Error("no session"));
        }
        const subscriptionId = this.subscriptionId;
        const triggeringItemId = triggeringItem.monitoredItemId;
        const setTriggeringRequest = new node_opcua_service_subscription_1.SetTriggeringRequest({
          linksToAdd: linksToAdd ? linksToAdd.map((i) => i.monitoredItemId) : null,
          linksToRemove: linksToRemove ? linksToRemove.map((i) => i.monitoredItemId) : null,
          subscriptionId,
          triggeringItemId
        });
        session.setTriggering(setTriggeringRequest, (err, response) => {
          if (err) {
            if (response) {
              return callback(null, response);
            } else {
              return callback(err);
            }
          }
          if (!response) {
            return callback(new Error("Internal Error"));
          }
          callback(null, response);
        });
      }
      modify(...args) {
        const modifySubscriptionRequest = args[0];
        const callback = args[1];
        const session = this.session;
        if (!session) {
          return callback(new Error("no session"));
        }
        modifySubscriptionRequest.subscriptionId = this.subscriptionId;
        modifySubscriptionRequest.priority = modifySubscriptionRequest.priority === void 0 ? this.priority : modifySubscriptionRequest.priority;
        modifySubscriptionRequest.requestedLifetimeCount = modifySubscriptionRequest.requestedLifetimeCount === void 0 ? this.lifetimeCount : modifySubscriptionRequest.requestedLifetimeCount;
        modifySubscriptionRequest.requestedMaxKeepAliveCount = modifySubscriptionRequest.requestedMaxKeepAliveCount === void 0 ? this.maxKeepAliveCount : modifySubscriptionRequest.requestedMaxKeepAliveCount;
        modifySubscriptionRequest.requestedPublishingInterval = modifySubscriptionRequest.requestedPublishingInterval === void 0 ? this.publishingInterval : modifySubscriptionRequest.requestedPublishingInterval;
        modifySubscriptionRequest.maxNotificationsPerPublish = modifySubscriptionRequest.maxNotificationsPerPublish === void 0 ? this.maxNotificationsPerPublish : modifySubscriptionRequest.maxNotificationsPerPublish;
        session.modifySubscription(modifySubscriptionRequest, (err, response) => {
          if (err || !response) {
            return callback(err);
          }
          this.publishingInterval = response.revisedPublishingInterval;
          this.lifetimeCount = response.revisedLifetimeCount;
          this.maxKeepAliveCount = response.revisedMaxKeepAliveCount;
          callback(null, response);
        });
      }
      getMonitoredItems(...args) {
        this.session.getMonitoredItems(this.subscriptionId, args[0]);
      }
      /**
       *  utility function to recreate new subscription
       *  @method recreateSubscriptionAndMonitoredItem
       */
      recreateSubscriptionAndMonitoredItem(callback) {
        debugLog("ClientSubscription#recreateSubscriptionAndMonitoredItem");
        if (this.subscriptionId === TERMINATED_SUBSCRIPTION_ID) {
          debugLog("Subscription is not in a valid state");
          return callback();
        }
        const oldMonitoredItems = this.monitoredItems;
        this.publishEngine.unregisterSubscription(this.subscriptionId);
        async_1.default.series([
          (innerCallback) => {
            this.__create_subscription(innerCallback);
          },
          (innerCallback) => {
            const test = this.publishEngine.getSubscription(this.subscriptionId);
            debugLog("recreating ", Object.keys(oldMonitoredItems).length, " monitored Items");
            const itemsToCreate = [];
            for (const monitoredItem of Object.values(oldMonitoredItems)) {
              (0, node_opcua_assert_1.assert)(monitoredItem.monitoringParameters.clientHandle > 0);
              itemsToCreate.push({
                itemToMonitor: monitoredItem.itemToMonitor,
                monitoringMode: monitoredItem.monitoringMode,
                requestedParameters: monitoredItem.monitoringParameters
              });
            }
            const createMonitorItemsRequest = new node_opcua_service_subscription_1.CreateMonitoredItemsRequest({
              itemsToCreate,
              subscriptionId: this.subscriptionId,
              timestampsToReturn: node_opcua_service_read_1.TimestampsToReturn.Both
              // this.timestampsToReturn,
            });
            const session = this.session;
            if (!session) {
              return innerCallback(new Error("no session"));
            }
            debugLog("Recreating ", itemsToCreate.length, " monitored items");
            createMonitoredItemsAndRespectOperationalLimits(session, createMonitorItemsRequest, (err, response) => {
              if (err) {
                debugLog("Recreating monitored item has failed with ", err.message);
                return innerCallback(err);
              }
              if (!response) {
                return innerCallback(new Error("Internal Error"));
              }
              const monitoredItemResults = response.results || [];
              monitoredItemResults.forEach((monitoredItemResult, index) => {
                const itemToCreate = itemsToCreate[index];
                if (!itemToCreate || !itemToCreate.requestedParameters) {
                  throw new Error("Internal Error");
                }
                const clientHandle = itemToCreate.requestedParameters.clientHandle;
                if (!clientHandle) {
                  throw new Error("Internal Error");
                }
                const monitoredItem = this.monitoredItems[clientHandle];
                if (monitoredItem) {
                  monitoredItem._applyResult(monitoredItemResult);
                } else {
                  warningLog("cannot find monitored item for clientHandle !:", clientHandle);
                }
              });
              innerCallback();
            });
          }
        ], (err) => {
          if (err) {
            warningLog(err.message);
          }
          callback(err);
        });
      }
      toString() {
        let str = "";
        str += "subscriptionId      : " + this.subscriptionId + "\n";
        str += "publishingInterval  : " + this.publishingInterval + "\n";
        str += "lifetimeCount       : " + this.lifetimeCount + "\n";
        str += "maxKeepAliveCount   : " + this.maxKeepAliveCount + "\n";
        str += "hasTimedOut         : " + this.hasTimedOut + "\n";
        const timeToLive = this.lifetimeCount * this.publishingInterval;
        str += "timeToLive          : " + timeToLive + "\n";
        str += "lastRequestSentTime : " + this.lastRequestSentTime.toString() + "\n";
        const duration = Date.now() - this.lastRequestSentTime.getTime();
        const extra = duration - timeToLive > 0 ? chalk_1.default.red(" expired since " + (duration - timeToLive) / 1e3 + " seconds") : chalk_1.default.green(" valid for " + -(duration - timeToLive) / 1e3 + " seconds");
        str += "timeSinceLast PR    : " + duration + "ms" + extra + "\n";
        str += "has expired         : " + (duration > timeToLive) + "\n";
        str += "(session timeout    : " + this.session.timeout + " ms)\n";
        str += "(maxKeepAliveCount*publishingInterval: " + this.publishingInterval * this.session.timeout + " ms)\n";
        return str;
      }
      /**
       * returns the approximated remaining life time of this subscription in milliseconds
       */
      evaluateRemainingLifetime() {
        const now = Date.now();
        const timeout = this.publishingInterval * this.lifetimeCount;
        const expiryTime = this.lastRequestSentTime.getTime() + timeout;
        return Math.max(0, expiryTime - now);
      }
      _add_monitored_item(clientHandle, monitoredItem) {
        (0, node_opcua_assert_1.assert)(this.isActive, "subscription must be active and not terminated");
        (0, node_opcua_assert_1.assert)(monitoredItem.monitoringParameters.clientHandle === clientHandle);
        this.monitoredItems[clientHandle] = monitoredItem;
        this.emit("item_added", monitoredItem);
      }
      _add_monitored_items_group(monitoredItemGroup) {
        this.monitoredItemGroups.push(monitoredItemGroup);
      }
      _wait_for_subscription_to_be_ready(done) {
        let _watchDogCount = 0;
        const waitForSubscriptionAndMonitor = () => {
          _watchDogCount++;
          if (this.subscriptionId === PENDING_SUBSCRIPTION_ID) {
            setImmediate(waitForSubscriptionAndMonitor);
          } else if (this.subscriptionId === TERMINATED_SUBSCRIPTION_ID) {
            if (typeof done === "function") {
              done(new Error("subscription has been deleted"));
            }
          } else {
            done();
          }
        };
        setImmediate(waitForSubscriptionAndMonitor);
      }
      __create_subscription(callback) {
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        if (!this.hasSession) {
          return callback(new Error("No Session"));
        }
        const session = this.session;
        debugLog(chalk_1.default.yellow.bold("ClientSubscription created "));
        const request = new node_opcua_service_subscription_1.CreateSubscriptionRequest({
          maxNotificationsPerPublish: this.maxNotificationsPerPublish,
          priority: this.priority,
          publishingEnabled: this.publishingEnabled,
          requestedLifetimeCount: this.lifetimeCount,
          requestedMaxKeepAliveCount: this.maxKeepAliveCount,
          requestedPublishingInterval: this.publishingInterval
        });
        session.createSubscription(request, (err, response) => {
          if (err) {
            this.emit("internal_error", err);
            if (callback) {
              return callback(err);
            }
            return;
          }
          if (!response) {
            return callback(new Error("internal error"));
          }
          if (!this.hasSession) {
            return callback(new Error("createSubscription has failed = > no session"));
          }
          (0, node_opcua_assert_1.assert)(this.hasSession);
          this.subscriptionId = response.subscriptionId;
          this.publishingInterval = response.revisedPublishingInterval;
          this.lifetimeCount = response.revisedLifetimeCount;
          this.maxKeepAliveCount = response.revisedMaxKeepAliveCount;
          this.timeoutHint = Math.min((this.maxKeepAliveCount + 10) * this.publishingInterval * 2, 524287);
          displayKeepAliveWarning(this.session.timeout, this.maxKeepAliveCount, this.publishingInterval);
          client_subscription_1.ClientSubscription.ignoreNextWarning = false;
          if (doDebug) {
            debugLog(chalk_1.default.yellow.bold("registering callback"));
            debugLog(chalk_1.default.yellow.bold("publishingInterval               "), this.publishingInterval);
            debugLog(chalk_1.default.yellow.bold("lifetimeCount                    "), this.lifetimeCount);
            debugLog(chalk_1.default.yellow.bold("maxKeepAliveCount                "), this.maxKeepAliveCount);
            debugLog(chalk_1.default.yellow.bold("publish request timeout hint =   "), this.timeoutHint);
            debugLog(chalk_1.default.yellow.bold("hasTimedOut                      "), this.hasTimedOut);
            debugLog(chalk_1.default.yellow.bold("timeoutHint for publish request  "), this.timeoutHint);
          }
          this.publishEngine.registerSubscription(this);
          if (callback) {
            callback();
          }
        });
      }
      __on_publish_response_DataChangeNotification(notification) {
        (0, node_opcua_assert_1.assert)(notification.schema.name === "DataChangeNotification");
        const monitoredItems = notification.monitoredItems || [];
        let repeated = 0;
        for (const monitoredItem of monitoredItems) {
          const monitorItemObj = this.monitoredItems[monitoredItem.clientHandle];
          if (monitorItemObj) {
            if (monitorItemObj.itemToMonitor.attributeId === node_opcua_data_model_1.AttributeIds.EventNotifier) {
              warningLog(chalk_1.default.yellow("Warning"), chalk_1.default.cyan(" Server send a DataChangeNotification for an EventNotifier. EventNotificationList was expected"));
              warningLog(chalk_1.default.cyan("         the Server may not be fully OPCUA compliant"), chalk_1.default.yellow(". This notification will be ignored."));
            } else {
              const monitoredItemImpl = monitorItemObj;
              monitoredItemImpl._notify_value_change(monitoredItem.value);
            }
          } else {
            repeated += 1;
            if (repeated === 1) {
              warningLog("Receiving a notification for a unknown monitoredItem with clientHandle ", monitoredItem.clientHandle);
            }
          }
        }
        if (repeated > 1) {
          warningLog("previous message repeated", repeated, "times");
        }
      }
      __on_publish_response_StatusChangeNotification(notification) {
        (0, node_opcua_assert_1.assert)(notification.schema.name === "StatusChangeNotification");
        debugLog("Client has received a Status Change Notification ", notification.status.toString());
        if (notification.status === node_opcua_status_code_1.StatusCodes.GoodSubscriptionTransferred) {
          debugLog("ClientSubscription#__on_publish_response_StatusChangeNotification : GoodSubscriptionTransferred");
        }
        if (notification.status === node_opcua_status_code_1.StatusCodes.BadTimeout) {
          this.hasTimedOut = true;
          this.terminate(() => {
          });
        }
        this.emit("status_changed", notification.status, notification.diagnosticInfo);
      }
      __on_publish_response_EventNotificationList(notification) {
        (0, node_opcua_assert_1.assert)(notification.schema.name === "EventNotificationList");
        const events = notification.events || [];
        for (const event of events) {
          const monitorItemObj = this.monitoredItems[event.clientHandle];
          (0, node_opcua_assert_1.assert)(monitorItemObj, "Expecting a monitored item");
          const monitoredItemImpl = monitorItemObj;
          monitoredItemImpl._notify_event(event.eventFields || []);
        }
      }
      onNotificationMessage(notificationMessage) {
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(notificationMessage, "sequenceNumber"));
        this.lastSequenceNumber = notificationMessage.sequenceNumber;
        this.emit("raw_notification", notificationMessage);
        const notificationData = notificationMessage.notificationData || [];
        if (notificationData.length === 0) {
          debugLog(chalk_1.default.yellow("Client : received a keep alive notification from client"));
          this.emit("keepalive");
        } else {
          this.emit("received_notifications", notificationMessage);
          (0, node_opcua_client_dynamic_extension_object_1.promoteOpaqueStructureInNotificationData)(this.session, notificationData).then(() => {
            (0, performance_1.detectLongOperation)(() => {
              for (const notification of notificationData) {
                if (!notification) {
                  continue;
                }
                switch (notification.schema.name) {
                  case "DataChangeNotification":
                    this.__on_publish_response_DataChangeNotification(notification);
                    break;
                  case "StatusChangeNotification":
                    this.__on_publish_response_StatusChangeNotification(notification);
                    break;
                  case "EventNotificationList":
                    this.__on_publish_response_EventNotificationList(notification);
                    break;
                  default:
                    warningLog(" Invalid notification :", notification.toString());
                }
              }
            }, (duration) => {
              const s = (a) => {
                const b = a;
                b.$_slowNotifCount = b.$_slowNotifCount || 0;
                b.$_maxDuration = b.$_maxDuration || 0;
                return b;
              };
              s(this).$_maxDuration = Math.max(s(this).$_maxDuration, duration);
              if (s(this).$_slowNotifCount > 0 && s(this).$_slowNotifCount % 1e3 !== 0)
                return;
              s(this).$_slowNotifCount++;
              warningLog(`[NODE-OPCUA-W32]}: monitored.item event handler takes too much time : operation duration ${duration} ms [repeated ${s(this).$_slowNotifCount} times]
         please ensure that your monitoreItem event handler is not blocking the event loop.`);
            });
          });
        }
      }
      _terminate_step2(callback) {
        const monitoredItems = Object.values(this.monitoredItems);
        for (const monitoredItem of monitoredItems) {
          this._remove(monitoredItem);
        }
        const monitoredItemGroups = this.monitoredItemGroups;
        for (const monitoredItemGroup of monitoredItemGroups) {
          this._removeGroup(monitoredItemGroup);
        }
        (0, node_opcua_assert_1.assert)(Object.values(this.monitoredItems).length === 0);
        setImmediate(() => {
          this.subscriptionId = TERMINATED_SUBSCRIPTION_ID;
          this.emit("terminated");
          callback();
        });
      }
      _remove(monitoredItem) {
        const clientHandle = monitoredItem.monitoringParameters.clientHandle;
        (0, node_opcua_assert_1.assert)(clientHandle > 0);
        if (!Object.prototype.hasOwnProperty.call(this.monitoredItems, clientHandle)) {
          return;
        }
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(this.monitoredItems, clientHandle));
        const priv = monitoredItem;
        priv._terminate_and_emit();
      }
      _removeGroup(monitoredItemGroup) {
        monitoredItemGroup._terminate_and_emit();
        this.monitoredItemGroups = this.monitoredItemGroups.filter((obj) => obj !== monitoredItemGroup);
      }
      /**
       * @private
       * @param itemToMonitor
       * @param monitoringParameters
       * @param timestampsToReturn
       */
      _createMonitoredItem(itemToMonitor, monitoringParameters, timestampsToReturn, monitoringMode = node_opcua_service_subscription_1.MonitoringMode.Reporting) {
        const monitoredItem = new client_monitored_item_impl_1.ClientMonitoredItemImpl(this, itemToMonitor, monitoringParameters, timestampsToReturn, monitoringMode);
        return monitoredItem;
      }
    };
    exports2.ClientSubscriptionImpl = ClientSubscriptionImpl;
    function ClientMonitoredItem_create(subscription, itemToMonitor, monitoringParameters, timestampsToReturn, monitoringMode = node_opcua_service_subscription_1.MonitoringMode.Reporting, callback) {
      const monitoredItem = new client_monitored_item_impl_1.ClientMonitoredItemImpl(subscription, itemToMonitor, monitoringParameters, timestampsToReturn, monitoringMode);
      setImmediate(() => {
        subscription._wait_for_subscription_to_be_ready((err) => {
          if (err) {
            if (callback) {
              callback(err);
            }
            return;
          }
          client_monitored_item_toolbox_1.ClientMonitoredItemToolbox._toolbox_monitor(subscription, timestampsToReturn, [monitoredItem], (err1) => {
            if (err1) {
              monitoredItem._terminate_and_emit(err1);
            }
            if (callback) {
              callback(err1, monitoredItem);
            }
          });
        });
      });
      return monitoredItem;
    }
    exports2.ClientMonitoredItem_create = ClientMonitoredItem_create;
    var thenify = require_thenify();
    ClientSubscriptionImpl.prototype.setPublishingMode = thenify.withCallback(ClientSubscriptionImpl.prototype.setPublishingMode);
    ClientSubscriptionImpl.prototype.monitor = thenify.withCallback(ClientSubscriptionImpl.prototype.monitor);
    ClientSubscriptionImpl.prototype.monitorItems = thenify.withCallback(ClientSubscriptionImpl.prototype.monitorItems);
    ClientSubscriptionImpl.prototype.setTriggering = thenify.withCallback(ClientSubscriptionImpl.prototype.setTriggering);
    ClientSubscriptionImpl.prototype.modify = thenify.withCallback(ClientSubscriptionImpl.prototype.modify);
    ClientSubscriptionImpl.prototype.recreateSubscriptionAndMonitoredItem = thenify.withCallback(ClientSubscriptionImpl.prototype.recreateSubscriptionAndMonitoredItem);
    ClientSubscriptionImpl.prototype.terminate = thenify.withCallback(ClientSubscriptionImpl.prototype.terminate);
    ClientSubscriptionImpl.prototype.getMonitoredItems = thenify.withCallback(ClientSubscriptionImpl.prototype.getMonitoredItems);
    client_subscription_1.ClientSubscription.create = (clientSession, options) => {
      return new ClientSubscriptionImpl(clientSession, options);
    };
  }
});

// node_modules/node-opcua-client/dist/private/client_session_impl.js
var require_client_session_impl = __commonJS({
  "node_modules/node-opcua-client/dist/private/client_session_impl.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ClientSessionImpl = void 0;
    var events_1 = require("events");
    var util_1 = require("util");
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_client_dynamic_extension_object_1 = require_dist56();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_pseudo_session_1 = require_dist55();
    var node_opcua_secure_channel_1 = require_source7();
    var node_opcua_service_browse_1 = require_dist37();
    var node_opcua_service_call_1 = require_dist41();
    var node_opcua_service_history_1 = require_dist54();
    var node_opcua_service_query_1 = require_dist50();
    var node_opcua_service_read_1 = require_dist39();
    var node_opcua_service_register_node_1 = require_dist43();
    var node_opcua_service_subscription_1 = require_dist45();
    var node_opcua_service_translate_browse_path_1 = require_dist49();
    var node_opcua_service_write_1 = require_dist40();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_variant_1 = require_dist28();
    var client_session_keepalive_manager_1 = require_client_session_keepalive_manager();
    var reconnection_1 = require_reconnection();
    var client_publish_engine_1 = require_client_publish_engine();
    var client_subscription_impl_1 = require_client_subscription_impl();
    var helpAPIChange = process.env.DEBUG && process.env.DEBUG.match(/API/);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var pendingTransactionMessageDisplayed = false;
    function coerceBrowseDescription(data) {
      if (typeof data === "string" || data instanceof node_opcua_nodeid_1.NodeId) {
        return coerceBrowseDescription({
          browseDirection: node_opcua_data_model_1.BrowseDirection.Forward,
          includeSubtypes: true,
          nodeClassMask: 0,
          nodeId: data,
          referenceTypeId: "HierarchicalReferences",
          resultMask: 63
        });
      } else {
        data.nodeId = (0, node_opcua_nodeid_1.resolveNodeId)(data.nodeId);
        data.referenceTypeId = data.referenceTypeId ? (0, node_opcua_nodeid_1.resolveNodeId)(data.referenceTypeId) : null;
        return new node_opcua_service_browse_1.BrowseDescription(data);
      }
    }
    function coerceReadValueId(node) {
      if (typeof node === "string" || node instanceof node_opcua_nodeid_1.NodeId) {
        return new node_opcua_service_read_1.ReadValueId({
          attributeId: node_opcua_service_read_1.AttributeIds.Value,
          dataEncoding: void 0,
          // {namespaceIndex: 0, name: undefined}
          indexRange: void 0,
          nodeId: (0, node_opcua_nodeid_1.resolveNodeId)(node)
        });
      } else {
        (0, node_opcua_assert_1.assert)(node instanceof Object);
        return new node_opcua_service_read_1.ReadValueId(node);
      }
    }
    var emptyUint32Array = new Uint32Array(0);
    var ClientSessionImpl = class extends events_1.EventEmitter {
      constructor(client2) {
        super();
        this.name = "";
        this.serverEndpoints = [];
        this.recursive_repair_detector = 0;
        this.processTransactionQueue = (request, callback) => {
          this._reconnecting.pendingTransactionsCount = this._reconnecting.pendingTransactionsCount || 0;
          this._reconnecting.pendingTransactionsCount++;
          this._performMessageTransaction(request, (err, response) => {
            this._reconnecting.pendingTransactionsCount--;
            if (err && err.message.match(/BadSessionIdInvalid/) && request.constructor.name !== "ActivateSessionRequest") {
              debugLog("Transaction on Invalid Session ", request.constructor.name);
              request.requestHeader.requestHandle = node_opcua_secure_channel_1.requestHandleNotSetValue;
              warningLog("client is now attempting to recreate a session");
              this.recreate_session_and_reperform_transaction(request, callback);
              return;
            }
            callback(err, response);
            const length = this._reconnecting.pendingTransactions.length;
            if (length > 0) {
              debugLog("processTransactionQueue => ", this._reconnecting.pendingTransactions.length, " transaction(s) left in queue");
              const { request: request2, callback: callback2 } = this._reconnecting.pendingTransactions.shift();
              this.processTransactionQueue(request2, callback2);
            }
          });
        };
        this.serverCertificate = Buffer.alloc(0);
        this.sessionId = new node_opcua_nodeid_1.NodeId();
        this._closeEventHasBeenEmitted = false;
        this._client = client2;
        this._publishEngine = null;
        this._closed = false;
        this._reconnecting = {
          reconnecting: false,
          pendingCallbacks: [],
          pendingTransactions: [],
          pendingTransactionsCount: 0
        };
        this.requestedMaxReferencesPerNode = 1e4;
        this.lastRequestSentTime = new Date(1, 1, 1970);
        this.lastResponseReceivedTime = new Date(1, 1, 1970);
        this.timeout = 0;
      }
      getTransportSettings() {
        return this._client.getTransportSettings();
      }
      /**
       * the endpoint on which this session is operating
       * @property endpoint
       * @type {EndpointDescription}
       */
      get endpoint() {
        return this._client.endpoint;
      }
      get subscriptionCount() {
        return this._publishEngine ? this._publishEngine.subscriptionCount : 0;
      }
      get isReconnecting() {
        return this._client ? this._client.isReconnecting || this._reconnecting?.reconnecting : false;
      }
      getPublishEngine() {
        if (!this._publishEngine) {
          this._publishEngine = new client_publish_engine_1.ClientSidePublishEngine(this);
        }
        return this._publishEngine;
      }
      changeUser(userIdentityInfo, callback) {
        userIdentityInfo = userIdentityInfo || {
          type: node_opcua_types_1.UserTokenType.Anonymous
        };
        if (!this._client || !this.userIdentityInfo) {
          warningLog("changeUser: invalid session");
          return callback(null, node_opcua_status_code_1.StatusCodes.BadInternalError);
        }
        const old_userIdentity = this.userIdentityInfo;
        this._client._activateSession(this, userIdentityInfo, (err1, session2) => {
          if (err1) {
            this.userIdentityInfo = old_userIdentity;
            warningLog("activate session error = ", err1.message);
            return callback(null, node_opcua_status_code_1.StatusCodes.BadUserAccessDenied);
          }
          this.userIdentityInfo = userIdentityInfo;
          callback(null, node_opcua_status_code_1.StatusCodes.Good);
        });
      }
      /**
       * @internal
       * @param args
       */
      browse(...args) {
        const arg0 = args[0];
        const isArray = Array.isArray(arg0);
        const callback = args[1];
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        (0, node_opcua_assert_1.assert)(isFinite(this.requestedMaxReferencesPerNode));
        const nodesToBrowse = (isArray ? arg0 : [arg0]).map(coerceBrowseDescription);
        const request = new node_opcua_service_browse_1.BrowseRequest({
          nodesToBrowse,
          requestedMaxReferencesPerNode: this.requestedMaxReferencesPerNode
        });
        this.performMessageTransaction(request, (err, response) => {
          if (err) {
            return callback(err);
          }
          if (!response || !(response instanceof node_opcua_service_browse_1.BrowseResponse)) {
            return callback(new Error("Internal Error"));
          }
          const results = response.results ? response.results : [];
          if (this.requestedMaxReferencesPerNode > 0) {
            for (let i = 0; i < results.length; i++) {
              const r = results[i];
              if (r.references && r.references.length > this.requestedMaxReferencesPerNode) {
                warningLog(chalk_1.default.yellow("warning") + " BrowseResponse : the server didn't take into account our requestedMaxReferencesPerNode ");
                warningLog("        this.requestedMaxReferencesPerNode= " + this.requestedMaxReferencesPerNode);
                warningLog("        got " + r.references.length + "for " + nodesToBrowse[i].nodeId.toString());
                warningLog("        continuationPoint ", r.continuationPoint);
              }
            }
          }
          for (const r of results) {
            r.references = r.references || /* istanbul ignore next */
            [];
          }
          (0, node_opcua_assert_1.assert)(results[0] instanceof node_opcua_service_browse_1.BrowseResult);
          return callback(null, isArray ? results : results[0]);
        });
      }
      browseNext(...args) {
        const arg0 = args[0];
        const isArray = Array.isArray(arg0);
        const releaseContinuationPoints = args[1];
        const callback = args[2];
        (0, node_opcua_assert_1.assert)(typeof callback === "function", "expecting a callback function here");
        const continuationPoints = isArray ? arg0 : [arg0];
        const request = new node_opcua_types_1.BrowseNextRequest({
          continuationPoints,
          releaseContinuationPoints
        });
        this.performMessageTransaction(request, (err, response) => {
          if (err) {
            return callback(err);
          }
          if (!response || !(response instanceof node_opcua_types_1.BrowseNextResponse)) {
            return callback(new Error("Internal Error"));
          }
          const results = response.results ? response.results : [];
          for (const r of results) {
            r.references = r.references || [];
          }
          (0, node_opcua_assert_1.assert)(results[0] instanceof node_opcua_service_browse_1.BrowseResult);
          return callback(null, isArray ? results : results[0]);
        });
      }
      /**
       * @internal
       * @param args
       */
      readVariableValue(...args) {
        const callback = args[1];
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        const isArray = Array.isArray(args[0]);
        const nodes = isArray ? args[0] : [args[0]];
        const nodesToRead = nodes.map(coerceReadValueId);
        const request = new node_opcua_service_read_1.ReadRequest({
          nodesToRead,
          timestampsToReturn: node_opcua_service_read_1.TimestampsToReturn.Neither
        });
        this.performMessageTransaction(request, (err, response) => {
          if (err) {
            return callback(err);
          }
          if (!(response instanceof node_opcua_service_read_1.ReadResponse)) {
            return callback(new Error("Internal Error"));
          }
          if (response.responseHeader.serviceResult.isNot(node_opcua_status_code_1.StatusCodes.Good)) {
            return callback(new Error(response.responseHeader.serviceResult.toString()));
          }
          if (!response.results) {
            response.results = [];
          }
          (0, node_opcua_assert_1.assert)(nodes.length === response.results.length);
          callback(null, isArray ? response.results : response.results[0]);
        });
      }
      readHistoryValue(...args) {
        const startTime = args[1];
        const endTime = args[2];
        let options = {};
        let callback = args[3];
        if (typeof callback !== "function") {
          options = args[3];
          callback = args[4];
        }
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        options.numValuesPerNode = options.numValuesPerNode || 0;
        options.returnBounds = options.returnBounds || options.returnBounds === void 0 ? true : false;
        options.isReadModified = options.isReadModified || false;
        options.timestampsToReturn = options.timestampsToReturn || node_opcua_service_read_1.TimestampsToReturn.Both;
        const arg0 = args[0];
        const isArray = Array.isArray(arg0);
        const nodes = isArray ? arg0 : [arg0];
        const nodesToRead = [];
        for (const node of nodes) {
          if (!node.nodeId) {
            nodesToRead.push({
              continuationPoint: void 0,
              dataEncoding: void 0,
              // {namespaceIndex: 0, name: undefined},
              indexRange: void 0,
              nodeId: (0, node_opcua_nodeid_1.resolveNodeId)(node)
            });
          } else {
            nodesToRead.push(node);
          }
        }
        const readRawModifiedDetails = new node_opcua_service_history_1.ReadRawModifiedDetails({
          endTime,
          isReadModified: false,
          numValuesPerNode: options.numValuesPerNode,
          returnBounds: options.returnBounds,
          startTime
        });
        const request = new node_opcua_service_history_1.HistoryReadRequest({
          historyReadDetails: readRawModifiedDetails,
          nodesToRead,
          releaseContinuationPoints: false,
          timestampsToReturn: options.timestampsToReturn
        });
        request.nodesToRead = request.nodesToRead || [];
        (0, node_opcua_assert_1.assert)(nodes.length === request.nodesToRead.length);
        this.historyRead(request, (err, response) => {
          if (err) {
            return callback(err);
          }
          if (!response || !(response instanceof node_opcua_service_history_1.HistoryReadResponse)) {
            return callback(new Error("Internal Error"));
          }
          response.results = response.results || [];
          (0, node_opcua_assert_1.assert)(nodes.length === response.results.length);
          callback(null, isArray ? response.results : response.results[0]);
        });
      }
      historyRead(request, callback) {
        if (!callback) {
          throw new Error("expecting a callback");
        }
        this.performMessageTransaction(request, (err, response) => {
          if (err) {
            return callback(err);
          }
          if (!response || !(response instanceof node_opcua_service_history_1.HistoryReadResponse)) {
            return callback(new Error("Internal Error"));
          }
          if (response.responseHeader.serviceResult.isNot(node_opcua_status_code_1.StatusCodes.Good)) {
            return callback(new Error(response.responseHeader.serviceResult.toString()));
          }
          response.results = response.results || /* istanbul ignore next */
          [];
          callback(null, response);
        });
      }
      readAggregateValue(arg0, startTime, endTime, aggregateFn, processingInterval, ...args) {
        const callback = typeof args[0] === "function" ? args[0] : args[1];
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        const defaultAggregateFunction = {
          percentDataBad: 100,
          percentDataGood: 100,
          treatUncertainAsBad: true,
          useServerCapabilitiesDefaults: true,
          useSlopedExtrapolation: false
        };
        const aggregateConfiguration = typeof args[0] === "function" ? defaultAggregateFunction : args[0];
        const isArray = Array.isArray(arg0);
        const nodesToRead = isArray ? arg0 : [arg0];
        const aggregateFns = Array.isArray(aggregateFn) ? aggregateFn : [aggregateFn];
        (0, node_opcua_assert_1.assert)(aggregateFns.length === nodesToRead.length);
        const readProcessedDetails = new node_opcua_service_history_1.ReadProcessedDetails({
          aggregateType: aggregateFns,
          endTime,
          processingInterval,
          startTime,
          aggregateConfiguration
        });
        const request = new node_opcua_service_history_1.HistoryReadRequest({
          historyReadDetails: readProcessedDetails,
          nodesToRead,
          releaseContinuationPoints: false,
          timestampsToReturn: node_opcua_service_read_1.TimestampsToReturn.Both
        });
        (0, node_opcua_assert_1.assert)(nodesToRead.length === request.nodesToRead.length);
        this.performMessageTransaction(request, (err, response) => {
          if (err) {
            return callback(err);
          }
          if (!response || !(response instanceof node_opcua_service_history_1.HistoryReadResponse)) {
            return callback(new Error("Internal Error"));
          }
          if (response.responseHeader.serviceResult.isNot(node_opcua_status_code_1.StatusCodes.Good)) {
            return callback(new Error(response.responseHeader.serviceResult.toString()));
          }
          response.results = response.results || /* istanbul ignore next */
          [];
          (0, node_opcua_assert_1.assert)(nodesToRead.length === response.results.length);
          callback(null, isArray ? response.results : response.results[0]);
        });
      }
      /**
       * @internal
       * @param args
       */
      write(...args) {
        const arg0 = args[0];
        const isArray = Array.isArray(arg0);
        const nodesToWrite = isArray ? arg0 : [arg0];
        const callback = args[1];
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        const request = new node_opcua_service_write_1.WriteRequest({ nodesToWrite });
        this.performMessageTransaction(request, (err, response) => {
          if (err) {
            return callback(err, response);
          }
          if (!response || !(response instanceof node_opcua_service_write_1.WriteResponse)) {
            return callback(new Error("Internal Error"));
          }
          if (response.responseHeader.serviceResult.isNot(node_opcua_status_code_1.StatusCodes.Good)) {
            return callback(new Error(response.responseHeader.serviceResult.toString()));
          }
          response.results = response.results || /* istanbul ignore next */
          [];
          (0, node_opcua_assert_1.assert)(nodesToWrite.length === response.results.length);
          callback(null, isArray ? response.results : response.results[0]);
        });
      }
      writeSingleNode(...args) {
        const nodeId = args[0];
        const value = args[1];
        const callback = args[2];
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        const nodeToWrite = new node_opcua_service_write_1.WriteValue({
          attributeId: node_opcua_service_read_1.AttributeIds.Value,
          indexRange: void 0,
          nodeId: (0, node_opcua_nodeid_1.resolveNodeId)(nodeId),
          value: new node_opcua_data_value_1.DataValue({ value })
        });
        this.write(nodeToWrite, (err, statusCode) => {
          if (err) {
            return callback(err);
          }
          (0, node_opcua_assert_1.assert)(statusCode);
          callback(null, statusCode);
        });
      }
      readAllAttributes(...args) {
        const nodes = args[0];
        const callback = args[1];
        (0, node_opcua_pseudo_session_1.readAllAttributes)(this, nodes).then((data) => callback(null, data)).catch((err) => callback(err));
      }
      /**
       * @internal
       * @param args
       */
      read(...args) {
        if (args.length === 2) {
          return this.read(args[0], 0, args[1]);
        }
        (0, node_opcua_assert_1.assert)(args.length === 3);
        const isArray = Array.isArray(args[0]);
        const nodesToRead = isArray ? args[0] : [args[0]];
        (0, node_opcua_assert_1.assert)(Array.isArray(nodesToRead));
        const maxAge = args[1];
        const callback = args[2];
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        if (helpAPIChange) {
          if (!((0, node_opcua_utils_1.getFunctionParameterNames)(callback)[1] === "dataValues" || (0, node_opcua_utils_1.getFunctionParameterNames)(callback)[1] === "dataValue")) {
            warningLog(chalk_1.default.red("[NODE-OPCUA-E04] the ClientSession#read  API has changed !!, please fix the client code"));
            warningLog(chalk_1.default.red("   replace ..:"));
            warningLog(chalk_1.default.cyan("   session.read(nodesToRead,function(err,nodesToRead,results) {}"));
            warningLog(chalk_1.default.red("   with .... :"));
            warningLog(chalk_1.default.cyan("   session.read(nodesToRead,function(err,dataValues) {}"));
            warningLog("");
            warningLog(chalk_1.default.yellow("please make sure to refactor your code and check that the second argument of your callback function is named"), chalk_1.default.cyan("dataValue" + (isArray ? "s" : "")));
            warningLog(chalk_1.default.cyan("to make this exception disappear"));
            throw new Error("ERROR ClientSession#read  API has changed !!, please fix the client code");
          }
        }
        for (const node of nodesToRead) {
          node.nodeId = (0, node_opcua_nodeid_1.resolveNodeId)(node.nodeId);
        }
        const request = new node_opcua_service_read_1.ReadRequest({
          maxAge,
          nodesToRead,
          timestampsToReturn: node_opcua_service_read_1.TimestampsToReturn.Both
        });
        this.performMessageTransaction(request, (err, response) => {
          if (err) {
            return callback(err, response);
          }
          if (!response || !(response instanceof node_opcua_service_read_1.ReadResponse)) {
            return callback(new Error("Internal Error"));
          }
          promoteOpaqueStructureWithCallback(this, response.results, () => {
            response.results = response.results || /* istanbul ignore next */
            [];
            return callback(null, isArray ? response.results : response.results[0]);
          });
        });
      }
      emitCloseEvent(statusCode) {
        if (!this._closeEventHasBeenEmitted) {
          debugLog("ClientSession#emitCloseEvent");
          this._closeEventHasBeenEmitted = true;
          this.emit("session_closed", statusCode);
        }
      }
      createSubscription(options, callback) {
        this._defaultRequest(node_opcua_service_subscription_1.CreateSubscriptionRequest, node_opcua_service_subscription_1.CreateSubscriptionResponse, options, callback);
      }
      createSubscription2(...args) {
        const createSubscriptionRequest = args[0];
        let callback = args[1];
        const subscription = new client_subscription_impl_1.ClientSubscriptionImpl(this, createSubscriptionRequest);
        subscription.on("error", (err) => {
          if (callback) {
            callback(err);
            callback = null;
          }
        });
        subscription.on("started", () => {
          (0, node_opcua_assert_1.assert)(subscription.session === this, "expecting a session here");
          if (callback) {
            callback(null, subscription);
            callback = null;
          }
        });
      }
      deleteSubscriptions(options, callback) {
        this._defaultRequest(node_opcua_service_subscription_1.DeleteSubscriptionsRequest, node_opcua_service_subscription_1.DeleteSubscriptionsResponse, options, callback);
      }
      setTriggering(request, callback) {
        this._defaultRequest(node_opcua_service_subscription_1.SetTriggeringRequest, node_opcua_service_subscription_1.SetTriggeringResponse, request, callback);
      }
      /**
       * @method transferSubscriptions
       * @async
       */
      transferSubscriptions(options, callback) {
        this._defaultRequest(node_opcua_service_subscription_1.TransferSubscriptionsRequest, node_opcua_service_subscription_1.TransferSubscriptionsResponse, options, callback);
      }
      createMonitoredItems(options, callback) {
        this._defaultRequest(node_opcua_service_subscription_1.CreateMonitoredItemsRequest, node_opcua_service_subscription_1.CreateMonitoredItemsResponse, options, callback);
      }
      modifyMonitoredItems(options, callback) {
        this._defaultRequest(node_opcua_service_subscription_1.ModifyMonitoredItemsRequest, node_opcua_service_subscription_1.ModifyMonitoredItemsResponse, options, callback);
      }
      /**
       *
       * @method modifySubscription
       * @async
       * @param options {ModifySubscriptionRequest}
       * @param callback {Function}
       * @param callback.err {Error|null}   - the Error if the async method has failed
       * @param callback.response {ModifySubscriptionResponse} - the response
       */
      modifySubscription(options, callback) {
        this._defaultRequest(node_opcua_service_subscription_1.ModifySubscriptionRequest, node_opcua_service_subscription_1.ModifySubscriptionResponse, options, callback);
      }
      setMonitoringMode(options, callback) {
        this._defaultRequest(node_opcua_service_subscription_1.SetMonitoringModeRequest, node_opcua_service_subscription_1.SetMonitoringModeResponse, options, callback);
      }
      /**
       *
       * @method publish
       * @async
       * @param options  {PublishRequest}
       * @param callback {Function}
       * @param callback.err {Error|null}   - the Error if the async method has failed
       * @param callback.response {PublishResponse} - the response
       */
      publish(options, callback) {
        this._defaultRequest(node_opcua_service_subscription_1.PublishRequest, node_opcua_service_subscription_1.PublishResponse, options, callback);
      }
      /**
       *
       * @method republish
       * @async
       * @param options  {RepublishRequest}
       * @param callback the callback
       */
      republish(options, callback) {
        this._defaultRequest(node_opcua_service_subscription_1.RepublishRequest, node_opcua_service_subscription_1.RepublishResponse, options, callback);
      }
      /**
       *
       * @method deleteMonitoredItems
       * @async
       * @param options  {DeleteMonitoredItemsRequest}
       * @param callback {Function}
       * @param callback.err {Error|null}   - the Error if the async method has failed
       */
      deleteMonitoredItems(options, callback) {
        this._defaultRequest(node_opcua_service_subscription_1.DeleteMonitoredItemsRequest, node_opcua_service_subscription_1.DeleteMonitoredItemsResponse, options, callback);
      }
      /**
       * @internal
       */
      setPublishingMode(...args) {
        const publishingEnabled = args[0];
        const isArray = Array.isArray(args[1]);
        const subscriptionIds = isArray ? args[1] : [args[1]];
        const callback = args[2];
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        (0, node_opcua_assert_1.assert)(publishingEnabled === true || publishingEnabled === false);
        const options = new node_opcua_service_subscription_1.SetPublishingModeRequest({
          publishingEnabled,
          subscriptionIds
        });
        this._defaultRequest(node_opcua_service_subscription_1.SetPublishingModeRequest, node_opcua_service_subscription_1.SetPublishingModeResponse, options, (err, response) => {
          if (err) {
            return callback(err);
          }
          if (!response) {
            return callback(new Error("Internal Error"));
          }
          response.results = response.results || /* istanbul ignore next */
          [];
          callback(err, isArray ? response.results : response.results[0]);
        });
      }
      /**
       * @internal
       * @param args
       */
      translateBrowsePath(...args) {
        const isArray = Array.isArray(args[0]);
        const browsePaths = isArray ? args[0] : [args[0]];
        const callback = args[1];
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        const request = new node_opcua_service_translate_browse_path_1.TranslateBrowsePathsToNodeIdsRequest({ browsePaths });
        this.performMessageTransaction(request, (err, response) => {
          if (err) {
            return callback(err, response);
          }
          if (!response || !(response instanceof node_opcua_service_translate_browse_path_1.TranslateBrowsePathsToNodeIdsResponse)) {
            return callback(new Error("Internal Error"));
          }
          response.results = response.results || /* istanbul ignore next */
          [];
          callback(null, isArray ? response.results : response.results[0]);
        });
      }
      channelId() {
        return this._client !== null && this._client._secureChannel !== null && this._client._secureChannel.isOpened() ? this._client._secureChannel.channelId : -1;
      }
      isChannelValid() {
        if (!this._client) {
          debugLog(chalk_1.default.red("Warning SessionClient is null ?"));
        }
        return this._client !== null && this._client._secureChannel !== null && this._client._secureChannel.isOpened();
      }
      requestReconnection() {
        if (this._client) {
          this._client.requestReconnection();
          (0, node_opcua_assert_1.assert)(this._client.isReconnecting === true, "expecting client to be reconnecting now");
        }
      }
      performMessageTransaction(request, callback) {
        if (!this._client) {
          return callback(new Error("Session has been closed and should not be used to perform a transaction anymore"));
        }
        this._reconnecting.pendingTransactions = this._reconnecting.pendingTransactions || [];
        this._reconnecting.pendingTransactionsCount = this._reconnecting.pendingTransactionsCount || 0;
        const isPublishRequest = request instanceof node_opcua_service_subscription_1.PublishRequest;
        if (isPublishRequest) {
          return this._performMessageTransaction(request, callback);
        }
        if (this._reconnecting.pendingTransactionsCount > 0) {
          if (this._reconnecting.pendingTransactions.length > 10) {
            if (!pendingTransactionMessageDisplayed) {
              pendingTransactionMessageDisplayed = true;
              warningLog("[NODE-OPCUA-W21]", "Pending transactions: ", this._reconnecting.pendingTransactions.map((a) => a.request.constructor.name).join(" "));
              warningLog("[NODE-OPCUA-W22]", chalk_1.default.yellow("Warning : your opcua client is sending multiple requests simultaneously to the server", request.constructor.name), "\n", chalk_1.default.yellow(" please fix your application code"));
            }
          } else if (this._reconnecting.pendingTransactions.length > 3) {
            debugLog(chalk_1.default.yellow("Warning : your client is sending multiple requests simultaneously to the server", request.constructor.name));
          }
          this._reconnecting.pendingTransactions.push({ request, callback });
          return;
        }
        this.processTransactionQueue(request, callback);
      }
      _performMessageTransaction(request, callback) {
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        if (!this._client) {
          return callback(new Error("Session has been closed and should not be used to perform a transaction anymore"));
        }
        if (!this.isChannelValid()) {
          debugLog(chalk_1.default.bgWhite.red("!!! Performing transaction on invalid channel !!! ", request.constructor.name));
          return callback(new Error("Invalid Channel BadConnectionClosed"));
        }
        if (request.requestHeader) {
          request.requestHeader.authenticationToken = this.authenticationToken;
        }
        this.lastRequestSentTime = /* @__PURE__ */ new Date();
        this._client.performMessageTransaction(request, (err, response) => {
          this.lastResponseReceivedTime = /* @__PURE__ */ new Date();
          if (err) {
            if (response && response.responseHeader.serviceDiagnostics) {
              err.serviceDiagnostics = response.responseHeader.serviceDiagnostics;
            }
            if (response && response.diagnosticInfos) {
              err.diagnosticsInfo = response.diagnosticInfos;
            }
            return callback(err);
          }
          if (!response) {
            return callback(new Error("internal Error"));
          }
          if (response.responseHeader.serviceResult.isNot(node_opcua_status_code_1.StatusCodes.Good)) {
            err = new Error(" ServiceResult is " + response.responseHeader.serviceResult.toString() + " request was " + request.constructor.name);
            if (response && response.responseHeader.serviceDiagnostics) {
              err.serviceDiagnostics = response.responseHeader.serviceDiagnostics;
            }
            if (response && response.diagnosticInfos) {
              err.diagnosticsInfo = response.diagnosticInfos;
            }
            return callback(err, response);
          }
          return callback(null, response);
        });
      }
      /**
       *  evaluate the remaining time for the session
       *
       *
       * evaluate the time in milliseconds that the session will live
       * on the server end from now.
       * The remaining live time is calculated based on when the last message was sent to the server
       * and the session timeout.
       *
       * * In normal operation , when server and client communicates on a regular
       *   basis, evaluateRemainingLifetime will return a number slightly below
       *   session.timeout
       *
       * * when the client and server cannot communicate due to a network issue
       *   (or a server crash), evaluateRemainingLifetime returns the estimated number
       *   of milliseconds before the server (if not crash) will keep  the session alive
       *   on its end to allow a automatic reconnection with session.
       *
       * * When evaluateRemainingLifetime returns zero , this mean that
       *   the session has probably ended on the server side and will have to be recreated
       *   from scratch in case of a reconnection.
       *
       * @return the number of milliseconds before session expires
       */
      evaluateRemainingLifetime() {
        const now = Date.now();
        const expiryTime = this.lastRequestSentTime.getTime() + this.timeout;
        return Math.max(0, expiryTime - now);
      }
      _terminatePublishEngine() {
        if (this._publishEngine) {
          this._publishEngine.terminate();
          this._publishEngine = null;
        }
      }
      /**
       * @internal
       * @param args
       */
      close(...args) {
        if (arguments.length === 1) {
          return this.close(true, args[0]);
        }
        const deleteSubscription = args[0];
        const callback = args[1];
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        (0, node_opcua_assert_1.assert)(typeof deleteSubscription === "boolean");
        if (!this._client) {
          debugLog("ClientSession#close : warning, client is already closed");
          return callback();
        }
        (0, node_opcua_assert_1.assert)(this._client);
        this._terminatePublishEngine();
        this._client.closeSession(this, deleteSubscription, (err) => {
          debugLog("session Close err ", err ? err.message : "null");
          callback();
        });
      }
      /**
       * @method hasBeenClosed
       * @return {Boolean}
       */
      hasBeenClosed() {
        return (0, node_opcua_utils_1.isNullOrUndefined)(this._client) || this._closed || this._closeEventHasBeenEmitted;
      }
      /**
       * @internal
       * @param args
       */
      call(...args) {
        const isArray = Array.isArray(args[0]);
        const methodsToCall = isArray ? args[0] : [args[0]];
        (0, node_opcua_assert_1.assert)(Array.isArray(methodsToCall));
        const callback = args[1];
        const request = new node_opcua_service_call_1.CallRequest({ methodsToCall });
        this.performMessageTransaction(request, (err, response) => {
          if (err) {
            return callback(err);
          }
          if (!response || !(response instanceof node_opcua_service_call_1.CallResponse)) {
            return callback(new Error("internal error"));
          }
          response.results = response.results || [];
          promoteOpaqueStructure3WithCallback(this, response.results, () => {
            callback(null, isArray ? response.results : response.results[0]);
          });
        });
      }
      getMonitoredItems(...args) {
        const subscriptionId = args[0];
        const callback = args[1];
        const methodsToCall = new node_opcua_service_call_1.CallMethodRequest({
          inputArguments: [
            // BaseDataType
            { dataType: node_opcua_variant_1.DataType.UInt32, value: subscriptionId }
          ],
          methodId: (0, node_opcua_nodeid_1.coerceNodeId)("ns=0;i=11492"),
          // MethodIds.Server_GetMonitoredItems;
          objectId: (0, node_opcua_nodeid_1.coerceNodeId)("ns=0;i=2253")
          // ObjectId.Server
        });
        this.call(methodsToCall, (err, result2) => {
          if (err) {
            return callback(err);
          }
          if (!result2) {
            return callback(new Error("internal error"));
          }
          if (result2.statusCode.isNot(node_opcua_status_code_1.StatusCodes.Good)) {
            callback(new Error(result2.statusCode.toString()));
          } else {
            result2.outputArguments = result2.outputArguments || [];
            (0, node_opcua_assert_1.assert)(result2.outputArguments.length === 2);
            const data = {
              clientHandles: result2.outputArguments[1].value,
              serverHandles: result2.outputArguments[0].value
              //
            };
            data.serverHandles = data.serverHandles || /* istanbul ignore next */
            emptyUint32Array;
            data.clientHandles = data.clientHandles || /* istanbul ignore next */
            emptyUint32Array;
            (0, node_opcua_assert_1.assert)(data.serverHandles instanceof Uint32Array);
            (0, node_opcua_assert_1.assert)(data.clientHandles instanceof Uint32Array);
            callback(null, data);
          }
        });
      }
      /**
       * @internal
       */
      getArgumentDefinition(...args) {
        const methodId = args[0];
        const callback = args[1];
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        return (0, node_opcua_pseudo_session_1.getArgumentDefinitionHelper)(this, methodId).then((result2) => {
          callback(null, result2);
        }).catch((err) => {
          callback(err);
        });
      }
      registerNodes(...args) {
        const nodesToRegister = args[0];
        const callback = args[1];
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        (0, node_opcua_assert_1.assert)(Array.isArray(nodesToRegister));
        const request = new node_opcua_service_register_node_1.RegisterNodesRequest({
          nodesToRegister: nodesToRegister.map(node_opcua_nodeid_1.resolveNodeId)
        });
        this.performMessageTransaction(request, (err, response) => {
          if (err) {
            return callback(err);
          }
          if (!response || !(response instanceof node_opcua_service_register_node_1.RegisterNodesResponse)) {
            return callback(new Error("Internal Error"));
          }
          response.registeredNodeIds = response.registeredNodeIds || /* istanbul ignore next */
          [];
          callback(null, response.registeredNodeIds);
        });
      }
      unregisterNodes(...args) {
        const nodesToUnregister = args[0];
        const callback = args[1];
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        (0, node_opcua_assert_1.assert)(Array.isArray(nodesToUnregister));
        const request = new node_opcua_service_register_node_1.UnregisterNodesRequest({
          nodesToUnregister: nodesToUnregister.map(node_opcua_nodeid_1.resolveNodeId)
        });
        this.performMessageTransaction(request, (err, response) => {
          if (err) {
            return callback(err);
          }
          if (!response || !(response instanceof node_opcua_service_register_node_1.UnregisterNodesResponse)) {
            return callback(new Error("Internal Error"));
          }
          callback();
        });
      }
      queryFirst(...args) {
        const queryFirstRequest = args[0];
        const callback = args[1];
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        const request = new node_opcua_service_query_1.QueryFirstRequest(queryFirstRequest);
        this.performMessageTransaction(request, (err, response) => {
          if (err) {
            return callback(err);
          }
          if (!response || !(response instanceof node_opcua_service_query_1.QueryFirstResponse)) {
            return callback(new Error("internal error"));
          }
          callback(null, response);
        });
      }
      startKeepAliveManager(keepAliveInterval) {
        if (this._keepAliveManager) {
          return;
        }
        this._keepAliveManager = new client_session_keepalive_manager_1.ClientSessionKeepAliveManager(this);
        this._keepAliveManager.on("failure", () => {
          this.emit("keepalive_failure");
        });
        this._keepAliveManager.on("keepalive", (state, count) => {
          this.emit("keepalive", state, count);
        });
        this._keepAliveManager.start(keepAliveInterval);
      }
      stopKeepAliveManager() {
        if (this._keepAliveManager) {
          this._keepAliveManager.stop();
          this._keepAliveManager = void 0;
        }
      }
      dispose() {
        (0, node_opcua_assert_1.assert)(this._closeEventHasBeenEmitted);
        this._terminatePublishEngine();
        this.stopKeepAliveManager();
        this.removeAllListeners();
        const privateThis = this;
        if (!(!privateThis.pendingTransactions || privateThis.pendingTransactions.length === 0)) {
          warningLog("dispose when pendingTransactions is not empty ");
        }
      }
      toString() {
        const now = Date.now();
        const lap1 = now - this.lastRequestSentTime.getTime();
        const lap2 = now - this.lastResponseReceivedTime.getTime();
        const timeoutDelay = this.timeout - lap1;
        const timeoutInfo = timeoutDelay < 0 ? chalk_1.default.red(" expired since " + -timeoutDelay / 1e3 + " seconds") : chalk_1.default.green(" timeout in " + timeoutDelay / 1e3 + " seconds");
        let str = "";
        str += " name..................... " + this.name;
        str += "\n sessionId................ " + this.sessionId.toString();
        str += "\n authenticationToken...... " + (this.authenticationToken ? this.authenticationToken.toString() : "");
        str += "\n timeout.................. " + this.timeout + "ms" + timeoutInfo;
        str += "\n serverNonce.............. " + (this.serverNonce ? this.serverNonce.toString("hex") : "");
        str += "\n serverCertificate........ " + (0, node_opcua_utils_1.buffer_ellipsis)(this.serverCertificate);
        str += "\n serverSignature.......... " + this.serverSignature;
        str += "\n lastRequestSentTime...... " + new Date(this.lastRequestSentTime).toISOString() + "  (" + lap1 + ")";
        str += "\n lastResponseReceivedTime. " + new Date(this.lastResponseReceivedTime).toISOString() + " (" + lap2 + ")";
        str += "\n isReconnecting........... " + this.isReconnecting;
        str += "\n isValidChannel........... " + this.isChannelValid() + " has been closed  " + this.hasBeenClosed();
        str += "\n channelId................ " + this.channelId();
        str += "\n remaining life time...... " + this.evaluateRemainingLifetime();
        str += "\n subscription count....... " + this.subscriptionCount;
        if (this._client && this._client._secureChannel) {
          if (this._client._secureChannel.securityToken) {
            str += "\n reviseTokenLifetime...... " + this._client._secureChannel.securityToken.revisedLifetime;
          }
        }
        str += "\n keepAlive ................ " + this._keepAliveManager ? true : false;
        if (this._keepAliveManager) {
          str += "\n keepAlive checkInterval.. " + this._keepAliveManager.checkInterval;
          str += "\n defaultTransportTimeout.. " + node_opcua_secure_channel_1.ClientSecureChannelLayer.defaultTransportTimeout;
        }
        return str;
      }
      getBuiltInDataType(...args) {
        const nodeId = args[0];
        const callback = args[1];
        return (0, node_opcua_pseudo_session_1.getBuiltInDataType)(this, nodeId).then((dataType) => callback(null, dataType)).catch(callback);
      }
      resumePublishEngine() {
        (0, node_opcua_assert_1.assert)(this._publishEngine);
        if (this._publishEngine && this._publishEngine.subscriptionCount > 0) {
          this._publishEngine.replenish_publish_request_queue();
        }
      }
      readNamespaceArray(...args) {
        const callback = args[0];
        this.read({
          attributeId: node_opcua_service_read_1.AttributeIds.Value,
          nodeId: (0, node_opcua_nodeid_1.resolveNodeId)("Server_NamespaceArray")
        }, (err, dataValue) => {
          if (err) {
            return callback(err);
          }
          if (!dataValue) {
            return callback(new Error("Internal Error"));
          }
          if (dataValue.statusCode.isNotGood()) {
            return callback(new Error("readNamespaceArray : " + dataValue.statusCode.toString()));
          }
          (0, node_opcua_assert_1.assert)(dataValue.value.value instanceof Array);
          this._namespaceArray = dataValue.value.value;
          callback(null, this._namespaceArray);
        });
      }
      getNamespaceIndex(namespaceUri) {
        (0, node_opcua_assert_1.assert)(this._namespaceArray, "please make sure that readNamespaceArray has been called");
        return this._namespaceArray.indexOf(namespaceUri);
      }
      // tslint:disable:no-empty
      // ---------------------------------------- Alarm & condition stub
      disableCondition() {
      }
      enableCondition() {
      }
      addCommentCondition(_conditionId, _eventId, _comment, _callback) {
      }
      confirmCondition(_conditionId, _eventId, _comment, _callback) {
      }
      acknowledgeCondition(_conditionId, _eventId, _comment, _callback) {
      }
      /**
       * @deprecated
       * @private
       */
      findMethodId(_nodeId, _methodName, _callback) {
      }
      _callMethodCondition(_methodName, _conditionId, _eventId, _comment, _callback) {
      }
      async extractNamespaceDataType() {
        return (0, node_opcua_client_dynamic_extension_object_1.getExtraDataTypeManager)(this);
      }
      async getExtensionObjectConstructor(dataTypeNodeId) {
        return (0, node_opcua_client_dynamic_extension_object_1.getExtensionObjectConstructor)(this, dataTypeNodeId);
      }
      /**
       *
       * @param dataType
       * @param pojo
       * @async
       */
      async constructExtensionObject(dataType, pojo) {
        const Constructor = await this.getExtensionObjectConstructor(dataType);
        return new Constructor(pojo);
      }
      _defaultRequest(requestClass, _responseClass, options, callback) {
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        const request = options instanceof requestClass ? options : new requestClass(options);
        if (doDebug) {
          request.trace = new Error("").stack;
        }
        if (this._closeEventHasBeenEmitted) {
          debugLog("ClientSession#_defaultRequest => session has been closed !!", request.toString());
          setImmediate(() => {
            callback(new Error("ClientSession is closed !"));
          });
          return;
        }
        this.performMessageTransaction(request, (err, response) => {
          if (this._closeEventHasBeenEmitted) {
            debugLog("ClientSession#_defaultRequest ... err =", err ? err.message : "null", response ? response.toString() : " null");
          }
          if (err) {
            debugLog("Client session : performMessageTransaction error = ", err.message);
            if (err.message.match(/BadSessionClosed/)) {
              const now = Date.now();
              if (doDebug) {
                debugLog(chalk_1.default.bgWhite.red(" server send BadSessionClosed !"));
                debugLog(chalk_1.default.bgWhite.red(" request was               "), request.toString());
                debugLog(" timeout.................. ", this.timeout);
                debugLog(" lastRequestSentTime...... ", new Date(this.lastRequestSentTime).toISOString(), now - this.lastRequestSentTime.getTime());
                debugLog(" lastResponseReceivedTime. ", new Date(this.lastResponseReceivedTime).toISOString(), now - this.lastResponseReceivedTime.getTime());
              }
              if (false) {
                this.emitCloseEvent(node_opcua_status_code_1.StatusCodes.BadSessionClosed);
              }
            }
            return callback(err, response);
          }
          callback(null, response);
        });
      }
      recreate_session_and_reperform_transaction(request, callback) {
        if (this.recursive_repair_detector >= 1) {
          warningLog("recreate_session_and_reperform_transaction => Already in Progress");
          return callback(new Error("Cannot recreate session"));
        }
        this.recursive_repair_detector += 1;
        debugLog(chalk_1.default.red("----------------> Repairing Client Session as Server believes it is invalid now "));
        (0, reconnection_1.repair_client_session)(this._client, this, (err) => {
          this.recursive_repair_detector -= 1;
          if (err) {
            debugLog(chalk_1.default.red("----------------> session Repaired has failed with error", err.message));
            return callback(err);
          }
          debugLog(chalk_1.default.red("----------------> session Repaired, now redoing original transaction "));
          this._performMessageTransaction(request, callback);
        });
      }
    };
    exports2.ClientSessionImpl = ClientSessionImpl;
    async function promoteOpaqueStructure2(session, callMethodResult) {
      if (!callMethodResult || !callMethodResult.outputArguments || callMethodResult.outputArguments.length === 0) {
        return;
      }
      await (0, node_opcua_client_dynamic_extension_object_1.promoteOpaqueStructure)(session, callMethodResult.outputArguments.map((a) => ({ value: a })));
    }
    function countOpaqueStructures(callMethodResults) {
      const x2 = (a) => {
        if (a === null)
          return [];
        return a.map((value) => {
          return { value };
        });
      };
      const opaqueStructureCount = callMethodResults.reduce((prev, callMethodResult) => {
        return prev + (0, node_opcua_client_dynamic_extension_object_1.extractDataValueToPromote)(x2(callMethodResult.outputArguments)).length;
      }, 0);
      return opaqueStructureCount;
    }
    async function promoteOpaqueStructure3(session, callMethodResults) {
      const opaqueStructureCount = countOpaqueStructures(callMethodResults);
      if (0 === opaqueStructureCount)
        return;
      await (0, node_opcua_client_dynamic_extension_object_1.getExtraDataTypeManager)(session);
      const promises = callMethodResults.map(async (x2) => promoteOpaqueStructure2(session, x2));
      await Promise.all(promises);
    }
    var thenify = require_thenify();
    var opts = { multiArgs: false };
    var promoteOpaqueStructureWithCallback = (0, util_1.callbackify)(node_opcua_client_dynamic_extension_object_1.promoteOpaqueStructure);
    var promoteOpaqueStructure3WithCallback = (0, util_1.callbackify)(promoteOpaqueStructure3);
    ClientSessionImpl.prototype.browse = thenify.withCallback(ClientSessionImpl.prototype.browse, opts);
    ClientSessionImpl.prototype.browseNext = thenify.withCallback(ClientSessionImpl.prototype.browseNext, opts);
    ClientSessionImpl.prototype.readVariableValue = thenify.withCallback(ClientSessionImpl.prototype.readVariableValue, opts);
    ClientSessionImpl.prototype.readHistoryValue = thenify.withCallback(ClientSessionImpl.prototype.readHistoryValue, opts);
    ClientSessionImpl.prototype.readAggregateValue = thenify.withCallback(ClientSessionImpl.prototype.readAggregateValue, opts);
    ClientSessionImpl.prototype.historyRead = thenify.withCallback(ClientSessionImpl.prototype.historyRead, opts);
    ClientSessionImpl.prototype.write = thenify.withCallback(ClientSessionImpl.prototype.write, opts);
    ClientSessionImpl.prototype.writeSingleNode = thenify.withCallback(ClientSessionImpl.prototype.writeSingleNode, opts);
    ClientSessionImpl.prototype.readAllAttributes = thenify.withCallback(ClientSessionImpl.prototype.readAllAttributes, opts);
    ClientSessionImpl.prototype.read = thenify.withCallback(ClientSessionImpl.prototype.read, opts);
    ClientSessionImpl.prototype.createSubscription = thenify.withCallback(ClientSessionImpl.prototype.createSubscription, opts);
    ClientSessionImpl.prototype.createSubscription2 = thenify.withCallback(ClientSessionImpl.prototype.createSubscription2, opts);
    ClientSessionImpl.prototype.deleteSubscriptions = thenify.withCallback(ClientSessionImpl.prototype.deleteSubscriptions, opts);
    ClientSessionImpl.prototype.transferSubscriptions = thenify.withCallback(ClientSessionImpl.prototype.transferSubscriptions, opts);
    ClientSessionImpl.prototype.createMonitoredItems = thenify.withCallback(ClientSessionImpl.prototype.createMonitoredItems, opts);
    ClientSessionImpl.prototype.modifyMonitoredItems = thenify.withCallback(ClientSessionImpl.prototype.modifyMonitoredItems, opts);
    ClientSessionImpl.prototype.modifySubscription = thenify.withCallback(ClientSessionImpl.prototype.modifySubscription, opts);
    ClientSessionImpl.prototype.setTriggering = thenify.withCallback(ClientSessionImpl.prototype.setTriggering, opts);
    ClientSessionImpl.prototype.setMonitoringMode = thenify.withCallback(ClientSessionImpl.prototype.setMonitoringMode, opts);
    ClientSessionImpl.prototype.publish = thenify.withCallback(ClientSessionImpl.prototype.publish, opts);
    ClientSessionImpl.prototype.republish = thenify.withCallback(ClientSessionImpl.prototype.republish, opts);
    ClientSessionImpl.prototype.deleteMonitoredItems = thenify.withCallback(ClientSessionImpl.prototype.deleteMonitoredItems, opts);
    ClientSessionImpl.prototype.setPublishingMode = thenify.withCallback(ClientSessionImpl.prototype.setPublishingMode, opts);
    ClientSessionImpl.prototype.translateBrowsePath = thenify.withCallback(ClientSessionImpl.prototype.translateBrowsePath, opts);
    ClientSessionImpl.prototype.performMessageTransaction = thenify.withCallback(ClientSessionImpl.prototype.performMessageTransaction, opts);
    ClientSessionImpl.prototype.close = thenify.withCallback(ClientSessionImpl.prototype.close, opts);
    ClientSessionImpl.prototype.call = thenify.withCallback(ClientSessionImpl.prototype.call, opts);
    ClientSessionImpl.prototype.getMonitoredItems = thenify.withCallback(ClientSessionImpl.prototype.getMonitoredItems, opts);
    ClientSessionImpl.prototype.getArgumentDefinition = thenify.withCallback(ClientSessionImpl.prototype.getArgumentDefinition, opts);
    ClientSessionImpl.prototype.queryFirst = thenify.withCallback(ClientSessionImpl.prototype.queryFirst, opts);
    ClientSessionImpl.prototype.registerNodes = thenify.withCallback(ClientSessionImpl.prototype.registerNodes, opts);
    ClientSessionImpl.prototype.unregisterNodes = thenify.withCallback(ClientSessionImpl.prototype.unregisterNodes, opts);
    ClientSessionImpl.prototype.readNamespaceArray = thenify.withCallback(ClientSessionImpl.prototype.readNamespaceArray, opts);
    ClientSessionImpl.prototype.getBuiltInDataType = thenify.withCallback(ClientSessionImpl.prototype.getBuiltInDataType, opts);
    ClientSessionImpl.prototype.changeUser = thenify.withCallback(ClientSessionImpl.prototype.changeUser, opts);
  }
});

// node_modules/node-opcua-client/dist/private/opcua_client_impl.js
var require_opcua_client_impl = __commonJS({
  "node_modules/node-opcua-client/dist/private/opcua_client_impl.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OPCUAClientImpl = void 0;
    var util_1 = require("util");
    var crypto_1 = require("crypto");
    var async_1 = __importDefault3(require_async());
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_buffer_utils_1 = require_dist15();
    var node_opcua_crypto_1 = require_dist33();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_hostname_1 = require_dist36();
    var node_opcua_secure_channel_1 = require_source7();
    var node_opcua_service_endpoints_1 = require_dist44();
    var node_opcua_service_secure_channel_1 = require_dist38();
    var node_opcua_service_session_1 = require_dist42();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_utils_1 = require_dist16();
    var opcua_client_1 = require_opcua_client();
    var reconnection_1 = require_reconnection();
    var client_base_impl_1 = require_client_base_impl();
    var client_session_impl_1 = require_client_session_impl();
    var client_subscription_impl_1 = require_client_subscription_impl();
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    function validateServerNonce(serverNonce) {
      return !(serverNonce && serverNonce.length < 32) || serverNonce && serverNonce.length === 0;
    }
    function verifyEndpointDescriptionMatches(client2, responseServerEndpoints) {
      return true;
    }
    var hasDeprecatedSecurityPolicy = (userIdentity) => {
      return userIdentity.securityPolicyUri === node_opcua_secure_channel_1.SecurityPolicy.Basic128Rsa15 || userIdentity.securityPolicyUri === node_opcua_secure_channel_1.SecurityPolicy.Basic128;
    };
    var ordered = [
      // obsolete
      node_opcua_secure_channel_1.SecurityPolicy.Basic128Rsa15,
      node_opcua_secure_channel_1.SecurityPolicy.Basic192Rsa15,
      node_opcua_secure_channel_1.SecurityPolicy.Basic256,
      node_opcua_secure_channel_1.SecurityPolicy.None,
      node_opcua_secure_channel_1.SecurityPolicy.Basic128,
      node_opcua_secure_channel_1.SecurityPolicy.Basic192,
      node_opcua_secure_channel_1.SecurityPolicy.Basic256Rsa15,
      node_opcua_secure_channel_1.SecurityPolicy.Basic256Sha256,
      node_opcua_secure_channel_1.SecurityPolicy.Aes128_Sha256_RsaOaep,
      node_opcua_secure_channel_1.SecurityPolicy.Aes256_Sha256_RsaPss
    ];
    var _compareSecurityPolicy = (a, b) => {
      if (a === b) {
        return 0;
      }
      if (!a && b)
        return 1;
      if (a && !b)
        return -1;
      const rankA = ordered.indexOf(a);
      const rankB = ordered.indexOf(b);
      return rankB - rankA;
    };
    var compareSecurityPolicy = (a, b) => {
      return _compareSecurityPolicy(a.securityPolicyUri, b.securityPolicyUri);
    };
    function findUserTokenPolicy(endpointDescription, userTokenType) {
      endpointDescription.userIdentityTokens = endpointDescription.userIdentityTokens || [];
      let r = endpointDescription.userIdentityTokens.filter((userIdentity) => userIdentity.tokenType === userTokenType);
      if (r.length === 0) {
        return null;
      }
      if (r.length > 1) {
        r = r.filter((userIdentity) => !hasDeprecatedSecurityPolicy(userIdentity));
      }
      if (r.length > 1) {
        if (endpointDescription.securityMode === node_opcua_service_secure_channel_1.MessageSecurityMode.SignAndEncrypt) {
          const unencrypted = r.find((userIdentity) => userIdentity.securityPolicyUri === node_opcua_secure_channel_1.SecurityPolicy.None || !userIdentity.securityPolicyUri);
          if (unencrypted)
            return unencrypted;
        }
        r = r.sort(compareSecurityPolicy);
      }
      return r.length === 0 ? null : r[0];
    }
    function createAnonymousIdentityToken(context) {
      const endpoint = context.endpoint;
      const userTokenPolicy = findUserTokenPolicy(endpoint, node_opcua_service_endpoints_1.UserTokenType.Anonymous);
      if (!userTokenPolicy) {
        throw new Error("Cannot find ANONYMOUS user token policy in end point description");
      }
      return new node_opcua_service_session_1.AnonymousIdentityToken({ policyId: userTokenPolicy.policyId });
    }
    function createX509IdentityToken(context, certificate, privateKey) {
      const endpoint = context.endpoint;
      (0, node_opcua_assert_1.assert)(endpoint instanceof node_opcua_service_endpoints_1.EndpointDescription);
      const userTokenPolicy = findUserTokenPolicy(endpoint, node_opcua_service_endpoints_1.UserTokenType.Certificate);
      if (!userTokenPolicy) {
        throw new Error("Cannot find Certificate (X509) user token policy in end point description");
      }
      let securityPolicy = (0, node_opcua_secure_channel_1.fromURI)(userTokenPolicy.securityPolicyUri);
      if (securityPolicy === node_opcua_secure_channel_1.SecurityPolicy.Invalid) {
        securityPolicy = context.securityPolicy;
      }
      const userIdentityToken = new node_opcua_service_session_1.X509IdentityToken({
        certificateData: certificate,
        policyId: userTokenPolicy.policyId
      });
      const serverCertificate = context.serverCertificate;
      (0, node_opcua_assert_1.assert)(serverCertificate instanceof Buffer);
      const serverNonce = context.serverNonce || Buffer.alloc(0);
      (0, node_opcua_assert_1.assert)(serverNonce instanceof Buffer);
      const cryptoFactory = (0, node_opcua_secure_channel_1.getCryptoFactory)(securityPolicy);
      if (!cryptoFactory) {
        throw new Error(" Unsupported security Policy");
      }
      const userTokenSignature = (0, node_opcua_secure_channel_1.computeSignature)(serverCertificate, serverNonce, privateKey, securityPolicy);
      return { userIdentityToken, userTokenSignature };
    }
    function createUserNameIdentityToken(session, userName, password) {
      (0, node_opcua_assert_1.assert)(userName === null || typeof userName === "string");
      (0, node_opcua_assert_1.assert)(password === null || typeof password === "string");
      const endpoint = session.endpoint;
      (0, node_opcua_assert_1.assert)(endpoint instanceof node_opcua_service_endpoints_1.EndpointDescription);
      const userTokenPolicy = findUserTokenPolicy(endpoint, node_opcua_service_endpoints_1.UserTokenType.UserName);
      if (!userTokenPolicy) {
        throw new Error("Cannot find USERNAME user token policy in end point description");
      }
      let securityPolicy = (0, node_opcua_secure_channel_1.fromURI)(userTokenPolicy.securityPolicyUri);
      if (securityPolicy === node_opcua_secure_channel_1.SecurityPolicy.Invalid) {
        securityPolicy = session.securityPolicy;
      }
      let identityToken;
      let serverCertificate = session.serverCertificate;
      if (!serverCertificate) {
        identityToken = new node_opcua_service_session_1.UserNameIdentityToken({
          encryptionAlgorithm: null,
          password: Buffer.from(password, "utf-8"),
          policyId: userTokenPolicy ? userTokenPolicy.policyId : null,
          userName
        });
        return identityToken;
      }
      (0, node_opcua_assert_1.assert)(serverCertificate instanceof Buffer);
      serverCertificate = (0, node_opcua_crypto_1.toPem)(serverCertificate, "CERTIFICATE");
      const publicKey = (0, crypto_1.createPublicKey)((0, node_opcua_crypto_1.extractPublicKeyFromCertificateSync)(serverCertificate));
      const serverNonce = session.serverNonce || Buffer.alloc(0);
      (0, node_opcua_assert_1.assert)(serverNonce instanceof Buffer);
      if (securityPolicy === node_opcua_secure_channel_1.SecurityPolicy.None) {
        identityToken = new node_opcua_service_session_1.UserNameIdentityToken({
          encryptionAlgorithm: null,
          password: Buffer.from(password, "utf-8"),
          policyId: userTokenPolicy.policyId,
          userName
        });
        return identityToken;
      }
      const cryptoFactory = (0, node_opcua_secure_channel_1.getCryptoFactory)(securityPolicy);
      if (!cryptoFactory) {
        throw new Error(" Unsupported security Policy " + securityPolicy.toString());
      }
      identityToken = new node_opcua_service_session_1.UserNameIdentityToken({
        encryptionAlgorithm: cryptoFactory.asymmetricEncryptionAlgorithm,
        password: Buffer.from(password, "utf-8"),
        policyId: userTokenPolicy.policyId,
        userName
      });
      const lenBuf = (0, node_opcua_buffer_utils_1.createFastUninitializedBuffer)(4);
      lenBuf.writeUInt32LE(identityToken.password.length + serverNonce.length, 0);
      const block = Buffer.concat([lenBuf, identityToken.password, serverNonce]);
      identityToken.password = cryptoFactory.asymmetricEncrypt(block, publicKey);
      return identityToken;
    }
    function _adjustRevisedSessionTimeout(revisedSessionTimeout, requestedTimeout) {
      if (revisedSessionTimeout < 1e-10) {
        warningLog(`the revisedSessionTimeout ${revisedSessionTimeout} reported by the server is inconsistent and has been adjusted back to requestedTimeout ${requestedTimeout}`);
        return requestedTimeout;
      }
      if (revisedSessionTimeout < OPCUAClientImpl.minimumRevisedSessionTimeout) {
        warningLog(`the revisedSessionTimeout ${revisedSessionTimeout} is smaller than the minimum timeout (OPCUAClientImpl.minimumRevisedSessionTimeout = ${OPCUAClientImpl.minimumRevisedSessionTimeout}) and has been clamped to this value`);
        return OPCUAClientImpl.minimumRevisedSessionTimeout;
      }
      return revisedSessionTimeout;
    }
    var OPCUAClientImpl = class _OPCUAClientImpl extends client_base_impl_1.ClientBaseImpl {
      static create(options) {
        return new _OPCUAClientImpl(options);
      }
      constructor(options) {
        options = options || {};
        super(options);
        if (Object.prototype.hasOwnProperty.call(options, "endpoint_must_exist")) {
          if (Object.prototype.hasOwnProperty.call(options, "endpointMustExist")) {
            throw new Error("endpoint_must_exist is deprecated! you must now use endpointMustExist instead of endpoint_must_exist ");
          }
          warningLog("Warning: endpoint_must_exist is now deprecated, use endpointMustExist instead");
          options.endpointMustExist = options.endpoint_must_exist;
        }
        this.endpointMustExist = (0, node_opcua_utils_1.isNullOrUndefined)(options.endpointMustExist) ? true : !!options.endpointMustExist;
        this.requestedSessionTimeout = options.requestedSessionTimeout || 6e4;
        this.___sessionName_counter = 0;
        this.endpoint = void 0;
      }
      /**
       * @internal
       * @param args
       *
       */
      createSession(...args) {
        if (args.length === 1) {
          return this.createSession({ type: node_opcua_service_endpoints_1.UserTokenType.Anonymous }, args[0]);
        }
        const userIdentityInfo = args[0] || { type: node_opcua_service_endpoints_1.UserTokenType.Anonymous };
        const callback = args[1];
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        this._createSession((err, session) => {
          if (err) {
            callback(err);
          } else {
            if (!session) {
              return callback(new Error("Internal Error"));
            }
            this._addSession(session);
            this._activateSession(session, userIdentityInfo, (err1, session2) => {
              callback(err1, session2);
            });
          }
        });
      }
      createSession2(...args) {
        if (args.length === 1) {
          return this.createSession2({ type: node_opcua_service_endpoints_1.UserTokenType.Anonymous }, args[0]);
        }
        const userIdentityInfo = args[0];
        const callback = args[1];
        if (!this._secureChannel) {
          return callback(new Error("Connection is closed"));
        }
        if (this._internalState === "disconnected" || this._internalState === "disconnecting") {
          return callback(new Error(`disconnecting`));
        }
        return this.createSession(args[0], (err, session) => {
          if (err && err.message.match(/BadTooManySessions/)) {
            const delayToRetry = 5;
            errorLog(`TooManySession .... we need to retry later  ... in  ${delayToRetry} secondes ${this._internalState}`);
            this._retryCreateSessionTimer = setTimeout(() => {
              errorLog(`TooManySession .... now retrying (${this._internalState})`);
              this.createSession2(userIdentityInfo, callback);
            }, delayToRetry * 1e3);
            return;
          }
          callback(err, session);
        });
      }
      changeSessionIdentity(...args) {
        warningLog("[NODE-OPCUA-W27] OPCUAClient.changeSessionIdentity(session,userIdentity) is deprecated use ClientSession.changeUser(userIdentity) instead");
        const session = args[0];
        const userIdentityInfo = args[1];
        const callback = args[2];
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        session.changeUser(userIdentityInfo, callback);
      }
      /**
       * @internals
       * @param args
       */
      closeSession(...args) {
        if (this._retryCreateSessionTimer) {
          clearTimeout(this._retryCreateSessionTimer);
          this._retryCreateSessionTimer = void 0;
        }
        super.closeSession(...args);
      }
      toString() {
        let str = client_base_impl_1.ClientBaseImpl.prototype.toString.call(this);
        str += "  requestedSessionTimeout....... " + this.requestedSessionTimeout + "\n";
        str += "  endpointUrl................... " + this.endpointUrl + "\n";
        str += "  serverUri..................... " + this.serverUri + "\n";
        return str;
      }
      /**
       *
       * @example
       *
       * ```javascript
       *
       * const session = await OPCUAClient.createSession(endpointUrl);
       * const dataValue = await session.read({ nodeId, attributeId: AttributeIds.Value });
       * await session.close();
       *
       * ```
       * @stability experimental
       *
       * @param endpointUrl
       * @param userIdentity
       * @returns session
       *
       *
       * const create
       */
      static async createSession(endpointUrl, userIdentity, clientOptions) {
        const client2 = opcua_client_1.OPCUAClient.create(clientOptions || {});
        await client2.connect(endpointUrl);
        const session = await client2.createSession2(userIdentity);
        const oldClose = session.close;
        session.close = thenify.withCallback((...args) => {
          if (args.length === 1) {
            return session.close(true, args[0]);
          }
          const deleteSubscriptions = args[0];
          const callback = args[1];
          session.close = oldClose;
          oldClose.call(session, deleteSubscriptions, (err) => {
            client2.disconnect((err2) => {
              callback(err2);
            });
          });
        });
        return session;
      }
      /**
       * @internal
       * @param args
       */
      withSession(connectionPoint, inner_func, ...args) {
        const endpointUrl = typeof connectionPoint === "string" ? connectionPoint : connectionPoint.endpointUrl;
        const userIdentity = typeof connectionPoint === "string" ? { type: node_opcua_service_endpoints_1.UserTokenType.Anonymous } : connectionPoint.userIdentity;
        const callback = args[0];
        (0, node_opcua_assert_1.assert)(typeof inner_func === "function", "expecting inner function");
        (0, node_opcua_assert_1.assert)(typeof callback === "function", "expecting callback function");
        let theSession;
        let the_error;
        let need_disconnect = false;
        async_1.default.series([
          // step 1 : connect to
          (innerCallback) => {
            this.connect(endpointUrl, (err) => {
              need_disconnect = true;
              if (err) {
                warningLog(err.message);
                errorLog(" cannot connect to endpoint :", endpointUrl);
              }
              innerCallback(err);
            });
          },
          // step 2 : createSession
          (innerCallback) => {
            this.createSession2(userIdentity, (err, session) => {
              if (err) {
                return innerCallback(err);
              }
              if (!session) {
                return innerCallback(new Error("internal error"));
              }
              theSession = session;
              innerCallback();
            });
          },
          (innerCallback) => {
            try {
              inner_func(theSession, (err) => {
                the_error = err;
                innerCallback();
              });
            } catch (err) {
              errorLog("Exception catch in inner function,  check your code ", err);
              errorLog("OPCUAClientImpl#withClientSession", err.message);
              the_error = err;
              innerCallback();
            }
          },
          // close session
          (innerCallback) => {
            theSession.close(
              /*deleteSubscriptions=*/
              true,
              (err) => {
                if (err) {
                  debugLog("OPCUAClientImpl#withClientSession: session closed failed ?");
                }
                innerCallback();
              }
            );
          },
          (innerCallback) => {
            this.disconnect((err) => {
              need_disconnect = false;
              if (err) {
                errorLog("OPCUAClientImpl#withClientSession: client disconnect failed ?");
              }
              innerCallback();
            });
          }
        ], (err1) => {
          if (err1) {
            errorLog("err", err1.message);
          }
          if (need_disconnect) {
            errorLog("Disconnecting client after failure");
            this.disconnect((err2) => {
              return callback(the_error || err1 || err2);
            });
          } else {
            return callback(the_error || err1);
          }
        });
      }
      withSubscription(endpointUrl, subscriptionParameters, innerFunc, callback) {
        (0, node_opcua_assert_1.assert)(typeof innerFunc === "function");
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        this.withSession(endpointUrl, (session, done) => {
          (0, node_opcua_assert_1.assert)(typeof done === "function");
          const subscription = new client_subscription_impl_1.ClientSubscriptionImpl(session, subscriptionParameters);
          try {
            innerFunc(session, subscription, (err) => {
              subscription.terminate((err1) => {
                done(err1);
              });
            });
          } catch (err) {
            debugLog(err);
            done(err);
          }
        }, callback);
      }
      async withSessionAsync(connectionPoint, func) {
        (0, node_opcua_assert_1.assert)(typeof func === "function");
        (0, node_opcua_assert_1.assert)(func.length === 1, "expecting a single argument in func");
        const endpointUrl = typeof connectionPoint === "string" ? connectionPoint : connectionPoint.endpointUrl;
        const userIdentity = typeof connectionPoint === "string" ? { type: node_opcua_service_endpoints_1.UserTokenType.Anonymous } : connectionPoint.userIdentity;
        await this.connect(endpointUrl);
        this.on("backoff", (count, delay) => {
          warningLog("cannot connect to ", endpointUrl, "attempt #" + count, " retrying in ", delay);
        });
        try {
          const session = await this.createSession2(userIdentity);
          let result2;
          try {
            result2 = await func(session);
            return result2;
          } catch (err) {
            errorLog(err);
            throw err;
          } finally {
            await session.close();
          }
        } catch (err) {
          errorLog(err.message);
          throw err;
        } finally {
          await this.disconnect();
        }
      }
      async withSubscriptionAsync(connectionPoint, parameters, func) {
        await this.withSessionAsync(connectionPoint, async (session) => {
          (0, node_opcua_assert_1.assert)(session, " session must exist");
          const subscription = await session.createSubscription2(parameters);
          try {
            const result2 = await func(session, subscription);
            return result2;
          } catch (err) {
            errorLog("withSubscriptionAsync inner function failed ", err.message);
            throw err;
          } finally {
            await subscription.terminate();
          }
        });
      }
      reactivateSession(session, callback) {
        const internalSession = session;
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        if (!this._secureChannel) {
          return callback(new Error(" client must be connected first"));
        }
        if (!this.__resolveEndPoint() || !this.endpoint) {
          return callback(new Error(" End point must exist " + this._secureChannel.endpointUrl + "  securityMode = " + node_opcua_service_secure_channel_1.MessageSecurityMode[this.securityMode] + "  securityPolicy = " + this.securityPolicy));
        }
        (0, node_opcua_assert_1.assert)(!internalSession._client || (0, node_opcua_utils_1.matchUri)(internalSession._client.endpointUrl, this.endpointUrl), "cannot reactivateSession on a different endpoint");
        const old_client = internalSession._client;
        debugLog("OPCUAClientImpl#reactivateSession");
        this._activateSession(internalSession, internalSession.userIdentityInfo, (err) => {
          if (!err) {
            if (old_client !== this) {
              if (old_client) {
                old_client._removeSession(internalSession);
                (0, node_opcua_assert_1.assert)(old_client._sessions.indexOf(internalSession) === -1);
              }
              this._addSession(internalSession);
              (0, node_opcua_assert_1.assert)(internalSession._client === this);
              (0, node_opcua_assert_1.assert)(!internalSession._closed, "session should not vbe closed");
              (0, node_opcua_assert_1.assert)(this._sessions.indexOf(internalSession) !== -1);
            }
            callback();
          } else {
            if (doDebug) {
              debugLog(chalk_1.default.red.bgWhite("reactivateSession has failed !"), err.message);
            }
            callback(err);
          }
        });
      }
      /**
       * @internal
       * @private
       */
      _on_connection_reestablished(callback) {
        super._on_connection_reestablished(() => {
          (0, reconnection_1.repair_client_sessions)(this, callback);
        });
      }
      /**
       *
       * @internal
       * @private
       */
      __createSession_step3(session, callback) {
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        (0, node_opcua_assert_1.assert)(this.serverUri !== void 0, " must have a valid server URI " + this.serverUri);
        (0, node_opcua_assert_1.assert)(this.endpointUrl !== void 0, " must have a valid server endpointUrl");
        (0, node_opcua_assert_1.assert)(this.endpoint);
        if (!this._secureChannel) {
          return callback(new Error("Invalid channel"));
        }
        const applicationUri = this._getApplicationUri();
        const applicationDescription = {
          applicationName: new node_opcua_data_model_1.LocalizedText({ text: this.applicationName, locale: null }),
          applicationType: node_opcua_service_endpoints_1.ApplicationType.Client,
          applicationUri,
          discoveryProfileUri: void 0,
          discoveryUrls: [],
          gatewayServerUri: void 0,
          productUri: "NodeOPCUA-Client"
        };
        this.clientNonce = (0, crypto_1.randomBytes)(32);
        const sessionName = session.name;
        const request = new node_opcua_service_session_1.CreateSessionRequest({
          clientCertificate: this.getCertificate(),
          clientDescription: applicationDescription,
          clientNonce: this.clientNonce,
          endpointUrl: this.endpointUrl,
          maxResponseMessageSize: 8e5,
          requestedSessionTimeout: this.requestedSessionTimeout,
          serverUri: this.serverUri,
          sessionName
        });
        (0, node_opcua_assert_1.assert)(this._secureChannel.securityMode === node_opcua_service_secure_channel_1.MessageSecurityMode.None || request.clientNonce !== null);
        this.performMessageTransaction(request, (err, response) => {
          if (err) {
            debugLog("__createSession_step3 has failed", err.message);
            return callback(err);
          }
          if (!response || !(response instanceof node_opcua_service_session_1.CreateSessionResponse)) {
            return callback(new Error("internal error"));
          }
          if (response.responseHeader.serviceResult === node_opcua_status_code_1.StatusCodes.BadTooManySessions) {
            return callback(new Error(response.responseHeader.serviceResult.toString()));
          }
          if (response.responseHeader.serviceResult !== node_opcua_status_code_1.StatusCodes.Good) {
            err = new Error("Error " + response.responseHeader.serviceResult.name + " " + response.responseHeader.serviceResult.description);
            return callback(err);
          }
          if (!validateServerNonce(response.serverNonce)) {
            return callback(new Error("Invalid server Nonce"));
          }
          session.name = request.sessionName || "";
          session.sessionId = response.sessionId;
          session.authenticationToken = response.authenticationToken;
          session.timeout = _adjustRevisedSessionTimeout(response.revisedSessionTimeout, this.requestedSessionTimeout);
          session.serverNonce = response.serverNonce;
          session.serverCertificate = response.serverCertificate;
          session.serverSignature = response.serverSignature;
          debugLog("revised session timeout = ", session.timeout, response.revisedSessionTimeout);
          response.serverEndpoints = response.serverEndpoints || [];
          if (!verifyEndpointDescriptionMatches(this, response.serverEndpoints)) {
            errorLog("Endpoint description previously retrieved with GetEndpointsDescription");
            errorLog("CreateSessionResponse.serverEndpoints= ");
            errorLog(response.serverEndpoints);
            return callback(new Error("Invalid endpoint descriptions Found"));
          }
          session.serverEndpoints = response.serverEndpoints;
          callback(null, session);
        });
      }
      /**
       *
       * @internal
       * @private
       */
      __createSession_step2(session, callback) {
        (0, util_1.callbackify)(node_opcua_hostname_1.extractFullyQualifiedDomainName)(() => {
          this.__createSession_step3(session, callback);
        });
      }
      /**
       * @internal
       * @private
       */
      _activateSession(session, userIdentityInfo, callback) {
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        if (!this._secureChannel) {
          return callback(new Error(" No secure channel"));
        }
        const serverCertificate = session.serverCertificate;
        (0, node_opcua_assert_1.assert)(serverCertificate === null || serverCertificate instanceof Buffer);
        const serverNonce = session.serverNonce;
        (0, node_opcua_assert_1.assert)(!serverNonce || serverNonce instanceof Buffer);
        const _old_client = session._client;
        session._client = this;
        const context = {
          endpoint: this.endpoint,
          securityPolicy: this._secureChannel.securityPolicy,
          serverCertificate,
          serverNonce
          // please check this !
        };
        this.createUserIdentityToken(context, userIdentityInfo, (err, data) => {
          if (err) {
            session._client = _old_client;
            return callback(err);
          }
          data = data;
          const userIdentityToken = data.userIdentityToken;
          const userTokenSignature = data.userTokenSignature;
          const request = new node_opcua_service_session_1.ActivateSessionRequest({
            // This is a signature generated with the private key associated with the
            // clientCertificate. The SignatureAlgorithm shall be the AsymmetricSignatureAlgorithm
            // specified in the SecurityPolicy for the Endpoint. The SignatureData type is defined in 7.30.
            clientSignature: this.computeClientSignature(this._secureChannel, serverCertificate, serverNonce) || void 0,
            // These are the SoftwareCertificates which have been issued to the Client application.
            // The productUri contained in the SoftwareCertificates shall match the productUri in the
            // ApplicationDescription passed by the Client in the CreateSession requests. Certificates without
            // matching productUri should be ignored.  Servers may reject connections from Clients if they are
            // not satisfied with the SoftwareCertificates provided by the Client.
            // This parameter only needs to be specified in the first ActivateSession request
            // after CreateSession.
            // It shall always be omitted if the maxRequestMessageSize returned from the Server in the
            // CreateSession response is less than one megabyte.
            // The SignedSoftwareCertificate type is defined in 7.31.
            clientSoftwareCertificates: [],
            // List of locale ids in priority order for localized strings. The first LocaleId in the list
            // has the highest priority. If the Server returns a localized string to the Client, the Server
            // shall return the translation with the highest priority that it can. If it does not have a
            // translation for any of the locales identified in this list, then it shall return the string
            // value that it has and include the locale id with the string.
            // See Part 3 for more detail on locale ids. If the Client fails to specify at least one locale id,
            // the Server shall use any that it has.
            // This parameter only needs to be specified during the first call to ActivateSession during
            // a single application Session. If it is not specified the Server shall keep using the current
            // localeIds for the Session.
            localeIds: [],
            // The credentials of the user associated with the Client application. The Server uses these
            // credentials to determine whether the Client should be allowed to activate a Session and what
            // resources the Client has access to during this Session. The UserIdentityToken is an extensible
            // parameter type defined in 7.35.
            // The EndpointDescription specifies what UserIdentityTokens the Server shall accept.
            userIdentityToken,
            // If the Client specified a user   identity token that supports digital signatures,
            // then it shall create a signature and pass it as this parameter. Otherwise the parameter
            // is omitted.
            // The SignatureAlgorithm depends on the identity token type.
            userTokenSignature
          });
          request.requestHeader.authenticationToken = session.authenticationToken;
          session.lastRequestSentTime = /* @__PURE__ */ new Date();
          this.performMessageTransaction(request, (err1, response) => {
            if (!err1 && response && response.responseHeader.serviceResult === node_opcua_status_code_1.StatusCodes.Good) {
              if (!(response instanceof node_opcua_service_session_1.ActivateSessionResponse)) {
                return callback(new Error("Internal Error"));
              }
              if (!validateServerNonce(response.serverNonce)) {
                return callback(new Error("Invalid server Nonce"));
              }
              session._client = this;
              session.serverNonce = response.serverNonce;
              session.lastResponseReceivedTime = /* @__PURE__ */ new Date();
              if (this.keepSessionAlive) {
                session.startKeepAliveManager(this.keepAliveInterval);
              }
              session.userIdentityInfo = userIdentityInfo;
              return callback(null, session);
            } else {
              session._client = _old_client;
              if (!err1 && response) {
                err1 = new Error(response.responseHeader.serviceResult.toString());
              }
              session._client = _old_client;
              return callback(err1);
            }
          });
        });
      }
      /**
       *
       * @private
       */
      _nextSessionName() {
        if (!this.___sessionName_counter) {
          this.___sessionName_counter = 0;
        }
        this.___sessionName_counter += 1;
        return this.clientName + this.___sessionName_counter;
      }
      /**
       *
       * @private
       */
      _getApplicationUri() {
        const certificate = this.getCertificate();
        let applicationUri;
        if (certificate) {
          const e = (0, node_opcua_crypto_1.exploreCertificate)(certificate);
          if (e.tbsCertificate.extensions?.subjectAltName?.uniformResourceIdentifier) {
            applicationUri = e.tbsCertificate.extensions.subjectAltName.uniformResourceIdentifier[0];
          } else {
            errorLog("Certificate has no extensions.subjectAltName.uniformResourceIdentifier, ");
            errorLog((0, node_opcua_crypto_1.toPem)(certificate, "CERTIFICATE"));
            applicationUri = this._getBuiltApplicationUri();
          }
        } else {
          applicationUri = this._getBuiltApplicationUri();
        }
        return applicationUri;
      }
      /**
       *
       * @private
       */
      __resolveEndPoint() {
        this.securityPolicy = this.securityPolicy || node_opcua_secure_channel_1.SecurityPolicy.None;
        let endpoint = this.findEndpoint(this._secureChannel.endpointUrl, this.securityMode, this.securityPolicy);
        this.endpoint = endpoint;
        if (!this.endpoint) {
          if (this.endpointMustExist) {
            warningLog("OPCUAClientImpl#endpointMustExist = true and endpoint with url ", this._secureChannel.endpointUrl, " cannot be found");
            const infos = this._serverEndpoints.map((endpoint2) => `${endpoint2.endpointUrl} ${node_opcua_service_secure_channel_1.MessageSecurityMode[endpoint2.securityMode]}, ${endpoint2.securityPolicyUri} `);
            warningLog("Valid endpoints are ");
            warningLog("   " + infos.join("\n   "));
            return false;
          } else {
            endpoint = this.findEndpointForSecurity(this.securityMode, this.securityPolicy);
            if (!endpoint) {
              return false;
            }
            this.endpoint = endpoint;
          }
        }
        return true;
      }
      /**
       *
       * @private
       */
      _createSession(callback) {
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        (0, node_opcua_assert_1.assert)(this._secureChannel);
        if (!this.__resolveEndPoint() || !this.endpoint) {
          if (this._serverEndpoints) {
            warningLog("server endpoints =", this._serverEndpoints.map((endpoint) => endpoint.endpointUrl + " " + node_opcua_service_secure_channel_1.MessageSecurityMode[endpoint.securityMode] + " " + endpoint.securityPolicyUri + " " + endpoint.userIdentityTokens?.map((u2) => node_opcua_service_endpoints_1.UserTokenType[u2.tokenType]).join(",")).join("\n"));
          }
          return callback(new Error(" End point must exist " + this._secureChannel.endpointUrl + "  securityMode = " + node_opcua_service_secure_channel_1.MessageSecurityMode[this.securityMode] + "  securityPolicy = " + this.securityPolicy));
        }
        this.serverUri = this.endpoint.server.applicationUri || "invalid application uri";
        this.endpointUrl = this._secureChannel.endpointUrl;
        const session = new client_session_impl_1.ClientSessionImpl(this);
        session.name = this._nextSessionName();
        this.__createSession_step2(session, callback);
      }
      /**
       *
       * @private
       */
      computeClientSignature(channel, serverCertificate, serverNonce) {
        return (0, node_opcua_secure_channel_1.computeSignature)(serverCertificate, serverNonce || Buffer.alloc(0), this.getPrivateKey(), channel.securityPolicy);
      }
      /**
       *
       * @private
       */
      createUserIdentityToken(context, userIdentityInfo, callback) {
        function coerceUserIdentityInfo(identityInfo) {
          if (!identityInfo) {
            return { type: node_opcua_service_endpoints_1.UserTokenType.Anonymous };
          }
          if (Object.prototype.hasOwnProperty.call(identityInfo, "type")) {
            return identityInfo;
          }
          if (Object.prototype.hasOwnProperty.call(identityInfo, "userName")) {
            identityInfo.type = node_opcua_service_endpoints_1.UserTokenType.UserName;
            return identityInfo;
          }
          if (Object.prototype.hasOwnProperty.call(identityInfo, "certificateData")) {
            identityInfo.type = node_opcua_service_endpoints_1.UserTokenType.Certificate;
            return identityInfo;
          }
          identityInfo.type = node_opcua_service_endpoints_1.UserTokenType.Anonymous;
          return identityInfo;
        }
        userIdentityInfo = coerceUserIdentityInfo(userIdentityInfo);
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        if (null === userIdentityInfo) {
          return callback(null, {
            userIdentityToken: null,
            userTokenSignature: {}
          });
        }
        let userIdentityToken;
        let userTokenSignature = {
          algorithm: void 0,
          signature: void 0
        };
        try {
          switch (userIdentityInfo.type) {
            case node_opcua_service_endpoints_1.UserTokenType.Anonymous:
              userIdentityToken = createAnonymousIdentityToken(context);
              break;
            case node_opcua_service_endpoints_1.UserTokenType.UserName: {
              const userName = userIdentityInfo.userName || "";
              const password = userIdentityInfo.password || "";
              userIdentityToken = createUserNameIdentityToken(context, userName, password);
              break;
            }
            case node_opcua_service_endpoints_1.UserTokenType.Certificate: {
              const certificate = userIdentityInfo.certificateData;
              const privateKey = (0, node_opcua_crypto_1.makePrivateKeyFromPem)(userIdentityInfo.privateKey);
              ({ userIdentityToken, userTokenSignature } = createX509IdentityToken(context, certificate, privateKey));
              break;
            }
            default:
              debugLog(" userIdentityInfo = ", userIdentityInfo);
              return callback(new Error("CLIENT: Invalid userIdentityInfo"));
          }
        } catch (err) {
          if (typeof err === "string") {
            return callback(new Error("Create identity token failed " + userIdentityInfo.type + " " + err));
          }
          return callback(err);
        }
        return callback(null, { userIdentityToken, userTokenSignature });
      }
    };
    exports2.OPCUAClientImpl = OPCUAClientImpl;
    OPCUAClientImpl.minimumRevisedSessionTimeout = 100;
    var thenify = require_thenify();
    OPCUAClientImpl.prototype.createSession = thenify.withCallback(OPCUAClientImpl.prototype.createSession);
    OPCUAClientImpl.prototype.createSession2 = thenify.withCallback(OPCUAClientImpl.prototype.createSession2);
    OPCUAClientImpl.prototype.changeSessionIdentity = thenify.withCallback(OPCUAClientImpl.prototype.changeSessionIdentity);
    OPCUAClientImpl.prototype.closeSession = thenify.withCallback(OPCUAClientImpl.prototype.closeSession);
    OPCUAClientImpl.prototype.reactivateSession = thenify.withCallback(OPCUAClientImpl.prototype.reactivateSession);
  }
});

// node_modules/node-opcua-client/dist/opcua_client.js
var require_opcua_client = __commonJS({
  "node_modules/node-opcua-client/dist/opcua_client.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OPCUAClient = void 0;
    var opcua_client_impl_1 = require_opcua_client_impl();
    var OPCUAClient = class {
      static create(options) {
        return new opcua_client_impl_1.OPCUAClientImpl(options);
      }
      static async createSession(endpointUrl, userIdentity, clientOptions) {
        return opcua_client_impl_1.OPCUAClientImpl.createSession(endpointUrl, userIdentity, clientOptions);
      }
      static set minimumRevisedSessionTimeout(minimumRevisedSessionTimeout) {
        opcua_client_impl_1.OPCUAClientImpl.minimumRevisedSessionTimeout = minimumRevisedSessionTimeout;
      }
      static get minimumRevisedSessionTimeout() {
        return opcua_client_impl_1.OPCUAClientImpl.minimumRevisedSessionTimeout;
      }
    };
    exports2.OPCUAClient = OPCUAClient;
  }
});

// node_modules/node-opcua-client/dist/client_session.js
var require_client_session = __commonJS({
  "node_modules/node-opcua-client/dist/client_session.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ExtensionObject = exports2.ExtraDataTypeManager = void 0;
    var node_opcua_client_dynamic_extension_object_1 = require_dist56();
    Object.defineProperty(exports2, "ExtraDataTypeManager", { enumerable: true, get: function() {
      return node_opcua_client_dynamic_extension_object_1.ExtraDataTypeManager;
    } });
    var node_opcua_extension_object_1 = require_dist30();
    Object.defineProperty(exports2, "ExtensionObject", { enumerable: true, get: function() {
      return node_opcua_extension_object_1.ExtensionObject;
    } });
  }
});

// node_modules/node-opcua-client/dist/client_monitored_item_base.js
var require_client_monitored_item_base = __commonJS({
  "node_modules/node-opcua-client/dist/client_monitored_item_base.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-alarm-condition/dist/event_stuff.js
var require_event_stuff = __commonJS({
  "node_modules/node-opcua-alarm-condition/dist/event_stuff.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.fieldsToJson = void 0;
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_debug_1 = require_dist24();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    function fieldsToJson(fields, eventFields, flat) {
      function setProperty(_data, fieldName, value) {
        let name;
        if (!fieldName || value === null) {
          return;
        }
        if (!flat) {
          const f2 = fieldName.split(".");
          if (f2.length === 1) {
            fieldName = (0, node_opcua_utils_1.lowerFirstLetter)(fieldName);
            _data[fieldName] = value;
          } else {
            for (let i = 0; i < f2.length - 1; i++) {
              name = (0, node_opcua_utils_1.lowerFirstLetter)(f2[i]);
              _data[name] = _data[name] || {};
              _data = _data[name];
            }
            name = (0, node_opcua_utils_1.lowerFirstLetter)(f2[f2.length - 1]);
            _data[name] = value;
          }
        } else {
          const name2 = fieldName.split(".").map(node_opcua_utils_1.lowerFirstLetter).join(".");
          _data[name2] = value;
        }
      }
      if (fields.length > eventFields.length) {
        warningLog("warning fields.length !==  eventFields.length", fields.length, eventFields.length);
      }
      const data = {};
      for (let index = 0; index < fields.length; index++) {
        const variant = eventFields[index];
        setProperty(data, fields[index], variant);
      }
      return data;
    }
    exports2.fieldsToJson = fieldsToJson;
  }
});

// node_modules/node-opcua-alarm-condition/dist/extract_condition_fields.js
var require_extract_condition_fields = __commonJS({
  "node_modules/node-opcua-alarm-condition/dist/extract_condition_fields.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.extractConditionFields = void 0;
    var node_opcua_pseudo_session_1 = require_dist55();
    async function extractConditionFields(session, conditionNodeId) {
      const p3 = await (0, node_opcua_pseudo_session_1.extractFields)(session, conditionNodeId);
      const fields1 = (0, node_opcua_pseudo_session_1.simpleBrowsePathsToString)(p3.map((a) => a.path));
      fields1.push("ConditionId");
      return fields1;
    }
    exports2.extractConditionFields = extractConditionFields;
  }
});

// node_modules/node-opcua-alarm-condition/dist/call_method_condition.js
var require_call_method_condition = __commonJS({
  "node_modules/node-opcua-alarm-condition/dist/call_method_condition.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.confirmCondition = exports2.acknowledgeCondition = exports2.callMethodCondition = void 0;
    var node_opcua_assert_1 = __importDefault3(require_dist14());
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_pseudo_session_1 = require_dist55();
    var node_opcua_constants_1 = require_dist20();
    async function callMethodCondition(session, methodName, conditionId, eventId, comment) {
      conditionId = (0, node_opcua_nodeid_1.coerceNodeId)(conditionId);
      (0, node_opcua_assert_1.default)(conditionId instanceof node_opcua_nodeid_1.NodeId);
      (0, node_opcua_assert_1.default)(eventId instanceof Buffer);
      (0, node_opcua_assert_1.default)(typeof comment === "string" || comment instanceof node_opcua_data_model_1.LocalizedText);
      comment = node_opcua_data_model_1.LocalizedText.coerce(comment) || new node_opcua_data_model_1.LocalizedText();
      const r = await (0, node_opcua_pseudo_session_1.findMethodId)(session, conditionId, methodName);
      let methodId = r.methodId;
      if (!methodId) {
        switch (methodName) {
          case "Acknowledge":
            methodId = (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_constants_1.MethodIds.AcknowledgeableConditionType_Acknowledge);
            break;
          case "Confirm":
            methodId = (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_constants_1.MethodIds.AcknowledgeableConditionType_Confirm);
            break;
          default:
            return node_opcua_status_code_1.StatusCodes.BadNodeIdUnknown;
        }
      }
      const methodToCalls = [];
      methodToCalls.push(new node_opcua_types_1.CallMethodRequest({
        inputArguments: [
          /* eventId */
          new node_opcua_variant_1.Variant({ dataType: "ByteString", value: eventId }),
          /* comment */
          new node_opcua_variant_1.Variant({ dataType: "LocalizedText", value: comment })
        ],
        methodId,
        objectId: conditionId
      }));
      const results = await session.call(methodToCalls);
      const statusCode = results[0].statusCode;
      return statusCode;
    }
    exports2.callMethodCondition = callMethodCondition;
    async function acknowledgeCondition(session, conditionId, eventId, comment) {
      return await callMethodCondition(session, "Acknowledge", conditionId, eventId, comment);
    }
    exports2.acknowledgeCondition = acknowledgeCondition;
    async function confirmCondition(session, conditionId, eventId, comment) {
      return await callMethodCondition(session, "Confirm", conditionId, eventId, comment);
    }
    exports2.confirmCondition = confirmCondition;
  }
});

// node_modules/node-opcua-alarm-condition/dist/call_condition_refresh.js
var require_call_condition_refresh = __commonJS({
  "node_modules/node-opcua-alarm-condition/dist/call_condition_refresh.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.callConditionRefresh = void 0;
    var node_opcua_assert_1 = __importDefault3(require_dist14());
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_service_translate_browse_path_1 = require_dist49();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_debug_1 = require_dist24();
    var doDebug = false;
    var debugLog = (0, node_opcua_debug_1.make_debugLog)("A&E");
    var warningLog = (0, node_opcua_debug_1.make_warningLog)("A&E");
    async function callConditionRefresh(session, subscriptionId) {
      (0, node_opcua_assert_1.default)(isFinite(subscriptionId), "May be subscription is not yet initialized");
      const conditionTypeNodeId = (0, node_opcua_nodeid_1.resolveNodeId)("ConditionType");
      let conditionRefreshId = (0, node_opcua_nodeid_1.resolveNodeId)("ConditionType_ConditionRefresh");
      const browsePath = (0, node_opcua_service_translate_browse_path_1.makeBrowsePath)(conditionTypeNodeId, ".ConditionRefresh");
      const translateResult = await session.translateBrowsePath(browsePath);
      if (translateResult.targets && translateResult.targets.length > 0) {
        conditionRefreshId = translateResult.targets[0].targetId;
      } else {
        return node_opcua_basic_types_1.StatusCodes.BadInternalError;
      }
      const methodToCall = {
        inputArguments: [new node_opcua_variant_1.Variant({ dataType: node_opcua_basic_types_1.DataType.UInt32, value: subscriptionId })],
        methodId: conditionRefreshId,
        objectId: conditionTypeNodeId
      };
      doDebug && debugLog("Calling method ", new node_opcua_types_1.CallMethodRequest(methodToCall).toString());
      const callResult = await session.call(methodToCall);
      if (callResult.statusCode.isNotGood()) {
        warningLog(new node_opcua_types_1.CallMethodRequest(methodToCall).toString());
      }
      return callResult.statusCode;
    }
    exports2.callConditionRefresh = callConditionRefresh;
  }
});

// node_modules/node-opcua-alarm-condition/dist/acknowledge_all_conditions.js
var require_acknowledge_all_conditions = __commonJS({
  "node_modules/node-opcua-alarm-condition/dist/acknowledge_all_conditions.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.confirmAllConditions = exports2.acknowledgeAllConditions = exports2.findActiveConditions = void 0;
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_service_filter_1 = require_dist61();
    var node_opcua_service_read_1 = require_dist39();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_debug_1 = require_dist24();
    var event_stuff_1 = require_event_stuff();
    var extract_condition_fields_1 = require_extract_condition_fields();
    var call_method_condition_1 = require_call_method_condition();
    var call_condition_refresh_1 = require_call_condition_refresh();
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    async function acknowledgeConditionEV(session, eventStuff, comment) {
      const conditionId = eventStuff.conditionId?.value;
      const eventId = eventStuff.eventId?.value;
      try {
        return await (0, call_method_condition_1.acknowledgeCondition)(session, conditionId, eventId, comment);
      } catch (err) {
        errorLog(`conditionId: ${conditionId?.toString()}`);
        errorLog("Acknowledging Condition has failed !", err);
        return node_opcua_status_code_1.StatusCodes.BadInternalError;
      }
    }
    async function confirmConditionEV(session, eventStuff, comment) {
      const conditionId = eventStuff.conditionId?.value;
      const eventId = eventStuff.eventId?.value;
      try {
        return await (0, call_method_condition_1.confirmCondition)(session, conditionId, eventId, comment);
      } catch (err) {
        errorLog(`conditionId: ${conditionId?.toString()}`);
        errorLog("Confirming Condition has failed !", err);
        return node_opcua_status_code_1.StatusCodes.BadInternalError;
      }
    }
    async function findActiveConditions(session) {
      const request = {
        maxNotificationsPerPublish: 1e4,
        priority: 6,
        publishingEnabled: true,
        requestedLifetimeCount: 1e3,
        requestedMaxKeepAliveCount: 100,
        requestedPublishingInterval: 100
      };
      const subscription = await session.createSubscription2(request);
      const itemToMonitor = {
        attributeId: node_opcua_service_read_1.AttributeIds.EventNotifier,
        nodeId: (0, node_opcua_nodeid_1.resolveNodeId)("Server")
        // i=2253session
      };
      const fields = await (0, extract_condition_fields_1.extractConditionFields)(session, "AcknowledgeableConditionType");
      const eventFilter = (0, node_opcua_service_filter_1.constructEventFilter)(fields);
      const monitoringParameters = {
        discardOldest: false,
        filter: eventFilter,
        queueSize: 100,
        samplingInterval: 0
      };
      const event_monitoringItem = await subscription.monitor(itemToMonitor, monitoringParameters, node_opcua_service_read_1.TimestampsToReturn.Both);
      const acknowledgeableConditions = [];
      let refreshStartEventHasBeenReceived = false;
      let RefreshEndEventHasBeenReceived = false;
      const RefreshStartEventType = (0, node_opcua_nodeid_1.resolveNodeId)("RefreshStartEventType").toString();
      const RefreshEndEventType = (0, node_opcua_nodeid_1.resolveNodeId)("RefreshEndEventType").toString();
      await new Promise((resolve2, reject) => {
        event_monitoringItem.on("changed", (_eventFields) => {
          const eventFields = _eventFields;
          try {
            if (RefreshEndEventHasBeenReceived) {
              return;
            }
            const pojo = (0, event_stuff_1.fieldsToJson)(fields, eventFields);
            if (!refreshStartEventHasBeenReceived) {
              if (pojo.eventType.value.toString() === RefreshStartEventType) {
                refreshStartEventHasBeenReceived = true;
              }
              return;
            }
            if (pojo.eventType.value.toString() === RefreshEndEventType) {
              RefreshEndEventHasBeenReceived = true;
              resolve2();
              return;
            }
            if (!pojo.conditionId.value) {
              return;
            }
            if (pojo.ackedState.id.dataType === node_opcua_variant_1.DataType.Boolean) {
              acknowledgeableConditions.push(pojo);
            }
          } catch (err) {
            errorLog("Error !!", err);
          }
        });
        try {
          (0, call_condition_refresh_1.callConditionRefresh)(session, subscription.subscriptionId);
        } catch (err) {
          errorLog("Server may not implement conditionRefresh", err.message);
        }
      });
      await subscription.terminate();
      return acknowledgeableConditions;
    }
    exports2.findActiveConditions = findActiveConditions;
    async function acknowledgeAllConditions(session, message) {
      try {
        let conditions = await findActiveConditions(session);
        conditions = conditions.filter((pojo) => pojo.ackedState.id.value === false);
        const promises = [];
        for (const eventStuff of conditions) {
          promises.push(acknowledgeConditionEV(session, eventStuff, message));
        }
        const result2 = await Promise.all(promises);
        if (doDebug) {
          debugLog("Acked all results: ", result2.map((e) => e.toString()).join(" "));
        }
      } catch (err) {
        errorLog("Error", err);
      }
    }
    exports2.acknowledgeAllConditions = acknowledgeAllConditions;
    async function confirmAllConditions(session, message) {
      try {
        let conditions = await findActiveConditions(session);
        conditions = conditions.filter((pojo) => pojo.confirmedState.id.value === false);
        const promises = [];
        for (const eventStuff of conditions) {
          promises.push(confirmConditionEV(session, eventStuff, message));
        }
        const result2 = await Promise.all(promises);
        if (doDebug) {
          debugLog("Confirm all results: ", result2.map((e) => e.toString()).join(" "));
        }
      } catch (err) {
        errorLog("Error", err);
      }
    }
    exports2.confirmAllConditions = confirmAllConditions;
  }
});

// node_modules/node-opcua-alarm-condition/dist/client_alarm.js
var require_client_alarm = __commonJS({
  "node_modules/node-opcua-alarm-condition/dist/client_alarm.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ClientAlarm = void 0;
    var events_1 = require("events");
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_variant_1 = require_dist28();
    var call_method_condition_1 = require_call_method_condition();
    var ClientAlarm = class extends events_1.EventEmitter {
      constructor(eventFields) {
        super();
        this.conditionId = (0, node_opcua_nodeid_1.resolveNodeId)(eventFields.conditionId.value);
        this.eventType = (0, node_opcua_nodeid_1.resolveNodeId)(eventFields.eventType.value);
        this.eventId = eventFields.eventId.value;
        this.fields = eventFields;
        this.update(eventFields);
      }
      async acknowledge(session, comment) {
        return await (0, call_method_condition_1.acknowledgeCondition)(session, this.conditionId, this.eventId, comment);
      }
      async confirm(session, comment) {
        return await (0, call_method_condition_1.confirmCondition)(session, this.conditionId, this.eventId, comment);
      }
      update(eventFields) {
        (0, node_opcua_assert_1.assert)(this.conditionId.toString() === (0, node_opcua_nodeid_1.resolveNodeId)(eventFields.conditionId.value).toString());
        (0, node_opcua_assert_1.assert)(this.eventType.toString() === (0, node_opcua_nodeid_1.resolveNodeId)(eventFields.eventType.value).toString());
        this.eventId = eventFields.eventId.value;
        this.fields = eventFields;
      }
      getRetain() {
        return this.fields.retain.value;
      }
      toString() {
        return this.constructor.name + ": " + this.conditionId.toString() + " " + this.eventType.toString() + " " + Object.entries(this.fields).filter(([key, value]) => value.dataType !== node_opcua_variant_1.DataType.Null).map(([key, value]) => key.padEnd(30) + "=" + value.toString()).join("\n") + "\n\n";
      }
      getField(fieldName) {
        return this.fields[fieldName] || null;
      }
    };
    exports2.ClientAlarm = ClientAlarm;
  }
});

// node_modules/node-opcua-alarm-condition/dist/client_alarm_list.js
var require_client_alarm_list = __commonJS({
  "node_modules/node-opcua-alarm-condition/dist/client_alarm_list.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ClientAlarmList = void 0;
    var events_1 = require("events");
    var node_opcua_assert_1 = require_dist14();
    var client_alarm_1 = require_client_alarm();
    var ClientAlarmList = class extends events_1.EventEmitter {
      constructor() {
        super();
        this._map = {};
      }
      [Symbol.iterator]() {
        let pointer = 0;
        const components = Object.values(this._map);
        return {
          next() {
            if (pointer >= components.length) {
              return {
                done: true,
                value: components[pointer++]
              };
            } else {
              return {
                done: false,
                value: components[pointer++]
              };
            }
          }
        };
      }
      alarms() {
        return Object.values(this._map);
      }
      update(eventField) {
        const { conditionId, eventType } = eventField;
        (0, node_opcua_assert_1.assert)(conditionId, "must have a valid conditionId ( verify that event is a acknowledgeable type");
        const alarm = this.findAlarm(conditionId.value, eventType.value);
        if (!alarm) {
          const key = this.makeKey(conditionId.value, eventType.value);
          const newAlarm = new client_alarm_1.ClientAlarm(eventField);
          this._map[key] = newAlarm;
          this.emit("newAlarm", newAlarm);
          this.emit("alarmChanged", newAlarm);
        } else {
          alarm.update(eventField);
          this.emit("alarmChanged", alarm);
        }
      }
      removeAlarm(eventField) {
        const { conditionId, eventType } = eventField;
        const alarm = this.findAlarm(conditionId.value, eventType.value);
        if (alarm) {
          alarm.update(eventField);
          this._removeAlarm(alarm);
        }
      }
      get length() {
        return Object.keys(this._map).length;
      }
      purgeUnusedAlarms() {
        const alarms = this.alarms();
        for (const alarm of alarms) {
          if (!alarm.getRetain()) {
            this._removeAlarm(alarm);
          }
        }
      }
      _removeAlarm(alarm) {
        this.emit("alarmDeleted", alarm);
        this.deleteAlarm(alarm.conditionId, alarm.eventType);
      }
      makeKey(conditionId, eventType) {
        return conditionId.toString() + "|" + eventType.toString();
      }
      findAlarm(conditionId, eventType) {
        const key = this.makeKey(conditionId, eventType);
        const _c = this._map[key];
        return _c || null;
      }
      deleteAlarm(conditionId, eventType) {
        const key = this.makeKey(conditionId, eventType);
        const _c = this._map[key];
        if (_c) {
          delete this._map[key];
          return true;
        }
        return false;
      }
    };
    exports2.ClientAlarmList = ClientAlarmList;
  }
});

// node_modules/node-opcua-alarm-condition/dist/client_alarm_tools_dump_event.js
var require_client_alarm_tools_dump_event = __commonJS({
  "node_modules/node-opcua-alarm-condition/dist/client_alarm_tools_dump_event.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.dumpEvent = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_debug_1 = require_dist24();
    var traceLog = (0, node_opcua_debug_1.make_traceLog)("ClientAlarmTool");
    async function dumpEvent(session, fields, eventFields) {
      async function getBrowseName(_session, nodeId) {
        const dataValue = await _session.read({
          attributeId: node_opcua_data_model_1.AttributeIds.BrowseName,
          nodeId
        });
        if (dataValue.statusCode.isGood()) {
          const browseName = dataValue.value.value.name;
          return browseName;
        } else {
          return "???";
        }
      }
      function w(str, l2) {
        return (str || "").toString().padEnd(l2, " ").substring(0, l2);
      }
      async function __dumpEvent1(_session, _fields, variant, index) {
        if (variant.dataType === node_opcua_variant_1.DataType.Null) {
          return;
        }
        if (variant.dataType === node_opcua_variant_1.DataType.NodeId) {
          const name = await getBrowseName(_session, variant.value);
          traceLog(chalk_1.default.yellow(w(name, 30), w(_fields[index], 25)), chalk_1.default.cyan(w(node_opcua_variant_1.DataType[variant.dataType], 10).toString()), chalk_1.default.cyan.bold(name), "(", w(variant.value, 20), ")");
        } else {
          traceLog(chalk_1.default.yellow(w("", 30), w(_fields[index], 25)), chalk_1.default.cyan(w(node_opcua_variant_1.DataType[variant.dataType], 10).toString()), variant.value);
        }
      }
      async function __dumpEvent(_session, _fields, _eventFields) {
        let index = 0;
        const promises = [];
        for (const variant of _eventFields) {
          promises.push(__dumpEvent1(_session, _fields, variant, index));
          index++;
        }
        await Promise.all(promises);
      }
      await __dumpEvent(session, fields, eventFields);
    }
    exports2.dumpEvent = dumpEvent;
  }
});

// node_modules/node-opcua-alarm-condition/dist/index.js
var require_dist62 = __commonJS({
  "node_modules/node-opcua-alarm-condition/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_acknowledge_all_conditions(), exports2);
    __exportStar3(require_call_condition_refresh(), exports2);
    __exportStar3(require_call_method_condition(), exports2);
    __exportStar3(require_client_alarm_list(), exports2);
    __exportStar3(require_client_alarm_tools_dump_event(), exports2);
    __exportStar3(require_client_alarm(), exports2);
    __exportStar3(require_event_stuff(), exports2);
    __exportStar3(require_extract_condition_fields(), exports2);
  }
});

// node_modules/node-opcua-client/dist/alarms_and_conditions/client_tools.js
var require_client_tools = __commonJS({
  "node_modules/node-opcua-client/dist/alarms_and_conditions/client_tools.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var util_1 = require("util");
    var node_opcua_alarm_condition_1 = require_dist62();
    var node_opcua_pseudo_session_1 = require_dist55();
    var client_session_impl_1 = require_client_session_impl();
    client_session_impl_1.ClientSessionImpl.prototype.disableCondition = () => {
    };
    client_session_impl_1.ClientSessionImpl.prototype.enableCondition = () => {
    };
    client_session_impl_1.ClientSessionImpl.prototype.addCommentCondition = function(conditionId, eventId, comment, callback) {
      (0, util_1.callbackify)(node_opcua_alarm_condition_1.callMethodCondition)(this, "AddComment", conditionId, eventId, comment, callback);
    };
    client_session_impl_1.ClientSessionImpl.prototype.findMethodId = function(nodeId, methodName, callback) {
      (0, node_opcua_pseudo_session_1.findMethodId)(this, nodeId, methodName).then((data) => {
        if (data.methodId) {
          callback(null, data.methodId);
        } else {
          callback(data.err);
        }
      }).catch((err) => {
        callback(err);
      });
    };
    client_session_impl_1.ClientSessionImpl.prototype.confirmCondition = function(conditionId, eventId, comment, callback) {
      (0, util_1.callbackify)(node_opcua_alarm_condition_1.confirmCondition)(this, conditionId, eventId, comment, callback);
    };
    client_session_impl_1.ClientSessionImpl.prototype.acknowledgeCondition = function(conditionId, eventId, comment, callback) {
      (0, util_1.callbackify)(node_opcua_alarm_condition_1.acknowledgeCondition)(this, conditionId, eventId, comment, callback);
    };
    var thenify = require_thenify();
    var opts = { multiArgs: false };
    client_session_impl_1.ClientSessionImpl.prototype.addCommentCondition = thenify.withCallback(client_session_impl_1.ClientSessionImpl.prototype.addCommentCondition, opts);
    client_session_impl_1.ClientSessionImpl.prototype.findMethodId = thenify.withCallback(client_session_impl_1.ClientSessionImpl.prototype.findMethodId, opts);
    client_session_impl_1.ClientSessionImpl.prototype.confirmCondition = thenify.withCallback(client_session_impl_1.ClientSessionImpl.prototype.confirmCondition, opts);
    client_session_impl_1.ClientSessionImpl.prototype.acknowledgeCondition = thenify.withCallback(client_session_impl_1.ClientSessionImpl.prototype.acknowledgeCondition, opts);
  }
});

// node_modules/node-opcua-client/dist/tools/findservers.js
var require_findservers = __commonJS({
  "node_modules/node-opcua-client/dist/tools/findservers.js"(exports2, module2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.findServersOnNetwork = exports2.findServers = void 0;
    var async_1 = __importDefault3(require_async());
    var client_base_impl_1 = require_client_base_impl();
    function findServers(discoveryServerEndpointUri, callback) {
      const client2 = new client_base_impl_1.ClientBaseImpl({ connectionStrategy: { maxRetry: 3 } });
      let servers = [];
      let endpoints = [];
      async_1.default.series([
        (innerCallback) => {
          client2.connect(discoveryServerEndpointUri, innerCallback);
        },
        (innerCallback) => {
          client2.findServers((err, _servers) => {
            if (_servers) {
              servers = _servers;
            }
            innerCallback(err ? err : void 0);
          });
        },
        (innerCallback) => {
          client2.getEndpoints({ endpointUrl: void 0 }, (err, _endpoints) => {
            if (_endpoints) {
              endpoints = _endpoints;
            }
            innerCallback(err ? err : void 0);
          });
        }
      ], (err) => {
        client2.disconnect(() => {
          callback(err ? err : null, { servers, endpoints });
        });
      });
    }
    exports2.findServers = findServers;
    function findServersOnNetwork(discoveryServerEndpointUri, callback) {
      const client2 = new client_base_impl_1.ClientBaseImpl({ connectionStrategy: { maxRetry: 3 } });
      client2.connect(discoveryServerEndpointUri, (err) => {
        if (!err) {
          client2.findServersOnNetwork((err1, servers) => {
            client2.disconnect(() => {
              callback(err1, servers);
            });
          });
        } else {
          client2.disconnect(() => {
            callback(err);
          });
        }
      });
    }
    exports2.findServersOnNetwork = findServersOnNetwork;
    var thenify = require_thenify();
    module2.exports.findServersOnNetwork = thenify.withCallback(module2.exports.findServersOnNetwork);
    module2.exports.findServers = thenify.withCallback(module2.exports.findServers);
  }
});

// node_modules/node-opcua-client/dist/tools/read_history_server_capabilities.js
var require_read_history_server_capabilities = __commonJS({
  "node_modules/node-opcua-client/dist/tools/read_history_server_capabilities.js"(exports2, module2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.readHistoryServerCapabilities = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_service_translate_browse_path_1 = require_dist49();
    var node_opcua_utils_1 = require_dist16();
    function readHistoryServerCapabilities(session, callback) {
      if (!callback) {
        throw new Error("Internal error");
      }
      const browsePath = (0, node_opcua_service_translate_browse_path_1.makeBrowsePath)(node_opcua_constants_1.ObjectIds.ObjectsFolder, "/Server/ServerCapabilities.HistoryServerCapabilities");
      session.translateBrowsePath(browsePath, (err, result2) => {
        if (err) {
          return callback(err);
        }
        if (!result2) {
          return callback(new Error("Internal Error"));
        }
        if (result2.statusCode.isNotGood()) {
          return callback(new Error("StatusCode = " + result2.statusCode.toString()));
        }
        result2.targets = result2.targets || [];
        const historyServerCapabilitiesNodeId = result2.targets[0].targetId;
        (0, node_opcua_assert_1.assert)(historyServerCapabilitiesNodeId.toString() === "ns=0;i=11192");
        const properties = [
          "AccessHistoryDataCapability",
          "AccessHistoryEventsCapability",
          "DeleteAtTimeCapability",
          "DeleteRawCapability",
          "DeleteEventCapability",
          "InsertAnnotationCapability",
          "InsertDataCapability",
          "InsertEventCapability",
          "ReplaceDataCapability",
          "ReplaceEventCapability",
          "UpdateDataCapability",
          "UpdateEventCapability",
          "MaxReturnDataValues",
          "MaxReturnEventValues",
          "AggregateFunctions/AnnotationCount",
          "AggregateFunctions/Average",
          "AggregateFunctions/Count",
          "AggregateFunctions/Delta",
          "AggregateFunctions/DeltaBounds",
          "AggregateFunctions/DurationBad",
          "AggregateFunctions/DurationGood",
          "AggregateFunctions/DurationStateNonZero"
          // etc....
        ];
        const browsePaths = properties.map((prop) => (0, node_opcua_service_translate_browse_path_1.makeBrowsePath)(historyServerCapabilitiesNodeId, "." + prop));
        session.translateBrowsePath(browsePaths, (innerErr, results) => {
          if (innerErr) {
            return callback(innerErr);
          }
          if (!results) {
            return callback(new Error("Internal Error"));
          }
          const nodeIds = results.map((innerResult) => innerResult.statusCode.isGood() && innerResult.targets ? innerResult.targets[0].targetId : new node_opcua_nodeid_1.NodeId());
          const nodesToRead = nodeIds.map((nodeId) => ({
            attributeId: node_opcua_data_model_1.AttributeIds.Value,
            nodeId
            /*: coerceNodeId(nodeId)*/
          }));
          const data = {};
          session.read(nodesToRead, (err2, dataValues) => {
            if (err2) {
              return callback(err2);
            }
            if (!dataValues) {
              return callback(new Error("Internal Error"));
            }
            for (let i = 0; i < dataValues.length; i++) {
              const propName = (0, node_opcua_utils_1.lowerFirstLetter)(properties[i]);
              data[propName] = dataValues[i].value;
            }
            callback(null, data);
          });
        });
      });
    }
    exports2.readHistoryServerCapabilities = readHistoryServerCapabilities;
    var thenify = require_thenify();
    var opts = { multiArgs: false };
    module2.exports.readHistoryServerCapabilities = thenify.withCallback(module2.exports.readHistoryServerCapabilities, opts);
  }
});

// node_modules/node-opcua-client/dist/client_utils.js
var require_client_utils = __commonJS({
  "node_modules/node-opcua-client/dist/client_utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.readUAAnalogItem = void 0;
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_service_translate_browse_path_1 = require_dist49();
    var hasPropertyRefId = (0, node_opcua_nodeid_1.resolveNodeId)("HasProperty");
    function browsePathPropertyRequest(nodeId, propertyName) {
      return new node_opcua_service_translate_browse_path_1.BrowsePath({
        relativePath: (
          /* RelativePath   */
          {
            elements: (
              /* RelativePathElement */
              [
                {
                  includeSubtypes: false,
                  isInverse: false,
                  referenceTypeId: hasPropertyRefId,
                  targetName: { namespaceIndex: 0, name: propertyName }
                }
              ]
            )
          }
        ),
        startingNode: (
          /* NodeId  */
          nodeId
        )
      });
    }
    async function readUAAnalogItem(session, nodeId) {
      const browsePaths = [
        browsePathPropertyRequest(nodeId, "EngineeringUnits"),
        browsePathPropertyRequest(nodeId, "EURange"),
        browsePathPropertyRequest(nodeId, "InstrumentRange"),
        browsePathPropertyRequest(nodeId, "ValuePrecision"),
        browsePathPropertyRequest(nodeId, "Definition")
      ];
      const analogItemData = {
        definition: null,
        engineeringUnits: null,
        engineeringUnitsRange: null,
        instrumentRange: null,
        valuePrecision: null
      };
      const browsePathResults = await session.translateBrowsePath(browsePaths);
      const actions = [];
      const nodesToRead = [];
      function processProperty(browsePathResult, propertyName) {
        if (browsePathResult.statusCode.isGood()) {
          browsePathResult.targets = browsePathResult.targets || [];
          nodesToRead.push({
            attributeId: node_opcua_data_model_1.AttributeIds.Value,
            nodeId: browsePathResult.targets[0].targetId
          });
          actions.push((readResult) => analogItemData[propertyName] = readResult.value.value);
        }
      }
      processProperty(browsePathResults[0], "engineeringUnits");
      processProperty(browsePathResults[1], "engineeringUnitsRange");
      processProperty(browsePathResults[2], "instrumentRange");
      processProperty(browsePathResults[3], "valuePrecision");
      processProperty(browsePathResults[4], "definition");
      const dataValues = await session.read(nodesToRead);
      dataValues.forEach((result2, index) => {
        actions[index].call(null, result2);
      });
      return analogItemData;
    }
    exports2.readUAAnalogItem = readUAAnalogItem;
  }
});

// node_modules/node-opcua-client/dist/user_identity_info.js
var require_user_identity_info = __commonJS({
  "node_modules/node-opcua-client/dist/user_identity_info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/node-opcua-client/dist/alarms_and_conditions/client_alarm_tools.js
var require_client_alarm_tools = __commonJS({
  "node_modules/node-opcua-client/dist/alarms_and_conditions/client_alarm_tools.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.installAlarmMonitoring = exports2.uninstallAlarmMonitoring = void 0;
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_service_filter_1 = require_dist61();
    var node_opcua_service_read_1 = require_dist39();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_alarm_condition_1 = require_dist62();
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)("A&E");
    var debugLog = (0, node_opcua_debug_1.make_debugLog)("A&E");
    var warningLog = (0, node_opcua_debug_1.make_warningLog)("A&E");
    function r(_key, o2) {
      if (o2 && o2.dataType === "Null") {
        return void 0;
      }
      return o2;
    }
    async function uninstallAlarmMonitoring(session) {
      const _sessionPriv = session;
      if (!_sessionPriv.$clientAlarmList) {
        return;
      }
      const mi = _sessionPriv.$monitoredItemForAlarmList;
      mi.removeAllListeners();
      _sessionPriv.$monitoredItemForAlarmList = null;
      await _sessionPriv.$subscriptionForAlarmList.terminate();
      _sessionPriv.$clientAlarmList = null;
      return;
    }
    exports2.uninstallAlarmMonitoring = uninstallAlarmMonitoring;
    async function installAlarmMonitoring(session) {
      const _sessionPriv = session;
      if (_sessionPriv.$clientAlarmList) {
        return _sessionPriv.$clientAlarmList;
      }
      const clientAlarmList = new node_opcua_alarm_condition_1.ClientAlarmList();
      _sessionPriv.$clientAlarmList = clientAlarmList;
      const request = {
        maxNotificationsPerPublish: 100,
        priority: 6,
        publishingEnabled: true,
        requestedLifetimeCount: 1e4,
        requestedMaxKeepAliveCount: 10,
        requestedPublishingInterval: 500
      };
      const subscription = await session.createSubscription2(request);
      _sessionPriv.$subscriptionForAlarmList = subscription;
      const itemToMonitor = {
        attributeId: node_opcua_data_model_1.AttributeIds.EventNotifier,
        nodeId: (0, node_opcua_nodeid_1.resolveNodeId)("Server")
        // i=2253
      };
      const fields = await (0, node_opcua_alarm_condition_1.extractConditionFields)(session, "AlarmConditionType");
      const AcknowledgeableConditionType = (0, node_opcua_nodeid_1.resolveNodeId)("AcknowledgeableConditionType");
      const eventFilter = (0, node_opcua_service_filter_1.constructEventFilter)(fields, (0, node_opcua_service_filter_1.ofType)(AcknowledgeableConditionType));
      const monitoringParameters = {
        discardOldest: false,
        filter: eventFilter,
        queueSize: 1e3,
        samplingInterval: 0
      };
      const eventMonitoringItem = await subscription.monitor(itemToMonitor, monitoringParameters, node_opcua_service_read_1.TimestampsToReturn.Both);
      const queueEvent = [];
      function flushQueue() {
        const q2 = [...queueEvent];
        queueEvent.length = 0;
        for (const pojo of q2) {
          clientAlarmList.update(pojo);
        }
      }
      let inInit = true;
      eventMonitoringItem.on("changed", (eventFields) => {
        const pojo = (0, node_opcua_alarm_condition_1.fieldsToJson)(fields, eventFields);
        const { eventType, eventId, conditionId, conditionName } = pojo;
        debugLog("xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx ---- ALARM RECEIVED " + eventType.value.toString() + " " + eventId.value?.toString("hex"));
        try {
          if (!conditionId || !conditionId.value || conditionId.dataType === node_opcua_variant_1.DataType.Null) {
            warningLog(" not acknowledgeable condition ---- " + eventType.value.toString() + " ", conditionId, conditionName?.value, " " + eventId.value?.toString("hex"));
            return;
          }
          queueEvent.push(pojo);
          if (queueEvent.length === 1 && !inInit) {
            setTimeout(() => flushQueue(), 10);
          }
        } catch (err) {
          warningLog(JSON.stringify(pojo, r, " "));
          warningLog("Error !!", err);
        }
      });
      try {
        await (0, node_opcua_alarm_condition_1.callConditionRefresh)(session, subscription.subscriptionId);
      } catch (err) {
        if (err.message.match(/BadNothingToDo/)) {
        } else {
          warningLog("Server may not implement condition refresh", err.message);
        }
      }
      _sessionPriv.$monitoredItemForAlarmList = eventMonitoringItem;
      setTimeout(() => flushQueue(), 10);
      inInit = false;
      return clientAlarmList;
    }
    exports2.installAlarmMonitoring = installAlarmMonitoring;
  }
});

// node_modules/node-opcua-client/dist/index.js
var require_dist63 = __commonJS({
  "node_modules/node-opcua-client/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __setModuleDefault2 = exports2 && exports2.__setModuleDefault || (Object.create ? function(o2, v) {
      Object.defineProperty(o2, "default", { enumerable: true, value: v });
    } : function(o2, v) {
      o2["default"] = v;
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    var __importStar3 = exports2 && exports2.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result2 = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
            __createBinding3(result2, mod, k);
      }
      __setModuleDefault2(result2, mod);
      return result2;
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.makeApplicationUrn = exports2.StatusCodes = exports2.StatusCode = exports2.coerceExpandedNodeId = exports2.makeExpandedNodeId = exports2.ExpandedNodeId = exports2.sameNodeId = exports2.coerceNodeId = exports2.makeNodeId = exports2.resolveNodeId = exports2.NodeId = exports2.setErrorLogger = exports2.setWarningLogger = exports2.setDebugLogger = exports2.setLogLevel = exports2.LogLevel = exports2.hexDump = exports2.crypto_utils = exports2.utils = exports2.ClientSecureChannelLayer = exports2.SecurityPolicy = exports2.ServiceCounterDataType = exports2.ServerState = exports2.ClientSidePublishEngine = exports2.assert = void 0;
    __exportStar3(require_client_base(), exports2);
    __exportStar3(require_opcua_client(), exports2);
    __exportStar3(require_client_session(), exports2);
    __exportStar3(require_client_subscription(), exports2);
    __exportStar3(require_client_monitored_item_base(), exports2);
    __exportStar3(require_client_monitored_item(), exports2);
    __exportStar3(require_client_monitored_item_group(), exports2);
    __exportStar3(require_client_tools(), exports2);
    __exportStar3(require_findservers(), exports2);
    __exportStar3(require_read_history_server_capabilities(), exports2);
    __exportStar3(require_client_utils(), exports2);
    __exportStar3(require_verify(), exports2);
    __exportStar3(require_user_identity_info(), exports2);
    __exportStar3(require_client_alarm_tools(), exports2);
    __exportStar3(require_client_tools(), exports2);
    __exportStar3(require_dist62(), exports2);
    var node_opcua_assert_1 = require_dist14();
    Object.defineProperty(exports2, "assert", { enumerable: true, get: function() {
      return node_opcua_assert_1.assert;
    } });
    __exportStar3(require_dist16(), exports2);
    var client_publish_engine_1 = require_client_publish_engine();
    Object.defineProperty(exports2, "ClientSidePublishEngine", { enumerable: true, get: function() {
      return client_publish_engine_1.ClientSidePublishEngine;
    } });
    var node_opcua_common_1 = require_dist34();
    Object.defineProperty(exports2, "ServerState", { enumerable: true, get: function() {
      return node_opcua_common_1.ServerState;
    } });
    Object.defineProperty(exports2, "ServiceCounterDataType", { enumerable: true, get: function() {
      return node_opcua_common_1.ServiceCounterDataType;
    } });
    var node_opcua_secure_channel_1 = require_source7();
    Object.defineProperty(exports2, "SecurityPolicy", { enumerable: true, get: function() {
      return node_opcua_secure_channel_1.SecurityPolicy;
    } });
    Object.defineProperty(exports2, "ClientSecureChannelLayer", { enumerable: true, get: function() {
      return node_opcua_secure_channel_1.ClientSecureChannelLayer;
    } });
    var utils1 = __importStar3(require_dist16());
    exports2.utils = utils1;
    var crypto_util1 = __importStar3(require_dist33());
    exports2.crypto_utils = crypto_util1;
    var node_opcua_debug_1 = require_dist24();
    Object.defineProperty(exports2, "hexDump", { enumerable: true, get: function() {
      return node_opcua_debug_1.hexDump;
    } });
    Object.defineProperty(exports2, "LogLevel", { enumerable: true, get: function() {
      return node_opcua_debug_1.LogLevel;
    } });
    Object.defineProperty(exports2, "setLogLevel", { enumerable: true, get: function() {
      return node_opcua_debug_1.setLogLevel;
    } });
    Object.defineProperty(exports2, "setDebugLogger", { enumerable: true, get: function() {
      return node_opcua_debug_1.setDebugLogger;
    } });
    Object.defineProperty(exports2, "setWarningLogger", { enumerable: true, get: function() {
      return node_opcua_debug_1.setWarningLogger;
    } });
    Object.defineProperty(exports2, "setErrorLogger", { enumerable: true, get: function() {
      return node_opcua_debug_1.setErrorLogger;
    } });
    var node_opcua_nodeid_1 = require_dist21();
    Object.defineProperty(exports2, "NodeId", { enumerable: true, get: function() {
      return node_opcua_nodeid_1.NodeId;
    } });
    Object.defineProperty(exports2, "resolveNodeId", { enumerable: true, get: function() {
      return node_opcua_nodeid_1.resolveNodeId;
    } });
    Object.defineProperty(exports2, "makeNodeId", { enumerable: true, get: function() {
      return node_opcua_nodeid_1.makeNodeId;
    } });
    Object.defineProperty(exports2, "coerceNodeId", { enumerable: true, get: function() {
      return node_opcua_nodeid_1.coerceNodeId;
    } });
    Object.defineProperty(exports2, "sameNodeId", { enumerable: true, get: function() {
      return node_opcua_nodeid_1.sameNodeId;
    } });
    Object.defineProperty(exports2, "ExpandedNodeId", { enumerable: true, get: function() {
      return node_opcua_nodeid_1.ExpandedNodeId;
    } });
    Object.defineProperty(exports2, "makeExpandedNodeId", { enumerable: true, get: function() {
      return node_opcua_nodeid_1.makeExpandedNodeId;
    } });
    Object.defineProperty(exports2, "coerceExpandedNodeId", { enumerable: true, get: function() {
      return node_opcua_nodeid_1.coerceExpandedNodeId;
    } });
    var node_opcua_status_code_1 = require_dist22();
    Object.defineProperty(exports2, "StatusCode", { enumerable: true, get: function() {
      return node_opcua_status_code_1.StatusCode;
    } });
    Object.defineProperty(exports2, "StatusCodes", { enumerable: true, get: function() {
      return node_opcua_status_code_1.StatusCodes;
    } });
    __exportStar3(require_dist28(), exports2);
    __exportStar3(require_dist29(), exports2);
    __exportStar3(require_dist27(), exports2);
    __exportStar3(require_dist20(), exports2);
    __exportStar3(require_source7(), exports2);
    var node_opcua_common_2 = require_dist34();
    Object.defineProperty(exports2, "makeApplicationUrn", { enumerable: true, get: function() {
      return node_opcua_common_2.makeApplicationUrn;
    } });
    __exportStar3(require_dist44(), exports2);
    __exportStar3(require_dist37(), exports2);
    __exportStar3(require_dist41(), exports2);
    __exportStar3(require_dist48(), exports2);
    __exportStar3(require_dist44(), exports2);
    __exportStar3(require_dist54(), exports2);
    __exportStar3(require_dist50(), exports2);
    __exportStar3(require_dist39(), exports2);
    __exportStar3(require_dist38(), exports2);
    __exportStar3(require_dist42(), exports2);
    __exportStar3(require_dist45(), exports2);
    __exportStar3(require_dist49(), exports2);
    __exportStar3(require_dist40(), exports2);
    __exportStar3(require_dist61(), exports2);
    __exportStar3(require_dist55(), exports2);
    __exportStar3(require_dist56(), exports2);
  }
});

// node_modules/node-opcua-server/dist/base_server.js
var require_base_server = __commonJS({
  "node_modules/node-opcua-server/dist/base_server.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OPCUABaseServer = void 0;
    var fs_1 = __importDefault3(require("fs"));
    var path_1 = __importDefault3(require("path"));
    var os_1 = __importDefault3(require("os"));
    var util_1 = require("util");
    var async_1 = __importDefault3(require_async());
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var global_mutex_1 = require_source8();
    var node_opcua_certificate_manager_1 = require_dist60();
    var node_opcua_common_1 = require_dist34();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_date_time_1 = require_dist17();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_debug_2 = require_dist24();
    var node_opcua_hostname_1 = require_dist36();
    var node_opcua_service_discovery_1 = require_dist48();
    var node_opcua_service_endpoints_1 = require_dist44();
    var node_opcua_service_endpoints_2 = require_dist44();
    var node_opcua_service_secure_channel_1 = require_dist38();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_client_1 = require_dist63();
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var warningLog = errorLog;
    var default_server_info = {
      // The globally unique identifier for the application instance. This URI is used as
      // ServerUri in Services if the application is a Server.
      applicationUri: (0, node_opcua_common_1.makeApplicationUrn)(os_1.default.hostname(), "NodeOPCUA-Server"),
      // The globally unique identifier for the product.
      productUri: "NodeOPCUA-Server",
      // A localized descriptive name for the application.
      applicationName: { text: "NodeOPCUA", locale: "en" },
      applicationType: node_opcua_service_endpoints_1.ApplicationType.Server,
      gatewayServerUri: "",
      discoveryProfileUri: "",
      discoveryUrls: []
    };
    function cleanupEndpoint(endpoint) {
      if (endpoint._on_new_channel) {
        (0, node_opcua_assert_1.assert)(typeof endpoint._on_new_channel === "function");
        endpoint.removeListener("newChannel", endpoint._on_new_channel);
        endpoint._on_new_channel = void 0;
      }
      if (endpoint._on_close_channel) {
        (0, node_opcua_assert_1.assert)(typeof endpoint._on_close_channel === "function");
        endpoint.removeListener("closeChannel", endpoint._on_close_channel);
        endpoint._on_close_channel = void 0;
      }
      if (endpoint._on_connectionRefused) {
        (0, node_opcua_assert_1.assert)(typeof endpoint._on_connectionRefused === "function");
        endpoint.removeListener("connectionRefused", endpoint._on_connectionRefused);
        endpoint._on_connectionRefused = void 0;
      }
      if (endpoint._on_openSecureChannelFailure) {
        (0, node_opcua_assert_1.assert)(typeof endpoint._on_openSecureChannelFailure === "function");
        endpoint.removeListener("openSecureChannelFailure", endpoint._on_openSecureChannelFailure);
        endpoint._on_openSecureChannelFailure = void 0;
      }
    }
    var emptyCallback = () => {
    };
    var OPCUABaseServer = class extends node_opcua_common_1.OPCUASecureObject {
      /**
       * The type of server
       */
      get serverType() {
        return this.serverInfo.applicationType;
      }
      constructor(options) {
        options = options || {};
        if (!options.serverCertificateManager) {
          options.serverCertificateManager = (0, node_opcua_certificate_manager_1.getDefaultCertificateManager)("PKI");
        }
        options.privateKeyFile = options.privateKeyFile || options.serverCertificateManager.privateKey;
        options.certificateFile = options.certificateFile || path_1.default.join(options.serverCertificateManager.rootDir, "own/certs/certificate.pem");
        super(options);
        this.serverCertificateManager = options.serverCertificateManager;
        this.capabilitiesForMDNS = [];
        this.endpoints = [];
        this.options = options;
        this._preInitTask = [];
        const serverInfo = {
          ...default_server_info,
          ...options.serverInfo
        };
        serverInfo.applicationName = (0, node_opcua_data_model_1.coerceLocalizedText)(serverInfo.applicationName);
        this.serverInfo = new node_opcua_service_endpoints_2.ApplicationDescription(serverInfo);
        if (this.serverInfo.applicationName.toString().match(/urn:/)) {
          errorLog("[NODE-OPCUA-E06] application name cannot be a urn", this.serverInfo.applicationName.toString());
        }
        this.serverInfo.applicationName.locale = this.serverInfo.applicationName?.locale || "en";
        if (!this.serverInfo.applicationName?.locale) {
          warningLog("[NODE-OPCUA-W24] the server applicationName must have a valid locale : ", this.serverInfo.applicationName.toString());
        }
        const __applicationUri = serverInfo.applicationUri || "";
        this.serverInfo.__defineGetter__("applicationUri", () => (0, node_opcua_hostname_1.resolveFullyQualifiedDomainName)(__applicationUri));
        this._preInitTask.push(async () => {
          const fqdn = await (0, node_opcua_hostname_1.extractFullyQualifiedDomainName)();
        });
        this._preInitTask.push(async () => {
          await this.initializeCM();
        });
      }
      async createDefaultCertificate() {
        if (fs_1.default.existsSync(this.certificateFile)) {
          return;
        }
        const hostnames = [];
        for (const e of this.endpoints) {
          for (const ee of e.endpointDescriptions()) {
          }
        }
        if (!fs_1.default.existsSync(this.certificateFile)) {
          await (0, global_mutex_1.withLock)({ fileToLock: this.certificateFile + ".mutex" }, async () => {
            if (fs_1.default.existsSync(this.certificateFile)) {
              return;
            }
            const applicationUri = this.serverInfo.applicationUri;
            const fqdn = (0, node_opcua_hostname_1.getFullyQualifiedDomainName)();
            const hostname2 = (0, node_opcua_hostname_1.getHostname)();
            const dns = [.../* @__PURE__ */ new Set([fqdn, hostname2])];
            await this.serverCertificateManager.createSelfSignedCertificate({
              applicationUri,
              dns,
              // ip: await getIpAddresses(),
              outputFile: this.certificateFile,
              subject: (0, node_opcua_certificate_manager_1.makeSubject)(this.serverInfo.applicationName.text, hostname2),
              startDate: /* @__PURE__ */ new Date(),
              validity: 365 * 10
              // 10 years
            });
          });
        }
      }
      async initializeCM() {
        await this.serverCertificateManager.initialize();
        await this.createDefaultCertificate();
        debugLog("privateKey      = ", this.privateKeyFile, this.serverCertificateManager.privateKey);
        debugLog("certificateFile = ", this.certificateFile);
        await (0, node_opcua_client_1.performCertificateSanityCheck)(this, "server", this.serverCertificateManager, this.serverInfo.applicationUri);
      }
      /**
       * start all registered endPoint, in parallel, and call done when all endPoints are listening.
       * @method start
       * @async
       * @param {callback} done
       */
      start(done) {
        (0, node_opcua_assert_1.assert)(typeof done === "function");
        this.startAsync().then(() => done(null)).catch((err) => done(err));
      }
      async performPreInitialization() {
        const tasks = this._preInitTask;
        this._preInitTask = [];
        for (const task of tasks) {
          await task();
        }
      }
      async startAsync() {
        await this.performPreInitialization();
        (0, node_opcua_assert_1.assert)(Array.isArray(this.endpoints));
        (0, node_opcua_assert_1.assert)(this.endpoints.length > 0, "We need at least one end point");
        (0, node_opcua_date_time_1.installPeriodicClockAdjustment)();
        const server = this;
        const _on_new_channel = function(channel) {
          server.emit("newChannel", channel, this);
        };
        const _on_close_channel = function(channel) {
          server.emit("closeChannel", channel, this);
        };
        const _on_connectionRefused = function(socketData) {
          server.emit("connectionRefused", socketData, this);
        };
        const _on_openSecureChannelFailure = function(socketData, channelData) {
          server.emit("openSecureChannelFailure", socketData, channelData, this);
        };
        const promises = [];
        for (const endpoint of this.endpoints) {
          (0, node_opcua_assert_1.assert)(!endpoint._on_close_channel);
          endpoint._on_new_channel = _on_new_channel;
          endpoint.on("newChannel", endpoint._on_new_channel);
          endpoint._on_close_channel = _on_close_channel;
          endpoint.on("closeChannel", endpoint._on_close_channel);
          endpoint._on_connectionRefused = _on_connectionRefused;
          endpoint.on("connectionRefused", endpoint._on_connectionRefused);
          endpoint._on_openSecureChannelFailure = _on_openSecureChannelFailure;
          endpoint.on("openSecureChannelFailure", endpoint._on_openSecureChannelFailure);
          promises.push(new Promise((resolve2, reject) => endpoint.start((err) => err ? reject(err) : resolve2())));
        }
        await Promise.all(promises);
      }
      /**
       * shutdown all server endPoints
       * @async
       */
      shutdown(done) {
        (0, node_opcua_assert_1.assert)(typeof done === "function");
        (0, node_opcua_date_time_1.uninstallPeriodicClockAdjustment)();
        this.serverCertificateManager.dispose().then(() => {
          debugLog("OPCUABaseServer#shutdown starting");
          async_1.default.forEach(this.endpoints, (endpoint, callback) => {
            cleanupEndpoint(endpoint);
            endpoint.shutdown(callback);
          }, (err) => {
            debugLog("shutdown completed");
            done(err);
          });
        });
      }
      shutdownChannels(callback) {
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        debugLog("OPCUABaseServer#shutdownChannels");
        async_1.default.forEach(this.endpoints, (endpoint, inner_callback) => {
          debugLog(" shutting down endpoint ", endpoint.endpointDescriptions()[0].endpointUrl);
          async_1.default.series([
            // xx                  (callback2: (err?: Error| null) => void) => {
            // xx                      endpoint.suspendConnection(callback2);
            // xx                  },
            (callback2) => {
              endpoint.abruptlyInterruptChannels();
              endpoint.shutdown(callback2);
            }
            // xx              (callback2: (err?: Error| null) => void) => {
            // xx                 endpoint.restoreConnection(callback2);
            // xx              }
          ], inner_callback);
        }, callback);
      }
      /**
       * @private
       */
      on_request(message, channel) {
        (0, node_opcua_assert_1.assert)(message.request);
        (0, node_opcua_assert_1.assert)(message.requestId !== 0);
        const request = message.request;
        if (!channel._on_response) {
          channel._on_response = (msg, response1) => {
            this.emit("response", response1, channel);
          };
        }
        this.prepare(message, channel);
        if (doDebug) {
          debugLog(chalk_1.default.green.bold("--------------------------------------------------------"), channel.channelId, request.schema.name);
        }
        let errMessage;
        let response;
        this.emit("request", request, channel);
        try {
          const handler = this["_on_" + request.schema.name];
          if (typeof handler === "function") {
            handler.apply(this, arguments);
          } else {
            errMessage = "[NODE-OPCUA-W07] Unsupported Service : " + request.schema.name;
            warningLog(errMessage);
            debugLog(chalk_1.default.red.bold(errMessage));
            response = makeServiceFault(node_opcua_status_code_1.StatusCodes.BadServiceUnsupported, [errMessage]);
            channel.send_response("MSG", response, message, emptyCallback);
          }
        } catch (err) {
          const errMessage1 = "[NODE-OPCUA-W08] EXCEPTION CAUGHT WHILE PROCESSING REQUEST !! " + request.schema.name;
          warningLog(chalk_1.default.red.bold(errMessage1));
          warningLog(request.toString());
          (0, node_opcua_debug_2.displayTraceFromThisProjectOnly)(err);
          let additional_messages = [];
          additional_messages.push("EXCEPTION CAUGHT WHILE PROCESSING REQUEST !!! " + request.schema.name);
          if (util_1.types.isNativeError(err)) {
            additional_messages.push(err.message);
            if (err.stack) {
              additional_messages = additional_messages.concat(err.stack.split("\n"));
            }
          }
          response = makeServiceFault(node_opcua_status_code_1.StatusCodes.BadInternalError, additional_messages);
          channel.send_response("MSG", response, message, emptyCallback);
        }
      }
      /**
       * @private
       */
      _get_endpoints(endpointUrl) {
        let endpoints = [];
        for (const endPoint of this.endpoints) {
          const ep = endPoint.endpointDescriptions();
          const epFiltered = endpointUrl ? ep.filter((e) => (0, node_opcua_utils_1.matchUri)(e.endpointUrl, endpointUrl)) : ep;
          endpoints = endpoints.concat(epFiltered);
        }
        return endpoints;
      }
      /**
       * get one of the possible endpointUrl
       */
      getEndpointUrl() {
        return this._get_endpoints()[0].endpointUrl;
      }
      getDiscoveryUrls() {
        const discoveryUrls = this.endpoints.map((e) => {
          return e.endpointDescriptions()[0].endpointUrl;
        });
        return discoveryUrls;
      }
      getServers(channel) {
        this.serverInfo.discoveryUrls = this.getDiscoveryUrls();
        const servers = [this.serverInfo];
        return servers;
      }
      suspendEndPoints(callback) {
        if (!callback) {
          throw new Error("Internal Error");
        }
        async_1.default.forEach(this.endpoints, (ep, _inner_callback) => {
          if (doDebug) {
            debugLog("Suspending ", ep.endpointDescriptions()[0].endpointUrl);
          }
          ep.suspendConnection((err) => {
            if (doDebug) {
              debugLog("Suspended ", ep.endpointDescriptions()[0].endpointUrl);
            }
            _inner_callback(err);
          });
        }, (err) => callback(err));
      }
      resumeEndPoints(callback) {
        async_1.default.forEach(this.endpoints, (ep, _inner_callback) => {
          ep.restoreConnection(_inner_callback);
        }, (err) => callback(err));
      }
      prepare(message, channel) {
      }
      /**
       * @private
       */
      _on_GetEndpointsRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request.schema.name === "GetEndpointsRequest");
        const response = new node_opcua_service_endpoints_1.GetEndpointsResponse({});
        response.endpoints = this._get_endpoints(null);
        const e = response.endpoints.map((e2) => e2.endpointUrl);
        if (request.endpointUrl) {
          const filtered = response.endpoints.filter((endpoint) => endpoint.endpointUrl === request.endpointUrl);
          if (filtered.length > 0) {
            response.endpoints = filtered;
          }
        }
        response.endpoints = response.endpoints.filter((endpoint) => !endpoint.restricted);
        if (request.profileUris && request.profileUris.length > 0) {
          response.endpoints = response.endpoints.filter((endpoint) => {
            return request.profileUris.indexOf(endpoint.transportProfileUri) >= 0;
          });
        }
        response.endpoints.forEach((endpoint) => {
          endpoint.server.applicationName.locale = "en-US";
        });
        channel.send_response("MSG", response, message, emptyCallback);
      }
      /**
       * @private
       */
      _on_FindServersRequest(message, channel) {
        const shortDelay = 100;
        setTimeout(() => {
          const request = message.request;
          (0, node_opcua_assert_1.assert)(request.schema.name === "FindServersRequest");
          if (!(request instanceof node_opcua_service_discovery_1.FindServersRequest)) {
            throw new Error("Invalid request type");
          }
          let servers = this.getServers(channel);
          if (request.serverUris && request.serverUris.length > 0) {
            servers = servers.filter((inner_Server) => {
              return request.serverUris.indexOf(inner_Server.applicationUri) >= 0;
            });
          }
          function adapt(applicationDescription) {
            return new node_opcua_service_endpoints_2.ApplicationDescription({
              applicationName: applicationDescription.applicationName,
              applicationType: applicationDescription.applicationType,
              applicationUri: applicationDescription.applicationUri,
              discoveryProfileUri: applicationDescription.discoveryProfileUri,
              discoveryUrls: applicationDescription.discoveryUrls,
              gatewayServerUri: applicationDescription.gatewayServerUri,
              productUri: applicationDescription.productUri
            });
          }
          const response = new node_opcua_service_discovery_1.FindServersResponse({
            servers: servers.map(adapt)
          });
          channel.send_response("MSG", response, message, emptyCallback);
        }, shortDelay);
      }
      /**
       * returns a array of currently active channels
       */
      getChannels() {
        let channels = [];
        for (const endpoint of this.endpoints) {
          const c2 = endpoint.getChannels();
          channels = channels.concat(c2);
        }
        return channels;
      }
    };
    exports2.OPCUABaseServer = OPCUABaseServer;
    OPCUABaseServer.makeServiceFault = makeServiceFault;
    function makeServiceFault(statusCode, messages) {
      const response = new node_opcua_service_secure_channel_1.ServiceFault();
      response.responseHeader.serviceResult = statusCode;
      (0, node_opcua_assert_1.assert)(Array.isArray(messages));
      (0, node_opcua_assert_1.assert)(typeof messages[0] === "string");
      response.responseHeader.stringTable = messages;
      warningLog(chalk_1.default.cyan(" messages "), messages.join("\n"));
      return response;
    }
    var thenify = require_thenify();
    var opts = { multiArgs: false };
    OPCUABaseServer.prototype.resumeEndPoints = thenify.withCallback(OPCUABaseServer.prototype.resumeEndPoints, opts);
    OPCUABaseServer.prototype.suspendEndPoints = thenify.withCallback(OPCUABaseServer.prototype.suspendEndPoints, opts);
    OPCUABaseServer.prototype.shutdownChannels = thenify.withCallback(OPCUABaseServer.prototype.shutdownChannels, opts);
  }
});

// node_modules/node-opcua-server/dist/server_end_point.js
var require_server_end_point = __commonJS({
  "node_modules/node-opcua-server/dist/server_end_point.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OPCUAServerEndPoint = void 0;
    var events_1 = require("events");
    var net_1 = __importDefault3(require("net"));
    var chalk_1 = __importDefault3(require_source());
    var async_1 = __importDefault3(require_async());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_crypto_1 = require_dist33();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_hostname_1 = require_dist36();
    var node_opcua_secure_channel_1 = require_source7();
    var node_opcua_service_endpoints_1 = require_dist44();
    var node_opcua_service_endpoints_2 = require_dist44();
    var node_opcua_service_endpoints_3 = require_dist44();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var default_transportProfileUri = "http://opcfoundation.org/UA-Profile/Transport/uatcp-uasc-uabinary";
    function extractSocketData(socket, reason) {
      const { bytesRead, bytesWritten, remoteAddress, remoteFamily, remotePort, localAddress, localPort } = socket;
      const data = {
        bytesRead,
        bytesWritten,
        localAddress,
        localPort,
        remoteAddress,
        remoteFamily,
        remotePort,
        timestamp: /* @__PURE__ */ new Date(),
        reason
      };
      return data;
    }
    function extractChannelData(channel) {
      const { channelId, clientCertificate, clientNonce, clientSecurityHeader, securityHeader, securityMode, securityPolicy, timeout, transactionsCount } = channel;
      const channelData = {
        channelId,
        clientCertificate,
        clientNonce,
        clientSecurityHeader,
        securityHeader,
        securityMode,
        securityPolicy,
        timeout,
        transactionsCount
      };
      return channelData;
    }
    var emptyCertificate = Buffer.alloc(0);
    var emptyPrivateKey = null;
    var OPCUAServerEndPointCounter = 0;
    function getUniqueName(name, collection) {
      if (collection[name]) {
        let counter = 0;
        while (collection[name + "_" + counter.toString()]) {
          counter++;
        }
        name = name + "_" + counter.toString();
        collection[name] = 1;
        return name;
      } else {
        collection[name] = 1;
        return name;
      }
    }
    var OPCUAServerEndPoint = class extends events_1.EventEmitter {
      constructor(options) {
        super();
        this._started = false;
        this._counter = OPCUAServerEndPointCounter++;
        this._policy_deduplicator = {};
        (0, node_opcua_assert_1.assert)(!Object.prototype.hasOwnProperty.call(options, "certificate"), "expecting a certificateChain instead");
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "certificateChain"), "expecting a certificateChain");
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "privateKey"));
        this.certificateManager = options.certificateManager;
        options.port = options.port || 0;
        this.port = parseInt(options.port.toString(), 10);
        this.host = options.host;
        (0, node_opcua_assert_1.assert)(typeof this.port === "number");
        this._certificateChain = options.certificateChain;
        this._privateKey = options.privateKey;
        this._channels = {};
        this.defaultSecureTokenLifetime = options.defaultSecureTokenLifetime || 6e5;
        this.maxConnections = options.maxConnections || 20;
        this.timeout = options.timeout || 3e4;
        this._server = void 0;
        this._setup_server();
        this._endpoints = [];
        this.objectFactory = options.objectFactory;
        this.bytesWrittenInOldChannels = 0;
        this.bytesReadInOldChannels = 0;
        this.transactionsCountOldChannels = 0;
        this.securityTokenCountOldChannels = 0;
        this.serverInfo = options.serverInfo;
        (0, node_opcua_assert_1.assert)(this.serverInfo !== null && typeof this.serverInfo === "object");
        this.transportSettings = options.transportSettings;
      }
      dispose() {
        this._certificateChain = emptyCertificate;
        this._privateKey = emptyPrivateKey;
        (0, node_opcua_assert_1.assert)(Object.keys(this._channels).length === 0, "OPCUAServerEndPoint channels must have been deleted");
        this._channels = {};
        this.serverInfo = new node_opcua_service_endpoints_3.ApplicationDescription({});
        this._endpoints = [];
        (0, node_opcua_assert_1.assert)(this._endpoints.length === 0, "endpoints must have been deleted");
        this._endpoints = [];
        this._server = void 0;
        this._listen_callback = void 0;
        this.removeAllListeners();
      }
      toString() {
        const privateKeyThumpPrint = (0, node_opcua_crypto_1.makePrivateKeyThumbPrint)(this.getPrivateKey());
        const txt = " end point" + this._counter + " port = " + this.port + " l = " + this._endpoints.length + " " + (0, node_opcua_crypto_1.makeSHA1Thumbprint)(this.getCertificateChain()).toString("hex") + " " + privateKeyThumpPrint.toString("hex");
        return txt;
      }
      getChannels() {
        return Object.values(this._channels);
      }
      /**
       * Returns the X509 DER form of the server certificate
       */
      getCertificate() {
        return (0, node_opcua_crypto_1.split_der)(this.getCertificateChain())[0];
      }
      /**
       * Returns the X509 DER form of the server certificate
       */
      getCertificateChain() {
        return this._certificateChain;
      }
      /**
       * the private key
       */
      getPrivateKey() {
        return this._privateKey;
      }
      /**
       * The number of active channel on this end point.
       */
      get currentChannelCount() {
        return Object.keys(this._channels).length;
      }
      /**
       * @method getEndpointDescription
       * @param securityMode
       * @param securityPolicy
       * @return endpoint_description {EndpointDescription|null}
       */
      getEndpointDescription(securityMode, securityPolicy, endpointUrl) {
        const endpoints = this.endpointDescriptions();
        const arr = endpoints.filter(matching_endpoint.bind(this, securityMode, securityPolicy, endpointUrl));
        if (endpointUrl && endpointUrl.length > 0 && !(arr.length === 0 || arr.length === 1)) {
          errorLog("Several matching endpoints have been found : ");
          for (const a of arr) {
            errorLog("   ", a.endpointUrl, node_opcua_secure_channel_1.MessageSecurityMode[securityMode], securityPolicy);
          }
        }
        return arr.length === 0 ? null : arr[0];
      }
      addEndpointDescription(securityMode, securityPolicy, options) {
        if (securityMode === node_opcua_secure_channel_1.MessageSecurityMode.None && securityPolicy !== node_opcua_secure_channel_1.SecurityPolicy.None) {
          throw new Error(" invalid security ");
        }
        if (securityMode !== node_opcua_secure_channel_1.MessageSecurityMode.None && securityPolicy === node_opcua_secure_channel_1.SecurityPolicy.None) {
          throw new Error(" invalid security ");
        }
        const resourcePath = (options.resourcePath || "").replace(/\\/g, "/");
        (0, node_opcua_assert_1.assert)(resourcePath.length === 0 || resourcePath.charAt(0) === "/", "resourcePath should start with /");
        const hostname2 = options.hostname || (0, node_opcua_hostname_1.getFullyQualifiedDomainName)();
        const endpointUrl = `opc.tcp://${hostname2}:${this.port}${resourcePath}`;
        const endpoint_desc = this.getEndpointDescription(securityMode, securityPolicy, endpointUrl);
        if (endpoint_desc) {
          throw new Error(" endpoint already exist");
        }
        const userTokenTypes = options.userTokenTypes;
        this._endpoints.push(_makeEndpointDescription({
          collection: this._policy_deduplicator,
          hostname: hostname2,
          server: this.serverInfo,
          serverCertificateChain: this.getCertificateChain(),
          securityMode,
          securityPolicy,
          allowUnsecurePassword: options.allowUnsecurePassword,
          resourcePath: options.resourcePath,
          restricted: !!options.restricted,
          securityPolicies: options.securityPolicies || [],
          userTokenTypes
        }, this));
      }
      addRestrictedEndpointDescription(options) {
        options = { ...options };
        options.restricted = true;
        return this.addEndpointDescription(node_opcua_secure_channel_1.MessageSecurityMode.None, node_opcua_secure_channel_1.SecurityPolicy.None, options);
      }
      addStandardEndpointDescriptions(options) {
        options = options || {};
        options.securityModes = options.securityModes || defaultSecurityModes;
        options.securityPolicies = options.securityPolicies || defaultSecurityPolicies;
        options.userTokenTypes = options.userTokenTypes || defaultUserTokenTypes;
        options.allowAnonymous = options.allowAnonymous === void 0 ? true : options.allowAnonymous;
        if (!options.allowAnonymous) {
          options.userTokenTypes = options.userTokenTypes.filter((r) => r !== node_opcua_service_endpoints_1.UserTokenType.Anonymous);
        }
        const defaultHostname = options.hostname || (0, node_opcua_hostname_1.getFullyQualifiedDomainName)();
        let hostnames = [defaultHostname];
        options.alternateHostname = options.alternateHostname || [];
        if (typeof options.alternateHostname === "string") {
          options.alternateHostname = [options.alternateHostname];
        }
        hostnames = [...new Set(hostnames.concat(options.alternateHostname))];
        for (const alternateHostname of hostnames) {
          const optionsE = {
            hostname: alternateHostname,
            securityPolicies: options.securityPolicies,
            userTokenTypes: options.userTokenTypes,
            allowUnsecurePassword: options.allowUnsecurePassword,
            alternateHostname: options.alternateHostname,
            resourcePath: options.resourcePath
          };
          if (options.securityModes.indexOf(node_opcua_secure_channel_1.MessageSecurityMode.None) >= 0) {
            this.addEndpointDescription(node_opcua_secure_channel_1.MessageSecurityMode.None, node_opcua_secure_channel_1.SecurityPolicy.None, optionsE);
          } else {
            if (!options.disableDiscovery) {
              this.addRestrictedEndpointDescription(optionsE);
            }
          }
          for (const securityMode of options.securityModes) {
            if (securityMode === node_opcua_secure_channel_1.MessageSecurityMode.None) {
              continue;
            }
            for (const securityPolicy of options.securityPolicies) {
              if (securityPolicy === node_opcua_secure_channel_1.SecurityPolicy.None) {
                continue;
              }
              this.addEndpointDescription(securityMode, securityPolicy, optionsE);
            }
          }
        }
      }
      /**
       * returns the list of end point descriptions.
       */
      endpointDescriptions() {
        return this._endpoints;
      }
      /**
       * @method listen
       * @async
       */
      listen(callback) {
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        (0, node_opcua_assert_1.assert)(!this._started, "OPCUAServerEndPoint is already listening");
        this._listen_callback = callback;
        this._server.on("error", (err) => {
          debugLog(chalk_1.default.red.bold(" error") + " port = " + this.port, err);
          this._started = false;
          this._end_listen(err);
        });
        this._server.on("listening", () => {
          debugLog("server is listening");
        });
        const listenOptions = {
          port: this.port,
          host: this.host
        };
        this._server.listen(
          listenOptions,
          /*"::",*/
          (err) => {
            debugLog(chalk_1.default.green.bold("LISTENING TO PORT "), this.port, "err  ", err);
            (0, node_opcua_assert_1.assert)(!err, " cannot listen to port ");
            this._started = true;
            if (!this.port) {
              const add = this._server.address();
              this.port = typeof add !== "string" ? add.port : this.port;
            }
            this._end_listen();
          }
        );
      }
      killClientSockets(callback) {
        for (const channel of this.getChannels()) {
          const hacked_channel = channel;
          if (hacked_channel.transport && hacked_channel.transport._socket) {
            hacked_channel.transport._socket.destroy();
            hacked_channel.transport._socket.emit("error", new Error("EPIPE"));
          }
        }
        callback();
      }
      suspendConnection(callback) {
        if (!this._started) {
          return callback(new Error("Connection already suspended !!"));
        }
        this._server.close(() => {
          this._started = false;
          debugLog("Connection has been closed !" + this.port);
        });
        this._started = false;
        callback();
      }
      restoreConnection(callback) {
        this.listen(callback);
      }
      abruptlyInterruptChannels() {
        for (const channel of Object.values(this._channels)) {
          channel.abruptlyInterrupt();
        }
      }
      /**
       * @method shutdown
       * @async
       */
      shutdown(callback) {
        debugLog("OPCUAServerEndPoint#shutdown ");
        if (this._started) {
          this.suspendConnection(() => {
            const _channels = Object.values(this._channels);
            async_1.default.each(_channels, (channel, callback1) => {
              this.shutdown_channel(channel, callback1);
            }, (err) => {
              if (!(Object.keys(this._channels).length === 0)) {
                errorLog(" Bad !");
              }
              (0, node_opcua_assert_1.assert)(Object.keys(this._channels).length === 0, "channel must have unregistered themselves");
              callback(err || void 0);
            });
          });
        } else {
          callback();
        }
      }
      /**
       * @method start
       * @async
       * @param callback
       */
      start(callback) {
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        this.listen(callback);
      }
      get bytesWritten() {
        const channels = Object.values(this._channels);
        return this.bytesWrittenInOldChannels + channels.reduce((accumulated, channel) => {
          return accumulated + channel.bytesWritten;
        }, 0);
      }
      get bytesRead() {
        const channels = Object.values(this._channels);
        return this.bytesReadInOldChannels + channels.reduce((accumulated, channel) => {
          return accumulated + channel.bytesRead;
        }, 0);
      }
      get transactionsCount() {
        const channels = Object.values(this._channels);
        return this.transactionsCountOldChannels + channels.reduce((accumulated, channel) => {
          return accumulated + channel.transactionsCount;
        }, 0);
      }
      get securityTokenCount() {
        const channels = Object.values(this._channels);
        return this.securityTokenCountOldChannels + channels.reduce((accumulated, channel) => {
          return accumulated + channel.securityTokenCount;
        }, 0);
      }
      get activeChannelCount() {
        return Object.keys(this._channels).length;
      }
      _dump_statistics() {
        this._server.getConnections((err, count) => {
          debugLog(chalk_1.default.cyan("CONCURRENT CONNECTION = "), count);
        });
        debugLog(chalk_1.default.cyan("MAX CONNECTIONS = "), this._server.maxConnections);
      }
      _setup_server() {
        (0, node_opcua_assert_1.assert)(!this._server);
        this._server = net_1.default.createServer({ pauseOnConnect: true }, this._on_client_connection.bind(this));
        this._server.maxConnections = this.maxConnections + 1;
        this._listen_callback = void 0;
        this._server.on("connection", (socket) => {
          if (doDebug) {
            this._dump_statistics();
            debugLog("server connected  with : " + socket.remoteAddress + ":" + socket.remotePort);
          }
        }).on("close", () => {
          debugLog("server closed : all connections have ended");
        }).on("error", (err) => {
          debugLog(chalk_1.default.red.bold("server error: "), err.message);
        });
      }
      _on_client_connection(socket) {
        socket.setNoDelay(true);
        debugLog("OPCUAServerEndPoint#_on_client_connection", this._started);
        if (!this._started) {
          debugLog(chalk_1.default.bgWhite.cyan("OPCUAServerEndPoint#_on_client_connection SERVER END POINT IS PROBABLY SHUTTING DOWN !!! - Connection is refused"));
          socket.end();
          return;
        }
        const deny_connection = () => {
          console.log(chalk_1.default.bgWhite.cyan("OPCUAServerEndPoint#_on_client_connection The maximum number of connection has been reached - Connection is refused"));
          const reason = "maxConnections reached (" + this.maxConnections + ")";
          const socketData = extractSocketData(socket, reason);
          this.emit("connectionRefused", socketData);
          socket.end();
          socket.destroy();
        };
        const establish_connection = () => {
          const nbConnections = Object.keys(this._channels).length;
          if (nbConnections >= this.maxConnections) {
            warningLog(" nbConnections ", nbConnections, " self._server.maxConnections", this._server.maxConnections, this.maxConnections);
            deny_connection();
            return;
          }
          debugLog("OPCUAServerEndPoint._on_client_connection successful => New Channel");
          const channel = new node_opcua_secure_channel_1.ServerSecureChannelLayer({
            defaultSecureTokenLifetime: this.defaultSecureTokenLifetime,
            // objectFactory: this.objectFactory,
            parent: this,
            timeout: this.timeout,
            adjustTransportLimits: this.transportSettings?.adjustTransportLimits
          });
          debugLog("channel Timeout = >", channel.timeout);
          socket.resume();
          this._preregisterChannel(channel);
          channel.init(socket, (err) => {
            this._un_pre_registerChannel(channel);
            debugLog(chalk_1.default.yellow.bold("Channel#init done"), err);
            if (err) {
              const reason = "openSecureChannel has Failed " + err.message;
              const socketData = extractSocketData(socket, reason);
              const channelData = extractChannelData(channel);
              this.emit("openSecureChannelFailure", socketData, channelData);
              socket.end();
              socket.destroy();
            } else {
              debugLog("server receiving a client connection");
              this._registerChannel(channel);
            }
          });
          channel.on("message", (message) => {
            this.emit("message", message, channel, this);
          });
        };
        this._prevent_DDOS_Attack(establish_connection, deny_connection);
      }
      _preregisterChannel(channel) {
        (0, node_opcua_assert_1.assert)(this._started, "OPCUAServerEndPoint must be started");
        (0, node_opcua_assert_1.assert)(!Object.prototype.hasOwnProperty.call(this._channels, channel.hashKey), " channel already preregistered!");
        const channelPriv = channel;
        this._channels[channel.hashKey] = channelPriv;
        channelPriv._unpreregisterChannelEvent = () => {
          debugLog("Channel received an abort event during the preregistration phase");
          this._un_pre_registerChannel(channel);
          channel.dispose();
        };
        channel.on("abort", channelPriv._unpreregisterChannelEvent);
      }
      _un_pre_registerChannel(channel) {
        if (!this._channels[channel.hashKey]) {
          debugLog("Already un preregistered ?", channel.hashKey);
          return;
        }
        delete this._channels[channel.hashKey];
        const channelPriv = channel;
        if (typeof channelPriv._unpreregisterChannelEvent === "function") {
          channel.removeListener("abort", channelPriv._unpreregisterChannelEvent);
          channelPriv._unpreregisterChannelEvent = void 0;
        }
      }
      /**
       * @method _registerChannel
       * @param channel
       * @private
       */
      _registerChannel(channel) {
        if (this._started) {
          debugLog(chalk_1.default.red("_registerChannel = "), "channel.hashKey = ", channel.hashKey);
          (0, node_opcua_assert_1.assert)(!this._channels[channel.hashKey]);
          this._channels[channel.hashKey] = channel;
          this.emit("newChannel", channel);
          channel.on("abort", () => {
            this._unregisterChannel(channel);
          });
        } else {
          debugLog("OPCUAServerEndPoint#_registerChannel called when end point is shutdown !");
          debugLog("  -> channel will be forcefully terminated");
          channel.close(() => {
            channel.dispose();
          });
        }
      }
      /**
       * @method _unregisterChannel
       * @param channel
       * @private
       */
      _unregisterChannel(channel) {
        debugLog("_un-registerChannel channel.hashKey", channel.hashKey);
        if (!Object.prototype.hasOwnProperty.call(this._channels, channel.hashKey)) {
          return;
        }
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(this._channels, channel.hashKey), "channel is not registered");
        this.emit("closeChannel", channel);
        this.bytesWrittenInOldChannels += channel.bytesWritten;
        this.bytesReadInOldChannels += channel.bytesRead;
        this.transactionsCountOldChannels += channel.transactionsCount;
        delete this._channels[channel.hashKey];
        if (doDebug) {
          this._dump_statistics();
          debugLog("un-registering channel  - Count = ", this.currentChannelCount);
        }
      }
      _end_listen(err) {
        if (!this._listen_callback)
          return;
        (0, node_opcua_assert_1.assert)(typeof this._listen_callback === "function");
        this._listen_callback(err);
        this._listen_callback = void 0;
      }
      /**
       *  shutdown_channel
       * @param channel
       * @param inner_callback
       */
      shutdown_channel(channel, inner_callback) {
        (0, node_opcua_assert_1.assert)(typeof inner_callback === "function");
        channel.once("close", () => {
        });
        channel.close(() => {
          this._unregisterChannel(channel);
          setImmediate(inner_callback);
        });
      }
      /**
       * @private
       */
      _prevent_DDOS_Attack(establish_connection, deny_connection) {
        const nbConnections = this.activeChannelCount;
        if (nbConnections >= this.maxConnections) {
          errorLog(chalk_1.default.bgRed.white("PREVENTING DDOS ATTACK => maxConnection =" + this.maxConnections));
          const unused_channels = this.getChannels().filter((channel1) => {
            return !channel1.hasSession;
          });
          if (unused_channels.length === 0) {
            doDebug && console.log(this.getChannels().map(({ status: status2, isOpened, hasSession }) => `${status2} ${isOpened} ${hasSession}
`).join(" "));
            errorLog(`All channels are in used ! we cannot cancel any ${this.getChannels().length}`);
            if (doDebug) {
              console.log("  - all channels are used !!!!");
            }
            setTimeout(deny_connection, 1e3);
            return;
          }
          if (doDebug) {
            console.log("   - Unused channels that can be clobbered", unused_channels.map((channel1) => channel1.hashKey).join(" "));
          }
          const channel = unused_channels[0];
          errorLog(`${unused_channels.length} : Forcefully closing oldest channel that have no session: ${channel.hashKey}`);
          channel.close(() => {
            if (doDebug) {
              console.log("   _ Unused channel has been closed ", channel.hashKey);
            }
            this._unregisterChannel(channel);
            establish_connection();
          });
        } else {
          setImmediate(establish_connection);
        }
      }
    };
    exports2.OPCUAServerEndPoint = OPCUAServerEndPoint;
    function estimateSecurityLevel(securityMode, securityPolicy) {
      if (securityMode === node_opcua_secure_channel_1.MessageSecurityMode.None) {
        return 1;
      }
      let offset = 100;
      if (securityMode === node_opcua_secure_channel_1.MessageSecurityMode.SignAndEncrypt) {
        offset = 200;
      }
      switch (securityPolicy) {
        case node_opcua_secure_channel_1.SecurityPolicy.Basic128:
        case node_opcua_secure_channel_1.SecurityPolicy.Basic128Rsa15:
        case node_opcua_secure_channel_1.SecurityPolicy.Basic192:
          return 2;
        case node_opcua_secure_channel_1.SecurityPolicy.Basic192Rsa15:
          return 3;
        case node_opcua_secure_channel_1.SecurityPolicy.Basic256:
          return 4;
        case node_opcua_secure_channel_1.SecurityPolicy.Basic256Rsa15:
          return 4 + offset;
        case node_opcua_secure_channel_1.SecurityPolicy.Aes128_Sha256_RsaOaep:
          return 5 + offset;
        case node_opcua_secure_channel_1.SecurityPolicy.Basic256Sha256:
          return 6 + offset;
        case node_opcua_secure_channel_1.SecurityPolicy.Aes256_Sha256_RsaPss:
          return 7 + offset;
        default:
        case node_opcua_secure_channel_1.SecurityPolicy.None:
          return 1;
      }
    }
    function _makeEndpointDescription(options, parent) {
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "serverCertificateChain"));
      (0, node_opcua_assert_1.assert)(!Object.prototype.hasOwnProperty.call(options, "serverCertificate"));
      (0, node_opcua_assert_1.assert)(!!options.securityMode);
      (0, node_opcua_assert_1.assert)(!!options.securityPolicy);
      (0, node_opcua_assert_1.assert)(options.server !== null && typeof options.server === "object");
      (0, node_opcua_assert_1.assert)(!!options.hostname && typeof options.hostname === "string");
      (0, node_opcua_assert_1.assert)(typeof options.restricted === "boolean");
      const u2 = (n) => getUniqueName(n, options.collection);
      options.securityLevel = options.securityLevel === void 0 ? estimateSecurityLevel(options.securityMode, options.securityPolicy) : options.securityLevel;
      (0, node_opcua_assert_1.assert)(isFinite(options.securityLevel), "expecting a valid securityLevel");
      const securityPolicyUri = (0, node_opcua_secure_channel_1.toURI)(options.securityPolicy);
      const userIdentityTokens = [];
      const registerIdentity2 = (tokenType, securityPolicy, name) => {
        return registerIdentity({
          policyId: u2(name),
          tokenType,
          issuedTokenType: null,
          issuerEndpointUrl: null,
          securityPolicyUri: securityPolicy
        });
      };
      const registerIdentity = (r) => {
        const tokenType = r.tokenType === void 0 ? node_opcua_service_endpoints_1.UserTokenType.Invalid : r.tokenType;
        const securityPolicy = r.securityPolicyUri || "";
        if (!securityPolicy && options.userTokenTypes.indexOf(tokenType) >= 0) {
          userIdentityTokens.push(r);
          return;
        }
        if (options.securityPolicies.indexOf(securityPolicy) >= 0 && options.userTokenTypes.indexOf(tokenType) >= 0) {
          userIdentityTokens.push(r);
        }
      };
      if (!options.noUserIdentityTokens) {
        if (options.securityPolicy === node_opcua_secure_channel_1.SecurityPolicy.None) {
          if (options.allowUnsecurePassword) {
            registerIdentity({
              policyId: u2("username_unsecure"),
              tokenType: node_opcua_service_endpoints_1.UserTokenType.UserName,
              issuedTokenType: null,
              issuerEndpointUrl: null,
              securityPolicyUri: null
            });
          }
          const onlyCertificateLessConnection = options.onlyCertificateLessConnection === void 0 ? false : options.onlyCertificateLessConnection;
          if (!onlyCertificateLessConnection) {
            registerIdentity2(node_opcua_service_endpoints_1.UserTokenType.UserName, node_opcua_secure_channel_1.SecurityPolicy.Basic256, "username_basic256");
            registerIdentity2(node_opcua_service_endpoints_1.UserTokenType.UserName, node_opcua_secure_channel_1.SecurityPolicy.Basic128Rsa15, "username_basic128Rsa15");
            registerIdentity2(node_opcua_service_endpoints_1.UserTokenType.UserName, node_opcua_secure_channel_1.SecurityPolicy.Basic256Sha256, "username_basic256Sha256");
            registerIdentity2(node_opcua_service_endpoints_1.UserTokenType.UserName, node_opcua_secure_channel_1.SecurityPolicy.Aes128_Sha256_RsaOaep, "username_aes128Sha256RsaOaep");
            registerIdentity2(node_opcua_service_endpoints_1.UserTokenType.Certificate, node_opcua_secure_channel_1.SecurityPolicy.Basic256, "certificate_basic256");
            registerIdentity2(node_opcua_service_endpoints_1.UserTokenType.Certificate, node_opcua_secure_channel_1.SecurityPolicy.Basic128Rsa15, "certificate_basic128Rsa15");
            registerIdentity2(node_opcua_service_endpoints_1.UserTokenType.Certificate, node_opcua_secure_channel_1.SecurityPolicy.Basic256Sha256, "certificate_basic256Sha256");
            registerIdentity2(node_opcua_service_endpoints_1.UserTokenType.Certificate, node_opcua_secure_channel_1.SecurityPolicy.Aes128_Sha256_RsaOaep, "certificate_aes128Sha256RsaOaep");
          }
        } else {
          if (process.env.NODEOPCUA_SERVER_EMULATE_SIEMENS) {
            const registerIdentity3 = (tokenType, securityPolicy, name) => {
              const identity = {
                policyId: u2(name),
                tokenType,
                issuedTokenType: null,
                issuerEndpointUrl: null,
                securityPolicyUri: securityPolicy
              };
              userIdentityTokens.push(identity);
            };
            registerIdentity3(node_opcua_service_endpoints_1.UserTokenType.UserName, node_opcua_secure_channel_1.SecurityPolicy.Basic256, "username_basic256");
            registerIdentity3(node_opcua_service_endpoints_1.UserTokenType.UserName, node_opcua_secure_channel_1.SecurityPolicy.Basic128Rsa15, "username_basic128Rsa15");
            registerIdentity3(node_opcua_service_endpoints_1.UserTokenType.UserName, node_opcua_secure_channel_1.SecurityPolicy.Basic256Sha256, "username_basic256Sha256");
          } else {
            registerIdentity({
              policyId: u2("usernamePassword"),
              tokenType: node_opcua_service_endpoints_1.UserTokenType.UserName,
              issuedTokenType: null,
              issuerEndpointUrl: null,
              securityPolicyUri: null
            });
            registerIdentity({
              policyId: u2("certificateX509"),
              tokenType: node_opcua_service_endpoints_1.UserTokenType.Certificate,
              issuedTokenType: null,
              issuerEndpointUrl: null,
              securityPolicyUri: null
            });
          }
        }
        registerIdentity({
          policyId: u2("anonymous"),
          tokenType: node_opcua_service_endpoints_1.UserTokenType.Anonymous,
          issuedTokenType: null,
          issuerEndpointUrl: null,
          securityPolicyUri: null
        });
      }
      const endpoint = new node_opcua_service_endpoints_2.EndpointDescription({
        endpointUrl: "<to be evaluated at run time>",
        // options.endpointUrl,
        server: void 0,
        // options.server,
        serverCertificate: options.serverCertificateChain,
        securityMode: options.securityMode,
        securityPolicyUri,
        userIdentityTokens,
        securityLevel: options.securityLevel,
        transportProfileUri: default_transportProfileUri
      });
      endpoint._parent = parent;
      endpoint.__defineGetter__("endpointUrl", () => {
        const port2 = endpoint._parent.port;
        const resourcePath = options.resourcePath || "";
        const hostname2 = options.hostname;
        const endpointUrl = `opc.tcp://${hostname2}:${port2}${resourcePath}`;
        return (0, node_opcua_hostname_1.resolveFullyQualifiedDomainName)(endpointUrl);
      });
      endpoint.server = options.server;
      endpoint.restricted = options.restricted;
      return endpoint;
    }
    function matching_endpoint(securityMode, securityPolicy, endpointUrl, endpoint) {
      (0, node_opcua_assert_1.assert)(endpoint instanceof node_opcua_service_endpoints_2.EndpointDescription);
      const endpoint_securityPolicy = (0, node_opcua_secure_channel_1.fromURI)(endpoint.securityPolicyUri);
      if (endpointUrl && endpoint.endpointUrl !== endpointUrl) {
        return false;
      }
      return endpoint.securityMode === securityMode && endpoint_securityPolicy === securityPolicy;
    }
    var defaultSecurityModes = [node_opcua_secure_channel_1.MessageSecurityMode.None, node_opcua_secure_channel_1.MessageSecurityMode.Sign, node_opcua_secure_channel_1.MessageSecurityMode.SignAndEncrypt];
    var defaultSecurityPolicies = [
      // now deprecated  Basic128Rs15 shall be disabled by default
      // see https://profiles.opcfoundation.org/profile/1532
      // SecurityPolicy.Basic128Rsa15,
      // now deprecated Basic256 shall be disabled by default
      // see https://profiles.opcfoundation.org/profile/2062
      // SecurityPolicy.Basic256,
      // xx UNUSED!!  SecurityPolicy.Basic192Rsa15,
      // xx UNUSED!!  SecurityPolicy.Basic256Rsa15,
      node_opcua_secure_channel_1.SecurityPolicy.Basic256Sha256,
      node_opcua_secure_channel_1.SecurityPolicy.Aes128_Sha256_RsaOaep,
      node_opcua_secure_channel_1.SecurityPolicy.Aes256_Sha256_RsaPss
    ];
    var defaultUserTokenTypes = [
      node_opcua_service_endpoints_1.UserTokenType.Anonymous,
      node_opcua_service_endpoints_1.UserTokenType.UserName,
      node_opcua_service_endpoints_1.UserTokenType.Certificate
      // NOT USED YET : UserTokenType.IssuedToken
    ];
  }
});

// node_modules/node-opcua-server/dist/register_server_manager.js
var require_register_server_manager = __commonJS({
  "node_modules/node-opcua-server/dist/register_server_manager.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RegisterServerManager = exports2.RegisterServerManagerStatus = void 0;
    var events_1 = require("events");
    var async_1 = __importDefault3(require_async());
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_client_1 = require_dist63();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_hostname_1 = require_dist36();
    var node_opcua_secure_channel_1 = require_source7();
    var node_opcua_service_discovery_1 = require_dist48();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_crypto_1 = require_dist33();
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var RegisterServerManagerStatus;
    (function(RegisterServerManagerStatus2) {
      RegisterServerManagerStatus2[RegisterServerManagerStatus2["INACTIVE"] = 1] = "INACTIVE";
      RegisterServerManagerStatus2[RegisterServerManagerStatus2["INITIALIZING"] = 2] = "INITIALIZING";
      RegisterServerManagerStatus2[RegisterServerManagerStatus2["REGISTERING"] = 3] = "REGISTERING";
      RegisterServerManagerStatus2[RegisterServerManagerStatus2["WAITING"] = 4] = "WAITING";
      RegisterServerManagerStatus2[RegisterServerManagerStatus2["UNREGISTERING"] = 5] = "UNREGISTERING";
    })(RegisterServerManagerStatus || (exports2.RegisterServerManagerStatus = RegisterServerManagerStatus = {}));
    var g_DefaultRegistrationServerTimeout = 8 * 60 * 1e3;
    function securityPolicyLevel(securityPolicy) {
      switch (securityPolicy) {
        case node_opcua_secure_channel_1.SecurityPolicy.None:
          return 0;
        case node_opcua_secure_channel_1.SecurityPolicy.Basic128:
          return 1;
        case node_opcua_secure_channel_1.SecurityPolicy.Basic128Rsa15:
          return 2;
        case node_opcua_secure_channel_1.SecurityPolicy.Basic192:
          return 3;
        case node_opcua_secure_channel_1.SecurityPolicy.Basic192Rsa15:
          return 4;
        case node_opcua_secure_channel_1.SecurityPolicy.Basic256:
          return 5;
        case node_opcua_secure_channel_1.SecurityPolicy.Basic256Rsa15:
          return 6;
        case node_opcua_secure_channel_1.SecurityPolicy.Aes128_Sha256_RsaOaep:
          return 7;
        case node_opcua_secure_channel_1.SecurityPolicy.Basic256Sha256:
          return 8;
        case node_opcua_secure_channel_1.SecurityPolicy.Aes256_Sha256_RsaPss:
          return 9;
        default:
          return 0;
      }
    }
    function sortEndpointBySecurityLevel(endpoints) {
      endpoints.sort((a, b) => {
        if (a.securityMode === b.securityMode) {
          if (a.securityPolicyUri === b.securityPolicyUri) {
            const sa = a.securityLevel;
            const sb = b.securityLevel;
            return sa < sb ? 1 : sa > sb ? -1 : 0;
          } else {
            const sa = securityPolicyLevel(a.securityPolicyUri);
            const sb = securityPolicyLevel(b.securityPolicyUri);
            return sa < sb ? 1 : sa > sb ? -1 : 0;
          }
        } else {
          return a.securityMode < b.securityMode ? 1 : 0;
        }
      });
      return endpoints;
    }
    function findSecureEndpoint(endpoints) {
      endpoints = endpoints.filter((e) => {
        return e.transportProfileUri === "http://opcfoundation.org/UA-Profile/Transport/uatcp-uasc-uabinary";
      });
      endpoints = endpoints.filter((e) => {
        return e.securityMode === node_opcua_secure_channel_1.MessageSecurityMode.SignAndEncrypt;
      });
      if (endpoints.length === 0) {
        endpoints = endpoints.filter((e) => {
          return e.securityMode === node_opcua_secure_channel_1.MessageSecurityMode.Sign;
        });
      }
      if (endpoints.length === 0) {
        endpoints = endpoints.filter((e) => {
          return e.securityMode === node_opcua_secure_channel_1.MessageSecurityMode.None;
        });
      }
      endpoints = sortEndpointBySecurityLevel(endpoints);
      return endpoints[0];
    }
    function constructRegisteredServer(server, isOnline) {
      const discoveryUrls = server.getDiscoveryUrls();
      (0, node_opcua_assert_1.assert)(!isOnline || discoveryUrls.length >= 1, "expecting some discoveryUrls if we go online ....");
      const info = (0, node_opcua_crypto_1.exploreCertificate)(server.getCertificate());
      const commonName = info.tbsCertificate.subject.commonName;
      const serverUri = info.tbsCertificate.extensions?.subjectAltName.uniformResourceIdentifier[0];
      if (serverUri !== server.serverInfo.applicationUri) {
        warningLog(chalk_1.default.yellow("Warning certificate uniformResourceIdentifier doesn't match serverInfo.applicationUri"), "\n subjectKeyIdentifier      : ", info.tbsCertificate.extensions?.subjectKeyIdentifier, "\n subjectAltName            : ", info.tbsCertificate.extensions?.subjectAltName, "\n commonName                : ", info.tbsCertificate.subject.commonName, "\n serverInfo.applicationUri : ", server.serverInfo.applicationUri);
      }
      if (!server.serverInfo.applicationName.text) {
        debugLog("warning: application name is missing");
      }
      const s = {
        serverUri: server.serverInfo.applicationUri,
        // The globally unique identifier for the Server product.
        productUri: server.serverInfo.productUri,
        serverNames: [
          {
            locale: "en-US",
            text: server.serverInfo.applicationName.text
          }
        ],
        serverType: server.serverType,
        discoveryUrls,
        gatewayServerUri: null,
        isOnline,
        semaphoreFilePath: null
      };
      return s;
    }
    function constructRegisterServerRequest(serverB, isOnline) {
      const server = constructRegisteredServer(serverB, isOnline);
      return new node_opcua_service_discovery_1.RegisterServerRequest({
        server
      });
    }
    function constructRegisterServer2Request(serverB, isOnline) {
      const server = constructRegisteredServer(serverB, isOnline);
      return new node_opcua_service_discovery_1.RegisterServer2Request({
        discoveryConfiguration: [
          new node_opcua_types_1.MdnsDiscoveryConfiguration({
            mdnsServerName: serverB.serverInfo.applicationUri,
            serverCapabilities: serverB.capabilitiesForMDNS
          })
        ],
        server
      });
    }
    var no_reconnect_connectivity_strategy = {
      initialDelay: 2e3,
      maxDelay: 5e4,
      maxRetry: 1,
      // NO RETRY !!!
      randomisationFactor: 0
    };
    var infinite_connectivity_strategy = {
      initialDelay: 2e3,
      maxDelay: 5e4,
      maxRetry: 1e7,
      randomisationFactor: 0
    };
    function sendRegisterServerRequest(server, client2, isOnline, callback) {
      const request = constructRegisterServer2Request(server, isOnline);
      client2.performMessageTransaction(request, (err, response) => {
        if (!err) {
          debugLog("RegisterServerManager#_registerServer sendRegisterServer2Request has succeeded (isOnline", isOnline, ")");
          (0, node_opcua_assert_1.assert)(response instanceof node_opcua_service_discovery_1.RegisterServer2Response);
          callback(err);
        } else {
          debugLog("RegisterServerManager#_registerServer sendRegisterServer2Request has failed (isOnline", isOnline, ")");
          debugLog("RegisterServerManager#_registerServer falling back to using sendRegisterServerRequest instead");
          const request1 = constructRegisterServerRequest(server, isOnline);
          client2.performMessageTransaction(request1, (err1, response1) => {
            if (!err1) {
              debugLog("RegisterServerManager#_registerServer sendRegisterServerRequest has succeeded (isOnline", isOnline, ")");
              (0, node_opcua_assert_1.assert)(response1 instanceof node_opcua_service_discovery_1.RegisterServerResponse);
            } else {
              debugLog("RegisterServerManager#_registerServer sendRegisterServerRequest has failed (isOnline", isOnline, ")");
            }
            callback(err1);
          });
        }
      });
    }
    var RegisterServerManager = class extends events_1.EventEmitter {
      constructor(options) {
        super();
        this.state = RegisterServerManagerStatus.INACTIVE;
        this._registration_client = null;
        this._serverEndpoints = [];
        this.server = options.server;
        this._setState(RegisterServerManagerStatus.INACTIVE);
        this.timeout = g_DefaultRegistrationServerTimeout;
        this.discoveryServerEndpointUrl = options.discoveryServerEndpointUrl || "opc.tcp://localhost:4840";
        (0, node_opcua_assert_1.assert)(typeof this.discoveryServerEndpointUrl === "string");
        this._registrationTimerId = null;
      }
      dispose() {
        this.server = null;
        debugLog("RegisterServerManager#dispose", this.state.toString());
        (0, node_opcua_assert_1.assert)(this.state === RegisterServerManagerStatus.INACTIVE);
        if (this._registrationTimerId) {
          clearTimeout(this._registrationTimerId);
          this._registrationTimerId = null;
        }
        (0, node_opcua_assert_1.assert)(this._registrationTimerId === null, "stop has not been called");
        this.removeAllListeners();
      }
      _emitEvent(eventName) {
        setImmediate(() => {
          this.emit(eventName);
        });
      }
      _setState(status2) {
        const previousState = this.state || RegisterServerManagerStatus.INACTIVE;
        debugLog("RegisterServerManager#setState : ", RegisterServerManagerStatus[previousState], " => ", RegisterServerManagerStatus[status2]);
        this.state = status2;
      }
      start(callback) {
        debugLog("RegisterServerManager#start");
        if (this.state !== RegisterServerManagerStatus.INACTIVE) {
          return callback(new Error("RegisterServer process already started"));
        }
        this.discoveryServerEndpointUrl = (0, node_opcua_hostname_1.resolveFullyQualifiedDomainName)(this.discoveryServerEndpointUrl);
        this._establish_initial_connection((err) => {
          if (err) {
            debugLog("RegisterServerManager#start => _establish_initial_connection has failed");
            return callback(err);
          }
          if (this.state !== RegisterServerManagerStatus.INITIALIZING) {
            debugLog("RegisterServerManager#start => _establish_initial_connection has failed");
            return callback();
          }
          this._registerServer(true, (err1) => {
            if (this.state !== RegisterServerManagerStatus.REGISTERING) {
              debugLog("RegisterServerManager#start )=> Registration has been cancelled");
              return callback(new Error("Registration has been cancelled"));
            }
            if (err1) {
              warningLog("RegisterServerManager#start - registering server has failed ! \nplease check that your server certificate is accepted by the LDS");
              this._setState(RegisterServerManagerStatus.INACTIVE);
              this._emitEvent("serverRegistrationFailure");
            } else {
              this._emitEvent("serverRegistered");
              this._setState(RegisterServerManagerStatus.WAITING);
              this._trigger_next();
            }
            callback();
          });
        });
      }
      _establish_initial_connection(outer_callback) {
        if (!this.server) {
          throw new Error("Internal Error");
        }
        debugLog("RegisterServerManager#_establish_initial_connection");
        (0, node_opcua_assert_1.assert)(!this._registration_client);
        (0, node_opcua_assert_1.assert)(typeof this.discoveryServerEndpointUrl === "string");
        (0, node_opcua_assert_1.assert)(this.state === RegisterServerManagerStatus.INACTIVE);
        this._setState(RegisterServerManagerStatus.INITIALIZING);
        this.selectedEndpoint = void 0;
        const applicationName = (0, node_opcua_client_1.coerceLocalizedText)(this.server.serverInfo.applicationName)?.text || void 0;
        this.server.serverCertificateManager.referenceCounter++;
        const registrationClient = node_opcua_client_1.OPCUAClientBase.create({
          clientName: this.server.serverInfo.applicationUri,
          applicationName,
          applicationUri: this.server.serverInfo.applicationUri,
          connectionStrategy: infinite_connectivity_strategy,
          clientCertificateManager: this.server.serverCertificateManager,
          certificateFile: this.server.certificateFile,
          privateKeyFile: this.server.privateKeyFile
        });
        this._registration_client = registrationClient;
        registrationClient.on("backoff", (nbRetry, delay) => {
          debugLog("RegisterServerManager - received backoff");
          warningLog(chalk_1.default.bgWhite.cyan("contacting discovery server backoff "), this.discoveryServerEndpointUrl, " attempt #", nbRetry, " retrying in ", delay / 1e3, " seconds");
          this._emitEvent("serverRegistrationPending");
        });
        async_1.default.series([
          //  do_initial_connection_with_discovery_server
          (callback) => {
            registrationClient.connect(this.discoveryServerEndpointUrl, (err) => {
              if (err) {
                debugLog("RegisterServerManager#_establish_initial_connection : initial connection to server has failed");
              }
              return callback(err);
            });
          },
          // getEndpoints_on_discovery_server
          (callback) => {
            registrationClient.getEndpoints((err, endpoints) => {
              if (!err) {
                const endpoint = findSecureEndpoint(endpoints);
                if (!endpoint) {
                  throw new Error("Cannot find Secure endpoint");
                }
                if (endpoint.serverCertificate) {
                  (0, node_opcua_assert_1.assert)(endpoint.serverCertificate);
                  this.selectedEndpoint = endpoint;
                } else {
                  this.selectedEndpoint = void 0;
                }
              } else {
                debugLog("RegisterServerManager#_establish_initial_connection : getEndpointsRequest has failed");
                debugLog(err);
              }
              callback(err);
            });
          },
          // function closing_discovery_server_connection
          (callback) => {
            this._serverEndpoints = registrationClient._serverEndpoints;
            registrationClient.disconnect((err) => {
              this._registration_client = null;
              callback(err);
            });
          },
          // function wait_a_little_bit
          (callback) => {
            setTimeout(callback, 10);
          }
        ], (err) => {
          debugLog("-------------------------------", !!err);
          if (this.state !== RegisterServerManagerStatus.INITIALIZING) {
            debugLog("RegisterServerManager#_establish_initial_connection has been interrupted ", RegisterServerManagerStatus[this.state]);
            this._setState(RegisterServerManagerStatus.INACTIVE);
            if (this._registration_client) {
              this._registration_client.disconnect((err2) => {
                this._registration_client = null;
                outer_callback(new Error("Initialization has been canceled"));
              });
            } else {
              outer_callback(new Error("Initialization has been canceled"));
            }
            return;
          }
          if (err) {
            this._setState(RegisterServerManagerStatus.INACTIVE);
            if (this._registration_client) {
              this._registration_client.disconnect((err1) => {
                this._registration_client = null;
                debugLog("#######", !!err1);
                outer_callback(err);
              });
              return;
            }
          }
          outer_callback();
        });
      }
      _trigger_next() {
        (0, node_opcua_assert_1.assert)(!this._registrationTimerId);
        (0, node_opcua_assert_1.assert)(this.state === RegisterServerManagerStatus.WAITING);
        debugLog("RegisterServerManager#_trigger_next : installing timeout to perform registerServer renewal (timeout =", this.timeout, ")");
        this._registrationTimerId = setTimeout(() => {
          if (!this._registrationTimerId) {
            debugLog("RegisterServerManager => cancelling re registration");
            return;
          }
          this._registrationTimerId = null;
          debugLog("RegisterServerManager#_trigger_next : renewing RegisterServer");
          this._registerServer(true, (err) => {
            if (this.state !== RegisterServerManagerStatus.INACTIVE && this.state !== RegisterServerManagerStatus.UNREGISTERING) {
              debugLog("RegisterServerManager#_trigger_next : renewed !", err);
              this._setState(RegisterServerManagerStatus.WAITING);
              this._emitEvent("serverRegistrationRenewed");
              this._trigger_next();
            }
          });
        }, this.timeout);
      }
      stop(callback) {
        debugLog("RegisterServerManager#stop");
        if (this._registrationTimerId) {
          debugLog("RegisterServerManager#stop :clearing timeout");
          clearTimeout(this._registrationTimerId);
          this._registrationTimerId = null;
        }
        this._cancel_pending_client_if_any(() => {
          debugLog("RegisterServerManager#stop  _cancel_pending_client_if_any done ", this.state);
          if (!this.selectedEndpoint || this.state === RegisterServerManagerStatus.INACTIVE) {
            this.state = RegisterServerManagerStatus.INACTIVE;
            (0, node_opcua_assert_1.assert)(this._registrationTimerId === null);
            return callback();
          }
          this._registerServer(false, () => {
            this._setState(RegisterServerManagerStatus.INACTIVE);
            this._emitEvent("serverUnregistered");
            callback();
          });
        });
      }
      /**
       * @param isOnline
       * @param outer_callback
       * @private
       */
      _registerServer(isOnline, outer_callback) {
        (0, node_opcua_assert_1.assert)(typeof outer_callback === "function");
        debugLog("RegisterServerManager#_registerServer isOnline:", isOnline, "selectedEndpoint: ", this.selectedEndpoint?.endpointUrl);
        (0, node_opcua_assert_1.assert)(this.selectedEndpoint, "must have a selected endpoint => please call _establish_initial_connection");
        (0, node_opcua_assert_1.assert)(this.server.serverType !== void 0, " must have a valid server Type");
        const server = this.server;
        const selectedEndpoint = this.selectedEndpoint;
        if (!selectedEndpoint) {
          warningLog("Warning : cannot register server - no endpoint available");
          return outer_callback(new Error("Cannot registerServer"));
        }
        server.serverCertificateManager.referenceCounter++;
        const applicationName = (0, node_opcua_client_1.coerceLocalizedText)(server.serverInfo.applicationName)?.text || void 0;
        const theStatus = isOnline ? RegisterServerManagerStatus.REGISTERING : RegisterServerManagerStatus.UNREGISTERING;
        if (theStatus === this.state) {
          warningLog(`Warning the server is already in the ${RegisterServerManagerStatus[theStatus]} state`);
          return outer_callback();
        }
        if (!(this.state === RegisterServerManagerStatus.INITIALIZING || this.state === RegisterServerManagerStatus.WAITING)) {
          warningLog("Warning : cannot register server - wrong state ", RegisterServerManagerStatus[this.state]);
          return outer_callback();
        }
        ;
        this._setState(theStatus);
        if (this._registration_client) {
          warningLog(`Warning there is already a registering/unregistering task taking place:  ${RegisterServerManagerStatus[this.state]} state`);
        }
        const options = {
          securityMode: selectedEndpoint.securityMode,
          securityPolicy: (0, node_opcua_secure_channel_1.coerceSecurityPolicy)(selectedEndpoint.securityPolicyUri),
          serverCertificate: selectedEndpoint.serverCertificate,
          clientCertificateManager: server.serverCertificateManager,
          certificateFile: server.certificateFile,
          privateKeyFile: server.privateKeyFile,
          // xx clientName: server.serverInfo.applicationUri!,
          applicationName,
          applicationUri: server.serverInfo.applicationUri,
          connectionStrategy: no_reconnect_connectivity_strategy,
          clientName: "server client to LDS " + RegisterServerManagerStatus[theStatus]
        };
        const client2 = node_opcua_client_1.OPCUAClientBase.create(options);
        const tmp = this._serverEndpoints;
        client2._serverEndpoints = tmp;
        this._registration_client = client2;
        debugLog("                      lds endpoint uri : ", selectedEndpoint.endpointUrl);
        debugLog("                      securityMode     : ", node_opcua_secure_channel_1.MessageSecurityMode[selectedEndpoint.securityMode]);
        debugLog("                      securityPolicy   : ", selectedEndpoint.securityPolicyUri);
        async_1.default.series([
          // establish_connection_with_lds
          (callback) => {
            client2.connect(selectedEndpoint.endpointUrl, (err) => {
              debugLog("establish_connection_with_lds => err = ", err);
              if (err) {
                debugLog("RegisterServerManager#_registerServer connection to client has failed");
                debugLog("RegisterServerManager#_registerServer  => please check that you server certificate is trusted by the LDS");
                warningLog("RegisterServer to the LDS  has failed during secure connection  => please check that you server certificate is trusted by the LDS.", "\nerr: " + err.message, "\nLDS endpoint    :", selectedEndpoint.endpointUrl, "\nsecurity mode   :", node_opcua_secure_channel_1.MessageSecurityMode[selectedEndpoint.securityMode], "\nsecurity policy :", (0, node_opcua_secure_channel_1.coerceSecurityPolicy)(selectedEndpoint.securityPolicyUri));
                client2.disconnect(() => {
                  this._registration_client = null;
                  debugLog("RegisterServerManager#_registerServer client disconnected");
                  callback(
                    /* intentionally no error propagation*/
                  );
                });
              } else {
                callback();
              }
            });
          },
          (callback) => {
            if (!this._registration_client) {
              callback();
              return;
            }
            sendRegisterServerRequest(this.server, client2, isOnline, (err) => {
              callback(
                /* intentionally no error propagation*/
              );
            });
          },
          // close_connection_with_lds
          (callback) => {
            if (!this._registration_client) {
              callback();
              return;
            }
            client2.disconnect(callback);
          }
        ], (err) => {
          if (!this._registration_client) {
            debugLog("RegisterServerManager#_registerServer end (isOnline", isOnline, ") has been interrupted");
            outer_callback();
            return;
          }
          this._registration_client.disconnect(() => {
            debugLog("RegisterServerManager#_registerServer end (isOnline", isOnline, ")");
            this._registration_client = null;
            outer_callback(err);
          });
        });
      }
      _cancel_pending_client_if_any(callback) {
        debugLog("RegisterServerManager#_cancel_pending_client_if_any");
        if (this._registration_client) {
          debugLog("RegisterServerManager#_cancel_pending_client_if_any => wee need to disconnect  _registration_client");
          this._registration_client.disconnect(() => {
            this._registration_client = null;
            this._cancel_pending_client_if_any(callback);
          });
        } else {
          debugLog("RegisterServerManager#_cancel_pending_client_if_any : done");
          callback();
        }
      }
    };
    exports2.RegisterServerManager = RegisterServerManager;
  }
});

// node_modules/node-opcua-server/dist/register_server_manager_mdns_only.js
var require_register_server_manager_mdns_only = __commonJS({
  "node_modules/node-opcua-server/dist/register_server_manager_mdns_only.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RegisterServerManagerMDNSONLY = void 0;
    var events_1 = require("events");
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_service_discovery_1 = require_dist48();
    var base_server_1 = require_base_server();
    var RegisterServerManagerMDNSONLY = class extends events_1.EventEmitter {
      constructor(options) {
        super();
        this.discoveryServerEndpointUrl = "";
        this.server = options.server;
        (0, node_opcua_assert_1.assert)(this.server);
        (0, node_opcua_assert_1.assert)(this.server instanceof base_server_1.OPCUABaseServer);
        this.bonjour = new node_opcua_service_discovery_1.BonjourHolder();
      }
      stop(callback) {
        if (this.bonjour) {
          this.bonjour.stopAnnouncedOnMulticastSubnetWithCallback(() => {
            this.emit("serverUnregistered");
            setImmediate(callback);
          });
        }
      }
      start(callback) {
        if (!this.server) {
          throw new Error("internal error");
        }
        (0, node_opcua_assert_1.assert)(this.server instanceof base_server_1.OPCUABaseServer);
        const host = "TODO-find how to extract hostname";
        this.bonjour.announcedOnMulticastSubnetWithCallback({
          capabilities: this.server.capabilitiesForMDNS,
          name: this.server.serverInfo.applicationUri,
          path: "/",
          // <- to do
          host,
          port: this.server.endpoints[0].port
        }, () => {
          this.emit("serverRegistered");
          setImmediate(callback);
        });
      }
      dispose() {
        (0, node_opcua_assert_1.assert)(!this.bonjour.isStarted());
        (0, node_opcua_assert_1.assert)(this.server);
        this.server = void 0;
      }
    };
    exports2.RegisterServerManagerMDNSONLY = RegisterServerManagerMDNSONLY;
  }
});

// node_modules/node-opcua-server/dist/queue.js
var require_queue = __commonJS({
  "node_modules/node-opcua-server/dist/queue.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Queue = void 0;
    var Dequeue = require_lib16();
    var Queue = class {
      constructor() {
        this._d = new Dequeue();
        this.size = 0;
      }
      clear() {
        this.size = 0;
      }
      first() {
        if (this.size === 0) {
          return void 0;
        }
        return this._d.first();
      }
      shift() {
        if (this.size === 0) {
          return void 0;
        }
        this.size -= 1;
        return this._d.shift();
      }
      push(value) {
        this.size += 1;
        this._d.push(value);
      }
      filterOut(predicate) {
        let counter = 0;
        let p3 = this._d.head.next;
        while (p3 != this._d.head) {
          const shouldRemove = predicate(p3.data);
          const pPrev = p3;
          p3 = p3.next;
          if (shouldRemove) {
            this.size -= 1;
            counter += 1;
            pPrev.remove();
          }
        }
        return counter;
      }
      values() {
        const self2 = this;
        const iteratable = {
          [Symbol.iterator]() {
            let cursor = self2._d.head;
            const iterator = {
              next() {
                cursor = cursor.next;
                if (cursor === self2._d.head) {
                  return { done: true, value: null };
                }
                const ret = {
                  done: false,
                  value: cursor.data
                };
                return ret;
              }
            };
            return iterator;
          }
        };
        return iteratable;
      }
    };
    exports2.Queue = Queue;
  }
});

// node_modules/node-opcua-server/dist/node_sampler.js
var require_node_sampler = __commonJS({
  "node_modules/node-opcua-server/dist/node_sampler.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.removeFromTimer = exports2.appendToTimer = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_utils_1 = require_dist16();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var timers = {};
    var NS_PER_SEC = 1e9;
    function sampleMonitoredItem(monitoredItem) {
      const _monitoredItem = monitoredItem;
      if (monitoredItem.monitoringMode === node_opcua_types_1.MonitoringMode.Disabled) {
        return;
      }
      setImmediate(() => {
        _monitoredItem._on_sampling_timer();
      });
    }
    function appendToTimer(monitoredItem) {
      const samplingInterval = monitoredItem.samplingInterval;
      const key = samplingInterval.toString();
      (0, node_opcua_assert_1.assert)(samplingInterval > 0);
      let _t = timers[key];
      if (!_t) {
        _t = {
          _samplingId: false,
          monitoredItems: {},
          monitoredItemsCount: 0
        };
        _t._samplingId = setInterval(() => {
          const start = doDebug ? (0, node_opcua_utils_1.hrtime)() : void 0;
          let counter = 0;
          for (const m2 in _t.monitoredItems) {
            if (Object.prototype.hasOwnProperty.call(_t.monitoredItems, m2)) {
              sampleMonitoredItem(_t.monitoredItems[m2]);
              counter++;
            }
          }
          if (doDebug) {
            const elapsed = (0, node_opcua_utils_1.hrtime)(start);
            debugLog(`Sampler ${samplingInterval}  ms : Benchmark took ${((elapsed[0] * NS_PER_SEC + elapsed[1]) / 1e3 / 1e3).toFixed(3)} milliseconds for ${counter} elements`);
          }
        }, samplingInterval);
        timers[key] = _t;
      }
      (0, node_opcua_assert_1.assert)(!_t.monitoredItems[monitoredItem.monitoredItemId]);
      _t.monitoredItems[monitoredItem.monitoredItemId] = monitoredItem;
      _t.monitoredItemsCount++;
      return key;
    }
    exports2.appendToTimer = appendToTimer;
    function removeFromTimer(monitoredItem) {
      const samplingInterval = monitoredItem.samplingInterval;
      (0, node_opcua_assert_1.assert)(samplingInterval > 0);
      (0, node_opcua_assert_1.assert)(typeof monitoredItem._samplingId === "string");
      const key = monitoredItem._samplingId;
      const _t = timers[key];
      if (!_t) {
        debugLog("cannot find common timer for samplingInterval", key);
        return;
      }
      (0, node_opcua_assert_1.assert)(_t);
      (0, node_opcua_assert_1.assert)(_t.monitoredItems[monitoredItem.monitoredItemId]);
      delete _t.monitoredItems[monitoredItem.monitoredItemId];
      _t.monitoredItemsCount--;
      (0, node_opcua_assert_1.assert)(_t.monitoredItemsCount >= 0);
      if (_t.monitoredItemsCount === 0) {
        if (_t._samplingId !== false) {
          clearInterval(_t._samplingId);
        }
        delete timers[key];
      }
    }
    exports2.removeFromTimer = removeFromTimer;
  }
});

// node_modules/node-opcua-server/dist/validate_filter.js
var require_validate_filter = __commonJS({
  "node_modules/node-opcua-server/dist/validate_filter.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.validateFilter = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_data_model_2 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_service_filter_1 = require_dist61();
    var node_opcua_service_subscription_1 = require_dist45();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_debug_1 = require_dist24();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    function isNumberDataType(node) {
      const n = node.dataType;
      if (n.namespace === 0 && n.identifierType === node_opcua_nodeid_1.NodeIdType.NUMERIC && n.value < 22) {
        switch (n.value) {
          case node_opcua_basic_types_1.DataType.Float:
          case node_opcua_basic_types_1.DataType.Double:
          case node_opcua_basic_types_1.DataType.Byte:
          case node_opcua_basic_types_1.DataType.SByte:
          case node_opcua_basic_types_1.DataType.Int16:
          case node_opcua_basic_types_1.DataType.Int32:
          case node_opcua_basic_types_1.DataType.Int64:
          case node_opcua_basic_types_1.DataType.UInt16:
          case node_opcua_basic_types_1.DataType.UInt32:
          case node_opcua_basic_types_1.DataType.UInt64:
            return true;
          default:
            return false;
        }
      }
      const dataType = node.addressSpace.findDataType(node.dataType);
      const dataTypeNumber = node.addressSpace.findDataType("Number");
      return dataType.isSubtypeOf(dataTypeNumber);
    }
    function __validateDataChangeFilter(filter, itemToMonitor, node) {
      (0, node_opcua_assert_1.assert)(itemToMonitor.attributeId === node_opcua_data_model_1.AttributeIds.Value);
      if (node.nodeClass !== node_opcua_data_model_2.NodeClass.Variable) {
        return node_opcua_status_code_1.StatusCodes.BadNodeIdInvalid;
      }
      if (filter.deadbandType !== node_opcua_service_subscription_1.DeadbandType.None) {
        (0, node_opcua_assert_1.assert)(node.dataType instanceof node_opcua_nodeid_1.NodeId);
        if (!isNumberDataType(node)) {
          return node_opcua_status_code_1.StatusCodes.BadFilterNotAllowed;
        }
      }
      if (filter.deadbandType === node_opcua_service_subscription_1.DeadbandType.Percent) {
        if (filter.deadbandValue < 0 || filter.deadbandValue > 100) {
          return node_opcua_status_code_1.StatusCodes.BadDeadbandFilterInvalid;
        }
        if (!node.getChildByName("EURange", 0)) {
          warningLog(" node has no euRange ! Dead band Percent cannot be used on node " + node.nodeId.toString());
          return node_opcua_status_code_1.StatusCodes.BadMonitoredItemFilterUnsupported;
        }
      }
      return node_opcua_status_code_1.StatusCodes.Good;
    }
    function validateFilter(filter, itemToMonitor, node) {
      if (filter && filter instanceof node_opcua_service_filter_1.EventFilter && itemToMonitor.attributeId !== node_opcua_data_model_1.AttributeIds.EventNotifier) {
        return node_opcua_status_code_1.StatusCodes.BadFilterNotAllowed;
      }
      if (filter && filter instanceof node_opcua_service_filter_1.DataChangeFilter && itemToMonitor.attributeId !== node_opcua_data_model_1.AttributeIds.Value) {
        return node_opcua_status_code_1.StatusCodes.BadFilterNotAllowed;
      }
      if (filter && itemToMonitor.attributeId !== node_opcua_data_model_1.AttributeIds.EventNotifier && itemToMonitor.attributeId !== node_opcua_data_model_1.AttributeIds.Value) {
        return node_opcua_status_code_1.StatusCodes.BadFilterNotAllowed;
      }
      if (filter instanceof node_opcua_service_filter_1.DataChangeFilter) {
        return __validateDataChangeFilter(filter, itemToMonitor, node);
      }
      return node_opcua_status_code_1.StatusCodes.Good;
    }
    exports2.validateFilter = validateFilter;
  }
});

// node_modules/node-opcua-server/dist/filter/check_where_clause_on_address_space.js
var require_check_where_clause_on_address_space = __commonJS({
  "node_modules/node-opcua-server/dist/filter/check_where_clause_on_address_space.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.checkWhereClauseOnAdressSpace = void 0;
    var node_opcua_service_filter_1 = require_dist61();
    var node_opcua_service_filter_2 = require_dist61();
    function checkWhereClauseOnAdressSpace(addressSpace, sessionContext, whereClause, eventData) {
      const filterContext = new node_opcua_service_filter_2.FilterContextOnAddressSpace(sessionContext, eventData);
      return (0, node_opcua_service_filter_1.checkFilter)(filterContext, whereClause);
    }
    exports2.checkWhereClauseOnAdressSpace = checkWhereClauseOnAdressSpace;
  }
});

// node_modules/node-opcua-server/dist/monitored_item.js
var require_monitored_item = __commonJS({
  "node_modules/node-opcua-server/dist/monitored_item.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.MonitoredItem = void 0;
    var events_1 = require("events");
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_address_space_1 = require_index_current();
    var node_opcua_service_filter_1 = require_dist61();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_data_model_2 = require_dist27();
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_numeric_range_1 = require_dist31();
    var node_opcua_object_registry_1 = require_dist46();
    var node_opcua_service_filter_2 = require_dist61();
    var node_opcua_service_read_1 = require_dist39();
    var node_opcua_service_subscription_1 = require_dist45();
    var node_opcua_service_subscription_2 = require_dist45();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_variant_1 = require_dist28();
    var node_sampler_1 = require_node_sampler();
    var validate_filter_1 = require_validate_filter();
    var check_where_clause_on_address_space_1 = require_check_where_clause_on_address_space();
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var defaultItemToMonitor = new node_opcua_service_read_1.ReadValueId({
      attributeId: node_opcua_data_model_2.AttributeIds.Value,
      indexRange: void 0
    });
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var doDebug2 = doDebug && false;
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    function _adjust_sampling_interval(samplingInterval, node_minimumSamplingInterval) {
      (0, node_opcua_assert_1.assert)(typeof node_minimumSamplingInterval === "number", "expecting a number");
      if (samplingInterval === 0) {
        return node_minimumSamplingInterval === 0 ? samplingInterval : Math.max(MonitoredItem.minimumSamplingInterval, node_minimumSamplingInterval);
      }
      (0, node_opcua_assert_1.assert)(samplingInterval >= 0, " this case should have been prevented outside");
      samplingInterval = samplingInterval || MonitoredItem.defaultSamplingInterval;
      samplingInterval = Math.max(samplingInterval, MonitoredItem.minimumSamplingInterval);
      samplingInterval = Math.min(samplingInterval, MonitoredItem.maximumSamplingInterval);
      samplingInterval = node_minimumSamplingInterval === 0 ? samplingInterval : Math.max(samplingInterval, node_minimumSamplingInterval);
      return samplingInterval;
    }
    var maxQueueSize = 5e3;
    function _adjust_queue_size(queueSize) {
      queueSize = Math.min(queueSize, maxQueueSize);
      queueSize = Math.max(1, queueSize);
      return queueSize;
    }
    function _validate_parameters(monitoringParameters) {
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(monitoringParameters, "clientHandle"));
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(monitoringParameters, "samplingInterval"));
      (0, node_opcua_assert_1.assert)(isFinite(monitoringParameters.clientHandle));
      (0, node_opcua_assert_1.assert)(isFinite(monitoringParameters.samplingInterval));
      (0, node_opcua_assert_1.assert)(typeof monitoringParameters.discardOldest === "boolean");
      (0, node_opcua_assert_1.assert)(isFinite(monitoringParameters.queueSize));
      (0, node_opcua_assert_1.assert)(monitoringParameters.queueSize >= 0);
    }
    function statusCodeHasChanged(newDataValue, oldDataValue) {
      (0, node_opcua_assert_1.assert)(newDataValue instanceof node_opcua_data_value_1.DataValue);
      (0, node_opcua_assert_1.assert)(oldDataValue instanceof node_opcua_data_value_1.DataValue);
      return newDataValue.statusCode.value !== oldDataValue.statusCode.value;
    }
    function valueHasChanged(newDataValue, oldDataValue, deadbandType, deadbandValue) {
      (0, node_opcua_assert_1.assert)(newDataValue instanceof node_opcua_data_value_1.DataValue);
      (0, node_opcua_assert_1.assert)(oldDataValue instanceof node_opcua_data_value_1.DataValue);
      switch (deadbandType) {
        case node_opcua_service_subscription_2.DeadbandType.None:
          (0, node_opcua_assert_1.assert)(newDataValue.value instanceof node_opcua_variant_1.Variant);
          (0, node_opcua_assert_1.assert)(newDataValue.value instanceof node_opcua_variant_1.Variant);
          return (0, node_opcua_service_subscription_2.isOutsideDeadbandNone)(oldDataValue.value, newDataValue.value);
        case node_opcua_service_subscription_2.DeadbandType.Absolute:
          return (0, node_opcua_service_subscription_2.isOutsideDeadbandAbsolute)(oldDataValue.value, newDataValue.value, deadbandValue);
        default: {
          (0, node_opcua_assert_1.assert)(deadbandType === node_opcua_service_subscription_2.DeadbandType.Percent);
          (0, node_opcua_assert_1.assert)(deadbandValue >= 0 && deadbandValue <= 100);
          (0, node_opcua_assert_1.assert)(this.node !== null, "expecting a valid address_space object here to get access the the EURange");
          const euRangeNode = this.node.getChildByName("EURange");
          if (euRangeNode && euRangeNode.nodeClass === node_opcua_data_model_1.NodeClass.Variable) {
            const rangeVariant = euRangeNode.readValue().value;
            return (0, node_opcua_service_subscription_2.isOutsideDeadbandPercent)(oldDataValue.value, newDataValue.value, deadbandValue, rangeVariant.value);
          } else {
            errorLog("EURange is not of type Variable");
          }
          return true;
        }
      }
    }
    function timestampHasChanged(t1, t2) {
      if (t1 || !t2 || t2 || !t1) {
        return true;
      }
      if (!t1 || !t2) {
        return false;
      }
      return t1.getTime() !== t2.getTime();
    }
    function apply_dataChange_filter(newDataValue, oldDataValue) {
      if (!this.filter || !(this.filter instanceof node_opcua_service_subscription_2.DataChangeFilter)) {
        throw new Error("Internal Error");
      }
      const trigger = this.filter.trigger;
      if (doDebug) {
        try {
          debugLog("filter pass ?", node_opcua_service_subscription_2.DataChangeTrigger[trigger], this.oldDataValue?.toString(), newDataValue.toString());
          if (trigger === node_opcua_service_subscription_2.DataChangeTrigger.Status || trigger === node_opcua_service_subscription_2.DataChangeTrigger.StatusValue || trigger === node_opcua_service_subscription_2.DataChangeTrigger.StatusValueTimestamp) {
            debugLog("statusCodeHasChanged ", statusCodeHasChanged(newDataValue, oldDataValue));
          }
          if (trigger === node_opcua_service_subscription_2.DataChangeTrigger.StatusValue || trigger === node_opcua_service_subscription_2.DataChangeTrigger.StatusValueTimestamp) {
            debugLog("valueHasChanged ", valueHasChanged.call(this, newDataValue, oldDataValue, this.filter.deadbandType, this.filter.deadbandValue));
          }
          if (trigger === node_opcua_service_subscription_2.DataChangeTrigger.StatusValueTimestamp) {
            debugLog("timestampHasChanged ", timestampHasChanged(newDataValue.sourceTimestamp, oldDataValue.sourceTimestamp));
          }
        } catch (err) {
          warningLog(err);
        }
      }
      switch (trigger) {
        case node_opcua_service_subscription_2.DataChangeTrigger.Status: {
          return statusCodeHasChanged(newDataValue, oldDataValue);
        }
        case node_opcua_service_subscription_2.DataChangeTrigger.StatusValue: {
          return statusCodeHasChanged(newDataValue, oldDataValue) || valueHasChanged.call(this, newDataValue, oldDataValue, this.filter.deadbandType, this.filter.deadbandValue);
        }
        default: {
          (0, node_opcua_assert_1.assert)(trigger === node_opcua_service_subscription_2.DataChangeTrigger.StatusValueTimestamp);
          return timestampHasChanged(newDataValue.sourceTimestamp, oldDataValue.sourceTimestamp) || statusCodeHasChanged(newDataValue, oldDataValue) || valueHasChanged.call(this, newDataValue, oldDataValue, this.filter.deadbandType, this.filter.deadbandValue);
        }
      }
    }
    var s = (a) => JSON.stringify(a, null, "  ");
    function safeGuardRegister(monitoredItem) {
      monitoredItem.oldDataValue._$monitoredItem = monitoredItem.node?.nodeId?.toString();
      monitoredItem._$safeGuard = s(monitoredItem.oldDataValue);
    }
    function safeGuardVerify(monitoredItem) {
      if (monitoredItem._$safeGuard) {
        const verif = s(monitoredItem.oldDataValue || "");
        if (verif !== monitoredItem._$safeGuard) {
          errorLog(verif, monitoredItem._$safeGuard);
          throw new Error("Internal error: DataValue has been altered !!!");
        }
      }
    }
    function apply_filter(newDataValue) {
      if (this.oldDataValue === badDataUnavailable) {
        return true;
      }
      doDebug && safeGuardVerify(this);
      if (this.filter instanceof node_opcua_service_subscription_2.DataChangeFilter) {
        return apply_dataChange_filter.call(this, newDataValue, this.oldDataValue);
      } else {
        if (newDataValue.statusCode.value !== this.oldDataValue.statusCode.value) {
          return true;
        }
        return !(0, node_opcua_variant_1.sameVariant)(newDataValue.value, this.oldDataValue.value);
      }
    }
    function setSemanticChangeBit(notification) {
      if (notification instanceof node_opcua_service_subscription_1.MonitoredItemNotification) {
        notification.value.statusCode = node_opcua_status_code_1.StatusCode.makeStatusCode(notification.value.statusCode || node_opcua_status_code_1.StatusCodes.Good, "SemanticChanged");
      } else if (notification instanceof node_opcua_data_value_1.DataValue) {
        notification.statusCode = node_opcua_status_code_1.StatusCode.makeStatusCode(notification.statusCode || node_opcua_status_code_1.StatusCodes.Good, "SemanticChanged");
      }
    }
    var useCommonTimer = true;
    var badDataUnavailable = new node_opcua_data_value_1.DataValue({ statusCode: node_opcua_status_code_1.StatusCodes.BadDataUnavailable });
    var MonitoredItem = class _MonitoredItem extends events_1.EventEmitter {
      get node() {
        return this._node;
      }
      set node(someNode) {
        throw new Error("Unexpected way to set node");
      }
      constructor(options) {
        super();
        this.samplingInterval = -1;
        this.discardOldest = true;
        this.queueSize = 0;
        this.samplingFunc = null;
        this._is_sampling = false;
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "monitoredItemId"));
        (0, node_opcua_assert_1.assert)(!options.monitoringMode, "use setMonitoring mode explicitly to activate the monitored item");
        options.itemToMonitor = options.itemToMonitor || defaultItemToMonitor;
        this._samplingId = void 0;
        this.clientHandle = 0;
        this.filter = null;
        this._set_parameters(options);
        this.monitoredItemId = options.monitoredItemId;
        this.queue = [];
        this.overflow = false;
        this.oldDataValue = badDataUnavailable;
        this.monitoringMode = node_opcua_service_subscription_1.MonitoringMode.Invalid;
        this.timestampsToReturn = (0, node_opcua_data_value_1.coerceTimestampsToReturn)(options.timestampsToReturn);
        this.itemToMonitor = options.itemToMonitor;
        this._node = null;
        this._semantic_version = 0;
        if (doDebug) {
          debugLog("Monitoring ", options.itemToMonitor.toString());
        }
        this._on_node_disposed_listener = null;
        _MonitoredItem.registry.register(this);
      }
      setNode(node) {
        (0, node_opcua_assert_1.assert)(!this.node || this.node === node, "node already set");
        this._node = node;
        this._semantic_version = node.semantic_version;
        this._on_node_disposed_listener = () => this._on_node_disposed(this._node);
        this._node.on("dispose", this._on_node_disposed_listener);
      }
      setMonitoringMode(monitoringMode) {
        (0, node_opcua_assert_1.assert)(monitoringMode !== node_opcua_service_subscription_1.MonitoringMode.Invalid);
        if (monitoringMode === this.monitoringMode) {
          return;
        }
        const old_monitoringMode = this.monitoringMode;
        this.monitoringMode = monitoringMode;
        if (this.monitoringMode === node_opcua_service_subscription_1.MonitoringMode.Disabled) {
          this._stop_sampling();
          this._empty_queue();
        } else {
          (0, node_opcua_assert_1.assert)(this.monitoringMode === node_opcua_service_subscription_1.MonitoringMode.Sampling || this.monitoringMode === node_opcua_service_subscription_1.MonitoringMode.Reporting);
          const recordInitialValue = old_monitoringMode === node_opcua_service_subscription_1.MonitoringMode.Invalid || old_monitoringMode === node_opcua_service_subscription_1.MonitoringMode.Disabled;
          const installEventHandler = old_monitoringMode === node_opcua_service_subscription_1.MonitoringMode.Invalid;
          this._start_sampling(recordInitialValue);
        }
      }
      /**
       * Terminate the  MonitoredItem.
       * @method terminate
       *
       * This will stop the internal sampling timer.
       */
      terminate() {
        this._stop_sampling();
      }
      dispose() {
        if (doDebug) {
          debugLog("DISPOSING MONITORED ITEM", this._node.nodeId.toString());
        }
        this._stop_sampling();
        _MonitoredItem.registry.unregister(this);
        if (this._on_node_disposed_listener) {
          this._node.removeListener("dispose", this._on_node_disposed_listener);
          this._on_node_disposed_listener = null;
        }
        this.oldDataValue = badDataUnavailable;
        this.queue = [];
        this.itemToMonitor = null;
        this.filter = null;
        this.monitoredItemId = 0;
        this._node = null;
        this._semantic_version = 0;
        this.$subscription = void 0;
        this.removeAllListeners();
        (0, node_opcua_assert_1.assert)(!this._samplingId);
        (0, node_opcua_assert_1.assert)(!this._value_changed_callback);
        (0, node_opcua_assert_1.assert)(!this._semantic_changed_callback);
        (0, node_opcua_assert_1.assert)(!this._attribute_changed_callback);
        (0, node_opcua_assert_1.assert)(!this._on_opcua_event_received_callback);
        this._on_opcua_event_received_callback = null;
        this._attribute_changed_callback = null;
        this._semantic_changed_callback = null;
        this._on_opcua_event_received_callback = null;
      }
      get isSampling() {
        return !!this._samplingId || typeof this._value_changed_callback === "function" || typeof this._attribute_changed_callback === "function";
      }
      toString() {
        let str = "";
        str += `monitored item nodeId : ${this.node?.nodeId.toString()} 
`;
        str += `    sampling interval : ${this.samplingInterval} 
`;
        str += `    monitoredItemId   : ${this.monitoredItemId} 
`;
        return str;
      }
      /**
       * @param dataValue       the whole dataValue
       * @param skipChangeTest  indicates whether recordValue should  not check that dataValue is really
       *                                  different from previous one, ( by checking timestamps but also variant value)
       * @private
       *
       * Notes:
       *  - recordValue can only be called within timer event
       *  - for performance reason, dataValue may be a shared value with the underlying node,
       *    therefore recordValue must clone the dataValue to make sure it retains a snapshot
       *    of the contain at the time recordValue was called.
       *
       * return true if the value has been recorded, false if not.
       *
       * Value will not be recorded :
       *   * if the range do not overlap
       *   * is !skipChangeTest and value is equal to previous value
       *
       */
      // eslint-disable-next-line complexity, max-statements
      recordValue(dataValue, skipChangeTest, indexRange) {
        if (!this.itemToMonitor) {
          doDebug && debugLog("recordValue => Rejected", this.node?.browseName.toString(), " because no itemToMonitor");
          return false;
        }
        if (dataValue === this.oldDataValue) {
          errorLog("recordValue expects different dataValue to be provided");
        }
        doDebug && (0, node_opcua_assert_1.assert)(!dataValue.value || dataValue.value.isValid(), "expecting a valid variant value");
        const hasSemanticChanged = this.node && this.node.semantic_version !== this._semantic_version;
        if (!hasSemanticChanged && indexRange && this.itemToMonitor.indexRange) {
          if (!node_opcua_numeric_range_1.NumericRange.overlap(indexRange, this.itemToMonitor.indexRange)) {
            doDebug && debugLog("recordValue => Rejected", this.node?.browseName.toString(), " because no range not overlap");
            return false;
          }
        }
        dataValue = (0, node_opcua_data_value_1.extractRange)(dataValue, this.itemToMonitor.indexRange);
        if (doDebug2) {
          debugLog("MonitoredItem#recordValue", this.node.nodeId.toString(), this.node.browseName.toString(), " has Changed = ", !(0, node_opcua_data_value_1.sameDataValue)(dataValue, this.oldDataValue), "skipChangeTest = ", skipChangeTest, "hasSemanticChanged = ", hasSemanticChanged);
        }
        if (hasSemanticChanged) {
          debugLog("_enqueue_value => because hasSemanticChanged");
          setSemanticChangeBit(dataValue);
          this._semantic_version = this.node.semantic_version;
          this._enqueue_value(dataValue);
          doDebug && debugLog("recordValue => OK ", this.node?.browseName.toString(), " because hasSemanticChanged");
          return true;
        }
        const useIndexRange = this.itemToMonitor.indexRange && !this.itemToMonitor.indexRange.isEmpty();
        if (!skipChangeTest) {
          const hasChanged = !(0, node_opcua_data_value_1.sameDataValue)(dataValue, this.oldDataValue);
          if (!hasChanged) {
            doDebug2 && debugLog("recordValue => Rejected ", this.node?.browseName.toString(), " because !skipChangeTest && sameDataValue");
            return false;
          }
        }
        if (!skipChangeTest && !apply_filter.call(this, dataValue)) {
          if (doDebug) {
            debugLog("recordValue => Rejected ", this.node?.browseName.toString(), " because apply_filter");
            debugLog("current Value =>", this.oldDataValue?.toString());
            debugLog("proposed Value =>", dataValue?.toString());
            debugLog("proposed Value =>", dataValue == this.oldDataValue, dataValue.value === this.oldDataValue?.value);
          }
          return false;
        }
        if (useIndexRange) {
          if (doDebug) {
            debugLog("Current : ", this.oldDataValue?.toString());
            debugLog("New : ", dataValue.toString());
            debugLog("indexRange=", indexRange);
          }
          if (this.oldDataValue !== badDataUnavailable && (0, node_opcua_variant_1.sameVariant)(dataValue.value, this.oldDataValue.value)) {
            doDebug && debugLog("recordValue => Rejected ", this.node?.browseName.toString(), " because useIndexRange && sameVariant");
            return false;
          }
        }
        this.triggerLinkedItems();
        this._enqueue_value(dataValue);
        doDebug && debugLog("recordValue => OK ", this.node?.browseName.toString());
        return true;
      }
      hasLinkItem(linkedMonitoredItemId) {
        if (!this._linkedItems) {
          return false;
        }
        return this._linkedItems.findIndex((x2) => x2 === linkedMonitoredItemId) > 0;
      }
      addLinkItem(linkedMonitoredItemId) {
        if (linkedMonitoredItemId === this.monitoredItemId) {
          return node_opcua_status_code_1.StatusCodes.BadMonitoredItemIdInvalid;
        }
        this._linkedItems = this._linkedItems || [];
        if (this.hasLinkItem(linkedMonitoredItemId)) {
          return node_opcua_status_code_1.StatusCodes.BadMonitoredItemIdInvalid;
        }
        this._linkedItems.push(linkedMonitoredItemId);
        return node_opcua_status_code_1.StatusCodes.Good;
      }
      removeLinkItem(linkedMonitoredItemId) {
        if (!this._linkedItems || linkedMonitoredItemId === this.monitoredItemId) {
          return node_opcua_status_code_1.StatusCodes.BadMonitoredItemIdInvalid;
        }
        const index = this._linkedItems.findIndex((x2) => x2 === linkedMonitoredItemId);
        if (index === -1) {
          return node_opcua_status_code_1.StatusCodes.BadMonitoredItemIdInvalid;
        }
        this._linkedItems.splice(index, 1);
        return node_opcua_status_code_1.StatusCodes.Good;
      }
      /**
       * @internals
       */
      triggerLinkedItems() {
        if (!this.$subscription || !this._linkedItems) {
          return;
        }
        for (const linkItem of this._linkedItems) {
          const linkedMonitoredItem = this.$subscription.getMonitoredItem(linkItem);
          if (!linkedMonitoredItem) {
            continue;
          }
          if (linkedMonitoredItem.monitoringMode === node_opcua_service_subscription_1.MonitoringMode.Disabled) {
            continue;
          }
          if (linkedMonitoredItem.monitoringMode === node_opcua_service_subscription_1.MonitoringMode.Reporting) {
            continue;
          }
          (0, node_opcua_assert_1.assert)(linkedMonitoredItem.monitoringMode === node_opcua_service_subscription_1.MonitoringMode.Sampling);
          if (doDebug) {
            debugLog("triggerLinkedItems => ", this.node?.nodeId.toString(), linkedMonitoredItem.node?.nodeId.toString());
          }
          linkedMonitoredItem.trigger();
        }
      }
      get hasMonitoredItemNotifications() {
        return this.queue.length > 0 || this._triggeredNotifications !== void 0 && this._triggeredNotifications.length > 0;
      }
      /**
       * @internals
       */
      trigger() {
        setImmediate(() => {
          this._triggeredNotifications = this._triggeredNotifications || [];
          const notifications = this.extractMonitoredItemNotifications(true);
          this._triggeredNotifications = [].concat(this._triggeredNotifications, notifications);
        });
      }
      extractMonitoredItemNotifications(bForce = false) {
        if (!bForce && this.monitoringMode === node_opcua_service_subscription_1.MonitoringMode.Sampling && this._triggeredNotifications) {
          const notifications1 = this._triggeredNotifications;
          this._triggeredNotifications = void 0;
          return notifications1;
        }
        if (!bForce && this.monitoringMode !== node_opcua_service_subscription_1.MonitoringMode.Reporting) {
          return [];
        }
        const notifications = this.queue;
        this._empty_queue();
        if (notifications.length > 0 && this.node && this._semantic_version < this.node.semantic_version) {
          const dataValue = notifications[notifications.length - 1];
          setSemanticChangeBit(dataValue);
          (0, node_opcua_assert_1.assert)(this.node.nodeClass === node_opcua_data_model_1.NodeClass.Variable);
          this._semantic_version = this.node.semantic_version;
        }
        return notifications;
      }
      modify(timestampsToReturn, monitoringParameters) {
        (0, node_opcua_assert_1.assert)(monitoringParameters instanceof node_opcua_service_subscription_1.MonitoringParameters);
        const old_samplingInterval = this.samplingInterval;
        this.timestampsToReturn = timestampsToReturn || this.timestampsToReturn;
        if (!monitoringParameters) {
          return new node_opcua_service_subscription_1.MonitoredItemModifyResult({
            revisedQueueSize: this.queueSize,
            revisedSamplingInterval: this.samplingInterval,
            filterResult: null,
            statusCode: node_opcua_status_code_1.StatusCodes.Good
          });
        }
        if (old_samplingInterval !== 0 && monitoringParameters.samplingInterval === 0) {
          monitoringParameters.samplingInterval = _MonitoredItem.minimumSamplingInterval;
        }
        this._set_parameters(monitoringParameters);
        this._adjust_queue_to_match_new_queue_size();
        this._adjustSampling(old_samplingInterval);
        if (monitoringParameters.filter) {
          const statusCodeFilter = (0, validate_filter_1.validateFilter)(monitoringParameters.filter, this.itemToMonitor, this.node);
          if (statusCodeFilter.isNot(node_opcua_status_code_1.StatusCodes.Good)) {
            return new node_opcua_service_subscription_1.MonitoredItemModifyResult({
              statusCode: statusCodeFilter
            });
          }
        }
        const filterResult = null;
        return new node_opcua_service_subscription_1.MonitoredItemModifyResult({
          filterResult,
          revisedQueueSize: this.queueSize,
          revisedSamplingInterval: this.samplingInterval,
          statusCode: node_opcua_status_code_1.StatusCodes.Good
        });
      }
      async resendInitialValue() {
        if (!this.node)
          return;
        const sessionContext = this.getSessionContext() || node_opcua_address_space_1.SessionContext.defaultContext;
        if (!sessionContext)
          return;
        if (this.queue.length > 0)
          return;
        const theValueToResend = this.oldDataValue !== badDataUnavailable ? this.oldDataValue : this.node.readAttribute(sessionContext, this.itemToMonitor.attributeId);
        this.oldDataValue = badDataUnavailable;
        this._enqueue_value(theValueToResend);
      }
      getSessionContext() {
        const session = this._getSession();
        if (!session) {
          return null;
        }
        const sessionContext = session.sessionContext;
        return sessionContext;
      }
      /**
       * @method _on_sampling_timer
       * @private
       */
      _on_sampling_timer() {
        if (this.monitoringMode === node_opcua_service_subscription_1.MonitoringMode.Disabled) {
          return;
        }
        const sessionContext = this.getSessionContext() || node_opcua_address_space_1.SessionContext.defaultContext;
        if (!sessionContext) {
          warningLog("MonitoredItem#_on_sampling_timer : ", this.node?.nodeId.toString(), "cannot find session");
          return;
        }
        if (doDebug2) {
          debugLog("MonitoredItem#_on_sampling_timer", this.node ? this.node.nodeId.toString() : "null", " isSampling?=", this._is_sampling);
        }
        if (this._samplingId) {
          (0, node_opcua_assert_1.assert)(this.monitoringMode === node_opcua_service_subscription_1.MonitoringMode.Sampling || this.monitoringMode === node_opcua_service_subscription_1.MonitoringMode.Reporting);
          if (this._is_sampling) {
            const statusCode = node_opcua_status_code_1.StatusCodes.GoodOverload;
            return;
          }
          (0, node_opcua_assert_1.assert)(!this._is_sampling, "sampling func shall not be re-entrant !! fix it");
          if (!this.samplingFunc) {
            throw new Error("internal error : missing samplingFunc");
          }
          this._is_sampling = true;
          this.samplingFunc.call(this, sessionContext, this.oldDataValue, (err, newDataValue) => {
            if (!this._samplingId) {
              return;
            }
            if (err) {
              errorLog(" SAMPLING ERROR =>", err);
            } else {
              this._on_value_changed(newDataValue);
            }
            this._is_sampling = false;
          });
        } else {
          debugLog("_on_sampling_timer call but MonitoredItem has been terminated !!! ");
        }
      }
      _stop_sampling() {
        if (!this.node) {
          throw new Error("Internal Error");
        }
        if (this._on_opcua_event_received_callback) {
          (0, node_opcua_assert_1.assert)(typeof this._on_opcua_event_received_callback === "function");
          this.node.removeListener("event", this._on_opcua_event_received_callback);
          this._on_opcua_event_received_callback = null;
        }
        if (this._attribute_changed_callback) {
          (0, node_opcua_assert_1.assert)(typeof this._attribute_changed_callback === "function");
          const event_name = (0, node_opcua_address_space_1.makeAttributeEventName)(this.itemToMonitor.attributeId);
          this.node.removeListener(event_name, this._attribute_changed_callback);
          this._attribute_changed_callback = null;
        }
        if (this._value_changed_callback) {
          (0, node_opcua_assert_1.assert)(typeof this._value_changed_callback === "function");
          (0, node_opcua_assert_1.assert)(!this._samplingId);
          this.node.removeListener("value_changed", this._value_changed_callback);
          this._value_changed_callback = null;
        }
        if (this._semantic_changed_callback) {
          (0, node_opcua_assert_1.assert)(typeof this._semantic_changed_callback === "function");
          (0, node_opcua_assert_1.assert)(!this._samplingId);
          this.node.removeListener("semantic_changed", this._semantic_changed_callback);
          this._semantic_changed_callback = null;
        }
        if (this._samplingId) {
          this._clear_timer();
        }
        (0, node_opcua_assert_1.assert)(!this._samplingId);
        (0, node_opcua_assert_1.assert)(!this._value_changed_callback);
        (0, node_opcua_assert_1.assert)(!this._semantic_changed_callback);
        (0, node_opcua_assert_1.assert)(!this._attribute_changed_callback);
        (0, node_opcua_assert_1.assert)(!this._on_opcua_event_received_callback);
      }
      _on_value_changed(dataValue, indexRange) {
        (0, node_opcua_assert_1.assert)(dataValue instanceof node_opcua_data_value_1.DataValue);
        this.recordValue(dataValue, false, indexRange);
      }
      _on_semantic_changed() {
        const dataValue = this.node.readValue();
        this._on_value_changed(dataValue);
      }
      _on_opcua_event(eventData) {
        if (!this.filter || !(this.filter instanceof node_opcua_service_filter_2.EventFilter)) {
          throw new Error("Internal Error : a EventFilter is requested");
        }
        const addressSpace = eventData.$eventDataSource?.addressSpace;
        if (!(0, check_where_clause_on_address_space_1.checkWhereClauseOnAdressSpace)(addressSpace, node_opcua_address_space_1.SessionContext.defaultContext, this.filter.whereClause, eventData)) {
          return;
        }
        const selectClauses = this.filter.selectClauses ? this.filter.selectClauses : [];
        const eventFields = (0, node_opcua_service_filter_1.extractEventFields)(node_opcua_address_space_1.SessionContext.defaultContext, selectClauses, eventData);
        if (doDebug) {
          debugLog(" RECEIVED INTERNAL EVENT THAT WE ARE MONITORING");
          debugLog(this.filter ? this.filter.toString() : "no filter");
          eventFields.forEach((e) => {
            debugLog(e.toString());
          });
        }
        this._enqueue_event(eventFields);
      }
      _getSession() {
        if (!this.$subscription) {
          return null;
        }
        if (!this.$subscription.$session) {
          return null;
        }
        return this.$subscription.$session;
      }
      _start_sampling(recordInitialValue) {
        if (!this.node) {
          return;
        }
        this.oldDataValue = badDataUnavailable;
        setImmediate(() => this.__start_sampling(recordInitialValue));
      }
      __acquireInitialValue(sessionContext, callback) {
        (0, node_opcua_assert_1.assert)(this.itemToMonitor.attributeId === node_opcua_data_model_2.AttributeIds.Value);
        (0, node_opcua_assert_1.assert)(this.node);
        if (this.node?.nodeClass !== node_opcua_data_model_1.NodeClass.Variable) {
          return callback(new Error("Invalid "));
        }
        const variable = this.node;
        if (this.oldDataValue == badDataUnavailable) {
          variable.readValueAsync(sessionContext, (err, dataValue) => {
            callback(err, dataValue);
          });
        } else {
          const o2 = this.oldDataValue;
          this.oldDataValue = badDataUnavailable;
          if (doDebug) {
            safeGuardRegister(this);
          }
          callback(null, o2);
        }
      }
      __start_sampling(recordInitialValue) {
        if (!this.node) {
          return;
        }
        const sessionContext = this.getSessionContext() || node_opcua_address_space_1.SessionContext.defaultContext;
        if (!sessionContext) {
          return;
        }
        this._stop_sampling();
        if (this.itemToMonitor.attributeId === node_opcua_data_model_2.AttributeIds.EventNotifier) {
          if (doDebug) {
            debugLog("xxxxxx monitoring EventNotifier on", this.node.nodeId.toString(), this.node.browseName.toString());
          }
          if (!this._on_opcua_event_received_callback) {
            this._on_opcua_event_received_callback = this._on_opcua_event.bind(this);
            this.node.on("event", this._on_opcua_event_received_callback);
          }
          return;
        }
        if (this.itemToMonitor.attributeId !== node_opcua_data_model_2.AttributeIds.Value) {
          this.samplingInterval = 0;
          if (!this._attribute_changed_callback) {
            this._attribute_changed_callback = this._on_value_changed.bind(this);
            const event_name = (0, node_opcua_address_space_1.makeAttributeEventName)(this.itemToMonitor.attributeId);
            this.node.on(event_name, this._attribute_changed_callback);
          }
          if (recordInitialValue) {
            const dataValue = this.node.readAttribute(sessionContext, this.itemToMonitor.attributeId);
            this.recordValue(dataValue, true);
          }
          return;
        }
        if (this.samplingInterval === 0) {
          if (!this._value_changed_callback) {
            (0, node_opcua_assert_1.assert)(!this._semantic_changed_callback);
            this._value_changed_callback = this._on_value_changed.bind(this);
            this._semantic_changed_callback = this._on_semantic_changed.bind(this);
            this.node.on("value_changed", this._value_changed_callback);
            this.node.on("semantic_changed", this._semantic_changed_callback);
          }
          if (recordInitialValue) {
            this.__acquireInitialValue(sessionContext, (err, dataValue) => {
              if (err) {
                warningLog(err.message);
              }
              if (!err && dataValue) {
                this.recordValue(dataValue.clone(), true);
              }
            });
          }
        } else {
          if (recordInitialValue) {
            this.__acquireInitialValue(sessionContext, (err, dataValue) => {
              if (err) {
                warningLog(err.message);
              }
              if (!err && dataValue) {
                this.recordValue(dataValue, true);
              }
              this._set_timer();
            });
          } else {
            this._set_timer();
          }
        }
      }
      _set_parameters(monitoredParameters) {
        _validate_parameters(monitoredParameters);
        if (monitoredParameters.clientHandle !== 0 && monitoredParameters.clientHandle !== 4294967295) {
          this.clientHandle = monitoredParameters.clientHandle;
        }
        if (this.node && this.node.nodeClass === node_opcua_data_model_1.NodeClass.Variable) {
          const variable = this.node;
          this.samplingInterval = _adjust_sampling_interval(monitoredParameters.samplingInterval, variable.minimumSamplingInterval || 0);
        } else {
          this.samplingInterval = _adjust_sampling_interval(monitoredParameters.samplingInterval, 0);
        }
        this.discardOldest = monitoredParameters.discardOldest;
        this.queueSize = _adjust_queue_size(monitoredParameters.queueSize);
        this.filter = monitoredParameters.filter || null;
      }
      _setOverflowBit(notification) {
        if (Object.prototype.hasOwnProperty.call(notification, "value")) {
          (0, node_opcua_assert_1.assert)(notification.value.statusCode.equals(node_opcua_status_code_1.StatusCodes.Good));
          notification.value.statusCode = node_opcua_status_code_1.StatusCode.makeStatusCode(notification.value.statusCode, "Overflow | InfoTypeDataValue");
          (0, node_opcua_assert_1.assert)((0, node_opcua_data_value_1.sameStatusCode)(notification.value.statusCode, node_opcua_status_code_1.StatusCodes.GoodWithOverflowBit));
          (0, node_opcua_assert_1.assert)(notification.value.statusCode.hasOverflowBit);
        }
        if (this.$subscription && this.$subscription.subscriptionDiagnostics) {
          this.$subscription.subscriptionDiagnostics.monitoringQueueOverflowCount++;
        }
      }
      _enqueue_notification(notification) {
        if (this.queueSize === 1) {
          if (!this.queue || this.queue.length !== 1) {
            this.queue = [];
          }
          this.queue[0] = notification;
          (0, node_opcua_assert_1.assert)(this.queue.length === 1);
        } else {
          if (this.discardOldest) {
            this.queue.push(notification);
            if (this.queue.length > this.queueSize) {
              this.overflow = true;
              this.queue.shift();
              this._setOverflowBit(this.queue[0]);
            }
          } else {
            if (this.queue.length < this.queueSize) {
              this.queue.push(notification);
            } else {
              this.overflow = true;
              this._setOverflowBit(notification);
              this.queue[this.queue.length - 1] = notification;
            }
          }
        }
        (0, node_opcua_assert_1.assert)(this.queue.length >= 1);
      }
      _makeDataChangeNotification(dataValue) {
        if (this.clientHandle === -1 || this.clientHandle === 4294967295) {
          debugLog("Invalid client handle");
        }
        const attributeId = this.itemToMonitor.attributeId;
        if (this.filter && this.filter instanceof node_opcua_service_subscription_2.DataChangeFilter) {
          if (this.filter.trigger === node_opcua_service_subscription_2.DataChangeTrigger.Status) {
          }
        }
        dataValue = (0, node_opcua_data_value_1.apply_timestamps)(dataValue, this.timestampsToReturn, attributeId);
        return new node_opcua_service_subscription_1.MonitoredItemNotification({
          clientHandle: this.clientHandle,
          value: dataValue
        });
      }
      /**
       * @method _enqueue_value
       * @param dataValue {DataValue} the dataValue to enqueue
       * @private
       */
      _enqueue_value(dataValue) {
        doDebug && debugLog("_enqueue_value = ", dataValue.toString());
        doDebug && (0, node_opcua_assert_1.assert)(!dataValue.statusCode.isGoodish() || dataValue.value instanceof node_opcua_variant_1.Variant);
        doDebug && (0, node_opcua_assert_1.assert)(dataValue !== this.oldDataValue, "dataValue cannot be the same object twice!");
        if (!(!this.oldDataValue.value || !dataValue.value || !(dataValue.value.value instanceof Object) || dataValue.value.value !== this.oldDataValue.value.value) && !(dataValue.value.value instanceof Date)) {
          throw new Error("dataValue.value.value cannot be the same object twice! " + this.node.browseName.toString() + " " + dataValue.toString() + "  " + chalk_1.default.cyan(this.oldDataValue.toString()));
        }
        if (doDebug) {
          debugLog("MonitoredItem#_enqueue_value", this.node.nodeId.toString());
          safeGuardVerify(this);
        }
        this.oldDataValue = dataValue.clone();
        if (doDebug) {
          safeGuardRegister(this);
        }
        const notification = this._makeDataChangeNotification(this.oldDataValue);
        this._enqueue_notification(notification);
      }
      _makeEventFieldList(eventFields) {
        return new node_opcua_types_1.EventFieldList({
          clientHandle: this.clientHandle,
          eventFields
        });
      }
      _enqueue_event(eventFields) {
        if (doDebug) {
          debugLog(" MonitoredItem#_enqueue_event");
        }
        const notification = this._makeEventFieldList(eventFields);
        this._enqueue_notification(notification);
      }
      _empty_queue() {
        this.queue = [];
        this.overflow = false;
      }
      _clear_timer() {
        if (this._samplingId) {
          if (useCommonTimer) {
            (0, node_sampler_1.removeFromTimer)(this);
          } else {
            clearInterval(this._samplingId);
          }
          this._samplingId = void 0;
        }
      }
      _set_timer() {
        if (!this.itemToMonitor) {
          return;
        }
        (0, node_opcua_assert_1.assert)(this.samplingInterval >= _MonitoredItem.minimumSamplingInterval);
        (0, node_opcua_assert_1.assert)(!this._samplingId);
        if (useCommonTimer) {
          this._samplingId = (0, node_sampler_1.appendToTimer)(this);
        } else {
          this._samplingId = setInterval(() => {
            this._on_sampling_timer();
          }, this.samplingInterval);
        }
      }
      _adjust_queue_to_match_new_queue_size() {
        if (this.queueSize < this.queue.length) {
          if (this.discardOldest) {
            this.queue.splice(0, this.queue.length - this.queueSize);
          } else {
            const lastElement = this.queue[this.queue.length - 1];
            this.queue.splice(this.queueSize);
            this.queue[this.queue.length - 1] = lastElement;
          }
        }
        if (this.queueSize <= 1) {
          this.overflow = false;
          if (this.queue.length === 1) {
            if (this.queue[0] instanceof node_opcua_service_subscription_1.MonitoredItemNotification) {
              const el = this.queue[0];
              if (el.value.statusCode.hasOverflowBit) {
                el.value.statusCode.unset("Overflow | InfoTypeDataValue");
              }
            }
          }
        }
        (0, node_opcua_assert_1.assert)(this.queue.length <= this.queueSize);
      }
      _adjustSampling(old_samplingInterval) {
        if (old_samplingInterval !== this.samplingInterval) {
          this._start_sampling(false);
        }
      }
      _on_node_disposed(node) {
        this._on_value_changed(new node_opcua_data_value_1.DataValue({
          sourceTimestamp: /* @__PURE__ */ new Date(),
          statusCode: node_opcua_status_code_1.StatusCodes.BadNodeIdInvalid
        }));
        this._stop_sampling();
        node.removeListener("dispose", this._on_node_disposed_listener);
        this._on_node_disposed_listener = null;
      }
    };
    exports2.MonitoredItem = MonitoredItem;
    MonitoredItem.registry = new node_opcua_object_registry_1.ObjectRegistry();
    MonitoredItem.minimumSamplingInterval = 50;
    MonitoredItem.defaultSamplingInterval = 1500;
    MonitoredItem.maximumSamplingInterval = 1e3 * 60 * 60;
  }
});

// node_modules/node-opcua-server/dist/i_server_side_publish_engine.js
var require_i_server_side_publish_engine = __commonJS({
  "node_modules/node-opcua-server/dist/i_server_side_publish_engine.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.TransferredSubscription = void 0;
    var node_opcua_types_1 = require_dist32();
    var node_opcua_assert_1 = __importDefault3(require_dist14());
    var TransferredSubscription = class {
      constructor(options) {
        this.id = options.id;
        this._sequence_number_generator = options.generator;
        this.publishEngine = options.publishEngine;
      }
      get hasPendingNotifications() {
        return !!this._pending_notification;
      }
      dispose() {
        this._pending_notification = void 0;
        this.publishEngine = null;
      }
      _publish_pending_notifications() {
        (0, node_opcua_assert_1.default)(this._pending_notification);
        const notificationMessage = this._pending_notification;
        this._pending_notification = void 0;
        const moreNotifications = false;
        const subscriptionId = this.id;
        const response = new node_opcua_types_1.PublishResponse({
          moreNotifications,
          notificationMessage: {
            notificationData: [notificationMessage],
            publishTime: /* @__PURE__ */ new Date(),
            sequenceNumber: 4294967295
          },
          subscriptionId
        });
        (0, node_opcua_assert_1.default)(response.notificationMessage.sequenceNumber === 4294967295);
        response.notificationMessage.sequenceNumber = this._get_next_sequence_number();
        const availableSequenceNumbers = [response.notificationMessage.sequenceNumber];
        (0, node_opcua_assert_1.default)(!response.notificationMessage || availableSequenceNumbers[availableSequenceNumbers.length - 1] === response.notificationMessage.sequenceNumber);
        response.availableSequenceNumbers = availableSequenceNumbers;
        this.publishEngine._send_response(this, response);
      }
      _get_next_sequence_number() {
        return this._sequence_number_generator ? this._sequence_number_generator.next() : 0;
      }
    };
    exports2.TransferredSubscription = TransferredSubscription;
  }
});

// node_modules/node-opcua-server/dist/server_subscription.js
var require_server_subscription = __commonJS({
  "node_modules/node-opcua-server/dist/server_subscription.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Subscription = exports2.SubscriptionState = void 0;
    var events_1 = require("events");
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_address_space_1 = require_index_current();
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_common_1 = require_dist34();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_object_registry_1 = require_dist46();
    var node_opcua_secure_channel_1 = require_source7();
    var node_opcua_service_filter_1 = require_dist61();
    var node_opcua_service_subscription_1 = require_dist45();
    var node_opcua_service_subscription_2 = require_dist45();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_types_1 = require_dist32();
    var queue_1 = require_queue();
    var monitored_item_1 = require_monitored_item();
    var validate_filter_1 = require_validate_filter();
    var i_server_side_publish_engine_1 = require_i_server_side_publish_engine();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var maxNotificationMessagesInQueue = 100;
    var SubscriptionState;
    (function(SubscriptionState2) {
      SubscriptionState2[SubscriptionState2["CLOSED"] = 1] = "CLOSED";
      SubscriptionState2[SubscriptionState2["CREATING"] = 2] = "CREATING";
      SubscriptionState2[SubscriptionState2["NORMAL"] = 3] = "NORMAL";
      SubscriptionState2[SubscriptionState2["LATE"] = 4] = "LATE";
      SubscriptionState2[SubscriptionState2["KEEPALIVE"] = 5] = "KEEPALIVE";
      SubscriptionState2[SubscriptionState2["TERMINATED"] = 6] = "TERMINATED";
    })(SubscriptionState || (exports2.SubscriptionState = SubscriptionState = {}));
    function _adjust_publishing_interval(publishingInterval) {
      publishingInterval = publishingInterval === void 0 || Number.isNaN(publishingInterval) ? Subscription.defaultPublishingInterval : publishingInterval;
      publishingInterval = Math.max(publishingInterval, Subscription.minimumPublishingInterval);
      publishingInterval = Math.min(publishingInterval, Subscription.maximumPublishingInterval);
      return publishingInterval;
    }
    var minimumMaxKeepAliveCount = 2;
    var maximumMaxKeepAliveCount = 12e3;
    function _adjust_maxKeepAliveCount(maxKeepAliveCount) {
      maxKeepAliveCount = maxKeepAliveCount || minimumMaxKeepAliveCount;
      maxKeepAliveCount = Math.max(maxKeepAliveCount, minimumMaxKeepAliveCount);
      maxKeepAliveCount = Math.min(maxKeepAliveCount, maximumMaxKeepAliveCount);
      return maxKeepAliveCount;
    }
    var MaxUint32 = 4294967295;
    function _adjust_lifeTimeCount(lifeTimeCount, maxKeepAliveCount, publishingInterval) {
      lifeTimeCount = lifeTimeCount || 1;
      const minTicks = Math.ceil(Subscription.minimumLifetimeDuration / publishingInterval);
      const maxTicks = Math.floor(Subscription.maximumLifetimeDuration / publishingInterval);
      lifeTimeCount = Math.max(minTicks, lifeTimeCount);
      lifeTimeCount = Math.min(maxTicks, lifeTimeCount);
      lifeTimeCount = Math.max(lifeTimeCount, Math.min(maxKeepAliveCount * 3, MaxUint32));
      return lifeTimeCount;
    }
    function _adjust_publishingEnable(publishingEnabled) {
      return publishingEnabled === null || publishingEnabled === void 0 ? true : !!publishingEnabled;
    }
    function _adjust_maxNotificationsPerPublish(maxNotificationsPerPublish) {
      (0, node_opcua_assert_1.assert)(Subscription.maxNotificationPerPublishHighLimit > 0, "Subscription.maxNotificationPerPublishHighLimit must be positive");
      maxNotificationsPerPublish = maxNotificationsPerPublish || 0;
      (0, node_opcua_assert_1.assert)(typeof maxNotificationsPerPublish === "number");
      maxNotificationsPerPublish = maxNotificationsPerPublish >= 0 ? maxNotificationsPerPublish : 0;
      if (maxNotificationsPerPublish === 0) {
        maxNotificationsPerPublish = Subscription.maxNotificationPerPublishHighLimit;
      } else {
        maxNotificationsPerPublish = Math.min(Subscription.maxNotificationPerPublishHighLimit, maxNotificationsPerPublish);
      }
      (0, node_opcua_assert_1.assert)(maxNotificationsPerPublish !== 0 && maxNotificationsPerPublish <= Subscription.maxNotificationPerPublishHighLimit);
      return maxNotificationsPerPublish;
    }
    function w(s, length) {
      return ("000" + s).padStart(length);
    }
    function t(d2) {
      return w(d2.getHours(), 2) + ":" + w(d2.getMinutes(), 2) + ":" + w(d2.getSeconds(), 2) + ":" + w(d2.getMilliseconds(), 3);
    }
    function _getSequenceNumbers(arr) {
      return arr.map((notificationMessage) => notificationMessage.sequenceNumber);
    }
    function analyzeEventFilterResult(node, eventFilter) {
      if (!(eventFilter instanceof node_opcua_service_filter_1.EventFilter)) {
        throw new Error("Internal Error");
      }
      const selectClauseResults = (0, node_opcua_service_filter_1.checkSelectClauses)(node, eventFilter.selectClauses || []);
      const whereClauseResult = new node_opcua_types_1.ContentFilterResult();
      return new node_opcua_types_1.EventFilterResult({
        selectClauseDiagnosticInfos: [],
        selectClauseResults,
        whereClauseResult
      });
    }
    function analyzeDataChangeFilterResult(node, dataChangeFilter) {
      (0, node_opcua_assert_1.assert)(dataChangeFilter instanceof node_opcua_service_subscription_2.DataChangeFilter);
      return null;
    }
    function analyzeAggregateFilterResult(node, aggregateFilter) {
      (0, node_opcua_assert_1.assert)(aggregateFilter instanceof node_opcua_service_subscription_1.AggregateFilter);
      return new node_opcua_types_1.AggregateFilterResult({});
    }
    function _process_filter(node, filter) {
      if (!filter) {
        return null;
      }
      if (filter instanceof node_opcua_service_filter_1.EventFilter) {
        return analyzeEventFilterResult(node, filter);
      } else if (filter instanceof node_opcua_service_subscription_2.DataChangeFilter) {
        return analyzeDataChangeFilterResult(node, filter);
      } else if (filter instanceof node_opcua_service_subscription_1.AggregateFilter) {
        return analyzeAggregateFilterResult(node, filter);
      }
      throw new Error("invalid filter");
    }
    function createSubscriptionDiagnostics(subscription) {
      (0, node_opcua_assert_1.assert)(subscription instanceof Subscription);
      const subscriptionDiagnostics = new node_opcua_common_1.SubscriptionDiagnosticsDataType({});
      const subscription_subscriptionDiagnostics = subscriptionDiagnostics;
      subscription_subscriptionDiagnostics.$subscription = subscription;
      subscription_subscriptionDiagnostics.__defineGetter__("sessionId", function() {
        if (!this.$subscription) {
          return node_opcua_nodeid_1.NodeId.nullNodeId;
        }
        return this.$subscription.getSessionId();
      });
      subscription_subscriptionDiagnostics.__defineGetter__("subscriptionId", function() {
        if (!this.$subscription) {
          return 0;
        }
        return this.$subscription.id;
      });
      subscription_subscriptionDiagnostics.__defineGetter__("priority", function() {
        if (!this.$subscription) {
          return 0;
        }
        return this.$subscription.priority;
      });
      subscription_subscriptionDiagnostics.__defineGetter__("publishingInterval", function() {
        if (!this.$subscription) {
          return 0;
        }
        return this.$subscription.publishingInterval;
      });
      subscription_subscriptionDiagnostics.__defineGetter__("maxLifetimeCount", function() {
        return this.$subscription.lifeTimeCount;
      });
      subscription_subscriptionDiagnostics.__defineGetter__("maxKeepAliveCount", function() {
        if (!this.$subscription) {
          return 0;
        }
        return this.$subscription.maxKeepAliveCount;
      });
      subscription_subscriptionDiagnostics.__defineGetter__("maxNotificationsPerPublish", function() {
        if (!this.$subscription) {
          return 0;
        }
        return this.$subscription.maxNotificationsPerPublish;
      });
      subscription_subscriptionDiagnostics.__defineGetter__("publishingEnabled", function() {
        if (!this.$subscription) {
          return false;
        }
        return this.$subscription.publishingEnabled;
      });
      subscription_subscriptionDiagnostics.__defineGetter__("monitoredItemCount", function() {
        if (!this.$subscription) {
          return 0;
        }
        return this.$subscription.monitoredItemCount;
      });
      subscription_subscriptionDiagnostics.__defineGetter__("nextSequenceNumber", function() {
        if (!this.$subscription) {
          return 0;
        }
        return this.$subscription.futureSequenceNumber;
      });
      subscription_subscriptionDiagnostics.__defineGetter__("disabledMonitoredItemCount", function() {
        if (!this.$subscription) {
          return 0;
        }
        return this.$subscription.disabledMonitoredItemCount;
      });
      subscription_subscriptionDiagnostics.__defineGetter__("currentKeepAliveCount", function() {
        if (!this.$subscription) {
          return 0;
        }
        return this.$subscription.currentKeepAliveCount;
      });
      subscription_subscriptionDiagnostics.__defineGetter__("currentLifetimeCount", function() {
        if (!this.$subscription) {
          return 0;
        }
        return this.$subscription.currentLifetimeCount;
      });
      return subscriptionDiagnostics;
    }
    var g_monitoredItemId = Math.ceil(Math.random() * 1e5);
    function getNextMonitoredItemId() {
      return g_monitoredItemId++;
    }
    var INVALID_ID = -1;
    var Subscription = class _Subscription extends events_1.EventEmitter {
      /**
       * @deprecated use serverCapacity.maxMonitoredItems and serverCapacity.maxMonitoredItemsPerSubscription instead
       */
      static get maxMonitoredItemCount() {
        return _Subscription.defaultMaxMonitoredItemCount;
      }
      set state(value) {
        if (this._state !== value) {
          this._state = value;
          this.emit("stateChanged", value);
        }
      }
      get state() {
        return this._state;
      }
      get sessionId() {
        return this.$session ? this.$session.nodeId : node_opcua_nodeid_1.NodeId.nullNodeId;
      }
      get currentLifetimeCount() {
        return this._life_time_counter;
      }
      get currentKeepAliveCount() {
        return this._keep_alive_counter;
      }
      constructor(options) {
        super();
        this._state = -1;
        this._keep_alive_counter = 0;
        this._hasUncollectedMonitoredItemNotifications = false;
        options = options || {};
        _Subscription.registry.register(this);
        (0, node_opcua_assert_1.assert)(this.sessionId instanceof node_opcua_nodeid_1.NodeId, "expecting a sessionId NodeId");
        this.publishEngine = options.publishEngine;
        this.id = options.id || INVALID_ID;
        this.priority = options.priority || 0;
        this.publishingInterval = _adjust_publishing_interval(options.publishingInterval);
        this.maxKeepAliveCount = _adjust_maxKeepAliveCount(options.maxKeepAliveCount);
        this.resetKeepAliveCounter();
        this.lifeTimeCount = _adjust_lifeTimeCount(options.lifeTimeCount || 0, this.maxKeepAliveCount, this.publishingInterval);
        this.maxNotificationsPerPublish = _adjust_maxNotificationsPerPublish(options.maxNotificationsPerPublish);
        this._life_time_counter = 0;
        this.resetLifeTimeCounter();
        this._pending_notifications = new queue_1.Queue();
        this._sent_notification_messages = [];
        this._sequence_number_generator = new node_opcua_secure_channel_1.SequenceNumberGenerator();
        this.state = SubscriptionState.CREATING;
        this.publishIntervalCount = 0;
        this.monitoredItems = {};
        this.monitoredItemIdCounter = 0;
        this.publishingEnabled = _adjust_publishingEnable(options.publishingEnabled);
        this.subscriptionDiagnostics = createSubscriptionDiagnostics(this);
        this.messageSent = false;
        this.timerId = null;
        this._start_timer({ firstTime: true });
        debugLog(chalk_1.default.green(`creating subscription ${this.id}`));
        this.serverCapabilities = options.serverCapabilities;
        this.serverCapabilities.maxMonitoredItems = this.serverCapabilities.maxMonitoredItems || _Subscription.defaultMaxMonitoredItemCount;
        this.serverCapabilities.maxMonitoredItemsPerSubscription = this.serverCapabilities.maxMonitoredItemsPerSubscription || _Subscription.defaultMaxMonitoredItemCount;
        this.globalCounter = options.globalCounter;
      }
      getSessionId() {
        return this.sessionId;
      }
      toString() {
        let str = "Subscription:\n";
        str += "  subscriptionId          " + this.id + "\n";
        str += "  sessionId          " + this.getSessionId()?.toString() + "\n";
        str += "  publishingEnabled  " + this.publishingEnabled + "\n";
        str += "  maxKeepAliveCount  " + this.maxKeepAliveCount + "\n";
        str += "  publishingInterval " + this.publishingInterval + "\n";
        str += "  lifeTimeCount      " + this.lifeTimeCount + "\n";
        str += "  maxKeepAliveCount  " + this.maxKeepAliveCount + "\n";
        return str;
      }
      /**
       * modify subscription parameters
       * @param param
       */
      modify(param) {
        this.subscriptionDiagnostics.modifyCount += 1;
        const publishingInterval_old = this.publishingInterval;
        param.requestedPublishingInterval = param.requestedPublishingInterval || 0;
        param.requestedMaxKeepAliveCount = param.requestedMaxKeepAliveCount || this.maxKeepAliveCount;
        param.requestedLifetimeCount = param.requestedLifetimeCount || this.lifeTimeCount;
        this.publishingInterval = _adjust_publishing_interval(param.requestedPublishingInterval);
        this.maxKeepAliveCount = _adjust_maxKeepAliveCount(param.requestedMaxKeepAliveCount);
        this.lifeTimeCount = _adjust_lifeTimeCount(param.requestedLifetimeCount, this.maxKeepAliveCount, this.publishingInterval);
        this.maxNotificationsPerPublish = _adjust_maxNotificationsPerPublish(param.maxNotificationsPerPublish || 0);
        this.priority = param.priority || 0;
        this.resetLifeTimeAndKeepAliveCounters();
        if (publishingInterval_old !== this.publishingInterval) {
        }
        this._stop_timer();
        this._start_timer({ firstTime: false });
      }
      /**
       * set publishing mode
       * @param publishingEnabled
       */
      setPublishingMode(publishingEnabled) {
        this.publishingEnabled = !!publishingEnabled;
        if (this.publishingEnabled) {
          this.subscriptionDiagnostics.enableCount += 1;
        } else {
          this.subscriptionDiagnostics.disableCount += 1;
        }
        this.resetLifeTimeCounter();
        if (!publishingEnabled && this.state !== SubscriptionState.CLOSED) {
          this.state = SubscriptionState.NORMAL;
        }
        return node_opcua_status_code_1.StatusCodes.Good;
      }
      /**
       * @private
       */
      get keepAliveCounterHasExpired() {
        return this._keep_alive_counter >= this.maxKeepAliveCount || this.state === SubscriptionState.LATE;
      }
      /**
       * Reset the Lifetime Counter Variable to the value specified for the lifetime of a Subscription in
       * the CreateSubscription Service( 5.13.2).
       * @private
       */
      resetLifeTimeCounter() {
        this._life_time_counter = 0;
      }
      /**
       * @private
       */
      increaseLifeTimeCounter() {
        this._life_time_counter += 1;
        if (this._life_time_counter >= this.lifeTimeCount) {
          this.emit("lifeTimeExpired");
        }
        this.emit("lifeTimeCounterChanged", this._life_time_counter);
      }
      /**
       *  True if the subscription life time has expired.
       *
       */
      get lifeTimeHasExpired() {
        (0, node_opcua_assert_1.assert)(this.lifeTimeCount > 0);
        return this._life_time_counter >= this.lifeTimeCount;
      }
      /**
       * number of milliseconds before this subscription times out (lifeTimeHasExpired === true);
       */
      get timeToExpiration() {
        return (this.lifeTimeCount - this._life_time_counter) * this.publishingInterval;
      }
      get timeToKeepAlive() {
        return (this.maxKeepAliveCount - this._keep_alive_counter) * this.publishingInterval;
      }
      /**
       * Terminates the subscription.
       * Calling this method will also remove any monitored items.
       *
       */
      terminate() {
        (0, node_opcua_assert_1.assert)(arguments.length === 0);
        debugLog("Subscription#terminate status", SubscriptionState[this.state]);
        if (this.state === SubscriptionState.CLOSED) {
          return;
        }
        this._stop_timer();
        debugLog("terminating Subscription  ", this.id, " with ", this.monitoredItemCount, " monitored items");
        const keys = Object.keys(this.monitoredItems);
        for (const key of keys) {
          const status2 = this.removeMonitoredItem(parseInt(key, 10));
          (0, node_opcua_assert_1.assert)(status2 === node_opcua_status_code_1.StatusCodes.Good);
        }
        (0, node_opcua_assert_1.assert)(this.monitoredItemCount === 0);
        if (this.$session && this.$session._unexposeSubscriptionDiagnostics) {
          this.$session._unexposeSubscriptionDiagnostics(this);
        }
        this.state = SubscriptionState.CLOSED;
        this.emit("terminated");
        if (this.publishEngine) {
          this.publishEngine.on_close_subscription(this);
        }
      }
      setTriggering(triggeringItemId, linksToAdd, linksToRemove) {
        linksToAdd = linksToAdd || [];
        linksToRemove = linksToRemove || [];
        if (linksToAdd.length === 0 && linksToRemove.length === 0) {
          return { statusCode: node_opcua_status_code_1.StatusCodes.BadNothingToDo, addResults: [], removeResults: [] };
        }
        const triggeringItem = this.getMonitoredItem(triggeringItemId);
        const monitoredItemsToAdd = linksToAdd.map((id) => this.getMonitoredItem(id));
        const monitoredItemsToRemove = linksToRemove.map((id) => this.getMonitoredItem(id));
        if (!triggeringItem) {
          const removeResults1 = monitoredItemsToRemove.map((m2) => m2 ? node_opcua_status_code_1.StatusCodes.Good : node_opcua_status_code_1.StatusCodes.BadMonitoredItemIdInvalid);
          const addResults1 = monitoredItemsToAdd.map((m2) => m2 ? node_opcua_status_code_1.StatusCodes.Good : node_opcua_status_code_1.StatusCodes.BadMonitoredItemIdInvalid);
          return {
            statusCode: node_opcua_status_code_1.StatusCodes.BadMonitoredItemIdInvalid,
            addResults: addResults1,
            removeResults: removeResults1
          };
        }
        const removeResults = monitoredItemsToRemove.map((m2) => !m2 ? node_opcua_status_code_1.StatusCodes.BadMonitoredItemIdInvalid : triggeringItem.removeLinkItem(m2.monitoredItemId));
        const addResults = monitoredItemsToAdd.map((m2) => !m2 ? node_opcua_status_code_1.StatusCodes.BadMonitoredItemIdInvalid : triggeringItem.addLinkItem(m2.monitoredItemId));
        const statusCode = node_opcua_status_code_1.StatusCodes.Good;
        return {
          statusCode,
          addResults,
          removeResults
        };
      }
      dispose() {
        if (doDebug) {
          debugLog("Subscription#dispose", this.id, this.monitoredItemCount);
        }
        (0, node_opcua_assert_1.assert)(this.monitoredItemCount === 0, "MonitoredItems haven't been  deleted first !!!");
        (0, node_opcua_assert_1.assert)(this.timerId === null, "Subscription timer haven't been terminated");
        if (this.subscriptionDiagnostics) {
          this.subscriptionDiagnostics.$subscription = null;
        }
        this.publishEngine = void 0;
        this._pending_notifications.clear();
        this._sent_notification_messages = [];
        this.$session = void 0;
        this.removeAllListeners();
        _Subscription.registry.unregister(this);
      }
      get aborted() {
        const session = this.$session;
        if (!session) {
          return true;
        }
        return session.aborted;
      }
      /**
       * number of pending notifications
       */
      get pendingNotificationsCount() {
        return this._pending_notifications ? this._pending_notifications.size : 0;
      }
      /**
       * is 'true' if there are pending notifications for this subscription. (i.e moreNotifications)
       */
      get hasPendingNotifications() {
        return this.pendingNotificationsCount > 0;
      }
      /**
       * number of sent notifications
       */
      get sentNotificationMessageCount() {
        return this._sent_notification_messages.length;
      }
      /**
       * @internal
       */
      _flushSentNotifications() {
        const tmp = this._sent_notification_messages;
        this._sent_notification_messages = [];
        return tmp;
      }
      /**
       * number of monitored items handled by this subscription
       */
      get monitoredItemCount() {
        return Object.keys(this.monitoredItems).length;
      }
      /**
       * number of disabled monitored items.
       */
      get disabledMonitoredItemCount() {
        return Object.values(this.monitoredItems).reduce((sum, monitoredItem) => {
          return sum + (monitoredItem.monitoringMode === node_opcua_service_subscription_2.MonitoringMode.Disabled ? 1 : 0);
        }, 0);
      }
      /**
       * The number of unacknowledged messages saved in the republish queue.
       */
      get unacknowledgedMessageCount() {
        return this.subscriptionDiagnostics.unacknowledgedMessageCount;
      }
      /**
       * adjust monitored item sampling interval
       *  - an samplingInterval ===0 means that we use a event-base model ( no sampling)
       *  - otherwise the sampling is adjusted
       * @private
       */
      adjustSamplingInterval(samplingInterval, node) {
        if (samplingInterval < 0) {
          samplingInterval = this.publishingInterval;
        } else if (samplingInterval === 0) {
          if (!node)
            throw new Error("Internal Error");
          const dataValueSamplingInterval = node.readAttribute(node_opcua_address_space_1.SessionContext.defaultContext, node_opcua_data_model_1.AttributeIds.MinimumSamplingInterval);
          if (dataValueSamplingInterval.statusCode.isGood()) {
            samplingInterval = dataValueSamplingInterval.value.value;
            (0, node_opcua_assert_1.assert)(samplingInterval >= 0 && samplingInterval <= monitored_item_1.MonitoredItem.maximumSamplingInterval);
          }
        } else if (samplingInterval < monitored_item_1.MonitoredItem.minimumSamplingInterval) {
          samplingInterval = monitored_item_1.MonitoredItem.minimumSamplingInterval;
        } else if (samplingInterval > monitored_item_1.MonitoredItem.maximumSamplingInterval) {
          samplingInterval = monitored_item_1.MonitoredItem.maximumSamplingInterval;
        }
        const node_minimumSamplingInterval = node && node.minimumSamplingInterval ? node.minimumSamplingInterval : 0;
        samplingInterval = Math.max(samplingInterval, node_minimumSamplingInterval);
        return samplingInterval;
      }
      /**
       * create a monitored item
       * @param addressSpace - address space
       * @param timestampsToReturn  - the timestamp to return
       * @param monitoredItemCreateRequest - the parameters describing the monitored Item to create
       */
      preCreateMonitoredItem(addressSpace, timestampsToReturn, monitoredItemCreateRequest) {
        (0, node_opcua_assert_1.assert)(monitoredItemCreateRequest instanceof node_opcua_service_subscription_2.MonitoredItemCreateRequest);
        function handle_error(statusCode) {
          return {
            createResult: new node_opcua_service_subscription_2.MonitoredItemCreateResult({ statusCode }),
            monitoredItemCreateRequest
          };
        }
        const itemToMonitor = monitoredItemCreateRequest.itemToMonitor;
        const node = addressSpace.findNode(itemToMonitor.nodeId);
        if (!node) {
          return handle_error(node_opcua_status_code_1.StatusCodes.BadNodeIdUnknown);
        }
        if (itemToMonitor.attributeId === node_opcua_data_model_1.AttributeIds.Value && !(node.nodeClass === node_opcua_data_model_1.NodeClass.Variable)) {
          return handle_error(node_opcua_status_code_1.StatusCodes.BadAttributeIdInvalid);
        }
        if (itemToMonitor.attributeId === node_opcua_data_model_1.AttributeIds.INVALID) {
          return handle_error(node_opcua_status_code_1.StatusCodes.BadAttributeIdInvalid);
        }
        if (!itemToMonitor.indexRange.isValid()) {
          return handle_error(node_opcua_status_code_1.StatusCodes.BadIndexRangeInvalid);
        }
        if (itemToMonitor.dataEncoding.name && itemToMonitor.attributeId !== node_opcua_data_model_1.AttributeIds.Value) {
          return handle_error(node_opcua_status_code_1.StatusCodes.BadDataEncodingInvalid);
        }
        if (!(0, node_opcua_data_model_1.isValidDataEncoding)(itemToMonitor.dataEncoding)) {
          return handle_error(node_opcua_status_code_1.StatusCodes.BadDataEncodingUnsupported);
        }
        const requestedParameters = monitoredItemCreateRequest.requestedParameters;
        const filter = requestedParameters.filter;
        const statusCodeFilter = (0, validate_filter_1.validateFilter)(filter, itemToMonitor, node);
        if (statusCodeFilter !== node_opcua_status_code_1.StatusCodes.Good) {
          return handle_error(statusCodeFilter);
        }
        if (this.monitoredItemCount >= this.serverCapabilities.maxMonitoredItemsPerSubscription) {
          return handle_error(node_opcua_status_code_1.StatusCodes.BadTooManyMonitoredItems);
        }
        if (this.globalCounter.totalMonitoredItemCount >= this.serverCapabilities.maxMonitoredItems) {
          return handle_error(node_opcua_status_code_1.StatusCodes.BadTooManyMonitoredItems);
        }
        const createResult = this._createMonitoredItemStep2(timestampsToReturn, monitoredItemCreateRequest, node);
        (0, node_opcua_assert_1.assert)(createResult.statusCode.isGood());
        const monitoredItem = this.getMonitoredItem(createResult.monitoredItemId);
        if (!monitoredItem) {
          throw new Error("internal error");
        }
        monitoredItem.setNode(node);
        this.emit("monitoredItem", monitoredItem, itemToMonitor);
        return { monitoredItem, monitoredItemCreateRequest, createResult };
      }
      async applyOnMonitoredItem(functor) {
        for (const m2 of Object.values(this.monitoredItems)) {
          await functor(m2);
        }
      }
      postCreateMonitoredItem(monitoredItem, monitoredItemCreateRequest, createResult) {
        this._createMonitoredItemStep3(monitoredItem, monitoredItemCreateRequest);
      }
      async createMonitoredItem(addressSpace, timestampsToReturn, monitoredItemCreateRequest) {
        const { monitoredItem, createResult } = this.preCreateMonitoredItem(addressSpace, timestampsToReturn, monitoredItemCreateRequest);
        this.postCreateMonitoredItem(monitoredItem, monitoredItemCreateRequest, createResult);
        return createResult;
      }
      /**
       * get a monitoredItem by Id.
       * @param monitoredItemId : the id of the monitored item to get.
       * @return the monitored item matching monitoredItemId
       */
      getMonitoredItem(monitoredItemId) {
        return this.monitoredItems[monitoredItemId] || null;
      }
      /**
       * remove a monitored Item from the subscription.
       * @param monitoredItemId : the id of the monitored item to get.
       */
      removeMonitoredItem(monitoredItemId) {
        debugLog("Removing monitoredIem ", monitoredItemId);
        if (!Object.prototype.hasOwnProperty.call(this.monitoredItems, monitoredItemId.toString())) {
          return node_opcua_status_code_1.StatusCodes.BadMonitoredItemIdInvalid;
        }
        const monitoredItem = this.monitoredItems[monitoredItemId];
        monitoredItem.terminate();
        monitoredItem.dispose();
        this.emit("removeMonitoredItem", monitoredItem);
        delete this.monitoredItems[monitoredItemId];
        this.globalCounter.totalMonitoredItemCount -= 1;
        this._removePendingNotificationsFor(monitoredItemId);
        return node_opcua_status_code_1.StatusCodes.Good;
      }
      /**
       * rue if monitored Item have uncollected Notifications
       */
      get hasUncollectedMonitoredItemNotifications() {
        if (this._hasUncollectedMonitoredItemNotifications) {
          return true;
        }
        const keys = Object.keys(this.monitoredItems);
        const n = keys.length;
        for (let i = 0; i < n; i++) {
          const key = parseInt(keys[i], 10);
          const monitoredItem = this.monitoredItems[key];
          if (monitoredItem.hasMonitoredItemNotifications) {
            this._hasUncollectedMonitoredItemNotifications = true;
            return true;
          }
        }
        return false;
      }
      get subscriptionId() {
        return this.id;
      }
      getMessageForSequenceNumber(sequenceNumber) {
        const notification_message = this._sent_notification_messages.find((e) => e.sequenceNumber === sequenceNumber);
        return notification_message || null;
      }
      /**
       * returns true if the notification has expired
       * @param notification
       */
      notificationHasExpired(notification) {
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(notification, "start_tick"));
        (0, node_opcua_assert_1.assert)(isFinite(notification.start_tick + this.maxKeepAliveCount));
        return notification.start_tick + this.maxKeepAliveCount < this.publishIntervalCount;
      }
      /**
       *  returns in an array the sequence numbers of the notifications that have been sent
       *  and that haven't been acknowledged yet.
       */
      getAvailableSequenceNumbers() {
        const availableSequenceNumbers = _getSequenceNumbers(this._sent_notification_messages);
        return availableSequenceNumbers;
      }
      /**
       * acknowledges a notification identified by its sequence number
       */
      acknowledgeNotification(sequenceNumber) {
        debugLog("acknowledgeNotification ", sequenceNumber);
        let foundIndex = -1;
        this._sent_notification_messages.forEach((e, index) => {
          if (e.sequenceNumber === sequenceNumber) {
            foundIndex = index;
          }
        });
        if (foundIndex === -1) {
          if (doDebug) {
            debugLog(chalk_1.default.red("acknowledging sequence FAILED !!! "), chalk_1.default.cyan(sequenceNumber.toString()));
          }
          return node_opcua_status_code_1.StatusCodes.BadSequenceNumberUnknown;
        } else {
          if (doDebug) {
            debugLog(chalk_1.default.yellow("acknowledging sequence "), chalk_1.default.cyan(sequenceNumber.toString()));
          }
          this._sent_notification_messages.splice(foundIndex, 1);
          this.subscriptionDiagnostics.unacknowledgedMessageCount--;
          return node_opcua_status_code_1.StatusCodes.Good;
        }
      }
      /**
       * getMonitoredItems is used to get information about monitored items of a subscription.Its intended
       * use is defined in Part 4. This method is the implementation of the Standard OPCUA GetMonitoredItems Method.
       * from spec:
       * This method can be used to get the  list of monitored items in a subscription if CreateMonitoredItems
       * failed due to a network interruption and the client does not know if the creation succeeded in the server.
       *
       */
      getMonitoredItems() {
        const monitoredItems = Object.keys(this.monitoredItems);
        const monitoredItemCount = monitoredItems.length;
        const result2 = {
          clientHandles: new Uint32Array(monitoredItemCount),
          serverHandles: new Uint32Array(monitoredItemCount),
          statusCode: node_opcua_status_code_1.StatusCodes.Good
        };
        for (let index = 0; index < monitoredItemCount; index++) {
          const monitoredItemId = monitoredItems[index];
          const serverHandle = parseInt(monitoredItemId, 10);
          const monitoredItem = this.getMonitoredItem(serverHandle);
          result2.clientHandles[index] = monitoredItem.clientHandle;
          result2.serverHandles[index] = serverHandle;
        }
        return result2;
      }
      /**
       * @private
       */
      async resendInitialValues() {
        this._keep_alive_counter = 0;
        try {
          const promises = [];
          for (const monitoredItem of Object.values(this.monitoredItems)) {
            promises.push((async () => {
              try {
                monitoredItem.resendInitialValue();
              } catch (err) {
                warningLog("resendInitialValues:", monitoredItem.node?.nodeId.toString(), "error:", err.message);
              }
            })());
          }
          await Promise.all(promises);
        } catch (err) {
          warningLog("resendInitialValues: error:", err.message);
        }
        this._keep_alive_counter = this.maxKeepAliveCount - 1;
        this.state = SubscriptionState.NORMAL;
        this._harvestMonitoredItems();
      }
      /**
       * @private
       */
      notifyTransfer() {
        debugLog(chalk_1.default.red(" Subscription => Notifying Transfer                                  "));
        const notificationData = new node_opcua_service_subscription_2.StatusChangeNotification({
          status: node_opcua_status_code_1.StatusCodes.GoodSubscriptionTransferred
        });
        if (this.publishEngine.pendingPublishRequestCount) {
          this._addNotificationMessage(notificationData);
          debugLog(chalk_1.default.red("pendingPublishRequestCount"), this.publishEngine?.pendingPublishRequestCount);
          this._publish_pending_notifications();
        } else {
          debugLog(chalk_1.default.red("Cannot  send GoodSubscriptionTransferred => lets create a TransferredSubscription "));
          const ts = new i_server_side_publish_engine_1.TransferredSubscription({
            generator: this._sequence_number_generator,
            id: this.id,
            publishEngine: this.publishEngine
          });
          ts._pending_notification = notificationData;
          this.publishEngine._closed_subscriptions.push(ts);
        }
      }
      /**
       *
       *  the server invokes the resetLifeTimeAndKeepAliveCounters method of the subscription
       *  when the server  has send a Publish Response, so that the subscription
       *  can reset its life time counter.
       *
       * @private
       */
      resetLifeTimeAndKeepAliveCounters() {
        this.resetLifeTimeCounter();
        this.resetKeepAliveCounter();
      }
      _updateCounters(notificationMessage) {
        for (const notificationData of notificationMessage.notificationData || []) {
          if (notificationData instanceof node_opcua_service_subscription_2.DataChangeNotification) {
            const nbNotifs = notificationData.monitoredItems.length;
            this.subscriptionDiagnostics.dataChangeNotificationsCount += nbNotifs;
            this.subscriptionDiagnostics.notificationsCount += nbNotifs;
          } else if (notificationData instanceof node_opcua_service_subscription_2.EventNotificationList) {
            const nbNotifs = notificationData.events.length;
            this.subscriptionDiagnostics.eventNotificationsCount += nbNotifs;
            this.subscriptionDiagnostics.notificationsCount += nbNotifs;
          } else {
            (0, node_opcua_assert_1.assert)(notificationData instanceof node_opcua_service_subscription_2.StatusChangeNotification);
          }
        }
      }
      /**
       *  _publish_pending_notifications send a "notification" event:
       *
       * @private
       * @precondition
       *     - pendingPublishRequestCount > 0
       */
      _publish_pending_notifications() {
        const publishEngine = this.publishEngine;
        const subscriptionId = this.id;
        (0, node_opcua_assert_1.assert)(publishEngine.pendingPublishRequestCount > 0);
        (0, node_opcua_assert_1.assert)(this.hasPendingNotifications);
        const notificationMessage = this._popNotificationToSend();
        if (notificationMessage.notificationData.length === 0) {
          return;
        }
        const moreNotifications = this.hasPendingNotifications;
        this.emit("notification", notificationMessage);
        this._updateCounters(notificationMessage);
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(notificationMessage, "sequenceNumber"));
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(notificationMessage, "notificationData"));
        this.subscriptionDiagnostics.publishRequestCount += 1;
        const response = new node_opcua_service_subscription_2.PublishResponse({
          moreNotifications,
          notificationMessage: {
            notificationData: notificationMessage.notificationData,
            sequenceNumber: this._get_next_sequence_number()
          },
          subscriptionId
        });
        this._sent_notification_messages.push(response.notificationMessage);
        const availableSequenceNumbers = this.getAvailableSequenceNumbers();
        (0, node_opcua_assert_1.assert)(!response.notificationMessage || availableSequenceNumbers[availableSequenceNumbers.length - 1] === response.notificationMessage.sequenceNumber);
        response.availableSequenceNumbers = availableSequenceNumbers;
        publishEngine._send_response(this, response);
        this.messageSent = true;
        this.subscriptionDiagnostics.unacknowledgedMessageCount++;
        this.resetLifeTimeAndKeepAliveCounters();
        if (doDebug) {
          debugLog("Subscription sending a notificationMessage subscriptionId=", subscriptionId, "sequenceNumber = ", notificationMessage.sequenceNumber.toString(), notificationMessage.notificationData?.map((x2) => x2?.constructor.name).join(" "));
        }
        if (this.state !== SubscriptionState.CLOSED) {
          (0, node_opcua_assert_1.assert)(notificationMessage.notificationData.length > 0, "We are not expecting a keep-alive message here");
          this.state = SubscriptionState.NORMAL;
          debugLog("subscription " + this.id + chalk_1.default.bgYellow(" set to NORMAL"));
        }
      }
      process_subscription() {
        (0, node_opcua_assert_1.assert)(this.publishEngine.pendingPublishRequestCount > 0);
        if (!this.publishingEnabled) {
          debugLog("    -> no publish to do, except keep alive");
          this._process_keepAlive();
          return;
        }
        if (!this.hasPendingNotifications && this.hasUncollectedMonitoredItemNotifications) {
          this._harvestMonitoredItems();
        }
        if (this.hasPendingNotifications) {
          this._publish_pending_notifications();
          if (this.state === SubscriptionState.NORMAL || this.state === SubscriptionState.LATE && this.hasPendingNotifications) {
            if (doDebug) {
              debugLog("    -> pendingPublishRequestCount > 0 && normal state => re-trigger tick event immediately ");
            }
            setImmediate(this._tick.bind(this));
          }
        } else {
          this._process_keepAlive();
        }
      }
      _process_keepAlive() {
        this.increaseKeepAliveCounter();
        if (this.keepAliveCounterHasExpired) {
          debugLog(`     ->  _process_keepAlive => keepAliveCounterHasExpired`);
          if (this._sendKeepAliveResponse()) {
            this.resetLifeTimeAndKeepAliveCounters();
          } else {
            debugLog("     -> subscription.state === LATE , because keepAlive Response cannot be send due to lack of PublishRequest");
            if (this.messageSent || this.keepAliveCounterHasExpired) {
              this.state = SubscriptionState.LATE;
            }
          }
        }
      }
      _stop_timer() {
        if (this.timerId) {
          debugLog(chalk_1.default.bgWhite.blue("Subscription#_stop_timer subscriptionId="), this.id);
          clearInterval(this.timerId);
          this.timerId = null;
        }
      }
      _start_timer({ firstTime }) {
        debugLog(chalk_1.default.bgWhite.blue("Subscription#_start_timer  subscriptionId="), this.id, " publishingInterval = ", this.publishingInterval);
        (0, node_opcua_assert_1.assert)(this.timerId === null);
        this._keep_alive_counter = this.maxKeepAliveCount - 1;
        if (firstTime) {
          (0, node_opcua_assert_1.assert)(this.messageSent === false);
          (0, node_opcua_assert_1.assert)(this.state === SubscriptionState.CREATING);
        }
        (0, node_opcua_assert_1.assert)(this.publishingInterval >= _Subscription.minimumPublishingInterval);
        this.timerId = setInterval(this._tick.bind(this), this.publishingInterval);
      }
      _get_future_sequence_number() {
        return this._sequence_number_generator ? this._sequence_number_generator.future() : 0;
      }
      get futureSequenceNumber() {
        return this._get_future_sequence_number();
      }
      // counter
      _get_next_sequence_number() {
        return this._sequence_number_generator ? this._sequence_number_generator.next() : 0;
      }
      get nextSequenceNumber() {
        return this._get_next_sequence_number();
      }
      /**
       * @private
       */
      _tick() {
        if (doDebug) {
          debugLog(`Subscription#_tick id ${this.id} aborted=${this.aborted} state=${SubscriptionState[this.state]}`);
        }
        if (this.state === SubscriptionState.CLOSED) {
          warningLog(`Warning: Subscription#_tick id ${this.id}  called while subscription is CLOSED`);
          return;
        }
        this.discardOldSentNotifications();
        if (doDebug) {
          debugLog(t(/* @__PURE__ */ new Date()) + "  " + this._life_time_counter + "/" + this.lifeTimeCount + chalk_1.default.cyan("   Subscription#_tick"), "  processing subscriptionId=", this.id, "hasUncollectedMonitoredItemNotifications = ", this.hasUncollectedMonitoredItemNotifications, " publishingIntervalCount =", this.publishIntervalCount);
        }
        this.publishEngine._on_tick();
        this.publishIntervalCount += 1;
        if (this.state === SubscriptionState.LATE) {
          this.increaseLifeTimeCounter();
        }
        if (this.lifeTimeHasExpired) {
          doDebug && debugLog(chalk_1.default.red.bold(`Subscription ${this.id} has expired !!!!! => Terminating`));
          this.emit("expired");
          doDebug && debugLog("adding StatusChangeNotification notification message for BadTimeout subscription = ", this.id);
          this._addNotificationMessage(new node_opcua_service_subscription_2.StatusChangeNotification({ status: node_opcua_status_code_1.StatusCodes.BadTimeout }));
          this.terminate();
          return;
        }
        const publishEngine = this.publishEngine;
        doDebug && debugLog("Subscription#_tick  self._pending_notifications= ", this._pending_notifications.size);
        if (publishEngine.pendingPublishRequestCount === 0 && (this.hasPendingNotifications || this.hasUncollectedMonitoredItemNotifications)) {
          doDebug && debugLog("subscription set to LATE  hasPendingNotifications = ", this.hasPendingNotifications, " hasUncollectedMonitoredItemNotifications =", this.hasUncollectedMonitoredItemNotifications);
          this.state = SubscriptionState.LATE;
          return;
        }
        if (publishEngine.pendingPublishRequestCount > 0) {
          if (this.hasPendingNotifications) {
            this.process_subscription();
          } else if (this.hasUncollectedMonitoredItemNotifications) {
            this.process_subscription();
          } else {
            this._process_keepAlive();
          }
        } else {
          if (this.state !== SubscriptionState.LATE) {
            this._process_keepAlive();
          } else {
            this.resetKeepAliveCounter();
          }
        }
      }
      /**
       * @private
       */
      _sendKeepAliveResponse() {
        const future_sequence_number = this._get_future_sequence_number();
        if (this.publishEngine.send_keep_alive_response(this.id, future_sequence_number)) {
          this.messageSent = true;
          doDebug && debugLog(`    -> Subscription#_sendKeepAliveResponse subscriptionId ${this.id} future_sequence_number ${future_sequence_number}`);
          this.emit("keepalive", future_sequence_number);
          this.state = SubscriptionState.KEEPALIVE;
          return true;
        }
        return false;
      }
      /**
       * Reset the Lifetime Counter Variable to the value specified for the lifetime of a Subscription in
       * the CreateSubscription Service( 5.13.2).
       * @private
       */
      resetKeepAliveCounter() {
        this._keep_alive_counter = 0;
        doDebug && debugLog("     -> subscriptionId", this.id, " Resetting keepAliveCounter = ", this._keep_alive_counter, this.maxKeepAliveCount);
      }
      /**
       * @private
       */
      increaseKeepAliveCounter() {
        this._keep_alive_counter += 1;
        doDebug && debugLog("     -> subscriptionId", this.id, " Increasing keepAliveCounter = ", this._keep_alive_counter, this.maxKeepAliveCount);
      }
      /**
       * @private
       */
      _addNotificationMessage(notificationData, monitoredItemId) {
        doDebug && debugLog(chalk_1.default.yellow("Subscription#_addNotificationMessage"), notificationData.toString());
        this._pending_notifications.push({
          monitoredItemId,
          notification: notificationData,
          publishTime: /* @__PURE__ */ new Date(),
          start_tick: this.publishIntervalCount
        });
      }
      /**
       * @internal
       * @param monitoredItemId
       */
      _removePendingNotificationsFor(monitoredItemId) {
        const nbRemovedNotification = this._pending_notifications.filterOut((e) => e.monitoredItemId === monitoredItemId);
        doDebug && debugLog(`Removed ${nbRemovedNotification} notifications`);
      }
      /**
       * Extract the next Notification that is ready to be sent to the client.
       * @return the Notification to send._pending_notifications
       */
      _popNotificationToSend() {
        (0, node_opcua_assert_1.assert)(this._pending_notifications.size > 0);
        const notificationMessage = new node_opcua_service_subscription_2.NotificationMessage({
          sequenceNumber: 4294967295,
          notificationData: [],
          publishTime: /* @__PURE__ */ new Date()
        });
        const dataChangeNotifications = new node_opcua_service_subscription_2.DataChangeNotification({
          monitoredItems: []
        });
        const eventNotificationList = new node_opcua_service_subscription_2.EventNotificationList({
          events: []
        });
        let statusChangeNotification;
        let i = 0;
        let hasEventFieldList = 0;
        let hasMonitoredItemNotification = 0;
        const m2 = this.maxNotificationsPerPublish;
        while (i < m2 && this._pending_notifications.size > 0) {
          if (hasEventFieldList || hasMonitoredItemNotification) {
            const notification1 = this._pending_notifications.first().notification;
            if (notification1 instanceof node_opcua_service_subscription_2.StatusChangeNotification) {
              break;
            }
          }
          const notification = this._pending_notifications.shift().notification;
          if (notification instanceof node_opcua_service_subscription_2.MonitoredItemNotification) {
            (0, node_opcua_assert_1.assert)(notification.clientHandle !== 4294967295);
            dataChangeNotifications.monitoredItems.push(notification);
            hasMonitoredItemNotification = 1;
          } else if (notification instanceof node_opcua_types_1.EventFieldList) {
            eventNotificationList.events.push(notification);
            hasEventFieldList = 1;
          } else if (notification instanceof node_opcua_service_subscription_2.StatusChangeNotification) {
            statusChangeNotification = notification;
            break;
          }
          i += 1;
        }
        if (dataChangeNotifications.monitoredItems.length) {
          notificationMessage.notificationData.push(dataChangeNotifications);
        }
        if (eventNotificationList.events.length) {
          notificationMessage.notificationData.push(eventNotificationList);
        }
        if (statusChangeNotification) {
          notificationMessage.notificationData.push(statusChangeNotification);
        }
        return notificationMessage;
      }
      /**
       * discardOldSentNotification find all sent notification message that have expired keep-alive
       * and destroy them.
       * @private
       *
       * Subscriptions maintain a retransmission queue of sent  NotificationMessages.
       * NotificationMessages are retained in this queue until they are acknowledged or until they have
       * been in the queue for a minimum of one keep-alive interval.
       *
       */
      discardOldSentNotifications() {
        if (maxNotificationMessagesInQueue <= this._sent_notification_messages.length) {
          doDebug && debugLog("discardOldSentNotifications = ", this._sent_notification_messages.length);
          this._sent_notification_messages.splice(this._sent_notification_messages.length - maxNotificationMessagesInQueue);
        }
      }
      /**
       * @param timestampsToReturn
       * @param monitoredItemCreateRequest
       * @param node
       * @private
       */
      _createMonitoredItemStep2(timestampsToReturn, monitoredItemCreateRequest, node) {
        (0, node_opcua_assert_1.assert)(monitoredItemCreateRequest instanceof node_opcua_service_subscription_2.MonitoredItemCreateRequest);
        const itemToMonitor = monitoredItemCreateRequest.itemToMonitor;
        this.monitoredItemIdCounter += 1;
        const monitoredItemId = getNextMonitoredItemId();
        const requestedParameters = monitoredItemCreateRequest.requestedParameters;
        requestedParameters.samplingInterval = this.adjustSamplingInterval(requestedParameters.samplingInterval, node);
        const options = requestedParameters;
        options.monitoredItemId = monitoredItemId;
        options.itemToMonitor = itemToMonitor;
        const monitoredItem = new monitored_item_1.MonitoredItem(options);
        monitoredItem.timestampsToReturn = timestampsToReturn;
        monitoredItem.$subscription = this;
        (0, node_opcua_assert_1.assert)(monitoredItem.monitoredItemId === monitoredItemId);
        this.monitoredItems[monitoredItemId] = monitoredItem;
        this.globalCounter.totalMonitoredItemCount += 1;
        (0, node_opcua_assert_1.assert)(monitoredItem.clientHandle !== 4294967295);
        const filterResult = _process_filter(node, requestedParameters.filter);
        const monitoredItemCreateResult = new node_opcua_service_subscription_2.MonitoredItemCreateResult({
          filterResult,
          monitoredItemId,
          revisedQueueSize: monitoredItem.queueSize,
          revisedSamplingInterval: monitoredItem.samplingInterval,
          statusCode: node_opcua_status_code_1.StatusCodes.Good
        });
        return monitoredItemCreateResult;
      }
      /**
       *
       * @param monitoredItem
       * @param monitoredItemCreateRequest
       * @private
       */
      _createMonitoredItemStep3(monitoredItem, monitoredItemCreateRequest) {
        if (!monitoredItem) {
          return;
        }
        (0, node_opcua_assert_1.assert)(monitoredItem.monitoringMode === node_opcua_service_subscription_2.MonitoringMode.Invalid);
        (0, node_opcua_assert_1.assert)(typeof monitoredItem.samplingFunc === "function", " expecting a sampling function here");
        const monitoringMode = monitoredItemCreateRequest.monitoringMode;
        monitoredItem.setMonitoringMode(monitoringMode);
      }
      _harvestMonitoredItems() {
        for (const monitoredItem of Object.values(this.monitoredItems)) {
          const notifications_chunks = monitoredItem.extractMonitoredItemNotifications();
          for (const chunk of notifications_chunks) {
            this._addNotificationMessage(chunk, monitoredItem.monitoredItemId);
          }
        }
        this._hasUncollectedMonitoredItemNotifications = false;
      }
    };
    exports2.Subscription = Subscription;
    Subscription.minimumPublishingInterval = 50;
    Subscription.defaultPublishingInterval = 1e3;
    Subscription.maximumPublishingInterval = 1e3 * 60;
    Subscription.maxNotificationPerPublishHighLimit = 1e3;
    Subscription.minimumLifetimeDuration = 5 * 1e3;
    Subscription.maximumLifetimeDuration = 60 * 60 * 1e3;
    Subscription.defaultMaxMonitoredItemCount = 2e4;
    Subscription.registry = new node_opcua_object_registry_1.ObjectRegistry();
    (0, node_opcua_assert_1.assert)(Subscription.maximumPublishingInterval < 2147483647, "maximumPublishingInterval cannot exceed (2**31-1) ms ");
  }
});

// node_modules/node-opcua-server/dist/server_publish_engine.js
var require_server_publish_engine = __commonJS({
  "node_modules/node-opcua-server/dist/server_publish_engine.js"(exports2) {
    "use strict";
    var __classPrivateFieldGet3 = exports2 && exports2.__classPrivateFieldGet || function(receiver, state, kind, f2) {
      if (kind === "a" && !f2)
        throw new TypeError("Private accessor was defined without a getter");
      if (typeof state === "function" ? receiver !== state || !f2 : !state.has(receiver))
        throw new TypeError("Cannot read private member from an object whose class did not declare it");
      return kind === "m" ? f2 : kind === "a" ? f2.call(receiver) : f2 ? f2.value : state.get(receiver);
    };
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    var _ServerSidePublishEngine_instances;
    var _ServerSidePublishEngine__find_starving_subscription;
    var _ServerSidePublishEngine__feed_late_subscription;
    var _ServerSidePublishEngine__feed_closed_subscription;
    var _ServerSidePublishEngine__handle_too_many_requests;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ServerSidePublishEngine = void 0;
    var events_1 = require("events");
    var chalk_1 = __importDefault3(require_source());
    var lodash_1 = require_lodash2();
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_object_registry_1 = require_dist46();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_types_1 = require_dist32();
    var server_subscription_1 = require_server_subscription();
    var server_subscription_2 = require_server_subscription();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    function traceLog(...args) {
      if (!doDebug) {
        return;
      }
      const a = args.map((x2) => x2);
      a.unshift(chalk_1.default.yellow(" TRACE "));
      debugLog(...a);
    }
    function _assertValidPublishData(publishData) {
      (0, node_opcua_assert_1.assert)(publishData.request instanceof node_opcua_types_1.PublishRequest);
      (0, node_opcua_assert_1.assert)(typeof publishData.serverTimeWhenReceived === "number");
      (0, node_opcua_assert_1.assert)(Array.isArray(publishData.results));
      (0, node_opcua_assert_1.assert)(typeof publishData.callback === "function");
    }
    function dummy_function() {
    }
    function addDate(date, delta) {
      return new Date(date.getTime() + delta);
    }
    function timeout_filter(publishData) {
      const request = publishData.request;
      const results = publishData.results;
      if (!request.requestHeader.timeoutHint) {
        return false;
      }
      const serverTimeWhenReceived = publishData.serverTimeWhenReceived;
      const expected_timeout_time = addDate(new Date(serverTimeWhenReceived), request.requestHeader.timeoutHint);
      return expected_timeout_time.getTime() < Date.now();
    }
    var ServerSidePublishEngine = class _ServerSidePublishEngine extends events_1.EventEmitter {
      /**
       * @private
       */
      static transferSubscriptionsToOrphan(srcPublishEngine, destPublishEngine) {
        debugLog(chalk_1.default.yellow("ServerSidePublishEngine#transferSubscriptionsToOrphan! start transferring long live subscriptions to orphan"));
        for (const subscription of Object.values(srcPublishEngine._subscriptions)) {
          (0, node_opcua_assert_1.assert)(subscription.publishEngine === srcPublishEngine);
          if (subscription.$session) {
            subscription.$session._unexposeSubscriptionDiagnostics(subscription);
          } else {
            console.warn("Warning:  subscription", subscription.id, " has no session attached!!!");
          }
          _ServerSidePublishEngine.transferSubscription(subscription, destPublishEngine, false);
        }
        (0, node_opcua_assert_1.assert)(srcPublishEngine.subscriptionCount === 0);
        debugLog(chalk_1.default.yellow("ServerSidePublishEngine#transferSubscriptionsToOrphan! end transferring long lived subscriptions to orphan"));
      }
      /**
       * @param subscription
       * @param destPublishEngine
       * @param sendInitialValues true if initial values should be sent
       * @private
       */
      static async transferSubscription(subscription, destPublishEngine, sendInitialValues) {
        const srcPublishEngine = subscription.publishEngine;
        (0, node_opcua_assert_1.assert)(!destPublishEngine.getSubscriptionById(subscription.id));
        (0, node_opcua_assert_1.assert)(srcPublishEngine.getSubscriptionById(subscription.id));
        destPublishEngine._purge_dangling_subscription(subscription.id);
        debugLog(chalk_1.default.cyan("ServerSidePublishEngine.transferSubscription live subscriptionId ="), subscription.subscriptionId);
        debugLog(chalk_1.default.cyan("ServerSidePublishEngine.transferSubscription with  = "), subscription.getAvailableSequenceNumbers());
        subscription.notifyTransfer();
        const tmp = srcPublishEngine.detach_subscription(subscription);
        destPublishEngine.add_subscription(tmp);
        subscription.resetLifeTimeCounter();
        if (sendInitialValues) {
          debugLog("Resending initial values");
          await subscription.resendInitialValues();
        }
        (0, node_opcua_assert_1.assert)(destPublishEngine.getSubscriptionById(subscription.id));
        (0, node_opcua_assert_1.assert)(!srcPublishEngine.getSubscriptionById(subscription.id));
        return subscription;
      }
      constructor(options) {
        super();
        _ServerSidePublishEngine_instances.add(this);
        this.maxPublishRequestInQueue = 0;
        this.isSessionClosed = false;
        this._publish_request_queue = [];
        this._closed_subscriptions = [];
        options = options || {};
        _ServerSidePublishEngine.registry.register(this);
        this._publish_request_queue = [];
        this._subscriptions = {};
        this._closed_subscriptions = [];
        this.maxPublishRequestInQueue = options.maxPublishRequestInQueue || 100;
        this.isSessionClosed = false;
      }
      toString() {
        let str = "";
        str += `maxPublishRequestInQueue ${this.maxPublishRequestInQueue}
`;
        str += `subscriptions ${Object.keys(this._subscriptions).join()}
`;
        str += `closed subscriptions ${this._closed_subscriptions.map((s) => s.id).join()}
`;
        return str;
      }
      dispose() {
        debugLog("ServerSidePublishEngine#dispose");
        (0, node_opcua_assert_1.assert)(Object.keys(this._subscriptions).length === 0, "self._subscriptions count!=0");
        this._subscriptions = {};
        (0, node_opcua_assert_1.assert)(this._closed_subscriptions.length === 0, "self._closed_subscriptions count!=0");
        this._closed_subscriptions = [];
        _ServerSidePublishEngine.registry.unregister(this);
      }
      process_subscriptionAcknowledgements(subscriptionAcknowledgements) {
        subscriptionAcknowledgements = subscriptionAcknowledgements || [];
        debugLog("process_subscriptionAcknowledgements = ", subscriptionAcknowledgements);
        const results = subscriptionAcknowledgements.map((subscriptionAcknowledgement) => {
          const subscription = this.getSubscriptionById(subscriptionAcknowledgement.subscriptionId);
          if (!subscription) {
            return node_opcua_status_code_1.StatusCodes.BadSubscriptionIdInvalid;
          }
          return subscription.acknowledgeNotification(subscriptionAcknowledgement.sequenceNumber);
        });
        return results;
      }
      /**
       * get a array of subscription handled by the publish engine.
       */
      get subscriptions() {
        return Object.values(this._subscriptions);
      }
      /**
       */
      add_subscription(subscription) {
        (0, node_opcua_assert_1.assert)(subscription instanceof server_subscription_1.Subscription);
        (0, node_opcua_assert_1.assert)(isFinite(subscription.id));
        subscription.publishEngine = subscription.publishEngine || this;
        (0, node_opcua_assert_1.assert)(subscription.publishEngine === this);
        (0, node_opcua_assert_1.assert)(!this._subscriptions[subscription.id]);
        debugLog("ServerSidePublishEngine#add_subscription -  adding subscription with Id:", subscription.id);
        this._subscriptions[subscription.id] = subscription;
        return subscription;
      }
      detach_subscription(subscription) {
        (0, node_opcua_assert_1.assert)(subscription instanceof server_subscription_1.Subscription);
        (0, node_opcua_assert_1.assert)(isFinite(subscription.id));
        (0, node_opcua_assert_1.assert)(subscription.publishEngine === this);
        (0, node_opcua_assert_1.assert)(this._subscriptions[subscription.id] === subscription);
        delete this._subscriptions[subscription.id];
        subscription.publishEngine = null;
        debugLog("ServerSidePublishEngine#detach_subscription detaching subscription with Id:", subscription.id);
        return subscription;
      }
      /**
       */
      shutdown() {
        if (this.subscriptionCount !== 0) {
          debugLog(chalk_1.default.red("Shutting down pending subscription"));
          this.subscriptions.map((subscription) => subscription.terminate());
        }
        (0, node_opcua_assert_1.assert)(this.subscriptionCount === 0, "subscription shall be removed first before you can shutdown a publish engine");
        debugLog("ServerSidePublishEngine#shutdown");
        this._publish_request_queue = [];
        this._closed_subscriptions.map((subscription) => subscription.dispose());
        this._closed_subscriptions = [];
      }
      /**
       * number of pending PublishRequest available in queue
       */
      get pendingPublishRequestCount() {
        return this._publish_request_queue.length;
      }
      /**
       * number of subscriptions
       */
      get subscriptionCount() {
        return Object.keys(this._subscriptions).length;
      }
      get pendingClosedSubscriptionCount() {
        return this._closed_subscriptions.length;
      }
      get currentMonitoredItemCount() {
        const subscriptions = Object.values(this._subscriptions);
        const result2 = subscriptions.reduce((sum, subscription) => {
          return sum + subscription.monitoredItemCount;
        }, 0);
        (0, node_opcua_assert_1.assert)(isFinite(result2));
        return result2;
      }
      _purge_dangling_subscription(subscriptionId) {
        this._closed_subscriptions = this._closed_subscriptions.filter((s) => s.id !== subscriptionId);
      }
      on_close_subscription(subscription) {
        doDebug && debugLog("ServerSidePublishEngine#on_close_subscription", subscription.id);
        if (subscription.hasPendingNotifications) {
          doDebug && debugLog("ServerSidePublishEngine#on_close_subscription storing subscription", subscription.id, " to _closed_subscriptions because it has pending notification");
          this._closed_subscriptions.push(subscription);
        } else {
          doDebug && debugLog("ServerSidePublishEngine#on_close_subscription disposing subscription", subscription.id);
          subscription.dispose();
        }
        delete this._subscriptions[subscription.id];
        while (__classPrivateFieldGet3(this, _ServerSidePublishEngine_instances, "m", _ServerSidePublishEngine__feed_closed_subscription).call(this)) {
        }
        if (this.subscriptionCount === 0 && this._closed_subscriptions.length === 0) {
          this.cancelPendingPublishRequest();
        }
      }
      /**
       * retrieve a subscription by id.
       * @param subscriptionId
       * @return Subscription
       */
      getSubscriptionById(subscriptionId) {
        return this._subscriptions[subscriptionId.toString()];
      }
      findLateSubscriptions() {
        const subscriptions = Object.values(this._subscriptions);
        return subscriptions.filter((subscription) => {
          return (subscription.state === server_subscription_2.SubscriptionState.LATE || !subscription.messageSent) && subscription.publishingEnabled;
        });
      }
      get hasLateSubscriptions() {
        return this.findLateSubscriptions().length > 0;
      }
      findLateSubscriptionsSortedByAge() {
        let late_subscriptions = this.findLateSubscriptions();
        late_subscriptions = (0, lodash_1.sortBy)(late_subscriptions, "timeToExpiration");
        return late_subscriptions;
      }
      cancelPendingPublishRequestBeforeChannelChange() {
        this._cancelPendingPublishRequest(node_opcua_status_code_1.StatusCodes.BadSecureChannelClosed);
      }
      onSessionClose() {
        this.isSessionClosed = true;
        this._cancelPendingPublishRequest(node_opcua_status_code_1.StatusCodes.BadSessionClosed);
      }
      /**
       * @private
       */
      cancelPendingPublishRequest() {
        (0, node_opcua_assert_1.assert)(this.subscriptionCount === 0);
        this._cancelPendingPublishRequest(node_opcua_status_code_1.StatusCodes.BadNoSubscription);
      }
      /**
       *
       * @param request
       * @param callback
       * @private
       * @internal
       */
      _on_PublishRequest(request, callback) {
        callback = callback || dummy_function;
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        if (!(request instanceof node_opcua_types_1.PublishRequest)) {
          throw new Error("Internal error : expecting a Publish Request here");
        }
        const subscriptionAckResults = this.process_subscriptionAcknowledgements(request.subscriptionAcknowledgements || []);
        const currentTime = Date.now();
        const publishData = {
          callback,
          request,
          results: subscriptionAckResults,
          serverTimeWhenReceived: currentTime
        };
        if (this.isSessionClosed) {
          traceLog("server has received a PublishRequest but session is Closed");
          this._send_error_for_request(publishData, node_opcua_status_code_1.StatusCodes.BadSessionClosed);
        } else if (this.subscriptionCount === 0) {
          if (this._closed_subscriptions.length > 0 && this._closed_subscriptions[0].hasPendingNotifications) {
            const verif = this._publish_request_queue.length;
            this._publish_request_queue.push(publishData);
            const processed = __classPrivateFieldGet3(this, _ServerSidePublishEngine_instances, "m", _ServerSidePublishEngine__feed_closed_subscription).call(this);
            return;
          }
          traceLog("server has received a PublishRequest but has no subscription opened");
          this._send_error_for_request(publishData, node_opcua_status_code_1.StatusCodes.BadNoSubscription);
        } else {
          this._publish_request_queue.push(publishData);
          (0, node_opcua_assert_1.assert)(this.pendingPublishRequestCount > 0);
          debugLog(chalk_1.default.bgWhite.red("Adding a PublishRequest to the queue "), this._publish_request_queue.length);
          __classPrivateFieldGet3(this, _ServerSidePublishEngine_instances, "m", _ServerSidePublishEngine__feed_closed_subscription).call(this);
          __classPrivateFieldGet3(this, _ServerSidePublishEngine_instances, "m", _ServerSidePublishEngine__feed_late_subscription).call(this);
          __classPrivateFieldGet3(this, _ServerSidePublishEngine_instances, "m", _ServerSidePublishEngine__handle_too_many_requests).call(this);
        }
      }
      _send_error_for_request(publishData, statusCode) {
        _assertValidPublishData(publishData);
        const response = new node_opcua_types_1.ServiceFault({
          responseHeader: { serviceResult: statusCode }
        });
        this._send_response_for_request(publishData, response);
      }
      _cancelPendingPublishRequest(statusCode) {
        if (this._publish_request_queue) {
          debugLog(chalk_1.default.red("Cancelling pending PublishRequest with statusCode  "), statusCode.toString(), " length =", this._publish_request_queue.length);
        } else {
          debugLog(chalk_1.default.red("No pending PublishRequest to cancel"));
        }
        for (const publishData of this._publish_request_queue) {
          this._send_error_for_request(publishData, statusCode);
        }
        this._publish_request_queue = [];
      }
      /**
       * call by a subscription when no notification message is available after the keep alive delay has
       * expired.
       *
       * @method send_keep_alive_response
       * @param subscriptionId
       * @param future_sequence_number
       * @return true if a publish response has been sent
       */
      send_keep_alive_response(subscriptionId, future_sequence_number) {
        const subscription = this.getSubscriptionById(subscriptionId);
        if (!subscription) {
          traceLog("send_keep_alive_response  => invalid subscriptionId = ", subscriptionId);
          return false;
        }
        if (this.pendingPublishRequestCount === 0 || subscription.hasPendingNotifications) {
          traceLog("send_keep_alive_response  => cannot send keep-alive  (no PublishRequest left) subscriptionId = ", subscriptionId);
          return false;
        }
        debugLog(`Sending keep alive response for subscription id ${subscription.id} ${subscription.publishingInterval} ${subscription.maxKeepAliveCount}`);
        this._send_response(subscription, new node_opcua_types_1.PublishResponse({
          availableSequenceNumbers: subscription.getAvailableSequenceNumbers(),
          moreNotifications: false,
          notificationMessage: {
            sequenceNumber: future_sequence_number
          },
          subscriptionId
        }));
        return true;
      }
      _send_response(subscription, response) {
        (0, node_opcua_assert_1.assert)(this.pendingPublishRequestCount > 0);
        (0, node_opcua_assert_1.assert)(response.subscriptionId !== 16777215);
        const publishData = this._publish_request_queue.shift();
        this._send_valid_response_for_request(publishData, response);
      }
      _on_tick() {
        this._cancelTimeoutRequests();
      }
      _cancelTimeoutRequests() {
        if (this._publish_request_queue.length === 0) {
          return;
        }
        const parts = (0, lodash_1.partition)(this._publish_request_queue, timeout_filter);
        this._publish_request_queue = parts[1];
        const invalid_published_request = parts[0];
        for (const publishData of invalid_published_request) {
          if (doDebug) {
            debugLog(chalk_1.default.cyan(" CANCELING TIMEOUT PUBLISH REQUEST "));
          }
          this._send_error_for_request(publishData, node_opcua_status_code_1.StatusCodes.BadTimeout);
        }
      }
      _send_response_for_request(publishData, response) {
        response.responseHeader.requestHandle = publishData.request.requestHeader.requestHandle;
        publishData.callback(publishData.request, response);
      }
      _send_valid_response_for_request(publishData, response) {
        if (doDebug) {
          debugLog("_send_response_for_request ", response.toString());
        }
        _assertValidPublishData(publishData);
        response.results = publishData.results;
        this._send_response_for_request(publishData, response);
      }
    };
    exports2.ServerSidePublishEngine = ServerSidePublishEngine;
    _ServerSidePublishEngine_instances = /* @__PURE__ */ new WeakSet(), _ServerSidePublishEngine__find_starving_subscription = function _ServerSidePublishEngine__find_starving_subscription2() {
      const late_subscriptions = this.findLateSubscriptions();
      function compare_subscriptions(s1, s2) {
        if (s1.priority === s2.priority) {
          return s1.timeToExpiration < s2.timeToExpiration ? 1 : 0;
        }
        return s1.priority > s2.priority ? 1 : 0;
      }
      function findLateSubscriptionSortedByPriority() {
        if (late_subscriptions.length === 0) {
          return null;
        }
        late_subscriptions.sort(compare_subscriptions);
        if (doDebug) {
          debugLog(late_subscriptions.map((s) => "[ id = " + s.id + " prio=" + s.priority + " t=" + s.timeToExpiration + " ka=" + s.timeToKeepAlive + " m?=" + s.hasUncollectedMonitoredItemNotifications + " " + server_subscription_2.SubscriptionState[s.state] + " " + s.messageSent + "]").join(" \n"));
        }
        return late_subscriptions[late_subscriptions.length - 1];
      }
      if (this._closed_subscriptions) {
      }
      const starving_subscription = (
        /* this.findSubscriptionWaitingForFirstPublish() || */
        findLateSubscriptionSortedByPriority()
      );
      return starving_subscription;
    }, _ServerSidePublishEngine__feed_late_subscription = function _ServerSidePublishEngine__feed_late_subscription2() {
      setImmediate(() => {
        if (!this.pendingPublishRequestCount) {
          return;
        }
        const starving_subscription = __classPrivateFieldGet3(this, _ServerSidePublishEngine_instances, "m", _ServerSidePublishEngine__find_starving_subscription).call(this);
        if (starving_subscription) {
          doDebug && debugLog(chalk_1.default.bgWhite.red("feeding most late subscription subscriptionId  = "), starving_subscription.id);
          starving_subscription.process_subscription();
        }
      });
    }, _ServerSidePublishEngine__feed_closed_subscription = function _ServerSidePublishEngine__feed_closed_subscription2() {
      if (!this.pendingPublishRequestCount) {
        return false;
      }
      if (this._closed_subscriptions.length === 0) {
        debugLog("ServerSidePublishEngine#_feed_closed_subscription  -> nothing to do");
        return false;
      }
      const closed_subscription = this._closed_subscriptions[0];
      (0, node_opcua_assert_1.assert)(closed_subscription.hasPendingNotifications);
      debugLog("ServerSidePublishEngine#_feed_closed_subscription for closed_subscription ", closed_subscription.id);
      closed_subscription?._publish_pending_notifications();
      if (!closed_subscription?.hasPendingNotifications) {
        closed_subscription.dispose();
        this._closed_subscriptions.shift();
      }
      return true;
    }, _ServerSidePublishEngine__handle_too_many_requests = function _ServerSidePublishEngine__handle_too_many_requests2() {
      if (this.pendingPublishRequestCount > this.maxPublishRequestInQueue) {
        traceLog("server has received too many PublishRequest", this.pendingPublishRequestCount, "/", this.maxPublishRequestInQueue);
        (0, node_opcua_assert_1.assert)(this.pendingPublishRequestCount === this.maxPublishRequestInQueue + 1);
        const publishData = this._publish_request_queue.shift();
        this._send_error_for_request(publishData, node_opcua_status_code_1.StatusCodes.BadTooManyPublishRequests);
      }
    };
    ServerSidePublishEngine.registry = new node_opcua_object_registry_1.ObjectRegistry();
  }
});

// node_modules/node-opcua-server/dist/server_session.js
var require_server_session = __commonJS({
  "node_modules/node-opcua-server/dist/server_session.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ServerSession = void 0;
    var crypto_1 = require("crypto");
    var events_1 = require("events");
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_address_space_1 = require_index_current();
    var node_opcua_basic_types_1 = require_dist23();
    var node_opcua_common_1 = require_dist34();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_object_registry_1 = require_dist46();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_utils_2 = require_dist16();
    var server_publish_engine_1 = require_server_publish_engine();
    var server_subscription_1 = require_server_subscription();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var theWatchDog = new node_opcua_utils_1.WatchDog();
    var registeredNodeNameSpace = 9999;
    function on_channel_abort() {
      debugLog("ON CHANNEL ABORT ON  SESSION!!!");
      this.emit("channel_aborted");
    }
    var ServerSession = class _ServerSession extends events_1.EventEmitter {
      constructor(parent, userManager, sessionTimeout) {
        super();
        this.__status = "new";
        this.sessionName = "";
        this.keepAlive = node_opcua_utils_1.WatchDog.emptyKeepAlive;
        this.parent = parent;
        _ServerSession.registry.register(this);
        this.sessionContext = new node_opcua_address_space_1.SessionContext({
          session: this,
          server: { userManager }
        });
        (0, node_opcua_assert_1.assert)(isFinite(sessionTimeout));
        (0, node_opcua_assert_1.assert)(sessionTimeout >= 0, " sessionTimeout");
        this.sessionTimeout = sessionTimeout;
        const authenticationTokenBuf = (0, crypto_1.randomBytes)(16);
        this.authenticationToken = new node_opcua_nodeid_1.NodeId(node_opcua_nodeid_1.NodeIdType.BYTESTRING, authenticationTokenBuf);
        const ownNamespaceIndex = 1;
        this.nodeId = new node_opcua_nodeid_1.NodeId(node_opcua_nodeid_1.NodeIdType.GUID, (0, node_opcua_basic_types_1.randomGuid)(), ownNamespaceIndex);
        (0, node_opcua_assert_1.assert)(this.authenticationToken instanceof node_opcua_nodeid_1.NodeId);
        (0, node_opcua_assert_1.assert)(this.nodeId instanceof node_opcua_nodeid_1.NodeId);
        this._cumulatedSubscriptionCount = 0;
        this.publishEngine = new server_publish_engine_1.ServerSidePublishEngine({
          maxPublishRequestInQueue: _ServerSession.maxPublishRequestInQueue
        });
        this.publishEngine.setMaxListeners(100);
        theWatchDog.addSubscriber(this, this.sessionTimeout);
        this.__status = "new";
        this.continuationPointManager = new node_opcua_address_space_1.ContinuationPointManager();
        this.creationDate = /* @__PURE__ */ new Date();
        this._registeredNodesCounter = 0;
        this._registeredNodes = {};
        this._registeredNodesInv = {};
      }
      getSessionId() {
        return this.nodeId;
      }
      getEndpointDescription() {
        return this.endpoint;
      }
      dispose() {
        debugLog("ServerSession#dispose()");
        (0, node_opcua_assert_1.assert)(!this.sessionObject, " sessionObject has not been cleared !");
        this.parent = null;
        this.authenticationToken = new node_opcua_nodeid_1.NodeId();
        if (this.publishEngine) {
          this.publishEngine.dispose();
          this.publishEngine = null;
        }
        this._sessionDiagnostics = void 0;
        this._registeredNodesCounter = 0;
        this._registeredNodes = null;
        this._registeredNodesInv = null;
        this.continuationPointManager = null;
        this.removeAllListeners();
        this.__status = "disposed";
        _ServerSession.registry.unregister(this);
      }
      get clientConnectionTime() {
        return this.creationDate;
      }
      /**
       * return the number of milisecond since last session transaction occurs from client
       * the first transaction is the creation of the session
       */
      get clientLastContactTime() {
        const lastSeen = this._watchDogData ? this._watchDogData.lastSeen : node_opcua_basic_types_1.minOPCUADate.getTime();
        return node_opcua_utils_1.WatchDog.lastSeenToDuration(lastSeen);
      }
      get status() {
        return this.__status;
      }
      set status(value) {
        if (value === "active") {
          this._createSessionObjectInAddressSpace();
        }
        if (this.__status !== value) {
          this.emit("statusChanged", value);
        }
        this.__status = value;
      }
      get addressSpace() {
        if (this.parent && this.parent.addressSpace) {
          return this.parent.addressSpace;
        }
        return null;
      }
      get currentPublishRequestInQueue() {
        return this.publishEngine ? this.publishEngine.pendingPublishRequestCount : 0;
      }
      updateClientLastContactTime() {
        if (this._sessionDiagnostics && this._sessionDiagnostics.clientLastContactTime) {
          const currentTime = /* @__PURE__ */ new Date();
          if (currentTime.getTime() - 250 >= this._sessionDiagnostics.clientLastContactTime.getTime()) {
            this._sessionDiagnostics.clientLastContactTime = currentTime;
          }
        }
      }
      /**
       * @method onClientSeen
       * required for watch dog
       * @param currentTime {DateTime}
       * @private
       */
      onClientSeen() {
        this.updateClientLastContactTime();
        if (this._sessionDiagnostics) {
          (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(this._sessionDiagnostics, "currentMonitoredItemsCount"));
          (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(this._sessionDiagnostics, "currentSubscriptionsCount"));
          (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(this._sessionDiagnostics, "currentPublishRequestsInQueue"));
          if (this._sessionDiagnostics.currentMonitoredItemsCount !== this.currentMonitoredItemCount) {
            this._sessionDiagnostics.currentMonitoredItemsCount = this.currentMonitoredItemCount;
          }
          if (this._sessionDiagnostics.currentSubscriptionsCount !== this.currentSubscriptionCount) {
            this._sessionDiagnostics.currentSubscriptionsCount = this.currentSubscriptionCount;
          }
          if (this._sessionDiagnostics.currentPublishRequestsInQueue !== this.currentPublishRequestInQueue) {
            this._sessionDiagnostics.currentPublishRequestsInQueue = this.currentPublishRequestInQueue;
          }
        }
      }
      incrementTotalRequestCount() {
        if (this._sessionDiagnostics && this._sessionDiagnostics.totalRequestCount) {
          this._sessionDiagnostics.totalRequestCount.totalCount += 1;
        }
      }
      incrementRequestTotalCounter(counterName) {
        if (this._sessionDiagnostics) {
          const propName = (0, node_opcua_utils_2.lowerFirstLetter)(counterName + "Count");
          if (!Object.prototype.hasOwnProperty.call(this._sessionDiagnostics, propName)) {
            errorLog("incrementRequestTotalCounter: cannot find", propName);
          } else {
            this._sessionDiagnostics[propName].totalCount += 1;
          }
        }
      }
      incrementRequestErrorCounter(counterName) {
        this.parent?.incrementRejectedRequestsCount();
        if (this._sessionDiagnostics) {
          const propName = (0, node_opcua_utils_2.lowerFirstLetter)(counterName + "Count");
          if (!Object.prototype.hasOwnProperty.call(this._sessionDiagnostics, propName)) {
            errorLog("incrementRequestErrorCounter: cannot find", propName);
          } else {
            this._sessionDiagnostics[propName].errorCount += 1;
          }
        }
      }
      /**
       * returns rootFolder.objects.server.serverDiagnostics.sessionsDiagnosticsSummary.sessionDiagnosticsArray
       */
      getSessionDiagnosticsArray() {
        const server = this.addressSpace.rootFolder.objects.server;
        return server.serverDiagnostics.sessionsDiagnosticsSummary.sessionDiagnosticsArray;
      }
      /**
       * returns rootFolder.objects.server.serverDiagnostics.sessionsDiagnosticsSummary.sessionSecurityDiagnosticsArray
       */
      getSessionSecurityDiagnosticsArray() {
        const server = this.addressSpace.rootFolder.objects.server;
        return server.serverDiagnostics.sessionsDiagnosticsSummary.sessionSecurityDiagnosticsArray;
      }
      /**
       * number of active subscriptions
       */
      get currentSubscriptionCount() {
        return this.publishEngine ? this.publishEngine.subscriptionCount : 0;
      }
      /**
       * number of subscriptions ever created since this object is live
       */
      get cumulatedSubscriptionCount() {
        return this._cumulatedSubscriptionCount;
      }
      /**
       * number of monitored items
       */
      get currentMonitoredItemCount() {
        return this.publishEngine ? this.publishEngine.currentMonitoredItemCount : 0;
      }
      /**
       * retrieve an existing subscription by subscriptionId
       * @method getSubscription
       * @param subscriptionId {Number}
       * @return {Subscription}
       */
      getSubscription(subscriptionId) {
        if (!this.publishEngine)
          return null;
        const subscription = this.publishEngine.getSubscriptionById(subscriptionId);
        if (subscription && subscription.state === server_subscription_1.SubscriptionState.CLOSED) {
          return null;
        }
        (0, node_opcua_assert_1.assert)(!subscription || subscription.state !== server_subscription_1.SubscriptionState.CLOSED, "CLOSED subscription shall not be managed by publish engine anymore");
        return subscription;
      }
      /**
       * @method deleteSubscription
       * @param subscriptionId {Number}
       * @return {StatusCode}
       */
      deleteSubscription(subscriptionId) {
        const subscription = this.getSubscription(subscriptionId);
        if (!subscription) {
          return node_opcua_status_code_1.StatusCodes.BadSubscriptionIdInvalid;
        }
        subscription.terminate();
        if (this.currentSubscriptionCount === 0) {
          const local_publishEngine = this.publishEngine;
          local_publishEngine.cancelPendingPublishRequest();
        }
        return node_opcua_status_code_1.StatusCodes.Good;
      }
      /**
       * close a ServerSession, this will also delete the subscriptions if the flag is set.
       *
       * Spec extract:
       *
       * If a Client invokes the CloseSession Service then all Subscriptions associated with the Session are also deleted
       * if the deleteSubscriptions flag is set to TRUE. If a Server terminates a Session for any other reason,
       * Subscriptions associated with the Session, are not deleted. Each Subscription has its own lifetime to protect
       * against data loss in the case of a Session termination. In these cases, the Subscription can be reassigned to
       * another Client before its lifetime expires.
       *
       * @method close
       * @param deleteSubscriptions : should we delete subscription ?
       * @param [reason = "CloseSession"] the reason for closing the session
       *         (shall be "Timeout", "Terminated" or "CloseSession")
       *
       */
      close(deleteSubscriptions, reason) {
        debugLog(" closing session deleteSubscriptions = ", deleteSubscriptions);
        if (this.publishEngine) {
          this.publishEngine.onSessionClose();
        }
        theWatchDog.removeSubscriber(this);
        if (!deleteSubscriptions && this.currentSubscriptionCount !== 0) {
          errorLog("TO DO : Closing session without deleting subscription not yet implemented");
        }
        this._deleteSubscriptions();
        (0, node_opcua_assert_1.assert)(this.currentSubscriptionCount === 0);
        (0, node_opcua_assert_1.assert)(this.currentSubscriptionCount === 0);
        this.status = "closed";
        this._detach_channel();
        this.emit("session_closed", this, deleteSubscriptions, reason);
        if (this.publishEngine) {
          this.publishEngine.shutdown();
          (0, node_opcua_assert_1.assert)(this.publishEngine.subscriptionCount === 0);
          this.publishEngine.dispose();
          this.publishEngine = null;
        }
        this._removeSessionObjectFromAddressSpace();
        (0, node_opcua_assert_1.assert)(!this.sessionDiagnostics, "ServerSession#_removeSessionObjectFromAddressSpace must be called");
        (0, node_opcua_assert_1.assert)(!this.sessionObject, "ServerSession#_removeSessionObjectFromAddressSpace must be called");
      }
      registerNode(nodeId) {
        (0, node_opcua_assert_1.assert)(nodeId instanceof node_opcua_nodeid_1.NodeId);
        if (nodeId.namespace === 0 && nodeId.identifierType === node_opcua_nodeid_1.NodeIdType.NUMERIC) {
          return nodeId;
        }
        const key = nodeId.toString();
        const registeredNode = this._registeredNodes[key];
        if (registeredNode) {
          return registeredNode;
        }
        const node = this.addressSpace.findNode(nodeId);
        if (!node) {
          return nodeId;
        }
        this._registeredNodesCounter += 1;
        const aliasNodeId = (0, node_opcua_nodeid_1.makeNodeId)(this._registeredNodesCounter, registeredNodeNameSpace);
        this._registeredNodes[key] = aliasNodeId;
        this._registeredNodesInv[aliasNodeId.toString()] = node;
        return aliasNodeId;
      }
      unRegisterNode(aliasNodeId) {
        (0, node_opcua_assert_1.assert)(aliasNodeId instanceof node_opcua_nodeid_1.NodeId);
        if (aliasNodeId.namespace !== registeredNodeNameSpace) {
          return;
        }
        const node = this._registeredNodesInv[aliasNodeId.toString()];
        if (!node) {
          return;
        }
        this._registeredNodesInv[aliasNodeId.toString()] = null;
        this._registeredNodes[node.nodeId.toString()] = null;
      }
      resolveRegisteredNode(aliasNodeId) {
        if (aliasNodeId.namespace !== registeredNodeNameSpace) {
          return aliasNodeId;
        }
        const node = this._registeredNodesInv[aliasNodeId.toString()];
        if (!node) {
          return aliasNodeId;
        }
        return node.nodeId;
      }
      /**
       * true if the underlying channel has been closed or aborted...
       */
      get aborted() {
        if (!this.channel) {
          return true;
        }
        return this.channel.aborted;
      }
      createSubscription(parameters) {
        const subscription = this.parent._createSubscriptionOnSession(this, parameters);
        (0, node_opcua_assert_1.assert)(!Object.prototype.hasOwnProperty.call(parameters, "id"));
        this.assignSubscription(subscription);
        (0, node_opcua_assert_1.assert)(subscription.$session === this);
        (0, node_opcua_assert_1.assert)(subscription.sessionId instanceof node_opcua_nodeid_1.NodeId);
        (0, node_opcua_assert_1.assert)((0, node_opcua_nodeid_1.sameNodeId)(subscription.sessionId, this.nodeId));
        return subscription;
      }
      _attach_channel(channel) {
        (0, node_opcua_assert_1.assert)(this.nonce && this.nonce instanceof Buffer);
        this.channel = channel;
        this.channelId = channel.channelId;
        const key = this.authenticationToken.toString();
        (0, node_opcua_assert_1.assert)(!Object.prototype.hasOwnProperty.call(channel.sessionTokens, key), "channel has already a session");
        channel.sessionTokens[key] = this;
        this.channel_abort_event_handler = on_channel_abort.bind(this);
        channel.on("abort", this.channel_abort_event_handler);
      }
      _detach_channel() {
        const channel = this.channel;
        if (!channel) {
          return;
        }
        (0, node_opcua_assert_1.assert)(this.nonce && this.nonce instanceof Buffer);
        (0, node_opcua_assert_1.assert)(this.authenticationToken);
        const key = this.authenticationToken.toString();
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(channel.sessionTokens, key));
        (0, node_opcua_assert_1.assert)(this.channel);
        (0, node_opcua_assert_1.assert)(typeof this.channel_abort_event_handler === "function");
        channel.removeListener("abort", this.channel_abort_event_handler);
        delete channel.sessionTokens[key];
        this.channel = void 0;
        this.channelId = void 0;
      }
      _exposeSubscriptionDiagnostics(subscription) {
        debugLog("ServerSession#_exposeSubscriptionDiagnostics");
        (0, node_opcua_assert_1.assert)(subscription.$session === this);
        const subscriptionDiagnosticsArray = this._getSubscriptionDiagnosticsArray();
        const subscriptionDiagnostics = subscription.subscriptionDiagnostics;
        (0, node_opcua_assert_1.assert)(subscriptionDiagnostics.$subscription === subscription);
        if (subscriptionDiagnostics && subscriptionDiagnosticsArray) {
          (0, node_opcua_address_space_1.addElement)(subscriptionDiagnostics, subscriptionDiagnosticsArray);
        }
      }
      _unexposeSubscriptionDiagnostics(subscription) {
        const subscriptionDiagnosticsArray = this._getSubscriptionDiagnosticsArray();
        const subscriptionDiagnostics = subscription.subscriptionDiagnostics;
        (0, node_opcua_assert_1.assert)(subscriptionDiagnostics instanceof node_opcua_common_1.SubscriptionDiagnosticsDataType);
        if (subscriptionDiagnostics && subscriptionDiagnosticsArray) {
          (0, node_opcua_address_space_1.removeElement)(subscriptionDiagnosticsArray, (a) => a.subscriptionId === subscription.id);
        }
        debugLog("ServerSession#_unexposeSubscriptionDiagnostics");
      }
      /**
       * @method watchdogReset
       * used as a callback for the Watchdog
       * @private
       */
      watchdogReset() {
        debugLog("Session#watchdogReset: the server session has expired and must be removed from the server");
        this.emit("timeout");
      }
      _createSessionObjectInAddressSpace() {
        if (this.sessionObject) {
          return;
        }
        (0, node_opcua_assert_1.assert)(!this.sessionObject, "ServerSession#_createSessionObjectInAddressSpace already called ?");
        this.sessionObject = null;
        if (!this.addressSpace) {
          debugLog("ServerSession#_createSessionObjectInAddressSpace : no addressSpace");
          return;
        }
        const root = this.addressSpace.rootFolder;
        (0, node_opcua_assert_1.assert)(root, "expecting a root object");
        if (!root.objects) {
          debugLog("ServerSession#_createSessionObjectInAddressSpace : no object folder");
          return false;
        }
        if (!root.objects.server) {
          debugLog("ServerSession#_createSessionObjectInAddressSpace : no server object");
          return false;
        }
        const serverDiagnosticsNode = root.objects.server.serverDiagnostics;
        if (!serverDiagnosticsNode || !serverDiagnosticsNode.sessionsDiagnosticsSummary) {
          debugLog("ServerSession#_createSessionObjectInAddressSpace : no serverDiagnostics.sessionsDiagnosticsSummary");
          return false;
        }
        const sessionDiagnosticsObjectType = this.addressSpace.findObjectType("SessionDiagnosticsObjectType");
        const sessionDiagnosticsDataType = this.addressSpace.findDataType("SessionDiagnosticsDataType");
        const sessionDiagnosticsVariableType = this.addressSpace.findVariableType("SessionDiagnosticsVariableType");
        const sessionSecurityDiagnosticsDataType = this.addressSpace.findDataType("SessionSecurityDiagnosticsDataType");
        const sessionSecurityDiagnosticsType = this.addressSpace.findVariableType("SessionSecurityDiagnosticsType");
        const namespace = this.addressSpace.getOwnNamespace();
        function createSessionDiagnosticsStuff() {
          if (sessionDiagnosticsDataType && sessionDiagnosticsVariableType) {
            this._sessionDiagnostics = this.addressSpace.constructExtensionObject(sessionDiagnosticsDataType, {});
            this._sessionDiagnostics.$session = this;
            if (this.parent.clientDescription) {
              this._sessionDiagnostics.clientDescription = this.parent.clientDescription;
            }
            Object.defineProperty(this._sessionDiagnostics, "clientConnectionTime", {
              get() {
                return this.$session.clientConnectionTime;
              }
            });
            Object.defineProperty(this._sessionDiagnostics, "actualSessionTimeout", {
              get() {
                return this.$session?.sessionTimeout;
              }
            });
            Object.defineProperty(this._sessionDiagnostics, "sessionId", {
              get() {
                return this.$session ? this.$session.nodeId : node_opcua_nodeid_1.NodeId.nullNodeId;
              }
            });
            Object.defineProperty(this._sessionDiagnostics, "sessionName", {
              get() {
                return this.$session ? this.$session.sessionName.toString() : "";
              }
            });
            this.sessionDiagnostics = sessionDiagnosticsVariableType.instantiate({
              browseName: new node_opcua_data_model_1.QualifiedName({ name: "SessionDiagnostics", namespaceIndex: 0 }),
              componentOf: this.sessionObject,
              extensionObject: this._sessionDiagnostics,
              minimumSamplingInterval: 2e3
              // 2 seconds
            });
            this._sessionDiagnostics = this.sessionDiagnostics.$extensionObject;
            (0, node_opcua_assert_1.assert)(this._sessionDiagnostics.$session === this);
            const sessionDiagnosticsArray = this.getSessionDiagnosticsArray();
            (0, node_opcua_address_space_1.addElement)(this._sessionDiagnostics, sessionDiagnosticsArray);
          }
        }
        function createSessionSecurityDiagnosticsStuff() {
          if (sessionSecurityDiagnosticsDataType && sessionSecurityDiagnosticsType) {
            this._sessionSecurityDiagnostics = this.addressSpace.constructExtensionObject(sessionSecurityDiagnosticsDataType, {});
            this._sessionSecurityDiagnostics.$session = this;
            Object.defineProperty(this._sessionSecurityDiagnostics, "sessionId", {
              get() {
                return this.$session?.nodeId;
              }
            });
            Object.defineProperty(this._sessionSecurityDiagnostics, "clientUserIdOfSession", {
              get() {
                return "";
              }
            });
            Object.defineProperty(this._sessionSecurityDiagnostics, "clientUserIdHistory", {
              get() {
                return [];
              }
            });
            Object.defineProperty(this._sessionSecurityDiagnostics, "authenticationMechanism", {
              get() {
                return "";
              }
            });
            Object.defineProperty(this._sessionSecurityDiagnostics, "encoding", {
              get() {
                return "";
              }
            });
            Object.defineProperty(this._sessionSecurityDiagnostics, "transportProtocol", {
              get() {
                return "opc.tcp";
              }
            });
            Object.defineProperty(this._sessionSecurityDiagnostics, "securityMode", {
              get() {
                const session = this.$session;
                return session?.channel?.securityMode;
              }
            });
            Object.defineProperty(this._sessionSecurityDiagnostics, "securityPolicyUri", {
              get() {
                const session = this.$session;
                return session?.channel?.securityPolicy;
              }
            });
            Object.defineProperty(this._sessionSecurityDiagnostics, "clientCertificate", {
              get() {
                const session = this.$session;
                return session?.channel.clientCertificate;
              }
            });
            this.sessionSecurityDiagnostics = sessionSecurityDiagnosticsType.instantiate({
              browseName: new node_opcua_data_model_1.QualifiedName({ name: "SessionSecurityDiagnostics", namespaceIndex: 0 }),
              componentOf: this.sessionObject,
              extensionObject: this._sessionSecurityDiagnostics,
              minimumSamplingInterval: 2e3
              // 2 seconds
            });
            (0, node_opcua_address_space_1.ensureObjectIsSecure)(this.sessionSecurityDiagnostics);
            this._sessionSecurityDiagnostics = this.sessionSecurityDiagnostics.$extensionObject;
            (0, node_opcua_assert_1.assert)(this._sessionSecurityDiagnostics.$session === this);
            const sessionSecurityDiagnosticsArray = this.getSessionSecurityDiagnosticsArray();
            const node = (0, node_opcua_address_space_1.addElement)(this._sessionSecurityDiagnostics, sessionSecurityDiagnosticsArray);
            (0, node_opcua_address_space_1.ensureObjectIsSecure)(node);
          }
        }
        function createSessionDiagnosticSummaryUAObject() {
          const references = [];
          if (sessionDiagnosticsObjectType) {
            references.push({
              isForward: true,
              nodeId: sessionDiagnosticsObjectType,
              referenceType: "HasTypeDefinition"
            });
          }
          this.sessionObject = namespace.createNode({
            browseName: this.sessionName || "Session-" + this.nodeId.toString(),
            componentOf: serverDiagnosticsNode.sessionsDiagnosticsSummary,
            nodeClass: node_opcua_data_model_1.NodeClass.Object,
            nodeId: this.nodeId,
            references,
            typeDefinition: sessionDiagnosticsObjectType
          });
          createSessionDiagnosticsStuff.call(this);
          createSessionSecurityDiagnosticsStuff.call(this);
        }
        function createSubscriptionDiagnosticsArray() {
          const subscriptionDiagnosticsArrayType = this.addressSpace.findVariableType("SubscriptionDiagnosticsArrayType");
          (0, node_opcua_assert_1.assert)(subscriptionDiagnosticsArrayType.nodeId.toString() === "ns=0;i=2171");
          this.subscriptionDiagnosticsArray = (0, node_opcua_address_space_1.createExtObjArrayNode)(this.sessionObject, {
            browseName: { namespaceIndex: 0, name: "SubscriptionDiagnosticsArray" },
            complexVariableType: "SubscriptionDiagnosticsArrayType",
            indexPropertyName: "subscriptionId",
            minimumSamplingInterval: 2e3,
            // 2 seconds
            variableType: "SubscriptionDiagnosticsType"
          });
        }
        createSessionDiagnosticSummaryUAObject.call(this);
        createSubscriptionDiagnosticsArray.call(this);
        return this.sessionObject;
      }
      async resendMonitoredItemInitialValues() {
        for (const subscription of this.publishEngine.subscriptions) {
          await subscription.resendInitialValues();
        }
      }
      /**
       *
       * @private
       */
      _removeSessionObjectFromAddressSpace() {
        if (!this.addressSpace) {
          return;
        }
        if (this.sessionDiagnostics) {
          const sessionDiagnosticsArray = this.getSessionDiagnosticsArray();
          (0, node_opcua_address_space_1.removeElement)(sessionDiagnosticsArray, (a) => (0, node_opcua_nodeid_1.sameNodeId)(a.sessionId, this.getSessionId()));
          this.addressSpace.deleteNode(this.sessionDiagnostics);
          (0, node_opcua_assert_1.assert)(this._sessionDiagnostics.$session === this);
          this._sessionDiagnostics.$session = null;
          this._sessionDiagnostics = void 0;
          this.sessionDiagnostics = void 0;
        }
        if (this.sessionSecurityDiagnostics) {
          const sessionSecurityDiagnosticsArray = this.getSessionSecurityDiagnosticsArray();
          (0, node_opcua_address_space_1.removeElement)(sessionSecurityDiagnosticsArray, (a) => (0, node_opcua_nodeid_1.sameNodeId)(a.sessionId, this.getSessionId()));
          this.addressSpace.deleteNode(this.sessionSecurityDiagnostics);
          (0, node_opcua_assert_1.assert)(this._sessionSecurityDiagnostics.$session === this);
          this._sessionSecurityDiagnostics.$session = null;
          this._sessionSecurityDiagnostics = void 0;
          this.sessionSecurityDiagnostics = void 0;
        }
        if (this.sessionObject) {
          this.addressSpace.deleteNode(this.sessionObject);
          this.sessionObject = null;
        }
      }
      /**
       *
       * @private
       */
      _getSubscriptionDiagnosticsArray() {
        if (!this.addressSpace) {
          if (doDebug) {
            console.warn("ServerSession#_getSubscriptionDiagnosticsArray : no addressSpace");
          }
          return null;
        }
        const subscriptionDiagnosticsArray = this.subscriptionDiagnosticsArray;
        if (!subscriptionDiagnosticsArray) {
          return null;
        }
        (0, node_opcua_assert_1.assert)(subscriptionDiagnosticsArray.browseName.toString() === "SubscriptionDiagnosticsArray");
        return subscriptionDiagnosticsArray;
      }
      assignSubscription(subscription) {
        (0, node_opcua_assert_1.assert)(!subscription.$session);
        (0, node_opcua_assert_1.assert)(this.nodeId instanceof node_opcua_nodeid_1.NodeId);
        subscription.$session = this;
        (0, node_opcua_assert_1.assert)(subscription.sessionId === this.nodeId);
        this._cumulatedSubscriptionCount += 1;
        this.emit("new_subscription", subscription);
        this._exposeSubscriptionDiagnostics(subscription);
        subscription.once("terminated", () => {
          this.emit("subscription_terminated", subscription);
        });
      }
      _deleteSubscriptions() {
        if (!this.publishEngine)
          return;
        const subscriptions = this.publishEngine.subscriptions;
        for (const subscription of subscriptions) {
          this.deleteSubscription(subscription.id);
        }
      }
    };
    exports2.ServerSession = ServerSession;
    ServerSession.registry = new node_opcua_object_registry_1.ObjectRegistry();
    ServerSession.maxPublishRequestInQueue = 100;
  }
});

// node_modules/node-opcua-server/dist/server_capabilities.js
var require_server_capabilities2 = __commonJS({
  "node_modules/node-opcua-server/dist/server_capabilities.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ServerCapabilities = exports2.defaultServerCapabilities = exports2.ServerOperationLimits = void 0;
    var node_opcua_binary_stream_1 = require_dist18();
    var node_opcua_debug_1 = require_dist24();
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var ServerOperationLimits = class {
      constructor(options) {
        this.maxNodesPerRead = options.maxNodesPerRead || 0;
        this.maxNodesPerWrite = options.maxNodesPerWrite || 0;
        this.maxNodesPerMethodCall = options.maxNodesPerMethodCall || 0;
        this.maxNodesPerBrowse = options.maxNodesPerBrowse || 0;
        this.maxNodesPerRegisterNodes = options.maxNodesPerRegisterNodes || 0;
        this.maxNodesPerNodeManagement = options.maxNodesPerNodeManagement || 0;
        this.maxMonitoredItemsPerCall = options.maxMonitoredItemsPerCall || 0;
        this.maxNodesPerHistoryReadData = options.maxNodesPerHistoryReadData || 0;
        this.maxNodesPerHistoryReadEvents = options.maxNodesPerHistoryReadEvents || 0;
        this.maxNodesPerHistoryUpdateData = options.maxNodesPerHistoryUpdateData || 0;
        this.maxNodesPerHistoryUpdateEvents = options.maxNodesPerHistoryUpdateEvents || 0;
        this.maxNodesPerTranslateBrowsePathsToNodeIds = options.maxNodesPerTranslateBrowsePathsToNodeIds || 0;
      }
    };
    exports2.ServerOperationLimits = ServerOperationLimits;
    exports2.defaultServerCapabilities = {
      maxBrowseContinuationPoints: 0,
      maxHistoryContinuationPoints: 0,
      maxStringLength: 16 * 1024 * 1024,
      maxArrayLength: 1024 * 1024,
      maxByteStringLength: 16 * 1024 * 1024,
      maxQueryContinuationPoints: 0,
      minSupportedSampleRate: 100,
      operationLimits: {
        maxNodesPerBrowse: 0,
        maxNodesPerHistoryReadData: 0,
        maxNodesPerHistoryReadEvents: 0,
        maxNodesPerHistoryUpdateData: 0,
        maxNodesPerHistoryUpdateEvents: 0,
        maxNodesPerMethodCall: 0,
        maxNodesPerNodeManagement: 0,
        maxNodesPerRead: 0,
        maxNodesPerRegisterNodes: 0,
        maxNodesPerWrite: 0,
        maxNodesPerTranslateBrowsePathsToNodeIds: 0,
        maxMonitoredItemsPerCall: 0
      },
      serverProfileArray: [],
      localeIdArray: [],
      softwareCertificates: [],
      maxSessions: 10,
      maxSubscriptions: 100,
      maxMonitoredItems: 1e6,
      // 1 million
      maxSubscriptionsPerSession: 10,
      maxMonitoredItemsPerSubscription: 1e5,
      // one hundred thousand
      maxSelectClauseParameters: 100,
      maxWhereClauseParameters: 100,
      maxMonitoredItemsQueueSize: 6e4,
      conformanceUnits: []
    };
    var ServerCapabilities = class {
      // eslint-disable-next-line complexity
      constructor(options) {
        options = options || {};
        options.operationLimits = options.operationLimits || {};
        this.serverProfileArray = options.serverProfileArray || [];
        this.localeIdArray = options.localeIdArray || [];
        this.softwareCertificates = options.softwareCertificates || [];
        this.maxArrayLength = options.maxArrayLength || exports2.defaultServerCapabilities.maxArrayLength;
        this.maxStringLength = options.maxStringLength || exports2.defaultServerCapabilities.maxStringLength;
        this.maxByteStringLength = options.maxByteStringLength || exports2.defaultServerCapabilities.maxByteStringLength;
        if (node_opcua_binary_stream_1.BinaryStream.maxStringLength < this.maxStringLength) {
          warningLog(`ServerCapabilities.maxStringLength ${this.maxStringLength} is greater that the allowed limite BinaryStream.maxStringLength = ${node_opcua_binary_stream_1.BinaryStream.maxStringLength}
Please adjust the value.`);
        }
        if (node_opcua_binary_stream_1.BinaryStream.maxByteStringLength < this.maxByteStringLength) {
          warningLog(`ServerCapabilities.maxByteStringLength ${this.maxByteStringLength} is greater that the allowed limite BinaryStream.maxByteStringLength = ${node_opcua_binary_stream_1.BinaryStream.maxByteStringLength}
Please adjust the value.`);
        }
        this.maxBrowseContinuationPoints = options.maxBrowseContinuationPoints || exports2.defaultServerCapabilities.maxBrowseContinuationPoints;
        this.maxQueryContinuationPoints = options.maxQueryContinuationPoints || exports2.defaultServerCapabilities.maxQueryContinuationPoints;
        this.maxHistoryContinuationPoints = options.maxHistoryContinuationPoints || exports2.defaultServerCapabilities.maxHistoryContinuationPoints;
        this.operationLimits = new ServerOperationLimits(options.operationLimits);
        this.minSupportedSampleRate = options.minSupportedSampleRate || exports2.defaultServerCapabilities.minSupportedSampleRate;
        this.maxSessions = options.maxSessions || exports2.defaultServerCapabilities.maxSessions;
        this.maxSubscriptionsPerSession = options.maxSubscriptionsPerSession || exports2.defaultServerCapabilities.maxSubscriptionsPerSession;
        this.maxSubscriptions = options.maxSubscriptions || exports2.defaultServerCapabilities.maxSubscriptions;
        this.maxMonitoredItems = options.maxMonitoredItems || exports2.defaultServerCapabilities.maxMonitoredItems;
        this.maxMonitoredItemsPerSubscription = options.maxMonitoredItemsPerSubscription || exports2.defaultServerCapabilities.maxMonitoredItemsPerSubscription;
        this.maxSelectClauseParameters = options.maxSelectClauseParameters || exports2.defaultServerCapabilities.maxSelectClauseParameters;
        this.maxWhereClauseParameters = options.maxWhereClauseParameters || exports2.defaultServerCapabilities.maxWhereClauseParameters;
        this.maxMonitoredItemsQueueSize = options.maxMonitoredItemsQueueSize || exports2.defaultServerCapabilities.maxMonitoredItemsQueueSize;
        this.conformanceUnits = options.conformanceUnits || exports2.defaultServerCapabilities.conformanceUnits;
      }
    };
    exports2.ServerCapabilities = ServerCapabilities;
  }
});

// node_modules/node-opcua-server/dist/history_server_capabilities.js
var require_history_server_capabilities = __commonJS({
  "node_modules/node-opcua-server/dist/history_server_capabilities.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.HistoryServerCapabilities = void 0;
    var node_opcua_assert_1 = require_dist14();
    var HistoryServerCapabilities = class {
      constructor(options) {
        options = options || {};
        function coerceBool(value, defaultValue) {
          if (void 0 === value) {
            return defaultValue;
          }
          (0, node_opcua_assert_1.assert)(typeof value === "boolean");
          return value;
        }
        function coerceUInt32(value, defaultValue) {
          if (void 0 === value) {
            return defaultValue;
          }
          (0, node_opcua_assert_1.assert)(typeof value === "number");
          return value;
        }
        this.accessHistoryDataCapability = coerceBool(options.accessHistoryDataCapability, false);
        this.accessHistoryEventsCapability = coerceBool(options.accessHistoryEventsCapability, false);
        this.maxReturnDataValues = coerceUInt32(options.maxReturnDataValues, 0);
        this.maxReturnEventValues = coerceUInt32(options.maxReturnEventValues, 0);
        this.insertDataCapability = coerceBool(options.insertDataCapability, false);
        this.replaceDataCapability = coerceBool(options.replaceDataCapability, false);
        this.updateDataCapability = coerceBool(options.updateDataCapability, false);
        this.deleteRawCapability = coerceBool(options.deleteRawCapability, false);
        this.deleteAtTimeCapability = coerceBool(options.deleteAtTimeCapability, false);
        this.insertEventCapability = coerceBool(options.insertEventCapability, false);
        this.replaceEventCapability = coerceBool(options.replaceEventCapability, false);
        this.updateEventCapability = coerceBool(options.updateEventCapability, false);
        this.deleteEventCapability = coerceBool(options.deleteEventCapability, false);
        this.insertAnnotationCapability = coerceBool(options.insertAnnotationCapability, false);
      }
    };
    exports2.HistoryServerCapabilities = HistoryServerCapabilities;
  }
});

// node_modules/node-opcua-server/dist/server_publish_engine_for_orphan_subscriptions.js
var require_server_publish_engine_for_orphan_subscriptions = __commonJS({
  "node_modules/node-opcua-server/dist/server_publish_engine_for_orphan_subscriptions.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ServerSidePublishEngineForOrphanSubscription = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_debug_1 = require_dist24();
    var server_publish_engine_1 = require_server_publish_engine();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var ServerSidePublishEngineForOrphanSubscription = class extends server_publish_engine_1.ServerSidePublishEngine {
      constructor(options) {
        super(options);
      }
      add_subscription(subscription) {
        debugLog(chalk_1.default.bgCyan.yellow.bold(" adding live subscription with id="), subscription.id, " to orphan");
        subscription.$session = void 0;
        super.add_subscription(subscription);
        subscription._expired_func = function() {
          debugLog(chalk_1.default.bgCyan.yellow(" Removing expired subscription with id="), this.id, " from orphan");
        };
        subscription.once("expired", subscription._expired_func);
        return subscription;
      }
      detach_subscription(subscription) {
        super.detach_subscription(subscription);
        subscription.removeListener("expired", subscription._expired_func);
        subscription._expired_func = null;
        return subscription;
      }
    };
    exports2.ServerSidePublishEngineForOrphanSubscription = ServerSidePublishEngineForOrphanSubscription;
  }
});

// node_modules/node-opcua-server/dist/sessions_compatible_for_transfer.js
var require_sessions_compatible_for_transfer = __commonJS({
  "node_modules/node-opcua-server/dist/sessions_compatible_for_transfer.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.sessionsCompatibleForTransfer = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_types_1 = require_dist32();
    function sessionsCompatibleForTransfer(sessionSrc, sessionDest) {
      if (!sessionSrc) {
        return true;
      }
      (0, node_opcua_assert_1.assert)(sessionDest);
      (0, node_opcua_assert_1.assert)(sessionSrc);
      if (!sessionSrc.userIdentityToken && !sessionDest.userIdentityToken) {
        return true;
      }
      if (sessionSrc.userIdentityToken instanceof node_opcua_types_1.AnonymousIdentityToken) {
        if (!(sessionDest.userIdentityToken instanceof node_opcua_types_1.AnonymousIdentityToken)) {
          return false;
        }
        return true;
      } else if (sessionSrc.userIdentityToken instanceof node_opcua_types_1.UserNameIdentityToken) {
        if (!(sessionDest.userIdentityToken instanceof node_opcua_types_1.UserNameIdentityToken)) {
          return false;
        }
        return sessionSrc.userIdentityToken.userName === sessionDest.userIdentityToken.userName;
      } else if (sessionSrc.userIdentityToken instanceof node_opcua_types_1.X509IdentityToken) {
        if (!(sessionDest.userIdentityToken instanceof node_opcua_types_1.X509IdentityToken)) {
          return false;
        }
        return sessionSrc.userIdentityToken.certificateData.toString("hex") === sessionDest.userIdentityToken.certificateData.toString("hex");
      } else {
        throw new Error("Unsupported Identity token");
      }
    }
    exports2.sessionsCompatibleForTransfer = sessionsCompatibleForTransfer;
  }
});

// node_modules/node-opcua-server/dist/addressSpace_accessor.js
var require_addressSpace_accessor = __commonJS({
  "node_modules/node-opcua-server/dist/addressSpace_accessor.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AddressSpaceAccessor = void 0;
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_address_space_1 = require_index_current();
    var node_opcua_assert_1 = __importDefault3(require_dist14());
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_date_time_1 = require_dist17();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_pki_1 = require_lib18();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_variant_1 = require_dist28();
    function checkReadProcessedDetails(historyReadDetails) {
      if (!historyReadDetails.aggregateConfiguration) {
        historyReadDetails.aggregateConfiguration = new node_opcua_types_1.AggregateConfiguration({
          useServerCapabilitiesDefaults: true
        });
      }
      if (historyReadDetails.aggregateConfiguration.useServerCapabilitiesDefaults) {
        return node_opcua_status_code_1.StatusCodes.Good;
      }
      if (historyReadDetails.aggregateConfiguration.percentDataGood < 100 - historyReadDetails.aggregateConfiguration.percentDataBad) {
        return node_opcua_status_code_1.StatusCodes.BadAggregateInvalidInputs;
      }
      if (historyReadDetails.aggregateConfiguration.percentDataGood > 100 || historyReadDetails.aggregateConfiguration.percentDataGood < 0) {
        return node_opcua_status_code_1.StatusCodes.BadAggregateInvalidInputs;
      }
      if (historyReadDetails.aggregateConfiguration.percentDataBad > 100 || historyReadDetails.aggregateConfiguration.percentDataBad < 0) {
        return node_opcua_status_code_1.StatusCodes.BadAggregateInvalidInputs;
      }
      return node_opcua_status_code_1.StatusCodes.Good;
    }
    var AddressSpaceAccessor = class {
      constructor(addressSpace) {
        this.addressSpace = addressSpace;
      }
      async browse(context, nodesToBrowse) {
        const results = [];
        for (const browseDescription of nodesToBrowse) {
          results.push(await this.browseNode(browseDescription, context));
          (0, node_opcua_assert_1.default)(browseDescription.nodeId, "expecting a nodeId");
        }
        return results;
      }
      async read(context, readRequest) {
        readRequest.maxAge = readRequest.maxAge || 0;
        const timestampsToReturn = readRequest.timestampsToReturn;
        const nodesToRead = readRequest.nodesToRead || [];
        context.currentTime = (0, node_opcua_date_time_1.getCurrentClock)();
        const dataValues = [];
        for (const readValueId of nodesToRead) {
          const dataValue = await this.readNode(context, readValueId, readRequest.maxAge, timestampsToReturn);
          dataValues.push(dataValue);
        }
        return dataValues;
      }
      async write(context, nodesToWrite) {
        context.currentTime = (0, node_opcua_date_time_1.getCurrentClock)();
        await (0, node_opcua_address_space_1.ensureDatatypeExtracted)(this.addressSpace);
        const results = [];
        for (const writeValue of nodesToWrite) {
          const statusCode = await this.writeNode(context, writeValue);
          results.push(statusCode);
        }
        return results;
      }
      async call(context, methodsToCall) {
        const results = [];
        await (0, node_opcua_address_space_1.ensureDatatypeExtracted)(this.addressSpace);
        for (const methodToCall of methodsToCall) {
          const result2 = await this.callMethod(context, methodToCall);
          results.push(result2);
        }
        return results;
      }
      async historyRead(context, historyReadRequest) {
        (0, node_opcua_assert_1.default)(context instanceof node_opcua_address_space_1.SessionContext);
        (0, node_opcua_assert_1.default)(historyReadRequest instanceof node_opcua_types_1.HistoryReadRequest);
        const timestampsToReturn = historyReadRequest.timestampsToReturn;
        const historyReadDetails = historyReadRequest.historyReadDetails;
        const releaseContinuationPoints = historyReadRequest.releaseContinuationPoints;
        (0, node_opcua_assert_1.default)(historyReadDetails instanceof node_opcua_types_1.HistoryReadDetails);
        const nodesToRead = historyReadRequest.nodesToRead || [];
        (0, node_opcua_assert_1.default)(Array.isArray(nodesToRead));
        const _q = async (m2) => {
          const continuationPoint = m2.nodeToRead.continuationPoint;
          return await this.historyReadNode(context, m2.nodeToRead, m2.processDetail, timestampsToReturn, {
            continuationPoint,
            releaseContinuationPoints
          });
        };
        if (historyReadDetails instanceof node_opcua_types_1.ReadProcessedDetails) {
          if (!historyReadDetails.aggregateType || historyReadDetails.aggregateType.length !== nodesToRead.length) {
            return [new node_opcua_types_1.HistoryReadResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadInvalidArgument })];
          }
          const parameterStatus = checkReadProcessedDetails(historyReadDetails);
          if (parameterStatus !== node_opcua_status_code_1.StatusCodes.Good) {
            return [new node_opcua_types_1.HistoryReadResult({ statusCode: parameterStatus })];
          }
          const promises2 = [];
          let index2 = 0;
          for (const nodeToRead of nodesToRead) {
            const aggregateType = historyReadDetails.aggregateType[index2];
            const processDetail = new node_opcua_types_1.ReadProcessedDetails({ ...historyReadDetails, aggregateType: [aggregateType] });
            promises2.push(_q({ nodeToRead, processDetail, index: index2 }));
            index2++;
          }
          const results = await Promise.all(promises2);
          return results;
        }
        const _r = async (nodeToRead, index2) => {
          const continuationPoint = nodeToRead.continuationPoint;
          return await this.historyReadNode(context, nodeToRead, historyReadDetails, timestampsToReturn, {
            continuationPoint,
            releaseContinuationPoints
          });
        };
        const promises = [];
        let index = 0;
        for (const nodeToRead of nodesToRead) {
          promises.push(_r(nodeToRead, index));
          index++;
        }
        const result2 = await Promise.all(promises);
        return result2;
      }
      async browseNode(browseDescription, context) {
        if (!this.addressSpace) {
          throw new Error("Address Space has not been initialized");
        }
        const nodeId = (0, node_opcua_nodeid_1.resolveNodeId)(browseDescription.nodeId);
        const r = this.addressSpace.browseSingleNode(nodeId, browseDescription instanceof node_opcua_types_1.BrowseDescription ? browseDescription : new node_opcua_types_1.BrowseDescription({ ...browseDescription, nodeId }), context);
        return r;
      }
      async readNode(context, nodeToRead, maxAge, timestampsToReturn) {
        (0, node_opcua_assert_1.default)(context instanceof node_opcua_address_space_1.SessionContext);
        const nodeId = (0, node_opcua_nodeid_1.resolveNodeId)(nodeToRead.nodeId);
        const attributeId = nodeToRead.attributeId;
        const indexRange = nodeToRead.indexRange;
        const dataEncoding = nodeToRead.dataEncoding;
        if (timestampsToReturn === node_opcua_data_value_1.TimestampsToReturn.Invalid) {
          return new node_opcua_data_value_1.DataValue({ statusCode: node_opcua_status_code_1.StatusCodes.BadTimestampsToReturnInvalid });
        }
        timestampsToReturn = (0, node_opcua_data_value_1.coerceTimestampsToReturn)(timestampsToReturn);
        const obj = this.__findNode((0, node_opcua_nodeid_1.coerceNodeId)(nodeId));
        let dataValue;
        if (!obj) {
          return new node_opcua_data_value_1.DataValue({ statusCode: node_opcua_status_code_1.StatusCodes.BadNodeIdUnknown });
        } else {
          dataValue = obj.readAttribute(context, attributeId, indexRange, dataEncoding);
          dataValue = (0, node_opcua_data_value_1.apply_timestamps_no_copy)(dataValue, timestampsToReturn, attributeId);
          if (timestampsToReturn === node_opcua_data_value_1.TimestampsToReturn.Server) {
            dataValue.sourceTimestamp = null;
            dataValue.sourcePicoseconds = 0;
          }
          if ((timestampsToReturn === node_opcua_data_value_1.TimestampsToReturn.Both || timestampsToReturn === node_opcua_data_value_1.TimestampsToReturn.Server) && (!dataValue.serverTimestamp || dataValue.serverTimestamp.getTime() === node_opcua_date_time_1.minOPCUADate.getTime())) {
            const t = context.currentTime ? context.currentTime.timestamp : (0, node_opcua_date_time_1.getCurrentClock)().timestamp;
            dataValue.serverTimestamp = t;
            dataValue.serverPicoseconds = 0;
          }
          return dataValue;
        }
      }
      __findNode(nodeId) {
        const namespaceIndex = nodeId.namespace || 0;
        if (namespaceIndex && namespaceIndex >= (this.addressSpace?.getNamespaceArray().length || 0)) {
          return null;
        }
        const namespace = this.addressSpace.getNamespace(namespaceIndex);
        return namespace.findNode2(nodeId);
      }
      async writeNode(context, writeValue) {
        await (0, node_opcua_address_space_1.resolveOpaqueOnAddressSpace)(this.addressSpace, writeValue.value.value);
        (0, node_opcua_assert_1.default)(context instanceof node_opcua_address_space_1.SessionContext);
        (0, node_opcua_assert_1.default)(writeValue.schema.name === "WriteValue");
        (0, node_opcua_assert_1.default)(writeValue.value instanceof node_opcua_data_value_1.DataValue);
        if (!writeValue.value.value) {
          return node_opcua_status_code_1.StatusCodes.BadTypeMismatch;
        }
        (0, node_opcua_assert_1.default)(writeValue.value.value instanceof node_opcua_variant_1.Variant);
        const nodeId = writeValue.nodeId;
        const obj = this.__findNode(nodeId);
        if (!obj) {
          return node_opcua_status_code_1.StatusCodes.BadNodeIdUnknown;
        } else {
          return await new Promise((resolve2, reject) => {
            obj.writeAttribute(context, writeValue, (err, statusCode) => {
              if (err) {
                reject(err);
              } else {
                resolve2(statusCode);
              }
            });
          });
        }
      }
      async callMethod(context, methodToCall) {
        return await new Promise((resolve2, reject) => {
          (0, node_opcua_address_space_1.callMethodHelper)(context, this.addressSpace, methodToCall, (err, result2) => {
            if (err) {
              reject(err);
            } else {
              resolve2(result2);
            }
          });
        });
      }
      async historyReadNode(context, nodeToRead, historyReadDetails, timestampsToReturn, continuationData) {
        (0, node_opcua_assert_1.default)(context instanceof node_opcua_address_space_1.SessionContext);
        if (timestampsToReturn === node_opcua_data_value_1.TimestampsToReturn.Invalid) {
          return new node_opcua_types_1.HistoryReadResult({
            statusCode: node_opcua_status_code_1.StatusCodes.BadTimestampsToReturnInvalid
          });
        }
        const nodeId = nodeToRead.nodeId;
        const indexRange = nodeToRead.indexRange;
        const dataEncoding = nodeToRead.dataEncoding;
        const continuationPoint = nodeToRead.continuationPoint;
        timestampsToReturn = (0, node_opcua_data_value_1.coerceTimestampsToReturn)(timestampsToReturn);
        if (timestampsToReturn === node_opcua_data_value_1.TimestampsToReturn.Invalid) {
          return new node_opcua_types_1.HistoryReadResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadTimestampsToReturnInvalid });
        }
        const obj = this.__findNode(nodeId);
        if (!obj) {
          return new node_opcua_types_1.HistoryReadResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadNodeIdUnknown });
        } else {
          if (!obj.historyRead) {
            const msg = " this node doesn't provide historyRead! probably not a UAVariable\n " + obj.nodeId.toString() + " " + obj.browseName.toString() + "\nwith " + nodeToRead.toString() + "\nHistoryReadDetails " + historyReadDetails.toString();
            if (node_opcua_pki_1.doDebug) {
              (0, node_opcua_pki_1.debugLog)(chalk_1.default.cyan("ServerEngine#_historyReadNode "), chalk_1.default.white.bold(msg));
            }
            throw new Error(msg);
          }
          const result2 = await obj.historyRead(context, historyReadDetails, indexRange, dataEncoding, continuationData);
          (0, node_opcua_assert_1.default)(result2.isValid());
          return result2;
        }
      }
    };
    exports2.AddressSpaceAccessor = AddressSpaceAccessor;
  }
});

// node_modules/node-opcua-server/dist/server_engine.js
var require_server_engine = __commonJS({
  "node_modules/node-opcua-server/dist/server_engine.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ServerEngine = void 0;
    var events_1 = require("events");
    var util_1 = require("util");
    var async_1 = __importDefault3(require_async());
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_binary_stream_1 = require_dist18();
    var node_opcua_address_space_1 = require_index_current();
    var nodeJS_1 = require_nodeJS();
    var node_opcua_common_1 = require_dist34();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_date_time_1 = require_dist17();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_nodesets_1 = require_dist52();
    var node_opcua_object_registry_1 = require_dist46();
    var node_opcua_service_call_1 = require_dist41();
    var node_opcua_service_subscription_1 = require_dist45();
    var node_opcua_service_endpoints_1 = require_dist44();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_variant_1 = require_dist28();
    var history_server_capabilities_1 = require_history_server_capabilities();
    var monitored_item_1 = require_monitored_item();
    var server_capabilities_1 = require_server_capabilities2();
    var server_publish_engine_1 = require_server_publish_engine();
    var server_publish_engine_for_orphan_subscriptions_1 = require_server_publish_engine_for_orphan_subscriptions();
    var server_session_1 = require_server_session();
    var server_subscription_1 = require_server_subscription();
    var sessions_compatible_for_transfer_1 = require_sessions_compatible_for_transfer();
    var addressSpace_accessor_1 = require_addressSpace_accessor();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    function upperCaseFirst(str) {
      return str.slice(0, 1).toUpperCase() + str.slice(1);
    }
    async function shutdownAndDisposeAddressSpace() {
      if (this.addressSpace) {
        await this.addressSpace.shutdown();
        this.addressSpace.dispose();
        delete this.addressSpace;
      }
    }
    function setSubscriptionDurable(inputArguments, context, callback) {
      (0, node_opcua_assert_1.assert)(typeof callback === "function");
      const data = _getSubscription.call(this, inputArguments, context);
      if (data.statusCode)
        return callback(null, { statusCode: data.statusCode });
      const { subscription } = data;
      const lifetimeInHours = inputArguments[1].value;
      if (subscription.monitoredItemCount > 0) {
        return callback(null, { statusCode: node_opcua_status_code_1.StatusCodes.BadInvalidState });
      }
      const highestLifetimeInHours = 24 * 100;
      const revisedLifetimeInHours = lifetimeInHours === 0 ? highestLifetimeInHours : Math.max(1, Math.min(lifetimeInHours, highestLifetimeInHours));
      const currentLifeTimeInHours = subscription.lifeTimeCount * subscription.publishingInterval / (1e3 * 60 * 60);
      if (currentLifeTimeInHours < revisedLifetimeInHours) {
        const requestedLifetimeCount = Math.ceil(revisedLifetimeInHours * (1e3 * 60 * 60) / subscription.publishingInterval);
        subscription.modify({
          requestedMaxKeepAliveCount: subscription.maxKeepAliveCount,
          requestedPublishingInterval: subscription.publishingInterval,
          maxNotificationsPerPublish: subscription.maxNotificationsPerPublish,
          priority: subscription.priority,
          requestedLifetimeCount
        });
      }
      const callMethodResult = new node_opcua_service_call_1.CallMethodResult({
        statusCode: node_opcua_status_code_1.StatusCodes.Good,
        outputArguments: [{ dataType: node_opcua_variant_1.DataType.UInt32, arrayType: node_opcua_variant_1.VariantArrayType.Scalar, value: revisedLifetimeInHours }]
      });
      callback(null, callMethodResult);
    }
    function requestServerStateChange(inputArguments, context, callback) {
      (0, node_opcua_assert_1.assert)(Array.isArray(inputArguments));
      (0, node_opcua_assert_1.assert)(typeof callback === "function");
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(context, "session"), " expecting a session id in the context object");
      const session = context.session;
      if (!session) {
        return callback(null, { statusCode: node_opcua_status_code_1.StatusCodes.BadInternalError });
      }
      return callback(null, { statusCode: node_opcua_status_code_1.StatusCodes.BadNotImplemented });
    }
    function _getSubscription(inputArguments, context) {
      (0, node_opcua_assert_1.assert)(Array.isArray(inputArguments));
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(context, "session"), " expecting a session id in the context object");
      const session = context.session;
      if (!session) {
        return { statusCode: node_opcua_status_code_1.StatusCodes.BadInternalError };
      }
      const subscriptionId = inputArguments[0].value;
      const subscription = session.getSubscription(subscriptionId);
      if (!subscription) {
        if (this.findSubscription(subscriptionId)) {
          return { statusCode: node_opcua_status_code_1.StatusCodes.BadUserAccessDenied };
        }
        return { statusCode: node_opcua_status_code_1.StatusCodes.BadSubscriptionIdInvalid };
      }
      return { subscription };
    }
    function resendData(inputArguments, context, callback) {
      (0, node_opcua_assert_1.assert)(typeof callback === "function");
      const data = _getSubscription.call(this, inputArguments, context);
      if (data.statusCode)
        return callback(null, { statusCode: data.statusCode });
      const { subscription } = data;
      subscription.resendInitialValues().then(() => {
        callback(null, { statusCode: node_opcua_status_code_1.StatusCodes.Good });
      }).catch((err) => callback(err));
    }
    function getMonitoredItemsId(inputArguments, context, callback) {
      (0, node_opcua_assert_1.assert)(typeof callback === "function");
      const data = _getSubscription.call(this, inputArguments, context);
      if (data.statusCode)
        return callback(null, { statusCode: data.statusCode });
      const { subscription } = data;
      const result2 = subscription.getMonitoredItems();
      (0, node_opcua_assert_1.assert)(result2.statusCode);
      (0, node_opcua_assert_1.assert)(result2.serverHandles.length === result2.clientHandles.length);
      const callMethodResult = new node_opcua_service_call_1.CallMethodResult({
        statusCode: result2.statusCode,
        outputArguments: [
          { dataType: node_opcua_variant_1.DataType.UInt32, arrayType: node_opcua_variant_1.VariantArrayType.Array, value: result2.serverHandles },
          { dataType: node_opcua_variant_1.DataType.UInt32, arrayType: node_opcua_variant_1.VariantArrayType.Array, value: result2.clientHandles }
        ]
      });
      callback(null, callMethodResult);
    }
    function __bindVariable(self2, nodeId, options) {
      options = options || {};
      const variable = self2.addressSpace.findNode(nodeId);
      if (variable && variable.bindVariable) {
        variable.bindVariable(options, true);
        (0, node_opcua_assert_1.assert)(typeof variable.asyncRefresh === "function");
        (0, node_opcua_assert_1.assert)(typeof variable.refreshFunc === "function");
      } else {
        warningLog("Warning: cannot bind object with id ", nodeId.toString(), " please check your nodeset.xml file or add this node programmatically");
      }
    }
    var next_subscriptionId = Math.ceil(Math.random() * 1e6);
    function _get_next_subscriptionId() {
      debugLog(" next_subscriptionId = ", next_subscriptionId);
      return next_subscriptionId++;
    }
    var ServerEngine = class _ServerEngine extends events_1.EventEmitter {
      constructor(options) {
        super();
        this.addressSpaceAccessor = null;
        this._globalCounter = { totalMonitoredItemCount: 0 };
        options = options || { applicationUri: "" };
        options.buildInfo = options.buildInfo || {};
        _ServerEngine.registry.register(this);
        this._sessions = {};
        this._closedSessions = {};
        this._orphanPublishEngine = void 0;
        this.isAuditing = typeof options.isAuditing === "boolean" ? options.isAuditing : false;
        options.buildInfo.buildDate = options.buildInfo.buildDate || /* @__PURE__ */ new Date();
        this._serverStatus = new node_opcua_common_1.ServerStatusDataType({
          buildInfo: options.buildInfo,
          currentTime: /* @__PURE__ */ new Date(),
          secondsTillShutdown: 0,
          shutdownReason: { text: "" },
          startTime: /* @__PURE__ */ new Date(),
          state: node_opcua_common_1.ServerState.NoConfiguration
        });
        options.serverCapabilities = options.serverCapabilities || {};
        options.serverConfiguration = options.serverConfiguration || {
          supportedPrivateKeyFormat: ["PEM"]
        };
        options.serverCapabilities.serverProfileArray = options.serverCapabilities.serverProfileArray || [
          "http://opcfoundation.org/UA-Profile/Server/Standard",
          // Standard UA Server Profile",
          "http://opcfoundation.org/UA-Profile/Server/DataAccess",
          "http://opcfoundation.org/UA-Profile/Server/Events",
          "http://opcfoundation.org/UA-Profile/Client/HistoricalAccess",
          "http://opcfoundation.org/UA-Profile/Server/Methods",
          "http://opcfoundation.org/UA-Profile/Server/StandardEventSubscription",
          "http://opcfoundation.org/UA-Profile/Transport/uatcp-uasc-uabinary",
          "http://opcfoundation.org/UA-Profile/Server/FileAccess",
          "http://opcfoundation.org/UA-Profile/Server/StateMachine"
          // "http://opcfoundation.org/UA-Profile/Transport/wss-uajson",
          // "http://opcfoundation.org/UA-Profile/Transport/wss-uasc-uabinary"
          // "http://opcfoundation.org/UA-Profile/Server/DurableSubscription"
          // "http://opcfoundation.org/UA-Profile/Server/ReverseConnect",
          // "http://opcfoundation.org/UAProfile/Server/NodeManagement",
          //  "Embedded UA Server Profile",
          // "Micro Embedded Device Server Profile",
          // "Nano Embedded Device Server Profile"
        ];
        options.serverCapabilities.localeIdArray = options.serverCapabilities.localeIdArray || ["en-EN", "fr-FR"];
        this.serverCapabilities = new server_capabilities_1.ServerCapabilities(options.serverCapabilities);
        this.serverCapabilities.softwareCertificates = [
          // new SignedSoftwareCertificate({})
        ];
        this.serverCapabilities.__defineGetter__("minSupportedSampleRate", () => {
          return monitored_item_1.MonitoredItem.minimumSamplingInterval;
        });
        this.serverConfiguration = options.serverConfiguration;
        this.historyServerCapabilities = new history_server_capabilities_1.HistoryServerCapabilities(options.historyServerCapabilities);
        this.serverDiagnosticsSummary = new node_opcua_common_1.ServerDiagnosticsSummaryDataType();
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(this.serverDiagnosticsSummary, "currentSessionCount"));
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(this.serverDiagnosticsSummary, "currentSubscriptionCount"));
        this.serverDiagnosticsSummary.__defineGetter__("currentSubscriptionCount", () => {
          let counter = 0;
          Object.values(this._sessions).forEach((session) => {
            counter += session.currentSubscriptionCount;
          });
          counter += this._orphanPublishEngine ? this._orphanPublishEngine.subscriptions.length : 0;
          return counter;
        });
        this._internalState = "creating";
        this.setServerState(node_opcua_common_1.ServerState.NoConfiguration);
        this.addressSpace = null;
        this._shutdownTasks = [];
        this._applicationUri = "";
        if (typeof options.applicationUri === "function") {
          this.__defineGetter__("_applicationUri", options.applicationUri);
        } else {
          this._applicationUri = options.applicationUri || "<unset _applicationUri>";
        }
        options.serverDiagnosticsEnabled = Object.prototype.hasOwnProperty.call(options, "serverDiagnosticsEnable") ? options.serverDiagnosticsEnabled : true;
        this.serverDiagnosticsEnabled = options.serverDiagnosticsEnabled;
      }
      isStarted() {
        return !!this._serverStatus;
      }
      dispose() {
        this.addressSpace = null;
        (0, node_opcua_assert_1.assert)(Object.keys(this._sessions).length === 0, "ServerEngine#_sessions not empty");
        this._sessions = {};
        this._closedSessions = {};
        (0, node_opcua_assert_1.assert)(Object.keys(this._closedSessions).length === 0, "ServerEngine#_closedSessions not empty");
        this._closedSessions = {};
        if (this._orphanPublishEngine) {
          this._orphanPublishEngine.dispose();
          this._orphanPublishEngine = void 0;
        }
        this._shutdownTasks = [];
        this._serverStatus = null;
        this._internalState = "disposed";
        this.removeAllListeners();
        _ServerEngine.registry.unregister(this);
      }
      get startTime() {
        return this._serverStatus.startTime;
      }
      get currentTime() {
        return this._serverStatus.currentTime;
      }
      get buildInfo() {
        return this._serverStatus.buildInfo;
      }
      /**
       * register a function that will be called when the server will perform its shut down.
       * @method registerShutdownTask
       */
      registerShutdownTask(task) {
        (0, node_opcua_assert_1.assert)(typeof task === "function");
        this._shutdownTasks.push(task);
      }
      /**
       * @method shutdown
       */
      async shutdown() {
        debugLog("ServerEngine#shutdown");
        this._internalState = "shutdown";
        this.setServerState(node_opcua_common_1.ServerState.Shutdown);
        const tokens = Object.keys(this._sessions).map((key) => {
          const session = this._sessions[key];
          return session.authenticationToken;
        });
        if (this._orphanPublishEngine) {
          this._orphanPublishEngine.shutdown();
        }
        for (const token of tokens) {
          this.closeSession(token, true, "Terminated");
        }
        (0, node_opcua_assert_1.assert)(this.currentSessionCount === 0);
        (0, node_opcua_assert_1.assert)(this.currentSubscriptionCount === 0, "all subscriptions must have been terminated");
        this._shutdownTasks.push(shutdownAndDisposeAddressSpace);
        for (const task of this._shutdownTasks) {
          await task.call(this);
        }
        this.dispose();
      }
      /**
       * the number of active sessions
       */
      get currentSessionCount() {
        return this.serverDiagnosticsSummary.currentSessionCount;
      }
      /**
       * the cumulated number of sessions that have been opened since this object exists
       */
      get cumulatedSessionCount() {
        return this.serverDiagnosticsSummary.cumulatedSessionCount;
      }
      /**
       * the number of active subscriptions.
       */
      get currentSubscriptionCount() {
        return this.serverDiagnosticsSummary.currentSubscriptionCount;
      }
      /**
       * the cumulated number of subscriptions that have been created since this object exists
       */
      get cumulatedSubscriptionCount() {
        return this.serverDiagnosticsSummary.cumulatedSubscriptionCount;
      }
      get rejectedSessionCount() {
        return this.serverDiagnosticsSummary.rejectedSessionCount;
      }
      get rejectedRequestsCount() {
        return this.serverDiagnosticsSummary.rejectedRequestsCount;
      }
      get sessionAbortCount() {
        return this.serverDiagnosticsSummary.sessionAbortCount;
      }
      get sessionTimeoutCount() {
        return this.serverDiagnosticsSummary.sessionTimeoutCount;
      }
      get publishingIntervalCount() {
        return this.serverDiagnosticsSummary.publishingIntervalCount;
      }
      incrementSessionTimeoutCount() {
        if (this.serverDiagnosticsSummary && this.serverDiagnosticsEnabled) {
          this.serverDiagnosticsSummary.sessionTimeoutCount += 1;
        }
      }
      incrementSessionAbortCount() {
        if (this.serverDiagnosticsSummary && this.serverDiagnosticsEnabled) {
          this.serverDiagnosticsSummary.sessionAbortCount += 1;
        }
      }
      incrementRejectedRequestsCount() {
        if (this.serverDiagnosticsSummary && this.serverDiagnosticsEnabled) {
          this.serverDiagnosticsSummary.rejectedRequestsCount += 1;
        }
      }
      /**
       * increment rejected session count (also increment rejected requests count)
       */
      incrementRejectedSessionCount() {
        if (this.serverDiagnosticsSummary && this.serverDiagnosticsEnabled) {
          this.serverDiagnosticsSummary.rejectedSessionCount += 1;
        }
        this.incrementRejectedRequestsCount();
      }
      incrementSecurityRejectedRequestsCount() {
        if (this.serverDiagnosticsSummary && this.serverDiagnosticsEnabled) {
          this.serverDiagnosticsSummary.securityRejectedRequestsCount += 1;
        }
        this.incrementRejectedRequestsCount();
      }
      /**
       * increment rejected session count (also increment rejected requests count)
       */
      incrementSecurityRejectedSessionCount() {
        if (this.serverDiagnosticsSummary && this.serverDiagnosticsEnabled) {
          this.serverDiagnosticsSummary.securityRejectedSessionCount += 1;
        }
        this.incrementSecurityRejectedRequestsCount();
      }
      setShutdownTime(date) {
        this._expectedShutdownTime = date;
      }
      setShutdownReason(reason) {
        this.addressSpace?.rootFolder.objects.server.serverStatus.shutdownReason.setValueFromSource({
          dataType: node_opcua_variant_1.DataType.LocalizedText,
          value: (0, node_opcua_data_model_1.coerceLocalizedText)(reason)
        });
      }
      /**
       * @method secondsTillShutdown
       * @return the approximate number of seconds until the server will be shut down. The
       * value is only relevant once the state changes into SHUTDOWN.
       */
      secondsTillShutdown() {
        if (!this._expectedShutdownTime) {
          return 0;
        }
        const now = Date.now();
        return Math.max(0, Math.ceil((this._expectedShutdownTime.getTime() - now) / 1e3));
      }
      /**
       * the name of the server
       */
      get serverName() {
        return this._serverStatus.buildInfo.productName;
      }
      /**
       * the server urn
       */
      get serverNameUrn() {
        return this._applicationUri;
      }
      /**
       * the urn of the server namespace
       */
      get serverNamespaceUrn() {
        return this._applicationUri;
      }
      get serverStatus() {
        return this._serverStatus;
      }
      setServerState(serverState) {
        (0, node_opcua_assert_1.assert)(serverState !== null && serverState !== void 0);
        this.addressSpace?.rootFolder?.objects?.server?.serverStatus?.state?.setValueFromSource({
          dataType: node_opcua_variant_1.DataType.Int32,
          value: serverState
        });
      }
      getServerDiagnosticsEnabledFlag() {
        const server = this.addressSpace.rootFolder.objects.server;
        const serverDiagnostics = server.getComponentByName("ServerDiagnostics");
        if (!serverDiagnostics) {
          return false;
        }
        return serverDiagnostics.readValue().value.value;
      }
      /**
       * @method initialize
       * @async
       *
       * @param options {Object}
       * @param options.nodeset_filename {String} - [option](default : 'mini.Node.Set2.xml' )
       * @param callback
       */
      initialize(options, callback) {
        (0, node_opcua_assert_1.assert)(!this.addressSpace);
        this._internalState = "initializing";
        options = options || {};
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        options.nodeset_filename = options.nodeset_filename || node_opcua_nodesets_1.nodesets.standard;
        const startTime = /* @__PURE__ */ new Date();
        debugLog("Loading ", options.nodeset_filename, "...");
        this.addressSpace = node_opcua_address_space_1.AddressSpace.create();
        this.addressSpaceAccessor = new addressSpace_accessor_1.AddressSpaceAccessor(this.addressSpace);
        if (!options.skipOwnNamespace) {
          const serverNamespace = this.addressSpace.registerNamespace(this.serverNamespaceUrn);
          (0, node_opcua_assert_1.assert)(serverNamespace.index === 1);
        }
        (0, nodeJS_1.generateAddressSpace)(this.addressSpace, options.nodeset_filename, () => {
          if (!this.addressSpace) {
            throw new Error("Internal error");
          }
          const addressSpace = this.addressSpace;
          const endTime = /* @__PURE__ */ new Date();
          debugLog("Loading ", options.nodeset_filename, " done : ", endTime.getTime() - startTime.getTime(), " ms");
          const bindVariableIfPresent = (nodeId, opts) => {
            (0, node_opcua_assert_1.assert)(!nodeId.isEmpty());
            const obj = addressSpace.findNode(nodeId);
            if (obj) {
              __bindVariable(this, nodeId, opts);
            }
            return obj;
          };
          const server_NamespaceArray_Id = (0, node_opcua_nodeid_1.makeNodeId)(node_opcua_constants_1.VariableIds.Server_NamespaceArray);
          bindVariableIfPresent(server_NamespaceArray_Id, {
            get() {
              return new node_opcua_variant_1.Variant({
                arrayType: node_opcua_variant_1.VariantArrayType.Array,
                dataType: node_opcua_variant_1.DataType.String,
                value: addressSpace.getNamespaceArray().map((x2) => x2.namespaceUri)
              });
            },
            set: null
            // read only
          });
          const server_NameUrn_var = new node_opcua_variant_1.Variant({
            arrayType: node_opcua_variant_1.VariantArrayType.Array,
            dataType: node_opcua_variant_1.DataType.String,
            value: [
              this.serverNameUrn
              // this is us !
            ]
          });
          const server_ServerArray_Id = (0, node_opcua_nodeid_1.makeNodeId)(node_opcua_constants_1.VariableIds.Server_ServerArray);
          bindVariableIfPresent(server_ServerArray_Id, {
            get() {
              return server_NameUrn_var;
            },
            set: null
            // read only
          });
          const namespaces = (0, node_opcua_nodeid_1.makeNodeId)(node_opcua_constants_1.ObjectIds.Server_Namespaces);
          const namespacesNode = addressSpace.findNode(namespaces);
          if (namespacesNode) {
            for (const ns of namespacesNode.getComponents()) {
              const defaultUserRolePermissions = ns.getChildByName("DefaultUserRolePermissions");
              if (defaultUserRolePermissions) {
                defaultUserRolePermissions.setValueFromSource({ dataType: node_opcua_variant_1.DataType.Null });
              }
              const defaultRolePermissions = ns.getChildByName("DefaultRolePermissions");
              if (defaultRolePermissions) {
                defaultRolePermissions.setValueFromSource({ dataType: node_opcua_variant_1.DataType.Null });
              }
            }
          }
          const bindStandardScalar = (id, dataType, func, setter_func) => {
            (0, node_opcua_assert_1.assert)(typeof id === "number", "expecting id to be a number");
            (0, node_opcua_assert_1.assert)(typeof func === "function");
            (0, node_opcua_assert_1.assert)(typeof setter_func === "function" || !setter_func);
            (0, node_opcua_assert_1.assert)(dataType !== null);
            let setter_func2 = null;
            if (setter_func) {
              setter_func2 = (variant) => {
                const variable2 = !!variant.value;
                setter_func(variable2);
                return node_opcua_status_code_1.StatusCodes.Good;
              };
            }
            const nodeId = (0, node_opcua_nodeid_1.makeNodeId)(id);
            if (!(0, node_opcua_variant_1.isValidVariant)(node_opcua_variant_1.VariantArrayType.Scalar, dataType, func())) {
              errorLog("func", func());
              throw new Error("bindStandardScalar : func doesn't provide an value of type " + node_opcua_variant_1.DataType[dataType]);
            }
            return bindVariableIfPresent(nodeId, {
              get() {
                return new node_opcua_variant_1.Variant({
                  arrayType: node_opcua_variant_1.VariantArrayType.Scalar,
                  dataType,
                  value: func()
                });
              },
              set: setter_func2
            });
          };
          const bindStandardArray = (id, variantDataType, dataType, func) => {
            (0, node_opcua_assert_1.assert)(typeof func === "function");
            (0, node_opcua_assert_1.assert)(variantDataType !== null);
            const nodeId = (0, node_opcua_nodeid_1.makeNodeId)(id);
            (0, node_opcua_assert_1.assert)((0, node_opcua_variant_1.isValidVariant)(node_opcua_variant_1.VariantArrayType.Array, variantDataType, func()));
            bindVariableIfPresent(nodeId, {
              get() {
                const value = func();
                (0, node_opcua_assert_1.assert)(Array.isArray(value));
                return new node_opcua_variant_1.Variant({
                  arrayType: node_opcua_variant_1.VariantArrayType.Array,
                  dataType: variantDataType,
                  value
                });
              },
              set: null
              // read only
            });
          };
          bindStandardScalar(node_opcua_constants_1.VariableIds.Server_EstimatedReturnTime, node_opcua_variant_1.DataType.DateTime, () => node_opcua_date_time_1.minOPCUADate);
          const timeZoneDataType = addressSpace.findDataType((0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_constants_1.DataTypeIds.TimeZoneDataType));
          const timeZone = new node_opcua_types_1.TimeZoneDataType({
            daylightSavingInOffset: (
              /* boolean*/
              false
            ),
            offset: (
              /* int16 */
              0
            )
          });
          bindStandardScalar(node_opcua_constants_1.VariableIds.Server_LocalTime, node_opcua_variant_1.DataType.ExtensionObject, () => {
            return timeZone;
          });
          bindStandardScalar(node_opcua_constants_1.VariableIds.Server_ServiceLevel, node_opcua_variant_1.DataType.Byte, () => {
            return 255;
          });
          bindStandardScalar(node_opcua_constants_1.VariableIds.Server_Auditing, node_opcua_variant_1.DataType.Boolean, () => {
            return this.isAuditing;
          });
          const engine = this;
          const makeNotReadableIfEnabledFlagIsFalse = (variable) => {
            const originalIsReadable = variable.isReadable;
            variable.isUserReadable = checkReadableFlag;
            function checkReadableFlag(context) {
              const isEnabled = engine.serverDiagnosticsEnabled;
              return originalIsReadable.call(this, context) && isEnabled;
            }
            for (const c2 of variable.getAggregates()) {
              if (c2.nodeClass === node_opcua_data_model_1.NodeClass.Variable) {
                makeNotReadableIfEnabledFlagIsFalse(c2);
              }
            }
          };
          const bindServerDiagnostics = () => {
            bindStandardScalar(node_opcua_constants_1.VariableIds.Server_ServerDiagnostics_EnabledFlag, node_opcua_variant_1.DataType.Boolean, () => {
              return this.serverDiagnosticsEnabled;
            }, (newFlag) => {
              this.serverDiagnosticsEnabled = newFlag;
            });
            const nodeId = (0, node_opcua_nodeid_1.makeNodeId)(node_opcua_constants_1.VariableIds.Server_ServerDiagnostics_ServerDiagnosticsSummary);
            const serverDiagnosticsSummaryNode = addressSpace.findNode(nodeId);
            if (serverDiagnosticsSummaryNode) {
              serverDiagnosticsSummaryNode.bindExtensionObject(this.serverDiagnosticsSummary);
              this.serverDiagnosticsSummary = serverDiagnosticsSummaryNode.$extensionObject;
              makeNotReadableIfEnabledFlagIsFalse(serverDiagnosticsSummaryNode);
            }
          };
          const bindServerStatus = () => {
            const serverStatusNode = addressSpace.findNode((0, node_opcua_nodeid_1.makeNodeId)(node_opcua_constants_1.VariableIds.Server_ServerStatus));
            if (!serverStatusNode) {
              return;
            }
            if (serverStatusNode) {
              serverStatusNode.bindExtensionObject(this._serverStatus);
              serverStatusNode.minimumSamplingInterval = 1e3;
            }
            const currentTimeNode = addressSpace.findNode((0, node_opcua_nodeid_1.makeNodeId)(node_opcua_constants_1.VariableIds.Server_ServerStatus_CurrentTime));
            if (currentTimeNode) {
              currentTimeNode.minimumSamplingInterval = 1e3;
            }
            const secondsTillShutdown = addressSpace.findNode((0, node_opcua_nodeid_1.makeNodeId)(node_opcua_constants_1.VariableIds.Server_ServerStatus_SecondsTillShutdown));
            if (secondsTillShutdown) {
              secondsTillShutdown.minimumSamplingInterval = 1e3;
            }
            (0, node_opcua_assert_1.assert)(serverStatusNode.$extensionObject);
            serverStatusNode.$extensionObject = new Proxy(serverStatusNode.$extensionObject, {
              get(target, prop) {
                if (prop === "currentTime") {
                  serverStatusNode.currentTime.touchValue();
                  return /* @__PURE__ */ new Date();
                } else if (prop === "secondsTillShutdown") {
                  serverStatusNode.secondsTillShutdown.touchValue();
                  return engine.secondsTillShutdown();
                }
                return target[prop];
              }
            });
            this._serverStatus = serverStatusNode.$extensionObject;
          };
          const bindServerCapabilities = () => {
            bindStandardArray(node_opcua_constants_1.VariableIds.Server_ServerCapabilities_ServerProfileArray, node_opcua_variant_1.DataType.String, node_opcua_variant_1.DataType.String, () => {
              return this.serverCapabilities.serverProfileArray;
            });
            bindStandardArray(node_opcua_constants_1.VariableIds.Server_ServerCapabilities_LocaleIdArray, node_opcua_variant_1.DataType.String, "LocaleId", () => {
              return this.serverCapabilities.localeIdArray;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MinSupportedSampleRate, node_opcua_variant_1.DataType.Double, () => {
              return this.serverCapabilities.minSupportedSampleRate;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxBrowseContinuationPoints, node_opcua_variant_1.DataType.UInt16, () => {
              return this.serverCapabilities.maxBrowseContinuationPoints;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxQueryContinuationPoints, node_opcua_variant_1.DataType.UInt16, () => {
              return this.serverCapabilities.maxQueryContinuationPoints;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxHistoryContinuationPoints, node_opcua_variant_1.DataType.UInt16, () => {
              return this.serverCapabilities.maxHistoryContinuationPoints;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxSessions, node_opcua_variant_1.DataType.UInt32, () => {
              return this.serverCapabilities.maxSessions;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxSubscriptions, node_opcua_variant_1.DataType.UInt32, () => {
              return this.serverCapabilities.maxSubscriptions;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxMonitoredItems, node_opcua_variant_1.DataType.UInt32, () => {
              return this.serverCapabilities.maxMonitoredItems;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxSubscriptionsPerSession, node_opcua_variant_1.DataType.UInt32, () => {
              return this.serverCapabilities.maxSubscriptionsPerSession;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxSelectClauseParameters, node_opcua_variant_1.DataType.UInt32, () => {
              return this.serverCapabilities.maxSelectClauseParameters;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxWhereClauseParameters, node_opcua_variant_1.DataType.UInt32, () => {
              return this.serverCapabilities.maxWhereClauseParameters;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxMonitoredItemsPerSubscription, node_opcua_variant_1.DataType.UInt32, () => {
              return this.serverCapabilities.maxMonitoredItemsPerSubscription;
            });
            bindStandardArray(node_opcua_constants_1.VariableIds.Server_ServerCapabilities_SoftwareCertificates, node_opcua_variant_1.DataType.ExtensionObject, "SoftwareCertificates", () => {
              return this.serverCapabilities.softwareCertificates;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxArrayLength, node_opcua_variant_1.DataType.UInt32, () => {
              return Math.min(this.serverCapabilities.maxArrayLength, node_opcua_variant_1.Variant.maxArrayLength);
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxStringLength, node_opcua_variant_1.DataType.UInt32, () => {
              return Math.min(this.serverCapabilities.maxStringLength, node_opcua_binary_stream_1.BinaryStream.maxStringLength);
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxByteStringLength, node_opcua_variant_1.DataType.UInt32, () => {
              return Math.min(this.serverCapabilities.maxByteStringLength, node_opcua_binary_stream_1.BinaryStream.maxByteStringLength);
            });
            const bindOperationLimits = (operationLimits) => {
              (0, node_opcua_assert_1.assert)(operationLimits !== null && typeof operationLimits === "object");
              const keys = Object.keys(operationLimits);
              keys.forEach((key) => {
                const uid = "Server_ServerCapabilities_OperationLimits_" + upperCaseFirst(key);
                const nodeId = (0, node_opcua_nodeid_1.makeNodeId)(node_opcua_constants_1.VariableIds[uid]);
                (0, node_opcua_assert_1.assert)(!nodeId.isEmpty());
                bindStandardScalar(node_opcua_constants_1.VariableIds[uid], node_opcua_variant_1.DataType.UInt32, () => {
                  return operationLimits[key];
                });
              });
            };
            bindOperationLimits(this.serverCapabilities.operationLimits);
            function fix_ProgramStateMachineType_ProgramDiagnostics() {
              const nodeId = (0, node_opcua_nodeid_1.coerceNodeId)("i=2399");
              const variable = addressSpace.findNode(nodeId);
              if (variable) {
                variable.$extensionObject = new node_opcua_types_1.ProgramDiagnosticDataType({});
              }
            }
            fix_ProgramStateMachineType_ProgramDiagnostics();
          };
          const bindHistoryServerCapabilities = () => {
            bindStandardScalar(node_opcua_constants_1.VariableIds.HistoryServerCapabilities_MaxReturnDataValues, node_opcua_variant_1.DataType.UInt32, () => {
              return this.historyServerCapabilities.maxReturnDataValues;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.HistoryServerCapabilities_MaxReturnEventValues, node_opcua_variant_1.DataType.UInt32, () => {
              return this.historyServerCapabilities.maxReturnEventValues;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.HistoryServerCapabilities_AccessHistoryDataCapability, node_opcua_variant_1.DataType.Boolean, () => {
              return this.historyServerCapabilities.accessHistoryDataCapability;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.HistoryServerCapabilities_AccessHistoryEventsCapability, node_opcua_variant_1.DataType.Boolean, () => {
              return this.historyServerCapabilities.accessHistoryEventsCapability;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.HistoryServerCapabilities_InsertDataCapability, node_opcua_variant_1.DataType.Boolean, () => {
              return this.historyServerCapabilities.insertDataCapability;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.HistoryServerCapabilities_ReplaceDataCapability, node_opcua_variant_1.DataType.Boolean, () => {
              return this.historyServerCapabilities.replaceDataCapability;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.HistoryServerCapabilities_UpdateDataCapability, node_opcua_variant_1.DataType.Boolean, () => {
              return this.historyServerCapabilities.updateDataCapability;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.HistoryServerCapabilities_InsertEventCapability, node_opcua_variant_1.DataType.Boolean, () => {
              return this.historyServerCapabilities.insertEventCapability;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.HistoryServerCapabilities_ReplaceEventCapability, node_opcua_variant_1.DataType.Boolean, () => {
              return this.historyServerCapabilities.replaceEventCapability;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.HistoryServerCapabilities_UpdateEventCapability, node_opcua_variant_1.DataType.Boolean, () => {
              return this.historyServerCapabilities.updateEventCapability;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.HistoryServerCapabilities_DeleteEventCapability, node_opcua_variant_1.DataType.Boolean, () => {
              return this.historyServerCapabilities.deleteEventCapability;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.HistoryServerCapabilities_DeleteRawCapability, node_opcua_variant_1.DataType.Boolean, () => {
              return this.historyServerCapabilities.deleteRawCapability;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.HistoryServerCapabilities_DeleteAtTimeCapability, node_opcua_variant_1.DataType.Boolean, () => {
              return this.historyServerCapabilities.deleteAtTimeCapability;
            });
            bindStandardScalar(node_opcua_constants_1.VariableIds.HistoryServerCapabilities_InsertAnnotationCapability, node_opcua_variant_1.DataType.Boolean, () => {
              return this.historyServerCapabilities.insertAnnotationCapability;
            });
          };
          function r(a, defaultValue) {
            if (a === void 0)
              return defaultValue;
            if (typeof a === "function") {
              return a();
            }
            return a;
          }
          const bindServerConfigurationBasic = () => {
            bindStandardArray(node_opcua_constants_1.VariableIds.ServerConfiguration_ServerCapabilities, node_opcua_variant_1.DataType.String, node_opcua_variant_1.DataType.String, () => r(this.serverConfiguration.serverCapabilities, ["NA"]));
            bindStandardScalar(node_opcua_constants_1.VariableIds.ServerConfiguration_ApplicationType, node_opcua_variant_1.DataType.Int32, () => r(this.serverConfiguration.applicationType, node_opcua_types_1.ApplicationType.Server));
            bindStandardScalar(node_opcua_constants_1.VariableIds.ServerConfiguration_ApplicationUri, node_opcua_variant_1.DataType.String, () => r(this.serverConfiguration.applicationUri, ""));
            bindStandardScalar(node_opcua_constants_1.VariableIds.ServerConfiguration_ProductUri, node_opcua_variant_1.DataType.String, () => r(this.serverConfiguration.productUri, ""));
            bindStandardScalar(node_opcua_constants_1.VariableIds.ServerConfiguration_HasSecureElement, node_opcua_variant_1.DataType.Boolean, () => r(this.serverConfiguration.hasSecureElement, false));
            bindStandardScalar(node_opcua_constants_1.VariableIds.ServerConfiguration_MulticastDnsEnabled, node_opcua_variant_1.DataType.Boolean, () => r(this.serverConfiguration.multicastDnsEnabled, false));
            bindStandardArray(node_opcua_constants_1.VariableIds.ServerConfiguration_SupportedPrivateKeyFormats, node_opcua_variant_1.DataType.String, node_opcua_variant_1.DataType.String, () => r(this.serverConfiguration.supportedPrivateKeyFormat, ["PEM"]));
          };
          bindServerDiagnostics();
          bindServerStatus();
          bindServerCapabilities();
          bindServerConfigurationBasic();
          bindHistoryServerCapabilities();
          const bindExtraStuff = () => {
          };
          bindExtraStuff();
          this.__internal_bindMethod((0, node_opcua_nodeid_1.makeNodeId)(node_opcua_constants_1.MethodIds.Server_GetMonitoredItems), getMonitoredItemsId.bind(this));
          this.__internal_bindMethod((0, node_opcua_nodeid_1.makeNodeId)(node_opcua_constants_1.MethodIds.Server_SetSubscriptionDurable), setSubscriptionDurable.bind(this));
          this.__internal_bindMethod((0, node_opcua_nodeid_1.makeNodeId)(node_opcua_constants_1.MethodIds.Server_ResendData), resendData.bind(this));
          this.__internal_bindMethod((0, node_opcua_nodeid_1.makeNodeId)(node_opcua_constants_1.MethodIds.Server_RequestServerStateChange), requestServerStateChange.bind(this));
          const fixGetMonitoredItemArgs = () => {
            const objects = this.addressSpace.rootFolder?.objects;
            if (!objects || !objects.server || !objects.server.getMonitoredItems) {
              return;
            }
            const outputArguments = objects.server.getMonitoredItems.outputArguments;
            const dataValue = outputArguments.readValue();
            (0, node_opcua_assert_1.assert)(dataValue.value.value[0].arrayDimensions.length === 1 && dataValue.value.value[0].arrayDimensions[0] === 0);
            (0, node_opcua_assert_1.assert)(dataValue.value.value[1].arrayDimensions.length === 1 && dataValue.value.value[1].arrayDimensions[0] === 0);
          };
          fixGetMonitoredItemArgs();
          const prepareServerDiagnostics = () => {
            const addressSpace1 = this.addressSpace;
            if (!addressSpace1.rootFolder.objects) {
              return;
            }
            const server = addressSpace1.rootFolder.objects.server;
            if (!server) {
              return;
            }
            const serverDiagnosticsNode = server.getComponentByName("ServerDiagnostics");
            if (!serverDiagnosticsNode) {
              return;
            }
            if (true) {
              serverDiagnosticsNode.enabledFlag.userAccessLevel = (0, node_opcua_data_model_1.makeAccessLevelFlag)("CurrentRead");
              serverDiagnosticsNode.enabledFlag.accessLevel = (0, node_opcua_data_model_1.makeAccessLevelFlag)("CurrentRead");
            }
            const samplingIntervalDiagnosticsArray = serverDiagnosticsNode.getComponentByName("SamplingIntervalDiagnosticsArray");
            if (samplingIntervalDiagnosticsArray) {
              addressSpace.deleteNode(samplingIntervalDiagnosticsArray);
              const s = serverDiagnosticsNode.getComponents();
            }
            const subscriptionDiagnosticsArrayNode = serverDiagnosticsNode.getComponentByName("SubscriptionDiagnosticsArray");
            (0, node_opcua_assert_1.assert)(subscriptionDiagnosticsArrayNode.nodeClass === node_opcua_data_model_1.NodeClass.Variable);
            (0, node_opcua_address_space_1.bindExtObjArrayNode)(subscriptionDiagnosticsArrayNode, "SubscriptionDiagnosticsType", "subscriptionId");
            makeNotReadableIfEnabledFlagIsFalse(subscriptionDiagnosticsArrayNode);
            const sessionsDiagnosticsSummary = serverDiagnosticsNode.getComponentByName("SessionsDiagnosticsSummary");
            const sessionDiagnosticsArray = sessionsDiagnosticsSummary.getComponentByName("SessionDiagnosticsArray");
            (0, node_opcua_assert_1.assert)(sessionDiagnosticsArray.nodeClass === node_opcua_data_model_1.NodeClass.Variable);
            (0, node_opcua_address_space_1.bindExtObjArrayNode)(sessionDiagnosticsArray, "SessionDiagnosticsVariableType", "sessionId");
            const varType = addressSpace.findVariableType("SessionSecurityDiagnosticsType");
            if (!varType) {
              debugLog("Warning cannot find SessionSecurityDiagnosticsType variable Type");
            } else {
              const sessionSecurityDiagnosticsArray = sessionsDiagnosticsSummary.getComponentByName("SessionSecurityDiagnosticsArray");
              (0, node_opcua_assert_1.assert)(sessionSecurityDiagnosticsArray.nodeClass === node_opcua_data_model_1.NodeClass.Variable);
              (0, node_opcua_address_space_1.bindExtObjArrayNode)(sessionSecurityDiagnosticsArray, "SessionSecurityDiagnosticsType", "sessionId");
              (0, node_opcua_address_space_1.ensureObjectIsSecure)(sessionSecurityDiagnosticsArray);
            }
          };
          prepareServerDiagnostics();
          this._internalState = "initialized";
          this.setServerState(node_opcua_common_1.ServerState.Running);
          setImmediate(() => callback());
        });
      }
      async browseWithAutomaticExpansion(nodesToBrowse, context) {
        for (const browseDescription of nodesToBrowse) {
          const nodeId = (0, node_opcua_nodeid_1.resolveNodeId)(browseDescription.nodeId);
          const node = this.addressSpace.findNode(nodeId);
          if (node) {
            if (node.onFirstBrowseAction) {
              try {
                await node.onFirstBrowseAction();
                node.onFirstBrowseAction = void 0;
              } catch (err) {
                if (util_1.types.isNativeError(err)) {
                  errorLog("onFirstBrowseAction method has failed", err.message);
                }
                errorLog(err);
              }
              (0, node_opcua_assert_1.assert)(node.onFirstBrowseAction === void 0, "expansion can only be made once");
            }
          }
        }
        return await this.browse(context, nodesToBrowse);
      }
      async browse(context, nodesToBrowse) {
        return this.addressSpaceAccessor.browse(context, nodesToBrowse);
      }
      async read(context, readRequest) {
        return this.addressSpaceAccessor.read(context, readRequest);
      }
      async write(context, nodesToWrite) {
        return await this.addressSpaceAccessor.write(context, nodesToWrite);
      }
      async call(context, methodsToCall) {
        return await this.addressSpaceAccessor.call(context, methodsToCall);
      }
      async historyRead(context, historyReadRequest) {
        return this.addressSpaceAccessor.historyRead(context, historyReadRequest);
      }
      getOldestInactiveSession() {
        let tmp = Object.values(this._sessions).filter((session1) => session1.status === "screwed" || session1.status === "disposed" || session1.status === "closed");
        if (tmp.length === 0) {
          tmp = Object.values(this._sessions).filter((session1) => session1.status === "new");
        }
        if (tmp.length === 0)
          return null;
        let session = tmp[0];
        for (let i = 1; i < tmp.length; i++) {
          const c2 = tmp[i];
          if (session.creationDate.getTime() < c2.creationDate.getTime()) {
            session = c2;
          }
        }
        return session;
      }
      /**
       * create a new server session object.
       * @class ServerEngine
       * @method createSession
       * @param  [options] {Object}
       * @param  [options.sessionTimeout = 1000] {Number} sessionTimeout
       * @param  [options.clientDescription] {ApplicationDescription}
       * @return {ServerSession}
       */
      createSession(options) {
        options = options || {};
        options.server = options.server || {};
        debugLog("createSession : increasing serverDiagnosticsSummary cumulatedSessionCount/currentSessionCount ");
        this.serverDiagnosticsSummary.cumulatedSessionCount += 1;
        this.serverDiagnosticsSummary.currentSessionCount += 1;
        this.clientDescription = options.clientDescription || new node_opcua_service_endpoints_1.ApplicationDescription({});
        const sessionTimeout = options.sessionTimeout || 1e3;
        (0, node_opcua_assert_1.assert)(typeof sessionTimeout === "number");
        const session = new server_session_1.ServerSession(this, options.server.userManager, sessionTimeout);
        debugLog("createSession :sessionTimeout = ", session.sessionTimeout);
        const key = session.authenticationToken.toString();
        this._sessions[key] = session;
        session.on("new_subscription", (subscription) => {
          this.serverDiagnosticsSummary.cumulatedSubscriptionCount += 1;
        });
        session.on("subscription_terminated", (subscription) => {
        });
        session.on("timeout", () => {
          this.serverDiagnosticsSummary.sessionTimeoutCount += 1;
          session.sessionName = session.sessionName || "";
          const channel = session.channel;
          errorLog(chalk_1.default.cyan("Server: closing SESSION "), session.status, chalk_1.default.yellow(session.sessionName), chalk_1.default.yellow(session.nodeId.toString()), chalk_1.default.cyan(" because of timeout = "), session.sessionTimeout, chalk_1.default.cyan(" has expired without a keep alive"), chalk_1.default.bgCyan("channel = "), channel?.remoteAddress, " port = ", channel?.remotePort);
          this.closeSession(
            session.authenticationToken,
            /*deleteSubscription=*/
            false,
            /* reason =*/
            "Timeout"
          );
          this.incrementSessionTimeoutCount();
        });
        return session;
      }
      /**
       * @method closeSession
       * @param authenticationToken
       * @param deleteSubscriptions {Boolean} : true if session's subscription shall be deleted
       * @param {String} [reason = "CloseSession"] the reason for closing the session (
       *                 shall be "Timeout", "Terminated" or "CloseSession")
       *
       *
       * what the specs say:
       * -------------------
       *
       * If a Client invokes the CloseSession Service then all Subscriptions associated with the Session are also deleted
       * if the deleteSubscriptions flag is set to TRUE. If a Server terminates a Session for any other reason,
       * Subscriptions associated with the Session, are not deleted. Each Subscription has its own lifetime to protect
       * against data loss in the case of a Session termination. In these cases, the Subscription can be reassigned to
       * another Client before its lifetime expires.
       */
      closeSession(authenticationToken, deleteSubscriptions, reason) {
        reason = reason || "CloseSession";
        (0, node_opcua_assert_1.assert)(typeof reason === "string");
        (0, node_opcua_assert_1.assert)(reason === "Timeout" || reason === "Terminated" || reason === "CloseSession" || reason === "Forcing");
        debugLog("ServerEngine.closeSession ", authenticationToken.toString(), deleteSubscriptions);
        const session = this.getSession(authenticationToken);
        if (!session) {
          throw new Error("cannot find session with this authenticationToken " + authenticationToken.toString());
        }
        if (!deleteSubscriptions) {
          if (!this._orphanPublishEngine) {
            this._orphanPublishEngine = new server_publish_engine_for_orphan_subscriptions_1.ServerSidePublishEngineForOrphanSubscription({ maxPublishRequestInQueue: 0 });
          }
          debugLog("transferring remaining live subscription to orphanPublishEngine !");
          server_publish_engine_1.ServerSidePublishEngine.transferSubscriptionsToOrphan(session.publishEngine, this._orphanPublishEngine);
        }
        session.close(deleteSubscriptions, reason);
        (0, node_opcua_assert_1.assert)(session.status === "closed");
        debugLog(" engine.serverDiagnosticsSummary.currentSessionCount -= 1;");
        this.serverDiagnosticsSummary.currentSessionCount -= 1;
        delete this._sessions[authenticationToken.toString()];
        session.dispose();
      }
      findSubscription(subscriptionId) {
        const subscriptions = [];
        Object.values(this._sessions).map((session) => {
          if (subscriptions.length) {
            return;
          }
          const subscription = session.publishEngine.getSubscriptionById(subscriptionId);
          if (subscription) {
            subscriptions.push(subscription);
          }
        });
        if (subscriptions.length) {
          (0, node_opcua_assert_1.assert)(subscriptions.length === 1);
          return subscriptions[0];
        }
        return this.findOrphanSubscription(subscriptionId);
      }
      findOrphanSubscription(subscriptionId) {
        if (!this._orphanPublishEngine) {
          return null;
        }
        return this._orphanPublishEngine.getSubscriptionById(subscriptionId);
      }
      deleteOrphanSubscription(subscription) {
        if (!this._orphanPublishEngine) {
          return node_opcua_status_code_1.StatusCodes.BadInternalError;
        }
        (0, node_opcua_assert_1.assert)(this.findSubscription(subscription.id));
        const c2 = this._orphanPublishEngine.subscriptionCount;
        subscription.terminate();
        subscription.dispose();
        (0, node_opcua_assert_1.assert)(this._orphanPublishEngine.subscriptionCount === c2 - 1);
        return node_opcua_status_code_1.StatusCodes.Good;
      }
      /**
       * @method transferSubscription
       * @param session           {ServerSession}  - the new session that will own the subscription
       * @param subscriptionId    {IntegerId}      - the subscription Id to transfer
       * @param sendInitialValues {Boolean}        - true if initial values will be resent.
       * @return                  {TransferResult}
       */
      async transferSubscription(session, subscriptionId, sendInitialValues) {
        if (subscriptionId <= 0) {
          return new node_opcua_service_subscription_1.TransferResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadSubscriptionIdInvalid });
        }
        const subscription = this.findSubscription(subscriptionId);
        if (!subscription) {
          return new node_opcua_service_subscription_1.TransferResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadSubscriptionIdInvalid });
        }
        if (!(0, sessions_compatible_for_transfer_1.sessionsCompatibleForTransfer)(subscription.$session, session)) {
          return new node_opcua_service_subscription_1.TransferResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadUserAccessDenied });
        }
        subscription.subscriptionDiagnostics.transferRequestCount++;
        if (session.publishEngine === subscription.publishEngine) {
          return new node_opcua_service_subscription_1.TransferResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadNothingToDo });
        }
        if (session === subscription.$session) {
          return new node_opcua_service_subscription_1.TransferResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadNothingToDo });
        }
        subscription.subscriptionDiagnostics.transferredToAltClientCount++;
        subscription.subscriptionDiagnostics.transferredToSameClientCount++;
        const nbSubscriptionBefore = session.publishEngine.subscriptionCount;
        if (subscription.$session) {
          subscription.$session._unexposeSubscriptionDiagnostics(subscription);
        }
        subscription.$session = session;
        await server_publish_engine_1.ServerSidePublishEngine.transferSubscription(subscription, session.publishEngine, sendInitialValues);
        session._exposeSubscriptionDiagnostics(subscription);
        (0, node_opcua_assert_1.assert)(subscription.publishEngine === session.publishEngine);
        const result2 = new node_opcua_service_subscription_1.TransferResult({
          availableSequenceNumbers: subscription.getAvailableSequenceNumbers(),
          statusCode: node_opcua_status_code_1.StatusCodes.Good
        });
        if (doDebug) {
          debugLog("TransferResult", result2.toString());
        }
        return result2;
      }
      /**
       * retrieve a session by its authenticationToken.
       *
       * @method getSession
       * @param authenticationToken
       * @param activeOnly
       * @return {ServerSession}
       */
      getSession(authenticationToken, activeOnly) {
        if (!authenticationToken || authenticationToken.identifierType && authenticationToken.identifierType !== node_opcua_nodeid_1.NodeIdType.BYTESTRING) {
          return null;
        }
        const key = authenticationToken.toString();
        let session = this._sessions[key];
        if (!activeOnly && !session) {
          session = this._closedSessions[key];
        }
        return session;
      }
      async translateBrowsePaths(browsePaths) {
        const browsePathResults = [];
        for (const browsePath of browsePaths) {
          const result2 = await this.translateBrowsePath(browsePath);
          browsePathResults.push(result2);
        }
        return browsePathResults;
      }
      async translateBrowsePath(browsePath) {
        return this.addressSpace.browsePath(browsePath);
      }
      /**
       *
       * performs a call to ```asyncRefresh``` on all variable nodes that provide an async refresh func.
       *
       * @method refreshValues
       * @param nodesToRefresh {Array<ReadValueId|HistoryReadValueId>}  an array containing the node to consider
       * Each element of the array shall be of the form { nodeId: <xxx>, attributeIds: <value> }.
       * @param maxAge {number}  the maximum age of the value to be read, in milliseconds.
       * @param callback
       * @param callback.err       {Error}
       * @param callback.dataValue {DataValue}  an array containing value read
       * The array length matches the number of  nodeIds that are candidate for an async refresh (i.e: nodes that
       * are of type Variable with asyncRefresh func }
       *
       * @async
       */
      refreshValues(nodesToRefresh, maxAge, callback) {
        const referenceTime = (0, node_opcua_date_time_1.getCurrentClock)();
        maxAge && referenceTime.timestamp.setTime(referenceTime.timestamp.getTime() - maxAge);
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        const nodeMap = {};
        for (const nodeToRefresh of nodesToRefresh) {
          if (nodeToRefresh instanceof node_opcua_types_1.ReadValueId && nodeToRefresh.attributeId !== node_opcua_data_model_1.AttributeIds.Value) {
            continue;
          }
          const uaNode = this.addressSpace.findNode(nodeToRefresh.nodeId);
          if (!uaNode || !(uaNode.nodeClass === node_opcua_data_model_1.NodeClass.Variable)) {
            continue;
          }
          if (typeof uaNode.refreshFunc !== "function") {
            continue;
          }
          const key = uaNode.nodeId.toString();
          if (nodeMap[key]) {
            continue;
          }
          nodeMap[key] = uaNode;
        }
        const uaVariableArray = Object.values(nodeMap);
        if (uaVariableArray.length === 0) {
          return callback(null, []);
        }
        async_1.default.map(uaVariableArray, (uaVariable, inner_callback) => {
          try {
            uaVariable.asyncRefresh(referenceTime, (err, dataValue) => {
              inner_callback(err, dataValue);
            });
          } catch (err) {
            const _err = err;
            errorLog("asyncRefresh internal error", _err.message);
            inner_callback(_err);
          }
        }, (err, arrResult) => {
          callback(err || null, arrResult);
        });
      }
      _exposeSubscriptionDiagnostics(subscription) {
        try {
          debugLog("ServerEngine#_exposeSubscriptionDiagnostics", subscription.subscriptionId);
          const subscriptionDiagnosticsArray = this._getServerSubscriptionDiagnosticsArrayNode();
          const subscriptionDiagnostics = subscription.subscriptionDiagnostics;
          (0, node_opcua_assert_1.assert)(subscriptionDiagnostics.$subscription === subscription);
          (0, node_opcua_assert_1.assert)(subscriptionDiagnostics instanceof node_opcua_common_1.SubscriptionDiagnosticsDataType);
          if (subscriptionDiagnostics && subscriptionDiagnosticsArray) {
            (0, node_opcua_address_space_1.addElement)(subscriptionDiagnostics, subscriptionDiagnosticsArray);
          }
        } catch (err) {
          errorLog("_exposeSubscriptionDiagnostics err", err);
        }
      }
      _unexposeSubscriptionDiagnostics(subscription) {
        const serverSubscriptionDiagnosticsArray = this._getServerSubscriptionDiagnosticsArrayNode();
        const subscriptionDiagnostics = subscription.subscriptionDiagnostics;
        (0, node_opcua_assert_1.assert)(subscriptionDiagnostics instanceof node_opcua_common_1.SubscriptionDiagnosticsDataType);
        if (subscriptionDiagnostics && serverSubscriptionDiagnosticsArray) {
          const node = serverSubscriptionDiagnosticsArray[subscription.id];
          (0, node_opcua_address_space_1.removeElement)(serverSubscriptionDiagnosticsArray, (a) => a.subscriptionId === subscription.id);
        }
        debugLog("ServerEngine#_unexposeSubscriptionDiagnostics", subscription.subscriptionId);
      }
      /**
       * create a new subscription
       * @return {Subscription}
       */
      _createSubscriptionOnSession(session, request) {
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(request, "requestedPublishingInterval"));
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(request, "requestedLifetimeCount"));
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(request, "requestedMaxKeepAliveCount"));
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(request, "maxNotificationsPerPublish"));
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(request, "publishingEnabled"));
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(request, "priority"));
        const publishingInterval = request.requestedPublishingInterval || 0;
        const maxKeepAliveCount = request.requestedMaxKeepAliveCount || 0;
        const lifeTimeCount = request.requestedLifetimeCount || 0;
        const subscription = new server_subscription_1.Subscription({
          id: _get_next_subscriptionId(),
          lifeTimeCount,
          maxKeepAliveCount,
          maxNotificationsPerPublish: request.maxNotificationsPerPublish,
          priority: request.priority || 0,
          publishEngine: session.publishEngine,
          //
          publishingEnabled: request.publishingEnabled,
          publishingInterval,
          // -------------------
          sessionId: node_opcua_nodeid_1.NodeId.nullNodeId,
          globalCounter: this._globalCounter,
          serverCapabilities: this.serverCapabilities
          // shared
        });
        this._exposeSubscriptionDiagnostics(subscription);
        (0, node_opcua_assert_1.assert)(subscription.publishEngine === session.publishEngine);
        session.publishEngine.add_subscription(subscription);
        const engine = this;
        subscription.once("terminated", function() {
          engine._unexposeSubscriptionDiagnostics(this);
        });
        return subscription;
      }
      /**
       */
      __internal_bindMethod(nodeId, func) {
        (0, node_opcua_assert_1.assert)(typeof func === "function");
        (0, node_opcua_assert_1.assert)(nodeId instanceof node_opcua_nodeid_1.NodeId);
        const methodNode = this.addressSpace.findNode(nodeId);
        if (!methodNode) {
          return;
        }
        if (methodNode && methodNode.bindMethod) {
          methodNode.bindMethod(func);
        } else {
          warningLog(chalk_1.default.yellow("WARNING:  cannot bind a method with id ") + chalk_1.default.cyan(nodeId.toString()) + chalk_1.default.yellow(". please check your nodeset.xml file or add this node programmatically"));
          warningLog((0, node_opcua_debug_1.traceFromThisProjectOnly)());
        }
      }
      _getServerSubscriptionDiagnosticsArrayNode() {
        if (!this.addressSpace) {
          doDebug && debugLog("ServerEngine#_getServerSubscriptionDiagnosticsArray : no addressSpace");
          return null;
        }
        const subscriptionDiagnosticsType = this.addressSpace.findVariableType("SubscriptionDiagnosticsType");
        if (!subscriptionDiagnosticsType) {
          doDebug && debugLog("ServerEngine#_getServerSubscriptionDiagnosticsArray : cannot find SubscriptionDiagnosticsType");
        }
        const subscriptionDiagnosticsArrayNode = this.addressSpace.findNode((0, node_opcua_nodeid_1.makeNodeId)(node_opcua_constants_1.VariableIds.Server_ServerDiagnostics_SubscriptionDiagnosticsArray));
        return subscriptionDiagnosticsArrayNode;
      }
    };
    exports2.ServerEngine = ServerEngine;
    ServerEngine.registry = new node_opcua_object_registry_1.ObjectRegistry();
  }
});

// node_modules/node-opcua-server/dist/factory.js
var require_factory = __commonJS({
  "node_modules/node-opcua-server/dist/factory.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Factory = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_extension_object_1 = require_dist30();
    var node_opcua_factory_1 = require_dist26();
    var Factory = class {
      constructor(engine) {
        (0, node_opcua_assert_1.assert)(engine !== null && typeof engine === "object");
        this.engine = engine;
      }
      constructObject(id) {
        const obj = (0, node_opcua_factory_1.getStandardDataTypeFactory)().constructObject(id);
        if (!(obj instanceof node_opcua_extension_object_1.ExtensionObject)) {
          throw new Error("Internal Error constructObject");
        }
        return obj;
      }
    };
    exports2.Factory = Factory;
  }
});

// node_modules/node-opcua-server/dist/register_server_manager_hidden.js
var require_register_server_manager_hidden = __commonJS({
  "node_modules/node-opcua-server/dist/register_server_manager_hidden.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RegisterServerManagerHidden = void 0;
    var events_1 = require("events");
    var RegisterServerManagerHidden = class extends events_1.EventEmitter {
      constructor(options) {
        super();
        this.discoveryServerEndpointUrl = "";
      }
      stop(callback) {
        setImmediate(callback);
      }
      start(callback) {
        setImmediate(callback);
      }
      dispose() {
      }
    };
    exports2.RegisterServerManagerHidden = RegisterServerManagerHidden;
  }
});

// node_modules/node-opcua-server/dist/user_manager.js
var require_user_manager = __commonJS({
  "node_modules/node-opcua-server/dist/user_manager.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.makeUserManager = exports2.UAUserManager1 = exports2.UAUserManagerBase = void 0;
    var util_1 = require("util");
    var node_opcua_debug_1 = require_dist24();
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var UAUserManagerBase = class {
      getUserRoles(user) {
        throw new Error("Method not implemented.");
      }
      isValidUser(session, username, password) {
        throw new Error("Method not implemented.");
      }
      getIdentitiesForRole(role) {
        return [];
      }
      bind(roleSet) {
      }
    };
    exports2.UAUserManagerBase = UAUserManagerBase;
    var UAUserManager1 = class extends UAUserManagerBase {
      constructor(options) {
        super();
        this.options = options;
      }
      getUserRoles(user) {
        if (!this.options.getUserRoles)
          return [];
        try {
          return this.options.getUserRoles(user);
        } catch (err) {
          if (util_1.types.isNativeError(err)) {
            errorLog("[NODE-OPCUA-E27] userManager provided getUserRoles method has thrown an exception, please fix your code! ");
            errorLog(err.message, "\n", err.stack?.split("\n").slice(0, 2).join("\n"));
          }
          return [];
        }
      }
      async isValidUser(session, username, password) {
        if (typeof this.options.isValidUserAsync === "function") {
          return new Promise((resolve2, reject) => {
            this.options.isValidUserAsync?.call(session, username, password, (err, isAuthorized) => {
              if (err)
                return reject();
              resolve2(isAuthorized);
            });
          });
        } else if (typeof this.options.isValidUser === "function") {
          try {
            const authorized = this.options.isValidUser.call(session, username, password);
            return authorized;
          } catch (err) {
            if (util_1.types.isNativeError(err)) {
              errorLog("[NODE-OPCUA-E26] userManager provided isValidUser method has thrown an exception, please fix your code!");
              errorLog(err.message, "\n", err.stack?.split("\n").slice(0, 2).join("\n"));
            }
            return false;
          }
        } else {
          return false;
        }
      }
      getIdentitiesForRole(role) {
        return [];
      }
    };
    exports2.UAUserManager1 = UAUserManager1;
    function makeUserManager(options) {
      if (options instanceof UAUserManagerBase) {
        return options;
      }
      options = options || {};
      if (typeof options.isValidUser !== "function") {
        options.isValidUser = () => {
          return false;
        };
      }
      return new UAUserManager1(options);
    }
    exports2.makeUserManager = makeUserManager;
  }
});

// node_modules/node-opcua-server/dist/user_manager_ua.js
var require_user_manager_ua = __commonJS({
  "node_modules/node-opcua-server/dist/user_manager_ua.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.bindRoleSet = void 0;
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_address_space_1 = require_index_current();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_data_model_1 = require_dist27();
    function bindRoleSet(userManager, addressSpace) {
      const roleSet = addressSpace.findNode(node_opcua_constants_1.ObjectIds.Server_ServerCapabilities_RoleSet);
      if (!roleSet)
        return;
      const components = roleSet.getComponents();
      for (const component of components) {
        (0, node_opcua_address_space_1.ensureObjectIsSecure)(component);
        if (component.nodeClass !== node_opcua_data_model_1.NodeClass.Object) {
          continue;
        }
        const o2 = component;
        if (o2.typeDefinitionObj.browseName.name !== "RoleType") {
          continue;
        }
        const roleType = o2;
        const roleTypeProperties = roleType.findReferencesAsObject("HasChild", false);
        for (const roleTypeProp of roleTypeProperties) {
          (0, node_opcua_address_space_1.ensureObjectIsSecure)(roleTypeProp);
        }
        roleType.identities.setValueFromSource({ dataType: node_opcua_variant_1.DataType.ExtensionObject, value: [] });
        roleType.endpoints?.setValueFromSource({ dataType: node_opcua_variant_1.DataType.ExtensionObject, value: [] });
        roleType.identities.bindVariable({
          get: () => {
            const identities = userManager.getIdentitiesForRole(roleType.nodeId);
            return new node_opcua_variant_1.Variant({ dataType: node_opcua_variant_1.DataType.ExtensionObject, value: identities });
          }
        }, true);
      }
      userManager.bind(roleSet);
    }
    exports2.bindRoleSet = bindRoleSet;
  }
});

// node_modules/node-opcua-server/package.json
var require_package2 = __commonJS({
  "node_modules/node-opcua-server/package.json"(exports2, module2) {
    module2.exports = {
      name: "node-opcua-server",
      version: "2.123.0",
      description: "pure nodejs OPCUA SDK - module server",
      scripts: {
        build: "tsc -b",
        lint: "eslint source test",
        format: "prettier --write source test",
        clean: "npx rimraf node_modules dist *.tsbuildinfo certificates",
        test: "mocha"
      },
      main: "./dist/index.js",
      types: "./dist/index.d.ts",
      dependencies: {
        "@ster5/global-mutex": "^2.0.0",
        async: "^3.2.5",
        chalk: "4.1.2",
        dequeue: "^1.0.5",
        lodash: "4.17.21",
        "node-opcua-address-space": "2.123.0",
        "node-opcua-address-space-base": "2.123.0",
        "node-opcua-assert": "2.120.0",
        "node-opcua-basic-types": "2.121.0",
        "node-opcua-binary-stream": "2.120.0",
        "node-opcua-certificate-manager": "2.121.0",
        "node-opcua-client": "2.123.0",
        "node-opcua-client-dynamic-extension-object": "2.123.0",
        "node-opcua-common": "2.123.0",
        "node-opcua-constants": "2.121.0",
        "node-opcua-crypto": "4.8.0",
        "node-opcua-data-model": "2.121.0",
        "node-opcua-data-value": "2.121.0",
        "node-opcua-date-time": "2.121.0",
        "node-opcua-debug": "2.121.0",
        "node-opcua-extension-object": "2.121.0",
        "node-opcua-factory": "2.121.0",
        "node-opcua-hostname": "2.120.0",
        "node-opcua-nodeid": "2.121.0",
        "node-opcua-nodesets": "2.121.0",
        "node-opcua-numeric-range": "2.121.0",
        "node-opcua-object-registry": "2.121.0",
        "node-opcua-secure-channel": "2.123.0",
        "node-opcua-service-browse": "2.123.0",
        "node-opcua-service-call": "2.123.0",
        "node-opcua-service-discovery": "2.123.0",
        "node-opcua-service-endpoints": "2.123.0",
        "node-opcua-service-filter": "2.123.0",
        "node-opcua-service-history": "2.123.0",
        "node-opcua-service-node-management": "2.123.0",
        "node-opcua-service-query": "2.123.0",
        "node-opcua-service-read": "2.123.0",
        "node-opcua-service-register-node": "2.123.0",
        "node-opcua-service-secure-channel": "2.123.0",
        "node-opcua-service-session": "2.123.0",
        "node-opcua-service-subscription": "2.123.0",
        "node-opcua-service-translate-browse-path": "2.123.0",
        "node-opcua-service-write": "2.123.0",
        "node-opcua-status-code": "2.121.0",
        "node-opcua-transport": "2.123.0",
        "node-opcua-types": "2.123.0",
        "node-opcua-utils": "2.120.0",
        "node-opcua-variant": "2.121.0",
        thenify: "^3.3.1"
      },
      devDependencies: {
        "node-opcua-data-access": "2.123.0",
        "node-opcua-leak-detector": "2.121.0",
        "node-opcua-test-helpers": "2.120.0",
        should: "^13.2.3",
        sinon: "^17.0.1",
        underscore: "^1.13.6"
      },
      author: "Etienne Rossignon",
      license: "MIT",
      repository: {
        type: "git",
        url: "git://github.com/node-opcua/node-opcua.git"
      },
      keywords: [
        "OPCUA",
        "opcua",
        "m2m",
        "iot",
        "opc ua",
        "internet of things"
      ],
      homepage: "http://node-opcua.github.io/",
      gitHead: "64b4575687f6a8130e06fa78b6f61b6eeaa05e74",
      files: [
        "dist",
        "source"
      ]
    };
  }
});

// node_modules/node-opcua-server/dist/opcua_server.js
var require_opcua_server = __commonJS({
  "node_modules/node-opcua-server/dist/opcua_server.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OPCUAServer = exports2.RegisterServerMethod = exports2.filterDiagnosticInfo = void 0;
    var crypto_1 = require("crypto");
    var util_1 = require("util");
    var async_1 = __importDefault3(require_async());
    var chalk_1 = __importDefault3(require_source());
    var node_opcua_hostname_1 = require_dist36();
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_address_space_1 = require_index_current();
    var node_opcua_certificate_manager_1 = require_dist60();
    var node_opcua_common_1 = require_dist34();
    var node_opcua_crypto_1 = require_dist33();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_object_registry_1 = require_dist46();
    var node_opcua_secure_channel_1 = require_source7();
    var node_opcua_service_browse_1 = require_dist37();
    var node_opcua_service_call_1 = require_dist41();
    var node_opcua_service_endpoints_1 = require_dist44();
    var node_opcua_service_history_1 = require_dist54();
    var node_opcua_service_node_management_1 = require_dist51();
    var node_opcua_service_query_1 = require_dist50();
    var node_opcua_service_read_1 = require_dist39();
    var node_opcua_service_register_node_1 = require_dist43();
    var node_opcua_service_session_1 = require_dist42();
    var node_opcua_service_subscription_1 = require_dist45();
    var node_opcua_service_translate_browse_path_1 = require_dist49();
    var node_opcua_service_write_1 = require_dist40();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_types_1 = require_dist32();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_variant_2 = require_dist28();
    var node_opcua_utils_2 = require_dist16();
    var base_server_1 = require_base_server();
    var factory_1 = require_factory();
    var monitored_item_1 = require_monitored_item();
    var register_server_manager_1 = require_register_server_manager();
    var register_server_manager_hidden_1 = require_register_server_manager_hidden();
    var register_server_manager_mdns_only_1 = require_register_server_manager_mdns_only();
    var server_end_point_1 = require_server_end_point();
    var server_engine_1 = require_server_engine();
    var user_manager_1 = require_user_manager();
    var user_manager_ua_1 = require_user_manager_ua();
    function isSubscriptionIdInvalid(subscriptionId) {
      return subscriptionId < 0 || subscriptionId >= 4294967295;
    }
    var thenify = require_thenify();
    var package_info = require_package2();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    var warningLog = (0, node_opcua_debug_1.make_warningLog)(__filename);
    var default_maxConnectionsPerEndpoint = 10;
    function g_sendError(channel, message, ResponseClass, statusCode) {
      const response = new node_opcua_types_1.ServiceFault({
        responseHeader: { serviceResult: statusCode }
      });
      return channel.send_response("MSG", response, message);
    }
    var default_build_info = {
      manufacturerName: "NodeOPCUA : MIT Licence ( see http://node-opcua.github.io/)",
      productName: "NodeOPCUA-Server",
      productUri: null,
      // << should be same as default_server_info.productUri?
      softwareVersion: package_info.version,
      buildNumber: "0",
      buildDate: new Date(2020, 1, 1)
      // xx buildDate: fs.statSync(package_json_file).mtime
    };
    var minSessionTimeout = 100;
    var defaultSessionTimeout = 1e3 * 30;
    var maxSessionTimeout = 1e3 * 60 * 50;
    var unnamed_session_count = 0;
    function _adjust_session_timeout(sessionTimeout) {
      let revisedSessionTimeout = sessionTimeout || defaultSessionTimeout;
      revisedSessionTimeout = Math.min(revisedSessionTimeout, maxSessionTimeout);
      revisedSessionTimeout = Math.max(revisedSessionTimeout, minSessionTimeout);
      return revisedSessionTimeout;
    }
    function channel_has_session(channel, session) {
      if (session.channel === channel) {
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(channel.sessionTokens, session.authenticationToken.toString()));
        return true;
      }
      return false;
    }
    function moveSessionToChannel(session, channel) {
      debugLog("moveSessionToChannel sessionId", session.nodeId, " channelId=", channel.channelId);
      if (session.publishEngine) {
        session.publishEngine.cancelPendingPublishRequestBeforeChannelChange();
      }
      session._detach_channel();
      session._attach_channel(channel);
      (0, node_opcua_assert_1.assert)(session.channel.channelId === channel.channelId);
    }
    async function _attempt_to_close_some_old_unactivated_session(server) {
      const session = server.engine.getOldestInactiveSession();
      if (session) {
        await server.engine.closeSession(session.authenticationToken, false, "Forcing");
      }
    }
    function getRequiredEndpointInfo(endpoint) {
      (0, node_opcua_assert_1.assert)(endpoint instanceof node_opcua_types_1.EndpointDescription);
      const e = new node_opcua_types_1.EndpointDescription({
        endpointUrl: endpoint.endpointUrl,
        securityLevel: endpoint.securityLevel,
        securityMode: endpoint.securityMode,
        securityPolicyUri: endpoint.securityPolicyUri,
        server: {
          applicationUri: endpoint.server.applicationUri,
          applicationType: endpoint.server.applicationType,
          applicationName: endpoint.server.applicationName,
          productUri: endpoint.server.productUri
        },
        transportProfileUri: endpoint.transportProfileUri,
        userIdentityTokens: endpoint.userIdentityTokens
      });
      e.server.applicationName = null;
      e.server.gatewayServerUri = null;
      e.server.discoveryProfileUri = null;
      e.server.discoveryUrls = null;
      e.serverCertificate = null;
      return e;
    }
    function _serverEndpointsForCreateSessionResponse(server, endpointUrl, serverUri) {
      serverUri = null;
      return server._get_endpoints(endpointUrl).filter((e) => !e.restricted).filter((e) => (0, node_opcua_utils_2.matchUri)(e.endpointUrl, endpointUrl)).map(getRequiredEndpointInfo);
    }
    function adjustSecurityPolicy(channel, userTokenPolicy_securityPolicyUri) {
      let securityPolicy = (0, node_opcua_secure_channel_1.fromURI)(userTokenPolicy_securityPolicyUri);
      if (securityPolicy === node_opcua_secure_channel_1.SecurityPolicy.Invalid) {
        securityPolicy = (0, node_opcua_secure_channel_1.fromURI)(channel.clientSecurityHeader.securityPolicyUri);
        (0, node_opcua_assert_1.assert)(securityPolicy !== node_opcua_secure_channel_1.SecurityPolicy.Invalid);
      }
      return securityPolicy;
    }
    function findUserTokenByPolicy(endpoint_description, userTokenType, policyId) {
      (0, node_opcua_assert_1.assert)(endpoint_description instanceof node_opcua_types_1.EndpointDescription);
      const r = endpoint_description.userIdentityTokens.filter((userIdentity) => userIdentity.tokenType === userTokenType && (!policyId || userIdentity.policyId === policyId));
      return r.length === 0 ? null : r[0];
    }
    function findUserTokenPolicy(endpoint_description, userTokenType) {
      (0, node_opcua_assert_1.assert)(endpoint_description instanceof node_opcua_types_1.EndpointDescription);
      const r = endpoint_description.userIdentityTokens.filter((userIdentity) => {
        (0, node_opcua_assert_1.assert)(userIdentity.tokenType !== void 0);
        return userIdentity.tokenType === userTokenType;
      });
      return r.length === 0 ? null : r[0];
    }
    function createAnonymousIdentityToken(endpoint_desc) {
      (0, node_opcua_assert_1.assert)(endpoint_desc instanceof node_opcua_types_1.EndpointDescription);
      const userTokenPolicy = findUserTokenPolicy(endpoint_desc, node_opcua_service_endpoints_1.UserTokenType.Anonymous);
      if (!userTokenPolicy) {
        throw new Error("Cannot find ANONYMOUS user token policy in end point description");
      }
      return new node_opcua_service_session_1.AnonymousIdentityToken({ policyId: userTokenPolicy.policyId });
    }
    function sameIdentityToken(token1, token2) {
      if (token1 instanceof node_opcua_service_session_1.UserNameIdentityToken) {
        if (!(token2 instanceof node_opcua_service_session_1.UserNameIdentityToken)) {
          return false;
        }
        if (token1.userName !== token2.userName) {
          return false;
        }
        if (token1.password.toString("hex") !== token2.password.toString("hex")) {
          return false;
        }
      } else if (token1 instanceof node_opcua_service_session_1.AnonymousIdentityToken) {
        if (!(token2 instanceof node_opcua_service_session_1.AnonymousIdentityToken)) {
          return false;
        }
        if (token1.policyId !== token2.policyId) {
          return false;
        }
        return true;
      }
      (0, node_opcua_assert_1.assert)(false, " Not implemented yet");
      return false;
    }
    function getTokenType(userIdentityToken) {
      if (userIdentityToken instanceof node_opcua_service_session_1.AnonymousIdentityToken) {
        return node_opcua_service_endpoints_1.UserTokenType.Anonymous;
      } else if (userIdentityToken instanceof node_opcua_service_session_1.UserNameIdentityToken) {
        return node_opcua_service_endpoints_1.UserTokenType.UserName;
      } else if (userIdentityToken instanceof node_opcua_types_1.IssuedIdentityToken) {
        return node_opcua_service_endpoints_1.UserTokenType.IssuedToken;
      } else if (userIdentityToken instanceof node_opcua_service_session_1.X509IdentityToken) {
        return node_opcua_service_endpoints_1.UserTokenType.Certificate;
      }
      return node_opcua_service_endpoints_1.UserTokenType.Invalid;
    }
    function thumbprint(certificate) {
      return certificate ? certificate.toString("base64") : "";
    }
    function monitoredItem_read_and_record_value(self2, context, oldValue, node, itemToMonitor, callback) {
      (0, node_opcua_assert_1.assert)(self2 instanceof monitored_item_1.MonitoredItem);
      (0, node_opcua_assert_1.assert)(oldValue instanceof node_opcua_data_value_1.DataValue);
      (0, node_opcua_assert_1.assert)(itemToMonitor.attributeId === node_opcua_data_model_1.AttributeIds.Value);
      const dataValue = node.readAttribute(context, itemToMonitor.attributeId, itemToMonitor.indexRange, itemToMonitor.dataEncoding);
      callback(null, dataValue);
    }
    function monitoredItem_read_and_record_value_async(self2, context, oldValue, node, itemToMonitor, callback) {
      (0, node_opcua_assert_1.assert)(context instanceof node_opcua_address_space_1.SessionContext);
      (0, node_opcua_assert_1.assert)(itemToMonitor.attributeId === node_opcua_data_model_1.AttributeIds.Value);
      (0, node_opcua_assert_1.assert)(self2 instanceof monitored_item_1.MonitoredItem);
      (0, node_opcua_assert_1.assert)(oldValue instanceof node_opcua_data_value_1.DataValue);
      (0, node_opcua_assert_1.assert)(itemToMonitor.attributeId === node_opcua_data_model_1.AttributeIds.Value);
      node.readValueAsync(context, (err, dataValue) => {
        callback(err, dataValue);
      });
    }
    function build_scanning_node_function(addressSpace, itemToMonitor) {
      (0, node_opcua_assert_1.assert)(itemToMonitor instanceof node_opcua_service_read_1.ReadValueId);
      const node = addressSpace.findNode(itemToMonitor.nodeId);
      if (!node) {
        errorLog(" INVALID NODE ID  , ", itemToMonitor.nodeId.toString());
        (0, node_opcua_debug_1.dump)(itemToMonitor);
        return (_sessionContext, _oldData, callback) => {
          callback(null, new node_opcua_data_value_1.DataValue({
            statusCode: node_opcua_status_code_1.StatusCodes.BadNodeIdUnknown,
            value: { dataType: node_opcua_variant_1.DataType.Null, value: 0 }
          }));
        };
      }
      if (itemToMonitor.attributeId === node_opcua_data_model_1.AttributeIds.Value) {
        const monitoredItem_read_and_record_value_func = itemToMonitor.attributeId === node_opcua_data_model_1.AttributeIds.Value && typeof node.readValueAsync === "function" ? monitoredItem_read_and_record_value_async : monitoredItem_read_and_record_value;
        return function func(sessionContext, oldDataValue, callback) {
          (0, node_opcua_assert_1.assert)(this instanceof monitored_item_1.MonitoredItem);
          (0, node_opcua_assert_1.assert)(oldDataValue instanceof node_opcua_data_value_1.DataValue);
          (0, node_opcua_assert_1.assert)(typeof callback === "function");
          monitoredItem_read_and_record_value_func(this, sessionContext, oldDataValue, node, itemToMonitor, callback);
        };
      } else {
        return function func(sessionContext, oldDataValue, callback) {
          (0, node_opcua_assert_1.assert)(this instanceof monitored_item_1.MonitoredItem);
          (0, node_opcua_assert_1.assert)(oldDataValue instanceof node_opcua_data_value_1.DataValue);
          (0, node_opcua_assert_1.assert)(typeof callback === "function");
          const newDataValue = node.readAttribute(sessionContext, itemToMonitor.attributeId);
          callback(null, newDataValue);
        };
      }
    }
    function prepareMonitoredItem(context, addressSpace, monitoredItem) {
      const itemToMonitor = monitoredItem.itemToMonitor;
      const readNodeFunc = build_scanning_node_function(addressSpace, itemToMonitor);
      monitoredItem.samplingFunc = readNodeFunc;
    }
    function isMonitoringModeValid(monitoringMode) {
      (0, node_opcua_assert_1.assert)(node_opcua_types_1.MonitoringMode.Invalid !== void 0);
      return monitoringMode !== node_opcua_types_1.MonitoringMode.Invalid && monitoringMode <= node_opcua_types_1.MonitoringMode.Reporting;
    }
    function _installRegisterServerManager(self2) {
      (0, node_opcua_assert_1.assert)(self2 instanceof OPCUAServer);
      (0, node_opcua_assert_1.assert)(!self2.registerServerManager);
      if (!self2.registerServerMethod) {
        throw new Error("Internal Error");
      }
      switch (self2.registerServerMethod) {
        case RegisterServerMethod.HIDDEN:
          self2.registerServerManager = new register_server_manager_hidden_1.RegisterServerManagerHidden({
            server: self2
          });
          break;
        case RegisterServerMethod.MDNS:
          self2.registerServerManager = new register_server_manager_mdns_only_1.RegisterServerManagerMDNSONLY({
            server: self2
          });
          break;
        case RegisterServerMethod.LDS:
          self2.registerServerManager = new register_server_manager_1.RegisterServerManager({
            discoveryServerEndpointUrl: self2.discoveryServerEndpointUrl,
            server: self2
          });
          break;
        default:
          throw new Error("Invalid switch");
      }
      self2.registerServerManager.on("serverRegistrationPending", () => {
        debugLog("serverRegistrationPending");
        self2.emit("serverRegistrationPending");
      });
      self2.registerServerManager.on("serverRegistered", () => {
        debugLog("serverRegistered");
        self2.emit("serverRegistered");
      });
      self2.registerServerManager.on("serverRegistrationRenewed", () => {
        debugLog("serverRegistrationRenewed");
        self2.emit("serverRegistrationRenewed");
      });
      self2.registerServerManager.on("serverUnregistered", () => {
        debugLog("serverUnregistered");
        self2.emit("serverUnregistered");
      });
    }
    function validate_applicationUri(channel, request) {
      const applicationUri = request.clientDescription.applicationUri;
      const clientCertificate = request.clientCertificate;
      if (channel.securityMode === node_opcua_secure_channel_1.MessageSecurityMode.None) {
        return true;
      }
      if (!clientCertificate || clientCertificate.length === 0) {
        return true;
      }
      const e = (0, node_opcua_crypto_1.exploreCertificate)(clientCertificate);
      const uniformResourceIdentifier = e.tbsCertificate.extensions.subjectAltName?.uniformResourceIdentifier ?? null;
      const applicationUriFromCert = uniformResourceIdentifier && uniformResourceIdentifier.length > 0 ? uniformResourceIdentifier[0] : null;
      if (applicationUriFromCert !== applicationUri) {
        errorLog("BadCertificateUriInvalid!");
        errorLog("applicationUri           = ", applicationUri);
        errorLog("applicationUriFromCert   = ", applicationUriFromCert);
      }
      return applicationUriFromCert === applicationUri;
    }
    function validate_security_endpoint(server, request, channel) {
      debugLog("validate_security_endpoint = ", request.endpointUrl);
      let endpoints = server._get_endpoints(request.endpointUrl);
      if (endpoints.length === 0 && request.endpointUrl?.endsWith("/")) {
        endpoints = server._get_endpoints(request.endpointUrl.slice(0, -1));
      }
      if (endpoints.length === 0) {
        const ua_server = server.engine.addressSpace.rootFolder.objects.server;
        if (!request.endpointUrl?.match(/localhost/i) || OPCUAServer.requestExactEndpointUrl) {
          warningLog("Cannot find suitable endpoints in available endpoints. endpointUri =", request.endpointUrl);
        }
        ua_server.raiseEvent("AuditUrlMismatchEventType", {
          endpointUrl: { dataType: node_opcua_variant_1.DataType.String, value: request.endpointUrl }
        });
        if (OPCUAServer.requestExactEndpointUrl) {
          return { errCode: node_opcua_status_code_1.StatusCodes.BadServiceUnsupported };
        } else {
          endpoints = server._get_endpoints(null);
        }
      }
      endpoints = endpoints.filter((e) => !e.restricted);
      const endpoints_matching_security_mode = endpoints.filter((e) => {
        return e.securityMode === channel.securityMode;
      });
      if (endpoints_matching_security_mode.length === 0) {
        return { errCode: node_opcua_status_code_1.StatusCodes.BadSecurityModeRejected };
      }
      const endpoints_matching_security_policy = endpoints_matching_security_mode.filter((e) => {
        return e.securityPolicyUri === channel.securityHeader.securityPolicyUri;
      });
      if (endpoints_matching_security_policy.length === 0) {
        return { errCode: node_opcua_status_code_1.StatusCodes.BadSecurityPolicyRejected };
      }
      if (endpoints_matching_security_policy.length !== 1) {
        debugLog("endpoints_matching_security_policy= ", endpoints_matching_security_policy.length);
      }
      return { errCode: node_opcua_status_code_1.StatusCodes.Good, endpoint: endpoints_matching_security_policy[0] };
    }
    function filterDiagnosticInfo(returnDiagnostics, response) {
      if (node_opcua_data_model_1.RESPONSE_DIAGNOSTICS_MASK_ALL & returnDiagnostics) {
        response.responseHeader.serviceDiagnostics = (0, node_opcua_data_model_1.filterDiagnosticServiceLevel)(returnDiagnostics, response.responseHeader.serviceDiagnostics);
        if (response.diagnosticInfos && response.diagnosticInfos.length > 0) {
          response.diagnosticInfos = response.diagnosticInfos.map((d2) => (0, node_opcua_data_model_1.filterDiagnosticOperationLevel)(returnDiagnostics, d2));
        } else {
          response.diagnosticInfos = [];
        }
        if (response.results) {
          for (const entry of response.results) {
            if (entry.inputArgumentDiagnosticInfos && entry.inputArgumentDiagnosticInfos.length > 0) {
              entry.inputArgumentDiagnosticInfos = entry.inputArgumentDiagnosticInfos.map((d2) => (0, node_opcua_data_model_1.filterDiagnosticOperationLevel)(returnDiagnostics, d2));
            } else {
              entry.inputArgumentDiagnosticInfos = [];
            }
          }
        }
      }
    }
    exports2.filterDiagnosticInfo = filterDiagnosticInfo;
    var RegisterServerMethod;
    (function(RegisterServerMethod2) {
      RegisterServerMethod2[RegisterServerMethod2["HIDDEN"] = 1] = "HIDDEN";
      RegisterServerMethod2[RegisterServerMethod2["MDNS"] = 2] = "MDNS";
      RegisterServerMethod2[RegisterServerMethod2["LDS"] = 3] = "LDS";
    })(RegisterServerMethod || (exports2.RegisterServerMethod = RegisterServerMethod = {}));
    var g_requestExactEndpointUrl = !!process.env.NODEOPCUA_SERVER_REQUEST_EXACT_ENDPOINT_URL;
    var OPCUAServer = class _OPCUAServer extends base_server_1.OPCUABaseServer {
      /**
       * total number of bytes written  by the server since startup
       */
      get bytesWritten() {
        return this.endpoints.reduce((accumulated, endpoint) => {
          return accumulated + endpoint.bytesWritten;
        }, 0);
      }
      /**
       * total number of bytes read  by the server since startup
       */
      get bytesRead() {
        return this.endpoints.reduce((accumulated, endpoint) => {
          return accumulated + endpoint.bytesRead;
        }, 0);
      }
      /**
       * Number of transactions processed by the server since startup
       */
      get transactionsCount() {
        return this.endpoints.reduce((accumulated, endpoint) => {
          return accumulated + endpoint.transactionsCount;
        }, 0);
      }
      /**
       * The server build info
       */
      get buildInfo() {
        return this.engine.buildInfo;
      }
      /**
       * the number of connected channel on all existing end points
       */
      get currentChannelCount() {
        return this.endpoints.reduce((currentValue, endPoint) => {
          return currentValue + endPoint.currentChannelCount;
        }, 0);
      }
      /**
       * The number of active subscriptions from all sessions
       */
      get currentSubscriptionCount() {
        return this.engine ? this.engine.currentSubscriptionCount : 0;
      }
      /**
       * the number of session activation requests that have been rejected
       */
      get rejectedSessionCount() {
        return this.engine ? this.engine.rejectedSessionCount : 0;
      }
      /**
       * the number of request that have been rejected
       */
      get rejectedRequestsCount() {
        return this.engine ? this.engine.rejectedRequestsCount : 0;
      }
      /**
       * the number of sessions that have been aborted
       */
      get sessionAbortCount() {
        return this.engine ? this.engine.sessionAbortCount : 0;
      }
      /**
       * the publishing interval count
       */
      get publishingIntervalCount() {
        return this.engine ? this.engine.publishingIntervalCount : 0;
      }
      /**
       * the number of sessions currently active
       */
      get currentSessionCount() {
        return this.engine ? this.engine.currentSessionCount : 0;
      }
      /**
       * true if the server has been initialized
       *
       */
      get initialized() {
        return this.engine && this.engine.addressSpace !== null;
      }
      /**
       * is the server auditing ?
       */
      get isAuditing() {
        return this.engine ? this.engine.isAuditing : false;
      }
      /**
       * the maximum number of concurrent sessions allowed on the server
       */
      get maxAllowedSessionNumber() {
        return this.engine.serverCapabilities.maxSessions;
      }
      constructor(options) {
        super(options);
        this.allowAnonymous = false;
        this.allowAnonymous = false;
        options = options || {};
        this.options = options;
        if (options.maxAllowedSessionNumber !== void 0) {
          warningLog("[NODE-OPCUA-W21] maxAllowedSessionNumber property is now deprecated , please use serverCapabilities.maxSessions instead");
          options.serverCapabilities = options.serverCapabilities || {};
          options.serverCapabilities.maxSessions = options.maxAllowedSessionNumber;
        }
        if (options.securityPolicies) {
          options.securityPolicies = options.securityPolicies.map(node_opcua_secure_channel_1.coerceSecurityPolicy);
        }
        this.maxConnectionsPerEndpoint = options.maxConnectionsPerEndpoint || default_maxConnectionsPerEndpoint;
        const buildInfo = {
          ...default_build_info,
          ...options.buildInfo
        };
        buildInfo.productUri = buildInfo.productUri || this.serverInfo.productUri;
        this.serverInfo.productUri = this.serverInfo.productUri || buildInfo.productUri;
        this.userManager = (0, user_manager_1.makeUserManager)(options.userManager);
        options.allowAnonymous = options.allowAnonymous === void 0 ? true : !!options.allowAnonymous;
        this.allowAnonymous = options.allowAnonymous;
        this.discoveryServerEndpointUrl = options.discoveryServerEndpointUrl || "opc.tcp://%FQDN%:4840";
        (0, node_opcua_assert_1.assert)(typeof this.discoveryServerEndpointUrl === "string");
        this.serverInfo.applicationType = options.serverInfo?.applicationType === void 0 ? node_opcua_service_endpoints_1.ApplicationType.Server : options.serverInfo.applicationType;
        this.capabilitiesForMDNS = options.capabilitiesForMDNS || ["NA"];
        this.registerServerMethod = options.registerServerMethod || RegisterServerMethod.HIDDEN;
        _installRegisterServerManager(this);
        if (!options.userCertificateManager) {
          this.userCertificateManager = (0, node_opcua_certificate_manager_1.getDefaultCertificateManager)("UserPKI");
        } else {
          this.userCertificateManager = options.userCertificateManager;
        }
        this._delayInit = async () => {
          if (!options) {
            throw new Error("Internal Error");
          }
          this.engine = new server_engine_1.ServerEngine({
            applicationUri: () => this.serverInfo.applicationUri,
            buildInfo,
            isAuditing: options.isAuditing,
            serverCapabilities: options.serverCapabilities,
            serverConfiguration: {
              serverCapabilities: () => {
                return this.capabilitiesForMDNS || ["NA"];
              },
              supportedPrivateKeyFormat: ["PEM"],
              applicationType: () => this.serverInfo.applicationType,
              applicationUri: () => this.serverInfo.applicationUri || "",
              productUri: () => this.serverInfo.productUri || "",
              // hasSecureElement: () => false,
              multicastDnsEnabled: () => this.registerServerMethod === RegisterServerMethod.MDNS
            }
          });
          this.objectFactory = new factory_1.Factory(this.engine);
          const endpointDefinitions = [
            ...options.endpoints || [],
            ...options.alternateEndpoints || []
          ];
          const hostname2 = (0, node_opcua_hostname_1.getFullyQualifiedDomainName)();
          endpointDefinitions.forEach((endpointDefinition) => {
            endpointDefinition.port = endpointDefinition.port === void 0 ? 26543 : endpointDefinition.port;
            endpointDefinition.hostname = endpointDefinition.hostname || hostname2;
          });
          if (!options.endpoints) {
            endpointDefinitions.push({
              port: options.port === void 0 ? 26543 : options.port,
              hostname: options.hostname || hostname2,
              host: options.host,
              allowAnonymous: options.allowAnonymous,
              alternateHostname: options.alternateHostname,
              disableDiscovery: options.disableDiscovery,
              securityModes: options.securityModes,
              securityPolicies: options.securityPolicies
            });
          }
          for (const endpointOptions of endpointDefinitions) {
            const endPoint = this.createEndpointDescriptions(options, endpointOptions);
            this.endpoints.push(endPoint);
            endPoint.on("message", (message, channel) => {
              this.on_request(message, channel);
            });
          }
        };
      }
      initialize(...args) {
        const done = args[0];
        (0, node_opcua_assert_1.assert)(!this.initialized, "server is already initialized");
        this._preInitTask.push(async () => {
          if (this._delayInit) {
            await this._delayInit();
            this._delayInit = void 0;
          }
        });
        this.performPreInitialization().then(() => {
          _OPCUAServer.registry.register(this);
          this.engine.initialize(this.options, () => {
            (0, user_manager_ua_1.bindRoleSet)(this.userManager, this.engine.addressSpace);
            setImmediate(() => {
              this.emit("post_initialize");
              done();
            });
          });
        }).catch((err) => {
          done(err);
        });
      }
      start(...args) {
        const done = args[0];
        const tasks = [];
        tasks.push((0, util_1.callbackify)(node_opcua_hostname_1.extractFullyQualifiedDomainName));
        if (!this.initialized) {
          tasks.push((callback) => {
            this.initialize(callback);
          });
        }
        tasks.push((callback) => {
          super.start((err) => {
            if (err) {
              this.shutdown((err2) => {
                callback(err);
              });
            } else {
              this.registerServerManager.start(() => {
              });
              setImmediate(callback);
            }
          });
        });
        async_1.default.series(tasks, done);
      }
      shutdown(...args) {
        const timeout = args.length === 1 ? _OPCUAServer.defaultShutdownTimeout : args[0];
        const callback = args.length === 1 ? args[0] : args[1];
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        debugLog("OPCUAServer#shutdown (timeout = ", timeout, ")");
        if (!this.engine) {
          return callback();
        }
        (0, node_opcua_assert_1.assert)(this.engine);
        if (!this.engine.isStarted()) {
          const err = new Error("OPCUAServer#shutdown failure ! server doesn't seems to be started yet");
          return callback(err);
        }
        this.userCertificateManager.dispose();
        this.engine.setServerState(node_opcua_common_1.ServerState.Shutdown);
        const shutdownTime = new Date(Date.now() + timeout);
        this.engine.setShutdownTime(shutdownTime);
        debugLog("OPCUAServer is now un-registering itself from  the discovery server " + this.buildInfo);
        this.registerServerManager.stop((err) => {
          debugLog("OPCUAServer unregistered from discovery server", err);
          setTimeout(async () => {
            await this.engine.shutdown();
            debugLog("OPCUAServer#shutdown: started");
            base_server_1.OPCUABaseServer.prototype.shutdown.call(this, (err1) => {
              debugLog("OPCUAServer#shutdown: completed");
              this.dispose();
              callback(err1);
            });
          }, timeout);
        });
      }
      dispose() {
        for (const endpoint of this.endpoints) {
          endpoint.dispose();
        }
        this.endpoints = [];
        this.removeAllListeners();
        if (this.registerServerManager) {
          this.registerServerManager.dispose();
          this.registerServerManager = void 0;
        }
        _OPCUAServer.registry.unregister(this);
        if (this.engine) {
          this.engine.dispose();
        }
      }
      raiseEvent(eventType, options) {
        if (!this.engine.addressSpace) {
          errorLog("addressSpace missing");
          return;
        }
        const server = this.engine.addressSpace.findNode("Server");
        if (!server) {
          return;
        }
        let eventTypeNode = eventType;
        if (typeof eventType === "string") {
          eventTypeNode = this.engine.addressSpace.findEventType(eventType);
          if (eventTypeNode) {
            return server.raiseEvent(eventTypeNode, options);
          } else {
            console.warn(" cannot find event type ", eventType);
          }
        } else {
          return server.raiseEvent(eventTypeNode, options);
        }
      }
      /**
       * create and register a new session
       * @internal
       */
      createSession(options) {
        if (!this.engine) {
          throw new Error("Internal Error");
        }
        return this.engine.createSession(options);
      }
      /**
       * retrieve a session by authentication token
       * @internal
       * @private
       */
      getSession(authenticationToken, activeOnly) {
        return this.engine ? this.engine.getSession(authenticationToken, activeOnly) : null;
      }
      /**
       *
       * @param channel
       * @param clientCertificate
       * @param clientNonce
       * @internal
       */
      computeServerSignature(channel, clientCertificate, clientNonce) {
        return (0, node_opcua_secure_channel_1.computeSignature)(clientCertificate, clientNonce, this.getPrivateKey(), channel.messageBuilder.securityPolicy);
      }
      /**
       *
       * @param session
       * @param channel
       * @param clientSignature
       * @internal
       */
      verifyClientSignature(session, channel, clientSignature) {
        const clientCertificate = channel.receiverCertificate;
        const securityPolicy = channel.messageBuilder.securityPolicy;
        const serverCertificate = this.getCertificate();
        const result2 = (0, node_opcua_secure_channel_1.verifySignature)(serverCertificate, session.nonce, clientSignature, clientCertificate, securityPolicy);
        return result2;
      }
      isValidUserNameIdentityToken(channel, session, userTokenPolicy, userIdentityToken, userTokenSignature, callback) {
        (0, node_opcua_assert_1.assert)(userIdentityToken instanceof node_opcua_service_session_1.UserNameIdentityToken);
        const securityPolicy = adjustSecurityPolicy(channel, userTokenPolicy.securityPolicyUri);
        if (securityPolicy === node_opcua_secure_channel_1.SecurityPolicy.None) {
          return callback(null, node_opcua_status_code_1.StatusCodes.Good);
        }
        const cryptoFactory = (0, node_opcua_secure_channel_1.getCryptoFactory)(securityPolicy);
        if (!cryptoFactory) {
          return callback(null, node_opcua_status_code_1.StatusCodes.BadSecurityPolicyRejected);
        }
        if (userIdentityToken.encryptionAlgorithm !== cryptoFactory.asymmetricEncryptionAlgorithm) {
          errorLog("invalid encryptionAlgorithm");
          errorLog("userTokenPolicy", userTokenPolicy.toString());
          errorLog("userTokenPolicy", userIdentityToken.toString());
          return callback(null, node_opcua_status_code_1.StatusCodes.BadIdentityTokenInvalid);
        }
        const userName = userIdentityToken.userName;
        const password = userIdentityToken.password;
        if (!userName || !password) {
          return callback(null, node_opcua_status_code_1.StatusCodes.BadIdentityTokenInvalid);
        }
        return callback(null, node_opcua_status_code_1.StatusCodes.Good);
      }
      isValidX509IdentityToken(channel, session, userTokenPolicy, userIdentityToken, userTokenSignature, callback) {
        (0, node_opcua_assert_1.assert)(userIdentityToken instanceof node_opcua_service_session_1.X509IdentityToken);
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        const securityPolicy = adjustSecurityPolicy(channel, userTokenPolicy.securityPolicyUri);
        const cryptoFactory = (0, node_opcua_secure_channel_1.getCryptoFactory)(securityPolicy);
        if (!cryptoFactory) {
          return callback(null, node_opcua_status_code_1.StatusCodes.BadSecurityPolicyRejected);
        }
        if (!userTokenSignature || !userTokenSignature.signature) {
          this.raiseEvent("AuditCreateSessionEventType", {});
          return callback(null, node_opcua_status_code_1.StatusCodes.BadUserSignatureInvalid);
        }
        if (userIdentityToken.policyId !== userTokenPolicy.policyId) {
          errorLog("invalid encryptionAlgorithm");
          errorLog("userTokenPolicy", userTokenPolicy.toString());
          errorLog("userTokenPolicy", userIdentityToken.toString());
          return callback(null, node_opcua_status_code_1.StatusCodes.BadSecurityPolicyRejected);
        }
        const certificate = userIdentityToken.certificateData;
        const nonce = session.nonce;
        const serverCertificate = this.getCertificate();
        (0, node_opcua_assert_1.assert)(serverCertificate instanceof Buffer);
        (0, node_opcua_assert_1.assert)(certificate instanceof Buffer, "expecting certificate to be a Buffer");
        (0, node_opcua_assert_1.assert)(nonce instanceof Buffer, "expecting nonce to be a Buffer");
        (0, node_opcua_assert_1.assert)(userTokenSignature.signature instanceof Buffer, "expecting userTokenSignature to be a Buffer");
        if (!(0, node_opcua_secure_channel_1.verifySignature)(serverCertificate, nonce, userTokenSignature, certificate, securityPolicy)) {
          return callback(null, node_opcua_status_code_1.StatusCodes.BadUserSignatureInvalid);
        }
        this.userCertificateManager.checkCertificate(certificate, (err, certificateStatus) => {
          if (err) {
            return callback(err);
          }
          if (this.isAuditing) {
            switch (certificateStatus) {
              case node_opcua_status_code_1.StatusCodes.Good:
                break;
              case node_opcua_status_code_1.StatusCodes.BadCertificateUntrusted:
                this.raiseEvent("AuditCertificateUntrustedEventType", {
                  certificate: { dataType: node_opcua_variant_1.DataType.ByteString, value: certificate },
                  sourceName: { dataType: node_opcua_variant_1.DataType.String, value: "Security/Certificate" }
                });
                break;
              case node_opcua_status_code_1.StatusCodes.BadCertificateTimeInvalid:
              case node_opcua_status_code_1.StatusCodes.BadCertificateIssuerTimeInvalid:
                this.raiseEvent("AuditCertificateExpiredEventType", {
                  certificate: { dataType: node_opcua_variant_1.DataType.ByteString, value: certificate },
                  sourceName: { dataType: node_opcua_variant_1.DataType.String, value: "Security/Certificate" }
                });
                break;
              case node_opcua_status_code_1.StatusCodes.BadCertificateRevoked:
              case node_opcua_status_code_1.StatusCodes.BadCertificateRevocationUnknown:
              case node_opcua_status_code_1.StatusCodes.BadCertificateIssuerRevocationUnknown:
                this.raiseEvent("AuditCertificateRevokedEventType", {
                  certificate: { dataType: node_opcua_variant_1.DataType.ByteString, value: certificate },
                  sourceName: { dataType: node_opcua_variant_1.DataType.String, value: "Security/Certificate" }
                });
                break;
              case node_opcua_status_code_1.StatusCodes.BadCertificateIssuerUseNotAllowed:
              case node_opcua_status_code_1.StatusCodes.BadCertificateUseNotAllowed:
              case node_opcua_status_code_1.StatusCodes.BadSecurityChecksFailed:
                this.raiseEvent("AuditCertificateMismatchEventType", {
                  certificate: { dataType: node_opcua_variant_1.DataType.ByteString, value: certificate },
                  sourceName: { dataType: node_opcua_variant_1.DataType.String, value: "Security/Certificate" }
                });
                break;
            }
          }
          if (certificateStatus && (node_opcua_status_code_1.StatusCodes.BadCertificateUntrusted.equals(certificateStatus) || node_opcua_status_code_1.StatusCodes.BadCertificateTimeInvalid.equals(certificateStatus) || node_opcua_status_code_1.StatusCodes.BadCertificateIssuerTimeInvalid.equals(certificateStatus) || node_opcua_status_code_1.StatusCodes.BadCertificateIssuerUseNotAllowed.equals(certificateStatus) || node_opcua_status_code_1.StatusCodes.BadCertificateIssuerRevocationUnknown.equals(certificateStatus) || node_opcua_status_code_1.StatusCodes.BadCertificateRevocationUnknown.equals(certificateStatus) || node_opcua_status_code_1.StatusCodes.BadCertificateRevoked.equals(certificateStatus) || node_opcua_status_code_1.StatusCodes.BadCertificateUseNotAllowed.equals(certificateStatus) || node_opcua_status_code_1.StatusCodes.BadSecurityChecksFailed.equals(certificateStatus) || !node_opcua_status_code_1.StatusCodes.Good.equals(certificateStatus))) {
            debugLog("isValidX509IdentityToken => certificateStatus = ", certificateStatus?.toString());
            return callback(null, node_opcua_status_code_1.StatusCodes.BadIdentityTokenRejected);
          }
          if (node_opcua_status_code_1.StatusCodes.Good !== certificateStatus) {
            (0, node_opcua_assert_1.assert)(certificateStatus instanceof node_opcua_status_code_1.StatusCode);
            return callback(null, certificateStatus);
          }
          return callback(null, node_opcua_status_code_1.StatusCodes.Good);
        });
      }
      /**
       * @internal
       */
      userNameIdentityTokenAuthenticateUser(channel, session, userTokenPolicy, userIdentityToken, callback) {
        (0, node_opcua_assert_1.assert)(userIdentityToken instanceof node_opcua_service_session_1.UserNameIdentityToken);
        const securityPolicy = adjustSecurityPolicy(channel, userTokenPolicy.securityPolicyUri);
        const userName = userIdentityToken.userName;
        let password = userIdentityToken.password;
        if (securityPolicy === node_opcua_secure_channel_1.SecurityPolicy.None) {
          password = password.toString();
        } else {
          const serverPrivateKey = this.getPrivateKey();
          const serverNonce = session.nonce;
          (0, node_opcua_assert_1.assert)(serverNonce instanceof Buffer);
          const cryptoFactory = (0, node_opcua_secure_channel_1.getCryptoFactory)(securityPolicy);
          if (!cryptoFactory) {
            return callback(new Error(" Unsupported security Policy"));
          }
          const buff = cryptoFactory.asymmetricDecrypt(password, serverPrivateKey);
          if (!buff || buff.length < 4) {
            async_1.default.setImmediate(() => callback(null, false));
            return;
          }
          const length = buff.readUInt32LE(0) - serverNonce.length;
          password = buff.subarray(4, 4 + length).toString("utf-8");
        }
        this.userManager.isValidUser(session, userName, password).then((isValid) => callback(null, isValid)).catch((err) => callback(err));
      }
      /**
       * @internal
       */
      isValidUserIdentityToken(channel, session, userIdentityToken, userTokenSignature, endpointDescription, callback) {
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        if (!userIdentityToken) {
          throw new Error("Invalid token");
        }
        const userTokenType = getTokenType(userIdentityToken);
        const userTokenPolicy = findUserTokenByPolicy(endpointDescription, userTokenType, userIdentityToken.policyId);
        if (!userTokenPolicy) {
          return callback(null, node_opcua_status_code_1.StatusCodes.BadIdentityTokenInvalid);
        }
        if (userIdentityToken instanceof node_opcua_service_session_1.UserNameIdentityToken) {
          return this.isValidUserNameIdentityToken(channel, session, userTokenPolicy, userIdentityToken, userTokenSignature, callback);
        }
        if (userIdentityToken instanceof node_opcua_service_session_1.X509IdentityToken) {
          return this.isValidX509IdentityToken(channel, session, userTokenPolicy, userIdentityToken, userTokenSignature, callback);
        }
        return callback(null, node_opcua_status_code_1.StatusCodes.Good);
      }
      /**
       *
       * @internal
       * @param channel
       * @param session
       * @param userIdentityToken
       * @param callback
       * @returns {*}
       */
      isUserAuthorized(channel, session, userIdentityToken, callback) {
        (0, node_opcua_assert_1.assert)(userIdentityToken);
        (0, node_opcua_assert_1.assert)(typeof callback === "function");
        const userTokenType = getTokenType(userIdentityToken);
        const userTokenPolicy = findUserTokenByPolicy(session.getEndpointDescription(), userTokenType, userIdentityToken.policyId);
        if (!userTokenPolicy) {
          return callback(null, false);
        }
        if (userIdentityToken instanceof node_opcua_service_session_1.UserNameIdentityToken) {
          return this.userNameIdentityTokenAuthenticateUser(channel, session, userTokenPolicy, userIdentityToken, callback);
        }
        async_1.default.setImmediate(callback.bind(null, null, true));
      }
      makeServerNonce() {
        return (0, crypto_1.randomBytes)(32);
      }
      // session services
      // eslint-disable-next-line max-statements
      async _on_CreateSessionRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_session_1.CreateSessionRequest);
        function rejectConnection(server, statusCode) {
          server.engine.incrementSecurityRejectedSessionCount();
          const response1 = new node_opcua_types_1.ServiceFault({
            responseHeader: { serviceResult: statusCode }
          });
          channel.send_response("MSG", response1, message);
        }
        if (this.currentSessionCount >= this.engine.serverCapabilities.maxSessions) {
          await _attempt_to_close_some_old_unactivated_session(this);
        }
        if (this.currentSessionCount >= this.engine.serverCapabilities.maxSessions) {
          return rejectConnection(this, node_opcua_status_code_1.StatusCodes.BadTooManySessions);
        }
        if ((0, node_opcua_utils_1.isNullOrUndefined)(request.sessionName)) {
          debugLog("assigning OPCUAServer.fallbackSessionName because client's sessionName is null ", _OPCUAServer.fallbackSessionName);
          request.sessionName = _OPCUAServer.fallbackSessionName;
        }
        const revisedSessionTimeout = _adjust_session_timeout(request.requestedSessionTimeout);
        if (!request.clientNonce || request.clientNonce.length < 32) {
          if (channel.securityMode !== node_opcua_secure_channel_1.MessageSecurityMode.None) {
            errorLog(chalk_1.default.red("SERVER with secure connection: Missing or invalid client Nonce "), request.clientNonce && request.clientNonce.toString("hex"));
            return rejectConnection(this, node_opcua_status_code_1.StatusCodes.BadNonceInvalid);
          }
        }
        if ((0, node_opcua_secure_channel_1.nonceAlreadyBeenUsed)(request.clientNonce)) {
          errorLog(chalk_1.default.red("SERVER with secure connection: None has already been used"), request.clientNonce && request.clientNonce.toString("hex"));
          return rejectConnection(this, node_opcua_status_code_1.StatusCodes.BadNonceInvalid);
        }
        if (!validate_applicationUri(channel, request)) {
          return rejectConnection(this, node_opcua_status_code_1.StatusCodes.BadCertificateUriInvalid);
        }
        const { errCode, endpoint } = validate_security_endpoint(this, request, channel);
        if (errCode !== node_opcua_status_code_1.StatusCodes.Good) {
          return rejectConnection(this, errCode);
        }
        const session = this.createSession({
          clientDescription: request.clientDescription,
          sessionTimeout: revisedSessionTimeout,
          server: this
        });
        session.endpoint = endpoint;
        (0, node_opcua_assert_1.assert)(session);
        (0, node_opcua_assert_1.assert)(session.sessionTimeout === revisedSessionTimeout);
        session.clientDescription = request.clientDescription;
        session.sessionName = request.sessionName || `<unknown session name ${unnamed_session_count++}>`;
        session.nonce = this.makeServerNonce();
        session.channelId = channel.channelId;
        session._attach_channel(channel);
        const serverCertificateChain = this.getCertificateChain();
        const hasEncryption = true;
        if (session.channel.securityMode === node_opcua_secure_channel_1.MessageSecurityMode.None) {
        }
        const response = new node_opcua_service_session_1.CreateSessionResponse({
          // A identifier which uniquely identifies the session.
          sessionId: session.nodeId,
          // A unique identifier assigned by the Server to the Session.
          // The token used to authenticate the client in subsequent requests.
          authenticationToken: session.authenticationToken,
          revisedSessionTimeout,
          serverNonce: session.nonce,
          // serverCertificate: type ApplicationServerCertificate
          // The application instance Certificate issued to the Server.
          // A Server shall prove possession by using the private key to sign the Nonce provided
          // by the Client in the request. The Client shall verify that this Certificate is the same as
          // the one it used to create the SecureChannel.
          // The ApplicationInstanceCertificate type is defined in OpCUA 1.03 part 4 - $7.2 page 108
          // If the securityPolicyUri is None and none of the UserTokenPolicies requires
          // encryption, the Server shall not send an ApplicationInstanceCertificate and the Client
          // shall ignore the ApplicationInstanceCertificate.
          serverCertificate: hasEncryption ? serverCertificateChain : void 0,
          // The endpoints provided by the server.
          // The Server shall return a set of EndpointDescriptions available for the serverUri
          // specified in the request.[...]
          // The Client shall verify this list with the list from a Discovery Endpoint if it used a Discovery
          // Endpoint to fetch the EndpointDescriptions.
          // It is recommended that Servers only include the endpointUrl, securityMode,
          // securityPolicyUri, userIdentityTokens, transportProfileUri and securityLevel with all
          // other parameters set to null. Only the recommended parameters shall be verified by
          // the client.
          serverEndpoints: _serverEndpointsForCreateSessionResponse(this, session.endpoint.endpointUrl, request.serverUri),
          // This parameter is deprecated and the array shall be empty.
          serverSoftwareCertificates: null,
          // This is a signature generated with the private key associated with the
          // serverCertificate. This parameter is calculated by appending the clientNonce to the
          // clientCertificate and signing the resulting sequence of bytes.
          // The SignatureAlgorithm shall be the AsymmetricSignatureAlgorithm specified in the
          // SecurityPolicy for the Endpoint.
          // The SignatureData type is defined in 7.30.
          serverSignature: this.computeServerSignature(channel, request.clientCertificate, request.clientNonce),
          // The maximum message size accepted by the server
          // The Client Communication Stack should return a Bad_RequestTooLarge error to the
          // application if a request message exceeds this limit.
          // The value zero indicates that this parameter is not used.
          maxRequestMessageSize: 67108864
        });
        this.emit("create_session", session);
        session.on("session_closed", (session1, deleteSubscriptions, reason) => {
          (0, node_opcua_assert_1.assert)(typeof reason === "string");
          if (this.isAuditing) {
            (0, node_opcua_assert_1.assert)(reason === "Timeout" || reason === "Terminated" || reason === "CloseSession" || reason === "Forcing");
            const sourceName = "Session/" + reason;
            this.raiseEvent("AuditSessionEventType", {
              /* part 5 -  6.4.3 AuditEventType */
              actionTimeStamp: { dataType: "DateTime", value: /* @__PURE__ */ new Date() },
              status: { dataType: "Boolean", value: true },
              serverId: { dataType: "String", value: "" },
              // ClientAuditEntryId contains the human-readable AuditEntryId defined in Part 3.
              clientAuditEntryId: { dataType: "String", value: "" },
              // The ClientUserId identifies the user of the client requesting an action. The ClientUserId can be
              // obtained from the UserIdentityToken passed in the ActivateSession call.
              clientUserId: { dataType: "String", value: "" },
              sourceName: { dataType: "String", value: sourceName },
              /* part 5 - 6.4.7 AuditSessionEventType */
              sessionId: { dataType: "NodeId", value: session1.nodeId }
            });
          }
          this.emit("session_closed", session1, deleteSubscriptions);
        });
        if (this.isAuditing) {
          this.raiseEvent("AuditCreateSessionEventType", {
            /* part 5 -  6.4.3 AuditEventType */
            actionTimeStamp: { dataType: "DateTime", value: /* @__PURE__ */ new Date() },
            status: { dataType: "Boolean", value: true },
            serverId: { dataType: "String", value: "" },
            // ClientAuditEntryId contains the human-readable AuditEntryId defined in Part 3.
            clientAuditEntryId: { dataType: "String", value: "" },
            // The ClientUserId identifies the user of the client requesting an action. The ClientUserId can be
            // obtained from the UserIdentityToken passed in the ActivateSession call.
            clientUserId: { dataType: "String", value: "" },
            sourceName: { dataType: "String", value: "Session/CreateSession" },
            /* part 5 - 6.4.7 AuditSessionEventType */
            sessionId: { dataType: "NodeId", value: session.nodeId },
            /* part 5 - 6.4.8 AuditCreateSessionEventType */
            // SecureChannelId shall uniquely identify the SecureChannel. The application shall use the same
            // identifier in all AuditEvents related to the Session Service Set (AuditCreateSessionEventType,
            // AuditActivateSessionEventType and their subtypes) and the SecureChannel Service Set
            // (AuditChannelEventType and its subtypes
            secureChannelId: { dataType: "String", value: session.channel.channelId.toString() },
            // Duration
            revisedSessionTimeout: { dataType: "Duration", value: session.sessionTimeout },
            // clientCertificate
            clientCertificate: { dataType: "ByteString", value: session.channel.clientCertificate },
            // clientCertificateThumbprint
            clientCertificateThumbprint: {
              dataType: "String",
              value: thumbprint(session.channel.clientCertificate)
            }
          });
        }
        (0, node_opcua_assert_1.assert)(response.authenticationToken);
        channel.send_response("MSG", response, message);
      }
      // TODO : implement this:
      //
      // When the ActivateSession Service is called for the first time then the Server shall reject the request
      // if the SecureChannel is not same as the one associated with the CreateSession request.
      // Subsequent calls to ActivateSession may be associated with different SecureChannels. If this is the
      // case then the Server shall verify that the Certificate the Client used to create the new
      // SecureChannel is the same as the Certificate used to create the original SecureChannel. In addition,
      // the Server shall verify that the Client supplied a UserIdentityToken that is identical to the token
      // currently associated with the Session. Once the Server accepts the new SecureChannel it shall
      // reject requests sent via the old SecureChannel.
      /**
       *
       * @method _on_ActivateSessionRequest
       * @private
       *
       *
       */
      _on_ActivateSessionRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_session_1.ActivateSessionRequest);
        const authenticationToken = request.requestHeader.authenticationToken;
        const session = this.getSession(authenticationToken);
        function rejectConnection(server, statusCode) {
          if (statusCode.equals(node_opcua_status_code_1.StatusCodes.BadSessionIdInvalid)) {
            server.engine.incrementRejectedSessionCount();
          } else {
            server.engine.incrementRejectedSessionCount();
            server.engine.incrementSecurityRejectedSessionCount();
          }
          const response1 = new node_opcua_service_session_1.ActivateSessionResponse({ responseHeader: { serviceResult: statusCode } });
          channel.send_response("MSG", response1, message);
        }
        let response;
        if (!session) {
          debugLog(chalk_1.default.yellow.bold(" Bad Session in  _on_ActivateSessionRequest"), authenticationToken.toString());
          return rejectConnection(this, node_opcua_status_code_1.StatusCodes.BadSessionIdInvalid);
        }
        session.keepAlive ? session.keepAlive() : void 0;
        if (session.status === "new") {
          if (!channel_has_session(channel, session)) {
            errorLog(" channel.sessionTokens === " + Object.keys(channel.sessionTokens).join(" "));
            return rejectConnection(this, node_opcua_status_code_1.StatusCodes.BadSessionNotActivated);
          }
        }
        if (session.status === "active") {
          if (session.channel.channelId !== channel.channelId) {
            warningLog(" Session ", session.sessionName, " is being transferred from channel", chalk_1.default.cyan(session.channel.channelId.toString()), " to channel ", chalk_1.default.cyan(channel.channelId.toString()));
            const old_channel_cert_thumbprint = thumbprint(session.channel.clientCertificate);
            const new_channel_cert_thumbprint = thumbprint(channel.clientCertificate);
            if (old_channel_cert_thumbprint !== new_channel_cert_thumbprint) {
              return rejectConnection(this, node_opcua_status_code_1.StatusCodes.BadNoValidCertificates);
            }
            if (!sameIdentityToken(session.userIdentityToken, request.userIdentityToken)) {
              return rejectConnection(this, node_opcua_status_code_1.StatusCodes.BadIdentityChangeNotSupported);
            }
          }
        } else if (session.status === "screwed") {
          return rejectConnection(this, node_opcua_status_code_1.StatusCodes.BadSessionClosed);
        } else if (session.status === "closed") {
          warningLog(chalk_1.default.yellow.bold(" Bad Session Closed in  _on_ActivateSessionRequest"), authenticationToken.toString());
          return rejectConnection(this, node_opcua_status_code_1.StatusCodes.BadSessionClosed);
        }
        if (!this.verifyClientSignature(session, channel, request.clientSignature)) {
          return rejectConnection(this, node_opcua_status_code_1.StatusCodes.BadApplicationSignatureInvalid);
        }
        request.userIdentityToken = request.userIdentityToken || createAnonymousIdentityToken(session.endpoint);
        this.isValidUserIdentityToken(channel, session, request.userIdentityToken, request.userTokenSignature, session.endpoint, (err, statusCode) => {
          if (!statusCode || statusCode.isNotGood()) {
            if (!(statusCode && statusCode instanceof node_opcua_status_code_1.StatusCode)) {
              return rejectConnection(this, node_opcua_status_code_1.StatusCodes.BadCertificateInvalid);
            }
            return rejectConnection(this, statusCode);
          }
          this.isUserAuthorized(channel, session, request.userIdentityToken, (err1, authorized) => {
            if (err1) {
              return rejectConnection(this, node_opcua_status_code_1.StatusCodes.BadInternalError);
            }
            if (!authorized) {
              return rejectConnection(this, node_opcua_status_code_1.StatusCodes.BadUserAccessDenied);
            } else {
              if (session.status === "active") {
                moveSessionToChannel(session, channel);
              }
              session.userIdentityToken = request.userIdentityToken;
              session.nonce = this.makeServerNonce();
              session.status = "active";
              response = new node_opcua_service_session_1.ActivateSessionResponse({ serverNonce: session.nonce });
              channel.send_response("MSG", response, message);
              (0, node_opcua_assert_1.assert)(session.nodeId);
              (0, node_opcua_assert_1.assert)(session.sessionTimeout > 0);
              raiseAuditActivateSessionEventType.call(this, session);
              this.emit("session_activated", session, userIdentityTokenPasswordRemoved(session.userIdentityToken));
              session.resendMonitoredItemInitialValues();
            }
          });
        });
      }
      prepare(message, channel) {
        const request = message.request;
        const authenticationToken = request.requestHeader.authenticationToken;
        const session = this.getSession(
          authenticationToken,
          /*activeOnly*/
          true
        );
        if (!session) {
          message.session_statusCode = node_opcua_status_code_1.StatusCodes.BadSessionIdInvalid;
          return;
        }
        message.session = session;
        if (channel.channelId !== session.channelId) {
          if (!(request instanceof node_opcua_service_session_1.ActivateSessionRequest)) {
            errorLog(chalk_1.default.red.bgWhite("ERROR: channel.channelId !== session.channelId  on processing request " + request.constructor.name), channel.channelId, session.channelId);
          }
          message.session_statusCode = node_opcua_status_code_1.StatusCodes.BadSecureChannelIdInvalid;
        } else if (channel_has_session(channel, session)) {
          message.session_statusCode = node_opcua_status_code_1.StatusCodes.Good;
        } else {
          message.session_statusCode = node_opcua_status_code_1.StatusCodes.BadSecureChannelIdInvalid;
        }
      }
      /**
       * ensure that action is performed on a valid session object,
       * @method _apply_on_SessionObject
       * @param ResponseClass the constructor of the response Class
       * @param message
       * @param channel
       * @param actionToPerform
       * @param actionToPerform.session {ServerSession}
       * @param actionToPerform.sendResponse
       * @param actionToPerform.sendResponse.response
       * @param actionToPerform.sendError
       * @param actionToPerform.sendError.statusCode
       * @param actionToPerform.sendError.diagnostics
       *
       * @private
       */
      async _apply_on_SessionObject(ResponseClass, message, channel, actionToPerform) {
        (0, node_opcua_assert_1.assert)(typeof actionToPerform === "function");
        function sendResponse(response1) {
          try {
            (0, node_opcua_assert_1.assert)(response1 instanceof ResponseClass || response1 instanceof node_opcua_types_1.ServiceFault);
            if (message.session) {
              const counterName = ResponseClass.schema.name.replace("Response", "");
              message.session.incrementRequestTotalCounter(counterName);
            }
            return channel.send_response("MSG", response1, message);
          } catch (err) {
            warningLog(err);
            if (util_1.types.isNativeError(err)) {
              errorLog("Internal error in issuing response\nplease contact support@sterfive.com", message.request.toString(), "\n", response1.toString());
            }
            throw err;
          }
        }
        function sendError(statusCode) {
          if (message.session) {
            message.session.incrementRequestErrorCounter(ResponseClass.schema.name.replace("Response", ""));
          }
          return g_sendError(channel, message, ResponseClass, statusCode);
        }
        let response;
        if (!message.session || message.session_statusCode !== node_opcua_status_code_1.StatusCodes.Good) {
          const errMessage = "=>" + message.session_statusCode?.toString();
          response = new node_opcua_types_1.ServiceFault({ responseHeader: { serviceResult: message.session_statusCode } });
          debugLog(chalk_1.default.red.bold(errMessage), chalk_1.default.yellow(message.session_statusCode.toString()), response.constructor.name);
          return sendResponse(response);
        }
        (0, node_opcua_assert_1.assert)(message.session_statusCode.isGood());
        if (message.session.status === "closed") {
          return sendError(node_opcua_status_code_1.StatusCodes.BadSessionIdInvalid);
        }
        if (message.session.status === "new") {
          message.session.status = "screwed";
          return sendError(node_opcua_status_code_1.StatusCodes.BadSessionNotActivated);
        }
        if (message.session.status !== "active") {
          message.session.status = "screwed";
          return sendError(node_opcua_status_code_1.StatusCodes.BadSessionIdInvalid);
        }
        if (message.session.keepAlive) {
          (0, node_opcua_assert_1.assert)(typeof message.session.keepAlive === "function");
          message.session.keepAlive();
        }
        message.session.incrementTotalRequestCount();
        await actionToPerform(message.session, sendResponse, sendError);
      }
      async _apply_on_Subscription(ResponseClass, message, channel, actionToPerform) {
        (0, node_opcua_assert_1.assert)(typeof actionToPerform === "function");
        const request = message.request;
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(request, "subscriptionId"));
        this._apply_on_SessionObject(ResponseClass, message, channel, async (session, sendResponse, sendError) => {
          const subscription = session.getSubscription(request.subscriptionId);
          if (!subscription) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadSubscriptionIdInvalid);
          }
          subscription.resetLifeTimeAndKeepAliveCounters();
          await actionToPerform(session, subscription, sendResponse, sendError);
        });
      }
      _apply_on_SubscriptionIds(ResponseClass, message, channel, actionToPerform) {
        (0, node_opcua_assert_1.assert)(typeof actionToPerform === "function");
        const request = message.request;
        (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(request, "subscriptionIds"));
        this._apply_on_SessionObject(ResponseClass, message, channel, async (session, sendResponse, sendError) => {
          const subscriptionIds = request.subscriptionIds;
          if (!request.subscriptionIds || request.subscriptionIds.length === 0) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadNothingToDo);
          }
          if (request.subscriptionIds.length > Math.min(this.engine.serverCapabilities.maxSubscriptionsPerSession, this.engine.serverCapabilities.maxSubscriptions)) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadTooManyOperations);
          }
          const promises = subscriptionIds.map((subscriptionId) => actionToPerform(session, subscriptionId));
          const results = await Promise.all(promises);
          const serviceResult = node_opcua_status_code_1.StatusCodes.Good;
          const response = new ResponseClass({
            responseHeader: {
              serviceResult
            },
            results
          });
          sendResponse(response);
        });
      }
      _apply_on_Subscriptions(ResponseClass, message, channel, actionToPerform) {
        this._apply_on_SubscriptionIds(ResponseClass, message, channel, async (session, subscriptionId) => {
          if (isSubscriptionIdInvalid(subscriptionId)) {
            return node_opcua_status_code_1.StatusCodes.BadSubscriptionIdInvalid;
          }
          const subscription = session.getSubscription(subscriptionId);
          if (!subscription) {
            return node_opcua_status_code_1.StatusCodes.BadSubscriptionIdInvalid;
          }
          return actionToPerform(session, subscription);
        });
      }
      async _closeSession(authenticationToken, deleteSubscriptions, reason) {
        if (deleteSubscriptions && this.options.onDeleteMonitoredItem) {
          const session = this.getSession(authenticationToken);
          if (session) {
            const subscriptions = session.publishEngine.subscriptions;
            for (const subscription of subscriptions) {
              await subscription.applyOnMonitoredItem(this.options.onDeleteMonitoredItem.bind(null, subscription));
            }
          }
        }
        await this.engine.closeSession(authenticationToken, deleteSubscriptions, reason);
      }
      /**
       * @method _on_CloseSessionRequest
       * @param message
       * @param channel
       * @private
       */
      _on_CloseSessionRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_session_1.CloseSessionRequest);
        let response;
        message.session_statusCode = node_opcua_status_code_1.StatusCodes.Good;
        function sendError(statusCode) {
          return g_sendError(channel, message, node_opcua_service_session_1.CloseSessionResponse, statusCode);
        }
        function sendResponse(response1) {
          channel.send_response("MSG", response1, message);
        }
        const session = message.session;
        if (!session) {
          return sendError(node_opcua_status_code_1.StatusCodes.BadSessionIdInvalid);
        }
        const wasNotActivated = session.status === "new";
        (async () => {
          try {
            await this._closeSession(request.requestHeader.authenticationToken, request.deleteSubscriptions, "CloseSession");
            response = new node_opcua_service_session_1.CloseSessionResponse({});
            sendResponse(response);
          } catch (err) {
            sendError(node_opcua_status_code_1.StatusCodes.BadInternalError);
          }
        })();
      }
      // browse services
      /**
       * @method _on_BrowseRequest
       * @param message
       * @param channel
       * @private
       */
      _on_BrowseRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_browse_1.BrowseRequest);
        const diagnostic = {};
        this._apply_on_SessionObject(node_opcua_service_browse_1.BrowseResponse, message, channel, (session, sendResponse, sendError) => {
          let response;
          if (request.view && !request.view.viewId.isEmpty()) {
            let theView = this.engine.addressSpace.findNode(request.view.viewId);
            if (theView && theView.nodeClass !== node_opcua_data_model_1.NodeClass.View) {
              diagnostic.localizedText = { text: "Expecting a view here" };
              theView = null;
            }
            if (!theView) {
              return sendError(node_opcua_status_code_1.StatusCodes.BadViewIdUnknown);
            }
          }
          if (!request.nodesToBrowse || request.nodesToBrowse.length === 0) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadNothingToDo);
          }
          if (this.engine.serverCapabilities.operationLimits.maxNodesPerBrowse > 0) {
            if (request.nodesToBrowse.length > this.engine.serverCapabilities.operationLimits.maxNodesPerBrowse) {
              return sendError(node_opcua_status_code_1.StatusCodes.BadTooManyOperations);
            }
          }
          const requestedMaxReferencesPerNode = Math.min(9876, request.requestedMaxReferencesPerNode);
          (0, node_opcua_assert_1.assert)(request.nodesToBrowse[0].schema.name === "BrowseDescription");
          const context = session.sessionContext;
          const browseAll = (nodesToBrowse, callack) => {
            const f2 = (0, util_1.callbackify)(this.engine.browseWithAutomaticExpansion).bind(this.engine);
            f2(request.nodesToBrowse, context, callack);
          };
          const maxBrowseContinuationPoints = this.engine.serverCapabilities.maxBrowseContinuationPoints;
          (0, node_opcua_address_space_1.innerBrowse)({
            browseAll,
            context,
            continuationPointManager: session.continuationPointManager,
            requestedMaxReferencesPerNode,
            maxBrowseContinuationPoints
          }, request.nodesToBrowse, (err, results) => {
            if (!results) {
              return sendError(node_opcua_status_code_1.StatusCodes.BadInternalError);
            }
            (0, node_opcua_assert_1.assert)(results[0].schema.name === "BrowseResult");
            response = new node_opcua_service_browse_1.BrowseResponse({
              diagnosticInfos: void 0,
              results
            });
            sendResponse(response);
          });
        });
      }
      /**
       * @method _on_BrowseNextRequest
       * @param message
       * @param channel
       * @private
       */
      _on_BrowseNextRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_browse_1.BrowseNextRequest);
        this._apply_on_SessionObject(node_opcua_service_browse_1.BrowseNextResponse, message, channel, (session, sendResponse, sendError) => {
          if (!request.continuationPoints || request.continuationPoints.length === 0) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadNothingToDo);
          }
          (0, node_opcua_address_space_1.innerBrowseNext)({
            continuationPointManager: session.continuationPointManager
          }, request.continuationPoints, request.releaseContinuationPoints, (err, results) => {
            if (err) {
              return sendError(node_opcua_status_code_1.StatusCodes.BadInternalError);
            }
            const response = new node_opcua_service_browse_1.BrowseNextResponse({
              diagnosticInfos: void 0,
              results
            });
            sendResponse(response);
          });
        });
      }
      // read services
      _on_ReadRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_read_1.ReadRequest);
        this._apply_on_SessionObject(node_opcua_service_read_1.ReadResponse, message, channel, (session, sendResponse, sendError) => {
          const context = session.sessionContext;
          const timestampsToReturn = request.timestampsToReturn;
          if (timestampsToReturn === node_opcua_service_read_1.TimestampsToReturn.Invalid) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadTimestampsToReturnInvalid);
          }
          if (request.maxAge < 0) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadMaxAgeInvalid);
          }
          request.nodesToRead = request.nodesToRead || [];
          if (!request.nodesToRead || request.nodesToRead.length <= 0) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadNothingToDo);
          }
          (0, node_opcua_assert_1.assert)(request.nodesToRead[0].schema.name === "ReadValueId");
          if (this.engine.serverCapabilities.operationLimits.maxNodesPerRead > 0) {
            if (request.nodesToRead.length > this.engine.serverCapabilities.operationLimits.maxNodesPerRead) {
              return sendError(node_opcua_status_code_1.StatusCodes.BadTooManyOperations);
            }
          }
          for (const nodeToRead of request.nodesToRead) {
            nodeToRead.nodeId = session.resolveRegisteredNode(nodeToRead.nodeId);
          }
          this.engine.refreshValues(request.nodesToRead, request.maxAge, (err) => {
            this.engine.read(context, request).then((results) => {
              (0, node_opcua_assert_1.assert)(results[0].schema.name === "DataValue");
              (0, node_opcua_assert_1.assert)(results.length === request.nodesToRead.length);
              const response = new node_opcua_service_read_1.ReadResponse({
                diagnosticInfos: void 0,
                results: void 0
              });
              response.results = results;
              (0, node_opcua_assert_1.assert)(response.diagnosticInfos.length === 0);
              sendResponse(response);
            });
          });
        });
      }
      // read services
      _on_HistoryReadRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_history_1.HistoryReadRequest);
        this._apply_on_SessionObject(node_opcua_service_history_1.HistoryReadResponse, message, channel, (session, sendResponse, sendError) => {
          let response;
          const timestampsToReturn = request.timestampsToReturn;
          if (timestampsToReturn === node_opcua_service_read_1.TimestampsToReturn.Invalid) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadTimestampsToReturnInvalid);
          }
          request.nodesToRead = request.nodesToRead || [];
          if (!request.nodesToRead || request.nodesToRead.length <= 0) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadNothingToDo);
          }
          (0, node_opcua_assert_1.assert)(request.nodesToRead[0].schema.name === "HistoryReadValueId");
          if (this.engine.serverCapabilities.operationLimits.maxNodesPerRead > 0) {
            if (request.nodesToRead.length > this.engine.serverCapabilities.operationLimits.maxNodesPerRead) {
              return sendError(node_opcua_status_code_1.StatusCodes.BadTooManyOperations);
            }
          }
          if (this.engine.serverCapabilities.operationLimits.maxNodesPerHistoryReadData > 0) {
            if (request.nodesToRead.length > this.engine.serverCapabilities.operationLimits.maxNodesPerHistoryReadData) {
              return sendError(node_opcua_status_code_1.StatusCodes.BadTooManyOperations);
            }
          }
          if (this.engine.serverCapabilities.operationLimits.maxNodesPerHistoryReadEvents > 0) {
            if (request.nodesToRead.length > this.engine.serverCapabilities.operationLimits.maxNodesPerHistoryReadEvents) {
              return sendError(node_opcua_status_code_1.StatusCodes.BadTooManyOperations);
            }
          }
          const context = session.sessionContext;
          this.engine.refreshValues(request.nodesToRead, 0, (err) => {
            (0, node_opcua_assert_1.assert)(!err, " error not handled here , fix me");
            this.engine.historyRead(context, request).then((results) => {
              (0, node_opcua_assert_1.assert)(results[0].schema.name === "HistoryReadResult");
              (0, node_opcua_assert_1.assert)(results.length === request.nodesToRead.length);
              response = new node_opcua_service_history_1.HistoryReadResponse({
                diagnosticInfos: void 0,
                results
              });
              (0, node_opcua_assert_1.assert)(response.diagnosticInfos.length === 0);
              sendResponse(response);
            }).catch((err2) => {
              return sendError(node_opcua_status_code_1.StatusCodes.BadHistoryOperationInvalid);
            });
          });
        });
      }
      /*
      // write services
      // OPCUA Specification 1.02 Part 3 : 5.10.4 Write
      // This Service is used to write values to one or more Attributes of one or more Nodes. For constructed
      // Attribute values whose elements are indexed, such as an array, this Service allows Clients to write
      // the entire set of indexed values as a composite, to write individual elements or to write ranges of
      // elements of the composite.
      // The values are written to the data source, such as a device, and the Service does not return until it writes
      // the values or determines that the value cannot be written. In certain cases, the Server will successfully
      // to an intermediate system or Server, and will not know if the data source was updated properly. In these cases,
      // the Server should report a success code that indicates that the write was not verified.
      // In the cases where the Server is able to verify that it has successfully written to the data source,
      // it reports an unconditional success.
      */
      _on_WriteRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_write_1.WriteRequest);
        (0, node_opcua_assert_1.assert)(!request.nodesToWrite || Array.isArray(request.nodesToWrite));
        this._apply_on_SessionObject(node_opcua_service_write_1.WriteResponse, message, channel, (session, sendResponse, sendError) => {
          let response;
          if (!request.nodesToWrite || request.nodesToWrite.length === 0) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadNothingToDo);
          }
          if (this.engine.serverCapabilities.operationLimits.maxNodesPerWrite > 0) {
            if (request.nodesToWrite.length > this.engine.serverCapabilities.operationLimits.maxNodesPerWrite) {
              return sendError(node_opcua_status_code_1.StatusCodes.BadTooManyOperations);
            }
          }
          for (const nodeToWrite of request.nodesToWrite) {
            nodeToWrite.nodeId = session.resolveRegisteredNode(nodeToWrite.nodeId);
          }
          const context = session.sessionContext;
          (0, node_opcua_assert_1.assert)(request.nodesToWrite[0].schema.name === "WriteValue");
          this.engine.write(context, request.nodesToWrite).then((results) => {
            (0, node_opcua_assert_1.assert)(results.length === request.nodesToWrite.length);
            response = new node_opcua_service_write_1.WriteResponse({
              diagnosticInfos: void 0,
              results
            });
            sendResponse(response);
          }).catch((err) => {
            errorLog(err);
            sendError(node_opcua_status_code_1.StatusCodes.BadInternalError);
          });
        });
      }
      // subscription services
      _on_CreateSubscriptionRequest(message, channel) {
        const engine = this.engine;
        const addressSpace = engine.addressSpace;
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_subscription_1.CreateSubscriptionRequest);
        this._apply_on_SessionObject(node_opcua_service_subscription_1.CreateSubscriptionResponse, message, channel, (session, sendResponse, sendError) => {
          const context = session.sessionContext;
          if (session.currentSubscriptionCount >= this.engine.serverCapabilities.maxSubscriptionsPerSession) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadTooManySubscriptions);
          }
          if (this.currentSubscriptionCount >= this.engine.serverCapabilities.maxSubscriptions) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadTooManySubscriptions);
          }
          const subscription = session.createSubscription(request);
          subscription.on("monitoredItem", (monitoredItem) => {
            prepareMonitoredItem(context, addressSpace, monitoredItem);
          });
          const response = new node_opcua_service_subscription_1.CreateSubscriptionResponse({
            revisedLifetimeCount: subscription.lifeTimeCount,
            revisedMaxKeepAliveCount: subscription.maxKeepAliveCount,
            revisedPublishingInterval: subscription.publishingInterval,
            subscriptionId: subscription.id
          });
          sendResponse(response);
        });
      }
      _on_DeleteSubscriptionsRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_subscription_1.DeleteSubscriptionsRequest);
        this._apply_on_SubscriptionIds(node_opcua_service_subscription_1.DeleteSubscriptionsResponse, message, channel, async (session, subscriptionId) => {
          let subscription = this.engine.findOrphanSubscription(subscriptionId);
          if (subscription) {
            warningLog("Deleting an orphan subscription", subscriptionId);
            await this._beforeDeleteSubscription(subscription);
            return this.engine.deleteOrphanSubscription(subscription);
          }
          subscription = session.getSubscription(subscriptionId);
          if (subscription) {
            await this._beforeDeleteSubscription(subscription);
          }
          return session.deleteSubscription(subscriptionId);
        });
      }
      _on_TransferSubscriptionsRequest(message, channel) {
        const engine = this.engine;
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_subscription_1.TransferSubscriptionsRequest);
        this._apply_on_SubscriptionIds(node_opcua_service_subscription_1.TransferSubscriptionsResponse, message, channel, async (session, subscriptionId) => await engine.transferSubscription(session, subscriptionId, request.sendInitialValues));
      }
      _on_CreateMonitoredItemsRequest(message, channel) {
        const engine = this.engine;
        const addressSpace = engine.addressSpace;
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_subscription_1.CreateMonitoredItemsRequest);
        this._apply_on_Subscription(node_opcua_service_subscription_1.CreateMonitoredItemsResponse, message, channel, async (session, subscription, sendResponse, sendError) => {
          const timestampsToReturn = request.timestampsToReturn;
          if (timestampsToReturn === node_opcua_service_read_1.TimestampsToReturn.Invalid) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadTimestampsToReturnInvalid);
          }
          if (!request.itemsToCreate || request.itemsToCreate.length === 0) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadNothingToDo);
          }
          if (this.engine.serverCapabilities.operationLimits.maxMonitoredItemsPerCall > 0) {
            if (request.itemsToCreate.length > this.engine.serverCapabilities.operationLimits.maxMonitoredItemsPerCall) {
              return sendError(node_opcua_status_code_1.StatusCodes.BadTooManyOperations);
            }
          }
          const options = this.options;
          let results = [];
          if (options.onCreateMonitoredItem) {
            const resultsPromise = request.itemsToCreate.map(async (monitoredItemCreateRequest) => {
              const { monitoredItem, createResult } = subscription.preCreateMonitoredItem(addressSpace, timestampsToReturn, monitoredItemCreateRequest);
              if (monitoredItem) {
                await options.onCreateMonitoredItem(subscription, monitoredItem);
                subscription.postCreateMonitoredItem(monitoredItem, monitoredItemCreateRequest, createResult);
              }
              return createResult;
            });
            results = await Promise.all(resultsPromise);
          } else {
            results = request.itemsToCreate.map((monitoredItemCreateRequest) => {
              const { monitoredItem, createResult } = subscription.preCreateMonitoredItem(addressSpace, timestampsToReturn, monitoredItemCreateRequest);
              if (monitoredItem) {
                subscription.postCreateMonitoredItem(monitoredItem, monitoredItemCreateRequest, createResult);
              }
              return createResult;
            });
          }
          const response = new node_opcua_service_subscription_1.CreateMonitoredItemsResponse({
            responseHeader: { serviceResult: node_opcua_status_code_1.StatusCodes.Good },
            results
            // ,diagnosticInfos: []
          });
          sendResponse(response);
        });
      }
      _on_ModifySubscriptionRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_subscription_1.ModifySubscriptionRequest);
        this._apply_on_Subscription(node_opcua_service_subscription_1.ModifySubscriptionResponse, message, channel, async (session, subscription, sendResponse, sendError) => {
          subscription.modify(request);
          const response = new node_opcua_service_subscription_1.ModifySubscriptionResponse({
            revisedLifetimeCount: subscription.lifeTimeCount,
            revisedMaxKeepAliveCount: subscription.maxKeepAliveCount,
            revisedPublishingInterval: subscription.publishingInterval
          });
          sendResponse(response);
        });
      }
      _on_ModifyMonitoredItemsRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_subscription_1.ModifyMonitoredItemsRequest);
        this._apply_on_Subscription(node_opcua_service_subscription_1.ModifyMonitoredItemsResponse, message, channel, async (session, subscription, sendResponse, sendError) => {
          const timestampsToReturn = request.timestampsToReturn;
          if (timestampsToReturn === node_opcua_service_read_1.TimestampsToReturn.Invalid) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadTimestampsToReturnInvalid);
          }
          if (!request.itemsToModify || request.itemsToModify.length === 0) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadNothingToDo);
          }
          if (this.engine.serverCapabilities.operationLimits.maxMonitoredItemsPerCall > 0) {
            if (request.itemsToModify.length > this.engine.serverCapabilities.operationLimits.maxMonitoredItemsPerCall) {
              return sendError(node_opcua_status_code_1.StatusCodes.BadTooManyOperations);
            }
          }
          const itemsToModify = request.itemsToModify;
          function modifyMonitoredItem(item) {
            const monitoredItemId = item.monitoredItemId;
            const monitoredItem = subscription.getMonitoredItem(monitoredItemId);
            if (!monitoredItem) {
              return new node_opcua_service_subscription_1.MonitoredItemModifyResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadMonitoredItemIdInvalid });
            }
            if (item.requestedParameters.samplingInterval === -1) {
              item.requestedParameters.samplingInterval = subscription.publishingInterval;
            }
            return monitoredItem.modify(timestampsToReturn, item.requestedParameters);
          }
          const results = itemsToModify.map(modifyMonitoredItem);
          const response = new node_opcua_service_subscription_1.ModifyMonitoredItemsResponse({
            results
          });
          sendResponse(response);
        });
      }
      _on_PublishRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_subscription_1.PublishRequest);
        this._apply_on_SessionObject(node_opcua_service_subscription_1.PublishResponse, message, channel, (session, sendResponse, sendError) => {
          (0, node_opcua_assert_1.assert)(session);
          (0, node_opcua_assert_1.assert)(session.publishEngine);
          session.publishEngine._on_PublishRequest(request, (_request1, response) => {
            sendResponse(response);
          });
        });
      }
      _on_SetPublishingModeRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_subscription_1.SetPublishingModeRequest);
        const publishingEnabled = request.publishingEnabled;
        this._apply_on_Subscriptions(node_opcua_service_subscription_1.SetPublishingModeResponse, message, channel, async (session, subscription) => {
          return subscription.setPublishingMode(publishingEnabled);
        });
      }
      _on_DeleteMonitoredItemsRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_subscription_1.DeleteMonitoredItemsRequest);
        this._apply_on_Subscription(node_opcua_service_subscription_1.DeleteMonitoredItemsResponse, message, channel, async (session, subscription, sendResponse, sendError) => {
          if (!request.monitoredItemIds || request.monitoredItemIds.length === 0) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadNothingToDo);
          }
          if (this.engine.serverCapabilities.operationLimits.maxMonitoredItemsPerCall > 0) {
            if (request.monitoredItemIds.length > this.engine.serverCapabilities.operationLimits.maxMonitoredItemsPerCall) {
              return sendError(node_opcua_status_code_1.StatusCodes.BadTooManyOperations);
            }
          }
          const resultsPromises = request.monitoredItemIds.map(async (monitoredItemId) => {
            if (this.options.onDeleteMonitoredItem) {
              const monitoredItem = subscription.getMonitoredItem(monitoredItemId);
              if (monitoredItem) {
                await this.options.onDeleteMonitoredItem(subscription, monitoredItem);
              }
            }
            return subscription.removeMonitoredItem(monitoredItemId);
          });
          try {
            const results = await Promise.all(resultsPromises);
            const response = new node_opcua_service_subscription_1.DeleteMonitoredItemsResponse({
              diagnosticInfos: void 0,
              results
            });
            sendResponse(response);
          } catch (err) {
            warningLog(err);
            return sendError(node_opcua_status_code_1.StatusCodes.BadInternalError);
          }
        });
      }
      _on_SetTriggeringRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_subscription_1.SetTriggeringRequest);
        this._apply_on_Subscription(node_opcua_service_subscription_1.SetTriggeringResponse, message, channel, async (session, subscription, sendResponse, sendError) => {
          const { triggeringItemId, linksToAdd, linksToRemove } = request;
          const maxElements = (linksToAdd ? linksToAdd.length : 0) + (linksToRemove ? linksToRemove.length : 0);
          if (this.engine.serverCapabilities.operationLimits.maxMonitoredItemsPerCall > 0) {
            if (maxElements > this.engine.serverCapabilities.operationLimits.maxMonitoredItemsPerCall) {
              return sendError(node_opcua_status_code_1.StatusCodes.BadTooManyOperations);
            }
          }
          const { addResults, removeResults, statusCode } = subscription.setTriggering(triggeringItemId, linksToAdd, linksToRemove);
          if (statusCode.isNotGood()) {
            const response = new node_opcua_types_1.ServiceFault({ responseHeader: { serviceResult: statusCode } });
            sendResponse(response);
          } else {
            const response = new node_opcua_service_subscription_1.SetTriggeringResponse({
              responseHeader: { serviceResult: statusCode },
              addResults,
              removeResults,
              addDiagnosticInfos: null,
              removeDiagnosticInfos: null
            });
            sendResponse(response);
          }
        });
      }
      async _beforeDeleteSubscription(subscription) {
        if (!this.options.onDeleteMonitoredItem) {
          return;
        }
        await subscription.applyOnMonitoredItem(this.options.onDeleteMonitoredItem.bind(null, subscription));
      }
      _on_RepublishRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_subscription_1.RepublishRequest);
        this._apply_on_Subscription(node_opcua_service_subscription_1.RepublishResponse, message, channel, async (session, subscription, sendResponse, sendError) => {
          subscription.subscriptionDiagnostics.republishRequestCount += 1;
          subscription.subscriptionDiagnostics.republishMessageRequestCount += 1;
          const retransmitSequenceNumber = request.retransmitSequenceNumber;
          const notificationMessage = subscription.getMessageForSequenceNumber(retransmitSequenceNumber);
          if (!notificationMessage) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadMessageNotAvailable);
          }
          const response = new node_opcua_service_subscription_1.RepublishResponse({
            notificationMessage,
            responseHeader: {
              serviceResult: node_opcua_status_code_1.StatusCodes.Good
            }
          });
          subscription.subscriptionDiagnostics.republishMessageCount += 1;
          sendResponse(response);
        });
      }
      // Bad_NothingToDo
      // Bad_TooManyOperations
      // Bad_SubscriptionIdInvalid
      // Bad_MonitoringModeInvalid
      _on_SetMonitoringModeRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_subscription_1.SetMonitoringModeRequest);
        this._apply_on_Subscription(node_opcua_service_subscription_1.SetMonitoringModeResponse, message, channel, async (session, subscription, sendResponse, sendError) => {
          if (!request.monitoredItemIds || request.monitoredItemIds.length === 0) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadNothingToDo);
          }
          if (this.engine.serverCapabilities.operationLimits.maxMonitoredItemsPerCall > 0) {
            if (request.monitoredItemIds.length > this.engine.serverCapabilities.operationLimits.maxMonitoredItemsPerCall) {
              return sendError(node_opcua_status_code_1.StatusCodes.BadTooManyOperations);
            }
          }
          const monitoringMode = request.monitoringMode;
          if (!isMonitoringModeValid(monitoringMode)) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadMonitoringModeInvalid);
          }
          const results = request.monitoredItemIds.map((monitoredItemId) => {
            const monitoredItem = subscription.getMonitoredItem(monitoredItemId);
            if (!monitoredItem) {
              return node_opcua_status_code_1.StatusCodes.BadMonitoredItemIdInvalid;
            }
            monitoredItem.setMonitoringMode(monitoringMode);
            return node_opcua_status_code_1.StatusCodes.Good;
          });
          const response = new node_opcua_service_subscription_1.SetMonitoringModeResponse({
            results
          });
          sendResponse(response);
        });
      }
      // _on_TranslateBrowsePathsToNodeIds service
      _on_TranslateBrowsePathsToNodeIdsRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_translate_browse_path_1.TranslateBrowsePathsToNodeIdsRequest);
        this._apply_on_SessionObject(node_opcua_service_translate_browse_path_1.TranslateBrowsePathsToNodeIdsResponse, message, channel, async (session, sendResponse, sendError) => {
          if (!request.browsePaths || request.browsePaths.length === 0) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadNothingToDo);
          }
          if (this.engine.serverCapabilities.operationLimits.maxNodesPerTranslateBrowsePathsToNodeIds > 0) {
            if (request.browsePaths.length > this.engine.serverCapabilities.operationLimits.maxNodesPerTranslateBrowsePathsToNodeIds) {
              return sendError(node_opcua_status_code_1.StatusCodes.BadTooManyOperations);
            }
          }
          this.engine.translateBrowsePaths(request.browsePaths).then((browsePathsResults) => {
            const response = new node_opcua_service_translate_browse_path_1.TranslateBrowsePathsToNodeIdsResponse({
              diagnosticInfos: null,
              results: browsePathsResults
            });
            sendResponse(response);
          }).catch((err) => {
            sendError(node_opcua_status_code_1.StatusCodes.BadInternalError);
          });
        });
      }
      // Call Service Result Codes
      // Symbolic Id Description
      // Bad_NothingToDo       See Table 165 for the description of this result code.
      // Bad_TooManyOperations See Table 165 for the description of this result code.
      //
      _on_CallRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_call_1.CallRequest);
        this._apply_on_SessionObject(node_opcua_service_call_1.CallResponse, message, channel, (session, sendResponse, sendError) => {
          let response;
          if (!request.methodsToCall || request.methodsToCall.length === 0) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadNothingToDo);
          }
          let maxNodesPerMethodCall = this.engine.serverCapabilities.operationLimits.maxNodesPerMethodCall;
          maxNodesPerMethodCall = maxNodesPerMethodCall <= 0 ? 1e3 : maxNodesPerMethodCall;
          if (request.methodsToCall.length > maxNodesPerMethodCall) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadTooManyOperations);
          }
          const context = session.sessionContext;
          this.engine.call(context, request.methodsToCall).then((results) => {
            const response2 = new node_opcua_service_call_1.CallResponse({ results });
            filterDiagnosticInfo(request.requestHeader.returnDiagnostics, response2);
            sendResponse(response2);
          }).catch((err) => {
            sendError(node_opcua_status_code_1.StatusCodes.BadInternalError);
          });
        });
      }
      _on_RegisterNodesRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_register_node_1.RegisterNodesRequest);
        this._apply_on_SessionObject(node_opcua_service_register_node_1.RegisterNodesResponse, message, channel, (session, sendResponse, sendError) => {
          if (!request.nodesToRegister || request.nodesToRegister.length === 0) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadNothingToDo);
          }
          if (this.engine.serverCapabilities.operationLimits.maxNodesPerRegisterNodes > 0) {
            if (request.nodesToRegister.length > this.engine.serverCapabilities.operationLimits.maxNodesPerRegisterNodes) {
              return sendError(node_opcua_status_code_1.StatusCodes.BadTooManyOperations);
            }
          }
          const registeredNodeIds = request.nodesToRegister.map((nodeId) => session.registerNode(nodeId));
          const response = new node_opcua_service_register_node_1.RegisterNodesResponse({
            registeredNodeIds
          });
          sendResponse(response);
        });
      }
      _on_UnregisterNodesRequest(message, channel) {
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request instanceof node_opcua_service_register_node_1.UnregisterNodesRequest);
        this._apply_on_SessionObject(node_opcua_service_register_node_1.UnregisterNodesResponse, message, channel, (session, sendResponse, sendError) => {
          request.nodesToUnregister = request.nodesToUnregister || [];
          if (!request.nodesToUnregister || request.nodesToUnregister.length === 0) {
            return sendError(node_opcua_status_code_1.StatusCodes.BadNothingToDo);
          }
          if (this.engine.serverCapabilities.operationLimits.maxNodesPerRegisterNodes > 0) {
            if (request.nodesToUnregister.length > this.engine.serverCapabilities.operationLimits.maxNodesPerRegisterNodes) {
              return sendError(node_opcua_status_code_1.StatusCodes.BadTooManyOperations);
            }
          }
          request.nodesToUnregister.map((nodeId) => session.unRegisterNode(nodeId));
          const response = new node_opcua_service_register_node_1.UnregisterNodesResponse({});
          sendResponse(response);
        });
      }
      /* istanbul ignore next */
      _on_Cancel(message, channel) {
        return g_sendError(channel, message, node_opcua_types_1.CancelResponse, node_opcua_status_code_1.StatusCodes.BadServiceUnsupported);
      }
      // NodeManagement Service Set Overview
      // This Service Set defines Services to add and delete AddressSpace Nodes and References between them. All added
      // Nodes continue to exist in the AddressSpace even if the Client that created them disconnects from the Server.
      //
      /* istanbul ignore next */
      _on_AddNodes(message, channel) {
        return g_sendError(channel, message, node_opcua_service_node_management_1.AddNodesResponse, node_opcua_status_code_1.StatusCodes.BadServiceUnsupported);
      }
      /* istanbul ignore next */
      _on_AddReferences(message, channel) {
        return g_sendError(channel, message, node_opcua_service_node_management_1.AddReferencesResponse, node_opcua_status_code_1.StatusCodes.BadServiceUnsupported);
      }
      /* istanbul ignore next */
      _on_DeleteNodes(message, channel) {
        return g_sendError(channel, message, node_opcua_service_node_management_1.DeleteNodesResponse, node_opcua_status_code_1.StatusCodes.BadServiceUnsupported);
      }
      /* istanbul ignore next */
      _on_DeleteReferences(message, channel) {
        return g_sendError(channel, message, node_opcua_service_node_management_1.DeleteReferencesResponse, node_opcua_status_code_1.StatusCodes.BadServiceUnsupported);
      }
      // Query Service
      /* istanbul ignore next */
      _on_QueryFirst(message, channel) {
        return g_sendError(channel, message, node_opcua_service_query_1.QueryFirstResponse, node_opcua_status_code_1.StatusCodes.BadServiceUnsupported);
      }
      /* istanbul ignore next */
      _on_QueryNext(message, channel) {
        return g_sendError(channel, message, node_opcua_service_query_1.QueryNextResponse, node_opcua_status_code_1.StatusCodes.BadServiceUnsupported);
      }
      /* istanbul ignore next */
      _on_HistoryUpdate(message, channel) {
        return g_sendError(channel, message, node_opcua_service_history_1.HistoryUpdateResponse, node_opcua_status_code_1.StatusCodes.BadServiceUnsupported);
      }
      createEndpoint(port1, serverOptions) {
        const endPoint = new server_end_point_1.OPCUAServerEndPoint({
          port: port1,
          host: serverOptions.host,
          certificateManager: this.serverCertificateManager,
          certificateChain: this.getCertificateChain(),
          privateKey: this.getPrivateKey(),
          defaultSecureTokenLifetime: serverOptions.defaultSecureTokenLifetime || 6e5,
          timeout: serverOptions.timeout || 3 * 60 * 1e3,
          maxConnections: this.maxConnectionsPerEndpoint,
          objectFactory: this.objectFactory,
          serverInfo: this.serverInfo,
          transportSettings: serverOptions.transportSettings
        });
        return endPoint;
      }
      createEndpointDescriptions(serverOption, endpointOptions) {
        if (!endpointOptions) {
          throw new Error("internal error");
        }
        const hostname2 = (0, node_opcua_hostname_1.getFullyQualifiedDomainName)();
        endpointOptions.hostname = endpointOptions.hostname || hostname2;
        endpointOptions.port = endpointOptions.port === void 0 ? 26543 : endpointOptions.port;
        if (!Object.prototype.hasOwnProperty.call(endpointOptions, "port") || !isFinite(endpointOptions.port) || typeof endpointOptions.port !== "number") {
          throw new Error("expecting a valid port (number) when specified. alternatively you can specify port:0 and node-opcua will choose the first available port");
        }
        const port2 = Number(endpointOptions.port || 0);
        const endPoint = this.createEndpoint(port2, serverOption);
        endpointOptions.alternateHostname = endpointOptions.alternateHostname || [];
        const alternateHostname = endpointOptions.alternateHostname instanceof Array ? endpointOptions.alternateHostname : [endpointOptions.alternateHostname];
        const allowAnonymous = endpointOptions.allowAnonymous === void 0 ? true : !!endpointOptions.allowAnonymous;
        endPoint.addStandardEndpointDescriptions({
          allowAnonymous,
          securityModes: endpointOptions.securityModes,
          securityPolicies: endpointOptions.securityPolicies,
          hostname: endpointOptions.hostname,
          alternateHostname,
          disableDiscovery: !!endpointOptions.disableDiscovery,
          // xx                hostname,
          resourcePath: serverOption.resourcePath || ""
          // TODO  userTokenTypes: endpointOptions.userTokenTypes || undefined,
          // TODO allowUnsecurePassword: endpointOptions.allowUnsecurePassword || false
        });
        return endPoint;
      }
      async initializeCM() {
        await super.initializeCM();
        await this.userCertificateManager.initialize();
      }
    };
    exports2.OPCUAServer = OPCUAServer;
    OPCUAServer.defaultShutdownTimeout = 100;
    OPCUAServer.requestExactEndpointUrl = g_requestExactEndpointUrl;
    OPCUAServer.registry = new node_opcua_object_registry_1.ObjectRegistry();
    OPCUAServer.fallbackSessionName = "Client didn't provide a meaningful sessionName ...";
    OPCUAServer.deprecated_MAX_SUBSCRIPTION = 50;
    var userIdentityTokenPasswordRemoved = (userIdentityToken) => {
      const a = userIdentityToken.clone();
      a.password = "*************";
      return a;
    };
    function raiseAuditActivateSessionEventType(session) {
      if (this.isAuditing) {
        this.raiseEvent("AuditActivateSessionEventType", {
          /* part 5 -  6.4.3 AuditEventType */
          actionTimeStamp: { dataType: "DateTime", value: /* @__PURE__ */ new Date() },
          status: { dataType: "Boolean", value: true },
          serverId: { dataType: "String", value: "" },
          // ClientAuditEntryId contains the human-readable AuditEntryId defined in Part 3.
          clientAuditEntryId: { dataType: "String", value: "" },
          // The ClientUserId identifies the user of the client requesting an action.
          // The ClientUserId can be obtained from the UserIdentityToken passed in the
          // ActivateSession call.
          clientUserId: { dataType: "String", value: "cc" },
          sourceName: { dataType: "String", value: "Session/ActivateSession" },
          /* part 5 - 6.4.7 AuditSessionEventType */
          sessionId: { dataType: "NodeId", value: session.nodeId },
          /* part 5 - 6.4.10 AuditActivateSessionEventType */
          clientSoftwareCertificates: {
            arrayType: node_opcua_variant_2.VariantArrayType.Array,
            dataType: "ExtensionObject",
            value: []
          },
          // UserIdentityToken reflects the userIdentityToken parameter of the ActivateSession
          // Service call.
          // For Username/Password tokens the password should NOT be included.
          userIdentityToken: {
            dataType: "ExtensionObject",
            value: userIdentityTokenPasswordRemoved(session.userIdentityToken)
          },
          // SecureChannelId shall uniquely identify the SecureChannel. The application shall
          // use the same identifier in all AuditEvents related to the Session Service Set
          // (AuditCreateSessionEventType, AuditActivateSessionEventType and their subtypes) and
          // the SecureChannel Service Set (AuditChannelEventType and its subtypes).
          secureChannelId: { dataType: "String", value: session.channel.channelId.toString() }
        });
      }
    }
    var opts = { multiArgs: false };
    OPCUAServer.prototype.start = thenify.withCallback(OPCUAServer.prototype.start, opts);
    OPCUAServer.prototype.initialize = thenify.withCallback(OPCUAServer.prototype.initialize, opts);
    OPCUAServer.prototype.shutdown = thenify.withCallback(OPCUAServer.prototype.shutdown, opts);
  }
});

// node_modules/node-opcua-server/dist/helper.js
var require_helper2 = __commonJS({
  "node_modules/node-opcua-server/dist/helper.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.installSessionLoggingOnEngine = exports2.installSubscriptionMonitoring = exports2.installSessionLogging = void 0;
    var util_1 = __importDefault3(require("util"));
    var server_subscription_1 = require_server_subscription();
    var consolelog = (...args) => {
      const d2 = /* @__PURE__ */ new Date();
      const t = d2.toTimeString().split(" ")[0] + "." + d2.getMilliseconds().toString().padStart(3, "0");
      console.log.apply(console, [t, ...args]);
    };
    function installSessionLogging(server) {
      installSessionLoggingOnEngine(server.engine);
    }
    exports2.installSessionLogging = installSessionLogging;
    var info = (subscription) => {
      return util_1.default.format(subscription.subscriptionId, server_subscription_1.SubscriptionState[subscription.state].padEnd(9), subscription.state, "kac=", subscription.currentKeepAliveCount.toString().padStart(3) + "/" + subscription.maxKeepAliveCount.toString().padStart(3), "ltc=", subscription.currentLifetimeCount.toString().padStart(3) + "/" + subscription.lifeTimeCount.toString().padStart(3), "prc=", subscription.publishEngine?.pendingPublishRequestCount.toString().padStart(3), "pi=", subscription.publishingInterval);
    };
    function installSubscriptionMonitoring(subscription) {
      consolelog("new_subscription", subscription.subscriptionId, info(subscription));
      subscription.on("lifeTimeExpired", () => {
        consolelog("lifeTimeExpired".padEnd(45), info(subscription));
      });
      if (true) {
        subscription.on("lifeTimeCounterChanged", (ltc) => {
          consolelog("subscription lifeTimeCounterChanged".padEnd(45), info(subscription));
        });
      }
      subscription.on("expired", () => {
        consolelog("subscription expired".padEnd(45), info(subscription));
      });
      subscription.on("stateChanged", (state) => {
        consolelog("subscription stateChanged".padEnd(45), info(subscription));
      });
      subscription.on("terminate", () => {
        consolelog("subscription terminated".padEnd(45), info(subscription));
      });
      subscription.on("keepalive", () => {
        consolelog("subscription keepalive".padEnd(45), info(subscription));
      });
    }
    exports2.installSubscriptionMonitoring = installSubscriptionMonitoring;
    function installSessionLoggingOnEngine(serverEngine) {
      function on_create_session(session) {
        try {
          session.on("activate_session", function() {
            consolelog("activate_session");
          });
          session.on("statusChanged", (status2) => {
            consolelog("session status changed: ", status2);
          });
          session.on("new_subscription", function(subscription) {
            installSubscriptionMonitoring(subscription);
          });
        } catch (err) {
          consolelog(err.message);
        }
      }
      serverEngine.on("create_session", on_create_session);
      serverEngine.once("session_closed", function(session) {
        consolelog("session is closed");
        serverEngine.removeListener("create_session", on_create_session);
      });
    }
    exports2.installSessionLoggingOnEngine = installSessionLoggingOnEngine;
  }
});

// node_modules/node-opcua-server/dist/index.js
var require_dist64 = __commonJS({
  "node_modules/node-opcua-server/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_base_server(), exports2);
    __exportStar3(require_server_end_point(), exports2);
    __exportStar3(require_register_server_manager(), exports2);
    __exportStar3(require_register_server_manager_mdns_only(), exports2);
    __exportStar3(require_server_publish_engine(), exports2);
    __exportStar3(require_server_subscription(), exports2);
    __exportStar3(require_server_session(), exports2);
    __exportStar3(require_server_capabilities2(), exports2);
    __exportStar3(require_server_engine(), exports2);
    __exportStar3(require_opcua_server(), exports2);
    __exportStar3(require_monitored_item(), exports2);
    __exportStar3(require_user_manager(), exports2);
    __exportStar3(require_helper2(), exports2);
  }
});

// node_modules/node-opcua-server-discovery/dist/mdns_responder.js
var require_mdns_responder = __commonJS({
  "node_modules/node-opcua-server-discovery/dist/mdns_responder.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.MDNSResponder = void 0;
    var sterfive_bonjour_service_1 = require_dist47();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_object_registry_1 = require_dist46();
    var node_opcua_service_discovery_1 = require_dist48();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename) || true;
    var registry = new node_opcua_object_registry_1.ObjectRegistry();
    var MDNSResponder = class {
      constructor() {
        this.lastUpdateDate = /* @__PURE__ */ new Date();
        registry.register(this);
        this.registeredServers = [];
        this.multicastDNS = new sterfive_bonjour_service_1.Bonjour();
        this.recordId = 0;
        this.browser = this.multicastDNS.find({
          protocol: "tcp",
          type: "opcua-tcp"
        });
        const findServiceIndex = (serverName) => {
          const index = this.registeredServers.findIndex((server) => server.serverName === serverName);
          return index;
        };
        const addService = (service) => {
          doDebug && debugLog("adding server ", service.name, "port =", service.port);
          const existingIndex = findServiceIndex(service.name);
          if (existingIndex >= 0) {
            debugLog("Ignoring existing server ", service.name);
            return;
          }
          this.recordId++;
          const recordId = this.recordId;
          const serverName = service.name;
          service.txt = service.txt || {};
          const service_txt = service.txt;
          service_txt.caps = service_txt.caps || "";
          const serverCapabilities = service_txt.caps.split(",").map((x2) => x2.toUpperCase()).sort();
          const path3 = service_txt.path || "";
          const discoveryUrl = "opc.tcp://" + service.host + ":" + service.port + path3;
          this.registeredServers.push(new node_opcua_service_discovery_1.ServerOnNetwork({
            discoveryUrl,
            recordId,
            serverCapabilities,
            serverName
          }));
          this.lastUpdateDate = new Date(Date.now());
          debugLog("a new OPCUA server has been registered on mDNS", service.name, recordId);
        };
        const removeService = (service) => {
          const serverName = service.name;
          debugLog("a OPCUA server has been unregistered in mDNS", serverName);
          const index = findServiceIndex(serverName);
          if (index === -1) {
            debugLog("Cannot find server with name ", serverName, " in registeredServers");
            return;
          }
          this.registeredServers.splice(index, 1);
          this.lastUpdateDate = /* @__PURE__ */ new Date();
        };
        this.browser.on("up", (service) => {
          doDebug && debugLog("MDNSResponder : service is up with  ", (0, node_opcua_service_discovery_1.serviceToString)(service));
          addService(service);
        });
        this.browser.on("down", (service) => {
          doDebug && debugLog("MDNSResponder : service is down with  ", (0, node_opcua_service_discovery_1.serviceToString)(service));
          removeService(service);
        });
      }
      dispose() {
        this.multicastDNS.destroy();
        registry.unregister(this);
      }
    };
    exports2.MDNSResponder = MDNSResponder;
  }
});

// node_modules/node-opcua-server-discovery/dist/opcua_discovery_server.js
var require_opcua_discovery_server = __commonJS({
  "node_modules/node-opcua-server-discovery/dist/opcua_discovery_server.js"(exports2) {
    "use strict";
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OPCUADiscoveryServer = void 0;
    var os_1 = __importDefault3(require("os"));
    var path_1 = __importDefault3(require("path"));
    var url_1 = __importDefault3(require("url"));
    var util_1 = require("util");
    var chalk_1 = __importDefault3(require_source());
    var env_paths_1 = __importDefault3(require_env_paths());
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_common_1 = require_dist34();
    var node_opcua_debug_1 = require_dist24();
    var node_opcua_secure_channel_1 = require_source7();
    var node_opcua_server_1 = require_dist64();
    var node_opcua_service_discovery_1 = require_dist48();
    var node_opcua_certificate_manager_1 = require_dist60();
    var node_opcua_service_endpoints_1 = require_dist44();
    var node_opcua_service_endpoints_2 = require_dist44();
    var node_opcua_status_code_1 = require_dist22();
    var mdns_responder_1 = require_mdns_responder();
    var debugLog = (0, node_opcua_debug_1.make_debugLog)(__filename);
    var doDebug = (0, node_opcua_debug_1.checkDebugFlag)(__filename);
    var errorLog = (0, node_opcua_debug_1.make_errorLog)(__filename);
    function hasCapabilities(serverCapabilities, serverCapabilityFilter) {
      if (serverCapabilities == null) {
        return true;
      }
      if (serverCapabilityFilter.length === 0) {
        return true;
      }
      return !!serverCapabilities.join(" ").match(serverCapabilityFilter);
    }
    var defaultProductUri = "NodeOPCUA-LocalDiscoveryServer";
    var defaultApplicationUri = (0, node_opcua_common_1.makeApplicationUrn)(os_1.default.hostname(), defaultProductUri);
    function getDefaultCertificateManager() {
      const config = (0, env_paths_1.default)(defaultProductUri).config;
      return new node_opcua_certificate_manager_1.OPCUACertificateManager({
        name: "PKI",
        rootFolder: path_1.default.join(config, "PKI"),
        automaticallyAcceptUnknownCertificate: true
      });
    }
    var OPCUADiscoveryServer = class _OPCUADiscoveryServer extends node_opcua_server_1.OPCUABaseServer {
      constructor(options) {
        options.serverInfo = options.serverInfo || {};
        const serverInfo = options.serverInfo;
        serverInfo.applicationType = node_opcua_service_endpoints_2.ApplicationType.DiscoveryServer;
        serverInfo.applicationUri = serverInfo.applicationUri || defaultApplicationUri;
        serverInfo.productUri = serverInfo.productUri || defaultProductUri;
        serverInfo.applicationName = serverInfo.applicationName || {
          text: defaultProductUri,
          locale: null
        };
        serverInfo.gatewayServerUri = serverInfo.gatewayServerUri || "";
        serverInfo.discoveryProfileUri = serverInfo.discoveryProfileUri || "";
        serverInfo.discoveryUrls = serverInfo.discoveryUrls || [];
        options.serverCertificateManager = options.serverCertificateManager || getDefaultCertificateManager();
        super(options);
        this.bonjourHolder = new node_opcua_service_discovery_1.BonjourHolder();
        const port2 = options.port || 4840;
        this.capabilitiesForMDNS = ["LDS"];
        this.registeredServers = {};
        this.mDnsResponder = void 0;
        this._delayInit = async () => {
          const endPoint = new node_opcua_server_1.OPCUAServerEndPoint({
            port: port2,
            certificateChain: this.getCertificateChain(),
            certificateManager: this.serverCertificateManager,
            privateKey: this.getPrivateKey(),
            serverInfo: this.serverInfo
          });
          const options1 = {
            allowAnonymous: true,
            securityModes: options.securityModes,
            securityPolicies: options.securityPolicies,
            userTokenTypes: [],
            // << intentionally empty (discovery server without session)
            hostname: options.hostname,
            alternateHostname: options.alternateHostname,
            disableDiscovery: true
          };
          endPoint.addStandardEndpointDescriptions(options1);
          this.endpoints.push(endPoint);
          endPoint.on("message", (message, channel) => {
            this.on_request(message, channel);
          });
        };
      }
      start(callback) {
        (0, node_opcua_assert_1.assert)(!this.mDnsResponder);
        (0, node_opcua_assert_1.assert)(Array.isArray(this.capabilitiesForMDNS));
        this._preInitTask.push(async () => {
          await this._delayInit();
        });
        super.start((err) => {
          if (err) {
            return callback(err);
          }
          const endpointUri = this.getEndpointUrl();
          const { hostname: hostname2 } = url_1.default.parse(endpointUri);
          this.mDnsResponder = new mdns_responder_1.MDNSResponder();
          this.bonjourHolder.announcedOnMulticastSubnetWithCallback({
            capabilities: this.capabilitiesForMDNS,
            name: this.serverInfo.applicationUri,
            path: "/DiscoveryServer",
            host: hostname2 || "",
            port: this.endpoints[0].port
          }, (err2) => {
            callback(err2);
          });
        });
      }
      shutdown(callback) {
        debugLog("stopping announcement of LDS on mDNS");
        if (this.mDnsResponder) {
          this.mDnsResponder.dispose();
          this.mDnsResponder = void 0;
        }
        this.bonjourHolder.stopAnnouncedOnMulticastSubnetWithCallback((err) => {
          if (err) {
            errorLog("stopAnnouncedOnMulticastSubnet Error ", err.message);
          }
          debugLog("stopping announcement of LDS on mDNS - DONE");
          debugLog("Shutting down Discovery Server");
          super.shutdown(() => {
            setTimeout(() => {
              callback();
            }, 100);
          });
        });
      }
      /**
       * returns the number of registered servers
       */
      get registeredServerCount() {
        return Object.keys(this.registeredServers).length;
      }
      getServers(channel) {
        this.serverInfo.discoveryUrls = this.getDiscoveryUrls();
        const servers = [this.serverInfo];
        for (const registered_server of Object.values(this.registeredServers)) {
          const serverInfo = new node_opcua_service_endpoints_1.ApplicationDescription(registered_server.serverInfo);
          servers.push(serverInfo);
        }
        return servers;
      }
      _on_RegisterServer2Request(message, channel) {
        (0, node_opcua_assert_1.assert)(message.request instanceof node_opcua_service_discovery_1.RegisterServer2Request);
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request.schema.name === "RegisterServer2Request");
        request.discoveryConfiguration = request.discoveryConfiguration || [];
        this.__internalRegisterServerWithCallback(node_opcua_service_discovery_1.RegisterServer2Response, request.server, request.discoveryConfiguration, (err, response) => {
          if (err) {
            errorLog("What shall I do ?", err.message);
            errorLog(err);
            let additional_messages = [];
            additional_messages.push("EXCEPTION CAUGHT WHILE PROCESSING REQUEST !!! " + request.schema.name);
            additional_messages.push(err.message);
            if (err.stack) {
              additional_messages = additional_messages.concat(err.stack.split("\n"));
            }
            response = _OPCUADiscoveryServer.makeServiceFault(node_opcua_status_code_1.StatusCodes.BadInternalError, additional_messages);
            channel.send_response("MSG", response, message);
          } else {
            channel.send_response("MSG", response, message);
          }
        });
      }
      _on_RegisterServerRequest(message, channel) {
        (0, node_opcua_assert_1.assert)(message.request instanceof node_opcua_service_discovery_1.RegisterServerRequest);
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request.schema.name === "RegisterServerRequest");
        this.__internalRegisterServerWithCallback(node_opcua_service_discovery_1.RegisterServerResponse, request.server, void 0, (err, response) => {
          channel.send_response("MSG", response, message);
        });
      }
      _on_FindServersOnNetworkRequest(message, channel) {
        (0, node_opcua_assert_1.assert)(message.request instanceof node_opcua_service_discovery_1.FindServersOnNetworkRequest);
        const request = message.request;
        (0, node_opcua_assert_1.assert)(request.schema.name === "FindServersOnNetworkRequest");
        function sendError(statusCode) {
          const response1 = new node_opcua_service_discovery_1.FindServersOnNetworkResponse({ responseHeader: { serviceResult: statusCode } });
          return channel.send_response("MSG", response1, message);
        }
        const lastCounterResetTime = /* @__PURE__ */ new Date();
        const servers = [];
        request.serverCapabilityFilter = request.serverCapabilityFilter || [];
        const serverCapabilityFilter = request.serverCapabilityFilter.map((x2) => x2.toUpperCase()).sort().join(" ");
        debugLog(" startingRecordId = ", request.startingRecordId);
        if (this.mDnsResponder) {
          for (const server of this.mDnsResponder.registeredServers) {
            debugLog("Exploring server ", server.serverName);
            if (server.recordId <= request.startingRecordId) {
              continue;
            }
            if (!hasCapabilities(server.serverCapabilities, serverCapabilityFilter)) {
              if (doDebug) {
                debugLog("   server ", server.serverName, server.serverCapabilities ? server.serverCapabilities.join(",") : [], " does not match serverCapabilities ", serverCapabilityFilter);
              }
              continue;
            }
            debugLog("   server ", server.serverName, " found");
            servers.push(server);
            if (servers.length === request.maxRecordsToReturn) {
              debugLog("max records to return reached", request.maxRecordsToReturn);
              break;
            }
          }
        }
        const response = new node_opcua_service_discovery_1.FindServersOnNetworkResponse({
          lastCounterResetTime,
          //  UtcTime The last time the counters were reset
          servers
        });
        channel.send_response("MSG", response, message);
      }
      async __internalRegisterServerWithCallback(RegisterServerXResponse, rawServer, discoveryConfigurations, callback) {
        callback(new Error("internal Error"));
      }
      // eslint-disable-next-line max-statements
      async __internalRegisterServer(RegisterServerXResponse, rawServer, discoveryConfigurations) {
        const server = rawServer;
        if (!discoveryConfigurations) {
          discoveryConfigurations = [
            new node_opcua_service_discovery_1.MdnsDiscoveryConfiguration({
              mdnsServerName: void 0,
              serverCapabilities: ["NA"]
            })
          ];
        }
        function sendError(statusCode) {
          debugLog(chalk_1.default.red("_on_RegisterServer(2)Request error"), statusCode.toString());
          const response1 = new node_opcua_secure_channel_1.ServiceFault({
            responseHeader: { serviceResult: statusCode }
          });
          return response1;
        }
        async function _stop_announcedOnMulticastSubnet(conf) {
          const b = conf.bonjourHolder;
          await b.stopAnnouncedOnMulticastSubnet();
          conf.bonjourHolder = void 0;
        }
        async function _announcedOnMulticastSubnet(conf, announcement) {
          const serviceConfig = (0, node_opcua_service_discovery_1.announcementToServiceConfig)(announcement);
          let b = conf.bonjourHolder;
          if (b && b.serviceConfig) {
            if ((0, node_opcua_service_discovery_1.sameService)(b.serviceConfig, serviceConfig)) {
              debugLog("Configuration ", conf.mdnsServerName, " has not changed !");
              return;
            } else {
              if (doDebug) {
                debugLog("Configuration ", conf.mdnsServerName, " HAS changed !");
                debugLog(" Was ", (0, node_opcua_service_discovery_1.serviceToString)(b.serviceConfig));
                debugLog(" is  ", announcement);
              }
            }
            await _stop_announcedOnMulticastSubnet(conf);
          }
          b = new node_opcua_service_discovery_1.BonjourHolder();
          conf.bonjourHolder = b;
          await b.announcedOnMulticastSubnet(announcement);
        }
        async function dealWithDiscoveryConfiguration(previousConfMap, server1, serverInfo, discoveryConfiguration) {
          discoveryConfiguration.mdnsServerName = discoveryConfiguration.mdnsServerName || server1.serverNames[0].text;
          serverInfo.discoveryUrls = serverInfo.discoveryUrls || [];
          const endpointUrl = serverInfo.discoveryUrls[0];
          const parsedUrl = url_1.default.parse(endpointUrl);
          discoveryConfiguration.serverCapabilities = discoveryConfiguration.serverCapabilities || [];
          const announcement = {
            capabilities: discoveryConfiguration.serverCapabilities.map((x2) => x2) || ["DA"],
            name: discoveryConfiguration.mdnsServerName,
            host: parsedUrl.hostname || "",
            path: parsedUrl.pathname || "/",
            port: parseInt(parsedUrl.port, 10)
          };
          if (previousConfMap[discoveryConfiguration.mdnsServerName]) {
            debugLog("Configuration ", discoveryConfiguration.mdnsServerName, " already exists !");
            const prevConf = previousConfMap[discoveryConfiguration.mdnsServerName];
            delete previousConfMap[discoveryConfiguration.mdnsServerName];
            discoveryConfiguration.bonjourHolder = prevConf.bonjourHolder;
          }
          await _announcedOnMulticastSubnet(discoveryConfiguration, announcement);
          return node_opcua_status_code_1.StatusCodes.Good;
        }
        if (!_isValidServerType(server.serverType)) {
          debugLog("Invalid server Type", node_opcua_service_endpoints_2.ApplicationType[server.serverType]);
          return sendError(node_opcua_status_code_1.StatusCodes.BadInvalidArgument);
        }
        if (!server.serverUri) {
          debugLog("Missing serverURI");
          return sendError(node_opcua_status_code_1.StatusCodes.BadInvalidArgument);
        }
        server.serverNames = server.serverNames || [];
        if (server.serverNames.length === 0 || !server.serverNames[0].text) {
          return sendError(node_opcua_status_code_1.StatusCodes.BadServerNameMissing);
        }
        server.discoveryUrls = server.discoveryUrls || [];
        if (server.discoveryUrls.length === 0 || !server.discoveryUrls[0]) {
          return sendError(node_opcua_status_code_1.StatusCodes.BadDiscoveryUrlMissing);
        }
        const key = server.serverUri;
        let configurationResults = null;
        if (server.isOnline) {
          debugLog(chalk_1.default.cyan(" registering server : "), chalk_1.default.yellow(server.serverUri));
          const serverInfo = {
            applicationName: server.serverNames[0],
            // which one shall we use ?
            applicationType: server.serverType,
            applicationUri: server.serverUri,
            discoveryUrls: server.discoveryUrls,
            gatewayServerUri: server.gatewayServerUri,
            productUri: server.productUri
            // XXX ?????? serverInfo.discoveryProfileUri = serverInfo.discoveryProfileUri;
          };
          const previousConfMap = [];
          if (this.registeredServers[key]) {
            const previousServer = this.registeredServers[key];
            for (const conf of previousServer.discoveryConfiguration) {
              previousConfMap[conf.mdnsServerName] = conf;
            }
          }
          this.registeredServers[key] = server;
          server.serverInfo = serverInfo;
          server.discoveryConfiguration = discoveryConfigurations;
          (0, node_opcua_assert_1.assert)(discoveryConfigurations);
          configurationResults = [];
          for (const conf of discoveryConfigurations) {
            const statusCode = await dealWithDiscoveryConfiguration(previousConfMap, server, serverInfo, conf);
            configurationResults.push(statusCode);
          }
          if (Object.keys(previousConfMap).length !== 0) {
            debugLog(" Warning some conf need to be removed !");
          }
        } else {
          if (key in this.registeredServers) {
            const server1 = this.registeredServers[key];
            debugLog(chalk_1.default.cyan("unregistering server : "), chalk_1.default.yellow(server1.serverUri));
            configurationResults = [];
            discoveryConfigurations = server1.discoveryConfiguration || [];
            for (const conf of discoveryConfigurations) {
              await _stop_announcedOnMulticastSubnet(conf);
              configurationResults.push(node_opcua_status_code_1.StatusCodes.Good);
            }
            delete this.registeredServers[key];
          }
        }
        const response = new RegisterServerXResponse({
          configurationResults
        });
        return response;
      }
    };
    exports2.OPCUADiscoveryServer = OPCUADiscoveryServer;
    function _isValidServerType(serverType) {
      switch (serverType) {
        case node_opcua_service_endpoints_2.ApplicationType.Client:
          return false;
        case node_opcua_service_endpoints_2.ApplicationType.Server:
        case node_opcua_service_endpoints_2.ApplicationType.ClientAndServer:
        case node_opcua_service_endpoints_2.ApplicationType.DiscoveryServer:
          return true;
      }
      return false;
    }
    OPCUADiscoveryServer.prototype.__internalRegisterServerWithCallback = (0, util_1.callbackify)(OPCUADiscoveryServer.prototype.__internalRegisterServer);
    var thenify = require_thenify();
    var opts = { multiArgs: false };
    OPCUADiscoveryServer.prototype.start = thenify.withCallback(OPCUADiscoveryServer.prototype.start, opts);
    OPCUADiscoveryServer.prototype.shutdown = thenify.withCallback(OPCUADiscoveryServer.prototype.shutdown, opts);
  }
});

// node_modules/node-opcua-server-discovery/dist/index.js
var require_dist65 = __commonJS({
  "node_modules/node-opcua-server-discovery/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar3(require_opcua_discovery_server(), exports2);
  }
});

// node_modules/node-opcua/dist/server-stuff.js
var require_server_stuff = __commonJS({
  "node_modules/node-opcua/dist/server-stuff.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OPCUADiscoveryServer = void 0;
    __exportStar3(require_dist60(), exports2);
    __exportStar3(require_index_current(), exports2);
    __exportStar3(require_dist64(), exports2);
    var node_opcua_server_discovery_1 = require_dist65();
    Object.defineProperty(exports2, "OPCUADiscoveryServer", { enumerable: true, get: function() {
      return node_opcua_server_discovery_1.OPCUADiscoveryServer;
    } });
  }
});

// node_modules/node-opcua-aggregates/dist/interval.js
var require_interval = __commonJS({
  "node_modules/node-opcua-aggregates/dist/interval.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getInterval = exports2.Interval = exports2.adjustProcessingOptions = exports2._findGoodDataValueAfter = exports2._findGoodDataValueBefore = exports2.isUncertain = exports2.isGoodish2 = void 0;
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_status_code_1 = require_dist22();
    function isGoodish2(statusCode, { treatUncertainAsBad }) {
      if (statusCode.isGoodish())
        return true;
      if (isUncertain(statusCode))
        return !treatUncertainAsBad;
      return false;
    }
    exports2.isGoodish2 = isGoodish2;
    function isUncertain(statusCode) {
      return (statusCode.value & 1073741824) === 1073741824 && statusCode.value !== node_opcua_status_code_1.StatusCodes.BadNoData.value;
    }
    exports2.isUncertain = isUncertain;
    function _findGoodDataValueBefore(dataValues, index, bTreatUncertainAsBad) {
      index--;
      while (index >= 0) {
        const dataValue1 = dataValues[index];
        if (!bTreatUncertainAsBad && !dataValue1.statusCode.isBad()) {
          return { index, dataValue: dataValue1 };
        }
        if (bTreatUncertainAsBad && dataValue1.statusCode.isGood()) {
          return { index, dataValue: dataValue1 };
        }
        index -= 1;
      }
      return {
        dataValue: new node_opcua_data_value_1.DataValue({ statusCode: node_opcua_status_code_1.StatusCodes.BadNoData }),
        index: -1
      };
    }
    exports2._findGoodDataValueBefore = _findGoodDataValueBefore;
    function _findGoodDataValueAfter(dataValues, index, bTreatUncertainAsBad) {
      while (index < dataValues.length) {
        const dataValue1 = dataValues[index];
        if (!bTreatUncertainAsBad && !dataValue1.statusCode.isBad()) {
          return {
            dataValue: dataValue1,
            index
          };
        }
        if (bTreatUncertainAsBad && dataValue1.statusCode.isGood()) {
          return {
            dataValue: dataValue1,
            index
          };
        }
        index += 1;
      }
      return {
        dataValue: new node_opcua_data_value_1.DataValue({ statusCode: node_opcua_status_code_1.StatusCodes.BadNoData }),
        index: -1
      };
    }
    exports2._findGoodDataValueAfter = _findGoodDataValueAfter;
    function adjustProcessingOptions(options) {
      options = options || {};
      options.treatUncertainAsBad = options.treatUncertainAsBad || false;
      options.useSlopedExtrapolation = options.useSlopedExtrapolation || false;
      options.stepped = options.stepped || false;
      options.percentDataBad = parseInt(options.percentDataBad, 10);
      options.percentDataGood = parseInt(options.percentDataGood, 10);
      return options;
    }
    exports2.adjustProcessingOptions = adjustProcessingOptions;
    var Interval = class {
      // startTime
      // dataValues
      // index:       index of first dataValue inside the interval
      // count:       number of dataValue inside the interval
      constructor(options) {
        this.startTime = options.startTime;
        this.dataValues = options.dataValues;
        this.index = options.index;
        this.count = options.count;
        this.isPartial = options.isPartial;
        this.processingInterval = options.processingInterval;
      }
      getPercentBad() {
        return 100;
      }
      /**
       * returns true if a raw data exists at start
       */
      hasRawDataAsStart() {
        const index = this.index;
        if (index < 0) {
          return false;
        }
        const dataValue1 = this.dataValues[index];
        return this.startTime.getTime() === dataValue1.sourceTimestamp.getTime();
      }
      /**
       * Find the first good or uncertain dataValue
       * just preceding this interval
       * @returns {*}
       */
      beforeStartDataValue(bTreatUncertainAsBad) {
        return _findGoodDataValueBefore(this.dataValues, this.index, bTreatUncertainAsBad);
      }
      nextStartDataValue(bTreatUncertainAsBad) {
        return _findGoodDataValueAfter(this.dataValues, this.index, bTreatUncertainAsBad);
      }
      toString() {
        let str = "";
        str += "startTime " + this.startTime.toUTCString() + "\n";
        str += "start     " + this.index + "  ";
        str += "count     " + this.count + " ";
        str += "isPartial " + this.isPartial + "\n";
        if (this.index >= 0) {
          for (let i = this.index; i < this.index + this.count; i++) {
            const dataValue = this.dataValues[i];
            str += " " + dataValue.sourceTimestamp.toUTCString() + dataValue.statusCode.toString();
            str += dataValue.value ? dataValue.value.toString() : "";
            str += "\n";
          }
        }
        return str;
      }
      getEffectiveEndTime() {
        const e = this.startTime.getTime() + this.processingInterval;
        if (!this.dataValues || this.dataValues.length === 0) {
          return e;
        }
        let i = this.dataValues.length - 1;
        while (i >= 0 && this.dataValues[i].statusCode.equals(node_opcua_status_code_1.StatusCodes.BadNoData)) {
          i--;
        }
        if (i < 0) {
          return e;
        }
        const lastTimestamp = this.dataValues[i].sourceTimestamp;
        return Math.min(e, lastTimestamp.getTime() + 1);
      }
      /**
       *
       * @returns the interval duration
       */
      duration() {
        const t1 = this.dataValues[this.index].sourceTimestamp.getTime();
        const e = this.getEffectiveEndTime();
        return e - t1;
      }
      /**
       * returns the region duration starting at index and finishing at index+1 or end limit of the interval
       */
      regionDuration(index) {
        const t1 = this.dataValues[index].sourceTimestamp.getTime();
        const e = this.getEffectiveEndTime();
        const t2 = index < this.dataValues.length - 1 ? Math.min(this.dataValues[index + 1].sourceTimestamp.getTime(), e) : e;
        return t2 - t1;
      }
    };
    exports2.Interval = Interval;
    function getInterval(startTime, processingInterval, indexHint, dataValues) {
      let count = 0;
      let index = -1;
      for (let i = indexHint; i < dataValues.length; i++) {
        if (dataValues[i].sourceTimestamp.getTime() < startTime.getTime()) {
          continue;
        }
        index = i;
        break;
      }
      if (index >= 0) {
        for (let i = index; i < dataValues.length; i++) {
          if (dataValues[i].sourceTimestamp.getTime() >= startTime.getTime() + processingInterval) {
            break;
          }
          count++;
        }
      }
      let isPartial = false;
      if (index + count >= dataValues.length && dataValues[dataValues.length - 1].sourceTimestamp.getTime() < startTime.getTime() + processingInterval) {
        isPartial = true;
      }
      if (index <= 0 && dataValues[0].sourceTimestamp.getTime() > startTime.getTime()) {
        isPartial = true;
      }
      return new Interval({
        count,
        dataValues,
        index,
        isPartial,
        startTime,
        processingInterval
      });
    }
    exports2.getInterval = getInterval;
  }
});

// node_modules/node-opcua-aggregates/dist/common.js
var require_common4 = __commonJS({
  "node_modules/node-opcua-aggregates/dist/common.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.interpolateValue = exports2.getAggregateData = void 0;
    var node_opcua_address_space_1 = require_index_current();
    var node_opcua_data_model_1 = require_dist27();
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_service_history_1 = require_dist54();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_nodeid_1 = require_dist21();
    var aggregates_1 = require_aggregates();
    var interval_1 = require_interval();
    function processAggregateData(node, processingInterval, startDate, endDate, dataValues, lambda, callback) {
      const aggregateConfiguration = (0, aggregates_1.getAggregateConfiguration)(node);
      const results = [];
      const startTime = startDate.getTime();
      const endTime = endDate.getTime();
      const indexHint = 0;
      for (let t = startTime; t < endTime; t += processingInterval) {
        const sourceTimestamp = /* @__PURE__ */ new Date();
        sourceTimestamp.setTime(t);
        const interval = (0, interval_1.getInterval)(sourceTimestamp, processingInterval, indexHint, dataValues);
        const dataValue = lambda(interval, aggregateConfiguration);
        if (!dataValue || !dataValue.sourceTimestamp) {
          throw Error("invalid DataValue");
        }
        results.push(dataValue);
      }
      setImmediate(() => {
        callback(null, results);
      });
    }
    function getAggregateData(node, processingInterval, startDate, endDate, lambda, callback) {
      if (node.nodeClass !== node_opcua_data_model_1.NodeClass.Variable) {
        return callback(new Error("node must be UAVariable"));
      }
      if (processingInterval <= 0) {
        return callback(new Error("Invalid processing interval, shall be greater than 0"));
      }
      const continuationPointManager = new node_opcua_address_space_1.ContinuationPointManager();
      const context = new node_opcua_address_space_1.SessionContext({
        session: {
          continuationPointManager,
          getSessionId: () => (0, node_opcua_nodeid_1.coerceNodeId)("i=0")
        }
      });
      const historyReadDetails = new node_opcua_service_history_1.ReadRawModifiedDetails({
        endTime: endDate,
        startTime: startDate,
        isReadModified: false,
        numValuesPerNode: 0
        // returnBounds: true,
      });
      const indexRange = null;
      const dataEncoding = null;
      const continuationPoint = null;
      node.historyRead(context, historyReadDetails, indexRange, dataEncoding, { continuationPoint }, (err, result2) => {
        if (err) {
          return callback(err);
        }
        const historyData = result2.historyData;
        const dataValues = historyData.dataValues || [];
        processAggregateData(node, processingInterval, startDate, endDate, dataValues, lambda, callback);
      });
    }
    exports2.getAggregateData = getAggregateData;
    function interpolateValue(dataValue1, dataValue2, date) {
      const t0 = dataValue1.sourceTimestamp.getTime();
      const t = date.getTime();
      const t1 = dataValue2.sourceTimestamp.getTime();
      const coef1 = (t - t0) / (t1 - t0);
      const coef2 = (t1 - t) / (t1 - t0);
      const value = dataValue1.value.clone();
      value.value = coef2 * dataValue1.value.value + coef1 * dataValue2.value.value;
      const statusCode = node_opcua_status_code_1.StatusCode.makeStatusCode(dataValue1.statusCode, "HistorianInterpolated");
      return new node_opcua_data_value_1.DataValue({
        sourceTimestamp: date,
        statusCode,
        value
      });
    }
    exports2.interpolateValue = interpolateValue;
  }
});

// node_modules/node-opcua-aggregates/dist/minmax.js
var require_minmax = __commonJS({
  "node_modules/node-opcua-aggregates/dist/minmax.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getMaxData = exports2.getMinData = exports2.calculateIntervalMaxValue = exports2.calculateIntervalMinValue = void 0;
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_status_code_1 = require_dist22();
    var common_1 = require_common4();
    function calculateIntervalMinOrMaxValue(interval, options, predicate) {
      const indexStart = interval.index;
      let selectedValue = null;
      let counter = 0;
      let statusCode;
      let isPartial = interval.isPartial;
      let isRaw = false;
      let hasBad = false;
      for (let i = indexStart; i < indexStart + interval.count; i++) {
        const dataValue = interval.dataValues[i];
        if (dataValue.statusCode.equals(node_opcua_status_code_1.StatusCodes.BadNoData)) {
          isPartial = true;
          continue;
        }
        if (!dataValue.statusCode.isGood()) {
          hasBad = true;
          continue;
        }
        if (!selectedValue) {
          selectedValue = dataValue.value;
          counter = 1;
          if (i === indexStart && dataValue.sourceTimestamp.getTime() === interval.startTime.getTime()) {
            isRaw = true;
          }
          continue;
        }
        const compare = predicate(selectedValue, dataValue.value);
        if (compare === "equal") {
          counter = 1;
          continue;
        }
        if (compare === "select") {
          selectedValue = dataValue.value;
          counter = 1;
        }
      }
      if (!selectedValue) {
        return new node_opcua_data_value_1.DataValue({
          sourceTimestamp: interval.startTime,
          statusCode: node_opcua_status_code_1.StatusCodes.BadNoData
        });
      }
      if (isRaw) {
        if (hasBad) {
          statusCode = node_opcua_status_code_1.StatusCodes.UncertainDataSubNormal;
        } else {
          statusCode = node_opcua_status_code_1.StatusCodes.Good;
        }
      } else if (hasBad) {
        statusCode = node_opcua_status_code_1.StatusCode.makeStatusCode(node_opcua_status_code_1.StatusCodes.UncertainDataSubNormal, "HistorianCalculated");
      } else {
        statusCode = node_opcua_status_code_1.StatusCode.makeStatusCode(node_opcua_status_code_1.StatusCodes.Good, "HistorianCalculated");
      }
      if (counter > 1) {
        statusCode = node_opcua_status_code_1.StatusCode.makeStatusCode(statusCode, "HistorianMultiValue");
      }
      if (isPartial || interval.isPartial) {
        statusCode = node_opcua_status_code_1.StatusCode.makeStatusCode(statusCode, "HistorianPartial");
      }
      return new node_opcua_data_value_1.DataValue({
        sourceTimestamp: interval.startTime,
        statusCode,
        value: selectedValue
      });
    }
    function calculateIntervalMinValue(interval, options) {
      return calculateIntervalMinOrMaxValue(interval, options, (a, b) => a.value > b.value ? "select" : a.value === b.value ? "equal" : "reject");
    }
    exports2.calculateIntervalMinValue = calculateIntervalMinValue;
    function calculateIntervalMaxValue(interval, options) {
      return calculateIntervalMinOrMaxValue(interval, options, (a, b) => a.value < b.value ? "select" : a.value === b.value ? "equal" : "reject");
    }
    exports2.calculateIntervalMaxValue = calculateIntervalMaxValue;
    function getMinData(node, processingInterval, startDate, endDate, callback) {
      return (0, common_1.getAggregateData)(node, processingInterval, startDate, endDate, calculateIntervalMinValue, callback);
    }
    exports2.getMinData = getMinData;
    function getMaxData(node, processingInterval, startDate, endDate, callback) {
      return (0, common_1.getAggregateData)(node, processingInterval, startDate, endDate, calculateIntervalMaxValue, callback);
    }
    exports2.getMaxData = getMaxData;
  }
});

// node_modules/node-opcua-aggregates/dist/interpolate.js
var require_interpolate = __commonJS({
  "node_modules/node-opcua-aggregates/dist/interpolate.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getInterpolatedData = exports2.interpolatedValue = void 0;
    var node_opcua_assert_1 = require_dist14();
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_status_code_1 = require_dist22();
    var common_1 = require_common4();
    var interval_1 = require_interval();
    function interpolatedValue(interval, options) {
      options = (0, interval_1.adjustProcessingOptions)(options);
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "useSlopedExtrapolation"));
      (0, node_opcua_assert_1.assert)(Object.prototype.hasOwnProperty.call(options, "treatUncertainAsBad"));
      const bTreatUncertainAsBad = options.treatUncertainAsBad;
      const steppedValue = (previousDataValue) => {
        if (!previousDataValue.statusCode) {
          throw new Error("Expecting statusCode");
        }
        const interpValue = new node_opcua_data_value_1.DataValue({
          sourceTimestamp: interval.startTime,
          statusCode: node_opcua_status_code_1.StatusCodes.Bad,
          value: previousDataValue.value
        });
        interpValue.statusCode = node_opcua_status_code_1.StatusCode.makeStatusCode(node_opcua_status_code_1.StatusCodes.UncertainDataSubNormal, "HistorianInterpolated");
        return interpValue;
      };
      if (interval.index === -1) {
        const prev1 = (0, interval_1._findGoodDataValueBefore)(interval.dataValues, interval.dataValues.length, bTreatUncertainAsBad);
        if (prev1.index <= 0) {
          return new node_opcua_data_value_1.DataValue({
            sourceTimestamp: interval.startTime,
            statusCode: node_opcua_status_code_1.StatusCodes.BadNoData,
            value: void 0
          });
        }
        if (!options.useSlopedExtrapolation) {
          return steppedValue(prev1.dataValue);
        }
        const prev2 = (0, interval_1._findGoodDataValueBefore)(interval.dataValues, prev1.index, bTreatUncertainAsBad);
        if (prev2.index <= 0) {
          return steppedValue(prev1.dataValue);
        }
        const interpVal = (0, common_1.interpolateValue)(prev2.dataValue, prev1.dataValue, interval.startTime);
        if (prev2.index + 1 < prev1.index || prev1.index < interval.dataValues.length - 1) {
          const mask = 16777215;
          const extraBits = interpVal.statusCode.value & mask;
          interpVal.statusCode = node_opcua_status_code_1.StatusCode.makeStatusCode(node_opcua_status_code_1.StatusCodes.UncertainDataSubNormal, extraBits);
        }
        return interpVal;
      }
      if (interval.index < 0 && interval.count === 0) {
        return new node_opcua_data_value_1.DataValue({
          sourceTimestamp: interval.startTime,
          statusCode: node_opcua_status_code_1.StatusCodes.BadNoData
        });
      }
      const dataValue1 = interval.dataValues[interval.index];
      if (!dataValue1.statusCode.isBad() && interval.hasRawDataAsStart()) {
        return dataValue1;
      }
      const before = interval.beforeStartDataValue(bTreatUncertainAsBad);
      if (before.dataValue.statusCode.isBad()) {
        return new node_opcua_data_value_1.DataValue({
          sourceTimestamp: interval.startTime,
          statusCode: node_opcua_status_code_1.StatusCodes.BadNoData
        });
      }
      if (options.stepped) {
        if (before.index + 1 === interval.index) {
          return new node_opcua_data_value_1.DataValue({
            sourceTimestamp: interval.startTime,
            statusCode: node_opcua_status_code_1.StatusCode.makeStatusCode(before.dataValue.statusCode, "HistorianInterpolated"),
            value: before.dataValue.value
          });
        }
        return steppedValue(before.dataValue);
      }
      const next = interval.nextStartDataValue(bTreatUncertainAsBad);
      const interpolatedDataValue = (0, common_1.interpolateValue)(before.dataValue, next.dataValue, interval.startTime);
      if (before.index + 1 < next.index || !next.dataValue.statusCode.isGood() || !before.dataValue.statusCode.isGood()) {
        const mask = 16777215;
        const extraBits = interpolatedDataValue.statusCode.value & mask;
        interpolatedDataValue.statusCode = node_opcua_status_code_1.StatusCode.makeStatusCode(node_opcua_status_code_1.StatusCodes.UncertainDataSubNormal, extraBits);
      }
      return interpolatedDataValue;
    }
    exports2.interpolatedValue = interpolatedValue;
    function getInterpolatedData(node, processingInterval, startDate, endDate, callback) {
      (0, common_1.getAggregateData)(node, processingInterval, startDate, endDate, interpolatedValue, callback);
    }
    exports2.getInterpolatedData = getInterpolatedData;
  }
});

// node_modules/node-opcua-aggregates/dist/average.js
var require_average = __commonJS({
  "node_modules/node-opcua-aggregates/dist/average.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getAverageData = void 0;
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_status_code_1 = require_dist22();
    var common_1 = require_common4();
    function calculateIntervalAverageValue(interval, options) {
      const indexStart = interval.index;
      let statusCode;
      let isPartial = interval.isPartial;
      const isRaw = false;
      let hasBad = false;
      const values = [];
      for (let i = indexStart; i < indexStart + interval.count; i++) {
        const dataValue = interval.dataValues[i];
        if (dataValue.statusCode.equals(node_opcua_status_code_1.StatusCodes.BadNoData)) {
          isPartial = true;
          continue;
        }
        if (dataValue.statusCode.isNotGood()) {
          hasBad = true;
          continue;
        }
        values.push(dataValue.value.value);
      }
      if (isRaw) {
        if (hasBad) {
          statusCode = node_opcua_status_code_1.StatusCodes.UncertainDataSubNormal;
        } else {
          statusCode = node_opcua_status_code_1.StatusCodes.Good;
        }
      } else if (hasBad) {
        statusCode = node_opcua_status_code_1.StatusCode.makeStatusCode(node_opcua_status_code_1.StatusCodes.UncertainDataSubNormal, "HistorianCalculated");
      } else {
        statusCode = node_opcua_status_code_1.StatusCode.makeStatusCode(node_opcua_status_code_1.StatusCodes.Good, "HistorianCalculated");
      }
      if (values.length === 0) {
        return new node_opcua_data_value_1.DataValue({
          sourceTimestamp: interval.startTime,
          statusCode: node_opcua_status_code_1.StatusCodes.BadNoData
        });
      }
      const mean = values.reduce((p3, c2) => p3 + c2, 0) / values.length;
      return new node_opcua_data_value_1.DataValue({
        sourceTimestamp: interval.startTime,
        statusCode,
        value: {
          dataType: node_opcua_variant_1.DataType.Double,
          value: mean
        }
      });
    }
    function getAverageData(node, processingInterval, startDate, endDate, callback) {
      (0, common_1.getAggregateData)(node, processingInterval, startDate, endDate, calculateIntervalAverageValue, callback);
    }
    exports2.getAverageData = getAverageData;
  }
});

// node_modules/node-opcua-aggregates/dist/count.js
var require_count = __commonJS({
  "node_modules/node-opcua-aggregates/dist/count.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getCountData = void 0;
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_variant_1 = require_dist28();
    var common_1 = require_common4();
    var interval_1 = require_interval();
    function calculateCountValue(interval, options) {
      const indexStart = interval.index;
      let statusCode = node_opcua_status_code_1.StatusCodes.Good;
      let isPartial = interval.isPartial;
      let nbBad = 0;
      let nbGood = 0;
      let nbUncertain = 0;
      let badDuration = 0;
      let uncertainDuration = 0;
      let goodDuration = 0;
      for (let i = indexStart; i < indexStart + interval.count; i++) {
        const dataValue = interval.dataValues[i];
        if (dataValue.statusCode.equals(node_opcua_status_code_1.StatusCodes.BadNoData)) {
          isPartial = true;
          continue;
        }
        const regionDuration = interval.regionDuration(i);
        if (dataValue.statusCode.isBad()) {
          nbBad++;
          badDuration += regionDuration;
        } else if ((0, interval_1.isUncertain)(dataValue.statusCode)) {
          nbUncertain++;
          uncertainDuration += regionDuration;
        } else if (dataValue.statusCode.isGoodish()) {
          nbGood++;
          goodDuration += regionDuration;
        }
      }
      const partialFlag = isPartial ? node_opcua_status_code_1.extraStatusCodeBits.HistorianPartial : 0;
      if (nbBad > 0) {
        const duration = interval.duration();
        if (options.treatUncertainAsBad) {
          badDuration += uncertainDuration;
        }
        const actualPercentDataBad = badDuration / duration * 100;
        const percentDataBad = options.percentDataBad === void 0 ? 100 : options.percentDataBad;
        if (actualPercentDataBad >= percentDataBad) {
          return new node_opcua_data_value_1.DataValue({
            sourceTimestamp: interval.startTime,
            statusCode: node_opcua_status_code_1.StatusCodes.Bad
          });
        }
      }
      if (nbUncertain > 0 || nbBad > 0) {
        statusCode = node_opcua_status_code_1.StatusCode.makeStatusCode(node_opcua_status_code_1.StatusCodes.UncertainDataSubNormal, node_opcua_status_code_1.extraStatusCodeBits.HistorianCalculated | partialFlag);
      } else {
        statusCode = node_opcua_status_code_1.StatusCode.makeStatusCode(node_opcua_status_code_1.StatusCodes.Good, node_opcua_status_code_1.extraStatusCodeBits.HistorianCalculated | partialFlag);
      }
      if (nbUncertain === 0 && nbGood === 0) {
        statusCode = node_opcua_status_code_1.StatusCodes.BadNoData;
        return new node_opcua_data_value_1.DataValue({
          sourceTimestamp: interval.startTime,
          statusCode
        });
      }
      return new node_opcua_data_value_1.DataValue({
        sourceTimestamp: interval.startTime,
        statusCode,
        value: {
          dataType: node_opcua_variant_1.DataType.UInt32,
          value: nbGood
        }
      });
    }
    function getCountData(node, processingInterval, startDate, endDate, callback) {
      (0, common_1.getAggregateData)(node, processingInterval, startDate, endDate, calculateCountValue, callback);
    }
    exports2.getCountData = getCountData;
  }
});

// node_modules/node-opcua-aggregates/dist/calculate_bad_good.js
var require_calculate_bad_good = __commonJS({
  "node_modules/node-opcua-aggregates/dist/calculate_bad_good.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.calculateBadAndGood = void 0;
    var node_opcua_status_code_1 = require_dist22();
    var interval_1 = require_interval();
    var a = (s, options) => !s || s === node_opcua_status_code_1.StatusCodes.BadNoData ? node_opcua_status_code_1.StatusCodes.BadNoData : s.isBad() || options.treatUncertainAsBad && (0, interval_1.isUncertain)(s) ? node_opcua_status_code_1.StatusCodes.Bad : node_opcua_status_code_1.StatusCodes.Good;
    function findLowBound(interval, options) {
      const indexStart = interval.index;
      const initialValue = interval.dataValues[indexStart];
      if (initialValue.sourceTimestamp.getTime() === interval.startTime.getTime()) {
        return { previousStatus: initialValue.statusCode, previousTime: interval.startTime.getTime(), indexStart: indexStart + 1 };
      }
      const previousStatus = indexStart === 0 || !interval.dataValues[indexStart - 1] ? node_opcua_status_code_1.StatusCodes.BadNoData : a(interval.dataValues[indexStart - 1].statusCode, options);
      const previousTime = interval.startTime.getTime();
      return { previousStatus, previousTime, indexStart };
    }
    function calculateBadAndGood(interval, options) {
      if (interval.count === 0) {
        return {
          durationGood: 0,
          durationBad: 0,
          durationUnknown: 0,
          percentBad: 0,
          percentGood: 0,
          statusCode: node_opcua_status_code_1.StatusCodes.BadNoData
        };
      }
      let durationGood = 0;
      let durationBad = 0;
      let durationUnknown = 0;
      let partialFlag = interval.isPartial ? node_opcua_status_code_1.extraStatusCodeBits.HistorianPartial : 0;
      let { previousStatus, previousTime, indexStart } = findLowBound(interval, options);
      if (previousStatus === node_opcua_status_code_1.StatusCodes.BadNoData) {
        partialFlag = node_opcua_status_code_1.extraStatusCodeBits.HistorianPartial;
        previousStatus = node_opcua_status_code_1.StatusCodes.Bad;
      }
      let nbGood = 0;
      let nbBad = 0;
      let nbUncertain = 0;
      indexStart += 0;
      for (let i = indexStart; i < interval.index + interval.count; i++) {
        const dataValue = interval.dataValues[i];
        if (dataValue.statusCode.isGoodish()) {
          nbGood++;
        }
        if ((0, interval_1.isUncertain)(dataValue.statusCode)) {
          nbUncertain++;
        }
        if (dataValue.statusCode.isBad()) {
          nbBad++;
        }
        const currentStatus = a(dataValue.statusCode, options);
        if (currentStatus === node_opcua_status_code_1.StatusCodes.BadNoData) {
          partialFlag = node_opcua_status_code_1.extraStatusCodeBits.HistorianPartial;
        }
        const currentTime2 = dataValue.sourceTimestamp.getTime();
        if (currentStatus === previousStatus)
          continue;
        if (previousStatus === node_opcua_status_code_1.StatusCodes.Good) {
          durationGood += currentTime2 - previousTime;
        } else if (previousStatus === node_opcua_status_code_1.StatusCodes.BadNoData) {
          durationUnknown += currentTime2 - previousTime;
        } else {
          durationBad += currentTime2 - previousTime;
        }
        previousStatus = currentStatus;
        previousTime = currentTime2;
      }
      const currentTime = interval.getEffectiveEndTime();
      if (previousStatus === node_opcua_status_code_1.StatusCodes.Good) {
        durationGood += currentTime - previousTime;
      } else if (previousStatus === node_opcua_status_code_1.StatusCodes.BadNoData) {
        durationUnknown += currentTime - previousTime;
      } else {
        durationBad += currentTime - previousTime;
      }
      if (nbGood === 0) {
        if (nbBad > 0) {
          durationGood = -1;
        } else {
          durationGood = 0;
        }
      }
      const effectiveProcessingInterval = currentTime - interval.startTime.getTime();
      const percentGood = durationGood / effectiveProcessingInterval * 100;
      const percentBad = durationBad / effectiveProcessingInterval * 100;
      let percentDataGood = options.percentDataGood === void 0 ? 100 : options.percentDataGood;
      const percentDataBad = options.percentDataBad === void 0 ? 100 : options.percentDataBad;
      if (percentBad >= percentDataBad || nbGood === 0 && nbUncertain === 0) {
        durationGood = 0;
        percentDataGood = -1;
      }
      const statusCode = node_opcua_status_code_1.StatusCode.makeStatusCode(node_opcua_status_code_1.StatusCodes.Good, node_opcua_status_code_1.extraStatusCodeBits.HistorianCalculated | partialFlag);
      return { durationGood, durationBad, durationUnknown, percentBad, percentGood, statusCode };
    }
    exports2.calculateBadAndGood = calculateBadAndGood;
  }
});

// node_modules/node-opcua-aggregates/dist/percent_bad.js
var require_percent_bad = __commonJS({
  "node_modules/node-opcua-aggregates/dist/percent_bad.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getPercentBadData = void 0;
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_variant_1 = require_dist28();
    var common_1 = require_common4();
    var calculate_bad_good_1 = require_calculate_bad_good();
    function calculatePercentBad(interval, options) {
      const { percentBad, statusCode } = (0, calculate_bad_good_1.calculateBadAndGood)(interval, options);
      const value = percentBad;
      if (statusCode.isGoodish()) {
        return new node_opcua_data_value_1.DataValue({
          sourceTimestamp: interval.startTime,
          statusCode,
          value: { dataType: node_opcua_variant_1.DataType.Double, value }
        });
      }
      return new node_opcua_data_value_1.DataValue({ sourceTimestamp: interval.startTime, statusCode, value: { dataType: node_opcua_variant_1.DataType.Null } });
    }
    function getPercentBadData(node, processingInterval, startDate, endDate, callback) {
      (0, common_1.getAggregateData)(node, processingInterval, startDate, endDate, calculatePercentBad, callback);
    }
    exports2.getPercentBadData = getPercentBadData;
  }
});

// node_modules/node-opcua-aggregates/dist/percent_good.js
var require_percent_good = __commonJS({
  "node_modules/node-opcua-aggregates/dist/percent_good.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getPercentGoodData = void 0;
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_status_code_1 = require_dist22();
    var common_1 = require_common4();
    var calculate_bad_good_1 = require_calculate_bad_good();
    function calculatePercentGood(interval, options) {
      const { percentGood, statusCode } = (0, calculate_bad_good_1.calculateBadAndGood)(interval, options);
      if (percentGood < 0) {
        return new node_opcua_data_value_1.DataValue({
          sourceTimestamp: interval.startTime,
          statusCode: node_opcua_status_code_1.StatusCodes.Bad,
          value: { dataType: node_opcua_variant_1.DataType.Null }
        });
      }
      const value = percentGood;
      if (statusCode.isGoodish()) {
        return new node_opcua_data_value_1.DataValue({
          sourceTimestamp: interval.startTime,
          statusCode,
          value: { dataType: node_opcua_variant_1.DataType.Double, value }
        });
      }
      return new node_opcua_data_value_1.DataValue({ sourceTimestamp: interval.startTime, statusCode, value: { dataType: node_opcua_variant_1.DataType.Null } });
    }
    function getPercentGoodData(node, processingInterval, startDate, endDate, callback) {
      (0, common_1.getAggregateData)(node, processingInterval, startDate, endDate, calculatePercentGood, callback);
    }
    exports2.getPercentGoodData = getPercentGoodData;
  }
});

// node_modules/node-opcua-aggregates/dist/duration_good.js
var require_duration_good = __commonJS({
  "node_modules/node-opcua-aggregates/dist/duration_good.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getDurationGoodData = void 0;
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_status_code_1 = require_dist22();
    var common_1 = require_common4();
    var calculate_bad_good_1 = require_calculate_bad_good();
    function calculateDurationGood(interval, options) {
      const { durationGood, durationUnknown, statusCode } = (0, calculate_bad_good_1.calculateBadAndGood)(interval, options);
      if (durationUnknown > 0 && durationGood === 0) {
        return new node_opcua_data_value_1.DataValue({
          sourceTimestamp: interval.startTime,
          statusCode: node_opcua_status_code_1.StatusCodes.Bad
        });
      }
      const value = durationGood;
      if (statusCode.isGoodish()) {
        return new node_opcua_data_value_1.DataValue({
          sourceTimestamp: interval.startTime,
          statusCode,
          value: { dataType: node_opcua_variant_1.DataType.Double, value }
        });
      }
      return new node_opcua_data_value_1.DataValue({ sourceTimestamp: interval.startTime, statusCode, value: { dataType: node_opcua_variant_1.DataType.Null } });
    }
    function getDurationGoodData(node, processingInterval, startDate, endDate, callback) {
      (0, common_1.getAggregateData)(node, processingInterval, startDate, endDate, calculateDurationGood, callback);
    }
    exports2.getDurationGoodData = getDurationGoodData;
  }
});

// node_modules/node-opcua-aggregates/dist/duration_bad.js
var require_duration_bad = __commonJS({
  "node_modules/node-opcua-aggregates/dist/duration_bad.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getDurationBadData = void 0;
    var node_opcua_data_value_1 = require_dist29();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_status_code_1 = require_dist22();
    var common_1 = require_common4();
    var calculate_bad_good_1 = require_calculate_bad_good();
    function calculateDurationBad(interval, options) {
      const { durationBad, durationUnknown, statusCode } = (0, calculate_bad_good_1.calculateBadAndGood)(interval, options);
      if (durationUnknown > 0 && durationBad === 0) {
        return new node_opcua_data_value_1.DataValue({
          sourceTimestamp: interval.startTime,
          statusCode: node_opcua_status_code_1.StatusCodes.Bad
        });
      }
      const value = durationBad;
      if (statusCode.isGoodish()) {
        return new node_opcua_data_value_1.DataValue({
          sourceTimestamp: interval.startTime,
          statusCode,
          value: { dataType: node_opcua_variant_1.DataType.Double, value }
        });
      }
      return new node_opcua_data_value_1.DataValue({ sourceTimestamp: interval.startTime, statusCode, value: { dataType: node_opcua_variant_1.DataType.Null } });
    }
    function getDurationBadData(node, processingInterval, startDate, endDate, callback) {
      (0, common_1.getAggregateData)(node, processingInterval, startDate, endDate, calculateDurationBad, callback);
    }
    exports2.getDurationBadData = getDurationBadData;
  }
});

// node_modules/node-opcua-aggregates/dist/read_processed_details.js
var require_read_processed_details = __commonJS({
  "node_modules/node-opcua-aggregates/dist/read_processed_details.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.readProcessedDetails = void 0;
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_status_code_1 = require_dist22();
    var node_opcua_service_history_1 = require_dist54();
    var minmax_1 = require_minmax();
    var interpolate_1 = require_interpolate();
    var average_1 = require_average();
    var count_1 = require_count();
    var percent_bad_1 = require_percent_bad();
    var percent_good_1 = require_percent_good();
    var duration_good_1 = require_duration_good();
    var duration_bad_1 = require_duration_bad();
    function _buildResult(err, dataValues, callback2) {
      if (err) {
        return callback2(null, new node_opcua_service_history_1.HistoryReadResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadInternalError }));
      }
      const result2 = new node_opcua_service_history_1.HistoryReadResult({
        historyData: new node_opcua_service_history_1.HistoryData({
          dataValues
        }),
        statusCode: node_opcua_status_code_1.StatusCodes.Good
      });
      return callback2(null, result2);
    }
    function applyAggregate(variable, processingInterval, startTime, endTime, aggregateType, callback2) {
      if (!startTime || !endTime) {
        return _buildResult(new Error("Invalid date time"), void 0, callback2);
      }
      const buildResult = (err, dataValues) => {
        _buildResult(err, dataValues, callback2);
      };
      if (aggregateType.namespace === 0) {
        switch (aggregateType.value) {
          case node_opcua_constants_1.AggregateFunction.Minimum:
            (0, minmax_1.getMinData)(variable, processingInterval, startTime, endTime, buildResult);
            break;
          case node_opcua_constants_1.AggregateFunction.Maximum:
            (0, minmax_1.getMaxData)(variable, processingInterval, startTime, endTime, buildResult);
            break;
          case node_opcua_constants_1.AggregateFunction.Interpolative:
            (0, interpolate_1.getInterpolatedData)(variable, processingInterval, startTime, endTime, buildResult);
            break;
          case node_opcua_constants_1.AggregateFunction.Average:
            (0, average_1.getAverageData)(variable, processingInterval, startTime, endTime, buildResult);
            break;
          case node_opcua_constants_1.AggregateFunction.DurationGood:
            (0, duration_good_1.getDurationGoodData)(variable, processingInterval, startTime, endTime, buildResult);
            break;
          case node_opcua_constants_1.AggregateFunction.DurationBad:
            (0, duration_bad_1.getDurationBadData)(variable, processingInterval, startTime, endTime, buildResult);
            break;
          case node_opcua_constants_1.AggregateFunction.PercentBad:
            (0, percent_bad_1.getPercentBadData)(variable, processingInterval, startTime, endTime, buildResult);
            break;
          case node_opcua_constants_1.AggregateFunction.PercentGood:
            (0, percent_good_1.getPercentGoodData)(variable, processingInterval, startTime, endTime, buildResult);
            break;
          case node_opcua_constants_1.AggregateFunction.Count:
            (0, count_1.getCountData)(variable, processingInterval, startTime, endTime, buildResult);
            break;
          default:
            return callback2(null, new node_opcua_service_history_1.HistoryReadResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadAggregateNotSupported }));
        }
      } else {
        return callback2(null, new node_opcua_service_history_1.HistoryReadResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadAggregateNotSupported }));
      }
    }
    function readProcessedDetails(variable, context, historyReadDetails, indexRange, dataEncoding, continuationData, callback) {
      const startTime = historyReadDetails.startTime;
      const endTime = historyReadDetails.endTime;
      if (!startTime || !endTime) {
        return callback(null, new node_opcua_service_history_1.HistoryReadResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadInvalidArgument }));
      }
      if (startTime.getTime() === endTime.getTime()) {
        return callback(null, new node_opcua_service_history_1.HistoryReadResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadInvalidArgument }));
      }
      const aggregateTypes = historyReadDetails.aggregateType || [];
      const processingInterval = historyReadDetails.processingInterval || endTime.getTime() - startTime.getTime();
      if (!historyReadDetails.aggregateType || historyReadDetails.aggregateType.length !== 1) {
        return callback(null, new node_opcua_service_history_1.HistoryReadResult({ statusCode: node_opcua_status_code_1.StatusCodes.BadInternalError }));
      }
      return applyAggregate(variable, processingInterval, startTime, endTime, aggregateTypes[0], callback);
    }
    exports2.readProcessedDetails = readProcessedDetails;
  }
});

// node_modules/node-opcua-aggregates/dist/aggregates.js
var require_aggregates = __commonJS({
  "node_modules/node-opcua-aggregates/dist/aggregates.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getAggregateConfiguration = exports2.installAggregateConfigurationOptions = exports2.getAggregateFunctions = exports2.addAggregateSupport = exports2.addAggregateStandardFunctionSupport = exports2.addAggregateFunctionSupport = exports2.createHistoryServerCapabilities = void 0;
    var node_opcua_constants_1 = require_dist20();
    var node_opcua_nodeid_1 = require_dist21();
    var node_opcua_variant_1 = require_dist28();
    var node_opcua_utils_1 = require_dist16();
    var node_opcua_data_model_1 = require_dist27();
    var read_processed_details_1 = require_read_processed_details();
    var historicalCapabilitiesDefaultProperties = {
      accessHistoryDataCapability: true,
      // Boolean PropertyType Mandatory
      accessHistoryEventsCapability: true,
      // Boolean PropertyType Mandatory
      deleteAtTimeCapability: false,
      // Boolean PropertyType Mandatory
      deleteEventCapability: false,
      // Boolean PropertyType Mandatory
      deleteRawCapability: false,
      // Boolean PropertyType Mandatory
      insertAnnotationCapability: false,
      // Boolean PropertyType Mandatory
      insertDataCapability: false,
      // Boolean PropertyType Mandatory
      insertEventCapability: false,
      // Boolean PropertyType Mandatory
      maxReturnDataValues: 0,
      maxReturnEventValues: 0,
      // UInt32 PropertyType Mandatory
      replaceDataCapability: false,
      // Boolean PropertyType Mandatory
      replaceEventCapability: false,
      // Boolean PropertyType Mandatory
      updateDataCapability: false,
      // Boolean PropertyType Mandatory
      updateEventCapability: false
      // Boolean PropertyType Mandatory
    };
    function createHistoryServerCapabilities(addressSpace, serverCapabilities) {
      if (serverCapabilities.browseName.toString() !== "ServerCapabilities") {
        throw new Error("Expecting server Capabilities");
      }
      const historyServerCapabilitiesType = addressSpace.getNamespace(0).findObjectType("HistoryServerCapabilitiesType");
      if (!historyServerCapabilitiesType) {
        throw new Error("Cannot find HistoryServerCapabilitiesType");
      }
      return historyServerCapabilitiesType.instantiate({
        browseName: "HistoryServerCapabilities",
        componentOf: serverCapabilities
      });
    }
    exports2.createHistoryServerCapabilities = createHistoryServerCapabilities;
    function setHistoricalServerCapabilities(historyServerCapabilities, defaultProperties) {
      function setBoolean(propName) {
        const lowerCase = (0, node_opcua_utils_1.lowerFirstLetter)(propName);
        if (!Object.prototype.hasOwnProperty.call(defaultProperties, lowerCase)) {
          throw new Error("cannot find " + lowerCase);
        }
        const value = defaultProperties[lowerCase];
        const prop = historyServerCapabilities.getChildByName(propName);
        if (!prop) {
          throw new Error(" Cannot find property " + propName);
        }
        prop.setValueFromSource({ dataType: node_opcua_variant_1.DataType.Boolean, value });
      }
      function setUInt32(propName) {
        const lowerCase = (0, node_opcua_utils_1.lowerFirstLetter)(propName);
        if (!Object.prototype.hasOwnProperty.call(historyServerCapabilities, lowerCase)) {
          throw new Error("cannot find " + lowerCase);
        }
        const value = defaultProperties[lowerCase];
        const prop = historyServerCapabilities.getChildByName(propName);
        prop.setValueFromSource({ dataType: node_opcua_variant_1.DataType.UInt32, value });
      }
      setBoolean("AccessHistoryDataCapability");
      setBoolean("AccessHistoryEventsCapability");
      setUInt32("MaxReturnDataValues");
      setUInt32("MaxReturnEventValues");
      setBoolean("InsertDataCapability");
      setBoolean("ReplaceDataCapability");
      setBoolean("UpdateDataCapability");
      setBoolean("DeleteRawCapability");
      setBoolean("DeleteAtTimeCapability");
      setBoolean("InsertEventCapability");
      setBoolean("ReplaceEventCapability");
      setBoolean("UpdateEventCapability");
      setBoolean("DeleteEventCapability");
    }
    function addAggregateFunctionSupport(addressSpace, aggregateFunctionNodeId) {
      const serverCapabilities = addressSpace.rootFolder.objects.server.serverCapabilities;
      if (!serverCapabilities.historyServerCapabilities) {
        throw new Error("missing serverCapabilities.historyServerCapabilities");
      }
      const aggregateFunctions = serverCapabilities.aggregateFunctions;
      const aggregateFunctionsInHist = serverCapabilities.historyServerCapabilities.aggregateFunctions;
      const functionNode = addressSpace.findNode(aggregateFunctionNodeId);
      if (!functionNode) {
        throw new Error("Cannot find node " + aggregateFunctionNodeId.toString() + " in addressSpace");
      }
      if (functionNode.nodeClass !== node_opcua_data_model_1.NodeClass.Object) {
        throw new Error("Expecting an object Node");
      }
      if (!(0, node_opcua_nodeid_1.sameNodeId)(functionNode.typeDefinition, (0, node_opcua_nodeid_1.coerceNodeId)(node_opcua_constants_1.ObjectTypeIds.AggregateFunctionType))) {
        throw new Error("Expecting an object with TypeDefinition AggregateFunctionType");
      }
      aggregateFunctions.addReference({
        nodeId: functionNode.nodeId,
        referenceType: "Organizes"
      });
      aggregateFunctionsInHist.addReference({
        nodeId: functionNode.nodeId,
        referenceType: "Organizes"
      });
    }
    exports2.addAggregateFunctionSupport = addAggregateFunctionSupport;
    function addAggregateStandardFunctionSupport(addressSpace, functionName) {
      if (!functionName) {
        throw new Error("Invalid function name");
      }
      const functionNodeId = (0, node_opcua_nodeid_1.makeNodeId)(functionName);
      addAggregateFunctionSupport(addressSpace, functionNodeId);
    }
    exports2.addAggregateStandardFunctionSupport = addAggregateStandardFunctionSupport;
    function addAggregateSupport(addressSpace, aggregatedFunctions) {
      aggregatedFunctions = aggregatedFunctions || [
        node_opcua_constants_1.AggregateFunction.Interpolative,
        node_opcua_constants_1.AggregateFunction.Minimum,
        node_opcua_constants_1.AggregateFunction.Maximum,
        node_opcua_constants_1.AggregateFunction.Average
      ];
      const aggregateConfigurationType = addressSpace.getNamespace(0).findObjectType("AggregateConfigurationType");
      if (!aggregateConfigurationType) {
        throw new Error("addressSpace do not expose AggregateConfigurationType");
      }
      const aggregateFunctionType = addressSpace.getNamespace(0).findObjectType("AggregateFunctionType");
      if (!aggregateFunctionType) {
        throw new Error("addressSpace do not expose AggregateFunctionType");
      }
      const serverObject = addressSpace.rootFolder.objects.getFolderElementByName("Server");
      if (!serverObject) {
        throw new Error("addressSpace do not expose a ServerObject");
      }
      const serverCapabilities = serverObject.getChildByName("ServerCapabilities");
      let historyServerCapabilities = serverCapabilities.getChildByName("HistoryServerCapabilities");
      if (!historyServerCapabilities) {
        historyServerCapabilities = createHistoryServerCapabilities(addressSpace, serverCapabilities);
      }
      setHistoricalServerCapabilities(historyServerCapabilities, historicalCapabilitiesDefaultProperties);
      for (const f2 of aggregatedFunctions) {
        addAggregateStandardFunctionSupport(addressSpace, f2);
      }
      const addressSpaceInternal = addressSpace;
      addressSpaceInternal._readProcessedDetails = read_processed_details_1.readProcessedDetails;
    }
    exports2.addAggregateSupport = addAggregateSupport;
    function getAggregateFunctions(addressSpace) {
      const aggregateFunctionTypeNodeId = (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_constants_1.ObjectTypeIds.AggregateFunctionType);
      const aggregateFunctions = addressSpace.findNode(node_opcua_constants_1.ObjectIds.Server_ServerCapabilities_AggregateFunctions);
      if (!aggregateFunctions) {
        return [];
      }
      const referenceDescripitions = aggregateFunctions.browseNode({
        referenceTypeId: node_opcua_constants_1.ReferenceTypeIds.HierarchicalReferences,
        resultMask: 63,
        nodeClassMask: node_opcua_data_model_1.NodeClassMask.Object,
        browseDirection: node_opcua_data_model_1.BrowseDirection.Forward,
        includeSubtypes: true
      });
      const aggregateFunctionsNodeIds = referenceDescripitions.filter((a) => (0, node_opcua_nodeid_1.sameNodeId)(a.typeDefinition, aggregateFunctionTypeNodeId)).map((a) => a.nodeId);
      return aggregateFunctionsNodeIds;
    }
    exports2.getAggregateFunctions = getAggregateFunctions;
    function installAggregateConfigurationOptions(node, options, aggregateFunctions) {
      const nodePriv = node;
      if (!nodePriv.historizing) {
        throw new Error("variable.historizing is not set\n make sure addressSpace.installHistoricalDataNode(variable) has been called");
      }
      const aggregateConfiguration = nodePriv.$historicalDataConfiguration.aggregateConfiguration;
      const f2 = (a, defaultValue) => a === void 0 ? defaultValue : a;
      aggregateConfiguration.percentDataBad.setValueFromSource({ dataType: "Byte", value: f2(options.percentDataBad, 100) });
      aggregateConfiguration.percentDataGood.setValueFromSource({ dataType: "Byte", value: f2(options.percentDataGood, 100) });
      aggregateConfiguration.treatUncertainAsBad.setValueFromSource({
        dataType: "Boolean",
        value: f2(options.treatUncertainAsBad, false)
      });
      aggregateConfiguration.useSlopedExtrapolation.setValueFromSource({
        dataType: "Boolean",
        value: f2(options.useSlopedExtrapolation, false)
      });
      nodePriv.$historicalDataConfiguration.stepped.setValueFromSource({
        dataType: "Boolean",
        value: f2(options.stepped, false)
      });
      if (!aggregateFunctions) {
        aggregateFunctions = getAggregateFunctions(node.addressSpace);
      }
      let uaAggregateFunctions = nodePriv.$historicalDataConfiguration.aggregateFunctions;
      if (!uaAggregateFunctions) {
        const namespace = nodePriv.namespace;
        uaAggregateFunctions = namespace.addObject({
          browseName: (0, node_opcua_data_model_1.coerceQualifiedName)({ name: "AggregateFunctions", namespaceIndex: 0 }),
          componentOf: nodePriv.$historicalDataConfiguration
        });
        uaAggregateFunctions = nodePriv.$historicalDataConfiguration.aggregateFunctions;
      }
      const referenceType = (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_constants_1.ReferenceTypeIds.Organizes);
      for (const nodeId of aggregateFunctions) {
        uaAggregateFunctions.addReference({
          nodeId,
          referenceType,
          isForward: true
        });
      }
    }
    exports2.installAggregateConfigurationOptions = installAggregateConfigurationOptions;
    function getAggregateConfiguration(node) {
      const nodePriv = node;
      if (!nodePriv.$historicalDataConfiguration) {
        throw new Error("internal error");
      }
      const aggregateConfiguration = nodePriv.$historicalDataConfiguration.aggregateConfiguration;
      const stepped = nodePriv.$historicalDataConfiguration.stepped.readValue().value.value;
      return {
        percentDataBad: aggregateConfiguration.percentDataBad.readValue().value.value,
        percentDataGood: aggregateConfiguration.percentDataGood.readValue().value.value,
        stepped,
        treatUncertainAsBad: aggregateConfiguration.treatUncertainAsBad.readValue().value.value,
        // xx stepped:                aggregateConfiguration.stepped.readValue().value,
        useSlopedExtrapolation: aggregateConfiguration.useSlopedExtrapolation.readValue().value.value
      };
    }
    exports2.getAggregateConfiguration = getAggregateConfiguration;
  }
});

// node_modules/node-opcua-aggregates/dist/index.js
var require_dist66 = __commonJS({
  "node_modules/node-opcua-aggregates/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getDurationGoodData = exports2.getDurationBadData = exports2.getPercentBadData = exports2.getPercentGoodData = exports2.getCountData = exports2.AggregateFunction = exports2.addAggregateFunctionSupport = exports2.addAggregateStandardFunctionSupport = exports2.getAggregateConfiguration = exports2.installAggregateConfigurationOptions = exports2.addAggregateSupport = void 0;
    var aggregates_1 = require_aggregates();
    Object.defineProperty(exports2, "addAggregateSupport", { enumerable: true, get: function() {
      return aggregates_1.addAggregateSupport;
    } });
    Object.defineProperty(exports2, "installAggregateConfigurationOptions", { enumerable: true, get: function() {
      return aggregates_1.installAggregateConfigurationOptions;
    } });
    Object.defineProperty(exports2, "getAggregateConfiguration", { enumerable: true, get: function() {
      return aggregates_1.getAggregateConfiguration;
    } });
    Object.defineProperty(exports2, "addAggregateStandardFunctionSupport", { enumerable: true, get: function() {
      return aggregates_1.addAggregateStandardFunctionSupport;
    } });
    Object.defineProperty(exports2, "addAggregateFunctionSupport", { enumerable: true, get: function() {
      return aggregates_1.addAggregateFunctionSupport;
    } });
    __exportStar3(require_interpolate(), exports2);
    __exportStar3(require_minmax(), exports2);
    __exportStar3(require_interval(), exports2);
    __exportStar3(require_common4(), exports2);
    __exportStar3(require_average(), exports2);
    __exportStar3(require_read_processed_details(), exports2);
    var node_opcua_constants_1 = require_dist20();
    Object.defineProperty(exports2, "AggregateFunction", { enumerable: true, get: function() {
      return node_opcua_constants_1.AggregateFunction;
    } });
    var count_1 = require_count();
    Object.defineProperty(exports2, "getCountData", { enumerable: true, get: function() {
      return count_1.getCountData;
    } });
    var percent_good_1 = require_percent_good();
    Object.defineProperty(exports2, "getPercentGoodData", { enumerable: true, get: function() {
      return percent_good_1.getPercentGoodData;
    } });
    var percent_bad_1 = require_percent_bad();
    Object.defineProperty(exports2, "getPercentBadData", { enumerable: true, get: function() {
      return percent_bad_1.getPercentBadData;
    } });
    var duration_bad_1 = require_duration_bad();
    Object.defineProperty(exports2, "getDurationBadData", { enumerable: true, get: function() {
      return duration_bad_1.getDurationBadData;
    } });
    var duration_good_1 = require_duration_good();
    Object.defineProperty(exports2, "getDurationGoodData", { enumerable: true, get: function() {
      return duration_good_1.getDurationGoodData;
    } });
  }
});

// node_modules/node-opcua/dist/index.js
var require_dist67 = __commonJS({
  "node_modules/node-opcua/dist/index.js"(exports2) {
    "use strict";
    var __createBinding3 = exports2 && exports2.__createBinding || (Object.create ? function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m2, k);
      if (!desc || ("get" in desc ? !m2.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m2[k];
        } };
      }
      Object.defineProperty(o2, k2, desc);
    } : function(o2, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m2[k];
    });
    var __exportStar3 = exports2 && exports2.__exportStar || function(m2, exports3) {
      for (var p3 in m2)
        if (p3 !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p3))
          __createBinding3(exports3, m2, p3);
    };
    var __importDefault3 = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.setDebugLogger = exports2.setLogLevel = exports2.hexDump = exports2.LogLevel = exports2.utils = exports2.get_mini_nodeset_filename = exports2.get_empty_nodeset_filename = exports2.nodesets = exports2.Range = exports2.makeEUInformation = exports2.standardUnits = exports2.DiagnosticInfo = exports2.BrowseDirection = exports2.AttributeIds = exports2.NodeClassMask = exports2.NodeClass = exports2.coerceQualifiedName = exports2.QualifiedName = exports2.coerceLocalizedText = exports2.LocalizedText = exports2.makeAccessLevelFlag = exports2.AccessLevelFlag = exports2.NumericRange = exports2.sameDataValue = exports2.DataValue = exports2.buildVariantArray = exports2.VariantArrayType = exports2.Variant = exports2.DataType = exports2.AggregateFunction = exports2.DataTypeIds = exports2.ReferenceTypeIds = exports2.ObjectTypeIds = exports2.ObjectIds = exports2.MethodIds = exports2.VariableIds = exports2.VariableTypeIds = exports2.StatusCodes = exports2.StatusCode = exports2.coerceExpandedNodeId = exports2.makeExpandedNodeId = exports2.ExpandedNodeId = exports2.NodeIdType = exports2.sameNodeId = exports2.coerceNodeId = exports2.makeNodeId = exports2.resolveNodeId = exports2.NodeId = exports2.BinaryStream = exports2.assert = void 0;
    exports2.is_valid_endpointUrl = exports2.parseEndpointUrl = exports2.setErrorLogger = exports2.setWarningLogger = void 0;
    var chalk_1 = __importDefault3(require_source());
    var semver = require_semver2();
    var minimumNodeVersionRequired = ">=16.7.0";
    if (typeof process === "object" && !semver.satisfies(process.version, minimumNodeVersionRequired)) {
      console.log(chalk_1.default.cyan(`warning node-opcua: Required nodejs version ${minimumNodeVersionRequired} not satisfied with current nodejs version ${process.version}.`));
    }
    __exportStar3(require_dist34(), exports2);
    var node_opcua_assert_1 = require_dist14();
    Object.defineProperty(exports2, "assert", { enumerable: true, get: function() {
      return node_opcua_assert_1.assert;
    } });
    var node_opcua_binary_stream_1 = require_dist18();
    Object.defineProperty(exports2, "BinaryStream", { enumerable: true, get: function() {
      return node_opcua_binary_stream_1.BinaryStream;
    } });
    __exportStar3(require_dist16(), exports2);
    var node_opcua_nodeid_1 = require_dist21();
    Object.defineProperty(exports2, "NodeId", { enumerable: true, get: function() {
      return node_opcua_nodeid_1.NodeId;
    } });
    Object.defineProperty(exports2, "resolveNodeId", { enumerable: true, get: function() {
      return node_opcua_nodeid_1.resolveNodeId;
    } });
    Object.defineProperty(exports2, "makeNodeId", { enumerable: true, get: function() {
      return node_opcua_nodeid_1.makeNodeId;
    } });
    Object.defineProperty(exports2, "coerceNodeId", { enumerable: true, get: function() {
      return node_opcua_nodeid_1.coerceNodeId;
    } });
    Object.defineProperty(exports2, "sameNodeId", { enumerable: true, get: function() {
      return node_opcua_nodeid_1.sameNodeId;
    } });
    Object.defineProperty(exports2, "NodeIdType", { enumerable: true, get: function() {
      return node_opcua_nodeid_1.NodeIdType;
    } });
    Object.defineProperty(exports2, "ExpandedNodeId", { enumerable: true, get: function() {
      return node_opcua_nodeid_1.ExpandedNodeId;
    } });
    Object.defineProperty(exports2, "makeExpandedNodeId", { enumerable: true, get: function() {
      return node_opcua_nodeid_1.makeExpandedNodeId;
    } });
    Object.defineProperty(exports2, "coerceExpandedNodeId", { enumerable: true, get: function() {
      return node_opcua_nodeid_1.coerceExpandedNodeId;
    } });
    var node_opcua_status_code_1 = require_dist22();
    Object.defineProperty(exports2, "StatusCode", { enumerable: true, get: function() {
      return node_opcua_status_code_1.StatusCode;
    } });
    Object.defineProperty(exports2, "StatusCodes", { enumerable: true, get: function() {
      return node_opcua_status_code_1.StatusCodes;
    } });
    var node_opcua_constants_1 = require_dist20();
    Object.defineProperty(exports2, "VariableTypeIds", { enumerable: true, get: function() {
      return node_opcua_constants_1.VariableTypeIds;
    } });
    Object.defineProperty(exports2, "VariableIds", { enumerable: true, get: function() {
      return node_opcua_constants_1.VariableIds;
    } });
    Object.defineProperty(exports2, "MethodIds", { enumerable: true, get: function() {
      return node_opcua_constants_1.MethodIds;
    } });
    Object.defineProperty(exports2, "ObjectIds", { enumerable: true, get: function() {
      return node_opcua_constants_1.ObjectIds;
    } });
    Object.defineProperty(exports2, "ObjectTypeIds", { enumerable: true, get: function() {
      return node_opcua_constants_1.ObjectTypeIds;
    } });
    Object.defineProperty(exports2, "ReferenceTypeIds", { enumerable: true, get: function() {
      return node_opcua_constants_1.ReferenceTypeIds;
    } });
    Object.defineProperty(exports2, "DataTypeIds", { enumerable: true, get: function() {
      return node_opcua_constants_1.DataTypeIds;
    } });
    Object.defineProperty(exports2, "AggregateFunction", { enumerable: true, get: function() {
      return node_opcua_constants_1.AggregateFunction;
    } });
    var node_opcua_variant_1 = require_dist28();
    Object.defineProperty(exports2, "DataType", { enumerable: true, get: function() {
      return node_opcua_variant_1.DataType;
    } });
    Object.defineProperty(exports2, "Variant", { enumerable: true, get: function() {
      return node_opcua_variant_1.Variant;
    } });
    Object.defineProperty(exports2, "VariantArrayType", { enumerable: true, get: function() {
      return node_opcua_variant_1.VariantArrayType;
    } });
    Object.defineProperty(exports2, "buildVariantArray", { enumerable: true, get: function() {
      return node_opcua_variant_1.buildVariantArray;
    } });
    var node_opcua_data_value_1 = require_dist29();
    Object.defineProperty(exports2, "DataValue", { enumerable: true, get: function() {
      return node_opcua_data_value_1.DataValue;
    } });
    Object.defineProperty(exports2, "sameDataValue", { enumerable: true, get: function() {
      return node_opcua_data_value_1.sameDataValue;
    } });
    var node_opcua_numeric_range_1 = require_dist31();
    Object.defineProperty(exports2, "NumericRange", { enumerable: true, get: function() {
      return node_opcua_numeric_range_1.NumericRange;
    } });
    var node_opcua_data_model_1 = require_dist27();
    Object.defineProperty(exports2, "AccessLevelFlag", { enumerable: true, get: function() {
      return node_opcua_data_model_1.AccessLevelFlag;
    } });
    Object.defineProperty(exports2, "makeAccessLevelFlag", { enumerable: true, get: function() {
      return node_opcua_data_model_1.makeAccessLevelFlag;
    } });
    Object.defineProperty(exports2, "LocalizedText", { enumerable: true, get: function() {
      return node_opcua_data_model_1.LocalizedText;
    } });
    Object.defineProperty(exports2, "coerceLocalizedText", { enumerable: true, get: function() {
      return node_opcua_data_model_1.coerceLocalizedText;
    } });
    Object.defineProperty(exports2, "QualifiedName", { enumerable: true, get: function() {
      return node_opcua_data_model_1.QualifiedName;
    } });
    Object.defineProperty(exports2, "coerceQualifiedName", { enumerable: true, get: function() {
      return node_opcua_data_model_1.coerceQualifiedName;
    } });
    Object.defineProperty(exports2, "NodeClass", { enumerable: true, get: function() {
      return node_opcua_data_model_1.NodeClass;
    } });
    Object.defineProperty(exports2, "NodeClassMask", { enumerable: true, get: function() {
      return node_opcua_data_model_1.NodeClassMask;
    } });
    Object.defineProperty(exports2, "AttributeIds", { enumerable: true, get: function() {
      return node_opcua_data_model_1.AttributeIds;
    } });
    Object.defineProperty(exports2, "BrowseDirection", { enumerable: true, get: function() {
      return node_opcua_data_model_1.BrowseDirection;
    } });
    Object.defineProperty(exports2, "DiagnosticInfo", { enumerable: true, get: function() {
      return node_opcua_data_model_1.DiagnosticInfo;
    } });
    __exportStar3(require_dist23(), exports2);
    var node_opcua_data_access_1 = require_dist35();
    Object.defineProperty(exports2, "standardUnits", { enumerable: true, get: function() {
      return node_opcua_data_access_1.standardUnits;
    } });
    Object.defineProperty(exports2, "makeEUInformation", { enumerable: true, get: function() {
      return node_opcua_data_access_1.makeEUInformation;
    } });
    Object.defineProperty(exports2, "Range", { enumerable: true, get: function() {
      return node_opcua_data_access_1.Range;
    } });
    __exportStar3(require_dist36(), exports2);
    __exportStar3(require_dist37(), exports2);
    __exportStar3(require_dist39(), exports2);
    __exportStar3(require_dist40(), exports2);
    __exportStar3(require_dist41(), exports2);
    __exportStar3(require_dist42(), exports2);
    __exportStar3(require_dist43(), exports2);
    __exportStar3(require_dist44(), exports2);
    __exportStar3(require_dist45(), exports2);
    __exportStar3(require_dist48(), exports2);
    __exportStar3(require_dist38(), exports2);
    __exportStar3(require_dist49(), exports2);
    __exportStar3(require_dist50(), exports2);
    __exportStar3(require_dist51(), exports2);
    var node_opcua_nodesets_1 = require_dist52();
    Object.defineProperty(exports2, "nodesets", { enumerable: true, get: function() {
      return node_opcua_nodesets_1.nodesets;
    } });
    var testHelpers_1 = require_testHelpers();
    Object.defineProperty(exports2, "get_empty_nodeset_filename", { enumerable: true, get: function() {
      return testHelpers_1.get_empty_nodeset_filename;
    } });
    Object.defineProperty(exports2, "get_mini_nodeset_filename", { enumerable: true, get: function() {
      return testHelpers_1.get_mini_nodeset_filename;
    } });
    __exportStar3(require_nodeJS(), exports2);
    exports2.utils = require_dist16();
    var node_opcua_debug_1 = require_dist24();
    Object.defineProperty(exports2, "LogLevel", { enumerable: true, get: function() {
      return node_opcua_debug_1.LogLevel;
    } });
    Object.defineProperty(exports2, "hexDump", { enumerable: true, get: function() {
      return node_opcua_debug_1.hexDump;
    } });
    Object.defineProperty(exports2, "setLogLevel", { enumerable: true, get: function() {
      return node_opcua_debug_1.setLogLevel;
    } });
    Object.defineProperty(exports2, "setDebugLogger", { enumerable: true, get: function() {
      return node_opcua_debug_1.setDebugLogger;
    } });
    Object.defineProperty(exports2, "setWarningLogger", { enumerable: true, get: function() {
      return node_opcua_debug_1.setWarningLogger;
    } });
    Object.defineProperty(exports2, "setErrorLogger", { enumerable: true, get: function() {
      return node_opcua_debug_1.setErrorLogger;
    } });
    __exportStar3(require_dist63(), exports2);
    var node_opcua_transport_1 = require_source5();
    Object.defineProperty(exports2, "parseEndpointUrl", { enumerable: true, get: function() {
      return node_opcua_transport_1.parseEndpointUrl;
    } });
    Object.defineProperty(exports2, "is_valid_endpointUrl", { enumerable: true, get: function() {
      return node_opcua_transport_1.is_valid_endpointUrl;
    } });
    __exportStar3(require_server_stuff(), exports2);
    __exportStar3(require_dist61(), exports2);
    __exportStar3(require_source5(), exports2);
    __exportStar3(require_dist66(), exports2);
  }
});

// src/OPC.js
var require_OPC = __commonJS({
  "src/OPC.js"(exports2, module2) {
    "use strict";
    var gwutils2 = require_gwutils();
    var path3 = require("path");
    var getSensorDefinition = require_sensorDefinition().getSensorDefinition;
    var phantomService2 = require_phantomService().phantomService;
    var opcState = {};
    var opcServer = class {
      static async init(gwGlobalState) {
        const { OPCUAServer, Variant, DataType, StatusCodes, VariantArrayType, OPCUACertificateManager, NodeId, NodeIdType, DataValue } = await Promise.resolve().then(() => __toESM(require_dist67()));
        function addExtendedMetrics(node) {
          let phantomCode = node.phantomCode;
          let extendedMetrics = node.extendedMetrics;
          if (!extendedMetrics)
            return;
          let opcNodeState = opcState[node.phantomCode];
          if (opcNodeState && opcNodeState.extendedMetrics) {
            for (let i = 0; i < extendedMetrics.length; i++) {
              let channel = opcNodeState.extendedMetrics.getComponentByName(i.toString());
              if (!channel) {
                channel = namespace.addObject({
                  componentOf: opcNodeState.extendedMetrics,
                  browseName: i.toString(),
                  nodeId: new NodeId(NodeIdType.STRING, "ph" + phantomCode + "-ext-ch" + i, 1)
                });
              }
              for (const metric in extendedMetrics[i]) {
                let variable = channel.getComponentByName(metric);
                if (variable)
                  return;
                namespace.addVariable({
                  componentOf: channel,
                  browseName: metric,
                  dataType: DataType.Double,
                  nodeId: new NodeId(NodeIdType.STRING, "ph" + phantomCode + "-ext-ch" + i + "-" + metric, 1),
                  valueRank: -1,
                  arrayDimensions: void 0,
                  value: {
                    timestamped_get: function() {
                      return new DataValue({
                        value: new Variant({
                          dataType: DataType.Double,
                          arrayType: VariantArrayType.Scalar,
                          value: node.extendedMetrics[i][metric]
                        }),
                        sourceTimestamp: new Date(node.extendedMetrics.lastupdate),
                        serverTimestamp: new Date(node.extendedMetrics.lastupdate)
                      });
                    }
                  }
                });
              }
            }
          }
        }
        function addPhantomSensorToTree(phantomCode) {
          let nodeinfo = gwGlobalState.nodes[phantomCode];
          if (!nodeinfo.phantomCode)
            return;
          const device = namespace.addObject({
            organizedBy: addressSpace.rootFolder.objects,
            browseName: phantomCode.toString(),
            nodeId: new NodeId(NodeIdType.STRING, "ph" + phantomCode, 1)
          });
          opcState[phantomCode] = {
            deviceNode: device
          };
          if (phantomService2.isTriaxial(gwGlobalState.nodes[phantomCode].type)) {
            let extendedMetrics = namespace.addObject({
              componentOf: device,
              //organizedBy: addressSpace.rootFolder.objects,
              browseName: "extendedMetrics",
              nodeId: new NodeId(NodeIdType.STRING, "ph" + phantomCode + "-ext", 1)
            });
            opcState[phantomCode].extendedMetrics = extendedMetrics;
            addExtendedMetrics(gwGlobalState.nodes[phantomCode]);
          }
          let sensorActions2 = namespace.addObject({
            componentOf: device,
            //organizedBy: addressSpace.rootFolder.objects,
            browseName: "sensorActions",
            nodeId: new NodeId(NodeIdType.STRING, "ph" + phantomCode + "-actions", 1)
          });
          if (phantomService2.isTriaxial(gwGlobalState.nodes[phantomCode].type) || phantomService2.isGP(gwGlobalState.nodes[phantomCode].type) || phantomService2.isThermalImage(gwGlobalState.nodes[phantomCode].type)) {
            namespace.addVariable({
              componentOf: sensorActions2,
              browseName: "triggerCollection",
              dataType: DataType.Boolean,
              nodeId: new NodeId(NodeIdType.STRING, "ph" + phantomCode + "-actions-triggerCollection", 1),
              valueRank: -1,
              arrayDimensions: void 0,
              value: {
                get: function() {
                  return new Variant({
                    dataType: DataType.Boolean,
                    value: gwGlobalState.nodes[phantomCode]?.actions?.["signal"] ? true : false
                  });
                },
                set: function(value) {
                  if (gwGlobalState.nodes[phantomCode].actions === void 0)
                    gwGlobalState.nodes[phantomCode].actions = {};
                  gwGlobalState.nodes[phantomCode].actions["signal"] = {};
                  gwGlobalState.nodes[phantomCode].actions["signal"].requestTime = Date.now();
                  gwutils2.gwUpdateGlobalState();
                }
              }
            });
          }
          namespace.addVariable({
            componentOf: sensorActions2,
            browseName: "triggerStateUpdate",
            dataType: DataType.Boolean,
            nodeId: new NodeId(NodeIdType.STRING, "ph" + phantomCode + "-actions-triggerStateUpdate", 1),
            valueRank: -1,
            arrayDimensions: void 0,
            value: {
              get: function() {
                return new Variant({
                  dataType: DataType.Boolean,
                  value: gwGlobalState.nodes[phantomCode]?.actions?.["updatestate"] ? true : false
                });
              },
              set: function(value) {
                if (gwGlobalState.nodes[phantomCode].advdatav2?.canForceUpdate) {
                  if (gwGlobalState.nodes[phantomCode].actions === void 0)
                    gwGlobalState.nodes[phantomCode].actions = {};
                  gwGlobalState.nodes[phantomCode].actions["updatestate"] = {};
                  gwGlobalState.nodes[phantomCode].actions["updatestate"].requestTime = Date.now();
                  gwutils2.gwUpdateGlobalState();
                }
              }
            }
          });
          let variables = getSensorDefinition(nodeinfo.type);
          if (!variables)
            return;
          for (let i = 0; i < variables.length; i++) {
            let getOpcValue = function() {
              let value = void 0;
              if (nodeinfo.advdatav2)
                value = nodeinfo.advdatav2[variable.stateVariableName];
              if (!value) {
                if (variable.opc.isArray)
                  value = [0];
                else
                  value = 0;
              }
              return value;
            };
            const variable = variables[i];
            if (!variable.opc)
              continue;
            namespace.addVariable({
              componentOf: device,
              browseName: variable.opc.browseName,
              dataType: variable.opc.dataType,
              nodeId: new NodeId(NodeIdType.STRING, "ph" + phantomCode + "-" + variable.opc.browseName, 1),
              valueRank: variable.opc.isArray ? 1 : -1,
              arrayDimensions: variable.opc.isArray ? [getOpcValue().length] : void 0,
              value: {
                timestamped_get: function() {
                  console.log("-------------------------------->");
                  return new DataValue({
                    value: new Variant({
                      dataType: variable.opc.dataType,
                      arrayType: variable.opc.isArray ? VariantArrayType.Array : VariantArrayType.Scalar,
                      value: getOpcValue()
                    }),
                    sourceTimestamp: new Date(nodeinfo.lastseqchange),
                    serverTimestamp: new Date(nodeinfo.lastseqchange)
                  });
                }
              }
            });
            if (variable.opc.isArray) {
              for (let iArrayElment = 0; iArrayElment < getOpcValue().length; iArrayElment++) {
                namespace.addVariable({
                  componentOf: device,
                  browseName: variable.opc.browseName + "_element" + iArrayElment,
                  dataType: variable.opc.dataType,
                  nodeId: new NodeId(NodeIdType.STRING, "ph" + phantomCode + "-" + variable.opc.browseName + "_element" + iArrayElment, 1),
                  valueRank: -1,
                  arrayDimensions: void 0,
                  value: {
                    timestamped_get: function() {
                      return new DataValue({
                        value: new Variant({
                          dataType: variable.opc.dataType,
                          arrayType: VariantArrayType.Scalar,
                          value: getOpcValue()[iArrayElment]
                        }),
                        sourceTimestamp: new Date(nodeinfo.lastseqchange),
                        serverTimestamp: new Date(nodeinfo.lastseqchange)
                      });
                    }
                  }
                });
              }
            }
          }
        }
        const configpath = gwutils2.getDataDirectory("opc");
        const pkiDir = path3.join(configpath, "pki");
        const userPkiDir = path3.join(configpath, "userpki");
        const userCertificateManager = new OPCUACertificateManager({
          automaticallyAcceptUnknownCertificate: true,
          name: "UserPKI",
          rootFolder: userPkiDir
        });
        await userCertificateManager.initialize();
        const serverCertificateManager = new OPCUACertificateManager({
          automaticallyAcceptUnknownCertificate: true,
          name: "PKI",
          rootFolder: pkiDir
        });
        await serverCertificateManager.initialize();
        const server = new OPCUAServer({
          port: 4334,
          // the port of the listening socket of the server
          resourcePath: "/UA/PhantomGW",
          // this path will be added to the endpoint resource name
          buildInfo: {
            productName: "PhantomGW",
            buildNumber: "0",
            buildDate: "0"
          },
          userCertificateManager,
          serverCertificateManager
        });
        await server.initialize();
        const addressSpace = server.engine.addressSpace;
        const namespace = addressSpace.getOwnNamespace();
        if (gwGlobalState.nodes) {
          for (const phantomCode in gwGlobalState.nodes) {
            addPhantomSensorToTree(phantomCode);
          }
        }
        gwutils2.subscribeToEvent("nodeadded", async (e) => {
          addPhantomSensorToTree(e);
        });
        gwutils2.subscribeToEvent("noderemoved", async (e) => {
          let opcNodeState = opcState[e];
          if (opcNodeState) {
            try {
              namespace.deleteNode(opcNodeState.deviceNode.nodeId);
            } catch (e2) {
              console.log("deleting opc node", e2);
            }
          }
        });
        gwutils2.subscribeToEvent("extendedmetricsadded", async (e) => {
          let node = e.node;
          addExtendedMetrics(node);
        });
        await server.start();
      }
    };
    module2.exports = {
      opcServer
    };
  }
});

// src/index.js
var VERSION = 56;
var EXPECTEDOS = 22;
var OSVERSION = 0;
var dogpet = require_dogpet();
dogpet.handleWatchdog();
var ble = require_nrf_ble();
var dfu = require_nrfbledfu().nordicDFU;
var gwutils = require_gwutils();
var neteim = require_neteimonitoring().NETEIMonitoring;
var phantomMesh = require_phantommesh().PhantoMesh;
var oledscreen = require_oledscreen();
var gpio = require_gpio();
var systemmon = require_systemmon();
var phantomService = require_phantomService().phantomService;
var cloudUpload = require_cloudupload().CloudUpload;
var modbusServer = require_modbus().ModbusServer;
var offlineStorage = require_offlineStorage().OfflineStorage;
var sensorDefinition = require_sensorDefinition();
var mqttClient = require_mqtt3().mqttClient;
var gwCrypto = require_crypto().gwCrypto;
var gwapi = require_gwapi();
var signalGenerator = require_signalGenerator();
var sensorActions = require_sensorActions().sensorActions;
var http = require("http");
var fs = require("fs").promises;
var os = require("os");
var hostname = os.hostname();
var path2 = require("path");
async function init() {
  const customFwPath = gwutils.getDataDirectory("customFw");
  let g_GWState = null;
  try {
    g_GWState = await gwutils.loadStateFile();
    try {
      let basicconfig = await gwutils.gwLoadBasicConfig();
      g_GWState.basicconfig = basicconfig;
    } catch (e) {
    }
    try {
      let eiosversion = await fs.readFile("/eiosversion.txt", "utf8");
      OSVERSION = eiosversion.trim();
    } catch (e) {
    }
  } catch (e) {
    console.log(e);
  }
  if (!g_GWState)
    g_GWState = {};
  g_GWState.deviceInfo = {
    serialNumber: 0,
    version: VERSION,
    osversion: OSVERSION,
    expectedos: EXPECTEDOS,
    currentTZOffset: (/* @__PURE__ */ new Date()).getTimezoneOffset() * 60,
    bleInitializing: true,
    vendorId: 0
  };
  gwutils.setGlobalState(g_GWState);
  await gwutils.loadSecurity();
  g_GWState.deviceInfo.currentTZGWOffset = (/* @__PURE__ */ new Date()).getTimezoneOffset() * 60;
  if (process.platform == "linux" && false) {
    await gpio.init(g_GWState);
    gpio.resetNRF();
  }
  systemmon.run(g_GWState);
  await gwapi.gwAPIStart(g_GWState);
  if (true)
    g_GWState.deviceInfo.gatewayPC = true;
  if (g_GWState.basicconfig.virtualSerialNumber && true) {
    g_GWState.deviceInfo.serialNumber = parseInt(g_GWState.basicconfig.virtualSerialNumber);
  } else {
    await ble.init(g_GWState);
  }
  g_GWState.deviceInfo.bleInitializing = false;
  if (process.platform == "linux" && false) {
    oledscreen.oledScreenInit(g_GWState);
  }
  gwapi.gwAPIStartExternalConnections();
  if (gwutils.isSubordinate()) {
    dogpet.enableSubordinateWatchDog();
  } else {
    gwutils.stateFileSaver();
    gwutils.nodeConfigFileSaver();
  }
  sensorActions.init(g_GWState);
  await gwCrypto.init();
  if (gwutils.isSubordinate()) {
  } else {
    if (g_GWState.basicconfig.sendtoeimonitor)
      neteim.startUDPServer(g_GWState);
    if (g_GWState.basicconfig.sendtoeianalytics || g_GWState.basicconfig.isalternateurl && g_GWState.basicconfig.endpointurl)
      cloudUpload.init(g_GWState);
    if (g_GWState.basicconfig.enablemodbus)
      modbusServer.init(g_GWState);
    if (g_GWState.basicconfig.enableopc) {
      const opcServer = require_OPC().opcServer;
      opcServer.init(g_GWState);
    }
    if (g_GWState.basicconfig.enablemqtt)
      mqttClient.init(g_GWState);
    await offlineStorage.init(g_GWState);
  }
  phantomMesh.init(g_GWState);
  function isBigDataManuallyRequested(node) {
    return !node.action && node.actions && node.actions.signal ? true : false;
  }
  function isBigDataRequestedbyNode(node) {
    return node.advdatav2 && node.advdatav2.advFlags && node.advdatav2.advFlags & phantomService.phantomV2AdvFlags.GW2_ADV_FLAGS_COLLECT_NOW ? true : false;
  }
  function isBigDataScheduled(node) {
    let scheduleMode = "global";
    if (node.settings?.timed?.collectionMode)
      scheduleMode = node.settings?.timed?.collectionMode;
    if (scheduleMode == "global") {
      if (g_GWState.basicconfig?.disableCollection) {
        return false;
      }
      return !node.lastcollection || Date.now() - node.lastcollection >= g_GWState.basicconfig.collectionInterval * g_GWState.basicconfig.collectionIntervalUnits * 1e3;
    } else if (scheduleMode == "interval") {
      return !node.lastcollection || Date.now() - node.lastcollection >= node.settings?.timed.collectionInterval * node.settings?.timed.collectionUnits * 1e3;
    } else if (scheduleMode == "timeoftheday") {
      return false;
    } else if (scheduleMode == "disabled") {
      return false;
    }
    return false;
  }
  function isAlarmed(node) {
    if (!node.settings?.alarms?.enabled)
      return false;
    if (node.lastAlarmCollection && Date.now() - node.lastAlarmCollection < node.settings?.alarms.waitAfter * node.settings?.alarms.waitAfterUnits * 1e3)
      return false;
    if (Date.now() - node.lastseqchange >= 240 * 1e3)
      return false;
    let alarmed = node.advdatav2.rms[0] > node.settings?.alarms?.rms[0] || node.advdatav2.rms[1] > node.settings?.alarms?.rms[1] || node.advdatav2.rms[2] > node.settings?.alarms?.rms[2];
    if (alarmed) {
      if (node.alarmLastSeq != node.advdatav2?.seq) {
        node.alarmLastSeq = node.advdatav2?.seq;
        if (!node.alarmCount)
          node.alarmCount = 0;
        node.alarmCount++;
      }
      if (!node.settings.alarms.alarmCount) {
        node.settings.alarms.alarmCount = 0;
      }
      if (node.alarmCount >= node.settings?.alarms?.alarmCount)
        return true;
    } else {
      node.alarmCount = 0;
    }
    return false;
  }
  function isAlarmedLevel2(node) {
    if (!node.settings?.alarms?.enabledLevel2)
      return false;
    if (node.lastAlarmCollectionLevel2 && Date.now() - node.lastAlarmCollectionLevel2 < node.settings?.alarms.waitAfter * node.settings?.alarms.waitAfterUnits * 1e3)
      return false;
    if (Date.now() - node.lastseqchange >= 240 * 1e3)
      return false;
    let alarmed = node.advdatav2.rms[0] > node.settings?.alarms?.rmsLevel2[0] || node.advdatav2.rms[1] > node.settings?.alarms?.rmsLevel2[1] || node.advdatav2.rms[2] > node.settings?.alarms?.rmsLevel2[2];
    if (alarmed) {
      if (node.alarmLastSeq != node.advdatav2?.seq) {
        node.alarmLastSeq = node.advdatav2?.seq;
        if (!node.alarmCountLevel2)
          node.alarmCountLevel2 = 0;
        node.alarmCountLevel2++;
      }
      if (!node.settings.alarms.alarmCount) {
        node.settings.alarms.alarmCount = 0;
      }
      if (node.alarmCountLevel2 >= node.settings?.alarms?.alarmCount)
        return true;
    } else {
      node.alarmCountLevel2 = 0;
    }
    return false;
  }
  function checkGpioTrigger(triggeringNode) {
    for (let phantomCode in g_GWState.nodes) {
      let node = g_GWState.nodes[phantomCode];
      if (node.settings?.trigger?.type == "gpio" && node.settings.trigger.transient) {
        let currentValue = triggeringNode.advdatav2?.dryContactsState?.[node.settings.trigger.channel];
        if (currentValue != void 0) {
          if (!currentValue && node.settings.trigger.dryState == "closed" || currentValue && node.settings.trigger.dryState == "open") {
            node.triggerNow = true;
          }
        }
      }
    }
  }
  function isTriggered(node) {
    try {
      if (!node.settings?.trigger?.type || !node.settings?.trigger?.type == "none")
        return false;
      if (node.lastTriggerCollection && Date.now() - node.lastTriggerCollection < node.settings?.trigger.waitAfter * node.settings?.trigger.waitAfterUnits * 1e3)
        return false;
      let triggeringNode = g_GWState.nodes[node.settings?.trigger?.phantomCode];
      if (!triggeringNode)
        return;
      if (node.settings.trigger.type == "current" || triggeringNode.advdatav2?.highPerformace) {
        if (Date.now() - triggeringNode.lastseen >= 20 * 1e3)
          return false;
      } else {
        if (Date.now() - triggeringNode.lastseqchange >= 20 * 1e3)
          return false;
      }
      if (node.settings.trigger.type == "current") {
        let currentValue = triggeringNode.advdatav2.instCurrent[node.settings.trigger.channel];
        return currentValue > node.settings.trigger.min && currentValue < node.settings.trigger.max;
      } else if (node.settings.trigger.type == "rpm") {
        let currentValue = triggeringNode.advdatav2.rpm;
        return currentValue > node.settings.trigger.min && currentValue < node.settings.trigger.max;
      } else if (node.settings.trigger.type == "gpio") {
        if (node.triggerNow)
          return true;
        if (node.settings.trigger.transient)
          return false;
        let currentValue = triggeringNode.advdatav2.dryContactsState[node.settings.trigger.channel];
        return !currentValue && node.settings.trigger.dryState == "closed" || currentValue && node.settings.trigger.dryState == "open";
      }
    } catch (e) {
      console.log("Error when triggering: ", e.message);
    }
    return false;
  }
  function sensorHasData(node) {
    try {
      if (g_GWState.basicconfig.collectdisconnected) {
        if (node.advdatav2?.haveDataToCollect) {
          let ellapsed = Date.now() - (node.lastScheduledDownload ? node.lastScheduledDownload : 0);
          let delay = 0;
          if (g_GWState.basicconfig.collectDisconnectedDelay == void 0)
            delay = 5e3;
          else
            delay = g_GWState.basicconfig.collectDisconnectedDelay * 1e3;
          if (ellapsed >= delay)
            return true;
        }
      } else {
        return node.advdatav2?.haveDataToCollect;
      }
    } catch (e) {
      console.log("Error when triggering: ", e.message);
    }
    return false;
  }
  function checkPhantomSyncTrigger(triggeringNode) {
    try {
      if (!g_GWState.deviceInfo.runningPhantomSync?.waitingForTrigger)
        return false;
      let syncSettings = g_GWState.phantomSync[g_GWState.deviceInfo.runningPhantomSync.index];
      if (!syncSettings.trigger.enabled || syncSettings.trigger.phantomCode != triggeringNode.phantomCode)
        return false;
      if (syncSettings.trigger.type == "current" || triggeringNode.advdatav2?.highPerformace) {
        if (Date.now() - triggeringNode.lastseen >= 20 * 1e3)
          return false;
      } else {
        if (Date.now() - triggeringNode.lastseqchange >= 20 * 1e3)
          return false;
      }
      if (syncSettings.trigger.type == "current") {
        let currentValue = triggeringNode.advdatav2.instCurrent[syncSettings.trigger.trigger.channel];
        return currentValue > syncSettings.trigger.min && currentValue < syncSettings.trigger.max;
      } else if (syncSettings.trigger.type == "rpm") {
        let currentValue = triggeringNode.advdatav2.rpm;
        return currentValue > syncSettings.trigger.min && currentValue < syncSettings.trigger.max;
      } else if (syncSettings.trigger.type == "gpio") {
        let currentValue = triggeringNode.advdatav2.dryContactsState[syncSettings.trigger.channel];
        return !currentValue && syncSettings.trigger.dryState == "closed" || currentValue && syncSettings.trigger.dryState == "open";
      }
    } catch (e) {
      console.log("Error when triggering: ", e.message);
    }
    return false;
  }
  function getTriaxialRecordingSettings(node) {
    let recordSettings = {
      sampleRate: 25600,
      axisCount: 3,
      axis: 0,
      range: 8,
      samples: 0
    };
    if (node.settings?.triaxialRecording?.custom) {
      recordSettings.sampleRate = node.settings?.triaxialRecording.sampleRate;
      if (node.settings?.triaxialRecording.mode == "singleaxis")
        recordSettings.axisCount = 1;
      recordSettings.axis = node.settings?.triaxialRecording.axis;
      recordSettings.range = node.settings?.triaxialRecording.range;
      if (!node.settings?.triaxialRecording.samples)
        node.settings.triaxialRecording.samples = 0;
      recordSettings.samples = node.settings?.triaxialRecording.samples;
    } else {
      recordSettings.sampleRate = g_GWState.basicconfig.vibrationWaveFormSettings.sampleRate;
      if (g_GWState.basicconfig.vibrationWaveFormSettings.mode == "singleaxis")
        recordSettings.axisCount = 1;
      recordSettings.axis = g_GWState.basicconfig.vibrationWaveFormSettings?.axis;
      recordSettings.range = g_GWState.basicconfig.vibrationWaveFormSettings.highRange;
      if (phantomService.isTriaxialLowRange(node.type))
        recordSettings.range = g_GWState.basicconfig.vibrationWaveFormSettings.lowRange;
      if (!g_GWState.basicconfig.vibrationWaveFormSettings?.samples)
        g_GWState.basicconfig.vibrationWaveFormSettings.samples = 0;
      recordSettings.samples = g_GWState.basicconfig.vibrationWaveFormSettings?.samples;
    }
    return recordSettings;
  }
  function getTriaxialRecordingTime(node) {
    let recordingSettings = getTriaxialRecordingSettings(node);
    if (recordingSettings.axisCount == 3) {
      let samples = 16384;
      if (recordingSettings.samples == 2)
        samples = 32768;
      else if (recordingSettings.samples == 3)
        samples = 8192;
      else if (recordingSettings.samples == 4)
        samples = 4096;
      else if (recordingSettings.samples == 5)
        samples = 2048;
      else if (recordingSettings.samples == 6)
        samples = 1024;
      else if (recordingSettings.samples == 7)
        samples = 512;
      return samples / recordingSettings.sampleRate;
    } else {
      let samples = 65536;
      if (recordingSettings.samples == 2)
        samples = 76800;
      else if (recordingSettings.samples == 3)
        samples = 32768;
      else if (recordingSettings.samples == 4)
        samples = 16384;
      else if (recordingSettings.samples == 5)
        samples = 8192;
      else if (recordingSettings.samples == 6)
        samples = 4096;
      else if (recordingSettings.samples == 7)
        samples = 2048;
      else if (recordingSettings.samples == 8)
        samples = 1024;
      else if (recordingSettings.samples == 9)
        samples = 512;
      return samples / recordingSettings.sampleRate;
    }
  }
  function checkCustomTimes() {
    let d2 = /* @__PURE__ */ new Date();
    let min = d2.getMinutes();
    if (min < 10) {
      min = "0" + min;
    }
    let hr = d2.getHours();
    if (hr < 10) {
      hr = "0" + hr;
    }
    let currentTime = hr + ":" + min;
    if (g_GWState.phantomSync) {
      for (let iSettings = 0; iSettings < g_GWState.phantomSync.length; iSettings++) {
        let syncSettings = g_GWState.phantomSync[iSettings];
        if (!syncSettings)
          continue;
        if (syncSettings.activateLater) {
          maybeDoPhantomSync(iSettings);
        } else if (syncSettings.type == "timeoftheday") {
          if (syncSettings.timeoftheday?.timeArray && !syncSettings.activateNow) {
            for (let iTimes = 0; iTimes < syncSettings.timeoftheday.timeArray.length; iTimes++) {
              let customTime = syncSettings.timeoftheday.timeArray[iTimes];
              console.log("Checking ", currentTime, customTime);
              if (customTime == currentTime) {
                console.log("Activate", syncSettings.name, "at", customTime);
                maybeDoPhantomSync(iSettings);
              }
            }
          }
        } else if (syncSettings.type == "interval") {
          let interval = syncSettings.timed.collectionInterval * syncSettings.timed.collectionUnits * 1e3;
          if (!syncSettings.lastActivated)
            syncSettings.lastActivated = 0;
          if (Date.now() - syncSettings.lastActivated >= interval) {
            console.log("Activate interval now");
            maybeDoPhantomSync(iSettings);
          }
        }
      }
    }
    for (const code in g_GWState.nodes) {
      let node = g_GWState.nodes[code];
      if (node.settings?.timed?.collectionMode != "timeoftheday" || !node.settings?.timed?.timeArray)
        continue;
      for (let iTimes = 0; iTimes < node.settings.timed.timeArray.length; iTimes++) {
        let customTime = node.settings.timed.timeArray[iTimes];
        if (customTime == currentTime) {
          node.doCollection = true;
          break;
        }
      }
    }
  }
  function handleNewDownload(phantomCode, downloadret) {
    let signalDate = new Date(downloadret.captureTime * 1e3);
    let uniqueName = phantomCode + "-" + gwutils.stringFormat(
      "{0}-{1}-{2}-{3}-{4}-{5}",
      signalDate.getFullYear(),
      String(signalDate.getMonth() + 1).padStart(2, "0"),
      String(signalDate.getDate()).padStart(2, "0"),
      String(signalDate.getHours()).padStart(2, "0"),
      String(signalDate.getMinutes()).padStart(2, "0"),
      String(signalDate.getSeconds()).padStart(2, "0")
    );
    let signalData = {
      phantomCode,
      captureTime: downloadret.captureTime,
      uniqueName,
      alarm: downloadret.alarm,
      start: downloadret.start,
      triggered: downloadret.triggered,
      services: {}
    };
    let eventData = {
      header: downloadret.header,
      data: downloadret.data,
      node: g_GWState.nodes[phantomCode],
      signalData
    };
    if (!g_GWState.sensorData)
      g_GWState.sensorData = {};
    g_GWState.sensorData[uniqueName] = signalData;
    gwutils.broadcastEvent("newsignal", eventData);
    gwutils.broadcastEvent("newsignalfirsttime", eventData);
    gwutils.gwUpdateGlobalState();
  }
  `
  setTimeout(async () => {
    let fileData = signalGenerator.generateTestSignal()
    
    let header = fileData.subarray(0, 28)
    let data = fileData.subarray(28)


    let downloadret = {
      header: header,
      data: data,
      start: false,
      triggered: false,
      alarm: false
    };


    /*

    let fileData = await fs.readFile("C:\\code\\gw.js\\BORRAME.bin")
    let header = fileData.subarray(0, 28)
    let data = fileData.subarray(28)


    let downloadret = {
      header: header,
      data: data,
      start: false,
      triggered: false,
      alarm: false
    }
*/
    handleNewDownload(189302894, downloadret)
  }, 500)
  `;
  function compareAddr(addr1, addr2) {
    return addr1 && addr2 && addr1.length == 6 && addr2.length == 6 && addr1[0] == addr2[0] && addr1[1] == addr2[1] && addr1[2] == addr2[2] && addr1[3] == addr2[3] && addr1[4] == addr2[4] && addr1[5] == addr2[5];
  }
  function lookupAddr(list, addr) {
    for (let i = 0; i < list.length; i++) {
      let phantomCode = list[i];
      if (g_GWState.nodes[phantomCode]?.bledevice && compareAddr(g_GWState.nodes[phantomCode]?.bledevice.ble_addr, addr)) {
        return phantomCode;
      }
    }
    return null;
  }
  function sendSyncBeacon(_syncSettings) {
    console.log("Starting sync broadcast...");
    if (!g_GWState.deviceInfo.phantomSync)
      g_GWState.deviceInfo.phantomSync = {};
    if (g_GWState.deviceInfo.phantomSync.sendingBeacon)
      return;
    g_GWState.deviceInfo.phantomSync.sendingBeacon = true;
    let syncTimeout = 6;
    let syncSettings = _syncSettings;
    if (!syncSettings)
      g_GWState.phantomSync[g_GWState.deviceInfo.runningPhantomSync?.index];
    gwutils.gwUpdateGlobalState();
    console.log("Actually sending sync beacon");
    ble.startSyncBroadcast(80, syncTimeout, syncSettings?.longRange);
    setTimeout(() => {
      console.log("Done with sync broadcast");
      if (syncSettings) {
        syncSettings.lastActivated = Date.now();
        syncSettings.activateLater = false;
      }
      g_GWState.deviceInfo.phantomSync.sendingBeacon = false;
      delete g_GWState.deviceInfo.runningPhantomSync;
      gwutils.gwUpdateGlobalState();
    }, 1e3 * syncTimeout);
  }
  async function doPhantomSync(syncSettings, prepareonly, customTimeout, manual) {
    let activationStartTimestamp = Date.now();
    if (!g_GWState.deviceInfo.phantomSync)
      g_GWState.deviceInfo.phantomSync = {};
    g_GWState.deviceInfo.phantomSync.preparing = true;
    gwutils.gwUpdateGlobalState();
    let failCount = 0;
    let addr = Buffer.alloc(5);
    addr[0] = 144;
    addr.writeUInt32LE(g_GWState.deviceInfo.serialNumber, 1);
    let alreadyActivated = [];
    let sensorsToActivate = syncSettings.sensorList;
    let timeout2 = 60 + 15 * sensorsToActivate.length;
    if (syncSettings?.trigger?.enabled)
      timeout2 += syncSettings.trigger.maxTriggerTime * syncSettings.trigger.maxTriggerTimeUnits;
    if (customTimeout)
      timeout2 = customTimeout;
    while (failCount < 20) {
      let connectArray = [];
      let anyleft = false;
      for (let i = 0; i < sensorsToActivate.length; i++) {
        let phantomCode2 = sensorsToActivate[i];
        console.log(
          "Maybe adding to activation array",
          phantomCode2,
          "Is doing something?",
          g_GWState.nodes[phantomCode2].action,
          "Have ble addr?",
          g_GWState.nodes[phantomCode2]?.bledevice,
          "Is the addr a buffer?",
          Buffer.isBuffer(g_GWState.nodes[phantomCode2]?.bledevice.ble_addr),
          "Last seen in 60000seconds?",
          activationStartTimestamp - g_GWState.nodes[phantomCode2].lastseen
        );
        if (alreadyActivated.indexOf(phantomCode2) == -1) {
          anyleft = true;
        }
        if (alreadyActivated.indexOf(phantomCode2) == -1 && !g_GWState.nodes[phantomCode2].action && g_GWState.nodes[phantomCode2]?.bledevice && g_GWState.nodes[phantomCode2]?.bledevice.ble_addr && activationStartTimestamp - g_GWState.nodes[phantomCode2].lastseen <= 12e4) {
          connectArray.push(g_GWState.nodes[phantomCode2]?.bledevice);
          if (connectArray.length == 8)
            break;
        }
      }
      if (connectArray.length == 0) {
        if (anyleft) {
          failCount++;
          await gwutils.sleep(5e3);
          continue;
        } else {
          break;
        }
      }
      let phantomCode = 0;
      let connected = false;
      try {
        console.log("Attemping to connect for sync to array");
        let ps2 = new phantomService(connectArray, false);
        let connResult = await ps2.connect();
        if (connResult)
          connected = true;
        phantomCode = lookupAddr(sensorsToActivate, connResult.btaddr);
        g_GWState.nodes[phantomCode].action = "schedulesync";
        g_GWState.nodes[phantomCode].actionstate = "requesting";
        g_GWState.nodes[phantomCode].actionprogress = 0;
        gwutils.gwUpdateGlobalState();
        console.log("Connected to ", phantomCode, "for activation");
        let recordinSettings = getTriaxialRecordingSettings(g_GWState.nodes[phantomCode]);
        let downloadret = await ps2.downloadPhantomSignal({
          range: recordinSettings.range,
          sampleRate: recordinSettings.sampleRate,
          axisCount: recordinSettings.axisCount,
          axis: 0,
          samples: recordinSettings.samples,
          existing: false,
          /// Sync
          collectafterdisconnectsync: true,
          channel: 80,
          syncAddr: addr,
          syncTimeout: timeout2,
          syncSeconds: 5,
          syncScanDistance: 300,
          syncLongRange: syncSettings.longRange
        });
        await ps2.disconnect();
        console.log("Adding ", phantomCode, "to already activated list");
        alreadyActivated.push(phantomCode);
        failCount = 0;
      } catch (e) {
        try {
          if (connected)
            await ps.disconnect();
        } catch (e2) {
        }
        failCount++;
        await gwutils.sleep(5e3);
        console.log(e);
      }
      if (phantomCode != 0) {
        delete g_GWState.nodes[phantomCode].action;
        delete g_GWState.nodes[phantomCode].actionstate;
        delete g_GWState.nodes[phantomCode].actionprogress;
        gwutils.gwUpdateGlobalState();
      }
    }
    g_GWState.deviceInfo.phantomSync.preparing = false;
    gwutils.gwUpdateGlobalState();
    if (!syncSettings.trigger?.enabled && !prepareonly) {
      setTimeout(() => sendSyncBeacon(syncSettings), 8e3);
    } else if (syncSettings?.trigger?.enabled) {
      if (g_GWState.deviceInfo.runningPhantomSync)
        setTimeout(() => g_GWState.deviceInfo.runningPhantomSync.waitingForTrigger = true, 1e4);
    }
  }
  function maybeDoPhantomSync(index, action, timeout2, manual) {
    if (action == "activate") {
      sendSyncBeacon(g_GWState.phantomSync[index]);
    } else if (g_GWState.deviceInfo.runningPhantomSync) {
      g_GWState.phantomSync[index].activateLater = true;
    } else {
      if (!manual) {
        g_GWState.deviceInfo.runningPhantomSync = {
          index
        };
      }
      let prepareonly = action == "prepare";
      doPhantomSync(g_GWState.phantomSync[index], prepareonly, timeout2, manual);
    }
  }
  gwutils.subscribeToEvent("dophantomsync", (eventdata) => {
    maybeDoPhantomSync(eventdata.index, eventdata.action, eventdata.timeout, eventdata.manual);
  });
  let timeout = (61 - (/* @__PURE__ */ new Date()).getSeconds()) * 1e3;
  setTimeout(() => {
    checkCustomTimes();
    setInterval(checkCustomTimes, 6e4);
  }, timeout);
  console.log("Starting ...");
  async function processSensorAdvertising(bledevice, advdata, gwSerial, isLocal) {
    try {
      let vendorChar = String.fromCharCode(g_GWState.deviceInfo.vendorId + 64);
      if (g_GWState.deviceInfo.vendorId == 0 && advdata.name.startsWith("PH") || g_GWState.deviceInfo.vendorId != 0 && advdata.name[0] == "U" && advdata.name[1] == vendorChar) {
        let phantomCode = parseInt(advdata.name.substring(2));
        let phantom_bootloader_data = dfu.parse_phantom_bootloader_adv_data(advdata.manufacturer);
        if (g_GWState.nodes[phantomCode] === void 0)
          g_GWState.nodes[phantomCode] = {};
        delete g_GWState.nodes[phantomCode].lastSleep;
        g_GWState.nodes[phantomCode].bootloaderadvdata = phantom_bootloader_data;
        g_GWState.nodes[phantomCode].bootloaderadvdata.lastseen = Date.now();
        g_GWState.nodes[phantomCode].lastseen = Date.now();
        g_GWState.nodes[phantomCode].phantomCode = phantomCode;
        g_GWState.nodes[phantomCode].isDFUmode = true;
        g_GWState.nodes[phantomCode].version = phantom_bootloader_data.version;
        g_GWState.nodes[phantomCode].type = phantom_bootloader_data.type;
        if (gwSerial) {
          if (!g_GWState.nodes[phantomCode].subordinatesInfo)
            g_GWState.nodes[phantomCode].subordinatesInfo = {};
          if (!g_GWState.nodes[phantomCode].subordinatesInfo[gwSerial])
            g_GWState.nodes[phantomCode].subordinatesInfo[gwSerial] = {};
          g_GWState.nodes[phantomCode].subordinatesInfo[gwSerial].rssi = bledevice.rssi;
          g_GWState.nodes[phantomCode].subordinatesInfo[gwSerial].lastseen = Date.now();
        }
        let minVersion = sensorDefinition.getDefaultUpdateFilename(g_GWState.nodes[phantomCode].type)?.mingw2version;
        let currentVersion = sensorDefinition.getDefaultUpdateFilename(g_GWState.nodes[phantomCode].type)?.version;
        if (currentVersion > g_GWState.nodes[phantomCode].version)
          g_GWState.nodes[phantomCode].hasupdate = true;
        else
          g_GWState.nodes[phantomCode].hasupdate = false;
        if (minVersion > g_GWState.nodes[phantomCode].version)
          g_GWState.nodes[phantomCode].needsupdate = true;
        else
          g_GWState.nodes[phantomCode].needsupdate = false;
        gwutils.gwUpdateGlobalState();
        let subordinateInfo = g_GWState.nodes[phantomCode].subordinatesInfo;
        for (let gw in subordinateInfo) {
          let info = subordinateInfo[gw];
          let lastAdv = Date.now() - info.lastseen;
          if (gw == gwSerial)
            continue;
          if (lastAdv > 2e4)
            continue;
          if (info.rssi > bledevice.rssi) {
            return;
          }
        }
        if (gwutils.isSubordinate())
          return;
        if (!g_GWState.nodes[phantomCode].action && g_GWState.nodes[phantomCode].actions && g_GWState.nodes[phantomCode].actions.update) {
          try {
            g_GWState.nodes[phantomCode].action = "updating";
            g_GWState.nodes[phantomCode].actionstate = "downloading";
            g_GWState.nodes[phantomCode].actionprogress = 0;
            gwutils.gwUpdateGlobalState();
            console.log("DFU ", phantomCode);
            let firmware = null;
            let twoStepUpdate = false;
            if (g_GWState.nodes[phantomCode].actions.update.params && g_GWState.nodes[phantomCode].actions.update.params.updatecode) {
              let updateCode = g_GWState.nodes[phantomCode].actions.update.params.updatecode;
              let haveSDBL = false;
              try {
                if (!g_GWState.nodes[phantomCode].actions.update.params.secondstep) {
                  await fs.access(path2.join(customFwPath, updateCode + "sdbl.dat"));
                  haveSDBL = true;
                }
              } catch (e) {
              }
              let ini = null;
              let bin = null;
              if (haveSDBL) {
                ini = await fs.readFile(path2.join(customFwPath, updateCode + "sdbl.dat"));
                bin = await fs.readFile(path2.join(customFwPath, updateCode + "sdbl.bin"));
                twoStepUpdate = true;
              } else {
                ini = await fs.readFile(path2.join(customFwPath, updateCode + ".dat"));
                bin = await fs.readFile(path2.join(customFwPath, updateCode + ".bin"));
              }
              firmware = {
                ini,
                bin
              };
            } else {
              let baseFilename = sensorDefinition.getDefaultUpdateFilename(g_GWState.nodes[phantomCode].type)?.name;
              let ini = await fs.readFile(path2.join("fw", baseFilename + ".dat"));
              let bin = await fs.readFile(path2.join("fw", baseFilename + ".bin"));
              firmware = {
                ini,
                bin
              };
            }
            let actionParams = {
              subordinateAction: "dfu",
              phantomCode,
              gwSerial,
              bledevice,
              type: g_GWState.nodes[phantomCode].type,
              firmware
            };
            let success = await sensorActions.sensorActionDispatch("dfu", actionParams, true);
            if (success) {
              if (twoStepUpdate) {
                g_GWState.nodes[phantomCode].actions.update.params.secondstep = true;
              } else {
                delete g_GWState.nodes[phantomCode].actions.update;
              }
            }
          } catch (e) {
            console.log("Error during update", e);
          }
          delete g_GWState.nodes[phantomCode].action;
          delete g_GWState.nodes[phantomCode].actionstate;
          delete g_GWState.nodes[phantomCode].actionprogress;
          gwutils.gwUpdateGlobalState();
        }
      } else if ((advdata.name == "PC" || advdata.name == "PE") && g_GWState.deviceInfo.vendorId == 0 || (advdata.name[0] == "V" && advdata.name[1] == vendorChar || advdata.name[0] == "E" && advdata.name[1] == vendorChar && g_GWState.deviceInfo.vendorId != 0)) {
        let phantomv1_data = phantomService.parsePhantomV1AdvData(advdata, g_GWState);
        let phantomCode = phantomv1_data.phantomCode;
        let nodeadded = false;
        if (g_GWState.nodes[phantomCode] === void 0) {
          nodeadded = true;
          g_GWState.nodes[phantomCode] = {};
        }
        delete g_GWState.nodes[phantomCode].lastSleep;
        if (phantomv1_data.gw2adv) {
          if (!g_GWState.nodes[phantomCode].advdatav2 || typeof phantomv1_data.seq == "number" && phantomv1_data.seq != g_GWState.nodes[phantomCode].advdatav2.seq) {
            g_GWState.nodes[phantomCode].lastseqchange = Date.now();
            gwutils.broadcastEvent("sensorchangedseq", g_GWState.nodes[phantomCode]);
            if (g_GWState.nodes[phantomCode].settings?.isPaired) {
              let messages = phantomService.createPhantomV1SmallMessages(g_GWState.nodes[phantomCode], phantomv1_data);
              let updateReportCount = 1;
              if (g_GWState.nodes[phantomCode].settings?.misc?.updateReportCount > 0)
                updateReportCount = g_GWState.nodes[phantomCode].settings?.misc?.updateReportCount;
              if (!g_GWState.nodes[phantomCode].updatesSinceLastReport)
                g_GWState.nodes[phantomCode].updatesSinceLastReport = 0;
              g_GWState.nodes[phantomCode].updatesSinceLastReport++;
              if (g_GWState.nodes[phantomCode].updatesSinceLastReport >= updateReportCount) {
                g_GWState.nodes[phantomCode].updatesSinceLastReport = 0;
                gwutils.broadcastEvent("newphantomv1broadcast", {
                  phantomCode,
                  messages,
                  nodeData: JSON.parse(JSON.stringify(g_GWState.nodes[phantomCode])),
                  captureTime: Math.floor(Date.now() / 1e3)
                });
              }
            }
            if (phantomService.isDryContacts(g_GWState.nodes[phantomCode].type)) {
              checkGpioTrigger(g_GWState.nodes[phantomCode]);
            }
          }
        } else {
        }
        if (!phantomv1_data.gw2adv && g_GWState.nodes[phantomCode]?.advdatav2?.gw2adv) {
          if (Date.now() - g_GWState.nodes[phantomCode].lastseen <= 24e4)
            phantomv1_data.ignoreAdv1 = true;
        }
        if (phantomv1_data.gw2merge && g_GWState.nodes[phantomCode].advdatav2) {
          g_GWState.nodes[phantomCode].advdatav2 = { ...g_GWState.nodes[phantomCode].advdatav2, ...phantomv1_data };
        } else if (!phantomv1_data.ignoreAdv1 && phantomv1_data.gw2adv) {
          g_GWState.nodes[phantomCode].advdatav2 = phantomv1_data;
          g_GWState.nodes[phantomCode].needsupdate = phantomv1_data.needsupdate;
        }
        g_GWState.nodes[phantomCode].phantomCode = phantomv1_data.phantomCode;
        g_GWState.nodes[phantomCode].type = phantomv1_data.type;
        g_GWState.nodes[phantomCode].version = phantomv1_data.version;
        if (!g_GWState.nodes[phantomCode].subordinatesInfo)
          g_GWState.nodes[phantomCode].subordinatesInfo = {};
        if (!g_GWState.nodes[phantomCode].subordinatesInfo[gwSerial])
          g_GWState.nodes[phantomCode].subordinatesInfo[gwSerial] = {};
        g_GWState.nodes[phantomCode].subordinatesInfo[gwSerial].rssi = bledevice.rssi;
        g_GWState.nodes[phantomCode].subordinatesInfo[gwSerial].phy = bledevice.primaryPhy;
        g_GWState.nodes[phantomCode].subordinatesInfo[gwSerial].chIndex = bledevice.ch_index;
        g_GWState.nodes[phantomCode].subordinatesInfo[gwSerial].lastseen = Date.now();
        let bestrssi = bledevice.rssi;
        for (let gw in g_GWState.nodes[phantomCode].subordinatesInfo) {
          let info = g_GWState.nodes[phantomCode].subordinatesInfo[gw];
          let lastAdv = Date.now() - info.lastseen;
          if (lastAdv > 1e4) {
            continue;
          }
          if (info.rssi > bestrssi) {
            bestrssi = info.rssi;
          }
        }
        g_GWState.nodes[phantomCode].rssi = bestrssi;
        g_GWState.nodes[phantomCode].lastseen = Date.now();
        g_GWState.nodes[phantomCode].ch_index = bledevice.ch_index;
        g_GWState.nodes[phantomCode].bledevice = bledevice;
        g_GWState.nodes[phantomCode].isDFUmode = false;
        let currentVersion = sensorDefinition.getDefaultUpdateFilename(g_GWState.nodes[phantomCode].type)?.version;
        if (currentVersion > g_GWState.nodes[phantomCode].version)
          g_GWState.nodes[phantomCode].hasupdate = true;
        else
          g_GWState.nodes[phantomCode].hasupdate = false;
        gwutils.gwUpdateGlobalState();
        if (nodeadded)
          gwutils.broadcastEvent("nodeadded", phantomCode);
        if (g_GWState.nodes[phantomCode].advdatav2?.decryptFail)
          return;
        if (gwutils.isSubordinate())
          return;
        if (checkPhantomSyncTrigger(g_GWState.nodes[phantomCode])) {
          let syncSettings = g_GWState.phantomSync[g_GWState.deviceInfo.runningPhantomSync.index];
          sendSyncBeacon(syncSettings);
        }
        let subordinateInfo = g_GWState.nodes[phantomCode].subordinatesInfo;
        for (let gw in subordinateInfo) {
          let info = subordinateInfo[gw];
          let lastAdv = Date.now() - info.lastseen;
          if (gw == gwSerial)
            continue;
          if (lastAdv > 2e4)
            continue;
          if (info.rssi > bledevice.rssi) {
            return;
          }
        }
        if (!g_GWState.nodes[phantomCode].action && g_GWState.nodes[phantomCode].actions && g_GWState.nodes[phantomCode].actions.update) {
          console.log("Connecting to jump into bootloader...", phantomCode);
          let actionParams = {
            subordinateAction: "jumptobootloader",
            phantomCode,
            gwSerial,
            bledevice,
            encrypted: g_GWState.nodes[phantomCode].advdatav2?.encrypted,
            type: g_GWState.nodes[phantomCode].type
          };
          await sensorActions.sensorActionDispatch("jumptobootloader", actionParams, true);
        } else if (!g_GWState.nodes[phantomCode].action && g_GWState.nodes[phantomCode].actions && g_GWState.nodes[phantomCode].actions.encrypt && (g_GWState.nodes[phantomCode].advdatav2?.initialAdvertising || g_GWState.nodes[phantomCode].advdatav2?.encrypted)) {
          console.log("Connecting for encryption...", phantomCode);
          g_GWState.nodes[phantomCode].action = "encrypt";
          g_GWState.nodes[phantomCode].actionstate = "connecting";
          g_GWState.nodes[phantomCode].actionprogress = 0;
          gwutils.gwUpdateGlobalState();
          let enableEncryption = g_GWState.nodes[phantomCode].actions.encrypt.params?.enable;
          let newConnKey = null;
          let newAdvKey = null;
          if (enableEncryption) {
            newConnKey = await gwCrypto.generateAESKeyAsync();
            newAdvKey = await gwCrypto.generateAESKeyAsync();
          }
          let actionParams = {
            subordinateAction: "encrypt",
            phantomCode,
            gwSerial,
            bledevice,
            encrypted: g_GWState.nodes[phantomCode].advdatav2?.encrypted,
            type: g_GWState.nodes[phantomCode].type,
            newConnKey,
            newAdvKey,
            enableEncryption
          };
          let success = await sensorActions.sensorActionDispatch("encrypt", actionParams, true);
          if (success) {
            if (enableEncryption) {
              gwCrypto.saveKey(phantomCode, newConnKey, newAdvKey);
            }
            delete g_GWState.nodes[phantomCode].actions.encrypt;
          }
          delete g_GWState.nodes[phantomCode].action;
          delete g_GWState.nodes[phantomCode].actionstate;
          delete g_GWState.nodes[phantomCode].actionprogress;
          gwutils.gwUpdateGlobalState();
        } else if (!g_GWState.nodes[phantomCode].action && g_GWState.nodes[phantomCode].actions && g_GWState.nodes[phantomCode].actions.updatestate) {
          console.log("Connecting to request update ...", phantomCode);
          if (!g_GWState.nodes[phantomCode].actions.updatestate.retries)
            g_GWState.nodes[phantomCode].actions.updatestate.retries = 0;
          g_GWState.nodes[phantomCode].actions.updatestate.retries++;
          g_GWState.nodes[phantomCode].action = "updatestate";
          g_GWState.nodes[phantomCode].actionstate = "connecting";
          g_GWState.nodes[phantomCode].actionprogress = 0;
          gwutils.gwUpdateGlobalState();
          let actionParams = {
            subordinateAction: "updatestate",
            phantomCode,
            gwSerial,
            bledevice,
            type: g_GWState.nodes[phantomCode].type,
            encrypted: g_GWState.nodes[phantomCode].advdatav2?.encrypted
          };
          let success = await sensorActions.sensorActionDispatch("updatestate", actionParams, true);
          if (success || g_GWState.nodes[phantomCode].actions.updatestate.retries > 20)
            g_GWState.nodes[phantomCode].actions.updatestate = void 0;
          g_GWState.nodes[phantomCode].action = void 0;
          g_GWState.nodes[phantomCode].actionstate = void 0;
          g_GWState.nodes[phantomCode].actionprogress = void 0;
          gwutils.gwUpdateGlobalState();
        } else if (!g_GWState.nodes[phantomCode].action && g_GWState.nodes[phantomCode].actions && g_GWState.nodes[phantomCode].actions.changesettings) {
          gwutils.broadcastEvent("changesettings", {});
          console.log("Connecting to change settings...", phantomCode);
          if (!g_GWState.nodes[phantomCode].actions.changesettings.retries)
            g_GWState.nodes[phantomCode].actions.changesettings.retries = 0;
          g_GWState.nodes[phantomCode].actions.changesettings.retries++;
          g_GWState.nodes[phantomCode].action = "changesettings";
          g_GWState.nodes[phantomCode].actionstate = "connecting";
          g_GWState.nodes[phantomCode].actionprogress = 0;
          gwutils.gwUpdateGlobalState();
          let actionParams = {
            subordinateAction: "changesettings",
            phantomCode,
            gwSerial,
            bledevice,
            type: g_GWState.nodes[phantomCode].type,
            version: g_GWState.nodes[phantomCode].version,
            encrypted: g_GWState.nodes[phantomCode].advdatav2?.encrypted,
            changeSettingsParams: g_GWState.nodes[phantomCode].actions.changesettings.params
          };
          let success = await sensorActions.sensorActionDispatch("changesettings", actionParams, true);
          if (success || g_GWState.nodes[phantomCode].actions.changesettings.retries > 20)
            g_GWState.nodes[phantomCode].actions.changesettings = void 0;
          g_GWState.nodes[phantomCode].action = void 0;
          g_GWState.nodes[phantomCode].actionstate = void 0;
          g_GWState.nodes[phantomCode].actionprogress = void 0;
          gwutils.gwUpdateGlobalState();
        } else if (g_GWState.nodes[phantomCode].doBlink) {
          console.log("Connecting for blink...", phantomCode);
          let startTime = Date.now();
          let ps2 = new phantomService(bledevice, g_GWState.nodes[phantomCode].advdatav2?.encrypted, phantomCode);
          try {
            let result2 = await ps2.connect();
            if (result2) {
              try {
                console.log("Ellapsed connection", Date.now() - startTime);
                if (g_GWState.nodes[phantomCode]?.advdatav2?.highPerformaceAdv)
                  await ps2.setHighPerformaceAdv(false, 20);
                else
                  await ps2.setHighPerformaceAdv(true, 20);
                console.log("Done blink", Date.now() - startTime);
              } catch (e) {
                console.log("testt----------->", e);
              }
              console.log("Ellapsed blink", Date.now() - startTime);
              g_GWState.nodes[phantomCode].doBlink = false;
              await ps2.disconnect();
            }
          } catch (e) {
            console.log("Error when putting to sleep", e);
          }
          console.log("Ellapsed done ", Date.now() - startTime);
          console.log("Ellapsed since requested ", Date.now() - g_GWState.nodes[phantomCode].blinkStart);
        } else if (!g_GWState.nodes[phantomCode].action && g_GWState.nodes[phantomCode].actions && g_GWState.nodes[phantomCode].actions.sleep) {
          gwutils.broadcastEvent("sleepingsensor", {});
          console.log("Connecting for sleep...", phantomCode);
          g_GWState.nodes[phantomCode].action = "sleep";
          g_GWState.nodes[phantomCode].actionstate = "connecting";
          g_GWState.nodes[phantomCode].actionprogress = 0;
          gwutils.gwUpdateGlobalState();
          let actionDownloadParams = {
            subordinateAction: "sleep",
            phantomCode,
            gwSerial,
            bledevice,
            type: g_GWState.nodes[phantomCode].type,
            encrypted: g_GWState.nodes[phantomCode].advdatav2?.encrypted
          };
          let retVal = await sensorActions.sensorActionDispatch("sleep", actionDownloadParams, true);
          if (retVal) {
            g_GWState.nodes[phantomCode].lastSleep = Date.now();
            gwutils.gwUpdateGlobalState();
            g_GWState.nodes[phantomCode].actions.sleep = void 0;
          }
          g_GWState.nodes[phantomCode].action = void 0;
          g_GWState.nodes[phantomCode].actionstate = void 0;
          g_GWState.nodes[phantomCode].actionprogress = void 0;
          gwutils.gwUpdateGlobalState();
        } else if (!g_GWState.nodes[phantomCode].action && g_GWState.nodes[phantomCode].actions && g_GWState.nodes[phantomCode].actions.resetcurrent) {
          console.log("Connecting for current reset...", phantomCode);
          g_GWState.nodes[phantomCode].action = "resetcurrent";
          g_GWState.nodes[phantomCode].actionstate = "connecting";
          g_GWState.nodes[phantomCode].actionprogress = 0;
          gwutils.gwUpdateGlobalState();
          let ps2 = new phantomService(bledevice, g_GWState.nodes[phantomCode].advdatav2?.encrypted, phantomCode);
          try {
            let result2 = await ps2.connect();
            console.log("Connection result", result2 ? true : false);
            if (result2) {
              g_GWState.nodes[phantomCode].actionstate = "resetingcurrent";
              gwutils.gwUpdateGlobalState();
              try {
                let startTime = Math.floor(Date.now() / 1e3);
                startTime = gwutils.offsetTimestampLocalTime(startTime);
                await ps2.resetCurrentAccumulation(startTime);
                await ps2.disconnect();
              } catch (e) {
              }
            }
          } catch (e) {
            console.log("Error when putting to sleep", e);
          }
          g_GWState.nodes[phantomCode].actions.resetcurrent = void 0;
          g_GWState.nodes[phantomCode].action = void 0;
          g_GWState.nodes[phantomCode].actionstate = void 0;
          g_GWState.nodes[phantomCode].actionprogress = void 0;
          gwutils.gwUpdateGlobalState();
        } else if (g_GWState.nodes[phantomCode].advdatav2?.candownloaddata && (isBigDataManuallyRequested(g_GWState.nodes[phantomCode]) || g_GWState.nodes[phantomCode].settings?.isPaired && (isBigDataRequestedbyNode(g_GWState.nodes[phantomCode]) || isBigDataScheduled(g_GWState.nodes[phantomCode]) || isTriggered(g_GWState.nodes[phantomCode]) || isAlarmed(g_GWState.nodes[phantomCode]) || isAlarmedLevel2(g_GWState.nodes[phantomCode]) || g_GWState.nodes[phantomCode].doCollection || sensorHasData(g_GWState.nodes[phantomCode])))) {
          let manual = isBigDataManuallyRequested(g_GWState.nodes[phantomCode]);
          let restart = isBigDataRequestedbyNode(g_GWState.nodes[phantomCode]);
          let scheduled = isBigDataScheduled(g_GWState.nodes[phantomCode]);
          let triggered = isTriggered(g_GWState.nodes[phantomCode]);
          let alarmed = isAlarmed(g_GWState.nodes[phantomCode]);
          let alarmedLevel2 = isAlarmedLevel2(g_GWState.nodes[phantomCode]);
          let custom2 = g_GWState.nodes[phantomCode].doCollection;
          let justCollect = g_GWState.nodes[phantomCode].advdatav2?.haveDataToCollect || (alarmed || alarmedLevel2) && !g_GWState.nodes[phantomCode].settings.alarms?.collect;
          g_GWState.nodes[phantomCode].advdatav2.haveDataToCollect = false;
          let recordTime = 0;
          if (phantomService.isTriaxial(g_GWState.nodes[phantomCode].type) && !justCollect) {
            recordTime = getTriaxialRecordingTime(g_GWState.nodes[phantomCode]);
          }
          let encrypted = g_GWState.nodes[phantomCode].advdatav2?.encrypted;
          let recordinSettings = {};
          if (phantomService.isTriaxial(g_GWState.nodes[phantomCode].type)) {
            recordinSettings = getTriaxialRecordingSettings(g_GWState.nodes[phantomCode]);
          }
          let collectdisconnected = false;
          if (g_GWState.basicconfig.collectdisconnected && g_GWState.nodes[phantomCode].version >= 187) {
            if (!justCollect) {
              collectdisconnected = true;
              recordTime = 0;
            }
          }
          let actionDownloadParams = {
            subordinateAction: "download",
            phantomCode,
            gwSerial,
            bledevice,
            type: g_GWState.nodes[phantomCode].type,
            encrypted: g_GWState.nodes[phantomCode].advdatav2?.encrypted,
            manual,
            restart,
            scheduled,
            triggered,
            alarmed,
            alarmedLevel2,
            custom: custom2,
            justCollect,
            recordTime,
            recordinSettings,
            collectafterdisconnect: collectdisconnected
          };
          console.log("Connecting for collection...", phantomCode);
          g_GWState.nodes[phantomCode].action = "downloadsignal";
          g_GWState.nodes[phantomCode].actionstate = "connecting";
          g_GWState.nodes[phantomCode].actionprogress = 0;
          gwutils.gwUpdateGlobalState();
          let rpmDataMessages = null;
          let rpmData = null;
          let rpmSourceCode = null;
          if (g_GWState.nodes[phantomCode].settings?.rpmsource?.enabled && g_GWState.nodes[phantomCode].settings?.rpmsource?.phantomCode) {
            rpmSourceCode = g_GWState.nodes[phantomCode].settings?.rpmsource?.phantomCode;
            let rpmSourceNode = g_GWState.nodes[rpmSourceCode];
            if (rpmSourceNode && rpmSourceNode.advdatav2) {
              rpmDataMessages = phantomService.createPhantomV1SmallMessages(rpmSourceNode, rpmSourceNode.advdatav2);
              rpmData = JSON.parse(JSON.stringify(rpmSourceNode));
            }
          }
          let retVal = await sensorActions.sensorActionDispatch("downloadSignal", actionDownloadParams, true);
          if (retVal) {
            if (retVal.scheduledDownload) {
              g_GWState.nodes[phantomCode].lastScheduledDownload = Date.now();
            } else {
              if (retVal.downloadretArray) {
                for (let i = 0; i < retVal.downloadretArray.length; i++) {
                  handleNewDownload(actionDownloadParams.phantomCode, retVal.downloadretArray[i]);
                }
              } else {
                handleNewDownload(actionDownloadParams.phantomCode, retVal.downloadret);
              }
            }
            if (rpmDataMessages) {
              let captureTime = retVal?.downloadret?.captureTime;
              gwutils.broadcastEvent("newphantomv1broadcast", {
                phantomCode: rpmSourceCode,
                messages: rpmDataMessages,
                nodeData: rpmData,
                captureTime
              });
            }
            if (triggered) {
              g_GWState.nodes[phantomCode].triggerNow = false;
              g_GWState.nodes[phantomCode].lastTriggerCollection = Date.now();
            }
            if (alarmed) {
              g_GWState.nodes[phantomCode].lastAlarmCollection = Date.now();
            }
            if (alarmedLevel2) {
              g_GWState.nodes[phantomCode].lastAlarmCollection = Date.now();
              g_GWState.nodes[phantomCode].lastAlarmCollectionLevel2 = Date.now();
            }
            if (manual) {
              g_GWState.nodes[phantomCode].lastManualCollection = Date.now();
            }
            if (restart) {
              g_GWState.nodes[phantomCode].advdatav2.advFlags &= ~phantomService.phantomV2AdvFlags.GW2_ADV_FLAGS_COLLECT_NOW;
            }
            g_GWState.nodes[phantomCode].lastcollection = Date.now();
            delete g_GWState.nodes[phantomCode].doCollection;
            if (g_GWState.nodes[phantomCode].actions)
              delete g_GWState.nodes[phantomCode].actions.signal;
          }
          delete g_GWState.nodes[phantomCode].action;
          delete g_GWState.nodes[phantomCode].actionstate;
          delete g_GWState.nodes[phantomCode].actionprogress;
          gwutils.gwUpdateGlobalState();
        }
      }
    } catch (e) {
      console.log("Error when processing advertising", e);
    }
  }
  ble.start(async function(bledevice, advdata) {
    if (!advdata.name || !advdata.manufacturer)
      return;
    gwutils.broadcastEvent("sensorAdvertising", {
      bledevice,
      advdata
    });
    gwutils.broadcastEvent("seensensor", null);
    if (!gwutils.isSubordinate())
      processSensorAdvertising(bledevice, advdata, g_GWState.deviceInfo.serialNumber, true);
  });
  gwutils.subscribeToEvent("subordinateSensorAdvertising", async (e) => {
    gwutils.broadcastEvent("seensensor", {});
    processSensorAdvertising(e.payload.bledevice, e.payload.advdata, e.sourcegw, false);
  });
}
init();
/*! Bundled license information:

jsonpatcherproxy/src/jsonpatcherproxy.js:
  (*!
   * https://github.com/Palindrom/JSONPatcherProxy
   * (c) 2017 Starcounter
   * MIT license
   *
   * Vocabulary used in this file:
   *  * root - root object that is deeply observed by JSONPatcherProxy
   *  * tree - any subtree within the root or the root
   *)

fast-json-patch/commonjs/helpers.js:
  (*!
   * https://github.com/Starcounter-Jack/JSON-Patch
   * (c) 2017-2022 Joachim Wester
   * MIT licensed
   *)

fast-json-patch/commonjs/duplex.js:
  (*!
   * https://github.com/Starcounter-Jack/JSON-Patch
   * (c) 2017-2021 Joachim Wester
   * MIT license
   *)

mime-db/index.js:
  (*!
   * mime-db
   * Copyright(c) 2014 Jonathan Ong
   * Copyright(c) 2015-2022 Douglas Christopher Wilson
   * MIT Licensed
   *)

negotiator/index.js:
  (*!
   * negotiator
   * Copyright(c) 2012 Federico Romero
   * Copyright(c) 2012-2014 Isaac Z. Schlueter
   * Copyright(c) 2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

safe-buffer/index.js:
  (*! safe-buffer. MIT License. Feross Aboukhadijeh <https://feross.org/opensource> *)

jsrsasign/lib/jsrsasign.js:
  (*! CryptoJS v3.1.2 core-fix.js
   * code.google.com/p/crypto-js
   * (c) 2009-2013 by Jeff Mott. All rights reserved.
   * code.google.com/p/crypto-js/wiki/License
   * THIS IS FIX of 'core.js' to fix Hmac issue.
   * https://code.google.com/p/crypto-js/issues/detail?id=84
   * https://crypto-js.googlecode.com/svn-history/r667/branches/3.x/src/core.js
   *)
  (*! (c) Tom Wu | http://www-cs-students.stanford.edu/~tjw/jsbn/
   *)
  (*! (c) Tom Wu, Kenji Urushima | http://www-cs-students.stanford.edu/~tjw/jsbn/
   *)
  (*! (c) Stefan Thomas | https://github.com/bitcoinjs/bitcoinjs-lib
   *)
  (*! Mike Samuel (c) 2009 | code.google.com/p/json-sans-eval
   *)

reflect-metadata/Reflect.js:
  (*! *****************************************************************************
  Copyright (C) Microsoft. All rights reserved.
  Licensed under the Apache License, Version 2.0 (the "License"); you may not use
  this file except in compliance with the License. You may obtain a copy of the
  License at http://www.apache.org/licenses/LICENSE-2.0
  
  THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
  WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
  MERCHANTABLITY OR NON-INFRINGEMENT.
  
  See the Apache Version 2.0 License for specific language governing permissions
  and limitations under the License.
  ***************************************************************************** *)

pvtsutils/build/index.js:
  (*!
   * MIT License
   * 
   * Copyright (c) 2017-2022 Peculiar Ventures, LLC
   * 
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   * 
   * The above copyright notice and this permission notice shall be included in all
   * copies or substantial portions of the Software.
   * 
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
   * SOFTWARE.
   * 
   *)

pvutils/build/utils.js:
  (*!
   Copyright (c) Peculiar Ventures, LLC
  *)

asn1js/build/index.js:
  (*!
   * Copyright (c) 2014, GMO GlobalSign
   * Copyright (c) 2015-2022, Peculiar Ventures
   * All rights reserved.
   * 
   * Author 2014-2019, Yury Strozhevsky
   * 
   * Redistribution and use in source and binary forms, with or without modification,
   * are permitted provided that the following conditions are met:
   * 
   * * Redistributions of source code must retain the above copyright notice, this
   *   list of conditions and the following disclaimer.
   * 
   * * Redistributions in binary form must reproduce the above copyright notice, this
   *   list of conditions and the following disclaimer in the documentation and/or
   *   other materials provided with the distribution.
   * 
   * * Neither the name of the copyright holder nor the names of its
   *   contributors may be used to endorse or promote products derived from
   *   this software without specific prior written permission.
   * 
   * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
   * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
   * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
   * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
   * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
   * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
   * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
   * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
   * 
   *)

tslib/tslib.es6.js:
  (*! *****************************************************************************
  Copyright (c) Microsoft Corporation.
  
  Permission to use, copy, modify, and/or distribute this software for any
  purpose with or without fee is hereby granted.
  
  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
  REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
  AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
  INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
  OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
  PERFORMANCE OF THIS SOFTWARE.
  ***************************************************************************** *)

@peculiar/x509/build/x509.cjs.js:
  (*!
   * MIT License
   * 
   * Copyright (c) Peculiar Ventures. All rights reserved.
   * 
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   * 
   * The above copyright notice and this permission notice shall be included in all
   * copies or substantial portions of the Software.
   * 
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
   * SOFTWARE.
   * 
   *)

webcrypto-core/build/webcrypto-core.js:
  (*!
   Copyright (c) Peculiar Ventures, LLC
  *)

@peculiar/webcrypto/build/webcrypto.js:
  (*!
   Copyright (c) Peculiar Ventures, LLC
  *)

node-opcua-crypto/dist/index.js:
  (*! Bundled license information:
  
  pvtsutils/build/index.es.js:
    (*!
     * MIT License
     * 
     * Copyright (c) 2017-2022 Peculiar Ventures, LLC
     * 
     * Permission is hereby granted, free of charge, to any person obtaining a copy
     * of this software and associated documentation files (the "Software"), to deal
     * in the Software without restriction, including without limitation the rights
     * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
     * copies of the Software, and to permit persons to whom the Software is
     * furnished to do so, subject to the following conditions:
     * 
     * The above copyright notice and this permission notice shall be included in all
     * copies or substantial portions of the Software.
     * 
     * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
     * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
     * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
     * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
     * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
     * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
     * SOFTWARE.
     * 
     *)
  
  pvutils/build/utils.es.js:
    (*!
     Copyright (c) Peculiar Ventures, LLC
    *)
  
  asn1js/build/index.es.js:
    (*!
     * Copyright (c) 2014, GMO GlobalSign
     * Copyright (c) 2015-2022, Peculiar Ventures
     * All rights reserved.
     * 
     * Author 2014-2019, Yury Strozhevsky
     * 
     * Redistribution and use in source and binary forms, with or without modification,
     * are permitted provided that the following conditions are met:
     * 
     * * Redistributions of source code must retain the above copyright notice, this
     *   list of conditions and the following disclaimer.
     * 
     * * Redistributions in binary form must reproduce the above copyright notice, this
     *   list of conditions and the following disclaimer in the documentation and/or
     *   other materials provided with the distribution.
     * 
     * * Neither the name of the copyright holder nor the names of its
     *   contributors may be used to endorse or promote products derived from
     *   this software without specific prior written permission.
     * 
     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
     * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
     * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
     * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
     * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
     * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
     * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
     * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
     * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
     * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
     * 
     *)
  *)

lodash/lodash.js:
  (**
   * @license
   * Lodash <https://lodash.com/>
   * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
   * Released under MIT license <https://lodash.com/license>
   * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
   * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
   *)

normalize-path/index.js:
  (*!
   * normalize-path <https://github.com/jonschlinkert/normalize-path>
   *
   * Copyright (c) 2014-2018, Jon Schlinkert.
   * Released under the MIT License.
   *)

is-extglob/index.js:
  (*!
   * is-extglob <https://github.com/jonschlinkert/is-extglob>
   *
   * Copyright (c) 2014-2016, Jon Schlinkert.
   * Licensed under the MIT License.
   *)

is-glob/index.js:
  (*!
   * is-glob <https://github.com/jonschlinkert/is-glob>
   *
   * Copyright (c) 2014-2017, Jon Schlinkert.
   * Released under the MIT License.
   *)

is-number/index.js:
  (*!
   * is-number <https://github.com/jonschlinkert/is-number>
   *
   * Copyright (c) 2014-present, Jon Schlinkert.
   * Released under the MIT License.
   *)

to-regex-range/index.js:
  (*!
   * to-regex-range <https://github.com/micromatch/to-regex-range>
   *
   * Copyright (c) 2015-present, Jon Schlinkert.
   * Released under the MIT License.
   *)

fill-range/index.js:
  (*!
   * fill-range <https://github.com/jonschlinkert/fill-range>
   *
   * Copyright (c) 2014-present, Jon Schlinkert.
   * Licensed under the MIT License.
   *)

progress/lib/node-progress.js:
  (*!
   * node-progress
   * Copyright(c) 2011 TJ Holowaychuk <tj@vision-media.ca>
   * MIT Licensed
   *)
*/
